(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 5.0'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[  12446684,     462276]*)
(*NotebookOutlinePosition[  12447384,     462300]*)
(*  CellTagsIndexPosition[  12447340,     462296]*)
(*WindowFrame->Normal*)



Notebook[{
Cell["Intersecting Cylinders", "Title"],

Cell[BoxData[
    \(Needs["\<DrawGraphics`DrawingMaster`\>"]\)], "Input"],

Cell[CellGroupData[{

Cell["Intersecting Cylinders", "Subsection"],

Cell["\<\
Let's draw the region bounded by two intersecting cylinders of unit radius. \
The first cylinder will have the x axis as the cylinder axis and the second \
cylinder will have the y axis as the cylinder axis.\
\>", "Text"],

Cell["This is a parametrization of the two cylinders.", "Text"],

Cell[CellGroupData[{

Cell[BoxData[{
    \(xcylinder[\[Theta]_, x_] := {x, Cos[\[Theta]], 
        Sin[\[Theta]]}\), "\[IndentingNewLine]", 
    \(ycylinder[\[Theta]_, y_] := {Cos[\[Theta]], y, 
        Sin[\[Theta]]}\)}], "Input"],

Cell[BoxData[
    RowBox[{\(General::"spell1"\), \(\(:\)\(\ \)\), "\<\"Possible spelling \
error: new symbol name \\\"\\!\\(xcylinder\\)\\\" is similar to existing \
symbol \\\"\\!\\(cylinder\\)\\\". \\!\\(\\*ButtonBox[\\\"More\[Ellipsis]\\\", \
ButtonStyle->\\\"RefGuideLinkText\\\", ButtonFrame->None, \
ButtonData:>\\\"General::spell1\\\"]\\)\"\>"}]], "Message"],

Cell[BoxData[
    RowBox[{\(General::"spell"\), \(\(:\)\(\ \)\), "\<\"Possible spelling \
error: new symbol name \\\"\\!\\(ycylinder\\)\\\" is similar to existing \
symbols \\!\\({cylinder, xcylinder}\\). \
\\!\\(\\*ButtonBox[\\\"More\[Ellipsis]\\\", ButtonStyle->\\\"RefGuideLinkText\
\\\", ButtonFrame->None, ButtonData:>\\\"General::spell\\\"]\\)\"\>"}]], \
"Message"]
}, Open  ]],

Cell["\<\
We can obtain an idea of the surface by directly drawing our two cylinders.\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(Draw3DItems[\[IndentingNewLine]{SurfaceColor[
            Cobalt], \[IndentingNewLine]ParametricDraw3D[
            Evaluate[xcylinder[\[Theta], x]], {x, \(-1\), 1}, {\[Theta], 0, 
              2  \[Pi]}, 
            PlotPoints \[Rule] {15, 31}], \[IndentingNewLine]SurfaceColor[
            EnglishRed], \[IndentingNewLine]ParametricDraw3D[
            Evaluate[ycylinder[\[Theta], y]], {y, \(-1\), 1}, {\[Theta], 0, 
              2  \[Pi]}, 
            PlotPoints \[Rule] {15, 
                31}]}, \[IndentingNewLine]\[IndentingNewLine]NeutralLighting[
          0.3, 0.6, 
          0.1], \[IndentingNewLine]ViewPoint -> {1.886, \ \(-2.634\), \ 
            0.975}, \[IndentingNewLine]ImageSize \[Rule] 500];\)\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .95143 
%%ImageSize: 500 475.717 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics3D
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.0324378 1.099 9.15067e-017 1.099 [
[ 0 0 0 0 ]
[ 1 .95143 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.04338 .2036 m
0 .87776 L
s
0 .87776 m
.44854 .95143 L
s
.44854 .95143 m
.45322 .39737 L
s
.45322 .39737 m
.04338 .2036 L
s
.61074 0 m
.96194 .26706 L
s
.96194 .26706 m
1 .90216 L
s
1 .90216 m
.62118 .79761 L
s
.62118 .79761 m
.61074 0 L
s
.04338 .2036 m
0 .87776 L
s
0 .87776 m
.62118 .79761 L
s
.62118 .79761 m
.61074 0 L
s
.61074 0 m
.04338 .2036 L
s
.45322 .39737 m
.96194 .26706 L
s
.96194 .26706 m
1 .90216 L
s
1 .90216 m
.44854 .95143 L
s
.44854 .95143 m
.45322 .39737 L
s
0 0 m
1 0 L
1 .95143 L
0 .95143 L
closepath
clip
newpath
.5 Mabswid
1 .299 .125 r
.47329 .54898 m .49644 .49691 L p .46292 .52765 L F P
0 g
s
1 .299 .125 r
.45911 .54342 m .47329 .54898 L p .46292 .52765 L F P
0 g
s
.228 .327 .653 r
.45412 .5641 m .45811 .55877 L .45749 .56816 L F
.44024 .54741 m .45911 .54342 L p .45412 .5641 L F P
0 g
s
1 .292 .121 r
.47329 .54898 m .45911 .54342 L p .45749 .56816 L F P
0 g
s
.228 .327 .653 r
.45911 .54342 m .47154 .54078 L p .45412 .5641 L F P
0 g
s
.218 .309 .619 r
.45361 .65999 m .45046 .6036 L p .45501 .61025 L F P
0 g
s
1 .283 .117 r
.45361 .65999 m .45883 .60397 L p .45501 .61025 L F P
0 g
s
1 .283 .117 r
.42961 .65214 m .45361 .65999 L p .45501 .61025 L F P
0 g
s
.218 .309 .619 r
.48188 .5975 m .48523 .65439 L p .45501 .61025 L F P
0 g
s
.218 .309 .619 r
.45046 .6036 m .45523 .60267 L p .45501 .61025 L F P
0 g
s
1 .283 .117 r
.45501 .61025 m .45584 .60889 L .45507 .60838 L F
.45883 .60397 m .45523 .60267 L p .45584 .60889 L F P
0 g
s
.228 .327 .653 r
.45046 .6036 m .44024 .54741 L p .45103 .56039 L F P
0 g
s
.228 .327 .653 r
.45103 .56039 m .4537 .58727 L .45046 .6036 L F
.45523 .60267 m .45046 .6036 L p .45749 .56816 L F P
0 g
s
1 .283 .117 r
.45523 .60267 m .43503 .59542 L p .45584 .60889 L F P
0 g
s
1 .292 .121 r
.45883 .60397 m .47329 .54898 L p .45749 .56816 L F P
0 g
s
1 .292 .121 r
.45523 .60267 m .45883 .60397 L p .45749 .56816 L F P
0 g
s
.218 .309 .619 r
.45523 .60267 m .48188 .5975 L p .45501 .61025 L F P
0 g
s
.218 .309 .619 r
.48523 .65439 m .45361 .65999 L p .45501 .61025 L F P
0 g
s
1 .283 .117 r
.43503 .59542 m .42961 .65214 L p .45501 .61025 L F P
0 g
s
1 .283 .117 r
.45501 .61025 m .45507 .60838 L .43503 .59542 L F
.228 .327 .653 r
.45103 .56039 m .45749 .56816 L .4537 .58727 L F
.48188 .5975 m .45523 .60267 L p .45749 .56816 L F P
0 g
s
1 .292 .121 r
.43503 .59542 m .45523 .60267 L p .45749 .56816 L F P
0 g
s
.238 .343 .685 r
.44024 .54741 m .42329 .49317 L p .46049 .52988 L F P
0 g
s
1 .299 .125 r
.46049 .52988 m .45911 .54342 L .46292 .52765 L F
.238 .343 .685 r
.47154 .54078 m .45911 .54342 L p .46049 .52988 L F P
0 g
s
.238 .343 .685 r
.45911 .54342 m .44024 .54741 L p .46049 .52988 L F P
0 g
s
1 .299 .125 r
.44974 .53973 m .45911 .54342 L p .46049 .52988 L F P
0 g
s
1 .292 .121 r
.44974 .53973 m .43503 .59542 L p .45749 .56816 L F P
0 g
s
1 .292 .121 r
.45911 .54342 m .44974 .53973 L p .45749 .56816 L F P
0 g
s
.228 .327 .653 r
.47154 .54078 m .48188 .5975 L p .45749 .56816 L F P
0 g
s
.228 .327 .653 r
.45811 .55877 m .47154 .54078 L .45749 .56816 L F
1 .305 .127 r
.47318 .48697 m .49644 .49691 L .5275 .44955 L p F P
0 g
s
.238 .343 .685 r
.42329 .49317 m .45454 .486 L .46238 .51127 L p F P
0 g
s
1 .299 .125 r
.46049 .52988 m .49644 .49691 L .46238 .51127 L F
.238 .343 .685 r
.46238 .51127 m .47154 .54078 L p .46049 .52988 L F P
0 g
s
.238 .343 .685 r
.42329 .49317 m .46238 .51127 L .46049 .52988 L F
1 .299 .125 r
.49644 .49691 m .47318 .48697 L .46238 .51127 L p F P
0 g
s
1 .299 .125 r
.46238 .51127 m .44974 .53973 L p .46049 .52988 L F P
0 g
s
1 .308 .129 r
.50456 .43893 m .5275 .44955 L .56549 .40858 L p F P
0 g
s
1 .305 .127 r
.5275 .44955 m .50456 .43893 L .47318 .48697 L p F P
0 g
s
.248 .36 .716 r
.45454 .486 m .42329 .49317 L .40008 .44259 L p F P
0 g
s
.205 .289 .58 r
.45434 .71402 m .4495 .7148 L .45084 .69696 L p F P
0 g
s
.205 .289 .58 r
.45084 .69696 m .45361 .65999 L p .45434 .71402 L F P
0 g
s
.191 .265 .533 r
.43806 .76618 m .4495 .7148 L p .4552 .72762 L F P
0 g
s
.191 .265 .533 r
.45746 .76336 m .43806 .76618 L p .45017 .73895 L F P
0 g
s
.191 .265 .533 r
.4552 .72762 m .45746 .76336 L .45017 .73895 L F
.833 .226 .091 r
.47205 .7673 m .45746 .76336 L p .47133 .80853 L F P
0 g
s
.171 .233 .471 r
.45191 .80795 m .41938 .81226 L .43806 .76618 L p F P
0 g
s
.142 .187 .38 r
.41938 .81226 m .45191 .80795 L .4267 .84708 L p F P
0 g
s
.142 .187 .38 r
.46027 .843 m .4267 .84708 L .44892 .81259 L p F P
0 g
s
.142 .187 .38 r
.44892 .81259 m .45191 .80795 L p .4549 .82046 L F P
0 g
s
.142 .187 .38 r
.4549 .82046 m .46027 .843 L .44892 .81259 L F
.498 .121 .047 r
.47903 .84351 m .47103 .84169 L p .49446 .86994 L F P
0 g
s
.142 .187 .38 r
.45191 .80795 m .46301 .80648 L p .46027 .843 L F P
0 g
s
.703 .185 .074 r
.47903 .84351 m .47828 .84011 L .46786 .82777 L F
.46839 .8301 m .47903 .84351 L p .46786 .82777 L F P
0 g
s
.703 .185 .074 r
.47133 .80853 m .46301 .80648 L p .47828 .84011 L F P
0 g
s
.142 .187 .38 r
.46839 .8301 m .46027 .843 L p .46301 .80648 L F P
0 g
s
.171 .233 .471 r
.43806 .76618 m .44431 .76527 L p .45191 .80795 L F P
0 g
s
.171 .233 .471 r
.44431 .76527 m .45444 .78759 L .45191 .80795 L F
.46042 .78637 m .45191 .80795 L p .45746 .76336 L F P
0 g
s
.833 .226 .091 r
.46042 .78637 m .47035 .80653 L p .45746 .76336 L F P
0 g
s
.833 .226 .091 r
.47035 .80653 m .47133 .80853 L p .45746 .76336 L F P
0 g
s
.914 .252 .103 r
.4552 .72762 m .45746 .76336 L .45799 .7151 L F
.45746 .76336 m .47205 .7673 L .46143 .72788 L p F P
0 g
s
.914 .252 .103 r
.46143 .72788 m .45799 .7151 L p .45746 .76336 L F P
0 g
s
.191 .265 .533 r
.48137 .70967 m .47024 .76149 L p .4552 .72762 L F P
0 g
s
.191 .265 .533 r
.4495 .7148 m .45434 .71402 L p .4552 .72762 L F P
0 g
s
.914 .252 .103 r
.4552 .72762 m .4562 .72312 L .45486 .7222 L F
.45799 .7151 m .45434 .71402 L p .4562 .72312 L F P
0 g
s
.914 .252 .103 r
.45434 .71402 m .43384 .70793 L p .4562 .72312 L F P
0 g
s
.967 .27 .111 r
.45434 .71402 m .45799 .7151 L .45361 .65999 L p F P
0 g
s
.191 .265 .533 r
.45434 .71402 m .48137 .70967 L p .4552 .72762 L F P
0 g
s
.914 .252 .103 r
.44781 .76075 m .45746 .76336 L p .4552 .72762 L F P
0 g
s
.833 .226 .091 r
.47133 .80853 m .49558 .81451 L .47205 .7673 L p F P
0 g
s
.171 .233 .471 r
.46301 .80648 m .45247 .80787 L p .46049 .78692 L F P
0 g
s
.833 .226 .091 r
.46301 .80648 m .47133 .80853 L .46042 .78637 L p F P
0 g
s
.171 .233 .471 r
.45268 .806 m .47024 .76149 L p .45247 .80787 L F P
0 g
s
.171 .233 .471 r
.44431 .76527 m .45746 .76336 L p .45444 .78759 L F P
0 g
s
.833 .226 .091 r
.44641 .80238 m .46301 .80648 L p .44781 .76075 L F P
0 g
s
.833 .226 .091 r
.46042 .78637 m .44781 .76075 L p .46301 .80648 L F P
0 g
s
.171 .233 .471 r
.48509 .80355 m .46301 .80648 L p .47024 .76149 L F P
0 g
s
.171 .233 .471 r
.47024 .76149 m .46301 .80648 L .46049 .78692 L F
.45247 .80787 m .45191 .80795 L .45268 .806 L p F P
0 g
s
.703 .185 .074 r
.46301 .80648 m .44641 .80238 L p .46786 .82777 L F P
0 g
s
.703 .185 .074 r
.47828 .84011 m .46301 .80648 L .46786 .82777 L F
.49558 .81451 m .47133 .80853 L .50389 .84918 L p F P
0 g
s
.703 .185 .074 r
.47903 .84351 m .50389 .84918 L .47133 .80853 L p F P
0 g
s
.142 .187 .38 r
.47103 .84169 m .46027 .843 L .46839 .8301 L p F P
0 g
s
.703 .185 .074 r
.45346 .83768 m .47103 .84169 L p .44641 .80238 L F P
0 g
s
.703 .185 .074 r
.47103 .84169 m .47903 .84351 L .47206 .83472 L p F P
0 g
s
.703 .185 .074 r
.47206 .83472 m .44641 .80238 L p .47103 .84169 L F P
0 g
s
.096 .115 .238 r
.46027 .843 m .47103 .84169 L p .46385 .86915 L F P
0 g
s
.096 .115 .238 r
.47697 .85619 m .4675 .86554 L p .47103 .84169 L F P
0 g
s
.096 .115 .238 r
.4675 .86554 m .46385 .86915 L p .47103 .84169 L F P
0 g
s
.096 .115 .238 r
.4267 .84708 m .46027 .843 L .42915 .8731 L p F P
0 g
s
.096 .115 .238 r
.46385 .86915 m .42915 .8731 L .46027 .843 L p F P
0 g
s
.498 .121 .047 r
.47103 .84169 m .45346 .83768 L .47697 .85619 L p F P
0 g
s
.498 .121 .047 r
.47697 .85619 m .48959 .86611 L p .47103 .84169 L F P
0 g
s
.498 .121 .047 r
.48959 .86611 m .49446 .86994 L p .47103 .84169 L F P
0 g
s
.498 .121 .047 r
.50389 .84918 m .47903 .84351 L .51987 .8754 L p F P
0 g
s
.498 .121 .047 r
.49446 .86994 m .51987 .8754 L .47903 .84351 L p F P
0 g
s
.096 .115 .238 r
.47103 .84169 m .49454 .83883 L .47697 .85619 L p F P
0 g
s
.142 .187 .38 r
.49454 .83883 m .47103 .84169 L p .48509 .80355 L F P
0 g
s
.142 .187 .38 r
.46839 .8301 m .48509 .80355 L p .47103 .84169 L F P
0 g
s
.142 .187 .38 r
.46301 .80648 m .48509 .80355 L .46839 .8301 L p F P
0 g
s
.703 .185 .074 r
.44641 .80238 m .46839 .8301 L p .46786 .82777 L F P
0 g
s
.171 .233 .471 r
.45746 .76336 m .47024 .76149 L .46042 .78637 L p F P
0 g
s
.833 .226 .091 r
.45746 .76336 m .44781 .76075 L .46042 .78637 L p F P
0 g
s
.191 .265 .533 r
.47024 .76149 m .45746 .76336 L p .4552 .72762 L F P
0 g
s
.914 .252 .103 r
.43384 .70793 m .44781 .76075 L p .4552 .72762 L F P
0 g
s
.914 .252 .103 r
.4552 .72762 m .45486 .7222 L .43384 .70793 L F
.967 .27 .111 r
.43384 .70793 m .45434 .71402 L p .45361 .65999 L F P
0 g
s
.205 .289 .58 r
.48137 .70967 m .45434 .71402 L p .45361 .65999 L F P
0 g
s
.205 .289 .58 r
.45361 .65999 m .48523 .65439 L .48137 .70967 L p F P
0 g
s
.967 .27 .111 r
.45361 .65999 m .42961 .65214 L .43384 .70793 L p F P
0 g
s
1 .309 .13 r
.5429 .39734 m .56549 .40858 L .60921 .3756 L p F P
0 g
s
1 .308 .129 r
.56549 .40858 m .5429 .39734 L .50456 .43893 L p F P
0 g
s
.228 .327 .653 r
.51391 .59128 m .48188 .5975 L .47154 .54078 L p F P
0 g
s
.228 .327 .653 r
.47154 .54078 m .50344 .53403 L .51391 .59128 L p F P
0 g
s
1 .299 .125 r
.42556 .53023 m .44974 .53973 L .46238 .51127 L p F P
0 g
s
1 .299 .125 r
.46238 .51127 m .47318 .48697 L p .46401 .4953 L F P
0 g
s
.238 .343 .685 r
.46238 .51127 m .45454 .486 L p .46401 .4953 L F P
0 g
s
1 .299 .125 r
.42556 .53023 m .46238 .51127 L .46401 .4953 L F
.238 .343 .685 r
.50344 .53403 m .47154 .54078 L .46238 .51127 L p F P
0 g
s
.238 .343 .685 r
.46401 .4953 m .50344 .53403 L .46238 .51127 L F
.218 .309 .619 r
.51746 .64869 m .48523 .65439 L .48188 .5975 L p F P
0 g
s
.218 .309 .619 r
.48188 .5975 m .51391 .59128 L .51746 .64869 L p F P
0 g
s
1 .292 .121 r
.44974 .53973 m .42556 .53023 L .41059 .58665 L p F P
0 g
s
1 .292 .121 r
.41059 .58665 m .43503 .59542 L .44974 .53973 L p F P
0 g
s
.248 .36 .716 r
.40008 .44259 m .43135 .43489 L .45454 .486 L p F P
0 g
s
.258 .377 .748 r
.43135 .43489 m .40008 .44259 L .37121 .3974 L p F P
0 g
s
1 .305 .127 r
.47318 .48697 m .50456 .43893 L p .47193 .46126 L F P
0 g
s
1 .305 .127 r
.46521 .48356 m .47318 .48697 L p .47193 .46126 L F P
0 g
s
.238 .343 .685 r
.4622 .49352 m .46432 .49222 L .46401 .4953 L F
.45454 .486 m .46521 .48356 L p .4622 .49352 L F P
0 g
s
1 .299 .125 r
.47318 .48697 m .46521 .48356 L p .46401 .4953 L F P
0 g
s
.238 .343 .685 r
.46521 .48356 m .48639 .4787 L p .4622 .49352 L F P
0 g
s
.248 .36 .716 r
.45454 .486 m .43135 .43489 L p .46793 .464 L F P
0 g
s
1 .305 .127 r
.46793 .464 m .46521 .48356 L .47193 .46126 L F
.248 .36 .716 r
.48639 .4787 m .46521 .48356 L p .46793 .464 L F P
0 g
s
.248 .36 .716 r
.46521 .48356 m .45454 .486 L p .46793 .464 L F P
0 g
s
1 .305 .127 r
.4493 .47675 m .46521 .48356 L p .46793 .464 L F P
0 g
s
1 .299 .125 r
.4493 .47675 m .42556 .53023 L p .46401 .4953 L F P
0 g
s
1 .299 .125 r
.46521 .48356 m .4493 .47675 L p .46401 .4953 L F P
0 g
s
.238 .343 .685 r
.48639 .4787 m .50344 .53403 L p .46401 .4953 L F P
0 g
s
.238 .343 .685 r
.46432 .49222 m .48639 .4787 L .46401 .4953 L F
1 .283 .117 r
.43503 .59542 m .41059 .58665 L .40495 .64409 L p F P
0 g
s
1 .283 .117 r
.40495 .64409 m .42961 .65214 L .43503 .59542 L p F P
0 g
s
.205 .289 .58 r
.51386 .70445 m .48137 .70967 L .48523 .65439 L p F P
0 g
s
.205 .289 .58 r
.48523 .65439 m .51746 .64869 L .51386 .70445 L p F P
0 g
s
1 .308 .129 r
.48101 .42802 m .50456 .43893 L .5429 .39734 L p F P
0 g
s
.248 .36 .716 r
.43135 .43489 m .46323 .42703 L .47074 .4438 L p F P
0 g
s
1 .305 .127 r
.46793 .464 m .50456 .43893 L .47074 .4438 L F
.248 .36 .716 r
.47074 .4438 m .48639 .4787 L p .46793 .464 L F P
0 g
s
.248 .36 .716 r
.43135 .43489 m .47074 .4438 L .46793 .464 L F
1 .305 .127 r
.50456 .43893 m .48101 .42802 L .47074 .4438 L p F P
0 g
s
1 .305 .127 r
.47074 .4438 m .4493 .47675 L p .46793 .464 L F P
0 g
s
.228 .327 .653 r
.54655 .58494 m .51391 .59128 L .50344 .53403 L p F P
0 g
s
.228 .327 .653 r
.50344 .53403 m .53596 .52714 L .54655 .58494 L p F P
0 g
s
.238 .343 .685 r
.53596 .52714 m .50344 .53403 L .48639 .4787 L p F P
0 g
s
1 .307 .13 r
.58698 .3638 m .60921 .3756 L .65721 .35205 L p F P
0 g
s
1 .309 .13 r
.60921 .3756 m .58698 .3638 L .5429 .39734 L p F P
0 g
s
.967 .27 .111 r
.42961 .65214 m .40495 .64409 L .40902 .70056 L p F P
0 g
s
.967 .27 .111 r
.40902 .70056 m .43384 .70793 L .42961 .65214 L p F P
0 g
s
.218 .309 .619 r
.55031 .64287 m .51746 .64869 L .51391 .59128 L p F P
0 g
s
.218 .309 .619 r
.51391 .59128 m .54655 .58494 L .55031 .64287 L p F P
0 g
s
.258 .377 .748 r
.46323 .42703 m .43135 .43489 L .40257 .38917 L p F P
0 g
s
.258 .377 .748 r
.37121 .3974 m .40257 .38917 L .43135 .43489 L p F P
0 g
s
.238 .343 .685 r
.48639 .4787 m .51886 .47125 L .53596 .52714 L p F P
0 g
s
1 .305 .127 r
.42476 .46626 m .4493 .47675 L .47074 .4438 L p F P
0 g
s
1 .305 .127 r
.47074 .4438 m .48101 .42802 L p .4721 .43408 L F P
0 g
s
.248 .36 .716 r
.47074 .4438 m .46323 .42703 L p .4721 .43408 L F P
0 g
s
1 .305 .127 r
.42476 .46626 m .47074 .4438 L .4721 .43408 L F
.248 .36 .716 r
.51886 .47125 m .48639 .4787 L .47074 .4438 L p F P
0 g
s
.248 .36 .716 r
.4721 .43408 m .51886 .47125 L .47074 .4438 L F
.268 .395 .782 r
.40257 .38917 m .37121 .3974 L .33746 .3593 L p F P
0 g
s
1 .309 .13 r
.5197 .38579 m .5429 .39734 L .58698 .3638 L p F P
0 g
s
1 .308 .129 r
.5429 .39734 m .5197 .38579 L .48101 .42802 L p F P
0 g
s
1 .299 .125 r
.40072 .52048 m .42556 .53023 L .4493 .47675 L p F P
0 g
s
1 .292 .121 r
.42556 .53023 m .40072 .52048 L .38548 .57763 L p F P
0 g
s
1 .292 .121 r
.38548 .57763 m .41059 .58665 L .42556 .53023 L p F P
0 g
s
.191 .265 .533 r
.50305 .75671 m .47024 .76149 L .48137 .70967 L p F P
0 g
s
.191 .265 .533 r
.48137 .70967 m .51386 .70445 L .50305 .75671 L p F P
0 g
s
.205 .289 .58 r
.54699 .69913 m .51386 .70445 L .51746 .64869 L p F P
0 g
s
.205 .289 .58 r
.51746 .64869 m .55031 .64287 L .54699 .69913 L p F P
0 g
s
1 .299 .125 r
.4493 .47675 m .42476 .46626 L .40072 .52048 L p F P
0 g
s
1 .283 .117 r
.41059 .58665 m .38548 .57763 L .37962 .63581 L p F P
0 g
s
1 .283 .117 r
.37962 .63581 m .40495 .64409 L .41059 .58665 L p F P
0 g
s
.914 .252 .103 r
.43384 .70793 m .40902 .70056 L .4229 .75403 L p F P
0 g
s
.914 .252 .103 r
.4229 .75403 m .44781 .76075 L .43384 .70793 L p F P
0 g
s
.228 .327 .653 r
.57984 .57848 m .54655 .58494 L .53596 .52714 L p F P
0 g
s
.228 .327 .653 r
.53596 .52714 m .56911 .52012 L .57984 .57848 L p F P
0 g
s
.238 .343 .685 r
.56911 .52012 m .53596 .52714 L .51886 .47125 L p F P
0 g
s
1 .308 .129 r
.48101 .42802 m .5197 .38579 L p .48114 .40481 L F P
0 g
s
1 .308 .129 r
.47343 .42452 m .48101 .42802 L p .48114 .40481 L F P
0 g
s
.248 .36 .716 r
.47026 .43262 m .47246 .43144 L .4721 .43408 L F
.46323 .42703 m .47343 .42452 L p .47026 .43262 L F P
0 g
s
1 .305 .127 r
.48101 .42802 m .47343 .42452 L p .4721 .43408 L F P
0 g
s
.248 .36 .716 r
.47343 .42452 m .49572 .41902 L p .47026 .43262 L F P
0 g
s
.258 .377 .748 r
.46323 .42703 m .43454 .38077 L p .47659 .40706 L F P
0 g
s
1 .308 .129 r
.47659 .40706 m .47343 .42452 L .48114 .40481 L F
.258 .377 .748 r
.49572 .41902 m .47343 .42452 L p .47659 .40706 L F P
0 g
s
.258 .377 .748 r
.47343 .42452 m .46323 .42703 L p .47659 .40706 L F P
0 g
s
.258 .377 .748 r
.40257 .38917 m .43454 .38077 L .46323 .42703 L p F P
0 g
s
1 .308 .129 r
.45681 .41682 m .47343 .42452 L p .47659 .40706 L F P
0 g
s
1 .305 .127 r
.45681 .41682 m .42476 .46626 L p .4721 .43408 L F P
0 g
s
1 .305 .127 r
.47343 .42452 m .45681 .41682 L p .4721 .43408 L F P
0 g
s
.248 .36 .716 r
.49572 .41902 m .51886 .47125 L p .4721 .43408 L F P
0 g
s
.248 .36 .716 r
.47246 .43144 m .49572 .41902 L .4721 .43408 L F
.218 .309 .619 r
.5838 .63695 m .55031 .64287 L .54655 .58494 L p F P
0 g
s
.218 .309 .619 r
.54655 .58494 m .57984 .57848 L .5838 .63695 L p F P
0 g
s
.997 .297 .127 r
.63536 .33978 m .65721 .35205 L .70783 .33918 L p F P
0 g
s
1 .307 .13 r
.65721 .35205 m .63536 .33978 L .58698 .3638 L p F P
0 g
s
.238 .343 .685 r
.51886 .47125 m .55196 .46366 L .56911 .52012 L p F P
0 g
s
.248 .36 .716 r
.55196 .46366 m .51886 .47125 L .49572 .41902 L p F P
0 g
s
.268 .395 .782 r
.43454 .38077 m .40257 .38917 L .36897 .35057 L p F P
0 g
s
.268 .395 .782 r
.33746 .3593 m .36897 .35057 L .40257 .38917 L p F P
0 g
s
1 .307 .13 r
.56415 .35167 m .58698 .3638 L .63536 .33978 L p F P
0 g
s
1 .309 .13 r
.58698 .3638 m .56415 .35167 L .5197 .38579 L p F P
0 g
s
.967 .27 .111 r
.40495 .64409 m .37962 .63581 L .38352 .69299 L p F P
0 g
s
.967 .27 .111 r
.38352 .69299 m .40902 .70056 L .40495 .64409 L p F P
0 g
s
.191 .265 .533 r
.53651 .75184 m .50305 .75671 L .51386 .70445 L p F P
0 g
s
.191 .265 .533 r
.51386 .70445 m .54699 .69913 L .53651 .75184 L p F P
0 g
s
.205 .289 .58 r
.58077 .6937 m .54699 .69913 L .55031 .64287 L p F P
0 g
s
.205 .289 .58 r
.55031 .64287 m .5838 .63695 L .58077 .6937 L p F P
0 g
s
1 .309 .13 r
.49585 .37392 m .5197 .38579 L .56415 .35167 L p F P
0 g
s
1 .308 .129 r
.47659 .40706 m .5197 .38579 L .47929 .39212 L F
.258 .377 .748 r
.52886 .41085 m .49572 .41902 L .47929 .39212 L p F P
0 g
s
.258 .377 .748 r
.47929 .39212 m .46714 .37221 L p .48129 .38107 L F P
0 g
s
1 .308 .129 r
.5197 .38579 m .49585 .37392 L .47929 .39212 L p F P
0 g
s
.258 .377 .748 r
.43454 .38077 m .47929 .39212 L .47659 .40706 L F
1 .308 .129 r
.43194 .40531 m .45681 .41682 L .47929 .39212 L p F P
0 g
s
1 .308 .129 r
.47929 .39212 m .49585 .37392 L p .48129 .38107 L F P
0 g
s
.258 .377 .748 r
.43454 .38077 m .46714 .37221 L .47929 .39212 L p F P
0 g
s
1 .308 .129 r
.43194 .40531 m .47929 .39212 L .48129 .38107 L F
.258 .377 .748 r
.47929 .39212 m .49572 .41902 L p .47659 .40706 L F P
0 g
s
.258 .377 .748 r
.48129 .38107 m .52886 .41085 L .47929 .39212 L F
1 .308 .129 r
.47929 .39212 m .45681 .41682 L p .47659 .40706 L F P
0 g
s
.279 .414 .818 r
.36897 .35057 m .33746 .3593 L .2998 .32997 L p F P
0 g
s
.171 .233 .471 r
.47024 .76149 m .50305 .75671 L .48509 .80355 L p F P
0 g
s
1 .299 .125 r
.3752 .51045 m .40072 .52048 L .42476 .46626 L p F P
0 g
s
1 .292 .121 r
.40072 .52048 m .3752 .51045 L .35968 .56837 L p F P
0 g
s
1 .292 .121 r
.35968 .56837 m .38548 .57763 L .40072 .52048 L p F P
0 g
s
.228 .327 .653 r
.61377 .57189 m .57984 .57848 L .56911 .52012 L p F P
0 g
s
.228 .327 .653 r
.56911 .52012 m .60291 .51296 L .61377 .57189 L p F P
0 g
s
.238 .343 .685 r
.60291 .51296 m .56911 .52012 L .55196 .46366 L p F P
0 g
s
1 .305 .127 r
.39955 .45547 m .42476 .46626 L .45681 .41682 L p F P
0 g
s
1 .299 .125 r
.42476 .46626 m .39955 .45547 L .3752 .51045 L p F P
0 g
s
.218 .309 .619 r
.61796 .6309 m .5838 .63695 L .57984 .57848 L p F P
0 g
s
.218 .309 .619 r
.57984 .57848 m .61377 .57189 L .61796 .6309 L p F P
0 g
s
.703 .185 .074 r
.50389 .84918 m .52806 .85469 L .49558 .81451 L p F P
0 g
s
.833 .226 .091 r
.44781 .76075 m .4229 .75403 L .44641 .80238 L p F P
0 g
s
.248 .36 .716 r
.49572 .41902 m .52886 .41085 L .55196 .46366 L p F P
0 g
s
1 .283 .117 r
.38548 .57763 m .35968 .56837 L .35359 .6273 L p F P
0 g
s
1 .283 .117 r
.35359 .6273 m .37962 .63581 L .38548 .57763 L p F P
0 g
s
.914 .252 .103 r
.40902 .70056 m .38352 .69299 L .39729 .74712 L p F P
0 g
s
.914 .252 .103 r
.39729 .74712 m .4229 .75403 L .40902 .70056 L p F P
0 g
s
.238 .343 .685 r
.55196 .46366 m .58572 .45591 L .60291 .51296 L p F P
0 g
s
.248 .36 .716 r
.58572 .45591 m .55196 .46366 L .52886 .41085 L p F P
0 g
s
.268 .395 .782 r
.46714 .37221 m .43454 .38077 L .4011 .34166 L p F P
0 g
s
.268 .395 .782 r
.36897 .35057 m .4011 .34166 L .43454 .38077 L p F P
0 g
s
1 .305 .127 r
.45681 .41682 m .43194 .40531 L .39955 .45547 L p F P
0 g
s
.191 .265 .533 r
.57065 .74687 m .53651 .75184 L .54699 .69913 L p F P
0 g
s
.191 .265 .533 r
.54699 .69913 m .58077 .6937 L .57065 .74687 L p F P
0 g
s
.142 .187 .38 r
.4267 .84708 m .3938 .85108 L .41938 .81226 L p F P
0 g
s
.205 .289 .58 r
.61523 .68816 m .58077 .6937 L .5838 .63695 L p F P
0 g
s
.205 .289 .58 r
.5838 .63695 m .61796 .6309 L .61523 .68816 L p F P
0 g
s
.997 .297 .127 r
.70783 .33918 m .68637 .32655 L .63536 .33978 L p F P
0 g
s
.997 .297 .127 r
.61291 .32716 m .63536 .33978 L .68637 .32655 L p F P
0 g
s
1 .307 .13 r
.63536 .33978 m .61291 .32716 L .56415 .35167 L p F P
0 g
s
.901 .274 .119 r
.68637 .32655 m .70783 .33918 L .75914 .33797 L p F P
0 g
s
1 .307 .13 r
.54068 .33921 m .56415 .35167 L .61291 .32716 L p F P
0 g
s
1 .309 .13 r
.56415 .35167 m .54068 .33921 L .49585 .37392 L p F P
0 g
s
.967 .27 .111 r
.37962 .63581 m .35359 .6273 L .3573 .68521 L p F P
0 g
s
.967 .27 .111 r
.3573 .68521 m .38352 .69299 L .37962 .63581 L p F P
0 g
s
.279 .414 .818 r
.4011 .34166 m .36897 .35057 L .3315 .32078 L p F P
0 g
s
.279 .414 .818 r
.2998 .32997 m .3315 .32078 L .36897 .35057 L p F P
0 g
s
.171 .233 .471 r
.51894 .79907 m .48509 .80355 L .50305 .75671 L p F P
0 g
s
.171 .233 .471 r
.50305 .75671 m .53651 .75184 L .51894 .79907 L p F P
0 g
s
.228 .327 .653 r
.64839 .56517 m .61377 .57189 L .60291 .51296 L p F P
0 g
s
.228 .327 .653 r
.60291 .51296 m .63739 .50566 L .64839 .56517 L p F P
0 g
s
.238 .343 .685 r
.63739 .50566 m .60291 .51296 L .58572 .45591 L p F P
0 g
s
.218 .309 .619 r
.6528 .62473 m .61796 .6309 L .61377 .57189 L p F P
0 g
s
.218 .309 .619 r
.61377 .57189 m .64839 .56517 L .6528 .62473 L p F P
0 g
s
.248 .36 .716 r
.52886 .41085 m .56265 .40252 L .58572 .45591 L p F P
0 g
s
1 .309 .13 r
.49585 .37392 m .54068 .33921 L p .49045 .35552 L F P
0 g
s
.268 .395 .782 r
.46714 .37221 m .43387 .33257 L p .48218 .35502 L F P
0 g
s
.268 .395 .782 r
.48218 .35502 m .48273 .3597 L .46714 .37221 L F
.48368 .36787 m .46714 .37221 L p .48622 .35689 L F P
0 g
s
1 .308 .129 r
.48129 .38107 m .48501 .37925 L .48226 .37572 L F
.49585 .37392 m .48368 .36787 L p .48501 .37925 L F P
0 g
s
.258 .377 .748 r
.46714 .37221 m .48368 .36787 L p .47768 .37881 L F P
0 g
s
.258 .377 .748 r
.48368 .36787 m .48226 .37572 L .47768 .37881 L F
1 .308 .129 r
.48368 .36787 m .47134 .36172 L p .48226 .37572 L F P
0 g
s
1 .308 .129 r
.48501 .37925 m .48368 .36787 L .48226 .37572 L F
1 .309 .13 r
.48368 .36787 m .49585 .37392 L p .49045 .35552 L F P
0 g
s
.258 .377 .748 r
.48368 .36787 m .50039 .36348 L p .48226 .37572 L F P
0 g
s
.258 .377 .748 r
.50039 .36348 m .52886 .41085 L p .48129 .38107 L F P
0 g
s
.258 .377 .748 r
.47768 .37881 m .48226 .37572 L .48129 .38107 L F
.48226 .37572 m .50039 .36348 L .48129 .38107 L F
.268 .395 .782 r
.4011 .34166 m .43387 .33257 L .46714 .37221 L p F P
0 g
s
1 .308 .129 r
.47134 .36172 m .43194 .40531 L p .48129 .38107 L F P
0 g
s
1 .308 .129 r
.48129 .38107 m .48226 .37572 L .47134 .36172 L F
.268 .395 .782 r
.48218 .35502 m .48622 .35689 L .48273 .3597 L F
1 .309 .13 r
.48622 .35689 m .48368 .36787 L .49045 .35552 L F
.268 .395 .782 r
.50039 .36348 m .48368 .36787 L p .48622 .35689 L F P
0 g
s
1 .309 .13 r
.47134 .36172 m .48368 .36787 L p .48622 .35689 L F P
0 g
s
.258 .377 .748 r
.56265 .40252 m .52886 .41085 L .50039 .36348 L p F P
0 g
s
1 .299 .125 r
.34896 .50014 m .3752 .51045 L .39955 .45547 L p F P
0 g
s
1 .292 .121 r
.3752 .51045 m .34896 .50014 L .33315 .55885 L p F P
0 g
s
1 .292 .121 r
.33315 .55885 m .35968 .56837 L .3752 .51045 L p F P
0 g
s
.238 .343 .685 r
.58572 .45591 m .62015 .44802 L .63739 .50566 L p F P
0 g
s
.248 .36 .716 r
.62015 .44802 m .58572 .45591 L .56265 .40252 L p F P
0 g
s
1 .305 .127 r
.37364 .44439 m .39955 .45547 L .43194 .40531 L p F P
0 g
s
1 .299 .125 r
.39955 .45547 m .37364 .44439 L .34896 .50014 L p F P
0 g
s
.833 .226 .091 r
.4229 .75403 m .39729 .74712 L .42077 .79606 L p F P
0 g
s
.833 .226 .091 r
.42077 .79606 m .44641 .80238 L .4229 .75403 L p F P
0 g
s
.191 .265 .533 r
.60547 .74179 m .57065 .74687 L .58077 .6937 L p F P
0 g
s
.191 .265 .533 r
.58077 .6937 m .61523 .68816 L .60547 .74179 L p F P
0 g
s
1 .283 .117 r
.35968 .56837 m .33315 .55885 L .32681 .61855 L p F P
0 g
s
1 .283 .117 r
.32681 .61855 m .35359 .6273 L .35968 .56837 L p F P
0 g
s
.205 .289 .58 r
.65038 .68252 m .61523 .68816 L .61796 .6309 L p F P
0 g
s
.205 .289 .58 r
.61796 .6309 m .6528 .62473 L .65038 .68252 L p F P
0 g
s
.498 .121 .047 r
.52806 .85469 m .50389 .84918 L .54455 .88071 L p F P
0 g
s
.498 .121 .047 r
.54455 .88071 m .56855 .88587 L .52806 .85469 L p F P
0 g
s
.914 .252 .103 r
.38352 .69299 m .3573 .68521 L .37095 .74001 L p F P
0 g
s
.914 .252 .103 r
.37095 .74001 m .39729 .74712 L .38352 .69299 L p F P
0 g
s
.288 .434 .852 r
.3315 .32078 m .2998 .32997 L .25942 .31099 L p F P
0 g
s
1 .308 .129 r
.40637 .39347 m .43194 .40531 L .47134 .36172 L p F P
0 g
s
1 .305 .127 r
.43194 .40531 m .40637 .39347 L .37364 .44439 L p F P
0 g
s
.279 .414 .818 r
.43387 .33257 m .4011 .34166 L .36385 .3114 L p F P
0 g
s
.279 .414 .818 r
.3315 .32078 m .36385 .3114 L .4011 .34166 L p F P
0 g
s
.171 .233 .471 r
.55348 .79449 m .51894 .79907 L .53651 .75184 L p F P
0 g
s
.171 .233 .471 r
.53651 .75184 m .57065 .74687 L .55348 .79449 L p F P
0 g
s
.228 .327 .653 r
.6837 .55831 m .64839 .56517 L .63739 .50566 L p F P
0 g
s
.228 .327 .653 r
.63739 .50566 m .67255 .49821 L .6837 .55831 L p F P
0 g
s
.238 .343 .685 r
.67255 .49821 m .63739 .50566 L .62015 .44802 L p F P
0 g
s
.218 .309 .619 r
.68835 .61844 m .6528 .62473 L .64839 .56517 L p F P
0 g
s
.218 .309 .619 r
.64839 .56517 m .6837 .55831 L .68835 .61844 L p F P
0 g
s
.997 .297 .127 r
.68637 .32655 m .6643 .31357 L .61291 .32716 L p F P
0 g
s
.997 .297 .127 r
.58983 .3142 m .61291 .32716 L .6643 .31357 L p F P
0 g
s
1 .307 .13 r
.61291 .32716 m .58983 .3142 L .54068 .33921 L p F P
0 g
s
.901 .274 .119 r
.75914 .33797 m .73806 .32512 L .68637 .32655 L p F P
0 g
s
.901 .274 .119 r
.6643 .31357 m .68637 .32655 L .73806 .32512 L p F P
0 g
s
.248 .36 .716 r
.56265 .40252 m .59713 .39403 L .62015 .44802 L p F P
0 g
s
.258 .377 .748 r
.59713 .39403 m .56265 .40252 L .53431 .35457 L p F P
0 g
s
.258 .377 .748 r
.50039 .36348 m .53431 .35457 L .56265 .40252 L p F P
0 g
s
1 .307 .13 r
.51655 .3264 m .54068 .33921 L .58983 .3142 L p F P
0 g
s
1 .309 .13 r
.48622 .35689 m .54068 .33921 L .48814 .3486 L F
.268 .395 .782 r
.53431 .35457 m .50039 .36348 L .48814 .3486 L p F P
0 g
s
.268 .395 .782 r
.48814 .3486 m .46731 .3233 L p .49139 .33454 L F P
0 g
s
1 .309 .13 r
.54068 .33921 m .51655 .3264 L .48814 .3486 L p F P
0 g
s
.268 .395 .782 r
.43387 .33257 m .48814 .3486 L .48622 .35689 L F
1 .309 .13 r
.44614 .34918 m .47134 .36172 L .48814 .3486 L p F P
0 g
s
1 .309 .13 r
.48814 .3486 m .51655 .3264 L p .49139 .33454 L F P
0 g
s
.268 .395 .782 r
.43387 .33257 m .46731 .3233 L .48814 .3486 L p F P
0 g
s
1 .309 .13 r
.44614 .34918 m .48814 .3486 L .49139 .33454 L F
.268 .395 .782 r
.48814 .3486 m .50039 .36348 L p .48622 .35689 L F P
0 g
s
.268 .395 .782 r
.49139 .33454 m .53431 .35457 L .48814 .3486 L F
1 .309 .13 r
.48814 .3486 m .47134 .36172 L p .48622 .35689 L F P
0 g
s
.967 .27 .111 r
.35359 .6273 m .32681 .61855 L .33033 .6772 L p F P
0 g
s
.967 .27 .111 r
.33033 .6772 m .3573 .68521 L .35359 .6273 L p F P
0 g
s
.699 .221 .098 r
.73806 .32512 m .75914 .33797 L .80903 .34903 L p F P
0 g
s
.238 .343 .685 r
.62015 .44802 m .65527 .43996 L .67255 .49821 L p F P
0 g
s
.248 .36 .716 r
.65527 .43996 m .62015 .44802 L .59713 .39403 L p F P
0 g
s
.096 .115 .238 r
.39517 .87696 m .36188 .88074 L .3938 .85108 L p F P
0 g
s
.096 .115 .238 r
.3938 .85108 m .4267 .84708 L .39517 .87696 L p F P
0 g
s
1 .308 .129 r
.47134 .36172 m .44614 .34918 L .40637 .39347 L p F P
0 g
s
.191 .265 .533 r
.64101 .73661 m .60547 .74179 L .61523 .68816 L p F P
0 g
s
.191 .265 .533 r
.61523 .68816 m .65038 .68252 L .64101 .73661 L p F P
0 g
s
.142 .187 .38 r
.48509 .80355 m .51894 .79907 L .49454 .83883 L p F P
0 g
s
.205 .289 .58 r
.68625 .67675 m .65038 .68252 L .6528 .62473 L p F P
0 g
s
.205 .289 .58 r
.6528 .62473 m .68835 .61844 L .68625 .67675 L p F P
0 g
s
1 .299 .125 r
.32198 .48954 m .34896 .50014 L .37364 .44439 L p F P
0 g
s
1 .292 .121 r
.34896 .50014 m .32198 .48954 L .30588 .54905 L p F P
0 g
s
1 .292 .121 r
.30588 .54905 m .33315 .55885 L .34896 .50014 L p F P
0 g
s
.288 .434 .852 r
.36385 .3114 m .3315 .32078 L .29138 .30141 L p F P
0 g
s
.288 .434 .852 r
.25942 .31099 m .29138 .30141 L .3315 .32078 L p F P
0 g
s
1 .305 .127 r
.34699 .43299 m .37364 .44439 L .40637 .39347 L p F P
0 g
s
1 .299 .125 r
.37364 .44439 m .34699 .43299 L .32198 .48954 L p F P
0 g
s
.703 .185 .074 r
.44641 .80238 m .42077 .79606 L .45346 .83768 L p F P
0 g
s
.833 .226 .091 r
.39729 .74712 m .37095 .74001 L .3944 .78955 L p F P
0 g
s
.833 .226 .091 r
.3944 .78955 m .42077 .79606 L .39729 .74712 L p F P
0 g
s
.279 .414 .818 r
.46731 .3233 m .43387 .33257 L .39687 .30183 L p F P
0 g
s
.279 .414 .818 r
.36385 .3114 m .39687 .30183 L .43387 .33257 L p F P
0 g
s
.171 .233 .471 r
.58873 .78982 m .55348 .79449 L .57065 .74687 L p F P
0 g
s
.171 .233 .471 r
.57065 .74687 m .60547 .74179 L .58873 .78982 L p F P
0 g
s
.228 .327 .653 r
.71972 .55131 m .6837 .55831 L .67255 .49821 L p F P
0 g
s
.228 .327 .653 r
.67255 .49821 m .70843 .49061 L .71972 .55131 L p F P
0 g
s
.238 .343 .685 r
.70843 .49061 m .67255 .49821 L .65527 .43996 L p F P
0 g
s
1 .283 .117 r
.33315 .55885 m .30588 .54905 L .29928 .60955 L p F P
0 g
s
1 .283 .117 r
.29928 .60955 m .32681 .61855 L .33315 .55885 L p F P
0 g
s
.498 .121 .047 r
.51987 .8754 m .54455 .88071 L .50389 .84918 L p F P
0 g
s
.218 .309 .619 r
.72462 .61202 m .68835 .61844 L .6837 .55831 L p F P
0 g
s
.218 .309 .619 r
.6837 .55831 m .71972 .55131 L .72462 .61202 L p F P
0 g
s
.914 .252 .103 r
.3573 .68521 m .33033 .6772 L .34386 .7327 L p F P
0 g
s
.914 .252 .103 r
.34386 .7327 m .37095 .74001 L .3573 .68521 L p F P
0 g
s
.248 .36 .716 r
.59713 .39403 m .63231 .38536 L .65527 .43996 L p F P
0 g
s
.258 .377 .748 r
.63231 .38536 m .59713 .39403 L .56892 .34548 L p F P
0 g
s
.258 .377 .748 r
.53431 .35457 m .56892 .34548 L .59713 .39403 L p F P
0 g
s
1 .308 .129 r
.38007 .3813 m .40637 .39347 L .44614 .34918 L p F P
0 g
s
1 .305 .127 r
.40637 .39347 m .38007 .3813 L .34699 .43299 L p F P
0 g
s
.309 .07 .029 r
.56855 .88587 m .54455 .88071 L .59198 .9013 L p F P
0 g
s
.309 .07 .029 r
.59198 .9013 m .6157 .90625 L .56855 .88587 L p F P
0 g
s
.238 .343 .685 r
.65527 .43996 m .69111 .43174 L .70843 .49061 L p F P
0 g
s
.248 .36 .716 r
.69111 .43174 m .65527 .43996 L .63231 .38536 L p F P
0 g
s
1 .307 .13 r
.58983 .3142 m .56609 .30086 L .51655 .3264 L p F P
0 g
s
1 .307 .13 r
.51655 .3264 m .56609 .30086 L p .49894 .31202 L F P
0 g
s
.279 .414 .818 r
.49462 .31174 m .49504 .31301 L .46731 .3233 L F
.49582 .31539 m .46731 .3233 L p .49672 .31239 L F P
0 g
s
1 .309 .13 r
.49139 .33454 m .50109 .3314 L .4949 .31938 L F
.51655 .3264 m .49582 .31539 L p .50109 .3314 L F P
0 g
s
.268 .395 .782 r
.46731 .3233 m .49582 .31539 L p .48213 .33021 L F P
0 g
s
.268 .395 .782 r
.49582 .31539 m .4949 .31938 L .48213 .33021 L F
1 .309 .13 r
.49582 .31539 m .49172 .31322 L p .4949 .31938 L F P
0 g
s
1 .309 .13 r
.50109 .3314 m .49582 .31539 L .4949 .31938 L F
1 .307 .13 r
.49582 .31539 m .51655 .3264 L p .49894 .31202 L F P
0 g
s
.268 .395 .782 r
.49582 .31539 m .50144 .31383 L p .4949 .31938 L F P
0 g
s
.268 .395 .782 r
.50144 .31383 m .53431 .35457 L p .49139 .33454 L F P
0 g
s
.268 .395 .782 r
.48213 .33021 m .4949 .31938 L .49139 .33454 L F
.4949 .31938 m .50144 .31383 L .49139 .33454 L F
1 .309 .13 r
.49172 .31322 m .44614 .34918 L p .49139 .33454 L F P
0 g
s
1 .309 .13 r
.49139 .33454 m .4949 .31938 L .49172 .31322 L F
.279 .414 .818 r
.46731 .3233 m .43056 .29206 L p .49462 .31174 L F P
0 g
s
.279 .414 .818 r
.49462 .31174 m .49672 .31239 L .49504 .31301 L F
1 .307 .13 r
.49672 .31239 m .49582 .31539 L .49894 .31202 L F
.279 .414 .818 r
.50144 .31383 m .49582 .31539 L p .49672 .31239 L F P
0 g
s
1 .307 .13 r
.49172 .31322 m .49582 .31539 L p .49672 .31239 L F P
0 g
s
.268 .395 .782 r
.56892 .34548 m .53431 .35457 L .50144 .31383 L p F P
0 g
s
.997 .297 .127 r
.6643 .31357 m .64161 .30021 L .58983 .3142 L p F P
0 g
s
.997 .297 .127 r
.56609 .30086 m .58983 .3142 L .64161 .30021 L p F P
0 g
s
.096 .115 .238 r
.42915 .8731 m .39517 .87696 L .4267 .84708 L p F P
0 g
s
.901 .274 .119 r
.73806 .32512 m .71638 .31191 L .6643 .31357 L p F P
0 g
s
.901 .274 .119 r
.64161 .30021 m .6643 .31357 L .71638 .31191 L p F P
0 g
s
.191 .265 .533 r
.67729 .73133 m .64101 .73661 L .65038 .68252 L p F P
0 g
s
.191 .265 .533 r
.65038 .68252 m .68625 .67675 L .67729 .73133 L p F P
0 g
s
.967 .27 .111 r
.32681 .61855 m .29928 .60955 L .30259 .66897 L p F P
0 g
s
.967 .27 .111 r
.30259 .66897 m .33033 .6772 L .32681 .61855 L p F P
0 g
s
.142 .187 .38 r
.52952 .83457 m .49454 .83883 L .51894 .79907 L p F P
0 g
s
.142 .187 .38 r
.51894 .79907 m .55348 .79449 L .52952 .83457 L p F P
0 g
s
.205 .289 .58 r
.72286 .67087 m .68625 .67675 L .68835 .61844 L p F P
0 g
s
.205 .289 .58 r
.68835 .61844 m .72462 .61202 L .72286 .67087 L p F P
0 g
s
.699 .221 .098 r
.80903 .34903 m .78832 .33612 L .73806 .32512 L p F P
0 g
s
.699 .221 .098 r
.71638 .31191 m .73806 .32512 L .78832 .33612 L p F P
0 g
s
.288 .434 .852 r
.39687 .30183 m .36385 .3114 L .324 .29163 L p F P
0 g
s
.288 .434 .852 r
.29138 .30141 m .324 .29163 L .36385 .3114 L p F P
0 g
s
.288 .441 .86 r
.29138 .30141 m .25942 .31099 L .21779 .30377 L p F P
0 g
s
.279 .414 .818 r
.39687 .30183 m .43056 .29206 L .46731 .3233 L p F P
0 g
s
.171 .233 .471 r
.62472 .78505 m .58873 .78982 L .60547 .74179 L p F P
0 g
s
.171 .233 .471 r
.60547 .74179 m .64101 .73661 L .62472 .78505 L p F P
0 g
s
1 .309 .13 r
.42021 .33628 m .44614 .34918 L .49172 .31322 L p F P
0 g
s
1 .308 .129 r
.44614 .34918 m .42021 .33628 L .38007 .3813 L p F P
0 g
s
.444 .142 .066 r
.78832 .33612 m .80903 .34903 L .85523 .37247 L p F P
0 g
s
.228 .327 .653 r
.75649 .54418 m .71972 .55131 L .70843 .49061 L p F P
0 g
s
.228 .327 .653 r
.70843 .49061 m .74505 .48286 L .75649 .54418 L p F P
0 g
s
.238 .343 .685 r
.74505 .48286 m .70843 .49061 L .69111 .43174 L p F P
0 g
s
.218 .309 .619 r
.76164 .60547 m .72462 .61202 L .71972 .55131 L p F P
0 g
s
.218 .309 .619 r
.71972 .55131 m .75649 .54418 L .76164 .60547 L p F P
0 g
s
1 .299 .125 r
.29423 .47864 m .32198 .48954 L .34699 .43299 L p F P
0 g
s
1 .292 .121 r
.32198 .48954 m .29423 .47864 L .27781 .53898 L p F P
0 g
s
1 .292 .121 r
.27781 .53898 m .30588 .54905 L .32198 .48954 L p F P
0 g
s
.248 .36 .716 r
.63231 .38536 m .66821 .37651 L .69111 .43174 L p F P
0 g
s
.258 .377 .748 r
.66821 .37651 m .63231 .38536 L .60425 .3362 L p F P
0 g
s
.258 .377 .748 r
.56892 .34548 m .60425 .3362 L .63231 .38536 L p F P
0 g
s
1 .305 .127 r
.31957 .42126 m .34699 .43299 L .38007 .3813 L p F P
0 g
s
1 .299 .125 r
.34699 .43299 m .31957 .42126 L .29423 .47864 L p F P
0 g
s
.703 .185 .074 r
.42077 .79606 m .3944 .78955 L .42714 .83168 L p F P
0 g
s
.703 .185 .074 r
.42714 .83168 m .45346 .83768 L .42077 .79606 L p F P
0 g
s
.833 .226 .091 r
.37095 .74001 m .34386 .7327 L .36725 .78286 L p F P
0 g
s
.833 .226 .091 r
.36725 .78286 m .3944 .78955 L .37095 .74001 L p F P
0 g
s
.238 .343 .685 r
.69111 .43174 m .72768 .42335 L .74505 .48286 L p F P
0 g
s
.248 .36 .716 r
.72768 .42335 m .69111 .43174 L .66821 .37651 L p F P
0 g
s
1 .307 .13 r
.56609 .30086 m .54165 .28714 L .49735 .31028 L p F P
0 g
s
1 .307 .13 r
.49672 .31239 m .56609 .30086 L .49735 .31028 L F
.279 .414 .818 r
.43056 .29206 m .46496 .28209 L .49735 .31028 L p F P
0 g
s
.279 .414 .818 r
.49735 .31028 m .50144 .31383 L p .49672 .31239 L F P
0 g
s
.279 .414 .818 r
.43056 .29206 m .49735 .31028 L .49672 .31239 L F
1 .307 .13 r
.46618 .29965 m .49172 .31322 L .49735 .31028 L p F P
0 g
s
1 .307 .13 r
.49735 .31028 m .54165 .28714 L p .50231 .29366 L F P
0 g
s
.279 .414 .818 r
.49735 .31028 m .46496 .28209 L p .50231 .29366 L F P
0 g
s
1 .307 .13 r
.46618 .29965 m .49735 .31028 L .50231 .29366 L F
.49735 .31028 m .49172 .31322 L p .49672 .31239 L F P
0 g
s
.279 .414 .818 r
.53627 .30418 m .50144 .31383 L .49735 .31028 L p F P
0 g
s
.279 .414 .818 r
.50231 .29366 m .53627 .30418 L .49735 .31028 L F
.268 .395 .782 r
.60425 .3362 m .56892 .34548 L .53627 .30418 L p F P
0 g
s
.268 .395 .782 r
.50144 .31383 m .53627 .30418 L .56892 .34548 L p F P
0 g
s
1 .283 .117 r
.30588 .54905 m .27781 .53898 L .27094 .60029 L p F P
0 g
s
1 .283 .117 r
.27094 .60029 m .29928 .60955 L .30588 .54905 L p F P
0 g
s
.914 .252 .103 r
.33033 .6772 m .30259 .66897 L .31597 .72517 L p F P
0 g
s
.914 .252 .103 r
.31597 .72517 m .34386 .7327 L .33033 .6772 L p F P
0 g
s
.191 .265 .533 r
.71432 .72593 m .67729 .73133 L .68625 .67675 L p F P
0 g
s
.191 .265 .533 r
.68625 .67675 m .72286 .67087 L .71432 .72593 L p F P
0 g
s
.142 .187 .38 r
.56523 .83023 m .52952 .83457 L .55348 .79449 L p F P
0 g
s
.142 .187 .38 r
.55348 .79449 m .58873 .78982 L .56523 .83023 L p F P
0 g
s
.205 .289 .58 r
.76024 .66486 m .72286 .67087 L .72462 .61202 L p F P
0 g
s
.205 .289 .58 r
.72462 .61202 m .76164 .60547 L .76024 .66486 L p F P
0 g
s
1 .308 .129 r
.35301 .36877 m .38007 .3813 L .42021 .33628 L p F P
0 g
s
1 .305 .127 r
.38007 .3813 m .35301 .36877 L .31957 .42126 L p F P
0 g
s
.06 .071 .137 r
.35821 .89574 m .32456 .89941 L .36188 .88074 L p F P
0 g
s
.06 .071 .137 r
.36188 .88074 m .39517 .87696 L .35821 .89574 L p F P
0 g
s
.309 .07 .029 r
.54455 .88071 m .51987 .8754 L .56756 .8962 L p F P
0 g
s
.309 .07 .029 r
.56756 .8962 m .59198 .9013 L .54455 .88071 L p F P
0 g
s
.288 .434 .852 r
.43056 .29206 m .39687 .30183 L .3573 .28165 L p F P
0 g
s
.288 .434 .852 r
.324 .29163 m .3573 .28165 L .39687 .30183 L p F P
0 g
s
.288 .441 .86 r
.324 .29163 m .29138 .30141 L .25004 .2939 L p F P
0 g
s
.288 .441 .86 r
.21779 .30377 m .25004 .2939 L .29138 .30141 L p F P
0 g
s
.997 .297 .127 r
.64161 .30021 m .61825 .28647 L .56609 .30086 L p F P
0 g
s
.997 .297 .127 r
.54165 .28714 m .56609 .30086 L .61825 .28647 L p F P
0 g
s
.528 .175 .077 r
.6157 .90625 m .59198 .9013 L .64435 .90945 L p F P
0 g
s
.528 .175 .077 r
.64435 .90945 m .6677 .91436 L .6157 .90625 L p F P
0 g
s
.171 .233 .471 r
.66146 .78018 m .62472 .78505 L .64101 .73661 L p F P
0 g
s
.171 .233 .471 r
.64101 .73661 m .67729 .73133 L .66146 .78018 L p F P
0 g
s
.901 .274 .119 r
.71638 .31191 m .69407 .29831 L .64161 .30021 L p F P
0 g
s
.901 .274 .119 r
.61825 .28647 m .64161 .30021 L .69407 .29831 L p F P
0 g
s
.228 .327 .653 r
.79401 .53689 m .75649 .54418 L .74505 .48286 L p F P
0 g
s
.228 .327 .653 r
.74505 .48286 m .78242 .47494 L .79401 .53689 L p F P
0 g
s
.238 .343 .685 r
.78242 .47494 m .74505 .48286 L .72768 .42335 L p F P
0 g
s
1 .309 .13 r
.49172 .31322 m .46618 .29965 L .42021 .33628 L p F P
0 g
s
.967 .27 .111 r
.29928 .60955 m .27094 .60029 L .27403 .66049 L p F P
0 g
s
.967 .27 .111 r
.27403 .66049 m .30259 .66897 L .29928 .60955 L p F P
0 g
s
.218 .309 .619 r
.79943 .59878 m .76164 .60547 L .75649 .54418 L p F P
0 g
s
.218 .309 .619 r
.75649 .54418 m .79401 .53689 L .79943 .59878 L p F P
0 g
s
.699 .221 .098 r
.78832 .33612 m .76699 .32284 L .71638 .31191 L p F P
0 g
s
.699 .221 .098 r
.69407 .29831 m .71638 .31191 L .76699 .32284 L p F P
0 g
s
.248 .36 .716 r
.66821 .37651 m .70485 .36748 L .72768 .42335 L p F P
0 g
s
.258 .377 .748 r
.70485 .36748 m .66821 .37651 L .64031 .32673 L p F P
0 g
s
.258 .377 .748 r
.60425 .3362 m .64031 .32673 L .66821 .37651 L p F P
0 g
s
.238 .343 .685 r
.72768 .42335 m .76502 .41479 L .78242 .47494 L p F P
0 g
s
.248 .36 .716 r
.76502 .41479 m .72768 .42335 L .70485 .36748 L p F P
0 g
s
1 .309 .13 r
.39353 .323 m .42021 .33628 L .46618 .29965 L p F P
0 g
s
1 .308 .129 r
.42021 .33628 m .39353 .323 L .35301 .36877 L p F P
0 g
s
.268 .395 .782 r
.64031 .32673 m .60425 .3362 L .57182 .29432 L p F P
0 g
s
.268 .395 .782 r
.53627 .30418 m .57182 .29432 L .60425 .3362 L p F P
0 g
s
.444 .142 .066 r
.85523 .37247 m .83483 .35969 L .78832 .33612 L p F P
0 g
s
.444 .142 .066 r
.76699 .32284 m .78832 .33612 L .83483 .35969 L p F P
0 g
s
1 .299 .125 r
.26566 .46741 m .29423 .47864 L .31957 .42126 L p F P
0 g
s
1 .292 .121 r
.29423 .47864 m .26566 .46741 L .24892 .5286 L p F P
0 g
s
1 .292 .121 r
.24892 .5286 m .27781 .53898 L .29423 .47864 L p F P
0 g
s
.096 .115 .238 r
.48147 .86715 m .46385 .86915 L .47192 .86118 L p F P
0 g
s
.096 .115 .238 r
.47192 .86118 m .47697 .85619 L p .48147 .86715 L F P
0 g
s
.309 .07 .029 r
.49446 .86994 m .48147 .86715 L p .51651 .88555 L F P
0 g
s
.06 .071 .137 r
.46385 .86915 m .48147 .86715 L p .46358 .88424 L F P
0 g
s
.309 .07 .029 r
.48612 .87217 m .49751 .87719 L p .48147 .86715 L F P
0 g
s
.309 .07 .029 r
.49751 .87719 m .51651 .88555 L p .48147 .86715 L F P
0 g
s
.498 .121 .047 r
.48147 .86715 m .49446 .86994 L .47697 .85619 L p F P
0 g
s
.06 .071 .137 r
.48147 .86715 m .49928 .86513 L .48612 .87217 L p F P
0 g
s
.06 .071 .137 r
.48612 .87217 m .46358 .88424 L p .48147 .86715 L F P
0 g
s
.309 .07 .029 r
.48147 .86715 m .46829 .86432 L .48612 .87217 L p F P
0 g
s
.498 .121 .047 r
.46829 .86432 m .48147 .86715 L p .45346 .83768 L F P
0 g
s
.498 .121 .047 r
.47697 .85619 m .45346 .83768 L p .48147 .86715 L F P
0 g
s
.096 .115 .238 r
.49928 .86513 m .48147 .86715 L p .49454 .83883 L F P
0 g
s
.096 .115 .238 r
.47697 .85619 m .49454 .83883 L p .48147 .86715 L F P
0 g
s
.096 .115 .238 r
.49454 .83883 m .52952 .83457 L .49928 .86513 L p F P
0 g
s
.191 .265 .533 r
.75214 .72042 m .71432 .72593 L .72286 .67087 L p F P
0 g
s
.191 .265 .533 r
.72286 .67087 m .76024 .66486 L .75214 .72042 L p F P
0 g
s
1 .305 .127 r
.29135 .40919 m .31957 .42126 L .35301 .36877 L p F P
0 g
s
1 .299 .125 r
.31957 .42126 m .29135 .40919 L .26566 .46741 L p F P
0 g
s
.142 .187 .38 r
.60171 .82579 m .56523 .83023 L .58873 .78982 L p F P
0 g
s
.142 .187 .38 r
.58873 .78982 m .62472 .78505 L .60171 .82579 L p F P
0 g
s
.411 .095 .039 r
.83483 .35969 m .85523 .37247 L .89539 .40784 L p F P
0 g
s
.205 .289 .58 r
.7984 .65873 m .76024 .66486 L .76164 .60547 L p F P
0 g
s
.205 .289 .58 r
.76164 .60547 m .79943 .59878 L .7984 .65873 L p F P
0 g
s
.06 .071 .137 r
.39259 .89199 m .35821 .89574 L .39517 .87696 L p F P
0 g
s
.06 .071 .137 r
.39517 .87696 m .42915 .8731 L .39259 .89199 L p F P
0 g
s
.703 .185 .074 r
.3944 .78955 m .36725 .78286 L .40003 .82551 L p F P
0 g
s
.703 .185 .074 r
.40003 .82551 m .42714 .83168 L .3944 .78955 L p F P
0 g
s
.833 .226 .091 r
.34386 .7327 m .31597 .72517 L .3393 .77596 L p F P
0 g
s
.833 .226 .091 r
.3393 .77596 m .36725 .78286 L .34386 .7327 L p F P
0 g
s
.288 .434 .852 r
.46496 .28209 m .43056 .29206 L .3913 .27146 L p F P
0 g
s
.288 .434 .852 r
.3573 .28165 m .3913 .27146 L .43056 .29206 L p F P
0 g
s
1 .283 .117 r
.27781 .53898 m .24892 .5286 L .24177 .59075 L p F P
0 g
s
1 .283 .117 r
.24177 .59075 m .27094 .60029 L .27781 .53898 L p F P
0 g
s
.498 .121 .047 r
.45346 .83768 m .42714 .83168 L .46829 .86432 L p F P
0 g
s
.288 .441 .86 r
.3573 .28165 m .324 .29163 L .28296 .28382 L p F P
0 g
s
.288 .441 .86 r
.25004 .2939 m .28296 .28382 L .324 .29163 L p F P
0 g
s
.914 .252 .103 r
.30259 .66897 m .27403 .66049 L .28726 .71742 L p F P
0 g
s
.914 .252 .103 r
.28726 .71742 m .31597 .72517 L .30259 .66897 L p F P
0 g
s
.997 .297 .127 r
.61825 .28647 m .59421 .27232 L .54165 .28714 L p F P
0 g
s
.997 .297 .127 r
.5165 .27301 m .54165 .28714 L .59421 .27232 L p F P
0 g
s
1 .307 .13 r
.54165 .28714 m .5165 .27301 L .50697 .27806 L p F P
0 g
s
1 .307 .13 r
.50231 .29366 m .54165 .28714 L .50697 .27806 L F
.279 .414 .818 r
.46496 .28209 m .50008 .27191 L .50697 .27806 L p F P
0 g
s
.279 .414 .818 r
.50697 .27806 m .53627 .30418 L p .50231 .29366 L F P
0 g
s
.279 .414 .818 r
.46496 .28209 m .50697 .27806 L .50231 .29366 L F
1 .307 .13 r
.43989 .28569 m .46618 .29965 L .50697 .27806 L p F P
0 g
s
1 .307 .13 r
.50697 .27806 m .5165 .27301 L p .50806 .2744 L F P
0 g
s
.279 .414 .818 r
.50697 .27806 m .50008 .27191 L p .50806 .2744 L F P
0 g
s
.288 .434 .852 r
.50008 .27191 m .46496 .28209 L .42603 .26106 L p F P
0 g
s
.288 .434 .852 r
.3913 .27146 m .42603 .26106 L .46496 .28209 L p F P
0 g
s
1 .307 .13 r
.43989 .28569 m .50697 .27806 L .50806 .2744 L F
.50697 .27806 m .46618 .29965 L p .50231 .29366 L F P
0 g
s
.279 .414 .818 r
.57182 .29432 m .53627 .30418 L .50697 .27806 L p F P
0 g
s
.279 .414 .818 r
.50806 .2744 m .57182 .29432 L .50697 .27806 L F
.171 .233 .471 r
.69899 .77521 m .66146 .78018 L .67729 .73133 L p F P
0 g
s
.171 .233 .471 r
.67729 .73133 m .71432 .72593 L .69899 .77521 L p F P
0 g
s
.246 .389 .747 r
.25004 .2939 m .21779 .30377 L .17662 .30941 L p F P
0 g
s
.228 .327 .653 r
.83232 .52945 m .79401 .53689 L .78242 .47494 L p F P
0 g
s
.228 .327 .653 r
.78242 .47494 m .82058 .46686 L .83232 .52945 L p F P
0 g
s
.238 .343 .685 r
.82058 .46686 m .78242 .47494 L .76502 .41479 L p F P
0 g
s
1 .308 .129 r
.32516 .35588 m .35301 .36877 L .39353 .323 L p F P
0 g
s
1 .305 .127 r
.35301 .36877 m .32516 .35588 L .29135 .40919 L p F P
0 g
s
.309 .07 .029 r
.51987 .8754 m .49446 .86994 L .54242 .89096 L p F P
0 g
s
.309 .07 .029 r
.54242 .89096 m .56756 .8962 L .51987 .8754 L p F P
0 g
s
.218 .309 .619 r
.83801 .59195 m .79943 .59878 L .79401 .53689 L p F P
0 g
s
.218 .309 .619 r
.79401 .53689 m .83232 .52945 L .83801 .59195 L p F P
0 g
s
.248 .36 .716 r
.70485 .36748 m .74226 .35825 L .76502 .41479 L p F P
0 g
s
.258 .377 .748 r
.74226 .35825 m .70485 .36748 L .67712 .31706 L p F P
0 g
s
.258 .377 .748 r
.64031 .32673 m .67712 .31706 L .70485 .36748 L p F P
0 g
s
.528 .175 .077 r
.59198 .9013 m .56756 .8962 L .62031 .90439 L p F P
0 g
s
.528 .175 .077 r
.62031 .90439 m .64435 .90945 L .59198 .9013 L p F P
0 g
s
.901 .274 .119 r
.69407 .29831 m .67109 .2843 L .61825 .28647 L p F P
0 g
s
.901 .274 .119 r
.59421 .27232 m .61825 .28647 L .67109 .2843 L p F P
0 g
s
.238 .343 .685 r
.76502 .41479 m .80314 .40605 L .82058 .46686 L p F P
0 g
s
.248 .36 .716 r
.80314 .40605 m .76502 .41479 L .74226 .35825 L p F P
0 g
s
.268 .395 .782 r
.67712 .31706 m .64031 .32673 L .60813 .28425 L p F P
0 g
s
.268 .395 .782 r
.57182 .29432 m .60813 .28425 L .64031 .32673 L p F P
0 g
s
1 .309 .13 r
.46618 .29965 m .43989 .28569 L .39353 .323 L p F P
0 g
s
.967 .27 .111 r
.27094 .60029 m .24177 .59075 L .24462 .65176 L p F P
0 g
s
.967 .27 .111 r
.24462 .65176 m .27403 .66049 L .27094 .60029 L p F P
0 g
s
.851 .265 .114 r
.6677 .91436 m .64435 .90945 L .69943 .90414 L p F P
0 g
s
.851 .265 .114 r
.69943 .90414 m .72233 .90921 L .6677 .91436 L p F P
0 g
s
.699 .221 .098 r
.76699 .32284 m .74504 .30916 L .69407 .29831 L p F P
0 g
s
.699 .221 .098 r
.67109 .2843 m .69407 .29831 L .74504 .30916 L p F P
0 g
s
.096 .115 .238 r
.53548 .86101 m .49928 .86513 L .52952 .83457 L p F P
0 g
s
.096 .115 .238 r
.52952 .83457 m .56523 .83023 L .53548 .86101 L p F P
0 g
s
.191 .265 .533 r
.79076 .71479 m .75214 .72042 L .76024 .66486 L p F P
0 g
s
.191 .265 .533 r
.76024 .66486 m .7984 .65873 L .79076 .71479 L p F P
0 g
s
.142 .187 .38 r
.63897 .82126 m .60171 .82579 L .62472 .78505 L p F P
0 g
s
.142 .187 .38 r
.62472 .78505 m .66146 .78018 L .63897 .82126 L p F P
0 g
s
.205 .289 .58 r
.83737 .65247 m .7984 .65873 L .79943 .59878 L p F P
0 g
s
.205 .289 .58 r
.79943 .59878 m .83801 .59195 L .83737 .65247 L p F P
0 g
s
.06 .071 .137 r
.4277 .88816 m .39259 .89199 L .42915 .8731 L p F P
0 g
s
.06 .071 .137 r
.42915 .8731 m .46385 .86915 L .4277 .88816 L p F P
0 g
s
1 .309 .13 r
.36606 .30933 m .39353 .323 L .43989 .28569 L p F P
0 g
s
1 .308 .129 r
.39353 .323 m .36606 .30933 L .32516 .35588 L p F P
0 g
s
.444 .142 .066 r
.83483 .35969 m .81383 .34653 L .76699 .32284 L p F P
0 g
s
.444 .142 .066 r
.74504 .30916 m .76699 .32284 L .81383 .34653 L p F P
0 g
s
.024 .035 .067 r
.31709 .90182 m .28309 .90551 L .32456 .89941 L p F P
0 g
s
.024 .035 .067 r
.32456 .89941 m .35821 .89574 L .31709 .90182 L p F P
0 g
s
.288 .441 .86 r
.3913 .27146 m .3573 .28165 L .31659 .27353 L p F P
0 g
s
.288 .441 .86 r
.28296 .28382 m .31659 .27353 L .3573 .28165 L p F P
0 g
s
1 .299 .125 r
.23624 .45586 m .26566 .46741 L .29135 .40919 L p F P
0 g
s
1 .292 .121 r
.26566 .46741 m .23624 .45586 L .21918 .51792 L p F P
0 g
s
1 .292 .121 r
.21918 .51792 m .24892 .5286 L .26566 .46741 L p F P
0 g
s
.997 .297 .127 r
.59421 .27232 m .56945 .25775 L .5165 .27301 L p F P
0 g
s
.997 .297 .127 r
.4906 .25846 m .5165 .27301 L .56945 .25775 L p F P
0 g
s
.279 .414 .818 r
.60813 .28425 m .57182 .29432 L .53595 .26152 L p F P
0 g
s
.279 .414 .818 r
.50008 .27191 m .50963 .26915 L p .50806 .2744 L F P
0 g
s
.288 .434 .852 r
.53595 .26152 m .50008 .27191 L .4615 .25042 L p F P
0 g
s
.288 .434 .852 r
.42603 .26106 m .4615 .25042 L .50008 .27191 L p F P
0 g
s
1 .307 .13 r
.4906 .25846 m .43989 .28569 L p .50806 .2744 L F P
0 g
s
1 .307 .13 r
.5165 .27301 m .50963 .26915 L p .50806 .2744 L F P
0 g
s
1 .307 .13 r
.50963 .26915 m .4906 .25846 L p .50806 .2744 L F P
0 g
s
.279 .414 .818 r
.53595 .26152 m .57182 .29432 L p .50806 .2744 L F P
0 g
s
.279 .414 .818 r
.50963 .26915 m .53595 .26152 L p .50806 .2744 L F P
0 g
s
.171 .233 .471 r
.73732 .77013 m .69899 .77521 L .71432 .72593 L p F P
0 g
s
.171 .233 .471 r
.71432 .72593 m .75214 .72042 L .73732 .77013 L p F P
0 g
s
.246 .389 .747 r
.28296 .28382 m .25004 .2939 L .20917 .29938 L p F P
0 g
s
.246 .389 .747 r
.17662 .30941 m .20917 .29938 L .25004 .2939 L p F P
0 g
s
.228 .327 .653 r
.87144 .52185 m .83232 .52945 L .82058 .46686 L p F P
0 g
s
.228 .327 .653 r
.82058 .46686 m .85954 .45861 L .87144 .52185 L p F P
0 g
s
.238 .343 .685 r
.85954 .45861 m .82058 .46686 L .80314 .40605 L p F P
0 g
s
1 .305 .127 r
.26229 .39676 m .29135 .40919 L .32516 .35588 L p F P
0 g
s
1 .299 .125 r
.29135 .40919 m .26229 .39676 L .23624 .45586 L p F P
0 g
s
.411 .095 .039 r
.89539 .40784 m .87526 .39538 L .83483 .35969 L p F P
0 g
s
.238 .343 .685 r
.84207 .39712 m .86834 .39109 L p .89933 .45019 L F P
0 g
s
.411 .095 .039 r
.83483 .35969 m .87526 .39538 L p .81964 .35114 L F P
0 g
s
.643 .166 .063 r
.87526 .39538 m .89539 .40784 L .92728 .454 L p F P
0 g
s
.411 .095 .039 r
.87526 .39538 m .86834 .39109 L p .81383 .34653 L F P
0 g
s
.411 .095 .039 r
.82682 .35802 m .81383 .34653 L p .86834 .39109 L F P
0 g
s
.411 .095 .039 r
.81458 .347 m .83483 .35969 L p .81964 .35114 L F P
0 g
s
.248 .36 .716 r
.88183 .388 m .86834 .39109 L p .81948 .33922 L F P
0 g
s
.248 .36 .716 r
.86834 .39109 m .84207 .39712 L .82682 .35802 L p F P
0 g
s
.248 .36 .716 r
.82682 .35802 m .81948 .33922 L p .86834 .39109 L F P
0 g
s
.444 .142 .066 r
.81383 .34653 m .80706 .34228 L p .74504 .30916 L F P
0 g
s
.258 .377 .748 r
.81948 .33922 m .80706 .34228 L p .75312 .2971 L F P
0 g
s
.444 .142 .066 r
.76476 .31911 m .75047 .3119 L p .80706 .34228 L F P
0 g
s
.444 .142 .066 r
.75047 .3119 m .74504 .30916 L p .80706 .34228 L F P
0 g
s
.258 .377 .748 r
.80706 .34228 m .78046 .34884 L .76476 .31911 L p F P
0 g
s
.258 .377 .748 r
.76476 .31911 m .75312 .2971 L p .80706 .34228 L F P
0 g
s
.444 .142 .066 r
.80706 .34228 m .7922 .33297 L .76476 .31911 L p F P
0 g
s
.248 .36 .716 r
.80706 .34228 m .81948 .33922 L .82429 .35153 L p F P
0 g
s
.411 .095 .039 r
.80706 .34228 m .81383 .34653 L .82682 .35802 L p F P
0 g
s
.411 .095 .039 r
.81383 .34653 m .81458 .347 L p .81964 .35114 L F P
0 g
s
.248 .36 .716 r
.82429 .35153 m .82682 .35802 L p .80706 .34228 L F P
0 g
s
.248 .36 .716 r
.78046 .34884 m .80706 .34228 L p .84207 .39712 L F P
0 g
s
.248 .36 .716 r
.82682 .35802 m .84207 .39712 L p .80706 .34228 L F P
0 g
s
.411 .095 .039 r
.7922 .33297 m .80706 .34228 L p .85452 .38253 L F P
0 g
s
.411 .095 .039 r
.82682 .35802 m .85452 .38253 L p .80706 .34228 L F P
0 g
s
.411 .095 .039 r
.86834 .39109 m .85452 .38253 L .82682 .35802 L p F P
0 g
s
.643 .166 .063 r
.92728 .454 m .91528 .44681 L p .87526 .39538 L F P
0 g
s
.643 .166 .063 r
.8899 .41669 m .87526 .39538 L p .91528 .44681 L F P
0 g
s
.238 .343 .685 r
.93999 .44158 m .91528 .44681 L p .88183 .388 L F P
0 g
s
.238 .343 .685 r
.91528 .44681 m .89933 .45019 L .8899 .41669 L p F P
0 g
s
.238 .343 .685 r
.8899 .41669 m .89933 .45019 L p .86834 .39109 L F P
0 g
s
.643 .166 .063 r
.85452 .38253 m .86834 .39109 L p .90733 .44204 L F P
0 g
s
.643 .166 .063 r
.86834 .39109 m .87526 .39538 L .8899 .41669 L p F P
0 g
s
.643 .166 .063 r
.8899 .41669 m .90733 .44204 L p .86834 .39109 L F P
0 g
s
.238 .343 .685 r
.8899 .41669 m .88255 .39057 L p .91528 .44681 L F P
0 g
s
.238 .343 .685 r
.88255 .39057 m .88183 .388 L p .91528 .44681 L F P
0 g
s
.228 .327 .653 r
.9114 .51409 m .89933 .45019 L p .93733 .4904 L F P
0 g
s
.848 .229 .091 r
.93733 .4904 m .91528 .44681 L .93768 .48828 L F
.94149 .4971 m .93768 .48828 L .94893 .50909 L F
.93733 .4904 m .93768 .48828 L .94149 .4971 L F
.218 .309 .619 r
.9114 .51409 m .94592 .50739 L p .9588 .57057 L F P
0 g
s
.848 .229 .091 r
.94353 .49536 m .94893 .50909 L p .91528 .44681 L F P
0 g
s
.228 .327 .653 r
.94592 .50739 m .9114 .51409 L p .93733 .4904 L F P
0 g
s
.963 .267 .107 r
.92905 .49782 m .94893 .50909 L .9588 .57057 L p F P
0 g
s
.228 .327 .653 r
.89933 .45019 m .91528 .44681 L p .93733 .4904 L F P
0 g
s
.848 .229 .091 r
.92905 .49782 m .90733 .44204 L p .93733 .4904 L F P
0 g
s
.848 .229 .091 r
.94893 .50909 m .94592 .50739 L p .93733 .4904 L F P
0 g
s
.848 .229 .091 r
.94592 .50739 m .92905 .49782 L p .93733 .4904 L F P
0 g
s
.848 .229 .091 r
.91528 .44681 m .92728 .454 L .94353 .49536 L p F P
0 g
s
.228 .327 .653 r
.93999 .44158 m .95223 .50617 L p .93733 .4904 L F P
0 g
s
.228 .327 .653 r
.91528 .44681 m .93999 .44158 L p .93733 .4904 L F P
0 g
s
.218 .309 .619 r
.94592 .50739 m .95223 .50617 L .95434 .52692 L p F P
0 g
s
.218 .309 .619 r
.95434 .52692 m .9588 .57057 L p .94592 .50739 L F P
0 g
s
.228 .327 .653 r
.95223 .50617 m .94592 .50739 L p .93733 .4904 L F P
0 g
s
.848 .229 .091 r
.90733 .44204 m .91528 .44681 L p .93733 .4904 L F P
0 g
s
.643 .166 .063 r
.91528 .44681 m .90733 .44204 L .8899 .41669 L p F P
0 g
s
.238 .343 .685 r
.88701 .40641 m .8899 .41669 L p .86834 .39109 L F P
0 g
s
.238 .343 .685 r
.86834 .39109 m .88183 .388 L .88701 .40641 L p F P
0 g
s
.703 .185 .074 r
.36725 .78286 m .3393 .77596 L .37211 .81914 L p F P
0 g
s
.703 .185 .074 r
.37211 .81914 m .40003 .82551 L .36725 .78286 L p F P
0 g
s
.833 .226 .091 r
.31597 .72517 m .28726 .71742 L .31051 .76886 L p F P
0 g
s
.833 .226 .091 r
.31051 .76886 m .3393 .77596 L .31597 .72517 L p F P
0 g
s
.218 .309 .619 r
.87742 .58497 m .83801 .59195 L .83232 .52945 L p F P
0 g
s
.218 .309 .619 r
.83232 .52945 m .87144 .52185 L .87742 .58497 L p F P
0 g
s
.248 .36 .716 r
.74226 .35825 m .78046 .34884 L .80314 .40605 L p F P
0 g
s
.258 .377 .748 r
.78046 .34884 m .74226 .35825 L .71472 .30719 L p F P
0 g
s
.258 .377 .748 r
.67712 .31706 m .71472 .30719 L .74226 .35825 L p F P
0 g
s
1 .283 .117 r
.24892 .5286 m .21918 .51792 L .21172 .58093 L p F P
0 g
s
1 .283 .117 r
.21172 .58093 m .24177 .59075 L .24892 .5286 L p F P
0 g
s
.498 .121 .047 r
.42714 .83168 m .40003 .82551 L .44133 .85852 L p F P
0 g
s
.498 .121 .047 r
.44133 .85852 m .46829 .86432 L .42714 .83168 L p F P
0 g
s
.914 .252 .103 r
.27403 .66049 m .24462 .65176 L .25768 .70944 L p F P
0 g
s
.914 .252 .103 r
.25768 .70944 m .28726 .71742 L .27403 .66049 L p F P
0 g
s
.238 .343 .685 r
.80314 .40605 m .84207 .39712 L .85954 .45861 L p F P
0 g
s
.248 .36 .716 r
.84207 .39712 m .80314 .40605 L .78046 .34884 L p F P
0 g
s
.901 .274 .119 r
.67109 .2843 m .65134 .27226 L p .59421 .27232 L F P
0 g
s
.901 .274 .119 r
.64128 .27017 m .59421 .27232 L p .65134 .27226 L F P
0 g
s
.279 .414 .818 r
.6831 .26346 m .65134 .27226 L p .61003 .24004 L F P
0 g
s
.279 .414 .818 r
.65134 .27226 m .64522 .27396 L .64128 .27017 L p F P
0 g
s
.279 .414 .818 r
.63695 .26599 m .61003 .24004 L p .65134 .27226 L F P
0 g
s
.268 .395 .782 r
.75312 .2971 m .73382 .30217 L p .6831 .26346 L F P
0 g
s
.699 .221 .098 r
.74504 .30916 m .73382 .30217 L p .67109 .2843 L F P
0 g
s
.268 .395 .782 r
.70302 .291 m .69555 .28067 L p .73382 .30217 L F P
0 g
s
.268 .395 .782 r
.69555 .28067 m .6831 .26346 L p .73382 .30217 L F P
0 g
s
.258 .377 .748 r
.73382 .30217 m .75312 .2971 L .76027 .31062 L p F P
0 g
s
.444 .142 .066 r
.73382 .30217 m .74504 .30916 L .75709 .31524 L p F P
0 g
s
.258 .377 .748 r
.76027 .31062 m .76476 .31911 L p .73382 .30217 L F P
0 g
s
.444 .142 .066 r
.75709 .31524 m .76476 .31911 L p .73382 .30217 L F P
0 g
s
.258 .377 .748 r
.76476 .31911 m .78046 .34884 L p .73382 .30217 L F P
0 g
s
.444 .142 .066 r
.76476 .31911 m .7922 .33297 L p .73382 .30217 L F P
0 g
s
.444 .142 .066 r
.72243 .29507 m .73382 .30217 L p .7922 .33297 L F P
0 g
s
.699 .221 .098 r
.69088 .28846 m .67109 .2843 L p .73382 .30217 L F P
0 g
s
.699 .221 .098 r
.65134 .27226 m .67109 .2843 L .68625 .28748 L p F P
0 g
s
.268 .395 .782 r
.64522 .27396 m .65134 .27226 L p .71472 .30719 L F P
0 g
s
.268 .395 .782 r
.65134 .27226 m .6831 .26346 L .70302 .291 L p F P
0 g
s
.699 .221 .098 r
.70302 .291 m .69088 .28846 L p .73382 .30217 L F P
0 g
s
.699 .221 .098 r
.68625 .28748 m .70302 .291 L p .65134 .27226 L F P
0 g
s
.268 .395 .782 r
.70302 .291 m .71472 .30719 L p .65134 .27226 L F P
0 g
s
.699 .221 .098 r
.73382 .30217 m .72243 .29507 L .70302 .291 L p F P
0 g
s
.258 .377 .748 r
.71472 .30719 m .73382 .30217 L p .78046 .34884 L F P
0 g
s
.268 .395 .782 r
.73382 .30217 m .71472 .30719 L .70302 .291 L p F P
0 g
s
.699 .221 .098 r
.70302 .291 m .72243 .29507 L p .65134 .27226 L F P
0 g
s
.699 .221 .098 r
.64744 .26988 m .65134 .27226 L p .72243 .29507 L F P
0 g
s
.279 .414 .818 r
.64128 .27017 m .63695 .26599 L p .65134 .27226 L F P
0 g
s
.901 .274 .119 r
.56945 .25775 m .59421 .27232 L .64128 .27017 L p F P
0 g
s
.901 .274 .119 r
.56945 .25775 m .64128 .27017 L .61791 .26529 L F
.279 .414 .818 r
.57259 .25089 m .61003 .24004 L .64128 .27017 L p F P
0 g
s
.279 .414 .818 r
.64128 .27017 m .64522 .27396 L p .61791 .26529 L F P
0 g
s
.279 .414 .818 r
.57259 .25089 m .64128 .27017 L .61791 .26529 L F
.57936 .25725 m .57259 .25089 L p .61791 .26529 L F P
0 g
s
.901 .274 .119 r
.64744 .26988 m .62306 .25502 L .57936 .25725 L p F P
0 g
s
.901 .274 .119 r
.57936 .25725 m .56945 .25775 L p .61791 .26529 L F P
0 g
s
.901 .274 .119 r
.61791 .26529 m .64744 .26988 L .57936 .25725 L F
.64128 .27017 m .64744 .26988 L p .61791 .26529 L F P
0 g
s
.901 .274 .119 r
.65134 .27226 m .64744 .26988 L .64128 .27017 L p F P
0 g
s
.279 .414 .818 r
.64522 .27396 m .60813 .28425 L .57936 .25725 L p F P
0 g
s
.279 .414 .818 r
.61791 .26529 m .64522 .27396 L .57936 .25725 L F
.268 .395 .782 r
.71472 .30719 m .67712 .31706 L .64522 .27396 L p F P
0 g
s
.268 .395 .782 r
.60813 .28425 m .64522 .27396 L .67712 .31706 L p F P
0 g
s
1 .308 .129 r
.29647 .3426 m .32516 .35588 L .36606 .30933 L p F P
0 g
s
1 .305 .127 r
.32516 .35588 m .29647 .3426 L .26229 .39676 L p F P
0 g
s
.309 .07 .029 r
.51651 .88555 m .54242 .89096 L .49446 .86994 L p F P
0 g
s
.096 .115 .238 r
.57246 .85681 m .53548 .86101 L .56523 .83023 L p F P
0 g
s
.096 .115 .238 r
.56523 .83023 m .60171 .82579 L .57246 .85681 L p F P
0 g
s
.191 .265 .533 r
.83022 .70905 m .79076 .71479 L .7984 .65873 L p F P
0 g
s
.191 .265 .533 r
.7984 .65873 m .83737 .65247 L .83022 .70905 L p F P
0 g
s
.142 .187 .38 r
.67704 .81663 m .63897 .82126 L .66146 .78018 L p F P
0 g
s
.142 .187 .38 r
.66146 .78018 m .69899 .77521 L .67704 .81663 L p F P
0 g
s
.205 .289 .58 r
.87718 .64607 m .83737 .65247 L .83801 .59195 L p F P
0 g
s
.205 .289 .58 r
.83801 .59195 m .87742 .58497 L .87718 .64607 L p F P
0 g
s
.06 .071 .137 r
.46358 .88424 m .4277 .88816 L .46385 .86915 L p F P
0 g
s
.528 .175 .077 r
.56756 .8962 m .54242 .89096 L .59553 .89917 L p F P
0 g
s
.528 .175 .077 r
.59553 .89917 m .62031 .90439 L .56756 .8962 L p F P
0 g
s
1 .307 .13 r
.4128 .27131 m .43989 .28569 L .4906 .25846 L p F P
0 g
s
1 .309 .13 r
.43989 .28569 m .4128 .27131 L .36606 .30933 L p F P
0 g
s
.967 .27 .111 r
.24177 .59075 m .21172 .58093 L .21433 .64276 L p F P
0 g
s
.967 .27 .111 r
.21433 .64276 m .24462 .65176 L .24177 .59075 L p F P
0 g
s
.024 .035 .067 r
.35182 .89805 m .31709 .90182 L .35821 .89574 L p F P
0 g
s
.024 .035 .067 r
.35821 .89574 m .39259 .89199 L .35182 .89805 L p F P
0 g
s
.288 .441 .86 r
.42603 .26106 m .3913 .27146 L .35094 .26301 L p F P
0 g
s
.288 .441 .86 r
.31659 .27353 m .35094 .26301 L .3913 .27146 L p F P
0 g
s
.851 .265 .114 r
.64435 .90945 m .62031 .90439 L .67584 .89892 L p F P
0 g
s
.851 .265 .114 r
.67584 .89892 m .69943 .90414 L .64435 .90945 L p F P
0 g
s
.997 .297 .127 r
.56945 .25775 m .54394 .24274 L .4906 .25846 L p F P
0 g
s
.279 .414 .818 r
.56268 .25377 m .57259 .25089 L .57936 .25725 L p F P
0 g
s
.288 .434 .852 r
.57259 .25089 m .53595 .26152 L .49775 .23956 L p F P
0 g
s
.288 .434 .852 r
.61003 .24004 m .57259 .25089 L .5348 .22846 L p F P
0 g
s
.288 .434 .852 r
.49775 .23956 m .5348 .22846 L .57259 .25089 L p F P
0 g
s
.901 .274 .119 r
.54394 .24274 m .56268 .25377 L p .62306 .25502 L F P
0 g
s
.901 .274 .119 r
.56268 .25377 m .56945 .25775 L .57936 .25725 L p F P
0 g
s
.901 .274 .119 r
.57936 .25725 m .62306 .25502 L p .56268 .25377 L F P
0 g
s
.279 .414 .818 r
.53595 .26152 m .56268 .25377 L p .60813 .28425 L F P
0 g
s
.279 .414 .818 r
.57936 .25725 m .60813 .28425 L p .56268 .25377 L F P
0 g
s
.171 .233 .471 r
.77649 .76494 m .73732 .77013 L .75214 .72042 L p F P
0 g
s
.171 .233 .471 r
.75214 .72042 m .79076 .71479 L .77649 .76494 L p F P
0 g
s
1 .31 .131 r
.72233 .90921 m .69943 .90414 L .7546 .88501 L p F P
0 g
s
1 .31 .131 r
.7546 .88501 m .77699 .89044 L .72233 .90921 L p F P
0 g
s
.246 .389 .747 r
.31659 .27353 m .28296 .28382 L .24243 .28912 L p F P
0 g
s
.246 .389 .747 r
.20917 .29938 m .24243 .28912 L .28296 .28382 L p F P
0 g
s
.228 .327 .653 r
.9114 .51409 m .87144 .52185 L .85954 .45861 L p F P
0 g
s
.228 .327 .653 r
.85954 .45861 m .89933 .45019 L .9114 .51409 L p F P
0 g
s
.238 .343 .685 r
.89933 .45019 m .85954 .45861 L .84207 .39712 L p F P
0 g
s
.218 .309 .619 r
.91767 .57785 m .87742 .58497 L .87144 .52185 L p F P
0 g
s
.218 .309 .619 r
.87144 .52185 m .9114 .51409 L .91767 .57785 L p F P
0 g
s
.024 .035 .067 r
.20917 .29938 m .17662 .30941 L .13784 .32857 L p F P
0 g
s
1 .309 .13 r
.33776 .29525 m .36606 .30933 L .4128 .27131 L p F P
0 g
s
1 .308 .129 r
.36606 .30933 m .33776 .29525 L .29647 .3426 L p F P
0 g
s
1 .299 .125 r
.20595 .44395 m .23624 .45586 L .26229 .39676 L p F P
0 g
s
1 .292 .121 r
.23624 .45586 m .20595 .44395 L .18853 .50692 L p F P
0 g
s
1 .292 .121 r
.18853 .50692 m .21918 .51792 L .23624 .45586 L p F P
0 g
s
1 .305 .127 r
.23236 .38396 m .26229 .39676 L .29647 .3426 L p F P
0 g
s
1 .299 .125 r
.26229 .39676 m .23236 .38396 L .20595 .44395 L p F P
0 g
s
.703 .185 .074 r
.3393 .77596 m .31051 .76886 L .34334 .81258 L p F P
0 g
s
.703 .185 .074 r
.34334 .81258 m .37211 .81914 L .3393 .77596 L p F P
0 g
s
.833 .226 .091 r
.28726 .71742 m .25768 .70944 L .28084 .76154 L p F P
0 g
s
.833 .226 .091 r
.28084 .76154 m .31051 .76886 L .28726 .71742 L p F P
0 g
s
.096 .115 .238 r
.61026 .85252 m .57246 .85681 L .60171 .82579 L p F P
0 g
s
.096 .115 .238 r
.60171 .82579 m .63897 .82126 L .61026 .85252 L p F P
0 g
s
.191 .265 .533 r
.87054 .70317 m .83022 .70905 L .83737 .65247 L p F P
0 g
s
.191 .265 .533 r
.83737 .65247 m .87718 .64607 L .87054 .70317 L p F P
0 g
s
1 .283 .117 r
.21918 .51792 m .18853 .50692 L .18077 .57082 L p F P
0 g
s
1 .283 .117 r
.18077 .57082 m .21172 .58093 L .21918 .51792 L p F P
0 g
s
.498 .121 .047 r
.40003 .82551 m .37211 .81914 L .41354 .85255 L p F P
0 g
s
.498 .121 .047 r
.41354 .85255 m .44133 .85852 L .40003 .82551 L p F P
0 g
s
.142 .187 .38 r
.71594 .8119 m .67704 .81663 L .69899 .77521 L p F P
0 g
s
.142 .187 .38 r
.69899 .77521 m .73732 .77013 L .71594 .8119 L p F P
0 g
s
.205 .289 .58 r
.91785 .63953 m .87718 .64607 L .87742 .58497 L p F P
0 g
s
.205 .289 .58 r
.87742 .58497 m .91767 .57785 L .91785 .63953 L p F P
0 g
s
.06 .071 .137 r
.49421 .8809 m .46358 .88424 L .47443 .87843 L p F P
0 g
s
.06 .071 .137 r
.47443 .87843 m .48612 .87217 L p .49421 .8809 L F P
0 g
s
.309 .07 .029 r
.49421 .8809 m .51651 .88555 L .50192 .87913 L p F P
0 g
s
.309 .07 .029 r
.50192 .87913 m .48612 .87217 L p .49421 .8809 L F P
0 g
s
.024 .035 .067 r
.46358 .88424 m .49421 .8809 L p .46072 .88622 L F P
0 g
s
.528 .175 .077 r
.51651 .88555 m .49421 .8809 L p .54364 .88826 L F P
0 g
s
.024 .035 .067 r
.49421 .8809 m .50025 .88024 L .49584 .88091 L p F P
0 g
s
.309 .07 .029 r
.4898 .87998 m .49421 .8809 L p .46829 .86432 L F P
0 g
s
.309 .07 .029 r
.48612 .87217 m .46829 .86432 L p .49421 .8809 L F P
0 g
s
.06 .071 .137 r
.50025 .88024 m .49421 .8809 L p .49928 .86513 L F P
0 g
s
.06 .071 .137 r
.48612 .87217 m .49928 .86513 L p .49421 .8809 L F P
0 g
s
.528 .175 .077 r
.49421 .8809 m .4898 .87998 L .49584 .88091 L p F P
0 g
s
.528 .175 .077 r
.49584 .88091 m .50248 .88193 L p .49421 .8809 L F P
0 g
s
.528 .175 .077 r
.50248 .88193 m .54364 .88826 L p .49421 .8809 L F P
0 g
s
.024 .035 .067 r
.49584 .88091 m .49099 .88164 L p .49421 .8809 L F P
0 g
s
.024 .035 .067 r
.49099 .88164 m .46072 .88622 L p .49421 .8809 L F P
0 g
s
.06 .071 .137 r
.49928 .86513 m .53548 .86101 L .50025 .88024 L p F P
0 g
s
.914 .252 .103 r
.24462 .65176 m .21433 .64276 L .22719 .70121 L p F P
0 g
s
.914 .252 .103 r
.22719 .70121 m .25768 .70944 L .24462 .65176 L p F P
0 g
s
.288 .434 .852 r
.4615 .25042 m .49775 .23956 L .53595 .26152 L p F P
0 g
s
1 .308 .129 r
.26693 .32892 m .29647 .3426 L .33776 .29525 L p F P
0 g
s
1 .305 .127 r
.29647 .3426 m .26693 .32892 L .23236 .38396 L p F P
0 g
s
.024 .035 .067 r
.38732 .89419 m .35182 .89805 L .39259 .89199 L p F P
0 g
s
.024 .035 .067 r
.39259 .89199 m .4277 .88816 L .38732 .89419 L p F P
0 g
s
1 .307 .13 r
.4906 .25846 m .47115 .24753 L p .4128 .27131 L F P
0 g
s
1 .307 .13 r
.47115 .24753 m .46391 .24347 L .45423 .24874 L p F P
0 g
s
.288 .441 .86 r
.4615 .25042 m .42603 .26106 L .3907 .25329 L p F P
0 g
s
.288 .441 .86 r
.4148 .25156 m .4615 .25042 L .3907 .25329 L F
1 .307 .13 r
.45423 .24874 m .46391 .24347 L p .4148 .25156 L F P
0 g
s
1 .307 .13 r
.46391 .24347 m .4364 .22801 L .3907 .25329 L p F P
0 g
s
.288 .441 .86 r
.35094 .26301 m .38027 .25404 L p .42603 .26106 L F P
0 g
s
.288 .441 .86 r
.3907 .25329 m .42603 .26106 L p .38027 .25404 L F P
0 g
s
1 .307 .13 r
.3907 .25329 m .3849 .25649 L p .4148 .25156 L F P
0 g
s
1 .307 .13 r
.4148 .25156 m .46391 .24347 L .3907 .25329 L F
.35614 .24122 m .38027 .25404 L p .4364 .22801 L F P
0 g
s
1 .307 .13 r
.38027 .25404 m .3849 .25649 L .39706 .24977 L p F P
0 g
s
1 .307 .13 r
.39706 .24977 m .4364 .22801 L p .38027 .25404 L F P
0 g
s
.246 .389 .747 r
.38027 .25404 m .35094 .26301 L .33925 .26446 L p F P
0 g
s
1 .309 .13 r
.3849 .25649 m .38027 .25404 L p .3086 .28074 L F P
0 g
s
1 .309 .13 r
.38027 .25404 m .35614 .24122 L .32626 .26606 L p F P
0 g
s
.246 .389 .747 r
.33925 .26446 m .32626 .26606 L p .38027 .25404 L F P
0 g
s
.246 .389 .747 r
.35094 .26301 m .31659 .27353 L .27642 .27864 L p F P
0 g
s
.246 .389 .747 r
.27642 .27864 m .29369 .27332 L p .35094 .26301 L F P
0 g
s
1 .309 .13 r
.32626 .26606 m .33749 .25673 L p .29369 .27332 L F P
0 g
s
1 .309 .13 r
.33749 .25673 m .35614 .24122 L p .29369 .27332 L F P
0 g
s
.246 .389 .747 r
.29369 .27332 m .31115 .26793 L .32626 .26606 L p F P
0 g
s
.246 .389 .747 r
.32626 .26606 m .35094 .26301 L p .29369 .27332 L F P
0 g
s
.246 .389 .747 r
.24243 .28912 m .27642 .27864 L .31659 .27353 L p F P
0 g
s
1 .309 .13 r
.29369 .27332 m .3086 .28074 L .32626 .26606 L p F P
0 g
s
.024 .035 .067 r
.29369 .27332 m .27642 .27864 L .26681 .28349 L p F P
0 g
s
1 .308 .129 r
.3086 .28074 m .29369 .27332 L p .23647 .31482 L F P
0 g
s
.024 .035 .067 r
.26681 .28349 m .26069 .28659 L p .29369 .27332 L F P
0 g
s
.024 .035 .067 r
.27642 .27864 m .24243 .28912 L .20432 .30823 L p F P
0 g
s
.024 .035 .067 r
.20432 .30823 m .21509 .30493 L p .27642 .27864 L F P
0 g
s
1 .308 .129 r
.21509 .30493 m .23647 .31482 L .26069 .28659 L p F P
0 g
s
.024 .035 .067 r
.21509 .30493 m .23867 .29772 L .26069 .28659 L p F P
0 g
s
.024 .035 .067 r
.26069 .28659 m .27642 .27864 L p .21509 .30493 L F P
0 g
s
.024 .035 .067 r
.24243 .28912 m .20917 .29938 L .17071 .31851 L p F P
0 g
s
.024 .035 .067 r
.13784 .32857 m .17071 .31851 L .20917 .29938 L p F P
0 g
s
.024 .035 .067 r
.17071 .31851 m .20432 .30823 L .24243 .28912 L p F P
0 g
s
1 .308 .129 r
.20506 .30029 m .21509 .30493 L p .27854 .26578 L F P
0 g
s
1 .308 .129 r
.26069 .28659 m .27854 .26578 L p .21509 .30493 L F P
0 g
s
1 .308 .129 r
.29369 .27332 m .27854 .26578 L .26069 .28659 L p F P
0 g
s
1 .308 .129 r
.26069 .28659 m .23647 .31482 L p .29369 .27332 L F P
0 g
s
.024 .035 .067 r
.26069 .28659 m .23867 .29772 L p .29369 .27332 L F P
0 g
s
.024 .035 .067 r
.31115 .26793 m .29369 .27332 L p .23867 .29772 L F P
0 g
s
1 .309 .13 r
.27854 .26578 m .29369 .27332 L p .35614 .24122 L F P
0 g
s
1 .309 .13 r
.32626 .26606 m .3086 .28074 L p .38027 .25404 L F P
0 g
s
.246 .389 .747 r
.32626 .26606 m .31115 .26793 L p .38027 .25404 L F P
0 g
s
.246 .389 .747 r
.38605 .25227 m .38027 .25404 L p .31115 .26793 L F P
0 g
s
.288 .441 .86 r
.38027 .25404 m .38605 .25227 L .3907 .25329 L p F P
0 g
s
.288 .441 .86 r
.38605 .25227 m .42193 .24128 L .45423 .24874 L p F P
0 g
s
.288 .441 .86 r
.45423 .24874 m .4615 .25042 L p .4148 .25156 L F P
0 g
s
.288 .441 .86 r
.38605 .25227 m .45423 .24874 L .4148 .25156 L F
1 .307 .13 r
.3849 .25649 m .4128 .27131 L .45423 .24874 L p F P
0 g
s
1 .307 .13 r
.3849 .25649 m .45423 .24874 L .4148 .25156 L F
.45423 .24874 m .4128 .27131 L p .47115 .24753 L F P
0 g
s
.288 .441 .86 r
.3907 .25329 m .38605 .25227 L p .4148 .25156 L F P
0 g
s
.309 .07 .029 r
.46829 .86432 m .44133 .85852 L .4898 .87998 L p F P
0 g
s
.171 .233 .471 r
.81651 .75964 m .77649 .76494 L .79076 .71479 L p F P
0 g
s
.171 .233 .471 r
.79076 .71479 m .83022 .70905 L .81651 .75964 L p F P
0 g
s
.246 .387 .762 r
.27345 .89402 m .23917 .89788 L .28309 .90551 L p F P
0 g
s
.246 .387 .762 r
.28309 .90551 m .31709 .90182 L .27345 .89402 L p F P
0 g
s
.997 .297 .127 r
.46391 .24347 m .4906 .25846 L .54394 .24274 L p F P
0 g
s
.218 .309 .619 r
.9588 .57057 m .91767 .57785 L .9114 .51409 L p F P
0 g
s
.528 .175 .077 r
.54242 .89096 m .51651 .88555 L .56998 .8938 L p F P
0 g
s
.528 .175 .077 r
.56998 .8938 m .59553 .89917 L .54242 .89096 L p F P
0 g
s
.248 .36 .716 r
.81948 .33922 m .85935 .32939 L .88183 .388 L p F P
0 g
s
.258 .377 .748 r
.85935 .32939 m .81948 .33922 L .79236 .2868 L p F P
0 g
s
.258 .377 .748 r
.75312 .2971 m .79236 .2868 L .81948 .33922 L p F P
0 g
s
1 .309 .13 r
.4128 .27131 m .3849 .25649 L .33776 .29525 L p F P
0 g
s
.967 .27 .111 r
.21172 .58093 m .18077 .57082 L .18311 .63349 L p F P
0 g
s
.967 .27 .111 r
.18311 .63349 m .21433 .64276 L .21172 .58093 L p F P
0 g
s
1 .325 .136 r
.77699 .89044 m .7546 .88501 L .80701 .85248 L p F P
0 g
s
1 .325 .136 r
.80701 .85248 m .82885 .85845 L .77699 .89044 L p F P
0 g
s
.851 .265 .114 r
.62031 .90439 m .59553 .89917 L .65152 .89354 L p F P
0 g
s
.851 .265 .114 r
.65152 .89354 m .67584 .89892 L .62031 .90439 L p F P
0 g
s
.699 .221 .098 r
.72243 .29507 m .69913 .28056 L .64744 .26988 L p F P
0 g
s
.699 .221 .098 r
.62306 .25502 m .64744 .26988 L .69913 .28056 L p F P
0 g
s
1 .31 .131 r
.69943 .90414 m .67584 .89892 L .73152 .87942 L p F P
0 g
s
1 .31 .131 r
.73152 .87942 m .7546 .88501 L .69943 .90414 L p F P
0 g
s
.238 .343 .685 r
.88183 .388 m .92245 .37868 L .93999 .44158 L p F P
0 g
s
.248 .36 .716 r
.92245 .37868 m .88183 .388 L .85935 .32939 L p F P
0 g
s
.268 .395 .782 r
.79236 .2868 m .75312 .2971 L .72181 .25272 L p F P
0 g
s
.268 .395 .782 r
.6831 .26346 m .72181 .25272 L .75312 .2971 L p F P
0 g
s
.096 .115 .238 r
.64889 .84812 m .61026 .85252 L .63897 .82126 L p F P
0 g
s
.096 .115 .238 r
.63897 .82126 m .67704 .81663 L .64889 .84812 L p F P
0 g
s
1 .309 .13 r
.3086 .28074 m .33776 .29525 L .3849 .25649 L p F P
0 g
s
1 .308 .129 r
.33776 .29525 m .3086 .28074 L .26693 .32892 L p F P
0 g
s
.444 .142 .066 r
.7922 .33297 m .7699 .31899 L .72243 .29507 L p F P
0 g
s
.444 .142 .066 r
.69913 .28056 m .72243 .29507 L .7699 .31899 L p F P
0 g
s
.191 .265 .533 r
.91174 .69717 m .87054 .70317 L .87718 .64607 L p F P
0 g
s
.191 .265 .533 r
.87718 .64607 m .91785 .63953 L .91174 .69717 L p F P
0 g
s
.142 .187 .38 r
.75571 .80706 m .71594 .8119 L .73732 .77013 L p F P
0 g
s
.142 .187 .38 r
.73732 .77013 m .77649 .76494 L .75571 .80706 L p F P
0 g
s
1 .305 .125 r
.95222 .65122 m .94054 .69989 L p .93901 .67524 L F P
0 g
s
1 .316 .13 r
.94054 .69989 m .91304 .76073 L p .9185 .70738 L F P
0 g
s
.171 .233 .471 r
.91174 .69717 m .92826 .69476 L p .9185 .70738 L F P
0 g
s
1 .305 .125 r
.93863 .66924 m .95222 .65122 L .93901 .67524 L F
.191 .265 .533 r
.91174 .69717 m .91785 .63953 L p .93863 .66924 L F P
0 g
s
.191 .265 .533 r
.93863 .66924 m .9347 .67891 L .91174 .69717 L F
1 .305 .125 r
.94054 .69989 m .92826 .69476 L p .93863 .66924 L F P
0 g
s
.191 .265 .533 r
.92826 .69476 m .91174 .69717 L p .94158 .67345 L F P
0 g
s
.191 .265 .533 r
.91785 .63953 m .953 .63389 L p .93863 .66924 L F P
0 g
s
.205 .289 .58 r
.91785 .63953 m .91767 .57785 L p .95378 .62542 L F P
0 g
s
.205 .289 .58 r
.953 .63389 m .91785 .63953 L p .95378 .62542 L F P
0 g
s
1 .305 .125 r
.92013 .69136 m .93593 .62582 L p .93863 .66924 L F P
0 g
s
1 .305 .125 r
.92826 .69476 m .92013 .69136 L p .93863 .66924 L F P
0 g
s
.191 .265 .533 r
.93863 .66924 m .94158 .67345 L .9347 .67891 L F
.95387 .69103 m .92826 .69476 L p .94158 .67345 L F P
0 g
s
1 .316 .13 r
.91304 .76073 m .89223 .75316 L .89338 .75061 L p F P
0 g
s
.171 .233 .471 r
.85743 .75421 m .87054 .70317 L p .89354 .73961 L F P
0 g
s
1 .316 .13 r
.90507 .72472 m .91813 .71099 L .90788 .72739 L F
.89338 .75061 m .90046 .73492 L p .90788 .72739 L F P
0 g
s
1 .316 .13 r
.90046 .73492 m .90507 .72472 L p .90788 .72739 L F P
0 g
s
1 .316 .13 r
.91813 .71099 m .91304 .76073 L .89338 .75061 L F
1 .323 .134 r
.87508 .81452 m .85378 .80782 L .89223 .75316 L p F P
0 g
s
1 .323 .134 r
.89223 .75316 m .91304 .76073 L .87508 .81452 L p F P
0 g
s
1 .323 .134 r
.89223 .75316 m .85378 .80782 L p .86499 .76656 L F P
0 g
s
.142 .187 .38 r
.85743 .75421 m .88507 .75055 L p .86499 .76656 L F P
0 g
s
.171 .233 .471 r
.88507 .75055 m .85743 .75421 L p .89354 .73961 L F P
0 g
s
1 .323 .134 r
.87075 .74535 m .88507 .75055 L p .86499 .76656 L F P
0 g
s
1 .323 .134 r
.88507 .75055 m .89223 .75316 L p .86499 .76656 L F P
0 g
s
.142 .187 .38 r
.86499 .76656 m .88507 .75055 L .86664 .76926 L F
.171 .233 .471 r
.87054 .70317 m .91174 .69717 L .90507 .72472 L p F P
0 g
s
.171 .233 .471 r
.87054 .70317 m .90507 .72472 L .89354 .73961 L F
1 .316 .13 r
.87075 .74535 m .89908 .68257 L p .89354 .73961 L F P
0 g
s
1 .316 .13 r
.89223 .75316 m .88507 .75055 L p .89354 .73961 L F P
0 g
s
1 .316 .13 r
.88507 .75055 m .87075 .74535 L p .89354 .73961 L F P
0 g
s
.171 .233 .471 r
.90507 .72472 m .91174 .69717 L p .9185 .70738 L F P
0 g
s
1 .316 .13 r
.89908 .68257 m .92013 .69136 L .90507 .72472 L p F P
0 g
s
1 .316 .13 r
.90507 .72472 m .89223 .75316 L p .89354 .73961 L F P
0 g
s
1 .316 .13 r
.89908 .68257 m .90507 .72472 L .89354 .73961 L F
.171 .233 .471 r
.94205 .743 m .89927 .74867 L .90507 .72472 L p F P
0 g
s
1 .316 .13 r
.9185 .70738 m .91813 .71099 L .90507 .72472 L F
.171 .233 .471 r
.9185 .70738 m .94205 .743 L .90507 .72472 L F
.90507 .72472 m .89927 .74867 L p .89354 .73961 L F P
0 g
s
.142 .187 .38 r
.89927 .74867 m .8805 .79188 L p .86664 .76926 L F P
0 g
s
.142 .187 .38 r
.88507 .75055 m .89927 .74867 L p .86664 .76926 L F P
0 g
s
.171 .233 .471 r
.89927 .74867 m .88507 .75055 L p .89354 .73961 L F P
0 g
s
1 .316 .13 r
.90507 .72472 m .92013 .69136 L p .9185 .70738 L F P
0 g
s
1 .316 .13 r
.92013 .69136 m .92826 .69476 L p .9185 .70738 L F P
0 g
s
1 .316 .13 r
.92826 .69476 m .94054 .69989 L p .9185 .70738 L F P
0 g
s
.171 .233 .471 r
.9185 .70738 m .92826 .69476 L .92004 .70971 L F
.95387 .69103 m .94205 .743 L p .92004 .70971 L F P
0 g
s
.171 .233 .471 r
.92826 .69476 m .95387 .69103 L p .92004 .70971 L F P
0 g
s
1 .305 .125 r
.95604 .63532 m .95222 .65122 L p .93863 .66924 L F P
0 g
s
1 .305 .125 r
.93593 .62582 m .953 .63389 L p .93863 .66924 L F P
0 g
s
1 .305 .125 r
.953 .63389 m .95604 .63532 L p .93863 .66924 L F P
0 g
s
.191 .265 .533 r
.93863 .66924 m .953 .63389 L .94429 .67733 L F
.95942 .63285 m .95387 .69103 L p .94429 .67733 L F P
0 g
s
1 .29 .118 r
.95694 .61428 m .95604 .63532 L p .95427 .62757 L F P
0 g
s
.205 .289 .58 r
.91767 .57785 m .9588 .57057 L p .95378 .62542 L F P
0 g
s
1 .29 .118 r
.93593 .62582 m .93888 .56013 L p .95378 .62542 L F P
0 g
s
1 .29 .118 r
.95604 .63532 m .953 .63389 L p .95378 .62542 L F P
0 g
s
1 .29 .118 r
.953 .63389 m .93593 .62582 L p .95378 .62542 L F P
0 g
s
1 .29 .118 r
.9588 .57057 m .95694 .61428 L p .95378 .62542 L F P
0 g
s
1 .29 .118 r
.95378 .62542 m .95694 .61428 L .95427 .62757 L F
.205 .289 .58 r
.9588 .57057 m .95942 .63285 L p .95378 .62542 L F P
0 g
s
.191 .265 .533 r
.953 .63389 m .95942 .63285 L p .94429 .67733 L F P
0 g
s
1 .29 .118 r
.93888 .56013 m .9588 .57057 L p .95378 .62542 L F P
0 g
s
.205 .289 .58 r
.95942 .63285 m .953 .63389 L p .95378 .62542 L F P
0 g
s
.06 .071 .137 r
.53774 .87615 m .50025 .88024 L .53548 .86101 L p F P
0 g
s
.06 .071 .137 r
.53548 .86101 m .57246 .85681 L .53774 .87615 L p F P
0 g
s
1 .299 .125 r
.17472 .43169 m .20595 .44395 L .23236 .38396 L p F P
0 g
s
1 .292 .121 r
.20595 .44395 m .17472 .43169 L .15695 .49558 L p F P
0 g
s
1 .292 .121 r
.15695 .49558 m .18853 .50692 L .20595 .44395 L p F P
0 g
s
1 .305 .127 r
.20151 .37077 m .23236 .38396 L .26693 .32892 L p F P
0 g
s
1 .299 .125 r
.23236 .38396 m .20151 .37077 L .17472 .43169 L p F P
0 g
s
.411 .095 .039 r
.85452 .38253 m .83314 .36929 L .7922 .33297 L p F P
0 g
s
.411 .095 .039 r
.7699 .31899 m .7922 .33297 L .83314 .36929 L p F P
0 g
s
.024 .035 .067 r
.42361 .89025 m .38732 .89419 L .4277 .88816 L p F P
0 g
s
.024 .035 .067 r
.4277 .88816 m .46358 .88424 L .42361 .89025 L p F P
0 g
s
.997 .297 .127 r
.54394 .24274 m .51765 .22726 L .46391 .24347 L p F P
0 g
s
.997 .297 .127 r
.4364 .22801 m .46391 .24347 L .51765 .22726 L p F P
0 g
s
.288 .441 .86 r
.49775 .23956 m .4615 .25042 L .42193 .24128 L p F P
0 g
s
.703 .185 .074 r
.31051 .76886 m .28084 .76154 L .31366 .80582 L p F P
0 g
s
.703 .185 .074 r
.31366 .80582 m .34334 .81258 L .31051 .76886 L p F P
0 g
s
.833 .226 .091 r
.25768 .70944 m .22719 .70121 L .25024 .754 L p F P
0 g
s
.833 .226 .091 r
.25024 .754 m .28084 .76154 L .25768 .70944 L p F P
0 g
s
.279 .414 .818 r
.72181 .25272 m .6831 .26346 L .6483 .22895 L p F P
0 g
s
.279 .414 .818 r
.61003 .24004 m .6483 .22895 L .6831 .26346 L p F P
0 g
s
.171 .233 .471 r
.85743 .75421 m .81651 .75964 L .83022 .70905 L p F P
0 g
s
.171 .233 .471 r
.83022 .70905 m .87054 .70317 L .85743 .75421 L p F P
0 g
s
.848 .229 .091 r
.88676 .42972 m .90733 .44204 L .92905 .49782 L p F P
0 g
s
.643 .166 .063 r
.90733 .44204 m .88676 .42972 L .85452 .38253 L p F P
0 g
s
.643 .166 .063 r
.83314 .36929 m .85452 .38253 L .88676 .42972 L p F P
0 g
s
.246 .387 .762 r
.30849 .89007 m .27345 .89402 L .31709 .90182 L p F P
0 g
s
.246 .387 .762 r
.31709 .90182 m .35182 .89805 L .30849 .89007 L p F P
0 g
s
1 .283 .117 r
.18853 .50692 m .15695 .49558 L .14886 .56039 L p F P
0 g
s
1 .283 .117 r
.14886 .56039 m .18077 .57082 L .18853 .50692 L p F P
0 g
s
.498 .121 .047 r
.37211 .81914 m .34334 .81258 L .38489 .84639 L p F P
0 g
s
.498 .121 .047 r
.38489 .84639 m .41354 .85255 L .37211 .81914 L p F P
0 g
s
.914 .252 .103 r
.21433 .64276 m .18311 .63349 L .19576 .69272 L p F P
0 g
s
.914 .252 .103 r
.19576 .69272 m .22719 .70121 L .21433 .64276 L p F P
0 g
s
.248 .36 .716 r
.85935 .32939 m .90009 .31935 L .92245 .37868 L p F P
0 g
s
.258 .377 .748 r
.90009 .31935 m .85935 .32939 L .83245 .27627 L p F P
0 g
s
.258 .377 .748 r
.79236 .2868 m .83245 .27627 L .85935 .32939 L p F P
0 g
s
1 .308 .129 r
.23647 .31482 m .26693 .32892 L .3086 .28074 L p F P
0 g
s
1 .305 .127 r
.26693 .32892 m .23647 .31482 L .20151 .37077 L p F P
0 g
s
.309 .07 .029 r
.44133 .85852 m .41354 .85255 L .46226 .87423 L p F P
0 g
s
.309 .07 .029 r
.46226 .87423 m .4898 .87998 L .44133 .85852 L p F P
0 g
s
.058 .07 .135 r
.17071 .31851 m .13784 .32857 L .10352 .36121 L p F P
0 g
s
1 .327 .136 r
.82885 .85845 m .80701 .85248 L .85378 .80782 L p F P
0 g
s
1 .327 .136 r
.85378 .80782 m .87508 .81452 L .82885 .85845 L p F P
0 g
s
.268 .395 .782 r
.83245 .27627 m .79236 .2868 L .76138 .24175 L p F P
0 g
s
.268 .395 .782 r
.72181 .25272 m .76138 .24175 L .79236 .2868 L p F P
0 g
s
.528 .175 .077 r
.54364 .88826 m .56998 .8938 L .51651 .88555 L p F P
0 g
s
.901 .274 .119 r
.62306 .25502 m .59793 .2397 L .54394 .24274 L p F P
0 g
s
.901 .274 .119 r
.51765 .22726 m .52478 .23146 L p .52649 .22863 L F P
0 g
s
.288 .441 .86 r
.49775 .23956 m .45861 .23006 L p .52649 .22863 L F P
0 g
s
.288 .441 .86 r
.5348 .22846 m .52478 .23146 L p .52649 .22863 L F P
0 g
s
.288 .441 .86 r
.52478 .23146 m .49775 .23956 L p .52649 .22863 L F P
0 g
s
.901 .274 .119 r
.54394 .24274 m .59793 .2397 L p .52649 .22863 L F P
0 g
s
.901 .274 .119 r
.52478 .23146 m .54394 .24274 L p .52649 .22863 L F P
0 g
s
.096 .115 .238 r
.6884 .84363 m .64889 .84812 L .67704 .81663 L p F P
0 g
s
.096 .115 .238 r
.67704 .81663 m .71594 .8119 L .6884 .84363 L p F P
0 g
s
.967 .27 .111 r
.18077 .57082 m .14886 .56039 L .15091 .62393 L p F P
0 g
s
.967 .27 .111 r
.15091 .62393 m .18311 .63349 L .18077 .57082 L p F P
0 g
s
.142 .187 .38 r
.79637 .80212 m .75571 .80706 L .77649 .76494 L p F P
0 g
s
.142 .187 .38 r
.77649 .76494 m .81651 .75964 L .79637 .80212 L p F P
0 g
s
.963 .267 .107 r
.9588 .57057 m .93888 .56013 L .92905 .49782 L p F P
0 g
s
1 .325 .136 r
.7546 .88501 m .73152 .87942 L .78448 .84632 L p F P
0 g
s
1 .325 .136 r
.78448 .84632 m .80701 .85248 L .7546 .88501 L p F P
0 g
s
.06 .071 .137 r
.57607 .87197 m .53774 .87615 L .57246 .85681 L p F P
0 g
s
.06 .071 .137 r
.57246 .85681 m .61026 .85252 L .57607 .87197 L p F P
0 g
s
.851 .265 .114 r
.59553 .89917 m .56998 .8938 L .62643 .88799 L p F P
0 g
s
.851 .265 .114 r
.62643 .88799 m .65152 .89354 L .59553 .89917 L p F P
0 g
s
.699 .221 .098 r
.69913 .28056 m .6751 .26559 L .62306 .25502 L p F P
0 g
s
.699 .221 .098 r
.59793 .2397 m .62306 .25502 L .6751 .26559 L p F P
0 g
s
1 .31 .131 r
.67584 .89892 m .65152 .89354 L .70773 .87366 L p F P
0 g
s
1 .31 .131 r
.70773 .87366 m .73152 .87942 L .67584 .89892 L p F P
0 g
s
.288 .434 .852 r
.6483 .22895 m .61003 .24004 L .57267 .21711 L p F P
0 g
s
.288 .434 .852 r
.5348 .22846 m .57267 .21711 L .61003 .24004 L p F P
0 g
s
.024 .035 .067 r
.46072 .88622 m .42361 .89025 L .46358 .88424 L p F P
0 g
s
.288 .441 .86 r
.42193 .24128 m .45861 .23006 L .49775 .23956 L p F P
0 g
s
.279 .414 .818 r
.76138 .24175 m .72181 .25272 L .68742 .21761 L p F P
0 g
s
.279 .414 .818 r
.6483 .22895 m .68742 .21761 L .72181 .25272 L p F P
0 g
s
.444 .142 .066 r
.7699 .31899 m .74691 .30458 L .69913 .28056 L p F P
0 g
s
.444 .142 .066 r
.6751 .26559 m .69913 .28056 L .74691 .30458 L p F P
0 g
s
.246 .387 .762 r
.34432 .88604 m .30849 .89007 L .35182 .89805 L p F P
0 g
s
.246 .387 .762 r
.35182 .89805 m .38732 .89419 L .34432 .88604 L p F P
0 g
s
.246 .389 .747 r
.42193 .24128 m .38605 .25227 L .34666 .25698 L p F P
0 g
s
.246 .389 .747 r
.31115 .26793 m .34666 .25698 L .38605 .25227 L p F P
0 g
s
.268 .41 .812 r
.22932 .87179 m .19484 .87597 L .23917 .89788 L p F P
0 g
s
.268 .41 .812 r
.23917 .89788 m .27345 .89402 L .22932 .87179 L p F P
0 g
s
.963 .267 .107 r
.90855 .4862 m .92905 .49782 L .93888 .56013 L p F P
0 g
s
.848 .229 .091 r
.92905 .49782 m .90855 .4862 L .88676 .42972 L p F P
0 g
s
1 .299 .125 r
.14253 .41904 m .17472 .43169 L .20151 .37077 L p F P
0 g
s
1 .292 .121 r
.17472 .43169 m .14253 .41904 L .12439 .48389 L p F P
0 g
s
1 .292 .121 r
.12439 .48389 m .15695 .49558 L .17472 .43169 L p F P
0 g
s
.258 .377 .748 r
.83245 .27627 m .87344 .2655 L .90009 .31935 L p F P
0 g
s
1 .305 .127 r
.16971 .35716 m .20151 .37077 L .23647 .31482 L p F P
0 g
s
1 .299 .125 r
.20151 .37077 m .16971 .35716 L .14253 .41904 L p F P
0 g
s
.411 .095 .039 r
.83314 .36929 m .8111 .35564 L .7699 .31899 L p F P
0 g
s
.411 .095 .039 r
.74691 .30458 m .7699 .31899 L .8111 .35564 L p F P
0 g
s
1 .299 .125 r
.16971 .35716 m .14807 .34791 L p .10933 .40599 L F P
0 g
s
.058 .07 .135 r
.17071 .31851 m .13672 .3513 L p .19798 .31227 L F P
0 g
s
.058 .07 .135 r
.10352 .36121 m .13672 .3513 L .17071 .31851 L p F P
0 g
s
.111 .142 .3 r
.13672 .3513 m .10352 .36121 L .07573 .4065 L p F P
0 g
s
.058 .07 .135 r
.13672 .3513 m .14807 .34791 L p .20432 .30823 L F P
0 g
s
.058 .07 .135 r
.19361 .3187 m .20432 .30823 L p .14807 .34791 L F P
0 g
s
.058 .07 .135 r
.20312 .30859 m .17071 .31851 L p .19798 .31227 L F P
0 g
s
1 .305 .127 r
.1369 .34313 m .14807 .34791 L p .20506 .30029 L F P
0 g
s
1 .305 .127 r
.14807 .34791 m .16971 .35716 L .19361 .3187 L p F P
0 g
s
1 .305 .127 r
.19361 .3187 m .20506 .30029 L p .14807 .34791 L F P
0 g
s
1 .305 .127 r
.23647 .31482 m .21509 .30493 L p .16971 .35716 L F P
0 g
s
1 .305 .127 r
.19361 .3187 m .16971 .35716 L p .21509 .30493 L F P
0 g
s
.058 .07 .135 r
.23867 .29772 m .21509 .30493 L p .17067 .34116 L F P
0 g
s
.058 .07 .135 r
.21509 .30493 m .20432 .30823 L .19361 .3187 L p F P
0 g
s
.058 .07 .135 r
.19361 .3187 m .17067 .34116 L p .21509 .30493 L F P
0 g
s
.058 .07 .135 r
.14807 .34791 m .17067 .34116 L .19361 .3187 L p F P
0 g
s
.058 .07 .135 r
.20432 .30823 m .20312 .30859 L p .19798 .31227 L F P
0 g
s
1 .305 .127 r
.21509 .30493 m .20506 .30029 L .19361 .3187 L p F P
0 g
s
1 .299 .125 r
.1242 .37209 m .10933 .40599 L p .14807 .34791 L F P
0 g
s
.111 .142 .3 r
.07573 .4065 m .09593 .40073 L p .13672 .3513 L F P
0 g
s
1 .299 .125 r
.07506 .39253 m .09593 .40073 L p .1369 .34313 L F P
0 g
s
1 .299 .125 r
.09593 .40073 m .10933 .40599 L .1242 .37209 L p F P
0 g
s
.111 .142 .3 r
.1242 .37209 m .13672 .3513 L p .09593 .40073 L F P
0 g
s
1 .299 .125 r
.1242 .37209 m .1369 .34313 L p .09593 .40073 L F P
0 g
s
.111 .142 .3 r
.09593 .40073 m .10925 .39692 L .1242 .37209 L p F P
0 g
s
.111 .142 .3 r
.17067 .34116 m .14807 .34791 L p .10925 .39692 L F P
0 g
s
.111 .142 .3 r
.14807 .34791 m .13672 .3513 L .1242 .37209 L p F P
0 g
s
.111 .142 .3 r
.1242 .37209 m .10925 .39692 L p .14807 .34791 L F P
0 g
s
1 .299 .125 r
.12876 .3617 m .1242 .37209 L p .14807 .34791 L F P
0 g
s
1 .299 .125 r
.14807 .34791 m .1369 .34313 L .12876 .3617 L p F P
0 g
s
.703 .185 .074 r
.28084 .76154 m .25024 .754 L .28306 .79884 L p F P
0 g
s
.703 .185 .074 r
.28306 .79884 m .31366 .80582 L .28084 .76154 L p F P
0 g
s
.833 .226 .091 r
.22719 .70121 m .19576 .69272 L .21868 .74621 L p F P
0 g
s
.833 .226 .091 r
.21868 .74621 m .25024 .754 L .22719 .70121 L p F P
0 g
s
.848 .229 .091 r
.86556 .41701 m .88676 .42972 L .90855 .4862 L p F P
0 g
s
.643 .166 .063 r
.88676 .42972 m .86556 .41701 L .83314 .36929 L p F P
0 g
s
.643 .166 .063 r
.8111 .35564 m .83314 .36929 L .86556 .41701 L p F P
0 g
s
.268 .395 .782 r
.87344 .2655 m .83245 .27627 L .80183 .23054 L p F P
0 g
s
.268 .395 .782 r
.76138 .24175 m .80183 .23054 L .83245 .27627 L p F P
0 g
s
1 .283 .117 r
.15695 .49558 m .12439 .48389 L .11595 .54963 L p F P
0 g
s
1 .283 .117 r
.11595 .54963 m .14886 .56039 L .15695 .49558 L p F P
0 g
s
.498 .121 .047 r
.34334 .81258 m .31366 .80582 L .35533 .84004 L p F P
0 g
s
.498 .121 .047 r
.35533 .84004 m .38489 .84639 L .34334 .81258 L p F P
0 g
s
.914 .252 .103 r
.18311 .63349 m .15091 .62393 L .16334 .68397 L p F P
0 g
s
.914 .252 .103 r
.16334 .68397 m .19576 .69272 L .18311 .63349 L p F P
0 g
s
.096 .115 .238 r
.7288 .83904 m .6884 .84363 L .71594 .8119 L p F P
0 g
s
.096 .115 .238 r
.71594 .8119 m .75571 .80706 L .7288 .83904 L p F P
0 g
s
1 .323 .134 r
.85378 .80782 m .8318 .8009 L .84 .78921 L p F P
0 g
s
1 .327 .136 r
.80701 .85248 m .78448 .84632 L .8318 .8009 L p F P
0 g
s
1 .327 .136 r
.8318 .8009 m .85378 .80782 L .80701 .85248 L p F P
0 g
s
1 .327 .136 r
.8318 .8009 m .78448 .84632 L p .80128 .8105 L F P
0 g
s
.096 .115 .238 r
.79637 .80212 m .82471 .79867 L p .80128 .8105 L F P
0 g
s
.142 .187 .38 r
.79637 .80212 m .81651 .75964 L p .83444 .79092 L F P
0 g
s
.142 .187 .38 r
.82471 .79867 m .79637 .80212 L p .83444 .79092 L F P
0 g
s
1 .327 .136 r
.80912 .79377 m .82471 .79867 L p .80128 .8105 L F P
0 g
s
1 .327 .136 r
.82471 .79867 m .8318 .8009 L p .80128 .8105 L F P
0 g
s
.096 .115 .238 r
.80128 .8105 m .82471 .79867 L .80243 .81246 L F
.142 .187 .38 r
.81651 .75964 m .85743 .75421 L .84433 .78302 L p F P
0 g
s
.142 .187 .38 r
.81651 .75964 m .84433 .78302 L .83444 .79092 L F
1 .323 .134 r
.80912 .79377 m .84859 .73728 L p .83444 .79092 L F P
0 g
s
1 .323 .134 r
.8318 .8009 m .82471 .79867 L p .83444 .79092 L F P
0 g
s
1 .323 .134 r
.82471 .79867 m .80912 .79377 L p .83444 .79092 L F P
0 g
s
1 .323 .134 r
.84 .78921 m .84433 .78302 L p .84541 .78586 L F P
0 g
s
1 .323 .134 r
.84541 .78586 m .85378 .80782 L .84 .78921 L F
.142 .187 .38 r
.84433 .78302 m .85743 .75421 L p .86499 .76656 L F P
0 g
s
1 .323 .134 r
.84859 .73728 m .87075 .74535 L .84433 .78302 L p F P
0 g
s
1 .323 .134 r
.84433 .78302 m .8318 .8009 L p .83444 .79092 L F P
0 g
s
1 .323 .134 r
.84859 .73728 m .84433 .78302 L .83444 .79092 L F
.86499 .76656 m .85378 .80782 L .84433 .78302 L F
.142 .187 .38 r
.8805 .79188 m .83796 .79706 L .84433 .78302 L p F P
0 g
s
.142 .187 .38 r
.86499 .76656 m .8805 .79188 L .84433 .78302 L F
.84433 .78302 m .83796 .79706 L p .83444 .79092 L F P
0 g
s
.096 .115 .238 r
.83796 .79706 m .81243 .82954 L p .80243 .81246 L F P
0 g
s
.096 .115 .238 r
.82471 .79867 m .83796 .79706 L p .80243 .81246 L F P
0 g
s
1 .323 .134 r
.84433 .78302 m .87075 .74535 L p .86499 .76656 L F P
0 g
s
.142 .187 .38 r
.83796 .79706 m .82471 .79867 L p .83444 .79092 L F P
0 g
s
.309 .07 .029 r
.41354 .85255 m .38489 .84639 L .43385 .8683 L p F P
0 g
s
.309 .07 .029 r
.43385 .8683 m .46226 .87423 L .41354 .85255 L p F P
0 g
s
.06 .071 .137 r
.61527 .86769 m .57607 .87197 L .61026 .85252 L p F P
0 g
s
.06 .071 .137 r
.61026 .85252 m .64889 .84812 L .61527 .86769 L p F P
0 g
s
.288 .434 .852 r
.68742 .21761 m .6483 .22895 L .6114 .2055 L p F P
0 g
s
.288 .434 .852 r
.57267 .21711 m .6114 .2055 L .6483 .22895 L p F P
0 g
s
.024 .035 .067 r
.49584 .88091 m .50025 .88024 L p .49967 .88093 L F P
0 g
s
.528 .175 .077 r
.50615 .88096 m .51646 .88254 L p .49967 .88093 L F P
0 g
s
.024 .035 .067 r
.50025 .88024 m .53774 .87615 L .50615 .88096 L p F P
0 g
s
.528 .175 .077 r
.51646 .88254 m .54364 .88826 L .49584 .88091 L p F P
0 g
s
.528 .175 .077 r
.51646 .88254 m .49584 .88091 L .49967 .88093 L F
.024 .035 .067 r
.50615 .88096 m .49868 .88209 L p .49967 .88093 L F P
0 g
s
.024 .035 .067 r
.50025 .88024 m .50615 .88096 L .49967 .88093 L F
.528 .175 .077 r
.49584 .88091 m .4898 .87998 L p .49967 .88093 L F P
0 g
s
.528 .175 .077 r
.4898 .87998 m .46226 .87423 L .50615 .88096 L p F P
0 g
s
.528 .175 .077 r
.49967 .88093 m .4898 .87998 L .50615 .88096 L F
.024 .035 .067 r
.49868 .88209 m .46072 .88622 L .49584 .88091 L p F P
0 g
s
.024 .035 .067 r
.49967 .88093 m .49868 .88209 L .49584 .88091 L F
.997 .297 .127 r
.51765 .22726 m .49053 .2113 L .4364 .22801 L p F P
0 g
s
.288 .441 .86 r
.57267 .21711 m .5348 .22846 L .52769 .22664 L p F P
0 g
s
.901 .274 .119 r
.59793 .2397 m .57201 .22391 L .52769 .22664 L p F P
0 g
s
.901 .274 .119 r
.52769 .22664 m .51765 .22726 L p .52649 .22863 L F P
0 g
s
.901 .274 .119 r
.52649 .22863 m .59793 .2397 L .52769 .22664 L F
.288 .441 .86 r
.53298 .21787 m .57267 .21711 L .52769 .22664 L F
.901 .274 .119 r
.49053 .2113 m .51765 .22726 L .52769 .22664 L p F P
0 g
s
.901 .274 .119 r
.52769 .22664 m .57201 .22391 L p .53298 .21787 L F P
0 g
s
.901 .274 .119 r
.49053 .2113 m .52769 .22664 L .53298 .21787 L F
.288 .441 .86 r
.45861 .23006 m .49611 .21858 L .52769 .22664 L p F P
0 g
s
.288 .441 .86 r
.52769 .22664 m .5348 .22846 L p .52649 .22863 L F P
0 g
s
.288 .441 .86 r
.45861 .23006 m .52769 .22664 L .52649 .22863 L F
.52769 .22664 m .49611 .21858 L p .53298 .21787 L F P
0 g
s
.997 .297 .127 r
.40804 .21208 m .4364 .22801 L .49053 .2113 L p F P
0 g
s
1 .307 .13 r
.4364 .22801 m .40804 .21208 L .35614 .24122 L p F P
0 g
s
.279 .414 .818 r
.80183 .23054 m .76138 .24175 L .72742 .20602 L p F P
0 g
s
.279 .414 .818 r
.68742 .21761 m .72742 .20602 L .76138 .24175 L p F P
0 g
s
.246 .387 .762 r
.38097 .88191 m .34432 .88604 L .38732 .89419 L p F P
0 g
s
.246 .387 .762 r
.38732 .89419 m .42361 .89025 L .38097 .88191 L p F P
0 g
s
.246 .389 .747 r
.45861 .23006 m .42193 .24128 L .38298 .24578 L p F P
0 g
s
.246 .389 .747 r
.34666 .25698 m .38298 .24578 L .42193 .24128 L p F P
0 g
s
1 .307 .13 r
.32647 .22547 m .35614 .24122 L .40804 .21208 L p F P
0 g
s
1 .309 .13 r
.35614 .24122 m .32647 .22547 L .27854 .26578 L p F P
0 g
s
.967 .27 .111 r
.14886 .56039 m .11595 .54963 L .1177 .61407 L p F P
0 g
s
.967 .27 .111 r
.1177 .61407 m .15091 .62393 L .14886 .56039 L p F P
0 g
s
.963 .267 .107 r
.93888 .56013 m .91832 .54937 L .90855 .4862 L p F P
0 g
s
1 .29 .118 r
.91832 .54937 m .93888 .56013 L .93593 .62582 L p F P
0 g
s
.268 .41 .812 r
.2646 .86751 m .22932 .87179 L .27345 .89402 L p F P
0 g
s
.268 .41 .812 r
.27345 .89402 m .30849 .89007 L .2646 .86751 L p F P
0 g
s
1 .325 .136 r
.73152 .87942 m .70773 .87366 L .76125 .83996 L p F P
0 g
s
1 .325 .136 r
.76125 .83996 m .78448 .84632 L .73152 .87942 L p F P
0 g
s
.851 .265 .114 r
.56998 .8938 m .54364 .88826 L .60055 .88226 L p F P
0 g
s
.851 .265 .114 r
.60055 .88226 m .62643 .88799 L .56998 .8938 L p F P
0 g
s
.699 .221 .098 r
.6751 .26559 m .65032 .25016 L .59793 .2397 L p F P
0 g
s
.699 .221 .098 r
.57201 .22391 m .59793 .2397 L .65032 .25016 L p F P
0 g
s
1 .31 .131 r
.65152 .89354 m .62643 .88799 L .68317 .86771 L p F P
0 g
s
1 .31 .131 r
.68317 .86771 m .70773 .87366 L .65152 .89354 L p F P
0 g
s
.024 .035 .067 r
.34666 .25698 m .31115 .26793 L .27381 .28697 L p F P
0 g
s
.024 .035 .067 r
.23867 .29772 m .27381 .28697 L .31115 .26793 L p F P
0 g
s
1 .309 .13 r
.24754 .25035 m .27854 .26578 L .32647 .22547 L p F P
0 g
s
1 .308 .129 r
.27854 .26578 m .24754 .25035 L .20506 .30029 L p F P
0 g
s
.444 .142 .066 r
.74691 .30458 m .7232 .28972 L .6751 .26559 L p F P
0 g
s
.444 .142 .066 r
.65032 .25016 m .6751 .26559 L .7232 .28972 L p F P
0 g
s
.268 .395 .782 r
.80183 .23054 m .84319 .21907 L .87344 .2655 L p F P
0 g
s
.963 .267 .107 r
.88741 .47421 m .90855 .4862 L .91832 .54937 L p F P
0 g
s
.848 .229 .091 r
.90855 .4862 m .88741 .47421 L .86556 .41701 L p F P
0 g
s
1 .299 .125 r
.10933 .40599 m .14253 .41904 L .16971 .35716 L p F P
0 g
s
1 .292 .121 r
.14253 .41904 m .10933 .40599 L .0908 .47183 L p F P
0 g
s
1 .292 .121 r
.0908 .47183 m .12439 .48389 L .14253 .41904 L p F P
0 g
s
1 .327 .136 r
.78448 .84632 m .76125 .83996 L .77356 .82808 L p F P
0 g
s
1 .325 .136 r
.76125 .83996 m .70773 .87366 L p .73081 .8422 L F P
0 g
s
.06 .071 .137 r
.7288 .83904 m .74935 .83671 L p .73081 .8422 L F P
0 g
s
.096 .115 .238 r
.7288 .83904 m .75571 .80706 L p .76674 .82793 L F P
0 g
s
.096 .115 .238 r
.74935 .83671 m .7288 .83904 L p .76674 .82793 L F P
0 g
s
1 .325 .136 r
.73726 .8334 m .74935 .83671 L p .73081 .8422 L F P
0 g
s
1 .325 .136 r
.74935 .83671 m .76125 .83996 L p .73081 .8422 L F P
0 g
s
.06 .071 .137 r
.73081 .8422 m .74935 .83671 L .73138 .84311 L F
.096 .115 .238 r
.75571 .80706 m .79637 .80212 L .78137 .82055 L p F P
0 g
s
.096 .115 .238 r
.75571 .80706 m .78137 .82055 L .76674 .82793 L F
1 .327 .136 r
.73726 .8334 m .78571 .7864 L p .76674 .82793 L F P
0 g
s
1 .327 .136 r
.76125 .83996 m .74935 .83671 L p .76674 .82793 L F P
0 g
s
1 .327 .136 r
.74935 .83671 m .73726 .8334 L p .76674 .82793 L F P
0 g
s
1 .327 .136 r
.77356 .82808 m .78137 .82055 L p .78192 .8251 L F P
0 g
s
1 .327 .136 r
.78192 .8251 m .78448 .84632 L .77356 .82808 L F
.096 .115 .238 r
.78137 .82055 m .79637 .80212 L p .80128 .8105 L F P
0 g
s
1 .327 .136 r
.78571 .7864 m .80912 .79377 L .78137 .82055 L p F P
0 g
s
1 .327 .136 r
.78137 .82055 m .76125 .83996 L p .76674 .82793 L F P
0 g
s
1 .327 .136 r
.78571 .7864 m .78137 .82055 L .76674 .82793 L F
.80128 .8105 m .78448 .84632 L .78137 .82055 L F
.096 .115 .238 r
.81243 .82954 m .77014 .83435 L .78137 .82055 L p F P
0 g
s
.096 .115 .238 r
.80128 .8105 m .81243 .82954 L .78137 .82055 L F
.78137 .82055 m .77014 .83435 L p .76674 .82793 L F P
0 g
s
.06 .071 .137 r
.77014 .83435 m .73844 .85425 L p .73138 .84311 L F P
0 g
s
.06 .071 .137 r
.74935 .83671 m .77014 .83435 L p .73138 .84311 L F P
0 g
s
1 .327 .136 r
.78137 .82055 m .80912 .79377 L p .80128 .8105 L F P
0 g
s
.096 .115 .238 r
.77014 .83435 m .74935 .83671 L p .76674 .82793 L F P
0 g
s
.411 .095 .039 r
.8111 .35564 m .78836 .34156 L .74691 .30458 L p F P
0 g
s
.411 .095 .039 r
.7232 .28972 m .74691 .30458 L .78836 .34156 L p F P
0 g
s
1 .305 .125 r
.9152 .61602 m .93593 .62582 L .92013 .69136 L p F P
0 g
s
1 .29 .118 r
.93593 .62582 m .9152 .61602 L .91832 .54937 L p F P
0 g
s
.06 .071 .137 r
.65538 .86331 m .61527 .86769 L .64889 .84812 L p F P
0 g
s
.06 .071 .137 r
.64889 .84812 m .6884 .84363 L .65538 .86331 L p F P
0 g
s
.703 .185 .074 r
.25024 .754 m .21868 .74621 L .25146 .79164 L p F P
0 g
s
.703 .185 .074 r
.25146 .79164 m .28306 .79884 L .25024 .754 L p F P
0 g
s
.833 .226 .091 r
.19576 .69272 m .16334 .68397 L .18611 .73818 L p F P
0 g
s
.833 .226 .091 r
.18611 .73818 m .21868 .74621 L .19576 .69272 L p F P
0 g
s
.848 .229 .091 r
.84368 .4039 m .86556 .41701 L .88741 .47421 L p F P
0 g
s
.643 .166 .063 r
.86556 .41701 m .84368 .4039 L .8111 .35564 L p F P
0 g
s
.643 .166 .063 r
.78836 .34156 m .8111 .35564 L .84368 .4039 L p F P
0 g
s
.288 .434 .852 r
.72742 .20602 m .68742 .21761 L .65101 .19363 L p F P
0 g
s
.288 .434 .852 r
.6114 .2055 m .65101 .19363 L .68742 .21761 L p F P
0 g
s
1 .283 .117 r
.12439 .48389 m .0908 .47183 L .082 .53853 L p F P
0 g
s
1 .283 .117 r
.082 .53853 m .11595 .54963 L .12439 .48389 L p F P
0 g
s
.498 .121 .047 r
.31366 .80582 m .28306 .79884 L .32481 .83348 L p F P
0 g
s
.498 .121 .047 r
.32481 .83348 m .35533 .84004 L .31366 .80582 L p F P
0 g
s
.024 .035 .067 r
.50615 .88096 m .53774 .87615 L p .50902 .88097 L F P
0 g
s
.528 .175 .077 r
.48839 .87663 m .50902 .88097 L p .46226 .87423 L F P
0 g
s
.528 .175 .077 r
.50902 .88097 m .51646 .88254 L .50615 .88096 L p F P
0 g
s
.528 .175 .077 r
.50615 .88096 m .46226 .87423 L p .50902 .88097 L F P
0 g
s
.024 .035 .067 r
.53752 .87788 m .50902 .88097 L p .53774 .87615 L F P
0 g
s
.024 .035 .067 r
.50902 .88097 m .49868 .88209 L .50615 .88096 L p F P
0 g
s
.024 .035 .067 r
.53774 .87615 m .57607 .87197 L .53752 .87788 L p F P
0 g
s
.288 .441 .86 r
.6114 .2055 m .57267 .21711 L .53892 .20803 L p F P
0 g
s
.288 .441 .86 r
.5397 .20675 m .6114 .2055 L .53892 .20803 L F
.901 .274 .119 r
.53892 .20803 m .49053 .2113 L p .53298 .21787 L F P
0 g
s
.901 .274 .119 r
.46255 .19484 m .49053 .2113 L .53892 .20803 L p F P
0 g
s
.901 .274 .119 r
.46255 .19484 m .53892 .20803 L .5397 .20675 L F
.288 .441 .86 r
.49611 .21858 m .53448 .20684 L .53892 .20803 L p F P
0 g
s
.288 .441 .86 r
.53892 .20803 m .57267 .21711 L p .53298 .21787 L F P
0 g
s
.288 .441 .86 r
.49611 .21858 m .53892 .20803 L .53298 .21787 L F
.901 .274 .119 r
.53892 .20803 m .54526 .2076 L p .5397 .20675 L F P
0 g
s
.901 .274 .119 r
.57201 .22391 m .54526 .2076 L .53892 .20803 L p F P
0 g
s
.901 .274 .119 r
.53298 .21787 m .57201 .22391 L .53892 .20803 L F
.288 .441 .86 r
.53892 .20803 m .53448 .20684 L p .5397 .20675 L F P
0 g
s
.264 .396 .788 r
.18704 .83541 m .15242 .84008 L .19484 .87597 L p F P
0 g
s
.264 .396 .788 r
.19484 .87597 m .22932 .87179 L .18704 .83541 L p F P
0 g
s
1 .305 .125 r
.92013 .69136 m .89908 .68257 L .9152 .61602 L p F P
0 g
s
.914 .252 .103 r
.15091 .62393 m .1177 .61407 L .12988 .67494 L p F P
0 g
s
.914 .252 .103 r
.12988 .67494 m .16334 .68397 L .15091 .62393 L p F P
0 g
s
.279 .414 .818 r
.84319 .21907 m .80183 .23054 L .76833 .19416 L p F P
0 g
s
.279 .414 .818 r
.72742 .20602 m .76833 .19416 L .80183 .23054 L p F P
0 g
s
.246 .387 .762 r
.41846 .87769 m .38097 .88191 L .42361 .89025 L p F P
0 g
s
.246 .387 .762 r
.42361 .89025 m .46072 .88622 L .41846 .87769 L p F P
0 g
s
.246 .389 .747 r
.49611 .21858 m .45861 .23006 L .42013 .23433 L p F P
0 g
s
.246 .389 .747 r
.38298 .24578 m .42013 .23433 L .45861 .23006 L p F P
0 g
s
1 .308 .129 r
.17266 .28529 m .20506 .30029 L .24754 .25035 L p F P
0 g
s
1 .305 .127 r
.20506 .30029 m .17266 .28529 L .1369 .34313 L p F P
0 g
s
.268 .41 .812 r
.30068 .86312 m .2646 .86751 L .30849 .89007 L p F P
0 g
s
.268 .41 .812 r
.30849 .89007 m .34432 .88604 L .30068 .86312 L p F P
0 g
s
.309 .07 .029 r
.38489 .84639 m .35533 .84004 L .40451 .86218 L p F P
0 g
s
.309 .07 .029 r
.40451 .86218 m .43385 .8683 L .38489 .84639 L p F P
0 g
s
.024 .035 .067 r
.38298 .24578 m .34666 .25698 L .30975 .27597 L p F P
0 g
s
.024 .035 .067 r
.27381 .28697 m .30975 .27597 L .34666 .25698 L p F P
0 g
s
.058 .07 .135 r
.27381 .28697 m .23867 .29772 L .2054 .3308 L p F P
0 g
s
.058 .07 .135 r
.17067 .34116 m .2054 .3308 L .23867 .29772 L p F P
0 g
s
.997 .297 .127 r
.49053 .2113 m .46255 .19484 L .40804 .21208 L p F P
0 g
s
.997 .297 .127 r
.37877 .19563 m .40804 .21208 L .46255 .19484 L p F P
0 g
s
1 .307 .13 r
.40804 .21208 m .37877 .19563 L .32647 .22547 L p F P
0 g
s
.528 .175 .077 r
.46226 .87423 m .43385 .8683 L .48839 .87663 L p F P
0 g
s
1 .307 .13 r
.29587 .20922 m .32647 .22547 L .37877 .19563 L p F P
0 g
s
1 .309 .13 r
.32647 .22547 m .29587 .20922 L .24754 .25035 L p F P
0 g
s
.967 .27 .111 r
.11595 .54963 m .082 .53853 L .08342 .60389 L p F P
0 g
s
.967 .27 .111 r
.08342 .60389 m .1177 .61407 L .11595 .54963 L p F P
0 g
s
.963 .267 .107 r
.91832 .54937 m .89712 .53826 L .88741 .47421 L p F P
0 g
s
1 .29 .118 r
.89712 .53826 m .91832 .54937 L .9152 .61602 L p F P
0 g
s
.06 .071 .137 r
.6884 .84363 m .7288 .83904 L .71688 .84633 L p F P
0 g
s
.06 .071 .137 r
.6884 .84363 m .71688 .84633 L .69348 .85326 L F
1 .325 .136 r
.71249 .82663 m .73726 .8334 L .71688 .84633 L p F P
0 g
s
1 .325 .136 r
.71688 .84633 m .68317 .86771 L p .69348 .85326 L F P
0 g
s
1 .325 .136 r
.71249 .82663 m .71688 .84633 L .69348 .85326 L F
.06 .071 .137 r
.65538 .86331 m .6884 .84363 L p .69348 .85326 L F P
0 g
s
.06 .071 .137 r
.66201 .86259 m .65538 .86331 L p .69348 .85326 L F P
0 g
s
1 .325 .136 r
.65782 .86157 m .71249 .82663 L p .68949 .85886 L F P
0 g
s
1 .325 .136 r
.68317 .86771 m .66201 .86259 L p .68949 .85886 L F P
0 g
s
1 .325 .136 r
.66201 .86259 m .65782 .86157 L p .68949 .85886 L F P
0 g
s
1 .31 .131 r
.68317 .86771 m .62643 .88799 L p .65566 .8634 L F P
0 g
s
.024 .035 .067 r
.65538 .86331 m .66201 .86259 L p .65566 .8634 L F P
0 g
s
1 .31 .131 r
.65782 .86157 m .66201 .86259 L p .65566 .8634 L F P
0 g
s
1 .31 .131 r
.66201 .86259 m .68317 .86771 L p .65566 .8634 L F P
0 g
s
.024 .035 .067 r
.65566 .8634 m .66201 .86259 L .65578 .86343 L F
.69643 .85883 m .65959 .86462 L p .65578 .86343 L F P
0 g
s
.024 .035 .067 r
.66201 .86259 m .69643 .85883 L p .65578 .86343 L F P
0 g
s
.06 .071 .137 r
.69643 .85883 m .66201 .86259 L p .69348 .85326 L F P
0 g
s
.06 .071 .137 r
.71688 .84633 m .69643 .85883 L p .69348 .85326 L F P
0 g
s
1 .325 .136 r
.70773 .87366 m .68317 .86771 L .71688 .84633 L p F P
0 g
s
1 .325 .136 r
.73081 .8422 m .70773 .87366 L .71688 .84633 L F
.06 .071 .137 r
.73844 .85425 m .69643 .85883 L .7288 .83904 L p F P
0 g
s
1 .325 .136 r
.71688 .84633 m .73726 .8334 L p .73081 .8422 L F P
0 g
s
.851 .265 .114 r
.54364 .88826 m .51646 .88254 L .57382 .87635 L p F P
0 g
s
.851 .265 .114 r
.57382 .87635 m .60055 .88226 L .54364 .88826 L p F P
0 g
s
.699 .221 .098 r
.65032 .25016 m .62475 .23423 L .57201 .22391 L p F P
0 g
s
.699 .221 .098 r
.54526 .2076 m .57201 .22391 L .62475 .23423 L p F P
0 g
s
.024 .035 .067 r
.61527 .86769 m .65538 .86331 L .65121 .86396 L p F P
0 g
s
.024 .035 .067 r
.61527 .86769 m .65121 .86396 L .61653 .86837 L F
1 .31 .131 r
.63164 .85523 m .65782 .86157 L .65121 .86396 L p F P
0 g
s
1 .31 .131 r
.65121 .86396 m .60055 .88226 L p .61653 .86837 L F P
0 g
s
1 .31 .131 r
.63164 .85523 m .65121 .86396 L .61653 .86837 L F
.024 .035 .067 r
.58453 .87244 m .61527 .86769 L p .61653 .86837 L F P
0 g
s
1 .31 .131 r
.60055 .88226 m .57382 .87635 L .58453 .87244 L p F P
0 g
s
.024 .035 .067 r
.57607 .87197 m .61527 .86769 L .58453 .87244 L p F P
0 g
s
1 .31 .131 r
.58453 .87244 m .63164 .85523 L p .61653 .86837 L F P
0 g
s
1 .31 .131 r
.61653 .86837 m .60055 .88226 L .58453 .87244 L F
.024 .035 .067 r
.57607 .87197 m .58453 .87244 L .57712 .87338 L F
1 .31 .131 r
.60458 .84868 m .63164 .85523 L .58453 .87244 L p F P
0 g
s
1 .31 .131 r
.58453 .87244 m .57382 .87635 L p .57712 .87338 L F P
0 g
s
1 .31 .131 r
.60458 .84868 m .58453 .87244 L .57712 .87338 L F
.024 .035 .067 r
.53752 .87788 m .57607 .87197 L p .57712 .87338 L F P
0 g
s
.024 .035 .067 r
.56651 .87473 m .53752 .87788 L p .57712 .87338 L F P
0 g
s
1 .31 .131 r
.57382 .87635 m .54622 .87024 L .60458 .84868 L p F P
0 g
s
.024 .035 .067 r
.57726 .87356 m .56651 .87473 L p .57712 .87338 L F P
0 g
s
.024 .035 .067 r
.58453 .87244 m .57726 .87356 L p .57712 .87338 L F P
0 g
s
.024 .035 .067 r
.61794 .86914 m .57726 .87356 L .58453 .87244 L p F P
0 g
s
.024 .035 .067 r
.61653 .86837 m .61794 .86914 L .58453 .87244 L F
.65121 .86396 m .61794 .86914 L p .61653 .86837 L F P
0 g
s
1 .31 .131 r
.62643 .88799 m .60055 .88226 L .65121 .86396 L p F P
0 g
s
1 .31 .131 r
.65121 .86396 m .65782 .86157 L p .65566 .8634 L F P
0 g
s
1 .31 .131 r
.65566 .8634 m .62643 .88799 L .65121 .86396 L F
.142 .187 .38 r
.92402 .78659 m .8805 .79188 L .89927 .74867 L p F P
0 g
s
.142 .187 .38 r
.89927 .74867 m .94205 .743 L .92402 .78659 L p F P
0 g
s
1 .309 .13 r
.21554 .23442 m .24754 .25035 L .29587 .20922 L p F P
0 g
s
1 .308 .129 r
.24754 .25035 m .21554 .23442 L .17266 .28529 L p F P
0 g
s
.444 .142 .066 r
.7232 .28972 m .69873 .27438 L .65032 .25016 L p F P
0 g
s
.444 .142 .066 r
.62475 .23423 m .65032 .25016 L .69873 .27438 L p F P
0 g
s
.288 .434 .852 r
.76833 .19416 m .72742 .20602 L .69153 .18149 L p F P
0 g
s
.288 .434 .852 r
.65101 .19363 m .69153 .18149 L .72742 .20602 L p F P
0 g
s
.288 .441 .86 r
.65101 .19363 m .6114 .2055 L .57373 .19482 L p F P
0 g
s
.901 .274 .119 r
.51765 .19077 m .46255 .19484 L p .53723 .20636 L F P
0 g
s
.901 .274 .119 r
.53723 .20636 m .53847 .20586 L .51765 .19077 L F
.54082 .2049 m .51765 .19077 L p .53847 .20586 L F P
0 g
s
.901 .274 .119 r
.5397 .20675 m .54082 .2049 L .53847 .20586 L F
.699 .221 .098 r
.51765 .19077 m .54082 .2049 L p .5465 .20043 L F P
0 g
s
.246 .389 .747 r
.53448 .20684 m .49703 .21061 L p .5465 .20043 L F P
0 g
s
.246 .389 .747 r
.5465 .20043 m .55701 .19826 L .54198 .20398 L F
.5465 .20043 m .54198 .20398 L .53448 .20684 L F
.5465 .20043 m .5629 .19585 L .55701 .19826 L F
.5481 .19917 m .5629 .19585 L .5465 .20043 L F
.699 .221 .098 r
.55086 .197 m .51765 .19077 L p .5465 .20043 L F P
0 g
s
.246 .389 .747 r
.49703 .21061 m .53684 .19834 L .55086 .197 L p F P
0 g
s
.246 .389 .747 r
.55086 .197 m .5629 .19585 L p .5481 .19917 L F P
0 g
s
.246 .389 .747 r
.49703 .21061 m .55086 .197 L .5481 .19917 L F
.699 .221 .098 r
.48913 .17339 m .51765 .19077 L .55086 .197 L p F P
0 g
s
.246 .389 .747 r
.5629 .19585 m .57373 .19482 L p .55701 .19826 L F P
0 g
s
.246 .389 .747 r
.57373 .19482 m .54082 .2049 L p .55701 .19826 L F P
0 g
s
.288 .441 .86 r
.57373 .19482 m .6114 .2055 L p .5397 .20675 L F P
0 g
s
.288 .441 .86 r
.54082 .2049 m .57373 .19482 L p .5397 .20675 L F P
0 g
s
.699 .221 .098 r
.48913 .17339 m .55086 .197 L .55351 .19492 L F
.246 .389 .747 r
.61389 .18253 m .57373 .19482 L .55086 .197 L p F P
0 g
s
.246 .389 .747 r
.55086 .197 m .53684 .19834 L p .55351 .19492 L F P
0 g
s
.246 .389 .747 r
.55351 .19492 m .61389 .18253 L .55086 .197 L F
.699 .221 .098 r
.54851 .19325 m .55351 .19492 L .55161 .19283 L F
.55711 .19209 m .5429 .18323 L p .55351 .19492 L F P
0 g
s
.246 .389 .747 r
.57761 .18576 m .61389 .18253 L p .55823 .19395 L F P
0 g
s
.246 .389 .747 r
.53684 .19834 m .55711 .19209 L p .55823 .19395 L F P
0 g
s
.246 .389 .747 r
.55711 .19209 m .57761 .18576 L p .55823 .19395 L F P
0 g
s
.444 .142 .066 r
.55917 .19253 m .57108 .20079 L .5606 .19284 L F
.024 .035 .067 r
.57761 .18576 m .55711 .19209 L p .56495 .19103 L F P
0 g
s
.444 .142 .066 r
.55711 .19209 m .57108 .20079 L p .55917 .19253 L F P
0 g
s
.024 .035 .067 r
.56495 .19103 m .55711 .19209 L .55917 .19253 L F
.444 .142 .066 r
.55711 .19209 m .55917 .19253 L .55608 .19039 L F
.699 .221 .098 r
.57108 .20079 m .55711 .19209 L p .55351 .19492 L F P
0 g
s
.024 .035 .067 r
.55711 .19209 m .53684 .19834 L p .55917 .19253 L F P
0 g
s
.699 .221 .098 r
.55086 .197 m .57108 .20079 L p .55351 .19492 L F P
0 g
s
.246 .389 .747 r
.49703 .21061 m .5481 .19917 L .5465 .20043 L F
.53448 .20684 m .49611 .21858 L .45813 .22261 L p F P
0 g
s
.246 .389 .747 r
.45813 .22261 m .49703 .21061 L .53448 .20684 L p F P
0 g
s
.024 .035 .067 r
.53684 .19834 m .50253 .21698 L p .5606 .19284 L F P
0 g
s
.024 .035 .067 r
.5606 .19284 m .56495 .19103 L .55917 .19253 L F
.5606 .19284 m .55917 .19253 L .53684 .19834 L F
.444 .142 .066 r
.57108 .20079 m .62038 .22527 L p .5606 .19284 L F P
0 g
s
.444 .142 .066 r
.55608 .19039 m .55917 .19253 L .5606 .19284 L F
.5429 .18323 m .55711 .19209 L p .55608 .19039 L F P
0 g
s
.699 .221 .098 r
.5429 .18323 m .48913 .17339 L p .54851 .19325 L F P
0 g
s
.699 .221 .098 r
.54851 .19325 m .55161 .19283 L .5429 .18323 L F
.246 .389 .747 r
.54082 .2049 m .53448 .20684 L p .55701 .19826 L F P
0 g
s
.699 .221 .098 r
.59835 .21778 m .57108 .20079 L .55086 .197 L p F P
0 g
s
.699 .221 .098 r
.5465 .20043 m .59835 .21778 L .55086 .197 L F
.54526 .2076 m .59835 .21778 L p .5465 .20043 L F P
0 g
s
.699 .221 .098 r
.54082 .2049 m .54526 .2076 L p .5465 .20043 L F P
0 g
s
.901 .274 .119 r
.53723 .20636 m .5397 .20675 L .53847 .20586 L F
.54526 .2076 m .54082 .2049 L p .5397 .20675 L F P
0 g
s
.288 .441 .86 r
.53448 .20684 m .54082 .2049 L p .5397 .20675 L F P
0 g
s
.153 .209 .43 r
.07573 .4065 m .05638 .46269 L p .06588 .45087 L F P
0 g
s
.153 .209 .43 r
.06588 .45087 m .07119 .44427 L .07221 .43579 L F
.06588 .45087 m .07221 .43579 L .07573 .4065 L F
1 .283 .117 r
.0908 .47183 m .0615 .46131 L p .04694 .52708 L F P
0 g
s
1 .292 .121 r
.10933 .40599 m .09593 .40073 L p .07119 .44427 L F P
0 g
s
1 .292 .121 r
.0908 .47183 m .10933 .40599 L p .07119 .44427 L F P
0 g
s
.153 .209 .43 r
.0902 .45361 m .10925 .39692 L p .07119 .44427 L F P
0 g
s
.153 .209 .43 r
.05638 .46269 m .0615 .46131 L p .07119 .44427 L F P
0 g
s
1 .292 .121 r
.0615 .46131 m .0908 .47183 L p .07119 .44427 L F P
0 g
s
.153 .209 .43 r
.0615 .46131 m .0902 .45361 L p .07119 .44427 L F P
0 g
s
1 .292 .121 r
.05613 .45938 m .0615 .46131 L p .07119 .44427 L F P
0 g
s
.181 .252 .514 r
.0902 .45361 m .05638 .46269 L .04694 .52708 L p F P
0 g
s
1 .283 .117 r
.0615 .46131 m .05613 .45938 L .05317 .48118 L p F P
0 g
s
1 .283 .117 r
.05317 .48118 m .04694 .52708 L p .0615 .46131 L F P
0 g
s
1 .292 .121 r
.07506 .39253 m .05613 .45938 L p .07119 .44427 L F P
0 g
s
.153 .209 .43 r
.09593 .40073 m .07573 .4065 L p .07119 .44427 L F P
0 g
s
1 .292 .121 r
.09593 .40073 m .07506 .39253 L p .07119 .44427 L F P
0 g
s
.153 .209 .43 r
.10925 .39692 m .09593 .40073 L p .07119 .44427 L F P
0 g
s
.264 .396 .788 r
.22246 .83062 m .18704 .83541 L .22932 .87179 L p F P
0 g
s
.264 .396 .788 r
.22932 .87179 m .2646 .86751 L .22246 .83062 L p F P
0 g
s
.963 .267 .107 r
.86559 .46184 m .88741 .47421 L .89712 .53826 L p F P
0 g
s
.848 .229 .091 r
.88741 .47421 m .86559 .46184 L .84368 .4039 L p F P
0 g
s
.279 .414 .818 r
.76833 .19416 m .81018 .18203 L .84319 .21907 L p F P
0 g
s
.246 .387 .762 r
.45683 .87337 m .41846 .87769 L .46072 .88622 L p F P
0 g
s
.246 .387 .762 r
.46072 .88622 m .49868 .88209 L .45683 .87337 L p F P
0 g
s
.246 .389 .747 r
.42013 .23433 m .45813 .22261 L .49611 .21858 L p F P
0 g
s
1 .305 .127 r
.10305 .32865 m .1369 .34313 L .17266 .28529 L p F P
0 g
s
1 .299 .125 r
.1369 .34313 m .10305 .32865 L .07506 .39253 L p F P
0 g
s
.411 .095 .039 r
.78836 .34156 m .76489 .32703 L .7232 .28972 L p F P
0 g
s
.411 .095 .039 r
.69873 .27438 m .7232 .28972 L .76489 .32703 L p F P
0 g
s
1 .305 .125 r
.8938 .6059 m .9152 .61602 L .89908 .68257 L p F P
0 g
s
1 .29 .118 r
.9152 .61602 m .8938 .6059 L .89712 .53826 L p F P
0 g
s
.268 .41 .812 r
.33761 .85864 m .30068 .86312 L .34432 .88604 L p F P
0 g
s
.268 .41 .812 r
.34432 .88604 m .38097 .88191 L .33761 .85864 L p F P
0 g
s
.703 .185 .074 r
.21868 .74621 m .18611 .73818 L .21884 .7842 L p F P
0 g
s
.703 .185 .074 r
.21884 .7842 m .25146 .79164 L .21868 .74621 L p F P
0 g
s
.833 .226 .091 r
.16334 .68397 m .12988 .67494 L .15248 .72989 L p F P
0 g
s
.833 .226 .091 r
.15248 .72989 m .18611 .73818 L .16334 .68397 L p F P
0 g
s
.848 .229 .091 r
.82111 .39037 m .84368 .4039 L .86559 .46184 L p F P
0 g
s
.643 .166 .063 r
.84368 .4039 m .82111 .39037 L .78836 .34156 L p F P
0 g
s
.643 .166 .063 r
.76489 .32703 m .78836 .34156 L .82111 .39037 L p F P
0 g
s
.024 .035 .067 r
.42013 .23433 m .38298 .24578 L .34652 .26472 L p F P
0 g
s
.024 .035 .067 r
.30975 .27597 m .34652 .26472 L .38298 .24578 L p F P
0 g
s
1 .283 .117 r
.04694 .52708 m .082 .53853 L .0908 .47183 L p F P
0 g
s
.111 .142 .3 r
.2054 .3308 m .17067 .34116 L .14355 .38711 L p F P
0 g
s
.111 .142 .3 r
.10925 .39692 m .14355 .38711 L .17067 .34116 L p F P
0 g
s
.498 .121 .047 r
.28306 .79884 m .25146 .79164 L .2933 .82671 L p F P
0 g
s
.498 .121 .047 r
.2933 .82671 m .32481 .83348 L .28306 .79884 L p F P
0 g
s
1 .316 .13 r
.87075 .74535 m .84859 .73728 L .87736 .67349 L p F P
0 g
s
1 .316 .13 r
.87736 .67349 m .89908 .68257 L .87075 .74535 L p F P
0 g
s
.058 .07 .135 r
.30975 .27597 m .27381 .28697 L .24093 .32019 L p F P
0 g
s
.058 .07 .135 r
.2054 .3308 m .24093 .32019 L .27381 .28697 L p F P
0 g
s
1 .305 .125 r
.89908 .68257 m .87736 .67349 L .8938 .6059 L p F P
0 g
s
.914 .252 .103 r
.1177 .61407 m .08342 .60389 L .09533 .66562 L p F P
0 g
s
.914 .252 .103 r
.09533 .66562 m .12988 .67494 L .1177 .61407 L p F P
0 g
s
1 .308 .129 r
.13922 .26981 m .17266 .28529 L .21554 .23442 L p F P
0 g
s
1 .305 .127 r
.17266 .28529 m .13922 .26981 L .10305 .32865 L p F P
0 g
s
.253 .375 .749 r
.14905 .78614 m .11439 .79145 L .15242 .84008 L p F P
0 g
s
.253 .375 .749 r
.15242 .84008 m .18704 .83541 L .14905 .78614 L p F P
0 g
s
.309 .07 .029 r
.35533 .84004 m .32481 .83348 L .37422 .85586 L p F P
0 g
s
.309 .07 .029 r
.37422 .85586 m .40451 .86218 L .35533 .84004 L p F P
0 g
s
.096 .115 .238 r
.85572 .82462 m .81243 .82954 L .83796 .79706 L p F P
0 g
s
.096 .115 .238 r
.83796 .79706 m .8805 .79188 L .85572 .82462 L p F P
0 g
s
.997 .297 .127 r
.46255 .19484 m .43366 .17784 L .37877 .19563 L p F P
0 g
s
.997 .297 .127 r
.34855 .17866 m .37877 .19563 L .43366 .17784 L p F P
0 g
s
1 .307 .13 r
.37877 .19563 m .34855 .17866 L .29587 .20922 L p F P
0 g
s
.268 .41 .812 r
.41411 .84935 m .37541 .85405 L .38041 .8568 L p F P
0 g
s
.528 .175 .077 r
.43385 .8683 m .40451 .86218 L .44896 .86895 L p F P
0 g
s
.268 .41 .812 r
.41623 .86315 m .41411 .84935 L .38041 .8568 L F
.528 .175 .077 r
.40451 .86218 m .37422 .85586 L .38041 .8568 L p F P
0 g
s
.528 .175 .077 r
.4565 .87028 m .43385 .8683 L .44896 .86895 L F
.48839 .87663 m .43385 .8683 L p .4565 .87028 L F P
0 g
s
.268 .41 .812 r
.41846 .87769 m .45683 .87337 L .44896 .86895 L p F P
0 g
s
.268 .41 .812 r
.44896 .86895 m .41411 .84935 L p .41623 .86315 L F P
0 g
s
.268 .41 .812 r
.45374 .84454 m .41411 .84935 L .44896 .86895 L p F P
0 g
s
.268 .41 .812 r
.4565 .87028 m .45374 .84454 L .44896 .86895 L F
.528 .175 .077 r
.46728 .87219 m .48839 .87663 L p .4565 .87028 L F P
0 g
s
.268 .41 .812 r
.45683 .87337 m .49611 .86894 L .45374 .84454 L p F P
0 g
s
.528 .175 .077 r
.42946 .86423 m .45941 .87054 L .44896 .86895 L p F P
0 g
s
.528 .175 .077 r
.44896 .86895 m .40451 .86218 L p .41623 .86315 L F P
0 g
s
.528 .175 .077 r
.42946 .86423 m .44896 .86895 L .41623 .86315 L F
.268 .41 .812 r
.44896 .86895 m .45683 .87337 L p .4565 .87028 L F P
0 g
s
.268 .41 .812 r
.41846 .87769 m .44896 .86895 L .41623 .86315 L F
.528 .175 .077 r
.45941 .87054 m .46728 .87219 L p .4565 .87028 L F P
0 g
s
.528 .175 .077 r
.38041 .8568 m .42946 .86423 L p .41623 .86315 L F P
0 g
s
.528 .175 .077 r
.41623 .86315 m .40451 .86218 L .38041 .8568 L F
.39848 .85772 m .42946 .86423 L .38041 .8568 L p F P
0 g
s
.528 .175 .077 r
.38041 .8568 m .37422 .85586 L p .37579 .85598 L F P
0 g
s
.268 .41 .812 r
.38041 .8568 m .37541 .85405 L p .37579 .85598 L F P
0 g
s
.528 .175 .077 r
.39848 .85772 m .38041 .8568 L .37579 .85598 L F
.268 .41 .812 r
.38097 .88191 m .41846 .87769 L .38041 .8568 L p F P
0 g
s
.268 .41 .812 r
.38097 .88191 m .38041 .8568 L .37579 .85598 L F
.33761 .85864 m .38097 .88191 L p .37579 .85598 L F P
0 g
s
.264 .396 .788 r
.31163 .83507 m .33761 .85864 L p .33628 .84352 L F P
0 g
s
.309 .07 .029 r
.32481 .83348 m .2933 .82671 L .31163 .83507 L p F P
0 g
s
.309 .07 .029 r
.37422 .85586 m .32481 .83348 L p .33628 .84352 L F P
0 g
s
.309 .07 .029 r
.36239 .85248 m .37422 .85586 L .33628 .84352 L F
.264 .396 .788 r
.37541 .85405 m .33383 .81559 L p .33628 .84352 L F P
0 g
s
.264 .396 .788 r
.33679 .84938 m .36918 .85481 L .33628 .84352 L F
.309 .07 .029 r
.36918 .85481 m .37422 .85586 L p .36239 .85248 L F P
0 g
s
.264 .396 .788 r
.36918 .85481 m .37541 .85405 L p .33628 .84352 L F P
0 g
s
.309 .07 .029 r
.36918 .85481 m .36239 .85248 L .33881 .84574 L F
.33881 .84574 m .36239 .85248 L .33628 .84352 L F
.34291 .84933 m .36918 .85481 L p .33881 .84574 L F P
0 g
s
.268 .41 .812 r
.37541 .85405 m .36918 .85481 L p .37579 .85598 L F P
0 g
s
.528 .175 .077 r
.34291 .84933 m .39848 .85772 L p .37649 .85603 L F P
0 g
s
.528 .175 .077 r
.37422 .85586 m .36918 .85481 L p .37649 .85603 L F P
0 g
s
.528 .175 .077 r
.36918 .85481 m .34291 .84933 L p .37649 .85603 L F P
0 g
s
.264 .396 .788 r
.33761 .85864 m .36918 .85481 L p .33679 .84938 L F P
0 g
s
.309 .07 .029 r
.31163 .83507 m .34291 .84933 L p .33628 .84352 L F P
0 g
s
.309 .07 .029 r
.33628 .84352 m .32481 .83348 L .31163 .83507 L F
.264 .396 .788 r
.25871 .82573 m .30068 .86312 L p .29689 .83001 L F P
0 g
s
.498 .121 .047 r
.2933 .82671 m .25146 .79164 L p .25856 .81311 L F P
0 g
s
.498 .121 .047 r
.27716 .82324 m .2933 .82671 L p .25856 .81311 L F P
0 g
s
.253 .375 .749 r
.29582 .82072 m .25804 .76946 L p .25856 .81311 L F P
0 g
s
.253 .375 .749 r
.25871 .82573 m .27716 .82324 L p .2586 .81634 L F P
0 g
s
.264 .396 .788 r
.27716 .82324 m .25871 .82573 L p .29689 .83001 L F P
0 g
s
.264 .396 .788 r
.30068 .86312 m .33761 .85864 L .31163 .83507 L p F P
0 g
s
.264 .396 .788 r
.30068 .86312 m .31163 .83507 L .29689 .83001 L F
.309 .07 .029 r
.31054 .84257 m .34291 .84933 L .2933 .82671 L p F P
0 g
s
.264 .396 .788 r
.31163 .83507 m .29582 .82072 L p .29689 .83001 L F P
0 g
s
.309 .07 .029 r
.29792 .83096 m .29689 .83001 L .27716 .82324 L F
.2933 .82671 m .27716 .82324 L p .29689 .83001 L F P
0 g
s
.309 .07 .029 r
.26074 .81971 m .31054 .84257 L p .29792 .83096 L F P
0 g
s
.309 .07 .029 r
.27716 .82324 m .26074 .81971 L p .29792 .83096 L F P
0 g
s
.253 .375 .749 r
.2586 .81634 m .27716 .82324 L .25856 .81311 L F
.27716 .82324 m .29582 .82072 L p .25856 .81311 L F P
0 g
s
.498 .121 .047 r
.25146 .79164 m .21884 .7842 L .24285 .80455 L p F P
0 g
s
.253 .375 .749 r
.24285 .80455 m .25871 .82573 L p .25856 .81311 L F P
0 g
s
.498 .121 .047 r
.24285 .80455 m .26074 .81971 L p .25856 .81311 L F P
0 g
s
.498 .121 .047 r
.25856 .81311 m .25146 .79164 L .24285 .80455 L F
.26074 .81971 m .27716 .82324 L p .25856 .81311 L F P
0 g
s
.253 .375 .749 r
.25804 .76946 m .22084 .77516 L .24285 .80455 L p F P
0 g
s
.253 .375 .749 r
.25856 .81311 m .25804 .76946 L .24285 .80455 L F
.264 .396 .788 r
.29582 .82072 m .27716 .82324 L p .29689 .83001 L F P
0 g
s
.264 .396 .788 r
.33383 .81559 m .29582 .82072 L .31163 .83507 L p F P
0 g
s
.264 .396 .788 r
.33628 .84352 m .33383 .81559 L .31163 .83507 L F
.268 .41 .812 r
.36918 .85481 m .33761 .85864 L p .37361 .85613 L F P
0 g
s
.268 .41 .812 r
.37579 .85598 m .36918 .85481 L .37361 .85613 L F
.38041 .8568 m .41846 .87769 L p .41623 .86315 L F P
0 g
s
.528 .175 .077 r
.44896 .86895 m .45941 .87054 L p .4565 .87028 L F P
0 g
s
.901 .274 .119 r
.43366 .17784 m .46255 .19484 L .51765 .19077 L p F P
0 g
s
1 .307 .13 r
.26427 .19244 m .29587 .20922 L .34855 .17866 L p F P
0 g
s
1 .309 .13 r
.29587 .20922 m .26427 .19244 L .21554 .23442 L p F P
0 g
s
.288 .434 .852 r
.81018 .18203 m .76833 .19416 L .73299 .16906 L p F P
0 g
s
.288 .434 .852 r
.69153 .18149 m .73299 .16906 L .76833 .19416 L p F P
0 g
s
.2 .284 .576 r
.04786 .57373 m .04831 .59618 L p .05169 .58816 L F P
0 g
s
.967 .27 .111 r
.082 .53853 m .04694 .52708 L p .05263 .58594 L F P
0 g
s
.967 .27 .111 r
.08342 .60389 m .082 .53853 L p .05263 .58594 L F P
0 g
s
.2 .284 .576 r
.08263 .5885 m .08103 .51864 L p .05263 .58594 L F P
0 g
s
.2 .284 .576 r
.04831 .59618 m .05351 .59501 L p .05263 .58594 L F P
0 g
s
.967 .27 .111 r
.05351 .59501 m .08342 .60389 L p .05263 .58594 L F P
0 g
s
.2 .284 .576 r
.05351 .59501 m .08263 .5885 L p .05263 .58594 L F P
0 g
s
.2 .284 .576 r
.05169 .58816 m .05263 .58594 L .04786 .57373 L F
.967 .27 .111 r
.04802 .59338 m .05351 .59501 L p .05263 .58594 L F P
0 g
s
.216 .31 .625 r
.05134 .61339 m .06059 .66598 L p .06793 .64017 L F P
0 g
s
.229 .333 .668 r
.06059 .66598 m .0831 .73235 L p .09233 .67603 L F P
0 g
s
.833 .226 .091 r
.09533 .66562 m .08138 .66185 L p .09233 .67603 L F P
0 g
s
.216 .31 .625 r
.06793 .64017 m .06972 .6339 L .05134 .61339 L F
.914 .252 .103 r
.09533 .66562 m .08342 .60389 L p .06972 .6339 L F P
0 g
s
.914 .252 .103 r
.08342 .60389 m .05351 .59501 L p .06972 .6339 L F P
0 g
s
.216 .31 .625 r
.0951 .65912 m .08263 .5885 L p .06972 .6339 L F P
0 g
s
.216 .31 .625 r
.06059 .66598 m .08138 .66185 L p .06972 .6339 L F P
0 g
s
.914 .252 .103 r
.07414 .6445 m .09533 .66562 L .06972 .6339 L F
.08138 .66185 m .09533 .66562 L p .06777 .63815 L F P
0 g
s
.216 .31 .625 r
.08138 .66185 m .0951 .65912 L p .06972 .6339 L F P
0 g
s
.914 .252 .103 r
.06777 .63815 m .07414 .6445 L .06972 .6339 L F
.05963 .65598 m .08138 .66185 L p .06777 .63815 L F P
0 g
s
.229 .333 .668 r
.0831 .73235 m .11772 .72631 L .11679 .72355 L p F P
0 g
s
.833 .226 .091 r
.12988 .67494 m .09533 .66562 L .10733 .69545 L p F P
0 g
s
.833 .226 .091 r
.12016 .71206 m .12988 .67494 L .10733 .69545 L F
.229 .333 .668 r
.13043 .6521 m .0951 .65912 L .10733 .69545 L p F P
0 g
s
.229 .333 .668 r
.11106 .70653 m .11772 .72631 L p .11969 .71479 L F P
0 g
s
.242 .354 .709 r
.11772 .72631 m .14905 .78614 L p .15177 .74255 L F P
0 g
s
.703 .185 .074 r
.15248 .72989 m .12957 .72424 L p .15177 .74255 L F P
0 g
s
.833 .226 .091 r
.15248 .72989 m .12988 .67494 L p .12016 .71206 L F P
0 g
s
.833 .226 .091 r
.12957 .72424 m .15248 .72989 L p .12016 .71206 L F P
0 g
s
.703 .185 .074 r
.18611 .73818 m .15248 .72989 L .17447 .76128 L p F P
0 g
s
.703 .185 .074 r
.1853 .77022 m .18611 .73818 L .17447 .76128 L F
.242 .354 .709 r
.18946 .71377 m .15316 .72011 L .17447 .76128 L p F P
0 g
s
.242 .354 .709 r
.17447 .76128 m .18452 .78072 L p .1853 .77022 L F P
0 g
s
.703 .185 .074 r
.21884 .7842 m .18611 .73818 L p .1853 .77022 L F P
0 g
s
.242 .354 .709 r
.1853 .77022 m .18946 .71377 L .17447 .76128 L F
.703 .185 .074 r
.19591 .77897 m .21884 .7842 L p .1853 .77022 L F P
0 g
s
.242 .354 .709 r
.22084 .77516 m .18946 .71377 L p .1853 .77022 L F P
0 g
s
.242 .354 .709 r
.18452 .78072 m .19591 .77897 L p .18514 .7724 L F P
0 g
s
.253 .375 .749 r
.18452 .78072 m .22246 .83062 L p .22136 .79284 L F P
0 g
s
.498 .121 .047 r
.21884 .7842 m .19591 .77897 L p .22136 .79284 L F P
0 g
s
.253 .375 .749 r
.22246 .83062 m .25871 .82573 L .24285 .80455 L p F P
0 g
s
.253 .375 .749 r
.22246 .83062 m .24285 .80455 L .22136 .79284 L F
.498 .121 .047 r
.22708 .81248 m .26074 .81971 L .24285 .80455 L p F P
0 g
s
.498 .121 .047 r
.24285 .80455 m .21884 .7842 L p .22136 .79284 L F P
0 g
s
.498 .121 .047 r
.22708 .81248 m .24285 .80455 L .22136 .79284 L F
.253 .375 .749 r
.24285 .80455 m .22084 .77516 L p .22136 .79284 L F P
0 g
s
.253 .375 .749 r
.22084 .77516 m .19591 .77897 L p .22136 .79284 L F P
0 g
s
.253 .375 .749 r
.19591 .77897 m .18452 .78072 L p .22136 .79284 L F P
0 g
s
.498 .121 .047 r
.22195 .79486 m .22136 .79284 L .19591 .77897 L F
.18514 .77652 m .22708 .81248 L p .22195 .79486 L F P
0 g
s
.498 .121 .047 r
.19591 .77897 m .18514 .77652 L p .22195 .79486 L F P
0 g
s
.242 .354 .709 r
.18514 .7724 m .19591 .77897 L .1853 .77022 L F
.19591 .77897 m .22084 .77516 L p .1853 .77022 L F P
0 g
s
.242 .354 .709 r
.14905 .78614 m .18452 .78072 L .17447 .76128 L p F P
0 g
s
.242 .354 .709 r
.14905 .78614 m .17447 .76128 L .15177 .74255 L F
.703 .185 .074 r
.1503 .76857 m .18514 .77652 L .17447 .76128 L p F P
0 g
s
.703 .185 .074 r
.17447 .76128 m .15248 .72989 L p .15177 .74255 L F P
0 g
s
.703 .185 .074 r
.1503 .76857 m .17447 .76128 L .15177 .74255 L F
.18514 .77652 m .19591 .77897 L p .1853 .77022 L F P
0 g
s
.703 .185 .074 r
.17447 .76128 m .18514 .77652 L p .1853 .77022 L F P
0 g
s
.242 .354 .709 r
.17447 .76128 m .15316 .72011 L p .15177 .74255 L F P
0 g
s
.242 .354 .709 r
.15316 .72011 m .12957 .72424 L p .15177 .74255 L F P
0 g
s
.242 .354 .709 r
.12957 .72424 m .11772 .72631 L p .15177 .74255 L F P
0 g
s
.703 .185 .074 r
.15161 .74532 m .15177 .74255 L .12957 .72424 L F
.229 .333 .668 r
.11772 .72631 m .15316 .72011 L .13043 .6521 L p F P
0 g
s
.703 .185 .074 r
.11774 .72132 m .1503 .76857 L p .15161 .74532 L F P
0 g
s
.703 .185 .074 r
.12957 .72424 m .11774 .72132 L p .15161 .74532 L F P
0 g
s
.229 .333 .668 r
.10733 .69545 m .11106 .70653 L p .12016 .71206 L F P
0 g
s
.229 .333 .668 r
.11969 .71479 m .12016 .71206 L .11106 .70653 L F
.12016 .71206 m .13043 .6521 L .10733 .69545 L F
.833 .226 .091 r
.11774 .72132 m .12957 .72424 L p .12016 .71206 L F P
0 g
s
.833 .226 .091 r
.10733 .69545 m .11774 .72132 L p .12016 .71206 L F P
0 g
s
.229 .333 .668 r
.11679 .72355 m .10733 .69545 L p .0917 .67984 L F P
0 g
s
.229 .333 .668 r
.0917 .67984 m .10733 .69545 L .09233 .67603 L F
.0831 .73235 m .11679 .72355 L .0917 .67984 L F
.833 .226 .091 r
.08182 .71246 m .11774 .72132 L .09533 .66562 L p F P
0 g
s
.229 .333 .668 r
.10733 .69545 m .0951 .65912 L p .09233 .67603 L F P
0 g
s
.229 .333 .668 r
.0951 .65912 m .08138 .66185 L p .09233 .67603 L F P
0 g
s
.229 .333 .668 r
.08138 .66185 m .06059 .66598 L p .09233 .67603 L F P
0 g
s
.833 .226 .091 r
.09164 .67841 m .09233 .67603 L .08138 .66185 L F
.05963 .65598 m .08182 .71246 L p .09164 .67841 L F P
0 g
s
.833 .226 .091 r
.08138 .66185 m .05963 .65598 L p .09164 .67841 L F P
0 g
s
.216 .31 .625 r
.04831 .59618 m .05134 .61339 L p .06972 .6339 L F P
0 g
s
.216 .31 .625 r
.08263 .5885 m .05351 .59501 L p .06972 .6339 L F P
0 g
s
.216 .31 .625 r
.05351 .59501 m .04831 .59618 L p .06972 .6339 L F P
0 g
s
.914 .252 .103 r
.06598 .64208 m .06972 .6339 L .05351 .59501 L F
.04802 .59338 m .05963 .65598 L p .06598 .64208 L F P
0 g
s
.914 .252 .103 r
.05351 .59501 m .04802 .59338 L p .06598 .64208 L F P
0 g
s
.2 .284 .576 r
.04694 .52708 m .04786 .57373 L p .05263 .58594 L F P
0 g
s
.2 .284 .576 r
.08103 .51864 m .04694 .52708 L p .05263 .58594 L F P
0 g
s
.967 .27 .111 r
.04694 .52708 m .04802 .59338 L p .05263 .58594 L F P
0 g
s
.963 .267 .107 r
.89712 .53826 m .87523 .52679 L .86559 .46184 L p F P
0 g
s
1 .29 .118 r
.87523 .52679 m .89712 .53826 L .8938 .6059 L p F P
0 g
s
.288 .441 .86 r
.69153 .18149 m .65101 .19363 L .61389 .18253 L p F P
0 g
s
.288 .441 .86 r
.57373 .19482 m .61389 .18253 L .65101 .19363 L p F P
0 g
s
.153 .209 .43 r
.14355 .38711 m .10925 .39692 L .0902 .45361 L p F P
0 g
s
.264 .396 .788 r
.25871 .82573 m .22246 .83062 L .2646 .86751 L p F P
0 g
s
.264 .396 .788 r
.2646 .86751 m .30068 .86312 L .25871 .82573 L p F P
0 g
s
.851 .265 .114 r
.51646 .88254 m .48839 .87663 L .54622 .87024 L p F P
0 g
s
.851 .265 .114 r
.54622 .87024 m .57382 .87635 L .51646 .88254 L p F P
0 g
s
.699 .221 .098 r
.62475 .23423 m .59835 .21778 L .54526 .2076 L p F P
0 g
s
.246 .387 .762 r
.49611 .86894 m .45683 .87337 L .49868 .88209 L p F P
0 g
s
.246 .387 .762 r
.49868 .88209 m .53752 .87788 L .49611 .86894 L p F P
0 g
s
1 .309 .13 r
.1825 .21799 m .21554 .23442 L .26427 .19244 L p F P
0 g
s
1 .308 .129 r
.21554 .23442 m .1825 .21799 L .13922 .26981 L p F P
0 g
s
.024 .035 .067 r
.45813 .22261 m .42013 .23433 L .38415 .2532 L p F P
0 g
s
.024 .035 .067 r
.34652 .26472 m .38415 .2532 L .42013 .23433 L p F P
0 g
s
.444 .142 .066 r
.69873 .27438 m .67346 .25855 L .62475 .23423 L p F P
0 g
s
.444 .142 .066 r
.59835 .21778 m .62475 .23423 L .67346 .25855 L p F P
0 g
s
.111 .142 .3 r
.24093 .32019 m .2054 .3308 L .17864 .37708 L p F P
0 g
s
.111 .142 .3 r
.14355 .38711 m .17864 .37708 L .2054 .3308 L p F P
0 g
s
1 .323 .134 r
.80912 .79377 m .78571 .7864 L .82571 .72896 L p F P
0 g
s
1 .323 .134 r
.82571 .72896 m .84859 .73728 L .80912 .79377 L p F P
0 g
s
.058 .07 .135 r
.34652 .26472 m .30975 .27597 L .2773 .30933 L p F P
0 g
s
.058 .07 .135 r
.24093 .32019 m .2773 .30933 L .30975 .27597 L p F P
0 g
s
.963 .267 .107 r
.84306 .44907 m .86559 .46184 L .87523 .52679 L p F P
0 g
s
.848 .229 .091 r
.86559 .46184 m .84306 .44907 L .82111 .39037 L p F P
0 g
s
.411 .095 .039 r
.76489 .32703 m .74066 .31203 L .69873 .27438 L p F P
0 g
s
.411 .095 .039 r
.67346 .25855 m .69873 .27438 L .74066 .31203 L p F P
0 g
s
1 .305 .125 r
.8717 .59546 m .8938 .6059 L .87736 .67349 L p F P
0 g
s
1 .29 .118 r
.8938 .6059 m .8717 .59546 L .87523 .52679 L p F P
0 g
s
.253 .375 .749 r
.18452 .78072 m .14905 .78614 L .18704 .83541 L p F P
0 g
s
.253 .375 .749 r
.18704 .83541 m .22246 .83062 L .18452 .78072 L p F P
0 g
s
.848 .229 .091 r
.79779 .3764 m .82111 .39037 L .84306 .44907 L p F P
0 g
s
.643 .166 .063 r
.82111 .39037 m .79779 .3764 L .76489 .32703 L p F P
0 g
s
.643 .166 .063 r
.74066 .31203 m .76489 .32703 L .79779 .3764 L p F P
0 g
s
.096 .115 .238 r
.90004 .81958 m .85572 .82462 L .8805 .79188 L p F P
0 g
s
.096 .115 .238 r
.8805 .79188 m .92402 .78659 L .90004 .81958 L p F P
0 g
s
1 .316 .13 r
.84859 .73728 m .82571 .72896 L .85492 .66412 L p F P
0 g
s
1 .316 .13 r
.85492 .66412 m .87736 .67349 L .84859 .73728 L p F P
0 g
s
.242 .354 .709 r
.11772 .72631 m .0831 .73235 L .11439 .79145 L p F P
0 g
s
.242 .354 .709 r
.11439 .79145 m .14905 .78614 L .11772 .72631 L p F P
0 g
s
.06 .071 .137 r
.78145 .84955 m .73844 .85425 L .77014 .83435 L p F P
0 g
s
.06 .071 .137 r
.77014 .83435 m .81243 .82954 L .78145 .84955 L p F P
0 g
s
1 .305 .125 r
.87736 .67349 m .85492 .66412 L .8717 .59546 L p F P
0 g
s
.288 .434 .852 r
.73299 .16906 m .77544 .15634 L .81018 .18203 L p F P
0 g
s
.024 .035 .067 r
.65959 .86462 m .61794 .86914 L .65538 .86331 L p F P
0 g
s
.288 .441 .86 r
.73299 .16906 m .69153 .18149 L .65501 .16994 L p F P
0 g
s
.288 .441 .86 r
.61389 .18253 m .65501 .16994 L .69153 .18149 L p F P
0 g
s
1 .327 .136 r
.73726 .8334 m .71249 .82663 L .76152 .77879 L p F P
0 g
s
1 .327 .136 r
.76152 .77879 m .78571 .7864 L .73726 .8334 L p F P
0 g
s
.153 .209 .43 r
.17864 .37708 m .14355 .38711 L .12481 .44431 L p F P
0 g
s
.153 .209 .43 r
.0902 .45361 m .12481 .44431 L .14355 .38711 L p F P
0 g
s
1 .31 .131 r
.54622 .87024 m .52544 .86564 L p .57661 .8419 L F P
0 g
s
.268 .41 .812 r
.49611 .86894 m .52544 .86564 L p .49435 .83961 L F P
0 g
s
.268 .41 .812 r
.5286 .85985 m .49435 .83961 L p .52544 .86564 L F P
0 g
s
1 .31 .131 r
.52544 .86564 m .5177 .86393 L .5286 .85985 L p F P
0 g
s
1 .31 .131 r
.5286 .85985 m .57661 .8419 L p .52544 .86564 L F P
0 g
s
.268 .41 .812 r
.52544 .86564 m .53633 .86442 L .5286 .85985 L p F P
0 g
s
.246 .387 .762 r
.53633 .86442 m .49611 .86894 L .53752 .87788 L p F P
0 g
s
1 .31 .131 r
.57661 .8419 m .60458 .84868 L .54622 .87024 L p F P
0 g
s
.246 .387 .762 r
.53752 .87788 m .57726 .87356 L .53633 .86442 L p F P
0 g
s
.997 .297 .127 r
.43366 .17784 m .40383 .16028 L .34855 .17866 L p F P
0 g
s
.997 .297 .127 r
.31735 .16113 m .34855 .17866 L .40383 .16028 L p F P
0 g
s
1 .307 .13 r
.34855 .17866 m .31735 .16113 L .26427 .19244 L p F P
0 g
s
.901 .274 .119 r
.51765 .19077 m .48913 .17339 L .43366 .17784 L p F P
0 g
s
.901 .274 .119 r
.40383 .16028 m .43366 .17784 L .48913 .17339 L p F P
0 g
s
.024 .035 .067 r
.49703 .21061 m .45813 .22261 L .42267 .24142 L p F P
0 g
s
.024 .035 .067 r
.38415 .2532 m .42267 .24142 L .45813 .22261 L p F P
0 g
s
1 .307 .13 r
.23164 .17511 m .26427 .19244 L .31735 .16113 L p F P
0 g
s
1 .309 .13 r
.26427 .19244 m .23164 .17511 L .1825 .21799 L p F P
0 g
s
.181 .252 .514 r
.04694 .52708 m .08103 .51864 L .0902 .45361 L p F P
0 g
s
.111 .142 .3 r
.2773 .30933 m .24093 .32019 L .21456 .36681 L p F P
0 g
s
.111 .142 .3 r
.17864 .37708 m .21456 .36681 L .24093 .32019 L p F P
0 g
s
.963 .267 .107 r
.87523 .52679 m .85262 .51495 L .84306 .44907 L p F P
0 g
s
1 .29 .118 r
.85262 .51495 m .87523 .52679 L .8717 .59546 L p F P
0 g
s
.181 .252 .514 r
.12481 .44431 m .0902 .45361 L .08103 .51864 L p F P
0 g
s
1 .325 .136 r
.65782 .86157 m .63164 .85523 L .6869 .81963 L p F P
0 g
s
1 .325 .136 r
.6869 .81963 m .71249 .82663 L .65782 .86157 L p F P
0 g
s
.058 .07 .135 r
.38415 .2532 m .34652 .26472 L .31453 .29822 L p F P
0 g
s
.058 .07 .135 r
.2773 .30933 m .31453 .29822 L .34652 .26472 L p F P
0 g
s
.268 .41 .812 r
.49435 .83961 m .45374 .84454 L .49611 .86894 L p F P
0 g
s
.851 .265 .114 r
.48839 .87663 m .45941 .87054 L .5177 .86393 L p F P
0 g
s
.851 .265 .114 r
.5177 .86393 m .54622 .87024 L .48839 .87663 L p F P
0 g
s
.444 .142 .066 r
.67346 .25855 m .64736 .24219 L .59835 .21778 L p F P
0 g
s
.444 .142 .066 r
.57108 .20079 m .59835 .21778 L .64736 .24219 L p F P
0 g
s
1 .323 .134 r
.78571 .7864 m .76152 .77879 L .80207 .72036 L p F P
0 g
s
1 .323 .134 r
.80207 .72036 m .82571 .72896 L .78571 .7864 L p F P
0 g
s
.06 .071 .137 r
.8255 .84475 m .78145 .84955 L .81243 .82954 L p F P
0 g
s
.06 .071 .137 r
.81243 .82954 m .85572 .82462 L .8255 .84475 L p F P
0 g
s
.963 .267 .107 r
.81979 .43587 m .84306 .44907 L .85262 .51495 L p F P
0 g
s
.848 .229 .091 r
.84306 .44907 m .81979 .43587 L .79779 .3764 L p F P
0 g
s
.411 .095 .039 r
.74066 .31203 m .71563 .29652 L .67346 .25855 L p F P
0 g
s
.411 .095 .039 r
.64736 .24219 m .67346 .25855 L .71563 .29652 L p F P
0 g
s
1 .305 .125 r
.84887 .58467 m .8717 .59546 L .85492 .66412 L p F P
0 g
s
1 .29 .118 r
.8717 .59546 m .84887 .58467 L .85262 .51495 L p F P
0 g
s
.024 .035 .067 r
.70226 .85998 m .65959 .86462 L .69643 .85883 L p F P
0 g
s
.024 .035 .067 r
.69643 .85883 m .73844 .85425 L .70226 .85998 L p F P
0 g
s
.288 .441 .86 r
.77544 .15634 m .73299 .16906 L .6971 .15706 L p F P
0 g
s
.288 .441 .86 r
.65501 .16994 m .6971 .15706 L .73299 .16906 L p F P
0 g
s
.153 .209 .43 r
.21456 .36681 m .17864 .37708 L .16024 .43479 L p F P
0 g
s
.153 .209 .43 r
.12481 .44431 m .16024 .43479 L .17864 .37708 L p F P
0 g
s
.848 .229 .091 r
.77371 .36196 m .79779 .3764 L .81979 .43587 L p F P
0 g
s
.643 .166 .063 r
.79779 .3764 m .77371 .36196 L .74066 .31203 L p F P
0 g
s
.643 .166 .063 r
.71563 .29652 m .74066 .31203 L .77371 .36196 L p F P
0 g
s
.246 .387 .762 r
.57752 .85978 m .53633 .86442 L .57726 .87356 L p F P
0 g
s
.246 .387 .762 r
.57726 .87356 m .61794 .86914 L .57752 .85978 L p F P
0 g
s
.246 .389 .747 r
.65501 .16994 m .61389 .18253 L .57761 .18576 L p F P
0 g
s
1 .316 .13 r
.82571 .72896 m .80207 .72036 L .83174 .65443 L p F P
0 g
s
1 .316 .13 r
.83174 .65443 m .85492 .66412 L .82571 .72896 L p F P
0 g
s
1 .305 .125 r
.85492 .66412 m .83174 .65443 L .84887 .58467 L p F P
0 g
s
.024 .035 .067 r
.53684 .19834 m .49703 .21061 L .46212 .22935 L p F P
0 g
s
.024 .035 .067 r
.42267 .24142 m .46212 .22935 L .49703 .21061 L p F P
0 g
s
.181 .252 .514 r
.08103 .51864 m .11593 .51001 L .12481 .44431 L p F P
0 g
s
.2 .284 .576 r
.11593 .51001 m .08103 .51864 L .08263 .5885 L p F P
0 g
s
.111 .142 .3 r
.31453 .29822 m .2773 .30933 L .25134 .35629 L p F P
0 g
s
.111 .142 .3 r
.21456 .36681 m .25134 .35629 L .2773 .30933 L p F P
0 g
s
.181 .252 .514 r
.16024 .43479 m .12481 .44431 L .11593 .51001 L p F P
0 g
s
1 .327 .136 r
.71249 .82663 m .6869 .81963 L .73652 .77092 L p F P
0 g
s
1 .327 .136 r
.73652 .77092 m .76152 .77879 L .71249 .82663 L p F P
0 g
s
.058 .07 .135 r
.42267 .24142 m .38415 .2532 L .35265 .28684 L p F P
0 g
s
.058 .07 .135 r
.31453 .29822 m .35265 .28684 L .38415 .2532 L p F P
0 g
s
.997 .297 .127 r
.40383 .16028 m .373 .14214 L .31735 .16113 L p F P
0 g
s
.997 .297 .127 r
.2851 .14302 m .31735 .16113 L .373 .14214 L p F P
0 g
s
1 .307 .13 r
.31735 .16113 m .2851 .14302 L .23164 .17511 L p F P
0 g
s
.901 .274 .119 r
.48913 .17339 m .45966 .15543 L .40383 .16028 L p F P
0 g
s
.901 .274 .119 r
.373 .14214 m .40383 .16028 L .45966 .15543 L p F P
0 g
s
.963 .267 .107 r
.85262 .51495 m .82925 .50272 L .81979 .43587 L p F P
0 g
s
1 .29 .118 r
.82925 .50272 m .85262 .51495 L .84887 .58467 L p F P
0 g
s
1 .325 .136 r
.63164 .85523 m .60458 .84868 L .66044 .81239 L p F P
0 g
s
1 .325 .136 r
.66044 .81239 m .6869 .81963 L .63164 .85523 L p F P
0 g
s
.06 .071 .137 r
.87063 .83982 m .8255 .84475 L .85572 .82462 L p F P
0 g
s
.06 .071 .137 r
.85572 .82462 m .90004 .81958 L .87063 .83982 L p F P
0 g
s
.851 .265 .114 r
.45941 .87054 m .42946 .86423 L .4882 .8574 L p F P
0 g
s
.851 .265 .114 r
.4882 .8574 m .5177 .86393 L .45941 .87054 L p F P
0 g
s
.699 .221 .098 r
.45966 .15543 m .48913 .17339 L .5429 .18323 L p F P
0 g
s
.2 .284 .576 r
.08263 .5885 m .11777 .58065 L .11593 .51001 L p F P
0 g
s
.216 .31 .625 r
.11777 .58065 m .08263 .5885 L .0951 .65912 L p F P
0 g
s
.216 .31 .625 r
.0951 .65912 m .13043 .6521 L .11777 .58065 L p F P
0 g
s
.024 .035 .067 r
.74596 .85523 m .70226 .85998 L .73844 .85425 L p F P
0 g
s
.024 .035 .067 r
.73844 .85425 m .78145 .84955 L .74596 .85523 L p F P
0 g
s
.288 .441 .86 r
.6971 .15706 m .74022 .14386 L .77544 .15634 L p F P
0 g
s
.153 .209 .43 r
.25134 .35629 m .21456 .36681 L .19653 .42505 L p F P
0 g
s
.153 .209 .43 r
.16024 .43479 m .19653 .42505 L .21456 .36681 L p F P
0 g
s
.264 .396 .788 r
.37276 .81033 m .33383 .81559 L .37541 .85405 L p F P
0 g
s
.264 .396 .788 r
.37541 .85405 m .41411 .84935 L .37276 .81033 L p F P
0 g
s
.444 .142 .066 r
.64736 .24219 m .62038 .22527 L .57108 .20079 L p F P
0 g
s
.246 .387 .762 r
.61972 .85502 m .57752 .85978 L .61794 .86914 L p F P
0 g
s
.246 .387 .762 r
.61794 .86914 m .65959 .86462 L .61972 .85502 L p F P
0 g
s
.246 .389 .747 r
.6971 .15706 m .65501 .16994 L .61937 .17289 L p F P
0 g
s
.246 .389 .747 r
.57761 .18576 m .61937 .17289 L .65501 .16994 L p F P
0 g
s
1 .323 .134 r
.76152 .77879 m .73652 .77092 L .77763 .71147 L p F P
0 g
s
1 .323 .134 r
.77763 .71147 m .80207 .72036 L .76152 .77879 L p F P
0 g
s
.963 .267 .107 r
.79573 .42223 m .81979 .43587 L .82925 .50272 L p F P
0 g
s
.848 .229 .091 r
.81979 .43587 m .79573 .42223 L .77371 .36196 L p F P
0 g
s
.024 .035 .067 r
.46212 .22935 m .50253 .21698 L .53684 .19834 L p F P
0 g
s
.181 .252 .514 r
.11593 .51001 m .15167 .50117 L .16024 .43479 L p F P
0 g
s
.2 .284 .576 r
.15167 .50117 m .11593 .51001 L .11777 .58065 L p F P
0 g
s
.111 .142 .3 r
.35265 .28684 m .31453 .29822 L .28901 .34552 L p F P
0 g
s
.111 .142 .3 r
.25134 .35629 m .28901 .34552 L .31453 .29822 L p F P
0 g
s
.411 .095 .039 r
.71563 .29652 m .68975 .2805 L .64736 .24219 L p F P
0 g
s
.411 .095 .039 r
.62038 .22527 m .64736 .24219 L .68975 .2805 L p F P
0 g
s
1 .305 .125 r
.82527 .57352 m .84887 .58467 L .83174 .65443 L p F P
0 g
s
1 .29 .118 r
.84887 .58467 m .82527 .57352 L .82925 .50272 L p F P
0 g
s
.181 .252 .514 r
.19653 .42505 m .16024 .43479 L .15167 .50117 L p F P
0 g
s
.703 .185 .074 r
.11774 .72132 m .08182 .71246 L .11426 .76036 L p F P
0 g
s
.703 .185 .074 r
.11426 .76036 m .1503 .76857 L .11774 .72132 L p F P
0 g
s
.058 .07 .135 r
.46212 .22935 m .42267 .24142 L .39169 .27519 L p F P
0 g
s
.058 .07 .135 r
.35265 .28684 m .39169 .27519 L .42267 .24142 L p F P
0 g
s
.848 .229 .091 r
.74881 .34704 m .77371 .36196 L .79573 .42223 L p F P
0 g
s
.643 .166 .063 r
.77371 .36196 m .74881 .34704 L .71563 .29652 L p F P
0 g
s
.643 .166 .063 r
.68975 .2805 m .71563 .29652 L .74881 .34704 L p F P
0 g
s
.498 .121 .047 r
.18514 .77652 m .1503 .76857 L .19226 .80499 L p F P
0 g
s
.498 .121 .047 r
.19226 .80499 m .22708 .81248 L .18514 .77652 L p F P
0 g
s
1 .316 .13 r
.80207 .72036 m .77763 .71147 L .80778 .64442 L p F P
0 g
s
1 .316 .13 r
.80778 .64442 m .83174 .65443 L .80207 .72036 L p F P
0 g
s
.253 .375 .749 r
.29614 .76363 m .25804 .76946 L .29582 .82072 L p F P
0 g
s
.253 .375 .749 r
.29582 .82072 m .33383 .81559 L .29614 .76363 L p F P
0 g
s
.229 .333 .668 r
.16661 .64491 m .13043 .6521 L .15316 .72011 L p F P
0 g
s
.229 .333 .668 r
.15316 .72011 m .18946 .71377 L .16661 .64491 L p F P
0 g
s
1 .305 .125 r
.83174 .65443 m .80778 .64442 L .82527 .57352 L p F P
0 g
s
.309 .07 .029 r
.26074 .81971 m .22708 .81248 L .27706 .83559 L p F P
0 g
s
.309 .07 .029 r
.27706 .83559 m .31054 .84257 L .26074 .81971 L p F P
0 g
s
.242 .354 .709 r
.22664 .70728 m .18946 .71377 L .22084 .77516 L p F P
0 g
s
.242 .354 .709 r
.22084 .77516 m .25804 .76946 L .22664 .70728 L p F P
0 g
s
1 .327 .136 r
.6869 .81963 m .66044 .81239 L .71067 .76279 L p F P
0 g
s
1 .327 .136 r
.71067 .76279 m .73652 .77092 L .6869 .81963 L p F P
0 g
s
.2 .284 .576 r
.11777 .58065 m .15377 .5726 L .15167 .50117 L p F P
0 g
s
.216 .31 .625 r
.15377 .5726 m .11777 .58065 L .13043 .6521 L p F P
0 g
s
.216 .31 .625 r
.13043 .6521 m .16661 .64491 L .15377 .5726 L p F P
0 g
s
.024 .035 .067 r
.79076 .85037 m .74596 .85523 L .78145 .84955 L p F P
0 g
s
.024 .035 .067 r
.78145 .84955 m .8255 .84475 L .79076 .85037 L p F P
0 g
s
.997 .297 .127 r
.373 .14214 m .34113 .12338 L .2851 .14302 L p F P
0 g
s
.153 .209 .43 r
.28901 .34552 m .25134 .35629 L .23369 .41507 L p F P
0 g
s
.153 .209 .43 r
.19653 .42505 m .23369 .41507 L .25134 .35629 L p F P
0 g
s
.264 .396 .788 r
.41264 .80495 m .37276 .81033 L .41411 .84935 L p F P
0 g
s
.264 .396 .788 r
.41411 .84935 m .45374 .84454 L .41264 .80495 L p F P
0 g
s
.528 .175 .077 r
.34291 .84933 m .31054 .84257 L .36644 .85098 L p F P
0 g
s
.528 .175 .077 r
.36644 .85098 m .39848 .85772 L .34291 .84933 L p F P
0 g
s
.901 .274 .119 r
.45966 .15543 m .42918 .13685 L .373 .14214 L p F P
0 g
s
.901 .274 .119 r
.34113 .12338 m .373 .14214 L .42918 .13685 L p F P
0 g
s
.246 .387 .762 r
.66297 .85015 m .61972 .85502 L .65959 .86462 L p F P
0 g
s
.246 .387 .762 r
.65959 .86462 m .70226 .85998 L .66297 .85015 L p F P
0 g
s
.246 .389 .747 r
.74022 .14386 m .6971 .15706 L .66216 .15969 L p F P
0 g
s
.246 .389 .747 r
.61937 .17289 m .66216 .15969 L .6971 .15706 L p F P
0 g
s
.963 .267 .107 r
.82925 .50272 m .80509 .49006 L .79573 .42223 L p F P
0 g
s
1 .29 .118 r
.80509 .49006 m .82925 .50272 L .82527 .57352 L p F P
0 g
s
1 .325 .136 r
.60458 .84868 m .57661 .8419 L .63307 .8049 L p F P
0 g
s
1 .325 .136 r
.63307 .8049 m .66044 .81239 L .60458 .84868 L p F P
0 g
s
.268 .41 .812 r
.53596 .83456 m .49435 .83961 L .5286 .85985 L p F P
0 g
s
.268 .41 .812 r
.5361 .84609 m .53596 .83456 L .5286 .85985 L F
1 .31 .131 r
.54079 .83749 m .54766 .83489 L p .5361 .84609 L F P
0 g
s
1 .31 .131 r
.54766 .83489 m .57661 .8419 L .5286 .85985 L p F P
0 g
s
1 .31 .131 r
.54766 .83489 m .5286 .85985 L .5361 .84609 L F
.268 .41 .812 r
.53633 .86442 m .57752 .85978 L .54079 .83749 L p F P
0 g
s
.268 .41 .812 r
.54079 .83749 m .53596 .83456 L p .5361 .84609 L F P
0 g
s
.268 .41 .812 r
.53633 .86442 m .54079 .83749 L .5361 .84609 L F
1 .31 .131 r
.5286 .85985 m .5177 .86393 L p .5361 .84609 L F P
0 g
s
1 .31 .131 r
.5177 .86393 m .4882 .8574 L .54079 .83749 L p F P
0 g
s
1 .31 .131 r
.5361 .84609 m .5177 .86393 L .54079 .83749 L F
.268 .41 .812 r
.5286 .85985 m .53633 .86442 L p .5361 .84609 L F P
0 g
s
.851 .265 .114 r
.42946 .86423 m .39848 .85772 L .45768 .85065 L p F P
0 g
s
.851 .265 .114 r
.45768 .85065 m .4882 .8574 L .42946 .86423 L p F P
0 g
s
.699 .221 .098 r
.5429 .18323 m .51375 .16508 L .45966 .15543 L p F P
0 g
s
.699 .221 .098 r
.42918 .13685 m .45966 .15543 L .51375 .16508 L p F P
0 g
s
.444 .142 .066 r
.62038 .22527 m .59248 .20778 L .5636 .19348 L p F P
0 g
s
.444 .142 .066 r
.5606 .19284 m .62038 .22527 L .5636 .19348 L F
.024 .035 .067 r
.50253 .21698 m .54393 .20432 L .5636 .19348 L p F P
0 g
s
.024 .035 .067 r
.5636 .19348 m .57761 .18576 L p .5606 .19284 L F P
0 g
s
.024 .035 .067 r
.50253 .21698 m .5636 .19348 L .5606 .19284 L F
.444 .142 .066 r
.51375 .16508 m .5429 .18323 L .5636 .19348 L p F P
0 g
s
.444 .142 .066 r
.5636 .19348 m .59248 .20778 L p .56777 .19438 L F P
0 g
s
.024 .035 .067 r
.61937 .17289 m .57761 .18576 L .5636 .19348 L p F P
0 g
s
.024 .035 .067 r
.56777 .19438 m .61937 .17289 L .5636 .19348 L F
.444 .142 .066 r
.51375 .16508 m .5636 .19348 L .56777 .19438 L F
.5636 .19348 m .5429 .18323 L p .5606 .19284 L F P
0 g
s
.024 .035 .067 r
.5636 .19348 m .54393 .20432 L p .56777 .19438 L F P
0 g
s
.181 .252 .514 r
.15167 .50117 m .18827 .49212 L .19653 .42505 L p F P
0 g
s
.2 .284 .576 r
.18827 .49212 m .15167 .50117 L .15377 .5726 L p F P
0 g
s
.111 .142 .3 r
.39169 .27519 m .35265 .28684 L .32759 .33449 L p F P
0 g
s
.111 .142 .3 r
.28901 .34552 m .32759 .33449 L .35265 .28684 L p F P
0 g
s
.181 .252 .514 r
.23369 .41507 m .19653 .42505 L .18827 .49212 L p F P
0 g
s
.058 .07 .135 r
.50253 .21698 m .46212 .22935 L .43169 .26325 L p F P
0 g
s
.058 .07 .135 r
.39169 .27519 m .43169 .26325 L .46212 .22935 L p F P
0 g
s
1 .323 .134 r
.73652 .77092 m .71067 .76279 L .75235 .70227 L p F P
0 g
s
1 .323 .134 r
.75235 .70227 m .77763 .71147 L .73652 .77092 L p F P
0 g
s
.253 .375 .749 r
.33519 .75766 m .29614 .76363 L .33383 .81559 L p F P
0 g
s
.253 .375 .749 r
.33383 .81559 m .37276 .81033 L .33519 .75766 L p F P
0 g
s
.229 .333 .668 r
.20367 .63755 m .16661 .64491 L .18946 .71377 L p F P
0 g
s
.229 .333 .668 r
.18946 .71377 m .22664 .70728 L .20367 .63755 L p F P
0 g
s
.963 .267 .107 r
.77085 .40813 m .79573 .42223 L .80509 .49006 L p F P
0 g
s
.848 .229 .091 r
.79573 .42223 m .77085 .40813 L .74881 .34704 L p F P
0 g
s
.411 .095 .039 r
.68975 .2805 m .66299 .26392 L .62038 .22527 L p F P
0 g
s
.411 .095 .039 r
.59248 .20778 m .62038 .22527 L .66299 .26392 L p F P
0 g
s
1 .305 .125 r
.80087 .56198 m .82527 .57352 L .80778 .64442 L p F P
0 g
s
1 .29 .118 r
.82527 .57352 m .80087 .56198 L .80509 .49006 L p F P
0 g
s
.242 .354 .709 r
.26473 .70062 m .22664 .70728 L .25804 .76946 L p F P
0 g
s
.242 .354 .709 r
.25804 .76946 m .29614 .76363 L .26473 .70062 L p F P
0 g
s
.2 .284 .576 r
.15377 .5726 m .19064 .56436 L .18827 .49212 L p F P
0 g
s
.216 .31 .625 r
.19064 .56436 m .15377 .5726 L .16661 .64491 L p F P
0 g
s
.848 .229 .091 r
.72306 .33161 m .74881 .34704 L .77085 .40813 L p F P
0 g
s
.643 .166 .063 r
.74881 .34704 m .72306 .33161 L .68975 .2805 L p F P
0 g
s
.643 .166 .063 r
.66299 .26392 m .68975 .2805 L .72306 .33161 L p F P
0 g
s
.498 .121 .047 r
.1503 .76857 m .11426 .76036 L .15623 .79725 L p F P
0 g
s
.498 .121 .047 r
.15623 .79725 m .19226 .80499 L .1503 .76857 L p F P
0 g
s
1 .316 .13 r
.77763 .71147 m .75235 .70227 L .783 .63407 L p F P
0 g
s
1 .316 .13 r
.783 .63407 m .80778 .64442 L .77763 .71147 L p F P
0 g
s
.216 .31 .625 r
.16661 .64491 m .20367 .63755 L .19064 .56436 L p F P
0 g
s
.024 .035 .067 r
.83667 .84538 m .79076 .85037 L .8255 .84475 L p F P
0 g
s
.024 .035 .067 r
.8255 .84475 m .87063 .83982 L .83667 .84538 L p F P
0 g
s
.153 .209 .43 r
.32759 .33449 m .28901 .34552 L .27176 .40484 L p F P
0 g
s
.153 .209 .43 r
.23369 .41507 m .27176 .40484 L .28901 .34552 L p F P
0 g
s
.264 .396 .788 r
.45353 .79943 m .41264 .80495 L .45374 .84454 L p F P
0 g
s
.264 .396 .788 r
.45374 .84454 m .49435 .83961 L .45353 .79943 L p F P
0 g
s
1 .305 .125 r
.80778 .64442 m .783 .63407 L .80087 .56198 L p F P
0 g
s
.246 .387 .762 r
.70731 .84516 m .66297 .85015 L .70226 .85998 L p F P
0 g
s
.246 .387 .762 r
.70226 .85998 m .74596 .85523 L .70731 .84516 L p F P
0 g
s
.246 .389 .747 r
.66216 .15969 m .70601 .14617 L .74022 .14386 L p F P
0 g
s
.309 .07 .029 r
.22708 .81248 m .19226 .80499 L .2424 .82835 L p F P
0 g
s
.309 .07 .029 r
.2424 .82835 m .27706 .83559 L .22708 .81248 L p F P
0 g
s
1 .325 .136 r
.57661 .8419 m .54766 .83489 L .60474 .79715 L p F P
0 g
s
1 .325 .136 r
.60474 .79715 m .63307 .8049 L .57661 .8419 L p F P
0 g
s
.268 .41 .812 r
.54285 .83372 m .53596 .83456 L .54079 .83749 L p F P
0 g
s
.264 .396 .788 r
.49435 .83961 m .53596 .83456 L .49544 .79377 L p F P
0 g
s
.264 .396 .788 r
.53843 .78797 m .49544 .79377 L .53596 .83456 L p F P
0 g
s
.264 .396 .788 r
.53596 .83456 m .54285 .83372 L p .53843 .78797 L F P
0 g
s
1 .325 .136 r
.54766 .83489 m .54285 .83372 L p .5754 .78913 L F P
0 g
s
1 .325 .136 r
.55365 .80365 m .5754 .78913 L p .54285 .83372 L F P
0 g
s
1 .325 .136 r
.5754 .78913 m .60474 .79715 L .54766 .83489 L p F P
0 g
s
.264 .396 .788 r
.54285 .83372 m .57862 .82938 L .55365 .80365 L p F P
0 g
s
.264 .396 .788 r
.55365 .80365 m .53843 .78797 L p .54285 .83372 L F P
0 g
s
1 .325 .136 r
.54285 .83372 m .5177 .82763 L .55365 .80365 L p F P
0 g
s
1 .31 .131 r
.5177 .82763 m .54285 .83372 L p .4882 .8574 L F P
0 g
s
1 .31 .131 r
.54285 .83372 m .54766 .83489 L .54079 .83749 L p F P
0 g
s
1 .31 .131 r
.54079 .83749 m .4882 .8574 L p .54285 .83372 L F P
0 g
s
.268 .41 .812 r
.57862 .82938 m .54285 .83372 L p .57752 .85978 L F P
0 g
s
.268 .41 .812 r
.54079 .83749 m .57752 .85978 L p .54285 .83372 L F P
0 g
s
.268 .41 .812 r
.57752 .85978 m .61972 .85502 L .57862 .82938 L p F P
0 g
s
1 .327 .136 r
.66044 .81239 m .63307 .8049 L .68392 .75437 L p F P
0 g
s
1 .327 .136 r
.68392 .75437 m .71067 .76279 L .66044 .81239 L p F P
0 g
s
.024 .035 .067 r
.66216 .15969 m .61937 .17289 L .58636 .19134 L p F P
0 g
s
.444 .142 .066 r
.5636 .18968 m .51375 .16508 L p .56777 .19438 L F P
0 g
s
.444 .142 .066 r
.59248 .20778 m .57283 .19547 L p .56777 .19438 L F P
0 g
s
.024 .035 .067 r
.58636 .19134 m .61937 .17289 L p .57325 .1921 L F P
0 g
s
.024 .035 .067 r
.56777 .19438 m .57307 .19351 L .57325 .1921 L F
.57307 .19351 m .58636 .19134 L .57325 .1921 L F
.058 .07 .135 r
.54393 .20432 m .51472 .23846 L p .57503 .19879 L F P
0 g
s
.411 .095 .039 r
.57442 .19787 m .59248 .20778 L .57503 .19879 L F
.058 .07 .135 r
.57283 .19547 m .54393 .20432 L p .57503 .19879 L F P
0 g
s
.411 .095 .039 r
.57283 .19547 m .59248 .20778 L p .57442 .19787 L F P
0 g
s
.411 .095 .039 r
.57283 .19547 m .57442 .19787 L .57266 .1969 L F
.59248 .20778 m .63529 .24677 L p .57503 .19879 L F P
0 g
s
.024 .035 .067 r
.57283 .19547 m .58636 .19134 L p .56777 .19438 L F P
0 g
s
.444 .142 .066 r
.57283 .19547 m .5636 .18968 L p .56777 .19438 L F P
0 g
s
.024 .035 .067 r
.54393 .20432 m .57283 .19547 L p .56777 .19438 L F P
0 g
s
.411 .095 .039 r
.63529 .24677 m .60661 .22901 L .5773 .20221 L p F P
0 g
s
.058 .07 .135 r
.51472 .23846 m .5773 .20221 L .57503 .19879 L F
.411 .095 .039 r
.5773 .20221 m .5636 .18968 L p .57503 .19879 L F P
0 g
s
.411 .095 .039 r
.57503 .19879 m .63529 .24677 L .5773 .20221 L F
.058 .07 .135 r
.51472 .23846 m .55782 .22559 L .5773 .20221 L p F P
0 g
s
.058 .07 .135 r
.5773 .20221 m .58636 .19134 L p .57503 .19879 L F P
0 g
s
.058 .07 .135 r
.62986 .17803 m .58636 .19134 L .5773 .20221 L p F P
0 g
s
.058 .07 .135 r
.5773 .20221 m .55782 .22559 L p .58215 .20953 L F P
0 g
s
.444 .142 .066 r
.48359 .14629 m .51375 .16508 L .5636 .18968 L p F P
0 g
s
.444 .142 .066 r
.5636 .18968 m .5337 .17094 L .48359 .14629 L p F P
0 g
s
.411 .095 .039 r
.5337 .17094 m .5636 .18968 L .5773 .20221 L p F P
0 g
s
.411 .095 .039 r
.5773 .20221 m .60661 .22901 L p .58215 .20953 L F P
0 g
s
.411 .095 .039 r
.5337 .17094 m .5773 .20221 L .58215 .20953 L F
.66299 .26392 m .63529 .24677 L .59248 .20778 L p F P
0 g
s
.058 .07 .135 r
.60204 .2124 m .62986 .17803 L p .58215 .20953 L F P
0 g
s
.058 .07 .135 r
.55782 .22559 m .58702 .21688 L p .58215 .20953 L F P
0 g
s
.411 .095 .039 r
.57689 .21061 m .5337 .17094 L p .57687 .20533 L F P
0 g
s
.411 .095 .039 r
.60661 .22901 m .58702 .21688 L p .57687 .20533 L F P
0 g
s
.411 .095 .039 r
.58702 .21688 m .57689 .21061 L p .57687 .20533 L F P
0 g
s
.643 .166 .063 r
.60661 .22901 m .64023 .28197 L p .58921 .22449 L F P
0 g
s
.111 .142 .3 r
.58921 .22449 m .58863 .22248 L .55782 .22559 L F
.643 .166 .063 r
.58702 .21688 m .60661 .22901 L p .58921 .22449 L F P
0 g
s
.111 .142 .3 r
.58702 .21688 m .55782 .22559 L p .59167 .22217 L F P
0 g
s
.643 .166 .063 r
.57689 .21061 m .58702 .21688 L p .58921 .22449 L F P
0 g
s
.111 .142 .3 r
.55782 .22559 m .53562 .27501 L p .58921 .22449 L F P
0 g
s
.111 .142 .3 r
.58921 .22449 m .59167 .22217 L .58863 .22248 L F
.60204 .2124 m .58702 .21688 L p .59167 .22217 L F P
0 g
s
.058 .07 .135 r
.58702 .21688 m .60204 .2124 L p .58215 .20953 L F P
0 g
s
.058 .07 .135 r
.58215 .20953 m .62986 .17803 L .5773 .20221 L F
.58636 .19134 m .57283 .19547 L p .57503 .19879 L F P
0 g
s
.411 .095 .039 r
.57266 .1969 m .57442 .19787 L .57503 .19879 L F
.5636 .18968 m .57283 .19547 L p .57266 .1969 L F P
0 g
s
.181 .252 .514 r
.18827 .49212 m .22578 .48284 L .23369 .41507 L p F P
0 g
s
.2 .284 .576 r
.22578 .48284 m .18827 .49212 L .19064 .56436 L p F P
0 g
s
.111 .142 .3 r
.43169 .26325 m .39169 .27519 L .36714 .32318 L p F P
0 g
s
.111 .142 .3 r
.32759 .33449 m .36714 .32318 L .39169 .27519 L p F P
0 g
s
.181 .252 .514 r
.27176 .40484 m .23369 .41507 L .22578 .48284 L p F P
0 g
s
.058 .07 .135 r
.54393 .20432 m .50253 .21698 L .47269 .25101 L p F P
0 g
s
.058 .07 .135 r
.43169 .26325 m .47269 .25101 L .50253 .21698 L p F P
0 g
s
.528 .175 .077 r
.31054 .84257 m .27706 .83559 L .33327 .844 L p F P
0 g
s
.528 .175 .077 r
.33327 .844 m .36644 .85098 L .31054 .84257 L p F P
0 g
s
.901 .274 .119 r
.42918 .13685 m .39765 .11763 L .34113 .12338 L p F P
0 g
s
.963 .267 .107 r
.80509 .49006 m .7801 .47697 L .77085 .40813 L p F P
0 g
s
1 .29 .118 r
.7801 .47697 m .80509 .49006 L .80087 .56198 L p F P
0 g
s
.253 .375 .749 r
.37521 .75153 m .33519 .75766 L .37276 .81033 L p F P
0 g
s
.253 .375 .749 r
.37276 .81033 m .41264 .80495 L .37521 .75153 L p F P
0 g
s
.229 .333 .668 r
.24166 .63 m .20367 .63755 L .22664 .70728 L p F P
0 g
s
.229 .333 .668 r
.22664 .70728 m .26473 .70062 L .24166 .63 L p F P
0 g
s
.851 .265 .114 r
.39848 .85772 m .36644 .85098 L .42609 .84366 L p F P
0 g
s
.851 .265 .114 r
.42609 .84366 m .45768 .85065 L .39848 .85772 L p F P
0 g
s
.699 .221 .098 r
.51375 .16508 m .48359 .14629 L .42918 .13685 L p F P
0 g
s
.699 .221 .098 r
.39765 .11763 m .42918 .13685 L .48359 .14629 L p F P
0 g
s
.264 .396 .788 r
.49544 .79377 m .45353 .79943 L .49435 .83961 L p F P
0 g
s
1 .31 .131 r
.4882 .8574 m .45768 .85065 L .5177 .82763 L p F P
0 g
s
.242 .354 .709 r
.30378 .6938 m .26473 .70062 L .29614 .76363 L p F P
0 g
s
.242 .354 .709 r
.29614 .76363 m .33519 .75766 L .30378 .6938 L p F P
0 g
s
.2 .284 .576 r
.19064 .56436 m .22842 .55592 L .22578 .48284 L p F P
0 g
s
.216 .31 .625 r
.22842 .55592 m .19064 .56436 L .20367 .63755 L p F P
0 g
s
1 .323 .134 r
.71067 .76279 m .68392 .75437 L .72619 .69276 L p F P
0 g
s
1 .323 .134 r
.72619 .69276 m .75235 .70227 L .71067 .76279 L p F P
0 g
s
.216 .31 .625 r
.20367 .63755 m .24166 .63 L .22842 .55592 L p F P
0 g
s
.153 .209 .43 r
.36714 .32318 m .32759 .33449 L .31079 .39436 L p F P
0 g
s
.153 .209 .43 r
.27176 .40484 m .31079 .39436 L .32759 .33449 L p F P
0 g
s
.963 .267 .107 r
.74511 .39353 m .77085 .40813 L .7801 .47697 L p F P
0 g
s
.848 .229 .091 r
.77085 .40813 m .74511 .39353 L .72306 .33161 L p F P
0 g
s
.246 .387 .762 r
.75277 .84004 m .70731 .84516 L .74596 .85523 L p F P
0 g
s
.246 .387 .762 r
.74596 .85523 m .79076 .85037 L .75277 .84004 L p F P
0 g
s
1 .305 .125 r
.77562 .55004 m .80087 .56198 L .783 .63407 L p F P
0 g
s
1 .29 .118 r
.80087 .56198 m .77562 .55004 L .7801 .47697 L p F P
0 g
s
.268 .41 .812 r
.62236 .82407 m .57862 .82938 L .61972 .85502 L p F P
0 g
s
.268 .41 .812 r
.61972 .85502 m .66297 .85015 L .62236 .82407 L p F P
0 g
s
.848 .229 .091 r
.69641 .31564 m .72306 .33161 L .74511 .39353 L p F P
0 g
s
.643 .166 .063 r
.72306 .33161 m .69641 .31564 L .66299 .26392 L p F P
0 g
s
.643 .166 .063 r
.63529 .24677 m .66299 .26392 L .69641 .31564 L p F P
0 g
s
.024 .035 .067 r
.70601 .14617 m .66216 .15969 L .62986 .17803 L p F P
0 g
s
.024 .035 .067 r
.58636 .19134 m .62986 .17803 L .66216 .15969 L p F P
0 g
s
.181 .252 .514 r
.22578 .48284 m .26421 .47333 L .27176 .40484 L p F P
0 g
s
.2 .284 .576 r
.26421 .47333 m .22578 .48284 L .22842 .55592 L p F P
0 g
s
.111 .142 .3 r
.47269 .25101 m .43169 .26325 L .40768 .31159 L p F P
0 g
s
.111 .142 .3 r
.36714 .32318 m .40768 .31159 L .43169 .26325 L p F P
0 g
s
1 .316 .13 r
.75235 .70227 m .72619 .69276 L .75735 .62335 L p F P
0 g
s
1 .316 .13 r
.75735 .62335 m .783 .63407 L .75235 .70227 L p F P
0 g
s
.181 .252 .514 r
.31079 .39436 m .27176 .40484 L .26421 .47333 L p F P
0 g
s
.058 .07 .135 r
.47269 .25101 m .51472 .23846 L .54393 .20432 L p F P
0 g
s
1 .305 .125 r
.783 .63407 m .75735 .62335 L .77562 .55004 L p F P
0 g
s
.309 .07 .029 r
.19226 .80499 m .15623 .79725 L .2065 .82086 L p F P
0 g
s
.309 .07 .029 r
.2065 .82086 m .2424 .82835 L .19226 .80499 L p F P
0 g
s
.253 .375 .749 r
.41625 .74525 m .37521 .75153 L .41264 .80495 L p F P
0 g
s
.253 .375 .749 r
.41264 .80495 m .45353 .79943 L .41625 .74525 L p F P
0 g
s
1 .327 .136 r
.63307 .8049 m .60474 .79715 L .65623 .74566 L p F P
0 g
s
1 .327 .136 r
.65623 .74566 m .68392 .75437 L .63307 .8049 L p F P
0 g
s
.229 .333 .668 r
.28059 .62226 m .24166 .63 L .26473 .70062 L p F P
0 g
s
.229 .333 .668 r
.26473 .70062 m .30378 .6938 L .28059 .62226 L p F P
0 g
s
.242 .354 .709 r
.34381 .68681 m .30378 .6938 L .33519 .75766 L p F P
0 g
s
.242 .354 .709 r
.33519 .75766 m .37521 .75153 L .34381 .68681 L p F P
0 g
s
.528 .175 .077 r
.27706 .83559 m .2424 .82835 L .29891 .83677 L p F P
0 g
s
.528 .175 .077 r
.29891 .83677 m .33327 .844 L .27706 .83559 L p F P
0 g
s
.2 .284 .576 r
.22842 .55592 m .26714 .54726 L .26421 .47333 L p F P
0 g
s
.216 .31 .625 r
.26714 .54726 m .22842 .55592 L .24166 .63 L p F P
0 g
s
.963 .267 .107 r
.7801 .47697 m .75423 .46342 L .74511 .39353 L p F P
0 g
s
1 .29 .118 r
.75423 .46342 m .7801 .47697 L .77562 .55004 L p F P
0 g
s
.216 .31 .625 r
.24166 .63 m .28059 .62226 L .26714 .54726 L p F P
0 g
s
.851 .265 .114 r
.36644 .85098 m .33327 .844 L .39337 .83642 L p F P
0 g
s
.851 .265 .114 r
.39337 .83642 m .42609 .84366 L .36644 .85098 L p F P
0 g
s
.153 .209 .43 r
.40768 .31159 m .36714 .32318 L .35079 .38361 L p F P
0 g
s
.153 .209 .43 r
.31079 .39436 m .35079 .38361 L .36714 .32318 L p F P
0 g
s
.699 .221 .098 r
.48359 .14629 m .45237 .12684 L .39765 .11763 L p F P
0 g
s
1 .31 .131 r
.45768 .85065 m .42609 .84366 L .48667 .82012 L p F P
0 g
s
1 .31 .131 r
.48667 .82012 m .5177 .82763 L .45768 .85065 L p F P
0 g
s
.246 .387 .762 r
.79941 .83479 m .75277 .84004 L .79076 .85037 L p F P
0 g
s
.246 .387 .762 r
.79076 .85037 m .83667 .84538 L .79941 .83479 L p F P
0 g
s
.268 .41 .812 r
.66722 .81862 m .62236 .82407 L .66297 .85015 L p F P
0 g
s
.268 .41 .812 r
.66297 .85015 m .70731 .84516 L .66722 .81862 L p F P
0 g
s
.444 .142 .066 r
.45237 .12684 m .48359 .14629 L .5337 .17094 L p F P
0 g
s
.024 .035 .067 r
.62986 .17803 m .67447 .16438 L .70601 .14617 L p F P
0 g
s
1 .323 .134 r
.68392 .75437 m .65623 .74566 L .69909 .6829 L p F P
0 g
s
1 .323 .134 r
.69909 .6829 m .72619 .69276 L .68392 .75437 L p F P
0 g
s
.181 .252 .514 r
.26421 .47333 m .30361 .46359 L .31079 .39436 L p F P
0 g
s
.2 .284 .576 r
.30361 .46359 m .26421 .47333 L .26714 .54726 L p F P
0 g
s
.111 .142 .3 r
.51472 .23846 m .47269 .25101 L .44924 .29971 L p F P
0 g
s
.111 .142 .3 r
.40768 .31159 m .44924 .29971 L .47269 .25101 L p F P
0 g
s
.181 .252 .514 r
.35079 .38361 m .31079 .39436 L .30361 .46359 L p F P
0 g
s
.963 .267 .107 r
.71846 .37842 m .74511 .39353 L .75423 .46342 L p F P
0 g
s
.848 .229 .091 r
.74511 .39353 m .71846 .37842 L .69641 .31564 L p F P
0 g
s
1 .305 .125 r
.74947 .53769 m .77562 .55004 L .75735 .62335 L p F P
0 g
s
1 .29 .118 r
.77562 .55004 m .74947 .53769 L .75423 .46342 L p F P
0 g
s
.253 .375 .749 r
.45833 .73881 m .41625 .74525 L .45353 .79943 L p F P
0 g
s
.253 .375 .749 r
.45353 .79943 m .49544 .79377 L .45833 .73881 L p F P
0 g
s
.229 .333 .668 r
.32052 .61432 m .28059 .62226 L .30378 .6938 L p F P
0 g
s
.229 .333 .668 r
.30378 .6938 m .34381 .68681 L .32052 .61432 L p F P
0 g
s
.848 .229 .091 r
.66882 .2991 m .69641 .31564 L .71846 .37842 L p F P
0 g
s
.643 .166 .063 r
.69641 .31564 m .66882 .2991 L .63529 .24677 L p F P
0 g
s
.643 .166 .063 r
.60661 .22901 m .63529 .24677 L .66882 .2991 L p F P
0 g
s
1 .316 .13 r
.72619 .69276 m .69909 .6829 L .73078 .61225 L p F P
0 g
s
1 .316 .13 r
.73078 .61225 m .75735 .62335 L .72619 .69276 L p F P
0 g
s
.242 .354 .709 r
.38487 .67963 m .34381 .68681 L .37521 .75153 L p F P
0 g
s
.242 .354 .709 r
.37521 .75153 m .41625 .74525 L .38487 .67963 L p F P
0 g
s
1 .305 .125 r
.75735 .62335 m .73078 .61225 L .74947 .53769 L p F P
0 g
s
.2 .284 .576 r
.26714 .54726 m .30685 .53838 L .30361 .46359 L p F P
0 g
s
.216 .31 .625 r
.30685 .53838 m .26714 .54726 L .28059 .62226 L p F P
0 g
s
.216 .31 .625 r
.28059 .62226 m .32052 .61432 L .30685 .53838 L p F P
0 g
s
1 .327 .136 r
.60474 .79715 m .5754 .78913 L .62754 .73663 L p F P
0 g
s
1 .327 .136 r
.62754 .73663 m .65623 .74566 L .60474 .79715 L p F P
0 g
s
.153 .209 .43 r
.44924 .29971 m .40768 .31159 L .39182 .37259 L p F P
0 g
s
.153 .209 .43 r
.35079 .38361 m .39182 .37259 L .40768 .31159 L p F P
0 g
s
.264 .396 .788 r
.56034 .78501 m .53843 .78797 L .55365 .80365 L p F P
0 g
s
.253 .375 .749 r
.53843 .78797 m .56034 .78501 L p .54583 .72542 L F P
0 g
s
1 .327 .136 r
.5754 .78913 m .56034 .78501 L p .5978 .72728 L F P
0 g
s
1 .327 .136 r
.56717 .75833 m .5978 .72728 L p .56034 .78501 L F P
0 g
s
1 .327 .136 r
.5978 .72728 m .62754 .73663 L .5754 .78913 L p F P
0 g
s
.253 .375 .749 r
.56034 .78501 m .58253 .78201 L .56717 .75833 L p F P
0 g
s
.253 .375 .749 r
.56717 .75833 m .54583 .72542 L p .56034 .78501 L F P
0 g
s
1 .327 .136 r
.56034 .78501 m .545 .78081 L .56717 .75833 L p F P
0 g
s
1 .325 .136 r
.545 .78081 m .56034 .78501 L p .5177 .82763 L F P
0 g
s
1 .325 .136 r
.56034 .78501 m .5754 .78913 L .55365 .80365 L p F P
0 g
s
1 .325 .136 r
.55365 .80365 m .5177 .82763 L p .56034 .78501 L F P
0 g
s
.264 .396 .788 r
.58253 .78201 m .56034 .78501 L p .57862 .82938 L F P
0 g
s
.264 .396 .788 r
.55365 .80365 m .57862 .82938 L p .56034 .78501 L F P
0 g
s
.264 .396 .788 r
.57862 .82938 m .62236 .82407 L .58253 .78201 L p F P
0 g
s
.268 .41 .812 r
.71325 .81304 m .66722 .81862 L .70731 .84516 L p F P
0 g
s
.268 .41 .812 r
.70731 .84516 m .75277 .84004 L .71325 .81304 L p F P
0 g
s
.528 .175 .077 r
.2424 .82835 m .2065 .82086 L .26329 .82928 L p F P
0 g
s
.528 .175 .077 r
.26329 .82928 m .29891 .83677 L .2424 .82835 L p F P
0 g
s
.181 .252 .514 r
.30361 .46359 m .34402 .45359 L .35079 .38361 L p F P
0 g
s
.2 .284 .576 r
.34402 .45359 m .30361 .46359 L .30685 .53838 L p F P
0 g
s
.111 .142 .3 r
.55782 .22559 m .51472 .23846 L .49188 .28752 L p F P
0 g
s
.111 .142 .3 r
.44924 .29971 m .49188 .28752 L .51472 .23846 L p F P
0 g
s
.963 .267 .107 r
.75423 .46342 m .72743 .44938 L .71846 .37842 L p F P
0 g
s
1 .29 .118 r
.72743 .44938 m .75423 .46342 L .74947 .53769 L p F P
0 g
s
.253 .375 .749 r
.49544 .79377 m .53843 .78797 L .50151 .7322 L p F P
0 g
s
.253 .375 .749 r
.54583 .72542 m .50151 .7322 L .53843 .78797 L p F P
0 g
s
1 .325 .136 r
.5177 .82763 m .48667 .82012 L .545 .78081 L p F P
0 g
s
.181 .252 .514 r
.39182 .37259 m .35079 .38361 L .34402 .45359 L p F P
0 g
s
.851 .265 .114 r
.33327 .844 m .29891 .83677 L .35944 .82891 L p F P
0 g
s
.851 .265 .114 r
.35944 .82891 m .39337 .83642 L .33327 .844 L p F P
0 g
s
.058 .07 .135 r
.67447 .16438 m .62986 .17803 L .60204 .2124 L p F P
0 g
s
1 .31 .131 r
.42609 .84366 m .39337 .83642 L .4545 .81233 L p F P
0 g
s
1 .31 .131 r
.4545 .81233 m .48667 .82012 L .42609 .84366 L p F P
0 g
s
.253 .375 .749 r
.50151 .7322 m .45833 .73881 L .49544 .79377 L p F P
0 g
s
.229 .333 .668 r
.36147 .60619 m .32052 .61432 L .34381 .68681 L p F P
0 g
s
.229 .333 .668 r
.34381 .68681 m .38487 .67963 L .36147 .60619 L p F P
0 g
s
.444 .142 .066 r
.5337 .17094 m .50272 .15153 L .45237 .12684 L p F P
0 g
s
1 .323 .134 r
.65623 .74566 m .62754 .73663 L .67102 .67269 L p F P
0 g
s
1 .323 .134 r
.67102 .67269 m .69909 .6829 L .65623 .74566 L p F P
0 g
s
.242 .354 .709 r
.42699 .67227 m .38487 .67963 L .41625 .74525 L p F P
0 g
s
.242 .354 .709 r
.41625 .74525 m .45833 .73881 L .42699 .67227 L p F P
0 g
s
.963 .267 .107 r
.69085 .36276 m .71846 .37842 L .72743 .44938 L p F P
0 g
s
.848 .229 .091 r
.71846 .37842 m .69085 .36276 L .66882 .2991 L p F P
0 g
s
.2 .284 .576 r
.30685 .53838 m .34758 .52928 L .34402 .45359 L p F P
0 g
s
.216 .31 .625 r
.34758 .52928 m .30685 .53838 L .32052 .61432 L p F P
0 g
s
.411 .095 .039 r
.50272 .15153 m .5337 .17094 L .57689 .21061 L p F P
0 g
s
1 .305 .125 r
.72237 .52488 m .74947 .53769 L .73078 .61225 L p F P
0 g
s
1 .29 .118 r
.74947 .53769 m .72237 .52488 L .72743 .44938 L p F P
0 g
s
.216 .31 .625 r
.32052 .61432 m .36147 .60619 L .34758 .52928 L p F P
0 g
s
.153 .209 .43 r
.49188 .28752 m .44924 .29971 L .43391 .36129 L p F P
0 g
s
.153 .209 .43 r
.39182 .37259 m .43391 .36129 L .44924 .29971 L p F P
0 g
s
.264 .396 .788 r
.62779 .7759 m .58253 .78201 L .62236 .82407 L p F P
0 g
s
.264 .396 .788 r
.62236 .82407 m .66722 .81862 L .62779 .7759 L p F P
0 g
s
.848 .229 .091 r
.64023 .28197 m .66882 .2991 L .69085 .36276 L p F P
0 g
s
.643 .166 .063 r
.66882 .2991 m .64023 .28197 L .60661 .22901 L p F P
0 g
s
1 .316 .13 r
.69909 .6829 m .67102 .67269 L .70326 .60075 L p F P
0 g
s
1 .316 .13 r
.70326 .60075 m .73078 .61225 L .69909 .6829 L p F P
0 g
s
.268 .41 .812 r
.7605 .8073 m .71325 .81304 L .75277 .84004 L p F P
0 g
s
.268 .41 .812 r
.75277 .84004 m .79941 .83479 L .7605 .8073 L p F P
0 g
s
1 .305 .125 r
.73078 .61225 m .70326 .60075 L .72237 .52488 L p F P
0 g
s
.181 .252 .514 r
.34402 .45359 m .38547 .44334 L .39182 .37259 L p F P
0 g
s
.2 .284 .576 r
.38547 .44334 m .34402 .45359 L .34758 .52928 L p F P
0 g
s
.111 .142 .3 r
.49188 .28752 m .53562 .27501 L .55782 .22559 L p F P
0 g
s
.181 .252 .514 r
.43391 .36129 m .39182 .37259 L .38547 .44334 L p F P
0 g
s
.058 .07 .135 r
.60204 .2124 m .64741 .19885 L .67447 .16438 L p F P
0 g
s
.229 .333 .668 r
.40348 .59784 m .36147 .60619 L .38487 .67963 L p F P
0 g
s
.229 .333 .668 r
.38487 .67963 m .42699 .67227 L .40348 .59784 L p F P
0 g
s
.963 .267 .107 r
.72743 .44938 m .69965 .43484 L .69085 .36276 L p F P
0 g
s
1 .29 .118 r
.69965 .43484 m .72743 .44938 L .72237 .52488 L p F P
0 g
s
1 .325 .136 r
.48667 .82012 m .4545 .81233 L .51348 .77219 L p F P
0 g
s
1 .325 .136 r
.51348 .77219 m .545 .78081 L .48667 .82012 L p F P
0 g
s
.242 .354 .709 r
.47021 .66472 m .42699 .67227 L .45833 .73881 L p F P
0 g
s
.242 .354 .709 r
.45833 .73881 m .50151 .7322 L .47021 .66472 L p F P
0 g
s
.851 .265 .114 r
.29891 .83677 m .26329 .82928 L .32426 .82113 L p F P
0 g
s
.851 .265 .114 r
.32426 .82113 m .35944 .82891 L .29891 .83677 L p F P
0 g
s
1 .31 .131 r
.39337 .83642 m .35944 .82891 L .42114 .80425 L p F P
0 g
s
1 .31 .131 r
.42114 .80425 m .4545 .81233 L .39337 .83642 L p F P
0 g
s
.2 .284 .576 r
.34758 .52928 m .38937 .51994 L .38547 .44334 L p F P
0 g
s
.216 .31 .625 r
.38937 .51994 m .34758 .52928 L .36147 .60619 L p F P
0 g
s
.216 .31 .625 r
.36147 .60619 m .40348 .59784 L .38937 .51994 L p F P
0 g
s
.153 .209 .43 r
.53562 .27501 m .49188 .28752 L .4771 .34969 L p F P
0 g
s
.153 .209 .43 r
.43391 .36129 m .4771 .34969 L .49188 .28752 L p F P
0 g
s
.264 .396 .788 r
.67425 .76963 m .62779 .7759 L .66722 .81862 L p F P
0 g
s
.264 .396 .788 r
.66722 .81862 m .71325 .81304 L .67425 .76963 L p F P
0 g
s
1 .323 .134 r
.62754 .73663 m .5978 .72728 L .64192 .66211 L p F P
0 g
s
1 .323 .134 r
.64192 .66211 m .67102 .67269 L .62754 .73663 L p F P
0 g
s
.963 .267 .107 r
.66222 .34653 m .69085 .36276 L .69965 .43484 L p F P
0 g
s
.848 .229 .091 r
.69085 .36276 m .66222 .34653 L .64023 .28197 L p F P
0 g
s
.411 .095 .039 r
.57689 .21061 m .54607 .19153 L .50272 .15153 L p F P
0 g
s
.181 .252 .514 r
.38547 .44334 m .42801 .43282 L .43391 .36129 L p F P
0 g
s
.2 .284 .576 r
.42801 .43282 m .38547 .44334 L .38937 .51994 L p F P
0 g
s
.643 .166 .063 r
.64023 .28197 m .61059 .2642 L .59225 .23504 L p F P
0 g
s
.643 .166 .063 r
.58921 .22449 m .64023 .28197 L .59225 .23504 L F
.111 .142 .3 r
.53562 .27501 m .58053 .26217 L .59225 .23504 L p F P
0 g
s
.111 .142 .3 r
.59225 .23504 m .60204 .2124 L p .58921 .22449 L F P
0 g
s
.111 .142 .3 r
.53562 .27501 m .59225 .23504 L .58921 .22449 L F
.643 .166 .063 r
.54607 .19153 m .57689 .21061 L .59225 .23504 L p F P
0 g
s
.643 .166 .063 r
.59225 .23504 m .61059 .2642 L p .59588 .24763 L F P
0 g
s
.111 .142 .3 r
.59225 .23504 m .58053 .26217 L p .59588 .24763 L F P
0 g
s
.643 .166 .063 r
.54607 .19153 m .59225 .23504 L .59588 .24763 L F
.59225 .23504 m .57689 .21061 L p .58921 .22449 L F P
0 g
s
.111 .142 .3 r
.64741 .19885 m .60204 .2124 L .59225 .23504 L p F P
0 g
s
.111 .142 .3 r
.59588 .24763 m .64741 .19885 L .59225 .23504 L F
1 .305 .125 r
.69429 .5116 m .72237 .52488 L .70326 .60075 L p F P
0 g
s
1 .29 .118 r
.72237 .52488 m .69429 .5116 L .69965 .43484 L p F P
0 g
s
.181 .252 .514 r
.4771 .34969 m .43391 .36129 L .42801 .43282 L p F P
0 g
s
.848 .229 .091 r
.61059 .2642 m .64023 .28197 L .66222 .34653 L p F P
0 g
s
1 .316 .13 r
.67102 .67269 m .64192 .66211 L .67472 .58883 L p F P
0 g
s
1 .316 .13 r
.67472 .58883 m .70326 .60075 L .67102 .67269 L p F P
0 g
s
.253 .375 .749 r
.57682 .72068 m .54583 .72542 L .56717 .75833 L p F P
0 g
s
.242 .354 .709 r
.54583 .72542 m .57682 .72068 L p .56016 .64901 L F P
0 g
s
1 .323 .134 r
.5978 .72728 m .57682 .72068 L p .61172 .65112 L F P
0 g
s
1 .323 .134 r
.58134 .6962 m .61172 .65112 L p .57682 .72068 L F P
0 g
s
.242 .354 .709 r
.57682 .72068 m .59133 .71845 L .58134 .6962 L p F P
0 g
s
.242 .354 .709 r
.58134 .6962 m .56016 .64901 L p .57682 .72068 L F P
0 g
s
1 .323 .134 r
.57682 .72068 m .56694 .71757 L .58134 .6962 L p F P
0 g
s
1 .327 .136 r
.56694 .71757 m .57682 .72068 L p .545 .78081 L F P
0 g
s
1 .327 .136 r
.57682 .72068 m .5978 .72728 L .56717 .75833 L p F P
0 g
s
1 .327 .136 r
.56717 .75833 m .545 .78081 L p .57682 .72068 L F P
0 g
s
.253 .375 .749 r
.59133 .71845 m .57682 .72068 L p .58253 .78201 L F P
0 g
s
.253 .375 .749 r
.56717 .75833 m .58253 .78201 L p .57682 .72068 L F P
0 g
s
.253 .375 .749 r
.58253 .78201 m .62779 .7759 L .59133 .71845 L p F P
0 g
s
.229 .333 .668 r
.44661 .58927 m .40348 .59784 L .42699 .67227 L p F P
0 g
s
.229 .333 .668 r
.42699 .67227 m .47021 .66472 L .44661 .58927 L p F P
0 g
s
1 .305 .125 r
.70326 .60075 m .67472 .58883 L .69429 .5116 L p F P
0 g
s
1 .327 .136 r
.545 .78081 m .51348 .77219 L .56694 .71757 L p F P
0 g
s
.242 .354 .709 r
.51459 .65697 m .47021 .66472 L .50151 .7322 L p F P
0 g
s
.242 .354 .709 r
.50151 .7322 m .54583 .72542 L .51459 .65697 L p F P
0 g
s
.2 .284 .576 r
.38937 .51994 m .43226 .51035 L .42801 .43282 L p F P
0 g
s
.216 .31 .625 r
.43226 .51035 m .38937 .51994 L .40348 .59784 L p F P
0 g
s
.216 .31 .625 r
.40348 .59784 m .44661 .58927 L .43226 .51035 L p F P
0 g
s
.153 .209 .43 r
.58053 .26217 m .53562 .27501 L .52143 .33778 L p F P
0 g
s
.153 .209 .43 r
.4771 .34969 m .52143 .33778 L .53562 .27501 L p F P
0 g
s
.264 .396 .788 r
.72197 .76319 m .67425 .76963 L .71325 .81304 L p F P
0 g
s
.264 .396 .788 r
.71325 .81304 m .7605 .8073 L .72197 .76319 L p F P
0 g
s
.963 .267 .107 r
.69965 .43484 m .67084 .41975 L .66222 .34653 L p F P
0 g
s
1 .29 .118 r
.67084 .41975 m .69965 .43484 L .69429 .5116 L p F P
0 g
s
1 .325 .136 r
.4545 .81233 m .42114 .80425 L .48076 .76324 L p F P
0 g
s
1 .325 .136 r
.48076 .76324 m .51348 .77219 L .4545 .81233 L p F P
0 g
s
1 .31 .131 r
.35944 .82891 m .32426 .82113 L .38652 .79586 L p F P
0 g
s
1 .31 .131 r
.38652 .79586 m .42114 .80425 L .35944 .82891 L p F P
0 g
s
.181 .252 .514 r
.42801 .43282 m .47167 .42202 L .4771 .34969 L p F P
0 g
s
.2 .284 .576 r
.47167 .42202 m .42801 .43282 L .43226 .51035 L p F P
0 g
s
.153 .209 .43 r
.58053 .26217 m .56696 .32555 L p .60183 .28081 L F P
0 g
s
.848 .229 .091 r
.61059 .2642 m .63252 .3297 L p .60183 .28081 L F P
0 g
s
.848 .229 .091 r
.60059 .27171 m .61059 .2642 L .60183 .28081 L F
.153 .209 .43 r
.59858 .25701 m .58053 .26217 L p .60183 .28081 L F P
0 g
s
.848 .229 .091 r
.59858 .25701 m .61059 .2642 L p .59755 .27399 L F P
0 g
s
.848 .229 .091 r
.66222 .34653 m .63252 .3297 L .61059 .2642 L p F P
0 g
s
.643 .166 .063 r
.57983 .24577 m .54607 .19153 L p .59255 .24388 L F P
0 g
s
.643 .166 .063 r
.61059 .2642 m .59858 .25701 L p .59588 .24763 L F P
0 g
s
.111 .142 .3 r
.59588 .24763 m .59858 .25701 L .59935 .24435 L F
.58053 .26217 m .59858 .25701 L p .59588 .24763 L F P
0 g
s
.643 .166 .063 r
.59255 .24388 m .59588 .24763 L .59858 .25701 L F
.59858 .25701 m .57983 .24577 L p .59255 .24388 L F P
0 g
s
.153 .209 .43 r
.60183 .28081 m .60667 .2746 L .59858 .25701 L F
.62663 .24899 m .59858 .25701 L p .60667 .2746 L F P
0 g
s
.848 .229 .091 r
.59755 .27399 m .60059 .27171 L .60183 .28081 L F
.57983 .24577 m .59858 .25701 L p .59755 .27399 L F P
0 g
s
.111 .142 .3 r
.62663 .24899 m .64741 .19885 L p .59935 .24435 L F P
0 g
s
.111 .142 .3 r
.59858 .25701 m .62663 .24899 L p .59935 .24435 L F P
0 g
s
.181 .252 .514 r
.52143 .33778 m .4771 .34969 L .47167 .42202 L p F P
0 g
s
1 .323 .134 r
.61172 .65112 m .64192 .66211 L .5978 .72728 L p F P
0 g
s
.253 .375 .749 r
.63806 .7113 m .59133 .71845 L .62779 .7759 L p F P
0 g
s
.253 .375 .749 r
.62779 .7759 m .67425 .76963 L .63806 .7113 L p F P
0 g
s
.229 .333 .668 r
.49089 .58047 m .44661 .58927 L .47021 .66472 L p F P
0 g
s
.229 .333 .668 r
.47021 .66472 m .51459 .65697 L .49089 .58047 L p F P
0 g
s
.963 .267 .107 r
.63252 .3297 m .66222 .34653 L .67084 .41975 L p F P
0 g
s
1 .305 .125 r
.66515 .49783 m .69429 .5116 L .67472 .58883 L p F P
0 g
s
1 .29 .118 r
.69429 .5116 m .66515 .49783 L .67084 .41975 L p F P
0 g
s
.242 .354 .709 r
.56016 .64901 m .51459 .65697 L .54583 .72542 L p F P
0 g
s
.2 .284 .576 r
.43226 .51035 m .47629 .50051 L .47167 .42202 L p F P
0 g
s
.216 .31 .625 r
.47629 .50051 m .43226 .51035 L .44661 .58927 L p F P
0 g
s
1 .316 .13 r
.64192 .66211 m .61172 .65112 L .64511 .57646 L p F P
0 g
s
1 .316 .13 r
.64511 .57646 m .67472 .58883 L .64192 .66211 L p F P
0 g
s
.216 .31 .625 r
.44661 .58927 m .49089 .58047 L .47629 .50051 L p F P
0 g
s
1 .305 .125 r
.67472 .58883 m .64511 .57646 L .66515 .49783 L p F P
0 g
s
.153 .209 .43 r
.52143 .33778 m .56696 .32555 L .58053 .26217 L p F P
0 g
s
1 .327 .136 r
.51348 .77219 m .48076 .76324 L .53492 .70749 L p F P
0 g
s
1 .327 .136 r
.53492 .70749 m .56694 .71757 L .51348 .77219 L p F P
0 g
s
.181 .252 .514 r
.47167 .42202 m .51651 .41093 L .52143 .33778 L p F P
0 g
s
.2 .284 .576 r
.51651 .41093 m .47167 .42202 L .47629 .50051 L p F P
0 g
s
.181 .252 .514 r
.56696 .32555 m .52143 .33778 L .51651 .41093 L p F P
0 g
s
.963 .267 .107 r
.67084 .41975 m .64095 .40409 L .63252 .3297 L p F P
0 g
s
1 .29 .118 r
.64095 .40409 m .67084 .41975 L .66515 .49783 L p F P
0 g
s
1 .325 .136 r
.42114 .80425 m .38652 .79586 L .4468 .75395 L p F P
0 g
s
1 .325 .136 r
.4468 .75395 m .48076 .76324 L .42114 .80425 L p F P
0 g
s
.253 .375 .749 r
.68607 .70395 m .63806 .7113 L .67425 .76963 L p F P
0 g
s
.253 .375 .749 r
.67425 .76963 m .72197 .76319 L .68607 .70395 L p F P
0 g
s
.229 .333 .668 r
.53636 .57143 m .49089 .58047 L .51459 .65697 L p F P
0 g
s
.229 .333 .668 r
.51459 .65697 m .56016 .64901 L .53636 .57143 L p F P
0 g
s
.242 .354 .709 r
.59107 .64361 m .56016 .64901 L .58134 .6962 L p F P
0 g
s
.229 .333 .668 r
.56016 .64901 m .59107 .64361 L p .58309 .56214 L F P
0 g
s
1 .316 .13 r
.61172 .65112 m .59107 .64361 L p .61436 .56361 L F P
0 g
s
.229 .333 .668 r
.59601 .6047 m .58309 .56214 L p .59107 .64361 L F P
0 g
s
1 .316 .13 r
.59107 .64361 m .58037 .63972 L .59601 .6047 L p F P
0 g
s
1 .316 .13 r
.59601 .6047 m .61436 .56361 L p .59107 .64361 L F P
0 g
s
.229 .333 .668 r
.59995 .61768 m .59601 .6047 L p .59107 .64361 L F P
0 g
s
.229 .333 .668 r
.59107 .64361 m .60698 .64083 L .59995 .61768 L p F P
0 g
s
1 .323 .134 r
.56819 .71036 m .59107 .64361 L .56694 .71757 L F
.58037 .63972 m .59107 .64361 L p .56819 .71036 L F P
0 g
s
1 .323 .134 r
.59107 .64361 m .61172 .65112 L .58134 .6962 L p F P
0 g
s
1 .323 .134 r
.58134 .6962 m .56694 .71757 L p .59107 .64361 L F P
0 g
s
.242 .354 .709 r
.60698 .64083 m .59107 .64361 L p .59133 .71845 L F P
0 g
s
.242 .354 .709 r
.58134 .6962 m .59133 .71845 L p .59107 .64361 L F P
0 g
s
.242 .354 .709 r
.59133 .71845 m .63806 .7113 L .60698 .64083 L p F P
0 g
s
.2 .284 .576 r
.47629 .50051 m .52152 .4904 L .51651 .41093 L p F P
0 g
s
.216 .31 .625 r
.52152 .4904 m .47629 .50051 L .49089 .58047 L p F P
0 g
s
1 .323 .134 r
.56694 .71757 m .53492 .70749 L .58037 .63972 L p F P
0 g
s
.216 .31 .625 r
.49089 .58047 m .53636 .57143 L .52152 .4904 L p F P
0 g
s
.181 .252 .514 r
.56696 .32555 m .56257 .39953 L p .60693 .32448 L F P
0 g
s
.963 .267 .107 r
.60682 .32212 m .63252 .3297 L .60693 .32448 L F
.181 .252 .514 r
.60649 .31493 m .56696 .32555 L p .60693 .32448 L F P
0 g
s
.963 .267 .107 r
.60649 .31493 m .63252 .3297 L p .60682 .32212 L F P
0 g
s
.963 .267 .107 r
.60649 .31493 m .60682 .32212 L .6058 .32182 L F
.63252 .3297 m .64095 .40409 L p .60693 .32448 L F P
0 g
s
.848 .229 .091 r
.63252 .3297 m .60649 .31493 L p .60183 .28081 L F P
0 g
s
.153 .209 .43 r
.60183 .28081 m .60649 .31493 L .6111 .26891 L F
.56696 .32555 m .60649 .31493 L p .60183 .28081 L F P
0 g
s
.848 .229 .091 r
.59362 .26773 m .60183 .28081 L .60649 .31493 L F
.60169 .31222 m .57983 .24577 L p .59362 .26773 L F P
0 g
s
.848 .229 .091 r
.60649 .31493 m .60169 .31222 L p .59362 .26773 L F P
0 g
s
.181 .252 .514 r
.56257 .39953 m .6099 .38783 L p .60693 .32448 L F P
0 g
s
.963 .267 .107 r
.64095 .40409 m .6099 .38783 L .60169 .31222 L p F P
0 g
s
.181 .252 .514 r
.6099 .38783 m .6125 .33698 L p .60693 .32448 L F P
0 g
s
.181 .252 .514 r
.6125 .33698 m .61372 .31299 L p .60841 .32198 L F P
0 g
s
.181 .252 .514 r
.60693 .32448 m .6125 .33698 L .60841 .32198 L F
.61372 .31299 m .60649 .31493 L p .60693 .32448 L F P
0 g
s
.963 .267 .107 r
.6058 .32182 m .60682 .32212 L .60693 .32448 L F
.60169 .31222 m .60649 .31493 L p .6058 .32182 L F P
0 g
s
.153 .209 .43 r
.61372 .31299 m .62663 .24899 L p .6111 .26891 L F P
0 g
s
.153 .209 .43 r
.60649 .31493 m .61372 .31299 L p .6111 .26891 L F P
0 g
s
1 .305 .125 r
.63489 .48353 m .66515 .49783 L .64511 .57646 L p F P
0 g
s
1 .29 .118 r
.66515 .49783 m .63489 .48353 L .64095 .40409 L p F P
0 g
s
1 .316 .13 r
.61436 .56361 m .64511 .57646 L .61172 .65112 L p F P
0 g
s
.181 .252 .514 r
.51651 .41093 m .56257 .39953 L .56696 .32555 L p F P
0 g
s
.2 .284 .576 r
.56257 .39953 m .51651 .41093 L .52152 .4904 L p F P
0 g
s
1 .305 .125 r
.64511 .57646 m .61436 .56361 L .63489 .48353 L p F P
0 g
s
1 .327 .136 r
.48076 .76324 m .4468 .75395 L .50165 .69703 L p F P
0 g
s
1 .327 .136 r
.50165 .69703 m .53492 .70749 L .48076 .76324 L p F P
0 g
s
.229 .333 .668 r
.58309 .56214 m .53636 .57143 L .56016 .64901 L p F P
0 g
s
.242 .354 .709 r
.6551 .63242 m .60698 .64083 L .63806 .7113 L p F P
0 g
s
.242 .354 .709 r
.63806 .7113 m .68607 .70395 L .6551 .63242 L p F P
0 g
s
.2 .284 .576 r
.52152 .4904 m .56799 .48001 L .56257 .39953 L p F P
0 g
s
.216 .31 .625 r
.56799 .48001 m .52152 .4904 L .53636 .57143 L p F P
0 g
s
1 .29 .118 r
.6099 .38783 m .64095 .40409 L .63489 .48353 L p F P
0 g
s
.216 .31 .625 r
.53636 .57143 m .58309 .56214 L .56799 .48001 L p F P
0 g
s
1 .323 .134 r
.53492 .70749 m .50165 .69703 L .5478 .62787 L p F P
0 g
s
1 .323 .134 r
.5478 .62787 m .58037 .63972 L .53492 .70749 L p F P
0 g
s
.2 .284 .576 r
.6099 .38783 m .56257 .39953 L .56799 .48001 L p F P
0 g
s
.2 .284 .576 r
.56799 .48001 m .60835 .47099 L p .6099 .38783 L F P
0 g
s
1 .29 .118 r
.63489 .48353 m .60835 .47099 L p .6099 .38783 L F P
0 g
s
1 .29 .118 r
.60835 .47099 m .60347 .46868 L .60556 .44238 L p F P
0 g
s
1 .29 .118 r
.60556 .44238 m .6099 .38783 L p .60835 .47099 L F P
0 g
s
1 .305 .125 r
.63489 .48353 m .61436 .56361 L p .60654 .49549 L F P
0 g
s
.216 .31 .625 r
.60654 .49549 m .60726 .48576 L .56799 .48001 L F
1 .305 .125 r
.60544 .48591 m .60726 .48576 L .60654 .49549 L F
.60726 .48576 m .63489 .48353 L .60654 .49549 L F
.216 .31 .625 r
.56799 .48001 m .58309 .56214 L p .60654 .49549 L F P
0 g
s
.216 .31 .625 r
.60654 .49549 m .60983 .48614 L .60726 .48576 L F
1 .305 .125 r
.60835 .47099 m .63489 .48353 L p .60726 .48576 L F P
0 g
s
.216 .31 .625 r
.60835 .47099 m .56799 .48001 L p .60726 .48576 L F P
0 g
s
1 .305 .125 r
.60835 .47099 m .60726 .48576 L .60544 .48591 L F
.216 .31 .625 r
.60983 .48614 m .60835 .47099 L .60726 .48576 L F
.61575 .46934 m .60835 .47099 L p .60983 .48614 L F P
0 g
s
.2 .284 .576 r
.60835 .47099 m .61575 .46934 L .61384 .44284 L p F P
0 g
s
.2 .284 .576 r
.61384 .44284 m .6099 .38783 L p .60835 .47099 L F P
0 g
s
1 .305 .125 r
.60347 .46868 m .60835 .47099 L p .60544 .48591 L F P
0 g
s
.229 .333 .668 r
.6019 .5584 m .58309 .56214 L .59601 .6047 L p F P
0 g
s
.216 .31 .625 r
.63112 .5526 m .61575 .46934 L p .60654 .49549 L F P
0 g
s
.216 .31 .625 r
.58309 .56214 m .6019 .5584 L p .60654 .49549 L F P
0 g
s
1 .305 .125 r
.61436 .56361 m .6019 .5584 L p .60654 .49549 L F P
0 g
s
.216 .31 .625 r
.6019 .5584 m .63112 .5526 L p .60654 .49549 L F P
0 g
s
1 .305 .125 r
.58242 .55027 m .60347 .46868 L p .60654 .49549 L F P
0 g
s
1 .305 .125 r
.6019 .5584 m .58242 .55027 L p .60654 .49549 L F P
0 g
s
1 .316 .13 r
.58242 .55027 m .6019 .5584 L p .58037 .63972 L F P
0 g
s
1 .316 .13 r
.6019 .5584 m .61436 .56361 L .59601 .6047 L p F P
0 g
s
1 .316 .13 r
.59601 .6047 m .58037 .63972 L p .6019 .5584 L F P
0 g
s
.229 .333 .668 r
.63112 .5526 m .6019 .5584 L p .60698 .64083 L F P
0 g
s
.229 .333 .668 r
.59601 .6047 m .60698 .64083 L p .6019 .5584 L F P
0 g
s
.229 .333 .668 r
.60698 .64083 m .6551 .63242 L .63112 .5526 L p F P
0 g
s
1 .316 .13 r
.58037 .63972 m .5478 .62787 L .58242 .55027 L p F P
0 g
s
.25 Mabswid
.61074 0 m
.96194 .26706 L
s
.96194 .26706 m
1 .90216 L
s
1 .90216 m
.62118 .79761 L
s
.62118 .79761 m
.61074 0 L
s
.04338 .2036 m
0 .87776 L
s
0 .87776 m
.62118 .79761 L
s
.62118 .79761 m
.61074 0 L
s
.61074 0 m
.04338 .2036 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{500, 475.688},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40007d0001fb000`400?l00000o`00003oo`3oool`
0?ooo`800000``3oool00?l0oooo;@3oool3000000030?ooo`00000000000<80oooo003o0?ooobX0
oooo0`0000040?ooo`040000003oool0000000000<00oooo003o0?ooobP0oooo0P0000070?ooo`05
0000003oool0oooo0?ooo`000000_`3oool00?l0oooo9@3oool3000000T0oooo00<000000?ooo`3o
ool00P3oool00`000000oooo0?ooo`2l0?ooo`00o`3ooolR0?ooo`<00000303oool00`000000oooo
0?ooo`030?ooo`800000_03oool00?l0oooo7`3oool3000000l0oooo00<000000?ooo`3oool01@3o
ool00`000000oooo0?ooo`2i0?ooo`00o`3ooolL0?ooo`<000004P3oool00`000000oooo0?ooo`06
0?ooo`030000003oool0oooo0;P0oooo003o0?oooaX0oooo0P00000E0?ooo`030000003oool0oooo
00L0oooo0P00002h0?ooo`00o`3ooolG0?ooo`<000005`3oool00`000000oooo0?ooo`090?ooo`03
0000003oool0oooo0;D0oooo003o0?oooa@0oooo0`00000J0?ooo`030000003oool0oooo00X0oooo
00<000000?ooo`3oool0]03oool00?l0oooo4@3oool3000001d0oooo00<000000?ooo`3oool02`3o
ool200000;@0oooo003o0?ooo`h0oooo0`00000P0?ooo`030000003oool0oooo00d0oooo00<00000
0?ooo`3oool0/@3oool00?l0oooo303oool2000002<0oooo00<000000?ooo`3oool03P3oool00`00
0000oooo0?ooo`2`0?ooo`00o`3oool90?ooo`<000009@3oool00`000000oooo0?ooo`0?0?ooo`80
0000/03oool00?l0oooo1P3oool3000002P0oooo00<000000?ooo`3oool04@3oool00`000000oooo
0?ooo`2]0?ooo`00o`3oool30?ooo`<00000:`3oool00`000000oooo0?ooo`0B0?ooo`030000003o
ool0oooo0:`0oooo003o0?ooo`<00000;P3oool00`000000oooo0?ooo`0C0?ooo`800000[03oool0
0?d0oooo0P00000a0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3oool0Z@3oool00?X0
oooo0`00000c0?ooo`030000003oool0oooo01H0oooo00<000000?ooo`3oool0Z03oool00?L0oooo
0`00000f0?ooo`030000003oool0oooo01L0oooo00<000000?ooo`3oool0Y`3oool00?@0oooo0`00
000i0?ooo`030000003oool0oooo01P0oooo0P00002W0?ooo`00l@3oool3000003`0oooo00<00000
0?ooo`3oool06P3oool00`000000oooo0?ooo`2T0?ooo`00k`3oool2000003l0oooo00<000000?oo
o`3oool06`3oool00`000000oooo0?ooo`2S0?ooo`00k03oool300000440oooo00<000000?ooo`3o
ool0703oool200000:<0oooo003Y0?ooo`<00000A03oool00`000000oooo0?ooo`0N0?ooo`030000
003oool0oooo0:00oooo003V0?ooo`<00000A`3oool00`000000oooo0?ooo`0O0?ooo`030000003o
ool0oooo09l0oooo003S0?ooo`<00000BP3oool00`000000oooo0?ooo`0P0?ooo`800000W`3oool0
0>40oooo0P00001=0?ooo`030000003oool0oooo0280oooo00<000000?ooo`3oool0W03oool00=h0
oooo0`00001?0?ooo`030000003oool0oooo02<0oooo00<000000?ooo`3oool0V`3oool00=/0oooo
0`00001B0?ooo`030000003oool0oooo02@0oooo0P00002K0?ooo`00f03oool3000005D0oooo00<0
00000?ooo`3oool09P3oool00`000000oooo0?ooo`2H0?ooo`00e@3oool3000005P0oooo00<00000
0?ooo`3oool09`3oool00`000000oooo0?ooo`2G0?ooo`00d`3oool2000005/0oooo00<000000?oo
o`3oool0:03oool2000009L0oooo003@0?ooo`<00000G@3oool00`000000oooo0?ooo`0Z0?ooo`03
0000003oool0oooo09@0oooo003=0?ooo`<00000H03oool00`000000oooo0?ooo`0[0?ooo`030000
003oool0oooo09<0oooo003:0?ooo`<00000H`3oool00`000000oooo0?ooo`0/0?ooo`800000T`3o
ool00<L0oooo0`00001V0?ooo`030000003oool0oooo02h0oooo00<000000?ooo`3oool0T03oool0
0<D0oooo0P00001Y0?ooo`030000003oool0oooo02l0oooo00<000000?ooo`3oool0S`3oool00<80
oooo0`00001[0?ooo`030000003oool0oooo0300oooo00<000000?ooo`3oool0SP3oool00;l0oooo
0`00001_0?ooo`030000003oool0oooo0300oooo0P00002>0?ooo`00_03oool300000780oooo00<0
00000?ooo`3oool0<P3oool00`000000oooo0?ooo`2;0?ooo`00^@3oool3000007D0oooo00<00000
0?ooo`3oool0<`3oool00`000000oooo0?ooo`2:0?ooo`00]`3oool2000007P0oooo00<000000?oo
o`3oool0=03oool2000008X0oooo002d0?ooo`<00000NP3oool00`000000oooo0?ooo`0f0?ooo`03
0000003oool0oooo08L0oooo002a0?ooo`<00000O@3oool00`000000oooo0?ooo`0g0?ooo`030000
003oool0oooo08H0oooo002^0?ooo`<00000P03oool00`000000oooo0?ooo`0h0?ooo`800000QP3o
ool00:/0oooo0`0000230?ooo`030000003oool0oooo03X0oooo00<000000?ooo`3oool0P`3oool0
0:T0oooo0P0000260?ooo`030000003oool0oooo03/0oooo00<000000?ooo`3oool0PP3oool00:H0
oooo0`0000280?ooo`030000003oool0oooo03`0oooo0P0000220?ooo`00X`3oool3000008/0oooo
00<000000?ooo`3oool0?P3oool00`000000oooo0?ooo`1o0?ooo`00X03oool3000008h0oooo00<0
00000?ooo`3oool0?`3oool00`000000oooo0?ooo`1n0?ooo`00W@3oool300000940oooo00<00000
0?ooo`3oool0@03oool2000007h0oooo002K0?ooo`800000U03oool00`000000oooo0?ooo`120?oo
o`030000003oool0oooo07/0oooo002H0?ooo`<00000UP3oool00`000000oooo0?ooo`130?ooo`03
0000003oool0oooo07X0oooo002E0?ooo`<00000V@3oool00`000000oooo0?ooo`140?ooo`800000
NP3oool00980oooo0`00002L0?ooo`030000003oool0oooo04H0oooo00<000000?ooo`3oool0M`3o
ool008l0oooo0`00002O0?ooo`030000003oool0oooo04L0oooo00<000000?ooo`3oool0MP3oool0
08d0oooo0P00002R0?ooo`030000003oool0oooo04P0oooo00<000000?ooo`3oool0M@3oool008X0
oooo0`00000c0?ooo`X00000I`3oool00`000000oooo0?ooo`190?ooo`800000M@3oool008L0oooo
0`00000X0?ooo`h000001`3VAQh2000000030;8h6@000000000000D00000H03oool00`000000oooo
0?ooo`1;0?ooo`030000003oool0oooo0780oooo00240?ooo`<000008P3oool9000001L0iTHN0P00
00060;8h6@H00000FP3oool00`000000oooo0?ooo`1<0?ooo`030000003oool0oooo0740oooo0021
0?ooo`<000008P3oool300000080od`P0P00000N0>I67P8000002P2b>1T7000005<0oooo00<00000
0?ooo`3oool0C@3oool200000740oooo001o0?ooo`8000008`3oool2000000L0od`P00<000000>I6
7P3VAQh07@3VAQh00`000000/SPI0;8h6@0>0;8h6@D00000CP3oool00`000000oooo0?ooo`1?0?oo
o`030000003oool0oooo06h0oooo001l0?ooo`<000008P3oool3000000X0od`P0P00000N0>I67P80
00004P2b>1T3000004`0oooo00<000000?ooo`3oool0D03oool00`000000oooo0?ooo`1]0?ooo`00
N@3oool300000280oooo0`00000?0?m<808000007P3VAQh200000180/SPI0`00001:0?ooo`030000
003oool0oooo0540oooo0P00001]0?ooo`00MP3oool300000280oooo0`00000D0?m<80030000003V
AQh0iTHN01d0iTHN0P00000A0;8h6@@00000B03oool00`000000oooo0?ooo`1C0?ooo`030000003o
ool0oooo06X0oooo001c0?ooo`<000008P3oool3000001P0od`P0P00000O0>I67P8000004@2b>1T4
000004H0oooo00<000000?ooo`3oool0E03oool00`000000oooo0?ooo`1Y0?ooo`00L@3oool20000
02<0oooo0P00000M0?m<80030000003VAQh0iTHN01X0iTHN1`00000@0;8h6@040000001a91000000
000004@0oooo00<000000?ooo`3oool0E@3oool2000006T0oooo001^0?ooo`<000008P3oool30000
0200od`P0P00000A0>I67PT000001@3VAQh8000000/0/SPI0P0000000`1a91000000000000120?oo
o`030000003oool0oooo05L0oooo00<000000?ooo`3oool0IP3oool006/0oooo0`00000R0?ooo`<0
00009@3oC202000000D0iTHN2P00000@0>I67P800000102b>1T5000000P0/SPI00<00000074T401a
91000P0000100?ooo`030000003oool0oooo05P0oooo00<000000?ooo`3oool0I@3oool006P0oooo
0`00000S0?ooo`800000:P3oC205000001`0iTHN00<000000;8h6@2b>1T01P2b>1T5000000@0/SPI
0P000002074T40800000?P3oool00`000000oooo0?ooo`1I0?ooo`800000I@3oool006D0oooo0`00
000T0?ooo`80000000<0odhQ0000000000009@3oC20300000080od`P0P00000O0>I67P8000002`2b
>1T5000000030;8h6@00000000000080LB@@0P00000l0?ooo`030000003oool0oooo03D0oooo2P00
000L0?ooo`030000003oool0oooo0680oooo001S0?ooo`8000009@3oool2000000D0odhQ0P00000P
0?m<80<000001`3oC202000001l0iTHN0P00000?0;8h6@@000000P1a9102000003X0oooo00<00000
0?ooo`3oool0:`3oool:000000<0?V>o1000000304U`g0<000006P3oool00`000000oooo0?ooo`1Q
0?ooo`00H03oool3000002H0oooo00<000000?m>8@3oCR401`3oCR42000001/0od`P0`00000<0?m<
80030000003VAQh0iTHN01h0iTHN00<000000;8h6@2b>1T03`2b>1T300000080LB@@0P00000h0?oo
o`030000003oool0oooo02L0oooo1@00000803iS_`@000002P19L=`3000001P0oooo0P00001Q0?oo
o`00G@3oool3000002L0oooo0P00000<0?m>8@030000003oC200od`P01D0od`P0`00000@0?m<8080
00007`3VAQh200000140/SPI0`000002074T40800000=P3oool00`000000oooo0?ooo`0S0?ooo`@0
000000<01PPA0000000000001`0nHkl300000140BG3L0P00000H0?ooo`030000003oool0oooo05h0
oooo001J0?ooo`<00000:03oool2000000l0odhQ0P00000A0?m<80@000005@3oC202000001l0iTHN
0P00000A0;8h6@<000000P1a9102000003@0oooo00<000000?ooo`3oool0803oool3000000<01PPA
0P00000503iS_`@000005P19L=`3000001H0oooo00<000000?ooo`3oool0G@3oool005L0oooo0`00
000Z0?ooo`030000003oCR40odhQ0140odhQ0P00000<0?m<80<000006`3oC2000`000000iTHN0>I6
7P0J0>I67PL000003`2b>1T400000003074T40000000000003<0oooo00<000000?ooo`3oool0703o
ool4000000D01PPA00@0000003iS_`0nHkl0?V>o1000000M04U`g0<00000503oool00`000000oooo
0?ooo`1L0?ooo`00E@3oool2000002/0oooo0P00000F0?m>8@8000001`3oC203000001l0od`P0P00
000A0>I67PT000001@3VAQh8000000/0/SPI1`00000a0?ooo`030000003oool0oooo01P0oooo1000
000700H84@H000009019L=`2000001<0oooo0P00001L0?ooo`00DP3oool3000002/0oooo0P00000J
0?m>8@8000000P3oC203000002@0od`P0P0000050>I67PX00000403VAQh2000000@0/SPI1@000008
0;8h6@050000001a910000000000001Y60T00P00000_0?ooo`030000003oool0oooo01D0oooo0`00
000900H84@D000000`19L=`3000001d0BG3L1000000204U_fP8000004`3oool00`000000oooo0?oo
o`1I0?ooo`00C`3oool3000002`0oooo0P00000N0?m>8@800000:@3oC205000001`0iTHN00<00000
0;8h6@2b>1T01P2b>1T5000000@0/SPI0P0000001@1a910000000000001Y60T0000002h0oooo00<0
00000?ooo`3oool04P3oool4000000T01PPA1000000904U`g0<000005`19L=`3000000P0BFoJ00<0
00000?ooo`3oool04@3oool00`000000oooo0?ooo`1H0?ooo`00C03oool3000002h0oooo00<00000
0?m>8@3oCR40703oCR42000000030?m>8@000000000002@0od`P0`0000020?m<808000007`3VAQh2
000000/0/SPI1@0000001P2b>1T000000000001a9100000006TH2@800000;03oool00`000000oooo
0?ooo`0?0?ooo`<0000000<01PPA00000006214020062143000000l0BG3L0`00000@04U`g0@00000
3019KmX00`000000oooo0?ooo`0A0?ooo`800000F03oool004T0oooo0`00000_0?ooo`8000007@3o
CR42000000D0odhQ0P00000O0?m<80<000001`3oC202000001l0iTHN0P00000?0;8h6@D000000P1Y
60T00`000000oooo0?ooo`0Y0?ooo`030000003oool0oooo00`0oooo0`00000200H84@8000002006
2142000001D0BG3L0`00000:04U`g0<000004@19KmX2000001<0oooo00<000000?ooo`3oool0E@3o
ool004L0oooo0P00000`0?ooo`8000007P3oCR400`000000odhQ0?m>8@070?m>8@030000003oC200
od`P01T0od`P0`00000<0?m<80030000003VAQh0iTHN01h0iTHN00<000000;8h6@2b>1T03`2b>1T3
00000080JAP90P00000Y0?ooo`030000003oool0oooo00T0oooo0`00000300H84@8000001`062144
000001T0BG3L0`00000304U`g0@000005P19KmX00`000000oooo0?ooo`0A0?ooo`030000003oool0
oooo05@0oooo00140?ooo`<00000<@3oool00`000000odhQ0?m>8@0L0?m>8@8000002`3oCR420000
01H0od`P0`00000@0?m<808000007`3VAQh200000140/SPI0P00000306TH2@8000009`3oool00`00
0000oooo0?ooo`060?ooo`<000001@0621400`0000001PPA00H84@0400H84@<000000P0>4B800`00
0000BG3L04U`g00K04U`g0<000006`19KmX00`000000oooo0?ooo`0A0?ooo`800000E03oool00440
oooo0`00000b0?ooo`8000007@3oCR42000000l0odhQ0P00000@0?m<80@000005@3oC202000001l0
iTHN0P00000@0;8h6@800000101Y60T00`000000oooo0?ooo`0T0?ooo`030000003oool0oooo00<0
oooo0`00000600H84@80000010062143000000D03Q4R00<0000004U`g019L=`06019L=`300000080
BFoJ0P00000K04U_fP8000004`3oool00`000000oooo0?ooo`1A0?ooo`00?P3oool3000003<0oooo
0P00000N0?m>8@030000003oCR40odhQ0140odhQ00<000000?m<803oC2002P3oC203000001/0od`P
00<000000>I67P3VAQh06P3VAQh7000000l0/SPI00<0000006TH2@1Y60T00P1Y60T2000002@0oooo
00<000000?ooo`3oool00`00000800H84@030000000621401PPA00@000001`0>4B800`000000BG3L
04U`g00E04U`g0@000001`19KmX00`000000BFoJ04U_fP0J04U_fP030000003oool0oooo0140oooo
00<000000?ooo`3oool0D03oool003/0oooo0`00000e0?ooo`030000003oCR40odhQ01`0odhQ0P00
000E0?m>8@8000001`3oC203000001l0od`P0P00000A0>I67PT000001@3VAQh7000000/0/SPI00<0
000006TH2@1Y60T00P1Y60T300000240oooo1@00000800H84@D000002P0>4B8400000180BG3L0`00
000<04U_fP0300000019KmX0BFoJ01X0BFoJ0P00000B0?ooo`800000D03oool003T0oooo0P00000g
0?ooo`040000003oCb400000000001X0odhQ0P00000I0?m>8@8000000P3oC203000002@0od`P0P00
00050>I67PX00000403VAQh00`000000/SPI0;8h6@020;8h6@D000001`2b>1T00`000000JAP906TH
2@0206TH2@030000001Y60T0000001d0oooo0`0000000`06214000000000000800H84@@00000300>
4B800`000000BG3L04U`g00204U`g0@000002`19L=`300000100BFoJ0P00000L04U_fP030000003o
ool0oooo0140oooo00<000000?ooo`3oool0C@3oool003H0oooo0`00000h0?ooo`030000003oCb40
odlQ0080odlQ0P00000F0?m>8@8000007@3oCR42000002T0od`P1@00000K0>I67P8000001`2b>1T6
00000080/SPI00<0000006TH2@1Y60T00P1Y60T4000001L0oooo100000000`062140?V>o00000002
000000L01PPA0`00000?00hA8P0300000019L=`0BG3L00H0BG3L1000000304U`g0@000005@19KmX0
0`000000BFoJ04U_fP0J04U_fP030000003oool0oooo0140oooo00<000000?ooo`3oool0C03oool0
03<0oooo0`00000j0?ooo`030000003oCb40odlQ00D0odlQ0P00000C0?m>8@030000003oCR40odhQ
01/0odhQ0P0000000`3oCR4000000000000S0?m<80@000000P3oC202000001l0iTHN00<000000;8h
6@2b>1T02P2b>1T5000000<0JAP900<0000006TH2@1Y60T00P00000B0?ooo`<00000100621420000
00801PPA00@0000000H84@0621401PPA1@00000@00hA8P0300000019L=`0BG3L00/0BG3L0`00000J
04U_fP0300000019KmX0BFoJ01X0BFoJ0P00000B0?ooo`800000C03oool00300oooo0`00000l0?oo
o`030000003oCb40odlQ00P0odlQ00<000000?m>8@3oCR403P3oCR42000001`0odhQ0P0000050?m>
8@8000007P3oC203000000P0od`P0P00000N0>I67P8000003`2b>1T01@000000JAP906TH2@1Y60T0
000000<0JAP900<000000?ooo`3oool02`3oool4000000D01PPA0P00000400H84@@000000`0>4B80
0`0000003Q4R00hA8P0>00hA8P0300000019L=`0BG3L00P0BG3L1000000204U_fP0300000019KmX0
BFoJ01T0BFoJ0P00000K04U_fP8000004`3oool00`000000oooo0?ooo`190?ooo`00;@3oool30000
03h0oooo00<000000?m?8@3oCb402P3oCb42000000`0odhQ0P00000L0?m>8@8000002@3oCR420000
01T0od`P0`00000=0?m<808000007P3VAQh2000000h0/SPI00D0000006TH2@1Y60T0JAP900000003
06TH2@800000203oool3000000D01PPA00@0000000H84@00000000000`062144000000H03Q4R00<0
000000hA8P0>4B803@0>4B800`000000BG3L04U`g00604U`g0<000001`19KmX2000001/0BFoJ00<0
000004U_fP19KmX05019KmX400000080AfWA00<000000?ooo`3oool04@3oool00`000000oooo0?oo
o`180?ooo`00:`3oool2000003l0oooo0P00000?0?m?8@8000002@3oCR400`000000odhQ0?m>8@0K
0?m>8@030000003oCR40odhQ00/0odhQ0P00000C0?m<80@000004P3oC2000`000000iTHN0>I67P0M
0>I67P030000002b>1T0/SPI00`0/SPI00L0000006TH2@1Y60T0JAP90000001Y60T0LB@@0080JAP9
0P0000030?ooo`@000001`0621420000000300H84@0000000000008000000`0>4B800`0000003Q4R
00hA8P0300hA8P030000000>4B803Q4R00h03Q4R00<0000004U`g019L=`00P19L=`4000000`0BFoJ
00<0000004U_fP19KmX06@19KmX200000140BFoJ0`00000704MYd@030000003oool0oooo0140oooo
0P0000180?ooo`00:03oool300000400oooo00<000000?m?8@3oCb404@3oCb42000000D0odhQ0P00
000L0?m>8@800000403oCR42000000h0od`P0`00000G0?m<808000007P3VAQh2000000d0/SPI00D0
000006TH2@1Y60T0JAP90000000506TH2@D000001`062145000000L03Q4R00<0000000hA8P0>4B80
0P0>4B800`0000003Q4R00hA8P0>00hA8P0300000019L=`0BG3L00<000004@19KmX00`000000BFoJ
04U_fP0J04U_fP0300000019KmX0BFoJ00X0BFoJ1000000;04MYd@030000003oool0oooo0180oooo
00<000000?ooo`3oool0A@3oool002D0oooo0`0000120?ooo`030000003oCb40odlQ01@0odlQ0P00
00000`3oCR4000000000000L0?m>8@800000503oCR42000000T0od`P0`00000L0?m<80800000603V
AQh9000000/0/SPI00@0000006TH2@1Y60T0JAP90P00000406TH2@800000100621400`0nHkl01PPA
00H84@03000000/03Q4R00D0000000hA8P0>4B803Q4R0000000@00hA8P@000005@19KmX2000001/0
BFoJ00<0000004U_fP19KmX01P19KmX300000100AfWA00<000000?ooo`3oool04P3oool00`000000
oooo0?ooo`140?ooo`008P3oool3000004@0oooo00<000000?m?8@3oCb405`3oCb400`000000odhQ
0?m>8@0K0?m>8@030000003oCR40odhQ01H0odhQ0P0000030?m<80@000008@3oC202000000P0iTHN
3P0000070>I67PL000001`2b>1T2000000<0JAP900<0000006TH2@1Y60T00P1Y60T20000000300H8
4@0nHkl0000000@000003@0>4B80100000003Q4R00hA8P00000@00hA8P0300000019KmX0BFoJ01T0
BFoJ00<0000004U_fP19KmX06@19KmX200000080BFoJ1000000C04MYd@030000003oool0oooo01<0
oooo00<000000?ooo`3oool0@`3oool001l0oooo0`0000160?ooo`030000003oCb40odlQ01L0odlQ
00@000000?m?8@00000000006@3oCR42000001/0odhQ0`00000W0?m<80P000005`3VAQh00`000000
/SPI0;8h6@020;8h6@H0000000@0/SPI0000002T:Q0000000`1Y60T00`000000JAP900H84@0306TH
2@800000100>4B800`0000003Q4R00hA8P0;00hA8P030000000>4B80000001403Q4R0P00000K04U_
fP0300000019KmX0BFoJ01T0BFoJ0`00000H04MYd@030000003oool0oooo01<0oooo0P0000130?oo
o`007@3oool2000004P0oooo00<000000?m?8@3oCb405`3oCb400`000000odlQ0?m?8@020?m?8@80
00005@3oCR42000001`0odhQ0P0000000`3oCR4000000000000R0?m<80<000000P3oC202000001d0
iTHN0P0000050;8h6@8000000`06214010000000Y2X@00000000000206TH2@030000001Y60T0JAP9
0080JAP900<0000000hA8P0>4B800P0>4B800`0000003Q4R00hA8P0<00hA8P030000000>4B800000
01003Q4R00@0000004U_fP19KmX000006`19KmX2000001D0BFoJ1000000204MYd@0300000017JM40
AfWA01L0AfWA00<000000?ooo`3oool0503oool00`000000oooo0?ooo`100?ooo`006P3oool30000
04T0oooo00<000000?m?8@3oCb405`3oCb400`000000odlQ0?m?8@050?m?8@8000004@3oCR420000
01`0odhQ0P0000050?m>8@030000003oC200od`P01`0od`P0`0000070?m<808000007@3VAQh40000
00L01PPA00@000000:@Z402T:Q0000000P1Y60T00`000000JAP906TH2@0206TH2@040000000>4B80
3Q4R000000l03Q4R0P00000?00hA8P8000001019KmX2000001/0BFoJ00<0000004U_fP19KmX03`19
KmX3000000L0AfWA00<0000004MYd@17JM405`17JM400`000000oooo0?ooo`0D0?ooo`030000003o
ool0oooo03l0oooo000G0?ooo`<00000B`3oool00`000000odlQ0?m?8@0F0?m?8@8000002P3oCb42
000000h0odhQ00<000000?m>8@3oCR406P3oCR42000000P0odhQ0P00000I0?m<80<00000303oC202
000001X0iTHN1000000700H84@8000000`2T:Q020000000306TH2@000000JAP900<0JAP900<00000
00hA8P0000003`0>4B800`0000003Q4R00hA8P0;00hA8P<0000000<072A<00000019KmX01@19KmX2
000001X0BFoJ00<0000004U_fP19KmX02P19KmX4000000/0AfWA00<0000004MYd@17JM405`17JM40
0`000000oooo0?ooo`0D0?ooo`800000?`3oool001D0oooo0P00001=0?ooo`030000003oCb40odlQ
01H0odlQ00<000000?m?8@3oCb40303oCb42000000X0odhQ0P00000K0?m>8@800000303oCR400`00
0000od`P0?m<800C0?m<80<000004@3oC2000`000000iTHN0>I67P0D0>I67PD000001`0621450000
00@0Y2X@00<0000006TH2@0000000P1Y60T00`0>4B80JAP900hA8P0?00hA8P8000002@0>4B840000
00<072A<00<0000004U_fP19KmX01`19KmX00`000000BFoJ04U_fP0H04U_fP8000001`19KmX30000
0100AfWA00<0000004MYd@17JM405`17JM400`000000oooo0?ooo`0E0?ooo`030000003oool0oooo
03`0oooo000E0?ooo`040000003oool00000000004X0oooo00<000000?m?8@3oCb405P3oCb400`00
0000odlQ0?m?8@0?0?m?8@8000001P3oCR42000001`0odhQ00<000000?m>8@3oCR403@3oCR420000
0100od`P0`00000E0?m<80800000403VAQh40000000300H84@000000000000L01PPA0`00000300hA
8P030000002T:Q00Y2X@00<0Y2X@0`00000206TH2@030000001Y60T03Q4R00d03Q4R00<0000000hA
8P0000001P0>4B83000000L072A<00<0000004U_fP19KmX02019KmX2000001X0BFoJ00<0000004U_
fP19KmX01000000D04MYd@0300000017JM40AfWA01L0AfWA00<000000?ooo`3oool05@3oool00`00
0000oooo0?ooo`0k0?ooo`005@3oool010000000oooo0?ooo`3oool2000004L0oooo00<000000?m?
8@3oCb405P3oCb400`000000odlQ0?m?8@0B0?m?8@8000000P3oCR42000001`0odhQ0P00000B0?m>
8@8000002`3oC203000001X0od`P0P00000;0>I67P<000000`062142000000D01PPA1@00000600hA
8P030000002T:Q00Y2X@00@0Y2X@0P00000406TH2@`03Q4R00@0000000hA8P0>4B8000000`0>4B83
000000T072A<00<0000004U_fP19KmX02`19KmX00`000000BFoJ04U_fP0G04U_fP<000006@17JM40
0`000000AfWA04MYd@0G04MYd@030000003oool0oooo01D0oooo0P00000k0?ooo`005@3oool00`00
0000oooo0?ooo`030?ooo`800000@`3oool2000001P0odlQ00<000000?m?8@3oCb405@3oCb420000
01`0odhQ0P00000F0?m>8@030000003oC200od`P00D0od`P0`00000O0?m<808000001P3VAQh30000
00@01PPA0P00000400H84@<000000`0>4B800`0000003Q4R00hA8P0600hA8P030000002T:Q003Q4R
00@0Y2X@0P00000306TH2@`03Q4R00<0000000hA8P0>4B801000000<01`TC00300000019KmX0BFoJ
00`0BFoJ0P00000C04U_fP@000000P17JM400`000000AfWA04MYd@0H04MYd@0300000017JM40AfWA
01L0AfWA00<000000?ooo`3oool05P3oool00`000000oooo0?ooo`0h0?ooo`005@3oool00`000000
oooo0?ooo`050?ooo`800000@03oool00`000000odlQ0?m?8@0G0?m?8@030000003oCb40odlQ01H0
odlQ00@000000?m?8@0000000000603oCR42000001T0odhQ0P0000020?m<80<00000903oC2060000
00D01PPA0P00000200H84@@000001@0>4B800`0000003Q4R00hA8P0700hA8P030000002T:Q00Y2X@
00H0Y2X@00@0000006TH2@1Y60T0JAP92P0>4B85000000h072A<00<0000004U_fP19KmX03`19KmX2
000000d0BFoJ1000000704MYd@0300000017JM40AfWA01P0AfWA00<0000004MYd@17JM405P17JM40
0`000000oooo0?ooo`0G0?ooo`030000003oool0oooo03L0oooo000E0?ooo`030000003oool0oooo
00L0oooo0P00000m0?ooo`030000003oCb40odlQ01L0odlQ00<000000?m?8@3oCb405P3oCb400`00
0000odlQ0?m?8@020?m?8@800000503oCR42000001d0odhQ0P00000S0?m<80<0000000<0od`P0000
000000000P00000500H84@80000000@01PPA0000000000000000200>4B800`0000003Q4R00hA8P09
00hA8P030000002T:Q00Y2X@00H0Y2X@0P0000000`1Y60T03Q4R00hA8P0600hA8P<000000`0L94`0
0`00000072A<01`TC00<01`TC00300000019KmX0BFoJ0140BFoJ00<0000004U_fP19KmX01P19KmX4
000000`0AfWA00<0000004MYd@17JM405`17JM400`000000AfWA04MYd@0G04MYd@030000003oool0
oooo01L0oooo0P00000g0?ooo`005@3oool00`000000oooo0?ooo`090?ooo`800000>P3oool00`00
0000odlQ0?m?8@0F0?m?8@800000603oCb400`000000odlQ0?m?8@050?m?8@8000004@3oCR400`00
0000odhQ0?m>8@0K0?m>8@80000000<0odhQ0000000000007`3oC2060000000300H84@0000000000
00D01PPA1@00000;00hA8P030000000>4B803Q4R00X03Q4R00<000000:@Z402T:Q001@2T:Q001000
0000Y2X@00000000000300hA8P@0000000<072A<0000000L94`00`0L94`00`00000072A<01`TC00;
01`TC00300000019KmX0BFoJ01<0BFoJ0P00000204U_fP@000004@17JM400`000000AfWA04MYd@0G
04MYd@0300000017JM40AfWA01L0AfWA00<000000?ooo`3oool0603oool00`000000oooo0?ooo`0d
0?ooo`005@3oool00`000000oooo0?ooo`0;0?ooo`800000=`3oool00`000000odlQ0?m?8@0F0?m?
8@030000003oCb40odlQ01H0odlQ0P00000:0?m?8@8000003@3oCR42000001`0odhQ0P0000050?m>
8@8000006P3oC206000000801PPA0P00000500H84@<000003P0>4B800`0000003Q4R00hA8P0;00hA
8P030000002T:Q00Y2X@00H0Y2X@00<000000:@Z402T:Q000`00000401`TC0030000000L94`072A<
00<072A<00<0000001`TC00L94`02`0L94`00`000000BFoJ04U_fP0D04U_fP<000005P17JM400`00
0000AfWA04MYd@0G04MYd@0300000017JM40AfWA01L0AfWA00<000000?ooo`3oool0603oool00`00
0000oooo0?ooo`0c0?ooo`005@3oool00`000000oooo0?ooo`0=0?ooo`800000=03oool00`000000
odlQ0?m?8@0F0?m?8@030000003oCb40odlQ01H0odlQ00<000000?m?8@3oCb40303oCb42000000T0
odhQ0P00000L0?m>8@8000002@3oCR42000001D0od`P1P00000300H84@80000010062144000000l0
3Q4R00<0000000hA8P0>4B803@0>4B800`000000Y2X@0:@Z40060:@Z40030000002T:Q00Y2X@00H0
72A<00<0000001`TC00L94`00`0L94`00`00000072A<01`TC00;01`TC00300000019KmX0BFoJ0140
BFoJ0`00000204MYd@0300000017JM40AfWA01D0AfWA00<0000004MYd@17JM405`17JM400`000000
AfWA04MYd@0F04MYd@8000006P3oool2000003<0oooo000D0?ooo`030000003oool0oooo0100oooo
0`00000`0?ooo`040000003oCR400000000001D0odlQ00<000000?m?8@3oCb405P3oCb400`000000
odlQ0?m?8@0?0?m?8@8000001@3oCR42000001`0odhQ0P00000=0?m>8@030000003oC200od`P00l0
od`P1P00000400H84@8000000P062144000000803Q4R00<0000000hA8P0>4B803@0>4B800`000000
3Q4R00hA8P0=00hA8P800000202T:Q000`000000Y2X@0:@Z400501`TC0030000000L94`072A<00@0
72A<00<0000001`TC00L94`02P0L94`00`000000BFoJ04U_fP0>04U_fP@000001P17JM400`000000
AfWA04MYd@0E04MYd@0300000017JM40AfWA01L0AfWA00<0000004MYd@17JM404P17JM4300000080
A6G800<000000?ooo`3oool06@3oool00`000000oooo0?ooo`0`0?ooo`00503oool00`000000oooo
0?ooo`0C0?ooo`800000;@3oool00`000000odhQ0?m>8@020?m>8@8000004P3oCb400`000000odlQ
0?m?8@0F0?m?8@030000003oCb40odlQ0180odlQ0P0000000`3oCR4000000000000L0?m>8@800000
403oCR42000000`0od`P1@00000600H84@80000000@01PPA00000000000000001@0>4B800`000000
3Q4R00hA8P0=00hA8P030000000>4B803Q4R00d03Q4R100000080:@Z40030000002T:Q00Y2X@00@0
72A<00<0000001`TC00L94`0100L94`00`00000072A<01`TC00201`TC00304U_fP0L94`072A<00D0
72A<0P00000<04U_fP<000002`17JM400`000000AfWA04MYd@0E04MYd@0300000017JM40AfWA01L0
AfWA00<0000004MYd@17JM403@17JM44000000D0A6G800<000000?ooo`3oool06P3oool00`000000
oooo0?ooo`0_0?ooo`00503oool00`000000oooo0?ooo`0E0?ooo`800000:P3oool00`000000odhQ
0?m>8@050?m>8@8000003`3oCb400`000000odlQ0?m?8@0F0?m?8@030000003oCb40odlQ01D0odlQ
00<000000?m>8@3oCR406P3oCR42000001@0odhQ0P0000070?m<80H000001P0621400`0000001PPA
00000002000000L03Q4R00<0000000hA8P0>4B803@0>4B800`0000003Q4R00hA8P0<00hA8P<00000
0`0L94`00`000000Y2X@0:@Z40060:@Z40030000002T:Q0072A<008072A<00<0000001`TC00L94`0
1@0L94`01@00000072A<01`TC00L94`0000000L072A<00@0000004U_fP19KmX000002019KmX30000
00l0AfWA00<0000004MYd@17JM405@17JM400`000000AfWA04MYd@0G04MYd@0300000017JM40AfWA
00T0AfWA0`00000:04AUb0030000003oool0oooo01X0oooo0P00000_0?ooo`00503oool00`000000
oooo0?ooo`0G0?ooo`8000009`3oool00`000000odhQ0?m>8@080?m>8@800000303oCb400`000000
odlQ0?m?8@0F0?m?8@030000003oCb40odlQ01D0odlQ00@000000?m?8@00000000006@3oCR400`00
0000odhQ0?m>8@0F0?m>8@8000000P3oC207000000H01PPA1000000:00hA8P030000000>4B803Q4R
00`03Q4R00<0000000hA8P0>4B802P0>4B830000000301`TC000000072A<00<072A<00<000000:@Z
402T:Q000P2T:Q001@0L94`0Y2X@0:@Z402T:Q0000000080Y2X@0P0L94`00`00000072A<01`TC005
01`TC0040000000L94`072A<06TH2@P072A<00@0000004U_fP19KmX0BFoJ0P00000204U_fP@00000
4`17JM400`000000AfWA04MYd@0E04MYd@0300000017JM40AfWA01L0AfWA00<0000004MYd@17JM40
1@17JM43000000h0A6G800<000000?ooo`3oool06`3oool00`000000oooo0?ooo`0/0?ooo`00503o
ool00`000000oooo0?ooo`0I0?ooo`8000009@3oool00`000000odhQ0?m>8@0:0?m>8@800000203o
Cb42000001P0odlQ00<000000?m?8@3oCb405@3oCb400`000000odlQ0?m?8@020?m?8@8000005@3o
CR42000001/0odhQ100000000`06214000000000000500H84@<000003@0>4B800`0000003Q4R00hA
8P0<00hA8P030000000>4B803Q4R00P03Q4R0`00000301`TC0030000000L94`072A<00@072A<00<0
00000:@Z402T:Q001P2T:Q0010000000Y2X@01`TC000000801`TC0030000000L94`0000000P072A<
00<0000004U_fP19KmX00`19KmX3000001P0AfWA00<0000004MYd@17JM405@17JM400`000000AfWA
04MYd@0G04MYd@0300000017JM40AfWA00@000004@14ILP00`000000oooo0?ooo`0L0?ooo`030000
003oool0oooo02/0oooo000D0?ooo`030000003oool0oooo01/0oooo0P00000R0?ooo`030000003o
CR40odhQ00d0odhQ0P0000050?m?8@030000003oCb40odlQ01H0odlQ0P00000F0?m?8@8000001`3o
Cb4200000140odhQ0P00000J0?m>8@<000000`062142000000@01PPA1000000>00hA8P030000000>
4B803Q4R00d03Q4R00<0000000hA8P0>4B801@0>4B83000000H072A<00<0000001`TC00L94`01@0L
94`00`000000Y2X@0:@Z40060:@Z40030000000L94`0000000P072A<00<0000006TH2@0L94`0200L
94`00`000000BFoJ04U_fP0300000080AfWA00<0000004MYd@17JM405`17JM400`000000AfWA04MY
d@0E04MYd@0300000017JM40AfWA01D0AfWA1000000F04AUb0030000003oool0oooo01`0oooo00<0
00000?ooo`3oool0:P3oool001@0oooo00<000000?ooo`3oool07@3oool2000001l0oooo00<00000
0?m>8@3oCR40403oCR4200000080odlQ00<000000?m?8@3oCb405P3oCb400`000000odlQ0?m?8@0E
0?m?8@030000003oCb40odlQ00T0odlQ0P00000=0?m>8@8000006@3oCR43000000@01PPA0P000002
00H84@@000000P0>4B800`0000003Q4R00hA8P0<00hA8P030000000>4B803Q4R00d03Q4R00<00000
00hA8P0>4B800P0>4B84000000P072A<00<0000001`TC00L94`01P0L94`00`000000Y2X@0:@Z4006
0:@Z408000002@0L94`00`00000072A<01`TC00801`TC0<000001P17JM400`000000AfWA04MYd@0G
04MYd@0300000017JM40AfWA01D0AfWA00<0000004MYd@17JM404017JM44000000<0A6G800<00000
04AUb014ILP05@14ILP00`000000oooo0?ooo`0L0?ooo`800000:P3oool001@0oooo00<000000?oo
o`3oool07`3oool2000001`0oooo00<000000?m>8@3oCR404`3oCR42000001P0odlQ00<000000?m?
8@3oCb405@3oCb400`000000odlQ0?m?8@0<0?m?8@8000002@3oCR42000001P0odhQ0`00000500H8
4@80000000@01PPA00000000000000001@0>4B800`0000003Q4R00hA8P0<00hA8P030000000>4B80
3Q4R00d03Q4R00<0000000hA8P0>4B800`00000<01`TC0030000000L94`072A<00L072A<00<00000
0:@Z402T:Q001P2T:Q0901`TC08000002@0L94`3000000P0AfWA00<0000004MYd@17JM405P17JM40
0`000000AfWA04MYd@0F04MYd@0300000017JM40AfWA00/0AfWA1000000704AUb00300000014ILP0
A6G801D0A6G800<000000?ooo`3oool07P3oool00`000000oooo0?ooo`0W0?ooo`00503oool00`00
0000oooo0?ooo`0Q0?ooo`8000006@3oool00`000000odhQ0?m>8@0D0?m>8@040000003oCR400000
000001D0odlQ00<000000?m?8@3oCb405@3oCb400`000000odlQ0?m?8@0?0?m?8@8000001@3oCR42
000001H0odhQ1@00000500H84@D000001`0>4B800`0000003Q4R00hA8P0<00hA8P030000000>4B80
3Q4R00d03Q4R1000000>01`TC0030000000L94`072A<00P072A<00<000000:@Z402T:Q001`2T:Q07
01`TC0030:@Z400L94`0000000T072A<0P0000000`1Y60T000000000000704MYd@0300000017JM40
AfWA01H0AfWA00<0000004MYd@17JM405P17JM400`000000AfWA04MYd@0604MYd@@000003014ILP0
0`000000A6G804AUb00E04AUb0030000003oool0oooo01h0oooo00<000000?ooo`3oool09P3oool0
01@0oooo00<000000?ooo`3oool08`3oool3000001D0oooo00<000000?m>8@3oCR40503oCR400`00
0000odhQ0?m>8@020?m>8@8000004P3oCb400`000000odlQ0?m?8@0E0?m?8@030000003oCb40odlQ
0180odlQ0P0000000`3oCR4000000000000E0?m>8@<0000000<01PPA0000000000001@0621440000
00X03Q4R00<0000000hA8P0>4B802`0>4B800`0000003Q4R00hA8P0<00hA8P<000004@0L94`00`00
000072A<01`TC00901`TC0030000002T:Q00Y2X@00H0Y2X@1P0L94`0102T:Q0072A<01`TC0000008
01`TC0040000001Y60T0JAP900000080JAP900<0000004MYd@17JM401@17JM400`000000AfWA04MY
d@0F04MYd@0300000017JM40AfWA01H0AfWA00@0000004MYd@17JM40AfWA1000000A04AUb0030000
0014ILP0A6G801D0A6G800<000000?ooo`3oool07P3oool2000002H0oooo000D0?ooo`030000003o
ool0oooo02H0oooo0P00000B0?ooo`030000003oCR40odhQ01@0odhQ00<000000?m>8@3oCR401@3o
CR42000000l0odlQ00<000000?m?8@3oCb405@3oCb400`000000odlQ0?m?8@0E0?m?8@030000003o
CR40odhQ0140odhQ1000000200H84@80000010062143000000d03Q4R00<0000000hA8P0>4B802`0>
4B800`0000003Q4R00hA8P0900hA8P@0000000<072A<0000000L94`0400L94`00`00000072A<01`T
C00;01`TC0030000002T:Q00Y2X@00D0Y2X@1@0L94`00`2T:Q0072A<01`TC00201`TC0030000000L
94`072A<00D072A<00D0000006TH2@1Y60T0JAP90000000206TH2@8000001P17JM400`000000AfWA
04MYd@0F04MYd@0300000017JM40AfWA01D0AfWA1000000E04AUb00300000014ILP0A6G801D0A6G8
00<000000?ooo`3oool0803oool00`000000oooo0?ooo`0S0?ooo`00503oool00`000000oooo0?oo
o`0X0?ooo`8000003`3oool00`000000odhQ0?m>8@0E0?m>8@030000003oCR40odhQ00L0odhQ0P00
000<0?m?8@030000003oCb40odlQ01D0odlQ00<000000?m?8@3oCb405@3oCb4010000000odlQ0000
0000000=0?m>8@@0000010062142000000<01PPA1000000>00hA8P030000000>4B803Q4R00`03Q4R
00<0000000hA8P0>4B801P0>4B83000000@072A<00<0000001`TC00L94`0400L94`00`00000072A<
01`TC00;01`TC0030000002T:Q00Y2X@00@0Y2X@00<072A<0:@Z400L94`00P0L94`00`2T:Q0072A<
01`TC00301`TC0030000000L94`072A<00@072A<0`00000306TH2@050000001Y60T0JAP906TH2@00
00001P17JM400`000000AfWA04MYd@0F04MYd@0300000017JM40AfWA0140AfWA0`00000204AUb003
00000014ILP0A6G801D0A6G800<0000004AUb014ILP05@14ILP00`000000oooo0?ooo`0P0?ooo`03
0000003oool0oooo0280oooo000D0?ooo`030000003oool0oooo02X0oooo0P00000=0?ooo`030000
003oCR40odhQ01@0odhQ00<000000?m>8@3oCR402P3oCR42000000P0odlQ0P00000F0?m?8@800000
5`3oCb400`000000odlQ0?m?8@020?m?8@800000203oCR43000000H01PPA0P00000200H84@<00000
0P0>4B800`0000003Q4R00hA8P0<00hA8P030000000>4B803Q4R00`03Q4R00<0000000hA8P0>4B80
0`0>4B84000000L072A<00<0000001`TC00L94`0400L94`00`00000072A<01`TC00<01`TC0030000
002T:Q00Y2X@00@0Y2X@2P0L94`00`00000072A<01`TC00401`TC0040000002T:Q000000000000<0
JAP900@0000006TH2@1Y60T0JAP90P00000504MYd@0300000017JM40AfWA01H0AfWA00<0000004MY
d@17JM403@17JM43000000D0A6G800<0000004AUb014ILP05P14ILP00`000000A6G804AUb00D04AU
b0030000003oool0oooo0240oooo0P00000R0?ooo`00503oool00`000000oooo0?ooo`0/0?ooo`80
00002P3oool00`000000odhQ0?m>8@0D0?m>8@030000003oCR40odhQ00d0odhQ0P0000050?m?8@03
0000003oCb40odlQ01D0odlQ00<000000?m?8@3oCb405P3oCb400`000000odlQ0?m?8@050?m?8@03
0000003oCR40odhQ0080odhQ1000000600H84@H00000100>4B800`0000003Q4R00hA8P0<00hA8P03
0000000>4B803Q4R00`03Q4R00@0000000hA8P0>4B803Q4R0`00000:01`TC0030000000L94`072A<
010072A<00<0000001`TC00L94`03@0L94`3000000D0Y2X@2@0L94`00`00000072A<01`TC00301`T
C0030000002T:Q00Y2X@0080Y2X@00D0000006TH2@1Y60T0JAP90000000306TH2@<000001017JM40
0`000000AfWA04MYd@0F04MYd@0300000017JM40AfWA00P0AfWA1000000904AUb00300000014ILP0
A6G801D0A6G800<0000004AUb014ILP05@14ILP00`000000oooo0?ooo`0R0?ooo`030000003oool0
oooo01l0oooo000D0?ooo`030000003oool0oooo02h0oooo0P0000070?ooo`030000003oCR40odhQ
01@0odhQ00<000000?m>8@3oCR40403oCR4200000080odlQ00<000000?m?8@3oCb405@3oCb400`00
0000odlQ0?m?8@0E0?m?8@8000002@3oCb46000000H01PPA1000000700hA8P030000000>4B803Q4R
00`03Q4R00<0000000hA8P0>4B80300>4B85000000d072A<00<0000001`TC00L94`0400L94`00`00
000072A<01`TC00>01`TC0030000003I>QL0000000D0Y2X@200L94`00`00000072A<01`TC00201`T
C08000001@2T:Q0200000080JAP900L0000006TH2@1Y60T0JAP90000001Y60T0000000@0AfWA00<0
000004MYd@17JM405P17JM400`000000AfWA04MYd@0404MYd@<000003P14ILP00`000000A6G804AU
b00E04AUb00300000014ILP0A6G801D0A6G800<000000?ooo`3oool08P3oool00`000000oooo0?oo
o`0N0?ooo`00503oool00`000000oooo0?ooo`0`0?ooo`800000103oool00`000000odhQ0?m>8@0D
0?m>8@030000003oCR40odhQ01<0odhQ0`00000F0?m?8@030000003oCb40odlQ01D0odlQ00<00000
0?m?8@3oCb401P3oCb440000000300H84@000000000000H01PPA0`00000:00hA8P030000000>4B80
3Q4R00/03Q4R00<0000000hA8P0>4B802`0>4B830000010072A<00<0000001`TC00L94`0400L94`0
0`00000072A<01`TC00?01`TC0030000003I>QL0fCXG008000000`2T:Q0801`TC0D0000000<09cE^
0000002T:Q00102T:Q001P000000Y2X@000000000000JAP9000000<0JAP900@0000006TH2@000000
00000`17JM400`000000AfWA04MYd@0F04MYd@0300000017JM40AfWA00<000004@14ILP00`000000
A6G804AUb00F04AUb00300000014ILP0A6G801@0A6G800<000000?ooo`3oool08`3oool2000001h0
oooo000C0?ooo`030000003oool0oooo03<0oooo0P0000000`3oool000000?m>8@0E0?m>8@030000
003oCR40odhQ01@0odhQ00<000000?m>8@3oCR400P00000C0?m?8@030000003oCb40odlQ01D0odlQ
00<000000?m?8@3oCb40103oCb43000000<01PPA0P00000500H84@<00000300>4B800`0000003Q4R
00hA8P0;00hA8P030000000>4B803Q4R00T03Q4R0`0000000`0L94`0000001`TC00@01`TC0030000
000L94`072A<010072A<00<0000001`TC00L94`03`0L94`00`000000fCXG0=Tj5`020=Tj5`030000
002T:Q00Y2X@00H072A<0`00000502LeKP030000002T:Q00Y2X@00@0Y2X@00D000000:@Z402T:Q00
000006TH2@0200000080JAP90P0000000`1Y60T0000004MYd@0204MYd@0300000017JM40AfWA01D0
AfWA0`00000E04AUb00300000014ILP0A6G801D0A6G800<0000004AUb014ILP05@14ILP00`000000
oooo0?ooo`0T0?ooo`030000003oool0oooo01/0oooo000C0?ooo`030000003oool0oooo03D0oooo
00<000000?m>8@3oCR405@3oCR400`000000odhQ0?m>8@0C0?m>8@030000003oCR40odhQ00<0odhQ
0P00000@0?m?8@030000003oCb40odlQ01D0odlQ00<000000?m?8@3oCb400P3oCb43000000@01PPA
0P00000400H84@@000003@0>4B800`0000003Q4R00hA8P0<00hA8P030000000>4B803Q4R00D03Q4R
1000000301`TC0030000000L94`072A<00l072A<00<0000001`TC00L94`0400L94`00`00000072A<
01`TC00A01`TC0030000003I>QL0fCXG0080fCXG0P00000201`TC0@000000P0W=Fh00`0000009cE^
02LeKP0202LeKP030000002T:Q00Y2X@00D0Y2X@00@000000:@Z402T:Q00Y2X@0P0000000`1Y60T0
000006TH2@0206TH2@040000001Y60T0000000000080AfWA00<0000004MYd@17JM404017JM440000
0080A6G800<0000004AUb014ILP05014ILP00`000000A6G804AUb00E04AUb00300000014ILP0A6G8
01D0A6G800<000000?ooo`3oool0903oool00`000000oooo0?ooo`0J0?ooo`004`3oool00`000000
oooo0?ooo`0d0?ooo`030000003oCR40odhQ01D0odhQ00<000000?m>8@3oCR404`3oCR400`000000
odhQ0?m>8@060?m>8@8000003@3oCb400`000000odlQ0?m?8@0E0?m?8@030000003oCb40odlQ00<0
00001@062142000000<01PPA0`00000200hA8P030000000>4B803Q4R00/03Q4R00<0000000hA8P0>
4B80300>4B800`0000003Q4R00hA8P0300hA8P<000001`0L94`00`00000072A<01`TC00?01`TC003
0000000L94`072A<010072A<00<0000001`TC00L94`0400L94`2000000H0fCXG0P00000602LeKP03
0000000W=Fh09cE^00809cE^00<000000:@Z402T:Q001P2T:Q000`000000Y2X@0:@Z40020:@Z4003
0000001Y60T0000000<0JAP900<0000006TH2@1Y60T00P0000000`17JM40000004MYd@0<04MYd@@0
00001P14ILP00`000000A6G804AUb00E04AUb00300000014ILP0A6G801@0A6G800<0000004AUb014
ILP05@14ILP00`000000oooo0?ooo`0U0?ooo`8000006P3oool001<0oooo00<000000?ooo`3oool0
<`3oool00`000000odhQ0?m>8@0E0?m>8@030000003oCR40odhQ01@0odhQ00<000000?m>8@3oCR40
203oCR43000000P0odlQ0P00000G0?m?8@D000001@0621420000000300H84@000000000000800000
100>4B800`0000003Q4R00hA8P0;00hA8P030000000>4B803Q4R00`03Q4R00@0000000hA8P0>4B80
3Q4R0`00000901`TC0030000000L94`072A<00l072A<00<0000001`TC00L94`04@0L94`00`000000
72A<01`TC00@01`TC08000001`3I>QL702LeKP030000000W=Fh09cE^00809cE^0P0000080:@Z4003
0000002T:Q00Y2X@0080Y2X@0`00000306TH2@070000001Y60T0JAP906TH2@000000AfWA00000008
04MYd@@000002`14ILP00`000000A6G804AUb00D04AUb00300000014ILP0A6G801D0A6G800<00000
04AUb014ILP05@14ILP00`000000oooo0?ooo`0V0?ooo`030000003oool0oooo01L0oooo000C0?oo
o`030000003oool0oooo03<0oooo00<000000?m>8@3oCR40503oCR400`000000odhQ0?m>8@0D0?m>
8@030000003oCR40odhQ00`0odhQ0P0000050?m?8@030000003oCb40odlQ01@0odlQ0`0000000`06
214000000000000500H84@D000001`0>4B800`0000003Q4R00hA8P0;00hA8P030000000>4B803Q4R
00`03Q4R1@00000<01`TC0030000000L94`072A<00l072A<00<0000001`TC00L94`0400L94`00`00
000072A<01`TC00@01`TC0040000000L94`00000000000H0fCXG1`0W=Fh00`0000009cE^02LeKP02
02LeKP800000202T:Q000`000000Y2X@0:@Z40040:@Z408000000`1Y60T010000000JAP906TH2@1Y
60T3000000<0AfWA1000000@04AUb00300000014ILP0A6G801@0A6G800<0000004AUb014ILP05@14
ILP00`000000A6G804AUb00E04AUb0030000003oool0oooo02H0oooo00<000000?ooo`3oool05P3o
ool001<0oooo00<000000?ooo`3oool0<P3oool00`000000odhQ0?m>8@0D0?m>8@030000003oCR40
odhQ01@0odhQ00<000000?m>8@3oCR403`3oCR4200000080odlQ00<000000?m?8@3oCb404P3oCb43
000000801PPA0P00000500H84@@000002@0>4B800`0000003Q4R00hA8P0;00hA8P030000000>4B80
3Q4R00/03Q4R0`00000?01`TC0030000000L94`072A<00l072A<00<0000001`TC00L94`04@0L94`0
0`00000072A<01`TC00?01`TC0<0000000<09cE^0000003I>QL01@3I>QL702LeKP030000000W=Fh0
9cE^00809cE^00<000000:@Z40000000202T:Q000`000000Y2X@0:@Z40050:@Z40050000001Y60T0
JAP906TH2@0000000`1Y60T5000001@0A6G800<0000004AUb014ILP05@14ILP00`000000A6G804AU
b00D04AUb00300000014ILP0A6G801D0A6G800<000000?ooo`3oool09`3oool2000001H0oooo000C
0?ooo`030000003oool0oooo0340oooo00<000000?m>8@3oCR40503oCR400`000000odhQ0?m>8@0D
0?m>8@030000003oCR40odhQ0180odhQ0P00000A0?m?8@@000000`062142000000D01PPA0`00000;
00hA8P030000000>4B803Q4R00/03Q4R00<0000000hA8P0>4B802@0>4B840000014072A<00<00000
01`TC00L94`03`0L94`00`00000072A<01`TC00@01`TC0030000000L94`072A<00`072A<10000000
1@0W=Fh0000002LeKP0W=Fh0000000H0fCXG1`0W=Fh01@0000009cE^02LeKP0W=Fh0000000<0Y2X@
00<000000:@Z402T:Q001P2T:Q000`000000Y2X@0:@Z40050:@Z408000000P1Y60T010000000JAP9
06TH2@1Y60T3000001H0A6G800<0000004AUb014ILP05014ILP00`000000A6G804AUb00E04AUb003
00000014ILP0A6G801@0A6G80P00000Z0?ooo`030000003oool0oooo01<0oooo000C0?ooo`030000
003oool0oooo0300oooo00<000000?m>8@3oCR405@3oCR400`000000odhQ0?m>8@0C0?m>8@030000
003oCR40odhQ01<0odhQ00@000000?m>8@0000000000303oCb43000000D01PPA0P00000300H84@D0
0000300>4B800`0000003Q4R00hA8P0<00hA8P030000000>4B803Q4R00D03Q4R1000000301`TC003
0000000L94`072A<00h072A<00<0000001`TC00L94`0400L94`00`00000072A<01`TC00@01`TC003
0000000L94`072A<00P072A<1000000502LeKP050000000W=Fh09cE^02LeKP0000001@3I>QL702Le
KP050000000W=Fh09cE^02LeKP0000000`2T:Q000`000000Y2X@0:@Z40060:@Z40030000002T:Q00
Y2X@00D0Y2X@00<000000:@Z400000000P1Y60T01`000000JAP906TH2@1Y60T0000006TH2@000000
5P14ILP00`000000A6G804AUb00D04AUb00300000014ILP0A6G801D0A6G800<0000004AUb014ILP0
4014ILP300000080@V2o00<000000?ooo`3oool09`3oool2000001@0oooo000C0?ooo`030000003o
ool0oooo02l0oooo0P00000F0?m>8@030000003oCR40odhQ01<0odhQ00<000000?m>8@3oCR404`3o
CR400`000000odhQ0?m>8@020?m>8@8000001`3oCb44000000D01PPA0P00000200H84@<000000`0>
4B800`0000003Q4R00hA8P0:00hA8P030000000>4B803Q4R00`03Q4R00<0000000hA8P0>4B800`0>
4B83000000H072A<00<0000001`TC00L94`03`0L94`00`00000072A<01`TC00?01`TC0030000000L
94`072A<010072A<00<0000001`TC00L94`01P0L94`3000000P09cE^00<0000002LeKP0W=Fh00P0W
=Fh00`000000fCXG0=Tj5`030=Tj5`L09cE^00D0000002LeKP0W=Fh09cE^000000040:@Z40030000
002T:Q00Y2X@00H0Y2X@00<000000:@Z402T:Q001@2T:Q001P000000Y2X@000000000000JAP90000
00<0JAP91000000D04AUb00300000014ILP0A6G801D0A6G800<0000004AUb014ILP05014ILP00`00
0000A6G804AUb00<04AUb0@000001@12H;l00`000000oooo0?ooo`0S0?ooo`@0000000<0oooo0000
003oool04`3oool001<0oooo00<000000?ooo`3oool0;P3oool00`000000odhP0?m>8002000001<0
odhQ00<000000?m>8@3oCR40503oCR400`000000odhQ0?m>8@0C0?m>8@030000003oCR40odhQ00@0
odhQ0P0000020?m?8@D000001@0621400`0000001PPA00000003000000D03Q4R00<0000000hA8P0>
4B802`0>4B800`0000003Q4R00hA8P0;00hA8P040000000>4B803Q4R00hA8P<000002@0L94`00`00
000072A<01`TC00>01`TC0030000000L94`072A<010072A<00<0000001`TC00L94`0400L94`00`00
000072A<01`TC00201`TC0@000002`0W=Fh00`0000009cE^02LeKP0202LeKP030000003I>QL0fCXG
00@0fCXG1P0W=Fh01@0000009cE^02LeKP0W=Fh0000000D0Y2X@00<000000:@Z402T:Q001@2T:Q00
0`000000Y2X@0:@Z40060:@Z40050000002T:Q00Y2X@0000001Y60T00P00000306TH2@030000001Y
60T0000001@0A6G800<0000004AUb014ILP05014ILP00`000000A6G804AUb00E04AUb00300000014
ILP0A6G800P0A6G80`00000:049P_`030000003oool0oooo01h0oooo100000050?ooo`030000003o
ool0oooo0180oooo000C0?ooo`030000003oool0oooo02h0oooo00<000000?m>803oCR000P3oCR02
00000100odhQ00<000000?m>8@3oCR40503oCR400`000000odhQ0?m>8@0C0?m>8@030000003oCR40
odhQ00L0odhQ0P0000000`06214000000000000500H84@@00000200>4B800`0000003Q4R00hA8P0;
00hA8P030000000>4B803Q4R00/03Q4R1@00000;01`TC0030000000L94`072A<00l072A<00<00000
01`TC00L94`03`0L94`00`00000072A<01`TC00@01`TC0030000000L94`0000000<000003`0W=Fh0
0`0000009cE^02LeKP0302LeKP030000003I>QL0fCXG00<0fCXG1P0W=Fh0100000009cE^02LeKP0W
=Fh3000000<0Y2X@00<000000:@Z402T:Q001P2T:Q000`000000Y2X@0:@Z40050:@Z40040000002T
:Q00Y2X@0:@Z4080000000<0JAP90000001Y60T00P1Y60T010000000JAP900000000000C04AUb003
00000014ILP0A6G801@0A6G800<0000004AUb014ILP05@14ILP00`000000A6G804AUb00404AUb0<0
00003@12H;l00`000000oooo0?ooo`0J0?ooo`@000002@3oool00`000000oooo0?ooo`0B0?ooo`00
4`3oool00`000000oooo0?ooo`0]0?ooo`030000003oCR00odhP00D0odhP0P00000=0?m>8@030000
003oCR40odhQ01@0odhQ00<000000?m>8@3oCR404`3oCR400`000000odhQ0?m>8@060?m>8@<01PPA
0P00000400H84@<000002`0>4B800`0000003Q4R00hA8P0;00hA8P030000000>4B803Q4R00X03Q4R
0`00000?01`TC0030000000L94`072A<00h072A<00<0000001`TC00L94`0400L94`00`00000072A<
01`TC00?01`TC0<000004`0W=Fh00`0000009cE^02LeKP0302LeKP030000003I>QL0fCXG00<0fCXG
1P0W=Fh01@0000009cE^02LeKP0W=Fh000000080fCXG0P0000020:@Z40030000002T:Q00Y2X@00H0
Y2X@00<000000:@Z402T:Q001@2T:Q000`000000Y2X@0:@Z40020:@Z40<000000`1Y60T010000000
JAP906TH2@00000B04AUb00300000014ILP0A6G801D0A6G800<0000004AUb014ILP05014ILP00`00
0000A6G804AUb00400000140@V2o00<000000?ooo`3oool05@3oool4000000d0oooo00<000000?oo
o`3oool04P3oool001<0oooo00<000000?ooo`3oool0;@3oool00`000000odhP0?m>80070?m>8080
00002P3oCR400`000000odhQ0?m>8@0D0?m>8@030000003oCR40odhQ01<0odhQ00<000000?m>8@3o
CR401@3oCR4300H84@8000000`062144000000`03Q4R00<0000000hA8P0>4B802`0>4B800`000000
3Q4R00hA8P0800hA8P@00000400L94`00`00000072A<01`TC00?01`TC0030000000L94`072A<00l0
72A<00<0000001`TC00L94`0300L94`40000000302LeKP0000009cE^01809cE^00<0000002LeKP0W
=Fh0100W=Fh00`000000fCXG0=Tj5`030=Tj5`H09cE^00@0000002LeKP0W=Fh000001@3I>QL20000
00030:@Z40000000Y2X@00H0Y2X@00<000000:@Z402T:Q001P2T:Q000`000000Y2X@0:@Z40030:@Z
408000000`1Y60T00`000000JAP906TH2@0200000140A6G800<0000004AUb014ILP05@14ILP00`00
0000A6G804AUb00C04AUb0<000005@12H;l00`000000oooo0?ooo`0A0?ooo`@000004@3oool00`00
0000oooo0?ooo`0B0?ooo`004`3oool00`000000oooo0?ooo`0/0?ooo`030000003oCR00odhP00X0
odhP0P0000080?m>8@030000003oCR40odhQ01<0odhQ00<000000?m>8@3oCR404`3oCR400`000000
odhQ0?m>8@040?m>8@<01PPA0P00000200H84@<000000P0>4B800`0000003Q4R00hA8P0:00hA8P03
0000000>4B803Q4R00/03Q4R00<0000000hA8P0>4B801@0>4B84000000<072A<00<0000001`TC00L
94`03P0L94`00`00000072A<01`TC00?01`TC0030000000L94`072A<00l072A<00<0000001`TC00L
94`0200L94`4000000D09cE^00<0000002LeKP0W=Fh04@0W=Fh00`0000009cE^02LeKP0402LeKP03
0000003I>QL0fCXG00<0fCXG1P0W=Fh0100000009cE^02LeKP0000070=Tj5`800000202T:Q000`00
0000Y2X@0:@Z40050:@Z40030000002T:Q00Y2X@00@0Y2X@0P00000306TH2@030000001Y60T0JAP9
00<000004014ILP00`000000A6G804AUb00D04AUb00300000014ILP0A6G800l0A6G8100000000`12
H;l00000049P_`0F049P_`030000003oool0oooo00`0oooo1000000E0?ooo`030000003oool0oooo
0180oooo000C0?ooo`030000003oool0oooo02/0oooo00<000000?m>803oCR003@3oCR02000000D0
odhQ00<000000?m>8@3oCR404`3oCR400`000000odhQ0?m>8@0C0?m>8@030000003oCR40odhQ0080
odhQ100621420000000400H84@0000000000000000@03Q4R00<0000000hA8P0>4B802P0>4B800`00
00003Q4R00hA8P0;00hA8P030000000>4B803Q4R00<03Q4R0`00000601`TC0030000000L94`072A<
00h072A<00<0000001`TC00L94`03`0L94`00`00000072A<01`TC00?01`TC0030000000L94`072A<
00H072A<0`00000802LeKP030000000W=Fh09cE^01809cE^00<0000002LeKP0W=Fh01@0W=Fh00`00
0000fCXG0=Tj5`020=Tj5`H09cE^00@0000002LeKP0W=Fh000002@3I>QL00`000000Y2X@0:@Z4005
0:@Z40030000002T:Q00Y2X@00H0Y2X@00<000000:@Z402T:Q001@2T:Q001@000000JAP906TH2@1Y
60T000000080JAP90`00000@04AUb00300000014ILP0A6G801@0A6G800<0000004AUb014ILP02P14
ILP4000000H0@V2o00<00000049P_`12H;l05012H;l00`000000oooo0?ooo`080?ooo`@000006@3o
ool00`000000oooo0?ooo`0B0?ooo`004`3oool00`000000oooo0?ooo`0[0?ooo`030000003oCR00
odhP00l0odhP0P0000020?m>8@030000003oCR40odhQ01@0odhQ00<000000?m>8@3oCR404`3oCR40
0`000000odhQ0?m>8@0400H84@D000001P0>4B800`0000003Q4R00hA8P0;00hA8P030000000>4B80
3Q4R00X03Q4R00@0000000hA8P0>4B803Q4R0`00000901`TC0030000000L94`072A<00h072A<00<0
000001`TC00L94`03`0L94`00`00000072A<01`TC00?01`TC0030000000L94`072A<008072A<1000
000;02LeKP030000000W=Fh09cE^01809cE^00<0000002LeKP0W=Fh01@0W=Fh00`000000fCXG0=Tj
5`030=Tj5`D09cE^00@0000002LeKP0W=Fh000002@3I>QL3000000H0Y2X@00<000000:@Z402T:Q00
1P2T:Q000`000000Y2X@0:@Z40050:@Z408000000P1Y60T010000000JAP906TH2@1Y60T3000000h0
A6G800<0000004AUb014ILP05@14ILP00`000000A6G804AUb00504AUb0@000002P12H;l00`000000
@V2o049P_`0E049P_`030000003oool0oooo00<0oooo1000000M0?ooo`030000003oool0oooo0180
oooo000B0?ooo`030000003oool0oooo02/0oooo00<000000?m>803oCR004P3oCR02000001H0odhQ
00<000000?m>8@3oCR404`3oCR400`000000odhQ00H84@0300H84@@00000200>4B800`0000003Q4R
00hA8P0;00hA8P030000000>4B803Q4R00X03Q4R1@00000;01`TC0030000000L94`072A<00h072A<
00<0000001`TC00L94`03`0L94`00`00000072A<01`TC00?01`TC0030000000L94`0000000<00000
3`0W=Fh00`0000009cE^02LeKP0B02LeKP030000000W=Fh09cE^00D09cE^00<000000=Tj5`3I>QL0
0`3I>QL502LeKP040000000W=Fh09cE^000000X0fCXG00<000000=Tj5`0000001P2T:Q000`000000
Y2X@0:@Z40050:@Z40030000002T:Q00Y2X@00D0Y2X@00H000000:@Z40000000000006TH2@000003
06TH2@040000001Y60T00000000000d0A6G800<0000004AUb014ILP05014ILP010000000A6G804AU
b014ILP4000000l0@V2o00<00000049P_`12H;l05012H;l00`000000oooo0?ooo`0300000280oooo
00<000000?ooo`3oool04@3oool00180oooo00<000000?ooo`3oool0:`3oool00`000000odhP0?m>
800B0?m>80040000003oCR000000000001<0odhQ00<000000?m>8@3oCR404P3oCR42000000@01PPA
0`00000:00hA8P030000000>4B803Q4R00/03Q4R00<0000000hA8P0>4B802@0>4B83000000l072A<
00<0000001`TC00L94`03P0L94`00`00000072A<01`TC00?01`TC0030000000L94`072A<00h072A<
0`00000C02LeKP030000000W=Fh09cE^01409cE^00<0000002LeKP0W=Fh01`0W=Fh00`000000fCXG
0=Tj5`020=Tj5`D09cE^00<0000002LeKP0000002`3I>QL00`000000fCXG0=Tj5`02000000@0Y2X@
00<000000:@Z402T:Q001P2T:Q000`000000Y2X@0:@Z40050:@Z40050000002T:Q00Y2X@0000001Y
60T00P00000206TH2@030000001Y60T0JAP9008000003014ILP00`000000A6G804AUb00C04AUb0@0
00004`12H;l00`000000@V2o049P_`0E049P_`8000009@3oool00`000000oooo0?ooo`0A0?ooo`00
4P3oool00`000000oooo0?ooo`0Z0?ooo`030000003oCR00odhP01<0odhP00@000000?m>803oCR00
odhP0P00000@0?m>8@030000003oCR40odhQ0140odhQ00@0000000H84@0621401PPA1@00000;00hA
8P030000000>4B803Q4R00/03Q4R00<0000000hA8P0>4B801`0>4B840000010072A<00<0000001`T
C00L94`03P0L94`00`00000072A<01`TC00?01`TC0030000000L94`072A<00/072A<100000000`0W
=Fh0000002LeKP0B02LeKP030000000W=Fh09cE^01809cE^00<0000002LeKP0W=Fh01`0W=Fh00`00
0000fCXG0=Tj5`020=Tj5`D09cE^00<0000002LeKP0000002`3I>QL00`000000fCXG0=Tj5`020=Tj
5`030000002T:Q00Y2X@0080Y2X@00<000000:@Z402T:Q001@2T:Q000`000000Y2X@0:@Z40060:@Z
40030000002T:Q00Y2X@0080000000D0JAP90000001Y60T0JAP90000000306TH2@0300000014ILP0
A6G800T0A6G800<0000004AUb014ILP03`14ILP400000003049P_`000000@V2o01D0@V2o00<00000
049P_`12H;l05012H;l00`000000oooo0?ooo`0T0?ooo`030000003oool0oooo0140oooo000B0?oo
o`030000003oool0oooo02T0oooo00<000000?m>803oCR004`3oCR000`000000odhP0?m>80040?m>
808000003@3oCR400`000000odhQ0?m>8@0@0?m>8@030000000621401PPA00<000000`0>4B800`00
00003Q4R00hA8P0900hA8P030000000>4B803Q4R00/03Q4R00<0000000hA8P0>4B801@0>4B830000
00<072A<00<0000001`TC00L94`03P0L94`00`00000072A<01`TC00>01`TC0030000000L94`072A<
00l072A<00<0000001`TC00L94`0200L94`3000000D09cE^00<0000002LeKP0W=Fh04@0W=Fh00`00
00009cE^02LeKP0B02LeKP030000000W=Fh09cE^00L09cE^00<000000=Tj5`3I>QL00P3I>QL502Le
KP030000000W=Fh0000000`0fCXG00<000000=Tj5`3I>QL00P3I>QL2000000<0Y2X@00<000000:@Z
402T:Q001@2T:Q000`000000Y2X@0:@Z40050:@Z40030000002T:Q00Y2X@0080Y2X@00<0000006TH
2@0000000P1Y60T010000000JAP906TH2@1Y60T2000000X0A6G800<0000004AUb014ILP02P14ILP4
000000H0@V2o00<00000049P_`12H;l04`12H;l00`000000@V2o049P_`0E049P_`030000003oool0
oooo02<0oooo00<000000?ooo`3oool04@3oool00180oooo00<000000?ooo`3oool0:@3oool00`00
0000odhP0?m>800C0?m>80030000003oCR00odhP00H0odhP0P00000:0?m>8@030000003oCR40odhQ
00l0odhQ00<0000000H84@0000000P00000500hA8P030000000>4B803Q4R00X03Q4R00<0000000hA
8P0>4B802P0>4B800`0000003Q4R00hA8P0200hA8P@000001@0L94`00`00000072A<01`TC00>01`T
C0030000000L94`072A<00h072A<00<0000001`TC00L94`03`0L94`00`00000072A<01`TC00501`T
C0@000001`0W=Fh00`0000009cE^02LeKP0B02LeKP030000000W=Fh09cE^01809cE^00<0000002Le
KP0W=Fh0200W=Fh010000000fCXG0=Tj5`3I>QL502LeKP040000000W=Fh00000000000/0fCXG00<0
00000=Tj5`3I>QL0103I>QL2000000030:@Z40000000Y2X@00L0Y2X@00<000000:@Z402T:Q001@2T
:Q000`000000Y2X@0:@Z40020:@Z40<000000P1Y60T200000080JAP90P00000:04AUb00300000014
ILP0A6G800D0A6G81000000:049P_`0300000012H;l0@V2o01@0@V2o00<00000049P_`12H;l05012
H;l00`000000oooo0?ooo`0S0?ooo`030000003oool0oooo0140oooo000B0?ooo`030000003oool0
oooo02P0oooo00<000000?m>803oCR004`3oCR000`000000odhP0?m>80090?m>80800000203oCR40
0`000000odhQ0?m>8@0<0?m>8@0300H84@0000000000008000001`0>4B800`0000003Q4R00hA8P0:
00hA8P030000000>4B803Q4R00X03Q4R00<0000000hA8P0>4B800`00000901`TC0030000000L94`0
72A<00h072A<00<0000001`TC00L94`03P0L94`00`00000072A<01`TC00?01`TC0030000000L94`0
72A<008072A<0`00000;02LeKP030000000W=Fh09cE^01809cE^00<0000002LeKP0W=Fh04@0W=Fh0
0`0000009cE^02LeKP0902LeKP040000003I>QL0fCXG0=Tj5`D09cE^00@0000002LeKP0000000000
2`3I>QL00`000000fCXG0=Tj5`060=Tj5`030000002T:Q00000000L0Y2X@00<000000:@Z402T:Q00
1@2T:Q000`000000Y2X@0:@Z40040:@Z408000000`1Y60T00`000000JAP906TH2@03000000P0A6G8
00@0000004AUb014ILP0A6G81000000?049P_`0300000012H;l0@V2o01<0@V2o00<00000049P_`12
H;l05@12H;l00`000000oooo0?ooo`0R0?ooo`030000003oool0oooo0140oooo000B0?ooo`030000
003oool0oooo02P0oooo00<000000?m>803oCR004P3oCR000`000000odhP0?m>800<0?m>80800000
1@3oCR400`000000odhQ0?m>8@0;0?m>8@<000002P0>4B800`0000003Q4R00hA8P0:00hA8P030000
000>4B803Q4R00X03Q4R1000000;01`TC0030000000L94`072A<00h072A<00<0000001`TC00L94`0
3P0L94`00`00000072A<01`TC00?01`TC0030000000L94`0000000<000003P0W=Fh00`0000009cE^
02LeKP0B02LeKP030000000W=Fh09cE^01409cE^00<0000002LeKP0W=Fh02@0W=Fh010000000fCXG
0=Tj5`3I>QL502LeKP80000000<0fCXG0000003I>QL02`3I>QL00`000000fCXG0=Tj5`060=Tj5`80
0000202T:Q000`000000Y2X@0:@Z40050:@Z40030000002T:Q00Y2X@00D0Y2X@00D0000006TH2@1Y
60T0JAP90000000206TH2@030000001Y60T0000000L0A6G81000000C049P_`0300000012H;l0@V2o
01@0@V2o00<00000049P_`12H;l05012H;l00`000000oooo0?ooo`0R0?ooo`030000003oool0oooo
0140oooo000B0?ooo`030000003oool0oooo02L0oooo00<000000?m>803oCR004`3oCR000`000000
odhP0?m>800>0?m>808000000P3oCR400`000000odhQ0?m>8@090?m>8@@000002`0>4B800`000000
3Q4R00hA8P0:00hA8P030000000>4B803Q4R00T03Q4R0`00000>01`TC0030000000L94`072A<00h0
72A<00<0000001`TC00L94`03P0L94`00`00000072A<01`TC00>01`TC0<000004P0W=Fh00`000000
9cE^02LeKP0A02LeKP030000000W=Fh09cE^01809cE^00<0000002LeKP0W=Fh02P0W=Fh010000000
fCXG0=Tj5`3I>QL402LeKP8000000P3I>QL00`000000fCXG0=Tj5`090=Tj5`030000003I>QL0fCXG
00P0fCXG00<000000:@Z402T:Q001P2T:Q000`000000Y2X@0:@Z40050:@Z40030000002T:Q00Y2X@
00D0Y2X@0P00000206TH2@030000001Y60T0JAP900@000000P14ILP300000080@V2o00<00000049P
_`12H;l04`12H;l00`000000@V2o049P_`0C049P_`0300000012H;l0@V2o01D0@V2o00<000000?oo
o`3oool08@3oool00`000000oooo0?ooo`0A0?ooo`004P3oool00`000000oooo0?ooo`0V0?ooo`03
0000003oCR00odhP01<0odhP00<000000?m>803oCR004@3oCR03000000P0odhQ0`00000200hA8P03
0000000>4B803Q4R00T03Q4R00<0000000hA8P0>4B802P0>4B800`0000003Q4R00hA8P0600hA8PD0
00003`0L94`00`00000072A<01`TC00>01`TC0030000000L94`072A<00h072A<00<0000001`TC00L
94`02`0L94`40000000302LeKP0000009cE^01409cE^00<0000002LeKP0W=Fh04P0W=Fh00`000000
9cE^02LeKP0B02LeKP030000000W=Fh09cE^00X09cE^00@000000=Tj5`3I>QL0fCXG100W=Fh20000
0080fCXG00<000000=Tj5`3I>QL02@3I>QL00`000000fCXG0=Tj5`080=Tj5`<000001P2T:Q000`00
0000Y2X@0:@Z40050:@Z40030000002T:Q00Y2X@00D0Y2X@00H000000:@Z40000000000006TH2@00
000306TH2@040000001Y60T00000000000D0@V2o00<00000049P_`12H;l04`12H;l00`000000@V2o
049P_`0D049P_`0300000012H;l0@V2o01@0@V2o00<000000?ooo`3oool08@3oool00`000000oooo
0?ooo`0A0?ooo`004P3oool00`000000oooo0?ooo`0V0?ooo`030000003oCR00odhP0180odhP00<0
00000?m>803oCR004P3oCR000`000000odhP0?m>8002000000<0odhQ0`00000400hA8P030000000>
4B803Q4R00T03Q4R00<0000000hA8P0>4B802P0>4B800`0000003Q4R00hA8P0400hA8P<00000100L
94`00`00000072A<01`TC00=01`TC0030000000L94`072A<00h072A<00<0000001`TC00L94`03P0L
94`00`00000072A<01`TC00801`TC0<00000100W=Fh00`0000009cE^02LeKP0A02LeKP030000000W
=Fh09cE^01809cE^00<0000002LeKP0W=Fh04@0W=Fh00`0000009cE^02LeKP0;02LeKP040000003I
>QL0fCXG0=Tj5`@09cE^0P0000030=Tj5`030000003I>QL0fCXG00T0fCXG00<000000=Tj5`3I>QL0
203I>QL010000000fCXG0000000000050:@Z40030000002T:Q00Y2X@00D0Y2X@00<000000:@Z402T
:Q001@2T:Q001P000000Y2X@0:@Z40000000JAP9000000<0JAP900@0000006TH2@00000000001@12
H;l00`000000@V2o049P_`0C049P_`0300000012H;l0@V2o01<0@V2o00<00000049P_`12H;l05@12
H;l00`000000oooo0?ooo`0P0?ooo`030000003oool0oooo0140oooo000B0?ooo`030000003oool0
oooo02D0oooo00<000000?m>803oCR004`3oCR000`000000odhP0?m>800B0?m>80030000003oCR00
odhP0080odhP0`00000600hA8P030000000>4B803Q4R00X03Q4R00<0000000hA8P0>4B802@0>4B80
100000003Q4R00hA8P0>4B84000000H072A<00<0000001`TC00L94`03@0L94`00`00000072A<01`T
C00>01`TC0030000000L94`072A<00h072A<00<0000001`TC00L94`01@0L94`4000000L09cE^00<0
000002LeKP0W=Fh04@0W=Fh00`0000009cE^02LeKP0B02LeKP030000000W=Fh09cE^01409cE^00<0
000002LeKP0W=Fh0300W=Fh00`000000fCXG0=Tj5`0402LeKP8000000`3I>QL00`000000fCXG0=Tj
5`090=Tj5`030000003I>QL0fCXG00P0fCXG00@000000=Tj5`3I>QL0fCXG0P0000040:@Z40030000
002T:Q00Y2X@00D0Y2X@00<000000:@Z402T:Q001@2T:Q000`000000Y2X@0:@Z40020000000506TH
2@000000JAP906TH2@0000000P1Y60T00`000000@V2o049P_`02049P_`0300000012H;l0@V2o01<0
@V2o00<00000049P_`12H;l05012H;l00`000000@V2o049P_`0D049P_`030000003oool0oooo0200
oooo00<000000?ooo`3oool04@3oool00180oooo00<000000?ooo`3oool09@3oool00`000000odhP
0?m>800B0?m>80030000003oCR00odhP0180odhP00<000000?m>803oCR000`3oCR0800hA8P030000
000>4B803Q4R00X03Q4R00<0000000hA8P0>4B802@0>4B85000000X072A<00<0000001`TC00L94`0
3@0L94`00`00000072A<01`TC00>01`TC0030000000L94`072A<00h072A<00<0000001`TC00L94`0
0P0L94`3000000/09cE^00<0000002LeKP0W=Fh04@0W=Fh00`0000009cE^02LeKP0A02LeKP030000
000W=Fh09cE^01809cE^00<0000002LeKP0W=Fh0300W=Fh00`000000fCXG0=Tj5`0402LeKP800000
0`3I>QL00`000000fCXG0=Tj5`090=Tj5`030000003I>QL0fCXG00P0fCXG00<000000=Tj5`3I>QL0
0`3I>QL01@000000Y2X@0:@Z402T:Q00000000L0Y2X@00<000000:@Z402T:Q001@2T:Q000`000000
Y2X@0:@Z40020:@Z40<000000P1Y60T00`000000JAP906TH2@02000000<0@V2o00<00000049P_`12
H;l04`12H;l00`000000@V2o049P_`0C049P_`0300000012H;l0@V2o01D0@V2o00<000000?ooo`3o
ool07`3oool00`000000oooo0?ooo`0A0?ooo`004P3oool00`000000oooo0?ooo`0T0?ooo`030000
003oCR00odhP01<0odhP00<000000?m>803oCR004@3oCR000`000000odhP0?m>80020?m>80T03Q4R
00<0000000hA8P0>4B802P0>4B800`0000003Q4R00hA8P0800hA8P<000003@0L94`00`00000072A<
01`TC00=01`TC0030000000L94`072A<00h072A<00<0000001`TC00L94`03P0L94`00`00000072A<
00000003000000h09cE^00<0000002LeKP0W=Fh04@0W=Fh00`0000009cE^02LeKP0A02LeKP030000
000W=Fh09cE^01809cE^00<0000002LeKP0W=Fh0300W=Fh00`000000fCXG0=Tj5`0402LeKP030000
003I>QL0fCXG00<0fCXG00<000000=Tj5`3I>QL02@3I>QL00`000000fCXG0=Tj5`080=Tj5`030000
003I>QL0fCXG00<0fCXG0P0000020:@Z40030000002T:Q00Y2X@00D0Y2X@00<000000:@Z402T:Q00
1@2T:Q000`000000Y2X@0:@Z40030:@Z408000000P1Y60T00`000000JAP906TH2@0300000003049P
_`000000@V2o01@0@V2o00<00000049P_`12H;l05012H;l00`000000@V2o049P_`0D049P_`030000
003oool0oooo01l0oooo00<000000?ooo`3oool04@3oool00180oooo00<000000?ooo`3oool08`3o
ool00`000000odhP0?m>800C0?m>80030000003oCR00odhP0180odhP00@000000?m>803oCR00odhP
2@0>4B800`0000003Q4R00hA8P0:00hA8P030000000>4B803Q4R00H03Q4R1000000?01`TC0030000
000L94`072A<00d072A<00<0000001`TC00L94`03P0L94`00`00000072A<01`TC00=01`TC0<00000
4@0W=Fh00`0000009cE^02LeKP0A02LeKP030000000W=Fh09cE^01809cE^00<0000002LeKP0W=Fh0
4P0W=Fh00`0000009cE^02LeKP0=02LeKP80fCXG100W=Fh00`000000fCXG0=Tj5`030=Tj5`030000
003I>QL0fCXG00T0fCXG00<000000=Tj5`3I>QL0203I>QL00`000000fCXG0=Tj5`050=Tj5`800000
00<0Y2X@0000002T:Q001P2T:Q000`000000Y2X@0:@Z40040:@Z40030000002T:Q00Y2X@00D0Y2X@
00@0000006TH2@1Y60T000000P1Y60T300000003049P_`000000@V2o01@0@V2o00<00000049P_`12
H;l04`12H;l00`000000@V2o049P_`0E049P_`030000003oool0oooo01h0oooo00<000000?ooo`3o
ool04@3oool00180oooo00<000000?ooo`3oool08`3oool00`000000odhP0?m>800B0?m>80030000
003oCR00odhP0180odhP00<000000?m>803oCR002P0>4B800`0000003Q4R00hA8P0:00hA8P030000
000>4B803Q4R00@03Q4R0`00000301`TC0030000000L94`072A<00`072A<00<0000001`TC00L94`0
3@0L94`00`00000072A<01`TC00>01`TC0030000000L94`072A<00/072A<0`0000000`0W=Fh00000
02LeKP0A02LeKP030000000W=Fh09cE^01409cE^00<0000002LeKP0W=Fh04P0W=Fh00`0000009cE^
02LeKP0A02LeKP030000000W=Fh09cE^00h09cE^00<000000=Tj5`0W=Fh00P0W=Fh2000000D0fCXG
00<000000=Tj5`3I>QL02@3I>QL00`000000fCXG0=Tj5`080=Tj5`030000003I>QL0fCXG00L0fCXG
0P0000070:@Z40030000002T:Q00Y2X@00D0Y2X@00<000000:@Z402T:Q001@2T:Q020000000306TH
2@000000JAP90080JAP90`00000E049P_`0300000012H;l0@V2o01@0@V2o00<00000049P_`12H;l0
5012H;l00`000000oooo0?ooo`0N0?ooo`030000003oool0oooo0140oooo000B0?ooo`030000003o
ool0oooo0280oooo00<000000?m>803oCR004`3oCR000`000000odhP0?m>800A0?m>80030000003o
CR00odhP00X03Q4R00<0000000hA8P0>4B802P0>4B800`0000003Q4R00hA8P0200hA8P<000001@0L
94`00`00000072A<01`TC00=01`TC0030000000L94`072A<00d072A<00<0000001`TC00L94`03P0L
94`00`00000072A<01`TC00701`TC0@000000`0W=Fh00`0000009cE^02LeKP0A02LeKP030000000W
=Fh09cE^01409cE^00<0000002LeKP0W=Fh04@0W=Fh00`0000009cE^02LeKP0B02LeKP030000000W
=Fh09cE^00h09cE^1@0000000`0^@8<000000=Tj5`050=Tj5`030000003I>QL0fCXG00T0fCXG00<0
00000=Tj5`3I>QL0203I>QL00`000000fCXG0=Tj5`080=Tj5`030000002T:Q00Y2X@00D0Y2X@00<0
00000:@Z402T:Q001@2T:Q000`000000Y2X@0:@Z40040:@Z40050000002T:Q00000006TH2@000000
0`1Y60T010000000JAP900000000000D049P_`0300000012H;l0@V2o01<0@V2o00<00000049P_`12
H;l05@12H;l00`000000oooo0?ooo`0M0?ooo`030000003oool0oooo0140oooo000A0?ooo`030000
003oool0oooo02<0oooo00<000000?m>803oCR004P3oCR000`000000odhP0?m>800B0?m>80030000
000>4B803Q4R00T03Q4R00<0000000hA8P0>4B802P0>4B800`0000003Q4R00hA8P03000000P072A<
00<0000001`TC00L94`0300L94`00`00000072A<01`TC00=01`TC0030000000L94`072A<00h072A<
00<0000001`TC00L94`01@0L94`3000000L09cE^00<0000002LeKP0W=Fh04@0W=Fh00`0000009cE^
02LeKP0A02LeKP030000000W=Fh09cE^01409cE^00<0000002LeKP0W=Fh04P0W=Fh00`0000009cE^
02LeKP0;02LeKP@0000000<0mT@K02i0P`0^@8<00P0^@8<00`000000fCXG0=Tj5`040=Tj5`030000
003I>QL0fCXG00T0fCXG00<000000=Tj5`3I>QL0203I>QL00`000000fCXG0=Tj5`080=Tj5`<00000
1P2T:Q000`000000Y2X@0:@Z40040:@Z40030000002T:Q00Y2X@00D0Y2X@00<000000:@Z40000000
0`00000206TH2@030000001Y60T0JAP9008000004P12H;l00`000000@V2o049P_`0D049P_`030000
0012H;l0@V2o01@0@V2o00<000000?ooo`3oool07@3oool00`000000oooo0?ooo`0A0?ooo`004@3o
ool00`000000oooo0?ooo`0R0?ooo`030000003oCR00odhP0180odhP00<000000?m>803oCR004P3o
CR000`0000003Q4R00hA8P0900hA8P030000000>4B803Q4R00X03Q4R1000000:01`TC0030000000L
94`072A<00d072A<00<0000001`TC00L94`03@0L94`00`00000072A<01`TC00>01`TC0030000000L
94`072A<008072A<0`00000:02LeKP030000000W=Fh09cE^01009cE^00<0000002LeKP0W=Fh04@0W
=Fh00`0000009cE^02LeKP0B02LeKP030000000W=Fh09cE^01809cE^00<0000002LeKP0W=Fh01`0W
=Fh4000000<0;T2300<000000?I46`0^@8<00`0^@8<00`000000fCXG0=Tj5`040=Tj5`030000003I
>QL0fCXG00T0fCXG00<000000=Tj5`3I>QL0203I>QL00`000000fCXG0=Tj5`090=Tj5`040000003I
>QL00000000000@0Y2X@00<000000:@Z402T:Q001@2T:Q000`000000Y2X@0:@Z40050:@Z40060000
002T:Q00Y2X@0000001Y60T000000P1Y60T01@000000JAP906TH2@1Y60T000000180@V2o00<00000
049P_`12H;l04`12H;l00`000000@V2o049P_`0C049P_`<000007`3oool00`000000oooo0?ooo`0@
0?ooo`004@3oool00`000000oooo0?ooo`0Q0?ooo`030000003oCR00odhP01<0odhP00<000000?m>
803oCR004@3oCR000`0000003Q4R00hA8P0900hA8P030000000>4B803Q4R00T03Q4R0`00000=01`T
C0030000000L94`072A<00`072A<00<0000001`TC00L94`03@0L94`00`00000072A<01`TC00>01`T
C0030000000L94`0000000<000003@0W=Fh00`0000009cE^02LeKP0@02LeKP030000000W=Fh09cE^
01409cE^00<0000002LeKP0W=Fh04P0W=Fh00`0000009cE^02LeKP0A02LeKP030000000W=Fh09cE^
00@09cE^1000000702i0P`030000003fA1/0mT@K00<0;T230`0000050=Tj5`030000003I>QL0fCXG
00T0fCXG00<000000=Tj5`3I>QL0203I>QL00`000000fCXG0=Tj5`080=Tj5`050000003I>QL0fCXG
0=Tj5`000000102T:Q000`000000Y2X@0:@Z40050:@Z40030000002T:Q00Y2X@00@0Y2X@00@00000
0:@Z402T:Q00Y2X@0`00000206TH2@040000001Y60T0JAP906TH2@8000004012H;l00`000000@V2o
049P_`0D049P_`0300000012H;l0@V2o00h0@V2o1000000203mL]`030000003oool0oooo01d0oooo
00<000000?ooo`3oool0403oool00140oooo00<000000?ooo`3oool08@3oool00`000000odhP0?m>
800B0?m>80030000003oCR00odhP0100odhP00<03Q4R0000000>4B802P0>4B800`0000003Q4R00hA
8P0600hA8PD000003P0L94`00`00000072A<01`TC00=01`TC0030000000L94`072A<00d072A<00<0
000001`TC00L94`03@0L94`3000001009cE^00<0000002LeKP0W=Fh04@0W=Fh00`0000009cE^02Le
KP0A02LeKP030000000W=Fh09cE^01809cE^00<0000002LeKP0W=Fh04@0W=Fh00`0000009cE^02Le
KP04000000`0;T2300<000000?I46`0^@8<00P0^@8<00`000000mT@K0?I46`02000000<0fCXG00<0
00000=Tj5`3I>QL02@3I>QL00`000000fCXG0=Tj5`080=Tj5`030000003I>QL0fCXG00P0fCXG00<0
00000=Tj5`3I>QL00P3I>QL200000080Y2X@00<000000:@Z402T:Q001@2T:Q000`000000Y2X@0:@Z
40050:@Z40030000002T:Q00Y2X@0080Y2X@0P00000206TH2@8000000P1Y60T200000100@V2o00<0
0000049P_`12H;l04`12H;l00`000000@V2o049P_`0:049P_`@000001`0oG;L00`000000oooo0?oo
o`0L0?ooo`030000003oool0oooo0100oooo000A0?ooo`030000003oool0oooo0200oooo00<00000
0?m>803oCR004`3oCR000`000000odhP0?m>800?0?m>800300hA8P0000003Q4R00X03Q4R00<00000
00hA8P0>4B80100>4B83000000@072A<00<0000001`TC00L94`0300L94`00`00000072A<01`TC00<
01`TC0030000000L94`072A<00d072A<00<0000001`TC00L94`02`0L94`30000000302LeKP000000
9cE^01009cE^00<0000002LeKP0W=Fh04@0W=Fh00`0000009cE^02LeKP0A02LeKP030000000W=Fh0
9cE^01409cE^00<0000002LeKP0W=Fh04@0W=Fh400000100;T2300@000000?I46`0^@8<0;T230P00
00040?I46`80000000<0fCXG0000003I>QL02P3I>QL00`000000fCXG0=Tj5`080=Tj5`030000003I
>QL0fCXG00T0fCXG00<000000=Tj5`3I>QL00`3I>QL010000000Y2X@0:@Z400000070:@Z40030000
002T:Q00Y2X@00D0Y2X@00<000000:@Z402T:Q000P2T:Q02000000<0JAP900<0000006TH2@1Y60T0
0`00000>049P_`0300000012H;l0@V2o01@0@V2o00<00000049P_`12H;l01@12H;l4000000/0?ebg
00<000000?ooo`3oool0703oool00`000000oooo0?ooo`0@0?ooo`004@3oool00`000000oooo0?oo
o`0P0?ooo`030000003oCR00odhP0180odhP00<000000?m>803oCR003P3oCR0200hA8P030000000>
4B803Q4R00T03Q4R00@0000000hA8P0>4B803Q4R1000000601`TC0030000000L94`072A<00`072A<
00<0000001`TC00L94`03@0L94`00`00000072A<01`TC00=01`TC0030000000L94`072A<00L072A<
1000000302LeKP030000000W=Fh09cE^01009cE^00<0000002LeKP0W=Fh0400W=Fh00`0000009cE^
02LeKP0A02LeKP030000000W=Fh09cE^01809cE^00<0000002LeKP0W=Fh03@0W=Fh40000000302i0
P`000000;T230140;T2300@000000?I46`0^@8<0;T230P0000060?I46`<000002`3I>QL00`000000
fCXG0=Tj5`080=Tj5`030000003I>QL0fCXG00P0fCXG00<000000=Tj5`3I>QL0103I>QL200000003
0:@Z40000000Y2X@00H0Y2X@00<000000:@Z402T:Q00102T:Q000`000000Y2X@0:@Z40040:@Z4005
0000001Y60T0JAP906TH2@0000000P1Y60T010000000JAP900000000000=049P_`0300000012H;l0
@V2o01<0@V2o00@00000049P_`12H;l0@V2o1000000?03mL]`030000003oool0oooo01`0oooo00<0
00000?ooo`3oool0403oool00140oooo00<000000?ooo`3oool07`3oool2000001<0odhP00<00000
0?m>803oCR003@3oCR0300hA8P030000000>4B803Q4R00T03Q4R1@00000:01`TC0030000000L94`0
72A<00`072A<00<0000001`TC00L94`0300L94`00`00000072A<01`TC00=01`TC0030000000L94`0
72A<00D072A<0`00000702LeKP030000000W=Fh09cE^01009cE^00<0000002LeKP0W=Fh0400W=Fh0
0`0000009cE^02LeKP0A02LeKP030000000W=Fh09cE^01809cE^00<0000002LeKP0W=Fh02@0W=Fh4
000000D0;T2300<0000002i0P`0^@8<0400^@8<010000000mT@K02i0P`0^@8<2000000P0mT@K00<0
00000=Tj5`3I>QL02@3I>QL00`000000fCXG0=Tj5`080=Tj5`030000003I>QL0fCXG00P0fCXG00<0
00000=Tj5`3I>QL01P3I>QL2000000L0Y2X@00<000000:@Z402T:Q001@2T:Q000`000000Y2X@0:@Z
40040:@Z408000000P1Y60T00`000000JAP906TH2@020000000306TH2@000000@V2o00/0@V2o00<0
0000049P_`12H;l04`12H;l4000001@0?ebg00<000000?ooo`3oool06`3oool00`000000oooo0?oo
o`0@0?ooo`004@3oool00`000000oooo0?ooo`0O0?ooo`040000003oC1l0000000000140odhP00<0
00000?m>803oCR00303oCR0300hA8P030000000>4B803Q4R00P03Q4R0`00000=01`TC0030000000L
94`072A<00`072A<00<0000001`TC00L94`03@0L94`00`00000072A<01`TC00=01`TC0030000000L
94`072A<008072A<0`00000:02LeKP030000000W=Fh09cE^00l09cE^00<0000002LeKP0W=Fh04@0W
=Fh00`0000009cE^02LeKP0A02LeKP030000000W=Fh09cE^01809cE^00<0000002LeKP0W=Fh01P0W
=Fh3000000T0;T2300<0000002i0P`0^@8<0400^@8<010000000mT@K02i0P`0^@8<2000000P0mT@K
0`0000090=Tj5`030000003I>QL0fCXG00P0fCXG00<000000=Tj5`3I>QL02@3I>QL00`000000fCXG
0=Tj5`070=Tj5`030000002T:Q00Y2X@00D0Y2X@00<000000:@Z402T:Q001@2T:Q000`000000Y2X@
0:@Z40030:@Z40060000002T:Q0000000000001Y60T000000`1Y60T010000000JAP900000000000;
049P_`0300000012H;l0@V2o00h0@V2o100000000`0oG;L0000003mL]`0E03mL]`030000003oool0
oooo01/0oooo00<000000?ooo`3oool0403oool00140oooo00<000000?ooo`3oool07P3oool00`00
0000od`O0?m<7`020?m<7`<000003@3oCR000`000000odhP0?m>800;0?m>80@03Q4R00<0000000hA
8P0>4B801@0>4B85000000l072A<00<0000001`TC00L94`02`0L94`00`00000072A<01`TC00=01`T
C0030000000L94`072A<00d072A<00<0000001`TC00000000`00000=02LeKP030000000W=Fh09cE^
00l09cE^00<0000002LeKP0W=Fh04@0W=Fh00`0000009cE^02LeKP0A02LeKP030000000W=Fh09cE^
01409cE^00<0000002LeKP0W=Fh00`0W=Fh4000000`0;T2300<0000002i0P`0^@8<0400^@8<01000
0000mT@K02i0P`0^@8<2000000P0mT@K00<000000?I46`3fA1/00P0000080=Tj5`030000003I>QL0
fCXG00P0fCXG00<000000=Tj5`3I>QL0203I>QL00`000000fCXG0=Tj5`070=Tj5`<000001P2T:Q00
0`000000Y2X@0:@Z40040:@Z40030000002T:Q00Y2X@00@0Y2X@00H000000:@Z402T:Q00000006TH
2@00000306TH2@040000001Y60T0JAP9000000X0@V2o00<00000049P_`12H;l02P12H;l4000000H0
?ebg00<0000003mL]`0oG;L0500oG;L00`000000oooo0?ooo`0J0?ooo`030000003oool0oooo0100
oooo000A0?ooo`030000003oool0oooo01h0oooo00<000000?m<7`3oC1l01@3oC1l2000000X0odhP
00<000000?m>803oCR002P3oCR0500hA8P030000000>4B803Q4R00<03Q4R0`00000401`TC0030000
000L94`072A<00`072A<00<0000001`TC00L94`0300L94`00`00000072A<01`TC00=01`TC0030000
000L94`072A<00`072A<0`00000@02LeKP030000000W=Fh09cE^01009cE^00<0000002LeKP0W=Fh0
400W=Fh00`0000009cE^02LeKP0B02LeKP030000000W=Fh09cE^01409cE^00<0000002LeKP000000
0`00000@02i0P`030000000^@8<0;T230100;T2300@000000?I46`0^@8<0;T230P0000080?I46`03
0000003fA1/0mT@K0080mT@K00<000000=Tj5`3I>QL01@3I>QL00`000000fCXG0=Tj5`080=Tj5`03
0000003I>QL0fCXG00P0fCXG00<000000=Tj5`3I>QL0203I>QL010000000fCXG0000000000040:@Z
40030000002T:Q00Y2X@00D0Y2X@00<000000:@Z402T:Q00102T:Q000`000000Y2X@0:@Z40020000
000506TH2@000000JAP906TH2@0000000P1Y60T2000000T0@V2o00<00000049P_`12H;l01@12H;l4
000000X0?ebg00<0000003mL]`0oG;L0500oG;L00`000000oooo0?ooo`0J0?ooo`030000003oool0
oooo0100oooo000A0?ooo`030000003oool0oooo01d0oooo00<000000?m<7`3oC1l0203oC1l20000
00P0odhP00<000000?m>803oCR002@3oCR0500hA8P040000000>4B803Q4R00hA8P<000001P0L94`0
0`00000072A<01`TC00<01`TC0030000000L94`072A<00`072A<00<0000001`TC00L94`03@0L94`0
0`00000072A<01`TC00901`TC0@0000000<09cE^0000000W=Fh0400W=Fh00`0000009cE^02LeKP0@
02LeKP030000000W=Fh09cE^01009cE^00<0000002LeKP0W=Fh04@0W=Fh00`0000009cE^02LeKP0A
02LeKP<00000500^@8<00`000000;T2302i0P`0@02i0P`040000003fA1/0;T2302i0P`800000203f
A1/00`000000mT@K0?I46`030?I46`8000001@3I>QL00`000000fCXG0=Tj5`090=Tj5`030000003I
>QL0fCXG00P0fCXG00<000000=Tj5`3I>QL01`3I>QL01@000000fCXG0=Tj5`3I>QL0000000@0Y2X@
00<000000:@Z402T:Q001@2T:Q000`000000Y2X@0:@Z40030:@Z40030000002T:Q00Y2X@0080Y2X@
0`00000206TH2@030000001Y60T0JAP9008000002012H;l010000000@V2o049P_`12H;l4000000l0
?ebg00<0000003mL]`0oG;L04`0oG;L00`000000oooo0?ooo`0J0?ooo`030000003oool0oooo0100
oooo000A0?ooo`030000003oool0oooo01d0oooo00<000000?m<7`3oC1l02P3oC1l3000000@0odhP
00<000000?m>803oCR00203oCR0600hA8PD000002@0L94`00`00000072A<01`TC00<01`TC0030000
000L94`072A<00`072A<00<0000001`TC00L94`03@0L94`00`00000072A<01`TC00501`TC0@00000
100W=Fh00`0000009cE^02LeKP0@02LeKP030000000W=Fh09cE^00l09cE^00<0000002LeKP0W=Fh0
4@0W=Fh00`0000009cE^02LeKP0A02LeKP030000000W=Fh09cE^00d09cE^100000000`0^@8<00000
02i0P`0D02i0P`030000000^@8<0;T230100;T2300@000000?I46`0^@8<0;T230P0000090?I46`03
0000003fA1/0mT@K00@0mT@K0P0000040=Tj5`030000003I>QL0fCXG00P0fCXG00<000000=Tj5`3I
>QL0203I>QL00`000000fCXG0=Tj5`070=Tj5`030000003I>QL0fCXG0080fCXG0P0000020:@Z4003
0000002T:Q00Y2X@00H0Y2X@00<000000:@Z402T:Q000`2T:Q000`000000Y2X@0:@Z40030:@Z4080
00000P1Y60T00`000000JAP906TH2@02000000L0@V2o1000000C03mL]`030000000oG;L0?ebg01@0
?ebg00<000000?ooo`3oool06@3oool00`000000oooo0?ooo`0@0?ooo`004@3oool00`000000oooo
0?ooo`0L0?ooo`030000003oC1l0od`O00h0od`O0P0000020?m>80030000003oCR00odhP00H0odhP
1P0>4B83000000`072A<00<0000001`TC00L94`0300L94`00`00000072A<01`TC00<01`TC0030000
000L94`072A<00d072A<00<0000001`TC00L94`00P0L94`4000000P09cE^00<0000002LeKP0W=Fh0
400W=Fh00`0000009cE^02LeKP0?02LeKP030000000W=Fh09cE^01409cE^00<0000002LeKP0W=Fh0
4@0W=Fh00`0000009cE^02LeKP0902LeKP@000001@0^@8<00`000000;T2302i0P`0C02i0P`030000
000^@8<0;T230140;T2300<0000002i0P`0^@8<00P0000090?I46`030000003fA1/0mT@K00H0mT@K
00D000000=Tj5`3I>QL0fCXG0000000:0=Tj5`030000003I>QL0fCXG00P0fCXG00<000000=Tj5`3I
>QL0203I>QL00`000000fCXG0=Tj5`030=Tj5`040000002T:Q00Y2X@000000L0Y2X@00<000000:@Z
402T:Q00102T:Q000`000000Y2X@0:@Z40040:@Z40040000001Y60T0JAP900000080JAP90`000002
049P_`<0000000<0?ebg0000000oG;L0500oG;L00`000000?ebg03mL]`0D03mL]`030000003oool0
oooo01T0oooo00<000000?ooo`3oool0403oool00140oooo00<000000?ooo`3oool0703oool00`00
0000od`O0?m<7`0@0?m<7`<000001`3oCR0300hA8PD000003P0L94`00`00000072A<01`TC00<01`T
C0030000000L94`072A<00`072A<00<0000001`TC00L94`03@0L94`5000000`09cE^00<0000002Le
KP0W=Fh03`0W=Fh00`0000009cE^02LeKP0@02LeKP030000000W=Fh09cE^01009cE^00<0000002Le
KP0W=Fh04P0W=Fh00`0000009cE^02LeKP0602LeKP<000002@0^@8<00`000000;T2302i0P`0C02i0
P`030000000^@8<0;T230140;T2300<0000002i0P`0^@8<00P0000090?I46`030000003fA1/0mT@K
00L0mT@K0P0000000`3I>QL000000=Tj5`0:0=Tj5`030000003I>QL0fCXG00P0fCXG00<000000=Tj
5`3I>QL01`3I>QL00`000000fCXG0=Tj5`040=Tj5`80000000<0Y2X@0000002T:Q001P2T:Q000`00
0000Y2X@0:@Z40030:@Z40030000002T:Q00Y2X@00D0Y2X@0P000000101Y60T0000006TH2@1Y60T4
000000D0?ebg00<0000003mL]`0oG;L04`0oG;L00`000000?ebg03mL]`0C03mL]`030000003oool0
oooo01T0oooo00<000000?ooo`3oool0403oool00140oooo00<000000?ooo`3oool06`3oool00`00
0000od`O0?m<7`0B0?m<7`040000003oC1l00000000000<0odhP00<03Q4R0000000000000P000004
01`TC0030000000L94`072A<00/072A<00<0000001`TC00L94`0300L94`00`00000072A<01`TC00<
01`TC0030000000L94`072A<00`072A<0`00000@02LeKP030000000W=Fh09cE^00l09cE^00<00000
02LeKP0W=Fh0400W=Fh00`0000009cE^02LeKP0@02LeKP030000000W=Fh09cE^01409cE^00<00000
02LeKP0W=Fh00`0W=Fh4000000`0;T2300<0000002i0P`0^@8<04P0^@8<00`000000;T2302i0P`0B
02i0P`030000000^@8<0;T23008000002@3fA1/00`000000mT@K0?I46`090?I46`<000002P3I>QL0
0`000000fCXG0=Tj5`080=Tj5`030000003I>QL0fCXG00L0fCXG00<000000=Tj5`3I>QL01P3I>QL2
000000P0Y2X@00<000000:@Z402T:Q000`2T:Q000`000000Y2X@0:@Z40040:@Z40050000002T:Q00
000006TH2@0000000`1Y60T00`000000JAP903mL]`0403mL]`030000000oG;L0?ebg01<0?ebg00<0
000003mL]`0oG;L0500oG;L00`000000oooo0?ooo`0H0?ooo`030000003oool0oooo0100oooo000A
0?ooo`030000003oool0oooo01/0oooo00<000000?m<7`3oC1l04@3oC1l00`000000od`O0?m<7`02
0?m<7`@000001`0L94`00`00000072A<01`TC00;01`TC0030000000L94`072A<00d072A<00<00000
01`TC00L94`0300L94`00`00000072A<01`TC00901`TC0<0000000<09cE^0000000W=Fh03`0W=Fh0
0`0000009cE^02LeKP0@02LeKP030000000W=Fh09cE^00l09cE^00<0000002LeKP0W=Fh04@0W=Fh0
0`0000009cE^02LeKP0A02LeKP030000000W=Fh0000000<00000400^@8<00`000000;T2302i0P`0B
02i0P`030000000^@8<0;T230180;T2300<0000002i0P`0^@8<00P0000090?I46`030000003fA1/0
mT@K00/0mT@K00<000000=Tj5`3I>QL0203I>QL00`000000fCXG0=Tj5`080=Tj5`030000003I>QL0
fCXG00P0fCXG00<000000=Tj5`3I>QL01`3I>QL00`000000Y2X@0:@Z40050:@Z40030000002T:Q00
Y2X@00@0Y2X@00<000000:@Z402T:Q00102T:Q000`000000Y2X@0000000300000080JAP900<00000
06TH2@0oG;L0100oG;L00`000000?ebg03mL]`0C03mL]`030000000oG;L0?ebg01<0?ebg00<00000
0?ooo`3oool0603oool00`000000oooo0?ooo`0@0?ooo`00403oool00`000000oooo0?ooo`0L0?oo
o`030000003oC1l0od`O0140od`O00<000000?m<7`3oC1l00`3oC1l:01`TC0030000000L94`072A<
00/072A<00<0000001`TC00L94`0300L94`00`00000072A<01`TC00<01`TC0030000000L94`072A<
00L072A<0`00000302LeKP030000000W=Fh09cE^00l09cE^00<0000002LeKP0W=Fh0400W=Fh00`00
00009cE^02LeKP0?02LeKP030000000W=Fh09cE^01409cE^00<0000002LeKP0W=Fh0400W=Fh30000
01@0;T2300<0000002i0P`0^@8<04P0^@8<00`000000;T2302i0P`0B02i0P`030000000^@8<0;T23
008000002@3fA1/00`000000mT@K0?I46`0;0?I46`<000002@3I>QL00`000000fCXG0=Tj5`080=Tj
5`030000003I>QL0fCXG00L0fCXG00<000000=Tj5`3I>QL01`3I>QL3000000H0Y2X@00<000000:@Z
402T:Q000`2T:Q000`000000Y2X@0:@Z40050:@Z40030000002T:Q00Y2X@00<000000P1Y60T00`00
0000JAP906TH2@0303mL]`030000000oG;L0?ebg01<0?ebg00<0000003mL]`0oG;L04`0oG;L00`00
0000oooo0?ooo`0H0?ooo`030000003oool0oooo0100oooo000@0?ooo`030000003oool0oooo01/0
oooo00<000000?m<7`3oC1l04@3oC1l00`000000od`O0?m<7`030?m<7`X072A<00<0000001`TC00L
94`02`0L94`00`00000072A<01`TC00=01`TC0030000000L94`072A<00`072A<00<0000001`TC00L
94`00`0L94`4000000H09cE^00<0000002LeKP0W=Fh03`0W=Fh00`0000009cE^02LeKP0?02LeKP03
0000000W=Fh09cE^01009cE^00<0000002LeKP0W=Fh0400W=Fh00`0000009cE^02LeKP0=02LeKP@0
000000<0;T230000000^@8<04`0^@8<00`000000;T2302i0P`0C02i0P`030000000^@8<0;T230180
;T2300<0000002i0P`0^@8<00P0000090?I46`030000003fA1/0mT@K00/0mT@K00<000000?I46`3f
A1/00P0000070=Tj5`030000003I>QL0fCXG00P0fCXG00<000000=Tj5`3I>QL0203I>QL00`000000
fCXG0=Tj5`070=Tj5`040000003I>QL00000000000D0Y2X@00<000000:@Z402T:Q000`2T:Q000`00
0000Y2X@0:@Z40040:@Z40030000002T:Q00Y2X@0080Y2X@0P00000206TH2@030000001Y60T0JAP9
00<0?ebg00<0000003mL]`0oG;L04`0oG;L00`000000?ebg03mL]`0C03mL]`030000003oool0oooo
01P0oooo00<000000?ooo`3oool03`3oool00100oooo00<000000?ooo`3oool06`3oool00`000000
od`O0?m<7`0A0?m<7`030000003oC1l0od`O0080od`O2P0L94`00`00000072A<01`TC00<01`TC003
0000000L94`072A<00`072A<00<0000001`TC00L94`0300L94`01000000072A<01`TC00L94`30000
00X09cE^00<0000002LeKP0W=Fh03`0W=Fh00`0000009cE^02LeKP0?02LeKP030000000W=Fh09cE^
01009cE^00<0000002LeKP0W=Fh0400W=Fh00`0000009cE^02LeKP0902LeKP@000001@0^@8<00`00
0000;T2302i0P`0B02i0P`030000000^@8<0;T2301<0;T2300<0000002i0P`0^@8<04P0^@8<00`00
0000;T2302i0P`02000000T0mT@K00<000000?I46`3fA1/02`3fA1/00`000000mT@K0?I46`020?I4
6`8000001@3I>QL00`000000fCXG0=Tj5`090=Tj5`030000003I>QL0fCXG00L0fCXG00<000000=Tj
5`3I>QL01`3I>QL010000000fCXG0=Tj5`3I>QL2000000<0Y2X@00<000000:@Z402T:Q00102T:Q00
0`000000Y2X@0:@Z40040:@Z40030000002T:Q00Y2X@0080Y2X@0P00000206TH2@060000001Y60T0
JAP906TH2@0oG;L000005@0oG;L00`000000?ebg03mL]`0C03mL]`030000003oool0oooo01P0oooo
00<000000?ooo`3oool03`3oool00100oooo00<000000?ooo`3oool06P3oool00`000000od`O0?m<
7`0A0?m<7`030000003oC1l0od`O0080od`O2`0L94`00`00000072A<01`TC00;01`TC0030000000L
94`072A<00`072A<00<0000001`TC00L94`03@0L94`4000000`09cE^00<0000002LeKP0W=Fh03`0W
=Fh00`0000009cE^02LeKP0@02LeKP030000000W=Fh09cE^00l09cE^00<0000002LeKP0W=Fh04@0W
=Fh00`0000009cE^02LeKP0602LeKP<000002@0^@8<00`000000;T2302i0P`0B02i0P`030000000^
@8<0;T2301<0;T2300<0000002i0P`0^@8<04P0^@8<00`000000;T2302i0P`02000000T0mT@K00<0
00000?I46`3fA1/02`3fA1/00`000000mT@K0?I46`040?I46`030000003I>QL0fCXG00<0fCXG00<0
00000=Tj5`3I>QL0203I>QL00`000000fCXG0=Tj5`070=Tj5`030000003I>QL0fCXG00L0fCXG00<0
00000=Tj5`3I>QL00`3I>QL200000080Y2X@00<000000:@Z402T:Q00102T:Q000`000000Y2X@0:@Z
40030:@Z40030000002T:Q00Y2X@00@0Y2X@00@0000006TH2@1Y60T000000`1Y60T00`0oG;L00000
03mL]`0C03mL]`030000000oG;L0?ebg01@0?ebg00<000000?ooo`3oool05`3oool00`000000oooo
0?ooo`0?0?ooo`00403oool00`000000oooo0?ooo`0J0?ooo`030000003oC1l0od`O0140od`O00@0
00000?m<7`3oC1l0od`O2`0L94`00`00000072A<01`TC00<01`TC0030000000L94`072A<00`072A<
00<0000001`TC00L94`02`0L94`3000000l09cE^00<0000002LeKP0W=Fh03`0W=Fh00`0000009cE^
02LeKP0?02LeKP030000000W=Fh09cE^01009cE^00<0000002LeKP0W=Fh04@0W=Fh00`0000009cE^
02LeKP0202LeKP@00000300^@8<00`000000;T2302i0P`0B02i0P`030000000^@8<0;T2301<0;T23
00<0000002i0P`0^@8<04P0^@8<00`000000mT@K02i0P`02000000X0mT@K00<000000?I46`3fA1/0
2`3fA1/00`000000mT@K0?I46`040?I46`8000000`3I>QL00`000000fCXG0=Tj5`080=Tj5`030000
003I>QL0fCXG00P0fCXG00<000000=Tj5`3I>QL01`3I>QL00`000000fCXG0=Tj5`040=Tj5`800000
00<0Y2X@0000002T:Q00102T:Q000`000000Y2X@0:@Z40040:@Z40030000002T:Q00Y2X@00@0Y2X@
0P0000000`1Y60T0000006TH2@0206TH2@030000000oG;L0?ebg01<0?ebg00<0000003mL]`0oG;L0
4`0oG;L00`000000oooo0?ooo`0G0?ooo`030000003oool0oooo00l0oooo000@0?ooo`030000003o
ool0oooo01T0oooo00<000000?m<7`3oC1l04@3oC1l010000000od`O0?m<7`3oC1l<01`TC0030000
000L94`072A<00/072A<00<0000001`TC00L94`0300L94`00`00000072A<01`TC00801`TC0@00000
00<09cE^0000000W=Fh03`0W=Fh00`0000009cE^02LeKP0?02LeKP030000000W=Fh09cE^00l09cE^
00<0000002LeKP0W=Fh0400W=Fh00`0000009cE^02LeKP0@02LeKP030000000W=Fh0000000<00000
400^@8<00`000000;T2302i0P`0B02i0P`030000000^@8<0;T2301<0;T2300<0000002i0P`0^@8<0
4P0^@8<00`000000mT@K02i0P`02000000X0mT@K00<000000?I46`3fA1/02`3fA1/00`000000mT@K
0?I46`060?I46`80000000<0fCXG0000003I>QL02P3I>QL00`000000fCXG0=Tj5`070=Tj5`030000
003I>QL0fCXG00L0fCXG00<000000=Tj5`3I>QL01P3I>QL2000000H0Y2X@00<000000:@Z402T:Q00
102T:Q000`000000Y2X@0:@Z40030:@Z40050000002T:Q00000006TH2@0000000`1Y60T00`000000
?ebg03mL]`0B03mL]`030000000oG;L0?ebg01<0?ebg00<000000?ooo`3oool05`3oool00`000000
oooo0?ooo`0?0?ooo`00403oool00`000000oooo0?ooo`0I0?ooo`030000003oC1l0od`O0140od`O
00<000000?m<7`3oC1l0300L94`00`00000072A<01`TC00<01`TC0030000000L94`072A<00`072A<
00<0000001`TC00L94`01@0L94`3000000@09cE^00<0000002LeKP0W=Fh03`0W=Fh00`0000009cE^
02LeKP0?02LeKP030000000W=Fh09cE^00l09cE^00<0000002LeKP0W=Fh0400W=Fh00`0000009cE^
02LeKP0?02LeKP<000004`0^@8<00`000000;T2302i0P`0C02i0P`030000000^@8<0;T2301<0;T23
00<0000002i0P`0^@8<04`0^@8<010000000;T2300000000000:0?I46`030000003fA1/0mT@K00/0
mT@K00<000000?I46`3fA1/0203fA1/3000000X0fCXG00<000000=Tj5`3I>QL01`3I>QL00`000000
fCXG0=Tj5`080=Tj5`030000003I>QL0fCXG00L0fCXG00<000000:@Z402T:Q00102T:Q000`000000
Y2X@0:@Z40030:@Z40030000002T:Q00Y2X@00@0Y2X@00H000000:@Z40000000000006TH2@000002
06TH2@030000000oG;L0?ebg0180?ebg00<0000003mL]`0oG;L04`0oG;L00`000000oooo0?ooo`0F
0?ooo`030000003oool0oooo00l0oooo000@0?ooo`030000003oool0oooo01T0oooo00<000000?m<
7`3oC1l04@3oC1l00`000000od`O01`TC00;01`TC0030000000L94`072A<00`072A<00<0000001`T
C00L94`0300L94`00`00000072A<01`TC00201`TC0@000001`0W=Fh00`0000009cE^02LeKP0>02Le
KP030000000W=Fh09cE^00l09cE^00<0000002LeKP0W=Fh0400W=Fh00`0000009cE^02LeKP0?02Le
KP030000000W=Fh09cE^00`09cE^100000000`0^@8<0000002i0P`0C02i0P`030000000^@8<0;T23
01<0;T2300<0000002i0P`0^@8<04`0^@8<00`000000;T2302i0P`0C02i0P`80000000<0mT@K0000
003fA1/02@3fA1/00`000000mT@K0?I46`0;0?I46`030000003fA1/0mT@K00X0mT@K00<000000=Tj
5`3I>QL0203I>QL00`000000fCXG0=Tj5`080=Tj5`030000003I>QL0fCXG00L0fCXG00<000000=Tj
5`3I>QL01`3I>QL3000000@0Y2X@00<000000:@Z402T:Q00102T:Q000`000000Y2X@0:@Z40040:@Z
40030000002T:Q00Y2X@00<000000P1Y60T00`000000?ebg03mL]`0A03mL]`030000000oG;L0?ebg
01<0?ebg00<000000?ooo`3oool05P3oool00`000000oooo0?ooo`0?0?ooo`00403oool00`000000
oooo0?ooo`0H0?ooo`030000003oC1l0od`O0140od`O00<000000?m<7`0L94`0300L94`00`000000
72A<01`TC00;01`TC0030000000L94`072A<00d072A<1@00000;02LeKP030000000W=Fh09cE^00h0
9cE^00<0000002LeKP0W=Fh03`0W=Fh00`0000009cE^02LeKP0?02LeKP030000000W=Fh09cE^0100
9cE^00<0000002LeKP0W=Fh02@0W=Fh3000000D0;T2300<0000002i0P`0^@8<04P0^@8<00`000000
;T2302i0P`0C02i0P`030000000^@8<0;T2301<0;T2300<0000002i0P`0^@8<04`0^@8<200000003
0?I46`000000mT@K00T0mT@K00<000000?I46`3fA1/02`3fA1/00`000000mT@K0?I46`0:0?I46`<0
00002@3I>QL00`000000fCXG0=Tj5`070=Tj5`030000003I>QL0fCXG00L0fCXG00<000000=Tj5`3I
>QL0203I>QL00`000000fCXG000000040:@Z40030000002T:Q00Y2X@00@0Y2X@00<000000:@Z402T
:Q000`2T:Q000`000000Y2X@0:@Z40020:@Z408000000P1Y60T00`000000?ebg03mL]`0@03mL]`03
0000000oG;L0?ebg01<0?ebg00<000000?ooo`3oool05P3oool00`000000oooo0?ooo`0?0?ooo`00
403oool00`000000oooo0?ooo`0H0?ooo`030000003oC1l0od`O0140od`O00<0000001`TC00L94`0
2`0L94`00`00000072A<01`TC00<01`TC0030000000L94`072A<00/072A<0`00000>02LeKP030000
000W=Fh09cE^00l09cE^00<0000002LeKP0W=Fh03`0W=Fh00`0000009cE^02LeKP0?02LeKP030000
000W=Fh09cE^01009cE^00<0000002LeKP0W=Fh01@0W=Fh4000000P0;T2300<0000002i0P`0^@8<0
4P0^@8<00`000000;T2302i0P`0C02i0P`030000000^@8<0;T2301<0;T2300<0000002i0P`0^@8<0
4`0^@8<2000000030?I46`000000mT@K00T0mT@K00<000000?I46`3fA1/02`3fA1/00`000000mT@K
0?I46`0:0?I46`030000003fA1/0mT@K008000001`3I>QL00`000000fCXG0=Tj5`070=Tj5`030000
003I>QL0fCXG00P0fCXG00<000000=Tj5`3I>QL01`3I>QL00`000000fCXG0=Tj5`02000000<0Y2X@
00<000000:@Z402T:Q000`2T:Q000`000000Y2X@0:@Z40040:@Z40030000002T:Q00Y2X@0080Y2X@
0P00000206TH2@030000001Y60T0?ebg0100?ebg00<0000003mL]`0oG;L04`0oG;L00`000000oooo
0?ooo`0E0?ooo`030000003oool0oooo00l0oooo000@0?ooo`030000003oool0oooo01L0oooo00<0
00000?m<7`3oC1l04@3oC1l00`00000072A<01`TC00;01`TC0030000000L94`072A<00`072A<00<0
000001`TC00L94`0200L94`40000000302LeKP0000009cE^00h09cE^00<0000002LeKP0W=Fh03P0W
=Fh00`0000009cE^02LeKP0?02LeKP030000000W=Fh09cE^01009cE^00<0000002LeKP0W=Fh0400W
=Fh00`0000009cE^02LeKP0202LeKP<00000300^@8<00`000000;T2302i0P`0B02i0P`030000000^
@8<0;T2301<0;T2300<0000002i0P`0^@8<04`0^@8<00`000000;T2302i0P`0C02i0P`80000000<0
mT@K0000003fA1/02@3fA1/00`000000mT@K0?I46`0;0?I46`030000003fA1/0mT@K00X0mT@K00<0
00000?I46`3fA1/00P3fA1/2000000D0fCXG00<000000=Tj5`3I>QL0203I>QL00`000000fCXG0=Tj
5`070=Tj5`030000003I>QL0fCXG00L0fCXG00<000000=Tj5`3I>QL00P3I>QL010000000Y2X@0:@Z
400000060:@Z40030000002T:Q00Y2X@00@0Y2X@00<000000:@Z402T:Q000`2T:Q001@000000JAP9
06TH2@000000JAP90100?ebg00<0000003mL]`0oG;L04`0oG;L00`000000oooo0?ooo`0E0?ooo`03
0000003oool0oooo00l0oooo000@0?ooo`030000003oool0oooo01L0oooo00<000000?m<7`3oC1l0
4@3oC1l00`00000072A<01`TC00;01`TC0030000000L94`072A<00`072A<00<0000001`TC00L94`0
1@0L94`3000000@09cE^00<0000002LeKP0W=Fh03P0W=Fh00`0000009cE^02LeKP0>02LeKP030000
000W=Fh09cE^00l09cE^00<0000002LeKP0W=Fh0400W=Fh00`0000009cE^02LeKP0?02LeKP030000
000W=Fh0000000<000003`0^@8<00`000000;T2302i0P`0B02i0P`030000000^@8<0;T2301<0;T23
00<0000002i0P`0^@8<04`0^@8<00`000000;T2302i0P`0C02i0P`80000000<0mT@K0000003fA1/0
2@3fA1/00`000000mT@K0?I46`0;0?I46`030000003fA1/0mT@K00/0mT@K00<000000?I46`3fA1/0
0`3fA1/00`000000fCXG0=Tj5`030=Tj5`030000003I>QL0fCXG00L0fCXG00<000000=Tj5`3I>QL0
1`3I>QL00`000000fCXG0=Tj5`080=Tj5`030000003I>QL0fCXG0080fCXG0P0000000`2T:Q000000
0:@Z40050:@Z40030000002T:Q00Y2X@00<0Y2X@00<000000:@Z402T:Q00102T:Q020000000306TH
2@00000000000100?ebg00<0000003mL]`0oG;L04`0oG;L00`000000oooo0?ooo`0D0?ooo`030000
003oool0oooo00l0oooo000@0?ooo`030000003oool0oooo01H0oooo00<000000?m<7`3oC1l04@3o
C1l00`00000072A<01`TC00;01`TC0030000000L94`072A<00`072A<00<0000001`TC00L94`00P0L
94`4000000L09cE^00<0000002LeKP0W=Fh03P0W=Fh00`0000009cE^02LeKP0>02LeKP030000000W
=Fh09cE^00l09cE^00<0000002LeKP0W=Fh03`0W=Fh00`0000009cE^02LeKP0?02LeKP<000004P0^
@8<00`000000;T2302i0P`0C02i0P`030000000^@8<0;T2301<0;T2300<0000002i0P`0^@8<04`0^
@8<00`000000;T2302i0P`0C02i0P`80000000<0mT@K0000003fA1/02@3fA1/00`000000mT@K0?I4
6`0;0?I46`030000003fA1/0mT@K00/0mT@K00<000000?I46`3fA1/0103fA1/2000000<0fCXG00<0
00000=Tj5`3I>QL01`3I>QL00`000000fCXG0=Tj5`080=Tj5`030000003I>QL0fCXG00L0fCXG00<0
00000=Tj5`3I>QL0103I>QL00`000000Y2X@000000050:@Z40030000002T:Q00Y2X@00@0Y2X@00<0
00000:@Z402T:Q000`2T:Q000`000000Y2X@0000000206TH2@030000000oG;L0?ebg00d0?ebg00<0
000003mL]`0oG;L04`0oG;L00`000000oooo0?ooo`0D0?ooo`030000003oool0oooo00l0oooo000@
0?ooo`030000003oool0oooo01H0oooo00<000000?m<7`3oC1l0403oC1l00`0L94`0000001`TC00<
01`TC0030000000L94`072A<00`072A<1@00000;02LeKP030000000W=Fh09cE^00d09cE^00<00000
02LeKP0W=Fh03P0W=Fh00`0000009cE^02LeKP0@02LeKP030000000W=Fh09cE^00l09cE^00<00000
02LeKP0W=Fh02`0W=Fh40000000302i0P`000000;T230180;T2300<0000002i0P`0^@8<04`0^@8<0
0`000000;T2302i0P`0B02i0P`030000000^@8<0;T2301@0;T2300<0000002i0P`0^@8<04`0^@8<2
000000030?I46`000000mT@K00T0mT@K00<000000?I46`3fA1/0303fA1/00`000000mT@K0?I46`0:
0?I46`030000003fA1/0mT@K00H0mT@K0P0000000`3I>QL000000=Tj5`090=Tj5`030000003I>QL0
fCXG00L0fCXG00<000000=Tj5`3I>QL0203I>QL00`000000fCXG0=Tj5`040=Tj5`8000001P2T:Q00
0`000000Y2X@0:@Z40040:@Z40030000002T:Q00Y2X@00<0Y2X@00L000000:@Z40000000000006TH
2@000000JAP900h0?ebg00<0000003mL]`0oG;L04P0oG;L00`000000oooo0?ooo`0D0?ooo`030000
003oool0oooo00l0oooo000@0?ooo`030000003oool0oooo01D0oooo00<000000?m<7`3oC1l0403o
C1l00`0L94`0000001`TC00<01`TC0030000000L94`072A<00/072A<0`00000>02LeKP030000000W
=Fh09cE^00h09cE^00<0000002LeKP0W=Fh03P0W=Fh00`0000009cE^02LeKP0?02LeKP030000000W
=Fh09cE^01009cE^00<0000002LeKP0W=Fh01`0W=Fh4000000D0;T2300<0000002i0P`0^@8<04@0^
@8<00`000000;T2302i0P`0C02i0P`030000000^@8<0;T230180;T2300<0000002i0P`0^@8<0500^
@8<00`000000;T2302i0P`0C02i0P`80000000<0mT@K0000003fA1/02P3fA1/00`000000mT@K0?I4
6`0;0?I46`030000003fA1/0mT@K00X0mT@K00<000000?I46`3fA1/0203fA1/3000000T0fCXG00<0
00000=Tj5`3I>QL01`3I>QL00`000000fCXG0=Tj5`080=Tj5`030000003I>QL0fCXG00H0fCXG00<0
00000:@Z402T:Q00102T:Q000`000000Y2X@0:@Z40030:@Z40030000002T:Q00Y2X@00@0Y2X@00<0
00000:@Z402T:Q000`0000000`1Y60T0?ebg03mL]`0;03mL]`030000000oG;L0?ebg01<0?ebg00<0
00000?ooo`3oool04`3oool00`000000oooo0?ooo`0?0?ooo`00403oool00`000000oooo0?ooo`0E
0?ooo`030000003oC1l0od`O00l0od`O0P0L94`00`00000072A<01`TC00:01`TC0030000000L94`0
72A<00P072A<100000000`0W=Fh0000002LeKP0>02LeKP030000000W=Fh09cE^00h09cE^00<00000
02LeKP0W=Fh03P0W=Fh00`0000009cE^02LeKP0?02LeKP030000000W=Fh09cE^01009cE^00<00000
02LeKP0W=Fh00`0W=Fh4000000T0;T2300<0000002i0P`0^@8<04@0^@8<00`000000;T2302i0P`0C
02i0P`030000000^@8<0;T230180;T2300<0000002i0P`0^@8<0500^@8<00`000000;T2302i0P`0D
02i0P`030000003fA1/0000000/0mT@K00<000000?I46`3fA1/02`3fA1/00`000000mT@K0?I46`0:
0?I46`030000003fA1/0mT@K00X0mT@K00<000000=Tj5`3I>QL0203I>QL00`000000fCXG0=Tj5`07
0=Tj5`030000003I>QL0fCXG00L0fCXG00<000000=Tj5`3I>QL01P3I>QL3000000@0Y2X@00<00000
0:@Z402T:Q00102T:Q000`000000Y2X@0:@Z40030:@Z40030000002T:Q00Y2X@0080Y2X@0P000000
0`1Y60T0?ebg03mL]`0:03mL]`030000000oG;L0?ebg0140?ebg0`00000E0?ooo`030000003oool0
oooo00l0oooo000?0?ooo`030000003oool0oooo01H0oooo00<000000?m<7`3oC1l03P3oC1l201`T
C0030000000L94`072A<00/072A<00<0000001`TC00L94`01@0L94`3000000@09cE^00<0000002Le
KP0W=Fh03P0W=Fh00`0000009cE^02LeKP0=02LeKP030000000W=Fh09cE^00l09cE^00<0000002Le
KP0W=Fh03`0W=Fh00`0000009cE^02LeKP0?02LeKP030000000W=Fh09cE^00@000003@0^@8<00`00
0000;T2302i0P`0A02i0P`030000000^@8<0;T2301<0;T2300<0000002i0P`0^@8<04P0^@8<00`00
0000;T2302i0P`0C02i0P`030000000^@8<0;T2301D0;T2300<000000?I46`0000002`3fA1/00`00
0000mT@K0?I46`0;0?I46`030000003fA1/0mT@K00X0mT@K00<000000?I46`3fA1/02P3fA1/30000
00P0fCXG00<000000=Tj5`3I>QL01`3I>QL00`000000fCXG0=Tj5`080=Tj5`030000003I>QL0fCXG
00H0fCXG00<000000=Tj5`000000102T:Q000`000000Y2X@0:@Z40040:@Z40030000002T:Q00Y2X@
00<0Y2X@00<000000:@Z402T:Q000P2T:Q020000000306TH2@0oG;L0?ebg00X0?ebg00<0000003mL
]`0oG;L02`0oG;L500000080?5N_00<000000?ooo`3oool04`3oool00`000000oooo0?ooo`0?0?oo
o`003`3oool00`000000oooo0?ooo`0E0?ooo`030000003oC1l0od`O00h0od`O0P0L94`00`000000
72A<01`TC00;01`TC0030000000L94`072A<008072A<1000000702LeKP030000000W=Fh09cE^00h0
9cE^00<0000002LeKP0W=Fh03@0W=Fh00`0000009cE^02LeKP0>02LeKP030000000W=Fh09cE^0100
9cE^00<0000002LeKP0W=Fh03P0W=Fh400000140;T2300<0000002i0P`0^@8<04@0^@8<00`000000
;T2302i0P`0C02i0P`030000000^@8<0;T230180;T2300<0000002i0P`0^@8<04`0^@8<00`000000
;T2302i0P`0E02i0P`030000003fA1/0000000/0mT@K00<000000?I46`3fA1/02`3fA1/00`000000
mT@K0?I46`0:0?I46`030000003fA1/0mT@K00X0mT@K00<000000?I46`3fA1/00P0000060=Tj5`03
0000003I>QL0fCXG00P0fCXG00<000000=Tj5`3I>QL01`3I>QL00`000000fCXG0=Tj5`060=Tj5`03
0000003I>QL0fCXG008000000P2T:Q000`000000Y2X@0:@Z40040:@Z40030000002T:Q00Y2X@00@0
Y2X@00<000000:@Z402T:Q000`2T:Q000`000000JAP906TH2@0:03mL]`030000000oG;L0?ebg00H0
?ebg1@00000803aG[`030000003oool0oooo0180oooo00<000000?ooo`3oool03`3oool000l0oooo
00<000000?ooo`3oool05@3oool00`000000od`O0?m<7`0=0?m<7`<072A<00<0000001`TC00L94`0
2`0L94`5000000/09cE^00<0000002LeKP0W=Fh03@0W=Fh00`0000009cE^02LeKP0>02LeKP030000
000W=Fh09cE^00h09cE^00<0000002LeKP0W=Fh03`0W=Fh00`0000009cE^02LeKP0<02LeKP<00000
00<0;T230000000^@8<04@0^@8<00`000000;T2302i0P`0B02i0P`030000000^@8<0;T230180;T23
00<0000002i0P`0^@8<04`0^@8<00`000000;T2302i0P`0C02i0P`030000000^@8<0;T2301D0;T23
00<000000?I46`0000002`3fA1/00`000000mT@K0?I46`0;0?I46`030000003fA1/0mT@K00/0mT@K
00<000000?I46`3fA1/02@3fA1/00`000000mT@K0?I46`020?I46`8000001@3I>QL00`000000fCXG
0=Tj5`070=Tj5`030000003I>QL0fCXG00L0fCXG00<000000=Tj5`3I>QL01`3I>QL010000000fCXG
0=Tj5`3I>QL2000000030:@Z40000000Y2X@00D0Y2X@00<000000:@Z402T:Q000`2T:Q000`000000
Y2X@0:@Z40040:@Z4080000000<0JAP903mL]`0oG;L0200oG;L00`000000?ebg03mL]`05000000d0
?5N_00<000000?ooo`3oool04`3oool00`000000oooo0?ooo`0>0?ooo`003`3oool00`000000oooo
0?ooo`0D0?ooo`030000003oC1l0od`O00d0od`O0`0L94`00`00000072A<01`TC00:01`TC0<00000
3P0W=Fh00`0000009cE^02LeKP0>02LeKP030000000W=Fh09cE^00d09cE^00<0000002LeKP0W=Fh0
3`0W=Fh00`0000009cE^02LeKP0?02LeKP030000000W=Fh09cE^00P09cE^1000000402i0P`030000
000^@8<0;T230100;T2300<0000002i0P`0^@8<04P0^@8<00`000000;T2302i0P`0B02i0P`030000
000^@8<0;T2301<0;T2300<0000002i0P`0^@8<04`0^@8<00`000000;T2302i0P`0D02i0P`800000
00<0mT@K0000003fA1/02P3fA1/00`000000mT@K0?I46`0;0?I46`030000003fA1/0mT@K00/0mT@K
00<000000?I46`3fA1/02@3fA1/00`000000mT@K0?I46`040?I46`8000000`3I>QL00`000000fCXG
0=Tj5`070=Tj5`030000003I>QL0fCXG00P0fCXG00<000000=Tj5`3I>QL01P3I>QL00`000000fCXG
0=Tj5`030=Tj5`030000002T:Q00000000H0Y2X@00<000000:@Z402T:Q000`2T:Q000`000000Y2X@
0:@Z40030:@Z40040000002T:Q000000000000P0?ebg1000000B03aG[`030000003oool0oooo01<0
oooo00<000000?ooo`3oool03P3oool000l0oooo00<000000?ooo`3oool0503oool00`000000od`O
0?m<7`0<0?m<7`<072A<00<0000001`TC00L94`01`0L94`40000000302LeKP0000009cE^00h09cE^
00<0000002LeKP0W=Fh03P0W=Fh00`0000009cE^02LeKP0=02LeKP030000000W=Fh09cE^00h09cE^
00<0000002LeKP0W=Fh0400W=Fh00`0000009cE^02LeKP0502LeKP<00000200^@8<00`000000;T23
02i0P`0@02i0P`030000000^@8<0;T230180;T2300<0000002i0P`0^@8<04P0^@8<00`000000;T23
02i0P`0C02i0P`030000000^@8<0;T2301<0;T2300<0000002i0P`0^@8<0400^@8<40000000403=8
T`0000000000000000/0mT@K00<000000?I46`3fA1/02`3fA1/00`000000mT@K0?I46`0;0?I46`03
0000003fA1/0mT@K00X0mT@K00<000000?I46`3fA1/01@3fA1/2000000030=Tj5`000000fCXG00T0
fCXG00<000000=Tj5`3I>QL01`3I>QL00`000000fCXG0=Tj5`060=Tj5`030000003I>QL0fCXG00@0
fCXG0P0000060:@Z40030000002T:Q00Y2X@00@0Y2X@00<000000:@Z402T:Q000`2T:Q000`000000
Y2X@0:@Z400200000080?ebg100000000`0lEjl0000003aG[`0C03aG[`030000003oool0oooo01<0
oooo00<000000?ooo`3oool03P3oool000l0oooo00<000000?ooo`3oool04`3oool00`000000od`O
0?m<7`0<0?m<7`@072A<00<0000001`TC00L94`0100L94`3000000@09cE^00<0000002LeKP0W=Fh0
3P0W=Fh00`0000009cE^02LeKP0=02LeKP030000000W=Fh09cE^00h09cE^00<0000002LeKP0W=Fh0
3P0W=Fh00`0000009cE^02LeKP0@02LeKP030000000W=Fh09cE^00809cE^0`00000;02i0P`030000
000^@8<0;T230100;T2300<0000002i0P`0^@8<04P0^@8<00`000000;T2302i0P`0B02i0P`030000
000^@8<0;T2301<0;T2300<0000002i0P`0^@8<04`0^@8<00`000000;T2302i0P`0<02i0P`@00000
1@0cB9<00`000000odXN00000002000000T0mT@K00<000000?I46`3fA1/02`3fA1/00`000000mT@K
0?I46`0;0?I46`030000003fA1/0mT@K00X0mT@K00<000000?I46`3fA1/01`3fA1/3000000T0fCXG
00<000000=Tj5`3I>QL01`3I>QL00`000000fCXG0=Tj5`070=Tj5`030000003I>QL0fCXG00D0fCXG
00<000000:@Z402T:Q00102T:Q000`000000Y2X@0:@Z40030:@Z40030000002T:Q00Y2X@00@0Y2X@
00@000000:@Z402T:Q00Y2X@0P00000503aG[`030000000lEjl0?5N_01<0?5N_00<000000?ooo`3o
ool04P3oool00`000000oooo0?ooo`0>0?ooo`003`3oool00`000000oooo0?ooo`0C0?ooo`800000
303oC1l401`TC0030000000L94`072A<008072A<0`00000702LeKP030000000W=Fh09cE^00d09cE^
00<0000002LeKP0W=Fh03P0W=Fh00`0000009cE^02LeKP0=02LeKP030000000W=Fh09cE^00l09cE^
00<0000002LeKP0W=Fh03`0W=Fh00`0000009cE^00000003000000d0;T2300<0000002i0P`0^@8<0
4@0^@8<00`000000;T2302i0P`0B02i0P`030000000^@8<0;T230180;T2300<0000002i0P`0^@8<0
4`0^@8<00`000000;T2302i0P`0C02i0P`030000000^@8<0;T2300P0;T231000000903=8T`030000
003oBQh000000080odXN0P0000070?I46`030000003fA1/0mT@K00`0mT@K00<000000?I46`3fA1/0
2P3fA1/00`000000mT@K0?I46`0:0?I46`030000003fA1/0mT@K00T0mT@K00<000000=Tj5`3I>QL0
1`3I>QL00`000000fCXG0=Tj5`080=Tj5`030000003I>QL0fCXG00H0fCXG00<000000=Tj5`3I>QL0
1@3I>QL3000000D0Y2X@00<000000:@Z402T:Q000`2T:Q000`000000Y2X@0:@Z40030:@Z40030000
002T:Q00Y2X@0080Y2X@1`0lEjl00`000000?5N_03aG[`0B03aG[`030000003oool0oooo0180oooo
00<000000?ooo`3oool03P3oool000l0oooo00<000000?ooo`3oool04`3oool20?m:7P8000002@3o
C1l501`TC0D000002P0W=Fh00`0000009cE^02LeKP0=02LeKP030000000W=Fh09cE^00h09cE^00<0
000002LeKP0W=Fh03@0W=Fh00`0000009cE^02LeKP0>02LeKP030000000W=Fh09cE^00l09cE^0`00
000A02i0P`030000000^@8<0;T230140;T2300<0000002i0P`0^@8<04P0^@8<00`000000;T2302i0
P`0B02i0P`030000000^@8<0;T2301<0;T2300<0000002i0P`0^@8<04`0^@8<00`000000;T2302i0
P`0402i0P`@000003@0cB9<00`000000odXN000000040?m:7P8000001P3fA1/00`000000mT@K0?I4
6`0;0?I46`030000003fA1/0mT@K00X0mT@K00<000000?I46`3fA1/02P3fA1/00`000000mT@K0?I4
6`090?I46`<00000203I>QL00`000000fCXG0=Tj5`070=Tj5`030000003I>QL0fCXG00H0fCXG00<0
00000=Tj5`3I>QL01P3I>QL010000000fCXG0000000000030:@Z40030000002T:Q00Y2X@00@0Y2X@
00<000000:@Z402T:Q000`2T:Q000`000000Y2X@0:@Z40020:@Z40H0?5N_00<0000003aG[`0lEjl0
4P0lEjl00`000000oooo0?ooo`0B0?ooo`030000003oool0oooo00h0oooo000?0?ooo`030000003o
ool0oooo0180oooo00<000000?m:7P3oBQh00P3oBQh3000000D0od`O100L94`3000000d09cE^00<0
000002LeKP0W=Fh03P0W=Fh00`0000009cE^02LeKP0=02LeKP030000000W=Fh09cE^00h09cE^00<0
000002LeKP0W=Fh03P0W=Fh00`0000009cE^02LeKP0;02LeKP@0000000<0;T230000000^@8<04@0^
@8<00`000000;T2302i0P`0A02i0P`030000000^@8<0;T230140;T2300<0000002i0P`0^@8<04`0^
@8<00`000000;T2302i0P`0C02i0P`030000000^@8<0;T2301<0;T2300<0000002i0P`0^@8<01000
000A03=8T`030000003oBQh0000000H0odXN0P0000040?I46`030000003fA1/0mT@K00/0mT@K00<0
00000?I46`3fA1/02P3fA1/00`000000mT@K0?I46`0:0?I46`030000003fA1/0mT@K00T0mT@K00<0
00000?I46`3fA1/00P0000060=Tj5`030000003I>QL0fCXG00P0fCXG00<000000=Tj5`3I>QL01P3I
>QL00`000000fCXG0=Tj5`050=Tj5`040000003I>QL0fCXG0=Tj5`8000000P2T:Q000`000000Y2X@
0:@Z40030:@Z40030000002T:Q00Y2X@00@0Y2X@00<000000:@Z402T:Q000P2T:Q0503aG[`030000
000lEjl0?5N_01<0?5N_00<000000?ooo`3oool04@3oool00`000000oooo0?ooo`0>0?ooo`003`3o
ool00`000000oooo0?ooo`0B0?ooo`030000003oBQh0odXN00D0odXN0P0000020?m<7`0301`TC000
000000000080000000<09cE^0000000W=Fh03@0W=Fh00`0000009cE^02LeKP0=02LeKP030000000W
=Fh09cE^00h09cE^00<0000002LeKP0W=Fh03@0W=Fh00`0000009cE^02LeKP0?02LeKP030000000W
=Fh09cE^00L09cE^1000000502i0P`030000000^@8<0;T230100;T2300<0000002i0P`0^@8<04@0^
@8<00`000000;T2302i0P`0A02i0P`030000000^@8<0;T2301<0;T2300<0000002i0P`0^@8<04P0^
@8<00`000000;T2302i0P`0C02i0P`@000005@0cB9<00`000000odXN000000080?m:7P8000000P3f
A1/00`000000mT@K0?I46`0;0?I46`030000003fA1/0mT@K00X0mT@K00<000000?I46`3fA1/02P3f
A1/00`000000mT@K0?I46`090?I46`030000003fA1/0mT@K0080mT@K0P0000050=Tj5`030000003I
>QL0fCXG00L0fCXG00<000000=Tj5`3I>QL01P3I>QL00`000000fCXG0=Tj5`060=Tj5`030000003I
>QL0fCXG0080fCXG0P0000000`2T:Q0000000:@Z40040:@Z40030000002T:Q00Y2X@00@0Y2X@00<0
00000:@Z402T:Q000P2T:Q0403aG[`030000000lEjl0?5N_01<0?5N_00<000000?ooo`3oool04@3o
ool00`000000oooo0?ooo`0>0?ooo`003`3oool00`000000oooo0?ooo`0B0?ooo`030000003oBQh0
odXN00L0odXN0`00000402LeKP030000000W=Fh09cE^00d09cE^00<0000002LeKP0W=Fh03@0W=Fh0
0`0000009cE^02LeKP0>02LeKP030000000W=Fh09cE^00d09cE^00<0000002LeKP0W=Fh03`0W=Fh0
0`0000009cE^02LeKP0302LeKP@000002@0^@8<00`000000;T2302i0P`0@02i0P`030000000^@8<0
;T230140;T2300<0000002i0P`0^@8<04@0^@8<00`000000;T2302i0P`0C02i0P`030000000^@8<0
;T230180;T2300<0000002i0P`0^@8<03`0^@8<40000000303=8T`000000<dRC01D0<dRC0P000002
0?m:7P030000003oBQh0odXN00L0odXN0`00000=0?I46`030000003fA1/0mT@K00/0mT@K00<00000
0?I46`3fA1/02@3fA1/00`000000mT@K0?I46`0:0?I46`030000003fA1/0mT@K00<0mT@K0P000003
0=Tj5`030000003I>QL0fCXG00L0fCXG00<000000=Tj5`3I>QL01`3I>QL00`000000fCXG0=Tj5`05
0=Tj5`030000003I>QL0fCXG00@0fCXG0P0000060:@Z40030000002T:Q00Y2X@00<0Y2X@00<00000
0:@Z402T:Q000`2T:Q0303aG[`800000500lEjl00`000000oooo0?ooo`0A0?ooo`030000003oool0
oooo00h0oooo000?0?ooo`030000003oool0oooo0180oooo00<000000?m:7P3oBQh0203oBQh602Le
KP030000000W=Fh09cE^00`09cE^00<0000002LeKP0W=Fh03P0W=Fh00`0000009cE^02LeKP0=02Le
KP030000000W=Fh09cE^00h09cE^00<0000002LeKP0W=Fh03P0W=Fh00`0000009cE^02LeKP040000
00d0;T2300<0000002i0P`0^@8<0400^@8<00`000000;T2302i0P`0A02i0P`030000000^@8<0;T23
0140;T2300<0000002i0P`0^@8<04`0^@8<00`000000;T2302i0P`0B02i0P`030000000^@8<0;T23
00/0;T231000000503=8T`030000000cB9<0<dRC01@0<dRC00D0000003=8T`000000odXN0000000;
0?m:7P030000003fA1/0mT@K00/0mT@K00<000000?I46`3fA1/02`3fA1/00`000000mT@K0?I46`09
0?I46`030000003fA1/0mT@K00X0mT@K00<000000?I46`3fA1/01@3fA1/2000000030=Tj5`000000
fCXG00T0fCXG00<000000=Tj5`3I>QL01P3I>QL00`000000fCXG0=Tj5`050=Tj5`030000003I>QL0
fCXG00H0fCXG00<000000:@Z402T:Q000`2T:Q000`000000Y2X@0:@Z40040:@Z40030000002T:Q00
Y2X@00<0Y2X@0`0lEjl00`000000?5N_03aG[`0B03aG[`030000003oool0oooo0140oooo00<00000
0?ooo`3oool03P3oool000l0oooo00<000000?ooo`3oool04@3oool00`000000odXN0?m:7P080?m:
7PL09cE^00<0000002LeKP0W=Fh0300W=Fh00`0000009cE^02LeKP0=02LeKP030000000W=Fh09cE^
00h09cE^00<0000002LeKP0W=Fh03P0W=Fh00`0000009cE^02LeKP0=02LeKP@00000400^@8<00`00
0000;T2302i0P`0A02i0P`030000000^@8<0;T230140;T2300<0000002i0P`0^@8<04@0^@8<00`00
0000;T2302i0P`0C02i0P`030000000^@8<0;T230180;T2300<0000002i0P`0^@8<01`0^@8<40000
00T0<dRC00<0000003=8T`0cB9<0500cB9<01@000000<dRC0000003oBQh0000000/0odXN0`00000;
0?I46`030000003fA1/0mT@K00/0mT@K00<000000?I46`3fA1/02@3fA1/00`000000mT@K0?I46`0:
0?I46`030000003fA1/0mT@K00L0mT@K0`0000090=Tj5`030000003I>QL0fCXG00H0fCXG00<00000
0=Tj5`3I>QL01P3I>QL00`000000fCXG0=Tj5`050=Tj5`<00000102T:Q000`000000Y2X@0:@Z4004
0:@Z40030000002T:Q00Y2X@0080Y2X@0`0lEjl00`000000?5N_03aG[`0C03aG[`030000003oool0
oooo0100oooo00<000000?ooo`3oool03P3oool000l0oooo00<000000?ooo`3oool04@3oool00`00
0000odXN0?m:7P080?m:7PH09cE^00<0000002LeKP0W=Fh03@0W=Fh00`0000009cE^02LeKP0=02Le
KP030000000W=Fh09cE^00h09cE^00<0000002LeKP0W=Fh03@0W=Fh00`0000009cE^02LeKP0:02Le
KP@0000000<0;T230000000^@8<04@0^@8<00`000000;T2302i0P`0A02i0P`030000000^@8<0;T23
0140;T2300<0000002i0P`0^@8<04@0^@8<00`000000;T2302i0P`0C02i0P`030000000^@8<0;T23
0180;T2300<0000002i0P`0^@8<00`0^@8<4000000d0<dRC00<0000003=8T`0cB9<0500cB9<01@00
0000<dRC0000003oBQh0000000/0odXN00<000000?m:7P3oBQh00P0000090?I46`030000003fA1/0
mT@K00/0mT@K00<000000?I46`3fA1/02P3fA1/00`000000mT@K0?I46`090?I46`030000003fA1/0
mT@K00T0mT@K00<000000=Tj5`3I>QL01`3I>QL00`000000fCXG0=Tj5`070=Tj5`030000003I>QL0
fCXG00D0fCXG00<000000=Tj5`3I>QL01P3I>QL00`000000fCXG000000040:@Z40030000002T:Q00
Y2X@00<0Y2X@00<000000:@Z402T:Q000`2T:Q0203aG[`030000000lEjl0?5N_01<0?5N_00<00000
0?ooo`3oool0403oool00`000000oooo0?ooo`0>0?ooo`003`3oool00`000000oooo0?ooo`0A0?oo
o`030000003oBQh0odXN00L0odXN1`0W=Fh00`0000009cE^02LeKP0<02LeKP030000000W=Fh09cE^
00d09cE^00<0000002LeKP0W=Fh03P0W=Fh00`0000009cE^02LeKP0>02LeKP030000000W=Fh09cE^
00H09cE^1000000502i0P`030000000^@8<0;T230100;T2300<0000002i0P`0^@8<04@0^@8<00`00
0000;T2302i0P`0@02i0P`030000000^@8<0;T230180;T2300<0000002i0P`0^@8<04P0^@8<00`00
0000;T2302i0P`0C02i0P`030000000^@8<0000000<000004@0cB9<00`000000<dRC03=8T`0D03=8
T`050000000cB9<000000?m:7P0000002`3oBQh00`000000odXN0?m:7P020?m:7P8000001`3fA1/0
0`000000mT@K0?I46`0;0?I46`030000003fA1/0mT@K00X0mT@K00<000000?I46`3fA1/02@3fA1/0
0`000000mT@K0?I46`090?I46`<00000203I>QL00`000000fCXG0=Tj5`060=Tj5`030000003I>QL0
fCXG00D0fCXG00<000000=Tj5`3I>QL01P3I>QL00`000000fCXG0=Tj5`0200000080Y2X@00<00000
0:@Z402T:Q00102T:Q000`000000Y2X@0:@Z40030:@Z400303aG[`000000000001@0?5N_00<00000
0?ooo`3oool0403oool00`000000oooo0?ooo`0>0?ooo`003`3oool00`000000oooo0?ooo`0A0?oo
o`030000003oBQh0odXN00L0odXN1`0W=Fh00`0000009cE^02LeKP0<02LeKP030000000W=Fh09cE^
00d09cE^00<0000002LeKP0W=Fh03P0W=Fh00`0000009cE^02LeKP0>02LeKP030000000W=Fh09cE^
00809cE^1000000902i0P`030000000^@8<0;T230100;T2300<0000002i0P`0^@8<0400^@8<00`00
0000;T2302i0P`0A02i0P`030000000^@8<0;T230180;T2300<0000002i0P`0^@8<04P0^@8<00`00
0000;T2302i0P`0A02i0P`@000005@0cB9<00`000000<dRC03=8T`0D03=8T`050000000cB9<00000
0?m:7P0000002`3oBQh00`000000odXN0?m:7P040?m:7P8000001P3fA1/00`000000mT@K0?I46`0:
0?I46`030000003fA1/0mT@K00X0mT@K00<000000?I46`3fA1/02@3fA1/00`000000mT@K0?I46`09
0?I46`030000003fA1/0mT@K008000001P3I>QL00`000000fCXG0=Tj5`060=Tj5`030000003I>QL0
fCXG00H0fCXG00<000000=Tj5`3I>QL01P3I>QL010000000fCXG0=Tj5`3I>QL2000000030:@Z4000
0000Y2X@00D0Y2X@00<000000:@Z402T:Q000`2T:Q000`0lEjl0000003aG[`0D03aG[`030000003o
ool0oooo00l0oooo00<000000?ooo`3oool03P3oool000h0oooo00<000000?ooo`3oool04@3oool0
0`000000odXN0?m:7P070?m:7PL09cE^00<0000002LeKP0W=Fh03@0W=Fh00`0000009cE^02LeKP0=
02LeKP030000000W=Fh09cE^00h09cE^00<0000002LeKP0W=Fh03@0W=Fh00`0000009cE^00000003
000000d0;T2300<0000002i0P`0^@8<0400^@8<00`000000;T2302i0P`0@02i0P`030000000^@8<0
;T230140;T2300<0000002i0P`0^@8<04P0^@8<00`000000;T2302i0P`0B02i0P`030000000^@8<0
;T2300d0;T231000000203=8T`030000000cB9<0<dRC01D0<dRC00<0000003=8T`0cB9<04`0cB9<0
1@000000<dRC0000003oBQh0000000/0odXN00<000000?m:7P3oBQh01P3oBQh2000000@0mT@K00<0
00000?I46`3fA1/02P3fA1/00`000000mT@K0?I46`0:0?I46`030000003fA1/0mT@K00T0mT@K00<0
00000?I46`3fA1/02@3fA1/00`000000mT@K0?I46`020?I46`8000001@3I>QL00`000000fCXG0=Tj
5`060=Tj5`030000003I>QL0fCXG00D0fCXG00<000000=Tj5`3I>QL01P3I>QL00`000000fCXG0=Tj
5`030=Tj5`030000002T:Q00000000D0Y2X@00<000000:@Z402T:Q00102T:Q000`000000?5N_03aG
[`0C03aG[`030000003oool0oooo00l0oooo00<000000?ooo`3oool03P3oool000h0oooo00<00000
0?ooo`3oool04@3oool00`000000odXN0?m:7P060?m:7PP09cE^00<0000002LeKP0W=Fh0300W=Fh0
0`0000009cE^02LeKP0=02LeKP030000000W=Fh09cE^00l09cE^00<0000002LeKP0W=Fh0300W=Fh3
00000100;T2300<0000002i0P`0^@8<04@0^@8<00`000000;T2302i0P`0@02i0P`030000000^@8<0
;T230140;T2300<0000002i0P`0^@8<04P0^@8<00`000000;T2302i0P`0B02i0P`030000000^@8<0
;T2300T0;T231000000603=8T`030000000cB9<0<dRC01D0<dRC00<0000003=8T`0cB9<04`0cB9<0
1@000000<dRC0000003oBQh0000000/0odXN00<000000?m:7P3oBQh0203oBQh200000080mT@K00<0
00000?I46`3fA1/02`3fA1/00`000000mT@K0?I46`090?I46`030000003fA1/0mT@K00X0mT@K00<0
00000?I46`3fA1/02@3fA1/00`000000mT@K0?I46`030?I46`8000000`3I>QL00`000000fCXG0=Tj
5`060=Tj5`030000003I>QL0fCXG00H0fCXG00<000000=Tj5`3I>QL01@3I>QL00`000000fCXG0=Tj
5`040=Tj5`8000001P2T:Q000`000000Y2X@0:@Z40040:@Z40030000000lEjl0?5N_0180?5N_00<0
00000?ooo`3oool03`3oool00`000000oooo0?ooo`0>0?ooo`003P3oool00`000000oooo0?ooo`0A
0?ooo`030000003oBQh0odXN00H0odXN200W=Fh00`0000009cE^02LeKP0<02LeKP030000000W=Fh0
9cE^00d09cE^00<0000002LeKP0W=Fh03P0W=Fh00`0000009cE^02LeKP0902LeKP@0000000<0;T23
0000000^@8<0400^@8<00`000000;T2302i0P`0A02i0P`030000000^@8<0;T230100;T2300<00000
02i0P`0^@8<04@0^@8<00`000000;T2302i0P`0B02i0P`030000000^@8<0;T230180;T2300<00000
02i0P`0^@8<0100^@8<5000000X0<dRC00<0000003=8T`0cB9<05@0cB9<00`000000<dRC03=8T`0C
03=8T`050000000cB9<000000?m:7P0000002P3oBQh00`000000odXN0?m:7P0;0?m:7P<000003@3f
A1/00`000000mT@K0?I46`090?I46`030000003fA1/0mT@K00X0mT@K00<000000?I46`3fA1/02@3f
A1/00`000000mT@K0?I46`050?I46`80000000<0fCXG0000003I>QL0203I>QL00`000000fCXG0=Tj
5`050=Tj5`030000003I>QL0fCXG00H0fCXG00<000000=Tj5`3I>QL01@3I>QL00`000000Y2X@0:@Z
40040:@Z40030000002T:Q00Y2X@00<0Y2X@00<0000003aG[`0lEjl04`0lEjl00`000000oooo0?oo
o`0>0?ooo`030000003oool0oooo00h0oooo000>0?ooo`030000003oool0oooo0100oooo00<00000
0?m:7P3oBQh01P3oBQh802LeKP030000000W=Fh09cE^00d09cE^00<0000002LeKP0W=Fh03@0W=Fh0
0`0000009cE^02LeKP0>02LeKP030000000W=Fh09cE^00H09cE^0`00000502i0P`030000000^@8<0
;T2300l0;T2300<0000002i0P`0^@8<04@0^@8<00`000000;T2302i0P`0@02i0P`030000000^@8<0
;T230140;T2300<0000002i0P`0^@8<04P0^@8<00`000000;T2302i0P`0B02i0P`030000000^@8<0
;T2300@000003`0cB9<00`000000<dRC03=8T`0E03=8T`030000000cB9<0<dRC01<0<dRC00D00000
03=8T`000000odXN0000000:0?m:7P030000003oBQh0odXN00d0odXN00<000000?I46`3fA1/02`3f
A1/00`000000mT@K0?I46`090?I46`030000003fA1/0mT@K00X0mT@K00<000000?I46`3fA1/02@3f
A1/00`000000mT@K0?I46`070?I46`<00000203I>QL00`000000fCXG0=Tj5`050=Tj5`030000003I
>QL0fCXG00H0fCXG00<000000=Tj5`3I>QL01@3I>QL3000000D0Y2X@00<000000:@Z402T:Q000`2T
:Q000`000000?5N_03aG[`0B03aG[`030000003oool0oooo00l0oooo00<000000?ooo`3oool03@3o
ool000h0oooo00<000000?ooo`3oool0403oool00`000000odXN0?m:7P060?m:7PP09cE^00<00000
02LeKP0W=Fh03@0W=Fh00`0000009cE^02LeKP0<02LeKP030000000W=Fh09cE^00l09cE^00<00000
02LeKP0W=Fh00P0W=Fh4000000P0;T2300<0000002i0P`0^@8<03`0^@8<00`000000;T2302i0P`0@
02i0P`030000000^@8<0;T230140;T2300<0000002i0P`0^@8<04@0^@8<00`000000;T2302i0P`0A
02i0P`030000000^@8<0;T230180;T231000000C03=8T`030000000cB9<0<dRC01D0<dRC00<00000
03=8T`0cB9<04`0cB9<01@000000<dRC0000003oBQh0000000X0odXN00<000000?m:7P3oBQh03@3o
BQh3000000/0mT@K00<000000?I46`3fA1/02@3fA1/00`000000mT@K0?I46`0:0?I46`030000003f
A1/0mT@K00T0mT@K00<000000?I46`3fA1/02@3fA1/00`000000fCXG0=Tj5`060=Tj5`030000003I
>QL0fCXG00H0fCXG00<000000=Tj5`3I>QL01@3I>QL00`000000fCXG0=Tj5`060=Tj5`040000003I
>QL00000000000<0Y2X@00<000000:@Z402T:Q000`2T:Q000`000000?5N_03aG[`0B03aG[`030000
003oool0oooo00l0oooo00<000000?ooo`3oool03@3oool000h0oooo00<000000?ooo`3oool0403o
ool00`000000odXN0?m:7P050?m:7PT09cE^00<0000002LeKP0W=Fh0300W=Fh00`0000009cE^02Le
KP0=02LeKP030000000W=Fh09cE^00h09cE^00<0000002LeKP0000000`00000<02i0P`030000000^
@8<0;T2300l0;T2300<0000002i0P`0^@8<0400^@8<00`000000;T2302i0P`0A02i0P`030000000^
@8<0;T230140;T2300<0000002i0P`0^@8<04@0^@8<00`000000;T2302i0P`0>02i0P`@0000000<0
<dRC0000000cB9<0500cB9<00`000000<dRC03=8T`0E03=8T`030000000cB9<0<dRC01<0<dRC00D0
000003=8T`000000odXN0000000:0?m:7P030000003oBQh0odXN00d0odXN00<000000?m:7P3oBQh0
0P0000090?I46`030000003fA1/0mT@K00X0mT@K00<000000?I46`3fA1/02@3fA1/00`000000mT@K
0?I46`090?I46`030000003fA1/0mT@K00T0mT@K0`0000070=Tj5`030000003I>QL0fCXG00D0fCXG
00<000000=Tj5`3I>QL01P3I>QL00`000000fCXG0=Tj5`050=Tj5`040000003I>QL0fCXG0=Tj5`80
00000P2T:Q000`000000Y2X@0:@Z40030:@Z40030000000lEjl0?5N_0140?5N_00<000000?ooo`3o
ool03`3oool00`000000oooo0?ooo`0=0?ooo`003P3oool00`000000oooo0?ooo`0@0?ooo`030000
003oBQh0odXN00D0odXN200W=Fh00`0000009cE^02LeKP0=02LeKP030000000W=Fh09cE^00d09cE^
00<0000002LeKP0W=Fh03@0W=Fh3000000l0;T2300<0000002i0P`0^@8<0400^@8<00`000000;T23
02i0P`0@02i0P`030000000^@8<0;T230140;T2300<0000002i0P`0^@8<04@0^@8<00`000000;T23
02i0P`0A02i0P`030000000^@8<0;T2300X0;T231000000503=8T`030000000cB9<0<dRC01@0<dRC
00<0000003=8T`0cB9<0500cB9<00`000000<dRC03=8T`0C03=8T`050000000cB9<000000?m:7P00
00002P3oBQh00`000000odXN0?m:7P0=0?m:7P030000003oBQh0odXN0080odXN0P0000070?I46`03
0000003fA1/0mT@K00X0mT@K00<000000?I46`3fA1/02@3fA1/00`000000mT@K0?I46`090?I46`03
0000003fA1/0mT@K00T0mT@K00<000000?I46`3fA1/00P0000050=Tj5`030000003I>QL0fCXG00D0
fCXG00<000000=Tj5`3I>QL01P3I>QL00`000000fCXG0=Tj5`060=Tj5`030000003I>QL0fCXG0080
fCXG0P0000000`2T:Q0000000:@Z40040:@Z40030000000lEjl0?5N_0140?5N_00<000000?ooo`3o
ool03P3oool00`000000oooo0?ooo`0=0?ooo`003P3oool00`000000oooo0?ooo`0?0?ooo`030000
003oBQh0odXN00D0odXN2@0W=Fh00`0000009cE^02LeKP0=02LeKP030000000W=Fh09cE^00`09cE^
00<0000002LeKP0W=Fh02P0W=Fh40000000302i0P`000000;T2300l0;T2300<0000002i0P`0^@8<0
400^@8<00`000000;T2302i0P`0@02i0P`030000000^@8<0;T230100;T2300<0000002i0P`0^@8<0
4P0^@8<00`000000;T2302i0P`0A02i0P`030000000^@8<0;T2300L0;T230`00000903=8T`030000
000cB9<0<dRC01@0<dRC00<0000003=8T`0cB9<0500cB9<00`000000<dRC03=8T`0C03=8T`050000
000cB9<000000?m:7P0000002P3oBQh00`000000odXN0?m:7P0=0?m:7P030000003oBQh0odXN00@0
odXN0P0000050?I46`030000003fA1/0mT@K00X0mT@K00<000000?I46`3fA1/02@3fA1/00`000000
mT@K0?I46`090?I46`030000003fA1/0mT@K00T0mT@K00<000000?I46`3fA1/00P3fA1/00`000000
fCXG0=Tj5`020=Tj5`030000003I>QL0fCXG00H0fCXG00<000000=Tj5`3I>QL01P3I>QL00`000000
fCXG0=Tj5`050=Tj5`030000003I>QL0fCXG00@0fCXG0P0000050:@Z40030000000lEjl0?5N_0140
?5N_00<000000?ooo`3oool03P3oool00`000000oooo0?ooo`0=0?ooo`003P3oool00`000000oooo
0?ooo`0?0?ooo`030000003oBQh0odXN00@0odXN2P0W=Fh00`0000009cE^02LeKP0<02LeKP030000
000W=Fh09cE^00d09cE^00<0000002LeKP0W=Fh01P0W=Fh4000000D0;T2300<0000002i0P`0^@8<0
3P0^@8<00`000000;T2302i0P`0@02i0P`030000000^@8<0;T230100;T2300<0000002i0P`0^@8<0
400^@8<00`000000;T2302i0P`0B02i0P`030000000^@8<0;T230140;T2300<0000002i0P`0^@8<0
0`0^@8<4000000`0<dRC00<0000003=8T`0cB9<0500cB9<00`000000<dRC03=8T`0D03=8T`030000
000cB9<0<dRC0180<dRC00H000000?m:7P0cB9<000000?m:7P00000:0?m:7P030000003oBQh0odXN
00d0odXN00<000000?m:7P3oBQh01P3oBQh2000000@0mT@K00<000000?I46`3fA1/02@3fA1/00`00
0000mT@K0?I46`0:0?I46`030000003fA1/0mT@K00T0mT@K00<000000?I46`3fA1/0203fA1/00`00
0000mT@K0?I46`030?I46`8000000`3I>QL00`000000fCXG0=Tj5`050=Tj5`030000003I>QL0fCXG
00H0fCXG00<000000=Tj5`3I>QL01@3I>QL00`000000fCXG0=Tj5`060=Tj5`030000002T:Q00Y2X@
00<0Y2X@00<0000003aG[`0lEjl0400lEjl00`000000oooo0?ooo`0>0?ooo`030000003oool0oooo
00d0oooo000>0?ooo`030000003oool0oooo00l0oooo00<000000?m:7P3oBQh0103oBQh:02LeKP03
0000000W=Fh09cE^00`09cE^00<0000002LeKP0W=Fh03@0W=Fh00`0000009cE^02LeKP0202LeKP@0
00002@0^@8<00`000000;T2302i0P`0>02i0P`030000000^@8<0;T2300l0;T2300<0000002i0P`0^
@8<04@0^@8<00`000000;T2302i0P`0@02i0P`030000000^@8<0;T230180;T2300<0000002i0P`0^
@8<04@0^@8<00`000000;T230000000300000100<dRC00<0000003=8T`0cB9<0500cB9<00`000000
<dRC03=8T`0D03=8T`030000000cB9<0<dRC0180<dRC00@000000?m:7P0cB9<0<dRC0P00000:0?m:
7P030000003oBQh0odXN00d0odXN00<000000?m:7P3oBQh0203oBQh200000080mT@K00<000000?I4
6`3fA1/02@3fA1/00`000000mT@K0?I46`0:0?I46`030000003fA1/0mT@K00T0mT@K00<000000?I4
6`3fA1/02@3fA1/00`000000mT@K0?I46`040?I46`80000000<0fCXG0000003I>QL01`3I>QL00`00
0000fCXG0=Tj5`050=Tj5`030000003I>QL0fCXG00H0fCXG00<000000=Tj5`3I>QL01@3I>QL30000
00@0Y2X@00<0000003aG[`0lEjl0400lEjl00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo
00d0oooo000>0?ooo`030000003oool0oooo00l0oooo00<000000?m:7P3oBQh00`3oBQh:02LeKP03
0000000W=Fh09cE^00d09cE^00<0000002LeKP0W=Fh0300W=Fh00`0000009cE^00000003000000`0
;T2300<0000002i0P`0^@8<03`0^@8<00`000000;T2302i0P`0?02i0P`030000000^@8<0;T230140
;T2300<0000002i0P`0^@8<0400^@8<00`000000;T2302i0P`0A02i0P`030000000^@8<0;T230100
;T231000000D03=8T`030000000cB9<0<dRC01@0<dRC00<0000003=8T`0cB9<0500cB9<00`000000
<dRC03=8T`0B03=8T`040000003oBQh0<dRC03=8T`8000002P3oBQh00`000000odXN0?m:7P0<0?m:
7P030000003oBQh0odXN00/0odXN0`00000;0?I46`030000003fA1/0mT@K00X0mT@K00<000000?I4
6`3fA1/02@3fA1/00`000000mT@K0?I46`090?I46`030000003fA1/0mT@K00H0mT@K0`0000070=Tj
5`030000003I>QL0fCXG00H0fCXG00<000000=Tj5`3I>QL01@3I>QL00`000000fCXG0=Tj5`060=Tj
5`040000003I>QL0000000000080Y2X@00<000000:@Z400lEjl0400lEjl00`000000oooo0?ooo`0=
0?ooo`030000003oool0oooo00d0oooo000>0?ooo`030000003oool0oooo00h0oooo00<000000?m:
7P3oBQh0103oBQh:02LeKP030000000W=Fh09cE^00`09cE^00<0000002LeKP0W=Fh02`0W=Fh40000
0100;T2300<0000002i0P`0^@8<03`0^@8<00`000000;T2302i0P`0?02i0P`030000000^@8<0;T23
0140;T2300<0000002i0P`0^@8<0400^@8<00`000000;T2302i0P`0A02i0P`030000000^@8<0;T23
00`0;T231000000203=8T`030000000cB9<0<dRC01<0<dRC00<0000003=8T`0cB9<0500cB9<00`00
0000<dRC03=8T`0D03=8T`030000000cB9<0<dRC0180<dRC00@000000?m:7P0cB9<0<dRC0P00000:
0?m:7P030000003oBQh0odXN00`0odXN00<000000?m:7P3oBQh03@3oBQh00`000000mT@K0?I46`09
0?I46`030000003fA1/0mT@K00X0mT@K00<000000?I46`3fA1/02@3fA1/00`000000mT@K0?I46`09
0?I46`030000003fA1/0mT@K00P0mT@K00<000000=Tj5`3I>QL01@3I>QL00`000000fCXG0=Tj5`06
0=Tj5`030000003I>QL0fCXG00H0fCXG00<000000=Tj5`3I>QL01@3I>QL01@000000fCXG0=Tj5`3I
>QL000000080Y2X@00<000000:@Z400lEjl03`0lEjl00`000000oooo0?ooo`0=0?ooo`030000003o
ool0oooo00d0oooo000>0?ooo`030000003oool0oooo00h0oooo00<000000?m:7P3oBQh00`3oBQh;
02LeKP030000000W=Fh09cE^00`09cE^00<0000002LeKP0W=Fh01`0W=Fh400000080;T2300<00000
02i0P`0^@8<03`0^@8<00`000000;T2302i0P`0?02i0P`030000000^@8<0;T2300l0;T2300<00000
02i0P`0^@8<04@0^@8<00`000000;T2302i0P`0@02i0P`030000000^@8<0;T230140;T2300<00000
02i0P`0^@8<0200^@8<4000000H0<dRC00<0000003=8T`0cB9<04`0cB9<00`000000<dRC03=8T`0D
03=8T`030000000cB9<0<dRC01@0<dRC00<0000003=8T`0cB9<04P0cB9<010000000odXN03=8T`0c
B9<2000000X0odXN00<000000?m:7P3oBQh0303oBQh00`000000odXN0?m:7P0=0?m:7P<000002@3f
A1/00`000000mT@K0?I46`0:0?I46`030000003fA1/0mT@K00T0mT@K00<000000?I46`3fA1/02@3f
A1/00`000000mT@K0?I46`080?I46`<000001P3I>QL00`000000fCXG0=Tj5`050=Tj5`030000003I
>QL0fCXG00H0fCXG00<000000=Tj5`3I>QL01P3I>QL010000000fCXG0=Tj5`3I>QL2000000030:@Z
40000000?5N_00l0?5N_00<000000?ooo`3oool03@3oool00`000000oooo0?ooo`0=0?ooo`003P3o
ool00`000000oooo0?ooo`0>0?ooo`030000003oBQh0odXN00<0odXN2P0W=Fh00`0000009cE^02Le
KP0=02LeKP030000000W=Fh09cE^00<09cE^1000000602i0P`030000000^@8<0;T2300l0;T2300<0
000002i0P`0^@8<03`0^@8<00`000000;T2302i0P`0?02i0P`030000000^@8<0;T230100;T2300<0
000002i0P`0^@8<04@0^@8<00`000000;T2302i0P`0A02i0P`030000000^@8<0;T2300@0;T231000
000:03=8T`030000000cB9<0<dRC01<0<dRC00<0000003=8T`0cB9<0500cB9<00`000000<dRC03=8
T`0D03=8T`030000000cB9<0<dRC0180<dRC00@000000?m:7P0cB9<0<dRC0P00000:0?m:7P030000
003oBQh0odXN00`0odXN00<000000?m:7P3oBQh03@3oBQh00`000000odXN0?m:7P02000000L0mT@K
00<000000?I46`3fA1/02P3fA1/00`000000mT@K0?I46`090?I46`030000003fA1/0mT@K00T0mT@K
00<000000?I46`3fA1/0203fA1/010000000mT@K0?I46`0000050=Tj5`030000003I>QL0fCXG00H0
fCXG00<000000=Tj5`3I>QL01@3I>QL00`000000fCXG0=Tj5`060=Tj5`030000003I>QL0fCXG00<0
fCXG0P0000000`2T:Q00?5N_03aG[`0>03aG[`030000003oool0oooo00`0oooo00<000000?ooo`3o
ool03@3oool000h0oooo00<000000?ooo`3oool03@3oool00`000000odXN0?m:7P030?m:7P/09cE^
00<0000002LeKP0W=Fh0300W=Fh00`0000009cE^02LeKP04000000X0;T2300<0000002i0P`0^@8<0
3`0^@8<00`000000;T2302i0P`0>02i0P`030000000^@8<0;T230100;T2300<0000002i0P`0^@8<0
400^@8<00`000000;T2302i0P`0A02i0P`030000000^@8<0;T230140;T2300<0000002i0P`0^@8<0
1000000>03=8T`030000000cB9<0<dRC01<0<dRC00<0000003=8T`0cB9<0500cB9<00`000000<dRC
03=8T`0E03=8T`030000000cB9<0<dRC0140<dRC00@000000?m:7P0cB9<0<dRC0P00000:0?m:7P03
0000003oBQh0odXN00`0odXN00<000000?m:7P3oBQh03@3oBQh00`000000odXN0?m:7P020?m:7P80
00001P3fA1/00`000000mT@K0?I46`090?I46`030000003fA1/0mT@K00T0mT@K00<000000?I46`3f
A1/02@3fA1/00`000000mT@K0?I46`080?I46`040000003fA1/0mT@K0?I46`8000000`3I>QL00`00
0000fCXG0=Tj5`060=Tj5`030000003I>QL0fCXG00H0fCXG00<000000=Tj5`3I>QL01@3I>QL00`00
0000fCXG0=Tj5`050=Tj5`030000002T:Q00?5N_00`0?5N_0`00000>0?ooo`030000003oool0oooo
00d0oooo000>0?ooo`030000003oool0oooo00d0oooo00<000000?m:7P3oBQh00P3oBQh<02LeKP03
0000000W=Fh09cE^00/09cE^1000000>02i0P`030000000^@8<0;T2300l0;T2300<0000002i0P`0^
@8<03P0^@8<00`000000;T2302i0P`0@02i0P`030000000^@8<0;T230100;T2300<0000002i0P`0^
@8<04@0^@8<00`000000;T2302i0P`0?02i0P`D000004P0cB9<00`000000<dRC03=8T`0D03=8T`03
0000000cB9<0<dRC01<0<dRC00<0000003=8T`0cB9<05@0cB9<00`000000<dRC03=8T`0A03=8T`04
0000003oBQh0<dRC03=8T`8000002@3oBQh00`000000odXN0?m:7P0=0?m:7P030000003oBQh0odXN
00d0odXN00<000000?m:7P3oBQh0103oBQh2000000@0mT@K00<000000?I46`3fA1/02P3fA1/00`00
0000mT@K0?I46`090?I46`030000003fA1/0mT@K00P0mT@K00<000000?I46`3fA1/0203fA1/00`00
0000mT@K0?I46`030?I46`8000000P3I>QL00`000000fCXG0=Tj5`060=Tj5`030000003I>QL0fCXG
00D0fCXG00<000000=Tj5`3I>QL01P3I>QL00`000000fCXG0=Tj5`040=Tj5`80000000<0Y2X@03aG
[`0lEjl01P0lEjl400000080>U>W00<000000?ooo`3oool0303oool00`000000oooo0?ooo`0=0?oo
o`003@3oool00`000000oooo0?ooo`0>0?ooo`030000003oBQh0odXN0080odXN2`0W=Fh00`000000
9cE^02LeKP0802LeKP@0000000<0;T230000000^@8<03P0^@8<00`000000;T2302i0P`0?02i0P`03
0000000^@8<0;T2300l0;T2300<0000002i0P`0^@8<0400^@8<00`000000;T2302i0P`0@02i0P`03
0000000^@8<0;T230100;T2300<0000002i0P`0^@8<0300^@8<400000080<dRC00<0000003=8T`0c
B9<04P0cB9<00`000000<dRC03=8T`0D03=8T`030000000cB9<0<dRC01<0<dRC00<0000003=8T`0c
B9<05@0cB9<00`000000<dRC03=8T`0A03=8T`040000003oBQh0<dRC03=8T`8000002@3oBQh00`00
0000odXN0?m:7P0=0?m:7P030000003oBQh0odXN00d0odXN00<000000?m:7P3oBQh01P3oBQh20000
0080mT@K00<000000?I46`3fA1/02P3fA1/00`000000mT@K0?I46`090?I46`030000003fA1/0mT@K
00P0mT@K00<000000?I46`3fA1/02@3fA1/00`000000mT@K0?I46`040?I46`030000003I>QL00000
00P0fCXG00<000000=Tj5`3I>QL01@3I>QL00`000000fCXG0=Tj5`060=Tj5`030000003I>QL0fCXG
00D0fCXG0`00000303aG[`@000001P0jDjL00`000000oooo0?ooo`0<0?ooo`030000003oool0oooo
00d0oooo000=0?ooo`030000003oool0oooo00h0oooo00@000000?m:7P3oBQh0odXN300W=Fh00`00
00009cE^02LeKP0502LeKP<000001@0^@8<00`000000;T2302i0P`0=02i0P`030000000^@8<0;T23
00l0;T2300<0000002i0P`0^@8<03`0^@8<00`000000;T2302i0P`0@02i0P`030000000^@8<0;T23
0100;T2300<0000002i0P`0^@8<0400^@8<00`000000;T2302i0P`0802i0P`@000001P0cB9<00`00
0000<dRC03=8T`0B03=8T`030000000cB9<0<dRC01@0<dRC00<0000003=8T`0cB9<04`0cB9<00`00
0000<dRC03=8T`0E03=8T`030000000cB9<0<dRC0140<dRC00@000000?m:7P0cB9<0<dRC0P000009
0?m:7P030000003oBQh0odXN00d0odXN00<000000?m:7P3oBQh03@3oBQh00`000000odXN0?m:7P08
0?m:7P<00000303fA1/00`000000mT@K0?I46`090?I46`030000003fA1/0mT@K00T0mT@K00<00000
0?I46`3fA1/0203fA1/00`000000mT@K0?I46`050?I46`<000001`3I>QL00`000000fCXG0=Tj5`06
0=Tj5`030000003I>QL0fCXG00H0fCXG00<000000=Tj5`3I>QL0103I>QL00`000000fCXG0=Tj5`03
000000/0>U>W00<000000?ooo`3oool02`3oool00`000000oooo0?ooo`0=0?ooo`003@3oool00`00
0000oooo0?ooo`0=0?ooo`030000003oBQh0odXN0080odXN300W=Fh00`0000009cE^02LeKP0202Le
KP<00000200^@8<00`000000;T2302i0P`0=02i0P`030000000^@8<0;T2300l0;T2300<0000002i0
P`0^@8<03`0^@8<00`000000;T2302i0P`0?02i0P`030000000^@8<0;T230140;T2300<0000002i0
P`0^@8<0400^@8<00`000000;T2302i0P`0402i0P`@000002P0cB9<00`000000<dRC03=8T`0B03=8
T`030000000cB9<0<dRC01@0<dRC00<0000003=8T`0cB9<04`0cB9<00`000000<dRC03=8T`0E03=8
T`030000000cB9<0<dRC0140<dRC00@000000?m:7P0cB9<0<dRC0P0000090?m:7P030000003oBQh0
odXN00d0odXN00<000000?m:7P3oBQh0303oBQh00`000000odXN0?m:7P0;0?m:7P030000003fA1/0
mT@K00X0mT@K00<000000?I46`3fA1/02@3fA1/00`000000mT@K0?I46`090?I46`030000003fA1/0
mT@K00P0mT@K00<000000?I46`3fA1/01`3fA1/00`000000fCXG0=Tj5`060=Tj5`030000003I>QL0
fCXG00D0fCXG00<000000=Tj5`3I>QL01P3I>QL00`000000fCXG0=Tj5`050=Tj5`030000003I>QL0
fCXG00d0>U>W00<000000?ooo`3oool02`3oool00`000000oooo0?ooo`0=0?ooo`003@3oool00`00
0000oooo0?ooo`0=0?ooo`040000003oBQh0odXN0?m:7P`09cE^00<0000002LeKP0000000`00000:
02i0P`030000000^@8<0;T2300h0;T2300<0000002i0P`0^@8<03`0^@8<00`000000;T2302i0P`0?
02i0P`030000000^@8<0;T2300l0;T2300<0000002i0P`0^@8<04@0^@8<00`000000;T2302i0P`0@
02i0P`030000000^@8<0;T2300@000003P0cB9<00`000000<dRC03=8T`0B03=8T`030000000cB9<0
<dRC01@0<dRC00<0000003=8T`0cB9<0500cB9<00`000000<dRC03=8T`0D03=8T`030000000cB9<0
<dRC0140<dRC00@000000?m:7P0cB9<0<dRC0P0000090?m:7P030000003oBQh0odXN00d0odXN00<0
00000?m:7P3oBQh0303oBQh00`000000odXN0?m:7P0;0?m:7P<000002P3fA1/00`000000mT@K0?I4
6`090?I46`030000003fA1/0mT@K00T0mT@K00<000000?I46`3fA1/0203fA1/00`000000mT@K0?I4
6`070?I46`<000001P3I>QL00`000000fCXG0=Tj5`060=Tj5`030000003I>QL0fCXG00D0fCXG00<0
00000=Tj5`3I>QL01@3I>QL010000000fCXG0=Tj5`3I>QL<03YCY`030000003oool0oooo00`0oooo
00<000000?ooo`3oool0303oool000d0oooo00<000000?ooo`3oool03@3oool010000000odXN0?m:
7P3oBQh;02LeKP<000003P0^@8<00`000000;T2302i0P`0>02i0P`030000000^@8<0;T2300l0;T23
00<0000002i0P`0^@8<03`0^@8<00`000000;T2302i0P`0?02i0P`030000000^@8<0;T230140;T23
00<0000002i0P`0^@8<03`0^@8<400000180<dRC00<0000003=8T`0cB9<04`0cB9<00`000000<dRC
03=8T`0C03=8T`030000000cB9<0<dRC01@0<dRC00<0000003=8T`0cB9<0500cB9<00`000000<dRC
03=8T`0A03=8T`040000003oBQh0<dRC03=8T`8000002@3oBQh00`000000odXN0?m:7P0=0?m:7P03
0000003oBQh0odXN00`0odXN00<000000?m:7P3oBQh02`3oBQh00`000000odXN0?m:7P02000000P0
mT@K00<000000?I46`3fA1/02@3fA1/00`000000mT@K0?I46`090?I46`030000003fA1/0mT@K00P0
mT@K00<000000?I46`3fA1/01`3fA1/00`000000mT@K0?I46`02000000@0fCXG00<000000=Tj5`3I
>QL01P3I>QL00`000000fCXG0=Tj5`060=Tj5`030000003I>QL0fCXG00@0fCXG00@000000=Tj5`3I
>QL0fCXG300jDjL00`000000oooo0?ooo`0<0?ooo`030000003oool0oooo00`0oooo000=0?ooo`03
0000003oool0oooo00d0oooo00<000000?m:7P3oBQh0200W=Fh40000000302i0P`000000;T2300h0
;T2300<0000002i0P`0^@8<03P0^@8<00`000000;T2302i0P`0?02i0P`030000000^@8<0;T2300l0
;T2300<0000002i0P`0^@8<03`0^@8<00`000000;T2302i0P`0@02i0P`030000000^@8<0;T2300`0
;T23100000000`0cB9<0000003=8T`0C03=8T`030000000cB9<0<dRC01<0<dRC00<0000003=8T`0c
B9<04`0cB9<00`000000<dRC03=8T`0D03=8T`030000000cB9<0<dRC01@0<dRC00<0000003=8T`0c
B9<04@0cB9<010000000odXN03=8T`0cB9<2000000T0odXN00<000000?m:7P3oBQh03@3oBQh00`00
0000odXN0?m:7P0<0?m:7P030000003oBQh0odXN00/0odXN00<000000?m:7P3oBQh00P3oBQh20000
00H0mT@K00<000000?I46`3fA1/02@3fA1/00`000000mT@K0?I46`090?I46`030000003fA1/0mT@K
00P0mT@K00<000000?I46`3fA1/01`3fA1/00`000000mT@K0?I46`020?I46`8000000`3I>QL00`00
0000fCXG0=Tj5`050=Tj5`030000003I>QL0fCXG00H0fCXG00<000000=Tj5`3I>QL01@3I>QL01000
0000fCXG0=Tj5`3I>QL;03YCY`030000003oool0oooo00`0oooo00<000000?ooo`3oool0303oool0
00d0oooo00<000000?ooo`3oool0303oool010000000odXN0?m:7P3oBQh402LeKP@000001@0^@8<0
0`000000;T2302i0P`0=02i0P`030000000^@8<0;T2300h0;T2300<0000002i0P`0^@8<03`0^@8<0
0`000000;T2302i0P`0?02i0P`030000000^@8<0;T2300l0;T2300<0000002i0P`0^@8<0400^@8<0
0`000000;T2302i0P`0802i0P`@000001@0cB9<00`000000<dRC03=8T`0B03=8T`030000000cB9<0
<dRC01<0<dRC00<0000003=8T`0cB9<04`0cB9<00`000000<dRC03=8T`0D03=8T`030000000cB9<0
<dRC01@0<dRC00<0000003=8T`0cB9<0400cB9<00`000000odXN0?m:7P0303=8T`030000003oBQh0
odXN00L0odXN00<000000?m:7P3oBQh03@3oBQh00`000000odXN0?m:7P0<0?m:7P030000003oBQh0
odXN00/0odXN00<000000?m:7P3oBQh0103oBQh2000000D0mT@K00<000000?I46`3fA1/02@3fA1/0
0`000000mT@K0?I46`080?I46`030000003fA1/0mT@K00P0mT@K00<000000?I46`3fA1/0203fA1/0
0`000000mT@K0?I46`030?I46`80000000<0fCXG0000003I>QL01`3I>QL00`000000fCXG0=Tj5`05
0=Tj5`030000003I>QL0fCXG00D0fCXG00@000000=Tj5`3I>QL0fCXG2`0jDjL00`000000oooo0?oo
o`0<0?ooo`030000003oool0oooo00`0oooo000=0?ooo`030000003oool0oooo00`0oooo00@00000
0?m:7P3oBQh09cE^1@00000802i0P`030000000^@8<0;T2300d0;T2300<0000002i0P`0^@8<03P0^
@8<00`000000;T2302i0P`0>02i0P`030000000^@8<0;T2300l0;T2300<0000002i0P`0^@8<0400^
@8<00`000000;T2302i0P`0@02i0P`030000000^@8<0;T2300@0;T231000000903=8T`030000000c
B9<0<dRC0180<dRC00<0000003=8T`0cB9<04`0cB9<00`000000<dRC03=8T`0C03=8T`030000000c
B9<0<dRC01@0<dRC00<0000003=8T`0cB9<0500cB9<00`000000<dRC03=8T`0@03=8T`030000003o
BQh0odXN00<0<dRC00<000000?m:7P3oBQh01`3oBQh00`000000odXN0?m:7P0<0?m:7P030000003o
BQh0odXN00d0odXN00<000000?m:7P3oBQh02`3oBQh00`000000odXN0?m:7P060?m:7P8000000`3f
A1/00`000000mT@K0?I46`090?I46`030000003fA1/0mT@K00P0mT@K00<000000?I46`3fA1/0203f
A1/00`000000mT@K0?I46`080?I46`030000003fA1/0mT@K00D0mT@K0`0000070=Tj5`030000003I
>QL0fCXG00H0fCXG00<000000=Tj5`3I>QL01@3I>QL010000000fCXG0=Tj5`3I>QL;03YCY`030000
003oool0oooo00/0oooo00<000000?ooo`3oool0303oool000d0oooo00<000000?ooo`3oool0303o
ool6000000X0;T2300<0000002i0P`0^@8<03P0^@8<00`000000;T2302i0P`0=02i0P`030000000^
@8<0;T2300l0;T2300<0000002i0P`0^@8<03`0^@8<00`000000;T2302i0P`0@02i0P`030000000^
@8<0;T230100;T2300<0000002i0P`0^@8<01000000=03=8T`030000000cB9<0<dRC0180<dRC00<0
000003=8T`0cB9<04`0cB9<00`000000<dRC03=8T`0C03=8T`030000000cB9<0<dRC01@0<dRC00<0
000003=8T`0cB9<0500cB9<00`000000<dRC03=8T`0@03=8T`030000003oBQh0odXN00<0<dRC00<0
00000?m:7P3oBQh01`3oBQh00`000000odXN0?m:7P0<0?m:7P030000003oBQh0odXN00d0odXN00<0
00000?m:7P3oBQh02`3oBQh00`000000odXN0?m:7P080?m:7P80000000<0mT@K0000003fA1/02P3f
A1/00`000000mT@K0?I46`080?I46`030000003fA1/0mT@K00T0mT@K00<000000?I46`3fA1/01`3f
A1/00`000000mT@K0?I46`070?I46`030000003I>QL0fCXG00H0fCXG00<000000=Tj5`3I>QL01@3I
>QL00`000000fCXG0=Tj5`050=Tj5`040000003I>QL0fCXG0=Tj5`/0>U>W00<000000?ooo`3oool0
2`3oool00`000000oooo0?ooo`0<0?ooo`003@3oool00`000000oooo0?ooo`0<0?ooo`030000003o
B1d0;T2300d0;T2300<0000002i0P`0^@8<03@0^@8<00`000000;T2302i0P`0>02i0P`030000000^
@8<0;T2300l0;T2300<0000002i0P`0^@8<03`0^@8<00`000000;T2302i0P`0@02i0P`030000000^
@8<0;T2300l0;T231000000A03=8T`030000000cB9<0<dRC01<0<dRC00<0000003=8T`0cB9<04P0c
B9<00`000000<dRC03=8T`0C03=8T`030000000cB9<0<dRC01@0<dRC00<0000003=8T`0cB9<0500c
B9<00`000000<dRC03=8T`0@03=8T`030000003oBQh0odXN00<0<dRC00<000000?m:7P3oBQh01`3o
BQh00`000000odXN0?m:7P0<0?m:7P030000003oBQh0odXN00d0odXN00<000000?m:7P3oBQh02`3o
BQh00`000000odXN0?m:7P0:0?m:7P8000002`3fA1/00`000000mT@K0?I46`080?I46`030000003f
A1/0mT@K00T0mT@K00<000000?I46`3fA1/01`3fA1/00`000000mT@K0?I46`070?I46`<000001P3I
>QL00`000000fCXG0=Tj5`060=Tj5`030000003I>QL0fCXG00@0fCXG00<000000=Tj5`3I>QL00P3I
>QL:03YCY`030000003oool0oooo00/0oooo00<000000?ooo`3oool0303oool000d0oooo00<00000
0?ooo`3oool02`3oool00`000000odPM0?m87@0>02i0P`030000000^@8<0;T2300d0;T2300<00000
02i0P`0^@8<03P0^@8<00`000000;T2302i0P`0?02i0P`030000000^@8<0;T2300l0;T2300<00000
02i0P`0^@8<03`0^@8<00`000000;T2302i0P`0<02i0P`@0000000<0<dRC0000000cB9<04P0cB9<0
0`000000<dRC03=8T`0C03=8T`030000000cB9<0<dRC0180<dRC00<0000003=8T`0cB9<04`0cB9<0
0`000000<dRC03=8T`0D03=8T`030000000cB9<0<dRC01@0<dRC00<0000003=8T`0cB9<0400cB9<0
0`000000odXN0?m:7P0303=8T`030000003oBQh0odXN00L0odXN00<000000?m:7P3oBQh0303oBQh0
0`000000odXN0?m:7P0=0?m:7P030000003oBQh0odXN00/0odXN00<000000?m:7P3oBQh02`3oBQh3
000000T0mT@K00<000000?I46`3fA1/02@3fA1/00`000000mT@K0?I46`080?I46`030000003fA1/0
mT@K00L0mT@K00<000000?I46`3fA1/01`3fA1/00`000000mT@K0?I46`02000000@0fCXG00<00000
0=Tj5`3I>QL01P3I>QL00`000000fCXG0=Tj5`050=Tj5`040000003I>QL0fCXG0=Tj5`X0>U>W00<0
00000?ooo`3oool02`3oool00`000000oooo0?ooo`0<0?ooo`003@3oool00`000000oooo0?ooo`0;
0?ooo`030000003oB1d0odPM00h0;T2300<0000002i0P`0^@8<03@0^@8<00`000000;T2302i0P`0>
02i0P`030000000^@8<0;T2300l0;T2300<0000002i0P`0^@8<03`0^@8<00`000000;T2302i0P`0?
02i0P`030000000^@8<0;T2300P0;T231000000503=8T`030000000cB9<0<dRC0140<dRC00<00000
03=8T`0cB9<04`0cB9<00`000000<dRC03=8T`0B03=8T`030000000cB9<0<dRC01<0<dRC00<00000
03=8T`0cB9<0500cB9<00`000000<dRC03=8T`0E03=8T`030000000cB9<0<dRC00l0<dRC00<00000
0?m:7P3oBQh00`0cB9<00`000000odXN0?m:7P070?m:7P030000003oBQh0odXN00`0odXN00<00000
0?m:7P3oBQh03@3oBQh00`000000odXN0?m:7P0;0?m:7P030000003oBQh0odXN00/0odXN00<00000
0?m:7P3oBQh00P0000070?I46`030000003fA1/0mT@K00T0mT@K00<000000?I46`3fA1/0203fA1/0
0`000000mT@K0?I46`070?I46`030000003fA1/0mT@K00L0mT@K00<000000?I46`3fA1/00P3fA1/2
000000<0fCXG00<000000=Tj5`3I>QL01@3I>QL00`000000fCXG0=Tj5`050=Tj5`030000003I>QL0
fCXG0080fCXG2@0jDjL00`000000oooo0?ooo`0;0?ooo`030000003oool0oooo00`0oooo000=0?oo
o`030000003oool0oooo00/0oooo00<000000?m87@3oB1d03P0^@8<00`000000;T2302i0P`0=02i0
P`030000000^@8<0;T2300h0;T2300<0000002i0P`0^@8<03`0^@8<00`000000;T2302i0P`0?02i0
P`030000000^@8<0;T2300l0;T2300<0000002i0P`0^@8<0100^@8<4000000T0<dRC00<0000003=8
T`0cB9<04@0cB9<00`000000<dRC03=8T`0C03=8T`030000000cB9<0<dRC0180<dRC00<0000003=8
T`0cB9<04`0cB9<00`000000<dRC03=8T`0D03=8T`030000000cB9<0<dRC01D0<dRC00<0000003=8
T`0cB9<03`0cB9<00`000000odXN0?m:7P0203=8T`8000002@3oBQh00`000000odXN0?m:7P0<0?m:
7P030000003oBQh0odXN00d0odXN00<000000?m:7P3oBQh02P3oBQh00`000000odXN0?m:7P0<0?m:
7P030000003oBQh0odXN0080odXN0P0000050?I46`030000003fA1/0mT@K00T0mT@K00<000000?I4
6`3fA1/0203fA1/00`000000mT@K0?I46`080?I46`030000003fA1/0mT@K00L0mT@K00<000000?I4
6`3fA1/00`3fA1/2000000030=Tj5`000000fCXG00L0fCXG00<000000=Tj5`3I>QL0103I>QL00`00
0000fCXG0=Tj5`020=Tj5`X0>U>W00<000000?ooo`3oool02P3oool00`000000oooo0?ooo`0<0?oo
o`003@3oool00`000000oooo0?ooo`0;0?ooo`030000003oB1d0;T2300h0;T2300<0000002i0P`0^
@8<03@0^@8<00`000000;T2302i0P`0>02i0P`030000000^@8<0;T2300l0;T2300<0000002i0P`0^
@8<03`0^@8<00`000000;T2302i0P`0?02i0P`030000000^@8<0;T2300@000003@0cB9<00`000000
<dRC03=8T`0A03=8T`030000000cB9<0<dRC01<0<dRC00<0000003=8T`0cB9<04P0cB9<00`000000
<dRC03=8T`0C03=8T`030000000cB9<0<dRC01@0<dRC00<0000003=8T`0cB9<05@0cB9<00`000000
<dRC03=8T`0?03=8T`D0000000<0=dnO0000003oBQh01`3oBQh00`000000odXN0?m:7P0=0?m:7P03
0000003oBQh0odXN00d0odXN00<000000?m:7P3oBQh02P3oBQh00`000000odXN0?m:7P0<0?m:7P03
0000003oBQh0odXN00@0odXN0P0000040?I46`030000003fA1/0mT@K00P0mT@K00<000000?I46`3f
A1/0203fA1/00`000000mT@K0?I46`080?I46`030000003fA1/0mT@K00L0mT@K00<000000?I46`3f
A1/01@3fA1/3000000L0fCXG00<000000=Tj5`3I>QL01@3I>QL00`000000fCXG0=Tj5`020=Tj5`T0
>U>W00<000000?ooo`3oool02P3oool00`000000oooo0?ooo`0<0?ooo`003@3oool00`000000oooo
0?ooo`0;0?ooo`030000003oB1d0;T2300d0;T2300<0000002i0P`0^@8<03P0^@8<00`000000;T23
02i0P`0>02i0P`030000000^@8<0;T2300h0;T2300<0000002i0P`0^@8<0400^@8<00`000000;T23
02i0P`0>02i0P`@000004@0cB9<00`000000<dRC03=8T`0B03=8T`030000000cB9<0<dRC0180<dRC
00<0000003=8T`0cB9<04P0cB9<00`000000<dRC03=8T`0C03=8T`030000000cB9<0<dRC01@0<dRC
00<0000003=8T`0cB9<05@0cB9<00`000000<dRC03=8T`0:03=8T`D000000P3oCQl403M?W`030000
003oBQh0odXN00H0odXN00<000000?m:7P3oBQh03@3oBQh00`000000odXN0?m:7P0<0?m:7P030000
003oBQh0odXN00/0odXN00<000000?m:7P3oBQh0303oBQh00`000000odXN0?m:7P060?m:7P800000
0P3fA1/00`000000mT@K0?I46`080?I46`030000003fA1/0mT@K00P0mT@K00<000000?I46`3fA1/0
203fA1/00`000000mT@K0?I46`070?I46`030000003fA1/0mT@K00L0mT@K00<000000=Tj5`3I>QL0
1P3I>QL00`000000fCXG0=Tj5`040=Tj5`030000003I>QL0fCXG0080fCXG2@0jDjL00`000000oooo
0?ooo`0:0?ooo`030000003oool0oooo00`0oooo000=0?ooo`030000003oool0oooo00/0oooo00<0
00000?m87@0^@8<03@0^@8<00`000000;T2302i0P`0>02i0P`030000000^@8<0;T2300h0;T2300<0
000002i0P`0^@8<03P0^@8<00`000000;T2302i0P`0?02i0P`030000000^@8<0;T2300/0;T231000
00000`0cB9<0000003=8T`0B03=8T`030000000cB9<0<dRC0180<dRC00<0000003=8T`0cB9<04P0c
B9<00`000000<dRC03=8T`0B03=8T`030000000cB9<0<dRC01<0<dRC00<0000003=8T`0cB9<0500c
B9<00`000000<dRC03=8T`0E03=8T`030000000cB9<0<dRC00D0<dRC1@00000403M?W`030000003o
CQl0odhO00@0=dnO0P0000070?m:7P030000003oBQh0odXN00d0odXN00<000000?m:7P3oBQh0303o
BQh00`000000odXN0?m:7P0;0?m:7P030000003oBQh0odXN00`0odXN00<000000?m:7P3oBQh0203o
BQh3000000X0mT@K00<000000?I46`3fA1/0203fA1/00`000000mT@K0?I46`080?I46`030000003f
A1/0mT@K00L0mT@K00<000000?I46`3fA1/01`3fA1/3000000H0fCXG00<000000=Tj5`3I>QL01@3I
>QL00`000000fCXG0=Tj5`020=Tj5`P0>U>W00<000000?ooo`3oool02P3oool00`000000oooo0?oo
o`0<0?ooo`00303oool00`000000oooo0?ooo`0;0?ooo`030000003oB1d0odPM00h0;T2300<00000
02i0P`0^@8<03@0^@8<00`000000;T2302i0P`0>02i0P`030000000^@8<0;T2300l0;T2300<00000
02i0P`0^@8<03`0^@8<00`000000;T2302i0P`0702i0P`@000001@0cB9<00`000000<dRC03=8T`0A
03=8T`030000000cB9<0<dRC0180<dRC00<0000003=8T`0cB9<04P0cB9<00`000000<dRC03=8T`0B
03=8T`030000000cB9<0<dRC01<0<dRC00<0000003=8T`0cB9<05@0cB9<00`000000<dRC03=8T`0D
03=8T`030000000cB9<0<dRC00D000002@0gCil00`000000odhO0?m>7`0403M?W`@000001@3oBQh0
0`000000odXN0?m:7P0=0?m:7P030000003oBQh0odXN00`0odXN00<000000?m:7P3oBQh02`3oBQh0
0`000000odXN0?m:7P0;0?m:7P030000003oBQh0odXN00/0odXN00<000000?I46`3fA1/0203fA1/0
0`000000mT@K0?I46`080?I46`030000003fA1/0mT@K00P0mT@K00<000000?I46`3fA1/01`3fA1/0
0`000000mT@K0?I46`070?I46`030000003fA1/0mT@K00800000103I>QL00`000000fCXG0=Tj5`05
0=Tj5`030000003I>QL0fCXG0080fCXG200jDjL00`000000oooo0?ooo`0:0?ooo`030000003oool0
oooo00`0oooo000<0?ooo`030000003oool0oooo00/0oooo00<000000?m87@3oB1d03P0^@8<00`00
0000;T2302i0P`0=02i0P`030000000^@8<0;T2300h0;T2300<0000002i0P`0^@8<03`0^@8<00`00
0000;T2302i0P`0?02i0P`030000000^@8<0;T2300<0;T231000000903=8T`030000000cB9<0<dRC
0140<dRC00<0000003=8T`0cB9<04P0cB9<00`000000<dRC03=8T`0B03=8T`030000000cB9<0<dRC
0180<dRC00<0000003=8T`0cB9<04`0cB9<00`000000<dRC03=8T`0E03=8T`030000000cB9<0<dRC
0180<dRC1@00000>03M?W`030000003oCQl0odhO00@0=dnO0P0000020?m>7`8000000`3oBQh00`00
0000odXN0?m:7P0=0?m:7P030000003oBQh0odXN00`0odXN00<000000?m:7P3oBQh02`3oBQh00`00
0000odXN0?m:7P0;0?m:7P030000003oBQh0odXN00/0odXN0`0000080?I46`030000003fA1/0mT@K
00T0mT@K00<000000?I46`3fA1/01`3fA1/00`000000mT@K0?I46`070?I46`030000003fA1/0mT@K
00L0mT@K00<000000?I46`3fA1/00P3fA1/2000000<0fCXG00<000000=Tj5`3I>QL0103I>QL00`00
0000fCXG0=Tj5`030=Tj5`P0>U>W00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`0<0?oo
o`00303oool00`000000oooo0?ooo`0;0?ooo`030000003oB1d0;T2300h0;T2300<0000002i0P`0^
@8<03@0^@8<00`000000;T2302i0P`0>02i0P`030000000^@8<0;T2300l0;T2300<0000002i0P`0^
@8<03`0^@8<00`000000;T2300000003000000d0<dRC00<0000003=8T`0cB9<04@0cB9<00`000000
<dRC03=8T`0B03=8T`030000000cB9<0<dRC0180<dRC00<0000003=8T`0cB9<04P0cB9<00`000000
<dRC03=8T`0C03=8T`030000000cB9<0<dRC01D0<dRC00<0000003=8T`0cB9<03P0cB9<400000080
=dnO00<0000003M?W`0gCil03@0gCil010000000odhO0?m>7`3oCQl403M?W`800000103oCQl20000
00030?m:7P000000odXN00h0odXN00<000000?m:7P3oBQh0303oBQh00`000000odXN0?m:7P0;0?m:
7P030000003oBQh0odXN00/0odXN00<000000?m:7P3oBQh02`3oBQh00`000000odXN0?m:7P020000
00L0mT@K00<000000?I46`3fA1/0203fA1/00`000000mT@K0?I46`070?I46`030000003fA1/0mT@K
00P0mT@K00<000000?I46`3fA1/01`3fA1/00`000000mT@K0?I46`030?I46`80000000<0fCXG0000
003I>QL01P3I>QL00`000000fCXG0=Tj5`020=Tj5`P0>U>W00<000000?ooo`3oool02@3oool00`00
0000oooo0?ooo`0<0?ooo`00303oool00`000000oooo0?ooo`0;0?ooo`030000003oB1d0;T2300h0
;T2300<0000002i0P`0^@8<03@0^@8<00`000000;T2302i0P`0>02i0P`030000000^@8<0;T2300l0
;T2300<0000002i0P`0^@8<03@0^@8<400000140<dRC00<0000003=8T`0cB9<04P0cB9<00`000000
<dRC03=8T`0A03=8T`030000000cB9<0<dRC0180<dRC00<0000003=8T`0cB9<04P0cB9<00`000000
<dRC03=8T`0D03=8T`030000000cB9<0<dRC01@0<dRC00<0000003=8T`0cB9<02@0cB9<5000000H0
=dnO00<0000003M?W`0gCil03@0gCil010000000odhO0?m>7`3oCQl403M?W`8000001P3oCQl30000
00h0odXN00<000000?m:7P3oBQh0303oBQh00`000000odXN0?m:7P0;0?m:7P030000003oBQh0odXN
00/0odXN00<000000?m:7P3oBQh02`3oBQh00`000000odXN0?m:7P020?m:7P8000001@3fA1/00`00
0000mT@K0?I46`080?I46`030000003fA1/0mT@K00P0mT@K00<000000?I46`3fA1/01`3fA1/00`00
0000mT@K0?I46`070?I46`030000003fA1/0mT@K00D0mT@K0`0000060=Tj5`030000003I>QL0fCXG
00<0fCXG1`0jDjL00`000000oooo0?ooo`090?ooo`030000003oool0oooo00`0oooo000<0?ooo`03
0000003oool0oooo00/0oooo00<000000?m87@0^@8<03P0^@8<00`000000;T2302i0P`0=02i0P`03
0000000^@8<0;T2300h0;T2300<0000002i0P`0^@8<03P0^@8<00`000000;T2302i0P`0902i0P`D0
00000P0cB9<00`000000<dRC03=8T`0@03=8T`030000000cB9<0<dRC0180<dRC00<0000003=8T`0c
B9<04@0cB9<00`000000<dRC03=8T`0B03=8T`030000000cB9<0<dRC0180<dRC00<0000003=8T`0c
B9<0500cB9<00`000000<dRC03=8T`0D03=8T`030000000cB9<0<dRC00@0<dRC1@00000<03M?W`03
0000000gCil0=dnO00`0=dnO00@000000?m>7`3oCQl0odhO100gCil2000000L0odhO00@000000?m>
7`00000000002`3oBQh00`000000odXN0?m:7P0=0?m:7P030000003oBQh0odXN00/0odXN00<00000
0?m:7P3oBQh02`3oBQh00`000000odXN0?m:7P0;0?m:7P030000003oBQh0odXN00@0odXN0P000003
0?I46`030000003fA1/0mT@K00P0mT@K00<000000?I46`3fA1/0203fA1/00`000000mT@K0?I46`07
0?I46`030000003fA1/0mT@K00L0mT@K00<000000?I46`3fA1/01`3fA1/00`000000fCXG0=Tj5`05
0=Tj5`030000003I>QL0fCXG0080fCXG1`0jDjL00`000000oooo0?ooo`0:0?ooo`030000003oool0
oooo00/0oooo000<0?ooo`030000003oool0oooo00/0oooo00<000000?m87@0^@8<03@0^@8<00`00
0000;T2302i0P`0>02i0P`030000000^@8<0;T2300h0;T2300<0000002i0P`0^@8<03P0^@8<00`00
0000;T2302i0P`0502i0P`@000001`0cB9<00`000000<dRC03=8T`0@03=8T`030000000cB9<0<dRC
0180<dRC00<0000003=8T`0cB9<04@0cB9<00`000000<dRC03=8T`0B03=8T`030000000cB9<0<dRC
0180<dRC00<0000003=8T`0cB9<0500cB9<00`000000<dRC03=8T`0D03=8T`030000000cB9<0<dRC
00@000004@0gCil00`000000=dnO03M?W`0<03M?W`040000003oCQl0odhO0?m>7`@0=dnO0P000006
0?m>7`030000003oCQl0odhO0080odhO0P0000090?m:7P030000003oBQh0odXN00d0odXN00<00000
0?m:7P3oBQh02`3oBQh00`000000odXN0?m:7P0;0?m:7P030000003oBQh0odXN00/0odXN00<00000
0?m:7P3oBQh01P3oBQh2000000030?I46`000000mT@K00T0mT@K00<000000?I46`3fA1/0203fA1/0
0`000000mT@K0?I46`070?I46`030000003fA1/0mT@K00L0mT@K00<000000?I46`3fA1/01`3fA1/3
000000D0fCXG00<000000=Tj5`3I>QL00`3I>QL603YCY`030000003oool0oooo00X0oooo00<00000
0?ooo`3oool02`3oool000`0oooo00<000000?ooo`3oool02P3oool00`000000odPM0?m87@0>02i0
P`030000000^@8<0;T2300h0;T2300<0000002i0P`0^@8<03P0^@8<00`000000;T2302i0P`0>02i0
P`030000000^@8<0;T2300D000002`0cB9<00`000000<dRC03=8T`0@03=8T`030000000cB9<0<dRC
0180<dRC00<0000003=8T`0cB9<04@0cB9<00`000000<dRC03=8T`0B03=8T`030000000cB9<0<dRC
0180<dRC00<0000003=8T`0cB9<0500cB9<00`000000<dRC03=8T`0C03=8T`@000005@0gCil00`00
0000=dnO03M?W`0;03M?W`030000003oCQl0odhO0080odhO100gCil00`000000=dnO000000050?m>
7`030000003oCQl0odhO00@0odhO0P0000070?m:7P030000003oBQh0odXN00d0odXN00<000000?m:
7P3oBQh02`3oBQh00`000000odXN0?m:7P0;0?m:7P030000003oBQh0odXN00/0odXN00<000000?m:
7P3oBQh0203oBQh2000000X0mT@K00<000000?I46`3fA1/0203fA1/00`000000mT@K0?I46`070?I4
6`030000003fA1/0mT@K00L0mT@K00<000000?I46`3fA1/01`3fA1/00`000000mT@K0?I46`020000
00<0fCXG00<000000=Tj5`3I>QL00`3I>QL603YCY`030000003oool0oooo00X0oooo00<000000?oo
o`3oool02`3oool000`0oooo00<000000?ooo`3oool02P3oool00`000000odPM02i0P`0>02i0P`03
0000000^@8<0;T2300d0;T2300<0000002i0P`0^@8<03`0^@8<00`000000;T2302i0P`0=02i0P`@0
0000400cB9<00`000000<dRC03=8T`0@03=8T`030000000cB9<0<dRC0180<dRC00<0000003=8T`0c
B9<04@0cB9<00`000000<dRC03=8T`0B03=8T`030000000cB9<0<dRC01<0<dRC00<0000003=8T`0c
B9<04`0cB9<00`000000<dRC03=8T`0?03=8T`@0000000<0=dnO0000000gCil05P0gCil00`000000
=dnO03M?W`0;03M?W`030000003oCQl0odhO0080odhO100gCil00`000000=dnO000000050?m>7`03
0000003oCQl0odhO00H0odhO0P0000050?m:7P030000003oBQh0odXN00d0odXN00<000000?m:7P3o
BQh02`3oBQh00`000000odXN0?m:7P0;0?m:7P030000003oBQh0odXN00/0odXN00<000000?m:7P3o
BQh02@3oBQh3000000P0mT@K00<000000?I46`3fA1/0203fA1/00`000000mT@K0?I46`070?I46`03
0000003fA1/0mT@K00L0mT@K00<000000?I46`3fA1/01`3fA1/00`000000mT@K0?I46`020?I46`05
0000003I>QL0fCXG0=Tj5`0000001@3I>QL603YCY`030000003oool0oooo00T0oooo00<000000?oo
o`3oool02`3oool000`0oooo00<000000?ooo`3oool02P3oool00`000000odPM02i0P`0>02i0P`03
0000000^@8<0;T2300d0;T2300<0000002i0P`0^@8<03P0^@8<00`000000;T2302i0P`0:02i0P`@0
000000<0<dRC0000000cB9<04@0cB9<00`000000<dRC03=8T`0A03=8T`030000000cB9<0<dRC0140
<dRC00<0000003=8T`0cB9<04@0cB9<00`000000<dRC03=8T`0B03=8T`030000000cB9<0<dRC01<0
<dRC00<0000003=8T`0cB9<04`0cB9<00`000000<dRC03=8T`0;03=8T`@000001@0gCil00`000000
=dnO03M?W`0E03M?W`030000000gCil0=dnO00/0=dnO00<000000?m>7`3oCQl00P3oCQl403M?W`03
0000000gCil0000000D0odhO00<000000?m>7`3oCQl0203oCQl2000000<0odXN00<000000?m:7P3o
BQh03@3oBQh00`000000odXN0?m:7P0;0?m:7P030000003oBQh0odXN00/0odXN00<000000?m:7P3o
BQh02`3oBQh00`000000odXN0?m:7P090?m:7P030000003oBQh0odXN008000001P3fA1/00`000000
mT@K0?I46`080?I46`030000003fA1/0mT@K00L0mT@K00<000000?I46`3fA1/0203fA1/00`000000
mT@K0?I46`070?I46`030000003fA1/0mT@K0080mT@K0P0000000`3I>QL000000=Tj5`040=Tj5`H0
>U>W00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`0;0?ooo`00303oool00`000000oooo
0?ooo`0:0?ooo`030000003oB1d0;T2300h0;T2300<0000002i0P`0^@8<03@0^@8<00`000000;T23
02i0P`0>02i0P`030000000^@8<0;T2300L0;T230`00000503=8T`030000000cB9<0<dRC0100<dRC
00<0000003=8T`0cB9<04@0cB9<00`000000<dRC03=8T`0A03=8T`030000000cB9<0<dRC0140<dRC
00<0000003=8T`0cB9<04P0cB9<00`000000<dRC03=8T`0C03=8T`030000000cB9<0<dRC01<0<dRC
00<0000003=8T`0cB9<01`0cB9<4000000X0=dnO00<0000003M?W`0gCil0500gCil00`000000=dnO
03M?W`0:03M?W`030000003oCQl0odhO0080odhO1@0gCil00`000000=dnO000000040?m>7`030000
003oCQl0odhO00/0odhO0P0000000`3oBQh000000?m:7P0>0?m:7P030000003oBQh0odXN00/0odXN
00<000000?m:7P3oBQh02`3oBQh00`000000odXN0?m:7P0:0?m:7P030000003oBQh0odXN00X0odXN
00<000000?m:7P3oBQh00P3oBQh00`000000mT@K0?I46`040?I46`030000003fA1/0mT@K00L0mT@K
00<000000?I46`3fA1/0203fA1/00`000000mT@K0?I46`070?I46`030000003fA1/0mT@K00L0mT@K
00<000000?I46`3fA1/0103fA1/3000000D0fCXG1@0jDjL00`000000oooo0?ooo`090?ooo`030000
003oool0oooo00/0oooo000<0?ooo`030000003oool0oooo00X0oooo00<000000?m87@0^@8<03P0^
@8<00`000000;T2302i0P`0=02i0P`030000000^@8<0;T2300h0;T2300<0000002i0P`0^@8<00`0^
@8<4000000P0<dRC00<0000003=8T`0cB9<0400cB9<00`000000<dRC03=8T`0A03=8T`030000000c
B9<0<dRC0140<dRC00<0000003=8T`0cB9<04@0cB9<00`000000<dRC03=8T`0B03=8T`030000000c
B9<0<dRC01<0<dRC00<0000003=8T`0cB9<04`0cB9<00`000000<dRC03=8T`0303=8T`@000003P0g
Cil00`000000=dnO03M?W`0E03M?W`030000000gCil0=dnO00T0=dnO00<000000?m>7`3oCQl00P3o
CQl503M?W`030000000gCil0000000@0odhO00<000000?m>7`3oCQl03@3oCQl3000000h0odXN00<0
00000?m:7P3oBQh02`3oBQh00`000000odXN0?m:7P0;0?m:7P030000003oBQh0odXN00X0odXN00<0
00000?m:7P3oBQh02P3oBQh00`000000odXN0?m:7P030?m:7P800000103fA1/00`000000mT@K0?I4
6`080?I46`030000003fA1/0mT@K00L0mT@K00<000000?I46`3fA1/01`3fA1/00`000000mT@K0?I4
6`070?I46`030000003fA1/0mT@K00H0mT@K00<000000=Tj5`3I>QL00`3I>QL503YCY`030000003o
ool0oooo00T0oooo00<000000?ooo`3oool02`3oool000`0oooo00<000000?ooo`3oool02P3oool0
0`000000;T2302i0P`0>02i0P`030000000^@8<0;T2300d0;T2300<0000002i0P`0^@8<03P0^@8<0
0`000000;T2300000003000000`0<dRC00<0000003=8T`0cB9<0400cB9<00`000000<dRC03=8T`0A
03=8T`030000000cB9<0<dRC0140<dRC00<0000003=8T`0cB9<04@0cB9<00`000000<dRC03=8T`0B
03=8T`030000000cB9<0<dRC01<0<dRC00<0000003=8T`0cB9<04`0cB9<00`000000<dRC00000003
00000180=dnO00<0000003M?W`0gCil05@0gCil00`000000=dnO03M?W`0903M?W`030000003oCQl0
odhO0080odhO1@0gCil00`000000=dnO000000040?m>7`030000003oCQl0odhO00h0odhO00@00000
0?m>7`00000000002`3oBQh00`000000odXN0?m:7P0<0?m:7P030000003oBQh0odXN00/0odXN00<0
00000?m:7P3oBQh02P3oBQh00`000000odXN0?m:7P0:0?m:7P030000003oBQh0odXN00D0odXN0P00
00020?I46`030000003fA1/0mT@K00P0mT@K00<000000?I46`3fA1/01`3fA1/00`000000mT@K0?I4
6`070?I46`030000003fA1/0mT@K00L0mT@K00<000000?I46`3fA1/01P3fA1/3000000@0fCXG100j
DjL00`000000oooo0?ooo`090?ooo`030000003oool0oooo00/0oooo000<0?ooo`030000003oool0
oooo00X0oooo00<0000002i0P`0^@8<03@0^@8<00`000000;T2302i0P`0>02i0P`030000000^@8<0
;T2300`0;T231000000@03=8T`030000000cB9<0<dRC0100<dRC00<0000003=8T`0cB9<04@0cB9<0
0`000000<dRC03=8T`0A03=8T`030000000cB9<0<dRC0140<dRC00<0000003=8T`0cB9<04`0cB9<0
0`000000<dRC03=8T`0B03=8T`030000000cB9<0<dRC0140<dRC1000000F03M?W`030000000gCil0
=dnO01D0=dnO00<0000003M?W`0gCil02@0gCil00`000000odhO0?m>7`020?m>7`D0=dnO00@00000
03M?W`0gCil000000`3oCQl00`000000odhO0?m>7`0=0?m>7`030000003oCQl0odhO0080odhO0P00
00090?m:7P030000003oBQh0odXN00`0odXN00<000000?m:7P3oBQh02P3oBQh00`000000odXN0?m:
7P0;0?m:7P030000003oBQh0odXN00X0odXN00<000000?m:7P3oBQh01`3oBQh3000000X0mT@K00<0
00000?I46`3fA1/01`3fA1/00`000000mT@K0?I46`070?I46`030000003fA1/0mT@K00L0mT@K00<0
00000?I46`3fA1/01P3fA1/010000000mT@K0?I46`0000030=Tj5`D0>U>W00<000000?ooo`3oool0
203oool00`000000oooo0?ooo`0;0?ooo`00303oool00`000000oooo0?ooo`0:0?ooo`030000000^
@8<0;T2300d0;T2300<0000002i0P`0^@8<03@0^@8<00`000000;T2302i0P`0902i0P`@000000P0c
B9<00`000000<dRC03=8T`0?03=8T`030000000cB9<0<dRC0140<dRC00<0000003=8T`0cB9<0400c
B9<00`000000<dRC03=8T`0A03=8T`030000000cB9<0<dRC0140<dRC00<0000003=8T`0cB9<04`0c
B9<00`000000<dRC03=8T`0B03=8T`030000000cB9<0<dRC00/0<dRC1P00000203M?W`030000000g
Cil0=dnO01D0=dnO00<0000003M?W`0gCil05@0gCil00`000000=dnO03M?W`0803M?W`030000003o
CQl0odhO00<0odhO1@0gCil010000000=dnO03M?W`0000020?m>7`030000003oCQl0odhO00h0odhO
00<000000?m>7`3oCQl0103oCQl2000000L0odXN00<000000?m:7P3oBQh0303oBQh00`000000odXN
0?m:7P0:0?m:7P030000003oBQh0odXN00/0odXN00<000000?m:7P3oBQh02P3oBQh00`000000odXN
0?m:7P090?m:7P030000003fA1/0mT@K00P0mT@K00<000000?I46`3fA1/01`3fA1/00`000000mT@K
0?I46`070?I46`030000003fA1/0mT@K00L0mT@K00<000000?I46`3fA1/01P3fA1/010000000mT@K
0?I46`3fA1/200000080fCXG100jDjL00`000000oooo0?ooo`080?ooo`030000003oool0oooo00/0
oooo000<0?ooo`030000003oool0oooo00T0oooo00<000000?m87@0^@8<03P0^@8<00`000000;T23
02i0P`0=02i0P`030000000^@8<0;T2300@0;T231@00000603=8T`030000000cB9<0<dRC00l0<dRC
00<0000003=8T`0cB9<04@0cB9<00`000000<dRC03=8T`0@03=8T`030000000cB9<0<dRC0140<dRC
00<0000003=8T`0cB9<04@0cB9<00`000000<dRC03=8T`0C03=8T`030000000cB9<0<dRC0180<dRC
00<0000003=8T`0cB9<01P0cB9<5000000P0=dnO00<0000003M?W`0gCil05@0gCil00`000000=dnO
03M?W`0E03M?W`030000000gCil0=dnO00P0=dnO00<000000?m>7`3oCQl00`3oCQl503M?W`040000
000gCil0=dnO00000080odhO00<000000?m>7`3oCQl03P3oCQl00`000000odhO0?m>7`060?m>7`80
00001@3oBQh00`000000odXN0?m:7P0<0?m:7P030000003oBQh0odXN00X0odXN00<000000?m:7P3o
BQh02`3oBQh00`000000odXN0?m:7P0:0?m:7P030000003oBQh0odXN00T0odXN0`0000080?I46`03
0000003fA1/0mT@K00L0mT@K00<000000?I46`3fA1/01`3fA1/00`000000mT@K0?I46`080?I46`03
0000003fA1/0mT@K00H0mT@K00<000000?I46`3fA1/00P3fA1/2000000<0>U>W0P00000:0?ooo`03
0000003oool0oooo00/0oooo000<0?ooo`030000003oool0oooo00T0oooo00<000000?m87@0^@8<0
3P0^@8<00`000000;T2302i0P`0=02i0P`030000000^@8<0;T2300@000002`0cB9<00`000000<dRC
03=8T`0?03=8T`030000000cB9<0<dRC0140<dRC00<0000003=8T`0cB9<0400cB9<00`000000<dRC
03=8T`0A03=8T`030000000cB9<0<dRC0140<dRC00<0000003=8T`0cB9<04`0cB9<00`000000<dRC
03=8T`0B03=8T`030000000cB9<0<dRC00H000003P0gCil00`000000=dnO03M?W`0E03M?W`030000
000gCil0=dnO01@0=dnO00<0000003M?W`0gCil0200gCil00`000000odhO0?m>7`030?m>7`D0=dnO
00@0000003M?W`0gCil000000P3oCQl00`000000odhO0?m>7`0>0?m>7`030000003oCQl0odhO00P0
odhO0P0000030?m:7P030000003oBQh0odXN00/0odXN00<000000?m:7P3oBQh02`3oBQh00`000000
odXN0?m:7P0;0?m:7P030000003oBQh0odXN00T0odXN00<000000?m:7P3oBQh02P3oBQh00`000000
odXN0?m:7P02000000H0mT@K00<000000?I46`3fA1/01`3fA1/00`000000mT@K0?I46`080?I46`03
0000003fA1/0mT@K00L0mT@K00<000000?I46`3fA1/01P3fA1/00`000000mT@K0?I46`040?I46`<0
000000<0=dnN0000003oool02@3oool00`000000oooo0?ooo`0;0?ooo`002`3oool00`000000oooo
0?ooo`0:0?ooo`030000000^@8<0;T2300h0;T2300<0000002i0P`0^@8<0300^@8<4000000l0<dRC
00<0000003=8T`0cB9<03`0cB9<00`000000<dRC03=8T`0A03=8T`030000000cB9<0<dRC0100<dRC
00<0000003=8T`0cB9<04@0cB9<00`000000<dRC03=8T`0A03=8T`030000000cB9<0<dRC01<0<dRC
00<0000003=8T`0cB9<0400cB9<5000001@0=dnO00<0000003M?W`0gCil05@0gCil00`000000=dnO
03M?W`0E03M?W`030000000gCil0=dnO00H0=dnO00<000000?m>7`3oCQl0103oCQl503M?W`040000
000gCil0=dnO00000080odhO00<000000?m>7`3oCQl03@3oCQl00`000000odhO0?m>7`0;0?m>7`80
000000<0odXN0000003oBQh0303oBQh00`000000odXN0?m:7P0;0?m:7P030000003oBQh0odXN00/0
odXN00<000000?m:7P3oBQh02@3oBQh00`000000odXN0?m:7P0:0?m:7P030000003oBQh0odXN0080
odXN0P0000050?I46`030000003fA1/0mT@K00L0mT@K00<000000?I46`3fA1/01`3fA1/00`000000
mT@K0?I46`070?I46`030000003fA1/0mT@K00H0mT@K00<000000?I46`3fA1/01@3fA1/303M?WP03
0000003oool0oooo00P0oooo00<000000?ooo`3oool02`3oool000/0oooo00<000000?ooo`3oool0
2P3oool00`000000;T2302i0P`0>02i0P`030000000^@8<0;T2300P0;T23100000000`0cB9<00000
03=8T`0@03=8T`030000000cB9<0<dRC0100<dRC00<0000003=8T`0cB9<0400cB9<00`000000<dRC
03=8T`0@03=8T`030000000cB9<0<dRC0140<dRC00<0000003=8T`0cB9<04P0cB9<00`000000<dRC
03=8T`0B03=8T`030000000cB9<0<dRC00`0<dRC1000000203M?W`030000000gCil0=dnO01@0=dnO
00<0000003M?W`0gCil05@0gCil00`000000=dnO03M?W`0E03M?W`030000000gCil0=dnO00H0=dnO
00<000000?m>7`3oCQl0103oCQl503M?W`060000000gCil0=dnO0000003oCQl00000403oCQl00`00
0000odhO0?m>7`0=0?m>7`8000003@3oBQh00`000000odXN0?m:7P0;0?m:7P030000003oBQh0odXN
00/0odXN00<000000?m:7P3oBQh02@3oBQh00`000000odXN0?m:7P0:0?m:7P030000003oBQh0odXN
00@0odXN0P0000030?I46`030000003fA1/0mT@K00L0mT@K00<000000?I46`3fA1/01`3fA1/00`00
0000mT@K0?I46`070?I46`030000003fA1/0mT@K00H0mT@K00<000000?I46`3fA1/01@3fA1/303M?
WP030000003oool0oooo00P0oooo00<000000?ooo`3oool02`3oool000/0oooo00<000000?ooo`3o
ool02P3oool00`000000;T2302i0P`0=02i0P`030000000^@8<0;T2300H0;T230`00000503=8T`03
0000000cB9<0<dRC00l0<dRC00<0000003=8T`0cB9<0400cB9<00`000000<dRC03=8T`0@03=8T`03
0000000cB9<0<dRC0100<dRC00<0000003=8T`0cB9<04@0cB9<00`000000<dRC03=8T`0B03=8T`03
0000000cB9<0<dRC0180<dRC00<0000003=8T`0cB9<0200cB9<4000000H0=dnO00<0000003M?W`0g
Cil0500gCil00`000000=dnO03M?W`0E03M?W`030000000gCil0=dnO01D0=dnO00<0000003M?W`0g
Cil01P0gCil00`000000odhO0?m>7`040?m>7`D0=dnO00@0000003M?W`0gCil0=dnO0P00000@0?m>
7`030000003oCQl0odhO00h0odhO0`00000;0?m:7P030000003oBQh0odXN00/0odXN00<000000?m:
7P3oBQh02`3oBQh00`000000odXN0?m:7P090?m:7P030000003oBQh0odXN00X0odXN00<000000?m:
7P3oBQh01P3oBQh2000000030?I46`000000mT@K00P0mT@K00<000000?I46`3fA1/01`3fA1/00`00
0000mT@K0?I46`070?I46`030000003fA1/0mT@K00H0mT@K00<000000?I46`3fA1/01@3fA1/303M?
WP030000003oool0oooo00P0oooo00<000000?ooo`3oool02`3oool000/0oooo00<000000?ooo`3o
ool02P3oool00`000000;T2302i0P`0=02i0P`030000000^@8<0;T2300<0;T230`00000803=8T`03
0000000cB9<0<dRC00l0<dRC00<0000003=8T`0cB9<0400cB9<00`000000<dRC03=8T`0@03=8T`03
0000000cB9<0<dRC0100<dRC00<0000003=8T`0cB9<04@0cB9<00`000000<dRC03=8T`0B03=8T`03
0000000cB9<0<dRC0180<dRC00<0000003=8T`0cB9<0100cB9<4000000/0=dnO00<0000003M?W`0g
Cil04`0gCil00`000000=dnO03M?W`0E03M?W`030000000gCil0=dnO01D0=dnO00<0000003M?W`0g
Cil01P0gCil00`000000odhO0?m>7`040?m>7`D0=dnO00@0000003M?W`0gCil0=dnO0P00000@0?m>
7`030000003oCQl0odhO00d0odhO00@000000?m>7`3oCQl0odhO0P0000090?m:7P030000003oBQh0
odXN00/0odXN00<000000?m:7P3oBQh02`3oBQh00`000000odXN0?m:7P090?m:7P030000003oBQh0
odXN00X0odXN00<000000?m:7P3oBQh0203oBQh2000000T0mT@K00<000000?I46`3fA1/01`3fA1/0
0`000000mT@K0?I46`070?I46`030000003fA1/0mT@K00H0mT@K00<000000?I46`3fA1/01@3fA1/3
03M?WP030000003oool0oooo00P0oooo00<000000?ooo`3oool02`3oool000/0oooo00<000000?oo
o`3oool02P3oool00`000000;T2302i0P`0=02i0P`030000000^@8<0000000<000002`0cB9<00`00
0000<dRC03=8T`0?03=8T`030000000cB9<0<dRC0100<dRC00<0000003=8T`0cB9<0400cB9<00`00
0000<dRC03=8T`0@03=8T`030000000cB9<0<dRC0140<dRC00<0000003=8T`0cB9<04P0cB9<00`00
0000<dRC03=8T`0B03=8T`030000000cB9<0<dRC00@000003`0gCil00`000000=dnO03M?W`0C03M?
W`030000000gCil0=dnO01D0=dnO00<0000003M?W`0gCil05@0gCil00`000000=dnO03M?W`0503M?
W`030000003oCQl0odhO00D0odhO1@0gCil010000000=dnO03M?W`0gCil2000000l0odhO00<00000
0?m>7`3oCQl03P3oCQl00`000000odhO0?m>7`030?m>7`8000001`3oBQh00`000000odXN0?m:7P0;
0?m:7P030000003oBQh0odXN00/0odXN00<000000?m:7P3oBQh02@3oBQh00`000000odXN0?m:7P0:
0?m:7P030000003oBQh0odXN00T0odXN0`0000070?I46`030000003fA1/0mT@K00L0mT@K00<00000
0?I46`3fA1/01`3fA1/00`000000mT@K0?I46`070?I46`030000003fA1/0mT@K00D0mT@K0`0gCih0
0`000000oooo0?ooo`070?ooo`030000003oool0oooo00/0oooo000;0?ooo`030000003oool0oooo
00X0oooo00<0000002i0P`0^@8<02`0^@8<4000000l0<dRC00<0000003=8T`0cB9<03`0cB9<00`00
0000<dRC03=8T`0@03=8T`030000000cB9<0<dRC0100<dRC00<0000003=8T`0cB9<0400cB9<00`00
0000<dRC03=8T`0B03=8T`030000000cB9<0<dRC0140<dRC00<0000003=8T`0cB9<0400cB9<50000
01<0=dnO00<0000003M?W`0gCil0500gCil00`000000=dnO03M?W`0E03M?W`030000000gCil0=dnO
01@0=dnO00<0000003M?W`0gCil01@0gCil00`000000odhO0?m>7`050?m>7`D0=dnO00D0000003M?
W`0gCil0=dnO0000000@0?m>7`030000003oCQl0odhO00h0odhO00<000000?m>7`3oCQl01@3oCQl2
000000D0odXN00<000000?m:7P3oBQh02`3oBQh00`000000odXN0?m:7P0;0?m:7P030000003oBQh0
odXN00T0odXN00<000000?m:7P3oBQh02P3oBQh00`000000odXN0?m:7P090?m:7P030000003oBQh0
odXN008000001@3fA1/00`000000mT@K0?I46`080?I46`030000003fA1/0mT@K00L0mT@K00<00000
0?I46`3fA1/01P3fA1/00`000000mT@K0?I46`050?I46`<0=dnN00<000000?ooo`3oool0203oool0
0`000000oooo0?ooo`0:0?ooo`002`3oool00`000000oooo0?ooo`090?ooo`030000000^@8<0;T23
00P0;T231000000203=8T`030000000cB9<0<dRC00h0<dRC00<0000003=8T`0cB9<03`0cB9<00`00
0000<dRC03=8T`0@03=8T`030000000cB9<0<dRC0100<dRC00<0000003=8T`0cB9<0400cB9<00`00
0000<dRC03=8T`0B03=8T`030000000cB9<0<dRC0140<dRC00<0000003=8T`0cB9<0300cB9<40000
0080=dnO00<0000003M?W`0gCil04`0gCil00`000000=dnO03M?W`0D03M?W`030000000gCil0=dnO
01D0=dnO00<0000003M?W`0gCil05@0gCil00`000000=dnO03M?W`0403M?W`030000003oCQl0odhO
00D0odhO1@0gCil01@000000=dnO03M?W`0gCil000000100odhO00<000000?m>7`3oCQl03P3oCQl0
0`000000odhO0?m>7`070?m>7`8000000`3oBQh00`000000odXN0?m:7P0;0?m:7P030000003oBQh0
odXN00/0odXN00<000000?m:7P3oBQh02@3oBQh00`000000odXN0?m:7P090?m:7P030000003oBQh0
odXN00X0odXN00<000000?m:7P3oBQh00P3oBQh2000000@0mT@K00<000000?I46`3fA1/01`3fA1/0
0`000000mT@K0?I46`070?I46`030000003fA1/0mT@K00H0mT@K00<000000?I46`3fA1/01@3fA1/3
03M?WP030000003oool0oooo00P0oooo00<000000?ooo`3oool02P3oool000/0oooo00<000000?oo
o`3oool02@3oool00`000000;T2302i0P`0402i0P`@000001P0cB9<00`000000<dRC03=8T`0>03=8
T`030000000cB9<0<dRC00l0<dRC00<0000003=8T`0cB9<0400cB9<00`000000<dRC03=8T`0@03=8
T`030000000cB9<0<dRC0100<dRC00<0000003=8T`0cB9<04P0cB9<00`000000<dRC03=8T`0A03=8
T`030000000cB9<0<dRC00P0<dRC1000000603M?W`030000000gCil0=dnO01<0=dnO00<0000003M?
W`0gCil0500gCil00`000000=dnO03M?W`0E03M?W`030000000gCil0=dnO01D0=dnO00<0000003M?
W`0gCil0100gCil00`000000odhO0?m>7`050?m>7`D0=dnO00D0000003M?W`0gCil0=dnO0000000@
0?m>7`030000003oCQl0odhO00d0odhO00<000000?m>7`3oCQl02P3oCQl2000000030?m:7P000000
odXN00`0odXN00<000000?m:7P3oBQh02`3oBQh00`000000odXN0?m:7P090?m:7P030000003oBQh0
odXN00T0odXN00<000000?m:7P3oBQh02P3oBQh00`000000odXN0?m:7P040?m:7P8000000P3fA1/0
0`000000mT@K0?I46`070?I46`030000003fA1/0mT@K00L0mT@K00<000000?I46`3fA1/01P3fA1/0
0`000000mT@K0?I46`050?I46`<0=dnN00<000000?ooo`3oool0203oool00`000000oooo0?ooo`0:
0?ooo`002`3oool00`000000oooo0?ooo`090?ooo`030000000^@8<0;T2300@000002P0cB9<00`00
0000<dRC03=8T`0>03=8T`030000000cB9<0<dRC00l0<dRC00<0000003=8T`0cB9<0400cB9<00`00
0000<dRC03=8T`0@03=8T`030000000cB9<0<dRC0100<dRC00<0000003=8T`0cB9<04P0cB9<00`00
0000<dRC03=8T`0A03=8T`030000000cB9<0<dRC00@0<dRC1000000;03M?W`030000000gCil0=dnO
0180=dnO00<0000003M?W`0gCil0500gCil00`000000=dnO03M?W`0E03M?W`030000000gCil0=dnO
01D0=dnO00<0000003M?W`0gCil00`0gCil00`000000odhO0?m>7`060?m>7`D0=dnO00<0000003M?
W`0gCil00P0gCil00`000000odhO0?m>7`0<0?m>7`030000003oCQl0odhO00h0odhO00<000000?m>
7`3oCQl0303oCQl3000000/0odXN00<000000?m:7P3oBQh0303oBQh00`000000odXN0?m:7P090?m:
7P030000003oBQh0odXN00T0odXN00<000000?m:7P3oBQh02P3oBQh00`000000odXN0?m:7P060?m:
7P<000002@3fA1/00`000000mT@K0?I46`070?I46`030000003fA1/0mT@K00H0mT@K00<000000?I4
6`3fA1/01P3fA1/203M?WP030000003oool0oooo00P0oooo00<000000?ooo`3oool02P3oool000/0
oooo00<000000?ooo`3oool02@3oool3000000h0<dRC00<0000003=8T`0cB9<03P0cB9<00`000000
<dRC03=8T`0?03=8T`030000000cB9<0<dRC0100<dRC00<0000003=8T`0cB9<0400cB9<00`000000
<dRC03=8T`0@03=8T`030000000cB9<0<dRC0180<dRC00<0000003=8T`0cB9<04@0cB9<00`000000
<dRC03=8T`04000000l0=dnO00<0000003M?W`0gCil04`0gCil00`000000=dnO03M?W`0C03M?W`03
0000000gCil0=dnO01D0=dnO00<0000003M?W`0gCil05@0gCil00`000000=dnO03M?W`0303M?W`03
0000003oCQl0odhO00D0odhO1P0gCil00`000000=dnO03M?W`0203M?W`030000003oCQl0odhO00`0
odhO00<000000?m>7`3oCQl03P3oCQl00`000000odhO0?m>7`0=0?m>7`040000003oCQl000000000
00T0odXN00<000000?m:7P3oBQh0303oBQh00`000000odXN0?m:7P090?m:7P030000003oBQh0odXN
00T0odXN00<000000?m:7P3oBQh02P3oBQh00`000000odXN0?m:7P080?m:7P800000203fA1/00`00
0000mT@K0?I46`070?I46`030000003fA1/0mT@K00H0mT@K00<000000?I46`3fA1/01P3fA1/203M?
WP030000003oool0oooo00P0oooo00<000000?ooo`3oool02P3oool000/0oooo00<000000?ooo`3o
ool02@3oool00`000000<dRC03=8T`0>03=8T`030000000cB9<0<dRC00h0<dRC00<0000003=8T`0c
B9<03`0cB9<00`000000<dRC03=8T`0@03=8T`030000000cB9<0<dRC0100<dRC00<0000003=8T`0c
B9<04@0cB9<00`000000<dRC03=8T`0A03=8T`030000000cB9<0<dRC00l0<dRC1@00000C03M?W`03
0000000gCil0=dnO01<0=dnO00<0000003M?W`0gCil0500gCil00`000000=dnO03M?W`0D03M?W`03
0000000gCil0=dnO01D0=dnO00<0000003M?W`0gCil00`0gCil00`000000odhO0?m>7`050?m>7`H0
=dnO00<0000003M?W`0gCil00P0gCil00`000000odhO0?m>7`0<0?m>7`030000003oCQl0odhO00h0
odhO00<000000?m>7`3oCQl0303oCQl00`000000odhO0?m>7`020?m>7`8000001`3oBQh00`000000
odXN0?m:7P0<0?m:7P030000003oBQh0odXN00T0odXN00<000000?m:7P3oBQh02@3oBQh00`000000
odXN0?m:7P0:0?m:7P030000003oBQh0odXN00P0odXN00@000000?m:7P00000000001P3fA1/00`00
0000mT@K0?I46`070?I46`030000003fA1/0mT@K00L0mT@K00<000000?I46`3fA1/01@3fA1/203M?
WP030000003oool0oooo00P0oooo00<000000?ooo`3oool02P3oool000/0oooo00<000000?ooo`3o
ool02@3oool00`000000<dRC03=8T`0>03=8T`030000000cB9<0<dRC00h0<dRC00<0000003=8T`0c
B9<03`0cB9<00`000000<dRC03=8T`0@03=8T`030000000cB9<0<dRC0100<dRC00<0000003=8T`0c
B9<04@0cB9<00`000000<dRC03=8T`0A03=8T`030000000cB9<0<dRC00X0<dRC1@00000203M?W`03
0000000gCil0=dnO01<0=dnO00<0000003M?W`0gCil04`0gCil00`000000=dnO03M?W`0D03M?W`03
0000000gCil0=dnO01D0=dnO00<0000003M?W`0gCil0500gCil00`000000=dnO03M?W`0203M?W`03
0000003oCQl0odhO00H0odhO1P0gCil00`000000=dnO03M?W`0203M?W`030000003oCQl0odhO00`0
odhO00<000000?m>7`3oCQl03@3oCQl00`000000odhO0?m>7`0=0?m>7`030000003oCQl0odhO00@0
odhO0P0000050?m:7P030000003oBQh0odXN00/0odXN00<000000?m:7P3oBQh02P3oBQh00`000000
odXN0?m:7P090?m:7P030000003oBQh0odXN00X0odXN00<000000?m:7P3oBQh0203oBQh010000000
odXN0?m:7P3oBQh2000000D0mT@K00<000000?I46`3fA1/01`3fA1/00`000000mT@K0?I46`060?I4
6`030000003fA1/0mT@K00D0mT@K0P0gCih00`000000oooo0?ooo`080?ooo`030000003oool0oooo
00X0oooo000;0?ooo`030000003oool0oooo00T0oooo00<0000003=8T`0cB9<03P0cB9<00`000000
<dRC03=8T`0>03=8T`030000000cB9<0<dRC00l0<dRC00<0000003=8T`0cB9<0400cB9<00`000000
<dRC03=8T`0@03=8T`030000000cB9<0<dRC0140<dRC00<0000003=8T`0cB9<04@0cB9<00`000000
<dRC03=8T`0503=8T`D000001`0gCil00`000000=dnO03M?W`0C03M?W`030000000gCil0=dnO01<0
=dnO00<0000003M?W`0gCil0500gCil00`000000=dnO03M?W`0E03M?W`030000000gCil0=dnO01D0
=dnO00D0000003M?W`0gCil0=dnO000000080?m>7`H0=dnO00<0000003M?W`0gCil00P0gCil00`00
0000odhO0?m>7`0;0?m>7`030000003oCQl0odhO00h0odhO00<000000?m>7`3oCQl03@3oCQl00`00
0000odhO0?m>7`060?m>7`8000000`3oBQh00`000000odXN0?m:7P0;0?m:7P030000003oBQh0odXN
00X0odXN00<000000?m:7P3oBQh02@3oBQh00`000000odXN0?m:7P090?m:7P030000003oBQh0odXN
00T0odXN00<000000?m:7P3oBQh00`3oBQh2000000<0mT@K00<000000?I46`3fA1/01`3fA1/00`00
0000mT@K0?I46`060?I46`030000003fA1/0mT@K00D0mT@K0P0gCih00`000000oooo0?ooo`080?oo
o`030000003oool0oooo00X0oooo000;0?ooo`030000003oool0oooo00T0oooo00<0000003=8T`0c
B9<03P0cB9<00`000000<dRC03=8T`0>03=8T`030000000cB9<0<dRC00l0<dRC00<0000003=8T`0c
B9<0400cB9<00`000000<dRC03=8T`0@03=8T`030000000cB9<0<dRC0140<dRC00<0000003=8T`0c
B9<04@0cB9<00`000000<dRC03=8T`05000000d0=dnO00<0000003M?W`0gCil04P0gCil00`000000
=dnO03M?W`0C03M?W`030000000gCil0=dnO01@0=dnO00<0000003M?W`0gCil05@0gCil00`000000
=dnO03M?W`0E03M?W`050000000gCil0=dnO03M?W`000000203oCQl603M?W`030000000gCil0=dnO
0080=dnO00<000000?m>7`3oCQl02`3oCQl00`000000odhO0?m>7`0>0?m>7`030000003oCQl0odhO
00d0odhO00<000000?m>7`3oCQl0203oCQl2000000030?m:7P000000odXN00`0odXN00<000000?m:
7P3oBQh02P3oBQh00`000000odXN0?m:7P090?m:7P030000003oBQh0odXN00T0odXN00<000000?m:
7P3oBQh02@3oBQh00`000000odXN0?m:7P050?m:7P80000000<0mT@K0000003fA1/0203fA1/00`00
0000mT@K0?I46`060?I46`030000003fA1/0mT@K00H0mT@K00<0=dnN0000003oool02@3oool00`00
0000oooo0?ooo`0:0?ooo`002`3oool00`000000oooo0?ooo`090?ooo`030000000cB9<0<dRC00h0
<dRC00<0000003=8T`0cB9<03P0cB9<00`000000<dRC03=8T`0@03=8T`030000000cB9<0<dRC00l0
<dRC00<0000003=8T`0cB9<0400cB9<00`000000<dRC03=8T`0A03=8T`030000000cB9<0<dRC0100
<dRC1000000B03M?W`030000000gCil0=dnO01<0=dnO00<0000003M?W`0gCil04P0gCil00`000000
=dnO03M?W`0D03M?W`030000000gCil0=dnO01D0=dnO00<0000003M?W`0gCil05@0gCil01@000000
=dnO03M?W`0gCil0000000P0odhO1P0gCil00`000000=dnO03M?W`0303M?W`030000003oCQl0odhO
00X0odhO00<000000?m>7`3oCQl03P3oCQl00`000000odhO0?m>7`0<0?m>7`030000003oCQl0odhO
00/0odhO0`00000<0?m:7P030000003oBQh0odXN00X0odXN00<000000?m:7P3oBQh02@3oBQh00`00
0000odXN0?m:7P090?m:7P030000003oBQh0odXN00T0odXN00<000000?m:7P3oBQh01`3oBQh20000
00T0mT@K00<000000?I46`3fA1/01P3fA1/00`000000mT@K0?I46`060?I46`0303M?WP000000oooo
00T0oooo00<000000?ooo`3oool02P3oool000/0oooo00<000000?ooo`3oool02@3oool00`000000
<dRC03=8T`0>03=8T`030000000cB9<0<dRC00h0<dRC00<0000003=8T`0cB9<0400cB9<00`000000
<dRC03=8T`0?03=8T`030000000cB9<0<dRC0140<dRC00<0000003=8T`0cB9<0400cB9<00`000000
<dRC03=8T`0<03=8T`@0000000<0=dnO0000000gCil04`0gCil00`000000=dnO03M?W`0C03M?W`03
0000000gCil0=dnO01<0=dnO00<0000003M?W`0gCil04`0gCil00`000000=dnO03M?W`0E03M?W`03
0000000gCil0=dnO01D0=dnO00@0000003M?W`0gCil000002@3oCQl603M?W`030000000gCil0=dnO
00<0=dnO00<000000?m>7`3oCQl02P3oCQl00`000000odhO0?m>7`0=0?m>7`030000003oCQl0odhO
00d0odhO00<000000?m>7`3oCQl0303oCQl010000000odhO00000000000:0?m:7P030000003oBQh0
odXN00X0odXN00<000000?m:7P3oBQh02@3oBQh00`000000odXN0?m:7P090?m:7P030000003oBQh0
odXN00T0odXN00<000000?m:7P3oBQh0203oBQh3000000L0mT@K00<000000?I46`3fA1/01P3fA1/0
0`000000mT@K0?I46`060?I46`80=dnN00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`0:
0?ooo`002P3oool00`000000oooo0?ooo`0:0?ooo`030000000cB9<0<dRC00h0<dRC00<0000003=8
T`0cB9<03P0cB9<00`000000<dRC03=8T`0@03=8T`030000000cB9<0<dRC00l0<dRC00<0000003=8
T`0cB9<04@0cB9<00`000000<dRC03=8T`0@03=8T`030000000cB9<0<dRC00P0<dRC1000000503M?
W`030000000gCil0=dnO0180=dnO00<0000003M?W`0gCil04`0gCil00`000000=dnO03M?W`0C03M?
W`030000000gCil0=dnO01@0=dnO00<0000003M?W`0gCil0500gCil00`000000=dnO03M?W`0E03M?
W`040000000gCil0=dnO000000T0odhO1P0gCil00`000000=dnO03M?W`0303M?W`030000003oCQl0
odhO00T0odhO00<000000?m>7`3oCQl03P3oCQl00`000000odhO0?m>7`0=0?m>7`030000003oCQl0
odhO00`0odhO00@000000?m>7`3oCQl0odhO0P0000080?m:7P030000003oBQh0odXN00X0odXN00<0
00000?m:7P3oBQh02@3oBQh00`000000odXN0?m:7P090?m:7P030000003oBQh0odXN00T0odXN00<0
00000?m:7P3oBQh0203oBQh00`000000odXN0?m:7P02000000D0mT@K00<000000?I46`3fA1/01`3f
A1/00`000000mT@K0?I46`050?I46`80=dnN00<000000?ooo`3oool01`3oool00`000000oooo0?oo
o`0:0?ooo`002P3oool00`000000oooo0?ooo`0:0?ooo`030000000cB9<0<dRC00h0<dRC00<00000
03=8T`0cB9<03P0cB9<00`000000<dRC03=8T`0@03=8T`030000000cB9<0<dRC00l0<dRC00<00000
03=8T`0cB9<04@0cB9<00`000000<dRC03=8T`0@03=8T`030000000cB9<0<dRC00@0<dRC10000009
03M?W`030000000gCil0=dnO0180=dnO00<0000003M?W`0gCil04`0gCil00`000000=dnO03M?W`0C
03M?W`030000000gCil0=dnO01@0=dnO00<0000003M?W`0gCil05@0gCil00`000000=dnO03M?W`0D
03M?W`040000000gCil0=dnO000000T0odhO1P0gCil00`000000=dnO03M?W`0303M?W`030000003o
CQl0odhO00T0odhO00<000000?m>7`3oCQl03P3oCQl00`000000odhO0?m>7`0=0?m>7`030000003o
CQl0odhO00/0odhO00<000000?m>7`3oCQl0103oCQl3000000D0odXN00<000000?m:7P3oBQh02@3o
BQh00`000000odXN0?m:7P0:0?m:7P030000003oBQh0odXN00T0odXN00<000000?m:7P3oBQh02@3o
BQh00`000000odXN0?m:7P080?m:7P030000003oBQh0odXN0080odXN0P0000040?I46`030000003f
A1/0mT@K00H0mT@K00<000000?I46`3fA1/01P3fA1/00`0gCih000000?ooo`080?ooo`030000003o
ool0oooo00X0oooo000:0?ooo`030000003oool0oooo00X0oooo00<0000003=8T`0cB9<03P0cB9<0
0`000000<dRC03=8T`0>03=8T`030000000cB9<0<dRC0100<dRC00<0000003=8T`0cB9<03`0cB9<0
0`000000<dRC03=8T`0A03=8T`030000000cB9<0<dRC0100<dRC00<0000003=8T`0cB9<01000000>
03M?W`030000000gCil0=dnO0140=dnO00<0000003M?W`0gCil04`0gCil00`000000=dnO03M?W`0C
03M?W`030000000gCil0=dnO01@0=dnO00<0000003M?W`0gCil05@0gCil00`000000=dnO03M?W`0E
03M?W`030000000gCil0odhO00T0odhO1P0gCil00`000000=dnO03M?W`0303M?W`030000003oCQl0
odhO00T0odhO00<000000?m>7`3oCQl03P3oCQl00`000000odhO0?m>7`0<0?m>7`030000003oCQl0
odhO00`0odhO00<000000?m>7`3oCQl01`3oCQl2000000<0odXN00<000000?m:7P3oBQh02@3oBQh0
0`000000odXN0?m:7P0:0?m:7P030000003oBQh0odXN00T0odXN00<000000?m:7P3oBQh0203oBQh0
0`000000odXN0?m:7P090?m:7P030000003oBQh0odXN00@0odXN0P0000020?I46`030000003fA1/0
mT@K00H0mT@K00<000000?I46`3fA1/01P3fA1/00`0gCih000000?ooo`080?ooo`030000003oool0
oooo00X0oooo000:0?ooo`030000003oool0oooo00X0oooo00<000000?M5700cB9<03P0cB9<00`00
0000<dRC03=8T`0?03=8T`030000000cB9<0<dRC00l0<dRC00<0000003=8T`0cB9<0400cB9<00`00
0000<dRC03=8T`0@03=8T`030000000cB9<0<dRC00h0<dRC1@00000B03M?W`030000000gCil0=dnO
0180=dnO00<0000003M?W`0gCil04`0gCil00`000000=dnO03M?W`0B03M?W`030000000gCil0=dnO
01@0=dnO00<0000003M?W`0gCil05@0gCil00`000000=dnO03M?W`0E03M?W`8000002P3oCQl603M?
W`030000000gCil0=dnO00<0=dnO00<000000?m>7`3oCQl02@3oCQl00`000000odhO0?m>7`0=0?m>
7`030000003oCQl0odhO00d0odhO00<000000?m>7`3oCQl0303oCQl00`000000odhO0?m>7`090?m>
7`80000000<0odXN0000003oBQh02P3oBQh00`000000odXN0?m:7P0:0?m:7P030000003oBQh0odXN
00T0odXN00<000000?m:7P3oBQh0203oBQh00`000000odXN0?m:7P090?m:7P030000003oBQh0odXN
00H0odXN0`0000080?I46`030000003fA1/0mT@K00H0mT@K00<0=dnN0000003oool0203oool00`00
0000oooo0?ooo`0:0?ooo`002P3oool00`000000oooo0?ooo`0:0?ooo`030000003gAA`0<dRC00h0
<dRC00<0000003=8T`0cB9<03`0cB9<00`000000<dRC03=8T`0?03=8T`030000000cB9<0<dRC0100
<dRC00<0000003=8T`0cB9<0400cB9<00`000000<dRC03=8T`0903=8T`D000000P0gCil00`000000
=dnO03M?W`0B03M?W`030000000gCil0=dnO0180=dnO00<0000003M?W`0gCil04`0gCil00`000000
=dnO03M?W`0B03M?W`030000000gCil0=dnO01@0=dnO00<0000003M?W`0gCil05@0gCil00`000000
=dnO03M?W`0E03M?W`<000002@3oCQl603M?W`030000000gCil0=dnO00@0=dnO00<000000?m>7`3o
CQl01`3oCQl00`000000odhO0?m>7`0>0?m>7`030000003oCQl0odhO00d0odhO00<000000?m>7`3o
CQl0303oCQl00`000000odhO0?m>7`0;0?m>7`8000002`3oBQh00`000000odXN0?m:7P0:0?m:7P03
0000003oBQh0odXN00T0odXN00<000000?m:7P3oBQh0203oBQh00`000000odXN0?m:7P090?m:7P03
0000003oBQh0odXN00P0odXN00<000000?I46`3fA1/01P3fA1/00`000000mT@K0?I46`060?I46`03
03M?WP000000oooo00P0oooo00<000000?ooo`3oool02P3oool000X0oooo00<000000?ooo`3oool0
2P3oool00`000000mdDL03=8T`0>03=8T`030000000cB9<0<dRC00l0<dRC00<0000003=8T`0cB9<0
3`0cB9<00`000000<dRC03=8T`0@03=8T`030000000cB9<0<dRC0100<dRC00<0000003=8T`0cB9<0
1@0cB9<4000000L0=dnO00<0000003M?W`0gCil04P0gCil00`000000=dnO03M?W`0B03M?W`030000
000gCil0=dnO01<0=dnO00<0000003M?W`0gCil04`0gCil00`000000=dnO03M?W`0C03M?W`030000
000gCil0=dnO01D0=dnO00<0000003M?W`0gCil05@0gCil2000000030?m@8@000000000000L0odhO
1P0gCil00`000000=dnO03M?W`0403M?W`030000003oCQl0odhO00L0odhO00<000000?m>7`3oCQl0
3P3oCQl00`000000odhO0?m>7`0=0?m>7`030000003oCQl0odhO00/0odhO00<000000?m>7`3oCQl0
3@3oCQl3000000T0odXN00<000000?m:7P3oBQh02P3oBQh00`000000odXN0?m:7P090?m:7P030000
003oBQh0odXN00P0odXN00<000000?m:7P3oBQh02@3oBQh00`000000odXN0?m:7P080?m:7P<00000
1P3fA1/00`000000mT@K0?I46`060?I46`0303M?WP000000oooo00T0oooo00<000000?ooo`3oool0
2@3oool000X0oooo00<000000?ooo`3oool02P3oool00`000000mdDL03=8T`0>03=8T`030000000c
B9<0<dRC00l0<dRC00<0000003=8T`0cB9<03`0cB9<00`000000<dRC03=8T`0@03=8T`030000000c
B9<0<dRC0100<dRC00<0000003=8T`0cB9<01@00000<03M?W`030000000gCil0=dnO0140=dnO00<0
000003M?W`0gCil04P0gCil00`000000=dnO03M?W`0C03M?W`030000000gCil0=dnO01<0=dnO00<0
000003M?W`0gCil0500gCil00`000000=dnO03M?W`0D03M?W`030000000gCil0=dnO01D0=dnO00<0
00000?m@8@3oD2400P3oD243000000@0odhO1P0gCil010000000=dnO03M?W`0gCil4000000T0odhO
00<000000?m>7`3oCQl03P3oCQl00`000000odhO0?m>7`0<0?m>7`030000003oCQl0odhO00`0odhO
00<000000?m>7`3oCQl0303oCQl010000000odhO0?m>7`3oCQl2000000L0odXN00<000000?m:7P3o
BQh02P3oBQh00`000000odXN0?m:7P090?m:7P030000003oBQh0odXN00P0odXN00<000000?m:7P3o
BQh02@3oBQh00`000000odXN0?m:7P080?m:7P030000003oBQh0odXN008000001@3fA1/00`000000
mT@K0?I46`060?I46`030000003oool0oooo00P0oooo00<000000?ooo`3oool02@3oool000X0oooo
00<000000?ooo`3oool02P3oool00`000000mdDL03=8T`0?03=8T`030000000cB9<0<dRC00h0<dRC
00<0000003=8T`0cB9<03`0cB9<00`000000<dRC03=8T`0@03=8T`030000000cB9<0<dRC00h0<dRC
1@00000A03M?W`030000000gCil0=dnO0140=dnO00<0000003M?W`0gCil04P0gCil00`000000=dnO
03M?W`0C03M?W`030000000gCil0=dnO01<0=dnO00<0000003M?W`0gCil0500gCil00`000000=dnO
03M?W`0E03M?W`030000000gCil0=dnO01@0=dnO00<000000?m@8@3oD2401@3oD24200000080odhO
0`0gCil7000000<0>UF[00<000000?m>7`3oCQl01`3oCQl00`000000odhO0?m>7`0=0?m>7`030000
003oCQl0odhO00d0odhO00<000000?m>7`3oCQl0303oCQl00`000000odhO0?m>7`0<0?m>7`030000
003oCQl0odhO00<0odhO0P0000050?m:7P030000003oBQh0odXN00X0odXN00<000000?m:7P3oBQh0
2@3oBQh00`000000odXN0?m:7P080?m:7P030000003oBQh0odXN00P0odXN00<000000?m:7P3oBQh0
2@3oBQh00`000000odXN0?m:7P020?m:7P8000000`3fA1/00`000000mT@K0?I46`060?I46`030000
003oool0oooo00P0oooo00<000000?ooo`3oool02@3oool000X0oooo00<000000?ooo`3oool02P3o
ool00`000000mdDL03=8T`0?03=8T`030000000cB9<0<dRC00h0<dRC00<0000003=8T`0cB9<03`0c
B9<00`000000<dRC03=8T`0@03=8T`030000000cB9<0<dRC00T0<dRC1@00000203M?W`030000000g
Cil0=dnO0140=dnO00<0000003M?W`0gCil04P0gCil00`000000=dnO03M?W`0B03M?W`030000000g
Cil0=dnO0180=dnO00<0000003M?W`0gCil04`0gCil00`000000=dnO03M?W`0D03M?W`030000000g
Cil0=dnO01D0=dnO00<0000003M?W`0gCil04`0gCil00`000000oe0Q0?m@8@080?m@8@D000000`0j
EJ/00`000000>UF[03YEZ`0503YEZ`030000003oCQl0odhO00D0odhO00<000000?m>7`3oCQl03P3o
CQl00`000000odhO0?m>7`0=0?m>7`030000003oCQl0odhO00`0odhO00<000000?m>7`3oCQl0303o
CQl00`000000odhO0?m>7`050?m>7`8000000`3oBQh00`000000odXN0?m:7P090?m:7P030000003o
BQh0odXN00X0odXN00<000000?m:7P3oBQh0203oBQh00`000000odXN0?m:7P080?m:7P030000003o
BQh0odXN00T0odXN00<000000?m:7P3oBQh0103oBQh2000000030?I46`000000mT@K00L0mT@K00<0
00000?ooo`3oool0203oool00`000000oooo0?ooo`090?ooo`002P3oool00`000000oooo0?ooo`0:
0?ooo`030000003gAA`0<dRC00l0<dRC00<0000003=8T`0cB9<03P0cB9<00`000000<dRC03=8T`0?
03=8T`030000000cB9<0<dRC0100<dRC00<0000003=8T`0cB9<01@0cB9<4000000L0=dnO00<00000
03M?W`0gCil04@0gCil00`000000=dnO03M?W`0B03M?W`030000000gCil0=dnO0180=dnO00<00000
03M?W`0gCil04`0gCil00`000000=dnO03M?W`0B03M?W`030000000gCil0=dnO01@0=dnO00<00000
03M?W`0gCil05@0gCil00`000000=dnO03M?W`0C03M?W`030000003oD240oe0Q00T0oe0Q200jEJ/0
0`000000>UF[03YEZ`0403YEZ`030000003oCQl0odhO00D0odhO00<000000?m>7`3oCQl03P3oCQl0
0`000000odhO0?m>7`0=0?m>7`030000003oCQl0odhO00/0odhO00<000000?m>7`3oCQl03@3oCQl0
0`000000odhO0?m>7`070?m>7`80000000<0odXN0000003oBQh02P3oBQh00`000000odXN0?m:7P0:
0?m:7P030000003oBQh0odXN00P0odXN00<000000?m:7P3oBQh0203oBQh00`000000odXN0?m:7P09
0?m:7P030000003oBQh0odXN00H0odXN0P0000080?I46`0303M?WP000000oooo00P0oooo00<00000
0?ooo`3oool02@3oool000X0oooo00<000000?ooo`3oool02P3oool200000100<dRC00<0000003=8
T`0cB9<03P0cB9<00`000000<dRC03=8T`0?03=8T`030000000cB9<0<dRC0100<dRC00<0000003=8
T`0cB9<01@00000;03M?W`030000000gCil0=dnO0140=dnO00<0000003M?W`0gCil04P0gCil00`00
0000=dnO03M?W`0B03M?W`030000000gCil0=dnO01<0=dnO00<0000003M?W`0gCil04`0gCil00`00
0000=dnO03M?W`0C03M?W`030000000gCil0=dnO01D0=dnO00<0000003M?W`0gCil04P0gCil00`00
0000oe0Q0?m@8@0:0?m@8@P0>UF[00<0000003YEZ`0jEJ/0100jEJ/00`000000odhO0?m>7`050?m>
7`030000003oCQl0odhO00h0odhO00<000000?m>7`3oCQl0303oCQl00`000000odhO0?m>7`0<0?m>
7`030000003oCQl0odhO00`0odhO00<000000?m>7`3oCQl02P3oCQl2000000/0odXN00<000000?m:
7P3oBQh02P3oBQh00`000000odXN0?m:7P080?m:7P030000003oBQh0odXN00P0odXN00<000000?m:
7P3oBQh02@3oBQh00`000000odXN0?m:7P070?m:7P<000001P3fA1/2000000T0oooo00<000000?oo
o`3oool02@3oool000X0oooo00<000000?ooo`3oool02P3oool200000100<dRC00<0000003=8T`0c
B9<03P0cB9<00`000000<dRC03=8T`0?03=8T`030000000cB9<0<dRC00h0<dRC1@00000A03M?W`03
0000000gCil0=dnO0140=dnO00<0000003M?W`0gCil04@0gCil00`000000=dnO03M?W`0B03M?W`03
0000000gCil0=dnO01<0=dnO00<0000003M?W`0gCil04`0gCil00`000000=dnO03M?W`0D03M?W`03
0000000gCil0=dnO01@0=dnO00<0000003M?W`0gCil03`0gCil4000000`0oe0Q200jEJ/00`000000
>UF[03YEZ`0503YEZ`030000003oCQl0odhO00@0odhO00<000000?m>7`3oCQl03@3oCQl00`000000
odhO0?m>7`0=0?m>7`030000003oCQl0odhO00`0odhO00<000000?m>7`3oCQl0303oCQl00`000000
odhO0?m>7`0;0?m>7`<000002@3oBQh00`000000odXN0?m:7P0:0?m:7P030000003oBQh0odXN00P0
odXN00<000000?m:7P3oBQh0203oBQh00`000000odXN0?m:7P090?m:7P030000003oBQh0odXN00L0
odXN00<000000?m:7P3oBQh00P0000040?I46`8000002@3oool00`000000oooo0?ooo`090?ooo`00
2P3oool00`000000oooo0?ooo`0:0?ooo`800000400cB9<00`000000<dRC03=8T`0>03=8T`030000
000cB9<0<dRC00l0<dRC00<0000003=8T`0cB9<02@0cB9<500000080=dnO00<0000003M?W`0gCil0
4@0gCil00`000000=dnO03M?W`0A03M?W`030000000gCil0=dnO0140=dnO00<0000003M?W`0gCil0
4P0gCil00`000000=dnO03M?W`0C03M?W`030000000gCil0=dnO01<0=dnO00<0000003M?W`0gCil0
500gCil00`000000=dnO03M?W`0D03M?W`030000000gCil0=dnO00X0=dnO1@00000303YEZ`030000
003oD240oe0Q00X0oe0Q200jEJ/00`000000>UF[03YEZ`0503YEZ`030000003oCQl0odhO00<0odhO
00<000000?m>7`3oCQl03P3oCQl00`000000odhO0?m>7`0=0?m>7`030000003oCQl0odhO00`0odhO
00<000000?m>7`3oCQl0303oCQl00`000000odhO0?m>7`0:0?m>7`040000003oCQl0odhO0?m>7`80
00001`3oBQh00`000000odXN0?m:7P0:0?m:7P030000003oBQh0odXN00P0odXN00<000000?m:7P3o
BQh0203oBQh00`000000odXN0?m:7P090?m:7P030000003oBQh0odXN00L0odXN00<000000?m:7P3o
BQh00P3oBQh2000000<0mT@K00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`090?ooo`00
2P3oool00`000000oooo0?ooo`0:0?ooo`80000000<0mdDL03=8T`0cB9<03@0cB9<00`000000<dRC
03=8T`0>03=8T`030000000cB9<0<dRC00l0<dRC00<0000003=8T`0cB9<01@0cB9<4000000L0=dnO
00<0000003M?W`0gCil04@0gCil00`000000=dnO03M?W`0A03M?W`030000000gCil0=dnO0140=dnO
00<0000003M?W`0gCil04P0gCil00`000000=dnO03M?W`0C03M?W`030000000gCil0=dnO01<0=dnO
00<0000003M?W`0gCil0500gCil00`000000=dnO03M?W`0E03M?W`030000000gCil0=dnO00@0=dnO
1@00000703YEZ`030000003oD240oe0Q00/0oe0Q200jEJ/00`000000>UF[03YEZ`0503YEZ`030000
003oCQl0odhO00<0odhO00<000000?m>7`3oCQl03P3oCQl00`000000odhO0?m>7`0<0?m>7`030000
003oCQl0odhO00`0odhO00<000000?m>7`3oCQl03@3oCQl00`000000odhO0?m>7`0:0?m>7`030000
003oCQl0odhO00<0odhO0P0000050?m:7P030000003oBQh0odXN00X0odXN00<000000?m:7P3oBQh0
203oBQh00`000000odXN0?m:7P080?m:7P030000003oBQh0odXN00P0odXN00<000000?m:7P3oBQh0
203oBQh00`000000odXN0?m:7P040?m:7P80000000<0mT@K0000003oool0203oool00`000000oooo
0?ooo`090?ooo`002P3oool00`000000oooo0?ooo`0:0?ooo`80000000<0mdDL03=8T`0cB9<03@0c
B9<00`000000<dRC03=8T`0>03=8T`030000000cB9<0<dRC00l0<dRC00<0000003=8T`0cB9<01@00
000;03M?W`030000000gCil0=dnO0140=dnO00<0000003M?W`0gCil04@0gCil00`000000=dnO03M?
W`0B03M?W`030000000gCil0=dnO0180=dnO00<0000003M?W`0gCil04P0gCil00`000000=dnO03M?
W`0C03M?W`030000000gCil0=dnO01@0=dnO00<0000003M?W`0gCil05@0gCil00`000000=dnO03M?
W`04000000`0>UF[00<000000?m@8@3oD2402`3oD24803YEZ`030000000jEJ/0>UF[00D0>UF[00<0
00000?m>7`3oCQl00`3oCQl00`000000odhO0?m>7`0>0?m>7`030000003oCQl0odhO00`0odhO00<0
00000?m>7`3oCQl0303oCQl00`000000odhO0?m>7`0<0?m>7`030000003oCQl0odhO00/0odhO00<0
00000?m>7`3oCQl01@3oCQl2000000<0odXN00<000000?m:7P3oBQh02@3oBQh00`000000odXN0?m:
7P090?m:7P030000003oBQh0odXN00P0odXN00<000000?m:7P3oBQh0203oBQh00`000000odXN0?m:
7P080?m:7P030000003oBQh0odXN00H0odXN0P0000090?ooo`030000003oool0oooo00T0oooo000:
0?ooo`030000003oool0oooo00X0oooo0P0000000`3gAA`0<dRC03=8T`0=03=8T`030000000cB9<0
<dRC00h0<dRC00<0000003=8T`0cB9<03P0cB9<400000140=dnO00<0000003M?W`0gCil0400gCil0
0`000000=dnO03M?W`0A03M?W`030000000gCil0=dnO0180=dnO00<0000003M?W`0gCil04P0gCil0
0`000000=dnO03M?W`0C03M?W`030000000gCil0=dnO0180=dnO00<0000003M?W`0gCil0500gCil0
0`000000=dnO03M?W`0C03M?W`D000003`0jEJ/00`000000oe0Q0?m@8@0<0?m@8@P0>UF[00<00000
03YEZ`0jEJ/01P0jEJ/00`000000odhO0?m>7`020?m>7`030000003oCQl0odhO00d0odhO00<00000
0?m>7`3oCQl03@3oCQl00`000000odhO0?m>7`0<0?m>7`030000003oCQl0odhO00`0odhO00<00000
0?m>7`3oCQl02`3oCQl00`000000odhO0?m>7`070?m>7`80000000<0odXN0000003oBQh02P3oBQh0
0`000000odXN0?m:7P090?m:7P030000003oBQh0odXN00P0odXN00<000000?m:7P3oBQh0203oBQh0
0`000000odXN0?m:7P080?m:7P030000003oBQh0odXN00L0odXN00<000000?ooo`3oool01`3oool0
0`000000oooo0?ooo`090?ooo`002@3oool00`000000oooo0?ooo`0;0?ooo`80000000<0mdDL03=8
T`0cB9<03@0cB9<00`000000<dRC03=8T`0>03=8T`030000000cB9<0<dRC00X0<dRC100000000`0g
Cil0000003M?W`0B03M?W`030000000gCil0=dnO0100=dnO00<0000003M?W`0gCil04@0gCil00`00
0000=dnO03M?W`0B03M?W`030000000gCil0=dnO0180=dnO00<0000003M?W`0gCil04`0gCil00`00
0000=dnO03M?W`0C03M?W`030000000gCil0=dnO01<0=dnO00<0000003M?W`0gCil03@0gCil60000
0080>UF[00<0000003YEZ`0jEJ/03`0jEJ/00`000000oe0Q0?m@8@0;0?m@8@T0>UF[00<0000003YE
Z`0jEJ/01P0jEJ/3000000030?m>7`000000odhO00l0odhO00<000000?m>7`3oCQl03@3oCQl00`00
0000odhO0?m>7`0<0?m>7`030000003oCQl0odhO00`0odhO00<000000?m>7`3oCQl02P3oCQl00`00
0000odhO0?m>7`0:0?m>7`8000002`3oBQh00`000000odXN0?m:7P090?m:7P030000003oBQh0odXN
00P0odXN00<000000?m:7P3oBQh0203oBQh00`000000odXN0?m:7P080?m:7P030000003oBQh0odXN
00L0odXN00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`090?ooo`002@3oool00`000000
oooo0?ooo`0;0?ooo`80000000<0mdDL03=8T`0cB9<03@0cB9<00`000000<dRC03=8T`0>03=8T`03
0000000cB9<0<dRC00L0<dRC0`00000503M?W`030000000gCil0=dnO0140=dnO00<0000003M?W`0g
Cil04@0gCil00`000000=dnO03M?W`0A03M?W`030000000gCil0=dnO0140=dnO00<0000003M?W`0g
Cil04P0gCil00`000000=dnO03M?W`0C03M?W`030000000gCil0=dnO01<0=dnO00<0000003M?W`0g
Cil0500gCil00`000000=dnO03M?W`0603M?W`H000002@0jEJ/00`000000>UF[03YEZ`0=03YEZ`03
0000003oD240oe0Q00`0oe0Q2@0jEJ/00`000000>UF[03YEZ`0603YEZ`030000003oD240oe0Q00<0
00003`3oCQl00`000000odhO0?m>7`0<0?m>7`030000003oCQl0odhO00`0odhO00<000000?m>7`3o
CQl0303oCQl00`000000odhO0?m>7`0;0?m>7`030000003oCQl0odhO00/0odhO0`0000090?m:7P03
0000003oBQh0odXN00T0odXN00<000000?m:7P3oBQh0203oBQh00`000000odXN0?m:7P080?m:7P03
0000003oBQh0odXN00P0odXN00<000000?m:7P3oBQh01`3oBQh00`000000oooo0?ooo`070?ooo`03
0000003oool0oooo00T0oooo00090?ooo`030000003oool0oooo00/0oooo0P0000000`3gAA`0<dRC
03=8T`0=03=8T`030000000cB9<0<dRC00h0<dRC00<0000003=8T`0cB9<00`0cB9<4000000T0=dnO
00<0000003M?W`0gCil0400gCil00`000000=dnO03M?W`0A03M?W`030000000gCil0=dnO0140=dnO
00<0000003M?W`0gCil04@0gCil00`000000=dnO03M?W`0B03M?W`030000000gCil0=dnO01<0=dnO
00<0000003M?W`0gCil04`0gCil00`000000=dnO03M?W`0D03M?W`030000000gCil0=dnO00H00000
3`0jEJ/00`000000>UF[03YEZ`0=03YEZ`030000003oD240oe0Q00`0oe0Q2@0jEJ/00`000000>UF[
03YEZ`0703YEZ`050000003oD240oe0Q0000003oD2400P00000=0?m>7`030000003oCQl0odhO00`0
odhO00<000000?m>7`3oCQl0303oCQl00`000000odhO0?m>7`0<0?m>7`030000003oCQl0odhO00/0
odhO00<000000?m>7`3oCQl02`3oCQl00`000000odhO0?m>7`02000000L0odXN00<000000?m:7P3o
BQh02@3oBQh00`000000odXN0?m:7P080?m:7P030000003oBQh0odXN00P0odXN00<000000?m:7P3o
BQh01`3oBQh00`000000odXN0?m:7P080?m:7P030000003oool0oooo00L0oooo00<000000?ooo`3o
ool02@3oool000T0oooo00<000000?ooo`3oool02`3oool2000000030?M5700cB9<0<dRC00d0<dRC
00<0000003=8T`0cB9<03P0cB9<00`000000<dRC00000003000000d0=dnO00<0000003M?W`0gCil0
400gCil00`000000=dnO03M?W`0A03M?W`030000000gCil0=dnO0140=dnO00<0000003M?W`0gCil0
4@0gCil00`000000=dnO03M?W`0C03M?W`030000000gCil0=dnO0180=dnO00<0000003M?W`0gCil0
4`0gCil00`000000=dnO03M?W`0B03M?W`D000005@0jEJ/00`000000>UF[03YEZ`0<03YEZ`030000
003oD240oe0Q00d0oe0Q2@0jEJ/00`000000>UF[03YEZ`0703YEZ`030000003oD240000000@0oe0Q
0P00000:0?m>7`030000003oCQl0odhO00d0odhO00<000000?m>7`3oCQl0303oCQl00`000000odhO
0?m>7`0<0?m>7`030000003oCQl0odhO00/0odhO00<000000?m>7`3oCQl02P3oCQl00`000000odhO
0?m>7`030?m>7`8000001@3oBQh00`000000odXN0?m:7P080?m:7P030000003oBQh0odXN00T0odXN
00<000000?m:7P3oBQh0203oBQh00`000000odXN0?m:7P070?m:7P030000003oBQh0odXN00P0odXN
00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`090?ooo`002@3oool00`000000oooo0?oo
o`0;0?ooo`80000000<0mdDL03=8T`0cB9<03@0cB9<00`000000<dRC03=8T`0<03=8T`@000004@0g
Cil00`000000=dnO03M?W`0@03M?W`030000000gCil0=dnO0140=dnO00<0000003M?W`0gCil04@0g
Cil00`000000=dnO03M?W`0A03M?W`030000000gCil0=dnO01<0=dnO00<0000003M?W`0gCil04`0g
Cil00`000000=dnO03M?W`0B03M?W`030000000gCil0=dnO00h0=dnO1000000203YEZ`030000000j
EJ/0>UF[01H0>UF[00<0000003YEZ`0jEJ/02`0jEJ/00`000000oe0Q0?m@8@0=0?m@8@T0>UF[00<0
000003YEZ`0jEJ/01`0jEJ/00`000000oe0Q000000060?m@8@800000203oCQl00`000000odhO0?m>
7`0=0?m>7`030000003oCQl0odhO00`0odhO00<000000?m>7`3oCQl0303oCQl00`000000odhO0?m>
7`0:0?m>7`030000003oCQl0odhO00/0odhO00<000000?m>7`3oCQl01@3oCQl2000000<0odXN00<0
00000?m:7P3oBQh0203oBQh00`000000odXN0?m:7P090?m:7P030000003oBQh0odXN00P0odXN00<0
00000?m:7P3oBQh01`3oBQh00`000000odXN0?m:7P080?m:7P030000003oool0oooo00L0oooo00<0
00000?ooo`3oool02@3oool000T0oooo00<000000?ooo`3oool02`3oool2000000030?M5700cB9<0
<dRC00d0<dRC00<0000003=8T`0cB9<01P0cB9<600000080=dnO00<0000003M?W`0gCil0400gCil0
0`000000=dnO03M?W`0A03M?W`030000000gCil0=dnO0100=dnO00<0000003M?W`0gCil04@0gCil0
0`000000=dnO03M?W`0B03M?W`030000000gCil0=dnO0180=dnO00<0000003M?W`0gCil04`0gCil0
0`000000=dnO03M?W`0B03M?W`030000000gCil0=dnO00X0=dnO1000000703YEZ`030000000jEJ/0
>UF[01D0>UF[00<0000003YEZ`0jEJ/02`0jEJ/00`000000oe0Q0?m@8@0=0?m@8@T0>UF[00<00000
03YEZ`0jEJ/0200jEJ/00`000000oe0Q0?m@8@070?m@8@8000001P3oCQl00`000000odhO0?m>7`0<
0?m>7`030000003oCQl0odhO00`0odhO00<000000?m>7`3oCQl0303oCQl00`000000odhO0?m>7`0;
0?m>7`030000003oCQl0odhO00/0odhO00<000000?m>7`3oCQl01`3oCQl2000000030?m:7P000000
odXN00T0odXN00<000000?m:7P3oBQh02@3oBQh00`000000odXN0?m:7P080?m:7P030000003oBQh0
odXN00L0odXN00<000000?m:7P3oBQh0203oBQh00`000000oooo0?ooo`070?ooo`030000003oool0
oooo00T0oooo00090?ooo`030000003oool0oooo00`0oooo00<000000?M5700cB9<03P0cB9<00`00
0000<dRC03=8T`06000000P0=dnO00<0000003M?W`0gCil0400gCil00`000000=dnO03M?W`0A03M?
W`030000000gCil0=dnO0100=dnO00<0000003M?W`0gCil04P0gCil00`000000=dnO03M?W`0A03M?
W`030000000gCil0=dnO0180=dnO00<0000003M?W`0gCil04`0gCil00`000000=dnO03M?W`0C03M?
W`030000000gCil0=dnO00@0=dnO1@00000;03YEZ`030000000jEJ/0>UF[01D0>UF[00<0000003YE
Z`0jEJ/02P0jEJ/00`000000oe0Q0?m@8@0>0?m@8@T0>UF[00<0000003YEZ`0jEJ/0200jEJ/00`00
0000oe0Q0?m@8@090?m@8@800000103oCQl00`000000odhO0?m>7`0<0?m>7`030000003oCQl0odhO
00`0odhO00<000000?m>7`3oCQl0303oCQl00`000000odhO0?m>7`0;0?m>7`030000003oCQl0odhO
00/0odhO00<000000?m>7`3oCQl02@3oCQl3000000T0odXN00<000000?m:7P3oBQh02@3oBQh00`00
0000odXN0?m:7P080?m:7P030000003oBQh0odXN00L0odXN00<000000?m:7P3oBQh0203oBQh00`00
0000oooo0?ooo`080?ooo`030000003oool0oooo00P0oooo00090?ooo`030000003oool0oooo00`0
oooo00<000000?M5700cB9<03@0cB9<4000000l0=dnO00<0000003M?W`0gCil0400gCil00`000000
=dnO03M?W`0@03M?W`030000000gCil0=dnO0140=dnO00<0000003M?W`0gCil04@0gCil00`000000
=dnO03M?W`0A03M?W`030000000gCil0=dnO0180=dnO00<0000003M?W`0gCil04`0gCil00`000000
=dnO03M?W`0C03M?W`030000000gCil0=dnO00@00000400jEJ/00`000000>UF[03YEZ`0E03YEZ`03
0000000jEJ/0>UF[00X0>UF[00<000000?m@8@3oD2403P3oD24903YEZ`030000000jEJ/0>UF[00P0
>UF[00<000000?m@8@3oD2402`3oD242000000030?m>7`000000odhO00h0odhO00<000000?m>7`3o
CQl0303oCQl00`000000odhO0?m>7`0<0?m>7`030000003oCQl0odhO00/0odhO00<000000?m>7`3o
CQl02P3oCQl00`000000odhO0?m>7`0;0?m>7`040000003oCQl00000000000L0odXN00<000000?m:
7P3oBQh02@3oBQh00`000000odXN0?m:7P080?m:7P030000003oBQh0odXN00L0odXN00<000000?m:
7P3oBQh0203oBQh00`000000oooo0?ooo`080?ooo`030000003oool0oooo00P0oooo00090?ooo`03
0000003oool0oooo00`0oooo00<000000?M5700cB9<02@0cB9<40000000303M?W`000000=dnO0100
=dnO00<0000003M?W`0gCil0400gCil00`000000=dnO03M?W`0@03M?W`030000000gCil0=dnO0140
=dnO00<0000003M?W`0gCil04@0gCil00`000000=dnO03M?W`0A03M?W`030000000gCil0=dnO01<0
=dnO00<0000003M?W`0gCil04P0gCil00`000000=dnO03M?W`0A03M?W`D000005@0jEJ/00`000000
>UF[03YEZ`0E03YEZ`030000000jEJ/0>UF[00P0>UF[00<000000?m@8@3oD2403P3oD24:03YEZ`03
0000000jEJ/0>UF[00T0>UF[00<000000?m@8@3oD240303oD243000000h0odhO00<000000?m>7`3o
CQl0303oCQl00`000000odhO0?m>7`0<0?m>7`030000003oCQl0odhO00X0odhO00<000000?m>7`3o
CQl02`3oCQl00`000000odhO0?m>7`0;0?m>7`040000003oCQl0odhO0?m>7`8000001@3oBQh00`00
0000odXN0?m:7P080?m:7P030000003oBQh0odXN00T0odXN00<000000?m:7P3oBQh01`3oBQh00`00
0000odXN0?m:7P070?m:7P0303A9U0000000oooo00T0oooo00<000000?ooo`3oool0203oool000T0
oooo00<000000?ooo`3oool0303oool00`000000mdDL03=8T`0503=8T`@000001@0gCil00`000000
=dnO03M?W`0?03M?W`030000000gCil0=dnO0100=dnO00<0000003M?W`0gCil0400gCil00`000000
=dnO03M?W`0A03M?W`030000000gCil0=dnO0140=dnO00<0000003M?W`0gCil04@0gCil00`000000
=dnO03M?W`0C03M?W`030000000gCil0=dnO0180=dnO00<0000003M?W`0gCil0300gCil500000080
>UF[00<0000003YEZ`0jEJ/05@0jEJ/00`000000>UF[03YEZ`0E03YEZ`030000000jEJ/0>UF[00P0
>UF[00<000000?m@8@3oD2403P3oD24:03YEZ`030000000jEJ/0>UF[00T0>UF[00<000000?m@8@3o
D2403@3oD24010000000oe0Q00000000000;0?m>7`030000003oCQl0odhO00`0odhO00<000000?m>
7`3oCQl0303oCQl00`000000odhO0?m>7`0;0?m>7`030000003oCQl0odhO00/0odhO00<000000?m>
7`3oCQl02P3oCQl00`000000odhO0?m>7`040?m>7`8000000`3oBQh00`000000odXN0?m:7P080?m:
7P030000003oBQh0odXN00T0odXN00<000000?m:7P3oBQh01`3oBQh00`000000odXN0?m:7P070?m:
7P0303A9U0000000oooo00T0oooo00<000000?ooo`3oool0203oool000T0oooo00<000000?ooo`3o
ool0303oool010000000mdDL03=8T`0cB9<4000000T0=dnO00<0000003M?W`0gCil03`0gCil00`00
0000=dnO03M?W`0@03M?W`030000000gCil0=dnO0100=dnO00<0000003M?W`0gCil04@0gCil00`00
0000=dnO03M?W`0A03M?W`030000000gCil0=dnO0140=dnO00<0000003M?W`0gCil04`0gCil00`00
0000=dnO03M?W`0C03M?W`030000000gCil0=dnO00D0=dnO1P00000803YEZ`030000000jEJ/0>UF[
01@0>UF[00<0000003YEZ`0jEJ/05@0jEJ/00`000000>UF[03YEZ`0703YEZ`030000003oD240oe0Q
00l0oe0Q2P0jEJ/00`000000>UF[03YEZ`0903YEZ`030000003oD240oe0Q00`0oe0Q00<000000?m@
8@3oD2400P3oD242000000T0odhO00<000000?m>7`3oCQl0303oCQl00`000000odhO0?m>7`0<0?m>
7`030000003oCQl0odhO00/0odhO00<000000?m>7`3oCQl02`3oCQl00`000000odhO0?m>7`0:0?m>
7`030000003oCQl0odhO00H0odhO0P0000000`3oBQh000000?m:7P090?m:7P030000003oBQh0odXN
00T0odXN00<000000?m:7P3oBQh01`3oBQh00`000000odXN0?m:7P070?m:7P0303A9U0000000oooo
00T0oooo00<000000?ooo`3oool0203oool000T0oooo00<000000?ooo`3oool0303oool4000000h0
=dnO00<0000003M?W`0gCil03P0gCil00`000000=dnO03M?W`0@03M?W`030000000gCil0=dnO0140
=dnO00<0000003M?W`0gCil0400gCil00`000000=dnO03M?W`0B03M?W`030000000gCil0=dnO0140
=dnO00<0000003M?W`0gCil04P0gCil00`000000=dnO03M?W`0C03M?W`030000000gCil0=dnO00D0
00003P0jEJ/00`000000>UF[03YEZ`0D03YEZ`030000000jEJ/0>UF[01H0>UF[00<0000003YEZ`0j
EJ/01P0jEJ/00`000000oe0Q0?m@8@0?0?m@8@X0>UF[00<0000003YEZ`0jEJ/02@0jEJ/00`000000
oe0Q0?m@8@0<0?m@8@030000003oD240oe0Q00@0oe0Q0`0000060?m>7`030000003oCQl0odhO00`0
odhO00<000000?m>7`3oCQl0303oCQl00`000000odhO0?m>7`0;0?m>7`030000003oCQl0odhO00X0
odhO00<000000?m>7`3oCQl02`3oCQl00`000000odhO0?m>7`080?m>7`<000002@3oBQh00`000000
odXN0?m:7P090?m:7P030000003oBQh0odXN00L0odXN00<000000?m:7P3oBQh01`3oBQh00`0dBI@0
00000?ooo`090?ooo`030000003oool0oooo00P0oooo00090?ooo`030000003oool0oooo00`0oooo
00<000000>U06P3Y@1X03`0gCil00`000000=dnO03M?W`0?03M?W`030000000gCil0=dnO00l0=dnO
00<0000003M?W`0gCil04@0gCil00`000000=dnO03M?W`0@03M?W`030000000gCil0=dnO0180=dnO
00<0000003M?W`0gCil04@0gCil00`000000=dnO03M?W`0B03M?W`030000000gCil0=dnO0140=dnO
1@00000C03YEZ`030000000jEJ/0>UF[01D0>UF[00<0000003YEZ`0jEJ/05@0jEJ/00`000000>UF[
03YEZ`0603YEZ`030000003oD240oe0Q00l0oe0Q2P0jEJ/00`000000>UF[03YEZ`0:03YEZ`030000
003oD240oe0Q00X0oe0Q00<000000?m@8@3oD240203oD242000000@0odhO00<000000?m>7`3oCQl0
303oCQl00`000000odhO0?m>7`0<0?m>7`030000003oCQl0odhO00X0odhO00<000000?m>7`3oCQl0
2`3oCQl00`000000odhO0?m>7`0;0?m>7`030000003oCQl0odhO00T0odhO00@000000?m>7`000000
00001`3oBQh00`000000odXN0?m:7P090?m:7P030000003oBQh0odXN00L0odXN00<000000?m:7P3o
BQh01`3oBQh00`0dBI@000000?ooo`090?ooo`030000003oool0oooo00P0oooo00090?ooo`030000
003oool0oooo00`0oooo00<000000>U06P3Y@1X03`0gCil00`000000=dnO03M?W`0?03M?W`030000
000gCil0=dnO0100=dnO00<0000003M?W`0gCil0400gCil00`000000=dnO03M?W`0A03M?W`030000
000gCil0=dnO0140=dnO00<0000003M?W`0gCil04@0gCil00`000000=dnO03M?W`0B03M?W`030000
000gCil0=dnO00`0=dnO1@00000203YEZ`030000000jEJ/0>UF[01@0>UF[00<0000003YEZ`0jEJ/0
500jEJ/00`000000>UF[03YEZ`0E03YEZ`030000000jEJ/0>UF[00D0>UF[00<000000?m@8@3oD240
403oD24:03YEZ`030000000jEJ/0>UF[00X0>UF[00<000000?m@8@3oD2402P3oD2400`000000oe0Q
0?m@8@0:0?m@8@80000000<0odhO0000003oCQl03@3oCQl00`000000odhO0?m>7`0<0?m>7`030000
003oCQl0odhO00/0odhO00<000000?m>7`3oCQl02`3oCQl00`000000odhO0?m>7`0:0?m>7`030000
003oCQl0odhO00X0odhO00@000000?m>7`3oCQl0odhO0P0000050?m:7P030000003oBQh0odXN00P0
odXN00<000000?m:7P3oBQh0203oBQh00`000000odXN0?m:7P070?m:7P0303A9U0000000oooo00T0
oooo00<000000?ooo`3oool0203oool000T0oooo00<000000?ooo`3oool0303oool200000080jD0J
3P0gCil00`000000=dnO03M?W`0?03M?W`030000000gCil0=dnO0100=dnO00<0000003M?W`0gCil0
400gCil00`000000=dnO03M?W`0A03M?W`030000000gCil0=dnO0140=dnO00<0000003M?W`0gCil0
4@0gCil00`000000=dnO03M?W`0C03M?W`030000000gCil0=dnO00D0=dnO1P00000803YEZ`030000
000jEJ/0>UF[01<0>UF[00<0000003YEZ`0jEJ/0500jEJ/00`000000>UF[03YEZ`0F03YEZ`030000
000jEJ/0>UF[00@0>UF[00<000000?m@8@3oD240403oD24:03YEZ`030000000jEJ/0>UF[00X0>UF[
00<000000?m@8@3oD2402@3oD2400`000000oe0Q0?m@8@0=0?m@8@<000003@3oCQl00`000000odhO
0?m>7`0<0?m>7`030000003oCQl0odhO00/0odhO00<000000?m>7`3oCQl02`3oCQl00`000000odhO
0?m>7`0:0?m>7`030000003oCQl0odhO00T0odhO00<000000?m>7`3oCQl0103oCQl2000000<0odXN
00<000000?m:7P3oBQh0203oBQh00`000000odXN0?m:7P080?m:7P030000003oBQh0odXN00L0odXN
00<0=4VD0000003oool02@3oool00`000000oooo0?ooo`080?ooo`002@3oool00`000000oooo0?oo
o`0<0?ooo`8000000P3Y@1X>03M?W`030000000gCil0=dnO00l0=dnO00<0000003M?W`0gCil0400g
Cil00`000000=dnO03M?W`0@03M?W`030000000gCil0=dnO0140=dnO00<0000003M?W`0gCil04@0g
Cil00`000000=dnO03M?W`0A03M?W`030000000gCil0=dnO01<0=dnO00<0000003M?W`0gCil01@00
000>03YEZ`030000000jEJ/0>UF[01<0>UF[00<0000003YEZ`0jEJ/05@0jEJ/00`000000>UF[03YE
Z`0E03YEZ`030000000jEJ/0>UF[00<0>UF[00<000000?m@8@3oD2404@3oD24:03YEZ`030000000j
EJ/0>UF[00/0>UF[00<000000?m@8@3oD240203oD2400`000000oe0Q0?m@8@0>0?m@8@030000003o
D2400000008000002P3oCQl00`000000odhO0?m>7`0<0?m>7`030000003oCQl0odhO00/0odhO00<0
00000?m>7`3oCQl02`3oCQl00`000000odhO0?m>7`0:0?m>7`030000003oCQl0odhO00T0odhO00<0
00000?m>7`3oCQl01P3oCQl2000000030?m:7P000000odXN00T0odXN00<000000?m:7P3oBQh0203o
BQh00`000000odXN0?m:7P070?m:7P0303A9U0000000oooo00T0oooo00<000000?ooo`3oool0203o
ool000P0oooo00<000000?ooo`3oool03P3oool010000000jD0J0>U06P3Y@1X=03M?W`030000000g
Cil0=dnO00l0=dnO00<0000003M?W`0gCil0400gCil00`000000=dnO03M?W`0@03M?W`030000000g
Cil0=dnO0140=dnO00<0000003M?W`0gCil04@0gCil00`000000=dnO03M?W`0A03M?W`030000000g
Cil0=dnO0140=dnO1@00000C03YEZ`030000000jEJ/0>UF[01@0>UF[00<0000003YEZ`0jEJ/0500j
EJ/00`000000>UF[03YEZ`0E03YEZ`030000000jEJ/0>UF[00<0>UF[00<000000?m@8@3oD240403o
D2400`000000>UF[03YEZ`0803YEZ`030000000jEJ/0>UF[00/0>UF[00<000000?m@8@3oD2401`3o
D2400`000000oe0Q0?m@8@0>0?m@8@030000003oD240oe0Q00<0oe0Q0P0000080?m>7`030000003o
CQl0odhO00/0odhO00<000000?m>7`3oCQl02`3oCQl00`000000odhO0?m>7`0;0?m>7`030000003o
CQl0odhO00/0odhO00<000000?m>7`3oCQl02@3oCQl00`000000odhO0?m>7`080?m>7`<000002@3o
BQh00`000000odXN0?m:7P080?m:7P030000003oBQh0odXN00L0odXN00<0=4VD0000003oool02@3o
ool00`000000oooo0?ooo`080?ooo`00203oool00`000000oooo0?ooo`0>0?ooo`040000003Y@1X0
jD0J0>U06Ph0=dnO00<0000003M?W`0gCil03`0gCil00`000000=dnO03M?W`0?03M?W`030000000g
Cil0=dnO0140=dnO00<0000003M?W`0gCil0400gCil00`000000=dnO03M?W`0B03M?W`030000000g
Cil0=dnO0140=dnO00<0000003M?W`0gCil02`0gCil500000080>UF[00<0000003YEZ`0jEJ/0500j
EJ/00`000000>UF[03YEZ`0C03YEZ`030000000jEJ/0>UF[01@0>UF[00<0000003YEZ`0jEJ/05P0j
EJ/01@000000>UF[03YEZ`0jEJ/0000001<0oe0Q00<0000003YEZ`0jEJ/0200jEJ/00`000000>UF[
03YEZ`0;03YEZ`030000003oD240oe0Q00L0oe0Q00<000000?m@8@3oD2403P3oD2400`000000oe0Q
0?m@8@050?m@8@<00000103oCQl00`000000odhO0?m>7`0<0?m>7`030000003oCQl0odhO00/0odhO
00<000000?m>7`3oCQl02`3oCQl00`000000odhO0?m>7`0:0?m>7`030000003oCQl0odhO00X0odhO
00<000000?m>7`3oCQl02@3oCQl010000000odhO0000000000070?m:7P030000003oBQh0odXN00P0
odXN00<000000?m:7P3oBQh01P3oBQh203A9U0030000003oool0oooo00P0oooo00<000000?ooo`3o
ool0203oool000P0oooo00<000000?ooo`3oool03P3oool010000000jD0J0>U06P3Y@1X>03M?W`03
0000000gCil0=dnO00l0=dnO00<0000003M?W`0gCil0400gCil00`000000=dnO03M?W`0@03M?W`03
0000000gCil0=dnO0100=dnO00<0000003M?W`0gCil04P0gCil00`000000=dnO03M?W`0A03M?W`03
0000000gCil0=dnO00D0=dnO1P00000803YEZ`030000000jEJ/0>UF[01<0>UF[00<0000003YEZ`0j
EJ/04`0jEJ/00`000000>UF[03YEZ`0E03YEZ`030000000jEJ/0>UF[01D0>UF[00D0000003YEZ`0j
EJ/0>UF[0000000B0?m@8@030000000jEJ/0000000T0>UF[00<0000003YEZ`0jEJ/0300jEJ/00`00
0000oe0Q0?m@8@060?m@8@030000003oD240oe0Q00d0oe0Q00<000000?m@8@3oD2402@3oD2430000
00030?m>7`000000odhO00d0odhO00<000000?m>7`3oCQl02`3oCQl00`000000odhO0?m>7`0;0?m>
7`030000003oCQl0odhO00X0odhO00<000000?m>7`3oCQl02@3oCQl00`000000odhO0?m>7`0:0?m>
7`040000003oCQl0odhO0?m>7`8000001@3oBQh00`000000odXN0?m:7P070?m:7P030000003oBQh0
odXN00L0odXN0P0dBI@00`000000oooo0?ooo`080?ooo`030000003oool0oooo00P0oooo00080?oo
o`030000003oool0oooo00h0oooo00<000000>U06P3Y@1X00P3Y@1X=03M?W`030000000gCil0=dnO
00l0=dnO00<0000003M?W`0gCil0400gCil00`000000=dnO03M?W`0@03M?W`030000000gCil0=dnO
0140=dnO00<0000003M?W`0gCil04@0gCil00`000000=dnO03M?W`0A03M?W`030000000gCil0=dnO
00D000003P0jEJ/00`000000>UF[03YEZ`0C03YEZ`030000000jEJ/0>UF[01@0>UF[00<0000003YE
Z`0jEJ/0500jEJ/00`000000>UF[03YEZ`0E03YEZ`040000000jEJ/0>UF[000001<0oe0Q00<00000
03YEZ`0000002@0jEJ/00`000000>UF[03YEZ`0<03YEZ`030000003oD240oe0Q00D0oe0Q00<00000
0?m@8@3oD2403P3oD2400`000000oe0Q0?m@8@0<0?m@8@<000003@3oCQl00`000000odhO0?m>7`0;
0?m>7`030000003oCQl0odhO00/0odhO00<000000?m>7`3oCQl02P3oCQl00`000000odhO0?m>7`09
0?m>7`030000003oCQl0odhO00T0odhO00<000000?m>7`3oCQl0103oCQl2000000<0odXN00<00000
0?m:7P3oBQh01`3oBQh00`000000odXN0?m:7P070?m:7P80=4VD00<000000?ooo`3oool0203oool0
0`000000oooo0?ooo`080?ooo`00203oool00`000000oooo0?ooo`0>0?ooo`8000000`3Y@1X=03M?
W`030000000gCil0=dnO00l0=dnO00<0000003M?W`0gCil0400gCil00`000000=dnO03M?W`0@03M?
W`030000000gCil0=dnO0140=dnO00<0000003M?W`0gCil04@0gCil00`000000=dnO03M?W`0?03M?
W`D000004`0jEJ/00`000000>UF[03YEZ`0D03YEZ`030000000jEJ/0>UF[01<0>UF[00<0000003YE
Z`0jEJ/0500jEJ/00`000000>UF[03YEZ`0E03YEZ`040000000jEJ/0>UF[00000180oe0Q00@00000
0?m@8@0jEJ/000002@0jEJ/00`000000>UF[03YEZ`0<03YEZ`030000003oD240oe0Q00D0oe0Q00<0
00000?m@8@3oD2403@3oD2400`000000oe0Q0?m@8@0>0?m@8@040000003oD2400000000000X0odhO
00<000000?m>7`3oCQl02`3oCQl00`000000odhO0?m>7`0;0?m>7`030000003oCQl0odhO00/0odhO
00<000000?m>7`3oCQl02@3oCQl00`000000odhO0?m>7`090?m>7`030000003oCQl0odhO00H0odhO
0P0000000`3oBQh000000?m:7P080?m:7P030000003oBQh0odXN00L0odXN0P0dBI@00`000000oooo
0?ooo`080?ooo`030000003oool0oooo00P0oooo00080?ooo`030000003oool0oooo00h0oooo0P00
00040>U06P`0=dnO00<0000003M?W`0gCil03`0gCil00`000000=dnO03M?W`0@03M?W`030000000g
Cil0=dnO0100=dnO00<0000003M?W`0gCil04@0gCil00`000000=dnO03M?W`0A03M?W`030000000g
Cil0=dnO00X0=dnO1@00000203YEZ`030000000jEJ/0>UF[01@0>UF[00<0000003YEZ`0jEJ/04`0j
EJ/00`000000>UF[03YEZ`0C03YEZ`030000000jEJ/0>UF[01D0>UF[00<0000003YEZ`0jEJ/05@0j
EJ/00`000000>UF[0000000B0?m@8@040000003oD240>UF[000000T0>UF[00<0000003YEZ`0jEJ/0
3@0jEJ/00`000000oe0Q0?m@8@030?m@8@030000003oD240oe0Q00h0oe0Q00<000000?m@8@3oD240
3@3oD2400`000000oe0Q0?m@8@020?m@8@800000203oCQl00`000000odhO0?m>7`0;0?m>7`030000
003oCQl0odhO00/0odhO00<000000?m>7`3oCQl02P3oCQl00`000000odhO0?m>7`0:0?m>7`030000
003oCQl0odhO00T0odhO00<000000?m>7`3oCQl0203oCQl2000000T0odXN00<000000?m:7P3oBQh0
1`3oBQh203A9U0030000003oool0oooo00P0oooo00<000000?ooo`3oool0203oool000P0oooo00<0
00000?ooo`3oool03P3oool2000000@0jD0J300gCil00`000000=dnO03M?W`0@03M?W`030000000g
Cil0=dnO00l0=dnO00<0000003M?W`0gCil0400gCil00`000000=dnO03M?W`0A03M?W`030000000g
Cil0=dnO0180=dnO00<0000003M?W`0gCil01@0gCil4000000P0>UF[00<0000003YEZ`0jEJ/04`0j
EJ/00`000000>UF[03YEZ`0C03YEZ`030000000jEJ/0>UF[01@0>UF[00<0000003YEZ`0jEJ/0500j
EJ/00`000000>UF[03YEZ`0E03YEZ`8000004P3oD2400`000000oe0Q0?m@8@0203YEZ`030000000j
EJ/0>UF[00H0>UF[00<0000003YEZ`0jEJ/03@0jEJ/00`000000oe0Q0?m@8@030?m@8@030000003o
D240oe0Q00d0oe0Q00<000000?m@8@3oD2403P3oD2400`000000oe0Q0?m@8@040?m@8@8000001P3o
CQl00`000000odhO0?m>7`0;0?m>7`030000003oCQl0odhO00/0odhO00<000000?m>7`3oCQl02P3o
CQl00`000000odhO0?m>7`090?m>7`030000003oCQl0odhO00X0odhO00<000000?m>7`3oCQl02@3o
CQl3000000L0odXN00<000000?m:7P3oBQh01`3oBQh203A9U0030000003oool0oooo00P0oooo00<0
00000?ooo`3oool0203oool000P0oooo00<000000?ooo`3oool03`3oool00`000000jD0J0>U06P03
0>U06P`0=dnO00<0000003M?W`0gCil03`0gCil00`000000=dnO03M?W`0@03M?W`030000000gCil0
=dnO0100=dnO00<0000003M?W`0gCil0400gCil00`000000=dnO03M?W`0B03M?W`030000000gCil0
=dnO00D00000300jEJ/00`000000>UF[03YEZ`0C03YEZ`030000000jEJ/0>UF[01@0>UF[00<00000
03YEZ`0jEJ/04`0jEJ/00`000000>UF[03YEZ`0D03YEZ`030000000jEJ/0>UF[01D0>UF[0P00000B
0?m@8@030000003oD240>UF[0080>UF[00<0000003YEZ`0jEJ/01P0jEJ/00`000000>UF[03YEZ`0=
03YEZ`030000003oD240oe0Q0080oe0Q00<000000?m@8@3oD2403P3oD2400`000000oe0Q0?m@8@0=
0?m@8@030000003oD240oe0Q00L0oe0Q0P0000040?m>7`030000003oCQl0odhO00/0odhO00<00000
0?m>7`3oCQl02`3oCQl00`000000odhO0?m>7`0:0?m>7`030000003oCQl0odhO00T0odhO00<00000
0?m>7`3oCQl02@3oCQl00`000000odhO0?m>7`0:0?m>7`030000003oCQl0odhO008000001@3oBQh0
0`000000odXN0?m:7P070?m:7P80=4VD00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`07
0?ooo`00203oool00`000000oooo0?ooo`0?0?ooo`030000003Y@1X0jD0J00<0jD0J300gCil00`00
0000=dnO03M?W`0?03M?W`030000000gCil0=dnO0100=dnO00<0000003M?W`0gCil0400gCil00`00
0000=dnO03M?W`0@03M?W`030000000gCil0=dnO0100=dnO1@00000A03YEZ`030000000jEJ/0>UF[
01@0>UF[00<0000003YEZ`0jEJ/04`0jEJ/00`000000>UF[03YEZ`0C03YEZ`030000000jEJ/0>UF[
01@0>UF[00<0000003YEZ`0jEJ/05@0jEJ/00`000000oe0Q0?m@8@0@0?m@8@030000003oD240oe0Q
00<0>UF[00<0000003YEZ`0jEJ/01P0jEJ/00`000000>UF[03YEZ`0=03YEZ`030000003oD240oe0Q
0080oe0Q00<000000?m@8@3oD2403@3oD2400`000000oe0Q0?m@8@0>0?m@8@030000003oD240oe0Q
00T0oe0Q0P0000000`3oCQl000000?m>7`0<0?m>7`030000003oCQl0odhO00`0odhO00<000000?m>
7`3oCQl02P3oCQl00`000000odhO0?m>7`090?m>7`030000003oCQl0odhO00T0odhO00<000000?m>
7`3oCQl02@3oCQl00`000000odhO0?m>7`030?m>7`8000000`3oBQh00`000000odXN0?m:7P070?m:
7P80=4VD00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`070?ooo`00203oool00`000000
oooo0?ooo`0?0?ooo`030000003Y@1X0jD0J00<0jD0J300gCil00`000000=dnO03M?W`0?03M?W`03
0000000gCil0=dnO0100=dnO00<0000003M?W`0gCil0400gCil00`000000=dnO03M?W`0A03M?W`03
0000000gCil0=dnO00X0=dnO1@00000203YEZ`030000000jEJ/0>UF[0180>UF[00<0000003YEZ`0j
EJ/04`0jEJ/00`000000>UF[03YEZ`0C03YEZ`030000000jEJ/0>UF[01@0>UF[00<0000003YEZ`0j
EJ/0500jEJ/00`000000>UF[03YEZ`0D03YEZ`030000003oD240oe0Q0100oe0Q00<000000?m@8@3o
D2400`0jEJ/00`000000>UF[03YEZ`0603YEZ`030000000jEJ/0>UF[00h0>UF[00@000000?m@8@3o
D2400000403oD2400`000000oe0Q0?m@8@0=0?m@8@030000003oD240oe0Q00`0oe0Q0`00000<0?m>
7`030000003oCQl0odhO00/0odhO00<000000?m>7`3oCQl02`3oCQl00`000000odhO0?m>7`090?m>
7`030000003oCQl0odhO00T0odhO00<000000?m>7`3oCQl02@3oCQl00`000000odhO0?m>7`050?m>
7`80000000<0odXN0000003oBQh0203oBQh203A9U0030000003oool0oooo00T0oooo00<000000?oo
o`3oool01`3oool000P0oooo00<000000?ooo`3oool03`3oool2000000D0jD0J2`0gCil00`000000
=dnO03M?W`0?03M?W`030000000gCil0=dnO0100=dnO00<0000003M?W`0gCil0400gCil00`000000
=dnO03M?W`0A03M?W`030000000gCil0=dnO00D0=dnO1@00000803YEZ`030000000jEJ/0>UF[0140
>UF[00<0000003YEZ`0jEJ/04`0jEJ/00`000000>UF[03YEZ`0D03YEZ`030000000jEJ/0>UF[01<0
>UF[00<0000003YEZ`0jEJ/0500jEJ/00`000000>UF[03YEZ`0C03YEZ`030000003oD240oe0Q0100
oe0Q00@000000?m@8@3oD240oe0Q100jEJ/00`000000>UF[03YEZ`0503YEZ`030000000jEJ/0>UF[
00h0>UF[00@000000?m@8@3oD2400000403oD2400`000000oe0Q0?m@8@0=0?m@8@030000003oD240
oe0Q00d0oe0Q00@000000?m@8@00000000002P3oCQl00`000000odhO0?m>7`0;0?m>7`030000003o
CQl0odhO00X0odhO00<000000?m>7`3oCQl02@3oCQl00`000000odhO0?m>7`0:0?m>7`030000003o
CQl0odhO00T0odhO00<000000?m>7`3oCQl01`3oCQl3000000L0odXN0`0dBI@00`000000oooo0?oo
o`090?ooo`030000003oool0oooo00L0oooo00080?ooo`030000003oool0oooo00l0oooo0P000005
0>U06P/0=dnO00<0000003M?W`0gCil0400gCil00`000000=dnO03M?W`0?03M?W`030000000gCil0
=dnO0100=dnO00<0000003M?W`0gCil04@0gCil00`000000=dnO03M?W`05000000d0>UF[00<00000
03YEZ`0jEJ/04@0jEJ/00`000000>UF[03YEZ`0D03YEZ`030000000jEJ/0>UF[01<0>UF[00<00000
03YEZ`0jEJ/04`0jEJ/00`000000>UF[03YEZ`0D03YEZ`030000000jEJ/0>UF[01<0>UF[0P00000A
0?m@8@040000003oD240oe0Q0?m@8@@0>UF[00<0000003YEZ`0jEJ/01@0jEJ/00`000000>UF[03YE
Z`0>03YEZ`040000003oD240oe0Q000000l0oe0Q00<000000?m@8@3oD2403@3oD2400`000000oe0Q
0?m@8@0=0?m@8@030000003oD240oe0Q0080oe0Q0`0000070?m>7`030000003oCQl0odhO00/0odhO
00<000000?m>7`3oCQl02P3oCQl00`000000odhO0?m>7`090?m>7`030000003oCQl0odhO00T0odhO
00<000000?m>7`3oCQl02P3oCQl00`000000odhO0?m>7`080?m>7`040000003oCQl00000000000D0
odXN0`0dBI@00`000000oooo0?ooo`090?ooo`030000003oool0oooo00L0oooo00080?ooo`030000
003oool0oooo0100oooo00<000000>U06P3Y@1X0103Y@1X:03M?W`030000000gCil0=dnO0100=dnO
00<0000003M?W`0gCil03`0gCil00`000000=dnO03M?W`0@03M?W`030000000gCil0=dnO00l0=dnO
1@00000B03YEZ`030000000jEJ/0>UF[0180>UF[00<0000003YEZ`0jEJ/04`0jEJ/00`000000>UF[
03YEZ`0C03YEZ`030000000jEJ/0>UF[01<0>UF[00<0000003YEZ`0jEJ/05@0jEJ/00`000000>UF[
03YEZ`0A03YEZ`030000003oDR80oe8R008000003P3oD2400`000000oe0Q0?m@8@020?m@8@@0>UF[
00<0000003YEZ`0jEJ/01@0jEJ/00`000000>UF[03YEZ`0?03YEZ`800000403oD2400`000000oe0Q
0?m@8@0=0?m@8@030000003oD240oe0Q00d0oe0Q00<000000?m@8@3oD2401@3oD243000000<0odhO
00<000000?m>7`3oCQl0303oCQl00`000000odhO0?m>7`0:0?m>7`030000003oCQl0odhO00T0odhO
00<000000?m>7`3oCQl02@3oCQl00`000000odhO0?m>7`090?m>7`030000003oCQl0odhO00T0odhO
00@000000?m>7`3oCQl0odhO0P0000030?m:7P<0=4VD00<000000?ooo`3oool02@3oool00`000000
oooo0?ooo`070?ooo`00203oool00`000000oooo0?ooo`0@0?ooo`030000003Y@1X0jD0J00@0jD0J
2`0gCil00`000000=dnO03M?W`0?03M?W`030000000gCil0=dnO0100=dnO00<0000003M?W`0gCil0
400gCil00`000000=dnO03M?W`0903M?W`D000000P0jEJ/00`000000>UF[03YEZ`0C03YEZ`030000
000jEJ/0>UF[0140>UF[00<0000003YEZ`0jEJ/04`0jEJ/00`000000>UF[03YEZ`0D03YEZ`030000
000jEJ/0>UF[01<0>UF[00<0000003YEZ`0jEJ/0500jEJ/00`000000>UF[03YEZ`0A03YEZ`030000
003oDR80oe8R0080oe8R0`00000;0?m@8@040000003oD240oe0Q0?m@8@H0>UF[00<0000003YEZ`0j
EJ/0100jEJ/00`000000>UF[03YEZ`0=03YEZ`@000003`3oD2400`000000oe0Q0?m@8@0>0?m@8@03
0000003oD240oe0Q00`0oe0Q00<000000?m@8@3oD2402@3oD242000000030?m>7`000000odhO00`0
odhO00<000000?m>7`3oCQl02`3oCQl00`000000odhO0?m>7`090?m>7`030000003oCQl0odhO00T0
odhO00<000000?m>7`3oCQl02@3oCQl00`000000odhO0?m>7`080?m>7`030000003oCQl0odhO00@0
odhO0P0000001@3oBQh0=4VD03A9U00dBI@0000000/0oooo00<000000?ooo`3oool01`3oool000P0
oooo00<000000?ooo`3oool0403oool00`000000jD0J0>U06P040>U06P/0=dnO00<0000003M?W`0g
Cil03`0gCil00`000000=dnO03M?W`0@03M?W`030000000gCil0=dnO0100=dnO00<0000003M?W`0g
Cil01@0gCil4000000P0>UF[00<0000003YEZ`0jEJ/04P0jEJ/00`000000>UF[03YEZ`0A03YEZ`03
0000000jEJ/0>UF[01@0>UF[00<0000003YEZ`0jEJ/04`0jEJ/00`000000>UF[03YEZ`0C03YEZ`03
0000000jEJ/0>UF[01@0>UF[00<0000003YEZ`0jEJ/0400jEJ/00`000000oe8R0?mB8P060?mB8P<0
00001`3oD2400`000000oe0Q0?m@8@020?m@8@H0>UF[00<0000003YEZ`0jEJ/0100jEJ/00`000000
>UF[03YEZ`0803YEZ`D000000P0mF[D00`000000oe0Q0?m@8@0>0?m@8@030000003oD240oe0Q00d0
oe0Q00<000000?m@8@3oD2403@3oD2400`000000oe0Q0?m@8@0;0?m@8@<00000303oCQl00`000000
odhO0?m>7`0:0?m>7`030000003oCQl0odhO00X0odhO00<000000?m>7`3oCQl02@3oCQl00`000000
odhO0?m>7`090?m>7`030000003oCQl0odhO00P0odhO00<000000?m>7`3oCQl01P3oCQl5000000/0
oooo00<000000?ooo`3oool01`3oool000P0oooo00<000000?ooo`3oool0403oool00`000000jD0J
0>U06P050>U06PX0=dnO00<0000003M?W`0gCil03`0gCil00`000000=dnO03M?W`0@03M?W`030000
000gCil0=dnO0100=dnO00<0000003M?W`0gCil01@00000<03YEZ`030000000jEJ/0>UF[0180>UF[
00<0000003YEZ`0jEJ/04P0jEJ/00`000000>UF[03YEZ`0C03YEZ`030000000jEJ/0>UF[01<0>UF[
00<0000003YEZ`0jEJ/04`0jEJ/00`000000>UF[03YEZ`0E03YEZ`030000000jEJ/0>UF[00h0>UF[
00<000000?mB8P3oDR802P3oDR82000000D0oe0Q00<000000?m@8@3oD2400P3oD24603YEZ`030000
000jEJ/0>UF[00@0>UF[00<0000003YEZ`0jEJ/0100jEJ/4000000P0?EZe00<000000?m@8@3oD240
303oD2400`000000oe0Q0?m@8@0>0?m@8@030000003oD240oe0Q00`0oe0Q00<000000?m@8@3oD240
3@3oD24010000000oe0Q00000000000:0?m>7`030000003oCQl0odhO00X0odhO00<000000?m>7`3o
CQl02@3oCQl00`000000odhO0?m>7`090?m>7`030000003oCQl0odhO00X0odhO00<000000?m>7`3o
CQl0203oCQl00`000000odhO0?m>7`070?m>7`<0<4>800<000000?ooo`3oool02@3oool00`000000
oooo0?ooo`070?ooo`001`3oool00`000000oooo0?ooo`0A0?ooo`8000001`3Y@1X903M?W`030000
000gCil0=dnO0100=dnO00<0000003M?W`0gCil03`0gCil00`000000=dnO03M?W`0>03M?W`D00000
4@0jEJ/00`000000>UF[03YEZ`0B03YEZ`030000000jEJ/0>UF[0180>UF[00<0000003YEZ`0jEJ/0
4`0jEJ/00`000000>UF[03YEZ`0C03YEZ`030000000jEJ/0>UF[01@0>UF[00<0000003YEZ`0jEJ/0
500jEJ/00`000000>UF[03YEZ`0>03YEZ`030000003oDR80oe8R00`0oe8R0`0000070?m@8@H0>UF[
00<0000003YEZ`0jEJ/0100jEJ/00`000000>UF[00000004000000`0?EZe00<000000?m@8@3oD240
303oD2400`000000oe0Q0?m@8@0=0?m@8@030000003oD240oe0Q00d0oe0Q00<000000?m@8@3oD240
303oD2400`000000oe0Q0?m@8@020?m@8@<000001`3oCQl00`000000odhO0?m>7`0:0?m>7`030000
003oCQl0odhO00T0odhO00<000000?m>7`3oCQl02@3oCQl00`000000odhO0?m>7`090?m>7`030000
003oCQl0odhO00T0odhO00<000000?m>7`3oCQl01`3oCQl30313R0030000003oool0oooo00T0oooo
00<000000?ooo`3oool01`3oool000L0oooo00<000000?ooo`3oool04@3oool2000000D0jD0J00<0
=dnO0>U06P0gCil0200gCil00`000000=dnO03M?W`0@03M?W`030000000gCil0=dnO00l0=dnO00<0
000003M?W`0gCil02P0gCil400000080>UF[00<0000003YEZ`0jEJ/04P0jEJ/00`000000>UF[03YE
Z`0B03YEZ`030000000jEJ/0>UF[0140>UF[00<0000003YEZ`0jEJ/0500jEJ/00`000000>UF[03YE
Z`0C03YEZ`030000000jEJ/0>UF[01<0>UF[00<0000003YEZ`0jEJ/0500jEJ/00`000000>UF[03YE
Z`0=03YEZ`030000003oDR80oe8R0100oe8R0`0000040?m@8@L0>UF[00<0000003YEZ`0jEJ/01@00
000B03eJ]@030000003oD240oe0Q00X0oe0Q00<000000?m@8@3oD2403P3oD2400`000000oe0Q0?m@
8@0<0?m@8@030000003oD240oe0Q00d0oe0Q00<000000?m@8@3oD2401@3oD243000000<0odhO00<0
00000?m>7`3oCQl02`3oCQl00`000000odhO0?m>7`090?m>7`030000003oCQl0odhO00T0odhO00<0
00000?m>7`3oCQl02@3oCQl00`000000odhO0?m>7`090?m>7`030000003oCQl0odhO00H0odhO100`
@hP00`000000oooo0?ooo`090?ooo`030000003oool0oooo00L0oooo00070?ooo`030000003oool0
oooo0180oooo00D000000>U06P3Y@1X0jD0J03M?W`020>U06P0303M?W`3Y@1X0=dnO00L0=dnO00<0
000003M?W`0gCil0400gCil00`000000=dnO03M?W`0@03M?W`030000000gCil0=dnO00@0=dnO1@00
000703YEZ`030000000jEJ/0>UF[0140>UF[00<0000003YEZ`0jEJ/04P0jEJ/00`000000>UF[03YE
Z`0B03YEZ`030000000jEJ/0>UF[01<0>UF[00<0000003YEZ`0jEJ/04`0jEJ/00`000000>UF[03YE
Z`0C03YEZ`030000000jEJ/0>UF[01D0>UF[00<0000003YEZ`0jEJ/02`0jEJ/00`000000oe8R0?mB
8P0A0?mB8P030000003oDR80oe8R008000000P3oD24403YEZ`H000000`0mF[D00`000000?EZe03eJ
]@0A03eJ]@030000003oD240oe0Q00X0oe0Q00<000000?m@8@3oD2403@3oD2400`000000oe0Q0?m@
8@0=0?m@8@030000003oD240oe0Q00`0oe0Q00<000000?m@8@3oD2402@3oD242000000030?m>7`00
0000odhO00/0odhO00<000000?m>7`3oCQl02P3oCQl00`000000odhO0?m>7`090?m>7`030000003o
CQl0odhO00T0odhO00<000000?m>7`3oCQl0203oCQl00`000000odhO0?m>7`070?m>7`@0<4>800<0
00000?ooo`3oool02@3oool00`000000oooo0?ooo`070?ooo`001`3oool00`000000oooo0?ooo`0B
0?ooo`030000003Y@1X0jD0J00D0jD0J2P0gCil00`000000=dnO03M?W`0?03M?W`030000000gCil0
=dnO0100=dnO00<0000003M?W`0gCil01000000<03YEZ`030000000jEJ/0>UF[0140>UF[00<00000
03YEZ`0jEJ/04P0jEJ/00`000000>UF[03YEZ`0B03YEZ`030000000jEJ/0>UF[01<0>UF[00<00000
03YEZ`0jEJ/04`0jEJ/00`000000>UF[03YEZ`0D03YEZ`030000000jEJ/0>UF[01@0>UF[00<00000
03YEZ`0jEJ/02`0jEJ/00`000000oe8R0?mB8P0A0?mB8P030000003oDR80oe8R0080oe8R1P000003
03eJ]@030000000mF[D0?EZe00<0?EZe00<0000003eJ]@0mF[D04P0mF[D00`000000oe0Q0?m@8@08
0?m@8@030000003oD240oe0Q00h0oe0Q00<000000?m@8@3oD2403@3oD2400`000000oe0Q0?m@8@0<
0?m@8@030000003oD240oe0Q00/0oe0Q0`00000;0?m>7`030000003oCQl0odhO00T0odhO00<00000
0?m>7`3oCQl02P3oCQl00`000000odhO0?m>7`090?m>7`030000003oCQl0odhO00P0odhO00<00000
0?m>7`3oCQl01`3oCQl30313R0030000003oool0oooo00X0oooo00<000000?ooo`3oool01`3oool0
00L0oooo00<000000?ooo`3oool04P3oool00`000000jD0J0>U06P060>U06PT0=dnO00<0000003M?
W`0gCil03`0gCil00`000000=dnO03M?W`0>03M?W`D00000400jEJ/00`000000>UF[03YEZ`0B03YE
Z`030000000jEJ/0>UF[0180>UF[00<0000003YEZ`0jEJ/04@0jEJ/00`000000>UF[03YEZ`0C03YE
Z`030000000jEJ/0>UF[01@0>UF[00<0000003YEZ`0jEJ/04`0jEJ/00`000000>UF[03YEZ`0D03YE
Z`030000000jEJ/0>UF[00X0>UF[00<000000?mB8P3oDR804@3oDR800`000000oe8R0?mB8P040?mB
8PT0?EZe00<0000003eJ]@0mF[D00P0mF[D00`000000?EZe03eJ]@0B03eJ]@030000003oD240oe0Q
00P0oe0Q00<000000?m@8@3oD2403@3oD2400`000000oe0Q0?m@8@0=0?m@8@030000003oD240oe0Q
00`0oe0Q00<000000?m@8@3oD2403@3oD24010000000oe0Q0000000000090?m>7`030000003oCQl0
odhO00T0odhO00<000000?m>7`3oCQl02@3oCQl00`000000odhO0?m>7`090?m>7`030000003oCQl0
odhO00T0odhO00<000000?m>7`3oCQl01P3oCQl40313R0030000003oool0oooo00X0oooo00<00000
0?ooo`3oool01`3oool000L0oooo00<000000?ooo`3oool04P3oool00`000000jD0J0>U06P060>U0
6PT0=dnO00<0000003M?W`0gCil0400gCil00`000000=dnO03M?W`0703M?W`H000000P0jEJ/00`00
0000>UF[03YEZ`0A03YEZ`030000000jEJ/0>UF[0140>UF[00<0000003YEZ`0jEJ/04P0jEJ/00`00
0000>UF[03YEZ`0B03YEZ`030000000jEJ/0>UF[01<0>UF[00<0000003YEZ`0jEJ/04`0jEJ/00`00
0000>UF[03YEZ`0C03YEZ`030000000jEJ/0>UF[01@0>UF[00<0000003YEZ`0jEJ/02@0jEJ/00`00
0000oe8R0?mB8P0A0?mB8P030000003oDR80oe8R00D0oe8R2@0mF[D00`000000?EZe03eJ]@0203eJ
]@030000000mF[D0?EZe01<0?EZe00<000000?m@8@3oD2401P3oD2400`000000oe0Q0?m@8@0>0?m@
8@030000003oD240oe0Q00d0oe0Q00<000000?m@8@3oD240303oD2400`000000oe0Q0?m@8@0<0?m@
8@030000003oD240oe0Q0080oe0Q0P0000070?m>7`030000003oCQl0odhO00T0odhO00<000000?m>
7`3oCQl02@3oCQl00`000000odhO0?m>7`090?m>7`030000003oCQl0odhO00T0odhO00<000000?m>
7`3oCQl01P3oCQl40313R0030000003oool0oooo00X0oooo00<000000?ooo`3oool01`3oool000L0
oooo00<000000?ooo`3oool04P3oool2000000P0jD0J200gCil00`000000=dnO03M?W`0@03M?W`04
0000000gCil0=dnO03M?W`H000002@0jEJ/00`000000>UF[03YEZ`0@03YEZ`030000000jEJ/0>UF[
0140>UF[00<0000003YEZ`0jEJ/04P0jEJ/00`000000>UF[03YEZ`0B03YEZ`030000000jEJ/0>UF[
01<0>UF[00<0000003YEZ`0jEJ/04`0jEJ/00`000000>UF[03YEZ`0D03YEZ`030000000jEJ/0>UF[
01@0>UF[00<0000003YEZ`0jEJ/0200jEJ/00`000000oe8R0?mB8P0A0?mB8P030000003oDR80oe8R
00D0oe8R2P0mF[D01@000000?EZe03eJ]@0mF[D0000001D0?EZe00<000000?m@8@3oD2401P3oD240
0`000000oe0Q0?m@8@0>0?m@8@030000003oD240oe0Q00`0oe0Q00<000000?m@8@3oD240303oD240
0`000000oe0Q0?m@8@0=0?m@8@030000003oD240oe0Q00@0oe0Q0`0000030?m>7`030000003oCQl0
odhO00X0odhO00<000000?m>7`3oCQl02@3oCQl00`000000odhO0?m>7`090?m>7`030000003oCQl0
odhO00P0odhO00<000000?m>7`3oCQl01P3oCQl50313R0030000003oool0oooo00X0oooo00<00000
0?ooo`3oool01`3oool000L0oooo00<000000?ooo`3oool04`3oool00`000000jD0J0>U06P060>U0
6PP0=dnO00<0000003M?W`0gCil03P0gCil6000000l0>UF[00<0000003YEZ`0jEJ/0400jEJ/00`00
0000>UF[03YEZ`0B03YEZ`030000000jEJ/0>UF[0180>UF[00<0000003YEZ`0jEJ/04@0jEJ/00`00
0000>UF[03YEZ`0C03YEZ`030000000jEJ/0>UF[01@0>UF[00<0000003YEZ`0jEJ/04`0jEJ/00`00
0000>UF[03YEZ`0D03YEZ`030000000jEJ/0>UF[00L0>UF[00<000000?mB8P3oDR804@3oDR800`00
0000oe8R0?mB8P060?mB8PX0?EZe00D0000003eJ]@0mF[D0?EZe0000000E03eJ]@030000003oD240
oe0Q00H0oe0Q00<000000?m@8@3oD2403@3oD2400`000000oe0Q0?m@8@0=0?m@8@030000003oD240
oe0Q00`0oe0Q00<000000?m@8@3oD240303oD2400`000000oe0Q0?m@8@080?m@8@80000000<0odhO
0000003oCQl02P3oCQl00`000000odhO0?m>7`0:0?m>7`030000003oCQl0odhO00T0odhO00<00000
0?m>7`3oCQl0203oCQl00`000000odhO0?m>7`060?m>7`D0<4>800<000000?ooo`3oool02`3oool0
0`000000oooo0?ooo`060?ooo`001`3oool00`000000oooo0?ooo`0C0?ooo`030000003Y@1X0jD0J
00L0jD0J1`0gCil00`000000=dnO03M?W`0:03M?W`@000000P0jEJ/00`000000>UF[03YEZ`0@03YE
Z`030000000jEJ/0>UF[0140>UF[00<0000003YEZ`0jEJ/04@0jEJ/00`000000>UF[03YEZ`0B03YE
Z`030000000jEJ/0>UF[0180>UF[00<0000003YEZ`0jEJ/04`0jEJ/00`000000>UF[03YEZ`0C03YE
Z`030000000jEJ/0>UF[01<0>UF[00<0000003YEZ`0jEJ/0500jEJ/00`000000>UF[03YEZ`0603YE
Z`030000003oDR80oe8R0140oe8R00<000000?mB8P3oDR801`3oDR8;03eJ]@040000000mF[D0?EZe
000001H0?EZe00<000000?m@8@3oD240103oD2400`000000oe0Q0?m@8@0>0?m@8@030000003oD240
oe0Q00`0oe0Q00<000000?m@8@3oD2403@3oD2400`000000oe0Q0?m@8@0<0?m@8@030000003oD240
oe0Q00X0oe0Q0`00000:0?m>7`030000003oCQl0odhO00T0odhO00<000000?m>7`3oCQl02@3oCQl0
0`000000odhO0?m>7`090?m>7`030000003oCQl0odhO00H0odhO1@0`@hP00`000000oooo0?ooo`0;
0?ooo`030000003oool0oooo00H0oooo00070?ooo`030000003oool0oooo01<0oooo0P0000080>U0
6PP0=dnO00<0000003M?W`0gCil0100gCil5000000L0>UF[00<0000003YEZ`0jEJ/0400jEJ/00`00
0000>UF[03YEZ`0@03YEZ`030000000jEJ/0>UF[0140>UF[00<0000003YEZ`0jEJ/04P0jEJ/00`00
0000>UF[03YEZ`0B03YEZ`030000000jEJ/0>UF[01<0>UF[00<0000003YEZ`0jEJ/04`0jEJ/00`00
0000>UF[03YEZ`0D03YEZ`030000000jEJ/0>UF[01@0>UF[00<0000003YEZ`0jEJ/01P00000C0?mB
8P030000003oDR80oe8R00L0oe8R2`0mF[D010000000?EZe03eJ]@00000F03eJ]@030000003oD240
oe0Q00@0oe0Q00<000000?m@8@3oD2403@3oD2400`000000oe0Q0?m@8@0=0?m@8@030000003oD240
oe0Q00`0oe0Q00<000000?m@8@3oD240303oD2400`000000oe0Q0?m@8@0<0?m@8@040000003oD240
0000000000P0odhO00<000000?m>7`3oCQl02@3oCQl00`000000odhO0?m>7`090?m>7`030000003o
CQl0odhO00T0odhO00<000000?m>7`3oCQl01@3oCQl60313R0030000003oool0oooo00/0oooo00<0
00000?ooo`3oool01P3oool000L0oooo00<000000?ooo`3oool04`3oool00`000000eCTG00000003
000000D0jD0J1`0gCil00`000000=dnO03M?W`04000000`0>UF[00<0000003YEZ`0jEJ/0400jEJ/0
0`000000>UF[03YEZ`0@03YEZ`030000000jEJ/0>UF[0180>UF[00<0000003YEZ`0jEJ/04@0jEJ/0
0`000000>UF[03YEZ`0B03YEZ`030000000jEJ/0>UF[01<0>UF[00<0000003YEZ`0jEJ/0500jEJ/0
0`000000>UF[03YEZ`0C03YEZ`030000000jEJ/0>UF[0140>UF[1P00000403eJ]@030000003oDR80
oe8R0140oe8R00<000000?mB8P3oDR801`3oDR8=03eJ]@030000000mF[D0000001L0?EZe00<00000
0?m@8@3oD2400P3oD2400`000000oe0Q0?m@8@0>0?m@8@030000003oD240oe0Q00`0oe0Q00<00000
0?m@8@3oD2403@3oD2400`000000oe0Q0?m@8@0<0?m@8@030000003oD240oe0Q00/0oe0Q00<00000
0?m@8@3oD2400P3oD242000000H0odhO00<000000?m>7`3oCQl02@3oCQl00`000000odhO0?m>7`09
0?m>7`030000003oCQl0odhO00T0odhO00<000000?m>7`3oCQl01@3oCQl60313R0030000003oool0
oooo00/0oooo00<000000?ooo`3oool01P3oool000L0oooo00<000000?ooo`3oool04`3oool20000
00@0eCTG100000000`3Y@1X0=dnO03M?W`0203M?W`H00000400jEJ/00`000000>UF[03YEZ`0@03YE
Z`030000000jEJ/0>UF[0140>UF[00<0000003YEZ`0jEJ/04@0jEJ/00`000000>UF[03YEZ`0B03YE
Z`030000000jEJ/0>UF[0180>UF[00<0000003YEZ`0jEJ/04`0jEJ/00`000000>UF[03YEZ`0C03YE
Z`030000000jEJ/0>UF[01<0>UF[00<0000003YEZ`0jEJ/02P0jEJ/7000000<0?EZe00<0000003eJ
]@0mF[D00`0mF[D00`000000oe8R0?mB8P0A0?mB8P030000003oDR80oe8R00P0oe8R3@0mF[D00`00
0000?EZe0000000G03eJ]@030000003oD240oe0Q0080oe0Q00<000000?m@8@3oD2403@3oD2400`00
0000oe0Q0?m@8@0=0?m@8@030000003oD240oe0Q00`0oe0Q00<000000?m@8@3oD240303oD2400`00
0000oe0Q0?m@8@0<0?m@8@030000003oD240oe0Q00@0oe0Q0P0000030?m>7`030000003oCQl0odhO
00X0odhO00<000000?m>7`3oCQl02@3oCQl00`000000odhO0?m>7`080?m>7`030000003oCQl0odhO
00D0odhO1`0`@hP00`000000oooo0?ooo`0;0?ooo`030000003oool0oooo00H0oooo00070?ooo`03
0000003oool0oooo01@0oooo00<000000=Di5`3E>AL01P3E>AL5000000<0>UF[00<0000003YEZ`0j
EJ/03P0jEJ/0103Y@1X0>UF[03YEZ`00000B03YEZ`030000000jEJ/0>UF[0100>UF[00<0000003YE
Z`0jEJ/04@0jEJ/00`000000>UF[03YEZ`0B03YEZ`030000000jEJ/0>UF[0180>UF[00<0000003YE
Z`0jEJ/04`0jEJ/00`000000>UF[03YEZ`0C03YEZ`030000000jEJ/0>UF[01@0>UF[00@0000003YE
Z`0jEJ/0>UF[2000000;03eJ]@030000000mF[D0?EZe0080?EZe00<000000?mB8P3oDR804@3oDR80
0`000000oe8R0?mB8P080?mB8Ph0?EZe0P00000H03eJ]@040000003oD240oe0Q00000100oe0Q00<0
00000?m@8@3oD2403@3oD2400`000000oe0Q0?m@8@0<0?m@8@030000003oD240oe0Q00`0oe0Q00<0
00000?m@8@3oD2402`3oD2400`000000oe0Q0?m@8@070?m@8@80000000<0odhO0000003oCQl02P3o
CQl00`000000odhO0?m>7`090?m>7`030000003oCQl0odhO00T0odhO00<000000?m>7`3oCQl01@3o
CQl70313R0030000003oool0oooo00/0oooo00<000000?ooo`3oool01P3oool000L0oooo00<00000
0?ooo`3oool0503oool2000000T0eCTG1`0jEJ/00`000000>UF[03YEZ`0@03YEZ`030000000jEJ/0
>UF[0100>UF[00<0000003YEZ`0jEJ/0400jEJ/00`000000>UF[03YEZ`0B03YEZ`030000000jEJ/0
>UF[0140>UF[00<0000003YEZ`0jEJ/04P0jEJ/00`000000>UF[03YEZ`0C03YEZ`030000000jEJ/0
>UF[01@0>UF[00<0000003YEZ`0jEJ/04@0jEJ/6000001<0?EZe00D0000003eJ]@0mF[D0?EZe0000
000C0?mB8P030000003oDR80oe8R00T0oe8R3P0mF[D2000001P0?EZe00@000000?m@8@3oD2400000
3`3oD2400`000000oe0Q0?m@8@0=0?m@8@030000003oD240oe0Q00`0oe0Q00<000000?m@8@3oD240
3@3oD2400`000000oe0Q0?m@8@0;0?m@8@030000003oD240oe0Q00T0oe0Q0`00000:0?m>7`030000
003oCQl0odhO00T0odhO00<000000?m>7`3oCQl02@3oCQl00`000000odhO0?m>7`050?m>7`H0<4>8
00<000000?ooo`3oool0303oool00`000000oooo0?ooo`060?ooo`001`3oool00`000000oooo0?oo
o`0D0?ooo`8000002P3E>AL603YEZ`030000000jEJ/0>UF[0100>UF[00<0000003YEZ`0jEJ/0400j
EJ/00`000000>UF[03YEZ`0A03YEZ`030000000jEJ/0>UF[0140>UF[00<0000003YEZ`0jEJ/04P0j
EJ/00`000000>UF[03YEZ`0B03YEZ`030000000jEJ/0>UF[01<0>UF[00<0000003YEZ`0jEJ/04`0j
EJ/00`000000>UF[03YEZ`0<03YEZ`D000000P0mF[D00`000000?EZe03eJ]@0E03eJ]@040000000m
F[D0?EZe00000180oe8R00<000000?mB8P3oDR802P3oDR8>03eJ]@8000006@0mF[D200000100oe0Q
00<000000?m@8@3oD2403@3oD2400`000000oe0Q0?m@8@0<0?m@8@030000003oD240oe0Q00`0oe0Q
00<000000?m@8@3oD2402`3oD2400`000000oe0Q0?m@8@0;0?m@8@040000003oD2400000000000P0
odhO00<000000?m>7`3oCQl02@3oCQl00`000000odhO0?m>7`090?m>7`030000003oCQl0odhO00@0
odhO1`0`@hP00`000000oooo0?ooo`0<0?ooo`030000003oool0oooo00H0oooo00070?ooo`030000
003oool0oooo01@0oooo0P00000;0=Di5`D0>UF[00<0000003YEZ`0jEJ/04@0jEJ/00`000000>UF[
03YEZ`0@03YEZ`030000000jEJ/0>UF[0100>UF[00<0000003YEZ`0jEJ/04P0jEJ/00`000000>UF[
03YEZ`0A03YEZ`030000000jEJ/0>UF[0180>UF[00<0000003YEZ`0jEJ/04`0jEJ/00`000000>UF[
03YEZ`0C03YEZ`030000000jEJ/0>UF[00H0>UF[1P00000803eJ]@030000000mF[D0?EZe01@0?EZe
00<0000003eJ]@0000004`3oDR800`000000oe8R0?mB8P0:0?mB8Pl0?EZe00<0000003eJ]@0mF[D0
5`0mF[D200000100oe0Q00<000000?m@8@3oD240303oD2400`000000oe0Q0?m@8@0<0?m@8@030000
003oD240oe0Q00d0oe0Q00<000000?m@8@3oD2402`3oD2400`000000oe0Q0?m@8@0:0?m@8@030000
003oD240oe0Q0080oe0Q0P0000060?m>7`030000003oCQl0odhO00T0odhO00<000000?m>7`3oCQl0
2@3oCQl00`000000odhO0?m>7`040?m>7`L0<4>800<000000?ooo`3oool0303oool00`000000oooo
0?ooo`060?ooo`001P3oool00`000000oooo0?ooo`0F0?ooo`8000002`3E>AL503YEZ`030000000j
EJ/0>UF[0100>UF[00<0000003YEZ`0jEJ/0400jEJ/00`000000>UF[03YEZ`0@03YEZ`030000000j
EJ/0>UF[0180>UF[00<0000003YEZ`0jEJ/04@0jEJ/00`000000>UF[03YEZ`0B03YEZ`030000000j
EJ/0>UF[01<0>UF[00<0000003YEZ`0jEJ/0500jEJ/00`000000>UF[03YEZ`05000000h0?EZe00<0
000003eJ]@0mF[D05@0mF[D00`000000oe8R0?mB8P0A0?mB8P030000003oDR80oe8R00X0oe8R400m
F[D00`000000?EZe03eJ]@0G03eJ]@030000003oD240oe0Q00h0oe0Q00<000000?m@8@3oD2403@3o
D2400`000000oe0Q0?m@8@0<0?m@8@030000003oD240oe0Q00`0oe0Q00<000000?m@8@3oD2402`3o
D2400`000000oe0Q0?m@8@0;0?m@8@030000003oD240oe0Q00@0oe0Q0P0000030?m>7`030000003o
CQl0odhO00T0odhO00<000000?m>7`3oCQl02@3oCQl00`000000odhO0?m>7`040?m>7`P0<4>800<0
00000?ooo`3oool0303oool00`000000oooo0?ooo`060?ooo`001P3oool00`000000oooo0?ooo`0F
0?ooo`800000303E>AL403YEZ`030000000jEJ/0>UF[00/0>UF[00<0jD0J03YEZ`0jEJ/00P0jEJ/0
0`000000>UF[03YEZ`0@03YEZ`030000000jEJ/0>UF[0140>UF[00<0000003YEZ`0jEJ/04@0jEJ/0
0`000000>UF[03YEZ`0B03YEZ`030000000jEJ/0>UF[0180>UF[00<0000003YEZ`0jEJ/04`0jEJ/0
0`000000>UF[03YEZ`0A03YEZ`D00000500mF[D00`000000?EZe03eJ]@0D03eJ]@030000003oDR80
oe8R0100oe8R00<000000?mB8P3oDR802`3oDR8@03eJ]@8000006@0mF[D00`000000oe0Q0?m@8@0=
0?m@8@030000003oD240oe0Q00`0oe0Q00<000000?m@8@3oD2403@3oD2400`000000oe0Q0?m@8@0<
0?m@8@030000003oD240oe0Q00/0oe0Q00<000000?m@8@3oD2402P3oD2400`000000oe0Q0?m@8@07
0?m@8@80000000<0odhO0000003oCQl02P3oCQl00`000000odhO0?m>7`090?m>7`030000003oCQl0
odhO00@0odhO200`@hP00`000000oooo0?ooo`0<0?ooo`030000003oool0oooo00H0oooo00060?oo
o`030000003oool0oooo01H0oooo00<0000003YEZ`000000303E>AL303YEZ`030000000jEJ/0>UF[
0140>UF[00<0000003YEZ`0jEJ/0400jEJ/00`000000>UF[03YEZ`0@03YEZ`030000000jEJ/0>UF[
0180>UF[00<0000003YEZ`0jEJ/04@0jEJ/00`000000>UF[03YEZ`0B03YEZ`030000000jEJ/0>UF[
01<0>UF[00<0000003YEZ`0jEJ/0300jEJ/500000080?EZe00<0000003eJ]@0mF[D0500mF[D00`00
0000?EZe03eJ]@0C03eJ]@030000003oDR80oe8R0100oe8R00<000000?mB8P3oDR801P3oDR800`0m
F[D0oe8R0?mB8P030?mB8Q00?EZe0P00000I03eJ]@<00000303oD2400`000000oe0Q0?m@8@0=0?m@
8@030000003oD240oe0Q00`0oe0Q00<000000?m@8@3oD240303oD2400`000000oe0Q0?m@8@0;0?m@
8@030000003oD240oe0Q00/0oe0Q00<000000?m@8@3oD2402@3oD243000000X0odhO00<000000?m>
7`3oCQl02@3oCQl00`000000odhO0?m>7`040?m>7`030313R03oCQl0<4>800D0<4>800<000000?oo
o`3oool0303oool00`000000oooo0?ooo`060?ooo`001P3oool00`000000oooo0?ooo`0G0?ooo`80
0000303E>AL403YEZ`030000000jEJ/0>UF[0100>UF[00<0000003YEZ`0jEJ/0400jEJ/00`000000
>UF[03YEZ`0A03YEZ`030000000jEJ/0>UF[0140>UF[00<0000003YEZ`0jEJ/04@0jEJ/00`000000
>UF[03YEZ`0B03YEZ`030000000jEJ/0>UF[01<0>UF[00<0000003YEZ`0jEJ/01P0jEJ/6000000P0
?EZe00<0000003eJ]@0mF[D0500mF[D00`000000?EZe03eJ]@0A03eJ]@030000003oDR80oe8R0140
oe8R00<000000?mB8P3oDR80303oDR8@03eJ]@030000000mF[D0000001T0?EZe00@000000?mB8P00
000000002P3oD2400`000000oe0Q0?m@8@0=0?m@8@030000003oD240oe0Q00`0oe0Q00<000000?m@
8@3oD240303oD2400`000000oe0Q0?m@8@0;0?m@8@030000003oD240oe0Q00X0oe0Q00<000000?m@
8@3oD2402`3oD2400`000000oe0Q00000002000000L0odhO00<000000?m>7`3oCQl02@3oCQl00`00
0000odhO0?m>7`030?m>7`<0<4>800<0odhO0313R00`@hP00`0`@hP00`000000oooo0?ooo`0<0?oo
o`030000003oool0oooo00H0oooo00060?ooo`030000003oool0oooo01L0oooo0P00000;0=Di5`03
03YEZ`3E>AL0>UF[0080>UF[00<0000003YEZ`0jEJ/0400jEJ/00`000000>UF[03YEZ`0@03YEZ`03
0000000jEJ/0>UF[0140>UF[00<0000003YEZ`0jEJ/04@0jEJ/00`000000>UF[03YEZ`0B03YEZ`03
0000000jEJ/0>UF[0180>UF[00<0000003YEZ`0jEJ/04`0jEJ/00`000000>UF[03YEZ`05000000h0
?EZe00<0000003eJ]@0mF[D0500mF[D00`000000?EZe03eJ]@0A03eJ]@030000003oDR80oe8R0100
oe8R00<000000?mB8P3oDR803@3oDR8@03eJ]@030000000mF[D0000001T0?EZe00@000000?mB8P3o
DR80oe8R0`0000060?m@8@030000003oD240oe0Q00d0oe0Q00<000000?m@8@3oD240303oD2400`00
0000oe0Q0?m@8@0<0?m@8@030000003oD240oe0Q00`0oe0Q00<000000?m@8@3oD2402P3oD2400`00
0000oe0Q0?m@8@0:0?m@8@030000003oD240oe0Q00<0oe0Q0P0000040?m>7`030000003oCQl0odhO
00T0odhO00<000000?m>7`3oCQl0103oCQl90313R0030000003oool0oooo00`0oooo00<000000?oo
o`3oool01P3oool000H0oooo00<000000?ooo`3oool05`3oool00`000000>UF[0000000=0=Di5`80
>UF[00<0000003YEZ`0jEJ/04@0jEJ/00`000000>UF[03YEZ`0?03YEZ`030000000jEJ/0>UF[0140
>UF[00<0000003YEZ`0jEJ/04P0jEJ/00`000000>UF[03YEZ`0A03YEZ`030000000jEJ/0>UF[0180
>UF[00<0000003YEZ`0jEJ/0400jEJ/6000001@0?EZe00<0000003eJ]@0mF[D0500mF[D00`000000
?EZe03eJ]@0?03eJ]@030000003oDR80oe8R0100oe8R00<000000?mB8P3oDR803P3oDR8@03eJ]@04
0000000mF[D0?EZe000001T0?EZe00<000000?mB8P3oDR800`3oDR82000000@0oe0Q00<000000?m@
8@3oD2403@3oD2400`000000oe0Q0?m@8@0<0?m@8@030000003oD240oe0Q00`0oe0Q00<000000?m@
8@3oD2402`3oD2400`000000oe0Q0?m@8@0;0?m@8@030000003oD240oe0Q00X0oe0Q00<000000?m@
8@3oD2401@3oD243000000030?m>7`000000odhO00X0odhO00<000000?m>7`3oCQl00`3oCQl50313
R0030000000`@hP0<4>80080<4>800<000000?ooo`3oool0303oool00`000000oooo0?ooo`060?oo
o`001P3oool00`000000oooo0?ooo`0H0?ooo`8000003P3E>AL203YEZ`030000000jEJ/0>UF[00P0
>UF[00<0eCTG03YEZ`0jEJ/01@0jEJ/00`000000>UF[03YEZ`0@03YEZ`030000000jEJ/0>UF[0140
>UF[00<0000003YEZ`0jEJ/04@0jEJ/00`000000>UF[03YEZ`0A03YEZ`030000000jEJ/0>UF[0180
>UF[00<0000003YEZ`0jEJ/02@0jEJ/7000000<0?EZe00<0000003eJ]@0mF[D0500mF[D00`000000
?EZe03eJ]@0D03eJ]@030000000mF[D0?EZe00h0?EZe00<000000?mB8P3oDR804@3oDR800`000000
oe8R0?mB8P0>0?mB8Q00?EZe00@0000003eJ]@0mF[D000006@0mF[D00`000000oe8R0?mB8P050?mB
8P80000000<0oe0Q0000003oD2403P3oD2400`000000oe0Q0?m@8@0<0?m@8@030000003oD240oe0Q
00d0oe0Q00<000000?m@8@3oD2402`3oD2400`000000oe0Q0?m@8@0:0?m@8@030000003oD240oe0Q
00X0oe0Q00<000000?m@8@3oD2402@3oD243000000X0odhO00<000000?m>7`3oCQl00`3oCQl60313
R0050?ooo`0`@hP0<4>80313R00000003P3oool00`000000oooo0?ooo`060?ooo`001P3oool00`00
0000oooo0?ooo`0H0?ooo`8000003P3E>AL203YEZ`030000000jEJ/0>UF[0100>UF[00<0000003YE
Z`0jEJ/0400jEJ/00`000000>UF[03YEZ`0A03YEZ`030000000jEJ/0>UF[0140>UF[00<0000003YE
Z`0jEJ/04@0jEJ/00`000000>UF[03YEZ`0C03YEZ`040000000jEJ/0>UF[03YEZ`L000002`0mF[D0
0`000000?EZe03eJ]@0D03eJ]@030000000mF[D0?EZe01@0?EZe00<0000003eJ]@0mF[D03@0mF[D0
0`000000oe8R0?mB8P0@0?mB8P030000003oDR80oe8R00h0oe8R4@0mF[D01@000000?EZe03eJ]@0m
F[D0000001T0?EZe00<000000?mB8P3oDR801P3oDR83000000h0oe0Q00<000000?m@8@3oD240303o
D2400`000000oe0Q0?m@8@0<0?m@8@030000003oD240oe0Q00/0oe0Q00<000000?m@8@3oD2402`3o
D2400`000000oe0Q0?m@8@0:0?m@8@030000003oD240oe0Q00X0oe0Q00@000000?m@8@0000000000
203oCQl00`000000odhO0?m>7`030?m>7`T0<4>800<000000?ooo`3oool03@3oool00`000000oooo
0?ooo`060?ooo`001P3oool00`000000oooo0?ooo`0H0?ooo`030000000jEJ/0000000h0eCTG00<0
>UF[0000000jEJ/04@0jEJ/00`000000>UF[03YEZ`0@03YEZ`030000000jEJ/0>UF[0140>UF[00<0
000003YEZ`0jEJ/04P0jEJ/00`000000>UF[03YEZ`0A03YEZ`030000000jEJ/0>UF[0100>UF[1P00
000B03eJ]@030000000mF[D0?EZe01@0?EZe00<0000003eJ]@0mF[D0500mF[D00`000000?EZe03eJ
]@0<03eJ]@030000003oDR80oe8R0100oe8R00<000000?mB8P3oDR802@3oDR800`0mF[D0oe8R0?mB
8P030?mB8Q40?EZe00D0000003eJ]@0mF[D0?EZe0000000I03eJ]@030000003oDR80oe8R00H0oe8R
00<000000?mB8P3oDR80100000090?m@8@030000003oD240oe0Q00d0oe0Q00<000000?m@8@3oD240
303oD2400`000000oe0Q0?m@8@0;0?m@8@030000003oD240oe0Q00X0oe0Q00<000000?m@8@3oD240
2P3oD2400`000000oe0Q0?m@8@0:0?m@8@030000003oD240oe0Q0080oe0Q0P0000060?m>7`030000
003oCQl0odhO0080odhO200`@hP00`3oool0<4>80000000@0?ooo`030000003oool0oooo00D0oooo
00060?ooo`030000003oool0oooo01T0oooo0P00000?0=Di5`0303YEZ`000000>UF[0140>UF[00<0
000003YEZ`0jEJ/0400jEJ/00`000000>UF[03YEZ`0A03YEZ`030000000jEJ/0>UF[0140>UF[00<0
000003YEZ`0jEJ/04@0jEJ/00`000000>UF[03YEZ`0;03YEZ`D000000P0mF[D00`000000?EZe03eJ
]@0D03eJ]@030000000mF[D0?EZe01@0?EZe00<0000003eJ]@0mF[D0500mF[D00`000000?EZe03eJ
]@0:03eJ]@030000003oDR80oe8R0140oe8R00<000000?mB8P3oDR803`3oDR8A03eJ]@030000000m
F[D0?EZe0080?EZe00<0000003eJ]@0mF[D05P0mF[D00`000000oe8R0?mB8P060?mB8P030000003o
DR80oe8R00@0oe8R0`0000060?m@8@030000003oD240oe0Q00`0oe0Q00<000000?m@8@3oD240303o
D2400`000000oe0Q0?m@8@0;0?m@8@030000003oD240oe0Q00/0oe0Q00<000000?m@8@3oD2402P3o
D2400`000000oe0Q0?m@8@0:0?m@8@030000003oD240oe0Q00@0oe0Q0P0000030?m>7`030000003o
CQl0odhO00<0odhO2P0`@hP00`000000oooo0?ooo`0>0?ooo`030000003oool0oooo00D0oooo0006
0?ooo`030000003oool0oooo01T0oooo00<0000003YEZ`0000003P3E>AL00`0jEJ/0000003YEZ`0A
03YEZ`030000000jEJ/0>UF[0100>UF[00<0000003YEZ`0jEJ/04@0jEJ/00`000000>UF[03YEZ`0A
03YEZ`030000000jEJ/0>UF[0140>UF[00<0000003YEZ`0jEJ/01P0jEJ/5000000P0?EZe00<00000
03eJ]@0mF[D04`0mF[D00`000000?EZe03eJ]@0D03eJ]@030000000mF[D0?EZe01@0?EZe00<00000
03eJ]@0mF[D02P0mF[D00`000000oe8R0?mB8P0@0?mB8P030000003oDR80oe8R0100oe8R4@0mF[D0
0`000000?EZe03eJ]@0203eJ]@030000000mF[D0?EZe01L0?EZe00<000000?mB8P3oDR80103oDR80
0`000000oe8R0?mB8P080?mB8P@0000000<0oe0Q0000003oD2403P3oD2400`000000oe0Q0?m@8@0<
0?m@8@030000003oD240oe0Q00/0oe0Q00<000000?m@8@3oD2402P3oD2400`000000oe0Q0?m@8@0:
0?m@8@030000003oD240oe0Q00X0oe0Q00<000000?m@8@3oD2401`3oD242000000030?m>7`000000
odhO00<0odhO2`0`@hP00`000000oooo0?ooo`0>0?ooo`030000003oool0oooo00D0oooo00060?oo
o`030000003oool0oooo01T0oooo00<0000003YEZ`0000001P3E>AL00`0jEJ/0eCTG0=Di5`060=Di
5`030000000jEJ/0>UF[00H0>UF[00<0eCTG03YEZ`0jEJ/01`0jEJ/00`000000>UF[03YEZ`0@03YE
Z`030000000jEJ/0>UF[0140>UF[00<0000003YEZ`0jEJ/04P0jEJ/00`000000>UF[03YEZ`0A03YE
Z`030000000jEJ/0>UF[00D000003@0mF[D00`000000?EZe03eJ]@0D03eJ]@030000000mF[D0?EZe
01@0?EZe00<0000003eJ]@0mF[D0500mF[D00`000000?EZe03eJ]@0803eJ]@030000003oDR80oe8R
0100oe8R00<000000?mB8P3oDR804@3oDR8A03eJ]@030000000mF[D0?EZe0080?EZe00<0000003eJ
]@0mF[D05`0mF[D00`000000oe8R0?mB8P030?mB8P030000003oDR80oe8R00d0oe8R0`00000=0?m@
8@030000003oD240oe0Q00`0oe0Q00<000000?m@8@3oD2402`3oD2400`000000oe0Q0?m@8@0;0?m@
8@030000003oD240oe0Q00X0oe0Q00<000000?m@8@3oD2402P3oD2400`000000oe0Q0?m@8@090?m@
8@<000000`3oCQl60313R0H00000403oool00`000000oooo0?ooo`050?ooo`001P3oool00`000000
oooo0?ooo`0J0?ooo`8000003`3E>AL2000000L0>UF[00<0eCTG03YEZ`0jEJ/0200jEJ/00`000000
>UF[03YEZ`0@03YEZ`030000000jEJ/0>UF[0140>UF[00<0000003YEZ`0jEJ/04@0jEJ/00`000000
>UF[03YEZ`0>03YEZ`H000004`0mF[D00`000000?EZe03eJ]@0C03eJ]@030000000mF[D0?EZe01@0
?EZe00<0000003eJ]@0mF[D0500mF[D00`000000?EZe03eJ]@0703eJ]@030000003oDR80oe8R0140
oe8R00<000000?mB8P3oDR804@3oDR8A03eJ]@030000000mF[D0?EZe00<0?EZe00<0000003eJ]@0m
F[D05`0mF[D00`000000oe8R0?mB8P020?mB8P030000003oDR80oe8R00d0oe8R00<000000?mB8P3o
DR800P00000;0?m@8@030000003oD240oe0Q00`0oe0Q00<000000?m@8@3oD2402`3oD2400`000000
oe0Q0?m@8@0;0?m@8@030000003oD240oe0Q00X0oe0Q00<000000?m@8@3oD2402@3oD2400`000000
oe0Q0?m@8@0:0?m@8@030000003oD240oe0Q00T000001@0[>gP00`000000oooo0?ooo`0>0?ooo`03
0000003oool0oooo00D0oooo00060?ooo`030000003oool0oooo01X0oooo00<0000003YEZ`000000
3`3E>AL00`000000>UF[03YEZ`0@03YEZ`030000000jEJ/0>UF[0100>UF[00<0000003YEZ`0jEJ/0
4@0jEJ/00`000000>UF[03YEZ`0A03YEZ`030000000jEJ/0>UF[00P0>UF[1P00000303eJ]@030000
000mF[D0?EZe01<0?EZe00<0000003eJ]@0mF[D0500mF[D00`000000?EZe03eJ]@0C03eJ]@030000
000mF[D0?EZe01D0?EZe00<0000003eJ]@0mF[D01P0mF[D00`000000oe8R0?mB8P0@0?mB8P030000
003oDR80oe8R00/0oe8R00<0?EZe0?mB8P3oDR800`3oDR800`000000?EZe03eJ]@0?03eJ]@030000
000mF[D0?EZe00<0?EZe00<0000003eJ]@0mF[D05`0mF[D01@000000oe8R0?mB8P3oDR8000000100
oe8R00<000000?mB8P3oDR800P3oDR83000000L0oe0Q00<000000?m@8@3oD2403@3oD2400`000000
oe0Q0?m@8@0:0?m@8@030000003oD240oe0Q00/0oe0Q00<000000?m@8@3oD2402P3oD2400`000000
oe0Q0?m@8@0:0?m@8@030000003oD240oe0Q00X0oe0Q00<000000?m@8@3oD2400P3oD24<02/kN003
0000003oool0oooo00h0oooo00<000000?ooo`3oool01@3oool000H0oooo00<000000?ooo`3oool0
6P3oool00`000000>UF[0000000?0=Di5`030000000jEJ/0>UF[0100>UF[00<0000003YEZ`0jEJ/0
400jEJ/00`000000>UF[03YEZ`0A03YEZ`030000000jEJ/0>UF[0180>UF[00@0000003YEZ`0jEJ/0
>UF[1P00000:03eJ]@030000000mF[D0?EZe01<0?EZe00<0000003eJ]@0mF[D04`0mF[D00`000000
?EZe03eJ]@0D03eJ]@030000000mF[D0?EZe01@0?EZe00<0000003eJ]@0mF[D01@0mF[D200000140
oe8R00<000000?mB8P3oDR80303oDR800`0mF[D0oe8R0?mB8P020?mB8P8000004@0mF[D00`000000
?EZe03eJ]@0403eJ]@030000000mF[D0?EZe01L0?EZe00<000000?mB8P000000403oDR800`000000
oe8R0?mB8P060?mB8P<00000103oD2400`000000oe0Q0?m@8@0<0?m@8@030000003oD240oe0Q00/0
oe0Q00<000000?m@8@3oD2402`3oD2400`000000oe0Q0?m@8@0:0?m@8@030000003oD240oe0Q00T0
oe0Q00<000000?m@8@3oD2402P3oD2400`000000oe0Q0?m@8@020?m@8@`0:c]h00<000000?ooo`3o
ool03`3oool00`000000oooo0?ooo`050?ooo`001P3oool00`000000oooo0?ooo`0K0?ooo`030000
000jEJ/0000000l0eCTG00<0000003YEZ`0jEJ/0400jEJ/00`000000>UF[03YEZ`0@03YEZ`030000
000jEJ/0>UF[0140>UF[00<0000003YEZ`0jEJ/03`0jEJ/600000100?EZe00<0000003eJ]@0mF[D0
4`0mF[D00`000000?EZe03eJ]@0D03eJ]@030000000mF[D0?EZe01<0?EZe00<0000003eJ]@0mF[D0
500mF[D00`000000?EZe03eJ]@0403eJ]@030000003oDb80oe<R00<000003P3oDR800`000000oe8R
0?mB8P0A0?mB8P030000000mF[D000000100?EZe00<0000003eJ]@0mF[D0100mF[D00`000000?EZe
03eJ]@0G03eJ]@030000003oDR80000000l0oe8R00<000000?mB8P3oDR802P3oDR82000000030?m@
8@000000oe0Q00h0oe0Q00<000000?m@8@3oD2402`3oD2400`000000oe0Q0?m@8@0:0?m@8@030000
003oD240oe0Q00X0oe0Q00<000000?m@8@3oD2402P3oD2400`000000oe0Q0?m@8@0:0?m@8@040000
003oD240oe0Q0?m@8@d0:c]h00<000000?ooo`3oool03`3oool00`000000oooo0?ooo`050?ooo`00
1@3oool00`000000oooo0?ooo`0L0?ooo`030000000jEJ/0000000l0eCTG00<000000=Di5`0jEJ/0
0`0jEJ/00`3E>AL0>UF[03YEZ`0:03YEZ`030000000jEJ/0>UF[0100>UF[00<0000003YEZ`0jEJ/0
4@0jEJ/00`000000>UF[03YEZ`0:03YEZ`D000000P0mF[D00`000000?EZe03eJ]@0B03eJ]@030000
000mF[D0?EZe01<0?EZe00<0000003eJ]@0mF[D04`0mF[D00`000000?EZe03eJ]@0D03eJ]@030000
000mF[D0?EZe01@0?EZe00<0000003eJ]@0mF[D00P0mF[D00`000000oe<R0?mC8P040?mC8P<00000
2P3oDR800`000000oe8R0?mB8P0A0?mB8P040000003oDR80?EZe00000100?EZe00<0000003eJ]@0m
F[D01@0mF[D00`000000?EZe03eJ]@0G03eJ]@030000003oDR80oe8R00h0oe8R00<000000?mB8P3o
DR80303oDR83000000d0oe0Q00<000000?m@8@3oD2402`3oD2400`000000oe0Q0?m@8@0;0?m@8@03
0000003oD240oe0Q00X0oe0Q00<000000?m@8@3oD2402P3oD2400`000000oe0Q0?m@8@090?m@8@03
0000003oD240oe0Q0080oe0Q3@0[>gP00`000000oooo0?ooo`0?0?ooo`030000003oool0oooo00D0
oooo00050?ooo`030000003oool0oooo01`0oooo00<0000003YEZ`0000003`3E>AL2000000@0>UF[
00<0eCTG03YEZ`0jEJ/02P0jEJ/00`000000>UF[03YEZ`0@03YEZ`030000000jEJ/0>UF[0140>UF[
00<0000003YEZ`0jEJ/01P0jEJ/4000000P0?EZe00<0000003eJ]@0mF[D04@0mF[D00`000000?EZe
03eJ]@0C03eJ]@030000000mF[D0?EZe01<0?EZe00<0000003eJ]@0mF[D0500mF[D00`000000?EZe
03eJ]@0D03eJ]@050000000mF[D0?EZe03eJ]@0000002P3oDb84000000D0oe8R00<000000?mB8P3o
DR804@3oDR800`000000oe8R03eJ]@0203eJ]@030000000mF[D0?EZe00d0?EZe00<0000003eJ]@0m
F[D01@0mF[D00`000000?EZe03eJ]@0E03eJ]@<000003`3oDR800`000000oe8R0?mB8P0=0?mB8P03
0000003oDR80oe8R008000002`3oD2400`000000oe0Q0?m@8@0;0?m@8@030000003oD240oe0Q00/0
oe0Q00<000000?m@8@3oD2402@3oD2400`000000oe0Q0?m@8@0:0?m@8@030000003oD240oe0Q00X0
oe0Q00@000000?m@8@3oD240oe0Q3P0[>gP00`000000oooo0?ooo`0?0?ooo`030000003oool0oooo
00D0oooo00050?ooo`030000003oool0oooo01d0oooo00<0000003YEZ`0000003`3E>AL00`000000
eCTG03YEZ`0@03YEZ`030000000jEJ/0>UF[0100>UF[00<0000003YEZ`0jEJ/04@0jEJ/00`000000
>UF[03YEZ`05000000`0?EZe00<0000003eJ]@0mF[D04P0mF[D00`000000?EZe03eJ]@0C03eJ]@03
0000000mF[D0?EZe01<0?EZe00<0000003eJ]@0mF[D0500mF[D00`000000?EZe03eJ]@0D03eJ]@03
0000000mF[D0000000l0oe<R0`0000020?mB8P030000003oDR80oe8R0100oe8R00<000000?mB8P3o
DR800`0mF[D00`000000?EZe03eJ]@0=03eJ]@030000000mF[D0?EZe00H0?EZe00<0000003eJ]@0m
F[D03P0mF[D6000000<0@5no00<000000?mB8P3oDR802`3oDR800`000000oe8R0?mB8P0>0?mB8P03
0000003oDR80oe8R0080oe8R0`0000070?m@8@030000003oD240oe0Q00/0oe0Q00<000000?m@8@3o
D2402`3oD2400`000000oe0Q0?m@8@0:0?m@8@030000003oD240oe0Q00X0oe0Q00<000000?m@8@3o
D2402@3oD24010000000oe0Q0?m@8@3oD24?02/kN0030000003oool0oooo00l0oooo00<000000?oo
o`3oool01@3oool000D0oooo00<000000?ooo`3oool07@3oool00`000000>UF[0000000?0=Di5`03
0000003E>AL0eCTG0100>UF[00<0000003YEZ`0jEJ/0400jEJ/00`000000>UF[03YEZ`0>03YEZ`H0
00004P0mF[D00`000000?EZe03eJ]@0A03eJ]@030000000mF[D0?EZe01<0?EZe00<0000003eJ]@0m
F[D04`0mF[D00`000000?EZe03eJ]@0D03eJ]@030000000mF[D0?EZe01@0?EZe0P00000C0?mC8P<0
00003`3oDR80100mF[D0oe8R0?mB8P0000020?mB8P@0?EZe00<0000003eJ]@0mF[D0300mF[D00`00
0000?EZe03eJ]@0603eJ]@030000000mF[D0?EZe00P0?EZe1P000009041O_`030000003oDR80oe8R
00/0oe8R00<000000?mB8P3oDR803@3oDR800`000000oe8R0?mB8P060?mB8P<00000103oD2400`00
0000oe0Q0?m@8@0;0?m@8@030000003oD240oe0Q00/0oe0Q00<000000?m@8@3oD2402P3oD2400`00
0000oe0Q0?m@8@090?m@8@030000003oD240oe0Q00X0oe0Q00<000000?m@8@3oD2403`0[>gP00`00
0000oooo0?ooo`0@0?ooo`030000003oool0oooo00D0oooo00050?ooo`030000003oool0oooo01d0
oooo00@0000003YEZ`0jEJ/000003`3E>AL00`000000eCTG0=Di5`0?03YEZ`030000000jEJ/0>UF[
0100>UF[00<0000003YEZ`0jEJ/0200jEJ/6000000<0?EZe00<0000003eJ]@0mF[D04P0mF[D00`00
0000?EZe03eJ]@0B03eJ]@030000000mF[D0?EZe01<0?EZe00<0000003eJ]@0mF[D04`0mF[D00`00
0000?EZe03eJ]@0D03eJ]@030000000mF[D0?EZe01<0?EZe00<000000?mC8P3oDb804P3oDb800`00
0000oe<R0?mC8P03000000h0oe8R00@000000?mB8P3oDR80oe8R100mF[D00`000000?EZe03eJ]@0<
03eJ]@030000000mF[D0?EZe00L0?EZe00@0000003eJ]@0mF[D0?EZe1P00000@041O_`030000003o
DR80oe8R00T0oe8R00<000000?mB8P3oDR803@3oDR800`000000oe8R0?mB8P0:0?mB8P80000000<0
oe0Q0000003oD240303oD2400`000000oe0Q0?m@8@0;0?m@8@030000003oD240oe0Q00X0oe0Q00<0
00000?m@8@3oD2402P3oD2400`000000oe0Q0?m@8@090?m@8@040000003oD240oe0Q0?m@8@l0:c]h
00<000000?ooo`3oool0403oool00`000000oooo0?ooo`050?ooo`001@3oool00`000000oooo0?oo
o`0N0?ooo`040000000jEJ/00000000000h0eCTG00@000000=Di5`3E>AL0eCTG3`0jEJ/00`000000
>UF[03YEZ`0@03YEZ`040000000jEJ/0>UF[03YEZ`H000002P0mF[D00`000000?EZe03eJ]@0B03eJ
]@030000000mF[D0?EZe0140?EZe00<0000003eJ]@0mF[D04`0mF[D00`000000?EZe03eJ]@0C03eJ
]@030000000mF[D0?EZe01@0?EZe00<0000003eJ]@0mF[D04P0mF[D00`000000oe<R0?mC8P0B0?mC
8P030000003oDb80oe<R00@0oe<R0`00000:0?mB8P040000003oDR80oe8R0?mB8PH0?EZe00<00000
03eJ]@0mF[D02`0mF[D00`000000?EZe03eJ]@0403eJ]@L000005P10Gkl00`000000oe8R0?mB8P08
0?mB8P030000003oDR80oe8R00d0oe8R00<000000?mB8P3oDR803@3oDR83000000`0oe0Q00<00000
0?m@8@3oD2402`3oD2400`000000oe0Q0?m@8@0:0?m@8@030000003oD240oe0Q00T0oe0Q00<00000
0?m@8@3oD2402P3oD2400`000000oe0Q0?m@8@0@02/kN0030000003oool0oooo0100oooo00<00000
0?ooo`3oool01@3oool000D0oooo00<000000?ooo`3oool07P3oool00`000000>UF[03YEZ`050000
00X0eCTG00@000000=Di5`3E>AL0eCTG3`0jEJ/00`000000>UF[03YEZ`0>03YEZ`H00000400mF[D0
0`000000?EZe03eJ]@0B03eJ]@030000000mF[D0?EZe0180?EZe00<0000003eJ]@0mF[D04`0mF[D0
0`000000?EZe03eJ]@0C03eJ]@030000000mF[D0?EZe01@0?EZe00<0000003eJ]@0mF[D0400mF[D0
0`000000oe<R0?mC8P0B0?mC8P030000003oDb80oe<R00P0oe<R100000050?mB8P030000003oDR80
oe8R0080oe8R1P0mF[D00`000000?EZe03eJ]@0:03eJ]@P000001010Gkl00`000000@5no041O_`0G
041O_`030000003oDR80oe8R00L0oe8R00<000000?mB8P3oDR803@3oDR800`000000oe8R0?mB8P0=
0?mB8P030000003oDR80oe8R00<00000203oD2400`000000oe0Q0?m@8@0;0?m@8@030000003oD240
oe0Q00X0oe0Q00<000000?m@8@3oD2402P3oD2400`000000oe0Q0?m@8@090?m@8@030000003oD240
oe0Q00@0:c]h00<0oe0Q02/kN00[>gP02P0[>gP00`000000oooo0?ooo`0@0?ooo`030000003oool0
oooo00D0oooo00050?ooo`030000003oool0oooo01h0oooo00@0000003YEZ`0jEJ/00000102c;a83
000000P0eCTG00@000000=Di5`3E>AL0eCTG3P0jEJ/00`000000>UF[03YEZ`0803YEZ`H000000`0m
F[D00`000000?EZe03eJ]@0A03eJ]@030000000mF[D0?EZe0180?EZe00<0000003eJ]@0mF[D04@0m
F[D00`000000?EZe03eJ]@0C03eJ]@030000000mF[D0?EZe01<0?EZe00<0000003eJ]@0mF[D0500m
F[D00`000000?EZe03eJ]@0?03eJ]@030000003oDb80oe<R0180oe<R00<000000?mC8P3oDb803@3o
Db8300000080oe8R00<000000?mB8P3oDR800P3oDR8703eJ]@040000000mF[D0?EZe03eJ]@P00000
00<0@5no00000010Gkl02@10Gkl00`000000@5no041O_`0H041O_`030000003oDR80oe8R00D0oe8R
00<000000?mB8P3oDR803@3oDR800`000000oe8R0?mB8P0>0?mB8P030000003oDR80oe8R00<0oe8R
0`0000050?m@8@030000003oD240oe0Q00/0oe0Q00<000000?m@8@3oD2402P3oD2400`000000oe0Q
0?m@8@0:0?m@8@030000003oD240oe0Q00T0oe0Q00<000000?m@8@0[>gP04@0[>gP00`000000oooo
0?ooo`0@0?ooo`030000003oool0oooo00D0oooo00050?ooo`030000003oool0oooo01l0oooo00@0
000003YEZ`0jEJ/000001P2c;a84000000@0eCTG00<000000=Di5`3E>AL00P3E>AL>03YEZ`040000
000jEJ/0>UF[03YEZ`H000002@0mF[D00`000000?EZe03eJ]@0A03eJ]@030000000mF[D0?EZe0180
?EZe00<0000003eJ]@0mF[D04P0mF[D00`000000?EZe03eJ]@0C03eJ]@030000000mF[D0?EZe01<0
?EZe00<0000003eJ]@0mF[D04`0mF[D00`000000?EZe03eJ]@0>03eJ]@030000003oDb80oe<R0180
oe<R00<000000?mC8P3oDb804@3oDb84000000<0oe8R100mF[D7000000T0@5no00<00000041O_`10
Gkl02@10Gkl00`000000@5no041O_`0G041O_`030000003oDR80oe8R00@0oe8R00<000000?mB8P3o
DR803@3oDR800`000000oe8R0?mB8P0>0?mB8P030000003oDR80oe8R00L0oe8R0`0000000`3oD240
00000?m@8@0=0?m@8@030000003oD240oe0Q00T0oe0Q00<000000?m@8@3oD2402P3oD2400`000000
oe0Q0?m@8@090?m@8@030000003oD240:c]h0140:c]h00<000000?ooo`3oool04@3oool00`000000
oooo0?ooo`050?ooo`001@3oool00`000000oooo0?ooo`0O0?ooo`050000000jEJ/0>UF[03YEZ`00
00002@2c;a84000000030=Di5`000000eCTG00<0eCTG2`0jEJ/600000100?EZe00<0000003eJ]@0m
F[D04@0mF[D00`000000?EZe03eJ]@0B03eJ]@030000000mF[D0?EZe0140?EZe00<0000003eJ]@0m
F[D04`0mF[D00`000000?EZe03eJ]@0C03eJ]@030000000mF[D0?EZe01@0?EZe00<0000003eJ]@0m
F[D0300mF[D00`000000oe<R0?mC8P0B0?mC8P030000003oDb80oe<R0180oe<R00@000000?mC8P3o
Db80oe<R1`000004041O_`0300000010Gkl0@5no00X0@5no00<00000041O_`10Gkl02010Gkl00`00
0000@5no041O_`0H041O_`030000003oDR80oe8R00<0oe8R00<000000?mB8P3oDR803@3oDR800`00
0000oe8R0?mB8P0=0?mB8P030000003oDR80oe8R00/0oe8R0`00000<0?m@8@030000003oD240oe0Q
00X0oe0Q00<000000?m@8@3oD2402P3oD2400`000000oe0Q0?m@8@090?m@8@030000000[>gP0:c]h
00L0:c]h00<0oe0Q02/kN00[>gP01`0[>gP00`000000oooo0?ooo`0B0?ooo`030000003oool0oooo
00@0oooo00050?ooo`030000003oool0oooo01l0oooo00<0000003YEZ`0jEJ/00P0jEJ/00`000000
/blB0;<_4P0:0;<_4P@000000`3E>AL403YEZ`H000000`0mF[D00`000000?EZe03eJ]@0@03eJ]@03
0000000mF[D0?EZe0140?EZe00<0000003eJ]@0mF[D04P0mF[D00`000000?EZe03eJ]@0B03eJ]@03
0000000mF[D0?EZe01<0?EZe00<0000003eJ]@0mF[D04`0mF[D00`000000?EZe03eJ]@0C03eJ]@03
0000000mF[D0?EZe00/0?EZe00<000000?mC8P3oDb804P3oDb800`000000oe<R0?mC8P0B0?mC8P03
0000003oDb80oe<R00@0oe<R2@10Gkl00`000000@5no041O_`0:041O_`0300000010Gkl0@5no00T0
@5no00<00000041O_`10Gkl05`10Gkl00`000000oe8R0?mB8P020?mB8P030000003oDR80oe8R00d0
oe8R00<000000?mB8P3oDR803@3oDR800`000000oe8R0?mB8P0<0?mB8P030000003oDR80oe8R0080
00002P3oD2400`000000oe0Q0?m@8@090?m@8@030000003oD240oe0Q00X0oe0Q00<000000?m@8@3o
D2402@3oD2400`000000:c]h02/kN00B02/kN0030000003oool0oooo0180oooo00<000000?ooo`3o
ool0103oool000D0oooo00<000000?ooo`3oool0803oool01@000000>UF[03YEZ`0jEJ/0000000h0
/blB00<000000;<_4P0000001P00000903eJ]@030000000mF[D0?EZe0140?EZe00<0000003eJ]@0m
F[D04@0mF[D00`000000?EZe03eJ]@0B03eJ]@030000000mF[D0?EZe0140?EZe00<0000003eJ]@0m
F[D04`0mF[D00`000000?EZe03eJ]@0C03eJ]@030000000mF[D0?EZe01@0?EZe00<0000003eJ]@0m
F[D02@0mF[D00`000000oe<R0?mC8P0B0?mC8P030000003oDb80oe<R0180oe<R00<000000?mC8P3o
Db801@3oDb8:041O_`0300000010Gkl0@5no00T0@5no00<00000041O_`10Gkl02P10Gkl00`000000
@5no041O_`0G041O_`040000003oDR80oe8R000000l0oe8R00<000000?mB8P3oDR803P3oDR800`00
0000oe8R0?mB8P0<0?mB8P030000003oDR80oe8R0080oe8R0P0000070?m@8@030000003oD240oe0Q
00X0oe0Q00<000000?m@8@3oD2402P3oD2400`000000oe0Q0?m@8@090?m@8@030000000[>gP0:c]h
0180:c]h00<000000?ooo`3oool04P3oool00`000000oooo0?ooo`040?ooo`001@3oool00`000000
oooo0?ooo`0P0?ooo`030000000jEJ/0>UF[0080>UF[00<000000;<_4P2c;a802`2c;a800`000000
/blB0;<_4P040;<_4P`0?EZe00<0000003eJ]@0mF[D0400mF[D00`000000?EZe03eJ]@0A03eJ]@03
0000000mF[D0?EZe0180?EZe00<0000003eJ]@0mF[D04P0mF[D00`000000?EZe03eJ]@0C03eJ]@03
0000000mF[D0?EZe0180?EZe00<0000003eJ]@0mF[D0500mF[D00`000000?EZe03eJ]@0803eJ]@03
0000003oDb80oe<R0180oe<R00<000000?mC8P3oDb804P3oDb800`000000oe<R0?mC8P060?mC8PX0
@5no00<00000041O_`10Gkl02@10Gkl00`000000@5no041O_`0:041O_`0300000010Gkl0@5no01P0
@5no0P00000@0?mB8P030000003oDR80oe8R00d0oe8R00<000000?mB8P3oDR80303oDR800`000000
oe8R0?mB8P050?mB8P<00000103oD2400`000000oe0Q0?m@8@0:0?m@8@030000003oD240oe0Q00T0
oe0Q00<000000?m@8@3oD2402P3oD2400`000000:c]h02/kN00:02/kN0030?ooo`0[>gP0:c]h00D0
:c]h00<000000?ooo`3oool04P3oool00`000000oooo0?ooo`040?ooo`001@3oool00`000000oooo
0?ooo`0P0?ooo`030000000jEJ/0>UF[00<0>UF[00<000000;<_4P2c;a802`2c;a800`000000/blB
0;<_4P040;<_4P/0?EZe00<0000003eJ]@0mF[D04@0mF[D00`000000?EZe03eJ]@0A03eJ]@030000
000mF[D0?EZe0180?EZe00<0000003eJ]@0mF[D04@0mF[D00`000000?EZe03eJ]@0C03eJ]@030000
000mF[D0?EZe01<0?EZe00<0000003eJ]@0mF[D0500mF[D00`000000?EZe03eJ]@0603eJ]@030000
003oDb80oe<R0180oe<R00<000000?mC8P3oDb804P3oDb800`000000oe<R0?mC8P070?mC8P/0@5no
00<00000041O_`10Gkl02010Gkl00`000000@5no041O_`0;041O_`0300000010Gkl0@5no01L0@5no
0P00000?0?mB8P030000003oDR80oe8R00d0oe8R00<000000?mB8P3oDR80303oDR800`000000oe8R
0?mB8P090?mB8P80000000<0oe0Q0000003oD2402`3oD2400`000000oe0Q0?m@8@0:0?m@8@030000
003oD240oe0Q00T0oe0Q00<0000002/kN00[>gP04`0[>gP00`000000oooo0?ooo`0B0?ooo`030000
003oool0oooo00@0oooo00050?ooo`030000003oool0oooo0240oooo00<0000003YEZ`0jEJ/00`00
000>0;<_4P030000002c;a80/blB00@0/blB2`0mF[D00`000000?EZe03eJ]@0@03eJ]@030000000m
F[D0?EZe0140?EZe00<0000003eJ]@0mF[D04P0mF[D00`000000?EZe03eJ]@0B03eJ]@030000000m
F[D0?EZe01<0?EZe00<0000003eJ]@0mF[D04P0mF[D00`000000?EZe03eJ]@0D03eJ]@030000000m
F[D0?EZe00D0?EZe00<000000?mC8P3oDb804P3oDb800`000000oe<R0?mC8P0B0?mC8P030000003o
Db80oe<R00L0oe<R3@10Gkl00`000000@5no041O_`07041O_`0300000010Gkl0@5no00`0@5no00<0
0000041O_`10Gkl05`10Gkl00`000000oe8R0?mB8P0<0?mB8P030000003oDR80oe8R00d0oe8R00<0
00000?mB8P3oDR80303oDR800`000000oe8R0?mB8P0<0?mB8P<000002`3oD2400`000000oe0Q0?m@
8@090?m@8@030000003oD240oe0Q00T0oe0Q00<0:c]h0000000[>gP04`0[>gP00`000000oooo0?oo
o`0C0?ooo`030000003oool0oooo00@0oooo00050?ooo`030000003oool0oooo0240oooo0`000003
03eJ]@030000002c;a80/blB00`0/blB00<000000;<_4P2c;a80102c;a8:03eJ]@030000000mF[D0
?EZe0140?EZe00<0000003eJ]@0mF[D04@0mF[D00`000000?EZe03eJ]@0A03eJ]@030000000mF[D0
?EZe0180?EZe00<0000003eJ]@0mF[D04`0mF[D00`000000?EZe03eJ]@0C03eJ]@030000000mF[D0
?EZe01@0?EZe00<0000003eJ]@0mF[D00`0mF[D00`000000oe<R0?mC8P0B0?mC8P030000003oDb80
oe<R0180oe<R00<000000?mC8P3oDb80203oDb8=041O_`0300000010Gkl0@5no00L0@5no00<00000
041O_`10Gkl03010Gkl00`000000@5no041O_`0G041O_`030000003oDR80oe8R00/0oe8R00<00000
0?mB8P3oDR803P3oDR800`000000oe8R0?mB8P0<0?mB8P030000003oDR80oe8R00`0oe8R00<00000
0?mB8P3oDR800`0000070?m@8@030000003oD240oe0Q00X0oe0Q00<000000?m@8@3oD240203oD242
02/kN0030000000[>gP0:c]h00d0:c]h00<0oooo02/kN00[>gP00P0[>gP00`000000oooo0?ooo`0C
0?ooo`030000003oool0oooo00@0oooo00040?ooo`030000003oool0oooo02<0oooo00<0000003eJ
]@0mF[D00`0mF[D00`000000/blB0;<_4P0;0;<_4P030000002c;a80/blB00H0/blB2@0mF[D00`00
0000?EZe03eJ]@0@03eJ]@030000000mF[D0?EZe0140?EZe00<0000003eJ]@0mF[D04P0mF[D00`00
0000?EZe03eJ]@0B03eJ]@030000000mF[D0?EZe01<0?EZe00<0000003eJ]@0mF[D04P0mF[D00`00
0000?EZe03eJ]@0D03eJ]@030000000mF[D0?EZe0080?EZe00<000000?mC8P3oDb804P3oDb800`00
0000oe<R0?mC8P0B0?mC8P030000003oDb80oe<R00T0oe<R3P10Gkl00`000000@5no041O_`06041O
_`0300000010Gkl0@5no00d0@5no00<00000041O_`10Gkl05`10Gkl00`000000oe8R0?mB8P0:0?mB
8P030000003oDR80oe8R00d0oe8R00<000000?mB8P3oDR80303oDR800`000000oe8R0?mB8P0=0?mB
8P030000003oDR80oe8R00<0oe8R0P0000050?m@8@030000003oD240oe0Q00X0oe0Q00<000000?m@
8@3oD240203oD24202/kN0030000000[>gP0:c]h0180:c]h00<000000?ooo`3oool04`3oool00`00
0000oooo0?ooo`040?ooo`00103oool00`000000oooo0?ooo`0S0?ooo`030000000mF[D0?EZe00<0
?EZe00<000000;<_4P2c;a80302c;a800`000000/blB0;<_4P060;<_4PP0?EZe00<0000003eJ]@0m
F[D04@0mF[D00`000000?EZe03eJ]@0A03eJ]@030000000mF[D0?EZe0140?EZe00<0000003eJ]@0m
F[D04P0mF[D00`000000?EZe03eJ]@0C03eJ]@030000000mF[D0?EZe01<0?EZe00<0000003eJ]@0m
F[D0500mF[D010000000?EZe03eJ]@00000D0?mC8P030000003oDb80oe<R0180oe<R00<000000?mC
8P3oDb802P3oDb8?041O_`0300000010Gkl0@5no00D0@5no00<00000041O_`10Gkl03@10Gkl00`00
0000@5no041O_`0H041O_`030000003oDR80oe8R00P0oe8R00<000000?mB8P3oDR803@3oDR800`00
0000oe8R0?mB8P0<0?mB8P030000003oDR80oe8R00d0oe8R00<000000?mB8P3oDR801P3oDR830000
00030?m@8@000000oe0Q00/0oe0Q00<000000?m@8@3oD240203oD24202/kN0030000000[>gP0:c]h
01<0:c]h00<000000?ooo`3oool04`3oool00`000000oooo0?ooo`040?ooo`00103oool00`000000
oooo0?ooo`0T0?ooo`030000000mF[D0?EZe00<0?EZe00<000000;<_4P2c;a80302c;a800`000000
/blB0;<_4P060;<_4PP0?EZe00<0000003eJ]@0mF[D0400mF[D00`000000?EZe03eJ]@0A03eJ]@03
0000000mF[D0?EZe0180?EZe00<0000003eJ]@0mF[D04P0mF[D00`000000?EZe03eJ]@0C03eJ]@03
0000000mF[D0?EZe0180?EZe00<0000003eJ]@0mF[D04P0mF[D5000001D0oe<R00<000000?mC8P3o
Db804@3oDb800`000000oe<R0?mC8P0;0?mC8Pl0@5no00<00000041O_`10Gkl01@10Gkl00`000000
@5no041O_`0>041O_`0300000010Gkl0@5no01L0@5no00<000000?mB8P3oDR801`3oDR800`000000
oe8R0?mB8P0>0?mB8P030000003oDR80oe8R00/0oe8R00<000000?mB8P3oDR803@3oDR800`000000
oe8R0?mB8P0:0?mB8P<000002`3oD2400`000000oe0Q0?m@8@070?m@8@<0:c]h00<0000002/kN00[
>gP0400[>gP0103oool0:c]h02/kN000000E0?ooo`030000003oool0oooo00@0oooo00040?ooo`03
0000003oool0oooo02@0oooo00<0000003eJ]@0mF[D0100mF[D00`000000/blB0;<_4P0<0;<_4P03
0000002c;a80/blB00H0/blB1`0mF[D00`000000?EZe03eJ]@0A03eJ]@030000000mF[D0?EZe0140
?EZe00<0000003eJ]@0mF[D04@0mF[D00`000000?EZe03eJ]@0B03eJ]@030000000mF[D0?EZe01<0
?EZe00<0000003eJ]@0mF[D04`0mF[D00`000000?EZe03eJ]@0<03eJ]@D000000`10Gkl00`000000
oe<R0?mC8P0C0?mC8P030000003oDb80oe<R0140oe<R00<000000?mC8P3oDb802`3oDb8A041O_`03
00000010Gkl0@5no00@0@5no00<00000041O_`10Gkl03`10Gkl00`000000@5no041O_`0G041O_`03
0000003oDR80oe8R00H0oe8R00<000000?mB8P3oDR803@3oDR800`000000oe8R0?mB8P0<0?mB8P03
0000003oDR80oe8R00`0oe8R00<000000?mB8P3oDR802`3oDR800`000000oe8R0?mB8P03000000L0
oe0Q00<000000?m@8@3oD2401`3oD24402/kN0030000000[>gP0:c]h0180:c]h00<000000?ooo`3o
ool0503oool00`000000oooo0?ooo`040?ooo`00103oool00`000000oooo0?ooo`0U0?ooo`030000
000mF[D0?EZe00@0?EZe00<000000;<_4P2c;a802`2c;a800`000000/blB0;<_4P070;<_4PL0?EZe
00<0000003eJ]@0mF[D0400mF[D00`000000?EZe03eJ]@0A03eJ]@030000000mF[D0?EZe0180?EZe
00<0000003eJ]@0mF[D04P0mF[D00`000000?EZe03eJ]@0C03eJ]@030000000mF[D0?EZe0180?EZe
00<0000003eJ]@0mF[D01P0mF[D6000000L0@5no00<000000?mC8P3oDb804`3oDb800`000000oe<R
0?mC8P0A0?mC8P030000003oDb80oe<R00`0oe<R4@10Gkl00`000000@5no041O_`04041O_`030000
0010Gkl0@5no00l0@5no00<00000041O_`10Gkl05`10Gkl00`000000oe8R0?mB8P050?mB8P030000
003oDR80oe8R00d0oe8R00<000000?mB8P3oDR80303oDR800`000000oe8R0?mB8P0=0?mB8P030000
003oDR80oe8R00/0oe8R00<000000?mB8P3oDR800`3oDR82000000D0oe0Q00<000000?m@8@3oD240
1`3oD24402/kN0030000000[>gP0:c]h0180:c]h00<000000?ooo`3oool0503oool00`000000oooo
0?ooo`040?ooo`00103oool00`000000oooo0?ooo`0U0?ooo`030000000mF[D0?EZe00@0?EZe00<0
00000;<_4P2c;a80302c;a800`000000/blB0;<_4P080;<_4PD0?EZe00<0000003eJ]@0mF[D04@0m
F[D00`000000?EZe03eJ]@0A03eJ]@030000000mF[D0?EZe0140?EZe00<0000003eJ]@0mF[D04P0m
F[D00`000000?EZe03eJ]@0C03eJ]@030000000mF[D0?EZe01<0?EZe00<0000003eJ]@0mF[D01@00
000<041O_`030000003oDb80oe<R01<0oe<R00<000000?mC8P3oDb804@3oDb800`000000oe<R0?mC
8P0=0?mC8Q80@5no00<00000041O_`10Gkl00`10Gkl00`000000@5no041O_`0@041O_`0300000010
Gkl0@5no01L0@5no00<000000?mB8P3oDR800`3oDR800`000000oe8R0?mB8P0=0?mB8P030000003o
DR80oe8R00`0oe8R00<000000?mB8P3oDR803@3oDR800`000000oe8R0?mB8P0;0?mB8P030000003o
DR80oe8R00H0oe8R0`0000000`3oD24000000?m@8@080?m@8@@0:c]h00<0000002/kN00[>gP03P0[
>gP6000001H0oooo00<000000?ooo`3oool0103oool000@0oooo00<000000?ooo`3oool09P3oool0
0`000000?EZe03eJ]@0403eJ]@030000002c;a80/blB00`0/blB00<000000;<_4P2c;a80202c;a85
03eJ]@030000000mF[D0?EZe0100?EZe00<0000003eJ]@0mF[D04@0mF[D00`000000?EZe03eJ]@0B
03eJ]@030000000mF[D0?EZe0180?EZe00<0000003eJ]@0mF[D04`0mF[D00`000000?EZe03eJ]@0?
03eJ]@H000004010Gkl00`000000oe<R0?mC8P0C0?mC8P030000003oDb80oe<R0180oe<R00<00000
0?mC8P3oDb803@3oDb8C041O_`0300000010Gkl0@5no0080@5no00<00000041O_`10Gkl04@10Gkl0
0`000000@5no041O_`0G041O_`030000003oDR80oe8R0080oe8R00<000000?mB8P3oDR803@3oDR80
0`000000oe8R0?mB8P0<0?mB8P030000003oDR80oe8R00`0oe8R00<000000?mB8P3oDR802`3oDR80
0`000000oe8R0?mB8P0:0?mB8P<000001`3oD24502/kN0030000000[>gP0:c]h00<0:c]h2`000005
02@_H@030000003oool0oooo01@0oooo00<000000?ooo`3oool0103oool000@0oooo00<000000?oo
o`3oool09P3oool00`000000?EZe03eJ]@0503eJ]@030000002c;a80/blB00`0/blB00<000000;<_
4P2c;a80202c;a8403eJ]@030000000mF[D0?EZe0140?EZe00<0000003eJ]@0mF[D04@0mF[D00`00
0000?EZe03eJ]@0A03eJ]@030000000mF[D0?EZe0180?EZe00<0000003eJ]@0mF[D04`0mF[D00`00
0000?EZe03eJ]@0903eJ]@H000001010Gkl00`000000@5no041O_`0>041O_`030000003oDb80oe<R
01<0oe<R00<000000?mC8P3oDb804P3oDb800`000000oe<R0?mC8P0>0?mC8Q<0@5no00<00000041O
_`10Gkl00P10Gkl00`000000@5no041O_`0A041O_`0300000010Gkl0@5no01L0@5no00D000000?mB
8P3oDR80oe8R0000000?0?mB8P030000003oDR80oe8R00`0oe8R00<000000?mB8P3oDR803@3oDR80
0`000000oe8R0?mB8P0:0?mB8P030000003oDR80oe8R00/0oe8R00<000000?mB8P3oDR8010000002
0?m@8@<0:c]h2@00000?02@_H@030000003oool0oooo01D0oooo00<000000?ooo`3oool0103oool0
00@0oooo00<000000?ooo`3oool09`3oool00`000000?EZe03eJ]@0403eJ]@030000002c;a80/blB
00`0/blB00<000000;<_4P2c;a802@2c;a8403eJ]@030000000mF[D0?EZe0100?EZe00<0000003eJ
]@0mF[D04@0mF[D00`000000?EZe03eJ]@0B03eJ]@030000000mF[D0?EZe0180?EZe00<0000003eJ
]@0mF[D04`0mF[D010000000?EZe03eJ]@0mF[D7000000X0@5no00<00000041O_`10Gkl03@10Gkl0
0`000000oe<R0?mC8P0C0?mC8P030000003oDb80oe<R0180oe<R00<000000?mC8P3oDb803P3oDb8E
041O_`0500000010Gkl0@5no041O_`0000005010Gkl00`000000@5no041O_`0G041O_`030000003o
DR80000000l0oe8R00<000000?mB8P3oDR80303oDR800`000000oe8R0?mB8P0=0?mB8P030000003o
DR80oe8R00/0oe8R00<000000?mB8P3oDR802`3oDR800`000000oe8R0?mB8P040?mB8PD000000`0T
;f400`00000092mQ02@_H@0B02@_H@030000003oool0oooo01D0oooo00<000000?ooo`3oool0103o
ool000@0oooo00<000000?ooo`3oool09`3oool00`000000?EZe03eJ]@0503eJ]@030000002c;a80
/blB00`0/blB00<000000;<_4P2c;a802@2c;a8303eJ]@030000000mF[D0?EZe0140?EZe00<00000
03eJ]@0mF[D04@0mF[D00`000000?EZe03eJ]@0A03eJ]@030000000mF[D0?EZe0180?EZe00<00000
03eJ]@0mF[D0400mF[D700000180@5no00<00000041O_`10Gkl02`10Gkl00`000000oe<R0?mC8P0C
0?mC8P030000003oDb80oe<R0180oe<R00<000000?mC8P3oDb803`3oDb8F041O_`0400000010Gkl0
@5no000001@0@5no00<00000041O_`10Gkl05`10Gkl200000100oe8R00<000000?mB8P3oDR802`3o
DR800`000000oe8R0?mB8P0=0?mB8P030000003oDR80oe8R00/0oe8R00<000000?mB8P3oDR802`3o
DR800`000000oe8R0?mB8P050?mB8PL092mQ00<0000002@_H@0T;f404P0T;f400`000000oooo0?oo
o`0G0?ooo`030000003oool0oooo00<0oooo00040?ooo`030000003oool0oooo02P0oooo00<00000
03eJ]@0mF[D01@0mF[D00`000000/blB0;<_4P0<0;<_4P030000002c;a80/blB00X0/blB0P0mF[D0
0`000000?EZe03eJ]@0@03eJ]@030000000mF[D0?EZe0140?EZe00<0000003eJ]@0mF[D04P0mF[D0
0`000000?EZe03eJ]@0B03eJ]@030000000mF[D0?EZe00T0?EZe1P000004041O_`0300000010Gkl0
@5no01<0@5no00<00000041O_`10Gkl02@10Gkl2000001@0oe<R00<000000?mC8P3oDb804P3oDb80
0`000000oe<R0?mC8P0@0?mC8QH0@5no00@00000041O_`10Gkl000005@10Gkl00`000000@5no041O
_`0G041O_`030000003oDR80oe8R00d0oe8R00<000000?mB8P3oDR80303oDR800`000000oe8R0?mB
8P0<0?mB8P030000003oDR80oe8R00/0oe8R00<000000?mB8P3oDR802`3oDR800`000000oe8R0?mB
8P050?mB8PP092mQ00<0000002@_H@0T;f404P0T;f400`000000oooo0?ooo`0G0?ooo`030000003o
ool0oooo00<0oooo00040?ooo`030000003oool0oooo02P0oooo00<0000003eJ]@0mF[D01P0mF[D0
0`000000/blB0;<_4P0<0;<_4P030000002c;a80/blB00X0/blB00<0?EZe0000000mF[D04P0mF[D0
0`000000?EZe03eJ]@0A03eJ]@030000000mF[D0?EZe0140?EZe00<0000003eJ]@0mF[D04P0mF[D0
0`000000?EZe03eJ]@0203eJ]@L000002P10Gkl00`000000@5no041O_`0D041O_`0300000010Gkl0
@5no00H0@5no0P0000020?mC8P@000003`3oDb800`000000oe<R0?mC8P0B0?mC8P030000003oDb80
oe<R0140oe<R5`10Gkl00`000000@5no0000000F041O_`0300000010Gkl0@5no01L0@5no00<00000
0?mB8P3oDR802`3oDR800`000000oe8R0?mB8P0<0?mB8P030000003oDR80oe8R00d0oe8R00<00000
0?mB8P3oDR802`3oDR800`000000oe8R0?mB8P0:0?mB8P030000003oDR80oe8R00D0oe8R200T;f40
0`00000092mQ02@_H@0B02@_H@030000003oool0oooo01P0oooo00<000000?ooo`3oool00`3oool0
00@0oooo00<000000?ooo`3oool0:@3oool00`000000?EZe03eJ]@0503eJ]@030000002c;a80/blB
00`0/blB00<000000;<_4P2c;a802`2c;a800`0mF[D0000003eJ]@0A03eJ]@030000000mF[D0?EZe
0140?EZe00<0000003eJ]@0mF[D04P0mF[D00`000000?EZe03eJ]@0?03eJ]@L000004P10Gkl00`00
0000@5no041O_`0C041O_`0300000010Gkl0@5no00D0@5no00<000000?mC8P3oDb801P3oDb830000
00/0oe<R00<000000?mC8P3oDb804P3oDb800`000000oe<R0?mC8P0A0?mC8P0300000010Gkl0@5no
01D0@5no00<00000041O_`0000005P10Gkl00`000000@5no041O_`0G041O_`030000003oDR80oe8R
00X0oe8R00<000000?mB8P3oDR80303oDR800`000000oe8R0?mB8P0=0?mB8P030000003oDR80oe8R
00/0oe8R00<000000?mB8P3oDR802`3oDR800`000000oe8R0?mB8P030?mB8PX092mQ00<0000002@_
H@0T;f404P0T;f400`000000oooo0?ooo`0H0?ooo`030000003oool0oooo00<0oooo00040?ooo`03
0000003oool0oooo02T0oooo00<0000003eJ]@0mF[D01P0mF[D3000000`0/blB00<000000;<_4P2c
;a802`2c;a800`000000?EZe03eJ]@0A03eJ]@030000000mF[D0?EZe0140?EZe00<0000003eJ]@0m
F[D04@0mF[D00`000000?EZe03eJ]@0903eJ]@H000001010Gkl00`000000@5no041O_`0C041O_`03
00000010Gkl0@5no01<0@5no00<00000041O_`10Gkl00`10Gkl00`000000oe<R0?mC8P0:0?mC8P<0
00001`3oDb800`000000oe<R0?mC8P0B0?mC8P030000003oDb80oe<R0140oe<R00<00000041O_`00
00005`10Gkl2000001L0@5no00<00000041O_`10Gkl05`10Gkl00`000000oe8R0?mB8P090?mB8P03
0000003oDR80oe8R00`0oe8R00<000000?mB8P3oDR80303oDR800`000000oe8R0?mB8P0;0?mB8P03
0000003oDR80oe8R00/0oe8R00<000000?mB8P3oDR800`3oDR8;02@_H@030000000T;f4092mQ0180
92mQ00<000000?ooo`3oool0603oool00`000000oooo0?ooo`030?ooo`00103oool00`000000oooo
0?ooo`0Z0?ooo`030000000mF[D0?EZe00H0?EZe00<0000007lN300000000`0000090;<_4P030000
002c;a80/blB00/0/blB00<0000003eJ]@0mF[D0400mF[D00`000000?EZe03eJ]@0A03eJ]@030000
000mF[D0?EZe0180?EZe00@0000003eJ]@0mF[D0?EZe1`00000:041O_`0300000010Gkl0@5no01<0
@5no00<00000041O_`10Gkl05010Gkl00`000000@5no041O_`0200000100oe<R100000020?mC8P03
0000003oDb80oe<R0180oe<R00<000000?mC8P3oDb804@3oDb8010000000oe<R041O_`00000H041O
_`0300000010Gkl0@5no01H0@5no00<00000041O_`10Gkl05P10Gkl00`000000oe8R0?mB8P080?mB
8P030000003oDR80oe8R00`0oe8R00<000000?mB8P3oDR803@3oDR800`000000oe8R0?mB8P0:0?mB
8P030000003oDR80oe8R00/0oe8R00<000000?mB8P3oDR800`3oDR8;02@_H@030000000T;f4092mQ
018092mQ00<000000?ooo`3oool06@3oool00`000000oooo0?ooo`030?ooo`00103oool00`000000
oooo0?ooo`0[0?ooo`030000000mF[D0?EZe00H0?EZe00<0000007lN301o7P`00P1o7P`5000000D0
/blB00<000000;<_4P2c;a802`2c;a800`000000?EZe03eJ]@0@03eJ]@030000000mF[D0?EZe0140
?EZe00<0000003eJ]@0mF[D03P0mF[D700000180@5no00<00000041O_`10Gkl04`10Gkl00`000000
@5no041O_`0C041O_`0300000010Gkl0000001H0oe<R1000000B0?mC8P030000003oDb80oe<R0140
oe<R00<000000?mC8P3oDb800P10Gkl00`000000@5no041O_`0E041O_`0300000010Gkl0@5no01H0
@5no00<00000041O_`10Gkl05010Gkl4000000P0oe8R00<000000?mB8P3oDR80303oDR800`000000
oe8R0?mB8P0=0?mB8P030000003oDR80oe8R00/0oe8R00<000000?mB8P3oDR802P3oDR800`000000
oe8R0?mB8P030?mB8P`092mQ00<0000002@_H@0T;f404P0T;f400`000000oooo0?ooo`0I0?ooo`03
0000003oool0oooo00<0oooo00030?ooo`030000003oool0oooo02`0oooo00<0000003eJ]@0mF[D0
1`0mF[D00`000000Oah<07lN300607lN30@0000000<0/blB0000002c;a80302c;a800`000000/blB
03eJ]@0@03eJ]@030000000mF[D0?EZe0140?EZe00<0000003eJ]@0mF[D0200mF[D6000000@0@5no
00<00000041O_`10Gkl04`10Gkl00`000000@5no041O_`0C041O_`0300000010Gkl0@5no0180@5no
0P00000F0?mC8P8000000`3oDb84000000d0oe<R00<000000?mC8P3oDb804@3oDb800`000000oe<R
0?mC8P03041O_`0300000010Gkl0@5no01D0@5no0P00000H041O_`0300000010Gkl0@5no00/0@5no
2000000404=Ub@8000001@3oDR800`000000oe8R0?mB8P0<0?mB8P030000003oDR80oe8R00d0oe8R
00<000000?mB8P3oDR802`3oDR800`000000oe8R0?mB8P0;0?mB8P040000003oDR80oe8R0?mB8Pd0
92mQ00<0000002@_H@0T;f404P0T;f400`000000oooo0?ooo`0J0?ooo`030000003oool0oooo00<0
oooo00030?ooo`030000003oool0oooo02d0oooo00<0000003eJ]@0mF[D01`0mF[D00`000000Oah<
07lN300907lN30D000002`2c;a800`000000/blB03eJ]@0@03eJ]@030000000mF[D0?EZe0140?EZe
00@0000003eJ]@0mF[D0?EZe1P00000:041O_`0300000010Gkl0@5no01@0@5no00<00000041O_`10
Gkl04`10Gkl00`000000@5no041O_`0@041O_`030000003oDb80oe<R01D0oe<R00<000000?mC8P3o
Db801`3oDb84000000P0oe<R00<000000?mC8P3oDb804@3oDb8010000000oe<R0?mC8P3oDb84041O
_`0300000010Gkl0@5no01@0@5no00<00000041O_`0000005`10Gkl00`000000@5no041O_`03041O
_`P000003@13ILT400000080oe8R00<000000?mB8P3oDR80303oDR800`000000oe8R0?mB8P0<0?mB
8P030000003oDR80oe8R00/0oe8R00<000000?mB8P3oDR802`3oDR8010000000oe8R0?mB8P3oDR8>
02@_H@030000000T;f4092mQ018092mQ00<000000?ooo`3oool06P3oool00`000000oooo0?ooo`03
0?ooo`000`3oool00`000000oooo0?ooo`0]0?ooo`030000000mF[D0?EZe00P0?EZe00<0000007lN
301o7P`02`1o7P`00`000000Oah<00000003000000P0/blB00<000000;<_4P0mF[D03`0mF[D00`00
0000?EZe03eJ]@0?03eJ]@H000004@10Gkl00`000000@5no041O_`0C041O_`0300000010Gkl0@5no
01<0@5no00<00000041O_`10Gkl03P10Gkl2000001H0oe<R0P00000>0?mC8P@000000`3oDb800`00
0000oe<R0?mC8P0@0?mC8P800000103oDb84041O_`0300000010Gkl0@5no01@0@5no00<00000041O
_`0000005@10Gkl8000001H0@fG900<000000?mC8P3oDb800`00000=0?mB8P030000003oDR80oe8R
00d0oe8R00<000000?mB8P3oDR802`3oDR800`000000oe8R0?mB8P0:0?mB8P040000003oDR80oe8R
0?mB8Ph092mQ00<0000002@_H@0T;f404P0T;f400`000000oooo0?ooo`0K0?ooo`030000003oool0
oooo00<0oooo00030?ooo`030000003oool0oooo02h0oooo00<0000003eJ]@0mF[D0200mF[D00`00
0000Oah<07lN300;07lN30030000001o7P`0Oah<0080Oah<100000050;<_4P030000002c;a80/blB
00l0?EZe00<0000003eJ]@0mF[D0200mF[D6000000<0@5no00<00000041O_`10Gkl04P10Gkl00`00
0000@5no041O_`0C041O_`0300000010Gkl0@5no01<0@5no00<00000041O_`10Gkl03010Gkl00`00
0000oe<R0?mC8P0E0?mC8P030000003oDb80oe<R0180oe<R1000000A0?mC8P030000003oDb80oe<R
00<0oe<R1P10Gkl00`000000@5no041O_`0C041O_`0400000010Gkl0@5no000000`0@5no20000004
04=Ub@0300000013ILT0@fG901L0@fG900@000000?mC8P3oDb8000000P3oDb83000000T0oe8R00<0
00000?mB8P3oDR803@3oDR800`000000oe8R0?mB8P0;0?mB8P030000003oDR80oe8R00/0oe8R00<0
00000?mB8P3oDR803`0T;f400`00000092mQ02@_H@0B02@_H@030000003oool0oooo01/0oooo00<0
00000?ooo`3oool00`3oool000<0oooo00<000000?ooo`3oool0;P3oool00`000000?EZe03eJ]@09
03eJ]@030000001o7P`0Oah<00/0Oah<00<0000007lN301o7P`01@1o7P`4000000030;<_4P000000
/blB0080/blB3P0mF[D00`000000?EZe03eJ]@0203eJ]@H000002P10Gkl00`000000@5no041O_`0B
041O_`0300000010Gkl0@5no01<0@5no00<00000041O_`10Gkl04`10Gkl00`000000@5no041O_`0:
041O_`030000003oDb80oe<R01D0oe<R00<000000?mC8P3oDb804`3oDb8200000080oe<R1000000<
0?mC8P030000003oDb80oe<R00@0oe<R1`10Gkl00`000000@5no041O_`0B041O_`0400000010Gkl0
@5no000000@0@5no2000000=04=Ub@0300000013ILT0@fG901L0@fG90P0000060?mC8P<000001@3o
DR800`000000oe8R0?mB8P0=0?mB8P030000003oDR80oe8R00/0oe8R00<000000?mB8P3oDR802`3o
DR800`000000oe8R02@_H@0@02@_H@030000000T;f4092mQ018092mQ00<000000?ooo`3oool06`3o
ool00`000000oooo0?ooo`030?ooo`000`3oool00`000000oooo0?ooo`0_0?ooo`030000000mF[D0
?EZe00T0?EZe00<0000007lN301o7P`02`1o7P`00`000000Oah<07lN300807lN30D0000000<0/blB
03eJ]@0mF[D01P0mF[D:00000100@5no00<00000041O_`10Gkl04P10Gkl00`000000@5no041O_`0D
041O_`0300000010Gkl0@5no0180@5no00<00000041O_`10Gkl02010Gkl2000001H0oe<R0P00000E
0?mC8P030000003oDb80oe<R00H0oe<R100000070?mC8P030000003oDb80oe<R00D0oe<R1`10Gkl0
0`000000@5no041O_`0B041O_`P000005P13ILT00`000000@fG904=Ub@0G04=Ub@030000003oDb80
oe<R00L0oe<R0`0000020?mB8P030000003oDR80oe8R00d0oe8R00<000000?mB8P3oDR802P3oDR80
0`000000oe8R0?mB8P0;0?mB8P030000003oDR8092mQ010092mQ00<0000002@_H@0T;f404P0T;f40
0`000000oooo0?ooo`0L0?ooo`030000003oool0oooo00<0oooo00030?ooo`030000003oool0oooo
02l0oooo00<0000003eJ]@0mF[D02P0mF[D00`000000Oah<07lN300;07lN308000002`1o7P`00`00
0000Oah<00000008000000L0@5no00<00000041O_`10Gkl04@10Gkl00`000000@5no041O_`0B041O
_`0300000010Gkl0@5no01<0@5no00<00000041O_`10Gkl04`10Gkl00`000000@5no041O_`06041O
_`030000003oDb80oe<R01D0oe<R00<000000?mC8P3oDb804`3oDb82000000d0oe<R100000020?mC
8P030000003oDb80oe<R00D0oe<R2@10Gkl00`000000@5no041O_`0:041O_`P000001013ILT00`00
0000@fG904=Ub@0G04=Ub@0300000013ILT0@fG901L0@fG900<000000?mC8P3oDb802@3oDb830000
00h0oe8R00<000000?mB8P3oDR802`3oDR800`000000oe8R0?mB8P0:0?mB8P030000003oDR8092mQ
014092mQ00<0000002@_H@0T;f404P0T;f400`000000oooo0?ooo`0L0?ooo`030000003oool0oooo
00<0oooo00030?ooo`030000003oool0oooo0300oooo00<0000003eJ]@0mF[D02P0mF[D2000000d0
Oah<00<0000007lN301o7P`02@1o7P`00`000000Oah<07lN300207lN30d0@5no00<00000041O_`10
Gkl04@10Gkl00`000000@5no041O_`0B041O_`0300000010Gkl0@5no01<0@5no00<00000041O_`10
Gkl04`10Gkl00`000000@5no041O_`03041O_`8000005P3oDb82000001D0oe<R00<000000?mC8P3o
Db804@3oDb83000000L0oe<R2@10Gkl00`000000@5no041O_`02041O_`P000001`13ILT00`000000
@fG904=Ub@0304=Ub@0300000013ILT0@fG901L0@fG900<0000004=Ub@13ILT05`13ILT00`000000
oe<R0?mC8P080?mC8P030000003oDb80oe<R00<000002P3oDR800`000000oe8R0?mB8P0;0?mB8P03
0000003oDR80oe8R00/0oe8R00<0000002@_H@0T;f40400T;f400`00000092mQ02@_H@0B02@_H@03
0000003oool0oooo01d0oooo00<000000?ooo`3oool00`3oool000<0oooo00<000000?ooo`3oool0
<03oool00`000000?EZe03eJ]@0<03eJ]@030000001o7P`0Oah<00/0Oah<00<0000007lN301o7P`0
2@1o7P`2000000@0Oah<2`10Gkl00`000000@5no041O_`0B041O_`0300000010Gkl0@5no0180@5no
00<00000041O_`10Gkl04`10Gkl00`000000@5no041O_`0B041O_`0300000010Gkl0@5no0080@5no
00<000000?mC8P3oDb805@3oDb800`000000oe<R0?mC8P0C0?mC8P8000004`3oDb8200000080oe<R
100000030?mC8PD0@5no2@00000?04=Ub@0300000013ILT0@fG900@0@fG900<0000004=Ub@13ILT0
5P13ILT00`000000@fG904=Ub@0H04=Ub@030000003oDb80oe<R00H0oe<R00<000000?mC8P3oDb80
103oDb84000000D0oe8R00<000000?mB8P3oDR802`3oDR800`000000oe8R0?mB8P0;0?mB8P030000
000T;f4092mQ014092mQ00<0000002@_H@0T;f404P0T;f400`000000oooo0?ooo`0M0?ooo`030000
003oool0oooo00<0oooo00030?ooo`030000003oool0oooo0340oooo00<0000003eJ]@0mF[D0300m
F[D00`000000Oah<07lN300;07lN30030000001o7P`0Oah<00X0Oah<00<0000007lN301o7P`00`1o
7P`:041O_`0300000010Gkl0@5no0140@5no00<00000041O_`10Gkl04P10Gkl00`000000@5no041O
_`0C041O_`0300000010Gkl0@5no01<0@5no00@00000041O_`00000000005P3oDb82000001D0oe<R
00<000000?mC8P3oDb804P3oDb800`000000oe<R0?mC8P060?mC8PP000001P13ILT00`000000@fG9
04=Ub@0?04=Ub@0300000013ILT0@fG900D0@fG900<0000004=Ub@13ILT05P13ILT00`000000@fG9
04=Ub@0H04=Ub@030000003oDb80oe<R00@0oe<R00<000000?mC8P3oDb802@3oDb8300000080oe8R
00<000000?mB8P3oDR802`3oDR800`000000oe8R0?mB8P0:0?mB8P0302@_H@00000092mQ018092mQ
00<0000002@_H@0T;f404@0T;f400`000000oooo0?ooo`0N0?ooo`030000003oool0oooo00<0oooo
00030?ooo`030000003oool0oooo0340oooo00<0000003eJ]@0mF[D03@0mF[D00`000000Oah<07lN
300;07lN30030000001o7P`0Oah<00X0Oah<00<0000007lN301o7P`0101o7P`9041O_`0300000010
Gkl0@5no0140@5no00<00000041O_`10Gkl04P10Gkl00`000000@5no041O_`0C041O_`0300000010
Gkl0@5no01<0@5no00<000000?mC8P3oDb805@3oDb800`000000oe<R0?mC8P0C0?mC8P8000004`3o
Db82000000/0oe<R3@13ILT00`000000@fG904=Ub@0>04=Ub@0300000013ILT0@fG900H0@fG900<0
000004=Ub@13ILT05P13ILT00`000000@fG904=Ub@0G04=Ub@030000003oDb80oe<R00<0oe<R00<0
00000?mC8P3oDb803@3oDb83000000`0oe8R00<000000?mB8P3oDR802P3oDR800`0T;f40000002@_
H@0B02@_H@030000000T;f4092mQ00l092mQ1000000Q0?ooo`030000003oool0oooo0080oooo0003
0?ooo`030000003oool0oooo0380oooo00<0000003eJ]@0mF[D01`0mF[D7000000d0Oah<00<00000
07lN301o7P`02P1o7P`00`000000Oah<07lN300507lN30P0@5no00<00000041O_`10Gkl04@10Gkl0
0`000000@5no041O_`0B041O_`0300000010Gkl0@5no01<0@5no00<00000041O_`10Gkl04@10Gkl0
0`000000oe<R0?mC8P0D0?mC8P8000005@3oDb800`000000oe<R0?mC8P0B0?mC8P030000003oDb80
oe<R00/0oe<R3P13ILT00`000000@fG904=Ub@0=04=Ub@0300000013ILT0@fG900H0@fG900<00000
04=Ub@13ILT05`13ILT00`000000@fG904=Ub@0G04=Ub@050000003oDb80oe<R0?mC8P000000403o
Db800`000000oe<R0?mC8P03000000P0oe8R00<000000?mB8P3oDR802P3oDR8202@_H@030000000T
;f4092mQ014092mQ00<0000002@_H@0T;f40200T;f470000008061dl00<000000?ooo`3oool0803o
ool00`000000oooo0?ooo`020?ooo`000`3oool00`000000oooo0?ooo`0b0?ooo`040000000mF[D0
?EZe03eJ]@H000001`10Gkl00`000000Oah<07lN300;07lN30030000001o7P`0Oah<00X0Oah<00<0
000007lN301o7P`01P1o7P`6041O_`0300000010Gkl0@5no0180@5no00<00000041O_`10Gkl04@10
Gkl00`000000@5no041O_`0D041O_`0300000010Gkl0@5no00h0@5no0P00000F0?mC8P030000003o
Db80oe<R01<0oe<R0P00000D0?mC8P030000003oDb80oe<R00`0oe<R3`13ILT00`000000@fG904=U
b@0<04=Ub@0300000013ILT0@fG900L0@fG900<0000004=Ub@13ILT05`13ILT00`000000@fG904=U
b@0G04=Ub@030000003oDb8000000100oe<R00<000000?mC8P3oDb80103oDb82000000D0oe8R00<0
00000?mB8P3oDR802@3oDR8302@_H@030000000T;f4092mQ014092mQ00@0000002@_H@0T;f4092mQ
2000000901PM?0030000003oool0oooo0200oooo00<000000?ooo`3oool00P3oool000<0oooo00<0
00000?ooo`3oool0<`3oool3000000h0@5no00<0000007lN301o7P`02`1o7P`00`000000Oah<07lN
300:07lN30030000001o7P`0Oah<00H0Oah<1P10Gkl00`000000@5no041O_`0A041O_`0300000010
Gkl0@5no0180@5no00<00000041O_`10Gkl04`10Gkl00`000000@5no041O_`0=041O_`030000003o
Db80oe<R01@0oe<R0P00000E0?mC8P030000003oDb80oe<R0180oe<R0P00000>0?mC8Q40@fG900<0
000004=Ub@13ILT02`13ILT00`000000@fG904=Ub@0804=Ub@0300000013ILT0@fG901L0@fG900<0
000004=Ub@13ILT05`13ILT00`000000oe<R0?mC8P0>0?mC8P030000003oDb80oe<R00L0oe<R0`00
00020?mB8P030000003oDR80oe8R00P0oe8R100T;f400`00000092mQ02@_H@0<02@_H@T00000400H
7C`00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo0080oooo00030?ooo`030000003oool0
oooo03@0oooo00<00000041O_`10Gkl03P10Gkl00`000000Oah<07lN300;07lN30030000001o7P`0
Oah<00X0Oah<0P00000607lN3003041O_`1o7P`0@5no00@0@5no00<00000041O_`10Gkl04@10Gkl0
0`000000@5no041O_`0B041O_`0300000010Gkl0@5no01<0@5no00<00000041O_`10Gkl02P10Gkl2
000001H0oe<R00<000000?mC8P3oDb804`3oDb82000001@0oe<R00<000000?mC8P3oDb803P3oDb8B
04=Ub@0300000013ILT0@fG900X0@fG900<0000004=Ub@13ILT02@13ILT00`000000@fG904=Ub@0G
04=Ub@0300000013ILT0@fG901L0@fG900<000000?mC8P3oDb80303oDb800`000000oe<R0?mC8P0;
0?mC8P<000002@3oDR8402@_H@030000000T;f4092mQ00<092mQ2P00000401PM?0030000000H7C`0
61dl014061dl00<000000?ooo`3oool08P3oool00`000000oooo0?ooo`020?ooo`000`3oool00`00
0000oooo0?ooo`0e0?ooo`0300000010Gkl0@5no00h0@5no00<0000007lN301o7P`02`1o7P`20000
00`0Oah<00<0000007lN301o7P`01`1o7P`4041O_`0300000010Gkl0@5no0140@5no00<00000041O
_`10Gkl04P10Gkl00`000000@5no041O_`0C041O_`0300000010Gkl0@5no00L0@5no1000000E0?mC
8P030000003oDb80oe<R01<0oe<R00<000000?mC8P3oDb804P3oDb8200000140oe<R4`13ILT00`00
0000@fG904=Ub@0904=Ub@0300000013ILT0@fG900X0@fG900<0000004=Ub@13ILT05`13ILT00`00
0000@fG904=Ub@0G04=Ub@030000003oDb80oe<R00X0oe<R00<000000?mC8P3oDb80303oDb800`00
0000oe<R0?mC8P04000000@0oe8R0P0T;f49000000d061dl00<0000001PM?00H7C`04@0H7C`00`00
0000oooo0?ooo`0S0?ooo`030000003oool0oooo0080oooo00020?ooo`030000003oool0oooo03H0
oooo00<00000041O_`10Gkl03`10Gkl3000000`0Oah<00<0000007lN301o7P`02P1o7P`00`000000
Oah<07lN300807lN30<0@5no00<00000041O_`10Gkl04@10Gkl00`000000@5no041O_`0A041O_`03
00000010Gkl0@5no01@0@5no00<00000041O_`10Gkl01010Gkl2000000@0odlQ1000000?0?mC8P80
0000503oDb82000001@0oe<R00<000000?mC8P3oDb80403oDb8E04=Ub@0300000013ILT0@fG900D0
@fG91@00000<04=Ub@0300000013ILT0@fG901L0@fG900<0000004=Ub@13ILT05`13ILT00`000000
oe<R0?mC8P080?mC8P030000003oDb80oe<R00`0oe<R00<000000?mC8P3oDb801@3oDb8600000080
61dl00<0000001PM?00H7C`04@0H7C`00`00000061dl01PM?00A01PM?0030000003oool0oooo02<0
oooo00<000000?ooo`3oool00P3oool00080oooo00<000000?ooo`3oool0=`3oool00`000000@5no
041O_`0@041O_`L000001`1o7P`00`000000Oah<07lN300:07lN30030000001o7P`0Oah<0080Oah<
00<0@5no07lN301o7P`0101o7P`00`10Gkl00000041O_`0B041O_`0300000010Gkl0@5no0180@5no
00<00000041O_`10Gkl04`10Gkl010000000@5no041O_`10Gkl3000000X0odlQ1@0000090?mC8P03
0000003oDb80oe<R01<0oe<R00<000000?mC8P3oDb804P3oDb82000001<0oe<R5@13ILT8000000D0
@fG91000000904=Ub@0300000013ILT0@fG901L0@fG900<0000004=Ub@13ILT05`13ILT00`000000
oe<R0?mC8P060?mC8P030000003oDb80oe<R00`0oe<R00<000000?mC8P3oDb801P3oDb8701PM?003
0000000H7C`061dl014061dl00<0000001PM?00H7C`04@0H7C`00`000000oooo0?ooo`0T0?ooo`03
0000003oool0oooo0080oooo00020?ooo`030000003oool0oooo03P0oooo00<00000041O_`10Gkl0
4010Gkl3000000<0Ca471P00000207lN30030000001o7P`0Oah<00X0Oah<00<0000007lN301o7P`0
2P1o7P`00`000000@5no041O_`0A041O_`0300000010Gkl0@5no0180@5no00<00000041O_`10Gkl0
4`10Gkl300000180odlQ100000030?mC8P800000503oDb82000001@0oe<R00<000000?mC8P3oDb80
4`3oDb8=04=Ub@P000000P13ILT00`000000@fG904=Ub@0<04=Ub@@000001P13ILT00`000000@fG9
04=Ub@0F04=Ub@0300000013ILT0@fG901L0@fG900<000000?mC8P3oDb801@3oDb800`000000oe<R
0?mC8P0<0?mC8P030000003oDb80oe<R00D0oe<R2@0H7C`00`00000061dl01PM?00@01PM?0030000
000H7C`061dl014061dl00<000000?ooo`3oool09@3oool00`000000oooo0?ooo`020?ooo`000P3o
ool00`000000oooo0?ooo`0i0?ooo`0300000010Gkl0@5no0100@5no00<00000041O_`0000000P00
000604lA1`H000002P1o7P`00`000000Oah<07lN300:07lN300300000010Gkl0@5no0140@5no00<0
0000041O_`10Gkl04P10Gkl00`000000@5no041O_`0@041O_`8000006@3oCb44000001@0oe<R00<0
00000?mC8P3oDb804P3oDb82000001D0oe<R00<0000004=Ub@13ILT00`13ILT8000000X0@fG900<0
000004=Ub@13ILT04013ILT3000000@0@fG900<0000004=Ub@13ILT05P13ILT00`000000@fG904=U
b@0G04=Ub@030000003oDb80oe<R00<0oe<R00<000000?mC8P3oDb80303oDb800`000000oe<R0?mC
8P040?mC8PX061dl00<0000001PM?00H7C`0400H7C`00`00000061dl01PM?00B01PM?0030000003o
ool0oooo02D0oooo00<000000?ooo`3oool00P3oool00080oooo00<000000?ooo`3oool0>P3oool0
0`000000@5no041O_`0@041O_`0400000010Gkl0@5no041O_`8000002@1?4@L5000000L0Oah<0P00
00000`1o7P`0@5no07lN300807lN300300000010Gkl0@5no0140@5no00<00000041O_`10Gkl04@10
Gkl00`000000@5no041O_`0=041O_`<000006P3oCb42000000<0odlQ1000000>0?mC8P800000503o
Db800`000000oe<R0?mC8P0C0?mC8PP000004`13ILT00`000000@fG904=Ub@0B04=Ub@@0000000<0
@fG900000013ILT05`13ILT00`000000@fG904=Ub@0G04=Ub@050000003oDb80oe<R0?mC8P000000
3P3oDb800`000000oe<R0?mC8P030?mC8P/061dl00<0000001PM?00H7C`0400H7C`00`00000061dl
01PM?00B01PM?0030000003oool0oooo02H0oooo00<000000?ooo`3oool00P3oool00080oooo00<0
00000?ooo`3oool0>P3oool00`000000@5no041O_`0@041O_`0300000010Gkl0@5no00<0@5no0P00
000904lA1`80000000<0Ca470000000000000`00000407lN30030000001o7P`0Oah<00T0Oah<00<0
000007lN3010Gkl04010Gkl00`000000@5no041O_`0B041O_`0300000010Gkl0@5no00X0@5no0P00
000J0?m?8@<000002@3oCb44000000T0oe<R00<000000?mC8P3oDb804P3oDb82000000l0oe<R2000
0000103oDb80@fG904=Ub@00000G04=Ub@0300000013ILT0@fG901D0@fG90`00000H04=Ub@030000
0013ILT0@fG90180@fG91P0000000`3oDb8000000?mC8P0<0?mC8P800000103oDb8<01PM?0030000
000H7C`061dl010061dl00<0000001PM?00H7C`04P0H7C`00`000000oooo0?ooo`0W0?ooo`030000
003oool0oooo0080oooo00020?ooo`030000003oool0oooo03/0oooo00<00000041O_`10Gkl04010
Gkl00`000000@5no041O_`04041O_`<00000201?4@L2000000@0Ca47100000000`1o7P`0000007lN
300:07lN30030000001o7P`0Oah<0100@5no00<00000041O_`10Gkl04P10Gkl00`000000@5no041O
_`06041O_`<000006@3oCb4300000100odlQ100000030?mC8P800000503oDb800`000000oe<R0?mC
8P070?mC8PP00000103oDb8200000080oe<R1013ILT00`000000@fG904=Ub@0E04=Ub@0300000013
ILT0@fG901H0@fG91@00000E04=Ub@0300000013ILT0@fG900D0@fG93000000604AXc`800000303o
Db800`000000oe<R0?mC8P020?mC8Ph061dl00<0000001PM?00H7C`0400H7C`00`00000061dl01PM
?00B01PM?0030000003oool0oooo02L0oooo00<000000?ooo`3oool00P3oool00080oooo00<00000
0?ooo`3oool0?03oool00`000000@5no041O_`0@041O_`0300000010Gkl0@5no00H0@5no0P000008
04lA1`8000001P1?4@L5000000T0Oah<0P00000207lN30l0@5no00<00000041O_`10Gkl04P10Gkl0
0`000000@5no041O_`03041O_`8000006P3oCb42000001L0odlQ1000000D0?mC8P040000003oDb80
oe<R0?mC8PL000002`3oDb800`000000oe<R0?mC8P020?mC8PD0@fG900<0000004=Ub@13ILT05@13
ILT00`000000@fG904=Ub@0F04=Ub@0400000013ILT0@fG904=Ub@@000003`13ILT:000001@0A6S?
00<000000?mC8P3oDb80203oDb8010000000oe<R0?mC8P3oDb8?01PM?0030000000H7C`061dl0100
61dl00<0000001PM?00H7C`04P0H7C`00`000000oooo0?ooo`0X0?ooo`030000003oool0oooo0080
oooo00020?ooo`030000003oool0oooo03d0oooo00<00000041O_`10Gkl04010Gkl00`000000@5no
041O_`07041O_`<000001`1?4@L2000000P0Ca471@00000707lN30040000001o7P`0Oah<07lN30h0
@5no00<00000041O_`10Gkl04@10Gkl00`000000@5no041O_`03000001T0odlQ0`00000H0?m?8@80
00000`3oCb44000000`0oe<R2000000@0?mC8P800000103oDb8704=Ub@0300000013ILT0@fG901D0
@fG900<0000004=Ub@13ILT05P13ILT00`000000@fG904=Ub@0404=Ub@<000001013ILT8000000@0
A6S?0P00000I04AXc`8000001`3oDb800`000000oe<R0?mC8P0@01PM?0030000000H7C`061dl0100
61dl00<0000001PM?00H7C`04P0H7C`00`000000oooo0?ooo`0Y0?ooo`030000003oool0oooo0080
oooo00020?ooo`030000003oool0oooo03d0oooo00<00000041O_`10Gkl04010Gkl00`000000@5no
041O_`0:041O_`8000001`1?4@L2000000P0Ca470P0000000`1?4@L0000000000002000000@0Oah<
00@0000007lN301o7P`0Oah<3@10Gkl00`000000@5no041O_`0>041O_`H000006P3oCb42000001P0
odlQ0`0000090?m?8@`0000000<0oe<R0000003oDb80503oDb800`000000oe<R0?mC8P040?mC8PP0
@fG900<0000004=Ub@13ILT05@13ILT00`000000@fG904=Ub@0F04=Ub@0300000013ILT0@fG90080
@fG92000000>04AXc`0300000014J<l0A6S?01P0A6S?00<000000?mC8P3oDb800`3oDb800`000000
oe<R01PM?00701PM?0030?mC8P0H7C`061dl00H061dl00<0000001PM?00H7C`0400H7C`00`000000
61dl01PM?00B01PM?0030000003oool0oooo02X0oooo00<000000?ooo`3oool00P3oool00080oooo
00<000000?ooo`3oool0?P3oool00`000000@5no041O_`0@041O_`0300000010Gkl0@5no00/0@5no
0P00000704lA1`800000201?4@L2000000<0Ca47100000000`1o7P`0000007lN300307lN30`0@5no
00<00000041O_`10Gkl00`10Gkl:0000000304=Ub@000000000001X0odlQ0`00000H0?m?8@800000
203oCb4<000000<0oe<R0P00000D0?mC8P8000001`3oDb8804=Ub@0300000013ILT0@fG901H0@fG9
00<0000004=Ub@13ILT04`13ILT7000000P0A6S?1000000;04AXc`0300000014J<l0A6S?01P0A6S?
0P0000020?mC8P030000000H7C`061dl014061dl00<0000001PM?00H7C`03`0H7C`00`00000061dl
01PM?00C01PM?0030000003oool0oooo02X0oooo00<000000?ooo`3oool00P3oool00080oooo00<0
00000?ooo`3oool0?`3oool00`000000@5no041O_`0@041O_`0300000010Gkl0@5no00`0@5no1000
000504lA1`800000201?4@L2000000D0Ca471000000307lN30X0@5no1`00000704=Ub@D000006@3o
Cb42000001P0odlQ0`0000030?m?8@L00000303oCb44000001@0oe<R00<000000?mC8P3oDb801P3o
Db8:04=Ub@0300000013ILT0@fG901H0@fG900<0000004=Ub@13ILT02`13ILT7000000@0A6S?0P00
000=04AXc`<000002@14J<l2000001X0A6S?0P00000<01PM?0030?mC8P0H7C`061dl00@061dl00<0
000001PM?00H7C`0400H7C`00`00000061dl01PM?00=01PM?0H00000;P3oool00`000000oooo0?oo
o`010?ooo`000P3oool00`000000oooo0?ooo`100?ooo`0300000010Gkl0@5no0100@5no00<00000
041O_`10Gkl03`10Gkl60000000304lA1`000000000000P0Ca470P00000704lA1`@0000000<0Oah<
041O_`10Gkl00P10Gkl4000000<0@fG900<0000004=Ub@13ILT00P13ILT6000000D0fD<M1000000B
0?m?8@<00000603oCb4800000180odlQ0P0000030?m?8@@000003P3oDb82000000T0oe<R2`13ILT0
0`000000@fG904=Ub@0F04=Ub@0300000013ILT0@fG90080@fG92000000=04AXc`0300000014J<l0
A6S?00d0A6S?1000000704AXc`0300000014J<l0A6S?01P0A6S?00<0000001PM?00H7C`0400H7C`0
0`00000061dl01PM?00@01PM?0030000000H7C`061dl008061dl3000000300lB8`800000;`3oool0
0`000000oooo0?ooo`010?ooo`000P3oool00`000000oooo0?ooo`110?ooo`0300000010Gkl0@5no
00l0@5no00<00000041O_`10Gkl04P10Gkl8000000P0Ca470P00000704lA1`L000001P13ILT60000
00l0fD<M1@00000:0?m?8@<000004`3oCb48000001L0odlQ0`0000090?m?8@@000002@3oDb800`00
0000oe<R0?mC8P080?mC8Pd0@fG900<0000004=Ub@13ILT04`13ILT7000001H0A6S?0P00000A04AX
c`@000001014J<l2000001T0A6S?0P00000?01PM?0030000000H7C`061dl00d061dl2@00000>00lB
8`030000003oool0oooo02l0oooo00<000000?ooo`3oool00@3oool00080oooo00<000000?ooo`3o
ool0@@3oool00`000000@5no041O_`0@041O_`0300000010Gkl0@5no0140@5no00<00000041O_`10
Gkl00P10Gkl9000000@0Ca470P00000704lA1`8000000`1?4@L6000001X0fD<M100000040?m?8@80
00003P3oCb48000000<0odlQ0P00000H0?m?8@800000403oCb44000000<0oe<R0P00000;0?mC8Ph0
@fG900<0000004=Ub@13ILT02`13ILT7000000@0A6S?0P00000I04AXc`0300000014J<l0A6S?0180
A6S?0`00000304AXc`0300000014J<l0A6S?01P0A6S?00<0000001PM?00H7C`0300H7C`00`000000
61dl01PM?00601PM?0L0000000<03a8S0000000000004P0?4R<200000380oooo00<000000?ooo`3o
ool00@3oool00080oooo00<000000?ooo`3oool0@P3oool00`000000@5no041O_`0@041O_`030000
0010Gkl0@5no0140@5no00<00000041O_`10Gkl00`10Gkl?000000@0Ca471P00000S0=U37@H00000
203oCb47000000P0odlQ0`00000G0?m?8@<000005P3oCb44000000`0oe<R3`13ILT00`000000@fG9
04=Ub@0204=Ub@P000003@14J<l00`000000A6S?04AXc`0G04AXc`8000005@14J<l6000001T0A6S?
0P00000;01PM?0030000000H7C`061dl00L000001`0?4R<00`0000003a8S00lB8`0A00lB8`030000
003oool0oooo0380oooo00<000000?ooo`3oool00@3oool000030?ooo`000000oooo04D0oooo00<0
0000041O_`10Gkl04010Gkl00`000000@5no041O_`0?041O_`L000001`13ILT<00000240fD<M2000
00060=U37@P000003@3oCb42000001P0odlQ0P00000G0?m?8@<000000`3oCb44000000L0oe<R3@13
ILT8000001H0A6S?0P00000I04AXc`0300000014J<l0A6S?01H0A6S?0`00000J04AXc`030000000H
7C`061dl008061dl2@00000<00lB8`8000004P0?4R<2000003D0oooo00<000000?ooo`3oool00@3o
ool000030?ooo`000000oooo04H0oooo00<00000041O_`10Gkl03`10Gkl00`000000@5no041O_`09
041O_`H000000`13ILT00`000000@fG904=Ub@0<04=Ub@d000005@3I@ad7000000H0fD<M20000004
0=U37@@000002P3oCb43000001L0odlQ0`00000G0?m?8@8000002P3oCb44000000<0oe<R1013ILT9
000000D0A6S?0P00000I04AXc`0300000014J<l0A6S?01L0A6S?0P00000I04AXc`@000005`14J<l4
000000<03a8S0P00000?00lB8`030000000?4R<03a8S01403a8S00<000000?ooo`3oool0=@3oool0
0`000000oooo0?ooo`010?ooo`0000<0oooo0000003oool0A`3oool00`000000@5no041O_`0?041O
_`0300000010Gkl0@5no0080@5no1P00000:04=Ub@0300000013ILT0@fG90100@fG91000000308L/
4`L000001`3I@ad8000000H0fD<M1`00000@0=U37@@00000103oCb42000001P0odlQ0P00000G0?m?
8@<00000403oCb4700000100A6S?0P00000H04AXc`8000006@14J<l2000001P0A6S?0P0000000`14
J<l000000000000200000180A6S?1@00000200lB8`030000000?4R<03a8S00d03a8S0P00000B00lB
8`800000>03oool00`000000oooo0?ooo`010?ooo`0000<0oooo0000003oool0A`3oool00`000000
@5no041O_`0<041O_`P000004@13ILT00`000000@fG904=Ub@0B04=Ub@L000001027;1<7000000H0
fD<M2000000J0=U37@D000005`3oCb43000001H0odlQ0`00000E0?m?8AL0A6S?0P00000H04AXc`03
00000014J<l0A6S?01P0A6S?00<0000004AXc`14J<l05`14J<l00`000000A6S?04AXc`0204AXc`<0
00001`14J<l8000000D0?V?30`00000>00lB8`030000000?4R<03a8S01403a8S00<000000?ooo`3o
ool0>03oool00`000000oooo0?ooo`010?ooo`0000<0oooo0000003oool0B03oool00`000000@5no
041O_`03041O_`P000001@13ILT00`000000@fG904=Ub@0B04=Ub@0300000013ILT0@fG90180@fG9
00<0000004=Ub@13ILT00P13ILT800000080Qb`C2000000J0=U37@P000001@3I@ad400000140odlQ
0P00000G0?m?8@8000005P3oCb42000001T0A6S?00<0000004AXc`14J<l05P14J<l2000001T0A6S?
0P00000H04AXc`8000001014J<l800000100?V?30`00000900lB8`8000004P0?4R<2000003/0oooo
00<000000?ooo`3oool00@3oool000030?ooo`000000oooo04T0oooo1@00000>04=Ub@0300000013
ILT0@fG90180@fG90P00000C04=Ub@0300000013ILT0@fG900<0@fG94@00000B0=U37@L000004@3I
@ad4000000X0odlQ0`00000F0?m?8@<000005P3oCb42000000040?m?8@14J<l00000000001P0A6S?
0P00000H04AXc`8000006@14J<l00`000000A6S?04AXc`0B04AXc`T000001@0nHl<400000180?V?3
1000000400lB8`030000000?4R<03a8S00`03a8S1P00000m0?ooo`030000003oool0oooo0040oooo
00000`3oool000000?ooo`1:0?ooo`0300000013ILT0@fG90100@fG90P00000D04=Ub@0300000013
ILT0@fG900l0@fG91`00000904=Ub@`000001P3I@ad8000001`0fD<M100000040?m?8@8000005P3o
Cb43000001H0odlQ0`0000020?m?8@@0A6S?0P00000H04AXc`8000006014J<l00`000000A6S?04AX
c`0G04AXc`8000001P14J<l<000000L0?V?31000000703iS``<000004`0nHl<4000000<03a8S3`00
00100?ooo`030000003oool0oooo0040oooo00000`3oool000000?ooo`1;0?ooo`0300000013ILT0
@fG90140@fG900<0000004=Ub@13ILT04P13ILT00`000000@fG904=Ub@0604=Ub@P000000`13ILT2
00000100@fG93@00000V0=U37@L00000503oCb43000001H0odlQ0`0000050?m?8@H0A6S?0P00000H
04AXc`8000005`14J<l2000001H0A6S?2@00000G03iS``@000001P0nHl<400000180?V?310000003
00H84@H00000AP3oool00`000000oooo0?ooo`010?ooo`0000<0oooo0000003oool0C03oool20000
0180@fG900<0000004=Ub@13ILT04P13ILT8000000d0@fG900<0000004=Ub@13ILT04@13ILT=0000
01P0fD<M2P0000070=U37@D000003@3oCb42000001L0odlQ0P0000070?m?8@T0A6S?00<0000004AX
c`14J<l05`14J<l00`000000A6S?04AXc`0F04AXc`0300000014J<l0A6S?00`0A6S?1`00000503iS
``<00000700nHl<4000000H0?V?31000000=03iS``P00000C03oool00`000000oooo0?ooo`010?oo
o`0000<0oooo0000003oool0CP3oool00`000000@fG904=Ub@0@04=Ub@0300000013ILT0@fG900X0
@fG91`0000000`13ILT0000004=Ub@0C04=Ub@0300000013ILT0@fG90180@fG900<0000004=Ub@00
00000`00000308L/4`P00000203I@ad:000001H0fD<M1P0000040?m?8@<000005P3oCb43000000T0
odlQ2P14J<l2000001P0A6S?0P00000G04AXc`8000001014J<l8000000l0?V?31000000L03iS``@0
00001P0nHl<=000000H0oe<R00<000000?ooo`3oool0B`3oool00`000000oooo0?ooo`010?ooo`00
00<0oooo0000003oool0C`3oool00`000000@fG904=Ub@0@04=Ub@0400000013ILT0@fG904=Ub@P0
00002@13ILT00`000000@fG904=Ub@0B04=Ub@0300000013ILT0@fG90180@fG900<0000004=Ub@13
ILT00P13ILT6000000@0Qb`C2@00000U0=U37@D000005`3oCb42000000/0odlQ3@14J<l2000001P0
A6S?0P00000B04AXc`T000006`0nHl<3000001/0?V?32P0000000`3oDb80000000000002000000/0
oe<R00<000000?ooo`3oool0C03oool00`000000oooo0?ooo`010?ooo`0000<0oooo0000003oool0
D03oool00`000000@fG904=Ub@0;04=Ub@P000004P13ILT00`000000@fG904=Ub@0B04=Ub@030000
0013ILT0@fG90180@fG900<0000004=Ub@13ILT01`13ILT700000080Qb`C1000000M0=U37@P00000
1@3I@ad400000100odlQ0`00000=0?m?8@l0A6S?00<0000004AXc`14J<l05`14J<l2000000H0A6S?
2P00000703iS``@00000700nHl<300000140?V?31`00000:0?mC8P<000000P3oDb83000000L0oe<R
00<000000?ooo`3oool0CP3oool100000040oooo0@3oool000030?ooo`000000oooo0540oooo00<0
000004=Ub@13ILT00P13ILT8000000H0@fG90P00000C04=Ub@0300000013ILT0@fG90180@fG900<0
000004=Ub@13ILT04P13ILT00`000000@fG904=Ub@0<04=Ub@/000004P3I@ad700000140fD<M1000
00090?m?8@<000003`3oCb4A04AXc`8000005P14J<l9000001D0?V?31000000K03iS``@000001@0n
Hl<8000000030?mC8P000000oe<R00d0oe<R0P0000020?mC8P@0000000<0oe<R0000000000000P00
00020?mC8P030000003oool0oooo04l0oooo0@0000010?ooo`40oooo00000`3oool000000?ooo`1?
0?ooo`L000004013ILT00`000000@fG904=Ub@0A04=Ub@0300000013ILT0@fG90180@fG90P00000C
04=Ub@0300000013ILT0@fG900<0@fG92000000604AXc`0308L/4`000000000000H000001P3I@ad8
000001`0fD<M100000030?m?8@8000004P3oCb4C04AXc`8000003@14J<l7000000D0?V?31000000I
03iS``@000005`0nHl<9000000L0oe<R0P00000=0?mC8P800000203oDb84000000030?mC8P000000
000000800000D03oool100000040oooo0@3oool000030?ooo`000000oooo04L0oooo200000040?oo
o`8000004P13ILT00`000000@fG904=Ub@0A04=Ub@8000005013ILT00`000000@fG904=Ub@0=04=U
b@T000004@14J<l2000000<0A6S?1`00000U0=U37@L000004P3oCb4F04AXc`8000001014J<l70000
0100?V?31000000I03iS``@00000200nHl<;000000l0oe<R00<000000?mC8P3oDb80303oDb800`00
0000oe<R0?mC8P0<0?mC8P8000000`3oool3000004d0oooo0@0000010?ooo`40oooo00000`3oool0
00000?ooo`0o0?ooo`P000003P3oool00`000000@fG904=Ub@0@04=Ub@0300000013ILT0@fG90180
@fG900<0000004=Ub@13ILT04P13ILT00`000000@fG904=Ub@0304=Ub@T000001@14J<l2000001D0
A6S?0P00000704AXc`D000005`3I@ad:000000L0fD<M1@00000;0?m?8@8000004`14J<l9000001/0
?V?31000000F03iS``/000001`3oDb82000000l0oe<R0P00000=0?mC8P8000003P3oDb82000000L0
oooo100000190?ooo`4000000@3oool10?ooo`0000<000000?ooo`3oool0=`3oool8000001L0oooo
00<0000004=Ub@13ILT04013ILT00`000000@fG904=Ub@0B04=Ub@0300000013ILT0@fG90100@fG9
1`00000@04AXc`8000005@14J<l2000000X0A6S?1P0000070=U37@X000005P3I@ad5000000@0odlQ
0P000000103oCb40A6S?00000000000704AXc`X00000200nHl<5000001/0?V?31000000803iS``/0
0000403oDb800`000000oe<R0?mC8P0>0?mC8P030000003oDb80oe<R00`0oe<R00<000000?mC8P3o
Db80303oDb82000000d0oooo100000150?ooo`4000000@3oool10?ooo`0000<000000?ooo`3oool0
<03oool700000200oooo00<0000004=Ub@13ILT04013ILT00`000000@fG904=Ub@0B04=Ub@030000
0013ILT0@fG900T0@fG91P00000304AXc`8000005014J<l2000001D0A6S?00<0000004AXc`14J<l0
3014J<l8000002<0fD<M1`0000020?m?8@X000005`0nHl<5000001L0?V?32`0000080?mC8P030000
003oDb80oe<R00h0oe<R0P00000?0?mC8P8000003@3oDb82000000h0oe<R00<000000?ooo`3oool0
4@3oool300000480oooo0@0000010?ooo`40oooo00000`000000oooo0?ooo`0X0?ooo`P00000:03o
ool00`000000@fG904=Ub@0@04=Ub@8000004`13ILT00`000000@fG904=Ub@0204=Ub@H000002`14
J<l2000001@0A6S?0P00000D04AXc`8000004P14J<l5000001H0fD<M2P0000070=U37@@000001@0n
Hl<4000001/0?V?31@00000803iS``X000002`3oCb4400000080oe<R0P00000@0?mC8P030000003o
Db80oe<R00d0oe<R0P00000=0?mC8P8000003P3oDb82000001L0oooo1000000n0?ooo`4000000@3o
ool10?ooo`0000<000000?ooo`3oool0803oool800000340oooo00<0000004=Ub@13ILT04@13ILT0
0`000000@fG904=Ub@0=04=Ub@P000004`14J<l2000001@0A6S?0P00000D04AXc`8000005@14J<l5
000000L0fD<M2P00000E0=U37@D00000100nHl<4000001/0?V?32@0000040?m?8@8000004`3oCb44
000000h0oe<R0P00000?0?mC8P030000003oDb80oe<R00`0oe<R00<000000?mC8P3oDb803@3oDb80
0`000000oooo0?ooo`0K0?ooo`@00000>P3oool100000040oooo0@3oool000030000003oool0oooo
01T0oooo1`00000j0?ooo`8000004P13ILT00`000000@fG904=Ub@0304=Ub@T000001@14J<l20000
01H0A6S?00<0000004AXc`14J<l04`14J<l00`000000A6S?04AXc`0C04AXc`0300000014J<l0A6S?
01D0A6S?00<0000004AXc`0000001P00000R0=U37@D000001@0nHl<400000140?V?31P00000:0?m?
8@<000004P3oCb43000000@0odlQ100000090?mC8P030000003oDb80oe<R00d0oe<R0P00000=0?mC
8P8000003P3oDb8200000280oooo0`00000g0?ooo`4000000@3oool10?ooo`0000<000000?ooo`3o
ool04@3oool8000004<0oooo00<0000004=Ub@13ILT03013ILT900000100A6S?0P00000E04AXc`80
00005014J<l2000001@0A6S?0P00000F04AXc`0300000014J<l0A6S?0080A6S?1@00000F0=U37@X0
00003P0nHl<4000000H0?V?31`00000=0?m?8@<000004`3oCb42000000/0odlQ100000030?mC8P80
00003`3oDb800`000000oe<R0?mC8P0;0?mC8P8000003P3oDb82000002L0oooo1000000c0?ooo`40
00000@3oool10?ooo`0000<000000?ooo`3oool02@3oool8000004`0oooo00<0000004=Ub@13ILT0
0`13ILT8000000D0A6S?0P00000D04AXc`8000005@14J<l2000001@0A6S?0P00000D04AXc`800000
4@14J<l8000000D0?V?31@0000070=U37@h000005P0nHl<800000140odlQ0`00000C0?m?8@<00000
4@3oCb44000000h0oe<R0P00000=0?mC8P030000003oDb80oe<R00d0oe<R00<000000?ooo`3oool0
:`3oool300000300oooo0@0000010?ooo`40oooo000010000000oooo0?ooo`3oool8000005D0oooo
1@00000?04AXc`8000005014J<l2000001D0A6S?0P00000D04AXc`8000005014J<l2000000D0A6S?
2P00000703iS``D000001P0nHl<7000000h0?V?31000000803iS``l000004@3oCb43000001<0odlQ
0`00000B0?m?8@<000000`3oCb44000000T0oe<R00<000000?mC8P3oDb802`3oDb82000000h0oe<R
0P00000a0?ooo`@00000;03oool100000040oooo0@3oool000@00000GP3oool2000001<0A6S?0P00
000D04AXc`8000005@14J<l00`000000A6S?04AXc`0C04AXc`8000004014J<l9000001H0?V?31P00
000G03iS`a8000001`3I@ad4000000/0odlQ0P00000C0?m?8@<000004`3oCb42000000X0odlQ1000
00030?mC8P8000003@3oDb800`000000oe<R0?mC8P0<0?mC8P800000=`3oool4000002P0oooo0@00
00010?ooo`40oooo00040?ooo`H00000FP3oool2000001<0A6S?0P00000D04AXc`8000005014J<l2
000001D0A6S?0P00000504AXc`T000001`0nHl<5000001T0?V?31@00000803iS`a8000005@3I@ad4
000000@0odlQ0`00000B0?m?8@<000004`3oCb4300000100odlQ1@00000;0?mC8P8000003P3oDb80
0`000000oooo0?ooo`0k0?ooo`<000009@3oool100000040oooo0@3oool000X0oooo1P00001F0?oo
o`8000004`14J<l2000001@0A6S?0P00000D04AXc`8000004@14J<l9000001D0?V?31P00000F03iS
`a8000008@3I@ad700000180odlQ0P00000C0?m?8@<000004@3oCb43000000@0odlQ1P0000030?mC
8P8000003P3oDb8200000440oooo1000000Q0?ooo`4000000@3oool10?ooo`00403oool600000580
oooo0P00000C04AXc`8000005014J<l2000001@0A6S?0P00000504AXc`X000001`0nHl<5000001P0
?V?31@00000703iS``X00000203oool<000001H0fD<M2@0000070=U37@@000002`3oCb4300000180
odlQ0`00000A0?m?8@<000003@3oCb44000000h0oe<R00<000000?ooo`3oool0A@3oool4000001d0
oooo0@0000010?ooo`40oooo000F0?ooo`H00000CP3oool2000001<0A6S?0P00000D04AXc`800000
4014J<l9000001H0?V?31P00000E03iS``T000005P3oool=000000L0fD<M2P00000D0=U37@@00000
103oCb4300000180odlQ0`00000A0?m?8@<000003P3oCb43000000<0odlQ100000080?mC8P800000
C03oool3000001/0oooo0@0000010?ooo`00703oool7000004T0oooo0P00000C04AXc`8000005014
J<l2000000D0A6S?2@00000703iS``H00000600nHl<5000000L0?V?32@00000T0?ooo`l00000803I
@ad700000180odlQ0P00000A0?m?8@<000003`3oCb42000000X0odlQ100000020?mC8P800000D@3o
ool4000001L0oooo0@0000010?ooo`008`3oool6000004D0oooo0P00000C04AXc`8000004014J<l9
000001H0?V?31@00000F03iS``T000001`3oool00`000000oooo0?ooo`0Y0?ooo`/000005@3I@ad9
000000L0fD<M1000000;0?m?8@<000003`3oCb44000000l0odlQ0`00000@0?m?8@800000E`3oool4
000001<0oooo0@0000010?ooo`00:@3oool600000440oooo0P00000C04AXc`8000001P14J<l80000
00L0?V?31P00000G03iS``H000001`0nHl<900000100oooo00<000000?ooo`3oool0;`3oool90000
00L0fD<M2P00000D0=U37@@00000103oCb43000000l0odlQ0`00000@0?m?8@<00000403oCb430000
05d0oooo0`00000@0?ooo`4000000@3oool002l0oooo1P00000m0?ooo`8000004014J<l9000001D0
?V?31@00000F03iS``T000006@3oool00`000000oooo0?ooo`0c0?ooo``000007P3I@ad9000000h0
odlQ0`00000A0?m?8@800000403oCb43000006<0oooo1000000<0?ooo`4000000@3oool003D0oooo
1P00000i0?ooo`8000001P14J<l8000000L0?V?31P00000F03iS``H000001`0nHl<900000280oooo
00<000000?ooo`3oool0=`3oool=000000/0fD<M3P0000090=U37@H000001@3oCb4300000140odlQ
0`00000?0?m?8@<00000JP3oool3000000T0oooo0@0000010?ooo`00>`3oool7000003@0oooo1P00
000E03iS``D000005@0nHl<9000002/0oooo00<000000?ooo`3oool0?03oool70000000308L/4`00
0000000000T00000703I@ad600000140odlQ0`00000?0?m?8@<00000L03oool4000000D0oooo0@00
00010?ooo`00@P3oool600000380oooo1P00000F03iS``H000001`0nHl<8000003@0oooo00<00000
0?ooo`3oool0@P3oool;000001D0fD<M2@0000060=U37@@000002`3oCb42000000l0odlQ0`00001g
0?ooo`@000000@3oool100000040oooo00180?ooo`H00000<P3oool5000001D0?V?32@00000l0?oo
o`030000003oool0oooo04L0oooo2P0000070=U37@X000004`3I@ad4000000@0odlQ0`00000>0?m?
8@<00000NP3oool600000040oooo001>0?ooo`H00000<@3oool6000000L0?V?3200000150?ooo`03
0000003oool0oooo04/0oooo3@00000O0=U37@L000003@3oCb4300000740oooo300000070?ooo`00
E03oool600000340oooo1`00001=0?ooo`030000003oool0oooo04l0oooo2P00000E0=U37@T00000
1`3I@ad6000000@0odlQ0`00001Y0?ooo`/000004`3oool005X0oooo1`00001n0?ooo`030000003o
ool0oooo05D0oooo200000070=U37@X00000503I@ad600000600oooo3000000N0?ooo`00H@3oool6
000007P0oooo00<000000?ooo`3oool0F`3oool9000001D0fD<M2@00001K0?ooo`/00000:P3oool0
06L0oooo1P00001b0?ooo`030000003oool0oooo0680oooo1P0000080=U37@T00000F03oool<0000
03D0oooo001]0?ooo`H00000K03oool00`000000oooo0?ooo`1X0?ooo`P00000EP3oool;00000440
oooo001c0?ooo`H00000IP3oool00`000000oooo0?ooo`2k0?ooo`/00000C03oool007T0oooo1P00
001P0?ooo`030000003oool0oooo0:l0oooo3000001G0?ooo`00O`3oool7000005T0oooo00<00000
0?ooo`3oool0Y03oool;000006<0oooo00260?ooo`H00000D`3oool00`000000oooo0?ooo`2H0?oo
o``00000KP3oool008`0oooo1P00001=0?ooo`030000003oool0oooo08d0oooo2`00001j0?ooo`00
TP3oool6000004L0oooo00<000000?ooo`3oool0P@3oool<000008D0oooo002H0?ooo`H00000@@3o
ool00`000000oooo0?ooo`1f0?ooo`/00000T@3oool009h0oooo1`00000j0?ooo`030000003oool0
oooo06X0oooo3000002L0?ooo`00Y@3oool6000003@0oooo00<000000?ooo`3oool0G`3oool;0000
0:P0oooo002[0?ooo`H00000;P3oool00`000000oooo0?ooo`1C0?ooo``00000/`3oool00;40oooo
1P00000X0?ooo`030000003oool0oooo04P0oooo2`00002o0?ooo`00]`3oool600000280oooo00<0
00000?ooo`3oool0?@3oool;00000<X0oooo002m0?ooo`L000006`3oool00`000000oooo0?ooo`0a
0?ooo``00000e@3oool00<@0oooo1P00000E0?ooo`030000003oool0oooo02H0oooo2`00003Q0?oo
o`00bP3oool6000000l0oooo00<000000?ooo`3oool06P3oool<00000>`0oooo003@0?ooo`H00000
2@3oool00`000000oooo0?ooo`0?0?ooo`/00000n03oool00=H0oooo1P0000030?ooo`030000003o
ool0oooo00<0oooo3000003o0?ooo`@0oooo003L0?ooo`T00000o`3oool@0?ooo`00\
\>"],
  ImageRangeCache->{{{0, 499}, {474.688, 0}} -> {0.0294383, -4.32866*^-06, \
0.00182379, 0.00182379}}]
}, Open  ]],

Cell[TextData[{
  "The surfaces we want are the four inner surfaces. The two cylinders \
intersect when ",
  Cell[BoxData[
      \(x \[Equal] y\)]],
  " for any given value of z."
}], "Text"],

Cell[CellGroupData[{

Cell[BoxData[{
    \(\(eqns = {y\^2 + z\^2 \[Equal] 1, x\^2 + z\^2 \[Equal] 1};\)\), "\n", 
    \(Eliminate[eqns, z]\)}], "Input"],

Cell[BoxData[
    \(y\^2 \[Equal] x\^2\)], "Output"]
}, Open  ]],

Cell[TextData[{
  "For the x axis cylinder, ",
  Cell[BoxData[
      \(x \[Equal] y \[Equal] Cos[\[Theta]]\)]],
  " so we would really like to plot the surface with an x iterator of ",
  Cell[BoxData[
      \({x, \(-Cos[\[Theta]]\), Cos[\[Theta]]}\)]],
  ". Since this is not directly possible, we use IteratorSubstitution to give \
us variable substitution which does have a fixed range iterator."
}], "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(IteratorSubstitution[{x, Cos[\[Theta]], 
        Sin[\[Theta]]}, \ {x, \(-Cos[\[Theta]]\), Cos[\[Theta]]}]\)], "Input"],

Cell[BoxData[
    \({{w\ Cos[\[Theta]], Cos[\[Theta]], Sin[\[Theta]]}, {w, \(-1\), 
        1}}\)], "Output"]
}, Open  ]],

Cell["Doing the same for the y cylinder...", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(IteratorSubstitution[{Cos[\[Theta]], y, 
        Sin[\[Theta]]}, \ {y, \(-Cos[\[Theta]]\), Cos[\[Theta]]}]\)], "Input"],

Cell[BoxData[
    \({{Cos[\[Theta]], w\ Cos[\[Theta]], Sin[\[Theta]]}, {w, \(-1\), 
        1}}\)], "Output"]
}, Open  ]],

Cell["\<\
1) The original cylinders are plotted as wireframes. They are slightly shrunk \
in size so they won't intersect the solid surface we want to plot. Their \
length has also been extended.
2) The cylinders are plotted with the new parametrizations, copied from the \
two statements above.\
\>", "Text",
  ParagraphSpacing->{0, 0}],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(plot1 = \[IndentingNewLine]Draw3DItems[\[IndentingNewLine]{Cobalt, 
            ParametricDraw3D[
                Evaluate[0.99  xcylinder[\[Theta], x]], {x, \(-2\), 
                  2}, {\[Theta], 0, 2  \[Pi]}, PlotPoints \[Rule] {15, 31}] // 
              UseWireFrame, \[IndentingNewLine]EnglishRed, 
            ParametricDraw3D[
                Evaluate[0.99  ycylinder[\[Theta], y]], {y, \(-2\), 
                  2}, {\[Theta], 0, 2  \[Pi]}, PlotPoints \[Rule] {15, 31}] // 
              UseWireFrame, \
\[IndentingNewLine]\[IndentingNewLine]SurfaceColor[
              Cobalt], \[IndentingNewLine]ParametricDraw3D[{w\ Cos[\[Theta]], 
                Cos[\[Theta]], Sin[\[Theta]]}, {w, \(-1\), 1}, {\[Theta], 0, 
                2  \[Pi]}, 
              PlotPoints \[Rule] {15, 41}], \[IndentingNewLine]SurfaceColor[
              EnglishRed], \
\[IndentingNewLine]ParametricDraw3D[{Cos[\[Theta]], w\ Cos[\[Theta]], 
                Sin[\[Theta]]}, {w, \(-1\), 1}, {\[Theta], 0, 2  \[Pi]}, 
              PlotPoints \[Rule] {15, 
                  41}]}, \[IndentingNewLine]\[IndentingNewLine]\
NeutralLighting[0.3, 0.6, 
            0.1], \[IndentingNewLine]ViewPoint -> {1.886, \ \(-2.634\), \ 
              0.975}, \[IndentingNewLine]Background \[Rule] 
            Seashell, \[IndentingNewLine]ImageSize \[Rule] 500];\)\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .64029 
%%ImageSize: 500 320.145 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics3D
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Background color
1 .961 .933 r
MFill
% Scaling calculations
-2.4774e-017 1.03339 -0.140224 1.03339 [
[ 0 0 0 0 ]
[ 1 .64029 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 0 r
.25 Mabswid
[ ] 0 setdash
.02248 .1816 m
0 .53093 L
s
0 .53093 m
.44792 .64029 L
s
.44792 .64029 m
.45035 .35305 L
s
.45035 .35305 m
.02248 .1816 L
s
.61484 0 m
.98028 .2379 L
s
.98028 .2379 m
1 .56705 L
s
1 .56705 m
.62024 .41303 L
s
.62024 .41303 m
.61484 0 L
s
.02248 .1816 m
0 .53093 L
s
0 .53093 m
.62024 .41303 L
s
.62024 .41303 m
.61484 0 L
s
.61484 0 m
.02248 .1816 L
s
.45035 .35305 m
.98028 .2379 L
s
.98028 .2379 m
1 .56705 L
s
1 .56705 m
.44792 .64029 L
s
.44792 .64029 m
.45035 .35305 L
s
0 0 m
1 0 L
1 .64029 L
0 .64029 L
closepath
clip
newpath
.83 .24 .1 r
.5 Mabswid
.57765 .41008 m
.58996 .38248 L
s
.55411 .40073 m
.57765 .41008 L
s
.57012 .43925 m
.57765 .41008 L
s
.58996 .38248 m
.60659 .35753 L
s
.56658 .37275 m
.58996 .38248 L
s
.54645 .43029 m
.57012 .43925 L
s
.5677 .46887 m
.57012 .43925 L
s
.60659 .35753 m
.62692 .33622 L
s
.58339 .34743 m
.60659 .35753 L
s
.54392 .46029 m
.5677 .46887 L
s
.57052 .49778 m
.5677 .46887 L
s
.62692 .33622 m
.65017 .31943 L
s
.60392 .32579 m
.62692 .33622 L
s
.54667 .48957 m
.57052 .49778 L
s
.57853 .52482 m
.57052 .49778 L
s
.65017 .31943 m
.67547 .3079 L
s
.62738 .30872 m
.65017 .31943 L
s
.56658 .37275 m
.55411 .40073 L
s
.52991 .39112 m
.55411 .40073 L
s
.55411 .40073 m
.54645 .43029 L
s
.58339 .34743 m
.56658 .37275 L
s
.54255 .36274 m
.56658 .37275 L
s
.55466 .51693 m
.57853 .52482 L
s
.59151 .54885 m
.57853 .52482 L
s
.24 .35 .67 r
.36159 .43015 m
.35614 .39997 L
s
.35614 .39997 m
.38896 .3931 L
s
.35614 .39997 m
.3469 .37093 L
s
.83 .24 .1 r
.52211 .42108 m
.54645 .43029 L
s
.54645 .43029 m
.54392 .46029 L
s
.24 .35 .67 r
.36305 .46035 m
.36159 .43015 L
s
.36159 .43015 m
.39448 .42358 L
s
.83 .24 .1 r
.60392 .32579 m
.58339 .34743 L
s
.55955 .33705 m
.58339 .34743 L
s
.24 .35 .67 r
.3469 .37093 m
.3797 .36376 L
s
.3469 .37093 m
.33421 .34411 L
s
.83 .24 .1 r
.67547 .3079 m
.70181 .30221 L
s
.65288 .29696 m
.67547 .3079 L
s
.24 .35 .67 r
.39605 .45406 m
.36305 .46035 L
s
.36043 .48943 m
.36305 .46035 L
s
.83 .24 .1 r
.51947 .45148 m
.54392 .46029 L
s
.54392 .46029 m
.54667 .48957 L
s
.62738 .30872 m
.60392 .32579 L
s
.58027 .31507 m
.60392 .32579 L
s
.24 .35 .67 r
.33421 .34411 m
.36701 .33665 L
s
.33421 .34411 m
.31849 .32057 L
s
.83 .24 .1 r
.56765 .54125 m
.59151 .54885 L
s
.60901 .56883 m
.59151 .54885 L
s
.52215 .48112 m
.54667 .48957 L
s
.54667 .48957 m
.55466 .51693 L
s
.24 .35 .67 r
.35377 .51629 m
.36043 .48943 L
s
.36043 .48943 m
.39356 .48341 L
s
.83 .24 .1 r
.70181 .30221 m
.72812 .30271 L
s
.67943 .2911 m
.70181 .30221 L
s
.24 .35 .67 r
.39448 .42358 m
.38896 .3931 L
s
.38896 .3931 m
.42245 .38609 L
s
.38896 .3931 m
.3797 .36376 L
s
.83 .24 .1 r
.65288 .29696 m
.62738 .30872 L
s
.60394 .2977 m
.62738 .30872 L
s
.24 .35 .67 r
.39605 .45406 m
.39448 .42358 L
s
.39448 .42358 m
.42804 .41687 L
s
.3797 .36376 m
.41315 .35644 L
s
.3797 .36376 m
.36701 .33665 L
s
.31849 .32057 m
.35133 .31281 L
s
.31849 .32057 m
.3003 .30125 L
s
.83 .24 .1 r
.54255 .36274 m
.52991 .39112 L
s
.50503 .38123 m
.52991 .39112 L
s
.52991 .39112 m
.52211 .42108 L
s
.24 .35 .67 r
.42971 .44764 m
.39605 .45406 L
s
.39356 .48341 m
.39605 .45406 L
s
.83 .24 .1 r
.55955 .33705 m
.54255 .36274 L
s
.51784 .35245 m
.54255 .36274 L
s
.53011 .50882 m
.55466 .51693 L
s
.55466 .51693 m
.56765 .54125 L
s
.49708 .41161 m
.52211 .42108 L
s
.52211 .42108 m
.51947 .45148 L
s
.58521 .56145 m
.60901 .56883 L
s
.6304 .5838 m
.60901 .56883 L
s
.24 .35 .67 r
.34326 .53983 m
.35377 .51629 L
s
.35377 .51629 m
.38706 .51049 L
s
.83 .24 .1 r
.58027 .31507 m
.55955 .33705 L
s
.53502 .32638 m
.55955 .33705 L
s
.24 .35 .67 r
.36701 .33665 m
.40047 .32902 L
s
.36701 .33665 m
.35133 .31281 L
s
.83 .24 .1 r
.67943 .2911 m
.65288 .29696 L
s
.62965 .2857 m
.65288 .29696 L
s
.49434 .44241 m
.51947 .45148 L
s
.51947 .45148 m
.52215 .48112 L
s
.72812 .30271 m
.75327 .30953 L
s
.70593 .29152 m
.72812 .30271 L
s
.24 .35 .67 r
.38706 .51049 m
.39356 .48341 L
s
.39356 .48341 m
.42736 .47726 L
s
.83 .24 .1 r
.60394 .2977 m
.58027 .31507 L
s
.55595 .30404 m
.58027 .31507 L
s
.24 .35 .67 r
.3003 .30125 m
.33321 .29324 L
s
.3003 .30125 m
.28029 .28702 L
s
.42804 .41687 m
.42245 .38609 L
s
.42245 .38609 m
.45662 .37894 L
s
.42245 .38609 m
.41315 .35644 L
s
.42971 .44764 m
.42804 .41687 L
s
.42804 .41687 m
.46228 .41003 L
s
.83 .24 .1 r
.54311 .53343 m
.56765 .54125 L
s
.56765 .54125 m
.58521 .56145 L
s
.49693 .47243 m
.52215 .48112 L
s
.52215 .48112 m
.53011 .50882 L
s
.24 .35 .67 r
.41315 .35644 m
.44729 .34898 L
s
.41315 .35644 m
.40047 .32902 L
s
.35133 .31281 m
.38484 .3049 L
s
.35133 .31281 m
.33321 .29324 L
s
.83 .24 .1 r
.60671 .57657 m
.6304 .5838 L
s
.65484 .59301 m
.6304 .5838 L
s
.24 .35 .67 r
.32921 .55902 m
.34326 .53983 L
s
.34326 .53983 m
.37673 .53422 L
s
.46406 .4411 m
.42971 .44764 L
s
.42736 .47726 m
.42971 .44764 L
s
.83 .24 .1 r
.70593 .29152 m
.67943 .2911 L
s
.65641 .27967 m
.67943 .2911 L
s
.62965 .2857 m
.60394 .2977 L
s
.57983 .28636 m
.60394 .2977 L
s
.24 .35 .67 r
.37673 .53422 m
.38706 .51049 L
s
.38706 .51049 m
.42103 .50458 L
s
.40047 .32902 m
.43461 .32125 L
s
.40047 .32902 m
.38484 .3049 L
s
.83 .24 .1 r
.75327 .30953 m
.77611 .32253 L
s
.73125 .29834 m
.75327 .30953 L
s
.51784 .35245 m
.50503 .38123 L
s
.50503 .38123 m
.49708 .41161 L
s
.53502 .32638 m
.51784 .35245 L
s
.50485 .50048 m
.53011 .50882 L
s
.53011 .50882 m
.54311 .53343 L
s
.24 .35 .67 r
.42103 .50458 m
.42736 .47726 L
s
.42736 .47726 m
.46186 .47099 L
s
.83 .24 .1 r
.49708 .41161 m
.49434 .44241 L
s
.56073 .55385 m
.58521 .56145 L
s
.58521 .56145 m
.60671 .57657 L
s
.24 .35 .67 r
.28029 .28702 m
.31332 .27879 L
s
.28029 .28702 m
.25924 .27861 L
s
.83 .24 .1 r
.55595 .30404 m
.53502 .32638 L
s
.50979 .3154 m
.53502 .32638 L
s
.24 .35 .67 r
.33321 .29324 m
.3668 .28506 L
s
.33321 .29324 m
.31332 .27879 L
s
.46228 .41003 m
.45662 .37894 L
s
.45662 .37894 m
.44729 .34898 L
s
.46406 .4411 m
.46228 .41003 L
s
.83 .24 .1 r
.65641 .27967 m
.62965 .2857 L
s
.60576 .27412 m
.62965 .2857 L
s
.63131 .58585 m
.65484 .59301 L
s
.68133 .59588 m
.65484 .59301 L
s
.49434 .44241 m
.49693 .47243 L
s
.73125 .29834 m
.70593 .29152 L
s
.6831 .28 m
.70593 .29152 L
s
.24 .35 .67 r
.44729 .34898 m
.43461 .32125 L
s
.38484 .3049 m
.41903 .29683 L
s
.38484 .3049 m
.3668 .28506 L
s
.31209 .57295 m
.32921 .55902 L
s
.32921 .55902 m
.36286 .55356 L
s
.83 .24 .1 r
.57983 .28636 m
.55595 .30404 L
s
.53092 .2927 m
.55595 .30404 L
s
.24 .35 .67 r
.36286 .55356 m
.37673 .53422 L
s
.37673 .53422 m
.41088 .5285 L
s
.46186 .47099 m
.46406 .4411 L
s
.83 .24 .1 r
.77611 .32253 m
.79558 .34128 L
s
.75424 .31144 m
.77611 .32253 L
s
.51786 .52538 m
.54311 .53343 L
s
.54311 .53343 m
.56073 .55385 L
s
.24 .35 .67 r
.41088 .5285 m
.42103 .50458 L
s
.42103 .50458 m
.4557 .49854 L
s
1 .291 .12 r
.47049 .38493 m .48296 .38976 L .48167 .41446 L p F P
0 0 0 r
s
.24 .35 .67 r
.46228 .41003 m
.47875 .40674 L
s
1 .291 .12 r
.48167 .41446 m .46872 .40962 L .47049 .38493 L p F P
0 0 0 r
s
1 .283 .116 r
.46872 .40962 m .48167 .41446 L .48117 .43834 L p F P
0 0 0 r
s
.213 .302 .606 r
.49895 .43496 m .48117 .43834 L .48167 .41446 L p F P
0 0 0 r
s
.213 .302 .606 r
.48167 .41446 m .4992 .411 L .49895 .43496 L p F P
0 0 0 r
s
.83 .24 .1 r
.48374 .40656 m
.49676 .41148 L
s
.222 .317 .635 r
.4992 .411 m .48167 .41446 L .48296 .38976 L p F P
0 0 0 r
s
1 .298 .123 r
.47332 .36 m .48501 .3647 L .48296 .38976 L p F P
0 0 0 r
s
1 .298 .123 r
.48296 .38976 m .47049 .38493 L .47332 .36 L p F P
0 0 0 r
s
.24 .35 .67 r
.45662 .37894 m
.47153 .37582 L
s
.222 .317 .635 r
.48296 .38976 m .49985 .38631 L .4992 .411 L p F P
0 0 0 r
s
.24 .35 .67 r
.48141 .40621 m
.49722 .40305 L
s
.83 .24 .1 r
.47134 .40186 m
.48301 .40628 L
s
.23 .331 .661 r
.49985 .38631 m .48296 .38976 L .48501 .3647 L p F P
0 0 0 r
s
.83 .24 .1 r
.49312 .3765 m
.50503 .38123 L
s
.24 .35 .67 r
.43461 .32125 m
.46946 .31331 L
s
.43461 .32125 m
.41903 .29683 L
s
.83 .24 .1 r
.58233 .56914 m
.60671 .57657 L
s
.60671 .57657 m
.63131 .58585 L
s
1 .283 .116 r
.48117 .43834 m .46802 .4336 L .46872 .40962 L p F P
0 0 0 r
s
.976 .272 .112 r
.46802 .4336 m .48117 .43834 L .48147 .46097 L p F P
0 0 0 r
s
.24 .35 .67 r
.46406 .4411 m
.47105 .43977 L
s
.203 .285 .574 r
.4991 .45772 m .48147 .46097 L .48117 .43834 L p F P
0 0 0 r
s
.203 .285 .574 r
.48117 .43834 m .49895 .43496 L .4991 .45772 L p F P
0 0 0 r
s
.83 .24 .1 r
.6831 .28 m
.65641 .27967 L
s
.63272 .26792 m
.65641 .27967 L
s
.24 .35 .67 r
.4557 .49854 m
.46186 .47099 L
s
.83 .24 .1 r
.60576 .27412 m
.57983 .28636 L
s
.55502 .2747 m
.57983 .28636 L
s
.23 .331 .661 r
.48501 .3647 m .50088 .36134 L .49985 .38631 L p F P
0 0 0 r
s
.24 .35 .67 r
.48357 .3733 m
.49148 .37165 L
s
.83 .24 .1 r
.47943 .37107 m
.48526 .37338 L
s
.238 .344 .686 r
.50088 .36134 m .48501 .3647 L .4878 .33972 L p F P
0 0 0 r
s
.83 .24 .1 r
.49242 .34187 m
.51784 .35245 L
s
1 .304 .126 r
.47715 .33529 m .4878 .33972 L .48501 .3647 L p F P
0 0 0 r
s
1 .304 .126 r
.48501 .3647 m .47332 .36 L .47715 .33529 L p F P
0 0 0 r
s
.24 .35 .67 r
.44729 .34898 m
.476 .34269 L
s
.83 .24 .1 r
.65798 .58871 m
.68133 .59588 L
s
.7087 .59215 m
.68133 .59588 L
s
.24 .35 .67 r
.31332 .27879 m
.34702 .27039 L
s
.31332 .27879 m
.29239 .2702 L
s
.25924 .27861 m
.29239 .2702 L
s
.25924 .27861 m
.23799 .27654 L
s
.3668 .28506 m
.40109 .27672 L
s
.3668 .28506 m
.34702 .27039 L
s
.49148 .37165 m
.49722 .40305 L
s
.48519 .35128 m
.49148 .37165 L
s
.83 .24 .1 r
.75424 .31144 m
.73125 .29834 L
s
.70859 .28683 m
.73125 .29834 L
s
.213 .302 .606 r
.51692 .43154 m .49895 .43496 L .4992 .411 L p F P
0 0 0 r
s
.213 .302 .606 r
.4992 .411 m .51691 .40751 L .51692 .43154 L p F P
0 0 0 r
s
.222 .317 .635 r
.51691 .40751 m .4992 .411 L .49985 .38631 L p F P
0 0 0 r
s
.222 .317 .635 r
.49985 .38631 m .51691 .38282 L .51691 .40751 L p F P
0 0 0 r
s
.23 .331 .661 r
.51691 .38282 m .49985 .38631 L .50088 .36134 L p F P
0 0 0 r
s
.83 .24 .1 r
.47943 .37107 m
.48816 .35143 L
s
.49101 .34503 m
.49242 .34187 L
s
.47134 .40186 m
.47943 .37107 L
s
.191 .266 .537 r
.49965 .47887 m .48257 .4819 L .48147 .46097 L p F P
0 0 0 r
s
.83 .24 .1 r
.49693 .47243 m
.4984 .47764 L
s
.49879 .47902 m
.50485 .50048 L
s
.49106 .47041 m
.49693 .47243 L
s
.191 .266 .537 r
.48147 .46097 m .4991 .45772 L .49965 .47887 L p F P
0 0 0 r
s
.976 .272 .112 r
.48147 .46097 m .46843 .45643 L .46802 .4336 L p F P
0 0 0 r
s
.934 .258 .105 r
.46843 .45643 m .48147 .46097 L .48257 .4819 L p F P
0 0 0 r
s
.24 .35 .67 r
.46186 .47099 m
.47517 .46856 L
s
.83 .24 .1 r
.50485 .50048 m
.51786 .52538 L
s
.24 .35 .67 r
.41903 .29683 m
.45394 .28859 L
s
.41903 .29683 m
.40109 .27672 L
s
.83 .24 .1 r
.79558 .34128 m
.81068 .36505 L
s
.77381 .33037 m
.79558 .34128 L
s
.53554 .54604 m
.56073 .55385 L
s
.56073 .55385 m
.58233 .56914 L
s
.203 .285 .574 r
.51691 .45445 m .4991 .45772 L .49895 .43496 L p F P
0 0 0 r
s
.203 .285 .574 r
.49895 .43496 m .51692 .43154 L .51691 .45445 L p F P
0 0 0 r
s
.24 .35 .67 r
.48026 .43801 m
.49911 .43442 L
s
.49722 .40305 m
.49911 .43442 L
s
1 .291 .12 r
.45785 .38003 m .47049 .38493 L .46872 .40962 L p F P
0 0 0 r
s
1 .291 .12 r
.46872 .40962 m .45557 .40471 L .45785 .38003 L p F P
0 0 0 r
s
1 .283 .116 r
.45557 .40471 m .46872 .40962 L .46802 .4336 L p F P
0 0 0 r
s
.83 .24 .1 r
.46847 .43308 m
.47134 .40186 L
s
.46847 .43308 m
.48241 .43811 L
s
1 .298 .123 r
.46148 .35524 m .47332 .36 L .47049 .38493 L p F P
0 0 0 r
s
1 .298 .123 r
.47049 .38493 m .45785 .38003 L .46148 .35524 L p F P
0 0 0 r
s
.23 .331 .661 r
.50088 .36134 m .51689 .35795 L .51691 .38282 L p F P
0 0 0 r
s
.238 .344 .686 r
.51689 .35795 m .50088 .36134 L .50227 .33655 L p F P
0 0 0 r
s
.238 .344 .686 r
.4878 .33972 m .50227 .33655 L .50088 .36134 L p F P
0 0 0 r
s
1 .308 .128 r
.48193 .31127 m .49127 .31529 L .4878 .33972 L p F P
0 0 0 r
s
1 .308 .128 r
.4878 .33972 m .47715 .33529 L .48193 .31127 L p F P
0 0 0 r
s
.245 .357 .711 r
.50227 .33655 m .4878 .33972 L .49127 .31529 L p F P
0 0 0 r
s
.83 .24 .1 r
.49947 .33113 m
.50979 .3154 L
s
.24 .35 .67 r
.34593 .56757 m
.36286 .55356 L
s
.36286 .55356 m
.39722 .54798 L
s
.39722 .54798 m
.41088 .5285 L
s
.41088 .5285 m
.44575 .52266 L
s
.29254 .58086 m
.31209 .57295 L
s
.31209 .57295 m
.34593 .56757 L
s
1 .283 .116 r
.46802 .4336 m .45468 .4288 L .45557 .40471 L p F P
0 0 0 r
s
.976 .272 .112 r
.45468 .4288 m .46802 .4336 L .46843 .45643 L p F P
0 0 0 r
s
.83 .24 .1 r
.63272 .26792 m
.60576 .27412 L
s
.58116 .2622 m
.60576 .27412 L
s
1 .304 .126 r
.46638 .3308 m .47715 .33529 L .47332 .36 L p F P
0 0 0 r
s
1 .304 .126 r
.47332 .36 m .46148 .35524 L .46638 .3308 L p F P
0 0 0 r
s
.24 .35 .67 r
.46946 .31331 m
.47783 .33186 L
s
.83 .24 .1 r
.60708 .57849 m
.63131 .58585 L
s
.63131 .58585 m
.65798 .58871 L
s
.24 .35 .67 r
.44575 .52266 m
.4557 .49854 L
s
.222 .317 .635 r
.53481 .40397 m .51691 .40751 L .51691 .38282 L p F P
0 0 0 r
s
.222 .317 .635 r
.51691 .38282 m .53413 .3793 L .53481 .40397 L p F P
0 0 0 r
s
.24 .35 .67 r
.49722 .40305 m
.53289 .39593 L
s
.23 .331 .661 r
.53413 .3793 m .51691 .38282 L .51689 .35795 L p F P
0 0 0 r
s
.213 .302 .606 r
.53507 .42808 m .51692 .43154 L .51691 .40751 L p F P
0 0 0 r
s
.213 .302 .606 r
.51691 .40751 m .53481 .40397 L .53507 .42808 L p F P
0 0 0 r
s
.83 .24 .1 r
.70859 .28683 m
.6831 .28 L
s
.6596 .26815 m
.6831 .28 L
s
.68557 .58487 m
.7087 .59215 L
s
.73569 .58183 m
.7087 .59215 L
s
.191 .266 .537 r
.51691 .4758 m .49965 .47887 L .4991 .45772 L p F P
0 0 0 r
s
.191 .266 .537 r
.4991 .45772 m .51691 .45445 L .51691 .4758 L p F P
0 0 0 r
s
.24 .35 .67 r
.49707 .46458 m
.49911 .43442 L
s
.238 .344 .686 r
.50227 .33655 m .51688 .33336 L .51689 .35795 L p F P
0 0 0 r
s
.245 .357 .711 r
.51688 .33336 m .50227 .33655 L .50401 .31242 L p F P
0 0 0 r
s
.83 .24 .1 r
.5044 .31305 m
.50979 .3154 L
s
.50979 .3154 m
.53092 .2927 L
s
.245 .357 .711 r
.49127 .31529 m .50401 .31242 L .50227 .33655 L p F P
0 0 0 r
s
.83 .24 .1 r
.55502 .2747 m
.53092 .2927 L
s
.934 .258 .105 r
.48257 .4819 m .46995 .47765 L .46843 .45643 L p F P
0 0 0 r
s
.83 .24 .1 r
.47099 .46349 m
.48275 .46755 L
s
.24 .35 .67 r
.48114 .46748 m
.49707 .46458 L
s
.877 .239 .097 r
.46995 .47765 m .48257 .4819 L .48447 .50072 L p F P
0 0 0 r
s
.24 .35 .67 r
.4557 .49854 m
.48039 .49425 L
s
.176 .242 .491 r
.5006 .49794 m .48447 .50072 L .48257 .4819 L p F P
0 0 0 r
s
.83 .24 .1 r
.49834 .49833 m
.50485 .50048 L
s
.176 .242 .491 r
.48257 .4819 m .49965 .47887 L .5006 .49794 L p F P
0 0 0 r
s
.23 .331 .661 r
.51689 .35795 m .53306 .35453 L .53413 .3793 L p F P
0 0 0 r
s
.24 .35 .67 r
.49148 .37165 m
.52707 .3642 L
s
.238 .344 .686 r
.53306 .35453 m .51689 .35795 L .51688 .33336 L p F P
0 0 0 r
s
.203 .285 .574 r
.53492 .45114 m .51691 .45445 L .51692 .43154 L p F P
0 0 0 r
s
.203 .285 .574 r
.51692 .43154 m .53507 .42808 L .53492 .45114 L p F P
0 0 0 r
s
.24 .35 .67 r
.4911 .49238 m
.49707 .46458 L
s
.976 .272 .112 r
.46843 .45643 m .45521 .45183 L .45468 .4288 L p F P
0 0 0 r
s
.934 .258 .105 r
.45521 .45183 m .46843 .45643 L .46995 .47765 L p F P
0 0 0 r
s
.83 .24 .1 r
.46847 .43308 m
.47099 .46349 L
s
.77381 .33037 m
.75424 .31144 L
s
.73173 .30002 m
.75424 .31144 L
s
1 .308 .128 r
.47249 .3072 m .48193 .31127 L .47715 .33529 L p F P
0 0 0 r
s
.24 .35 .67 r
.46946 .31331 m
.47336 .31242 L
s
1 .308 .128 r
.47715 .33529 m .46638 .3308 L .47249 .3072 L p F P
0 0 0 r
s
.24 .35 .67 r
.45394 .28859 m
.46946 .31331 L
s
.83 .24 .1 r
.49187 .5171 m
.51786 .52538 L
s
.51786 .52538 m
.53554 .54604 L
s
.81068 .36505 m
.82062 .39283 L
s
.78898 .35441 m
.81068 .36505 L
s
.24 .35 .67 r
.34702 .27039 m
.38143 .26181 L
s
.34702 .27039 m
.32624 .26162 L
s
.29239 .2702 m
.32624 .26162 L
s
.29239 .2702 m
.2713 .26802 L
s
1 .311 .13 r
.48757 .28843 m .49538 .2919 L .49127 .31529 L p F P
0 0 0 r
s
1 .311 .13 r
.49127 .31529 m .48193 .31127 L .48757 .28843 L p F P
0 0 0 r
s
.24 .35 .67 r
.48072 .31075 m
.48214 .31043 L
s
.253 .37 .736 r
.50401 .31242 m .49127 .31529 L .49538 .2919 L p F P
0 0 0 r
s
1 .298 .123 r
.44948 .35041 m .46148 .35524 L .45785 .38003 L p F P
0 0 0 r
s
1 .298 .123 r
.45785 .38003 m .44503 .37506 L .44948 .35041 L p F P
0 0 0 r
s
.83 .24 .1 r
.45309 .36061 m
.47943 .37107 L
s
1 .291 .12 r
.44503 .37506 m .45785 .38003 L .45557 .40471 L p F P
0 0 0 r
s
1 .291 .12 r
.45557 .40471 m .44224 .39972 L .44503 .37506 L p F P
0 0 0 r
s
1 .283 .116 r
.44224 .39972 m .45557 .40471 L .45468 .4288 L p F P
0 0 0 r
s
.24 .35 .67 r
.40109 .27672 m
.43609 .2682 L
s
.40109 .27672 m
.38143 .26181 L
s
.23799 .27654 m
.2713 .26802 L
s
.23799 .27654 m
.21746 .28113 L
s
.52707 .3642 m
.53289 .39593 L
s
.222 .317 .635 r
.55289 .40041 m .53481 .40397 L .53413 .3793 L p F P
0 0 0 r
s
.222 .317 .635 r
.53413 .3793 m .55153 .37574 L .55289 .40041 L p F P
0 0 0 r
s
.23 .331 .661 r
.55153 .37574 m .53413 .3793 L .53306 .35453 L p F P
0 0 0 r
s
.83 .24 .1 r
.55724 .56148 m
.58233 .56914 L
s
.58233 .56914 m
.60708 .57849 L
s
.213 .302 .606 r
.55342 .42458 m .53507 .42808 L .53481 .40397 L p F P
0 0 0 r
s
.24 .35 .67 r
.49911 .43442 m
.5349 .4276 L
s
.213 .302 .606 r
.53481 .40397 m .55289 .40041 L .55342 .42458 L p F P
0 0 0 r
s
.24 .35 .67 r
.53289 .39593 m
.5349 .4276 L
s
1 .304 .126 r
.45549 .32626 m .46638 .3308 L .46148 .35524 L p F P
0 0 0 r
s
.83 .24 .1 r
.46625 .33098 m
.48913 .3405 L
s
1 .304 .126 r
.46148 .35524 m .44948 .35041 L .45549 .32626 L p F P
0 0 0 r
s
.238 .344 .686 r
.51688 .33336 m .5316 .33013 L .53306 .35453 L p F P
0 0 0 r
s
.24 .35 .67 r
.51768 .33358 m
.52707 .3642 L
s
.4866 .34038 m
.51768 .33358 L
s
.245 .357 .711 r
.5316 .33013 m .51688 .33336 L .51685 .30952 L p F P
0 0 0 r
s
.245 .357 .711 r
.50401 .31242 m .51685 .30952 L .51688 .33336 L p F P
0 0 0 r
s
.191 .266 .537 r
.53434 .4727 m .51691 .4758 L .51691 .45445 L p F P
0 0 0 r
s
.191 .266 .537 r
.51691 .45445 m .53492 .45114 L .53434 .4727 L p F P
0 0 0 r
s
.24 .35 .67 r
.49707 .46458 m
.53301 .45804 L
s
1 .283 .116 r
.45468 .4288 m .44115 .42392 L .44224 .39972 L p F P
0 0 0 r
s
.976 .272 .112 r
.44115 .42392 m .45468 .4288 L .45521 .45183 L p F P
0 0 0 r
s
.23 .331 .661 r
.53306 .35453 m .54937 .35107 L .55153 .37574 L p F P
0 0 0 r
s
.238 .344 .686 r
.54937 .35107 m .53306 .35453 L .5316 .33013 L p F P
0 0 0 r
s
.83 .24 .1 r
.6596 .26815 m
.63272 .26792 L
s
.60833 .25581 m
.63272 .26792 L
s
.176 .242 .491 r
.5169 .49514 m .5006 .49794 L .49965 .47887 L p F P
0 0 0 r
s
.176 .242 .491 r
.49965 .47887 m .51691 .4758 L .5169 .49514 L p F P
0 0 0 r
s
.24 .35 .67 r
.45394 .28859 m
.43609 .2682 L
s
.83 .24 .1 r
.58116 .2622 m
.55502 .2747 L
s
.52948 .26269 m
.55502 .2747 L
s
.7128 .57435 m
.73569 .58183 L
s
.76102 .56529 m
.73569 .58183 L
s
.203 .285 .574 r
.5531 .4478 m .53492 .45114 L .53507 .42808 L p F P
0 0 0 r
s
.203 .285 .574 r
.53507 .42808 m .55342 .42458 L .5531 .4478 L p F P
0 0 0 r
s
.83 .24 .1 r
.63394 .58133 m
.65798 .58871 L
s
.65798 .58871 m
.68557 .58487 L
s
.253 .37 .736 r
.51685 .30952 m .50401 .31242 L .50607 .28941 L p F P
0 0 0 r
s
.253 .37 .736 r
.49538 .2919 m .50607 .28941 L .50401 .31242 L p F P
0 0 0 r
s
.24 .35 .67 r
.49138 .30832 m
.50504 .30521 L
s
.38049 .56208 m
.39722 .54798 L
s
.39722 .54798 m
.43229 .54228 L
s
.43229 .54228 m
.44575 .52266 L
s
.32656 .5755 m
.34593 .56757 L
s
.34593 .56757 m
.38049 .56208 L
s
.934 .258 .105 r
.46995 .47765 m .45716 .47335 L .45521 .45183 L p F P
0 0 0 r
s
.877 .239 .097 r
.45716 .47335 m .46995 .47765 L .47257 .49683 L p F P
0 0 0 r
s
.877 .239 .097 r
.48447 .50072 m .47257 .49683 L .46995 .47765 L p F P
0 0 0 r
s
.83 .24 .1 r
.47099 .46349 m
.47886 .49189 L
s
.47886 .49189 m
.48478 .49385 L
s
.24 .35 .67 r
.48306 .49378 m
.4911 .49238 L
s
.83 .24 .1 r
.73173 .30002 m
.70859 .28683 L
s
.68527 .27498 m
.70859 .28683 L
s
.24 .35 .67 r
.27133 .5822 m
.29254 .58086 L
s
.29254 .58086 m
.32656 .5755 L
s
1 .308 .128 r
.46295 .3031 m .47249 .3072 L .46638 .3308 L p F P
0 0 0 r
s
1 .308 .128 r
.46638 .3308 m .45549 .32626 L .46295 .3031 L p F P
0 0 0 r
s
1 .311 .13 r
.4797 .28492 m .48757 .28843 L .48193 .31127 L p F P
0 0 0 r
s
.83 .24 .1 r
.48383 .3041 m
.49382 .30845 L
s
1 .311 .13 r
.48193 .31127 m .47249 .3072 L .4797 .28492 L p F P
0 0 0 r
s
.83 .24 .1 r
.82062 .39283 m
.82483 .42336 L
s
.79894 .38253 m
.82062 .39283 L
s
.45309 .36061 m
.46625 .33098 L
s
.157 .212 .431 r
.50195 .51453 m .48714 .517 L .48447 .50072 L p F P
0 0 0 r
s
.157 .212 .431 r
.48447 .50072 m .5006 .49794 L .50195 .51453 L p F P
0 0 0 r
s
.795 .213 .085 r
.47257 .49683 m .48447 .50072 L .48714 .517 L p F P
0 0 0 r
s
.24 .35 .67 r
.48456 .50869 m
.4911 .49238 L
s
.238 .344 .686 r
.5316 .33013 m .54645 .32688 L .54937 .35107 L p F P
0 0 0 r
s
.245 .357 .711 r
.54645 .32688 m .5316 .33013 L .52979 .3066 L p F P
0 0 0 r
s
.245 .357 .711 r
.51685 .30952 m .52979 .3066 L .5316 .33013 L p F P
0 0 0 r
s
.24 .35 .67 r
.50504 .30521 m
.51768 .33358 L
s
.222 .317 .635 r
.57116 .3968 m .55289 .40041 L .55153 .37574 L p F P
0 0 0 r
s
.222 .317 .635 r
.55153 .37574 m .5691 .37215 L .57116 .3968 L p F P
0 0 0 r
s
.23 .331 .661 r
.5691 .37215 m .55153 .37574 L .54937 .35107 L p F P
0 0 0 r
s
.976 .272 .112 r
.45521 .45183 m .44179 .44716 L .44115 .42392 L p F P
0 0 0 r
s
.934 .258 .105 r
.44179 .44716 m .45521 .45183 L .45716 .47335 L p F P
0 0 0 r
s
.83 .24 .1 r
.46625 .33098 m
.48383 .3041 L
s
.213 .302 .606 r
.57196 .42105 m .55342 .42458 L .55289 .40041 L p F P
0 0 0 r
s
.213 .302 .606 r
.55289 .40041 m .57116 .3968 L .57196 .42105 L p F P
0 0 0 r
s
.83 .24 .1 r
.47886 .49189 m
.48759 .50881 L
s
.49145 .51628 m
.49187 .5171 L
s
.78898 .35441 m
.77381 .33037 L
s
.75141 .31914 m
.77381 .33037 L
s
1 .298 .123 r
.43732 .34553 m .44948 .35041 L .44503 .37506 L p F P
0 0 0 r
s
1 .298 .123 r
.44503 .37506 m .43203 .37002 L .43732 .34553 L p F P
0 0 0 r
s
1 .291 .12 r
.43203 .37002 m .44503 .37506 L .44224 .39972 L p F P
0 0 0 r
s
.83 .24 .1 r
.44485 .39184 m
.45309 .36061 L
s
.44485 .39184 m
.47134 .40186 L
s
.191 .266 .537 r
.55194 .46958 m .53434 .4727 L .53492 .45114 L p F P
0 0 0 r
s
.24 .35 .67 r
.53301 .45804 m
.5349 .4276 L
s
.191 .266 .537 r
.53492 .45114 m .5531 .4478 L .55194 .46958 L p F P
0 0 0 r
s
.83 .24 .1 r
.5096 .538 m
.53554 .54604 L
s
.53554 .54604 m
.55724 .56148 L
s
.23 .331 .661 r
.54937 .35107 m .56584 .34759 L .5691 .37215 L p F P
0 0 0 r
s
.24 .35 .67 r
.52707 .3642 m
.56341 .35659 L
s
.238 .344 .686 r
.56584 .34759 m .54937 .35107 L .54645 .32688 L p F P
0 0 0 r
s
.253 .37 .736 r
.52979 .3066 m .51685 .30952 L .51683 .28692 L p F P
0 0 0 r
s
.253 .37 .736 r
.50607 .28941 m .51683 .28692 L .51685 .30952 L p F P
0 0 0 r
s
1 .291 .12 r
.44224 .39972 m .42871 .39467 L .43203 .37002 L p F P
0 0 0 r
s
1 .283 .116 r
.42871 .39467 m .44224 .39972 L .44115 .42392 L p F P
0 0 0 r
s
.83 .24 .1 r
.44185 .42347 m
.44485 .39184 L
s
.44185 .42347 m
.46847 .43308 L
s
.176 .242 .491 r
.53334 .49231 m .5169 .49514 L .51691 .4758 L p F P
0 0 0 r
s
.176 .242 .491 r
.51691 .4758 m .53434 .4727 L .53334 .49231 L p F P
0 0 0 r
s
1 .304 .126 r
.44446 .32167 m .45549 .32626 L .44948 .35041 L p F P
0 0 0 r
s
1 .304 .126 r
.44948 .35041 m .43732 .34553 L .44446 .32167 L p F P
0 0 0 r
s
.83 .24 .1 r
.73838 .55752 m
.76102 .56529 L
s
.78343 .54322 m
.76102 .56529 L
s
1 .313 .131 r
.49399 .26724 m .50006 .27002 L .49538 .2919 L p F P
0 0 0 r
s
1 .313 .131 r
.49538 .2919 m .48757 .28843 L .49399 .26724 L p F P
0 0 0 r
s
.261 .384 .762 r
.50607 .28941 m .49538 .2919 L .50006 .27002 L p F P
0 0 0 r
s
.83 .24 .1 r
.48383 .3041 m
.49904 .28764 L
s
.24 .35 .67 r
.49403 .28737 m
.50504 .30521 L
s
.203 .285 .574 r
.57148 .44442 m .5531 .4478 L .55342 .42458 L p F P
0 0 0 r
s
.203 .285 .574 r
.55342 .42458 m .57196 .42105 L .57148 .44442 L p F P
0 0 0 r
s
.24 .35 .67 r
.52723 .48609 m
.53301 .45804 L
s
1 .283 .116 r
.44115 .42392 m .42741 .41897 L .42871 .39467 L p F P
0 0 0 r
s
.976 .272 .112 r
.42741 .41897 m .44115 .42392 L .44179 .44716 L p F P
0 0 0 r
s
.83 .24 .1 r
.60833 .25581 m
.58116 .2622 L
s
.58213 .5709 m
.60708 .57849 L
s
.60708 .57849 m
.63394 .58133 L
s
.24 .35 .67 r
.38143 .26181 m
.41657 .25305 L
s
.38143 .26181 m
.3608 .25286 L
s
.238 .344 .686 r
.54645 .32688 m .56143 .32361 L .56584 .34759 L p F P
0 0 0 r
s
.245 .357 .711 r
.56143 .32361 m .54645 .32688 L .54283 .30366 L p F P
0 0 0 r
s
.245 .357 .711 r
.52979 .3066 m .54283 .30366 L .54645 .32688 L p F P
0 0 0 r
s
.24 .35 .67 r
.51768 .33358 m
.55399 .32564 L
s
.32624 .26162 m
.3608 .25286 L
s
.32624 .26162 m
.30531 .25932 L
s
1 .311 .13 r
.47175 .28139 m .4797 .28492 L .47249 .3072 L p F P
0 0 0 r
s
.24 .35 .67 r
.45394 .28859 m
.47184 .28437 L
s
1 .311 .13 r
.47249 .3072 m .46295 .3031 L .47175 .28139 L p F P
0 0 0 r
s
.83 .24 .1 r
.82483 .42336 m
.8031 .41346 L
s
.82483 .42336 m
.82303 .4552 L
s
.157 .212 .431 r
.51688 .51203 m .50195 .51453 L .5006 .49794 L p F P
0 0 0 r
s
.157 .212 .431 r
.5006 .49794 m .5169 .49514 L .51688 .51203 L p F P
0 0 0 r
s
.24 .35 .67 r
.43609 .2682 m
.41657 .25305 L
s
.83 .24 .1 r
.68527 .27498 m
.6596 .26815 L
s
.63541 .25595 m
.6596 .26815 L
s
.222 .317 .635 r
.58962 .39316 m .57116 .3968 L .5691 .37215 L p F P
0 0 0 r
s
.222 .317 .635 r
.5691 .37215 m .58685 .36852 L .58962 .39316 L p F P
0 0 0 r
s
.24 .35 .67 r
.53289 .39593 m
.5693 .38865 L
s
.23 .331 .661 r
.58685 .36852 m .5691 .37215 L .56584 .34759 L p F P
0 0 0 r
s
1 .308 .128 r
.45332 .29894 m .46295 .3031 L .45549 .32626 L p F P
0 0 0 r
s
1 .308 .128 r
.45549 .32626 m .44446 .32167 L .45332 .29894 L p F P
0 0 0 r
s
.83 .24 .1 r
.66176 .57737 m
.68557 .58487 L
s
.68557 .58487 m
.7128 .57435 L
s
.253 .37 .736 r
.54283 .30366 m .52979 .3066 L .52766 .2844 L p F P
0 0 0 r
s
.253 .37 .736 r
.51683 .28692 m .52766 .2844 L .52979 .3066 L p F P
0 0 0 r
s
.24 .35 .67 r
.2713 .26802 m
.30531 .25932 L
s
.2713 .26802 m
.25093 .27255 L
s
.56341 .35659 m
.5693 .38865 L
s
.261 .384 .762 r
.51683 .28692 m .50607 .28941 L .50841 .26803 L p F P
0 0 0 r
s
.83 .24 .1 r
.51649 .28615 m
.51772 .28671 L
s
.261 .384 .762 r
.50006 .27002 m .50841 .26803 L .50607 .28941 L p F P
0 0 0 r
s
.213 .302 .606 r
.5907 .41749 m .57196 .42105 L .57116 .3968 L p F P
0 0 0 r
s
.24 .35 .67 r
.5349 .4276 m
.57144 .42064 L
s
.213 .302 .606 r
.57116 .3968 m .58962 .39316 L .5907 .41749 L p F P
0 0 0 r
s
.24 .35 .67 r
.5693 .38865 m
.57144 .42064 L
s
.934 .258 .105 r
.45716 .47335 m .44418 .46898 L .44179 .44716 L p F P
0 0 0 r
s
.83 .24 .1 r
.44428 .45429 m
.47099 .46349 L
s
.877 .239 .097 r
.44418 .46898 m .45716 .47335 L .46051 .4929 L p F P
0 0 0 r
s
.877 .239 .097 r
.47257 .49683 m .46051 .4929 L .45716 .47335 L p F P
0 0 0 r
s
.23 .331 .661 r
.56584 .34759 m .58247 .34407 L .58685 .36852 L p F P
0 0 0 r
s
.238 .344 .686 r
.58247 .34407 m .56584 .34759 L .56143 .32361 L p F P
0 0 0 r
s
.24 .35 .67 r
.55399 .32564 m
.56341 .35659 L
s
.21746 .28113 m
.25093 .27255 L
s
.21746 .28113 m
.19859 .29238 L
s
.795 .213 .085 r
.46051 .4929 m .47257 .49683 L .47625 .51354 L p F P
0 0 0 r
s
.795 .213 .085 r
.48714 .517 m .47625 .51354 L .47257 .49683 L p F P
0 0 0 r
s
.24 .35 .67 r
.44575 .52266 m
.48135 .5167 L
s
.48135 .5167 m
.4819 .51533 L
s
.83 .24 .1 r
.76104 .53509 m
.78343 .54322 L
s
.80182 .51664 m
.78343 .54322 L
s
.191 .266 .537 r
.56973 .46642 m .55194 .46958 L .5531 .4478 L p F P
0 0 0 r
s
.191 .266 .537 r
.5531 .4478 m .57148 .44442 L .56973 .46642 L p F P
0 0 0 r
s
.24 .35 .67 r
.53301 .45804 m
.56972 .45137 L
s
.176 .242 .491 r
.54995 .48945 m .53334 .49231 L .53434 .4727 L p F P
0 0 0 r
s
.176 .242 .491 r
.53434 .4727 m .55194 .46958 L .54995 .48945 L p F P
0 0 0 r
s
1 .313 .131 r
.48788 .26444 m .49399 .26724 L .48757 .28843 L p F P
0 0 0 r
s
.24 .35 .67 r
.47615 .28335 m
.48767 .28063 L
s
1 .313 .131 r
.48757 .28843 m .4797 .28492 L .48788 .26444 L p F P
0 0 0 r
s
.976 .272 .112 r
.44179 .44716 m .42817 .44242 L .42741 .41897 L p F P
0 0 0 r
s
.934 .258 .105 r
.42817 .44242 m .44179 .44716 L .44418 .46898 L p F P
0 0 0 r
s
.83 .24 .1 r
.44185 .42347 m
.44428 .45429 L
s
.75141 .31914 m
.73173 .30002 L
s
.70854 .28826 m
.73173 .30002 L
s
.82303 .4552 m
.81523 .48681 L
s
.8012 .44575 m
.82303 .4552 L
s
.49004 .51652 m
.49187 .5171 L
s
.203 .285 .574 r
.59006 .44101 m .57148 .44442 L .57196 .42105 L p F P
0 0 0 r
s
.203 .285 .574 r
.57196 .42105 m .5907 .41749 L .59006 .44101 L p F P
0 0 0 r
s
1 .298 .123 r
.425 .34057 m .43732 .34553 L .43203 .37002 L p F P
0 0 0 r
s
1 .298 .123 r
.43203 .37002 m .41885 .36491 L .425 .34057 L p F P
0 0 0 r
s
.83 .24 .1 r
.42597 .34983 m
.45309 .36061 L
s
1 .291 .12 r
.41885 .36491 m .43203 .37002 L .42871 .39467 L p F P
0 0 0 r
s
.24 .35 .67 r
.41578 .55647 m
.43229 .54228 L
s
.43229 .54228 m
.46811 .53647 L
s
.83 .24 .1 r
.79894 .38253 m
.78898 .35441 L
s
.76663 .34345 m
.78898 .35441 L
s
.24 .35 .67 r
.48135 .5167 m
.48452 .51617 L
s
.238 .344 .686 r
.56143 .32361 m .57654 .3203 L .58247 .34407 L p F P
0 0 0 r
s
.245 .357 .711 r
.57654 .3203 m .56143 .32361 L .55596 .30069 L p F P
0 0 0 r
s
.245 .357 .711 r
.54283 .30366 m .55596 .30069 L .56143 .32361 L p F P
0 0 0 r
s
.83 .24 .1 r
.77965 .50809 m
.80182 .51664 L
s
.81523 .48681 m
.80182 .51664 L
s
.24 .35 .67 r
.36131 .57003 m
.38049 .56208 L
s
.38049 .56208 m
.41578 .55647 L
s
1 .291 .12 r
.42871 .39467 m .41498 .38954 L .41885 .36491 L p F P
0 0 0 r
s
1 .283 .116 r
.41498 .38954 m .42871 .39467 L .42741 .41897 L p F P
0 0 0 r
s
1 .304 .126 r
.43329 .31702 m .44446 .32167 L .43732 .34553 L p F P
0 0 0 r
s
1 .304 .126 r
.43732 .34553 m .425 .34057 L .43329 .31702 L p F P
0 0 0 r
s
.261 .384 .762 r
.52766 .2844 m .51683 .28692 L .5168 .26603 L p F P
0 0 0 r
s
.83 .24 .1 r
.51934 .27033 m
.52948 .26269 L
s
.261 .384 .762 r
.50841 .26803 m .5168 .26603 L .51683 .28692 L p F P
0 0 0 r
s
.253 .37 .736 r
.55596 .30069 m .54283 .30366 L .53855 .28187 L p F P
0 0 0 r
s
.253 .37 .736 r
.52766 .2844 m .53855 .28187 L .54283 .30366 L p F P
0 0 0 r
s
.24 .35 .67 r
.50504 .30521 m
.54137 .29694 L
s
.54137 .29694 m
.55399 .32564 L
s
.83 .24 .1 r
.79326 .47782 m
.81523 .48681 L
s
.157 .212 .431 r
.53194 .50951 m .51688 .51203 L .5169 .49514 L p F P
0 0 0 r
s
.157 .212 .431 r
.5169 .49514 m .53334 .49231 L .53194 .50951 L p F P
0 0 0 r
s
.24 .35 .67 r
.4911 .49238 m
.52723 .48609 L
s
.30552 .57679 m
.32656 .5755 L
s
.32656 .5755 m
.36131 .57003 L
s
1 .311 .13 r
.46374 .27782 m .47175 .28139 L .46295 .3031 L p F P
0 0 0 r
s
1 .311 .13 r
.46295 .3031 m .45332 .29894 L .46374 .27782 L p F P
0 0 0 r
s
.131 .17 .349 r
.50366 .52821 m .49057 .53035 L .48714 .517 L p F P
0 0 0 r
s
.83 .24 .1 r
.50159 .52855 m
.5096 .538 L
s
.131 .17 .349 r
.48714 .517 m .50195 .51453 L .50366 .52821 L p F P
0 0 0 r
s
.672 .175 .069 r
.47625 .51354 m .48714 .517 L .49057 .53035 L p F P
0 0 0 r
s
.83 .24 .1 r
.5314 .5536 m
.55724 .56148 L
s
.55724 .56148 m
.58213 .5709 L
s
.222 .317 .635 r
.60827 .38947 m .58962 .39316 L .58685 .36852 L p F P
0 0 0 r
s
.222 .317 .635 r
.58685 .36852 m .60478 .36485 L .60827 .38947 L p F P
0 0 0 r
s
.23 .331 .661 r
.60478 .36485 m .58685 .36852 L .58247 .34407 L p F P
0 0 0 r
s
.24 .35 .67 r
.24938 .57667 m
.27133 .5822 L
s
.27133 .5822 m
.30552 .57679 L
s
.23 .331 .661 r
.58247 .34407 m .59925 .34051 L .60478 .36485 L p F P
0 0 0 r
s
.238 .344 .686 r
.59925 .34051 m .58247 .34407 L .57654 .3203 L p F P
0 0 0 r
s
.213 .302 .606 r
.60964 .41388 m .5907 .41749 L .58962 .39316 L p F P
0 0 0 r
s
.213 .302 .606 r
.58962 .39316 m .60827 .38947 L .60964 .41388 L p F P
0 0 0 r
s
1 .283 .116 r
.42741 .41897 m .41346 .41394 L .41498 .38954 L p F P
0 0 0 r
s
.976 .272 .112 r
.41346 .41394 m .42741 .41897 L .42817 .44242 L p F P
0 0 0 r
s
1 .308 .128 r
.44358 .29475 m .45332 .29894 L .44446 .32167 L p F P
0 0 0 r
s
1 .308 .128 r
.44446 .32167 m .43329 .31702 L .44358 .29475 L p F P
0 0 0 r
s
.83 .24 .1 r
.43932 .31977 m
.46625 .33098 L
s
1 .313 .131 r
.48172 .26162 m .48788 .26444 L .4797 .28492 L p F P
0 0 0 r
s
1 .313 .131 r
.4797 .28492 m .47175 .28139 L .48172 .26162 L p F P
0 0 0 r
s
.24 .35 .67 r
.47184 .2595 m
.47874 .26754 L
s
.43609 .2682 m
.47184 .2595 L
s
.83 .24 .1 r
.63541 .25595 m
.60833 .25581 L
s
.58321 .24335 m
.60833 .25581 L
s
.191 .266 .537 r
.5877 .46323 m .56973 .46642 L .57148 .44442 L p F P
0 0 0 r
s
.24 .35 .67 r
.56972 .45137 m
.57144 .42064 L
s
.191 .266 .537 r
.57148 .44442 m .59006 .44101 L .5877 .46323 L p F P
0 0 0 r
s
.83 .24 .1 r
.68923 .56664 m
.7128 .57435 L
s
.7128 .57435 m
.73838 .55752 L
s
.176 .242 .491 r
.56671 .48657 m .54995 .48945 L .55194 .46958 L p F P
0 0 0 r
s
.176 .242 .491 r
.55194 .46958 m .56973 .46642 L .56671 .48657 L p F P
0 0 0 r
s
.24 .35 .67 r
.52723 .48609 m
.56414 .47966 L
s
.261 .384 .762 r
.53855 .28187 m .52766 .2844 L .52523 .26402 L p F P
0 0 0 r
s
.261 .384 .762 r
.5168 .26603 m .52523 .26402 L .52766 .2844 L p F P
0 0 0 r
s
.83 .24 .1 r
.60919 .57372 m
.63394 .58133 L
s
.63394 .58133 m
.66176 .57737 L
s
.245 .357 .711 r
.55596 .30069 m .56919 .29771 L .57654 .3203 L p F P
0 0 0 r
s
.253 .37 .736 r
.56919 .29771 m .55596 .30069 L .54951 .27932 L p F P
0 0 0 r
s
.253 .37 .736 r
.53855 .28187 m .54951 .27932 L .55596 .30069 L p F P
0 0 0 r
s
.934 .258 .105 r
.44418 .46898 m .43102 .46455 L .42817 .44242 L p F P
0 0 0 r
s
.877 .239 .097 r
.43102 .46455 m .44418 .46898 L .44829 .48891 L p F P
0 0 0 r
s
.877 .239 .097 r
.46051 .4929 m .44829 .48891 L .44418 .46898 L p F P
0 0 0 r
s
.83 .24 .1 r
.44428 .45429 m
.4521 .48305 L
s
.238 .344 .686 r
.57654 .3203 m .59178 .31697 L .59925 .34051 L p F P
0 0 0 r
s
.245 .357 .711 r
.59178 .31697 m .57654 .3203 L .56919 .29771 L p F P
0 0 0 r
s
.24 .35 .67 r
.55399 .32564 m
.59107 .31753 L
s
1 .313 .132 r
.50107 .24818 m .50524 .25014 L .50006 .27002 L p F P
0 0 0 r
s
1 .313 .132 r
.50006 .27002 m .49399 .26724 L .50107 .24818 L p F P
0 0 0 r
s
.269 .398 .789 r
.50841 .26803 m .50006 .27002 L .50524 .25014 L p F P
0 0 0 r
s
.795 .213 .085 r
.44829 .48891 m .46051 .4929 L .46523 .51003 L p F P
0 0 0 r
s
.83 .24 .1 r
.4521 .48305 m
.47886 .49189 L
s
.795 .213 .085 r
.47625 .51354 m .46523 .51003 L .46051 .4929 L p F P
0 0 0 r
s
.203 .285 .574 r
.60883 .43756 m .59006 .44101 L .5907 .41749 L p F P
0 0 0 r
s
.203 .285 .574 r
.5907 .41749 m .60964 .41388 L .60883 .43756 L p F P
0 0 0 r
s
.83 .24 .1 r
.70854 .28826 m
.68527 .27498 L
s
.66124 .26277 m
.68527 .27498 L
s
.131 .17 .349 r
.51686 .52606 m .50366 .52821 L .50195 .51453 L p F P
0 0 0 r
s
.131 .17 .349 r
.50195 .51453 m .51688 .51203 L .51686 .52606 L p F P
0 0 0 r
s
.157 .212 .431 r
.54714 .50697 m .53194 .50951 L .53334 .49231 L p F P
0 0 0 r
s
.157 .212 .431 r
.53334 .49231 m .54995 .48945 L .54714 .50697 L p F P
0 0 0 r
s
.83 .24 .1 r
.8031 .41346 m
.79894 .38253 L
s
.7766 .37193 m
.79894 .38253 L
s
.42597 .34983 m
.43932 .31977 L
s
.24 .35 .67 r
.41657 .25305 m
.39611 .24391 L
s
.976 .272 .112 r
.42817 .44242 m .41436 .43762 L .41346 .41394 L p F P
0 0 0 r
s
.934 .258 .105 r
.41436 .43762 m .42817 .44242 L .43102 .46455 L p F P
0 0 0 r
s
.24 .35 .67 r
.3608 .25286 m
.39611 .24391 L
s
.3608 .25286 m
.34004 .25043 L
s
1 .311 .13 r
.45565 .27423 m .46374 .27782 L .45332 .29894 L p F P
0 0 0 r
s
.83 .24 .1 r
.45709 .29246 m
.48383 .3041 L
s
1 .311 .13 r
.45332 .29894 m .44358 .29475 L .45565 .27423 L p F P
0 0 0 r
s
.83 .24 .1 r
.43932 .31977 m
.45709 .29246 L
s
.261 .384 .762 r
.54951 .27932 m .53855 .28187 L .5337 .262 L p F P
0 0 0 r
s
.261 .384 .762 r
.52523 .26402 m .5337 .262 L .53855 .28187 L p F P
0 0 0 r
s
.24 .35 .67 r
.52598 .27158 m
.54137 .29694 L
s
.49683 .27847 m
.52598 .27158 L
s
1 .298 .123 r
.41251 .33556 m .425 .34057 L .41885 .36491 L p F P
0 0 0 r
s
1 .298 .123 r
.41885 .36491 m .40548 .35973 L .41251 .33556 L p F P
0 0 0 r
s
1 .291 .12 r
.40548 .35973 m .41885 .36491 L .41498 .38954 L p F P
0 0 0 r
s
.83 .24 .1 r
.41757 .38151 m
.42597 .34983 L
s
.41757 .38151 m
.44485 .39184 L
s
.222 .317 .635 r
.62713 .38575 m .60827 .38947 L .60478 .36485 L p F P
0 0 0 r
s
.222 .317 .635 r
.60478 .36485 m .6229 .36115 L .62713 .38575 L p F P
0 0 0 r
s
.24 .35 .67 r
.5693 .38865 m
.60649 .38122 L
s
.23 .331 .661 r
.6229 .36115 m .60478 .36485 L .59925 .34051 L p F P
0 0 0 r
s
.269 .398 .789 r
.5168 .26603 m .50841 .26803 L .51099 .24874 L p F P
0 0 0 r
s
.269 .398 .789 r
.50524 .25014 m .51099 .24874 L .50841 .26803 L p F P
0 0 0 r
s
.83 .24 .1 r
.50317 .25033 m
.5078 .2525 L
s
1 .304 .126 r
.42199 .31232 m .43329 .31702 L .425 .34057 L p F P
0 0 0 r
s
1 .304 .126 r
.425 .34057 m .41251 .33556 L .42199 .31232 L p F P
0 0 0 r
s
.24 .35 .67 r
.50196 .25217 m
.50835 .25062 L
s
.23 .331 .661 r
.59925 .34051 m .61619 .33693 L .6229 .36115 L p F P
0 0 0 r
s
.24 .35 .67 r
.56341 .35659 m
.60052 .34883 L
s
.238 .344 .686 r
.61619 .33693 m .59925 .34051 L .59178 .31697 L p F P
0 0 0 r
s
1 .313 .131 r
.47553 .25878 m .48172 .26162 L .47175 .28139 L p F P
0 0 0 r
s
.83 .24 .1 r
.47865 .26899 m
.4999 .27863 L
s
1 .313 .131 r
.47175 .28139 m .46374 .27782 L .47553 .25878 L p F P
0 0 0 r
s
.83 .24 .1 r
.76663 .34345 m
.75141 .31914 L
s
.72832 .30757 m
.75141 .31914 L
s
.24 .35 .67 r
.30531 .25932 m
.34004 .25043 L
s
.30531 .25932 m
.28512 .2638 L
s
.672 .175 .069 r
.46523 .51003 m .47625 .51354 L .48097 .52736 L p F P
0 0 0 r
s
.24 .35 .67 r
.47869 .52067 m
.48029 .51828 L
s
.672 .175 .069 r
.49057 .53035 m .48097 .52736 L .47625 .51354 L p F P
0 0 0 r
s
.24 .35 .67 r
.46811 .53647 m
.47708 .52308 L
s
.60052 .34883 m
.60649 .38122 L
s
.83 .24 .1 r
.5096 .538 m
.5314 .5536 L
s
1 .291 .12 r
.41498 .38954 m .40104 .38433 L .40548 .35973 L p F P
0 0 0 r
s
1 .283 .116 r
.40104 .38433 m .41498 .38954 L .41346 .41394 L p F P
0 0 0 r
s
.83 .24 .1 r
.41444 .41359 m
.41757 .38151 L
s
.41444 .41359 m
.44185 .42347 L
s
.213 .302 .606 r
.62878 .41024 m .60964 .41388 L .60827 .38947 L p F P
0 0 0 r
s
.24 .35 .67 r
.57144 .42064 m
.60875 .41353 L
s
.213 .302 .606 r
.60827 .38947 m .62713 .38575 L .62878 .41024 L p F P
0 0 0 r
s
.24 .35 .67 r
.60649 .38122 m
.60875 .41353 L
s
1 .313 .132 r
.49689 .24621 m .50107 .24818 L .49399 .26724 L p F P
0 0 0 r
s
1 .313 .132 r
.49399 .26724 m .48788 .26444 L .49689 .24621 L p F P
0 0 0 r
s
.245 .357 .711 r
.56919 .29771 m .58252 .2947 L .59178 .31697 L p F P
0 0 0 r
s
.253 .37 .736 r
.58252 .2947 m .56919 .29771 L .56055 .27676 L p F P
0 0 0 r
s
.253 .37 .736 r
.54951 .27932 m .56055 .27676 L .56919 .29771 L p F P
0 0 0 r
s
.24 .35 .67 r
.25093 .27255 m
.28512 .2638 L
s
.25093 .27255 m
.23224 .28383 L
s
.176 .242 .491 r
.58364 .48366 m .56671 .48657 L .56973 .46642 L p F P
0 0 0 r
s
.24 .35 .67 r
.56414 .47966 m
.56972 .45137 L
s
.176 .242 .491 r
.56973 .46642 m .5877 .46323 L .58364 .48366 L p F P
0 0 0 r
s
.191 .266 .537 r
.60585 .46 m .5877 .46323 L .59006 .44101 L p F P
0 0 0 r
s
.191 .266 .537 r
.59006 .44101 m .60883 .43756 L .60585 .46 L p F P
0 0 0 r
s
1 .308 .128 r
.43373 .29051 m .44358 .29475 L .43329 .31702 L p F P
0 0 0 r
s
1 .308 .128 r
.43329 .31702 m .42199 .31232 L .43373 .29051 L p F P
0 0 0 r
s
.24 .35 .67 r
.19859 .29238 m
.23224 .28383 L
s
.19859 .29238 m
.18232 .31001 L
s
.238 .344 .686 r
.59178 .31697 m .60715 .3136 L .61619 .33693 L p F P
0 0 0 r
s
.24 .35 .67 r
.59107 .31753 m
.60052 .34883 L
s
.245 .357 .711 r
.60715 .3136 m .59178 .31697 L .58252 .2947 L p F P
0 0 0 r
s
.83 .24 .1 r
.71507 .54952 m
.73838 .55752 L
s
.73838 .55752 m
.76104 .53509 L
s
.269 .398 .789 r
.52523 .26402 m .5168 .26603 L .51677 .24733 L p F P
0 0 0 r
s
.83 .24 .1 r
.52302 .25966 m
.52948 .26269 L
s
.269 .398 .789 r
.51099 .24874 m .51677 .24733 L .5168 .26603 L p F P
0 0 0 r
s
.261 .384 .762 r
.56055 .27676 m .54951 .27932 L .54222 .25997 L p F P
0 0 0 r
s
.83 .24 .1 r
.55583 .24993 m
.58116 .2622 L
s
.261 .384 .762 r
.5337 .262 m .54222 .25997 L .54951 .27932 L p F P
0 0 0 r
s
.83 .24 .1 r
.52948 .26269 m
.55583 .24993 L
s
.131 .17 .349 r
.53016 .52389 m .51686 .52606 L .51688 .51203 L p F P
0 0 0 r
s
.131 .17 .349 r
.51688 .51203 m .53194 .50951 L .53016 .52389 L p F P
0 0 0 r
s
.24 .35 .67 r
.48593 .51593 m
.51771 .51061 L
s
.51771 .51061 m
.52723 .48609 L
s
.83 .24 .1 r
.58321 .24335 m
.55583 .24993 L
s
.55644 .56309 m
.58213 .5709 L
s
.58213 .5709 m
.60919 .57372 L
s
1 .283 .116 r
.41346 .41394 m .39931 .40884 L .40104 .38433 L p F P
0 0 0 r
s
.976 .272 .112 r
.39931 .40884 m .41346 .41394 L .41436 .43762 L p F P
0 0 0 r
s
.203 .285 .574 r
.6278 .43407 m .60883 .43756 L .60964 .41388 L p F P
0 0 0 r
s
.203 .285 .574 r
.60964 .41388 m .62878 .41024 L .6278 .43407 L p F P
0 0 0 r
s
.24 .35 .67 r
.45183 .55074 m
.46811 .53647 L
s
.157 .212 .431 r
.56247 .50441 m .54714 .50697 L .54995 .48945 L p F P
0 0 0 r
s
.157 .212 .431 r
.54995 .48945 m .56671 .48657 L .56247 .50441 L p F P
0 0 0 r
s
.83 .24 .1 r
.8031 .41346 m
.78072 .40328 L
s
.8012 .44575 m
.8031 .41346 L
s
.24 .35 .67 r
.39681 .56444 m
.41578 .55647 L
s
.41578 .55647 m
.45183 .55074 L
s
1 .313 .132 r
.49268 .24424 m .49689 .24621 L .48788 .26444 L p F P
0 0 0 r
s
1 .313 .132 r
.48788 .26444 m .48172 .26162 L .49268 .24424 L p F P
0 0 0 r
s
.24 .35 .67 r
.47184 .2595 m
.48509 .25628 L
s
.877 .239 .097 r
.44829 .48891 m .43591 .48487 L .43102 .46455 L p F P
0 0 0 r
s
.795 .213 .085 r
.43591 .48487 m .44829 .48891 L .45408 .50649 L p F P
0 0 0 r
s
.795 .213 .085 r
.46523 .51003 m .45408 .50649 L .44829 .48891 L p F P
0 0 0 r
s
.83 .24 .1 r
.66124 .26277 m
.63541 .25595 L
s
.63722 .56965 m
.66176 .57737 L
s
.66176 .57737 m
.68923 .56664 L
s
.934 .258 .105 r
.43102 .46455 m .41767 .46006 L .41436 .43762 L p F P
0 0 0 r
s
.877 .239 .097 r
.41767 .46006 m .43102 .46455 L .43591 .48487 L p F P
0 0 0 r
s
1 .313 .131 r
.46929 .25592 m .47553 .25878 L .46374 .27782 L p F P
0 0 0 r
s
1 .313 .131 r
.46374 .27782 m .45565 .27423 L .46929 .25592 L p F P
0 0 0 r
s
.83 .24 .1 r
.45709 .29246 m
.47865 .26899 L
s
1 .311 .13 r
.4475 .2706 m .45565 .27423 L .44358 .29475 L p F P
0 0 0 r
s
1 .311 .13 r
.44358 .29475 m .43373 .29051 L .4475 .2706 L p F P
0 0 0 r
s
.24 .35 .67 r
.34045 .57127 m
.36131 .57003 L
s
.36131 .57003 m
.39681 .56444 L
s
.269 .398 .789 r
.5337 .262 m .52523 .26402 L .52256 .24592 L p F P
0 0 0 r
s
.269 .398 .789 r
.51677 .24733 m .52256 .24592 L .52523 .26402 L p F P
0 0 0 r
s
.245 .357 .711 r
.58252 .2947 m .59596 .29166 L .60715 .3136 L p F P
0 0 0 r
s
.253 .37 .736 r
.59596 .29166 m .58252 .2947 L .57165 .27418 L p F P
0 0 0 r
s
.253 .37 .736 r
.56055 .27676 m .57165 .27418 L .58252 .2947 L p F P
0 0 0 r
s
.24 .35 .67 r
.54137 .29694 m
.57847 .28849 L
s
.57847 .28849 m
.59107 .31753 L
s
.222 .317 .635 r
.64618 .38199 m .62713 .38575 L .6229 .36115 L p F P
0 0 0 r
s
.222 .317 .635 r
.6229 .36115 m .6412 .3574 L .64618 .38199 L p F P
0 0 0 r
s
.23 .331 .661 r
.6412 .3574 m .6229 .36115 L .61619 .33693 L p F P
0 0 0 r
s
.23 .331 .661 r
.61619 .33693 m .6333 .33331 L .6412 .3574 L p F P
0 0 0 r
s
.238 .344 .686 r
.6333 .33331 m .61619 .33693 L .60715 .3136 L p F P
0 0 0 r
s
.24 .35 .67 r
.28371 .57115 m
.30552 .57679 L
s
.30552 .57679 m
.34045 .57127 L
s
.094 .113 .235 r
.50573 .53861 m .4947 .54038 L .49057 .53035 L p F P
0 0 0 r
s
.094 .113 .235 r
.49057 .53035 m .50366 .52821 L .50573 .53861 L p F P
0 0 0 r
s
.83 .24 .1 r
.50534 .53668 m
.5096 .538 L
s
.51 .125 .049 r
.48097 .52736 m .49057 .53035 L .4947 .54038 L p F P
0 0 0 r
s
.24 .35 .67 r
.46811 .53647 m
.48729 .53335 L
s
.83 .24 .1 r
.73798 .52672 m
.76104 .53509 L
s
.76104 .53509 m
.77965 .50809 L
s
.24 .35 .67 r
.22768 .56433 m
.24938 .57667 L
s
.24938 .57667 m
.28371 .57115 L
s
.261 .384 .762 r
.57165 .27418 m .56055 .27676 L .55078 .25793 L p F P
0 0 0 r
s
.261 .384 .762 r
.54222 .25997 m .55078 .25793 L .56055 .27676 L p F P
0 0 0 r
s
.213 .302 .606 r
.64813 .40655 m .62878 .41024 L .62713 .38575 L p F P
0 0 0 r
s
.213 .302 .606 r
.62713 .38575 m .64618 .38199 L .64813 .40655 L p F P
0 0 0 r
s
.238 .344 .686 r
.60715 .3136 m .62266 .31021 L .6333 .33331 L p F P
0 0 0 r
s
.245 .357 .711 r
.62266 .31021 m .60715 .3136 L .59596 .29166 L p F P
0 0 0 r
s
.672 .175 .069 r
.45408 .50649 m .46523 .51003 L .47126 .52434 L p F P
0 0 0 r
s
.83 .24 .1 r
.4521 .48305 m
.46511 .50857 L
s
.672 .175 .069 r
.48097 .52736 m .47126 .52434 L .46523 .51003 L p F P
0 0 0 r
s
.83 .24 .1 r
.46511 .50857 m
.48851 .51603 L
s
.176 .242 .491 r
.60073 .48072 m .58364 .48366 L .5877 .46323 L p F P
0 0 0 r
s
.176 .242 .491 r
.5877 .46323 m .60585 .46 L .60073 .48072 L p F P
0 0 0 r
s
1 .304 .126 r
.41056 .30755 m .42199 .31232 L .41251 .33556 L p F P
0 0 0 r
s
1 .304 .126 r
.41251 .33556 m .39986 .33047 L .41056 .30755 L p F P
0 0 0 r
s
1 .298 .123 r
.39986 .33047 m .41251 .33556 L .40548 .35973 L p F P
0 0 0 r
s
.976 .272 .112 r
.41436 .43762 m .40033 .43274 L .39931 .40884 L p F P
0 0 0 r
s
.934 .258 .105 r
.40033 .43274 m .41436 .43762 L .41767 .46006 L p F P
0 0 0 r
s
.83 .24 .1 r
.41677 .44481 m
.44428 .45429 L
s
.41444 .41359 m
.41677 .44481 L
s
1 .298 .123 r
.40548 .35973 m .39191 .35447 L .39986 .33047 L p F P
0 0 0 r
s
1 .291 .12 r
.39191 .35447 m .40548 .35973 L .40104 .38433 L p F P
0 0 0 r
s
.191 .266 .537 r
.62419 .45675 m .60585 .46 L .60883 .43756 L p F P
0 0 0 r
s
.24 .35 .67 r
.60721 .44455 m
.60875 .41353 L
s
.56972 .45137 m
.60721 .44455 L
s
.191 .266 .537 r
.60883 .43756 m .6278 .43407 L .62419 .45675 L p F P
0 0 0 r
s
.83 .24 .1 r
.72832 .30757 m
.70854 .28826 L
s
.68466 .27615 m
.70854 .28826 L
s
.79326 .47782 m
.8012 .44575 L
s
.77871 .43601 m
.8012 .44575 L
s
.269 .398 .789 r
.54222 .25997 m .5337 .262 L .52838 .2445 L p F P
0 0 0 r
s
.269 .398 .789 r
.52256 .24592 m .52838 .2445 L .5337 .262 L p F P
0 0 0 r
s
.24 .35 .67 r
.50835 .25062 m
.52598 .27158 L
s
.131 .17 .349 r
.54356 .52171 m .53016 .52389 L .53194 .50951 L p F P
0 0 0 r
s
.131 .17 .349 r
.53194 .50951 m .54714 .50697 L .54356 .52171 L p F P
0 0 0 r
s
.83 .24 .1 r
.7766 .37193 m
.76663 .34345 L
s
.74361 .33216 m
.76663 .34345 L
s
1 .313 .132 r
.48846 .24225 m .49268 .24424 L .48172 .26162 L p F P
0 0 0 r
s
1 .313 .132 r
.48172 .26162 m .47553 .25878 L .48846 .24225 L p F P
0 0 0 r
s
.83 .24 .1 r
.47865 .26899 m
.50317 .25033 L
s
1 .308 .128 r
.42379 .28622 m .43373 .29051 L .42199 .31232 L p F P
0 0 0 r
s
1 .308 .128 r
.42199 .31232 m .41056 .30755 L .42379 .28622 L p F P
0 0 0 r
s
.83 .24 .1 r
.41157 .30822 m
.43932 .31977 L
s
.75681 .49929 m
.77965 .50809 L
s
.77965 .50809 m
.79326 .47782 L
s
1 .291 .12 r
.40104 .38433 m .3869 .37905 L .39191 .35447 L p F P
0 0 0 r
s
1 .283 .116 r
.3869 .37905 m .40104 .38433 L .39931 .40884 L p F P
0 0 0 r
s
.157 .212 .431 r
.57793 .50183 m .56247 .50441 L .56671 .48657 L p F P
0 0 0 r
s
.24 .35 .67 r
.55484 .50439 m
.56414 .47966 L
s
.157 .212 .431 r
.56671 .48657 m .58364 .48366 L .57793 .50183 L p F P
0 0 0 r
s
.83 .24 .1 r
.77062 .46855 m
.79326 .47782 L
s
.203 .285 .574 r
.64698 .43055 m .6278 .43407 L .62878 .41024 L p F P
0 0 0 r
s
.203 .285 .574 r
.62878 .41024 m .64813 .40655 L .64698 .43055 L p F P
0 0 0 r
s
.245 .357 .711 r
.59596 .29166 m .60949 .28861 L .62266 .31021 L p F P
0 0 0 r
s
.253 .37 .736 r
.60949 .28861 m .59596 .29166 L .58282 .27159 L p F P
0 0 0 r
s
.253 .37 .736 r
.57165 .27418 m .58282 .27159 L .59596 .29166 L p F P
0 0 0 r
s
1 .313 .131 r
.46301 .25304 m .46929 .25592 L .45565 .27423 L p F P
0 0 0 r
s
1 .313 .131 r
.45565 .27423 m .4475 .2706 L .46301 .25304 L p F P
0 0 0 r
s
.24 .35 .67 r
.45246 .24411 m
.46465 .25379 L
s
.41657 .25305 m
.45246 .24411 L
s
.261 .384 .762 r
.58282 .27159 m .57165 .27418 L .55937 .25588 L p F P
0 0 0 r
s
.261 .384 .762 r
.55078 .25793 m .55937 .25588 L .57165 .27418 L p F P
0 0 0 r
s
.83 .24 .1 r
.5314 .5536 m
.55644 .56309 L
s
1 .31 .131 r
.50869 .23175 m .51082 .23277 L .50524 .25014 L p F P
0 0 0 r
s
1 .31 .131 r
.50524 .25014 m .50107 .24818 L .50869 .23175 L p F P
0 0 0 r
s
.277 .413 .817 r
.51099 .24874 m .50524 .25014 L .51082 .23277 L p F P
0 0 0 r
s
.094 .113 .235 r
.51683 .53684 m .50573 .53861 L .50366 .52821 L p F P
0 0 0 r
s
.094 .113 .235 r
.50366 .52821 m .51686 .52606 L .51683 .53684 L p F P
0 0 0 r
s
.23 .331 .661 r
.65969 .35362 m .6412 .3574 L .6333 .33331 L p F P
0 0 0 r
s
.23 .331 .661 r
.6333 .33331 m .65058 .32965 L .65969 .35362 L p F P
0 0 0 r
s
.24 .35 .67 r
.60052 .34883 m
.63842 .3409 L
s
.238 .344 .686 r
.65058 .32965 m .6333 .33331 L .62266 .31021 L p F P
0 0 0 r
s
.269 .398 .789 r
.55078 .25793 m .54222 .25997 L .53421 .24308 L p F P
0 0 0 r
s
.269 .398 .789 r
.52838 .2445 m .53421 .24308 L .54222 .25997 L p F P
0 0 0 r
s
.24 .35 .67 r
.45246 .24411 m
.43217 .23476 L
s
.222 .317 .635 r
.66544 .37819 m .64618 .38199 L .6412 .3574 L p F P
0 0 0 r
s
.222 .317 .635 r
.6412 .3574 m .65969 .35362 L .66544 .37819 L p F P
0 0 0 r
s
.24 .35 .67 r
.60649 .38122 m
.64447 .37363 L
s
1 .311 .13 r
.43927 .26694 m .4475 .2706 L .43373 .29051 L p F P
0 0 0 r
s
1 .311 .13 r
.43373 .29051 m .42379 .28622 L .43927 .26694 L p F P
0 0 0 r
s
.24 .35 .67 r
.39611 .24391 m
.43217 .23476 L
s
.39611 .24391 m
.37553 .24135 L
s
.238 .344 .686 r
.62266 .31021 m .6383 .30679 L .65058 .32965 L p F P
0 0 0 r
s
.245 .357 .711 r
.6383 .30679 m .62266 .31021 L .60949 .28861 L p F P
0 0 0 r
s
.24 .35 .67 r
.59107 .31753 m
.62894 .30925 L
s
1 .283 .116 r
.39931 .40884 m .38494 .40366 L .3869 .37905 L p F P
0 0 0 r
s
.976 .272 .112 r
.38494 .40366 m .39931 .40884 L .40033 .43274 L p F P
0 0 0 r
s
.83 .24 .1 r
.61048 .24338 m
.58321 .24335 L
s
.24 .35 .67 r
.34004 .25043 m
.37553 .24135 L
s
.34004 .25043 m
.32005 .25485 L
s
.877 .239 .097 r
.43591 .48487 m .42336 .48077 L .41767 .46006 L p F P
0 0 0 r
s
.795 .213 .085 r
.42336 .48077 m .43591 .48487 L .44278 .5029 L p F P
0 0 0 r
s
.83 .24 .1 r
.42454 .47395 m
.4521 .48305 L
s
.795 .213 .085 r
.45408 .50649 m .44278 .5029 L .43591 .48487 L p F P
0 0 0 r
s
.24 .35 .67 r
.63842 .3409 m
.64447 .37363 L
s
.62894 .30925 m
.63842 .3409 L
s
.277 .413 .817 r
.51677 .24733 m .51099 .24874 L .51377 .23204 L p F P
0 0 0 r
s
.277 .413 .817 r
.51082 .23277 m .51377 .23204 L .51099 .24874 L p F P
0 0 0 r
s
.51 .125 .049 r
.47126 .52434 m .48097 .52736 L .48664 .53791 L p F P
0 0 0 r
s
.51 .125 .049 r
.4947 .54038 m .48664 .53791 L .48097 .52736 L p F P
0 0 0 r
s
.83 .24 .1 r
.48288 .52971 m
.49316 .5329 L
s
.24 .35 .67 r
.49066 .53281 m
.50471 .53053 L
s
1 .313 .132 r
.48422 .24025 m .48846 .24225 L .47553 .25878 L p F P
0 0 0 r
s
1 .313 .132 r
.47553 .25878 m .46929 .25592 L .48422 .24025 L p F P
0 0 0 r
s
.83 .24 .1 r
.66495 .5587 m
.68923 .56664 L
s
.68923 .56664 m
.71507 .54952 L
s
.213 .302 .606 r
.66769 .40283 m .64813 .40655 L .64618 .38199 L p F P
0 0 0 r
s
.24 .35 .67 r
.60875 .41353 m
.64687 .40626 L
s
.213 .302 .606 r
.64618 .38199 m .66544 .37819 L .66769 .40283 L p F P
0 0 0 r
s
.24 .35 .67 r
.64447 .37363 m
.64687 .40626 L
s
.83 .24 .1 r
.58368 .56589 m
.60919 .57372 L
s
.60919 .57372 m
.63722 .56965 L
s
.131 .17 .349 r
.55706 .5195 m .54356 .52171 L .54714 .50697 L p F P
0 0 0 r
s
.131 .17 .349 r
.54714 .50697 m .56247 .50441 L .55706 .5195 L p F P
0 0 0 r
s
.24 .35 .67 r
.51771 .51061 m
.55484 .50439 L
s
.934 .258 .105 r
.41767 .46006 m .40412 .4555 L .40033 .43274 L p F P
0 0 0 r
s
.877 .239 .097 r
.40412 .4555 m .41767 .46006 L .42336 .48077 L p F P
0 0 0 r
s
.83 .24 .1 r
.41677 .44481 m
.42454 .47395 L
s
1 .31 .131 r
.50656 .23072 m .50869 .23175 L .50107 .24818 L p F P
0 0 0 r
s
1 .31 .131 r
.50107 .24818 m .49689 .24621 L .50656 .23072 L p F P
0 0 0 r
s
.83 .24 .1 r
.50317 .25033 m
.51288 .24556 L
s
.176 .242 .491 r
.61798 .47775 m .60073 .48072 L .60585 .46 L p F P
0 0 0 r
s
.24 .35 .67 r
.56414 .47966 m
.60184 .4731 L
s
.176 .242 .491 r
.60585 .46 m .62419 .45675 L .61798 .47775 L p F P
0 0 0 r
s
.24 .35 .67 r
.60184 .4731 m
.60721 .44455 L
s
.28512 .2638 m
.32005 .25485 L
s
.28512 .2638 m
.26661 .2751 L
s
.18232 .31001 m
.21614 .30156 L
s
.18232 .31001 m
.16949 .33336 L
s
.269 .398 .789 r
.55937 .25588 m .55078 .25793 L .54006 .24166 L p F P
0 0 0 r
s
.83 .24 .1 r
.54255 .24349 m
.55583 .24993 L
s
.269 .398 .789 r
.53421 .24308 m .54006 .24166 L .55078 .25793 L p F P
0 0 0 r
s
.191 .266 .537 r
.64272 .45345 m .62419 .45675 L .6278 .43407 L p F P
0 0 0 r
s
.191 .266 .537 r
.6278 .43407 m .64698 .43055 L .64272 .45345 L p F P
0 0 0 r
s
.253 .37 .736 r
.58282 .27159 m .59407 .26898 L .60949 .28861 L p F P
0 0 0 r
s
.261 .384 .762 r
.59407 .26898 m .58282 .27159 L .56802 .25382 L p F P
0 0 0 r
s
.261 .384 .762 r
.55937 .25588 m .56802 .25382 L .58282 .27159 L p F P
0 0 0 r
s
.24 .35 .67 r
.56316 .26281 m
.57847 .28849 L
s
.52598 .27158 m
.56316 .26281 L
s
.23224 .28383 m
.26661 .2751 L
s
.23224 .28383 m
.21614 .30156 L
s
.245 .357 .711 r
.60949 .28861 m .62313 .28553 L .6383 .30679 L p F P
0 0 0 r
s
.253 .37 .736 r
.62313 .28553 m .60949 .28861 L .59407 .26898 L p F P
0 0 0 r
s
.672 .175 .069 r
.44278 .5029 m .45408 .50649 L .46145 .52129 L p F P
0 0 0 r
s
.672 .175 .069 r
.47126 .52434 m .46145 .52129 L .45408 .50649 L p F P
0 0 0 r
s
.83 .24 .1 r
.46511 .50857 m
.48288 .52971 L
s
.277 .413 .817 r
.52256 .24592 m .51677 .24733 L .51673 .2313 L p F P
0 0 0 r
s
.277 .413 .817 r
.51377 .23204 m .51673 .2313 L .51677 .24733 L p F P
0 0 0 r
s
.157 .212 .431 r
.59353 .49922 m .57793 .50183 L .58364 .48366 L p F P
0 0 0 r
s
.157 .212 .431 r
.58364 .48366 m .60073 .48072 L .59353 .49922 L p F P
0 0 0 r
s
.83 .24 .1 r
.68466 .27615 m
.66124 .26277 L
s
.094 .113 .235 r
.52801 .53505 m .51683 .53684 L .51686 .52606 L p F P
0 0 0 r
s
.094 .113 .235 r
.51686 .52606 m .53016 .52389 L .52801 .53505 L p F P
0 0 0 r
s
.24 .35 .67 r
.50471 .53053 m
.51771 .51061 L
s
1 .304 .126 r
.39898 .30273 m .41056 .30755 L .39986 .33047 L p F P
0 0 0 r
s
1 .304 .126 r
.39986 .33047 m .38703 .32531 L .39898 .30273 L p F P
0 0 0 r
s
1 .298 .123 r
.38703 .32531 m .39986 .33047 L .39191 .35447 L p F P
0 0 0 r
s
.83 .24 .1 r
.39804 .33874 m
.42597 .34983 L
s
1 .313 .131 r
.45668 .25014 m .46301 .25304 L .4475 .2706 L p F P
0 0 0 r
s
1 .313 .131 r
.4475 .2706 m .43927 .26694 L .45668 .25014 L p F P
0 0 0 r
s
.83 .24 .1 r
.78072 .40328 m
.7766 .37193 L
s
.75358 .361 m
.7766 .37193 L
s
1 .308 .128 r
.41373 .28189 m .42379 .28622 L .41056 .30755 L p F P
0 0 0 r
s
1 .308 .128 r
.41056 .30755 m .39898 .30273 L .41373 .28189 L p F P
0 0 0 r
s
.83 .24 .1 r
.39804 .33874 m
.41157 .30822 L
s
.203 .285 .574 r
.66636 .42698 m .64698 .43055 L .64813 .40655 L p F P
0 0 0 r
s
.203 .285 .574 r
.64813 .40655 m .66769 .40283 L .66636 .42698 L p F P
0 0 0 r
s
1 .298 .123 r
.39191 .35447 m .37815 .34914 L .38703 .32531 L p F P
0 0 0 r
s
1 .291 .12 r
.37815 .34914 m .39191 .35447 L .3869 .37905 L p F P
0 0 0 r
s
.83 .24 .1 r
.38947 .37088 m
.39804 .33874 L
s
.38947 .37088 m
.41757 .38151 L
s
1 .31 .131 r
.50442 .22969 m .50656 .23072 L .49689 .24621 L p F P
0 0 0 r
s
1 .31 .131 r
.49689 .24621 m .49268 .24424 L .50442 .22969 L p F P
0 0 0 r
s
.24 .35 .67 r
.50134 .24491 m
.50835 .25062 L
s
.976 .272 .112 r
.40033 .43274 m .3861 .42779 L .38494 .40366 L p F P
0 0 0 r
s
.934 .258 .105 r
.3861 .42779 m .40033 .43274 L .40412 .4555 L p F P
0 0 0 r
s
.277 .413 .817 r
.52838 .2445 m .52256 .24592 L .5197 .23057 L p F P
0 0 0 r
s
.277 .413 .817 r
.51673 .2313 m .5197 .23057 L .52256 .24592 L p F P
0 0 0 r
s
.23 .331 .661 r
.67837 .3498 m .65969 .35362 L .65058 .32965 L p F P
0 0 0 r
s
.23 .331 .661 r
.65058 .32965 m .66802 .32596 L .67837 .3498 L p F P
0 0 0 r
s
.238 .344 .686 r
.66802 .32596 m .65058 .32965 L .6383 .30679 L p F P
0 0 0 r
s
.24 .35 .67 r
.43308 .55873 m
.45183 .55074 L
s
1 .313 .132 r
.47995 .23824 m .48422 .24025 L .46929 .25592 L p F P
0 0 0 r
s
1 .313 .132 r
.46929 .25592 m .46301 .25304 L .47995 .23824 L p F P
0 0 0 r
s
.269 .398 .789 r
.56802 .25382 m .55937 .25588 L .54594 .24023 L p F P
0 0 0 r
s
.269 .398 .789 r
.54006 .24166 m .54594 .24023 L .55937 .25588 L p F P
0 0 0 r
s
.238 .344 .686 r
.6383 .30679 m .65408 .30333 L .66802 .32596 L p F P
0 0 0 r
s
.245 .357 .711 r
.65408 .30333 m .6383 .30679 L .62313 .28553 L p F P
0 0 0 r
s
.222 .317 .635 r
.68491 .37435 m .66544 .37819 L .65969 .35362 L p F P
0 0 0 r
s
.222 .317 .635 r
.65969 .35362 m .67837 .3498 L .68491 .37435 L p F P
0 0 0 r
s
.83 .24 .1 r
.74361 .33216 m
.72832 .30757 L
s
1 .311 .13 r
.43096 .26324 m .43927 .26694 L .42379 .28622 L p F P
0 0 0 r
s
1 .311 .13 r
.42379 .28622 m .41373 .28189 L .43096 .26324 L p F P
0 0 0 r
s
.83 .24 .1 r
.42956 .28047 m
.45709 .29246 L
s
.41157 .30822 m
.42956 .28047 L
s
.24 .35 .67 r
.37613 .56563 m
.39681 .56444 L
s
.39681 .56444 m
.43308 .55873 L
s
.253 .37 .736 r
.59407 .26898 m .60539 .26635 L .62313 .28553 L p F P
0 0 0 r
s
.261 .384 .762 r
.60539 .26635 m .59407 .26898 L .5767 .25175 L p F P
0 0 0 r
s
.261 .384 .762 r
.56802 .25382 m .5767 .25175 L .59407 .26898 L p F P
0 0 0 r
s
1 .291 .12 r
.3869 .37905 m .37254 .37368 L .37815 .34914 L p F P
0 0 0 r
s
1 .283 .116 r
.37254 .37368 m .3869 .37905 L .38494 .40366 L p F P
0 0 0 r
s
.83 .24 .1 r
.3862 .4034 m
.38947 .37088 L
s
.3862 .4034 m
.41444 .41359 L
s
.24 .35 .67 r
.20729 .54555 m
.22768 .56433 L
s
.22768 .56433 m
.26211 .55861 L
s
.131 .17 .349 r
.57067 .51728 m .55706 .5195 L .56247 .50441 L p F P
0 0 0 r
s
.131 .17 .349 r
.56247 .50441 m .57793 .50183 L .57067 .51728 L p F P
0 0 0 r
s
.277 .413 .817 r
.53421 .24308 m .52838 .2445 L .52267 .22983 L p F P
0 0 0 r
s
.277 .413 .817 r
.5197 .23057 m .52267 .22983 L .52838 .2445 L p F P
0 0 0 r
s
.245 .357 .711 r
.62313 .28553 m .63688 .28243 L .65408 .30333 L p F P
0 0 0 r
s
.253 .37 .736 r
.63688 .28243 m .62313 .28553 L .60539 .26635 L p F P
0 0 0 r
s
.24 .35 .67 r
.61638 .27985 m
.62894 .30925 L
s
.57847 .28849 m
.61638 .27985 L
s
.31878 .56551 m
.34045 .57127 L
s
.34045 .57127 m
.37613 .56563 L
s
1 .31 .131 r
.50228 .22866 m .50442 .22969 L .49268 .24424 L p F P
0 0 0 r
s
1 .31 .131 r
.49268 .24424 m .48846 .24225 L .50228 .22866 L p F P
0 0 0 r
s
.51 .125 .049 r
.46145 .52129 m .47126 .52434 L .4785 .53542 L p F P
0 0 0 r
s
.51 .125 .049 r
.48664 .53791 m .4785 .53542 L .47126 .52434 L p F P
0 0 0 r
s
.24 .35 .67 r
.26211 .55861 m
.28371 .57115 L
s
.28371 .57115 m
.31878 .56551 L
s
.213 .302 .606 r
.68747 .39906 m .66769 .40283 L .66544 .37819 L p F P
0 0 0 r
s
.213 .302 .606 r
.66544 .37819 m .68491 .37435 L .68747 .39906 L p F P
0 0 0 r
s
.83 .24 .1 r
.69104 .54127 m
.71507 .54952 L
s
.71507 .54952 m
.73798 .52672 L
s
.176 .242 .491 r
.63541 .47475 m .61798 .47775 L .62419 .45675 L p F P
0 0 0 r
s
.176 .242 .491 r
.62419 .45675 m .64272 .45345 L .63541 .47475 L p F P
0 0 0 r
s
.269 .398 .789 r
.5767 .25175 m .56802 .25382 L .55183 .23879 L p F P
0 0 0 r
s
.269 .398 .789 r
.54594 .24023 m .55183 .23879 L .56802 .25382 L p F P
0 0 0 r
s
.094 .113 .235 r
.53926 .53325 m .52801 .53505 L .53016 .52389 L p F P
0 0 0 r
s
.094 .113 .235 r
.53016 .52389 m .54356 .52171 L .53926 .53325 L p F P
0 0 0 r
s
.191 .266 .537 r
.66145 .45013 m .64272 .45345 L .64698 .43055 L p F P
0 0 0 r
s
.24 .35 .67 r
.64551 .43758 m
.64687 .40626 L
s
.60721 .44455 m
.64551 .43758 L
s
.191 .266 .537 r
.64698 .43055 m .66636 .42698 L .66145 .45013 L p F P
0 0 0 r
s
.877 .239 .097 r
.42336 .48077 m .41064 .47662 L .40412 .4555 L p F P
0 0 0 r
s
.795 .213 .085 r
.41064 .47662 m .42336 .48077 L .43135 .49926 L p F P
0 0 0 r
s
.795 .213 .085 r
.44278 .5029 m .43135 .49926 L .42336 .48077 L p F P
0 0 0 r
s
.277 .413 .817 r
.54006 .24166 m .53421 .24308 L .52564 .22909 L p F P
0 0 0 r
s
.277 .413 .817 r
.52267 .22983 m .52564 .22909 L .53421 .24308 L p F P
0 0 0 r
s
.157 .212 .431 r
.60927 .49659 m .59353 .49922 L .60073 .48072 L p F P
0 0 0 r
s
.157 .212 .431 r
.60073 .48072 m .61798 .47775 L .60927 .49659 L p F P
0 0 0 r
s
1 .313 .131 r
.45032 .24722 m .45668 .25014 L .43927 .26694 L p F P
0 0 0 r
s
.83 .24 .1 r
.45132 .25661 m
.47865 .26899 L
s
1 .313 .131 r
.43927 .26694 m .43096 .26324 L .45032 .24722 L p F P
0 0 0 r
s
.83 .24 .1 r
.42956 .28047 m
.45132 .25661 L
s
1 .313 .132 r
.47567 .23623 m .47995 .23824 L .46301 .25304 L p F P
0 0 0 r
s
.24 .35 .67 r
.45246 .24411 m
.47373 .2388 L
s
1 .313 .132 r
.46301 .25304 m .45668 .25014 L .47567 .23623 L p F P
0 0 0 r
s
.83 .24 .1 r
.52996 .55504 m
.55644 .56309 L
s
.55644 .56309 m
.58368 .56589 L
s
1 .283 .116 r
.38494 .40366 m .37035 .3984 L .37254 .37368 L p F P
0 0 0 r
s
.976 .272 .112 r
.37035 .3984 m .38494 .40366 L .3861 .42779 L p F P
0 0 0 r
s
.063 .075 .143 r
.50811 .54537 m .49947 .54674 L .4947 .54038 L p F P
0 0 0 r
s
.83 .24 .1 r
.50569 .54576 m
.5314 .5536 L
s
.063 .075 .143 r
.4947 .54038 m .50573 .53861 L .50811 .54537 L p F P
0 0 0 r
s
.351 .078 .033 r
.48664 .53791 m .4947 .54038 L .49947 .54674 L p F P
0 0 0 r
s
.83 .24 .1 r
.48288 .52971 m
.49847 .54094 L
s
.24 .35 .67 r
.49329 .54075 m
.50471 .53053 L
s
.672 .175 .069 r
.43135 .49926 m .44278 .5029 L .45153 .5182 L p F P
0 0 0 r
s
.83 .24 .1 r
.42454 .47395 m
.43754 .49978 L
s
.672 .175 .069 r
.46145 .52129 m .45153 .5182 L .44278 .5029 L p F P
0 0 0 r
s
.83 .24 .1 r
.43754 .49978 m
.46511 .50857 L
s
.253 .37 .736 r
.60539 .26635 m .61678 .2637 L .63688 .28243 L p F P
0 0 0 r
s
.261 .384 .762 r
.61678 .2637 m .60539 .26635 L .58543 .24967 L p F P
0 0 0 r
s
.83 .24 .1 r
.61048 .24338 m
.63541 .25595 L
s
.261 .384 .762 r
.5767 .25175 m .58543 .24967 L .60539 .26635 L p F P
0 0 0 r
s
1 .31 .131 r
.50013 .22762 m .50228 .22866 L .48846 .24225 L p F P
0 0 0 r
s
1 .31 .131 r
.48846 .24225 m .48422 .24025 L .50013 .22762 L p F P
0 0 0 r
s
.24 .35 .67 r
.48912 .23497 m
.48999 .23567 L
s
.47858 .23759 m
.48912 .23497 L
s
.83 .24 .1 r
.78072 .40328 m
.75765 .39277 L
s
.77871 .43601 m
.78072 .40328 L
s
.934 .258 .105 r
.40412 .4555 m .39038 .45088 L .3861 .42779 L p F P
0 0 0 r
s
.877 .239 .097 r
.39038 .45088 m .40412 .4555 L .41064 .47662 L p F P
0 0 0 r
s
.238 .344 .686 r
.68563 .32223 m .66802 .32596 L .65408 .30333 L p F P
0 0 0 r
s
.238 .344 .686 r
.65408 .30333 m .67001 .29985 L .68563 .32223 L p F P
0 0 0 r
s
.245 .357 .711 r
.67001 .29985 m .65408 .30333 L .63688 .28243 L p F P
0 0 0 r
s
.24 .35 .67 r
.62894 .30925 m
.66764 .30078 L
s
.23 .331 .661 r
.69725 .34594 m .67837 .3498 L .66802 .32596 L p F P
0 0 0 r
s
.23 .331 .661 r
.66802 .32596 m .68563 .32223 L .69725 .34594 L p F P
0 0 0 r
s
.24 .35 .67 r
.63842 .3409 m
.67714 .33279 L
s
.203 .285 .574 r
.68596 .42338 m .66636 .42698 L .66769 .40283 L p F P
0 0 0 r
s
.203 .285 .574 r
.66769 .40283 m .68747 .39906 L .68596 .42338 L p F P
0 0 0 r
s
.83 .24 .1 r
.61194 .56168 m
.63722 .56965 L
s
.63722 .56965 m
.66495 .5587 L
s
.277 .413 .817 r
.54594 .24023 m .54006 .24166 L .52862 .22835 L p F P
0 0 0 r
s
.277 .413 .817 r
.52564 .22909 m .52862 .22835 L .54006 .24166 L p F P
0 0 0 r
s
.24 .35 .67 r
.50835 .25062 m
.54565 .24154 L
s
.269 .398 .789 r
.58543 .24967 m .5767 .25175 L .55774 .23735 L p F P
0 0 0 r
s
.269 .398 .789 r
.55183 .23879 m .55774 .23735 L .5767 .25175 L p F P
0 0 0 r
s
.24 .35 .67 r
.54565 .24154 m
.56316 .26281 L
s
1 .308 .128 r
.40356 .27751 m .41373 .28189 L .39898 .30273 L p F P
0 0 0 r
s
1 .308 .128 r
.39898 .30273 m .38726 .29785 L .40356 .27751 L p F P
0 0 0 r
s
1 .304 .126 r
.38726 .29785 m .39898 .30273 L .38703 .32531 L p F P
0 0 0 r
s
.245 .357 .711 r
.63688 .28243 m .65073 .2793 L .67001 .29985 L p F P
0 0 0 r
s
.253 .37 .736 r
.65073 .2793 m .63688 .28243 L .61678 .2637 L p F P
0 0 0 r
s
1 .304 .126 r
.38703 .32531 m .37403 .32009 L .38726 .29785 L p F P
0 0 0 r
s
1 .298 .123 r
.37403 .32009 m .38703 .32531 L .37815 .34914 L p F P
0 0 0 r
s
.222 .317 .635 r
.70459 .37047 m .68491 .37435 L .67837 .3498 L p F P
0 0 0 r
s
.222 .317 .635 r
.67837 .3498 m .69725 .34594 L .70459 .37047 L p F P
0 0 0 r
s
.24 .35 .67 r
.64447 .37363 m
.68327 .36588 L
s
.131 .17 .349 r
.58438 .51505 m .57067 .51728 L .57793 .50183 L p F P
0 0 0 r
s
.131 .17 .349 r
.57793 .50183 m .59353 .49922 L .58438 .51505 L p F P
0 0 0 r
s
.83 .24 .1 r
.71421 .51809 m
.73798 .52672 L
s
.73798 .52672 m
.75681 .49929 L
s
1 .311 .13 r
.42259 .25952 m .43096 .26324 L .41373 .28189 L p F P
0 0 0 r
s
1 .311 .13 r
.41373 .28189 m .40356 .27751 L .42259 .25952 L p F P
0 0 0 r
s
.24 .35 .67 r
.16949 .33336 m
.20348 .32509 L
s
.16949 .33336 m
.16084 .36144 L
s
.094 .113 .235 r
.55058 .53144 m .53926 .53325 L .54356 .52171 L p F P
0 0 0 r
s
.24 .35 .67 r
.50471 .53053 m
.54209 .52446 L
s
.094 .113 .235 r
.54356 .52171 m .55706 .5195 L .55058 .53144 L p F P
0 0 0 r
s
.24 .35 .67 r
.54209 .52446 m
.55484 .50439 L
s
1 .31 .131 r
.49798 .22658 m .50013 .22762 L .48422 .24025 L p F P
0 0 0 r
s
.24 .35 .67 r
.48912 .23497 m
.48968 .23483 L
s
1 .31 .131 r
.48422 .24025 m .47995 .23824 L .49798 .22658 L p F P
0 0 0 r
s
.277 .413 .817 r
.55183 .23879 m .54594 .24023 L .53161 .22761 L p F P
0 0 0 r
s
.83 .24 .1 r
.53851 .23513 m
.53979 .23481 L
s
.277 .413 .817 r
.52862 .22835 m .53161 .22761 L .54594 .24023 L p F P
0 0 0 r
s
1 .298 .123 r
.37815 .34914 m .36419 .34373 L .37403 .32009 L p F P
0 0 0 r
s
1 .291 .12 r
.36419 .34373 m .37815 .34914 L .37254 .37368 L p F P
0 0 0 r
s
1 .313 .132 r
.47137 .2342 m .47567 .23623 L .45668 .25014 L p F P
0 0 0 r
s
1 .313 .132 r
.45668 .25014 m .45032 .24722 L .47137 .2342 L p F P
0 0 0 r
s
.24 .35 .67 r
.37553 .24135 m
.35574 .24571 L
s
.976 .272 .112 r
.3861 .42779 m .37164 .42276 L .37035 .3984 L p F P
0 0 0 r
s
.934 .258 .105 r
.37164 .42276 m .3861 .42779 L .39038 .45088 L p F P
0 0 0 r
s
.83 .24 .1 r
.38843 .43505 m
.41677 .44481 L
s
.3862 .4034 m
.38843 .43505 L
s
.063 .075 .143 r
.5168 .544 m .50811 .54537 L .50573 .53861 L p F P
0 0 0 r
s
.063 .075 .143 r
.50573 .53861 m .51683 .53684 L .5168 .544 L p F P
0 0 0 r
s
.51 .125 .049 r
.45153 .5182 m .46145 .52129 L .4703 .53291 L p F P
0 0 0 r
s
.51 .125 .049 r
.4785 .53542 m .4703 .53291 L .46145 .52129 L p F P
0 0 0 r
s
.24 .35 .67 r
.67714 .33279 m
.68327 .36588 L
s
.253 .37 .736 r
.61678 .2637 m .62824 .26104 L .65073 .2793 L p F P
0 0 0 r
s
.261 .384 .762 r
.62824 .26104 m .61678 .2637 L .5942 .24758 L p F P
0 0 0 r
s
.261 .384 .762 r
.58543 .24967 m .5942 .24758 L .61678 .2637 L p F P
0 0 0 r
s
.24 .35 .67 r
.56316 .26281 m
.60114 .25384 L
s
.60114 .25384 m
.61638 .27985 L
s
.83 .24 .1 r
.77062 .46855 m
.77871 .43601 L
s
.75554 .42598 m
.77871 .43601 L
s
.269 .398 .789 r
.5942 .24758 m .58543 .24967 L .56368 .2359 L p F P
0 0 0 r
s
.269 .398 .789 r
.55774 .23735 m .56368 .2359 L .58543 .24967 L p F P
0 0 0 r
s
.176 .242 .491 r
.65301 .47173 m .63541 .47475 L .64272 .45345 L p F P
0 0 0 r
s
.24 .35 .67 r
.60184 .4731 m
.64037 .46639 L
s
.176 .242 .491 r
.64272 .45345 m .66145 .45013 L .65301 .47173 L p F P
0 0 0 r
s
.24 .35 .67 r
.64037 .46639 m
.64551 .43758 L
s
.213 .302 .606 r
.70747 .39525 m .68747 .39906 L .68491 .37435 L p F P
0 0 0 r
s
.24 .35 .67 r
.64687 .40626 m
.68582 .39884 L
s
.213 .302 .606 r
.68491 .37435 m .70459 .37047 L .70747 .39525 L p F P
0 0 0 r
s
.24 .35 .67 r
.68327 .36588 m
.68582 .39884 L
s
1 .313 .131 r
.4439 .24428 m .45032 .24722 L .43096 .26324 L p F P
0 0 0 r
s
1 .313 .131 r
.43096 .26324 m .42259 .25952 L .4439 .24428 L p F P
0 0 0 r
s
1 .303 .129 r
.51082 .23277 m .50869 .23175 L .5167 .21838 L closepath p F P
0 0 0 r
s
.284 .428 .842 r
.5167 .21838 m .51377 .23204 L .51082 .23277 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.75358 .361 m
.74361 .33216 L
s
.24 .35 .67 r
.32005 .25485 m
.35574 .24571 L
s
.32005 .25485 m
.30174 .26618 L
s
.157 .212 .431 r
.62515 .49393 m .60927 .49659 L .61798 .47775 L p F P
0 0 0 r
s
.157 .212 .431 r
.61798 .47775 m .63541 .47475 L .62515 .49393 L p F P
0 0 0 r
s
.24 .35 .67 r
.21614 .30156 m
.2507 .29293 L
s
.21614 .30156 m
.20348 .32509 L
s
.277 .413 .817 r
.55774 .23735 m .55183 .23879 L .5346 .22687 L p F P
0 0 0 r
s
.83 .24 .1 r
.54315 .23399 m
.54444 .23367 L
s
.277 .413 .817 r
.53161 .22761 m .5346 .22687 L .55183 .23879 L p F P
0 0 0 r
s
.191 .266 .537 r
.68037 .44677 m .66145 .45013 L .66636 .42698 L p F P
0 0 0 r
s
.191 .266 .537 r
.66636 .42698 m .68596 .42338 L .68037 .44677 L p F P
0 0 0 r
s
.83 .24 .1 r
.73328 .49022 m
.75681 .49929 L
s
.75681 .49929 m
.77062 .46855 L
s
.351 .078 .033 r
.4785 .53542 m .48664 .53791 L .49318 .54483 L p F P
0 0 0 r
s
.351 .078 .033 r
.49947 .54674 m .49318 .54483 L .48664 .53791 L p F P
0 0 0 r
s
.24 .35 .67 r
.48866 .54489 m
.49058 .54317 L
s
.45183 .55074 m
.48866 .54489 L
s
1 .291 .12 r
.37254 .37368 m .35797 .36823 L .36419 .34373 L p F P
0 0 0 r
s
1 .283 .116 r
.35797 .36823 m .37254 .37368 L .37035 .3984 L p F P
0 0 0 r
s
.24 .35 .67 r
.26661 .2751 m
.30174 .26618 L
s
.26661 .2751 m
.2507 .29293 L
s
.284 .428 .842 r
.5167 .21838 m .51673 .2313 L .51377 .23204 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.74729 .45901 m
.77062 .46855 L
s
1 .31 .131 r
.49582 .22554 m .49798 .22658 L .47995 .23824 L p F P
0 0 0 r
s
1 .31 .131 r
.47995 .23824 m .47567 .23623 L .49582 .22554 L p F P
0 0 0 r
s
.83 .24 .1 r
.47607 .23759 m
.50317 .25033 L
s
.238 .344 .686 r
.70341 .31846 m .68563 .32223 L .67001 .29985 L p F P
0 0 0 r
s
.238 .344 .686 r
.67001 .29985 m .68607 .29633 L .70341 .31846 L p F P
0 0 0 r
s
.24 .35 .67 r
.66764 .30078 m
.67714 .33279 L
s
.245 .357 .711 r
.68607 .29633 m .67001 .29985 L .65073 .2793 L p F P
0 0 0 r
s
1 .303 .129 r
.50869 .23175 m .50656 .23072 L .5167 .21838 L closepath p F P
0 0 0 r
s
.245 .357 .711 r
.65073 .2793 m .66469 .27615 L .68607 .29633 L p F P
0 0 0 r
s
.253 .37 .736 r
.66469 .27615 m .65073 .2793 L .62824 .26104 L p F P
0 0 0 r
s
.24 .35 .67 r
.18925 .52111 m
.20729 .54555 L
s
.20729 .54555 m
.2418 .53958 L
s
.23 .331 .661 r
.71632 .34204 m .69725 .34594 L .68563 .32223 L p F P
0 0 0 r
s
.23 .331 .661 r
.68563 .32223 m .70341 .31846 L .71632 .34204 L p F P
0 0 0 r
s
.284 .428 .842 r
.5167 .21838 m .5197 .23057 L .51673 .2313 L closepath p F P
0 0 0 r
s
.261 .384 .762 r
.5942 .24758 m .60301 .24548 L .62824 .26104 L p F P
0 0 0 r
s
.269 .398 .789 r
.60301 .24548 m .5942 .24758 L .56963 .23445 L p F P
0 0 0 r
s
.269 .398 .789 r
.56368 .2359 m .56963 .23445 L .5942 .24758 L p F P
0 0 0 r
s
.277 .413 .817 r
.56368 .2359 m .55774 .23735 L .5376 .22612 L p F P
0 0 0 r
s
.83 .24 .1 r
.5478 .23285 m
.54909 .23253 L
s
.277 .413 .817 r
.5346 .22687 m .5376 .22612 L .55774 .23735 L p F P
0 0 0 r
s
.83 .24 .1 r
.55247 .2317 m
.55733 .23051 L
s
.55733 .23051 m
.56671 .23516 L
s
.877 .239 .097 r
.41064 .47662 m .39774 .47241 L .39038 .45088 L p F P
0 0 0 r
s
.795 .213 .085 r
.39774 .47241 m .41064 .47662 L .41977 .49558 L p F P
0 0 0 r
s
.795 .213 .085 r
.43135 .49926 m .41977 .49558 L .41064 .47662 L p F P
0 0 0 r
s
.672 .175 .069 r
.41977 .49558 m .43135 .49926 L .44151 .51509 L p F P
0 0 0 r
s
.672 .175 .069 r
.45153 .5182 m .44151 .51509 L .43135 .49926 L p F P
0 0 0 r
s
.131 .17 .349 r
.59821 .51279 m .58438 .51505 L .59353 .49922 L p F P
0 0 0 r
s
.24 .35 .67 r
.55484 .50439 m
.59279 .49803 L
s
.131 .17 .349 r
.59353 .49922 m .60927 .49659 L .59821 .51279 L p F P
0 0 0 r
s
.24 .35 .67 r
.59279 .49803 m
.60184 .4731 L
s
.203 .285 .574 r
.70577 .41974 m .68596 .42338 L .68747 .39906 L p F P
0 0 0 r
s
.203 .285 .574 r
.68747 .39906 m .70747 .39525 L .70577 .41974 L p F P
0 0 0 r
s
1 .313 .132 r
.46704 .23216 m .47137 .2342 L .45032 .24722 L p F P
0 0 0 r
s
1 .313 .132 r
.45032 .24722 m .4439 .24428 L .46704 .23216 L p F P
0 0 0 r
s
.83 .24 .1 r
.45132 .25661 m
.47607 .23759 L
s
.094 .113 .235 r
.56197 .52961 m .55058 .53144 L .55706 .5195 L p F P
0 0 0 r
s
.094 .113 .235 r
.55706 .5195 m .57067 .51728 L .56197 .52961 L p F P
0 0 0 r
s
1 .303 .129 r
.50656 .23072 m .50442 .22969 L .5167 .21838 L closepath p F P
0 0 0 r
s
.063 .075 .143 r
.52554 .54262 m .5168 .544 L .51683 .53684 L p F P
0 0 0 r
s
.063 .075 .143 r
.51683 .53684 m .52801 .53505 L .52554 .54262 L p F P
0 0 0 r
s
.253 .37 .736 r
.62824 .26104 m .63978 .25836 L .66469 .27615 L p F P
0 0 0 r
s
.261 .384 .762 r
.63978 .25836 m .62824 .26104 L .60301 .24548 L p F P
0 0 0 r
s
.284 .428 .842 r
.5167 .21838 m .52267 .22983 L .5197 .23057 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.48866 .54489 m
.49235 .5443 L
s
.222 .317 .635 r
.72449 .36654 m .70459 .37047 L .69725 .34594 L p F P
0 0 0 r
s
.222 .317 .635 r
.69725 .34594 m .71632 .34204 L .72449 .36654 L p F P
0 0 0 r
s
1 .31 .131 r
.49366 .2245 m .49582 .22554 L .47567 .23623 L p F P
0 0 0 r
s
1 .31 .131 r
.47567 .23623 m .47137 .2342 L .49366 .2245 L p F P
0 0 0 r
s
1 .283 .116 r
.37035 .3984 m .35553 .39307 L .35797 .36823 L p F P
0 0 0 r
s
.976 .272 .112 r
.35553 .39307 m .37035 .3984 L .37164 .42276 L p F P
0 0 0 r
s
.284 .428 .842 r
.5167 .21838 m .52564 .22909 L .52267 .22983 L closepath p F P
0 0 0 r
s
1 .303 .129 r
.50442 .22969 m .50228 .22866 L .5167 .21838 L closepath p F P
0 0 0 r
s
.934 .258 .105 r
.39038 .45088 m .37644 .44618 L .37164 .42276 L p F P
0 0 0 r
s
.877 .239 .097 r
.37644 .44618 m .39038 .45088 L .39774 .47241 L p F P
0 0 0 r
s
.83 .24 .1 r
.38843 .43505 m
.39614 .46457 L
s
.39614 .46457 m
.42454 .47395 L
s
.277 .413 .817 r
.56963 .23445 m .56368 .2359 L .5406 .22538 L p F P
0 0 0 r
s
.277 .413 .817 r
.5376 .22612 m .5406 .22538 L .56368 .2359 L p F P
0 0 0 r
s
1 .311 .13 r
.41413 .25576 m .42259 .25952 L .40356 .27751 L p F P
0 0 0 r
s
1 .311 .13 r
.40356 .27751 m .39329 .27308 L .41413 .25576 L p F P
0 0 0 r
s
1 .308 .128 r
.39329 .27308 m .40356 .27751 L .38726 .29785 L p F P
0 0 0 r
s
1 .308 .128 r
.38726 .29785 m .37539 .29291 L .39329 .27308 L p F P
0 0 0 r
s
1 .304 .126 r
.37539 .29291 m .38726 .29785 L .37403 .32009 L p F P
0 0 0 r
s
.83 .24 .1 r
.38299 .29631 m
.41157 .30822 L
s
.24 .35 .67 r
.41261 .55987 m
.43308 .55873 L
s
.43308 .55873 m
.47014 .5529 L
s
.83 .24 .1 r
.63992 .55052 m
.66495 .5587 L
s
.66495 .5587 m
.69104 .54127 L
s
.24 .35 .67 r
.2418 .53958 m
.26211 .55861 L
s
.26211 .55861 m
.29731 .55278 L
s
.83 .24 .1 r
.55739 .55781 m
.58368 .56589 L
s
.58368 .56589 m
.61194 .56168 L
s
.284 .428 .842 r
.5167 .21838 m .52862 .22835 L .52564 .22909 L closepath p F P
0 0 0 r
s
1 .313 .131 r
.43744 .24132 m .4439 .24428 L .42259 .25952 L p F P
0 0 0 r
s
1 .313 .131 r
.42259 .25952 m .41413 .25576 L .43744 .24132 L p F P
0 0 0 r
s
.261 .384 .762 r
.60301 .24548 m .61187 .24337 L .63978 .25836 L p F P
0 0 0 r
s
.83 .24 .1 r
.61048 .24338 m
.61113 .24355 L
s
.61322 .2441 m
.63649 .25019 L
s
.269 .398 .789 r
.61187 .24337 m .60301 .24548 L .5756 .233 L p F P
0 0 0 r
s
.269 .398 .789 r
.56963 .23445 m .5756 .233 L .60301 .24548 L p F P
0 0 0 r
s
1 .304 .126 r
.37403 .32009 m .36085 .31479 L .37539 .29291 L p F P
0 0 0 r
s
1 .298 .123 r
.36085 .31479 m .37403 .32009 L .36419 .34373 L p F P
0 0 0 r
s
.83 .24 .1 r
.36926 .32731 m
.39804 .33874 L
s
.24 .35 .67 r
.35463 .55974 m
.37613 .56563 L
s
.37613 .56563 m
.41261 .55987 L
s
.51 .125 .049 r
.44151 .51509 m .45153 .5182 L .46202 .53037 L p F P
0 0 0 r
s
.51 .125 .049 r
.4703 .53291 m .46202 .53037 L .45153 .5182 L p F P
0 0 0 r
s
.83 .24 .1 r
.45534 .52117 m
.48288 .52971 L
s
.43754 .49978 m
.45534 .52117 L
s
.176 .242 .491 r
.67078 .46867 m .65301 .47173 L .66145 .45013 L p F P
0 0 0 r
s
.176 .242 .491 r
.66145 .45013 m .68037 .44677 L .67078 .46867 L p F P
0 0 0 r
s
.24 .35 .67 r
.29731 .55278 m
.31878 .56551 L
s
.31878 .56551 m
.35463 .55974 L
s
1 .303 .129 r
.50228 .22866 m .50013 .22762 L .5167 .21838 L closepath p F P
0 0 0 r
s
.351 .078 .033 r
.4703 .53291 m .4785 .53542 L .48684 .54291 L p F P
0 0 0 r
s
.351 .078 .033 r
.49318 .54483 m .48684 .54291 L .4785 .53542 L p F P
0 0 0 r
s
.157 .212 .431 r
.64118 .49126 m .62515 .49393 L .63541 .47475 L p F P
0 0 0 r
s
.157 .212 .431 r
.63541 .47475 m .65301 .47173 L .64118 .49126 L p F P
0 0 0 r
s
.213 .302 .606 r
.72768 .3914 m .70747 .39525 L .70459 .37047 L p F P
0 0 0 r
s
.213 .302 .606 r
.70459 .37047 m .72449 .36654 L .72768 .3914 L p F P
0 0 0 r
s
.284 .428 .842 r
.5167 .21838 m .53161 .22761 L .52862 .22835 L closepath p F P
0 0 0 r
s
.245 .357 .711 r
.70227 .29279 m .68607 .29633 L .66469 .27615 L p F P
0 0 0 r
s
.245 .357 .711 r
.66469 .27615 m .67876 .27297 L .70227 .29279 L p F P
0 0 0 r
s
.83 .24 .1 r
.68466 .27615 m
.69766 .2889 L
s
.67931 .27343 m
.68466 .27615 L
s
.253 .37 .736 r
.67876 .27297 m .66469 .27615 L .63978 .25836 L p F P
0 0 0 r
s
.24 .35 .67 r
.65511 .27103 m
.66764 .30078 L
s
.83 .24 .1 r
.63649 .25019 m
.66124 .26277 L
s
.24 .35 .67 r
.61638 .27985 m
.65511 .27103 L
s
.277 .413 .817 r
.5756 .233 m .56963 .23445 L .5436 .22463 L p F P
0 0 0 r
s
.83 .24 .1 r
.55733 .23051 m
.55916 .2305 L
s
.277 .413 .817 r
.5406 .22538 m .5436 .22463 L .56963 .23445 L p F P
0 0 0 r
s
.238 .344 .686 r
.72137 .31466 m .70341 .31846 L .68607 .29633 L p F P
0 0 0 r
s
.238 .344 .686 r
.68607 .29633 m .70227 .29279 L .72137 .31466 L p F P
0 0 0 r
s
.83 .24 .1 r
.70495 .29586 m
.72832 .30757 L
s
1 .31 .131 r
.49149 .22346 m .49366 .2245 L .47137 .2342 L p F P
0 0 0 r
s
1 .31 .131 r
.47137 .2342 m .46704 .23216 L .49149 .22346 L p F P
0 0 0 r
s
.063 .075 .143 r
.53432 .54124 m .52554 .54262 L .52801 .53505 L p F P
0 0 0 r
s
.063 .075 .143 r
.52801 .53505 m .53926 .53325 L .53432 .54124 L p F P
0 0 0 r
s
.253 .37 .736 r
.63978 .25836 m .65139 .25566 L .67876 .27297 L p F P
0 0 0 r
s
.261 .384 .762 r
.65139 .25566 m .63978 .25836 L .61187 .24337 L p F P
0 0 0 r
s
.83 .24 .1 r
.63649 .25019 m
.63969 .25203 L
s
.191 .266 .537 r
.69949 .44337 m .68037 .44677 L .68596 .42338 L p F P
0 0 0 r
s
.24 .35 .67 r
.68464 .43046 m
.68582 .39884 L
s
.64551 .43758 m
.68464 .43046 L
s
.191 .266 .537 r
.68596 .42338 m .70577 .41974 L .69949 .44337 L p F P
0 0 0 r
s
.24 .35 .67 r
.16084 .36144 m
.19499 .35342 L
s
.16084 .36144 m
.15689 .39297 L
s
1 .313 .132 r
.4627 .23012 m .46704 .23216 L .4439 .24428 L p F P
0 0 0 r
s
1 .313 .132 r
.4439 .24428 m .43744 .24132 L .4627 .23012 L p F P
0 0 0 r
s
1 .298 .123 r
.36419 .34373 m .35002 .33823 L .36085 .31479 L p F P
0 0 0 r
s
1 .291 .12 r
.35002 .33823 m .36419 .34373 L .35797 .36823 L p F P
0 0 0 r
s
.83 .24 .1 r
.36051 .35992 m
.38947 .37088 L
s
1 .303 .129 r
.50013 .22762 m .49798 .22658 L .5167 .21838 L closepath p F P
0 0 0 r
s
.284 .428 .842 r
.5167 .21838 m .5346 .22687 L .53161 .22761 L closepath p F P
0 0 0 r
s
.094 .113 .235 r
.57344 .52778 m .56197 .52961 L .57067 .51728 L p F P
0 0 0 r
s
.094 .113 .235 r
.57067 .51728 m .58438 .51505 L .57344 .52778 L p F P
0 0 0 r
s
.83 .24 .1 r
.75765 .39277 m
.75358 .361 L
s
.36926 .32731 m
.38299 .29631 L
s
.36051 .35992 m
.36926 .32731 L
s
.23 .331 .661 r
.7356 .3381 m .71632 .34204 L .70341 .31846 L p F P
0 0 0 r
s
.23 .331 .661 r
.70341 .31846 m .72137 .31466 L .7356 .3381 L p F P
0 0 0 r
s
.83 .24 .1 r
.72708 .32406 m
.74361 .33216 L
s
.24 .35 .67 r
.67714 .33279 m
.71671 .32451 L
s
.131 .17 .349 r
.61214 .51052 m .59821 .51279 L .60927 .49659 L p F P
0 0 0 r
s
.131 .17 .349 r
.60927 .49659 m .62515 .49393 L .61214 .51052 L p F P
0 0 0 r
s
.976 .272 .112 r
.37164 .42276 m .35697 .41765 L .35553 .39307 L p F P
0 0 0 r
s
.934 .258 .105 r
.35697 .41765 m .37164 .42276 L .37644 .44618 L p F P
0 0 0 r
s
.284 .428 .842 r
.5167 .21838 m .5376 .22612 L .5346 .22687 L closepath p F P
0 0 0 r
s
.261 .384 .762 r
.61187 .24337 m .62077 .24125 L .65139 .25566 L p F P
0 0 0 r
s
.269 .398 .789 r
.62077 .24125 m .61187 .24337 L .5816 .23153 L p F P
0 0 0 r
s
.83 .24 .1 r
.60561 .24093 m
.60862 .24244 L
s
.269 .398 .789 r
.5756 .233 m .5816 .23153 L .61187 .24337 L p F P
0 0 0 r
s
.277 .413 .817 r
.5816 .23153 m .5756 .233 L .54662 .22388 L p F P
0 0 0 r
s
.83 .24 .1 r
.56598 .23048 m
.56759 .23048 L
s
.277 .413 .817 r
.5436 .22463 m .54662 .22388 L .5756 .233 L p F P
0 0 0 r
s
1 .303 .129 r
.49798 .22658 m .49582 .22554 L .5167 .21838 L closepath p F P
0 0 0 r
s
.284 .428 .842 r
.5167 .21838 m .5406 .22538 L .5376 .22612 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.50406 .23124 m
.52659 .22563 L
s
.52659 .22563 m
.54565 .24154 L
s
.203 .285 .574 r
.72579 .41606 m .70577 .41974 L .70747 .39525 L p F P
0 0 0 r
s
.203 .285 .574 r
.70747 .39525 m .72768 .3914 L .72579 .41606 L p F P
0 0 0 r
s
1 .31 .131 r
.48932 .22241 m .49149 .22346 L .46704 .23216 L p F P
0 0 0 r
s
1 .31 .131 r
.46704 .23216 m .4627 .23012 L .48932 .22241 L p F P
0 0 0 r
s
.24 .35 .67 r
.46902 .22542 m
.47277 .2272 L
s
.43217 .23476 m
.46902 .22542 L
s
.17452 .49213 m
.18925 .52111 L
s
.18925 .52111 m
.22379 .51484 L
s
1 .291 .12 r
.35797 .36823 m .34317 .3627 L .35002 .33823 L p F P
0 0 0 r
s
1 .283 .116 r
.34317 .3627 m .35797 .36823 L .35553 .39307 L p F P
0 0 0 r
s
.83 .24 .1 r
.3571 .3929 m
.36051 .35992 L
s
.3571 .3929 m
.3862 .4034 L
s
.222 .317 .635 r
.7446 .36257 m .72449 .36654 L .71632 .34204 L p F P
0 0 0 r
s
.222 .317 .635 r
.71632 .34204 m .7356 .3381 L .7446 .36257 L p F P
0 0 0 r
s
.24 .35 .67 r
.68327 .36588 m
.72293 .35796 L
s
1 .303 .129 r
.49582 .22554 m .49366 .2245 L .5167 .21838 L closepath p F P
0 0 0 r
s
.795 .213 .085 r
.41977 .49558 m .40805 .49186 L .39774 .47241 L p F P
0 0 0 r
s
.672 .175 .069 r
.40805 .49186 m .41977 .49558 L .43138 .51193 L p F P
0 0 0 r
s
.672 .175 .069 r
.44151 .51509 m .43138 .51193 L .41977 .49558 L p F P
0 0 0 r
s
.284 .428 .842 r
.5167 .21838 m .5436 .22463 L .5406 .22538 L closepath p F P
0 0 0 r
s
.269 .398 .789 r
.5816 .23153 m .58761 .23007 L .62077 .24125 L p F P
0 0 0 r
s
.277 .413 .817 r
.58761 .23007 m .5816 .23153 L .54963 .22313 L p F P
0 0 0 r
s
.277 .413 .817 r
.54662 .22388 m .54963 .22313 L .5816 .23153 L p F P
0 0 0 r
s
.877 .239 .097 r
.39774 .47241 m .38466 .46814 L .37644 .44618 L p F P
0 0 0 r
s
.795 .213 .085 r
.38466 .46814 m .39774 .47241 L .40805 .49186 L p F P
0 0 0 r
s
.063 .075 .143 r
.54314 .53984 m .53432 .54124 L .53926 .53325 L p F P
0 0 0 r
s
.063 .075 .143 r
.53926 .53325 m .55058 .53144 L .54314 .53984 L p F P
0 0 0 r
s
.24 .35 .67 r
.5263 .53891 m
.54209 .52446 L
s
1 .313 .131 r
.43094 .23834 m .43744 .24132 L .41413 .25576 L p F P
0 0 0 r
s
1 .313 .131 r
.41413 .25576 m .4056 .25196 L .43094 .23834 L p F P
0 0 0 r
s
.24 .35 .67 r
.37553 .24135 m
.4118 .23207 L
s
1 .311 .13 r
.4056 .25196 m .41413 .25576 L .39329 .27308 L p F P
0 0 0 r
s
.44 .141 .066 r
.65139 .25566 m .64394 .25187 L .61491 .23827 L p F P
0 0 0 r
s
.44 .141 .066 r
.61491 .23827 m .62077 .24125 L .65139 .25566 L p F P
0 0 0 r
s
.35 .078 .032 r
.64394 .25187 m .65139 .25566 L .67876 .27297 L p F P
0 0 0 r
s
.24 .35 .67 r
.63996 .24468 m
.64365 .2511 L
s
.60114 .25384 m
.6321 .24653 L
s
.6324 .24646 m
.63996 .24468 L
s
1 .311 .13 r
.39329 .27308 m .3829 .26861 L .4056 .25196 L p F P
0 0 0 r
s
.83 .24 .1 r
.40118 .26812 m
.42956 .28047 L
s
1 .308 .128 r
.3829 .26861 m .39329 .27308 L .37539 .29291 L p F P
0 0 0 r
s
.83 .24 .1 r
.38299 .29631 m
.40118 .26812 L
s
.53 .131 .051 r
.66994 .2685 m .67876 .27297 L .70227 .29279 L p F P
0 0 0 r
s
.35 .078 .032 r
.67876 .27297 m .66994 .2685 L .64394 .25187 L p F P
0 0 0 r
s
.24 .35 .67 r
.65511 .27103 m
.66897 .26788 L
s
.64432 .25226 m
.65511 .27103 L
s
.64365 .2511 m
.64416 .25198 L
s
1 .313 .132 r
.45833 .22806 m .4627 .23012 L .43744 .24132 L p F P
0 0 0 r
s
1 .313 .132 r
.43744 .24132 m .43094 .23834 L .45833 .22806 L p F P
0 0 0 r
s
.24 .35 .67 r
.4118 .23207 m
.43217 .23476 L
s
.20348 .32509 m
.23822 .31664 L
s
.20348 .32509 m
.19499 .35342 L
s
.83 .24 .1 r
.66627 .53277 m
.69104 .54127 L
s
.69104 .54127 m
.71421 .51809 L
s
.626 .202 .09 r
.62077 .24125 m .61491 .23827 L .58354 .22801 L p F P
0 0 0 r
s
.626 .202 .09 r
.58354 .22801 m .58761 .23007 L .62077 .24125 L p F P
0 0 0 r
s
.24 .35 .67 r
.54565 .24154 m
.58377 .23226 L
s
.58377 .23226 m
.60114 .25384 L
s
.83 .24 .1 r
.58479 .23043 m
.58931 .23271 L
s
.57466 .23046 m
.58479 .23043 L
s
.284 .428 .842 r
.5167 .21838 m .54662 .22388 L .5436 .22463 L closepath p F P
0 0 0 r
s
.351 .078 .033 r
.46202 .53037 m .4703 .53291 L .48046 .54097 L p F P
0 0 0 r
s
.351 .078 .033 r
.48684 .54291 m .48046 .54097 L .4703 .53291 L p F P
0 0 0 r
s
1 .303 .129 r
.49366 .2245 m .49149 .22346 L .5167 .21838 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.50286 .22425 m
.51906 .2321 L
s
.24 .35 .67 r
.58377 .23226 m
.59048 .23063 L
s
1 .308 .128 r
.37539 .29291 m .36337 .2879 L .3829 .26861 L p F P
0 0 0 r
s
1 .304 .126 r
.36337 .2879 m .37539 .29291 L .36085 .31479 L p F P
0 0 0 r
s
.157 .212 .431 r
.65735 .48855 m .64118 .49126 L .65301 .47173 L p F P
0 0 0 r
s
.157 .212 .431 r
.65301 .47173 m .67078 .46867 L .65735 .48855 L p F P
0 0 0 r
s
.036 .047 .09 r
.51077 .5482 m .50479 .54914 L .49947 .54674 L p F P
0 0 0 r
s
.036 .047 .09 r
.49947 .54674 m .50811 .54537 L .51077 .5482 L p F P
0 0 0 r
s
.83 .24 .1 r
.51012 .54751 m
.52996 .55504 L
s
.214 .05 .021 r
.49318 .54483 m .49947 .54674 L .50479 .54914 L p F P
0 0 0 r
s
.176 .242 .491 r
.68872 .46558 m .67078 .46867 L .68037 .44677 L p F P
0 0 0 r
s
.176 .242 .491 r
.68037 .44677 m .69949 .44337 L .68872 .46558 L p F P
0 0 0 r
s
.24 .35 .67 r
.67974 .45954 m
.68464 .43046 L
s
.696 .182 .07 r
.69231 .28778 m .70227 .29279 L .72137 .31466 L p F P
0 0 0 r
s
.24 .35 .67 r
.70211 .29325 m
.70231 .2932 L
s
.66764 .30078 m
.69896 .29393 L
s
.53 .131 .051 r
.70227 .29279 m .69231 .28778 L .66994 .2685 L p F P
0 0 0 r
s
.51 .125 .049 r
.43138 .51193 m .44151 .51509 L .45366 .52781 L p F P
0 0 0 r
s
.51 .125 .049 r
.46202 .53037 m .45366 .52781 L .44151 .51509 L p F P
0 0 0 r
s
.24 .35 .67 r
.71671 .32451 m
.72293 .35796 L
s
.71098 .30505 m
.71671 .32451 L
s
.094 .113 .235 r
.58499 .52593 m .57344 .52778 L .58438 .51505 L p F P
0 0 0 r
s
.24 .35 .67 r
.54209 .52446 m
.5803 .51825 L
s
.094 .113 .235 r
.58438 .51505 m .59821 .51279 L .58499 .52593 L p F P
0 0 0 r
s
.24 .35 .67 r
.5803 .51825 m
.59279 .49803 L
s
.284 .428 .842 r
.5167 .21838 m .54963 .22313 L .54662 .22388 L closepath p F P
0 0 0 r
s
1 .31 .131 r
.48714 .22136 m .48932 .22241 L .4627 .23012 L p F P
0 0 0 r
s
1 .31 .131 r
.4627 .23012 m .45833 .22806 L .48714 .22136 L p F P
0 0 0 r
s
.24 .35 .67 r
.46902 .22542 m
.48051 .22251 L
s
.83 .24 .1 r
.47607 .23759 m
.50286 .22425 L
s
.277 .413 .817 r
.54963 .22313 m .55265 .22238 L .58761 .23007 L p F P
0 0 0 r
s
.831 .257 .112 r
.58761 .23007 m .58354 .22801 L .55055 .22133 L p F P
0 0 0 r
s
.831 .257 .112 r
.55055 .22133 m .55265 .22238 L .58761 .23007 L p F P
0 0 0 r
s
.213 .302 .606 r
.74812 .38751 m .72768 .3914 L .72449 .36654 L p F P
0 0 0 r
s
.24 .35 .67 r
.68582 .39884 m
.72562 .39126 L
s
.213 .302 .606 r
.72449 .36654 m .7446 .36257 L .74812 .38751 L p F P
0 0 0 r
s
.83 .24 .1 r
.50858 .54854 m
.52996 .55504 L
s
.52996 .55504 m
.55739 .55781 L
s
1 .303 .129 r
.49149 .22346 m .48932 .22241 L .5167 .21838 L closepath p F P
0 0 0 r
s
.934 .258 .105 r
.37644 .44618 m .36229 .44142 L .35697 .41765 L p F P
0 0 0 r
s
.877 .239 .097 r
.36229 .44142 m .37644 .44618 L .38466 .46814 L p F P
0 0 0 r
s
1 .283 .116 r
.35553 .39307 m .34048 .38764 L .34317 .3627 L p F P
0 0 0 r
s
.976 .272 .112 r
.34048 .38764 m .35553 .39307 L .35697 .41765 L p F P
0 0 0 r
s
.24 .35 .67 r
.35574 .24571 m
.33764 .25705 L
s
.15689 .39297 m
.19117 .38525 L
s
.15689 .39297 m
.1579 .42639 L
s
.2507 .29293 m
.28602 .28411 L
s
.2507 .29293 m
.23822 .31664 L
s
.284 .428 .842 r
.5167 .21838 m .55265 .22238 L .54963 .22313 L closepath p F P
0 0 0 r
s
.131 .17 .349 r
.62618 .50823 m .61214 .51052 L .62515 .49393 L p F P
0 0 0 r
s
.131 .17 .349 r
.62515 .49393 m .64118 .49126 L .62618 .50823 L p F P
0 0 0 r
s
.24 .35 .67 r
.59279 .49803 m
.63157 .49154 L
s
.63157 .49154 m
.64037 .46639 L
s
.191 .266 .537 r
.71882 .43994 m .69949 .44337 L .70577 .41974 L p F P
0 0 0 r
s
.191 .266 .537 r
.70577 .41974 m .72579 .41606 L .71882 .43994 L p F P
0 0 0 r
s
1 .304 .126 r
.36085 .31479 m .34749 .30942 L .36337 .2879 L p F P
0 0 0 r
s
1 .298 .123 r
.34749 .30942 m .36085 .31479 L .35002 .33823 L p F P
0 0 0 r
s
.83 .24 .1 r
.75554 .42598 m
.75765 .39277 L
s
.83 .224 .089 r
.71051 .30929 m .72137 .31466 L .7356 .3381 L p F P
0 0 0 r
s
.24 .35 .67 r
.71671 .32451 m
.72268 .32326 L
s
.696 .182 .07 r
.72137 .31466 m .71051 .30929 L .69231 .28778 L p F P
0 0 0 r
s
.24 .35 .67 r
.70718 .29214 m
.71031 .30275 L
s
.70231 .2932 m
.70718 .29214 L
s
.30174 .26618 m
.33764 .25705 L
s
.30174 .26618 m
.28602 .28411 L
s
1 .303 .129 r
.48932 .22241 m .48714 .22136 L .5167 .21838 L closepath p F P
0 0 0 r
s
.951 .288 .124 r
.5167 .21838 m .55265 .22238 L .55055 .22133 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.58587 .55347 m
.61194 .56168 L
s
.61194 .56168 m
.63992 .55052 L
s
.063 .075 .143 r
.55201 .53844 m .54314 .53984 L .55058 .53144 L p F P
0 0 0 r
s
.063 .075 .143 r
.55058 .53144 m .56197 .52961 L .55201 .53844 L p F P
0 0 0 r
s
.24 .35 .67 r
.22379 .51484 m
.2418 .53958 L
s
.2418 .53958 m
.27707 .53349 L
s
.036 .047 .09 r
.51677 .54726 m .51077 .5482 L .50811 .54537 L p F P
0 0 0 r
s
.036 .047 .09 r
.50811 .54537 m .5168 .544 L .51677 .54726 L p F P
0 0 0 r
s
.24 .35 .67 r
.16388 .46001 m
.17452 .49213 L
s
.17452 .49213 m
.20905 .48551 L
s
1 .31 .131 r
.48495 .2203 m .48714 .22136 L .45833 .22806 L p F P
0 0 0 r
s
1 .31 .131 r
.45833 .22806 m .45394 .226 L .48495 .2203 L p F P
0 0 0 r
s
1 .313 .132 r
.45394 .226 m .45833 .22806 L .43094 .23834 L p F P
0 0 0 r
s
.626 .202 .09 r
.57946 .22595 m .58354 .22801 L .61491 .23827 L p F P
0 0 0 r
s
.831 .257 .112 r
.58354 .22801 m .57946 .22595 L .54844 .22028 L p F P
0 0 0 r
s
.831 .257 .112 r
.54844 .22028 m .55055 .22133 L .58354 .22801 L p F P
0 0 0 r
s
1 .313 .132 r
.43094 .23834 m .42439 .23534 L .45394 .226 L p F P
0 0 0 r
s
1 .313 .131 r
.42439 .23534 m .43094 .23834 L .4056 .25196 L p F P
0 0 0 r
s
.83 .24 .1 r
.40118 .26812 m
.42316 .24384 L
s
.42316 .24384 m
.45132 .25661 L
s
.44 .141 .066 r
.60901 .23527 m .61491 .23827 L .64394 .25187 L p F P
0 0 0 r
s
.626 .202 .09 r
.61491 .23827 m .60901 .23527 L .57946 .22595 L p F P
0 0 0 r
s
.24 .35 .67 r
.57689 .22636 m
.58377 .23226 L
s
1 .303 .129 r
.48714 .22136 m .48495 .2203 L .5167 .21838 L closepath p F P
0 0 0 r
s
1 .298 .123 r
.35002 .33823 m .33564 .33266 L .34749 .30942 L p F P
0 0 0 r
s
1 .291 .12 r
.33564 .33266 m .35002 .33823 L .34317 .3627 L p F P
0 0 0 r
s
.951 .288 .124 r
.5167 .21838 m .55055 .22133 L .54844 .22028 L closepath p F P
0 0 0 r
s
.203 .285 .574 r
.74604 .41234 m .72579 .41606 L .72768 .3914 L p F P
0 0 0 r
s
.203 .285 .574 r
.72768 .3914 m .74812 .38751 L .74604 .41234 L p F P
0 0 0 r
s
.83 .24 .1 r
.74805 .3884 m
.75765 .39277 L
s
.68969 .50919 m
.71421 .51809 L
s
.71421 .51809 m
.73328 .49022 L
s
.918 .252 .101 r
.72408 .33252 m .7356 .3381 L .7446 .36257 L p F P
0 0 0 r
s
.24 .35 .67 r
.72293 .35796 m
.73923 .3547 L
s
.72293 .35796 m
.72562 .39126 L
s
.83 .24 .1 r
.742 .35551 m
.75358 .361 L
s
.83 .224 .089 r
.7356 .3381 m .72408 .33252 L .71051 .30929 L p F P
0 0 0 r
s
.24 .35 .67 r
.72574 .32262 m
.75715 .31605 L
s
1 .313 .131 r
.4056 .25196 m .39699 .24813 L .42439 .23534 L p F P
0 0 0 r
s
1 .311 .13 r
.39699 .24813 m .4056 .25196 L .3829 .26861 L p F P
0 0 0 r
s
.214 .05 .021 r
.48684 .54291 m .49318 .54483 L .50047 .54782 L p F P
0 0 0 r
s
.24 .35 .67 r
.49616 .5437 m
.5263 .53891 L
s
.47014 .5529 m
.48866 .54489 L
s
.214 .05 .021 r
.50479 .54914 m .50047 .54782 L .49318 .54483 L p F P
0 0 0 r
s
.44 .141 .066 r
.64394 .25187 m .63642 .24804 L .60901 .23527 L p F P
0 0 0 r
s
.35 .078 .032 r
.63642 .24804 m .64394 .25187 L .66994 .2685 L p F P
0 0 0 r
s
.83 .24 .1 r
.64319 .25402 m
.66004 .26366 L
s
.66004 .26366 m
.66952 .26847 L
s
.351 .078 .033 r
.45366 .52781 m .46202 .53037 L .47404 .53902 L p F P
0 0 0 r
s
.351 .078 .033 r
.48046 .54097 m .47404 .53902 L .46202 .53037 L p F P
0 0 0 r
s
.83 .24 .1 r
.45534 .52117 m
.47733 .5371 L
s
.47733 .5371 m
.49933 .54382 L
s
.24 .35 .67 r
.1579 .42639 m
.1923 .41902 L
s
.1579 .42639 m
.16388 .46001 L
s
.094 .113 .235 r
.59661 .52407 m .58499 .52593 L .59821 .51279 L p F P
0 0 0 r
s
.094 .113 .235 r
.59821 .51279 m .61214 .51052 L .59661 .52407 L p F P
0 0 0 r
s
.951 .288 .124 r
.5167 .21838 m .52492 .20853 L .52275 .20744 L closepath p F P
0 0 0 r
s
.951 .288 .124 r
.5167 .21838 m .52924 .21069 L .52708 .20961 L closepath p F P
0 0 0 r
s
.951 .288 .124 r
.5167 .21838 m .52708 .20961 L .52492 .20853 L closepath p F P
0 0 0 r
s
.951 .288 .124 r
.5167 .21838 m .53355 .21284 L .5314 .21176 L closepath p F P
0 0 0 r
s
.951 .288 .124 r
.5167 .21838 m .5314 .21176 L .52924 .21069 L closepath p F P
0 0 0 r
s
.951 .288 .124 r
.5167 .21838 m .53783 .21498 L .53569 .21391 L closepath p F P
0 0 0 r
s
.951 .288 .124 r
.5167 .21838 m .53569 .21391 L .53355 .21284 L closepath p F P
0 0 0 r
s
.951 .288 .124 r
.5167 .21838 m .54209 .2171 L .53996 .21604 L closepath p F P
0 0 0 r
s
.951 .288 .124 r
.5167 .21838 m .53996 .21604 L .53783 .21498 L closepath p F P
0 0 0 r
s
.951 .288 .124 r
.5167 .21838 m .54633 .21922 L .54421 .21817 L closepath p F P
0 0 0 r
s
.951 .288 .124 r
.5167 .21838 m .54421 .21817 L .54209 .2171 L closepath p F P
0 0 0 r
s
.951 .288 .124 r
.5167 .21838 m .54844 .22028 L .54633 .21922 L closepath p F P
0 0 0 r
s
1 .303 .129 r
.48495 .2203 m .48276 .21925 L .5167 .21838 L closepath p F P
0 0 0 r
s
1 .303 .129 r
.48276 .21925 m .48057 .21819 L .5167 .21838 L closepath p F P
0 0 0 r
s
.285 .435 .853 r
.48355 .21743 m .48057 .21819 L .5167 .21838 L closepath p F P
0 0 0 r
s
.285 .435 .853 r
.48653 .21667 m .48355 .21743 L .5167 .21838 L closepath p F P
0 0 0 r
s
.285 .435 .853 r
.48952 .21591 m .48653 .21667 L .5167 .21838 L closepath p F P
0 0 0 r
s
.285 .435 .853 r
.49251 .21515 m .48952 .21591 L .5167 .21838 L closepath p F P
0 0 0 r
s
.285 .435 .853 r
.49551 .21438 m .49251 .21515 L .5167 .21838 L closepath p F P
0 0 0 r
s
.285 .435 .853 r
.49852 .21362 m .49551 .21438 L .5167 .21838 L closepath p F P
0 0 0 r
s
.285 .435 .853 r
.50153 .21285 m .49852 .21362 L .5167 .21838 L closepath p F P
0 0 0 r
s
.285 .435 .853 r
.50455 .21208 m .50153 .21285 L .5167 .21838 L closepath p F P
0 0 0 r
s
.285 .435 .853 r
.50757 .21131 m .50455 .21208 L .5167 .21838 L closepath p F P
0 0 0 r
s
.285 .435 .853 r
.51059 .21054 m .50757 .21131 L .5167 .21838 L closepath p F P
0 0 0 r
s
.285 .435 .853 r
.51362 .20977 m .51059 .21054 L .5167 .21838 L closepath p F P
0 0 0 r
s
.285 .435 .853 r
.51666 .20899 m .51362 .20977 L .5167 .21838 L closepath p F P
0 0 0 r
s
.285 .435 .853 r
.5197 .20822 m .51666 .20899 L .5167 .21838 L closepath p F P
0 0 0 r
s
.285 .435 .853 r
.52275 .20744 m .5197 .20822 L .5167 .21838 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.50669 .21587 m
.52659 .22563 L
s
.83 .24 .1 r
.50286 .22425 m
.53065 .21727 L
s
.976 .272 .112 r
.35697 .41765 m .34207 .41247 L .34048 .38764 L p F P
0 0 0 r
s
.934 .258 .105 r
.34207 .41247 m .35697 .41765 L .36229 .44142 L p F P
0 0 0 r
s
.83 .24 .1 r
.3571 .3929 m
.35922 .42499 L
s
.35922 .42499 m
.38843 .43505 L
s
1 .31 .131 r
.48276 .21925 m .48495 .2203 L .45394 .226 L p F P
0 0 0 r
s
.831 .257 .112 r
.54633 .21922 m .54844 .22028 L .57946 .22595 L p F P
0 0 0 r
s
.24 .35 .67 r
.57489 .22465 m
.57545 .22514 L
s
.16388 .46001 m
.19836 .45302 L
s
1 .311 .13 r
.3829 .26861 m .3724 .26408 L .39699 .24813 L p F P
0 0 0 r
s
1 .308 .128 r
.3724 .26408 m .3829 .26861 L .36337 .2879 L p F P
0 0 0 r
s
.24 .35 .67 r
.44989 .55397 m
.47014 .5529 L
s
.47014 .5529 m
.50112 .54802 L
s
.83 .24 .1 r
.74729 .45901 m
.75554 .42598 L
s
.795 .213 .085 r
.40805 .49186 m .39618 .48808 L .38466 .46814 L p F P
0 0 0 r
s
.672 .175 .069 r
.39618 .48808 m .40805 .49186 L .42113 .50875 L p F P
0 0 0 r
s
.83 .24 .1 r
.39614 .46457 m
.40912 .49073 L
s
.672 .175 .069 r
.43138 .51193 m .42113 .50875 L .40805 .49186 L p F P
0 0 0 r
s
.83 .24 .1 r
.40912 .49073 m
.43754 .49978 L
s
.53 .131 .051 r
.66102 .26397 m .66994 .2685 L .69231 .28778 L p F P
0 0 0 r
s
.24 .35 .67 r
.6701 .26762 m
.67137 .26733 L
s
.35 .078 .032 r
.66994 .2685 m .66102 .26397 L .63642 .24804 L p F P
0 0 0 r
s
.157 .212 .431 r
.67366 .48583 m .65735 .48855 L .67078 .46867 L p F P
0 0 0 r
s
.157 .212 .431 r
.67078 .46867 m .68872 .46558 L .67366 .48583 L p F P
0 0 0 r
s
.24 .35 .67 r
.64037 .46639 m
.67974 .45954 L
s
.27707 .53349 m
.29731 .55278 L
s
.29731 .55278 m
.33329 .54681 L
s
.036 .047 .09 r
.52279 .54631 m .51677 .54726 L .5168 .544 L p F P
0 0 0 r
s
.036 .047 .09 r
.5168 .544 m .52554 .54262 L .52279 .54631 L p F P
0 0 0 r
s
1 .31 .131 r
.45394 .226 m .44953 .22392 L .48276 .21925 L p F P
0 0 0 r
s
1 .313 .132 r
.44953 .22392 m .45394 .226 L .42439 .23534 L p F P
0 0 0 r
s
.626 .202 .09 r
.57535 .22387 m .57946 .22595 L .60901 .23527 L p F P
0 0 0 r
s
.831 .257 .112 r
.57946 .22595 m .57535 .22387 L .54633 .21922 L p F P
0 0 0 r
s
.24 .35 .67 r
.52659 .22563 m
.54942 .21993 L
s
.176 .242 .491 r
.70685 .46246 m .68872 .46558 L .69949 .44337 L p F P
0 0 0 r
s
.176 .242 .491 r
.69949 .44337 m .71882 .43994 L .70685 .46246 L p F P
0 0 0 r
s
.063 .075 .143 r
.56092 .53704 m .55201 .53844 L .56197 .52961 L p F P
0 0 0 r
s
.063 .075 .143 r
.56197 .52961 m .57344 .52778 L .56092 .53704 L p F P
0 0 0 r
s
.24 .35 .67 r
.39128 .55384 m
.41261 .55987 L
s
.41261 .55987 m
.44989 .55397 L
s
.51 .125 .049 r
.42113 .50875 m .43138 .51193 L .44523 .52523 L p F P
0 0 0 r
s
.51 .125 .049 r
.45366 .52781 m .44523 .52523 L .43138 .51193 L p F P
0 0 0 r
s
1 .31 .131 r
.48057 .21819 m .48276 .21925 L .44953 .22392 L p F P
0 0 0 r
s
.131 .17 .349 r
.64033 .50592 m .62618 .50823 L .64118 .49126 L p F P
0 0 0 r
s
.131 .17 .349 r
.64118 .49126 m .65735 .48855 L .64033 .50592 L p F P
0 0 0 r
s
.831 .257 .112 r
.54421 .21817 m .54633 .21922 L .57535 .22387 L p F P
0 0 0 r
s
.24 .35 .67 r
.5513 .21947 m
.55303 .21903 L
s
.877 .239 .097 r
.38466 .46814 m .37141 .46381 L .36229 .44142 L p F P
0 0 0 r
s
.795 .213 .085 r
.37141 .46381 m .38466 .46814 L .39618 .48808 L p F P
0 0 0 r
s
.83 .24 .1 r
.709 .48087 m
.73328 .49022 L
s
.73328 .49022 m
.74729 .45901 L
s
.24 .35 .67 r
.33329 .54681 m
.35463 .55974 L
s
.35463 .55974 m
.39128 .55384 L
s
1 .291 .12 r
.34317 .3627 m .32814 .35709 L .33564 .33266 L p F P
0 0 0 r
s
1 .283 .116 r
.32814 .35709 m .34317 .3627 L .34048 .38764 L p F P
0 0 0 r
s
.978 .272 .11 r
.73267 .35695 m .7446 .36257 L .74812 .38751 L p F P
0 0 0 r
s
.918 .252 .101 r
.7446 .36257 m .73267 .35695 L .72408 .33252 L p F P
0 0 0 r
s
.24 .35 .67 r
.74105 .35434 m
.76346 .34986 L
s
1 .308 .128 r
.36337 .2879 m .3512 .28284 L .3724 .26408 L p F P
0 0 0 r
s
1 .304 .126 r
.3512 .28284 m .36337 .2879 L .34749 .30942 L p F P
0 0 0 r
s
.83 .24 .1 r
.35351 .28404 m
.38299 .29631 L
s
.696 .182 .07 r
.68222 .28271 m .69231 .28778 L .71051 .30929 L p F P
0 0 0 r
s
.24 .35 .67 r
.69469 .26202 m
.70718 .29214 L
s
.53 .131 .051 r
.69231 .28778 m .68222 .28271 L .66102 .26397 L p F P
0 0 0 r
s
.24 .35 .67 r
.67137 .26733 m
.69469 .26202 L
s
1 .313 .132 r
.42439 .23534 m .4178 .23232 L .44953 .22392 L p F P
0 0 0 r
s
1 .313 .131 r
.4178 .23232 m .42439 .23534 L .39699 .24813 L p F P
0 0 0 r
s
.44 .141 .066 r
.60307 .23225 m .60901 .23527 L .63642 .24804 L p F P
0 0 0 r
s
.626 .202 .09 r
.60901 .23527 m .60307 .23225 L .57535 .22387 L p F P
0 0 0 r
s
.24 .35 .67 r
.69469 .26202 m
.73515 .2528 L
s
.191 .266 .537 r
.73835 .43647 m .71882 .43994 L .72579 .41606 L p F P
0 0 0 r
s
.24 .35 .67 r
.72464 .42319 m
.72562 .39126 L
s
.68464 .43046 m
.72464 .42319 L
s
.191 .266 .537 r
.72579 .41606 m .74604 .41234 L .73835 .43647 L p F P
0 0 0 r
s
.24 .35 .67 r
.19499 .35342 m
.2299 .34522 L
s
.19499 .35342 m
.19117 .38525 L
s
1 .31 .131 r
.44953 .22392 m .44511 .22184 L .48057 .21819 L p F P
0 0 0 r
s
.269 .419 .815 r
.48057 .21819 m .48355 .21743 L .45095 .22034 L p F P
0 0 0 r
s
.269 .419 .815 r
.45095 .22034 m .44511 .22184 L .48057 .21819 L p F P
0 0 0 r
s
.831 .257 .112 r
.57535 .22387 m .57122 .22179 L .54421 .21817 L p F P
0 0 0 r
s
.831 .257 .112 r
.54209 .2171 m .54421 .21817 L .57122 .22179 L p F P
0 0 0 r
s
.214 .05 .021 r
.48046 .54097 m .48684 .54291 L .49612 .54651 L p F P
0 0 0 r
s
.214 .05 .021 r
.50047 .54782 m .49612 .54651 L .48684 .54291 L p F P
0 0 0 r
s
.036 .047 .09 r
.52883 .54536 m .52279 .54631 L .52554 .54262 L p F P
0 0 0 r
s
.036 .047 .09 r
.52554 .54262 m .53432 .54124 L .52883 .54536 L p F P
0 0 0 r
s
1 .313 .132 r
.44511 .22184 m .44953 .22392 L .4178 .23232 L p F P
0 0 0 r
s
.83 .24 .1 r
.42316 .24384 m
.44813 .22445 L
s
.44813 .22445 m
.47607 .23759 L
s
.24 .35 .67 r
.4118 .23207 m
.43178 .22695 L
s
.626 .202 .09 r
.57122 .22179 m .57535 .22387 L .60307 .23225 L p F P
0 0 0 r
s
.269 .419 .815 r
.48355 .21743 m .48653 .21667 L .45682 .21884 L p F P
0 0 0 r
s
.269 .419 .815 r
.45682 .21884 m .45095 .22034 L .48355 .21743 L p F P
0 0 0 r
s
.094 .113 .235 r
.60831 .5222 m .59661 .52407 L .61214 .51052 L p F P
0 0 0 r
s
.094 .113 .235 r
.61214 .51052 m .62618 .50823 L .60831 .5222 L p F P
0 0 0 r
s
1 .313 .131 r
.39699 .24813 m .3883 .24427 L .4178 .23232 L p F P
0 0 0 r
s
1 .311 .13 r
.3883 .24427 m .39699 .24813 L .3724 .26408 L p F P
0 0 0 r
s
.44 .141 .066 r
.63642 .24804 m .62883 .24417 L .60307 .23225 L p F P
0 0 0 r
s
.35 .078 .032 r
.62883 .24417 m .63642 .24804 L .66102 .26397 L p F P
0 0 0 r
s
.831 .257 .112 r
.57122 .22179 m .56708 .21969 L .54209 .2171 L p F P
0 0 0 r
s
.831 .257 .112 r
.53996 .21604 m .54209 .2171 L .56708 .21969 L p F P
0 0 0 r
s
.83 .24 .1 r
.53065 .21727 m
.54672 .22524 L
s
1 .304 .126 r
.34749 .30942 m .33394 .30397 L .3512 .28284 L p F P
0 0 0 r
s
1 .298 .123 r
.33394 .30397 m .34749 .30942 L .33564 .33266 L p F P
0 0 0 r
s
.83 .24 .1 r
.33959 .31552 m
.36926 .32731 L
s
.934 .258 .105 r
.36229 .44142 m .34793 .43659 L .34207 .41247 L p F P
0 0 0 r
s
.877 .239 .097 r
.34793 .43659 m .36229 .44142 L .37141 .46381 L p F P
0 0 0 r
s
.83 .24 .1 r
.35922 .42499 m
.36685 .4549 L
s
.83 .224 .089 r
.69949 .30384 m .71051 .30929 L .72408 .33252 L p F P
0 0 0 r
s
.696 .182 .07 r
.71051 .30929 m .69949 .30384 L .68222 .28271 L p F P
0 0 0 r
s
.24 .35 .67 r
.70718 .29214 m
.7476 .2833 L
s
.351 .078 .033 r
.44523 .52523 m .45366 .52781 L .46757 .53706 L p F P
0 0 0 r
s
.351 .078 .033 r
.47404 .53902 m .46757 .53706 L .45366 .52781 L p F P
0 0 0 r
s
.269 .419 .815 r
.48653 .21667 m .48952 .21591 L .46271 .21733 L p F P
0 0 0 r
s
.269 .419 .815 r
.46271 .21733 m .45682 .21884 L .48653 .21667 L p F P
0 0 0 r
s
.063 .075 .143 r
.56988 .53562 m .56092 .53704 L .57344 .52778 L p F P
0 0 0 r
s
.063 .075 .143 r
.57344 .52778 m .58499 .52593 L .56988 .53562 L p F P
0 0 0 r
s
1 .283 .116 r
.34048 .38764 m .3252 .38214 L .32814 .35709 L p F P
0 0 0 r
s
.976 .272 .112 r
.3252 .38214 m .34048 .38764 L .34207 .41247 L p F P
0 0 0 r
s
.978 .272 .11 r
.74812 .38751 m .73604 .382 L .73267 .35695 L p F P
0 0 0 r
s
1 .286 .117 r
.73604 .382 m .74812 .38751 L .74604 .41234 L p F P
0 0 0 r
s
.24 .35 .67 r
.74728 .38713 m
.7663 .3835 L
s
.72562 .39126 m
.73829 .38884 L
s
.83 .24 .1 r
.6141 .54207 m
.63992 .55052 L
s
.63992 .55052 m
.66627 .53277 L
s
.24 .35 .67 r
.20905 .48551 m
.22379 .51484 L
s
.22379 .51484 m
.2591 .50842 L
s
.831 .257 .112 r
.56708 .21969 m .56291 .21759 L .53996 .21604 L p F P
0 0 0 r
s
.24 .35 .67 r
.56489 .21608 m
.57175 .22196 L
s
.831 .257 .112 r
.53783 .21498 m .53996 .21604 L .56291 .21759 L p F P
0 0 0 r
s
.24 .35 .67 r
.56004 .21729 m
.56489 .21608 L
s
.83 .24 .1 r
.53027 .54948 m
.55739 .55781 L
s
.55739 .55781 m
.58587 .55347 L
s
.269 .419 .815 r
.48952 .21591 m .49251 .21515 L .46861 .21581 L p F P
0 0 0 r
s
.269 .419 .815 r
.46861 .21581 m .46271 .21733 L .48952 .21591 L p F P
0 0 0 r
s
.24 .35 .67 r
.48403 .22161 m
.50669 .21587 L
s
.83 .24 .1 r
.48636 .21626 m
.50286 .22425 L
s
.157 .212 .431 r
.69013 .48308 m .67366 .48583 L .68872 .46558 L p F P
0 0 0 r
s
.24 .35 .67 r
.6712 .4849 m
.67974 .45954 L
s
.157 .212 .431 r
.68872 .46558 m .70685 .46246 L .69013 .48308 L p F P
0 0 0 r
s
1 .313 .132 r
.4178 .23232 m .41115 .22928 L .44511 .22184 L p F P
0 0 0 r
s
1 .313 .131 r
.41115 .22928 m .4178 .23232 L .3883 .24427 L p F P
0 0 0 r
s
.24 .35 .67 r
.39222 .23637 m
.40443 .23369 L
s
.215 .346 .663 r
.44511 .22184 m .45095 .22034 L .41969 .22708 L p F P
0 0 0 r
s
.83 .24 .1 r
.44813 .22445 m
.458 .21947 L
s
.24 .35 .67 r
.44887 .22258 m
.45632 .22363 L
s
.215 .346 .663 r
.41969 .22708 m .41115 .22928 L .44511 .22184 L p F P
0 0 0 r
s
.83 .24 .1 r
.44319 .22213 m
.44813 .22445 L
s
.24 .35 .67 r
.44237 .22424 m
.44887 .22258 L
s
.44 .141 .066 r
.59708 .2292 m .60307 .23225 L .62883 .24417 L p F P
0 0 0 r
s
.24 .35 .67 r
.59489 .22956 m
.59589 .22931 L
s
.626 .202 .09 r
.60307 .23225 m .59708 .2292 L .57122 .22179 L p F P
0 0 0 r
s
.83 .24 .1 r
.58479 .23043 m
.61096 .23722 L
s
.036 .047 .09 r
.53489 .54441 m .52883 .54536 L .53432 .54124 L p F P
0 0 0 r
s
.036 .047 .09 r
.53432 .54124 m .54314 .53984 L .53489 .54441 L p F P
0 0 0 r
s
.626 .202 .09 r
.56708 .21969 m .57122 .22179 L .59708 .2292 L p F P
0 0 0 r
s
.24 .35 .67 r
.59677 .2291 m
.62273 .22278 L
s
1 .311 .13 r
.3724 .26408 m .36178 .25951 L .3883 .24427 L p F P
0 0 0 r
s
.24 .35 .67 r
.35574 .24571 m
.39222 .23637 L
s
1 .308 .128 r
.36178 .25951 m .3724 .26408 L .3512 .28284 L p F P
0 0 0 r
s
.53 .131 .051 r
.652 .25939 m .66102 .26397 L .68222 .28271 L p F P
0 0 0 r
s
.35 .078 .032 r
.66102 .26397 m .652 .25939 L .62883 .24417 L p F P
0 0 0 r
s
.83 .24 .1 r
.61096 .23722 m
.63142 .24762 L
s
.24 .35 .67 r
.62273 .22278 m
.63996 .24468 L
s
.131 .17 .349 r
.6546 .5036 m .64033 .50592 L .65735 .48855 L p F P
0 0 0 r
s
.131 .17 .349 r
.65735 .48855 m .67366 .48583 L .6546 .5036 L p F P
0 0 0 r
s
.24 .35 .67 r
.63157 .49154 m
.6712 .4849 L
s
.23822 .31664 m
.27374 .308 L
s
.23822 .31664 m
.2299 .34522 L
s
.269 .419 .815 r
.49251 .21515 m .49551 .21438 L .47454 .21429 L p F P
0 0 0 r
s
.269 .419 .815 r
.47454 .21429 m .46861 .21581 L .49251 .21515 L p F P
0 0 0 r
s
.214 .05 .021 r
.47404 .53902 m .48046 .54097 L .49175 .54518 L p F P
0 0 0 r
s
.214 .05 .021 r
.49612 .54651 m .49175 .54518 L .48046 .54097 L p F P
0 0 0 r
s
.831 .257 .112 r
.56291 .21759 m .55872 .21547 L .53783 .21498 L p F P
0 0 0 r
s
.831 .257 .112 r
.53569 .21391 m .53783 .21498 L .55872 .21547 L p F P
0 0 0 r
s
.176 .242 .491 r
.72516 .45931 m .70685 .46246 L .71882 .43994 L p F P
0 0 0 r
s
.176 .242 .491 r
.71882 .43994 m .73835 .43647 L .72516 .45931 L p F P
0 0 0 r
s
.24 .35 .67 r
.71998 .45253 m
.72464 .42319 L
s
1 .298 .123 r
.33564 .33266 m .32105 .327 L .33394 .30397 L p F P
0 0 0 r
s
1 .291 .12 r
.32105 .327 m .33564 .33266 L .32814 .35709 L p F P
0 0 0 r
s
.83 .24 .1 r
.33066 .34862 m
.36051 .35992 L
s
.24 .35 .67 r
.62273 .22278 m
.66256 .21309 L
s
.918 .252 .101 r
.71238 .32686 m .72408 .33252 L .73267 .35695 L p F P
0 0 0 r
s
.83 .24 .1 r
.7239 .33232 m
.72395 .33246 L
s
.83 .224 .089 r
.72408 .33252 m .71238 .32686 L .69949 .30384 L p F P
0 0 0 r
s
.795 .213 .085 r
.39618 .48808 m .38416 .48426 L .37141 .46381 L p F P
0 0 0 r
s
.83 .24 .1 r
.36685 .4549 m
.39614 .46457 L
s
.672 .175 .069 r
.38416 .48426 m .39618 .48808 L .41077 .50552 L p F P
0 0 0 r
s
.672 .175 .069 r
.42113 .50875 m .41077 .50552 L .39618 .48808 L p F P
0 0 0 r
s
.51 .125 .049 r
.41077 .50552 m .42113 .50875 L .43672 .52262 L p F P
0 0 0 r
s
.51 .125 .049 r
.44523 .52523 m .43672 .52262 L .42113 .50875 L p F P
0 0 0 r
s
.83 .24 .1 r
.42696 .51237 m
.45534 .52117 L
s
.40912 .49073 m
.42696 .51237 L
s
.24 .35 .67 r
.76346 .34986 m
.75715 .31605 L
s
.75715 .31605 m
.7985 .30739 L
s
.75715 .31605 m
.7476 .2833 L
s
.269 .419 .815 r
.49551 .21438 m .49852 .21362 L .48049 .21277 L p F P
0 0 0 r
s
.269 .419 .815 r
.48049 .21277 m .47454 .21429 L .49551 .21438 L p F P
0 0 0 r
s
.83 .24 .1 r
.47514 .21082 m
.47962 .21299 L
s
.24 .35 .67 r
.7663 .3835 m
.76346 .34986 L
s
.76346 .34986 m
.8049 .34158 L
s
.215 .346 .663 r
.45095 .22034 m .45682 .21884 L .42828 .22488 L p F P
0 0 0 r
s
.215 .346 .663 r
.42828 .22488 m .41969 .22708 L .45095 .22034 L p F P
0 0 0 r
s
.83 .24 .1 r
.44151 .22134 m
.44259 .22185 L
s
.831 .257 .112 r
.55872 .21547 m .55452 .21335 L .53569 .21391 L p F P
0 0 0 r
s
.831 .257 .112 r
.53355 .21284 m .53569 .21391 L .55452 .21335 L p F P
0 0 0 r
s
.83 .24 .1 r
.33959 .31552 m
.35351 .28404 L
s
.33066 .34862 m
.33959 .31552 L
s
.094 .113 .235 r
.62008 .52032 m .60831 .5222 L .62618 .50823 L p F P
0 0 0 r
s
.24 .35 .67 r
.5803 .51825 m
.61935 .51191 L
s
.094 .113 .235 r
.62618 .50823 m .64033 .50592 L .62008 .52032 L p F P
0 0 0 r
s
.24 .35 .67 r
.61935 .51191 m
.63157 .49154 L
s
.063 .075 .143 r
.57889 .5342 m .56988 .53562 L .58499 .52593 L p F P
0 0 0 r
s
.063 .075 .143 r
.58499 .52593 m .59661 .52407 L .57889 .5342 L p F P
0 0 0 r
s
.24 .35 .67 r
.56478 .53279 m
.5803 .51825 L
s
.976 .272 .112 r
.34207 .41247 m .32694 .4072 L .3252 .38214 L p F P
0 0 0 r
s
.934 .258 .105 r
.32694 .4072 m .34207 .41247 L .34793 .43659 L p F P
0 0 0 r
s
.24 .35 .67 r
.19117 .38525 m
.22623 .37737 L
s
.19117 .38525 m
.1923 .41902 L
s
.269 .419 .815 r
.49852 .21362 m .50153 .21285 L .48646 .21124 L p F P
0 0 0 r
s
.269 .419 .815 r
.48646 .21124 m .48049 .21277 L .49852 .21362 L p F P
0 0 0 r
s
.24 .35 .67 r
.48676 .21288 m
.50669 .21587 L
s
.28602 .28411 m
.27374 .308 L
s
1 .297 .122 r
.73405 .40707 m .74604 .41234 L .73835 .43647 L p F P
0 0 0 r
s
.24 .35 .67 r
.74293 .41986 m
.76553 .41575 L
s
.72464 .42319 m
.7361 .4211 L
s
.83 .24 .1 r
.74337 .42072 m
.75554 .42598 L
s
1 .286 .117 r
.74604 .41234 m .73405 .40707 L .73604 .382 L p F P
0 0 0 r
s
.626 .202 .09 r
.59708 .2292 m .59105 .22614 L .56708 .21969 L p F P
0 0 0 r
s
.626 .202 .09 r
.56291 .21759 m .56708 .21969 L .59105 .22614 L p F P
0 0 0 r
s
1 .308 .128 r
.3512 .28284 m .33888 .27771 L .36178 .25951 L p F P
0 0 0 r
s
1 .304 .126 r
.33888 .27771 m .3512 .28284 L .33394 .30397 L p F P
0 0 0 r
s
.036 .047 .09 r
.54097 .54346 m .53489 .54441 L .54314 .53984 L p F P
0 0 0 r
s
.036 .047 .09 r
.54314 .53984 m .55201 .53844 L .54097 .54346 L p F P
0 0 0 r
s
.24 .35 .67 r
.5263 .53891 m
.56478 .53279 L
s
1 .313 .131 r
.3883 .24427 m .37954 .24036 L .41115 .22928 L p F P
0 0 0 r
s
1 .311 .13 r
.37954 .24036 m .3883 .24427 L .36178 .25951 L p F P
0 0 0 r
s
.83 .24 .1 r
.35351 .28404 m
.37192 .25539 L
s
.37192 .25539 m
.40118 .26812 L
s
.696 .182 .07 r
.672 .27758 m .68222 .28271 L .69949 .30384 L p F P
0 0 0 r
s
.83 .24 .1 r
.6691 .27259 m
.6764 .27979 L
s
.53 .131 .051 r
.68222 .28271 m .672 .27758 L .652 .25939 L p F P
0 0 0 r
s
.24 .35 .67 r
.67964 .23531 m
.69469 .26202 L
s
.877 .239 .097 r
.37141 .46381 m .35797 .45942 L .34793 .43659 L p F P
0 0 0 r
s
.795 .213 .085 r
.35797 .45942 m .37141 .46381 L .38416 .48426 L p F P
0 0 0 r
s
.44 .141 .066 r
.62883 .24417 m .62117 .24027 L .59708 .2292 L p F P
0 0 0 r
s
.35 .078 .032 r
.62117 .24027 m .62883 .24417 L .652 .25939 L p F P
0 0 0 r
s
.24 .35 .67 r
.63996 .24468 m
.67964 .23531 L
s
.269 .419 .815 r
.50153 .21285 m .50455 .21208 L .49245 .2097 L p F P
0 0 0 r
s
.269 .419 .815 r
.49245 .2097 m .48646 .21124 L .50153 .21285 L p F P
0 0 0 r
s
.831 .257 .112 r
.55452 .21335 m .55029 .21121 L .53355 .21284 L p F P
0 0 0 r
s
.831 .257 .112 r
.5314 .21176 m .53355 .21284 L .55029 .21121 L p F P
0 0 0 r
s
.24 .35 .67 r
.7476 .2833 m
.78893 .27426 L
s
.7476 .2833 m
.73515 .2528 L
s
.351 .078 .033 r
.43672 .52262 m .44523 .52523 L .46106 .53508 L p F P
0 0 0 r
s
.351 .078 .033 r
.46757 .53706 m .46106 .53508 L .44523 .52523 L p F P
0 0 0 r
s
.24 .35 .67 r
.67964 .23531 m
.72021 .22573 L
s
.67964 .23531 m
.66256 .21309 L
s
.215 .346 .663 r
.45682 .21884 m .46271 .21733 L .4369 .22266 L p F P
0 0 0 r
s
.215 .346 .663 r
.4369 .22266 m .42828 .22488 L .45682 .21884 L p F P
0 0 0 r
s
.024 .035 .067 r
.41115 .22928 m .41969 .22708 L .39054 .23755 L p F P
0 0 0 r
s
.024 .035 .067 r
.39054 .23755 m .37954 .24036 L .41115 .22928 L p F P
0 0 0 r
s
.83 .24 .1 r
.40101 .23379 m
.42316 .24384 L
s
1 .291 .12 r
.32814 .35709 m .31288 .35139 L .32105 .327 L p F P
0 0 0 r
s
1 .283 .116 r
.31288 .35139 m .32814 .35709 L .3252 .38214 L p F P
0 0 0 r
s
.83 .24 .1 r
.3271 .38208 m
.33066 .34862 L
s
.3271 .38208 m
.3571 .3929 L
s
.24 .35 .67 r
.2591 .50842 m
.27707 .53349 L
s
.27707 .53349 m
.31314 .52725 L
s
.44 .141 .066 r
.59105 .22614 m .59708 .2292 L .62117 .24027 L p F P
0 0 0 r
s
.24 .35 .67 r
.19836 .45302 m
.20905 .48551 L
s
.20905 .48551 m
.24435 .47873 L
s
.978 .272 .11 r
.72056 .35125 m .73267 .35695 L .73604 .382 L p F P
0 0 0 r
s
.83 .24 .1 r
.73031 .35345 m
.73063 .35599 L
s
.918 .252 .101 r
.73267 .35695 m .72056 .35125 L .71238 .32686 L p F P
0 0 0 r
s
.269 .419 .815 r
.50455 .21208 m .50757 .21131 L .49846 .20816 L p F P
0 0 0 r
s
.269 .419 .815 r
.49846 .20816 m .49245 .2097 L .50455 .21208 L p F P
0 0 0 r
s
.214 .05 .021 r
.46757 .53706 m .47404 .53902 L .48736 .54385 L p F P
0 0 0 r
s
.214 .05 .021 r
.49175 .54518 m .48736 .54385 L .47404 .53902 L p F P
0 0 0 r
s
.83 .24 .1 r
.47733 .5371 m
.50265 .54674 L
s
.831 .257 .112 r
.55029 .21121 m .54604 .20906 L .5314 .21176 L p F P
0 0 0 r
s
.831 .257 .112 r
.52924 .21069 m .5314 .21176 L .54604 .20906 L p F P
0 0 0 r
s
.24 .35 .67 r
.8079 .37558 m
.7663 .3835 L
s
.76553 .41575 m
.7663 .3835 L
s
.195 .318 .617 r
.51365 .54685 m .51058 .54733 L .50479 .54914 L p F P
0 0 0 r
s
.195 .318 .617 r
.50479 .54914 m .51077 .5482 L .51365 .54685 L p F P
0 0 0 r
s
.24 .35 .67 r
.50803 .54693 m
.5263 .53891 L
s
.614 .201 .088 r
.50047 .54782 m .50479 .54914 L .51058 .54733 L p F P
0 0 0 r
s
.24 .35 .67 r
.50324 .54769 m
.50803 .54693 L
s
.83 .24 .1 r
.50265 .54674 m
.50543 .54758 L
s
.131 .17 .349 r
.66898 .50125 m .6546 .5036 L .67366 .48583 L p F P
0 0 0 r
s
.131 .17 .349 r
.67366 .48583 m .69013 .48308 L .66898 .50125 L p F P
0 0 0 r
s
.269 .419 .815 r
.50757 .21131 m .51059 .21054 L .50449 .20661 L p F P
0 0 0 r
s
.269 .419 .815 r
.50449 .20661 m .49846 .20816 L .50757 .21131 L p F P
0 0 0 r
s
.83 .24 .1 r
.66627 .53277 m
.68969 .50919 L
s
.157 .212 .431 r
.70674 .4803 m .69013 .48308 L .70685 .46246 L p F P
0 0 0 r
s
.157 .212 .431 r
.70685 .46246 m .72516 .45931 L .70674 .4803 L p F P
0 0 0 r
s
.24 .35 .67 r
.67974 .45954 m
.71998 .45253 L
s
.626 .202 .09 r
.59105 .22614 m .58498 .22305 L .56291 .21759 L p F P
0 0 0 r
s
.626 .202 .09 r
.55872 .21547 m .56291 .21759 L .58498 .22305 L p F P
0 0 0 r
s
.24 .35 .67 r
.1923 .41902 m
.22748 .41149 L
s
.1923 .41902 m
.19836 .45302 L
s
.036 .047 .09 r
.54708 .5425 m .54097 .54346 L .55201 .53844 L p F P
0 0 0 r
s
.036 .047 .09 r
.55201 .53844 m .56092 .53704 L .54708 .5425 L p F P
0 0 0 r
s
1 .304 .126 r
.33394 .30397 m .3202 .29845 L .33888 .27771 L p F P
0 0 0 r
s
1 .298 .123 r
.3202 .29845 m .33394 .30397 L .32105 .327 L p F P
0 0 0 r
s
.215 .346 .663 r
.46271 .21733 m .46861 .21581 L .44558 .22044 L p F P
0 0 0 r
s
.83 .24 .1 r
.46193 .21749 m
.46199 .21746 L
s
.46302 .21693 m
.47514 .21082 L
s
.215 .346 .663 r
.44558 .22044 m .4369 .22266 L .46271 .21733 L p F P
0 0 0 r
s
.063 .075 .143 r
.58794 .53277 m .57889 .5342 L .59661 .52407 L p F P
0 0 0 r
s
.063 .075 .143 r
.59661 .52407 m .60831 .5222 L .58794 .53277 L p F P
0 0 0 r
s
.83 .224 .089 r
.68832 .29832 m .69949 .30384 L .71238 .32686 L p F P
0 0 0 r
s
.696 .182 .07 r
.69949 .30384 m .68832 .29832 L .672 .27758 L p F P
0 0 0 r
s
.831 .257 .112 r
.54604 .20906 m .54177 .20691 L .52924 .21069 L p F P
0 0 0 r
s
.24 .35 .67 r
.54186 .20695 m
.5452 .2061 L
s
.831 .257 .112 r
.52708 .20961 m .52924 .21069 L .54177 .20691 L p F P
0 0 0 r
s
1 .311 .13 r
.36178 .25951 m .35104 .25488 L .37954 .24036 L p F P
0 0 0 r
s
1 .308 .128 r
.35104 .25488 m .36178 .25951 L .33888 .27771 L p F P
0 0 0 r
s
.24 .35 .67 r
.19836 .45302 m
.23362 .44587 L
s
.269 .419 .815 r
.51059 .21054 m .51362 .20977 L .51055 .20506 L p F P
0 0 0 r
s
.269 .419 .815 r
.51055 .20506 m .50449 .20661 L .51059 .21054 L p F P
0 0 0 r
s
.83 .24 .1 r
.50314 .20361 m
.50758 .20582 L
s
.24 .35 .67 r
.50669 .21587 m
.52965 .21005 L
s
.53 .131 .051 r
.64287 .25477 m .652 .25939 L .672 .27758 L p F P
0 0 0 r
s
.35 .078 .032 r
.652 .25939 m .64287 .25477 L .62117 .24027 L p F P
0 0 0 r
s
.934 .258 .105 r
.34793 .43659 m .33335 .43168 L .32694 .4072 L p F P
0 0 0 r
s
.877 .239 .097 r
.33335 .43168 m .34793 .43659 L .35797 .45942 L p F P
0 0 0 r
s
.094 .113 .235 r
.63194 .51842 m .62008 .52032 L .64033 .50592 L p F P
0 0 0 r
s
.094 .113 .235 r
.64033 .50592 m .6546 .5036 L .63194 .51842 L p F P
0 0 0 r
s
1 .306 .126 r
.7267 .43156 m .73835 .43647 L .72516 .45931 L p F P
0 0 0 r
s
.83 .24 .1 r
.72953 .45174 m
.74729 .45901 L
s
1 .297 .122 r
.73835 .43647 m .7267 .43156 L .73405 .40707 L p F P
0 0 0 r
s
.83 .24 .1 r
.44654 .19696 m
.47514 .21082 L
s
.24 .35 .67 r
.31314 .52725 m
.33329 .54681 L
s
.33329 .54681 m
.37007 .54071 L
s
.024 .035 .067 r
.41969 .22708 m .42828 .22488 L .40161 .23472 L p F P
0 0 0 r
s
.024 .035 .067 r
.40161 .23472 m .39054 .23755 L .41969 .22708 L p F P
0 0 0 r
s
.83 .24 .1 r
.39412 .23067 m
.40003 .23335 L
s
.24 .35 .67 r
.72917 .45093 m
.76113 .44537 L
s
.71998 .45253 m
.72559 .45155 L
s
.195 .318 .617 r
.51673 .54636 m .51365 .54685 L .51077 .5482 L p F P
0 0 0 r
s
.195 .318 .617 r
.51077 .5482 m .51677 .54726 L .51673 .54636 L p F P
0 0 0 r
s
.83 .24 .1 r
.51273 .54774 m
.51565 .54803 L
s
.51565 .54803 m
.53027 .54948 L
s
.269 .419 .815 r
.51362 .20977 m .51666 .20899 L .51662 .2035 L p F P
0 0 0 r
s
.269 .419 .815 r
.51662 .2035 m .51055 .20506 L .51362 .20977 L p F P
0 0 0 r
s
1 .283 .116 r
.3252 .38214 m .30968 .37654 L .31288 .35139 L p F P
0 0 0 r
s
.976 .272 .112 r
.30968 .37654 m .3252 .38214 L .32694 .4072 L p F P
0 0 0 r
s
.24 .35 .67 r
.42875 .54781 m
.44989 .55397 L
s
.44989 .55397 m
.48801 .54795 L
s
.672 .175 .069 r
.41077 .50552 m .40029 .50227 L .38416 .48426 L p F P
0 0 0 r
s
.51 .125 .049 r
.40029 .50227 m .41077 .50552 L .42813 .51999 L p F P
0 0 0 r
s
.51 .125 .049 r
.43672 .52262 m .42813 .51999 L .41077 .50552 L p F P
0 0 0 r
s
.831 .257 .112 r
.54177 .20691 m .53748 .20474 L .52708 .20961 L p F P
0 0 0 r
s
.831 .257 .112 r
.52492 .20853 m .52708 .20961 L .53748 .20474 L p F P
0 0 0 r
s
.83 .24 .1 r
.51427 .20914 m
.53065 .21727 L
s
.978 .272 .11 r
.73604 .382 m .72376 .3764 L .72056 .35125 L p F P
0 0 0 r
s
1 .286 .117 r
.72376 .3764 m .73604 .382 L .73405 .40707 L p F P
0 0 0 r
s
.24 .35 .67 r
.37007 .54071 m
.39128 .55384 L
s
.39128 .55384 m
.42875 .54781 L
s
.215 .346 .663 r
.46861 .21581 m .47454 .21429 L .45429 .2182 L p F P
0 0 0 r
s
.215 .346 .663 r
.45429 .2182 m .44558 .22044 L .46861 .21581 L p F P
0 0 0 r
s
.44 .141 .066 r
.62117 .24027 m .61344 .23633 L .59105 .22614 L p F P
0 0 0 r
s
.44 .141 .066 r
.58498 .22305 m .59105 .22614 L .61344 .23633 L p F P
0 0 0 r
s
.614 .201 .088 r
.49612 .54651 m .50047 .54782 L .50837 .54666 L p F P
0 0 0 r
s
.24 .35 .67 r
.48801 .54795 m
.49863 .54741 L
s
.614 .201 .088 r
.51058 .54733 m .50837 .54666 L .50047 .54782 L p F P
0 0 0 r
s
.24 .35 .67 r
.49863 .54741 m
.50074 .5473 L
s
.054 .065 .125 r
.37954 .24036 m .39054 .23755 L .36422 .25154 L p F P
0 0 0 r
s
.83 .24 .1 r
.38872 .23668 m
.39412 .23067 L
s
.38775 .23777 m
.38872 .23668 L
s
.37192 .25539 m
.38557 .24019 L
s
.054 .065 .125 r
.36422 .25154 m .35104 .25488 L .37954 .24036 L p F P
0 0 0 r
s
.83 .24 .1 r
.3635 .25172 m
.37192 .25539 L
s
.24 .35 .67 r
.33764 .25705 m
.35586 .25243 L
s
.626 .202 .09 r
.58498 .22305 m .57887 .21994 L .55872 .21547 L p F P
0 0 0 r
s
.626 .202 .09 r
.55452 .21335 m .55872 .21547 L .57887 .21994 L p F P
0 0 0 r
s
.83 .24 .1 r
.55831 .21707 m
.58479 .23043 L
s
.53065 .21727 m
.55831 .21707 L
s
.795 .213 .085 r
.38416 .48426 m .37199 .48039 L .35797 .45942 L p F P
0 0 0 r
s
.672 .175 .069 r
.37199 .48039 m .38416 .48426 L .40029 .50227 L p F P
0 0 0 r
s
.83 .24 .1 r
.37981 .48139 m
.40912 .49073 L
s
.35 .078 .032 r
.61344 .23633 m .62117 .24027 L .64287 .25477 L p F P
0 0 0 r
s
.83 .24 .1 r
.61096 .23722 m
.63466 .25079 L
s
.269 .419 .815 r
.51666 .20899 m .5197 .20822 L .52272 .20194 L p F P
0 0 0 r
s
.269 .419 .815 r
.52272 .20194 m .51662 .2035 L .51666 .20899 L p F P
0 0 0 r
s
.83 .24 .1 r
.55898 .54501 m
.58587 .55347 L
s
.58587 .55347 m
.6141 .54207 L
s
.214 .05 .021 r
.46106 .53508 m .46757 .53706 L .48295 .54252 L p F P
0 0 0 r
s
.214 .05 .021 r
.48736 .54385 m .48295 .54252 L .46757 .53706 L p F P
0 0 0 r
s
.24 .35 .67 r
.73515 .2528 m
.77652 .24338 L
s
.73515 .2528 m
.72021 .22573 L
s
.036 .047 .09 r
.5532 .54154 m .54708 .5425 L .56092 .53704 L p F P
0 0 0 r
s
.036 .047 .09 r
.56092 .53704 m .56988 .53562 L .5532 .54154 L p F P
0 0 0 r
s
.351 .078 .033 r
.42813 .51999 m .43672 .52262 L .45449 .53309 L p F P
0 0 0 r
s
.351 .078 .033 r
.46106 .53508 m .45449 .53309 L .43672 .52262 L p F P
0 0 0 r
s
.24 .35 .67 r
.2299 .34522 m
.26559 .33684 L
s
.2299 .34522 m
.22623 .37737 L
s
.831 .257 .112 r
.53748 .20474 m .53317 .20256 L .52492 .20853 L p F P
0 0 0 r
s
.831 .257 .112 r
.52275 .20744 m .52492 .20853 L .53317 .20256 L p F P
0 0 0 r
s
1 .298 .123 r
.32105 .327 m .30623 .32126 L .3202 .29845 L p F P
0 0 0 r
s
1 .291 .12 r
.30623 .32126 m .32105 .327 L .31288 .35139 L p F P
0 0 0 r
s
.195 .318 .617 r
.51982 .54588 m .51673 .54636 L .51677 .54726 L p F P
0 0 0 r
s
.195 .318 .617 r
.51677 .54726 m .52279 .54631 L .51982 .54588 L p F P
0 0 0 r
s
.269 .419 .815 r
.5197 .20822 m .52275 .20744 L .52884 .20037 L p F P
0 0 0 r
s
.269 .419 .815 r
.52884 .20037 m .52272 .20194 L .5197 .20822 L p F P
0 0 0 r
s
.918 .252 .101 r
.70051 .32112 m .71238 .32686 L .72056 .35125 L p F P
0 0 0 r
s
.83 .224 .089 r
.71238 .32686 m .70051 .32112 L .68832 .29832 L p F P
0 0 0 r
s
.024 .035 .067 r
.42828 .22488 m .4369 .22266 L .41276 .23186 L p F P
0 0 0 r
s
.024 .035 .067 r
.41276 .23186 m .40161 .23472 L .42828 .22488 L p F P
0 0 0 r
s
.063 .075 .143 r
.59704 .53133 m .58794 .53277 L .60831 .5222 L p F P
0 0 0 r
s
.063 .075 .143 r
.60831 .5222 m .62008 .52032 L .59704 .53133 L p F P
0 0 0 r
s
.215 .346 .663 r
.47454 .21429 m .48049 .21277 L .46305 .21595 L p F P
0 0 0 r
s
.215 .346 .663 r
.46305 .21595 m .45429 .2182 L .47454 .21429 L p F P
0 0 0 r
s
.83 .24 .1 r
.36417 .21709 m
.39412 .23067 L
s
1 .308 .128 r
.33888 .27771 m .3264 .27251 L .35104 .25488 L p F P
0 0 0 r
s
1 .304 .126 r
.3264 .27251 m .33888 .27771 L .3202 .29845 L p F P
0 0 0 r
s
.696 .182 .07 r
.66165 .27238 m .672 .27758 L .68832 .29832 L p F P
0 0 0 r
s
.53 .131 .051 r
.672 .27758 m .66165 .27238 L .64287 .25477 L p F P
0 0 0 r
s
.83 .24 .1 r
.63466 .25079 m
.64331 .25517 L
s
.831 .257 .112 r
.53317 .20256 m .52884 .20037 L .52275 .20744 L p F P
0 0 0 r
s
.131 .17 .349 r
.68348 .49889 m .66898 .50125 L .69013 .48308 L p F P
0 0 0 r
s
.131 .17 .349 r
.69013 .48308 m .70674 .4803 L .68348 .49889 L p F P
0 0 0 r
s
.83 .24 .1 r
.68969 .50919 m
.709 .48087 L
s
.614 .201 .088 r
.49175 .54518 m .49612 .54651 L .50615 .54598 L p F P
0 0 0 r
s
.83 .24 .1 r
.50104 .54625 m
.50213 .54658 L
s
.614 .201 .088 r
.50837 .54666 m .50615 .54598 L .49612 .54651 L p F P
0 0 0 r
s
.877 .239 .097 r
.35797 .45942 m .34433 .45497 L .33335 .43168 L p F P
0 0 0 r
s
.795 .213 .085 r
.34433 .45497 m .35797 .45942 L .37199 .48039 L p F P
0 0 0 r
s
.83 .24 .1 r
.36685 .4549 m
.37981 .48139 L
s
.626 .202 .09 r
.57887 .21994 m .57271 .2168 L .55452 .21335 L p F P
0 0 0 r
s
.626 .202 .09 r
.55029 .21121 m .55452 .21335 L .57271 .2168 L p F P
0 0 0 r
s
.24 .35 .67 r
.56735 .21547 m
.60404 .20632 L
s
.5452 .2061 m
.56011 .21366 L
s
1 .312 .129 r
.71412 .45486 m .72516 .45931 L .70674 .4803 L p F P
0 0 0 r
s
.24 .35 .67 r
.71864 .45668 m
.71998 .45253 L
s
1 .306 .126 r
.72516 .45931 m .71412 .45486 L .7267 .43156 L p F P
0 0 0 r
s
.976 .272 .112 r
.32694 .4072 m .31157 .40186 L .30968 .37654 L p F P
0 0 0 r
s
.934 .258 .105 r
.31157 .40186 m .32694 .4072 L .33335 .43168 L p F P
0 0 0 r
s
.83 .24 .1 r
.3271 .38208 m
.3291 .41461 L
s
.3291 .41461 m
.35922 .42499 L
s
.094 .113 .235 r
.64387 .51651 m .63194 .51842 L .6546 .5036 L p F P
0 0 0 r
s
.094 .113 .235 r
.6546 .5036 m .66898 .50125 L .64387 .51651 L p F P
0 0 0 r
s
.195 .318 .617 r
.52291 .54539 m .51982 .54588 L .52279 .54631 L p F P
0 0 0 r
s
.195 .318 .617 r
.52279 .54631 m .52883 .54536 L .52291 .54539 L p F P
0 0 0 r
s
.24 .35 .67 r
.76113 .44537 m
.76553 .41575 L
s
.76553 .41575 m
.80735 .40814 L
s
1 .297 .122 r
.72187 .40173 m .73405 .40707 L .7267 .43156 L p F P
0 0 0 r
s
.83 .24 .1 r
.73225 .40629 m
.7325 .40247 L
s
1 .286 .117 r
.73405 .40707 m .72187 .40173 L .72376 .3764 L p F P
0 0 0 r
s
.24 .35 .67 r
.24435 .47873 m
.2591 .50842 L
s
.2591 .50842 m
.29521 .50186 L
s
.036 .047 .09 r
.55935 .54057 m .5532 .54154 L .56988 .53562 L p F P
0 0 0 r
s
.036 .047 .09 r
.56988 .53562 m .57889 .5342 L .55935 .54057 L p F P
0 0 0 r
s
.215 .346 .663 r
.48049 .21277 m .48646 .21124 L .47186 .21369 L p F P
0 0 0 r
s
.215 .346 .663 r
.47186 .21369 m .46305 .21595 L .48049 .21277 L p F P
0 0 0 r
s
.054 .065 .125 r
.39054 .23755 m .40161 .23472 L .37751 .24816 L p F P
0 0 0 r
s
.054 .065 .125 r
.37751 .24816 m .36422 .25154 L .39054 .23755 L p F P
0 0 0 r
s
.44 .141 .066 r
.61344 .23633 m .60563 .23236 L .58498 .22305 L p F P
0 0 0 r
s
.44 .141 .066 r
.57887 .21994 m .58498 .22305 L .60563 .23236 L p F P
0 0 0 r
s
.24 .35 .67 r
.60404 .20632 m
.62273 .22278 L
s
.60404 .20632 m
.64407 .19634 L
s
.60404 .20632 m
.58458 .19612 L
s
.024 .035 .067 r
.4369 .22266 m .44558 .22044 L .42399 .22899 L p F P
0 0 0 r
s
.83 .24 .1 r
.43919 .22025 m
.44151 .22134 L
s
.024 .035 .067 r
.42399 .22899 m .41276 .23186 L .4369 .22266 L p F P
0 0 0 r
s
.24 .35 .67 r
.42952 .22682 m
.44887 .22258 L
s
.42939 .22685 m
.42952 .22682 L
s
.83 .24 .1 r
.39412 .23067 m
.41931 .21091 L
s
.088 .108 .226 r
.35104 .25488 m .36422 .25154 L .34144 .26874 L p F P
0 0 0 r
s
.088 .108 .226 r
.34144 .26874 m .3264 .27251 L .35104 .25488 L p F P
0 0 0 r
s
.214 .05 .021 r
.45449 .53309 m .46106 .53508 L .47851 .54117 L p F P
0 0 0 r
s
.214 .05 .021 r
.48295 .54252 m .47851 .54117 L .46106 .53508 L p F P
0 0 0 r
s
.83 .24 .1 r
.70694 .48007 m
.709 .48087 L
s
.709 .48087 m
.71189 .47443 L
s
1 .291 .12 r
.31288 .35139 m .29738 .34559 L .30623 .32126 L p F P
0 0 0 r
s
1 .283 .116 r
.29738 .34559 m .31288 .35139 L .30968 .37654 L p F P
0 0 0 r
s
.53 .131 .051 r
.63365 .25009 m .64287 .25477 L .66165 .27238 L p F P
0 0 0 r
s
.35 .078 .032 r
.64287 .25477 m .63365 .25009 L .61344 .23633 L p F P
0 0 0 r
s
.24 .35 .67 r
.53787 .20494 m
.5452 .2061 L
s
.978 .272 .11 r
.70825 .34545 m .72056 .35125 L .72376 .3764 L p F P
0 0 0 r
s
.918 .252 .101 r
.72056 .35125 m .70825 .34545 L .70051 .32112 L p F P
0 0 0 r
s
.24 .35 .67 r
.27374 .308 m
.26559 .33684 L
s
.195 .318 .617 r
.52601 .54491 m .52291 .54539 L .52883 .54536 L p F P
0 0 0 r
s
.195 .318 .617 r
.52883 .54536 m .53489 .54441 L .52601 .54491 L p F P
0 0 0 r
s
.063 .075 .143 r
.60618 .52989 m .59704 .53133 L .62008 .52032 L p F P
0 0 0 r
s
.063 .075 .143 r
.62008 .52032 m .63194 .51842 L .60618 .52989 L p F P
0 0 0 r
s
.24 .35 .67 r
.66256 .21309 m
.7033 .20318 L
s
.66256 .21309 m
.64407 .19634 L
s
.35 .078 .032 r
.60563 .23236 m .61344 .23633 L .63365 .25009 L p F P
0 0 0 r
s
.614 .201 .088 r
.48736 .54385 m .49175 .54518 L .50392 .5453 L p F P
0 0 0 r
s
.83 .24 .1 r
.49772 .54524 m
.49882 .54557 L
s
.614 .201 .088 r
.50615 .54598 m .50392 .5453 L .49175 .54518 L p F P
0 0 0 r
s
.215 .346 .663 r
.48646 .21124 m .49245 .2097 L .48071 .21141 L p F P
0 0 0 r
s
.215 .346 .663 r
.48071 .21141 m .47186 .21369 L .48646 .21124 L p F P
0 0 0 r
s
.24 .35 .67 r
.44887 .22258 m
.48676 .21288 L
s
.672 .175 .069 r
.40029 .50227 m .3897 .49897 L .37199 .48039 L p F P
0 0 0 r
s
.51 .125 .049 r
.3897 .49897 m .40029 .50227 L .41946 .51734 L p F P
0 0 0 r
s
.51 .125 .049 r
.42813 .51999 m .41946 .51734 L .40029 .50227 L p F P
0 0 0 r
s
.626 .202 .09 r
.57271 .2168 m .56651 .21365 L .55029 .21121 L p F P
0 0 0 r
s
.626 .202 .09 r
.54604 .20906 m .55029 .21121 L .56651 .21365 L p F P
0 0 0 r
s
1 .304 .126 r
.3202 .29845 m .30626 .29285 L .3264 .27251 L p F P
0 0 0 r
s
.24 .35 .67 r
.32214 .27509 m
.33764 .25705 L
s
.28602 .28411 m
.32214 .27509 L
s
1 .298 .123 r
.30626 .29285 m .3202 .29845 L .30623 .32126 L p F P
0 0 0 r
s
.83 .24 .1 r
.30898 .30337 m
.33959 .31552 L
s
.24 .35 .67 r
.8049 .34158 m
.7985 .30739 L
s
.7985 .30739 m
.84078 .29854 L
s
.7985 .30739 m
.78893 .27426 L
s
.83 .224 .089 r
.67698 .29271 m .68832 .29832 L .70051 .32112 L p F P
0 0 0 r
s
.696 .182 .07 r
.68832 .29832 m .67698 .29271 L .66165 .27238 L p F P
0 0 0 r
s
.351 .078 .033 r
.41946 .51734 m .42813 .51999 L .44788 .53109 L p F P
0 0 0 r
s
.351 .078 .033 r
.45449 .53309 m .44788 .53109 L .42813 .51999 L p F P
0 0 0 r
s
.83 .24 .1 r
.42696 .51237 m
.44903 .52847 L
s
.44903 .52847 m
.47733 .5371 L
s
.24 .35 .67 r
.8079 .37558 m
.8049 .34158 L
s
.8049 .34158 m
.84728 .33311 L
s
.036 .047 .09 r
.56552 .53961 m .55935 .54057 L .57889 .5342 L p F P
0 0 0 r
s
.24 .35 .67 r
.54677 .54084 m
.56478 .53279 L
s
.036 .047 .09 r
.57889 .5342 m .58794 .53277 L .56552 .53961 L p F P
0 0 0 r
s
.934 .258 .105 r
.33335 .43168 m .31855 .4267 L .31157 .40186 L p F P
0 0 0 r
s
.877 .239 .097 r
.31855 .4267 m .33335 .43168 L .34433 .45497 L p F P
0 0 0 r
s
.24 .35 .67 r
.22623 .37737 m
.26208 .3693 L
s
.22623 .37737 m
.22748 .41149 L
s
.32214 .27509 m
.32441 .27452 L
s
.32039 .27858 m
.32044 .27848 L
s
.32044 .27848 m
.32214 .27509 L
s
.195 .318 .617 r
.52911 .54442 m .52601 .54491 L .53489 .54441 L p F P
0 0 0 r
s
.195 .318 .617 r
.53489 .54441 m .54097 .54346 L .52911 .54442 L p F P
0 0 0 r
s
1 .306 .126 r
.71488 .42658 m .7267 .43156 L .71412 .45486 L p F P
0 0 0 r
s
1 .297 .122 r
.7267 .43156 m .71488 .42658 L .72187 .40173 L p F P
0 0 0 r
s
.024 .035 .067 r
.44558 .22044 m .45429 .2182 L .43528 .2261 L p F P
0 0 0 r
s
.83 .24 .1 r
.41931 .21091 m
.43919 .22025 L
s
.024 .035 .067 r
.43528 .2261 m .42399 .22899 L .44558 .22044 L p F P
0 0 0 r
s
.795 .213 .085 r
.37199 .48039 m .35966 .47647 L .34433 .45497 L p F P
0 0 0 r
s
.672 .175 .069 r
.35966 .47647 m .37199 .48039 L .3897 .49897 L p F P
0 0 0 r
s
.054 .065 .125 r
.40161 .23472 m .41276 .23186 L .39091 .24477 L p F P
0 0 0 r
s
.054 .065 .125 r
.39091 .24477 m .37751 .24816 L .40161 .23472 L p F P
0 0 0 r
s
1 .317 .132 r
.69656 .47638 m .70674 .4803 L .68348 .49889 L p F P
0 0 0 r
s
.24 .35 .67 r
.6712 .4849 m
.69381 .48111 L
s
1 .312 .129 r
.70674 .4803 m .69656 .47638 L .71412 .45486 L p F P
0 0 0 r
s
.24 .35 .67 r
.70653 .47898 m
.70673 .47894 L
s
.70673 .47894 m
.71173 .47811 L
s
.71173 .47811 m
.71445 .46968 L
s
.215 .346 .663 r
.49245 .2097 m .49846 .20816 L .48961 .20913 L p F P
0 0 0 r
s
.215 .346 .663 r
.48961 .20913 m .48071 .21141 L .49245 .2097 L p F P
0 0 0 r
s
.83 .24 .1 r
.47514 .21082 m
.50314 .20361 L
s
.094 .113 .235 r
.65589 .51459 m .64387 .51651 L .66898 .50125 L p F P
0 0 0 r
s
.094 .113 .235 r
.66898 .50125 m .68348 .49889 L .65589 .51459 L p F P
0 0 0 r
s
.24 .35 .67 r
.61935 .51191 m
.65928 .50543 L
s
.65928 .50543 m
.6712 .4849 L
s
.83 .24 .1 r
.50314 .20361 m
.5168 .20346 L
s
.47475 .18953 m
.50314 .20361 L
s
.44 .141 .066 r
.60563 .23236 m .59776 .22835 L .57887 .21994 L p F P
0 0 0 r
s
.44 .141 .066 r
.57271 .2168 m .57887 .21994 L .59776 .22835 L p F P
0 0 0 r
s
.83 .24 .1 r
.55831 .21707 m
.58464 .22385 L
s
.58464 .22385 m
.61096 .23722 L
s
.24 .35 .67 r
.78893 .27426 m
.83119 .26501 L
s
.78893 .27426 m
.77652 .24338 L
s
.72021 .22573 m
.7617 .21594 L
s
.72021 .22573 m
.7033 .20318 L
s
.83 .24 .1 r
.44654 .19696 m
.41931 .21091 L
s
.38958 .19693 m
.41931 .21091 L
s
1 .283 .116 r
.30968 .37654 m .2939 .37086 L .29738 .34559 L p F P
0 0 0 r
s
.976 .272 .112 r
.2939 .37086 m .30968 .37654 L .31157 .40186 L p F P
0 0 0 r
s
.614 .201 .088 r
.48295 .54252 m .48736 .54385 L .50169 .54462 L p F P
0 0 0 r
s
.83 .24 .1 r
.4944 .54423 m
.4955 .54456 L
s
.614 .201 .088 r
.50392 .5453 m .50169 .54462 L .48736 .54385 L p F P
0 0 0 r
s
.626 .202 .09 r
.56651 .21365 m .56026 .21047 L .54604 .20906 L p F P
0 0 0 r
s
.626 .202 .09 r
.54177 .20691 m .54604 .20906 L .56026 .21047 L p F P
0 0 0 r
s
.978 .272 .11 r
.72376 .3764 m .71128 .37072 L .70825 .34545 L p F P
0 0 0 r
s
1 .286 .117 r
.71128 .37072 m .72376 .3764 L .72187 .40173 L p F P
0 0 0 r
s
.24 .35 .67 r
.29521 .50186 m
.31314 .52725 L
s
.31314 .52725 m
.35002 .52087 L
s
.23362 .44587 m
.24435 .47873 L
s
.24435 .47873 m
.28046 .4718 L
s
.214 .05 .021 r
.44788 .53109 m .45449 .53309 L .47406 .53982 L p F P
0 0 0 r
s
.214 .05 .021 r
.47851 .54117 m .47406 .53982 L .45449 .53309 L p F P
0 0 0 r
s
.83 .24 .1 r
.51915 .54606 m
.53027 .54948 L
s
.53027 .54948 m
.55898 .54501 L
s
.088 .108 .226 r
.36422 .25154 m .37751 .24816 L .35662 .26495 L p F P
0 0 0 r
s
.83 .24 .1 r
.35955 .25 m
.36052 .25042 L
s
.088 .108 .226 r
.35662 .26495 m .34144 .26874 L .36422 .25154 L p F P
0 0 0 r
s
.195 .318 .617 r
.53222 .54393 m .52911 .54442 L .54097 .54346 L p F P
0 0 0 r
s
.195 .318 .617 r
.54097 .54346 m .54708 .5425 L .53222 .54393 L p F P
0 0 0 r
s
.24 .35 .67 r
.50886 .54681 m
.54677 .54084 L
s
.126 .164 .342 r
.3264 .27251 m .34144 .26874 L .3228 .28879 L p F P
0 0 0 r
s
.83 .24 .1 r
.32688 .27295 m
.32703 .27302 L
s
.33455 .27615 m
.35351 .28404 L
s
.126 .164 .342 r
.3228 .28879 m .30626 .29285 L .3264 .27251 L p F P
0 0 0 r
s
.83 .24 .1 r
.32312 .27139 m
.32688 .27295 L
s
.063 .075 .143 r
.61537 .52844 m .60618 .52989 L .63194 .51842 L p F P
0 0 0 r
s
.063 .075 .143 r
.63194 .51842 m .64387 .51651 L .61537 .52844 L p F P
0 0 0 r
s
.24 .35 .67 r
.60411 .52654 m
.61935 .51191 L
s
.696 .182 .07 r
.65116 .26711 m .66165 .27238 L .67698 .29271 L p F P
0 0 0 r
s
.53 .131 .051 r
.66165 .27238 m .65116 .26711 L .63365 .25009 L p F P
0 0 0 r
s
.83 .24 .1 r
.65473 .27068 m
.65479 .27071 L
s
.036 .047 .09 r
.57171 .53863 m .56552 .53961 L .58794 .53277 L p F P
0 0 0 r
s
.036 .047 .09 r
.58794 .53277 m .59704 .53133 L .57171 .53863 L p F P
0 0 0 r
s
.24 .35 .67 r
.56478 .53279 m
.60411 .52654 L
s
1 .298 .123 r
.30623 .32126 m .29119 .31543 L .30626 .29285 L p F P
0 0 0 r
s
1 .291 .12 r
.29119 .31543 m .30623 .32126 L .29738 .34559 L p F P
0 0 0 r
s
.83 .24 .1 r
.29987 .33697 m
.33066 .34862 L
s
.215 .346 .663 r
.49846 .20816 m .50449 .20661 L .49856 .20683 L p F P
0 0 0 r
s
.215 .346 .663 r
.49856 .20683 m .48961 .20913 L .49846 .20816 L p F P
0 0 0 r
s
.24 .35 .67 r
.70012 .4988 m
.71173 .47811 L
s
.85044 .36747 m
.8079 .37558 L
s
.80735 .40814 m
.8079 .37558 L
s
.918 .252 .101 r
.68846 .31529 m .70051 .32112 L .70825 .34545 L p F P
0 0 0 r
s
.83 .24 .1 r
.69905 .31935 m
.69948 .32062 L
s
.83 .224 .089 r
.70051 .32112 m .68846 .31529 L .67698 .29271 L p F P
0 0 0 r
s
.024 .035 .067 r
.45429 .2182 m .46305 .21595 L .44666 .22319 L p F P
0 0 0 r
s
.024 .035 .067 r
.44666 .22319 m .43528 .2261 L .45429 .2182 L p F P
0 0 0 r
s
.24 .35 .67 r
.22748 .41149 m
.26345 .40379 L
s
.22748 .41149 m
.23362 .44587 L
s
.35 .078 .032 r
.63365 .25009 m .62432 .24536 L .60563 .23236 L p F P
0 0 0 r
s
.35 .078 .032 r
.59776 .22835 m .60563 .23236 L .62432 .24536 L p F P
0 0 0 r
s
.877 .239 .097 r
.34433 .45497 m .33051 .45046 L .31855 .4267 L p F P
0 0 0 r
s
.83 .24 .1 r
.3291 .41461 m
.33665 .44492 L
s
.795 .213 .085 r
.33051 .45046 m .34433 .45497 L .35966 .47647 L p F P
0 0 0 r
s
.83 .24 .1 r
.33665 .44492 m
.36685 .4549 L
s
.24 .35 .67 r
.23362 .44587 m
.26968 .43855 L
s
1 .312 .129 r
.70292 .45035 m .71412 .45486 L .69656 .47638 L p F P
0 0 0 r
s
.24 .35 .67 r
.71173 .47811 m
.75318 .47116 L
s
1 .306 .126 r
.71412 .45486 m .70292 .45035 L .71488 .42658 L p F P
0 0 0 r
s
.614 .201 .088 r
.47851 .54117 m .48295 .54252 L .49945 .54394 L p F P
0 0 0 r
s
.83 .24 .1 r
.49106 .54321 m
.49216 .54355 L
s
.614 .201 .088 r
.50169 .54462 m .49945 .54394 L .48295 .54252 L p F P
0 0 0 r
s
.53 .131 .051 r
.62432 .24536 m .63365 .25009 L .65116 .26711 L p F P
0 0 0 r
s
.83 .24 .1 r
.65098 .26697 m
.65473 .27068 L
s
.195 .318 .617 r
.53533 .54344 m .53222 .54393 L .54708 .5425 L p F P
0 0 0 r
s
.195 .318 .617 r
.54708 .5425 m .5532 .54154 L .53533 .54344 L p F P
0 0 0 r
s
.626 .202 .09 r
.56026 .21047 m .55397 .20727 L .54177 .20691 L p F P
0 0 0 r
s
.626 .202 .09 r
.53748 .20474 m .54177 .20691 L .55397 .20727 L p F P
0 0 0 r
s
.51 .125 .049 r
.41946 .51734 m .41071 .51466 L .3897 .49897 L p F P
0 0 0 r
s
.351 .078 .033 r
.41071 .51466 m .41946 .51734 L .44122 .52907 L p F P
0 0 0 r
s
.351 .078 .033 r
.44788 .53109 m .44122 .52907 L .41946 .51734 L p F P
0 0 0 r
s
.24 .35 .67 r
.35002 .52087 m
.37007 .54071 L
s
.37007 .54071 m
.40769 .53447 L
s
.054 .065 .125 r
.41276 .23186 m .42399 .22899 L .40441 .24134 L p F P
0 0 0 r
s
.054 .065 .125 r
.40441 .24134 m .39091 .24477 L .41276 .23186 L p F P
0 0 0 r
s
.215 .346 .663 r
.50449 .20661 m .51055 .20506 L .50755 .20452 L p F P
0 0 0 r
s
.215 .346 .663 r
.50755 .20452 m .49856 .20683 L .50449 .20661 L p F P
0 0 0 r
s
.83 .24 .1 r
.31849 .28186 m
.32312 .27139 L
s
.30898 .30337 m
.31453 .29082 L
s
.29987 .33697 m
.30898 .30337 L
s
.24 .35 .67 r
.75318 .47116 m
.76113 .44537 L
s
.76113 .44537 m
.80322 .43804 L
s
.976 .272 .112 r
.31157 .40186 m .29596 .39643 L .2939 .37086 L p F P
0 0 0 r
s
.83 .24 .1 r
.29615 .37091 m
.3271 .38208 L
s
.934 .258 .105 r
.29596 .39643 m .31157 .40186 L .31855 .4267 L p F P
0 0 0 r
s
.24 .35 .67 r
.48801 .54795 m
.50354 .54549 L
s
.672 .175 .069 r
.3897 .49897 m .37899 .49564 L .35966 .47647 L p F P
0 0 0 r
s
.51 .125 .049 r
.37899 .49564 m .3897 .49897 L .41071 .51466 L p F P
0 0 0 r
s
.83 .24 .1 r
.37981 .48139 m
.39768 .50329 L
s
.39768 .50329 m
.42696 .51237 L
s
1 .297 .122 r
.70949 .39629 m .72187 .40173 L .71488 .42658 L p F P
0 0 0 r
s
1 .286 .117 r
.72187 .40173 m .70949 .39629 L .71128 .37072 L p F P
0 0 0 r
s
.83 .24 .1 r
.70932 .37078 m
.71122 .37164 L
s
.44 .141 .066 r
.59776 .22835 m .58981 .2243 L .57271 .2168 L p F P
0 0 0 r
s
.44 .141 .066 r
.56651 .21365 m .57271 .2168 L .58981 .2243 L p F P
0 0 0 r
s
1 .321 .134 r
.67442 .49556 m .68348 .49889 L .65589 .51459 L p F P
0 0 0 r
s
.24 .35 .67 r
.67475 .50292 m
.67606 .50271 L
s
.65928 .50543 m
.66584 .50437 L
s
.83 .24 .1 r
.67496 .50384 m
.68969 .50919 L
s
.67485 .5038 m
.67496 .50384 L
s
1 .317 .132 r
.68348 .49889 m .67442 .49556 L .69656 .47638 L p F P
0 0 0 r
s
.24 .35 .67 r
.67606 .50271 m
.70012 .4988 L
s
.036 .047 .09 r
.57792 .53766 m .57171 .53863 L .59704 .53133 L p F P
0 0 0 r
s
.036 .047 .09 r
.59704 .53133 m .60618 .52989 L .57792 .53766 L p F P
0 0 0 r
s
.214 .05 .021 r
.44122 .52907 m .44788 .53109 L .46958 .53847 L p F P
0 0 0 r
s
.214 .05 .021 r
.47406 .53982 m .46958 .53847 L .44788 .53109 L p F P
0 0 0 r
s
.83 .24 .1 r
.44903 .52847 m
.47449 .53818 L
s
.063 .075 .143 r
.62461 .52698 m .61537 .52844 L .64387 .51651 L p F P
0 0 0 r
s
.063 .075 .143 r
.64387 .51651 m .65589 .51459 L .62461 .52698 L p F P
0 0 0 r
s
.83 .24 .1 r
.6141 .54207 m
.64072 .524 L
s
.64072 .524 m
.66627 .53277 L
s
.195 .318 .617 r
.53845 .54295 m .53533 .54344 L .5532 .54154 L p F P
0 0 0 r
s
.195 .318 .617 r
.5532 .54154 m .55935 .54057 L .53845 .54295 L p F P
0 0 0 r
s
.024 .035 .067 r
.46305 .21595 m .47186 .21369 L .45811 .22026 L p F P
0 0 0 r
s
.024 .035 .067 r
.45811 .22026 m .44666 .22319 L .46305 .21595 L p F P
0 0 0 r
s
.24 .35 .67 r
.77652 .24338 m
.81884 .23375 L
s
.77652 .24338 m
.7617 .21594 L
s
1 .291 .12 r
.29738 .34559 m .28163 .33971 L .29119 .31543 L p F P
0 0 0 r
s
1 .283 .116 r
.28163 .33971 m .29738 .34559 L .2939 .37086 L p F P
0 0 0 r
s
.83 .24 .1 r
.29615 .37091 m
.29987 .33697 L
s
.24 .35 .67 r
.26559 .33684 m
.26208 .3693 L
s
.215 .346 .663 r
.51055 .20506 m .51662 .2035 L .51659 .2022 L p F P
0 0 0 r
s
.215 .346 .663 r
.51659 .2022 m .50755 .20452 L .51055 .20506 L p F P
0 0 0 r
s
.088 .108 .226 r
.37751 .24816 m .39091 .24477 L .37193 .26111 L p F P
0 0 0 r
s
.088 .108 .226 r
.37193 .26111 m .35662 .26495 L .37751 .24816 L p F P
0 0 0 r
s
.83 .24 .1 r
.34174 .24225 m
.35955 .25 L
s
.978 .272 .11 r
.69575 .33957 m .70825 .34545 L .71128 .37072 L p F P
0 0 0 r
s
.83 .24 .1 r
.70581 .34173 m
.70614 .34446 L
s
.70868 .36551 m
.70932 .37078 L
s
.918 .252 .101 r
.70825 .34545 m .69575 .33957 L .68846 .31529 L p F P
0 0 0 r
s
.155 .21 .43 r
.30626 .29285 m .3228 .28879 L .30884 .3112 L p F P
0 0 0 r
s
.155 .21 .43 r
.30884 .3112 m .29119 .31543 L .30626 .29285 L p F P
0 0 0 r
s
.83 .24 .1 r
.30083 .30013 m
.30196 .30058 L
s
.2774 .29082 m
.30083 .30013 L
s
.24 .35 .67 r
.27374 .308 m
.3005 .30149 L
s
.614 .201 .088 r
.47406 .53982 m .47851 .54117 L .49721 .54325 L p F P
0 0 0 r
s
.83 .24 .1 r
.48771 .5422 m
.48882 .54253 L
s
.614 .201 .088 r
.49945 .54394 m .49721 .54325 L .47851 .54117 L p F P
0 0 0 r
s
.83 .24 .1 r
.47449 .53818 m
.48546 .54151 L
s
.83 .224 .089 r
.66549 .28703 m .67698 .29271 L .68846 .31529 L p F P
0 0 0 r
s
.696 .182 .07 r
.67698 .29271 m .66549 .28703 L .65116 .26711 L p F P
0 0 0 r
s
.626 .202 .09 r
.55397 .20727 m .54763 .20404 L .53748 .20474 L p F P
0 0 0 r
s
.24 .35 .67 r
.54952 .20501 m
.58458 .19612 L
s
.626 .202 .09 r
.53317 .20256 m .53748 .20474 L .54763 .20404 L p F P
0 0 0 r
s
.126 .164 .342 r
.34144 .26874 m .35662 .26495 L .3395 .28469 L p F P
0 0 0 r
s
.24 .35 .67 r
.33959 .27073 m
.34125 .27031 L
s
.126 .164 .342 r
.3395 .28469 m .3228 .28879 L .34144 .26874 L p F P
0 0 0 r
s
.83 .24 .1 r
.32312 .27139 m
.34174 .24225 L
s
.29175 .25833 m
.32312 .27139 L
s
.254 .399 .781 r
.51058 .54733 m .51365 .54685 L .5167 .54118 L closepath p F P
0 0 0 r
s
.847 .264 .114 r
.5167 .54118 m .50837 .54666 L .51058 .54733 L closepath p F P
0 0 0 r
s
.795 .213 .085 r
.35966 .47647 m .34717 .4725 L .33051 .45046 L p F P
0 0 0 r
s
.672 .175 .069 r
.34717 .4725 m .35966 .47647 L .37899 .49564 L p F P
0 0 0 r
s
.83 .24 .1 r
.36417 .21709 m
.34174 .24225 L
s
.31059 .22869 m
.34174 .24225 L
s
1 .317 .132 r
.68625 .47241 m .69656 .47638 L .67442 .49556 L p F P
0 0 0 r
s
1 .312 .129 r
.69656 .47638 m .68625 .47241 L .70292 .45035 L p F P
0 0 0 r
s
.83 .24 .1 r
.64072 .524 m
.64623 .51842 L
s
.195 .318 .617 r
.54158 .54246 m .53845 .54295 L .55935 .54057 L p F P
0 0 0 r
s
.195 .318 .617 r
.55935 .54057 m .56552 .53961 L .54158 .54246 L p F P
0 0 0 r
s
.054 .065 .125 r
.42399 .22899 m .43528 .2261 L .41803 .23789 L p F P
0 0 0 r
s
.054 .065 .125 r
.41803 .23789 m .40441 .24134 L .42399 .22899 L p F P
0 0 0 r
s
.036 .047 .09 r
.58416 .53668 m .57792 .53766 L .60618 .52989 L p F P
0 0 0 r
s
.036 .047 .09 r
.60618 .52989 m .61537 .52844 L .58416 .53668 L p F P
0 0 0 r
s
.934 .258 .105 r
.31855 .4267 m .30353 .42165 L .29596 .39643 L p F P
0 0 0 r
s
.877 .239 .097 r
.30353 .42165 m .31855 .4267 L .33051 .45046 L p F P
0 0 0 r
s
.254 .399 .781 r
.51365 .54685 m .51673 .54636 L .5167 .54118 L closepath p F P
0 0 0 r
s
.215 .346 .663 r
.51662 .2035 m .52272 .20194 L .52567 .19987 L p F P
0 0 0 r
s
.215 .346 .663 r
.52567 .19987 m .51659 .2022 L .51662 .2035 L p F P
0 0 0 r
s
.24 .35 .67 r
.52552 .20297 m
.5328 .20413 L
s
.83 .24 .1 r
.52071 .20341 m
.53098 .20329 L
s
.24 .35 .67 r
.48676 .21288 m
.52552 .20297 L
s
1 .306 .126 r
.70287 .42153 m .71488 .42658 L .70292 .45035 L p F P
0 0 0 r
s
1 .297 .122 r
.71488 .42658 m .70287 .42153 L .70949 .39629 L p F P
0 0 0 r
s
.847 .264 .114 r
.5167 .54118 m .50615 .54598 L .50837 .54666 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.80322 .43804 m
.80735 .40814 L
s
.80735 .40814 m
.85012 .40036 L
s
.35 .078 .032 r
.62432 .24536 m .61489 .24057 L .59776 .22835 L p F P
0 0 0 r
s
.35 .078 .032 r
.58981 .2243 m .59776 .22835 L .61489 .24057 L p F P
0 0 0 r
s
.024 .035 .067 r
.47186 .21369 m .48071 .21141 L .46964 .21731 L p F P
0 0 0 r
s
.024 .035 .067 r
.46964 .21731 m .45811 .22026 L .47186 .21369 L p F P
0 0 0 r
s
.24 .35 .67 r
.47184 .21614 m
.48676 .21288 L
s
.28046 .4718 m
.29521 .50186 L
s
.29521 .50186 m
.33214 .49515 L
s
.44 .141 .066 r
.58981 .2243 m .58178 .22021 L .56651 .21365 L p F P
0 0 0 r
s
.83 .24 .1 r
.58464 .22385 m
.60847 .2375 L
s
.44 .141 .066 r
.56026 .21047 m .56651 .21365 L .58178 .22021 L p F P
0 0 0 r
s
.83 .24 .1 r
.47475 .18953 m
.44654 .19696 L
s
.41703 .18266 m
.44654 .19696 L
s
.254 .399 .781 r
.51673 .54636 m .51982 .54588 L .5167 .54118 L closepath p F P
0 0 0 r
s
.51 .125 .049 r
.41071 .51466 m .40187 .51195 L .37899 .49564 L p F P
0 0 0 r
s
.351 .078 .033 r
.40187 .51195 m .41071 .51466 L .43452 .52703 L p F P
0 0 0 r
s
.351 .078 .033 r
.44122 .52907 m .43452 .52703 L .41071 .51466 L p F P
0 0 0 r
s
.696 .182 .07 r
.64054 .26178 m .65116 .26711 L .66549 .28703 L p F P
0 0 0 r
s
.53 .131 .051 r
.65116 .26711 m .64054 .26178 L .62432 .24536 L p F P
0 0 0 r
s
.614 .201 .088 r
.46958 .53847 m .47406 .53982 L .49496 .54257 L p F P
0 0 0 r
s
.614 .201 .088 r
.49721 .54325 m .49496 .54257 L .47406 .53982 L p F P
0 0 0 r
s
1 .323 .135 r
.6482 .51189 m .65589 .51459 L .62461 .52698 L p F P
0 0 0 r
s
.83 .24 .1 r
.63613 .52242 m
.64072 .524 L
s
.24 .35 .67 r
.648 .51655 m
.64866 .5159 L
s
.65154 .51306 m
.65928 .50543 L
s
.60411 .52654 m
.6323 .52206 L
s
1 .321 .134 r
.65589 .51459 m .6482 .51189 L .67442 .49556 L p F P
0 0 0 r
s
.626 .202 .09 r
.54763 .20404 m .54124 .2008 L .53317 .20256 L p F P
0 0 0 r
s
.83 .24 .1 r
.53098 .20329 m
.55831 .21707 L
s
.626 .202 .09 r
.52884 .20037 m .53317 .20256 L .54124 .2008 L p F P
0 0 0 r
s
.214 .05 .021 r
.43452 .52703 m .44122 .52907 L .46508 .5371 L p F P
0 0 0 r
s
.214 .05 .021 r
.46958 .53847 m .46508 .5371 L .44122 .52907 L p F P
0 0 0 r
s
.195 .318 .617 r
.54471 .54197 m .54158 .54246 L .56552 .53961 L p F P
0 0 0 r
s
.195 .318 .617 r
.56552 .53961 m .57171 .53863 L .54471 .54197 L p F P
0 0 0 r
s
.24 .35 .67 r
.64407 .19634 m
.68502 .18613 L
s
.64407 .19634 m
.62486 .18591 L
s
1 .283 .116 r
.2939 .37086 m .27788 .36508 L .28163 .33971 L p F P
0 0 0 r
s
.976 .272 .112 r
.27788 .36508 m .2939 .37086 L .29596 .39643 L p F P
0 0 0 r
s
.847 .264 .114 r
.5167 .54118 m .50392 .5453 L .50615 .54598 L closepath p F P
0 0 0 r
s
.53 .131 .051 r
.61489 .24057 m .62432 .24536 L .64054 .26178 L p F P
0 0 0 r
s
.83 .24 .1 r
.60847 .2375 m
.61548 .24106 L
s
.24 .35 .67 r
.58458 .19612 m
.62486 .18591 L
s
.58458 .19612 m
.56516 .19282 L
s
.978 .272 .11 r
.71128 .37072 m .69861 .36494 L .69575 .33957 L p F P
0 0 0 r
s
1 .286 .117 r
.69861 .36494 m .71128 .37072 L .70949 .39629 L p F P
0 0 0 r
s
.254 .399 .781 r
.51982 .54588 m .52291 .54539 L .5167 .54118 L closepath p F P
0 0 0 r
s
.215 .346 .663 r
.52272 .20194 m .52884 .20037 L .53481 .19752 L p F P
0 0 0 r
s
.215 .346 .663 r
.53481 .19752 m .52567 .19987 L .52272 .20194 L p F P
0 0 0 r
s
.83 .24 .1 r
.52615 .20085 m
.53098 .20329 L
s
.5245 .20002 m
.5247 .20012 L
s
.036 .047 .09 r
.59041 .5357 m .58416 .53668 L .61537 .52844 L p F P
0 0 0 r
s
.83 .24 .1 r
.5959 .53612 m
.6141 .54207 L
s
.036 .047 .09 r
.61537 .52844 m .62461 .52698 L .59041 .5357 L p F P
0 0 0 r
s
.24 .35 .67 r
.7033 .20318 m
.74496 .19304 L
s
.7033 .20318 m
.68502 .18613 L
s
.175 .243 .494 r
.29119 .31543 m .30884 .3112 L .29997 .33544 L p F P
0 0 0 r
s
.175 .243 .494 r
.29997 .33544 m .28163 .33971 L .29119 .31543 L p F P
0 0 0 r
s
.83 .24 .1 r
.29741 .33604 m
.29987 .33697 L
s
.2681 .32494 m
.2857 .3316 L
s
.24 .35 .67 r
.26559 .33684 m
.28451 .3324 L
s
.088 .108 .226 r
.39091 .24477 m .40441 .24134 L .3874 .25724 L p F P
0 0 0 r
s
.088 .108 .226 r
.3874 .25724 m .37193 .26111 L .39091 .24477 L p F P
0 0 0 r
s
.918 .252 .101 r
.67623 .30937 m .68846 .31529 L .69575 .33957 L p F P
0 0 0 r
s
.83 .224 .089 r
.68846 .31529 m .67623 .30937 L .66549 .28703 L p F P
0 0 0 r
s
.83 .24 .1 r
.66327 .28478 m
.66879 .2939 L
s
.672 .175 .069 r
.37899 .49564 m .36816 .49227 L .34717 .4725 L p F P
0 0 0 r
s
.83 .24 .1 r
.34958 .47175 m
.37981 .48139 L
s
.51 .125 .049 r
.36816 .49227 m .37899 .49564 L .40187 .51195 L p F P
0 0 0 r
s
.24 .35 .67 r
.52552 .20297 m
.53234 .20122 L
s
.254 .399 .781 r
.52291 .54539 m .52601 .54491 L .5167 .54118 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.84728 .33311 m
.84078 .29854 L
s
.84078 .29854 m
.88403 .28949 L
s
.84078 .29854 m
.83119 .26501 L
s
1 .321 .134 r
.66526 .49218 m .67442 .49556 L .6482 .51189 L p F P
0 0 0 r
s
1 .317 .132 r
.67442 .49556 m .66526 .49218 L .68625 .47241 L p F P
0 0 0 r
s
.847 .264 .114 r
.5167 .54118 m .50169 .54462 L .50392 .5453 L closepath p F P
0 0 0 r
s
.877 .239 .097 r
.33051 .45046 m .31648 .44588 L .30353 .42165 L p F P
0 0 0 r
s
.795 .213 .085 r
.31648 .44588 m .33051 .45046 L .34717 .4725 L p F P
0 0 0 r
s
.83 .24 .1 r
.33665 .44492 m
.34958 .47175 L
s
.054 .065 .125 r
.43528 .2261 m .44666 .22319 L .43175 .2344 L p F P
0 0 0 r
s
.054 .065 .125 r
.43175 .2344 m .41803 .23789 L .43528 .2261 L p F P
0 0 0 r
s
.195 .318 .617 r
.54785 .54147 m .54471 .54197 L .57171 .53863 L p F P
0 0 0 r
s
.83 .24 .1 r
.54795 .54153 m
.55898 .54501 L
s
.195 .318 .617 r
.57171 .53863 m .57792 .53766 L .54785 .54147 L p F P
0 0 0 r
s
1 .312 .129 r
.69156 .44577 m .70292 .45035 L .68625 .47241 L p F P
0 0 0 r
s
1 .306 .126 r
.70292 .45035 m .69156 .44577 L .70287 .42153 L p F P
0 0 0 r
s
.024 .035 .067 r
.48071 .21141 m .48961 .20913 L .48125 .21434 L p F P
0 0 0 r
s
.024 .035 .067 r
.48125 .21434 m .46964 .21731 L .48071 .21141 L p F P
0 0 0 r
s
.24 .35 .67 r
.85044 .36747 m
.84728 .33311 L
s
.84728 .33311 m
.89062 .32445 L
s
.614 .201 .088 r
.46508 .5371 m .46958 .53847 L .49271 .54188 L p F P
0 0 0 r
s
.614 .201 .088 r
.49496 .54257 m .49271 .54188 L .46958 .53847 L p F P
0 0 0 r
s
.155 .21 .43 r
.3228 .28879 m .3395 .28469 L .32668 .30693 L p F P
0 0 0 r
s
.155 .21 .43 r
.32668 .30693 m .30884 .3112 L .3228 .28879 L p F P
0 0 0 r
s
.83 .24 .1 r
.38958 .19693 m
.36417 .21709 L
s
.33325 .20307 m
.36417 .21709 L
s
.254 .399 .781 r
.52601 .54491 m .52911 .54442 L .5167 .54118 L closepath p F P
0 0 0 r
s
.126 .164 .342 r
.35662 .26495 m .37193 .26111 L .35638 .28055 L p F P
0 0 0 r
s
.24 .35 .67 r
.35492 .2669 m
.35659 .26648 L
s
.126 .164 .342 r
.35638 .28055 m .3395 .28469 L .35662 .26495 L p F P
0 0 0 r
s
.626 .202 .09 r
.54124 .2008 m .53481 .19752 L .52884 .20037 L p F P
0 0 0 r
s
.24 .35 .67 r
.53882 .19956 m
.56516 .19282 L
s
.26208 .3693 m
.26345 .40379 L
s
.847 .264 .114 r
.5167 .54118 m .49945 .54394 L .50169 .54462 L closepath p F P
0 0 0 r
s
.44 .141 .066 r
.58178 .22021 m .57368 .21608 L .56026 .21047 L p F P
0 0 0 r
s
.44 .141 .066 r
.55397 .20727 m .56026 .21047 L .57368 .21608 L p F P
0 0 0 r
s
.254 .399 .781 r
.52911 .54442 m .53222 .54393 L .5167 .54118 L closepath p F P
0 0 0 r
s
.976 .272 .112 r
.29596 .39643 m .2801 .39091 L .27788 .36508 L p F P
0 0 0 r
s
.24 .35 .67 r
.26208 .3693 m
.27794 .36573 L
s
.934 .258 .105 r
.2801 .39091 m .29596 .39643 L .30353 .42165 L p F P
0 0 0 r
s
.83 .24 .1 r
.29615 .37091 m
.29802 .4039 L
s
.29802 .4039 m
.3291 .41461 L
s
.24 .35 .67 r
.83119 .26501 m
.87443 .25556 L
s
.83119 .26501 m
.81884 .23375 L
s
.351 .078 .033 r
.43452 .52703 m .42776 .52498 L .40187 .51195 L p F P
0 0 0 r
s
.214 .05 .021 r
.42776 .52498 m .43452 .52703 L .46056 .53573 L p F P
0 0 0 r
s
.24 .35 .67 r
.40769 .53447 m
.42875 .54781 L
s
.214 .05 .021 r
.46508 .5371 m .46056 .53573 L .43452 .52703 L p F P
0 0 0 r
s
.24 .35 .67 r
.7617 .21594 m
.80413 .20592 L
s
.7617 .21594 m
.74496 .19304 L
s
1 .297 .122 r
.69692 .39077 m .70949 .39629 L .70287 .42153 L p F P
0 0 0 r
s
.83 .24 .1 r
.70763 .39548 m
.70789 .39168 L
s
1 .286 .117 r
.70949 .39629 m .69692 .39077 L .69861 .36494 L p F P
0 0 0 r
s
1 .321 .135 r
.61855 .52493 m .62461 .52698 L .59041 .5357 L p F P
0 0 0 r
s
.24 .35 .67 r
.5864 .5346 m
.60411 .52654 L
s
.83 .24 .1 r
.59277 .5351 m
.5959 .53612 L
s
1 .323 .135 r
.62461 .52698 m .61855 .52493 L .6482 .51189 L p F P
0 0 0 r
s
.195 .318 .617 r
.55099 .54098 m .54785 .54147 L .57792 .53766 L p F P
0 0 0 r
s
.195 .318 .617 r
.57792 .53766 m .58416 .53668 L .55099 .54098 L p F P
0 0 0 r
s
.83 .24 .1 r
.55898 .54501 m
.57394 .53889 L
s
.70272 .42186 m
.70284 .42136 L
s
.24 .35 .67 r
.33214 .49515 m
.35002 .52087 L
s
.35 .078 .032 r
.61489 .24057 m .60535 .23573 L .58981 .2243 L p F P
0 0 0 r
s
.35 .078 .032 r
.58178 .22021 m .58981 .2243 L .60535 .23573 L p F P
0 0 0 r
s
.24 .35 .67 r
.26968 .43855 m
.28046 .4718 L
s
.847 .264 .114 r
.5167 .54118 m .49721 .54325 L .49945 .54394 L closepath p F P
0 0 0 r
s
.254 .399 .781 r
.53222 .54393 m .53533 .54344 L .5167 .54118 L closepath p F P
0 0 0 r
s
.51 .125 .049 r
.40187 .51195 m .39296 .50922 L .36816 .49227 L p F P
0 0 0 r
s
.351 .078 .033 r
.39296 .50922 m .40187 .51195 L .42776 .52498 L p F P
0 0 0 r
s
.83 .24 .1 r
.39768 .50329 m
.41983 .51956 L
s
.41983 .51956 m
.44903 .52847 L
s
.83 .224 .089 r
.65383 .28127 m .66549 .28703 L .67623 .30937 L p F P
0 0 0 r
s
.696 .182 .07 r
.66549 .28703 m .65383 .28127 L .64054 .26178 L p F P
0 0 0 r
s
.795 .213 .085 r
.34717 .4725 m .33452 .46848 L .31648 .44588 L p F P
0 0 0 r
s
.672 .175 .069 r
.33452 .46848 m .34717 .4725 L .36816 .49227 L p F P
0 0 0 r
s
1 .323 .135 r
.64045 .50916 m .6482 .51189 L .61855 .52493 L p F P
0 0 0 r
s
.24 .35 .67 r
.64435 .52015 m
.648 .51655 L
s
.63619 .52145 m
.64435 .52015 L
s
1 .321 .134 r
.6482 .51189 m .64045 .50916 L .66526 .49218 L p F P
0 0 0 r
s
.024 .035 .067 r
.48961 .20913 m .49856 .20683 L .49294 .21135 L p F P
0 0 0 r
s
.024 .035 .067 r
.49294 .21135 m .48125 .21434 L .48961 .20913 L p F P
0 0 0 r
s
.24 .35 .67 r
.6855 .51361 m
.70012 .4988 L
s
.70012 .4988 m
.74189 .49202 L
s
1 .317 .132 r
.67581 .46838 m .68625 .47241 L .66526 .49218 L p F P
0 0 0 r
s
1 .312 .129 r
.68625 .47241 m .67581 .46838 L .69156 .44577 L p F P
0 0 0 r
s
.614 .201 .088 r
.46056 .53573 m .46508 .5371 L .49045 .54119 L p F P
0 0 0 r
s
.614 .201 .088 r
.49271 .54188 m .49045 .54119 L .46508 .5371 L p F P
0 0 0 r
s
.24 .35 .67 r
.46707 .54165 m
.48801 .54795 L
s
.42875 .54781 m
.46707 .54165 L
s
.191 .268 .543 r
.28163 .33971 m .29997 .33544 L .29649 .36089 L p F P
0 0 0 r
s
.191 .268 .543 r
.29649 .36089 m .27788 .36508 L .28163 .33971 L p F P
0 0 0 r
s
.24 .35 .67 r
.74189 .49202 m
.75318 .47116 L
s
.75318 .47116 m
.79558 .46406 L
s
.254 .399 .781 r
.53533 .54344 m .53845 .54295 L .5167 .54118 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.89395 .35918 m
.85044 .36747 L
s
.85012 .40036 m
.85044 .36747 L
s
.978 .272 .11 r
.68305 .33359 m .69575 .33957 L .69861 .36494 L p F P
0 0 0 r
s
.918 .252 .101 r
.69575 .33957 m .68305 .33359 L .67623 .30937 L p F P
0 0 0 r
s
.24 .35 .67 r
.64435 .52015 m
.6855 .51361 L
s
.054 .065 .125 r
.44666 .22319 m .45811 .22026 L .44559 .23089 L p F P
0 0 0 r
s
.054 .065 .125 r
.44559 .23089 m .43175 .2344 L .44666 .22319 L p F P
0 0 0 r
s
.088 .108 .226 r
.40441 .24134 m .41803 .23789 L .403 .25334 L p F P
0 0 0 r
s
.088 .108 .226 r
.403 .25334 m .3874 .25724 L .40441 .24134 L p F P
0 0 0 r
s
.847 .264 .114 r
.5167 .54118 m .49496 .54257 L .49721 .54325 L closepath p F P
0 0 0 r
s
.195 .318 .617 r
.55414 .54048 m .55099 .54098 L .58416 .53668 L p F P
0 0 0 r
s
.195 .318 .617 r
.58416 .53668 m .59041 .5357 L .55414 .54048 L p F P
0 0 0 r
s
.24 .35 .67 r
.54677 .54084 m
.5864 .5346 L
s
.83 .24 .1 r
.57394 .53889 m
.57696 .53765 L
s
.24 .35 .67 r
.26345 .40379 m
.26968 .43855 L
s
.254 .399 .781 r
.53845 .54295 m .54158 .54246 L .5167 .54118 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.5278 .54175 m
.54677 .54084 L
s
.53 .131 .051 r
.64054 .26178 m .62978 .25637 L .61489 .24057 L p F P
0 0 0 r
s
.53 .131 .051 r
.60535 .23573 m .61489 .24057 L .62978 .25637 L p F P
0 0 0 r
s
.696 .182 .07 r
.62978 .25637 m .64054 .26178 L .65383 .28127 L p F P
0 0 0 r
s
.934 .258 .105 r
.30353 .42165 m .28828 .41652 L .2801 .39091 L p F P
0 0 0 r
s
.877 .239 .097 r
.28828 .41652 m .30353 .42165 L .31648 .44588 L p F P
0 0 0 r
s
1 .306 .126 r
.69069 .41639 m .70287 .42153 L .69156 .44577 L p F P
0 0 0 r
s
1 .297 .122 r
.70287 .42153 m .69069 .41639 L .69692 .39077 L p F P
0 0 0 r
s
.175 .243 .494 r
.30884 .3112 m .32668 .30693 L .31853 .33112 L p F P
0 0 0 r
s
.175 .243 .494 r
.31853 .33112 m .29997 .33544 L .30884 .3112 L p F P
0 0 0 r
s
.847 .264 .114 r
.5167 .54118 m .49271 .54188 L .49496 .54257 L closepath p F P
0 0 0 r
s
.44 .141 .066 r
.57368 .21608 m .56551 .21192 L .55397 .20727 L p F P
0 0 0 r
s
.44 .141 .066 r
.54763 .20404 m .55397 .20727 L .56551 .21192 L p F P
0 0 0 r
s
.254 .399 .781 r
.54158 .54246 m .54471 .54197 L .5167 .54118 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.79558 .46406 m
.80322 .43804 L
s
.80322 .43804 m
.84627 .43054 L
s
.126 .164 .342 r
.37193 .26111 m .3874 .25724 L .37343 .27636 L p F P
0 0 0 r
s
.24 .35 .67 r
.3704 .26303 m
.37208 .26261 L
s
.126 .164 .342 r
.37343 .27636 m .35638 .28055 L .37193 .26111 L p F P
0 0 0 r
s
.672 .175 .069 r
.36816 .49227 m .3572 .48886 L .33452 .46848 L p F P
0 0 0 r
s
.51 .125 .049 r
.3572 .48886 m .36816 .49227 L .39296 .50922 L p F P
0 0 0 r
s
1 .321 .134 r
.656 .48878 m .66526 .49218 L .64045 .50916 L p F P
0 0 0 r
s
1 .317 .132 r
.66526 .49218 m .656 .48878 L .67581 .46838 L p F P
0 0 0 r
s
.214 .05 .021 r
.46056 .53573 m .45602 .53435 L .42776 .52498 L p F P
0 0 0 r
s
.614 .201 .088 r
.45602 .53435 m .46056 .53573 L .48819 .5405 L p F P
0 0 0 r
s
.83 .24 .1 r
.47418 .53808 m
.47449 .53818 L
s
.47449 .53818 m
.47503 .53823 L
s
.614 .201 .088 r
.49045 .54119 m .48819 .5405 L .46056 .53573 L p F P
0 0 0 r
s
.83 .24 .1 r
.47761 .53848 m
.50229 .54088 L
s
.024 .035 .067 r
.49856 .20683 m .50755 .20452 L .5047 .20834 L p F P
0 0 0 r
s
.024 .035 .067 r
.5047 .20834 m .49294 .21135 L .49856 .20683 L p F P
0 0 0 r
s
.351 .078 .033 r
.42776 .52498 m .42096 .52292 L .39296 .50922 L p F P
0 0 0 r
s
.214 .05 .021 r
.42096 .52292 m .42776 .52498 L .45602 .53435 L p F P
0 0 0 r
s
1 .315 .133 r
.58619 .53432 m .59041 .5357 L .55414 .54048 L p F P
0 0 0 r
s
1 .321 .135 r
.59041 .5357 m .58619 .53432 L .61855 .52493 L p F P
0 0 0 r
s
1 .321 .135 r
.61244 .52286 m .61855 .52493 L .58619 .53432 L p F P
0 0 0 r
s
.83 .24 .1 r
.58416 .53471 m
.58746 .53336 L
s
.58746 .53336 m
.58799 .53354 L
s
1 .323 .135 r
.61855 .52493 m .61244 .52286 L .64045 .50916 L p F P
0 0 0 r
s
.155 .21 .43 r
.3395 .28469 m .35638 .28055 L .34471 .30261 L p F P
0 0 0 r
s
.155 .21 .43 r
.34471 .30261 m .32668 .30693 L .3395 .28469 L p F P
0 0 0 r
s
.254 .399 .781 r
.54471 .54197 m .54785 .54147 L .5167 .54118 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.50278 .18907 m
.47475 .18953 L
s
.44544 .17498 m
.47475 .18953 L
s
.847 .264 .114 r
.5167 .54118 m .49045 .54119 L .49271 .54188 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.50229 .54088 m
.50328 .54118 L
s
.24 .35 .67 r
.81884 .23375 m
.86213 .22389 L
s
.81884 .23375 m
.80413 .20592 L
s
.83 .24 .1 r
.41703 .18266 m
.38958 .19693 L
s
.35889 .1825 m
.38958 .19693 L
s
.204 .289 .584 r
.27788 .36508 m .29649 .36089 L .29855 .3869 L p F P
0 0 0 r
s
.24 .35 .67 r
.29655 .36154 m
.29874 .36105 L
s
.83 .24 .1 r
.26421 .35939 m
.27918 .36479 L
s
.204 .289 .584 r
.29855 .3869 m .2801 .39091 L .27788 .36508 L p F P
0 0 0 r
s
.978 .272 .11 r
.69861 .36494 m .68573 .35907 L .68305 .33359 L p F P
0 0 0 r
s
1 .286 .117 r
.68573 .35907 m .69861 .36494 L .69692 .39077 L p F P
0 0 0 r
s
.054 .065 .125 r
.45811 .22026 m .46964 .21731 L .45954 .22735 L p F P
0 0 0 r
s
.054 .065 .125 r
.45954 .22735 m .44559 .23089 L .45811 .22026 L p F P
0 0 0 r
s
.254 .399 .781 r
.54785 .54147 m .55099 .54098 L .5167 .54118 L closepath p F P
0 0 0 r
s
.35 .078 .032 r
.60535 .23573 m .5957 .23083 L .58178 .22021 L p F P
0 0 0 r
s
.35 .078 .032 r
.57368 .21608 m .58178 .22021 L .5957 .23083 L p F P
0 0 0 r
s
.877 .239 .097 r
.31648 .44588 m .30226 .44123 L .28828 .41652 L p F P
0 0 0 r
s
.795 .213 .085 r
.30226 .44123 m .31648 .44588 L .33452 .46848 L p F P
0 0 0 r
s
.918 .252 .101 r
.66381 .30336 m .67623 .30937 L .68305 .33359 L p F P
0 0 0 r
s
.83 .24 .1 r
.67335 .30575 m
.67423 .3084 L
s
.83 .224 .089 r
.67623 .30937 m .66381 .30336 L .65383 .28127 L p F P
0 0 0 r
s
1 .312 .129 r
.68004 .44112 m .69156 .44577 L .67581 .46838 L p F P
0 0 0 r
s
1 .306 .126 r
.69156 .44577 m .68004 .44112 L .69069 .41639 L p F P
0 0 0 r
s
.847 .264 .114 r
.5167 .54118 m .48819 .5405 L .49045 .54119 L closepath p F P
0 0 0 r
s
.51 .125 .049 r
.39296 .50922 m .38396 .50647 L .3572 .48886 L p F P
0 0 0 r
s
.351 .078 .033 r
.38396 .50647 m .39296 .50922 L .42096 .52292 L p F P
0 0 0 r
s
1 .323 .135 r
.63262 .5064 m .64045 .50916 L .61244 .52286 L p F P
0 0 0 r
s
1 .321 .134 r
.64045 .50916 m .63262 .5064 L .656 .48878 L p F P
0 0 0 r
s
.088 .108 .226 r
.41803 .23789 m .43175 .2344 L .41876 .2494 L p F P
0 0 0 r
s
.088 .108 .226 r
.41876 .2494 m .403 .25334 L .41803 .23789 L p F P
0 0 0 r
s
.254 .399 .781 r
.55099 .54098 m .55414 .54048 L .5167 .54118 L closepath p F P
0 0 0 r
s
.214 .05 .021 r
.45602 .53435 m .45145 .53297 L .42096 .52292 L p F P
0 0 0 r
s
.614 .201 .088 r
.45145 .53297 m .45602 .53435 L .48592 .53981 L p F P
0 0 0 r
s
.83 .24 .1 r
.47076 .53704 m
.47189 .53739 L
s
.614 .201 .088 r
.48819 .5405 m .48592 .53981 L .45602 .53435 L p F P
0 0 0 r
s
.24 .35 .67 r
.46707 .54165 m
.47902 .53973 L
s
1 .315 .133 r
.55414 .54048 m .55195 .53979 L .58619 .53432 L p F P
0 0 0 r
s
1 .315 .133 r
.58195 .53294 m .58619 .53432 L .55195 .53979 L p F P
0 0 0 r
s
1 .321 .135 r
.58619 .53432 m .58195 .53294 L .61244 .52286 L p F P
0 0 0 r
s
.024 .035 .067 r
.50755 .20452 m .51659 .2022 L .51655 .2053 L p F P
0 0 0 r
s
.24 .35 .67 r
.51656 .20491 m
.52552 .20297 L
s
.024 .035 .067 r
.51655 .2053 m .5047 .20834 L .50755 .20452 L p F P
0 0 0 r
s
.44 .141 .066 r
.56551 .21192 m .55725 .20771 L .54763 .20404 L p F P
0 0 0 r
s
.83 .24 .1 r
.55748 .21005 m
.58464 .22385 L
s
.44 .141 .066 r
.54124 .2008 m .54763 .20404 L .55725 .20771 L p F P
0 0 0 r
s
.83 .24 .1 r
.53098 .20329 m
.55748 .21005 L
s
.52944 .1958 m
.53251 .19736 L
s
.847 .264 .114 r
.5167 .54118 m .48592 .53981 L .48819 .5405 L closepath p F P
0 0 0 r
s
.983 .298 .127 r
.55195 .53979 m .55414 .54048 L .5167 .54118 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.84627 .43054 m
.85012 .40036 L
s
.85012 .40036 m
.89387 .3924 L
s
.191 .268 .543 r
.29997 .33544 m .31853 .33112 L .31533 .35665 L p F P
0 0 0 r
s
.191 .268 .543 r
.31533 .35665 m .29649 .36089 L .29997 .33544 L p F P
0 0 0 r
s
.24 .35 .67 r
.29874 .36105 m
.29881 .36037 L
s
.351 .078 .033 r
.42096 .52292 m .41411 .52084 L .38396 .50647 L p F P
0 0 0 r
s
.214 .05 .021 r
.41411 .52084 m .42096 .52292 L .45145 .53297 L p F P
0 0 0 r
s
1 .321 .135 r
.60629 .52078 m .61244 .52286 L .58195 .53294 L p F P
0 0 0 r
s
1 .323 .135 r
.61244 .52286 m .60629 .52078 L .63262 .5064 L p F P
0 0 0 r
s
.795 .213 .085 r
.33452 .46848 m .3217 .46441 L .30226 .44123 L p F P
0 0 0 r
s
.24 .35 .67 r
.28046 .4718 m
.31739 .46472 L
s
.83 .24 .1 r
.30549 .43463 m
.33665 .44492 L
s
.672 .175 .069 r
.3217 .46441 m .33452 .46848 L .3572 .48886 L p F P
0 0 0 r
s
1 .317 .132 r
.66523 .46431 m .67581 .46838 L .656 .48878 L p F P
0 0 0 r
s
1 .312 .129 r
.67581 .46838 m .66523 .46431 L .68004 .44112 L p F P
0 0 0 r
s
.83 .24 .1 r
.29175 .25833 m
.2774 .29082 L
s
.2448 .27787 m
.2774 .29082 L
s
.2774 .29082 m
.2681 .32494 L
s
.215 .307 .618 r
.2801 .39091 m .29855 .3869 L .30613 .41279 L p F P
0 0 0 r
s
.215 .307 .618 r
.30613 .41279 m .28828 .41652 L .2801 .39091 L p F P
0 0 0 r
s
.24 .35 .67 r
.26345 .40379 m
.28288 .39963 L
s
.83 .24 .1 r
.26594 .39285 m
.28371 .39898 L
s
.30047 .41397 m
.30549 .43463 L
s
1 .297 .122 r
.68415 .38516 m .69692 .39077 L .69069 .41639 L p F P
0 0 0 r
s
1 .286 .117 r
.69692 .39077 m .68415 .38516 L .68573 .35907 L p F P
0 0 0 r
s
.83 .24 .1 r
.684 .35925 m
.68567 .36001 L
s
.24 .35 .67 r
.68502 .18613 m
.72692 .17569 L
s
.68502 .18613 m
.66607 .17546 L
s
.83 .24 .1 r
.31059 .22869 m
.29175 .25833 L
s
.25936 .24485 m
.29175 .25833 L
s
.83 .224 .089 r
.64201 .27542 m .65383 .28127 L .66381 .30336 L p F P
0 0 0 r
s
.696 .182 .07 r
.65383 .28127 m .64201 .27542 L .62978 .25637 L p F P
0 0 0 r
s
.83 .24 .1 r
.62863 .2576 m
.63149 .25903 L
s
.614 .201 .088 r
.48592 .53981 m .48364 .53911 L .45145 .53297 L p F P
0 0 0 r
s
.24 .35 .67 r
.47902 .53973 m
.48269 .53914 L
s
.847 .264 .114 r
.5167 .54118 m .48364 .53911 L .48592 .53981 L closepath p F P
0 0 0 r
s
.126 .164 .342 r
.3874 .25724 m .403 .25334 L .39066 .27213 L p F P
0 0 0 r
s
.24 .35 .67 r
.38602 .25913 m
.38772 .25871 L
s
.126 .164 .342 r
.39066 .27213 m .37343 .27636 L .3874 .25724 L p F P
0 0 0 r
s
.983 .298 .127 r
.54976 .5391 m .55195 .53979 L .5167 .54118 L closepath p F P
0 0 0 r
s
1 .315 .133 r
.55195 .53979 m .54976 .5391 L .58195 .53294 L p F P
0 0 0 r
s
.53 .131 .051 r
.62978 .25637 m .61888 .2509 L .60535 .23573 L p F P
0 0 0 r
s
.83 .24 .1 r
.62498 .25396 m
.62863 .2576 L
s
.53 .131 .051 r
.5957 .23083 m .60535 .23573 L .61888 .2509 L p F P
0 0 0 r
s
.24 .35 .67 r
.62486 .18591 m
.66607 .17546 L
s
.62486 .18591 m
.60571 .18244 L
s
.054 .065 .125 r
.46964 .21731 m .48125 .21434 L .47361 .22379 L p F P
0 0 0 r
s
.054 .065 .125 r
.47361 .22379 m .45954 .22735 L .46964 .21731 L p F P
0 0 0 r
s
.175 .243 .494 r
.32668 .30693 m .34471 .30261 L .33729 .32675 L p F P
0 0 0 r
s
.175 .243 .494 r
.33729 .32675 m .31853 .33112 L .32668 .30693 L p F P
0 0 0 r
s
.214 .05 .021 r
.45145 .53297 m .44686 .53158 L .41411 .52084 L p F P
0 0 0 r
s
.614 .201 .088 r
.44686 .53158 m .45145 .53297 L .48364 .53911 L p F P
0 0 0 r
s
.24 .35 .67 r
.45611 .53453 m
.46707 .54165 L
s
1 .315 .133 r
.57769 .53155 m .58195 .53294 L .54976 .5391 L p F P
0 0 0 r
s
1 .321 .135 r
.58195 .53294 m .57769 .53155 L .60629 .52078 L p F P
0 0 0 r
s
.024 .035 .067 r
.51659 .2022 m .52567 .19987 L .52848 .20225 L p F P
0 0 0 r
s
.83 .24 .1 r
.50278 .18907 m
.52224 .19888 L
s
.52224 .19888 m
.5245 .20002 L
s
.024 .035 .067 r
.52848 .20225 m .51655 .2053 L .51659 .2022 L p F P
0 0 0 r
s
.24 .35 .67 r
.74496 .19304 m
.78759 .18267 L
s
.74496 .19304 m
.72692 .17569 L
s
.155 .21 .43 r
.35638 .28055 m .37343 .27636 L .36295 .29824 L p F P
0 0 0 r
s
.155 .21 .43 r
.36295 .29824 m .34471 .30261 L .35638 .28055 L p F P
0 0 0 r
s
.672 .175 .069 r
.3572 .48886 m .34611 .48541 L .3217 .46441 L p F P
0 0 0 r
s
.24 .35 .67 r
.31739 .46472 m
.33214 .49515 L
s
.51 .125 .049 r
.34611 .48541 m .3572 .48886 L .38396 .50647 L p F P
0 0 0 r
s
.83 .24 .1 r
.34958 .47175 m
.36746 .49392 L
s
.36746 .49392 m
.39768 .50329 L
s
.696 .182 .07 r
.61888 .2509 m .62978 .25637 L .64201 .27542 L p F P
0 0 0 r
s
.83 .24 .1 r
.23529 .31252 m
.2681 .32494 L
s
.2681 .32494 m
.26421 .35939 L
s
.24 .35 .67 r
.56516 .19282 m
.60571 .18244 L
s
.56516 .19282 m
.5466 .19683 L
s
1 .321 .134 r
.64663 .48533 m .656 .48878 L .63262 .5064 L p F P
0 0 0 r
s
1 .317 .132 r
.656 .48878 m .64663 .48533 L .66523 .46431 L p F P
0 0 0 r
s
.24 .35 .67 r
.88403 .28949 m
.89062 .32445 L
s
.87443 .25556 m
.88403 .28949 L
s
.614 .201 .088 r
.48364 .53911 m .48136 .53842 L .44686 .53158 L p F P
0 0 0 r
s
.24 .35 .67 r
.4539 .53309 m
.45611 .53453 L
s
.847 .264 .114 r
.5167 .54118 m .48136 .53842 L .48364 .53911 L closepath p F P
0 0 0 r
s
.983 .298 .127 r
.54756 .5384 m .54976 .5391 L .5167 .54118 L closepath p F P
0 0 0 r
s
1 .315 .133 r
.54976 .5391 m .54756 .5384 L .57769 .53155 L p F P
0 0 0 r
s
.978 .272 .11 r
.67015 .32751 m .68305 .33359 L .68573 .35907 L p F P
0 0 0 r
s
.83 .24 .1 r
.68052 .32961 m
.68087 .33256 L
s
.68343 .35442 m
.684 .35925 L
s
.918 .252 .101 r
.68305 .33359 m .67015 .32751 L .66381 .30336 L p F P
0 0 0 r
s
.274 .419 .827 r
.5167 .54118 m .51034 .53267 L .5135 .53216 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.50578 .54032 m
.51496 .53886 L
s
.274 .419 .827 r
.5167 .54118 m .5135 .53216 L .51666 .53165 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.51669 .53858 m
.52316 .54059 L
s
.274 .419 .827 r
.5167 .54118 m .51666 .53165 L .51983 .53114 L closepath p F P
0 0 0 r
s
.274 .419 .827 r
.5167 .54118 m .51983 .53114 L .523 .53063 L closepath p F P
0 0 0 r
s
.274 .419 .827 r
.5167 .54118 m .48217 .53722 L .48528 .53672 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.49526 .53872 m
.49867 .53977 L
s
.274 .419 .827 r
.5167 .54118 m .48528 .53672 L .48839 .53622 L closepath p F P
0 0 0 r
s
.274 .419 .827 r
.5167 .54118 m .48839 .53622 L .49151 .53571 L closepath p F P
0 0 0 r
s
.274 .419 .827 r
.5167 .54118 m .49151 .53571 L .49463 .53521 L closepath p F P
0 0 0 r
s
.274 .419 .827 r
.5167 .54118 m .49463 .53521 L .49776 .5347 L closepath p F P
0 0 0 r
s
.274 .419 .827 r
.5167 .54118 m .49776 .5347 L .5009 .5342 L closepath p F P
0 0 0 r
s
.274 .419 .827 r
.5167 .54118 m .5009 .5342 L .50404 .53369 L closepath p F P
0 0 0 r
s
.274 .419 .827 r
.5167 .54118 m .50404 .53369 L .50718 .53318 L closepath p F P
0 0 0 r
s
.274 .419 .827 r
.5167 .54118 m .50718 .53318 L .51034 .53267 L closepath p F P
0 0 0 r
s
.847 .264 .114 r
.5167 .54118 m .47907 .53772 L .48136 .53842 L closepath p F P
0 0 0 r
s
.983 .298 .127 r
.54535 .5377 m .54756 .5384 L .5167 .54118 L closepath p F P
0 0 0 r
s
.983 .298 .127 r
.54314 .537 m .54535 .5377 L .5167 .54118 L closepath p F P
0 0 0 r
s
.983 .298 .127 r
.54093 .5363 m .54314 .537 L .5167 .54118 L closepath p F P
0 0 0 r
s
.274 .419 .827 r
.5167 .54118 m .47907 .53772 L .48217 .53722 L closepath p F P
0 0 0 r
s
.983 .298 .127 r
.53871 .5356 m .54093 .5363 L .5167 .54118 L closepath p F P
0 0 0 r
s
.983 .298 .127 r
.53648 .53489 m .53871 .5356 L .5167 .54118 L closepath p F P
0 0 0 r
s
.983 .298 .127 r
.53425 .53419 m .53648 .53489 L .5167 .54118 L closepath p F P
0 0 0 r
s
.983 .298 .127 r
.53201 .53348 m .53425 .53419 L .5167 .54118 L closepath p F P
0 0 0 r
s
.983 .298 .127 r
.52977 .53277 m .53201 .53348 L .5167 .54118 L closepath p F P
0 0 0 r
s
.983 .298 .127 r
.52752 .53206 m .52977 .53277 L .5167 .54118 L closepath p F P
0 0 0 r
s
.983 .298 .127 r
.52526 .53134 m .52752 .53206 L .5167 .54118 L closepath p F P
0 0 0 r
s
.983 .298 .127 r
.523 .53063 m .52526 .53134 L .5167 .54118 L closepath p F P
0 0 0 r
s
.088 .108 .226 r
.43175 .2344 m .44559 .23089 L .43466 .24542 L p F P
0 0 0 r
s
.088 .108 .226 r
.43466 .24542 m .41876 .2494 L .43175 .2344 L p F P
0 0 0 r
s
.24 .35 .67 r
.89062 .32445 m
.89395 .35918 L
s
.35 .078 .032 r
.5957 .23083 m .58593 .22588 L .57368 .21608 L p F P
0 0 0 r
s
.35 .078 .032 r
.56551 .21192 m .57368 .21608 L .58593 .22588 L p F P
0 0 0 r
s
.51 .125 .049 r
.38396 .50647 m .37487 .50368 L .34611 .48541 L p F P
0 0 0 r
s
.24 .35 .67 r
.33214 .49515 m
.3542 .49114 L
s
.3542 .49114 m
.35492 .49101 L
s
.351 .078 .033 r
.37487 .50368 m .38396 .50647 L .41411 .52084 L p F P
0 0 0 r
s
.44 .141 .066 r
.55725 .20771 m .54891 .20347 L .54124 .2008 L p F P
0 0 0 r
s
.44 .141 .066 r
.53481 .19752 m .54124 .2008 L .54891 .20347 L p F P
0 0 0 r
s
1 .323 .135 r
.62472 .50362 m .63262 .5064 L .60629 .52078 L p F P
0 0 0 r
s
.83 .24 .1 r
.60525 .52117 m
.60759 .51957 L
s
.24 .35 .67 r
.62693 .52822 m
.64435 .52015 L
s
1 .321 .134 r
.63262 .5064 m .62472 .50362 L .64663 .48533 L p F P
0 0 0 r
s
.83 .24 .1 r
.6383 .49053 m
.63976 .49106 L
s
.225 .323 .649 r
.28828 .41652 m .30613 .41279 L .31909 .43787 L p F P
0 0 0 r
s
.225 .323 .649 r
.31909 .43787 m .30226 .44123 L .28828 .41652 L p F P
0 0 0 r
s
.24 .35 .67 r
.26968 .43855 m
.29754 .4329 L
s
.83 .24 .1 r
.27331 .424 m
.29833 .43226 L
s
.33325 .20307 m
.31059 .22869 L
s
.27843 .2147 m
.31059 .22869 L
s
.204 .289 .584 r
.29649 .36089 m .31533 .35665 L .31722 .38285 L p F P
0 0 0 r
s
.204 .289 .584 r
.31722 .38285 m .29855 .3869 L .29649 .36089 L p F P
0 0 0 r
s
.24 .35 .67 r
.29984 .38662 m
.30008 .39213 L
s
.214 .05 .021 r
.4072 .51874 m .41411 .52084 L .44686 .53158 L p F P
0 0 0 r
s
.214 .05 .021 r
.44686 .53158 m .44225 .53018 L .4072 .51874 L p F P
0 0 0 r
s
.614 .201 .088 r
.44225 .53018 m .44686 .53158 L .48136 .53842 L p F P
0 0 0 r
s
.614 .201 .088 r
.48136 .53842 m .47907 .53772 L .44225 .53018 L p F P
0 0 0 r
s
1 .306 .126 r
.67831 .41118 m .69069 .41639 L .68004 .44112 L p F P
0 0 0 r
s
1 .297 .122 r
.69069 .41639 m .67831 .41118 L .68415 .38516 L p F P
0 0 0 r
s
1 .315 .133 r
.54756 .5384 m .54535 .5377 L .5734 .53015 L p F P
0 0 0 r
s
1 .315 .133 r
.5734 .53015 m .57769 .53155 L .54756 .5384 L p F P
0 0 0 r
s
.83 .24 .1 r
.62884 .50017 m
.6383 .49053 L
s
.351 .078 .033 r
.41411 .52084 m .4072 .51874 L .37487 .50368 L p F P
0 0 0 r
s
.24 .35 .67 r
.35002 .52087 m
.38775 .51435 L
s
.38775 .51435 m
.40769 .53447 L
s
.83 .24 .1 r
.41983 .51956 m
.44542 .52934 L
s
.24 .35 .67 r
.40769 .53447 m
.4393 .52922 L
s
1 .321 .135 r
.60009 .51869 m .60629 .52078 L .57769 .53155 L p F P
0 0 0 r
s
1 .323 .135 r
.60629 .52078 m .60009 .51869 L .62472 .50362 L p F P
0 0 0 r
s
1 .321 .135 r
.57769 .53155 m .5734 .53015 L .60009 .51869 L p F P
0 0 0 r
s
.24 .35 .67 r
.86213 .22389 m
.87443 .25556 L
s
.44 .141 .066 r
.54891 .20347 m .5405 .19918 L .53481 .19752 L p F P
0 0 0 r
s
.024 .035 .067 r
.52567 .19987 m .53481 .19752 L .5405 .19918 L p F P
0 0 0 r
s
.24 .35 .67 r
.53906 .19876 m
.54225 .19794 L
s
.83 .24 .1 r
.53251 .19736 m
.53515 .1987 L
s
.024 .035 .067 r
.5405 .19918 m .52848 .20225 L .52567 .19987 L p F P
0 0 0 r
s
.24 .35 .67 r
.80413 .20592 m
.84756 .19567 L
s
.80413 .20592 m
.78759 .18267 L
s
.38307 .5075 m
.38345 .50806 L
s
.38345 .50806 m
.38775 .51435 L
s
.38775 .51435 m
.39505 .51308 L
s
.054 .065 .125 r
.48125 .21434 m .49294 .21135 L .4878 .22019 L p F P
0 0 0 r
s
.054 .065 .125 r
.4878 .22019 m .47361 .22379 L .48125 .21434 L p F P
0 0 0 r
s
.24 .35 .67 r
.31455 .45589 m
.31586 .45994 L
s
.31586 .45994 m
.31739 .46472 L
s
.83 .24 .1 r
.44544 .17498 m
.41703 .18266 L
s
.38656 .16789 m
.41703 .18266 L
s
.274 .413 .818 r
.48217 .53722 m .47907 .53772 L .44225 .53018 L p F P
0 0 0 r
s
.83 .24 .1 r
.44542 .52934 m
.45639 .53268 L
s
1 .315 .133 r
.54535 .5377 m .54314 .537 L .56909 .52874 L p F P
0 0 0 r
s
1 .315 .133 r
.56909 .52874 m .5734 .53015 L .54535 .5377 L p F P
0 0 0 r
s
.24 .35 .67 r
.72762 .50692 m
.74189 .49202 L
s
.74189 .49202 m
.78463 .48508 L
s
.234 .339 .679 r
.30226 .44123 m .31909 .43787 L .33709 .46146 L p F P
0 0 0 r
s
.234 .339 .679 r
.33709 .46146 m .3217 .46441 L .30226 .44123 L p F P
0 0 0 r
s
.83 .24 .1 r
.31653 .45792 m
.31837 .46181 L
s
.31413 .45286 m
.31653 .45792 L
s
.24 .35 .67 r
.31739 .46472 m
.32132 .46396 L
s
.83 .24 .1 r
.32471 .46383 m
.34958 .47175 L
s
.23122 .34749 m
.26421 .35939 L
s
.26421 .35939 m
.26594 .39285 L
s
1 .312 .129 r
.66835 .43641 m .68004 .44112 L .66523 .46431 L p F P
0 0 0 r
s
1 .306 .126 r
.68004 .44112 m .66835 .43641 L .67831 .41118 L p F P
0 0 0 r
s
.191 .268 .543 r
.31853 .33112 m .33729 .32675 L .33438 .35236 L p F P
0 0 0 r
s
.191 .268 .543 r
.33438 .35236 m .31533 .35665 L .31853 .33112 L p F P
0 0 0 r
s
.126 .164 .342 r
.403 .25334 m .41876 .2494 L .40807 .26786 L p F P
0 0 0 r
s
.24 .35 .67 r
.40178 .2552 m
.4035 .25477 L
s
.126 .164 .342 r
.40807 .26786 m .39066 .27213 L .403 .25334 L p F P
0 0 0 r
s
.274 .413 .818 r
.44225 .53018 m .44832 .52918 L .48217 .53722 L p F P
0 0 0 r
s
.83 .24 .1 r
.44542 .52934 m
.44664 .52946 L
s
.274 .413 .818 r
.48528 .53672 m .48217 .53722 L .44832 .52918 L p F P
0 0 0 r
s
.24 .35 .67 r
.78463 .48508 m
.79558 .46406 L
s
.79558 .46406 m
.83896 .4568 L
s
.89395 .35918 m
.89387 .3924 L
s
.6684 .52169 m
.6855 .51361 L
s
.6855 .51361 m
.72762 .50692 L
s
.978 .272 .11 r
.68573 .35907 m .67264 .3531 L .67015 .32751 L p F P
0 0 0 r
s
1 .286 .117 r
.67264 .3531 m .68573 .35907 L .68415 .38516 L p F P
0 0 0 r
s
.918 .252 .101 r
.65119 .29725 m .66381 .30336 L .67015 .32751 L p F P
0 0 0 r
s
.83 .224 .089 r
.66381 .30336 m .65119 .29725 L .64201 .27542 L p F P
0 0 0 r
s
1 .315 .133 r
.54314 .537 m .54093 .5363 L .56476 .52733 L p F P
0 0 0 r
s
1 .315 .133 r
.56476 .52733 m .56909 .52874 L .54314 .537 L p F P
0 0 0 r
s
.24 .35 .67 r
.56688 .53548 m
.57929 .53492 L
s
.83 .24 .1 r
.52944 .1958 m
.50278 .18907 L
s
.47366 .17439 m
.50278 .18907 L
s
.215 .307 .618 r
.29855 .3869 m .31722 .38285 L .32419 .40903 L p F P
0 0 0 r
s
.215 .307 .618 r
.32419 .40903 m .30613 .41279 L .29855 .3869 L p F P
0 0 0 r
s
.267 .399 .793 r
.44832 .52918 m .44225 .53018 L .4072 .51874 L p F P
0 0 0 r
s
.24 .35 .67 r
.44486 .5283 m
.44618 .52808 L
s
.44618 .52808 m
.44758 .52899 L
s
1 .321 .135 r
.5734 .53015 m .56909 .52874 L .59385 .51658 L p F P
0 0 0 r
s
.83 .24 .1 r
.5748 .52922 m
.57523 .52936 L
s
1 .321 .135 r
.59385 .51658 m .60009 .51869 L .5734 .53015 L p F P
0 0 0 r
s
.24 .35 .67 r
.59337 .5335 m
.62693 .52822 L
s
.274 .413 .818 r
.44832 .52918 m .45442 .52817 L .48528 .53672 L p F P
0 0 0 r
s
.274 .413 .818 r
.48839 .53622 m .48528 .53672 L .45442 .52817 L p F P
0 0 0 r
s
.088 .108 .226 r
.44559 .23089 m .45954 .22735 L .45072 .2414 L p F P
0 0 0 r
s
.088 .108 .226 r
.45072 .2414 m .43466 .24542 L .44559 .23089 L p F P
0 0 0 r
s
.24 .35 .67 r
.43551 .24677 m
.43709 .24481 L
s
.53 .131 .051 r
.61888 .2509 m .60784 .24535 L .5957 .23083 L p F P
0 0 0 r
s
.53 .131 .051 r
.58593 .22588 m .5957 .23083 L .60784 .24535 L p F P
0 0 0 r
s
.242 .354 .707 r
.3217 .46441 m .33709 .46146 L .35967 .48292 L p F P
0 0 0 r
s
.83 .24 .1 r
.31837 .46181 m
.32223 .46304 L
s
.32223 .46304 m
.32239 .46309 L
s
.242 .354 .707 r
.35967 .48292 m .34611 .48541 L .3217 .46441 L p F P
0 0 0 r
s
.175 .243 .494 r
.34471 .30261 m .36295 .29824 L .35627 .32233 L p F P
0 0 0 r
s
.175 .243 .494 r
.35627 .32233 m .33729 .32675 L .34471 .30261 L p F P
0 0 0 r
s
.24 .35 .67 r
.60769 .52903 m
.62693 .52822 L
s
.62693 .52822 m
.6684 .52169 L
s
.54225 .19794 m
.5466 .19683 L
s
.155 .21 .43 r
.37343 .27636 m .39066 .27213 L .38138 .29382 L p F P
0 0 0 r
s
.155 .21 .43 r
.38138 .29382 m .36295 .29824 L .37343 .27636 L p F P
0 0 0 r
s
1 .317 .132 r
.6545 .46018 m .66523 .46431 L .64663 .48533 L p F P
0 0 0 r
s
1 .312 .129 r
.66523 .46431 m .6545 .46018 L .66835 .43641 L p F P
0 0 0 r
s
1 .315 .133 r
.54093 .5363 m .53871 .5356 L .56041 .52591 L p F P
0 0 0 r
s
1 .315 .133 r
.56041 .52591 m .56476 .52733 L .54093 .5363 L p F P
0 0 0 r
s
.24 .35 .67 r
.55077 .53803 m
.56688 .53548 L
s
.35 .078 .032 r
.58593 .22588 m .57606 .22087 L .56551 .21192 L p F P
0 0 0 r
s
.83 .24 .1 r
.58143 .22379 m
.58644 .22633 L
s
.55748 .21005 m
.57546 .22037 L
s
.57851 .22212 m
.58143 .22379 L
s
.35 .078 .032 r
.55725 .20771 m .56551 .21192 L .57606 .22087 L p F P
0 0 0 r
s
.83 .24 .1 r
.53756 .19993 m
.55748 .21005 L
s
.274 .413 .818 r
.45442 .52817 m .46054 .52716 L .48839 .53622 L p F P
0 0 0 r
s
.274 .413 .818 r
.49151 .53571 m .48839 .53622 L .46054 .52716 L p F P
0 0 0 r
s
.259 .384 .764 r
.41605 .51723 m .4072 .51874 L .37487 .50368 L p F P
0 0 0 r
s
.83 .24 .1 r
.41357 .51765 m
.41983 .51956 L
s
.267 .399 .793 r
.4072 .51874 m .41605 .51723 L .44832 .52918 L p F P
0 0 0 r
s
.83 .24 .1 r
.35889 .1825 m
.33325 .20307 L
s
.30132 .18859 m
.33325 .20307 L
s
.24 .35 .67 r
.83896 .4568 m
.84627 .43054 L
s
.84627 .43054 m
.89033 .42287 L
s
1 .323 .135 r
.60009 .51869 m .59385 .51658 L .61674 .50081 L p F P
0 0 0 r
s
1 .323 .135 r
.61674 .50081 m .62472 .50362 L .60009 .51869 L p F P
0 0 0 r
s
.251 .368 .736 r
.34611 .48541 m .35967 .48292 L .38623 .50168 L p F P
0 0 0 r
s
.251 .368 .736 r
.38623 .50168 m .37487 .50368 L .34611 .48541 L p F P
0 0 0 r
s
.83 .24 .1 r
.33627 .48425 m
.35469 .48996 L
s
.35469 .48996 m
.35568 .49027 L
s
.24 .35 .67 r
.37985 .5028 m
.38208 .50606 L
s
.56688 .53548 m
.60769 .52903 L
s
1 .321 .134 r
.63715 .48184 m .64663 .48533 L .62472 .50362 L p F P
0 0 0 r
s
1 .317 .132 r
.64663 .48533 m .63715 .48184 L .6545 .46018 L p F P
0 0 0 r
s
.259 .384 .764 r
.37487 .50368 m .38623 .50168 L .41605 .51723 L p F P
0 0 0 r
s
.83 .24 .1 r
.39299 .51137 m
.39582 .51224 L
s
1 .321 .134 r
.62472 .50362 m .61674 .50081 L .63715 .48184 L p F P
0 0 0 r
s
.054 .065 .125 r
.49294 .21135 m .5047 .20834 L .5021 .21656 L p F P
0 0 0 r
s
.24 .35 .67 r
.50469 .20838 m
.50479 .20831 L
s
.054 .065 .125 r
.5021 .21656 m .4878 .22019 L .49294 .21135 L p F P
0 0 0 r
s
.83 .224 .089 r
.63001 .26948 m .64201 .27542 L .65119 .29725 L p F P
0 0 0 r
s
.83 .24 .1 r
.63462 .26759 m
.63819 .27353 L
s
.696 .182 .07 r
.64201 .27542 m .63001 .26948 L .61888 .2509 L p F P
0 0 0 r
s
.267 .399 .793 r
.45442 .52817 m .44832 .52918 L .41605 .51723 L p F P
0 0 0 r
s
.83 .24 .1 r
.43853 .52724 m
.44028 .52778 L
s
.274 .413 .818 r
.46054 .52716 m .46668 .52614 L .49151 .53571 L p F P
0 0 0 r
s
.274 .413 .818 r
.49463 .53521 m .49151 .53571 L .46668 .52614 L p F P
0 0 0 r
s
.83 .24 .1 r
.48238 .53476 m
.4851 .5356 L
s
.696 .182 .07 r
.60784 .24535 m .61888 .2509 L .63001 .26948 L p F P
0 0 0 r
s
1 .315 .133 r
.53871 .5356 m .53648 .53489 L .55604 .52449 L p F P
0 0 0 r
s
1 .315 .133 r
.55604 .52449 m .56041 .52591 L .53871 .5356 L p F P
0 0 0 r
s
.83 .24 .1 r
.55808 .52515 m
.55996 .52437 L
s
.53538 .53455 m
.54329 .53127 L
s
.225 .323 .649 r
.30613 .41279 m .32419 .40903 L .33609 .43447 L p F P
0 0 0 r
s
.225 .323 .649 r
.33609 .43447 m .31909 .43787 L .30613 .41279 L p F P
0 0 0 r
s
1 .297 .122 r
.67117 .37947 m .68415 .38516 L .67831 .41118 L p F P
0 0 0 r
s
.83 .24 .1 r
.68221 .38432 m
.68248 .38053 L
s
1 .286 .117 r
.68415 .38516 m .67117 .37947 L .67264 .3531 L p F P
0 0 0 r
s
.24 .35 .67 r
.84756 .19567 m
.86213 .22389 L
s
1 .321 .135 r
.56909 .52874 m .56476 .52733 L .58756 .51445 L p F P
0 0 0 r
s
.83 .24 .1 r
.57035 .52777 m
.57079 .52791 L
s
1 .321 .135 r
.58756 .51445 m .59385 .51658 L .56909 .52874 L p F P
0 0 0 r
s
.83 .24 .1 r
.6751 .4193 m
.67777 .40878 L
s
.204 .289 .584 r
.31533 .35665 m .33438 .35236 L .3361 .37875 L p F P
0 0 0 r
s
.24 .35 .67 r
.31537 .35731 m
.31584 .3572 L
s
.33442 .35302 m
.33626 .35261 L
s
.204 .289 .584 r
.3361 .37875 m .31722 .38285 L .31533 .35665 L p F P
0 0 0 r
s
.274 .413 .818 r
.46668 .52614 m .47284 .52512 L .49463 .53521 L p F P
0 0 0 r
s
.274 .413 .818 r
.49776 .5347 m .49463 .53521 L .47284 .52512 L p F P
0 0 0 r
s
.83 .24 .1 r
.28614 .45154 m
.31837 .46181 L
s
.31837 .46181 m
.33627 .48425 L
s
1 .315 .133 r
.53648 .53489 m .53425 .53419 L .55165 .52305 L p F P
0 0 0 r
s
1 .315 .133 r
.55165 .52305 m .55604 .52449 L .53648 .53489 L p F P
0 0 0 r
s
.267 .399 .793 r
.41605 .51723 m .42495 .51571 L .45442 .52817 L p F P
0 0 0 r
s
.267 .399 .793 r
.46054 .52716 m .45442 .52817 L .42495 .51571 L p F P
0 0 0 r
s
.259 .384 .764 r
.42495 .51571 m .41605 .51723 L .38623 .50168 L p F P
0 0 0 r
s
.274 .413 .818 r
.47284 .52512 m .47903 .5241 L .49776 .5347 L p F P
0 0 0 r
s
.83 .24 .1 r
.45563 .53031 m
.47341 .53201 L
s
.274 .413 .818 r
.5009 .5342 m .49776 .5347 L .47903 .5241 L p F P
0 0 0 r
s
.978 .272 .11 r
.65704 .32134 m .67015 .32751 L .67264 .3531 L p F P
0 0 0 r
s
.918 .252 .101 r
.67015 .32751 m .65704 .32134 L .65119 .29725 L p F P
0 0 0 r
s
.126 .164 .342 r
.41876 .2494 m .43466 .24542 L .42566 .26354 L p F P
0 0 0 r
s
.24 .35 .67 r
.4177 .25122 m
.41944 .25079 L
s
.43377 .24721 m
.43551 .24677 L
s
.126 .164 .342 r
.42566 .26354 m .40807 .26786 L .41876 .2494 L p F P
0 0 0 r
s
.234 .339 .679 r
.31909 .43787 m .33609 .43447 L .35262 .45848 L p F P
0 0 0 r
s
.234 .339 .679 r
.35262 .45848 m .33709 .46146 L .31909 .43787 L p F P
0 0 0 r
s
.83 .24 .1 r
.23281 .38144 m
.26594 .39285 L
s
.26594 .39285 m
.27331 .424 L
s
.088 .108 .226 r
.45954 .22735 m .47361 .22379 L .46693 .23735 L p F P
0 0 0 r
s
.088 .108 .226 r
.46693 .23735 m .45072 .2414 L .45954 .22735 L p F P
0 0 0 r
s
.274 .413 .818 r
.47903 .5241 m .48524 .52307 L .5009 .5342 L p F P
0 0 0 r
s
.83 .24 .1 r
.47341 .53201 m
.48238 .53476 L
s
.274 .413 .818 r
.50404 .53369 m .5009 .5342 L .48524 .52307 L p F P
0 0 0 r
s
1 .315 .133 r
.53425 .53419 m .53201 .53348 L .54723 .52161 L p F P
0 0 0 r
s
1 .315 .133 r
.54723 .52161 m .55165 .52305 L .53425 .53419 L p F P
0 0 0 r
s
1 .306 .126 r
.66574 .40588 m .67831 .41118 L .66835 .43641 L p F P
0 0 0 r
s
1 .297 .122 r
.67831 .41118 m .66574 .40588 L .67117 .37947 L p F P
0 0 0 r
s
1 .323 .135 r
.59385 .51658 m .58756 .51445 L .60869 .49797 L p F P
0 0 0 r
s
1 .323 .135 r
.60869 .49797 m .61674 .50081 L .59385 .51658 L p F P
0 0 0 r
s
.24 .35 .67 r
.89387 .3924 m
.89033 .42287 L
s
.191 .268 .543 r
.33729 .32675 m .35627 .32233 L .35365 .34802 L p F P
0 0 0 r
s
.191 .268 .543 r
.35365 .34802 m .33438 .35236 L .33729 .32675 L p F P
0 0 0 r
s
.24 .35 .67 r
.33626 .35261 m
.33633 .35192 L
s
.251 .368 .736 r
.39767 .49965 m .38623 .50168 L .35967 .48292 L p F P
0 0 0 r
s
.259 .384 .764 r
.38623 .50168 m .39767 .49965 L .42495 .51571 L p F P
0 0 0 r
s
.83 .24 .1 r
.38328 .50563 m
.38969 .51037 L
s
.38969 .51037 m
.39299 .51137 L
s
.35856 .50087 m
.38969 .51037 L
s
.054 .065 .125 r
.5047 .20834 m .51655 .2053 L .51652 .2129 L p F P
0 0 0 r
s
.054 .065 .125 r
.51652 .2129 m .5021 .21656 L .5047 .20834 L p F P
0 0 0 r
s
1 .321 .135 r
.56476 .52733 m .56041 .52591 L .58122 .51231 L p F P
0 0 0 r
s
.83 .24 .1 r
.55996 .52437 m
.56184 .52498 L
s
.56589 .52631 m
.56632 .52645 L
s
1 .321 .135 r
.58122 .51231 m .58756 .51445 L .56476 .52733 L p F P
0 0 0 r
s
.242 .354 .707 r
.33709 .46146 m .35262 .45848 L .37334 .4804 L p F P
0 0 0 r
s
.242 .354 .707 r
.37334 .4804 m .35967 .48292 L .33709 .46146 L p F P
0 0 0 r
s
.267 .399 .793 r
.42495 .51571 m .43389 .51419 L .46054 .52716 L p F P
0 0 0 r
s
.267 .399 .793 r
.46668 .52614 m .46054 .52716 L .43389 .51419 L p F P
0 0 0 r
s
.251 .368 .736 r
.35967 .48292 m .37334 .4804 L .39767 .49965 L p F P
0 0 0 r
s
.274 .413 .818 r
.48524 .52307 m .49147 .52204 L .50404 .53369 L p F P
0 0 0 r
s
.24 .35 .67 r
.48556 .52155 m
.48733 .52272 L
s
.274 .413 .818 r
.50718 .53318 m .50404 .53369 L .49147 .52204 L p F P
0 0 0 r
s
.215 .307 .618 r
.31722 .38285 m .3361 .37875 L .34245 .40522 L p F P
0 0 0 r
s
.215 .307 .618 r
.34245 .40522 m .32419 .40903 L .31722 .38285 L p F P
0 0 0 r
s
.155 .21 .43 r
.39066 .27213 m .40807 .26786 L .40003 .28935 L p F P
0 0 0 r
s
.155 .21 .43 r
.40003 .28935 m .38138 .29382 L .39066 .27213 L p F P
0 0 0 r
s
.35 .078 .032 r
.57606 .22087 m .56607 .2158 L .55725 .20771 L p F P
0 0 0 r
s
.35 .078 .032 r
.54891 .20347 m .55725 .20771 L .56607 .2158 L p F P
0 0 0 r
s
1 .315 .133 r
.53201 .53348 m .52977 .53277 L .54279 .52016 L p F P
0 0 0 r
s
1 .315 .133 r
.54279 .52016 m .54723 .52161 L .53201 .53348 L p F P
0 0 0 r
s
.24 .35 .67 r
.5464 .52889 m
.56688 .53548 L
s
.72692 .17569 m
.76979 .165 L
s
.72692 .17569 m
.70825 .16476 L
s
.175 .243 .494 r
.36295 .29824 m .38138 .29382 L .37548 .31786 L p F P
0 0 0 r
s
.175 .243 .494 r
.37548 .31786 m .35627 .32233 L .36295 .29824 L p F P
0 0 0 r
s
.53 .131 .051 r
.60784 .24535 m .59665 .23973 L .58593 .22588 L p F P
0 0 0 r
s
.53 .131 .051 r
.57606 .22087 m .58593 .22588 L .59665 .23973 L p F P
0 0 0 r
s
.24 .35 .67 r
.66607 .17546 m
.70825 .16476 L
s
.66607 .17546 m
.64722 .17182 L
s
1 .312 .129 r
.65649 .43163 m .66835 .43641 L .6545 .46018 L p F P
0 0 0 r
s
1 .306 .126 r
.66835 .43641 m .65649 .43163 L .66574 .40588 L p F P
0 0 0 r
s
.259 .384 .764 r
.43389 .51419 m .42495 .51571 L .39767 .49965 L p F P
0 0 0 r
s
1 .321 .134 r
.61674 .50081 m .60869 .49797 L .62756 .47831 L p F P
0 0 0 r
s
1 .321 .134 r
.62756 .47831 m .63715 .48184 L .61674 .50081 L p F P
0 0 0 r
s
.274 .413 .818 r
.49147 .52204 m .49772 .521 L .50718 .53318 L p F P
0 0 0 r
s
.274 .413 .818 r
.51034 .53267 m .50718 .53318 L .49772 .521 L p F P
0 0 0 r
s
.83 .24 .1 r
.47366 .17439 m
.44544 .17498 L
s
.41517 .15996 m
.44544 .17498 L
s
.24 .35 .67 r
.78759 .18267 m
.83121 .17205 L
s
.78759 .18267 m
.76979 .165 L
s
.83 .24 .1 r
.38656 .16789 m
.35889 .1825 L
s
.32719 .1676 m
.35889 .1825 L
s
.24 .35 .67 r
.60571 .18244 m
.64722 .17182 L
s
.60571 .18244 m
.58746 .18637 L
s
1 .317 .132 r
.64364 .45599 m .6545 .46018 L .63715 .48184 L p F P
0 0 0 r
s
1 .312 .129 r
.6545 .46018 m .64364 .45599 L .65649 .43163 L p F P
0 0 0 r
s
1 .317 .132 r
.63715 .48184 m .62756 .47831 L .64364 .45599 L p F P
0 0 0 r
s
.267 .399 .793 r
.43389 .51419 m .44288 .51265 L .46668 .52614 L p F P
0 0 0 r
s
.83 .24 .1 r
.41541 .52022 m
.43853 .52724 L
s
.267 .399 .793 r
.47284 .52512 m .46668 .52614 L .44288 .51265 L p F P
0 0 0 r
s
.918 .252 .101 r
.63838 .29105 m .65119 .29725 L .65704 .32134 L p F P
0 0 0 r
s
.83 .24 .1 r
.64672 .29139 m
.64816 .29578 L
s
.83 .224 .089 r
.65119 .29725 m .63838 .29105 L .63001 .26948 L p F P
0 0 0 r
s
1 .315 .133 r
.52977 .53277 m .52752 .53206 L .53833 .51871 L p F P
0 0 0 r
s
.24 .35 .67 r
.52724 .53197 m
.52764 .53191 L
s
1 .315 .133 r
.53833 .51871 m .54279 .52016 L .52977 .53277 L p F P
0 0 0 r
s
.274 .413 .818 r
.49772 .521 m .504 .51997 L .51034 .53267 L p F P
0 0 0 r
s
.274 .413 .818 r
.5135 .53216 m .51034 .53267 L .504 .51997 L p F P
0 0 0 r
s
.978 .272 .11 r
.67264 .3531 m .65933 .34704 L .65704 .32134 L p F P
0 0 0 r
s
1 .286 .117 r
.65933 .34704 m .67264 .3531 L .67117 .37947 L p F P
0 0 0 r
s
.83 .24 .1 r
.47341 .53201 m
.50257 .52724 L
s
1 .321 .135 r
.56041 .52591 m .55604 .52449 L .57484 .51015 L p F P
0 0 0 r
s
1 .321 .135 r
.57484 .51015 m .58122 .51231 L .56041 .52591 L p F P
0 0 0 r
s
.225 .323 .649 r
.32419 .40903 m .34245 .40522 L .35328 .43103 L p F P
0 0 0 r
s
.225 .323 .649 r
.35328 .43103 m .33609 .43447 L .32419 .40903 L p F P
0 0 0 r
s
.24 .35 .67 r
.5466 .19683 m
.58746 .18637 L
s
.274 .413 .818 r
.504 .51997 m .5103 .51892 L .5135 .53216 L p F P
0 0 0 r
s
.274 .413 .818 r
.51666 .53165 m .5135 .53216 L .5103 .51892 L p F P
0 0 0 r
s
.251 .368 .736 r
.40919 .49762 m .39767 .49965 L .37334 .4804 L p F P
0 0 0 r
s
.259 .384 .764 r
.39767 .49965 m .40919 .49762 L .43389 .51419 L p F P
0 0 0 r
s
.054 .065 .125 r
.51655 .2053 m .52848 .20225 L .53107 .20921 L p F P
0 0 0 r
s
.054 .065 .125 r
.53107 .20921 m .51652 .2129 L .51655 .2053 L p F P
0 0 0 r
s
1 .315 .133 r
.52752 .53206 m .52526 .53134 L .53384 .51724 L p F P
0 0 0 r
s
1 .315 .133 r
.53384 .51724 m .53833 .51871 L .52752 .53206 L p F P
0 0 0 r
s
.24 .35 .67 r
.53019 .53149 m
.53397 .53089 L
s
.53397 .53089 m
.5464 .52889 L
s
.088 .108 .226 r
.47361 .22379 m .4878 .22019 L .48329 .23325 L p F P
0 0 0 r
s
.088 .108 .226 r
.48329 .23325 m .46693 .23735 L .47361 .22379 L p F P
0 0 0 r
s
1 .323 .135 r
.58756 .51445 m .58122 .51231 L .60056 .49511 L p F P
0 0 0 r
s
1 .323 .135 r
.60056 .49511 m .60869 .49797 L .58756 .51445 L p F P
0 0 0 r
s
.204 .289 .584 r
.33438 .35236 m .35365 .34802 L .3552 .37461 L p F P
0 0 0 r
s
.204 .289 .584 r
.3552 .37461 m .3361 .37875 L .33438 .35236 L p F P
0 0 0 r
s
.24 .35 .67 r
.33746 .37846 m
.3378 .38586 L
s
.126 .164 .342 r
.43466 .24542 m .45072 .2414 L .44344 .25917 L p F P
0 0 0 r
s
.24 .35 .67 r
.43551 .24677 m
.43552 .24677 L
s
.126 .164 .342 r
.44344 .25917 m .42566 .26354 L .43466 .24542 L p F P
0 0 0 r
s
.24 .35 .67 r
.48747 .22114 m
.48832 .22005 L
s
.696 .182 .07 r
.63001 .26948 m .61784 .26346 L .60784 .24535 L p F P
0 0 0 r
s
.696 .182 .07 r
.59665 .23973 m .60784 .24535 L .61784 .26346 L p F P
0 0 0 r
s
.83 .224 .089 r
.61784 .26346 m .63001 .26948 L .63838 .29105 L p F P
0 0 0 r
s
.267 .399 .793 r
.44288 .51265 m .45192 .51111 L .47284 .52512 L p F P
0 0 0 r
s
.267 .399 .793 r
.47903 .5241 m .47284 .52512 L .45192 .51111 L p F P
0 0 0 r
s
.259 .384 .764 r
.44288 .51265 m .43389 .51419 L .40919 .49762 L p F P
0 0 0 r
s
.274 .413 .818 r
.5103 .51892 m .51662 .51788 L .51666 .53165 L p F P
0 0 0 r
s
.83 .24 .1 r
.51147 .53004 m
.51417 .5309 L
s
.50257 .52724 m
.51147 .53004 L
s
.274 .413 .818 r
.51983 .53114 m .51666 .53165 L .51662 .51788 L p F P
0 0 0 r
s
.83 .24 .1 r
.50048 .18109 m
.52944 .1958 L
s
.234 .339 .679 r
.33609 .43447 m .35328 .43103 L .36831 .45547 L p F P
0 0 0 r
s
.234 .339 .679 r
.36831 .45547 m .35262 .45848 L .33609 .43447 L p F P
0 0 0 r
s
.24 .35 .67 r
.83121 .17205 m
.84756 .19567 L
s
.242 .354 .707 r
.38712 .47787 m .37334 .4804 L .35262 .45848 L p F P
0 0 0 r
s
.24 .35 .67 r
.35541 .45794 m
.35679 .46082 L
s
.251 .368 .736 r
.37334 .4804 m .38712 .47787 L .40919 .49762 L p F P
0 0 0 r
s
1 .315 .133 r
.52526 .53134 m .523 .53063 L .52934 .51577 L p F P
0 0 0 r
s
1 .315 .133 r
.52934 .51577 m .53384 .51724 L .52526 .53134 L p F P
0 0 0 r
s
.242 .354 .707 r
.35262 .45848 m .36831 .45547 L .38712 .47787 L p F P
0 0 0 r
s
1 .321 .135 r
.55604 .52449 m .55165 .52305 L .56841 .50797 L p F P
0 0 0 r
s
.83 .24 .1 r
.55688 .52336 m
.55733 .52351 L
s
1 .321 .135 r
.56841 .50797 m .57484 .51015 L .55604 .52449 L p F P
0 0 0 r
s
.83 .24 .1 r
.25936 .24485 m
.2448 .27787 L
s
.21112 .2645 m
.2448 .27787 L
s
.2448 .27787 m
.23529 .31252 L
s
.274 .413 .818 r
.51662 .51788 m .52297 .51683 L .51983 .53114 L p F P
0 0 0 r
s
.274 .413 .818 r
.523 .53063 m .51983 .53114 L .52297 .51683 L p F P
0 0 0 r
s
.24 .35 .67 r
.77072 .50007 m
.78463 .48508 L
s
.78463 .48508 m
.82838 .47798 L
s
1 .297 .122 r
.65798 .37367 m .67117 .37947 L .66574 .40588 L p F P
0 0 0 r
s
1 .286 .117 r
.67117 .37947 m .65798 .37367 L .65933 .34704 L p F P
0 0 0 r
s
.83 .24 .1 r
.65785 .34735 m
.65928 .348 L
s
.35 .078 .032 r
.56607 .2158 m .55596 .21068 L .54891 .20347 L p F P
0 0 0 r
s
.35 .078 .032 r
.5405 .19918 m .54891 .20347 L .55596 .21068 L p F P
0 0 0 r
s
.24 .35 .67 r
.54257 .19957 m
.5466 .19683 L
s
.54201 .19995 m
.54257 .19957 L
s
.83 .24 .1 r
.27843 .2147 m
.25936 .24485 L
s
.22591 .23092 m
.25936 .24485 L
s
.191 .268 .543 r
.35627 .32233 m .37548 .31786 L .37316 .34363 L p F P
0 0 0 r
s
.191 .268 .543 r
.37316 .34363 m .35365 .34802 L .35627 .32233 L p F P
0 0 0 r
s
.267 .399 .793 r
.45192 .51111 m .46101 .50956 L .47903 .5241 L p F P
0 0 0 r
s
.267 .399 .793 r
.48524 .52307 m .47903 .5241 L .46101 .50956 L p F P
0 0 0 r
s
.24 .35 .67 r
.48321 .52194 m
.48556 .52155 L
s
.82838 .47798 m
.83896 .4568 L
s
.83896 .4568 m
.88337 .44936 L
s
.155 .21 .43 r
.40807 .26786 m .42566 .26354 L .41889 .28483 L p F P
0 0 0 r
s
.155 .21 .43 r
.41889 .28483 m .40003 .28935 L .40807 .26786 L p F P
0 0 0 r
s
.24 .35 .67 r
.71085 .515 m
.72762 .50692 L
s
.72762 .50692 m
.77072 .50007 L
s
.83 .24 .1 r
.24007 .41302 m
.27331 .424 L
s
.27331 .424 m
.28614 .45154 L
s
.274 .413 .818 r
.52297 .51683 m .52934 .51577 L .523 .53063 L p F P
0 0 0 r
s
1 .321 .134 r
.60869 .49797 m .60056 .49511 L .61786 .47474 L p F P
0 0 0 r
s
1 .321 .134 r
.61786 .47474 m .62756 .47831 L .60869 .49797 L p F P
0 0 0 r
s
.215 .307 .618 r
.3361 .37875 m .3552 .37461 L .36091 .40137 L p F P
0 0 0 r
s
.215 .307 .618 r
.36091 .40137 m .34245 .40522 L .3361 .37875 L p F P
0 0 0 r
s
.175 .243 .494 r
.38138 .29382 m .40003 .28935 L .39491 .31334 L p F P
0 0 0 r
s
.175 .243 .494 r
.39491 .31334 m .37548 .31786 L .38138 .29382 L p F P
0 0 0 r
s
.259 .384 .764 r
.40919 .49762 m .42079 .49557 L .44288 .51265 L p F P
0 0 0 r
s
.83 .24 .1 r
.38969 .51037 m
.41541 .52022 L
s
.259 .384 .764 r
.45192 .51111 m .44288 .51265 L .42079 .49557 L p F P
0 0 0 r
s
.83 .24 .1 r
.2014 .2997 m
.23529 .31252 L
s
.23529 .31252 m
.23122 .34749 L
s
.30404 .47425 m
.33627 .48425 L
s
.33627 .48425 m
.35856 .50087 L
s
.251 .368 .736 r
.42079 .49557 m .40919 .49762 L .38712 .47787 L p F P
0 0 0 r
s
.53 .131 .051 r
.59665 .23973 m .5853 .23403 L .57606 .22087 L p F P
0 0 0 r
s
.53 .131 .051 r
.56607 .2158 m .57606 .22087 L .5853 .23403 L p F P
0 0 0 r
s
.054 .065 .125 r
.52848 .20225 m .5405 .19918 L .54573 .20549 L p F P
0 0 0 r
s
.24 .35 .67 r
.54145 .20033 m
.54176 .20012 L
s
.83 .24 .1 r
.52944 .1958 m
.53524 .19913 L
s
.53524 .19913 m
.53629 .19974 L
s
.054 .065 .125 r
.54573 .20549 m .53107 .20921 L .52848 .20225 L p F P
0 0 0 r
s
.978 .272 .11 r
.64371 .31506 m .65704 .32134 L .65933 .34704 L p F P
0 0 0 r
s
.83 .24 .1 r
.65442 .31708 m
.65478 .32027 L
s
.65735 .34299 m
.65785 .34735 L
s
.918 .252 .101 r
.65704 .32134 m .64371 .31506 L .63838 .29105 L p F P
0 0 0 r
s
.24 .35 .67 r
.64947 .52243 m
.6684 .52169 L
s
.6684 .52169 m
.71085 .515 L
s
1 .323 .135 r
.58122 .51231 m .57484 .51015 L .59235 .49221 L p F P
0 0 0 r
s
1 .323 .135 r
.59235 .49221 m .60056 .49511 L .58122 .51231 L p F P
0 0 0 r
s
1 .306 .126 r
.65297 .4005 m .66574 .40588 L .65649 .43163 L p F P
0 0 0 r
s
1 .297 .122 r
.66574 .40588 m .65297 .4005 L .65798 .37367 L p F P
0 0 0 r
s
.267 .399 .793 r
.46101 .50956 m .47015 .508 L .48524 .52307 L p F P
0 0 0 r
s
.267 .399 .793 r
.49147 .52204 m .48524 .52307 L .47015 .508 L p F P
0 0 0 r
s
.83 .24 .1 r
.44357 .52284 m
.47341 .53201 L
s
1 .321 .135 r
.55165 .52305 m .54723 .52161 L .56193 .50578 L p F P
0 0 0 r
s
.83 .24 .1 r
.55235 .52188 m
.55279 .52202 L
s
1 .321 .135 r
.56193 .50578 m .56841 .50797 L .55165 .52305 L p F P
0 0 0 r
s
.088 .108 .226 r
.4878 .22019 m .5021 .21656 L .49981 .22912 L p F P
0 0 0 r
s
.088 .108 .226 r
.49981 .22912 m .48329 .23325 L .4878 .22019 L p F P
0 0 0 r
s
.24 .35 .67 r
.89033 .42287 m
.88337 .44936 L
s
.58746 .52228 m
.60769 .52903 L
s
.60769 .52903 m
.64947 .52243 L
s
1 .317 .132 r
.62756 .47831 m .61786 .47474 L .63263 .45175 L p F P
0 0 0 r
s
1 .317 .132 r
.63263 .45175 m .64364 .45599 L .62756 .47831 L p F P
0 0 0 r
s
.83 .24 .1 r
.30132 .18859 m
.27843 .2147 L
s
.24521 .20024 m
.27843 .2147 L
s
.24 .35 .67 r
.5464 .52889 m
.58746 .52228 L
s
.126 .164 .342 r
.45072 .2414 m .46693 .23735 L .46141 .25476 L p F P
0 0 0 r
s
.24 .35 .67 r
.45 .24315 m
.45177 .24271 L
s
.126 .164 .342 r
.46141 .25476 m .44344 .25917 L .45072 .2414 L p F P
0 0 0 r
s
.225 .323 .649 r
.34245 .40522 m .36091 .40137 L .37065 .42755 L p F P
0 0 0 r
s
.225 .323 .649 r
.37065 .42755 m .35328 .43103 L .34245 .40522 L p F P
0 0 0 r
s
1 .312 .129 r
.64445 .42677 m .65649 .43163 L .64364 .45599 L p F P
0 0 0 r
s
1 .306 .126 r
.65649 .43163 m .64445 .42677 L .65297 .4005 L p F P
0 0 0 r
s
.242 .354 .707 r
.40102 .47531 m .38712 .47787 L .36831 .45547 L p F P
0 0 0 r
s
.251 .368 .736 r
.38712 .47787 m .40102 .47531 L .42079 .49557 L p F P
0 0 0 r
s
1 .312 .129 r
.64364 .45599 m .63263 .45175 L .64445 .42677 L p F P
0 0 0 r
s
.259 .384 .764 r
.42079 .49557 m .43247 .4935 L .45192 .51111 L p F P
0 0 0 r
s
.259 .384 .764 r
.46101 .50956 m .45192 .51111 L .43247 .4935 L p F P
0 0 0 r
s
.267 .399 .793 r
.47015 .508 m .47934 .50643 L .49147 .52204 L p F P
0 0 0 r
s
.267 .399 .793 r
.49772 .521 m .49147 .52204 L .47934 .50643 L p F P
0 0 0 r
s
.83 .24 .1 r
.41517 .15996 m
.38656 .16789 L
s
.35508 .15264 m
.38656 .16789 L
s
.204 .289 .584 r
.35365 .34802 m .37316 .34363 L .37453 .37041 L p F P
0 0 0 r
s
.24 .35 .67 r
.35369 .34869 m
.35418 .34858 L
s
.37319 .3443 m
.37466 .34397 L
s
.204 .289 .584 r
.37453 .37041 m .3552 .37461 L .35365 .34802 L p F P
0 0 0 r
s
.234 .339 .679 r
.35328 .43103 m .37065 .42755 L .38414 .45243 L p F P
0 0 0 r
s
.234 .339 .679 r
.38414 .45243 m .36831 .45547 L .35328 .43103 L p F P
0 0 0 r
s
.83 .24 .1 r
.3844 .51079 m
.41541 .52022 L
s
.41541 .52022 m
.44357 .52284 L
s
.242 .354 .707 r
.36831 .45547 m .38414 .45243 L .40102 .47531 L p F P
0 0 0 r
s
.918 .252 .101 r
.62537 .28475 m .63838 .29105 L .64371 .31506 L p F P
0 0 0 r
s
.83 .224 .089 r
.63838 .29105 m .62537 .28475 L .61784 .26346 L p F P
0 0 0 r
s
.83 .24 .1 r
.19715 .3352 m
.23122 .34749 L
s
.23122 .34749 m
.23281 .38144 L
s
1 .321 .135 r
.54723 .52161 m .54279 .52016 L .5554 .50358 L p F P
0 0 0 r
s
.24 .35 .67 r
.53563 .52153 m
.5464 .52889 L
s
.53346 .52004 m
.53563 .52153 L
s
.83 .24 .1 r
.54778 .52039 m
.54823 .52053 L
s
1 .321 .135 r
.5554 .50358 m .56193 .50578 L .54723 .52161 L p F P
0 0 0 r
s
.251 .368 .736 r
.43247 .4935 m .42079 .49557 L .40102 .47531 L p F P
0 0 0 r
s
.696 .182 .07 r
.61784 .26346 m .60548 .25736 L .59665 .23973 L p F P
0 0 0 r
s
.696 .182 .07 r
.5853 .23403 m .59665 .23973 L .60548 .25736 L p F P
0 0 0 r
s
.35 .078 .032 r
.55596 .21068 m .54573 .20549 L .5405 .19918 L p F P
0 0 0 r
s
.83 .24 .1 r
.55058 .20795 m
.55352 .20963 L
s
.978 .272 .11 r
.65933 .34704 m .64581 .34087 L .64371 .31506 L p F P
0 0 0 r
s
1 .286 .117 r
.64581 .34087 m .65933 .34704 L .65798 .37367 L p F P
0 0 0 r
s
.83 .24 .1 r
.50048 .18109 m
.47366 .17439 L
s
.44358 .15921 m
.47366 .17439 L
s
1 .323 .135 r
.57484 .51015 m .56841 .50797 L .58405 .48929 L p F P
0 0 0 r
s
1 .323 .135 r
.58405 .48929 m .59235 .49221 L .57484 .51015 L p F P
0 0 0 r
s
1 .321 .134 r
.60056 .49511 m .59235 .49221 L .60804 .47113 L p F P
0 0 0 r
s
1 .321 .134 r
.60804 .47113 m .61786 .47474 L .60056 .49511 L p F P
0 0 0 r
s
.155 .21 .43 r
.42566 .26354 m .44344 .25917 L .43796 .28026 L p F P
0 0 0 r
s
.155 .21 .43 r
.43796 .28026 m .41889 .28483 L .42566 .26354 L p F P
0 0 0 r
s
.267 .399 .793 r
.47934 .50643 m .48857 .50486 L .49772 .521 L p F P
0 0 0 r
s
.267 .399 .793 r
.504 .51997 m .49772 .521 L .48857 .50486 L p F P
0 0 0 r
s
.83 .24 .1 r
.50257 .52724 m
.5178 .52085 L
s
.5178 .52085 m
.52087 .51956 L
s
.83 .224 .089 r
.60548 .25736 m .61784 .26346 L .62537 .28475 L p F P
0 0 0 r
s
.191 .268 .543 r
.37548 .31786 m .39491 .31334 L .3929 .33918 L p F P
0 0 0 r
s
.191 .268 .543 r
.3929 .33918 m .37316 .34363 L .37548 .31786 L p F P
0 0 0 r
s
.24 .35 .67 r
.37466 .34397 m
.37472 .34327 L
s
.088 .108 .226 r
.5021 .21656 m .51652 .2129 L .51649 .22494 L p F P
0 0 0 r
s
.088 .108 .226 r
.51649 .22494 m .49981 .22912 L .5021 .21656 L p F P
0 0 0 r
s
.259 .384 .764 r
.43247 .4935 m .44423 .49142 L .46101 .50956 L p F P
0 0 0 r
s
.259 .384 .764 r
.47015 .508 m .46101 .50956 L .44423 .49142 L p F P
0 0 0 r
s
.175 .243 .494 r
.40003 .28935 m .41889 .28483 L .41457 .30876 L p F P
0 0 0 r
s
.175 .243 .494 r
.41457 .30876 m .39491 .31334 L .40003 .28935 L p F P
0 0 0 r
s
.83 .24 .1 r
.32719 .1676 m
.30132 .18859 L
s
.26834 .17364 m
.30132 .18859 L
s
.215 .307 .618 r
.3552 .37461 m .37453 .37041 L .37958 .39747 L p F P
0 0 0 r
s
.215 .307 .618 r
.37958 .39747 m .36091 .40137 L .3552 .37461 L p F P
0 0 0 r
s
.24 .35 .67 r
.37625 .37963 m
.37643 .37959 L
s
.76979 .165 m
.81368 .15406 L
s
.76979 .165 m
.75142 .15382 L
s
.53 .131 .051 r
.5853 .23403 m .57381 .22826 L .56607 .2158 L p F P
0 0 0 r
s
.53 .131 .051 r
.55596 .21068 m .56607 .2158 L .57381 .22826 L p F P
0 0 0 r
s
.83 .24 .1 r
.55352 .20963 m
.55637 .21108 L
s
1 .321 .135 r
.54279 .52016 m .53833 .51871 L .54882 .50135 L p F P
0 0 0 r
s
.83 .24 .1 r
.5432 .51889 m
.54365 .51903 L
s
1 .321 .135 r
.54882 .50135 m .5554 .50358 L .54279 .52016 L p F P
0 0 0 r
s
.24 .35 .67 r
.70825 .16476 m
.75142 .15382 L
s
.70825 .16476 m
.68971 .16095 L
s
.242 .354 .707 r
.41503 .47274 m .40102 .47531 L .38414 .45243 L p F P
0 0 0 r
s
.24 .35 .67 r
.40541 .47451 m
.40758 .47911 L
s
.251 .368 .736 r
.40102 .47531 m .41503 .47274 L .43247 .4935 L p F P
0 0 0 r
s
.267 .399 .793 r
.48857 .50486 m .49786 .50327 L .504 .51997 L p F P
0 0 0 r
s
.267 .399 .793 r
.5103 .51892 m .504 .51997 L .49786 .50327 L p F P
0 0 0 r
s
.126 .164 .342 r
.46693 .23735 m .48329 .23325 L .47957 .25031 L p F P
0 0 0 r
s
.24 .35 .67 r
.46638 .23906 m
.46817 .23862 L
s
.126 .164 .342 r
.47957 .25031 m .46141 .25476 L .46693 .23735 L p F P
0 0 0 r
s
.24 .35 .67 r
.81368 .15406 m
.83121 .17205 L
s
1 .297 .122 r
.64457 .36779 m .65798 .37367 L .65297 .4005 L p F P
0 0 0 r
s
.83 .24 .1 r
.65597 .37279 m
.65625 .36902 L
s
1 .286 .117 r
.65798 .37367 m .64457 .36779 L .64581 .34087 L p F P
0 0 0 r
s
.251 .368 .736 r
.44423 .49142 m .43247 .4935 L .41503 .47274 L p F P
0 0 0 r
s
.24 .35 .67 r
.64722 .17182 m
.68971 .16095 L
s
.64722 .17182 m
.62929 .17565 L
s
.83 .24 .1 r
.52467 .19501 m
.54263 .20411 L
s
.54547 .20555 m
.55352 .20963 L
s
1 .317 .132 r
.61786 .47474 m .60804 .47113 L .62147 .44745 L p F P
0 0 0 r
s
1 .317 .132 r
.62147 .44745 m .63263 .45175 L .61786 .47474 L p F P
0 0 0 r
s
.83 .24 .1 r
.63125 .45122 m
.63142 .45096 L
s
.63142 .45096 m
.63276 .45148 L
s
.25284 .44093 m
.28614 .45154 L
s
.28614 .45154 m
.30404 .47425 L
s
.225 .323 .649 r
.36091 .40137 m .37958 .39747 L .3882 .42404 L p F P
0 0 0 r
s
.225 .323 .649 r
.3882 .42404 m .37065 .42755 L .36091 .40137 L p F P
0 0 0 r
s
.234 .339 .679 r
.40013 .44937 m .38414 .45243 L .37065 .42755 L p F P
0 0 0 r
s
.242 .354 .707 r
.38414 .45243 m .40013 .44937 L .41503 .47274 L p F P
0 0 0 r
s
.259 .384 .764 r
.44423 .49142 m .45607 .48933 L .47015 .508 L p F P
0 0 0 r
s
.259 .384 .764 r
.47934 .50643 m .47015 .508 L .45607 .48933 L p F P
0 0 0 r
s
1 .323 .135 r
.56841 .50797 m .56193 .50578 L .57568 .48634 L p F P
0 0 0 r
s
1 .323 .135 r
.57568 .48634 m .58405 .48929 L .56841 .50797 L p F P
0 0 0 r
s
.24 .35 .67 r
.58746 .18637 m
.62929 .17565 L
s
.58746 .18637 m
.57096 .19778 L
s
.234 .339 .679 r
.37065 .42755 m .3882 .42404 L .40013 .44937 L p F P
0 0 0 r
s
.267 .399 .793 r
.49786 .50327 m .5072 .50168 L .5103 .51892 L p F P
0 0 0 r
s
.83 .24 .1 r
.47295 .51792 m
.50257 .52724 L
s
.267 .399 .793 r
.51662 .51788 m .5103 .51892 L .5072 .50168 L p F P
0 0 0 r
s
.978 .272 .11 r
.63016 .30868 m .64371 .31506 L .64581 .34087 L p F P
0 0 0 r
s
.918 .252 .101 r
.64371 .31506 m .63016 .30868 L .62537 .28475 L p F P
0 0 0 r
s
1 .321 .135 r
.53833 .51871 m .53384 .51724 L .54219 .49911 L p F P
0 0 0 r
s
.83 .24 .1 r
.53859 .51738 m
.53904 .51753 L
s
1 .321 .135 r
.54219 .49911 m .54882 .50135 L .53833 .51871 L p F P
0 0 0 r
s
.24 .35 .67 r
.54538 .20427 m
.57096 .19778 L
s
1 .306 .126 r
.64 .39504 m .65297 .4005 L .64445 .42677 L p F P
0 0 0 r
s
.83 .24 .1 r
.63142 .45096 m
.64392 .42301 L
s
.6509 .39963 m
.65182 .39601 L
s
1 .297 .122 r
.65297 .4005 m .64 .39504 L .64457 .36779 L p F P
0 0 0 r
s
.204 .289 .584 r
.37316 .34363 m .3929 .33918 L .39408 .36617 L p F P
0 0 0 r
s
.204 .289 .584 r
.39408 .36617 m .37453 .37041 L .37316 .34363 L p F P
0 0 0 r
s
.24 .35 .67 r
.37596 .3701 m
.37643 .37959 L
s
1 .312 .129 r
.63263 .45175 m .62147 .44745 L .63223 .42185 L p F P
0 0 0 r
s
1 .312 .129 r
.63223 .42185 m .64445 .42677 L .63263 .45175 L p F P
0 0 0 r
s
.83 .24 .1 r
.19857 .36965 m
.23281 .38144 L
s
.23281 .38144 m
.24007 .41302 L
s
1 .321 .134 r
.59235 .49221 m .58405 .48929 L .59811 .46747 L p F P
0 0 0 r
s
1 .321 .134 r
.59811 .46747 m .60804 .47113 L .59235 .49221 L p F P
0 0 0 r
s
1 .306 .126 r
.64445 .42677 m .63223 .42185 L .64 .39504 L p F P
0 0 0 r
s
.088 .108 .226 r
.51652 .2129 m .53107 .20921 L .53334 .22073 L p F P
0 0 0 r
s
.088 .108 .226 r
.53334 .22073 m .51649 .22494 L .51652 .2129 L p F P
0 0 0 r
s
.83 .24 .1 r
.32639 .49106 m
.35856 .50087 L
s
.35856 .50087 m
.3844 .51079 L
s
.155 .21 .43 r
.44344 .25917 m .46141 .25476 L .45724 .27564 L p F P
0 0 0 r
s
.155 .21 .43 r
.45724 .27564 m .43796 .28026 L .44344 .25917 L p F P
0 0 0 r
s
.267 .399 .793 r
.5072 .50168 m .51658 .50008 L .51662 .51788 L p F P
0 0 0 r
s
.267 .399 .793 r
.52297 .51683 m .51662 .51788 L .51658 .50008 L p F P
0 0 0 r
s
.696 .182 .07 r
.60548 .25736 m .59294 .25116 L .5853 .23403 L p F P
0 0 0 r
s
.696 .182 .07 r
.57381 .22826 m .5853 .23403 L .59294 .25116 L p F P
0 0 0 r
s
.83 .24 .1 r
.57385 .23014 m
.57649 .23147 L
s
.242 .354 .707 r
.42916 .47014 m .41503 .47274 L .40013 .44937 L p F P
0 0 0 r
s
.251 .368 .736 r
.41503 .47274 m .42916 .47014 L .44423 .49142 L p F P
0 0 0 r
s
.24 .35 .67 r
.81485 .49305 m
.82838 .47798 L
s
.82838 .47798 m
.87317 .47071 L
s
.251 .368 .736 r
.45607 .48933 m .44423 .49142 L .42916 .47014 L p F P
0 0 0 r
s
.191 .268 .543 r
.39491 .31334 m .41457 .30876 L .41287 .33468 L p F P
0 0 0 r
s
.191 .268 .543 r
.41287 .33468 m .3929 .33918 L .39491 .31334 L p F P
0 0 0 r
s
.259 .384 .764 r
.45607 .48933 m .46799 .48722 L .47934 .50643 L p F P
0 0 0 r
s
.259 .384 .764 r
.48857 .50486 m .47934 .50643 L .46799 .48722 L p F P
0 0 0 r
s
.24 .35 .67 r
.88337 .44936 m
.87317 .47071 L
s
.75431 .50816 m
.77072 .50007 L
s
.77072 .50007 m
.81485 .49305 L
s
.175 .243 .494 r
.41889 .28483 m .43796 .28026 L .43446 .30413 L p F P
0 0 0 r
s
.175 .243 .494 r
.43446 .30413 m .41457 .30876 L .41889 .28483 L p F P
0 0 0 r
s
1 .321 .135 r
.53384 .51724 m .52934 .51577 L .53551 .49685 L p F P
0 0 0 r
s
.83 .24 .1 r
.53396 .51586 m
.53441 .51601 L
s
1 .321 .135 r
.53551 .49685 m .54219 .49911 L .53384 .51724 L p F P
0 0 0 r
s
.918 .252 .101 r
.61214 .27836 m .62537 .28475 L .63016 .30868 L p F P
0 0 0 r
s
.83 .24 .1 r
.6191 .27612 m
.62124 .28276 L
s
.83 .224 .089 r
.62537 .28475 m .61214 .27836 L .60548 .25736 L p F P
0 0 0 r
s
.126 .164 .342 r
.48329 .23325 m .49981 .22912 L .49792 .2458 L p F P
0 0 0 r
s
.24 .35 .67 r
.48292 .23493 m
.48472 .23448 L
s
.126 .164 .342 r
.49792 .2458 m .47957 .25031 L .48329 .23325 L p F P
0 0 0 r
s
.83 .24 .1 r
.44358 .15921 m
.41517 .15996 L
s
.3839 .14444 m
.41517 .15996 L
s
.215 .307 .618 r
.37453 .37041 m .39408 .36617 L .39847 .39354 L p F P
0 0 0 r
s
.215 .307 .618 r
.39847 .39354 m .37958 .39747 L .37453 .37041 L p F P
0 0 0 r
s
.24 .35 .67 r
.37967 .39746 m
.37978 .39808 L
s
.83 .24 .1 r
.35508 .15264 m
.32719 .1676 L
s
.29444 .1522 m
.32719 .1676 L
s
1 .323 .135 r
.56193 .50578 m .5554 .50358 L .56722 .48336 L p F P
0 0 0 r
s
1 .323 .135 r
.56722 .48336 m .57568 .48634 L .56193 .50578 L p F P
0 0 0 r
s
.53 .131 .051 r
.57381 .22826 m .56216 .22241 L .55596 .21068 L p F P
0 0 0 r
s
.83 .24 .1 r
.55352 .20963 m
.55757 .21372 L
s
.57016 .22643 m
.57385 .23014 L
s
.53 .131 .051 r
.54573 .20549 m .55596 .21068 L .56216 .22241 L p F P
0 0 0 r
s
.267 .399 .793 r
.51658 .50008 m .52602 .49847 L .52297 .51683 L p F P
0 0 0 r
s
.267 .399 .793 r
.52934 .51577 m .52297 .51683 L .52602 .49847 L p F P
0 0 0 r
s
.83 .24 .1 r
.52905 .51426 m
.52975 .51449 L
s
.83 .224 .089 r
.59294 .25116 m .60548 .25736 L .61214 .27836 L p F P
0 0 0 r
s
.24 .35 .67 r
.69224 .51567 m
.71085 .515 L
s
.71085 .515 m
.75431 .50816 L
s
.83 .24 .1 r
.41274 .51337 m
.44357 .52284 L
s
.44357 .52284 m
.47295 .51792 L
s
.24 .35 .67 r
.52906 .51433 m
.52985 .5142 L
s
.978 .272 .11 r
.64581 .34087 m .63205 .33461 L .63016 .30868 L p F P
0 0 0 r
s
1 .286 .117 r
.63205 .33461 m .64581 .34087 L .64457 .36779 L p F P
0 0 0 r
s
.234 .339 .679 r
.41627 .44627 m .40013 .44937 L .3882 .42404 L p F P
0 0 0 r
s
.242 .354 .707 r
.40013 .44937 m .41627 .44627 L .42916 .47014 L p F P
0 0 0 r
s
.24 .35 .67 r
.6295 .51552 m
.64947 .52243 L
s
.64947 .52243 m
.69224 .51567 L
s
1 .317 .132 r
.60804 .47113 m .59811 .46747 L .61016 .4431 L p F P
0 0 0 r
s
1 .317 .132 r
.61016 .4431 m .62147 .44745 L .60804 .47113 L p F P
0 0 0 r
s
.225 .323 .649 r
.37958 .39747 m .39847 .39354 L .40594 .4205 L p F P
0 0 0 r
s
.225 .323 .649 r
.40594 .4205 m .3882 .42404 L .37958 .39747 L p F P
0 0 0 r
s
.24 .35 .67 r
.56714 .50802 m
.58746 .52228 L
s
.58746 .52228 m
.6295 .51552 L
s
.259 .384 .764 r
.46799 .48722 m .48 .4851 L .48857 .50486 L p F P
0 0 0 r
s
.259 .384 .764 r
.49786 .50327 m .48857 .50486 L .48 .4851 L p F P
0 0 0 r
s
.234 .339 .679 r
.3882 .42404 m .40594 .4205 L .41627 .44627 L p F P
0 0 0 r
s
.088 .108 .226 r
.53107 .20921 m .54573 .20549 L .55035 .21647 L p F P
0 0 0 r
s
.088 .108 .226 r
.55035 .21647 m .53334 .22073 L .53107 .20921 L p F P
0 0 0 r
s
.267 .399 .793 r
.52602 .49847 m .53551 .49685 L .52934 .51577 L p F P
0 0 0 r
s
.24 .35 .67 r
.53297 .51368 m
.56714 .50802 L
s
.83 .24 .1 r
.50221 .50548 m
.52653 .51344 L
s
.52467 .19501 m
.50048 .18109 L
s
.47055 .16588 m
.50048 .18109 L
s
.251 .368 .736 r
.42916 .47014 m .44341 .46752 L .45607 .48933 L p F P
0 0 0 r
s
.251 .368 .736 r
.46799 .48722 m .45607 .48933 L .44341 .46752 L p F P
0 0 0 r
s
1 .321 .134 r
.58405 .48929 m .57568 .48634 L .58807 .46377 L p F P
0 0 0 r
s
1 .321 .134 r
.58807 .46377 m .59811 .46747 L .58405 .48929 L p F P
0 0 0 r
s
.242 .354 .707 r
.44341 .46752 m .42916 .47014 L .41627 .44627 L p F P
0 0 0 r
s
.204 .289 .584 r
.3929 .33918 m .41287 .33468 L .41387 .36187 L p F P
0 0 0 r
s
.24 .35 .67 r
.39293 .33986 m
.39342 .33975 L
s
.41289 .33537 m
.41397 .33512 L
s
.204 .289 .584 r
.41387 .36187 m .39408 .36617 L .3929 .33918 L p F P
0 0 0 r
s
.83 .24 .1 r
.22591 .23092 m
.21112 .2645 L
s
.17631 .25067 m
.21112 .2645 L
s
.21112 .2645 m
.2014 .2997 L
s
.155 .21 .43 r
.46141 .25476 m .47957 .25031 L .47675 .27096 L p F P
0 0 0 r
s
.155 .21 .43 r
.47675 .27096 m .45724 .27564 L .46141 .25476 L p F P
0 0 0 r
s
1 .297 .122 r
.63094 .3618 m .64457 .36779 L .64 .39504 L p F P
0 0 0 r
s
1 .286 .117 r
.64457 .36779 m .63094 .3618 L .63205 .33461 L p F P
0 0 0 r
s
.83 .24 .1 r
.63083 .33505 m
.63201 .33559 L
s
.24521 .20024 m
.22591 .23092 L
s
.19133 .21652 m
.22591 .23092 L
s
1 .312 .129 r
.62147 .44745 m .61016 .4431 L .61983 .41685 L p F P
0 0 0 r
s
.83 .24 .1 r
.62146 .44712 m
.62159 .44718 L
s
1 .312 .129 r
.61983 .41685 m .63223 .42185 L .62147 .44745 L p F P
0 0 0 r
s
1 .323 .135 r
.5554 .50358 m .54882 .50135 L .55868 .48036 L p F P
0 0 0 r
s
1 .323 .135 r
.55868 .48036 m .56722 .48336 L .5554 .50358 L p F P
0 0 0 r
s
.83 .24 .1 r
.20572 .40167 m
.24007 .41302 L
s
.24007 .41302 m
.25284 .44093 L
s
.126 .164 .342 r
.49981 .22912 m .51649 .22494 L .51647 .24125 L p F P
0 0 0 r
s
.24 .35 .67 r
.49963 .23076 m
.50144 .23031 L
s
.51649 .22558 m
.51709 .22479 L
s
.126 .164 .342 r
.51647 .24125 m .49792 .2458 L .49981 .22912 L p F P
0 0 0 r
s
.259 .384 .764 r
.48 .4851 m .4921 .48296 L .49786 .50327 L p F P
0 0 0 r
s
.259 .384 .764 r
.5072 .50168 m .49786 .50327 L .4921 .48296 L p F P
0 0 0 r
s
.83 .24 .1 r
.16638 .28644 m
.2014 .2997 L
s
.2014 .2997 m
.19715 .3352 L
s
.27074 .46392 m
.30404 .47425 L
s
.30404 .47425 m
.32639 .49106 L
s
.191 .268 .543 r
.41457 .30876 m .43446 .30413 L .43308 .33013 L p F P
0 0 0 r
s
.191 .268 .543 r
.43308 .33013 m .41287 .33468 L .41457 .30876 L p F P
0 0 0 r
s
.24 .35 .67 r
.41397 .33512 m
.41403 .33442 L
s
1 .306 .126 r
.62683 .38948 m .64 .39504 L .63223 .42185 L p F P
0 0 0 r
s
1 .297 .122 r
.64 .39504 m .62683 .38948 L .63094 .3618 L p F P
0 0 0 r
s
.978 .272 .11 r
.61639 .3022 m .63016 .30868 L .63205 .33461 L p F P
0 0 0 r
s
.83 .24 .1 r
.62745 .30411 m
.62783 .30758 L
s
.63041 .33121 m
.63083 .33505 L
s
.918 .252 .101 r
.63016 .30868 m .61639 .3022 L .61214 .27836 L p F P
0 0 0 r
s
1 .306 .126 r
.63223 .42185 m .61983 .41685 L .62683 .38948 L p F P
0 0 0 r
s
.175 .243 .494 r
.43796 .28026 m .45724 .27564 L .45459 .29944 L p F P
0 0 0 r
s
.175 .243 .494 r
.45459 .29944 m .43446 .30413 L .43796 .28026 L p F P
0 0 0 r
s
.696 .182 .07 r
.59294 .25116 m .58022 .24486 L .57381 .22826 L p F P
0 0 0 r
s
.696 .182 .07 r
.56216 .22241 m .57381 .22826 L .58022 .24486 L p F P
0 0 0 r
s
.234 .339 .679 r
.43257 .44315 m .41627 .44627 L .40594 .4205 L p F P
0 0 0 r
s
.242 .354 .707 r
.41627 .44627 m .43257 .44315 L .44341 .46752 L p F P
0 0 0 r
s
.215 .307 .618 r
.39408 .36617 m .41387 .36187 L .41757 .38955 L p F P
0 0 0 r
s
.215 .307 .618 r
.41757 .38955 m .39847 .39354 L .39408 .36617 L p F P
0 0 0 r
s
.24 .35 .67 r
.41513 .37131 m
.41589 .37114 L
s
.251 .368 .736 r
.44341 .46752 m .45779 .46487 L .46799 .48722 L p F P
0 0 0 r
s
.251 .368 .736 r
.48 .4851 m .46799 .48722 L .45779 .46487 L p F P
0 0 0 r
s
.24 .35 .67 r
.79563 .14261 m
.81368 .15406 L
s
.83 .24 .1 r
.26834 .17364 m
.24521 .20024 L
s
.21088 .18529 m
.24521 .20024 L
s
.53 .131 .051 r
.56216 .22241 m .55035 .21647 L .54573 .20549 L p F P
0 0 0 r
s
.24 .35 .67 r
.75142 .15382 m
.79563 .14261 L
s
.75142 .15382 m
.73322 .14982 L
s
.225 .323 .649 r
.42386 .41691 m .40594 .4205 L .39847 .39354 L p F P
0 0 0 r
s
.234 .339 .679 r
.40594 .4205 m .42386 .41691 L .43257 .44315 L p F P
0 0 0 r
s
.24 .35 .67 r
.4324 .44265 m
.43346 .44244 L
s
.225 .323 .649 r
.39847 .39354 m .41757 .38955 L .42386 .41691 L p F P
0 0 0 r
s
.24 .35 .67 r
.42174 .4077 m
.4225 .40754 L
s
.242 .354 .707 r
.45779 .46487 m .44341 .46752 L .43257 .44315 L p F P
0 0 0 r
s
.24 .35 .67 r
.43346 .44244 m
.4346 .44491 L
s
.259 .384 .764 r
.4921 .48296 m .50428 .4808 L .5072 .50168 L p F P
0 0 0 r
s
.259 .384 .764 r
.51658 .50008 m .5072 .50168 L .50428 .4808 L p F P
0 0 0 r
s
.24 .35 .67 r
.68971 .16095 m
.73322 .14982 L
s
.68971 .16095 m
.67212 .16469 L
s
1 .317 .132 r
.59811 .46747 m .58807 .46377 L .5987 .43868 L p F P
0 0 0 r
s
1 .317 .132 r
.5987 .43868 m .61016 .4431 L .59811 .46747 L p F P
0 0 0 r
s
1 .321 .134 r
.57568 .48634 m .56722 .48336 L .5779 .46003 L p F P
0 0 0 r
s
1 .321 .134 r
.5779 .46003 m .58807 .46377 L .57568 .48634 L p F P
0 0 0 r
s
.918 .252 .101 r
.59871 .27185 m .61214 .27836 L .61639 .3022 L p F P
0 0 0 r
s
.83 .224 .089 r
.61214 .27836 m .59871 .27185 L .59294 .25116 L p F P
0 0 0 r
s
.83 .24 .1 r
.3839 .14444 m
.35508 .15264 L
s
.32254 .13687 m
.35508 .15264 L
s
.35235 .50105 m
.3844 .51079 L
s
.3844 .51079 m
.41274 .51337 L
s
.83 .224 .089 r
.58022 .24486 m .59294 .25116 L .59871 .27185 L p F P
0 0 0 r
s
1 .323 .135 r
.54882 .50135 m .54219 .49911 L .55006 .47732 L p F P
0 0 0 r
s
1 .323 .135 r
.55006 .47732 m .55868 .48036 L .54882 .50135 L p F P
0 0 0 r
s
.24 .35 .67 r
.62929 .17565 m
.67212 .16469 L
s
.62929 .17565 m
.61311 .18707 L
s
.83 .24 .1 r
.16192 .32249 m
.19715 .3352 L
s
.19715 .3352 m
.19857 .36965 L
s
.155 .21 .43 r
.47957 .25031 m .49792 .2458 L .49649 .26623 L p F P
0 0 0 r
s
.155 .21 .43 r
.49649 .26623 m .47675 .27096 L .47957 .25031 L p F P
0 0 0 r
s
.24 .35 .67 r
.57096 .19778 m
.61311 .18707 L
s
.55704 .21642 m
.57096 .19778 L
s
.204 .289 .584 r
.41287 .33468 m .43308 .33013 L .4339 .35753 L p F P
0 0 0 r
s
.204 .289 .584 r
.4339 .35753 m .41387 .36187 L .41287 .33468 L p F P
0 0 0 r
s
.24 .35 .67 r
.41538 .36155 m
.41589 .37114 L
s
.978 .272 .11 r
.63205 .33461 m .61807 .32823 L .61639 .3022 L p F P
0 0 0 r
s
1 .286 .117 r
.61807 .32823 m .63205 .33461 L .63094 .3618 L p F P
0 0 0 r
s
.83 .24 .1 r
.47055 .16588 m
.44358 .15921 L
s
.41248 .14353 m
.44358 .15921 L
s
.44235 .50828 m
.47295 .51792 L
s
.47295 .51792 m
.50221 .50548 L
s
.126 .164 .342 r
.51649 .22494 m .53334 .22073 L .53522 .23664 L p F P
0 0 0 r
s
.24 .35 .67 r
.51649 .22655 m
.51833 .22609 L
s
.126 .164 .342 r
.53522 .23664 m .51647 .24125 L .51649 .22494 L p F P
0 0 0 r
s
.251 .368 .736 r
.45779 .46487 m .47228 .46221 L .48 .4851 L p F P
0 0 0 r
s
.251 .368 .736 r
.4921 .48296 m .48 .4851 L .47228 .46221 L p F P
0 0 0 r
s
.259 .384 .764 r
.50428 .4808 m .51655 .47863 L .51658 .50008 L p F P
0 0 0 r
s
.259 .384 .764 r
.52602 .49847 m .51658 .50008 L .51655 .47863 L p F P
0 0 0 r
s
.83 .24 .1 r
.29444 .1522 m
.26834 .17364 L
s
.23424 .15818 m
.26834 .17364 L
s
.234 .339 .679 r
.44902 .43999 m .43257 .44315 L .42386 .41691 L p F P
0 0 0 r
s
.24 .35 .67 r
.4225 .40754 m
.42608 .41894 L
s
.242 .354 .707 r
.43257 .44315 m .44902 .43999 L .45779 .46487 L p F P
0 0 0 r
s
.24 .35 .67 r
.87317 .47071 m
.86004 .48587 L
s
1 .312 .129 r
.61016 .4431 m .5987 .43868 L .60725 .41177 L p F P
0 0 0 r
s
.83 .24 .1 r
.61013 .44276 m
.61027 .44281 L
s
1 .312 .129 r
.60725 .41177 m .61983 .41685 L .61016 .4431 L p F P
0 0 0 r
s
.191 .268 .543 r
.43446 .30413 m .45459 .29944 L .45354 .32552 L p F P
0 0 0 r
s
.191 .268 .543 r
.45354 .32552 m .43308 .33013 L .43446 .30413 L p F P
0 0 0 r
s
.175 .243 .494 r
.45724 .27564 m .47675 .27096 L .47496 .2947 L p F P
0 0 0 r
s
.175 .243 .494 r
.47496 .2947 m .45459 .29944 L .45724 .27564 L p F P
0 0 0 r
s
.24 .35 .67 r
.79882 .50116 m
.81485 .49305 L
s
.81485 .49305 m
.86004 .48587 L
s
.242 .354 .707 r
.47228 .46221 m .45779 .46487 L .44902 .43999 L p F P
0 0 0 r
s
1 .323 .135 r
.54219 .49911 m .53551 .49685 L .54135 .47425 L p F P
0 0 0 r
s
1 .323 .135 r
.54135 .47425 m .55006 .47732 L .54219 .49911 L p F P
0 0 0 r
s
.215 .307 .618 r
.41387 .36187 m .4339 .35753 L .43689 .38552 L p F P
0 0 0 r
s
.215 .307 .618 r
.43689 .38552 m .41757 .38955 L .41387 .36187 L p F P
0 0 0 r
s
.24 .35 .67 r
.41917 .38922 m
.4225 .40754 L
s
1 .297 .122 r
.61708 .35572 m .63094 .3618 L .62683 .38948 L p F P
0 0 0 r
s
.83 .24 .1 r
.62885 .36089 m
.62914 .35712 L
s
1 .286 .117 r
.63094 .3618 m .61708 .35572 L .61807 .32823 L p F P
0 0 0 r
s
.83 .24 .1 r
.52467 .19501 m
.54508 .21572 L
s
.49485 .17988 m
.52467 .19501 L
s
.696 .182 .07 r
.58022 .24486 m .5673 .23847 L .56216 .22241 L p F P
0 0 0 r
s
.696 .182 .07 r
.55035 .21647 m .56216 .22241 L .5673 .23847 L p F P
0 0 0 r
s
.24 .35 .67 r
.73604 .50874 m
.75431 .50816 L
s
.75431 .50816 m
.79882 .50116 L
s
.83 .24 .1 r
.21842 .42996 m
.25284 .44093 L
s
.25284 .44093 m
.27074 .46392 L
s
1 .321 .134 r
.56722 .48336 m .55868 .48036 L .56761 .45624 L p F P
0 0 0 r
s
1 .321 .134 r
.56761 .45624 m .5779 .46003 L .56722 .48336 L p F P
0 0 0 r
s
.225 .323 .649 r
.44199 .41329 m .42386 .41691 L .41757 .38955 L p F P
0 0 0 r
s
.234 .339 .679 r
.42386 .41691 m .44199 .41329 L .44902 .43999 L p F P
0 0 0 r
s
.24 .35 .67 r
.54773 .48668 m
.56714 .50802 L
s
.56714 .50802 m
.60941 .50101 L
s
1 .306 .126 r
.61983 .41685 m .60725 .41177 L .61344 .38384 L p F P
0 0 0 r
s
1 .306 .126 r
.61344 .38384 m .62683 .38948 L .61983 .41685 L p F P
0 0 0 r
s
.83 .24 .1 r
.62365 .38815 m
.62496 .38303 L
s
.259 .384 .764 r
.51655 .47863 m .5289 .47645 L .52602 .49847 L p F P
0 0 0 r
s
.259 .384 .764 r
.53551 .49685 m .52602 .49847 L .5289 .47645 L p F P
0 0 0 r
s
.225 .323 .649 r
.41757 .38955 m .43689 .38552 L .44199 .41329 L p F P
0 0 0 r
s
1 .297 .122 r
.62683 .38948 m .61344 .38384 L .61708 .35572 L p F P
0 0 0 r
s
.251 .368 .736 r
.47228 .46221 m .4869 .45952 L .4921 .48296 L p F P
0 0 0 r
s
.251 .368 .736 r
.50428 .4808 m .4921 .48296 L .4869 .45952 L p F P
0 0 0 r
s
1 .317 .132 r
.58807 .46377 m .5779 .46003 L .58708 .4342 L p F P
0 0 0 r
s
1 .317 .132 r
.58708 .4342 m .5987 .43868 L .58807 .46377 L p F P
0 0 0 r
s
.24 .35 .67 r
.67256 .50859 m
.69224 .51567 L
s
.69224 .51567 m
.73604 .50874 L
s
.978 .272 .11 r
.60239 .2956 m .61639 .3022 L .61807 .32823 L p F P
0 0 0 r
s
.918 .252 .101 r
.61639 .3022 m .60239 .2956 L .59871 .27185 L p F P
0 0 0 r
s
.24 .35 .67 r
.60941 .50101 m
.6295 .51552 L
s
.6295 .51552 m
.67256 .50859 L
s
.83 .24 .1 r
.16318 .35745 m
.19857 .36965 L
s
.19857 .36965 m
.20572 .40167 L
s
.155 .21 .43 r
.49792 .2458 m .51647 .24125 L .51645 .26145 L p F P
0 0 0 r
s
.155 .21 .43 r
.51645 .26145 m .49649 .26623 L .49792 .2458 L p F P
0 0 0 r
s
.126 .164 .342 r
.53334 .22073 m .55035 .21647 L .55418 .23199 L p F P
0 0 0 r
s
.24 .35 .67 r
.53352 .2223 m
.53538 .22183 L
s
.55073 .218 m
.5514 .21783 L
s
.55172 .21775 m
.55193 .2177 L
s
.83 .24 .1 r
.54864 .21751 m
.54879 .21758 L
s
.55088 .21863 m
.55272 .21955 L
s
.54508 .21572 m
.54864 .21751 L
s
.126 .164 .342 r
.55418 .23199 m .53522 .23664 L .53334 .22073 L p F P
0 0 0 r
s
.83 .24 .1 r
.29313 .48091 m
.32639 .49106 L
s
.32639 .49106 m
.35235 .50105 L
s
.204 .289 .584 r
.43308 .33013 m .45354 .32552 L .45416 .35313 L p F P
0 0 0 r
s
.24 .35 .67 r
.4331 .33082 m
.43361 .33071 L
s
.45356 .32622 m
.45422 .32607 L
s
.204 .289 .584 r
.45416 .35313 m .4339 .35753 L .43308 .33013 L p F P
0 0 0 r
s
.83 .224 .089 r
.59871 .27185 m .58506 .26525 L .58022 .24486 L p F P
0 0 0 r
s
.83 .224 .089 r
.5673 .23847 m .58022 .24486 L .58506 .26525 L p F P
0 0 0 r
s
.259 .384 .764 r
.5289 .47645 m .54135 .47425 L .53551 .49685 L p F P
0 0 0 r
s
.83 .24 .1 r
.52992 .48596 m
.53584 .488 L
s
.24 .35 .67 r
.53933 .48814 m
.54773 .48668 L
s
.234 .339 .679 r
.46564 .43681 m .44902 .43999 L .44199 .41329 L p F P
0 0 0 r
s
.242 .354 .707 r
.44902 .43999 m .46564 .43681 L .47228 .46221 L p F P
0 0 0 r
s
.918 .252 .101 r
.58506 .26525 m .59871 .27185 L .60239 .2956 L p F P
0 0 0 r
s
.242 .354 .707 r
.4869 .45952 m .47228 .46221 L .46564 .43681 L p F P
0 0 0 r
s
.83 .24 .1 r
.41248 .14353 m
.3839 .14444 L
s
.35156 .12839 m
.3839 .14444 L
s
.251 .368 .736 r
.4869 .45952 m .50164 .45681 L .50428 .4808 L p F P
0 0 0 r
s
.251 .368 .736 r
.51655 .47863 m .50428 .4808 L .50164 .45681 L p F P
0 0 0 r
s
.175 .243 .494 r
.47675 .27096 m .49649 .26623 L .49558 .2899 L p F P
0 0 0 r
s
.175 .243 .494 r
.49558 .2899 m .47496 .2947 L .47675 .27096 L p F P
0 0 0 r
s
.83 .24 .1 r
.32254 .13687 m
.29444 .1522 L
s
.26057 .13628 m
.29444 .1522 L
s
.191 .268 .543 r
.45459 .29944 m .47496 .2947 L .47425 .32086 L p F P
0 0 0 r
s
.191 .268 .543 r
.47425 .32086 m .45354 .32552 L .45459 .29944 L p F P
0 0 0 r
s
.24 .35 .67 r
.45422 .32607 m
.45427 .32536 L
s
.83 .24 .1 r
.47186 .49556 m
.50221 .50548 L
s
.50221 .50548 m
.52992 .48596 L
s
.38086 .50357 m
.41274 .51337 L
s
.41274 .51337 m
.44235 .50828 L
s
1 .321 .134 r
.55868 .48036 m .55006 .47732 L .55719 .45241 L p F P
0 0 0 r
s
1 .321 .134 r
.55719 .45241 m .56761 .45624 L .55868 .48036 L p F P
0 0 0 r
s
1 .312 .129 r
.5987 .43868 m .58708 .4342 L .59447 .40662 L p F P
0 0 0 r
s
.83 .24 .1 r
.59866 .43834 m
.59879 .43839 L
s
1 .312 .129 r
.59447 .40662 m .60725 .41177 L .5987 .43868 L p F P
0 0 0 r
s
.978 .272 .11 r
.61807 .32823 m .60384 .32175 L .60239 .2956 L p F P
0 0 0 r
s
1 .286 .117 r
.60384 .32175 m .61807 .32823 L .61708 .35572 L p F P
0 0 0 r
s
.215 .307 .618 r
.4339 .35753 m .45416 .35313 L .45644 .38145 L p F P
0 0 0 r
s
.215 .307 .618 r
.45644 .38145 m .43689 .38552 L .4339 .35753 L p F P
0 0 0 r
s
.24 .35 .67 r
.45494 .36278 m
.4563 .36249 L
s
.225 .323 .649 r
.4603 .40962 m .44199 .41329 L .43689 .38552 L p F P
0 0 0 r
s
.234 .339 .679 r
.44199 .41329 m .4603 .40962 L .46564 .43681 L p F P
0 0 0 r
s
.24 .35 .67 r
.77779 .13841 m
.79563 .14261 L
s
.225 .323 .649 r
.43689 .38552 m .45644 .38145 L .4603 .40962 L p F P
0 0 0 r
s
.83 .24 .1 r
.49485 .17988 m
.47055 .16588 L
s
.43959 .15015 m
.47055 .16588 L
s
.696 .182 .07 r
.5673 .23847 m .55418 .23199 L .55035 .21647 L p F P
0 0 0 r
s
.24 .35 .67 r
.55193 .2177 m
.55704 .21642 L
s
1 .317 .132 r
.5779 .46003 m .56761 .45624 L .5753 .42967 L p F P
0 0 0 r
s
1 .317 .132 r
.5753 .42967 m .58708 .4342 L .5779 .46003 L p F P
0 0 0 r
s
.24 .35 .67 r
.73322 .14982 m
.77779 .13841 L
s
.73322 .14982 m
.71599 .15345 L
s
.155 .21 .43 r
.51647 .24125 m .53522 .23664 L .53665 .25661 L p F P
0 0 0 r
s
.155 .21 .43 r
.53665 .25661 m .51645 .26145 L .51647 .24125 L p F P
0 0 0 r
s
.83 .24 .1 r
.19133 .21652 m
.17631 .25067 L
s
.17631 .25067 m
.16638 .28644 L
s
.242 .354 .707 r
.46564 .43681 m .48242 .43359 L .4869 .45952 L p F P
0 0 0 r
s
.242 .354 .707 r
.50164 .45681 m .4869 .45952 L .48242 .43359 L p F P
0 0 0 r
s
.251 .368 .736 r
.50164 .45681 m .51652 .45407 L .51655 .47863 L p F P
0 0 0 r
s
.251 .368 .736 r
.5289 .47645 m .51655 .47863 L .51652 .45407 L p F P
0 0 0 r
s
1 .306 .126 r
.60725 .41177 m .59447 .40662 L .59983 .37811 L p F P
0 0 0 r
s
1 .306 .126 r
.59983 .37811 m .61344 .38384 L .60725 .41177 L p F P
0 0 0 r
s
1 .297 .122 r
.60299 .34953 m .61708 .35572 L .61344 .38384 L p F P
0 0 0 r
s
1 .286 .117 r
.61708 .35572 m .60299 .34953 L .60384 .32175 L p F P
0 0 0 r
s
.83 .24 .1 r
.6029 .32234 m
.60381 .32275 L
s
.24 .35 .67 r
.67212 .16469 m
.71599 .15345 L
s
.67212 .16469 m
.65629 .1761 L
s
.83 .24 .1 r
.21088 .18529 m
.19133 .21652 L
s
.234 .339 .679 r
.48242 .43359 m .46564 .43681 L .4603 .40962 L p F P
0 0 0 r
s
.24 .35 .67 r
.55704 .21642 m
.59952 .20581 L
s
.55361 .22462 m
.55704 .21642 L
s
.83 .24 .1 r
.1702 .38994 m
.20572 .40167 L
s
.20572 .40167 m
.21842 .42996 L
s
.24 .35 .67 r
.61311 .18707 m
.65629 .1761 L
s
.61311 .18707 m
.59952 .20581 L
s
1 .297 .122 r
.61344 .38384 m .59983 .37811 L .60299 .34953 L p F P
0 0 0 r
s
.204 .289 .584 r
.45354 .32552 m .47425 .32086 L .47467 .34868 L p F P
0 0 0 r
s
.204 .289 .584 r
.47467 .34868 m .45416 .35313 L .45354 .32552 L p F P
0 0 0 r
s
.24 .35 .67 r
.45574 .35279 m
.4563 .36249 L
s
.83 .24 .1 r
.54508 .21572 m
.55014 .22442 L
s
.51532 .20081 m
.54508 .21572 L
s
.16638 .28644 m
.16192 .32249 L
s
.23629 .45324 m
.27074 .46392 L
s
.27074 .46392 m
.29313 .48091 L
s
.978 .272 .11 r
.58816 .2889 m .60239 .2956 L .60384 .32175 L p F P
0 0 0 r
s
.83 .24 .1 r
.59957 .29066 m
.59997 .29446 L
s
.60256 .31906 m
.6029 .32234 L
s
.918 .252 .101 r
.60239 .2956 m .58816 .2889 L .58506 .26525 L p F P
0 0 0 r
s
.24 .35 .67 r
.54274 .47884 m
.54773 .48668 L
s
.54773 .48668 m
.59016 .47935 L
s
1 .321 .134 r
.55006 .47732 m .54135 .47425 L .54665 .44853 L p F P
0 0 0 r
s
1 .321 .134 r
.54665 .44853 m .55719 .45241 L .55006 .47732 L p F P
0 0 0 r
s
.175 .243 .494 r
.49649 .26623 m .51645 .26145 L .51644 .28504 L p F P
0 0 0 r
s
.175 .243 .494 r
.51644 .28504 m .49558 .2899 L .49649 .26623 L p F P
0 0 0 r
s
.191 .268 .543 r
.47496 .2947 m .49558 .2899 L .49522 .31614 L p F P
0 0 0 r
s
.191 .268 .543 r
.49522 .31614 m .47425 .32086 L .47496 .2947 L p F P
0 0 0 r
s
.83 .24 .1 r
.23424 .15818 m
.21088 .18529 L
s
.83 .224 .089 r
.58506 .26525 m .57119 .25854 L .5673 .23847 L p F P
0 0 0 r
s
.83 .224 .089 r
.55418 .23199 m .5673 .23847 L .57119 .25854 L p F P
0 0 0 r
s
.83 .24 .1 r
.56063 .24246 m
.561 .24264 L
s
.55811 .23812 m
.56063 .24246 L
s
.52992 .48596 m
.537 .47861 L
s
.24 .35 .67 r
.86004 .48587 m
.84442 .49398 L
s
.225 .323 .649 r
.47882 .40592 m .4603 .40962 L .45644 .38145 L p F P
0 0 0 r
s
.234 .339 .679 r
.4603 .40962 m .47882 .40592 L .48242 .43359 L p F P
0 0 0 r
s
.918 .252 .101 r
.57119 .25854 m .58506 .26525 L .58816 .2889 L p F P
0 0 0 r
s
.215 .307 .618 r
.45416 .35313 m .47467 .34868 L .47621 .37732 L p F P
0 0 0 r
s
.215 .307 .618 r
.47621 .37732 m .45644 .38145 L .45416 .35313 L p F P
0 0 0 r
s
.24 .35 .67 r
.45963 .38078 m
.46057 .38597 L
s
.251 .368 .736 r
.51652 .45407 m .53152 .45131 L .5289 .47645 L p F P
0 0 0 r
s
.251 .368 .736 r
.54135 .47425 m .5289 .47645 L .53152 .45131 L p F P
0 0 0 r
s
.83 .24 .1 r
.49986 .47564 m
.52992 .48596 L
s
.5413 .47414 m
.54139 .47404 L
s
.24 .35 .67 r
.78091 .50165 m
.79882 .50116 L
s
.79882 .50116 m
.84442 .49398 L
s
.242 .354 .707 r
.48242 .43359 m .49937 .43034 L .50164 .45681 L p F P
0 0 0 r
s
.242 .354 .707 r
.51652 .45407 m .50164 .45681 L .49937 .43034 L p F P
0 0 0 r
s
.83 .24 .1 r
.35156 .12839 m
.32254 .13687 L
s
.28888 .12056 m
.32254 .13687 L
s
1 .312 .129 r
.58708 .4342 m .5753 .42967 L .5815 .40139 L p F P
0 0 0 r
s
.83 .24 .1 r
.57532 .42934 m
.57537 .42936 L
s
.58702 .43385 m
.58716 .43391 L
s
1 .312 .129 r
.5815 .40139 m .59447 .40662 L .58708 .4342 L p F P
0 0 0 r
s
.225 .323 .649 r
.45644 .38145 m .47621 .37732 L .47882 .40592 L p F P
0 0 0 r
s
.83 .24 .1 r
.3192 .49097 m
.35235 .50105 L
s
.35235 .50105 m
.38086 .50357 L
s
.24 .35 .67 r
.59016 .47935 m
.60941 .50101 L
s
.60941 .50101 m
.6527 .49382 L
s
.155 .21 .43 r
.53522 .23664 m .55418 .23199 L .55709 .25171 L p F P
0 0 0 r
s
.155 .21 .43 r
.55709 .25171 m .53665 .25661 L .53522 .23664 L p F P
0 0 0 r
s
.83 .24 .1 r
.16192 .32249 m
.16318 .35745 L
s
1 .317 .132 r
.56761 .45624 m .55719 .45241 L .56335 .42506 L p F P
0 0 0 r
s
1 .317 .132 r
.56335 .42506 m .5753 .42967 L .56761 .45624 L p F P
0 0 0 r
s
.24 .35 .67 r
.71667 .5015 m
.73604 .50874 L
s
.73604 .50874 m
.78091 .50165 L
s
.234 .339 .679 r
.49937 .43034 m .48242 .43359 L .47882 .40592 L p F P
0 0 0 r
s
.24 .35 .67 r
.6527 .49382 m
.67256 .50859 L
s
.67256 .50859 m
.71667 .5015 L
s
.83 .24 .1 r
.43959 .15015 m
.41248 .14353 L
s
.38031 .12731 m
.41248 .14353 L
s
.41069 .49831 m
.44235 .50828 L
s
.44235 .50828 m
.47186 .49556 L
s
.978 .272 .11 r
.60384 .32175 m .58937 .31515 L .58816 .2889 L p F P
0 0 0 r
s
1 .286 .117 r
.58937 .31515 m .60384 .32175 L .60299 .34953 L p F P
0 0 0 r
s
.204 .289 .584 r
.47425 .32086 m .49522 .31614 L .49543 .34417 L p F P
0 0 0 r
s
.24 .35 .67 r
.47426 .32156 m
.47478 .32144 L
s
.49522 .31684 m
.49545 .31679 L
s
.204 .289 .584 r
.49543 .34417 m .47467 .34868 L .47425 .32086 L p F P
0 0 0 r
s
.251 .368 .736 r
.53152 .45131 m .54665 .44853 L .54135 .47425 L p F P
0 0 0 r
s
.83 .24 .1 r
.26057 .13628 m
.23424 .15818 L
s
.57514 .42961 m
.57532 .42934 L
s
1 .306 .126 r
.59447 .40662 m .5815 .40139 L .586 .37228 L p F P
0 0 0 r
s
1 .306 .126 r
.586 .37228 m .59983 .37811 L .59447 .40662 L p F P
0 0 0 r
s
.175 .243 .494 r
.51645 .26145 m .53665 .25661 L .53756 .28012 L p F P
0 0 0 r
s
.175 .243 .494 r
.53756 .28012 m .51644 .28504 L .51645 .26145 L p F P
0 0 0 r
s
1 .297 .122 r
.58865 .34324 m .60299 .34953 L .59983 .37811 L p F P
0 0 0 r
s
.83 .24 .1 r
.60082 .34858 m
.60112 .34481 L
s
1 .286 .117 r
.60299 .34953 m .58865 .34324 L .58937 .31515 L p F P
0 0 0 r
s
.242 .354 .707 r
.49937 .43034 m .51649 .42706 L .51652 .45407 L p F P
0 0 0 r
s
.242 .354 .707 r
.53152 .45131 m .51652 .45407 L .51649 .42706 L p F P
0 0 0 r
s
.83 .24 .1 r
.54252 .45576 m
.54348 .45611 L
s
.225 .323 .649 r
.49754 .40217 m .47882 .40592 L .47621 .37732 L p F P
0 0 0 r
s
.234 .339 .679 r
.47882 .40592 m .49754 .40217 L .49937 .43034 L p F P
0 0 0 r
s
.83 .24 .1 r
.51532 .20081 m
.49485 .17988 L
s
.46401 .16424 m
.49485 .17988 L
s
.191 .268 .543 r
.49558 .2899 m .51644 .28504 L .51644 .31136 L p F P
0 0 0 r
s
.191 .268 .543 r
.51644 .31136 m .49522 .31614 L .49558 .2899 L p F P
0 0 0 r
s
.24 .35 .67 r
.49545 .31679 m
.4955 .31607 L
s
1 .297 .122 r
.59983 .37811 m .586 .37228 L .58865 .34324 L p F P
0 0 0 r
s
.83 .24 .1 r
.18281 .41861 m
.21842 .42996 L
s
.21842 .42996 m
.23629 .45324 L
s
.24 .35 .67 r
.54632 .45623 m
.54768 .45598 L
s
.83 .24 .1 r
.53089 .22788 m
.55296 .23869 L
s
.55296 .23869 m
.55402 .23922 L
s
.215 .307 .618 r
.47467 .34868 m .49543 .34417 L .49621 .37315 L p F P
0 0 0 r
s
.215 .307 .618 r
.49621 .37315 m .47621 .37732 L .47467 .34868 L p F P
0 0 0 r
s
.24 .35 .67 r
.49569 .35405 m
.49769 .35363 L
s
.83 .24 .1 r
.57532 .42934 m
.57542 .42912 L
s
.978 .272 .11 r
.57368 .28208 m .58816 .2889 L .58937 .31515 L p F P
0 0 0 r
s
.918 .252 .101 r
.58816 .2889 m .57368 .28208 L .57119 .25854 L p F P
0 0 0 r
s
.225 .323 .649 r
.47621 .37732 m .49621 .37315 L .49754 .40217 L p F P
0 0 0 r
s
.234 .339 .679 r
.51649 .42706 m .49937 .43034 L .49754 .40217 L p F P
0 0 0 r
s
.83 .224 .089 r
.57119 .25854 m .55709 .25171 L .55418 .23199 L p F P
0 0 0 r
s
.83 .24 .1 r
.16318 .35745 m
.1702 .38994 L
s
.24 .35 .67 r
.55602 .23933 m
.58926 .23124 L
s
1 .317 .132 r
.55719 .45241 m .54665 .44853 L .55124 .4204 L p F P
0 0 0 r
s
1 .317 .132 r
.55124 .4204 m .56335 .42506 L .55719 .45241 L p F P
0 0 0 r
s
.24 .35 .67 r
.54768 .45598 m
.57275 .45142 L
s
1 .312 .129 r
.5753 .42967 m .56335 .42506 L .56833 .39608 L p F P
0 0 0 r
s
.83 .24 .1 r
.57522 .42931 m
.57532 .42934 L
s
1 .312 .129 r
.56833 .39608 m .5815 .40139 L .5753 .42967 L p F P
0 0 0 r
s
.24 .35 .67 r
.76094 .14194 m
.77779 .13841 L
s
.83 .24 .1 r
.25873 .47041 m
.29313 .48091 L
s
.29313 .48091 m
.3192 .49097 L
s
.918 .252 .101 r
.55709 .25171 m .57119 .25854 L .57368 .28208 L p F P
0 0 0 r
s
.24 .35 .67 r
.71599 .15345 m
.76094 .14194 L
s
.71599 .15345 m
.70054 .16486 L
s
.59952 .20581 m
.64305 .19494 L
s
.59952 .20581 m
.58926 .23124 L
s
.65629 .1761 m
.70054 .16486 L
s
.65629 .1761 m
.64305 .19494 L
s
.242 .354 .707 r
.51649 .42706 m .53378 .42375 L .53152 .45131 L p F P
0 0 0 r
s
.242 .354 .707 r
.54665 .44853 m .53152 .45131 L .53378 .42375 L p F P
0 0 0 r
s
.83 .24 .1 r
.52494 .44938 m
.54252 .45576 L
s
.38031 .12731 m
.35156 .12839 L
s
.3181 .11179 m
.35156 .12839 L
s
.204 .289 .584 r
.49522 .31614 m .51644 .31136 L .51644 .33961 L p F P
0 0 0 r
s
.24 .35 .67 r
.49545 .31679 m
.49575 .31672 L
s
.204 .289 .584 r
.51644 .33961 m .49543 .34417 L .49522 .31614 L p F P
0 0 0 r
s
.24 .35 .67 r
.49709 .34381 m
.49769 .35363 L
s
.83 .24 .1 r
.28888 .12056 m
.26057 .13628 L
s
.44046 .48529 m
.47186 .49556 L
s
.47186 .49556 m
.49986 .47564 L
s
.24 .35 .67 r
.57275 .45142 m
.59016 .47935 L
s
.59016 .47935 m
.63363 .47183 L
s
.175 .243 .494 r
.53665 .25661 m .55709 .25171 L .55895 .27515 L p F P
0 0 0 r
s
.175 .243 .494 r
.55895 .27515 m .53756 .28012 L .53665 .25661 L p F P
0 0 0 r
s
.83 .24 .1 r
.34788 .49344 m
.38086 .50357 L
s
.38086 .50357 m
.41069 .49831 L
s
.225 .323 .649 r
.51647 .39839 m .49754 .40217 L .49621 .37315 L p F P
0 0 0 r
s
.234 .339 .679 r
.49754 .40217 m .51647 .39839 L .51649 .42706 L p F P
0 0 0 r
s
.978 .272 .11 r
.58937 .31515 m .57466 .30845 L .57368 .28208 L p F P
0 0 0 r
s
1 .286 .117 r
.57466 .30845 m .58937 .31515 L .58865 .34324 L p F P
0 0 0 r
s
.191 .268 .543 r
.51644 .28504 m .53756 .28012 L .53792 .30652 L p F P
0 0 0 r
s
.191 .268 .543 r
.53792 .30652 m .51644 .31136 L .51644 .28504 L p F P
0 0 0 r
s
.234 .339 .679 r
.53378 .42375 m .51649 .42706 L .51647 .39839 L p F P
0 0 0 r
s
1 .306 .126 r
.5815 .40139 m .56833 .39608 L .57194 .36636 L p F P
0 0 0 r
s
1 .306 .126 r
.57194 .36636 m .586 .37228 L .5815 .40139 L p F P
0 0 0 r
s
.215 .307 .618 r
.49543 .34417 m .51644 .33961 L .51645 .36893 L p F P
0 0 0 r
s
.215 .307 .618 r
.51645 .36893 m .49621 .37315 L .49543 .34417 L p F P
0 0 0 r
s
.83 .24 .1 r
.46401 .16424 m
.43959 .15015 L
s
.40757 .13388 m
.43959 .15015 L
s
.225 .323 .649 r
.49621 .37315 m .51645 .36893 L .51647 .39839 L p F P
0 0 0 r
s
.24 .35 .67 r
.84442 .49398 m
.82689 .49439 L
s
.63363 .47183 m
.6527 .49382 L
s
.6527 .49382 m
.69707 .48647 L
s
1 .297 .122 r
.57408 .33683 m .58865 .34324 L .586 .37228 L p F P
0 0 0 r
s
1 .286 .117 r
.58865 .34324 m .57408 .33683 L .57466 .30845 L p F P
0 0 0 r
s
.83 .24 .1 r
.57402 .30919 m
.57463 .30947 L
s
1 .297 .122 r
.586 .37228 m .57194 .36636 L .57408 .33683 L p F P
0 0 0 r
s
.242 .354 .707 r
.53378 .42375 m .55124 .4204 L .54665 .44853 L p F P
0 0 0 r
s
.24 .35 .67 r
.76186 .49422 m
.78091 .50165 L
s
.78091 .50165 m
.82689 .49439 L
s
.69707 .48647 m
.71667 .5015 L
s
.71667 .5015 m
.76186 .49422 L
s
.83 .24 .1 r
.1702 .38994 m
.18281 .41861 L
s
.53089 .22788 m
.51532 .20081 L
s
.48454 .18538 m
.51532 .20081 L
s
1 .312 .129 r
.56335 .42506 m .55124 .4204 L .55495 .39069 L p F P
0 0 0 r
s
.83 .24 .1 r
.56326 .4247 m
.56341 .42475 L
s
.24 .35 .67 r
.55263 .41957 m
.55285 .41953 L
s
1 .312 .129 r
.55495 .39069 m .56833 .39608 L .56335 .42506 L p F P
0 0 0 r
s
.83 .24 .1 r
.20065 .44219 m
.23629 .45324 L
s
.23629 .45324 m
.25873 .47041 L
s
.978 .272 .11 r
.55895 .27515 m .57368 .28208 L .57466 .30845 L p F P
0 0 0 r
s
.83 .24 .1 r
.57074 .27672 m
.57117 .2809 L
s
.57375 .30653 m
.57402 .30919 L
s
.918 .252 .101 r
.57368 .28208 m .55895 .27515 L .55709 .25171 L p F P
0 0 0 r
s
.83 .24 .1 r
.5407 .25995 m
.55721 .26779 L
s
.24 .35 .67 r
.55912 .26789 m
.58295 .2623 L
s
.204 .289 .584 r
.51644 .31136 m .53792 .30652 L .53771 .335 L p F P
0 0 0 r
s
.24 .35 .67 r
.51644 .31207 m
.51697 .31195 L
s
.204 .289 .584 r
.53771 .335 m .51644 .33961 L .51644 .31136 L p F P
0 0 0 r
s
.225 .323 .649 r
.5356 .39456 m .51647 .39839 L .51645 .36893 L p F P
0 0 0 r
s
.234 .339 .679 r
.51647 .39839 m .5356 .39456 L .53378 .42375 L p F P
0 0 0 r
s
.83 .24 .1 r
.46874 .46496 m
.49986 .47564 L
s
.49986 .47564 m
.52494 .44938 L
s
.234 .339 .679 r
.55124 .4204 m .53378 .42375 L .5356 .39456 L p F P
0 0 0 r
s
.24 .35 .67 r
.55094 .4199 m
.55131 .41983 L
s
.83 .24 .1 r
.54948 .41938 m
.54963 .41944 L
s
.55097 .41996 m
.55128 .42008 L
s
.191 .268 .543 r
.53756 .28012 m .55895 .27515 L .55968 .30162 L p F P
0 0 0 r
s
.191 .268 .543 r
.55968 .30162 m .53792 .30652 L .53756 .28012 L p F P
0 0 0 r
s
.83 .24 .1 r
.3181 .11179 m
.28888 .12056 L
s
.24 .35 .67 r
.5581 .41853 m
.57275 .45142 L
s
.57275 .45142 m
.61633 .4435 L
s
.83 .24 .1 r
.2849 .48054 m
.3192 .49097 L
s
.3192 .49097 m
.34788 .49344 L
s
.215 .307 .618 r
.51644 .33961 m .53771 .335 L .53693 .36466 L p F P
0 0 0 r
s
.215 .307 .618 r
.53693 .36466 m .51645 .36893 L .51644 .33961 L p F P
0 0 0 r
s
.225 .323 .649 r
.51645 .36893 m .53693 .36466 L .5356 .39456 L p F P
0 0 0 r
s
.24 .35 .67 r
.58926 .23124 m
.63311 .22057 L
s
.58926 .23124 m
.58295 .2623 L
s
.83 .24 .1 r
.40757 .13388 m
.38031 .12731 L
s
.34702 .11052 m
.38031 .12731 L
s
1 .306 .126 r
.56833 .39608 m .55495 .39069 L .55765 .36034 L p F P
0 0 0 r
s
1 .306 .126 r
.55765 .36034 m .57194 .36636 L .56833 .39608 L p F P
0 0 0 r
s
.83 .24 .1 r
.37793 .48799 m
.41069 .49831 L
s
.41069 .49831 m
.44046 .48529 L
s
.978 .272 .11 r
.57466 .30845 m .55968 .30162 L .55895 .27515 L p F P
0 0 0 r
s
1 .286 .117 r
.55968 .30162 m .57466 .30845 L .57408 .33683 L p F P
0 0 0 r
s
.83 .24 .1 r
.49412 .43819 m
.52494 .44938 L
s
.24 .35 .67 r
.74588 .15334 m
.76094 .14194 L
s
.64305 .19494 m
.68766 .1838 L
s
.64305 .19494 m
.63311 .22057 L
s
.70054 .16486 m
.74588 .15334 L
s
.70054 .16486 m
.68766 .1838 L
s
.234 .339 .679 r
.5356 .39456 m .55495 .39069 L .55124 .4204 L p F P
0 0 0 r
s
.83 .24 .1 r
.52494 .44938 m
.54582 .41797 L
s
.54582 .41797 m
.54948 .41938 L
s
.24 .35 .67 r
.55285 .41953 m
.5581 .41853 L
s
.225 .323 .649 r
.55495 .39069 m .5356 .39456 L .53693 .36466 L p F P
0 0 0 r
s
1 .297 .122 r
.57194 .36636 m .55765 .36034 L .55925 .33032 L p F P
0 0 0 r
s
1 .297 .122 r
.55925 .33032 m .57408 .33683 L .57194 .36636 L p F P
0 0 0 r
s
.83 .24 .1 r
.57182 .33585 m
.57213 .33208 L
s
1 .286 .117 r
.57408 .33683 m .55925 .33032 L .55968 .30162 L p F P
0 0 0 r
s
.24 .35 .67 r
.56074 .3021 m
.58099 .29754 L
s
.204 .289 .584 r
.53792 .30652 m .55968 .30162 L .55925 .33032 L p F P
0 0 0 r
s
.24 .35 .67 r
.53792 .30724 m
.53846 .30711 L
s
.83 .24 .1 r
.54413 .29558 m
.55815 .30196 L
s
.204 .289 .584 r
.55925 .33032 m .53771 .335 L .53792 .30652 L p F P
0 0 0 r
s
.83 .24 .1 r
.48454 .18538 m
.46401 .16424 L
s
.43209 .14805 m
.46401 .16424 L
s
.18281 .41861 m
.20065 .44219 L
s
.24 .35 .67 r
.61633 .4435 m
.63363 .47183 L
s
.63363 .47183 m
.67819 .46413 L
s
.55448 .40668 m
.5581 .41853 L
s
.5581 .41853 m
.60172 .41016 L
s
.83 .24 .1 r
.53089 .22788 m
.5407 .25995 L
s
.50011 .21278 m
.53089 .22788 L
s
.51529 .40621 m
.54582 .41797 L
s
.54582 .41797 m
.55093 .40652 L
s
.215 .307 .618 r
.55765 .36034 m .53693 .36466 L .53771 .335 L p F P
0 0 0 r
s
.24 .35 .67 r
.53946 .33462 m
.53964 .33745 L
s
.225 .323 .649 r
.53693 .36466 m .55765 .36034 L .55495 .39069 L p F P
0 0 0 r
s
.83 .24 .1 r
.53116 .37057 m
.5547 .38021 L
s
.215 .307 .618 r
.53771 .335 m .55925 .33032 L .55765 .36034 L p F P
0 0 0 r
s
.83 .24 .1 r
.54092 .33308 m
.55674 .33992 L
s
.55674 .33992 m
.55758 .34029 L
s
.24 .35 .67 r
.56074 .34012 m
.58357 .33524 L
s
.55952 .34039 m
.56074 .34012 L
s
.83 .24 .1 r
.22312 .45955 m
.25873 .47041 L
s
.25873 .47041 m
.2849 .48054 L
s
.24 .35 .67 r
.55674 .38031 m
.5906 .37344 L
s
.67819 .46413 m
.69707 .48647 L
s
.69707 .48647 m
.74254 .47892 L
s
.82689 .49439 m
.80819 .48677 L
s
.74254 .47892 m
.76186 .49422 L
s
.76186 .49422 m
.80819 .48677 L
s
.83 .24 .1 r
.34702 .11052 m
.3181 .11179 L
s
.40796 .47466 m
.44046 .48529 L
s
.44046 .48529 m
.46874 .46496 L
s
.24 .35 .67 r
.58295 .2623 m
.62709 .25193 L
s
.58295 .2623 m
.58099 .29754 L
s
.83 .24 .1 r
.31374 .48295 m
.34788 .49344 L
s
.34788 .49344 m
.37793 .48799 L
s
.43209 .14805 m
.40757 .13388 L
s
.37442 .11704 m
.40757 .13388 L
s
.24 .35 .67 r
.60172 .41016 m
.61633 .4435 L
s
.61633 .4435 m
.66101 .43539 L
s
.83 .24 .1 r
.54413 .29558 m
.5407 .25995 L
s
.50986 .24531 m
.5407 .25995 L
s
.24 .35 .67 r
.63311 .22057 m
.67807 .20964 L
s
.63311 .22057 m
.62709 .25193 L
s
.83 .24 .1 r
.50011 .21278 m
.48454 .18538 L
s
.45267 .1694 m
.48454 .18538 L
s
.20065 .44219 m
.22312 .45955 L
s
.24 .35 .67 r
.58099 .29754 m
.62537 .28756 L
s
.58099 .29754 m
.58357 .33524 L
s
.68766 .1838 m
.73339 .17238 L
s
.68766 .1838 m
.67807 .20964 L
s
.83 .24 .1 r
.43653 .45391 m
.46874 .46496 L
s
.46874 .46496 m
.49412 .43819 L
s
.24 .35 .67 r
.73339 .17238 m
.74588 .15334 L
s
.66101 .43539 m
.67819 .46413 L
s
.67819 .46413 m
.72387 .45623 L
s
.5906 .37344 m
.60172 .41016 L
s
.60172 .41016 m
.64644 .40157 L
s
.83 .24 .1 r
.24938 .46974 m
.2849 .48054 L
s
.2849 .48054 m
.31374 .48295 L
s
.54413 .29558 m
.51318 .2815 L
s
.54092 .33308 m
.54413 .29558 L
s
.37442 .11704 m
.34702 .11052 L
s
.344 .47731 m
.37793 .48799 L
s
.37793 .48799 m
.40796 .47466 L
s
.24 .35 .67 r
.58357 .33524 m
.62814 .32569 L
s
.58357 .33524 m
.5906 .37344 L
s
.5906 .37344 m
.63528 .36437 L
s
.72387 .45623 m
.74254 .47892 L
s
.74254 .47892 m
.78916 .47119 L
s
.83 .24 .1 r
.46221 .4266 m
.49412 .43819 L
s
.49412 .43819 m
.51529 .40621 L
s
.24 .35 .67 r
.80819 .48677 m
.78916 .47119 L
s
.83 .24 .1 r
.45267 .1694 m
.43209 .14805 L
s
.39903 .13128 m
.43209 .14805 L
s
.53116 .37057 m
.54092 .33308 L
s
.5098 .3196 m
.54092 .33308 L
s
.24 .35 .67 r
.62709 .25193 m
.67235 .2413 L
s
.62709 .25193 m
.62537 .28756 L
s
.83 .24 .1 r
.50986 .24531 m
.50011 .21278 L
s
.46824 .19716 m
.50011 .21278 L
s
.48367 .39402 m
.51529 .40621 L
s
.51529 .40621 m
.53116 .37057 L
s
.4998 .35775 m
.53116 .37057 L
s
.22312 .45955 m
.24938 .46974 L
s
.24 .35 .67 r
.64644 .40157 m
.66101 .43539 L
s
.66101 .43539 m
.70683 .42706 L
s
.67807 .20964 m
.72417 .19842 L
s
.67807 .20964 m
.67235 .2413 L
s
.83 .24 .1 r
.3743 .46365 m
.40796 .47466 L
s
.40796 .47466 m
.43653 .45391 L
s
.27837 .47209 m
.31374 .48295 L
s
.31374 .48295 m
.344 .47731 L
s
.24 .35 .67 r
.62537 .28756 m
.67089 .27732 L
s
.62537 .28756 m
.62814 .32569 L
s
.72417 .19842 m
.73339 .17238 L
s
.83 .24 .1 r
.39903 .13128 m
.37442 .11704 L
s
.24 .35 .67 r
.70683 .42706 m
.72387 .45623 L
s
.72387 .45623 m
.77073 .44812 L
s
.63528 .36437 m
.64644 .40157 L
s
.64644 .40157 m
.69231 .39277 L
s
.83 .24 .1 r
.51318 .2815 m
.50986 .24531 L
s
.47792 .23015 m
.50986 .24531 L
s
.46824 .19716 m
.45267 .1694 L
s
.41965 .15285 m
.45267 .1694 L
s
.24 .35 .67 r
.62814 .32569 m
.67385 .3159 L
s
.62814 .32569 m
.63528 .36437 L
s
.63528 .36437 m
.68111 .35507 L
s
.78916 .47119 m
.77073 .44812 L
s
.83 .24 .1 r
.40316 .44245 m
.43653 .45391 L
s
.43653 .45391 m
.46221 .4266 L
s
.24 .35 .67 r
.67235 .2413 m
.71878 .23039 L
s
.67235 .2413 m
.67089 .27732 L
s
.83 .24 .1 r
.24938 .46974 m
.27837 .47209 L
s
.51318 .2815 m
.48111 .2669 L
s
.5098 .3196 m
.51318 .2815 L
s
.30885 .46624 m
.344 .47731 L
s
.344 .47731 m
.3743 .46365 L
s
.24 .35 .67 r
.69231 .39277 m
.70683 .42706 L
s
.70683 .42706 m
.75382 .41852 L
s
.83 .24 .1 r
.42914 .4146 m
.46221 .4266 L
s
.46221 .4266 m
.48367 .39402 L
s
.24 .35 .67 r
.71878 .23039 m
.72417 .19842 L
s
.83 .24 .1 r
.41965 .15285 m
.39903 .13128 L
s
.4998 .35775 m
.5098 .3196 L
s
.47754 .30564 m
.5098 .3196 L
s
.47792 .23015 m
.46824 .19716 L
s
.4352 .18096 m
.46824 .19716 L
s
.4509 .38139 m
.48367 .39402 L
s
.48367 .39402 m
.4998 .35775 L
s
.24 .35 .67 r
.67089 .27732 m
.71759 .26681 L
s
.67089 .27732 m
.67385 .3159 L
s
.83 .24 .1 r
.46731 .34445 m
.4998 .35775 L
s
.24 .35 .67 r
.77073 .44812 m
.75382 .41852 L
s
.68111 .35507 m
.69231 .39277 L
s
.69231 .39277 m
.73936 .38374 L
s
.67385 .3159 m
.72075 .30586 L
s
.67385 .3159 m
.68111 .35507 L
s
.83 .24 .1 r
.3394 .45224 m
.3743 .46365 L
s
.3743 .46365 m
.40316 .44245 L
s
.24 .35 .67 r
.68111 .35507 m
.72813 .34553 L
s
.83 .24 .1 r
.27837 .47209 m
.30885 .46624 L
s
.24 .35 .67 r
.71759 .26681 m
.71878 .23039 L
s
.83 .24 .1 r
.48111 .2669 m
.47792 .23015 L
s
.44481 .21444 m
.47792 .23015 L
s
.4352 .18096 m
.41965 .15285 L
s
.24 .35 .67 r
.75382 .41852 m
.73936 .38374 L
s
.83 .24 .1 r
.36856 .43057 m
.40316 .44245 L
s
.40316 .44245 m
.42914 .4146 L
s
.48111 .2669 m
.44786 .25176 L
s
.47754 .30564 m
.48111 .2669 L
s
.24 .35 .67 r
.72075 .30586 m
.71759 .26681 L
s
.83 .24 .1 r
.30885 .46624 m
.3394 .45224 L
s
.24 .35 .67 r
.73936 .38374 m
.72813 .34553 L
s
.83 .24 .1 r
.39485 .40215 m
.42914 .4146 L
s
.42914 .4146 m
.4509 .38139 L
s
.24 .35 .67 r
.72813 .34553 m
.72075 .30586 L
s
.83 .24 .1 r
.46731 .34445 m
.47754 .30564 L
s
.4441 .29116 m
.47754 .30564 L
s
.44481 .21444 m
.4352 .18096 L
s
.41692 .36829 m
.4509 .38139 L
s
.4509 .38139 m
.46731 .34445 L
s
.43361 .33067 m
.46731 .34445 L
s
.3394 .45224 m
.36856 .43057 L
s
.44786 .25176 m
.44481 .21444 L
s
.36856 .43057 m
.39485 .40215 L
s
.4441 .29116 m
.44786 .25176 L
s
.39485 .40215 m
.41692 .36829 L
s
.43361 .33067 m
.4441 .29116 L
s
.41692 .36829 m
.43361 .33067 L
s
0 0 0 r
.25 Mabswid
.61484 0 m
.98028 .2379 L
s
.98028 .2379 m
1 .56705 L
s
1 .56705 m
.62024 .41303 L
s
.62024 .41303 m
.61484 0 L
s
.02248 .1816 m
0 .53093 L
s
0 .53093 m
.62024 .41303 L
s
.62024 .41303 m
.61484 0 L
s
.61484 0 m
.02248 .1816 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{500, 320.125},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40007d0001@2000`400?l00000o`00003oo`3ooolb
0?ooo`800000`@3oool00?l0ooK^;`3om^h3000000040?ofkP000000000000000;h0ooK^0@3oool0
0?l0ooK^:`3om^h4000000@0ooK^00@000000?ofkP3om^h00000_@3om^h10?ooo`00o`3om^hX0?of
kP<00000203om^h010000000ooK^0?ofkP3om^h200000;/0ooK^0@3oool00?l0ooK^9@3om^h30000
00/0ooK^00<000000?ofkP3om^h00`3om^h00`000000ooK^0?ofkP2h0?ofkP40oooo003o0?ofkR80
ooK^0`00000>0?ofkP030000003om^h0ooK^00@0ooK^0P00002h0?ofkP40oooo003o0?ofkQh0ooK^
1000000A0?ofkP030000003om^h0ooK^00H0ooK^00<000000?ofkP3om^h0]@3om^h10?ooo`00o`3o
m^hK0?ofkP<000005@3om^h00`000000ooK^0?ofkP070?ofkP800000]@3om^h10?ooo`00o`3om^hH
0?ofkP<00000603om^h00`000000ooK^0?ofkP090?ofkP030000003om^h0ooK^0;80ooK^0@3oool0
0?l0ooK^5@3om^h3000001/0ooK^00<000000?ofkP3om^h02P3om^h200000;80ooK^0@3oool00?l0
ooK^4@3om^h4000001h0ooK^00<000000?ofkP3om^h0303om^h200000;00ooK^0@3oool00?l0ooK^
3P3om^h300000280ooK^00<000000?ofkP3om^h03P3om^h00`000000ooK^0?ofkP2]0?ofkP40oooo
003o0?ofkP/0ooK^0`00000U0?ofkP030000003om^h0ooK^00l0ooK^0P00002]0?ofkP40oooo003o
0?ofkPP0ooK^0`00000X0?ofkP030000003om^h0ooK^0140ooK^00<000000?ofkP3om^h0ZP3om^h1
0?ooo`00o`3om^h40?ofkP@00000:`3om^h00`000000ooK^0?ofkP0B0?ofkP800000ZP3om^h10?oo
o`00o`3om^h10?ofkP<00000;`3om^h00`000000ooK^0?ofkP0D0?ofkP030000003om^h0ooK^0:L0
ooK^0@3oool00?d0ooK^0`00000b0?ofkP030000003om^h0ooK^01D0ooK^0P00002W0?ofkP40oooo
003j0?ofkP<00000=@3om^h00`000000ooK^0?ofkP0G0?ofkP030000003om^h0ooK^0:@0ooK^0@3o
ool00?L0ooK^0`00000h0?ofkP030000003om^h0ooK^01P0ooK^0P00002T0?ofkP40oooo003c0?of
kP@00000>`3om^h00`000000ooK^0?ofkP0J0?ofkP030000003om^h0ooK^0:40ooK^0@3oool00?00
ooK^0`00000o0?ofkP030000003om^h0ooK^01/0ooK^0P00002Q0?ofkP40oooo003]0?ofkP<00000
@P3om^h00`000000ooK^0?ofkP0M0?ofkP030000003om^h0ooK^09h0ooK^0@3oool00>X0ooK^0`00
00150?ofkP030000003om^h0ooK^01h0ooK^0P00002N0?ofkP40oooo003V0?ofkP@00000B03om^h0
0`000000ooK^0?ofkP0P0?ofkP030000003om^h0ooK^09/0ooK^0@3oool00><0ooK^0`00001<0?of
kP030000003om^h0ooK^0240ooK^0P00002K0?ofkP40oooo003P0?ofkP<00000C`3om^h00`000000
ooK^0?ofkP0S0?ofkP030000003om^h0ooK^09P0ooK^0@3oool00=d0ooK^0`00001B0?ofkP030000
003om^h0ooK^02@0ooK^0P00002H0?ofkP40oooo003I0?ofkP@00000E@3om^h00`000000ooK^0?of
kP0V0?ofkP800000UP3om^h10?ooo`00eP3om^h3000005T0ooK^00<000000?ofkP3om^h0:03om^h0
0`000000ooK^0?ofkP2C0?ofkP40oooo003C0?ofkP<00000G03om^h00`000000ooK^0?ofkP0Y0?of
kP800000T`3om^h10?ooo`00d03om^h3000005l0ooK^00<000000?ofkP3om^h0:`3om^h00`000000
ooK^0?ofkP2@0?ofkP40oooo003<0?ofkP@00000HP3om^h00`000000ooK^0?ofkP0/0?ofkP800000
T03om^h10?ooo`00b@3om^h3000006H0ooK^00<000000?ofkP3om^h0;P3om^h00`000000ooK^0?of
kP2=0?ofkP40oooo00360?ofkP<00000J@3om^h00`000000ooK^0?ofkP0_0?ofkP800000S@3om^h1
0?ooo`00``3om^h3000006`0ooK^00<000000?ofkP3om^h0<@3om^h00`000000ooK^0?ofkP2:0?of
kP40oooo002o0?ofkP@00000L03om^h00`000000ooK^0?ofkP0a0?ofkP800000RP3om^h10?ooo`00
_03om^h3000007@0ooK^00<000000?ofkP3om^h0<`3om^h00`000000ooK^0?ofkP270?ofkP40oooo
002i0?ofkP<00000M`3om^h00`000000ooK^0?ofkP0d0?ofkP800000Q`3om^h10?ooo`00]P3om^h3
000007X0ooK^00<000000?ofkP3om^h0=P3om^h00`000000ooK^0?ofkP240?ofkP40oooo002b0?of
kP@00000O@3om^h00`000000ooK^0?ofkP0g0?ofkP800000Q03om^h10?ooo`00[`3om^h300000840
ooK^00<000000?ofkP3om^h0>@3om^h00`000000ooK^0?ofkP210?ofkP40oooo002/0?ofkP<00000
Q03om^h00`000000ooK^0?ofkP0j0?ofkP800000P@3om^h10?ooo`00Z@3om^h3000008L0ooK^00<0
00000?ofkP3om^h0?03om^h00`000000ooK^0?ofkP1n0?ofkP40oooo002U0?ofkP@00000RP3om^h0
0`000000ooK^0?ofkP0m0?ofkP800000OP3om^h10?ooo`00XP3om^h3000008h0ooK^00<000000?of
kP3om^h0?`3om^h2000007`0ooK^0@3oool009l0ooK^0`00002A0?ofkP030000003om^h0ooK^0440
ooK^00<000000?ofkP3om^h0N@3om^h10?ooo`00W03om^h3000009@0ooK^00<000000?ofkP3om^h0
@P3om^h2000007T0ooK^0@3oool009T0ooK^0`00002G0?ofkP030000003om^h0ooK^04@0ooK^00<0
00000?ofkP3om^h0MP3om^h10?ooo`00U@3om^h4000009X0ooK^00<000000?ofkP3om^h0A@3om^h2
000007H0ooK^0@3oool00980ooK^0`00002N0?ofkP030000003om^h0ooK^04L0ooK^00<000000?of
kP3om^h0L`3om^h10?ooo`00S`3om^h300000:40ooK^00<000000?ofkP3om^h0B03om^h2000007<0
ooK^0@3oool008`0ooK^0`00002T0?ofkP030000003om^h0ooK^04X0ooK^00<000000?ofkP3om^h0
L03om^h10?ooo`00R03om^h400000:L0ooK^00<000000?ofkP3om^h0B`3om^h200000700ooK^0@3o
ool008D0ooK^0`00002[0?ofkP030000003om^h0ooK^04d0ooK^00<000000?ofkP3om^h0K@3om^h1
0?ooo`00PP3om^h300000:h0ooK^00<000000?ofkP3om^h0CP3om^h2000006d0ooK^0@3oool007l0
ooK^0`00000T0?ofkPT0e3dIQ03om^h00`000000ooK^0?ofkP1@0?ofkP030000003om^h0ooK^06X0
ooK^0@3oool007/0ooK^1000000N0?ofkPT0e3dI203om^h40=@m6H40ooK^00<000000?ofkP3om^h0
D@3om^h2000006X0ooK^0@3oool007P0ooK^0`00000N0?ofkP@0e3dI0`3om^h20=@m6@h0ooK^1P3D
?AUm0?ofkP030000003om^h0ooK^05<0ooK^00<000000?ofkP3om^h0I`3om^h10?ooo`00M@3om^h3
000001h0ooK^0`3D?AT90?ofkP80e3dI3P3om^h20=@m6@80ooK^0`3D?AUj0?ofkP030000003om^h0
ooK^05@0ooK^0P00001W0?ofkP40oooo001b0?ofkP<000007@3om^h40=@m6@h0ooK^0P3D?AT>0?of
kP030=@m6@3om^h0ooK^0080ooK^0`3D?AUg0?ofkP030000003om^h0ooK^05H0ooK^00<000000?of
kP3om^h0I03om^h10?ooo`00KP3om^h4000001h0ooK^0P3D?ATD0?ofkP80e3dI3@3om^h20=@m6@@0
ooK^0`3D?AUe0?ofkP030000003om^h0ooK^05L0ooK^0P00001T0?ofkP40oooo001[0?ofkP<00000
803om^h20=@m6@030?ofkP3D?AT0e3dI01D0ooK^0P3D?AT=0?ofkP80e3dI103om^h30=@m6G<0ooK^
00<000000?ofkP3om^h0F@3om^h200000680ooK^0@3oool006P0ooK^0`00000Q0?ofkP80e3dI1@3o
m^h20=@m6AD0ooK^0P3D?AT=0?ofkP80e3dI103om^h30=@m6G40ooK^00<000000?ofkP3om^h0F`3o
m^h00`000000ooK^0?ofkP1O0?ofkP40oooo001U0?ofkP<000008P3om^h20=@m6@T0ooK^0P3D?ATE
0?ofkP80e3dI3@3om^h20=@m6@@0ooK^0`3D?AU_0?ofkP030000003om^h0ooK^05`0ooK^0P00001O
0?ofkP40oooo001Q0?ofkP@00000903om^h00`3D?AT0ooK^0?ofkP0;0?ofkP80e3dI5@3om^hB0=@m
6@<0ooK^0`3D?AU]0?ofkP030000003om^h0ooK^05h0ooK^00<000000?ofkP3om^h0G03om^h10?oo
o`00GP3om^h3000002H0ooK^0P3D?AT@0?ofkP80e3dI403om^h30=@m6@80ooK^0P3D?AT<0?ofkPH0
e3dI00@0ooK^0=@m6@3D?AT0e3dIJ`3om^h00`000000ooK^0?ofkP1O0?ofkP800000G03om^h10?oo
o`00F`3om^h3000002L0ooK^0P3D?ATD0?ofkP80e3dI303om^h20=@m6@L0ooK^0P3D?AT<0?ofkP80
e3dI0P3om^h60=@m6FT0ooK^00<000000?ofkP3om^h0H@3om^h00`000000ooK^0?ofkP1I0?ofkP40
oooo001H0?ofkP<00000:03om^h20=@m6AP0ooK^0P3D?AT70?ofkP<0e3dI2`3om^h20=@m6@`0ooK^
0P3D?AT40?ofkP@0e3dII`3om^h00`000000ooK^0?ofkP1R0?ofkP800000F@3om^h10?ooo`00E03o
m^h4000002X0ooK^0P3D?ATK0?ofkP80e3dI0P3om^h30=@m6A00ooK^0P3D?AT<0?ofkP80e3dI0`3o
m^h50=@m6FD0ooK^00<000000?ofkP3om^h0I03om^h00`000000ooK^0?ofkP1F0?ofkP40oooo001A
0?ofkP<00000;@3om^h00`3D?AT0ooK^0?ofkP020=@m6A/0ooK^0P3D?ATE0?ofkP80e3dI303om^h2
0=@m6@80ooK^00<0e3dI0?ofkP3D?AT00`3D?AUS0?ofkP030000003om^h0ooK^04`0ooK^100mFJ/E
0?ofkP800000EP3om^h10?ooo`00CP3om^h3000002l0ooK^00<0e3dI0?ofkP3om^h00`3om^h20=@m
6AL0ooK^0P3D?AT20?ofkP80e3dI5@3om^h20=@m6@`0ooK^0P3D?AT0103om^h0e3dI0?ofkP3om^h4
0=@m6F40ooK^00<000000?ofkP3om^h0B03om^h403eIZ`@0ooK^100mFJ/C0?ofkP030000003om^h0
ooK^05<0ooK^0@3oool004/0ooK^0`00000`0?ofkP80e3dI203om^h20=@m6A<0ooK^0P3D?AT60?of
kP80e3dI5@3om^h20=@m6@`0ooK^0`3D?AT30?ofkP@0e3dIG`3om^h00`000000ooK^0?ofkP140?of
kP@0?EV[303om^h303eIZa40ooK^0P00001C0?ofkP40oooo00170?ofkP@00000<P3om^h00`3D?AT0
ooK^0?ofkP0:0?ofkP80e3dI3`3om^h20=@m6@X0ooK^0P3D?ATE0?ofkQ80e3dI0P3om^h40=@m6Ed0
ooK^00<000000?ofkP3om^h0@03om^h503eIZ``0ooK^100mFJ/20?ofkP80?EV[4@3om^h00`000000
ooK^0?ofkP1@0?ofkP40oooo00140?ofkP<00000=@3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP80e3dI
2`3om^h20=@m6@h0ooK^0`3D?AT>0?ofkP@0e3dI0P3om^h20=@m6@/0ooK^2`3D?AUK0?ofkP030000
003om^h0ooK^03`0ooK^1@0mFJ/20?ofkP0303eIZ`3om^h0ooK^00L0ooK^100mFJ/80?ofkP0303eI
Z`3om^h0ooK^00l0ooK^0P00001@0?ofkP40oooo00110?ofkP<00000=`3om^h00`3D?AT0ooK^0?of
kP0@0?ofkP80e3dI1`3om^h20=@m6A<0ooK^0P3D?AT90?ofkP<0e3dI203om^h20=@m6@X0ooK^00@0
e3dI0?ofkP3D?AT0e3dI0P3om^h60=@m6ET0ooK^00<000000?ofkP3om^h0>@3om^h403eIZ`@0ooK^
0P0mFJ/70?ofkP<0?EV[3@3om^h203eIZa40ooK^00<000000?ofkP3om^h0C@3om^h10?ooo`00?P3o
m^h3000003T0ooK^00<0e3dI0?ofkP3om^h04`3om^h20=@m6@<0ooK^0P3D?ATG0?ofkP80e3dI0`3o
m^h40=@m6@d0ooK^0P3D?AT90?ofkP030=@m6@3om^h0ooK^0080e3dI103om^h40=@m6EL0ooK^00<0
00000?ofkP3om^h0=@3om^h503eIZ`H0ooK^00<0?EV[0?ofkP3om^h00`3om^h403eIZa80ooK^00<0
?EV[0?ofkP3om^h03`3om^h2000004d0ooK^0@3oool003/0ooK^0`00000j0?ofkP80e3dI603om^h3
0=@m6A/0ooK^0`3D?ATC0?ofkP80e3dI203om^h0103D?AT0ooK^0?ofkP3om^h20=@m6@<0ooK^1@3D
?AUE0?ofkP030000003om^h0ooK^0340ooK^1@0mFJ/40?ofkP@0?EV[00@0ooK^03eIZ`3om^h0ooK^
100mFJ/G0?ofkP80?EV[4@3om^h00`000000ooK^0?ofkP1:0?ofkP40oooo000g0?ofkP@00000?03o
m^h00`3D?AT0ooK^0?ofkP0H0?ofkP040=@m6@3om^h0e3dI0=@m6AT0ooK^0P3D?AT00`3om^h0e3dI
0=@m6@0D0?ofkP80e3dI1`3om^h00`3D?AT0ooK^0?ofkP020?ofkP80e3dI0P3om^h00`3D?AT0ooK^
0=@m6@030=@m6E<0ooK^00<000000?ofkP3om^h0;@3om^h503eIZ`/0ooK^1@0mFJ/L0?ofkP80?EV[
4@3om^h2000004X0ooK^0@3oool003@0ooK^0`00000o0?ofkP030=@m6@3om^h0ooK^01P0ooK^00<0
e3dI0?ofkP3om^h00P3om^h20=@m6AD0ooK^0P3D?AT50?ofkP80e3dI503om^h20=@m6@H0ooK^0P3D
?AT40?ofkP80e3dI00@0ooK^0=@m6@3om^h0ooK^103D?AUA0?ofkP030000003om^h0ooK^02T0ooK^
1P0mFJ/:0?ofkPD0?EV[0`3om^h203eIZaL0ooK^100mFJ/20?ofkP0303eIZ`3om^h0ooK^0100ooK^
0P0000180?ofkP40oooo000a0?ofkP<00000@@3om^h20=@m6AP0ooK^0P3D?AT70?ofkP80e3dI4@3o
m^h20=@m6@T0ooK^0P3D?ATD0?ofkP80e3dI103om^h0103D?AT0ooK^0=@m6@3D?AT40?ofkP<0e3dI
0`3om^h40=@m6Dl0ooK^00<000000?ofkP3om^h09@3om^h603eIZ`030?ofkP0mFJ/0?EV[00L0ooK^
1@0mFJ/20?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h0403om^h403eIZ`L0ooK^
00<0?EV[0?ofkP3om^h04@3om^h00`000000ooK^0?ofkP150?ofkP40oooo000^0?ofkP<00000@`3o
m^h00`3D?AT0ooK^0?ofkP020=@m6AD0ooK^00<0e3dI0?ofkP3om^h02@3om^h20=@m6@h0ooK^00<0
e3dI0?ofkP3om^h02`3om^h20=@m6A@0ooK^4P3D?AT20?ofkP@0e3dIC@3om^h00`000000ooK^0?of
kP0P0?ofkPP0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP030?ofkPD0?EV[1P3om^h00`0mFJ/0ooK^0?of
kP050?ofkP80?EV[3@3om^h303eIZ``0ooK^00<0?EV[0?ofkP3om^h04@3om^h2000004D0ooK^0@3o
ool002X0ooK^100000150?ofkP030=@m6@3om^h0ooK^00<0ooK^0P3D?ATB0?ofkP030=@m6@3om^h0
ooK^00`0ooK^0P3D?AT:0?ofkP80e3dI403om^h20=@m6@h0ooK^103D?AT20?ofkP80e3dI00<0ooK^
0=@m6@3om^h00`3om^h20=@m6@<0ooK^00<0e3dI0?ofkP3D?AT0203D?AU;0?ofkP030000003om^h0
ooK^01`0ooK^2`0mFJ/30?ofkP0303eIZ`3om^h0ooK^00D0?EV[2@3om^h00`0mFJ/0ooK^0?ofkP08
0?ofkP0303eIZ`3om^h0ooK^00H0ooK^100mFJ/@0?ofkP0303eIZ`3om^h0ooK^0180ooK^00<00000
0?ofkP3om^h0@P3om^h10?ooo`009`3om^h3000004P0ooK^00<0e3dI0?ofkP3om^h01P3om^h20=@m
6@l0ooK^00<0e3dI0?ofkP3om^h03`3om^h20=@m6@H0ooK^0P3D?ATD0?ofkP80e3dI203om^h40=@m
6@P0ooK^0`3D?AT50?ofkP80e3dI0P3om^h00`3D?AT0ooK^0?ofkP020=@m6@030?ofkP3D?AT0e3dI
00@0e3dIB@3om^h00`000000ooK^0?ofkP0H0?ofkPP0?EV[1`3om^h703eIZ``0ooK^00<0?EV[0?of
kP3om^h02P3om^h203eIZ`80ooK^100mFJ/E0?ofkP0303eIZ`3om^h0ooK^0180ooK^0P0000120?of
kP40oooo000T0?ofkP<00000B`3om^h00`3D?AT0ooK^0?ofkP080?ofkP80e3dI303om^h00`3D?AT0
ooK^0?ofkP0B0?ofkP80e3dI0P3om^h20=@m6AP0ooK^0P3D?AT20?ofkP@0e3dI3P3om^h20=@m6@H0
ooK^0P3D?AT00`3om^h0e3dI0?ofkP020?ofkP80e3dI0`3om^h30=@m6DP0ooK^00<000000?ofkP3o
m^h0503om^h803eIZ`T0ooK^1@0mFJ/20?ofkP80?EV[2`3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP@0
?EV[6P3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP030000003om^h0ooK^03l0ooK^0@3oool00240ooK^
0`00001=0?ofkP030=@m6@3om^h0ooK^00/0ooK^0P3D?AT80?ofkP80e3dI5`3om^h30=@m6A/0ooK^
0P3D?ATC0?ofkP<0e3dI1P3om^h30=@m6@@0ooK^0P3D?AT20?ofkP@0e3dIAP3om^h00`000000ooK^
0?ofkP0@0?ofkPP0?EV[2@3om^h603eIZ`L0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^
0?ofkP070?ofkP@0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP0I0?ofkP0303eIZ`3om^h0ooK^01<0ooK^
0P00000o0?ofkP40oooo000M0?ofkP@00000C`3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP80e3dI1@3o
m^h00`3D?AT0ooK^0?ofkP0G0?ofkP030=@m6@3om^h0ooK^0080e3dI5`3om^h20=@m6@80ooK^0P3D
?ATB0?ofkP040=@m6@3om^h0e3dI0=@m6@H0ooK^0P3D?AT50?ofkP80e3dI00<0ooK^0=@m6@3om^h0
0`3D?AU40?ofkP030000003om^h0ooK^00d0ooK^1P0mFJ/20?ofkP0303eIZ`3om^h0ooK^00D0ooK^
1P0mFJ/30?ofkP0303eIZ`3om^h0ooK^00H0ooK^0P0mFJ/70?ofkP0303eIZ`3om^h0ooK^00@0ooK^
100mFJ/80?ofkP0303eIZ`3om^h0ooK^01T0ooK^00<0?EV[0?ofkP3om^h0503om^h00`000000ooK^
0?ofkP0l0?ofkP40oooo000J0?ofkP<00000DP3om^h00`3D?AT0ooK^0?ofkP0A0?ofkP80e3dI0P3o
m^h00`3D?AT0ooK^0?ofkP0F0?ofkP80e3dI1@3om^h20=@m6A<0ooK^0P3D?AT60?ofkP80e3dI403o
m^h0103D?AT0ooK^0?ofkP3om^h20=@m6@H0ooK^0P3D?AT50?ofkP<0e3dI0P3om^h30=@m6D80ooK^
00<000000?ofkP3om^h02@3om^h603eIZ`D0ooK^00@0?EV[0?ofkP3om^h0ooK^1`0mFJ/60?ofkP03
03eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h00P3om^h203eIZ`<0ooK^100mFJ/=0?ofkP03
03eIZ`3om^h0ooK^01L0ooK^0`0mFJ/F0?ofkP800000?03om^h10?ooo`005`3om^h3000005@0ooK^
00<0e3dI0?ofkP3om^h0503om^h30=@m6AL0ooK^00<0e3dI0?ofkP3om^h01`3om^h20=@m6@l0ooK^
0P3D?AT:0?ofkP80e3dI3`3om^h00`3D?AT0ooK^0?ofkP020?ofkP80e3dI103om^h00`3D?AT0ooK^
0=@m6@090=@m6@80ooK^0`3D?AU00?ofkP030000003om^h0ooK^00D0ooK^1P0mFJ/40?ofkPd0?EV[
203om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP@0?EV[00<0ooK^03eIZ`0mFJ/00P0mFJ/B0?ofkP80?EV[
4`3om^h403eIZ`<0ooK^00<0?EV[0?ofkP3om^h05@3om^h00`000000ooK^0?ofkP0i0?ofkP40oooo
000D0?ofkP<00000EP3om^h00`3D?AT0ooK^0?ofkP0E0?ofkP030=@m6@3om^h0ooK^0080e3dI503o
m^h00`3D?AT0ooK^0?ofkP0:0?ofkP<0e3dI2P3om^h20=@m6@h0ooK^0`3D?AT<0?ofkP030=@m6@3o
m^h0ooK^0080ooK^303D?AT40?ofkPD0e3dI00@0ooK^0=@m6@3D?AT0e3dI?P3om^h00`000000ooK^
0?ofkP020?ofkPD0?EV[2@3om^h803eIZ``0ooK^00<0?EV[0?ofkP3om^h01`3om^h903eIZaP0ooK^
00<0?EV[0?ofkP3om^h0303om^h403eIZ`L0ooK^00<0?EV[0?ofkP3om^h05P3om^h2000003T0ooK^
0@3oool00100ooK^1000001H0?ofkP030=@m6@3om^h0ooK^01D0ooK^00<0e3dI0?ofkP3om^h00`3o
m^h20=@m6A00ooK^0P3D?AT@0?ofkP80e3dI1P3om^h20=@m6A<0ooK^0P3D?AT;0?ofkP@0e3dI0`3o
m^h20=@m6@80ooK^00<0e3dI0?ofkP3om^h00P3om^h20=@m6@<0ooK^00<0e3dI0?ofkP3D?AT01`3D
?ATl0?ofkP030000000mFJ/0?EV[00<0?EV[2@3om^h803eIZ`<0ooK^0P0mFJ/:0?ofkP0303eIZ`3o
m^h0ooK^00D0ooK^1`0mFJ/30?ofkP80?EV[6@3om^h00`0mFJ/0ooK^0?ofkP060?ofkPD0?EV[303o
m^h00`0mFJ/0ooK^0?ofkP0G0?ofkP030000003om^h0ooK^03H0ooK^0@3oool000d0ooK^0`00001L
0?ofkP030=@m6@3om^h0ooK^01@0ooK^00<0e3dI0?ofkP3om^h01P3om^h20=@m6@d0ooK^00<0e3dI
0?ofkP3om^h04P3om^h20=@m6@80ooK^0P3D?ATG0?ofkP80e3dI103om^h60=@m6@P0ooK^0P3D?AT0
0`3om^h0e3dI0?ofkP040?ofkP80e3dI0P3om^h00`3D?AT0ooK^0?ofkP020=@m6@80ooK^103D?ATg
0?ofkP<0?EV[00<0000003eIZ`3om^h00P0mFJ/60?ofkPT0?EV[203om^h203eIZ`L0ooK^00<0?EV[
0?ofkP3om^h00P3om^h703eIZ`P0ooK^00<0?EV[0?ofkP3om^h0603om^h0100mFJ/0ooK^0?ofkP3o
m^h403eIZa80ooK^00<0?EV[0?ofkP3om^h05`3om^h2000003H0ooK^0@3oool000/0ooK^0P00001N
0?ofkP030=@m6@3om^h0ooK^01@0ooK^00<0e3dI0?ofkP3om^h02@3om^h30=@m6@T0ooK^00<0e3dI
0?ofkP3om^h05@3om^h20=@m6A/0ooK^103D?AT60?ofkP030=@m6@3om^h0ooK^00L0ooK^0P3D?AT7
0?ofkP80e3dI00<0ooK^0=@m6@3om^h00P3om^h0103D?AT0ooK^0?ofkP3om^h40=@m6C40ooK^1@0m
FJ/20?ofkP030000003om^h0?EV[00D0ooK^1`0mFJ/30?ofkP0303eIZ`3om^h0ooK^00T0ooK^0P0m
FJ/50?ofkPP0?EV[2`3om^h00`0mFJ/0ooK^03eIZ`0I0?ofkP@0?EV[5P3om^h00`0mFJ/0ooK^0?of
kP0I0?ofkP030000003om^h0ooK^03<0ooK^0@3oool000/0ooK^00@000000?ofkP0000000000F`3o
m^h00`3D?AT0ooK^0?ofkP0D0?ofkP030=@m6@3om^h0ooK^00d0ooK^0P3D?AT50?ofkP80e3dI603o
m^h0103D?AT0ooK^0=@m6@3D?ATH0?ofkP80e3dI00<0ooK^0=@m6@3D?AT01P3om^h30=@m6@T0ooK^
0P3D?AT70?ofkP<0e3dI0`3om^h20=@m6@80ooK^1@3D?AT[0?ofkP@0?EV[1@3om^h203eIZ`040000
000mFJ/0ooK^0?ofkPL0?EV[1P3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP80?EV[00<0ooK^03eIZ`0m
FJ/0100mFJ/?0?ofkP0403eIZ`3om^h0ooK^03eIZa@0ooK^100mFJ/20?ofkP0303eIZ`3om^h0ooK^
01H0ooK^00<0?EV[0?ofkP3om^h06@3om^h2000003<0ooK^0@3oool000/0ooK^00@000000?ofkP3o
m^h0ooK^0`00001G0?ofkP80e3dI5@3om^h00`3D?AT0ooK^0?ofkP0@0?ofkP80e3dI0P3om^h00`3D
?AT0ooK^0?ofkP0G0?ofkP030=@m6@3om^h0ooK^0080ooK^0P3D?ATD0?ofkP80e3dI1@3om^h20=@m
6@@0ooK^00<0e3dI0?ofkP3om^h00P3D?AT80?ofkP<0e3dI1`3om^h30=@m6@<0ooK^0P3D?AT00`3o
m^h0e3dI0?ofkP040=@m6B@0ooK^1@0mFJ/:0?ofkP0303eIZ`000000?EV[00D0?EV[2@3om^h00`0m
FJ/0ooK^0?ofkP0<0?ofkPH0?EV[4`3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[0100ooK^0`0mFJ/6
0?ofkP0303eIZ`3om^h0ooK^01L0ooK^00<0?EV[0?ofkP3om^h06P3om^h00`000000ooK^0?ofkP0`
0?ofkP40oooo000;0?ofkP030000003om^h0ooK^00@0ooK^0P00001D0?ofkP030=@m6@3om^h0ooK^
0080e3dI4`3om^h00`3D?AT0ooK^0?ofkP0B0?ofkP80e3dI603om^h20=@m6@L0ooK^0P3D?AT@0?of
kP80e3dI2@3om^h20=@m6@<0ooK^00@0e3dI0?ofkP3om^h0ooK^0P3D?AT60?ofkP030=@m6@3om^h0
ooK^0080e3dI1`3om^h30=@m6@<0ooK^0`3D?AT20?ofkP@0e3dI7P3om^h603eIZ`X0ooK^100mFJ/0
0`000000?EV[03eIZ`020?ofkP80?EV[2@3om^h00`0mFJ/0ooK^0?ofkP080?ofkPH0?EV[0P3om^h0
0`0mFJ/0ooK^0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h02@3om^h4
03eIZ`X0ooK^00<0?EV[0?ofkP3om^h05P3om^h00`0mFJ/0ooK^0?ofkP0K0?ofkP800000<03om^h1
0?ooo`002`3om^h00`000000ooK^0?ofkP060?ofkP<00000D@3om^h00`3D?AT0ooK^0?ofkP020?of
kP<0e3dI3`3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP040=@m6@3om^h0e3dI0=@m6AD0ooK^00<0e3dI
0?ofkP3om^h02@3om^h20=@m6@d0ooK^00<0e3dI0?ofkP3om^h02`3om^h0103D?AT0ooK^0?ofkP3D
?AT50?ofkP80e3dI1@3om^h0103D?AT0ooK^0?ofkP3om^hB0=@m6@80ooK^103D?ATH0?ofkPD0?EV[
0P3om^h00`0mFJ/0ooK^0?ofkP060?ofkPL0?EV[00<0ooK^0000003om^h01@3om^h203eIZ`H0ooK^
00<0?EV[0?ofkP3om^h01@3om^h603eIZ`H0ooK^0P0mFJ/B0?ofkP0303eIZ`3om^h0ooK^00@0ooK^
00<0?EV[0?ofkP3om^h01@3om^h303eIZ`l0ooK^00<0?EV[0?ofkP3om^h05P3om^h00`0mFJ/0ooK^
0?ofkP0L0?ofkP800000;P3om^h10?ooo`002`3om^h00`000000ooK^0?ofkP090?ofkP800000CP3o
m^h00`3D?AT0ooK^0?ofkP060?ofkP80e3dI303om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3o
m^h0ooK^0080ooK^0P3D?ATB0?ofkP030=@m6@3om^h0ooK^00`0ooK^0P3D?AT90?ofkP80e3dI3`3o
m^h30=@m6@L0ooK^0P3D?AT30?ofkP@0e3dI0`3om^h20=@m6@<0ooK^00@0e3dI0?ofkP3om^h0ooK^
0P3D?AT30?ofkPT0e3dI4P3om^h503eIZ`@0ooK^0P0mFJ/50?ofkPL0?EV[0P3om^h0100mFJ/0ooK^
0?ofkP0000080?ofkP80?EV[0`3om^h00`0mFJ/0ooK^0?ofkP020?ofkPH0?EV[2@3om^h0100mFJ/0
ooK^0?ofkP0mFJ/A0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h0100mFJ/C0?of
kP0303eIZ`3om^h0ooK^01H0ooK^00<0?EV[0?ofkP3om^h07@3om^h00`000000ooK^0?ofkP0[0?of
kP40oooo000;0?ofkP030000003om^h0ooK^00/0ooK^0`00001:0?ofkP030=@m6@3om^h0ooK^00T0
ooK^0P3D?AT90?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h01@3om^h20=@m6@l0
ooK^00<0e3dI0?ofkP3om^h03`3om^h20=@m6@D0ooK^0P3D?ATC0?ofkP80e3dI203om^h30=@m6@03
0?ofkP3D?AT0ooK^00H0ooK^0P3D?AT00`3om^h0e3dI0?ofkP040?ofkP<0e3dI0P3om^h90=@m6@`0
ooK^1@0mFJ/40?ofkPD0?EV[0P3om^h703eIZ`D0ooK^00D0?EV[0?ofkP3om^h0ooK^0000000:0?of
kP80?EV[00<0ooK^03eIZ`0mFJ/01@0mFJ/=0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/0403om^h0
0`0mFJ/0ooK^0?ofkP040?ofkP@0?EV[5`3om^h00`0mFJ/0ooK^0?ofkP0F0?ofkP0303eIZ`3om^h0
ooK^01h0ooK^0P00000[0?ofkP40oooo000;0?ofkP030000003om^h0ooK^00h0ooK^0P0000180?of
kP030=@m6@3om^h0ooK^00/0ooK^0`3D?AT50?ofkP030=@m6@3om^h0ooK^01@0ooK^00<0e3dI0?of
kP3om^h01`3om^h20=@m6@`0ooK^00<0e3dI0?ofkP3om^h04P3om^h20=@m6@030?ofkP3D?AT0e3dI
01H0ooK^0`3D?AT20?ofkP@0e3dI0P3om^h30=@m6@T0ooK^0`3D?AT70?ofkP80e3dI00<0ooK^0=@m
6@3om^h00P3D?AT20?ofkP@0e3dI1`3om^h503eIZ`P0ooK^2@0mFJ/80?ofkP0303eIZ`3om^h0ooK^
0080ooK^00<000000?ofkP3om^h0203om^h603eIZa40ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0m
FJ/0ooK^0?ofkP0<0?ofkP0403eIZ`3om^h0ooK^0?ofkP@0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP0F
0?ofkP0303eIZ`3om^h0ooK^01@0ooK^0`0mFJ/Q0?ofkP030000003om^h0ooK^02P0ooK^0@3oool0
00X0ooK^00<000000?ofkP3om^h04@3om^h3000004@0ooK^00<0e3dI0?ofkP3om^h03`3om^h20=@m
6@80ooK^00<0e3dI0?ofkP3om^h0503om^h00`3D?AT0ooK^0?ofkP0:0?ofkP80e3dI203om^h20=@m
6AL0ooK^0P3D?ATG0?ofkP030=@m6@3om^h0e3dI0080e3dI203om^h30=@m6@T0ooK^0P3D?AT80?of
kP<0e3dI0P3om^h20=@m6@030?ofkP3D?AT0e3dI00@0e3dI1@0mFJ/:0?ofkPL0?EV[0P3om^h203eI
Z`P0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`000000ooK^0?ofkP040?ofkPL0?EV[00<0ooK^03eI
Z`3om^h0403om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00X0ooK^1@0mFJ/70?of
kP0303eIZ`3om^h0ooK^01L0ooK^00<0?EV[0?ofkP3om^h03`3om^h403eIZ`80ooK^00<0?EV[0?of
kP3om^h0803om^h2000002P0ooK^0@3oool000X0ooK^00<000000?ofkP3om^h0503om^h200000440
ooK^00<0e3dI0?ofkP3om^h04P3om^h30=@m6AD0ooK^00<0e3dI0?ofkP3om^h03@3om^h20=@m6@D0
ooK^00<0e3dI0?ofkP3om^h05P3om^h00`3D?AT0ooK^0?ofkP020=@m6AD0ooK^0P3D?AT30?ofkP80
e3dI1`3om^h0103D?AT0ooK^0=@m6@3D?AT80?ofkP<0e3dI203om^h20=@m6@80ooK^00D000000=@m
6@000000e3dI000000030=@m6@80000000<0?EV[0?ofkP3om^h01P3om^h703eIZ`P0ooK^0P0mFJ/5
0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<000000?ofkP3om^h01P0mFJ/30?ofkP0503eIZ`3om^h0
ooK^0?ofkP0mFJ/0403om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00D0ooK^1P0m
FJ/;0?ofkP0303eIZ`3om^h0ooK^01L0ooK^00<0?EV[0?ofkP3om^h02P3om^h403eIZ`L0ooK^00<0
?EV[0?ofkP3om^h08@3om^h00`000000ooK^0?ofkP0U0?ofkP40oooo000:0?ofkP030000003om^h0
ooK^01H0ooK^0`00000n0?ofkP030=@m6@3om^h0ooK^0180ooK^00<0e3dI0?ofkP3om^h00P3D?ATB
0?ofkP030=@m6@3om^h0ooK^0100ooK^0P3D?AT20?ofkP030=@m6@3om^h0ooK^01D0ooK^0P3D?AT5
0?ofkP<0e3dI403om^h30=@m6@H0ooK^0`3D?AT50?ofkP030=@m6@3om^h0ooK^0080e3dI1`3om^h0
103D?AT0ooK^0=@m6@3D?AT60?ofkP040000003D?AT0e3dI0=@m6@801PPA0P0000000`3D?AT00000
000000020=@m6@0400d@7`000000000000000080ooK^100mFJ/0103om^h0?EV[03eIZ`0mFJ/=0?of
kP80?EV[0P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`000000?EV[00<0?EV[1`3om^h00`0m
FJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0m
FJ/0ooK^0?ofkP0503eIZ`@0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP0F0?of
kP0303eIZ`3om^h0ooK^00H0ooK^100mFJ/;0?ofkP0303eIZ`3om^h0ooK^0280ooK^0P00000U0?of
kP40oooo000:0?ofkP030000003om^h0ooK^01T0ooK^0P00000k0?ofkP030=@m6@3om^h0ooK^01<0
ooK^00<0e3dI0?ofkP3om^h00P3om^h30=@m6@h0ooK^00<0e3dI0?ofkP3om^h04`3om^h30=@m6AH0
ooK^00<0e3dI0?ofkP3om^h0203om^h20=@m6@`0ooK^0P3D?AT30?ofkP030=@m6@3om^h0ooK^00H0
ooK^0P3D?AT30?ofkP030=@m6@3om^h0ooK^0080ooK^0P3D?AT60?ofkP040=@m6@3om^h0e3dI0=@m
6@D0000000@01PPA0000003D?AT000000P3D?AT0100=41l0000000d@7`3D?AT300d@7`80e3dI00D0
000003eIZ`0mFJ/0?EV[0?ofkP0403eIZ`80ooK^00<0?EV[0?ofkP3om^h03@3om^h303eIZ`030?of
kP0mFJ/0?EV[00<0?EV[00<000000?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eI
Z`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h01P3om^h503eIZ`L0ooK^00<0?EV[0?ofkP3om^h0
303om^h00`0mFJ/0ooK^0?ofkP0F0?ofkP0403eIZ`3om^h0ooK^0?ofkP@0?EV[403om^h00`0mFJ/0
ooK^0?ofkP0S0?ofkP030000003om^h0ooK^0280ooK^0@3oool000X0ooK^00<000000?ofkP3om^h0
6`3om^h3000003L0ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP060?ofkP80e3dI
2`3om^h00`3D?AT0ooK^0?ofkP0D0?ofkP030=@m6@3om^h0ooK^0080e3dI4`3om^h00`3D?AT0ooK^
0?ofkP0;0?ofkP<0e3dI1`3om^h20=@m6@D0ooK^00<0e3dI0?ofkP3om^h0203om^h40=@m6@H0ooK^
0`3D?AT0103om^h0e3dI0=@m6@3D?AT30000000400H84@0000001PPA00H84@<0000000@0e3dI00d@
7`0=41l03A0O0P3D?AT200d@7`030=@m6@0=41l03A0O00803A0O1P0000040?ofkP0303eIZ`3om^h0
ooK^00d0ooK^1`0mFJ/30?ofkP030000003om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h01@3om^h0
0`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^0080ooK^1@0mFJ/20?ofkP0303eIZ`3om^h0
ooK^00H0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0E0?ofkPD0?EV[503om^h0
0`0mFJ/0ooK^0?ofkP0T0?ofkP8000008P3om^h10?ooo`002P3om^h00`000000ooK^0?ofkP0N0?of
kP800000=@3om^h00`3D?AT0ooK^0?ofkP0B0?ofkP030=@m6@3om^h0ooK^00T0ooK^0P3D?AT90?of
kP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h00`3om^h20=@m6@l0ooK^0P3D?ATA0?of
kP80e3dI0`3om^h20=@m6@L0ooK^00<0e3dI0?ofkP3om^h02`3om^h20=@m6@@0ooK^1P3D?AT20000
00030=@m6@062140000000@000000P0=41l00`0000003A0O0=@m6@0400d@7`040=@m6@0=41l03A0O
0=@m6@<0000000<05Q/i000000278@d01@0000000`3om^h0?EV[0?ofkP0;0?ofkPL0?EV[0P3om^h0
0`0mFJ/0ooK^0?ofkP030?ofkP030000003om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h01`3om^h0
0`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0?EV[00@0?EV[1`3om^h00`0mFJ/0ooK^0?ofkP05
0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h0403om^h403eIZ`80ooK^00<0?EV[
0?ofkP3om^h05@3om^h00`0mFJ/0ooK^0?ofkP0U0?ofkP030000003om^h0ooK^01l0ooK^0@3oool0
00X0ooK^00<000000?ofkP3om^h0803om^h300000340ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D
?AT0ooK^0?ofkP0;0?ofkP<0e3dI1@3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^
00H0ooK^0P3D?AT<0?ofkP030=@m6@3om^h0ooK^01<0ooK^0`3D?AT90?ofkP030=@m6@3om^h0ooK^
00`0ooK^1@3D?AT20?ofkP@000000`3D?AT00`0000003A0O0000000500d@7`040000000=41l0e3dI
00d@7`@000000P3D?AT00`0F6cT0e3dI01HK>@0301HK>@03000000278@d0Qb4=0080000000<0FA<8
03eIZ`000000203om^h703eIZ`80ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP02
0?ofkP030000003om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP05
0?ofkPD0?EV[2`3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[
0?ofkP3om^h02`3om^h403eIZ`L0ooK^00<0?EV[0?ofkP3om^h0503om^h00`0mFJ/0ooK^0?ofkP0V
0?ofkP8000007`3om^h10?ooo`002P3om^h00`000000ooK^0?ofkP0S0?ofkP800000;P3om^h00`3D
?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^00l0ooK^0P3D?AT20?ofkP030=@m6@3om^h0ooK^
01<0ooK^00<0e3dI0?ofkP3om^h02@3om^h20=@m6@T0ooK^00<0e3dI0?ofkP3om^h0503om^h0103D
?AT0ooK^0=@m6@3D?AT90?ofkP030=@m6@3om^h0ooK^00/0ooK^0P3D?AT00`3om^h0000000000007
0000000400d@7`3D?AT0e3dI000000D03A0O100000001@3D?AT05Q/i01HK>@0F6cT0000000805Q/i
0`3D?AT301HK>@04000000278@d0Qb4=08LQ3@80000000D0?EV[00000000000000000?ofkP0903eI
Z`D0ooK^00<0?EV[0?ofkP3om^h00`3om^h01@0mFJ/0ooK^0?ofkP3om^h0000000P0ooK^00<0?EV[
0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP0503eIZ`030?ofkP0mFJ/0ooK^00d0ooK^00<0?EV[
0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00D0ooK^1@0mFJ/;
0?ofkP0303eIZ`3om^h0ooK^01D0ooK^00<0?EV[0?ofkP3om^h09`3om^h00`000000ooK^0?ofkP0L
0?ofkP40oooo000:0?ofkP030000003om^h0ooK^02D0ooK^0`00000[0?ofkP030=@m6@3om^h0ooK^
0180ooK^00<0e3dI0?ofkP3om^h04P3om^h30=@m6A@0ooK^00<0e3dI0?ofkP3om^h0303om^h20=@m
6@D0ooK^0P3D?ATE0?ofkP80e3dI103om^h20=@m6@L0ooK^0P3D?AT:0?ofkP030=@m6@000000e3dI
00L0000000<03A0O0000000=41l00`0=41l30=@m6@@0000000D05Q/i0000000F6cT05Q/i0=@m6@04
01HK>@040000000F6cT05Q/i01HK>@80e3dI0`0F6cT01P000000Qb4=08LQ3@278@d0?EV[08LQ3@@0
?EV[00<0000003eIZ`0mFJ/00P0mFJ/80?ofkP0303eIZ`3om^h0ooK^00D0ooK^0P0mFJ/00`3om^h0
00000?ofkP060?ofkP0303eIZ`3om^h0ooK^00P0ooK^1P0mFJ/50?ofkP0303eIZ`3om^h0ooK^00d0
ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0403eIZ`3om^h0ooK^0?of
kP@0?EV[4@3om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP0303eIZ`3om^h0ooK^02P0ooK^0P00000L0?of
kP40oooo000:0?ofkP030000003om^h0ooK^02P0ooK^0P00000X0?ofkP80e3dI503om^h00`3D?AT0
ooK^0?ofkP0B0?ofkP030=@m6@3om^h0ooK^0080e3dI4@3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP80
e3dI0P3om^h00`3D?AT0ooK^0?ofkP0D0?ofkP030=@m6@3om^h0ooK^00H0ooK^0P3D?AT50?ofkP04
0=@m6@3om^h0e3dI0=@m6@@0ooK^1@0000000`06214000000=@m6@03000000@03A0O00<0000000d@
7`0=41l00P0=41l00`000000e3dI000000020=@m6@<05Q/i00D0000001HK>@0F6cT05Q/i0=@m6@03
01HK>@030000000F6cT05Q/i00<05Q/i00@0e3dI01HK>@00000000000P278@d303eIZ`80Qb4=1@00
000:0?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0000003om^h01P3om^h00`0mFJ/0ooK^0?of
kP030?ofkPH0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00l0ooK^00D0
?EV[0?ofkP3om^h0ooK^03eIZ`0B0?ofkP@0?EV[5@3om^h00`0mFJ/0ooK^0?ofkP0E0?ofkP0303eI
Z`3om^h0ooK^02T0ooK^00<000000?ofkP3om^h06@3om^h10?ooo`002P3om^h00`000000ooK^0?of
kP0Z0?ofkP<000009@3om^h0103D?AT0ooK^0=@m6@3D?ATA0?ofkP030=@m6@3om^h0ooK^01<0ooK^
00<0e3dI0?ofkP3om^h00P3om^h20=@m6@l0ooK^00<0e3dI0?ofkP3om^h04@3om^h30=@m6AD0ooK^
00<0e3dI0?ofkP3om^h02@3om^h20=@m6@<0ooK^00@0e3dI0?ofkP3om^h0ooK^0P3D?AT900000003
0=@m6@0=41l0000000@03A0O00<0000000d@7`0000000`0000000`0F6cT0e3dI01HK>@0201HK>@80
e3dI00<05Q/i0000000F6cT00P0F6cT00`3D?AT05Q/i01HK>@0201HK>@030000000F6cT05Q/i00<0
00000P3D?AT01P000000?EV[03eIZ`0mFJ/0Qb4=000000<0Qb4=1P0000070?ofkP0303eIZ`3om^h0
ooK^00T0ooK^00<000000?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0503eIZ`T0ooK^00<0?EV[
0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0403eIZ`3om^h0ooK^03eIZ`h0ooK^100m
FJ/20?ofkP0303eIZ`3om^h0ooK^01D0ooK^00<0?EV[0?ofkP3om^h0503om^h00`0mFJ/0ooK^0?of
kP0Z0?ofkP8000006@3om^h10?ooo`002P3om^h00`000000ooK^0?ofkP0]0?ofkP8000008P3om^h0
0`3D?AT0ooK^0?ofkP020?ofkP<0e3dI3@3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0
ooK^00D0ooK^0P3D?AT<0?ofkP030=@m6@3om^h0ooK^0180ooK^00<0e3dI0?ofkP3om^h00P3D?ATA
0?ofkP80e3dI3P3om^h20=@m6@030?ofkP3D?AT000000080000000@01PPA0000003D?AT0e3dI0`00
00001`0=41l0000000d@7`0=41l0e3dI00d@7`0000000`0=41l3000000D05Q/i00<0e3dI01HK>@0F
6cT00`0F6cT20=@m6@@05Q/i00<0e3dI01HK>@00000010000003020YE`050=@m6@0P:EL000000;8^
4@0mFJ/00`00000308LQ3@03000000278@d0Qb4=00<0000000<0FA<80000003om^h0103om^h00`0m
FJ/0ooK^0?ofkP090?ofkP030000000mFJ/0ooK^0080ooK^1@0mFJ/>0?ofkP0303eIZ`3om^h0ooK^
0080ooK^00<0?EV[0?ofkP3om^h04@3om^h00`0mFJ/0ooK^03eIZ`0:0?ofkP@0?EV[1P3om^h00`0m
FJ/0ooK^0?ofkP0E0?ofkP0303eIZ`3om^h0ooK^01D0ooK^00<0?EV[0?ofkP3om^h0:`3om^h00`00
0000ooK^0?ofkP0F0?ofkP40oooo000:0?ofkP030000003om^h0ooK^02l0ooK^0`00000O0?ofkP03
0=@m6@3om^h0ooK^00D0ooK^0P3D?AT;0?ofkP030=@m6@3om^h0ooK^0180ooK^00<0e3dI0?ofkP3o
m^h0203om^h30=@m6@P0ooK^00<0e3dI0?ofkP3om^h04P3om^h00`3D?AT0ooK^0?ofkP030?ofkP<0
e3dI3@3om^h00`3D?AT0ooK^0?ofkP0<0?ofkPD0000000<0e3dI000000062140100000001@0=41l0
e3dI0=@m6@0=41l0000000@03A0O00<0e3dI0000000000000P0000000`0F6cT0000001HK>@0501HK
>@030=@m6@0F6cT05Q/i00@05Q/i00<000000=@m6@3D?AT00P0000001@3D?AT00000020YE`0P:EL0
000000H082UG00@0e3dI020YE`000000?EV[0P2b;Q42000000<0Qb4=00@0000008LQ3@278@d0Qb4=
1@0000020?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0000003eIZ`0mFJ/00`0mFJ/00`3om^h0?EV[
0?ofkP0@0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/04`3om^h00`0mFJ/0ooK^03eIZ`060?ofkP@0
?EV[2`3om^h00`0mFJ/0ooK^0?ofkP0E0?ofkP0303eIZ`3om^h0ooK^01@0ooK^00<0?EV[0?ofkP3o
m^h0;03om^h2000001H0ooK^0@3oool000X0ooK^00<000000?ofkP3om^h0<P3om^h2000001`0ooK^
00<0e3dI0?ofkP3om^h0203om^h20=@m6@P0ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^
0?ofkP0;0?ofkP80e3dI1@3om^h00`3D?AT0ooK^0?ofkP0B0?ofkP030=@m6@3om^h0ooK^00L0ooK^
0P3D?AT:0?ofkP030=@m6@3om^h0ooK^00T0ooK^2P0000001@3D?AT0000000d@7`0=41l0000000@0
3A0O0P3D?AT200d@7`80000000<0e3dI01HK>@0F6cT00P0F6cT00`0000005Q/i01HK>@0401HK>@03
0000000F6cT0e3dI00@05Q/i100000020=@m6@05020YE`3D?AT082UG020YE`0000001`0P:EL00`3D
?AT0000003eIZ`030;8^4@<000000P278@d01@000000Qb4=08LQ3@000000Qb4=0080000000@0FA<8
000000000000?EV[2P3om^h203eIZ`040000000mFJ/0ooK^03eIZ`<0ooK^00<0?EV[0?ofkP3om^h0
403om^h0100mFJ/0ooK^0?ofkP0mFJ/D0?ofkP80?EV[0P3om^h403eIZ`l0ooK^00<0?EV[0?ofkP3o
m^h05@3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP<0?EV[;`3om^h2000001@0ooK^0@3oool000X0ooK^
00<000000?ofkP3om^h0=03om^h3000001T0ooK^00<0e3dI0?ofkP3om^h02P3om^h30=@m6@@0ooK^
00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP80e3dI0P3om^h00`3D?AT0ooK^
0?ofkP0B0?ofkP030=@m6@3om^h0ooK^00X0ooK^0`3D?AT50?ofkP80e3dI2P3om^h20000000300H8
4@000000?EV[00L0000000@0e3dI00d@7`0000000000100=41l300000080e3dI00<05Q/i0000003D
?AT0100F6cT00`0000005Q/i01HK>@0401HK>@030000000F6cT0e3dI00805Q/i0P0000000`0P:EL0
0000020YE`03020YE`80e3dI0P0P:EL00`00000082UG020YE`06020YE`030000002b;Q40/RhA00<0
/RhA00<000000;8^4@0000000P00000308LQ3@03000000278@d0Qb4=0080000000<0?EV[00000000
00001@3om^h403eIZ`80ooK^00L000000?ofkP3om^h0ooK^03eIZ`3om^h0?EV[01@0ooK^0P0mFJ/E
0?ofkP@0?EV[503om^h00`0mFJ/0ooK^0?ofkP0E0?ofkP0303eIZ`3om^h0ooK^00h0ooK^100mFJ/2
0?ofkP0303eIZ`3om^h0ooK^02l0ooK^00<000000?ofkP3om^h04@3om^h10?ooo`002P3om^h00`00
0000ooK^0?ofkP0g0?ofkP8000005`3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP80e3dI0P3om^h00`3D
?AT0ooK^0?ofkP0B0?ofkP030=@m6@3om^h0ooK^0140ooK^0`3D?ATC0?ofkP030=@m6@3om^h0ooK^
00h0ooK^0P3D?AT20?ofkP030=@m6@3om^h0ooK^00L0ooK^2P00000200d@7`050000000=41l03A0O
0=@m6@0000000P0=41l5000000@05Q/i0P3D?AT00`0F6cT0e3dI01HK>@0201HK>@030000000F6cT0
5Q/i00@05Q/i00<0000001HK>@3D?AT00P000003020YE`030000000P:EL082UG00@082UG0P3D?AT0
0`00000082UG020YE`06020YE`030000002b;Q40/RhA00<0/RhA00@000000;8^4@2b;Q40/RhA0P00
000308LQ3@05000000278@d0Qb4=0000000mFJ/01000000403eIZ`D0ooK^00L000000?ofkP3om^h0
ooK^03eIZ`3om^h0?EV[01D0ooK^00<0?EV[0?ofkP3om^h03`3om^h503eIZ`030?ofkP0mFJ/0ooK^
01@0ooK^00<0?EV[0?ofkP3om^h05@3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP@0?EV[1`3om^h00`0m
FJ/0ooK^0?ofkP0_0?ofkP8000004@3om^h10?ooo`002@3om^h00`000000ooK^0?ofkP0j0?ofkP<0
00004`3om^h00`3D?AT0ooK^0?ofkP0@0?ofkP<0e3dI503om^h00`3D?AT0ooK^0?ofkP0A0?ofkP03
0=@m6@3om^h0ooK^0080e3dI403om^h00`3D?AT0ooK^0?ofkP0A0?ofkP80e3dI1`3om^h300000003
00H84@000000000000<0000000<03A0O0000000=41l00P0=41l01@0000003A0O00d@7`000000e3dI
00<000000P0F6cT00`0000005Q/i01HK>@0401HK>@040000000F6cT0e3dI0=@m6@<05Q/i00<00000
01HK>@0F6cT00`0F6cT20000000303eIZ`0P:EL0e3dI00@082UG00<00000020YE`0P:EL0100P:EL0
103D?AT082UG0=@m6@3D?AT8020YE`030000002b;Q40/RhA0080/RhA00<000000;8^4@2b;Q400P2b
;Q4300000080Qb4=00@0000008LQ3@0mFJ/0Qb4=100mFJ/2000000L0ooK^00<000000?ofkP3om^h0
0P3om^h203eIZaD0ooK^0P0mFJ/<0?ofkP@0?EV[0`3om^h203eIZ`030?ofkP0mFJ/0ooK^01D0ooK^
00<0?EV[0?ofkP3om^h05@3om^h00`0mFJ/0ooK^0?ofkP050?ofkP@0?EV[2`3om^h00`0mFJ/0ooK^
0?ofkP0a0?ofkP030000003om^h0ooK^00h0ooK^0@3oool000T0ooK^00<000000?ofkP3om^h0?@3o
m^h200000140ooK^00<0e3dI0?ofkP3om^h04@3om^h0103D?AT0ooK^0=@m6@3D?ATA0?ofkP030=@m
6@3om^h0ooK^0180ooK^00<0e3dI0?ofkP3om^h00P3om^h20=@m6@h0ooK^00<0e3dI0?ofkP3om^h0
4@3om^h0103D?AT0ooK^0=@m6@3D?AT20?ofkPX0000000<03A0O0000000000000P0=41l600000003
0=@m6@0F6cT05Q/i00<05Q/i00<0000001HK>@0F6cT00`0F6cT0100000005Q/i01HK>@0F6cT30=@m
6@030000000F6cT05Q/i00@0000000D082UG0000000P:EL082UG0=@m6@04020YE`030000000P:EL0
82UG00D082UG00<0e3dI020YE`0000000P3D?AT4020YE`@00000102b;Q400`000000/RhA0;8^4@02
0;8^4@030000002b;Q400000008000000`0mFJ/308LQ3@D000001@3om^h00`000000ooK^0?ofkP03
0?ofkP0303eIZ`3om^h0ooK^01<0ooK^0P0mFJ/80?ofkP@0?EV[0`3om^h403eIZ`050?ofkP0mFJ/0
ooK^0?ofkP0mFJ/05P3om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP0403eIZ`3om^h0ooK^0?ofkP@0?EV[
403om^h00`0mFJ/0ooK^0?ofkP0a0?ofkP8000003P3om^h10?ooo`002@3om^h00`000000ooK^0?of
kP0o0?ofkP<000003@3om^h00`3D?AT0ooK^0?ofkP0A0?ofkP030=@m6@3om^h0ooK^0080ooK^0`3D
?AT=0?ofkP030=@m6@3om^h0ooK^0180ooK^00<0e3dI0?ofkP3om^h01@3om^h20=@m6@/0ooK^00<0
e3dI0?ofkP3om^h04P3om^h00`3D?AT0ooK^0?ofkP080000000300d@7`000000000000803A0O00<0
000000d@7`0=41l00`00000301HK>@030000000F6cT0e3dI00@05Q/i00<0000001HK>@0F6cT0100F
6cT01`0000005Q/i01HK>@0F6cT0e3dI01HK>@0mFJ/00P3D?AT00`00000082UG020YE`03020YE`04
0000000P:EL082UG0=@m6@@082UG00<00000020YE`0P:EL01@0P:EL00`3D?AT082UG00000002020Y
E`80e3dI0P00000202LeKP040000003D>AH0000000000080/RhA00<000000;8^4@2b;Q400P2b;Q40
0`000000?EV[03eIZ`0203eIZ`040000000mFJ/0Qb4=00000080Qb4=00<0000008LQ3@0000001000
00030?ofkP030000003om^h0ooK^00<0ooK^0P0mFJ/D0?ofkP0303eIZ`3om^h0?EV[00<0ooK^100m
FJ/30?ofkP@0?EV[1@3om^h0100mFJ/0ooK^0?ofkP0mFJ/F0?ofkP0303eIZ`3om^h0ooK^01<0ooK^
1@0mFJ/D0?ofkP0303eIZ`3om^h0ooK^03<0ooK^00<000000?ofkP3om^h02`3om^h10?ooo`002@3o
m^h00`000000ooK^0?ofkP120?ofkP8000002`3om^h00`3D?AT0ooK^0?ofkP0A0?ofkP030=@m6@3o
m^h0ooK^00D0ooK^0P3D?AT;0?ofkP030=@m6@3om^h0ooK^0140ooK^00<0e3dI0?ofkP3om^h0203o
m^h20=@m6@P0ooK^00<0e3dI0?ofkP3om^h04P3om^h00`3D?AT0000000000003000000803A0O0P00
000200d@7`030000000=41l03A0O00H000001@0F6cT00`0000005Q/i0=@m6@0301HK>@030000000F
6cT05Q/i00@05Q/i00<0000001HK>@0F6cT00P0000001@3D?AT00000020YE`00000082UG0080e3dI
100P:EL01@00000082UG020YE`0P:EL0e3dI00<082UG00<00000020YE`0P:EL01@0P:EL00`3D?AT0
000000000002000000809cE^0P3D?AT202LeKP040000003D>AH0e3TF0=@i5P80000000<0/RhA0000
000mFJ/00`0mFJ/40;8^4@050000000mFJ/0000008LQ3@0000000P278@d00`000000Qb4=08LQ3@05
000000030?ofkP000000ooK^00<0ooK^00@0?EV[0?ofkP3om^h0?EV[4`3om^h603eIZ`<0ooK^100m
FJ/90?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/05P3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP@0?EV[
0P3om^h00`0mFJ/0ooK^0?ofkP0E0?ofkP0303eIZ`3om^h0ooK^03<0ooK^0P00000;0?ofkP40oooo
00090?ofkP030000003om^h0ooK^04@0ooK^0`0000070?ofkP030=@m6@3om^h0ooK^0140ooK^00<0
e3dI0?ofkP3om^h0203om^h20=@m6@P0ooK^00<0e3dI0?ofkP3om^h04P3om^h00`3D?AT0ooK^0?of
kP0:0?ofkP80e3dI1@3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP0403eIZ`00000000000=@m6@@00000
0P0=41l2000000803A0O0P000000100=41l0000000000000000301HK>@030000000F6cT05Q/i00<0
5Q/i00@0000001HK>@0F6cT0e3dI0P0F6cT00`0000005Q/i01HK>@0301HK>@D000000P0P:EL00`3D
?AT082UG00000004020YE`80e3dI00<082UG0000000P:EL00`0P:EL01@3D?AT082UG020YE`0P:EL0
000000D082UG0`0000000`3D?AT0000002LeKP0502LeKP80e3dI00@000000=@i5P3D?AT0e3TF100m
FJ/40;8^4@070000002b;Q40/RhA0;8^4@0mFJ/000000;8^4@02000000<0Qb4=00<0000008LQ3@27
8@d01P0000040?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/03P3om^h503eIZ`<0ooK^1@0mFJ/=0?of
kP0503eIZ`3om^h0ooK^0?ofkP0mFJ/05P3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP@0?EV[1`3om^h0
0`0mFJ/0ooK^0?ofkP0D0?ofkP0303eIZ`3om^h0ooK^03<0ooK^0`00000:0?ofkP40oooo00090?of
kP030000003om^h0ooK^04L0ooK^0P0000050?ofkP030=@m6@3om^h0ooK^0140ooK^00<0e3dI0?of
kP3om^h02P3om^h30=@m6@@0ooK^00<0e3dI0?ofkP3om^h04P3om^h00`3D?AT0ooK^0?ofkP0=0?of
kP80e3dI0P3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP80?EV[1@000000100=41l0000000d@7`0=41l2
000000803A0O1P00000501HK>@030000000F6cT05Q/i00805Q/i00D0000001HK>@0F6cT05Q/i0=@m
6@0201HK>@030000000F6cT0000000<0000000<082UG03eIZ`0000001@0P:EL00`3D?AT00000020Y
E`05020YE`80e3dI100P:EL01P3D?AT082UG020YE`0P:EL00000020YE`@000000`0W=Fh00`3D?AT0
000002LeKP0702LeKP040000000mFJ/0?EV[03eIZ`<0e3TF0`0000020;8^4@060000002b;Q40/RhA
0;8^4@0mFJ/000000`2b;Q401@000000Qb4=08LQ3@278@d000000080Qb4=1P0000030?ofkP0503eI
Z`3om^h0ooK^0?ofkP0mFJ/02@3om^h503eIZ`<0ooK^00<0?EV[0?ofkP0mFJ/00`0mFJ/A0?ofkP03
03eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h0503om^h00`0mFJ/0ooK^0?ofkP050?ofkP@0
?EV[2`3om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP0303eIZ`3om^h0ooK^02l0ooK^100000020?ofkP03
0000003om^h0ooK^00P0ooK^0@3oool000T0ooK^00<000000?ofkP3om^h0B@3om^h300000080ooK^
00<0e3dI0?ofkP3om^h04@3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP80e3dI0P3om^h00`3D?AT0ooK^
0?ofkP0A0?ofkP030=@m6@3om^h0ooK^0100ooK^0`3D?AT;0?ofkP@0?EV[0P000000100=41l00000
0000000=41l20000000400d@7`000000000000d@7`@000000`0F6cT00`0000005Q/i01HK>@0301HK
>@030000000F6cT05Q/i00805Q/i00<0000001HK>@0F6cT00P0F6cT01@3D?AT000000000000mFJ/0
000000D082UG00<00000020YE`0P:EL0100P:EL00`3D?AT00000020YE`06020YE`030000003D?AT0
e3dI008082UG00<0e3dI020YE`0000000`00000702LeKP030=@m6@0000009cE^00L09cE^00<00000
0=@i5P3D>AH0103D>AH00`000000e3TF0=@i5P02000000060;8^4@000000/RhA0;8^4@0mFJ/00000
102b;Q420000000308LQ3@000000Qb4=0080Qb4=00<0000008LQ3@000000100000000`3om^h0?EV[
0?ofkP030?ofkP0403eIZ`3om^h0ooK^0?ofkPD0?EV[1P3om^h403eIZ`@0ooK^00<0?EV[0?ofkP3o
m^h03P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^01@0ooK^00@0?EV[0?ofkP3o
m^h0ooK^100mFJ/@0?ofkP0303eIZ`3om^h0ooK^01@0ooK^00<0?EV[0?ofkP3om^h0:@3om^h50000
00H0ooK^00<000000?ofkP3om^h0203om^h10?ooo`002@3om^h00`000000ooK^0?ofkP1<0?ofkP03
0000003D?AT0ooK^0180ooK^00<0e3dI0?ofkP3om^h0403om^h30=@m6A<0ooK^00<0e3dI0?ofkP3o
m^h0403om^h00`3D?AT0ooK^0?ofkP020=@m6@D0ooK^1P0mFJ/20000000400d@7`000000000000d@
7`80000000<03A0O0000000000000`0000000`0F6cT0000001HK>@0301HK>@030000000F6cT05Q/i
00<05Q/i00<0000001HK>@0F6cT00`0F6cT00`000000?EV[00000003000000030=@m6@00000082UG
00H082UG00<00000020YE`0P:EL0100P:EL00`3D?AT00000020YE`06020YE`030000000P:EL082UG
0080e3dI00D000000=@m6@0W=Fh09cE^0000000802LeKP030=@m6@0000009cE^00P09cE^00<00000
0=@i5P3D>AH00`3D>AH00`000000e3TF0=@i5P020=@i5P8000000P2b;Q400`0mFJ/0/RhA00000003
0;8^4@030000002b;Q400000008000000P278@d00`000000Qb4=08LQ3@030000000305TC20000000
?EV[00@0ooK^100mFJ/70?ofkP@0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0
ooK^00h0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP0B0?ofkPD0?EV[503om^h0
0`0mFJ/0ooK^0?ofkP0D0?ofkP0303eIZ`3om^h0ooK^02@0ooK^1@00000;0?ofkP030000003om^h0
ooK^00P0ooK^0@3oool000T0ooK^00<000000?ofkP3om^h0C@3om^h0103D?AT0000000000000000@
0?ofkP030=@m6@3om^h0ooK^0140ooK^00@0e3dI0?ofkP3D?AT0e3dI403om^h00`3D?AT0ooK^0?of
kP0A0?ofkP030=@m6@3om^h0ooK^0080ooK^0P3D?AT503eIZ`80ooK^0P000000100=41l000000000
000=41l6000000@05Q/i00<0000001HK>@0F6cT00P0F6cT00`0000005Q/i01HK>@0301HK>@030000
000F6cT05Q/i00805Q/i0P0000000`0mFJ/00000020YE`03020YE`030=@m6@0P:EL082UG00D082UG
00<00000020YE`0P:EL01@0P:EL00`3D?AT082UG020YE`04020YE`D000000P0W=Fh30=@m6@0302Le
KP0000009cE^00P09cE^00<0e3dI02LeKP0W=Fh01`0W=Fh00`000000e3TF0=@i5P030=@i5P030000
003D>AH0e3TF00<0e3TF0`0000000`0mFJ/0/RhA000000040;8^4@030000002b;Q40/RhA00<00000
00<0Qb4=000000278@d00P00000010278@d000000000000mFJ/200000080?EV[00<0ooK^03eIZ`3o
m^h00`3om^h503eIZ`H0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP03
03eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h03@3om^h503eIZ`80ooK^00<0?EV[0?ofkP3o
m^h0503om^h00`0mFJ/0ooK^0?ofkP0E0?ofkP0303eIZ`3om^h0ooK^01l0ooK^1000000@0?ofkP03
0000003om^h0ooK^00P0ooK^0@3oool000T0ooK^00<000000?ofkP3om^h0C03om^h00`3D?AT0ooK^
0?ofkP020?ofkP8000003@3om^h00`3D?AT0ooK^0?ofkP0A0?ofkP030=@m6@3om^h0ooK^0080ooK^
0P3D?AT=0?ofkP030=@m6@3om^h0ooK^0140ooK^00<0e3dI0?ofkP3om^h01@0mFJ/20=@m6@<0ooK^
0P000000100=41l000000000000=41l3000000<05Q/i00<0000001HK>@0F6cT00P0F6cT00`000000
5Q/i01HK>@0301HK>@030000000F6cT05Q/i00<05Q/i1@0000000`0P:EL00000020YE`05020YE`03
0=@m6@0P:EL082UG00D082UG00<00000020YE`0P:EL01@0P:EL00`3D?AT082UG020YE`0400000080
9cE^00<0000002LeKP0W=Fh00`0W=Fh0103D?AT09cE^0=@m6@3D?AT902LeKP030=@m6@0W=Fh09cE^
00L09cE^00<000000=@i5P3D>AH00`3D>AH00`000000e3TF0=@i5P030=@i5P060000003D>AH0?EV[
0000002b;Q400000102b;Q400`000000/RhA0;8^4@020;8^4@D0000000@0Qb4=000000278@d0?EV[
1@0000000`3om^h0?EV[03eIZ`0303eIZ`/0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^
0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h01P3om^h603eIZ`P0ooK^
00<0?EV[0?ofkP3om^h0503om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP0303eIZ`3om^h0ooK^01X0ooK^
1@00000D0?ofkP030000003om^h0ooK^00P0ooK^0@3oool000T0ooK^00<000000?ofkP3om^h0C03o
m^h20=@m6@D0ooK^0`00000:0?ofkP030=@m6@3om^h0ooK^0140ooK^00<0e3dI0?ofkP3om^h0103o
m^h20=@m6@/0ooK^00<0e3dI0?ofkP3om^h03`3om^h203eIZ`030=@m6@0mFJ/0?EV[00@0?EV[0`3o
m^h20=@m6@030000000=41l0000000D00000100F6cT00`0000005Q/i01HK>@0201HK>@030000000F
6cT05Q/i00<05Q/i00<0000001HK>@0F6cT00P0F6cT3000000@082UG00<00000020YE`0P:EL01@0P
:EL00`3D?AT082UG020YE`05020YE`030000000P:EL082UG00<082UG0P0000000`3D?AT000000000
000602LeKP030000000W=Fh09cE^00<09cE^00@0e3dI02LeKP0W=Fh000000P3D?AT702LeKP030=@m
6@0W=Fh09cE^00L09cE^00<000000=@i5P3D>AH0103D>AH00`000000e3TF0=@i5P030=@i5P030000
000mFJ/0e3TF00<00000102b;Q401@000000/RhA0;8^4@2b;Q4000000080/RhA0P00000208LQ3@04
0000000mFJ/0000008LQ3@@0?EV[00<0000003eIZ`3om^h03@3om^h00`0mFJ/0ooK^0?ofkP050?of
kP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h01@3om^h0100mFJ/0ooK^0?ofkP3om^h5
03eIZ`h0ooK^00<0?EV[0?ofkP3om^h0503om^h00`0mFJ/0ooK^0?ofkP0E0?ofkP0303eIZ`3om^h0
ooK^01@0ooK^1@00000I0?ofkP030000003om^h0ooK^00P0ooK^0@3oool000T0ooK^00<000000?of
kP3om^h0C03om^h0103D?AT0ooK^0=@m6@3D?AT60?ofkP8000001`3om^h00`3D?AT0ooK^0?ofkP0A
0?ofkP030=@m6@3om^h0ooK^00L0ooK^0`3D?AT70?ofkP030=@m6@3om^h0ooK^00`0ooK^1@0mFJ/0
103D?AT0ooK^0?ofkP3om^h203eIZ`80ooK^0`0mFJ/5000000805Q/i0P00000401HK>@030000000F
6cT05Q/i00805Q/i00<0000001HK>@0F6cT00`0F6cT00`0000005Q/i00000004000000H082UG00<0
0000020YE`0P:EL0100P:EL00`000000e3dI0=@m6@05020YE`030000000P:EL082UG00@000000P0W
=Fh00`3D?AT09cE^02LeKP0602LeKP030000000W=Fh09cE^00<09cE^00@0e3dI02LeKP0W=Fh00000
0P0W=Fh20=@m6@D09cE^00<000000=@m6@0W=Fh01@0W=Fh4000000D0e3TF00<000000=@i5P3D>AH0
0`3D>AH00`000000?EV[0=@i5P020=@i5P8000000`2b;Q400`000000/RhA0;8^4@020;8^4@030000
002b;Q40/RhA008000001@0mFJ/208LQ3@D000003@3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eI
Z`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h01@3om^h403eIZa@0ooK^00<0?EV[0?ofkP3om^h0
503om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP0303eIZ`3om^h0ooK^0100ooK^1000000N0?ofkP030000
003om^h0ooK^00P0ooK^0@3oool000T0ooK^00<000000?ofkP3om^h0B`3om^h00`3D?AT0ooK^0?of
kP020?ofkP<0e3dI1@3om^h3000000@0ooK^00<0e3dI0?ofkP3om^h04@3om^h00`3D?AT0ooK^0?of
kP0:0?ofkP80e3dI103om^h00`3D?AT0ooK^0?ofkP090?ofkPH0?EV[0P3om^h00`3D?AT0ooK^0?of
kP0603eIZ`H000000`0F6cT00`0000005Q/i01HK>@0201HK>@800000100F6cT00`0000005Q/i01HK
>@0201HK>@@00000100P:EL00`00000082UG020YE`03020YE`030000000P:EL082UG00D082UG00<0
00000=@m6@0P:EL00P3D?AT2020YE`@000001P0W=Fh00`3D?AT09cE^02LeKP0602LeKP030000000W
=Fh09cE^00<09cE^00@0e3dI02LeKP0W=Fh00000100W=Fh20=@m6@<09cE^00<000000=@m6@0W=Fh0
1@00000202`nOP040000003[@1T00000000000<0e3TF00<000000=@i5P3D>AH00`3D>AH00`000000
?EV[0=@i5P020=@i5P040000003D>AH0000000000080/RhA00D000000;8^4@2b;Q40/RhA00000002
03eIZ`080000000mFJ/0/RhA0000000mFJ/0000008LQ3@00000208LQ3@H000002`3om^h00`0mFJ/0
ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00X0ooK^00@0?EV[0?ofkP3om^h0ooK^100mFJ/00`3o
m^h0?EV[0?ofkP0E0?ofkP0303eIZ`3om^h0ooK^01@0ooK^00<0?EV[0?ofkP3om^h05@3om^h00`0m
FJ/0ooK^0?ofkP0:0?ofkPD000008P3om^h00`000000ooK^0?ofkP080?ofkP40oooo00090?ofkP03
0000003om^h0ooK^04/0ooK^00<0e3dI0?ofkP3om^h01@3om^h20=@m6@H0ooK^0P0000020?ofkP03
0=@m6@3om^h0ooK^0140ooK^00<0e3dI0?ofkP3om^h0303om^h20=@m6@80ooK^00<0e3dI0?ofkP3o
m^h01@3om^h703eIZ`D0ooK^00<0e3dI03eIZ`0mFJ/00P0mFJ/0103om^h0?EV[00000000000301HK
>@030000000F6cT05Q/i00805Q/i00<0000001HK>@0F6cT00P0F6cT00`0000005Q/i01HK>@0301HK
>@030000000F6cT0000000@000001P0P:EL00`00000082UG020YE`04020YE`030000000P:EL082UG
00D082UG00D000000=@m6@0P:EL082UG000000030=@m6@030000000W=Fh09cE^00D09cE^00<00000
0=@m6@0W=Fh01P0W=Fh00`0000009cE^02LeKP0502LeKP030=@m6@0W=Fh0000000H09cE^0P3D?AT2
000000030=@m6@000000;3in00H0;3in00@000000>]06@3[@1T0jd0I0P0000000`3D>AH000000=@i
5P040=@i5P030000000mFJ/0e3TF00<0e3TF00<000000=@i5P3D>AH00P0000000`2b;Q40?EV[03eI
Z`0203eIZ`070000002b;Q4000000;8^4@000000/RhA03eIZ`020000000608LQ3@000000Qb4=08LQ
3@000000Qb4=1@0000090?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h02P3om^h4
03eIZ`H0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP0303eIZ`3om^h0
ooK^01<0ooK^0`0mFJ/80?ofkP@00000:03om^h00`000000ooK^0?ofkP070?ofkP40oooo00090?of
kP030000003om^h0ooK^04/0ooK^00<0e3dI0?ofkP3om^h01`3om^h20=@m6@H0ooK^00<000000=@m
6@0000004P3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP<0e3dI103om^h703eIZ`D0ooK^0P0mFJ/00`3D
?AT0?EV[03eIZ`0403eIZ`030000000F6cT05Q/i00805Q/i00<0000001HK>@0F6cT00P0F6cT00`00
00005Q/i01HK>@0201HK>@030000000F6cT05Q/i00805Q/i10000004020YE`030000000P:EL082UG
00<082UG00<00000020YE`0P:EL0100P:EL00`00000082UG020YE`05020YE`030000000P:EL0e3dI
00800000100W=Fh20=@m6@H09cE^00<0000002LeKP3D?AT01P0W=Fh00`0000009cE^02LeKP0502Le
KP030=@m6@0W=Fh0000000D09cE^0`0000020=@m6@0302`nOP3D?AT0;3in00H0;3in00<000000>]0
6@3[@1T00`3[@1T2000000D0e3TF00<0?EV[0=@i5P3D>AH00`3D>AH00`000000?EV[03eIZ`0303eI
Z`0;0000002b;Q40/RhA0;8^4@000000/RhA0000002b;Q4000000;8^4@0mFJ/00P2b;Q4300000080
Qb4=00<0000008LQ3@000000100000080?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3o
m^h01@3om^h503eIZ`T0ooK^00<0?EV[0?ofkP3om^h0503om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP03
03eIZ`3om^h0ooK^00`0ooK^1P0mFJ/20?ofkP0403eIZ`3om^h0ooK^0?ofkPD00000;03om^h00`00
0000ooK^0?ofkP070?ofkP40oooo00090?ofkP030000003om^h0ooK^04/0ooK^00<0e3dI0?ofkP3o
m^h02@3om^h30=@m6@@0ooK^00@0e3dI0?ofkP0000000000403om^h00`3D?AT0ooK^0?ofkP0@0?of
kP040=@m6@3om^h0e3dI0=@m6@P0?EV[0`3om^h303eIZ`030?ofkP0mFJ/0e3dI0080?EV[0P3om^h2
000000<05Q/i0P00000301HK>@800000100F6cT00`0000005Q/i00000004000000H082UG00<00000
020YE`0P:EL0100P:EL00`00000082UG020YE`04020YE`030000000P:EL082UG00<082UG10000000
0`3D?AT09cE^02LeKP0302LeKP030000000W=Fh09cE^0080e3dI100W=Fh00`0000009cE^0=@m6@06
02LeKP030000000W=Fh09cE^00D09cE^00@0e3dI02LeKP0000009cE^1000000402`nOP040000003D
?AT0e3dI0=@m6@H0;3in00<000000>]06@3[@1T0103[@1T3000000<0e3TF00<0?EV[0=@i5P3D>AH0
100mFJ/50=@i5P<000000P2b;Q4200000080/RhA00H0000003eIZ`2b;Q40/RhA0000002b;Q420000
000608LQ3@000000Qb4=08LQ3@000000Qb4=0P0000000`1I4`P000000?ofkP040?ofkP0303eIZ`3o
m^h0ooK^00P0ooK^00@0?EV[0?ofkP3om^h0ooK^100mFJ/40?ofkP0303eIZ`3om^h0ooK^00L0ooK^
00<0?EV[0?ofkP3om^h0503om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP0303eIZ`3om^h0ooK^00L0ooK^
1@0mFJ/70?ofkP030000000mFJ/0000000800000<@3om^h00`000000ooK^0?ofkP070?ofkP40oooo
00080?ofkP030000003om^h0ooK^04/0ooK^00<0e3dI0?ofkP3om^h03@3om^h20=@m6@030?ofkP3D
?AT0ooK^00<0ooK^0`00000<0?ofkP030=@m6@3om^h0ooK^0100ooK^00<0e3dI03eIZ`0mFJ/00P0m
FJ/20=@m6@80ooK^00<0?EV[0?ofkP3om^h0200mFJ/00`3D?AT0?EV[0?ofkP020?ofkP030000000F
6cT05Q/i00805Q/i00<0000001HK>@0F6cT00P0F6cT00`0000005Q/i01HK>@020000000403eIZ`00
00000000000000<082UG00<00000020YE`0P:EL0100P:EL00`00000082UG020YE`04020YE`030000
000P:EL082UG00@082UG00<00000020YE`0P:EL01000000202LeKP030000003D?AT09cE^00D09cE^
00<0000002LeKP0W=Fh00P0W=Fh30=@m6@0402LeKP0000009cE^0=@m6@H09cE^00<0000002LeKP0W
=Fh01@0W=Fh0103D?AT0000000000000000802`nOP040000000/?Wh0e3dI02`nOP80e3dI100/?Wh0
0`000000jd0I0>]06@040>]06@030000003[@1T0jd0I00800000100mFJ/30=@i5P030000003D>AH0
e3TF00@0e3TF00H000000=@i5P00000000000;8^4@0000030;8^4@0503eIZ`2b;Q40/RhA0;8^4@00
00000P2b;Q400`000000Qb4=0000000208LQ3@03000000278@d0000000@000000`3om^h00`0mFJ/0
ooK^0?ofkP080?ofkP@0?EV[203om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^01@0
ooK^00<0?EV[0?ofkP3om^h0503om^h00`0mFJ/0ooK^0?ofkP0603eIZ`P0ooK^100000020?ofkP03
03eIZ`3om^h0ooK^0340ooK^00<000000?ofkP3om^h01`3om^h10?ooo`00203om^h00`000000ooK^
0?ofkP1;0?ofkP030=@m6@3om^h0ooK^00l0ooK^0`3D?AT60?ofkP8000002P3om^h00`3D?AT0ooK^
0?ofkP0<0?ofkP@0?EV[00<0e3dI03eIZ`3om^h0103om^h20=@m6@<0?EV[00<0ooK^03eIZ`0mFJ/0
0P0mFJ/20?ofkP060=@m6@0mFJ/0?EV[03eIZ`3om^h00000100F6cT0100000005Q/i01HK>@0F6cT5
0000008082UG00<00000020YE`0P:EL0100P:EL00`00000082UG020YE`04020YE`030000000P:EL0
82UG00<082UG00<00000020YE`0P:EL00`0P:EL5000000D09cE^00<0000002LeKP3D?AT01P0W=Fh0
0`0000009cE^02LeKP0502LeKP80e3dI00<09cE^0=@m6@0W=Fh01@0W=Fh00`0000009cE^02LeKP05
000000030=@m6@0/?Wh0000000T0;3in00<0000002`nOP3D?AT00`0/?Wh20=@m6@80;3in00<00000
0>]06@3[@1T0103[@1T00`000000?EV[03eIZ`0203eIZ`030000000mFJ/0000000D0e3TF00<00000
0=@i5P3D>AH00`3D>AH010000000e3TF0=@i5P3D>AH2000000<0/RhA00D0?EV[0;8^4@2b;Q40/RhA
000000030;8^4@<000000P278@d700000080ooK^00<0?EV[0?ofkP3om^h0103om^h403eIZ`030?of
kP0mFJ/0ooK^00T0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP0303eI
Z`3om^h0ooK^0180ooK^1@0mFJ/90?ofkPD000001P3om^h00`0mFJ/0ooK^0?ofkP0a0?ofkP030000
003om^h0ooK^00L0ooK^0@3oool000P0ooK^00<000000?ofkP3om^h0B`3om^h00`3D?AT0ooK^0?of
kP0@0?ofkP040=@m6@3om^h0e3dI0=@m6@H0ooK^0`0000060?ofkP030=@m6@3om^h0ooK^00T0ooK^
1P0mFJ/00`3om^h0e3dI0?ofkP030?ofkP@0?EV[00D0ooK^0=@m6@3D?AT0e3dI03eIZ`060?ofkP03
0=@m6@0mFJ/0ooK^008000000`0F6cT70000000303eIZ`0P:EL082UG008082UG00<00000020YE`0P
:EL0100P:EL00`00000082UG020YE`04020YE`030000000P:EL082UG00@082UG00<00000020YE`00
00000`00000202LeKP030000000W=Fh09cE^00D09cE^00<0000002LeKP3D?AT01P0W=Fh00`000000
9cE^02LeKP0502LeKP040000000W=Fh0e3dI0=@m6@@09cE^1@00000502`nOP030=@m6@0/?Wh00000
00T0;3in00<0000002`nOP3D?AT01@0/?Wh20=@m6@0402`nOP000000jd0I0>]06@@0?EV[00<00000
0>]06@3[@1T00P3[@1T00`0mFJ/00000000000040=@i5P030000003D>AH0e3TF00<0e3TF00<00000
0=@i5P3D>AH00P3D>AH3000000030;8^4@0mFJ/0000000<0/RhA00D000000;8^4@2b;Q4000000;8^
4@02000000030=@m6@278@d0Qb4=0080000000<0Qb4=0000000000000P0000000`0mFJ/0ooK^0?of
kP0403eIZ`H0ooK^00<0?EV[0?ofkP3om^h01P3om^h203eIZ`/0ooK^00<0?EV[0?ofkP3om^h04`3o
m^h00`0mFJ/0ooK^0?ofkP0>0?ofkP@0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP040?ofkPD000002`3o
m^h00`0mFJ/0ooK^0?ofkP0a0?ofkP030000003om^h0ooK^00L0ooK^0@3oool000P0ooK^00<00000
0?ofkP3om^h0BP3om^h00`3D?AT0ooK^0?ofkP0@0?ofkP030=@m6@3om^h0ooK^0080ooK^0`3D?AT6
0?ofkP<000000`3om^h00`3D?AT0ooK^0?ofkP050?ofkPT0?EV[0P3om^h00`3D?AT0?EV[03eIZ`02
03eIZ`030?ofkP0mFJ/0?EV[0080?EV[0`3om^h20=@m6@@0ooK^00@0e3dI03eIZ`3om^h000000`0F
6cT4000000<082UG00<00000020YE`0P:EL00`0P:EL00`00000082UG020YE`04020YE`030000000P
:EL082UG00@082UG00<00000020YE`0P:EL00`0P:EL4000000D09cE^00<0000002LeKP0W=Fh01P0W
=Fh00`0000009cE^0=@m6@0602LeKP030000000W=Fh09cE^00D09cE^00<0000002LeKP0W=Fh00`3D
?AT200000080;3in00<0000002`nOP0/?Wh01@0/?Wh00`3D?AT0;3in0000000902`nOP030000000/
?Wh0e3dI00L0;3in00@0e3dI03eIZ`0mFJ/0?EV[103[@1T00`000000jd0I0>]06@020>]06@0303eI
Z`000000jd0I008000000P3D>AH00`000000e3TF0=@i5P030=@i5P030000003D>AH0e3TF0080e3TF
0P0000000`3D>AH0000003eIZ`050;8^4@040000002b;Q40/RhA00000080/RhA00@000000=@m6@27
8@d0Qb4=0P00000010278@d0000000000000000303eIZ`X0ooK^00<0?EV[0?ofkP3om^h00P3om^h4
03eIZ`030?ofkP0mFJ/0ooK^00X0ooK^00<0?EV[0?ofkP3om^h0503om^h00`0mFJ/0ooK^0?ofkP09
0?ofkP@0?EV[1`3om^h00`0mFJ/0ooK^0000000300000100ooK^00<0?EV[0?ofkP3om^h0<@3om^h0
0`000000ooK^0?ofkP070?ofkP40oooo00080?ofkP030000003om^h0ooK^04X0ooK^00<0e3dI0?of
kP3om^h0403om^h00`3D?AT0ooK^0?ofkP050?ofkP80e3dI1`3om^h2000000030?ofkP3D?AT0ooK^
0080ooK^1@0mFJ/30?ofkP80?EV[0P3om^h203eIZ`030=@m6@0mFJ/0?EV[00@0?EV[2@3om^h20=@m
6@80ooK^00<0e3dI0000000000001@0000000`0mFJ/082UG020YE`02020YE`030000000P:EL082UG
00<082UG00<00000020YE`0P:EL0100P:EL00`00000082UG020YE`05020YE`030000000P:EL00000
00<0000000<09cE^0000000W=Fh01P0W=Fh00`0000009cE^02LeKP0502LeKP040000000W=Fh09cE^
0=@m6@H09cE^00<0000002LeKP0W=Fh0100W=Fh4000000030=@m6@0/?Wh0;3in0080e3dI0P0/?Wh0
0`000000;3in02`nOP0502`nOP030=@m6@0/?Wh0000000X0;3in00<0000002`nOP3D?AT01`0/?Wh0
0`000000jd0I0>]06@040>]06@030000003[@1T0jd0I0080jd0I00<0?EV[0000003[@1T00P3[@1T2
000000030=@i5P000000e3TF00@0e3TF00@000000=@i5P3D>AH0e3TF0P0000000`3D>AH0?EV[0=@i
5P02000000<0/RhA00D000000;8^4@2b;Q40/RhA000000020;8^4@030000003D?AT0000000@00000
00<0Qb4=0000000mFJ/00`00000:0?ofkP@0?EV[1@3om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eI
Z`3om^h0ooK^01@0ooK^00<0?EV[0?ofkP3om^h01@3om^h403eIZ`P0ooK^0`0000000`0mFJ/00000
0?ofkP0D0?ofkP0303eIZ`3om^h0ooK^0300ooK^00<000000?ofkP3om^h01`3om^h10?ooo`00203o
m^h00`000000ooK^0?ofkP1:0?ofkP030=@m6@3om^h0ooK^0100ooK^00<0e3dI0?ofkP3om^h01`3o
m^h20=@m6@L0ooK^00<0e3dI03eIZ`0mFJ/00`0mFJ/50?ofkPP0?EV[00<0e3dI03eIZ`3om^h00P3o
m^h303eIZ`X0ooK^103D?AT01@00000082UG020YE`0P:EL0000000D082UG00<00000020YE`0P:EL0
100P:EL00`00000082UG020YE`04020YE`030000000P:EL082UG008082UG1@00000402LeKP030000
000W=Fh09cE^00H09cE^00<0000002LeKP0W=Fh01@0W=Fh0100000009cE^02LeKP3D?AT502LeKP03
0000000W=Fh09cE^00809cE^0`0000001@0/?Wh0000002`nOP0/?Wh0e3dI00@0;3in0P3D?AT00`00
0000;3in02`nOP0502`nOP030=@m6@0/?Wh0000000X0;3in00<0000002`nOP3D?AT01`0/?Wh00`00
0000jd0I0>]06@040>]06@030000003[@1T0jd0I0080jd0I00<0?EV[0>]06@000000103[@1T30000
00@0e3TF00@000000=@i5P3D>AH0e3TF0P000000103D>AH0?EV[0=@i5P3D>AH300000080/RhA00@0
00000;8^4@2b;Q4000000`2b;Q400`000000/RhA0;8^4@020000000508LQ3@000000Qb4=03eIZ`27
8@d00`0000000`3D?AT0ooK^0?ofkP020?ofkPD0?EV[203om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP03
03eIZ`3om^h0ooK^01@0ooK^00<0?EV[0?ofkP3om^h0100mFJ/70?ofkPD000000`3om^h00`0mFJ/0
ooK^0?ofkP0D0?ofkP0303eIZ`3om^h0ooK^0300ooK^00<000000?ofkP3om^h01`3om^h10?ooo`00
203om^h00`000000ooK^0?ofkP1:0?ofkP030=@m6@3om^h0ooK^0100ooK^00<0e3dI0?ofkP3om^h0
2@3om^h30=@m6@@0?EV[00<0e3dI03eIZ`3om^h00P0000040?ofkPP0?EV[00<0ooK^0=@m6@3om^h0
0`3om^h0100mFJ/0ooK^0?ofkP3om^h303eIZ`H0ooK^0P0mFJ/00`3D?AT082UG020YE`03020YE`03
0000000P:EL082UG00<082UG00<00000020YE`0P:EL0100P:EL00`00000082UG020YE`04020YE`03
0000000P:EL0000000<000000P0W=Fh00`0000009cE^02LeKP0402LeKP030000000W=Fh09cE^00D0
9cE^00<0000002LeKP0W=Fh01P0W=Fh0100000009cE^02LeKP3D?AT502LeKP030000000W=Fh00000
00800000100/?Wh010000000;3in02`nOP3D?AT602`nOP80e3dI1`0/?Wh00`3D?AT0000002`nOP09
02`nOP030000000/?Wh0e3dI00L0;3in00<000000>]06@3[@1T0103[@1T00`000000jd0I0>]06@02
0>]06@0303eIZ`3[@1T0000000D0jd0I00@000000>]06@00000000000P3D>AH010000000e3TF0=@i
5P3D>AH2000000030=@i5P0mFJ/0e3TF0080e3TF00@000000=@i5P0000000000102b;Q4010000000
/RhA0;8^4@0000040;8^4@<0000000H0?EV[000000278@d0000008LQ3@00000403eIZ`@0ooK^00<0
?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^0180ooK^1@0m
FJ/70?ofkP@00000203om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP0303eIZ`3om^h0ooK^0300ooK^00<0
00000?ofkP3om^h01`3om^h10?ooo`00203om^h00`000000ooK^0?ofkP190?ofkP030=@m6@3om^h0
ooK^0100ooK^00<0e3dI0?ofkP3om^h02@3om^h403eIZ`80e3dI00<0?EV[0=@m6@0mFJ/0103om^h8
03eIZ`D0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP040?ofkPL0?EV[00<0e3dI
020YE`0P:EL00`0P:EL00`00000082UG020YE`04020YE`030000000P:EL082UG00<082UG00<00000
020YE`0P:EL00P0P:EL5000000D09cE^00<0000002LeKP0W=Fh01@0W=Fh00`0000009cE^02LeKP05
02LeKP030000000W=Fh09cE^00H09cE^00@0000002LeKP0W=Fh0e3dI0`0W=Fh4000000L0;3in00<0
000002`nOP3D?AT01`0/?Wh010000000;3in0=@m6@3D?AT502`nOP030=@m6@000000;3in00T0;3in
00<0000002`nOP3D?AT01@0/?Wh4000000D0jd0I00<000000>]06@3[@1T00P3[@1T00`0mFJ/0jd0I
000000050>]06@040000003[@1T0jd0I0>]06@80000000P0e3TF0000003D>AH0e3TF0000003D>AH0
000003eIZ`<0e3TF00@000000=@i5P3D>AH0e3TF0P0000030;8^4@040000002b;Q40/RhA000000<0
/RhA00D000000;8^4@000000?EV[08LQ3@0403eIZ`040000003D?AT0e3dI0=@m6@D0ooK^00<0?EV[
0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00h0ooK^100mFJ/2
0?ofkP0303eIZ`3om^h0ooK^0080ooK^1@00000=0?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[
0?ofkP3om^h0<03om^h00`000000ooK^0?ofkP070?ofkP40oooo00080?ofkP030000003om^h0ooK^
04T0ooK^00<0e3dI0?ofkP3om^h0403om^h00`3D?AT0ooK^0?ofkP050?ofkPD0?EV[103om^h0100m
FJ/0e3dI0=@m6@3D?AT803eIZ`030000003om^h0ooK^00H0ooK^00D0e3dI0?ofkP3om^h0ooK^03eI
Z`060?ofkPL0?EV[00<000000=@m6@0P:EL00`0P:EL00`00000082UG020YE`04020YE`030000000P
:EL082UG00<082UG00<00000020YE`0000000`00000202LeKP030000000W=Fh09cE^00D09cE^00<0
000002LeKP0W=Fh0100W=Fh00`0000009cE^02LeKP0602LeKP030000000W=Fh09cE^00D09cE^00D0
000002LeKP0W=Fh000000=@m6@0300000080;3in00<0000002`nOP0/?Wh01P0/?Wh00`000000;3in
0=@m6@0702`nOP040000000/?Wh0;3in02`nOP80e3dI0`0/?Wh00`3D?AT0000002`nOP0902`nOP03
0000000/?Wh0e3dI00D000000P0`A8/010000000nTDL0000000000040>]06@070000003[@1T0jd0I
0>]06@0mFJ/0jd0I000000050>]06@030000003[@1T0jd0I00<0jd0I0P0000020=@i5P040000003D
>AH0000003eIZ`@0e3TF00@000000=@i5P3D>AH0e3TF0`0000020;8^4@040000002b;Q40/RhA0000
00<0/RhA100mFJ/00`000000Qb4=00000004000000<0e3dI0`3om^h00`0mFJ/0ooK^0?ofkP060?of
kP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h02@3om^h403eIZ`L0ooK^00@0?EV[0000
0000000000004P3om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP0303eIZ`3om^h0ooK^02l0ooK^00<00000
0?ofkP3om^h01`3om^h10?ooo`00203om^h00`000000ooK^0?ofkP190?ofkP030=@m6@3om^h0ooK^
0100ooK^00<0e3dI0?ofkP3om^h00P3om^h303eIZ`P0ooK^00D0?EV[0?ofkP3om^h0e3dI03eIZ`02
0=@m6@@0ooK^0`0mFJ/3000000@0ooK^00D0e3dI0?ofkP3om^h0ooK^03eIZ`030?ofkPH0?EV[0`3o
m^h00`0mFJ/000000=@m6@05020YE`030000000P:EL082UG00<082UG00<00000020YE`0P:EL00P0P
:EL4000000D09cE^00<0000002LeKP0W=Fh01@0W=Fh00`0000009cE^02LeKP0502LeKP030000000W
=Fh09cE^00H09cE^00<0000002LeKP0W=Fh00`0W=Fh50000000302`nOP3D?AT0;3in00@0;3in00<0
000002`nOP0/?Wh01P0/?Wh00`000000;3in0=@m6@0702`nOP030000000/?Wh0;3in00<0;3in0P3D
?AT00`0/?Wh0e3dI0000000802`nOP@0000000<0e3dI0314R`0`A8/01@0`A8/010000000nTDL0?Y5
703jAA`3000000050>]06@000000jd0I0>]06@0mFJ/00P3[@1T00`000000jd0I0>]06@040>]06@03
0000003[@1T0jd0I00<0jd0I100000000`3D>AH0000003eIZ`040=@i5P030000003D>AH0e3TF0080
e3TF00@000000=@i5P00000000000`2b;Q4403eIZ`040;8^4@000000?EV[0;8^4@@0000000@0Qb4=
000000278@d00000103D?AT20?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h02P3o
m^h00`0mFJ/0ooK^0?ofkP050?ofkP@0?EV[1P3om^h50000000303eIZ`3om^h0ooK^01<0ooK^00<0
?EV[0?ofkP3om^h0503om^h00`0mFJ/0ooK^0?ofkP0_0?ofkP030000003om^h0ooK^00L0ooK^0@3o
ool000P0ooK^00<000000?ofkP3om^h0B@3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP040=@m6@3om^h0
ooK^0?ofkP80?EV[2@3om^h403eIZ`030=@m6@3om^h0ooK^0080ooK^0`3D?AT0100mFJ/0ooK^0?of
kP3om^h303eIZ`8000000P3om^h00`3D?AT0ooK^0?ofkP0703eIZ`L0ooK^00<00000020YE`3D?AT0
100P:EL00`00000082UG020YE`03020YE`030000000P:EL0000000<0000000<09cE^0000000W=Fh0
1P0W=Fh00`0000009cE^02LeKP0502LeKP030000000W=Fh09cE^00@09cE^00<0000002LeKP0W=Fh0
1P0W=Fh00`0000009cE^02LeKP0400000080;3in00@0000002`nOP0/?Wh0e3dI1@0/?Wh00`000000
;3in02`nOP0702`nOP030000000/?Wh0e3dI00L0;3in00<0000002`nOP0/?Wh01@0/?Wh30=@m6@80
;3in1P0000020314R`030000000`A8/0e3dI00L0<4B;00<000000?Y5703jAA`0103jAA`300000005
0>]06@0mFJ/0jd0I0>]06@0000001P3[@1T00`000000jd0I0>]06@030>]06@030000003[@1T0jd0I
0080000000<0e3TF03eIZ`3D>AH00`3D>AH00`000000e3TF0=@i5P020=@i5P030000003D>AH0?EV[
00@0?EV[00<0/RhA0000002b;Q400P2b;Q401P000000?EV[0;8^4@2b;Q4000000;8^4@80000000@0
Qb4=000000278@d000001@3D?AT00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00/0ooK^
00<0?EV[0?ofkP3om^h0100mFJ/50?ofkPD000001@3om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP0303eI
Z`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h0;`3om^h00`000000ooK^0?ofkP070?ofkP40oooo
00080?ofkP030000003om^h0ooK^04P0ooK^00<0e3dI0?ofkP3om^h0403om^h0103D?AT0ooK^0?of
kP0mFJ/80?ofkP@0?EV[0`3om^h00`3D?AT0ooK^0?ofkP050?ofkP<0e3dI103om^h203eIZ`030000
003D?AT0?EV[00D0?EV[2P3om^h00`00000082UG020YE`04020YE`030000000P:EL082UG008082UG
1000000402LeKP030000000W=Fh09cE^00D09cE^00<0000002LeKP0W=Fh01@0W=Fh00`0000009cE^
02LeKP0502LeKP030000000W=Fh09cE^00D09cE^1000000602`nOP040000000/?Wh0;3in0=@m6@D0
;3in00<0000002`nOP0/?Wh01`0/?Wh00`000000;3in0=@m6@0702`nOP030000000/?Wh0;3in00H0
;3in00@0e3dI0000003D?AT0e3dI200`A8/00`000000<4B;0=@m6@070314R`030000003jAA`0nTDL
00D0nTDL00@000000?Y570000000?EV[0`3[@1T00`000000jd0I0>]06@030>]06@030000003[@1T0
jd0I00<0jd0I00P000000>]06@3[@1T000000>]06@000000?EV[000000@0e3TF00<0000003eIZ`0m
FJ/00`0mFJ/30=@i5P050000003D>AH000000000003D?AT00`2b;Q40100mFJ/0/RhA0;8^4@000003
0;8^4@<0000000<0Qb4=0000003D?AT00`3D?AT00`0mFJ/0e3dI0?ofkP050?ofkP0303eIZ`3om^h0
ooK^00T0ooK^1@0mFJ/50?ofkP@000002P3om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP0303eIZ`3om^h0
ooK^01<0ooK^00<0?EV[0?ofkP3om^h0;`3om^h00`000000ooK^0?ofkP070?ofkP40oooo00080?of
kP030000003om^h0ooK^04P0ooK^0P3D?ATA0?ofkP030=@m6@0mFJ/0?EV[00D0ooK^100mFJ/00`3o
m^h0?EV[0?ofkP040?ofkP030=@m6@3om^h0ooK^00@0ooK^00@0?EV[0?ofkP3om^h0ooK^0P3D?AT2
0?ofkP<0?EV[00@0e3dI03eIZ`0mFJ/00000303om^h00`00000082UG020YE`04020YE`030000000P
:EL0000000@000001`0W=Fh00`0000009cE^02LeKP0502LeKP030000000W=Fh09cE^00D09cE^00<0
000002LeKP0W=Fh01@0W=Fh00`0000009cE^02LeKP0202LeKP<0000000<0;3in0000000/?Wh01P0/
?Wh01@000000;3in02`nOP0/?Wh0e3dI00D0;3in00<0000002`nOP0/?Wh01`0/?Wh00`000000;3in
0=@m6@0702`nOP030000000/?Wh0;3in00<0;3in0`000000103D?AT000000314R`0`A8/20=@m6@H0
<4B;00<000000314R`3D?AT01`0`A8/00`000000nTDL0?Y570050?Y570040000003jAA`0nTDL03eI
Z`80000000<0jd0I0000003[@1T0103[@1T00`000000jd0I0>]06@040>]06@030000003[@1T00000
0080jd0I00<0?EV[0>]06@000000100mFJ/40=@i5P030000003D>AH0e3TF0080e3TF00<000000=@i
5P3D>AH00P0000020;8^4@0503eIZ`000000/RhA0;8^4@0000000P2b;Q401`000000/RhA00000000
0000Qb4=0000003D?AT00P3om^h0103D?AT0?EV[0=@m6@3D?AT40?ofkP0303eIZ`3om^h0ooK^00@0
ooK^1@0mFJ/20?ofkP0303eIZ`3om^h0ooK^00D000003`3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP03
03eIZ`3om^h0ooK^01@0ooK^00<0?EV[0?ofkP3om^h0;P3om^h00`000000ooK^0?ofkP070?ofkP40
oooo00080?ofkP030000003om^h0ooK^04P0ooK^00@0e3dI0?ofkP3D?AT0e3dI3`3om^h0103D?AT0
ooK^0?ofkP3om^h403eIZ`@0ooK^00<0?EV[0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP030?of
kP0303eIZ`3om^h0ooK^0080ooK^0P0mFJ/30=@m6@030?ofkP3D?AT0ooK^0080?EV[00@0ooK^0000
000000000000203om^h00`00000082UG020YE`02020YE`D00000100W=Fh00`0000009cE^02LeKP04
02LeKP030000000W=Fh09cE^00D09cE^00<0000002LeKP0W=Fh01@0W=Fh00`0000009cE^02LeKP05
02LeKP030000000W=Fh0000000<000000`0/?Wh00`000000;3in02`nOP0602`nOP050000000/?Wh0
;3in02`nOP3D?AT01@0/?Wh00`000000;3in02`nOP0702`nOP030000000/?Wh0e3dI00L0;3in00<0
000002`nOP0000000`0000030314R`030=@m6@000000<4B;00<0<4B;0P3D?AT40314R`040000000`
A8/0<4B;0=@m6@H0<4B;00<000000?Y5703jAA`01@3jAA`010000000nTDL0?Y5700mFJ/20?Y57080
00001@3[@1T00`000000jd0I0>]06@040>]06@030000003[@1T0000000D0?EV[00D0jd0I00000000
0000e3TF000000030=@i5P030000003D>AH0e3TF0080e3TF00@000000=@i5P3D>AH0e3TF0`000000
0`2b;Q40?EV[000000020;8^4@040000002b;Q40/RhA00000080/RhA0P0000001@278@d000000?of
kP3om^h0?EV[00@0e3dI0P3om^h00`0mFJ/0ooK^03eIZ`0403eIZ`D0ooK^0`0000000`0mFJ/00000
0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^01@0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^
0?ofkP0_0?ofkP030000003om^h0ooK^00H0ooK^0@3oool000P0ooK^00<000000?ofkP3om^h0B03o
m^h0103D?AT0ooK^0?ofkP3om^h30=@m6@X0ooK^00<0?EV[0=@m6@0mFJ/00`0mFJ/70?ofkP0303eI
Z`3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`0mFJ/0ooK^03eIZ`0303eIZ`D0ooK^
0`3D?AT303eIZ`<0ooK^0P0000050?ofkP030000000P:EL0000000<0000000<09cE^0000000W=Fh0
1@0W=Fh00`0000009cE^02LeKP0502LeKP030000000W=Fh09cE^00D09cE^00<0000002LeKP0W=Fh0
1@0W=Fh00`0000009cE^02LeKP0302LeKP@000001`0/?Wh00`000000;3in02`nOP0602`nOP040000
000/?Wh0;3in02`nOP80e3dI100/?Wh00`000000;3in02`nOP0702`nOP030000000/?Wh0e3dI00D0
;3in100000070314R`030=@m6@000000<4B;00D0<4B;0P3D?AT20314R`040000000`A8/0<4B;0=@m
6@L0<4B;00<000000?Y5703jAA`0103jAA`010000000nTDL0?Y5700mFJ/30?Y570<000000`3[@1T0
0`3D?AT0jd0I0>]06@030>]06@<0?EV[00D000000>]06@3[@1T0?EV[000000040>]06@800000103D
>AH00`000000e3TF0=@i5P020=@i5P090000003D>AH0e3TF0=@i5P000000e3TF0000000mFJ/00000
00<0/RhA00@000000;8^4@2b;Q4000000P2b;Q44000000050=@m6@3om^h0?EV[0?ofkP3D?AT01@0m
FJ/60?ofkP@000000`3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^01@0ooK^00<0
?EV[0?ofkP3om^h04@3om^h303eIZc40ooK^00<000000?ofkP3om^h01P3om^h10?ooo`00203om^h0
0`000000ooK^0?ofkP180?ofkP030=@m6@3om^h0ooK^00@0ooK^0P3D?AT70?ofkP80?EV[00<0e3dI
0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP050?ofkP040=@m6@3om^h0ooK^0?ofkP@0?EV[2P3o
m^h01P3D?AT0ooK^0=@m6@3D?AT0ooK^03eIZ`@0ooK^0`000000103om^h0000000000000000502Le
KP030000000W=Fh09cE^00@09cE^00<0000002LeKP0W=Fh0100W=Fh00`0000009cE^02LeKP0502Le
KP030000000W=Fh09cE^00D09cE^00<0000002LeKP0W=Fh01000000202`nOP030000000/?Wh0;3in
00H0;3in00<0000002`nOP0/?Wh01P0/?Wh01P000000;3in02`nOP0/?Wh0e3dI02`nOP80e3dI0P0/
?Wh00`000000;3in02`nOP0702`nOP030000000/?Wh0e3dI00D000000P0`A8/00`000000<4B;0314
R`050314R`030=@m6@0`A8/0000000P0<4B;0P3D?AT010000000<4B;0314R`3D?AT70314R`030000
003jAA`0nTDL00@0nTDL00@000000?Y5703jAA`0?EV[0`3jAA`00`000000nTDL0?Y5700200000003
0>]06@3D?AT0000000@0?EV[00@0jd0I0000003[@1T000000P3[@1T00`0mFJ/000000>]06@040>]0
6@<0000000<0e3TF0=@m6@000000103D>AH01@000000e3TF0=@i5P3D>AH000000080e3TF00<0?EV[
0000000000000`2b;Q4010000000/RhA0;8^4@0000020;8^4@050000002b;Q4000000000003D?AT0
0`0mFJ/30=@m6@0303eIZ`3D?AT0ooK^00D000001`3om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP0303eI
Z`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h0303om^h503eIZ`80ooK^00<0?EV[0?ofkP3om^h0
;`3om^h00`000000ooK^0?ofkP060?ofkP40oooo00070?ofkP030000003om^h0ooK^04T0ooK^00<0
e3dI0?ofkP3om^h01P3om^h20=@m6@@0ooK^00@0?EV[0?ofkP3om^h0e3dI2P3om^h00`0mFJ/0ooK^
0?ofkP050?ofkP030=@m6@0mFJ/0?EV[0080?EV[303om^h00`3D?AT0ooK^03eIZ`020?ofkP80e3dI
00<0?EV[0?ofkP3om^h0103om^h00`0000009cE^02LeKP0502LeKP030000000W=Fh09cE^00@09cE^
00<0000002LeKP0W=Fh01@0W=Fh00`0000009cE^02LeKP0502LeKP030000000W=Fh09cE^00<09cE^
1@00000602`nOP030000000/?Wh0;3in00H0;3in00<0000002`nOP0/?Wh01P0/?Wh010000000;3in
02`nOP3D?AT402`nOP80e3dI2@0/?Wh3000000030=@m6@0`A8/0<4B;00D0<4B;00<000000314R`0`
A8/01@0`A8/00`3D?AT0<4B;0000000:0314R`80e3dI00<0<4B;0=@m6@0`A8/01P0`A8/00`000000
nTDL0?Y570040?Y570040000003jAA`0nTDL03eIZ`<0nTDL00<000000?Y5703jAA`01@0mFJ/50>]0
6@030000003[@1T000000080jd0I00<0?EV[0000003[@1T0103[@1T01P000000jd0I0>]06@000000
e3TF000000D0e3TF00P000000=@i5P3D>AH0e3TF0000003D>AH0?EV[0=@i5P<0000000D0/RhA0000
002b;Q40/RhA000000020;8^4@030000002b;Q40/RhA00<0?EV[00<0ooK^0=@m6@3D?AT00P3D?AT0
100mFJ/0e3dI0=@m6@3D?AT<0?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h04`3o
m^h00`0mFJ/0ooK^0?ofkP060?ofkPH0?EV[1`3om^h00`0mFJ/0ooK^0?ofkP0_0?ofkP030000003o
m^h0ooK^00H0ooK^0@3oool000L0ooK^00<000000?ofkP3om^h0B03om^h00`3D?AT0ooK^0?ofkP09
0?ofkP<0e3dI00D0?EV[0?ofkP3om^h0ooK^0=@m6@090?ofkP0303eIZ`3om^h0ooK^00<0ooK^0P0m
FJ/00`3D?AT0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0e3dI0?ofkP0mFJ/0103o
m^h30=@m6@@0ooK^00<0000002LeKP0W=Fh0100W=Fh00`0000009cE^02LeKP0502LeKP030000000W
=Fh09cE^00@09cE^00<0000002LeKP0W=Fh01@0W=Fh00`0000009cE^02LeKP0400000080;3in00<0
000002`nOP0/?Wh01@0/?Wh00`000000;3in02`nOP0602`nOP030000000/?Wh0;3in00L0;3in00@0
000002`nOP0/?Wh0e3dI1@0/?Wh00`000000e3dI0=@m6@0302`nOP@0000000<0<4B;0000003D?AT0
200`A8/00`000000<4B;0314R`050314R`030=@m6@0`A8/0000000X0<4B;00<000000314R`3D?AT0
0P3D?AT60314R`030000003jAA`0nTDL00@0nTDL00@000000?Y5703jAA`0?EV[0P3jAA`403eIZ`@0
nTDL0P0000040>]06@030000003[@1T000000080jd0I00<0?EV[0000003[@1T01@3[@1T00`000000
jd0I0>]06@03000000@0e3TF00L000000=@i5P3D>AH0e3TF0000003D>AH0?EV[0080e3TF00<00000
0=@i5P0000000P0000020;8^4@040000002b;Q40/RhA000000<0/RhA00@0000003eIZ`0000000000
0P3D?AT00`0mFJ/0e3dI0=@m6@030=@m6@X0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^
0?ofkP0D0?ofkP0303eIZ`3om^h0ooK^00D0?EV[3P3om^h00`0mFJ/0ooK^0?ofkP0^0?ofkP030000
003om^h0ooK^00H0ooK^0@3oool000L0ooK^00<000000?ofkP3om^h0B03om^h00`3D?AT0ooK^0?of
kP0;0?ofkP0503eIZ`3D?AT0e3dI0?ofkP3D?AT02@3om^h0100mFJ/0ooK^0?ofkP3om^h303eIZ`80
ooK^00D0e3dI0?ofkP3om^h0ooK^03eIZ`0=0?ofkP030=@m6@0mFJ/0ooK^00H0ooK^00D0?EV[0=@m
6@3D?AT0ooK^0000000702LeKP030000000W=Fh09cE^00@09cE^00<0000002LeKP0W=Fh01@0W=Fh0
0`0000009cE^02LeKP0302LeKPD000001@0/?Wh00`000000;3in02`nOP0602`nOP030000000/?Wh0
;3in00H0;3in00<0000002`nOP0/?Wh01P0/?Wh01@000000;3in02`nOP0/?Wh0e3dI00D0;3in00<0
000002`nOP0000000P3D?AT00`000000<4B;0314R`030314R`030000003D?AT0<4B;00L0<4B;00<0
00000314R`0`A8/01@0`A8/00`3D?AT0<4B;0000000:0314R`050000000`A8/0<4B;0=@m6@0`A8/0
0P3D?AT40314R`030000003jAA`0nTDL00@0nTDL00<0000003eIZ`0mFJ/00`0mFJ/00`3jAA`00000
0?Y570050?Y570040000003jAA`00000000000<0jd0I0P0000030>]06@0303eIZ`000000jd0I00@0
jd0I00<000000>]06@3[@1T00P3[@1T2000000@0e3TF00H000000=@i5P3D>AH0e3TF0000000mFJ/2
0=@i5P040000003D>AH0e3TF0=@i5P8000000P2b;Q4010000000/RhA0;8^4@0000020;8^4@030000
000mFJ/0ooK^00<0ooK^00@0e3dI03eIZ`3om^h0ooK^0`3D?AT90?ofkP0303eIZ`3om^h0ooK^01@0
ooK^00<0?EV[0?ofkP3om^h04@3om^h503eIZa<0ooK^00<0?EV[0?ofkP3om^h0;P3om^h00`000000
ooK^0?ofkP060?ofkP40oooo00070?ofkP030000003om^h0ooK^04P0ooK^00<0e3dI0?ofkP3om^h0
2P3om^h0100mFJ/0ooK^0?ofkP3om^h30=@m6@L0ooK^1@0mFJ/50?ofkP050=@m6@3om^h0ooK^0?of
kP0mFJ/03@3om^h00`3D?AT0?EV[0?ofkP080?ofkP0303eIZ`3D?AT0e3dI00H09cE^00<0000002Le
KP0W=Fh01@0W=Fh00`0000009cE^02LeKP0402LeKP030000000W=Fh09cE^00@000000P0/?Wh00`00
0000;3in02`nOP0502`nOP030000000/?Wh0;3in00H0;3in00<0000002`nOP0/?Wh01P0/?Wh00`00
0000;3in02`nOP0602`nOP050000000/?Wh0;3in02`nOP3D?AT00`0/?Wh4000000<0<4B;0P3D?AT4
0314R`030000003D?AT0<4B;00L0<4B;00<000000314R`0`A8/01@0`A8/00`3D?AT0<4B;0000000:
0314R`040000000`A8/0<4B;0=@m6@<0<4B;0P3D?AT20314R`030000003jAA`0nTDL00D0?EV[0P3j
AA`01@0mFJ/0nTDL0?Y5703jAA`0000000H0nTDL00@000000?Y5703jAA`0nTDL0P0000000`3[@1T0
0000000000030>]06@0303eIZ`000000jd0I00@0jd0I00<000000>]06@3[@1T00P3[@1T010000000
jd0I0000000000020=@i5P060000003D>AH0e3TF0=@i5P000000?EV[0`3D>AH00`000000e3TF0=@i
5P020=@i5P80000000D0/RhA0000002b;Q40/RhA000000020;8^4@030000000mFJ/0e3dI00<0ooK^
00<0?EV[0=@m6@3D?AT00P3om^h30=@m6@L0ooK^00<0?EV[0?ofkP3om^h0503om^h00`0mFJ/0ooK^
0?ofkP0=0?ofkP@0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^02h0ooK^
00<000000?ofkP3om^h01P3om^h10?ooo`001`3om^h00`000000ooK^0?ofkP180?ofkP030=@m6@3o
m^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`3D?AT0ooK^0=@m6@020=@m6@030?ofkP0m
FJ/0?EV[0080?EV[203om^h01@3D?AT0ooK^0?ofkP3om^h0?EV[00d0ooK^00<0e3dI03eIZ`3om^h0
2@3om^h303eIZ`H09cE^00<0000002LeKP0W=Fh0100W=Fh00`0000009cE^02LeKP0302LeKPD00000
1@0/?Wh00`000000;3in02`nOP0602`nOP030000000/?Wh0;3in00H0;3in00<0000002`nOP0/?Wh0
1P0/?Wh00`000000;3in02`nOP0602`nOP040000000/?Wh0;3in0=@m6@@000000P0`A8/00`000000
<4B;0314R`040314R`80e3dI0P0`A8/00`000000e3dI0314R`070314R`030000000`A8/0<4B;00D0
<4B;00<0e3dI0314R`0000002P0`A8/010000000<4B;0314R`3D?AT50314R`80e3dI00<0000003eI
Z`0mFJ/0103jAA`010000000nTDL0?Y5700mFJ/40?Y570030000003jAA`0nTDL00<0nTDL00<00000
0?Y5703jAA`00`3jAA`3000000<0jd0I00<0?EV[0000003[@1T0103[@1T00`000000jd0I0>]06@02
0>]06@040000003[@1T0jd0I0>]06@80000000<0e3TF0000003D>AH00P3D>AH01@0mFJ/0e3TF0=@i
5P3D>AH0000000@0e3TF00@000000=@i5P00000000000`2b;Q4010000000/RhA0;8^4@0mFJ/40=@m
6@0303eIZ`3D?AT0e3dI00L0e3dI1P3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^
00T0ooK^100mFJ/60?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h0;P3om^h00`00
0000ooK^0?ofkP060?ofkP40oooo00070?ofkP030000003om^h0ooK^04P0ooK^00<0e3dI0?ofkP3o
m^h02@3om^h00`0mFJ/0ooK^0?ofkP030?ofkP030=@m6@3om^h0?EV[0080?EV[0`3D?AT:0?ofkP05
0=@m6@3om^h0ooK^0?ofkP0mFJ/03@3om^h00`3D?AT0?EV[0?ofkP050?ofkP@0?EV[00<0000002Le
KP0W=Fh01@0W=Fh00`0000009cE^02LeKP0502LeKP030000000W=Fh0000000<000000P0/?Wh00`00
0000;3in02`nOP0502`nOP030000000/?Wh0;3in00H0;3in00<0000002`nOP0/?Wh01P0/?Wh00`00
0000;3in02`nOP0502`nOP030000000/?Wh0;3in00D0;3in1@0000000`3D?AT0<4B;0314R`040314
R`030000000`A8/0<4B;00H0<4B;0P3D?AT00`000000e3dI0314R`070314R`030000000`A8/0<4B;
00D0<4B;00<0e3dI0314R`0000002P0`A8/010000000<4B;0314R`3D?AT500000080=4VE00@00000
0?m97@00000000000`3jAA`010000000nTDL0?Y5700mFJ/40?Y570030000003jAA`0nTDL00<0nTDL
00<000000?Y5703jAA`0103jAA`4000000030>]06@0mFJ/0e3dI00H0jd0I00<000000>]06@3[@1T0
0P3[@1T00`000000jd0I0>]06@020>]06@8000000`3D>AH00`0mFJ/0e3TF0=@i5P020=@i5P030000
003D>AH0e3TF0080e3TF00@000000=@i5P3D>AH000000`2b;Q4010000000/RhA03eIZ`0000020?of
kP040=@m6@0mFJ/0ooK^0=@m6@<0ooK^1P3D?AT40?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[
0?ofkP3om^h01@3om^h403eIZ`/0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP0]
0?ofkP030000003om^h0ooK^00H0ooK^0@3oool000L0ooK^00<000000?ofkP3om^h0B03om^h00`3D
?AT0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^0080ooK^0P0mFJ/00`3D?AT0?EV[0?ofkP040?of
kP0303eIZ`3D?AT0e3dI00P0ooK^00@0e3dI0?ofkP3om^h0?EV[3P3om^h00`3D?AT0ooK^0?ofkP05
03eIZ`@0ooK^00<0000002LeKP0W=Fh0100W=Fh00`0000009cE^02LeKP0302LeKPD000001@0/?Wh0
0`000000;3in02`nOP0602`nOP030000000/?Wh0;3in00D0;3in00<0000002`nOP0/?Wh01`0/?Wh0
0`000000;3in02`nOP0502`nOP030000000/?Wh0;3in00D000000P0`A8/010000000<4B;0314R`3D
?AT60314R`030000000`A8/0<4B;00P0<4B;0`3D?AT70314R`030000000`A8/0<4B;00D0<4B;00<0
e3dI0314R`0000002@0`A8/3000000030=@m6@0dBID0=4VE00H0=4VE00@000000?m97@3oBAd0odTM
0P0000001@3jAA`0e3dI0?Y5703jAA`0?EV[00@0nTDL00<000000?Y5703jAA`00`3jAA`00`000000
nTDL0?Y570040?Y5708000000P3jAA`010000000?EV[0>]06@0000050>]06@030000003[@1T0jd0I
0080jd0I00<000000>]06@3[@1T00`3[@1T3000000030=@i5P0mFJ/0000000<0e3TF00<000000=@i
5P3D>AH00P3D>AH010000000e3TF0=@i5P3D>AH2000000030;8^4@000000/RhA0080/RhA00@00000
03eIZ`0mFJ/0?EV[0`3D?AT40?ofkPH0e3dI0P3om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP0303eIZ`3o
m^h0ooK^00@0?EV[3`3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^02d0ooK^00<0
00000?ofkP3om^h01P3om^h10?ooo`001`3om^h00`000000ooK^0?ofkP180?ofkP030=@m6@3om^h0
ooK^00L0ooK^00<0?EV[0?ofkP0mFJ/00`0mFJ/20?ofkP030=@m6@3om^h0ooK^00<0ooK^00@0?EV[
0?ofkP3om^h0ooK^0`3D?AT50?ofkP040=@m6@3om^h0ooK^03eIZ``0ooK^00<0?EV[0=@m6@0mFJ/0
0P0mFJ/80?ofkP030000000W=Fh09cE^00D09cE^00<0000002LeKP0000000`00000202`nOP030000
000/?Wh0;3in00D0;3in00<0000002`nOP0/?Wh01@0/?Wh00`000000;3in02`nOP0602`nOP030000
000/?Wh0;3in00H0;3in00<0000002`nOP0/?Wh01@0/?Wh4000000L0<4B;00@000000314R`0`A8/0
e3dI1P0`A8/00`000000<4B;0314R`070314R`040000000`A8/0e3dI0314R`80e3dI1@0`A8/00`00
0000<4B;0314R`050314R`030=@m6@0`A8/0000000D0<4B;10000000100dBID0000003A9U@3D?AT8
03A9U@030000003oBAd0odTM00<0odTM0`0000020?Y5700503eIZ`3jAA`0nTDL0?Y5700000001@3j
AA`00`000000nTDL0?Y570040?Y5708000000`3jAA`0100mFJ/000000000000000040>]06@030000
003[@1T0jd0I0080jd0I00<000000>]06@3[@1T00`3[@1T00`000000jd0I0>]06@020000000303eI
Z`3D>AH0e3TF0080e3TF00<000000=@i5P3D>AH00P3D>AH01@000000e3TF0=@i5P000000e3TF0080
0000100mFJ/00`000000ooK^03eIZ`020?ofkP<0e3dI0`3om^h00`3D?AT0ooK^0?ofkP040=@m6@03
0?ofkP0mFJ/0ooK^0180ooK^1@0mFJ/C0?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3o
m^h0;@3om^h00`000000ooK^0?ofkP060?ofkP40oooo00070?ofkP030000003om^h0ooK^04P0ooK^
00<0e3dI0?ofkP3om^h01P3om^h303eIZ`D0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`0mFJ/0ooK^
0?ofkP050?ofkP<0e3dI00D0ooK^0=@m6@3om^h0ooK^03eIZ`090?ofkP@0?EV[00<0ooK^0=@m6@0m
FJ/02P3om^h00`0000009cE^02LeKP0302LeKP@000001@0/?Wh00`000000;3in02`nOP0602`nOP03
0000000/?Wh0;3in00D0;3in00<0000002`nOP0/?Wh01P0/?Wh00`000000;3in02`nOP0602`nOP03
0000000/?Wh0;3in0080;3in0`0000000`0`A8/000000314R`080314R`030000000`A8/0e3dI00L0
<4B;00<000000314R`0`A8/01`0`A8/00`000000e3dI0314R`030314R`80e3dI0`0`A8/00`000000
<4B;0314R`050314R`040=@m6@0`A8/000000314R`@000001@0dBID00`000000=4VE0=@m6@0803A9
U@030000003oBAd0odTM00@0odTM00D000000?m97@000000000003eIZ`030?Y570030000003jAA`0
nTDL00@0nTDL00<000000?Y5703jAA`00`3jAA`2000000<0nTDL00@0?EV[0?Y570000000nTDL0P00
00020>]06@030000003[@1T0jd0I0080jd0I00<000000>]06@3[@1T0103[@1T01P000000jd0I0>]0
6@3[@1T0?EV[000000<0e3TF00<000000=@i5P3D>AH00P3D>AH00`000000e3TF03eIZ`0403eIZ`<0
000000@0/RhA0000003om^h0?EV[103om^h30=@m6@80ooK^0P3D?AT20?ofkP<0e3dI00<0?EV[0?of
kP3om^h0303om^h503eIZ`80ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP0C0?of
kP0303eIZ`3om^h0ooK^02d0ooK^00<000000?ofkP3om^h01P3om^h10?ooo`001`3om^h00`000000
ooK^0?ofkP180?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`3D?AT0
ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00P0ooK^0`3D?AT00`3om^h0?EV[0?ofkP040?ofkP@0
?EV[1@3om^h00`3D?AT0ooK^0?ofkP080?ofkP040000000W=Fh09cE^02LeKP<0000000<0;3in0000
000/?Wh01P0/?Wh00`000000;3in02`nOP0502`nOP030000000/?Wh0;3in00H0;3in00<0000002`n
OP0/?Wh01P0/?Wh00`000000;3in02`nOP0602`nOP030000000/?Wh0000000800000100`A8/00`00
0000<4B;0314R`070314R`030000000`A8/0e3dI00L0<4B;00<000000314R`0`A8/01`0`A8/00`00
0000e3dI0314R`050314R`80e3dI00<0<4B;0000000`A8/01@0`A8/00`3D?AT00000000000020000
00T0=4VE00<0000003A9U@3D?AT0200dBID00`000000odTM0?m97@040?m97@050000003oBAd0odTM
0?m97@0mFJ/00P0000000`3jAA`000000?Y570050?Y570030000003jAA`0nTDL00<0nTDL0P000003
0?Y5700303eIZ`3jAA`0000000<0nTDL0P0000000`3[@1T000000>]06@030>]06@030000003[@1T0
jd0I00<0jd0I00D000000>]06@3[@1T0jd0I03eIZ`0300000080e3TF00<0000003eIZ`0mFJ/00`0m
FJ/30=@i5P040000003D>AH0e3TF0=@i5P@0000000<0ooK^03eIZ`3om^h00P3om^h00`3D?AT0ooK^
0?ofkP020=@m6@80ooK^00L0e3dI0?ofkP3om^h0ooK^0=@m6@0mFJ/0e3dI00L0ooK^1P0mFJ/70?of
kP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h0503om^h00`0mFJ/0ooK^0?ofkP0/0?of
kP030000003om^h0ooK^00H0ooK^0@3oool000L0ooK^00<000000?ofkP3om^h0A`3om^h00`3D?AT0
ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`0mFJ/0
ooK^0?ofkP0:0?ofkP050=@m6@3om^h0e3dI0=@m6@3om^h0100mFJ/80?ofkP030=@m6@0mFJ/0ooK^
00T0ooK^1000000302`nOP030000000/?Wh0;3in00H0;3in00<0000002`nOP0/?Wh01@0/?Wh00`00
0000;3in02`nOP0502`nOP030000000/?Wh0;3in00H0;3in00<0000002`nOP0/?Wh01@0/?Wh40000
00L0<4B;00<000000314R`0`A8/01`0`A8/00`000000<4B;0=@m6@070314R`030000000`A8/0<4B;
00L0<4B;00<000000=@m6@0`A8/01`0`A8/30=@m6@030314R`00000000000080000000@0e3dI03A9
U@0dBID000002P0dBID00`000000=4VE0=@m6@0803A9U@030000003oBAd0odTM00@0odTM00D00000
0?m97@3oBAd0odTM03eIZ`020?m97@8000001P3jAA`00`000000nTDL0?Y570030?Y5708000000`3j
AA`00`0mFJ/0nTDL000000050?Y570800000103[@1T00`000000jd0I0>]06@030>]06@070000003[
@1T0jd0I0>]06@0mFJ/000000>]06@0403eIZ`@0e3TF00D000000=@i5P3D>AH0e3TF000000030=@i
5P030000003D>AH0e3TF0080000000<0?EV[0?ofkP3om^h00P3om^h0103D?AT0ooK^0?ofkP3om^h2
0=@m6@030?ofkP3D?AT0ooK^00<0ooK^00<0?EV[0=@m6@3D?AT01@0mFJ/>0?ofkP0303eIZ`3om^h0
ooK^0180ooK^00<0?EV[0?ofkP3om^h0503om^h00`0mFJ/0ooK^0?ofkP0/0?ofkP030000003om^h0
ooK^00H0ooK^0@3oool000L0ooK^00<000000?ofkP3om^h0A`3om^h00`3D?AT0ooK^0?ofkP050?of
kP0303eIZ`3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP0:0?of
kP040=@m6@0mFJ/0?EV[03eIZ`<0e3dI2P3om^h00`3D?AT0?EV[0?ofkP080?ofkP8000001P0/?Wh0
0`000000;3in02`nOP0502`nOP030000000/?Wh0;3in00H0;3in00<0000002`nOP0/?Wh01@0/?Wh0
0`000000;3in02`nOP0602`nOP030000000/?Wh0;3in00D000000P0`A8/00`000000<4B;0314R`06
0314R`030000000`A8/0<4B;00L0<4B;00<000000314R`3D?AT01`0`A8/00`000000<4B;0314R`07
0314R`030000003D?AT0<4B;00H0<4B;100000020=@m6@<0=4VE00@0e3dI03A9U@0dBID000002P0d
BID00`000000=4VE0=@m6@0803A9U@030000003oBAd0odTM00@0odTM00D000000?m97@3oBAd0odTM
03eIZ`030?m97@<00000103jAA`00`000000nTDL0?Y570040?Y570070000003jAA`0nTDL0?Y5700m
FJ/0nTDL000000060?Y570<000000P3[@1T00`3D?AT0jd0I0>]06@030>]06@030000003[@1T0?EV[
00@0?EV[0`3[@1T3000000<0e3TF00D000000=@i5P3D>AH0e3TF000000030=@i5P050000003D>AH0
e3TF0=@i5P0mFJ/0103om^h00`3D?AT0ooK^0?ofkP030?ofkP<0e3dI00<0ooK^03eIZ`0mFJ/00`0m
FJ/20=@m6A40ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3o
m^h0ooK^02`0ooK^00<000000?ofkP3om^h01P3om^h10?ooo`001`3om^h00`000000ooK^0?ofkP17
0?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h01`3om^h01@3D?AT0ooK^0?ofkP3o
m^h0?EV[00T0ooK^100mFJ/00`3D?AT0ooK^03eIZ`040?ofkP<0e3dI1`3om^h00`3D?AT0?EV[0?of
kP080?ofkP030000000/?Wh0;3in00@0;3in00<0000002`nOP0/?Wh01P0/?Wh00`000000;3in02`n
OP0502`nOP030000000/?Wh0;3in00H0;3in00<0000002`nOP0/?Wh0100/?Wh5000000L0<4B;00<0
00000314R`0`A8/01P0`A8/00`000000<4B;0314R`070314R`030000003D?AT0<4B;00L0<4B;00<0
00000314R`0`A8/01`0`A8/00`3D?AT0<4B;0314R`0600000080=4VE00@0000003A9U@0dBID0=4VE
0P3D?AT01@0dBID0e3dI03A9U@0dBID0000000X0=4VE00<0000003A9U@3D?AT0200dBID00`000000
odTM0?m97@040?m97@050000003oBAd0odTM0?m97@0mFJ/00`3oBAd00`000000odTM0?m97@020000
0080nTDL00<000000?Y5703jAA`0103jAA`00`000000nTDL0?Y570020?Y5700303eIZ`000000nTDL
00D0nTDL00H000000?Y5703jAA`000000>]06@3D?AT30>]06@@0?EV[0P3[@1T00`0mFJ/0jd0I0000
00040>]06@030000003[@1T0000000800000103D>AH00`000000e3TF0=@i5P020=@i5P040000003D
>AH0e3TF03eIZ`D0ooK^00@0e3dI0?ofkP3om^h0ooK^1@0mFJ/20?ofkP0303eIZ`3om^h0e3dI0080
ooK^0P3D?AT?0?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0
ooK^0?ofkP0/0?ofkP030000003om^h0ooK^00H0ooK^0@3oool000L0ooK^00<000000?ofkP3om^h0
A`3om^h00`3D?AT0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00P0ooK^00@0e3dI0?ofkP3om^h0
?EV[1@3om^h503eIZ`@0ooK^00<0e3dI03eIZ`3om^h01`3om^h20=@m6@D0ooK^00<0e3dI0?ofkP3o
m^h01`3om^h00`000000;3in02`nOP0502`nOP030000000/?Wh0;3in00H0;3in00<0000002`nOP0/
?Wh01@0/?Wh00`000000;3in02`nOP0502`nOP030000000/?Wh0;3in00D000000P0`A8/00`000000
<4B;0314R`070314R`030000000`A8/0<4B;00H0<4B;00<000000314R`0`A8/01`0`A8/00`000000
e3dI0314R`070314R`030000000`A8/0<4B;00H0<4B;00@000000=@m6@0000000000200dBID00`00
0000=4VE03A9U@0303A9U@<0e3dI00<0=4VE0000000dBID02@0dBID00`000000=4VE0=@m6@0803A9
U@030000003oBAd0odTM00@0odTM00D000000?m97@3oBAd0odTM03eIZ`030?m97@030000003oBAd0
odTM0080odTM0`0000060?Y570030000003jAA`0nTDL0080nTDL00<0?EV[0000003jAA`01@3jAA`0
10000000nTDL0?Y5703jAA`503eIZ`<0jd0I00H000000>]06@3[@1T0?EV[0>]06@0000050>]06@04
0000003[@1T0jd0I0>]06@8000000`3D>AH01@000000e3TF0=@i5P3D>AH000000080e3TF00<0?EV[
0000003om^h00P3om^h503eIZ`D0ooK^0P3D?AT0100mFJ/0ooK^0?ofkP3D?AT30?ofkP80e3dI3@3o
m^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^01@0ooK^00<0?EV[0?ofkP3om^h0:`3o
m^h00`000000ooK^0?ofkP060?ofkP40oooo00070?ofkP030000003om^h0ooK^04L0ooK^0P3D?AT4
0?ofkP0303eIZ`3om^h0ooK^00T0ooK^00D0e3dI0?ofkP3om^h0?EV[0?ofkP0403eIZ`P0ooK^00<0
e3dI0?ofkP0mFJ/02P3om^h30=@m6@030?ofkP3D?AT0?EV[00T0ooK^00<0000002`nOP0/?Wh01@0/
?Wh00`000000;3in02`nOP0502`nOP030000000/?Wh0;3in00H0;3in00<0000002`nOP0/?Wh00`0/
?Wh5000000L0<4B;00<000000314R`0`A8/01`0`A8/00`000000<4B;0314R`060314R`030000000`
A8/0<4B;00L0<4B;00<000000=@m6@0`A8/01`0`A8/00`000000<4B;0314R`030314R`<0000000<0
=4VE0=@m6@0dBID02@0dBID00`000000=4VE03A9U@0403A9U@040=@m6@0dBID0e3dI0=@m6@X0=4VE
00<0000003A9U@3D?AT0200dBID00`000000odTM0?m97@040?m97@050000003oBAd0odTM0?m97@0m
FJ/00`3oBAd00`000000odTM0?m97@040?m97@8000001@3jAA`00`000000nTDL0?Y570020?Y57003
03eIZ`3jAA`0000000@0nTDL1@0mFJ/20?Y570800000103[@1T01P000000jd0I0>]06@0mFJ/0jd0I
000000D0jd0I00<000000>]06@3[@1T00P3[@1T300000080e3TF00H000000=@i5P3D>AH0e3TF0000
003D>AH503eIZ`80ooK^00<0e3dI0?ofkP3om^h01@3om^h0103D?AT0ooK^0=@m6@0mFJ/20?ofkP03
0=@m6@3om^h0ooK^0080ooK^0P3D?AT;0?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3o
m^h0503om^h00`0mFJ/0ooK^0?ofkP0/0?ofkP030000003om^h0ooK^00D0ooK^0@3oool000L0ooK^
00<000000?ofkP3om^h0A`3om^h00`3D?AT0ooK^0=@m6@020=@m6@030?ofkP0mFJ/0ooK^00X0ooK^
00<0e3dI03eIZ`0mFJ/00P0mFJ/<0?ofkP030=@m6@3om^h0?EV[00d0ooK^0`3D?AT80?ofkP030000
000/?Wh0;3in00D0;3in00<0000002`nOP0/?Wh01P0/?Wh00`000000;3in02`nOP0502`nOP030000
000/?Wh0;3in00@000000P0`A8/00`000000<4B;0314R`070314R`030000000`A8/0<4B;00L0<4B;
00<000000314R`0`A8/01P0`A8/00`000000<4B;0314R`070314R`030000003D?AT0<4B;00L0<4B;
00<000000314R`0000000`00000403A9U@030=@m6@0dBID0=4VE00P0=4VE00<0000003A9U@0dBID0
0`0dBID01@3D?AT0=4VE03A9U@0dBID0000000<0e3dI1`0dBID00`000000e3dI03A9U@0803A9U@03
0000003oBAd0odTM00@0odTM00D000000?m97@3oBAd0odTM03eIZ`030?m97@030000003oBAd0odTM
00@0odTM00@000000?m97@00000000000`3jAA`00`000000nTDL0?Y570020?Y5700303eIZ`3jAA`0
000000@0?EV[00<0nTDL0000003jAA`0103jAA`010000000nTDL0000000000020>]06@070000003[
@1T0jd0I0>]06@0mFJ/0jd0I000000040>]06@030000003[@1T0jd0I00<0jd0I00@000000>]06@00
00000000103D>AH01@000000e3TF0=@i5P0mFJ/0000000D0ooK^00<0e3dI0?ofkP3om^h01@3om^h0
0`3D?AT0ooK^03eIZ`020=@m6@030?ofkP3D?AT0ooK^00@0ooK^00<0e3dI0?ofkP3om^h0203om^h0
0`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^0180ooK^0`0mFJ/^0?ofkP030000003om^h0
ooK^00D0ooK^0@3oool000H0ooK^00<000000?ofkP3om^h0B03om^h00`3D?AT0ooK^0?ofkP020?of
kP<0e3dI1`3om^h203eIZ`040=@m6@0mFJ/0ooK^03eIZ`h0ooK^00<0e3dI03eIZ`3om^h03P3om^h0
103D?AT0ooK^0=@m6@3D?AT60?ofkP030000000/?Wh0;3in00D0;3in00<0000002`nOP0/?Wh01P0/
?Wh00`000000;3in02`nOP0302`nOPD000001P0`A8/00`000000<4B;0314R`070314R`030000000`
A8/0<4B;00H0<4B;00<000000314R`0`A8/01`0`A8/00`000000<4B;0314R`070314R`030=@m6@0`
A8/0<4B;00D0<4B;1000000703A9U@030=@m6@000000=4VE00T0=4VE00<0000003A9U@0dBID00`0d
BID01@3D?AT0=4VE03A9U@0dBID0000000<0=4VE0P3D?AT503A9U@030000003D?AT0=4VE00P0=4VE
00<000000?m97@3oBAd0103oBAd00`000000odTM0?m97@020?m97@0403eIZ`3oBAd0odTM000000H0
odTM00@000000?m97@3oBAd0odTM0P000000103jAA`000000?Y5703jAA`503eIZ`D0nTDL00<00000
0?Y5703jAA`00`3jAA`010000000nTDL0?Y5703jAA`2000000070>]06@000000jd0I0>]06@0mFJ/0
jd0I000000050>]06@030000003[@1T0jd0I0080jd0I00@000000>]06@3[@1T0jd0I0P0000030=@i
5P040000003D>AH0?EV[00000080e3dI0`3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0
?EV[0080ooK^0`3D?AT50?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h04P3om^h0
0`0mFJ/0ooK^0?ofkP0<0?ofkPH0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP0/0?ofkP030000003om^h0
ooK^00D0ooK^0@3oool000H0ooK^00<000000?ofkP3om^h0B03om^h00`3D?AT0ooK^0?ofkP020?of
kP0303eIZ`3om^h0ooK^0080e3dI0P3om^h303eIZ`80ooK^00<0e3dI0?ofkP0mFJ/03`3om^h00`3D
?AT0?EV[0?ofkP0>0?ofkP040=@m6@3om^h0ooK^0?ofkP80e3dI0`3om^h00`000000;3in02`nOP06
02`nOP030000000/?Wh0;3in00D0;3in00<0000002`nOP0/?Wh0100000020314R`030000000`A8/0
<4B;00H0<4B;00<000000314R`0`A8/01`0`A8/00`000000<4B;0314R`060314R`030000000`A8/0
<4B;00L0<4B;00<000000314R`0`A8/01`0`A8/00`3D?AT0<4B;0314R`0500000080=4VE00<00000
03A9U@0dBID01P0dBID00`3D?AT0000003A9U@0903A9U@030000000dBID0=4VE00<0=4VE00D0e3dI
03A9U@0dBID0=4VE0000000503A9U@<0e3dI0P0dBID00`000000e3dI03A9U@0803A9U@030000003o
BAd0odTM00@0odTM00<000000?m97@3oBAd00P3oBAd00`0mFJ/0odTM000000070?m97@040000003o
BAd0odTM0?m97@<0?EV[00<0000003eIZ`0mFJ/00P3jAA`00`0mFJ/0nTDL000000060?Y570030000
003jAA`0nTDL0080nTDL00<000000?Y5703jAA`00`3jAA`200000080jd0I00<0?EV[0>]06@000000
1@3[@1T00`000000jd0I0>]06@020>]06@030000003[@1T0jd0I0080jd0I0`0000020=@i5P050000
000mFJ/0e3TF0000003om^h00P3D?AT20?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI03eIZ`3o
m^h00`3om^h20=@m6@D0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP03
03eIZ`3om^h0ooK^00H0ooK^1@0mFJ/80?ofkP0303eIZ`3om^h0ooK^02`0ooK^00<000000?ofkP3o
m^h01@3om^h10?ooo`001P3om^h00`000000ooK^0?ofkP180?ofkP050=@m6@3om^h0ooK^0?ofkP0m
FJ/0103om^h0100mFJ/0e3dI0=@m6@3D?AT40?ofkP030=@m6@3om^h0?EV[00l0ooK^00<0e3dI0?of
kP3om^h03P3om^h00`3D?AT0ooK^0?ofkP030?ofkP80e3dI00<0ooK^0000000/?Wh01P0/?Wh00`00
0000;3in02`nOP0502`nOP@000001P0`A8/00`000000<4B;0314R`060314R`030000000`A8/0<4B;
00L0<4B;00<000000314R`0`A8/01P0`A8/00`000000<4B;0314R`070314R`030000000`A8/0<4B;
00D0<4B;0P0000020=@m6@030000000dBID0=4VE00D0=4VE00<0000003A9U@0dBID01P0dBID00`3D
?AT0000003A9U@0903A9U@030000000dBID0=4VE00<0=4VE00D0e3dI03A9U@0dBID0=4VE00000008
03A9U@80e3dI00<000000=@m6@0dBID01P0dBID4000000D0odTM00<000000?m97@3oBAd00P3oBAd0
0`0mFJ/0odTM000000060?m97@D0?EV[0`3oBAd020000000odTM000000000000nTDL03eIZ`3D?AT0
00001P3jAA`00`000000nTDL0?Y570020?Y570030000003jAA`0nTDL00@0nTDL0`0000000`0mFJ/0
jd0I0=@m6@050>]06@030000003[@1T0jd0I00<0jd0I00<000000>]06@3[@1T00P3[@1T01P000000
jd0I000000000000e3TF03eIZ`80e3TF00<000000?ofkP3om^h00`3D?AT80?ofkP0303eIZ`3om^h0
ooK^00@0ooK^0P3D?AT40?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h04`3om^h0
0`0mFJ/0ooK^0?ofkP0603eIZ`d0ooK^00<0?EV[0?ofkP3om^h0;03om^h00`000000ooK^0?ofkP05
0?ofkP40oooo00060?ofkP030000003om^h0ooK^04P0ooK^00@0e3dI0?ofkP3om^h0ooK^1@0mFJ/4
0?ofkP<0e3dI00@0ooK^0=@m6@3om^h0?EV[3`3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3o
m^h0ooK^00@0ooK^0`0mFJ/702`nOP030000000/?Wh0;3in0080;3in0`0000000`0`A8/000000314
R`070314R`030000000`A8/0<4B;00H0<4B;00<000000314R`0`A8/01P0`A8/00`000000<4B;0314
R`070314R`030000000`A8/0<4B;00L0<4B;00<000000314R`0`A8/01@00000203A9U@040=@m6@0d
BID0e3dI0=@m6@H0=4VE00<0000003A9U@0dBID01P0dBID00`3D?AT0000003A9U@0903A9U@030000
000dBID0=4VE0080=4VE00<0e3dI03A9U@0dBID00P0dBID00`000000=4VE03A9U@0803A9U@80e3dI
00<0=4VE0000000000001000000203M>WP040000003oC1l00000000000<0odTM00<000000?m97@3o
BAd00P3oBAd00`0mFJ/0odTM0000000603eIZ`030?m97@000000odTM00D0odTM00P000000?m97@3o
BAd0odTM0000000mFJ/0nTDL000000H0nTDL00<000000?Y5703jAA`00P3jAA`00`000000nTDL0?Y5
70040?Y570070000003jAA`0nTDL03eIZ`000000jd0I000000050>]06@030000003[@1T0jd0I0080
jd0I00<000000>]06@3[@1T00P3[@1T010000000jd0I0>]06@3[@1T20000000303eIZ`3D>AH00000
00@0ooK^0P3D?AT70?ofkP0303eIZ`3om^h0ooK^00D0ooK^0`3D?AT30?ofkP030=@m6@3om^h0ooK^
00D0ooK^00<0?EV[0?ofkP3om^h04@3om^h503eIZa<0ooK^00<0?EV[0?ofkP3om^h0;03om^h00`00
0000ooK^0?ofkP050?ofkP40oooo00060?ofkP030000003om^h0ooK^04P0ooK^00<0e3dI0?ofkP3o
m^h00P0mFJ/;0?ofkP<0e3dI00<0?EV[0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP03
0=@m6@3om^h0ooK^00D0?EV[00<0ooK^0000000/?Wh01P0/?Wh00`000000;3in00000003000000@0
<4B;00<000000314R`0`A8/01@0`A8/00`000000<4B;0314R`070314R`030000000`A8/0<4B;00H0
<4B;00<000000314R`0`A8/01`0`A8/00`000000<4B;0314R`050314R`D000001P0dBID00`3D?AT0
000003A9U@0203A9U@<0e3dI0`0dBID00`000000=4VE03A9U@0503A9U@030=@m6@0dBID0000000X0
=4VE00<0000003A9U@0dBID00P0dBID00`3D?AT0=4VE03A9U@0203A9U@030000000dBID0=4VE00L0
=4VE0P0000030=@m6@L0=djN00@000000?m<7`3oC1l0od`O0P0000000`3oBAd000000?m97@020?m9
7@@0?EV[1`3oBAd00`000000odTM0?m97@040?m97@030000003oBAd0odTM00<0odTM00<0?EV[0000
000000001@3jAA`00`000000nTDL0?Y570020?Y570030000003jAA`0nTDL00@0nTDL00D000000?Y5
703jAA`0?EV[0?Y57003000000@0jd0I00<000000>]06@3[@1T00P3[@1T00`000000jd0I0>]06@02
0>]06@030000003[@1T0jd0I0080jd0I00D0000003eIZ`000000e3TF000000040?ofkP<0e3dI1P3o
m^h00`0mFJ/0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^0080e3dI0P3om^h00`3D?AT0ooK^0?of
kP040?ofkP0303eIZ`3om^h0ooK^00d0ooK^100mFJ/20?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0
?EV[0?ofkP3om^h0;03om^h00`000000ooK^0?ofkP050?ofkP40oooo00060?ofkP030000003om^h0
ooK^04P0ooK^00@0e3dI0?ofkP3om^h0?EV[3@3om^h0103D?AT0?EV[0=@m6@3D?AT=0?ofkP0303eI
Z`3D?AT0ooK^00`0ooK^0P0mFJ/00`3D?AT0?EV[03eIZ`060?ofkP030000000/?Wh0;3in00<0;3in
100000080314R`030000000`A8/0<4B;00D0<4B;00<000000314R`0`A8/01P0`A8/00`000000<4B;
0314R`070314R`030000000`A8/0<4B;00L0<4B;00<000000314R`0`A8/01@00000203A9U@030000
000dBID0=4VE00H0=4VE00<0e3dI0000000dBID01@0dBID20=@m6@0303A9U@000000=4VE00H0=4VE
00<0e3dI03A9U@0000002P0dBID00`000000=4VE03A9U@0203A9U@030=@m6@0dBID0=4VE0080=4VE
00<0000003A9U@0dBID00`0dBID40000000303M>WP000000e3dI0080=djN0P3D?AT503M>WP030000
003oC1l0od`O00<0od`O00<0000003eIZ`0mFJ/00P0mFJ/0103oBAd0?EV[0?m97@0000060?m97@03
0000003oBAd0odTM00D0odTM00<000000?m97@3oBAd00`3oBAd00`0mFJ/000000?m97@02000000<0
nTDL00<000000?Y5703jAA`00`3jAA`00`000000nTDL0?Y570030?Y570080000003jAA`0nTDL0?Y5
700mFJ/0nTDL0000003jAA`200000080jd0I00<000000>]06@3[@1T00P3[@1T00`000000jd0I0>]0
6@030>]06@030000003[@1T0jd0I0080jd0I00@0?EV[0>]06@00000000001@3om^h0103D?AT0ooK^
0=@m6@3D?AT40?ofkP0303eIZ`3D?AT0ooK^00D0ooK^00@0e3dI0?ofkP3om^h0ooK^0P3D?AT00`3o
m^h0e3dI0?ofkP040?ofkP0303eIZ`3om^h0ooK^00T0ooK^100mFJ/60?ofkP0303eIZ`3om^h0ooK^
01<0ooK^00<0?EV[0?ofkP3om^h0;03om^h00`000000ooK^0?ofkP050?ofkP40oooo00060?ofkP03
0000003om^h0ooK^04P0ooK^00<0e3dI0?ofkP0mFJ/03P3om^h0103D?AT0?EV[0?ofkP3om^h30=@m
6@X0ooK^00<0?EV[0=@m6@3om^h0203om^h403eIZ`80ooK^00<0e3dI0?ofkP3om^h01@3om^h00`00
0000;3in02`nOP0400000080<4B;00<000000314R`0`A8/01P0`A8/00`000000<4B;0314R`060314
R`030000000`A8/0<4B;00H0<4B;00<000000314R`0`A8/01`0`A8/00`000000<4B;0314R`060314
R`@000001`0dBID00`000000=4VE03A9U@0503A9U@030=@m6@0dBID0000000P0=4VE0P3D?AT703A9
U@030=@m6@0dBID0000000X0=4VE00<0000003A9U@0dBID00P0dBID00`3D?AT0=4VE03A9U@0203A9
U@030000000dBID0000000<000001@0gCYh00`3D?AT0?EV[03M>WP0303M>WP80e3dI0`0gCYh00`00
0000od`O0?m<7`0403eIZ`080000003oC1l000000000003oBAd0?EV[0?m97@0000060?m97@030000
003oBAd0odTM00D0odTM00<000000?m97@3oBAd00`3oBAd00`0mFJ/000000?m97@020?m97@800000
00<0nTDL0000003jAA`0103jAA`00`000000nTDL0?Y570030?Y570070000003jAA`0nTDL0?Y5700m
FJ/0nTDL000000030?Y57080000000<0jd0I0000003[@1T00`3[@1T00`000000jd0I0>]06@020>]0
6@030000003[@1T0jd0I0080jd0I00D0?EV[0>]06@3[@1T0jd0I000000040?ofkP040=@m6@3om^h0
ooK^0?ofkP80e3dI0P3om^h00`0mFJ/0e3dI0?ofkP060?ofkP030=@m6@3om^h0ooK^0080ooK^0`3D
?AT50?ofkP0303eIZ`3om^h0ooK^00@0ooK^100mFJ/:0?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0
?EV[0?ofkP3om^h0;03om^h00`000000ooK^0?ofkP050?ofkP40oooo00060?ofkP030000003om^h0
ooK^04P0ooK^00<0e3dI0?ofkP0mFJ/03P3om^h00`3D?AT0?EV[0?ofkP040?ofkP80e3dI203om^h0
0`3D?AT0ooK^0?ofkP030?ofkPD0?EV[1P3om^h00`3D?AT0ooK^0?ofkP050?ofkP<000001P0`A8/0
0`000000<4B;0314R`060314R`030000000`A8/0<4B;00H0<4B;00<000000314R`0`A8/01P0`A8/0
0`000000<4B;0314R`070314R`030000000`A8/0<4B;00<0<4B;0`0000000`0dBID0000003A9U@08
03A9U@030000000dBID0=4VE00D0=4VE00<0e3dI03A9U@0000002@0dBID010000000e3dI0=@m6@3D
?AT403A9U@030=@m6@0dBID0000000X0=4VE00D0000003A9U@0dBID0=4VE0=@m6@0303A9U@@00000
2@0gCYh00`3D?AT0=djN03M>WP0503M>WP<0e3dI0`0mFJ/40?m<7`080000003oC1l0od`O0?m<7`00
0000?EV[0?m97@0000060?m97@030000003oBAd0odTM00D0odTM00<000000?m97@3oBAd00`3oBAd0
0`0mFJ/000000?m97@040?m97@8000001@3jAA`00`000000nTDL0?Y570030?Y570070000003jAA`0
nTDL0?Y5700mFJ/0nTDL000000050?Y570800000103[@1T00`000000jd0I0>]06@020>]06@030000
003[@1T0jd0I0080jd0I00D0?EV[0>]06@3[@1T0jd0I000000040?ofkP030=@m6@3om^h0ooK^00<0
ooK^0P3D?AT00`0mFJ/0ooK^0=@m6@060?ofkP030=@m6@3om^h0ooK^00@0ooK^0P3D?AT40?ofkP03
03eIZ`3om^h0ooK^00@0?EV[3P3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^02`0
ooK^00<000000?ofkP3om^h01@3om^h10?ooo`001P3om^h00`000000ooK^0?ofkP180?ofkP030=@m
6@3om^h0?EV[00h0ooK^00<0e3dI03eIZ`3om^h01P3om^h20=@m6@D0ooK^00<0?EV[0=@m6@3om^h0
100mFJ/;0?ofkP030=@m6@3om^h0ooK^00D0ooK^00<000000314R`0`A8/01P0`A8/00`000000<4B;
0314R`060314R`030000000`A8/0<4B;00H0<4B;00<000000314R`0`A8/01P0`A8/00`000000<4B;
0314R`070314R`030000000mFJ/0000000<00000100dBID00`000000=4VE03A9U@0703A9U@030000
000dBID0=4VE00@0=4VE00@0e3dI03A9U@0dBID000002@0dBID010000000=4VE03A9U@0dBID20=@m
6@0503A9U@3D?AT0=4VE03A9U@0000002P0dBID01@000000=4VE03A9U@000000e3dI00<000000P0g
CYh00`000000=djN03M>WP0803M>WP030=@m6@0gCYh0=djN00P0=djN00<000000?m<7`3oC1l0103o
C1l00`000000od`O0?m<7`030?m<7`0303eIZ`000000odTM00D0odTM00<000000?m97@3oBAd0103o
BAd2000000D0odTM00<0?EV[0000003oBAd01@3oBAd3000000<0nTDL00<000000?Y5703jAA`0103j
AA`010000000nTDL0?Y5700mFJ/20?Y570030000003jAA`0nTDL00<0nTDL0`0000020>]06@030=@m
6@3[@1T0jd0I00<0jd0I00<000000>]06@3[@1T00P3[@1T01@0mFJ/0jd0I0>]06@3[@1T0000000@0
ooK^00<0e3dI0?ofkP3om^h0103om^h00`0mFJ/0e3dI0=@m6@070?ofkP030=@m6@3om^h0ooK^00D0
ooK^00<0e3dI0?ofkP0mFJ/0100mFJ/C0?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3o
m^h0:`3om^h00`000000ooK^0?ofkP050?ofkP40oooo00060?ofkP030000003om^h0ooK^04P0ooK^
00<0e3dI0?ofkP0mFJ/03P3om^h00`3D?AT0ooK^0?ofkP080?ofkP<0e3dI00D0ooK^03eIZ`0mFJ/0
e3dI03eIZ`0>0?ofkP0303eIZ`3D?AT0ooK^00H0ooK^00<000000314R`0`A8/01P0`A8/00`000000
<4B;0314R`060314R`030000000`A8/0<4B;00H0<4B;00<000000314R`0`A8/01P0`A8/00`000000
<4B;0314R`050314R`@00000200dBID00`000000=4VE03A9U@0703A9U@030000000dBID0=4VE00@0
=4VE00@0e3dI03A9U@0dBID000002@0dBID00`000000=4VE03A9U@0303A9U@<0e3dI00<0=4VE0000
000dBID01`0dBID50000000303M>WP3D?AT0=djN00@0=djN00<0000003M>WP0gCYh0200gCYh00`3D
?AT0=djN03M>WP0803M>WP030000003oC1l0od`O00@0od`O00<000000?m<7`3oC1l00`3oC1l0100m
FJ/000000000000000030?m97@030=@m6@000000odTM00D0odTM00<000000?m97@000000103oBAd0
0`0mFJ/000000?m97@050?m97@030000003oBAd0odTM0080000000<0nTDL0000003jAA`01@3jAA`0
10000000nTDL0?Y5700mFJ/20?Y570030000003jAA`0nTDL00<0nTDL00<000000?Y5703jAA`00P00
00000`3[@1T000000>]06@030>]06@030000003[@1T0jd0I0080jd0I00D0?EV[0>]06@3[@1T0jd0I
000000040?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3D?AT00P3D?AT60?ofkP040=@m
6@3om^h0ooK^0?ofkPD0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^01<0
ooK^00<0?EV[0?ofkP3om^h0:`3om^h00`000000ooK^0?ofkP050?ofkP40oooo00060?ofkP030000
003om^h0ooK^04P0ooK^00<0e3dI03eIZ`3om^h03P3om^h00`3D?AT0ooK^0?ofkP080?ofkP<0?EV[
0P3D?AT00`0mFJ/0e3dI0?ofkP0>0?ofkP0303eIZ`3D?AT0ooK^00D0ooK^00<000000314R`0`A8/0
1`0`A8/00`000000<4B;0314R`060314R`030000000`A8/0<4B;00D0<4B;00<000000314R`0`A8/0
1`0`A8/00`000000<4B;0314R`0500000080=4VE00<0000003A9U@0dBID01`0dBID00`000000=4VE
03A9U@0703A9U@030000000dBID0=4VE00@0=4VE00@0e3dI03A9U@0dBID000002@0dBID00`000000
=4VE03A9U@0403A9U@040=@m6@0dBID0e3dI0=@m6@80=4VE1P00000203M>WP050000000gCYh0=djN
03M>WP3D?AT01@0gCYh00`000000=djN03M>WP0803M>WP030=@m6@0gCYh0=djN00L0=djN00<00000
0?m<7`3oC1l01@3oC1l00`000000od`O0?m<7`030?m<7`0403eIZ`000000od`O0?m<7`8000000P3o
BAd00`000000odTM0?m97@040?m97@030000003oBAd0000000D0odTM00<0?EV[0?m97@3oBAd0103o
BAd00`000000odTM0?m97@020?m97@<000001@3jAA`010000000nTDL0?Y5700mFJ/20?Y570030000
003jAA`0nTDL00<0nTDL00<000000?Y5703jAA`00P3jAA`3000000<0jd0I00<000000>]06@3[@1T0
0`0mFJ/40>]06@050000003om^h0ooK^0?ofkP3D?AT01`3om^h0100mFJ/0ooK^0=@m6@3om^h20=@m
6@80ooK^1P0mFJ/40?ofkP040=@m6@3om^h0ooK^03eIZaD0ooK^00<0?EV[0?ofkP3om^h04`3om^h0
0`0mFJ/0ooK^0?ofkP0[0?ofkP030000003om^h0ooK^00D0ooK^0@3oool000H0ooK^00<000000?of
kP3om^h0B03om^h00`3D?AT0?EV[0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00D0ooK^0`0mFJ/50?of
kP<0e3dI3P3om^h00`0mFJ/0e3dI0?ofkP050?ofkP030000000`A8/0<4B;00H0<4B;00<000000314
R`0`A8/01`0`A8/00`000000<4B;0314R`050314R`030000000`A8/0<4B;00D0<4B;1@00000703A9
U@030000000dBID0=4VE00L0=4VE00<0000003A9U@0dBID01`0dBID00`000000=4VE03A9U@0303A9
U@050=@m6@0dBID0=4VE03A9U@0000002@0dBID00`000000=4VE03A9U@0303A9U@030=@m6@0dBID0
0000008000000P3D?AT803M>WP040000000gCYh0=djN0=@m6@H0=djN00<0000003M>WP0gCYh01`0g
CYh00`3D?AT0000003M>WP0803M>WP030000003oC1l0od`O00D0od`O00<000000?m<7`3oC1l00`3o
C1l00`0mFJ/000000?m<7`030?m<7`<000001P3oBAd00`000000odTM000000040?m97@030000000m
FJ/0odTM00D0odTM00<000000?m97@3oBAd00`3oBAd010000000odTM0000000000030?Y570070000
003jAA`0nTDL0?Y5700mFJ/0nTDL000000050?Y570030000003jAA`0nTDL00<0nTDL00<000000?Y5
700mFJ/01@0mFJ/20>]06@0303eIZ`000000jd0I0080jd0I00<000000?ofkP3om^h00P3om^h00`3D
?AT0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00D0?EV[0`3om^h00`3D?AT0ooK^0?ofkP050?of
kP030=@m6@3om^h0?EV[01D0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP0[0?of
kP030000003om^h0ooK^00D0ooK^0@3oool000H0ooK^00<000000?ofkP3om^h0B03om^h00`3D?AT0
?EV[0?ofkP0>0?ofkP030=@m6@3om^h0ooK^0080ooK^0`0mFJ/80?ofkP0303eIZ`3D?AT0ooK^00<0
e3dI2`3om^h00`3D?AT0ooK^0?ofkP050?ofkP030000000`A8/0<4B;00H0<4B;00<000000314R`0`
A8/01P0`A8/00`000000<4B;0314R`060314R`030000000`A8/0<4B;00D000000P0dBID00`000000
=4VE03A9U@0703A9U@030000000dBID0=4VE00L0=4VE00<0000003A9U@0dBID01`0dBID00`000000
=4VE03A9U@0303A9U@050=@m6@0dBID0=4VE03A9U@0000002@0dBID00`000000=4VE03A9U@030000
00050=@m6@000000=djN03M>WP0000000P0gCYh20=@m6@H0=djN00@0000003M>WP0gCYh0e3dI1P0g
CYh00`000000=djN03M>WP0703M>WP030=@m6@0gCYh0=djN00P0=djN00<000000?m<7`3oC1l01@3o
C1l00`000000od`O0?m<7`030?m<7`0303eIZ`000000od`O00D0od`O0P0000050?m97@030000003o
BAd0000000@0odTM00<0000003eIZ`3oBAd01@3oBAd00`000000odTM0?m97@030?m97@040000003o
BAd0odTM0?m97@80000000<0nTDL0000003jAA`00P3jAA`00`0mFJ/0nTDL000000050?Y570030000
003jAA`0?EV[00D0?EV[0`3jAA`2000000@0jd0I00D0?EV[0>]06@3[@1T0jd0I000000040?ofkP03
0=@m6@3om^h0ooK^0080ooK^1@0mFJ/00`3D?AT0ooK^0?ofkP020?ofkP80e3dI0P3om^h00`3D?AT0
ooK^0?ofkP040?ofkP030=@m6@3om^h0?EV[01D0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0
ooK^0?ofkP0[0?ofkP030000003om^h0ooK^00D0ooK^0@3oool000H0ooK^00<000000?ofkP3om^h0
B03om^h00`3D?AT0ooK^0?ofkP0=0?ofkP0303eIZ`3D?AT0?EV[00<0?EV[2`3om^h00`0mFJ/0e3dI
0?ofkP030?ofkP<0e3dI203om^h00`3D?AT0ooK^0?ofkP050?ofkP030000000`A8/0<4B;00H0<4B;
00<000000314R`0`A8/01P0`A8/00`000000<4B;0314R`040314R`D000001`0dBID00`000000=4VE
03A9U@0703A9U@030000000dBID0=4VE00L0=4VE00<0000003A9U@0dBID01`0dBID00`000000=4VE
03A9U@0203A9U@030=@m6@0dBID0=4VE0080=4VE00<0000003A9U@0dBID01P0dBID400000080=djN
00<0e3dI03M>WP0gCYh00P0gCYh00`000000=djN03M>WP0203M>WP<0e3dI0`0gCYh010000000=djN
03M>WP3D?AT603M>WP030000000gCYh0=djN00L0=djN00<0e3dI03M>WP0gCYh0200gCYh00`000000
od`O0?m<7`040?m<7`030000003oC1l0od`O00@0od`O00<0?EV[0000003oC1l01@3oC1l010000000
od`O0000000000030?m97@030000003oBAd0000000@0odTM00<0000003eIZ`3oBAd01@3oBAd00`00
0000odTM0?m97@030?m97@030000003oBAd0odTM00<0odTM0`0000020?Y5700403eIZ`3jAA`00000
0?Y570H0?EV[103jAA`00`000000nTDL0?Y570030?Y570<000000P3[@1T00`0mFJ/0jd0I0>]06@02
0>]06@030000003om^h0ooK^00H0?EV[0P3om^h0100mFJ/0ooK^0?ofkP3D?AT60?ofkP<0e3dI1`3o
m^h00`3D?AT0?EV[0?ofkP0D0?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h0:`3o
m^h00`000000ooK^0?ofkP050?ofkP40oooo00060?ofkP030000003om^h0ooK^04P0ooK^00<0e3dI
0?ofkP3om^h02`3om^h403eIZ`030=@m6@3om^h0ooK^00`0ooK^00<0?EV[0=@m6@3om^h01P3om^h4
0=@m6@@0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`000000<4B;0314R`060314R`030000000`A8/0
<4B;00H0<4B;00<000000314R`0`A8/01000000203A9U@030000000dBID0=4VE00L0=4VE00<00000
03A9U@0dBID01`0dBID00`000000=4VE03A9U@0703A9U@030000000dBID0=4VE00L0=4VE00<00000
03A9U@0dBID00P0dBID00`3D?AT0=4VE03A9U@0203A9U@030000000dBID0=4VE00<0=4VE0`000000
0`0gCYh0000003M>WP0303M>WP030=@m6@0gCYh0=djN0080=djN00<0000003M>WP0gCYh01@0gCYh2
0=@m6@0503M>WP000000=djN03M>WP3D?AT01P0gCYh00`000000=djN03M>WP0703M>WP030=@m6@0g
CYh0=djN00P0=djN00<000000?m<7`3oC1l0103oC1l00`000000od`O0?m<7`050?m<7`0303eIZ`3o
C1l0od`O00@0od`O00@000000?m<7`3oC1l0od`O0P000000103oBAd000000?m97@0000040?m97@03
0000000mFJ/0odTM00@0odTM00<000000?m97@3oBAd0103oBAd00`000000odTM0?m97@040?m97@03
0000003oBAd0?EV[00D0?EV[1@3jAA`00`000000nTDL0?Y570020?Y570030000003jAA`0nTDL00<0
nTDL00<000000?Y5703jAA`00P0000000`0mFJ/000000>]06@020>]06@<0?EV[0P3om^h00`3D?AT0
ooK^0?ofkP030?ofkP0503eIZ`3om^h0ooK^0?ofkP3D?AT01`3om^h30=@m6@H0ooK^00<0?EV[0?of
kP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^02`0ooK^00<000000?of
kP3om^h0103om^h10?ooo`001@3om^h00`000000ooK^0?ofkP190?ofkP030=@m6@3om^h0ooK^00L0
ooK^100mFJ/20?ofkP0303eIZ`3om^h0e3dI00h0ooK^00<0?EV[0=@m6@3om^h02P3om^h30=@m6@03
0?ofkP3D?AT0ooK^00H0ooK^00<000000314R`0`A8/01P0`A8/00`000000<4B;0314R`040314R`D0
00001P0dBID00`000000=4VE03A9U@0703A9U@030000000dBID0=4VE00L0=4VE00<0000003A9U@0d
BID01`0dBID00`000000=4VE03A9U@0703A9U@030000000dBID0=4VE0080=4VE00<0e3dI03A9U@0d
BID00P0dBID00`000000=4VE00000003000000@0=djN00D0000003M>WP0gCYh0=djN0=@m6@0503M>
WP030000000gCYh0=djN00L0=djN0P3D?AT00`0gCYh0e3dI03M>WP0603M>WP030000000gCYh0=djN
00H0=djN00<0e3dI0000000gCYh02@0gCYh00`000000od`O0?m<7`040?m<7`030000003oC1l0od`O
00D0od`O00<0?EV[0?m<7`3oC1l0103oC1l00`000000od`O0?m<7`030?m<7`@000000`3oBAd00`3D
?AT0000003eIZ`050?m97@030000003oBAd0odTM00@0odTM00<000000?m97@3oBAd00P3oBAd403eI
Z`80odTM00@0?EV[0000003jAA`000001@3jAA`00`000000nTDL0?Y570020?Y570030000003jAA`0
nTDL00<0nTDL00<000000?Y5703jAA`00P3jAA`00`0mFJ/000000>]06@030>]06@80e3dI0P3om^h0
0`3D?AT0ooK^0?ofkP030?ofkP0503eIZ`3om^h0ooK^0?ofkP3D?AT0203om^h0103D?AT0ooK^0=@m
6@3D?AT40?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^
0?ofkP0/0?ofkP030000003om^h0ooK^00@0ooK^0@3oool000D0ooK^00<000000?ofkP3om^h0B@3o
m^h20=@m6@@0ooK^100mFJ/60?ofkP0303eIZ`3om^h0e3dI00h0ooK^00<0?EV[0=@m6@3om^h03@3o
m^h30=@m6@D0ooK^00<000000314R`0`A8/01`0`A8/00`000000<4B;0314R`0400000080=4VE00<0
000003A9U@0dBID01P0dBID00`000000=4VE03A9U@0703A9U@030000000dBID0=4VE00L0=4VE00<0
000003A9U@0dBID01`0dBID00`000000=4VE03A9U@0703A9U@050000000dBID0=4VE03A9U@3D?AT0
0`0dBID4000000P0=djN00D0000003M>WP0gCYh0=djN0=@m6@0503M>WP030000000gCYh0=djN00P0
=djN00@000000=@m6@3D?AT0e3dI1P0gCYh00`000000=djN03M>WP0603M>WP030=@m6@000000=djN
00T0=djN00<000000?m<7`3oC1l0103oC1l00`000000od`O0?m<7`040?m<7`030000000mFJ/0od`O
00D0od`O00<000000?m<7`3oC1l0103oC1l010000000od`O0000000000030?m97@030000003oBAd0
?EV[00@0odTM00<000000?m97@3oBAd0103oBAd503eIZ`80odTM00<000000?m97@3oBAd00P3oBAd0
0`0mFJ/00000000000050?Y570030000003jAA`0nTDL0080nTDL00<000000?Y5703jAA`0103jAA`0
0`000000nTDL0?Y570020?Y5700303eIZ`00000000000080jd0I00H000000?ofkP3D?AT0e3dI0?of
kP3D?AT40?ofkP0503eIZ`3om^h0ooK^0?ofkP3D?AT02@3om^h00`3D?AT0ooK^0?ofkP020=@m6@80
ooK^00<0?EV[0=@m6@3om^h04`3om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP<0?EV[;P3om^h00`000000
ooK^0?ofkP040?ofkP40oooo00050?ofkP030000003om^h0ooK^04P0ooK^00<0?EV[0=@m6@3om^h0
0`3D?AT00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0e3dI00d0ooK^00<0?EV[0?ofkP3D?AT0
3P3om^h00`0mFJ/0e3dI0?ofkP020=@m6@<0ooK^00<000000314R`0`A8/01@0`A8/5000000H0=4VE
00<0000003A9U@0dBID01P0dBID00`000000=4VE03A9U@0703A9U@030000000dBID0=4VE00L0=4VE
00<0000003A9U@0dBID01`0dBID00`000000=4VE03A9U@0703A9U@050000000dBID0=4VE0000003D
?AT00`00000203M>WP030000000gCYh0=djN00L0=djN00@0000003M>WP0gCYh0e3dI1P0gCYh00`00
0000=djN03M>WP0803M>WP040000000gCYh0e3dI03M>WP80e3dI100gCYh00`000000=djN03M>WP06
03M>WP030=@m6@000000=djN00L0=djN100000050?m<7`030000003oC1l0od`O00@0od`O00<00000
03eIZ`3oC1l01@3oC1l00`000000od`O0?m<7`040?m<7`040000003oC1l000000?m<7`80000000@0
odTM0000003oBAd0?EV[103oBAd00`000000odTM03eIZ`0403eIZ`030000003oBAd0odTM00@0odTM
00<000000?m97@3oBAd00P3oBAd00`0mFJ/0odTM00000002000000<0nTDL00<000000?Y5703jAA`0
0`3jAA`00`000000nTDL0?Y570030?Y570030000003jAA`0nTDL0080nTDL00<0?EV[0?Y5703jAA`0
0P000000103[@1T000000?ofkP3om^h20=@m6@D0ooK^00D0?EV[0?ofkP3om^h0ooK^0=@m6@080?of
kP030=@m6@3om^h0ooK^0080ooK^0P3D?AT00`3om^h0?EV[0=@m6@0D0?ofkP0303eIZ`3om^h0ooK^
00`0ooK^100mFJ/20?ofkP0303eIZ`3om^h0ooK^02`0ooK^00<000000?ofkP3om^h0103om^h10?oo
o`001@3om^h00`000000ooK^0?ofkP180?ofkP0303eIZ`3D?AT0?EV[00<0ooK^0`3D?AT70?ofkP04
03eIZ`3om^h0ooK^0=@m6@d0ooK^00<0?EV[0?ofkP3D?AT03P3om^h00`0mFJ/0e3dI0?ofkP020?of
kP<0e3dI00<000000314R`0`A8/01@00000203A9U@030000000dBID0=4VE00H0=4VE00<0000003A9
U@0dBID01P0dBID00`000000=4VE03A9U@0803A9U@030000000dBID0=4VE00H0=4VE00<0000003A9
U@0dBID01`0dBID00`000000=4VE03A9U@0503A9U@D0000000<0e3dI03M>WP0gCYh0100gCYh00`00
0000=djN03M>WP0703M>WP040000000gCYh0=djN0=@m6@H0=djN00<0000003M>WP0gCYh0200gCYh0
0`000000e3dI03M>WP0303M>WP<0e3dI00<0=djN0000000gCYh01`0gCYh0103D?AT0000003M>WP0g
CYh600000080>E:V00@000000?m>8000000000000`3oC1l00`000000od`O0?m<7`040?m<7`030000
000mFJ/0od`O00D0od`O00<000000?m<7`3oC1l0103oC1l00`000000od`O000000030?m<7`<00000
00<0?EV[0?m97@3oBAd0100mFJ/50?m97@030000003oBAd0odTM00@0odTM00<000000?m97@3oBAd0
0P3oBAd00`0mFJ/0odTM000000020?m97@80000000<0nTDL0000003jAA`0103jAA`00`000000nTDL
0?Y570030?Y570030000003jAA`0nTDL0080nTDL00<0?EV[0?Y5703jAA`00P3jAA`2000000<0ooK^
0`3D?AT30?ofkP0503eIZ`3om^h0ooK^0?ofkP3D?AT0203om^h00`3D?AT0ooK^0?ofkP040?ofkP03
0=@m6@0mFJ/0e3dI01@0ooK^00<0?EV[0?ofkP3om^h0203om^h403eIZ`H0ooK^00<0?EV[0?ofkP3o
m^h0;03om^h00`000000ooK^0?ofkP040?ofkP40oooo00050?ofkP030000003om^h0ooK^04P0ooK^
00<0?EV[0?ofkP3D?AT01P3om^h30=@m6@@0ooK^00@0?EV[0?ofkP3om^h0e3dI3@3om^h00`0mFJ/0
ooK^0=@m6@0>0?ofkP0303eIZ`3D?AT0ooK^00D0ooK^00<000000=@m6@0000001`0dBID00`000000
=4VE03A9U@0603A9U@030000000dBID0=4VE00H0=4VE00<0000003A9U@0dBID0200dBID00`000000
=4VE03A9U@0603A9U@030000000dBID0=4VE00L0=4VE00<0000003A9U@0dBID01@00000203M>WP04
0000000gCYh0=djN0=@m6@H0=djN00<0000003M>WP0gCYh01`0gCYh010000000=djN03M>WP3D?AT7
03M>WP030000000gCYh0=djN00L0=djN00<000000=@m6@0gCYh01P0gCYh30=@m6@H0=djN00<00000
0=@m6@0000000P00000803UBYP040000003oCR00odhP0?m>8080000000<0od`O0000003oC1l01@3o
C1l00`000000?EV[0?m<7`040?m<7`030000003oC1l0od`O00D0od`O00<000000?m<7`000000103o
C1l503eIZ`80odTM00<000000?m97@3oBAd0103oBAd00`000000odTM0?m97@040?m97@030000003o
BAd0odTM00<0odTM00<0?EV[0000003oBAd00`3oBAd2000000D0nTDL00<000000?Y5703jAA`00`3j
AA`00`000000nTDL0?Y570020?Y5700303eIZ`000000nTDL00<0nTDL00D000000?ofkP3om^h0ooK^
0=@m6@020?ofkP80e3dI00<0ooK^03eIZ`3om^h00`3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m
6@3om^h0ooK^00@0ooK^00<0?EV[0=@m6@3D?AT04`3om^h00`0mFJ/0ooK^0?ofkP040?ofkP@0?EV[
2P3om^h00`0mFJ/0ooK^0?ofkP0/0?ofkP030000003om^h0ooK^00@0ooK^0@3oool000D0ooK^00<0
00000?ofkP3om^h0B03om^h00`0mFJ/0ooK^0=@m6@090?ofkP<0e3dI00D0ooK^03eIZ`3om^h0ooK^
0=@m6@0=0?ofkP0403eIZ`3om^h0ooK^0=@m6@d0ooK^00<0?EV[0=@m6@3om^h00P3om^h303eIZ`03
0000000dBID0=4VE00L0=4VE00<0000003A9U@0dBID01P0dBID00`000000=4VE03A9U@0703A9U@03
0000000dBID0=4VE00L0=4VE00<0000003A9U@0dBID01P0dBID00`000000=4VE03A9U@0503A9U@D0
00001`0gCYh00`000000=djN0=@m6@0803M>WP030000000gCYh0=djN00H0=djN00<0000003M>WP3D
?AT0200gCYh00`000000=djN03M>WP0703M>WP030=@m6@0gCYh0=djN00L0=djN00@0000003M>WP3D
?AT0e3dI100000000`3D?AT0>E:V0000000:03UBYP030000003oCR00odhP00<0odhP0`0000050?m<
7`030000003oC1l0?EV[00@0od`O00<000000?m<7`3oC1l01@3oC1l00`000000?EV[0000000403eI
Z`040000003oC1l0?EV[0?m<7`80000000<0odTM0000003oBAd01@3oBAd00`000000odTM0?m97@03
0?m97@030000003oBAd0odTM00@0odTM00<0?EV[0000003oBAd0103oBAd3000000<0nTDL00<00000
0?Y5703jAA`00`3jAA`00`000000nTDL0?Y570030?Y5700303eIZ`3jAA`0nTDL0080nTDL00D00000
0?ofkP3om^h0ooK^0=@m6@040?ofkP030=@m6@0mFJ/0ooK^00<0ooK^00<0e3dI0?ofkP3om^h01P3o
m^h00`3D?AT0ooK^0?ofkP040?ofkP0303eIZ`3om^h0e3dI01<0ooK^00<0?EV[0?ofkP3om^h0100m
FJ/>0?ofkP0303eIZ`3om^h0ooK^02`0ooK^00<000000?ofkP3om^h0103om^h10?ooo`001@3om^h0
0`000000ooK^0?ofkP180?ofkP0303eIZ`3om^h0e3dI00`0ooK^0`3D?AT00`3om^h0e3dI0?ofkP0<
0?ofkP0403eIZ`3om^h0ooK^0=@m6@/0ooK^0`0mFJ/0103D?AT0?EV[03eIZ`0mFJ/30?ofkP030000
000dBID0=4VE00L0=4VE00<0000003A9U@0dBID01P0dBID00`000000=4VE03A9U@0703A9U@030000
000dBID0=4VE00L0=4VE00<0000003A9U@0dBID01P0dBID00`000000=4VE03A9U@0500000080=djN
00<0000003M>WP0gCYh01`0gCYh010000000=djN0=@m6@3D?AT703M>WP030000000gCYh0=djN00L0
=djN00<000000=@m6@0gCYh01`0gCYh00`000000=djN03M>WP0703M>WP030=@m6@0gCYh0=djN00D0
=djN1@000000200iDZH0e3dI0=@m6@3D?AT0>E:V0=@m6@0iDZH000002@0iDZH00`000000odhP0?m>
80050?m>80040000003oCR000000000000<0od`O00<000000?m<7`0mFJ/0103oC1l010000000od`O
0?m<7`3oC1l503eIZ`030?m<7`000000od`O00<0od`O00@000000?m<7`3oC1l0?EV[0P3oC1l30000
00@0odTM00<0e3dI0000003oBAd0103oBAd00`000000odTM0?m97@040?m97@0303eIZ`000000odTM
00@0odTM00<000000?m97@3oBAd00P0000000`3jAA`000000?Y570040?Y570030000003jAA`0nTDL
00<0nTDL00<0?EV[0?Y5703jAA`00P3jAA`01@000000ooK^0?ofkP3om^h0e3dI00D0ooK^00<0?EV[
0=@m6@3D?AT00P3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00@0ooK^00@0?EV[
0?ofkP3om^h0e3dI403om^h503eIZa80ooK^00<0?EV[0?ofkP3om^h0;03om^h00`000000ooK^0?of
kP040?ofkP40oooo00050?ofkP030000003om^h0ooK^04L0ooK^00@0?EV[0?ofkP3om^h0e3dI3@3o
m^h00`0mFJ/0ooK^0=@m6@020=@m6@`0ooK^00@0?EV[0?ofkP3om^h0e3dI1`3om^h403eIZ`80ooK^
00<0?EV[0=@m6@3om^h01@3om^h00`000000=4VE03A9U@0703A9U@030000000dBID0=4VE00L0=4VE
00<0000003A9U@0dBID01P0dBID00`000000=4VE03A9U@0703A9U@030000000dBID0=4VE00@0=4VE
1@00000703M>WP030000000gCYh0=djN00P0=djN00<0e3dI03M>WP0gCYh00`3D?AT403M>WP030000
000gCYh0=djN00L0=djN00<0e3dI03M>WP0gCYh01`0gCYh00`000000=djN03M>WP0603M>WP040=@m
6@000000=djN03M>WPD000000P0iDZH00`000000>E:V03UBYP0403UBYP<0e3dI00<0000003UBYP0i
DZH01`0iDZH00`000000odhP0?m>80050?m>80040000003oCR00odhP0?m>8080000000@0od`O0000
003oC1l0?EV[0P3oC1l603eIZ`<0od`O00@000000?m<7`3oC1l000000`3oC1l01@000000od`O0?m<
7`3oC1l0?EV[00<0od`O00@000000?m<7`00000000000`3oBAd00`000000odTM0?m97@030?m97@03
0000003oBAd0odTM00D0odTM00<0?EV[0?m97@3oBAd00`3oBAd00`000000odTM0?m97@020?m97@<0
00001@3jAA`00`000000nTDL0?Y570020?Y5700303eIZ`3jAA`0nTDL00<0nTDL00D000000?ofkP3o
m^h0ooK^0=@m6@040?ofkP0303eIZ`3om^h0ooK^0080e3dI00<0ooK^0=@m6@3om^h01`3om^h00`3D
?AT0ooK^0?ofkP030?ofkP0403eIZ`3om^h0ooK^0=@m6@X0ooK^1P0mFJ/20?ofkP0303eIZ`3om^h0
ooK^0180ooK^00<0?EV[0?ofkP3om^h0;03om^h00`000000ooK^0?ofkP040?ofkP40oooo00050?of
kP030000003om^h0ooK^04L0ooK^00D0?EV[0?ofkP3om^h0ooK^0=@m6@0<0?ofkP0503eIZ`3om^h0
ooK^0=@m6@3om^h0103D?AT80?ofkP0403eIZ`3om^h0ooK^0=@m6@<0ooK^100mFJ/60?ofkP0303eI
Z`3D?AT0ooK^00D0ooK^00<0000003A9U@0dBID01`0dBID00`000000=4VE03A9U@0703A9U@030000
000dBID0=4VE00H0=4VE00<0000003A9U@0dBID01`0dBID00`000000=4VE03A9U@0400000080=djN
00<0000003M>WP0gCYh01`0gCYh00`000000=djN03M>WP0803M>WP030=@m6@0gCYh0=djN00<0=djN
0`3D?AT00`0gCYh0000003M>WP0803M>WP030=@m6@0gCYh0=djN00L0=djN00<0000003M>WP0gCYh0
1@0gCYh00`000000e3dI00000002000000L0>E:V00<0000003UBYP0iDZH01@0iDZH0103D?AT0>E:V
0=@m6@3D?AT803UBYP030000003oCR00odhP00D0odhP00<000000?m>803oCR000`3oCR000`000000
?EV[03eIZ`0303eIZ`80od`O00<000000?m<7`3oC1l0103oC1l010000000od`O0?m<7`0000030?m<
7`050000003oC1l0od`O0?m<7`0mFJ/00`3oC1l010000000od`O0?m<7`3oC1l2000000030?m97@00
0000odTM00@0odTM00<000000?m97@3oBAd0103oBAd00`000000?EV[0?m97@040?m97@030000003o
BAd0odTM00<0odTM00@000000?m97@00000000000`3jAA`00`000000nTDL0?Y570020?Y5700303eI
Z`3jAA`0nTDL00<0nTDL00D000000?ofkP3om^h0ooK^0=@m6@040?ofkP0303eIZ`3om^h0ooK^0080
ooK^0`3D?AT70?ofkP030=@m6@3om^h0ooK^00<0ooK^00@0?EV[0?ofkP3om^h0e3dI1@3om^h503eI
Z`P0ooK^00<0?EV[0?ofkP3om^h04P3om^h00`0mFJ/0ooK^0?ofkP0/0?ofkP030000003om^h0ooK^
00@0ooK^0@3oool000D0ooK^00<000000?ofkP3om^h0A`3om^h01@0mFJ/0ooK^0?ofkP3om^h0e3dI
00`0ooK^00@0?EV[0?ofkP3om^h0e3dI1@3om^h30=@m6@D0ooK^00@0?EV[0?ofkP3om^h0e3dI0`0m
FJ/:0?ofkP0303eIZ`3D?AT0ooK^00D0ooK^00<0000003A9U@0dBID0200dBID00`000000=4VE03A9
U@0603A9U@030000000dBID0=4VE00H0=4VE00<0000003A9U@0dBID01@0dBID5000000H0=djN00<0
000003M>WP0gCYh0200gCYh00`000000=djN03M>WP0603M>WP030=@m6@000000=djN00L0=djN0P3D
?AT803M>WP030=@m6@000000=djN00P0=djN00<0000003M>WP0gCYh01@0000000`3D?AT0>E:V0000
000903UBYP030000000iDZH0>E:V00@0>E:V00D0e3dI03UBYP0iDZH0000003UBYP020=@m6@H0>E:V
00<000000?m>803oCR00103oCR0010000000odhP0?m>803oCR0403eIZ`040000003oCR00?EV[0000
00<0od`O00<000000?m<7`3oC1l0103oC1l010000000od`O0?m<7`0000030?m<7`030000003oC1l0
od`O0080od`O00@0?EV[0?m<7`3oC1l000001@3oC1l2000000D0odTM00<000000?m97@3oBAd0103o
BAd00`000000?EV[0?m97@040?m97@030000003oBAd0odTM00<0odTM00@000000?m97@3oBAd0odTM
0P0000000`3jAA`000000?Y570030?Y570030000000mFJ/0nTDL00<0nTDL00D000000?ofkP3om^h0
ooK^0=@m6@040?ofkP0303eIZ`3om^h0ooK^00<0ooK^00@0e3dI0?ofkP3D?AT0e3dI1P3om^h00`3D
?AT0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00H0?EV[3@3om^h00`0mFJ/0ooK^0?ofkP0B0?of
kP0303eIZ`3om^h0ooK^02`0ooK^00<000000?ofkP3om^h0103om^h10?ooo`001@3om^h00`000000
ooK^0?ofkP170?ofkP0503eIZ`3om^h0ooK^0?ofkP3D?AT0303om^h01@0mFJ/0ooK^0?ofkP3om^h0
e3dI00L0ooK^0`3D?AT503eIZ`030=@m6@3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3D?AT01@3om^h0
0`000000=4VE03A9U@0803A9U@030000000dBID0=4VE00H0=4VE00<0000003A9U@0dBID01P0dBID0
0`000000=4VE03A9U@0500000080=djN00<0000003M>WP0gCYh01`0gCYh00`000000=djN03M>WP07
03M>WP030000000gCYh0=djN00D0=djN00<0e3dI03M>WP0000002@0gCYh010000000e3dI0=@m6@3D
?AT503M>WP030=@m6@000000=djN00H0=djN1@00000503UBYP030=@m6@0iDZH0000000T0>E:V00<0
000003UBYP0iDZH0100iDZH0103D?AT0>E:V03UBYP00000303UBYP80e3dI100iDZH00`000000odhP
0?m>80040?m>80@0?EV[103oCR0010000000odhP0?m>800mFJ/2000000030?m<7`000000od`O00D0
od`O00@000000?m<7`3oC1l000000`3oC1l00`000000od`O0?m<7`020?m<7`0303eIZ`3oC1l00000
00L0od`O0`0000030?m97@030000003oBAd0odTM00@0odTM00<0000003eIZ`3oBAd0103oBAd00`00
0000odTM0?m97@030?m97@030000003oBAd0odTM00<0odTM0P0000050?Y5700303eIZ`3jAA`0nTDL
0080nTDL00D000000?ofkP3om^h0ooK^0=@m6@050?ofkP0303eIZ`3om^h0ooK^0080ooK^00@0e3dI
0?ofkP3om^h0ooK^0P3D?AT40?ofkP030=@m6@3om^h0ooK^00D0?EV[00<0ooK^0=@m6@3om^h0403o
m^h00`0mFJ/0ooK^0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^02`0ooK^00<000000?ofkP3om^h0103o
m^h10?ooo`001@3om^h00`000000ooK^0?ofkP170?ofkP0503eIZ`3om^h0ooK^0?ofkP3D?AT02`3o
m^h00`0mFJ/0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00@0ooK^100mFJ/40=@m6@030?ofkP3D
?AT0ooK^00`0ooK^00<0?EV[0?ofkP3D?AT01P3om^h00`000000=4VE03A9U@0703A9U@030000000d
BID0=4VE00H0=4VE00<0000003A9U@0dBID0100dBID5000000L0=djN00<0000003M>WP0gCYh01`0g
CYh00`000000=djN03M>WP0703M>WP030000000gCYh0=djN00D0=djN00<0e3dI03M>WP0000002@0g
CYh010000000=djN03M>WP0gCYh30=@m6@0403M>WP3D?AT0=djN00000080=djN1@00000203UBYP03
0000000iDZH0>E:V00D0>E:V00<0e3dI03UBYP0000002@0iDZH00`000000>E:V03UBYP0303UBYP05
0=@m6@0iDZH0>E:V03UBYP0000001@0iDZH20=@m6@80>E:V00<000000?m>803oCR00100mFJ/00`00
0000odhP0?m>80050?m>80040000003oCR00odhP03eIZ`80odhP0`0000050?m<7`040000003oC1l0
od`O000000<0od`O00<000000?m<7`3oC1l00P3oC1l00`0mFJ/0od`O000000070?m<7`030000003o
C1l0od`O0080000000<0odTM0000003oBAd01@3oBAd00`000000odTM03eIZ`030?m97@030000003o
BAd0odTM00@0odTM00<000000?m97@3oBAd0103oBAd3000000<0nTDL00<0?EV[0?Y5703jAA`00P3j
AA`01@000000ooK^0?ofkP3om^h0e3dI00D0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`3D?AT0ooK^
0?ofkP030?ofkP80e3dI1@0mFJ/20?ofkP0503eIZ`3om^h0ooK^0?ofkP3D?AT04@3om^h00`0mFJ/0
ooK^0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^02`0ooK^00<000000?ofkP3om^h0103om^h10?ooo`00
1@3om^h00`000000ooK^0?ofkP170?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h0
203om^h00`0mFJ/0ooK^0?ofkP020?ofkP030=@m6@3om^h0?EV[00@0?EV[1P3om^h00`0mFJ/0ooK^
0=@m6@020=@m6@`0ooK^00<0?EV[0?ofkP3D?AT01P3om^h00`000000=4VE03A9U@0703A9U@030000
000dBID0=4VE00H0=4VE00<0000003A9U@0dBID01000000203M>WP030000000gCYh0=djN00P0=djN
00<0000003M>WP0gCYh01P0gCYh00`000000=djN03M>WP0703M>WP030000000gCYh0=djN00@0=djN
00@0e3dI03M>WP0gCYh000002P0gCYh00`000000=djN03M>WP0303M>WP<0e3dI0`00000703UBYP03
0000000iDZH0>E:V00@0>E:V00@0e3dI03UBYP0iDZH000002@0iDZH00`000000>E:V03UBYP0303UB
YP050=@m6@0iDZH0>E:V03UBYP0000001`0iDZH20=@m6@<0?EV[103oCR000`000000odhP0?m>8004
0?m>80050000003oCR00odhP0?m>800mFJ/00`3oCR0010000000odhP0000000000030?m<7`040000
003oC1l0od`O000000<0od`O00<000000?m<7`3oC1l00`3oC1l00`0mFJ/000000?m<7`050?m<7`03
0000003oC1l0od`O00<0od`O0`0000050?m97@030000003oBAd0?EV[00<0odTM00<000000?m97@3o
BAd0103oBAd00`000000odTM0?m97@040?m97@030000003oBAd0odTM0080000000<0nTDL03eIZ`3j
AA`00`3jAA`01@000000ooK^0?ofkP3om^h0e3dI00D0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`3D
?AT0ooK^03eIZ`0403eIZ`80e3dI00<0ooK^0=@m6@3om^h00P3om^h00`0mFJ/0ooK^0?ofkP020?of
kP030=@m6@3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h04P3om^h00`0mFJ/0ooK^0?ofkP0/0?of
kP030000003om^h0ooK^00@0ooK^0@3oool000D0ooK^00<000000?ofkP3om^h0A`3om^h00`0mFJ/0
ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h00P0mFJ/00`3D?AT0
?EV[0?ofkP0:0?ofkP0503eIZ`3om^h0ooK^0=@m6@3om^h00P3D?AT:0?ofkP0303eIZ`3om^h0e3dI
00H0ooK^00<0000003A9U@0dBID01`0dBID00`000000=4VE03A9U@0403A9U@D000001P0gCYh00`00
0000=djN03M>WP0803M>WP030000000gCYh0=djN00H0=djN00<0000003M>WP0gCYh01`0gCYh00`00
0000=djN03M>WP0303M>WP050=@m6@0gCYh0=djN03M>WP0000002P0gCYh00`000000=djN03M>WP02
03M>WP040000003D?AT0000003UBYP80e3dI200iDZH00`000000>E:V03UBYP0403UBYP040=@m6@0i
DZH0>E:V000000T0>E:V00<0000003UBYP0iDZH00P0iDZH00`3D?AT0>E:V03UBYP0203UBYP030000
000iDZH0>E:V00L0>E:V00<000000?m>803oCR00103oCR000`000000odhP0?m>80040?m>80030000
003oCR00odhP0080odhP00@0?EV[0?m>803oCR0000000`3oCR02000000050?m<7`000000od`O0?m<
7`0000000P3oC1l00`000000od`O0?m<7`040?m<7`0303eIZ`000000od`O00D0od`O00<000000?m<
7`3oC1l0103oC1l00`000000od`O00000003000000040?m97@000000odTM03eIZ`<0odTM00<00000
0?m97@3oBAd0103oBAd00`000000odTM0?m97@040?m97@030000003oBAd0odTM0080odTM0P000000
0`0mFJ/0nTDL0?Y570020?Y570040000003om^h0ooK^0=@m6@D0ooK^00<0?EV[0?ofkP3om^h01@0m
FJ/70?ofkP<0e3dI0P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0
?EV[0?ofkP3om^h04P3om^h00`0mFJ/0ooK^0?ofkP0/0?ofkP030000003om^h0ooK^00@0ooK^0@3o
ool000D0ooK^00<000000?ofkP3om^h0A`3om^h00`0mFJ/0ooK^0?ofkP020?ofkP030=@m6@3om^h0
ooK^00H0ooK^1@0mFJ/20?ofkP030=@m6@3om^h0ooK^00X0ooK^00@0?EV[0?ofkP3om^h0e3dI0`3o
m^h30=@m6@L0ooK^00<0?EV[0?ofkP3D?AT01P3om^h00`000000=4VE03A9U@0703A9U@030000000d
BID0=4VE00@000000P0gCYh00`000000=djN03M>WP0703M>WP030000000gCYh0=djN00L0=djN00<0
000003M>WP0gCYh01`0gCYh00`000000=djN03M>WP0603M>WP030000000gCYh0=djN00<0=djN00<0
e3dI03M>WP0gCYh00P0gCYh00`000000=djN03M>WP0703M>WP030000000gCYh000000080000000H0
>E:V0=@m6@0iDZH0>E:V0000000iDZH20=@m6@H0>E:V00<0000003UBYP0iDZH00`0iDZH01@3D?AT0
>E:V03UBYP0iDZH0000000T0>E:V00<0000003UBYP0iDZH00P0iDZH00`3D?AT0>E:V03UBYP0203UB
YP030000000iDZH0>E:V00H0>E:V00<000000?m>803oCR001@3oCR000`000000odhP0?m>80040?m>
80030000003oCR00odhP0080odhP00<0?EV[0?m>800000001P3oCR03000000050?m<7`000000od`O
0?m<7`0000001P3oC1l00`0mFJ/000000?m<7`050?m<7`030000003oC1l0od`O00@0od`O00<00000
0?m<7`3oC1l00`3oC1l200000080odTM00@0?EV[0?m97@3oBAd000001@3oBAd00`000000odTM0?m9
7@050?m97@030000003oBAd0odTM0080odTM0`0mFJ/01@000000nTDL0?Y5703jAA`000000080ooK^
00<0e3dI0?ofkP0mFJ/01P0mFJ/30?ofkP030=@m6@3om^h0ooK^00L0ooK^00D0e3dI0?ofkP3D?AT0
e3dI03eIZ`050?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h04P3om^h00`0mFJ/0
ooK^0?ofkP0/0?ofkP030000003om^h0ooK^00@0ooK^0@3oool000D0ooK^00<000000?ofkP3om^h0
AP3om^h00`0mFJ/0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^0080ooK^100mFJ/20?ofkP0303eI
Z`3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h02P3om^h01@0mFJ/0ooK^0?ofkP3om^h0e3dI00D0
ooK^0`3D?AT40?ofkP0303eIZ`3om^h0e3dI00H0ooK^00<0000003A9U@0dBID01@0dBID5000000H0
=djN00<0000003M>WP0gCYh01`0gCYh00`000000=djN03M>WP0703M>WP030000000gCYh0=djN00L0
=djN00<0000003M>WP0gCYh01P0gCYh00`000000=djN03M>WP0203M>WP030=@m6@0gCYh0=djN00<0
=djN00<0000003M>WP0gCYh01@0gCYh4000000<0>E:V00P0e3dI03UBYP0iDZH0>E:V0000000iDZH0
?EV[03UBYP80e3dI100iDZH00`000000>E:V03UBYP0303UBYP050=@m6@0iDZH0>E:V03UBYP000000
2@0iDZH01@000000>E:V03UBYP0iDZH0e3dI00D0>E:V00<0000003UBYP0iDZH01P0iDZH00`000000
odhP0?m>80050?m>80030000003oCR00odhP00@0odhP00<000000?m>803oCR000P3oCR000`0mFJ/0
odhP000000070?m>80030000003oCR0000000080000000<0od`O0000003oC1l01@3oC1l00`0mFJ/0
00000?m<7`050?m<7`030000003oC1l0od`O00@0od`O00<000000?m<7`3oC1l0103oC1l300000004
03eIZ`3oBAd0odTM000000D0odTM00<000000?m97@3oBAd0103oBAd603eIZ`040?m97@000000?EV[
0?m97@8000001P0mFJ/40?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h01`3om^h0
1P3D?AT0ooK^0?ofkP3om^h0?EV[0=@m6@@0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`0mFJ/0ooK^
0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^02d0ooK^00<000000?ofkP3om^h00`3om^h10?ooo`00103o
m^h00`000000ooK^0?ofkP170?ofkP0303eIZ`3om^h0ooK^00@0ooK^00@0e3dI03eIZ`0mFJ/0?EV[
1P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00T0ooK^00D0?EV[0?ofkP3om^h0
ooK^0=@m6@080?ofkP80e3dI0`3om^h00`0mFJ/0e3dI0?ofkP050?ofkP030000000dBID0=4VE00D0
00000P0gCYh00`000000=djN03M>WP0703M>WP030000000gCYh0=djN00H0=djN00<0000003M>WP0g
CYh0200gCYh00`000000=djN03M>WP0603M>WP030000000gCYh0=djN00L0=djN00D0000003M>WP0g
CYh0=djN0=@m6@0503M>WP030000000mFJ/0=djN00D000000P0iDZH01@000000>E:V03UBYP0iDZH0
e3dI00D0>E:V00<0000003UBYP0iDZH00P0iDZH30=@m6@0303UBYP000000>E:V00<0>E:V00<0e3dI
03UBYP0iDZH00`0iDZH00`000000>E:V03UBYP0603UBYP050000000iDZH0>E:V03UBYP3D?AT01@0i
DZH00`000000>E:V03UBYP0603UBYP030000003oCR00odhP00D0odhP00<000000?m>803oCR00103o
CR000`000000odhP0?m>80030?m>800303eIZ`000000odhP00D0odhP00H000000?m>803oCR00odhP
0000003oCR03000000D0od`O00<0000003eIZ`3oC1l0103oC1l00`000000od`O0?m<7`040?m<7`03
0000003oC1l0od`O00D0od`O00L000000?m<7`3oC1l0?EV[0000003oBAd0000000D0odTM00<00000
03eIZ`0mFJ/0100mFJ/00`3oBAd000000?m97@040?m97@030000000mFJ/0?EV[0080odTM0P000003
0?ofkP030=@m6@3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP07
0?ofkP060=@m6@3om^h0ooK^0?ofkP0mFJ/0ooK^0P3D?AT20?ofkP030=@m6@3om^h0ooK^00d0ooK^
00<0?EV[0?ofkP3om^h04P3om^h00`0mFJ/0ooK^0?ofkP0]0?ofkP030000003om^h0ooK^00<0ooK^
0@3oool000@0ooK^00<000000?ofkP3om^h0A`3om^h00`0mFJ/0ooK^0?ofkP0403eIZ`80e3dI203o
m^h00`0mFJ/0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00T0ooK^00D0?EV[0?ofkP3om^h0ooK^
0=@m6@0:0?ofkP<0e3dI00<0?EV[0=@m6@3om^h01@3om^h3000000L0=djN00<0000003M>WP0gCYh0
1`0gCYh00`000000=djN03M>WP0603M>WP030000000gCYh0=djN00P0=djN00<0000003M>WP0gCYh0
1P0gCYh00`000000=djN03M>WP0703M>WP040000000gCYh0=djN0=@m6@@0=djN1@00000703UBYP05
0000000iDZH0>E:V03UBYP3D?AT01@0iDZH00`000000>E:V03UBYP0503UBYP80e3dI100iDZH00`3D
?AT0>E:V03UBYP0303UBYP030000000iDZH0>E:V00H0>E:V00D0000003UBYP0iDZH0>E:V0=@m6@05
03UBYP030000000iDZH0>E:V00@0>E:V100000050?m>80030000003oCR00odhP00D0odhP00<00000
0?m>803oCR000`3oCR000`0mFJ/000000?m>80050?m>80050000003oCR00odhP0?m>800000000P3o
CR0010000000odhP0000000000030?m<7`030000000mFJ/0od`O00@0od`O00<000000?m<7`3oC1l0
103oC1l00`000000od`O0?m<7`040?m<7`030000003oC1l0od`O0080od`O00<0?EV[000000000000
1P0mFJ/60?m97@030000003oBAd0odTM00@0odTM00<000000?m97@0mFJ/00`3oBAd01@000000e3dI
0=@m6@3om^h0e3dI00@0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP080?ofkP04
0=@m6@3om^h0ooK^03eIZ`<0ooK^0P3D?AT00`3om^h0e3dI0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^
0180ooK^00<0?EV[0?ofkP3om^h0;@3om^h00`000000ooK^0?ofkP030?ofkP40oooo00040?ofkP03
0000003om^h0ooK^04L0ooK^0`0mFJ/40?ofkP030=@m6@3om^h0e3dI0080e3dI1@3om^h00`0mFJ/0
ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00T0ooK^00D0?EV[0?ofkP3om^h0ooK^0=@m6@0=0?of
kP<0e3dI1@3om^h00`000000=djN03M>WP0703M>WP0303eIZ`000000=djN00L0=djN00<0000003M>
WP0gCYh01`0gCYh00`000000=djN03M>WP0703M>WP030000000gCYh0=djN00L0=djN00<0000003M>
WP0gCYh01P0gCYh00`000000=djN0=@m6@0500000080>E:V00<0000003UBYP0iDZH01`0iDZH01000
0000>E:V03UBYP3D?AT603UBYP030000000iDZH0>E:V00L0>E:V0P3D?AT00`0iDZH0e3dI03UBYP05
03UBYP030000000iDZH0>E:V00H0>E:V00@0000003UBYP0iDZH0e3dI1P0iDZH00`000000>E:V03UB
YP0400000080>eJ]00@000000?m?8@00000000000`3oCR000`000000odhP0?m>80050?m>80030000
003oCR00odhP00<0odhP00<0?EV[0?m>803oCR001@3oCR001@000000odhP0?m>803oCR0000000080
odhP00@000000?m>803oCR00odhP0P0000000`3oC1l0000003eIZ`050?m<7`030000003oC1l0od`O
00@0od`O00<000000?m<7`3oC1l0103oC1l00`000000od`O0?m<7`0503eIZ`8000000`3oBAd00`3D
?AT0odTM0?m97@040?m97@030000003oBAd0odTM00@0odTM00@000000?m97@3oBAd0?EV[0P3oBAd0
0`000000ooK^0?ofkP030=@m6@<0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP08
0?ofkP040=@m6@3om^h0ooK^03eIZ`D0ooK^0P3D?AT>0?ofkP0303eIZ`3om^h0ooK^0100ooK^0`0m
FJ/_0?ofkP030000003om^h0ooK^00<0ooK^0@3oool000@0ooK^00<000000?ofkP3om^h0A`3om^h0
0`0mFJ/0ooK^0?ofkP050?ofkP040=@m6@3om^h0ooK^0?ofkP<0e3dI0P3om^h00`0mFJ/0ooK^0?of
kP030?ofkP030=@m6@3om^h0ooK^00T0ooK^00D0?EV[0?ofkP3om^h0ooK^0=@m6@0=0?ofkP0303eI
Z`3D?AT0ooK^00<0e3dI0`3om^h00`000000=djN03M>WP0703M>WP030000000gCYh0=djN00H0=djN
00<0000003M>WP0gCYh01`0gCYh00`000000=djN03M>WP0703M>WP030000000gCYh0=djN00L0=djN
00<0000003M>WP0gCYh00P0gCYh6000000030=@m6@0iDZH0>E:V00D0>E:V00<0000003UBYP0iDZH0
200iDZH00`000000e3dI03UBYP0603UBYP030000000iDZH0>E:V00L0>E:V00<0000003UBYP3D?AT0
0P3D?AT503UBYP030000000iDZH0>E:V00H0>E:V00@0000003UBYP0iDZH0e3dI100iDZH5000000H0
>eJ]00@000000?m?8@3oCb40odlQ0P0000000`3oCR0000000?m>80050?m>80030000003oCR00odhP
00@0odhP00<0?EV[0?m>803oCR001@3oCR001`000000odhP0?m>803oCR0000000?m>800000001P3o
CR02000000030?m<7`0mFJ/0od`O00<0od`O00<000000?m<7`3oC1l0103oC1l00`000000od`O0?m<
7`030?m<7`@0?EV[0P3oC1l00`0mFJ/0od`O000000020?m<7`80000000<0odTM0000003oBAd01@3o
BAd00`000000odTM0?m97@030?m97@050000003oBAd0odTM0?m97@0mFJ/00P3oBAd01P000000ooK^
0?ofkP3om^h0e3dI0?ofkP80e3dI00<0ooK^03eIZ`3om^h0103om^h00`3D?AT0ooK^0?ofkP080?of
kP040=@m6@3om^h0ooK^03eIZ`H0ooK^00<0e3dI0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0;
0?ofkPD0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP0]0?ofkP030000003om^h0ooK^00<0ooK^0@3oool0
00@0ooK^00<000000?ofkP3om^h0A`3om^h00`0mFJ/0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^
00@0ooK^0P3D?AT00`0mFJ/0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00T0ooK^00D0?EV[0?of
kP3om^h0ooK^0=@m6@0=0?ofkP0303eIZ`3D?AT0ooK^00<0ooK^0`3D?AT00`000000=djN03M>WP07
03M>WP030000000gCYh0=djN00L0=djN00<0000003M>WP0gCYh01P0gCYh00`000000=djN03M>WP08
03M>WP030000000gCYh0=djN00@0=djN1`00000403UBYP030000003D?AT0>E:V00P0>E:V00<00000
03UBYP0iDZH01`0iDZH00`000000e3dI03UBYP0603UBYP030000000iDZH0>E:V00L0>E:V00<00000
03UBYP3D?AT00P0iDZH20=@m6@<0>E:V00<0000003UBYP0iDZH01P0iDZH00`000000>E:V0=@m6@05
00000080>eJ]00<0000003]F[@0kEZd01P0kEZd00`000000odlQ0?m?8@030?m?8@<000001@3oCR00
0`000000odhP0?m>80040?m>80030000000mFJ/0odhP00@0odhP00<000000?m>803oCR000P3oCR00
0`000000odhP000000070?m>8080000000D0?EV[0?m<7`3oC1l0od`O0=@m6@070?m<7`030000000m
FJ/0?EV[00<0?EV[00<0od`O0000003oC1l0103oC1l00`0mFJ/0od`O0?m<7`030?m<7`<000001@3o
BAd00`000000odTM0?m97@030?m97@030000003oBAd0odTM0080odTM00<0?EV[0?m97@0000000`3o
m^h01P3D?AT0ooK^0?ofkP3om^h0e3dI03eIZ`H0ooK^00<0e3dI0?ofkP3om^h01`3om^h0103D?AT0
ooK^0?ofkP0mFJ/60?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h01@3om^h603eI
Z`L0ooK^00<0?EV[0?ofkP3om^h0;@3om^h00`000000ooK^0?ofkP030?ofkP40oooo00040?ofkP03
0000003om^h0ooK^04L0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP050?ofkP<0
e3dI103om^h00`3D?AT0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0e3dI0?ofkP3o
m^h02P3om^h00`0mFJ/0ooK^0=@m6@060?ofkP80e3dI200gCYh00`000000=djN03M>WP0703M>WP03
0000000gCYh0=djN00H0=djN00<0000003M>WP0gCYh0200gCYh00`000000=djN03M>WP0400000080
>E:V00<0000003UBYP0iDZH01P0iDZH00`3D?AT0000003UBYP0803UBYP030000000iDZH0>E:V00L0
>E:V00<0e3dI03UBYP0iDZH01P0iDZH00`000000>E:V03UBYP0703UBYP030000000iDZH0e3dI00@0
>E:V0`3D?AT00`000000>E:V03UBYP0403UBYP@0000000<0e3dI03]F[@0kEZd01@0kEZd00`000000
>eJ]03]F[@0603]F[@030000003oCb40odlQ00@0odlQ00<000000?m?8@0000000`0000000`3oCR00
00000?m>80050?m>80030000000mFJ/0odhP00@0odhP00<000000?m>803oCR000P3oCR000`000000
odhP000000060?m>80040000003oCR00odhP03eIZ`80000000<0od`O0000003oC1l00P3oC1l503eI
Z`D0od`O00<000000?m<7`3oC1l0103oC1l00`0mFJ/0od`O0?m<7`040?m<7`040000003oC1l00000
000000<0odTM00<000000?m97@3oBAd00`3oBAd00`000000odTM0?m97@020?m97@0303eIZ`3oBAd0
000000<0ooK^00<0e3dI0?ofkP3om^h00P3om^h0100mFJ/0e3dI0=@m6@3D?AT30?ofkP030=@m6@3o
m^h0ooK^00L0ooK^00@0e3dI0?ofkP3om^h0?EV[1P3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP0303eI
Z`3om^h0ooK^00D0?EV[3@3om^h00`0mFJ/0ooK^0?ofkP0]0?ofkP030000003om^h0ooK^00<0ooK^
0@3oool000@0ooK^00<000000?ofkP3om^h0A`3om^h00`0mFJ/0ooK^0?ofkP060?ofkP030=@m6@3o
m^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h00`3D?AT00`3om^h0e3dI0?ofkP090?ofkP0303eIZ`3o
m^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0=@m6@050?ofkP<0?EV[2@0g
CYh00`000000=djN03M>WP0603M>WP030000000gCYh0=djN00L0=djN00<0000003M>WP0gCYh01@0g
CYh5000000L0>E:V00<0000003UBYP0iDZH01@0iDZH00`3D?AT0000003UBYP0803UBYP030000000i
DZH0>E:V00L0>E:V00<0e3dI03UBYP0iDZH01P0iDZH00`000000>E:V03UBYP0703UBYP030000003D
?AT0>E:V00L0>E:V0`3D?AT400000080>eJ]00<000000=@m6@0kEZd01`0kEZd00`000000>eJ]03]F
[@0603]F[@030000003oCb40odlQ00@0odlQ00<000000?m?8@3oCb400`3oCb42000000H0odhP00<0
000003eIZ`3oCR00103oCR000`000000odhP0?m>80020?m>80030000003oCR00000000H0odhP00L0
00000?m>803oCR00odhP03eIZ`3oCR00000000@0?EV[0`3oC1l00`000000od`O0?m<7`040?m<7`03
0000003oC1l0od`O00@0od`O00<0000003eIZ`3oC1l00`3oC1l00`000000od`O0?m<7`020?m<7`80
000000<0odTM0000003oBAd0103oBAd00`000000odTM0?m97@030?m97@0303eIZ`3om^h0ooK^0080
ooK^00D0e3dI0?ofkP3om^h0ooK^03eIZ`040?ofkP80e3dI00<0ooK^0=@m6@3om^h0203om^h0103D
?AT0ooK^0?ofkP0mFJ/70?ofkP030=@m6@3om^h0ooK^00T0ooK^1@0mFJ/B0?ofkP0303eIZ`3om^h0
ooK^02d0ooK^00<000000?ofkP3om^h00`3om^h10?ooo`00103om^h00`000000ooK^0?ofkP170?of
kP0303eIZ`3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP020?of
kP<0e3dI2@3om^h00`0mFJ/0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0?EV[0?of
kP3D?AT01@0mFJ/20?ofkP030000000gCYh0=djN00L0=djN00<0000003M>WP0gCYh01P0gCYh00`00
0000=djN03M>WP0703M>WP030000000gCYh0=djN00D000000P0iDZH00`000000>E:V03UBYP0703UB
YP030000000iDZH0>E:V00@0>E:V0P3D?AT00`000000>E:V03UBYP0703UBYP030000000iDZH0>E:V
00H0>E:V00<0e3dI0000000iDZH01`0iDZH00`000000>E:V03UBYP0703UBYP030=@m6@0iDZH0>E:V
00D0>E:V1@0000020=@m6@@0>eJ]00<000000=@m6@0kEZd01`0kEZd00`000000>eJ]03]F[@0603]F
[@030000003oCb40odlQ00@0odlQ00<000000?m?8@3oCb40103oCb43000000<0odhP00@000000?m>
803oCR00?EV[0`3oCR000`000000odhP0?m>80030?m>808000001`3oCR000`000000odhP03eIZ`04
03eIZ`040000003oCR000000000000<0od`O00<000000?m<7`3oC1l0103oC1l00`000000od`O0?m<
7`040?m<7`030000000mFJ/0od`O00<0od`O00<000000?m<7`3oC1l0103oC1l3000000@0odTM00<0
00000?m97@3oBAd00`3oBAd00`0mFJ/0ooK^0?ofkP020?ofkP050=@m6@3om^h0ooK^0?ofkP0mFJ/0
1P3om^h30=@m6@P0ooK^00@0e3dI0?ofkP3om^h0?EV[1`3om^h00`3D?AT0ooK^0?ofkP030?ofkPH0
?EV[0P3om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^02d0ooK^00<000000?ofkP3o
m^h00`3om^h10?ooo`00103om^h00`000000ooK^0?ofkP170?ofkP0303eIZ`3om^h0ooK^00L0ooK^
00<0e3dI0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP030?ofkP030=@m6@3om^h0e3dI00<0e3dI
1@3om^h00`0mFJ/0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00P0ooK^100mFJ/00`3D?AT0ooK^
0?ofkP050?ofkP030000000gCYh0=djN00L0=djN00<0000003M>WP0gCYh01`0gCYh00`000000=djN
03M>WP0403M>WPD00000200iDZH00`000000>E:V03UBYP0603UBYP030000000iDZH0>E:V00<0>E:V
00<0e3dI03UBYP0iDZH00`3D?AT803UBYP030000000iDZH0>E:V00@0>E:V00<0e3dI03UBYP000000
2@0iDZH00`000000>E:V03UBYP0603UBYP030=@m6@0iDZH0>E:V00D000000P0kEZd00`000000>eJ]
03]F[@0203]F[@<0e3dI00<0>eJ]0=@m6@0kEZd0200kEZd00`000000>eJ]03]F[@0603]F[@030000
003oCb40odlQ00<0odlQ00<000000?m?8@3oCb401@3oCb400`000000odlQ0?m?8@02000000050?m>
80000000odhP0?m>800mFJ/00`3oCR000`000000odhP0?m>80030?m>808000000`3oCR0603eIZ`80
odhP00<0?EV[0?m>80000000103oCR02000000030?m<7`000000od`O00D0od`O00<000000?m<7`3o
C1l00`3oC1l00`000000od`O03eIZ`040?m<7`030000003oC1l0od`O00D0od`O00<000000?m<7`00
00000P0000000`3oBAd000000?m97@040?m97@030000000mFJ/0ooK^0080ooK^00D0e3dI0?ofkP3o
m^h0ooK^03eIZ`070?ofkP040=@m6@3om^h0e3dI0=@m6@H0ooK^00@0e3dI0?ofkP3om^h0?EV[1`3o
m^h00`3D?AT0?EV[03eIZ`0303eIZ`P0ooK^00<0?EV[0?ofkP3om^h04P3om^h00`0mFJ/0ooK^0?of
kP0]0?ofkP030000003om^h0ooK^00<0ooK^0@3oool000@0ooK^00<000000?ofkP3om^h0A`3om^h0
0`0mFJ/0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h0103om^h0
0`3D?AT0ooK^0?ofkP020?ofkP<0e3dI0P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP030=@m6@3om^h0
ooK^0080ooK^1P0mFJ/20?ofkP0403eIZ`3om^h0ooK^0=@m6@H0ooK^00<0000003M>WP0gCYh01`0g
CYh00`000000=djN03M>WP0703M>WP030000000gCYh0=djN00@000000P0iDZH00`000000>E:V03UB
YP0803UBYP030000000iDZH0>E:V00H0>E:V00<0000003UBYP0iDZH00P0iDZH00`3D?AT0>E:V03UB
YP0203UBYP030000000iDZH0e3dI0080e3dI1@0iDZH00`000000>E:V03UBYP0403UBYP040=@m6@0i
DZH0>E:V000000P0>E:V00<0000003UBYP0iDZH0100iDZH00`000000e3dI00000002000000L0>eJ]
00<0000003]F[@0kEZd01@0kEZd30=@m6@P0>eJ]00<0000003]F[@0kEZd0100kEZd00`3D?AT00000
03eIZ`050?m?8@030000003oCb40odlQ00@0odlQ00<000000?m?8@3oCb400`3oCb4200000080odhP
00D0?EV[0?m>803oCR00odhP000000050?m>80030000000mFJ/0?EV[0080?EV[0`3oCR000`000000
odhP0?m>80030?m>800303eIZ`000000odhP00D0odhP0`0000040?m<7`030000003oC1l0od`O00@0
od`O00@000000?m<7`3oC1l0?EV[0`3oC1l00`000000od`O0?m<7`040?m<7`030000003oC1l0od`O
00<0od`O0P0000050?m97@030000000mFJ/0ooK^0080ooK^00D0e3dI0?ofkP3om^h0ooK^03eIZ`07
0?ofkP040=@m6@3om^h0ooK^0?ofkP80e3dI1@3om^h00`3D?AT0ooK^03eIZ`020?ofkPH0?EV[3@3o
m^h00`0mFJ/0ooK^0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^02d0ooK^00<000000?ofkP3om^h00`3o
m^h10?ooo`00103om^h00`000000ooK^0?ofkP170?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0e3dI
0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00D0ooK^0`3D?AT3
0?ofkP80?EV[00@0e3dI03eIZ`0mFJ/0?EV[203om^h0100mFJ/0ooK^0?ofkP3D?AT70?ofkP030000
000gCYh0=djN00L0=djN00<0000003M>WP0gCYh0100gCYh5000000L0>E:V00<0000003UBYP0iDZH0
200iDZH00`000000>E:V03UBYP0603UBYP040000000iDZH0>E:V0=@m6@D0>E:V00<0000003UBYP0i
DZH00P0iDZH20=@m6@<0>E:V00<0000003UBYP0iDZH00`0iDZH01@3D?AT0>E:V03UBYP0iDZH00000
00P0>E:V00<0000003UBYP0iDZH0100000000`3D?AT0>eJ]0000000903]F[@030000000kEZd0>eJ]
00D0>eJ]00<0e3dI0000000kEZd00P3D?AT603]F[@030000000kEZd0>eJ]00@0>eJ]00<0e3dI0000
000mFJ/01@3oCb400`000000odlQ0?m?8@040?m?8@030000003oCb40odlQ00@0odlQ0`000000103o
CR00?EV[0?m>803oCR0603eIZ`8000001P3oCR000`000000odhP0?m>80030?m>800303eIZ`000000
odhP00H0odhP00<000000?m>800000000P0000000`3oC1l0e3dI0?m<7`050?m<7`040000003oC1l0
od`O03eIZ`80od`O00<000000?m<7`3oC1l01@3oC1l00`000000od`O0?m<7`040?m<7`<000000`3o
BAd00`000000ooK^03eIZ`020?ofkP050=@m6@3om^h0ooK^0?ofkP0mFJ/01`3om^h00`3D?AT0ooK^
0?ofkP030?ofkP80e3dI0`3om^h503eIZ`D0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`0mFJ/0ooK^
0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^02h0ooK^00<000000?ofkP3om^h00`3om^h10?ooo`00103o
m^h00`000000ooK^0?ofkP170?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h0103o
m^h00`0mFJ/0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00@0ooK^0`0mFJ/40=@m6@030?ofkP3D
?AT0ooK^00/0ooK^00<0?EV[0?ofkP3D?AT01`3om^h00`000000=djN03M>WP0703M>WP030000000g
CYh0=djN00@000000P0iDZH00`000000>E:V03UBYP0703UBYP030000000iDZH0>E:V00P0>E:V00<0
000003UBYP0iDZH01P0iDZH00`000000>E:V0=@m6@0603UBYP030000000iDZH0>E:V00@0>E:V0`3D
?AT00`000000>E:V03UBYP0203UBYP030=@m6@0iDZH0>E:V0080>E:V00<0000003UBYP0iDZH00P0i
DZH7000000<0>eJ]00@0e3dI03]F[@0kEZd000002@0kEZd00`000000>eJ]03]F[@0503]F[@030=@m
6@000000>eJ]0080>eJ]0`3D?AT203]F[@030000000kEZd0>eJ]00@0>eJ]00D0e3dI03]F[@000000
odlQ03eIZ`040?m?8@030000003oCb40odlQ00@0odlQ00<000000?m?8@3oCb400`3oCb400`000000
odlQ0?m?8@0503eIZ`H0odhP0P0000060?m>80030000003oCR00odhP00<0odhP00<0000003eIZ`3o
CR001@3oCR000`000000odhP0?m>80030?m>808000001P3oC1l01`000000od`O0?m<7`3oC1l0?EV[
0?m<7`0000001`3oC1l00`000000od`O0?m<7`030?m<7`040000003oC1l0od`O0?m<7`80000000H0
odTM0000003om^h0?EV[0?ofkP3D?AT40?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3o
m^h00`3om^h503eIZ`030=@m6@3om^h0?EV[00L0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`0mFJ/0
ooK^0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^02h0ooK^00<000000?ofkP3om^h00`3om^h10?ooo`00
103om^h00`000000ooK^0?ofkP170?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h0
0`3om^h00`0mFJ/0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00@0?EV[0P3om^h00`0mFJ/0ooK^
0?ofkP020?ofkP<0e3dI2`3om^h00`0mFJ/0ooK^0=@m6@070?ofkP030000000gCYh0=djN00D0=djN
1@00000703UBYP030000000iDZH0>E:V00L0>E:V00<0000003UBYP0iDZH01`0iDZH00`000000>E:V
03UBYP0603UBYP030000003D?AT0>E:V00L0>E:V00<0000003UBYP0iDZH01P0iDZH30=@m6@80>E:V
00<0e3dI03UBYP0iDZH01`00000403]F[@030000000kEZd0>eJ]00<0>eJ]00@0e3dI03]F[@0kEZd0
00002@0kEZd00`000000>eJ]03]F[@0403]F[@030=@m6@0kEZd0000000H0>eJ]0P3D?AT00`000000
>eJ]03]F[@0403]F[@050=@m6@0kEZd000000?m?8@0mFJ/0103oCb400`000000odlQ0?m?8@040?m?
8@030000003oCb40odlQ00H0?EV[0P3oCb40100mFJ/000000000000000030?m>80@000001@3oCR00
0`000000odhP0?m>80040?m>80030000000mFJ/0odhP00D0odhP00<000000?m>803oCR00103oCR03
000000<0od`O00<000000?m<7`3oC1l00P3oC1l00`0mFJ/0od`O000000060?m<7`030000003oC1l0
od`O00@0od`O00<000000?m<7`3oC1l00`3oC1l200000080ooK^00<0?EV[0=@m6@3om^h00`3om^h0
0`0mFJ/0ooK^0?ofkP050?ofkPH0?EV[103om^h30=@m6@0303eIZ`3om^h0ooK^00D0ooK^00<0e3dI
0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^02h0ooK^00<00000
0?ofkP3om^h00`3om^h10?ooo`00103om^h00`000000ooK^0?ofkP170?ofkP0303eIZ`3om^h0ooK^
00T0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP040?ofkP80?EV[00<0e3dI03eI
Z`3om^h01@3om^h00`0mFJ/0ooK^0?ofkP030?ofkP030=@m6@3om^h0e3dI0080e3dI203om^h0100m
FJ/0ooK^0?ofkP3D?AT70?ofkP030000000gCYh0=djN00@000000`0iDZH00`000000>E:V03UBYP06
03UBYP030000000iDZH0>E:V00L0>E:V00<0000003UBYP0iDZH0200iDZH00`000000>E:V03UBYP05
03UBYP030=@m6@000000>E:V00L0>E:V00<0000003UBYP0iDZH01`0iDZH00`000000>E:V0=@m6@02
0=@m6@8000000P0kEZd00`000000>eJ]03]F[@0603]F[@030000000kEZd0>eJ]0080>eJ]00<0e3dI
03]F[@0kEZd00P0kEZd00`000000>eJ]03]F[@0603]F[@030000000kEZd0>eJ]00<0>eJ]00@0e3dI
03]F[@0kEZd00000200kEZd30=@m6@@0>eJ]00D0e3dI03]F[@000000odlQ03eIZ`040?m?8@030000
003oCb40odlQ0080odlQ1@0mFJ/30?m?8@030000003oCb40odlQ00<0odlQ00<0?EV[000000000000
100000000`3oCR0000000?m>8002000000<0odhP00<000000?m>803oCR00103oCR000`000000odhP
03eIZ`040?m>80030000003oCR00odhP00@0odhP00@000000?m>803oCR00odhP0P0000000`3oC1l0
00000?m<7`040?m<7`0303eIZ`000000od`O00D0od`O00<000000?m<7`3oC1l0103oC1l00`000000
od`O0?m<7`040?m<7`050000003om^h0ooK^03eIZ`3D?AT0103om^h00`0mFJ/0ooK^0?ofkP0503eI
Z`030=@m6@3om^h0ooK^00P0ooK^00@0e3dI0?ofkP0mFJ/0e3dI1P3om^h00`3D?AT0ooK^0?ofkP0:
0?ofkP0303eIZ`3om^h0ooK^0180ooK^00<0?EV[0?ofkP3om^h0;P3om^h00`000000ooK^0?ofkP03
0?ofkP40oooo00040?ofkP030000003om^h0ooK^04L0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`3D
?AT0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00@0?EV[0P3om^h00`3D?AT0ooK^0?ofkP050?of
kP0303eIZ`3om^h0ooK^00@0ooK^00@0e3dI0?ofkP3om^h0ooK^0`3D?AT50?ofkP0403eIZ`3om^h0
ooK^0=@m6@L0ooK^0`00000703UBYP030000000iDZH0>E:V00L0>E:V00<0000003UBYP0iDZH01`0i
DZH00`000000>E:V03UBYP0703UBYP030000000iDZH0>E:V00@0>E:V00<0e3dI03UBYP000000200i
DZH00`000000>E:V03UBYP0503UBYP@0000000<0e3dI03]F[@0kEZd00P3D?AT303]F[@030000000k
EZd0>eJ]00H0>eJ]00@0000003]F[@0kEZd0e3dI1@0kEZd00`000000>eJ]03]F[@0603]F[@030000
000kEZd0>eJ]00<0>eJ]00@0e3dI03]F[@0kEZd00000200kEZd00`000000>eJ]03]F[@020=@m6@05
03]F[@3D?AT0>eJ]03]F[@0000000P3oCb400`0mFJ/0odlQ0?m?8@0603eIZ`030?m?8@000000odlQ
00D0odlQ1`0000060?m?8@8000000`3oCR04000000H0odhP00<000000?m>800mFJ/0103oCR000`00
0000odhP0?m>80040?m>80030000003oCR00odhP00<0odhP0`0000040?m<7`0303eIZ`3oC1l0od`O
00D0od`O00<000000?m<7`3oC1l00`3oC1l00`000000od`O0?m<7`040?m<7`030000003om^h0ooK^
0080ooK^00<0?EV[0?ofkP3om^h01@0mFJ/50?ofkP030=@m6@3om^h0ooK^00P0ooK^00@0e3dI03eI
Z`3om^h0ooK^0P3D?AT50?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h04P3om^h0
0`0mFJ/0ooK^0?ofkP0^0?ofkP030000003om^h0ooK^00<0ooK^0@3oool000@0ooK^00<000000?of
kP3om^h0A`3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP80e3dI00<0ooK^03eIZ`0mFJ/00`0mFJ/70?of
kP030=@m6@3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP040?of
kP80e3dI0`3om^h0100mFJ/0ooK^0?ofkP3D?AT80?ofkP030000000iDZH0>E:V00L0>E:V00<00000
03UBYP0iDZH01P0iDZH00`000000>E:V03UBYP0703UBYP030000000iDZH0>E:V00L0>E:V00<00000
03UBYP0iDZH00`0iDZH0103D?AT0>E:V03UBYP00000903UBYP030000000iDZH0>E:V00@000000P0k
EZd00`000000e3dI03]F[@0403]F[@<0e3dI00<0000003]F[@0kEZd01P0kEZd010000000>eJ]03]F
[@3D?AT503]F[@030000000kEZd0>eJ]00L0>eJ]00D0000003]F[@0kEZd0>eJ]0=@m6@0303]F[@03
0000000kEZd0>eJ]00H0>eJ]00<0000003]F[@0kEZd00P0kEZd40=@m6@H0?EV[00<000000?m?8@3o
Cb40103oCb400`000000odlQ0?m?8@05000000D0odlQ00<0000003eIZ`3oCb401@3oCb43000000@0
odhP0P0000040?m>80040000003oCR00odhP03eIZ`<0odhP00<000000?m>803oCR00103oCR000`00
0000odhP0?m>80050?m>80030000003oCR0000000080000000<0od`O03eIZ`3oC1l01@3oC1l00`00
0000od`O0?m<7`040?m<7`030000003oC1l0od`O00@0od`O00<000000?ofkP0mFJ/01@0mFJ/20?of
kP0303eIZ`3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0?EV[0?ofkP030?of
kP80e3dI0`3om^h00`3D?AT0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^0180ooK^00<0?EV[0?of
kP3om^h0;P3om^h00`000000ooK^0?ofkP030?ofkP40oooo00030?ofkP030000003om^h0ooK^04P0
ooK^00<0?EV[0?ofkP3om^h02@3om^h203eIZ`@0e3dI00<0?EV[0?ofkP3om^h01`3om^h00`3D?AT0
ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h01@3om^h30=@m6@04
03eIZ`3om^h0ooK^0=@m6@P0ooK^00<0000003UBYP0iDZH01`0iDZH00`000000>E:V03UBYP0703UB
YP030000000iDZH0>E:V00L0>E:V00<0000003UBYP0iDZH01`0iDZH01@000000>E:V03UBYP0iDZH0
e3dI00<0>E:V00<0000003UBYP0iDZH01@0iDZH5000000H0>eJ]00<0e3dI0000000kEZd01`0kEZd3
0=@m6@H0>eJ]00<0000003]F[@3D?AT01P0kEZd00`000000>eJ]03]F[@0703]F[@040000000kEZd0
>eJ]0=@m6@@0>eJ]00<0000003]F[@0kEZd01P0kEZd00`000000>eJ]03]F[@0203]F[@040=@m6@0k
EZd000000=@m6@80000000D0odlQ03eIZ`3oCb40odlQ000000040?m?8@D000000`3oCb400`000000
odlQ0?m?8@040?m?8@030000000mFJ/0odlQ00@0odlQ00@000000?m?8@3oCb40odlQ0P000000103o
CR0000000?m>803oCR03000000030?m>80000000odhP0080odhP00@0?EV[0?m>803oCR0000001P3o
CR000`000000odhP0?m>80040?m>80030000003oCR00odhP00<0odhP0P0000000`0mFJ/0od`O0?m<
7`030?m<7`030000003oC1l0od`O00@0od`O00<000000?m<7`3oC1l01`0mFJ/20?ofkP030=@m6@0m
FJ/0ooK^0080ooK^00<0?EV[0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@0m
FJ/0ooK^00D0ooK^0P3D?AT00`3om^h0e3dI0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^0180ooK^00<0
?EV[0?ofkP3om^h0;`3om^h00`000000ooK^0?ofkP020?ofkP40oooo00030?ofkP030000003om^h0
ooK^04P0ooK^00<0?EV[0?ofkP3om^h0103om^h503eIZ`80ooK^00@0e3dI0?ofkP3om^h0ooK^0`3D
?AT80?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h0103om^h00`3D?AT0ooK^0?of
kP080?ofkP<0e3dI00<0ooK^0=@m6@3om^h01`3om^h00`000000>E:V03UBYP0703UBYP030000000i
DZH0>E:V00H0>E:V00<0000003UBYP0iDZH01`0iDZH00`000000>E:V03UBYP0703UBYP040000000i
DZH0>E:V0=@m6@D0>E:V00<0000003UBYP0iDZH01000000203]F[@030000000kEZd0>eJ]00D0>eJ]
00<0e3dI03]F[@000000200kEZd00`000000>eJ]03]F[@020=@m6@@0>eJ]00<000000=@m6@0kEZd0
1P0kEZd00`000000>eJ]03]F[@0703]F[@030000000kEZd0e3dI00D0>eJ]00<0000003]F[@0kEZd0
1P0kEZd00`000000>eJ]03]F[@02000000060=@m6@000000?EZd03eJ]0000000oe4Q0P0000000`0m
FJ/0odlQ0000000400000080odlQ00<000000?m?8@3oCb400`3oCb400`000000odlQ0?m?8@030?m?
8@040000003oCb40odlQ03eIZ`@0odlQ00<000000?m?8@3oCb400`3oCb43000000@0odhP0P000003
0?m>800403eIZ`3oCR00odhP000000H0odhP00<000000?m>803oCR00103oCR000`000000odhP0?m>
80040?m>80030000000mFJ/0000000@0od`O00<000000?m<7`3oC1l00P3oC1l603eIZ`80od`O00<0
00000=@m6@3D?AT00`3om^h00`3D?AT0?EV[0?ofkP020?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0
e3dI0?ofkP3om^h02@3om^h00`3D?AT0?EV[0?ofkP070?ofkP80e3dI2`3om^h00`0mFJ/0ooK^0?of
kP0@0?ofkP<0?EV[<@3om^h00`000000ooK^0?ofkP020?ofkP40oooo00030?ofkP030000003om^h0
ooK^04P0ooK^00<0?EV[0?ofkP3om^h0100mFJ/80?ofkP060=@m6@3om^h0ooK^0?ofkP0mFJ/0ooK^
0`3D?AT50?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`3D?AT0ooK^
0?ofkP080?ofkP0303eIZ`3om^h0e3dI0080e3dI1`3om^h00`000000>E:V03UBYP0703UBYP030000
000iDZH0>E:V00L0>E:V00<0000003UBYP0iDZH01`0iDZH00`000000>E:V03UBYP0703UBYP030000
003D?AT0>E:V0080>E:V1P00000703]F[@030000000kEZd0>eJ]00<0>eJ]00@0e3dI03]F[@0kEZd0
00002@0kEZd010000000>eJ]03]F[@0kEZd30=@m6@80>eJ]00<0e3dI03]F[@0kEZd01@0kEZd00`00
0000>eJ]03]F[@0703]F[@030000000kEZd0e3dI00D0>eJ]00<0000003]F[@0kEZd00P0kEZd70000
000303eJ]03D?AT0?EZd00<0?EZd1`0000060?m?8@030000003oCb40odlQ0080odlQ00<000000?m?
8@3oCb40103oCb4010000000odlQ0?m?8@0mFJ/30?m?8@030000003oCb40odlQ00D0odlQ00<00000
0?m?8@0000000P0000000`3oCR00e3dI0?m>800200000080odhP00<0?EV[0000003oCR001@3oCR00
0`000000odhP0?m>80040?m>80030000003oCR00odhP00@0odhP00@000000?m>803oCR00?EV[0P00
00000`3oC1l0?EV[03eIZ`0403eIZ`030?m<7`000000od`O00D0od`O00<000000?ofkP3om^h00P3D
?AT01P3om^h0e3dI0?ofkP0mFJ/0ooK^03eIZ`L0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0
?EV[0?ofkP080?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h02`3om^h603eIZ`80
ooK^00<0?EV[0?ofkP3om^h0;`3om^h00`000000ooK^0?ofkP020?ofkP40oooo00030?ofkP030000
003om^h0ooK^04P0ooK^0`0mFJ/=0?ofkP040=@m6@3om^h0ooK^03eIZ`@0ooK^0`3D?AT30?ofkP03
0=@m6@3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP080?ofkP05
03eIZ`3om^h0ooK^0=@m6@3om^h00`3D?AT50?ofkP030000000iDZH0>E:V00L0>E:V00<0000003UB
YP0iDZH01P0iDZH00`000000>E:V03UBYP0703UBYP030000000iDZH0>E:V00D0>E:V0P0000000`3D
?AT0000000000002000000<0>eJ]00<0000003]F[@0kEZd01`0kEZd00`000000>eJ]03]F[@0203]F
[@030=@m6@0kEZd0>eJ]0080>eJ]00<0000003]F[@0kEZd01P0kEZd00`000000>eJ]03]F[@0403]F
[@<0e3dI200kEZd00`000000>eJ]03]F[@0603]F[@030000003D?AT0>eJ]00@0>eJ]1P00000403eJ
]0040000000mF[@0?EZd0=@m6@D000001@3oDB40100mFJ/000000000000000030?m?8@030000003o
Cb40odlQ00<0odlQ00<000000?m?8@3oCb40103oCb4010000000odlQ0?m?8@0mFJ/30?m?8@030000
003oCb40odlQ00@0odlQ00<000000?m?8@3oCb400`3oCb4300000080odhP100000060?m>80030000
003oCR00odhP00@0odhP00<000000?m>803oCR00103oCR000`000000?EV[03eIZ`0403eIZ`800000
1@3oC1l00`000000od`O0?m<7`040?m<7`030000003om^h0ooK^0080ooK^0`3D?AT00`0mFJ/0ooK^
03eIZ`070?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI03eIZ`3om^h0203om^h00`3D?AT0ooK^
0?ofkP080?ofkP0303eIZ`3om^h0ooK^00H0ooK^1@0mFJ/70?ofkP0303eIZ`3om^h0ooK^0300ooK^
00<000000?ofkP3om^h00P3om^h10?ooo`000`3om^h00`000000ooK^0?ofkP180?ofkP0303eIZ`3o
m^h0ooK^00h0ooK^00<0e3dI0?ofkP0mFJ/01`3om^h40=@m6@D0ooK^00<0?EV[0?ofkP3om^h01P3o
m^h00`3D?AT0ooK^0?ofkP070?ofkP0503eIZ`3om^h0ooK^0?ofkP3D?AT00`3om^h30=@m6@80ooK^
00<0000003UBYP0iDZH01`0iDZH00`000000>E:V03UBYP0703UBYP030000000iDZH0>E:V00L0>E:V
00<0000003UBYP0iDZH0100000000`0kEZd0e3dI0000000803]F[@030000000kEZd0>eJ]00L0>eJ]
00@0000003]F[@0kEZd0e3dI1@0kEZd00`000000>eJ]03]F[@0603]F[@030000000kEZd0>eJ]00@0
>eJ]00<0e3dI03]F[@0000000P3D?AT603]F[@030000000kEZd0>eJ]00H0>eJ]00<0e3dI03]F[@0k
EZd0100000000`0mF[@0000003eJ]00603eJ]0D00000100mF[@00`000000oe4Q0?mA8@030?mA8@04
03eIZ`000000oe4Q0?mA8@80000000<0e3dI0000003oCb40103oCb400`000000odlQ0?m?8@040?m?
8@050000003oCb40odlQ0?m?8@0mFJ/00P3oCb400`000000odlQ0?m?8@040?m?8@030000003oCb40
odlQ00@0odlQ00<000000?m?8@0000000P000000103oCR0000000000000000050?m>80030000003o
CR00odhP00<0odhP00<000000?m>803oCR001P0mFJ/30?m>800303eIZ`3oCR0000000080odhP0`00
00000`3oC1l000000?m<7`050?m<7`030000003om^h0ooK^00@0ooK^00<0e3dI0?ofkP3D?AT00P0m
FJ/70?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI03eIZ`3om^h0203om^h00`3D?AT0ooK^0?of
kP080?ofkP0303eIZ`3om^h0ooK^00H0?EV[303om^h00`0mFJ/0ooK^0?ofkP0`0?ofkP030000003o
m^h0ooK^0080ooK^0@3oool000<0ooK^00<000000?ofkP3om^h0B03om^h00`0mFJ/0ooK^0?ofkP0>
0?ofkP030=@m6@3om^h0?EV[00X0ooK^0`3D?AT40?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0e3dI
0?ofkP3om^h01`3om^h01@0mFJ/0ooK^0?ofkP3om^h0e3dI00H0ooK^0`3D?AT00`000000>E:V03UB
YP0703UBYP030000000iDZH0>E:V00H0>E:V00<0000003UBYP0iDZH01@0iDZH5000000@0>eJ]0P3D
?AT00`0kEZd0000003]F[@0603]F[@030000000kEZd0>eJ]00L0>eJ]00@0000003]F[@0kEZd0e3dI
1@0kEZd00`000000>eJ]03]F[@0703]F[@030000000kEZd0>eJ]0080>eJ]00@0e3dI03]F[@0kEZd0
00000P0kEZd30=@m6@<0>eJ]00<0000003]F[@0kEZd00P0kEZd4000000030=@m6@000000000000D0
?EZd00<0000003eJ]00mF[@01@000000100mF[@0000003eJ]03D?AT503eJ]0030000003oDB40oe4Q
00<0oe4Q00<0000003eIZ`3oDB400`3oDB43000000@0odlQ00<000000?m?8@3oCb400`3oCb400`00
0000odlQ0?m?8@020?m?8@0303eIZ`3oCb40000000H0odlQ00<000000?m?8@3oCb40103oCb400`00
0000odlQ0?m?8@030?m?8@80000000<0?EV[0?m>800000000P0000000`3oCR0000000?m>80020?m>
80H0?EV[103oCR000`000000odhP0?m>80020?m>800303eIZ`3oCR00000000D0odhP0P0000060?m<
7`030000003om^h0ooK^00<0ooK^00@0e3dI0?ofkP3om^h0ooK^0P0mFJ/00`3D?AT0ooK^0?ofkP04
0?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP0mFJ/02@3om^h00`3D?AT0ooK^0?ofkP06
0?ofkPD0?EV[4P3om^h00`0mFJ/0ooK^0?ofkP0`0?ofkP030000003om^h0ooK^0080ooK^0@3oool0
00<0ooK^00<000000?ofkP3om^h0B@3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP030=@m6@0mFJ/0ooK^
00/0ooK^1@3D?AT00`0mFJ/0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0?EV[0?of
kP3om^h00P3om^h00`3D?AT0ooK^0?ofkP050?ofkP0303eIZ`3D?AT0e3dI00P0>E:V00<0000003UB
YP0iDZH01`0iDZH00`000000>E:V03UBYP04000000<0>eJ]00<0000003]F[@0kEZd00P0kEZd00`3D
?AT0>eJ]03]F[@030=@m6@L0>eJ]00<0000003]F[@0kEZd01P0kEZd00`000000>eJ]0=@m6@0603]F
[@030000000kEZd0>eJ]00L0>eJ]00D0000003]F[@0kEZd0>eJ]0=@m6@0403]F[@030000000kEZd0
>eJ]0080>eJ]0`3D?AT5000000<0?EZd00<0e3dI0000000mF[@0100mF[@5000000H0?EZd00<00000
0=@m6@0mF[@01@0mF[@00`000000oe4Q0?mA8@030?mA8@030000000mFJ/0oe4Q00@0oe4Q00H00000
0?mA8@00000000000?m?8@0000060?m?8@030000003oCb40odlQ00<0odlQ00<0?EV[0000003oCb40
1@3oCb400`000000odlQ0?m?8@040?m?8@030000003oCb40odlQ00@0odlQ0P000000100mFJ/0odhP
0?m>800mFJ/2000000<0?EV[0`3oCR000`000000odhP0?m>80030?m>80030000003oCR00odhP00@0
odhP00<0?EV[0?m>803oCR00103oCR0010000000odhP0000000000040?m<7`030000003om^h0ooK^
00<0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0=@m6@020=@m6@<0ooK^00<0e3dI0?of
kP3om^h0203om^h00`3D?AT0?EV[0?ofkP090?ofkP030=@m6@3om^h0ooK^00H0?EV[0P3om^h00`0m
FJ/0ooK^0?ofkP0A0?ofkP0303eIZ`3om^h0ooK^0340ooK^00<000000?ofkP3om^h00P3om^h10?oo
o`000`3om^h00`000000ooK^0?ofkP190?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3o
m^h02`3om^h0103D?AT0ooK^0?ofkP3om^h30=@m6@H0ooK^00<0e3dI0?ofkP3om^h01`3om^h01@0m
FJ/0ooK^0?ofkP3om^h0e3dI00<0ooK^100mFJ/20?ofkP030000000iDZH0>E:V00L0>E:V00<00000
03UBYP0iDZH01@0iDZH4000000L0>eJ]00<0000003]F[@0kEZd00P3D?AT503]F[@040000003D?AT0
e3dI0=@m6@@0>eJ]00<0000003]F[@0kEZd01`0kEZd00`3D?AT0>eJ]03]F[@0603]F[@030000000k
EZd0>eJ]00H0>eJ]00@0000003]F[@0kEZd0e3dI1@0kEZd00`000000>eJ]03]F[@040000000303eJ
]03D?AT0e3dI00D0?EZd00<0e3dI03eJ]00000001@00000203eJ]0030000000mF[@0?EZd00H0?EZd
00<0e3dI03eJ]00mF[@0100mF[@00`000000oe4Q0?mA8@040?mA8@030000000mFJ/0oe4Q00<0oe4Q
00<000000?mA8@3oDB400P3oDB43000000D0odlQ00<000000?m?8@3oCb400`3oCb400`0mFJ/00000
0?m?8@040?m?8@030000003oCb40odlQ00@0odlQ00<000000?m?8@3oCb40103oCb400`000000?EV[
03eIZ`0303eIZ`030?m>80000000odhP00<000000P3oCR000`000000odhP0?m>80040?m>80030000
003oCR00odhP00@0odhP00<0?EV[0?m>803oCR00103oCR0010000000odhP0?m>803oCR0200000003
0?m<7`000000ooK^00D0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP80
e3dI00<0ooK^0=@m6@3om^h02@3om^h00`3D?AT0?EV[0?ofkP070?ofkPD0?EV[1`3om^h00`0mFJ/0
ooK^0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^0340ooK^00<000000?ofkP3om^h00P3om^h10?ooo`00
0`3om^h00`000000ooK^0?ofkP190?ofkP0303eIZ`3om^h0ooK^0100ooK^00<0e3dI0?ofkP3om^h0
2P3om^h01@3D?AT0ooK^0?ofkP3om^h0?EV[0080ooK^0`3D?AT40?ofkP030=@m6@3om^h0ooK^00H0
ooK^00<0?EV[0?ofkP3om^h00P0mFJ/00`3D?AT0?EV[03eIZ`070?ofkP030000000iDZH0>E:V00H0
>E:V00@0000003UBYP0iDZH0>E:V1000000203]F[@030000000kEZd0>eJ]00L0>eJ]00<000000=@m
6@0kEZd01P0kEZd010000000>eJ]03]F[@0kEZd30=@m6@80>eJ]00<0000003]F[@0kEZd01@0kEZd0
0`3D?AT0000003]F[@0703]F[@030000000kEZd0>eJ]00H0>eJ]00<0000003]F[@3D?AT01@0kEZd4
000000D0?EZd00@0000003eJ]03D?AT0e3dI1P00000703eJ]0030000000mF[@0?EZd00D0?EZd00<0
e3dI0000000mF[@01@0mF[@00`000000oe4Q0?mA8@040?mA8@030000003oDB40?EV[00<0oe4Q00<0
00000?mA8@3oDB400`3oDB400`000000oe4Q00000002000000030?m?8@000000odlQ00D0odlQ00<0
000003eIZ`3oCb40103oCb400`000000odlQ0?m?8@040?m?8@030000003oCb40?EV[00D0?EV[0`3o
Cb400`0mFJ/0odlQ00000002000000<0odhP0`0000050?m>80030000003oCR00odhP00@0odhP00<0
00000?m>800mFJ/0103oCR000`000000odhP0?m>80040?m>808000001P3om^h00`3D?AT0ooK^0?of
kP020?ofkP80?EV[1@3om^h30=@m6@T0ooK^00@0e3dI03eIZ`3om^h0ooK^1P0mFJ/20?ofkP030=@m
6@3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h04P3om^h00`0mFJ/0ooK^0?ofkP0a0?ofkP030000
003om^h0ooK^0080ooK^0@3oool000<0ooK^00<000000?ofkP3om^h0B@3om^h00`0mFJ/0ooK^0?of
kP0@0?ofkP030=@m6@3om^h0ooK^00/0ooK^00@0e3dI0?ofkP3om^h0?EV[1@3om^h50=@m6@H0ooK^
1@0mFJ/20?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0000003UBYP0iDZH00`0iDZH7000000H0>eJ]
00<0000003]F[@0kEZd01`0kEZd00`3D?AT0>eJ]03]F[@0703]F[@030000000kEZd0>eJ]00<0>eJ]
0`3D?AT603]F[@030=@m6@0kEZd0000000P0>eJ]00<0000003]F[@0kEZd01`0kEZd00`3D?AT0>eJ]
03]F[@040000000303eJ]0000000?EZd00D0?EZd1@0000001P0mF[@0e3dI0=@m6@3D?AT0?EZd0000
00L0?EZd00<0000003eJ]00mF[@01@0mF[@00`3D?AT0?EZd03eJ]00503eJ]0030000003oDB40oe4Q
00<0oe4Q00@000000?mA8@3oDB40?EV[0`3oDB400`000000oe4Q0?mA8@020?mA8@030000003oDB40
oe4Q00<0oe4Q0`0000050?m?8@030000000mFJ/0odlQ00@0odlQ00@000000?m?8@3oCb40odlQ1@0m
FJ/40?m?8@030000003oCb40odlQ0080odlQ00<0?EV[0?m?8@0000000P3oCb43000000030?m>8000
00000000008000000`3oCR000`000000odhP0?m>80040?m>80040000003oCR00odhP03eIZ`<0odhP
00<000000?m>803oCR00103oCR000`000000ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^0080ooK^
00<0?EV[0?ofkP0mFJ/01P3om^h0103D?AT0ooK^0=@m6@3D?AT50?ofkPH0?EV[1`3om^h00`3D?AT0
ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^0180ooK^00<0?EV[0?ofkP3om^h0<@3om^h00`000000
ooK^0?ofkP020?ofkP40oooo00030?ofkP030000003om^h0ooK^04T0ooK^00<0?EV[0?ofkP3om^h0
403om^h00`0mFJ/0e3dI0?ofkP0<0?ofkP030=@m6@3om^h0?EV[00T0ooK^0`3D?AT403eIZ`80ooK^
00<0?EV[0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP070?ofkPD000001@0kEZd00`000000>eJ]
03]F[@0603]F[@030000000kEZd0>eJ]00D0>eJ]00<0e3dI03]F[@000000200kEZd00`000000>eJ]
03]F[@0603]F[@<0e3dI0P0kEZd01@3D?AT0>eJ]03]F[@0kEZd0000000P0>eJ]00<0000003]F[@0k
EZd00P0kEZd3000000040=@m6@0000000000000000D0?EZd00<0000003eJ]00000001000000203eJ
]0050000000mF[@0?EZd03eJ]03D?AT00P0mF[@30=@m6@H0?EZd00<0000003eJ]00mF[@0100mF[@0
0`3D?AT0000003eJ]00603eJ]0030000003oDB40oe4Q00<0oe4Q00L000000?mA8@3oDB40oe4Q03eI
Z`3oDB40000000D0oe4Q00<000000?mA8@3oDB40103oDB400`000000oe4Q00000002000000050?m?
8@000000odlQ0?m?8@0mFJ/00P3oCb4603eIZ`80odlQ00<000000?m?8@3oCb40103oCb400`000000
odlQ0?m?8@030?m?8@0303eIZ`000000odlQ00@0odlQ0P0000030?m>80<000001P3oCR001@000000
odhP0?m>803oCR00?EV[0080odhP00<000000?m>803oCR001@3oCR000`000000ooK^0?ofkP040?of
kP030=@m6@3om^h0ooK^0080ooK^00@0?EV[0?ofkP3om^h0?EV[103om^h00`3D?AT0ooK^0?ofkP07
03eIZ`80ooK^00<0e3dI03eIZ`3om^h0203om^h00`3D?AT0ooK^0?ofkP070?ofkP0303eIZ`3om^h0
ooK^0180ooK^00<0?EV[0?ofkP3om^h0<P3om^h00`000000ooK^0?ofkP020?ofkP40oooo00030?of
kP030000003om^h0ooK^04T0ooK^00<0?EV[0?ofkP3om^h0403om^h0100mFJ/0ooK^0=@m6@3D?AT<
0?ofkP030=@m6@3om^h0?EV[00H0ooK^100mFJ/40=@m6@@0ooK^00<0?EV[0?ofkP3om^h00P3om^h0
0`3D?AT0ooK^0?ofkP080?ofkP030000000kEZd0>eJ]00L0>eJ]00<0000003]F[@0kEZd01P0kEZd0
0`000000>eJ]03]F[@0203]F[@80e3dI0P0kEZd00`000000>eJ]03]F[@0703]F[@030000000kEZd0
>eJ]00D0>eJ]00<0000003]F[@0kEZd00`3D?AT303]F[@030000000kEZd0>eJ]00D0>eJ]1P000003
03eJ]0030=@m6@000000?EZd0080?EZd1P00000703eJ]0040000000mF[@0?EZd0=@m6@@0?EZd00<0
000003eJ]03D?AT00P3D?AT303eJ]0030000000mF[@0?EZd00<0?EZd00<0e3dI03eJ]00000001`0m
F[@00`000000oe4Q0?mA8@030?mA8@070000003oDB40oe4Q0?mA8@0mFJ/0oe4Q000000050?mA8@03
0000003oDB40oe4Q00<0oe4Q00<000000?mA8@3oDB400`3oDB42000000D0?EV[00<0odlQ0000003o
Cb40103oCb400`000000odlQ0?m?8@040?m?8@030000003oCb40odlQ00@0odlQ00<0?EV[0?m?8@3o
Cb40103oCb4010000000odlQ0000000000030?m>80<00000103oCR000`000000odhP0?m>80020?m>
800303eIZ`3oCR00000000H0odhP00<000000?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP020?of
kP0303eIZ`3om^h0ooK^00P0?EV[103om^h20=@m6@<0ooK^00<0?EV[0?ofkP3om^h0203om^h00`3D
?AT0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^0180ooK^00<0?EV[0?ofkP3om^h0<P3om^h00`00
0000ooK^0?ofkP020?ofkP40oooo00030?ofkP030000003om^h0ooK^04X0ooK^00<0?EV[0?ofkP3o
m^h03`3om^h00`0mFJ/0ooK^0?ofkP050=@m6@T0ooK^00@0e3dI03eIZ`3om^h0ooK^100mFJ/40?of
kP040=@m6@3om^h0ooK^0?ofkP<0e3dI00<0ooK^03eIZ`3om^h0103om^h00`3D?AT0ooK^0?ofkP08
0?ofkP030000000kEZd0>eJ]00H0>eJ]00<0000003]F[@0kEZd01`0kEZd010000000>eJ]03]F[@3D
?AT503]F[@030000000kEZd0>eJ]00H0>eJ]00<0000003]F[@0kEZd01P0kEZd00`000000e3dI0=@m
6@0203]F[@80e3dI0P0kEZd00`000000>eJ]03]F[@040000000303eJ]0000000?EV[00D0?EZd00<0
e3dI0000000000000`00000503eJ]0030000000mF[@0?EZd00D0?EZd00<0000003eJ]03D?AT01P0m
F[@010000000?EZd03eJ]00mF[@30=@m6@030000000mF[@0?EZd0080?EZd00@0e3dI03eJ]00mF[@0
00001P0mF[@00`000000oe4Q0?mA8@040?mA8@030000003oDB40oe4Q0080oe4Q00<0?EV[0000003o
DB400`3oDB400`000000oe4Q0?mA8@040?mA8@030000003oDB40?EV[00D0?EV[00H0oe4Q00000000
0000?EV[0?m?8@0000060?m?8@030000003oCb40odlQ00@0odlQ00<000000?m?8@3oCb40103oCb40
0`000000?EV[0?m?8@040?m?8@040000003oCb40odlQ0?m?8@<000000`3oCR02000000030?m>8000
0000odhP00@0odhP00<0?EV[0000003oCR001@3oCR000`000000ooK^0?ofkP060?ofkP030=@m6@3o
m^h0ooK^00L0?EV[0`3om^h00`3D?AT0ooK^0?ofkP060?ofkP80e3dI00<0ooK^03eIZ`3om^h02@3o
m^h00`3D?AT0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^0180ooK^00<0?EV[0?ofkP3om^h0<P3o
m^h00`000000ooK^0?ofkP020?ofkP40oooo00030?ofkP030000003om^h0ooK^04X0ooK^00<0?EV[
0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00<0e3dI1@3om^h2
03eIZ`030=@m6@0mFJ/0?EV[00T0ooK^00<0e3dI0?ofkP3om^h00`3om^h40=@m6@<0ooK^00<0e3dI
0?ofkP3om^h0203om^h00`000000>eJ]03]F[@0703]F[@030000000kEZd0>eJ]00H0>eJ]00<00000
03]F[@3D?AT01`0kEZd00`000000>eJ]03]F[@0603]F[@030000000kEZd0>eJ]00D0>eJ]00<0e3dI
03]F[@0kEZd00`0kEZd010000000e3dI0=@m6@3D?AT2000000H0?EZd00<0000003eJ]00000001000
000203eJ]0030000000mF[@0?EZd00D0?EZd00<0000003eJ]00mF[@01@0mF[@00`000000e3dI03eJ
]00603eJ]0030000000mF[@0?EZd00@0?EZd0`3D?AT203eJ]0040=@m6@0mF[@0?EZd000000H0?EZd
00<000000?mA8@3oDB40103oDB400`000000oe4Q0?mA8@020?mA8@0303eIZ`000000oe4Q00<0oe4Q
00@000000?mA8@3oDB40oe4Q1@0mFJ/40?mA8@030000003oDB40oe4Q0080oe4Q00<0?EV[00000000
00001@3oCb400`000000odlQ0?m?8@040?m?8@030000003oCb40odlQ00@0odlQ00@000000?m?8@3o
Cb40?EV[0`3oCb400`000000odlQ0?m?8@040?m?8@800000103oCR02000000H0odhP00<0?EV[0?m>
803oCR00103oCR000`000000ooK^0?ofkP040?ofkPD0?EV[0P3om^h01@0mFJ/0ooK^0?ofkP3om^h0
?EV[00<0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0?EV[0=@m6@090?ofkP030=@m6@3om^h0
ooK^00L0ooK^00<0?EV[0?ofkP3om^h04@3om^h00`0mFJ/0ooK^0?ofkP0c0?ofkP030000003om^h0
ooK^0080ooK^0@3oool000<0ooK^00<000000?ofkP3om^h0BP3om^h00`0mFJ/0ooK^0?ofkP0@0?of
kP0303eIZ`3om^h0ooK^0080ooK^00D0e3dI0?ofkP3om^h0ooK^03eIZ`040=@m6@0403eIZ`3om^h0
ooK^0=@m6@`0ooK^00<0e3dI0?ofkP3om^h0103om^h00`0mFJ/0ooK^0=@m6@020=@m6@030?ofkP3D
?AT0ooK^00T0ooK^00<0000003]F[@0kEZd01`0kEZd00`000000>eJ]03]F[@0503]F[@80e3dI200k
EZd00`000000>eJ]03]F[@0603]F[@030000000kEZd0>eJ]00<0>eJ]0P3D?AT6000000@0?EZd0`3D
?AT203eJ]0D000000P0mF[@00`3D?AT0?EZd03eJ]00203eJ]0030000000mF[@0?EZd00D0?EZd00<0
000003eJ]00mF[@01@0mF[@00`3D?AT0?EZd03eJ]00603eJ]0030000000mF[@0?EZd00@0?EZd00<0
000003eJ]00mF[@00`3D?AT203eJ]0040000000mF[@0?EZd03eJ]0D00000103oDB400`000000oe4Q
0?mA8@030?mA8@040000000mFJ/0oe4Q0?mA8@H0?EV[0P3oDB400`000000oe4Q0?mA8@030?mA8@03
0000003oDB40oe4Q00@0oe4Q00@0?EV[0?mA8@00000000000`3oCb400`000000odlQ0?m?8@040?m?
8@030000003oCb40odlQ00<0odlQ00D000000?m?8@3oCb40odlQ03eIZ`020?m?8@030000003oCb40
odlQ00@0odlQ00<000000?m?8@3oCb400`0000000`3oCR0000000?m>800300000080odhP00<00000
0?m>800mFJ/0103oCR000`000000ooK^03eIZ`0503eIZ`030?ofkP3D?AT0ooK^00<0ooK^00@0?EV[
0?ofkP3om^h0ooK^0`0mFJ/00`3om^h0e3dI0?ofkP0:0?ofkP0303eIZ`3D?AT0ooK^00<0e3dI1P3o
m^h00`3D?AT0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^0100ooK^0`0mFJ/e0?ofkP030000003o
m^h0ooK^0080ooK^0@3oool000<0ooK^00<000000?ofkP3om^h0BP3om^h00`0mFJ/0ooK^0?ofkP0@
0?ofkP0303eIZ`3om^h0ooK^00<0?EV[0P3D?AT00`0mFJ/0ooK^0?ofkP030?ofkPD0e3dI303om^h0
0`3D?AT0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^0080ooK^0`3D?AT:0?ofkP030000000kEZd0
>eJ]00L0>eJ]00<0000003]F[@0kEZd00`0kEZd0103D?AT0>eJ]03]F[@00000803]F[@030000000k
EZd0>eJ]00H0>eJ]00D0000003]F[@0kEZd000000=@m6@0200000080?EZd00<0000003eJ]00mF[@0
100mF[@6000000@0?EZd00<0000003eJ]03D?AT01P0mF[@00`000000?EZd03eJ]00503eJ]0030000
000mF[@0?EZd00<0?EZd00<0e3dI0000000mF[@01`0mF[@00`000000?EZd03eJ]00403eJ]0040000
000mF[@0?EZd0=@m6@80?EZd0P3D?AT4000000<0@5jl00<000000?mB8P0000000P0000000`3oDB40
00000?mA8@040?mA8@@0?EV[0P3oDB400`000000oe4Q0?mA8@030?mA8@030000003oDB40oe4Q00<0
oe4Q00<000000?mA8@3oDB40103oDB40100mFJ/0oe4Q0?mA8@3oDB43000000H0odlQ00<000000?m?
8@3oCb40103oCb400`000000odlQ0?m?8@020?m?8@0303eIZ`3oCb40000000H0odlQ00<000000?m?
8@3oCb400`3oCb43000000<0odhP0`0000000`3oCR00?EV[0?m>80020?m>80<0?EV[1`3om^h00`3D
?AT0ooK^0?ofkP0603eIZ`<0ooK^00<0?EV[0=@m6@3om^h02P3om^h00`0mFJ/0ooK^0?ofkP030?of
kP80e3dI103om^h00`3D?AT0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00X0ooK^1P0mFJ/20?of
kP0303eIZ`3om^h0ooK^03<0ooK^00<000000?ofkP3om^h00P3om^h10?ooo`000P3om^h00`000000
ooK^0?ofkP1;0?ofkP0303eIZ`3om^h0ooK^00h0ooK^1@0mFJ/50?ofkP030=@m6@3om^h0ooK^00L0
ooK^0`3D?AT:0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h0103om^h30=@m6@T0
ooK^00<000000=@m6@0kEZd01`0kEZd00`000000>eJ]03]F[@030=@m6@<0>eJ]00<0000003]F[@0k
EZd01@0kEZd00`000000>eJ]03]F[@0303]F[@D000000P3D?AT503eJ]0030000000mF[@0000000@0
00000P0mF[@010000000?EZd03eJ]00mF[@30=@m6@0303eJ]0000000e3dI00L0?EZd00<0000003eJ
]00mF[@01@0mF[@00`000000?EZd03eJ]00203eJ]0040=@m6@0mF[@0?EZd000000L0?EZd00<00000
03eJ]00mF[@0100mF[@00`000000?EZd0=@m6@0400000003041N_03D?AT0e3dI00D0@5jl00<00000
0?mB8P3oDR800P3oDR83000000@0?EV[00<000000?mA8@0mFJ/00P3oDB400`000000oe4Q0?mA8@03
0?mA8@030000003oDB40oe4Q00<0oe4Q00<000000?mA8@3oDB40103oDB400`000000oe4Q03eIZ`04
0?mA8@8000001@3oCb400`000000odlQ0?m?8@030?m?8@030000003oCb40odlQ00<0odlQ00<0?EV[
0000003oCb401@3oCb400`000000odlQ0?m?8@040?m?8@030000003oCb40odlQ00<0000000<0odhP
0000000000000P0000000`0mFJ/0odhP0?m>80020=@m6@D0ooK^1P0mFJ/20?ofkP0303eIZ`3om^h0
ooK^00D0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP050?ofkP<0e3dI00<0ooK^
0=@m6@3om^h01`3om^h00`0mFJ/0ooK^0?ofkP050?ofkPD0?EV[1`3om^h00`0mFJ/0ooK^0?ofkP0e
0?ofkP040000003om^h0ooK^0?ofkP40oooo00020?ofkP030000003om^h0ooK^04/0ooK^00<0?EV[
0?ofkP3om^h02P3om^h403eIZ`80ooK^00<0?EV[0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP06
0?ofkP0303eIZ`3om^h0e3dI00<0e3dI203om^h00`3D?AT0ooK^0?ofkP030?ofkP0303eIZ`3om^h0
ooK^00<0ooK^00<0e3dI0?ofkP3om^h00`3D?AT70?ofkP030000003D?AT0>eJ]00L0>eJ]0P3D?AT3
03]F[@@0e3dI1`0kEZd6000000@0?EZd00<0e3dI03eJ]00mF[@00P0mF[@5000000L0?EZd00<00000
03eJ]00mF[@0100mF[@30=@m6@L0?EZd00<0000003eJ]00mF[@01@0mF[@01@000000?EZd03eJ]00m
F[@0e3dI00<0?EZd00<0000003eJ]00mF[@01@0mF[@010000000?EZd03eJ]00mF[@4000000030=@m
6@000000@5jl00@0@5jl00@00000041N_03D?AT0e3dI0`10G[`010000000oe8R0?mB8P3oDR8403eI
Z`80000000D0oe4Q0000003oDB40oe4Q03eIZ`020?mA8@030000003oDB40oe4Q00<0oe4Q00<00000
0?mA8@3oDB400`3oDB400`000000oe4Q0?mA8@040?mA8@040000003oDB40oe4Q03eIZ`80oe4Q00<0
00000?mA8@3oDB400`0000000`3oCb4000000?m?8@050?m?8@030000003oCb40odlQ00<0odlQ00<0
000003eIZ`3oCb40103oCb400`000000odlQ0?m?8@050?m?8@030000003oCb40odlQ00<0odlQ0`00
00020?m>80<0000000<0ooK^03eIZ`0mFJ/0100mFJ/20?ofkP030=@m6@3om^h0ooK^0080ooK^00<0
?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^00P0ooK^0P3D
?AT70?ofkP0303eIZ`3om^h0ooK^00H0?EV[303om^h00`0mFJ/0ooK^0?ofkP0e0?ofkP040000003o
m^h0ooK^0?ofkP40oooo00020?ofkP030000003om^h0ooK^04`0ooK^00<0?EV[0?ofkP3om^h0103o
m^h503eIZ`L0ooK^00<0?EV[0?ofkP3om^h01P3om^h20=@m6@L0ooK^00D0?EV[0?ofkP3D?AT0e3dI
0?ofkP030=@m6@H0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP040?ofkP030=@m
6@3om^h0ooK^0080ooK^0`3D?AT50?ofkP030=@m6@0kEZd0>eJ]00@0>eJ]0P3D?AT00`000000>eJ]
03]F[@0603]F[@<0e3dI1000000203eJ]0030000000mF[@0?EZd00<0?EZd0P3D?AT5000000D0?EZd
00<0000003eJ]00mF[@01@0mF[@00`000000?EZd03eJ]00203eJ]080e3dI00<0?EZd0000003D?AT0
0P3D?AT503eJ]0030000000mF[@0?EZd00@0?EZd00@0000003eJ]00mF[@0e3dI100mF[@00`000000
?EZd03eJ]00203eJ]0L000000`10G[`00`3D?AT0@5jl041N_005041N_00400000010G[`0@5jl041N
_0<0e3dI100mFJ/00`3oDR8000000?mB8P030?mB8P<000000P3oDB400`0mFJ/0oe4Q000000050?mA
8@030000003oDB40oe4Q0080oe4Q00<000000?mA8@3oDB40103oDB401@000000oe4Q0?mA8@3oDB40
?EV[0080oe4Q00<000000?mA8@3oDB400`3oDB43000000@0odlQ00<000000?m?8@3oCb40103oCb40
0`000000odlQ03eIZ`040?m?8@030000003oCb40odlQ00@0odlQ00<000000?m?8@3oCb40103oCb40
10000000odlQ0?m?8@00000303eIZ`<000000`3om^h30=@m6@030?ofkP3D?AT0ooK^00<0ooK^00<0
?EV[0?ofkP3om^h01@3om^h00`3D?AT0ooK^03eIZ`090?ofkP0303eIZ`3D?AT0ooK^00X0ooK^00<0
e3dI0?ofkP3om^h00`3om^h503eIZa40ooK^00<0?EV[0?ofkP3om^h0=P3om^h010000000ooK^0?of
kP3om^h10?ooo`000P3om^h00`000000ooK^0?ofkP1<0?ofkP0303eIZ`3om^h0ooK^00@0?EV[303o
m^h00`0mFJ/0ooK^0?ofkP080?ofkP80e3dI1@3om^h01@0mFJ/0ooK^0?ofkP3om^h0e3dI00<0ooK^
0P3D?AT50?ofkP030=@m6@3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h0103om^h00`3D?AT0ooK^
0?ofkP040?ofkP80e3dI0`3om^h00`000000e3dI03]F[@0203]F[@80e3dI0`0kEZd00`000000>eJ]
03]F[@0303]F[@D000000`3D?AT403eJ]0L0000000<0?EZd0000000mF[@01`0mF[@00`000000?EZd
03eJ]00503eJ]0050000000mF[@0?EZd03eJ]03D?AT0100mF[@00`000000?EZd03eJ]0030=@m6@80
?EZd00<0000003eJ]00mF[@01@0mF[@00`000000e3dI03eJ]00303eJ]0H000000`10G[`00`000000
@5jl041N_003041N_0030=@m6@000000@5jl00D0@5jl00<00000041N_010G[`01010G[`00`000000
oe8R0?mB8P030?mB8P030000003oDR80oe8R00<0oe8R00H000000?mB8P00000000000?mA8@0mFJ/5
0?mA8@030000003oDB40oe4Q00<0oe4Q00<000000?mA8@3oDB400`3oDB400`000000oe4Q0?mA8@03
0?mA8@0303eIZ`000000oe4Q00D0oe4Q00<000000?mA8@3oDB400P0000020?m?8@030000003oCb40
odlQ00<0odlQ00@000000?m?8@3oCb40?EV[0`3oCb400`000000odlQ0?m?8@040?m?8@030000003o
Cb40odlQ00<0odlQ1P0mFJ/0103oCb4000000000000mFJ/20?ofkP800000103om^h30=@m6@<0ooK^
00<0?EV[0?ofkP3om^h01@3om^h0103D?AT0ooK^0?ofkP0mFJ/80?ofkP0303eIZ`3om^h0ooK^00T0
ooK^00<0e3dI03eIZ`0mFJ/0100mFJ/20?ofkP0303eIZ`3om^h0ooK^0140ooK^00<0?EV[0?ofkP3o
m^h0=P3om^h010000000ooK^0?ofkP3om^h10?ooo`000P3om^h00`000000ooK^0?ofkP1<0?ofkP<0
?EV[403om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP<0e3dI0`3om^h01@0mFJ/0ooK^0?ofkP3om^h0e3dI
00@0ooK^0`3D?AT20?ofkP030=@m6@3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h01@3om^h00`3D
?AT0ooK^0?ofkP050?ofkP<0e3dI00<0?EV[0=@m6@0kEZd00P3D?AT503]F[@H00000100mF[@01000
0000?EZd03eJ]00mF[@50000000303eJ]03D?AT0e3dI00D0?EZd00<0000003eJ]00mF[@01P0mF[@0
0`000000?EZd03eJ]00503eJ]0030000000mF[@0e3dI00D0?EZd00<0000003eJ]00mF[@00`0mF[@4
0=@m6@H0?EZd00<0e3dI03eJ]00000000`0000000`10G[`00000041N_006041N_00300000010G[`0
@5jl0080@5jl00<0e3dI041N_00000001P10G[`00`000000@5jl041N_004041N_0030000003oDR80
oe8R00<0oe8R00<000000?mB8P3oDR800P3oDR800`000000oe8R0?mB8P020?mB8P030000000mFJ/0
000000@0oe4Q00<000000?mA8@3oDB400P3oDB400`000000oe4Q0?mA8@040?mA8@030000003oDB40
oe4Q00<0oe4Q00<0?EV[0?mA8@3oDB401@3oDB400`000000oe4Q0?mA8@020?mA8@<00000103oCb40
0`000000odlQ0?m?8@020?m?8@0403eIZ`3oCb40odlQ000000D0odlQ00<0000003eIZ`0mFJ/0100m
FJ/00`3oCb4000000?m?8@040?m?8@040000003om^h0ooK^03eIZ`<0ooK^0`0000020?ofkP060=@m
6@3om^h0e3dI0=@m6@3om^h0?EV[1`3om^h01@3D?AT0ooK^0?ofkP3om^h0?EV[00L0ooK^00<0?EV[
0?ofkP3om^h01@3om^h503eIZ`L0ooK^00<0?EV[0?ofkP3om^h04@3om^h00`0mFJ/0ooK^0?ofkP0g
0?ofkP040000003om^h0ooK^0?ofkP40oooo00020?ofkP030000003om^h0ooK^04`0ooK^00<0?EV[
0?ofkP3om^h04@3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP@0e3dI00<0?EV[0?ofkP3om^h00P3om^h0
0`3D?AT0ooK^0?ofkP040?ofkP@0e3dI0`3om^h00`0mFJ/0ooK^0?ofkP050?ofkP030=@m6@3om^h0
ooK^00P0ooK^103D?AT203]F[@@000000P0mF[@00`000000?EZd03eJ]00403eJ]0D00000100mF[@3
0=@m6@L0?EZd00<0000003eJ]00mF[@01P0mF[@00`000000?EZd03eJ]00403eJ]080e3dI1`0mF[@0
0`000000?EZd03eJ]00503eJ]0040000003D?AT0e3dI0=@m6@80000000<0e3dI0000000000001@10
G[`00`000000@5jl041N_005041N_00300000010G[`0@5jl0080@5jl00<0e3dI041N_00000001P10
G[`00`000000@5jl041N_004041N_0030000003oDR80oe8R0080oe8R00<000000?mB8P3oDR800`3o
DR800`000000oe8R0?mB8P030?mB8P060000000mFJ/000000000003oDB4000001@3oDB400`000000
oe4Q0?mA8@030?mA8@030000003oDB40oe4Q00@0oe4Q00<0000003eIZ`3oDB40103oDB400`000000
oe4Q0?mA8@030?mA8@030000003oDB40oe4Q008000000P3oCb400`000000odlQ0?m?8@020?m?8@04
03eIZ`3oCb4000000?m?8@H0?EV[1P3oCb400`000000odlQ0?m?8@030?m?8@050000003om^h0ooK^
0?ofkP0mFJ/01P3om^h2000000@0ooK^00<0?EV[0=@m6@3om^h01P3om^h00`3D?AT0ooK^0?ofkP02
0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0=@m6@3om^h01P0mFJ/40?ofkP030=@m6@3om^h0
ooK^00D0ooK^00<0?EV[0?ofkP3om^h04@3om^h00`0mFJ/0ooK^0?ofkP0g0?ofkP040000003om^h0
ooK^0?ofkP40oooo00020?ofkP030000003om^h0ooK^04d0ooK^00<0?EV[0?ofkP3om^h0403om^h0
0`0mFJ/0ooK^0?ofkP0>0?ofkP@0e3dI0`3om^h00`3D?AT0ooK^0?ofkP060?ofkP<0e3dI0P3om^h0
0`0mFJ/0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00H0ooK^0P3D?AT00`0mFJ/0e3dI00000002
000000L0?EZd1P00000303eJ]0040000000mF[@0?EZd03eJ]080e3dI0P0mF[@010000000e3dI0=@m
6@3D?AT503eJ]0030000000mF[@0?EZd00D0?EZd00<0000003eJ]00mF[@00`0mF[@00`3D?AT0?EZd
0000000703eJ]0030000000mF[@0?EZd0080?EZd1`0000030=@m6@0300000010G[`0@5jl00D0@5jl
00<00000041N_010G[`01010G[`01@000000@5jl041N_010G[`0e3dI0080@5jl00<00000041N_010
G[`01010G[`00`000000@5jl041N_004041N_0030000003oDR80oe8R0080oe8R00<000000?mB8P3o
DR800P3oDR800`000000oe8R0?mB8P030?mB8P030000003oDR80?EV[0080oe8R100000020?mA8@03
0000003oDB40oe4Q00@0oe4Q00<000000?mA8@3oDB400`3oDB4010000000oe4Q0?mA8@0mFJ/30?mA
8@030000003oDB40oe4Q00<0oe4Q00<000000?mA8@3oDB400`3oDB43000000<0odlQ1@0mFJ/40?m?
8@030000003oCb40odlQ00@0odlQ00<000000?m?8@3oCb40103oCb400`000000ooK^0?ofkP020?of
kP0303eIZ`3om^h0ooK^00@0ooK^00L0e3dI00000000000000000?ofkP0mFJ/0ooK^00<0e3dI0`3o
m^h00`3D?AT0ooK^0?ofkP040?ofkP0303eIZ`3om^h0?EV[00D0?EV[2P3om^h00`3D?AT0ooK^0?of
kP040?ofkP0303eIZ`3om^h0ooK^0140ooK^00<0?EV[0?ofkP3om^h0>03om^h010000000ooK^0?of
kP3om^h10?ooo`000P3om^h00`000000ooK^0?ofkP1=0?ofkP0303eIZ`3om^h0ooK^0100ooK^00<0
?EV[0?ofkP3om^h0403om^h00`0mFJ/0e3dI0=@m6@020=@m6@030?ofkP3D?AT0e3dI00P0ooK^103D
?AT80?ofkP040=@m6@3om^h0ooK^0?ofkP@0e3dI0P3om^h0100mFJ/0ooK^0=@m6@00000303eJ]0L0
0000200mF[@00`000000e3dI0=@m6@0503eJ]0030000000mF[@0?EZd00<0e3dI0`0mF[@00`000000
?EZd03eJ]00503eJ]0030000000mF[@0?EZd0080e3dI0`0mF[@00`000000?EZd03eJ]00403eJ]0D0
00000`10G[`00`000000@5jl041N_0020=@m6@80@5jl0`3D?AT5041N_00300000010G[`0@5jl00@0
@5jl00@00000041N_010G[`0e3dI0`10G[`00`000000@5jl041N_004041N_00300000010G[`0@5jl
00@0@5jl00<000000?mB8P3oDR800P3oDR800`000000oe8R0?mB8P020?mB8P030000003oDR80oe8R
00<0oe8R00H000000?mB8P3oDR80?EV[0?mB8P0000030?mB8P@00000103oDB400`000000oe4Q0?mA
8@040?mA8@040000003oDB40oe4Q03eIZ`80oe4Q00<000000?mA8@3oDB40103oDB400`000000oe4Q
0?mA8@030?mA8@H0?EV[0P3oCb400`000000?EV[0?m?8@030?m?8@030000003oCb40odlQ00@0odlQ
00<000000?m?8@3oCb40103oCb400`000000ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^0080ooK^
00<0e3dI0?ofkP3om^h00P3om^h2000000@0ooK^0P3D?AT00`3om^h0e3dI0?ofkP0703eIZ`80ooK^
00<0?EV[0=@m6@3om^h02P3om^h00`3D?AT0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^0140ooK^
00<0?EV[0?ofkP3om^h0>03om^h010000000ooK^0?ofkP3om^h10?ooo`000P3om^h00`000000ooK^
0?ofkP1=0?ofkP0303eIZ`3om^h0ooK^0100ooK^00<0?EV[0?ofkP3om^h0403om^h00`0mFJ/0ooK^
0?ofkP060=@m6@T0ooK^00<0e3dI03eIZ`3D?AT00P3D?AT40?ofkPD0e3dI103om^h40=@m6@D00000
1`0mF[@00`000000?EZd03eJ]00403eJ]080e3dI00<0000003eJ]00mF[@01@0mF[@00`000000?EZd
03eJ]00203eJ]080e3dI0P0mF[@00`000000?EZd03eJ]00503eJ]0030000003D?AT0?EZd00@0?EZd
00<0000003eJ]00mF[@010000002041N_00300000010G[`0@5jl00@0@5jl00<000000=@m6@10G[`0
1010G[`00`000000@5jl0=@m6@020=@m6@80@5jl00<00000041N_010G[`01010G[`00`000000@5jl
0=@m6@04041N_00300000010G[`0@5jl00@0@5jl00<00000041N_010G[`00`10G[`00`000000oe8R
0?mB8P020?mB8P030000003oDR80oe8R0080oe8R00<000000?mB8P3oDR800`3oDR800`000000oe8R
0?mB8P020?mB8P0303eIZ`000000oe8R00<0oe8R00<000000?mB8P3oDR800P0000020?mA8@030000
003oDB40oe4Q00<0oe4Q00<000000?mA8@3oDB400P3oDB400`0mFJ/0oe4Q000000050?mA8@030000
003oDB40?EV[00@0?EV[1P3oDB43000000050?m?8@0mFJ/0odlQ0?m?8@0000001P3oCb400`000000
odlQ0?m?8@030?m?8@0303eIZ`000000ooK^00L0ooK^00D0?EV[0?ofkP3om^h0ooK^0=@m6@040?of
kP0403eIZ`3om^h00000000000L0?EV[1P3om^h01@0mFJ/0ooK^0?ofkP0mFJ/0e3dI00/0ooK^00<0
e3dI0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP0303eIZ`3om^h0ooK^03T0ooK^00@0
00000?ofkP3om^h0ooK^0@3oool00080ooK^00<000000?ofkP3om^h0CP3om^h00`0mFJ/0ooK^0?of
kP0@0?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h00`3om^h:0=@m6@<0ooK^00<0
e3dI03eIZ`3om^h01@3D?AT20?ofkP030=@m6@3om^h0ooK^00<0ooK^1@0000030=@m6@800000200m
F[@010000000?EZd03eJ]00mF[@20=@m6@80?EZd00<0000003eJ]00mF[@01P0mF[@00`000000?EZd
03eJ]00303eJ]0<0e3dI1`0mF[@00`3D?AT0?EZd03eJ]00203eJ]0D000001P10G[`00`000000@5jl
041N_004041N_0030=@m6@10G[`0@5jl00@0@5jl00<00000041N_010G[`00P10G[`40=@m6@H0@5jl
00<0e3dI041N_010G[`00`10G[`00`000000@5jl041N_003041N_00300000010G[`0@5jl00@0@5jl
00<000000?mB8P3oDR800P3oDR800`000000oe8R0?mB8P020?mB8P030000003oDR80oe8R00<0oe8R
00<000000?mB8P3oDR800P3oDR800`0mFJ/0oe8R0?mB8P030?mB8P030000003oDR80oe8R0080oe8R
0`0000040?mA8@030000003oDB40oe4Q00<0oe4Q00@0?EV[0000003oDB40oe4Q1P0mFJ/30?mA8@03
0000003oDB40oe4Q00D0oe4Q00D000000?mA8@3oDB40000003eIZ`020?m?8@030000003oCb40odlQ
00<0odlQ00<000000?m?8@3oCb40103oCb400`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0e3dI
00<0ooK^1P0mFJ/300000080ooK^00@0e3dI0?ofkP3D?AT0e3dI0`3om^h403eIZ`030?ofkP3D?AT0
ooK^00X0ooK^00<0e3dI0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP<0?EV[>`3om^h0
10000000ooK^0?ofkP3om^h10?ooo`000P3om^h00`000000ooK^0?ofkP1>0?ofkP0303eIZ`3om^h0
ooK^0100ooK^00<0?EV[0?ofkP3om^h0403om^h00`0mFJ/0ooK^0?ofkP050?ofkPH0e3dI00<0ooK^
0=@m6@3D?AT0103D?AT00`0mFJ/0ooK^0?ofkP020?ofkP<0e3dI1@0000050?ofkP0303eIZ`3om^h0
e3dI00<0e3dI200mF[@00`000000e3dI0=@m6@0503eJ]0030000000mF[@0?EZd00D0?EZd00<00000
03eJ]00mF[@01P0mF[@30=@m6@80?EZd0P3D?AT5000000@0@5jl00<00000041N_010G[`01@10G[`0
10000000@5jl041N_010G[`20=@m6@03041N_0000000@5jl00D0@5jl00<00000041N_010G[`01010
G[`010000000e3dI0=@m6@3D?AT2041N_0030=@m6@000000@5jl00@0@5jl00<00000041N_010G[`0
0`10G[`00`000000@5jl041N_004041N_0030000003oDR80oe8R0080oe8R00<000000?mB8P3oDR80
0P3oDR800`000000oe8R0?mB8P020?mB8P030000003oDR80oe8R00<0oe8R00<0000003eIZ`3oDR80
0P3oDR800`000000oe8R0?mB8P030?mB8P030000003oDR80oe8R008000000P3oDB4010000000oe4Q
0?mA8@3oDB4603eIZ`80oe4Q00<000000?mA8@3oDB400`3oDB400`000000oe4Q0?mA8@050?mA8@03
0000003oDB40oe4Q00<0oe4Q00<0?EV[0000000000001@3oCb400`000000odlQ0?m?8@030?m?8@03
0000000mFJ/0ooK^00X0ooK^1@0mFJ/20?ofkP0303eIZ`3om^h0ooK^00@0ooK^0P0000000`3om^h0
?EV[03eIZ`0403eIZ`<0ooK^00<0?EV[0?ofkP3D?AT02`3om^h00`3D?AT0ooK^0?ofkP030?ofkP03
03eIZ`3om^h0ooK^00X0ooK^1P0mFJ/00`3om^h0?EV[0?ofkP0k0?ofkP040000003om^h0ooK^0?of
kP40oooo00020?ofkP030000003om^h0ooK^04l0ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0
ooK^0?ofkP0@0?ofkP0303eIZ`3om^h0ooK^00P0ooK^1P3D?AT20?ofkP0303eIZ`3D?AT0e3dI0080
e3dI1@0000030=@m6@L0ooK^00@0?EV[0?ofkP3om^h0e3dI0P3om^h40=@m6@<0?EZd0P3D?AT00`00
0000?EZd03eJ]00503eJ]0030000000mF[@0?EZd00D0?EZd00<0000003eJ]00mF[@01@0mF[@30000
00<0e3dI0`10G[`00`000000@5jl041N_004041N_00300000010G[`0@5jl00D0@5jl00@00000041N
_010G[`0e3dI0`10G[`00`000000@5jl041N_004041N_00300000010G[`0@5jl00@0@5jl00@00000
041N_010G[`0@5jl0`3D?AT00`000000@5jl041N_003041N_00300000010G[`0@5jl00<0@5jl00@0
0000041N_010G[`0@5jl1@0000020?mB8P030000003oDR80oe8R0080oe8R00<000000?mB8P3oDR80
0`3oDR800`000000oe8R0?mB8P020?mB8P060000003oDR80oe8R03eIZ`3oDR8000001P3oDR801000
0000oe8R0?mB8P3oDR8703eIZ`050?mA8@000000oe4Q0?mA8@0mFJ/00P3oDB400`000000oe4Q0?mA
8@030?mA8@030000003oDB40oe4Q00D0oe4Q00<000000?mA8@3oDB40103oDB400`000000?EV[0?mA
8@0200000080odlQ00<000000?m?8@3oCb400`3oCb400`000000?EV[0?ofkP060?ofkPH0?EV[1@3o
m^h00`0mFJ/0ooK^0?ofkP020?ofkPD0?EV[0`0000030?ofkP80e3dI00<0ooK^03eIZ`3om^h00P0m
FJ/:0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h01@3om^h503eIZ`H0ooK^00<0
?EV[0?ofkP3om^h0>`3om^h010000000ooK^0?ofkP3om^h10?ooo`000P3om^h00`000000ooK^0?of
kP1?0?ofkP0303eIZ`3om^h0ooK^0100ooK^00<0?EV[0?ofkP3om^h0403om^h0100mFJ/0ooK^0?of
kP3om^h603eIZ`<0ooK^103D?AT6000000<0e3dI103om^h40=@m6@D0ooK^00@0?EV[0?ofkP3om^h0
e3dI0P3om^h00`000000?EZd0=@m6@030=@m6@<0?EZd00<0000003eJ]00mF[@01@0mF[@00`000000
?EZd03eJ]00503eJ]0030000000mF[@0?EZd00@0000000<0@5jl0=@m6@3D?AT00`10G[`30=@m6@03
041N_0000000@5jl00D0@5jl00<00000041N_010G[`01@10G[`20=@m6@D0@5jl00<00000041N_010
G[`01010G[`00`000000@5jl041N_003041N_00300000010G[`0@5jl0080e3dI0P10G[`20=@m6@@0
@5jl00@00000041N_010G[`0@5jl1P000003049R``030000003oDR80000000800000103oDR800`00
0000oe8R0?mB8P020?mB8P030000003oDR80oe8R00<0oe8R00H000000?mB8P3oDR80?EV[0?mB8P00
00020?mB8PP0?EV[00@0oe8R0000003oDR80oe8R0P0000020?mA8@060000003oDB40oe4Q0?mA8@0m
FJ/000001P3oDB400`000000oe4Q0?mA8@040?mA8@030000003oDB40oe4Q00@0oe4Q00@000000?mA
8@3oDB40?EV[0P3oDB43000000D0odlQ00@0e3dI03eIZ`3om^h0ooK^1@0mFJ/50?ofkP030=@m6@0m
FJ/0ooK^0080ooK^1P0mFJ/30?ofkP030=@m6@3om^h0ooK^0080ooK^0P0000030?ofkP060=@m6@0m
FJ/0ooK^0=@m6@3om^h0?EV[2@3om^h00`3D?AT0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00H0
?EV[2P3om^h00`0mFJ/0ooK^0?ofkP0l0?ofkP040000003om^h0ooK^0?ofkP40oooo00020?ofkP03
0000003om^h0ooK^04l0ooK^00<0?EV[0?ofkP3om^h0403om^h00`0mFJ/0ooK^0?ofkP0>0?ofkPH0
?EV[203om^h5000000L0e3dI0P3om^h30=@m6@<0ooK^00<0e3dI0?ofkP3D?AT00P3D?AT20?ofkP03
03eIZ`3om^h0ooK^00D0e3dI100mF[@30=@m6@0303eJ]0000000?EZd00H0?EZd00<0000003eJ]00m
F[@00P0mF[@5000000<0@5jl0P3D?AT2041N_0030000000mFJ/0@5jl00<0@5jl0`3D?AT6041N_003
00000010G[`0@5jl00<0@5jl00<0e3dI00000010G[`01@10G[`00`000000@5jl041N_004041N_003
00000010G[`0@5jl00<0@5jl00<00000041N_03D?AT01010G[`00`000000@5jl0=@m6@020=@m6@D0
00000P12H/<020000000@V;3049R``12H/<0e3dI049R``000000?EV[0`3oDR83000000030?mB8P00
0000oe8R00@0oe8R00<000000?mB8P3oDR800P3oDR800`000000oe8R0?mB8P0603eIZ`80oe8R00<0
00000?mB8P3oDR800`3oDR800`000000oe8R0?mB8P030?mB8P8000001@3oDB400`0mFJ/0oe4Q0?mA
8@030?mA8@030000003oDB40oe4Q00@0oe4Q00<000000?mA8@3oDB40103oDB400`000000oe4Q0?mA
8@020?mA8@0303eIZ`3oDB4000000080oe4Q0P0000000`3oCb40?EV[03eIZ`0403eIZ`X0ooK^1P0m
FJ/80?ofkP030=@m6@3om^h0ooK^00@0ooK^0`0000000`0mFJ/0ooK^0=@m6@020=@m6@030?ofkP0m
FJ/0ooK^00L0ooK^00<0e3dI0?ofkP3om^h01P0mFJ/?0?ofkP0303eIZ`3om^h0ooK^03d0ooK^00@0
00000?ofkP3om^h0ooK^0@3oool00080ooK^00<000000?ofkP3om^h0D03om^h00`0mFJ/0ooK^0?of
kP0?0?ofkP0303eIZ`3om^h0ooK^00P0ooK^1P0mFJ/20?ofkP0303eIZ`3om^h0ooK^00@0ooK^1@00
00070?ofkPP0e3dI0P3om^h50=@m6@<0ooK^1@3D?AT00`3om^h0e3dI0?ofkP020?ofkP8000001@0m
F[@30=@m6@@0?EZd1`000004041N_00400000010G[`0e3dI0=@m6@D0@5jl00<00000041N_010G[`0
1010G[`00`000000e3dI0=@m6@020=@m6@80@5jl00<00000041N_010G[`00P10G[`0103D?AT0@5jl
041N_0000006041N_00300000010G[`0@5jl00<0@5jl00<00000041N_010G[`01010G[`0103D?AT0
@5jl041N_010G[`600000003049R``3D?AT0e3dI00D0@V;300@00000049R``12H/<0e3dI0P12H/<0
1@000000oe8R03eIZ`3oDR80000000<0oe8R100000020?mB8P040000003oDR80oe8R0?mB8PD0?EV[
0P3oDR800`000000?EV[0?mB8P020?mB8P030000003oDR80oe8R00<0oe8R00<000000?mB8P3oDR80
103oDR8010000000oe8R0000000000020?mA8@030000003oDB40?EV[00<0oe4Q00<000000?mA8@3o
DB40103oDB400`000000oe4Q0?mA8@040?mA8@030000003oDB40oe4Q00<0oe4Q00<0000003eIZ`0m
FJ/0103oDB42000000030=@m6@0mFJ/0ooK^00H0ooK^1P0mFJ/30?ofkP0303eIZ`3om^h0?EV[00L0
ooK^00<0e3dI0?ofkP3om^h0203om^h2000000030?ofkP3D?AT0ooK^0080e3dI00@0?EV[0?ofkP3o
m^h0ooK^1`0mFJ/20?ofkP0303eIZ`3om^h0ooK^0100ooK^00<0?EV[0?ofkP3om^h0?@3om^h01000
0000ooK^0?ofkP3om^h10?ooo`000P3om^h00`000000ooK^0?ofkP1@0?ofkP0303eIZ`3om^h0ooK^
0100ooK^00@0?EV[0?ofkP3om^h0ooK^1P0mFJ/90?ofkP0303eIZ`000000000000<000003@3om^h0
0`0mFJ/0ooK^0=@m6@0>0=@m6@<0ooK^00<0?EV[0=@m6@3D?AT00P3D?AT40?ofkP030000000mF[@0
?EZd0080?EZd0`0000020=@m6@8000001010G[`00`000000@5jl041N_004041N_080e3dI00<00000
041N_010G[`01@10G[`00`000000@5jl041N_004041N_00400000010G[`0@5jl041N_0<0e3dI00@0
0000041N_03D?AT0e3dI0`10G[`00`000000@5jl041N_004041N_00300000010G[`0@5jl00@0@5jl
00@00000041N_010G[`0@5jl0P3D?AT400000080@V;300<00000049R``12H/<00`12H/<010000000
e3dI0=@m6@3D?AT2049R``0300000012H/<0e3dI00<0@V;300D000000?mB8P0mFJ/0oe8R00000003
0?mB8P040000003oDR80oe8R0?mB8PH0?EV[00<0oe8R0000003oDR800`3oDR8010000000oe8R0?mB
8P0mFJ/20?mB8P030000003oDR80oe8R0080oe8R00<000000?mB8P3oDR80103oDR800`000000oe8R
0?mB8P020?mB8P@0000000@0?EV[0?mA8@3oDB4000001P3oDB400`000000oe4Q0?mA8@030?mA8@80
00001@3oDB400`000000oe4Q03eIZ`050?mA8@050000003D?AT0ooK^03eIZ`3D?AT01P0mFJ/50?of
kP030=@m6@3om^h0ooK^0080ooK^0P0mFJ/70?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0?EV[0?of
kP3om^h00`00000603eIZ`<0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP0@0?of
kP0303eIZ`3om^h0ooK^03h0ooK^00@000000?ofkP3om^h0ooK^0@3oool000030?ofkP000000ooK^
0580ooK^00<0?EV[0?ofkP3om^h03P3om^h603eIZ`X0ooK^1P00000C0?ofkP0303eIZ`3om^h0ooK^
0080ooK^1P3D?AT40?ofkP@0e3dI00@0ooK^03eIZ`3om^h0ooK^0`3D?AT30?ofkP@000001010G[`0
10000000e3dI0=@m6@3D?AT4041N_08000000P10G[`20=@m6@<0@5jl00<00000041N_010G[`01@10
G[`00`000000@5jl041N_004041N_00300000010G[`0@5jl00<0@5jl0`3D?AT5041N_00300000010
G[`0@5jl00@0@5jl00@00000041N_010G[`0@5jl1@000000103D?AT0@V;3049R``000005049R``03
00000012H/<0@V;300<0@V;300@00000049R``12H/<0@V;30P3D?AT00`000000@V;30=@m6@03049R
``050000003oDR80oe8R03eIZ`0000000P3oDR8503eIZ`030?mB8P000000oe8R008000000P3oDR80
1@000000oe8R0?mB8P3oDR80000000@0oe8R00<0?EV[0000003oDR800`3oDR800`000000oe8R0?mB
8P040?mB8P030000003oDR80oe8R00<0oe8R00H000000?mB8P3oDR80oe8R0000000mFJ/2000000D0
oe4Q00<000000?mA8@3oDB400`3oDB400`000000oe4Q0?mA8@040?mA8@050000003oDB40oe4Q0?mA
8@0mFJ/00P3oDB400`000000?EV[03eIZ`0403eIZ`030?ofkP3D?AT0e3dI00L0ooK^00<0e3dI0?of
kP3om^h00`3om^h00`0mFJ/0ooK^03eIZ`050?ofkP030=@m6@3om^h0ooK^00H0ooK^1P0mFJ/20?of
kP8000000`3om^h01@0mFJ/0e3dI0=@m6@3om^h0e3dI00<0ooK^00<0?EV[0?ofkP3om^h0403om^h0
0`0mFJ/0ooK^0?ofkP0o0?ofkP040000003om^h0ooK^0?ofkP40oooo00000`3om^h000000?ofkP1C
0?ofkP0303eIZ`3om^h0ooK^00T0ooK^100mFJ/20?ofkP0303eIZ`3om^h0ooK^00H0ooK^1@000006
0?ofkP0303eIZ`3om^h0ooK^0100ooK^00<0?EV[0?ofkP3om^h01@3om^h70=@m6@040?ofkP3D?AT0
ooK^0?ofkP<0e3dI0`3om^h40=@m6@030?ofkP000000000000L0@5jl00<00000041N_03D?AT00P3D
?AT3041N_080e3dI1P10G[`00`000000@5jl041N_005041N_00300000010G[`0@5jl00@0@5jl00<0
0000041N_010G[`00P3D?AT2041N_0040000003D?AT0e3dI0=@m6@80@5jl00<00000041N_010G[`0
0P10G[`600000080@V;300<000000=@m6@3D?AT01012H/<00`000000@V;3049R``03049R``030000
0012H/<0@V;30080@V;300<00000049R``12H/<00`12H/<30=@m6@80@V;300@000000?mB8P3oDR80
oe8R100mFJ/00`000000oe8R0?mB8P030?mB8P040000003oDR80oe8R0?mB8P<000000`3oDR800`00
0000oe8R0?mB8P020?mB8P030000000mFJ/0oe8R00<0oe8R00<000000?mB8P3oDR800`3oDR800`00
0000oe8R0?mB8P030?mB8P030000003oDR80oe8R00<0oe8R00<0000003eIZ`3oDR800P0000020?mA
8@030000003oDB40oe4Q00<0oe4Q00<000000?mA8@3oDB40103oDB400`000000oe4Q0?mA8@0603eI
Z`040?ofkP3D?AT0ooK^03eIZ`D0ooK^0`3D?AT40?ofkP030=@m6@3om^h0ooK^0080ooK^00D0?EV[
0?ofkP3om^h0ooK^03eIZ`040?ofkP040=@m6@3om^h0ooK^0?ofkPD0?EV[00D0ooK^03eIZ`3om^h0
ooK^0=@m6@050?ofkP<000000`0mFJ/20=@m6@80ooK^00<0?EV[0?ofkP3om^h03@3om^h403eIZd<0
ooK^00<000000?ofkP3om^h00@3oool000030?ofkP000000ooK^05<0ooK^00<0?EV[0?ofkP3om^h0
1@3om^h403eIZ`L0ooK^00<0?EV[0?ofkP3om^h01@00000;0?ofkP0303eIZ`3om^h0ooK^0140ooK^
00<0?EV[0?ofkP3om^h01`3om^h80=@m6@80ooK^00@0?EV[0=@m6@3D?AT0e3dI0P3om^h00`3D?AT0
ooK^0=@m6@030=@m6@0300000010G[`0@5jl00@0@5jl0P0000050=@m6@03041N_0000000@5jl00H0
@5jl00<00000041N_010G[`01@10G[`00`000000@5jl041N_003041N_0030000003D?AT0e3dI00@0
@5jl00@00000041N_010G[`0@5jl0`3D?AT4000000<0@V;300<00000049R``12H/<00P12H/<00`3D
?AT00000049R``04049R``0300000012H/<0@V;300<0@V;300<00000049R``12H/<00P12H/<00`00
0000@V;3049R``02049R``80e3dI0P12H/<20=@m6@090000000mFJ/0?EV[03eIZ`000000oe8R03eI
Z`3oDR80000000@0oe8R00<000000?mB8P3oDR800P3oDR800`000000oe8R0?mB8P03000000@0oe8R
00@000000?mB8P3oDR80?EV[0P3oDR800`000000oe8R0?mB8P030?mB8P030000003oDR80oe8R00<0
oe8R00<000000?mB8P3oDR800P3oDR8200000080oe8R00<0?EV[0?mB8P3oDR800P0000050?mA8@04
0000003oDB40oe4Q0?mA8@L0?EV[0`3oDB401P000000?EV[03eIZ`3D?AT0ooK^03eIZ`T0ooK^0P3D
?AT00`3om^h0e3dI0?ofkP040?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP0mFJ/01@0m
FJ/50?ofkP0603eIZ`3om^h0ooK^0?ofkP3D?AT0ooK^1P0mFJ/0103om^h000000000003om^h203eI
Z`030?ofkP0mFJ/0ooK^00P0ooK^1`0mFJ/00`3om^h0?EV[03eIZ`140?ofkP030000003om^h0ooK^
0040oooo00000`3om^h000000?ofkP1D0?ofkP0303eIZ`3om^h0ooK^00@0?EV[2@3om^h500000140
ooK^00<0?EV[0?ofkP3om^h0403om^h00`0mFJ/0ooK^0?ofkP0;0?ofkPP0e3dI0P3om^h50=@m6@03
0?ofkP0mFJ/0?EV[00T0e3dI00<00000041N_010G[`00P10G[`30=@m6@0300000010G[`0@5jl00@0
@5jl00<00000041N_010G[`01@10G[`010000000@5jl041N_010G[`20=@m6@0300000010G[`0@5jl
0080@5jl1P000002049R``@0e3dI0`12H/<01`000000@V;3049R``12H/<0e3dI049R``0000001@12
H/<00`000000@V;3049R``03049R``0300000012H/<0@V;30080@V;300H00000049R``12H/<0@V;3
0=@m6@000005049R``040000003oDR80oe8R000000<0oe8R00<0?EV[0?mB8P3oDR800`3oDR801@00
0000oe8R0?mB8P3oDR80000000@0oe8R00@000000?mB8P00000000000P3oDR801P000000oe8R0?mB
8P0mFJ/0oe8R000000D0oe8R00<000000?mB8P3oDR800`3oDR800`000000oe8R0?mB8P020?mB8P03
0000003D?AT0oe8R00<0oe8R00D0?EV[0?mB8P000000oe8R0000000803eIZ`030?mA8@0000000000
00D0oe4Q0P0000030?ofkP80?EV[303om^h30=@m6@<0ooK^00<0?EV[0?ofkP3om^h01P0mFJ/00`3D
?AT0ooK^0?ofkP060?ofkPL0?EV[2@3om^h2000000040?ofkP0mFJ/0?EV[0?ofkPP0?EV[1P3om^h2
03eIZdH0ooK^00<000000?ofkP3om^h00@3oool000030?ofkP000000ooK^05@0ooK^0`0mFJ/70?of
kPH000000`3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0303eIZ`3om^h0ooK^0140ooK^00<0?EV[0?of
kP3om^h03@3om^h@0=@m6@030?ofkP000000000000H0@5jl00<00000041N_010G[`01010G[`30=@m
6@D0@5jl0P000006041N_0040000003D?AT0e3dI041N_0H000000`12H/<00`000000@V;3049R``03
049R``0300000012H/<0@V;300<0e3dI00@0@V;30000003D?AT0e3dI0`12H/<00`000000@V;3049R
``02049R``0300000012H/<0@V;300<0@V;300<00000049R``12H/<00P12H/<01P000000@V;30=@m
6@3D?AT0@V;3000000D0@V;300@000000?mB8P3oDR8000000`3oDR800`0mFJ/0oe8R0?mB8P020?mB
8P030000003oDR80oe8R0080oe8R00D000000?mB8P3oDR80oe8R000000040?mB8P<000000`3oDR80
0`0mFJ/0oe8R0?mB8P030?mB8P030000003oDR80oe8R0080oe8R0P0000040?mB8P030000003oDR80
oe8R00<0oe8R1P0mFJ/00`3oDR80000000000002000000<0oe4Q00<000000?mA8@3oDB40103oDB40
0`000000ooK^0?ofkP020?ofkP030=@m6@3om^h0?EV[00`0ooK^00<0e3dI0?ofkP3om^h01P0mFJ/5
0?ofkP030=@m6@0mFJ/0ooK^0080ooK^1P0mFJ/30?ofkP030=@m6@3om^h0ooK^00T0ooK^0P0mFJ/3
00000080?EV[2`3om^h203eIZdP0ooK^00<000000?ofkP3om^h00@3oool000030?ofkP000000ooK^
05@0ooK^00<0?EV[0?ofkP3om^h00P3om^h5000000T0ooK^00<0?EV[0?ofkP3om^h04@3om^h00`0m
FJ/0ooK^0?ofkP0@0?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0=@m6@3D?AT01@3D?AT30?of
kPD0e3dI00<0ooK^0000000000001@10G[`2000000H0@5jl00<000000=@m6@3D?AT00P3D?AT3041N
_00300000010G[`0@5jl0080@5jl0P3D?AT3000000<0@V;300<00000049R``12H/<01012H/<00`00
0000@V;3049R``03049R``0300000012H/<0@V;30080@V;30`3D?AT4049R``0300000012H/<0@V;3
00<0@V;300<00000049R``12H/<00P12H/<00`000000@V;3049R``02049R``030000003D?AT0@V;3
0080@V;300<00000049R``12H/<00P12H/<01@000000oe8R0?mB8P3oDR8000000080oe8R00<00000
0?mB8P0mFJ/00P3oDR800`000000oe8R0?mB8P020?mB8P030000003oDR80oe8R0080oe8R00<00000
0?mB8P3oDR800P3oDR800`000000oe8R0?mB8P03000000030?mB8P0mFJ/0oe8R0080oe8R00<00000
0?mB8P3oDR800P3oDR800`000000oe8R0?mB8P030?mB8P030000003oDR80?EV[00@0?EV[00@00000
0?mB8P3oDR80?EV[0P3oDR82000000<0oe8R0`0000060?mA8@030000003om^h0ooK^0080ooK^00@0
e3dI0?ofkP0mFJ/0ooK^0P0mFJ/60?ofkPL0?EV[0P3om^h0100mFJ/0e3dI0=@m6@3D?AT40?ofkPH0
?EV[103om^h01@0mFJ/0ooK^0?ofkP3om^h0e3dI00H0ooK^200mFJ/30?ofkP8000002`0mFJ]:0?of
kP030000003om^h0ooK^0040oooo00000`3om^h000000?ofkP1D0?ofkPD000003`3om^h00`0mFJ/0
ooK^0?ofkP0@0?ofkP0303eIZ`3om^h0ooK^0140ooK^00<0?EV[0?ofkP3om^h02P3om^h403eIZ`<0
ooK^00<0?EV[0=@m6@3D?AT01@3D?AT20?ofkP030=@m6@3om^h0?EV[00<0e3dI00<00000041N_010
G[`01010G[`00`000000@5jl041N_004041N_08000000P10G[`30=@m6@<000000P3D?AT3049R``03
00000012H/<0@V;300<0@V;300<00000049R``12H/<01012H/<00`000000@V;3049R``03049R``04
00000012H/<0e3dI0=@m6@80@V;300H000000=@m6@3D?AT0e3dI049R``000005049R``0300000012
H/<0@V;300<0@V;300<00000049R``12H/<00P3D?AT4049R``0300000012H/<0@V;300@0000000<0
oe8R0000003oDR800P3oDR801P000000oe8R0?mB8P0mFJ/0oe8R000000<0oe8R00<000000?mB8P3o
DR800P3oDR800`000000oe8R0?mB8P020?mB8P030000003oDR80oe8R0080oe8R00L000000?mB8P00
0000000003eIZ`3oDR80000000@0oe8R00<000000?mB8P3oDR801P0mFJ/40?mB8P030000003oDR80
oe8R0080oe8R0P0mFJ/50?mB8P80000000<0oe8R0000000000000P3oDB42000000D0ooK^00<0e3dI
0?ofkP0mFJ/00P3om^h703eIZ`<0ooK^00<0e3dI0?ofkP3om^h00P3om^h903eIZ`030=@m6@3om^h0
ooK^0080ooK^0`0mFJ/00`3om^h0?EV[0?ofkP030?ofkP030=@m6@3om^h0?EV[00@0?EV[0`3om^h8
03eIZ`030?ofkP0mFJ/0000000800000100mFJ]>0?ofkP030000003om^h0ooK^0040oooo00000`3o
m^h000000?ofkP1?0?ofkPD0000000<0ooK^03eIZ`3om^h04@3om^h00`0mFJ/0ooK^0?ofkP0A0?of
kP0303eIZ`3om^h0ooK^0100ooK^00<0?EV[0?ofkP3om^h01@3om^h503eIZ`L0ooK^00<0?EV[0?of
kP3om^h00P3om^h80=@m6@<0ooK^0`3D?AT5041N_08000001010G[`5000000D0e3dI1P12H/<20000
00@0@V;300<00000049R``12H/<01012H/<00`000000@V;3049R``02049R``80e3dI1@12H/<00`00
0000@V;3049R``030=@m6@@0@V;300<00000049R``12H/<00`12H/<01@000000e3dI0=@m6@12H/<0
00000080@V;31@00000204AVb`030000003oDR8000000080000000<0oe8R0000003oDR800`3oDR80
1@0mFJ/0oe8R0?mB8P3oDR80000000@0oe8R00<000000?mB8P3oDR800P3oDR800`000000oe8R0?mB
8P020?mB8P030000003oDR80oe8R0080oe8R00<0000003eIZ`0000000P3oDR8503eIZ`030?mB8P00
0000000000D0oe8R0P0000040?mB8P80000000<0oe8R03eIZ`3oDR800P3oDR800`000000oe8R0?mB
8P030?mB8P8000001P3om^h603eIZ`80ooK^0P0mFJ/40?ofkPP0?EV[1`3om^h30=@m6@H0ooK^6@0m
FJ/40?ofkP800000D03om^h00`000000ooK^0?ofkP010?ooo`0000<0ooK^0000003om^h0B@3om^h6
000000L0ooK^00<0?EV[0?ofkP3om^h0403om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0303eIZ`3om^h0
ooK^0140ooK^00<0?EV[0?ofkP3om^h0100mFJ/=0?ofkP0303eIZ`3om^h0ooK^00@0ooK^2@3D?AT2
0?ofkP@0e3dI00<0@5jl0000000000000P0000070=@m6@D0@V;30`3D?AT5049R``0300000012H/<0
@V;30080@V;300<00000049R``12H/<01012H/<01P000000@V;30=@m6@3D?AT0@V;3000000D0@V;3
00<00000049R``12H/<00P12H/<010000000e3dI0=@m6@3D?AT2049R``0300000012H/<0@V;30080
000000<0e3dI0000000000001000000204AVb`0500000014I//0A6K;04AVb`0000000`3oDR800`00
0000oe8R00000002000000<0oe8R00D0000003eIZ`3oDR80oe8R000000030?mB8P030000003oDR80
oe8R0080oe8R00<000000?mB8P3oDR800P3oDR800`000000oe8R0?mB8P030?mB8PD0?EV[0P000003
0?mB8P030000003D?AT0oe8R00@0oe8R00<000000?mB8P3oDR800`3oDR800`000000oe8R0?mB8P02
0?mB8P0303eIZ`000000000000D0oe8R0P0000000`3om^h0?EV[03eIZ`0403eIZ`030=@m6@0mFJ/0
ooK^00D0ooK^1P0mFJ/0103om^h0e3dI0?ofkP3om^h203eIZ`T0ooK^00<0e3dI0?ofkP3om^h00P3D
?ATE03eIZ`030?ofkP3D?AT0ooK^00/0ooK^0`00001=0?ofkP030000003om^h0ooK^0040oooo0000
0`3om^h000000?ofkP140?ofkPD000003@3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0303eIZ`3om^h0
ooK^0140ooK^00<0?EV[0?ofkP3om^h03P3om^h503eIZa80ooK^00<0?EV[0?ofkP3om^h01P3om^h3
0=@m6@030?ofkP3D?AT0e3dI00/0e3dI00<00000049R``12H/<01012H/<2000000D0@V;300@00000
0=@m6@3D?AT0e3dI0`12H/<00`000000@V;3049R``02049R``8000001012H/<20=@m6@@0@V;300<0
0000049R``12H/<00`12H/<00`000000@V;3049R``02049R``0300000012H/<0@V;300<0e3dI0P00
00020=@m6@0500000014I//0A6K;04AVb`0000001014I//01@000000A6K;04AVb`14I//000000080
oe8R00@000000?mB8P3oDR8000000P3oDR84000000030?mB8P0mFJ/0000000<0oe8R00<000000?mB
8P3oDR800P3oDR800`000000oe8R0?mB8P020?mB8P030000000mFJ/0?EV[00@0?EV[0`3oDR8203eI
Z`80oe8R0`0000060?mB8P030000003oDR80oe8R0080oe8R0P0000050?mB8P030000000mFJ/0oe8R
00<0oe8R00<0e3dI03eIZ`0mFJ/00P0mFJ/50?ofkP030=@m6@0mFJ/0ooK^00H0?EV[103om^h203eI
Z`040=@m6@3om^h0ooK^03eIZ`T0ooK^3@0mFJ/20?ofkP030=@m6@0mFJ/0?EV[00@0?EV[1P3om^h0
0`3D?AT0ooK^0?ofkP0>0?ofkP800000B`3om^h00`000000ooK^0?ofkP010?ooo`0000<0ooK^0000
003om^h0?`3om^h5000001<0ooK^00<0?EV[0?ofkP3om^h0403om^h00`0mFJ/0ooK^0?ofkP0@0?of
kP0303eIZ`3om^h0ooK^00P0ooK^1P0mFJ/30?ofkP0303eIZ`3om^h0ooK^0140ooK^00<0?EV[0?of
kP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP070=@m6@040?ofkP000000?EV[049R``@0e3dI0P000006
049R``8000001012H/<00`000000@V;3049R``040=@m6@0300000012H/<0@V;300<0@V;300@00000
049R``3D?AT0e3dI0P12H/<00`000000@V;3049R``02049R``0300000012H/<0@V;30080@V;300@0
0000049R``12H/<0@V;31000000204AVb`060000003D?AT0e3dI0=@m6@14I//000000`14I//01@00
0000A6K;04AVb`14I//0000000@0A6K;00@000000?mB8P3oDR8000000P3oDR801@000000oe8R0?mB
8P3oDR8000000080oe8R00<0000003eIZ`3oDR800`3oDR801P000000oe8R0?mB8P3oDR8000000?mB
8PD0?EV[0`3oDR800`000000oe8R0?mB8P020?mB8P050000003oDR80oe8R03eIZ`3oDR800P000000
0`3oDR800000000000020?mB8P800000103oDR800`000000oe8R0?mB8P040?mB8P030000003oDR80
oe8R0080?EV[00@0oe8R0000003om^h0ooK^0P3D?AT40?ofkPD0?EV[2`3om^h0103D?AT0?EV[03eI
Z`0mFJ/20?ofkPP0?EV[00<0ooK^0=@m6@0mFJ/01@0mFJ/00`3om^h0e3dI0=@m6@0503eIZ``0ooK^
00<0e3dI0?ofkP3om^h0403om^h3000004P0ooK^00<000000?ofkP3om^h00@3oool000030?ofkP00
0000ooK^03X0ooK^1@00000H0?ofkP0303eIZ`3om^h0ooK^0100ooK^00<0?EV[0?ofkP3om^h04@3o
m^h0100mFJ/0ooK^0?ofkP3om^h603eIZ`T0ooK^00<0?EV[0?ofkP3om^h04P3om^h00`0mFJ/0ooK^
0?ofkP050?ofkP0303eIZ`3om^h0ooK^00<0ooK^1`3D?AT00`0mFJ/000000=@m6@02049R``<0e3dI
00<00000049R``12H/<01012H/<00`000000@V;3049R``02049R``8000001012H/<30=@m6@<0@V;3
0P3D?AT5049R``0500000012H/<0@V;3049R``0000000`12H/<5000000H0A6K;0P3D?AT204AVb`<0
e3dI0P14I//01@000000A6K;04AVb`14I//0000000<0A6K;00@000000?mB8P3oDR8000000P3oDR80
1@000000oe8R0?mB8P3oDR80000000<0oe8R00H000000?mB8P0mFJ/000000?mB8P00000603eIZ`03
0?mB8P000000oe8R00@0oe8R00<000000?mB8P3oDR800P3oDR800`000000oe8R0?mB8P020?mB8P03
03eIZ`3oDR80oe8R00<0oe8R0`0000030?mB8P8000001@3oDR82000000@0oe8R00<0000003eIZ`3o
m^h00P3om^h803eIZ`d0ooK^1`0mFJ/40?ofkPH0?EV[0P3om^h703eIZ`80e3dI00<0ooK^0=@m6@3o
m^h02`3om^h00`3D?AT0ooK^0?ofkP0D0?ofkP800000AP3om^h00`000000ooK^0?ofkP010?ooo`00
00<0ooK^0000003om^h0=03om^h6000001h0ooK^00<0?EV[0?ofkP3om^h0403om^h00`0mFJ/0ooK^
0?ofkP0>0?ofkPH0?EV[403om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^00@0ooK^
00<0?EV[0?ofkP3om^h01`3om^h70=@m6@@0@V;3103D?AT4049R``8000001012H/<00`000000@V;3
049R``02049R``D0e3dI0P12H/<010000000@V;3049R``12H/<9000000<0A6K;00H0000004AVb`14
I//0A6K;00000014I//20=@m6@0304AVb`000000A6K;0080A6K;00<0000004AVb`3D?AT00P3D?AT3
04AVb`0500000014I//0A6K;04AVb`0000000P3oDR8010000000oe8R0?mB8P0000030?mB8P030000
003oDR80oe8R00L0?EV[0P3oDR801@000000oe8R0?mB8P3oDR80000000D0oe8R00@000000?mB8P3o
DR80oe8R0P0000030?mB8P80000000<0oe8R03eIZ`0mFJ/00P3oDR8200000080oe8R0`0000060?mB
8P030000003oDR80oe8R00<0oe8R1P0mFJ/50?ofkP0303eIZ`3D?AT0e3dI00H0ooK^1`0mFJ/00`3D
?AT0?EV[03eIZ`020?ofkPl0?EV[203om^h30=@m6@/0ooK^00<0e3dI0?ofkP3om^h05P3om^h30000
04<0ooK^00<000000?ofkP3om^h00@3oool000030?ofkP000000ooK^02l0ooK^1@00000T0?ofkP03
03eIZ`3om^h0ooK^0100ooK^00<0?EV[0?ofkP3om^h0203om^h603eIZ`<0ooK^00<0?EV[0?ofkP3o
m^h04@3om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3o
m^h02P3om^h90=@m6@80@V;300@000000=@m6@3D?AT0e3dI0`12H/<2000000L0e3dI0`12H/<00`00
0000@V;30=@m6@020=@m6@<000000`14I//01@000000A6K;04AVb`14I//0000000@0A6K;00@00000
04AVb`14I//0A6K;0P3D?AT304AVb`0300000014I//0A6K;0080A6K;00@0000004AVb`14I//00000
0`3D?AT01`000000A6K;04AVb`14I//000000?mB8P0000000P3oDR8803eIZ`@0oe8R00<0000003eI
Z`0mFJ/00`0000020?mB8P030000003oDR80oe8R0080oe8R0P0000030?mB8P030000003oDR80oe8R
0080oe8R00<000000?mB8P3oDR800`3oDR800`0mFJ/000000?mB8P030?mB8P80000000<0oe8R0000
000000000P3oDR800`000000?EV[03eIZ`0503eIZ`D0ooK^0`0mFJ/20?ofkP0303eIZ`3D?AT0ooK^
00L0?EV[1@3om^h703eIZ`80ooK^1`0mFJ/00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^
00<0e3dI1`3om^h00`3D?AT0ooK^0?ofkP0J0?ofkP800000@@3om^h00`000000ooK^0?ofkP010?oo
o`0000<0ooK^0000003om^h0:P3om^h5000002X0ooK^00<0?EV[0?ofkP3om^h0403om^h0100mFJ/0
ooK^0?ofkP3om^h603eIZ`T0ooK^00<0?EV[0?ofkP3om^h04P3om^h00`0mFJ/0ooK^0?ofkP0A0?of
kP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h01P3om^h603eIZ`030?ofkP0mFJ/0e3dI
00@0e3dI00<0@V;30=@m6@3D?AT02@3D?AT200000080@V;30P000003049R``D0000000@0A6K;0=@m
6@3D?AT0e3dI1014I//01@000000A6K;04AVb`14I//0000000@0A6K;00D000000=@m6@3D?AT0A6K;
0000000404AVb`0500000014I//0A6K;04AVb`0000000P14I//010000000A6K;04AVb`0000020=@m
6@0304AVb`000000?EV[00@0?EV[00@000000?mB8P3oDR8000000P3oDR800`000000oe8R0?mB8P02
0?mB8P050000003oDR80oe8R0?mB8P0mFJ/00P3oDR83000000<0oe8R00<000000?mB8P3oDR800P3o
DR8010000000oe8R0?mB8P3oDR82000000@0oe8R0P000000103oDR80?EV[03eIZ`3oDR8200000003
0?mB8P0mFJ/0?EV[00D0?EV[0`3oDR82000000T0ooK^1P0mFJ/30?ofkP030=@m6@0mFJ/0?EV[00l0
?EV[1P3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00<0ooK^0P3D?AT50?ofkP03
0=@m6@3om^h0ooK^01`0ooK^0P00000o0?ofkP030000003om^h0ooK^0040oooo00000`3om^h00000
0?ofkP0U0?ofkPD00000;`3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkPH0?EV[403om^h00`0mFJ/0ooK^
0?ofkP0A0?ofkP0303eIZ`3om^h0ooK^0180ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`020?ofkPH0
?EV[1@3om^h603eIZ`D0e3dI1012H/<200000004049R``3D?AT0e3dI0=@m6@P000000`14I//20000
00@0A6K;103D?AT00`14I//0000004AVb`0204AVb`0300000014I//0A6K;0080e3dI00D0000004AV
b`14I//0A6K;0000000304AVb`0500000014I//0A6K;04AVb`0000000P14I//010000000A6K;04AV
b`00000204AVb`0403eIZ`000000oe8R00000080oe8R00@000000?mB8P3oDR8000000`3oDR801@00
0000oe8R0?mB8P3oDR8000000080oe8R0P000000103oDR80?EV[03eIZ`0000020?mB8P@000000P3o
DR82000000<0oe8R00<000000?mB8P3oDR800P3oDR82000000<0oe8R1P0mFJ/20?mB8P8000000`3o
DR83000000H0ooK^1`0mFJ/00`3D?AT0ooK^03eIZ`0>03eIZ`h0ooK^00<0e3dI0?ofkP3om^h02`3o
m^h00`3D?AT0ooK^0?ofkP060?ofkP<0e3dI00<0ooK^0=@m6@3om^h0803om^h3000003`0ooK^00<0
00000?ofkP3om^h00@3oool000030000003om^h0ooK^0200ooK^1@00000e0?ofkP0303eIZ`3om^h0
ooK^00L0ooK^1P0mFJ/30?ofkP0303eIZ`3om^h0ooK^0140ooK^00<0?EV[0?ofkP3om^h04@3om^h0
0`0mFJ/0ooK^0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^00<0?EV[1@3om^h603eIZ`80ooK^00<0?EV[
0?ofkP0mFJ/0103om^h50=@m6@80@V;3100000001@14I//0e3dI0=@m6@3D?AT0000000<0A6K;00<0
000004AVb`14I//00`14I//00`000000A6K;04AVb`0204AVb`0300000014I//0A6K;00<0e3dI00<0
000004AVb`14I//00P3D?AT304AVb`0500000014I//0A6K;04AVb`0000000P14I//01P000000A6K;
04AVb`14I//0000004AVb`P0000000H0oe0R000000000000oe8R0=@m6@0000020?mB8P040000003o
DR80oe8R00000080oe8R0P0000020?mB8P030000003oDR80oe8R0080000000@0oe8R03eIZ`0mFJ/0
oe8R0P0000020?mB8P<000000P3oDR82000000<0oe8R0P00000503eIZ`040000003oDR80oe8R0?mB
8P80?EV[0P0000030?mB8P0303eIZ`000000000000<0ooK^1@0mFJ/30?ofkPH0?EV[00<0ooK^03eI
Z`0mFJ/01@0mFJ/20?ofkP80e3dI0P3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^
00/0ooK^00<0e3dI0?ofkP3om^h02P3om^h20=@m6B@0ooK^0P00000j0?ofkP030000003om^h0ooK^
0040oooo00000`000000ooK^0?ofkP0J0?ofkPH00000>P3om^h0100mFJ/0ooK^0?ofkP3om^h603eI
Z`T0ooK^00<0?EV[0?ofkP3om^h04P3om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP0303eIZ`3om^h0ooK^
0140ooK^00D0?EV[0?ofkP3om^h0?EV[0?ofkP0603eIZ`L0ooK^00D0?EV[0?ofkP3om^h0ooK^03eI
Z`060?ofkP040000003D?AT0e3dI0=@m6@<0A6K;0P00000304AVb`<0e3dI0`14I//2000000<0A6K;
0P00000304AVb`80000000<0A6K;0=@m6@3D?AT00`3D?AT204AVb`0400000014I//0A6K;000000<0
A6K;00H0000004AVb`14I//0A6K;00000014I//30000000404IYd@000000AVWA0=@m6@<0AVWA00@0
00000?m@8P000000oe0R0P0000020?mB8P040000003oDR80oe8R00000080oe8R00D000000?mB8P3o
DR80oe8R000000020?mB8P030000003oDR80oe8R0080oe8R00@0000003eIZ`3oDR80oe8R0P000003
0?mB8P<000001P0mFJ/20?mB8P800000103oDR82000000070?mB8P0mFJ/0?EV[0?mB8P000000?EV[
0000000503eIZ`<0ooK^300mFJ/;0?ofkP<0e3dI3@3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m
6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h09@3om^h3000003P0ooK^0@0000010?ofkP40oooo
00000`000000ooK^0?ofkP0E0?ofkPD00000@@3om^h303eIZa00ooK^00<0?EV[0?ofkP3om^h04@3o
m^h00`0mFJ/0ooK^0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^00l0ooK^1P0mFJ/=0?ofkP0303eIZ`3o
m^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h01P3om^h00`000000e3dI0=@m6@060=@m6@<0A6K;0`3D
?AT204AVb`80000000<0A6K;0=@m6@3D?AT01P3D?AT404AVb`030000003D?AT0e3dI0080e3dI0P14
I//00`000000A6K;04AVb`060000000404IYd@000000AVWA04IYd@80e3dI0`16JM4010000000oe0R
0?m@8P00000203eIZ`030?m@8P000000000000<0000000<0oe8R0=@m6@0000000P3oDR8200000003
0?mB8P000000000000<0oe8R0P0000020?mB8P80?EV[0`3oDR8503eIZ`<000000`3oDR82000000<0
oe8R0`0000020?mB8PL0?EV[0P3om^h;03eIZ`030?ofkP3D?AT0ooK^00l0ooK^00<0e3dI0?ofkP3o
m^h00`3D?AT90?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0
ooK^0?ofkP0X0?ofkP800000=P3om^h100000040ooK^0@3oool000030000003om^h0ooK^0100ooK^
1@0000170?ofkP0303eIZ`3om^h0ooK^0100ooK^00<0?EV[0?ofkP3om^h04@3om^h00`0mFJ/0ooK^
0?ofkP0A0?ofkP0303eIZ`3om^h0ooK^00T0ooK^1P0mFJ/30?ofkP0303eIZ`3om^h0ooK^00`0ooK^
00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0000000@0e3dI
00<0A6K;0=@m6@3D?AT02@3D?AT01@000000A6K;04AVb`14I//0000000<0A6K;0P00000304AVb`04
00000014I//0A6K;03eIZ`<0e3dI0P00000404IYd@0400000016JM40AVWA04IYd@80e3dI00<00000
04IYd@16JM400P16JM400`000000oe0R000000020?m@8P030000000mFJ/000000080oe0R00P00000
0?m@8P00000000000?mB8P3D?AT000000?mB8P8000000`3oDR8200000080oe8R00<0000003eIZ`0m
FJ/0100mFJ/20?mB8P<000000`3oDR83000000<0oe8R0P0000030?mB8P0303eIZ`000000e3dI00d0
?EV[1P3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00@0ooK^0`3D?AT50?ofkP03
0=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP0[0?ofkP<0
0000<`3om^h100000040ooK^0@3oool000030000003om^h0ooK^00/0ooK^1@00001<0?ofkP0303eI
Z`3om^h0ooK^0140ooK^00<0?EV[0?ofkP3om^h04@3om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP0303eI
Z`3om^h0ooK^0080ooK^1P0mFJ/80?ofkP0303eIZ`3om^h0?EV[00d0ooK^00<0?EV[0?ofkP3om^h0
1@3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^0080ooK^0P0000040=@m6@800000
0P14I//2000000<0e3dI0P00000204AVb`8000000P14I//700000080AVWA00<0000004IYd@3D?AT0
0`3D?AT304IYd@<0e3dI00L0000004IYd@000000AVWA00000016JM4000000080oe0R00D000000?m@
8P000000oe0R0000000203eIZ`050000003oD28000000000003oD280100000000`3D?AT0oe8R0?mB
8P0703eIZ`80oe8R0P000000103oDR80?EV[03eIZ`0mFJ/30?mB8P<000000`3oDR83000000<0oe8R
00<0000003eIZ`0mFJ/02P0mFJ/:0?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h0
203om^h30=@m6@80ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m
6@3om^h0ooK^02l0ooK^0P00000a0?ofkP4000000@3om^h10?ooo`0000<000000?ofkP3om^h01@3o
m^h600000580ooK^00<0?EV[0?ofkP3om^h0403om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP0303eIZ`3o
m^h0ooK^00l0ooK^1P0mFJ/>0?ofkP0403eIZ`3om^h0ooK^03eIZ``0ooK^00<0?EV[0?ofkP3om^h0
1P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00D0?EV[0`0000001014I//0e3dI
0=@m6@3D?AT20000000404AVb`000000000004AVb`<0e3dI1@00000304IYd@0400000016JM40AVWA
000000<0AVWA00@0000004IYd@16JM400000103D?AT05@000000AVWA04IYd@000000AVWA00000016
JM40000004IYd@000000oe0R0000003oD28000000?m@8P000000oe0R0000003oD280?EV[00000002
0?m@8P030000000mFJ/0?EV[00D0?EV[00@0oe8R0=@m6@00000000000`3oDR82000000040?mB8P00
0000000000000080oe8R100mFJ/20?mB8P<000003@0mFJ/0103om^h0e3dI0=@m6@3D?AT;0?ofkP03
0=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h0303om^h30=@m6@`0ooK^00<0e3dI0?ofkP3o
m^h02`3om^h00`3D?AT0ooK^0?ofkP0a0?ofkP<00000;P3om^h100000040ooK^0@3oool000030000
003om^h0ooK^00D00000F@3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0303eIZ`3om^h0ooK^0140ooK^
00<0?EV[0?ofkP3om^h02@3om^h603eIZ`<0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^
0?ofkP020?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^
0?ofkP0503eIZ`P0ooK^0`00000304AVb`H0000000H0AVWA0=@m6@3D?AT0e3dI00000016JM420000
00<0AVWA0P0000000`16JM40000004IYd@040=@m6@80000000T0AVWA0000003D?AT0e3dI04IYd@00
0000AVWA00000016JM400P0000020?m@8P80000000D0oe0R0000003oD28000000?m@8P0603eIZ`80
oe0R0P0000020?m@8P<0000000<0oe8R0=@m6@3oDR801@0000020?mB8P<000000P3oDR8?03eIZ`03
0?ofkP3D?AT0ooK^00H0ooK^103D?AT60?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3o
m^h03@3om^h00`3D?AT0ooK^0?ofkP030=@m6@P0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0
ooK^0?ofkP0e0?ofkP800000;03om^h100000040ooK^0@3oool000<00000G`3om^h00`0mFJ/0ooK^
0?ofkP0@0?ofkP0303eIZ`3om^h0ooK^0140ooK^00<0?EV[0?ofkP3om^h00P3om^h603eIZ`X0ooK^
00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00L0ooK^
00<0?EV[0?ofkP3om^h01@3om^h603eIZ`030?ofkP0mFJ/0ooK^00H0ooK^1@0mFJ/20?ofkP<00000
1016JM400`000000e3dI0=@m6@060=@m6@0400000016JM400000000000D0e3dI00@0000004IYd@16
JM4000000P16JM4010000000AVWA0000000000030=@m6@H0000000<0oe0R03eIZ`0mFJ/0100mFJ/0
103oD280000000000000000303eIZ`030000003oD2800000008000000P3oD28600000080oe8R00<0
000003eIZ`0mFJ/01@0mFJ/00`000000?EV[03eIZ`0603eIZ`D0ooK^0P3D?AT<0?ofkP<0e3dI0P3o
m^h00`3D?AT0ooK^0?ofkP0=0?ofkP80e3dI3`3om^h00`3D?AT0ooK^0?ofkP040?ofkP80e3dI1@3o
m^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^03P0ooK^0`00000Y0?ofkP4000000@3o
m^h10?ooo`000`3om^h4000005/0ooK^00<0?EV[0?ofkP3om^h04@3om^h00`0mFJ/0ooK^0?ofkP0?
0?ofkPH0?EV[4@3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[
0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP0603eIZ`D0ooK^0P0mFJ/20?ofkPH0?EV[1P3om^h0
0`0mFJ/0ooK^0?ofkP020?ofkP<0000000@0e3dI04IYd@16JM40AVWA0P0000070=@m6@80AVWA1000
00001016JM40000004IYd@00000204IYd@L0000000D0AV_C0000003kC20000000?]<800300000003
0?m@8P000000000000<0000000<0oe0R0000000000000P00000403eIZ`D000001`0mFJ/20?mB8P03
0000000mFJ/0?EV[00<0?EV[00<000000?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP<0
e3dI3P3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00L0ooK^0`3D?AT20?ofkP03
0=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h0?03om^h2000002L0ooK^0@0000010?ofkP40
oooo00070?ofkP@00000F03om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0303eIZ`3om^h0ooK^00T0ooK^
1P0mFJ/30?ofkP0303eIZ`3om^h0ooK^0180ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^
0?ofkP060?ofkP0303eIZ`3om^h0ooK^00L0?EV[2@3om^h603eIZ``0ooK^00<0?EV[0?ofkP3om^h0
0P3om^h01@000000ooK^0?ofkP000000?EV[00X000001@3D?AT00`16JM4000000000000500000003
04I[d`00000000000100000000<0oe0R0000000000002000000903eIZ`D0000000<0e3dI00000000
00003P3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP80e3dI0P3om^h30=@m6@X0ooK^00<0e3dI0?ofkP3o
m^h03P3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP<0e3dI303om^h00`3D?AT0ooK^0?ofkP0n0?ofkP80
00009@3om^h100000040ooK^0@3oool000/0ooK^1000001E0?ofkP0303eIZ`3om^h0ooK^0100ooK^
00<0?EV[0?ofkP3om^h00P3om^h603eIZ`X0ooK^00<0?EV[0?ofkP3om^h04P3om^h00`0mFJ/0ooK^
0?ofkP070?ofkP0303eIZ`3om^h0ooK^0080ooK^200mFJ/30?ofkP0303eIZ`3om^h0ooK^00@0ooK^
1P0mFJ/20?ofkP0403eIZ`3om^h0?EV[03eIZ`/0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`000000
ooK^0?ofkP020?ofkP80?EV[1@0000000`2M<aH000000000000?0000000304I[d`000000000001D0
0000100mFJ/=00000080ooK^0`3D?AT;0?ofkP80e3dI4@3om^h00`3D?AT0ooK^0?ofkP050?ofkP<0
e3dI1P3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3o
m^h00`3D?AT80?ofkP030=@m6@3om^h0ooK^0440ooK^0`00000R0?ofkP4000000@3om^h10?ooo`00
3`3om^h400000580ooK^00<0?EV[0?ofkP3om^h03P3om^h603eIZa40ooK^00<0?EV[0?ofkP3om^h0
4P3om^h00`0mFJ/0ooK^0?ofkP060?ofkPD0?EV[1`3om^h01@0mFJ/0ooK^0?ofkP0mFJ/0ooK^00H0
?EV[1`3om^h00`0mFJ/0ooK^0?ofkP020?ofkP80?EV[203om^h00`0mFJ/0ooK^0?ofkP040?ofkP03
0000003om^h0?EV[00L0?EV[100000000`0mFJ/000000000000R000000<0?EV[0`0000020?m@8P@0
000000<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP040?ofkP<0e3dI1`3om^h00`3D?AT0
ooK^0?ofkP0?0?ofkP80e3dI2`3om^h30=@m6@80ooK^00<0e3dI0?ofkP3om^h03@3om^h20=@m6@h0
ooK^00<0e3dI0?ofkP3om^h0103om^h20=@m6@D0ooK^00<0e3dI0?ofkP3om^h0A@3om^h200000200
ooK^0@0000010?ofkP40oooo000C0?ofkP@00000CP3om^h00`0mFJ/0ooK^0?ofkP080?ofkPH0?EV[
0`3om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^0180ooK^00<0?EV[0?ofkP3om^h0
103om^h00`0mFJ/0ooK^0?ofkP090?ofkPH0?EV[303om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eI
Z`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h01P0mFJ/50?ofkPL0?EV[;0000000103om^h0e3dI
0=@m6@3D?AT80?ofkP030=@m6@3om^h0ooK^00H0ooK^0`3D?AT20?ofkP80e3dI4@3om^h00`3D?AT0
ooK^0?ofkP0>0?ofkP<0e3dI3P3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00L0
ooK^0`3D?AT20?ofkP030=@m6@3om^h0ooK^04L0ooK^0`00000M0?ofkP4000000@3om^h10?ooo`00
5`3om^h4000004/0ooK^00@0?EV[0?ofkP3om^h0ooK^1P0mFJ/:0?ofkP0303eIZ`3om^h0ooK^0180
ooK^00<0?EV[0?ofkP3om^h04P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00<0
ooK^1P0mFJ/30?ofkP80?EV[3@3om^h00`0mFJ/0ooK^0?ofkP060?ofkPX0?EV[103om^h00`000000
?EV[03eIZ`0503eIZ`@0ooK^0`0mFJ/20?ofkR<000000P3D?AT30?ofkP<0e3dI00<0ooK^0=@m6@3D
?AT00P3D?AT50?ofkP030=@m6@3om^h0ooK^00T0ooK^0`3D?ATA0?ofkP030=@m6@3om^h0ooK^00h0
ooK^0P3D?AT20?ofkP<0e3dI2P3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00/0
ooK^0P3D?AU=0?ofkP8000006`3om^h100000040ooK^0@3oool001/0ooK^100000180?ofkP<0?EV[
4@3om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^0180ooK^00@0?EV[0?ofkP3om^h0
ooK^1`0mFJ/80?ofkP0303eIZ`3om^h0ooK^0080?EV[2P3om^h0100mFJ/0ooK^0?ofkP3om^h:03eI
Z`040?ofkP0mFJ/0ooK^0?ofkPL0?EV[103om^h203eIZ`P0ooK^1P0mFJ/2000000040=@m6@000000
?EV[03eIZ`P0000000<0@FK70000000000001`0000070?ofkPD0e3dI1@3om^h00`3D?AT0ooK^0?of
kP030=@m6@<0ooK^00<0e3dI0?ofkP3om^h01@3om^h30=@m6@<0ooK^0`3D?AT<0?ofkP80e3dI403o
m^h00`3D?AT0ooK^0?ofkP050?ofkP<0e3dI1P3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3o
m^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h0CP3om^h3000001P0ooK^0@0000010?ofkP40oooo000O
0?ofkPD00000A03om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP0303eIZ`3om^h0ooK^0180ooK^00<0?EV[
0?ofkP3om^h0403om^h603eIZ`d0ooK^00<0?EV[0?ofkP3om^h00`3om^h203eIZ`D0ooK^1`0mFJ/8
0?ofkPH0?EV[1P3om^h01@000000ooK^0?ofkP3om^h0?EV[00L0ooK^3@0mFJ/2000000<0WC<F1P00
00030=@m6@@0ooK^2@3D?AT00`3om^h0e3dI0?ofkP020?ofkP@0e3dI00<0ooK^0=@m6@3om^h0103o
m^h40=@m6@D0ooK^0P3D?AT90?ofkP@0e3dI1`3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP80e3dI2`3o
m^h30=@m6@80ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3o
m^h0ooK^0580ooK^0P00000F0?ofkP4000000@3om^h10?ooo`00903om^h400000440ooK^00<0?EV[
0?ofkP3om^h04@3om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^00T0ooK^1P0mFJ/3
0?ofkP80?EV[3P3om^h00`0mFJ/0ooK^0?ofkP040?ofkPH0?EV[00<0ooK^03eIZ`3om^h01P3om^h6
03eIZ`040?ofkP0mFJ/0ooK^0?ofkP@0?EV[103om^h010000000ooK^0?ofkP0mFJ/20?ofkP/0?EV[
1`3om^h303eIZ`H000004@3D?AT40?ofkP030=@m6@3om^h0ooK^00@0ooK^0`3D?AT70?ofkP80e3dI
00@0ooK^0=@m6@3D?AT0e3dI3`3om^h30=@m6@80ooK^0P3D?AT@0?ofkP030=@m6@3om^h0ooK^00h0
ooK^0`3D?AT>0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h0E@3om^h3000001<0
ooK^0@0000010?ofkP40oooo000X0?ofkP@00000?P3om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP0303eI
Z`3om^h0ooK^0180ooK^00<0?EV[0?ofkP3om^h00P3om^h603eIZ`T0ooK^00@0?EV[0?ofkP0mFJ/0
?EV[2`3om^h00`0mFJ/0ooK^03eIZ`0503eIZ`<0ooK^0P0mFJ/0103om^h0?EV[0?ofkP3om^h603eI
Z`D0ooK^0P0mFJ/70?ofkPl0?EV[0P3om^h203eIZ`030?ofkP0mFJ/0?EV[00H0?EV[203om^h:0=@m
6@030?ofkP3D?AT0e3dI00<0e3dI0P3om^h40=@m6@030?ofkP3D?AT0ooK^00L0ooK^103D?AT30?of
kP<0e3dI5@3om^h30=@m6A00ooK^00<0e3dI0?ofkP3om^h03P3om^h20=@m6@80ooK^0`3D?AT:0?of
kP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h0F@3om^h200000180ooK^0@0000010?oo
o`00;03om^h4000003/0ooK^00<0?EV[0?ofkP3om^h04@3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkPH0
?EV[3P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP80?EV[1P3om^h503eIZ`T0ooK^1P0mFJ/:0?ofkP03
03eIZ`3om^h0ooK^00D0ooK^5P0mFJ/D0?ofkP@0e3dI00@0ooK^0=@m6@3D?AT0e3dI0`3om^h30=@m
6@@0ooK^103D?AT70?ofkPH0e3dI0`3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP<0e3dI0`3om^h30=@m
6@/0ooK^0P3D?AT@0?ofkP030=@m6@3om^h0ooK^00D0ooK^0`3D?AT60?ofkP030=@m6@3om^h0ooK^
00`0ooK^00<0e3dI0?ofkP3om^h0G03om^h3000000l0ooK^0@0000010?ooo`00<03om^h4000003P0
ooK^00<0?EV[0?ofkP3om^h04@3om^h00`0mFJ/0ooK^0?ofkP090?ofkPH0?EV[0`3om^h203eIZ`h0
ooK^00<0?EV[0?ofkP3om^h01@3om^h603eIZ`030?ofkP0mFJ/0ooK^00D0ooK^200mFJ/20?ofkP<0
?EV[203om^h00`0mFJ/0ooK^0?ofkP0;03eIZ`040?ofkP000000ooK^0?ofkPH0?EV[7`3om^h80=@m
6@80ooK^103D?AT30?ofkPX0e3dI103om^h40=@m6@l0ooK^0P3D?AT90?ofkP<0e3dI1`3om^h00`3D
?AT0ooK^0?ofkP0>0?ofkP80e3dI2`3om^h30=@m6@80ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D
?AT0ooK^0?ofkP1P0?ofkP8000003@3om^h100000040oooo000d0?ofkP@00000=@3om^h00`0mFJ/0
ooK^0?ofkP0A0?ofkP0303eIZ`3om^h0ooK^0080ooK^1P0mFJ/;0?ofkP80?EV[303om^h00`0mFJ/0
ooK^03eIZ`0503eIZ`80ooK^0P0mFJ/0103om^h0?EV[03eIZ`3om^h603eIZ`D0ooK^00<0?EV[0?of
kP3om^h01@3om^h403eIZ`030?ofkP0mFJ/0?EV[00P0?EV[0`3om^h803eIZbP0ooK^4@3D?AT0103o
m^h0e3dI0=@m6@3D?AT20?ofkP030=@m6@3om^h0ooK^00D0ooK^103D?AT90?ofkP<0e3dI3P3om^h3
0=@m6@80ooK^0P3D?AT@0?ofkP030=@m6@3om^h0ooK^00h0ooK^0`3D?AT=0?ofkP030=@m6@3om^h0
ooK^06<0ooK^0P00000;0?ofkP4000000@3oool003P0ooK^1000000b0?ofkP0303eIZ`3om^h0ooK^
00l0ooK^1P0mFJ/C0?ofkP80?EV[2@3om^h303eIZ`P0ooK^1P0mFJ/:0?ofkP0303eIZ`3om^h0ooK^
00D0ooK^5@0mFJ/30?ofkP030000003om^h0ooK^02/0ooK^2@3D?AT20?ofkP@0e3dI0`3om^h40=@m
6@P0ooK^00<0e3dI0?ofkP3D?AT00P3D?AT30?ofkP<0e3dI503om^h30=@m6A00ooK^00<0e3dI0?of
kP3om^h03P3om^h20=@m6@80ooK^0`3D?AT90?ofkP030=@m6@3om^h0ooK^06H0ooK^0`0000080?of
kP4000000@3oool003`0ooK^1@00000^0?ofkP0303eIZ`3om^h0ooK^00P0ooK^1P0mFJ/30?ofkP80
?EV[5P3om^h203eIZ`H0ooK^00<0?EV[0?ofkP3om^h00`3om^h603eIZ`040?ofkP0mFJ/0ooK^0?of
kP<0?EV[203om^h00`0mFJ/0ooK^0?ofkP0;03eIZ`@0ooK^1P0mFJ/90?ofkP030000003om^h0ooK^
02l0ooK^0`3D?AT0103om^h0e3dI0=@m6@3D?AT30?ofkP@0e3dI0`3om^h30=@m6@L0ooK^00<0e3dI
0?ofkP3D?AT0103D?ATD0?ofkP<0e3dI0`3om^h30=@m6@/0ooK^0P3D?AT@0?ofkP030=@m6@3om^h0
ooK^00D0ooK^0P3D?AT60?ofkP030=@m6@3om^h0ooK^06X0ooK^0P0000060?ofkP4000000@3oool0
0440ooK^1000000[0?ofkP0403eIZ`3om^h0ooK^0?ofkPH0?EV[2`3om^h203eIZaH0ooK^0P0mFJ/2
0?ofkPP0?EV[1@3om^h203eIZ`H0ooK^3`0mFJ/30?ofkPP0?EV[3`3om^h00`000000ooK^0?ofkP0b
0?ofkPP0e3dI0P3om^h40=@m6@80ooK^2P3D?AT50?ofkP<0e3dI3`3om^h20=@m6@T0ooK^0`3D?AT7
0?ofkP030=@m6@3om^h0ooK^00h0ooK^0P3D?AT:0?ofkP<0e3dI0P3om^h00`3D?AT0ooK^0?ofkP1]
0?ofkP<000000`3om^h100000040oooo00150?ofkP@00000:03om^h303eIZa<0ooK^0P0mFJ/D0?of
kPH0?EV[2P3om^h0100mFJ/0ooK^0?ofkP3om^hI03eIZaD0ooK^00<000000?ofkP3om^h0=@3om^h@
0=@m6@040?ofkP3D?AT0e3dI0=@m6@80ooK^00<0e3dI0?ofkP3om^h01P3om^h30=@m6@T0ooK^0`3D
?AT>0?ofkP<0e3dI0P3om^h20=@m6A00ooK^00<0e3dI0?ofkP3om^h03@3om^h20=@m6G<0ooK^0P00
00010?ofkP4000000@3oool004T0ooK^1000000U0?ofkP80?EV[5@3om^h203eIZ``0ooK^1P0mFJ/2
0?ofkP0303eIZ`3om^h0?EV[0080?EV[1P3om^h703eIZ`80ooK^3`0mFJ/M0?ofkP030000003om^h0
ooK^03P0ooK^203D?AT30?ofkP<0e3dI0`3om^h40=@m6@X0ooK^0`3D?AT30?ofkP<0e3dI503om^h3
0=@m6A00ooK^00<0e3dI0?ofkP3om^h03@3om^h20=@m6G@0ooK^100000010?ooo`00C@3om^h40000
02<0ooK^0P0mFJ/E0?ofkP80?EV[103om^h603eIZ`H0ooK^0P0mFJ/50?ofkPL0?EV[0P3om^h<03eI
ZbH0ooK^00<000000?ofkP3om^h0?03om^h60=@m6@@0ooK^0`3D?AT30?ofkP80e3dI2P3om^h50=@m
6AD0ooK^0P3D?AT30?ofkP<0e3dI2`3om^h20=@m6@h0ooK^0P3D?AU^0?ofkPP00000103om^h10?oo
o`00D@3om^h400000240ooK^0P0mFJ/C0?ofkPH0?EV[2`3om^h00`0mFJ/0ooK^03eIZ`0503eIZ`<0
ooK^2`0mFJ/]0?ofkP030000003om^h0ooK^03l0ooK^203D?AT00`3om^h0e3dI0=@m6@020=@m6@80
ooK^0P3D?AT00`3om^h0e3dI0=@m6@050=@m6@D0ooK^0`3D?AT?0?ofkP<0e3dI203om^h30=@m6@L0
ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP1V0?ofkPP00000303om^h10?ooo`00
E@3om^h4000001l0ooK^0P0mFJ/;0?ofkPH0?EV[103om^h403eIZ`L0ooK^100mFJ/30?ofkP/0?EV[
<`3om^h00`000000ooK^0?ofkP120?ofkPl0e3dI3`3om^h40=@m6@P0ooK^0`3D?AT>0?ofkP<0e3dI
0P3om^h20=@m6@h0ooK^0P3D?AUR0?ofkPL00000503om^h10?ooo`00F@3om^h4000001d0ooK^0P0m
FJ/30?ofkPH0?EV[3P3om^h403eIZ`040?ofkP0mFJ/0?EV[0?ofkP/0?EV[>@3om^h00`000000ooK^
0?ofkP150?ofkPL0e3dI0`3om^h40=@m6A40ooK^0`3D?AT30?ofkP80e3dI503om^h30=@m6@h0ooK^
00<0e3dI0?ofkP3om^h0FP3om^h8000001/0ooK^0@3oool005d0ooK^1@00000J0?ofkP<0?EV[5`3o
m^h;03eIZch0ooK^00<000000?ofkP3om^h0B03om^h60=@m6@@0ooK^103D?AT?0?ofkPD0e3dI4`3o
m^h30=@m6@<0ooK^103D?AT80?ofkP80e3dIE@3om^h8000002<0ooK^0@3oool00680ooK^1000000H
0?ofkP@0?EV[3P3om^h;03eIZd@0ooK^00<000000?ofkP3om^h0B`3om^h80=@m6@80ooK^103D?AT5
0?ofkPL0e3dI1@3om^h30=@m6@h0ooK^0P3D?AT:0?ofkP@0e3dI0P3om^h20=@m6E00ooK^1`00000[
0?ofkP40oooo001V0?ofkP@00000603om^h403eIZ`@0ooK^2`0mFJ]:0?ofkP030000003om^h0ooK^
04h0ooK^403D?AT?0?ofkP80e3dI2@3om^h30=@m6A00ooK^0P3D?AU:0?ofkPP00000<P3om^h10?oo
o`00JP3om^h4000001P0ooK^1`0mFJ]B0?ofkP030000003om^h0ooK^0580ooK^203D?AT20?ofkP<0
e3dI403om^h30=@m6@<0ooK^0`3D?ATA0?ofkP80e3dIA@3om^h7000003X0ooK^0@3oool006h0ooK^
1000001]0?ofkP030000003om^h0ooK^05H0ooK^1P3D?AT30?ofkP<0e3dI3P3om^h50=@m6A80ooK^
0P3D?ATo0?ofkPP00000@@3om^h10?ooo`00LP3om^h4000006T0ooK^00<000000?ofkP3om^h0FP3o
m^h;0=@m6@D0ooK^1P3D?AT50?ofkP<0e3dI3@3om^h20=@m6CT0ooK^200000190?ofkP40oooo001f
0?ofkP@00000I@3om^h00`000000ooK^0?ofkP1M0?ofkP@0e3dI0P3om^h70=@m6@h0ooK^0`3D?AT8
0?ofkP80e3dI=03om^h700000540ooK^0@3oool007X0ooK^1000001Q0?ofkP030000003om^h0ooK^
0600ooK^0`3D?AT50?ofkP@0e3dI3`3om^h30=@m6@<0ooK^0P3D?AT^0?ofkPP00000F03om^h10?oo
o`00OP3om^h5000005`0ooK^00<000000?ofkP3om^h0H`3om^h80=@m6@030?ofkP3D?AT0e3dI0080
e3dI2@3om^h80=@m6BP0ooK^2000001P0?ofkP40oooo00230?ofkP@00000F03om^h00`000000ooK^
0?ofkP1[0?ofkPh0e3dI:@3om^h7000006P0ooK^0@3oool008L0ooK^1000001D0?ofkP030000003o
m^h0ooK^09X0ooK^2000001_0?ofkP40oooo002;0?ofkP@00000D03om^h00`000000ooK^0?ofkP2B
0?ofkPP00000M`3om^h10?ooo`00S`3om^h4000004`0ooK^00<000000?ofkP3om^h0R`3om^h70000
07l0ooK^0@3oool009<0ooK^100000180?ofkP030000003om^h0ooK^08<0ooK^200000260?ofkP40
oooo002G0?ofkP@00000A03om^h00`000000ooK^0?ofkP1l0?ofkPL00000SP3om^h10?ooo`00V`3o
m^h400000400ooK^00<000000?ofkP3om^h0M03om^h8000009D0ooK^0@3oool009l0ooK^1@00000k
0?ofkP030000003om^h0ooK^06`0ooK^2000002M0?ofkP40oooo002T0?ofkP@00000=`3om^h00`00
0000ooK^0?ofkP1U0?ofkPL00000Y@3om^h10?ooo`00Z03om^h4000003<0ooK^00<000000?ofkP3o
m^h0G@3om^h800000:`0ooK^0@3oool00:`0ooK^1000000_0?ofkP030000003om^h0ooK^05D0ooK^
2000002d0?ofkP40oooo002`0?ofkP@00000:`3om^h00`000000ooK^0?ofkP1>0?ofkPL00000_03o
m^h10?ooo`00]03om^h4000002L0ooK^00<000000?ofkP3om^h0AP3om^h800000<<0ooK^0@3oool0
0;P0ooK^1000000S0?ofkP030000003om^h0ooK^03h0ooK^2000003;0?ofkP40oooo002l0?ofkPD0
00007P3om^h00`000000ooK^0?ofkP0g0?ofkPL00000d`3om^h10?ooo`00`@3om^h4000001X0ooK^
00<000000?ofkP3om^h0;`3om^h800000=X0ooK^0@3oool00<D0ooK^1000000F0?ofkP030000003o
m^h0ooK^02P0ooK^1`00003R0?ofkP40oooo00390?ofkP@000004P3om^h00`000000ooK^0?ofkP0P
0?ofkPP00000j@3om^h10?ooo`00c@3om^h4000000h0ooK^00<000000?ofkP3om^h0603om^h80000
0?40ooK^0@3oool00=40ooK^1000000:0?ofkP030000003om^h0ooK^0140ooK^1`00003i0?ofkP40
oooo003E0?ofkP@000001P3om^h00`000000ooK^0?ofkP090?ofkPP00000o`3om^h10?ofkP40oooo
003I0?ofkP@000000P3om^h010000000ooK^0?ofkP3om^h800000?l0ooK^2@3om^h10?ooo`00g@3o
m^h600000?l0ooK^4@3om^h10?ooo`00\
\>"],
  ImageRangeCache->{{{0, 499}, {319.125, 0}} -> {-0.000580545, 0.13569, \
0.00194158, 0.00194158}}]
}, Open  ]],

Cell["\<\
If you have RealTime3D, this is nice. Unfortunately, it drops all color \
directives.\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[{
    \(<< RealTime3D`\), "\[IndentingNewLine]", 
    \(\(Show[plot1];\)\), "\[IndentingNewLine]", 
    \(<< Default3D`\)}], "Input"],

Cell[BoxData[
  Graphics3D[{
    Line[{{-1.980000, 0.990000, 0.000000},{-1.697143, 0.990000, 
        0.000000},{-1.697143, 0.968366, 0.205833},{-1.980000, 0.968366, 
        0.205833},{-1.980000, 0.990000, 0.000000}}],
    Line[{{-1.697143, 0.990000, 0.000000},{-1.414286, 0.990000, 
        0.000000},{-1.414286, 0.968366, 0.205833},{-1.697143, 0.968366, 
        0.205833},{-1.697143, 0.990000, 0.000000}}],
    Line[{{-1.414286, 0.990000, 0.000000},{-1.131429, 0.990000, 
        0.000000},{-1.131429, 0.968366, 0.205833},{-1.414286, 0.968366, 
        0.205833},{-1.414286, 0.990000, 0.000000}}],
    Line[{{-1.131429, 0.990000, 0.000000},{-0.848571, 0.990000, 
        0.000000},{-0.848571, 0.968366, 0.205833},{-1.131429, 0.968366, 
        0.205833},{-1.131429, 0.990000, 0.000000}}],
    Line[{{-0.848571, 0.990000, 0.000000},{-0.565714, 0.990000, 
        0.000000},{-0.565714, 0.968366, 0.205833},{-0.848571, 0.968366, 
        0.205833},{-0.848571, 0.990000, 0.000000}}],
    Line[{{-0.565714, 0.990000, 0.000000},{-0.282857, 0.990000, 
        0.000000},{-0.282857, 0.968366, 0.205833},{-0.565714, 0.968366, 
        0.205833},{-0.565714, 0.990000, 0.000000}}],
    Line[{{-0.282857, 0.990000, 0.000000},{-0.000000, 0.990000, 
        0.000000},{-0.000000, 0.968366, 0.205833},{-0.282857, 0.968366, 
        0.205833},{-0.282857, 0.990000, 0.000000}}],
    Line[{{-0.000000, 0.990000, 0.000000},{0.282857, 0.990000, 0.000000},{
      0.282857, 0.968366, 0.205833},{-0.000000, 0.968366, 
        0.205833},{-0.000000, 0.990000, 0.000000}}],
    Line[{{0.282857, 0.990000, 0.000000},{0.565714, 0.990000, 0.000000},{
      0.565714, 0.968366, 0.205833},{0.282857, 0.968366, 0.205833},{
      0.282857, 0.990000, 0.000000}}],
    Line[{{0.565714, 0.990000, 0.000000},{0.848571, 0.990000, 0.000000},{
      0.848571, 0.968366, 0.205833},{0.565714, 0.968366, 0.205833},{
      0.565714, 0.990000, 0.000000}}],
    Line[{{0.848571, 0.990000, 0.000000},{1.131429, 0.990000, 0.000000},{
      1.131429, 0.968366, 0.205833},{0.848571, 0.968366, 0.205833},{
      0.848571, 0.990000, 0.000000}}],
    Line[{{1.131429, 0.990000, 0.000000},{1.414286, 0.990000, 0.000000},{
      1.414286, 0.968366, 0.205833},{1.131429, 0.968366, 0.205833},{
      1.131429, 0.990000, 0.000000}}],
    Line[{{1.414286, 0.990000, 0.000000},{1.697143, 0.990000, 0.000000},{
      1.697143, 0.968366, 0.205833},{1.414286, 0.968366, 0.205833},{
      1.414286, 0.990000, 0.000000}}],
    Line[{{1.697143, 0.990000, 0.000000},{1.980000, 0.990000, 0.000000},{
      1.980000, 0.968366, 0.205833},{1.697143, 0.968366, 0.205833},{
      1.697143, 0.990000, 0.000000}}],
    Line[{{-1.980000, 0.968366, 0.205833},{-1.697143, 0.968366, 
        0.205833},{-1.697143, 0.904410, 0.402669},{-1.980000, 0.904410, 
        0.402669},{-1.980000, 0.968366, 0.205833}}],
    Line[{{-1.697143, 0.968366, 0.205833},{-1.414286, 0.968366, 
        0.205833},{-1.414286, 0.904410, 0.402669},{-1.697143, 0.904410, 
        0.402669},{-1.697143, 0.968366, 0.205833}}],
    Line[{{-1.414286, 0.968366, 0.205833},{-1.131429, 0.968366, 
        0.205833},{-1.131429, 0.904410, 0.402669},{-1.414286, 0.904410, 
        0.402669},{-1.414286, 0.968366, 0.205833}}],
    Line[{{-1.131429, 0.968366, 0.205833},{-0.848571, 0.968366, 
        0.205833},{-0.848571, 0.904410, 0.402669},{-1.131429, 0.904410, 
        0.402669},{-1.131429, 0.968366, 0.205833}}],
    Line[{{-0.848571, 0.968366, 0.205833},{-0.565714, 0.968366, 
        0.205833},{-0.565714, 0.904410, 0.402669},{-0.848571, 0.904410, 
        0.402669},{-0.848571, 0.968366, 0.205833}}],
    Line[{{-0.565714, 0.968366, 0.205833},{-0.282857, 0.968366, 
        0.205833},{-0.282857, 0.904410, 0.402669},{-0.565714, 0.904410, 
        0.402669},{-0.565714, 0.968366, 0.205833}}],
    Line[{{-0.282857, 0.968366, 0.205833},{-0.000000, 0.968366, 
        0.205833},{-0.000000, 0.904410, 0.402669},{-0.282857, 0.904410, 
        0.402669},{-0.282857, 0.968366, 0.205833}}],
    Line[{{-0.000000, 0.968366, 0.205833},{0.282857, 0.968366, 0.205833},{
      0.282857, 0.904410, 0.402669},{-0.000000, 0.904410, 
        0.402669},{-0.000000, 0.968366, 0.205833}}],
    Line[{{0.282857, 0.968366, 0.205833},{0.565714, 0.968366, 0.205833},{
      0.565714, 0.904410, 0.402669},{0.282857, 0.904410, 0.402669},{
      0.282857, 0.968366, 0.205833}}],
    Line[{{0.565714, 0.968366, 0.205833},{0.848571, 0.968366, 0.205833},{
      0.848571, 0.904410, 0.402669},{0.565714, 0.904410, 0.402669},{
      0.565714, 0.968366, 0.205833}}],
    Line[{{0.848571, 0.968366, 0.205833},{1.131429, 0.968366, 0.205833},{
      1.131429, 0.904410, 0.402669},{0.848571, 0.904410, 0.402669},{
      0.848571, 0.968366, 0.205833}}],
    Line[{{1.131429, 0.968366, 0.205833},{1.414286, 0.968366, 0.205833},{
      1.414286, 0.904410, 0.402669},{1.131429, 0.904410, 0.402669},{
      1.131429, 0.968366, 0.205833}}],
    Line[{{1.414286, 0.968366, 0.205833},{1.697143, 0.968366, 0.205833},{
      1.697143, 0.904410, 0.402669},{1.414286, 0.904410, 0.402669},{
      1.414286, 0.968366, 0.205833}}],
    Line[{{1.697143, 0.968366, 0.205833},{1.980000, 0.968366, 0.205833},{
      1.980000, 0.904410, 0.402669},{1.697143, 0.904410, 0.402669},{
      1.697143, 0.968366, 0.205833}}],
    Line[{{-1.980000, 0.904410, 0.402669},{-1.697143, 0.904410, 
        0.402669},{-1.697143, 0.800927, 0.581907},{-1.980000, 0.800927, 
        0.581907},{-1.980000, 0.904410, 0.402669}}],
    Line[{{-1.697143, 0.904410, 0.402669},{-1.414286, 0.904410, 
        0.402669},{-1.414286, 0.800927, 0.581907},{-1.697143, 0.800927, 
        0.581907},{-1.697143, 0.904410, 0.402669}}],
    Line[{{-1.414286, 0.904410, 0.402669},{-1.131429, 0.904410, 
        0.402669},{-1.131429, 0.800927, 0.581907},{-1.414286, 0.800927, 
        0.581907},{-1.414286, 0.904410, 0.402669}}],
    Line[{{-1.131429, 0.904410, 0.402669},{-0.848571, 0.904410, 
        0.402669},{-0.848571, 0.800927, 0.581907},{-1.131429, 0.800927, 
        0.581907},{-1.131429, 0.904410, 0.402669}}],
    Line[{{-0.848571, 0.904410, 0.402669},{-0.565714, 0.904410, 
        0.402669},{-0.565714, 0.800927, 0.581907},{-0.848571, 0.800927, 
        0.581907},{-0.848571, 0.904410, 0.402669}}],
    Line[{{-0.565714, 0.904410, 0.402669},{-0.282857, 0.904410, 
        0.402669},{-0.282857, 0.800927, 0.581907},{-0.565714, 0.800927, 
        0.581907},{-0.565714, 0.904410, 0.402669}}],
    Line[{{-0.282857, 0.904410, 0.402669},{-0.000000, 0.904410, 
        0.402669},{-0.000000, 0.800927, 0.581907},{-0.282857, 0.800927, 
        0.581907},{-0.282857, 0.904410, 0.402669}}],
    Line[{{-0.000000, 0.904410, 0.402669},{0.282857, 0.904410, 0.402669},{
      0.282857, 0.800927, 0.581907},{-0.000000, 0.800927, 
        0.581907},{-0.000000, 0.904410, 0.402669}}],
    Line[{{0.282857, 0.904410, 0.402669},{0.565714, 0.904410, 0.402669},{
      0.565714, 0.800927, 0.581907},{0.282857, 0.800927, 0.581907},{
      0.282857, 0.904410, 0.402669}}],
    Line[{{0.565714, 0.904410, 0.402669},{0.848571, 0.904410, 0.402669},{
      0.848571, 0.800927, 0.581907},{0.565714, 0.800927, 0.581907},{
      0.565714, 0.904410, 0.402669}}],
    Line[{{0.848571, 0.904410, 0.402669},{1.131429, 0.904410, 0.402669},{
      1.131429, 0.800927, 0.581907},{0.848571, 0.800927, 0.581907},{
      0.848571, 0.904410, 0.402669}}],
    Line[{{1.131429, 0.904410, 0.402669},{1.414286, 0.904410, 0.402669},{
      1.414286, 0.800927, 0.581907},{1.131429, 0.800927, 0.581907},{
      1.131429, 0.904410, 0.402669}}],
    Line[{{1.414286, 0.904410, 0.402669},{1.697143, 0.904410, 0.402669},{
      1.697143, 0.800927, 0.581907},{1.414286, 0.800927, 0.581907},{
      1.414286, 0.904410, 0.402669}}],
    Line[{{1.697143, 0.904410, 0.402669},{1.980000, 0.904410, 0.402669},{
      1.980000, 0.800927, 0.581907},{1.697143, 0.800927, 0.581907},{
      1.697143, 0.904410, 0.402669}}],
    Line[{{-1.980000, 0.800927, 0.581907},{-1.697143, 0.800927, 
        0.581907},{-1.697143, 0.662439, 0.735713},{-1.980000, 0.662439, 
        0.735713},{-1.980000, 0.800927, 0.581907}}],
    Line[{{-1.697143, 0.800927, 0.581907},{-1.414286, 0.800927, 
        0.581907},{-1.414286, 0.662439, 0.735713},{-1.697143, 0.662439, 
        0.735713},{-1.697143, 0.800927, 0.581907}}],
    Line[{{-1.414286, 0.800927, 0.581907},{-1.131429, 0.800927, 
        0.581907},{-1.131429, 0.662439, 0.735713},{-1.414286, 0.662439, 
        0.735713},{-1.414286, 0.800927, 0.581907}}],
    Line[{{-1.131429, 0.800927, 0.581907},{-0.848571, 0.800927, 
        0.581907},{-0.848571, 0.662439, 0.735713},{-1.131429, 0.662439, 
        0.735713},{-1.131429, 0.800927, 0.581907}}],
    Line[{{-0.848571, 0.800927, 0.581907},{-0.565714, 0.800927, 
        0.581907},{-0.565714, 0.662439, 0.735713},{-0.848571, 0.662439, 
        0.735713},{-0.848571, 0.800927, 0.581907}}],
    Line[{{-0.565714, 0.800927, 0.581907},{-0.282857, 0.800927, 
        0.581907},{-0.282857, 0.662439, 0.735713},{-0.565714, 0.662439, 
        0.735713},{-0.565714, 0.800927, 0.581907}}],
    Line[{{-0.282857, 0.800927, 0.581907},{-0.000000, 0.800927, 
        0.581907},{-0.000000, 0.662439, 0.735713},{-0.282857, 0.662439, 
        0.735713},{-0.282857, 0.800927, 0.581907}}],
    Line[{{-0.000000, 0.800927, 0.581907},{0.282857, 0.800927, 0.581907},{
      0.282857, 0.662439, 0.735713},{-0.000000, 0.662439, 
        0.735713},{-0.000000, 0.800927, 0.581907}}],
    Line[{{0.282857, 0.800927, 0.581907},{0.565714, 0.800927, 0.581907},{
      0.565714, 0.662439, 0.735713},{0.282857, 0.662439, 0.735713},{
      0.282857, 0.800927, 0.581907}}],
    Line[{{0.565714, 0.800927, 0.581907},{0.848571, 0.800927, 0.581907},{
      0.848571, 0.662439, 0.735713},{0.565714, 0.662439, 0.735713},{
      0.565714, 0.800927, 0.581907}}],
    Line[{{0.848571, 0.800927, 0.581907},{1.131429, 0.800927, 0.581907},{
      1.131429, 0.662439, 0.735713},{0.848571, 0.662439, 0.735713},{
      0.848571, 0.800927, 0.581907}}],
    Line[{{1.131429, 0.800927, 0.581907},{1.414286, 0.800927, 0.581907},{
      1.414286, 0.662439, 0.735713},{1.131429, 0.662439, 0.735713},{
      1.131429, 0.800927, 0.581907}}],
    Line[{{1.414286, 0.800927, 0.581907},{1.697143, 0.800927, 0.581907},{
      1.697143, 0.662439, 0.735713},{1.414286, 0.662439, 0.735713},{
      1.414286, 0.800927, 0.581907}}],
    Line[{{1.697143, 0.800927, 0.581907},{1.980000, 0.800927, 0.581907},{
      1.980000, 0.662439, 0.735713},{1.697143, 0.662439, 0.735713},{
      1.697143, 0.800927, 0.581907}}],
    Line[{{-1.980000, 0.662439, 0.735713},{-1.697143, 0.662439, 
        0.735713},{-1.697143, 0.495000, 0.857365},{-1.980000, 0.495000, 
        0.857365},{-1.980000, 0.662439, 0.735713}}],
    Line[{{-1.697143, 0.662439, 0.735713},{-1.414286, 0.662439, 
        0.735713},{-1.414286, 0.495000, 0.857365},{-1.697143, 0.495000, 
        0.857365},{-1.697143, 0.662439, 0.735713}}],
    Line[{{-1.414286, 0.662439, 0.735713},{-1.131429, 0.662439, 
        0.735713},{-1.131429, 0.495000, 0.857365},{-1.414286, 0.495000, 
        0.857365},{-1.414286, 0.662439, 0.735713}}],
    Line[{{-1.131429, 0.662439, 0.735713},{-0.848571, 0.662439, 
        0.735713},{-0.848571, 0.495000, 0.857365},{-1.131429, 0.495000, 
        0.857365},{-1.131429, 0.662439, 0.735713}}],
    Line[{{-0.848571, 0.662439, 0.735713},{-0.565714, 0.662439, 
        0.735713},{-0.565714, 0.495000, 0.857365},{-0.848571, 0.495000, 
        0.857365},{-0.848571, 0.662439, 0.735713}}],
    Line[{{-0.565714, 0.662439, 0.735713},{-0.282857, 0.662439, 
        0.735713},{-0.282857, 0.495000, 0.857365},{-0.565714, 0.495000, 
        0.857365},{-0.565714, 0.662439, 0.735713}}],
    Line[{{-0.282857, 0.662439, 0.735713},{-0.000000, 0.662439, 
        0.735713},{-0.000000, 0.495000, 0.857365},{-0.282857, 0.495000, 
        0.857365},{-0.282857, 0.662439, 0.735713}}],
    Line[{{-0.000000, 0.662439, 0.735713},{0.282857, 0.662439, 0.735713},{
      0.282857, 0.495000, 0.857365},{-0.000000, 0.495000, 
        0.857365},{-0.000000, 0.662439, 0.735713}}],
    Line[{{0.282857, 0.662439, 0.735713},{0.565714, 0.662439, 0.735713},{
      0.565714, 0.495000, 0.857365},{0.282857, 0.495000, 0.857365},{
      0.282857, 0.662439, 0.735713}}],
    Line[{{0.565714, 0.662439, 0.735713},{0.848571, 0.662439, 0.735713},{
      0.848571, 0.495000, 0.857365},{0.565714, 0.495000, 0.857365},{
      0.565714, 0.662439, 0.735713}}],
    Line[{{0.848571, 0.662439, 0.735713},{1.131429, 0.662439, 0.735713},{
      1.131429, 0.495000, 0.857365},{0.848571, 0.495000, 0.857365},{
      0.848571, 0.662439, 0.735713}}],
    Line[{{1.131429, 0.662439, 0.735713},{1.414286, 0.662439, 0.735713},{
      1.414286, 0.495000, 0.857365},{1.131429, 0.495000, 0.857365},{
      1.131429, 0.662439, 0.735713}}],
    Line[{{1.414286, 0.662439, 0.735713},{1.697143, 0.662439, 0.735713},{
      1.697143, 0.495000, 0.857365},{1.414286, 0.495000, 0.857365},{
      1.414286, 0.662439, 0.735713}}],
    Line[{{1.697143, 0.662439, 0.735713},{1.980000, 0.662439, 0.735713},{
      1.980000, 0.495000, 0.857365},{1.697143, 0.495000, 0.857365},{
      1.697143, 0.662439, 0.735713}}],
    Line[{{-1.980000, 0.495000, 0.857365},{-1.697143, 0.495000, 
        0.857365},{-1.697143, 0.305927, 0.941546},{-1.980000, 0.305927, 
        0.941546},{-1.980000, 0.495000, 0.857365}}],
    Line[{{-1.697143, 0.495000, 0.857365},{-1.414286, 0.495000, 
        0.857365},{-1.414286, 0.305927, 0.941546},{-1.697143, 0.305927, 
        0.941546},{-1.697143, 0.495000, 0.857365}}],
    Line[{{-1.414286, 0.495000, 0.857365},{-1.131429, 0.495000, 
        0.857365},{-1.131429, 0.305927, 0.941546},{-1.414286, 0.305927, 
        0.941546},{-1.414286, 0.495000, 0.857365}}],
    Line[{{-1.131429, 0.495000, 0.857365},{-0.848571, 0.495000, 
        0.857365},{-0.848571, 0.305927, 0.941546},{-1.131429, 0.305927, 
        0.941546},{-1.131429, 0.495000, 0.857365}}],
    Line[{{-0.848571, 0.495000, 0.857365},{-0.565714, 0.495000, 
        0.857365},{-0.565714, 0.305927, 0.941546},{-0.848571, 0.305927, 
        0.941546},{-0.848571, 0.495000, 0.857365}}],
    Line[{{-0.565714, 0.495000, 0.857365},{-0.282857, 0.495000, 
        0.857365},{-0.282857, 0.305927, 0.941546},{-0.565714, 0.305927, 
        0.941546},{-0.565714, 0.495000, 0.857365}}],
    Line[{{-0.282857, 0.495000, 0.857365},{-0.000000, 0.495000, 
        0.857365},{-0.000000, 0.305927, 0.941546},{-0.282857, 0.305927, 
        0.941546},{-0.282857, 0.495000, 0.857365}}],
    Line[{{-0.000000, 0.495000, 0.857365},{0.282857, 0.495000, 0.857365},{
      0.282857, 0.305927, 0.941546},{-0.000000, 0.305927, 
        0.941546},{-0.000000, 0.495000, 0.857365}}],
    Line[{{0.282857, 0.495000, 0.857365},{0.565714, 0.495000, 0.857365},{
      0.565714, 0.305927, 0.941546},{0.282857, 0.305927, 0.941546},{
      0.282857, 0.495000, 0.857365}}],
    Line[{{0.565714, 0.495000, 0.857365},{0.848571, 0.495000, 0.857365},{
      0.848571, 0.305927, 0.941546},{0.565714, 0.305927, 0.941546},{
      0.565714, 0.495000, 0.857365}}],
    Line[{{0.848571, 0.495000, 0.857365},{1.131429, 0.495000, 0.857365},{
      1.131429, 0.305927, 0.941546},{0.848571, 0.305927, 0.941546},{
      0.848571, 0.495000, 0.857365}}],
    Line[{{1.131429, 0.495000, 0.857365},{1.414286, 0.495000, 0.857365},{
      1.414286, 0.305927, 0.941546},{1.131429, 0.305927, 0.941546},{
      1.131429, 0.495000, 0.857365}}],
    Line[{{1.414286, 0.495000, 0.857365},{1.697143, 0.495000, 0.857365},{
      1.697143, 0.305927, 0.941546},{1.414286, 0.305927, 0.941546},{
      1.414286, 0.495000, 0.857365}}],
    Line[{{1.697143, 0.495000, 0.857365},{1.980000, 0.495000, 0.857365},{
      1.980000, 0.305927, 0.941546},{1.697143, 0.305927, 0.941546},{
      1.697143, 0.495000, 0.857365}}],
    Line[{{-1.980000, 0.305927, 0.941546},{-1.697143, 0.305927, 
        0.941546},{-1.697143, 0.103483, 0.984577},{-1.980000, 0.103483, 
        0.984577},{-1.980000, 0.305927, 0.941546}}],
    Line[{{-1.697143, 0.305927, 0.941546},{-1.414286, 0.305927, 
        0.941546},{-1.414286, 0.103483, 0.984577},{-1.697143, 0.103483, 
        0.984577},{-1.697143, 0.305927, 0.941546}}],
    Line[{{-1.414286, 0.305927, 0.941546},{-1.131429, 0.305927, 
        0.941546},{-1.131429, 0.103483, 0.984577},{-1.414286, 0.103483, 
        0.984577},{-1.414286, 0.305927, 0.941546}}],
    Line[{{-1.131429, 0.305927, 0.941546},{-0.848571, 0.305927, 
        0.941546},{-0.848571, 0.103483, 0.984577},{-1.131429, 0.103483, 
        0.984577},{-1.131429, 0.305927, 0.941546}}],
    Line[{{-0.848571, 0.305927, 0.941546},{-0.565714, 0.305927, 
        0.941546},{-0.565714, 0.103483, 0.984577},{-0.848571, 0.103483, 
        0.984577},{-0.848571, 0.305927, 0.941546}}],
    Line[{{-0.565714, 0.305927, 0.941546},{-0.282857, 0.305927, 
        0.941546},{-0.282857, 0.103483, 0.984577},{-0.565714, 0.103483, 
        0.984577},{-0.565714, 0.305927, 0.941546}}],
    Line[{{-0.282857, 0.305927, 0.941546},{-0.000000, 0.305927, 
        0.941546},{-0.000000, 0.103483, 0.984577},{-0.282857, 0.103483, 
        0.984577},{-0.282857, 0.305927, 0.941546}}],
    Line[{{-0.000000, 0.305927, 0.941546},{0.282857, 0.305927, 0.941546},{
      0.282857, 0.103483, 0.984577},{-0.000000, 0.103483, 
        0.984577},{-0.000000, 0.305927, 0.941546}}],
    Line[{{0.282857, 0.305927, 0.941546},{0.565714, 0.305927, 0.941546},{
      0.565714, 0.103483, 0.984577},{0.282857, 0.103483, 0.984577},{
      0.282857, 0.305927, 0.941546}}],
    Line[{{0.565714, 0.305927, 0.941546},{0.848571, 0.305927, 0.941546},{
      0.848571, 0.103483, 0.984577},{0.565714, 0.103483, 0.984577},{
      0.565714, 0.305927, 0.941546}}],
    Line[{{0.848571, 0.305927, 0.941546},{1.131429, 0.305927, 0.941546},{
      1.131429, 0.103483, 0.984577},{0.848571, 0.103483, 0.984577},{
      0.848571, 0.305927, 0.941546}}],
    Line[{{1.131429, 0.305927, 0.941546},{1.414286, 0.305927, 0.941546},{
      1.414286, 0.103483, 0.984577},{1.131429, 0.103483, 0.984577},{
      1.131429, 0.305927, 0.941546}}],
    Line[{{1.414286, 0.305927, 0.941546},{1.697143, 0.305927, 0.941546},{
      1.697143, 0.103483, 0.984577},{1.414286, 0.103483, 0.984577},{
      1.414286, 0.305927, 0.941546}}],
    Line[{{1.697143, 0.305927, 0.941546},{1.980000, 0.305927, 0.941546},{
      1.980000, 0.103483, 0.984577},{1.697143, 0.103483, 0.984577},{
      1.697143, 0.305927, 0.941546}}],
    Line[{{-1.980000, 0.103483, 0.984577},{-1.697143, 0.103483, 
        0.984577},{-1.697143, -0.103483, 0.984577},{-1.980000, -0.103483, 
        0.984577},{-1.980000, 0.103483, 0.984577}}],
    Line[{{-1.697143, 0.103483, 0.984577},{-1.414286, 0.103483, 
        0.984577},{-1.414286, -0.103483, 0.984577},{-1.697143, -0.103483, 
        0.984577},{-1.697143, 0.103483, 0.984577}}],
    Line[{{-1.414286, 0.103483, 0.984577},{-1.131429, 0.103483, 
        0.984577},{-1.131429, -0.103483, 0.984577},{-1.414286, -0.103483, 
        0.984577},{-1.414286, 0.103483, 0.984577}}],
    Line[{{-1.131429, 0.103483, 0.984577},{-0.848571, 0.103483, 
        0.984577},{-0.848571, -0.103483, 0.984577},{-1.131429, -0.103483, 
        0.984577},{-1.131429, 0.103483, 0.984577}}],
    Line[{{-0.848571, 0.103483, 0.984577},{-0.565714, 0.103483, 
        0.984577},{-0.565714, -0.103483, 0.984577},{-0.848571, -0.103483, 
        0.984577},{-0.848571, 0.103483, 0.984577}}],
    Line[{{-0.565714, 0.103483, 0.984577},{-0.282857, 0.103483, 
        0.984577},{-0.282857, -0.103483, 0.984577},{-0.565714, -0.103483, 
        0.984577},{-0.565714, 0.103483, 0.984577}}],
    Line[{{-0.282857, 0.103483, 0.984577},{-0.000000, 0.103483, 
        0.984577},{-0.000000, -0.103483, 0.984577},{-0.282857, -0.103483, 
        0.984577},{-0.282857, 0.103483, 0.984577}}],
    Line[{{-0.000000, 0.103483, 0.984577},{0.282857, 0.103483, 0.984577},{
      0.282857, -0.103483, 0.984577},{-0.000000, -0.103483, 
        0.984577},{-0.000000, 0.103483, 0.984577}}],
    Line[{{0.282857, 0.103483, 0.984577},{0.565714, 0.103483, 0.984577},{
      0.565714, -0.103483, 0.984577},{0.282857, -0.103483, 0.984577},{
      0.282857, 0.103483, 0.984577}}],
    Line[{{0.565714, 0.103483, 0.984577},{0.848571, 0.103483, 0.984577},{
      0.848571, -0.103483, 0.984577},{0.565714, -0.103483, 0.984577},{
      0.565714, 0.103483, 0.984577}}],
    Line[{{0.848571, 0.103483, 0.984577},{1.131429, 0.103483, 0.984577},{
      1.131429, -0.103483, 0.984577},{0.848571, -0.103483, 0.984577},{
      0.848571, 0.103483, 0.984577}}],
    Line[{{1.131429, 0.103483, 0.984577},{1.414286, 0.103483, 0.984577},{
      1.414286, -0.103483, 0.984577},{1.131429, -0.103483, 0.984577},{
      1.131429, 0.103483, 0.984577}}],
    Line[{{1.414286, 0.103483, 0.984577},{1.697143, 0.103483, 0.984577},{
      1.697143, -0.103483, 0.984577},{1.414286, -0.103483, 0.984577},{
      1.414286, 0.103483, 0.984577}}],
    Line[{{1.697143, 0.103483, 0.984577},{1.980000, 0.103483, 0.984577},{
      1.980000, -0.103483, 0.984577},{1.697143, -0.103483, 0.984577},{
      1.697143, 0.103483, 0.984577}}],
    Line[{{-1.980000, -0.103483, 0.984577},{-1.697143, -0.103483, 
        0.984577},{-1.697143, -0.305927, 0.941546},{-1.980000, -0.305927, 
        0.941546},{-1.980000, -0.103483, 0.984577}}],
    Line[{{-1.697143, -0.103483, 0.984577},{-1.414286, -0.103483, 
        0.984577},{-1.414286, -0.305927, 0.941546},{-1.697143, -0.305927, 
        0.941546},{-1.697143, -0.103483, 0.984577}}],
    Line[{{-1.414286, -0.103483, 0.984577},{-1.131429, -0.103483, 
        0.984577},{-1.131429, -0.305927, 0.941546},{-1.414286, -0.305927, 
        0.941546},{-1.414286, -0.103483, 0.984577}}],
    Line[{{-1.131429, -0.103483, 0.984577},{-0.848571, -0.103483, 
        0.984577},{-0.848571, -0.305927, 0.941546},{-1.131429, -0.305927, 
        0.941546},{-1.131429, -0.103483, 0.984577}}],
    Line[{{-0.848571, -0.103483, 0.984577},{-0.565714, -0.103483, 
        0.984577},{-0.565714, -0.305927, 0.941546},{-0.848571, -0.305927, 
        0.941546},{-0.848571, -0.103483, 0.984577}}],
    Line[{{-0.565714, -0.103483, 0.984577},{-0.282857, -0.103483, 
        0.984577},{-0.282857, -0.305927, 0.941546},{-0.565714, -0.305927, 
        0.941546},{-0.565714, -0.103483, 0.984577}}],
    Line[{{-0.282857, -0.103483, 0.984577},{-0.000000, -0.103483, 
        0.984577},{-0.000000, -0.305927, 0.941546},{-0.282857, -0.305927, 
        0.941546},{-0.282857, -0.103483, 0.984577}}],
    Line[{{-0.000000, -0.103483, 0.984577},{0.282857, -0.103483, 0.984577},{
      0.282857, -0.305927, 0.941546},{-0.000000, -0.305927, 
        0.941546},{-0.000000, -0.103483, 0.984577}}],
    Line[{{0.282857, -0.103483, 0.984577},{0.565714, -0.103483, 0.984577},{
      0.565714, -0.305927, 0.941546},{0.282857, -0.305927, 0.941546},{
      0.282857, -0.103483, 0.984577}}],
    Line[{{0.565714, -0.103483, 0.984577},{0.848571, -0.103483, 0.984577},{
      0.848571, -0.305927, 0.941546},{0.565714, -0.305927, 0.941546},{
      0.565714, -0.103483, 0.984577}}],
    Line[{{0.848571, -0.103483, 0.984577},{1.131429, -0.103483, 0.984577},{
      1.131429, -0.305927, 0.941546},{0.848571, -0.305927, 0.941546},{
      0.848571, -0.103483, 0.984577}}],
    Line[{{1.131429, -0.103483, 0.984577},{1.414286, -0.103483, 0.984577},{
      1.414286, -0.305927, 0.941546},{1.131429, -0.305927, 0.941546},{
      1.131429, -0.103483, 0.984577}}],
    Line[{{1.414286, -0.103483, 0.984577},{1.697143, -0.103483, 0.984577},{
      1.697143, -0.305927, 0.941546},{1.414286, -0.305927, 0.941546},{
      1.414286, -0.103483, 0.984577}}],
    Line[{{1.697143, -0.103483, 0.984577},{1.980000, -0.103483, 0.984577},{
      1.980000, -0.305927, 0.941546},{1.697143, -0.305927, 0.941546},{
      1.697143, -0.103483, 0.984577}}],
    Line[{{-1.980000, -0.305927, 0.941546},{-1.697143, -0.305927, 
        0.941546},{-1.697143, -0.495000, 0.857365},{-1.980000, -0.495000, 
        0.857365},{-1.980000, -0.305927, 0.941546}}],
    Line[{{-1.697143, -0.305927, 0.941546},{-1.414286, -0.305927, 
        0.941546},{-1.414286, -0.495000, 0.857365},{-1.697143, -0.495000, 
        0.857365},{-1.697143, -0.305927, 0.941546}}],
    Line[{{-1.414286, -0.305927, 0.941546},{-1.131429, -0.305927, 
        0.941546},{-1.131429, -0.495000, 0.857365},{-1.414286, -0.495000, 
        0.857365},{-1.414286, -0.305927, 0.941546}}],
    Line[{{-1.131429, -0.305927, 0.941546},{-0.848571, -0.305927, 
        0.941546},{-0.848571, -0.495000, 0.857365},{-1.131429, -0.495000, 
        0.857365},{-1.131429, -0.305927, 0.941546}}],
    Line[{{-0.848571, -0.305927, 0.941546},{-0.565714, -0.305927, 
        0.941546},{-0.565714, -0.495000, 0.857365},{-0.848571, -0.495000, 
        0.857365},{-0.848571, -0.305927, 0.941546}}],
    Line[{{-0.565714, -0.305927, 0.941546},{-0.282857, -0.305927, 
        0.941546},{-0.282857, -0.495000, 0.857365},{-0.565714, -0.495000, 
        0.857365},{-0.565714, -0.305927, 0.941546}}],
    Line[{{-0.282857, -0.305927, 0.941546},{-0.000000, -0.305927, 
        0.941546},{-0.000000, -0.495000, 0.857365},{-0.282857, -0.495000, 
        0.857365},{-0.282857, -0.305927, 0.941546}}],
    Line[{{-0.000000, -0.305927, 0.941546},{0.282857, -0.305927, 0.941546},{
      0.282857, -0.495000, 0.857365},{-0.000000, -0.495000, 
        0.857365},{-0.000000, -0.305927, 0.941546}}],
    Line[{{0.282857, -0.305927, 0.941546},{0.565714, -0.305927, 0.941546},{
      0.565714, -0.495000, 0.857365},{0.282857, -0.495000, 0.857365},{
      0.282857, -0.305927, 0.941546}}],
    Line[{{0.565714, -0.305927, 0.941546},{0.848571, -0.305927, 0.941546},{
      0.848571, -0.495000, 0.857365},{0.565714, -0.495000, 0.857365},{
      0.565714, -0.305927, 0.941546}}],
    Line[{{0.848571, -0.305927, 0.941546},{1.131429, -0.305927, 0.941546},{
      1.131429, -0.495000, 0.857365},{0.848571, -0.495000, 0.857365},{
      0.848571, -0.305927, 0.941546}}],
    Line[{{1.131429, -0.305927, 0.941546},{1.414286, -0.305927, 0.941546},{
      1.414286, -0.495000, 0.857365},{1.131429, -0.495000, 0.857365},{
      1.131429, -0.305927, 0.941546}}],
    Line[{{1.414286, -0.305927, 0.941546},{1.697143, -0.305927, 0.941546},{
      1.697143, -0.495000, 0.857365},{1.414286, -0.495000, 0.857365},{
      1.414286, -0.305927, 0.941546}}],
    Line[{{1.697143, -0.305927, 0.941546},{1.980000, -0.305927, 0.941546},{
      1.980000, -0.495000, 0.857365},{1.697143, -0.495000, 0.857365},{
      1.697143, -0.305927, 0.941546}}],
    Line[{{-1.980000, -0.495000, 0.857365},{-1.697143, -0.495000, 
        0.857365},{-1.697143, -0.662439, 0.735713},{-1.980000, -0.662439, 
        0.735713},{-1.980000, -0.495000, 0.857365}}],
    Line[{{-1.697143, -0.495000, 0.857365},{-1.414286, -0.495000, 
        0.857365},{-1.414286, -0.662439, 0.735713},{-1.697143, -0.662439, 
        0.735713},{-1.697143, -0.495000, 0.857365}}],
    Line[{{-1.414286, -0.495000, 0.857365},{-1.131429, -0.495000, 
        0.857365},{-1.131429, -0.662439, 0.735713},{-1.414286, -0.662439, 
        0.735713},{-1.414286, -0.495000, 0.857365}}],
    Line[{{-1.131429, -0.495000, 0.857365},{-0.848571, -0.495000, 
        0.857365},{-0.848571, -0.662439, 0.735713},{-1.131429, -0.662439, 
        0.735713},{-1.131429, -0.495000, 0.857365}}],
    Line[{{-0.848571, -0.495000, 0.857365},{-0.565714, -0.495000, 
        0.857365},{-0.565714, -0.662439, 0.735713},{-0.848571, -0.662439, 
        0.735713},{-0.848571, -0.495000, 0.857365}}],
    Line[{{-0.565714, -0.495000, 0.857365},{-0.282857, -0.495000, 
        0.857365},{-0.282857, -0.662439, 0.735713},{-0.565714, -0.662439, 
        0.735713},{-0.565714, -0.495000, 0.857365}}],
    Line[{{-0.282857, -0.495000, 0.857365},{-0.000000, -0.495000, 
        0.857365},{-0.000000, -0.662439, 0.735713},{-0.282857, -0.662439, 
        0.735713},{-0.282857, -0.495000, 0.857365}}],
    Line[{{-0.000000, -0.495000, 0.857365},{0.282857, -0.495000, 0.857365},{
      0.282857, -0.662439, 0.735713},{-0.000000, -0.662439, 
        0.735713},{-0.000000, -0.495000, 0.857365}}],
    Line[{{0.282857, -0.495000, 0.857365},{0.565714, -0.495000, 0.857365},{
      0.565714, -0.662439, 0.735713},{0.282857, -0.662439, 0.735713},{
      0.282857, -0.495000, 0.857365}}],
    Line[{{0.565714, -0.495000, 0.857365},{0.848571, -0.495000, 0.857365},{
      0.848571, -0.662439, 0.735713},{0.565714, -0.662439, 0.735713},{
      0.565714, -0.495000, 0.857365}}],
    Line[{{0.848571, -0.495000, 0.857365},{1.131429, -0.495000, 0.857365},{
      1.131429, -0.662439, 0.735713},{0.848571, -0.662439, 0.735713},{
      0.848571, -0.495000, 0.857365}}],
    Line[{{1.131429, -0.495000, 0.857365},{1.414286, -0.495000, 0.857365},{
      1.414286, -0.662439, 0.735713},{1.131429, -0.662439, 0.735713},{
      1.131429, -0.495000, 0.857365}}],
    Line[{{1.414286, -0.495000, 0.857365},{1.697143, -0.495000, 0.857365},{
      1.697143, -0.662439, 0.735713},{1.414286, -0.662439, 0.735713},{
      1.414286, -0.495000, 0.857365}}],
    Line[{{1.697143, -0.495000, 0.857365},{1.980000, -0.495000, 0.857365},{
      1.980000, -0.662439, 0.735713},{1.697143, -0.662439, 0.735713},{
      1.697143, -0.495000, 0.857365}}],
    Line[{{-1.980000, -0.662439, 0.735713},{-1.697143, -0.662439, 
        0.735713},{-1.697143, -0.800927, 0.581907},{-1.980000, -0.800927, 
        0.581907},{-1.980000, -0.662439, 0.735713}}],
    Line[{{-1.697143, -0.662439, 0.735713},{-1.414286, -0.662439, 
        0.735713},{-1.414286, -0.800927, 0.581907},{-1.697143, -0.800927, 
        0.581907},{-1.697143, -0.662439, 0.735713}}],
    Line[{{-1.414286, -0.662439, 0.735713},{-1.131429, -0.662439, 
        0.735713},{-1.131429, -0.800927, 0.581907},{-1.414286, -0.800927, 
        0.581907},{-1.414286, -0.662439, 0.735713}}],
    Line[{{-1.131429, -0.662439, 0.735713},{-0.848571, -0.662439, 
        0.735713},{-0.848571, -0.800927, 0.581907},{-1.131429, -0.800927, 
        0.581907},{-1.131429, -0.662439, 0.735713}}],
    Line[{{-0.848571, -0.662439, 0.735713},{-0.565714, -0.662439, 
        0.735713},{-0.565714, -0.800927, 0.581907},{-0.848571, -0.800927, 
        0.581907},{-0.848571, -0.662439, 0.735713}}],
    Line[{{-0.565714, -0.662439, 0.735713},{-0.282857, -0.662439, 
        0.735713},{-0.282857, -0.800927, 0.581907},{-0.565714, -0.800927, 
        0.581907},{-0.565714, -0.662439, 0.735713}}],
    Line[{{-0.282857, -0.662439, 0.735713},{-0.000000, -0.662439, 
        0.735713},{-0.000000, -0.800927, 0.581907},{-0.282857, -0.800927, 
        0.581907},{-0.282857, -0.662439, 0.735713}}],
    Line[{{-0.000000, -0.662439, 0.735713},{0.282857, -0.662439, 0.735713},{
      0.282857, -0.800927, 0.581907},{-0.000000, -0.800927, 
        0.581907},{-0.000000, -0.662439, 0.735713}}],
    Line[{{0.282857, -0.662439, 0.735713},{0.565714, -0.662439, 0.735713},{
      0.565714, -0.800927, 0.581907},{0.282857, -0.800927, 0.581907},{
      0.282857, -0.662439, 0.735713}}],
    Line[{{0.565714, -0.662439, 0.735713},{0.848571, -0.662439, 0.735713},{
      0.848571, -0.800927, 0.581907},{0.565714, -0.800927, 0.581907},{
      0.565714, -0.662439, 0.735713}}],
    Line[{{0.848571, -0.662439, 0.735713},{1.131429, -0.662439, 0.735713},{
      1.131429, -0.800927, 0.581907},{0.848571, -0.800927, 0.581907},{
      0.848571, -0.662439, 0.735713}}],
    Line[{{1.131429, -0.662439, 0.735713},{1.414286, -0.662439, 0.735713},{
      1.414286, -0.800927, 0.581907},{1.131429, -0.800927, 0.581907},{
      1.131429, -0.662439, 0.735713}}],
    Line[{{1.414286, -0.662439, 0.735713},{1.697143, -0.662439, 0.735713},{
      1.697143, -0.800927, 0.581907},{1.414286, -0.800927, 0.581907},{
      1.414286, -0.662439, 0.735713}}],
    Line[{{1.697143, -0.662439, 0.735713},{1.980000, -0.662439, 0.735713},{
      1.980000, -0.800927, 0.581907},{1.697143, -0.800927, 0.581907},{
      1.697143, -0.662439, 0.735713}}],
    Line[{{-1.980000, -0.800927, 0.581907},{-1.697143, -0.800927, 
        0.581907},{-1.697143, -0.904410, 0.402669},{-1.980000, -0.904410, 
        0.402669},{-1.980000, -0.800927, 0.581907}}],
    Line[{{-1.697143, -0.800927, 0.581907},{-1.414286, -0.800927, 
        0.581907},{-1.414286, -0.904410, 0.402669},{-1.697143, -0.904410, 
        0.402669},{-1.697143, -0.800927, 0.581907}}],
    Line[{{-1.414286, -0.800927, 0.581907},{-1.131429, -0.800927, 
        0.581907},{-1.131429, -0.904410, 0.402669},{-1.414286, -0.904410, 
        0.402669},{-1.414286, -0.800927, 0.581907}}],
    Line[{{-1.131429, -0.800927, 0.581907},{-0.848571, -0.800927, 
        0.581907},{-0.848571, -0.904410, 0.402669},{-1.131429, -0.904410, 
        0.402669},{-1.131429, -0.800927, 0.581907}}],
    Line[{{-0.848571, -0.800927, 0.581907},{-0.565714, -0.800927, 
        0.581907},{-0.565714, -0.904410, 0.402669},{-0.848571, -0.904410, 
        0.402669},{-0.848571, -0.800927, 0.581907}}],
    Line[{{-0.565714, -0.800927, 0.581907},{-0.282857, -0.800927, 
        0.581907},{-0.282857, -0.904410, 0.402669},{-0.565714, -0.904410, 
        0.402669},{-0.565714, -0.800927, 0.581907}}],
    Line[{{-0.282857, -0.800927, 0.581907},{-0.000000, -0.800927, 
        0.581907},{-0.000000, -0.904410, 0.402669},{-0.282857, -0.904410, 
        0.402669},{-0.282857, -0.800927, 0.581907}}],
    Line[{{-0.000000, -0.800927, 0.581907},{0.282857, -0.800927, 0.581907},{
      0.282857, -0.904410, 0.402669},{-0.000000, -0.904410, 
        0.402669},{-0.000000, -0.800927, 0.581907}}],
    Line[{{0.282857, -0.800927, 0.581907},{0.565714, -0.800927, 0.581907},{
      0.565714, -0.904410, 0.402669},{0.282857, -0.904410, 0.402669},{
      0.282857, -0.800927, 0.581907}}],
    Line[{{0.565714, -0.800927, 0.581907},{0.848571, -0.800927, 0.581907},{
      0.848571, -0.904410, 0.402669},{0.565714, -0.904410, 0.402669},{
      0.565714, -0.800927, 0.581907}}],
    Line[{{0.848571, -0.800927, 0.581907},{1.131429, -0.800927, 0.581907},{
      1.131429, -0.904410, 0.402669},{0.848571, -0.904410, 0.402669},{
      0.848571, -0.800927, 0.581907}}],
    Line[{{1.131429, -0.800927, 0.581907},{1.414286, -0.800927, 0.581907},{
      1.414286, -0.904410, 0.402669},{1.131429, -0.904410, 0.402669},{
      1.131429, -0.800927, 0.581907}}],
    Line[{{1.414286, -0.800927, 0.581907},{1.697143, -0.800927, 0.581907},{
      1.697143, -0.904410, 0.402669},{1.414286, -0.904410, 0.402669},{
      1.414286, -0.800927, 0.581907}}],
    Line[{{1.697143, -0.800927, 0.581907},{1.980000, -0.800927, 0.581907},{
      1.980000, -0.904410, 0.402669},{1.697143, -0.904410, 0.402669},{
      1.697143, -0.800927, 0.581907}}],
    Line[{{-1.980000, -0.904410, 0.402669},{-1.697143, -0.904410, 
        0.402669},{-1.697143, -0.968366, 0.205833},{-1.980000, -0.968366, 
        0.205833},{-1.980000, -0.904410, 0.402669}}],
    Line[{{-1.697143, -0.904410, 0.402669},{-1.414286, -0.904410, 
        0.402669},{-1.414286, -0.968366, 0.205833},{-1.697143, -0.968366, 
        0.205833},{-1.697143, -0.904410, 0.402669}}],
    Line[{{-1.414286, -0.904410, 0.402669},{-1.131429, -0.904410, 
        0.402669},{-1.131429, -0.968366, 0.205833},{-1.414286, -0.968366, 
        0.205833},{-1.414286, -0.904410, 0.402669}}],
    Line[{{-1.131429, -0.904410, 0.402669},{-0.848571, -0.904410, 
        0.402669},{-0.848571, -0.968366, 0.205833},{-1.131429, -0.968366, 
        0.205833},{-1.131429, -0.904410, 0.402669}}],
    Line[{{-0.848571, -0.904410, 0.402669},{-0.565714, -0.904410, 
        0.402669},{-0.565714, -0.968366, 0.205833},{-0.848571, -0.968366, 
        0.205833},{-0.848571, -0.904410, 0.402669}}],
    Line[{{-0.565714, -0.904410, 0.402669},{-0.282857, -0.904410, 
        0.402669},{-0.282857, -0.968366, 0.205833},{-0.565714, -0.968366, 
        0.205833},{-0.565714, -0.904410, 0.402669}}],
    Line[{{-0.282857, -0.904410, 0.402669},{-0.000000, -0.904410, 
        0.402669},{-0.000000, -0.968366, 0.205833},{-0.282857, -0.968366, 
        0.205833},{-0.282857, -0.904410, 0.402669}}],
    Line[{{-0.000000, -0.904410, 0.402669},{0.282857, -0.904410, 0.402669},{
      0.282857, -0.968366, 0.205833},{-0.000000, -0.968366, 
        0.205833},{-0.000000, -0.904410, 0.402669}}],
    Line[{{0.282857, -0.904410, 0.402669},{0.565714, -0.904410, 0.402669},{
      0.565714, -0.968366, 0.205833},{0.282857, -0.968366, 0.205833},{
      0.282857, -0.904410, 0.402669}}],
    Line[{{0.565714, -0.904410, 0.402669},{0.848571, -0.904410, 0.402669},{
      0.848571, -0.968366, 0.205833},{0.565714, -0.968366, 0.205833},{
      0.565714, -0.904410, 0.402669}}],
    Line[{{0.848571, -0.904410, 0.402669},{1.131429, -0.904410, 0.402669},{
      1.131429, -0.968366, 0.205833},{0.848571, -0.968366, 0.205833},{
      0.848571, -0.904410, 0.402669}}],
    Line[{{1.131429, -0.904410, 0.402669},{1.414286, -0.904410, 0.402669},{
      1.414286, -0.968366, 0.205833},{1.131429, -0.968366, 0.205833},{
      1.131429, -0.904410, 0.402669}}],
    Line[{{1.414286, -0.904410, 0.402669},{1.697143, -0.904410, 0.402669},{
      1.697143, -0.968366, 0.205833},{1.414286, -0.968366, 0.205833},{
      1.414286, -0.904410, 0.402669}}],
    Line[{{1.697143, -0.904410, 0.402669},{1.980000, -0.904410, 0.402669},{
      1.980000, -0.968366, 0.205833},{1.697143, -0.968366, 0.205833},{
      1.697143, -0.904410, 0.402669}}],
    Line[{{-1.980000, -0.968366, 0.205833},{-1.697143, -0.968366, 
        0.205833},{-1.697143, -0.990000, 0.000000},{-1.980000, -0.990000, 
        0.000000},{-1.980000, -0.968366, 0.205833}}],
    Line[{{-1.697143, -0.968366, 0.205833},{-1.414286, -0.968366, 
        0.205833},{-1.414286, -0.990000, 0.000000},{-1.697143, -0.990000, 
        0.000000},{-1.697143, -0.968366, 0.205833}}],
    Line[{{-1.414286, -0.968366, 0.205833},{-1.131429, -0.968366, 
        0.205833},{-1.131429, -0.990000, 0.000000},{-1.414286, -0.990000, 
        0.000000},{-1.414286, -0.968366, 0.205833}}],
    Line[{{-1.131429, -0.968366, 0.205833},{-0.848571, -0.968366, 
        0.205833},{-0.848571, -0.990000, 0.000000},{-1.131429, -0.990000, 
        0.000000},{-1.131429, -0.968366, 0.205833}}],
    Line[{{-0.848571, -0.968366, 0.205833},{-0.565714, -0.968366, 
        0.205833},{-0.565714, -0.990000, 0.000000},{-0.848571, -0.990000, 
        0.000000},{-0.848571, -0.968366, 0.205833}}],
    Line[{{-0.565714, -0.968366, 0.205833},{-0.282857, -0.968366, 
        0.205833},{-0.282857, -0.990000, 0.000000},{-0.565714, -0.990000, 
        0.000000},{-0.565714, -0.968366, 0.205833}}],
    Line[{{-0.282857, -0.968366, 0.205833},{-0.000000, -0.968366, 
        0.205833},{-0.000000, -0.990000, 0.000000},{-0.282857, -0.990000, 
        0.000000},{-0.282857, -0.968366, 0.205833}}],
    Line[{{-0.000000, -0.968366, 0.205833},{0.282857, -0.968366, 0.205833},{
      0.282857, -0.990000, 0.000000},{-0.000000, -0.990000, 
        0.000000},{-0.000000, -0.968366, 0.205833}}],
    Line[{{0.282857, -0.968366, 0.205833},{0.565714, -0.968366, 0.205833},{
      0.565714, -0.990000, 0.000000},{0.282857, -0.990000, 0.000000},{
      0.282857, -0.968366, 0.205833}}],
    Line[{{0.565714, -0.968366, 0.205833},{0.848571, -0.968366, 0.205833},{
      0.848571, -0.990000, 0.000000},{0.565714, -0.990000, 0.000000},{
      0.565714, -0.968366, 0.205833}}],
    Line[{{0.848571, -0.968366, 0.205833},{1.131429, -0.968366, 0.205833},{
      1.131429, -0.990000, 0.000000},{0.848571, -0.990000, 0.000000},{
      0.848571, -0.968366, 0.205833}}],
    Line[{{1.131429, -0.968366, 0.205833},{1.414286, -0.968366, 0.205833},{
      1.414286, -0.990000, 0.000000},{1.131429, -0.990000, 0.000000},{
      1.131429, -0.968366, 0.205833}}],
    Line[{{1.414286, -0.968366, 0.205833},{1.697143, -0.968366, 0.205833},{
      1.697143, -0.990000, 0.000000},{1.414286, -0.990000, 0.000000},{
      1.414286, -0.968366, 0.205833}}],
    Line[{{1.697143, -0.968366, 0.205833},{1.980000, -0.968366, 0.205833},{
      1.980000, -0.990000, 0.000000},{1.697143, -0.990000, 0.000000},{
      1.697143, -0.968366, 0.205833}}],
    Line[{{-1.980000, -0.990000, 0.000000},{-1.697143, -0.990000, 
        0.000000},{-1.697143, -0.968366, -0.205833},{-1.980000, -0.968366, \
-0.205833},{-1.980000, -0.990000, 0.000000}}],
    Line[{{-1.697143, -0.990000, 0.000000},{-1.414286, -0.990000, 
        0.000000},{-1.414286, -0.968366, -0.205833},{-1.697143, -0.968366, \
-0.205833},{-1.697143, -0.990000, 0.000000}}],
    Line[{{-1.414286, -0.990000, 0.000000},{-1.131429, -0.990000, 
        0.000000},{-1.131429, -0.968366, -0.205833},{-1.414286, -0.968366, \
-0.205833},{-1.414286, -0.990000, 0.000000}}],
    Line[{{-1.131429, -0.990000, 0.000000},{-0.848571, -0.990000, 
        0.000000},{-0.848571, -0.968366, -0.205833},{-1.131429, -0.968366, \
-0.205833},{-1.131429, -0.990000, 0.000000}}],
    Line[{{-0.848571, -0.990000, 0.000000},{-0.565714, -0.990000, 
        0.000000},{-0.565714, -0.968366, -0.205833},{-0.848571, -0.968366, \
-0.205833},{-0.848571, -0.990000, 0.000000}}],
    Line[{{-0.565714, -0.990000, 0.000000},{-0.282857, -0.990000, 
        0.000000},{-0.282857, -0.968366, -0.205833},{-0.565714, -0.968366, \
-0.205833},{-0.565714, -0.990000, 0.000000}}],
    Line[{{-0.282857, -0.990000, 0.000000},{-0.000000, -0.990000, 
        0.000000},{-0.000000, -0.968366, -0.205833},{-0.282857, -0.968366, \
-0.205833},{-0.282857, -0.990000, 0.000000}}],
    Line[{{-0.000000, -0.990000, 0.000000},{0.282857, -0.990000, 0.000000},{
      0.282857, -0.968366, -0.205833},{-0.000000, -0.968366, \
-0.205833},{-0.000000, -0.990000, 0.000000}}],
    Line[{{0.282857, -0.990000, 0.000000},{0.565714, -0.990000, 0.000000},{
      0.565714, -0.968366, -0.205833},{0.282857, -0.968366, -0.205833},{
      0.282857, -0.990000, 0.000000}}],
    Line[{{0.565714, -0.990000, 0.000000},{0.848571, -0.990000, 0.000000},{
      0.848571, -0.968366, -0.205833},{0.565714, -0.968366, -0.205833},{
      0.565714, -0.990000, 0.000000}}],
    Line[{{0.848571, -0.990000, 0.000000},{1.131429, -0.990000, 0.000000},{
      1.131429, -0.968366, -0.205833},{0.848571, -0.968366, -0.205833},{
      0.848571, -0.990000, 0.000000}}],
    Line[{{1.131429, -0.990000, 0.000000},{1.414286, -0.990000, 0.000000},{
      1.414286, -0.968366, -0.205833},{1.131429, -0.968366, -0.205833},{
      1.131429, -0.990000, 0.000000}}],
    Line[{{1.414286, -0.990000, 0.000000},{1.697143, -0.990000, 0.000000},{
      1.697143, -0.968366, -0.205833},{1.414286, -0.968366, -0.205833},{
      1.414286, -0.990000, 0.000000}}],
    Line[{{1.697143, -0.990000, 0.000000},{1.980000, -0.990000, 0.000000},{
      1.980000, -0.968366, -0.205833},{1.697143, -0.968366, -0.205833},{
      1.697143, -0.990000, 0.000000}}],
    Line[{{-1.980000, -0.968366, -0.205833},{-1.697143, -0.968366, \
-0.205833},{-1.697143, -0.904410, -0.402669},{-1.980000, -0.904410, \
-0.402669},{-1.980000, -0.968366, -0.205833}}],
    Line[{{-1.697143, -0.968366, -0.205833},{-1.414286, -0.968366, \
-0.205833},{-1.414286, -0.904410, -0.402669},{-1.697143, -0.904410, \
-0.402669},{-1.697143, -0.968366, -0.205833}}],
    Line[{{-1.414286, -0.968366, -0.205833},{-1.131429, -0.968366, \
-0.205833},{-1.131429, -0.904410, -0.402669},{-1.414286, -0.904410, \
-0.402669},{-1.414286, -0.968366, -0.205833}}],
    Line[{{-1.131429, -0.968366, -0.205833},{-0.848571, -0.968366, \
-0.205833},{-0.848571, -0.904410, -0.402669},{-1.131429, -0.904410, \
-0.402669},{-1.131429, -0.968366, -0.205833}}],
    Line[{{-0.848571, -0.968366, -0.205833},{-0.565714, -0.968366, \
-0.205833},{-0.565714, -0.904410, -0.402669},{-0.848571, -0.904410, \
-0.402669},{-0.848571, -0.968366, -0.205833}}],
    Line[{{-0.565714, -0.968366, -0.205833},{-0.282857, -0.968366, \
-0.205833},{-0.282857, -0.904410, -0.402669},{-0.565714, -0.904410, \
-0.402669},{-0.565714, -0.968366, -0.205833}}],
    Line[{{-0.282857, -0.968366, -0.205833},{-0.000000, -0.968366, \
-0.205833},{-0.000000, -0.904410, -0.402669},{-0.282857, -0.904410, \
-0.402669},{-0.282857, -0.968366, -0.205833}}],
    Line[{{-0.000000, -0.968366, -0.205833},{0.282857, -0.968366, -0.205833},{
      0.282857, -0.904410, -0.402669},{-0.000000, -0.904410, \
-0.402669},{-0.000000, -0.968366, -0.205833}}],
    Line[{{0.282857, -0.968366, -0.205833},{0.565714, -0.968366, -0.205833},{
      0.565714, -0.904410, -0.402669},{0.282857, -0.904410, -0.402669},{
      0.282857, -0.968366, -0.205833}}],
    Line[{{0.565714, -0.968366, -0.205833},{0.848571, -0.968366, -0.205833},{
      0.848571, -0.904410, -0.402669},{0.565714, -0.904410, -0.402669},{
      0.565714, -0.968366, -0.205833}}],
    Line[{{0.848571, -0.968366, -0.205833},{1.131429, -0.968366, -0.205833},{
      1.131429, -0.904410, -0.402669},{0.848571, -0.904410, -0.402669},{
      0.848571, -0.968366, -0.205833}}],
    Line[{{1.131429, -0.968366, -0.205833},{1.414286, -0.968366, -0.205833},{
      1.414286, -0.904410, -0.402669},{1.131429, -0.904410, -0.402669},{
      1.131429, -0.968366, -0.205833}}],
    Line[{{1.414286, -0.968366, -0.205833},{1.697143, -0.968366, -0.205833},{
      1.697143, -0.904410, -0.402669},{1.414286, -0.904410, -0.402669},{
      1.414286, -0.968366, -0.205833}}],
    Line[{{1.697143, -0.968366, -0.205833},{1.980000, -0.968366, -0.205833},{
      1.980000, -0.904410, -0.402669},{1.697143, -0.904410, -0.402669},{
      1.697143, -0.968366, -0.205833}}],
    Line[{{-1.980000, -0.904410, -0.402669},{-1.697143, -0.904410, \
-0.402669},{-1.697143, -0.800927, -0.581907},{-1.980000, -0.800927, \
-0.581907},{-1.980000, -0.904410, -0.402669}}],
    Line[{{-1.697143, -0.904410, -0.402669},{-1.414286, -0.904410, \
-0.402669},{-1.414286, -0.800927, -0.581907},{-1.697143, -0.800927, \
-0.581907},{-1.697143, -0.904410, -0.402669}}],
    Line[{{-1.414286, -0.904410, -0.402669},{-1.131429, -0.904410, \
-0.402669},{-1.131429, -0.800927, -0.581907},{-1.414286, -0.800927, \
-0.581907},{-1.414286, -0.904410, -0.402669}}],
    Line[{{-1.131429, -0.904410, -0.402669},{-0.848571, -0.904410, \
-0.402669},{-0.848571, -0.800927, -0.581907},{-1.131429, -0.800927, \
-0.581907},{-1.131429, -0.904410, -0.402669}}],
    Line[{{-0.848571, -0.904410, -0.402669},{-0.565714, -0.904410, \
-0.402669},{-0.565714, -0.800927, -0.581907},{-0.848571, -0.800927, \
-0.581907},{-0.848571, -0.904410, -0.402669}}],
    Line[{{-0.565714, -0.904410, -0.402669},{-0.282857, -0.904410, \
-0.402669},{-0.282857, -0.800927, -0.581907},{-0.565714, -0.800927, \
-0.581907},{-0.565714, -0.904410, -0.402669}}],
    Line[{{-0.282857, -0.904410, -0.402669},{-0.000000, -0.904410, \
-0.402669},{-0.000000, -0.800927, -0.581907},{-0.282857, -0.800927, \
-0.581907},{-0.282857, -0.904410, -0.402669}}],
    Line[{{-0.000000, -0.904410, -0.402669},{0.282857, -0.904410, -0.402669},{
      0.282857, -0.800927, -0.581907},{-0.000000, -0.800927, \
-0.581907},{-0.000000, -0.904410, -0.402669}}],
    Line[{{0.282857, -0.904410, -0.402669},{0.565714, -0.904410, -0.402669},{
      0.565714, -0.800927, -0.581907},{0.282857, -0.800927, -0.581907},{
      0.282857, -0.904410, -0.402669}}],
    Line[{{0.565714, -0.904410, -0.402669},{0.848571, -0.904410, -0.402669},{
      0.848571, -0.800927, -0.581907},{0.565714, -0.800927, -0.581907},{
      0.565714, -0.904410, -0.402669}}],
    Line[{{0.848571, -0.904410, -0.402669},{1.131429, -0.904410, -0.402669},{
      1.131429, -0.800927, -0.581907},{0.848571, -0.800927, -0.581907},{
      0.848571, -0.904410, -0.402669}}],
    Line[{{1.131429, -0.904410, -0.402669},{1.414286, -0.904410, -0.402669},{
      1.414286, -0.800927, -0.581907},{1.131429, -0.800927, -0.581907},{
      1.131429, -0.904410, -0.402669}}],
    Line[{{1.414286, -0.904410, -0.402669},{1.697143, -0.904410, -0.402669},{
      1.697143, -0.800927, -0.581907},{1.414286, -0.800927, -0.581907},{
      1.414286, -0.904410, -0.402669}}],
    Line[{{1.697143, -0.904410, -0.402669},{1.980000, -0.904410, -0.402669},{
      1.980000, -0.800927, -0.581907},{1.697143, -0.800927, -0.581907},{
      1.697143, -0.904410, -0.402669}}],
    Line[{{-1.980000, -0.800927, -0.581907},{-1.697143, -0.800927, \
-0.581907},{-1.697143, -0.662439, -0.735713},{-1.980000, -0.662439, \
-0.735713},{-1.980000, -0.800927, -0.581907}}],
    Line[{{-1.697143, -0.800927, -0.581907},{-1.414286, -0.800927, \
-0.581907},{-1.414286, -0.662439, -0.735713},{-1.697143, -0.662439, \
-0.735713},{-1.697143, -0.800927, -0.581907}}],
    Line[{{-1.414286, -0.800927, -0.581907},{-1.131429, -0.800927, \
-0.581907},{-1.131429, -0.662439, -0.735713},{-1.414286, -0.662439, \
-0.735713},{-1.414286, -0.800927, -0.581907}}],
    Line[{{-1.131429, -0.800927, -0.581907},{-0.848571, -0.800927, \
-0.581907},{-0.848571, -0.662439, -0.735713},{-1.131429, -0.662439, \
-0.735713},{-1.131429, -0.800927, -0.581907}}],
    Line[{{-0.848571, -0.800927, -0.581907},{-0.565714, -0.800927, \
-0.581907},{-0.565714, -0.662439, -0.735713},{-0.848571, -0.662439, \
-0.735713},{-0.848571, -0.800927, -0.581907}}],
    Line[{{-0.565714, -0.800927, -0.581907},{-0.282857, -0.800927, \
-0.581907},{-0.282857, -0.662439, -0.735713},{-0.565714, -0.662439, \
-0.735713},{-0.565714, -0.800927, -0.581907}}],
    Line[{{-0.282857, -0.800927, -0.581907},{-0.000000, -0.800927, \
-0.581907},{-0.000000, -0.662439, -0.735713},{-0.282857, -0.662439, \
-0.735713},{-0.282857, -0.800927, -0.581907}}],
    Line[{{-0.000000, -0.800927, -0.581907},{0.282857, -0.800927, -0.581907},{
      0.282857, -0.662439, -0.735713},{-0.000000, -0.662439, \
-0.735713},{-0.000000, -0.800927, -0.581907}}],
    Line[{{0.282857, -0.800927, -0.581907},{0.565714, -0.800927, -0.581907},{
      0.565714, -0.662439, -0.735713},{0.282857, -0.662439, -0.735713},{
      0.282857, -0.800927, -0.581907}}],
    Line[{{0.565714, -0.800927, -0.581907},{0.848571, -0.800927, -0.581907},{
      0.848571, -0.662439, -0.735713},{0.565714, -0.662439, -0.735713},{
      0.565714, -0.800927, -0.581907}}],
    Line[{{0.848571, -0.800927, -0.581907},{1.131429, -0.800927, -0.581907},{
      1.131429, -0.662439, -0.735713},{0.848571, -0.662439, -0.735713},{
      0.848571, -0.800927, -0.581907}}],
    Line[{{1.131429, -0.800927, -0.581907},{1.414286, -0.800927, -0.581907},{
      1.414286, -0.662439, -0.735713},{1.131429, -0.662439, -0.735713},{
      1.131429, -0.800927, -0.581907}}],
    Line[{{1.414286, -0.800927, -0.581907},{1.697143, -0.800927, -0.581907},{
      1.697143, -0.662439, -0.735713},{1.414286, -0.662439, -0.735713},{
      1.414286, -0.800927, -0.581907}}],
    Line[{{1.697143, -0.800927, -0.581907},{1.980000, -0.800927, -0.581907},{
      1.980000, -0.662439, -0.735713},{1.697143, -0.662439, -0.735713},{
      1.697143, -0.800927, -0.581907}}],
    Line[{{-1.980000, -0.662439, -0.735713},{-1.697143, -0.662439, \
-0.735713},{-1.697143, -0.495000, -0.857365},{-1.980000, -0.495000, \
-0.857365},{-1.980000, -0.662439, -0.735713}}],
    Line[{{-1.697143, -0.662439, -0.735713},{-1.414286, -0.662439, \
-0.735713},{-1.414286, -0.495000, -0.857365},{-1.697143, -0.495000, \
-0.857365},{-1.697143, -0.662439, -0.735713}}],
    Line[{{-1.414286, -0.662439, -0.735713},{-1.131429, -0.662439, \
-0.735713},{-1.131429, -0.495000, -0.857365},{-1.414286, -0.495000, \
-0.857365},{-1.414286, -0.662439, -0.735713}}],
    Line[{{-1.131429, -0.662439, -0.735713},{-0.848571, -0.662439, \
-0.735713},{-0.848571, -0.495000, -0.857365},{-1.131429, -0.495000, \
-0.857365},{-1.131429, -0.662439, -0.735713}}],
    Line[{{-0.848571, -0.662439, -0.735713},{-0.565714, -0.662439, \
-0.735713},{-0.565714, -0.495000, -0.857365},{-0.848571, -0.495000, \
-0.857365},{-0.848571, -0.662439, -0.735713}}],
    Line[{{-0.565714, -0.662439, -0.735713},{-0.282857, -0.662439, \
-0.735713},{-0.282857, -0.495000, -0.857365},{-0.565714, -0.495000, \
-0.857365},{-0.565714, -0.662439, -0.735713}}],
    Line[{{-0.282857, -0.662439, -0.735713},{-0.000000, -0.662439, \
-0.735713},{-0.000000, -0.495000, -0.857365},{-0.282857, -0.495000, \
-0.857365},{-0.282857, -0.662439, -0.735713}}],
    Line[{{-0.000000, -0.662439, -0.735713},{0.282857, -0.662439, -0.735713},{
      0.282857, -0.495000, -0.857365},{-0.000000, -0.495000, \
-0.857365},{-0.000000, -0.662439, -0.735713}}],
    Line[{{0.282857, -0.662439, -0.735713},{0.565714, -0.662439, -0.735713},{
      0.565714, -0.495000, -0.857365},{0.282857, -0.495000, -0.857365},{
      0.282857, -0.662439, -0.735713}}],
    Line[{{0.565714, -0.662439, -0.735713},{0.848571, -0.662439, -0.735713},{
      0.848571, -0.495000, -0.857365},{0.565714, -0.495000, -0.857365},{
      0.565714, -0.662439, -0.735713}}],
    Line[{{0.848571, -0.662439, -0.735713},{1.131429, -0.662439, -0.735713},{
      1.131429, -0.495000, -0.857365},{0.848571, -0.495000, -0.857365},{
      0.848571, -0.662439, -0.735713}}],
    Line[{{1.131429, -0.662439, -0.735713},{1.414286, -0.662439, -0.735713},{
      1.414286, -0.495000, -0.857365},{1.131429, -0.495000, -0.857365},{
      1.131429, -0.662439, -0.735713}}],
    Line[{{1.414286, -0.662439, -0.735713},{1.697143, -0.662439, -0.735713},{
      1.697143, -0.495000, -0.857365},{1.414286, -0.495000, -0.857365},{
      1.414286, -0.662439, -0.735713}}],
    Line[{{1.697143, -0.662439, -0.735713},{1.980000, -0.662439, -0.735713},{
      1.980000, -0.495000, -0.857365},{1.697143, -0.495000, -0.857365},{
      1.697143, -0.662439, -0.735713}}],
    Line[{{-1.980000, -0.495000, -0.857365},{-1.697143, -0.495000, \
-0.857365},{-1.697143, -0.305927, -0.941546},{-1.980000, -0.305927, \
-0.941546},{-1.980000, -0.495000, -0.857365}}],
    Line[{{-1.697143, -0.495000, -0.857365},{-1.414286, -0.495000, \
-0.857365},{-1.414286, -0.305927, -0.941546},{-1.697143, -0.305927, \
-0.941546},{-1.697143, -0.495000, -0.857365}}],
    Line[{{-1.414286, -0.495000, -0.857365},{-1.131429, -0.495000, \
-0.857365},{-1.131429, -0.305927, -0.941546},{-1.414286, -0.305927, \
-0.941546},{-1.414286, -0.495000, -0.857365}}],
    Line[{{-1.131429, -0.495000, -0.857365},{-0.848571, -0.495000, \
-0.857365},{-0.848571, -0.305927, -0.941546},{-1.131429, -0.305927, \
-0.941546},{-1.131429, -0.495000, -0.857365}}],
    Line[{{-0.848571, -0.495000, -0.857365},{-0.565714, -0.495000, \
-0.857365},{-0.565714, -0.305927, -0.941546},{-0.848571, -0.305927, \
-0.941546},{-0.848571, -0.495000, -0.857365}}],
    Line[{{-0.565714, -0.495000, -0.857365},{-0.282857, -0.495000, \
-0.857365},{-0.282857, -0.305927, -0.941546},{-0.565714, -0.305927, \
-0.941546},{-0.565714, -0.495000, -0.857365}}],
    Line[{{-0.282857, -0.495000, -0.857365},{-0.000000, -0.495000, \
-0.857365},{-0.000000, -0.305927, -0.941546},{-0.282857, -0.305927, \
-0.941546},{-0.282857, -0.495000, -0.857365}}],
    Line[{{-0.000000, -0.495000, -0.857365},{0.282857, -0.495000, -0.857365},{
      0.282857, -0.305927, -0.941546},{-0.000000, -0.305927, \
-0.941546},{-0.000000, -0.495000, -0.857365}}],
    Line[{{0.282857, -0.495000, -0.857365},{0.565714, -0.495000, -0.857365},{
      0.565714, -0.305927, -0.941546},{0.282857, -0.305927, -0.941546},{
      0.282857, -0.495000, -0.857365}}],
    Line[{{0.565714, -0.495000, -0.857365},{0.848571, -0.495000, -0.857365},{
      0.848571, -0.305927, -0.941546},{0.565714, -0.305927, -0.941546},{
      0.565714, -0.495000, -0.857365}}],
    Line[{{0.848571, -0.495000, -0.857365},{1.131429, -0.495000, -0.857365},{
      1.131429, -0.305927, -0.941546},{0.848571, -0.305927, -0.941546},{
      0.848571, -0.495000, -0.857365}}],
    Line[{{1.131429, -0.495000, -0.857365},{1.414286, -0.495000, -0.857365},{
      1.414286, -0.305927, -0.941546},{1.131429, -0.305927, -0.941546},{
      1.131429, -0.495000, -0.857365}}],
    Line[{{1.414286, -0.495000, -0.857365},{1.697143, -0.495000, -0.857365},{
      1.697143, -0.305927, -0.941546},{1.414286, -0.305927, -0.941546},{
      1.414286, -0.495000, -0.857365}}],
    Line[{{1.697143, -0.495000, -0.857365},{1.980000, -0.495000, -0.857365},{
      1.980000, -0.305927, -0.941546},{1.697143, -0.305927, -0.941546},{
      1.697143, -0.495000, -0.857365}}],
    Line[{{-1.980000, -0.305927, -0.941546},{-1.697143, -0.305927, \
-0.941546},{-1.697143, -0.103483, -0.984577},{-1.980000, -0.103483, \
-0.984577},{-1.980000, -0.305927, -0.941546}}],
    Line[{{-1.697143, -0.305927, -0.941546},{-1.414286, -0.305927, \
-0.941546},{-1.414286, -0.103483, -0.984577},{-1.697143, -0.103483, \
-0.984577},{-1.697143, -0.305927, -0.941546}}],
    Line[{{-1.414286, -0.305927, -0.941546},{-1.131429, -0.305927, \
-0.941546},{-1.131429, -0.103483, -0.984577},{-1.414286, -0.103483, \
-0.984577},{-1.414286, -0.305927, -0.941546}}],
    Line[{{-1.131429, -0.305927, -0.941546},{-0.848571, -0.305927, \
-0.941546},{-0.848571, -0.103483, -0.984577},{-1.131429, -0.103483, \
-0.984577},{-1.131429, -0.305927, -0.941546}}],
    Line[{{-0.848571, -0.305927, -0.941546},{-0.565714, -0.305927, \
-0.941546},{-0.565714, -0.103483, -0.984577},{-0.848571, -0.103483, \
-0.984577},{-0.848571, -0.305927, -0.941546}}],
    Line[{{-0.565714, -0.305927, -0.941546},{-0.282857, -0.305927, \
-0.941546},{-0.282857, -0.103483, -0.984577},{-0.565714, -0.103483, \
-0.984577},{-0.565714, -0.305927, -0.941546}}],
    Line[{{-0.282857, -0.305927, -0.941546},{-0.000000, -0.305927, \
-0.941546},{-0.000000, -0.103483, -0.984577},{-0.282857, -0.103483, \
-0.984577},{-0.282857, -0.305927, -0.941546}}],
    Line[{{-0.000000, -0.305927, -0.941546},{0.282857, -0.305927, -0.941546},{
      0.282857, -0.103483, -0.984577},{-0.000000, -0.103483, \
-0.984577},{-0.000000, -0.305927, -0.941546}}],
    Line[{{0.282857, -0.305927, -0.941546},{0.565714, -0.305927, -0.941546},{
      0.565714, -0.103483, -0.984577},{0.282857, -0.103483, -0.984577},{
      0.282857, -0.305927, -0.941546}}],
    Line[{{0.565714, -0.305927, -0.941546},{0.848571, -0.305927, -0.941546},{
      0.848571, -0.103483, -0.984577},{0.565714, -0.103483, -0.984577},{
      0.565714, -0.305927, -0.941546}}],
    Line[{{0.848571, -0.305927, -0.941546},{1.131429, -0.305927, -0.941546},{
      1.131429, -0.103483, -0.984577},{0.848571, -0.103483, -0.984577},{
      0.848571, -0.305927, -0.941546}}],
    Line[{{1.131429, -0.305927, -0.941546},{1.414286, -0.305927, -0.941546},{
      1.414286, -0.103483, -0.984577},{1.131429, -0.103483, -0.984577},{
      1.131429, -0.305927, -0.941546}}],
    Line[{{1.414286, -0.305927, -0.941546},{1.697143, -0.305927, -0.941546},{
      1.697143, -0.103483, -0.984577},{1.414286, -0.103483, -0.984577},{
      1.414286, -0.305927, -0.941546}}],
    Line[{{1.697143, -0.305927, -0.941546},{1.980000, -0.305927, -0.941546},{
      1.980000, -0.103483, -0.984577},{1.697143, -0.103483, -0.984577},{
      1.697143, -0.305927, -0.941546}}],
    Line[{{-1.980000, -0.103483, -0.984577},{-1.697143, -0.103483, \
-0.984577},{-1.697143, 0.103483, -0.984577},{-1.980000, 
        0.103483, -0.984577},{-1.980000, -0.103483, -0.984577}}],
    Line[{{-1.697143, -0.103483, -0.984577},{-1.414286, -0.103483, \
-0.984577},{-1.414286, 0.103483, -0.984577},{-1.697143, 
        0.103483, -0.984577},{-1.697143, -0.103483, -0.984577}}],
    Line[{{-1.414286, -0.103483, -0.984577},{-1.131429, -0.103483, \
-0.984577},{-1.131429, 0.103483, -0.984577},{-1.414286, 
        0.103483, -0.984577},{-1.414286, -0.103483, -0.984577}}],
    Line[{{-1.131429, -0.103483, -0.984577},{-0.848571, -0.103483, \
-0.984577},{-0.848571, 0.103483, -0.984577},{-1.131429, 
        0.103483, -0.984577},{-1.131429, -0.103483, -0.984577}}],
    Line[{{-0.848571, -0.103483, -0.984577},{-0.565714, -0.103483, \
-0.984577},{-0.565714, 0.103483, -0.984577},{-0.848571, 
        0.103483, -0.984577},{-0.848571, -0.103483, -0.984577}}],
    Line[{{-0.565714, -0.103483, -0.984577},{-0.282857, -0.103483, \
-0.984577},{-0.282857, 0.103483, -0.984577},{-0.565714, 
        0.103483, -0.984577},{-0.565714, -0.103483, -0.984577}}],
    Line[{{-0.282857, -0.103483, -0.984577},{-0.000000, -0.103483, \
-0.984577},{-0.000000, 0.103483, -0.984577},{-0.282857, 
        0.103483, -0.984577},{-0.282857, -0.103483, -0.984577}}],
    Line[{{-0.000000, -0.103483, -0.984577},{0.282857, -0.103483, -0.984577},{
      0.282857, 0.103483, -0.984577},{-0.000000, 
        0.103483, -0.984577},{-0.000000, -0.103483, -0.984577}}],
    Line[{{0.282857, -0.103483, -0.984577},{0.565714, -0.103483, -0.984577},{
      0.565714, 0.103483, -0.984577},{0.282857, 0.103483, -0.984577},{
      0.282857, -0.103483, -0.984577}}],
    Line[{{0.565714, -0.103483, -0.984577},{0.848571, -0.103483, -0.984577},{
      0.848571, 0.103483, -0.984577},{0.565714, 0.103483, -0.984577},{
      0.565714, -0.103483, -0.984577}}],
    Line[{{0.848571, -0.103483, -0.984577},{1.131429, -0.103483, -0.984577},{
      1.131429, 0.103483, -0.984577},{0.848571, 0.103483, -0.984577},{
      0.848571, -0.103483, -0.984577}}],
    Line[{{1.131429, -0.103483, -0.984577},{1.414286, -0.103483, -0.984577},{
      1.414286, 0.103483, -0.984577},{1.131429, 0.103483, -0.984577},{
      1.131429, -0.103483, -0.984577}}],
    Line[{{1.414286, -0.103483, -0.984577},{1.697143, -0.103483, -0.984577},{
      1.697143, 0.103483, -0.984577},{1.414286, 0.103483, -0.984577},{
      1.414286, -0.103483, -0.984577}}],
    Line[{{1.697143, -0.103483, -0.984577},{1.980000, -0.103483, -0.984577},{
      1.980000, 0.103483, -0.984577},{1.697143, 0.103483, -0.984577},{
      1.697143, -0.103483, -0.984577}}],
    Line[{{-1.980000, 0.103483, -0.984577},{-1.697143, 
        0.103483, -0.984577},{-1.697143, 0.305927, -0.941546},{-1.980000, 
        0.305927, -0.941546},{-1.980000, 0.103483, -0.984577}}],
    Line[{{-1.697143, 0.103483, -0.984577},{-1.414286, 
        0.103483, -0.984577},{-1.414286, 0.305927, -0.941546},{-1.697143, 
        0.305927, -0.941546},{-1.697143, 0.103483, -0.984577}}],
    Line[{{-1.414286, 0.103483, -0.984577},{-1.131429, 
        0.103483, -0.984577},{-1.131429, 0.305927, -0.941546},{-1.414286, 
        0.305927, -0.941546},{-1.414286, 0.103483, -0.984577}}],
    Line[{{-1.131429, 0.103483, -0.984577},{-0.848571, 
        0.103483, -0.984577},{-0.848571, 0.305927, -0.941546},{-1.131429, 
        0.305927, -0.941546},{-1.131429, 0.103483, -0.984577}}],
    Line[{{-0.848571, 0.103483, -0.984577},{-0.565714, 
        0.103483, -0.984577},{-0.565714, 0.305927, -0.941546},{-0.848571, 
        0.305927, -0.941546},{-0.848571, 0.103483, -0.984577}}],
    Line[{{-0.565714, 0.103483, -0.984577},{-0.282857, 
        0.103483, -0.984577},{-0.282857, 0.305927, -0.941546},{-0.565714, 
        0.305927, -0.941546},{-0.565714, 0.103483, -0.984577}}],
    Line[{{-0.282857, 0.103483, -0.984577},{-0.000000, 
        0.103483, -0.984577},{-0.000000, 0.305927, -0.941546},{-0.282857, 
        0.305927, -0.941546},{-0.282857, 0.103483, -0.984577}}],
    Line[{{-0.000000, 0.103483, -0.984577},{0.282857, 0.103483, -0.984577},{
      0.282857, 0.305927, -0.941546},{-0.000000, 
        0.305927, -0.941546},{-0.000000, 0.103483, -0.984577}}],
    Line[{{0.282857, 0.103483, -0.984577},{0.565714, 0.103483, -0.984577},{
      0.565714, 0.305927, -0.941546},{0.282857, 0.305927, -0.941546},{
      0.282857, 0.103483, -0.984577}}],
    Line[{{0.565714, 0.103483, -0.984577},{0.848571, 0.103483, -0.984577},{
      0.848571, 0.305927, -0.941546},{0.565714, 0.305927, -0.941546},{
      0.565714, 0.103483, -0.984577}}],
    Line[{{0.848571, 0.103483, -0.984577},{1.131429, 0.103483, -0.984577},{
      1.131429, 0.305927, -0.941546},{0.848571, 0.305927, -0.941546},{
      0.848571, 0.103483, -0.984577}}],
    Line[{{1.131429, 0.103483, -0.984577},{1.414286, 0.103483, -0.984577},{
      1.414286, 0.305927, -0.941546},{1.131429, 0.305927, -0.941546},{
      1.131429, 0.103483, -0.984577}}],
    Line[{{1.414286, 0.103483, -0.984577},{1.697143, 0.103483, -0.984577},{
      1.697143, 0.305927, -0.941546},{1.414286, 0.305927, -0.941546},{
      1.414286, 0.103483, -0.984577}}],
    Line[{{1.697143, 0.103483, -0.984577},{1.980000, 0.103483, -0.984577},{
      1.980000, 0.305927, -0.941546},{1.697143, 0.305927, -0.941546},{
      1.697143, 0.103483, -0.984577}}],
    Line[{{-1.980000, 0.305927, -0.941546},{-1.697143, 
        0.305927, -0.941546},{-1.697143, 0.495000, -0.857365},{-1.980000, 
        0.495000, -0.857365},{-1.980000, 0.305927, -0.941546}}],
    Line[{{-1.697143, 0.305927, -0.941546},{-1.414286, 
        0.305927, -0.941546},{-1.414286, 0.495000, -0.857365},{-1.697143, 
        0.495000, -0.857365},{-1.697143, 0.305927, -0.941546}}],
    Line[{{-1.414286, 0.305927, -0.941546},{-1.131429, 
        0.305927, -0.941546},{-1.131429, 0.495000, -0.857365},{-1.414286, 
        0.495000, -0.857365},{-1.414286, 0.305927, -0.941546}}],
    Line[{{-1.131429, 0.305927, -0.941546},{-0.848571, 
        0.305927, -0.941546},{-0.848571, 0.495000, -0.857365},{-1.131429, 
        0.495000, -0.857365},{-1.131429, 0.305927, -0.941546}}],
    Line[{{-0.848571, 0.305927, -0.941546},{-0.565714, 
        0.305927, -0.941546},{-0.565714, 0.495000, -0.857365},{-0.848571, 
        0.495000, -0.857365},{-0.848571, 0.305927, -0.941546}}],
    Line[{{-0.565714, 0.305927, -0.941546},{-0.282857, 
        0.305927, -0.941546},{-0.282857, 0.495000, -0.857365},{-0.565714, 
        0.495000, -0.857365},{-0.565714, 0.305927, -0.941546}}],
    Line[{{-0.282857, 0.305927, -0.941546},{-0.000000, 
        0.305927, -0.941546},{-0.000000, 0.495000, -0.857365},{-0.282857, 
        0.495000, -0.857365},{-0.282857, 0.305927, -0.941546}}],
    Line[{{-0.000000, 0.305927, -0.941546},{0.282857, 0.305927, -0.941546},{
      0.282857, 0.495000, -0.857365},{-0.000000, 
        0.495000, -0.857365},{-0.000000, 0.305927, -0.941546}}],
    Line[{{0.282857, 0.305927, -0.941546},{0.565714, 0.305927, -0.941546},{
      0.565714, 0.495000, -0.857365},{0.282857, 0.495000, -0.857365},{
      0.282857, 0.305927, -0.941546}}],
    Line[{{0.565714, 0.305927, -0.941546},{0.848571, 0.305927, -0.941546},{
      0.848571, 0.495000, -0.857365},{0.565714, 0.495000, -0.857365},{
      0.565714, 0.305927, -0.941546}}],
    Line[{{0.848571, 0.305927, -0.941546},{1.131429, 0.305927, -0.941546},{
      1.131429, 0.495000, -0.857365},{0.848571, 0.495000, -0.857365},{
      0.848571, 0.305927, -0.941546}}],
    Line[{{1.131429, 0.305927, -0.941546},{1.414286, 0.305927, -0.941546},{
      1.414286, 0.495000, -0.857365},{1.131429, 0.495000, -0.857365},{
      1.131429, 0.305927, -0.941546}}],
    Line[{{1.414286, 0.305927, -0.941546},{1.697143, 0.305927, -0.941546},{
      1.697143, 0.495000, -0.857365},{1.414286, 0.495000, -0.857365},{
      1.414286, 0.305927, -0.941546}}],
    Line[{{1.697143, 0.305927, -0.941546},{1.980000, 0.305927, -0.941546},{
      1.980000, 0.495000, -0.857365},{1.697143, 0.495000, -0.857365},{
      1.697143, 0.305927, -0.941546}}],
    Line[{{-1.980000, 0.495000, -0.857365},{-1.697143, 
        0.495000, -0.857365},{-1.697143, 0.662439, -0.735713},{-1.980000, 
        0.662439, -0.735713},{-1.980000, 0.495000, -0.857365}}],
    Line[{{-1.697143, 0.495000, -0.857365},{-1.414286, 
        0.495000, -0.857365},{-1.414286, 0.662439, -0.735713},{-1.697143, 
        0.662439, -0.735713},{-1.697143, 0.495000, -0.857365}}],
    Line[{{-1.414286, 0.495000, -0.857365},{-1.131429, 
        0.495000, -0.857365},{-1.131429, 0.662439, -0.735713},{-1.414286, 
        0.662439, -0.735713},{-1.414286, 0.495000, -0.857365}}],
    Line[{{-1.131429, 0.495000, -0.857365},{-0.848571, 
        0.495000, -0.857365},{-0.848571, 0.662439, -0.735713},{-1.131429, 
        0.662439, -0.735713},{-1.131429, 0.495000, -0.857365}}],
    Line[{{-0.848571, 0.495000, -0.857365},{-0.565714, 
        0.495000, -0.857365},{-0.565714, 0.662439, -0.735713},{-0.848571, 
        0.662439, -0.735713},{-0.848571, 0.495000, -0.857365}}],
    Line[{{-0.565714, 0.495000, -0.857365},{-0.282857, 
        0.495000, -0.857365},{-0.282857, 0.662439, -0.735713},{-0.565714, 
        0.662439, -0.735713},{-0.565714, 0.495000, -0.857365}}],
    Line[{{-0.282857, 0.495000, -0.857365},{-0.000000, 
        0.495000, -0.857365},{-0.000000, 0.662439, -0.735713},{-0.282857, 
        0.662439, -0.735713},{-0.282857, 0.495000, -0.857365}}],
    Line[{{-0.000000, 0.495000, -0.857365},{0.282857, 0.495000, -0.857365},{
      0.282857, 0.662439, -0.735713},{-0.000000, 
        0.662439, -0.735713},{-0.000000, 0.495000, -0.857365}}],
    Line[{{0.282857, 0.495000, -0.857365},{0.565714, 0.495000, -0.857365},{
      0.565714, 0.662439, -0.735713},{0.282857, 0.662439, -0.735713},{
      0.282857, 0.495000, -0.857365}}],
    Line[{{0.565714, 0.495000, -0.857365},{0.848571, 0.495000, -0.857365},{
      0.848571, 0.662439, -0.735713},{0.565714, 0.662439, -0.735713},{
      0.565714, 0.495000, -0.857365}}],
    Line[{{0.848571, 0.495000, -0.857365},{1.131429, 0.495000, -0.857365},{
      1.131429, 0.662439, -0.735713},{0.848571, 0.662439, -0.735713},{
      0.848571, 0.495000, -0.857365}}],
    Line[{{1.131429, 0.495000, -0.857365},{1.414286, 0.495000, -0.857365},{
      1.414286, 0.662439, -0.735713},{1.131429, 0.662439, -0.735713},{
      1.131429, 0.495000, -0.857365}}],
    Line[{{1.414286, 0.495000, -0.857365},{1.697143, 0.495000, -0.857365},{
      1.697143, 0.662439, -0.735713},{1.414286, 0.662439, -0.735713},{
      1.414286, 0.495000, -0.857365}}],
    Line[{{1.697143, 0.495000, -0.857365},{1.980000, 0.495000, -0.857365},{
      1.980000, 0.662439, -0.735713},{1.697143, 0.662439, -0.735713},{
      1.697143, 0.495000, -0.857365}}],
    Line[{{-1.980000, 0.662439, -0.735713},{-1.697143, 
        0.662439, -0.735713},{-1.697143, 0.800927, -0.581907},{-1.980000, 
        0.800927, -0.581907},{-1.980000, 0.662439, -0.735713}}],
    Line[{{-1.697143, 0.662439, -0.735713},{-1.414286, 
        0.662439, -0.735713},{-1.414286, 0.800927, -0.581907},{-1.697143, 
        0.800927, -0.581907},{-1.697143, 0.662439, -0.735713}}],
    Line[{{-1.414286, 0.662439, -0.735713},{-1.131429, 
        0.662439, -0.735713},{-1.131429, 0.800927, -0.581907},{-1.414286, 
        0.800927, -0.581907},{-1.414286, 0.662439, -0.735713}}],
    Line[{{-1.131429, 0.662439, -0.735713},{-0.848571, 
        0.662439, -0.735713},{-0.848571, 0.800927, -0.581907},{-1.131429, 
        0.800927, -0.581907},{-1.131429, 0.662439, -0.735713}}],
    Line[{{-0.848571, 0.662439, -0.735713},{-0.565714, 
        0.662439, -0.735713},{-0.565714, 0.800927, -0.581907},{-0.848571, 
        0.800927, -0.581907},{-0.848571, 0.662439, -0.735713}}],
    Line[{{-0.565714, 0.662439, -0.735713},{-0.282857, 
        0.662439, -0.735713},{-0.282857, 0.800927, -0.581907},{-0.565714, 
        0.800927, -0.581907},{-0.565714, 0.662439, -0.735713}}],
    Line[{{-0.282857, 0.662439, -0.735713},{-0.000000, 
        0.662439, -0.735713},{-0.000000, 0.800927, -0.581907},{-0.282857, 
        0.800927, -0.581907},{-0.282857, 0.662439, -0.735713}}],
    Line[{{-0.000000, 0.662439, -0.735713},{0.282857, 0.662439, -0.735713},{
      0.282857, 0.800927, -0.581907},{-0.000000, 
        0.800927, -0.581907},{-0.000000, 0.662439, -0.735713}}],
    Line[{{0.282857, 0.662439, -0.735713},{0.565714, 0.662439, -0.735713},{
      0.565714, 0.800927, -0.581907},{0.282857, 0.800927, -0.581907},{
      0.282857, 0.662439, -0.735713}}],
    Line[{{0.565714, 0.662439, -0.735713},{0.848571, 0.662439, -0.735713},{
      0.848571, 0.800927, -0.581907},{0.565714, 0.800927, -0.581907},{
      0.565714, 0.662439, -0.735713}}],
    Line[{{0.848571, 0.662439, -0.735713},{1.131429, 0.662439, -0.735713},{
      1.131429, 0.800927, -0.581907},{0.848571, 0.800927, -0.581907},{
      0.848571, 0.662439, -0.735713}}],
    Line[{{1.131429, 0.662439, -0.735713},{1.414286, 0.662439, -0.735713},{
      1.414286, 0.800927, -0.581907},{1.131429, 0.800927, -0.581907},{
      1.131429, 0.662439, -0.735713}}],
    Line[{{1.414286, 0.662439, -0.735713},{1.697143, 0.662439, -0.735713},{
      1.697143, 0.800927, -0.581907},{1.414286, 0.800927, -0.581907},{
      1.414286, 0.662439, -0.735713}}],
    Line[{{1.697143, 0.662439, -0.735713},{1.980000, 0.662439, -0.735713},{
      1.980000, 0.800927, -0.581907},{1.697143, 0.800927, -0.581907},{
      1.697143, 0.662439, -0.735713}}],
    Line[{{-1.980000, 0.800927, -0.581907},{-1.697143, 
        0.800927, -0.581907},{-1.697143, 0.904410, -0.402669},{-1.980000, 
        0.904410, -0.402669},{-1.980000, 0.800927, -0.581907}}],
    Line[{{-1.697143, 0.800927, -0.581907},{-1.414286, 
        0.800927, -0.581907},{-1.414286, 0.904410, -0.402669},{-1.697143, 
        0.904410, -0.402669},{-1.697143, 0.800927, -0.581907}}],
    Line[{{-1.414286, 0.800927, -0.581907},{-1.131429, 
        0.800927, -0.581907},{-1.131429, 0.904410, -0.402669},{-1.414286, 
        0.904410, -0.402669},{-1.414286, 0.800927, -0.581907}}],
    Line[{{-1.131429, 0.800927, -0.581907},{-0.848571, 
        0.800927, -0.581907},{-0.848571, 0.904410, -0.402669},{-1.131429, 
        0.904410, -0.402669},{-1.131429, 0.800927, -0.581907}}],
    Line[{{-0.848571, 0.800927, -0.581907},{-0.565714, 
        0.800927, -0.581907},{-0.565714, 0.904410, -0.402669},{-0.848571, 
        0.904410, -0.402669},{-0.848571, 0.800927, -0.581907}}],
    Line[{{-0.565714, 0.800927, -0.581907},{-0.282857, 
        0.800927, -0.581907},{-0.282857, 0.904410, -0.402669},{-0.565714, 
        0.904410, -0.402669},{-0.565714, 0.800927, -0.581907}}],
    Line[{{-0.282857, 0.800927, -0.581907},{-0.000000, 
        0.800927, -0.581907},{-0.000000, 0.904410, -0.402669},{-0.282857, 
        0.904410, -0.402669},{-0.282857, 0.800927, -0.581907}}],
    Line[{{-0.000000, 0.800927, -0.581907},{0.282857, 0.800927, -0.581907},{
      0.282857, 0.904410, -0.402669},{-0.000000, 
        0.904410, -0.402669},{-0.000000, 0.800927, -0.581907}}],
    Line[{{0.282857, 0.800927, -0.581907},{0.565714, 0.800927, -0.581907},{
      0.565714, 0.904410, -0.402669},{0.282857, 0.904410, -0.402669},{
      0.282857, 0.800927, -0.581907}}],
    Line[{{0.565714, 0.800927, -0.581907},{0.848571, 0.800927, -0.581907},{
      0.848571, 0.904410, -0.402669},{0.565714, 0.904410, -0.402669},{
      0.565714, 0.800927, -0.581907}}],
    Line[{{0.848571, 0.800927, -0.581907},{1.131429, 0.800927, -0.581907},{
      1.131429, 0.904410, -0.402669},{0.848571, 0.904410, -0.402669},{
      0.848571, 0.800927, -0.581907}}],
    Line[{{1.131429, 0.800927, -0.581907},{1.414286, 0.800927, -0.581907},{
      1.414286, 0.904410, -0.402669},{1.131429, 0.904410, -0.402669},{
      1.131429, 0.800927, -0.581907}}],
    Line[{{1.414286, 0.800927, -0.581907},{1.697143, 0.800927, -0.581907},{
      1.697143, 0.904410, -0.402669},{1.414286, 0.904410, -0.402669},{
      1.414286, 0.800927, -0.581907}}],
    Line[{{1.697143, 0.800927, -0.581907},{1.980000, 0.800927, -0.581907},{
      1.980000, 0.904410, -0.402669},{1.697143, 0.904410, -0.402669},{
      1.697143, 0.800927, -0.581907}}],
    Line[{{-1.980000, 0.904410, -0.402669},{-1.697143, 
        0.904410, -0.402669},{-1.697143, 0.968366, -0.205833},{-1.980000, 
        0.968366, -0.205833},{-1.980000, 0.904410, -0.402669}}],
    Line[{{-1.697143, 0.904410, -0.402669},{-1.414286, 
        0.904410, -0.402669},{-1.414286, 0.968366, -0.205833},{-1.697143, 
        0.968366, -0.205833},{-1.697143, 0.904410, -0.402669}}],
    Line[{{-1.414286, 0.904410, -0.402669},{-1.131429, 
        0.904410, -0.402669},{-1.131429, 0.968366, -0.205833},{-1.414286, 
        0.968366, -0.205833},{-1.414286, 0.904410, -0.402669}}],
    Line[{{-1.131429, 0.904410, -0.402669},{-0.848571, 
        0.904410, -0.402669},{-0.848571, 0.968366, -0.205833},{-1.131429, 
        0.968366, -0.205833},{-1.131429, 0.904410, -0.402669}}],
    Line[{{-0.848571, 0.904410, -0.402669},{-0.565714, 
        0.904410, -0.402669},{-0.565714, 0.968366, -0.205833},{-0.848571, 
        0.968366, -0.205833},{-0.848571, 0.904410, -0.402669}}],
    Line[{{-0.565714, 0.904410, -0.402669},{-0.282857, 
        0.904410, -0.402669},{-0.282857, 0.968366, -0.205833},{-0.565714, 
        0.968366, -0.205833},{-0.565714, 0.904410, -0.402669}}],
    Line[{{-0.282857, 0.904410, -0.402669},{-0.000000, 
        0.904410, -0.402669},{-0.000000, 0.968366, -0.205833},{-0.282857, 
        0.968366, -0.205833},{-0.282857, 0.904410, -0.402669}}],
    Line[{{-0.000000, 0.904410, -0.402669},{0.282857, 0.904410, -0.402669},{
      0.282857, 0.968366, -0.205833},{-0.000000, 
        0.968366, -0.205833},{-0.000000, 0.904410, -0.402669}}],
    Line[{{0.282857, 0.904410, -0.402669},{0.565714, 0.904410, -0.402669},{
      0.565714, 0.968366, -0.205833},{0.282857, 0.968366, -0.205833},{
      0.282857, 0.904410, -0.402669}}],
    Line[{{0.565714, 0.904410, -0.402669},{0.848571, 0.904410, -0.402669},{
      0.848571, 0.968366, -0.205833},{0.565714, 0.968366, -0.205833},{
      0.565714, 0.904410, -0.402669}}],
    Line[{{0.848571, 0.904410, -0.402669},{1.131429, 0.904410, -0.402669},{
      1.131429, 0.968366, -0.205833},{0.848571, 0.968366, -0.205833},{
      0.848571, 0.904410, -0.402669}}],
    Line[{{1.131429, 0.904410, -0.402669},{1.414286, 0.904410, -0.402669},{
      1.414286, 0.968366, -0.205833},{1.131429, 0.968366, -0.205833},{
      1.131429, 0.904410, -0.402669}}],
    Line[{{1.414286, 0.904410, -0.402669},{1.697143, 0.904410, -0.402669},{
      1.697143, 0.968366, -0.205833},{1.414286, 0.968366, -0.205833},{
      1.414286, 0.904410, -0.402669}}],
    Line[{{1.697143, 0.904410, -0.402669},{1.980000, 0.904410, -0.402669},{
      1.980000, 0.968366, -0.205833},{1.697143, 0.968366, -0.205833},{
      1.697143, 0.904410, -0.402669}}],
    Line[{{-1.980000, 0.968366, -0.205833},{-1.697143, 
        0.968366, -0.205833},{-1.697143, 0.990000, -0.000000},{-1.980000, 
        0.990000, -0.000000},{-1.980000, 0.968366, -0.205833}}],
    Line[{{-1.697143, 0.968366, -0.205833},{-1.414286, 
        0.968366, -0.205833},{-1.414286, 0.990000, -0.000000},{-1.697143, 
        0.990000, -0.000000},{-1.697143, 0.968366, -0.205833}}],
    Line[{{-1.414286, 0.968366, -0.205833},{-1.131429, 
        0.968366, -0.205833},{-1.131429, 0.990000, -0.000000},{-1.414286, 
        0.990000, -0.000000},{-1.414286, 0.968366, -0.205833}}],
    Line[{{-1.131429, 0.968366, -0.205833},{-0.848571, 
        0.968366, -0.205833},{-0.848571, 0.990000, -0.000000},{-1.131429, 
        0.990000, -0.000000},{-1.131429, 0.968366, -0.205833}}],
    Line[{{-0.848571, 0.968366, -0.205833},{-0.565714, 
        0.968366, -0.205833},{-0.565714, 0.990000, -0.000000},{-0.848571, 
        0.990000, -0.000000},{-0.848571, 0.968366, -0.205833}}],
    Line[{{-0.565714, 0.968366, -0.205833},{-0.282857, 
        0.968366, -0.205833},{-0.282857, 0.990000, -0.000000},{-0.565714, 
        0.990000, -0.000000},{-0.565714, 0.968366, -0.205833}}],
    Line[{{-0.282857, 0.968366, -0.205833},{-0.000000, 
        0.968366, -0.205833},{-0.000000, 0.990000, -0.000000},{-0.282857, 
        0.990000, -0.000000},{-0.282857, 0.968366, -0.205833}}],
    Line[{{-0.000000, 0.968366, -0.205833},{0.282857, 0.968366, -0.205833},{
      0.282857, 0.990000, -0.000000},{-0.000000, 
        0.990000, -0.000000},{-0.000000, 0.968366, -0.205833}}],
    Line[{{0.282857, 0.968366, -0.205833},{0.565714, 0.968366, -0.205833},{
      0.565714, 0.990000, -0.000000},{0.282857, 0.990000, -0.000000},{
      0.282857, 0.968366, -0.205833}}],
    Line[{{0.565714, 0.968366, -0.205833},{0.848571, 0.968366, -0.205833},{
      0.848571, 0.990000, -0.000000},{0.565714, 0.990000, -0.000000},{
      0.565714, 0.968366, -0.205833}}],
    Line[{{0.848571, 0.968366, -0.205833},{1.131429, 0.968366, -0.205833},{
      1.131429, 0.990000, -0.000000},{0.848571, 0.990000, -0.000000},{
      0.848571, 0.968366, -0.205833}}],
    Line[{{1.131429, 0.968366, -0.205833},{1.414286, 0.968366, -0.205833},{
      1.414286, 0.990000, -0.000000},{1.131429, 0.990000, -0.000000},{
      1.131429, 0.968366, -0.205833}}],
    Line[{{1.414286, 0.968366, -0.205833},{1.697143, 0.968366, -0.205833},{
      1.697143, 0.990000, -0.000000},{1.414286, 0.990000, -0.000000},{
      1.414286, 0.968366, -0.205833}}],
    Line[{{1.697143, 0.968366, -0.205833},{1.980000, 0.968366, -0.205833},{
      1.980000, 0.990000, -0.000000},{1.697143, 0.990000, -0.000000},{
      1.697143, 0.968366, -0.205833}}],
    Line[{{0.990000, -1.980000, 0.000000},{0.990000, -1.697143, 0.000000},{
      0.968366, -1.697143, 0.205833},{0.968366, -1.980000, 0.205833},{
      0.990000, -1.980000, 0.000000}}],
    Line[{{0.990000, -1.697143, 0.000000},{0.990000, -1.414286, 0.000000},{
      0.968366, -1.414286, 0.205833},{0.968366, -1.697143, 0.205833},{
      0.990000, -1.697143, 0.000000}}],
    Line[{{0.990000, -1.414286, 0.000000},{0.990000, -1.131429, 0.000000},{
      0.968366, -1.131429, 0.205833},{0.968366, -1.414286, 0.205833},{
      0.990000, -1.414286, 0.000000}}],
    Line[{{0.990000, -1.131429, 0.000000},{0.990000, -0.848571, 0.000000},{
      0.968366, -0.848571, 0.205833},{0.968366, -1.131429, 0.205833},{
      0.990000, -1.131429, 0.000000}}],
    Line[{{0.990000, -0.848571, 0.000000},{0.990000, -0.565714, 0.000000},{
      0.968366, -0.565714, 0.205833},{0.968366, -0.848571, 0.205833},{
      0.990000, -0.848571, 0.000000}}],
    Line[{{0.990000, -0.565714, 0.000000},{0.990000, -0.282857, 0.000000},{
      0.968366, -0.282857, 0.205833},{0.968366, -0.565714, 0.205833},{
      0.990000, -0.565714, 0.000000}}],
    Line[{{0.990000, -0.282857, 0.000000},{0.990000, -0.000000, 0.000000},{
      0.968366, -0.000000, 0.205833},{0.968366, -0.282857, 0.205833},{
      0.990000, -0.282857, 0.000000}}],
    Line[{{0.990000, -0.000000, 0.000000},{0.990000, 0.282857, 0.000000},{
      0.968366, 0.282857, 0.205833},{0.968366, -0.000000, 0.205833},{
      0.990000, -0.000000, 0.000000}}],
    Line[{{0.990000, 0.282857, 0.000000},{0.990000, 0.565714, 0.000000},{
      0.968366, 0.565714, 0.205833},{0.968366, 0.282857, 0.205833},{
      0.990000, 0.282857, 0.000000}}],
    Line[{{0.990000, 0.565714, 0.000000},{0.990000, 0.848571, 0.000000},{
      0.968366, 0.848571, 0.205833},{0.968366, 0.565714, 0.205833},{
      0.990000, 0.565714, 0.000000}}],
    Line[{{0.990000, 0.848571, 0.000000},{0.990000, 1.131429, 0.000000},{
      0.968366, 1.131429, 0.205833},{0.968366, 0.848571, 0.205833},{
      0.990000, 0.848571, 0.000000}}],
    Line[{{0.990000, 1.131429, 0.000000},{0.990000, 1.414286, 0.000000},{
      0.968366, 1.414286, 0.205833},{0.968366, 1.131429, 0.205833},{
      0.990000, 1.131429, 0.000000}}],
    Line[{{0.990000, 1.414286, 0.000000},{0.990000, 1.697143, 0.000000},{
      0.968366, 1.697143, 0.205833},{0.968366, 1.414286, 0.205833},{
      0.990000, 1.414286, 0.000000}}],
    Line[{{0.990000, 1.697143, 0.000000},{0.990000, 1.980000, 0.000000},{
      0.968366, 1.980000, 0.205833},{0.968366, 1.697143, 0.205833},{
      0.990000, 1.697143, 0.000000}}],
    Line[{{0.968366, -1.980000, 0.205833},{0.968366, -1.697143, 0.205833},{
      0.904410, -1.697143, 0.402669},{0.904410, -1.980000, 0.402669},{
      0.968366, -1.980000, 0.205833}}],
    Line[{{0.968366, -1.697143, 0.205833},{0.968366, -1.414286, 0.205833},{
      0.904410, -1.414286, 0.402669},{0.904410, -1.697143, 0.402669},{
      0.968366, -1.697143, 0.205833}}],
    Line[{{0.968366, -1.414286, 0.205833},{0.968366, -1.131429, 0.205833},{
      0.904410, -1.131429, 0.402669},{0.904410, -1.414286, 0.402669},{
      0.968366, -1.414286, 0.205833}}],
    Line[{{0.968366, -1.131429, 0.205833},{0.968366, -0.848571, 0.205833},{
      0.904410, -0.848571, 0.402669},{0.904410, -1.131429, 0.402669},{
      0.968366, -1.131429, 0.205833}}],
    Line[{{0.968366, -0.848571, 0.205833},{0.968366, -0.565714, 0.205833},{
      0.904410, -0.565714, 0.402669},{0.904410, -0.848571, 0.402669},{
      0.968366, -0.848571, 0.205833}}],
    Line[{{0.968366, -0.565714, 0.205833},{0.968366, -0.282857, 0.205833},{
      0.904410, -0.282857, 0.402669},{0.904410, -0.565714, 0.402669},{
      0.968366, -0.565714, 0.205833}}],
    Line[{{0.968366, -0.282857, 0.205833},{0.968366, -0.000000, 0.205833},{
      0.904410, -0.000000, 0.402669},{0.904410, -0.282857, 0.402669},{
      0.968366, -0.282857, 0.205833}}],
    Line[{{0.968366, -0.000000, 0.205833},{0.968366, 0.282857, 0.205833},{
      0.904410, 0.282857, 0.402669},{0.904410, -0.000000, 0.402669},{
      0.968366, -0.000000, 0.205833}}],
    Line[{{0.968366, 0.282857, 0.205833},{0.968366, 0.565714, 0.205833},{
      0.904410, 0.565714, 0.402669},{0.904410, 0.282857, 0.402669},{
      0.968366, 0.282857, 0.205833}}],
    Line[{{0.968366, 0.565714, 0.205833},{0.968366, 0.848571, 0.205833},{
      0.904410, 0.848571, 0.402669},{0.904410, 0.565714, 0.402669},{
      0.968366, 0.565714, 0.205833}}],
    Line[{{0.968366, 0.848571, 0.205833},{0.968366, 1.131429, 0.205833},{
      0.904410, 1.131429, 0.402669},{0.904410, 0.848571, 0.402669},{
      0.968366, 0.848571, 0.205833}}],
    Line[{{0.968366, 1.131429, 0.205833},{0.968366, 1.414286, 0.205833},{
      0.904410, 1.414286, 0.402669},{0.904410, 1.131429, 0.402669},{
      0.968366, 1.131429, 0.205833}}],
    Line[{{0.968366, 1.414286, 0.205833},{0.968366, 1.697143, 0.205833},{
      0.904410, 1.697143, 0.402669},{0.904410, 1.414286, 0.402669},{
      0.968366, 1.414286, 0.205833}}],
    Line[{{0.968366, 1.697143, 0.205833},{0.968366, 1.980000, 0.205833},{
      0.904410, 1.980000, 0.402669},{0.904410, 1.697143, 0.402669},{
      0.968366, 1.697143, 0.205833}}],
    Line[{{0.904410, -1.980000, 0.402669},{0.904410, -1.697143, 0.402669},{
      0.800927, -1.697143, 0.581907},{0.800927, -1.980000, 0.581907},{
      0.904410, -1.980000, 0.402669}}],
    Line[{{0.904410, -1.697143, 0.402669},{0.904410, -1.414286, 0.402669},{
      0.800927, -1.414286, 0.581907},{0.800927, -1.697143, 0.581907},{
      0.904410, -1.697143, 0.402669}}],
    Line[{{0.904410, -1.414286, 0.402669},{0.904410, -1.131429, 0.402669},{
      0.800927, -1.131429, 0.581907},{0.800927, -1.414286, 0.581907},{
      0.904410, -1.414286, 0.402669}}],
    Line[{{0.904410, -1.131429, 0.402669},{0.904410, -0.848571, 0.402669},{
      0.800927, -0.848571, 0.581907},{0.800927, -1.131429, 0.581907},{
      0.904410, -1.131429, 0.402669}}],
    Line[{{0.904410, -0.848571, 0.402669},{0.904410, -0.565714, 0.402669},{
      0.800927, -0.565714, 0.581907},{0.800927, -0.848571, 0.581907},{
      0.904410, -0.848571, 0.402669}}],
    Line[{{0.904410, -0.565714, 0.402669},{0.904410, -0.282857, 0.402669},{
      0.800927, -0.282857, 0.581907},{0.800927, -0.565714, 0.581907},{
      0.904410, -0.565714, 0.402669}}],
    Line[{{0.904410, -0.282857, 0.402669},{0.904410, -0.000000, 0.402669},{
      0.800927, -0.000000, 0.581907},{0.800927, -0.282857, 0.581907},{
      0.904410, -0.282857, 0.402669}}],
    Line[{{0.904410, -0.000000, 0.402669},{0.904410, 0.282857, 0.402669},{
      0.800927, 0.282857, 0.581907},{0.800927, -0.000000, 0.581907},{
      0.904410, -0.000000, 0.402669}}],
    Line[{{0.904410, 0.282857, 0.402669},{0.904410, 0.565714, 0.402669},{
      0.800927, 0.565714, 0.581907},{0.800927, 0.282857, 0.581907},{
      0.904410, 0.282857, 0.402669}}],
    Line[{{0.904410, 0.565714, 0.402669},{0.904410, 0.848571, 0.402669},{
      0.800927, 0.848571, 0.581907},{0.800927, 0.565714, 0.581907},{
      0.904410, 0.565714, 0.402669}}],
    Line[{{0.904410, 0.848571, 0.402669},{0.904410, 1.131429, 0.402669},{
      0.800927, 1.131429, 0.581907},{0.800927, 0.848571, 0.581907},{
      0.904410, 0.848571, 0.402669}}],
    Line[{{0.904410, 1.131429, 0.402669},{0.904410, 1.414286, 0.402669},{
      0.800927, 1.414286, 0.581907},{0.800927, 1.131429, 0.581907},{
      0.904410, 1.131429, 0.402669}}],
    Line[{{0.904410, 1.414286, 0.402669},{0.904410, 1.697143, 0.402669},{
      0.800927, 1.697143, 0.581907},{0.800927, 1.414286, 0.581907},{
      0.904410, 1.414286, 0.402669}}],
    Line[{{0.904410, 1.697143, 0.402669},{0.904410, 1.980000, 0.402669},{
      0.800927, 1.980000, 0.581907},{0.800927, 1.697143, 0.581907},{
      0.904410, 1.697143, 0.402669}}],
    Line[{{0.800927, -1.980000, 0.581907},{0.800927, -1.697143, 0.581907},{
      0.662439, -1.697143, 0.735713},{0.662439, -1.980000, 0.735713},{
      0.800927, -1.980000, 0.581907}}],
    Line[{{0.800927, -1.697143, 0.581907},{0.800927, -1.414286, 0.581907},{
      0.662439, -1.414286, 0.735713},{0.662439, -1.697143, 0.735713},{
      0.800927, -1.697143, 0.581907}}],
    Line[{{0.800927, -1.414286, 0.581907},{0.800927, -1.131429, 0.581907},{
      0.662439, -1.131429, 0.735713},{0.662439, -1.414286, 0.735713},{
      0.800927, -1.414286, 0.581907}}],
    Line[{{0.800927, -1.131429, 0.581907},{0.800927, -0.848571, 0.581907},{
      0.662439, -0.848571, 0.735713},{0.662439, -1.131429, 0.735713},{
      0.800927, -1.131429, 0.581907}}],
    Line[{{0.800927, -0.848571, 0.581907},{0.800927, -0.565714, 0.581907},{
      0.662439, -0.565714, 0.735713},{0.662439, -0.848571, 0.735713},{
      0.800927, -0.848571, 0.581907}}],
    Line[{{0.800927, -0.565714, 0.581907},{0.800927, -0.282857, 0.581907},{
      0.662439, -0.282857, 0.735713},{0.662439, -0.565714, 0.735713},{
      0.800927, -0.565714, 0.581907}}],
    Line[{{0.800927, -0.282857, 0.581907},{0.800927, -0.000000, 0.581907},{
      0.662439, -0.000000, 0.735713},{0.662439, -0.282857, 0.735713},{
      0.800927, -0.282857, 0.581907}}],
    Line[{{0.800927, -0.000000, 0.581907},{0.800927, 0.282857, 0.581907},{
      0.662439, 0.282857, 0.735713},{0.662439, -0.000000, 0.735713},{
      0.800927, -0.000000, 0.581907}}],
    Line[{{0.800927, 0.282857, 0.581907},{0.800927, 0.565714, 0.581907},{
      0.662439, 0.565714, 0.735713},{0.662439, 0.282857, 0.735713},{
      0.800927, 0.282857, 0.581907}}],
    Line[{{0.800927, 0.565714, 0.581907},{0.800927, 0.848571, 0.581907},{
      0.662439, 0.848571, 0.735713},{0.662439, 0.565714, 0.735713},{
      0.800927, 0.565714, 0.581907}}],
    Line[{{0.800927, 0.848571, 0.581907},{0.800927, 1.131429, 0.581907},{
      0.662439, 1.131429, 0.735713},{0.662439, 0.848571, 0.735713},{
      0.800927, 0.848571, 0.581907}}],
    Line[{{0.800927, 1.131429, 0.581907},{0.800927, 1.414286, 0.581907},{
      0.662439, 1.414286, 0.735713},{0.662439, 1.131429, 0.735713},{
      0.800927, 1.131429, 0.581907}}],
    Line[{{0.800927, 1.414286, 0.581907},{0.800927, 1.697143, 0.581907},{
      0.662439, 1.697143, 0.735713},{0.662439, 1.414286, 0.735713},{
      0.800927, 1.414286, 0.581907}}],
    Line[{{0.800927, 1.697143, 0.581907},{0.800927, 1.980000, 0.581907},{
      0.662439, 1.980000, 0.735713},{0.662439, 1.697143, 0.735713},{
      0.800927, 1.697143, 0.581907}}],
    Line[{{0.662439, -1.980000, 0.735713},{0.662439, -1.697143, 0.735713},{
      0.495000, -1.697143, 0.857365},{0.495000, -1.980000, 0.857365},{
      0.662439, -1.980000, 0.735713}}],
    Line[{{0.662439, -1.697143, 0.735713},{0.662439, -1.414286, 0.735713},{
      0.495000, -1.414286, 0.857365},{0.495000, -1.697143, 0.857365},{
      0.662439, -1.697143, 0.735713}}],
    Line[{{0.662439, -1.414286, 0.735713},{0.662439, -1.131429, 0.735713},{
      0.495000, -1.131429, 0.857365},{0.495000, -1.414286, 0.857365},{
      0.662439, -1.414286, 0.735713}}],
    Line[{{0.662439, -1.131429, 0.735713},{0.662439, -0.848571, 0.735713},{
      0.495000, -0.848571, 0.857365},{0.495000, -1.131429, 0.857365},{
      0.662439, -1.131429, 0.735713}}],
    Line[{{0.662439, -0.848571, 0.735713},{0.662439, -0.565714, 0.735713},{
      0.495000, -0.565714, 0.857365},{0.495000, -0.848571, 0.857365},{
      0.662439, -0.848571, 0.735713}}],
    Line[{{0.662439, -0.565714, 0.735713},{0.662439, -0.282857, 0.735713},{
      0.495000, -0.282857, 0.857365},{0.495000, -0.565714, 0.857365},{
      0.662439, -0.565714, 0.735713}}],
    Line[{{0.662439, -0.282857, 0.735713},{0.662439, -0.000000, 0.735713},{
      0.495000, -0.000000, 0.857365},{0.495000, -0.282857, 0.857365},{
      0.662439, -0.282857, 0.735713}}],
    Line[{{0.662439, -0.000000, 0.735713},{0.662439, 0.282857, 0.735713},{
      0.495000, 0.282857, 0.857365},{0.495000, -0.000000, 0.857365},{
      0.662439, -0.000000, 0.735713}}],
    Line[{{0.662439, 0.282857, 0.735713},{0.662439, 0.565714, 0.735713},{
      0.495000, 0.565714, 0.857365},{0.495000, 0.282857, 0.857365},{
      0.662439, 0.282857, 0.735713}}],
    Line[{{0.662439, 0.565714, 0.735713},{0.662439, 0.848571, 0.735713},{
      0.495000, 0.848571, 0.857365},{0.495000, 0.565714, 0.857365},{
      0.662439, 0.565714, 0.735713}}],
    Line[{{0.662439, 0.848571, 0.735713},{0.662439, 1.131429, 0.735713},{
      0.495000, 1.131429, 0.857365},{0.495000, 0.848571, 0.857365},{
      0.662439, 0.848571, 0.735713}}],
    Line[{{0.662439, 1.131429, 0.735713},{0.662439, 1.414286, 0.735713},{
      0.495000, 1.414286, 0.857365},{0.495000, 1.131429, 0.857365},{
      0.662439, 1.131429, 0.735713}}],
    Line[{{0.662439, 1.414286, 0.735713},{0.662439, 1.697143, 0.735713},{
      0.495000, 1.697143, 0.857365},{0.495000, 1.414286, 0.857365},{
      0.662439, 1.414286, 0.735713}}],
    Line[{{0.662439, 1.697143, 0.735713},{0.662439, 1.980000, 0.735713},{
      0.495000, 1.980000, 0.857365},{0.495000, 1.697143, 0.857365},{
      0.662439, 1.697143, 0.735713}}],
    Line[{{0.495000, -1.980000, 0.857365},{0.495000, -1.697143, 0.857365},{
      0.305927, -1.697143, 0.941546},{0.305927, -1.980000, 0.941546},{
      0.495000, -1.980000, 0.857365}}],
    Line[{{0.495000, -1.697143, 0.857365},{0.495000, -1.414286, 0.857365},{
      0.305927, -1.414286, 0.941546},{0.305927, -1.697143, 0.941546},{
      0.495000, -1.697143, 0.857365}}],
    Line[{{0.495000, -1.414286, 0.857365},{0.495000, -1.131429, 0.857365},{
      0.305927, -1.131429, 0.941546},{0.305927, -1.414286, 0.941546},{
      0.495000, -1.414286, 0.857365}}],
    Line[{{0.495000, -1.131429, 0.857365},{0.495000, -0.848571, 0.857365},{
      0.305927, -0.848571, 0.941546},{0.305927, -1.131429, 0.941546},{
      0.495000, -1.131429, 0.857365}}],
    Line[{{0.495000, -0.848571, 0.857365},{0.495000, -0.565714, 0.857365},{
      0.305927, -0.565714, 0.941546},{0.305927, -0.848571, 0.941546},{
      0.495000, -0.848571, 0.857365}}],
    Line[{{0.495000, -0.565714, 0.857365},{0.495000, -0.282857, 0.857365},{
      0.305927, -0.282857, 0.941546},{0.305927, -0.565714, 0.941546},{
      0.495000, -0.565714, 0.857365}}],
    Line[{{0.495000, -0.282857, 0.857365},{0.495000, -0.000000, 0.857365},{
      0.305927, -0.000000, 0.941546},{0.305927, -0.282857, 0.941546},{
      0.495000, -0.282857, 0.857365}}],
    Line[{{0.495000, -0.000000, 0.857365},{0.495000, 0.282857, 0.857365},{
      0.305927, 0.282857, 0.941546},{0.305927, -0.000000, 0.941546},{
      0.495000, -0.000000, 0.857365}}],
    Line[{{0.495000, 0.282857, 0.857365},{0.495000, 0.565714, 0.857365},{
      0.305927, 0.565714, 0.941546},{0.305927, 0.282857, 0.941546},{
      0.495000, 0.282857, 0.857365}}],
    Line[{{0.495000, 0.565714, 0.857365},{0.495000, 0.848571, 0.857365},{
      0.305927, 0.848571, 0.941546},{0.305927, 0.565714, 0.941546},{
      0.495000, 0.565714, 0.857365}}],
    Line[{{0.495000, 0.848571, 0.857365},{0.495000, 1.131429, 0.857365},{
      0.305927, 1.131429, 0.941546},{0.305927, 0.848571, 0.941546},{
      0.495000, 0.848571, 0.857365}}],
    Line[{{0.495000, 1.131429, 0.857365},{0.495000, 1.414286, 0.857365},{
      0.305927, 1.414286, 0.941546},{0.305927, 1.131429, 0.941546},{
      0.495000, 1.131429, 0.857365}}],
    Line[{{0.495000, 1.414286, 0.857365},{0.495000, 1.697143, 0.857365},{
      0.305927, 1.697143, 0.941546},{0.305927, 1.414286, 0.941546},{
      0.495000, 1.414286, 0.857365}}],
    Line[{{0.495000, 1.697143, 0.857365},{0.495000, 1.980000, 0.857365},{
      0.305927, 1.980000, 0.941546},{0.305927, 1.697143, 0.941546},{
      0.495000, 1.697143, 0.857365}}],
    Line[{{0.305927, -1.980000, 0.941546},{0.305927, -1.697143, 0.941546},{
      0.103483, -1.697143, 0.984577},{0.103483, -1.980000, 0.984577},{
      0.305927, -1.980000, 0.941546}}],
    Line[{{0.305927, -1.697143, 0.941546},{0.305927, -1.414286, 0.941546},{
      0.103483, -1.414286, 0.984577},{0.103483, -1.697143, 0.984577},{
      0.305927, -1.697143, 0.941546}}],
    Line[{{0.305927, -1.414286, 0.941546},{0.305927, -1.131429, 0.941546},{
      0.103483, -1.131429, 0.984577},{0.103483, -1.414286, 0.984577},{
      0.305927, -1.414286, 0.941546}}],
    Line[{{0.305927, -1.131429, 0.941546},{0.305927, -0.848571, 0.941546},{
      0.103483, -0.848571, 0.984577},{0.103483, -1.131429, 0.984577},{
      0.305927, -1.131429, 0.941546}}],
    Line[{{0.305927, -0.848571, 0.941546},{0.305927, -0.565714, 0.941546},{
      0.103483, -0.565714, 0.984577},{0.103483, -0.848571, 0.984577},{
      0.305927, -0.848571, 0.941546}}],
    Line[{{0.305927, -0.565714, 0.941546},{0.305927, -0.282857, 0.941546},{
      0.103483, -0.282857, 0.984577},{0.103483, -0.565714, 0.984577},{
      0.305927, -0.565714, 0.941546}}],
    Line[{{0.305927, -0.282857, 0.941546},{0.305927, -0.000000, 0.941546},{
      0.103483, -0.000000, 0.984577},{0.103483, -0.282857, 0.984577},{
      0.305927, -0.282857, 0.941546}}],
    Line[{{0.305927, -0.000000, 0.941546},{0.305927, 0.282857, 0.941546},{
      0.103483, 0.282857, 0.984577},{0.103483, -0.000000, 0.984577},{
      0.305927, -0.000000, 0.941546}}],
    Line[{{0.305927, 0.282857, 0.941546},{0.305927, 0.565714, 0.941546},{
      0.103483, 0.565714, 0.984577},{0.103483, 0.282857, 0.984577},{
      0.305927, 0.282857, 0.941546}}],
    Line[{{0.305927, 0.565714, 0.941546},{0.305927, 0.848571, 0.941546},{
      0.103483, 0.848571, 0.984577},{0.103483, 0.565714, 0.984577},{
      0.305927, 0.565714, 0.941546}}],
    Line[{{0.305927, 0.848571, 0.941546},{0.305927, 1.131429, 0.941546},{
      0.103483, 1.131429, 0.984577},{0.103483, 0.848571, 0.984577},{
      0.305927, 0.848571, 0.941546}}],
    Line[{{0.305927, 1.131429, 0.941546},{0.305927, 1.414286, 0.941546},{
      0.103483, 1.414286, 0.984577},{0.103483, 1.131429, 0.984577},{
      0.305927, 1.131429, 0.941546}}],
    Line[{{0.305927, 1.414286, 0.941546},{0.305927, 1.697143, 0.941546},{
      0.103483, 1.697143, 0.984577},{0.103483, 1.414286, 0.984577},{
      0.305927, 1.414286, 0.941546}}],
    Line[{{0.305927, 1.697143, 0.941546},{0.305927, 1.980000, 0.941546},{
      0.103483, 1.980000, 0.984577},{0.103483, 1.697143, 0.984577},{
      0.305927, 1.697143, 0.941546}}],
    Line[{{0.103483, -1.980000, 0.984577},{
      0.103483, -1.697143, 0.984577},{-0.103483, -1.697143, 
        0.984577},{-0.103483, -1.980000, 0.984577},{
      0.103483, -1.980000, 0.984577}}],
    Line[{{0.103483, -1.697143, 0.984577},{
      0.103483, -1.414286, 0.984577},{-0.103483, -1.414286, 
        0.984577},{-0.103483, -1.697143, 0.984577},{
      0.103483, -1.697143, 0.984577}}],
    Line[{{0.103483, -1.414286, 0.984577},{
      0.103483, -1.131429, 0.984577},{-0.103483, -1.131429, 
        0.984577},{-0.103483, -1.414286, 0.984577},{
      0.103483, -1.414286, 0.984577}}],
    Line[{{0.103483, -1.131429, 0.984577},{
      0.103483, -0.848571, 0.984577},{-0.103483, -0.848571, 
        0.984577},{-0.103483, -1.131429, 0.984577},{
      0.103483, -1.131429, 0.984577}}],
    Line[{{0.103483, -0.848571, 0.984577},{
      0.103483, -0.565714, 0.984577},{-0.103483, -0.565714, 
        0.984577},{-0.103483, -0.848571, 0.984577},{
      0.103483, -0.848571, 0.984577}}],
    Line[{{0.103483, -0.565714, 0.984577},{
      0.103483, -0.282857, 0.984577},{-0.103483, -0.282857, 
        0.984577},{-0.103483, -0.565714, 0.984577},{
      0.103483, -0.565714, 0.984577}}],
    Line[{{0.103483, -0.282857, 0.984577},{
      0.103483, -0.000000, 0.984577},{-0.103483, -0.000000, 
        0.984577},{-0.103483, -0.282857, 0.984577},{
      0.103483, -0.282857, 0.984577}}],
    Line[{{0.103483, -0.000000, 0.984577},{
      0.103483, 0.282857, 0.984577},{-0.103483, 0.282857, 
        0.984577},{-0.103483, -0.000000, 0.984577},{
      0.103483, -0.000000, 0.984577}}],
    Line[{{0.103483, 0.282857, 0.984577},{
      0.103483, 0.565714, 0.984577},{-0.103483, 0.565714, 
        0.984577},{-0.103483, 0.282857, 0.984577},{
      0.103483, 0.282857, 0.984577}}],
    Line[{{0.103483, 0.565714, 0.984577},{
      0.103483, 0.848571, 0.984577},{-0.103483, 0.848571, 
        0.984577},{-0.103483, 0.565714, 0.984577},{
      0.103483, 0.565714, 0.984577}}],
    Line[{{0.103483, 0.848571, 0.984577},{
      0.103483, 1.131429, 0.984577},{-0.103483, 1.131429, 
        0.984577},{-0.103483, 0.848571, 0.984577},{
      0.103483, 0.848571, 0.984577}}],
    Line[{{0.103483, 1.131429, 0.984577},{
      0.103483, 1.414286, 0.984577},{-0.103483, 1.414286, 
        0.984577},{-0.103483, 1.131429, 0.984577},{
      0.103483, 1.131429, 0.984577}}],
    Line[{{0.103483, 1.414286, 0.984577},{
      0.103483, 1.697143, 0.984577},{-0.103483, 1.697143, 
        0.984577},{-0.103483, 1.414286, 0.984577},{
      0.103483, 1.414286, 0.984577}}],
    Line[{{0.103483, 1.697143, 0.984577},{
      0.103483, 1.980000, 0.984577},{-0.103483, 1.980000, 
        0.984577},{-0.103483, 1.697143, 0.984577},{
      0.103483, 1.697143, 0.984577}}],
    Line[{{-0.103483, -1.980000, 0.984577},{-0.103483, -1.697143, 
        0.984577},{-0.305927, -1.697143, 0.941546},{-0.305927, -1.980000, 
        0.941546},{-0.103483, -1.980000, 0.984577}}],
    Line[{{-0.103483, -1.697143, 0.984577},{-0.103483, -1.414286, 
        0.984577},{-0.305927, -1.414286, 0.941546},{-0.305927, -1.697143, 
        0.941546},{-0.103483, -1.697143, 0.984577}}],
    Line[{{-0.103483, -1.414286, 0.984577},{-0.103483, -1.131429, 
        0.984577},{-0.305927, -1.131429, 0.941546},{-0.305927, -1.414286, 
        0.941546},{-0.103483, -1.414286, 0.984577}}],
    Line[{{-0.103483, -1.131429, 0.984577},{-0.103483, -0.848571, 
        0.984577},{-0.305927, -0.848571, 0.941546},{-0.305927, -1.131429, 
        0.941546},{-0.103483, -1.131429, 0.984577}}],
    Line[{{-0.103483, -0.848571, 0.984577},{-0.103483, -0.565714, 
        0.984577},{-0.305927, -0.565714, 0.941546},{-0.305927, -0.848571, 
        0.941546},{-0.103483, -0.848571, 0.984577}}],
    Line[{{-0.103483, -0.565714, 0.984577},{-0.103483, -0.282857, 
        0.984577},{-0.305927, -0.282857, 0.941546},{-0.305927, -0.565714, 
        0.941546},{-0.103483, -0.565714, 0.984577}}],
    Line[{{-0.103483, -0.282857, 0.984577},{-0.103483, -0.000000, 
        0.984577},{-0.305927, -0.000000, 0.941546},{-0.305927, -0.282857, 
        0.941546},{-0.103483, -0.282857, 0.984577}}],
    Line[{{-0.103483, -0.000000, 0.984577},{-0.103483, 0.282857, 
        0.984577},{-0.305927, 0.282857, 0.941546},{-0.305927, -0.000000, 
        0.941546},{-0.103483, -0.000000, 0.984577}}],
    Line[{{-0.103483, 0.282857, 0.984577},{-0.103483, 0.565714, 
        0.984577},{-0.305927, 0.565714, 0.941546},{-0.305927, 0.282857, 
        0.941546},{-0.103483, 0.282857, 0.984577}}],
    Line[{{-0.103483, 0.565714, 0.984577},{-0.103483, 0.848571, 
        0.984577},{-0.305927, 0.848571, 0.941546},{-0.305927, 0.565714, 
        0.941546},{-0.103483, 0.565714, 0.984577}}],
    Line[{{-0.103483, 0.848571, 0.984577},{-0.103483, 1.131429, 
        0.984577},{-0.305927, 1.131429, 0.941546},{-0.305927, 0.848571, 
        0.941546},{-0.103483, 0.848571, 0.984577}}],
    Line[{{-0.103483, 1.131429, 0.984577},{-0.103483, 1.414286, 
        0.984577},{-0.305927, 1.414286, 0.941546},{-0.305927, 1.131429, 
        0.941546},{-0.103483, 1.131429, 0.984577}}],
    Line[{{-0.103483, 1.414286, 0.984577},{-0.103483, 1.697143, 
        0.984577},{-0.305927, 1.697143, 0.941546},{-0.305927, 1.414286, 
        0.941546},{-0.103483, 1.414286, 0.984577}}],
    Line[{{-0.103483, 1.697143, 0.984577},{-0.103483, 1.980000, 
        0.984577},{-0.305927, 1.980000, 0.941546},{-0.305927, 1.697143, 
        0.941546},{-0.103483, 1.697143, 0.984577}}],
    Line[{{-0.305927, -1.980000, 0.941546},{-0.305927, -1.697143, 
        0.941546},{-0.495000, -1.697143, 0.857365},{-0.495000, -1.980000, 
        0.857365},{-0.305927, -1.980000, 0.941546}}],
    Line[{{-0.305927, -1.697143, 0.941546},{-0.305927, -1.414286, 
        0.941546},{-0.495000, -1.414286, 0.857365},{-0.495000, -1.697143, 
        0.857365},{-0.305927, -1.697143, 0.941546}}],
    Line[{{-0.305927, -1.414286, 0.941546},{-0.305927, -1.131429, 
        0.941546},{-0.495000, -1.131429, 0.857365},{-0.495000, -1.414286, 
        0.857365},{-0.305927, -1.414286, 0.941546}}],
    Line[{{-0.305927, -1.131429, 0.941546},{-0.305927, -0.848571, 
        0.941546},{-0.495000, -0.848571, 0.857365},{-0.495000, -1.131429, 
        0.857365},{-0.305927, -1.131429, 0.941546}}],
    Line[{{-0.305927, -0.848571, 0.941546},{-0.305927, -0.565714, 
        0.941546},{-0.495000, -0.565714, 0.857365},{-0.495000, -0.848571, 
        0.857365},{-0.305927, -0.848571, 0.941546}}],
    Line[{{-0.305927, -0.565714, 0.941546},{-0.305927, -0.282857, 
        0.941546},{-0.495000, -0.282857, 0.857365},{-0.495000, -0.565714, 
        0.857365},{-0.305927, -0.565714, 0.941546}}],
    Line[{{-0.305927, -0.282857, 0.941546},{-0.305927, -0.000000, 
        0.941546},{-0.495000, -0.000000, 0.857365},{-0.495000, -0.282857, 
        0.857365},{-0.305927, -0.282857, 0.941546}}],
    Line[{{-0.305927, -0.000000, 0.941546},{-0.305927, 0.282857, 
        0.941546},{-0.495000, 0.282857, 0.857365},{-0.495000, -0.000000, 
        0.857365},{-0.305927, -0.000000, 0.941546}}],
    Line[{{-0.305927, 0.282857, 0.941546},{-0.305927, 0.565714, 
        0.941546},{-0.495000, 0.565714, 0.857365},{-0.495000, 0.282857, 
        0.857365},{-0.305927, 0.282857, 0.941546}}],
    Line[{{-0.305927, 0.565714, 0.941546},{-0.305927, 0.848571, 
        0.941546},{-0.495000, 0.848571, 0.857365},{-0.495000, 0.565714, 
        0.857365},{-0.305927, 0.565714, 0.941546}}],
    Line[{{-0.305927, 0.848571, 0.941546},{-0.305927, 1.131429, 
        0.941546},{-0.495000, 1.131429, 0.857365},{-0.495000, 0.848571, 
        0.857365},{-0.305927, 0.848571, 0.941546}}],
    Line[{{-0.305927, 1.131429, 0.941546},{-0.305927, 1.414286, 
        0.941546},{-0.495000, 1.414286, 0.857365},{-0.495000, 1.131429, 
        0.857365},{-0.305927, 1.131429, 0.941546}}],
    Line[{{-0.305927, 1.414286, 0.941546},{-0.305927, 1.697143, 
        0.941546},{-0.495000, 1.697143, 0.857365},{-0.495000, 1.414286, 
        0.857365},{-0.305927, 1.414286, 0.941546}}],
    Line[{{-0.305927, 1.697143, 0.941546},{-0.305927, 1.980000, 
        0.941546},{-0.495000, 1.980000, 0.857365},{-0.495000, 1.697143, 
        0.857365},{-0.305927, 1.697143, 0.941546}}],
    Line[{{-0.495000, -1.980000, 0.857365},{-0.495000, -1.697143, 
        0.857365},{-0.662439, -1.697143, 0.735713},{-0.662439, -1.980000, 
        0.735713},{-0.495000, -1.980000, 0.857365}}],
    Line[{{-0.495000, -1.697143, 0.857365},{-0.495000, -1.414286, 
        0.857365},{-0.662439, -1.414286, 0.735713},{-0.662439, -1.697143, 
        0.735713},{-0.495000, -1.697143, 0.857365}}],
    Line[{{-0.495000, -1.414286, 0.857365},{-0.495000, -1.131429, 
        0.857365},{-0.662439, -1.131429, 0.735713},{-0.662439, -1.414286, 
        0.735713},{-0.495000, -1.414286, 0.857365}}],
    Line[{{-0.495000, -1.131429, 0.857365},{-0.495000, -0.848571, 
        0.857365},{-0.662439, -0.848571, 0.735713},{-0.662439, -1.131429, 
        0.735713},{-0.495000, -1.131429, 0.857365}}],
    Line[{{-0.495000, -0.848571, 0.857365},{-0.495000, -0.565714, 
        0.857365},{-0.662439, -0.565714, 0.735713},{-0.662439, -0.848571, 
        0.735713},{-0.495000, -0.848571, 0.857365}}],
    Line[{{-0.495000, -0.565714, 0.857365},{-0.495000, -0.282857, 
        0.857365},{-0.662439, -0.282857, 0.735713},{-0.662439, -0.565714, 
        0.735713},{-0.495000, -0.565714, 0.857365}}],
    Line[{{-0.495000, -0.282857, 0.857365},{-0.495000, -0.000000, 
        0.857365},{-0.662439, -0.000000, 0.735713},{-0.662439, -0.282857, 
        0.735713},{-0.495000, -0.282857, 0.857365}}],
    Line[{{-0.495000, -0.000000, 0.857365},{-0.495000, 0.282857, 
        0.857365},{-0.662439, 0.282857, 0.735713},{-0.662439, -0.000000, 
        0.735713},{-0.495000, -0.000000, 0.857365}}],
    Line[{{-0.495000, 0.282857, 0.857365},{-0.495000, 0.565714, 
        0.857365},{-0.662439, 0.565714, 0.735713},{-0.662439, 0.282857, 
        0.735713},{-0.495000, 0.282857, 0.857365}}],
    Line[{{-0.495000, 0.565714, 0.857365},{-0.495000, 0.848571, 
        0.857365},{-0.662439, 0.848571, 0.735713},{-0.662439, 0.565714, 
        0.735713},{-0.495000, 0.565714, 0.857365}}],
    Line[{{-0.495000, 0.848571, 0.857365},{-0.495000, 1.131429, 
        0.857365},{-0.662439, 1.131429, 0.735713},{-0.662439, 0.848571, 
        0.735713},{-0.495000, 0.848571, 0.857365}}],
    Line[{{-0.495000, 1.131429, 0.857365},{-0.495000, 1.414286, 
        0.857365},{-0.662439, 1.414286, 0.735713},{-0.662439, 1.131429, 
        0.735713},{-0.495000, 1.131429, 0.857365}}],
    Line[{{-0.495000, 1.414286, 0.857365},{-0.495000, 1.697143, 
        0.857365},{-0.662439, 1.697143, 0.735713},{-0.662439, 1.414286, 
        0.735713},{-0.495000, 1.414286, 0.857365}}],
    Line[{{-0.495000, 1.697143, 0.857365},{-0.495000, 1.980000, 
        0.857365},{-0.662439, 1.980000, 0.735713},{-0.662439, 1.697143, 
        0.735713},{-0.495000, 1.697143, 0.857365}}],
    Line[{{-0.662439, -1.980000, 0.735713},{-0.662439, -1.697143, 
        0.735713},{-0.800927, -1.697143, 0.581907},{-0.800927, -1.980000, 
        0.581907},{-0.662439, -1.980000, 0.735713}}],
    Line[{{-0.662439, -1.697143, 0.735713},{-0.662439, -1.414286, 
        0.735713},{-0.800927, -1.414286, 0.581907},{-0.800927, -1.697143, 
        0.581907},{-0.662439, -1.697143, 0.735713}}],
    Line[{{-0.662439, -1.414286, 0.735713},{-0.662439, -1.131429, 
        0.735713},{-0.800927, -1.131429, 0.581907},{-0.800927, -1.414286, 
        0.581907},{-0.662439, -1.414286, 0.735713}}],
    Line[{{-0.662439, -1.131429, 0.735713},{-0.662439, -0.848571, 
        0.735713},{-0.800927, -0.848571, 0.581907},{-0.800927, -1.131429, 
        0.581907},{-0.662439, -1.131429, 0.735713}}],
    Line[{{-0.662439, -0.848571, 0.735713},{-0.662439, -0.565714, 
        0.735713},{-0.800927, -0.565714, 0.581907},{-0.800927, -0.848571, 
        0.581907},{-0.662439, -0.848571, 0.735713}}],
    Line[{{-0.662439, -0.565714, 0.735713},{-0.662439, -0.282857, 
        0.735713},{-0.800927, -0.282857, 0.581907},{-0.800927, -0.565714, 
        0.581907},{-0.662439, -0.565714, 0.735713}}],
    Line[{{-0.662439, -0.282857, 0.735713},{-0.662439, -0.000000, 
        0.735713},{-0.800927, -0.000000, 0.581907},{-0.800927, -0.282857, 
        0.581907},{-0.662439, -0.282857, 0.735713}}],
    Line[{{-0.662439, -0.000000, 0.735713},{-0.662439, 0.282857, 
        0.735713},{-0.800927, 0.282857, 0.581907},{-0.800927, -0.000000, 
        0.581907},{-0.662439, -0.000000, 0.735713}}],
    Line[{{-0.662439, 0.282857, 0.735713},{-0.662439, 0.565714, 
        0.735713},{-0.800927, 0.565714, 0.581907},{-0.800927, 0.282857, 
        0.581907},{-0.662439, 0.282857, 0.735713}}],
    Line[{{-0.662439, 0.565714, 0.735713},{-0.662439, 0.848571, 
        0.735713},{-0.800927, 0.848571, 0.581907},{-0.800927, 0.565714, 
        0.581907},{-0.662439, 0.565714, 0.735713}}],
    Line[{{-0.662439, 0.848571, 0.735713},{-0.662439, 1.131429, 
        0.735713},{-0.800927, 1.131429, 0.581907},{-0.800927, 0.848571, 
        0.581907},{-0.662439, 0.848571, 0.735713}}],
    Line[{{-0.662439, 1.131429, 0.735713},{-0.662439, 1.414286, 
        0.735713},{-0.800927, 1.414286, 0.581907},{-0.800927, 1.131429, 
        0.581907},{-0.662439, 1.131429, 0.735713}}],
    Line[{{-0.662439, 1.414286, 0.735713},{-0.662439, 1.697143, 
        0.735713},{-0.800927, 1.697143, 0.581907},{-0.800927, 1.414286, 
        0.581907},{-0.662439, 1.414286, 0.735713}}],
    Line[{{-0.662439, 1.697143, 0.735713},{-0.662439, 1.980000, 
        0.735713},{-0.800927, 1.980000, 0.581907},{-0.800927, 1.697143, 
        0.581907},{-0.662439, 1.697143, 0.735713}}],
    Line[{{-0.800927, -1.980000, 0.581907},{-0.800927, -1.697143, 
        0.581907},{-0.904410, -1.697143, 0.402669},{-0.904410, -1.980000, 
        0.402669},{-0.800927, -1.980000, 0.581907}}],
    Line[{{-0.800927, -1.697143, 0.581907},{-0.800927, -1.414286, 
        0.581907},{-0.904410, -1.414286, 0.402669},{-0.904410, -1.697143, 
        0.402669},{-0.800927, -1.697143, 0.581907}}],
    Line[{{-0.800927, -1.414286, 0.581907},{-0.800927, -1.131429, 
        0.581907},{-0.904410, -1.131429, 0.402669},{-0.904410, -1.414286, 
        0.402669},{-0.800927, -1.414286, 0.581907}}],
    Line[{{-0.800927, -1.131429, 0.581907},{-0.800927, -0.848571, 
        0.581907},{-0.904410, -0.848571, 0.402669},{-0.904410, -1.131429, 
        0.402669},{-0.800927, -1.131429, 0.581907}}],
    Line[{{-0.800927, -0.848571, 0.581907},{-0.800927, -0.565714, 
        0.581907},{-0.904410, -0.565714, 0.402669},{-0.904410, -0.848571, 
        0.402669},{-0.800927, -0.848571, 0.581907}}],
    Line[{{-0.800927, -0.565714, 0.581907},{-0.800927, -0.282857, 
        0.581907},{-0.904410, -0.282857, 0.402669},{-0.904410, -0.565714, 
        0.402669},{-0.800927, -0.565714, 0.581907}}],
    Line[{{-0.800927, -0.282857, 0.581907},{-0.800927, -0.000000, 
        0.581907},{-0.904410, -0.000000, 0.402669},{-0.904410, -0.282857, 
        0.402669},{-0.800927, -0.282857, 0.581907}}],
    Line[{{-0.800927, -0.000000, 0.581907},{-0.800927, 0.282857, 
        0.581907},{-0.904410, 0.282857, 0.402669},{-0.904410, -0.000000, 
        0.402669},{-0.800927, -0.000000, 0.581907}}],
    Line[{{-0.800927, 0.282857, 0.581907},{-0.800927, 0.565714, 
        0.581907},{-0.904410, 0.565714, 0.402669},{-0.904410, 0.282857, 
        0.402669},{-0.800927, 0.282857, 0.581907}}],
    Line[{{-0.800927, 0.565714, 0.581907},{-0.800927, 0.848571, 
        0.581907},{-0.904410, 0.848571, 0.402669},{-0.904410, 0.565714, 
        0.402669},{-0.800927, 0.565714, 0.581907}}],
    Line[{{-0.800927, 0.848571, 0.581907},{-0.800927, 1.131429, 
        0.581907},{-0.904410, 1.131429, 0.402669},{-0.904410, 0.848571, 
        0.402669},{-0.800927, 0.848571, 0.581907}}],
    Line[{{-0.800927, 1.131429, 0.581907},{-0.800927, 1.414286, 
        0.581907},{-0.904410, 1.414286, 0.402669},{-0.904410, 1.131429, 
        0.402669},{-0.800927, 1.131429, 0.581907}}],
    Line[{{-0.800927, 1.414286, 0.581907},{-0.800927, 1.697143, 
        0.581907},{-0.904410, 1.697143, 0.402669},{-0.904410, 1.414286, 
        0.402669},{-0.800927, 1.414286, 0.581907}}],
    Line[{{-0.800927, 1.697143, 0.581907},{-0.800927, 1.980000, 
        0.581907},{-0.904410, 1.980000, 0.402669},{-0.904410, 1.697143, 
        0.402669},{-0.800927, 1.697143, 0.581907}}],
    Line[{{-0.904410, -1.980000, 0.402669},{-0.904410, -1.697143, 
        0.402669},{-0.968366, -1.697143, 0.205833},{-0.968366, -1.980000, 
        0.205833},{-0.904410, -1.980000, 0.402669}}],
    Line[{{-0.904410, -1.697143, 0.402669},{-0.904410, -1.414286, 
        0.402669},{-0.968366, -1.414286, 0.205833},{-0.968366, -1.697143, 
        0.205833},{-0.904410, -1.697143, 0.402669}}],
    Line[{{-0.904410, -1.414286, 0.402669},{-0.904410, -1.131429, 
        0.402669},{-0.968366, -1.131429, 0.205833},{-0.968366, -1.414286, 
        0.205833},{-0.904410, -1.414286, 0.402669}}],
    Line[{{-0.904410, -1.131429, 0.402669},{-0.904410, -0.848571, 
        0.402669},{-0.968366, -0.848571, 0.205833},{-0.968366, -1.131429, 
        0.205833},{-0.904410, -1.131429, 0.402669}}],
    Line[{{-0.904410, -0.848571, 0.402669},{-0.904410, -0.565714, 
        0.402669},{-0.968366, -0.565714, 0.205833},{-0.968366, -0.848571, 
        0.205833},{-0.904410, -0.848571, 0.402669}}],
    Line[{{-0.904410, -0.565714, 0.402669},{-0.904410, -0.282857, 
        0.402669},{-0.968366, -0.282857, 0.205833},{-0.968366, -0.565714, 
        0.205833},{-0.904410, -0.565714, 0.402669}}],
    Line[{{-0.904410, -0.282857, 0.402669},{-0.904410, -0.000000, 
        0.402669},{-0.968366, -0.000000, 0.205833},{-0.968366, -0.282857, 
        0.205833},{-0.904410, -0.282857, 0.402669}}],
    Line[{{-0.904410, -0.000000, 0.402669},{-0.904410, 0.282857, 
        0.402669},{-0.968366, 0.282857, 0.205833},{-0.968366, -0.000000, 
        0.205833},{-0.904410, -0.000000, 0.402669}}],
    Line[{{-0.904410, 0.282857, 0.402669},{-0.904410, 0.565714, 
        0.402669},{-0.968366, 0.565714, 0.205833},{-0.968366, 0.282857, 
        0.205833},{-0.904410, 0.282857, 0.402669}}],
    Line[{{-0.904410, 0.565714, 0.402669},{-0.904410, 0.848571, 
        0.402669},{-0.968366, 0.848571, 0.205833},{-0.968366, 0.565714, 
        0.205833},{-0.904410, 0.565714, 0.402669}}],
    Line[{{-0.904410, 0.848571, 0.402669},{-0.904410, 1.131429, 
        0.402669},{-0.968366, 1.131429, 0.205833},{-0.968366, 0.848571, 
        0.205833},{-0.904410, 0.848571, 0.402669}}],
    Line[{{-0.904410, 1.131429, 0.402669},{-0.904410, 1.414286, 
        0.402669},{-0.968366, 1.414286, 0.205833},{-0.968366, 1.131429, 
        0.205833},{-0.904410, 1.131429, 0.402669}}],
    Line[{{-0.904410, 1.414286, 0.402669},{-0.904410, 1.697143, 
        0.402669},{-0.968366, 1.697143, 0.205833},{-0.968366, 1.414286, 
        0.205833},{-0.904410, 1.414286, 0.402669}}],
    Line[{{-0.904410, 1.697143, 0.402669},{-0.904410, 1.980000, 
        0.402669},{-0.968366, 1.980000, 0.205833},{-0.968366, 1.697143, 
        0.205833},{-0.904410, 1.697143, 0.402669}}],
    Line[{{-0.968366, -1.980000, 0.205833},{-0.968366, -1.697143, 
        0.205833},{-0.990000, -1.697143, 0.000000},{-0.990000, -1.980000, 
        0.000000},{-0.968366, -1.980000, 0.205833}}],
    Line[{{-0.968366, -1.697143, 0.205833},{-0.968366, -1.414286, 
        0.205833},{-0.990000, -1.414286, 0.000000},{-0.990000, -1.697143, 
        0.000000},{-0.968366, -1.697143, 0.205833}}],
    Line[{{-0.968366, -1.414286, 0.205833},{-0.968366, -1.131429, 
        0.205833},{-0.990000, -1.131429, 0.000000},{-0.990000, -1.414286, 
        0.000000},{-0.968366, -1.414286, 0.205833}}],
    Line[{{-0.968366, -1.131429, 0.205833},{-0.968366, -0.848571, 
        0.205833},{-0.990000, -0.848571, 0.000000},{-0.990000, -1.131429, 
        0.000000},{-0.968366, -1.131429, 0.205833}}],
    Line[{{-0.968366, -0.848571, 0.205833},{-0.968366, -0.565714, 
        0.205833},{-0.990000, -0.565714, 0.000000},{-0.990000, -0.848571, 
        0.000000},{-0.968366, -0.848571, 0.205833}}],
    Line[{{-0.968366, -0.565714, 0.205833},{-0.968366, -0.282857, 
        0.205833},{-0.990000, -0.282857, 0.000000},{-0.990000, -0.565714, 
        0.000000},{-0.968366, -0.565714, 0.205833}}],
    Line[{{-0.968366, -0.282857, 0.205833},{-0.968366, -0.000000, 
        0.205833},{-0.990000, -0.000000, 0.000000},{-0.990000, -0.282857, 
        0.000000},{-0.968366, -0.282857, 0.205833}}],
    Line[{{-0.968366, -0.000000, 0.205833},{-0.968366, 0.282857, 
        0.205833},{-0.990000, 0.282857, 0.000000},{-0.990000, -0.000000, 
        0.000000},{-0.968366, -0.000000, 0.205833}}],
    Line[{{-0.968366, 0.282857, 0.205833},{-0.968366, 0.565714, 
        0.205833},{-0.990000, 0.565714, 0.000000},{-0.990000, 0.282857, 
        0.000000},{-0.968366, 0.282857, 0.205833}}],
    Line[{{-0.968366, 0.565714, 0.205833},{-0.968366, 0.848571, 
        0.205833},{-0.990000, 0.848571, 0.000000},{-0.990000, 0.565714, 
        0.000000},{-0.968366, 0.565714, 0.205833}}],
    Line[{{-0.968366, 0.848571, 0.205833},{-0.968366, 1.131429, 
        0.205833},{-0.990000, 1.131429, 0.000000},{-0.990000, 0.848571, 
        0.000000},{-0.968366, 0.848571, 0.205833}}],
    Line[{{-0.968366, 1.131429, 0.205833},{-0.968366, 1.414286, 
        0.205833},{-0.990000, 1.414286, 0.000000},{-0.990000, 1.131429, 
        0.000000},{-0.968366, 1.131429, 0.205833}}],
    Line[{{-0.968366, 1.414286, 0.205833},{-0.968366, 1.697143, 
        0.205833},{-0.990000, 1.697143, 0.000000},{-0.990000, 1.414286, 
        0.000000},{-0.968366, 1.414286, 0.205833}}],
    Line[{{-0.968366, 1.697143, 0.205833},{-0.968366, 1.980000, 
        0.205833},{-0.990000, 1.980000, 0.000000},{-0.990000, 1.697143, 
        0.000000},{-0.968366, 1.697143, 0.205833}}],
    Line[{{-0.990000, -1.980000, 0.000000},{-0.990000, -1.697143, 
        0.000000},{-0.968366, -1.697143, -0.205833},{-0.968366, -1.980000, \
-0.205833},{-0.990000, -1.980000, 0.000000}}],
    Line[{{-0.990000, -1.697143, 0.000000},{-0.990000, -1.414286, 
        0.000000},{-0.968366, -1.414286, -0.205833},{-0.968366, -1.697143, \
-0.205833},{-0.990000, -1.697143, 0.000000}}],
    Line[{{-0.990000, -1.414286, 0.000000},{-0.990000, -1.131429, 
        0.000000},{-0.968366, -1.131429, -0.205833},{-0.968366, -1.414286, \
-0.205833},{-0.990000, -1.414286, 0.000000}}],
    Line[{{-0.990000, -1.131429, 0.000000},{-0.990000, -0.848571, 
        0.000000},{-0.968366, -0.848571, -0.205833},{-0.968366, -1.131429, \
-0.205833},{-0.990000, -1.131429, 0.000000}}],
    Line[{{-0.990000, -0.848571, 0.000000},{-0.990000, -0.565714, 
        0.000000},{-0.968366, -0.565714, -0.205833},{-0.968366, -0.848571, \
-0.205833},{-0.990000, -0.848571, 0.000000}}],
    Line[{{-0.990000, -0.565714, 0.000000},{-0.990000, -0.282857, 
        0.000000},{-0.968366, -0.282857, -0.205833},{-0.968366, -0.565714, \
-0.205833},{-0.990000, -0.565714, 0.000000}}],
    Line[{{-0.990000, -0.282857, 0.000000},{-0.990000, -0.000000, 
        0.000000},{-0.968366, -0.000000, -0.205833},{-0.968366, -0.282857, \
-0.205833},{-0.990000, -0.282857, 0.000000}}],
    Line[{{-0.990000, -0.000000, 0.000000},{-0.990000, 0.282857, 
        0.000000},{-0.968366, 
        0.282857, -0.205833},{-0.968366, -0.000000, -0.205833},{-0.990000, \
-0.000000, 0.000000}}],
    Line[{{-0.990000, 0.282857, 0.000000},{-0.990000, 0.565714, 
        0.000000},{-0.968366, 0.565714, -0.205833},{-0.968366, 
        0.282857, -0.205833},{-0.990000, 0.282857, 0.000000}}],
    Line[{{-0.990000, 0.565714, 0.000000},{-0.990000, 0.848571, 
        0.000000},{-0.968366, 0.848571, -0.205833},{-0.968366, 
        0.565714, -0.205833},{-0.990000, 0.565714, 0.000000}}],
    Line[{{-0.990000, 0.848571, 0.000000},{-0.990000, 1.131429, 
        0.000000},{-0.968366, 1.131429, -0.205833},{-0.968366, 
        0.848571, -0.205833},{-0.990000, 0.848571, 0.000000}}],
    Line[{{-0.990000, 1.131429, 0.000000},{-0.990000, 1.414286, 
        0.000000},{-0.968366, 1.414286, -0.205833},{-0.968366, 
        1.131429, -0.205833},{-0.990000, 1.131429, 0.000000}}],
    Line[{{-0.990000, 1.414286, 0.000000},{-0.990000, 1.697143, 
        0.000000},{-0.968366, 1.697143, -0.205833},{-0.968366, 
        1.414286, -0.205833},{-0.990000, 1.414286, 0.000000}}],
    Line[{{-0.990000, 1.697143, 0.000000},{-0.990000, 1.980000, 
        0.000000},{-0.968366, 1.980000, -0.205833},{-0.968366, 
        1.697143, -0.205833},{-0.990000, 1.697143, 0.000000}}],
    Line[{{-0.968366, -1.980000, -0.205833},{-0.968366, -1.697143, \
-0.205833},{-0.904410, -1.697143, -0.402669},{-0.904410, -1.980000, \
-0.402669},{-0.968366, -1.980000, -0.205833}}],
    Line[{{-0.968366, -1.697143, -0.205833},{-0.968366, -1.414286, \
-0.205833},{-0.904410, -1.414286, -0.402669},{-0.904410, -1.697143, \
-0.402669},{-0.968366, -1.697143, -0.205833}}],
    Line[{{-0.968366, -1.414286, -0.205833},{-0.968366, -1.131429, \
-0.205833},{-0.904410, -1.131429, -0.402669},{-0.904410, -1.414286, \
-0.402669},{-0.968366, -1.414286, -0.205833}}],
    Line[{{-0.968366, -1.131429, -0.205833},{-0.968366, -0.848571, \
-0.205833},{-0.904410, -0.848571, -0.402669},{-0.904410, -1.131429, \
-0.402669},{-0.968366, -1.131429, -0.205833}}],
    Line[{{-0.968366, -0.848571, -0.205833},{-0.968366, -0.565714, \
-0.205833},{-0.904410, -0.565714, -0.402669},{-0.904410, -0.848571, \
-0.402669},{-0.968366, -0.848571, -0.205833}}],
    Line[{{-0.968366, -0.565714, -0.205833},{-0.968366, -0.282857, \
-0.205833},{-0.904410, -0.282857, -0.402669},{-0.904410, -0.565714, \
-0.402669},{-0.968366, -0.565714, -0.205833}}],
    Line[{{-0.968366, -0.282857, -0.205833},{-0.968366, -0.000000, \
-0.205833},{-0.904410, -0.000000, -0.402669},{-0.904410, -0.282857, \
-0.402669},{-0.968366, -0.282857, -0.205833}}],
    Line[{{-0.968366, -0.000000, -0.205833},{-0.968366, 
        0.282857, -0.205833},{-0.904410, 
        0.282857, -0.402669},{-0.904410, -0.000000, -0.402669},{-0.968366, \
-0.000000, -0.205833}}],
    Line[{{-0.968366, 0.282857, -0.205833},{-0.968366, 
        0.565714, -0.205833},{-0.904410, 0.565714, -0.402669},{-0.904410, 
        0.282857, -0.402669},{-0.968366, 0.282857, -0.205833}}],
    Line[{{-0.968366, 0.565714, -0.205833},{-0.968366, 
        0.848571, -0.205833},{-0.904410, 0.848571, -0.402669},{-0.904410, 
        0.565714, -0.402669},{-0.968366, 0.565714, -0.205833}}],
    Line[{{-0.968366, 0.848571, -0.205833},{-0.968366, 
        1.131429, -0.205833},{-0.904410, 1.131429, -0.402669},{-0.904410, 
        0.848571, -0.402669},{-0.968366, 0.848571, -0.205833}}],
    Line[{{-0.968366, 1.131429, -0.205833},{-0.968366, 
        1.414286, -0.205833},{-0.904410, 1.414286, -0.402669},{-0.904410, 
        1.131429, -0.402669},{-0.968366, 1.131429, -0.205833}}],
    Line[{{-0.968366, 1.414286, -0.205833},{-0.968366, 
        1.697143, -0.205833},{-0.904410, 1.697143, -0.402669},{-0.904410, 
        1.414286, -0.402669},{-0.968366, 1.414286, -0.205833}}],
    Line[{{-0.968366, 1.697143, -0.205833},{-0.968366, 
        1.980000, -0.205833},{-0.904410, 1.980000, -0.402669},{-0.904410, 
        1.697143, -0.402669},{-0.968366, 1.697143, -0.205833}}],
    Line[{{-0.904410, -1.980000, -0.402669},{-0.904410, -1.697143, \
-0.402669},{-0.800927, -1.697143, -0.581907},{-0.800927, -1.980000, \
-0.581907},{-0.904410, -1.980000, -0.402669}}],
    Line[{{-0.904410, -1.697143, -0.402669},{-0.904410, -1.414286, \
-0.402669},{-0.800927, -1.414286, -0.581907},{-0.800927, -1.697143, \
-0.581907},{-0.904410, -1.697143, -0.402669}}],
    Line[{{-0.904410, -1.414286, -0.402669},{-0.904410, -1.131429, \
-0.402669},{-0.800927, -1.131429, -0.581907},{-0.800927, -1.414286, \
-0.581907},{-0.904410, -1.414286, -0.402669}}],
    Line[{{-0.904410, -1.131429, -0.402669},{-0.904410, -0.848571, \
-0.402669},{-0.800927, -0.848571, -0.581907},{-0.800927, -1.131429, \
-0.581907},{-0.904410, -1.131429, -0.402669}}],
    Line[{{-0.904410, -0.848571, -0.402669},{-0.904410, -0.565714, \
-0.402669},{-0.800927, -0.565714, -0.581907},{-0.800927, -0.848571, \
-0.581907},{-0.904410, -0.848571, -0.402669}}],
    Line[{{-0.904410, -0.565714, -0.402669},{-0.904410, -0.282857, \
-0.402669},{-0.800927, -0.282857, -0.581907},{-0.800927, -0.565714, \
-0.581907},{-0.904410, -0.565714, -0.402669}}],
    Line[{{-0.904410, -0.282857, -0.402669},{-0.904410, -0.000000, \
-0.402669},{-0.800927, -0.000000, -0.581907},{-0.800927, -0.282857, \
-0.581907},{-0.904410, -0.282857, -0.402669}}],
    Line[{{-0.904410, -0.000000, -0.402669},{-0.904410, 
        0.282857, -0.402669},{-0.800927, 
        0.282857, -0.581907},{-0.800927, -0.000000, -0.581907},{-0.904410, \
-0.000000, -0.402669}}],
    Line[{{-0.904410, 0.282857, -0.402669},{-0.904410, 
        0.565714, -0.402669},{-0.800927, 0.565714, -0.581907},{-0.800927, 
        0.282857, -0.581907},{-0.904410, 0.282857, -0.402669}}],
    Line[{{-0.904410, 0.565714, -0.402669},{-0.904410, 
        0.848571, -0.402669},{-0.800927, 0.848571, -0.581907},{-0.800927, 
        0.565714, -0.581907},{-0.904410, 0.565714, -0.402669}}],
    Line[{{-0.904410, 0.848571, -0.402669},{-0.904410, 
        1.131429, -0.402669},{-0.800927, 1.131429, -0.581907},{-0.800927, 
        0.848571, -0.581907},{-0.904410, 0.848571, -0.402669}}],
    Line[{{-0.904410, 1.131429, -0.402669},{-0.904410, 
        1.414286, -0.402669},{-0.800927, 1.414286, -0.581907},{-0.800927, 
        1.131429, -0.581907},{-0.904410, 1.131429, -0.402669}}],
    Line[{{-0.904410, 1.414286, -0.402669},{-0.904410, 
        1.697143, -0.402669},{-0.800927, 1.697143, -0.581907},{-0.800927, 
        1.414286, -0.581907},{-0.904410, 1.414286, -0.402669}}],
    Line[{{-0.904410, 1.697143, -0.402669},{-0.904410, 
        1.980000, -0.402669},{-0.800927, 1.980000, -0.581907},{-0.800927, 
        1.697143, -0.581907},{-0.904410, 1.697143, -0.402669}}],
    Line[{{-0.800927, -1.980000, -0.581907},{-0.800927, -1.697143, \
-0.581907},{-0.662439, -1.697143, -0.735713},{-0.662439, -1.980000, \
-0.735713},{-0.800927, -1.980000, -0.581907}}],
    Line[{{-0.800927, -1.697143, -0.581907},{-0.800927, -1.414286, \
-0.581907},{-0.662439, -1.414286, -0.735713},{-0.662439, -1.697143, \
-0.735713},{-0.800927, -1.697143, -0.581907}}],
    Line[{{-0.800927, -1.414286, -0.581907},{-0.800927, -1.131429, \
-0.581907},{-0.662439, -1.131429, -0.735713},{-0.662439, -1.414286, \
-0.735713},{-0.800927, -1.414286, -0.581907}}],
    Line[{{-0.800927, -1.131429, -0.581907},{-0.800927, -0.848571, \
-0.581907},{-0.662439, -0.848571, -0.735713},{-0.662439, -1.131429, \
-0.735713},{-0.800927, -1.131429, -0.581907}}],
    Line[{{-0.800927, -0.848571, -0.581907},{-0.800927, -0.565714, \
-0.581907},{-0.662439, -0.565714, -0.735713},{-0.662439, -0.848571, \
-0.735713},{-0.800927, -0.848571, -0.581907}}],
    Line[{{-0.800927, -0.565714, -0.581907},{-0.800927, -0.282857, \
-0.581907},{-0.662439, -0.282857, -0.735713},{-0.662439, -0.565714, \
-0.735713},{-0.800927, -0.565714, -0.581907}}],
    Line[{{-0.800927, -0.282857, -0.581907},{-0.800927, -0.000000, \
-0.581907},{-0.662439, -0.000000, -0.735713},{-0.662439, -0.282857, \
-0.735713},{-0.800927, -0.282857, -0.581907}}],
    Line[{{-0.800927, -0.000000, -0.581907},{-0.800927, 
        0.282857, -0.581907},{-0.662439, 
        0.282857, -0.735713},{-0.662439, -0.000000, -0.735713},{-0.800927, \
-0.000000, -0.581907}}],
    Line[{{-0.800927, 0.282857, -0.581907},{-0.800927, 
        0.565714, -0.581907},{-0.662439, 0.565714, -0.735713},{-0.662439, 
        0.282857, -0.735713},{-0.800927, 0.282857, -0.581907}}],
    Line[{{-0.800927, 0.565714, -0.581907},{-0.800927, 
        0.848571, -0.581907},{-0.662439, 0.848571, -0.735713},{-0.662439, 
        0.565714, -0.735713},{-0.800927, 0.565714, -0.581907}}],
    Line[{{-0.800927, 0.848571, -0.581907},{-0.800927, 
        1.131429, -0.581907},{-0.662439, 1.131429, -0.735713},{-0.662439, 
        0.848571, -0.735713},{-0.800927, 0.848571, -0.581907}}],
    Line[{{-0.800927, 1.131429, -0.581907},{-0.800927, 
        1.414286, -0.581907},{-0.662439, 1.414286, -0.735713},{-0.662439, 
        1.131429, -0.735713},{-0.800927, 1.131429, -0.581907}}],
    Line[{{-0.800927, 1.414286, -0.581907},{-0.800927, 
        1.697143, -0.581907},{-0.662439, 1.697143, -0.735713},{-0.662439, 
        1.414286, -0.735713},{-0.800927, 1.414286, -0.581907}}],
    Line[{{-0.800927, 1.697143, -0.581907},{-0.800927, 
        1.980000, -0.581907},{-0.662439, 1.980000, -0.735713},{-0.662439, 
        1.697143, -0.735713},{-0.800927, 1.697143, -0.581907}}],
    Line[{{-0.662439, -1.980000, -0.735713},{-0.662439, -1.697143, \
-0.735713},{-0.495000, -1.697143, -0.857365},{-0.495000, -1.980000, \
-0.857365},{-0.662439, -1.980000, -0.735713}}],
    Line[{{-0.662439, -1.697143, -0.735713},{-0.662439, -1.414286, \
-0.735713},{-0.495000, -1.414286, -0.857365},{-0.495000, -1.697143, \
-0.857365},{-0.662439, -1.697143, -0.735713}}],
    Line[{{-0.662439, -1.414286, -0.735713},{-0.662439, -1.131429, \
-0.735713},{-0.495000, -1.131429, -0.857365},{-0.495000, -1.414286, \
-0.857365},{-0.662439, -1.414286, -0.735713}}],
    Line[{{-0.662439, -1.131429, -0.735713},{-0.662439, -0.848571, \
-0.735713},{-0.495000, -0.848571, -0.857365},{-0.495000, -1.131429, \
-0.857365},{-0.662439, -1.131429, -0.735713}}],
    Line[{{-0.662439, -0.848571, -0.735713},{-0.662439, -0.565714, \
-0.735713},{-0.495000, -0.565714, -0.857365},{-0.495000, -0.848571, \
-0.857365},{-0.662439, -0.848571, -0.735713}}],
    Line[{{-0.662439, -0.565714, -0.735713},{-0.662439, -0.282857, \
-0.735713},{-0.495000, -0.282857, -0.857365},{-0.495000, -0.565714, \
-0.857365},{-0.662439, -0.565714, -0.735713}}],
    Line[{{-0.662439, -0.282857, -0.735713},{-0.662439, -0.000000, \
-0.735713},{-0.495000, -0.000000, -0.857365},{-0.495000, -0.282857, \
-0.857365},{-0.662439, -0.282857, -0.735713}}],
    Line[{{-0.662439, -0.000000, -0.735713},{-0.662439, 
        0.282857, -0.735713},{-0.495000, 
        0.282857, -0.857365},{-0.495000, -0.000000, -0.857365},{-0.662439, \
-0.000000, -0.735713}}],
    Line[{{-0.662439, 0.282857, -0.735713},{-0.662439, 
        0.565714, -0.735713},{-0.495000, 0.565714, -0.857365},{-0.495000, 
        0.282857, -0.857365},{-0.662439, 0.282857, -0.735713}}],
    Line[{{-0.662439, 0.565714, -0.735713},{-0.662439, 
        0.848571, -0.735713},{-0.495000, 0.848571, -0.857365},{-0.495000, 
        0.565714, -0.857365},{-0.662439, 0.565714, -0.735713}}],
    Line[{{-0.662439, 0.848571, -0.735713},{-0.662439, 
        1.131429, -0.735713},{-0.495000, 1.131429, -0.857365},{-0.495000, 
        0.848571, -0.857365},{-0.662439, 0.848571, -0.735713}}],
    Line[{{-0.662439, 1.131429, -0.735713},{-0.662439, 
        1.414286, -0.735713},{-0.495000, 1.414286, -0.857365},{-0.495000, 
        1.131429, -0.857365},{-0.662439, 1.131429, -0.735713}}],
    Line[{{-0.662439, 1.414286, -0.735713},{-0.662439, 
        1.697143, -0.735713},{-0.495000, 1.697143, -0.857365},{-0.495000, 
        1.414286, -0.857365},{-0.662439, 1.414286, -0.735713}}],
    Line[{{-0.662439, 1.697143, -0.735713},{-0.662439, 
        1.980000, -0.735713},{-0.495000, 1.980000, -0.857365},{-0.495000, 
        1.697143, -0.857365},{-0.662439, 1.697143, -0.735713}}],
    Line[{{-0.495000, -1.980000, -0.857365},{-0.495000, -1.697143, \
-0.857365},{-0.305927, -1.697143, -0.941546},{-0.305927, -1.980000, \
-0.941546},{-0.495000, -1.980000, -0.857365}}],
    Line[{{-0.495000, -1.697143, -0.857365},{-0.495000, -1.414286, \
-0.857365},{-0.305927, -1.414286, -0.941546},{-0.305927, -1.697143, \
-0.941546},{-0.495000, -1.697143, -0.857365}}],
    Line[{{-0.495000, -1.414286, -0.857365},{-0.495000, -1.131429, \
-0.857365},{-0.305927, -1.131429, -0.941546},{-0.305927, -1.414286, \
-0.941546},{-0.495000, -1.414286, -0.857365}}],
    Line[{{-0.495000, -1.131429, -0.857365},{-0.495000, -0.848571, \
-0.857365},{-0.305927, -0.848571, -0.941546},{-0.305927, -1.131429, \
-0.941546},{-0.495000, -1.131429, -0.857365}}],
    Line[{{-0.495000, -0.848571, -0.857365},{-0.495000, -0.565714, \
-0.857365},{-0.305927, -0.565714, -0.941546},{-0.305927, -0.848571, \
-0.941546},{-0.495000, -0.848571, -0.857365}}],
    Line[{{-0.495000, -0.565714, -0.857365},{-0.495000, -0.282857, \
-0.857365},{-0.305927, -0.282857, -0.941546},{-0.305927, -0.565714, \
-0.941546},{-0.495000, -0.565714, -0.857365}}],
    Line[{{-0.495000, -0.282857, -0.857365},{-0.495000, -0.000000, \
-0.857365},{-0.305927, -0.000000, -0.941546},{-0.305927, -0.282857, \
-0.941546},{-0.495000, -0.282857, -0.857365}}],
    Line[{{-0.495000, -0.000000, -0.857365},{-0.495000, 
        0.282857, -0.857365},{-0.305927, 
        0.282857, -0.941546},{-0.305927, -0.000000, -0.941546},{-0.495000, \
-0.000000, -0.857365}}],
    Line[{{-0.495000, 0.282857, -0.857365},{-0.495000, 
        0.565714, -0.857365},{-0.305927, 0.565714, -0.941546},{-0.305927, 
        0.282857, -0.941546},{-0.495000, 0.282857, -0.857365}}],
    Line[{{-0.495000, 0.565714, -0.857365},{-0.495000, 
        0.848571, -0.857365},{-0.305927, 0.848571, -0.941546},{-0.305927, 
        0.565714, -0.941546},{-0.495000, 0.565714, -0.857365}}],
    Line[{{-0.495000, 0.848571, -0.857365},{-0.495000, 
        1.131429, -0.857365},{-0.305927, 1.131429, -0.941546},{-0.305927, 
        0.848571, -0.941546},{-0.495000, 0.848571, -0.857365}}],
    Line[{{-0.495000, 1.131429, -0.857365},{-0.495000, 
        1.414286, -0.857365},{-0.305927, 1.414286, -0.941546},{-0.305927, 
        1.131429, -0.941546},{-0.495000, 1.131429, -0.857365}}],
    Line[{{-0.495000, 1.414286, -0.857365},{-0.495000, 
        1.697143, -0.857365},{-0.305927, 1.697143, -0.941546},{-0.305927, 
        1.414286, -0.941546},{-0.495000, 1.414286, -0.857365}}],
    Line[{{-0.495000, 1.697143, -0.857365},{-0.495000, 
        1.980000, -0.857365},{-0.305927, 1.980000, -0.941546},{-0.305927, 
        1.697143, -0.941546},{-0.495000, 1.697143, -0.857365}}],
    Line[{{-0.305927, -1.980000, -0.941546},{-0.305927, -1.697143, \
-0.941546},{-0.103483, -1.697143, -0.984577},{-0.103483, -1.980000, \
-0.984577},{-0.305927, -1.980000, -0.941546}}],
    Line[{{-0.305927, -1.697143, -0.941546},{-0.305927, -1.414286, \
-0.941546},{-0.103483, -1.414286, -0.984577},{-0.103483, -1.697143, \
-0.984577},{-0.305927, -1.697143, -0.941546}}],
    Line[{{-0.305927, -1.414286, -0.941546},{-0.305927, -1.131429, \
-0.941546},{-0.103483, -1.131429, -0.984577},{-0.103483, -1.414286, \
-0.984577},{-0.305927, -1.414286, -0.941546}}],
    Line[{{-0.305927, -1.131429, -0.941546},{-0.305927, -0.848571, \
-0.941546},{-0.103483, -0.848571, -0.984577},{-0.103483, -1.131429, \
-0.984577},{-0.305927, -1.131429, -0.941546}}],
    Line[{{-0.305927, -0.848571, -0.941546},{-0.305927, -0.565714, \
-0.941546},{-0.103483, -0.565714, -0.984577},{-0.103483, -0.848571, \
-0.984577},{-0.305927, -0.848571, -0.941546}}],
    Line[{{-0.305927, -0.565714, -0.941546},{-0.305927, -0.282857, \
-0.941546},{-0.103483, -0.282857, -0.984577},{-0.103483, -0.565714, \
-0.984577},{-0.305927, -0.565714, -0.941546}}],
    Line[{{-0.305927, -0.282857, -0.941546},{-0.305927, -0.000000, \
-0.941546},{-0.103483, -0.000000, -0.984577},{-0.103483, -0.282857, \
-0.984577},{-0.305927, -0.282857, -0.941546}}],
    Line[{{-0.305927, -0.000000, -0.941546},{-0.305927, 
        0.282857, -0.941546},{-0.103483, 
        0.282857, -0.984577},{-0.103483, -0.000000, -0.984577},{-0.305927, \
-0.000000, -0.941546}}],
    Line[{{-0.305927, 0.282857, -0.941546},{-0.305927, 
        0.565714, -0.941546},{-0.103483, 0.565714, -0.984577},{-0.103483, 
        0.282857, -0.984577},{-0.305927, 0.282857, -0.941546}}],
    Line[{{-0.305927, 0.565714, -0.941546},{-0.305927, 
        0.848571, -0.941546},{-0.103483, 0.848571, -0.984577},{-0.103483, 
        0.565714, -0.984577},{-0.305927, 0.565714, -0.941546}}],
    Line[{{-0.305927, 0.848571, -0.941546},{-0.305927, 
        1.131429, -0.941546},{-0.103483, 1.131429, -0.984577},{-0.103483, 
        0.848571, -0.984577},{-0.305927, 0.848571, -0.941546}}],
    Line[{{-0.305927, 1.131429, -0.941546},{-0.305927, 
        1.414286, -0.941546},{-0.103483, 1.414286, -0.984577},{-0.103483, 
        1.131429, -0.984577},{-0.305927, 1.131429, -0.941546}}],
    Line[{{-0.305927, 1.414286, -0.941546},{-0.305927, 
        1.697143, -0.941546},{-0.103483, 1.697143, -0.984577},{-0.103483, 
        1.414286, -0.984577},{-0.305927, 1.414286, -0.941546}}],
    Line[{{-0.305927, 1.697143, -0.941546},{-0.305927, 
        1.980000, -0.941546},{-0.103483, 1.980000, -0.984577},{-0.103483, 
        1.697143, -0.984577},{-0.305927, 1.697143, -0.941546}}],
    Line[{{-0.103483, -1.980000, -0.984577},{-0.103483, -1.697143, \
-0.984577},{0.103483, -1.697143, -0.984577},{
      0.103483, -1.980000, -0.984577},{-0.103483, -1.980000, -0.984577}}],
    Line[{{-0.103483, -1.697143, -0.984577},{-0.103483, -1.414286, \
-0.984577},{0.103483, -1.414286, -0.984577},{
      0.103483, -1.697143, -0.984577},{-0.103483, -1.697143, -0.984577}}],
    Line[{{-0.103483, -1.414286, -0.984577},{-0.103483, -1.131429, \
-0.984577},{0.103483, -1.131429, -0.984577},{
      0.103483, -1.414286, -0.984577},{-0.103483, -1.414286, -0.984577}}],
    Line[{{-0.103483, -1.131429, -0.984577},{-0.103483, -0.848571, \
-0.984577},{0.103483, -0.848571, -0.984577},{
      0.103483, -1.131429, -0.984577},{-0.103483, -1.131429, -0.984577}}],
    Line[{{-0.103483, -0.848571, -0.984577},{-0.103483, -0.565714, \
-0.984577},{0.103483, -0.565714, -0.984577},{
      0.103483, -0.848571, -0.984577},{-0.103483, -0.848571, -0.984577}}],
    Line[{{-0.103483, -0.565714, -0.984577},{-0.103483, -0.282857, \
-0.984577},{0.103483, -0.282857, -0.984577},{
      0.103483, -0.565714, -0.984577},{-0.103483, -0.565714, -0.984577}}],
    Line[{{-0.103483, -0.282857, -0.984577},{-0.103483, -0.000000, \
-0.984577},{0.103483, -0.000000, -0.984577},{
      0.103483, -0.282857, -0.984577},{-0.103483, -0.282857, -0.984577}}],
    Line[{{-0.103483, -0.000000, -0.984577},{-0.103483, 0.282857, -0.984577},{
      0.103483, 0.282857, -0.984577},{
      0.103483, -0.000000, -0.984577},{-0.103483, -0.000000, -0.984577}}],
    Line[{{-0.103483, 0.282857, -0.984577},{-0.103483, 0.565714, -0.984577},{
      0.103483, 0.565714, -0.984577},{
      0.103483, 0.282857, -0.984577},{-0.103483, 0.282857, -0.984577}}],
    Line[{{-0.103483, 0.565714, -0.984577},{-0.103483, 0.848571, -0.984577},{
      0.103483, 0.848571, -0.984577},{
      0.103483, 0.565714, -0.984577},{-0.103483, 0.565714, -0.984577}}],
    Line[{{-0.103483, 0.848571, -0.984577},{-0.103483, 1.131429, -0.984577},{
      0.103483, 1.131429, -0.984577},{
      0.103483, 0.848571, -0.984577},{-0.103483, 0.848571, -0.984577}}],
    Line[{{-0.103483, 1.131429, -0.984577},{-0.103483, 1.414286, -0.984577},{
      0.103483, 1.414286, -0.984577},{
      0.103483, 1.131429, -0.984577},{-0.103483, 1.131429, -0.984577}}],
    Line[{{-0.103483, 1.414286, -0.984577},{-0.103483, 1.697143, -0.984577},{
      0.103483, 1.697143, -0.984577},{
      0.103483, 1.414286, -0.984577},{-0.103483, 1.414286, -0.984577}}],
    Line[{{-0.103483, 1.697143, -0.984577},{-0.103483, 1.980000, -0.984577},{
      0.103483, 1.980000, -0.984577},{
      0.103483, 1.697143, -0.984577},{-0.103483, 1.697143, -0.984577}}],
    Line[{{0.103483, -1.980000, -0.984577},{0.103483, -1.697143, -0.984577},{
      0.305927, -1.697143, -0.941546},{0.305927, -1.980000, -0.941546},{
      0.103483, -1.980000, -0.984577}}],
    Line[{{0.103483, -1.697143, -0.984577},{0.103483, -1.414286, -0.984577},{
      0.305927, -1.414286, -0.941546},{0.305927, -1.697143, -0.941546},{
      0.103483, -1.697143, -0.984577}}],
    Line[{{0.103483, -1.414286, -0.984577},{0.103483, -1.131429, -0.984577},{
      0.305927, -1.131429, -0.941546},{0.305927, -1.414286, -0.941546},{
      0.103483, -1.414286, -0.984577}}],
    Line[{{0.103483, -1.131429, -0.984577},{0.103483, -0.848571, -0.984577},{
      0.305927, -0.848571, -0.941546},{0.305927, -1.131429, -0.941546},{
      0.103483, -1.131429, -0.984577}}],
    Line[{{0.103483, -0.848571, -0.984577},{0.103483, -0.565714, -0.984577},{
      0.305927, -0.565714, -0.941546},{0.305927, -0.848571, -0.941546},{
      0.103483, -0.848571, -0.984577}}],
    Line[{{0.103483, -0.565714, -0.984577},{0.103483, -0.282857, -0.984577},{
      0.305927, -0.282857, -0.941546},{0.305927, -0.565714, -0.941546},{
      0.103483, -0.565714, -0.984577}}],
    Line[{{0.103483, -0.282857, -0.984577},{0.103483, -0.000000, -0.984577},{
      0.305927, -0.000000, -0.941546},{0.305927, -0.282857, -0.941546},{
      0.103483, -0.282857, -0.984577}}],
    Line[{{0.103483, -0.000000, -0.984577},{0.103483, 0.282857, -0.984577},{
      0.305927, 0.282857, -0.941546},{0.305927, -0.000000, -0.941546},{
      0.103483, -0.000000, -0.984577}}],
    Line[{{0.103483, 0.282857, -0.984577},{0.103483, 0.565714, -0.984577},{
      0.305927, 0.565714, -0.941546},{0.305927, 0.282857, -0.941546},{
      0.103483, 0.282857, -0.984577}}],
    Line[{{0.103483, 0.565714, -0.984577},{0.103483, 0.848571, -0.984577},{
      0.305927, 0.848571, -0.941546},{0.305927, 0.565714, -0.941546},{
      0.103483, 0.565714, -0.984577}}],
    Line[{{0.103483, 0.848571, -0.984577},{0.103483, 1.131429, -0.984577},{
      0.305927, 1.131429, -0.941546},{0.305927, 0.848571, -0.941546},{
      0.103483, 0.848571, -0.984577}}],
    Line[{{0.103483, 1.131429, -0.984577},{0.103483, 1.414286, -0.984577},{
      0.305927, 1.414286, -0.941546},{0.305927, 1.131429, -0.941546},{
      0.103483, 1.131429, -0.984577}}],
    Line[{{0.103483, 1.414286, -0.984577},{0.103483, 1.697143, -0.984577},{
      0.305927, 1.697143, -0.941546},{0.305927, 1.414286, -0.941546},{
      0.103483, 1.414286, -0.984577}}],
    Line[{{0.103483, 1.697143, -0.984577},{0.103483, 1.980000, -0.984577},{
      0.305927, 1.980000, -0.941546},{0.305927, 1.697143, -0.941546},{
      0.103483, 1.697143, -0.984577}}],
    Line[{{0.305927, -1.980000, -0.941546},{0.305927, -1.697143, -0.941546},{
      0.495000, -1.697143, -0.857365},{0.495000, -1.980000, -0.857365},{
      0.305927, -1.980000, -0.941546}}],
    Line[{{0.305927, -1.697143, -0.941546},{0.305927, -1.414286, -0.941546},{
      0.495000, -1.414286, -0.857365},{0.495000, -1.697143, -0.857365},{
      0.305927, -1.697143, -0.941546}}],
    Line[{{0.305927, -1.414286, -0.941546},{0.305927, -1.131429, -0.941546},{
      0.495000, -1.131429, -0.857365},{0.495000, -1.414286, -0.857365},{
      0.305927, -1.414286, -0.941546}}],
    Line[{{0.305927, -1.131429, -0.941546},{0.305927, -0.848571, -0.941546},{
      0.495000, -0.848571, -0.857365},{0.495000, -1.131429, -0.857365},{
      0.305927, -1.131429, -0.941546}}],
    Line[{{0.305927, -0.848571, -0.941546},{0.305927, -0.565714, -0.941546},{
      0.495000, -0.565714, -0.857365},{0.495000, -0.848571, -0.857365},{
      0.305927, -0.848571, -0.941546}}],
    Line[{{0.305927, -0.565714, -0.941546},{0.305927, -0.282857, -0.941546},{
      0.495000, -0.282857, -0.857365},{0.495000, -0.565714, -0.857365},{
      0.305927, -0.565714, -0.941546}}],
    Line[{{0.305927, -0.282857, -0.941546},{0.305927, -0.000000, -0.941546},{
      0.495000, -0.000000, -0.857365},{0.495000, -0.282857, -0.857365},{
      0.305927, -0.282857, -0.941546}}],
    Line[{{0.305927, -0.000000, -0.941546},{0.305927, 0.282857, -0.941546},{
      0.495000, 0.282857, -0.857365},{0.495000, -0.000000, -0.857365},{
      0.305927, -0.000000, -0.941546}}],
    Line[{{0.305927, 0.282857, -0.941546},{0.305927, 0.565714, -0.941546},{
      0.495000, 0.565714, -0.857365},{0.495000, 0.282857, -0.857365},{
      0.305927, 0.282857, -0.941546}}],
    Line[{{0.305927, 0.565714, -0.941546},{0.305927, 0.848571, -0.941546},{
      0.495000, 0.848571, -0.857365},{0.495000, 0.565714, -0.857365},{
      0.305927, 0.565714, -0.941546}}],
    Line[{{0.305927, 0.848571, -0.941546},{0.305927, 1.131429, -0.941546},{
      0.495000, 1.131429, -0.857365},{0.495000, 0.848571, -0.857365},{
      0.305927, 0.848571, -0.941546}}],
    Line[{{0.305927, 1.131429, -0.941546},{0.305927, 1.414286, -0.941546},{
      0.495000, 1.414286, -0.857365},{0.495000, 1.131429, -0.857365},{
      0.305927, 1.131429, -0.941546}}],
    Line[{{0.305927, 1.414286, -0.941546},{0.305927, 1.697143, -0.941546},{
      0.495000, 1.697143, -0.857365},{0.495000, 1.414286, -0.857365},{
      0.305927, 1.414286, -0.941546}}],
    Line[{{0.305927, 1.697143, -0.941546},{0.305927, 1.980000, -0.941546},{
      0.495000, 1.980000, -0.857365},{0.495000, 1.697143, -0.857365},{
      0.305927, 1.697143, -0.941546}}],
    Line[{{0.495000, -1.980000, -0.857365},{0.495000, -1.697143, -0.857365},{
      0.662439, -1.697143, -0.735713},{0.662439, -1.980000, -0.735713},{
      0.495000, -1.980000, -0.857365}}],
    Line[{{0.495000, -1.697143, -0.857365},{0.495000, -1.414286, -0.857365},{
      0.662439, -1.414286, -0.735713},{0.662439, -1.697143, -0.735713},{
      0.495000, -1.697143, -0.857365}}],
    Line[{{0.495000, -1.414286, -0.857365},{0.495000, -1.131429, -0.857365},{
      0.662439, -1.131429, -0.735713},{0.662439, -1.414286, -0.735713},{
      0.495000, -1.414286, -0.857365}}],
    Line[{{0.495000, -1.131429, -0.857365},{0.495000, -0.848571, -0.857365},{
      0.662439, -0.848571, -0.735713},{0.662439, -1.131429, -0.735713},{
      0.495000, -1.131429, -0.857365}}],
    Line[{{0.495000, -0.848571, -0.857365},{0.495000, -0.565714, -0.857365},{
      0.662439, -0.565714, -0.735713},{0.662439, -0.848571, -0.735713},{
      0.495000, -0.848571, -0.857365}}],
    Line[{{0.495000, -0.565714, -0.857365},{0.495000, -0.282857, -0.857365},{
      0.662439, -0.282857, -0.735713},{0.662439, -0.565714, -0.735713},{
      0.495000, -0.565714, -0.857365}}],
    Line[{{0.495000, -0.282857, -0.857365},{0.495000, -0.000000, -0.857365},{
      0.662439, -0.000000, -0.735713},{0.662439, -0.282857, -0.735713},{
      0.495000, -0.282857, -0.857365}}],
    Line[{{0.495000, -0.000000, -0.857365},{0.495000, 0.282857, -0.857365},{
      0.662439, 0.282857, -0.735713},{0.662439, -0.000000, -0.735713},{
      0.495000, -0.000000, -0.857365}}],
    Line[{{0.495000, 0.282857, -0.857365},{0.495000, 0.565714, -0.857365},{
      0.662439, 0.565714, -0.735713},{0.662439, 0.282857, -0.735713},{
      0.495000, 0.282857, -0.857365}}],
    Line[{{0.495000, 0.565714, -0.857365},{0.495000, 0.848571, -0.857365},{
      0.662439, 0.848571, -0.735713},{0.662439, 0.565714, -0.735713},{
      0.495000, 0.565714, -0.857365}}],
    Line[{{0.495000, 0.848571, -0.857365},{0.495000, 1.131429, -0.857365},{
      0.662439, 1.131429, -0.735713},{0.662439, 0.848571, -0.735713},{
      0.495000, 0.848571, -0.857365}}],
    Line[{{0.495000, 1.131429, -0.857365},{0.495000, 1.414286, -0.857365},{
      0.662439, 1.414286, -0.735713},{0.662439, 1.131429, -0.735713},{
      0.495000, 1.131429, -0.857365}}],
    Line[{{0.495000, 1.414286, -0.857365},{0.495000, 1.697143, -0.857365},{
      0.662439, 1.697143, -0.735713},{0.662439, 1.414286, -0.735713},{
      0.495000, 1.414286, -0.857365}}],
    Line[{{0.495000, 1.697143, -0.857365},{0.495000, 1.980000, -0.857365},{
      0.662439, 1.980000, -0.735713},{0.662439, 1.697143, -0.735713},{
      0.495000, 1.697143, -0.857365}}],
    Line[{{0.662439, -1.980000, -0.735713},{0.662439, -1.697143, -0.735713},{
      0.800927, -1.697143, -0.581907},{0.800927, -1.980000, -0.581907},{
      0.662439, -1.980000, -0.735713}}],
    Line[{{0.662439, -1.697143, -0.735713},{0.662439, -1.414286, -0.735713},{
      0.800927, -1.414286, -0.581907},{0.800927, -1.697143, -0.581907},{
      0.662439, -1.697143, -0.735713}}],
    Line[{{0.662439, -1.414286, -0.735713},{0.662439, -1.131429, -0.735713},{
      0.800927, -1.131429, -0.581907},{0.800927, -1.414286, -0.581907},{
      0.662439, -1.414286, -0.735713}}],
    Line[{{0.662439, -1.131429, -0.735713},{0.662439, -0.848571, -0.735713},{
      0.800927, -0.848571, -0.581907},{0.800927, -1.131429, -0.581907},{
      0.662439, -1.131429, -0.735713}}],
    Line[{{0.662439, -0.848571, -0.735713},{0.662439, -0.565714, -0.735713},{
      0.800927, -0.565714, -0.581907},{0.800927, -0.848571, -0.581907},{
      0.662439, -0.848571, -0.735713}}],
    Line[{{0.662439, -0.565714, -0.735713},{0.662439, -0.282857, -0.735713},{
      0.800927, -0.282857, -0.581907},{0.800927, -0.565714, -0.581907},{
      0.662439, -0.565714, -0.735713}}],
    Line[{{0.662439, -0.282857, -0.735713},{0.662439, -0.000000, -0.735713},{
      0.800927, -0.000000, -0.581907},{0.800927, -0.282857, -0.581907},{
      0.662439, -0.282857, -0.735713}}],
    Line[{{0.662439, -0.000000, -0.735713},{0.662439, 0.282857, -0.735713},{
      0.800927, 0.282857, -0.581907},{0.800927, -0.000000, -0.581907},{
      0.662439, -0.000000, -0.735713}}],
    Line[{{0.662439, 0.282857, -0.735713},{0.662439, 0.565714, -0.735713},{
      0.800927, 0.565714, -0.581907},{0.800927, 0.282857, -0.581907},{
      0.662439, 0.282857, -0.735713}}],
    Line[{{0.662439, 0.565714, -0.735713},{0.662439, 0.848571, -0.735713},{
      0.800927, 0.848571, -0.581907},{0.800927, 0.565714, -0.581907},{
      0.662439, 0.565714, -0.735713}}],
    Line[{{0.662439, 0.848571, -0.735713},{0.662439, 1.131429, -0.735713},{
      0.800927, 1.131429, -0.581907},{0.800927, 0.848571, -0.581907},{
      0.662439, 0.848571, -0.735713}}],
    Line[{{0.662439, 1.131429, -0.735713},{0.662439, 1.414286, -0.735713},{
      0.800927, 1.414286, -0.581907},{0.800927, 1.131429, -0.581907},{
      0.662439, 1.131429, -0.735713}}],
    Line[{{0.662439, 1.414286, -0.735713},{0.662439, 1.697143, -0.735713},{
      0.800927, 1.697143, -0.581907},{0.800927, 1.414286, -0.581907},{
      0.662439, 1.414286, -0.735713}}],
    Line[{{0.662439, 1.697143, -0.735713},{0.662439, 1.980000, -0.735713},{
      0.800927, 1.980000, -0.581907},{0.800927, 1.697143, -0.581907},{
      0.662439, 1.697143, -0.735713}}],
    Line[{{0.800927, -1.980000, -0.581907},{0.800927, -1.697143, -0.581907},{
      0.904410, -1.697143, -0.402669},{0.904410, -1.980000, -0.402669},{
      0.800927, -1.980000, -0.581907}}],
    Line[{{0.800927, -1.697143, -0.581907},{0.800927, -1.414286, -0.581907},{
      0.904410, -1.414286, -0.402669},{0.904410, -1.697143, -0.402669},{
      0.800927, -1.697143, -0.581907}}],
    Line[{{0.800927, -1.414286, -0.581907},{0.800927, -1.131429, -0.581907},{
      0.904410, -1.131429, -0.402669},{0.904410, -1.414286, -0.402669},{
      0.800927, -1.414286, -0.581907}}],
    Line[{{0.800927, -1.131429, -0.581907},{0.800927, -0.848571, -0.581907},{
      0.904410, -0.848571, -0.402669},{0.904410, -1.131429, -0.402669},{
      0.800927, -1.131429, -0.581907}}],
    Line[{{0.800927, -0.848571, -0.581907},{0.800927, -0.565714, -0.581907},{
      0.904410, -0.565714, -0.402669},{0.904410, -0.848571, -0.402669},{
      0.800927, -0.848571, -0.581907}}],
    Line[{{0.800927, -0.565714, -0.581907},{0.800927, -0.282857, -0.581907},{
      0.904410, -0.282857, -0.402669},{0.904410, -0.565714, -0.402669},{
      0.800927, -0.565714, -0.581907}}],
    Line[{{0.800927, -0.282857, -0.581907},{0.800927, -0.000000, -0.581907},{
      0.904410, -0.000000, -0.402669},{0.904410, -0.282857, -0.402669},{
      0.800927, -0.282857, -0.581907}}],
    Line[{{0.800927, -0.000000, -0.581907},{0.800927, 0.282857, -0.581907},{
      0.904410, 0.282857, -0.402669},{0.904410, -0.000000, -0.402669},{
      0.800927, -0.000000, -0.581907}}],
    Line[{{0.800927, 0.282857, -0.581907},{0.800927, 0.565714, -0.581907},{
      0.904410, 0.565714, -0.402669},{0.904410, 0.282857, -0.402669},{
      0.800927, 0.282857, -0.581907}}],
    Line[{{0.800927, 0.565714, -0.581907},{0.800927, 0.848571, -0.581907},{
      0.904410, 0.848571, -0.402669},{0.904410, 0.565714, -0.402669},{
      0.800927, 0.565714, -0.581907}}],
    Line[{{0.800927, 0.848571, -0.581907},{0.800927, 1.131429, -0.581907},{
      0.904410, 1.131429, -0.402669},{0.904410, 0.848571, -0.402669},{
      0.800927, 0.848571, -0.581907}}],
    Line[{{0.800927, 1.131429, -0.581907},{0.800927, 1.414286, -0.581907},{
      0.904410, 1.414286, -0.402669},{0.904410, 1.131429, -0.402669},{
      0.800927, 1.131429, -0.581907}}],
    Line[{{0.800927, 1.414286, -0.581907},{0.800927, 1.697143, -0.581907},{
      0.904410, 1.697143, -0.402669},{0.904410, 1.414286, -0.402669},{
      0.800927, 1.414286, -0.581907}}],
    Line[{{0.800927, 1.697143, -0.581907},{0.800927, 1.980000, -0.581907},{
      0.904410, 1.980000, -0.402669},{0.904410, 1.697143, -0.402669},{
      0.800927, 1.697143, -0.581907}}],
    Line[{{0.904410, -1.980000, -0.402669},{0.904410, -1.697143, -0.402669},{
      0.968366, -1.697143, -0.205833},{0.968366, -1.980000, -0.205833},{
      0.904410, -1.980000, -0.402669}}],
    Line[{{0.904410, -1.697143, -0.402669},{0.904410, -1.414286, -0.402669},{
      0.968366, -1.414286, -0.205833},{0.968366, -1.697143, -0.205833},{
      0.904410, -1.697143, -0.402669}}],
    Line[{{0.904410, -1.414286, -0.402669},{0.904410, -1.131429, -0.402669},{
      0.968366, -1.131429, -0.205833},{0.968366, -1.414286, -0.205833},{
      0.904410, -1.414286, -0.402669}}],
    Line[{{0.904410, -1.131429, -0.402669},{0.904410, -0.848571, -0.402669},{
      0.968366, -0.848571, -0.205833},{0.968366, -1.131429, -0.205833},{
      0.904410, -1.131429, -0.402669}}],
    Line[{{0.904410, -0.848571, -0.402669},{0.904410, -0.565714, -0.402669},{
      0.968366, -0.565714, -0.205833},{0.968366, -0.848571, -0.205833},{
      0.904410, -0.848571, -0.402669}}],
    Line[{{0.904410, -0.565714, -0.402669},{0.904410, -0.282857, -0.402669},{
      0.968366, -0.282857, -0.205833},{0.968366, -0.565714, -0.205833},{
      0.904410, -0.565714, -0.402669}}],
    Line[{{0.904410, -0.282857, -0.402669},{0.904410, -0.000000, -0.402669},{
      0.968366, -0.000000, -0.205833},{0.968366, -0.282857, -0.205833},{
      0.904410, -0.282857, -0.402669}}],
    Line[{{0.904410, -0.000000, -0.402669},{0.904410, 0.282857, -0.402669},{
      0.968366, 0.282857, -0.205833},{0.968366, -0.000000, -0.205833},{
      0.904410, -0.000000, -0.402669}}],
    Line[{{0.904410, 0.282857, -0.402669},{0.904410, 0.565714, -0.402669},{
      0.968366, 0.565714, -0.205833},{0.968366, 0.282857, -0.205833},{
      0.904410, 0.282857, -0.402669}}],
    Line[{{0.904410, 0.565714, -0.402669},{0.904410, 0.848571, -0.402669},{
      0.968366, 0.848571, -0.205833},{0.968366, 0.565714, -0.205833},{
      0.904410, 0.565714, -0.402669}}],
    Line[{{0.904410, 0.848571, -0.402669},{0.904410, 1.131429, -0.402669},{
      0.968366, 1.131429, -0.205833},{0.968366, 0.848571, -0.205833},{
      0.904410, 0.848571, -0.402669}}],
    Line[{{0.904410, 1.131429, -0.402669},{0.904410, 1.414286, -0.402669},{
      0.968366, 1.414286, -0.205833},{0.968366, 1.131429, -0.205833},{
      0.904410, 1.131429, -0.402669}}],
    Line[{{0.904410, 1.414286, -0.402669},{0.904410, 1.697143, -0.402669},{
      0.968366, 1.697143, -0.205833},{0.968366, 1.414286, -0.205833},{
      0.904410, 1.414286, -0.402669}}],
    Line[{{0.904410, 1.697143, -0.402669},{0.904410, 1.980000, -0.402669},{
      0.968366, 1.980000, -0.205833},{0.968366, 1.697143, -0.205833},{
      0.904410, 1.697143, -0.402669}}],
    Line[{{0.968366, -1.980000, -0.205833},{0.968366, -1.697143, -0.205833},{
      0.990000, -1.697143, -0.000000},{0.990000, -1.980000, -0.000000},{
      0.968366, -1.980000, -0.205833}}],
    Line[{{0.968366, -1.697143, -0.205833},{0.968366, -1.414286, -0.205833},{
      0.990000, -1.414286, -0.000000},{0.990000, -1.697143, -0.000000},{
      0.968366, -1.697143, -0.205833}}],
    Line[{{0.968366, -1.414286, -0.205833},{0.968366, -1.131429, -0.205833},{
      0.990000, -1.131429, -0.000000},{0.990000, -1.414286, -0.000000},{
      0.968366, -1.414286, -0.205833}}],
    Line[{{0.968366, -1.131429, -0.205833},{0.968366, -0.848571, -0.205833},{
      0.990000, -0.848571, -0.000000},{0.990000, -1.131429, -0.000000},{
      0.968366, -1.131429, -0.205833}}],
    Line[{{0.968366, -0.848571, -0.205833},{0.968366, -0.565714, -0.205833},{
      0.990000, -0.565714, -0.000000},{0.990000, -0.848571, -0.000000},{
      0.968366, -0.848571, -0.205833}}],
    Line[{{0.968366, -0.565714, -0.205833},{0.968366, -0.282857, -0.205833},{
      0.990000, -0.282857, -0.000000},{0.990000, -0.565714, -0.000000},{
      0.968366, -0.565714, -0.205833}}],
    Line[{{0.968366, -0.282857, -0.205833},{0.968366, -0.000000, -0.205833},{
      0.990000, -0.000000, -0.000000},{0.990000, -0.282857, -0.000000},{
      0.968366, -0.282857, -0.205833}}],
    Line[{{0.968366, -0.000000, -0.205833},{0.968366, 0.282857, -0.205833},{
      0.990000, 0.282857, -0.000000},{0.990000, -0.000000, -0.000000},{
      0.968366, -0.000000, -0.205833}}],
    Line[{{0.968366, 0.282857, -0.205833},{0.968366, 0.565714, -0.205833},{
      0.990000, 0.565714, -0.000000},{0.990000, 0.282857, -0.000000},{
      0.968366, 0.282857, -0.205833}}],
    Line[{{0.968366, 0.565714, -0.205833},{0.968366, 0.848571, -0.205833},{
      0.990000, 0.848571, -0.000000},{0.990000, 0.565714, -0.000000},{
      0.968366, 0.565714, -0.205833}}],
    Line[{{0.968366, 0.848571, -0.205833},{0.968366, 1.131429, -0.205833},{
      0.990000, 1.131429, -0.000000},{0.990000, 0.848571, -0.000000},{
      0.968366, 0.848571, -0.205833}}],
    Line[{{0.968366, 1.131429, -0.205833},{0.968366, 1.414286, -0.205833},{
      0.990000, 1.414286, -0.000000},{0.990000, 1.131429, -0.000000},{
      0.968366, 1.131429, -0.205833}}],
    Line[{{0.968366, 1.414286, -0.205833},{0.968366, 1.697143, -0.205833},{
      0.990000, 1.697143, -0.000000},{0.990000, 1.414286, -0.000000},{
      0.968366, 1.414286, -0.205833}}],
    Line[{{0.968366, 1.697143, -0.205833},{0.968366, 1.980000, -0.205833},{
      0.990000, 1.980000, -0.000000},{0.990000, 1.697143, -0.000000},{
      0.968366, 1.697143, -0.205833}}],
    Polygon[{{-1.000000, 1.000000, 0.000000},{-0.857143, 1.000000, 
        0.000000},{-0.846590, 0.987688, 0.156434},{-0.987688, 0.987688, 
        0.156434}}],
    Polygon[{{-0.857143, 1.000000, 0.000000},{-0.714286, 1.000000, 
        0.000000},{-0.705492, 0.987688, 0.156434},{-0.846590, 0.987688, 
        0.156434}}],
    Polygon[{{-0.714286, 1.000000, 0.000000},{-0.571429, 1.000000, 
        0.000000},{-0.564393, 0.987688, 0.156434},{-0.705492, 0.987688, 
        0.156434}}],
    Polygon[{{-0.571429, 1.000000, 0.000000},{-0.428571, 1.000000, 
        0.000000},{-0.423295, 0.987688, 0.156434},{-0.564393, 0.987688, 
        0.156434}}],
    Polygon[{{-0.428571, 1.000000, 0.000000},{-0.285714, 1.000000, 
        0.000000},{-0.282197, 0.987688, 0.156434},{-0.423295, 0.987688, 
        0.156434}}],
    Polygon[{{-0.285714, 1.000000, 0.000000},{-0.142857, 1.000000, 
        0.000000},{-0.141098, 0.987688, 0.156434},{-0.282197, 0.987688, 
        0.156434}}],
    Polygon[{{-0.142857, 1.000000, 0.000000},{-0.000000, 1.000000, 
        0.000000},{-0.000000, 0.987688, 0.156434},{-0.141098, 0.987688, 
        0.156434}}],
    Polygon[{{-0.000000, 1.000000, 0.000000},{0.142857, 1.000000, 0.000000},{
      0.141098, 0.987688, 0.156434},{-0.000000, 0.987688, 0.156434}}],
    Polygon[{{0.142857, 1.000000, 0.000000},{0.285714, 1.000000, 0.000000},{
      0.282197, 0.987688, 0.156434},{0.141098, 0.987688, 0.156434}}],
    Polygon[{{0.285714, 1.000000, 0.000000},{0.428571, 1.000000, 0.000000},{
      0.423295, 0.987688, 0.156434},{0.282197, 0.987688, 0.156434}}],
    Polygon[{{0.428571, 1.000000, 0.000000},{0.571429, 1.000000, 0.000000},{
      0.564393, 0.987688, 0.156434},{0.423295, 0.987688, 0.156434}}],
    Polygon[{{0.571429, 1.000000, 0.000000},{0.714286, 1.000000, 0.000000},{
      0.705492, 0.987688, 0.156434},{0.564393, 0.987688, 0.156434}}],
    Polygon[{{0.714286, 1.000000, 0.000000},{0.857143, 1.000000, 0.000000},{
      0.846590, 0.987688, 0.156434},{0.705492, 0.987688, 0.156434}}],
    Polygon[{{0.857143, 1.000000, 0.000000},{1.000000, 1.000000, 0.000000},{
      0.987688, 0.987688, 0.156434},{0.846590, 0.987688, 0.156434}}],
    Polygon[{{-0.987688, 0.987688, 0.156434},{-0.846590, 0.987688, 
        0.156434},{-0.815191, 0.951057, 0.309017},{-0.951057, 0.951057, 
        0.309017}}],
    Polygon[{{-0.846590, 0.987688, 0.156434},{-0.705492, 0.987688, 
        0.156434},{-0.679326, 0.951057, 0.309017},{-0.815191, 0.951057, 
        0.309017}}],
    Polygon[{{-0.705492, 0.987688, 0.156434},{-0.564393, 0.987688, 
        0.156434},{-0.543461, 0.951057, 0.309017},{-0.679326, 0.951057, 
        0.309017}}],
    Polygon[{{-0.564393, 0.987688, 0.156434},{-0.423295, 0.987688, 
        0.156434},{-0.407596, 0.951057, 0.309017},{-0.543461, 0.951057, 
        0.309017}}],
    Polygon[{{-0.423295, 0.987688, 0.156434},{-0.282197, 0.987688, 
        0.156434},{-0.271730, 0.951057, 0.309017},{-0.407596, 0.951057, 
        0.309017}}],
    Polygon[{{-0.282197, 0.987688, 0.156434},{-0.141098, 0.987688, 
        0.156434},{-0.135865, 0.951057, 0.309017},{-0.271730, 0.951057, 
        0.309017}}],
    Polygon[{{-0.141098, 0.987688, 0.156434},{-0.000000, 0.987688, 
        0.156434},{-0.000000, 0.951057, 0.309017},{-0.135865, 0.951057, 
        0.309017}}],
    Polygon[{{-0.000000, 0.987688, 0.156434},{0.141098, 0.987688, 0.156434},{
      0.135865, 0.951057, 0.309017},{-0.000000, 0.951057, 0.309017}}],
    Polygon[{{0.141098, 0.987688, 0.156434},{0.282197, 0.987688, 0.156434},{
      0.271730, 0.951057, 0.309017},{0.135865, 0.951057, 0.309017}}],
    Polygon[{{0.282197, 0.987688, 0.156434},{0.423295, 0.987688, 0.156434},{
      0.407596, 0.951057, 0.309017},{0.271730, 0.951057, 0.309017}}],
    Polygon[{{0.423295, 0.987688, 0.156434},{0.564393, 0.987688, 0.156434},{
      0.543461, 0.951057, 0.309017},{0.407596, 0.951057, 0.309017}}],
    Polygon[{{0.564393, 0.987688, 0.156434},{0.705492, 0.987688, 0.156434},{
      0.679326, 0.951057, 0.309017},{0.543461, 0.951057, 0.309017}}],
    Polygon[{{0.705492, 0.987688, 0.156434},{0.846590, 0.987688, 0.156434},{
      0.815191, 0.951057, 0.309017},{0.679326, 0.951057, 0.309017}}],
    Polygon[{{0.846590, 0.987688, 0.156434},{0.987688, 0.987688, 0.156434},{
      0.951057, 0.951057, 0.309017},{0.815191, 0.951057, 0.309017}}],
    Polygon[{{-0.951057, 0.951057, 0.309017},{-0.815191, 0.951057, 
        0.309017},{-0.763720, 0.891007, 0.453990},{-0.891007, 0.891007, 
        0.453990}}],
    Polygon[{{-0.815191, 0.951057, 0.309017},{-0.679326, 0.951057, 
        0.309017},{-0.636433, 0.891007, 0.453990},{-0.763720, 0.891007, 
        0.453990}}],
    Polygon[{{-0.679326, 0.951057, 0.309017},{-0.543461, 0.951057, 
        0.309017},{-0.509147, 0.891007, 0.453990},{-0.636433, 0.891007, 
        0.453990}}],
    Polygon[{{-0.543461, 0.951057, 0.309017},{-0.407596, 0.951057, 
        0.309017},{-0.381860, 0.891007, 0.453990},{-0.509147, 0.891007, 
        0.453990}}],
    Polygon[{{-0.407596, 0.951057, 0.309017},{-0.271730, 0.951057, 
        0.309017},{-0.254573, 0.891007, 0.453990},{-0.381860, 0.891007, 
        0.453990}}],
    Polygon[{{-0.271730, 0.951057, 0.309017},{-0.135865, 0.951057, 
        0.309017},{-0.127287, 0.891007, 0.453990},{-0.254573, 0.891007, 
        0.453990}}],
    Polygon[{{-0.135865, 0.951057, 0.309017},{-0.000000, 0.951057, 
        0.309017},{-0.000000, 0.891007, 0.453990},{-0.127287, 0.891007, 
        0.453990}}],
    Polygon[{{-0.000000, 0.951057, 0.309017},{0.135865, 0.951057, 0.309017},{
      0.127287, 0.891007, 0.453990},{-0.000000, 0.891007, 0.453990}}],
    Polygon[{{0.135865, 0.951057, 0.309017},{0.271730, 0.951057, 0.309017},{
      0.254573, 0.891007, 0.453990},{0.127287, 0.891007, 0.453990}}],
    Polygon[{{0.271730, 0.951057, 0.309017},{0.407596, 0.951057, 0.309017},{
      0.381860, 0.891007, 0.453990},{0.254573, 0.891007, 0.453990}}],
    Polygon[{{0.407596, 0.951057, 0.309017},{0.543461, 0.951057, 0.309017},{
      0.509147, 0.891007, 0.453990},{0.381860, 0.891007, 0.453990}}],
    Polygon[{{0.543461, 0.951057, 0.309017},{0.679326, 0.951057, 0.309017},{
      0.636433, 0.891007, 0.453990},{0.509147, 0.891007, 0.453990}}],
    Polygon[{{0.679326, 0.951057, 0.309017},{0.815191, 0.951057, 0.309017},{
      0.763720, 0.891007, 0.453990},{0.636433, 0.891007, 0.453990}}],
    Polygon[{{0.815191, 0.951057, 0.309017},{0.951057, 0.951057, 0.309017},{
      0.891007, 0.891007, 0.453990},{0.763720, 0.891007, 0.453990}}],
    Polygon[{{-0.891007, 0.891007, 0.453990},{-0.763720, 0.891007, 
        0.453990},{-0.693443, 0.809017, 0.587785},{-0.809017, 0.809017, 
        0.587785}}],
    Polygon[{{-0.763720, 0.891007, 0.453990},{-0.636433, 0.891007, 
        0.453990},{-0.577869, 0.809017, 0.587785},{-0.693443, 0.809017, 
        0.587785}}],
    Polygon[{{-0.636433, 0.891007, 0.453990},{-0.509147, 0.891007, 
        0.453990},{-0.462295, 0.809017, 0.587785},{-0.577869, 0.809017, 
        0.587785}}],
    Polygon[{{-0.509147, 0.891007, 0.453990},{-0.381860, 0.891007, 
        0.453990},{-0.346722, 0.809017, 0.587785},{-0.462295, 0.809017, 
        0.587785}}],
    Polygon[{{-0.381860, 0.891007, 0.453990},{-0.254573, 0.891007, 
        0.453990},{-0.231148, 0.809017, 0.587785},{-0.346722, 0.809017, 
        0.587785}}],
    Polygon[{{-0.254573, 0.891007, 0.453990},{-0.127287, 0.891007, 
        0.453990},{-0.115574, 0.809017, 0.587785},{-0.231148, 0.809017, 
        0.587785}}],
    Polygon[{{-0.127287, 0.891007, 0.453990},{-0.000000, 0.891007, 
        0.453990},{-0.000000, 0.809017, 0.587785},{-0.115574, 0.809017, 
        0.587785}}],
    Polygon[{{-0.000000, 0.891007, 0.453990},{0.127287, 0.891007, 0.453990},{
      0.115574, 0.809017, 0.587785},{-0.000000, 0.809017, 0.587785}}],
    Polygon[{{0.127287, 0.891007, 0.453990},{0.254573, 0.891007, 0.453990},{
      0.231148, 0.809017, 0.587785},{0.115574, 0.809017, 0.587785}}],
    Polygon[{{0.254573, 0.891007, 0.453990},{0.381860, 0.891007, 0.453990},{
      0.346722, 0.809017, 0.587785},{0.231148, 0.809017, 0.587785}}],
    Polygon[{{0.381860, 0.891007, 0.453990},{0.509147, 0.891007, 0.453990},{
      0.462295, 0.809017, 0.587785},{0.346722, 0.809017, 0.587785}}],
    Polygon[{{0.509147, 0.891007, 0.453990},{0.636433, 0.891007, 0.453990},{
      0.577869, 0.809017, 0.587785},{0.462295, 0.809017, 0.587785}}],
    Polygon[{{0.636433, 0.891007, 0.453990},{0.763720, 0.891007, 0.453990},{
      0.693443, 0.809017, 0.587785},{0.577869, 0.809017, 0.587785}}],
    Polygon[{{0.763720, 0.891007, 0.453990},{0.891007, 0.891007, 0.453990},{
      0.809017, 0.809017, 0.587785},{0.693443, 0.809017, 0.587785}}],
    Polygon[{{-0.809017, 0.809017, 0.587785},{-0.693443, 0.809017, 
        0.587785},{-0.606091, 0.707107, 0.707107},{-0.707107, 0.707107, 
        0.707107}}],
    Polygon[{{-0.693443, 0.809017, 0.587785},{-0.577869, 0.809017, 
        0.587785},{-0.505076, 0.707107, 0.707107},{-0.606091, 0.707107, 
        0.707107}}],
    Polygon[{{-0.577869, 0.809017, 0.587785},{-0.462295, 0.809017, 
        0.587785},{-0.404061, 0.707107, 0.707107},{-0.505076, 0.707107, 
        0.707107}}],
    Polygon[{{-0.462295, 0.809017, 0.587785},{-0.346722, 0.809017, 
        0.587785},{-0.303046, 0.707107, 0.707107},{-0.404061, 0.707107, 
        0.707107}}],
    Polygon[{{-0.346722, 0.809017, 0.587785},{-0.231148, 0.809017, 
        0.587785},{-0.202031, 0.707107, 0.707107},{-0.303046, 0.707107, 
        0.707107}}],
    Polygon[{{-0.231148, 0.809017, 0.587785},{-0.115574, 0.809017, 
        0.587785},{-0.101015, 0.707107, 0.707107},{-0.202031, 0.707107, 
        0.707107}}],
    Polygon[{{-0.115574, 0.809017, 0.587785},{-0.000000, 0.809017, 
        0.587785},{-0.000000, 0.707107, 0.707107},{-0.101015, 0.707107, 
        0.707107}}],
    Polygon[{{-0.000000, 0.809017, 0.587785},{0.115574, 0.809017, 0.587785},{
      0.101015, 0.707107, 0.707107},{-0.000000, 0.707107, 0.707107}}],
    Polygon[{{0.115574, 0.809017, 0.587785},{0.231148, 0.809017, 0.587785},{
      0.202031, 0.707107, 0.707107},{0.101015, 0.707107, 0.707107}}],
    Polygon[{{0.231148, 0.809017, 0.587785},{0.346722, 0.809017, 0.587785},{
      0.303046, 0.707107, 0.707107},{0.202031, 0.707107, 0.707107}}],
    Polygon[{{0.346722, 0.809017, 0.587785},{0.462295, 0.809017, 0.587785},{
      0.404061, 0.707107, 0.707107},{0.303046, 0.707107, 0.707107}}],
    Polygon[{{0.462295, 0.809017, 0.587785},{0.577869, 0.809017, 0.587785},{
      0.505076, 0.707107, 0.707107},{0.404061, 0.707107, 0.707107}}],
    Polygon[{{0.577869, 0.809017, 0.587785},{0.693443, 0.809017, 0.587785},{
      0.606091, 0.707107, 0.707107},{0.505076, 0.707107, 0.707107}}],
    Polygon[{{0.693443, 0.809017, 0.587785},{0.809017, 0.809017, 0.587785},{
      0.707107, 0.707107, 0.707107},{0.606091, 0.707107, 0.707107}}],
    Polygon[{{-0.707107, 0.707107, 0.707107},{-0.606091, 0.707107, 
        0.707107},{-0.503816, 0.587785, 0.809017},{-0.587785, 0.587785, 
        0.809017}}],
    Polygon[{{-0.606091, 0.707107, 0.707107},{-0.505076, 0.707107, 
        0.707107},{-0.419847, 0.587785, 0.809017},{-0.503816, 0.587785, 
        0.809017}}],
    Polygon[{{-0.505076, 0.707107, 0.707107},{-0.404061, 0.707107, 
        0.707107},{-0.335877, 0.587785, 0.809017},{-0.419847, 0.587785, 
        0.809017}}],
    Polygon[{{-0.404061, 0.707107, 0.707107},{-0.303046, 0.707107, 
        0.707107},{-0.251908, 0.587785, 0.809017},{-0.335877, 0.587785, 
        0.809017}}],
    Polygon[{{-0.303046, 0.707107, 0.707107},{-0.202031, 0.707107, 
        0.707107},{-0.167939, 0.587785, 0.809017},{-0.251908, 0.587785, 
        0.809017}}],
    Polygon[{{-0.202031, 0.707107, 0.707107},{-0.101015, 0.707107, 
        0.707107},{-0.083969, 0.587785, 0.809017},{-0.167939, 0.587785, 
        0.809017}}],
    Polygon[{{-0.101015, 0.707107, 0.707107},{-0.000000, 0.707107, 
        0.707107},{-0.000000, 0.587785, 0.809017},{-0.083969, 0.587785, 
        0.809017}}],
    Polygon[{{-0.000000, 0.707107, 0.707107},{0.101015, 0.707107, 0.707107},{
      0.083969, 0.587785, 0.809017},{-0.000000, 0.587785, 0.809017}}],
    Polygon[{{0.101015, 0.707107, 0.707107},{0.202031, 0.707107, 0.707107},{
      0.167939, 0.587785, 0.809017},{0.083969, 0.587785, 0.809017}}],
    Polygon[{{0.202031, 0.707107, 0.707107},{0.303046, 0.707107, 0.707107},{
      0.251908, 0.587785, 0.809017},{0.167939, 0.587785, 0.809017}}],
    Polygon[{{0.303046, 0.707107, 0.707107},{0.404061, 0.707107, 0.707107},{
      0.335877, 0.587785, 0.809017},{0.251908, 0.587785, 0.809017}}],
    Polygon[{{0.404061, 0.707107, 0.707107},{0.505076, 0.707107, 0.707107},{
      0.419847, 0.587785, 0.809017},{0.335877, 0.587785, 0.809017}}],
    Polygon[{{0.505076, 0.707107, 0.707107},{0.606091, 0.707107, 0.707107},{
      0.503816, 0.587785, 0.809017},{0.419847, 0.587785, 0.809017}}],
    Polygon[{{0.606091, 0.707107, 0.707107},{0.707107, 0.707107, 0.707107},{
      0.587785, 0.587785, 0.809017},{0.503816, 0.587785, 0.809017}}],
    Polygon[{{-0.587785, 0.587785, 0.809017},{-0.503816, 0.587785, 
        0.809017},{-0.389135, 0.453990, 0.891007},{-0.453990, 0.453990, 
        0.891007}}],
    Polygon[{{-0.503816, 0.587785, 0.809017},{-0.419847, 0.587785, 
        0.809017},{-0.324279, 0.453990, 0.891007},{-0.389135, 0.453990, 
        0.891007}}],
    Polygon[{{-0.419847, 0.587785, 0.809017},{-0.335877, 0.587785, 
        0.809017},{-0.259423, 0.453990, 0.891007},{-0.324279, 0.453990, 
        0.891007}}],
    Polygon[{{-0.335877, 0.587785, 0.809017},{-0.251908, 0.587785, 
        0.809017},{-0.194567, 0.453990, 0.891007},{-0.259423, 0.453990, 
        0.891007}}],
    Polygon[{{-0.251908, 0.587785, 0.809017},{-0.167939, 0.587785, 
        0.809017},{-0.129712, 0.453990, 0.891007},{-0.194567, 0.453990, 
        0.891007}}],
    Polygon[{{-0.167939, 0.587785, 0.809017},{-0.083969, 0.587785, 
        0.809017},{-0.064856, 0.453990, 0.891007},{-0.129712, 0.453990, 
        0.891007}}],
    Polygon[{{-0.083969, 0.587785, 0.809017},{-0.000000, 0.587785, 
        0.809017},{-0.000000, 0.453990, 0.891007},{-0.064856, 0.453990, 
        0.891007}}],
    Polygon[{{-0.000000, 0.587785, 0.809017},{0.083969, 0.587785, 0.809017},{
      0.064856, 0.453990, 0.891007},{-0.000000, 0.453990, 0.891007}}],
    Polygon[{{0.083969, 0.587785, 0.809017},{0.167939, 0.587785, 0.809017},{
      0.129712, 0.453990, 0.891007},{0.064856, 0.453990, 0.891007}}],
    Polygon[{{0.167939, 0.587785, 0.809017},{0.251908, 0.587785, 0.809017},{
      0.194567, 0.453990, 0.891007},{0.129712, 0.453990, 0.891007}}],
    Polygon[{{0.251908, 0.587785, 0.809017},{0.335877, 0.587785, 0.809017},{
      0.259423, 0.453990, 0.891007},{0.194567, 0.453990, 0.891007}}],
    Polygon[{{0.335877, 0.587785, 0.809017},{0.419847, 0.587785, 0.809017},{
      0.324279, 0.453990, 0.891007},{0.259423, 0.453990, 0.891007}}],
    Polygon[{{0.419847, 0.587785, 0.809017},{0.503816, 0.587785, 0.809017},{
      0.389135, 0.453990, 0.891007},{0.324279, 0.453990, 0.891007}}],
    Polygon[{{0.503816, 0.587785, 0.809017},{0.587785, 0.587785, 0.809017},{
      0.453990, 0.453990, 0.891007},{0.389135, 0.453990, 0.891007}}],
    Polygon[{{-0.453990, 0.453990, 0.891007},{-0.389135, 0.453990, 
        0.891007},{-0.264872, 0.309017, 0.951057},{-0.309017, 0.309017, 
        0.951057}}],
    Polygon[{{-0.389135, 0.453990, 0.891007},{-0.324279, 0.453990, 
        0.891007},{-0.220726, 0.309017, 0.951057},{-0.264872, 0.309017, 
        0.951057}}],
    Polygon[{{-0.324279, 0.453990, 0.891007},{-0.259423, 0.453990, 
        0.891007},{-0.176581, 0.309017, 0.951057},{-0.220726, 0.309017, 
        0.951057}}],
    Polygon[{{-0.259423, 0.453990, 0.891007},{-0.194567, 0.453990, 
        0.891007},{-0.132436, 0.309017, 0.951057},{-0.176581, 0.309017, 
        0.951057}}],
    Polygon[{{-0.194567, 0.453990, 0.891007},{-0.129712, 0.453990, 
        0.891007},{-0.088291, 0.309017, 0.951057},{-0.132436, 0.309017, 
        0.951057}}],
    Polygon[{{-0.129712, 0.453990, 0.891007},{-0.064856, 0.453990, 
        0.891007},{-0.044145, 0.309017, 0.951057},{-0.088291, 0.309017, 
        0.951057}}],
    Polygon[{{-0.064856, 0.453990, 0.891007},{-0.000000, 0.453990, 
        0.891007},{-0.000000, 0.309017, 0.951057},{-0.044145, 0.309017, 
        0.951057}}],
    Polygon[{{-0.000000, 0.453990, 0.891007},{0.064856, 0.453990, 0.891007},{
      0.044145, 0.309017, 0.951057},{-0.000000, 0.309017, 0.951057}}],
    Polygon[{{0.064856, 0.453990, 0.891007},{0.129712, 0.453990, 0.891007},{
      0.088291, 0.309017, 0.951057},{0.044145, 0.309017, 0.951057}}],
    Polygon[{{0.129712, 0.453990, 0.891007},{0.194567, 0.453990, 0.891007},{
      0.132436, 0.309017, 0.951057},{0.088291, 0.309017, 0.951057}}],
    Polygon[{{0.194567, 0.453990, 0.891007},{0.259423, 0.453990, 0.891007},{
      0.176581, 0.309017, 0.951057},{0.132436, 0.309017, 0.951057}}],
    Polygon[{{0.259423, 0.453990, 0.891007},{0.324279, 0.453990, 0.891007},{
      0.220726, 0.309017, 0.951057},{0.176581, 0.309017, 0.951057}}],
    Polygon[{{0.324279, 0.453990, 0.891007},{0.389135, 0.453990, 0.891007},{
      0.264872, 0.309017, 0.951057},{0.220726, 0.309017, 0.951057}}],
    Polygon[{{0.389135, 0.453990, 0.891007},{0.453990, 0.453990, 0.891007},{
      0.309017, 0.309017, 0.951057},{0.264872, 0.309017, 0.951057}}],
    Polygon[{{-0.309017, 0.309017, 0.951057},{-0.264872, 0.309017, 
        0.951057},{-0.134087, 0.156434, 0.987688},{-0.156434, 0.156434, 
        0.987688}}],
    Polygon[{{-0.264872, 0.309017, 0.951057},{-0.220726, 0.309017, 
        0.951057},{-0.111739, 0.156434, 0.987688},{-0.134087, 0.156434, 
        0.987688}}],
    Polygon[{{-0.220726, 0.309017, 0.951057},{-0.176581, 0.309017, 
        0.951057},{-0.089391, 0.156434, 0.987688},{-0.111739, 0.156434, 
        0.987688}}],
    Polygon[{{-0.176581, 0.309017, 0.951057},{-0.132436, 0.309017, 
        0.951057},{-0.067043, 0.156434, 0.987688},{-0.089391, 0.156434, 
        0.987688}}],
    Polygon[{{-0.132436, 0.309017, 0.951057},{-0.088291, 0.309017, 
        0.951057},{-0.044696, 0.156434, 0.987688},{-0.067043, 0.156434, 
        0.987688}}],
    Polygon[{{-0.088291, 0.309017, 0.951057},{-0.044145, 0.309017, 
        0.951057},{-0.022348, 0.156434, 0.987688},{-0.044696, 0.156434, 
        0.987688}}],
    Polygon[{{-0.044145, 0.309017, 0.951057},{-0.000000, 0.309017, 
        0.951057},{-0.000000, 0.156434, 0.987688},{-0.022348, 0.156434, 
        0.987688}}],
    Polygon[{{-0.000000, 0.309017, 0.951057},{0.044145, 0.309017, 0.951057},{
      0.022348, 0.156434, 0.987688},{-0.000000, 0.156434, 0.987688}}],
    Polygon[{{0.044145, 0.309017, 0.951057},{0.088291, 0.309017, 0.951057},{
      0.044696, 0.156434, 0.987688},{0.022348, 0.156434, 0.987688}}],
    Polygon[{{0.088291, 0.309017, 0.951057},{0.132436, 0.309017, 0.951057},{
      0.067043, 0.156434, 0.987688},{0.044696, 0.156434, 0.987688}}],
    Polygon[{{0.132436, 0.309017, 0.951057},{0.176581, 0.309017, 0.951057},{
      0.089391, 0.156434, 0.987688},{0.067043, 0.156434, 0.987688}}],
    Polygon[{{0.176581, 0.309017, 0.951057},{0.220726, 0.309017, 0.951057},{
      0.111739, 0.156434, 0.987688},{0.089391, 0.156434, 0.987688}}],
    Polygon[{{0.220726, 0.309017, 0.951057},{0.264872, 0.309017, 0.951057},{
      0.134087, 0.156434, 0.987688},{0.111739, 0.156434, 0.987688}}],
    Polygon[{{0.264872, 0.309017, 0.951057},{0.309017, 0.309017, 0.951057},{
      0.156434, 0.156434, 0.987688},{0.134087, 0.156434, 0.987688}}],
    Polygon[{{-0.156434, 0.156434, 0.987688},{-0.134087, 0.156434, 
        0.987688},{-0.000000, 0.000000, 1.000000},{-0.000000, 0.000000, 
        1.000000}}],
    Polygon[{{-0.134087, 0.156434, 0.987688},{-0.111739, 0.156434, 
        0.987688},{-0.000000, 0.000000, 1.000000},{-0.000000, 0.000000, 
        1.000000}}],
    Polygon[{{-0.111739, 0.156434, 0.987688},{-0.089391, 0.156434, 
        0.987688},{-0.000000, 0.000000, 1.000000},{-0.000000, 0.000000, 
        1.000000}}],
    Polygon[{{-0.089391, 0.156434, 0.987688},{-0.067043, 0.156434, 
        0.987688},{-0.000000, 0.000000, 1.000000},{-0.000000, 0.000000, 
        1.000000}}],
    Polygon[{{-0.067043, 0.156434, 0.987688},{-0.044696, 0.156434, 
        0.987688},{-0.000000, 0.000000, 1.000000},{-0.000000, 0.000000, 
        1.000000}}],
    Polygon[{{-0.044696, 0.156434, 0.987688},{-0.022348, 0.156434, 
        0.987688},{-0.000000, 0.000000, 1.000000},{-0.000000, 0.000000, 
        1.000000}}],
    Polygon[{{-0.022348, 0.156434, 0.987688},{-0.000000, 0.156434, 
        0.987688},{-0.000000, 0.000000, 1.000000},{-0.000000, 0.000000, 
        1.000000}}],
    Polygon[{{-0.000000, 0.156434, 0.987688},{0.022348, 0.156434, 0.987688},{
      0.000000, 0.000000, 1.000000},{-0.000000, 0.000000, 1.000000}}],
    Polygon[{{0.022348, 0.156434, 0.987688},{0.044696, 0.156434, 0.987688},{
      0.000000, 0.000000, 1.000000},{0.000000, 0.000000, 1.000000}}],
    Polygon[{{0.044696, 0.156434, 0.987688},{0.067043, 0.156434, 0.987688},{
      0.000000, 0.000000, 1.000000},{0.000000, 0.000000, 1.000000}}],
    Polygon[{{0.067043, 0.156434, 0.987688},{0.089391, 0.156434, 0.987688},{
      0.000000, 0.000000, 1.000000},{0.000000, 0.000000, 1.000000}}],
    Polygon[{{0.089391, 0.156434, 0.987688},{0.111739, 0.156434, 0.987688},{
      0.000000, 0.000000, 1.000000},{0.000000, 0.000000, 1.000000}}],
    Polygon[{{0.111739, 0.156434, 0.987688},{0.134087, 0.156434, 0.987688},{
      0.000000, 0.000000, 1.000000},{0.000000, 0.000000, 1.000000}}],
    Polygon[{{0.134087, 0.156434, 0.987688},{0.156434, 0.156434, 0.987688},{
      0.000000, 0.000000, 1.000000},{0.000000, 0.000000, 1.000000}}],
    Polygon[{{-0.000000, 0.000000, 1.000000},{-0.000000, 0.000000, 1.000000},{
      0.134087, -0.156434, 0.987688},{0.156434, -0.156434, 0.987688}}],
    Polygon[{{-0.000000, 0.000000, 1.000000},{-0.000000, 0.000000, 1.000000},{
      0.111739, -0.156434, 0.987688},{0.134087, -0.156434, 0.987688}}],
    Polygon[{{-0.000000, 0.000000, 1.000000},{-0.000000, 0.000000, 1.000000},{
      0.089391, -0.156434, 0.987688},{0.111739, -0.156434, 0.987688}}],
    Polygon[{{-0.000000, 0.000000, 1.000000},{-0.000000, 0.000000, 1.000000},{
      0.067043, -0.156434, 0.987688},{0.089391, -0.156434, 0.987688}}],
    Polygon[{{-0.000000, 0.000000, 1.000000},{-0.000000, 0.000000, 1.000000},{
      0.044696, -0.156434, 0.987688},{0.067043, -0.156434, 0.987688}}],
    Polygon[{{-0.000000, 0.000000, 1.000000},{-0.000000, 0.000000, 1.000000},{
      0.022348, -0.156434, 0.987688},{0.044696, -0.156434, 0.987688}}],
    Polygon[{{-0.000000, 0.000000, 1.000000},{-0.000000, 0.000000, 1.000000},{
      0.000000, -0.156434, 0.987688},{0.022348, -0.156434, 0.987688}}],
    Polygon[{{-0.000000, 0.000000, 1.000000},{
      0.000000, 0.000000, 1.000000},{-0.022348, -0.156434, 0.987688},{
      0.000000, -0.156434, 0.987688}}],
    Polygon[{{0.000000, 0.000000, 1.000000},{
      0.000000, 0.000000, 1.000000},{-0.044696, -0.156434, 
        0.987688},{-0.022348, -0.156434, 0.987688}}],
    Polygon[{{0.000000, 0.000000, 1.000000},{
      0.000000, 0.000000, 1.000000},{-0.067043, -0.156434, 
        0.987688},{-0.044696, -0.156434, 0.987688}}],
    Polygon[{{0.000000, 0.000000, 1.000000},{
      0.000000, 0.000000, 1.000000},{-0.089391, -0.156434, 
        0.987688},{-0.067043, -0.156434, 0.987688}}],
    Polygon[{{0.000000, 0.000000, 1.000000},{
      0.000000, 0.000000, 1.000000},{-0.111739, -0.156434, 
        0.987688},{-0.089391, -0.156434, 0.987688}}],
    Polygon[{{0.000000, 0.000000, 1.000000},{
      0.000000, 0.000000, 1.000000},{-0.134087, -0.156434, 
        0.987688},{-0.111739, -0.156434, 0.987688}}],
    Polygon[{{0.000000, 0.000000, 1.000000},{
      0.000000, 0.000000, 1.000000},{-0.156434, -0.156434, 
        0.987688},{-0.134087, -0.156434, 0.987688}}],
    Polygon[{{0.156434, -0.156434, 0.987688},{0.134087, -0.156434, 0.987688},{
      0.264872, -0.309017, 0.951057},{0.309017, -0.309017, 0.951057}}],
    Polygon[{{0.134087, -0.156434, 0.987688},{0.111739, -0.156434, 0.987688},{
      0.220726, -0.309017, 0.951057},{0.264872, -0.309017, 0.951057}}],
    Polygon[{{0.111739, -0.156434, 0.987688},{0.089391, -0.156434, 0.987688},{
      0.176581, -0.309017, 0.951057},{0.220726, -0.309017, 0.951057}}],
    Polygon[{{0.089391, -0.156434, 0.987688},{0.067043, -0.156434, 0.987688},{
      0.132436, -0.309017, 0.951057},{0.176581, -0.309017, 0.951057}}],
    Polygon[{{0.067043, -0.156434, 0.987688},{0.044696, -0.156434, 0.987688},{
      0.088291, -0.309017, 0.951057},{0.132436, -0.309017, 0.951057}}],
    Polygon[{{0.044696, -0.156434, 0.987688},{0.022348, -0.156434, 0.987688},{
      0.044145, -0.309017, 0.951057},{0.088291, -0.309017, 0.951057}}],
    Polygon[{{0.022348, -0.156434, 0.987688},{0.000000, -0.156434, 0.987688},{
      0.000000, -0.309017, 0.951057},{0.044145, -0.309017, 0.951057}}],
    Polygon[{{
      0.000000, -0.156434, 0.987688},{-0.022348, -0.156434, 
        0.987688},{-0.044145, -0.309017, 0.951057},{
      0.000000, -0.309017, 0.951057}}],
    Polygon[{{-0.022348, -0.156434, 0.987688},{-0.044696, -0.156434, 
        0.987688},{-0.088291, -0.309017, 0.951057},{-0.044145, -0.309017, 
        0.951057}}],
    Polygon[{{-0.044696, -0.156434, 0.987688},{-0.067043, -0.156434, 
        0.987688},{-0.132436, -0.309017, 0.951057},{-0.088291, -0.309017, 
        0.951057}}],
    Polygon[{{-0.067043, -0.156434, 0.987688},{-0.089391, -0.156434, 
        0.987688},{-0.176581, -0.309017, 0.951057},{-0.132436, -0.309017, 
        0.951057}}],
    Polygon[{{-0.089391, -0.156434, 0.987688},{-0.111739, -0.156434, 
        0.987688},{-0.220726, -0.309017, 0.951057},{-0.176581, -0.309017, 
        0.951057}}],
    Polygon[{{-0.111739, -0.156434, 0.987688},{-0.134087, -0.156434, 
        0.987688},{-0.264872, -0.309017, 0.951057},{-0.220726, -0.309017, 
        0.951057}}],
    Polygon[{{-0.134087, -0.156434, 0.987688},{-0.156434, -0.156434, 
        0.987688},{-0.309017, -0.309017, 0.951057},{-0.264872, -0.309017, 
        0.951057}}],
    Polygon[{{0.309017, -0.309017, 0.951057},{0.264872, -0.309017, 0.951057},{
      0.389135, -0.453990, 0.891007},{0.453990, -0.453990, 0.891007}}],
    Polygon[{{0.264872, -0.309017, 0.951057},{0.220726, -0.309017, 0.951057},{
      0.324279, -0.453990, 0.891007},{0.389135, -0.453990, 0.891007}}],
    Polygon[{{0.220726, -0.309017, 0.951057},{0.176581, -0.309017, 0.951057},{
      0.259423, -0.453990, 0.891007},{0.324279, -0.453990, 0.891007}}],
    Polygon[{{0.176581, -0.309017, 0.951057},{0.132436, -0.309017, 0.951057},{
      0.194567, -0.453990, 0.891007},{0.259423, -0.453990, 0.891007}}],
    Polygon[{{0.132436, -0.309017, 0.951057},{0.088291, -0.309017, 0.951057},{
      0.129712, -0.453990, 0.891007},{0.194567, -0.453990, 0.891007}}],
    Polygon[{{0.088291, -0.309017, 0.951057},{0.044145, -0.309017, 0.951057},{
      0.064856, -0.453990, 0.891007},{0.129712, -0.453990, 0.891007}}],
    Polygon[{{0.044145, -0.309017, 0.951057},{0.000000, -0.309017, 0.951057},{
      0.000000, -0.453990, 0.891007},{0.064856, -0.453990, 0.891007}}],
    Polygon[{{
      0.000000, -0.309017, 0.951057},{-0.044145, -0.309017, 
        0.951057},{-0.064856, -0.453990, 0.891007},{
      0.000000, -0.453990, 0.891007}}],
    Polygon[{{-0.044145, -0.309017, 0.951057},{-0.088291, -0.309017, 
        0.951057},{-0.129712, -0.453990, 0.891007},{-0.064856, -0.453990, 
        0.891007}}],
    Polygon[{{-0.088291, -0.309017, 0.951057},{-0.132436, -0.309017, 
        0.951057},{-0.194567, -0.453990, 0.891007},{-0.129712, -0.453990, 
        0.891007}}],
    Polygon[{{-0.132436, -0.309017, 0.951057},{-0.176581, -0.309017, 
        0.951057},{-0.259423, -0.453990, 0.891007},{-0.194567, -0.453990, 
        0.891007}}],
    Polygon[{{-0.176581, -0.309017, 0.951057},{-0.220726, -0.309017, 
        0.951057},{-0.324279, -0.453990, 0.891007},{-0.259423, -0.453990, 
        0.891007}}],
    Polygon[{{-0.220726, -0.309017, 0.951057},{-0.264872, -0.309017, 
        0.951057},{-0.389135, -0.453990, 0.891007},{-0.324279, -0.453990, 
        0.891007}}],
    Polygon[{{-0.264872, -0.309017, 0.951057},{-0.309017, -0.309017, 
        0.951057},{-0.453990, -0.453990, 0.891007},{-0.389135, -0.453990, 
        0.891007}}],
    Polygon[{{0.453990, -0.453990, 0.891007},{0.389135, -0.453990, 0.891007},{
      0.503816, -0.587785, 0.809017},{0.587785, -0.587785, 0.809017}}],
    Polygon[{{0.389135, -0.453990, 0.891007},{0.324279, -0.453990, 0.891007},{
      0.419847, -0.587785, 0.809017},{0.503816, -0.587785, 0.809017}}],
    Polygon[{{0.324279, -0.453990, 0.891007},{0.259423, -0.453990, 0.891007},{
      0.335877, -0.587785, 0.809017},{0.419847, -0.587785, 0.809017}}],
    Polygon[{{0.259423, -0.453990, 0.891007},{0.194567, -0.453990, 0.891007},{
      0.251908, -0.587785, 0.809017},{0.335877, -0.587785, 0.809017}}],
    Polygon[{{0.194567, -0.453990, 0.891007},{0.129712, -0.453990, 0.891007},{
      0.167939, -0.587785, 0.809017},{0.251908, -0.587785, 0.809017}}],
    Polygon[{{0.129712, -0.453990, 0.891007},{0.064856, -0.453990, 0.891007},{
      0.083969, -0.587785, 0.809017},{0.167939, -0.587785, 0.809017}}],
    Polygon[{{0.064856, -0.453990, 0.891007},{0.000000, -0.453990, 0.891007},{
      0.000000, -0.587785, 0.809017},{0.083969, -0.587785, 0.809017}}],
    Polygon[{{
      0.000000, -0.453990, 0.891007},{-0.064856, -0.453990, 
        0.891007},{-0.083969, -0.587785, 0.809017},{
      0.000000, -0.587785, 0.809017}}],
    Polygon[{{-0.064856, -0.453990, 0.891007},{-0.129712, -0.453990, 
        0.891007},{-0.167939, -0.587785, 0.809017},{-0.083969, -0.587785, 
        0.809017}}],
    Polygon[{{-0.129712, -0.453990, 0.891007},{-0.194567, -0.453990, 
        0.891007},{-0.251908, -0.587785, 0.809017},{-0.167939, -0.587785, 
        0.809017}}],
    Polygon[{{-0.194567, -0.453990, 0.891007},{-0.259423, -0.453990, 
        0.891007},{-0.335877, -0.587785, 0.809017},{-0.251908, -0.587785, 
        0.809017}}],
    Polygon[{{-0.259423, -0.453990, 0.891007},{-0.324279, -0.453990, 
        0.891007},{-0.419847, -0.587785, 0.809017},{-0.335877, -0.587785, 
        0.809017}}],
    Polygon[{{-0.324279, -0.453990, 0.891007},{-0.389135, -0.453990, 
        0.891007},{-0.503816, -0.587785, 0.809017},{-0.419847, -0.587785, 
        0.809017}}],
    Polygon[{{-0.389135, -0.453990, 0.891007},{-0.453990, -0.453990, 
        0.891007},{-0.587785, -0.587785, 0.809017},{-0.503816, -0.587785, 
        0.809017}}],
    Polygon[{{0.587785, -0.587785, 0.809017},{0.503816, -0.587785, 0.809017},{
      0.606091, -0.707107, 0.707107},{0.707107, -0.707107, 0.707107}}],
    Polygon[{{0.503816, -0.587785, 0.809017},{0.419847, -0.587785, 0.809017},{
      0.505076, -0.707107, 0.707107},{0.606091, -0.707107, 0.707107}}],
    Polygon[{{0.419847, -0.587785, 0.809017},{0.335877, -0.587785, 0.809017},{
      0.404061, -0.707107, 0.707107},{0.505076, -0.707107, 0.707107}}],
    Polygon[{{0.335877, -0.587785, 0.809017},{0.251908, -0.587785, 0.809017},{
      0.303046, -0.707107, 0.707107},{0.404061, -0.707107, 0.707107}}],
    Polygon[{{0.251908, -0.587785, 0.809017},{0.167939, -0.587785, 0.809017},{
      0.202031, -0.707107, 0.707107},{0.303046, -0.707107, 0.707107}}],
    Polygon[{{0.167939, -0.587785, 0.809017},{0.083969, -0.587785, 0.809017},{
      0.101015, -0.707107, 0.707107},{0.202031, -0.707107, 0.707107}}],
    Polygon[{{0.083969, -0.587785, 0.809017},{0.000000, -0.587785, 0.809017},{
      0.000000, -0.707107, 0.707107},{0.101015, -0.707107, 0.707107}}],
    Polygon[{{
      0.000000, -0.587785, 0.809017},{-0.083969, -0.587785, 
        0.809017},{-0.101015, -0.707107, 0.707107},{
      0.000000, -0.707107, 0.707107}}],
    Polygon[{{-0.083969, -0.587785, 0.809017},{-0.167939, -0.587785, 
        0.809017},{-0.202031, -0.707107, 0.707107},{-0.101015, -0.707107, 
        0.707107}}],
    Polygon[{{-0.167939, -0.587785, 0.809017},{-0.251908, -0.587785, 
        0.809017},{-0.303046, -0.707107, 0.707107},{-0.202031, -0.707107, 
        0.707107}}],
    Polygon[{{-0.251908, -0.587785, 0.809017},{-0.335877, -0.587785, 
        0.809017},{-0.404061, -0.707107, 0.707107},{-0.303046, -0.707107, 
        0.707107}}],
    Polygon[{{-0.335877, -0.587785, 0.809017},{-0.419847, -0.587785, 
        0.809017},{-0.505076, -0.707107, 0.707107},{-0.404061, -0.707107, 
        0.707107}}],
    Polygon[{{-0.419847, -0.587785, 0.809017},{-0.503816, -0.587785, 
        0.809017},{-0.606091, -0.707107, 0.707107},{-0.505076, -0.707107, 
        0.707107}}],
    Polygon[{{-0.503816, -0.587785, 0.809017},{-0.587785, -0.587785, 
        0.809017},{-0.707107, -0.707107, 0.707107},{-0.606091, -0.707107, 
        0.707107}}],
    Polygon[{{0.707107, -0.707107, 0.707107},{0.606091, -0.707107, 0.707107},{
      0.693443, -0.809017, 0.587785},{0.809017, -0.809017, 0.587785}}],
    Polygon[{{0.606091, -0.707107, 0.707107},{0.505076, -0.707107, 0.707107},{
      0.577869, -0.809017, 0.587785},{0.693443, -0.809017, 0.587785}}],
    Polygon[{{0.505076, -0.707107, 0.707107},{0.404061, -0.707107, 0.707107},{
      0.462295, -0.809017, 0.587785},{0.577869, -0.809017, 0.587785}}],
    Polygon[{{0.404061, -0.707107, 0.707107},{0.303046, -0.707107, 0.707107},{
      0.346722, -0.809017, 0.587785},{0.462295, -0.809017, 0.587785}}],
    Polygon[{{0.303046, -0.707107, 0.707107},{0.202031, -0.707107, 0.707107},{
      0.231148, -0.809017, 0.587785},{0.346722, -0.809017, 0.587785}}],
    Polygon[{{0.202031, -0.707107, 0.707107},{0.101015, -0.707107, 0.707107},{
      0.115574, -0.809017, 0.587785},{0.231148, -0.809017, 0.587785}}],
    Polygon[{{0.101015, -0.707107, 0.707107},{0.000000, -0.707107, 0.707107},{
      0.000000, -0.809017, 0.587785},{0.115574, -0.809017, 0.587785}}],
    Polygon[{{
      0.000000, -0.707107, 0.707107},{-0.101015, -0.707107, 
        0.707107},{-0.115574, -0.809017, 0.587785},{
      0.000000, -0.809017, 0.587785}}],
    Polygon[{{-0.101015, -0.707107, 0.707107},{-0.202031, -0.707107, 
        0.707107},{-0.231148, -0.809017, 0.587785},{-0.115574, -0.809017, 
        0.587785}}],
    Polygon[{{-0.202031, -0.707107, 0.707107},{-0.303046, -0.707107, 
        0.707107},{-0.346722, -0.809017, 0.587785},{-0.231148, -0.809017, 
        0.587785}}],
    Polygon[{{-0.303046, -0.707107, 0.707107},{-0.404061, -0.707107, 
        0.707107},{-0.462295, -0.809017, 0.587785},{-0.346722, -0.809017, 
        0.587785}}],
    Polygon[{{-0.404061, -0.707107, 0.707107},{-0.505076, -0.707107, 
        0.707107},{-0.577869, -0.809017, 0.587785},{-0.462295, -0.809017, 
        0.587785}}],
    Polygon[{{-0.505076, -0.707107, 0.707107},{-0.606091, -0.707107, 
        0.707107},{-0.693443, -0.809017, 0.587785},{-0.577869, -0.809017, 
        0.587785}}],
    Polygon[{{-0.606091, -0.707107, 0.707107},{-0.707107, -0.707107, 
        0.707107},{-0.809017, -0.809017, 0.587785},{-0.693443, -0.809017, 
        0.587785}}],
    Polygon[{{0.809017, -0.809017, 0.587785},{0.693443, -0.809017, 0.587785},{
      0.763720, -0.891007, 0.453990},{0.891007, -0.891007, 0.453990}}],
    Polygon[{{0.693443, -0.809017, 0.587785},{0.577869, -0.809017, 0.587785},{
      0.636433, -0.891007, 0.453990},{0.763720, -0.891007, 0.453990}}],
    Polygon[{{0.577869, -0.809017, 0.587785},{0.462295, -0.809017, 0.587785},{
      0.509147, -0.891007, 0.453990},{0.636433, -0.891007, 0.453990}}],
    Polygon[{{0.462295, -0.809017, 0.587785},{0.346722, -0.809017, 0.587785},{
      0.381860, -0.891007, 0.453990},{0.509147, -0.891007, 0.453990}}],
    Polygon[{{0.346722, -0.809017, 0.587785},{0.231148, -0.809017, 0.587785},{
      0.254573, -0.891007, 0.453990},{0.381860, -0.891007, 0.453990}}],
    Polygon[{{0.231148, -0.809017, 0.587785},{0.115574, -0.809017, 0.587785},{
      0.127287, -0.891007, 0.453990},{0.254573, -0.891007, 0.453990}}],
    Polygon[{{0.115574, -0.809017, 0.587785},{0.000000, -0.809017, 0.587785},{
      0.000000, -0.891007, 0.453990},{0.127287, -0.891007, 0.453990}}],
    Polygon[{{
      0.000000, -0.809017, 0.587785},{-0.115574, -0.809017, 
        0.587785},{-0.127287, -0.891007, 0.453990},{
      0.000000, -0.891007, 0.453990}}],
    Polygon[{{-0.115574, -0.809017, 0.587785},{-0.231148, -0.809017, 
        0.587785},{-0.254573, -0.891007, 0.453990},{-0.127287, -0.891007, 
        0.453990}}],
    Polygon[{{-0.231148, -0.809017, 0.587785},{-0.346722, -0.809017, 
        0.587785},{-0.381860, -0.891007, 0.453990},{-0.254573, -0.891007, 
        0.453990}}],
    Polygon[{{-0.346722, -0.809017, 0.587785},{-0.462295, -0.809017, 
        0.587785},{-0.509147, -0.891007, 0.453990},{-0.381860, -0.891007, 
        0.453990}}],
    Polygon[{{-0.462295, -0.809017, 0.587785},{-0.577869, -0.809017, 
        0.587785},{-0.636433, -0.891007, 0.453990},{-0.509147, -0.891007, 
        0.453990}}],
    Polygon[{{-0.577869, -0.809017, 0.587785},{-0.693443, -0.809017, 
        0.587785},{-0.763720, -0.891007, 0.453990},{-0.636433, -0.891007, 
        0.453990}}],
    Polygon[{{-0.693443, -0.809017, 0.587785},{-0.809017, -0.809017, 
        0.587785},{-0.891007, -0.891007, 0.453990},{-0.763720, -0.891007, 
        0.453990}}],
    Polygon[{{0.891007, -0.891007, 0.453990},{0.763720, -0.891007, 0.453990},{
      0.815191, -0.951057, 0.309017},{0.951057, -0.951057, 0.309017}}],
    Polygon[{{0.763720, -0.891007, 0.453990},{0.636433, -0.891007, 0.453990},{
      0.679326, -0.951057, 0.309017},{0.815191, -0.951057, 0.309017}}],
    Polygon[{{0.636433, -0.891007, 0.453990},{0.509147, -0.891007, 0.453990},{
      0.543461, -0.951057, 0.309017},{0.679326, -0.951057, 0.309017}}],
    Polygon[{{0.509147, -0.891007, 0.453990},{0.381860, -0.891007, 0.453990},{
      0.407596, -0.951057, 0.309017},{0.543461, -0.951057, 0.309017}}],
    Polygon[{{0.381860, -0.891007, 0.453990},{0.254573, -0.891007, 0.453990},{
      0.271730, -0.951057, 0.309017},{0.407596, -0.951057, 0.309017}}],
    Polygon[{{0.254573, -0.891007, 0.453990},{0.127287, -0.891007, 0.453990},{
      0.135865, -0.951057, 0.309017},{0.271730, -0.951057, 0.309017}}],
    Polygon[{{0.127287, -0.891007, 0.453990},{0.000000, -0.891007, 0.453990},{
      0.000000, -0.951057, 0.309017},{0.135865, -0.951057, 0.309017}}],
    Polygon[{{
      0.000000, -0.891007, 0.453990},{-0.127287, -0.891007, 
        0.453990},{-0.135865, -0.951057, 0.309017},{
      0.000000, -0.951057, 0.309017}}],
    Polygon[{{-0.127287, -0.891007, 0.453990},{-0.254573, -0.891007, 
        0.453990},{-0.271730, -0.951057, 0.309017},{-0.135865, -0.951057, 
        0.309017}}],
    Polygon[{{-0.254573, -0.891007, 0.453990},{-0.381860, -0.891007, 
        0.453990},{-0.407596, -0.951057, 0.309017},{-0.271730, -0.951057, 
        0.309017}}],
    Polygon[{{-0.381860, -0.891007, 0.453990},{-0.509147, -0.891007, 
        0.453990},{-0.543461, -0.951057, 0.309017},{-0.407596, -0.951057, 
        0.309017}}],
    Polygon[{{-0.509147, -0.891007, 0.453990},{-0.636433, -0.891007, 
        0.453990},{-0.679326, -0.951057, 0.309017},{-0.543461, -0.951057, 
        0.309017}}],
    Polygon[{{-0.636433, -0.891007, 0.453990},{-0.763720, -0.891007, 
        0.453990},{-0.815191, -0.951057, 0.309017},{-0.679326, -0.951057, 
        0.309017}}],
    Polygon[{{-0.763720, -0.891007, 0.453990},{-0.891007, -0.891007, 
        0.453990},{-0.951057, -0.951057, 0.309017},{-0.815191, -0.951057, 
        0.309017}}],
    Polygon[{{0.951057, -0.951057, 0.309017},{0.815191, -0.951057, 0.309017},{
      0.846590, -0.987688, 0.156434},{0.987688, -0.987688, 0.156434}}],
    Polygon[{{0.815191, -0.951057, 0.309017},{0.679326, -0.951057, 0.309017},{
      0.705492, -0.987688, 0.156434},{0.846590, -0.987688, 0.156434}}],
    Polygon[{{0.679326, -0.951057, 0.309017},{0.543461, -0.951057, 0.309017},{
      0.564393, -0.987688, 0.156434},{0.705492, -0.987688, 0.156434}}],
    Polygon[{{0.543461, -0.951057, 0.309017},{0.407596, -0.951057, 0.309017},{
      0.423295, -0.987688, 0.156434},{0.564393, -0.987688, 0.156434}}],
    Polygon[{{0.407596, -0.951057, 0.309017},{0.271730, -0.951057, 0.309017},{
      0.282197, -0.987688, 0.156434},{0.423295, -0.987688, 0.156434}}],
    Polygon[{{0.271730, -0.951057, 0.309017},{0.135865, -0.951057, 0.309017},{
      0.141098, -0.987688, 0.156434},{0.282197, -0.987688, 0.156434}}],
    Polygon[{{0.135865, -0.951057, 0.309017},{0.000000, -0.951057, 0.309017},{
      0.000000, -0.987688, 0.156434},{0.141098, -0.987688, 0.156434}}],
    Polygon[{{
      0.000000, -0.951057, 0.309017},{-0.135865, -0.951057, 
        0.309017},{-0.141098, -0.987688, 0.156434},{
      0.000000, -0.987688, 0.156434}}],
    Polygon[{{-0.135865, -0.951057, 0.309017},{-0.271730, -0.951057, 
        0.309017},{-0.282197, -0.987688, 0.156434},{-0.141098, -0.987688, 
        0.156434}}],
    Polygon[{{-0.271730, -0.951057, 0.309017},{-0.407596, -0.951057, 
        0.309017},{-0.423295, -0.987688, 0.156434},{-0.282197, -0.987688, 
        0.156434}}],
    Polygon[{{-0.407596, -0.951057, 0.309017},{-0.543461, -0.951057, 
        0.309017},{-0.564393, -0.987688, 0.156434},{-0.423295, -0.987688, 
        0.156434}}],
    Polygon[{{-0.543461, -0.951057, 0.309017},{-0.679326, -0.951057, 
        0.309017},{-0.705492, -0.987688, 0.156434},{-0.564393, -0.987688, 
        0.156434}}],
    Polygon[{{-0.679326, -0.951057, 0.309017},{-0.815191, -0.951057, 
        0.309017},{-0.846590, -0.987688, 0.156434},{-0.705492, -0.987688, 
        0.156434}}],
    Polygon[{{-0.815191, -0.951057, 0.309017},{-0.951057, -0.951057, 
        0.309017},{-0.987688, -0.987688, 0.156434},{-0.846590, -0.987688, 
        0.156434}}],
    Polygon[{{0.987688, -0.987688, 0.156434},{0.846590, -0.987688, 0.156434},{
      0.857143, -1.000000, 0.000000},{1.000000, -1.000000, 0.000000}}],
    Polygon[{{0.846590, -0.987688, 0.156434},{0.705492, -0.987688, 0.156434},{
      0.714286, -1.000000, 0.000000},{0.857143, -1.000000, 0.000000}}],
    Polygon[{{0.705492, -0.987688, 0.156434},{0.564393, -0.987688, 0.156434},{
      0.571429, -1.000000, 0.000000},{0.714286, -1.000000, 0.000000}}],
    Polygon[{{0.564393, -0.987688, 0.156434},{0.423295, -0.987688, 0.156434},{
      0.428571, -1.000000, 0.000000},{0.571429, -1.000000, 0.000000}}],
    Polygon[{{0.423295, -0.987688, 0.156434},{0.282197, -0.987688, 0.156434},{
      0.285714, -1.000000, 0.000000},{0.428571, -1.000000, 0.000000}}],
    Polygon[{{0.282197, -0.987688, 0.156434},{0.141098, -0.987688, 0.156434},{
      0.142857, -1.000000, 0.000000},{0.285714, -1.000000, 0.000000}}],
    Polygon[{{0.141098, -0.987688, 0.156434},{0.000000, -0.987688, 0.156434},{
      0.000000, -1.000000, 0.000000},{0.142857, -1.000000, 0.000000}}],
    Polygon[{{
      0.000000, -0.987688, 0.156434},{-0.141098, -0.987688, 
        0.156434},{-0.142857, -1.000000, 0.000000},{
      0.000000, -1.000000, 0.000000}}],
    Polygon[{{-0.141098, -0.987688, 0.156434},{-0.282197, -0.987688, 
        0.156434},{-0.285714, -1.000000, 0.000000},{-0.142857, -1.000000, 
        0.000000}}],
    Polygon[{{-0.282197, -0.987688, 0.156434},{-0.423295, -0.987688, 
        0.156434},{-0.428571, -1.000000, 0.000000},{-0.285714, -1.000000, 
        0.000000}}],
    Polygon[{{-0.423295, -0.987688, 0.156434},{-0.564393, -0.987688, 
        0.156434},{-0.571429, -1.000000, 0.000000},{-0.428571, -1.000000, 
        0.000000}}],
    Polygon[{{-0.564393, -0.987688, 0.156434},{-0.705492, -0.987688, 
        0.156434},{-0.714286, -1.000000, 0.000000},{-0.571429, -1.000000, 
        0.000000}}],
    Polygon[{{-0.705492, -0.987688, 0.156434},{-0.846590, -0.987688, 
        0.156434},{-0.857143, -1.000000, 0.000000},{-0.714286, -1.000000, 
        0.000000}}],
    Polygon[{{-0.846590, -0.987688, 0.156434},{-0.987688, -0.987688, 
        0.156434},{-1.000000, -1.000000, 0.000000},{-0.857143, -1.000000, 
        0.000000}}],
    Polygon[{{1.000000, -1.000000, 0.000000},{0.857143, -1.000000, 0.000000},{
      0.846590, -0.987688, -0.156434},{0.987688, -0.987688, -0.156434}}],
    Polygon[{{0.857143, -1.000000, 0.000000},{0.714286, -1.000000, 0.000000},{
      0.705492, -0.987688, -0.156434},{0.846590, -0.987688, -0.156434}}],
    Polygon[{{0.714286, -1.000000, 0.000000},{0.571429, -1.000000, 0.000000},{
      0.564393, -0.987688, -0.156434},{0.705492, -0.987688, -0.156434}}],
    Polygon[{{0.571429, -1.000000, 0.000000},{0.428571, -1.000000, 0.000000},{
      0.423295, -0.987688, -0.156434},{0.564393, -0.987688, -0.156434}}],
    Polygon[{{0.428571, -1.000000, 0.000000},{0.285714, -1.000000, 0.000000},{
      0.282197, -0.987688, -0.156434},{0.423295, -0.987688, -0.156434}}],
    Polygon[{{0.285714, -1.000000, 0.000000},{0.142857, -1.000000, 0.000000},{
      0.141098, -0.987688, -0.156434},{0.282197, -0.987688, -0.156434}}],
    Polygon[{{0.142857, -1.000000, 0.000000},{0.000000, -1.000000, 0.000000},{
      0.000000, -0.987688, -0.156434},{0.141098, -0.987688, -0.156434}}],
    Polygon[{{
      0.000000, -1.000000, 0.000000},{-0.142857, -1.000000, 
        0.000000},{-0.141098, -0.987688, -0.156434},{
      0.000000, -0.987688, -0.156434}}],
    Polygon[{{-0.142857, -1.000000, 0.000000},{-0.285714, -1.000000, 
        0.000000},{-0.282197, -0.987688, -0.156434},{-0.141098, -0.987688, \
-0.156434}}],
    Polygon[{{-0.285714, -1.000000, 0.000000},{-0.428571, -1.000000, 
        0.000000},{-0.423295, -0.987688, -0.156434},{-0.282197, -0.987688, \
-0.156434}}],
    Polygon[{{-0.428571, -1.000000, 0.000000},{-0.571429, -1.000000, 
        0.000000},{-0.564393, -0.987688, -0.156434},{-0.423295, -0.987688, \
-0.156434}}],
    Polygon[{{-0.571429, -1.000000, 0.000000},{-0.714286, -1.000000, 
        0.000000},{-0.705492, -0.987688, -0.156434},{-0.564393, -0.987688, \
-0.156434}}],
    Polygon[{{-0.714286, -1.000000, 0.000000},{-0.857143, -1.000000, 
        0.000000},{-0.846590, -0.987688, -0.156434},{-0.705492, -0.987688, \
-0.156434}}],
    Polygon[{{-0.857143, -1.000000, 0.000000},{-1.000000, -1.000000, 
        0.000000},{-0.987688, -0.987688, -0.156434},{-0.846590, -0.987688, \
-0.156434}}],
    Polygon[{{0.987688, -0.987688, -0.156434},{
      0.846590, -0.987688, -0.156434},{0.815191, -0.951057, -0.309017},{
      0.951057, -0.951057, -0.309017}}],
    Polygon[{{0.846590, -0.987688, -0.156434},{
      0.705492, -0.987688, -0.156434},{0.679326, -0.951057, -0.309017},{
      0.815191, -0.951057, -0.309017}}],
    Polygon[{{0.705492, -0.987688, -0.156434},{
      0.564393, -0.987688, -0.156434},{0.543461, -0.951057, -0.309017},{
      0.679326, -0.951057, -0.309017}}],
    Polygon[{{0.564393, -0.987688, -0.156434},{
      0.423295, -0.987688, -0.156434},{0.407596, -0.951057, -0.309017},{
      0.543461, -0.951057, -0.309017}}],
    Polygon[{{0.423295, -0.987688, -0.156434},{
      0.282197, -0.987688, -0.156434},{0.271730, -0.951057, -0.309017},{
      0.407596, -0.951057, -0.309017}}],
    Polygon[{{0.282197, -0.987688, -0.156434},{
      0.141098, -0.987688, -0.156434},{0.135865, -0.951057, -0.309017},{
      0.271730, -0.951057, -0.309017}}],
    Polygon[{{0.141098, -0.987688, -0.156434},{
      0.000000, -0.987688, -0.156434},{0.000000, -0.951057, -0.309017},{
      0.135865, -0.951057, -0.309017}}],
    Polygon[{{
      0.000000, -0.987688, -0.156434},{-0.141098, -0.987688, \
-0.156434},{-0.135865, -0.951057, -0.309017},{
      0.000000, -0.951057, -0.309017}}],
    Polygon[{{-0.141098, -0.987688, -0.156434},{-0.282197, -0.987688, \
-0.156434},{-0.271730, -0.951057, -0.309017},{-0.135865, -0.951057, \
-0.309017}}],
    Polygon[{{-0.282197, -0.987688, -0.156434},{-0.423295, -0.987688, \
-0.156434},{-0.407596, -0.951057, -0.309017},{-0.271730, -0.951057, \
-0.309017}}],
    Polygon[{{-0.423295, -0.987688, -0.156434},{-0.564393, -0.987688, \
-0.156434},{-0.543461, -0.951057, -0.309017},{-0.407596, -0.951057, \
-0.309017}}],
    Polygon[{{-0.564393, -0.987688, -0.156434},{-0.705492, -0.987688, \
-0.156434},{-0.679326, -0.951057, -0.309017},{-0.543461, -0.951057, \
-0.309017}}],
    Polygon[{{-0.705492, -0.987688, -0.156434},{-0.846590, -0.987688, \
-0.156434},{-0.815191, -0.951057, -0.309017},{-0.679326, -0.951057, \
-0.309017}}],
    Polygon[{{-0.846590, -0.987688, -0.156434},{-0.987688, -0.987688, \
-0.156434},{-0.951057, -0.951057, -0.309017},{-0.815191, -0.951057, \
-0.309017}}],
    Polygon[{{0.951057, -0.951057, -0.309017},{
      0.815191, -0.951057, -0.309017},{0.763720, -0.891007, -0.453990},{
      0.891007, -0.891007, -0.453990}}],
    Polygon[{{0.815191, -0.951057, -0.309017},{
      0.679326, -0.951057, -0.309017},{0.636433, -0.891007, -0.453990},{
      0.763720, -0.891007, -0.453990}}],
    Polygon[{{0.679326, -0.951057, -0.309017},{
      0.543461, -0.951057, -0.309017},{0.509147, -0.891007, -0.453990},{
      0.636433, -0.891007, -0.453990}}],
    Polygon[{{0.543461, -0.951057, -0.309017},{
      0.407596, -0.951057, -0.309017},{0.381860, -0.891007, -0.453990},{
      0.509147, -0.891007, -0.453990}}],
    Polygon[{{0.407596, -0.951057, -0.309017},{
      0.271730, -0.951057, -0.309017},{0.254573, -0.891007, -0.453990},{
      0.381860, -0.891007, -0.453990}}],
    Polygon[{{0.271730, -0.951057, -0.309017},{
      0.135865, -0.951057, -0.309017},{0.127287, -0.891007, -0.453990},{
      0.254573, -0.891007, -0.453990}}],
    Polygon[{{0.135865, -0.951057, -0.309017},{
      0.000000, -0.951057, -0.309017},{0.000000, -0.891007, -0.453990},{
      0.127287, -0.891007, -0.453990}}],
    Polygon[{{
      0.000000, -0.951057, -0.309017},{-0.135865, -0.951057, \
-0.309017},{-0.127287, -0.891007, -0.453990},{
      0.000000, -0.891007, -0.453990}}],
    Polygon[{{-0.135865, -0.951057, -0.309017},{-0.271730, -0.951057, \
-0.309017},{-0.254573, -0.891007, -0.453990},{-0.127287, -0.891007, \
-0.453990}}],
    Polygon[{{-0.271730, -0.951057, -0.309017},{-0.407596, -0.951057, \
-0.309017},{-0.381860, -0.891007, -0.453990},{-0.254573, -0.891007, \
-0.453990}}],
    Polygon[{{-0.407596, -0.951057, -0.309017},{-0.543461, -0.951057, \
-0.309017},{-0.509147, -0.891007, -0.453990},{-0.381860, -0.891007, \
-0.453990}}],
    Polygon[{{-0.543461, -0.951057, -0.309017},{-0.679326, -0.951057, \
-0.309017},{-0.636433, -0.891007, -0.453990},{-0.509147, -0.891007, \
-0.453990}}],
    Polygon[{{-0.679326, -0.951057, -0.309017},{-0.815191, -0.951057, \
-0.309017},{-0.763720, -0.891007, -0.453990},{-0.636433, -0.891007, \
-0.453990}}],
    Polygon[{{-0.815191, -0.951057, -0.309017},{-0.951057, -0.951057, \
-0.309017},{-0.891007, -0.891007, -0.453990},{-0.763720, -0.891007, \
-0.453990}}],
    Polygon[{{0.891007, -0.891007, -0.453990},{
      0.763720, -0.891007, -0.453990},{0.693443, -0.809017, -0.587785},{
      0.809017, -0.809017, -0.587785}}],
    Polygon[{{0.763720, -0.891007, -0.453990},{
      0.636433, -0.891007, -0.453990},{0.577869, -0.809017, -0.587785},{
      0.693443, -0.809017, -0.587785}}],
    Polygon[{{0.636433, -0.891007, -0.453990},{
      0.509147, -0.891007, -0.453990},{0.462295, -0.809017, -0.587785},{
      0.577869, -0.809017, -0.587785}}],
    Polygon[{{0.509147, -0.891007, -0.453990},{
      0.381860, -0.891007, -0.453990},{0.346722, -0.809017, -0.587785},{
      0.462295, -0.809017, -0.587785}}],
    Polygon[{{0.381860, -0.891007, -0.453990},{
      0.254573, -0.891007, -0.453990},{0.231148, -0.809017, -0.587785},{
      0.346722, -0.809017, -0.587785}}],
    Polygon[{{0.254573, -0.891007, -0.453990},{
      0.127287, -0.891007, -0.453990},{0.115574, -0.809017, -0.587785},{
      0.231148, -0.809017, -0.587785}}],
    Polygon[{{0.127287, -0.891007, -0.453990},{
      0.000000, -0.891007, -0.453990},{0.000000, -0.809017, -0.587785},{
      0.115574, -0.809017, -0.587785}}],
    Polygon[{{
      0.000000, -0.891007, -0.453990},{-0.127287, -0.891007, \
-0.453990},{-0.115574, -0.809017, -0.587785},{
      0.000000, -0.809017, -0.587785}}],
    Polygon[{{-0.127287, -0.891007, -0.453990},{-0.254573, -0.891007, \
-0.453990},{-0.231148, -0.809017, -0.587785},{-0.115574, -0.809017, \
-0.587785}}],
    Polygon[{{-0.254573, -0.891007, -0.453990},{-0.381860, -0.891007, \
-0.453990},{-0.346722, -0.809017, -0.587785},{-0.231148, -0.809017, \
-0.587785}}],
    Polygon[{{-0.381860, -0.891007, -0.453990},{-0.509147, -0.891007, \
-0.453990},{-0.462295, -0.809017, -0.587785},{-0.346722, -0.809017, \
-0.587785}}],
    Polygon[{{-0.509147, -0.891007, -0.453990},{-0.636433, -0.891007, \
-0.453990},{-0.577869, -0.809017, -0.587785},{-0.462295, -0.809017, \
-0.587785}}],
    Polygon[{{-0.636433, -0.891007, -0.453990},{-0.763720, -0.891007, \
-0.453990},{-0.693443, -0.809017, -0.587785},{-0.577869, -0.809017, \
-0.587785}}],
    Polygon[{{-0.763720, -0.891007, -0.453990},{-0.891007, -0.891007, \
-0.453990},{-0.809017, -0.809017, -0.587785},{-0.693443, -0.809017, \
-0.587785}}],
    Polygon[{{0.809017, -0.809017, -0.587785},{
      0.693443, -0.809017, -0.587785},{0.606091, -0.707107, -0.707107},{
      0.707107, -0.707107, -0.707107}}],
    Polygon[{{0.693443, -0.809017, -0.587785},{
      0.577869, -0.809017, -0.587785},{0.505076, -0.707107, -0.707107},{
      0.606091, -0.707107, -0.707107}}],
    Polygon[{{0.577869, -0.809017, -0.587785},{
      0.462295, -0.809017, -0.587785},{0.404061, -0.707107, -0.707107},{
      0.505076, -0.707107, -0.707107}}],
    Polygon[{{0.462295, -0.809017, -0.587785},{
      0.346722, -0.809017, -0.587785},{0.303046, -0.707107, -0.707107},{
      0.404061, -0.707107, -0.707107}}],
    Polygon[{{0.346722, -0.809017, -0.587785},{
      0.231148, -0.809017, -0.587785},{0.202031, -0.707107, -0.707107},{
      0.303046, -0.707107, -0.707107}}],
    Polygon[{{0.231148, -0.809017, -0.587785},{
      0.115574, -0.809017, -0.587785},{0.101015, -0.707107, -0.707107},{
      0.202031, -0.707107, -0.707107}}],
    Polygon[{{0.115574, -0.809017, -0.587785},{
      0.000000, -0.809017, -0.587785},{0.000000, -0.707107, -0.707107},{
      0.101015, -0.707107, -0.707107}}],
    Polygon[{{
      0.000000, -0.809017, -0.587785},{-0.115574, -0.809017, \
-0.587785},{-0.101015, -0.707107, -0.707107},{
      0.000000, -0.707107, -0.707107}}],
    Polygon[{{-0.115574, -0.809017, -0.587785},{-0.231148, -0.809017, \
-0.587785},{-0.202031, -0.707107, -0.707107},{-0.101015, -0.707107, \
-0.707107}}],
    Polygon[{{-0.231148, -0.809017, -0.587785},{-0.346722, -0.809017, \
-0.587785},{-0.303046, -0.707107, -0.707107},{-0.202031, -0.707107, \
-0.707107}}],
    Polygon[{{-0.346722, -0.809017, -0.587785},{-0.462295, -0.809017, \
-0.587785},{-0.404061, -0.707107, -0.707107},{-0.303046, -0.707107, \
-0.707107}}],
    Polygon[{{-0.462295, -0.809017, -0.587785},{-0.577869, -0.809017, \
-0.587785},{-0.505076, -0.707107, -0.707107},{-0.404061, -0.707107, \
-0.707107}}],
    Polygon[{{-0.577869, -0.809017, -0.587785},{-0.693443, -0.809017, \
-0.587785},{-0.606091, -0.707107, -0.707107},{-0.505076, -0.707107, \
-0.707107}}],
    Polygon[{{-0.693443, -0.809017, -0.587785},{-0.809017, -0.809017, \
-0.587785},{-0.707107, -0.707107, -0.707107},{-0.606091, -0.707107, \
-0.707107}}],
    Polygon[{{0.707107, -0.707107, -0.707107},{
      0.606091, -0.707107, -0.707107},{0.503816, -0.587785, -0.809017},{
      0.587785, -0.587785, -0.809017}}],
    Polygon[{{0.606091, -0.707107, -0.707107},{
      0.505076, -0.707107, -0.707107},{0.419847, -0.587785, -0.809017},{
      0.503816, -0.587785, -0.809017}}],
    Polygon[{{0.505076, -0.707107, -0.707107},{
      0.404061, -0.707107, -0.707107},{0.335877, -0.587785, -0.809017},{
      0.419847, -0.587785, -0.809017}}],
    Polygon[{{0.404061, -0.707107, -0.707107},{
      0.303046, -0.707107, -0.707107},{0.251908, -0.587785, -0.809017},{
      0.335877, -0.587785, -0.809017}}],
    Polygon[{{0.303046, -0.707107, -0.707107},{
      0.202031, -0.707107, -0.707107},{0.167939, -0.587785, -0.809017},{
      0.251908, -0.587785, -0.809017}}],
    Polygon[{{0.202031, -0.707107, -0.707107},{
      0.101015, -0.707107, -0.707107},{0.083969, -0.587785, -0.809017},{
      0.167939, -0.587785, -0.809017}}],
    Polygon[{{0.101015, -0.707107, -0.707107},{
      0.000000, -0.707107, -0.707107},{0.000000, -0.587785, -0.809017},{
      0.083969, -0.587785, -0.809017}}],
    Polygon[{{
      0.000000, -0.707107, -0.707107},{-0.101015, -0.707107, \
-0.707107},{-0.083969, -0.587785, -0.809017},{
      0.000000, -0.587785, -0.809017}}],
    Polygon[{{-0.101015, -0.707107, -0.707107},{-0.202031, -0.707107, \
-0.707107},{-0.167939, -0.587785, -0.809017},{-0.083969, -0.587785, \
-0.809017}}],
    Polygon[{{-0.202031, -0.707107, -0.707107},{-0.303046, -0.707107, \
-0.707107},{-0.251908, -0.587785, -0.809017},{-0.167939, -0.587785, \
-0.809017}}],
    Polygon[{{-0.303046, -0.707107, -0.707107},{-0.404061, -0.707107, \
-0.707107},{-0.335877, -0.587785, -0.809017},{-0.251908, -0.587785, \
-0.809017}}],
    Polygon[{{-0.404061, -0.707107, -0.707107},{-0.505076, -0.707107, \
-0.707107},{-0.419847, -0.587785, -0.809017},{-0.335877, -0.587785, \
-0.809017}}],
    Polygon[{{-0.505076, -0.707107, -0.707107},{-0.606091, -0.707107, \
-0.707107},{-0.503816, -0.587785, -0.809017},{-0.419847, -0.587785, \
-0.809017}}],
    Polygon[{{-0.606091, -0.707107, -0.707107},{-0.707107, -0.707107, \
-0.707107},{-0.587785, -0.587785, -0.809017},{-0.503816, -0.587785, \
-0.809017}}],
    Polygon[{{0.587785, -0.587785, -0.809017},{
      0.503816, -0.587785, -0.809017},{0.389135, -0.453990, -0.891007},{
      0.453990, -0.453990, -0.891007}}],
    Polygon[{{0.503816, -0.587785, -0.809017},{
      0.419847, -0.587785, -0.809017},{0.324279, -0.453990, -0.891007},{
      0.389135, -0.453990, -0.891007}}],
    Polygon[{{0.419847, -0.587785, -0.809017},{
      0.335877, -0.587785, -0.809017},{0.259423, -0.453990, -0.891007},{
      0.324279, -0.453990, -0.891007}}],
    Polygon[{{0.335877, -0.587785, -0.809017},{
      0.251908, -0.587785, -0.809017},{0.194567, -0.453990, -0.891007},{
      0.259423, -0.453990, -0.891007}}],
    Polygon[{{0.251908, -0.587785, -0.809017},{
      0.167939, -0.587785, -0.809017},{0.129712, -0.453990, -0.891007},{
      0.194567, -0.453990, -0.891007}}],
    Polygon[{{0.167939, -0.587785, -0.809017},{
      0.083969, -0.587785, -0.809017},{0.064856, -0.453990, -0.891007},{
      0.129712, -0.453990, -0.891007}}],
    Polygon[{{0.083969, -0.587785, -0.809017},{
      0.000000, -0.587785, -0.809017},{0.000000, -0.453990, -0.891007},{
      0.064856, -0.453990, -0.891007}}],
    Polygon[{{
      0.000000, -0.587785, -0.809017},{-0.083969, -0.587785, \
-0.809017},{-0.064856, -0.453990, -0.891007},{
      0.000000, -0.453990, -0.891007}}],
    Polygon[{{-0.083969, -0.587785, -0.809017},{-0.167939, -0.587785, \
-0.809017},{-0.129712, -0.453990, -0.891007},{-0.064856, -0.453990, \
-0.891007}}],
    Polygon[{{-0.167939, -0.587785, -0.809017},{-0.251908, -0.587785, \
-0.809017},{-0.194567, -0.453990, -0.891007},{-0.129712, -0.453990, \
-0.891007}}],
    Polygon[{{-0.251908, -0.587785, -0.809017},{-0.335877, -0.587785, \
-0.809017},{-0.259423, -0.453990, -0.891007},{-0.194567, -0.453990, \
-0.891007}}],
    Polygon[{{-0.335877, -0.587785, -0.809017},{-0.419847, -0.587785, \
-0.809017},{-0.324279, -0.453990, -0.891007},{-0.259423, -0.453990, \
-0.891007}}],
    Polygon[{{-0.419847, -0.587785, -0.809017},{-0.503816, -0.587785, \
-0.809017},{-0.389135, -0.453990, -0.891007},{-0.324279, -0.453990, \
-0.891007}}],
    Polygon[{{-0.503816, -0.587785, -0.809017},{-0.587785, -0.587785, \
-0.809017},{-0.453990, -0.453990, -0.891007},{-0.389135, -0.453990, \
-0.891007}}],
    Polygon[{{0.453990, -0.453990, -0.891007},{
      0.389135, -0.453990, -0.891007},{0.264872, -0.309017, -0.951057},{
      0.309017, -0.309017, -0.951057}}],
    Polygon[{{0.389135, -0.453990, -0.891007},{
      0.324279, -0.453990, -0.891007},{0.220726, -0.309017, -0.951057},{
      0.264872, -0.309017, -0.951057}}],
    Polygon[{{0.324279, -0.453990, -0.891007},{
      0.259423, -0.453990, -0.891007},{0.176581, -0.309017, -0.951057},{
      0.220726, -0.309017, -0.951057}}],
    Polygon[{{0.259423, -0.453990, -0.891007},{
      0.194567, -0.453990, -0.891007},{0.132436, -0.309017, -0.951057},{
      0.176581, -0.309017, -0.951057}}],
    Polygon[{{0.194567, -0.453990, -0.891007},{
      0.129712, -0.453990, -0.891007},{0.088291, -0.309017, -0.951057},{
      0.132436, -0.309017, -0.951057}}],
    Polygon[{{0.129712, -0.453990, -0.891007},{
      0.064856, -0.453990, -0.891007},{0.044145, -0.309017, -0.951057},{
      0.088291, -0.309017, -0.951057}}],
    Polygon[{{0.064856, -0.453990, -0.891007},{
      0.000000, -0.453990, -0.891007},{0.000000, -0.309017, -0.951057},{
      0.044145, -0.309017, -0.951057}}],
    Polygon[{{
      0.000000, -0.453990, -0.891007},{-0.064856, -0.453990, \
-0.891007},{-0.044145, -0.309017, -0.951057},{
      0.000000, -0.309017, -0.951057}}],
    Polygon[{{-0.064856, -0.453990, -0.891007},{-0.129712, -0.453990, \
-0.891007},{-0.088291, -0.309017, -0.951057},{-0.044145, -0.309017, \
-0.951057}}],
    Polygon[{{-0.129712, -0.453990, -0.891007},{-0.194567, -0.453990, \
-0.891007},{-0.132436, -0.309017, -0.951057},{-0.088291, -0.309017, \
-0.951057}}],
    Polygon[{{-0.194567, -0.453990, -0.891007},{-0.259423, -0.453990, \
-0.891007},{-0.176581, -0.309017, -0.951057},{-0.132436, -0.309017, \
-0.951057}}],
    Polygon[{{-0.259423, -0.453990, -0.891007},{-0.324279, -0.453990, \
-0.891007},{-0.220726, -0.309017, -0.951057},{-0.176581, -0.309017, \
-0.951057}}],
    Polygon[{{-0.324279, -0.453990, -0.891007},{-0.389135, -0.453990, \
-0.891007},{-0.264872, -0.309017, -0.951057},{-0.220726, -0.309017, \
-0.951057}}],
    Polygon[{{-0.389135, -0.453990, -0.891007},{-0.453990, -0.453990, \
-0.891007},{-0.309017, -0.309017, -0.951057},{-0.264872, -0.309017, \
-0.951057}}],
    Polygon[{{0.309017, -0.309017, -0.951057},{
      0.264872, -0.309017, -0.951057},{0.134087, -0.156434, -0.987688},{
      0.156434, -0.156434, -0.987688}}],
    Polygon[{{0.264872, -0.309017, -0.951057},{
      0.220726, -0.309017, -0.951057},{0.111739, -0.156434, -0.987688},{
      0.134087, -0.156434, -0.987688}}],
    Polygon[{{0.220726, -0.309017, -0.951057},{
      0.176581, -0.309017, -0.951057},{0.089391, -0.156434, -0.987688},{
      0.111739, -0.156434, -0.987688}}],
    Polygon[{{0.176581, -0.309017, -0.951057},{
      0.132436, -0.309017, -0.951057},{0.067043, -0.156434, -0.987688},{
      0.089391, -0.156434, -0.987688}}],
    Polygon[{{0.132436, -0.309017, -0.951057},{
      0.088291, -0.309017, -0.951057},{0.044696, -0.156434, -0.987688},{
      0.067043, -0.156434, -0.987688}}],
    Polygon[{{0.088291, -0.309017, -0.951057},{
      0.044145, -0.309017, -0.951057},{0.022348, -0.156434, -0.987688},{
      0.044696, -0.156434, -0.987688}}],
    Polygon[{{0.044145, -0.309017, -0.951057},{
      0.000000, -0.309017, -0.951057},{0.000000, -0.156434, -0.987688},{
      0.022348, -0.156434, -0.987688}}],
    Polygon[{{
      0.000000, -0.309017, -0.951057},{-0.044145, -0.309017, \
-0.951057},{-0.022348, -0.156434, -0.987688},{
      0.000000, -0.156434, -0.987688}}],
    Polygon[{{-0.044145, -0.309017, -0.951057},{-0.088291, -0.309017, \
-0.951057},{-0.044696, -0.156434, -0.987688},{-0.022348, -0.156434, \
-0.987688}}],
    Polygon[{{-0.088291, -0.309017, -0.951057},{-0.132436, -0.309017, \
-0.951057},{-0.067043, -0.156434, -0.987688},{-0.044696, -0.156434, \
-0.987688}}],
    Polygon[{{-0.132436, -0.309017, -0.951057},{-0.176581, -0.309017, \
-0.951057},{-0.089391, -0.156434, -0.987688},{-0.067043, -0.156434, \
-0.987688}}],
    Polygon[{{-0.176581, -0.309017, -0.951057},{-0.220726, -0.309017, \
-0.951057},{-0.111739, -0.156434, -0.987688},{-0.089391, -0.156434, \
-0.987688}}],
    Polygon[{{-0.220726, -0.309017, -0.951057},{-0.264872, -0.309017, \
-0.951057},{-0.134087, -0.156434, -0.987688},{-0.111739, -0.156434, \
-0.987688}}],
    Polygon[{{-0.264872, -0.309017, -0.951057},{-0.309017, -0.309017, \
-0.951057},{-0.156434, -0.156434, -0.987688},{-0.134087, -0.156434, \
-0.987688}}],
    Polygon[{{0.156434, -0.156434, -0.987688},{
      0.134087, -0.156434, -0.987688},{0.000000, -0.000000, -1.000000},{
      0.000000, -0.000000, -1.000000}}],
    Polygon[{{0.134087, -0.156434, -0.987688},{
      0.111739, -0.156434, -0.987688},{0.000000, -0.000000, -1.000000},{
      0.000000, -0.000000, -1.000000}}],
    Polygon[{{0.111739, -0.156434, -0.987688},{
      0.089391, -0.156434, -0.987688},{0.000000, -0.000000, -1.000000},{
      0.000000, -0.000000, -1.000000}}],
    Polygon[{{0.089391, -0.156434, -0.987688},{
      0.067043, -0.156434, -0.987688},{0.000000, -0.000000, -1.000000},{
      0.000000, -0.000000, -1.000000}}],
    Polygon[{{0.067043, -0.156434, -0.987688},{
      0.044696, -0.156434, -0.987688},{0.000000, -0.000000, -1.000000},{
      0.000000, -0.000000, -1.000000}}],
    Polygon[{{0.044696, -0.156434, -0.987688},{
      0.022348, -0.156434, -0.987688},{0.000000, -0.000000, -1.000000},{
      0.000000, -0.000000, -1.000000}}],
    Polygon[{{0.022348, -0.156434, -0.987688},{
      0.000000, -0.156434, -0.987688},{0.000000, -0.000000, -1.000000},{
      0.000000, -0.000000, -1.000000}}],
    Polygon[{{
      0.000000, -0.156434, -0.987688},{-0.022348, -0.156434, \
-0.987688},{-0.000000, -0.000000, -1.000000},{
      0.000000, -0.000000, -1.000000}}],
    Polygon[{{-0.022348, -0.156434, -0.987688},{-0.044696, -0.156434, \
-0.987688},{-0.000000, -0.000000, -1.000000},{-0.000000, -0.000000, \
-1.000000}}],
    Polygon[{{-0.044696, -0.156434, -0.987688},{-0.067043, -0.156434, \
-0.987688},{-0.000000, -0.000000, -1.000000},{-0.000000, -0.000000, \
-1.000000}}],
    Polygon[{{-0.067043, -0.156434, -0.987688},{-0.089391, -0.156434, \
-0.987688},{-0.000000, -0.000000, -1.000000},{-0.000000, -0.000000, \
-1.000000}}],
    Polygon[{{-0.089391, -0.156434, -0.987688},{-0.111739, -0.156434, \
-0.987688},{-0.000000, -0.000000, -1.000000},{-0.000000, -0.000000, \
-1.000000}}],
    Polygon[{{-0.111739, -0.156434, -0.987688},{-0.134087, -0.156434, \
-0.987688},{-0.000000, -0.000000, -1.000000},{-0.000000, -0.000000, \
-1.000000}}],
    Polygon[{{-0.134087, -0.156434, -0.987688},{-0.156434, -0.156434, \
-0.987688},{-0.000000, -0.000000, -1.000000},{-0.000000, -0.000000, \
-1.000000}}],
    Polygon[{{0.000000, -0.000000, -1.000000},{
      0.000000, -0.000000, -1.000000},{-0.134087, 
        0.156434, -0.987688},{-0.156434, 0.156434, -0.987688}}],
    Polygon[{{0.000000, -0.000000, -1.000000},{
      0.000000, -0.000000, -1.000000},{-0.111739, 
        0.156434, -0.987688},{-0.134087, 0.156434, -0.987688}}],
    Polygon[{{0.000000, -0.000000, -1.000000},{
      0.000000, -0.000000, -1.000000},{-0.089391, 
        0.156434, -0.987688},{-0.111739, 0.156434, -0.987688}}],
    Polygon[{{0.000000, -0.000000, -1.000000},{
      0.000000, -0.000000, -1.000000},{-0.067043, 
        0.156434, -0.987688},{-0.089391, 0.156434, -0.987688}}],
    Polygon[{{0.000000, -0.000000, -1.000000},{
      0.000000, -0.000000, -1.000000},{-0.044696, 
        0.156434, -0.987688},{-0.067043, 0.156434, -0.987688}}],
    Polygon[{{0.000000, -0.000000, -1.000000},{
      0.000000, -0.000000, -1.000000},{-0.022348, 
        0.156434, -0.987688},{-0.044696, 0.156434, -0.987688}}],
    Polygon[{{0.000000, -0.000000, -1.000000},{
      0.000000, -0.000000, -1.000000},{-0.000000, 
        0.156434, -0.987688},{-0.022348, 0.156434, -0.987688}}],
    Polygon[{{
      0.000000, -0.000000, -1.000000},{-0.000000, -0.000000, -1.000000},{
      0.022348, 0.156434, -0.987688},{-0.000000, 0.156434, -0.987688}}],
    Polygon[{{-0.000000, -0.000000, -1.000000},{-0.000000, -0.000000, \
-1.000000},{0.044696, 0.156434, -0.987688},{0.022348, 0.156434, -0.987688}}],
    Polygon[{{-0.000000, -0.000000, -1.000000},{-0.000000, -0.000000, \
-1.000000},{0.067043, 0.156434, -0.987688},{0.044696, 0.156434, -0.987688}}],
    Polygon[{{-0.000000, -0.000000, -1.000000},{-0.000000, -0.000000, \
-1.000000},{0.089391, 0.156434, -0.987688},{0.067043, 0.156434, -0.987688}}],
    Polygon[{{-0.000000, -0.000000, -1.000000},{-0.000000, -0.000000, \
-1.000000},{0.111739, 0.156434, -0.987688},{0.089391, 0.156434, -0.987688}}],
    Polygon[{{-0.000000, -0.000000, -1.000000},{-0.000000, -0.000000, \
-1.000000},{0.134087, 0.156434, -0.987688},{0.111739, 0.156434, -0.987688}}],
    Polygon[{{-0.000000, -0.000000, -1.000000},{-0.000000, -0.000000, \
-1.000000},{0.156434, 0.156434, -0.987688},{0.134087, 0.156434, -0.987688}}],
    Polygon[{{-0.156434, 0.156434, -0.987688},{-0.134087, 
        0.156434, -0.987688},{-0.264872, 0.309017, -0.951057},{-0.309017, 
        0.309017, -0.951057}}],
    Polygon[{{-0.134087, 0.156434, -0.987688},{-0.111739, 
        0.156434, -0.987688},{-0.220726, 0.309017, -0.951057},{-0.264872, 
        0.309017, -0.951057}}],
    Polygon[{{-0.111739, 0.156434, -0.987688},{-0.089391, 
        0.156434, -0.987688},{-0.176581, 0.309017, -0.951057},{-0.220726, 
        0.309017, -0.951057}}],
    Polygon[{{-0.089391, 0.156434, -0.987688},{-0.067043, 
        0.156434, -0.987688},{-0.132436, 0.309017, -0.951057},{-0.176581, 
        0.309017, -0.951057}}],
    Polygon[{{-0.067043, 0.156434, -0.987688},{-0.044696, 
        0.156434, -0.987688},{-0.088291, 0.309017, -0.951057},{-0.132436, 
        0.309017, -0.951057}}],
    Polygon[{{-0.044696, 0.156434, -0.987688},{-0.022348, 
        0.156434, -0.987688},{-0.044145, 0.309017, -0.951057},{-0.088291, 
        0.309017, -0.951057}}],
    Polygon[{{-0.022348, 0.156434, -0.987688},{-0.000000, 
        0.156434, -0.987688},{-0.000000, 0.309017, -0.951057},{-0.044145, 
        0.309017, -0.951057}}],
    Polygon[{{-0.000000, 0.156434, -0.987688},{
      0.022348, 0.156434, -0.987688},{
      0.044145, 0.309017, -0.951057},{-0.000000, 0.309017, -0.951057}}],
    Polygon[{{0.022348, 0.156434, -0.987688},{0.044696, 0.156434, -0.987688},{
      0.088291, 0.309017, -0.951057},{0.044145, 0.309017, -0.951057}}],
    Polygon[{{0.044696, 0.156434, -0.987688},{0.067043, 0.156434, -0.987688},{
      0.132436, 0.309017, -0.951057},{0.088291, 0.309017, -0.951057}}],
    Polygon[{{0.067043, 0.156434, -0.987688},{0.089391, 0.156434, -0.987688},{
      0.176581, 0.309017, -0.951057},{0.132436, 0.309017, -0.951057}}],
    Polygon[{{0.089391, 0.156434, -0.987688},{0.111739, 0.156434, -0.987688},{
      0.220726, 0.309017, -0.951057},{0.176581, 0.309017, -0.951057}}],
    Polygon[{{0.111739, 0.156434, -0.987688},{0.134087, 0.156434, -0.987688},{
      0.264872, 0.309017, -0.951057},{0.220726, 0.309017, -0.951057}}],
    Polygon[{{0.134087, 0.156434, -0.987688},{0.156434, 0.156434, -0.987688},{
      0.309017, 0.309017, -0.951057},{0.264872, 0.309017, -0.951057}}],
    Polygon[{{-0.309017, 0.309017, -0.951057},{-0.264872, 
        0.309017, -0.951057},{-0.389135, 0.453990, -0.891007},{-0.453990, 
        0.453990, -0.891007}}],
    Polygon[{{-0.264872, 0.309017, -0.951057},{-0.220726, 
        0.309017, -0.951057},{-0.324279, 0.453990, -0.891007},{-0.389135, 
        0.453990, -0.891007}}],
    Polygon[{{-0.220726, 0.309017, -0.951057},{-0.176581, 
        0.309017, -0.951057},{-0.259423, 0.453990, -0.891007},{-0.324279, 
        0.453990, -0.891007}}],
    Polygon[{{-0.176581, 0.309017, -0.951057},{-0.132436, 
        0.309017, -0.951057},{-0.194567, 0.453990, -0.891007},{-0.259423, 
        0.453990, -0.891007}}],
    Polygon[{{-0.132436, 0.309017, -0.951057},{-0.088291, 
        0.309017, -0.951057},{-0.129712, 0.453990, -0.891007},{-0.194567, 
        0.453990, -0.891007}}],
    Polygon[{{-0.088291, 0.309017, -0.951057},{-0.044145, 
        0.309017, -0.951057},{-0.064856, 0.453990, -0.891007},{-0.129712, 
        0.453990, -0.891007}}],
    Polygon[{{-0.044145, 0.309017, -0.951057},{-0.000000, 
        0.309017, -0.951057},{-0.000000, 0.453990, -0.891007},{-0.064856, 
        0.453990, -0.891007}}],
    Polygon[{{-0.000000, 0.309017, -0.951057},{
      0.044145, 0.309017, -0.951057},{
      0.064856, 0.453990, -0.891007},{-0.000000, 0.453990, -0.891007}}],
    Polygon[{{0.044145, 0.309017, -0.951057},{0.088291, 0.309017, -0.951057},{
      0.129712, 0.453990, -0.891007},{0.064856, 0.453990, -0.891007}}],
    Polygon[{{0.088291, 0.309017, -0.951057},{0.132436, 0.309017, -0.951057},{
      0.194567, 0.453990, -0.891007},{0.129712, 0.453990, -0.891007}}],
    Polygon[{{0.132436, 0.309017, -0.951057},{0.176581, 0.309017, -0.951057},{
      0.259423, 0.453990, -0.891007},{0.194567, 0.453990, -0.891007}}],
    Polygon[{{0.176581, 0.309017, -0.951057},{0.220726, 0.309017, -0.951057},{
      0.324279, 0.453990, -0.891007},{0.259423, 0.453990, -0.891007}}],
    Polygon[{{0.220726, 0.309017, -0.951057},{0.264872, 0.309017, -0.951057},{
      0.389135, 0.453990, -0.891007},{0.324279, 0.453990, -0.891007}}],
    Polygon[{{0.264872, 0.309017, -0.951057},{0.309017, 0.309017, -0.951057},{
      0.453990, 0.453990, -0.891007},{0.389135, 0.453990, -0.891007}}],
    Polygon[{{-0.453990, 0.453990, -0.891007},{-0.389135, 
        0.453990, -0.891007},{-0.503816, 0.587785, -0.809017},{-0.587785, 
        0.587785, -0.809017}}],
    Polygon[{{-0.389135, 0.453990, -0.891007},{-0.324279, 
        0.453990, -0.891007},{-0.419847, 0.587785, -0.809017},{-0.503816, 
        0.587785, -0.809017}}],
    Polygon[{{-0.324279, 0.453990, -0.891007},{-0.259423, 
        0.453990, -0.891007},{-0.335877, 0.587785, -0.809017},{-0.419847, 
        0.587785, -0.809017}}],
    Polygon[{{-0.259423, 0.453990, -0.891007},{-0.194567, 
        0.453990, -0.891007},{-0.251908, 0.587785, -0.809017},{-0.335877, 
        0.587785, -0.809017}}],
    Polygon[{{-0.194567, 0.453990, -0.891007},{-0.129712, 
        0.453990, -0.891007},{-0.167939, 0.587785, -0.809017},{-0.251908, 
        0.587785, -0.809017}}],
    Polygon[{{-0.129712, 0.453990, -0.891007},{-0.064856, 
        0.453990, -0.891007},{-0.083969, 0.587785, -0.809017},{-0.167939, 
        0.587785, -0.809017}}],
    Polygon[{{-0.064856, 0.453990, -0.891007},{-0.000000, 
        0.453990, -0.891007},{-0.000000, 0.587785, -0.809017},{-0.083969, 
        0.587785, -0.809017}}],
    Polygon[{{-0.000000, 0.453990, -0.891007},{
      0.064856, 0.453990, -0.891007},{
      0.083969, 0.587785, -0.809017},{-0.000000, 0.587785, -0.809017}}],
    Polygon[{{0.064856, 0.453990, -0.891007},{0.129712, 0.453990, -0.891007},{
      0.167939, 0.587785, -0.809017},{0.083969, 0.587785, -0.809017}}],
    Polygon[{{0.129712, 0.453990, -0.891007},{0.194567, 0.453990, -0.891007},{
      0.251908, 0.587785, -0.809017},{0.167939, 0.587785, -0.809017}}],
    Polygon[{{0.194567, 0.453990, -0.891007},{0.259423, 0.453990, -0.891007},{
      0.335877, 0.587785, -0.809017},{0.251908, 0.587785, -0.809017}}],
    Polygon[{{0.259423, 0.453990, -0.891007},{0.324279, 0.453990, -0.891007},{
      0.419847, 0.587785, -0.809017},{0.335877, 0.587785, -0.809017}}],
    Polygon[{{0.324279, 0.453990, -0.891007},{0.389135, 0.453990, -0.891007},{
      0.503816, 0.587785, -0.809017},{0.419847, 0.587785, -0.809017}}],
    Polygon[{{0.389135, 0.453990, -0.891007},{0.453990, 0.453990, -0.891007},{
      0.587785, 0.587785, -0.809017},{0.503816, 0.587785, -0.809017}}],
    Polygon[{{-0.587785, 0.587785, -0.809017},{-0.503816, 
        0.587785, -0.809017},{-0.606091, 0.707107, -0.707107},{-0.707107, 
        0.707107, -0.707107}}],
    Polygon[{{-0.503816, 0.587785, -0.809017},{-0.419847, 
        0.587785, -0.809017},{-0.505076, 0.707107, -0.707107},{-0.606091, 
        0.707107, -0.707107}}],
    Polygon[{{-0.419847, 0.587785, -0.809017},{-0.335877, 
        0.587785, -0.809017},{-0.404061, 0.707107, -0.707107},{-0.505076, 
        0.707107, -0.707107}}],
    Polygon[{{-0.335877, 0.587785, -0.809017},{-0.251908, 
        0.587785, -0.809017},{-0.303046, 0.707107, -0.707107},{-0.404061, 
        0.707107, -0.707107}}],
    Polygon[{{-0.251908, 0.587785, -0.809017},{-0.167939, 
        0.587785, -0.809017},{-0.202031, 0.707107, -0.707107},{-0.303046, 
        0.707107, -0.707107}}],
    Polygon[{{-0.167939, 0.587785, -0.809017},{-0.083969, 
        0.587785, -0.809017},{-0.101015, 0.707107, -0.707107},{-0.202031, 
        0.707107, -0.707107}}],
    Polygon[{{-0.083969, 0.587785, -0.809017},{-0.000000, 
        0.587785, -0.809017},{-0.000000, 0.707107, -0.707107},{-0.101015, 
        0.707107, -0.707107}}],
    Polygon[{{-0.000000, 0.587785, -0.809017},{
      0.083969, 0.587785, -0.809017},{
      0.101015, 0.707107, -0.707107},{-0.000000, 0.707107, -0.707107}}],
    Polygon[{{0.083969, 0.587785, -0.809017},{0.167939, 0.587785, -0.809017},{
      0.202031, 0.707107, -0.707107},{0.101015, 0.707107, -0.707107}}],
    Polygon[{{0.167939, 0.587785, -0.809017},{0.251908, 0.587785, -0.809017},{
      0.303046, 0.707107, -0.707107},{0.202031, 0.707107, -0.707107}}],
    Polygon[{{0.251908, 0.587785, -0.809017},{0.335877, 0.587785, -0.809017},{
      0.404061, 0.707107, -0.707107},{0.303046, 0.707107, -0.707107}}],
    Polygon[{{0.335877, 0.587785, -0.809017},{0.419847, 0.587785, -0.809017},{
      0.505076, 0.707107, -0.707107},{0.404061, 0.707107, -0.707107}}],
    Polygon[{{0.419847, 0.587785, -0.809017},{0.503816, 0.587785, -0.809017},{
      0.606091, 0.707107, -0.707107},{0.505076, 0.707107, -0.707107}}],
    Polygon[{{0.503816, 0.587785, -0.809017},{0.587785, 0.587785, -0.809017},{
      0.707107, 0.707107, -0.707107},{0.606091, 0.707107, -0.707107}}],
    Polygon[{{-0.707107, 0.707107, -0.707107},{-0.606091, 
        0.707107, -0.707107},{-0.693443, 0.809017, -0.587785},{-0.809017, 
        0.809017, -0.587785}}],
    Polygon[{{-0.606091, 0.707107, -0.707107},{-0.505076, 
        0.707107, -0.707107},{-0.577869, 0.809017, -0.587785},{-0.693443, 
        0.809017, -0.587785}}],
    Polygon[{{-0.505076, 0.707107, -0.707107},{-0.404061, 
        0.707107, -0.707107},{-0.462295, 0.809017, -0.587785},{-0.577869, 
        0.809017, -0.587785}}],
    Polygon[{{-0.404061, 0.707107, -0.707107},{-0.303046, 
        0.707107, -0.707107},{-0.346722, 0.809017, -0.587785},{-0.462295, 
        0.809017, -0.587785}}],
    Polygon[{{-0.303046, 0.707107, -0.707107},{-0.202031, 
        0.707107, -0.707107},{-0.231148, 0.809017, -0.587785},{-0.346722, 
        0.809017, -0.587785}}],
    Polygon[{{-0.202031, 0.707107, -0.707107},{-0.101015, 
        0.707107, -0.707107},{-0.115574, 0.809017, -0.587785},{-0.231148, 
        0.809017, -0.587785}}],
    Polygon[{{-0.101015, 0.707107, -0.707107},{-0.000000, 
        0.707107, -0.707107},{-0.000000, 0.809017, -0.587785},{-0.115574, 
        0.809017, -0.587785}}],
    Polygon[{{-0.000000, 0.707107, -0.707107},{
      0.101015, 0.707107, -0.707107},{
      0.115574, 0.809017, -0.587785},{-0.000000, 0.809017, -0.587785}}],
    Polygon[{{0.101015, 0.707107, -0.707107},{0.202031, 0.707107, -0.707107},{
      0.231148, 0.809017, -0.587785},{0.115574, 0.809017, -0.587785}}],
    Polygon[{{0.202031, 0.707107, -0.707107},{0.303046, 0.707107, -0.707107},{
      0.346722, 0.809017, -0.587785},{0.231148, 0.809017, -0.587785}}],
    Polygon[{{0.303046, 0.707107, -0.707107},{0.404061, 0.707107, -0.707107},{
      0.462295, 0.809017, -0.587785},{0.346722, 0.809017, -0.587785}}],
    Polygon[{{0.404061, 0.707107, -0.707107},{0.505076, 0.707107, -0.707107},{
      0.577869, 0.809017, -0.587785},{0.462295, 0.809017, -0.587785}}],
    Polygon[{{0.505076, 0.707107, -0.707107},{0.606091, 0.707107, -0.707107},{
      0.693443, 0.809017, -0.587785},{0.577869, 0.809017, -0.587785}}],
    Polygon[{{0.606091, 0.707107, -0.707107},{0.707107, 0.707107, -0.707107},{
      0.809017, 0.809017, -0.587785},{0.693443, 0.809017, -0.587785}}],
    Polygon[{{-0.809017, 0.809017, -0.587785},{-0.693443, 
        0.809017, -0.587785},{-0.763720, 0.891007, -0.453990},{-0.891007, 
        0.891007, -0.453990}}],
    Polygon[{{-0.693443, 0.809017, -0.587785},{-0.577869, 
        0.809017, -0.587785},{-0.636433, 0.891007, -0.453990},{-0.763720, 
        0.891007, -0.453990}}],
    Polygon[{{-0.577869, 0.809017, -0.587785},{-0.462295, 
        0.809017, -0.587785},{-0.509147, 0.891007, -0.453990},{-0.636433, 
        0.891007, -0.453990}}],
    Polygon[{{-0.462295, 0.809017, -0.587785},{-0.346722, 
        0.809017, -0.587785},{-0.381860, 0.891007, -0.453990},{-0.509147, 
        0.891007, -0.453990}}],
    Polygon[{{-0.346722, 0.809017, -0.587785},{-0.231148, 
        0.809017, -0.587785},{-0.254573, 0.891007, -0.453990},{-0.381860, 
        0.891007, -0.453990}}],
    Polygon[{{-0.231148, 0.809017, -0.587785},{-0.115574, 
        0.809017, -0.587785},{-0.127287, 0.891007, -0.453990},{-0.254573, 
        0.891007, -0.453990}}],
    Polygon[{{-0.115574, 0.809017, -0.587785},{-0.000000, 
        0.809017, -0.587785},{-0.000000, 0.891007, -0.453990},{-0.127287, 
        0.891007, -0.453990}}],
    Polygon[{{-0.000000, 0.809017, -0.587785},{
      0.115574, 0.809017, -0.587785},{
      0.127287, 0.891007, -0.453990},{-0.000000, 0.891007, -0.453990}}],
    Polygon[{{0.115574, 0.809017, -0.587785},{0.231148, 0.809017, -0.587785},{
      0.254573, 0.891007, -0.453990},{0.127287, 0.891007, -0.453990}}],
    Polygon[{{0.231148, 0.809017, -0.587785},{0.346722, 0.809017, -0.587785},{
      0.381860, 0.891007, -0.453990},{0.254573, 0.891007, -0.453990}}],
    Polygon[{{0.346722, 0.809017, -0.587785},{0.462295, 0.809017, -0.587785},{
      0.509147, 0.891007, -0.453990},{0.381860, 0.891007, -0.453990}}],
    Polygon[{{0.462295, 0.809017, -0.587785},{0.577869, 0.809017, -0.587785},{
      0.636433, 0.891007, -0.453990},{0.509147, 0.891007, -0.453990}}],
    Polygon[{{0.577869, 0.809017, -0.587785},{0.693443, 0.809017, -0.587785},{
      0.763720, 0.891007, -0.453990},{0.636433, 0.891007, -0.453990}}],
    Polygon[{{0.693443, 0.809017, -0.587785},{0.809017, 0.809017, -0.587785},{
      0.891007, 0.891007, -0.453990},{0.763720, 0.891007, -0.453990}}],
    Polygon[{{-0.891007, 0.891007, -0.453990},{-0.763720, 
        0.891007, -0.453990},{-0.815191, 0.951057, -0.309017},{-0.951057, 
        0.951057, -0.309017}}],
    Polygon[{{-0.763720, 0.891007, -0.453990},{-0.636433, 
        0.891007, -0.453990},{-0.679326, 0.951057, -0.309017},{-0.815191, 
        0.951057, -0.309017}}],
    Polygon[{{-0.636433, 0.891007, -0.453990},{-0.509147, 
        0.891007, -0.453990},{-0.543461, 0.951057, -0.309017},{-0.679326, 
        0.951057, -0.309017}}],
    Polygon[{{-0.509147, 0.891007, -0.453990},{-0.381860, 
        0.891007, -0.453990},{-0.407596, 0.951057, -0.309017},{-0.543461, 
        0.951057, -0.309017}}],
    Polygon[{{-0.381860, 0.891007, -0.453990},{-0.254573, 
        0.891007, -0.453990},{-0.271730, 0.951057, -0.309017},{-0.407596, 
        0.951057, -0.309017}}],
    Polygon[{{-0.254573, 0.891007, -0.453990},{-0.127287, 
        0.891007, -0.453990},{-0.135865, 0.951057, -0.309017},{-0.271730, 
        0.951057, -0.309017}}],
    Polygon[{{-0.127287, 0.891007, -0.453990},{-0.000000, 
        0.891007, -0.453990},{-0.000000, 0.951057, -0.309017},{-0.135865, 
        0.951057, -0.309017}}],
    Polygon[{{-0.000000, 0.891007, -0.453990},{
      0.127287, 0.891007, -0.453990},{
      0.135865, 0.951057, -0.309017},{-0.000000, 0.951057, -0.309017}}],
    Polygon[{{0.127287, 0.891007, -0.453990},{0.254573, 0.891007, -0.453990},{
      0.271730, 0.951057, -0.309017},{0.135865, 0.951057, -0.309017}}],
    Polygon[{{0.254573, 0.891007, -0.453990},{0.381860, 0.891007, -0.453990},{
      0.407596, 0.951057, -0.309017},{0.271730, 0.951057, -0.309017}}],
    Polygon[{{0.381860, 0.891007, -0.453990},{0.509147, 0.891007, -0.453990},{
      0.543461, 0.951057, -0.309017},{0.407596, 0.951057, -0.309017}}],
    Polygon[{{0.509147, 0.891007, -0.453990},{0.636433, 0.891007, -0.453990},{
      0.679326, 0.951057, -0.309017},{0.543461, 0.951057, -0.309017}}],
    Polygon[{{0.636433, 0.891007, -0.453990},{0.763720, 0.891007, -0.453990},{
      0.815191, 0.951057, -0.309017},{0.679326, 0.951057, -0.309017}}],
    Polygon[{{0.763720, 0.891007, -0.453990},{0.891007, 0.891007, -0.453990},{
      0.951057, 0.951057, -0.309017},{0.815191, 0.951057, -0.309017}}],
    Polygon[{{-0.951057, 0.951057, -0.309017},{-0.815191, 
        0.951057, -0.309017},{-0.846590, 0.987688, -0.156434},{-0.987688, 
        0.987688, -0.156434}}],
    Polygon[{{-0.815191, 0.951057, -0.309017},{-0.679326, 
        0.951057, -0.309017},{-0.705492, 0.987688, -0.156434},{-0.846590, 
        0.987688, -0.156434}}],
    Polygon[{{-0.679326, 0.951057, -0.309017},{-0.543461, 
        0.951057, -0.309017},{-0.564393, 0.987688, -0.156434},{-0.705492, 
        0.987688, -0.156434}}],
    Polygon[{{-0.543461, 0.951057, -0.309017},{-0.407596, 
        0.951057, -0.309017},{-0.423295, 0.987688, -0.156434},{-0.564393, 
        0.987688, -0.156434}}],
    Polygon[{{-0.407596, 0.951057, -0.309017},{-0.271730, 
        0.951057, -0.309017},{-0.282197, 0.987688, -0.156434},{-0.423295, 
        0.987688, -0.156434}}],
    Polygon[{{-0.271730, 0.951057, -0.309017},{-0.135865, 
        0.951057, -0.309017},{-0.141098, 0.987688, -0.156434},{-0.282197, 
        0.987688, -0.156434}}],
    Polygon[{{-0.135865, 0.951057, -0.309017},{-0.000000, 
        0.951057, -0.309017},{-0.000000, 0.987688, -0.156434},{-0.141098, 
        0.987688, -0.156434}}],
    Polygon[{{-0.000000, 0.951057, -0.309017},{
      0.135865, 0.951057, -0.309017},{
      0.141098, 0.987688, -0.156434},{-0.000000, 0.987688, -0.156434}}],
    Polygon[{{0.135865, 0.951057, -0.309017},{0.271730, 0.951057, -0.309017},{
      0.282197, 0.987688, -0.156434},{0.141098, 0.987688, -0.156434}}],
    Polygon[{{0.271730, 0.951057, -0.309017},{0.407596, 0.951057, -0.309017},{
      0.423295, 0.987688, -0.156434},{0.282197, 0.987688, -0.156434}}],
    Polygon[{{0.407596, 0.951057, -0.309017},{0.543461, 0.951057, -0.309017},{
      0.564393, 0.987688, -0.156434},{0.423295, 0.987688, -0.156434}}],
    Polygon[{{0.543461, 0.951057, -0.309017},{0.679326, 0.951057, -0.309017},{
      0.705492, 0.987688, -0.156434},{0.564393, 0.987688, -0.156434}}],
    Polygon[{{0.679326, 0.951057, -0.309017},{0.815191, 0.951057, -0.309017},{
      0.846590, 0.987688, -0.156434},{0.705492, 0.987688, -0.156434}}],
    Polygon[{{0.815191, 0.951057, -0.309017},{0.951057, 0.951057, -0.309017},{
      0.987688, 0.987688, -0.156434},{0.846590, 0.987688, -0.156434}}],
    Polygon[{{-0.987688, 0.987688, -0.156434},{-0.846590, 
        0.987688, -0.156434},{-0.857143, 1.000000, -0.000000},{-1.000000, 
        1.000000, -0.000000}}],
    Polygon[{{-0.846590, 0.987688, -0.156434},{-0.705492, 
        0.987688, -0.156434},{-0.714286, 1.000000, -0.000000},{-0.857143, 
        1.000000, -0.000000}}],
    Polygon[{{-0.705492, 0.987688, -0.156434},{-0.564393, 
        0.987688, -0.156434},{-0.571429, 1.000000, -0.000000},{-0.714286, 
        1.000000, -0.000000}}],
    Polygon[{{-0.564393, 0.987688, -0.156434},{-0.423295, 
        0.987688, -0.156434},{-0.428571, 1.000000, -0.000000},{-0.571429, 
        1.000000, -0.000000}}],
    Polygon[{{-0.423295, 0.987688, -0.156434},{-0.282197, 
        0.987688, -0.156434},{-0.285714, 1.000000, -0.000000},{-0.428571, 
        1.000000, -0.000000}}],
    Polygon[{{-0.282197, 0.987688, -0.156434},{-0.141098, 
        0.987688, -0.156434},{-0.142857, 1.000000, -0.000000},{-0.285714, 
        1.000000, -0.000000}}],
    Polygon[{{-0.141098, 0.987688, -0.156434},{-0.000000, 
        0.987688, -0.156434},{-0.000000, 1.000000, -0.000000},{-0.142857, 
        1.000000, -0.000000}}],
    Polygon[{{-0.000000, 0.987688, -0.156434},{
      0.141098, 0.987688, -0.156434},{
      0.142857, 1.000000, -0.000000},{-0.000000, 1.000000, -0.000000}}],
    Polygon[{{0.141098, 0.987688, -0.156434},{0.282197, 0.987688, -0.156434},{
      0.285714, 1.000000, -0.000000},{0.142857, 1.000000, -0.000000}}],
    Polygon[{{0.282197, 0.987688, -0.156434},{0.423295, 0.987688, -0.156434},{
      0.428571, 1.000000, -0.000000},{0.285714, 1.000000, -0.000000}}],
    Polygon[{{0.423295, 0.987688, -0.156434},{0.564393, 0.987688, -0.156434},{
      0.571429, 1.000000, -0.000000},{0.428571, 1.000000, -0.000000}}],
    Polygon[{{0.564393, 0.987688, -0.156434},{0.705492, 0.987688, -0.156434},{
      0.714286, 1.000000, -0.000000},{0.571429, 1.000000, -0.000000}}],
    Polygon[{{0.705492, 0.987688, -0.156434},{0.846590, 0.987688, -0.156434},{
      0.857143, 1.000000, -0.000000},{0.714286, 1.000000, -0.000000}}],
    Polygon[{{0.846590, 0.987688, -0.156434},{0.987688, 0.987688, -0.156434},{
      1.000000, 1.000000, -0.000000},{0.857143, 1.000000, -0.000000}}],
    Polygon[{{1.000000, -1.000000, 0.000000},{1.000000, -0.857143, 0.000000},{
      0.987688, -0.846590, 0.156434},{0.987688, -0.987688, 0.156434}}],
    Polygon[{{1.000000, -0.857143, 0.000000},{1.000000, -0.714286, 0.000000},{
      0.987688, -0.705492, 0.156434},{0.987688, -0.846590, 0.156434}}],
    Polygon[{{1.000000, -0.714286, 0.000000},{1.000000, -0.571429, 0.000000},{
      0.987688, -0.564393, 0.156434},{0.987688, -0.705492, 0.156434}}],
    Polygon[{{1.000000, -0.571429, 0.000000},{1.000000, -0.428571, 0.000000},{
      0.987688, -0.423295, 0.156434},{0.987688, -0.564393, 0.156434}}],
    Polygon[{{1.000000, -0.428571, 0.000000},{1.000000, -0.285714, 0.000000},{
      0.987688, -0.282197, 0.156434},{0.987688, -0.423295, 0.156434}}],
    Polygon[{{1.000000, -0.285714, 0.000000},{1.000000, -0.142857, 0.000000},{
      0.987688, -0.141098, 0.156434},{0.987688, -0.282197, 0.156434}}],
    Polygon[{{1.000000, -0.142857, 0.000000},{1.000000, -0.000000, 0.000000},{
      0.987688, -0.000000, 0.156434},{0.987688, -0.141098, 0.156434}}],
    Polygon[{{1.000000, -0.000000, 0.000000},{1.000000, 0.142857, 0.000000},{
      0.987688, 0.141098, 0.156434},{0.987688, -0.000000, 0.156434}}],
    Polygon[{{1.000000, 0.142857, 0.000000},{1.000000, 0.285714, 0.000000},{
      0.987688, 0.282197, 0.156434},{0.987688, 0.141098, 0.156434}}],
    Polygon[{{1.000000, 0.285714, 0.000000},{1.000000, 0.428571, 0.000000},{
      0.987688, 0.423295, 0.156434},{0.987688, 0.282197, 0.156434}}],
    Polygon[{{1.000000, 0.428571, 0.000000},{1.000000, 0.571429, 0.000000},{
      0.987688, 0.564393, 0.156434},{0.987688, 0.423295, 0.156434}}],
    Polygon[{{1.000000, 0.571429, 0.000000},{1.000000, 0.714286, 0.000000},{
      0.987688, 0.705492, 0.156434},{0.987688, 0.564393, 0.156434}}],
    Polygon[{{1.000000, 0.714286, 0.000000},{1.000000, 0.857143, 0.000000},{
      0.987688, 0.846590, 0.156434},{0.987688, 0.705492, 0.156434}}],
    Polygon[{{1.000000, 0.857143, 0.000000},{1.000000, 1.000000, 0.000000},{
      0.987688, 0.987688, 0.156434},{0.987688, 0.846590, 0.156434}}],
    Polygon[{{0.987688, -0.987688, 0.156434},{0.987688, -0.846590, 0.156434},{
      0.951057, -0.815191, 0.309017},{0.951057, -0.951057, 0.309017}}],
    Polygon[{{0.987688, -0.846590, 0.156434},{0.987688, -0.705492, 0.156434},{
      0.951057, -0.679326, 0.309017},{0.951057, -0.815191, 0.309017}}],
    Polygon[{{0.987688, -0.705492, 0.156434},{0.987688, -0.564393, 0.156434},{
      0.951057, -0.543461, 0.309017},{0.951057, -0.679326, 0.309017}}],
    Polygon[{{0.987688, -0.564393, 0.156434},{0.987688, -0.423295, 0.156434},{
      0.951057, -0.407596, 0.309017},{0.951057, -0.543461, 0.309017}}],
    Polygon[{{0.987688, -0.423295, 0.156434},{0.987688, -0.282197, 0.156434},{
      0.951057, -0.271730, 0.309017},{0.951057, -0.407596, 0.309017}}],
    Polygon[{{0.987688, -0.282197, 0.156434},{0.987688, -0.141098, 0.156434},{
      0.951057, -0.135865, 0.309017},{0.951057, -0.271730, 0.309017}}],
    Polygon[{{0.987688, -0.141098, 0.156434},{0.987688, -0.000000, 0.156434},{
      0.951057, -0.000000, 0.309017},{0.951057, -0.135865, 0.309017}}],
    Polygon[{{0.987688, -0.000000, 0.156434},{0.987688, 0.141098, 0.156434},{
      0.951057, 0.135865, 0.309017},{0.951057, -0.000000, 0.309017}}],
    Polygon[{{0.987688, 0.141098, 0.156434},{0.987688, 0.282197, 0.156434},{
      0.951057, 0.271730, 0.309017},{0.951057, 0.135865, 0.309017}}],
    Polygon[{{0.987688, 0.282197, 0.156434},{0.987688, 0.423295, 0.156434},{
      0.951057, 0.407596, 0.309017},{0.951057, 0.271730, 0.309017}}],
    Polygon[{{0.987688, 0.423295, 0.156434},{0.987688, 0.564393, 0.156434},{
      0.951057, 0.543461, 0.309017},{0.951057, 0.407596, 0.309017}}],
    Polygon[{{0.987688, 0.564393, 0.156434},{0.987688, 0.705492, 0.156434},{
      0.951057, 0.679326, 0.309017},{0.951057, 0.543461, 0.309017}}],
    Polygon[{{0.987688, 0.705492, 0.156434},{0.987688, 0.846590, 0.156434},{
      0.951057, 0.815191, 0.309017},{0.951057, 0.679326, 0.309017}}],
    Polygon[{{0.987688, 0.846590, 0.156434},{0.987688, 0.987688, 0.156434},{
      0.951057, 0.951057, 0.309017},{0.951057, 0.815191, 0.309017}}],
    Polygon[{{0.951057, -0.951057, 0.309017},{0.951057, -0.815191, 0.309017},{
      0.891007, -0.763720, 0.453990},{0.891007, -0.891007, 0.453990}}],
    Polygon[{{0.951057, -0.815191, 0.309017},{0.951057, -0.679326, 0.309017},{
      0.891007, -0.636433, 0.453990},{0.891007, -0.763720, 0.453990}}],
    Polygon[{{0.951057, -0.679326, 0.309017},{0.951057, -0.543461, 0.309017},{
      0.891007, -0.509147, 0.453990},{0.891007, -0.636433, 0.453990}}],
    Polygon[{{0.951057, -0.543461, 0.309017},{0.951057, -0.407596, 0.309017},{
      0.891007, -0.381860, 0.453990},{0.891007, -0.509147, 0.453990}}],
    Polygon[{{0.951057, -0.407596, 0.309017},{0.951057, -0.271730, 0.309017},{
      0.891007, -0.254573, 0.453990},{0.891007, -0.381860, 0.453990}}],
    Polygon[{{0.951057, -0.271730, 0.309017},{0.951057, -0.135865, 0.309017},{
      0.891007, -0.127287, 0.453990},{0.891007, -0.254573, 0.453990}}],
    Polygon[{{0.951057, -0.135865, 0.309017},{0.951057, -0.000000, 0.309017},{
      0.891007, -0.000000, 0.453990},{0.891007, -0.127287, 0.453990}}],
    Polygon[{{0.951057, -0.000000, 0.309017},{0.951057, 0.135865, 0.309017},{
      0.891007, 0.127287, 0.453990},{0.891007, -0.000000, 0.453990}}],
    Polygon[{{0.951057, 0.135865, 0.309017},{0.951057, 0.271730, 0.309017},{
      0.891007, 0.254573, 0.453990},{0.891007, 0.127287, 0.453990}}],
    Polygon[{{0.951057, 0.271730, 0.309017},{0.951057, 0.407596, 0.309017},{
      0.891007, 0.381860, 0.453990},{0.891007, 0.254573, 0.453990}}],
    Polygon[{{0.951057, 0.407596, 0.309017},{0.951057, 0.543461, 0.309017},{
      0.891007, 0.509147, 0.453990},{0.891007, 0.381860, 0.453990}}],
    Polygon[{{0.951057, 0.543461, 0.309017},{0.951057, 0.679326, 0.309017},{
      0.891007, 0.636433, 0.453990},{0.891007, 0.509147, 0.453990}}],
    Polygon[{{0.951057, 0.679326, 0.309017},{0.951057, 0.815191, 0.309017},{
      0.891007, 0.763720, 0.453990},{0.891007, 0.636433, 0.453990}}],
    Polygon[{{0.951057, 0.815191, 0.309017},{0.951057, 0.951057, 0.309017},{
      0.891007, 0.891007, 0.453990},{0.891007, 0.763720, 0.453990}}],
    Polygon[{{0.891007, -0.891007, 0.453990},{0.891007, -0.763720, 0.453990},{
      0.809017, -0.693443, 0.587785},{0.809017, -0.809017, 0.587785}}],
    Polygon[{{0.891007, -0.763720, 0.453990},{0.891007, -0.636433, 0.453990},{
      0.809017, -0.577869, 0.587785},{0.809017, -0.693443, 0.587785}}],
    Polygon[{{0.891007, -0.636433, 0.453990},{0.891007, -0.509147, 0.453990},{
      0.809017, -0.462295, 0.587785},{0.809017, -0.577869, 0.587785}}],
    Polygon[{{0.891007, -0.509147, 0.453990},{0.891007, -0.381860, 0.453990},{
      0.809017, -0.346722, 0.587785},{0.809017, -0.462295, 0.587785}}],
    Polygon[{{0.891007, -0.381860, 0.453990},{0.891007, -0.254573, 0.453990},{
      0.809017, -0.231148, 0.587785},{0.809017, -0.346722, 0.587785}}],
    Polygon[{{0.891007, -0.254573, 0.453990},{0.891007, -0.127287, 0.453990},{
      0.809017, -0.115574, 0.587785},{0.809017, -0.231148, 0.587785}}],
    Polygon[{{0.891007, -0.127287, 0.453990},{0.891007, -0.000000, 0.453990},{
      0.809017, -0.000000, 0.587785},{0.809017, -0.115574, 0.587785}}],
    Polygon[{{0.891007, -0.000000, 0.453990},{0.891007, 0.127287, 0.453990},{
      0.809017, 0.115574, 0.587785},{0.809017, -0.000000, 0.587785}}],
    Polygon[{{0.891007, 0.127287, 0.453990},{0.891007, 0.254573, 0.453990},{
      0.809017, 0.231148, 0.587785},{0.809017, 0.115574, 0.587785}}],
    Polygon[{{0.891007, 0.254573, 0.453990},{0.891007, 0.381860, 0.453990},{
      0.809017, 0.346722, 0.587785},{0.809017, 0.231148, 0.587785}}],
    Polygon[{{0.891007, 0.381860, 0.453990},{0.891007, 0.509147, 0.453990},{
      0.809017, 0.462295, 0.587785},{0.809017, 0.346722, 0.587785}}],
    Polygon[{{0.891007, 0.509147, 0.453990},{0.891007, 0.636433, 0.453990},{
      0.809017, 0.577869, 0.587785},{0.809017, 0.462295, 0.587785}}],
    Polygon[{{0.891007, 0.636433, 0.453990},{0.891007, 0.763720, 0.453990},{
      0.809017, 0.693443, 0.587785},{0.809017, 0.577869, 0.587785}}],
    Polygon[{{0.891007, 0.763720, 0.453990},{0.891007, 0.891007, 0.453990},{
      0.809017, 0.809017, 0.587785},{0.809017, 0.693443, 0.587785}}],
    Polygon[{{0.809017, -0.809017, 0.587785},{0.809017, -0.693443, 0.587785},{
      0.707107, -0.606091, 0.707107},{0.707107, -0.707107, 0.707107}}],
    Polygon[{{0.809017, -0.693443, 0.587785},{0.809017, -0.577869, 0.587785},{
      0.707107, -0.505076, 0.707107},{0.707107, -0.606091, 0.707107}}],
    Polygon[{{0.809017, -0.577869, 0.587785},{0.809017, -0.462295, 0.587785},{
      0.707107, -0.404061, 0.707107},{0.707107, -0.505076, 0.707107}}],
    Polygon[{{0.809017, -0.462295, 0.587785},{0.809017, -0.346722, 0.587785},{
      0.707107, -0.303046, 0.707107},{0.707107, -0.404061, 0.707107}}],
    Polygon[{{0.809017, -0.346722, 0.587785},{0.809017, -0.231148, 0.587785},{
      0.707107, -0.202031, 0.707107},{0.707107, -0.303046, 0.707107}}],
    Polygon[{{0.809017, -0.231148, 0.587785},{0.809017, -0.115574, 0.587785},{
      0.707107, -0.101015, 0.707107},{0.707107, -0.202031, 0.707107}}],
    Polygon[{{0.809017, -0.115574, 0.587785},{0.809017, -0.000000, 0.587785},{
      0.707107, -0.000000, 0.707107},{0.707107, -0.101015, 0.707107}}],
    Polygon[{{0.809017, -0.000000, 0.587785},{0.809017, 0.115574, 0.587785},{
      0.707107, 0.101015, 0.707107},{0.707107, -0.000000, 0.707107}}],
    Polygon[{{0.809017, 0.115574, 0.587785},{0.809017, 0.231148, 0.587785},{
      0.707107, 0.202031, 0.707107},{0.707107, 0.101015, 0.707107}}],
    Polygon[{{0.809017, 0.231148, 0.587785},{0.809017, 0.346722, 0.587785},{
      0.707107, 0.303046, 0.707107},{0.707107, 0.202031, 0.707107}}],
    Polygon[{{0.809017, 0.346722, 0.587785},{0.809017, 0.462295, 0.587785},{
      0.707107, 0.404061, 0.707107},{0.707107, 0.303046, 0.707107}}],
    Polygon[{{0.809017, 0.462295, 0.587785},{0.809017, 0.577869, 0.587785},{
      0.707107, 0.505076, 0.707107},{0.707107, 0.404061, 0.707107}}],
    Polygon[{{0.809017, 0.577869, 0.587785},{0.809017, 0.693443, 0.587785},{
      0.707107, 0.606091, 0.707107},{0.707107, 0.505076, 0.707107}}],
    Polygon[{{0.809017, 0.693443, 0.587785},{0.809017, 0.809017, 0.587785},{
      0.707107, 0.707107, 0.707107},{0.707107, 0.606091, 0.707107}}],
    Polygon[{{0.707107, -0.707107, 0.707107},{0.707107, -0.606091, 0.707107},{
      0.587785, -0.503816, 0.809017},{0.587785, -0.587785, 0.809017}}],
    Polygon[{{0.707107, -0.606091, 0.707107},{0.707107, -0.505076, 0.707107},{
      0.587785, -0.419847, 0.809017},{0.587785, -0.503816, 0.809017}}],
    Polygon[{{0.707107, -0.505076, 0.707107},{0.707107, -0.404061, 0.707107},{
      0.587785, -0.335877, 0.809017},{0.587785, -0.419847, 0.809017}}],
    Polygon[{{0.707107, -0.404061, 0.707107},{0.707107, -0.303046, 0.707107},{
      0.587785, -0.251908, 0.809017},{0.587785, -0.335877, 0.809017}}],
    Polygon[{{0.707107, -0.303046, 0.707107},{0.707107, -0.202031, 0.707107},{
      0.587785, -0.167939, 0.809017},{0.587785, -0.251908, 0.809017}}],
    Polygon[{{0.707107, -0.202031, 0.707107},{0.707107, -0.101015, 0.707107},{
      0.587785, -0.083969, 0.809017},{0.587785, -0.167939, 0.809017}}],
    Polygon[{{0.707107, -0.101015, 0.707107},{0.707107, -0.000000, 0.707107},{
      0.587785, -0.000000, 0.809017},{0.587785, -0.083969, 0.809017}}],
    Polygon[{{0.707107, -0.000000, 0.707107},{0.707107, 0.101015, 0.707107},{
      0.587785, 0.083969, 0.809017},{0.587785, -0.000000, 0.809017}}],
    Polygon[{{0.707107, 0.101015, 0.707107},{0.707107, 0.202031, 0.707107},{
      0.587785, 0.167939, 0.809017},{0.587785, 0.083969, 0.809017}}],
    Polygon[{{0.707107, 0.202031, 0.707107},{0.707107, 0.303046, 0.707107},{
      0.587785, 0.251908, 0.809017},{0.587785, 0.167939, 0.809017}}],
    Polygon[{{0.707107, 0.303046, 0.707107},{0.707107, 0.404061, 0.707107},{
      0.587785, 0.335877, 0.809017},{0.587785, 0.251908, 0.809017}}],
    Polygon[{{0.707107, 0.404061, 0.707107},{0.707107, 0.505076, 0.707107},{
      0.587785, 0.419847, 0.809017},{0.587785, 0.335877, 0.809017}}],
    Polygon[{{0.707107, 0.505076, 0.707107},{0.707107, 0.606091, 0.707107},{
      0.587785, 0.503816, 0.809017},{0.587785, 0.419847, 0.809017}}],
    Polygon[{{0.707107, 0.606091, 0.707107},{0.707107, 0.707107, 0.707107},{
      0.587785, 0.587785, 0.809017},{0.587785, 0.503816, 0.809017}}],
    Polygon[{{0.587785, -0.587785, 0.809017},{0.587785, -0.503816, 0.809017},{
      0.453990, -0.389135, 0.891007},{0.453990, -0.453990, 0.891007}}],
    Polygon[{{0.587785, -0.503816, 0.809017},{0.587785, -0.419847, 0.809017},{
      0.453990, -0.324279, 0.891007},{0.453990, -0.389135, 0.891007}}],
    Polygon[{{0.587785, -0.419847, 0.809017},{0.587785, -0.335877, 0.809017},{
      0.453990, -0.259423, 0.891007},{0.453990, -0.324279, 0.891007}}],
    Polygon[{{0.587785, -0.335877, 0.809017},{0.587785, -0.251908, 0.809017},{
      0.453990, -0.194567, 0.891007},{0.453990, -0.259423, 0.891007}}],
    Polygon[{{0.587785, -0.251908, 0.809017},{0.587785, -0.167939, 0.809017},{
      0.453990, -0.129712, 0.891007},{0.453990, -0.194567, 0.891007}}],
    Polygon[{{0.587785, -0.167939, 0.809017},{0.587785, -0.083969, 0.809017},{
      0.453990, -0.064856, 0.891007},{0.453990, -0.129712, 0.891007}}],
    Polygon[{{0.587785, -0.083969, 0.809017},{0.587785, -0.000000, 0.809017},{
      0.453990, -0.000000, 0.891007},{0.453990, -0.064856, 0.891007}}],
    Polygon[{{0.587785, -0.000000, 0.809017},{0.587785, 0.083969, 0.809017},{
      0.453990, 0.064856, 0.891007},{0.453990, -0.000000, 0.891007}}],
    Polygon[{{0.587785, 0.083969, 0.809017},{0.587785, 0.167939, 0.809017},{
      0.453990, 0.129712, 0.891007},{0.453990, 0.064856, 0.891007}}],
    Polygon[{{0.587785, 0.167939, 0.809017},{0.587785, 0.251908, 0.809017},{
      0.453990, 0.194567, 0.891007},{0.453990, 0.129712, 0.891007}}],
    Polygon[{{0.587785, 0.251908, 0.809017},{0.587785, 0.335877, 0.809017},{
      0.453990, 0.259423, 0.891007},{0.453990, 0.194567, 0.891007}}],
    Polygon[{{0.587785, 0.335877, 0.809017},{0.587785, 0.419847, 0.809017},{
      0.453990, 0.324279, 0.891007},{0.453990, 0.259423, 0.891007}}],
    Polygon[{{0.587785, 0.419847, 0.809017},{0.587785, 0.503816, 0.809017},{
      0.453990, 0.389135, 0.891007},{0.453990, 0.324279, 0.891007}}],
    Polygon[{{0.587785, 0.503816, 0.809017},{0.587785, 0.587785, 0.809017},{
      0.453990, 0.453990, 0.891007},{0.453990, 0.389135, 0.891007}}],
    Polygon[{{0.453990, -0.453990, 0.891007},{0.453990, -0.389135, 0.891007},{
      0.309017, -0.264872, 0.951057},{0.309017, -0.309017, 0.951057}}],
    Polygon[{{0.453990, -0.389135, 0.891007},{0.453990, -0.324279, 0.891007},{
      0.309017, -0.220726, 0.951057},{0.309017, -0.264872, 0.951057}}],
    Polygon[{{0.453990, -0.324279, 0.891007},{0.453990, -0.259423, 0.891007},{
      0.309017, -0.176581, 0.951057},{0.309017, -0.220726, 0.951057}}],
    Polygon[{{0.453990, -0.259423, 0.891007},{0.453990, -0.194567, 0.891007},{
      0.309017, -0.132436, 0.951057},{0.309017, -0.176581, 0.951057}}],
    Polygon[{{0.453990, -0.194567, 0.891007},{0.453990, -0.129712, 0.891007},{
      0.309017, -0.088291, 0.951057},{0.309017, -0.132436, 0.951057}}],
    Polygon[{{0.453990, -0.129712, 0.891007},{0.453990, -0.064856, 0.891007},{
      0.309017, -0.044145, 0.951057},{0.309017, -0.088291, 0.951057}}],
    Polygon[{{0.453990, -0.064856, 0.891007},{0.453990, -0.000000, 0.891007},{
      0.309017, -0.000000, 0.951057},{0.309017, -0.044145, 0.951057}}],
    Polygon[{{0.453990, -0.000000, 0.891007},{0.453990, 0.064856, 0.891007},{
      0.309017, 0.044145, 0.951057},{0.309017, -0.000000, 0.951057}}],
    Polygon[{{0.453990, 0.064856, 0.891007},{0.453990, 0.129712, 0.891007},{
      0.309017, 0.088291, 0.951057},{0.309017, 0.044145, 0.951057}}],
    Polygon[{{0.453990, 0.129712, 0.891007},{0.453990, 0.194567, 0.891007},{
      0.309017, 0.132436, 0.951057},{0.309017, 0.088291, 0.951057}}],
    Polygon[{{0.453990, 0.194567, 0.891007},{0.453990, 0.259423, 0.891007},{
      0.309017, 0.176581, 0.951057},{0.309017, 0.132436, 0.951057}}],
    Polygon[{{0.453990, 0.259423, 0.891007},{0.453990, 0.324279, 0.891007},{
      0.309017, 0.220726, 0.951057},{0.309017, 0.176581, 0.951057}}],
    Polygon[{{0.453990, 0.324279, 0.891007},{0.453990, 0.389135, 0.891007},{
      0.309017, 0.264872, 0.951057},{0.309017, 0.220726, 0.951057}}],
    Polygon[{{0.453990, 0.389135, 0.891007},{0.453990, 0.453990, 0.891007},{
      0.309017, 0.309017, 0.951057},{0.309017, 0.264872, 0.951057}}],
    Polygon[{{0.309017, -0.309017, 0.951057},{0.309017, -0.264872, 0.951057},{
      0.156434, -0.134087, 0.987688},{0.156434, -0.156434, 0.987688}}],
    Polygon[{{0.309017, -0.264872, 0.951057},{0.309017, -0.220726, 0.951057},{
      0.156434, -0.111739, 0.987688},{0.156434, -0.134087, 0.987688}}],
    Polygon[{{0.309017, -0.220726, 0.951057},{0.309017, -0.176581, 0.951057},{
      0.156434, -0.089391, 0.987688},{0.156434, -0.111739, 0.987688}}],
    Polygon[{{0.309017, -0.176581, 0.951057},{0.309017, -0.132436, 0.951057},{
      0.156434, -0.067043, 0.987688},{0.156434, -0.089391, 0.987688}}],
    Polygon[{{0.309017, -0.132436, 0.951057},{0.309017, -0.088291, 0.951057},{
      0.156434, -0.044696, 0.987688},{0.156434, -0.067043, 0.987688}}],
    Polygon[{{0.309017, -0.088291, 0.951057},{0.309017, -0.044145, 0.951057},{
      0.156434, -0.022348, 0.987688},{0.156434, -0.044696, 0.987688}}],
    Polygon[{{0.309017, -0.044145, 0.951057},{0.309017, -0.000000, 0.951057},{
      0.156434, -0.000000, 0.987688},{0.156434, -0.022348, 0.987688}}],
    Polygon[{{0.309017, -0.000000, 0.951057},{0.309017, 0.044145, 0.951057},{
      0.156434, 0.022348, 0.987688},{0.156434, -0.000000, 0.987688}}],
    Polygon[{{0.309017, 0.044145, 0.951057},{0.309017, 0.088291, 0.951057},{
      0.156434, 0.044696, 0.987688},{0.156434, 0.022348, 0.987688}}],
    Polygon[{{0.309017, 0.088291, 0.951057},{0.309017, 0.132436, 0.951057},{
      0.156434, 0.067043, 0.987688},{0.156434, 0.044696, 0.987688}}],
    Polygon[{{0.309017, 0.132436, 0.951057},{0.309017, 0.176581, 0.951057},{
      0.156434, 0.089391, 0.987688},{0.156434, 0.067043, 0.987688}}],
    Polygon[{{0.309017, 0.176581, 0.951057},{0.309017, 0.220726, 0.951057},{
      0.156434, 0.111739, 0.987688},{0.156434, 0.089391, 0.987688}}],
    Polygon[{{0.309017, 0.220726, 0.951057},{0.309017, 0.264872, 0.951057},{
      0.156434, 0.134087, 0.987688},{0.156434, 0.111739, 0.987688}}],
    Polygon[{{0.309017, 0.264872, 0.951057},{0.309017, 0.309017, 0.951057},{
      0.156434, 0.156434, 0.987688},{0.156434, 0.134087, 0.987688}}],
    Polygon[{{0.156434, -0.156434, 0.987688},{0.156434, -0.134087, 0.987688},{
      0.000000, -0.000000, 1.000000},{0.000000, -0.000000, 1.000000}}],
    Polygon[{{0.156434, -0.134087, 0.987688},{0.156434, -0.111739, 0.987688},{
      0.000000, -0.000000, 1.000000},{0.000000, -0.000000, 1.000000}}],
    Polygon[{{0.156434, -0.111739, 0.987688},{0.156434, -0.089391, 0.987688},{
      0.000000, -0.000000, 1.000000},{0.000000, -0.000000, 1.000000}}],
    Polygon[{{0.156434, -0.089391, 0.987688},{0.156434, -0.067043, 0.987688},{
      0.000000, -0.000000, 1.000000},{0.000000, -0.000000, 1.000000}}],
    Polygon[{{0.156434, -0.067043, 0.987688},{0.156434, -0.044696, 0.987688},{
      0.000000, -0.000000, 1.000000},{0.000000, -0.000000, 1.000000}}],
    Polygon[{{0.156434, -0.044696, 0.987688},{0.156434, -0.022348, 0.987688},{
      0.000000, -0.000000, 1.000000},{0.000000, -0.000000, 1.000000}}],
    Polygon[{{0.156434, -0.022348, 0.987688},{0.156434, -0.000000, 0.987688},{
      0.000000, -0.000000, 1.000000},{0.000000, -0.000000, 1.000000}}],
    Polygon[{{0.156434, -0.000000, 0.987688},{0.156434, 0.022348, 0.987688},{
      0.000000, 0.000000, 1.000000},{0.000000, -0.000000, 1.000000}}],
    Polygon[{{0.156434, 0.022348, 0.987688},{0.156434, 0.044696, 0.987688},{
      0.000000, 0.000000, 1.000000},{0.000000, 0.000000, 1.000000}}],
    Polygon[{{0.156434, 0.044696, 0.987688},{0.156434, 0.067043, 0.987688},{
      0.000000, 0.000000, 1.000000},{0.000000, 0.000000, 1.000000}}],
    Polygon[{{0.156434, 0.067043, 0.987688},{0.156434, 0.089391, 0.987688},{
      0.000000, 0.000000, 1.000000},{0.000000, 0.000000, 1.000000}}],
    Polygon[{{0.156434, 0.089391, 0.987688},{0.156434, 0.111739, 0.987688},{
      0.000000, 0.000000, 1.000000},{0.000000, 0.000000, 1.000000}}],
    Polygon[{{0.156434, 0.111739, 0.987688},{0.156434, 0.134087, 0.987688},{
      0.000000, 0.000000, 1.000000},{0.000000, 0.000000, 1.000000}}],
    Polygon[{{0.156434, 0.134087, 0.987688},{0.156434, 0.156434, 0.987688},{
      0.000000, 0.000000, 1.000000},{0.000000, 0.000000, 1.000000}}],
    Polygon[{{0.000000, -0.000000, 1.000000},{
      0.000000, -0.000000, 1.000000},{-0.156434, 0.134087, 
        0.987688},{-0.156434, 0.156434, 0.987688}}],
    Polygon[{{0.000000, -0.000000, 1.000000},{
      0.000000, -0.000000, 1.000000},{-0.156434, 0.111739, 
        0.987688},{-0.156434, 0.134087, 0.987688}}],
    Polygon[{{0.000000, -0.000000, 1.000000},{
      0.000000, -0.000000, 1.000000},{-0.156434, 0.089391, 
        0.987688},{-0.156434, 0.111739, 0.987688}}],
    Polygon[{{0.000000, -0.000000, 1.000000},{
      0.000000, -0.000000, 1.000000},{-0.156434, 0.067043, 
        0.987688},{-0.156434, 0.089391, 0.987688}}],
    Polygon[{{0.000000, -0.000000, 1.000000},{
      0.000000, -0.000000, 1.000000},{-0.156434, 0.044696, 
        0.987688},{-0.156434, 0.067043, 0.987688}}],
    Polygon[{{0.000000, -0.000000, 1.000000},{
      0.000000, -0.000000, 1.000000},{-0.156434, 0.022348, 
        0.987688},{-0.156434, 0.044696, 0.987688}}],
    Polygon[{{0.000000, -0.000000, 1.000000},{
      0.000000, -0.000000, 1.000000},{-0.156434, 0.000000, 
        0.987688},{-0.156434, 0.022348, 0.987688}}],
    Polygon[{{0.000000, -0.000000, 1.000000},{
      0.000000, 0.000000, 1.000000},{-0.156434, -0.022348, 
        0.987688},{-0.156434, 0.000000, 0.987688}}],
    Polygon[{{0.000000, 0.000000, 1.000000},{
      0.000000, 0.000000, 1.000000},{-0.156434, -0.044696, 
        0.987688},{-0.156434, -0.022348, 0.987688}}],
    Polygon[{{0.000000, 0.000000, 1.000000},{
      0.000000, 0.000000, 1.000000},{-0.156434, -0.067043, 
        0.987688},{-0.156434, -0.044696, 0.987688}}],
    Polygon[{{0.000000, 0.000000, 1.000000},{
      0.000000, 0.000000, 1.000000},{-0.156434, -0.089391, 
        0.987688},{-0.156434, -0.067043, 0.987688}}],
    Polygon[{{0.000000, 0.000000, 1.000000},{
      0.000000, 0.000000, 1.000000},{-0.156434, -0.111739, 
        0.987688},{-0.156434, -0.089391, 0.987688}}],
    Polygon[{{0.000000, 0.000000, 1.000000},{
      0.000000, 0.000000, 1.000000},{-0.156434, -0.134087, 
        0.987688},{-0.156434, -0.111739, 0.987688}}],
    Polygon[{{0.000000, 0.000000, 1.000000},{
      0.000000, 0.000000, 1.000000},{-0.156434, -0.156434, 
        0.987688},{-0.156434, -0.134087, 0.987688}}],
    Polygon[{{-0.156434, 0.156434, 0.987688},{-0.156434, 0.134087, 
        0.987688},{-0.309017, 0.264872, 0.951057},{-0.309017, 0.309017, 
        0.951057}}],
    Polygon[{{-0.156434, 0.134087, 0.987688},{-0.156434, 0.111739, 
        0.987688},{-0.309017, 0.220726, 0.951057},{-0.309017, 0.264872, 
        0.951057}}],
    Polygon[{{-0.156434, 0.111739, 0.987688},{-0.156434, 0.089391, 
        0.987688},{-0.309017, 0.176581, 0.951057},{-0.309017, 0.220726, 
        0.951057}}],
    Polygon[{{-0.156434, 0.089391, 0.987688},{-0.156434, 0.067043, 
        0.987688},{-0.309017, 0.132436, 0.951057},{-0.309017, 0.176581, 
        0.951057}}],
    Polygon[{{-0.156434, 0.067043, 0.987688},{-0.156434, 0.044696, 
        0.987688},{-0.309017, 0.088291, 0.951057},{-0.309017, 0.132436, 
        0.951057}}],
    Polygon[{{-0.156434, 0.044696, 0.987688},{-0.156434, 0.022348, 
        0.987688},{-0.309017, 0.044145, 0.951057},{-0.309017, 0.088291, 
        0.951057}}],
    Polygon[{{-0.156434, 0.022348, 0.987688},{-0.156434, 0.000000, 
        0.987688},{-0.309017, 0.000000, 0.951057},{-0.309017, 0.044145, 
        0.951057}}],
    Polygon[{{-0.156434, 0.000000, 0.987688},{-0.156434, -0.022348, 
        0.987688},{-0.309017, -0.044145, 0.951057},{-0.309017, 0.000000, 
        0.951057}}],
    Polygon[{{-0.156434, -0.022348, 0.987688},{-0.156434, -0.044696, 
        0.987688},{-0.309017, -0.088291, 0.951057},{-0.309017, -0.044145, 
        0.951057}}],
    Polygon[{{-0.156434, -0.044696, 0.987688},{-0.156434, -0.067043, 
        0.987688},{-0.309017, -0.132436, 0.951057},{-0.309017, -0.088291, 
        0.951057}}],
    Polygon[{{-0.156434, -0.067043, 0.987688},{-0.156434, -0.089391, 
        0.987688},{-0.309017, -0.176581, 0.951057},{-0.309017, -0.132436, 
        0.951057}}],
    Polygon[{{-0.156434, -0.089391, 0.987688},{-0.156434, -0.111739, 
        0.987688},{-0.309017, -0.220726, 0.951057},{-0.309017, -0.176581, 
        0.951057}}],
    Polygon[{{-0.156434, -0.111739, 0.987688},{-0.156434, -0.134087, 
        0.987688},{-0.309017, -0.264872, 0.951057},{-0.309017, -0.220726, 
        0.951057}}],
    Polygon[{{-0.156434, -0.134087, 0.987688},{-0.156434, -0.156434, 
        0.987688},{-0.309017, -0.309017, 0.951057},{-0.309017, -0.264872, 
        0.951057}}],
    Polygon[{{-0.309017, 0.309017, 0.951057},{-0.309017, 0.264872, 
        0.951057},{-0.453990, 0.389135, 0.891007},{-0.453990, 0.453990, 
        0.891007}}],
    Polygon[{{-0.309017, 0.264872, 0.951057},{-0.309017, 0.220726, 
        0.951057},{-0.453990, 0.324279, 0.891007},{-0.453990, 0.389135, 
        0.891007}}],
    Polygon[{{-0.309017, 0.220726, 0.951057},{-0.309017, 0.176581, 
        0.951057},{-0.453990, 0.259423, 0.891007},{-0.453990, 0.324279, 
        0.891007}}],
    Polygon[{{-0.309017, 0.176581, 0.951057},{-0.309017, 0.132436, 
        0.951057},{-0.453990, 0.194567, 0.891007},{-0.453990, 0.259423, 
        0.891007}}],
    Polygon[{{-0.309017, 0.132436, 0.951057},{-0.309017, 0.088291, 
        0.951057},{-0.453990, 0.129712, 0.891007},{-0.453990, 0.194567, 
        0.891007}}],
    Polygon[{{-0.309017, 0.088291, 0.951057},{-0.309017, 0.044145, 
        0.951057},{-0.453990, 0.064856, 0.891007},{-0.453990, 0.129712, 
        0.891007}}],
    Polygon[{{-0.309017, 0.044145, 0.951057},{-0.309017, 0.000000, 
        0.951057},{-0.453990, 0.000000, 0.891007},{-0.453990, 0.064856, 
        0.891007}}],
    Polygon[{{-0.309017, 0.000000, 0.951057},{-0.309017, -0.044145, 
        0.951057},{-0.453990, -0.064856, 0.891007},{-0.453990, 0.000000, 
        0.891007}}],
    Polygon[{{-0.309017, -0.044145, 0.951057},{-0.309017, -0.088291, 
        0.951057},{-0.453990, -0.129712, 0.891007},{-0.453990, -0.064856, 
        0.891007}}],
    Polygon[{{-0.309017, -0.088291, 0.951057},{-0.309017, -0.132436, 
        0.951057},{-0.453990, -0.194567, 0.891007},{-0.453990, -0.129712, 
        0.891007}}],
    Polygon[{{-0.309017, -0.132436, 0.951057},{-0.309017, -0.176581, 
        0.951057},{-0.453990, -0.259423, 0.891007},{-0.453990, -0.194567, 
        0.891007}}],
    Polygon[{{-0.309017, -0.176581, 0.951057},{-0.309017, -0.220726, 
        0.951057},{-0.453990, -0.324279, 0.891007},{-0.453990, -0.259423, 
        0.891007}}],
    Polygon[{{-0.309017, -0.220726, 0.951057},{-0.309017, -0.264872, 
        0.951057},{-0.453990, -0.389135, 0.891007},{-0.453990, -0.324279, 
        0.891007}}],
    Polygon[{{-0.309017, -0.264872, 0.951057},{-0.309017, -0.309017, 
        0.951057},{-0.453990, -0.453990, 0.891007},{-0.453990, -0.389135, 
        0.891007}}],
    Polygon[{{-0.453990, 0.453990, 0.891007},{-0.453990, 0.389135, 
        0.891007},{-0.587785, 0.503816, 0.809017},{-0.587785, 0.587785, 
        0.809017}}],
    Polygon[{{-0.453990, 0.389135, 0.891007},{-0.453990, 0.324279, 
        0.891007},{-0.587785, 0.419847, 0.809017},{-0.587785, 0.503816, 
        0.809017}}],
    Polygon[{{-0.453990, 0.324279, 0.891007},{-0.453990, 0.259423, 
        0.891007},{-0.587785, 0.335877, 0.809017},{-0.587785, 0.419847, 
        0.809017}}],
    Polygon[{{-0.453990, 0.259423, 0.891007},{-0.453990, 0.194567, 
        0.891007},{-0.587785, 0.251908, 0.809017},{-0.587785, 0.335877, 
        0.809017}}],
    Polygon[{{-0.453990, 0.194567, 0.891007},{-0.453990, 0.129712, 
        0.891007},{-0.587785, 0.167939, 0.809017},{-0.587785, 0.251908, 
        0.809017}}],
    Polygon[{{-0.453990, 0.129712, 0.891007},{-0.453990, 0.064856, 
        0.891007},{-0.587785, 0.083969, 0.809017},{-0.587785, 0.167939, 
        0.809017}}],
    Polygon[{{-0.453990, 0.064856, 0.891007},{-0.453990, 0.000000, 
        0.891007},{-0.587785, 0.000000, 0.809017},{-0.587785, 0.083969, 
        0.809017}}],
    Polygon[{{-0.453990, 0.000000, 0.891007},{-0.453990, -0.064856, 
        0.891007},{-0.587785, -0.083969, 0.809017},{-0.587785, 0.000000, 
        0.809017}}],
    Polygon[{{-0.453990, -0.064856, 0.891007},{-0.453990, -0.129712, 
        0.891007},{-0.587785, -0.167939, 0.809017},{-0.587785, -0.083969, 
        0.809017}}],
    Polygon[{{-0.453990, -0.129712, 0.891007},{-0.453990, -0.194567, 
        0.891007},{-0.587785, -0.251908, 0.809017},{-0.587785, -0.167939, 
        0.809017}}],
    Polygon[{{-0.453990, -0.194567, 0.891007},{-0.453990, -0.259423, 
        0.891007},{-0.587785, -0.335877, 0.809017},{-0.587785, -0.251908, 
        0.809017}}],
    Polygon[{{-0.453990, -0.259423, 0.891007},{-0.453990, -0.324279, 
        0.891007},{-0.587785, -0.419847, 0.809017},{-0.587785, -0.335877, 
        0.809017}}],
    Polygon[{{-0.453990, -0.324279, 0.891007},{-0.453990, -0.389135, 
        0.891007},{-0.587785, -0.503816, 0.809017},{-0.587785, -0.419847, 
        0.809017}}],
    Polygon[{{-0.453990, -0.389135, 0.891007},{-0.453990, -0.453990, 
        0.891007},{-0.587785, -0.587785, 0.809017},{-0.587785, -0.503816, 
        0.809017}}],
    Polygon[{{-0.587785, 0.587785, 0.809017},{-0.587785, 0.503816, 
        0.809017},{-0.707107, 0.606091, 0.707107},{-0.707107, 0.707107, 
        0.707107}}],
    Polygon[{{-0.587785, 0.503816, 0.809017},{-0.587785, 0.419847, 
        0.809017},{-0.707107, 0.505076, 0.707107},{-0.707107, 0.606091, 
        0.707107}}],
    Polygon[{{-0.587785, 0.419847, 0.809017},{-0.587785, 0.335877, 
        0.809017},{-0.707107, 0.404061, 0.707107},{-0.707107, 0.505076, 
        0.707107}}],
    Polygon[{{-0.587785, 0.335877, 0.809017},{-0.587785, 0.251908, 
        0.809017},{-0.707107, 0.303046, 0.707107},{-0.707107, 0.404061, 
        0.707107}}],
    Polygon[{{-0.587785, 0.251908, 0.809017},{-0.587785, 0.167939, 
        0.809017},{-0.707107, 0.202031, 0.707107},{-0.707107, 0.303046, 
        0.707107}}],
    Polygon[{{-0.587785, 0.167939, 0.809017},{-0.587785, 0.083969, 
        0.809017},{-0.707107, 0.101015, 0.707107},{-0.707107, 0.202031, 
        0.707107}}],
    Polygon[{{-0.587785, 0.083969, 0.809017},{-0.587785, 0.000000, 
        0.809017},{-0.707107, 0.000000, 0.707107},{-0.707107, 0.101015, 
        0.707107}}],
    Polygon[{{-0.587785, 0.000000, 0.809017},{-0.587785, -0.083969, 
        0.809017},{-0.707107, -0.101015, 0.707107},{-0.707107, 0.000000, 
        0.707107}}],
    Polygon[{{-0.587785, -0.083969, 0.809017},{-0.587785, -0.167939, 
        0.809017},{-0.707107, -0.202031, 0.707107},{-0.707107, -0.101015, 
        0.707107}}],
    Polygon[{{-0.587785, -0.167939, 0.809017},{-0.587785, -0.251908, 
        0.809017},{-0.707107, -0.303046, 0.707107},{-0.707107, -0.202031, 
        0.707107}}],
    Polygon[{{-0.587785, -0.251908, 0.809017},{-0.587785, -0.335877, 
        0.809017},{-0.707107, -0.404061, 0.707107},{-0.707107, -0.303046, 
        0.707107}}],
    Polygon[{{-0.587785, -0.335877, 0.809017},{-0.587785, -0.419847, 
        0.809017},{-0.707107, -0.505076, 0.707107},{-0.707107, -0.404061, 
        0.707107}}],
    Polygon[{{-0.587785, -0.419847, 0.809017},{-0.587785, -0.503816, 
        0.809017},{-0.707107, -0.606091, 0.707107},{-0.707107, -0.505076, 
        0.707107}}],
    Polygon[{{-0.587785, -0.503816, 0.809017},{-0.587785, -0.587785, 
        0.809017},{-0.707107, -0.707107, 0.707107},{-0.707107, -0.606091, 
        0.707107}}],
    Polygon[{{-0.707107, 0.707107, 0.707107},{-0.707107, 0.606091, 
        0.707107},{-0.809017, 0.693443, 0.587785},{-0.809017, 0.809017, 
        0.587785}}],
    Polygon[{{-0.707107, 0.606091, 0.707107},{-0.707107, 0.505076, 
        0.707107},{-0.809017, 0.577869, 0.587785},{-0.809017, 0.693443, 
        0.587785}}],
    Polygon[{{-0.707107, 0.505076, 0.707107},{-0.707107, 0.404061, 
        0.707107},{-0.809017, 0.462295, 0.587785},{-0.809017, 0.577869, 
        0.587785}}],
    Polygon[{{-0.707107, 0.404061, 0.707107},{-0.707107, 0.303046, 
        0.707107},{-0.809017, 0.346722, 0.587785},{-0.809017, 0.462295, 
        0.587785}}],
    Polygon[{{-0.707107, 0.303046, 0.707107},{-0.707107, 0.202031, 
        0.707107},{-0.809017, 0.231148, 0.587785},{-0.809017, 0.346722, 
        0.587785}}],
    Polygon[{{-0.707107, 0.202031, 0.707107},{-0.707107, 0.101015, 
        0.707107},{-0.809017, 0.115574, 0.587785},{-0.809017, 0.231148, 
        0.587785}}],
    Polygon[{{-0.707107, 0.101015, 0.707107},{-0.707107, 0.000000, 
        0.707107},{-0.809017, 0.000000, 0.587785},{-0.809017, 0.115574, 
        0.587785}}],
    Polygon[{{-0.707107, 0.000000, 0.707107},{-0.707107, -0.101015, 
        0.707107},{-0.809017, -0.115574, 0.587785},{-0.809017, 0.000000, 
        0.587785}}],
    Polygon[{{-0.707107, -0.101015, 0.707107},{-0.707107, -0.202031, 
        0.707107},{-0.809017, -0.231148, 0.587785},{-0.809017, -0.115574, 
        0.587785}}],
    Polygon[{{-0.707107, -0.202031, 0.707107},{-0.707107, -0.303046, 
        0.707107},{-0.809017, -0.346722, 0.587785},{-0.809017, -0.231148, 
        0.587785}}],
    Polygon[{{-0.707107, -0.303046, 0.707107},{-0.707107, -0.404061, 
        0.707107},{-0.809017, -0.462295, 0.587785},{-0.809017, -0.346722, 
        0.587785}}],
    Polygon[{{-0.707107, -0.404061, 0.707107},{-0.707107, -0.505076, 
        0.707107},{-0.809017, -0.577869, 0.587785},{-0.809017, -0.462295, 
        0.587785}}],
    Polygon[{{-0.707107, -0.505076, 0.707107},{-0.707107, -0.606091, 
        0.707107},{-0.809017, -0.693443, 0.587785},{-0.809017, -0.577869, 
        0.587785}}],
    Polygon[{{-0.707107, -0.606091, 0.707107},{-0.707107, -0.707107, 
        0.707107},{-0.809017, -0.809017, 0.587785},{-0.809017, -0.693443, 
        0.587785}}],
    Polygon[{{-0.809017, 0.809017, 0.587785},{-0.809017, 0.693443, 
        0.587785},{-0.891007, 0.763720, 0.453990},{-0.891007, 0.891007, 
        0.453990}}],
    Polygon[{{-0.809017, 0.693443, 0.587785},{-0.809017, 0.577869, 
        0.587785},{-0.891007, 0.636433, 0.453990},{-0.891007, 0.763720, 
        0.453990}}],
    Polygon[{{-0.809017, 0.577869, 0.587785},{-0.809017, 0.462295, 
        0.587785},{-0.891007, 0.509147, 0.453990},{-0.891007, 0.636433, 
        0.453990}}],
    Polygon[{{-0.809017, 0.462295, 0.587785},{-0.809017, 0.346722, 
        0.587785},{-0.891007, 0.381860, 0.453990},{-0.891007, 0.509147, 
        0.453990}}],
    Polygon[{{-0.809017, 0.346722, 0.587785},{-0.809017, 0.231148, 
        0.587785},{-0.891007, 0.254573, 0.453990},{-0.891007, 0.381860, 
        0.453990}}],
    Polygon[{{-0.809017, 0.231148, 0.587785},{-0.809017, 0.115574, 
        0.587785},{-0.891007, 0.127287, 0.453990},{-0.891007, 0.254573, 
        0.453990}}],
    Polygon[{{-0.809017, 0.115574, 0.587785},{-0.809017, 0.000000, 
        0.587785},{-0.891007, 0.000000, 0.453990},{-0.891007, 0.127287, 
        0.453990}}],
    Polygon[{{-0.809017, 0.000000, 0.587785},{-0.809017, -0.115574, 
        0.587785},{-0.891007, -0.127287, 0.453990},{-0.891007, 0.000000, 
        0.453990}}],
    Polygon[{{-0.809017, -0.115574, 0.587785},{-0.809017, -0.231148, 
        0.587785},{-0.891007, -0.254573, 0.453990},{-0.891007, -0.127287, 
        0.453990}}],
    Polygon[{{-0.809017, -0.231148, 0.587785},{-0.809017, -0.346722, 
        0.587785},{-0.891007, -0.381860, 0.453990},{-0.891007, -0.254573, 
        0.453990}}],
    Polygon[{{-0.809017, -0.346722, 0.587785},{-0.809017, -0.462295, 
        0.587785},{-0.891007, -0.509147, 0.453990},{-0.891007, -0.381860, 
        0.453990}}],
    Polygon[{{-0.809017, -0.462295, 0.587785},{-0.809017, -0.577869, 
        0.587785},{-0.891007, -0.636433, 0.453990},{-0.891007, -0.509147, 
        0.453990}}],
    Polygon[{{-0.809017, -0.577869, 0.587785},{-0.809017, -0.693443, 
        0.587785},{-0.891007, -0.763720, 0.453990},{-0.891007, -0.636433, 
        0.453990}}],
    Polygon[{{-0.809017, -0.693443, 0.587785},{-0.809017, -0.809017, 
        0.587785},{-0.891007, -0.891007, 0.453990},{-0.891007, -0.763720, 
        0.453990}}],
    Polygon[{{-0.891007, 0.891007, 0.453990},{-0.891007, 0.763720, 
        0.453990},{-0.951057, 0.815191, 0.309017},{-0.951057, 0.951057, 
        0.309017}}],
    Polygon[{{-0.891007, 0.763720, 0.453990},{-0.891007, 0.636433, 
        0.453990},{-0.951057, 0.679326, 0.309017},{-0.951057, 0.815191, 
        0.309017}}],
    Polygon[{{-0.891007, 0.636433, 0.453990},{-0.891007, 0.509147, 
        0.453990},{-0.951057, 0.543461, 0.309017},{-0.951057, 0.679326, 
        0.309017}}],
    Polygon[{{-0.891007, 0.509147, 0.453990},{-0.891007, 0.381860, 
        0.453990},{-0.951057, 0.407596, 0.309017},{-0.951057, 0.543461, 
        0.309017}}],
    Polygon[{{-0.891007, 0.381860, 0.453990},{-0.891007, 0.254573, 
        0.453990},{-0.951057, 0.271730, 0.309017},{-0.951057, 0.407596, 
        0.309017}}],
    Polygon[{{-0.891007, 0.254573, 0.453990},{-0.891007, 0.127287, 
        0.453990},{-0.951057, 0.135865, 0.309017},{-0.951057, 0.271730, 
        0.309017}}],
    Polygon[{{-0.891007, 0.127287, 0.453990},{-0.891007, 0.000000, 
        0.453990},{-0.951057, 0.000000, 0.309017},{-0.951057, 0.135865, 
        0.309017}}],
    Polygon[{{-0.891007, 0.000000, 0.453990},{-0.891007, -0.127287, 
        0.453990},{-0.951057, -0.135865, 0.309017},{-0.951057, 0.000000, 
        0.309017}}],
    Polygon[{{-0.891007, -0.127287, 0.453990},{-0.891007, -0.254573, 
        0.453990},{-0.951057, -0.271730, 0.309017},{-0.951057, -0.135865, 
        0.309017}}],
    Polygon[{{-0.891007, -0.254573, 0.453990},{-0.891007, -0.381860, 
        0.453990},{-0.951057, -0.407596, 0.309017},{-0.951057, -0.271730, 
        0.309017}}],
    Polygon[{{-0.891007, -0.381860, 0.453990},{-0.891007, -0.509147, 
        0.453990},{-0.951057, -0.543461, 0.309017},{-0.951057, -0.407596, 
        0.309017}}],
    Polygon[{{-0.891007, -0.509147, 0.453990},{-0.891007, -0.636433, 
        0.453990},{-0.951057, -0.679326, 0.309017},{-0.951057, -0.543461, 
        0.309017}}],
    Polygon[{{-0.891007, -0.636433, 0.453990},{-0.891007, -0.763720, 
        0.453990},{-0.951057, -0.815191, 0.309017},{-0.951057, -0.679326, 
        0.309017}}],
    Polygon[{{-0.891007, -0.763720, 0.453990},{-0.891007, -0.891007, 
        0.453990},{-0.951057, -0.951057, 0.309017},{-0.951057, -0.815191, 
        0.309017}}],
    Polygon[{{-0.951057, 0.951057, 0.309017},{-0.951057, 0.815191, 
        0.309017},{-0.987688, 0.846590, 0.156434},{-0.987688, 0.987688, 
        0.156434}}],
    Polygon[{{-0.951057, 0.815191, 0.309017},{-0.951057, 0.679326, 
        0.309017},{-0.987688, 0.705492, 0.156434},{-0.987688, 0.846590, 
        0.156434}}],
    Polygon[{{-0.951057, 0.679326, 0.309017},{-0.951057, 0.543461, 
        0.309017},{-0.987688, 0.564393, 0.156434},{-0.987688, 0.705492, 
        0.156434}}],
    Polygon[{{-0.951057, 0.543461, 0.309017},{-0.951057, 0.407596, 
        0.309017},{-0.987688, 0.423295, 0.156434},{-0.987688, 0.564393, 
        0.156434}}],
    Polygon[{{-0.951057, 0.407596, 0.309017},{-0.951057, 0.271730, 
        0.309017},{-0.987688, 0.282197, 0.156434},{-0.987688, 0.423295, 
        0.156434}}],
    Polygon[{{-0.951057, 0.271730, 0.309017},{-0.951057, 0.135865, 
        0.309017},{-0.987688, 0.141098, 0.156434},{-0.987688, 0.282197, 
        0.156434}}],
    Polygon[{{-0.951057, 0.135865, 0.309017},{-0.951057, 0.000000, 
        0.309017},{-0.987688, 0.000000, 0.156434},{-0.987688, 0.141098, 
        0.156434}}],
    Polygon[{{-0.951057, 0.000000, 0.309017},{-0.951057, -0.135865, 
        0.309017},{-0.987688, -0.141098, 0.156434},{-0.987688, 0.000000, 
        0.156434}}],
    Polygon[{{-0.951057, -0.135865, 0.309017},{-0.951057, -0.271730, 
        0.309017},{-0.987688, -0.282197, 0.156434},{-0.987688, -0.141098, 
        0.156434}}],
    Polygon[{{-0.951057, -0.271730, 0.309017},{-0.951057, -0.407596, 
        0.309017},{-0.987688, -0.423295, 0.156434},{-0.987688, -0.282197, 
        0.156434}}],
    Polygon[{{-0.951057, -0.407596, 0.309017},{-0.951057, -0.543461, 
        0.309017},{-0.987688, -0.564393, 0.156434},{-0.987688, -0.423295, 
        0.156434}}],
    Polygon[{{-0.951057, -0.543461, 0.309017},{-0.951057, -0.679326, 
        0.309017},{-0.987688, -0.705492, 0.156434},{-0.987688, -0.564393, 
        0.156434}}],
    Polygon[{{-0.951057, -0.679326, 0.309017},{-0.951057, -0.815191, 
        0.309017},{-0.987688, -0.846590, 0.156434},{-0.987688, -0.705492, 
        0.156434}}],
    Polygon[{{-0.951057, -0.815191, 0.309017},{-0.951057, -0.951057, 
        0.309017},{-0.987688, -0.987688, 0.156434},{-0.987688, -0.846590, 
        0.156434}}],
    Polygon[{{-0.987688, 0.987688, 0.156434},{-0.987688, 0.846590, 
        0.156434},{-1.000000, 0.857143, 0.000000},{-1.000000, 1.000000, 
        0.000000}}],
    Polygon[{{-0.987688, 0.846590, 0.156434},{-0.987688, 0.705492, 
        0.156434},{-1.000000, 0.714286, 0.000000},{-1.000000, 0.857143, 
        0.000000}}],
    Polygon[{{-0.987688, 0.705492, 0.156434},{-0.987688, 0.564393, 
        0.156434},{-1.000000, 0.571429, 0.000000},{-1.000000, 0.714286, 
        0.000000}}],
    Polygon[{{-0.987688, 0.564393, 0.156434},{-0.987688, 0.423295, 
        0.156434},{-1.000000, 0.428571, 0.000000},{-1.000000, 0.571429, 
        0.000000}}],
    Polygon[{{-0.987688, 0.423295, 0.156434},{-0.987688, 0.282197, 
        0.156434},{-1.000000, 0.285714, 0.000000},{-1.000000, 0.428571, 
        0.000000}}],
    Polygon[{{-0.987688, 0.282197, 0.156434},{-0.987688, 0.141098, 
        0.156434},{-1.000000, 0.142857, 0.000000},{-1.000000, 0.285714, 
        0.000000}}],
    Polygon[{{-0.987688, 0.141098, 0.156434},{-0.987688, 0.000000, 
        0.156434},{-1.000000, 0.000000, 0.000000},{-1.000000, 0.142857, 
        0.000000}}],
    Polygon[{{-0.987688, 0.000000, 0.156434},{-0.987688, -0.141098, 
        0.156434},{-1.000000, -0.142857, 0.000000},{-1.000000, 0.000000, 
        0.000000}}],
    Polygon[{{-0.987688, -0.141098, 0.156434},{-0.987688, -0.282197, 
        0.156434},{-1.000000, -0.285714, 0.000000},{-1.000000, -0.142857, 
        0.000000}}],
    Polygon[{{-0.987688, -0.282197, 0.156434},{-0.987688, -0.423295, 
        0.156434},{-1.000000, -0.428571, 0.000000},{-1.000000, -0.285714, 
        0.000000}}],
    Polygon[{{-0.987688, -0.423295, 0.156434},{-0.987688, -0.564393, 
        0.156434},{-1.000000, -0.571429, 0.000000},{-1.000000, -0.428571, 
        0.000000}}],
    Polygon[{{-0.987688, -0.564393, 0.156434},{-0.987688, -0.705492, 
        0.156434},{-1.000000, -0.714286, 0.000000},{-1.000000, -0.571429, 
        0.000000}}],
    Polygon[{{-0.987688, -0.705492, 0.156434},{-0.987688, -0.846590, 
        0.156434},{-1.000000, -0.857143, 0.000000},{-1.000000, -0.714286, 
        0.000000}}],
    Polygon[{{-0.987688, -0.846590, 0.156434},{-0.987688, -0.987688, 
        0.156434},{-1.000000, -1.000000, 0.000000},{-1.000000, -0.857143, 
        0.000000}}],
    Polygon[{{-1.000000, 1.000000, 0.000000},{-1.000000, 0.857143, 
        0.000000},{-0.987688, 0.846590, -0.156434},{-0.987688, 
        0.987688, -0.156434}}],
    Polygon[{{-1.000000, 0.857143, 0.000000},{-1.000000, 0.714286, 
        0.000000},{-0.987688, 0.705492, -0.156434},{-0.987688, 
        0.846590, -0.156434}}],
    Polygon[{{-1.000000, 0.714286, 0.000000},{-1.000000, 0.571429, 
        0.000000},{-0.987688, 0.564393, -0.156434},{-0.987688, 
        0.705492, -0.156434}}],
    Polygon[{{-1.000000, 0.571429, 0.000000},{-1.000000, 0.428571, 
        0.000000},{-0.987688, 0.423295, -0.156434},{-0.987688, 
        0.564393, -0.156434}}],
    Polygon[{{-1.000000, 0.428571, 0.000000},{-1.000000, 0.285714, 
        0.000000},{-0.987688, 0.282197, -0.156434},{-0.987688, 
        0.423295, -0.156434}}],
    Polygon[{{-1.000000, 0.285714, 0.000000},{-1.000000, 0.142857, 
        0.000000},{-0.987688, 0.141098, -0.156434},{-0.987688, 
        0.282197, -0.156434}}],
    Polygon[{{-1.000000, 0.142857, 0.000000},{-1.000000, 0.000000, 
        0.000000},{-0.987688, 0.000000, -0.156434},{-0.987688, 
        0.141098, -0.156434}}],
    Polygon[{{-1.000000, 0.000000, 0.000000},{-1.000000, -0.142857, 
        0.000000},{-0.987688, -0.141098, -0.156434},{-0.987688, 
        0.000000, -0.156434}}],
    Polygon[{{-1.000000, -0.142857, 0.000000},{-1.000000, -0.285714, 
        0.000000},{-0.987688, -0.282197, -0.156434},{-0.987688, -0.141098, \
-0.156434}}],
    Polygon[{{-1.000000, -0.285714, 0.000000},{-1.000000, -0.428571, 
        0.000000},{-0.987688, -0.423295, -0.156434},{-0.987688, -0.282197, \
-0.156434}}],
    Polygon[{{-1.000000, -0.428571, 0.000000},{-1.000000, -0.571429, 
        0.000000},{-0.987688, -0.564393, -0.156434},{-0.987688, -0.423295, \
-0.156434}}],
    Polygon[{{-1.000000, -0.571429, 0.000000},{-1.000000, -0.714286, 
        0.000000},{-0.987688, -0.705492, -0.156434},{-0.987688, -0.564393, \
-0.156434}}],
    Polygon[{{-1.000000, -0.714286, 0.000000},{-1.000000, -0.857143, 
        0.000000},{-0.987688, -0.846590, -0.156434},{-0.987688, -0.705492, \
-0.156434}}],
    Polygon[{{-1.000000, -0.857143, 0.000000},{-1.000000, -1.000000, 
        0.000000},{-0.987688, -0.987688, -0.156434},{-0.987688, -0.846590, \
-0.156434}}],
    Polygon[{{-0.987688, 0.987688, -0.156434},{-0.987688, 
        0.846590, -0.156434},{-0.951057, 0.815191, -0.309017},{-0.951057, 
        0.951057, -0.309017}}],
    Polygon[{{-0.987688, 0.846590, -0.156434},{-0.987688, 
        0.705492, -0.156434},{-0.951057, 0.679326, -0.309017},{-0.951057, 
        0.815191, -0.309017}}],
    Polygon[{{-0.987688, 0.705492, -0.156434},{-0.987688, 
        0.564393, -0.156434},{-0.951057, 0.543461, -0.309017},{-0.951057, 
        0.679326, -0.309017}}],
    Polygon[{{-0.987688, 0.564393, -0.156434},{-0.987688, 
        0.423295, -0.156434},{-0.951057, 0.407596, -0.309017},{-0.951057, 
        0.543461, -0.309017}}],
    Polygon[{{-0.987688, 0.423295, -0.156434},{-0.987688, 
        0.282197, -0.156434},{-0.951057, 0.271730, -0.309017},{-0.951057, 
        0.407596, -0.309017}}],
    Polygon[{{-0.987688, 0.282197, -0.156434},{-0.987688, 
        0.141098, -0.156434},{-0.951057, 0.135865, -0.309017},{-0.951057, 
        0.271730, -0.309017}}],
    Polygon[{{-0.987688, 0.141098, -0.156434},{-0.987688, 
        0.000000, -0.156434},{-0.951057, 0.000000, -0.309017},{-0.951057, 
        0.135865, -0.309017}}],
    Polygon[{{-0.987688, 
        0.000000, -0.156434},{-0.987688, -0.141098, -0.156434},{-0.951057, \
-0.135865, -0.309017},{-0.951057, 0.000000, -0.309017}}],
    Polygon[{{-0.987688, -0.141098, -0.156434},{-0.987688, -0.282197, \
-0.156434},{-0.951057, -0.271730, -0.309017},{-0.951057, -0.135865, \
-0.309017}}],
    Polygon[{{-0.987688, -0.282197, -0.156434},{-0.987688, -0.423295, \
-0.156434},{-0.951057, -0.407596, -0.309017},{-0.951057, -0.271730, \
-0.309017}}],
    Polygon[{{-0.987688, -0.423295, -0.156434},{-0.987688, -0.564393, \
-0.156434},{-0.951057, -0.543461, -0.309017},{-0.951057, -0.407596, \
-0.309017}}],
    Polygon[{{-0.987688, -0.564393, -0.156434},{-0.987688, -0.705492, \
-0.156434},{-0.951057, -0.679326, -0.309017},{-0.951057, -0.543461, \
-0.309017}}],
    Polygon[{{-0.987688, -0.705492, -0.156434},{-0.987688, -0.846590, \
-0.156434},{-0.951057, -0.815191, -0.309017},{-0.951057, -0.679326, \
-0.309017}}],
    Polygon[{{-0.987688, -0.846590, -0.156434},{-0.987688, -0.987688, \
-0.156434},{-0.951057, -0.951057, -0.309017},{-0.951057, -0.815191, \
-0.309017}}],
    Polygon[{{-0.951057, 0.951057, -0.309017},{-0.951057, 
        0.815191, -0.309017},{-0.891007, 0.763720, -0.453990},{-0.891007, 
        0.891007, -0.453990}}],
    Polygon[{{-0.951057, 0.815191, -0.309017},{-0.951057, 
        0.679326, -0.309017},{-0.891007, 0.636433, -0.453990},{-0.891007, 
        0.763720, -0.453990}}],
    Polygon[{{-0.951057, 0.679326, -0.309017},{-0.951057, 
        0.543461, -0.309017},{-0.891007, 0.509147, -0.453990},{-0.891007, 
        0.636433, -0.453990}}],
    Polygon[{{-0.951057, 0.543461, -0.309017},{-0.951057, 
        0.407596, -0.309017},{-0.891007, 0.381860, -0.453990},{-0.891007, 
        0.509147, -0.453990}}],
    Polygon[{{-0.951057, 0.407596, -0.309017},{-0.951057, 
        0.271730, -0.309017},{-0.891007, 0.254573, -0.453990},{-0.891007, 
        0.381860, -0.453990}}],
    Polygon[{{-0.951057, 0.271730, -0.309017},{-0.951057, 
        0.135865, -0.309017},{-0.891007, 0.127287, -0.453990},{-0.891007, 
        0.254573, -0.453990}}],
    Polygon[{{-0.951057, 0.135865, -0.309017},{-0.951057, 
        0.000000, -0.309017},{-0.891007, 0.000000, -0.453990},{-0.891007, 
        0.127287, -0.453990}}],
    Polygon[{{-0.951057, 
        0.000000, -0.309017},{-0.951057, -0.135865, -0.309017},{-0.891007, \
-0.127287, -0.453990},{-0.891007, 0.000000, -0.453990}}],
    Polygon[{{-0.951057, -0.135865, -0.309017},{-0.951057, -0.271730, \
-0.309017},{-0.891007, -0.254573, -0.453990},{-0.891007, -0.127287, \
-0.453990}}],
    Polygon[{{-0.951057, -0.271730, -0.309017},{-0.951057, -0.407596, \
-0.309017},{-0.891007, -0.381860, -0.453990},{-0.891007, -0.254573, \
-0.453990}}],
    Polygon[{{-0.951057, -0.407596, -0.309017},{-0.951057, -0.543461, \
-0.309017},{-0.891007, -0.509147, -0.453990},{-0.891007, -0.381860, \
-0.453990}}],
    Polygon[{{-0.951057, -0.543461, -0.309017},{-0.951057, -0.679326, \
-0.309017},{-0.891007, -0.636433, -0.453990},{-0.891007, -0.509147, \
-0.453990}}],
    Polygon[{{-0.951057, -0.679326, -0.309017},{-0.951057, -0.815191, \
-0.309017},{-0.891007, -0.763720, -0.453990},{-0.891007, -0.636433, \
-0.453990}}],
    Polygon[{{-0.951057, -0.815191, -0.309017},{-0.951057, -0.951057, \
-0.309017},{-0.891007, -0.891007, -0.453990},{-0.891007, -0.763720, \
-0.453990}}],
    Polygon[{{-0.891007, 0.891007, -0.453990},{-0.891007, 
        0.763720, -0.453990},{-0.809017, 0.693443, -0.587785},{-0.809017, 
        0.809017, -0.587785}}],
    Polygon[{{-0.891007, 0.763720, -0.453990},{-0.891007, 
        0.636433, -0.453990},{-0.809017, 0.577869, -0.587785},{-0.809017, 
        0.693443, -0.587785}}],
    Polygon[{{-0.891007, 0.636433, -0.453990},{-0.891007, 
        0.509147, -0.453990},{-0.809017, 0.462295, -0.587785},{-0.809017, 
        0.577869, -0.587785}}],
    Polygon[{{-0.891007, 0.509147, -0.453990},{-0.891007, 
        0.381860, -0.453990},{-0.809017, 0.346722, -0.587785},{-0.809017, 
        0.462295, -0.587785}}],
    Polygon[{{-0.891007, 0.381860, -0.453990},{-0.891007, 
        0.254573, -0.453990},{-0.809017, 0.231148, -0.587785},{-0.809017, 
        0.346722, -0.587785}}],
    Polygon[{{-0.891007, 0.254573, -0.453990},{-0.891007, 
        0.127287, -0.453990},{-0.809017, 0.115574, -0.587785},{-0.809017, 
        0.231148, -0.587785}}],
    Polygon[{{-0.891007, 0.127287, -0.453990},{-0.891007, 
        0.000000, -0.453990},{-0.809017, 0.000000, -0.587785},{-0.809017, 
        0.115574, -0.587785}}],
    Polygon[{{-0.891007, 
        0.000000, -0.453990},{-0.891007, -0.127287, -0.453990},{-0.809017, \
-0.115574, -0.587785},{-0.809017, 0.000000, -0.587785}}],
    Polygon[{{-0.891007, -0.127287, -0.453990},{-0.891007, -0.254573, \
-0.453990},{-0.809017, -0.231148, -0.587785},{-0.809017, -0.115574, \
-0.587785}}],
    Polygon[{{-0.891007, -0.254573, -0.453990},{-0.891007, -0.381860, \
-0.453990},{-0.809017, -0.346722, -0.587785},{-0.809017, -0.231148, \
-0.587785}}],
    Polygon[{{-0.891007, -0.381860, -0.453990},{-0.891007, -0.509147, \
-0.453990},{-0.809017, -0.462295, -0.587785},{-0.809017, -0.346722, \
-0.587785}}],
    Polygon[{{-0.891007, -0.509147, -0.453990},{-0.891007, -0.636433, \
-0.453990},{-0.809017, -0.577869, -0.587785},{-0.809017, -0.462295, \
-0.587785}}],
    Polygon[{{-0.891007, -0.636433, -0.453990},{-0.891007, -0.763720, \
-0.453990},{-0.809017, -0.693443, -0.587785},{-0.809017, -0.577869, \
-0.587785}}],
    Polygon[{{-0.891007, -0.763720, -0.453990},{-0.891007, -0.891007, \
-0.453990},{-0.809017, -0.809017, -0.587785},{-0.809017, -0.693443, \
-0.587785}}],
    Polygon[{{-0.809017, 0.809017, -0.587785},{-0.809017, 
        0.693443, -0.587785},{-0.707107, 0.606091, -0.707107},{-0.707107, 
        0.707107, -0.707107}}],
    Polygon[{{-0.809017, 0.693443, -0.587785},{-0.809017, 
        0.577869, -0.587785},{-0.707107, 0.505076, -0.707107},{-0.707107, 
        0.606091, -0.707107}}],
    Polygon[{{-0.809017, 0.577869, -0.587785},{-0.809017, 
        0.462295, -0.587785},{-0.707107, 0.404061, -0.707107},{-0.707107, 
        0.505076, -0.707107}}],
    Polygon[{{-0.809017, 0.462295, -0.587785},{-0.809017, 
        0.346722, -0.587785},{-0.707107, 0.303046, -0.707107},{-0.707107, 
        0.404061, -0.707107}}],
    Polygon[{{-0.809017, 0.346722, -0.587785},{-0.809017, 
        0.231148, -0.587785},{-0.707107, 0.202031, -0.707107},{-0.707107, 
        0.303046, -0.707107}}],
    Polygon[{{-0.809017, 0.231148, -0.587785},{-0.809017, 0.115574, -0.587785}
      ,{-0.707107, 0.101015, -0.707107},{-0.707107, 0.202031, -0.707107}}],
    Polygon[{{-0.809017, 0.115574, -0.587785},{-0.809017, 
        0.000000, -0.587785},{-0.707107, 0.000000, -0.707107},{-0.707107, 
        0.101015, -0.707107}}],
    Polygon[{{-0.809017, 
        0.000000, -0.587785},{-0.809017, -0.115574, -0.587785},{-0.707107, \
-0.101015, -0.707107},{-0.707107, 0.000000, -0.707107}}],
    Polygon[{{-0.809017, -0.115574, -0.587785},{-0.809017, -0.231148, \
-0.587785},{-0.707107, -0.202031, -0.707107},{-0.707107, -0.101015, \
-0.707107}}],
    Polygon[{{-0.809017, -0.231148, -0.587785},{-0.809017, -0.346722, \
-0.587785},{-0.707107, -0.303046, -0.707107},{-0.707107, -0.202031, \
-0.707107}}],
    Polygon[{{-0.809017, -0.346722, -0.587785},{-0.809017, -0.462295, \
-0.587785},{-0.707107, -0.404061, -0.707107},{-0.707107, -0.303046, \
-0.707107}}],
    Polygon[{{-0.809017, -0.462295, -0.587785},{-0.809017, -0.577869, \
-0.587785},{-0.707107, -0.505076, -0.707107},{-0.707107, -0.404061, \
-0.707107}}],
    Polygon[{{-0.809017, -0.577869, -0.587785},{-0.809017, -0.693443, \
-0.587785},{-0.707107, -0.606091, -0.707107},{-0.707107, -0.505076, \
-0.707107}}],
    Polygon[{{-0.809017, -0.693443, -0.587785},{-0.809017, -0.809017, \
-0.587785},{-0.707107, -0.707107, -0.707107},{-0.707107, -0.606091, \
-0.707107}}],
    Polygon[{{-0.707107, 0.707107, -0.707107},{-0.707107, 
        0.606091, -0.707107},{-0.587785, 0.503816, -0.809017},{-0.587785, 
        0.587785, -0.809017}}],
    Polygon[{{-0.707107, 0.606091, -0.707107},{-0.707107, 
        0.505076, -0.707107},{-0.587785, 0.419847, -0.809017},{-0.587785, 
        0.503816, -0.809017}}],
    Polygon[{{-0.707107, 0.505076, -0.707107},{-0.707107, 
        0.404061, -0.707107},{-0.587785, 0.335877, -0.809017},{-0.587785, 
        0.419847, -0.809017}}],
    Polygon[{{-0.707107, 0.404061, -0.707107},{-0.707107, 
        0.303046, -0.707107},{-0.587785, 0.251908, -0.809017},{-0.587785, 
        0.335877, -0.809017}}],
    Polygon[{{-0.707107, 0.303046, -0.707107},{-0.707107, 
        0.202031, -0.707107},{-0.587785, 0.167939, -0.809017},{-0.587785, 
        0.251908, -0.809017}}],
    Polygon[{{-0.707107, 0.202031, -0.707107},{-0.707107, 
        0.101015, -0.707107},{-0.587785, 0.083969, -0.809017},{-0.587785, 
        0.167939, -0.809017}}],
    Polygon[{{-0.707107, 0.101015, -0.707107},{-0.707107, 
        0.000000, -0.707107},{-0.587785, 0.000000, -0.809017},{-0.587785, 
        0.083969, -0.809017}}],
    Polygon[{{-0.707107, 
        0.000000, -0.707107},{-0.707107, -0.101015, -0.707107},{-0.587785, \
-0.083969, -0.809017},{-0.587785, 0.000000, -0.809017}}],
    Polygon[{{-0.707107, -0.101015, -0.707107},{-0.707107, -0.202031, \
-0.707107},{-0.587785, -0.167939, -0.809017},{-0.587785, -0.083969, \
-0.809017}}],
    Polygon[{{-0.707107, -0.202031, -0.707107},{-0.707107, -0.303046, \
-0.707107},{-0.587785, -0.251908, -0.809017},{-0.587785, -0.167939, \
-0.809017}}],
    Polygon[{{-0.707107, -0.303046, -0.707107},{-0.707107, -0.404061, \
-0.707107},{-0.587785, -0.335877, -0.809017},{-0.587785, -0.251908, \
-0.809017}}],
    Polygon[{{-0.707107, -0.404061, -0.707107},{-0.707107, -0.505076, \
-0.707107},{-0.587785, -0.419847, -0.809017},{-0.587785, -0.335877, \
-0.809017}}],
    Polygon[{{-0.707107, -0.505076, -0.707107},{-0.707107, -0.606091, \
-0.707107},{-0.587785, -0.503816, -0.809017},{-0.587785, -0.419847, \
-0.809017}}],
    Polygon[{{-0.707107, -0.606091, -0.707107},{-0.707107, -0.707107, \
-0.707107},{-0.587785, -0.587785, -0.809017},{-0.587785, -0.503816, \
-0.809017}}],
    Polygon[{{-0.587785, 0.587785, -0.809017},{-0.587785, 
        0.503816, -0.809017},{-0.453990, 0.389135, -0.891007},{-0.453990, 
        0.453990, -0.891007}}],
    Polygon[{{-0.587785, 0.503816, -0.809017},{-0.587785, 
        0.419847, -0.809017},{-0.453990, 0.324279, -0.891007},{-0.453990, 
        0.389135, -0.891007}}],
    Polygon[{{-0.587785, 0.419847, -0.809017},{-0.587785, 0.335877, -0.809017}
      ,{-0.453990, 0.259423, -0.891007},{-0.453990, 0.324279, -0.891007}}],
    Polygon[{{-0.587785, 0.335877, -0.809017},{-0.587785, 
        0.251908, -0.809017},{-0.453990, 0.194567, -0.891007},{-0.453990, 
        0.259423, -0.891007}}],
    Polygon[{{-0.587785, 0.251908, -0.809017},{-0.587785, 
        0.167939, -0.809017},{-0.453990, 0.129712, -0.891007},{-0.453990, 
        0.194567, -0.891007}}],
    Polygon[{{-0.587785, 0.167939, -0.809017},{-0.587785, 
        0.083969, -0.809017},{-0.453990, 0.064856, -0.891007},{-0.453990, 
        0.129712, -0.891007}}],
    Polygon[{{-0.587785, 0.083969, -0.809017},{-0.587785, 
        0.000000, -0.809017},{-0.453990, 0.000000, -0.891007},{-0.453990, 
        0.064856, -0.891007}}],
    Polygon[{{-0.587785, 
        0.000000, -0.809017},{-0.587785, -0.083969, -0.809017},{-0.453990, \
-0.064856, -0.891007},{-0.453990, 0.000000, -0.891007}}],
    Polygon[{{-0.587785, -0.083969, -0.809017},{-0.587785, -0.167939, \
-0.809017},{-0.453990, -0.129712, -0.891007},{-0.453990, -0.064856, \
-0.891007}}],
    Polygon[{{-0.587785, -0.167939, -0.809017},{-0.587785, -0.251908, \
-0.809017},{-0.453990, -0.194567, -0.891007},{-0.453990, -0.129712, \
-0.891007}}],
    Polygon[{{-0.587785, -0.251908, -0.809017},{-0.587785, -0.335877, \
-0.809017},{-0.453990, -0.259423, -0.891007},{-0.453990, -0.194567, \
-0.891007}}],
    Polygon[{{-0.587785, -0.335877, -0.809017},{-0.587785, -0.419847, \
-0.809017},{-0.453990, -0.324279, -0.891007},{-0.453990, -0.259423, \
-0.891007}}],
    Polygon[{{-0.587785, -0.419847, -0.809017},{-0.587785, -0.503816, \
-0.809017},{-0.453990, -0.389135, -0.891007},{-0.453990, -0.324279, \
-0.891007}}],
    Polygon[{{-0.587785, -0.503816, -0.809017},{-0.587785, -0.587785, \
-0.809017},{-0.453990, -0.453990, -0.891007},{-0.453990, -0.389135, \
-0.891007}}],
    Polygon[{{-0.453990, 0.453990, -0.891007},{-0.453990, 
        0.389135, -0.891007},{-0.309017, 0.264872, -0.951057},{-0.309017, 
        0.309017, -0.951057}}],
    Polygon[{{-0.453990, 0.389135, -0.891007},{-0.453990, 
        0.324279, -0.891007},{-0.309017, 0.220726, -0.951057},{-0.309017, 
        0.264872, -0.951057}}],
    Polygon[{{-0.453990, 0.324279, -0.891007},{-0.453990, 
        0.259423, -0.891007},{-0.309017, 0.176581, -0.951057},{-0.309017, 
        0.220726, -0.951057}}],
    Polygon[{{-0.453990, 0.259423, -0.891007},{-0.453990, 
        0.194567, -0.891007},{-0.309017, 0.132436, -0.951057},{-0.309017, 
        0.176581, -0.951057}}],
    Polygon[{{-0.453990, 0.194567, -0.891007},{-0.453990, 
        0.129712, -0.891007},{-0.309017, 0.088291, -0.951057},{-0.309017, 
        0.132436, -0.951057}}],
    Polygon[{{-0.453990, 0.129712, -0.891007},{-0.453990, 
        0.064856, -0.891007},{-0.309017, 0.044145, -0.951057},{-0.309017, 
        0.088291, -0.951057}}],
    Polygon[{{-0.453990, 0.064856, -0.891007},{-0.453990, 
        0.000000, -0.891007},{-0.309017, 0.000000, -0.951057},{-0.309017, 
        0.044145, -0.951057}}],
    Polygon[{{-0.453990, 
        0.000000, -0.891007},{-0.453990, -0.064856, -0.891007},{-0.309017, \
-0.044145, -0.951057},{-0.309017, 0.000000, -0.951057}}],
    Polygon[{{-0.453990, -0.064856, -0.891007},{-0.453990, -0.129712, \
-0.891007},{-0.309017, -0.088291, -0.951057},{-0.309017, -0.044145, \
-0.951057}}],
    Polygon[{{-0.453990, -0.129712, -0.891007},{-0.453990, -0.194567, \
-0.891007},{-0.309017, -0.132436, -0.951057},{-0.309017, -0.088291, \
-0.951057}}],
    Polygon[{{-0.453990, -0.194567, -0.891007},{-0.453990, -0.259423, \
-0.891007},{-0.309017, -0.176581, -0.951057},{-0.309017, -0.132436, \
-0.951057}}],
    Polygon[{{-0.453990, -0.259423, -0.891007},{-0.453990, -0.324279, \
-0.891007},{-0.309017, -0.220726, -0.951057},{-0.309017, -0.176581, \
-0.951057}}],
    Polygon[{{-0.453990, -0.324279, -0.891007},{-0.453990, -0.389135, \
-0.891007},{-0.309017, -0.264872, -0.951057},{-0.309017, -0.220726, \
-0.951057}}],
    Polygon[{{-0.453990, -0.389135, -0.891007},{-0.453990, -0.453990, \
-0.891007},{-0.309017, -0.309017, -0.951057},{-0.309017, -0.264872, \
-0.951057}}],
    Polygon[{{-0.309017, 0.309017, -0.951057},{-0.309017, 
        0.264872, -0.951057},{-0.156434, 0.134087, -0.987688},{-0.156434, 
        0.156434, -0.987688}}],
    Polygon[{{-0.309017, 0.264872, -0.951057},{-0.309017, 
        0.220726, -0.951057},{-0.156434, 0.111739, -0.987688},{-0.156434, 
        0.134087, -0.987688}}],
    Polygon[{{-0.309017, 0.220726, -0.951057},{-0.309017, 
        0.176581, -0.951057},{-0.156434, 0.089391, -0.987688},{-0.156434, 
        0.111739, -0.987688}}],
    Polygon[{{-0.309017, 0.176581, -0.951057},{-0.309017, 
        0.132436, -0.951057},{-0.156434, 0.067043, -0.987688},{-0.156434, 
        0.089391, -0.987688}}],
    Polygon[{{-0.309017, 0.132436, -0.951057},{-0.309017, 
        0.088291, -0.951057},{-0.156434, 0.044696, -0.987688},{-0.156434, 
        0.067043, -0.987688}}],
    Polygon[{{-0.309017, 0.088291, -0.951057},{-0.309017, 
        0.044145, -0.951057},{-0.156434, 0.022348, -0.987688},{-0.156434, 
        0.044696, -0.987688}}],
    Polygon[{{-0.309017, 0.044145, -0.951057},{-0.309017, 
        0.000000, -0.951057},{-0.156434, 0.000000, -0.987688},{-0.156434, 
        0.022348, -0.987688}}],
    Polygon[{{-0.309017, 
        0.000000, -0.951057},{-0.309017, -0.044145, -0.951057},{-0.156434, \
-0.022348, -0.987688},{-0.156434, 0.000000, -0.987688}}],
    Polygon[{{-0.309017, -0.044145, -0.951057},{-0.309017, -0.088291, \
-0.951057},{-0.156434, -0.044696, -0.987688},{-0.156434, -0.022348, \
-0.987688}}],
    Polygon[{{-0.309017, -0.088291, -0.951057},{-0.309017, -0.132436, \
-0.951057},{-0.156434, -0.067043, -0.987688},{-0.156434, -0.044696, \
-0.987688}}],
    Polygon[{{-0.309017, -0.132436, -0.951057},{-0.309017, -0.176581, \
-0.951057},{-0.156434, -0.089391, -0.987688},{-0.156434, -0.067043, \
-0.987688}}],
    Polygon[{{-0.309017, -0.176581, -0.951057},{-0.309017, -0.220726, \
-0.951057},{-0.156434, -0.111739, -0.987688},{-0.156434, -0.089391, \
-0.987688}}],
    Polygon[{{-0.309017, -0.220726, -0.951057},{-0.309017, -0.264872, \
-0.951057},{-0.156434, -0.134087, -0.987688},{-0.156434, -0.111739, \
-0.987688}}],
    Polygon[{{-0.309017, -0.264872, -0.951057},{-0.309017, -0.309017, \
-0.951057},{-0.156434, -0.156434, -0.987688},{-0.156434, -0.134087, \
-0.987688}}],
    Polygon[{{-0.156434, 0.156434, -0.987688},{-0.156434, 
        0.134087, -0.987688},{-0.000000, 0.000000, -1.000000},{-0.000000, 
        0.000000, -1.000000}}],
    Polygon[{{-0.156434, 0.134087, -0.987688},{-0.156434, 
        0.111739, -0.987688},{-0.000000, 0.000000, -1.000000},{-0.000000, 
        0.000000, -1.000000}}],
    Polygon[{{-0.156434, 0.111739, -0.987688},{-0.156434, 
        0.089391, -0.987688},{-0.000000, 0.000000, -1.000000},{-0.000000, 
        0.000000, -1.000000}}],
    Polygon[{{-0.156434, 0.089391, -0.987688},{-0.156434, 
        0.067043, -0.987688},{-0.000000, 0.000000, -1.000000},{-0.000000, 
        0.000000, -1.000000}}],
    Polygon[{{-0.156434, 0.067043, -0.987688},{-0.156434, 
        0.044696, -0.987688},{-0.000000, 0.000000, -1.000000},{-0.000000, 
        0.000000, -1.000000}}],
    Polygon[{{-0.156434, 0.044696, -0.987688},{-0.156434, 
        0.022348, -0.987688},{-0.000000, 0.000000, -1.000000},{-0.000000, 
        0.000000, -1.000000}}],
    Polygon[{{-0.156434, 0.022348, -0.987688},{-0.156434, 
        0.000000, -0.987688},{-0.000000, 0.000000, -1.000000},{-0.000000, 
        0.000000, -1.000000}}],
    Polygon[{{-0.156434, 
        0.000000, -0.987688},{-0.156434, -0.022348, -0.987688},{-0.000000, \
-0.000000, -1.000000},{-0.000000, 0.000000, -1.000000}}],
    Polygon[{{-0.156434, -0.022348, -0.987688},{-0.156434, -0.044696, \
-0.987688},{-0.000000, -0.000000, -1.000000},{-0.000000, -0.000000, \
-1.000000}}],
    Polygon[{{-0.156434, -0.044696, -0.987688},{-0.156434, -0.067043, \
-0.987688},{-0.000000, -0.000000, -1.000000},{-0.000000, -0.000000, \
-1.000000}}],
    Polygon[{{-0.156434, -0.067043, -0.987688},{-0.156434, -0.089391, \
-0.987688},{-0.000000, -0.000000, -1.000000},{-0.000000, -0.000000, \
-1.000000}}],
    Polygon[{{-0.156434, -0.089391, -0.987688},{-0.156434, -0.111739, \
-0.987688},{-0.000000, -0.000000, -1.000000},{-0.000000, -0.000000, \
-1.000000}}],
    Polygon[{{-0.156434, -0.111739, -0.987688},{-0.156434, -0.134087, \
-0.987688},{-0.000000, -0.000000, -1.000000},{-0.000000, -0.000000, \
-1.000000}}],
    Polygon[{{-0.156434, -0.134087, -0.987688},{-0.156434, -0.156434, \
-0.987688},{-0.000000, -0.000000, -1.000000},{-0.000000, -0.000000, \
-1.000000}}],
    Polygon[{{-0.000000, 0.000000, -1.000000},{-0.000000, 
        0.000000, -1.000000},{0.156434, -0.134087, -0.987688},{
      0.156434, -0.156434, -0.987688}}],
    Polygon[{{-0.000000, 0.000000, -1.000000},{-0.000000, 
        0.000000, -1.000000},{0.156434, -0.111739, -0.987688},{
      0.156434, -0.134087, -0.987688}}],
    Polygon[{{-0.000000, 0.000000, -1.000000},{-0.000000, 
        0.000000, -1.000000},{0.156434, -0.089391, -0.987688},{
      0.156434, -0.111739, -0.987688}}],
    Polygon[{{-0.000000, 0.000000, -1.000000},{-0.000000, 
        0.000000, -1.000000},{0.156434, -0.067043, -0.987688},{
      0.156434, -0.089391, -0.987688}}],
    Polygon[{{-0.000000, 0.000000, -1.000000},{-0.000000, 
        0.000000, -1.000000},{0.156434, -0.044696, -0.987688},{
      0.156434, -0.067043, -0.987688}}],
    Polygon[{{-0.000000, 0.000000, -1.000000},{-0.000000, 
        0.000000, -1.000000},{0.156434, -0.022348, -0.987688},{
      0.156434, -0.044696, -0.987688}}],
    Polygon[{{-0.000000, 0.000000, -1.000000},{-0.000000, 
        0.000000, -1.000000},{0.156434, -0.000000, -0.987688},{
      0.156434, -0.022348, -0.987688}}],
    Polygon[{{-0.000000, 
        0.000000, -1.000000},{-0.000000, -0.000000, -1.000000},{
      0.156434, 0.022348, -0.987688},{0.156434, -0.000000, -0.987688}}],
    Polygon[{{-0.000000, -0.000000, -1.000000},{-0.000000, -0.000000, \
-1.000000},{0.156434, 0.044696, -0.987688},{0.156434, 0.022348, -0.987688}}],
    Polygon[{{-0.000000, -0.000000, -1.000000},{-0.000000, -0.000000, \
-1.000000},{0.156434, 0.067043, -0.987688},{0.156434, 0.044696, -0.987688}}],
    Polygon[{{-0.000000, -0.000000, -1.000000},{-0.000000, -0.000000, \
-1.000000},{0.156434, 0.089391, -0.987688},{0.156434, 0.067043, -0.987688}}],
    Polygon[{{-0.000000, -0.000000, -1.000000},{-0.000000, -0.000000, \
-1.000000},{0.156434, 0.111739, -0.987688},{0.156434, 0.089391, -0.987688}}],
    Polygon[{{-0.000000, -0.000000, -1.000000},{-0.000000, -0.000000, \
-1.000000},{0.156434, 0.134087, -0.987688},{0.156434, 0.111739, -0.987688}}],
    Polygon[{{-0.000000, -0.000000, -1.000000},{-0.000000, -0.000000, \
-1.000000},{0.156434, 0.156434, -0.987688},{0.156434, 0.134087, -0.987688}}],
    Polygon[{{0.156434, -0.156434, -0.987688},{
      0.156434, -0.134087, -0.987688},{0.309017, -0.264872, -0.951057},{
      0.309017, -0.309017, -0.951057}}],
    Polygon[{{0.156434, -0.134087, -0.987688},{
      0.156434, -0.111739, -0.987688},{0.309017, -0.220726, -0.951057},{
      0.309017, -0.264872, -0.951057}}],
    Polygon[{{0.156434, -0.111739, -0.987688},{
      0.156434, -0.089391, -0.987688},{0.309017, -0.176581, -0.951057},{
      0.309017, -0.220726, -0.951057}}],
    Polygon[{{0.156434, -0.089391, -0.987688},{
      0.156434, -0.067043, -0.987688},{0.309017, -0.132436, -0.951057},{
      0.309017, -0.176581, -0.951057}}],
    Polygon[{{0.156434, -0.067043, -0.987688},{
      0.156434, -0.044696, -0.987688},{0.309017, -0.088291, -0.951057},{
      0.309017, -0.132436, -0.951057}}],
    Polygon[{{0.156434, -0.044696, -0.987688},{
      0.156434, -0.022348, -0.987688},{0.309017, -0.044145, -0.951057},{
      0.309017, -0.088291, -0.951057}}],
    Polygon[{{0.156434, -0.022348, -0.987688},{
      0.156434, -0.000000, -0.987688},{0.309017, -0.000000, -0.951057},{
      0.309017, -0.044145, -0.951057}}],
    Polygon[{{0.156434, -0.000000, -0.987688},{
      0.156434, 0.022348, -0.987688},{0.309017, 0.044145, -0.951057},{
      0.309017, -0.000000, -0.951057}}],
    Polygon[{{0.156434, 0.022348, -0.987688},{0.156434, 0.044696, -0.987688},{
      0.309017, 0.088291, -0.951057},{0.309017, 0.044145, -0.951057}}],
    Polygon[{{0.156434, 0.044696, -0.987688},{0.156434, 0.067043, -0.987688},{
      0.309017, 0.132436, -0.951057},{0.309017, 0.088291, -0.951057}}],
    Polygon[{{0.156434, 0.067043, -0.987688},{0.156434, 0.089391, -0.987688},{
      0.309017, 0.176581, -0.951057},{0.309017, 0.132436, -0.951057}}],
    Polygon[{{0.156434, 0.089391, -0.987688},{0.156434, 0.111739, -0.987688},{
      0.309017, 0.220726, -0.951057},{0.309017, 0.176581, -0.951057}}],
    Polygon[{{0.156434, 0.111739, -0.987688},{0.156434, 0.134087, -0.987688},{
      0.309017, 0.264872, -0.951057},{0.309017, 0.220726, -0.951057}}],
    Polygon[{{0.156434, 0.134087, -0.987688},{0.156434, 0.156434, -0.987688},{
      0.309017, 0.309017, -0.951057},{0.309017, 0.264872, -0.951057}}],
    Polygon[{{0.309017, -0.309017, -0.951057},{
      0.309017, -0.264872, -0.951057},{0.453990, -0.389135, -0.891007},{
      0.453990, -0.453990, -0.891007}}],
    Polygon[{{0.309017, -0.264872, -0.951057},{
      0.309017, -0.220726, -0.951057},{0.453990, -0.324279, -0.891007},{
      0.453990, -0.389135, -0.891007}}],
    Polygon[{{0.309017, -0.220726, -0.951057},{
      0.309017, -0.176581, -0.951057},{0.453990, -0.259423, -0.891007},{
      0.453990, -0.324279, -0.891007}}],
    Polygon[{{0.309017, -0.176581, -0.951057},{
      0.309017, -0.132436, -0.951057},{0.453990, -0.194567, -0.891007},{
      0.453990, -0.259423, -0.891007}}],
    Polygon[{{0.309017, -0.132436, -0.951057},{
      0.309017, -0.088291, -0.951057},{0.453990, -0.129712, -0.891007},{
      0.453990, -0.194567, -0.891007}}],
    Polygon[{{0.309017, -0.088291, -0.951057},{
      0.309017, -0.044145, -0.951057},{0.453990, -0.064856, -0.891007},{
      0.453990, -0.129712, -0.891007}}],
    Polygon[{{0.309017, -0.044145, -0.951057},{
      0.309017, -0.000000, -0.951057},{0.453990, -0.000000, -0.891007},{
      0.453990, -0.064856, -0.891007}}],
    Polygon[{{0.309017, -0.000000, -0.951057},{
      0.309017, 0.044145, -0.951057},{0.453990, 0.064856, -0.891007},{
      0.453990, -0.000000, -0.891007}}],
    Polygon[{{0.309017, 0.044145, -0.951057},{0.309017, 0.088291, -0.951057},{
      0.453990, 0.129712, -0.891007},{0.453990, 0.064856, -0.891007}}],
    Polygon[{{0.309017, 0.088291, -0.951057},{0.309017, 0.132436, -0.951057},{
      0.453990, 0.194567, -0.891007},{0.453990, 0.129712, -0.891007}}],
    Polygon[{{0.309017, 0.132436, -0.951057},{0.309017, 0.176581, -0.951057},{
      0.453990, 0.259423, -0.891007},{0.453990, 0.194567, -0.891007}}],
    Polygon[{{0.309017, 0.176581, -0.951057},{0.309017, 0.220726, -0.951057},{
      0.453990, 0.324279, -0.891007},{0.453990, 0.259423, -0.891007}}],
    Polygon[{{0.309017, 0.220726, -0.951057},{0.309017, 0.264872, -0.951057},{
      0.453990, 0.389135, -0.891007},{0.453990, 0.324279, -0.891007}}],
    Polygon[{{0.309017, 0.264872, -0.951057},{0.309017, 0.309017, -0.951057},{
      0.453990, 0.453990, -0.891007},{0.453990, 0.389135, -0.891007}}],
    Polygon[{{0.453990, -0.453990, -0.891007},{
      0.453990, -0.389135, -0.891007},{0.587785, -0.503816, -0.809017},{
      0.587785, -0.587785, -0.809017}}],
    Polygon[{{0.453990, -0.389135, -0.891007},{
      0.453990, -0.324279, -0.891007},{0.587785, -0.419847, -0.809017},{
      0.587785, -0.503816, -0.809017}}],
    Polygon[{{0.453990, -0.324279, -0.891007},{
      0.453990, -0.259423, -0.891007},{0.587785, -0.335877, -0.809017},{
      0.587785, -0.419847, -0.809017}}],
    Polygon[{{0.453990, -0.259423, -0.891007},{
      0.453990, -0.194567, -0.891007},{0.587785, -0.251908, -0.809017},{
      0.587785, -0.335877, -0.809017}}],
    Polygon[{{0.453990, -0.194567, -0.891007},{
      0.453990, -0.129712, -0.891007},{0.587785, -0.167939, -0.809017},{
      0.587785, -0.251908, -0.809017}}],
    Polygon[{{0.453990, -0.129712, -0.891007},{
      0.453990, -0.064856, -0.891007},{0.587785, -0.083969, -0.809017},{
      0.587785, -0.167939, -0.809017}}],
    Polygon[{{0.453990, -0.064856, -0.891007},{
      0.453990, -0.000000, -0.891007},{0.587785, -0.000000, -0.809017},{
      0.587785, -0.083969, -0.809017}}],
    Polygon[{{0.453990, -0.000000, -0.891007},{
      0.453990, 0.064856, -0.891007},{0.587785, 0.083969, -0.809017},{
      0.587785, -0.000000, -0.809017}}],
    Polygon[{{0.453990, 0.064856, -0.891007},{0.453990, 0.129712, -0.891007},{
      0.587785, 0.167939, -0.809017},{0.587785, 0.083969, -0.809017}}],
    Polygon[{{0.453990, 0.129712, -0.891007},{0.453990, 0.194567, -0.891007},{
      0.587785, 0.251908, -0.809017},{0.587785, 0.167939, -0.809017}}],
    Polygon[{{0.453990, 0.194567, -0.891007},{0.453990, 0.259423, -0.891007},{
      0.587785, 0.335877, -0.809017},{0.587785, 0.251908, -0.809017}}],
    Polygon[{{0.453990, 0.259423, -0.891007},{0.453990, 0.324279, -0.891007},{
      0.587785, 0.419847, -0.809017},{0.587785, 0.335877, -0.809017}}],
    Polygon[{{0.453990, 0.324279, -0.891007},{0.453990, 0.389135, -0.891007},{
      0.587785, 0.503816, -0.809017},{0.587785, 0.419847, -0.809017}}],
    Polygon[{{0.453990, 0.389135, -0.891007},{0.453990, 0.453990, -0.891007},{
      0.587785, 0.587785, -0.809017},{0.587785, 0.503816, -0.809017}}],
    Polygon[{{0.587785, -0.587785, -0.809017},{
      0.587785, -0.503816, -0.809017},{0.707107, -0.606091, -0.707107},{
      0.707107, -0.707107, -0.707107}}],
    Polygon[{{0.587785, -0.503816, -0.809017},{
      0.587785, -0.419847, -0.809017},{0.707107, -0.505076, -0.707107},{
      0.707107, -0.606091, -0.707107}}],
    Polygon[{{0.587785, -0.419847, -0.809017},{
      0.587785, -0.335877, -0.809017},{0.707107, -0.404061, -0.707107},{
      0.707107, -0.505076, -0.707107}}],
    Polygon[{{0.587785, -0.335877, -0.809017},{
      0.587785, -0.251908, -0.809017},{0.707107, -0.303046, -0.707107},{
      0.707107, -0.404061, -0.707107}}],
    Polygon[{{0.587785, -0.251908, -0.809017},{
      0.587785, -0.167939, -0.809017},{0.707107, -0.202031, -0.707107},{
      0.707107, -0.303046, -0.707107}}],
    Polygon[{{0.587785, -0.167939, -0.809017},{
      0.587785, -0.083969, -0.809017},{0.707107, -0.101015, -0.707107},{
      0.707107, -0.202031, -0.707107}}],
    Polygon[{{0.587785, -0.083969, -0.809017},{
      0.587785, -0.000000, -0.809017},{0.707107, -0.000000, -0.707107},{
      0.707107, -0.101015, -0.707107}}],
    Polygon[{{0.587785, -0.000000, -0.809017},{
      0.587785, 0.083969, -0.809017},{0.707107, 0.101015, -0.707107},{
      0.707107, -0.000000, -0.707107}}],
    Polygon[{{0.587785, 0.083969, -0.809017},{0.587785, 0.167939, -0.809017},{
      0.707107, 0.202031, -0.707107},{0.707107, 0.101015, -0.707107}}],
    Polygon[{{0.587785, 0.167939, -0.809017},{0.587785, 0.251908, -0.809017},{
      0.707107, 0.303046, -0.707107},{0.707107, 0.202031, -0.707107}}],
    Polygon[{{0.587785, 0.251908, -0.809017},{0.587785, 0.335877, -0.809017},{
      0.707107, 0.404061, -0.707107},{0.707107, 0.303046, -0.707107}}],
    Polygon[{{0.587785, 0.335877, -0.809017},{0.587785, 0.419847, -0.809017},{
      0.707107, 0.505076, -0.707107},{0.707107, 0.404061, -0.707107}}],
    Polygon[{{0.587785, 0.419847, -0.809017},{0.587785, 0.503816, -0.809017},{
      0.707107, 0.606091, -0.707107},{0.707107, 0.505076, -0.707107}}],
    Polygon[{{0.587785, 0.503816, -0.809017},{0.587785, 0.587785, -0.809017},{
      0.707107, 0.707107, -0.707107},{0.707107, 0.606091, -0.707107}}],
    Polygon[{{0.707107, -0.707107, -0.707107},{
      0.707107, -0.606091, -0.707107},{0.809017, -0.693443, -0.587785},{
      0.809017, -0.809017, -0.587785}}],
    Polygon[{{0.707107, -0.606091, -0.707107},{
      0.707107, -0.505076, -0.707107},{0.809017, -0.577869, -0.587785},{
      0.809017, -0.693443, -0.587785}}],
    Polygon[{{0.707107, -0.505076, -0.707107},{
      0.707107, -0.404061, -0.707107},{0.809017, -0.462295, -0.587785},{
      0.809017, -0.577869, -0.587785}}],
    Polygon[{{0.707107, -0.404061, -0.707107},{
      0.707107, -0.303046, -0.707107},{0.809017, -0.346722, -0.587785},{
      0.809017, -0.462295, -0.587785}}],
    Polygon[{{0.707107, -0.303046, -0.707107},{
      0.707107, -0.202031, -0.707107},{0.809017, -0.231148, -0.587785},{
      0.809017, -0.346722, -0.587785}}],
    Polygon[{{0.707107, -0.202031, -0.707107},{
      0.707107, -0.101015, -0.707107},{0.809017, -0.115574, -0.587785},{
      0.809017, -0.231148, -0.587785}}],
    Polygon[{{0.707107, -0.101015, -0.707107},{
      0.707107, -0.000000, -0.707107},{0.809017, -0.000000, -0.587785},{
      0.809017, -0.115574, -0.587785}}],
    Polygon[{{0.707107, -0.000000, -0.707107},{
      0.707107, 0.101015, -0.707107},{0.809017, 0.115574, -0.587785},{
      0.809017, -0.000000, -0.587785}}],
    Polygon[{{0.707107, 0.101015, -0.707107},{0.707107, 0.202031, -0.707107},{
      0.809017, 0.231148, -0.587785},{0.809017, 0.115574, -0.587785}}],
    Polygon[{{0.707107, 0.202031, -0.707107},{0.707107, 0.303046, -0.707107},{
      0.809017, 0.346722, -0.587785},{0.809017, 0.231148, -0.587785}}],
    Polygon[{{0.707107, 0.303046, -0.707107},{0.707107, 0.404061, -0.707107},{
      0.809017, 0.462295, -0.587785},{0.809017, 0.346722, -0.587785}}],
    Polygon[{{0.707107, 0.404061, -0.707107},{0.707107, 0.505076, -0.707107},{
      0.809017, 0.577869, -0.587785},{0.809017, 0.462295, -0.587785}}],
    Polygon[{{0.707107, 0.505076, -0.707107},{0.707107, 0.606091, -0.707107},{
      0.809017, 0.693443, -0.587785},{0.809017, 0.577869, -0.587785}}],
    Polygon[{{0.707107, 0.606091, -0.707107},{0.707107, 0.707107, -0.707107},{
      0.809017, 0.809017, -0.587785},{0.809017, 0.693443, -0.587785}}],
    Polygon[{{0.809017, -0.809017, -0.587785},{
      0.809017, -0.693443, -0.587785},{0.891007, -0.763720, -0.453990},{
      0.891007, -0.891007, -0.453990}}],
    Polygon[{{0.809017, -0.693443, -0.587785},{
      0.809017, -0.577869, -0.587785},{0.891007, -0.636433, -0.453990},{
      0.891007, -0.763720, -0.453990}}],
    Polygon[{{0.809017, -0.577869, -0.587785},{
      0.809017, -0.462295, -0.587785},{0.891007, -0.509147, -0.453990},{
      0.891007, -0.636433, -0.453990}}],
    Polygon[{{0.809017, -0.462295, -0.587785},{
      0.809017, -0.346722, -0.587785},{0.891007, -0.381860, -0.453990},{
      0.891007, -0.509147, -0.453990}}],
    Polygon[{{0.809017, -0.346722, -0.587785},{
      0.809017, -0.231148, -0.587785},{0.891007, -0.254573, -0.453990},{
      0.891007, -0.381860, -0.453990}}],
    Polygon[{{0.809017, -0.231148, -0.587785},{
      0.809017, -0.115574, -0.587785},{0.891007, -0.127287, -0.453990},{
      0.891007, -0.254573, -0.453990}}],
    Polygon[{{0.809017, -0.115574, -0.587785},{
      0.809017, -0.000000, -0.587785},{0.891007, -0.000000, -0.453990},{
      0.891007, -0.127287, -0.453990}}],
    Polygon[{{0.809017, -0.000000, -0.587785},{
      0.809017, 0.115574, -0.587785},{0.891007, 0.127287, -0.453990},{
      0.891007, -0.000000, -0.453990}}],
    Polygon[{{0.809017, 0.115574, -0.587785},{0.809017, 0.231148, -0.587785},{
      0.891007, 0.254573, -0.453990},{0.891007, 0.127287, -0.453990}}],
    Polygon[{{0.809017, 0.231148, -0.587785},{0.809017, 0.346722, -0.587785},{
      0.891007, 0.381860, -0.453990},{0.891007, 0.254573, -0.453990}}],
    Polygon[{{0.809017, 0.346722, -0.587785},{0.809017, 0.462295, -0.587785},{
      0.891007, 0.509147, -0.453990},{0.891007, 0.381860, -0.453990}}],
    Polygon[{{0.809017, 0.462295, -0.587785},{0.809017, 0.577869, -0.587785},{
      0.891007, 0.636433, -0.453990},{0.891007, 0.509147, -0.453990}}],
    Polygon[{{0.809017, 0.577869, -0.587785},{0.809017, 0.693443, -0.587785},{
      0.891007, 0.763720, -0.453990},{0.891007, 0.636433, -0.453990}}],
    Polygon[{{0.809017, 0.693443, -0.587785},{0.809017, 0.809017, -0.587785},{
      0.891007, 0.891007, -0.453990},{0.891007, 0.763720, -0.453990}}],
    Polygon[{{0.891007, -0.891007, -0.453990},{
      0.891007, -0.763720, -0.453990},{0.951057, -0.815191, -0.309017},{
      0.951057, -0.951057, -0.309017}}],
    Polygon[{{0.891007, -0.763720, -0.453990},{
      0.891007, -0.636433, -0.453990},{0.951057, -0.679326, -0.309017},{
      0.951057, -0.815191, -0.309017}}],
    Polygon[{{0.891007, -0.636433, -0.453990},{
      0.891007, -0.509147, -0.453990},{0.951057, -0.543461, -0.309017},{
      0.951057, -0.679326, -0.309017}}],
    Polygon[{{0.891007, -0.509147, -0.453990},{
      0.891007, -0.381860, -0.453990},{0.951057, -0.407596, -0.309017},{
      0.951057, -0.543461, -0.309017}}],
    Polygon[{{0.891007, -0.381860, -0.453990},{
      0.891007, -0.254573, -0.453990},{0.951057, -0.271730, -0.309017},{
      0.951057, -0.407596, -0.309017}}],
    Polygon[{{0.891007, -0.254573, -0.453990},{
      0.891007, -0.127287, -0.453990},{0.951057, -0.135865, -0.309017},{
      0.951057, -0.271730, -0.309017}}],
    Polygon[{{0.891007, -0.127287, -0.453990},{
      0.891007, -0.000000, -0.453990},{0.951057, -0.000000, -0.309017},{
      0.951057, -0.135865, -0.309017}}],
    Polygon[{{0.891007, -0.000000, -0.453990},{
      0.891007, 0.127287, -0.453990},{0.951057, 0.135865, -0.309017},{
      0.951057, -0.000000, -0.309017}}],
    Polygon[{{0.891007, 0.127287, -0.453990},{0.891007, 0.254573, -0.453990},{
      0.951057, 0.271730, -0.309017},{0.951057, 0.135865, -0.309017}}],
    Polygon[{{0.891007, 0.254573, -0.453990},{0.891007, 0.381860, -0.453990},{
      0.951057, 0.407596, -0.309017},{0.951057, 0.271730, -0.309017}}],
    Polygon[{{0.891007, 0.381860, -0.453990},{0.891007, 0.509147, -0.453990},{
      0.951057, 0.543461, -0.309017},{0.951057, 0.407596, -0.309017}}],
    Polygon[{{0.891007, 0.509147, -0.453990},{0.891007, 0.636433, -0.453990},{
      0.951057, 0.679326, -0.309017},{0.951057, 0.543461, -0.309017}}],
    Polygon[{{0.891007, 0.636433, -0.453990},{0.891007, 0.763720, -0.453990},{
      0.951057, 0.815191, -0.309017},{0.951057, 0.679326, -0.309017}}],
    Polygon[{{0.891007, 0.763720, -0.453990},{0.891007, 0.891007, -0.453990},{
      0.951057, 0.951057, -0.309017},{0.951057, 0.815191, -0.309017}}],
    Polygon[{{0.951057, -0.951057, -0.309017},{
      0.951057, -0.815191, -0.309017},{0.987688, -0.846590, -0.156434},{
      0.987688, -0.987688, -0.156434}}],
    Polygon[{{0.951057, -0.815191, -0.309017},{
      0.951057, -0.679326, -0.309017},{0.987688, -0.705492, -0.156434},{
      0.987688, -0.846590, -0.156434}}],
    Polygon[{{0.951057, -0.679326, -0.309017},{
      0.951057, -0.543461, -0.309017},{0.987688, -0.564393, -0.156434},{
      0.987688, -0.705492, -0.156434}}],
    Polygon[{{0.951057, -0.543461, -0.309017},{
      0.951057, -0.407596, -0.309017},{0.987688, -0.423295, -0.156434},{
      0.987688, -0.564393, -0.156434}}],
    Polygon[{{0.951057, -0.407596, -0.309017},{
      0.951057, -0.271730, -0.309017},{0.987688, -0.282197, -0.156434},{
      0.987688, -0.423295, -0.156434}}],
    Polygon[{{0.951057, -0.271730, -0.309017},{
      0.951057, -0.135865, -0.309017},{0.987688, -0.141098, -0.156434},{
      0.987688, -0.282197, -0.156434}}],
    Polygon[{{0.951057, -0.135865, -0.309017},{
      0.951057, -0.000000, -0.309017},{0.987688, -0.000000, -0.156434},{
      0.987688, -0.141098, -0.156434}}],
    Polygon[{{0.951057, -0.000000, -0.309017},{
      0.951057, 0.135865, -0.309017},{0.987688, 0.141098, -0.156434},{
      0.987688, -0.000000, -0.156434}}],
    Polygon[{{0.951057, 0.135865, -0.309017},{0.951057, 0.271730, -0.309017},{
      0.987688, 0.282197, -0.156434},{0.987688, 0.141098, -0.156434}}],
    Polygon[{{0.951057, 0.271730, -0.309017},{0.951057, 0.407596, -0.309017},{
      0.987688, 0.423295, -0.156434},{0.987688, 0.282197, -0.156434}}],
    Polygon[{{0.951057, 0.407596, -0.309017},{0.951057, 0.543461, -0.309017},{
      0.987688, 0.564393, -0.156434},{0.987688, 0.423295, -0.156434}}],
    Polygon[{{0.951057, 0.543461, -0.309017},{0.951057, 0.679326, -0.309017},{
      0.987688, 0.705492, -0.156434},{0.987688, 0.564393, -0.156434}}],
    Polygon[{{0.951057, 0.679326, -0.309017},{0.951057, 0.815191, -0.309017},{
      0.987688, 0.846590, -0.156434},{0.987688, 0.705492, -0.156434}}],
    Polygon[{{0.951057, 0.815191, -0.309017},{0.951057, 0.951057, -0.309017},{
      0.987688, 0.987688, -0.156434},{0.987688, 0.846590, -0.156434}}],
    Polygon[{{0.987688, -0.987688, -0.156434},{
      0.987688, -0.846590, -0.156434},{1.000000, -0.857143, -0.000000},{
      1.000000, -1.000000, -0.000000}}],
    Polygon[{{0.987688, -0.846590, -0.156434},{
      0.987688, -0.705492, -0.156434},{1.000000, -0.714286, -0.000000},{
      1.000000, -0.857143, -0.000000}}],
    Polygon[{{0.987688, -0.705492, -0.156434},{
      0.987688, -0.564393, -0.156434},{1.000000, -0.571429, -0.000000},{
      1.000000, -0.714286, -0.000000}}],
    Polygon[{{0.987688, -0.564393, -0.156434},{
      0.987688, -0.423295, -0.156434},{1.000000, -0.428571, -0.000000},{
      1.000000, -0.571429, -0.000000}}],
    Polygon[{{0.987688, -0.423295, -0.156434},{
      0.987688, -0.282197, -0.156434},{1.000000, -0.285714, -0.000000},{
      1.000000, -0.428571, -0.000000}}],
    Polygon[{{0.987688, -0.282197, -0.156434},{
      0.987688, -0.141098, -0.156434},{1.000000, -0.142857, -0.000000},{
      1.000000, -0.285714, -0.000000}}],
    Polygon[{{0.987688, -0.141098, -0.156434},{
      0.987688, -0.000000, -0.156434},{1.000000, -0.000000, -0.000000},{
      1.000000, -0.142857, -0.000000}}],
    Polygon[{{0.987688, -0.000000, -0.156434},{
      0.987688, 0.141098, -0.156434},{1.000000, 0.142857, -0.000000},{
      1.000000, -0.000000, -0.000000}}],
    Polygon[{{0.987688, 0.141098, -0.156434},{0.987688, 0.282197, -0.156434},{
      1.000000, 0.285714, -0.000000},{1.000000, 0.142857, -0.000000}}],
    Polygon[{{0.987688, 0.282197, -0.156434},{0.987688, 0.423295, -0.156434},{
      1.000000, 0.428571, -0.000000},{1.000000, 0.285714, -0.000000}}],
    Polygon[{{0.987688, 0.423295, -0.156434},{0.987688, 0.564393, -0.156434},{
      1.000000, 0.571429, -0.000000},{1.000000, 0.428571, -0.000000}}],
    Polygon[{{0.987688, 0.564393, -0.156434},{0.987688, 0.705492, -0.156434},{
      1.000000, 0.714286, -0.000000},{1.000000, 0.571429, -0.000000}}],
    Polygon[{{0.987688, 0.705492, -0.156434},{0.987688, 0.846590, -0.156434},{
      1.000000, 0.857143, -0.000000},{1.000000, 0.714286, -0.000000}}],
    Polygon[{{0.987688, 0.846590, -0.156434},{0.987688, 0.987688, -0.156434},{
      1.000000, 1.000000, -0.000000},{1.000000, 0.857143, -0.000000}}]},
    Lighting -> True,
    ViewPoint -> {-2.760033, -0.453570, 1.903174}
  ]
], "Graphics",
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P000182000`400?l00000o`00003oo`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00g`3oool2000003l0oooo003F
0?ooo`T0000000<0oooo0000003oool0?P3oool00<h0oooo2000000:0?ooo`030000003oool0oooo
03d0oooo00350?ooo`T000004P3oool2000003h0oooo002l0?ooo`T000006`3oool2000003h0oooo
002d0?ooo`P000009@3oool00`000000oooo0?ooo`0l0?ooo`00Z`3oool9000002d0oooo00<00000
0?ooo`3oool0?03oool00:<0oooo2000000f0?ooo`030000003oool0oooo03`0oooo002J0?ooo`T0
0000?P3oool00`000000oooo0?ooo`0l0?ooo`00TP3oool8000004L0oooo00<000000?ooo`3oool0
?03oool008T0oooo2@00001?0?ooo`030000003oool0oooo03`0oooo00200?ooo`T00000F03oool2
000003d0oooo001h0?ooo`P00000H@3oool2000003d0oooo001_0?ooo`T00000J@3oool2000003d0
oooo001W0?ooo`P00000LP3oool2000003d0oooo001N0?ooo`T00000NP3oool2000003d0oooo001E
0?ooo`T00000P`3oool2000003d0oooo001=0?ooo`P00000S03oool2000003d0oooo00140?ooo`T0
0000U03oool2000003d0oooo000l0?ooo`P00000W@3oool2000003d0oooo000c0?ooo`T00000Y@3o
ool00`000000oooo0000000l0?ooo`00:P3oool9000004`0oooo4P00001@0?ooo`030000003oool0
000003`0oooo000T0?ooo`H00000D@3oool4000000L0oooo00<000000?ooo`3oool01P3oool00`00
0000oooo00000004000004/0oooo00<000000?ooo`000000?03oool002@0oooo0P00001A0?ooo`@0
00000P3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3o
ool0103oool3000004T0oooo0P00000l0?ooo`00903oool2000004h0oooo0`0000070?ooo`030000
003oool0oooo00H0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`050?ooo`040000
003oool00000000004L0oooo0P00000l0?ooo`00903oool00`000000oooo0000001;0?ooo`800000
00<0oooo0000003oool01`3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00H0oooo
00<000000?ooo`3oool0103oool010000000oooo0?ooo`3oool3000004@0oooo0P00000l0?ooo`00
903oool00`000000oooo000000180?ooo`<000000`3oool00`000000oooo0?ooo`060?ooo`030000
003oool0oooo00H0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`050?ooo`030000
003oool0oooo00<0oooo00<000000?ooo`3oool0@@3oool2000003`0oooo000S0?ooo`040000003o
ool0oooo000004H0oooo0P0000060?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool0
1P3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool0
0`3oool300000440oooo0P00000l0?ooo`008`3oool01@000000oooo0?ooo`3oool0000004<0oooo
0P0000090?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool01P3oool00`000000oooo
0?ooo`050?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool0103oool00`000000oooo
000000100?ooo`030000003oool0000003/0oooo000S0?ooo`050000003oool0oooo0?ooo`000000
@P3oool010000000oooo0?ooo`0000080?ooo`030000003oool0oooo00H0oooo00@000000?ooo`3o
ool0oooo3`0000060?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool00P00000n0?oo
o`030000003oool0000003/0oooo000S0?ooo`030000003oool0oooo0080oooo00<000000?ooo`3o
ool0?@3oool2000000<0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`050?ooo`D0
00001@3oool00`000000oooo0?ooo`060?ooo`D000000P3oool00`000000oooo0?ooo`040?ooo`03
0000003oool0oooo0080oooo00<000000?ooo`3oool0>`3oool00`000000oooo0000000k0?ooo`00
8`3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo03`0oooo00<000000?ooo`3oool0
0`3oool00`000000oooo0?ooo`060?ooo`040000003oool0oooo0?ooo`@000000P3oool00`000000
oooo0?ooo`060?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool00P3oool4000000D0
oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`0j0?ooo`030000003oool0000003/0
oooo000S0?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool0>@3oool2000000L0oooo
00<000000?ooo`3oool01P3oool3000000H0oooo00<000000?ooo`3oool01P3oool00`000000oooo
0?ooo`050?ooo`030000003oool0oooo00D0oooo0`0000030?ooo`030000003oool0oooo00<0oooo
0P00000k0?ooo`030000003oool0000003/0oooo000S0?ooo`030000003oool0oooo00<0oooo00<0
00000?ooo`3oool0>03oool2000000P0oooo00<000000?ooo`3oool00`3oool4000000P0oooo00<0
00000?ooo`3oool01P3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00@0oooo00<0
00000?ooo`3oool00`0000000`3oool000000?ooo`030?ooo`030000003oool0000003X0oooo00<0
00000?ooo`000000>`3oool00280oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`0f
0?ooo`030000003oool0000000P0oooo00@000000?ooo`3oool0oooo0P0000030?ooo`030000003o
ool0oooo00L0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`060?ooo`030000003o
ool0oooo00@0oooo00<000000?ooo`3oool00`3oool2000000@0oooo00@000000?ooo`3oool00000
>@3oool00`000000oooo0000000k0?ooo`008P3oool00`000000oooo0?ooo`050?ooo`030000003o
ool0oooo03D0oooo00D000000?ooo`3oool0oooo000000080?ooo`<000001P3oool00`000000oooo
0?ooo`060?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool01@3oool00`000000oooo
0?ooo`050?ooo`030000003oool0oooo00<0oooo0P0000030?ooo`040000003oool0oooo000003T0
oooo00<000000?ooo`000000>`3oool00280oooo00<000000?ooo`3oool01P3oool00`000000oooo
0?ooo`0c0?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool01@3oool2000000P0oooo
00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00D0oooo
00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`030?ooo`030000003oool0000000<0oooo
00@000000?ooo`3oool00000>03oool00`000000oooo0000000k0?ooo`008P3oool00`000000oooo
0?ooo`060?ooo`030000003oool0oooo0380oooo00<000000?ooo`3oool00`3oool00`000000oooo
0?ooo`040?ooo`030000003oool0000000P0oooo00<000000?ooo`3oool01P3oool010000000oooo
0?ooo`3oool?000000H0oooo00<000000?ooo`3oool0103oool01P000000oooo000000000000oooo
000000<0oooo00<000000?ooo`3oool0=@3oool010000000oooo0?ooo`00000j0?ooo`008P3oool0
0`000000oooo0?ooo`070?ooo`030000003oool0oooo0300oooo00<000000?ooo`3oool01@3oool0
10000000oooo0?ooo`3oool2000000<0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?oo
o`040?ooo`D000001@3oool00`000000oooo0?ooo`060?ooo`D000000P3oool00`000000oooo0?oo
o`040?ooo`040000003oool0oooo0?ooo`8000000`3oool00`000000oooo0?ooo`0e0?ooo`040000
003oool0oooo000003X0oooo000R0?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool0
;`3oool2000000L0oooo00@000000?ooo`3oool000001@3oool00`000000oooo0?ooo`060?ooo`03
0000003oool0oooo00@000000P3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00D0
oooo00<000000?ooo`3oool00P3oool4000000D0oooo00<000000?ooo`3oool00P3oool010000000
oooo0?ooo`3oool2000003H0oooo00@000000?ooo`3oool00000>P3oool00240oooo00<000000?oo
o`3oool02@3oool00`000000oooo0?ooo`0]0?ooo`030000003oool0000000L0oooo0`0000060?oo
o`030000003oool0oooo00H0oooo0`0000060?ooo`030000003oool0oooo00H0oooo00<000000?oo
o`3oool01@3oool00`000000oooo0?ooo`050?ooo`<000000`3oool00`000000oooo0?ooo`020?oo
o`8000000P3oool2000003H0oooo00@000000?ooo`3oool00000>P3oool00240oooo00<000000?oo
o`3oool02@3oool00`000000oooo0?ooo`0]0?ooo`040000003oool0oooo000000H0oooo0P000007
0?ooo`030000003oool0oooo00@0oooo0`0000080?ooo`030000003oool0oooo00H0oooo00<00000
0?ooo`3oool01@3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo0080000000<0oooo
0000003oool0103oool2000000040?ooo`000000oooo000003H0oooo00<000000?ooo`000000>P3o
ool00240oooo00<000000?ooo`3oool02P3oool00`000000oooo0?ooo`0[0?ooo`050000003oool0
oooo0?ooo`0000001@3oool00`000000oooo000000080?ooo`030000003oool0oooo00<000000`3o
ool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool01P3o
ool00`000000oooo0?ooo`040?ooo`030000003oool0oooo0080oooo0`0000040?ooo`060000003o
ool000000000003oool00000=P3oool00`000000oooo0000000j0?ooo`008@3oool00`000000oooo
0?ooo`0:0?ooo`030000003oool0oooo02X0oooo00<000000?ooo`3oool00P3oool00`000000oooo
0?ooo`020?ooo`040000003oool0oooo000000P0oooo0`0000060?ooo`030000003oool0oooo00H0
oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00@0
oooo00<000000?ooo`3oool0103oool2000000<0oooo00<000000?ooo`3oool00P0000000`3oool0
00000?ooo`0d0?ooo`030000003oool0000003X0oooo000Q0?ooo`030000003oool0oooo00/0oooo
00<000000?ooo`3oool0:03oool00`000000oooo0?ooo`040?ooo`040000003oool0oooo000000@0
oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00H0
oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00D0
oooo00<000000?ooo`3oool00`3oool00`000000oooo000000020?ooo`070000003oool0oooo0?oo
o`000000oooo0000000e0?ooo`030000003oool0000003X0oooo000Q0?ooo`030000003oool0oooo
00/0oooo00<000000?ooo`3oool0:03oool00`000000oooo0?ooo`040?ooo`030000003oool00000
00D0oooo00<000000?ooo`3oool00`3oool2000000030?ooo`000000oooo00L0oooo00<000000?oo
o`3oool01P3ooolC000000D0oooo00<000000?ooo`3oool00`3oool01P000000oooo0?ooo`000000
oooo000000<0oooo00<000000?ooo`000000=@3oool010000000oooo0?ooo`00000i0?ooo`008@3o
ool00`000000oooo0?ooo`0<0?ooo`030000003oool0oooo02H0oooo0P0000060?ooo`8000001P3o
ool00`000000oooo0?ooo`020?ooo`050000003oool0oooo0?ooo`000000203oool00`000000oooo
0?ooo`020?ooo`D00000203oool00`000000oooo0?ooo`050?ooo`030000003oool0000000<00000
00<0oooo0000003oool0103oool010000000oooo0?ooo`3oool300000080oooo0`00000e0?ooo`04
0000003oool0oooo000003T0oooo000P0?ooo`030000003oool0oooo00d0oooo00<000000?ooo`3o
ool09P3oool00`000000oooo000000050?ooo`8000001`3oool010000000oooo0000000000040?oo
o`030000003oool0oooo00H0oooo00<000000?ooo`0000000P0000040?ooo`030000003oool0oooo
00H0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`030?ooo`<000001@3oool00`00
0000oooo0?ooo`020?ooo`030000003oool0oooo00<00000=@3oool010000000oooo0?ooo`00000i
0?ooo`00803oool00`000000oooo0?ooo`0>0?ooo`030000003oool0oooo02@0oooo00@000000?oo
o`3oool00000103oool00`000000oooo000000070?ooo`8000001`3oool00`000000oooo0?ooo`04
0?ooo`<000001`3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00D0oooo00<00000
0?ooo`3oool0103oool010000000oooo0000000000030?ooo`030000003oool0oooo0080oooo0P00
00020?ooo`800000=@3oool010000000oooo0?ooo`00000i0?ooo`00803oool00`000000oooo0?oo
o`0>0?ooo`030000003oool0oooo02@0oooo00@000000?ooo`3oool000000`3oool010000000oooo
0?ooo`0000060?ooo`<000001`3oool00`000000oooo0?ooo`020?ooo`8000000P3oool00`000000
oooo0?ooo`060?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool01@3oool00`000000
oooo0?ooo`050?ooo`030000003oool0oooo00@00000103oool010000000oooo0000003oool30000
03@0oooo00@000000?ooo`3oool00000>@3oool00200oooo00<000000?ooo`3oool03P3oool00`00
0000oooo0?ooo`0S0?ooo`030000003oool0oooo0080oooo00@000000?ooo`3oool000000`3oool0
0`000000oooo0?ooo`020?ooo`040000003oool0oooo000000L0oooo00<000000?ooo`3oool00P00
00040?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?oo
o`050?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?oo
o`020?ooo`070000003oool000000?ooo`000000oooo0000000d0?ooo`040000003oool0oooo0000
03T0oooo000P0?ooo`030000003oool0oooo00l0oooo00<000000?ooo`3oool08P3oool00`000000
oooo0?ooo`020?ooo`030000003oool0000000@0oooo00D000000?ooo`3oool0oooo000000030?oo
o`030000003oool0oooo00H0oooo0P0000060?ooo`030000003oool0oooo00H0oooo00<000000?oo
o`3oool01P3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00@0oooo00<000000?oo
o`3oool00`3oool3000000<0oooo00H000000?ooo`00000000000?ooo`00000d0?ooo`040000003o
ool0oooo000003T0oooo000P0?ooo`030000003oool0oooo00l0oooo00<000000?ooo`3oool08@3o
ool2000000@0oooo0P0000060?ooo`030000003oool0000000D0oooo00<000000?ooo`3oool00`3o
ool3000000P0oooo00<000000?ooo`3oool01P3oool010000000oooo0?ooo`3oool=000000H0oooo
00<000000?ooo`3oool0103oool00`000000oooo000000020?ooo`060000003oool0oooo0000003o
ool00000=03oool010000000oooo0?ooo`00000i0?ooo`00803oool00`000000oooo0?ooo`0@0?oo
o`030000003oool0oooo0200oooo0P0000050?ooo`030000003oool0oooo00@0oooo0P0000060?oo
o`030000003oool0oooo0080oooo00@000000?ooo`3oool00000203oool00`000000oooo0?ooo`04
0?ooo`H00000103oool00`000000oooo0?ooo`050?ooo`D000000`3oool00`000000oooo0?ooo`03
0?ooo`060000003oool0oooo0000003oool000000P3oool3000003@0oooo00@000000?ooo`3oool0
0000>@3oool001l0oooo00<000000?ooo`3oool04@3oool00`000000oooo0?ooo`0P0?ooo`800000
103oool2000000H0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`02000000@0oooo
00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`0400000080oooo00<000000?ooo`3oool0
1P3oool00`000000oooo0?ooo`050?ooo`040000003oool0oooo0?ooo`@000001@3oool010000000
oooo0?ooo`3oool2000000<0oooo00<000000?ooo`000000<`3oool01@000000oooo0?ooo`3oool0
000003P0oooo000O0?ooo`030000003oool0oooo0180oooo00<000000?ooo`3oool07`3oool00`00
0000oooo000000030?ooo`030000003oool0000000@0oooo00<000000?ooo`0000001`3oool20000
00H0oooo00<000000?ooo`3oool01@3oool3000000H0oooo00<000000?ooo`3oool01P3oool00`00
0000oooo0?ooo`050?ooo`030000003oool0oooo00@0oooo0`0000030?ooo`030000003oool0oooo
0080oooo0P0000020?ooo`<00000<`3oool01@000000oooo0?ooo`3oool0000003P0oooo000O0?oo
o`030000003oool0oooo0180oooo00<000000?ooo`3oool07`3oool00`000000oooo000000020?oo
o`040000003oool0oooo000000@0oooo00<000000?ooo`0000001`3oool00`000000oooo0?ooo`05
0?ooo`030000003oool0oooo00<0oooo0P0000000`3oool000000?ooo`070?ooo`030000003oool0
oooo00D0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`040?ooo`030000003oool0
oooo0080000000<0oooo0000003oool00`3oool200000080oooo0`00000c0?ooo`050000003oool0
oooo0?ooo`000000>03oool001l0oooo00<000000?ooo`3oool04`3oool00`000000oooo0?ooo`0M
0?ooo`070000003oool0oooo0?ooo`000000oooo000000020?ooo`050000003oool0oooo0?ooo`00
00000P3oool00`000000oooo0?ooo`040?ooo`800000203oool00`000000oooo0?ooo`02000000<0
oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00D0
oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`020?ooo`<00000103oool200000004
0?ooo`000000oooo000002D0oooo200000060?ooo`050000003oool0oooo0?ooo`000000>03oool0
01l0oooo00<000000?ooo`3oool04`3oool00`000000oooo0?ooo`0M0?ooo`040000003oool0oooo
0?ooo`800000103oool00`000000oooo000000040?ooo`040000003oool0oooo0?ooo`8000000P3o
ool00`000000oooo0?ooo`050?ooo`<000001P3oool00`000000oooo0?ooo`050?ooo`030000003o
ool0oooo00H0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`040?ooo`030000003o
ool0oooo00<0oooo0P0000030?ooo`060000003oool000000000003oool000006`3ooolB000000H0
oooo00D000000?ooo`3oool0oooo0000000h0?ooo`007`3oool00`000000oooo0?ooo`0D0?ooo`03
0000003oool0oooo01`0oooo00@000000?ooo`3oool0oooo0P0000040?ooo`030000003oool00000
00@0oooo00@000000?ooo`3oool00000103oool00`000000oooo0?ooo`040?ooo`800000203oool0
0`000000oooo0?ooo`060?ooo`030000003oool0oooo0080oooo2@0000020?ooo`030000003oool0
oooo00@0oooo00<000000?ooo`3oool00`3oool00`000000oooo000000020?ooo`030000003oool0
000000<000004@3ooolG00000080oooo0`0000070?ooo`040000003oool0oooo000003P0oooo000N
0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3oool0703oool010000000oooo0?ooo`3o
ool2000000D0oooo00<000000?ooo`3oool00`3oool00`000000oooo000000050?ooo`030000003o
ool0oooo00<0oooo00@000000?ooo`3oool000001`3oool00`000000oooo0?ooo`040?ooo`L00000
0`3oool00`000000oooo0?ooo`030?ooo`H000000`3oool00`000000oooo0?ooo`030?ooo`090000
003oool0oooo0000003oool000000?ooo`000000oooo00<000001P3ooolH000000030?ooo`000000
000000P000000P3oool00`000000oooo0?ooo`050?ooo`040000003oool0oooo000003P0oooo000N
0?ooo`030000003oool0oooo01H0oooo00<000000?ooo`3oool06`3oool200000080oooo0P000004
0?ooo`8000001P3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo008000000`3oool0
0`000000oooo0?ooo`050?ooo`040000003oool0oooo0?ooo`<000000P3oool00`000000oooo0?oo
o`050?ooo`030000003oool0oooo00D0oooo00@000000?ooo`3oool0oooo100000060?ooo`030000
003oool0oooo0080000000<0oooo0000003oool08`00000:0?ooo`8000001`3oool010000000oooo
0?ooo`00000h0?ooo`007P3oool00`000000oooo0?ooo`0F0?ooo`030000003oool0oooo01/0oooo
0P0000020?ooo`800000103oool2000000H0oooo00<000000?ooo`3oool01@3oool00`000000oooo
000000050?ooo`030000003oool0oooo00H0oooo0`0000050?ooo`030000003oool0oooo00H0oooo
00<000000?ooo`3oool0103oool00`000000oooo0?ooo`050?oooa/000000P3oool9000000X0oooo
2`0000000`3oool00000000000060?ooo`050000003oool0oooo0?ooo`000000=`3oool001h0oooo
00<000000?ooo`3oool05`3oool00`000000oooo0?ooo`0J0?ooo`070000003oool000000?ooo`00
0000oooo000000020?ooo`040000003oool0oooo000000@0oooo00<000000?ooo`0000001P3oool2
000000L0oooo00<000000?ooo`3oool00P3oool4000000P0oooo00<000000?ooo`3oool01@3oool0
0`000000oooo0?ooo`020?ooo``000000P0c<c<=00000080oooo2P0000070?ooo`80000000<0oooo
0000000000002@0000050?ooo`L000001P3oool01@000000oooo0?ooo`3oool0000003L0oooo000N
0?ooo`030000003oool0oooo01L0oooo00<000000?ooo`3oool06P3oool01`000000oooo0000003o
ool000000?ooo`0000000P3oool010000000oooo0?ooo`0000030?ooo`040000003oool0oooo0000
00D0oooo00<000000?ooo`0000001`3oool00`000000oooo0?ooo`02000000<0oooo00<000000?oo
o`3oool01P3oool00`000000oooo0?ooo`0=0000000303<c<`000000000000P000000`0c<c<20000
0080<c<c00<0000003<c<`0000001@0000050?ooo`030000003oool000000080oooo2P0000060?oo
o`X000001@3oool2000000H0oooo00D000000?ooo`3oool0oooo0000000g0?ooo`007P3oool00`00
0000oooo0?ooo`0H0?ooo`030000003oool0oooo01T0oooo00@000000?ooo`00000000000`3oool0
0`000000oooo000000020?ooo`040000003oool0oooo000000<0oooo00<000000?ooo`3oool00P3o
ool010000000oooo0?ooo`0000070?ooo`<000001P3oool00`000000oooo0000000:0000000303<c
<`000000000000T00000100c<c<00`000000<c<c03<c<`0203<c<`030000000c<c<0<c<c00`00000
00<0oooo000000000000200000060?ooo`X00000103oool00`000000oooo0?ooo`080?ooo`800000
1P3oool01@000000oooo0?ooo`3oool0000003L0oooo000N0?ooo`030000003oool0oooo01P0oooo
00<000000?ooo`3oool06@3oool010000000oooo0?ooo`0000030?ooo`800000103oool00`000000
oooo000000040?ooo`040000003oool0oooo000000<0oooo00<000000?ooo`3oool0103oool=0000
0080<c<c2P00000403<c<`030000000c<c<0<c<c0080<c<c00<0000003<c<`0c<c<02P00000303<c
<`<000000P0c<c<5000000D0oooo2`000000103oool000000?ooo`00000:0?ooo`030000003oool0
oooo00H0oooo100000060?ooo`050000003oool0oooo0?ooo`000000=`3oool001d0oooo00<00000
0?ooo`3oool06P3oool00`000000oooo0?ooo`0I0?ooo`030000003oool0000000<0oooo0P000004
0?ooo`8000001@3oool00`000000oooo000000040?ooo`/0000000<0<c<c00000000000020000004
03<c<`030000000c<c<0<c<c0080<c<c00<0000003<c<`0c<c<02P00000303<c<`8000000`0c<c<0
0`000000<c<c03<c<`0203<c<`<000000P0c<c<;00000080oooo00<000000?ooo`3oool01`3oool2
000000T0oooo2P0000020?ooo`8000001P3oool01@000000oooo0?ooo`3oool0000003L0oooo000M
0?ooo`030000003oool0oooo01X0oooo00<000000?ooo`3oool06@3oool010000000oooo00000000
00020?ooo`800000103oool2000000D0oooo5000000303<c<`030000000c<c<0<c<c0080<c<c00<0
000003<c<`0c<c<02P00000203<c<`030000000c<c<0000000<0<c<c00<0000003<c<`0c<c<00P0c
<c<00`000000<c<c03<c<`0303<c<`030000000c<c<0<c<c00X000001P3oool010000000oooo0?oo
o`0000090?ooo`/0000000<0oooo0000003oool0103oool7000000H0oooo00D000000?ooo`3oool0
oooo0000000g0?ooo`007@3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo01P0oooo
00@000000?ooo`00000000000P3oool200000080oooo4`00000303<c<`030000000c<c<0<c<c0080
<c<c00@0000003<c<`0c<c<0<c<c2@0000001@0c<c<0000003<c<`0c<c<000000080<c<c00<00000
03<c<`0c<c<00P0c<c<00`000000<c<c03<c<`0303<c<`040000000c<c<0<c<c03<c<`/000000P0c
<c<010000000<c<c0000000c<c<3000000H0oooo0P0000000`3oool000000000000:000000H0oooo
2P0000050?ooo`8000001P3oool01@000000oooo0?ooo`3oool0000003L0oooo000M0?ooo`030000
003oool0oooo01/0oooo00<000000?ooo`3oool0603ooolD00000080<c<c0P00000303<c<`040000
000c<c<0<c<c03<c<`/000000P0c<c<00`000000<c<c0000000403<c<`030000000c<c<0<c<c00<0
<c<c00<0000003<c<`0c<c<00P0c<c<:00000080<c<c00<0000003<c<`0c<c<00`0c<c<2000000<0
<c<c0`0000000`0c<c<000000000000;000000L0oooo2P0000040?ooo`030000003oool0oooo00T0
oooo00<000000?ooo`3oool0103oool01@000000oooo0?ooo`3oool0000003L0oooo000M0?ooo`03
0000003oool0oooo01`0oooo00<000000?ooo`3oool03@3ooolG000000030?ooo`00000000000080
00000`0c<c<:000000<0<c<c0P00000403<c<`030000000c<c<0<c<c00<0<c<c00<0000003<c<`0c
<c<00P0c<c<<000000D0<c<c00<0000003<c<`0c<c<00`0c<c<00`000000<c<c03<c<`0303<c<`03
0000000c<c<0000000<0<c<c0P00000203<c<`030000000c<c<0000000H0oooo2P0000020?ooo`80
00002P3oool2000000X0oooo0P0000050?ooo`030000003oool0oooo0080oooo00<000000?ooo`3o
ool0=03oool001d0oooo00<000000?ooo`3oool0703oool00`000000oooo0?ooo`030?oooaL00000
00<0oooo0000000000003`00000303<c<`800000100c<c<00`000000<c<c03<c<`0203<c<`030000
000c<c<0<c<c0080<c<c00<0000003<c<`0c<c<02@00000503<c<`030000000c<c<0<c<c0080<c<c
00<0000003<c<`0c<c<00`0c<c<01`000000<c<c03<c<`0c<c<0000003<c<`000000100c<c<20000
00<0<c<c400000000`3oool000000?ooo`080?ooo`030000003oool0000000T0oooo0P00000:0?oo
o`8000001@3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo03@0oooo000L0?ooo`03
0000003oool0oooo01d0oooo4`0000020?ooo`T0000000<0oooo0000000000000P3oool200000080
oooo0`00000303<c<`030000000c<c<0<c<c0080<c<c00<0000003<c<`0c<c<00P0c<c<010000000
<c<c03<c<`0c<c<:00000080<c<c00<0000003<c<`0c<c<00`0c<c<00`000000<c<c03<c<`0303<c
<`030000000c<c<0<c<c0080<c<c00<0000003<c<`0c<c<00`0c<c<00`000000<c<c03<c<`0303<c
<`X000000P0c<c<01P000000<c<c03<c<`0c<c<0000003<c<`8000001@3oool010000000oooo0?oo
o`0000080?ooo`030000003oool0000000T0oooo0P0000030?ooo`T000001@3oool00`000000oooo
0?ooo`020?ooo`030000003oool0oooo03@0oooo000L0?ooo`030000003oool0oooo01d0oooo5P00
00060?ooo``00000100c<c<00`000000<c<c03<c<`0203<c<`X0000000<0<c<c0000000c<c<0100c
<c<00`000000<c<c03<c<`0203<c<`030000000c<c<0<c<c00<0<c<c0P00000403<c<`030000000c
<c<0<c<c0080<c<c00<0000003<c<`0000002P00000303<c<`030000000c<c<0000000@0<c<c0`00
000203<c<`040000000c<c<00000000000D0oooo00@000000?ooo`3oool00000203oool00`000000
oooo000000040?ooo`X000000P3oool7000000D0oooo00<000000?ooo`3oool00P3oool00`000000
oooo0?ooo`0d0?ooo`00703oool00`000000oooo0?ooo`0L0?ooo`030000003oool0000000@0oooo
1@0000070?ooo`030000003oool0000000T0000000<0oooo0000003oool00P3oool?000000@0<c<c
00<0000003<c<`0c<c<00`0c<c<00`000000<c<c03<c<`0203<c<`040000000c<c<0<c<c00000080
<c<c00<0000003<c<`0c<c<00`0c<c<00`000000<c<c03<c<`0:000000D0<c<c00<0000003<c<`0c
<c<00`0c<c<00`000000<c<c0000000203<c<`8000000P0c<c<01@000000<c<c000000000000<c<c
0080000000<0<c<c0000000000001@3oool010000000oooo0?ooo`0000040?ooo`/000000P3oool:
000000D0oooo0P0000050?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool0=03oool0
01`0oooo00<000000?ooo`3oool0703oool010000000oooo0?ooo`0000040?ooo`040000003oool0
00000?ooo`X000001@3oool;000000030?ooo`000000<c<c00<0<c<c00<0000003<c<`0c<c<00`0c
<c<00`000000<c<c03<c<`0203<c<`070000000c<c<0<c<c03<c<`000000<c<c0000000403<c<`03
0000000c<c<0<c<c0080<c<c2P00000303<c<`030000000c<c<0<c<c00<0<c<c00<0000003<c<`0c
<c<00`0c<c<00`000000<c<c03<c<`0303<c<`800000100c<c<010000000<c<c03<c<`00000203<c
<`040000000c<c<0000003<c<`<000000`3oool:000000<0oooo2P0000040?ooo`030000003oool0
oooo00P0oooo0P0000050?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool0=03oool0
01`0oooo00<000000?ooo`3oool06`3oool00`000000oooo0?ooo`0:000000D0oooo2P0000030?oo
o`@000000P3oool3000000D0<c<c00<0000003<c<`0c<c<00P0c<c<00`000000<c<c03<c<`0303<c
<`030000000c<c<0<c<c0080<c<c2`0000000`0c<c<0000003<c<`0403<c<`030000000c<c<0<c<c
00<0<c<c00<0000003<c<`0c<c<00`0c<c<00`000000<c<c03<c<`0303<c<`030000000c<c<0<c<c
00<0<c<c00<0000003<c<`0c<c<00`0c<c<00`000000<c<c0000000=00000080oooo2`000000103o
ool000000?ooo`00000:0?ooo`030000003oool0oooo00P0oooo0P0000060?ooo`050000003oool0
oooo0?ooo`000000=P3oool001`0oooo00<000000?ooo`3oool06`3oool300000080oooo00<00000
0?ooo`3oool00P3oool8000000<0oooo00<000000?ooo`3oool0203oool2000000060?ooo`000000
oooo0000003oool00000100c<c<00`000000<c<c03<c<`0303<c<`030000000c<c<0000000T00000
1@0c<c<00`000000<c<c03<c<`0303<c<`030000000c<c<0<c<c00<0<c<c00<0000003<c<`0c<c<0
0`0c<c<00`000000<c<c03<c<`0303<c<`030000000c<c<0<c<c00<0<c<c00@0000003<c<`0c<c<0
<c<c2`00000303<c?P8000000P0c<ch900000080oooo00<000000?ooo`3oool01P3oool00`000000
oooo0000000:0?ooo`030000003oool0oooo00P0oooo0P0000060?ooo`050000003oool0oooo0?oo
o`000000=P3oool001`0oooo00<000000?ooo`3oool06P3oool00`000000oooo0?ooo`030?ooo`03
0000003oool0oooo0080oooo0P0000090?ooo`800000203oool8000000<0<c<c2P00000303<c<`03
0000000c<c<0<c<c00<0<c<c00<0000003<c<`0c<c<00`0c<c<00`000000<c<c03<c<`0303<c<`03
0000000c<c<0<c<c00<0<c<c00<0000003<c<`0c<c<00`0c<c<00`000000<c<c03<c<`0303<c<`d0
00001@0c<ch2000000@0<c<n0P00000203<c?P@00000103oool010000000oooo0?ooo`0000080?oo
o`030000003oool0000000X0oooo00<000000?ooo`3oool0203oool2000000H0oooo00<000000?oo
o`3oool00P3oool00`000000oooo0?ooo`0c0?ooo`006`3oool00`000000oooo0?ooo`0K0?ooo`03
0000003oool0oooo00@0oooo00@000000?ooo`3oool0oooo0P0000090?ooo`X0000000<0oooo0000
000000002000000203<c<`030000000c<c<0<c<c0080<c<c00<0000003<c<`0c<c<00`0c<c<00`00
0000<c<c03<c<`0303<c<`030000000c<c<0<c<c00<0<c<c00<0000003<c<`0c<c<00`0c<c<00`00
0000<c<c03<c<`0303<c<`030000000c<c<0<c<c00X000001@0c<ch00`000000<c<n0000000203<c
?P8000001@0c<ch00`000000<c<n03<c?P0303<c?P8000000P0c<ch010000000<c<n000000000004
0?ooo`050000003oool0oooo0?ooo`0000001`3oool00`000000oooo0000000:0?ooo`030000003o
ool0oooo00P0oooo0P0000000`3oool0000000000009000003D0oooo000K0?ooo`030000003oool0
oooo01/0oooo00<000000?ooo`3oool0103oool010000000oooo0?ooo`3oool<000000030?ooo`00
0000oooo0080oooo2P0000000`3oool0000003<c<`0303<c<`030000000c<c<0<c<c00<0<c<c00<0
000003<c<`0c<c<00`0c<c<00`000000<c<c03<c<`0303<c<`030000000c<c<0<c<c00<0<c<c00<0
000003<c<`0c<c<00P0c<c<:000000<0<c<n00<0000003<c?P0c<ch00`0c<ch00`000000<c<n03<c
?P0303<c?P8000000`0c<ch2000000@0<c<n0`00000403<c?P8000000P0c<ch4000000@0oooo00D0
00000?ooo`3oool0oooo000000070?ooo`040000003oool0oooo000000T0oooo3P0000050?ooo`03
0000003oool0oooo0080oooo00<000000?ooo`3oool0<`3oool001/0oooo00<000000?ooo`3oool0
6P3oool00`000000oooo0?ooo`0:000000030?ooo`000000oooo00<0oooo2P0000050?ooo`H00000
1@0c<c<00`000000<c<c03<c<`0303<c<`030000000c<c<0<c<c00<0<c<c00<0000003<c<`0c<c<0
0`0c<c<;0000000303<c?P000000<c<n00@0<c<n00<0000003<c?P0c<ch00`0c<ch00`000000<c<n
03<c?P0303<c?P030000000c<ch0<c<n0080<c<n0P00000403<c?P8000000`0c<ch010000000<c<n
00000000000303<c?P<000000P0c<ch4000000@0oooo00D000000?ooo`3oool0oooo000000080?oo
o`030000003oool0000000l000001P3oool2000000D0oooo00<000000?ooo`3oool00P3oool00`00
0000oooo0?ooo`0c0?ooo`006`3oool00`000000oooo0?ooo`0J0?ooo`<000001P3oool00`000000
oooo000000030?ooo`@00000103oool00`000000oooo000000080?ooo`030000003oool0000000@0
0000100c<c<00`000000<c<c03<c<`0303<c<`030000000c<c<0<c<c00X000001@0c<ch00`000000
<c<n03<c?P0303<c?P030000000c<ch0<c<n00<0<c<n00<0000003<c?P0c<ch00`0c<ch00`000000
<c<n03<c?P0303<c?P030000000c<ch0<c<n0080000000<0<c<n0000000c<ch00`0c<ch200000080
<c<n00<0000003<c?P0c<ch03P0000040?ooo`060000003oool0oooo0?ooo`000000oooo3`000004
0?ooo`8000002P3oool2000000D0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`0c
0?ooo`006`3oool00`000000oooo0?ooo`0J0?ooo`030000003oool0oooo00L0oooo0P0000030?oo
o`030000003oool0oooo00@0oooo00D000000?ooo`3oool0oooo000000070?ooo`030000003oool0
000000<0000000<0<c<c0000000000002`00000303<c?P030000000c<ch0<c<n00<0<c<n00<00000
03<c?P0c<ch00`0c<ch00`000000<c<n03<c?P0303<c?P030000000c<ch0<c<n00<0<c<n00<00000
03<c?P0c<ch00`0c<ch00`000000<c<n03<c?P0303<c?P@000000P0c<ch00`000000<c<n03<c?P0;
00000080<c=D00L0000003<cE0000000000003<cE0000000<c=D014000000`3oool00`000000oooo
000000090?ooo`8000002P3oool2000000D0oooo00<000000?ooo`3oool00P3oool00`000000oooo
0?ooo`0c0?ooo`006`3oool00`000000oooo0?ooo`0J0?ooo`030000003oool0oooo00L0oooo0P00
00030?ooo`030000003oool0oooo00@0oooo00D000000?ooo`3oool0oooo000000070?ooo`030000
003oool0000000T000001@0c<ch00`000000<c<n03<c?P0303<c?P030000000c<ch0<c<n00<0<c<n
00<0000003<c?P0c<ch00`0c<ch00`000000<c<n03<c?P0303<c?P030000000c<ch0<c<n00<0<c<n
00<0000003<c?P0c<ch00`0c<ch010000000<c<n03<c?P0c<ch;000000<0<c=D0P00000403<cE004
0000000c<e@0000003<cE0l000000`3oool00`000000oooo0?ooo`060?ooo`030000003oool00000
00T0oooo0P00000:0?ooo`8000001@3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo
03<0oooo000K0?ooo`030000003oool0oooo01X0oooo00<000000?ooo`3oool0203oool00`000000
oooo0?ooo`020?ooo`030000003oool0oooo00<0oooo00@000000?ooo`3oool0oooo2P000000103o
ool0000000000000000203<c?P040000000c<ch0<c<n000000D0<c<n00<0000003<c?P0c<ch00`0c
<ch00`000000<c<n03<c?P0303<c?P030000000c<ch0<c<n00<0<c<n00<0000003<c?P0c<ch00`0c
<ch00`000000<c<n03<c?P0303<c?P/0000000D0<c=D0000000c<e@0<c=D0000000203<cE0030000
000c<e@0<c=D0080<c=D3@00000203<cE080000000<0<c=D0000001D<c<00P0000030?ooo`050000
003oool0oooo0?ooo`000000203oool00`000000oooo000000090?ooo`8000002P3oool2000000D0
oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`0c0?ooo`006P3oool00`000000oooo
0?ooo`0J0?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool00P3oool:000000030?oo
o`000000000000/000000`0c<ch00`000000<c<n00000002000000<0<c<n00<0000003<c?P0c<ch0
0`0c<ch00`000000<c<n03<c?P0303<c?P030000000c<ch0<c<n00<0<c<n00<0000003<c?P000000
2P00000503<cE0<000000`0c<e@00`000000<c=D0000000:000000@0<c=D00@0000003<cE00c<e@0
00000P0c<e@010000000<c=D03<cE000000203<cE0@00000103oool010000000oooo0?ooo`000008
0?ooo`030000003oool0000000T0oooo0P00000:0?ooo`8000001@3oool00`000000oooo0?ooo`02
0?ooo`030000003oool0oooo03<0oooo000J0?ooo`030000003oool0oooo01X0oooo00<000000?oo
o`3oool00`3oool<000000030?ooo`000000000000P000001P3oool00`000000oooo0?ooo`040000
0080<c<n00<0000003<c?P0000000P0c<ch4000000D0<c<n00<0000003<c?P0c<ch02`00000403<c
E0030000000c<e@0<c=D00<0<c=D00<0000003<cE00c<e@02`00000203<cE08000000`0c<e@30000
000303<cE0000000<c=D0080<c=D00@0000003<cE000000000000P0c<e@010000000<c=D03<cE000
000203<cE0@00000103oool010000000oooo0?ooo`0000080?ooo`030000003oool0000000X0oooo
00<000000?ooo`3oool0203oool2000000D0oooo00<000000?ooo`3oool00P3oool00`000000oooo
0?ooo`0c0?ooo`006P3oool00`000000oooo0?ooo`0J0?ooo`H000001@3oool00`000000oooo0000
00040?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool00P3oool00`000000oooo0?oo
o`040?ooo`040000003oool0oooo0?ooo`D0000000<0<c<n000000000000100c<ch:000000<0<c=D
00<0000003<cE00c<e@00`0c<e@00`000000<c=D03<cE00303<cE0X000000P0c<e@00`000000<c=D
03<cE00303<cE0040000000c<e@0<c=D03<cE08000000P0c<e@01P000000<c=D03<cE0000000<c=D
000000<0<c=D0P0000000`0c<e@0000003<cE00<000000<0oooo00D000000?ooo`3oool0oooo0000
00070?ooo`030000003oool0000000X0oooo3@0000050?ooo`030000003oool0oooo0080oooo00<0
00000?ooo`3oool0<`3oool001X0oooo00<000000?ooo`3oool06P3oool00`000000oooo0?ooo`08
0?ooo`040000003oool0oooo000000<0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?oo
o`020?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool00P3oool>00000080<c=D1000
000503<cE1<000001@0c<e@00`000000<c=D03<cE00203<cE0030000000c<e@0<c=D0080<c=D1000
000303<cE0/0000000<0<c=Z0000000c<fX00P0000000`0c<fX0000000000004000000<0oooo00D0
00000?ooo`3oool0oooo000000070?ooo`030000003oool00000018000000`3oool2000000D0oooo
00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`0c0?ooo`006P3oool00`000000oooo0?oo
o`0J0?ooo`030000003oool0oooo00P0oooo00@000000?ooo`3oool000000`3oool00`000000oooo
0?ooo`020?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool00P3oool00`000000oooo
0?ooo`020?ooo`@000000P0c<e@2000000@0<c=D0P00000203<cE1H0000000<0<c=D0000000c<e@0
0P0c<e@00`000000<c=D03<cE00303<cE0030000000c<e@0<c=D0080<c=D00<0000003<cE0000000
2P000000100c<fX0000003<cJP0c<fX2000000<0<c=Z0P000000100c<fX0000003<cJP0c<fX70000
00<0oooo00@000000?ooo`3oool0oooo4`0000020?ooo`030000003oool0oooo00P0oooo0P000005
0?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool0<`3oool001X0oooo00<000000?oo
o`3oool06P3oool00`000000oooo0?ooo`080?ooo`050000003oool0oooo0?ooo`0000000`3oool0
1@000000oooo0?ooo`3oool0000000D0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?oo
o`020?ooo`@0000000<0<c=D0000000000002@00000303<cE0800000100c<e@01`000000<c=D03<c
E00c<e@0000003<cE00000001@0c<e@010000000<c=D03<cE000000203<cE0030000000c<e@0<c=D
00X000000P0c<fX3000000D0<c=Z00D0000003<cJP0c<fX0000003<cJP02000000<0<c=Z0`000003
03<cJP<0000000<0E3<c0000000000004@0000020?ooo`030000003oool0oooo00L0oooo0P000009
0?ooo`030000003oool0000000@0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`0c
0?ooo`006@3oool00`000000oooo0?ooo`0K0?ooo`030000003oool0oooo00P0oooo00D000000?oo
o`3oool0oooo000000030?ooo`050000003oool0oooo0?ooo`0000001@3oool010000000oooo0?oo
o`3oool;00000080<c=D0`00000303<cE08000001@0c<e@2000000<0<c=D00<0000003<cE00c<e@0
0P0c<e@2000000<0<c=D2`00000303<cJP8000000`0c<fX010000000<c=Z00000000000203<cJP03
0000000c<fX0<c=Z00<0<c=Z00<0000003<cJP0c<fX00`00000403<cJP<000000`0c<fX;000000<0
oooo00<000000?ooo`3oool01@3oool010000000oooo0?ooo`0000090?ooo`8000002P3oool20000
00@0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`0c0?ooo`006@3oool00`000000
oooo0?ooo`0K0?ooo`030000003oool0oooo00P0oooo00<000000?ooo`3oool00P3oool010000000
oooo0?ooo`0000020?ooo`l000000`3oool20000000303<cE0000000<c=D0080<c=D00D0000003<c
E0000000000003<cE002000000D0<c=D0P00000303<cE0X000000P0c<fX010000000<c=Z03<cJP00
000203<cJP030000000c<fX0<c=Z00<0<c=Z0P00000203<cJP<00000100c<fX00`000000<c=Z03<c
JP0303<cJP060000000c<fX000000000000c<fX00000100c<fX2000000@0<c=Z00D0000006Xc<`00
0000000005@c<`02000000<0oooo00D000000?ooo`3oool0oooo000000080?ooo`030000003oool0
000000T0oooo0P00000:0?ooo`800000103oool00`000000oooo0?ooo`020?ooo`030000003oool0
oooo03<0oooo000I0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool0203oool?0000
00@0oooo00D000000?ooo`3oool0oooo000000050?ooo`D000000P0c<e@010000000<c=D03<cE00c
<e@=0000000303<cJP000000<c=Z00<0<c=Z0P00000403<cJP040000000c<fX0<c=Z00000080<c=Z
00<0000003<cJP0c<fX00`0c<fX01P000000<c=Z000000000000<c=Z000000D0<c=Z00<0000003<c
JP0c<fX00P0c<fX01`000000<c=Z0000000c<fX0000003<cJP000000100c<fX2000000@0<c=Z0P00
00000`1Z<c<000000000000300000080oooo00D000000?ooo`3oool0oooo000000080?ooo`030000
003oool0000000T0oooo0P00000:0?ooo`8000001@3oool01@000000oooo0?ooo`3oool0000003D0
oooo000I0?ooo`030000003oool0oooo01/0oooo3@0000030?ooo`040000003oool0oooo000000<0
oooo00<000000?ooo`3oool0103oool01@000000oooo0?ooo`3oool0000000D0oooo00<000000?oo
o`0000003@00000303<cJP030000000c<fX0000000<0<c=Z00<0000003<cJP0c<fX00P0c<fX20000
00@0<c=Z00L0000003<cJP0c<fX0<c=Z0000000c<fX0000000@0<c=Z1000000203<cJP030000000c
<fX0<c=Z00<0<c=Z0P00000303<cJP8000000P0c<fX00`000000<c=Z0000000203<cJPX0000000<0
JS<c0000000000000`0000020?ooo`050000003oool0oooo0?ooo`000000203oool00`000000oooo
000000090?ooo`8000001`3oool5000000D0oooo00D000000?ooo`3oool0oooo0000000e0?ooo`00
6@3oool00`000000oooo0?ooo`0D0?ooo`X00000203oool00`000000oooo0?ooo`030?ooo`040000
003oool0oooo00000080oooo00<000000?ooo`3oool0103oool01@000000oooo0?ooo`3oool00000
00D0oooo00<000000?ooo`0000000P000000100c<fX0000003<cJP00000503<cJP030000000c<fX0
000000<0000000<0<c=Z0000000c<fX00P0c<fX00`000000<c=Z03<cJP0203<cJP800000100c<fX0
1P000000<c=Z03<cJP0c<fX0000003<cJPD0000000@0<c=Z0000000c<fX000000P0c<fX00`000000
<c=Z03<cJP0303<cJP80000000<0<c=Z0000000000002P0000000`0c<gh000000000000303<cOP<0
000000<0JS<c0000000000000`0000020?ooo`050000003oool0oooo0?ooo`000000203oool00`00
0000oooo000000080?ooo`X000000`3oool2000000D0oooo00D000000?ooo`3oool0oooo0000000e
0?ooo`006@3oool00`000000oooo0?ooo`090?ooo`/000001`3oool00`000000oooo0?ooo`080?oo
o`030000003oool0oooo00<0oooo00@000000?ooo`3oool000000P3oool00`000000oooo0?ooo`04
0?ooo`050000003oool0oooo0?ooo`0000001@3oool00`000000oooo0000000200000080<c=Z0P00
000503<cJP030000000c<fX0<c=Z00<0<c=Z1P00000503<cJP030000000c<fX0<c=Z0080<c=Z1`00
000503<cJP040000000c<fX0000003<cJP/0000000<0<c=n0000000c<gh00`0c<gh020000000<c=n
03<cOP000000<c=n0000000c<gh000000`0c<gh900000080oooo00D000000?ooo`3oool0oooo0000
00080?ooo`/0000000<0oooo000000000000203oool4000000D0oooo00D000000?ooo`3oool0oooo
0000000e0?ooo`006@3oool00`000000oooo0000000900000180oooo00<000000?ooo`3oool0203o
ool00`000000oooo0?ooo`040?ooo`030000003oool000000080oooo00<000000?ooo`3oool0103o
ool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00<0oooo00<000000?ooo`0000000P00
000203<cJP800000100c<fX00`000000<c=Z03<cJP0303<cJP030000000c<fX0000000<0<c=Z2P00
00000`0c<fX0000003<cJP0203<cJP/0000000<0<c=n0000000c<gh00`0c<gh010000000<c=n0000
0000000203<cOP030000000c<gh0<c=n0080<c=n00<0000003<cOP0000000P0c<gh02`000000<c=n
03<cOP000000<c=n0000001n<c<0000006Xc<`000000JS<c00@000000P3oool>000000030?ooo`00
0000oooo00L0oooo2`0000020?ooo`8000001@3oool01@000000oooo0?ooo`3oool0000003D0oooo
000I0?ooo`800000703oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo00@0oooo00<0
00000?ooo`0000000P3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo0080oooo00<0
00000?ooo`3oool00P3oool6000000<0<c=Z0`00000303<cJP030000000c<fX0<c=Z0080<c=Z00<0
000003<cJP0000000`0c<fX010000000<c=Z03<cJP0c<fX=000000D0<c=n00H0000003<cOP0c<gh0
000003<cOP00000403<cOP80000000D0<c=n0000000c<gh0<c=n0000000403<cOP8000000`0c<gh0
0`000000<c=n03<cOP030000000307hc<`000000JS<c00X000000`3oool00`000000oooo0?ooo`05
0?ooo`/000000P3oool00`000000oooo0?ooo`080?ooo`8000001@3oool01@000000oooo0?ooo`3o
ool0000003D0oooo000I0?ooo`030000003oool0oooo01/0oooo00<000000?ooo`3oool0203oool0
0`000000oooo0?ooo`050?ooo`8000000P3oool00`000000oooo0?ooo`040?ooo`l0000000D0<c=Z
0000000c<fX0<c=Z0000000203<cJP040000000c<fX0<c=Z000000@0<c=Z2P00000203<cOP030000
000c<gh0<c=n0080<c=n00@0000003<cOP0c<gh0<c=n0P00000503<cOP070000000c<gh0<c=n0000
000c<gh0000003<cOP0400000080<c=n00<0000003<cOP000000100c<gh300000080<c=n00@00000
03<cOP0c<gh0<c=n100000000`1n<c<00000000000020000000405@c<`000000000000000080oooo
3@0000020?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool0203oool2000000D0oooo
00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`0b0?ooo`006P3oool00`000000oooo0?oo
o`0J0?ooo`030000003oool0oooo00P0oooo00<000000?ooo`3oool01@3oool00`000000oooo0000
000?000000@0oooo00D000000?ooo`3oool0000003<cJP020000000303<cJP000000000000T00000
00@0<c=n0000000c<gh000000P0c<gh00`000000<c=n03<cOP0303<cOP030000000c<gh0<c=n0080
<c=n00<0000003<cOP0c<gh00P0c<gh00`000000<c=n03<cOP0303<cOP040000000c<gh0<c=n03<c
OP<000000`0c<gh01P000000<c=n03<cOP000000<c=n000000@0<c=n00<0000003<cOP0000000P0c
<gh010000000<c=n03<cOP0c<gh40000000307hc<`000000000000T000000`3oool00`000000oooo
0?ooo`050?ooo`040000003oool0oooo000000T0oooo00<000000?ooo`3oool0203oool00`000000
oooo000000040?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool0<P3oool001X0oooo
00<000000?ooo`3oool06P3oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo0080oooo
2P0000050?ooo`050000003oool0oooo0?ooo`0000001@3oool00`000000oooo0?ooo`0500000003
03<cOP000000<c=n00<0<c=n0`00000303<cOP030000000c<gh0000000<0<c=n00<0000003<cOP0c
<gh00P0c<gh00`000000<c=n03<cOP0203<cOP030000000c<gh0<c=n0080<c=n0P00000403<cOP03
0000000c<gh0000000<00000100c<gh01P000000<c=n03<cOP000000<c=n00000080<c=n0`000000
0`0c<gh0000003<cOP0<0000000306Xc<`000000000000<000000P3oool01@000000oooo0?ooo`3o
ool0000000L0oooo00@000000?ooo`3oool000002@3oool2000000T0oooo00<000000?ooo`000000
103oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo0380oooo000K0?ooo`030000003o
ool0oooo01T0oooo00<000000?ooo`3oool00P3oool;000000@0oooo0P0000000`3oool000000?oo
o`060?ooo`050000003oool0oooo0?ooo`0000001@3oool02`000000oooo0?ooo`3oool0000003<c
OP000000<c=n0000000c<gh0000000@0<c=n00<0000003<cOP0000000P000000100c<gh0000003<c
OP00000203<cOP030000000c<gh0<c=n0080<c=n0P00000303<cOP030000000c<gh0<c=n0080<c=n
0P00000203<cOP@000000P0c<gh2000000@0<c=n00<0000003<cOP0c<gh03000000203<cT0030000
000c<i00000000H0000000<0JS<c0000000000000`0000020?ooo`050000003oool0oooo0?ooo`00
00001`3oool010000000oooo0?ooo`0000090?ooo`8000001@3oool7000000@0oooo00<000000?oo
o`3oool00P3oool00`000000oooo0?ooo`0b0?ooo`00703oool00`000000oooo0?ooo`0H0?ooo`D0
00001P3oool00`000000oooo0?ooo`070?ooo`030000003oool0000000L0oooo00D000000?ooo`3o
ool0oooo000000050?ooo`040000003oool0oooo0?ooo`<000000P0c<gh2000000D0<c=n00@00000
03<cOP0c<gh0<c=n1000000203<cOP030000000c<gh0<c=n00<0<c=n00<0000003<cOP0c<gh00P0c
<gh010000000<c=n03<cOP0c<gh400000080<c=n00<0000003<cOP0000002P000000100c<i000000
03<cT000000203<cT0040000000c<i00<c>@03<cT080000000@0<c>@0000000c<i00<c>@10000000
1@1n<c<0000006Xc<`000000JS<c00@000000P3oool01@000000oooo0?ooo`3oool0000000P0oooo
00<000000?ooo`0000001@3oool;000000D0oooo0P0000040?ooo`030000003oool0oooo0080oooo
00<000000?ooo`3oool0<P3oool001`0oooo00<000000?ooo`3oool0603oool00`000000oooo0?oo
o`080?ooo`030000003oool0oooo00L0oooo00<000000?ooo`0000001`3oool01@000000oooo0?oo
o`3oool0000000H0oooo00@000000?ooo`3oool0oooo0`00000203<cOP800000100c<gh00`000000
<c=n03<cOP0203<cOP030000000c<gh0000001T000000`0c<i001@000000<c>@03<cT00c<i000000
00@0<c>@0P00000303<cT0070000000c<i00<c>@03<cT0000000<c>@0000000203<cT0060000002@
<c<0000007hc<`000000OS<c0`0000000`1Z<c<0000000000003000000030?ooo`000000oooo0080
oooo00<000000?ooo`3oool00`3oool;000000@0oooo0P00000:0?ooo`800000103oool00`000000
oooo0?ooo`020?ooo`030000003oool0oooo0380oooo000M0?ooo`030000003oool0oooo01L0oooo
00<000000?ooo`3oool0203oool00`000000oooo0?ooo`070?ooo`<000001`3oool01@000000oooo
0?ooo`3oool0000000H0oooo00@000000?ooo`3oool0oooo0`00000303<cOP8000000`0c<gh20000
00@0<c=n00<0000003<cOP0000000P0c<gh;000000@0<c>@00<0000003<cT00c<i000P0c<i000`00
0000<c>@03<cT00203<cT0050000000c<i00<c>@03<cT00000000P0c<i03000000@0<c>@00@00000
03<cT00c<i00<c>@0P00000303<cT0030000002@<c<0000000<0000000<0OS<c0000001Z<c<04@00
00030?ooo`030000003oool0000000T0oooo0P0000080?ooo`@00000103oool00`000000oooo0?oo
o`020?ooo`030000003oool0oooo0380oooo000M0?ooo`030000003oool0oooo01L0oooo00<00000
0?ooo`3oool0203oool00`000000oooo0?ooo`070?ooo`<00000203oool00`000000oooo0?ooo`0?
00000080<c=n100000000`0c<gh000000000000:000000@0<c>@0P00000303<cT0030000000c<i00
<c>@0080<c>@00<0000003<cT00c<i000P0c<i0010000000<c>@03<cT00c<i02000000<0<c>@0`00
000203<cT08000000P0c<i000`000000<c>@03<cT00203<cT0080000000c<i00<c>@03<cT0000000
T3<c0000002@<c<30000000307hc<`000000JS<c00H0000000<0oooo0000003oool00P3oool00`00
0000oooo0?ooo`060?ooo`030000003oool0000000L0oooo300000020?ooo`L00000103oool00`00
0000oooo0?ooo`0b0?ooo`007P3oool00`000000oooo0?ooo`0F0?ooo`030000003oool0oooo00T0
oooo00<000000?ooo`3oool01P3oool010000000oooo0000003oool;000000H0oooo00@000000?oo
o`3oool0oooo3P00000403<cT08000000`0c<i000`000000<c>@03<cT00203<cT0050000000c<i00
<c>@03<cT0000000100c<i02000000<0<c>@00H0000003<cT00c<i00<c>@0000000c<i04000000<0
<c>@00<0000003<cT00000000P0c<i000`000000<c>@03<cT00300000080<c>@00@00000090c<`00
0000T3<c0`00000207hc<`80000000<0JS<c0000000000000`0000000`3oool000000?ooo`020?oo
o`030000003oool0oooo00D0oooo2`0000030?ooo`d00000103oool00`000000oooo0?ooo`020?oo
o`030000003oool0oooo0380oooo000O0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3o
ool02@3oool00`000000oooo0?ooo`070?ooo`<000001`3oool00`000000oooo0?ooo`0;00000007
0?ooo`00000000000000000c<i00000003<cT002000000<0<c>@0P00000403<cT0030000000c<i00
00000080<c>@00<0000003<cT00c<i000P0c<i02000000<0<c>@00@0000003<cT00c<i00<c>@0P00
000303<cT0040000000c<i00<c>@03<cT0<000000P0c<i002@000000<c>@03<cT00c<i00000003<c
T0000000<c>@0000000203<cT0030000000c<i00000000@0000000<0T3<c0000002@<c<00`000000
1@1n<c<00000000000000000JS<c0080000000<0E3<c0000000000000P3oool;000000030?ooo`00
0000oooo00`000002P3oool2000000@0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?oo
o`0b0?ooo`007`3oool00`000000oooo0?ooo`0E0?ooo`030000003oool0oooo00T0oooo00<00000
0?ooo`3oool01`3oool>000000H0oooo00<000000?ooo`3oool00P3oool40000000503<cT0000000
000003<cT00000000`0c<i050000000303<cT000000000000080<c>@00<0000003<cT00c<i000P0c
<i02000000<0<c>@00@0000003<cT00c<i00<c>@0P00000303<cT0D0000000H0<c>@0000000c<i00
<c>@0000000c<i0;00000080@d2P100000000`2@<c<00000090c<`0?000000<0oooo2`00000:0?oo
o`030000003oool0oooo00P0oooo0P0000050?ooo`050000003oool0oooo0?ooo`000000=03oool0
0200oooo00<000000?ooo`3oool0503oool00`000000oooo0?ooo`090?ooo`030000003oool00000
00X000001`3oool010000000oooo0?ooo`0000060?ooo`030000003oool0oooo0080oooo1@000000
1@0c<i0000000000000c<i0000000080<c>@0P00000303<cT0@000000P0c<i0010000000<c>@03<c
T00c<i02000000<0<c>@00H0000003<cT00c<i00<c>@0000000c<i0>00000080@d2P00<0000004=0
X013@:000`00000204=0X00300000013@:00@d2P00X0000000D0OS<c000000000000000006Xc<`0;
000000L0oooo00<000000?ooo`0000002P3oool00`000000oooo0000000:000000D0oooo00D00000
0?ooo`3oool0oooo0000000d0?ooo`008@3oool00`000000oooo0?ooo`0C0?ooo`030000003oool0
oooo00/00000203oool010000000oooo0000000000060?ooo`050000003oool0oooo0?ooo`000000
1@3oool00`000000oooo0?ooo`020?ooo`030000003oool0000000<0000000@0<c>@0000000c<i00
00000`0c<i02000000@0<c>@5`00000304=0X00300000013@:00@d2P008000000`13@:000`000000
@d2P04=0X002000000<0@d2P00H0000004=0X013@:00@d2P0000002P@4<300000007090c<`000000
T3<c0000001n<c<0000007hc<`08000000030?ooo`000000oooo0080oooo00<000000?ooo`3oool0
1@3oool00`000000oooo0?ooo`0<000000T0oooo0P0000050?ooo`050000003oool0oooo0?ooo`00
0000=03oool00240oooo00<000000?ooo`3oool04`3oool3000000T0oooo00<000000?ooo`3oool0
1`3oool010000000oooo0000000000060?ooo`050000003oool0oooo0?ooo`0000001@3oool00`00
0000oooo0?ooo`030?ooo`D000000P0c<i0300000080<c>@00<0000003<cT00000000P0c<i0<0000
0080@d2P00<0000004=0X013@:000P13@:0200000080@d2P00D0000004=0X013@:00@d2P00000002
04=0X08000000`13@:030000000304=0X0000000@d2P0080@d2P00P0000004=0X013@:0000000:10
@`000000X41300000080T3<c00<00000090c<`0000000P0000001@1n<c<0000006Xc<`000000JS<c
00@0000000<0oooo0000003oool00P3oool<000000T0oooo0P00000:0?ooo`800000103oool01@00
0000oooo0?ooo`3oool0000003@0oooo000R0?ooo`030000003oool0oooo0180oooo00<000000?oo
o`3oool02@3oool00`000000oooo0?ooo`070?ooo`050000003oool000000?ooo`0000001@3oool0
1@000000oooo0?ooo`3oool0000000D0oooo5`00000204=0X08000000P13@:0010000000@d2P04=0
X013@:02000000<0@d2P00T0000004=0X013@:00@d2P00000013@:00000004=0X00000000`13@:00
0`000000@d2P04=0X00200000080@d2P0P00000204=0X00500000013@:00000004=0X00000000`13
@:0020000000X4130000002P@4<00000090c<`000000T3<c0`0000001@1n<c<00000000000000000
JS<c00/00000203oool00`000000oooo000000090?ooo`8000002P3oool2000000@0oooo00D00000
0?ooo`3oool0oooo0000000d0?ooo`008P3oool00`000000oooo0?ooo`0C0?ooo`030000003oool0
oooo00P0oooo00<000000?ooo`3oool01`3oool01@000000oooo0000003oool0000000D0oooo2`00
00050?ooo`030000003oool0000000D000000`13@:030000000304=0X0000000@d2P0080@d2P0P00
000304=0X00400000013@:00@d2P04=0X08000000P13@:002@000000@d2P04=0X013@:00000004=0
X0000000@d2P0000000304=0X00400000013@:00@d2P04=0X0@000000`13@:001@000000@d2P0000
0013@:0000000080@d2P00@000000:10@`000000X4130`0000000`2@<c<00000090c<`0200000005
07hc<`000000OS<c0000001Z<c<00P0000001@1D<c<000000000003oool0000000<0oooo00<00000
0?ooo`3oool01P3oool00`000000oooo000000090?ooo`80000000<0oooo0000000000002@000004
0?ooo`050000003oool0oooo0?ooo`000000=03oool002<0oooo00<000000?ooo`3oool04P3oool0
0`000000oooo0?ooo`080?ooo`030000003oool0oooo00L0oooo2`0000030?ooo`030000003oool0
oooo00<0oooo00<000000?ooo`3oool00`3oool00`000000oooo0000000600000080@d2P00<00000
04=0X00000000`00000304=0X00500000013@:00@d2P04=0X00000000`13@:0200000080@d2P00T0
000004=0X013@:00@d2P00000013@:00000004=0X00000000`13@:000`000000@d2P000000020000
0080@d2P00H0000004=0X013@:00@d2P00000013@:07000000030:10@`000000X4130080000000<0
T3<c0000002@<c<00`00000207hc<`80000000<0JS<c0000001D<c<0100000030?ooo`030000003o
ool0oooo00H0oooo00@000000?ooo`000000oooo2`0000090?ooo`800000103oool01@000000oooo
0?ooo`3oool0000003@0oooo000T0?ooo`030000003oool0oooo0140oooo00<000000?ooo`3oool0
203oool00`000000oooo0?ooo`070?ooo`030000003oool000000080oooo00<000000?ooo`3oool0
0P3oool01@000000oooo0?ooo`3oool0000000D0oooo00<000000?ooo`0000003000000304=0X004
00000013@:00000004=0X0<000000P13@:001@000000@d2P04=0X013@:00000000<0@d2P00@00000
04=0X013@:0000000`13@:000`000000@d2P04=0X0020000000304=0X0000000000000l000000P1R
FJd3000000030:10@`000000X41300<0000000<0T3<c0000002@<c<00P0000001@1n<c<000000000
00000000JS<c00H000000`3oool=000000P0oooo0P00000:0?ooo`800000103oool01@000000oooo
0?ooo`3oool0000003@0oooo000T0?ooo`030000003oool0oooo0140oooo00<000000?ooo`3oool0
2@3oool00`000000oooo0?ooo`060?ooo`030000003oool000000080oooo00<000000?ooo`3oool0
0P3oool<000000<0oooo1`000000102@fOl0000000000000000304=0X08000000P13@:000`000000
@d2P000000040000000304=0X0000000@d2P0080@d2P0P00000204=0X0d0000000D0HUV]00000000
0000HUV]00000003069I[@030000001RFJd0HUV]00H0000000H0X4130000002P@4<000000:10@`00
0002090c<`060000002@<c<0000007hc<`000000OS<c3@0000080?ooo`030000003oool0000000T0
oooo0P0000020?ooo`X00000103oool01@000000oooo0?ooo`3oool0000003@0oooo000U0?ooo`03
0000003oool0oooo0100oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`060?ooo`/0
00000`3oool;000000040?ooo`000000oooo0?ooo`D0000000<0X=Wo0000000000000`13@:001@00
0000@d2P04=0X013@:0000000080@d2P4@0000000`1RFJd0000000000002069I[@060000001RFJd0
HUV]069I[@000000HUV]0P000002069I[@030000001RFJd0HUV]00@0000000H0[EUR000000000000
00000:10@`0000020:10@``0000000<0JS<c0000000000000P0000001@3oool000000?ooo`3oool0
000000P0oooo00@000000?ooo`000000oooo300000080?ooo`8000001@3oool010000000oooo0?oo
o`00000d0?ooo`009@3oool00`000000oooo0?ooo`0@0?ooo`030000003oool0oooo00L0oooo3000
00020?ooo`030000003oool0oooo00P0000000<0oooo0000003oool0103oool00`000000oooo0?oo
o`030?ooo`030000003oool0oooo00D0000000<0X=Wo00000000000030000002069I[@050000001R
FJd0HUV]069I[@0000000P1RFJd01P000000HUV]069I[@1RFJd00000069I[@8000000P1RFJd01000
0000HUV]069I[@000002069I[@8000000P1RFJd400000080HUV]2`0000000`2@<c<00000090c<`02
0000000507hc<`000000OS<c0000001Z<c<01@0000001P3oool000000?ooo`3oool000000?ooo`/0
00002@3oool00`000000oooo0?ooo`080?ooo`8000001@3oool010000000oooo0?ooo`00000d0?oo
o`009P3oool00`000000oooo0?ooo`0?0?ooo`X000000P3oool00`000000oooo0?ooo`060?ooo`04
0000003oool0oooo00000080oooo00D000000?ooo`3oool0oooo000000040?ooo`030000003oool0
oooo00<0oooo00<000000?ooo`3oool00P3oool=00000080HUV]0P000003069I[@040000001RFJd0
0000000000<0HUV]00<00000069I[@1RFJd00P000002069I[@040000001RFJd0HUV]00000080HUV]
00@00000069I[@1RFJd000000P1RFJd010000000HUV]069I[@000002069I[@80000000H0HUV]0000
001RFJd0HUV]0000002]FF82000000040:eIHP00000000000:10@`@0000000<0T3<c0000002@<c<0
0P0000000`1n<c<0000007hc<`0=000000L0oooo00<000000?ooo`0000002P3oool00`000000oooo
0?ooo`080?ooo`8000001@3oool010000000oooo0?ooo`00000d0?ooo`009`3oool00`000000oooo
0?ooo`0>0?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool01P3oool010000000oooo
0?ooo`0000020?ooo`050000003oool0oooo0?ooo`0000000`3oool<000000030?ooo`000000oooo
0080oooo1@0000000`2PfOl000000000000300000003069I[@000000HUV]0080HUV]00@00000069I
[@00000000000P1RFJd01@000000HUV]069I[@1RFJd000000080HUV]00@00000069I[@1RFJd00000
0P1RFJd010000000HUV]069I[@000002069I[@030000001RFJd0HUV]00@000000100HUV]0000001R
FJd0HUV]0000002]FF8000000:eIHP000000[EUR0000002P@4<000000:10@`000000X4130P000000
0`2@<c<00000090c<`020000000707hc<`00000000000000001Z<c<0000005@c<`02000000050?oo
o`000000oooo0?ooo`000000203oool00`000000oooo0000000:0?ooo`030000003oool0oooo00D0
oooo1@0000050?ooo`040000003oool0oooo000003@0oooo000W0?ooo`030000003oool0oooo00l0
oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00/0
000000<0oooo0000003oool0103oool00`000000oooo0?ooo`030?ooo`040000003oool0oooo0?oo
o`<0000000@0T=Wo000000000000X=Wo0P0000000`2]f_l000000000000300000006069I[@000000
HUV]0000001RFJd000000P1RFJd010000000HUV]069I[@000002069I[@040000001RFJd0HUV]0000
0080HUV]00@00000069I[@1RFJd000000P1RFJd=000000030:eIHP000000[EUR00<0000000L0X413
0000002P@4<0X4130000002@<c<000000080T3<c00<0000007hc<`1n<c<00`0000000`1Z<c<00000
00000002000000050?ooo`000000oooo0?ooo`0000002@3oool2000000L0oooo2`0000040?ooo`03
0000003oool0oooo00<0oooo00D000000?ooo`3oool0oooo0000000c0?ooo`00:03oool00`000000
oooo0?ooo`0>0?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool01@3oool400000080
oooo00D000000?ooo`3oool0oooo000000040?ooo`030000003oool0oooo00<0oooo00<000000?oo
o`3oool00`3oool010000000oooo0?ooo`3oool<00000080HUV]1@0000000`1RFJd00000069I[@02
069I[@050000001RFJd0HUV]0000001RFJd03@0000000`21L[P00000085b^00200000009085b^000
0000PG:h0000002hLX4000000:eIHP000000[EUR00<0000000@0X4130000002P@4<0X4130P000000
0`2@<c<00000090c<`020000000707hc<`000000OS<c0000001Z<c<0000006Xc<`03000000030?oo
o`000000oooo0080oooo00<000000?ooo`3oool00`3oool<000000<0oooo0P0000050?ooo`H00000
1@3oool01@000000oooo0?ooo`3oool0000003<0oooo000X0?ooo`030000003oool0oooo00h0oooo
00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`050?ooo`070000003oool0oooo0?ooo`00
0000oooo000000030?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool00P3oool00`00
0000oooo0?ooo`020?oooa00000000<0[M[o0000000000000P1RFJd00`000000HUV]069I[@0E0000
0009085b^0000000PG:h085b^0000000PG:h00000021L[P000000080PG:h100000001P2]FF800000
0:eIHP000000[EUR00000080X41300L000000:10@`2P@4<00000090c<`000000T3<c008000000P1n
<c<30000000306Xc<`000000000000`000000`3oool00`000000oooo000000040?ooo``000001@3o
ool2000000@0oooo00D000000?ooo`3oool0oooo0000000c0?ooo`00:@3oool00`000000oooo0?oo
o`0=0?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool01@3oool01`000000oooo0?oo
o`3oool000000?ooo`0000000`3oool010000000oooo0?ooo`3oool;000000<0oooo00<000000?oo
o`3oool0200000000`2PfOl000000000000900000080PG:h00D00000085b^021L[P00000085b^002
00000006085b^0000000PG:h085b^0000000PG:h0P0000002@21L[P00000085b^0000000PG:h0000
0021L[P00000085b^00200000004085b^000000000000;QbP@<0000000<0[EUR0000000000000P00
00000`2P@4<000000:10@`0400000003090c<`000000000000/0000000D0oooo0000003oool0oooo
000000030?ooo``000001@3oool2000000X0oooo0P0000040?ooo`050000003oool0oooo0?ooo`00
0000<`3oool002X0oooo00<000000?ooo`3oool0303oool00`000000oooo0?ooo`090?ooo`030000
003oool0oooo00D0oooo00<000000?ooo`3oool02`0000020?ooo`050000003oool0oooo0?ooo`00
00001`3oool01@000000oooo0?ooo`000000oooo00T0000000<0[M[o0000000000000P0000000`21
L[P000000000000200000080PG:h00P00000085b^021L[P00000085b^0000000PG:h00000080PG:h
00D00000085b^0000000PG:h00000002085b^00800000021L[P00000085b^0000000PG:h00000021
L[P2000000050;QbP@000000^7:10000002]FF804@00000207hc<`030000001Z<c<0000000`00000
1@3oool00`000000oooo000000090?ooo`8000002P3oool2000000@0oooo00D000000?ooo`3oool0
oooo0000000c0?ooo`00:P3oool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo00L0oooo
30000000103oool000000?ooo`0000030?ooo`030000003oool0oooo00<0oooo00D000000?ooo`3o
ool0oooo000000040?ooo`d0000000<0X=Wo0000000000001`000002085b^0<000000P21L[P01000
0000PG:h00000021L[P20000000A085b^0000000PG:h00000021L[P00000085b^0000000PG:h0000
0021L[P00000085b^0000000PG:h00000021L[P03@000000102P@4<000000:10@`2P@4<200000005
090c<`000000T3<c090c<`0000000P1n<c<30000000306Xc<`000000E3<c0080000000D0oooo0000
003oool0oooo000000080?ooo`030000003oool0000000T0oooo0P0000090?ooo`<000001@3oool0
10000000oooo0?ooo`00000c0?ooo`00:`3oool00`000000oooo0?ooo`0<0?ooo`X000000P3oool0
0`000000oooo0?ooo`040?ooo`070000003oool0oooo0?ooo`000000oooo000000030?ooo`030000
003oool0oooo00`000000`3oool010000000oooo0?ooo`0000020?ooo`80000000<0T=Wo00000000
0000100000000`2]f_l000000000000400000003085b^0000000PG:h0080000000<0PG:h00000021
L[P00`0000001@21L[P00000085b^0000000PG:h00d0000000@0^7:1000000000000^7:110000000
1@2]FF8000000000002]FF8000000080X41300@000000:10@`00000000000P2@<c<20000000307hc
<`000000OS<c0080000000<0JS<c0000000000000P0000001@3oool000000?ooo`3oool0000000P0
oooo00<000000?ooo`000000203oool?000000D0oooo00@000000?ooo`3oool00000<`3oool002`0
oooo00<000000?ooo`3oool02`3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00@0
oooo00<000000?ooo`0000002P0000040?ooo`040000003oool0oooo000000P0oooo00<000000?oo
o`0000000P3oool300000003093Io`000000X=Wo00/0000000@0PG:h000000000000PG:h30000000
0`2MR/000000000000050000000309f:`0000000000000<0000000<0^7:10000002hLX4010000000
0`2]FF8000000000000300000080X4130P0000000`2@<c<00000090c<`0200000080OS<c0`000000
0`1Z<c<000000000000300000080oooo00<000000?ooo`3oool01@3ooolG00000080oooo0P000005
0?ooo`040000003oool0oooo000003<0oooo000/0?ooo`030000003oool0oooo00/0oooo00<00000
0?ooo`3oool02@3oool00`000000oooo0?ooo`040?ooo`8000000`3oool2000000<0oooo00<00000
0?ooo`3oool0103oool010000000oooo0?ooo`0000080?ooo`8000000`3oool6000000030:3Io`00
0000000000h0000000<0WH[00000002MR/000P0000000`2MR/00000009f:`0080000000309f:`000
0000000000P0000000@0^7:10000002]FF80[EUR0P000000102]FF8000000:10@`2P@4<200000003
0:10@`00000000000080T3<c0P0000000`1n<c<0000007hc<`020000000306Xc<`000000000001P0
00000`3oool00`000000oooo0?ooo`080?ooo`8000001@3oool010000000oooo0?ooo`00000c0?oo
o`00;@3oool00`000000oooo0?ooo`0;0?ooo`030000003oool0oooo00P0oooo00<000000?ooo`3o
ool0103oool00`000000oooo0?ooo`020?ooo`8000000`3oool00`000000oooo0?ooo`040?ooo`04
0000003oool0oooo000000P0oooo3`0000000`2]f_l000000000000D0000000309f:`00000000000
0080000000<0WH[00000000000001@0000000`2hLX4000000;QbP@05000000060:eIHP0000000000
0000002P@4<000000P2P@4<200000080T3<c5`0000030?ooo`8000002P3oool00`000000oooo0?oo
o`090?ooo`030000003oool0oooo00<0oooo00@000000?ooo`3oool00000<`3oool002d0oooo00<0
00000?ooo`3oool02`3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00<0oooo00<0
00000?ooo`3oool00P3oool2000000<0oooo00<000000?ooo`3oool0103oool>000000@0oooo2000
00000`2]f_l000000000000@0000000309f:`0000000000000<0000000<0WH[00000000000003000
0000102hLX4000000000002]FF8=00000080T3<c00<0000007hc<`1n<c<020000000103oool00000
0?ooo`0000090?ooo`8000002P3oool010000000oooo0?ooo`3oool9000000D0oooo00@000000?oo
o`3oool00000<`3oool002h0oooo00<000000?ooo`3oool02P3oool00`000000oooo0?ooo`090?oo
o`030000003oool0oooo0080oooo00<000000?ooo`3oool00`3oool<000000040?ooo`000000oooo
000000H0oooo3@0000000`2PfOl0000000000005000000030;SKo`000000000002P0000000<0[EUR
0000000000000P2P@4<300000007090c<`00000000000000001n<c<0000007hc<`02000000030?oo
o`000000oooo0080000000@0oooo0000003oool000002@3oool200000080oooo4@0000030?ooo`03
0000003oool0oooo00<0oooo00@000000?ooo`3oool00000<`3oool002l0oooo00<000000?ooo`3o
ool02P3oool00`000000oooo0?ooo`080?ooo`d000000`3oool00`000000oooo0?ooo`020?ooo``0
00000`3oool00`000000oooo0?ooo`030?ooo`80000000<0T=Wo000000000000100000000`2]f_l0
00000000000U000000030;QbP@00000000000080[EUR0`0000020:10@`030000002P@4<0X4130080
00000P2@<c<200000080OS<c0P0000000`3oool000000?ooo`02000000050?ooo`000000oooo0000
003oool04@0000030?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool00`3oool01000
0000oooo0?ooo`00000c0?ooo`00;`3oool00`000000oooo0?ooo`0:0?ooo`/0000000<0oooo0000
003oool00P3oool010000000oooo0?ooo`3oool<000000<0oooo00<000000?ooo`0000002@3oool0
0`000000oooo0?ooo`030?ooo`<0000000<0T=Wo0000002PfOl01@0000000`2]f_l000000000000P
000000030;QbP@000000000000H0000000@0[EUR00000000000000000P2P@4<200000080T3<c0`00
00000`1n<c<000000000000@000000<0oooo0P00000:0?ooo`030000003oool0000000X000001@3o
ool010000000oooo0?ooo`00000c0?ooo`00<03oool00`000000oooo0?ooo`090?ooo`030000003o
ool0oooo00T0oooo00@000000?ooo`3oool0oooo100000020?ooo`050000003oool000000?ooo`00
00002@3oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo00@0oooo0`0000000`2@fOl0
00000000000/00000080[EUR0`0000000`2]FF8000000000000D000000030?ooo`000000oooo00P0
oooo6@0000060?ooo`030000003oool0000003<0oooo000`0?ooo`030000003oool0oooo00X0oooo
00<000000?ooo`3oool0203oool01@000000oooo0?ooo`3oool0000000D0oooo00D000000?ooo`00
0000oooo000000090?ooo`030000003oool0oooo00L0oooo3@000000102PfOl000000000002]f_l4
000000030;SKo`000000000002X000000P2P@4<2000000<0T3<c0P0000000`3oool000000?ooo`02
000000030?ooo`00000000000080000000<0oooo0000000000005P00000B0?ooo`030000003oool0
000003<0oooo000a0?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool02@3oool01000
0000oooo0?ooo`0000050?ooo`050000003oool000000?ooo`0000001`3ooolK000000030:3Io`00
0000000002D000000P2hLX46000000030:eIHP0000000000008000000P2P@4<L000001h0oooo00<0
00000?ooo`000000<`3oool00380oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`09
0?ooo`030000003oool0000000H0oooo5`0000001@3oool000000?ooo`3oool0000000D0oooo0P00
00000`2@fOl000000000000400000080[M[o9@0000000`2hLX4000000:eIHP0J000002X0oooo00<0
00000?ooo`000000<`3oool00380oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`06
0?oooaH000000`3oool2000000P0oooo00@000000?ooo`3oool000001P3oool6000000030:3Io`00
0000000003L0000000@0oooo0000003oool000000P3oool00`000000oooo0?ooo`02000002/0oooo
00<000000?ooo`000000<`3oool003<0oooo00<000000?ooo`3oool0203oool9000000<0oooo2@00
00020?ooo`800000203oool010000000oooo0?ooo`0000070?ooo`050000003oool0oooo0000003o
ool080000000103oc<0000000000003oc<0G000000@0oooo00<000000?ooo`000000103oool20000
00<0oooo00<000000?ooo`3oool00P00000[0?ooo`030000003oool0000003<0oooo000c0?ooo`03
0000003oool0oooo00T0oooo00<000000?ooo`3oool0203oool2000000H0oooo00<000000?ooo`3o
ool00P0000080?ooo`030000003oool0oooo01D0000000<0T=Wo0000000000000P0000040:gJo`03
0000002hfol0000001d000001P3oool2000000L0oooo0P0000040?ooo`8000000`3oool00`000000
oooo00000002000002/0oooo00<000000?ooo`000000<`3oool003@0oooo00<000000?ooo`3oool0
203oool00`000000oooo0?ooo`080?ooo`8000001P3oool00`000000oooo000000020?oooa400000
00<0oooo0000003oool0103oool01P000000oooo0?ooo`3oool000000?oooal000000P3oool00`00
0000oooo0?ooo`060?ooo`030000003oool0oooo0080oooo0P0000000`3oool000000?ooo`050?oo
o`8000001@3oool010000000oooo0?ooo`3oool2000000040?ooo`0000000000000002/0oooo00<0
00000?ooo`000000<`3oool003D0oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`07
0?oooa8000000P3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo0080oooo00@00000
0?ooo`3oool0oooo6`0000070?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool01P3o
ool00`000000oooo0?ooo`02000000<0oooo00<000000?ooo`3oool00`3oool00`000000oooo0000
00040?ooo`8000000`3oool2000000040?ooo`000000oooo000002/0oooo00<000000?ooo`000000
<`3oool003D0oooo00<000000?ooo`3oool0203oool@00000080oooo0P0000040?ooo`030000003o
ool0oooo00<0oooo00<000000?ooo`0000006@0000000`3oool000000?ooo`020?ooo`8000001@3o
ool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool01P3o
ool3000000H0oooo00D000000?ooo`3oool0oooo000000020?ooo`050000003oool0oooo0?ooo`00
00000P3oool00`000000oooo000000020?ooo`80000000<0oooo0000003oool0:`3oool00`000000
oooo0000000b0?ooo`00=P3oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo00D0oooo
00D000000?ooo`3oool0oooo000000030?ooo`030000003oool0000001L000002`3oool300000003
0?ooo`000000000000@0oooo100000030?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3o
ool01P3oool00`000000oooo0?ooo`020?ooo`D000001`3oool010000000oooo0000000000040?oo
o`030000003oool0000000<0oooo0P0000030?ooo`040000003oool0oooo000002`0oooo00<00000
0?ooo`000000<P3oool003H0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`030?oo
oaL00000603oool200000080oooo0P0000030?ooo`040000003oool0oooo0?ooo`@000001`3oool0
0`000000oooo0?ooo`050?ooo`030000003oool0000000800000103oool00`000000oooo0?ooo`05
0?ooo`8000001P3oool2000000@0oooo0P0000030?ooo`030000003oool0000002d0oooo00<00000
0?ooo`000000<P3oool003L0oooo00<000000?ooo`3oool02@3oool@000002@0oooo0`0000020?oo
o`8000000`3oool00`000000oooo0?ooo`030?oooa8000001`3oool00`000000oooo0?ooo`040?oo
o`8000001`3oool00`000000oooo0?ooo`030?ooo`040000003oool0oooo0?ooo`80000000<0oooo
0000003oool0;03oool00`000000oooo0000000b0?ooo`00>03oool00`000000oooo0?ooo`0;0?oo
o`030000003oool0oooo00P0oooo00<000000?ooo`3oool0903oool3000000030?ooo`000000oooo
0080000000<0oooo0000003oool01@3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo
00H0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`020?ooo`8000000P3oool00`00
0000oooo0?ooo`030?ooo`800000103oool00`000000oooo000000020?ooo`80000000<0oooo0000
003oool0;03oool00`000000oooo0000000b0?ooo`00>03oool00`000000oooo0?ooo`0F0?ooo`03
0000003oool0oooo02@0oooo0P000000103oool000000?ooo`0000020?ooo`8000001P3oool00`00
0000oooo0?ooo`050?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool01P3oool01000
0000oooo0000000000040?ooo`040000003oool0oooo0?ooo`80000000<0oooo0000003oool00P3o
ool01P000000oooo0?ooo`000000oooo00000080oooo0P00000]0?ooo`030000003oool000000380
oooo000i0?ooo`030000003oool0oooo01D0oooo00<000000?ooo`3oool0903oool3000000030?oo
o`000000000000@0oooo0`0000030?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool0
1@3oool00`000000oooo0?ooo`050?ooo`<000001P3oool010000000oooo0?ooo`0000040?ooo`04
0000003oool0oooo00000080oooo00<000000?ooo`0000000P3oool00`000000oooo0?ooo`0/0?oo
o`030000003oool000000380oooo000j0?ooo`030000003oool0oooo01@0oooo00<000000?ooo`3o
ool09@3oool200000080oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`0300000003
0?ooo`000000oooo00D0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`0400000003
0?ooo`000000oooo00H0oooo00<000000?ooo`0000001@3oool00`000000oooo000000030?ooo`80
00000`3oool00`000000oooo0?ooo`0/0?ooo`030000003oool000000380oooo000j0?ooo`030000
003oool0oooo01@0oooo00<000000?ooo`3oool09@3oool00`000000oooo000000020?ooo`800000
0`3oool00`000000oooo0?ooo`020?ooo`H000000`3oool00`000000oooo0?ooo`020?ooo`H00000
1P3oool00`000000oooo0?ooo`040?ooo`8000001P3oool2000000@0oooo00D000000?ooo`3oool0
oooo0000000_0?ooo`030000003oool000000380oooo000k0?ooo`030000003oool0oooo01<0oooo
00<000000?ooo`3oool09P3oool3000000030?ooo`000000oooo0080000000<0oooo0000003oool0
103oool00`000000oooo0?ooo`020?ooo`P000000`3oool00`000000oooo0?ooo`060?ooo`030000
003oool0oooo0080oooo0P0000000`3oool000000?ooo`040?ooo`8000001@3oool200000080oooo
00<000000?ooo`3oool0;P3oool200000380oooo000k0?ooo`030000003oool0oooo01<0oooo00<0
00000?ooo`3oool09P3oool2000000040?ooo`000000oooo00000080oooo0P0000060?ooo`030000
003oool0oooo00@0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`050?ooo`030000
003oool0oooo008000000`3oool00`000000oooo0?ooo`020?ooo`040000003oool0oooo000000<0
oooo00D000000?ooo`000000oooo0000000a0?ooo`800000<P3oool003`0oooo00<000000?ooo`3o
ool04P3oool00`000000oooo0?ooo`0V0?ooo`<0000000<0oooo0000000000000`3oool3000000@0
oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00D0
oooo0`0000060?ooo`040000003oool0oooo000000<0oooo00@000000?ooo`3oool000000P3oool0
0`000000oooo0000000a0?ooo`800000<P3oool003d0oooo00<000000?ooo`3oool04@3oool00`00
0000oooo0?ooo`0W0?ooo`8000000P3oool00`000000oooo0?ooo`020?ooo`030000003oool00000
0080000000<0oooo0000003oool01P3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo
0080oooo1@0000070?ooo`<00000103oool00`000000oooo000000030?ooo`800000<P3oool20000
0380oooo000m0?ooo`030000003oool0oooo0140oooo00<000000?ooo`3oool09`3oool00`000000
oooo000000020?ooo`8000000P3oool2000000<0oooo1@0000040?ooo`030000003oool0oooo00H0
oooo100000040?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool0103oool2000000@0
oooo0P00000b0?ooo`800000<P3oool003h0oooo00<000000?ooo`3oool0403oool00`000000oooo
0?ooo`0X0?ooo`<0000000<0oooo0000003oool00P0000000`3oool000000?ooo`040?ooo`030000
003oool0oooo00h000001`3oool00`000000oooo0?ooo`030?ooo`<000001P3oool2000000@0oooo
00<000000?ooo`3oool0<@3oool200000380oooo000n0?ooo`030000003oool0oooo00l0oooo00<0
00000?ooo`3oool0:P3oool010000000oooo0000000000030?ooo`8000001P3oool00`000000oooo
0?ooo`040?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool01@3oool010000000oooo
0?ooo`3oool2000000<0oooo00@000000?ooo`3oool0oooo0P0000000`3oool000000?ooo`020?oo
o`030000003oool0oooo0380oooo0P00000b0?ooo`00?`3oool00`000000oooo0?ooo`0>0?ooo`03
0000003oool0oooo02X0oooo0P0000000`3oool00000000000030?ooo`<00000103oool00`000000
oooo0?ooo`040?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool01P3oool3000000D0
oooo00@000000?ooo`3oool000000`3oool010000000oooo0?ooo`00000e0?ooo`800000<P3oool0
0400oooo00<000000?ooo`3oool03@3oool00`000000oooo0?ooo`0[0?ooo`040000003oool0oooo
000000@0oooo00<000000?ooo`0000000P0000000`3oool000000?ooo`060?ooo`030000003oool0
oooo00D0oooo00<000000?ooo`3oool00P3oool4000000L0oooo00<000000?ooo`000000103oool0
0`000000oooo0000000f0?ooo`800000<P3oool00400oooo00<000000?ooo`3oool03@3oool00`00
0000oooo0?ooo`0/0?ooo`030000003oool0oooo008000000P3oool00`000000oooo0?ooo`020?oo
o`@000001@3oool00`000000oooo0?ooo`050?ooo`D000000`3oool00`000000oooo0?ooo`050?oo
o`8000001@3oool2000003L0oooo0P00000b0?ooo`00@@3oool00`000000oooo0?ooo`0<0?ooo`03
0000003oool0oooo02d0oooo00@000000?ooo`000000oooo0P0000000`3oool000000?ooo`040?oo
o`030000003oool0000000d00000203oool00`000000oooo0?ooo`020?ooo`80000000<0oooo0000
003oool0103oool00`000000oooo0?ooo`0g0?ooo`030000003oool0oooo0300oooo00110?ooo`03
0000003oool0oooo00`0oooo00<000000?ooo`3oool0;P3oool2000000<0oooo0P0000050?ooo`03
0000003oool0oooo00D0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`050?ooo`03
0000003oool0oooo008000000`3oool010000000oooo0?ooo`3oool2000003X0oooo00<000000?oo
o`3oool0<03oool00480oooo00<000000?ooo`3oool02`3oool00`000000oooo0?ooo`0_0?ooo`80
00000`3oool3000000@0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`050?ooo`03
0000003oool0oooo00D0oooo0`0000050?ooo`040000003oool0oooo000003`0oooo00<000000?oo
o`3oool0<03oool004<0oooo00<000000?ooo`3oool02P3oool00`000000oooo0?ooo`0`0?ooo`03
0000003oool0oooo0080oooo00<000000?ooo`0000000P0000000`3oool000000?ooo`050?ooo`03
0000003oool0oooo00D0oooo00<000000?ooo`3oool00P3oool4000000L0oooo00<000000?ooo`00
0000?@3oool00`000000oooo0?ooo`0`0?ooo`00@`3oool00`000000oooo0?ooo`0:0?ooo`030000
003oool0oooo0340oooo0P0000020?ooo`030000003oool0oooo0080oooo100000050?ooo`030000
003oool0oooo00D0oooo100000040?ooo`030000003oool0oooo00@0oooo0P00000n0?ooo`030000
003oool0oooo0300oooo00140?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool0<`3o
ool2000000030?ooo`000000oooo00@0oooo00<000000?ooo`0000003@0000070?ooo`030000003o
ool0oooo0080oooo0P0000100?ooo`800000<@3oool004D0oooo00<000000?ooo`3oool0203oool0
0`000000oooo0?ooo`0e0?ooo`8000001@3oool00`000000oooo0?ooo`040?ooo`030000003oool0
oooo00D0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`0200000480oooo0P00000a
0?ooo`00A@3oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo03H0oooo0`0000030?oo
o`030000003oool0oooo00D0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`050?oo
o`800000A03oool200000340oooo00160?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3o
ool0>@3oool3000000030?ooo`000000oooo00D0oooo00<000000?ooo`3oool01@3oool010000000
oooo0?ooo`3oool4000004H0oooo0P00000a0?ooo`00AP3oool00`000000oooo0?ooo`060?ooo`03
0000003oool0oooo03d0oooo1P0000020?ooo`030000003oool0oooo00<0oooo1P00001;0?ooo`03
0000003oool0oooo02l0oooo00170?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool0
@`3oool800000540oooo00<000000?ooo`3oool0;`3oool004P0oooo00<000000?ooo`3oool0103o
ool00`000000oooo0?ooo`2C0?ooo`X00000<@3oool004P0oooo00<000000?ooo`3oool0103oool0
0`000000oooo0?ooo`250?ooo`h00000>`3oool004T0oooo00<000000?ooo`3oool00`3oool00`00
0000oooo0?ooo`1g0?ooo`h00000B@3oool004T0oooo00<000000?ooo`3oool00`3oool00`000000
oooo0?ooo`1Z0?ooo`d00000E`3oool004X0oooo00<000000?ooo`3oool00P3oool00`000000oooo
0?ooo`1L0?ooo`h00000I03oool004/0oooo00D000000?ooo`3oool0oooo0000001@0?ooo`h00000
LP3oool004/0oooo00D000000?ooo`3oool0oooo000000120?ooo`h00000P03oool004`0oooo00@0
00000?ooo`3oool00000=03oool>000008h0oooo001<0?ooo`040000003oool0oooo000002L0oooo
3@00002L0?ooo`00C@3oool00`000000oooo0000000I0?ooo`h00000Z@3oool004h0oooo0P00000;
0?ooo`h00000]`3oool004h0oooo3@0000350?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3o
oolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3o
oolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3o
oolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3o
oolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3o
oolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3o
oolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3o
oolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3o
oolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3o
oolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3o
oolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3o
oolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3o
oolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00\
\>"]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
    \(SpinShow[plot1]\), "\[IndentingNewLine]", 
    \(SelectionMove[EvaluationNotebook[], All, GeneratedCell]\), "\n", 
    \(FrontEndTokenExecute["\<OpenCloseGroup\>"]\), "\n", 
    \(FrontEndTokenExecute["\<SelectionAnimate\>"]\)}], "Input"],

Cell[CellGroupData[{

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
%%ImageSize: 500 500 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics3D
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Background color
1 .961 .933 r
MFill
% Scaling calculations
0 1 0 1 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 0 r
.25 Mabswid
[ ] 0 setdash
.23981 .55099 m
.21113 .79004 L
s
.21113 .79004 m
.78887 .79004 L
s
.78887 .79004 m
.76019 .55099 L
s
.76019 .55099 m
.23981 .55099 L
s
.14736 .14594 m
.85264 .14594 L
s
.85264 .14594 m
.90748 .42015 L
s
.90748 .42015 m
.09252 .42015 L
s
.09252 .42015 m
.14736 .14594 L
s
.23981 .55099 m
.21113 .79004 L
s
.21113 .79004 m
.09252 .42015 L
s
.09252 .42015 m
.14736 .14594 L
s
.14736 .14594 m
.23981 .55099 L
s
.76019 .55099 m
.85264 .14594 L
s
.85264 .14594 m
.90748 .42015 L
s
.90748 .42015 m
.78887 .79004 L
s
.78887 .79004 m
.76019 .55099 L
s
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
.24 .35 .67 r
.5 Mabswid
.53873 .55504 m
.51307 .55057 L
s
.51307 .55057 m
.51331 .52967 L
s
.51307 .55057 m
.48693 .55057 L
s
.48693 .55057 m
.48669 .52967 L
s
.48693 .55057 m
.46127 .55504 L
s
.56292 .56382 m
.53873 .55504 L
s
.53873 .55504 m
.53944 .53417 L
s
.46127 .55504 m
.46056 .53417 L
s
.46127 .55504 m
.43708 .56382 L
s
.58469 .57664 m
.56292 .56382 L
s
.56292 .56382 m
.56408 .54303 L
s
.43708 .56382 m
.43592 .54303 L
s
.43708 .56382 m
.41531 .57664 L
s
.60316 .59306 m
.58469 .57664 L
s
.58469 .57664 m
.58626 .55596 L
s
.41531 .57664 m
.41374 .55596 L
s
.41531 .57664 m
.39684 .59306 L
s
.53944 .53417 m
.51331 .52967 L
s
.51331 .52967 m
.51356 .50798 L
s
.51331 .52967 m
.48669 .52967 L
s
.48669 .52967 m
.48644 .50798 L
s
.48669 .52967 m
.46056 .53417 L
s
.61752 .61251 m
.60316 .59306 L
s
.60316 .59306 m
.60509 .57253 L
s
.39684 .59306 m
.39491 .57253 L
s
.39684 .59306 m
.38248 .61251 L
s
.56408 .54303 m
.53944 .53417 L
s
.53944 .53417 m
.54018 .51252 L
s
.46056 .53417 m
.45982 .51252 L
s
.46056 .53417 m
.43592 .54303 L
s
.58626 .55596 m
.56408 .54303 L
s
.56408 .54303 m
.56528 .52145 L
s
.43592 .54303 m
.43472 .52145 L
s
.43592 .54303 m
.41374 .55596 L
s
.62706 .63427 m
.61752 .61251 L
s
.61752 .61251 m
.61974 .59216 L
s
.38248 .61251 m
.38026 .59216 L
s
.38248 .61251 m
.37294 .63427 L
s
.60509 .57253 m
.58626 .55596 L
s
.58626 .55596 m
.58789 .5345 L
s
.41374 .55596 m
.41211 .5345 L
s
.41374 .55596 m
.39491 .57253 L
s
.54018 .51252 m
.51356 .50798 L
s
.51356 .50798 m
.51382 .48547 L
s
.51356 .50798 m
.48644 .50798 L
s
.48644 .50798 m
.48618 .48547 L
s
.48644 .50798 m
.45982 .51252 L
s
.37294 .63427 m
.37052 .61413 L
s
.37294 .63427 m
.36877 .65748 L
s
.63123 .65748 m
.62706 .63427 L
s
.62706 .63427 m
.62948 .61413 L
s
.61974 .59216 m
.60509 .57253 L
s
.60509 .57253 m
.6071 .55122 L
s
.39491 .57253 m
.3929 .55122 L
s
.39491 .57253 m
.38026 .59216 L
s
.56528 .52145 m
.54018 .51252 L
s
.54018 .51252 m
.54094 .49005 L
s
.45982 .51252 m
.45906 .49005 L
s
.45982 .51252 m
.43472 .52145 L
s
.58789 .5345 m
.56528 .52145 L
s
.56528 .52145 m
.56653 .49905 L
s
.43472 .52145 m
.43347 .49905 L
s
.43472 .52145 m
.41211 .5345 L
s
.62948 .61413 m
.61974 .59216 L
s
.61974 .59216 m
.62204 .57104 L
s
.38026 .59216 m
.37796 .57104 L
s
.38026 .59216 m
.37052 .61413 L
s
.63376 .63758 m
.63123 .65748 L
s
.6297 .68118 m
.63123 .65748 L
s
.36877 .65748 m
.36624 .63758 L
s
.36877 .65748 m
.3703 .68118 L
s
.6071 .55122 m
.58789 .5345 L
s
.58789 .5345 m
.58959 .51221 L
s
.41211 .5345 m
.41041 .51221 L
s
.41211 .5345 m
.3929 .55122 L
s
.51382 .48547 m
.48618 .48547 L
s
.48618 .48547 m
.48591 .46208 L
s
.48618 .48547 m
.45906 .49005 L
s
.54094 .49005 m
.51382 .48547 L
s
.51382 .48547 m
.51409 .46208 L
s
.63376 .63758 m
.62948 .61413 L
s
.62948 .61413 m
.63199 .59322 L
s
.37052 .61413 m
.36801 .59322 L
s
.37052 .61413 m
.36624 .63758 L
s
.62204 .57104 m
.6071 .55122 L
s
.6071 .55122 m
.60918 .52908 L
s
.3929 .55122 m
.39082 .52908 L
s
.3929 .55122 m
.37796 .57104 L
s
.56653 .49905 m
.54094 .49005 L
s
.54094 .49005 m
.54174 .4667 L
s
.45906 .49005 m
.45826 .4667 L
s
.45906 .49005 m
.43347 .49905 L
s
.62236 .7043 m
.6297 .68118 L
s
.6297 .68118 m
.63223 .66153 L
s
.3703 .68118 m
.36777 .66153 L
s
.3703 .68118 m
.37764 .7043 L
s
.58959 .51221 m
.56653 .49905 L
s
.56653 .49905 m
.56783 .47578 L
s
.43347 .49905 m
.43217 .47578 L
s
.43347 .49905 m
.41041 .51221 L
s
.63199 .59322 m
.62204 .57104 L
s
.62204 .57104 m
.62443 .54908 L
s
.37796 .57104 m
.37557 .54908 L
s
.37796 .57104 m
.36801 .59322 L
s
.63639 .6169 m
.63376 .63758 L
s
.63223 .66153 m
.63376 .63758 L
s
.36624 .63758 m
.36361 .6169 L
s
.36624 .63758 m
.36777 .66153 L
s
.60918 .52908 m
.58959 .51221 L
s
.58959 .51221 m
.59135 .48905 L
s
.41041 .51221 m
.40865 .48905 L
s
.41041 .51221 m
.39082 .52908 L
s
.60936 .72577 m
.62236 .7043 L
s
.62236 .7043 m
.62476 .68491 L
s
.37764 .7043 m
.37524 .68491 L
s
.37764 .7043 m
.39064 .72577 L
s
.54174 .4667 m
.51409 .46208 L
s
.51409 .46208 m
.51437 .43777 L
s
.51409 .46208 m
.48591 .46208 L
s
.48591 .46208 m
.48563 .43777 L
s
.48591 .46208 m
.45826 .4667 L
s
.63639 .6169 m
.63199 .59322 L
s
.63199 .59322 m
.63461 .57147 L
s
.36801 .59322 m
.36539 .57147 L
s
.36801 .59322 m
.36361 .6169 L
s
.62443 .54908 m
.60918 .52908 L
s
.60918 .52908 m
.61134 .50606 L
s
.39082 .52908 m
.38866 .50606 L
s
.39082 .52908 m
.37557 .54908 L
s
.56783 .47578 m
.54174 .4667 L
s
.54174 .4667 m
.54257 .44242 L
s
.45826 .4667 m
.45743 .44242 L
s
.45826 .4667 m
.43217 .47578 L
s
.59117 .74451 m
.60936 .72577 L
s
.60936 .72577 m
.61153 .70662 L
s
.39064 .72577 m
.38847 .70662 L
s
.39064 .72577 m
.40883 .74451 L
s
.62476 .68491 m
.63223 .66153 L
s
.63223 .66153 m
.63485 .6411 L
s
.36777 .66153 m
.36515 .6411 L
s
.36777 .66153 m
.37524 .68491 L
s
.59135 .48905 m
.56783 .47578 L
s
.43217 .47578 m
.40865 .48905 L
s
.63461 .57147 m
.62443 .54908 L
s
.37557 .54908 m
.36539 .57147 L
s
.40883 .74451 m
.407 .72558 L
s
.40883 .74451 m
.43144 .75955 L
s
.56856 .75955 m
.59117 .74451 L
s
.59117 .74451 m
.593 .72558 L
s
.63912 .5954 m
.63639 .6169 L
s
.63485 .6411 m
.63639 .6169 L
s
.36361 .6169 m
.36088 .5954 L
s
.36361 .6169 m
.36515 .6411 L
s
.61134 .50606 m
.59135 .48905 L
s
.40865 .48905 m
.38866 .50606 L
s
.61153 .70662 m
.62476 .68491 L
s
.62476 .68491 m
.62726 .66473 L
s
.37524 .68491 m
.37274 .66473 L
s
.37524 .68491 m
.38847 .70662 L
s
.43144 .75955 m
.43006 .74079 L
s
.43144 .75955 m
.45744 .77007 L
s
.54256 .77007 m
.56856 .75955 L
s
.56856 .75955 m
.56994 .74079 L
s
.54257 .44242 m
.51437 .43777 L
s
.51437 .43777 m
.48563 .43777 L
s
.48563 .43777 m
.45743 .44242 L
s
.36539 .57147 m
.36088 .5954 L
s
.63912 .5954 m
.63461 .57147 L
s
.45744 .77007 m
.45658 .75144 L
s
.45744 .77007 m
.48557 .77548 L
s
.51443 .77548 m
.54256 .77007 L
s
.54256 .77007 m
.54342 .75144 L
s
.56918 .45158 m
.54257 .44242 L
s
.45743 .44242 m
.43082 .45158 L
s
.593 .72558 m
.61153 .70662 L
s
.61153 .70662 m
.61379 .68669 L
s
.38847 .70662 m
.38621 .68669 L
s
.38847 .70662 m
.407 .72558 L
s
.62726 .66473 m
.63485 .6411 L
s
.63485 .6411 m
.63758 .61984 L
s
.36515 .6411 m
.36242 .61984 L
s
.36515 .6411 m
.37274 .66473 L
s
.893 .253 .108 r
.40138 .48028 m .41546 .48028 L .40337 .50212 L p F P
0 0 0 r
s
.893 .253 .108 r
.40337 .50212 m .38726 .50212 L .40138 .48028 L p F P
0 0 0 r
s
.24 .35 .67 r
.38839 .50319 m
.38866 .50606 L
s
.893 .253 .108 r
.41546 .48028 m .42955 .48028 L .41947 .50212 L p F P
0 0 0 r
s
.893 .253 .108 r
.41947 .50212 m .40337 .50212 L .41546 .48028 L p F P
0 0 0 r
s
.893 .253 .108 r
.42955 .48028 m .44364 .48028 L .43558 .50212 L p F P
0 0 0 r
s
.893 .253 .108 r
.43558 .50212 m .41947 .50212 L .42955 .48028 L p F P
0 0 0 r
s
.893 .253 .108 r
.44364 .48028 m .45773 .48028 L .45168 .50212 L p F P
0 0 0 r
s
.893 .253 .108 r
.45168 .50212 m .43558 .50212 L .44364 .48028 L p F P
0 0 0 r
s
.893 .253 .108 r
.45773 .48028 m .47182 .48028 L .46779 .50212 L p F P
0 0 0 r
s
.893 .253 .108 r
.46779 .50212 m .45168 .50212 L .45773 .48028 L p F P
0 0 0 r
s
.893 .253 .108 r
.47182 .48028 m .48591 .48028 L .48389 .50212 L p F P
0 0 0 r
s
.893 .253 .108 r
.48389 .50212 m .46779 .50212 L .47182 .48028 L p F P
0 0 0 r
s
.893 .253 .108 r
.48591 .48028 m .5 .48028 L .5 .50212 L p F P
0 0 0 r
s
.893 .253 .108 r
.5 .50212 m .48389 .50212 L .48591 .48028 L p F P
0 0 0 r
s
.893 .253 .108 r
.5 .48028 m .51409 .48028 L .51611 .50212 L p F P
0 0 0 r
s
.893 .253 .108 r
.51611 .50212 m .5 .50212 L .5 .48028 L p F P
0 0 0 r
s
.893 .253 .108 r
.51409 .48028 m .52818 .48028 L .53221 .50212 L p F P
0 0 0 r
s
.893 .253 .108 r
.53221 .50212 m .51611 .50212 L .51409 .48028 L p F P
0 0 0 r
s
.893 .253 .108 r
.52818 .48028 m .54227 .48028 L .54832 .50212 L p F P
0 0 0 r
s
.893 .253 .108 r
.54832 .50212 m .53221 .50212 L .52818 .48028 L p F P
0 0 0 r
s
.893 .253 .108 r
.54227 .48028 m .55636 .48028 L .56442 .50212 L p F P
0 0 0 r
s
.893 .253 .108 r
.56442 .50212 m .54832 .50212 L .54227 .48028 L p F P
0 0 0 r
s
.893 .253 .108 r
.55636 .48028 m .57045 .48028 L .58053 .50212 L p F P
0 0 0 r
s
.893 .253 .108 r
.58053 .50212 m .56442 .50212 L .55636 .48028 L p F P
0 0 0 r
s
.893 .253 .108 r
.57045 .48028 m .58454 .48028 L .59663 .50212 L p F P
0 0 0 r
s
.893 .253 .108 r
.59663 .50212 m .58053 .50212 L .57045 .48028 L p F P
0 0 0 r
s
.893 .253 .108 r
.58454 .48028 m .59862 .48028 L .61274 .50212 L p F P
0 0 0 r
s
.24 .35 .67 r
.59135 .48905 m
.5916 .48575 L
s
.61134 .50606 m
.61161 .50319 L
s
.893 .253 .108 r
.61274 .50212 m .59663 .50212 L .58454 .48028 L p F P
0 0 0 r
s
.867 .244 .104 r
.38726 .50212 m .40337 .50212 L .39343 .52392 L p F P
0 0 0 r
s
.867 .244 .104 r
.39343 .52392 m .37567 .52392 L .38726 .50212 L p F P
0 0 0 r
s
.867 .244 .104 r
.40337 .50212 m .41947 .50212 L .4112 .52392 L p F P
0 0 0 r
s
.867 .244 .104 r
.4112 .52392 m .39343 .52392 L .40337 .50212 L p F P
0 0 0 r
s
.867 .244 .104 r
.41947 .50212 m .43558 .50212 L .42896 .52392 L p F P
0 0 0 r
s
.867 .244 .104 r
.42896 .52392 m .4112 .52392 L .41947 .50212 L p F P
0 0 0 r
s
.867 .244 .104 r
.43558 .50212 m .45168 .50212 L .44672 .52392 L p F P
0 0 0 r
s
.867 .244 .104 r
.44672 .52392 m .42896 .52392 L .43558 .50212 L p F P
0 0 0 r
s
.867 .244 .104 r
.45168 .50212 m .46779 .50212 L .46448 .52392 L p F P
0 0 0 r
s
.867 .244 .104 r
.46448 .52392 m .44672 .52392 L .45168 .50212 L p F P
0 0 0 r
s
.867 .244 .104 r
.46779 .50212 m .48389 .50212 L .48224 .52392 L p F P
0 0 0 r
s
.867 .244 .104 r
.48224 .52392 m .46448 .52392 L .46779 .50212 L p F P
0 0 0 r
s
.867 .244 .104 r
.48389 .50212 m .5 .50212 L .5 .52392 L p F P
0 0 0 r
s
.867 .244 .104 r
.5 .52392 m .48224 .52392 L .48389 .50212 L p F P
0 0 0 r
s
.867 .244 .104 r
.5 .50212 m .51611 .50212 L .51776 .52392 L p F P
0 0 0 r
s
.867 .244 .104 r
.51776 .52392 m .5 .52392 L .5 .50212 L p F P
0 0 0 r
s
.867 .244 .104 r
.51611 .50212 m .53221 .50212 L .53552 .52392 L p F P
0 0 0 r
s
.867 .244 .104 r
.53552 .52392 m .51776 .52392 L .51611 .50212 L p F P
0 0 0 r
s
.867 .244 .104 r
.53221 .50212 m .54832 .50212 L .55328 .52392 L p F P
0 0 0 r
s
.867 .244 .104 r
.55328 .52392 m .53552 .52392 L .53221 .50212 L p F P
0 0 0 r
s
.867 .244 .104 r
.54832 .50212 m .56442 .50212 L .57104 .52392 L p F P
0 0 0 r
s
.867 .244 .104 r
.57104 .52392 m .55328 .52392 L .54832 .50212 L p F P
0 0 0 r
s
.867 .244 .104 r
.56442 .50212 m .58053 .50212 L .5888 .52392 L p F P
0 0 0 r
s
.867 .244 .104 r
.5888 .52392 m .57104 .52392 L .56442 .50212 L p F P
0 0 0 r
s
.867 .244 .104 r
.58053 .50212 m .59663 .50212 L .60657 .52392 L p F P
0 0 0 r
s
.867 .244 .104 r
.60657 .52392 m .5888 .52392 L .58053 .50212 L p F P
0 0 0 r
s
.867 .244 .104 r
.59663 .50212 m .61274 .50212 L .62433 .52392 L p F P
0 0 0 r
s
.867 .244 .104 r
.62433 .52392 m .60657 .52392 L .59663 .50212 L p F P
0 0 0 r
s
.135 .206 .453 r
.62545 .51338 m .62433 .52392 L .61274 .50212 L p F P
0 0 0 r
s
.135 .206 .453 r
.61274 .50212 m .61366 .49239 L .62545 .51338 L p F P
0 0 0 r
s
.173 .262 .553 r
.61366 .49239 m .61274 .50212 L .59862 .48028 L p F P
0 0 0 r
s
.332 .486 .914 r
.38634 .49239 m .38726 .50212 L .40138 .48028 L p F P
0 0 0 r
s
.33 .481 .895 r
.38726 .50212 m .38634 .49239 L .37455 .51338 L p F P
0 0 0 r
s
.33 .481 .895 r
.37455 .51338 m .37567 .52392 L .38726 .50212 L p F P
0 0 0 r
s
.24 .35 .67 r
.48557 .77548 m
.48528 .75692 L
s
.48557 .77548 m
.51443 .77548 L
s
.51443 .77548 m
.51472 .75692 L
s
.917 .262 .111 r
.41777 .45879 m .42952 .45879 L .41546 .48028 L p F P
0 0 0 r
s
.917 .262 .111 r
.41546 .48028 m .40138 .48028 L .41777 .45879 L p F P
0 0 0 r
s
.917 .262 .111 r
.42952 .45879 m .44126 .45879 L .42955 .48028 L p F P
0 0 0 r
s
.24 .35 .67 r
.43216 .4755 m
.43217 .47578 L
s
.917 .262 .111 r
.42955 .48028 m .41546 .48028 L .42952 .45879 L p F P
0 0 0 r
s
.917 .262 .111 r
.44126 .45879 m .45301 .45879 L .44364 .48028 L p F P
0 0 0 r
s
.917 .262 .111 r
.44364 .48028 m .42955 .48028 L .44126 .45879 L p F P
0 0 0 r
s
.24 .35 .67 r
.43082 .45158 m
.43122 .45879 L
s
.917 .262 .111 r
.45301 .45879 m .46476 .45879 L .45773 .48028 L p F P
0 0 0 r
s
.917 .262 .111 r
.45773 .48028 m .44364 .48028 L .45301 .45879 L p F P
0 0 0 r
s
.917 .262 .111 r
.46476 .45879 m .47651 .45879 L .47182 .48028 L p F P
0 0 0 r
s
.917 .262 .111 r
.47182 .48028 m .45773 .48028 L .46476 .45879 L p F P
0 0 0 r
s
.917 .262 .111 r
.47651 .45879 m .48825 .45879 L .48591 .48028 L p F P
0 0 0 r
s
.917 .262 .111 r
.48591 .48028 m .47182 .48028 L .47651 .45879 L p F P
0 0 0 r
s
.917 .262 .111 r
.48825 .45879 m .5 .45879 L .5 .48028 L p F P
0 0 0 r
s
.917 .262 .111 r
.5 .48028 m .48591 .48028 L .48825 .45879 L p F P
0 0 0 r
s
.917 .262 .111 r
.5 .45879 m .51175 .45879 L .51409 .48028 L p F P
0 0 0 r
s
.917 .262 .111 r
.51409 .48028 m .5 .48028 L .5 .45879 L p F P
0 0 0 r
s
.917 .262 .111 r
.51175 .45879 m .52349 .45879 L .52818 .48028 L p F P
0 0 0 r
s
.917 .262 .111 r
.52818 .48028 m .51409 .48028 L .51175 .45879 L p F P
0 0 0 r
s
.917 .262 .111 r
.52349 .45879 m .53524 .45879 L .54227 .48028 L p F P
0 0 0 r
s
.917 .262 .111 r
.54227 .48028 m .52818 .48028 L .52349 .45879 L p F P
0 0 0 r
s
.917 .262 .111 r
.53524 .45879 m .54699 .45879 L .55636 .48028 L p F P
0 0 0 r
s
.917 .262 .111 r
.55636 .48028 m .54227 .48028 L .53524 .45879 L p F P
0 0 0 r
s
.917 .262 .111 r
.54699 .45879 m .55874 .45879 L .57045 .48028 L p F P
0 0 0 r
s
.917 .262 .111 r
.57045 .48028 m .55636 .48028 L .54699 .45879 L p F P
0 0 0 r
s
.917 .262 .111 r
.55874 .45879 m .57048 .45879 L .58454 .48028 L p F P
0 0 0 r
s
.24 .35 .67 r
.56784 .4755 m
.56833 .46678 L
s
.917 .262 .111 r
.58454 .48028 m .57045 .48028 L .55874 .45879 L p F P
0 0 0 r
s
.24 .35 .67 r
.56878 .45879 m
.56918 .45158 L
s
.917 .262 .111 r
.57048 .45879 m .58223 .45879 L .59862 .48028 L p F P
0 0 0 r
s
.24 .35 .67 r
.59202 .48028 m
.59238 .47551 L
s
.917 .262 .111 r
.59862 .48028 m .58454 .48028 L .57048 .45879 L p F P
0 0 0 r
s
.173 .262 .553 r
.59862 .48028 m .59933 .47162 L .61366 .49239 L p F P
0 0 0 r
s
.203 .306 .632 r
.59933 .47162 m .59862 .48028 L .58223 .45879 L p F P
0 0 0 r
s
.33 .484 .918 r
.40067 .47162 m .40138 .48028 L .41777 .45879 L p F P
0 0 0 r
s
.332 .486 .914 r
.40138 .48028 m .40067 .47162 L .38634 .49239 L p F P
0 0 0 r
s
.83 .24 .1 r
.7371 .4733 m
.73671 .5021 L
s
.77616 .5021 m
.77661 .4733 L
s
.73671 .5021 m
.77616 .5021 L
s
.69758 .4733 m
.69726 .5021 L
s
.69726 .5021 m
.73671 .5021 L
s
.65807 .4733 m
.65781 .5021 L
s
.65781 .5021 m
.69726 .5021 L
s
.61837 .50077 m
.61855 .4733 L
s
.61911 .5021 m
.65781 .5021 L
s
.5789 .5021 m
.57903 .4733 L
s
.5789 .5021 m
.61334 .5021 L
s
.53945 .5021 m
.53952 .4733 L
s
.53945 .5021 m
.5789 .5021 L
s
.5 .4733 m
.5 .5021 L
s
.5 .5021 m
.53945 .5021 L
s
.46048 .4733 m
.46055 .5021 L
s
.46055 .5021 m
.5 .5021 L
s
.42097 .4733 m
.4211 .5021 L
s
.4211 .5021 m
.46055 .5021 L
s
.38145 .4733 m
.38163 .50077 L
s
.38666 .5021 m
.4211 .5021 L
s
.34193 .4733 m
.34219 .5021 L
s
.34219 .5021 m
.38089 .5021 L
s
.30242 .4733 m
.30274 .5021 L
s
.30274 .5021 m
.34219 .5021 L
s
.2629 .4733 m
.26329 .5021 L
s
.26329 .5021 m
.30274 .5021 L
s
.22339 .4733 m
.22384 .5021 L
s
.22384 .5021 m
.26329 .5021 L
s
.73671 .5021 m
.73723 .53082 L
s
.77677 .53082 m
.77616 .5021 L
s
.69726 .5021 m
.69769 .53082 L
s
.65781 .5021 m
.65815 .53082 L
s
.34219 .5021 m
.34185 .53082 L
s
.30274 .5021 m
.30231 .53082 L
s
.26329 .5021 m
.26277 .53082 L
s
.22384 .5021 m
.22323 .53082 L
s
.838 .234 .1 r
.37567 .52392 m .39343 .52392 L .38586 .54528 L p F P
0 0 0 r
s
.838 .234 .1 r
.38586 .54528 m .36684 .54528 L .37567 .52392 L p F P
0 0 0 r
s
.83 .24 .1 r
.38139 .53082 m
.38156 .51149 L
s
.24 .35 .67 r
.37516 .54528 m
.37557 .54908 L
s
.838 .234 .1 r
.39343 .52392 m .4112 .52392 L .40489 .54528 L p F P
0 0 0 r
s
.838 .234 .1 r
.40489 .54528 m .38586 .54528 L .39343 .52392 L p F P
0 0 0 r
s
.838 .234 .1 r
.4112 .52392 m .42896 .52392 L .42391 .54528 L p F P
0 0 0 r
s
.838 .234 .1 r
.42391 .54528 m .40489 .54528 L .4112 .52392 L p F P
0 0 0 r
s
.83 .24 .1 r
.42092 .53082 m
.4211 .5021 L
s
.838 .234 .1 r
.42896 .52392 m .44672 .52392 L .44293 .54528 L p F P
0 0 0 r
s
.838 .234 .1 r
.44293 .54528 m .42391 .54528 L .42896 .52392 L p F P
0 0 0 r
s
.838 .234 .1 r
.44672 .52392 m .46448 .52392 L .46195 .54528 L p F P
0 0 0 r
s
.838 .234 .1 r
.46195 .54528 m .44293 .54528 L .44672 .52392 L p F P
0 0 0 r
s
.83 .24 .1 r
.46046 .53082 m
.46055 .5021 L
s
.838 .234 .1 r
.46448 .52392 m .48224 .52392 L .48098 .54528 L p F P
0 0 0 r
s
.838 .234 .1 r
.48098 .54528 m .46195 .54528 L .46448 .52392 L p F P
0 0 0 r
s
.838 .234 .1 r
.48224 .52392 m .5 .52392 L .5 .54528 L p F P
0 0 0 r
s
.838 .234 .1 r
.5 .54528 m .48098 .54528 L .48224 .52392 L p F P
0 0 0 r
s
.838 .234 .1 r
.5 .52392 m .51776 .52392 L .51902 .54528 L p F P
0 0 0 r
s
.838 .234 .1 r
.51902 .54528 m .5 .54528 L .5 .52392 L p F P
0 0 0 r
s
.83 .24 .1 r
.5 .5021 m
.5 .53082 L
s
.838 .234 .1 r
.51776 .52392 m .53552 .52392 L .53805 .54528 L p F P
0 0 0 r
s
.838 .234 .1 r
.53805 .54528 m .51902 .54528 L .51776 .52392 L p F P
0 0 0 r
s
.838 .234 .1 r
.53552 .52392 m .55328 .52392 L .55707 .54528 L p F P
0 0 0 r
s
.838 .234 .1 r
.55707 .54528 m .53805 .54528 L .53552 .52392 L p F P
0 0 0 r
s
.83 .24 .1 r
.53945 .5021 m
.53954 .53082 L
s
.838 .234 .1 r
.55328 .52392 m .57104 .52392 L .57609 .54528 L p F P
0 0 0 r
s
.838 .234 .1 r
.57609 .54528 m .55707 .54528 L .55328 .52392 L p F P
0 0 0 r
s
.838 .234 .1 r
.57104 .52392 m .5888 .52392 L .59511 .54528 L p F P
0 0 0 r
s
.838 .234 .1 r
.59511 .54528 m .57609 .54528 L .57104 .52392 L p F P
0 0 0 r
s
.83 .24 .1 r
.5789 .5021 m
.57908 .53082 L
s
.838 .234 .1 r
.5888 .52392 m .60657 .52392 L .61414 .54528 L p F P
0 0 0 r
s
.838 .234 .1 r
.61414 .54528 m .59511 .54528 L .5888 .52392 L p F P
0 0 0 r
s
.838 .234 .1 r
.60657 .52392 m .62433 .52392 L .63316 .54528 L p F P
0 0 0 r
s
.24 .35 .67 r
.62443 .54908 m
.62551 .53914 L
s
.838 .234 .1 r
.63316 .54528 m .61414 .54528 L .60657 .52392 L p F P
0 0 0 r
s
.83 .24 .1 r
.61844 .51149 m
.61861 .53082 L
s
.096 .145 .343 r
.63445 .5342 m .63316 .54528 L .62433 .52392 L p F P
0 0 0 r
s
.096 .145 .343 r
.62433 .52392 m .62545 .51338 L .63445 .5342 L p F P
0 0 0 r
s
.24 .35 .67 r
.62635 .53146 m
.62692 .52624 L
s
.61641 .51263 m
.62692 .52624 L
s
.32 .464 .852 r
.37567 .52392 m .37455 .51338 L .36555 .5342 L p F P
0 0 0 r
s
.32 .464 .852 r
.36555 .5342 m .36684 .54528 L .37567 .52392 L p F P
0 0 0 r
s
.24 .35 .67 r
.37308 .52624 m
.38359 .51263 L
s
.37308 .52624 m
.37365 .53146 L
s
.83 .24 .1 r
.73838 .44538 m
.7371 .4733 L
s
.77661 .4733 m
.77811 .44538 L
s
.7371 .4733 m
.77661 .4733 L
s
.69865 .44538 m
.69758 .4733 L
s
.69758 .4733 m
.7371 .4733 L
s
.65892 .44538 m
.65807 .4733 L
s
.65807 .4733 m
.69758 .4733 L
s
.61919 .44538 m
.61855 .4733 L
s
.61855 .4733 m
.65807 .4733 L
s
.57903 .4733 m
.59411 .4733 L
s
.60049 .4733 m
.61855 .4733 L
s
.53952 .4733 m
.57903 .4733 L
s
.5 .4733 m
.53952 .4733 L
s
.46048 .4733 m
.5 .4733 L
s
.42097 .4733 m
.46048 .4733 L
s
.38081 .44538 m
.38145 .4733 L
s
.40589 .4733 m
.42097 .4733 L
s
.38145 .4733 m
.39951 .4733 L
s
.34108 .44538 m
.34193 .4733 L
s
.34193 .4733 m
.38145 .4733 L
s
.30135 .44538 m
.30242 .4733 L
s
.30242 .4733 m
.34193 .4733 L
s
.26162 .44538 m
.2629 .4733 L
s
.2629 .4733 m
.30242 .4733 L
s
.22189 .44538 m
.22339 .4733 L
s
.22339 .4733 m
.2629 .4733 L
s
.73723 .53082 m
.77677 .53082 L
s
.69769 .53082 m
.73723 .53082 L
s
.65815 .53082 m
.69769 .53082 L
s
.61861 .53082 m
.62752 .53082 L
s
.63299 .53082 m
.65815 .53082 L
s
.57908 .53082 m
.61861 .53082 L
s
.53954 .53082 m
.57908 .53082 L
s
.5 .53082 m
.53954 .53082 L
s
.46046 .53082 m
.5 .53082 L
s
.42092 .53082 m
.46046 .53082 L
s
.38139 .53082 m
.42092 .53082 L
s
.37248 .53082 m
.38139 .53082 L
s
.34185 .53082 m
.36701 .53082 L
s
.30231 .53082 m
.34185 .53082 L
s
.26277 .53082 m
.30231 .53082 L
s
.22323 .53082 m
.26277 .53082 L
s
.73723 .53082 m
.73863 .55854 L
s
.77841 .55854 m
.77677 .53082 L
s
.69769 .53082 m
.69886 .55854 L
s
.65815 .53082 m
.65909 .55854 L
s
.34185 .53082 m
.34091 .55854 L
s
.30231 .53082 m
.30114 .55854 L
s
.26277 .53082 m
.26137 .55854 L
s
.22323 .53082 m
.22159 .55854 L
s
.938 .269 .115 r
.43616 .43807 m .44528 .43807 L .42952 .45879 L p F P
0 0 0 r
s
.938 .269 .115 r
.42952 .45879 m .41777 .45879 L .43616 .43807 L p F P
0 0 0 r
s
.938 .269 .115 r
.44528 .43807 m .4544 .43807 L .44126 .45879 L p F P
0 0 0 r
s
.938 .269 .115 r
.44126 .45879 m .42952 .45879 L .44528 .43807 L p F P
0 0 0 r
s
.938 .269 .115 r
.4544 .43807 m .46352 .43807 L .45301 .45879 L p F P
0 0 0 r
s
.938 .269 .115 r
.45301 .45879 m .44126 .45879 L .4544 .43807 L p F P
0 0 0 r
s
.938 .269 .115 r
.46352 .43807 m .47264 .43807 L .46476 .45879 L p F P
0 0 0 r
s
.938 .269 .115 r
.46476 .45879 m .45301 .45879 L .46352 .43807 L p F P
0 0 0 r
s
.83 .24 .1 r
.46027 .44538 m
.46048 .4733 L
s
.938 .269 .115 r
.47264 .43807 m .48176 .43807 L .47651 .45879 L p F P
0 0 0 r
s
.938 .269 .115 r
.47651 .45879 m .46476 .45879 L .47264 .43807 L p F P
0 0 0 r
s
.938 .269 .115 r
.48176 .43807 m .49088 .43807 L .48825 .45879 L p F P
0 0 0 r
s
.938 .269 .115 r
.48825 .45879 m .47651 .45879 L .48176 .43807 L p F P
0 0 0 r
s
.938 .269 .115 r
.49088 .43807 m .5 .43807 L .5 .45879 L p F P
0 0 0 r
s
.938 .269 .115 r
.5 .45879 m .48825 .45879 L .49088 .43807 L p F P
0 0 0 r
s
.938 .269 .115 r
.5 .43807 m .50912 .43807 L .51175 .45879 L p F P
0 0 0 r
s
.938 .269 .115 r
.51175 .45879 m .5 .45879 L .5 .43807 L p F P
0 0 0 r
s
.83 .24 .1 r
.5 .44538 m
.5 .4733 L
s
.938 .269 .115 r
.50912 .43807 m .51824 .43807 L .52349 .45879 L p F P
0 0 0 r
s
.938 .269 .115 r
.52349 .45879 m .51175 .45879 L .50912 .43807 L p F P
0 0 0 r
s
.938 .269 .115 r
.51824 .43807 m .52736 .43807 L .53524 .45879 L p F P
0 0 0 r
s
.938 .269 .115 r
.53524 .45879 m .52349 .45879 L .51824 .43807 L p F P
0 0 0 r
s
.938 .269 .115 r
.52736 .43807 m .53648 .43807 L .54699 .45879 L p F P
0 0 0 r
s
.938 .269 .115 r
.54699 .45879 m .53524 .45879 L .52736 .43807 L p F P
0 0 0 r
s
.938 .269 .115 r
.53648 .43807 m .5456 .43807 L .55874 .45879 L p F P
0 0 0 r
s
.938 .269 .115 r
.55874 .45879 m .54699 .45879 L .53648 .43807 L p F P
0 0 0 r
s
.83 .24 .1 r
.53952 .4733 m
.53973 .44538 L
s
.938 .269 .115 r
.5456 .43807 m .55472 .43807 L .57048 .45879 L p F P
0 0 0 r
s
.938 .269 .115 r
.57048 .45879 m .55874 .45879 L .5456 .43807 L p F P
0 0 0 r
s
.938 .269 .115 r
.55472 .43807 m .56384 .43807 L .58223 .45879 L p F P
0 0 0 r
s
.938 .269 .115 r
.58223 .45879 m .57048 .45879 L .55472 .43807 L p F P
0 0 0 r
s
.203 .306 .632 r
.58223 .45879 m .58272 .45146 L .59933 .47162 L p F P
0 0 0 r
s
.228 .342 .695 r
.58272 .45146 m .58223 .45879 L .56384 .43807 L p F P
0 0 0 r
s
.83 .24 .1 r
.57903 .4733 m
.57934 .4534 L
s
.5794 .44911 m
.57946 .44538 L
s
.324 .477 .912 r
.41728 .45146 m .41777 .45879 L .43616 .43807 L p F P
0 0 0 r
s
.83 .24 .1 r
.42066 .4534 m
.42097 .4733 L
s
.42054 .44538 m
.4206 .44911 L
s
.33 .484 .918 r
.41777 .45879 m .41728 .45146 L .40067 .47162 L p F P
0 0 0 r
s
.804 .223 .095 r
.36684 .54528 m .38586 .54528 L .38081 .56581 L p F P
0 0 0 r
s
.804 .223 .095 r
.38081 .56581 m .36095 .56581 L .36684 .54528 L p F P
0 0 0 r
s
.24 .35 .67 r
.36471 .56581 m
.36539 .57147 L
s
.804 .223 .095 r
.38586 .54528 m .40489 .54528 L .40068 .56581 L p F P
0 0 0 r
s
.804 .223 .095 r
.40068 .56581 m .38081 .56581 L .38586 .54528 L p F P
0 0 0 r
s
.83 .24 .1 r
.38068 .55854 m
.38139 .53082 L
s
.804 .223 .095 r
.40489 .54528 m .42391 .54528 L .42054 .56581 L p F P
0 0 0 r
s
.804 .223 .095 r
.42054 .56581 m .40068 .56581 L .40489 .54528 L p F P
0 0 0 r
s
.804 .223 .095 r
.42391 .54528 m .44293 .54528 L .44041 .56581 L p F P
0 0 0 r
s
.804 .223 .095 r
.44041 .56581 m .42054 .56581 L .42391 .54528 L p F P
0 0 0 r
s
.83 .24 .1 r
.42046 .55854 m
.42092 .53082 L
s
.804 .223 .095 r
.44293 .54528 m .46195 .54528 L .46027 .56581 L p F P
0 0 0 r
s
.804 .223 .095 r
.46027 .56581 m .44041 .56581 L .44293 .54528 L p F P
0 0 0 r
s
.804 .223 .095 r
.46195 .54528 m .48098 .54528 L .48014 .56581 L p F P
0 0 0 r
s
.804 .223 .095 r
.48014 .56581 m .46027 .56581 L .46195 .54528 L p F P
0 0 0 r
s
.83 .24 .1 r
.46023 .55854 m
.46046 .53082 L
s
.804 .223 .095 r
.48098 .54528 m .5 .54528 L .5 .56581 L p F P
0 0 0 r
s
.804 .223 .095 r
.5 .56581 m .48014 .56581 L .48098 .54528 L p F P
0 0 0 r
s
.804 .223 .095 r
.5 .54528 m .51902 .54528 L .51986 .56581 L p F P
0 0 0 r
s
.804 .223 .095 r
.51986 .56581 m .5 .56581 L .5 .54528 L p F P
0 0 0 r
s
.83 .24 .1 r
.5 .53082 m
.5 .55854 L
s
.804 .223 .095 r
.51902 .54528 m .53805 .54528 L .53973 .56581 L p F P
0 0 0 r
s
.804 .223 .095 r
.53973 .56581 m .51986 .56581 L .51902 .54528 L p F P
0 0 0 r
s
.804 .223 .095 r
.53805 .54528 m .55707 .54528 L .55959 .56581 L p F P
0 0 0 r
s
.804 .223 .095 r
.55959 .56581 m .53973 .56581 L .53805 .54528 L p F P
0 0 0 r
s
.83 .24 .1 r
.53954 .53082 m
.53977 .55854 L
s
.804 .223 .095 r
.55707 .54528 m .57609 .54528 L .57946 .56581 L p F P
0 0 0 r
s
.804 .223 .095 r
.57946 .56581 m .55959 .56581 L .55707 .54528 L p F P
0 0 0 r
s
.804 .223 .095 r
.57609 .54528 m .59511 .54528 L .59932 .56581 L p F P
0 0 0 r
s
.804 .223 .095 r
.59932 .56581 m .57946 .56581 L .57609 .54528 L p F P
0 0 0 r
s
.83 .24 .1 r
.57908 .53082 m
.57954 .55854 L
s
.804 .223 .095 r
.59511 .54528 m .61414 .54528 L .61919 .56581 L p F P
0 0 0 r
s
.804 .223 .095 r
.61919 .56581 m .59932 .56581 L .59511 .54528 L p F P
0 0 0 r
s
.804 .223 .095 r
.61414 .54528 m .63316 .54528 L .63905 .56581 L p F P
0 0 0 r
s
.804 .223 .095 r
.63905 .56581 m .61919 .56581 L .61414 .54528 L p F P
0 0 0 r
s
.24 .35 .67 r
.63461 .57147 m
.63529 .56581 L
s
.83 .24 .1 r
.61861 .53082 m
.61932 .55854 L
s
.072 .105 .259 r
.64046 .55444 m .63905 .56581 L .63316 .54528 L p F P
0 0 0 r
s
.072 .105 .259 r
.63316 .54528 m .63445 .5342 L .64046 .55444 L p F P
0 0 0 r
s
.298 .43 .775 r
.36684 .54528 m .36555 .5342 L .35954 .55444 L p F P
0 0 0 r
s
.298 .43 .775 r
.35954 .55444 m .36095 .56581 L .36684 .54528 L p F P
0 0 0 r
s
.24 .35 .67 r
.407 .72558 m
.40511 .70587 L
s
.407 .72558 m
.43006 .74079 L
s
.56994 .74079 m
.593 .72558 L
s
.593 .72558 m
.59489 .70587 L
s
.83 .24 .1 r
.74052 .41926 m
.73838 .44538 L
s
.77811 .44538 m
.78061 .41926 L
s
.73838 .44538 m
.77811 .44538 L
s
.70043 .41926 m
.69865 .44538 L
s
.69865 .44538 m
.73838 .44538 L
s
.66035 .41926 m
.65892 .44538 L
s
.65892 .44538 m
.69865 .44538 L
s
.62026 .41926 m
.61919 .44538 L
s
.61919 .44538 m
.65892 .44538 L
s
.57946 .44538 m
.61919 .44538 L
s
.53973 .44538 m
.57148 .44538 L
s
.57414 .44538 m
.57946 .44538 L
s
.5 .44538 m
.53973 .44538 L
s
.46027 .44538 m
.5 .44538 L
s
.42852 .44538 m
.46027 .44538 L
s
.42054 .44538 m
.42586 .44538 L
s
.37974 .41926 m
.38081 .44538 L
s
.38081 .44538 m
.42054 .44538 L
s
.33965 .41926 m
.34108 .44538 L
s
.34108 .44538 m
.38081 .44538 L
s
.29957 .41926 m
.30135 .44538 L
s
.30135 .44538 m
.34108 .44538 L
s
.25948 .41926 m
.26162 .44538 L
s
.26162 .44538 m
.30135 .44538 L
s
.21939 .41926 m
.22189 .44538 L
s
.22189 .44538 m
.26162 .44538 L
s
.173 .262 .553 r
.6146 .4825 m .61366 .49239 L .59933 .47162 L p F P
0 0 0 r
s
.173 .262 .553 r
.59933 .47162 m .60004 .46284 L .6146 .4825 L p F P
0 0 0 r
s
.203 .306 .632 r
.60004 .46284 m .59933 .47162 L .58272 .45146 L p F P
0 0 0 r
s
.24 .35 .67 r
.57602 .45539 m
.59318 .46496 L
s
.59247 .47426 m
.59318 .46496 L
s
.33 .484 .918 r
.39996 .46284 m .40067 .47162 L .41728 .45146 L p F P
0 0 0 r
s
.24 .35 .67 r
.40682 .46496 m
.40753 .47426 L
s
.40682 .46496 m
.42398 .45539 L
s
.332 .486 .914 r
.40067 .47162 m .39996 .46284 L .3854 .4825 L p F P
0 0 0 r
s
.332 .486 .914 r
.3854 .4825 m .38634 .49239 L .40067 .47162 L p F P
0 0 0 r
s
.135 .206 .453 r
.62659 .50265 m .62545 .51338 L .61366 .49239 L p F P
0 0 0 r
s
.135 .206 .453 r
.61366 .49239 m .6146 .4825 L .62659 .50265 L p F P
0 0 0 r
s
.33 .481 .895 r
.38634 .49239 m .3854 .4825 L .37341 .50265 L p F P
0 0 0 r
s
.33 .481 .895 r
.37341 .50265 m .37455 .51338 L .38634 .49239 L p F P
0 0 0 r
s
.83 .24 .1 r
.73863 .55854 m
.77841 .55854 L
s
.69886 .55854 m
.73863 .55854 L
s
.65909 .55854 m
.69886 .55854 L
s
.61932 .55854 m
.63721 .55854 L
s
.63995 .55854 m
.65909 .55854 L
s
.57954 .55854 m
.61932 .55854 L
s
.53977 .55854 m
.57954 .55854 L
s
.5 .55854 m
.53977 .55854 L
s
.46023 .55854 m
.5 .55854 L
s
.42046 .55854 m
.46023 .55854 L
s
.38068 .55854 m
.42046 .55854 L
s
.36279 .55854 m
.38068 .55854 L
s
.34091 .55854 m
.36005 .55854 L
s
.30114 .55854 m
.34091 .55854 L
s
.26137 .55854 m
.30114 .55854 L
s
.22159 .55854 m
.26137 .55854 L
s
.73863 .55854 m
.7409 .58431 L
s
.78105 .58431 m
.77841 .55854 L
s
.69886 .55854 m
.70075 .58431 L
s
.65909 .55854 m
.6606 .58431 L
s
.34091 .55854 m
.3394 .58431 L
s
.30114 .55854 m
.29925 .58431 L
s
.26137 .55854 m
.2591 .58431 L
s
.22159 .55854 m
.21895 .58431 L
s
.959 .277 .118 r
.45624 .41851 m .46249 .41851 L .44528 .43807 L p F P
0 0 0 r
s
.959 .277 .118 r
.44528 .43807 m .43616 .43807 L .45624 .41851 L p F P
0 0 0 r
s
.959 .277 .118 r
.46249 .41851 m .46874 .41851 L .4544 .43807 L p F P
0 0 0 r
s
.24 .35 .67 r
.45716 .43431 m
.45729 .43807 L
s
.959 .277 .118 r
.4544 .43807 m .44528 .43807 L .46249 .41851 L p F P
0 0 0 r
s
.959 .277 .118 r
.46874 .41851 m .47499 .41851 L .46352 .43807 L p F P
0 0 0 r
s
.959 .277 .118 r
.46352 .43807 m .4544 .43807 L .46874 .41851 L p F P
0 0 0 r
s
.83 .24 .1 r
.45991 .41926 m
.46027 .44538 L
s
.959 .277 .118 r
.47499 .41851 m .48124 .41851 L .47264 .43807 L p F P
0 0 0 r
s
.959 .277 .118 r
.47264 .43807 m .46352 .43807 L .47499 .41851 L p F P
0 0 0 r
s
.959 .277 .118 r
.48124 .41851 m .4875 .41851 L .48176 .43807 L p F P
0 0 0 r
s
.24 .35 .67 r
.48549 .42535 m
.48563 .43777 L
s
.959 .277 .118 r
.48176 .43807 m .47264 .43807 L .48124 .41851 L p F P
0 0 0 r
s
.959 .277 .118 r
.4875 .41851 m .49375 .41851 L .49088 .43807 L p F P
0 0 0 r
s
.959 .277 .118 r
.49088 .43807 m .48176 .43807 L .4875 .41851 L p F P
0 0 0 r
s
.959 .277 .118 r
.49375 .41851 m .5 .41851 L .5 .43807 L p F P
0 0 0 r
s
.959 .277 .118 r
.5 .43807 m .49088 .43807 L .49375 .41851 L p F P
0 0 0 r
s
.959 .277 .118 r
.5 .41851 m .50625 .41851 L .50912 .43807 L p F P
0 0 0 r
s
.959 .277 .118 r
.50912 .43807 m .5 .43807 L .5 .41851 L p F P
0 0 0 r
s
.83 .24 .1 r
.5 .41926 m
.5 .44538 L
s
.959 .277 .118 r
.50625 .41851 m .5125 .41851 L .51824 .43807 L p F P
0 0 0 r
s
.24 .35 .67 r
.51437 .43777 m
.51443 .43186 L
s
.959 .277 .118 r
.51824 .43807 m .50912 .43807 L .50625 .41851 L p F P
0 0 0 r
s
.959 .277 .118 r
.5125 .41851 m .51876 .41851 L .52736 .43807 L p F P
0 0 0 r
s
.959 .277 .118 r
.52736 .43807 m .51824 .43807 L .5125 .41851 L p F P
0 0 0 r
s
.959 .277 .118 r
.51876 .41851 m .52501 .41851 L .53648 .43807 L p F P
0 0 0 r
s
.959 .277 .118 r
.53648 .43807 m .52736 .43807 L .51876 .41851 L p F P
0 0 0 r
s
.959 .277 .118 r
.52501 .41851 m .53126 .41851 L .5456 .43807 L p F P
0 0 0 r
s
.24 .35 .67 r
.54271 .43807 m
.54281 .43542 L
s
.959 .277 .118 r
.5456 .43807 m .53648 .43807 L .52501 .41851 L p F P
0 0 0 r
s
.959 .277 .118 r
.53126 .41851 m .53751 .41851 L .55472 .43807 L p F P
0 0 0 r
s
.959 .277 .118 r
.55472 .43807 m .5456 .43807 L .53126 .41851 L p F P
0 0 0 r
s
.959 .277 .118 r
.53751 .41851 m .54376 .41851 L .56384 .43807 L p F P
0 0 0 r
s
.959 .277 .118 r
.56384 .43807 m .55472 .43807 L .53751 .41851 L p F P
0 0 0 r
s
.83 .24 .1 r
.53973 .44538 m
.54009 .41926 L
s
.228 .342 .695 r
.56384 .43807 m .56413 .43229 L .58272 .45146 L p F P
0 0 0 r
s
.249 .372 .747 r
.56413 .43229 m .56384 .43807 L .54376 .41851 L p F P
0 0 0 r
s
.316 .466 .898 r
.43587 .43229 m .43616 .43807 L .45624 .41851 L p F P
0 0 0 r
s
.324 .477 .912 r
.43616 .43807 m .43587 .43229 L .41728 .45146 L p F P
0 0 0 r
s
.24 .35 .67 r
.61379 .68669 m
.62726 .66473 L
s
.62726 .66473 m
.62987 .64374 L
s
.37274 .66473 m
.37013 .64374 L
s
.37274 .66473 m
.38621 .68669 L
s
.203 .306 .632 r
.58272 .45146 m .58321 .44404 L .60004 .46284 L p F P
0 0 0 r
s
.228 .342 .695 r
.58321 .44404 m .58272 .45146 L .56413 .43229 L p F P
0 0 0 r
s
.324 .477 .912 r
.41679 .44404 m .41728 .45146 L .43587 .43229 L p F P
0 0 0 r
s
.33 .484 .918 r
.41728 .45146 m .41679 .44404 L .39996 .46284 L p F P
0 0 0 r
s
.764 .21 .089 r
.36095 .56581 m .38081 .56581 L .37842 .58511 L p F P
0 0 0 r
s
.764 .21 .089 r
.37842 .58511 m .35816 .58511 L .36095 .56581 L p F P
0 0 0 r
s
.764 .21 .089 r
.38081 .56581 m .40068 .56581 L .39868 .58511 L p F P
0 0 0 r
s
.764 .21 .089 r
.39868 .58511 m .37842 .58511 L .38081 .56581 L p F P
0 0 0 r
s
.83 .24 .1 r
.37955 .58431 m
.38068 .55854 L
s
.764 .21 .089 r
.40068 .56581 m .42054 .56581 L .41895 .58511 L p F P
0 0 0 r
s
.764 .21 .089 r
.41895 .58511 m .39868 .58511 L .40068 .56581 L p F P
0 0 0 r
s
.764 .21 .089 r
.42054 .56581 m .44041 .56581 L .43921 .58511 L p F P
0 0 0 r
s
.764 .21 .089 r
.43921 .58511 m .41895 .58511 L .42054 .56581 L p F P
0 0 0 r
s
.83 .24 .1 r
.4197 .58431 m
.42046 .55854 L
s
.764 .21 .089 r
.44041 .56581 m .46027 .56581 L .45947 .58511 L p F P
0 0 0 r
s
.764 .21 .089 r
.45947 .58511 m .43921 .58511 L .44041 .56581 L p F P
0 0 0 r
s
.764 .21 .089 r
.46027 .56581 m .48014 .56581 L .47974 .58511 L p F P
0 0 0 r
s
.764 .21 .089 r
.47974 .58511 m .45947 .58511 L .46027 .56581 L p F P
0 0 0 r
s
.83 .24 .1 r
.45985 .58431 m
.46023 .55854 L
s
.764 .21 .089 r
.48014 .56581 m .5 .56581 L .5 .58511 L p F P
0 0 0 r
s
.764 .21 .089 r
.5 .58511 m .47974 .58511 L .48014 .56581 L p F P
0 0 0 r
s
.764 .21 .089 r
.5 .56581 m .51986 .56581 L .52026 .58511 L p F P
0 0 0 r
s
.764 .21 .089 r
.52026 .58511 m .5 .58511 L .5 .56581 L p F P
0 0 0 r
s
.83 .24 .1 r
.5 .55854 m
.5 .58431 L
s
.764 .21 .089 r
.51986 .56581 m .53973 .56581 L .54053 .58511 L p F P
0 0 0 r
s
.764 .21 .089 r
.54053 .58511 m .52026 .58511 L .51986 .56581 L p F P
0 0 0 r
s
.764 .21 .089 r
.53973 .56581 m .55959 .56581 L .56079 .58511 L p F P
0 0 0 r
s
.764 .21 .089 r
.56079 .58511 m .54053 .58511 L .53973 .56581 L p F P
0 0 0 r
s
.83 .24 .1 r
.53977 .55854 m
.54015 .58431 L
s
.764 .21 .089 r
.55959 .56581 m .57946 .56581 L .58105 .58511 L p F P
0 0 0 r
s
.764 .21 .089 r
.58105 .58511 m .56079 .58511 L .55959 .56581 L p F P
0 0 0 r
s
.764 .21 .089 r
.57946 .56581 m .59932 .56581 L .60132 .58511 L p F P
0 0 0 r
s
.764 .21 .089 r
.60132 .58511 m .58105 .58511 L .57946 .56581 L p F P
0 0 0 r
s
.83 .24 .1 r
.57954 .55854 m
.5803 .58431 L
s
.764 .21 .089 r
.59932 .56581 m .61919 .56581 L .62158 .58511 L p F P
0 0 0 r
s
.764 .21 .089 r
.62158 .58511 m .60132 .58511 L .59932 .56581 L p F P
0 0 0 r
s
.764 .21 .089 r
.61919 .56581 m .63905 .56581 L .64184 .58511 L p F P
0 0 0 r
s
.764 .21 .089 r
.64184 .58511 m .62158 .58511 L .61919 .56581 L p F P
0 0 0 r
s
.83 .24 .1 r
.61932 .55854 m
.62045 .58431 L
s
.052 .076 .18 r
.64331 .5737 m .64184 .58511 L .63905 .56581 L p F P
0 0 0 r
s
.052 .076 .18 r
.63905 .56581 m .64046 .55444 L .64331 .5737 L p F P
0 0 0 r
s
.26 .371 .651 r
.36095 .56581 m .35954 .55444 L .35669 .5737 L p F P
0 0 0 r
s
.26 .371 .651 r
.35669 .5737 m .35816 .58511 L .36095 .56581 L p F P
0 0 0 r
s
.096 .145 .343 r
.63576 .52289 m .63445 .5342 L .62545 .51338 L p F P
0 0 0 r
s
.096 .145 .343 r
.62545 .51338 m .62659 .50265 L .63576 .52289 L p F P
0 0 0 r
s
.32 .464 .852 r
.37455 .51338 m .37341 .50265 L .36424 .52289 L p F P
0 0 0 r
s
.32 .464 .852 r
.36424 .52289 m .36555 .5342 L .37455 .51338 L p F P
0 0 0 r
s
.228 .342 .695 r
.56413 .43229 m .56443 .42645 L .58321 .44404 L p F P
0 0 0 r
s
.249 .372 .747 r
.56443 .42645 m .56413 .43229 L .5439 .41449 L p F P
0 0 0 r
s
.249 .372 .747 r
.54376 .41851 m .5439 .41449 L .56413 .43229 L p F P
0 0 0 r
s
.316 .466 .898 r
.45624 .41851 m .4561 .41449 L .43587 .43229 L p F P
0 0 0 r
s
.316 .466 .898 r
.43557 .42645 m .43587 .43229 L .4561 .41449 L p F P
0 0 0 r
s
.324 .477 .912 r
.43587 .43229 m .43557 .42645 L .41679 .44404 L p F P
0 0 0 r
s
.24 .35 .67 r
.43006 .74079 m
.42862 .72127 L
s
.43006 .74079 m
.45658 .75144 L
s
.54342 .75144 m
.56994 .74079 L
s
.56994 .74079 m
.57138 .72127 L
s
.072 .105 .259 r
.64189 .54283 m .64046 .55444 L .63445 .5342 L p F P
0 0 0 r
s
.24 .35 .67 r
.63609 .55914 m
.63733 .54885 L
s
.072 .105 .259 r
.63445 .5342 m .63576 .52289 L .64189 .54283 L p F P
0 0 0 r
s
.24 .35 .67 r
.62692 .52624 m
.63733 .54885 L
s
.298 .43 .775 r
.36555 .5342 m .36424 .52289 L .35811 .54283 L p F P
0 0 0 r
s
.298 .43 .775 r
.35811 .54283 m .35954 .55444 L .36555 .5342 L p F P
0 0 0 r
s
.24 .35 .67 r
.36267 .54885 m
.37308 .52624 L
s
.36267 .54885 m
.36391 .55914 L
s
.173 .262 .553 r
.61555 .47245 m .6146 .4825 L .60004 .46284 L p F P
0 0 0 r
s
.24 .35 .67 r
.61162 .50307 m
.61359 .48212 L
s
.173 .262 .553 r
.60004 .46284 m .60077 .45393 L .61555 .47245 L p F P
0 0 0 r
s
.24 .35 .67 r
.59318 .46496 m
.61359 .48212 L
s
.203 .306 .632 r
.60077 .45393 m .60004 .46284 L .58321 .44404 L p F P
0 0 0 r
s
.33 .484 .918 r
.39923 .45393 m .39996 .46284 L .41679 .44404 L p F P
0 0 0 r
s
.332 .486 .914 r
.39996 .46284 m .39923 .45393 L .38445 .47245 L p F P
0 0 0 r
s
.332 .486 .914 r
.38445 .47245 m .3854 .4825 L .39996 .46284 L p F P
0 0 0 r
s
.24 .35 .67 r
.38641 .48212 m
.40682 .46496 L
s
.38641 .48212 m
.38838 .50307 L
s
.203 .306 .632 r
.58321 .44404 m .58372 .43652 L .60077 .45393 L p F P
0 0 0 r
s
.228 .342 .695 r
.58372 .43652 m .58321 .44404 L .56443 .42645 L p F P
0 0 0 r
s
.83 .24 .1 r
.57976 .43446 m
.58017 .41926 L
s
.324 .477 .912 r
.41628 .43652 m .41679 .44404 L .43557 .42645 L p F P
0 0 0 r
s
.83 .24 .1 r
.41983 .41926 m
.42024 .43446 L
s
.33 .484 .918 r
.41679 .44404 m .41628 .43652 L .39923 .45393 L p F P
0 0 0 r
s
.977 .284 .121 r
.47765 .40051 m .48084 .40051 L .46249 .41851 L p F P
0 0 0 r
s
.977 .284 .121 r
.46249 .41851 m .45624 .41851 L .47765 .40051 L p F P
0 0 0 r
s
.977 .284 .121 r
.48084 .40051 m .48403 .40051 L .46874 .41851 L p F P
0 0 0 r
s
.977 .284 .121 r
.46874 .41851 m .46249 .41851 L .48084 .40051 L p F P
0 0 0 r
s
.977 .284 .121 r
.48403 .40051 m .48723 .40051 L .47499 .41851 L p F P
0 0 0 r
s
.977 .284 .121 r
.47499 .41851 m .46874 .41851 L .48403 .40051 L p F P
0 0 0 r
s
.977 .284 .121 r
.48723 .40051 m .49042 .40051 L .48124 .41851 L p F P
0 0 0 r
s
.977 .284 .121 r
.48124 .41851 m .47499 .41851 L .48723 .40051 L p F P
0 0 0 r
s
.977 .284 .121 r
.49042 .40051 m .49361 .40051 L .4875 .41851 L p F P
0 0 0 r
s
.977 .284 .121 r
.4875 .41851 m .48124 .41851 L .49042 .40051 L p F P
0 0 0 r
s
.977 .284 .121 r
.49361 .40051 m .49681 .40051 L .49375 .41851 L p F P
0 0 0 r
s
.977 .284 .121 r
.49375 .41851 m .4875 .41851 L .49361 .40051 L p F P
0 0 0 r
s
.977 .284 .121 r
.49681 .40051 m .5 .40051 L .5 .41851 L p F P
0 0 0 r
s
.977 .284 .121 r
.5 .41851 m .49375 .41851 L .49681 .40051 L p F P
0 0 0 r
s
.977 .284 .121 r
.5 .40051 m .50319 .40051 L .50625 .41851 L p F P
0 0 0 r
s
.977 .284 .121 r
.50625 .41851 m .5 .41851 L .5 .40051 L p F P
0 0 0 r
s
.977 .284 .121 r
.50319 .40051 m .50639 .40051 L .5125 .41851 L p F P
0 0 0 r
s
.977 .284 .121 r
.5125 .41851 m .50625 .41851 L .50319 .40051 L p F P
0 0 0 r
s
.977 .284 .121 r
.50639 .40051 m .50958 .40051 L .51876 .41851 L p F P
0 0 0 r
s
.977 .284 .121 r
.51876 .41851 m .5125 .41851 L .50639 .40051 L p F P
0 0 0 r
s
.977 .284 .121 r
.50958 .40051 m .51277 .40051 L .52501 .41851 L p F P
0 0 0 r
s
.977 .284 .121 r
.52501 .41851 m .51876 .41851 L .50958 .40051 L p F P
0 0 0 r
s
.977 .284 .121 r
.51277 .40051 m .51597 .40051 L .53126 .41851 L p F P
0 0 0 r
s
.977 .284 .121 r
.53126 .41851 m .52501 .41851 L .51277 .40051 L p F P
0 0 0 r
s
.977 .284 .121 r
.51597 .40051 m .51916 .40051 L .53751 .41851 L p F P
0 0 0 r
s
.977 .284 .121 r
.53751 .41851 m .53126 .41851 L .51597 .40051 L p F P
0 0 0 r
s
.977 .284 .121 r
.51916 .40051 m .52235 .40051 L .54376 .41851 L p F P
0 0 0 r
s
.977 .284 .121 r
.54376 .41851 m .53751 .41851 L .51916 .40051 L p F P
0 0 0 r
s
.266 .397 .789 r
.5439 .41449 m .54376 .41851 L .52235 .40051 L p F P
0 0 0 r
s
.24 .35 .67 r
.54328 .42163 m
.54343 .41717 L
s
.306 .453 .879 r
.4561 .41449 m .45624 .41851 L .47765 .40051 L p F P
0 0 0 r
s
.24 .35 .67 r
.45657 .41717 m
.45672 .42163 L
s
.53285 .41544 m
.54343 .41717 L
s
.45657 .41717 m
.46715 .41544 L
s
.135 .206 .453 r
.62776 .49173 m .62659 .50265 L .6146 .4825 L p F P
0 0 0 r
s
.135 .206 .453 r
.6146 .4825 m .61555 .47245 L .62776 .49173 L p F P
0 0 0 r
s
.33 .481 .895 r
.3854 .4825 m .38445 .47245 L .37224 .49173 L p F P
0 0 0 r
s
.33 .481 .895 r
.37224 .49173 m .37341 .50265 L .3854 .4825 L p F P
0 0 0 r
s
.83 .24 .1 r
.74348 .39591 m
.74052 .41926 L
s
.78061 .41926 m
.78406 .39591 L
s
.74052 .41926 m
.78061 .41926 L
s
.7029 .39591 m
.70043 .41926 L
s
.70043 .41926 m
.74052 .41926 L
s
.66232 .39591 m
.66035 .41926 L
s
.66035 .41926 m
.70043 .41926 L
s
.62174 .39591 m
.62026 .41926 L
s
.62026 .41926 m
.66035 .41926 L
s
.58017 .41926 m
.62026 .41926 L
s
.54009 .41926 m
.54705 .41926 L
s
.5521 .41926 m
.58017 .41926 L
s
.5 .41926 m
.54009 .41926 L
s
.45991 .41926 m
.5 .41926 L
s
.45295 .41926 m
.45991 .41926 L
s
.41983 .41926 m
.4479 .41926 L
s
.37826 .39591 m
.37974 .41926 L
s
.37974 .41926 m
.41983 .41926 L
s
.33768 .39591 m
.33965 .41926 L
s
.33965 .41926 m
.37974 .41926 L
s
.2971 .39591 m
.29957 .41926 L
s
.29957 .41926 m
.33965 .41926 L
s
.25652 .39591 m
.25948 .41926 L
s
.25948 .41926 m
.29957 .41926 L
s
.21594 .39591 m
.21939 .41926 L
s
.21939 .41926 m
.25948 .41926 L
s
.028 .041 .084 r
.64286 .59157 m .64141 .60276 L .64184 .58511 L p F P
0 0 0 r
s
.028 .041 .084 r
.64184 .58511 m .64331 .5737 L .64286 .59157 L p F P
0 0 0 r
s
.713 .193 .082 r
.35816 .58511 m .37842 .58511 L .37879 .60276 L p F P
0 0 0 r
s
.24 .35 .67 r
.35975 .58647 m
.36088 .5954 L
s
.713 .193 .082 r
.37879 .60276 m .35859 .60276 L .35816 .58511 L p F P
0 0 0 r
s
.24 .35 .67 r
.36135 .60276 m
.36242 .61984 L
s
.713 .193 .082 r
.37842 .58511 m .39868 .58511 L .399 .60276 L p F P
0 0 0 r
s
.713 .193 .082 r
.399 .60276 m .37879 .60276 L .37842 .58511 L p F P
0 0 0 r
s
.713 .193 .082 r
.39868 .58511 m .41895 .58511 L .4192 .60276 L p F P
0 0 0 r
s
.713 .193 .082 r
.4192 .60276 m .399 .60276 L .39868 .58511 L p F P
0 0 0 r
s
.713 .193 .082 r
.41895 .58511 m .43921 .58511 L .4394 .60276 L p F P
0 0 0 r
s
.713 .193 .082 r
.4394 .60276 m .4192 .60276 L .41895 .58511 L p F P
0 0 0 r
s
.713 .193 .082 r
.43921 .58511 m .45947 .58511 L .4596 .60276 L p F P
0 0 0 r
s
.713 .193 .082 r
.4596 .60276 m .4394 .60276 L .43921 .58511 L p F P
0 0 0 r
s
.713 .193 .082 r
.45947 .58511 m .47974 .58511 L .4798 .60276 L p F P
0 0 0 r
s
.713 .193 .082 r
.4798 .60276 m .4596 .60276 L .45947 .58511 L p F P
0 0 0 r
s
.713 .193 .082 r
.47974 .58511 m .5 .58511 L .5 .60276 L p F P
0 0 0 r
s
.713 .193 .082 r
.5 .60276 m .4798 .60276 L .47974 .58511 L p F P
0 0 0 r
s
.713 .193 .082 r
.5 .58511 m .52026 .58511 L .5202 .60276 L p F P
0 0 0 r
s
.713 .193 .082 r
.5202 .60276 m .5 .60276 L .5 .58511 L p F P
0 0 0 r
s
.713 .193 .082 r
.52026 .58511 m .54053 .58511 L .5404 .60276 L p F P
0 0 0 r
s
.713 .193 .082 r
.5404 .60276 m .5202 .60276 L .52026 .58511 L p F P
0 0 0 r
s
.713 .193 .082 r
.54053 .58511 m .56079 .58511 L .5606 .60276 L p F P
0 0 0 r
s
.713 .193 .082 r
.5606 .60276 m .5404 .60276 L .54053 .58511 L p F P
0 0 0 r
s
.713 .193 .082 r
.56079 .58511 m .58105 .58511 L .5808 .60276 L p F P
0 0 0 r
s
.713 .193 .082 r
.5808 .60276 m .5606 .60276 L .56079 .58511 L p F P
0 0 0 r
s
.713 .193 .082 r
.58105 .58511 m .60132 .58511 L .601 .60276 L p F P
0 0 0 r
s
.713 .193 .082 r
.601 .60276 m .5808 .60276 L .58105 .58511 L p F P
0 0 0 r
s
.713 .193 .082 r
.60132 .58511 m .62158 .58511 L .62121 .60276 L p F P
0 0 0 r
s
.713 .193 .082 r
.62121 .60276 m .601 .60276 L .60132 .58511 L p F P
0 0 0 r
s
.713 .193 .082 r
.62158 .58511 m .64184 .58511 L .64141 .60276 L p F P
0 0 0 r
s
.713 .193 .082 r
.64141 .60276 m .62121 .60276 L .62158 .58511 L p F P
0 0 0 r
s
.24 .35 .67 r
.63758 .61984 m
.63865 .60276 L
s
.203 .284 .476 r
.35816 .58511 m .35669 .5737 L .35714 .59157 L p F P
0 0 0 r
s
.203 .284 .476 r
.35714 .59157 m .35859 .60276 L .35816 .58511 L p F P
0 0 0 r
s
.228 .342 .695 r
.56443 .42645 m .56473 .42056 L .58372 .43652 L p F P
0 0 0 r
s
.249 .372 .747 r
.56473 .42056 m .56443 .42645 L .54404 .41044 L p F P
0 0 0 r
s
.249 .372 .747 r
.5439 .41449 m .54404 .41044 L .56443 .42645 L p F P
0 0 0 r
s
.316 .466 .898 r
.4561 .41449 m .45596 .41044 L .43557 .42645 L p F P
0 0 0 r
s
.316 .466 .898 r
.43527 .42056 m .43557 .42645 L .45596 .41044 L p F P
0 0 0 r
s
.324 .477 .912 r
.43557 .42645 m .43527 .42056 L .41628 .43652 L p F P
0 0 0 r
s
.24 .35 .67 r
.45658 .75144 m
.45568 .73204 L
s
.45658 .75144 m
.48528 .75692 L
s
.51472 .75692 m
.54342 .75144 L
s
.54342 .75144 m
.54432 .73204 L
s
.83 .24 .1 r
.7409 .58431 m
.78105 .58431 L
s
.70075 .58431 m
.7409 .58431 L
s
.6606 .58431 m
.70075 .58431 L
s
.62045 .58431 m
.64194 .58431 L
s
.64304 .58431 m
.6606 .58431 L
s
.5803 .58431 m
.62045 .58431 L
s
.54015 .58431 m
.5803 .58431 L
s
.5 .58431 m
.54015 .58431 L
s
.45985 .58431 m
.5 .58431 L
s
.4197 .58431 m
.45985 .58431 L
s
.37955 .58431 m
.4197 .58431 L
s
.35806 .58431 m
.37955 .58431 L
s
.3394 .58431 m
.35696 .58431 L
s
.29925 .58431 m
.3394 .58431 L
s
.2591 .58431 m
.29925 .58431 L
s
.21895 .58431 m
.2591 .58431 L
s
.7409 .58431 m
.74397 .6072 L
s
.78463 .6072 m
.78105 .58431 L
s
.70075 .58431 m
.70331 .6072 L
s
.6606 .58431 m
.66265 .6072 L
s
.3394 .58431 m
.33735 .6072 L
s
.29925 .58431 m
.29669 .6072 L
s
.2591 .58431 m
.25603 .6072 L
s
.21895 .58431 m
.21537 .6072 L
s
.306 .453 .879 r
.47765 .40051 m .47761 .39843 L .4561 .41449 L p F P
0 0 0 r
s
.306 .453 .879 r
.45596 .41044 m .4561 .41449 L .47761 .39843 L p F P
0 0 0 r
s
.83 .24 .1 r
.45973 .41076 m
.45991 .41926 L
s
.266 .397 .789 r
.54404 .41044 m .5439 .41449 L .52239 .39843 L p F P
0 0 0 r
s
.266 .397 .789 r
.52235 .40051 m .52239 .39843 L .5439 .41449 L p F P
0 0 0 r
s
.83 .24 .1 r
.54009 .41926 m
.54027 .41076 L
s
.24 .35 .67 r
.59489 .70587 m
.61379 .68669 L
s
.61379 .68669 m
.61614 .66594 L
s
.38621 .68669 m
.38386 .66594 L
s
.38621 .68669 m
.40511 .70587 L
s
.62987 .64374 m
.63758 .61984 L
s
.36242 .61984 m
.37013 .64374 L
s
.096 .145 .343 r
.6371 .51137 m .63576 .52289 L .62659 .50265 L p F P
0 0 0 r
s
.096 .145 .343 r
.62659 .50265 m .62776 .49173 L .6371 .51137 L p F P
0 0 0 r
s
.24 .35 .67 r
.62692 .52624 m
.62951 .50248 L
s
.32 .464 .852 r
.37341 .50265 m .37224 .49173 L .3629 .51137 L p F P
0 0 0 r
s
.32 .464 .852 r
.3629 .51137 m .36424 .52289 L .37341 .50265 L p F P
0 0 0 r
s
.24 .35 .67 r
.37049 .50248 m
.37308 .52624 L
s
.052 .076 .18 r
.6448 .56206 m .64331 .5737 L .64046 .55444 L p F P
0 0 0 r
s
.24 .35 .67 r
.64042 .58511 m
.64196 .57301 L
s
.052 .076 .18 r
.64046 .55444 m .64189 .54283 L .6448 .56206 L p F P
0 0 0 r
s
.24 .35 .67 r
.63733 .54885 m
.64196 .57301 L
s
.26 .371 .651 r
.35954 .55444 m .35811 .54283 L .3552 .56206 L p F P
0 0 0 r
s
.26 .371 .651 r
.3552 .56206 m .35669 .5737 L .35954 .55444 L p F P
0 0 0 r
s
.24 .35 .67 r
.35804 .57301 m
.36267 .54885 L
s
.35804 .57301 m
.35958 .58511 L
s
.48528 .75692 m
.48497 .73759 L
s
.48528 .75692 m
.51472 .75692 L
s
.51472 .75692 m
.51503 .73759 L
s
.203 .306 .632 r
.60151 .4449 m .60077 .45393 L .58372 .43652 L p F P
0 0 0 r
s
.203 .306 .632 r
.58372 .43652 m .58422 .42892 L .60151 .4449 L p F P
0 0 0 r
s
.228 .342 .695 r
.58422 .42892 m .58372 .43652 L .56473 .42056 L p F P
0 0 0 r
s
.324 .477 .912 r
.41578 .42892 m .41628 .43652 L .43527 .42056 L p F P
0 0 0 r
s
.33 .484 .918 r
.41628 .43652 m .41578 .42892 L .39849 .4449 L p F P
0 0 0 r
s
.33 .484 .918 r
.39849 .4449 m .39923 .45393 L .41628 .43652 L p F P
0 0 0 r
s
.173 .262 .553 r
.61652 .46224 m .61555 .47245 L .60077 .45393 L p F P
0 0 0 r
s
.173 .262 .553 r
.60077 .45393 m .60151 .4449 L .61652 .46224 L p F P
0 0 0 r
s
.332 .486 .914 r
.39923 .45393 m .39849 .4449 L .38348 .46224 L p F P
0 0 0 r
s
.332 .486 .914 r
.38348 .46224 m .38445 .47245 L .39923 .45393 L p F P
0 0 0 r
s
.249 .372 .747 r
.54404 .41044 m .54418 .40637 L .56473 .42056 L p F P
0 0 0 r
s
.266 .397 .789 r
.54418 .40637 m .54404 .41044 L .52243 .39634 L p F P
0 0 0 r
s
.266 .397 .789 r
.52239 .39843 m .52243 .39634 L .54404 .41044 L p F P
0 0 0 r
s
.306 .453 .879 r
.47761 .39843 m .47757 .39634 L .45596 .41044 L p F P
0 0 0 r
s
.306 .453 .879 r
.45582 .40637 m .45596 .41044 L .47757 .39634 L p F P
0 0 0 r
s
.316 .466 .898 r
.45596 .41044 m .45582 .40637 L .43527 .42056 L p F P
0 0 0 r
s
.228 .342 .695 r
.56473 .42056 m .56503 .41462 L .58422 .42892 L p F P
0 0 0 r
s
.24 .35 .67 r
.56946 .4466 m
.57059 .42639 L
s
.249 .372 .747 r
.56503 .41462 m .56473 .42056 L .54418 .40637 L p F P
0 0 0 r
s
.24 .35 .67 r
.54343 .41717 m
.57059 .42639 L
s
.316 .466 .898 r
.43497 .41462 m .43527 .42056 L .45582 .40637 L p F P
0 0 0 r
s
.324 .477 .912 r
.43527 .42056 m .43497 .41462 L .41578 .42892 L p F P
0 0 0 r
s
.24 .35 .67 r
.42941 .42639 m
.45657 .41717 L
s
.42941 .42639 m
.43054 .4466 L
s
.072 .105 .259 r
.64336 .53099 m .64189 .54283 L .63576 .52289 L p F P
0 0 0 r
s
.072 .105 .259 r
.63576 .52289 m .6371 .51137 L .64336 .53099 L p F P
0 0 0 r
s
.298 .43 .775 r
.36424 .52289 m .3629 .51137 L .35664 .53099 L p F P
0 0 0 r
s
.298 .43 .775 r
.35664 .53099 m .35811 .54283 L .36424 .52289 L p F P
0 0 0 r
s
.135 .206 .453 r
.62894 .4806 m .62776 .49173 L .61555 .47245 L p F P
0 0 0 r
s
.24 .35 .67 r
.61359 .48212 m
.62951 .50248 L
s
.135 .206 .453 r
.61555 .47245 m .61652 .46224 L .62894 .4806 L p F P
0 0 0 r
s
.33 .481 .895 r
.38445 .47245 m .38348 .46224 L .37106 .4806 L p F P
0 0 0 r
s
.33 .481 .895 r
.37106 .4806 m .37224 .49173 L .38445 .47245 L p F P
0 0 0 r
s
.24 .35 .67 r
.37049 .50248 m
.38641 .48212 L
s
.295 .437 .854 r
.47761 .39843 m .47765 .40051 L .5 .38446 L closepath p F P
0 0 0 r
s
.992 .291 .124 r
.48084 .40051 m .47765 .40051 L .5 .38446 L closepath p F P
0 0 0 r
s
.992 .291 .124 r
.48403 .40051 m .48084 .40051 L .5 .38446 L closepath p F P
0 0 0 r
s
.992 .291 .124 r
.48723 .40051 m .48403 .40051 L .5 .38446 L closepath p F P
0 0 0 r
s
.992 .291 .124 r
.49042 .40051 m .48723 .40051 L .5 .38446 L closepath p F P
0 0 0 r
s
.992 .291 .124 r
.49361 .40051 m .49042 .40051 L .5 .38446 L closepath p F P
0 0 0 r
s
.992 .291 .124 r
.49681 .40051 m .49361 .40051 L .5 .38446 L closepath p F P
0 0 0 r
s
.992 .291 .124 r
.5 .40051 m .49681 .40051 L .5 .38446 L closepath p F P
0 0 0 r
s
.992 .291 .124 r
.50319 .40051 m .5 .40051 L .5 .38446 L closepath p F P
0 0 0 r
s
.992 .291 .124 r
.50639 .40051 m .50319 .40051 L .5 .38446 L closepath p F P
0 0 0 r
s
.992 .291 .124 r
.50958 .40051 m .50639 .40051 L .5 .38446 L closepath p F P
0 0 0 r
s
.992 .291 .124 r
.51277 .40051 m .50958 .40051 L .5 .38446 L closepath p F P
0 0 0 r
s
.992 .291 .124 r
.51597 .40051 m .51277 .40051 L .5 .38446 L closepath p F P
0 0 0 r
s
.992 .291 .124 r
.51916 .40051 m .51597 .40051 L .5 .38446 L closepath p F P
0 0 0 r
s
.992 .291 .124 r
.52235 .40051 m .51916 .40051 L .5 .38446 L closepath p F P
0 0 0 r
s
.281 .419 .825 r
.5 .38446 m .52239 .39843 L .52235 .40051 L closepath p F P
0 0 0 r
s
.249 .372 .747 r
.54418 .40637 m .54432 .40227 L .56503 .41462 L p F P
0 0 0 r
s
.266 .397 .789 r
.54432 .40227 m .54418 .40637 L .52246 .39425 L p F P
0 0 0 r
s
.83 .24 .1 r
.5404 .40463 m
.5404 .40426 L
s
.266 .397 .789 r
.52243 .39634 m .52246 .39425 L .54418 .40637 L p F P
0 0 0 r
s
.306 .453 .879 r
.47757 .39634 m .47754 .39425 L .45582 .40637 L p F P
0 0 0 r
s
.306 .453 .879 r
.45568 .40227 m .45582 .40637 L .47754 .39425 L p F P
0 0 0 r
s
.316 .466 .898 r
.45582 .40637 m .45568 .40227 L .43497 .41462 L p F P
0 0 0 r
s
.295 .437 .854 r
.47757 .39634 m .47761 .39843 L .5 .38446 L closepath p F P
0 0 0 r
s
.281 .419 .825 r
.5 .38446 m .52243 .39634 L .52239 .39843 L closepath p F P
0 0 0 r
s
.647 .172 .073 r
.62121 .60276 m .64141 .60276 L .63766 .61838 L p F P
0 0 0 r
s
.23 .333 .575 r
.63904 .60765 m .63766 .61838 L .64141 .60276 L p F P
0 0 0 r
s
.24 .35 .67 r
.63758 .61984 m
.63789 .61742 L
s
.23 .333 .575 r
.64141 .60276 m .64286 .59157 L .63904 .60765 L p F P
0 0 0 r
s
.647 .172 .073 r
.35859 .60276 m .37879 .60276 L .382 .61838 L p F P
0 0 0 r
s
.647 .172 .073 r
.382 .61838 m .36234 .61838 L .35859 .60276 L p F P
0 0 0 r
s
.24 .35 .67 r
.36211 .61742 m
.36242 .61984 L
s
.647 .172 .073 r
.37879 .60276 m .399 .60276 L .40167 .61838 L p F P
0 0 0 r
s
.647 .172 .073 r
.40167 .61838 m .382 .61838 L .37879 .60276 L p F P
0 0 0 r
s
.83 .24 .1 r
.37801 .6072 m
.37955 .58431 L
s
.647 .172 .073 r
.399 .60276 m .4192 .60276 L .42134 .61838 L p F P
0 0 0 r
s
.647 .172 .073 r
.42134 .61838 m .40167 .61838 L .399 .60276 L p F P
0 0 0 r
s
.647 .172 .073 r
.4192 .60276 m .4394 .60276 L .441 .61838 L p F P
0 0 0 r
s
.647 .172 .073 r
.441 .61838 m .42134 .61838 L .4192 .60276 L p F P
0 0 0 r
s
.83 .24 .1 r
.41868 .6072 m
.4197 .58431 L
s
.647 .172 .073 r
.4394 .60276 m .4596 .60276 L .46067 .61838 L p F P
0 0 0 r
s
.647 .172 .073 r
.46067 .61838 m .441 .61838 L .4394 .60276 L p F P
0 0 0 r
s
.647 .172 .073 r
.4596 .60276 m .4798 .60276 L .48033 .61838 L p F P
0 0 0 r
s
.647 .172 .073 r
.48033 .61838 m .46067 .61838 L .4596 .60276 L p F P
0 0 0 r
s
.83 .24 .1 r
.45934 .6072 m
.45985 .58431 L
s
.647 .172 .073 r
.4798 .60276 m .5 .60276 L .5 .61838 L p F P
0 0 0 r
s
.647 .172 .073 r
.5 .61838 m .48033 .61838 L .4798 .60276 L p F P
0 0 0 r
s
.647 .172 .073 r
.5 .60276 m .5202 .60276 L .51967 .61838 L p F P
0 0 0 r
s
.647 .172 .073 r
.51967 .61838 m .5 .61838 L .5 .60276 L p F P
0 0 0 r
s
.83 .24 .1 r
.5 .58431 m
.5 .6072 L
s
.647 .172 .073 r
.5202 .60276 m .5404 .60276 L .53933 .61838 L p F P
0 0 0 r
s
.647 .172 .073 r
.53933 .61838 m .51967 .61838 L .5202 .60276 L p F P
0 0 0 r
s
.647 .172 .073 r
.5404 .60276 m .5606 .60276 L .559 .61838 L p F P
0 0 0 r
s
.647 .172 .073 r
.559 .61838 m .53933 .61838 L .5404 .60276 L p F P
0 0 0 r
s
.83 .24 .1 r
.54015 .58431 m
.54066 .6072 L
s
.647 .172 .073 r
.5606 .60276 m .5808 .60276 L .57866 .61838 L p F P
0 0 0 r
s
.647 .172 .073 r
.57866 .61838 m .559 .61838 L .5606 .60276 L p F P
0 0 0 r
s
.647 .172 .073 r
.5808 .60276 m .601 .60276 L .59833 .61838 L p F P
0 0 0 r
s
.647 .172 .073 r
.59833 .61838 m .57866 .61838 L .5808 .60276 L p F P
0 0 0 r
s
.83 .24 .1 r
.5803 .58431 m
.58132 .6072 L
s
.647 .172 .073 r
.601 .60276 m .62121 .60276 L .618 .61838 L p F P
0 0 0 r
s
.647 .172 .073 r
.618 .61838 m .59833 .61838 L .601 .60276 L p F P
0 0 0 r
s
.647 .172 .073 r
.63766 .61838 m .618 .61838 L .62121 .60276 L p F P
0 0 0 r
s
.83 .24 .1 r
.62045 .58431 m
.62199 .6072 L
s
.045 .066 .152 r
.35859 .60276 m .35714 .59157 L .36096 .60765 L p F P
0 0 0 r
s
.045 .066 .152 r
.36096 .60765 m .36234 .61838 L .35859 .60276 L p F P
0 0 0 r
s
.228 .342 .695 r
.58474 .42122 m .58422 .42892 L .56503 .41462 L p F P
0 0 0 r
s
.228 .342 .695 r
.56503 .41462 m .56534 .40861 L .58474 .42122 L p F P
0 0 0 r
s
.83 .24 .1 r
.58021 .41828 m
.58116 .39591 L
s
.249 .372 .747 r
.56534 .40861 m .56503 .41462 L .54432 .40227 L p F P
0 0 0 r
s
.316 .466 .898 r
.43466 .40861 m .43497 .41462 L .45568 .40227 L p F P
0 0 0 r
s
.324 .477 .912 r
.43497 .41462 m .43466 .40861 L .41526 .42122 L p F P
0 0 0 r
s
.324 .477 .912 r
.41526 .42122 m .41578 .42892 L .43497 .41462 L p F P
0 0 0 r
s
.83 .24 .1 r
.41884 .39591 m
.41979 .41828 L
s
.24 .35 .67 r
.40511 .70587 m
.40313 .68534 L
s
.40511 .70587 m
.42862 .72127 L
s
.57138 .72127 m
.59489 .70587 L
s
.59489 .70587 m
.59687 .68534 L
s
.203 .306 .632 r
.60225 .43573 m .60151 .4449 L .58422 .42892 L p F P
0 0 0 r
s
.24 .35 .67 r
.59318 .46496 m
.59509 .43988 L
s
.203 .306 .632 r
.58422 .42892 m .58474 .42122 L .60225 .43573 L p F P
0 0 0 r
s
.24 .35 .67 r
.57059 .42639 m
.59509 .43988 L
s
.33 .484 .918 r
.41578 .42892 m .41526 .42122 L .39775 .43573 L p F P
0 0 0 r
s
.33 .484 .918 r
.39775 .43573 m .39849 .4449 L .41578 .42892 L p F P
0 0 0 r
s
.24 .35 .67 r
.40491 .43988 m
.42941 .42639 L
s
.40491 .43988 m
.40682 .46496 L
s
.028 .041 .084 r
.64434 .58015 m .64286 .59157 L .64331 .5737 L p F P
0 0 0 r
s
.028 .041 .084 r
.64331 .5737 m .6448 .56206 L .64434 .58015 L p F P
0 0 0 r
s
.203 .284 .476 r
.35669 .5737 m .3552 .56206 L .35566 .58015 L p F P
0 0 0 r
s
.203 .284 .476 r
.35566 .58015 m .35714 .59157 L .35669 .5737 L p F P
0 0 0 r
s
.281 .419 .825 r
.5 .38446 m .52246 .39425 L .52243 .39634 L closepath p F P
0 0 0 r
s
.295 .437 .854 r
.47754 .39425 m .47757 .39634 L .5 .38446 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.5 .39591 m
.5 .41926 L
s
.096 .145 .343 r
.63847 .49961 m .6371 .51137 L .62776 .49173 L p F P
0 0 0 r
s
.096 .145 .343 r
.62776 .49173 m .62894 .4806 L .63847 .49961 L p F P
0 0 0 r
s
.32 .464 .852 r
.37224 .49173 m .37106 .4806 L .36153 .49961 L p F P
0 0 0 r
s
.32 .464 .852 r
.36153 .49961 m .3629 .51137 L .37224 .49173 L p F P
0 0 0 r
s
.249 .372 .747 r
.54432 .40227 m .54446 .39815 L .56534 .40861 L p F P
0 0 0 r
s
.266 .397 .789 r
.54446 .39815 m .54432 .40227 L .5225 .39215 L p F P
0 0 0 r
s
.83 .24 .1 r
.54048 .40086 m
.54048 .40049 L
s
.266 .397 .789 r
.52246 .39425 m .5225 .39215 L .54432 .40227 L p F P
0 0 0 r
s
.83 .24 .1 r
.54055 .39708 m
.54058 .39591 L
s
.306 .453 .879 r
.47754 .39425 m .4775 .39215 L .45568 .40227 L p F P
0 0 0 r
s
.306 .453 .879 r
.45554 .39815 m .45568 .40227 L .4775 .39215 L p F P
0 0 0 r
s
.83 .24 .1 r
.45942 .39591 m
.45945 .39708 L
s
.316 .466 .898 r
.45568 .40227 m .45554 .39815 L .43466 .40861 L p F P
0 0 0 r
s
.83 .24 .1 r
.74718 .37624 m
.74348 .39591 L
s
.78406 .39591 m
.78837 .37624 L
s
.74348 .39591 m
.78406 .39591 L
s
.70598 .37624 m
.7029 .39591 L
s
.7029 .39591 m
.74348 .39591 L
s
.66478 .37624 m
.66232 .39591 L
s
.66232 .39591 m
.7029 .39591 L
s
.62359 .37624 m
.62174 .39591 L
s
.62174 .39591 m
.66232 .39591 L
s
.58116 .39591 m
.62174 .39591 L
s
.54058 .39591 m
.58116 .39591 L
s
.5 .39591 m
.5243 .39591 L
s
.53626 .39591 m
.54058 .39591 L
s
.4757 .39591 m
.5 .39591 L
s
.45942 .39591 m
.46374 .39591 L
s
.41884 .39591 m
.45942 .39591 L
s
.37641 .37624 m
.37826 .39591 L
s
.37826 .39591 m
.41884 .39591 L
s
.33522 .37624 m
.33768 .39591 L
s
.33768 .39591 m
.37826 .39591 L
s
.29402 .37624 m
.2971 .39591 L
s
.2971 .39591 m
.33768 .39591 L
s
.25282 .37624 m
.25652 .39591 L
s
.25652 .39591 m
.2971 .39591 L
s
.21163 .37624 m
.21594 .39591 L
s
.21594 .39591 m
.25652 .39591 L
s
.173 .262 .553 r
.61751 .45184 m .61652 .46224 L .60151 .4449 L p F P
0 0 0 r
s
.24 .35 .67 r
.61359 .48212 m
.61593 .45718 L
s
.173 .262 .553 r
.60151 .4449 m .60225 .43573 L .61751 .45184 L p F P
0 0 0 r
s
.332 .486 .914 r
.39849 .4449 m .39775 .43573 L .38249 .45184 L p F P
0 0 0 r
s
.332 .486 .914 r
.38249 .45184 m .38348 .46224 L .39849 .4449 L p F P
0 0 0 r
s
.24 .35 .67 r
.38407 .45718 m
.38641 .48212 L
s
.281 .419 .825 r
.5 .38446 m .5225 .39215 L .52246 .39425 L closepath p F P
0 0 0 r
s
.295 .437 .854 r
.4775 .39215 m .47754 .39425 L .5 .38446 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.61614 .66594 m
.62987 .64374 L
s
.37013 .64374 m
.38386 .66594 L
s
.052 .076 .18 r
.64632 .55017 m .6448 .56206 L .64189 .54283 L p F P
0 0 0 r
s
.052 .076 .18 r
.64189 .54283 m .64336 .53099 L .64632 .55017 L p F P
0 0 0 r
s
.26 .371 .651 r
.35811 .54283 m .35664 .53099 L .35368 .55017 L p F P
0 0 0 r
s
.26 .371 .651 r
.35368 .55017 m .3552 .56206 L .35811 .54283 L p F P
0 0 0 r
s
.83 .24 .1 r
.74397 .6072 m
.78463 .6072 L
s
.70331 .6072 m
.74397 .6072 L
s
.66265 .6072 m
.70331 .6072 L
s
.64028 .6072 m
.66265 .6072 L
s
.62199 .6072 m
.63915 .6072 L
s
.58132 .6072 m
.62199 .6072 L
s
.54066 .6072 m
.58132 .6072 L
s
.5 .6072 m
.54066 .6072 L
s
.45934 .6072 m
.5 .6072 L
s
.41868 .6072 m
.45934 .6072 L
s
.37801 .6072 m
.41868 .6072 L
s
.33735 .6072 m
.35972 .6072 L
s
.36085 .6072 m
.37801 .6072 L
s
.29669 .6072 m
.33735 .6072 L
s
.25603 .6072 m
.29669 .6072 L
s
.21537 .6072 m
.25603 .6072 L
s
.74397 .6072 m
.74777 .62625 L
s
.78906 .62625 m
.78463 .6072 L
s
.70331 .6072 m
.70647 .62625 L
s
.66265 .6072 m
.66518 .62625 L
s
.33735 .6072 m
.33482 .62625 L
s
.29669 .6072 m
.29353 .62625 L
s
.25603 .6072 m
.25223 .62625 L
s
.21537 .6072 m
.21094 .62625 L
s
.266 .397 .789 r
.5225 .39215 m .52253 .39004 L .54446 .39815 L p F P
0 0 0 r
s
.281 .419 .825 r
.5 .38446 m .52253 .39004 L .5225 .39215 L closepath p F P
0 0 0 r
s
.295 .437 .854 r
.47747 .39004 m .4775 .39215 L .5 .38446 L closepath p F P
0 0 0 r
s
.306 .453 .879 r
.4775 .39215 m .47747 .39004 L .45554 .39815 L p F P
0 0 0 r
s
.249 .372 .747 r
.56565 .40255 m .56534 .40861 L .54446 .39815 L p F P
0 0 0 r
s
.249 .372 .747 r
.54446 .39815 m .54461 .394 L .56565 .40255 L p F P
0 0 0 r
s
.266 .397 .789 r
.54461 .394 m .54446 .39815 L .52253 .39004 L p F P
0 0 0 r
s
.306 .453 .879 r
.45539 .394 m .45554 .39815 L .47747 .39004 L p F P
0 0 0 r
s
.316 .466 .898 r
.45554 .39815 m .45539 .394 L .43435 .40255 L p F P
0 0 0 r
s
.316 .466 .898 r
.43435 .40255 m .43466 .40861 L .45554 .39815 L p F P
0 0 0 r
s
.228 .342 .695 r
.58526 .41343 m .58474 .42122 L .56534 .40861 L p F P
0 0 0 r
s
.228 .342 .695 r
.56534 .40861 m .56565 .40255 L .58526 .41343 L p F P
0 0 0 r
s
.324 .477 .912 r
.43466 .40861 m .43435 .40255 L .41474 .41343 L p F P
0 0 0 r
s
.324 .477 .912 r
.41474 .41343 m .41526 .42122 L .43466 .40861 L p F P
0 0 0 r
s
.135 .206 .453 r
.63015 .46926 m .62894 .4806 L .61652 .46224 L p F P
0 0 0 r
s
.135 .206 .453 r
.61652 .46224 m .61751 .45184 L .63015 .46926 L p F P
0 0 0 r
s
.33 .481 .895 r
.38348 .46224 m .38249 .45184 L .36985 .46926 L p F P
0 0 0 r
s
.33 .481 .895 r
.36985 .46926 m .37106 .4806 L .38348 .46224 L p F P
0 0 0 r
s
.266 .397 .789 r
.52253 .39004 m .52257 .38793 L .54461 .394 L p F P
0 0 0 r
s
.281 .419 .825 r
.5 .38446 m .52257 .38793 L .52253 .39004 L closepath p F P
0 0 0 r
s
.295 .437 .854 r
.47743 .38793 m .47747 .39004 L .5 .38446 L closepath p F P
0 0 0 r
s
.306 .453 .879 r
.47747 .39004 m .47743 .38793 L .45539 .394 L p F P
0 0 0 r
s
.072 .105 .259 r
.64485 .51889 m .64336 .53099 L .6371 .51137 L p F P
0 0 0 r
s
.24 .35 .67 r
.63733 .54885 m
.64016 .52529 L
s
.072 .105 .259 r
.6371 .51137 m .63847 .49961 L .64485 .51889 L p F P
0 0 0 r
s
.24 .35 .67 r
.62951 .50248 m
.64016 .52529 L
s
.298 .43 .775 r
.3629 .51137 m .36153 .49961 L .35515 .51889 L p F P
0 0 0 r
s
.298 .43 .775 r
.35515 .51889 m .35664 .53099 L .3629 .51137 L p F P
0 0 0 r
s
.24 .35 .67 r
.35984 .52529 m
.37049 .50248 L
s
.35984 .52529 m
.36267 .54885 L
s
.203 .306 .632 r
.60301 .42642 m .60225 .43573 L .58474 .42122 L p F P
0 0 0 r
s
.203 .306 .632 r
.58474 .42122 m .58526 .41343 L .60301 .42642 L p F P
0 0 0 r
s
.33 .484 .918 r
.41526 .42122 m .41474 .41343 L .39699 .42642 L p F P
0 0 0 r
s
.33 .484 .918 r
.39699 .42642 m .39775 .43573 L .41526 .42122 L p F P
0 0 0 r
s
.24 .35 .67 r
.42862 .72127 m
.42712 .70093 L
s
.42862 .72127 m
.45568 .73204 L
s
.54432 .73204 m
.57138 .72127 L
s
.57138 .72127 m
.57288 .70093 L
s
.266 .397 .789 r
.54475 .38982 m .54461 .394 L .52257 .38793 L p F P
0 0 0 r
s
.24 .35 .67 r
.54343 .41717 m
.54432 .39087 L
s
.266 .397 .789 r
.52257 .38793 m .52261 .38581 L .54475 .38982 L p F P
0 0 0 r
s
.281 .419 .825 r
.5 .38446 m .52261 .38581 L .52257 .38793 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.51478 .40205 m
.51496 .38615 L
s
.295 .437 .854 r
.47739 .38581 m .47743 .38793 L .5 .38446 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.48504 .38615 m
.48522 .40205 L
s
.306 .453 .879 r
.47743 .38793 m .47739 .38581 L .45525 .38982 L p F P
0 0 0 r
s
.83 .24 .1 r
.45922 .38948 m
.45933 .39292 L
s
.306 .453 .879 r
.45525 .38982 m .45539 .394 L .47743 .38793 L p F P
0 0 0 r
s
.24 .35 .67 r
.45568 .39087 m
.45657 .41717 L
s
.249 .372 .747 r
.56596 .39644 m .56565 .40255 L .54461 .394 L p F P
0 0 0 r
s
.249 .372 .747 r
.54461 .394 m .54475 .38982 L .56596 .39644 L p F P
0 0 0 r
s
.316 .466 .898 r
.45539 .394 m .45525 .38982 L .43404 .39644 L p F P
0 0 0 r
s
.316 .466 .898 r
.43404 .39644 m .43435 .40255 L .45539 .394 L p F P
0 0 0 r
s
1 .296 .126 r
.5 .38446 m .52287 .37077 L .5196 .37077 L closepath p F P
0 0 0 r
s
1 .296 .126 r
.5 .38446 m .5196 .37077 L .51633 .37077 L closepath p F P
0 0 0 r
s
1 .296 .126 r
.5 .38446 m .51633 .37077 L .51307 .37077 L closepath p F P
0 0 0 r
s
1 .296 .126 r
.5 .38446 m .51307 .37077 L .5098 .37077 L closepath p F P
0 0 0 r
s
1 .296 .126 r
.5 .38446 m .5098 .37077 L .50653 .37077 L closepath p F P
0 0 0 r
s
1 .296 .126 r
.5 .38446 m .50653 .37077 L .50327 .37077 L closepath p F P
0 0 0 r
s
1 .296 .126 r
.5 .38446 m .50327 .37077 L .5 .37077 L closepath p F P
0 0 0 r
s
1 .296 .126 r
.5 .38446 m .5 .37077 L .49673 .37077 L closepath p F P
0 0 0 r
s
1 .296 .126 r
.5 .38446 m .49673 .37077 L .49347 .37077 L closepath p F P
0 0 0 r
s
1 .296 .126 r
.5 .38446 m .49347 .37077 L .4902 .37077 L closepath p F P
0 0 0 r
s
1 .296 .126 r
.5 .38446 m .4902 .37077 L .48693 .37077 L closepath p F P
0 0 0 r
s
1 .296 .126 r
.5 .38446 m .48693 .37077 L .48367 .37077 L closepath p F P
0 0 0 r
s
1 .296 .126 r
.5 .38446 m .48367 .37077 L .4804 .37077 L closepath p F P
0 0 0 r
s
1 .296 .126 r
.5 .38446 m .4804 .37077 L .47713 .37077 L closepath p F P
0 0 0 r
s
.281 .419 .825 r
.5 .38446 m .52287 .37077 L .52283 .37294 L closepath p F P
0 0 0 r
s
.281 .419 .825 r
.5 .38446 m .52283 .37294 L .52279 .3751 L closepath p F P
0 0 0 r
s
.281 .419 .825 r
.5 .38446 m .52279 .3751 L .52276 .37726 L closepath p F P
0 0 0 r
s
.281 .419 .825 r
.5 .38446 m .52276 .37726 L .52272 .37941 L closepath p F P
0 0 0 r
s
.281 .419 .825 r
.5 .38446 m .52272 .37941 L .52268 .38155 L closepath p F P
0 0 0 r
s
.281 .419 .825 r
.5 .38446 m .52268 .38155 L .52264 .38368 L closepath p F P
0 0 0 r
s
.281 .419 .825 r
.5 .38446 m .52264 .38368 L .52261 .38581 L closepath p F P
0 0 0 r
s
.295 .437 .854 r
.47736 .38368 m .47739 .38581 L .5 .38446 L closepath p F P
0 0 0 r
s
.295 .437 .854 r
.47732 .38155 m .47736 .38368 L .5 .38446 L closepath p F P
0 0 0 r
s
.295 .437 .854 r
.47728 .37941 m .47732 .38155 L .5 .38446 L closepath p F P
0 0 0 r
s
.295 .437 .854 r
.47724 .37726 m .47728 .37941 L .5 .38446 L closepath p F P
0 0 0 r
s
.295 .437 .854 r
.47721 .3751 m .47724 .37726 L .5 .38446 L closepath p F P
0 0 0 r
s
.295 .437 .854 r
.47717 .37294 m .47721 .3751 L .5 .38446 L closepath p F P
0 0 0 r
s
.295 .437 .854 r
.47713 .37077 m .47717 .37294 L .5 .38446 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.5 .37624 m
.5 .39591 L
s
.266 .397 .789 r
.54489 .38562 m .54475 .38982 L .52261 .38581 L p F P
0 0 0 r
s
.266 .397 .789 r
.52261 .38581 m .52264 .38368 L .54489 .38562 L p F P
0 0 0 r
s
.306 .453 .879 r
.47739 .38581 m .47736 .38368 L .45511 .38562 L p F P
0 0 0 r
s
.306 .453 .879 r
.45511 .38562 m .45525 .38982 L .47739 .38581 L p F P
0 0 0 r
s
.24 .35 .67 r
.51496 .38615 m
.54432 .39087 L
s
.51496 .38615 m
.48504 .38615 L
s
.45568 .39087 m
.48504 .38615 L
s
.228 .342 .695 r
.58578 .40554 m .58526 .41343 L .56565 .40255 L p F P
0 0 0 r
s
.228 .342 .695 r
.56565 .40255 m .56596 .39644 L .58578 .40554 L p F P
0 0 0 r
s
.324 .477 .912 r
.43435 .40255 m .43404 .39644 L .41422 .40554 L p F P
0 0 0 r
s
.324 .477 .912 r
.41422 .40554 m .41474 .41343 L .43435 .40255 L p F P
0 0 0 r
s
.173 .262 .553 r
.61851 .44128 m .61751 .45184 L .60225 .43573 L p F P
0 0 0 r
s
.173 .262 .553 r
.60225 .43573 m .60301 .42642 L .61851 .44128 L p F P
0 0 0 r
s
.24 .35 .67 r
.59509 .43988 m
.61593 .45718 L
s
.332 .486 .914 r
.39775 .43573 m .39699 .42642 L .38149 .44128 L p F P
0 0 0 r
s
.332 .486 .914 r
.38149 .44128 m .38249 .45184 L .39775 .43573 L p F P
0 0 0 r
s
.24 .35 .67 r
.38407 .45718 m
.40491 .43988 L
s
.23 .333 .575 r
.64045 .5967 m .63904 .60765 L .64286 .59157 L p F P
0 0 0 r
s
.23 .333 .575 r
.64286 .59157 m .64434 .58015 L .64045 .5967 L p F P
0 0 0 r
s
.24 .35 .67 r
.6405 .59645 m
.64196 .57301 L
s
.045 .066 .152 r
.35714 .59157 m .35566 .58015 L .35955 .5967 L p F P
0 0 0 r
s
.045 .066 .152 r
.35955 .5967 m .36096 .60765 L .35714 .59157 L p F P
0 0 0 r
s
.24 .35 .67 r
.35804 .57301 m
.3595 .59645 L
s
.096 .145 .343 r
.63986 .48762 m .63847 .49961 L .62894 .4806 L p F P
0 0 0 r
s
.096 .145 .343 r
.62894 .4806 m .63015 .46926 L .63986 .48762 L p F P
0 0 0 r
s
.32 .464 .852 r
.37106 .4806 m .36985 .46926 L .36014 .48762 L p F P
0 0 0 r
s
.32 .464 .852 r
.36014 .48762 m .36153 .49961 L .37106 .4806 L p F P
0 0 0 r
s
.557 .144 .061 r
.36234 .61838 m .382 .61838 L .38808 .63157 L p F P
0 0 0 r
s
.557 .144 .061 r
.38808 .63157 m .36942 .63157 L .36234 .61838 L p F P
0 0 0 r
s
.83 .24 .1 r
.37612 .62625 m
.37801 .6072 L
s
.557 .144 .061 r
.382 .61838 m .40167 .61838 L .40673 .63157 L p F P
0 0 0 r
s
.557 .144 .061 r
.40673 .63157 m .38808 .63157 L .382 .61838 L p F P
0 0 0 r
s
.557 .144 .061 r
.40167 .61838 m .42134 .61838 L .42538 .63157 L p F P
0 0 0 r
s
.557 .144 .061 r
.42538 .63157 m .40673 .63157 L .40167 .61838 L p F P
0 0 0 r
s
.83 .24 .1 r
.41741 .62625 m
.41868 .6072 L
s
.557 .144 .061 r
.42134 .61838 m .441 .61838 L .44404 .63157 L p F P
0 0 0 r
s
.557 .144 .061 r
.44404 .63157 m .42538 .63157 L .42134 .61838 L p F P
0 0 0 r
s
.557 .144 .061 r
.441 .61838 m .46067 .61838 L .46269 .63157 L p F P
0 0 0 r
s
.557 .144 .061 r
.46269 .63157 m .44404 .63157 L .441 .61838 L p F P
0 0 0 r
s
.83 .24 .1 r
.45871 .62625 m
.45934 .6072 L
s
.557 .144 .061 r
.46067 .61838 m .48033 .61838 L .48135 .63157 L p F P
0 0 0 r
s
.557 .144 .061 r
.48135 .63157 m .46269 .63157 L .46067 .61838 L p F P
0 0 0 r
s
.557 .144 .061 r
.48033 .61838 m .5 .61838 L .5 .63157 L p F P
0 0 0 r
s
.557 .144 .061 r
.5 .63157 m .48135 .63157 L .48033 .61838 L p F P
0 0 0 r
s
.557 .144 .061 r
.5 .61838 m .51967 .61838 L .51865 .63157 L p F P
0 0 0 r
s
.557 .144 .061 r
.51865 .63157 m .5 .63157 L .5 .61838 L p F P
0 0 0 r
s
.83 .24 .1 r
.5 .6072 m
.5 .62625 L
s
.557 .144 .061 r
.51967 .61838 m .53933 .61838 L .53731 .63157 L p F P
0 0 0 r
s
.557 .144 .061 r
.53731 .63157 m .51865 .63157 L .51967 .61838 L p F P
0 0 0 r
s
.557 .144 .061 r
.53933 .61838 m .559 .61838 L .55596 .63157 L p F P
0 0 0 r
s
.557 .144 .061 r
.55596 .63157 m .53731 .63157 L .53933 .61838 L p F P
0 0 0 r
s
.83 .24 .1 r
.54066 .6072 m
.54129 .62625 L
s
.557 .144 .061 r
.559 .61838 m .57866 .61838 L .57462 .63157 L p F P
0 0 0 r
s
.557 .144 .061 r
.57462 .63157 m .55596 .63157 L .559 .61838 L p F P
0 0 0 r
s
.557 .144 .061 r
.57866 .61838 m .59833 .61838 L .59327 .63157 L p F P
0 0 0 r
s
.557 .144 .061 r
.59327 .63157 m .57462 .63157 L .57866 .61838 L p F P
0 0 0 r
s
.83 .24 .1 r
.58132 .6072 m
.58259 .62625 L
s
.557 .144 .061 r
.59833 .61838 m .618 .61838 L .61192 .63157 L p F P
0 0 0 r
s
.557 .144 .061 r
.61192 .63157 m .59327 .63157 L .59833 .61838 L p F P
0 0 0 r
s
.557 .144 .061 r
.618 .61838 m .63766 .61838 L .63058 .63157 L p F P
0 0 0 r
s
.557 .144 .061 r
.63058 .63157 m .61192 .63157 L .618 .61838 L p F P
0 0 0 r
s
.83 .24 .1 r
.62199 .6072 m
.62388 .62625 L
s
.281 .411 .734 r
.63182 .62152 m .63058 .63157 L .63766 .61838 L p F P
0 0 0 r
s
.24 .35 .67 r
.62987 .64374 m
.63162 .62964 L
s
.281 .411 .734 r
.63766 .61838 m .63904 .60765 L .63182 .62152 L p F P
0 0 0 r
s
.068 .1 .244 r
.36234 .61838 m .36096 .60765 L .36818 .62152 L p F P
0 0 0 r
s
.068 .1 .244 r
.36818 .62152 m .36942 .63157 L .36234 .61838 L p F P
0 0 0 r
s
.24 .35 .67 r
.36838 .62964 m
.37013 .64374 L
s
.266 .397 .789 r
.54504 .38139 m .54489 .38562 L .52264 .38368 L p F P
0 0 0 r
s
.266 .397 .789 r
.52264 .38368 m .52268 .38155 L .54504 .38139 L p F P
0 0 0 r
s
.306 .453 .879 r
.47736 .38368 m .47732 .38155 L .45496 .38139 L p F P
0 0 0 r
s
.306 .453 .879 r
.45496 .38139 m .45511 .38562 L .47736 .38368 L p F P
0 0 0 r
s
.028 .041 .084 r
.64586 .56849 m .64434 .58015 L .6448 .56206 L p F P
0 0 0 r
s
.028 .041 .084 r
.6448 .56206 m .64632 .55017 L .64586 .56849 L p F P
0 0 0 r
s
.203 .284 .476 r
.3552 .56206 m .35368 .55017 L .35414 .56849 L p F P
0 0 0 r
s
.203 .284 .476 r
.35414 .56849 m .35566 .58015 L .3552 .56206 L p F P
0 0 0 r
s
.249 .372 .747 r
.56627 .39026 m .56596 .39644 L .54475 .38982 L p F P
0 0 0 r
s
.249 .372 .747 r
.54475 .38982 m .54489 .38562 L .56627 .39026 L p F P
0 0 0 r
s
.316 .466 .898 r
.45525 .38982 m .45511 .38562 L .43373 .39026 L p F P
0 0 0 r
s
.316 .466 .898 r
.43373 .39026 m .43404 .39644 L .45525 .38982 L p F P
0 0 0 r
s
.24 .35 .67 r
.45568 .73204 m
.45475 .71183 L
s
.45568 .73204 m
.48497 .73759 L
s
.51503 .73759 m
.54432 .73204 L
s
.54432 .73204 m
.54525 .71183 L
s
.266 .397 .789 r
.54519 .37713 m .54504 .38139 L .52268 .38155 L p F P
0 0 0 r
s
.266 .397 .789 r
.52268 .38155 m .52272 .37941 L .54519 .37713 L p F P
0 0 0 r
s
.306 .453 .879 r
.47732 .38155 m .47728 .37941 L .45481 .37713 L p F P
0 0 0 r
s
.306 .453 .879 r
.45481 .37713 m .45496 .38139 L .47732 .38155 L p F P
0 0 0 r
s
.24 .35 .67 r
.59687 .68534 m
.61614 .66594 L
s
.61614 .66594 m
.61859 .64431 L
s
.38386 .66594 m
.38141 .64431 L
s
.38386 .66594 m
.40313 .68534 L
s
.203 .306 .632 r
.60378 .41697 m .60301 .42642 L .58526 .41343 L p F P
0 0 0 r
s
.203 .306 .632 r
.58526 .41343 m .58578 .40554 L .60378 .41697 L p F P
0 0 0 r
s
.33 .484 .918 r
.41474 .41343 m .41422 .40554 L .39622 .41697 L p F P
0 0 0 r
s
.33 .484 .918 r
.39622 .41697 m .39699 .42642 L .41474 .41343 L p F P
0 0 0 r
s
.052 .076 .18 r
.64788 .53803 m .64632 .55017 L .64336 .53099 L p F P
0 0 0 r
s
.052 .076 .18 r
.64336 .53099 m .64485 .51889 L .64788 .53803 L p F P
0 0 0 r
s
.24 .35 .67 r
.64016 .52529 m
.64492 .54969 L
s
.26 .371 .651 r
.35664 .53099 m .35515 .51889 L .35212 .53803 L p F P
0 0 0 r
s
.26 .371 .651 r
.35212 .53803 m .35368 .55017 L .35664 .53099 L p F P
0 0 0 r
s
.24 .35 .67 r
.35508 .54969 m
.35984 .52529 L
s
.48497 .73759 m
.48466 .71745 L
s
.48497 .73759 m
.51503 .73759 L
s
.51503 .73759 m
.51534 .71745 L
s
.266 .397 .789 r
.54533 .37284 m .54519 .37713 L .52272 .37941 L p F P
0 0 0 r
s
.266 .397 .789 r
.52272 .37941 m .52276 .37726 L .54533 .37284 L p F P
0 0 0 r
s
.306 .453 .879 r
.47728 .37941 m .47724 .37726 L .45467 .37284 L p F P
0 0 0 r
s
.306 .453 .879 r
.45467 .37284 m .45481 .37713 L .47728 .37941 L p F P
0 0 0 r
s
.135 .206 .453 r
.63138 .45771 m .63015 .46926 L .61751 .45184 L p F P
0 0 0 r
s
.135 .206 .453 r
.61751 .45184 m .61851 .44128 L .63138 .45771 L p F P
0 0 0 r
s
.33 .481 .895 r
.38249 .45184 m .38149 .44128 L .36862 .45771 L p F P
0 0 0 r
s
.33 .481 .895 r
.36862 .45771 m .36985 .46926 L .38249 .45184 L p F P
0 0 0 r
s
.249 .372 .747 r
.56659 .38403 m .56627 .39026 L .54489 .38562 L p F P
0 0 0 r
s
.249 .372 .747 r
.54489 .38562 m .54504 .38139 L .56659 .38403 L p F P
0 0 0 r
s
.316 .466 .898 r
.45511 .38562 m .45496 .38139 L .43341 .38403 L p F P
0 0 0 r
s
.316 .466 .898 r
.43341 .38403 m .43373 .39026 L .45511 .38562 L p F P
0 0 0 r
s
.228 .342 .695 r
.58632 .39756 m .58578 .40554 L .56596 .39644 L p F P
0 0 0 r
s
.24 .35 .67 r
.57059 .42639 m
.57205 .40016 L
s
.228 .342 .695 r
.56596 .39644 m .56627 .39026 L .58632 .39756 L p F P
0 0 0 r
s
.24 .35 .67 r
.54432 .39087 m
.57205 .40016 L
s
.83 .24 .1 r
.58117 .39569 m
.58239 .37624 L
s
.324 .477 .912 r
.43404 .39644 m .43373 .39026 L .41368 .39756 L p F P
0 0 0 r
s
.83 .24 .1 r
.41761 .37624 m
.41883 .39569 L
s
.324 .477 .912 r
.41368 .39756 m .41422 .40554 L .43404 .39644 L p F P
0 0 0 r
s
.24 .35 .67 r
.42795 .40016 m
.45568 .39087 L
s
.42795 .40016 m
.42941 .42639 L
s
.266 .397 .789 r
.54548 .36853 m .54533 .37284 L .52276 .37726 L p F P
0 0 0 r
s
.266 .397 .789 r
.52276 .37726 m .52279 .3751 L .54548 .36853 L p F P
0 0 0 r
s
.306 .453 .879 r
.47724 .37726 m .47721 .3751 L .45452 .36853 L p F P
0 0 0 r
s
.306 .453 .879 r
.45452 .36853 m .45467 .37284 L .47724 .37726 L p F P
0 0 0 r
s
.072 .105 .259 r
.64638 .50655 m .64485 .51889 L .63847 .49961 L p F P
0 0 0 r
s
.072 .105 .259 r
.63847 .49961 m .63986 .48762 L .64638 .50655 L p F P
0 0 0 r
s
.298 .43 .775 r
.36153 .49961 m .36014 .48762 L .35362 .50655 L p F P
0 0 0 r
s
.298 .43 .775 r
.35362 .50655 m .35515 .51889 L .36153 .49961 L p F P
0 0 0 r
s
.83 .24 .1 r
.75151 .36117 m
.74718 .37624 L
s
.78837 .37624 m
.79343 .36117 L
s
.74718 .37624 m
.78837 .37624 L
s
.70959 .36117 m
.70598 .37624 L
s
.70598 .37624 m
.74718 .37624 L
s
.66767 .36117 m
.66478 .37624 L
s
.66478 .37624 m
.70598 .37624 L
s
.62575 .36117 m
.62359 .37624 L
s
.62359 .37624 m
.66478 .37624 L
s
.58239 .37624 m
.62359 .37624 L
s
.54522 .37624 m
.58239 .37624 L
s
.5 .37624 m
.52467 .37624 L
s
.47533 .37624 m
.5 .37624 L
s
.41761 .37624 m
.45478 .37624 L
s
.37425 .36117 m
.37641 .37624 L
s
.37641 .37624 m
.41761 .37624 L
s
.33233 .36117 m
.33522 .37624 L
s
.33522 .37624 m
.37641 .37624 L
s
.29041 .36117 m
.29402 .37624 L
s
.29402 .37624 m
.33522 .37624 L
s
.24849 .36117 m
.25282 .37624 L
s
.25282 .37624 m
.29402 .37624 L
s
.20657 .36117 m
.21163 .37624 L
s
.21163 .37624 m
.25282 .37624 L
s
.173 .262 .553 r
.61953 .43053 m .61851 .44128 L .60301 .42642 L p F P
0 0 0 r
s
.24 .35 .67 r
.61593 .45718 m
.61837 .4312 L
s
.173 .262 .553 r
.60301 .42642 m .60378 .41697 L .61953 .43053 L p F P
0 0 0 r
s
.332 .486 .914 r
.39699 .42642 m .39622 .41697 L .38047 .43053 L p F P
0 0 0 r
s
.332 .486 .914 r
.38047 .43053 m .38149 .44128 L .39699 .42642 L p F P
0 0 0 r
s
.24 .35 .67 r
.38163 .4312 m
.38407 .45718 L
s
.266 .397 .789 r
.54563 .36418 m .54548 .36853 L .52279 .3751 L p F P
0 0 0 r
s
.266 .397 .789 r
.52279 .3751 m .52283 .37294 L .54563 .36418 L p F P
0 0 0 r
s
.306 .453 .879 r
.47721 .3751 m .47717 .37294 L .45437 .36418 L p F P
0 0 0 r
s
.306 .453 .879 r
.45437 .36418 m .45452 .36853 L .47721 .3751 L p F P
0 0 0 r
s
.249 .372 .747 r
.56691 .37774 m .56659 .38403 L .54504 .38139 L p F P
0 0 0 r
s
.249 .372 .747 r
.54504 .38139 m .54519 .37713 L .56691 .37774 L p F P
0 0 0 r
s
.316 .466 .898 r
.45496 .38139 m .45481 .37713 L .43309 .37774 L p F P
0 0 0 r
s
.316 .466 .898 r
.43309 .37774 m .43341 .38403 L .45496 .38139 L p F P
0 0 0 r
s
.203 .306 .632 r
.60456 .40739 m .60378 .41697 L .58578 .40554 L p F P
0 0 0 r
s
.24 .35 .67 r
.59509 .43988 m
.59707 .41375 L
s
.203 .306 .632 r
.58578 .40554 m .58632 .39756 L .60456 .40739 L p F P
0 0 0 r
s
.24 .35 .67 r
.57205 .40016 m
.59707 .41375 L
s
.33 .484 .918 r
.41422 .40554 m .41368 .39756 L .39544 .40739 L p F P
0 0 0 r
s
.33 .484 .918 r
.39544 .40739 m .39622 .41697 L .41422 .40554 L p F P
0 0 0 r
s
.24 .35 .67 r
.40293 .41375 m
.42795 .40016 L
s
.40293 .41375 m
.40491 .43988 L
s
.266 .397 .789 r
.54578 .35981 m .54563 .36418 L .52283 .37294 L p F P
0 0 0 r
s
.266 .397 .789 r
.52283 .37294 m .52287 .37077 L .54578 .35981 L p F P
0 0 0 r
s
.306 .453 .879 r
.47717 .37294 m .47713 .37077 L .45422 .35981 L p F P
0 0 0 r
s
.306 .453 .879 r
.45422 .35981 m .45437 .36418 L .47717 .37294 L p F P
0 0 0 r
s
.228 .342 .695 r
.58686 .38947 m .58632 .39756 L .56627 .39026 L p F P
0 0 0 r
s
.228 .342 .695 r
.56627 .39026 m .56659 .38403 L .58686 .38947 L p F P
0 0 0 r
s
.324 .477 .912 r
.43373 .39026 m .43341 .38403 L .41314 .38947 L p F P
0 0 0 r
s
.324 .477 .912 r
.41314 .38947 m .41368 .39756 L .43373 .39026 L p F P
0 0 0 r
s
.83 .24 .1 r
.74777 .62625 m
.78906 .62625 L
s
.70647 .62625 m
.74777 .62625 L
s
.66518 .62625 m
.70647 .62625 L
s
.63318 .62625 m
.66518 .62625 L
s
.62388 .62625 m
.63123 .62625 L
s
.58259 .62625 m
.62388 .62625 L
s
.54129 .62625 m
.58259 .62625 L
s
.5 .62625 m
.54129 .62625 L
s
.45871 .62625 m
.5 .62625 L
s
.41741 .62625 m
.45871 .62625 L
s
.37612 .62625 m
.41741 .62625 L
s
.33482 .62625 m
.36682 .62625 L
s
.36877 .62625 m
.37612 .62625 L
s
.29353 .62625 m
.33482 .62625 L
s
.25223 .62625 m
.29353 .62625 L
s
.21094 .62625 m
.25223 .62625 L
s
.74777 .62625 m
.75218 .64058 L
s
.79421 .64058 m
.78906 .62625 L
s
.70647 .62625 m
.71015 .64058 L
s
.66518 .62625 m
.66812 .64058 L
s
.33482 .62625 m
.33188 .64058 L
s
.29353 .62625 m
.28985 .64058 L
s
.25223 .62625 m
.24782 .64058 L
s
.21094 .62625 m
.20579 .64058 L
s
.096 .145 .343 r
.64129 .47539 m .63986 .48762 L .63015 .46926 L p F P
0 0 0 r
s
.24 .35 .67 r
.62951 .50248 m
.63221 .47772 L
s
.096 .145 .343 r
.63015 .46926 m .63138 .45771 L .64129 .47539 L p F P
0 0 0 r
s
.24 .35 .67 r
.61593 .45718 m
.63221 .47772 L
s
.32 .464 .852 r
.36985 .46926 m .36862 .45771 L .35871 .47539 L p F P
0 0 0 r
s
.32 .464 .852 r
.35871 .47539 m .36014 .48762 L .36985 .46926 L p F P
0 0 0 r
s
.24 .35 .67 r
.36779 .47772 m
.38407 .45718 L
s
.36779 .47772 m
.37049 .50248 L
s
.23 .333 .575 r
.64188 .58552 m .64045 .5967 L .64434 .58015 L p F P
0 0 0 r
s
.23 .333 .575 r
.64434 .58015 m .64586 .56849 L .64188 .58552 L p F P
0 0 0 r
s
.24 .35 .67 r
.64196 .57301 m
.64492 .54969 L
s
.045 .066 .152 r
.35566 .58015 m .35414 .56849 L .35812 .58552 L p F P
0 0 0 r
s
.24 .35 .67 r
.35508 .54969 m
.35804 .57301 L
s
.045 .066 .152 r
.35812 .58552 m .35955 .5967 L .35566 .58015 L p F P
0 0 0 r
s
.992 .297 .127 r
.54578 .35981 m .53924 .35981 L .5196 .37077 L p F P
0 0 0 r
s
.992 .297 .127 r
.5196 .37077 m .52287 .37077 L .54578 .35981 L p F P
0 0 0 r
s
.83 .24 .1 r
.54165 .36676 m
.54192 .36117 L
s
.992 .297 .127 r
.53924 .35981 m .5327 .35981 L .51633 .37077 L p F P
0 0 0 r
s
.992 .297 .127 r
.51633 .37077 m .5196 .37077 L .53924 .35981 L p F P
0 0 0 r
s
.992 .297 .127 r
.5327 .35981 m .52616 .35981 L .51307 .37077 L p F P
0 0 0 r
s
.992 .297 .127 r
.51307 .37077 m .51633 .37077 L .5327 .35981 L p F P
0 0 0 r
s
.992 .297 .127 r
.52616 .35981 m .51962 .35981 L .5098 .37077 L p F P
0 0 0 r
s
.992 .297 .127 r
.5098 .37077 m .51307 .37077 L .52616 .35981 L p F P
0 0 0 r
s
.992 .297 .127 r
.51962 .35981 m .51308 .35981 L .50653 .37077 L p F P
0 0 0 r
s
.992 .297 .127 r
.50653 .37077 m .5098 .37077 L .51962 .35981 L p F P
0 0 0 r
s
.24 .35 .67 r
.51496 .38615 m
.51514 .36985 L
s
.51526 .35981 m
.51527 .35871 L
s
.992 .297 .127 r
.51308 .35981 m .50654 .35981 L .50327 .37077 L p F P
0 0 0 r
s
.992 .297 .127 r
.50327 .37077 m .50653 .37077 L .51308 .35981 L p F P
0 0 0 r
s
.992 .297 .127 r
.50654 .35981 m .5 .35981 L .5 .37077 L p F P
0 0 0 r
s
.992 .297 .127 r
.5 .37077 m .50327 .37077 L .50654 .35981 L p F P
0 0 0 r
s
.992 .297 .127 r
.5 .35981 m .49346 .35981 L .49673 .37077 L p F P
0 0 0 r
s
.992 .297 .127 r
.49673 .37077 m .5 .37077 L .5 .35981 L p F P
0 0 0 r
s
.83 .24 .1 r
.5 .36117 m
.5 .37624 L
s
.992 .297 .127 r
.49346 .35981 m .48692 .35981 L .49347 .37077 L p F P
0 0 0 r
s
.992 .297 .127 r
.49347 .37077 m .49673 .37077 L .49346 .35981 L p F P
0 0 0 r
s
.992 .297 .127 r
.48692 .35981 m .48038 .35981 L .4902 .37077 L p F P
0 0 0 r
s
.992 .297 .127 r
.4902 .37077 m .49347 .37077 L .48692 .35981 L p F P
0 0 0 r
s
.992 .297 .127 r
.48038 .35981 m .47384 .35981 L .48693 .37077 L p F P
0 0 0 r
s
.992 .297 .127 r
.48693 .37077 m .4902 .37077 L .48038 .35981 L p F P
0 0 0 r
s
.992 .297 .127 r
.47384 .35981 m .4673 .35981 L .48367 .37077 L p F P
0 0 0 r
s
.992 .297 .127 r
.48367 .37077 m .48693 .37077 L .47384 .35981 L p F P
0 0 0 r
s
.24 .35 .67 r
.48486 .36985 m
.48504 .38615 L
s
.48473 .35871 m
.48474 .35981 L
s
.992 .297 .127 r
.4673 .35981 m .46076 .35981 L .4804 .37077 L p F P
0 0 0 r
s
.992 .297 .127 r
.4804 .37077 m .48367 .37077 L .4673 .35981 L p F P
0 0 0 r
s
.992 .297 .127 r
.46076 .35981 m .45422 .35981 L .47713 .37077 L p F P
0 0 0 r
s
.83 .24 .1 r
.45808 .36117 m
.45835 .36676 L
s
.992 .297 .127 r
.47713 .37077 m .4804 .37077 L .46076 .35981 L p F P
0 0 0 r
s
.281 .411 .734 r
.63308 .61128 m .63182 .62152 L .63904 .60765 L p F P
0 0 0 r
s
.24 .35 .67 r
.63674 .60905 m
.64024 .59827 L
s
.281 .411 .734 r
.63904 .60765 m .64045 .5967 L .63308 .61128 L p F P
0 0 0 r
s
.068 .1 .244 r
.36096 .60765 m .35955 .5967 L .36692 .61128 L p F P
0 0 0 r
s
.068 .1 .244 r
.36692 .61128 m .36818 .62152 L .36096 .60765 L p F P
0 0 0 r
s
.249 .372 .747 r
.56724 .37138 m .56691 .37774 L .54519 .37713 L p F P
0 0 0 r
s
.249 .372 .747 r
.54519 .37713 m .54533 .37284 L .56724 .37138 L p F P
0 0 0 r
s
.24 .35 .67 r
.54432 .39087 m
.54526 .36346 L
s
.316 .466 .898 r
.45481 .37713 m .45467 .37284 L .43276 .37138 L p F P
0 0 0 r
s
.316 .466 .898 r
.43276 .37138 m .43309 .37774 L .45481 .37713 L p F P
0 0 0 r
s
.24 .35 .67 r
.45474 .36346 m
.45568 .39087 L
s
.40313 .68534 m
.40107 .66394 L
s
.40313 .68534 m
.42712 .70093 L
s
.57288 .70093 m
.59687 .68534 L
s
.59687 .68534 m
.59893 .66394 L
s
.028 .041 .084 r
.64741 .55658 m .64586 .56849 L .64632 .55017 L p F P
0 0 0 r
s
.028 .041 .084 r
.64632 .55017 m .64788 .53803 L .64741 .55658 L p F P
0 0 0 r
s
.203 .284 .476 r
.35368 .55017 m .35212 .53803 L .35259 .55658 L p F P
0 0 0 r
s
.203 .284 .476 r
.35259 .55658 m .35414 .56849 L .35368 .55017 L p F P
0 0 0 r
s
.135 .206 .453 r
.63263 .44594 m .63138 .45771 L .61851 .44128 L p F P
0 0 0 r
s
.135 .206 .453 r
.61851 .44128 m .61953 .43053 L .63263 .44594 L p F P
0 0 0 r
s
.33 .481 .895 r
.38149 .44128 m .38047 .43053 L .36737 .44594 L p F P
0 0 0 r
s
.33 .481 .895 r
.36737 .44594 m .36862 .45771 L .38149 .44128 L p F P
0 0 0 r
s
.428 .104 .044 r
.61192 .63157 m .63058 .63157 L .62018 .64196 L p F P
0 0 0 r
s
.313 .46 .84 r
.62123 .63281 m .62018 .64196 L .63058 .63157 L p F P
0 0 0 r
s
.83 .24 .1 r
.62536 .63583 m
.62609 .64058 L
s
.313 .46 .84 r
.63058 .63157 m .63182 .62152 L .62123 .63281 L p F P
0 0 0 r
s
.83 .24 .1 r
.62388 .62625 m
.62438 .62945 L
s
.428 .104 .044 r
.36942 .63157 m .38808 .63157 L .39699 .64196 L p F P
0 0 0 r
s
.428 .104 .044 r
.39699 .64196 m .37982 .64196 L .36942 .63157 L p F P
0 0 0 r
s
.428 .104 .044 r
.38808 .63157 m .40673 .63157 L .41416 .64196 L p F P
0 0 0 r
s
.428 .104 .044 r
.41416 .64196 m .39699 .64196 L .38808 .63157 L p F P
0 0 0 r
s
.428 .104 .044 r
.40673 .63157 m .42538 .63157 L .43133 .64196 L p F P
0 0 0 r
s
.428 .104 .044 r
.43133 .64196 m .41416 .64196 L .40673 .63157 L p F P
0 0 0 r
s
.83 .24 .1 r
.41594 .64058 m
.41741 .62625 L
s
.428 .104 .044 r
.42538 .63157 m .44404 .63157 L .44849 .64196 L p F P
0 0 0 r
s
.428 .104 .044 r
.44849 .64196 m .43133 .64196 L .42538 .63157 L p F P
0 0 0 r
s
.428 .104 .044 r
.44404 .63157 m .46269 .63157 L .46566 .64196 L p F P
0 0 0 r
s
.428 .104 .044 r
.46566 .64196 m .44849 .64196 L .44404 .63157 L p F P
0 0 0 r
s
.83 .24 .1 r
.45797 .64058 m
.45871 .62625 L
s
.428 .104 .044 r
.46269 .63157 m .48135 .63157 L .48283 .64196 L p F P
0 0 0 r
s
.428 .104 .044 r
.48283 .64196 m .46566 .64196 L .46269 .63157 L p F P
0 0 0 r
s
.428 .104 .044 r
.48135 .63157 m .5 .63157 L .5 .64196 L p F P
0 0 0 r
s
.428 .104 .044 r
.5 .64196 m .48283 .64196 L .48135 .63157 L p F P
0 0 0 r
s
.428 .104 .044 r
.5 .63157 m .51865 .63157 L .51717 .64196 L p F P
0 0 0 r
s
.428 .104 .044 r
.51717 .64196 m .5 .64196 L .5 .63157 L p F P
0 0 0 r
s
.83 .24 .1 r
.5 .62625 m
.5 .64058 L
s
.428 .104 .044 r
.51865 .63157 m .53731 .63157 L .53434 .64196 L p F P
0 0 0 r
s
.428 .104 .044 r
.53434 .64196 m .51717 .64196 L .51865 .63157 L p F P
0 0 0 r
s
.428 .104 .044 r
.53731 .63157 m .55596 .63157 L .55151 .64196 L p F P
0 0 0 r
s
.428 .104 .044 r
.55151 .64196 m .53434 .64196 L .53731 .63157 L p F P
0 0 0 r
s
.83 .24 .1 r
.54129 .62625 m
.54203 .64058 L
s
.428 .104 .044 r
.55596 .63157 m .57462 .63157 L .56867 .64196 L p F P
0 0 0 r
s
.428 .104 .044 r
.56867 .64196 m .55151 .64196 L .55596 .63157 L p F P
0 0 0 r
s
.428 .104 .044 r
.57462 .63157 m .59327 .63157 L .58584 .64196 L p F P
0 0 0 r
s
.428 .104 .044 r
.58584 .64196 m .56867 .64196 L .57462 .63157 L p F P
0 0 0 r
s
.83 .24 .1 r
.58259 .62625 m
.58406 .64058 L
s
.428 .104 .044 r
.59327 .63157 m .61192 .63157 L .60301 .64196 L p F P
0 0 0 r
s
.428 .104 .044 r
.60301 .64196 m .58584 .64196 L .59327 .63157 L p F P
0 0 0 r
s
.428 .104 .044 r
.62018 .64196 m .60301 .64196 L .61192 .63157 L p F P
0 0 0 r
s
.092 .138 .333 r
.36942 .63157 m .36818 .62152 L .37877 .63281 L p F P
0 0 0 r
s
.83 .24 .1 r
.37562 .62945 m
.37612 .62625 L
s
.092 .138 .333 r
.37877 .63281 m .37982 .64196 L .36942 .63157 L p F P
0 0 0 r
s
.83 .24 .1 r
.37391 .64058 m
.37464 .63583 L
s
.24 .35 .67 r
.61859 .64431 m
.62005 .64196 L
s
.37995 .64196 m
.38141 .64431 L
s
.052 .076 .18 r
.64947 .52562 m .64788 .53803 L .64485 .51889 L p F P
0 0 0 r
s
.052 .076 .18 r
.64485 .51889 m .64638 .50655 L .64947 .52562 L p F P
0 0 0 r
s
.26 .371 .651 r
.35515 .51889 m .35362 .50655 L .35053 .52562 L p F P
0 0 0 r
s
.26 .371 .651 r
.35053 .52562 m .35212 .53803 L .35515 .51889 L p F P
0 0 0 r
s
.228 .342 .695 r
.5874 .38129 m .58686 .38947 L .56659 .38403 L p F P
0 0 0 r
s
.228 .342 .695 r
.56659 .38403 m .56691 .37774 L .5874 .38129 L p F P
0 0 0 r
s
.324 .477 .912 r
.43341 .38403 m .43309 .37774 L .4126 .38129 L p F P
0 0 0 r
s
.324 .477 .912 r
.4126 .38129 m .41314 .38947 L .43341 .38403 L p F P
0 0 0 r
s
.249 .372 .747 r
.56756 .36497 m .56724 .37138 L .54533 .37284 L p F P
0 0 0 r
s
.249 .372 .747 r
.54533 .37284 m .54548 .36853 L .56756 .36497 L p F P
0 0 0 r
s
.316 .466 .898 r
.45467 .37284 m .45452 .36853 L .43244 .36497 L p F P
0 0 0 r
s
.316 .466 .898 r
.43244 .36497 m .43276 .37138 L .45467 .37284 L p F P
0 0 0 r
s
.173 .262 .553 r
.62057 .41959 m .61953 .43053 L .60378 .41697 L p F P
0 0 0 r
s
.173 .262 .553 r
.60378 .41697 m .60456 .40739 L .62057 .41959 L p F P
0 0 0 r
s
.24 .35 .67 r
.59707 .41375 m
.61837 .4312 L
s
.332 .486 .914 r
.39622 .41697 m .39544 .40739 L .37943 .41959 L p F P
0 0 0 r
s
.332 .486 .914 r
.37943 .41959 m .38047 .43053 L .39622 .41697 L p F P
0 0 0 r
s
.24 .35 .67 r
.38163 .4312 m
.40293 .41375 L
s
.203 .306 .632 r
.60536 .39766 m .60456 .40739 L .58632 .39756 L p F P
0 0 0 r
s
.203 .306 .632 r
.58632 .39756 m .58686 .38947 L .60536 .39766 L p F P
0 0 0 r
s
.33 .484 .918 r
.41368 .39756 m .41314 .38947 L .39464 .39766 L p F P
0 0 0 r
s
.33 .484 .918 r
.39464 .39766 m .39544 .40739 L .41368 .39756 L p F P
0 0 0 r
s
.072 .105 .259 r
.64794 .49394 m .64638 .50655 L .63986 .48762 L p F P
0 0 0 r
s
.24 .35 .67 r
.64016 .52529 m
.64311 .50075 L
s
.072 .105 .259 r
.63986 .48762 m .64129 .47539 L .64794 .49394 L p F P
0 0 0 r
s
.24 .35 .67 r
.63221 .47772 m
.64311 .50075 L
s
.298 .43 .775 r
.36014 .48762 m .35871 .47539 L .35206 .49394 L p F P
0 0 0 r
s
.298 .43 .775 r
.35206 .49394 m .35362 .50655 L .36014 .48762 L p F P
0 0 0 r
s
.24 .35 .67 r
.35689 .50075 m
.36779 .47772 L
s
.35689 .50075 m
.35984 .52529 L
s
.249 .372 .747 r
.56789 .35849 m .56756 .36497 L .54548 .36853 L p F P
0 0 0 r
s
.249 .372 .747 r
.54548 .36853 m .54563 .36418 L .56789 .35849 L p F P
0 0 0 r
s
.316 .466 .898 r
.45452 .36853 m .45437 .36418 L .43211 .35849 L p F P
0 0 0 r
s
.316 .466 .898 r
.43211 .35849 m .43244 .36497 L .45452 .36853 L p F P
0 0 0 r
s
.24 .35 .67 r
.42712 .70093 m
.42556 .67971 L
s
.42712 .70093 m
.45475 .71183 L
s
.54525 .71183 m
.57288 .70093 L
s
.57288 .70093 m
.57444 .67971 L
s
.228 .342 .695 r
.58796 .37299 m .5874 .38129 L .56691 .37774 L p F P
0 0 0 r
s
.228 .342 .695 r
.56691 .37774 m .56724 .37138 L .58796 .37299 L p F P
0 0 0 r
s
.324 .477 .912 r
.43309 .37774 m .43276 .37138 L .41204 .37299 L p F P
0 0 0 r
s
.83 .24 .1 r
.41741 .3742 m
.41761 .37624 L
s
.324 .477 .912 r
.41204 .37299 m .4126 .38129 L .43309 .37774 L p F P
0 0 0 r
s
.096 .145 .343 r
.64274 .4629 m .64129 .47539 L .63138 .45771 L p F P
0 0 0 r
s
.096 .145 .343 r
.63138 .45771 m .63263 .44594 L .64274 .4629 L p F P
0 0 0 r
s
.32 .464 .852 r
.36862 .45771 m .36737 .44594 L .35726 .4629 L p F P
0 0 0 r
s
.32 .464 .852 r
.35726 .4629 m .35871 .47539 L .36862 .45771 L p F P
0 0 0 r
s
.24 .35 .67 r
.53424 .36171 m
.54526 .36346 L
s
.51527 .35871 m
.52225 .35981 L
s
.51527 .35871 m
.48473 .35871 L
s
.45474 .36346 m
.46576 .36171 L
s
.47775 .35981 m
.48473 .35871 L
s
.249 .372 .747 r
.56823 .35194 m .56789 .35849 L .54563 .36418 L p F P
0 0 0 r
s
.249 .372 .747 r
.54563 .36418 m .54578 .35981 L .56823 .35194 L p F P
0 0 0 r
s
.316 .466 .898 r
.45437 .36418 m .45422 .35981 L .43177 .35194 L p F P
0 0 0 r
s
.316 .466 .898 r
.43177 .35194 m .43211 .35849 L .45437 .36418 L p F P
0 0 0 r
s
.281 .411 .734 r
.63437 .60084 m .63308 .61128 L .64045 .5967 L p F P
0 0 0 r
s
.281 .411 .734 r
.64045 .5967 m .64188 .58552 L .63437 .60084 L p F P
0 0 0 r
s
.068 .1 .244 r
.35955 .5967 m .35812 .58552 L .36563 .60084 L p F P
0 0 0 r
s
.068 .1 .244 r
.36563 .60084 m .36692 .61128 L .35955 .5967 L p F P
0 0 0 r
s
.23 .333 .575 r
.64334 .57412 m .64188 .58552 L .64586 .56849 L p F P
0 0 0 r
s
.23 .333 .575 r
.64586 .56849 m .64741 .55658 L .64334 .57412 L p F P
0 0 0 r
s
.24 .35 .67 r
.64345 .57367 m
.64492 .54969 L
s
.045 .066 .152 r
.35414 .56849 m .35259 .55658 L .35666 .57412 L p F P
0 0 0 r
s
.045 .066 .152 r
.35666 .57412 m .35812 .58552 L .35414 .56849 L p F P
0 0 0 r
s
.24 .35 .67 r
.35508 .54969 m
.35655 .57367 L
s
.135 .206 .453 r
.63391 .43394 m .63263 .44594 L .61953 .43053 L p F P
0 0 0 r
s
.135 .206 .453 r
.61953 .43053 m .62057 .41959 L .63391 .43394 L p F P
0 0 0 r
s
.33 .481 .895 r
.38047 .43053 m .37943 .41959 L .36609 .43394 L p F P
0 0 0 r
s
.33 .481 .895 r
.36609 .43394 m .36737 .44594 L .38047 .43053 L p F P
0 0 0 r
s
.203 .306 .632 r
.60616 .38777 m .60536 .39766 L .58686 .38947 L p F P
0 0 0 r
s
.203 .306 .632 r
.58686 .38947 m .5874 .38129 L .60616 .38777 L p F P
0 0 0 r
s
.33 .484 .918 r
.41314 .38947 m .4126 .38129 L .39384 .38777 L p F P
0 0 0 r
s
.33 .484 .918 r
.39384 .38777 m .39464 .39766 L .41314 .38947 L p F P
0 0 0 r
s
.173 .262 .553 r
.62162 .40846 m .62057 .41959 L .60456 .40739 L p F P
0 0 0 r
s
.173 .262 .553 r
.60456 .40739 m .60536 .39766 L .62162 .40846 L p F P
0 0 0 r
s
.332 .486 .914 r
.39544 .40739 m .39464 .39766 L .37838 .40846 L p F P
0 0 0 r
s
.332 .486 .914 r
.37838 .40846 m .37943 .41959 L .39544 .40739 L p F P
0 0 0 r
s
.028 .041 .084 r
.64899 .54442 m .64741 .55658 L .64788 .53803 L p F P
0 0 0 r
s
.028 .041 .084 r
.64788 .53803 m .64947 .52562 L .64899 .54442 L p F P
0 0 0 r
s
.203 .284 .476 r
.35212 .53803 m .35053 .52562 L .35101 .54442 L p F P
0 0 0 r
s
.203 .284 .476 r
.35101 .54442 m .35259 .55658 L .35212 .53803 L p F P
0 0 0 r
s
.24 .35 .67 r
.45475 .71183 m
.45377 .69075 L
s
.45475 .71183 m
.48466 .71745 L
s
.51534 .71745 m
.54525 .71183 L
s
.54525 .71183 m
.54623 .69075 L
s
.313 .46 .84 r
.6223 .62349 m .62123 .63281 L .63182 .62152 L p F P
0 0 0 r
s
.313 .46 .84 r
.63182 .62152 m .63308 .61128 L .6223 .62349 L p F P
0 0 0 r
s
.092 .138 .333 r
.36818 .62152 m .36692 .61128 L .3777 .62349 L p F P
0 0 0 r
s
.092 .138 .333 r
.3777 .62349 m .37877 .63281 L .36818 .62152 L p F P
0 0 0 r
s
.24 .35 .67 r
.61859 .64431 m
.61885 .64196 L
s
.38115 .64196 m
.38141 .64431 L
s
.228 .342 .695 r
.58852 .3646 m .58796 .37299 L .56724 .37138 L p F P
0 0 0 r
s
.24 .35 .67 r
.57205 .40016 m
.57358 .37282 L
s
.228 .342 .695 r
.56724 .37138 m .56756 .36497 L .58852 .3646 L p F P
0 0 0 r
s
.83 .24 .1 r
.5835 .36469 m
.58384 .36117 L
s
.24 .35 .67 r
.54526 .36346 m
.57358 .37282 L
s
.324 .477 .912 r
.43276 .37138 m .43244 .36497 L .41148 .3646 L p F P
0 0 0 r
s
.83 .24 .1 r
.41665 .36625 m
.41726 .37259 L
s
.324 .477 .912 r
.41148 .3646 m .41204 .37299 L .43276 .37138 L p F P
0 0 0 r
s
.83 .24 .1 r
.41616 .36117 m
.4165 .36469 L
s
.24 .35 .67 r
.42642 .37282 m
.45474 .36346 L
s
.42642 .37282 m
.42795 .40016 L
s
.949 .289 .124 r
.56823 .35194 m .55848 .35194 L .53924 .35981 L p F P
0 0 0 r
s
.949 .289 .124 r
.53924 .35981 m .54578 .35981 L .56823 .35194 L p F P
0 0 0 r
s
.949 .289 .124 r
.55848 .35194 m .54873 .35194 L .5327 .35981 L p F P
0 0 0 r
s
.949 .289 .124 r
.5327 .35981 m .53924 .35981 L .55848 .35194 L p F P
0 0 0 r
s
.949 .289 .124 r
.54873 .35194 m .53899 .35194 L .52616 .35981 L p F P
0 0 0 r
s
.949 .289 .124 r
.52616 .35981 m .5327 .35981 L .54873 .35194 L p F P
0 0 0 r
s
.24 .35 .67 r
.54526 .36346 m
.54543 .35858 L
s
.949 .289 .124 r
.53899 .35194 m .52924 .35194 L .51962 .35981 L p F P
0 0 0 r
s
.949 .289 .124 r
.51962 .35981 m .52616 .35981 L .53899 .35194 L p F P
0 0 0 r
s
.949 .289 .124 r
.52924 .35194 m .51949 .35194 L .51308 .35981 L p F P
0 0 0 r
s
.949 .289 .124 r
.51308 .35981 m .51962 .35981 L .52924 .35194 L p F P
0 0 0 r
s
.949 .289 .124 r
.51949 .35194 m .50975 .35194 L .50654 .35981 L p F P
0 0 0 r
s
.24 .35 .67 r
.51529 .3571 m
.51532 .35448 L
s
.949 .289 .124 r
.50654 .35981 m .51308 .35981 L .51949 .35194 L p F P
0 0 0 r
s
.949 .289 .124 r
.50975 .35194 m .5 .35194 L .5 .35981 L p F P
0 0 0 r
s
.949 .289 .124 r
.5 .35981 m .50654 .35981 L .50975 .35194 L p F P
0 0 0 r
s
.949 .289 .124 r
.5 .35194 m .49025 .35194 L .49346 .35981 L p F P
0 0 0 r
s
.949 .289 .124 r
.49346 .35981 m .5 .35981 L .5 .35194 L p F P
0 0 0 r
s
.949 .289 .124 r
.49025 .35194 m .48051 .35194 L .48692 .35981 L p F P
0 0 0 r
s
.24 .35 .67 r
.48471 .3571 m
.48473 .35871 L
s
.949 .289 .124 r
.48692 .35981 m .49346 .35981 L .49025 .35194 L p F P
0 0 0 r
s
.949 .289 .124 r
.48051 .35194 m .47076 .35194 L .48038 .35981 L p F P
0 0 0 r
s
.949 .289 .124 r
.48038 .35981 m .48692 .35981 L .48051 .35194 L p F P
0 0 0 r
s
.949 .289 .124 r
.47076 .35194 m .46101 .35194 L .47384 .35981 L p F P
0 0 0 r
s
.949 .289 .124 r
.47384 .35981 m .48038 .35981 L .47076 .35194 L p F P
0 0 0 r
s
.949 .289 .124 r
.46101 .35194 m .45127 .35194 L .4673 .35981 L p F P
0 0 0 r
s
.949 .289 .124 r
.4673 .35981 m .47384 .35981 L .46101 .35194 L p F P
0 0 0 r
s
.949 .289 .124 r
.45127 .35194 m .44152 .35194 L .46076 .35981 L p F P
0 0 0 r
s
.949 .289 .124 r
.46076 .35981 m .4673 .35981 L .45127 .35194 L p F P
0 0 0 r
s
.949 .289 .124 r
.44152 .35194 m .43177 .35194 L .45422 .35981 L p F P
0 0 0 r
s
.949 .289 .124 r
.45422 .35981 m .46076 .35981 L .44152 .35194 L p F P
0 0 0 r
s
.24 .35 .67 r
.45457 .35858 m
.45474 .36346 L
s
.83 .24 .1 r
.75633 .35155 m
.75151 .36117 L
s
.79343 .36117 m
.79906 .35155 L
s
.75151 .36117 m
.79343 .36117 L
s
.71361 .35155 m
.70959 .36117 L
s
.70959 .36117 m
.75151 .36117 L
s
.67089 .35155 m
.66767 .36117 L
s
.66767 .36117 m
.70959 .36117 L
s
.62817 .35155 m
.62575 .36117 L
s
.62575 .36117 m
.66767 .36117 L
s
.58384 .36117 m
.62575 .36117 L
s
.54192 .36117 m
.5492 .36117 L
s
.56776 .36117 m
.58384 .36117 L
s
.5 .36117 m
.54192 .36117 L
s
.45808 .36117 m
.5 .36117 L
s
.4508 .36117 m
.45808 .36117 L
s
.41616 .36117 m
.43224 .36117 L
s
.37183 .35155 m
.37425 .36117 L
s
.37425 .36117 m
.41616 .36117 L
s
.32911 .35155 m
.33233 .36117 L
s
.33233 .36117 m
.37425 .36117 L
s
.28639 .35155 m
.29041 .36117 L
s
.29041 .36117 m
.33233 .36117 L
s
.24367 .35155 m
.24849 .36117 L
s
.24849 .36117 m
.29041 .36117 L
s
.20094 .35155 m
.20657 .36117 L
s
.20657 .36117 m
.24849 .36117 L
s
.052 .076 .18 r
.6511 .51295 m .64947 .52562 L .64638 .50655 L p F P
0 0 0 r
s
.052 .076 .18 r
.64638 .50655 m .64794 .49394 L .6511 .51295 L p F P
0 0 0 r
s
.24 .35 .67 r
.64311 .50075 m
.64801 .52537 L
s
.26 .371 .651 r
.35362 .50655 m .35206 .49394 L .3489 .51295 L p F P
0 0 0 r
s
.26 .371 .651 r
.3489 .51295 m .35053 .52562 L .35362 .50655 L p F P
0 0 0 r
s
.24 .35 .67 r
.35199 .52537 m
.35689 .50075 L
s
.48466 .71745 m
.48432 .69643 L
s
.48466 .71745 m
.51534 .71745 L
s
.51534 .71745 m
.51568 .69643 L
s
.304 .069 .029 r
.60301 .64196 m .62018 .64196 L .60657 .64919 L p F P
0 0 0 r
s
.329 .485 .9 r
.60739 .64114 m .60657 .64919 L .62018 .64196 L p F P
0 0 0 r
s
.329 .485 .9 r
.62018 .64196 m .62123 .63281 L .60739 .64114 L p F P
0 0 0 r
s
.304 .069 .029 r
.37982 .64196 m .39699 .64196 L .40866 .64919 L p F P
0 0 0 r
s
.304 .069 .029 r
.40866 .64919 m .39343 .64919 L .37982 .64196 L p F P
0 0 0 r
s
.304 .069 .029 r
.39699 .64196 m .41416 .64196 L .42388 .64919 L p F P
0 0 0 r
s
.304 .069 .029 r
.42388 .64919 m .40866 .64919 L .39699 .64196 L p F P
0 0 0 r
s
.304 .069 .029 r
.41416 .64196 m .43133 .64196 L .4391 .64919 L p F P
0 0 0 r
s
.304 .069 .029 r
.4391 .64919 m .42388 .64919 L .41416 .64196 L p F P
0 0 0 r
s
.304 .069 .029 r
.43133 .64196 m .44849 .64196 L .45433 .64919 L p F P
0 0 0 r
s
.304 .069 .029 r
.45433 .64919 m .4391 .64919 L .43133 .64196 L p F P
0 0 0 r
s
.304 .069 .029 r
.44849 .64196 m .46566 .64196 L .46955 .64919 L p F P
0 0 0 r
s
.304 .069 .029 r
.46955 .64919 m .45433 .64919 L .44849 .64196 L p F P
0 0 0 r
s
.304 .069 .029 r
.46566 .64196 m .48283 .64196 L .48478 .64919 L p F P
0 0 0 r
s
.304 .069 .029 r
.48478 .64919 m .46955 .64919 L .46566 .64196 L p F P
0 0 0 r
s
.304 .069 .029 r
.48283 .64196 m .5 .64196 L .5 .64919 L p F P
0 0 0 r
s
.304 .069 .029 r
.5 .64919 m .48478 .64919 L .48283 .64196 L p F P
0 0 0 r
s
.304 .069 .029 r
.5 .64196 m .51717 .64196 L .51522 .64919 L p F P
0 0 0 r
s
.304 .069 .029 r
.51522 .64919 m .5 .64919 L .5 .64196 L p F P
0 0 0 r
s
.304 .069 .029 r
.51717 .64196 m .53434 .64196 L .53045 .64919 L p F P
0 0 0 r
s
.304 .069 .029 r
.53045 .64919 m .51522 .64919 L .51717 .64196 L p F P
0 0 0 r
s
.304 .069 .029 r
.53434 .64196 m .55151 .64196 L .54567 .64919 L p F P
0 0 0 r
s
.304 .069 .029 r
.54567 .64919 m .53045 .64919 L .53434 .64196 L p F P
0 0 0 r
s
.304 .069 .029 r
.55151 .64196 m .56867 .64196 L .5609 .64919 L p F P
0 0 0 r
s
.304 .069 .029 r
.5609 .64919 m .54567 .64919 L .55151 .64196 L p F P
0 0 0 r
s
.304 .069 .029 r
.56867 .64196 m .58584 .64196 L .57612 .64919 L p F P
0 0 0 r
s
.304 .069 .029 r
.57612 .64919 m .5609 .64919 L .56867 .64196 L p F P
0 0 0 r
s
.304 .069 .029 r
.58584 .64196 m .60301 .64196 L .59134 .64919 L p F P
0 0 0 r
s
.304 .069 .029 r
.59134 .64919 m .57612 .64919 L .58584 .64196 L p F P
0 0 0 r
s
.304 .069 .029 r
.60657 .64919 m .59134 .64919 L .60301 .64196 L p F P
0 0 0 r
s
.24 .35 .67 r
.59893 .66394 m
.61859 .64431 L
s
.124 .196 .438 r
.37982 .64196 m .37877 .63281 L .39261 .64114 L p F P
0 0 0 r
s
.124 .196 .438 r
.39261 .64114 m .39343 .64919 L .37982 .64196 L p F P
0 0 0 r
s
.24 .35 .67 r
.38141 .64431 m
.40107 .66394 L
s
.072 .105 .259 r
.64953 .48105 m .64794 .49394 L .64129 .47539 L p F P
0 0 0 r
s
.072 .105 .259 r
.64129 .47539 m .64274 .4629 L .64953 .48105 L p F P
0 0 0 r
s
.298 .43 .775 r
.35871 .47539 m .35726 .4629 L .35047 .48105 L p F P
0 0 0 r
s
.298 .43 .775 r
.35047 .48105 m .35206 .49394 L .35871 .47539 L p F P
0 0 0 r
s
.83 .24 .1 r
.75218 .64058 m
.79421 .64058 L
s
.71015 .64058 m
.75218 .64058 L
s
.66812 .64058 m
.71015 .64058 L
s
.62609 .64058 m
.66812 .64058 L
s
.62096 .64058 m
.62609 .64058 L
s
.62075 .64058 m
.62096 .64058 L
s
.58406 .64058 m
.60833 .64058 L
s
.54203 .64058 m
.58406 .64058 L
s
.5 .64058 m
.54203 .64058 L
s
.45797 .64058 m
.5 .64058 L
s
.41594 .64058 m
.45797 .64058 L
s
.37391 .64058 m
.37904 .64058 L
s
.37904 .64058 m
.37925 .64058 L
s
.39167 .64058 m
.41594 .64058 L
s
.33188 .64058 m
.37391 .64058 L
s
.28985 .64058 m
.33188 .64058 L
s
.24782 .64058 m
.28985 .64058 L
s
.20579 .64058 m
.24782 .64058 L
s
.75218 .64058 m
.75706 .64935 L
s
.79991 .64935 m
.79421 .64058 L
s
.71015 .64058 m
.71422 .64935 L
s
.66812 .64058 m
.67138 .64935 L
s
.62609 .64058 m
.62853 .64935 L
s
.37147 .64935 m
.37391 .64058 L
s
.33188 .64058 m
.32862 .64935 L
s
.28985 .64058 m
.28578 .64935 L
s
.24782 .64058 m
.24294 .64935 L
s
.20579 .64058 m
.20009 .64935 L
s
.203 .306 .632 r
.60698 .37774 m .60616 .38777 L .5874 .38129 L p F P
0 0 0 r
s
.24 .35 .67 r
.59707 .41375 m
.59914 .38651 L
s
.203 .306 .632 r
.5874 .38129 m .58796 .37299 L .60698 .37774 L p F P
0 0 0 r
s
.33 .484 .918 r
.4126 .38129 m .41204 .37299 L .39302 .37774 L p F P
0 0 0 r
s
.33 .484 .918 r
.39302 .37774 m .39384 .38777 L .4126 .38129 L p F P
0 0 0 r
s
.24 .35 .67 r
.40086 .38651 m
.40293 .41375 L
s
.228 .342 .695 r
.58908 .35609 m .58852 .3646 L .56756 .36497 L p F P
0 0 0 r
s
.228 .342 .695 r
.56756 .36497 m .56789 .35849 L .58908 .35609 L p F P
0 0 0 r
s
.324 .477 .912 r
.43244 .36497 m .43211 .35849 L .41092 .35609 L p F P
0 0 0 r
s
.324 .477 .912 r
.41092 .35609 m .41148 .3646 L .43244 .36497 L p F P
0 0 0 r
s
.096 .145 .343 r
.64422 .45015 m .64274 .4629 L .63263 .44594 L p F P
0 0 0 r
s
.24 .35 .67 r
.63221 .47772 m
.63502 .45191 L
s
.096 .145 .343 r
.63263 .44594 m .63391 .43394 L .64422 .45015 L p F P
0 0 0 r
s
.32 .464 .852 r
.36737 .44594 m .36609 .43394 L .35578 .45015 L p F P
0 0 0 r
s
.32 .464 .852 r
.35578 .45015 m .35726 .4629 L .36737 .44594 L p F P
0 0 0 r
s
.24 .35 .67 r
.36498 .45191 m
.36779 .47772 L
s
.173 .262 .553 r
.6227 .39713 m .62162 .40846 L .60536 .39766 L p F P
0 0 0 r
s
.173 .262 .553 r
.60536 .39766 m .60616 .38777 L .6227 .39713 L p F P
0 0 0 r
s
.332 .486 .914 r
.39464 .39766 m .39384 .38777 L .3773 .39713 L p F P
0 0 0 r
s
.332 .486 .914 r
.3773 .39713 m .37838 .40846 L .39464 .39766 L p F P
0 0 0 r
s
.135 .206 .453 r
.63522 .4217 m .63391 .43394 L .62057 .41959 L p F P
0 0 0 r
s
.24 .35 .67 r
.61837 .4312 m
.63502 .45191 L
s
.135 .206 .453 r
.62057 .41959 m .62162 .40846 L .63522 .4217 L p F P
0 0 0 r
s
.24 .35 .67 r
.61837 .4312 m
.62092 .40409 L
s
.33 .481 .895 r
.37943 .41959 m .37838 .40846 L .36478 .4217 L p F P
0 0 0 r
s
.33 .481 .895 r
.36478 .4217 m .36609 .43394 L .37943 .41959 L p F P
0 0 0 r
s
.24 .35 .67 r
.37908 .40409 m
.38163 .4312 L
s
.36498 .45191 m
.38163 .4312 L
s
.281 .411 .734 r
.63568 .59019 m .63437 .60084 L .64188 .58552 L p F P
0 0 0 r
s
.24 .35 .67 r
.63916 .58757 m
.6432 .57521 L
s
.281 .411 .734 r
.64188 .58552 m .64334 .57412 L .63568 .59019 L p F P
0 0 0 r
s
.068 .1 .244 r
.35812 .58552 m .35666 .57412 L .36432 .59019 L p F P
0 0 0 r
s
.068 .1 .244 r
.36432 .59019 m .36563 .60084 L .35812 .58552 L p F P
0 0 0 r
s
.23 .333 .575 r
.64484 .56248 m .64334 .57412 L .64741 .55658 L p F P
0 0 0 r
s
.23 .333 .575 r
.64741 .55658 m .64899 .54442 L .64484 .56248 L p F P
0 0 0 r
s
.24 .35 .67 r
.64492 .54969 m
.64801 .52537 L
s
.045 .066 .152 r
.35259 .55658 m .35101 .54442 L .35516 .56248 L p F P
0 0 0 r
s
.24 .35 .67 r
.35199 .52537 m
.35508 .54969 L
s
.045 .066 .152 r
.35516 .56248 m .35666 .57412 L .35259 .55658 L p F P
0 0 0 r
s
.24 .35 .67 r
.57444 .67971 m
.59893 .66394 L
s
.40107 .66394 m
.42556 .67971 L
s
.313 .46 .84 r
.62338 .61402 m .6223 .62349 L .63308 .61128 L p F P
0 0 0 r
s
.313 .46 .84 r
.63308 .61128 m .63437 .60084 L .62338 .61402 L p F P
0 0 0 r
s
.092 .138 .333 r
.36692 .61128 m .36563 .60084 L .37662 .61402 L p F P
0 0 0 r
s
.092 .138 .333 r
.37662 .61402 m .3777 .62349 L .36692 .61128 L p F P
0 0 0 r
s
.028 .041 .084 r
.6506 .53199 m .64899 .54442 L .64947 .52562 L p F P
0 0 0 r
s
.028 .041 .084 r
.64947 .52562 m .6511 .51295 L .6506 .53199 L p F P
0 0 0 r
s
.203 .284 .476 r
.35053 .52562 m .3489 .51295 L .3494 .53199 L p F P
0 0 0 r
s
.203 .284 .476 r
.3494 .53199 m .35101 .54442 L .35053 .52562 L p F P
0 0 0 r
s
.228 .342 .695 r
.58966 .34748 m .58908 .35609 L .56789 .35849 L p F P
0 0 0 r
s
.228 .342 .695 r
.56789 .35849 m .56823 .35194 L .58966 .34748 L p F P
0 0 0 r
s
.324 .477 .912 r
.43211 .35849 m .43177 .35194 L .41034 .34748 L p F P
0 0 0 r
s
.324 .477 .912 r
.41034 .34748 m .41092 .35609 L .43211 .35849 L p F P
0 0 0 r
s
.203 .306 .632 r
.60781 .36755 m .60698 .37774 L .58796 .37299 L p F P
0 0 0 r
s
.203 .306 .632 r
.58796 .37299 m .58852 .3646 L .60781 .36755 L p F P
0 0 0 r
s
.24 .35 .67 r
.57358 .37282 m
.59914 .38651 L
s
.33 .484 .918 r
.41204 .37299 m .41148 .3646 L .39219 .36755 L p F P
0 0 0 r
s
.33 .484 .918 r
.39219 .36755 m .39302 .37774 L .41204 .37299 L p F P
0 0 0 r
s
.24 .35 .67 r
.40086 .38651 m
.42642 .37282 L
s
.63404 .60123 m
.63438 .60068 L
s
.36562 .60068 m
.36596 .60123 L
s
.052 .076 .18 r
.65276 .5 m .6511 .51295 L .64794 .49394 L p F P
0 0 0 r
s
.052 .076 .18 r
.64794 .49394 m .64953 .48105 L .65276 .5 L p F P
0 0 0 r
s
.26 .371 .651 r
.35206 .49394 m .35047 .48105 L .34724 .5 L p F P
0 0 0 r
s
.26 .371 .651 r
.34724 .5 m .3489 .51295 L .35206 .49394 L p F P
0 0 0 r
s
.329 .485 .9 r
.60823 .63297 m .60739 .64114 L .62123 .63281 L p F P
0 0 0 r
s
.329 .485 .9 r
.62123 .63281 m .6223 .62349 L .60823 .63297 L p F P
0 0 0 r
s
.124 .196 .438 r
.37877 .63281 m .3777 .62349 L .39177 .63297 L p F P
0 0 0 r
s
.24 .35 .67 r
.38011 .63282 m
.38021 .63367 L
s
.124 .196 .438 r
.39177 .63297 m .39261 .64114 L .37877 .63281 L p F P
0 0 0 r
s
.072 .105 .259 r
.65115 .46789 m .64953 .48105 L .64274 .4629 L p F P
0 0 0 r
s
.24 .35 .67 r
.64311 .50075 m
.64619 .47514 L
s
.072 .105 .259 r
.64274 .4629 m .64422 .45015 L .65115 .46789 L p F P
0 0 0 r
s
.24 .35 .67 r
.63502 .45191 m
.64619 .47514 L
s
.298 .43 .775 r
.35726 .4629 m .35578 .45015 L .34885 .46789 L p F P
0 0 0 r
s
.298 .43 .775 r
.34885 .46789 m .35047 .48105 L .35726 .4629 L p F P
0 0 0 r
s
.24 .35 .67 r
.35381 .47514 m
.36498 .45191 L
s
.35381 .47514 m
.35689 .50075 L
s
.173 .262 .553 r
.62379 .38561 m .6227 .39713 L .60616 .38777 L p F P
0 0 0 r
s
.173 .262 .553 r
.60616 .38777 m .60698 .37774 L .62379 .38561 L p F P
0 0 0 r
s
.24 .35 .67 r
.59914 .38651 m
.62092 .40409 L
s
.332 .486 .914 r
.39384 .38777 m .39302 .37774 L .37621 .38561 L p F P
0 0 0 r
s
.332 .486 .914 r
.37621 .38561 m .3773 .39713 L .39384 .38777 L p F P
0 0 0 r
s
.24 .35 .67 r
.37908 .40409 m
.40086 .38651 L
s
.831 .26 .112 r
.58966 .34748 m .57685 .34748 L .55848 .35194 L p F P
0 0 0 r
s
.831 .26 .112 r
.55848 .35194 m .56823 .35194 L .58966 .34748 L p F P
0 0 0 r
s
.831 .26 .112 r
.57685 .34748 m .56404 .34748 L .54873 .35194 L p F P
0 0 0 r
s
.831 .26 .112 r
.54873 .35194 m .55848 .35194 L .57685 .34748 L p F P
0 0 0 r
s
.24 .35 .67 r
.57499 .34748 m
.57517 .3443 L
s
.57358 .37282 m
.57484 .35013 L
s
.831 .26 .112 r
.56404 .34748 m .55123 .34748 L .53899 .35194 L p F P
0 0 0 r
s
.24 .35 .67 r
.54565 .35194 m
.54569 .35075 L
s
.831 .26 .112 r
.53899 .35194 m .54873 .35194 L .56404 .34748 L p F P
0 0 0 r
s
.831 .26 .112 r
.55123 .34748 m .53843 .34748 L .52924 .35194 L p F P
0 0 0 r
s
.24 .35 .67 r
.54574 .34948 m
.54577 .34859 L
s
.831 .26 .112 r
.52924 .35194 m .53899 .35194 L .55123 .34748 L p F P
0 0 0 r
s
.24 .35 .67 r
.5458 .34748 m
.54623 .33487 L
s
.83 .24 .1 r
.54192 .36117 m
.54272 .35155 L
s
.831 .26 .112 r
.53843 .34748 m .52562 .34748 L .51949 .35194 L p F P
0 0 0 r
s
.831 .26 .112 r
.51949 .35194 m .52924 .35194 L .53843 .34748 L p F P
0 0 0 r
s
.831 .26 .112 r
.52562 .34748 m .51281 .34748 L .50975 .35194 L p F P
0 0 0 r
s
.24 .35 .67 r
.51535 .35194 m
.51537 .35036 L
s
.831 .26 .112 r
.50975 .35194 m .51949 .35194 L .52562 .34748 L p F P
0 0 0 r
s
.24 .35 .67 r
.5154 .34748 m
.5156 .33009 L
s
.831 .26 .112 r
.51281 .34748 m .5 .34748 L .5 .35194 L p F P
0 0 0 r
s
.831 .26 .112 r
.5 .35194 m .50975 .35194 L .51281 .34748 L p F P
0 0 0 r
s
.831 .26 .112 r
.5 .34748 m .48719 .34748 L .49025 .35194 L p F P
0 0 0 r
s
.831 .26 .112 r
.49025 .35194 m .5 .35194 L .5 .34748 L p F P
0 0 0 r
s
.83 .24 .1 r
.5 .35155 m
.5 .36117 L
s
.831 .26 .112 r
.48719 .34748 m .47438 .34748 L .48051 .35194 L p F P
0 0 0 r
s
.24 .35 .67 r
.48462 .3492 m
.48465 .35194 L
s
.831 .26 .112 r
.48051 .35194 m .49025 .35194 L .48719 .34748 L p F P
0 0 0 r
s
.24 .35 .67 r
.4844 .33009 m
.4846 .34748 L
s
.831 .26 .112 r
.47438 .34748 m .46157 .34748 L .47076 .35194 L p F P
0 0 0 r
s
.831 .26 .112 r
.47076 .35194 m .48051 .35194 L .47438 .34748 L p F P
0 0 0 r
s
.831 .26 .112 r
.46157 .34748 m .44877 .34748 L .46101 .35194 L p F P
0 0 0 r
s
.24 .35 .67 r
.45426 .34948 m
.45435 .35194 L
s
.831 .26 .112 r
.46101 .35194 m .47076 .35194 L .46157 .34748 L p F P
0 0 0 r
s
.831 .26 .112 r
.44877 .34748 m .43596 .34748 L .45127 .35194 L p F P
0 0 0 r
s
.831 .26 .112 r
.45127 .35194 m .46101 .35194 L .44877 .34748 L p F P
0 0 0 r
s
.24 .35 .67 r
.45377 .33487 m
.4542 .34748 L
s
.83 .24 .1 r
.45728 .35155 m
.45808 .36117 L
s
.831 .26 .112 r
.43596 .34748 m .42315 .34748 L .44152 .35194 L p F P
0 0 0 r
s
.831 .26 .112 r
.44152 .35194 m .45127 .35194 L .43596 .34748 L p F P
0 0 0 r
s
.831 .26 .112 r
.42315 .34748 m .41034 .34748 L .43177 .35194 L p F P
0 0 0 r
s
.831 .26 .112 r
.43177 .35194 m .44152 .35194 L .42315 .34748 L p F P
0 0 0 r
s
.24 .35 .67 r
.42516 .35013 m
.42642 .37282 L
s
.42483 .3443 m
.42501 .34748 L
s
.096 .145 .343 r
.64573 .43714 m .64422 .45015 L .63391 .43394 L p F P
0 0 0 r
s
.096 .145 .343 r
.63391 .43394 m .63522 .4217 L .64573 .43714 L p F P
0 0 0 r
s
.32 .464 .852 r
.36609 .43394 m .36478 .4217 L .35427 .43714 L p F P
0 0 0 r
s
.32 .464 .852 r
.35427 .43714 m .35578 .45015 L .36609 .43394 L p F P
0 0 0 r
s
.135 .206 .453 r
.63654 .40923 m .63522 .4217 L .62162 .40846 L p F P
0 0 0 r
s
.135 .206 .453 r
.62162 .40846 m .6227 .39713 L .63654 .40923 L p F P
0 0 0 r
s
.33 .481 .895 r
.37838 .40846 m .3773 .39713 L .36346 .40923 L p F P
0 0 0 r
s
.33 .481 .895 r
.36346 .40923 m .36478 .4217 L .37838 .40846 L p F P
0 0 0 r
s
.24 .35 .67 r
.42556 .67971 m
.42393 .65756 L
s
.42556 .67971 m
.45377 .69075 L
s
.54623 .69075 m
.57444 .67971 L
s
.57444 .67971 m
.57607 .65756 L
s
.203 .306 .632 r
.60865 .3572 m .60781 .36755 L .58852 .3646 L p F P
0 0 0 r
s
.203 .306 .632 r
.58852 .3646 m .58908 .35609 L .60865 .3572 L p F P
0 0 0 r
s
.24 .35 .67 r
.59914 .38651 m
.6013 .35809 L
s
.33 .484 .918 r
.41148 .3646 m .41092 .35609 L .39135 .3572 L p F P
0 0 0 r
s
.33 .484 .918 r
.39135 .3572 m .39219 .36755 L .41148 .3646 L p F P
0 0 0 r
s
.24 .35 .67 r
.3987 .35809 m
.40086 .38651 L
s
.213 .05 .021 r
.57612 .64919 m .59134 .64919 L .57708 .65296 L p F P
0 0 0 r
s
.213 .05 .021 r
.59134 .64919 m .60657 .64919 L .58992 .65296 L p F P
0 0 0 r
s
.213 .05 .021 r
.58992 .65296 m .57708 .65296 L .59134 .64919 L p F P
0 0 0 r
s
.333 .493 .926 r
.59051 .6462 m .58992 .65296 L .60657 .64919 L p F P
0 0 0 r
s
.24 .35 .67 r
.59893 .66394 m
.60018 .65096 L
s
.60018 .65096 m
.60022 .65063 L
s
.333 .493 .926 r
.60657 .64919 m .60739 .64114 L .59051 .6462 L p F P
0 0 0 r
s
.213 .05 .021 r
.39343 .64919 m .40866 .64919 L .42292 .65296 L p F P
0 0 0 r
s
.213 .05 .021 r
.42292 .65296 m .41008 .65296 L .39343 .64919 L p F P
0 0 0 r
s
.213 .05 .021 r
.40866 .64919 m .42388 .64919 L .43577 .65296 L p F P
0 0 0 r
s
.213 .05 .021 r
.43577 .65296 m .42292 .65296 L .40866 .64919 L p F P
0 0 0 r
s
.83 .24 .1 r
.41431 .64935 m
.41594 .64058 L
s
.213 .05 .021 r
.42388 .64919 m .4391 .64919 L .44862 .65296 L p F P
0 0 0 r
s
.213 .05 .021 r
.44862 .65296 m .43577 .65296 L .42388 .64919 L p F P
0 0 0 r
s
.213 .05 .021 r
.4391 .64919 m .45433 .64919 L .46146 .65296 L p F P
0 0 0 r
s
.213 .05 .021 r
.46146 .65296 m .44862 .65296 L .4391 .64919 L p F P
0 0 0 r
s
.213 .05 .021 r
.45433 .64919 m .46955 .64919 L .47431 .65296 L p F P
0 0 0 r
s
.213 .05 .021 r
.47431 .65296 m .46146 .65296 L .45433 .64919 L p F P
0 0 0 r
s
.83 .24 .1 r
.45716 .64935 m
.45797 .64058 L
s
.213 .05 .021 r
.46955 .64919 m .48478 .64919 L .48715 .65296 L p F P
0 0 0 r
s
.213 .05 .021 r
.48715 .65296 m .47431 .65296 L .46955 .64919 L p F P
0 0 0 r
s
.213 .05 .021 r
.48478 .64919 m .5 .64919 L .5 .65296 L p F P
0 0 0 r
s
.213 .05 .021 r
.5 .65296 m .48715 .65296 L .48478 .64919 L p F P
0 0 0 r
s
.213 .05 .021 r
.5 .64919 m .51522 .64919 L .51285 .65296 L p F P
0 0 0 r
s
.213 .05 .021 r
.51285 .65296 m .5 .65296 L .5 .64919 L p F P
0 0 0 r
s
.83 .24 .1 r
.5 .64058 m
.5 .64935 L
s
.213 .05 .021 r
.51522 .64919 m .53045 .64919 L .52569 .65296 L p F P
0 0 0 r
s
.213 .05 .021 r
.52569 .65296 m .51285 .65296 L .51522 .64919 L p F P
0 0 0 r
s
.213 .05 .021 r
.53045 .64919 m .54567 .64919 L .53854 .65296 L p F P
0 0 0 r
s
.213 .05 .021 r
.53854 .65296 m .52569 .65296 L .53045 .64919 L p F P
0 0 0 r
s
.213 .05 .021 r
.54567 .64919 m .5609 .64919 L .55138 .65296 L p F P
0 0 0 r
s
.213 .05 .021 r
.55138 .65296 m .53854 .65296 L .54567 .64919 L p F P
0 0 0 r
s
.83 .24 .1 r
.54203 .64058 m
.54284 .64935 L
s
.213 .05 .021 r
.5609 .64919 m .57612 .64919 L .56423 .65296 L p F P
0 0 0 r
s
.213 .05 .021 r
.56423 .65296 m .55138 .65296 L .5609 .64919 L p F P
0 0 0 r
s
.83 .24 .1 r
.58406 .64058 m
.58569 .64935 L
s
.213 .05 .021 r
.57708 .65296 m .56423 .65296 L .57612 .64919 L p F P
0 0 0 r
s
.169 .262 .556 r
.39343 .64919 m .39261 .64114 L .40949 .6462 L p F P
0 0 0 r
s
.169 .262 .556 r
.40949 .6462 m .41008 .65296 L .39343 .64919 L p F P
0 0 0 r
s
.24 .35 .67 r
.39982 .65096 m
.40107 .66394 L
s
.39978 .65063 m
.39982 .65096 L
s
.281 .411 .734 r
.63702 .57934 m .63568 .59019 L .64334 .57412 L p F P
0 0 0 r
s
.281 .411 .734 r
.64334 .57412 m .64484 .56248 L .63702 .57934 L p F P
0 0 0 r
s
.068 .1 .244 r
.35666 .57412 m .35516 .56248 L .36298 .57934 L p F P
0 0 0 r
s
.068 .1 .244 r
.36298 .57934 m .36432 .59019 L .35666 .57412 L p F P
0 0 0 r
s
.24 .35 .67 r
.54623 .33487 m
.5156 .33009 L
s
.5156 .33009 m
.51594 .30021 L
s
.5156 .33009 m
.4844 .33009 L
s
.4844 .33009 m
.48406 .30021 L
s
.4844 .33009 m
.45377 .33487 L
s
.313 .46 .84 r
.62449 .60437 m .62338 .61402 L .63437 .60084 L p F P
0 0 0 r
s
.313 .46 .84 r
.63437 .60084 m .63568 .59019 L .62449 .60437 L p F P
0 0 0 r
s
.092 .138 .333 r
.36563 .60084 m .36432 .59019 L .37551 .60437 L p F P
0 0 0 r
s
.092 .138 .333 r
.37551 .60437 m .37662 .61402 L .36563 .60084 L p F P
0 0 0 r
s
.23 .333 .575 r
.64636 .55059 m .64484 .56248 L .64899 .54442 L p F P
0 0 0 r
s
.23 .333 .575 r
.64899 .54442 m .6506 .53199 L .64636 .55059 L p F P
0 0 0 r
s
.24 .35 .67 r
.64652 .5499 m
.64801 .52537 L
s
.045 .066 .152 r
.35101 .54442 m .3494 .53199 L .35364 .55059 L p F P
0 0 0 r
s
.045 .066 .152 r
.35364 .55059 m .35516 .56248 L .35101 .54442 L p F P
0 0 0 r
s
.24 .35 .67 r
.35199 .52537 m
.35348 .5499 L
s
.83 .24 .1 r
.76148 .34808 m
.75633 .35155 L
s
.79906 .35155 m
.80506 .34808 L
s
.75633 .35155 m
.79906 .35155 L
s
.7179 .34808 m
.71361 .35155 L
s
.71361 .35155 m
.75633 .35155 L
s
.67432 .34808 m
.67089 .35155 L
s
.67089 .35155 m
.71361 .35155 L
s
.63074 .34808 m
.62817 .35155 L
s
.62817 .35155 m
.67089 .35155 L
s
.58593 .35057 m
.58716 .34808 L
s
.58939 .35155 m
.62817 .35155 L
s
.54272 .35155 m
.54358 .34808 L
s
.54272 .35155 m
.57686 .35155 L
s
.5 .34808 m
.5 .35155 L
s
.5 .35155 m
.54272 .35155 L
s
.45642 .34808 m
.45728 .35155 L
s
.45728 .35155 m
.5 .35155 L
s
.41284 .34808 m
.41407 .35057 L
s
.42314 .35155 m
.45728 .35155 L
s
.36926 .34808 m
.37183 .35155 L
s
.37183 .35155 m
.41061 .35155 L
s
.32568 .34808 m
.32911 .35155 L
s
.32911 .35155 m
.37183 .35155 L
s
.2821 .34808 m
.28639 .35155 L
s
.28639 .35155 m
.32911 .35155 L
s
.23852 .34808 m
.24367 .35155 L
s
.24367 .35155 m
.28639 .35155 L
s
.19494 .34808 m
.20094 .35155 L
s
.20094 .35155 m
.24367 .35155 L
s
.028 .041 .084 r
.65225 .51929 m .6506 .53199 L .6511 .51295 L p F P
0 0 0 r
s
.028 .041 .084 r
.6511 .51295 m .65276 .5 L .65225 .51929 L p F P
0 0 0 r
s
.203 .284 .476 r
.3489 .51295 m .34724 .5 L .34775 .51929 L p F P
0 0 0 r
s
.203 .284 .476 r
.34775 .51929 m .3494 .53199 L .3489 .51295 L p F P
0 0 0 r
s
.24 .35 .67 r
.45377 .69075 m
.45276 .66874 L
s
.45377 .69075 m
.48432 .69643 L
s
.51568 .69643 m
.54623 .69075 L
s
.54623 .69075 m
.54724 .66874 L
s
.57517 .3443 m
.54623 .33487 L
s
.54623 .33487 m
.54725 .30502 L
s
.45377 .33487 m
.45275 .30502 L
s
.45377 .33487 m
.42483 .3443 L
s
.329 .485 .9 r
.60908 .62466 m .60823 .63297 L .6223 .62349 L p F P
0 0 0 r
s
.329 .485 .9 r
.6223 .62349 m .62338 .61402 L .60908 .62466 L p F P
0 0 0 r
s
.124 .196 .438 r
.3777 .62349 m .37662 .61402 L .39092 .62466 L p F P
0 0 0 r
s
.24 .35 .67 r
.37907 .62361 m
.37917 .62448 L
s
.124 .196 .438 r
.39092 .62466 m .39177 .63297 L .3777 .62349 L p F P
0 0 0 r
s
.173 .262 .553 r
.6249 .37387 m .62379 .38561 L .60698 .37774 L p F P
0 0 0 r
s
.173 .262 .553 r
.60698 .37774 m .60781 .36755 L .6249 .37387 L p F P
0 0 0 r
s
.332 .486 .914 r
.39302 .37774 m .39219 .36755 L .3751 .37387 L p F P
0 0 0 r
s
.332 .486 .914 r
.3751 .37387 m .37621 .38561 L .39302 .37774 L p F P
0 0 0 r
s
.052 .076 .18 r
.65446 .48676 m .65276 .5 L .64953 .48105 L p F P
0 0 0 r
s
.052 .076 .18 r
.64953 .48105 m .65115 .46789 L .65446 .48676 L p F P
0 0 0 r
s
.24 .35 .67 r
.64619 .47514 m
.65123 .5 L
s
.26 .371 .651 r
.35047 .48105 m .34885 .46789 L .34554 .48676 L p F P
0 0 0 r
s
.26 .371 .651 r
.34554 .48676 m .34724 .5 L .35047 .48105 L p F P
0 0 0 r
s
.24 .35 .67 r
.34877 .5 m
.35381 .47514 L
s
.83 .24 .1 r
.75706 .64935 m
.79991 .64935 L
s
.71422 .64935 m
.75706 .64935 L
s
.67138 .64935 m
.71422 .64935 L
s
.62853 .64935 m
.67138 .64935 L
s
.60203 .64935 m
.62853 .64935 L
s
.58569 .64935 m
.59023 .64935 L
s
.54284 .64935 m
.58569 .64935 L
s
.5 .64935 m
.54284 .64935 L
s
.45716 .64935 m
.5 .64935 L
s
.41431 .64935 m
.45716 .64935 L
s
.37147 .64935 m
.39797 .64935 L
s
.40977 .64935 m
.41431 .64935 L
s
.32862 .64935 m
.37147 .64935 L
s
.28578 .64935 m
.32862 .64935 L
s
.24294 .64935 m
.28578 .64935 L
s
.20009 .64935 m
.24294 .64935 L
s
.75706 .64935 m
.76224 .65188 L
s
.80595 .65188 m
.79991 .64935 L
s
.71422 .64935 m
.71853 .65188 L
s
.67138 .64935 m
.67483 .65188 L
s
.62853 .64935 m
.63112 .65188 L
s
.54284 .64935 m
.54371 .65188 L
s
.5 .64935 m
.5 .65188 L
s
.45629 .65188 m
.45716 .64935 L
s
.37147 .64935 m
.36888 .65188 L
s
.32862 .64935 m
.32517 .65188 L
s
.28578 .64935 m
.28147 .65188 L
s
.24294 .64935 m
.23776 .65188 L
s
.20009 .64935 m
.19405 .65188 L
s
.24 .35 .67 r
.48432 .69643 m
.48398 .67449 L
s
.48432 .69643 m
.51568 .69643 L
s
.51568 .69643 m
.51602 .67449 L
s
.203 .306 .632 r
.60951 .34669 m .60865 .3572 L .58908 .35609 L p F P
0 0 0 r
s
.203 .306 .632 r
.58908 .35609 m .58966 .34748 L .60951 .34669 L p F P
0 0 0 r
s
.33 .484 .918 r
.41092 .35609 m .41034 .34748 L .39049 .34669 L p F P
0 0 0 r
s
.33 .484 .918 r
.39049 .34669 m .39135 .3572 L .41092 .35609 L p F P
0 0 0 r
s
.072 .105 .259 r
.65282 .45444 m .65115 .46789 L .64422 .45015 L p F P
0 0 0 r
s
.072 .105 .259 r
.64422 .45015 m .64573 .43714 L .65282 .45444 L p F P
0 0 0 r
s
.298 .43 .775 r
.35578 .45015 m .35427 .43714 L .34718 .45444 L p F P
0 0 0 r
s
.298 .43 .775 r
.34718 .45444 m .34885 .46789 L .35578 .45015 L p F P
0 0 0 r
s
.135 .206 .453 r
.6379 .39651 m .63654 .40923 L .6227 .39713 L p F P
0 0 0 r
s
.135 .206 .453 r
.6227 .39713 m .62379 .38561 L .6379 .39651 L p F P
0 0 0 r
s
.24 .35 .67 r
.62092 .40409 m
.62358 .3758 L
s
.33 .481 .895 r
.3773 .39713 m .37621 .38561 L .3621 .39651 L p F P
0 0 0 r
s
.33 .481 .895 r
.3621 .39651 m .36346 .40923 L .3773 .39713 L p F P
0 0 0 r
s
.24 .35 .67 r
.37642 .3758 m
.37908 .40409 L
s
.096 .145 .343 r
.64728 .42385 m .64573 .43714 L .63522 .4217 L p F P
0 0 0 r
s
.24 .35 .67 r
.63502 .45191 m
.63795 .42498 L
s
.096 .145 .343 r
.63522 .4217 m .63654 .40923 L .64728 .42385 L p F P
0 0 0 r
s
.24 .35 .67 r
.62092 .40409 m
.63795 .42498 L
s
.32 .464 .852 r
.36478 .4217 m .36346 .40923 L .35272 .42385 L p F P
0 0 0 r
s
.32 .464 .852 r
.35272 .42385 m .35427 .43714 L .36478 .4217 L p F P
0 0 0 r
s
.24 .35 .67 r
.36205 .42498 m
.37908 .40409 L
s
.36205 .42498 m
.36498 .45191 L
s
.58261 .34823 m
.6013 .35809 L
s
.57517 .3443 m
.5812 .34748 L
s
.57517 .3443 m
.57683 .31451 L
s
.42483 .3443 m
.42317 .31451 L
s
.3987 .35809 m
.41739 .34823 L
s
.4188 .34748 m
.42483 .3443 L
s
.333 .493 .926 r
.5911 .63935 m .59051 .6462 L .60739 .64114 L p F P
0 0 0 r
s
.333 .493 .926 r
.60739 .64114 m .60823 .63297 L .5911 .63935 L p F P
0 0 0 r
s
.169 .262 .556 r
.39261 .64114 m .39177 .63297 L .4089 .63935 L p F P
0 0 0 r
s
.169 .262 .556 r
.4089 .63935 m .40949 .6462 L .39261 .64114 L p F P
0 0 0 r
s
.313 .46 .84 r
.62561 .59454 m .62449 .60437 L .63568 .59019 L p F P
0 0 0 r
s
.313 .46 .84 r
.63568 .59019 m .63702 .57934 L .62561 .59454 L p F P
0 0 0 r
s
.092 .138 .333 r
.36432 .59019 m .36298 .57934 L .37439 .59454 L p F P
0 0 0 r
s
.092 .138 .333 r
.37439 .59454 m .37551 .60437 L .36432 .59019 L p F P
0 0 0 r
s
.281 .411 .734 r
.63838 .56827 m .63702 .57934 L .64484 .56248 L p F P
0 0 0 r
s
.281 .411 .734 r
.64484 .56248 m .64636 .55059 L .63838 .56827 L p F P
0 0 0 r
s
.068 .1 .244 r
.35516 .56248 m .35364 .55059 L .36162 .56827 L p F P
0 0 0 r
s
.068 .1 .244 r
.36162 .56827 m .36298 .57934 L .35516 .56248 L p F P
0 0 0 r
s
.173 .262 .553 r
.62603 .36193 m .6249 .37387 L .60781 .36755 L p F P
0 0 0 r
s
.173 .262 .553 r
.60781 .36755 m .60865 .3572 L .62603 .36193 L p F P
0 0 0 r
s
.332 .486 .914 r
.39219 .36755 m .39135 .3572 L .37397 .36193 L p F P
0 0 0 r
s
.332 .486 .914 r
.37397 .36193 m .3751 .37387 L .39219 .36755 L p F P
0 0 0 r
s
.23 .333 .575 r
.64792 .53845 m .64636 .55059 L .6506 .53199 L p F P
0 0 0 r
s
.23 .333 .575 r
.6506 .53199 m .65225 .51929 L .64792 .53845 L p F P
0 0 0 r
s
.24 .35 .67 r
.64801 .52537 m
.65123 .5 L
s
.045 .066 .152 r
.3494 .53199 m .34775 .51929 L .35208 .53845 L p F P
0 0 0 r
s
.24 .35 .67 r
.34877 .5 m
.35199 .52537 L
s
.045 .066 .152 r
.35208 .53845 m .35364 .55059 L .3494 .53199 L p F P
0 0 0 r
s
.329 .485 .9 r
.60994 .61622 m .60908 .62466 L .62338 .61402 L p F P
0 0 0 r
s
.329 .485 .9 r
.62338 .61402 m .62449 .60437 L .60994 .61622 L p F P
0 0 0 r
s
.124 .196 .438 r
.37662 .61402 m .37551 .60437 L .39006 .61622 L p F P
0 0 0 r
s
.24 .35 .67 r
.37801 .61424 m
.37811 .61512 L
s
.124 .196 .438 r
.39006 .61622 m .39092 .62466 L .37662 .61402 L p F P
0 0 0 r
s
.594 .196 .084 r
.60951 .34669 m .59386 .34669 L .57685 .34748 L p F P
0 0 0 r
s
.594 .196 .084 r
.57685 .34748 m .58966 .34748 L .60951 .34669 L p F P
0 0 0 r
s
.594 .196 .084 r
.59386 .34669 m .57822 .34669 L .56404 .34748 L p F P
0 0 0 r
s
.594 .196 .084 r
.56404 .34748 m .57685 .34748 L .59386 .34669 L p F P
0 0 0 r
s
.594 .196 .084 r
.57822 .34669 m .56258 .34669 L .55123 .34748 L p F P
0 0 0 r
s
.594 .196 .084 r
.55123 .34748 m .56404 .34748 L .57822 .34669 L p F P
0 0 0 r
s
.594 .196 .084 r
.56258 .34669 m .54693 .34669 L .53843 .34748 L p F P
0 0 0 r
s
.594 .196 .084 r
.53843 .34748 m .55123 .34748 L .56258 .34669 L p F P
0 0 0 r
s
.594 .196 .084 r
.54693 .34669 m .53129 .34669 L .52562 .34748 L p F P
0 0 0 r
s
.594 .196 .084 r
.52562 .34748 m .53843 .34748 L .54693 .34669 L p F P
0 0 0 r
s
.594 .196 .084 r
.53129 .34669 m .51564 .34669 L .51281 .34748 L p F P
0 0 0 r
s
.594 .196 .084 r
.51281 .34748 m .52562 .34748 L .53129 .34669 L p F P
0 0 0 r
s
.594 .196 .084 r
.51564 .34669 m .5 .34669 L .5 .34748 L p F P
0 0 0 r
s
.594 .196 .084 r
.5 .34748 m .51281 .34748 L .51564 .34669 L p F P
0 0 0 r
s
.594 .196 .084 r
.5 .34669 m .48436 .34669 L .48719 .34748 L p F P
0 0 0 r
s
.594 .196 .084 r
.48719 .34748 m .5 .34748 L .5 .34669 L p F P
0 0 0 r
s
.594 .196 .084 r
.48436 .34669 m .46871 .34669 L .47438 .34748 L p F P
0 0 0 r
s
.594 .196 .084 r
.47438 .34748 m .48719 .34748 L .48436 .34669 L p F P
0 0 0 r
s
.594 .196 .084 r
.46871 .34669 m .45307 .34669 L .46157 .34748 L p F P
0 0 0 r
s
.594 .196 .084 r
.46157 .34748 m .47438 .34748 L .46871 .34669 L p F P
0 0 0 r
s
.594 .196 .084 r
.45307 .34669 m .43742 .34669 L .44877 .34748 L p F P
0 0 0 r
s
.594 .196 .084 r
.44877 .34748 m .46157 .34748 L .45307 .34669 L p F P
0 0 0 r
s
.594 .196 .084 r
.43742 .34669 m .42178 .34669 L .43596 .34748 L p F P
0 0 0 r
s
.594 .196 .084 r
.43596 .34748 m .44877 .34748 L .43742 .34669 L p F P
0 0 0 r
s
.594 .196 .084 r
.42178 .34669 m .40614 .34669 L .42315 .34748 L p F P
0 0 0 r
s
.594 .196 .084 r
.42315 .34748 m .43596 .34748 L .42178 .34669 L p F P
0 0 0 r
s
.594 .196 .084 r
.40614 .34669 m .39049 .34669 L .41034 .34748 L p F P
0 0 0 r
s
.594 .196 .084 r
.41034 .34748 m .42315 .34748 L .40614 .34669 L p F P
0 0 0 r
s
.24 .35 .67 r
.57607 .65756 m
.58217 .65367 L
s
.41783 .65367 m
.42393 .65756 L
s
.028 .041 .084 r
.65394 .50631 m .65225 .51929 L .65276 .5 L p F P
0 0 0 r
s
.028 .041 .084 r
.65276 .5 m .65446 .48676 L .65394 .50631 L p F P
0 0 0 r
s
.203 .284 .476 r
.34724 .5 m .34554 .48676 L .34606 .50631 L p F P
0 0 0 r
s
.203 .284 .476 r
.34606 .50631 m .34775 .51929 L .34724 .5 L p F P
0 0 0 r
s
.24 .35 .67 r
.6013 .35809 m
.60215 .34691 L
s
.39785 .34691 m
.3987 .35809 L
s
.085 .024 .01 r
.56423 .65296 m .57708 .65296 L .56044 .65302 L p F P
0 0 0 r
s
.085 .024 .01 r
.57708 .65296 m .58992 .65296 L .57051 .65302 L p F P
0 0 0 r
s
.085 .024 .01 r
.57051 .65302 m .56044 .65302 L .57708 .65296 L p F P
0 0 0 r
s
.33 .49 .931 r
.57087 .64773 m .57051 .65302 L .58992 .65296 L p F P
0 0 0 r
s
.24 .35 .67 r
.58217 .65367 m
.58325 .65298 L
s
.33 .49 .931 r
.58992 .65296 m .59051 .6462 L .57087 .64773 L p F P
0 0 0 r
s
.83 .24 .1 r
.58691 .65114 m
.58741 .65188 L
s
.085 .024 .01 r
.41008 .65296 m .42292 .65296 L .43956 .65302 L p F P
0 0 0 r
s
.085 .024 .01 r
.43956 .65302 m .42949 .65302 L .41008 .65296 L p F P
0 0 0 r
s
.085 .024 .01 r
.42292 .65296 m .43577 .65296 L .44963 .65302 L p F P
0 0 0 r
s
.085 .024 .01 r
.44963 .65302 m .43956 .65302 L .42292 .65296 L p F P
0 0 0 r
s
.085 .024 .01 r
.43577 .65296 m .44862 .65296 L .45971 .65302 L p F P
0 0 0 r
s
.085 .024 .01 r
.45971 .65302 m .44963 .65302 L .43577 .65296 L p F P
0 0 0 r
s
.085 .024 .01 r
.44862 .65296 m .46146 .65296 L .46978 .65302 L p F P
0 0 0 r
s
.085 .024 .01 r
.46978 .65302 m .45971 .65302 L .44862 .65296 L p F P
0 0 0 r
s
.085 .024 .01 r
.46146 .65296 m .47431 .65296 L .47985 .65302 L p F P
0 0 0 r
s
.085 .024 .01 r
.47985 .65302 m .46978 .65302 L .46146 .65296 L p F P
0 0 0 r
s
.085 .024 .01 r
.47431 .65296 m .48715 .65296 L .48993 .65302 L p F P
0 0 0 r
s
.085 .024 .01 r
.48993 .65302 m .47985 .65302 L .47431 .65296 L p F P
0 0 0 r
s
.085 .024 .01 r
.48715 .65296 m .5 .65296 L .5 .65302 L p F P
0 0 0 r
s
.085 .024 .01 r
.5 .65302 m .48993 .65302 L .48715 .65296 L p F P
0 0 0 r
s
.085 .024 .01 r
.5 .65296 m .51285 .65296 L .51007 .65302 L p F P
0 0 0 r
s
.085 .024 .01 r
.51007 .65302 m .5 .65302 L .5 .65296 L p F P
0 0 0 r
s
.085 .024 .01 r
.51285 .65296 m .52569 .65296 L .52015 .65302 L p F P
0 0 0 r
s
.085 .024 .01 r
.52015 .65302 m .51007 .65302 L .51285 .65296 L p F P
0 0 0 r
s
.085 .024 .01 r
.52569 .65296 m .53854 .65296 L .53022 .65302 L p F P
0 0 0 r
s
.085 .024 .01 r
.53022 .65302 m .52015 .65302 L .52569 .65296 L p F P
0 0 0 r
s
.085 .024 .01 r
.53854 .65296 m .55138 .65296 L .54029 .65302 L p F P
0 0 0 r
s
.085 .024 .01 r
.54029 .65302 m .53022 .65302 L .53854 .65296 L p F P
0 0 0 r
s
.085 .024 .01 r
.55138 .65296 m .56423 .65296 L .55037 .65302 L p F P
0 0 0 r
s
.085 .024 .01 r
.55037 .65302 m .54029 .65302 L .55138 .65296 L p F P
0 0 0 r
s
.085 .024 .01 r
.56044 .65302 m .55037 .65302 L .56423 .65296 L p F P
0 0 0 r
s
.206 .315 .651 r
.41008 .65296 m .40949 .6462 L .42913 .64773 L p F P
0 0 0 r
s
.206 .315 .651 r
.42913 .64773 m .42949 .65302 L .41008 .65296 L p F P
0 0 0 r
s
.83 .24 .1 r
.41259 .65188 m
.41309 .65114 L
s
.24 .35 .67 r
.41675 .65298 m
.41783 .65367 L
s
.135 .206 .453 r
.63928 .38353 m .6379 .39651 L .62379 .38561 L p F P
0 0 0 r
s
.135 .206 .453 r
.62379 .38561 m .6249 .37387 L .63928 .38353 L p F P
0 0 0 r
s
.33 .481 .895 r
.37621 .38561 m .3751 .37387 L .36072 .38353 L p F P
0 0 0 r
s
.33 .481 .895 r
.36072 .38353 m .3621 .39651 L .37621 .38561 L p F P
0 0 0 r
s
.052 .076 .18 r
.65619 .47322 m .65446 .48676 L .65115 .46789 L p F P
0 0 0 r
s
.052 .076 .18 r
.65115 .46789 m .65282 .45444 L .65619 .47322 L p F P
0 0 0 r
s
.26 .371 .651 r
.34885 .46789 m .34718 .45444 L .34381 .47322 L p F P
0 0 0 r
s
.26 .371 .651 r
.34381 .47322 m .34554 .48676 L .34885 .46789 L p F P
0 0 0 r
s
.333 .493 .926 r
.5917 .63241 m .5911 .63935 L .60823 .63297 L p F P
0 0 0 r
s
.333 .493 .926 r
.60823 .63297 m .60908 .62466 L .5917 .63241 L p F P
0 0 0 r
s
.169 .262 .556 r
.39177 .63297 m .39092 .62466 L .4083 .63241 L p F P
0 0 0 r
s
.169 .262 .556 r
.4083 .63241 m .4089 .63935 L .39177 .63297 L p F P
0 0 0 r
s
.072 .105 .259 r
.65452 .44069 m .65282 .45444 L .64573 .43714 L p F P
0 0 0 r
s
.24 .35 .67 r
.64619 .47514 m
.6494 .44841 L
s
.072 .105 .259 r
.64573 .43714 m .64728 .42385 L .65452 .44069 L p F P
0 0 0 r
s
.24 .35 .67 r
.63795 .42498 m
.6494 .44841 L
s
.298 .43 .775 r
.35427 .43714 m .35272 .42385 L .34548 .44069 L p F P
0 0 0 r
s
.298 .43 .775 r
.34548 .44069 m .34718 .45444 L .35427 .43714 L p F P
0 0 0 r
s
.24 .35 .67 r
.3506 .44841 m
.36205 .42498 L
s
.3506 .44841 m
.35381 .47514 L
s
.096 .145 .343 r
.64885 .41027 m .64728 .42385 L .63654 .40923 L p F P
0 0 0 r
s
.096 .145 .343 r
.63654 .40923 m .6379 .39651 L .64885 .41027 L p F P
0 0 0 r
s
.32 .464 .852 r
.36346 .40923 m .3621 .39651 L .35115 .41027 L p F P
0 0 0 r
s
.32 .464 .852 r
.35115 .41027 m .35272 .42385 L .36346 .40923 L p F P
0 0 0 r
s
.173 .262 .553 r
.62719 .34976 m .62603 .36193 L .60865 .3572 L p F P
0 0 0 r
s
.24 .35 .67 r
.6013 .35809 m
.62358 .3758 L
s
.173 .262 .553 r
.60865 .3572 m .60951 .34669 L .62719 .34976 L p F P
0 0 0 r
s
.332 .486 .914 r
.39135 .3572 m .39049 .34669 L .37281 .34976 L p F P
0 0 0 r
s
.332 .486 .914 r
.37281 .34976 m .37397 .36193 L .39135 .3572 L p F P
0 0 0 r
s
.24 .35 .67 r
.37642 .3758 m
.3987 .35809 L
s
.4236 .653 m
.42393 .65756 L
s
.42393 .65756 m
.45276 .66874 L
s
.54724 .66874 m
.57607 .65756 L
s
.57607 .65756 m
.5764 .653 L
s
.313 .46 .84 r
.62676 .58454 m .62561 .59454 L .63702 .57934 L p F P
0 0 0 r
s
.24 .35 .67 r
.63517 .58027 m
.63732 .57689 L
s
.313 .46 .84 r
.63702 .57934 m .63838 .56827 L .62676 .58454 L p F P
0 0 0 r
s
.092 .138 .333 r
.36298 .57934 m .36162 .56827 L .37324 .58454 L p F P
0 0 0 r
s
.092 .138 .333 r
.37324 .58454 m .37439 .59454 L .36298 .57934 L p F P
0 0 0 r
s
.329 .485 .9 r
.61082 .60765 m .60994 .61622 L .62449 .60437 L p F P
0 0 0 r
s
.329 .485 .9 r
.62449 .60437 m .62561 .59454 L .61082 .60765 L p F P
0 0 0 r
s
.124 .196 .438 r
.37551 .60437 m .37439 .59454 L .38918 .60765 L p F P
0 0 0 r
s
.24 .35 .67 r
.37692 .60471 m
.37703 .6056 L
s
.124 .196 .438 r
.38918 .60765 m .39006 .61622 L .37551 .60437 L p F P
0 0 0 r
s
.281 .411 .734 r
.63977 .55697 m .63838 .56827 L .64636 .55059 L p F P
0 0 0 r
s
.281 .411 .734 r
.64636 .55059 m .64792 .53845 L .63977 .55697 L p F P
0 0 0 r
s
.068 .1 .244 r
.35364 .55059 m .35208 .53845 L .36023 .55697 L p F P
0 0 0 r
s
.068 .1 .244 r
.36023 .55697 m .36162 .56827 L .35364 .55059 L p F P
0 0 0 r
s
.33 .49 .931 r
.57124 .64238 m .57087 .64773 L .59051 .6462 L p F P
0 0 0 r
s
.33 .49 .931 r
.59051 .6462 m .5911 .63935 L .57124 .64238 L p F P
0 0 0 r
s
.206 .315 .651 r
.40949 .6462 m .4089 .63935 L .42876 .64238 L p F P
0 0 0 r
s
.206 .315 .651 r
.42876 .64238 m .42913 .64773 L .40949 .6462 L p F P
0 0 0 r
s
.24 .35 .67 r
.54725 .30502 m
.51594 .30021 L
s
.51594 .30021 m
.5163 .26899 L
s
.51594 .30021 m
.48406 .30021 L
s
.48406 .30021 m
.4837 .26899 L
s
.48406 .30021 m
.45275 .30502 L
s
.83 .24 .1 r
.76674 .35131 m
.76148 .34808 L
s
.80506 .34808 m
.81119 .35131 L
s
.76148 .34808 m
.80506 .34808 L
s
.72228 .35131 m
.7179 .34808 L
s
.7179 .34808 m
.76148 .34808 L
s
.67782 .35131 m
.67432 .34808 L
s
.67432 .34808 m
.7179 .34808 L
s
.63074 .34808 m
.67432 .34808 L
s
.58716 .34808 m
.60378 .34808 L
s
.61751 .34808 m
.63074 .34808 L
s
.54358 .34808 m
.58716 .34808 L
s
.5 .34808 m
.54358 .34808 L
s
.45642 .34808 m
.5 .34808 L
s
.41284 .34808 m
.45642 .34808 L
s
.39622 .34808 m
.41284 .34808 L
s
.36926 .34808 m
.38249 .34808 L
s
.32218 .35131 m
.32568 .34808 L
s
.32568 .34808 m
.36926 .34808 L
s
.27772 .35131 m
.2821 .34808 L
s
.2821 .34808 m
.32568 .34808 L
s
.23326 .35131 m
.23852 .34808 L
s
.23852 .34808 m
.2821 .34808 L
s
.18881 .35131 m
.19494 .34808 L
s
.19494 .34808 m
.23852 .34808 L
s
.23 .333 .575 r
.64951 .52605 m .64792 .53845 L .65225 .51929 L p F P
0 0 0 r
s
.23 .333 .575 r
.65225 .51929 m .65394 .50631 L .64951 .52605 L p F P
0 0 0 r
s
.24 .35 .67 r
.64973 .52509 m
.65123 .5 L
s
.045 .066 .152 r
.34775 .51929 m .34606 .50631 L .35049 .52605 L p F P
0 0 0 r
s
.045 .066 .152 r
.35049 .52605 m .35208 .53845 L .34775 .51929 L p F P
0 0 0 r
s
.24 .35 .67 r
.34877 .5 m
.35027 .52509 L
s
.333 .493 .926 r
.59231 .62538 m .5917 .63241 L .60908 .62466 L p F P
0 0 0 r
s
.333 .493 .926 r
.60908 .62466 m .60994 .61622 L .59231 .62538 L p F P
0 0 0 r
s
.169 .262 .556 r
.39092 .62466 m .39006 .61622 L .40769 .62538 L p F P
0 0 0 r
s
.169 .262 .556 r
.40769 .62538 m .4083 .63241 L .39092 .62466 L p F P
0 0 0 r
s
.135 .206 .453 r
.64069 .3703 m .63928 .38353 L .6249 .37387 L p F P
0 0 0 r
s
.135 .206 .453 r
.6249 .37387 m .62603 .36193 L .64069 .3703 L p F P
0 0 0 r
s
.33 .481 .895 r
.3751 .37387 m .37397 .36193 L .35931 .3703 L p F P
0 0 0 r
s
.33 .481 .895 r
.35931 .3703 m .36072 .38353 L .3751 .37387 L p F P
0 0 0 r
s
.24 .35 .67 r
.45203 .65306 m
.45276 .66874 L
s
.45276 .66874 m
.48398 .67449 L
s
.51602 .67449 m
.54724 .66874 L
s
.54724 .66874 m
.54797 .65306 L
s
.57683 .31451 m
.54725 .30502 L
s
.54725 .30502 m
.54831 .27383 L
s
.45275 .30502 m
.45169 .27383 L
s
.45275 .30502 m
.42317 .31451 L
s
.028 .041 .084 r
.65566 .49304 m .65394 .50631 L .65446 .48676 L p F P
0 0 0 r
s
.028 .041 .084 r
.65446 .48676 m .65619 .47322 L .65566 .49304 L p F P
0 0 0 r
s
.203 .284 .476 r
.34554 .48676 m .34381 .47322 L .34434 .49304 L p F P
0 0 0 r
s
.203 .284 .476 r
.34434 .49304 m .34606 .50631 L .34554 .48676 L p F P
0 0 0 r
s
.83 .24 .1 r
.76224 .65188 m
.80595 .65188 L
s
.71853 .65188 m
.76224 .65188 L
s
.67483 .65188 m
.71853 .65188 L
s
.63112 .65188 m
.67483 .65188 L
s
.58741 .65188 m
.63112 .65188 L
s
.57863 .65188 m
.58741 .65188 L
s
.54371 .65188 m
.57059 .65188 L
s
.5 .65188 m
.54371 .65188 L
s
.45629 .65188 m
.5 .65188 L
s
.41259 .65188 m
.42137 .65188 L
s
.42941 .65188 m
.45629 .65188 L
s
.36888 .65188 m
.41259 .65188 L
s
.32517 .65188 m
.36888 .65188 L
s
.28147 .65188 m
.32517 .65188 L
s
.23776 .65188 m
.28147 .65188 L
s
.19405 .65188 m
.23776 .65188 L
s
.76224 .65188 m
.76749 .64765 L
s
.81208 .64765 m
.80595 .65188 L
s
.71853 .65188 m
.72291 .64765 L
s
.67483 .65188 m
.67833 .64765 L
s
.63112 .65188 m
.63375 .64765 L
s
.58741 .65188 m
.58916 .64765 L
s
.41084 .64765 m
.41259 .65188 L
s
.36888 .65188 m
.36625 .64765 L
s
.32517 .65188 m
.32167 .64765 L
s
.28147 .65188 m
.27709 .64765 L
s
.23776 .65188 m
.23251 .64765 L
s
.19405 .65188 m
.18792 .64765 L
s
.052 .076 .18 r
.65797 .45938 m .65619 .47322 L .65282 .45444 L p F P
0 0 0 r
s
.052 .076 .18 r
.65282 .45444 m .65452 .44069 L .65797 .45938 L p F P
0 0 0 r
s
.24 .35 .67 r
.6494 .44841 m
.6546 .4735 L
s
.26 .371 .651 r
.34718 .45444 m .34548 .44069 L .34203 .45938 L p F P
0 0 0 r
s
.26 .371 .651 r
.34203 .45938 m .34381 .47322 L .34718 .45444 L p F P
0 0 0 r
s
.24 .35 .67 r
.3454 .4735 m
.3506 .44841 L
s
.096 .145 .343 r
.65047 .3964 m .64885 .41027 L .6379 .39651 L p F P
0 0 0 r
s
.24 .35 .67 r
.63795 .42498 m
.64102 .39685 L
s
.096 .145 .343 r
.6379 .39651 m .63928 .38353 L .65047 .3964 L p F P
0 0 0 r
s
.24 .35 .67 r
.62358 .3758 m
.64102 .39685 L
s
.32 .464 .852 r
.3621 .39651 m .36072 .38353 L .34953 .3964 L p F P
0 0 0 r
s
.32 .464 .852 r
.34953 .3964 m .35115 .41027 L .3621 .39651 L p F P
0 0 0 r
s
.24 .35 .67 r
.35898 .39685 m
.37642 .3758 L
s
.35898 .39685 m
.36205 .42498 L
s
.48364 .65309 m
.48398 .67449 L
s
.48398 .67449 m
.51602 .67449 L
s
.51602 .67449 m
.51636 .65309 L
s
.072 .105 .259 r
.65625 .42663 m .65452 .44069 L .64728 .42385 L p F P
0 0 0 r
s
.072 .105 .259 r
.64728 .42385 m .64885 .41027 L .65625 .42663 L p F P
0 0 0 r
s
.298 .43 .775 r
.35272 .42385 m .35115 .41027 L .34375 .42663 L p F P
0 0 0 r
s
.298 .43 .775 r
.34375 .42663 m .34548 .44069 L .35272 .42385 L p F P
0 0 0 r
s
.189 .045 .019 r
.62719 .34976 m .60902 .34976 L .59386 .34669 L p F P
0 0 0 r
s
.24 .35 .67 r
.60222 .34597 m
.60356 .32839 L
s
.60217 .34669 m
.60222 .34597 L
s
.189 .045 .019 r
.59386 .34669 m .60951 .34669 L .62719 .34976 L p F P
0 0 0 r
s
.189 .045 .019 r
.60902 .34976 m .59085 .34976 L .57822 .34669 L p F P
0 0 0 r
s
.189 .045 .019 r
.57822 .34669 m .59386 .34669 L .60902 .34976 L p F P
0 0 0 r
s
.189 .045 .019 r
.59085 .34976 m .57268 .34976 L .56258 .34669 L p F P
0 0 0 r
s
.189 .045 .019 r
.56258 .34669 m .57822 .34669 L .59085 .34976 L p F P
0 0 0 r
s
.83 .24 .1 r
.58807 .34976 m
.58891 .35131 L
s
.189 .045 .019 r
.57268 .34976 m .55451 .34976 L .54693 .34669 L p F P
0 0 0 r
s
.189 .045 .019 r
.54693 .34669 m .56258 .34669 L .57268 .34976 L p F P
0 0 0 r
s
.189 .045 .019 r
.55451 .34976 m .53634 .34976 L .53129 .34669 L p F P
0 0 0 r
s
.83 .24 .1 r
.54358 .34808 m
.54365 .34832 L
s
.189 .045 .019 r
.53129 .34669 m .54693 .34669 L .55451 .34976 L p F P
0 0 0 r
s
.83 .24 .1 r
.54404 .34976 m
.54446 .35131 L
s
.189 .045 .019 r
.53634 .34976 m .51817 .34976 L .51564 .34669 L p F P
0 0 0 r
s
.189 .045 .019 r
.51564 .34669 m .53129 .34669 L .53634 .34976 L p F P
0 0 0 r
s
.189 .045 .019 r
.51817 .34976 m .5 .34976 L .5 .34669 L p F P
0 0 0 r
s
.189 .045 .019 r
.5 .34669 m .51564 .34669 L .51817 .34976 L p F P
0 0 0 r
s
.189 .045 .019 r
.5 .34976 m .48183 .34976 L .48436 .34669 L p F P
0 0 0 r
s
.189 .045 .019 r
.48436 .34669 m .5 .34669 L .5 .34976 L p F P
0 0 0 r
s
.83 .24 .1 r
.5 .34976 m
.5 .35131 L
s
.189 .045 .019 r
.48183 .34976 m .46366 .34976 L .46871 .34669 L p F P
0 0 0 r
s
.189 .045 .019 r
.46871 .34669 m .48436 .34669 L .48183 .34976 L p F P
0 0 0 r
s
.189 .045 .019 r
.46366 .34976 m .44549 .34976 L .45307 .34669 L p F P
0 0 0 r
s
.189 .045 .019 r
.45307 .34669 m .46871 .34669 L .46366 .34976 L p F P
0 0 0 r
s
.83 .24 .1 r
.45554 .35131 m
.45596 .34976 L
s
.189 .045 .019 r
.44549 .34976 m .42732 .34976 L .43742 .34669 L p F P
0 0 0 r
s
.189 .045 .019 r
.43742 .34669 m .45307 .34669 L .44549 .34976 L p F P
0 0 0 r
s
.189 .045 .019 r
.42732 .34976 m .40915 .34976 L .42178 .34669 L p F P
0 0 0 r
s
.189 .045 .019 r
.42178 .34669 m .43742 .34669 L .42732 .34976 L p F P
0 0 0 r
s
.189 .045 .019 r
.40915 .34976 m .39098 .34976 L .40614 .34669 L p F P
0 0 0 r
s
.24 .35 .67 r
.39644 .32839 m
.39778 .34597 L
s
.39778 .34597 m
.39783 .34669 L
s
.189 .045 .019 r
.40614 .34669 m .42178 .34669 L .40915 .34976 L p F P
0 0 0 r
s
.83 .24 .1 r
.41109 .35131 m
.41193 .34976 L
s
.189 .045 .019 r
.39098 .34976 m .37281 .34976 L .39049 .34669 L p F P
0 0 0 r
s
.189 .045 .019 r
.39049 .34669 m .40614 .34669 L .39098 .34976 L p F P
0 0 0 r
s
.33 .49 .931 r
.5716 .63697 m .57124 .64238 L .5911 .63935 L p F P
0 0 0 r
s
.33 .49 .931 r
.5911 .63935 m .5917 .63241 L .5716 .63697 L p F P
0 0 0 r
s
.206 .315 .651 r
.4089 .63935 m .4083 .63241 L .4284 .63697 L p F P
0 0 0 r
s
.206 .315 .651 r
.4284 .63697 m .42876 .64238 L .4089 .63935 L p F P
0 0 0 r
s
.24 .35 .67 r
.60356 .32839 m
.57683 .31451 L
s
.57683 .31451 m
.57857 .28338 L
s
.42317 .31451 m
.42143 .28338 L
s
.42317 .31451 m
.39644 .32839 L
s
.329 .485 .9 r
.61171 .59894 m .61082 .60765 L .62561 .59454 L p F P
0 0 0 r
s
.329 .485 .9 r
.62561 .59454 m .62676 .58454 L .61171 .59894 L p F P
0 0 0 r
s
.124 .196 .438 r
.37439 .59454 m .37324 .58454 L .38829 .59894 L p F P
0 0 0 r
s
.24 .35 .67 r
.37583 .595 m
.37593 .59591 L
s
.124 .196 .438 r
.38829 .59894 m .38918 .60765 L .37439 .59454 L p F P
0 0 0 r
s
.313 .46 .84 r
.62792 .57435 m .62676 .58454 L .63838 .56827 L p F P
0 0 0 r
s
.313 .46 .84 r
.63838 .56827 m .63977 .55697 L .62792 .57435 L p F P
0 0 0 r
s
.092 .138 .333 r
.36162 .56827 m .36023 .55697 L .37208 .57435 L p F P
0 0 0 r
s
.092 .138 .333 r
.37208 .57435 m .37324 .58454 L .36162 .56827 L p F P
0 0 0 r
s
.322 .48 .92 r
.54889 .64553 m .54872 .64919 L .57051 .65302 L p F P
0 0 0 r
s
.322 .48 .92 r
.57051 .65302 m .57087 .64773 L .54889 .64553 L p F P
0 0 0 r
s
.792 .25 .107 r
.42949 .65302 m .43956 .65302 L .45824 .64919 L p F P
0 0 0 r
s
.792 .25 .107 r
.45824 .64919 m .45128 .64919 L .42949 .65302 L p F P
0 0 0 r
s
.792 .25 .107 r
.43956 .65302 m .44963 .65302 L .4652 .64919 L p F P
0 0 0 r
s
.83 .24 .1 r
.4562 .65141 m
.45629 .65188 L
s
.792 .25 .107 r
.4652 .64919 m .45824 .64919 L .43956 .65302 L p F P
0 0 0 r
s
.792 .25 .107 r
.44963 .65302 m .45971 .65302 L .47216 .64919 L p F P
0 0 0 r
s
.792 .25 .107 r
.47216 .64919 m .4652 .64919 L .44963 .65302 L p F P
0 0 0 r
s
.24 .35 .67 r
.45188 .64981 m
.45203 .65306 L
s
.83 .24 .1 r
.45542 .64765 m
.45574 .64919 L
s
.792 .25 .107 r
.45971 .65302 m .46978 .65302 L .47912 .64919 L p F P
0 0 0 r
s
.792 .25 .107 r
.47912 .64919 m .47216 .64919 L .45971 .65302 L p F P
0 0 0 r
s
.792 .25 .107 r
.46978 .65302 m .47985 .65302 L .48608 .64919 L p F P
0 0 0 r
s
.792 .25 .107 r
.48608 .64919 m .47912 .64919 L .46978 .65302 L p F P
0 0 0 r
s
.792 .25 .107 r
.47985 .65302 m .48993 .65302 L .49304 .64919 L p F P
0 0 0 r
s
.792 .25 .107 r
.49304 .64919 m .48608 .64919 L .47985 .65302 L p F P
0 0 0 r
s
.24 .35 .67 r
.48362 .65156 m
.48364 .65309 L
s
.792 .25 .107 r
.48993 .65302 m .5 .65302 L .5 .64919 L p F P
0 0 0 r
s
.792 .25 .107 r
.5 .64919 m .49304 .64919 L .48993 .65302 L p F P
0 0 0 r
s
.792 .25 .107 r
.5 .65302 m .51007 .65302 L .50696 .64919 L p F P
0 0 0 r
s
.792 .25 .107 r
.50696 .64919 m .5 .64919 L .5 .65302 L p F P
0 0 0 r
s
.83 .24 .1 r
.5 .64765 m
.5 .64919 L
s
.792 .25 .107 r
.51007 .65302 m .52015 .65302 L .51392 .64919 L p F P
0 0 0 r
s
.792 .25 .107 r
.51392 .64919 m .50696 .64919 L .51007 .65302 L p F P
0 0 0 r
s
.792 .25 .107 r
.52015 .65302 m .53022 .65302 L .52088 .64919 L p F P
0 0 0 r
s
.792 .25 .107 r
.52088 .64919 m .51392 .64919 L .52015 .65302 L p F P
0 0 0 r
s
.24 .35 .67 r
.51636 .65309 m
.51638 .65156 L
s
.792 .25 .107 r
.53022 .65302 m .54029 .65302 L .52784 .64919 L p F P
0 0 0 r
s
.792 .25 .107 r
.52784 .64919 m .52088 .64919 L .53022 .65302 L p F P
0 0 0 r
s
.792 .25 .107 r
.54029 .65302 m .55037 .65302 L .5348 .64919 L p F P
0 0 0 r
s
.792 .25 .107 r
.5348 .64919 m .52784 .64919 L .54029 .65302 L p F P
0 0 0 r
s
.792 .25 .107 r
.55037 .65302 m .56044 .65302 L .54176 .64919 L p F P
0 0 0 r
s
.792 .25 .107 r
.54176 .64919 m .5348 .64919 L .55037 .65302 L p F P
0 0 0 r
s
.792 .25 .107 r
.56044 .65302 m .57051 .65302 L .54872 .64919 L p F P
0 0 0 r
s
.792 .25 .107 r
.54872 .64919 m .54176 .64919 L .56044 .65302 L p F P
0 0 0 r
s
.24 .35 .67 r
.54797 .65306 m
.54812 .64981 L
s
.83 .24 .1 r
.54426 .64919 m
.54458 .64765 L
s
.235 .358 .725 r
.42949 .65302 m .42913 .64773 L .45111 .64553 L p F P
0 0 0 r
s
.235 .358 .725 r
.45111 .64553 m .45128 .64919 L .42949 .65302 L p F P
0 0 0 r
s
.333 .493 .926 r
.59293 .61825 m .59231 .62538 L .60994 .61622 L p F P
0 0 0 r
s
.333 .493 .926 r
.60994 .61622 m .61082 .60765 L .59293 .61825 L p F P
0 0 0 r
s
.169 .262 .556 r
.39006 .61622 m .38918 .60765 L .40707 .61825 L p F P
0 0 0 r
s
.169 .262 .556 r
.40707 .61825 m .40769 .62538 L .39006 .61622 L p F P
0 0 0 r
s
.281 .411 .734 r
.64119 .54545 m .63977 .55697 L .64792 .53845 L p F P
0 0 0 r
s
.281 .411 .734 r
.64792 .53845 m .64951 .52605 L .64119 .54545 L p F P
0 0 0 r
s
.24 .35 .67 r
.6495 .52608 m
.64952 .52602 L
s
.068 .1 .244 r
.35208 .53845 m .35049 .52605 L .35881 .54545 L p F P
0 0 0 r
s
.24 .35 .67 r
.35048 .52602 m
.3505 .52608 L
s
.068 .1 .244 r
.35881 .54545 m .36023 .55697 L .35208 .53845 L p F P
0 0 0 r
s
.135 .206 .453 r
.64213 .35679 m .64069 .3703 L .62603 .36193 L p F P
0 0 0 r
s
.135 .206 .453 r
.62603 .36193 m .62719 .34976 L .64213 .35679 L p F P
0 0 0 r
s
.83 .24 .1 r
.63074 .34808 m
.63337 .35131 L
s
.33 .481 .895 r
.37397 .36193 m .37281 .34976 L .35787 .35679 L p F P
0 0 0 r
s
.83 .24 .1 r
.36663 .35131 m
.36926 .34808 L
s
.33 .481 .895 r
.35787 .35679 m .35931 .3703 L .37397 .36193 L p F P
0 0 0 r
s
.23 .333 .575 r
.65114 .51338 m .64951 .52605 L .65394 .50631 L p F P
0 0 0 r
s
.23 .333 .575 r
.65394 .50631 m .65566 .49304 L .65114 .51338 L p F P
0 0 0 r
s
.24 .35 .67 r
.65123 .5 m
.6546 .4735 L
s
.045 .066 .152 r
.34606 .50631 m .34434 .49304 L .34886 .51338 L p F P
0 0 0 r
s
.24 .35 .67 r
.3454 .4735 m
.34877 .5 L
s
.045 .066 .152 r
.34886 .51338 m .35049 .52605 L .34606 .50631 L p F P
0 0 0 r
s
.33 .49 .931 r
.57198 .63152 m .5716 .63697 L .5917 .63241 L p F P
0 0 0 r
s
.33 .49 .931 r
.5917 .63241 m .59231 .62538 L .57198 .63152 L p F P
0 0 0 r
s
.24 .35 .67 r
.5919 .6255 m
.59232 .62524 L
s
.206 .315 .651 r
.4083 .63241 m .40769 .62538 L .42802 .63152 L p F P
0 0 0 r
s
.24 .35 .67 r
.40768 .62524 m
.4081 .6255 L
s
.206 .315 .651 r
.42802 .63152 m .4284 .63697 L .4083 .63241 L p F P
0 0 0 r
s
.322 .48 .92 r
.54907 .64183 m .54889 .64553 L .57087 .64773 L p F P
0 0 0 r
s
.322 .48 .92 r
.57087 .64773 m .57124 .64238 L .54907 .64183 L p F P
0 0 0 r
s
.235 .358 .725 r
.42913 .64773 m .42876 .64238 L .45093 .64183 L p F P
0 0 0 r
s
.235 .358 .725 r
.45093 .64183 m .45111 .64553 L .42913 .64773 L p F P
0 0 0 r
s
.028 .041 .084 r
.65743 .47947 m .65566 .49304 L .65619 .47322 L p F P
0 0 0 r
s
.028 .041 .084 r
.65619 .47322 m .65797 .45938 L .65743 .47947 L p F P
0 0 0 r
s
.203 .284 .476 r
.34381 .47322 m .34203 .45938 L .34257 .47947 L p F P
0 0 0 r
s
.203 .284 .476 r
.34257 .47947 m .34434 .49304 L .34381 .47322 L p F P
0 0 0 r
s
.096 .145 .343 r
.65211 .38223 m .65047 .3964 L .63928 .38353 L p F P
0 0 0 r
s
.096 .145 .343 r
.63928 .38353 m .64069 .3703 L .65211 .38223 L p F P
0 0 0 r
s
.32 .464 .852 r
.36072 .38353 m .35931 .3703 L .34789 .38223 L p F P
0 0 0 r
s
.32 .464 .852 r
.34789 .38223 m .34953 .3964 L .36072 .38353 L p F P
0 0 0 r
s
.24 .35 .67 r
.62636 .34623 m
.60356 .32839 L
s
.60356 .32839 m
.60592 .29735 L
s
.39644 .32839 m
.39408 .29735 L
s
.39644 .32839 m
.37364 .34623 L
s
.052 .076 .18 r
.65979 .44522 m .65797 .45938 L .65452 .44069 L p F P
0 0 0 r
s
.052 .076 .18 r
.65452 .44069 m .65625 .42663 L .65979 .44522 L p F P
0 0 0 r
s
.26 .371 .651 r
.34548 .44069 m .34375 .42663 L .34021 .44522 L p F P
0 0 0 r
s
.26 .371 .651 r
.34021 .44522 m .34203 .45938 L .34548 .44069 L p F P
0 0 0 r
s
.072 .105 .259 r
.65803 .41225 m .65625 .42663 L .64885 .41027 L p F P
0 0 0 r
s
.24 .35 .67 r
.6494 .44841 m
.65276 .42048 L
s
.072 .105 .259 r
.64885 .41027 m .65047 .3964 L .65803 .41225 L p F P
0 0 0 r
s
.24 .35 .67 r
.64102 .39685 m
.65276 .42048 L
s
.298 .43 .775 r
.35115 .41027 m .34953 .3964 L .34197 .41225 L p F P
0 0 0 r
s
.298 .43 .775 r
.34197 .41225 m .34375 .42663 L .35115 .41027 L p F P
0 0 0 r
s
.24 .35 .67 r
.34724 .42048 m
.35898 .39685 L
s
.34724 .42048 m
.3506 .44841 L
s
.329 .485 .9 r
.61261 .59009 m .61171 .59894 L .62676 .58454 L p F P
0 0 0 r
s
.329 .485 .9 r
.62676 .58454 m .62792 .57435 L .61261 .59009 L p F P
0 0 0 r
s
.24 .35 .67 r
.62633 .576 m
.6266 .57358 L
s
.124 .196 .438 r
.37324 .58454 m .37208 .57435 L .38739 .59009 L p F P
0 0 0 r
s
.24 .35 .67 r
.3734 .57358 m
.37367 .576 L
s
.37471 .58511 m
.37481 .58604 L
s
.124 .196 .438 r
.38739 .59009 m .38829 .59894 L .37324 .58454 L p F P
0 0 0 r
s
.333 .493 .926 r
.59355 .61103 m .59293 .61825 L .61082 .60765 L p F P
0 0 0 r
s
.333 .493 .926 r
.61082 .60765 m .61171 .59894 L .59355 .61103 L p F P
0 0 0 r
s
.169 .262 .556 r
.38918 .60765 m .38829 .59894 L .40645 .61103 L p F P
0 0 0 r
s
.169 .262 .556 r
.40645 .61103 m .40707 .61825 L .38918 .60765 L p F P
0 0 0 r
s
.313 .46 .84 r
.62911 .56398 m .62792 .57435 L .63977 .55697 L p F P
0 0 0 r
s
.24 .35 .67 r
.6266 .57358 m
.62832 .5709 L
s
.313 .46 .84 r
.63977 .55697 m .64119 .54545 L .62911 .56398 L p F P
0 0 0 r
s
.092 .138 .333 r
.36023 .55697 m .35881 .54545 L .37089 .56398 L p F P
0 0 0 r
s
.092 .138 .333 r
.37089 .56398 m .37208 .57435 L .36023 .55697 L p F P
0 0 0 r
s
.24 .35 .67 r
.37168 .5709 m
.3734 .57358 L
s
.322 .48 .92 r
.54924 .63812 m .54907 .64183 L .57124 .64238 L p F P
0 0 0 r
s
.322 .48 .92 r
.57124 .64238 m .5716 .63697 L .54924 .63812 L p F P
0 0 0 r
s
.235 .358 .725 r
.42876 .64238 m .4284 .63697 L .45076 .63812 L p F P
0 0 0 r
s
.235 .358 .725 r
.45076 .63812 m .45093 .64183 L .42876 .64238 L p F P
0 0 0 r
s
.33 .49 .931 r
.57235 .626 m .57198 .63152 L .59231 .62538 L p F P
0 0 0 r
s
.33 .49 .931 r
.59231 .62538 m .59293 .61825 L .57235 .626 L p F P
0 0 0 r
s
.206 .315 .651 r
.40769 .62538 m .40707 .61825 L .42765 .626 L p F P
0 0 0 r
s
.206 .315 .651 r
.42765 .626 m .42802 .63152 L .40769 .62538 L p F P
0 0 0 r
s
.24 .35 .67 r
.42838 .63679 m
.42894 .637 L
s
.57106 .637 m
.57162 .63679 L
s
.83 .24 .1 r
.77186 .36147 m
.76674 .35131 L
s
.81119 .35131 m
.81717 .36147 L
s
.76674 .35131 m
.81119 .35131 L
s
.72655 .36147 m
.72228 .35131 L
s
.72228 .35131 m
.76674 .35131 L
s
.68124 .36147 m
.67782 .35131 L
s
.67782 .35131 m
.72228 .35131 L
s
.63337 .35131 m
.67782 .35131 L
s
.58891 .35131 m
.62772 .35131 L
s
.63048 .35131 m
.63337 .35131 L
s
.54446 .35131 m
.58891 .35131 L
s
.5 .35131 m
.54446 .35131 L
s
.45554 .35131 m
.5 .35131 L
s
.41109 .35131 m
.45554 .35131 L
s
.37228 .35131 m
.41109 .35131 L
s
.36663 .35131 m
.36952 .35131 L
s
.31876 .36147 m
.32218 .35131 L
s
.32218 .35131 m
.36663 .35131 L
s
.27345 .36147 m
.27772 .35131 L
s
.27772 .35131 m
.32218 .35131 L
s
.22814 .36147 m
.23326 .35131 L
s
.23326 .35131 m
.27772 .35131 L
s
.18283 .36147 m
.18881 .35131 L
s
.18881 .35131 m
.23326 .35131 L
s
.281 .411 .734 r
.64264 .53369 m .64119 .54545 L .64951 .52605 L p F P
0 0 0 r
s
.281 .411 .734 r
.64951 .52605 m .65114 .51338 L .64264 .53369 L p F P
0 0 0 r
s
.068 .1 .244 r
.35049 .52605 m .34886 .51338 L .35736 .53369 L p F P
0 0 0 r
s
.068 .1 .244 r
.35736 .53369 m .35881 .54545 L .35049 .52605 L p F P
0 0 0 r
s
.291 .066 .028 r
.64213 .35679 m .62183 .35679 L .60902 .34976 L p F P
0 0 0 r
s
.24 .35 .67 r
.62358 .3758 m
.62537 .35679 L
s
.291 .066 .028 r
.60902 .34976 m .62719 .34976 L .64213 .35679 L p F P
0 0 0 r
s
.24 .35 .67 r
.626 .35006 m
.62601 .34991 L
s
.62601 .34991 m
.62636 .34623 L
s
.83 .24 .1 r
.63337 .35131 m
.63376 .35285 L
s
.291 .066 .028 r
.62183 .35679 m .60152 .35679 L .59085 .34976 L p F P
0 0 0 r
s
.291 .066 .028 r
.59085 .34976 m .60902 .34976 L .62183 .35679 L p F P
0 0 0 r
s
.291 .066 .028 r
.60152 .35679 m .58122 .35679 L .57268 .34976 L p F P
0 0 0 r
s
.291 .066 .028 r
.57268 .34976 m .59085 .34976 L .60152 .35679 L p F P
0 0 0 r
s
.291 .066 .028 r
.58122 .35679 m .56091 .35679 L .55451 .34976 L p F P
0 0 0 r
s
.291 .066 .028 r
.55451 .34976 m .57268 .34976 L .58122 .35679 L p F P
0 0 0 r
s
.291 .066 .028 r
.56091 .35679 m .54061 .35679 L .53634 .34976 L p F P
0 0 0 r
s
.291 .066 .028 r
.53634 .34976 m .55451 .34976 L .56091 .35679 L p F P
0 0 0 r
s
.291 .066 .028 r
.54061 .35679 m .5203 .35679 L .51817 .34976 L p F P
0 0 0 r
s
.291 .066 .028 r
.51817 .34976 m .53634 .34976 L .54061 .35679 L p F P
0 0 0 r
s
.291 .066 .028 r
.5203 .35679 m .5 .35679 L .5 .34976 L p F P
0 0 0 r
s
.291 .066 .028 r
.5 .34976 m .51817 .34976 L .5203 .35679 L p F P
0 0 0 r
s
.291 .066 .028 r
.5 .35679 m .4797 .35679 L .48183 .34976 L p F P
0 0 0 r
s
.291 .066 .028 r
.48183 .34976 m .5 .34976 L .5 .35679 L p F P
0 0 0 r
s
.291 .066 .028 r
.4797 .35679 m .45939 .35679 L .46366 .34976 L p F P
0 0 0 r
s
.291 .066 .028 r
.46366 .34976 m .48183 .34976 L .4797 .35679 L p F P
0 0 0 r
s
.291 .066 .028 r
.45939 .35679 m .43909 .35679 L .44549 .34976 L p F P
0 0 0 r
s
.291 .066 .028 r
.44549 .34976 m .46366 .34976 L .45939 .35679 L p F P
0 0 0 r
s
.291 .066 .028 r
.43909 .35679 m .41878 .35679 L .42732 .34976 L p F P
0 0 0 r
s
.291 .066 .028 r
.42732 .34976 m .44549 .34976 L .43909 .35679 L p F P
0 0 0 r
s
.291 .066 .028 r
.41878 .35679 m .39848 .35679 L .40915 .34976 L p F P
0 0 0 r
s
.291 .066 .028 r
.40915 .34976 m .42732 .34976 L .41878 .35679 L p F P
0 0 0 r
s
.291 .066 .028 r
.39848 .35679 m .37817 .35679 L .39098 .34976 L p F P
0 0 0 r
s
.291 .066 .028 r
.39098 .34976 m .40915 .34976 L .39848 .35679 L p F P
0 0 0 r
s
.291 .066 .028 r
.37817 .35679 m .35787 .35679 L .37281 .34976 L p F P
0 0 0 r
s
.83 .24 .1 r
.36624 .35285 m
.36663 .35131 L
s
.24 .35 .67 r
.37463 .35679 m
.37642 .3758 L
s
.291 .066 .028 r
.37281 .34976 m .39098 .34976 L .37817 .35679 L p F P
0 0 0 r
s
.24 .35 .67 r
.37399 .34991 m
.374 .35006 L
s
.37364 .34623 m
.37399 .34991 L
s
.54831 .27383 m
.5163 .26899 L
s
.5163 .26899 m
.51668 .23634 L
s
.5163 .26899 m
.4837 .26899 L
s
.4837 .26899 m
.48332 .23634 L
s
.4837 .26899 m
.45169 .27383 L
s
.23 .333 .575 r
.6528 .50043 m .65114 .51338 L .65566 .49304 L p F P
0 0 0 r
s
.23 .333 .575 r
.65566 .49304 m .65743 .47947 L .6528 .50043 L p F P
0 0 0 r
s
.24 .35 .67 r
.65308 .49916 m
.6546 .4735 L
s
.045 .066 .152 r
.34434 .49304 m .34257 .47947 L .3472 .50043 L p F P
0 0 0 r
s
.045 .066 .152 r
.3472 .50043 m .34886 .51338 L .34434 .49304 L p F P
0 0 0 r
s
.24 .35 .67 r
.3454 .4735 m
.34692 .49916 L
s
.83 .24 .1 r
.76749 .64765 m
.81208 .64765 L
s
.72291 .64765 m
.76749 .64765 L
s
.67833 .64765 m
.72291 .64765 L
s
.63375 .64765 m
.67833 .64765 L
s
.58916 .64765 m
.63375 .64765 L
s
.55232 .64765 m
.58916 .64765 L
s
.54458 .64765 m
.54879 .64765 L
s
.5 .64765 m
.54458 .64765 L
s
.45542 .64765 m
.5 .64765 L
s
.41084 .64765 m
.44768 .64765 L
s
.45121 .64765 m
.45542 .64765 L
s
.36625 .64765 m
.41084 .64765 L
s
.32167 .64765 m
.36625 .64765 L
s
.27709 .64765 m
.32167 .64765 L
s
.23251 .64765 m
.27709 .64765 L
s
.18792 .64765 m
.23251 .64765 L
s
.76749 .64765 m
.77257 .63648 L
s
.818 .63648 m
.81208 .64765 L
s
.72291 .64765 m
.72714 .63648 L
s
.67833 .64765 m
.68172 .63648 L
s
.63375 .64765 m
.63629 .63648 L
s
.58916 .64765 m
.59086 .63648 L
s
.40914 .63648 m
.41084 .64765 L
s
.36625 .64765 m
.36371 .63648 L
s
.32167 .64765 m
.31828 .63648 L
s
.27709 .64765 m
.27286 .63648 L
s
.23251 .64765 m
.22743 .63648 L
s
.18792 .64765 m
.182 .63648 L
s
.311 .464 .899 r
.52507 .63951 m .52502 .6414 L .54872 .64919 L p F P
0 0 0 r
s
.24 .35 .67 r
.54815 .64919 m
.54816 .64901 L
s
.311 .464 .899 r
.54872 .64919 m .54889 .64553 L .52507 .63951 L p F P
0 0 0 r
s
.24 .35 .67 r
.54887 .64552 m
.54889 .64551 L
s
.936 .286 .123 r
.45128 .64919 m .45824 .64919 L .47855 .6414 L p F P
0 0 0 r
s
.936 .286 .123 r
.47855 .6414 m .47498 .6414 L .45128 .64919 L p F P
0 0 0 r
s
.936 .286 .123 r
.45824 .64919 m .4652 .64919 L .48213 .6414 L p F P
0 0 0 r
s
.936 .286 .123 r
.48213 .6414 m .47855 .6414 L .45824 .64919 L p F P
0 0 0 r
s
.936 .286 .123 r
.4652 .64919 m .47216 .64919 L .4857 .6414 L p F P
0 0 0 r
s
.936 .286 .123 r
.4857 .6414 m .48213 .6414 L .4652 .64919 L p F P
0 0 0 r
s
.936 .286 .123 r
.47216 .64919 m .47912 .64919 L .48928 .6414 L p F P
0 0 0 r
s
.936 .286 .123 r
.48928 .6414 m .4857 .6414 L .47216 .64919 L p F P
0 0 0 r
s
.936 .286 .123 r
.47912 .64919 m .48608 .64919 L .49285 .6414 L p F P
0 0 0 r
s
.936 .286 .123 r
.49285 .6414 m .48928 .6414 L .47912 .64919 L p F P
0 0 0 r
s
.936 .286 .123 r
.48608 .64919 m .49304 .64919 L .49643 .6414 L p F P
0 0 0 r
s
.936 .286 .123 r
.49643 .6414 m .49285 .6414 L .48608 .64919 L p F P
0 0 0 r
s
.936 .286 .123 r
.49304 .64919 m .5 .64919 L .5 .6414 L p F P
0 0 0 r
s
.936 .286 .123 r
.5 .6414 m .49643 .6414 L .49304 .64919 L p F P
0 0 0 r
s
.936 .286 .123 r
.5 .64919 m .50696 .64919 L .50357 .6414 L p F P
0 0 0 r
s
.936 .286 .123 r
.50357 .6414 m .5 .6414 L .5 .64919 L p F P
0 0 0 r
s
.936 .286 .123 r
.50696 .64919 m .51392 .64919 L .50715 .6414 L p F P
0 0 0 r
s
.936 .286 .123 r
.50715 .6414 m .50357 .6414 L .50696 .64919 L p F P
0 0 0 r
s
.936 .286 .123 r
.51392 .64919 m .52088 .64919 L .51072 .6414 L p F P
0 0 0 r
s
.936 .286 .123 r
.51072 .6414 m .50715 .6414 L .51392 .64919 L p F P
0 0 0 r
s
.936 .286 .123 r
.52088 .64919 m .52784 .64919 L .5143 .6414 L p F P
0 0 0 r
s
.936 .286 .123 r
.5143 .6414 m .51072 .6414 L .52088 .64919 L p F P
0 0 0 r
s
.936 .286 .123 r
.52784 .64919 m .5348 .64919 L .51787 .6414 L p F P
0 0 0 r
s
.936 .286 .123 r
.51787 .6414 m .5143 .6414 L .52784 .64919 L p F P
0 0 0 r
s
.936 .286 .123 r
.5348 .64919 m .54176 .64919 L .52145 .6414 L p F P
0 0 0 r
s
.936 .286 .123 r
.52145 .6414 m .51787 .6414 L .5348 .64919 L p F P
0 0 0 r
s
.936 .286 .123 r
.54176 .64919 m .54872 .64919 L .52502 .6414 L p F P
0 0 0 r
s
.936 .286 .123 r
.52502 .6414 m .52145 .6414 L .54176 .64919 L p F P
0 0 0 r
s
.26 .393 .784 r
.45128 .64919 m .45111 .64553 L .47493 .63951 L p F P
0 0 0 r
s
.83 .24 .1 r
.45541 .6475 m
.45542 .64765 L
s
.24 .35 .67 r
.45111 .64551 m
.45113 .64552 L
s
.45184 .64896 m
.45184 .64901 L
s
.26 .393 .784 r
.47493 .63951 m .47498 .6414 L .45128 .64919 L p F P
0 0 0 r
s
.322 .48 .92 r
.54941 .63437 m .54924 .63812 L .5716 .63697 L p F P
0 0 0 r
s
.322 .48 .92 r
.5716 .63697 m .57198 .63152 L .54941 .63437 L p F P
0 0 0 r
s
.235 .358 .725 r
.4284 .63697 m .42802 .63152 L .45059 .63437 L p F P
0 0 0 r
s
.235 .358 .725 r
.45059 .63437 m .45076 .63812 L .4284 .63697 L p F P
0 0 0 r
s
.24 .35 .67 r
.62636 .34623 m
.63216 .35312 L
s
.62636 .34623 m
.62926 .31531 L
s
.37364 .34623 m
.37074 .31531 L
s
.36784 .35312 m
.37364 .34623 L
s
.096 .145 .343 r
.6538 .36775 m .65211 .38223 L .64069 .3703 L p F P
0 0 0 r
s
.096 .145 .343 r
.64069 .3703 m .64213 .35679 L .6538 .36775 L p F P
0 0 0 r
s
.24 .35 .67 r
.64102 .39685 m
.64422 .36744 L
s
.63525 .35679 m
.64422 .36744 L
s
.32 .464 .852 r
.35931 .3703 m .35787 .35679 L .3462 .36775 L p F P
0 0 0 r
s
.24 .35 .67 r
.35578 .36744 m
.36475 .35679 L
s
.32 .464 .852 r
.3462 .36775 m .34789 .38223 L .35931 .3703 L p F P
0 0 0 r
s
.24 .35 .67 r
.35578 .36744 m
.35898 .39685 L
s
.46339 .64787 m
.48362 .65156 L
s
.51638 .65156 m
.53661 .64787 L
s
.57857 .28338 m
.54831 .27383 L
s
.54831 .27383 m
.54943 .24121 L
s
.45169 .27383 m
.45057 .24121 L
s
.45169 .27383 m
.42143 .28338 L
s
.028 .041 .084 r
.65923 .46558 m .65743 .47947 L .65797 .45938 L p F P
0 0 0 r
s
.028 .041 .084 r
.65797 .45938 m .65979 .44522 L .65923 .46558 L p F P
0 0 0 r
s
.203 .284 .476 r
.34203 .45938 m .34021 .44522 L .34077 .46558 L p F P
0 0 0 r
s
.203 .284 .476 r
.34077 .46558 m .34257 .47947 L .34203 .45938 L p F P
0 0 0 r
s
.333 .493 .926 r
.59419 .60371 m .59355 .61103 L .61171 .59894 L p F P
0 0 0 r
s
.333 .493 .926 r
.61171 .59894 m .61261 .59009 L .59419 .60371 L p F P
0 0 0 r
s
.169 .262 .556 r
.38829 .59894 m .38739 .59009 L .40581 .60371 L p F P
0 0 0 r
s
.169 .262 .556 r
.40581 .60371 m .40645 .61103 L .38829 .59894 L p F P
0 0 0 r
s
.33 .49 .931 r
.57273 .62042 m .57235 .626 L .59293 .61825 L p F P
0 0 0 r
s
.33 .49 .931 r
.59293 .61825 m .59355 .61103 L .57273 .62042 L p F P
0 0 0 r
s
.206 .315 .651 r
.40707 .61825 m .40645 .61103 L .42727 .62042 L p F P
0 0 0 r
s
.206 .315 .651 r
.42727 .62042 m .42765 .626 L .40707 .61825 L p F P
0 0 0 r
s
.329 .485 .9 r
.61353 .5811 m .61261 .59009 L .62792 .57435 L p F P
0 0 0 r
s
.329 .485 .9 r
.62792 .57435 m .62911 .56398 L .61353 .5811 L p F P
0 0 0 r
s
.124 .196 .438 r
.37208 .57435 m .37089 .56398 L .38647 .5811 L p F P
0 0 0 r
s
.124 .196 .438 r
.38647 .5811 m .38739 .59009 L .37208 .57435 L p F P
0 0 0 r
s
.052 .076 .18 r
.66164 .43072 m .65979 .44522 L .65625 .42663 L p F P
0 0 0 r
s
.052 .076 .18 r
.65625 .42663 m .65803 .41225 L .66164 .43072 L p F P
0 0 0 r
s
.24 .35 .67 r
.65276 .42048 m
.65812 .44579 L
s
.26 .371 .651 r
.34375 .42663 m .34197 .41225 L .33836 .43072 L p F P
0 0 0 r
s
.26 .371 .651 r
.33836 .43072 m .34021 .44522 L .34375 .42663 L p F P
0 0 0 r
s
.24 .35 .67 r
.34188 .44579 m
.34724 .42048 L
s
.072 .105 .259 r
.65985 .39754 m .65803 .41225 L .65047 .3964 L p F P
0 0 0 r
s
.072 .105 .259 r
.65047 .3964 m .65211 .38223 L .65985 .39754 L p F P
0 0 0 r
s
.298 .43 .775 r
.34953 .3964 m .34789 .38223 L .34015 .39754 L p F P
0 0 0 r
s
.298 .43 .775 r
.34015 .39754 m .34197 .41225 L .34953 .3964 L p F P
0 0 0 r
s
.311 .464 .899 r
.52511 .63761 m .52507 .63951 L .54889 .64553 L p F P
0 0 0 r
s
.311 .464 .899 r
.54889 .64553 m .54907 .64183 L .52511 .63761 L p F P
0 0 0 r
s
.26 .393 .784 r
.45111 .64553 m .45093 .64183 L .47489 .63761 L p F P
0 0 0 r
s
.24 .35 .67 r
.45167 .64534 m
.45168 .64538 L
s
.26 .393 .784 r
.47489 .63761 m .47493 .63951 L .45111 .64553 L p F P
0 0 0 r
s
.24 .35 .67 r
.48347 .64207 m
.48362 .65156 L
s
.48362 .65156 m
.51638 .65156 L
s
.51638 .65156 m
.51653 .64207 L
s
.313 .46 .84 r
.63032 .55341 m .62911 .56398 L .64119 .54545 L p F P
0 0 0 r
s
.313 .46 .84 r
.64119 .54545 m .64264 .53369 L .63032 .55341 L p F P
0 0 0 r
s
.092 .138 .333 r
.35881 .54545 m .35736 .53369 L .36968 .55341 L p F P
0 0 0 r
s
.092 .138 .333 r
.36968 .55341 m .37089 .56398 L .35881 .54545 L p F P
0 0 0 r
s
.322 .48 .92 r
.54959 .6306 m .54941 .63437 L .57198 .63152 L p F P
0 0 0 r
s
.322 .48 .92 r
.57198 .63152 m .57235 .626 L .54959 .6306 L p F P
0 0 0 r
s
.235 .358 .725 r
.42802 .63152 m .42765 .626 L .45041 .6306 L p F P
0 0 0 r
s
.235 .358 .725 r
.45041 .6306 m .45059 .63437 L .42802 .63152 L p F P
0 0 0 r
s
.24 .35 .67 r
.60592 .29735 m
.57857 .28338 L
s
.57857 .28338 m
.58039 .25081 L
s
.42143 .28338 m
.41961 .25081 L
s
.42143 .28338 m
.39408 .29735 L
s
.311 .464 .899 r
.52516 .6357 m .52511 .63761 L .54907 .64183 L p F P
0 0 0 r
s
.311 .464 .899 r
.54907 .64183 m .54924 .63812 L .52516 .6357 L p F P
0 0 0 r
s
.26 .393 .784 r
.45093 .64183 m .45076 .63812 L .47484 .6357 L p F P
0 0 0 r
s
.24 .35 .67 r
.45151 .64169 m
.45151 .64173 L
s
.26 .393 .784 r
.47484 .6357 m .47489 .63761 L .45093 .64183 L p F P
0 0 0 r
s
.281 .411 .734 r
.64412 .52169 m .64264 .53369 L .65114 .51338 L p F P
0 0 0 r
s
.281 .411 .734 r
.65114 .51338 m .6528 .50043 L .64412 .52169 L p F P
0 0 0 r
s
.24 .35 .67 r
.65207 .50221 m
.65306 .49926 L
s
.068 .1 .244 r
.34886 .51338 m .3472 .50043 L .35588 .52169 L p F P
0 0 0 r
s
.24 .35 .67 r
.34694 .49926 m
.34793 .50221 L
s
.068 .1 .244 r
.35588 .52169 m .35736 .53369 L .34886 .51338 L p F P
0 0 0 r
s
.33 .49 .931 r
.57311 .61479 m .57273 .62042 L .59355 .61103 L p F P
0 0 0 r
s
.33 .49 .931 r
.59355 .61103 m .59419 .60371 L .57311 .61479 L p F P
0 0 0 r
s
.206 .315 .651 r
.40645 .61103 m .40581 .60371 L .42689 .61479 L p F P
0 0 0 r
s
.206 .315 .651 r
.42689 .61479 m .42727 .62042 L .40645 .61103 L p F P
0 0 0 r
s
.333 .493 .926 r
.59483 .59629 m .59419 .60371 L .61261 .59009 L p F P
0 0 0 r
s
.333 .493 .926 r
.61261 .59009 m .61353 .5811 L .59483 .59629 L p F P
0 0 0 r
s
.169 .262 .556 r
.38739 .59009 m .38647 .5811 L .40517 .59629 L p F P
0 0 0 r
s
.169 .262 .556 r
.40517 .59629 m .40581 .60371 L .38739 .59009 L p F P
0 0 0 r
s
.311 .464 .899 r
.5252 .63378 m .52516 .6357 L .54924 .63812 L p F P
0 0 0 r
s
.311 .464 .899 r
.54924 .63812 m .54941 .63437 L .5252 .63378 L p F P
0 0 0 r
s
.83 .24 .1 r
.54489 .6436 m
.54543 .63648 L
s
.26 .393 .784 r
.45076 .63812 m .45059 .63437 L .4748 .63378 L p F P
0 0 0 r
s
.24 .35 .67 r
.45134 .63801 m
.45134 .63806 L
s
.26 .393 .784 r
.4748 .63378 m .47484 .6357 L .45076 .63812 L p F P
0 0 0 r
s
.83 .24 .1 r
.45457 .63648 m
.45511 .6436 L
s
.322 .48 .92 r
.54977 .6268 m .54959 .6306 L .57235 .626 L p F P
0 0 0 r
s
.322 .48 .92 r
.57235 .626 m .57273 .62042 L .54977 .6268 L p F P
0 0 0 r
s
.235 .358 .725 r
.42765 .626 m .42727 .62042 L .45023 .6268 L p F P
0 0 0 r
s
.235 .358 .725 r
.45023 .6268 m .45041 .6306 L .42765 .626 L p F P
0 0 0 r
s
.23 .333 .575 r
.6545 .48719 m .6528 .50043 L .65743 .47947 L p F P
0 0 0 r
s
.23 .333 .575 r
.65743 .47947 m .65923 .46558 L .6545 .48719 L p F P
0 0 0 r
s
.24 .35 .67 r
.6546 .4735 m
.65812 .44579 L
s
.045 .066 .152 r
.34257 .47947 m .34077 .46558 L .3455 .48719 L p F P
0 0 0 r
s
.24 .35 .67 r
.34188 .44579 m
.3454 .4735 L
s
.045 .066 .152 r
.3455 .48719 m .3472 .50043 L .34257 .47947 L p F P
0 0 0 r
s
.411 .099 .041 r
.6538 .36775 m .63183 .36775 L .62183 .35679 L p F P
0 0 0 r
s
.411 .099 .041 r
.62183 .35679 m .64213 .35679 L .6538 .36775 L p F P
0 0 0 r
s
.24 .35 .67 r
.64497 .36063 m
.64758 .33666 L
s
.411 .099 .041 r
.63183 .36775 m .60985 .36775 L .60152 .35679 L p F P
0 0 0 r
s
.411 .099 .041 r
.60152 .35679 m .62183 .35679 L .63183 .36775 L p F P
0 0 0 r
s
.411 .099 .041 r
.60985 .36775 m .58788 .36775 L .58122 .35679 L p F P
0 0 0 r
s
.411 .099 .041 r
.58122 .35679 m .60152 .35679 L .60985 .36775 L p F P
0 0 0 r
s
.411 .099 .041 r
.58788 .36775 m .56591 .36775 L .56091 .35679 L p F P
0 0 0 r
s
.411 .099 .041 r
.56091 .35679 m .58122 .35679 L .58788 .36775 L p F P
0 0 0 r
s
.411 .099 .041 r
.56591 .36775 m .54394 .36775 L .54061 .35679 L p F P
0 0 0 r
s
.83 .24 .1 r
.54492 .35679 m
.54508 .35872 L
s
.411 .099 .041 r
.54061 .35679 m .56091 .35679 L .56591 .36775 L p F P
0 0 0 r
s
.411 .099 .041 r
.54394 .36775 m .52197 .36775 L .5203 .35679 L p F P
0 0 0 r
s
.411 .099 .041 r
.5203 .35679 m .54061 .35679 L .54394 .36775 L p F P
0 0 0 r
s
.411 .099 .041 r
.52197 .36775 m .5 .36775 L .5 .35679 L p F P
0 0 0 r
s
.411 .099 .041 r
.5 .35679 m .5203 .35679 L .52197 .36775 L p F P
0 0 0 r
s
.411 .099 .041 r
.5 .36775 m .47803 .36775 L .4797 .35679 L p F P
0 0 0 r
s
.411 .099 .041 r
.4797 .35679 m .5 .35679 L .5 .36775 L p F P
0 0 0 r
s
.411 .099 .041 r
.47803 .36775 m .45606 .36775 L .45939 .35679 L p F P
0 0 0 r
s
.411 .099 .041 r
.45939 .35679 m .4797 .35679 L .47803 .36775 L p F P
0 0 0 r
s
.411 .099 .041 r
.45606 .36775 m .43409 .36775 L .43909 .35679 L p F P
0 0 0 r
s
.411 .099 .041 r
.43909 .35679 m .45939 .35679 L .45606 .36775 L p F P
0 0 0 r
s
.411 .099 .041 r
.43409 .36775 m .41212 .36775 L .41878 .35679 L p F P
0 0 0 r
s
.411 .099 .041 r
.41878 .35679 m .43909 .35679 L .43409 .36775 L p F P
0 0 0 r
s
.411 .099 .041 r
.41212 .36775 m .39015 .36775 L .39848 .35679 L p F P
0 0 0 r
s
.411 .099 .041 r
.39848 .35679 m .41878 .35679 L .41212 .36775 L p F P
0 0 0 r
s
.411 .099 .041 r
.39015 .36775 m .36817 .36775 L .37817 .35679 L p F P
0 0 0 r
s
.411 .099 .041 r
.37817 .35679 m .39848 .35679 L .39015 .36775 L p F P
0 0 0 r
s
.411 .099 .041 r
.36817 .36775 m .3462 .36775 L .35787 .35679 L p F P
0 0 0 r
s
.24 .35 .67 r
.35242 .33666 m
.35503 .36063 L
s
.411 .099 .041 r
.35787 .35679 m .37817 .35679 L .36817 .36775 L p F P
0 0 0 r
s
.329 .485 .9 r
.61447 .57195 m .61353 .5811 L .62911 .56398 L p F P
0 0 0 r
s
.329 .485 .9 r
.62911 .56398 m .63032 .55341 L .61447 .57195 L p F P
0 0 0 r
s
.124 .196 .438 r
.37089 .56398 m .36968 .55341 L .38553 .57195 L p F P
0 0 0 r
s
.24 .35 .67 r
.3724 .5648 m
.37251 .56577 L
s
.124 .196 .438 r
.38553 .57195 m .38647 .5811 L .37089 .56398 L p F P
0 0 0 r
s
.028 .041 .084 r
.66108 .45138 m .65923 .46558 L .65979 .44522 L p F P
0 0 0 r
s
.028 .041 .084 r
.65979 .44522 m .66164 .43072 L .66108 .45138 L p F P
0 0 0 r
s
.203 .284 .476 r
.34021 .44522 m .33836 .43072 L .33892 .45138 L p F P
0 0 0 r
s
.203 .284 .476 r
.33892 .45138 m .34077 .46558 L .34021 .44522 L p F P
0 0 0 r
s
.24 .35 .67 r
.62926 .31531 m
.60592 .29735 L
s
.60592 .29735 m
.60839 .26485 L
s
.39408 .29735 m
.39161 .26485 L
s
.39408 .29735 m
.37074 .31531 L
s
.311 .464 .899 r
.52525 .63186 m .5252 .63378 L .54941 .63437 L p F P
0 0 0 r
s
.311 .464 .899 r
.54941 .63437 m .54959 .6306 L .52525 .63186 L p F P
0 0 0 r
s
.26 .393 .784 r
.45059 .63437 m .45041 .6306 L .47475 .63186 L p F P
0 0 0 r
s
.24 .35 .67 r
.45117 .63431 m
.45117 .63436 L
s
.26 .393 .784 r
.47475 .63186 m .4748 .63378 L .45059 .63437 L p F P
0 0 0 r
s
.072 .105 .259 r
.66171 .38248 m .65985 .39754 L .65211 .38223 L p F P
0 0 0 r
s
.24 .35 .67 r
.65276 .42048 m
.65628 .39126 L
s
.072 .105 .259 r
.65211 .38223 m .6538 .36775 L .66171 .38248 L p F P
0 0 0 r
s
.24 .35 .67 r
.64438 .36775 m
.65628 .39126 L
s
.298 .43 .775 r
.34789 .38223 m .3462 .36775 L .33829 .38248 L p F P
0 0 0 r
s
.298 .43 .775 r
.33829 .38248 m .34015 .39754 L .34789 .38223 L p F P
0 0 0 r
s
.24 .35 .67 r
.34372 .39126 m
.35562 .36775 L
s
.34372 .39126 m
.34724 .42048 L
s
.297 .445 .87 r
.52502 .6414 m .52507 .63951 L .5 .62969 L closepath p F P
0 0 0 r
s
.99 .297 .127 r
.5 .62969 m .47498 .6414 L .47855 .6414 L closepath p F P
0 0 0 r
s
.99 .297 .127 r
.5 .62969 m .47855 .6414 L .48213 .6414 L closepath p F P
0 0 0 r
s
.99 .297 .127 r
.5 .62969 m .48213 .6414 L .4857 .6414 L closepath p F P
0 0 0 r
s
.99 .297 .127 r
.5 .62969 m .4857 .6414 L .48928 .6414 L closepath p F P
0 0 0 r
s
.99 .297 .127 r
.5 .62969 m .48928 .6414 L .49285 .6414 L closepath p F P
0 0 0 r
s
.99 .297 .127 r
.5 .62969 m .49285 .6414 L .49643 .6414 L closepath p F P
0 0 0 r
s
.99 .297 .127 r
.5 .62969 m .49643 .6414 L .5 .6414 L closepath p F P
0 0 0 r
s
.99 .297 .127 r
.5 .62969 m .5 .6414 L .50357 .6414 L closepath p F P
0 0 0 r
s
.99 .297 .127 r
.5 .62969 m .50357 .6414 L .50715 .6414 L closepath p F P
0 0 0 r
s
.99 .297 .127 r
.5 .62969 m .50715 .6414 L .51072 .6414 L closepath p F P
0 0 0 r
s
.99 .297 .127 r
.5 .62969 m .51072 .6414 L .5143 .6414 L closepath p F P
0 0 0 r
s
.99 .297 .127 r
.5 .62969 m .5143 .6414 L .51787 .6414 L closepath p F P
0 0 0 r
s
.99 .297 .127 r
.5 .62969 m .51787 .6414 L .52145 .6414 L closepath p F P
0 0 0 r
s
.99 .297 .127 r
.5 .62969 m .52145 .6414 L .52502 .6414 L closepath p F P
0 0 0 r
s
.28 .421 .831 r
.5 .62969 m .47498 .6414 L .47493 .63951 L closepath p F P
0 0 0 r
s
.052 .076 .18 r
.66355 .41589 m .66164 .43072 L .65803 .41225 L p F P
0 0 0 r
s
.052 .076 .18 r
.65803 .41225 m .65985 .39754 L .66355 .41589 L p F P
0 0 0 r
s
.26 .371 .651 r
.34197 .41225 m .34015 .39754 L .33645 .41589 L p F P
0 0 0 r
s
.26 .371 .651 r
.33645 .41589 m .33836 .43072 L .34197 .41225 L p F P
0 0 0 r
s
.313 .46 .84 r
.63156 .54264 m .63032 .55341 L .64264 .53369 L p F P
0 0 0 r
s
.313 .46 .84 r
.64264 .53369 m .64412 .52169 L .63156 .54264 L p F P
0 0 0 r
s
.092 .138 .333 r
.35736 .53369 m .35588 .52169 L .36844 .54264 L p F P
0 0 0 r
s
.092 .138 .333 r
.36844 .54264 m .36968 .55341 L .35736 .53369 L p F P
0 0 0 r
s
.83 .24 .1 r
.77658 .37848 m
.77186 .36147 L
s
.81717 .36147 m
.82268 .37848 L
s
.77186 .36147 m
.81717 .36147 L
s
.73048 .37848 m
.72655 .36147 L
s
.72655 .36147 m
.77186 .36147 L
s
.68439 .37848 m
.68124 .36147 L
s
.68124 .36147 m
.72655 .36147 L
s
.64712 .36147 m
.68124 .36147 L
s
.31561 .37848 m
.31876 .36147 L
s
.31876 .36147 m
.35288 .36147 L
s
.26952 .37848 m
.27345 .36147 L
s
.27345 .36147 m
.31876 .36147 L
s
.22342 .37848 m
.22814 .36147 L
s
.22814 .36147 m
.27345 .36147 L
s
.17732 .37848 m
.18283 .36147 L
s
.18283 .36147 m
.22814 .36147 L
s
.322 .48 .92 r
.54995 .62298 m .54977 .6268 L .57273 .62042 L p F P
0 0 0 r
s
.322 .48 .92 r
.57273 .62042 m .57311 .61479 L .54995 .62298 L p F P
0 0 0 r
s
.235 .358 .725 r
.42727 .62042 m .42689 .61479 L .45005 .62298 L p F P
0 0 0 r
s
.235 .358 .725 r
.45005 .62298 m .45023 .6268 L .42727 .62042 L p F P
0 0 0 r
s
.297 .445 .87 r
.52507 .63951 m .52511 .63761 L .5 .62969 L closepath p F P
0 0 0 r
s
.28 .421 .831 r
.5 .62969 m .47493 .63951 L .47489 .63761 L closepath p F P
0 0 0 r
s
.33 .49 .931 r
.5735 .6091 m .57311 .61479 L .59419 .60371 L p F P
0 0 0 r
s
.33 .49 .931 r
.59419 .60371 m .59483 .59629 L .5735 .6091 L p F P
0 0 0 r
s
.206 .315 .651 r
.40581 .60371 m .40517 .59629 L .4265 .6091 L p F P
0 0 0 r
s
.206 .315 .651 r
.4265 .6091 m .42689 .61479 L .40581 .60371 L p F P
0 0 0 r
s
.311 .464 .899 r
.5253 .62994 m .52525 .63186 L .54959 .6306 L p F P
0 0 0 r
s
.311 .464 .899 r
.54959 .6306 m .54977 .6268 L .5253 .62994 L p F P
0 0 0 r
s
.26 .393 .784 r
.45041 .6306 m .45023 .6268 L .4747 .62994 L p F P
0 0 0 r
s
.24 .35 .67 r
.45099 .63058 m
.451 .63063 L
s
.26 .393 .784 r
.4747 .62994 m .47475 .63186 L .45041 .6306 L p F P
0 0 0 r
s
.297 .445 .87 r
.52511 .63761 m .52516 .6357 L .5 .62969 L closepath p F P
0 0 0 r
s
.28 .421 .831 r
.5 .62969 m .47489 .63761 L .47484 .6357 L closepath p F P
0 0 0 r
s
.333 .493 .926 r
.59548 .58877 m .59483 .59629 L .61353 .5811 L p F P
0 0 0 r
s
.333 .493 .926 r
.61353 .5811 m .61447 .57195 L .59548 .58877 L p F P
0 0 0 r
s
.169 .262 .556 r
.38647 .5811 m .38553 .57195 L .40452 .58877 L p F P
0 0 0 r
s
.169 .262 .556 r
.40452 .58877 m .40517 .59629 L .38647 .5811 L p F P
0 0 0 r
s
.83 .24 .1 r
.77257 .63648 m
.818 .63648 L
s
.72714 .63648 m
.77257 .63648 L
s
.68172 .63648 m
.72714 .63648 L
s
.63629 .63648 m
.68172 .63648 L
s
.59086 .63648 m
.63629 .63648 L
s
.54543 .63648 m
.59086 .63648 L
s
.52721 .63648 m
.54543 .63648 L
s
.45457 .63648 m
.47279 .63648 L
s
.40914 .63648 m
.45457 .63648 L
s
.36371 .63648 m
.40914 .63648 L
s
.31828 .63648 m
.36371 .63648 L
s
.27286 .63648 m
.31828 .63648 L
s
.22743 .63648 m
.27286 .63648 L
s
.182 .63648 m
.22743 .63648 L
s
.77257 .63648 m
.77722 .61852 L
s
.82342 .61852 m
.818 .63648 L
s
.72714 .63648 m
.73101 .61852 L
s
.68172 .63648 m
.68481 .61852 L
s
.63629 .63648 m
.63861 .61852 L
s
.59086 .63648 m
.59241 .61852 L
s
.40759 .61852 m
.40914 .63648 L
s
.36371 .63648 m
.36139 .61852 L
s
.31828 .63648 m
.31519 .61852 L
s
.27286 .63648 m
.26899 .61852 L
s
.22743 .63648 m
.22278 .61852 L
s
.182 .63648 m
.17658 .61852 L
s
.281 .411 .734 r
.64563 .50943 m .64412 .52169 L .6528 .50043 L p F P
0 0 0 r
s
.281 .411 .734 r
.6528 .50043 m .6545 .48719 L .64563 .50943 L p F P
0 0 0 r
s
.068 .1 .244 r
.3472 .50043 m .3455 .48719 L .35437 .50943 L p F P
0 0 0 r
s
.068 .1 .244 r
.35437 .50943 m .35588 .52169 L .3472 .50043 L p F P
0 0 0 r
s
.297 .445 .87 r
.52516 .6357 m .5252 .63378 L .5 .62969 L closepath p F P
0 0 0 r
s
.28 .421 .831 r
.5 .62969 m .47484 .6357 L .4748 .63378 L closepath p F P
0 0 0 r
s
.322 .48 .92 r
.55013 .61912 m .54995 .62298 L .57311 .61479 L p F P
0 0 0 r
s
.24 .35 .67 r
.54942 .62168 m
.55002 .62145 L
s
.322 .48 .92 r
.57311 .61479 m .5735 .6091 L .55013 .61912 L p F P
0 0 0 r
s
.235 .358 .725 r
.42689 .61479 m .4265 .6091 L .44987 .61912 L p F P
0 0 0 r
s
.235 .358 .725 r
.44987 .61912 m .45005 .62298 L .42689 .61479 L p F P
0 0 0 r
s
.24 .35 .67 r
.44998 .62145 m
.45058 .62168 L
s
.311 .464 .899 r
.52534 .628 m .5253 .62994 L .54977 .6268 L p F P
0 0 0 r
s
.311 .464 .899 r
.54977 .6268 m .54995 .62298 L .52534 .628 L p F P
0 0 0 r
s
.24 .35 .67 r
.54935 .6231 m
.54942 .62168 L
s
.26 .393 .784 r
.45023 .6268 m .45005 .62298 L .47466 .628 L p F P
0 0 0 r
s
.24 .35 .67 r
.45058 .62168 m
.45065 .6231 L
s
.45082 .62683 m
.45082 .62688 L
s
.26 .393 .784 r
.47466 .628 m .4747 .62994 L .45023 .6268 L p F P
0 0 0 r
s
.329 .485 .9 r
.61542 .56266 m .61447 .57195 L .63032 .55341 L p F P
0 0 0 r
s
.329 .485 .9 r
.63032 .55341 m .63156 .54264 L .61542 .56266 L p F P
0 0 0 r
s
.124 .196 .438 r
.36968 .55341 m .36844 .54264 L .38458 .56266 L p F P
0 0 0 r
s
.24 .35 .67 r
.37122 .55437 m
.37133 .55535 L
s
.124 .196 .438 r
.38458 .56266 m .38553 .57195 L .36968 .55341 L p F P
0 0 0 r
s
.297 .445 .87 r
.5252 .63378 m .52525 .63186 L .5 .62969 L closepath p F P
0 0 0 r
s
.28 .421 .831 r
.5 .62969 m .4748 .63378 L .47475 .63186 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.54943 .24121 m
.51668 .23634 L
s
.51668 .23634 m
.51707 .20215 L
s
.51668 .23634 m
.48332 .23634 L
s
.48332 .23634 m
.48293 .20215 L
s
.48332 .23634 m
.45057 .24121 L
s
.23 .333 .575 r
.65624 .47365 m .6545 .48719 L .65923 .46558 L p F P
0 0 0 r
s
.23 .333 .575 r
.65923 .46558 m .66108 .45138 L .65624 .47365 L p F P
0 0 0 r
s
.24 .35 .67 r
.65654 .47228 m
.65661 .47174 L
s
.65661 .47174 m
.65812 .44579 L
s
.045 .066 .152 r
.34077 .46558 m .33892 .45138 L .34376 .47365 L p F P
0 0 0 r
s
.045 .066 .152 r
.34376 .47365 m .3455 .48719 L .34077 .46558 L p F P
0 0 0 r
s
.24 .35 .67 r
.34339 .47174 m
.34346 .47228 L
s
.34188 .44579 m
.34339 .47174 L
s
.33 .49 .931 r
.57389 .60335 m .5735 .6091 L .59483 .59629 L p F P
0 0 0 r
s
.33 .49 .931 r
.59483 .59629 m .59548 .58877 L .57389 .60335 L p F P
0 0 0 r
s
.206 .315 .651 r
.40517 .59629 m .40452 .58877 L .42611 .60335 L p F P
0 0 0 r
s
.206 .315 .651 r
.42611 .60335 m .4265 .6091 L .40517 .59629 L p F P
0 0 0 r
s
.24 .35 .67 r
.64758 .33666 m
.62926 .31531 L
s
.62926 .31531 m
.63231 .28292 L
s
.37074 .31531 m
.36769 .28292 L
s
.37074 .31531 m
.35242 .33666 L
s
.297 .445 .87 r
.52525 .63186 m .5253 .62994 L .5 .62969 L closepath p F P
0 0 0 r
s
.28 .421 .831 r
.5 .62969 m .47475 .63186 L .4747 .62994 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.58039 .25081 m
.54943 .24121 L
s
.54943 .24121 m
.55059 .20704 L
s
.45057 .24121 m
.44941 .20704 L
s
.45057 .24121 m
.41961 .25081 L
s
.311 .464 .899 r
.52539 .62606 m .52534 .628 L .54995 .62298 L p F P
0 0 0 r
s
.311 .464 .899 r
.54995 .62298 m .55013 .61912 L .52539 .62606 L p F P
0 0 0 r
s
.24 .35 .67 r
.51676 .62757 m
.52582 .62594 L
s
.26 .393 .784 r
.45005 .62298 m .44987 .61912 L .47461 .62606 L p F P
0 0 0 r
s
.26 .393 .784 r
.47461 .62606 m .47466 .628 L .45005 .62298 L p F P
0 0 0 r
s
.24 .35 .67 r
.47418 .62594 m
.48324 .62757 L
s
.028 .041 .084 r
.66297 .43684 m .66108 .45138 L .66164 .43072 L p F P
0 0 0 r
s
.028 .041 .084 r
.66164 .43072 m .66355 .41589 L .66297 .43684 L p F P
0 0 0 r
s
.203 .284 .476 r
.33836 .43072 m .33645 .41589 L .33703 .43684 L p F P
0 0 0 r
s
.203 .284 .476 r
.33703 .43684 m .33892 .45138 L .33836 .43072 L p F P
0 0 0 r
s
.297 .445 .87 r
.5253 .62994 m .52534 .628 L .5 .62969 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.51674 .62857 m
.51676 .62757 L
s
.28 .421 .831 r
.5 .62969 m .4747 .62994 L .47466 .628 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.48324 .62757 m
.48326 .62857 L
s
.557 .144 .061 r
.66171 .38248 m .63861 .38248 L .63183 .36775 L p F P
0 0 0 r
s
.83 .24 .1 r
.6368 .36775 m
.63717 .37038 L
s
.557 .144 .061 r
.63183 .36775 m .6538 .36775 L .66171 .38248 L p F P
0 0 0 r
s
.24 .35 .67 r
.65628 .39126 m
.65733 .38248 L
s
.65791 .37767 m
.65995 .36067 L
s
.557 .144 .061 r
.63861 .38248 m .61551 .38248 L .60985 .36775 L p F P
0 0 0 r
s
.557 .144 .061 r
.60985 .36775 m .63183 .36775 L .63861 .38248 L p F P
0 0 0 r
s
.557 .144 .061 r
.61551 .38248 m .59241 .38248 L .58788 .36775 L p F P
0 0 0 r
s
.83 .24 .1 r
.5912 .36775 m
.59137 .36961 L
s
.557 .144 .061 r
.58788 .36775 m .60985 .36775 L .61551 .38248 L p F P
0 0 0 r
s
.557 .144 .061 r
.59241 .38248 m .5693 .38248 L .56591 .36775 L p F P
0 0 0 r
s
.557 .144 .061 r
.56591 .36775 m .58788 .36775 L .59241 .38248 L p F P
0 0 0 r
s
.557 .144 .061 r
.5693 .38248 m .5462 .38248 L .54394 .36775 L p F P
0 0 0 r
s
.83 .24 .1 r
.5456 .36775 m
.54565 .36874 L
s
.557 .144 .061 r
.54394 .36775 m .56591 .36775 L .5693 .38248 L p F P
0 0 0 r
s
.557 .144 .061 r
.5462 .38248 m .5231 .38248 L .52197 .36775 L p F P
0 0 0 r
s
.557 .144 .061 r
.52197 .36775 m .54394 .36775 L .5462 .38248 L p F P
0 0 0 r
s
.557 .144 .061 r
.5231 .38248 m .5 .38248 L .5 .36775 L p F P
0 0 0 r
s
.557 .144 .061 r
.5 .36775 m .52197 .36775 L .5231 .38248 L p F P
0 0 0 r
s
.557 .144 .061 r
.5 .38248 m .4769 .38248 L .47803 .36775 L p F P
0 0 0 r
s
.557 .144 .061 r
.47803 .36775 m .5 .36775 L .5 .38248 L p F P
0 0 0 r
s
.557 .144 .061 r
.4769 .38248 m .4538 .38248 L .45606 .36775 L p F P
0 0 0 r
s
.557 .144 .061 r
.45606 .36775 m .47803 .36775 L .4769 .38248 L p F P
0 0 0 r
s
.557 .144 .061 r
.4538 .38248 m .4307 .38248 L .43409 .36775 L p F P
0 0 0 r
s
.557 .144 .061 r
.43409 .36775 m .45606 .36775 L .4538 .38248 L p F P
0 0 0 r
s
.557 .144 .061 r
.4307 .38248 m .40759 .38248 L .41212 .36775 L p F P
0 0 0 r
s
.557 .144 .061 r
.41212 .36775 m .43409 .36775 L .4307 .38248 L p F P
0 0 0 r
s
.557 .144 .061 r
.40759 .38248 m .38449 .38248 L .39015 .36775 L p F P
0 0 0 r
s
.557 .144 .061 r
.39015 .36775 m .41212 .36775 L .40759 .38248 L p F P
0 0 0 r
s
.557 .144 .061 r
.38449 .38248 m .36139 .38248 L .36817 .36775 L p F P
0 0 0 r
s
.557 .144 .061 r
.36817 .36775 m .39015 .36775 L .38449 .38248 L p F P
0 0 0 r
s
.557 .144 .061 r
.36139 .38248 m .33829 .38248 L .3462 .36775 L p F P
0 0 0 r
s
.24 .35 .67 r
.34005 .36067 m
.34209 .37767 L
s
.34267 .38248 m
.34372 .39126 L
s
.557 .144 .061 r
.3462 .36775 m .36817 .36775 L .36139 .38248 L p F P
0 0 0 r
s
.313 .46 .84 r
.63282 .53166 m .63156 .54264 L .64412 .52169 L p F P
0 0 0 r
s
.313 .46 .84 r
.64412 .52169 m .64563 .50943 L .63282 .53166 L p F P
0 0 0 r
s
.092 .138 .333 r
.35588 .52169 m .35437 .50943 L .36718 .53166 L p F P
0 0 0 r
s
.092 .138 .333 r
.36718 .53166 m .36844 .54264 L .35588 .52169 L p F P
0 0 0 r
s
.052 .076 .18 r
.6655 .4007 m .66355 .41589 L .65985 .39754 L p F P
0 0 0 r
s
.052 .076 .18 r
.65985 .39754 m .66171 .38248 L .6655 .4007 L p F P
0 0 0 r
s
.24 .35 .67 r
.65628 .39126 m
.6618 .41679 L
s
.26 .371 .651 r
.34015 .39754 m .33829 .38248 L .3345 .4007 L p F P
0 0 0 r
s
.26 .371 .651 r
.3345 .4007 m .33645 .41589 L .34015 .39754 L p F P
0 0 0 r
s
.24 .35 .67 r
.3382 .41679 m
.34372 .39126 L
s
.333 .493 .926 r
.59614 .58114 m .59548 .58877 L .61447 .57195 L p F P
0 0 0 r
s
.333 .493 .926 r
.61447 .57195 m .61542 .56266 L .59614 .58114 L p F P
0 0 0 r
s
.169 .262 .556 r
.38553 .57195 m .38458 .56266 L .40386 .58114 L p F P
0 0 0 r
s
.169 .262 .556 r
.40386 .58114 m .40452 .58877 L .38553 .57195 L p F P
0 0 0 r
s
.322 .48 .92 r
.55031 .61524 m .55013 .61912 L .5735 .6091 L p F P
0 0 0 r
s
.322 .48 .92 r
.5735 .6091 m .57389 .60335 L .55031 .61524 L p F P
0 0 0 r
s
.235 .358 .725 r
.4265 .6091 m .42611 .60335 L .44969 .61524 L p F P
0 0 0 r
s
.235 .358 .725 r
.44969 .61524 m .44987 .61912 L .4265 .6091 L p F P
0 0 0 r
s
.24 .35 .67 r
.48324 .62757 m
.51676 .62757 L
s
.297 .445 .87 r
.52534 .628 m .52539 .62606 L .5 .62969 L closepath p F P
0 0 0 r
s
.28 .421 .831 r
.5 .62969 m .47466 .628 L .47461 .62606 L closepath p F P
0 0 0 r
s
.28 .421 .831 r
.5 .62969 m .47438 .61624 L .47433 .61425 L closepath p F P
0 0 0 r
s
.28 .421 .831 r
.5 .62969 m .47461 .62606 L .47457 .62411 L closepath p F P
0 0 0 r
s
.28 .421 .831 r
.5 .62969 m .47457 .62411 L .47452 .62215 L closepath p F P
0 0 0 r
s
.28 .421 .831 r
.5 .62969 m .47452 .62215 L .47447 .62019 L closepath p F P
0 0 0 r
s
.28 .421 .831 r
.5 .62969 m .47447 .62019 L .47443 .61822 L closepath p F P
0 0 0 r
s
.28 .421 .831 r
.5 .62969 m .47443 .61822 L .47438 .61624 L closepath p F P
0 0 0 r
s
.297 .445 .87 r
.52557 .61822 m .52562 .61624 L .5 .62969 L closepath p F P
0 0 0 r
s
.297 .445 .87 r
.52553 .62019 m .52557 .61822 L .5 .62969 L closepath p F P
0 0 0 r
s
.297 .445 .87 r
.52548 .62215 m .52553 .62019 L .5 .62969 L closepath p F P
0 0 0 r
s
.297 .445 .87 r
.52543 .62411 m .52548 .62215 L .5 .62969 L closepath p F P
0 0 0 r
s
.297 .445 .87 r
.52539 .62606 m .52543 .62411 L .5 .62969 L closepath p F P
0 0 0 r
s
.999 .296 .126 r
.522 .61425 m .52567 .61425 L .5 .62969 L closepath p F P
0 0 0 r
s
.999 .296 .126 r
.51834 .61425 m .522 .61425 L .5 .62969 L closepath p F P
0 0 0 r
s
.999 .296 .126 r
.51467 .61425 m .51834 .61425 L .5 .62969 L closepath p F P
0 0 0 r
s
.999 .296 .126 r
.511 .61425 m .51467 .61425 L .5 .62969 L closepath p F P
0 0 0 r
s
.999 .296 .126 r
.50733 .61425 m .511 .61425 L .5 .62969 L closepath p F P
0 0 0 r
s
.999 .296 .126 r
.50367 .61425 m .50733 .61425 L .5 .62969 L closepath p F P
0 0 0 r
s
.999 .296 .126 r
.5 .61425 m .50367 .61425 L .5 .62969 L closepath p F P
0 0 0 r
s
.999 .296 .126 r
.49633 .61425 m .5 .61425 L .5 .62969 L closepath p F P
0 0 0 r
s
.999 .296 .126 r
.49267 .61425 m .49633 .61425 L .5 .62969 L closepath p F P
0 0 0 r
s
.999 .296 .126 r
.489 .61425 m .49267 .61425 L .5 .62969 L closepath p F P
0 0 0 r
s
.999 .296 .126 r
.48533 .61425 m .489 .61425 L .5 .62969 L closepath p F P
0 0 0 r
s
.999 .296 .126 r
.48166 .61425 m .48533 .61425 L .5 .62969 L closepath p F P
0 0 0 r
s
.999 .296 .126 r
.478 .61425 m .48166 .61425 L .5 .62969 L closepath p F P
0 0 0 r
s
.999 .296 .126 r
.47433 .61425 m .478 .61425 L .5 .62969 L closepath p F P
0 0 0 r
s
.297 .445 .87 r
.52562 .61624 m .52567 .61425 L .5 .62969 L closepath p F P
0 0 0 r
s
.311 .464 .899 r
.52543 .62411 m .52539 .62606 L .55013 .61912 L p F P
0 0 0 r
s
.311 .464 .899 r
.55013 .61912 m .55031 .61524 L .52543 .62411 L p F P
0 0 0 r
s
.26 .393 .784 r
.44987 .61912 m .44969 .61524 L .47457 .62411 L p F P
0 0 0 r
s
.24 .35 .67 r
.45047 .61924 m
.45047 .61929 L
s
.26 .393 .784 r
.47457 .62411 m .47461 .62606 L .44987 .61912 L p F P
0 0 0 r
s
.24 .35 .67 r
.60839 .26485 m
.58039 .25081 L
s
.58039 .25081 m
.58229 .21669 L
s
.41961 .25081 m
.41771 .21669 L
s
.41961 .25081 m
.39161 .26485 L
s
.33 .49 .931 r
.57428 .59753 m .57389 .60335 L .59548 .58877 L p F P
0 0 0 r
s
.33 .49 .931 r
.59548 .58877 m .59614 .58114 L .57428 .59753 L p F P
0 0 0 r
s
.206 .315 .651 r
.40452 .58877 m .40386 .58114 L .42572 .59753 L p F P
0 0 0 r
s
.206 .315 .651 r
.42572 .59753 m .42611 .60335 L .40452 .58877 L p F P
0 0 0 r
s
.281 .411 .734 r
.64717 .49692 m .64563 .50943 L .6545 .48719 L p F P
0 0 0 r
s
.281 .411 .734 r
.6545 .48719 m .65624 .47365 L .64717 .49692 L p F P
0 0 0 r
s
.24 .35 .67 r
.6542 .47889 m
.65661 .47174 L
s
.068 .1 .244 r
.3455 .48719 m .34376 .47365 L .35283 .49692 L p F P
0 0 0 r
s
.24 .35 .67 r
.34339 .47174 m
.3458 .47889 L
s
.068 .1 .244 r
.35283 .49692 m .35437 .50943 L .3455 .48719 L p F P
0 0 0 r
s
.311 .464 .899 r
.52548 .62215 m .52543 .62411 L .55031 .61524 L p F P
0 0 0 r
s
.26 .393 .784 r
.47452 .62215 m .47457 .62411 L .44969 .61524 L p F P
0 0 0 r
s
.329 .485 .9 r
.61639 .55321 m .61542 .56266 L .63156 .54264 L p F P
0 0 0 r
s
.329 .485 .9 r
.63156 .54264 m .63282 .53166 L .61639 .55321 L p F P
0 0 0 r
s
.124 .196 .438 r
.36844 .54264 m .36718 .53166 L .38361 .55321 L p F P
0 0 0 r
s
.24 .35 .67 r
.37002 .54373 m
.37013 .54473 L
s
.124 .196 .438 r
.38361 .55321 m .38458 .56266 L .36844 .54264 L p F P
0 0 0 r
s
.322 .48 .92 r
.55049 .61133 m .55031 .61524 L .57389 .60335 L p F P
0 0 0 r
s
.322 .48 .92 r
.57389 .60335 m .57428 .59753 L .55049 .61133 L p F P
0 0 0 r
s
.235 .358 .725 r
.42611 .60335 m .42572 .59753 L .44951 .61133 L p F P
0 0 0 r
s
.235 .358 .725 r
.44951 .61133 m .44969 .61524 L .42611 .60335 L p F P
0 0 0 r
s
.311 .464 .899 r
.55031 .61524 m .55049 .61133 L .52548 .62215 L p F P
0 0 0 r
s
.26 .393 .784 r
.44969 .61524 m .44951 .61133 L .47452 .62215 L p F P
0 0 0 r
s
.311 .464 .899 r
.52553 .62019 m .52548 .62215 L .55049 .61133 L p F P
0 0 0 r
s
.26 .393 .784 r
.47447 .62019 m .47452 .62215 L .44951 .61133 L p F P
0 0 0 r
s
.83 .24 .1 r
.78064 .40178 m
.77658 .37848 L
s
.82268 .37848 m
.82741 .40178 L
s
.77658 .37848 m
.82268 .37848 L
s
.73386 .40178 m
.73048 .37848 L
s
.73048 .37848 m
.77658 .37848 L
s
.68709 .40178 m
.68439 .37848 L
s
.68439 .37848 m
.73048 .37848 L
s
.65956 .37848 m
.68439 .37848 L
s
.31291 .40178 m
.31561 .37848 L
s
.31561 .37848 m
.34044 .37848 L
s
.26614 .40178 m
.26952 .37848 L
s
.26952 .37848 m
.31561 .37848 L
s
.21936 .40178 m
.22342 .37848 L
s
.22342 .37848 m
.26952 .37848 L
s
.17259 .40178 m
.17732 .37848 L
s
.17732 .37848 m
.22342 .37848 L
s
.23 .333 .575 r
.65801 .45981 m .65624 .47365 L .66108 .45138 L p F P
0 0 0 r
s
.23 .333 .575 r
.66108 .45138 m .66297 .43684 L .65801 .45981 L p F P
0 0 0 r
s
.24 .35 .67 r
.65812 .44579 m
.6618 .41679 L
s
.045 .066 .152 r
.33892 .45138 m .33703 .43684 L .34199 .45981 L p F P
0 0 0 r
s
.24 .35 .67 r
.3382 .41679 m
.34188 .44579 L
s
.045 .066 .152 r
.34199 .45981 m .34376 .47365 L .33892 .45138 L p F P
0 0 0 r
s
.24 .35 .67 r
.65995 .36067 m
.64758 .33666 L
s
.64758 .33666 m
.65109 .30442 L
s
.35242 .33666 m
.34891 .30442 L
s
.35242 .33666 m
.34005 .36067 L
s
.311 .464 .899 r
.52557 .61822 m .52553 .62019 L .55068 .6074 L p F P
0 0 0 r
s
.311 .464 .899 r
.55049 .61133 m .55068 .6074 L .52553 .62019 L p F P
0 0 0 r
s
.83 .24 .1 r
.54543 .63648 m
.5462 .61852 L
s
.26 .393 .784 r
.44951 .61133 m .44932 .6074 L .47447 .62019 L p F P
0 0 0 r
s
.26 .393 .784 r
.47443 .61822 m .47447 .62019 L .44932 .6074 L p F P
0 0 0 r
s
.83 .24 .1 r
.4538 .61852 m
.45457 .63648 L
s
.333 .493 .926 r
.59681 .57341 m .59614 .58114 L .61542 .56266 L p F P
0 0 0 r
s
.24 .35 .67 r
.61209 .56458 m
.61556 .56124 L
s
.333 .493 .926 r
.61542 .56266 m .61639 .55321 L .59681 .57341 L p F P
0 0 0 r
s
.169 .262 .556 r
.38458 .56266 m .38361 .55321 L .40319 .57341 L p F P
0 0 0 r
s
.169 .262 .556 r
.40319 .57341 m .40386 .58114 L .38458 .56266 L p F P
0 0 0 r
s
.83 .24 .1 r
.77722 .61852 m
.82342 .61852 L
s
.73101 .61852 m
.77722 .61852 L
s
.68481 .61852 m
.73101 .61852 L
s
.63861 .61852 m
.68481 .61852 L
s
.59241 .61852 m
.63861 .61852 L
s
.5462 .61852 m
.59241 .61852 L
s
.53201 .61852 m
.5462 .61852 L
s
.52767 .61852 m
.53201 .61852 L
s
.4538 .61852 m
.46799 .61852 L
s
.46799 .61852 m
.47233 .61852 L
s
.40759 .61852 m
.4538 .61852 L
s
.36139 .61852 m
.40759 .61852 L
s
.31519 .61852 m
.36139 .61852 L
s
.26899 .61852 m
.31519 .61852 L
s
.22278 .61852 m
.26899 .61852 L
s
.17658 .61852 m
.22278 .61852 L
s
.77722 .61852 m
.78115 .59437 L
s
.82801 .59437 m
.82342 .61852 L
s
.73101 .61852 m
.73429 .59437 L
s
.68481 .61852 m
.68744 .59437 L
s
.63861 .61852 m
.64058 .59437 L
s
.36139 .61852 m
.35942 .59437 L
s
.31519 .61852 m
.31256 .59437 L
s
.26899 .61852 m
.26571 .59437 L
s
.22278 .61852 m
.21885 .59437 L
s
.17658 .61852 m
.17199 .59437 L
s
.235 .358 .725 r
.44932 .6074 m .44951 .61133 L .42572 .59753 L p F P
0 0 0 r
s
.322 .48 .92 r
.55068 .6074 m .55049 .61133 L .57428 .59753 L p F P
0 0 0 r
s
.313 .46 .84 r
.6341 .52047 m .63282 .53166 L .64563 .50943 L p F P
0 0 0 r
s
.313 .46 .84 r
.64563 .50943 m .64717 .49692 L .6341 .52047 L p F P
0 0 0 r
s
.092 .138 .333 r
.35437 .50943 m .35283 .49692 L .3659 .52047 L p F P
0 0 0 r
s
.092 .138 .333 r
.3659 .52047 m .36718 .53166 L .35437 .50943 L p F P
0 0 0 r
s
.26 .393 .784 r
.44932 .6074 m .44914 .60343 L .47443 .61822 L p F P
0 0 0 r
s
.26 .393 .784 r
.47438 .61624 m .47443 .61822 L .44914 .60343 L p F P
0 0 0 r
s
.311 .464 .899 r
.52562 .61624 m .52557 .61822 L .55086 .60343 L p F P
0 0 0 r
s
.311 .464 .899 r
.55068 .6074 m .55086 .60343 L .52557 .61822 L p F P
0 0 0 r
s
.028 .041 .084 r
.6649 .42195 m .66297 .43684 L .66355 .41589 L p F P
0 0 0 r
s
.028 .041 .084 r
.66355 .41589 m .6655 .4007 L .6649 .42195 L p F P
0 0 0 r
s
.203 .284 .476 r
.33645 .41589 m .3345 .4007 L .3351 .42195 L p F P
0 0 0 r
s
.203 .284 .476 r
.3351 .42195 m .33703 .43684 L .33645 .41589 L p F P
0 0 0 r
s
.33 .49 .931 r
.57468 .59165 m .57428 .59753 L .59614 .58114 L p F P
0 0 0 r
s
.83 .24 .1 r
.59241 .61852 m
.59372 .59437 L
s
.33 .49 .931 r
.59614 .58114 m .59681 .57341 L .57468 .59165 L p F P
0 0 0 r
s
.24 .35 .67 r
.58132 .58618 m
.58142 .5849 L
s
.58142 .5849 m
.58724 .5813 L
s
.206 .315 .651 r
.40386 .58114 m .40319 .57341 L .42532 .59165 L p F P
0 0 0 r
s
.206 .315 .651 r
.42532 .59165 m .42572 .59753 L .40386 .58114 L p F P
0 0 0 r
s
.24 .35 .67 r
.41858 .5849 m
.41868 .58618 L
s
.41276 .5813 m
.41858 .5849 L
s
.83 .24 .1 r
.40628 .59437 m
.40759 .61852 L
s
.24 .35 .67 r
.63231 .28292 m
.60839 .26485 L
s
.60839 .26485 m
.61098 .23081 L
s
.39161 .26485 m
.38902 .23081 L
s
.39161 .26485 m
.36769 .28292 L
s
.322 .48 .92 r
.57428 .59753 m .57468 .59165 L .55068 .6074 L p F P
0 0 0 r
s
.235 .358 .725 r
.42572 .59753 m .42532 .59165 L .44932 .6074 L p F P
0 0 0 r
s
.657 .175 .074 r
.6655 .4007 m .64185 .4007 L .63861 .38248 L p F P
0 0 0 r
s
.83 .24 .1 r
.63864 .38248 m
.63864 .38251 L
s
.657 .175 .074 r
.63861 .38248 m .66171 .38248 L .6655 .4007 L p F P
0 0 0 r
s
.657 .175 .074 r
.64185 .4007 m .61821 .4007 L .61551 .38248 L p F P
0 0 0 r
s
.657 .175 .074 r
.61551 .38248 m .63861 .38248 L .64185 .4007 L p F P
0 0 0 r
s
.83 .24 .1 r
.64022 .4007 m
.64032 .40178 L
s
.657 .175 .074 r
.61821 .4007 m .59457 .4007 L .59241 .38248 L p F P
0 0 0 r
s
.83 .24 .1 r
.59243 .38248 m
.59243 .3825 L
s
.657 .175 .074 r
.59241 .38248 m .61551 .38248 L .61821 .4007 L p F P
0 0 0 r
s
.657 .175 .074 r
.59457 .4007 m .57093 .4007 L .5693 .38248 L p F P
0 0 0 r
s
.657 .175 .074 r
.5693 .38248 m .59241 .38248 L .59457 .4007 L p F P
0 0 0 r
s
.83 .24 .1 r
.59348 .4007 m
.59355 .40178 L
s
.657 .175 .074 r
.57093 .4007 m .54728 .4007 L .5462 .38248 L p F P
0 0 0 r
s
.83 .24 .1 r
.54621 .38248 m
.54621 .38249 L
s
.657 .175 .074 r
.5462 .38248 m .5693 .38248 L .57093 .4007 L p F P
0 0 0 r
s
.657 .175 .074 r
.54728 .4007 m .52364 .4007 L .5231 .38248 L p F P
0 0 0 r
s
.657 .175 .074 r
.5231 .38248 m .5462 .38248 L .54728 .4007 L p F P
0 0 0 r
s
.83 .24 .1 r
.54674 .4007 m
.54677 .40178 L
s
.657 .175 .074 r
.52364 .4007 m .5 .4007 L .5 .38248 L p F P
0 0 0 r
s
.657 .175 .074 r
.5 .38248 m .5231 .38248 L .52364 .4007 L p F P
0 0 0 r
s
.657 .175 .074 r
.5 .4007 m .47636 .4007 L .4769 .38248 L p F P
0 0 0 r
s
.657 .175 .074 r
.4769 .38248 m .5 .38248 L .5 .4007 L p F P
0 0 0 r
s
.83 .24 .1 r
.5 .4007 m
.5 .40178 L
s
.657 .175 .074 r
.47636 .4007 m .45272 .4007 L .4538 .38248 L p F P
0 0 0 r
s
.83 .24 .1 r
.45378 .38281 m
.45379 .38248 L
s
.657 .175 .074 r
.4538 .38248 m .4769 .38248 L .47636 .4007 L p F P
0 0 0 r
s
.657 .175 .074 r
.45272 .4007 m .42907 .4007 L .4307 .38248 L p F P
0 0 0 r
s
.657 .175 .074 r
.4307 .38248 m .4538 .38248 L .45272 .4007 L p F P
0 0 0 r
s
.83 .24 .1 r
.45323 .40178 m
.45326 .4007 L
s
.657 .175 .074 r
.42907 .4007 m .40543 .4007 L .40759 .38248 L p F P
0 0 0 r
s
.83 .24 .1 r
.40755 .38281 m
.40757 .38248 L
s
.657 .175 .074 r
.40759 .38248 m .4307 .38248 L .42907 .4007 L p F P
0 0 0 r
s
.657 .175 .074 r
.40543 .4007 m .38179 .4007 L .38449 .38248 L p F P
0 0 0 r
s
.657 .175 .074 r
.38449 .38248 m .40759 .38248 L .40543 .4007 L p F P
0 0 0 r
s
.83 .24 .1 r
.40645 .40178 m
.40652 .4007 L
s
.657 .175 .074 r
.38179 .4007 m .35815 .4007 L .36139 .38248 L p F P
0 0 0 r
s
.83 .24 .1 r
.36133 .38281 m
.36136 .38248 L
s
.657 .175 .074 r
.36139 .38248 m .38449 .38248 L .38179 .4007 L p F P
0 0 0 r
s
.657 .175 .074 r
.35815 .4007 m .3345 .4007 L .33829 .38248 L p F P
0 0 0 r
s
.657 .175 .074 r
.33829 .38248 m .36139 .38248 L .35815 .4007 L p F P
0 0 0 r
s
.83 .24 .1 r
.35968 .40178 m
.35978 .4007 L
s
.26 .393 .784 r
.44914 .60343 m .44895 .59943 L .47438 .61624 L p F P
0 0 0 r
s
.26 .393 .784 r
.47433 .61425 m .47438 .61624 L .44895 .59943 L p F P
0 0 0 r
s
.311 .464 .899 r
.52567 .61425 m .52562 .61624 L .55105 .59943 L p F P
0 0 0 r
s
.311 .464 .899 r
.55086 .60343 m .55105 .59943 L .52562 .61624 L p F P
0 0 0 r
s
.322 .48 .92 r
.55086 .60343 m .55068 .6074 L .57468 .59165 L p F P
0 0 0 r
s
.235 .358 .725 r
.44914 .60343 m .44932 .6074 L .42532 .59165 L p F P
0 0 0 r
s
.26 .393 .784 r
.44895 .59943 m .44876 .59541 L .47433 .61425 L p F P
0 0 0 r
s
.311 .464 .899 r
.55105 .59943 m .55124 .59541 L .52567 .61425 L p F P
0 0 0 r
s
.99 .29 .124 r
.52567 .61425 m .522 .61425 L .54392 .59541 L p F P
0 0 0 r
s
.99 .29 .124 r
.54392 .59541 m .55124 .59541 L .52567 .61425 L p F P
0 0 0 r
s
.83 .24 .1 r
.54683 .59541 m
.54686 .59437 L
s
.5462 .61852 m
.54662 .60331 L
s
.99 .29 .124 r
.522 .61425 m .51834 .61425 L .5366 .59541 L p F P
0 0 0 r
s
.99 .29 .124 r
.5366 .59541 m .54392 .59541 L .522 .61425 L p F P
0 0 0 r
s
.99 .29 .124 r
.51834 .61425 m .51467 .61425 L .52928 .59541 L p F P
0 0 0 r
s
.99 .29 .124 r
.52928 .59541 m .5366 .59541 L .51834 .61425 L p F P
0 0 0 r
s
.99 .29 .124 r
.51467 .61425 m .511 .61425 L .52196 .59541 L p F P
0 0 0 r
s
.99 .29 .124 r
.52196 .59541 m .52928 .59541 L .51467 .61425 L p F P
0 0 0 r
s
.99 .29 .124 r
.511 .61425 m .50733 .61425 L .51464 .59541 L p F P
0 0 0 r
s
.99 .29 .124 r
.51464 .59541 m .52196 .59541 L .511 .61425 L p F P
0 0 0 r
s
.24 .35 .67 r
.51703 .61029 m
.51716 .60245 L
s
.517 .61267 m
.51703 .61029 L
s
.99 .29 .124 r
.50733 .61425 m .50367 .61425 L .50732 .59541 L p F P
0 0 0 r
s
.99 .29 .124 r
.50732 .59541 m .51464 .59541 L .50733 .61425 L p F P
0 0 0 r
s
.99 .29 .124 r
.50367 .61425 m .5 .61425 L .5 .59541 L p F P
0 0 0 r
s
.99 .29 .124 r
.5 .59541 m .50732 .59541 L .50367 .61425 L p F P
0 0 0 r
s
.99 .29 .124 r
.5 .61425 m .49633 .61425 L .49268 .59541 L p F P
0 0 0 r
s
.99 .29 .124 r
.49268 .59541 m .5 .59541 L .5 .61425 L p F P
0 0 0 r
s
.83 .24 .1 r
.5 .59437 m
.5 .59541 L
s
.99 .29 .124 r
.49633 .61425 m .49267 .61425 L .48536 .59541 L p F P
0 0 0 r
s
.99 .29 .124 r
.48536 .59541 m .49268 .59541 L .49633 .61425 L p F P
0 0 0 r
s
.99 .29 .124 r
.49267 .61425 m .489 .61425 L .47804 .59541 L p F P
0 0 0 r
s
.99 .29 .124 r
.47804 .59541 m .48536 .59541 L .49267 .61425 L p F P
0 0 0 r
s
.99 .29 .124 r
.489 .61425 m .48533 .61425 L .47072 .59541 L p F P
0 0 0 r
s
.99 .29 .124 r
.47072 .59541 m .47804 .59541 L .489 .61425 L p F P
0 0 0 r
s
.99 .29 .124 r
.48533 .61425 m .48166 .61425 L .4634 .59541 L p F P
0 0 0 r
s
.99 .29 .124 r
.4634 .59541 m .47072 .59541 L .48533 .61425 L p F P
0 0 0 r
s
.24 .35 .67 r
.48284 .60245 m
.48297 .61029 L
s
.48297 .61029 m
.483 .61267 L
s
.99 .29 .124 r
.48166 .61425 m .478 .61425 L .45608 .59541 L p F P
0 0 0 r
s
.99 .29 .124 r
.45608 .59541 m .4634 .59541 L .48166 .61425 L p F P
0 0 0 r
s
.99 .29 .124 r
.478 .61425 m .47433 .61425 L .44876 .59541 L p F P
0 0 0 r
s
.99 .29 .124 r
.44876 .59541 m .45608 .59541 L .478 .61425 L p F P
0 0 0 r
s
.83 .24 .1 r
.45338 .60331 m
.4538 .61852 L
s
.45314 .59437 m
.45317 .59541 L
s
.329 .485 .9 r
.61737 .54359 m .61639 .55321 L .63282 .53166 L p F P
0 0 0 r
s
.329 .485 .9 r
.63282 .53166 m .6341 .52047 L .61737 .54359 L p F P
0 0 0 r
s
.24 .35 .67 r
.63234 .5229 m
.63257 .52087 L
s
.124 .196 .438 r
.36718 .53166 m .3659 .52047 L .38263 .54359 L p F P
0 0 0 r
s
.24 .35 .67 r
.36743 .52087 m
.36766 .5229 L
s
.36879 .5329 m
.3689 .53392 L
s
.124 .196 .438 r
.38263 .54359 m .38361 .55321 L .36718 .53166 L p F P
0 0 0 r
s
.281 .411 .734 r
.64875 .48413 m .64717 .49692 L .65624 .47365 L p F P
0 0 0 r
s
.281 .411 .734 r
.65624 .47365 m .65801 .45981 L .64875 .48413 L p F P
0 0 0 r
s
.068 .1 .244 r
.34376 .47365 m .34199 .45981 L .35125 .48413 L p F P
0 0 0 r
s
.068 .1 .244 r
.35125 .48413 m .35283 .49692 L .34376 .47365 L p F P
0 0 0 r
s
.322 .48 .92 r
.57468 .59165 m .57509 .58571 L .55086 .60343 L p F P
0 0 0 r
s
.33 .49 .931 r
.57509 .58571 m .57468 .59165 L .59681 .57341 L p F P
0 0 0 r
s
.206 .315 .651 r
.42491 .58571 m .42532 .59165 L .40319 .57341 L p F P
0 0 0 r
s
.235 .358 .725 r
.42532 .59165 m .42491 .58571 L .44914 .60343 L p F P
0 0 0 r
s
.322 .48 .92 r
.55105 .59943 m .55086 .60343 L .57509 .58571 L p F P
0 0 0 r
s
.235 .358 .725 r
.44895 .59943 m .44914 .60343 L .42491 .58571 L p F P
0 0 0 r
s
.333 .493 .926 r
.59749 .56557 m .59681 .57341 L .61639 .55321 L p F P
0 0 0 r
s
.333 .493 .926 r
.61639 .55321 m .61737 .54359 L .59749 .56557 L p F P
0 0 0 r
s
.169 .262 .556 r
.38361 .55321 m .38263 .54359 L .40251 .56557 L p F P
0 0 0 r
s
.169 .262 .556 r
.40251 .56557 m .40319 .57341 L .38361 .55321 L p F P
0 0 0 r
s
.33 .49 .931 r
.59681 .57341 m .59749 .56557 L .57509 .58571 L p F P
0 0 0 r
s
.206 .315 .651 r
.40319 .57341 m .40251 .56557 L .42491 .58571 L p F P
0 0 0 r
s
.24 .35 .67 r
.55059 .20704 m
.51707 .20215 L
s
.51707 .20215 m
.51748 .16632 L
s
.51707 .20215 m
.48293 .20215 L
s
.48293 .20215 m
.48252 .16632 L
s
.48293 .20215 m
.44941 .20704 L
s
.23 .333 .575 r
.65983 .44565 m .65801 .45981 L .66297 .43684 L p F P
0 0 0 r
s
.23 .333 .575 r
.66297 .43684 m .6649 .42195 L .65983 .44565 L p F P
0 0 0 r
s
.24 .35 .67 r
.66014 .44419 m
.6603 .44298 L
s
.045 .066 .152 r
.33703 .43684 m .3351 .42195 L .34017 .44565 L p F P
0 0 0 r
s
.045 .066 .152 r
.34017 .44565 m .34199 .45981 L .33703 .43684 L p F P
0 0 0 r
s
.24 .35 .67 r
.3397 .44298 m
.33986 .44419 L
s
.313 .46 .84 r
.6354 .50907 m .6341 .52047 L .64717 .49692 L p F P
0 0 0 r
s
.24 .35 .67 r
.63257 .52087 m
.63437 .51812 L
s
.313 .46 .84 r
.64717 .49692 m .64875 .48413 L .6354 .50907 L p F P
0 0 0 r
s
.092 .138 .333 r
.35283 .49692 m .35125 .48413 L .3646 .50907 L p F P
0 0 0 r
s
.092 .138 .333 r
.3646 .50907 m .3659 .52047 L .35283 .49692 L p F P
0 0 0 r
s
.24 .35 .67 r
.36563 .51812 m
.36743 .52087 L
s
.34005 .36067 m
.33619 .3286 L
s
.33434 .38641 m
.34005 .36067 L
s
.65995 .36067 m
.66566 .38641 L
s
.65995 .36067 m
.66381 .3286 L
s
.65109 .30442 m
.63231 .28292 L
s
.63231 .28292 m
.6355 .24898 L
s
.36769 .28292 m
.3645 .24898 L
s
.36769 .28292 m
.34891 .30442 L
s
.322 .48 .92 r
.55124 .59541 m .55105 .59943 L .57549 .57971 L p F P
0 0 0 r
s
.24 .35 .67 r
.5583 .59358 m
.56707 .59029 L
s
.322 .48 .92 r
.57509 .58571 m .57549 .57971 L .55105 .59943 L p F P
0 0 0 r
s
.235 .358 .725 r
.42491 .58571 m .42451 .57971 L .44895 .59943 L p F P
0 0 0 r
s
.235 .358 .725 r
.44876 .59541 m .44895 .59943 L .42451 .57971 L p F P
0 0 0 r
s
.24 .35 .67 r
.46166 .59867 m
.48284 .60245 L
s
.51716 .60245 m
.53834 .59867 L
s
.83 .24 .1 r
.82741 .40178 m
.78064 .40178 L
s
.78064 .40178 m
.73386 .40178 L
s
.73386 .40178 m
.68709 .40178 L
s
.64032 .40178 m
.66536 .40178 L
s
.66547 .40178 m
.68709 .40178 L
s
.64032 .40178 m
.59355 .40178 L
s
.59355 .40178 m
.54677 .40178 L
s
.54677 .40178 m
.5 .40178 L
s
.5 .40178 m
.45323 .40178 L
s
.45323 .40178 m
.40645 .40178 L
s
.40645 .40178 m
.35968 .40178 L
s
.33464 .40178 m
.35968 .40178 L
s
.31291 .40178 m
.33453 .40178 L
s
.31291 .40178 m
.26614 .40178 L
s
.26614 .40178 m
.21936 .40178 L
s
.21936 .40178 m
.17259 .40178 L
s
.78377 .43038 m
.78064 .40178 L
s
.82741 .40178 m
.83107 .43038 L
s
.73648 .43038 m
.73386 .40178 L
s
.68918 .43038 m
.68709 .40178 L
s
.31082 .43038 m
.31291 .40178 L
s
.26352 .43038 m
.26614 .40178 L
s
.21623 .43038 m
.21936 .40178 L
s
.16893 .43038 m
.17259 .40178 L
s
.24 .35 .67 r
.58229 .21669 m
.55059 .20704 L
s
.55059 .20704 m
.55181 .17123 L
s
.44941 .20704 m
.44819 .17123 L
s
.44941 .20704 m
.41771 .21669 L
s
.33 .49 .931 r
.57549 .57971 m .57509 .58571 L .59749 .56557 L p F P
0 0 0 r
s
.206 .315 .651 r
.42451 .57971 m .42491 .58571 L .40251 .56557 L p F P
0 0 0 r
s
.729 .199 .084 r
.6649 .42195 m .64134 .42195 L .64185 .4007 L p F P
0 0 0 r
s
.24 .35 .67 r
.66167 .41898 m
.6618 .41679 L
s
.729 .199 .084 r
.64185 .4007 m .6655 .4007 L .6649 .42195 L p F P
0 0 0 r
s
.24 .35 .67 r
.66384 .4007 m
.66566 .38641 L
s
.6603 .44298 m
.6615 .42195 L
s
.729 .199 .084 r
.64134 .42195 m .61779 .42195 L .61821 .4007 L p F P
0 0 0 r
s
.729 .199 .084 r
.61821 .4007 m .64185 .4007 L .64134 .42195 L p F P
0 0 0 r
s
.729 .199 .084 r
.61779 .42195 m .59423 .42195 L .59457 .4007 L p F P
0 0 0 r
s
.729 .199 .084 r
.59457 .4007 m .61821 .4007 L .61779 .42195 L p F P
0 0 0 r
s
.729 .199 .084 r
.59423 .42195 m .57067 .42195 L .57093 .4007 L p F P
0 0 0 r
s
.729 .199 .084 r
.57093 .4007 m .59457 .4007 L .59423 .42195 L p F P
0 0 0 r
s
.729 .199 .084 r
.57067 .42195 m .54711 .42195 L .54728 .4007 L p F P
0 0 0 r
s
.729 .199 .084 r
.54728 .4007 m .57093 .4007 L .57067 .42195 L p F P
0 0 0 r
s
.729 .199 .084 r
.54711 .42195 m .52356 .42195 L .52364 .4007 L p F P
0 0 0 r
s
.729 .199 .084 r
.52364 .4007 m .54728 .4007 L .54711 .42195 L p F P
0 0 0 r
s
.729 .199 .084 r
.52356 .42195 m .5 .42195 L .5 .4007 L p F P
0 0 0 r
s
.729 .199 .084 r
.5 .4007 m .52364 .4007 L .52356 .42195 L p F P
0 0 0 r
s
.729 .199 .084 r
.5 .42195 m .47644 .42195 L .47636 .4007 L p F P
0 0 0 r
s
.729 .199 .084 r
.47636 .4007 m .5 .4007 L .5 .42195 L p F P
0 0 0 r
s
.729 .199 .084 r
.47644 .42195 m .45289 .42195 L .45272 .4007 L p F P
0 0 0 r
s
.729 .199 .084 r
.45272 .4007 m .47636 .4007 L .47644 .42195 L p F P
0 0 0 r
s
.729 .199 .084 r
.45289 .42195 m .42933 .42195 L .42907 .4007 L p F P
0 0 0 r
s
.729 .199 .084 r
.42907 .4007 m .45272 .4007 L .45289 .42195 L p F P
0 0 0 r
s
.729 .199 .084 r
.42933 .42195 m .40577 .42195 L .40543 .4007 L p F P
0 0 0 r
s
.729 .199 .084 r
.40543 .4007 m .42907 .4007 L .42933 .42195 L p F P
0 0 0 r
s
.729 .199 .084 r
.40577 .42195 m .38221 .42195 L .38179 .4007 L p F P
0 0 0 r
s
.729 .199 .084 r
.38179 .4007 m .40543 .4007 L .40577 .42195 L p F P
0 0 0 r
s
.729 .199 .084 r
.38221 .42195 m .35866 .42195 L .35815 .4007 L p F P
0 0 0 r
s
.83 .24 .1 r
.35967 .40205 m
.35968 .40178 L
s
.729 .199 .084 r
.35815 .4007 m .38179 .4007 L .38221 .42195 L p F P
0 0 0 r
s
.729 .199 .084 r
.35866 .42195 m .3351 .42195 L .3345 .4007 L p F P
0 0 0 r
s
.729 .199 .084 r
.3345 .4007 m .35815 .4007 L .35866 .42195 L p F P
0 0 0 r
s
.24 .35 .67 r
.33434 .38641 m
.33616 .4007 L
s
.3385 .42195 m
.3397 .44298 L
s
.83 .24 .1 r
.78115 .59437 m
.82801 .59437 L
s
.73429 .59437 m
.78115 .59437 L
s
.68744 .59437 m
.73429 .59437 L
s
.64058 .59437 m
.68744 .59437 L
s
.59372 .59437 m
.64058 .59437 L
s
.555 .59437 m
.59372 .59437 L
s
.54686 .59437 m
.55283 .59437 L
s
.5 .59437 m
.54686 .59437 L
s
.45314 .59437 m
.5 .59437 L
s
.40628 .59437 m
.445 .59437 L
s
.44717 .59437 m
.45314 .59437 L
s
.35942 .59437 m
.40628 .59437 L
s
.31256 .59437 m
.35942 .59437 L
s
.26571 .59437 m
.31256 .59437 L
s
.21885 .59437 m
.26571 .59437 L
s
.17199 .59437 m
.21885 .59437 L
s
.78115 .59437 m
.78414 .56511 L
s
.8315 .56511 m
.82801 .59437 L
s
.73429 .59437 m
.73678 .56511 L
s
.68744 .59437 m
.68943 .56511 L
s
.64058 .59437 m
.64207 .56511 L
s
.35942 .59437 m
.35793 .56511 L
s
.31256 .59437 m
.31057 .56511 L
s
.26571 .59437 m
.26322 .56511 L
s
.21885 .59437 m
.21586 .56511 L
s
.17199 .59437 m
.1685 .56511 L
s
.329 .485 .9 r
.61837 .53382 m .61737 .54359 L .6341 .52047 L p F P
0 0 0 r
s
.329 .485 .9 r
.6341 .52047 m .6354 .50907 L .61837 .53382 L p F P
0 0 0 r
s
.124 .196 .438 r
.3659 .52047 m .3646 .50907 L .38163 .53382 L p F P
0 0 0 r
s
.124 .196 .438 r
.38163 .53382 m .38263 .54359 L .3659 .52047 L p F P
0 0 0 r
s
.24 .35 .67 r
.48284 .60245 m
.51716 .60245 L
s
.971 .282 .12 r
.55124 .59541 m .54392 .59541 L .56506 .57364 L p F P
0 0 0 r
s
.971 .282 .12 r
.56506 .57364 m .57591 .57364 L .55124 .59541 L p F P
0 0 0 r
s
.971 .282 .12 r
.54392 .59541 m .5366 .59541 L .55422 .57364 L p F P
0 0 0 r
s
.971 .282 .12 r
.55422 .57364 m .56506 .57364 L .54392 .59541 L p F P
0 0 0 r
s
.971 .282 .12 r
.5366 .59541 m .52928 .59541 L .54338 .57364 L p F P
0 0 0 r
s
.971 .282 .12 r
.54338 .57364 m .55422 .57364 L .5366 .59541 L p F P
0 0 0 r
s
.24 .35 .67 r
.55079 .59199 m
.55086 .59045 L
s
.971 .282 .12 r
.52928 .59541 m .52196 .59541 L .53253 .57364 L p F P
0 0 0 r
s
.971 .282 .12 r
.53253 .57364 m .54338 .57364 L .52928 .59541 L p F P
0 0 0 r
s
.971 .282 .12 r
.52196 .59541 m .51464 .59541 L .52169 .57364 L p F P
0 0 0 r
s
.971 .282 .12 r
.52169 .57364 m .53253 .57364 L .52196 .59541 L p F P
0 0 0 r
s
.971 .282 .12 r
.51464 .59541 m .50732 .59541 L .51084 .57364 L p F P
0 0 0 r
s
.971 .282 .12 r
.51084 .57364 m .52169 .57364 L .51464 .59541 L p F P
0 0 0 r
s
.24 .35 .67 r
.51716 .60245 m
.51757 .57611 L
s
.971 .282 .12 r
.50732 .59541 m .5 .59541 L .5 .57364 L p F P
0 0 0 r
s
.971 .282 .12 r
.5 .57364 m .51084 .57364 L .50732 .59541 L p F P
0 0 0 r
s
.971 .282 .12 r
.5 .59541 m .49268 .59541 L .48916 .57364 L p F P
0 0 0 r
s
.971 .282 .12 r
.48916 .57364 m .5 .57364 L .5 .59541 L p F P
0 0 0 r
s
.971 .282 .12 r
.49268 .59541 m .48536 .59541 L .47831 .57364 L p F P
0 0 0 r
s
.971 .282 .12 r
.47831 .57364 m .48916 .57364 L .49268 .59541 L p F P
0 0 0 r
s
.971 .282 .12 r
.48536 .59541 m .47804 .59541 L .46747 .57364 L p F P
0 0 0 r
s
.971 .282 .12 r
.46747 .57364 m .47831 .57364 L .48536 .59541 L p F P
0 0 0 r
s
.24 .35 .67 r
.48243 .57611 m
.48284 .60245 L
s
.971 .282 .12 r
.47804 .59541 m .47072 .59541 L .45662 .57364 L p F P
0 0 0 r
s
.971 .282 .12 r
.45662 .57364 m .46747 .57364 L .47804 .59541 L p F P
0 0 0 r
s
.971 .282 .12 r
.47072 .59541 m .4634 .59541 L .44578 .57364 L p F P
0 0 0 r
s
.971 .282 .12 r
.44578 .57364 m .45662 .57364 L .47072 .59541 L p F P
0 0 0 r
s
.971 .282 .12 r
.4634 .59541 m .45608 .59541 L .43494 .57364 L p F P
0 0 0 r
s
.83 .24 .1 r
.45311 .59234 m
.45314 .59437 L
s
.971 .282 .12 r
.43494 .57364 m .44578 .57364 L .4634 .59541 L p F P
0 0 0 r
s
.971 .282 .12 r
.45608 .59541 m .44876 .59541 L .42409 .57364 L p F P
0 0 0 r
s
.971 .282 .12 r
.42409 .57364 m .43494 .57364 L .45608 .59541 L p F P
0 0 0 r
s
.24 .35 .67 r
.44914 .59045 m
.44921 .59199 L
s
.235 .358 .725 r
.42451 .57971 m .42409 .57364 L .44876 .59541 L p F P
0 0 0 r
s
.322 .48 .92 r
.57549 .57971 m .57591 .57364 L .55124 .59541 L p F P
0 0 0 r
s
.33 .49 .931 r
.59749 .56557 m .59818 .55761 L .57549 .57971 L p F P
0 0 0 r
s
.333 .493 .926 r
.59818 .55761 m .59749 .56557 L .61737 .54359 L p F P
0 0 0 r
s
.169 .262 .556 r
.40182 .55761 m .40251 .56557 L .38263 .54359 L p F P
0 0 0 r
s
.206 .315 .651 r
.40251 .56557 m .40182 .55761 L .42451 .57971 L p F P
0 0 0 r
s
.333 .493 .926 r
.61737 .54359 m .61837 .53382 L .59818 .55761 L p F P
0 0 0 r
s
.169 .262 .556 r
.38263 .54359 m .38163 .53382 L .40182 .55761 L p F P
0 0 0 r
s
.281 .411 .734 r
.65036 .47107 m .64875 .48413 L .65801 .45981 L p F P
0 0 0 r
s
.281 .411 .734 r
.65801 .45981 m .65983 .44565 L .65036 .47107 L p F P
0 0 0 r
s
.24 .35 .67 r
.65487 .45898 m
.6603 .44298 L
s
.068 .1 .244 r
.34199 .45981 m .34017 .44565 L .34964 .47107 L p F P
0 0 0 r
s
.24 .35 .67 r
.3397 .44298 m
.34513 .45898 L
s
.068 .1 .244 r
.34964 .47107 m .35125 .48413 L .34199 .45981 L p F P
0 0 0 r
s
.24 .35 .67 r
.61098 .23081 m
.58229 .21669 L
s
.58229 .21669 m
.58429 .18091 L
s
.41771 .21669 m
.41571 .18091 L
s
.41771 .21669 m
.38902 .23081 L
s
.33 .49 .931 r
.57591 .57364 m .57549 .57971 L .59818 .55761 L p F P
0 0 0 r
s
.206 .315 .651 r
.42409 .57364 m .42451 .57971 L .40182 .55761 L p F P
0 0 0 r
s
.313 .46 .84 r
.63674 .49743 m .6354 .50907 L .64875 .48413 L p F P
0 0 0 r
s
.313 .46 .84 r
.64875 .48413 m .65036 .47107 L .63674 .49743 L p F P
0 0 0 r
s
.092 .138 .333 r
.35125 .48413 m .34964 .47107 L .36326 .49743 L p F P
0 0 0 r
s
.092 .138 .333 r
.36326 .49743 m .3646 .50907 L .35125 .48413 L p F P
0 0 0 r
s
.784 .216 .092 r
.65983 .44565 m .637 .44565 L .64134 .42195 L p F P
0 0 0 r
s
.83 .24 .1 r
.64142 .42195 m
.64143 .42206 L
s
.784 .216 .092 r
.64134 .42195 m .6649 .42195 L .65983 .44565 L p F P
0 0 0 r
s
.24 .35 .67 r
.66202 .42959 m
.66213 .42874 L
s
.66213 .42874 m
.66417 .41283 L
s
.784 .216 .092 r
.637 .44565 m .61417 .44565 L .61779 .42195 L p F P
0 0 0 r
s
.784 .216 .092 r
.61779 .42195 m .64134 .42195 L .637 .44565 L p F P
0 0 0 r
s
.784 .216 .092 r
.61417 .44565 m .59133 .44565 L .59423 .42195 L p F P
0 0 0 r
s
.83 .24 .1 r
.59428 .42195 m
.59429 .42202 L
s
.784 .216 .092 r
.59423 .42195 m .61779 .42195 L .61417 .44565 L p F P
0 0 0 r
s
.784 .216 .092 r
.59133 .44565 m .5685 .44565 L .57067 .42195 L p F P
0 0 0 r
s
.784 .216 .092 r
.57067 .42195 m .59423 .42195 L .59133 .44565 L p F P
0 0 0 r
s
.784 .216 .092 r
.5685 .44565 m .54567 .44565 L .54711 .42195 L p F P
0 0 0 r
s
.83 .24 .1 r
.54714 .42195 m
.54714 .42198 L
s
.784 .216 .092 r
.54711 .42195 m .57067 .42195 L .5685 .44565 L p F P
0 0 0 r
s
.784 .216 .092 r
.54567 .44565 m .52283 .44565 L .52356 .42195 L p F P
0 0 0 r
s
.784 .216 .092 r
.52356 .42195 m .54711 .42195 L .54567 .44565 L p F P
0 0 0 r
s
.784 .216 .092 r
.52283 .44565 m .5 .44565 L .5 .42195 L p F P
0 0 0 r
s
.784 .216 .092 r
.5 .42195 m .52356 .42195 L .52283 .44565 L p F P
0 0 0 r
s
.784 .216 .092 r
.5 .44565 m .47717 .44565 L .47644 .42195 L p F P
0 0 0 r
s
.784 .216 .092 r
.47644 .42195 m .5 .42195 L .5 .44565 L p F P
0 0 0 r
s
.784 .216 .092 r
.47717 .44565 m .45433 .44565 L .45289 .42195 L p F P
0 0 0 r
s
.784 .216 .092 r
.45289 .42195 m .47644 .42195 L .47717 .44565 L p F P
0 0 0 r
s
.784 .216 .092 r
.45433 .44565 m .4315 .44565 L .42933 .42195 L p F P
0 0 0 r
s
.784 .216 .092 r
.42933 .42195 m .45289 .42195 L .45433 .44565 L p F P
0 0 0 r
s
.784 .216 .092 r
.4315 .44565 m .40867 .44565 L .40577 .42195 L p F P
0 0 0 r
s
.784 .216 .092 r
.40577 .42195 m .42933 .42195 L .4315 .44565 L p F P
0 0 0 r
s
.784 .216 .092 r
.40867 .44565 m .38583 .44565 L .38221 .42195 L p F P
0 0 0 r
s
.784 .216 .092 r
.38221 .42195 m .40577 .42195 L .40867 .44565 L p F P
0 0 0 r
s
.784 .216 .092 r
.38583 .44565 m .363 .44565 L .35866 .42195 L p F P
0 0 0 r
s
.784 .216 .092 r
.35866 .42195 m .38221 .42195 L .38583 .44565 L p F P
0 0 0 r
s
.784 .216 .092 r
.363 .44565 m .34017 .44565 L .3351 .42195 L p F P
0 0 0 r
s
.784 .216 .092 r
.3351 .42195 m .35866 .42195 L .363 .44565 L p F P
0 0 0 r
s
.24 .35 .67 r
.33583 .41283 m
.33787 .42874 L
s
.33787 .42874 m
.33798 .42959 L
s
.33 .49 .931 r
.59818 .55761 m .59888 .54955 L .57591 .57364 L p F P
0 0 0 r
s
.333 .493 .926 r
.59888 .54955 m .59818 .55761 L .61837 .53382 L p F P
0 0 0 r
s
.169 .262 .556 r
.40112 .54955 m .40182 .55761 L .38163 .53382 L p F P
0 0 0 r
s
.206 .315 .651 r
.40182 .55761 m .40112 .54955 L .42409 .57364 L p F P
0 0 0 r
s
.24 .35 .67 r
.66381 .3286 m
.65109 .30442 L
s
.65109 .30442 m
.65478 .27061 L
s
.34891 .30442 m
.34522 .27061 L
s
.34891 .30442 m
.33619 .3286 L
s
.949 .273 .117 r
.57591 .57364 m .56506 .57364 L .58475 .54955 L p F P
0 0 0 r
s
.949 .273 .117 r
.58475 .54955 m .59888 .54955 L .57591 .57364 L p F P
0 0 0 r
s
.83 .24 .1 r
.59372 .59437 m
.59471 .56511 L
s
.949 .273 .117 r
.56506 .57364 m .55422 .57364 L .57063 .54955 L p F P
0 0 0 r
s
.949 .273 .117 r
.57063 .54955 m .58475 .54955 L .56506 .57364 L p F P
0 0 0 r
s
.24 .35 .67 r
.58337 .55835 m
.59124 .55354 L
s
.58297 .56379 m
.58337 .55835 L
s
.949 .273 .117 r
.55422 .57364 m .54338 .57364 L .5565 .54955 L p F P
0 0 0 r
s
.24 .35 .67 r
.55086 .59045 m
.55096 .58834 L
s
.949 .273 .117 r
.5565 .54955 m .57063 .54955 L .55422 .57364 L p F P
0 0 0 r
s
.949 .273 .117 r
.54338 .57364 m .53253 .57364 L .54238 .54955 L p F P
0 0 0 r
s
.949 .273 .117 r
.54238 .54955 m .5565 .54955 L .54338 .57364 L p F P
0 0 0 r
s
.24 .35 .67 r
.55096 .58834 m
.5518 .57007 L
s
.949 .273 .117 r
.53253 .57364 m .52169 .57364 L .52825 .54955 L p F P
0 0 0 r
s
.949 .273 .117 r
.52825 .54955 m .54238 .54955 L .53253 .57364 L p F P
0 0 0 r
s
.949 .273 .117 r
.52169 .57364 m .51084 .57364 L .51413 .54955 L p F P
0 0 0 r
s
.949 .273 .117 r
.51413 .54955 m .52825 .54955 L .52169 .57364 L p F P
0 0 0 r
s
.949 .273 .117 r
.51084 .57364 m .5 .57364 L .5 .54955 L p F P
0 0 0 r
s
.949 .273 .117 r
.5 .54955 m .51413 .54955 L .51084 .57364 L p F P
0 0 0 r
s
.949 .273 .117 r
.5 .57364 m .48916 .57364 L .48587 .54955 L p F P
0 0 0 r
s
.949 .273 .117 r
.48587 .54955 m .5 .54955 L .5 .57364 L p F P
0 0 0 r
s
.949 .273 .117 r
.48916 .57364 m .47831 .57364 L .47175 .54955 L p F P
0 0 0 r
s
.949 .273 .117 r
.47175 .54955 m .48587 .54955 L .48916 .57364 L p F P
0 0 0 r
s
.949 .273 .117 r
.47831 .57364 m .46747 .57364 L .45762 .54955 L p F P
0 0 0 r
s
.949 .273 .117 r
.45762 .54955 m .47175 .54955 L .47831 .57364 L p F P
0 0 0 r
s
.949 .273 .117 r
.46747 .57364 m .45662 .57364 L .4435 .54955 L p F P
0 0 0 r
s
.24 .35 .67 r
.44904 .58834 m
.44914 .59045 L
s
.949 .273 .117 r
.4435 .54955 m .45762 .54955 L .46747 .57364 L p F P
0 0 0 r
s
.949 .273 .117 r
.45662 .57364 m .44578 .57364 L .42937 .54955 L p F P
0 0 0 r
s
.949 .273 .117 r
.42937 .54955 m .4435 .54955 L .45662 .57364 L p F P
0 0 0 r
s
.24 .35 .67 r
.4482 .57007 m
.44904 .58834 L
s
.949 .273 .117 r
.44578 .57364 m .43494 .57364 L .41525 .54955 L p F P
0 0 0 r
s
.949 .273 .117 r
.41525 .54955 m .42937 .54955 L .44578 .57364 L p F P
0 0 0 r
s
.949 .273 .117 r
.43494 .57364 m .42409 .57364 L .40112 .54955 L p F P
0 0 0 r
s
.949 .273 .117 r
.40112 .54955 m .41525 .54955 L .43494 .57364 L p F P
0 0 0 r
s
.83 .24 .1 r
.40529 .56511 m
.40628 .59437 L
s
.24 .35 .67 r
.41663 .55835 m
.41703 .56379 L
s
.40876 .55354 m
.41663 .55835 L
s
.83 .24 .1 r
.78579 .46287 m
.78377 .43038 L
s
.83107 .43038 m
.83342 .46287 L
s
.78377 .43038 m
.83107 .43038 L
s
.73816 .46287 m
.73648 .43038 L
s
.73648 .43038 m
.78377 .43038 L
s
.69053 .46287 m
.68918 .43038 L
s
.68918 .43038 m
.73648 .43038 L
s
.66317 .43038 m
.68918 .43038 L
s
.30947 .46287 m
.31082 .43038 L
s
.31082 .43038 m
.33683 .43038 L
s
.26184 .46287 m
.26352 .43038 L
s
.26352 .43038 m
.31082 .43038 L
s
.21421 .46287 m
.21623 .43038 L
s
.21623 .43038 m
.26352 .43038 L
s
.16658 .46287 m
.16893 .43038 L
s
.16893 .43038 m
.21623 .43038 L
s
.24 .35 .67 r
.6697 .35454 m
.66566 .38641 L
s
.66417 .41283 m
.66566 .38641 L
s
.33434 .38641 m
.3303 .35454 L
s
.33434 .38641 m
.33583 .41283 L
s
.329 .485 .9 r
.61939 .52388 m .61837 .53382 L .6354 .50907 L p F P
0 0 0 r
s
.329 .485 .9 r
.6354 .50907 m .63674 .49743 L .61939 .52388 L p F P
0 0 0 r
s
.124 .196 .438 r
.3646 .50907 m .36326 .49743 L .38061 .52388 L p F P
0 0 0 r
s
.24 .35 .67 r
.36626 .51061 m
.36638 .51166 L
s
.124 .196 .438 r
.38061 .52388 m .38163 .53382 L .3646 .50907 L p F P
0 0 0 r
s
.333 .493 .926 r
.61837 .53382 m .61939 .52388 L .59888 .54955 L p F P
0 0 0 r
s
.24 .35 .67 r
.59778 .54955 m
.59993 .54823 L
s
.169 .262 .556 r
.38163 .53382 m .38061 .52388 L .40112 .54955 L p F P
0 0 0 r
s
.24 .35 .67 r
.40007 .54823 m
.40222 .54955 L
s
.83 .24 .1 r
.78414 .56511 m
.8315 .56511 L
s
.73678 .56511 m
.78414 .56511 L
s
.68943 .56511 m
.73678 .56511 L
s
.64207 .56511 m
.68943 .56511 L
s
.59471 .56511 m
.64207 .56511 L
s
.5852 .56511 m
.59471 .56511 L
s
.40529 .56511 m
.4148 .56511 L
s
.35793 .56511 m
.40529 .56511 L
s
.31057 .56511 m
.35793 .56511 L
s
.26322 .56511 m
.31057 .56511 L
s
.21586 .56511 m
.26322 .56511 L
s
.1685 .56511 m
.21586 .56511 L
s
.78414 .56511 m
.78598 .5322 L
s
.83364 .5322 m
.8315 .56511 L
s
.73678 .56511 m
.73831 .5322 L
s
.68943 .56511 m
.69065 .5322 L
s
.64207 .56511 m
.64299 .5322 L
s
.59471 .56511 m
.59489 .55573 L
s
.40511 .55573 m
.40529 .56511 L
s
.35793 .56511 m
.35701 .5322 L
s
.31057 .56511 m
.30935 .5322 L
s
.26322 .56511 m
.26169 .5322 L
s
.21586 .56511 m
.21402 .5322 L
s
.1685 .56511 m
.16636 .5322 L
s
.24 .35 .67 r
.6355 .24898 m
.61098 .23081 L
s
.61098 .23081 m
.61369 .1951 L
s
.38902 .23081 m
.38631 .1951 L
s
.38902 .23081 m
.3645 .24898 L
s
.827 .231 .098 r
.65036 .47107 m .62888 .47107 L .637 .44565 L p F P
0 0 0 r
s
.24 .35 .67 r
.65019 .47076 m
.65085 .46977 L
s
.827 .231 .098 r
.637 .44565 m .65983 .44565 L .65036 .47107 L p F P
0 0 0 r
s
.24 .35 .67 r
.6524 .46205 m
.65261 .46034 L
s
.65261 .46034 m
.65529 .43875 L
s
.827 .231 .098 r
.62888 .47107 m .6074 .47107 L .61417 .44565 L p F P
0 0 0 r
s
.827 .231 .098 r
.61417 .44565 m .637 .44565 L .62888 .47107 L p F P
0 0 0 r
s
.827 .231 .098 r
.6074 .47107 m .58592 .47107 L .59133 .44565 L p F P
0 0 0 r
s
.83 .24 .1 r
.59491 .44565 m
.59503 .45149 L
s
.827 .231 .098 r
.59133 .44565 m .61417 .44565 L .6074 .47107 L p F P
0 0 0 r
s
.827 .231 .098 r
.58592 .47107 m .56444 .47107 L .5685 .44565 L p F P
0 0 0 r
s
.827 .231 .098 r
.5685 .44565 m .59133 .44565 L .58592 .47107 L p F P
0 0 0 r
s
.827 .231 .098 r
.56444 .47107 m .54296 .47107 L .54567 .44565 L p F P
0 0 0 r
s
.83 .24 .1 r
.54745 .44565 m
.54748 .4481 L
s
.827 .231 .098 r
.54567 .44565 m .5685 .44565 L .56444 .47107 L p F P
0 0 0 r
s
.827 .231 .098 r
.54296 .47107 m .52148 .47107 L .52283 .44565 L p F P
0 0 0 r
s
.827 .231 .098 r
.52283 .44565 m .54567 .44565 L .54296 .47107 L p F P
0 0 0 r
s
.827 .231 .098 r
.52148 .47107 m .5 .47107 L .5 .44565 L p F P
0 0 0 r
s
.827 .231 .098 r
.5 .44565 m .52283 .44565 L .52148 .47107 L p F P
0 0 0 r
s
.827 .231 .098 r
.5 .47107 m .47852 .47107 L .47717 .44565 L p F P
0 0 0 r
s
.827 .231 .098 r
.47717 .44565 m .5 .44565 L .5 .47107 L p F P
0 0 0 r
s
.827 .231 .098 r
.47852 .47107 m .45704 .47107 L .45433 .44565 L p F P
0 0 0 r
s
.827 .231 .098 r
.45433 .44565 m .47717 .44565 L .47852 .47107 L p F P
0 0 0 r
s
.827 .231 .098 r
.45704 .47107 m .43556 .47107 L .4315 .44565 L p F P
0 0 0 r
s
.827 .231 .098 r
.4315 .44565 m .45433 .44565 L .45704 .47107 L p F P
0 0 0 r
s
.827 .231 .098 r
.43556 .47107 m .41408 .47107 L .40867 .44565 L p F P
0 0 0 r
s
.827 .231 .098 r
.40867 .44565 m .4315 .44565 L .43556 .47107 L p F P
0 0 0 r
s
.827 .231 .098 r
.41408 .47107 m .3926 .47107 L .38583 .44565 L p F P
0 0 0 r
s
.827 .231 .098 r
.38583 .44565 m .40867 .44565 L .41408 .47107 L p F P
0 0 0 r
s
.827 .231 .098 r
.3926 .47107 m .37112 .47107 L .363 .44565 L p F P
0 0 0 r
s
.827 .231 .098 r
.363 .44565 m .38583 .44565 L .3926 .47107 L p F P
0 0 0 r
s
.827 .231 .098 r
.37112 .47107 m .34964 .47107 L .34017 .44565 L p F P
0 0 0 r
s
.827 .231 .098 r
.34017 .44565 m .363 .44565 L .37112 .47107 L p F P
0 0 0 r
s
.24 .35 .67 r
.34471 .43875 m
.34739 .46034 L
s
.34739 .46034 m
.3476 .46205 L
s
.923 .264 .112 r
.59888 .54955 m .58475 .54955 L .60233 .52388 L p F P
0 0 0 r
s
.923 .264 .112 r
.60233 .52388 m .61939 .52388 L .59888 .54955 L p F P
0 0 0 r
s
.923 .264 .112 r
.58475 .54955 m .57063 .54955 L .58528 .52388 L p F P
0 0 0 r
s
.923 .264 .112 r
.58528 .52388 m .60233 .52388 L .58475 .54955 L p F P
0 0 0 r
s
.923 .264 .112 r
.57063 .54955 m .5565 .54955 L .56822 .52388 L p F P
0 0 0 r
s
.923 .264 .112 r
.56822 .52388 m .58528 .52388 L .57063 .54955 L p F P
0 0 0 r
s
.923 .264 .112 r
.5565 .54955 m .54238 .54955 L .55117 .52388 L p F P
0 0 0 r
s
.923 .264 .112 r
.55117 .52388 m .56822 .52388 L .5565 .54955 L p F P
0 0 0 r
s
.923 .264 .112 r
.54238 .54955 m .52825 .54955 L .53411 .52388 L p F P
0 0 0 r
s
.923 .264 .112 r
.53411 .52388 m .55117 .52388 L .54238 .54955 L p F P
0 0 0 r
s
.923 .264 .112 r
.52825 .54955 m .51413 .54955 L .51706 .52388 L p F P
0 0 0 r
s
.923 .264 .112 r
.51706 .52388 m .53411 .52388 L .52825 .54955 L p F P
0 0 0 r
s
.923 .264 .112 r
.51413 .54955 m .5 .54955 L .5 .52388 L p F P
0 0 0 r
s
.923 .264 .112 r
.5 .52388 m .51706 .52388 L .51413 .54955 L p F P
0 0 0 r
s
.923 .264 .112 r
.5 .54955 m .48587 .54955 L .48294 .52388 L p F P
0 0 0 r
s
.923 .264 .112 r
.48294 .52388 m .5 .52388 L .5 .54955 L p F P
0 0 0 r
s
.923 .264 .112 r
.48587 .54955 m .47175 .54955 L .46589 .52388 L p F P
0 0 0 r
s
.923 .264 .112 r
.46589 .52388 m .48294 .52388 L .48587 .54955 L p F P
0 0 0 r
s
.923 .264 .112 r
.47175 .54955 m .45762 .54955 L .44883 .52388 L p F P
0 0 0 r
s
.923 .264 .112 r
.44883 .52388 m .46589 .52388 L .47175 .54955 L p F P
0 0 0 r
s
.923 .264 .112 r
.45762 .54955 m .4435 .54955 L .43178 .52388 L p F P
0 0 0 r
s
.923 .264 .112 r
.43178 .52388 m .44883 .52388 L .45762 .54955 L p F P
0 0 0 r
s
.923 .264 .112 r
.4435 .54955 m .42937 .54955 L .41472 .52388 L p F P
0 0 0 r
s
.923 .264 .112 r
.41472 .52388 m .43178 .52388 L .4435 .54955 L p F P
0 0 0 r
s
.923 .264 .112 r
.42937 .54955 m .41525 .54955 L .39767 .52388 L p F P
0 0 0 r
s
.923 .264 .112 r
.39767 .52388 m .41472 .52388 L .42937 .54955 L p F P
0 0 0 r
s
.923 .264 .112 r
.41525 .54955 m .40112 .54955 L .38061 .52388 L p F P
0 0 0 r
s
.923 .264 .112 r
.38061 .52388 m .39767 .52388 L .41525 .54955 L p F P
0 0 0 r
s
.83 .24 .1 r
.78654 .49746 m
.78579 .46287 L
s
.83342 .46287 m
.8343 .49746 L
s
.78579 .46287 m
.83342 .46287 L
s
.73878 .49746 m
.73816 .46287 L
s
.73816 .46287 m
.78579 .46287 L
s
.69103 .49746 m
.69053 .46287 L
s
.69053 .46287 m
.73816 .46287 L
s
.64298 .47107 m
.64314 .48505 L
s
.65362 .46287 m
.69053 .46287 L
s
.35686 .48505 m
.35702 .47107 L
s
.30897 .49746 m
.30947 .46287 L
s
.30947 .46287 m
.34638 .46287 L
s
.26122 .49746 m
.26184 .46287 L
s
.26184 .46287 m
.30947 .46287 L
s
.21346 .49746 m
.21421 .46287 L
s
.21421 .46287 m
.26184 .46287 L
s
.1657 .49746 m
.16658 .46287 L
s
.16658 .46287 m
.21421 .46287 L
s
.24 .35 .67 r
.41458 .5305 m
.41663 .55835 L
s
.41663 .55835 m
.4482 .57007 L
s
.5518 .57007 m
.58337 .55835 L
s
.58337 .55835 m
.58542 .5305 L
s
.83 .24 .1 r
.78598 .5322 m
.83364 .5322 L
s
.73831 .5322 m
.78598 .5322 L
s
.69065 .5322 m
.73831 .5322 L
s
.64299 .5322 m
.69065 .5322 L
s
.61503 .5322 m
.64299 .5322 L
s
.61351 .5322 m
.61503 .5322 L
s
.35701 .5322 m
.38497 .5322 L
s
.38497 .5322 m
.38649 .5322 L
s
.30935 .5322 m
.35701 .5322 L
s
.26169 .5322 m
.30935 .5322 L
s
.21402 .5322 m
.26169 .5322 L
s
.16636 .5322 m
.21402 .5322 L
s
.78598 .5322 m
.78654 .49746 L
s
.8343 .49746 m
.83364 .5322 L
s
.73831 .5322 m
.73878 .49746 L
s
.69065 .5322 m
.69103 .49746 L
s
.64299 .5322 m
.64327 .49746 L
s
.59537 .52388 m
.59551 .49746 L
s
.54769 .52388 m
.54776 .49746 L
s
.5 .49746 m
.5 .52388 L
s
.45224 .49746 m
.45231 .52388 L
s
.40449 .49746 m
.40463 .52388 L
s
.35673 .49746 m
.35701 .5322 L
s
.30935 .5322 m
.30897 .49746 L
s
.26169 .5322 m
.26122 .49746 L
s
.21402 .5322 m
.21346 .49746 L
s
.16636 .5322 m
.1657 .49746 L
s
.864 .243 .104 r
.63674 .49743 m .6172 .49743 L .62888 .47107 L p F P
0 0 0 r
s
.864 .243 .104 r
.62888 .47107 m .65036 .47107 L .63674 .49743 L p F P
0 0 0 r
s
.24 .35 .67 r
.63536 .49627 m
.63578 .49261 L
s
.63578 .49261 m
.63804 .48917 L
s
.83 .24 .1 r
.64315 .48612 m
.64327 .49746 L
s
.24 .35 .67 r
.63804 .48917 m
.64099 .48471 L
s
.864 .243 .104 r
.6172 .49743 m .59767 .49743 L .6074 .47107 L p F P
0 0 0 r
s
.864 .243 .104 r
.6074 .47107 m .62888 .47107 L .6172 .49743 L p F P
0 0 0 r
s
.864 .243 .104 r
.59767 .49743 m .57814 .49743 L .58592 .47107 L p F P
0 0 0 r
s
.864 .243 .104 r
.58592 .47107 m .6074 .47107 L .59767 .49743 L p F P
0 0 0 r
s
.83 .24 .1 r
.59551 .49743 m
.59551 .49746 L
s
.864 .243 .104 r
.57814 .49743 m .5586 .49743 L .56444 .47107 L p F P
0 0 0 r
s
.864 .243 .104 r
.56444 .47107 m .58592 .47107 L .57814 .49743 L p F P
0 0 0 r
s
.864 .243 .104 r
.5586 .49743 m .53907 .49743 L .54296 .47107 L p F P
0 0 0 r
s
.83 .24 .1 r
.54766 .47107 m
.54769 .47905 L
s
.864 .243 .104 r
.54296 .47107 m .56444 .47107 L .5586 .49743 L p F P
0 0 0 r
s
.83 .24 .1 r
.54776 .49743 m
.54776 .49746 L
s
.864 .243 .104 r
.53907 .49743 m .51953 .49743 L .52148 .47107 L p F P
0 0 0 r
s
.864 .243 .104 r
.52148 .47107 m .54296 .47107 L .53907 .49743 L p F P
0 0 0 r
s
.864 .243 .104 r
.51953 .49743 m .5 .49743 L .5 .47107 L p F P
0 0 0 r
s
.864 .243 .104 r
.5 .47107 m .52148 .47107 L .51953 .49743 L p F P
0 0 0 r
s
.864 .243 .104 r
.5 .49743 m .48047 .49743 L .47852 .47107 L p F P
0 0 0 r
s
.864 .243 .104 r
.47852 .47107 m .5 .47107 L .5 .49743 L p F P
0 0 0 r
s
.83 .24 .1 r
.5 .49743 m
.5 .49746 L
s
.864 .243 .104 r
.48047 .49743 m .46093 .49743 L .45704 .47107 L p F P
0 0 0 r
s
.864 .243 .104 r
.45704 .47107 m .47852 .47107 L .48047 .49743 L p F P
0 0 0 r
s
.864 .243 .104 r
.46093 .49743 m .4414 .49743 L .43556 .47107 L p F P
0 0 0 r
s
.83 .24 .1 r
.45228 .48844 m
.45234 .47107 L
s
.864 .243 .104 r
.43556 .47107 m .45704 .47107 L .46093 .49743 L p F P
0 0 0 r
s
.83 .24 .1 r
.45224 .49746 m
.45224 .49743 L
s
.864 .243 .104 r
.4414 .49743 m .42186 .49743 L .41408 .47107 L p F P
0 0 0 r
s
.864 .243 .104 r
.41408 .47107 m .43556 .47107 L .4414 .49743 L p F P
0 0 0 r
s
.864 .243 .104 r
.42186 .49743 m .40233 .49743 L .3926 .47107 L p F P
0 0 0 r
s
.83 .24 .1 r
.4046 .48188 m
.40468 .47107 L
s
.864 .243 .104 r
.3926 .47107 m .41408 .47107 L .42186 .49743 L p F P
0 0 0 r
s
.83 .24 .1 r
.40449 .49746 m
.40449 .49743 L
s
.864 .243 .104 r
.40233 .49743 m .3828 .49743 L .37112 .47107 L p F P
0 0 0 r
s
.864 .243 .104 r
.37112 .47107 m .3926 .47107 L .40233 .49743 L p F P
0 0 0 r
s
.864 .243 .104 r
.3828 .49743 m .36326 .49743 L .34964 .47107 L p F P
0 0 0 r
s
.24 .35 .67 r
.35002 .47107 m
.35043 .4717 L
s
.864 .243 .104 r
.34964 .47107 m .37112 .47107 L .3828 .49743 L p F P
0 0 0 r
s
.24 .35 .67 r
.36422 .49261 m
.36464 .49627 L
s
.36196 .48917 m
.36422 .49261 L
s
.35901 .48471 m
.36196 .48917 L
s
.83 .24 .1 r
.35673 .49746 m
.35685 .48612 L
s
.78654 .49746 m
.8343 .49746 L
s
.73878 .49746 m
.78654 .49746 L
s
.69103 .49746 m
.73878 .49746 L
s
.64327 .49746 m
.69103 .49746 L
s
.6372 .49746 m
.64327 .49746 L
s
.59551 .49746 m
.63672 .49746 L
s
.54776 .49746 m
.59551 .49746 L
s
.5 .49746 m
.54776 .49746 L
s
.45224 .49746 m
.5 .49746 L
s
.40449 .49746 m
.45224 .49746 L
s
.35673 .49746 m
.3628 .49746 L
s
.36328 .49746 m
.40449 .49746 L
s
.30897 .49746 m
.35673 .49746 L
s
.26122 .49746 m
.30897 .49746 L
s
.21346 .49746 m
.26122 .49746 L
s
.1657 .49746 m
.21346 .49746 L
s
.895 .254 .108 r
.61939 .52388 m .60233 .52388 L .6172 .49743 L p F P
0 0 0 r
s
.24 .35 .67 r
.61173 .5311 m
.61182 .53021 L
s
.895 .254 .108 r
.6172 .49743 m .63674 .49743 L .61939 .52388 L p F P
0 0 0 r
s
.895 .254 .108 r
.60233 .52388 m .58528 .52388 L .59767 .49743 L p F P
0 0 0 r
s
.895 .254 .108 r
.59767 .49743 m .6172 .49743 L .60233 .52388 L p F P
0 0 0 r
s
.24 .35 .67 r
.61182 .53021 m
.61342 .5136 L
s
.895 .254 .108 r
.58528 .52388 m .56822 .52388 L .57814 .49743 L p F P
0 0 0 r
s
.895 .254 .108 r
.57814 .49743 m .59767 .49743 L .58528 .52388 L p F P
0 0 0 r
s
.895 .254 .108 r
.56822 .52388 m .55117 .52388 L .5586 .49743 L p F P
0 0 0 r
s
.895 .254 .108 r
.5586 .49743 m .57814 .49743 L .56822 .52388 L p F P
0 0 0 r
s
.895 .254 .108 r
.55117 .52388 m .53411 .52388 L .53907 .49743 L p F P
0 0 0 r
s
.895 .254 .108 r
.53907 .49743 m .5586 .49743 L .55117 .52388 L p F P
0 0 0 r
s
.895 .254 .108 r
.53411 .52388 m .51706 .52388 L .51953 .49743 L p F P
0 0 0 r
s
.895 .254 .108 r
.51953 .49743 m .53907 .49743 L .53411 .52388 L p F P
0 0 0 r
s
.895 .254 .108 r
.51706 .52388 m .5 .52388 L .5 .49743 L p F P
0 0 0 r
s
.895 .254 .108 r
.5 .49743 m .51953 .49743 L .51706 .52388 L p F P
0 0 0 r
s
.895 .254 .108 r
.5 .52388 m .48294 .52388 L .48047 .49743 L p F P
0 0 0 r
s
.895 .254 .108 r
.48047 .49743 m .5 .49743 L .5 .52388 L p F P
0 0 0 r
s
.895 .254 .108 r
.48294 .52388 m .46589 .52388 L .46093 .49743 L p F P
0 0 0 r
s
.895 .254 .108 r
.46093 .49743 m .48047 .49743 L .48294 .52388 L p F P
0 0 0 r
s
.895 .254 .108 r
.46589 .52388 m .44883 .52388 L .4414 .49743 L p F P
0 0 0 r
s
.895 .254 .108 r
.4414 .49743 m .46093 .49743 L .46589 .52388 L p F P
0 0 0 r
s
.895 .254 .108 r
.44883 .52388 m .43178 .52388 L .42186 .49743 L p F P
0 0 0 r
s
.895 .254 .108 r
.42186 .49743 m .4414 .49743 L .44883 .52388 L p F P
0 0 0 r
s
.895 .254 .108 r
.43178 .52388 m .41472 .52388 L .40233 .49743 L p F P
0 0 0 r
s
.895 .254 .108 r
.40233 .49743 m .42186 .49743 L .43178 .52388 L p F P
0 0 0 r
s
.895 .254 .108 r
.41472 .52388 m .39767 .52388 L .3828 .49743 L p F P
0 0 0 r
s
.24 .35 .67 r
.38818 .53021 m
.38827 .5311 L
s
.895 .254 .108 r
.3828 .49743 m .40233 .49743 L .41472 .52388 L p F P
0 0 0 r
s
.895 .254 .108 r
.39767 .52388 m .38061 .52388 L .36326 .49743 L p F P
0 0 0 r
s
.895 .254 .108 r
.36326 .49743 m .3828 .49743 L .39767 .52388 L p F P
0 0 0 r
s
.24 .35 .67 r
.38658 .5136 m
.38818 .53021 L
s
.51748 .16632 m
.55181 .17123 L
s
.48252 .16632 m
.51748 .16632 L
s
.44819 .17123 m
.48252 .16632 L
s
.33619 .3286 m
.33214 .29495 L
s
.33619 .3286 m
.3303 .35454 L
s
.6697 .35454 m
.66381 .3286 L
s
.66381 .3286 m
.66786 .29495 L
s
.65478 .27061 m
.6355 .24898 L
s
.6355 .24898 m
.63884 .21336 L
s
.3645 .24898 m
.36116 .21336 L
s
.3645 .24898 m
.34522 .27061 L
s
.4482 .57007 m
.44692 .54236 L
s
.4482 .57007 m
.48243 .57611 L
s
.51757 .57611 m
.5518 .57007 L
s
.5518 .57007 m
.55308 .54236 L
s
.55181 .17123 m
.58429 .18091 L
s
.41571 .18091 m
.44819 .17123 L
s
.61342 .5136 m
.63578 .49261 L
s
.63578 .49261 m
.63914 .46294 L
s
.36422 .49261 m
.36086 .46294 L
s
.36422 .49261 m
.38658 .5136 L
s
.65529 .43875 m
.66417 .41283 L
s
.66417 .41283 m
.66824 .38118 L
s
.33583 .41283 m
.33176 .38118 L
s
.33583 .41283 m
.34471 .43875 L
s
.48243 .57611 m
.48199 .54847 L
s
.48243 .57611 m
.51757 .57611 L
s
.51757 .57611 m
.51801 .54847 L
s
.58429 .18091 m
.61369 .1951 L
s
.38631 .1951 m
.41571 .18091 L
s
.66786 .29495 m
.65478 .27061 L
s
.65478 .27061 m
.65864 .2351 L
s
.34522 .27061 m
.34136 .2351 L
s
.34522 .27061 m
.33214 .29495 L
s
.38658 .5136 m
.38375 .48416 L
s
.38658 .5136 m
.41458 .5305 L
s
.58542 .5305 m
.61342 .5136 L
s
.61342 .5136 m
.61625 .48416 L
s
.67395 .32108 m
.6697 .35454 L
s
.66824 .38118 m
.6697 .35454 L
s
.3303 .35454 m
.32605 .32108 L
s
.3303 .35454 m
.33176 .38118 L
s
.61369 .1951 m
.63884 .21336 L
s
.36116 .21336 m
.38631 .1951 L
s
.63914 .46294 m
.65529 .43875 L
s
.65529 .43875 m
.65918 .40734 L
s
.34471 .43875 m
.34082 .40734 L
s
.34471 .43875 m
.36086 .46294 L
s
.41458 .5305 m
.41242 .50124 L
s
.41458 .5305 m
.44692 .54236 L
s
.55308 .54236 m
.58542 .5305 L
s
.58542 .5305 m
.58758 .50124 L
s
.33214 .29495 m
.32789 .25959 L
s
.33214 .29495 m
.32605 .32108 L
s
.67395 .32108 m
.66786 .29495 L
s
.66786 .29495 m
.67211 .25959 L
s
.63884 .21336 m
.65864 .2351 L
s
.34136 .2351 m
.36116 .21336 L
s
.44692 .54236 m
.44557 .51323 L
s
.44692 .54236 m
.48199 .54847 L
s
.51801 .54847 m
.55308 .54236 L
s
.55308 .54236 m
.55443 .51323 L
s
.36086 .46294 m
.35733 .43177 L
s
.36086 .46294 m
.38375 .48416 L
s
.61625 .48416 m
.63914 .46294 L
s
.63914 .46294 m
.64267 .43177 L
s
.65918 .40734 m
.66824 .38118 L
s
.66824 .38118 m
.67251 .34793 L
s
.33176 .38118 m
.32749 .34793 L
s
.33176 .38118 m
.34082 .40734 L
s
.48199 .54847 m
.48153 .51941 L
s
.48199 .54847 m
.51801 .54847 L
s
.51801 .54847 m
.51847 .51941 L
s
.32789 .25959 m
.34136 .2351 L
s
.65864 .2351 m
.67211 .25959 L
s
.38375 .48416 m
.38077 .4532 L
s
.38375 .48416 m
.41242 .50124 L
s
.58758 .50124 m
.61625 .48416 L
s
.61625 .48416 m
.61923 .4532 L
s
.67842 .2859 m
.67395 .32108 L
s
.67251 .34793 m
.67395 .32108 L
s
.32605 .32108 m
.32158 .2859 L
s
.32605 .32108 m
.32749 .34793 L
s
.64267 .43177 m
.65918 .40734 L
s
.65918 .40734 m
.66328 .37432 L
s
.34082 .40734 m
.33672 .37432 L
s
.34082 .40734 m
.35733 .43177 L
s
.41242 .50124 m
.41016 .47047 L
s
.41242 .50124 m
.44557 .51323 L
s
.55443 .51323 m
.58758 .50124 L
s
.58758 .50124 m
.58984 .47047 L
s
.32158 .2859 m
.32789 .25959 L
s
.67211 .25959 m
.67842 .2859 L
s
.44557 .51323 m
.44415 .4826 L
s
.44557 .51323 m
.48153 .51941 L
s
.51847 .51941 m
.55443 .51323 L
s
.55443 .51323 m
.55585 .4826 L
s
.35733 .43177 m
.35361 .39897 L
s
.35733 .43177 m
.38077 .4532 L
s
.61923 .4532 m
.64267 .43177 L
s
.64267 .43177 m
.64639 .39897 L
s
.66328 .37432 m
.67251 .34793 L
s
.67251 .34793 m
.677 .31295 L
s
.32749 .34793 m
.323 .31295 L
s
.32749 .34793 m
.33672 .37432 L
s
.48153 .51941 m
.48105 .48885 L
s
.48153 .51941 m
.51847 .51941 L
s
.51847 .51941 m
.51895 .48885 L
s
.38077 .4532 m
.37763 .42062 L
s
.38077 .4532 m
.41016 .47047 L
s
.58984 .47047 m
.61923 .4532 L
s
.61923 .4532 m
.62237 .42062 L
s
.67842 .2859 m
.677 .31295 L
s
.323 .31295 m
.32158 .2859 L
s
.64639 .39897 m
.66328 .37432 L
s
.66328 .37432 m
.66759 .33955 L
s
.33672 .37432 m
.33241 .33955 L
s
.33672 .37432 m
.35361 .39897 L
s
.41016 .47047 m
.40777 .43807 L
s
.41016 .47047 m
.44415 .4826 L
s
.55585 .4826 m
.58984 .47047 L
s
.58984 .47047 m
.59223 .43807 L
s
.44415 .4826 m
.44266 .45032 L
s
.44415 .4826 m
.48105 .48885 L
s
.51895 .48885 m
.55585 .4826 L
s
.55585 .4826 m
.55734 .45032 L
s
.62237 .42062 m
.64639 .39897 L
s
.64639 .39897 m
.6503 .36442 L
s
.35361 .39897 m
.3497 .36442 L
s
.35361 .39897 m
.37763 .42062 L
s
.33241 .33955 m
.323 .31295 L
s
.677 .31295 m
.66759 .33955 L
s
.48105 .48885 m
.48055 .45664 L
s
.48105 .48885 m
.51895 .48885 L
s
.51895 .48885 m
.51945 .45664 L
s
.37763 .42062 m
.37432 .38627 L
s
.37763 .42062 m
.40777 .43807 L
s
.59223 .43807 m
.62237 .42062 L
s
.62237 .42062 m
.62568 .38627 L
s
.3497 .36442 m
.33241 .33955 L
s
.66759 .33955 m
.6503 .36442 L
s
.40777 .43807 m
.40526 .4039 L
s
.40777 .43807 m
.44266 .45032 L
s
.55734 .45032 m
.59223 .43807 L
s
.59223 .43807 m
.59474 .4039 L
s
.44266 .45032 m
.44109 .41628 L
s
.44266 .45032 m
.48055 .45664 L
s
.51945 .45664 m
.55734 .45032 L
s
.55734 .45032 m
.55891 .41628 L
s
.37432 .38627 m
.3497 .36442 L
s
.6503 .36442 m
.62568 .38627 L
s
.48055 .45664 m
.48001 .42267 L
s
.48055 .45664 m
.51945 .45664 L
s
.51945 .45664 m
.51999 .42267 L
s
.40526 .4039 m
.37432 .38627 L
s
.62568 .38627 m
.59474 .4039 L
s
.44109 .41628 m
.40526 .4039 L
s
.59474 .4039 m
.55891 .41628 L
s
.48001 .42267 m
.44109 .41628 L
s
.55891 .41628 m
.51999 .42267 L
s
.51999 .42267 m
.48001 .42267 L
s
0 0 0 r
.25 Mabswid
.14736 .14594 m
.85264 .14594 L
s
.85264 .14594 m
.90748 .42015 L
s
.90748 .42015 m
.09252 .42015 L
s
.09252 .42015 m
.14736 .14594 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{500, 500},
  ImageMargins->{{0, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40007d0001m2000`400?l00000o`00003oo`3ooooe
0?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3o
m^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40
oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?of
k_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3o
ool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^
m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?oo
o`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd
0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo
003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0
ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool0
0?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03o
m^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00
o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?of
kP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o
0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^
0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0
ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h1
0?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3o
m^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40
oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?of
k_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00B@3om^ko000006800000B@3om^h10?ooo`00B@3o
m^h00`000000ooK^0?ofkP3o0?ofkUh0ooK^00<000000?ofkP3om^h0A`3om^h10?ooo`00B@3om^h0
0`000000ooK^0?ofkP3o0?ofkUh0ooK^00<000000?ofkP3om^h0A`3om^h10?ooo`00B03om^h00`00
0000ooK^0000003o0?ofkUh0ooK^00<000000?ofkP000000B03om^h10?ooo`00B03om^h00`000000
ooK^0000003o0?ofkUh0ooK^00<000000?ofkP000000B03om^h10?ooo`00B03om^h00`000000ooK^
0000003o0?ofkUh0ooK^00<000000?ofkP000000B03om^h10?ooo`00B03om^h00`000000ooK^0000
003o0?ofkUh0ooK^00<000000?ofkP000000B03om^h10?ooo`00B03om^h010000000ooK^0?ofkP00
003o0?ofkU`0ooK^00@000000?ofkP3om^h00000B03om^h10?ooo`00A`3om^h01@000000ooK^0?of
kP3om^h000000?l0ooK^G03om^h01@000000ooK^0?ofkP3om^h0000004L0ooK^0@3oool004L0ooK^
00D000000?ofkP3om^h0ooK^0000003o0?ofkU`0ooK^00D000000?ofkP3om^h0ooK^000000170?of
kP40oooo00170?ofkP050000003om^h0ooK^0?ofkP000000XP3om^hG03eIZj80ooK^00D000000?of
kP3om^h0ooK^000000170?ofkP40oooo00170?ofkP030000003om^h0ooK^0080ooK^00<000000?of
kP3om^h0V@3om^h603eIZ`80ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP0603eI
Zi/0ooK^00<000000?ofkP3om^h00P3om^h00`000000ooK^0?ofkP150?ofkP40oooo00170?ofkP03
0000003om^h0ooK^0080ooK^00<000000?ofkP3om^h0T`3om^h603eIZ`P0ooK^00<0?EV[0?ofkP3o
m^h03`3om^h00`0mFJ/0ooK^0?ofkP060?ofkPH0?EV[U@3om^h00`000000ooK^0?ofkP020?ofkP03
0000003om^h0ooK^04D0ooK^0@3oool004H0ooK^00<000000?ofkP3om^h00`3om^h00`000000ooK^
0?ofkP2?0?ofkP@0?EV[3P3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00`0ooK^
100mFJ^A0?ofkP030000003om^h0ooK^00<0ooK^00<000000?ofkP3om^h0A03om^h10?ooo`00AP3o
m^h00`000000ooK^0?ofkP030?ofkP030000003om^h0ooK^08`0ooK^0`0mFJ/00`3om^h0?EV[0?of
kP0?0?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^03eI
Z`0203eIZhh0ooK^00<000000?ofkP3om^h00`3om^h00`000000ooK^0?ofkP140?ofkP40oooo0016
0?ofkP030000003om^h0ooK^00<0ooK^00<000000?ofkP3om^h0R@3om^h303eIZ`@0ooK^00<0?EV[
0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[
0?ofkP3om^h00P3om^h303eIZh/0ooK^00<000000?ofkP3om^h00`3om^h00`000000ooK^0?ofkP14
0?ofkP40oooo00160?ofkP030000003om^h0ooK^00@0ooK^00<000000?ofkP3om^h0Q03om^h403eI
Z`L0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^
00h0ooK^00<0?EV[0?ofkP3om^h01@3om^h403eIZhH0ooK^00<000000?ofkP3om^h0103om^h00`00
0000ooK^0?ofkP140?ofkP40oooo00160?ofkP030000003om^h0ooK^00@0ooK^00<000000?ofkP3o
m^h0P@3om^h303eIZ`/0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP03
03eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h02@3om^h303eIZh<0ooK^00<000000?ofkP3o
m^h0103om^h00`000000ooK^0?ofkP140?ofkP40oooo00150?ofkP030000003om^h0ooK^00D0ooK^
00<000000?ofkP3om^h0OP3om^h303eIZ`h0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^
0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h0303om^h303eIZh00ooK^
00<000000?ofkP3om^h01@3om^h00`000000ooK^0?ofkP130?ofkP40oooo00150?ofkP030000003o
m^h0ooK^00D0ooK^00<000000?ofkP3om^h0O03om^h203eIZ`030?ofkP0mFJ/0ooK^00h0ooK^00<0
?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0
?EV[0?ofkP3om^h03@3om^h0100mFJ/0ooK^03eIZ`0mFJ]n0?ofkP030000003om^h0ooK^00D0ooK^
00<000000?ofkP3om^h0@`3om^h10?ooo`00A@3om^h00`000000ooK^0?ofkP060?ofkP030000003o
m^h0ooK^07T0ooK^0P0mFJ/30?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h03P3o
m^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h03@3o
m^h0100mFJ/0ooK^0?ofkP3om^h203eIZg/0ooK^00<000000?ofkP3om^h01P3om^h00`000000ooK^
0?ofkP130?ofkP40oooo00150?ofkP030000003om^h0ooK^00H0ooK^00<000000?ofkP3om^h0M`3o
m^h203eIZ`D0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3o
m^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3o
m^h0ooK^00<0ooK^0P0mFJ]i0?ofkP030000003om^h0ooK^00H0ooK^00<000000?ofkP3om^h0@`3o
m^h10?ooo`00A@3om^h00`000000ooK^0?ofkP060?ofkP030000003om^h0ooK^07D0ooK^0P0mFJ/7
0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0?
0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP05
0?ofkP80?EV[M`3om^h00`000000ooK^0?ofkP060?ofkP030000003om^h0ooK^04<0ooK^0@3oool0
04@0ooK^00<000000?ofkP3om^h01`3om^h00`000000ooK^0?ofkP1c0?ofkP80?EV[2@3om^h00`0m
FJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0m
FJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h01`3om^h203eI
ZgD0ooK^00<000000?ofkP3om^h01`3om^h00`000000ooK^0?ofkP120?ofkP40oooo00140?ofkP03
0000003om^h0ooK^00L0ooK^00<000000?ofkP3om^h0L@3om^h203eIZ`/0ooK^00<0?EV[0?ofkP3o
m^h03P3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3o
m^h03@3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00T0ooK^0P0mFJ]c0?ofkP03
0000003om^h0ooK^00L0ooK^00<000000?ofkP3om^h0@P3om^h10?ooo`00A03om^h00`000000ooK^
0?ofkP080?ofkP030000003om^h0ooK^06h0ooK^0P0mFJ/=0?ofkP0303eIZ`3om^h0ooK^00h0ooK^
00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00d0ooK^
00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP80?EV[L03om^h00`000000ooK^
0?ofkP080?ofkP030000003om^h0ooK^0480ooK^0@3oool004@0ooK^00<000000?ofkP3om^h0203o
m^h00`000000ooK^0?ofkP1]0?ofkP80?EV[3P3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3o
m^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3o
m^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h0303om^h203eIZfl0ooK^00<000000?ofkP3om^h0203o
m^h00`000000ooK^0?ofkP120?ofkP40oooo00140?ofkP030000003om^h0ooK^00P0ooK^00<00000
0?ofkP3om^h0J`3om^h203eIZ`030?ofkP0mFJ/0ooK^00d0ooK^00<0?EV[0?ofkP3om^h03P3om^h0
0`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h03@3om^h0
0`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00@0?EV[0?ofkP0mFJ/0?EV[K@3o
m^h00`000000ooK^0?ofkP080?ofkP030000003om^h0ooK^0480ooK^0@3oool004<0ooK^00<00000
0?ofkP3om^h02@3om^h00`000000ooK^0?ofkP1Z0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/03`3o
m^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00/0ooK^5`0mFJ/=0?ofkP0303eIZ`3o
m^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h03@3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[06`0ooK^
00<000000?ofkP3om^h02@3om^h00`000000ooK^0?ofkP110?ofkP40oooo00130?ofkP030000003o
m^h0ooK^00X0ooK^00<000000?ofkP3om^h0J03om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3o
m^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP060?ofkPD0?EV[0P3o
m^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00D0?EV[203om^h00`0mFJ/0ooK^0?of
kP0=0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?of
kP1X0?ofkP030000003om^h0ooK^00X0ooK^00<000000?ofkP3om^h0@@3om^h10?ooo`00@`3om^h0
0`000000ooK^0?ofkP0:0?ofkP030000003om^h0ooK^06H0ooK^0P0mFJ/60?ofkP0303eIZ`3om^h0
ooK^00`0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0603eIZ`L0ooK^00<0?EV[
0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP050?ofkPH0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP0=
0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h0103om^h203eIZfP0ooK^00<00000
0?ofkP3om^h02P3om^h00`000000ooK^0?ofkP110?ofkP40oooo00130?ofkP030000003om^h0ooK^
00X0ooK^00<000000?ofkP3om^h0I@3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^
00`0ooK^00<0?EV[0?ofkP3om^h0303om^h403eIZ`d0ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0m
FJ/0ooK^0?ofkP0;0?ofkP@0?EV[3P3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^
00H0ooK^00<0?EV[0?ofkP3om^h0I@3om^h00`000000ooK^0?ofkP0:0?ofkP030000003om^h0ooK^
0440ooK^0@3oool004<0ooK^00<000000?ofkP3om^h02P3om^h00`000000ooK^0?ofkP1T0?ofkP03
03eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP090?ofkP<0
?EV[00<0ooK^03eIZ`3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00d0
ooK^00<0?EV[0?ofkP0mFJ/00P0mFJ/;0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3o
m^h01`3om^h00`0mFJ/0ooK^0?ofkP1T0?ofkP030000003om^h0ooK^00X0ooK^00<000000?ofkP3o
m^h0@@3om^h10?ooo`00@P3om^h00`000000ooK^0?ofkP0<0?ofkP030000003om^h0ooK^0640ooK^
0P0mFJ/:0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h01P3om^h303eIZ`@0ooK^
00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00d0ooK^
00<0?EV[0?ofkP3om^h00P3om^h303eIZ`P0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^
0?ofkP080?ofkP80?EV[H`3om^h00`000000ooK^0?ofkP0<0?ofkP030000003om^h0ooK^0400ooK^
0@3oool00480ooK^00<000000?ofkP3om^h0303om^h00`000000ooK^0?ofkP1P0?ofkP0303eIZ`3o
m^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP020?ofkP@0?EV[1`3o
m^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h03@3o
m^h00`0mFJ/0ooK^0?ofkP050?ofkP@0?EV[103om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3o
m^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h0H03om^h00`000000ooK^0?ofkP0<0?ofkP030000003o
m^h0ooK^0400ooK^0@3oool00480ooK^00<000000?ofkP3om^h0303om^h00`000000ooK^0?ofkP1O
0?ofkP80?EV[303om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0?EV[0080?EV[2`3om^h0
0`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h03@3om^h0
0`0mFJ/0ooK^0?ofkP090?ofkP<0?EV[00<0ooK^03eIZ`3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0:
0?ofkP80?EV[H@3om^h00`000000ooK^0?ofkP0<0?ofkP030000003om^h0ooK^0400ooK^0@3oool0
0480ooK^00<000000?ofkP3om^h0303om^h00`000000ooK^0?ofkP1N0?ofkP0303eIZ`3om^h0?EV[
00`0ooK^00<0?EV[0?ofkP3om^h0303om^h203eIZ`h0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0m
FJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h0303om^h203eI
Z`h0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^03eIZ`1P0?ofkP030000003om^h0ooK^
00`0ooK^00<000000?ofkP3om^h0@03om^h10?ooo`00@P3om^h00`000000ooK^0?ofkP0<0?ofkP03
0000003om^h0ooK^05d0ooK^00@0?EV[0?ofkP3om^h0?EV[303om^h00`0mFJ/0ooK^0?ofkP0:0?of
kP<0?EV[3`3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?of
kP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP<0?EV[303om^h00`0mFJ/0ooK^0?ofkP0:0?of
kP0403eIZ`3om^h0ooK^03eIZel0ooK^00<000000?ofkP3om^h0303om^h00`000000ooK^0?ofkP10
0?ofkP40oooo00120?ofkP030000003om^h0ooK^00d0ooK^00<000000?ofkP3om^h0F`3om^h01@0m
FJ/0ooK^0?ofkP3om^h0?EV[00`0ooK^00<0?EV[0?ofkP3om^h0203om^h203eIZ`80ooK^00<0?EV[
0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[
0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^0080?EV[2P3om^h0
0`0mFJ/0ooK^0?ofkP0:0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/0G@3om^h00`000000ooK^0?of
kP0=0?ofkP030000003om^h0ooK^0400ooK^0@3oool00440ooK^00<000000?ofkP3om^h03P3om^h0
0`000000ooK^0?ofkP1J0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h02`3om^h0
0`0mFJ/0ooK^0?ofkP050?ofkP80?EV[103om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0
ooK^00h0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0
ooK^00d0ooK^00<0?EV[0?ofkP3om^h00P3om^h203eIZ`L0ooK^00<0?EV[0?ofkP3om^h02`3om^h0
0`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^05X0ooK^00<000000?ofkP3om^h03P3om^h0
0`000000ooK^0?ofkP0o0?ofkP40oooo00110?ofkP030000003om^h0ooK^00h0ooK^00<000000?of
kP3om^h0FP3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?of
kP3om^h00`3om^h203eIZ`H0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0>0?of
kP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0=0?of
kP0303eIZ`3om^h0ooK^00@0ooK^0P0mFJ/50?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?of
kP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP1J0?ofkP030000003om^h0ooK^00h0ooK^00<000000?of
kP3om^h0?`3om^h10?ooo`00@@3om^h00`000000ooK^0?ofkP0>0?ofkP030000003om^h0ooK^05T0
ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0403eIZ`3om^h0ooK^0?of
kP80?EV[203om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?of
kP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?of
kP3om^h01P3om^h203eIZ`<0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP030?of
kP0303eIZ`3om^h0ooK^05T0ooK^00<000000?ofkP3om^h03P3om^h00`000000ooK^0?ofkP0o0?of
kP40oooo00110?ofkP030000003om^h0ooK^00l0ooK^00<000000?ofkP3om^h0E`3om^h00`0mFJ/0
ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00/0ooK^00@0?EV[0?ofkP0mFJ/0?EV[2P3om^h00`0m
FJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0m
FJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h0203om^h203eI
Z`030?ofkP0mFJ/0ooK^00`0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP1G0?of
kP030000003om^h0ooK^00l0ooK^00<000000?ofkP3om^h0?`3om^h10?ooo`00@@3om^h00`000000
ooK^0?ofkP0?0?ofkP030000003om^h0ooK^05H0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0
ooK^0?ofkP0;0?ofkP80?EV[303om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00h0
ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00d0
ooK^00<0?EV[0?ofkP3om^h02P3om^h203eIZ``0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0
ooK^0?ofkP1F0?ofkP030000003om^h0ooK^00l0ooK^00<000000?ofkP3om^h0?`3om^h10?ooo`00
@03om^h00`000000ooK^0?ofkP0@0?ofkP030000003om^h0ooK^05D0ooK^00<0?EV[0?ofkP3om^h0
1`3om^h00`0mFJ/0ooK^0?ofkP080?ofkP<0?EV[3@3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eI
Z`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eI
Z`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h02`3om^h303eIZ`X0ooK^00<0?EV[0?ofkP3om^h0
1`3om^h00`0mFJ/0ooK^0?ofkP1E0?ofkP030000003om^h0ooK^0100ooK^00<000000?ofkP3om^h0
?P3om^h10?ooo`00@03om^h00`000000ooK^0?ofkP0@0?ofkP030000003om^h0ooK^05@0ooK^00<0
?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP070?ofkP0403eIZ`3om^h0ooK^03eIZ`h0ooK^
00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0<0?ofkQD0?EV[3P3om^h00`0mFJ/0ooK^
0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00@0?EV[0?ofkP3om^h0?EV[2@3om^h00`0mFJ/0
ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^05@0ooK^00<000000?ofkP3om^h0403om^h00`000000
ooK^0?ofkP0n0?ofkP40oooo00100?ofkP030000003om^h0ooK^0100ooK^00<000000?ofkP3om^h0
D`3om^h203eIZ`X0ooK^00<0?EV[0?ofkP3om^h01@3om^h203eIZ`<0ooK^00<0?EV[0?ofkP3om^h0
303om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00H0ooK^1P0mFJ/20?ofkP0303eI
Z`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h01P0mFJ/80?ofkP0303eIZ`3om^h0ooK^00`0ooK^
00<0?EV[0?ofkP3om^h0303om^h0100mFJ/0ooK^0?ofkP3om^h203eIZ`L0ooK^00<0?EV[0?ofkP3o
m^h0203om^h203eIZeD0ooK^00<000000?ofkP3om^h0403om^h00`000000ooK^0?ofkP0n0?ofkP40
oooo00100?ofkP030000003om^h0ooK^0140ooK^00<000000?ofkP3om^h0DP3om^h203eIZ`X0ooK^
00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00`0ooK^
00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0603eIZ`P0ooK^00<0?EV[0?ofkP3om^h0
3@3om^h00`0mFJ/0ooK^0?ofkP060?ofkPH0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eI
Z`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eI
Z`3om^h0ooK^00P0ooK^0P0mFJ]D0?ofkP030000003om^h0ooK^0140ooK^00<000000?ofkP3om^h0
?P3om^h10?ooo`00@03om^h00`000000ooK^0?ofkP0A0?ofkP030000003om^h0ooK^0540ooK^00<0
?EV[0?ofkP0mFJ/02P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0
?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP@0?EV[3P3om^h00`0mFJ/0ooK^0?of
kP0=0?ofkP0303eIZ`3om^h0ooK^00`0ooK^100mFJ/=0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0
?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0
?EV[0?ofkP0mFJ/0D`3om^h00`000000ooK^0?ofkP0A0?ofkP030000003om^h0ooK^03h0ooK^0@3o
ool003l0ooK^00<000000?ofkP3om^h04P3om^h00`000000ooK^0?ofkP1A0?ofkP0303eIZ`3om^h0
?EV[00X0ooK^00@0?EV[0?ofkP3om^h0ooK^0P0mFJ/70?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0
?EV[0?ofkP3om^h0203om^h303eIZ`030?ofkP0mFJ/0ooK^00l0ooK^00<0?EV[0?ofkP3om^h03@3o
m^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0?EV[0080?EV[2P3om^h00`0mFJ/0ooK^0?of
kP0<0?ofkP0303eIZ`3om^h0ooK^00D0ooK^0P0mFJ/30?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0
?EV[0?ofkP0mFJ/0D`3om^h00`000000ooK^0?ofkP0B0?ofkP030000003om^h0ooK^03d0ooK^0@3o
ool003l0ooK^00<000000?ofkP3om^h04P3om^h00`000000ooK^0?ofkP1@0?ofkP0503eIZ`3om^h0
ooK^0?ofkP0mFJ/02@3om^h0100mFJ/0ooK^0?ofkP0mFJ/90?ofkP0303eIZ`3om^h0ooK^00`0ooK^
00<0?EV[0?ofkP3om^h01@3om^h303eIZ`@0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^
0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h00P3om^h303eIZ`L0ooK^
00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP070?ofkP0403eIZ`3om^h0ooK^03eIZ`T0
ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`1B0?ofkP030000003om^h0ooK^0180ooK^00<000000?of
kP3om^h0?@3om^h10?ooo`00?`3om^h00`000000ooK^0?ofkP0C0?ofkP030000003om^h0ooK^04h0
ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP070?ofkP<0?EV[2P3om^h00`0mFJ/0
ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^0080ooK^0`0mFJ/70?ofkP0303eIZ`3om^h0ooK^00h0
ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00D0
ooK^0`0mFJ/40?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h0203om^h303eIZ`T0
ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`1A0?ofkP030000003om^h0ooK^01<0ooK^00<000000?of
kP3om^h0?@3om^h10?ooo`00?`3om^h00`000000ooK^0?ofkP0C0?ofkP030000003om^h0ooK^04h0
ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00/0
ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^03eIZ`0203eIZ`X0ooK^00<0?EV[0?ofkP3o
m^h03P3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3o
m^h0203om^h303eIZ`030?ofkP0mFJ/0ooK^00`0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0
ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h0CP3om^h00`000000
ooK^0?ofkP0C0?ofkP030000003om^h0ooK^03d0ooK^0@3oool003l0ooK^00<000000?ofkP3om^h0
4`3om^h00`000000ooK^0?ofkP1=0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h0
1P3om^h203eIZ`d0ooK^00<0?EV[0?ofkP3om^h02`3om^h203eIZ`d0ooK^00<0?EV[0?ofkP3om^h0
3P3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h0
2`3om^h203eIZ`d0ooK^00<0?EV[0?ofkP3om^h02`3om^h203eIZ`P0ooK^00<0?EV[0?ofkP3om^h0
0`3om^h00`0mFJ/0ooK^0?ofkP1=0?ofkP030000003om^h0ooK^01<0ooK^00<000000?ofkP3om^h0
?@3om^h10?ooo`00?P3om^h00`000000ooK^0?ofkP0D0?ofkP030000003om^h0ooK^04d0ooK^00<0
?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0?EV[00d0ooK^00<0
?EV[0?ofkP3om^h02@3om^h303eIZ`h0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?of
kP0=0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h0303om^h303eIZ`/0ooK^00<0
?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^03eIZ`070?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0
?EV[0?ofkP3om^h0C@3om^h00`000000ooK^0?ofkP0D0?ofkP030000003om^h0ooK^03`0ooK^0@3o
ool003h0ooK^00<000000?ofkP3om^h05@3om^h00`000000ooK^0?ofkP1;0?ofkP0303eIZ`3om^h0
ooK^00@0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^03eIZ`0=0?ofkP0303eIZ`3om^h0
ooK^00L0ooK^0P0mFJ/20?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h03P3om^h0
0`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h0303om^h0
0`0mFJ/0ooK^0?ofkP0203eIZ`T0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^03eIZ`07
0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h0B`3om^h00`000000ooK^0?ofkP0E
0?ofkP030000003om^h0ooK^03`0ooK^0@3oool003h0ooK^00<000000?ofkP3om^h05@3om^h00`00
0000ooK^0?ofkP1;0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h0103om^h0100m
FJ/0ooK^0?ofkP0mFJ/=0?ofkP0303eIZ`3om^h0ooK^00D0ooK^0P0mFJ/40?ofkP0303eIZ`3om^h0
ooK^00`0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0
ooK^00d0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP020?ofkP80?EV[1`3om^h0
0`0mFJ/0ooK^0?ofkP0;0?ofkP0403eIZ`3om^h0ooK^03eIZ`H0ooK^00<0?EV[0?ofkP3om^h0103o
m^h00`0mFJ/0ooK^0?ofkP1;0?ofkP030000003om^h0ooK^01D0ooK^00<000000?ofkP3om^h0?03o
m^h10?ooo`00?P3om^h00`000000ooK^0?ofkP0E0?ofkP030000003om^h0ooK^04X0ooK^00<0?EV[
0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[
0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP80?EV[1P3om^h00`0mFJ/0ooK^0?ofkP0=
0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0=
0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h0103om^h203eIZ`D0ooK^00<0?EV[
0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[
0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP1:0?ofkP030000003om^h0ooK^01D0ooK^00<00000
0?ofkP3om^h0?03om^h10?ooo`00?P3om^h00`000000ooK^0?ofkP0E0?ofkP030000003om^h0ooK^
04X0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^
00<0ooK^00<0?EV[0?ofkP3om^h02P3om^h0100mFJ/0ooK^0?ofkP3om^h203eIZ`P0ooK^00<0?EV[
0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[
0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00H0ooK^0P0mFJ/3
0?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP02
0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h0BP3om^h00`000000ooK^0?ofkP0E
0?ofkP030000003om^h0ooK^03`0ooK^0@3oool003d0ooK^00<000000?ofkP3om^h05P3om^h00`00
0000ooK^0?ofkP1:0?ofkP0303eIZ`3om^h0ooK^00H0ooK^00@0?EV[0?ofkP3om^h0?EV[1P3om^h0
0`0mFJ/0ooK^0?ofkP0:0?ofkP0403eIZ`3om^h0?EV[03eIZ`X0ooK^00<0?EV[0?ofkP3om^h03@3o
m^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h03@3o
m^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00P0ooK^0P0mFJ/00`3om^h0?EV[0?of
kP0;0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00@0?EV[0?ofkP3om^h0?EV[203om^h00`0mFJ/0ooK^
0?ofkP1:0?ofkP030000003om^h0ooK^01H0ooK^00<000000?ofkP3om^h0>`3om^h10?ooo`00?@3o
m^h00`000000ooK^0?ofkP0G0?ofkP030000003om^h0ooK^04P0ooK^0P0mFJ/80?ofkP0303eIZ`3o
m^h0?EV[00L0ooK^00<0?EV[0?ofkP3om^h02P3om^h203eIZ``0ooK^00<0?EV[0?ofkP3om^h03@3o
m^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h03@3o
m^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00X0ooK^0P0mFJ/<0?ofkP0303eIZ`3o
m^h0ooK^00D0ooK^00<0?EV[0?ofkP0mFJ/0203om^h203eIZdX0ooK^00<000000?ofkP3om^h05`3o
m^h00`000000ooK^0?ofkP0k0?ofkP40oooo000m0?ofkP030000003om^h0ooK^01L0ooK^00<00000
0?ofkP3om^h0B03om^h203eIZ`P0ooK^00<0?EV[0?ofkP0mFJ/01`3om^h00`0mFJ/0ooK^0?ofkP09
0?ofkP80?EV[3@3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[
0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[
0?ofkP3om^h0303om^h203eIZ`/0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^03eIZ`08
0?ofkP80?EV[BP3om^h00`000000ooK^0?ofkP0G0?ofkP030000003om^h0ooK^03/0ooK^0@3oool0
03d0ooK^00<000000?ofkP3om^h05`3om^h00`000000ooK^0?ofkP180?ofkP0303eIZ`3om^h0?EV[
00L0ooK^0P0mFJ/80?ofkP0303eIZ`3om^h0ooK^00L0ooK^0P0mFJ/00`3om^h0?EV[0?ofkP0=0?of
kP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h02P3om^hG03eIZ``0ooK^00<0?EV[0?of
kP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0403eIZ`3om^h0?EV[03eIZ`T0ooK^00<0?EV[
0?ofkP3om^h01P3om^h203eIZ`L0ooK^00<0?EV[0?ofkP0mFJ/0BP3om^h00`000000ooK^0?ofkP0G
0?ofkP030000003om^h0ooK^03/0ooK^0@3oool003d0ooK^00<000000?ofkP3om^h05`3om^h00`00
0000ooK^0?ofkP180?ofkP0303eIZ`3om^h0?EV[00L0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0m
FJ/0ooK^0?ofkP060?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/03P3om^h00`0mFJ/0ooK^0?ofkP0<
0?ofkP0303eIZ`3om^h0ooK^0080ooK^200mFJ/30?ofkP0303eIZ`3om^h0ooK^00d0ooK^00@0?EV[
0?ofkP3om^h0ooK^200mFJ/40?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h0303o
m^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00P0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^
0?ofkP050?ofkP0303eIZ`3om^h0?EV[04X0ooK^00<000000?ofkP3om^h05`3om^h00`000000ooK^
0?ofkP0k0?ofkP40oooo000l0?ofkP030000003om^h0ooK^01T0ooK^00<000000?ofkP3om^h0AP3o
m^h0100mFJ/0ooK^0?ofkP0mFJ/60?ofkP80?EV[2@3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eI
Z`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0;0?ofkPH0?EV[
2`3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00T0ooK^1P0mFJ/=0?ofkP0303eI
Z`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eI
Z`3om^h0ooK^00L0ooK^0P0mFJ/60?ofkP0403eIZ`3om^h0ooK^03eIZdP0ooK^00<000000?ofkP3o
m^h06@3om^h00`000000ooK^0?ofkP0j0?ofkP40oooo000l0?ofkP030000003om^h0ooK^01T0ooK^
00<000000?ofkP3om^h0AP3om^h0100mFJ/0ooK^0?ofkP0mFJ/60?ofkP80?EV[2P3om^h00`0mFJ/0
ooK^0?ofkP020?ofkP80?EV[1@3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00P0
ooK^0`0mFJ/00`3om^h0?EV[0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3o
m^h03@3om^h00`0mFJ/0ooK^03eIZ`0203eIZ`X0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0
ooK^0?ofkP030?ofkP80?EV[103om^h00`0mFJ/0ooK^0?ofkP080?ofkP80?EV[1P3om^h0100mFJ/0
ooK^0?ofkP0mFJ]80?ofkP030000003om^h0ooK^01T0ooK^00<000000?ofkP3om^h0>P3om^h10?oo
o`00?03om^h00`000000ooK^0?ofkP0I0?ofkP030000003om^h0ooK^04H0ooK^00@0?EV[0?ofkP3o
m^h0?EV[1@3om^h00`0mFJ/0ooK^03eIZ`0:0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/01`3om^h0
0`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00D0ooK^0`0mFJ/40?ofkP0303eIZ`3om^h0
ooK^00d0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0
ooK^0080ooK^0`0mFJ/70?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h01@3om^h0
1@0mFJ/0ooK^0?ofkP3om^h0?EV[00X0ooK^00<0?EV[0?ofkP0mFJ/01@3om^h0100mFJ/0ooK^0?of
kP0mFJ]80?ofkP030000003om^h0ooK^01T0ooK^00<000000?ofkP3om^h0>P3om^h10?ooo`00?03o
m^h00`000000ooK^0?ofkP0I0?ofkP030000003om^h0ooK^04H0ooK^00@0?EV[0?ofkP3om^h0?EV[
1@3om^h00`0mFJ/0ooK^03eIZ`0:0?ofkP0403eIZ`3om^h0ooK^03eIZ`P0ooK^00<0?EV[0?ofkP3o
m^h0303om^h00`0mFJ/0ooK^0?ofkP020?ofkP<0?EV[1`3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP03
03eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP050?ofkP<0
?EV[103om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00H0ooK^00@0?EV[0?ofkP3o
m^h0?EV[2@3om^h0100mFJ/0ooK^0?ofkP0mFJ/50?ofkP0403eIZ`3om^h0ooK^03eIZdP0ooK^00<0
00000?ofkP3om^h06@3om^h00`000000ooK^0?ofkP0j0?ofkP40oooo000l0?ofkP030000003om^h0
ooK^01T0ooK^00<000000?ofkP3om^h0A@3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00@0ooK^00D0
?EV[0?ofkP3om^h0ooK^03eIZ`090?ofkP<0?EV[2@3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eI
Z`3om^h0?EV[0080?EV[2P3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00d0ooK^
00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP080?ofkP<0?EV[00<0ooK^03eIZ`3om^h0
303om^h00`0mFJ/0ooK^0?ofkP080?ofkP<0?EV[2@3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00@0
ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`170?ofkP030000003om^h0ooK^01T0ooK^00<000000?of
kP3om^h0>P3om^h10?ooo`00>`3om^h00`000000ooK^0?ofkP0K0?ofkP030000003om^h0ooK^04@0
ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`030?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?of
kP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00/0ooK^0P0mFJ/=0?of
kP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0=0?of
kP0303eIZ`3om^h0ooK^00/0ooK^0P0mFJ/=0?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?of
kP3om^h01`3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00@0ooK^00D0?EV[0?ofkP3om^h0ooK^03eI
Z`160?ofkP030000003om^h0ooK^01/0ooK^00<000000?ofkP3om^h0>@3om^h10?ooo`00>`3om^h0
0`000000ooK^0?ofkP0K0?ofkP030000003om^h0ooK^04@0ooK^00D0?EV[0?ofkP3om^h0ooK^03eI
Z`030?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h01P3om^h203eIZ``0ooK^00<0
?EV[0?ofkP3om^h02@3om^h303eIZ`h0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?of
kP0=0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h0303om^h303eIZ`/0ooK^00<0
?EV[0?ofkP3om^h02P3om^h203eIZ`P0ooK^00<0?EV[0?ofkP3om^h00P3om^h01@0mFJ/0ooK^0?of
kP3om^h0?EV[00<0ooK^00<0?EV[0?ofkP3om^h0A03om^h00`000000ooK^0?ofkP0K0?ofkP030000
003om^h0ooK^03T0ooK^0@3oool003/0ooK^00<000000?ofkP3om^h06`3om^h00`000000ooK^0?of
kP140?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP0mFJ/01@3om^h00`0mFJ/0ooK^0?of
kP050?ofkP0303eIZ`3om^h0?EV[00`0ooK^00<0?EV[0?ofkP3om^h01`3om^h203eIZ`80ooK^00<0
?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0
?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^0080?EV[2@3o
m^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0?EV[00L0ooK^00<0?EV[0?ofkP3om^h00`3o
m^h00`0mFJ/0ooK^03eIZ`040?ofkP0303eIZ`3om^h0ooK^04@0ooK^00<000000?ofkP3om^h06`3o
m^h00`000000ooK^0?ofkP0i0?ofkP40oooo000k0?ofkP030000003om^h0ooK^01/0ooK^00<00000
0?ofkP3om^h0A03om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0?EV[00D0ooK^00<0?EV[
0?ofkP3om^h0103om^h0100mFJ/0ooK^0?ofkP0mFJ/<0?ofkP0303eIZ`3om^h0ooK^00D0ooK^0P0m
FJ/40?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?of
kP0=0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?of
kP020?ofkP80?EV[1`3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0403eIZ`3om^h0ooK^03eIZ`H0ooK^
00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^03eIZ`040?ofkP0303eIZ`3om^h0ooK^04@0ooK^
00<000000?ofkP3om^h06`3om^h00`000000ooK^0?ofkP0i0?ofkP40oooo000k0?ofkP030000003o
m^h0ooK^01`0ooK^00<000000?ofkP3om^h0@`3om^h00`0mFJ/0ooK^0?ofkP020?ofkP80?EV[1P3o
m^h00`0mFJ/0ooK^0?ofkP030?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/0303om^h00`0mFJ/0ooK^
0?ofkP030?ofkP80?EV[1P3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00d0ooK^
00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00`0ooK^
00<0?EV[0?ofkP3om^h0103om^h203eIZ`D0ooK^00<0?EV[0?ofkP3om^h02P3om^h01@0mFJ/0ooK^
0?ofkP3om^h0?EV[00D0ooK^00<0?EV[0?ofkP3om^h0103om^h203eIZ`@0ooK^00<0?EV[0?ofkP3o
m^h0@`3om^h00`000000ooK^0?ofkP0L0?ofkP030000003om^h0ooK^03T0ooK^0@3oool003X0ooK^
00<000000?ofkP3om^h07@3om^h00`000000ooK^0?ofkP130?ofkP0303eIZ`3om^h0ooK^0080ooK^
0P0mFJ/60?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^
0?ofkP090?ofkP0403eIZ`3om^h0ooK^0?ofkP80?EV[203om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP03
03eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP03
03eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h01P3om^h203eIZ`<0ooK^00<0?EV[0?ofkP3o
m^h02P3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00D0ooK^00<0?EV[0?ofkP3om^h0103om^h203eI
Z`@0ooK^00<0?EV[0?ofkP3om^h0@`3om^h00`000000ooK^0?ofkP0M0?ofkP030000003om^h0ooK^
03P0ooK^0@3oool003X0ooK^00<000000?ofkP3om^h07@3om^h00`000000ooK^0?ofkP130?ofkP80
?EV[0`3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3o
m^h00`3om^h00`0mFJ/0ooK^0?ofkP090?ofkP0403eIZ`3om^h0?EV[03eIZ`X0ooK^00<0?EV[0?of
kP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?of
kP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00P0ooK^0P0mFJ/00`3o
m^h0?EV[0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^0080ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`08
0?ofkP0403eIZ`3om^h0ooK^0?ofkP80?EV[A@3om^h00`000000ooK^0?ofkP0M0?ofkP030000003o
m^h0ooK^03P0ooK^0@3oool003X0ooK^00<000000?ofkP3om^h07@3om^h00`000000ooK^0?ofkP13
0?ofkP80?EV[0`3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0403eIZ`3om^h0ooK^03eIZ`H0ooK^00<0
?EV[0?ofkP3om^h02@3om^h203eIZ``0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?of
kP0=0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?of
kP0<0?ofkP0303eIZ`3om^h0ooK^00X0ooK^0P0mFJ/<0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00@0
?EV[0?ofkP3om^h0?EV[203om^h0100mFJ/0ooK^0?ofkP3om^h203eIZdD0ooK^00<000000?ofkP3o
m^h07@3om^h00`000000ooK^0?ofkP0h0?ofkP40oooo000j0?ofkP030000003om^h0ooK^01h0ooK^
00<000000?ofkP3om^h0@P3om^h203eIZ`<0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^
03eIZ`070?ofkP0303eIZ`3om^h0ooK^00P0ooK^0P0mFJ/>0?ofkP0303eIZ`3om^h0ooK^00/0ooK^
00<0?EV[0?ofkP3om^h02`3om^hE03eIZ`d0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^
0?ofkP0<0?ofkP80?EV[2P3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0?EV[00P0ooK^
00D0?EV[0?ofkP3om^h0ooK^03eIZ`150?ofkP030000003om^h0ooK^01h0ooK^00<000000?ofkP3o
m^h0>03om^h10?ooo`00>P3om^h00`000000ooK^0?ofkP0N0?ofkP030000003om^h0ooK^04<0ooK^
00<0?EV[0?ofkP3om^h00P0mFJ/80?ofkP80?EV[203om^h00`0mFJ/0ooK^0?ofkP060?ofkP80?EV[
00<0ooK^03eIZ`3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00H0ooK^
1@0mFJ/20?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h01@0mFJ/80?ofkP0303eI
Z`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h0303om^h0100mFJ/0ooK^03eIZ`0mFJ/80?ofkP03
03eIZ`3om^h0ooK^00H0ooK^0P0mFJ/80?ofkP80?EV[0P3om^h00`0mFJ/0ooK^0?ofkP130?ofkP03
0000003om^h0ooK^01h0ooK^00<000000?ofkP3om^h0>03om^h10?ooo`00>@3om^h00`000000ooK^
0?ofkP0O0?ofkP030000003om^h0ooK^04<0ooK^00<0?EV[0?ofkP3om^h00P0mFJ/80?ofkP0303eI
Z`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h01@3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00h0
ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP0603eIZ`L0ooK^00<0?EV[0?ofkP3o
m^h03@3om^h00`0mFJ/0ooK^0?ofkP050?ofkPH0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP03
03eIZ`3om^h0ooK^00`0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`070?ofkP0303eIZ`3om^h0ooK^
00L0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^03eIZ`020?ofkP0303eIZ`3om^h0ooK^
04<0ooK^00<000000?ofkP3om^h07`3om^h00`000000ooK^0?ofkP0g0?ofkP40oooo000i0?ofkP03
0000003om^h0ooK^01l0ooK^00<000000?ofkP3om^h0@`3om^h01P0mFJ/0ooK^0?ofkP0mFJ/0ooK^
03eIZ`H0ooK^0P0mFJ/90?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h00P3om^h0
0`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00X0ooK^100mFJ/=0?ofkP0303eIZ`3om^h0
ooK^00d0ooK^00<0?EV[0?ofkP3om^h02`3om^h403eIZ``0ooK^00<0?EV[0?ofkP3om^h0303om^h0
0`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h01`3om^h2
03eIZ`H0ooK^00<0?EV[0?ofkP0mFJ/00P3om^h00`0mFJ/0ooK^0?ofkP130?ofkP030000003om^h0
ooK^01l0ooK^00<000000?ofkP3om^h0=`3om^h10?ooo`00>@3om^h00`000000ooK^0?ofkP0O0?of
kP030000003om^h0ooK^04<0ooK^00H0?EV[0?ofkP3om^h0?EV[0?ofkP0mFJ/60?ofkP80?EV[2@3o
m^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h0303o
m^h00`0mFJ/0ooK^0?ofkP060?ofkP@0?EV[00<0ooK^03eIZ`3om^h03P3om^h00`0mFJ/0ooK^0?of
kP0=0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP0mFJ/00`0mFJ/80?ofkP0303eIZ`3o
m^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h00`3om^h203eIZ`@0ooK^00<0?EV[0?ofkP3om^h01`3o
m^h203eIZ`H0ooK^00<0?EV[0?ofkP0mFJ/00P3om^h00`0mFJ/0ooK^0?ofkP130?ofkP030000003o
m^h0ooK^01l0ooK^00<000000?ofkP3om^h0=`3om^h10?ooo`00>@3om^h00`000000ooK^0?ofkP0P
0?ofkP030000003om^h0ooK^0480ooK^00<0?EV[0?ofkP0mFJ/00P3om^h00`0mFJ/0ooK^0?ofkP03
0?ofkP0303eIZ`3om^h0?EV[00X0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`060?ofkP0303eIZ`3o
m^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h00`3om^h303eIZ`D0ooK^00<0?EV[0?ofkP3om^h03@3o
m^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h00`3o
m^h303eIZ`D0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP050?ofkP0503eIZ`3o
m^h0ooK^0?ofkP0mFJ/02@3om^h00`0mFJ/0ooK^03eIZ`050?ofkP0603eIZ`3om^h0ooK^03eIZ`3o
m^h0?EV[A03om^h00`000000ooK^0?ofkP0P0?ofkP030000003om^h0ooK^03L0ooK^0@3oool003T0
ooK^00<000000?ofkP3om^h0803om^h00`000000ooK^0?ofkP120?ofkP0303eIZ`3om^h0?EV[0080
ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^03eIZ`0:0?ofkP0403eIZ`3om^h0?EV[03eI
Z`L0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^03eIZ`0303eIZ`P0ooK^00<0?EV[0?of
kP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?of
kP3om^h01P3om^h403eIZ`030?ofkP0mFJ/0ooK^00d0ooK^00<0?EV[0?ofkP3om^h01P3om^h0100m
FJ/0ooK^0?ofkP0mFJ/90?ofkP0303eIZ`3om^h0?EV[00D0ooK^00H0?EV[0?ofkP3om^h0?EV[0?of
kP0mFJ]40?ofkP030000003om^h0ooK^0200ooK^00<000000?ofkP3om^h0=`3om^h10?ooo`00>03o
m^h00`000000ooK^0?ofkP0Q0?ofkP030000003om^h0ooK^0480ooK^0`0mFJ/20?ofkP0303eIZ`3o
m^h0ooK^0080ooK^00@0?EV[0?ofkP3om^h0?EV[2P3om^h203eIZ`X0ooK^00<0?EV[0?ofkP3om^h0
2`3om^h203eIZ``0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eI
Z`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h02P3om^h203eIZ`d0ooK^00<0?EV[0?ofkP3om^h0
203om^h303eIZ`T0ooK^00@0?EV[0?ofkP3om^h0?EV[103om^h00`0mFJ/0ooK^0?ofkP0303eIZd@0
ooK^00<000000?ofkP3om^h08@3om^h00`000000ooK^0?ofkP0f0?ofkP40oooo000h0?ofkP030000
003om^h0ooK^0240ooK^00<000000?ofkP3om^h0@P3om^h303eIZ`80ooK^00D0?EV[0?ofkP3om^h0
ooK^03eIZ`030?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0
ooK^0?ofkP090?ofkP<0?EV[3@3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00d0
ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP<0?EV[2`3om^h00`0mFJ/0
ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00L0ooK^00@0?EV[0?ofkP3om^h0?EV[103om^h00`0m
FJ/0ooK^0?ofkP0303eIZd@0ooK^00<000000?ofkP3om^h08@3om^h00`000000ooK^0?ofkP0f0?of
kP40oooo000h0?ofkP030000003om^h0ooK^0280ooK^00<000000?ofkP3om^h0@@3om^h203eIZ`<0
ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`030?ofkP0303eIZ`3om^h0ooK^00L0ooK^0P0mFJ/;0?of
kP0303eIZ`3om^h0ooK^00L0ooK^0P0mFJ/20?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?of
kP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?of
kP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP0203eIZ`T0ooK^00<0?EV[0?ofkP3om^h02P3om^h203eI
Z`P0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`030?ofkP0403eIZ`3om^h0ooK^0?ofkP80?EV[@`3o
m^h00`000000ooK^0?ofkP0R0?ofkP030000003om^h0ooK^03H0ooK^0@3oool003P0ooK^00<00000
0?ofkP3om^h08P3om^h00`000000ooK^0?ofkP110?ofkP80?EV[0`3om^h0100mFJ/0ooK^0?ofkP0m
FJ/40?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP0mFJ/02`3om^h00`0mFJ/0ooK^0?of
kP050?ofkP80?EV[103om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0
?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0
?EV[0?ofkP3om^h00P3om^h203eIZ`L0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^03eI
Z`060?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP0mFJ/0103om^h203eIZd<0ooK^00<0
00000?ofkP3om^h08P3om^h00`000000ooK^0?ofkP0f0?ofkP40oooo000h0?ofkP030000003om^h0
ooK^0280ooK^00<000000?ofkP3om^h0@@3om^h203eIZ`@0ooK^00<0?EV[0?ofkP0mFJ/01@3om^h0
0`0mFJ/0ooK^0?ofkP040?ofkP0403eIZ`3om^h0ooK^03eIZ`/0ooK^00<0?EV[0?ofkP3om^h00`3o
m^h203eIZ`H0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3o
m^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3o
m^h0ooK^00@0ooK^0P0mFJ/50?ofkP0303eIZ`3om^h0ooK^00X0ooK^00@0?EV[0?ofkP3om^h0?EV[
1@3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0?EV[00@0ooK^0P0mFJ]30?ofkP030000
003om^h0ooK^0280ooK^00<000000?ofkP3om^h0=P3om^h10?ooo`00=`3om^h00`000000ooK^0?of
kP0S0?ofkP030000003om^h0ooK^0480ooK^0P0mFJ/30?ofkP80?EV[1P3om^h00`0mFJ/0ooK^0?of
kP030?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/02`3om^h0100mFJ/0ooK^0?ofkP3om^h203eIZ`P0
ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00d0
ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00H0
ooK^0P0mFJ/30?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0
ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00@0ooK^0P0mFJ/30?ofkP80?EV[A03om^h00`000000
ooK^0?ofkP0S0?ofkP030000003om^h0ooK^03D0ooK^0@3oool003L0ooK^00<000000?ofkP3om^h0
8`3om^h00`000000ooK^0?ofkP120?ofkP80?EV[0`3om^h203eIZ`H0ooK^00<0?EV[0?ofkP3om^h0
0P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00T0ooK^00@0?EV[0?ofkP0mFJ/0
?EV[2P3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3o
m^h03@3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3o
m^h0203om^h203eIZ`030?ofkP0mFJ/0ooK^00X0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0
ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00@0ooK^0P0mFJ/30?ofkP80?EV[A03om^h00`000000
ooK^0?ofkP0S0?ofkP030000003om^h0ooK^03D0ooK^0@3oool003L0ooK^00<000000?ofkP3om^h0
903om^h00`000000ooK^0?ofkP110?ofkP80?EV[0`3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0503eI
Z`3om^h0ooK^0?ofkP0mFJ/01@3om^h00`0mFJ/0ooK^0?ofkP090?ofkP80?EV[303om^h00`0mFJ/0
ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0
ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h02P3om^h203eIZ`/0
ooK^00<0?EV[0?ofkP3om^h00`3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00L0ooK^00@0?EV[0?of
kP3om^h0ooK^0P0mFJ]30?ofkP030000003om^h0ooK^02@0ooK^00<000000?ofkP3om^h0=@3om^h1
0?ooo`00=`3om^h00`000000ooK^0?ofkP0T0?ofkP030000003om^h0ooK^0440ooK^0P0mFJ/30?of
kP0303eIZ`3om^h0ooK^00D0ooK^00@0?EV[0?ofkP3om^h0?EV[1P3om^h00`0mFJ/0ooK^0?ofkP08
0?ofkP80?EV[3@3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00X0ooK^5@0mFJ/<
0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h02`3om^h203eIZ`X0ooK^00<0?EV[
0?ofkP3om^h0103om^h0100mFJ/0ooK^0?ofkP0mFJ/70?ofkP0403eIZ`3om^h0ooK^0?ofkP80?EV[
@`3om^h00`000000ooK^0?ofkP0T0?ofkP030000003om^h0ooK^03D0ooK^0@3oool003L0ooK^00<0
00000?ofkP3om^h0903om^h00`000000ooK^0?ofkP110?ofkP<0?EV[0P3om^h00`0mFJ/0ooK^0?of
kP050?ofkP0303eIZ`3om^h0?EV[00P0ooK^00<0?EV[0?ofkP3om^h01@3om^h203eIZ`030?ofkP0m
FJ/0ooK^00`0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP050?ofkPD0?EV[0P3o
m^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00D0?EV[1`3om^h00`0mFJ/0ooK^0?of
kP0<0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00@0?EV[0?ofkP0mFJ/0?EV[203om^h00`0mFJ/0ooK^
0?ofkP050?ofkP0303eIZ`3om^h0?EV[00L0ooK^00<0?EV[0?ofkP3om^h00`0mFJ]30?ofkP030000
003om^h0ooK^02@0ooK^00<000000?ofkP3om^h0=@3om^h10?ooo`00=P3om^h00`000000ooK^0?of
kP0U0?ofkP030000003om^h0ooK^0440ooK^0`0mFJ/00`3om^h0?EV[03eIZ`070?ofkP80?EV[2@3o
m^h00`0mFJ/0ooK^0?ofkP040?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/03@3om^h00`0mFJ/0ooK^
0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00D0?EV[1`3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eI
Z`3om^h0ooK^00D0ooK^1@0mFJ/20?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h0
2`3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00L0ooK^00<0?EV[0?ofkP3om^h01P3om^h203eIZ`L0
ooK^0P0mFJ/0103om^h0?EV[03eIZ`0mFJ]30?ofkP030000003om^h0ooK^02D0ooK^00<000000?of
kP3om^h0=03om^h10?ooo`00=P3om^h00`000000ooK^0?ofkP0V0?ofkP030000003om^h0ooK^0400
ooK^0`0mFJ/00`3om^h0?EV[03eIZ`070?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3o
m^h00`3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3o
m^h02`3om^h403eIZ``0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP@0
?EV[3@3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3o
m^h0103om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00@0ooK^00@0?EV[0?ofkP0m
FJ/0ooK^0`0mFJ]20?ofkP030000003om^h0ooK^02H0ooK^00<000000?ofkP3om^h0=03om^h10?oo
o`00=P3om^h00`000000ooK^0?ofkP0V0?ofkP030000003om^h0ooK^0400ooK^0P0mFJ/01@3om^h0
?EV[03eIZ`3om^h0?EV[00D0ooK^0P0mFJ/:0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?of
kP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00L0ooK^100mFJ/00`3o
m^h0?EV[0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0m
FJ/0ooK^03eIZ`0303eIZ`T0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP040?of
kP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP040?of
kP0503eIZ`3om^h0?EV[03eIZ`3om^h00P0mFJ]20?ofkP030000003om^h0ooK^02H0ooK^00<00000
0?ofkP3om^h0=03om^h10?ooo`00=P3om^h00`000000ooK^0?ofkP0V0?ofkP030000003om^h0ooK^
0440ooK^00H0?EV[0?ofkP0mFJ/0?EV[0?ofkP0mFJ/50?ofkP80?EV[2P3om^h01@0mFJ/0ooK^0?of
kP3om^h0?EV[00L0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP@0?EV[
1@3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h0
303om^h00`0mFJ/0ooK^0?ofkP030?ofkP@0?EV[1@3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eI
Z`3om^h0ooK^00D0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0:0?ofkP80?EV[1@3om^h01P0mFJ/0
ooK^03eIZ`0mFJ/0ooK^03eIZd<0ooK^00<000000?ofkP3om^h09P3om^h00`000000ooK^0?ofkP0d
0?ofkP40oooo000f0?ofkP030000003om^h0ooK^02H0ooK^00<000000?ofkP3om^h0@@3om^h01P0m
FJ/0ooK^03eIZ`0mFJ/0ooK^03eIZ`@0ooK^00<0?EV[0?ofkP0mFJ/02P3om^h0100mFJ/0ooK^03eI
Z`0mFJ/80?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP0mFJ/00`0mFJ/90?ofkP0303eI
Z`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eI
Z`3om^h0ooK^00L0ooK^100mFJ/00`3om^h0?EV[0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00H0ooK^
0P0mFJ/00`3om^h0?EV[0?ofkP080?ofkP0303eIZ`3om^h0?EV[00D0ooK^00H0?EV[0?ofkP0mFJ/0
?EV[0?ofkP0mFJ]30?ofkP030000003om^h0ooK^02H0ooK^00<000000?ofkP3om^h0=03om^h10?oo
o`00=@3om^h00`000000ooK^0?ofkP0X0?ofkP030000003om^h0ooK^0400ooK^00H0?EV[0?ofkP0m
FJ/0?EV[0?ofkP0mFJ/40?ofkP0403eIZ`3om^h0ooK^03eIZ`T0ooK^0P0mFJ/:0?ofkP0303eIZ`3o
m^h0ooK^00X0ooK^0P0mFJ/=0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h03@3o
m^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00/0ooK^0P0mFJ/<0?ofkP0303eIZ`3o
m^h0ooK^00P0ooK^0P0mFJ/90?ofkP0403eIZ`3om^h0ooK^03eIZ`@0ooK^0P0mFJ/0103om^h0?EV[
0?ofkP0mFJ]20?ofkP030000003om^h0ooK^02P0ooK^00<000000?ofkP3om^h0<`3om^h10?ooo`00
=@3om^h00`000000ooK^0?ofkP0X0?ofkP030000003om^h0ooK^0400ooK^00<0?EV[0?ofkP0mFJ/0
0`0mFJ/30?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/02@3om^h00`0mFJ/0ooK^0?ofkP040?ofkW40
00001P3om^h00`0mFJ/0ooK^0?ofkP070?ofkP0403eIZ`3om^h0ooK^03eIZ`@0ooK^1P0mFJ]20?of
kP030000003om^h0ooK^02P0ooK^00<000000?ofkP3om^h0<`3om^h10?ooo`00=@3om^h00`000000
ooK^0?ofkP0X0?ofkP030000003D?AT0e3dI0400e3dI100mFJ/00`3D?AT0?EV[0=@m6@020=@m6@05
03eIZ`3D?AT0e3dI0=@m6@0mFJ/0203D?AT203eIZ`80e3dI10000004030;10@000001@0`2`@30000
00H0<0/40P000007030;108000001P0`2`@00`000000<0/4030;1005030;10030000000`2`@0<0/4
00H0<0/400<00000030;100`2`@01@0`2`@00`000000<0/4030;1006030;10030000000`2`@0<0/4
00@0<0/40P000007030;108000001P0`2`@3000000D0<0/410000004030;10@000000P3D?AT203eI
Z`P0e3dI00D0?EV[0=@m6@3D?AT0e3dI03eIZ`030=@m6@0303eIZ`3D?AT0?EV[00<0?EV[@P3D?AT0
0`000000ooK^0?ofkP0X0?ofkP030000003om^h0ooK^03<0ooK^0@3oool003D0ooK^00<000000?of
kP3om^h09`3om^h20=@m6@030?ofkP3D?AT0e3dI0140ooK^0P3D?AT00`3om^h0e3dI0?ofkP0A0?of
kP030=@m6@3om^h0e3dI01<0ooK^00L0e3dI0?ofkP0mFJ/0?EV[0?ofkP0mFJ/0ooK^0080?EV[00<0
ooK^03eIZ`3om^h00`3om^h00`0mFJ/0ooK^0?ofkP040?ofkP040=@m6@0mFJ/0ooK^03eIZgd00000
0P0mFJ/00`3om^h0e3dI0?ofkP050?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/00P3om^h203eIZ`03
0?ofkP0mFJ/0ooK^0080?EV[00<0ooK^0=@m6@3om^h04P3om^h00`3D?AT0ooK^0=@m6@0B0?ofkP04
0=@m6@3om^h0e3dI0=@m6A40ooK^0P3D?AT00`3om^h0e3dI0=@m6@0Y0?ofkP030000003om^h0ooK^
03<0ooK^0@3oool003D0ooK^00<000000?ofkP3om^h09P3om^i50=@m6@80?EV[00<0e3dI03eIZ`3D
?AT00P0mFJ/00`3D?AT0?EV[0=@m6@030=@m6@0303eIZ`3D?AT0e3dI00D0e3dI00<0?EV[0000001:
40L01P1:40L2000000L0BQ070P00000804X@1`030000001:40L0BQ0700H0BQ0700<0000004X@1`1:
40L01P1:40L00`000000BQ0704X@1`0704X@1`030000001:40L0BQ0700H0BQ0700<0000004X@1`1:
40L01P1:40L00`000000BQ0704X@1`0604X@1`030000001:40L0BQ0700L0BQ0700<0000004X@1`1:
40L01P1:40L00`000000BQ0704X@1`0604X@1`8000001`1:40L2000000L0BQ0700<0000003eIZ`3D
?AT01P3D?AT00`0mFJ/0e3dI0=@m6@020=@m6@<0?EV[0P3D?AT0100mFJ/0e3dI03eIZ`0mFJ]50=@m
6BP0ooK^00<000000?ofkP3om^h0<`3om^h10?ooo`00=@3om^h00`000000ooK^0?ofkP0U0?ofkP05
0=@m6@3om^h0ooK^0?ofkP0000000`3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^
00<0ooK^00<0e3dI0?ofkP3om^h03P3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI0140ooK^00<0e3dI
0?ofkP3om^h00P0mFJ/0103om^h0?EV[0?ofkP3om^h203eIZ`D0ooK^00<0?EV[0?ofkP3om^h00`3o
m^h00`3D?AT0?EV[04X@1`0604X@1`800000201:40L00`000000BQ0704X@1`0604X@1`800000201:
40L00`000000BQ0704X@1`0704X@1`030000001:40L0BQ0700H0BQ0700<0000004X@1`1:40L01`1:
40L00`000000BQ0704X@1`0604X@1`030000001:40L0BQ0700L0BQ0700<0000004X@1`1:40L01P1:
40L00`000000BQ0704X@1`0704X@1`800000201:40L00`000000BQ0704X@1`0604X@1`8000001`1:
40L00`0mFJ/0e3dI0?ofkP030?ofkP0303eIZ`3om^h0ooK^00<0ooK^0`0mFJ/20?ofkP0403eIZ`3o
m^h0?EV[03eIZ`80ooK^00<0e3dI0?ofkP3om^h03`3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI0100
ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP050=@m6@3om^h0ooK^0?of
kP0000000`3om^h00`3D?AT0ooK^0?ofkP0U0?ofkP030000003om^h0ooK^03<0ooK^0@3oool003@0
ooK^00<000000?ofkP3om^h09P3om^h01@3D?AT0ooK^0?ofkP3om^h0000000<0ooK^00<0e3dI0?of
kP3om^h02`3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?of
kP3om^h00`3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00@0?EV[0P3om^h303eI
Z`D0ooK^00<0?EV[0?ofkP3om^h00P00000704X@1`800000201:40L2000000P0BQ0700<0000004X@
1`1:40L0201:40L00`000000BQ0704X@1`0604X@1`030000001:40L0BQ0700L0BQ0700<0000004X@
1`1:40L01`1:40L00`000000BQ0704X@1`0704X@1`030000001:40L0BQ0700H0BQ0700<0000004X@
1`1:40L01`1:40L00`000000BQ0704X@1`0804X@1`030000001:40L0BQ0700H0BQ070P00000804X@
1`8000001`1:40L200000080ooK^00<0?EV[0?ofkP3om^h00`3om^h303eIZ`80ooK^100mFJ/20?of
kP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP0<0?of
kP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h02`3om^h01@3D?AT0ooK^0?ofkP3om^h0
000000<0ooK^00<0e3dI0?ofkP3om^h09P3om^h00`000000ooK^0?ofkP0b0?ofkP40oooo000d0?of
kP030000003om^h0ooK^02D0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`000000ooK^0?ofkP020?of
kP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP0<0?of
kP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP020?of
kP80?EV[00@0ooK^03eIZ`3om^h0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`000000
000008d0000000<0?EV[0?ofkP3om^h00P3om^h01`0mFJ/0ooK^03eIZ`0mFJ/0ooK^03eIZ`3om^h0
0P0mFJ/40?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^
0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^
0?ofkP020?ofkP030000003om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h09@3om^h00`000000ooK^
0?ofkP0b0?ofkP40oooo000d0?ofkP030000003om^h0ooK^02D0ooK^00<0e3dI0?ofkP3om^h00P3o
m^h00`000000ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h01P3o
m^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h0303o
m^h00`3D?AT0ooK^0?ofkP020?ofkP80?EV[00@0ooK^03eIZ`3om^h0?EV[0P3om^h00`0mFJ/0ooK^
0?ofkP020?ofkP0303eIZ`1Y6@X0JAT:00L0JAT:00<0000006TI2P1Y6@X01`1Y6@X00`000000JAT:
06TI2P0706TI2P030000001Y6@X0JAT:00P0JAT:00<0000006TI2P1Y6@X0201Y6@X00`000000JAT:
06TI2P0706TI2P030000001Y6@X0JAT:00L0JAT:00<0000006TI2P1Y6@X01`1Y6@X00`000000JAT:
06TI2P0706TI2P030000001Y6@X0e3dI00P0JAT:00<0000006TI2P1Y6@X0201Y6@X00`000000JAT:
06TI2P0706TI2P030000001Y6@X0JAT:00L0JAT:00<0000006TI2P1Y6@X01`1Y6@X01@0mFJ/0ooK^
0?ofkP3om^h0?EV[00<0ooK^00@0?EV[0?ofkP0mFJ/0ooK^0P0mFJ/40?ofkP030=@m6@3om^h0ooK^
00`0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^
00H0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP020?ofkP030000003om^h0ooK^
0080ooK^00<0e3dI0?ofkP3om^h09@3om^h00`000000ooK^0?ofkP0b0?ofkP40oooo000d0?ofkP03
0000003om^h0ooK^02@0ooK^B@3D?AT01P0mFJ/0e3dI03eIZ`0mFJ/0e3dI03eIZ`<0e3dI00@0?EV[
0=@m6@3D?AT0e3dI2@1Y6@X00`000000JAT:06TI2P0706TI2P030000001Y6@X0JAT:00P0JAT:00<0
000006TI2P1Y6@X0201Y6@X00`000000JAT:06TI2P0706TI2P030000001Y6@X0JAT:00P0JAT:00<0
000006TI2P1Y6@X01`1Y6@X00`000000JAT:06TI2P0706TI2P030000001Y6@X0JAT:00P0JAT:00<0
000006TI2P1Y6@X01`1Y6@X00`000000JAT:06TI2P0806TI2P030000001Y6@X0JAT:00P0JAT:00<0
000006TI2P1Y6@X01`1Y6@X00`000000JAT:06TI2P0706TI2P<0e3dI00H0?EV[0=@m6@3D?AT0e3dI
03eIZ`3D?AT403eIZdT0e3dI9P3om^h00`000000ooK^0?ofkP0b0?ofkP40oooo000d0?ofkP030000
003om^h0ooK^02@0ooK^00<0e3dI0?ofkP3om^h0103om^h00`000000ooK^0?ofkP020?ofkP030=@m
6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m
6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP020?ofkP@0?EV[
00<0ooK^03eIZ`3om^h00`3om^h00`0mFJ/0000006TI2P0806TI2P030000001Y6@X0JAT:00P0JAT:
00<0000006TI2P1Y6@X01`1Y6@X00`000000JAT:06TI2P0806TI2P030000001Y6@X0JAT:00P0JAT:
00<0000006TI2P1Y6@X01`1Y6@X00`000000JAT:06TI2P0806TI2P030000001Y6@X0JAT:00P0JAT:
00<0000006TI2P1Y6@X01`1Y6@X00`000000JAT:06TI2P0806TI2P030000001Y6@X0JAT:00P0JAT:
00<0000006TI2P1Y6@X01`1Y6@X00`000000JAT:06TI2P0806TI2P030000001Y6@X0JAT:00L0JAT:
00<0000003eIZ`3om^h00`3om^h00`0mFJ/0ooK^03eIZ`0303eIZ`@0ooK^00<0e3dI0?ofkP3om^h0
303om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h0
1`3om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^0080ooK^00<000000?ofkP3om^h0
103om^h00`3D?AT0ooK^0?ofkP0T0?ofkP030000003om^h0ooK^0380ooK^0@3oool003<0ooK^00<0
00000?ofkP3om^h0903om^h00`3D?AT0ooK^0?ofkP050?ofkP030000003om^h0ooK^00<0ooK^00<0
e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0
e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00<0ooK^1P0m
FJ/30?ofkP030000000mFJ/0?EV[00P0JAT:00<0000006TI2P1Y6@X0201Y6@X00`000000JAT:06TI
2P0806TI2P030000001Y6@X0JAT:00P0JAT:00<0000006TI2P1Y6@X01`1Y6@X00`000000JAT:06TI
2P0806TI2P030000001Y6@X0JAT:00P0JAT:00<0000006TI2P1Y6@X0201Y6@X00`000000JAT:06TI
2P0806TI2P030000001Y6@X0JAT:00L0JAT:00<0000006TI2P1Y6@X0201Y6@X00`000000JAT:06TI
2P0806TI2P030000001Y6@X0JAT:00P0JAT:00<0000006TI2P1Y6@X01P1Y6@X203eIZ`040000003o
m^h0ooK^0?ofkPH0?EV[103om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00H0ooK^
00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00H0ooK^
00<0e3dI0?ofkP3om^h00`3om^h00`000000ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^02@0ooK^
00<000000?ofkP3om^h0<@3om^h10?ooo`00<`3om^h00`000000ooK^0?ofkP0T0?ofkP030=@m6@3o
m^h0ooK^00D0ooK^00<000000?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3o
m^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3o
m^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h00`3om^h203eIZ`040=@m6@0mFJ/0?EV[03eIZ`80ooK^
0P0000000`0mFJ/0000003eIZ`2A0000000303eIZ`000000?EV[008000000P3om^h303eIZ`030=@m
6@0mFJ/0?EV[00D0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m
6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m
6@3om^h0ooK^00<0ooK^00<000000?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP0T0?ofkP030000
003om^h0ooK^0340ooK^0@3oool003<0ooK^00<000000?ofkP3om^h08`3om^h00`3D?AT0ooK^0?of
kP070?ofkP030000003om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?of
kP0:0?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?of
kP0:0?ofkP030=@m6@3om^h0ooK^00<0ooK^0P0mFJ/01P3D?AT0?EV[03eIZ`3om^h0?EV[00000080
SR@?00@0?EV[08hT3`2>90l0?EV[1@2>90l00`000000SR@?08hT3`0808hT3`030000002>90l0SR@?
00P0SR@?00<0000008hT3`2>90l0202>90l00`000000SR@?08hT3`0808hT3`030000002>90l0SR@?
00P0SR@?00<0000008hT3`2>90l0202>90l00`000000SR@?08hT3`0808hT3`030000002>90l0SR@?
00P0SR@?00<0000008hT3`2>90l0202>90l00`000000SR@?08hT3`0808hT3`030000002>90l0SR@?
00P0SR@?00<0000008hT3`2>90l0202>90l00`000000SR@?0=@m6@0308hT3`0403eIZ`2>90l0SR@?
03eIZ`80SR@?00<0000003eIZ`3om^h00P0mFJ/00`3D?AT0?EV[03eIZ`050?ofkP030=@m6@3om^h0
ooK^00X0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0
ooK^00X0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP020?ofkP030000003om^h0
ooK^00H0ooK^00<0e3dI0?ofkP3om^h0903om^h00`000000ooK^0?ofkP0a0?ofkP40oooo000c0?of
kP030000003om^h0ooK^02<0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`000000ooK^0?ofkP020?of
kP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP070?of
kP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP030?of
kP80?EV[00H0e3dI0?ofkP0mFJ/0ooK^03eIZ`00000208hT3`0503eIZ`2>90l0SR@?08hT3`0mFJ/0
0`2>90l00`000000SR@?08hT3`0808hT3`030000002>90l0SR@?00P0SR@?00<0000008hT3`2>90l0
202>90l00`000000SR@?08hT3`0908hT3`030000002>90l0SR@?00P0SR@?00<0000008hT3`2>90l0
202>90l00`000000SR@?08hT3`0808hT3`030000002>90l0SR@?00P0SR@?00<0000008hT3`2>90l0
2@2>90l00`000000SR@?08hT3`0808hT3`030000002>90l0SR@?00P0SR@?00<0000008hT3`2>90l0
202>90l01@000000SR@?08hT3`2>90l0?EV[00<0SR@?00T0?EV[08hT3`2>90l0000003eIZ`3om^h0
?EV[0?ofkP3D?AT00P0mFJ/50?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h01`3o
m^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h01@3o
m^h00`3D?AT0ooK^0?ofkP020?ofkP030000003om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h08`3o
m^h00`000000ooK^0?ofkP0a0?ofkP40oooo000c0?ofkP030000003om^h0ooK^02<0ooK^00<0e3dI
0?ofkP3om^h01`3om^h00`000000ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI
0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI
0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP050?ofkP0603eIZ`3om^h0?EV[03eIZ`3om^h0?EV[
102>90l01@0mFJ/0SR@?08hT3`2>90l0?EV[0080SR@?00<0000008hT3`2>90l0202>90l00`000000
SR@?08hT3`0808hT3`030000002>90l0SR@?00P0SR@?00<0000008hT3`2>90l02@2>90l00`000000
SR@?08hT3`0808hT3`030000002>90l0SR@?00P0SR@?00<0000008hT3`2>90l0202>90l00`000000
SR@?08hT3`0808hT3`030000002>90l0SR@?00T0SR@?00<0000008hT3`2>90l0202>90l00`000000
SR@?08hT3`0808hT3`030000002>90l0SR@?00P0SR@?00@0000008hT3`2>90l0?EV[0`2>90l00`0m
FJ/0SR@?08hT3`0208hT3`0603eIZ`3om^h0?EV[03eIZ`3om^h0?EV[1P3om^h00`3D?AT0ooK^0?of
kP090?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?of
kP0;0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`000000ooK^0?of
kP070?ofkP030=@m6@3om^h0ooK^02<0ooK^00<000000?ofkP3om^h0<@3om^h10?ooo`00<P3om^h0
0`000000ooK^0?ofkP0S0?ofkP030=@m6@3om^h0ooK^00P0ooK^00<000000?ofkP3om^h00`3om^hl
0=@m6@0303eIZ`3D?AT0?EV[00<0?EV[102>90l00`0mFJ/0SR@?08hT3`0208hT3`80?EV[2P2>90l0
0`000000SR@?08hT3`0908hT3`030000002>90l0SR@?00P0SR@?00<0000008hT3`2>90l0202>90l0
0`000000SR@?08hT3`0808hT3`030000002>90l0SR@?00T0SR@?00<0000008hT3`2>90l02@2>90l0
0`000000SR@?08hT3`0808hT3`030000002>90l0SR@?00P0SR@?00<0000008hT3`2>90l0202>90l0
0`000000SR@?08hT3`0908hT3`030000002>90l0SR@?00P0SR@?0P0mFJ/408hT3`0303eIZ`2>90l0
SR@?0080SR@?100mFJ/00`3D?AT0?EV[0=@m6@0k0=@m6@D0ooK^00<000000?ofkP3om^h0203om^h0
0`3D?AT0ooK^0?ofkP0S0?ofkP030000003om^h0ooK^0300ooK^0@3oool00380ooK^00<000000?of
kP3om^h08`3om^i=0=@m6@0303eIZ`3D?AT0?EV[00<0?EV[102>90l00`0mFJ/0SR@?08hT3`0308hT
3`030000000mFJ/0SR@?00P0SR@?00<0000008hT3`2>90l02@2>90l00`000000SR@?08hT3`0808hT
3`030000002>90l0SR@?00P0SR@?00<0000008hT3`2>90l0202>90l00`000000SR@?08hT3`0908hT
3`030000002>90l0SR@?00T0SR@?00<0000008hT3`2>90l0202>90l00`000000SR@?08hT3`0808hT
3`030000002>90l0SR@?00P0SR@?00<0000008hT3`2>90l02@2>90l00`000000SR@?08hT3`0708hT
3`0303eIZ`000000SR@?00@0SR@?00<0?EV[08hT3`2>90l00P2>90l603eIZdd0e3dI9@3om^h00`00
0000ooK^0?ofkP0`0?ofkP40oooo000b0?ofkP030000003om^h0ooK^02<0ooK^00<0e3dI0?ofkP3o
m^h02@3om^h00`000000ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3o
m^h0303om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3o
m^h0203om^h00`3D?AT0ooK^0?ofkP050?ofkP@0?EV[00<0000003eIZ`2>90l00`2>90l00`0mFJ/0
SR@?08hT3`0208hT3`040000002>90l0SR@?03eIZ`L0SR@?00<0000008hT3`2>90l02@2>90l00`00
0000SR@?08hT3`0808hT3`030000002>90l0SR@?00T0SR@?00<0000008hT3`2>90l0202>90l00`00
0000SR@?08hT3`0908hT3`030000002>90l0SR@?00T0SR@?00<0000008hT3`2>90l0202>90l00`00
0000SR@?08hT3`0908hT3`030000002>90l0SR@?00P0SR@?00<0000008hT3`2>90l02@2>90l00`00
0000SR@?08hT3`0508hT3`0403eIZ`2>90l0SR@?000000@0SR@?00<0?EV[08hT3`2>90l00P2>90l0
0`0mFJ/0000003eIZ`0303eIZ`L0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP09
0?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP03
0?ofkP030=@m6@3om^h0ooK^0080ooK^00<000000?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP0S
0?ofkP030000003om^h0ooK^0300ooK^0@3oool00380ooK^00<000000?ofkP3om^h08`3om^h00`3D
?AT0ooK^0?ofkP090?ofkP030000003om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D
?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D
?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00D0ooK^0P0mFJ/0103D?AT0?EV[0000000mFJ/4
0000000303eIZ`000000000000H0000000<0?EV[000000000000O`0000000`0mFJ/0000000000006
0000000303eIZ`00000000000080000000@0?EV[0000000mFJ/0e3dI0P0mFJ/70?ofkP030=@m6@3o
m^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3o
m^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP030?ofkP030000003o
m^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h08`3om^h00`000000ooK^0?ofkP0`0?ofkP40oooo000b
0?ofkP030000003om^h0ooK^0280ooK^00<0e3dI0?ofkP3om^h02P3om^h00`000000ooK^0?ofkP03
0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT0403om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3o
m^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP050?ofkP80?EV[00D0
e3dI0000000mFJ/0Z2`B03eIZ`030:P/4P0303eIZ`2X;180Z2`B0080Z2`B00<000000:P/4P2X;180
0P2X;1800`0mFJ/0Z2`B0:P/4P030:P/4P030000002X;180Z2`B00T0Z2`B00<000000:P/4P2X;180
202X;1800`000000Z2`B0:P/4P090:P/4P030000002X;180Z2`B00P0Z2`B00<000000:P/4P2X;180
2@2X;1800`000000Z2`B0:P/4P090:P/4P030000002X;180Z2`B00P0Z2`B00<000000:P/4P2X;180
2@2X;1800`000000Z2`B0:P/4P080:P/4P030000002X;180Z2`B00T0Z2`B00<000000:P/4P2X;180
0`2X;1800`0mFJ/0Z2`B0:P/4P020:P/4P030000002X;180Z2`B0080Z2`B00T0?EV[0:P/4P2X;180
Z2`B03eIZ`2X;180?EV[0000003D?AT00P0mFJ/70?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI
0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI
0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP030?ofkP030000003om^h0ooK^00T0ooK^00<0e3dI
0?ofkP3om^h08`3om^h00`000000ooK^0?ofkP0`0?ofkP40oooo000a0?ofkP030000003om^h0ooK^
02<0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`000000ooK^0?ofkP030?ofkP050=@m6@3om^h0ooK^
0?ofkP3D?AT0403om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI
0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP050?ofkP80?EV[00<0e3dI0000000mFJ/00P2X;180
100mFJ/0Z2`B0:P/4P0mFJ/40:P/4P030000002X;180Z2`B00<0Z2`B00<0?EV[0:P/4P2X;1800P2X
;1800`000000Z2`B0:P/4P090:P/4P030000002X;180Z2`B00P0Z2`B00<000000:P/4P2X;1802@2X
;1800`000000Z2`B0:P/4P080:P/4P030000002X;180Z2`B00T0Z2`B00<000000:P/4P2X;1802@2X
;1800`000000Z2`B0:P/4P080:P/4P030000002X;180Z2`B00T0Z2`B00<000000:P/4P2X;180202X
;1800`000000Z2`B0:P/4P090:P/4P030000002X;180Z2`B0080Z2`B00<0?EV[0:P/4P2X;1800`2X
;1800`000000Z2`B0:P/4P020:P/4P0403eIZ`2X;180Z2`B03eIZ`80Z2`B00<0?EV[0000003om^h0
0P0mFJ/70?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^
0?ofkP030?ofkP030=@m6@3om^h0ooK^00h0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@050?ofkP03
0000003om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h08`3om^h00`000000ooK^0?ofkP0_0?ofkP40
oooo000a0?ofkP030000003om^h0ooK^02<0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`000000ooK^
0?ofkP020?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT0403om^h00`3D?AT0ooK^0?ofkP030?ofkP03
0=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP050?ofkP80
?EV[00<000000:P/4P0mFJ/00P2X;180100mFJ/0Z2`B0:P/4P0mFJ/30:P/4P030000002X;180Z2`B
00@0Z2`B0`0mFJ/20:P/4P030000002X;180Z2`B00T0Z2`B00<000000:P/4P2X;180202X;1800`00
0000Z2`B0:P/4P090:P/4P030000002X;180Z2`B00P0Z2`B00<000000:P/4P2X;1802@2X;1800`00
0000Z2`B0:P/4P090:P/4P030000002X;180Z2`B00P0Z2`B00<000000:P/4P2X;1802@2X;1800`00
0000Z2`B0:P/4P080:P/4P030000002X;180Z2`B00T0Z2`B00<000000:P/4P2X;1800`0mFJ/60:P/
4P050000002X;180Z2`B0:P/4P0mFJ/00P2X;1801P0mFJ/0Z2`B0:P/4P0mFJ/0Z2`B00000080?EV[
1`3om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h0
0`3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT0103om^h00`000000
ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^02<0ooK^00<000000?ofkP3om^h0;`3om^h10?ooo`00
<@3om^h00`000000ooK^0?ofkP0S0?ofkP030=@m6@3om^h0ooK^00/0ooK^00<000000?ofkP3om^h0
0P3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI0100ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0
ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h01P3om^h303eIZ`03
0:P/4P0mFJ/0Z2`B0080Z2`B00<0?EV[0:P/4P0mFJ/00`2X;1800`000000Z2`B0:P/4P040:P/4P03
03eIZ`2X;180Z2`B0080?EV[00<000000:P/4P2X;1802@2X;1800`000000Z2`B0:P/4P080:P/4P03
0000002X;180Z2`B00T0Z2`B00<000000:P/4P2X;180202X;1800`000000Z2`B0:P/4P090:P/4P03
0000002X;180Z2`B00T0Z2`B00<000000:P/4P2X;180202X;1800`000000Z2`B0:P/4P090:P/4P03
0000002X;180Z2`B00P0Z2`B00<000000:P/4P2X;1802@2X;1800`000000?EV[03eIZ`020:P/4P03
03eIZ`2X;180Z2`B00@0Z2`B00L000000:P/4P2X;180Z2`B03eIZ`2X;180?EV[00<0Z2`B00@0?EV[
0:P/4P0mFJ/0?EV[203om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0
e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT0
103om^h00`000000ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^02<0ooK^00<000000?ofkP3om^h0
;`3om^h10?ooo`00<@3om^h00`000000ooK^0?ofkP0S0?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0
00000?ofkP3om^h00`3om^h0103D?AT0ooK^0?ofkP3D?ATA0?ofkP030=@m6@3om^h0ooK^0080ooK^
00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00L0ooK^
0P0mFJ/00`2X;180?EV[0:P/4P030:P/4P0303eIZ`2X;180?EV[0080Z2`B00<000000:P/4P2X;180
102X;1801@0mFJ/0Z2`B0:P/4P2X;18000000080?EV[2@2X;1800`000000Z2`B0:P/4P090:P/4P03
0000002X;180Z2`B00P0Z2`B00<000000:P/4P2X;1802@2X;1800`000000Z2`B0:P/4P090:P/4P03
0000002X;180Z2`B00T0Z2`B00<000000:P/4P2X;1802@2X;1800`000000Z2`B0:P/4P080:P/4P03
0000002X;180Z2`B00T0Z2`B00<000000:P/4P2X;1801`2X;18203eIZ`050000002X;180Z2`B0:P/
4P0mFJ/01P2X;1801P000000Z2`B0:P/4P0mFJ/0Z2`B03eIZ`@0Z2`B00@0?EV[0:P/4P0mFJ/0?EV[
2@3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h0
0P3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP040=@m6@3om^h0ooK^0=@m6@D0ooK^00<000000?ofkP3o
m^h02`3om^h00`3D?AT0ooK^0?ofkP0S0?ofkP030000003om^h0ooK^02l0ooK^0@3oool00340ooK^
00<000000?ofkP3om^h08`3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030000003om^h0ooK^00<0ooK^
00@0e3dI0?ofkP3om^h0e3dI4@3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00`0
ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP070?ofkP80?EV[00<0Z2`B03eIZ`2X
;1800`2X;1800`0mFJ/0Z2`B03eIZ`020:P/4P030000002X;180Z2`B00@0Z2`B00D0?EV[0:P/4P2X
;180Z2`B000000020:P/4P0303eIZ`2X;180Z2`B00H0Z2`B00<000000:P/4P2X;1802@2X;1800`00
0000Z2`B0:P/4P080:P/4P030000002X;180Z2`B00T0Z2`B00<000000:P/4P2X;1802@2X;1800`00
0000Z2`B0:P/4P090:P/4P030000002X;180Z2`B00T0Z2`B00<000000:P/4P2X;180202X;1800`00
0000Z2`B0:P/4P090:P/4P030000002X;180Z2`B00H0Z2`B00@0?EV[0:P/4P2X;18000000`2X;180
0`0mFJ/0Z2`B0:P/4P040:P/4P060000002X;180Z2`B03eIZ`2X;180?EV[102X;180100mFJ/0Z2`B
03eIZ`0mFJ/90?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0
ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00l0ooK^00@0e3dI0?ofkP3om^h0e3dI1@3om^h00`00
0000ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^02<0ooK^00<000000?ofkP3om^h0;`3om^h10?oo
o`00<03om^h00`000000ooK^0?ofkP0S0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<000000?ofkP3o
m^h00`3om^hk0=@m6@@0?EV[1@2X;18203eIZ`030:P/4P000000Z2`B00L0Z2`B00@0?EV[0:P/4P2X
;18000000`2X;18203eIZ`H0Z2`B00<000000:P/4P2X;1802@2X;1800`000000Z2`B0:P/4P080:P/
4P030000002X;180Z2`B00T0Z2`B00<000000:P/4P2X;1802@2X;1800`000000Z2`B0:P/4P090:P/
4P030000002X;180Z2`B00T0Z2`B00<000000:P/4P2X;180202X;1800`000000Z2`B0:P/4P090:P/
4P030000002X;180Z2`B00@0Z2`B0P0mFJ/30:P/4P040000002X;180Z2`B03eIZ`P0Z2`B00@00000
0:P/4P0mFJ/0?EV[1@2X;18403eIZc/0e3dI1@3om^h00`000000ooK^0?ofkP0;0?ofkP030=@m6@3o
m^h0ooK^02@0ooK^00<000000?ofkP3om^h0;P3om^h10?ooo`00<03om^h00`000000ooK^0?ofkP0S
0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<000000?ofkP3om^h00P3om^h00`3D?AT0ooK^0=@m6@0B
0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT03`3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3o
m^h0ooK^00L0ooK^100mFJ/50:P/4P80?EV[00<0Z2`B0000002X;1801`2X;180100mFJ/0Z2`B0:P/
4P0000050:P/4P80?EV[102X;1800`000000Z2`B0:P/4P090:P/4P030000002X;180Z2`B00P0Z2`B
00<000000:P/4P2X;1802@2X;1800`000000Z2`B0:P/4P090:P/4P030000002X;180Z2`B00T0Z2`B
00<000000:P/4P2X;1802@2X;1800`000000Z2`B0:P/4P080:P/4P030000002X;180Z2`B00T0Z2`B
00<000000:P/4P2X;1800P2X;18203eIZ`D0Z2`B00@000000:P/4P2X;180?EV[202X;18010000000
Z2`B03eIZ`0mFJ/50:P/4P@0?EV[2@3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^
00d0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0B0?ofkP030=@m6@3om^h0e3dI00@0ooK^00<00000
0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0S0?ofkP030000003om^h0ooK^02h0ooK^0@3oool0
0300ooK^00<000000?ofkP3om^h08`3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030000003om^h0ooK^
0080ooK^00<0e3dI0?ofkP3D?AT04P3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00l0ooK^00<0e3dI
0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP070?ofkP<0?EV[00<0000003eIZ`00000010000000
0`0mFJ/00000000000080000000303eIZ`000000000000P000000P0mFJ]S00000080?EV[2P000000
0`0mFJ/00000000000080000000303eIZ`000000000000<0000000<0?EV[0000000mFJ/00P0mFJ/9
0?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h03@3om^h01@3D?AT0ooK^0?ofkP3o
m^h0e3dI0180ooK^00<0e3dI0?ofkP3D?AT0103om^h00`000000ooK^0?ofkP0=0?ofkP030=@m6@3o
m^h0ooK^02<0ooK^00<000000?ofkP3om^h0;P3om^h10?ooo`00<03om^h00`000000ooK^0?ofkP0S
0?ofkU00e3dI0P0mFJ/00`2j<QD0?EV[03eIZ`050;Xb5@80?EV[00<000000=@m6@2j<QD01P2j<QD0
100mFJ/0^S8E0;Xb5@0000090;Xb5@80?EV[00<000000;Xb5@2j<QD02@2j<QD00`000000^S8E0;Xb
5@080;Xb5@030000002j<QD0^S8E00T0^S8E00<000000;Xb5@2j<QD02@2j<QD00`000000^S8E0;Xb
5@090;Xb5@030000002j<QD0^S8E00T0^S8E00<000000;Xb5@2j<QD0202j<QD00`000000^S8E0;Xb
5@090;Xb5@030000000mFJ/0?EV[00T0^S8E00@000000;Xb5@2j<QD0?EV[202j<QD00`000000?EV[
03eIZ`050;Xb5@80?EV[00<0^S8E03eIZ`0mFJ/0D03D?ATU0?ofkP030000003om^h0ooK^02h0ooK^
0@3oool00300ooK^00<000000?ofkP3om^h08`3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030000003o
m^h0ooK^00<0ooK^0P3D?ATB0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT03`3om^h00`3D?AT0ooK^
0?ofkP050?ofkP030=@m6@3om^h0ooK^00L0ooK^0P0mFJ/00`2j<QD0?EV[03eIZ`050;Xb5@0303eI
Z`2j<QD0?EV[00P0^S8E00@0?EV[0;Xb5@2j<QD000002`2j<QD203eIZ`X0^S8E00<000000;Xb5@2j
<QD0202j<QD00`000000^S8E0;Xb5@090;Xb5@030000002j<QD0^S8E00T0^S8E00<000000;Xb5@2j
<QD02@2j<QD00`000000^S8E0;Xb5@090;Xb5@030000002j<QD0^S8E00P0^S8E00<000000;Xb5@2j
<QD0202j<QD203eIZ`/0^S8E00@000000;Xb5@2j<QD0?EV[202j<QD00`0mFJ/0^S8E03eIZ`050;Xb
5@80?EV[00<0^S8E03eIZ`0mFJ/02@3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^
00d0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0B0?ofkP80e3dI1@3om^h00`000000ooK^0?ofkP0=
0?ofkP030=@m6@3om^h0ooK^02<0ooK^00<000000?ofkP3om^h0;P3om^h10?ooo`00;`3om^h00`00
0000ooK^0?ofkP0T0?ofkP030=@m6@3om^h0ooK^00h0ooK^00<000000?ofkP3om^h00P3om^h20=@m
6A80ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0?0?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI
0?ofkP3om^h01`3om^h203eIZ`80^S8E00<0?EV[0;Xb5@2j<QD00`2j<QD00`0mFJ/0^S8E00000002
03eIZ`H0^S8E00@0?EV[0;Xb5@2j<QD000002`2j<QD00`0mFJ/0^S8E03eIZ`0203eIZ`L0^S8E00<0
00000;Xb5@2j<QD0202j<QD00`000000^S8E0;Xb5@090;Xb5@030000002j<QD0^S8E00T0^S8E00<0
00000;Xb5@2j<QD02@2j<QD00`000000^S8E0;Xb5@090;Xb5@030000002j<QD0^S8E00P0^S8E00<0
00000;Xb5@2j<QD01@2j<QD303eIZ`030;Xb5@0mFJ/0^S8E00X0^S8E00@000000;Xb5@2j<QD0?EV[
1P2j<QD203eIZ`030000002j<QD0?EV[00D0^S8E00D0?EV[0;Xb5@2j<QD0?EV[000000090?ofkP03
0=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h03@3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI
0180ooK^0P3D?AT40?ofkP030000003om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h0903om^h00`00
0000ooK^0?ofkP0]0?ofkP40oooo000_0?ofkP030000003om^h0ooK^02@0ooK^00<0e3dI0?ofkP3o
m^h03P3om^h00`000000ooK^0?ofkP020?ofkP80e3dI4P3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI
00l0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP070?ofkP050000000mFJ/0^S8E
0;Xb5@0mFJ/01@2j<QD00`0mFJ/0^S8E000000020;Xb5@0303eIZ`2j<QD0^S8E00<0^S8E00@0?EV[
0;Xb5@2j<QD000002`2j<QD00`0mFJ/0^S8E0;Xb5@020;Xb5@<0?EV[102j<QD00`000000^S8E0;Xb
5@080;Xb5@030000002j<QD0^S8E00T0^S8E00<000000;Xb5@2j<QD02@2j<QD00`000000^S8E0;Xb
5@090;Xb5@030000002j<QD0^S8E00T0^S8E00<000000;Xb5@2j<QD0202j<QD00`000000^S8E0;Xb
5@020;Xb5@<0?EV[102j<QD00`0mFJ/0^S8E0;Xb5@090;Xb5@040000002j<QD0^S8E03eIZ`D0^S8E
00D0?EV[0;Xb5@2j<QD0000003eIZ`060;Xb5@0503eIZ`2j<QD0^S8E03eIZ`0000002@3om^h00`3D
?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00h0ooK^00@0e3dI0?ofkP3om^h0e3dI4`3om^h2
0=@m6@@0ooK^00<000000?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0T0?ofkP030000003om^h0
ooK^02d0ooK^0@3oool002l0ooK^00<000000?ofkP3om^h08`3om^h00`3D?AT0ooK^0?ofkP0?0?of
kP030000003om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h04P3om^h0103D?AT0ooK^0?ofkP3D?AT@
0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h01`3om^h010000000?EV[0;Xb5@2j
<QD203eIZ`D0^S8E00<0?EV[0000002j<QD00P2j<QD00`0mFJ/0^S8E0;Xb5@020;Xb5@0403eIZ`2j
<QD0^S8E000000/0^S8E00<0?EV[0;Xb5@2j<QD01@2j<QD303eIZ`030;Xb5@000000^S8E00T0^S8E
00<000000;Xb5@2j<QD02@2j<QD00`000000^S8E0;Xb5@090;Xb5@030000002j<QD0^S8E00T0^S8E
00<000000;Xb5@2j<QD02@2j<QD00`000000^S8E0;Xb5@080;Xb5@030000002j<QD0?EV[0080?EV[
1`2j<QD00`0mFJ/0^S8E0;Xb5@090;Xb5@040000002j<QD0^S8E03eIZ`@0^S8E00H0?EV[0;Xb5@2j
<QD0^S8E0000000mFJ/50;Xb5@80?EV[0P2j<QD00`0mFJ/000000?ofkP080?ofkP030=@m6@3om^h0
ooK^00@0ooK^00<0e3dI0?ofkP3om^h03P3om^h0103D?AT0ooK^0?ofkP3D?ATD0?ofkP030=@m6@3o
m^h0ooK^0080ooK^00<000000?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP0S0?ofkP030000003o
m^h0ooK^02d0ooK^0@3oool002l0ooK^00<000000?ofkP3om^h08`3om^h00`3D?AT0ooK^0?ofkP0?
0?ofkP030000003om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h04P3om^h0103D?AT0ooK^0?ofkP3D
?AT@0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h0203om^h00`0mFJ/0^S8E0;Xb
5@0203eIZ`D0^S8E00<0?EV[0000002j<QD00`2j<QD00`0mFJ/0^S8E0;Xb5@020;Xb5@0303eIZ`2j
<QD0000000/0^S8E00<0?EV[0;Xb5@2j<QD0202j<QD303eIZ`T0^S8E00<000000;Xb5@2j<QD02@2j
<QD00`000000^S8E0;Xb5@090;Xb5@030000002j<QD0^S8E00T0^S8E00<000000;Xb5@2j<QD02@2j
<QD00`000000^S8E0;Xb5@070;Xb5@<0?EV[2P2j<QD00`0mFJ/0^S8E0;Xb5@090;Xb5@030000002j
<QD0?EV[00@0^S8E00<0?EV[0;Xb5@2j<QD00P2j<QD00`000000?EV[0;Xb5@040;Xb5@80?EV[0P2j
<QD00`0mFJ/0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h03P3o
m^h0103D?AT0ooK^0?ofkP3D?ATD0?ofkP030=@m6@3om^h0ooK^0080ooK^00<000000?ofkP3om^h0
3`3om^h00`3D?AT0ooK^0?ofkP0S0?ofkP030000003om^h0ooK^02d0ooK^0@3oool002l0ooK^00<0
00000?ofkP3om^h08`3om^h00`3D?AT0ooK^0?ofkP0@0?ofkP050000003om^h0ooK^0?ofkP3D?AT0
503om^h0103D?AT0ooK^0?ofkP3D?AT@0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3o
m^h0203om^h01P0mFJ/0^S8E0;Xb5@0mFJ/0^S8E03eIZ`@0^S8E00<0?EV[0000002j<QD0102j<QD0
1`0mFJ/0^S8E0;Xb5@2j<QD0?EV[0;Xb5@0000002`2j<QD00`0mFJ/0^S8E0;Xb5@090;Xb5@030000
002j<QD0?EV[0080?EV[1P2j<QD00`000000^S8E0;Xb5@090;Xb5@030000002j<QD0^S8E00T0^S8E
00<000000;Xb5@2j<QD02@2j<QD00`000000^S8E0;Xb5@090;Xb5@030000002j<QD0^S8E00@0^S8E
0`0mFJ/00`2j<QD000000;Xb5@0:0;Xb5@0303eIZ`2j<QD0^S8E00T0^S8E00<000000;Xb5@0mFJ/0
0`2j<QD00`0mFJ/0^S8E0;Xb5@030;Xb5@030000000mFJ/0^S8E00<0^S8E00<0?EV[0;Xb5@0mFJ/0
0P2j<QD00`0mFJ/0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h0
3P3om^h0103D?AT0ooK^0?ofkP3D?ATC0?ofkP80e3dI0`3om^h00`000000ooK^0?ofkP0@0?ofkP03
0=@m6@3om^h0ooK^02<0ooK^00<000000?ofkP3om^h0;@3om^h10?ooo`00;P3om^h00`000000ooK^
0?ofkP0T0?ofkP030=@m6@3om^h0ooK^0100ooK^00@000000?ofkP3om^h0ooK^0P3D?ATC0?ofkP03
0=@m6@3om^h0e3dI0140ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP090?ofkP07
03eIZ`2j<QD0^S8E0;Xb5@0mFJ/0^S8E03eIZ`030;Xb5@0303eIZ`000000^S8E00D0^S8E0P0mFJ/0
102j<QD0?EV[0;Xb5@00000;0;Xb5@0303eIZ`2j<QD0^S8E00T0^S8E00<000000;Xb5@2j<QD00P2j
<QD503eIZ`030;Xb5@000000^S8E00X0^S8E00<000000;Xb5@2j<QD02@2j<QD00`000000^S8E0;Xb
5@090;Xb5@030000002j<QD0^S8E00T0^S8E00<000000;Xb5@0mFJ/0100mFJ/40;Xb5@030000002j
<QD0^S8E00T0^S8E00<0?EV[0;Xb5@2j<QD02@2j<QD010000000^S8E03eIZ`2j<QD203eIZ`H0^S8E
00<0000003eIZ`2j<QD00P2j<QD00`0mFJ/0^S8E03eIZ`030;Xb5@0303eIZ`3om^h0ooK^00P0ooK^
00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP0>0?ofkP040=@m6@3om^h0ooK^0=@m6A<0
ooK^0P3D?AT30?ofkP030000003om^h0ooK^0100ooK^00<0e3dI0?ofkP3om^h0903om^h00`000000
ooK^0?ofkP0/0?ofkP40oooo000^0?ofkP030000003om^h0ooK^02@0ooK^00<0e3dI0?ofkP3om^h0
403om^h010000000ooK^0?ofkP3om^h20=@m6A<0ooK^00<0e3dI0?ofkP3D?AT04@3om^h00`3D?AT0
ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00T0ooK^0P0mFJ/20;Xb5@0303eIZ`2j<QD0?EV[00<0
^S8E00<0?EV[0000002j<QD01`2j<QD203eIZ`030;Xb5@000000^S8E00X0^S8E00<0?EV[0;Xb5@2j
<QD02@2j<QD00`000000^S8E0;Xb5@030;Xb5@0403eIZ`2j<QD0^S8E0;Xb5@H0?EV[1`2j<QD00`00
0000^S8E0;Xb5@090;Xb5@030000002j<QD0^S8E00T0^S8E00<000000;Xb5@2j<QD01@2j<QD603eI
Z`<0^S8E00<0?EV[0;Xb5@2j<QD00`2j<QD00`000000^S8E0;Xb5@090;Xb5@0303eIZ`2j<QD0^S8E
00T0^S8E00@000000;Xb5@0mFJ/0?EV[202j<QD00`000000?EV[0;Xb5@020;Xb5@0303eIZ`2j<QD0
?EV[0080^S8E0P0mFJ/;0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h03`3om^h0
0`3D?AT0ooK^0=@m6@0C0?ofkP80e3dI0`3om^h00`000000ooK^0?ofkP0@0?ofkP030=@m6@3om^h0
ooK^02@0ooK^00<000000?ofkP3om^h0;03om^h10?ooo`00;P3om^ko000009P00000;P3om^h10?oo
o`00;P3om^h00`000000ooK^0?ofkP0T0?ofkP030=@m6@3om^h0ooK^0100ooK^00@000000?ofkP3o
m^h0ooK^0P3D?ATC0?ofkP030=@m6@3om^h0e3dI0140ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D
?AT0ooK^0?ofkP090?ofkP050000000mFJ/0?EV[0000000mFJ/00`0000000`0mFJ/0000003eIZ`0:
000000<0?EV[300000000`0mFJ/000000000000>0000000303eIZ`000000000000d000006`0mFJ/?
0000000303eIZ`000000000000h0000000<0?EV[0000000000002P00000303eIZ`X0000000<0?EV[
0000000mFJ/00`0000001@0mFJ/0000003eIZ`0mFJ/0000000/0ooK^00<0e3dI0?ofkP3om^h00`3o
m^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0e3dI01<0ooK^0P3D?AT30?ofkP030000003o
m^h0ooK^0100ooK^00<0e3dI0?ofkP3om^h0903om^h00`000000ooK^0?ofkP0/0?ofkP40oooo000_
0?ofkP030000003om^h0ooK^0280ooK^00<0e3dI0?ofkP3om^h04P3om^h01@000000ooK^0=@m6@3o
m^h0e3dI01<0ooK^00<0e3dI0?ofkP3D?AT04@3om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3o
m^h0ooK^00T0ooK^00D0000003eIZ`0mFJ/0b3LG03eIZ`030<Pg5`0403eIZ`38=aL0?EV[000000T0
b3LG00<0?EV[0<Pg5`0000000P0mFJ/90<Pg5`030000000mFJ/0b3LG00T0b3LG00<000000<Pg5`38
=aL00`38=aL00`0mFJ/0b3LG0<Pg5`020<Pg5`0300000038=aL0b3LG00T0b3LG00<000000<Pg5`0m
FJ/02@38=aL00`000000b3LG0<Pg5`070<Pg5`0303eIZ`38=aL0000000/0b3LG00<000000<Pg5`38
=aL00P38=aL00`0mFJ/0b3LG0<Pg5`030<Pg5`0300000038=aL0b3LG00P0b3LG00<0?EV[00000038
=aL02038=aL203eIZ`0300000038=aL0?EV[00T0b3LG00@0?EV[0<Pg5`38=aL0?EV[0`38=aL01@0m
FJ/0b3LG03eIZ`0mFJ/0000000/0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP0?
0?ofkP030=@m6@3om^h0e3dI01<0ooK^00D0e3dI0?ofkP3D?AT0ooK^0000000D0?ofkP030=@m6@3o
m^h0ooK^0280ooK^00<000000?ofkP3om^h0;@3om^h10?ooo`00;`3om^h00`000000ooK^0?ofkP0R
0?ofkP030=@m6@3om^h0ooK^0180ooK^00D000000?ofkP3D?AT0ooK^0=@m6@0C0?ofkP030=@m6@3o
m^h0e3dI0140ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP090?ofkP050000000m
FJ/0?EV[0<Pg5`0mFJ/01038=aL00`0mFJ/0b3LG03eIZ`090<Pg5`0303eIZ`38=aL000000080b3LG
00<0?EV[0<Pg5`38=aL01P38=aL00`000000?EV[0<Pg5`090<Pg5`0300000038=aL0b3LG00<0b3LG
00<0?EV[0<Pg5`38=aL00P38=aL00`000000b3LG0<Pg5`090<Pg5`0300000038=aL0?EV[00T0b3LG
00<000000<Pg5`38=aL01`38=aL00`0mFJ/0b3LG0000000;0<Pg5`0300000038=aL0b3LG0080b3LG
00<0?EV[0<Pg5`38=aL00`38=aL00`000000b3LG0<Pg5`080<Pg5`0303eIZ`000000b3LG00L0b3LG
00H0?EV[0<Pg5`38=aL000000<Pg5`0mFJ/80<Pg5`040000000mFJ/0b3LG03eIZ`@0b3LG0P0mFJ/0
0`38=aL0?EV[0000000;0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h03`3om^h0
0`3D?AT0ooK^0=@m6@0C0?ofkP050=@m6@3om^h0e3dI0?ofkP000000503om^h00`3D?AT0ooK^0?of
kP0R0?ofkP030000003om^h0ooK^02d0ooK^0@3oool002l0ooK^00<000000?ofkP3om^h08P3om^h0
0`3D?AT0ooK^0?ofkP0B0?ofkP050000003om^h0e3dI0?ofkP3D?AT04`3om^h00`3D?AT0ooK^0=@m
6@0A0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`000000?EV[0<Pg
5`0203eIZ`D0b3LG0P0mFJ/00`000000b3LG0<Pg5`060<Pg5`0303eIZ`38=aL0000000<0b3LG0P0m
FJ/60<Pg5`030000000mFJ/0b3LG00T0b3LG00<000000<Pg5`38=aL00`38=aL00`0mFJ/0b3LG0<Pg
5`020<Pg5`0300000038=aL0b3LG00T0b3LG00<000000<Pg5`0mFJ/02@38=aL00`000000b3LG0<Pg
5`070<Pg5`0303eIZ`38=aL0000000/0b3LG00<000000<Pg5`38=aL00P38=aL00`0mFJ/0b3LG0<Pg
5`030<Pg5`0300000038=aL0b3LG00P0b3LG00<0?EV[00000038=aL01@38=aL203eIZ`80b3LG00@0
00000<Pg5`38=aL0?EV[2038=aL00`000000?EV[03eIZ`050<Pg5`80?EV[00<0b3LG03eIZ`000000
2`3om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3D?AT0
4`3om^h01@3D?AT0ooK^0=@m6@3om^h0000001@0ooK^00<0e3dI0?ofkP3om^h08P3om^h00`000000
ooK^0?ofkP0]0?ofkP40oooo000`0?ofkP030000003om^h0ooK^0240ooK^E@3D?AT00`38=aL0?EV[
03eIZ`050<Pg5`80?EV[00<000000<Pg5`38=aL01`38=aL00`0mFJ/0b3LG000000040<Pg5`80?EV[
1038=aL00`000000?EV[0<Pg5`090<Pg5`0300000038=aL0b3LG00<0b3LG00<0?EV[0<Pg5`38=aL0
0P38=aL00`000000b3LG0<Pg5`090<Pg5`0300000038=aL0?EV[00T0b3LG00<000000<Pg5`38=aL0
1`38=aL00`0mFJ/0b3LG0000000;0<Pg5`0300000038=aL0b3LG0080b3LG00<0?EV[0<Pg5`38=aL0
0`38=aL00`000000b3LG0<Pg5`080<Pg5`0303eIZ`000000b3LG00<0b3LG0P0mFJ/40<Pg5`030000
0038=aL0?EV[00T0b3LG00<0000003eIZ`0mFJ/01@38=aL203eIZ`030<Pg5`3D?AT0e3dI05<0e3dI
8`3om^h00`000000ooK^0?ofkP0^0?ofkP40oooo000`0?ofkP030000003om^h0ooK^0240ooK^00<0
e3dI0?ofkP3om^h04`3om^h010000000e3dI0?ofkP3D?ATC0?ofkP030=@m6@3om^h0e3dI0140ooK^
00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP0300000038=aL0b3LG0080?EV[
1@38=aL00`0mFJ/000000<Pg5`080<Pg5`0303eIZ`38=aL0000000H0b3LG00H0?EV[0<Pg5`38=aL0
b3LG0000000mFJ/:0<Pg5`0300000038=aL0b3LG00<0b3LG00<0?EV[0<Pg5`38=aL00P38=aL00`00
0000b3LG0<Pg5`090<Pg5`0300000038=aL0?EV[00T0b3LG00<000000<Pg5`38=aL01`38=aL00`0m
FJ/0b3LG0000000;0<Pg5`0300000038=aL0b3LG0080b3LG00<0?EV[0<Pg5`38=aL00`38=aL00`00
0000b3LG0<Pg5`080<Pg5`0303eIZ`000000b3LG0080b3LG00<0?EV[0<Pg5`38=aL01038=aL00`00
0000b3LG03eIZ`090<Pg5`030000000mFJ/0b3LG00@0b3LG0P0mFJ/20<Pg5`030000003om^h0ooK^
00X0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0e3dI
01<0ooK^00@0e3dI0?ofkP3D?AT000005@3om^h00`3D?AT0ooK^0?ofkP0Q0?ofkP030000003om^h0
ooK^02h0ooK^0@3oool00300ooK^00<000000?ofkP3om^h08@3om^h00`3D?AT0ooK^0?ofkP0C0?of
kP050000003D?AT0ooK^0?ofkP3D?AT04`3om^h20=@m6A80ooK^00<0e3dI0?ofkP3om^h00P3om^h0
0`3D?AT0ooK^0?ofkP0:0?ofkP0300000038=aL0b3LG0080?EV[1@38=aL203eIZ`T0b3LG00<0?EV[
0<Pg5`0000001`38=aL203eIZ`030<Pg5`000000?EV[00X0b3LG00<000000<Pg5`38=aL00`38=aL0
0`0mFJ/0b3LG0<Pg5`020<Pg5`0300000038=aL0b3LG00T0b3LG00<000000<Pg5`0mFJ/02@38=aL0
0`000000b3LG0<Pg5`070<Pg5`0303eIZ`000000b3LG00X0b3LG00<000000<Pg5`38=aL00`38=aL0
0`0mFJ/0b3LG0<Pg5`020<Pg5`0300000038=aL0b3LG00T0b3LG00<0?EV[0<Pg5`38=aL00P0mFJ/7
0<Pg5`0300000038=aL0?EV[00P0b3LG00<0000003eIZ`0mFJ/01@38=aL203eIZ`80b3LG00<00000
0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^0100ooK^0P3D?ATC
0?ofkP050=@m6@3om^h0ooK^0=@m6@0000005@3om^h00`3D?AT0ooK^0?ofkP0Q0?ofkP030000003o
m^h0ooK^02h0ooK^0@3oool00340ooK^00<000000?ofkP3om^h0803om^h00`3D?AT0ooK^0?ofkP0C
0?ofkP050000003D?AT0ooK^0?ofkP3D?AT04`3om^h20=@m6A80ooK^00<0e3dI0?ofkP3om^h00P3o
m^h00`3D?AT0ooK^0?ofkP0:0?ofkP0500000038=aL0b3LG0<Pg5`0mFJ/01@38=aL00`0mFJ/0b3LG
03eIZ`080<Pg5`0303eIZ`38=aL0000000T0b3LG0`0mFJ/;0<Pg5`0300000038=aL0b3LG0080b3LG
00<0?EV[0<Pg5`38=aL00`38=aL00`000000b3LG0<Pg5`090<Pg5`030000000mFJ/0b3LG00P0b3LG
00<000000<Pg5`38=aL01`38=aL00`0mFJ/000000<Pg5`0:0<Pg5`0300000038=aL0b3LG00<0b3LG
00<0?EV[0<Pg5`38=aL00P38=aL00`000000b3LG0<Pg5`090<Pg5`<0?EV[2@38=aL00`000000b3LG
03eIZ`080<Pg5`0303eIZ`38=aL0?EV[00D0b3LG00D0?EV[0<Pg5`38=aL0b3LG0000000<0?ofkP03
0=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h0403om^h20=@m6A<0ooK^00D0e3dI0?ofkP3o
m^h0e3dI0000000E0?ofkP030=@m6@3om^h0ooK^0200ooK^00<000000?ofkP3om^h0;`3om^h10?oo
o`00<@3om^h00`000000ooK^0?ofkP0P0?ofkP030=@m6@3om^h0ooK^01<0ooK^00D000000=@m6@3o
m^h0ooK^0=@m6@0C0?ofkP80e3dI4P3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^
00X0ooK^00D000000<Pg5`38=aL0b3LG03eIZ`050<Pg5`0403eIZ`38=aL0000003eIZ`L0b3LG00<0
?EV[0<Pg5`0000002`38=aL203eIZ`X0b3LG00<000000<Pg5`38=aL00P38=aL00`0mFJ/0b3LG0<Pg
5`030<Pg5`0300000038=aL0b3LG00T0b3LG00<0000003eIZ`38=aL02038=aL00`000000b3LG0<Pg
5`070<Pg5`0303eIZ`000000b3LG00X0b3LG00<000000<Pg5`38=aL00`38=aL00`0mFJ/0b3LG0<Pg
5`020<Pg5`0300000038=aL0b3LG00P0b3LG0P0mFJ/;0<Pg5`0300000038=aL0?EV[00L0b3LG00@0
?EV[00000038=aL0?EV[1@38=aL01@0mFJ/0b3LG0<Pg5`38=aL0000000`0ooK^00<0e3dI0?ofkP3o
m^h00P3om^h00`3D?AT0ooK^0?ofkP0@0?ofkP80e3dI4`3om^h01@3D?AT0ooK^0?ofkP3D?AT00000
01D0ooK^00<0e3dI0?ofkP3om^h0803om^h00`000000ooK^0?ofkP0_0?ofkP40oooo000a0?ofkP03
0000003om^h0ooK^0200ooK^00<0e3dI0?ofkP3om^h04`3om^h01@000000e3dI0?ofkP3om^h0e3dI
01<0ooK^0P3D?ATB0?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h02P3om^h01000
0000b3LG0<Pg5`38=aL203eIZ`@0b3LG00D0?EV[0<Pg5`000000b3LG03eIZ`060<Pg5`0303eIZ`38
=aL0000000/0b3LG00<0?EV[0<Pg5`0mFJ/00P0mFJ/70<Pg5`0300000038=aL0b3LG0080b3LG00<0
?EV[0<Pg5`38=aL00`38=aL00`000000b3LG0<Pg5`090<Pg5`030000000mFJ/0b3LG00P0b3LG00<0
00000<Pg5`38=aL01`38=aL00`0mFJ/000000<Pg5`0:0<Pg5`0300000038=aL0b3LG00<0b3LG00<0
?EV[0<Pg5`38=aL00P38=aL00`000000b3LG0<Pg5`050<Pg5`<0?EV[00<0b3LG03eIZ`38=aL02@38
=aL010000000b3LG0<Pg5`0mFJ/60<Pg5`0403eIZ`38=aL0000003eIZ`D0b3LG0P0mFJ/20<Pg5`80
0000303om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^0100ooK^0P3D?ATC0?ofkP05
0=@m6@3om^h0ooK^0=@m6@0000005@3om^h00`3D?AT0ooK^0?ofkP0P0?ofkP030000003om^h0ooK^
02l0ooK^0@3oool00380ooK^00<000000?ofkP3om^h07`3om^h00`3D?AT0ooK^0?ofkP0D0?ofkP04
0=@m6@3om^h0ooK^0=@m6A<0ooK^0P3D?ATB0?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?of
kP3om^h02P3om^h200000080b3LG0P0mFJ/50<Pg5`0503eIZ`000000b3LG0<Pg5`0mFJ/01@38=aL0
100mFJ/0b3LG0<Pg5`00000:0<Pg5`0303eIZ`38=aL0b3LG0080b3LG0`0mFJ/40<Pg5`0300000038
=aL0b3LG0080b3LG00<0?EV[0<Pg5`38=aL00`38=aL00`000000b3LG0<Pg5`090<Pg5`030000000m
FJ/0b3LG00P0b3LG00<000000<Pg5`38=aL01`38=aL00`0mFJ/000000<Pg5`0:0<Pg5`0300000038
=aL0b3LG00<0b3LG00<0?EV[0<Pg5`38=aL00P38=aL00`000000b3LG0<Pg5`020<Pg5`<0?EV[1038
=aL00`0mFJ/0b3LG0<Pg5`080<Pg5`0400000038=aL0b3LG03eIZ`D0b3LG00D0?EV[0<Pg5`000000
b3LG03eIZ`050<Pg5`80?EV[0P38=aL2000000`0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0
ooK^0?ofkP0@0?ofkP80e3dI4`3om^h0103D?AT0ooK^0?ofkP3D?ATF0?ofkP030=@m6@3om^h0ooK^
01l0ooK^00<000000?ofkP3om^h0<03om^h10?ooo`00<P3om^h00`000000ooK^0?ofkP0O0?ofkP03
0=@m6@3om^h0ooK^01@0ooK^00@0e3dI0?ofkP3om^h0e3dI4`3om^h20=@m6A80ooK^00<0e3dI0?of
kP3om^h00P3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP8000000P38=aL00`0mFJ/0b3LG03eIZ`040<Pg
5`0303eIZ`38=aL000000080b3LG0P0mFJ/30<Pg5`0403eIZ`38=aL0b3LG000000X0b3LG00<0?EV[
0<Pg5`38=aL01@38=aL203eIZ`80b3LG00<000000<Pg5`38=aL00P38=aL00`0mFJ/0b3LG0<Pg5`03
0<Pg5`0300000038=aL0b3LG00T0b3LG00<0000003eIZ`38=aL02038=aL00`000000b3LG0<Pg5`07
0<Pg5`0303eIZ`000000b3LG00X0b3LG00<000000<Pg5`38=aL00`38=aL00`0mFJ/0b3LG0<Pg5`02
0<Pg5`0300000038=aL0b3LG0080?EV[1`38=aL00`0mFJ/0b3LG0<Pg5`080<Pg5`0400000038=aL0
b3LG03eIZ`<0b3LG0P0mFJ/20<Pg5`0300000038=aL0?EV[00@0b3LG00<0?EV[0<Pg5`0mFJ/00P38
=aL00`000000ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h0403o
m^h20=@m6A<0ooK^00@0e3dI0?ofkP3om^h0e3dI5P3om^h00`3D?AT0ooK^0?ofkP0O0?ofkP030000
003om^h0ooK^0300ooK^0@3oool00380ooK^00<000000?ofkP3om^h07P3om^h00`3D?AT0ooK^0?of
kP0D0?ofkP040=@m6@000000ooK^0?ofkS/0e3dI0`0000000`0mFJ/0000003eIZ`040000000303eI
Z`000000000000@0000000D0?EV[000000000000000003eIZ`0<0000000303eIZ`000000000000L0
00000`0mFJ/40000000303eIZ`00000000000100000000<0?EV[0000000000004@0000000`0mFJ/0
00000000000@0000000303eIZ`0000000000008000000`0mFJ/90000000303eIZ`000000000000X0
000000D0?EV[000000000000000003eIZ`060000000303eIZ`00000000000080000000<0?EV[0000
000mFJ/00`00000k0=@m6@80ooK^00<0e3dI0?ofkP3om^h0503om^h00`3D?AT0ooK^0?ofkP0O0?of
kP030000003om^h0ooK^0300ooK^0@3oool00380ooK^00<000000?ofkP3om^h07P3om^h00`3D?AT0
ooK^0?ofkP0D0?ofkP050=@m6@000000ooK^0?ofkP3D?AT04`3om^h00`3D?AT0ooK^0?ofkP0A0?of
kP050=@m6@3om^h0ooK^0?ofkP3D?AT03P3om^h010000000dc/I0=<k6@0mFJ/20=<k6@0703eIZ`3C
>aT0dc/I0=<k6@0mFJ/0dc/I000000050=<k6@0603eIZ`3C>aT0dc/I03eIZ`3C>aT000002P3C>aT0
0`0mFJ/0dc/I0=<k6@090=<k6@060000000mFJ/0?EV[03eIZ`3C>aT0?EV[1@3C>aT00`000000dc/I
0=<k6@090=<k6@030000000mFJ/0dc/I00P0dc/I00<000000=<k6@3C>aT01`3C>aT00`0mFJ/00000
0=<k6@0:0=<k6@030000003C>aT0dc/I00<0dc/I00<0?EV[0=<k6@0mFJ/00P0mFJ/00`000000dc/I
0=<k6@090=<k6@0303eIZ`3C>aT0dc/I00P0dc/I00<000000=<k6@0mFJ/00P3C>aT00`0mFJ/0dc/I
0=<k6@030=<k6@030000003C>aT0?EV[00<0dc/I00@0?EV[0=<k6@3C>aT0?EV[0P3C>aT00`000000
ooK^0?ofkP0<0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT04`3om^h00`3D?AT0ooK^0?ofkP0A0?of
kP050=@m6@3om^h0ooK^0000003D?AT05P3om^h00`3D?AT0ooK^0?ofkP0N0?ofkP030000003om^h0
ooK^0300ooK^0@3oool003<0ooK^00<000000?ofkP3om^h07@3om^h00`3D?AT0ooK^0?ofkP0D0?of
kP050=@m6@3om^h000000?ofkP3D?AT04`3om^h00`3D?AT0ooK^0?ofkP0A0?ofkP050=@m6@3om^h0
ooK^0?ofkP3D?AT03P3om^h200000080dc/I00@0?EV[0=<k6@3C>aT0?EV[0P3C>aT0100mFJ/0dc/I
0=<k6@0000050=<k6@0503eIZ`3C>aT0?EV[0=<k6@0000002P3C>aT00`0mFJ/0dc/I0=<k6@090=<k
6@040000003C>aT0dc/I0=<k6@D0?EV[0P3C>aT00`000000dc/I0=<k6@090=<k6@030000000mFJ/0
dc/I00P0dc/I00<000000=<k6@3C>aT01`3C>aT00`0mFJ/000000=<k6@0:0=<k6@030000003C>aT0
dc/I00D0?EV[0`3C>aT00`000000dc/I0=<k6@090=<k6@0303eIZ`3D?AT0dc/I00P0dc/I00D00000
0=<k6@0mFJ/0dc/I03eIZ`050=<k6@040000003C>aT0dc/I03eIZ`80dc/I00@0?EV[0=<k6@3C>aT0
?EV[0P3C>aT2000000h0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0C0?ofkP030=@m6@3om^h0ooK^
0140ooK^00D0e3dI0?ofkP000000ooK^0=@m6@0F0?ofkP030=@m6@3om^h0ooK^01d0ooK^00<00000
0?ofkP3om^h0<@3om^h10?ooo`00<`3om^h00`000000ooK^0?ofkP0M0?ofkP030=@m6@3om^h0ooK^
01@0ooK^00D0e3dI0?ofkP000000ooK^0=@m6@0C0?ofkP030=@m6@3om^h0ooK^0140ooK^00D0e3dI
0?ofkP3om^h0ooK^0=@m6@0>0?ofkP8000000P3C>aT0100mFJ/0dc/I0=<k6@0mFJ/20=<k6@0403eI
Z`3C>aT0dc/I000000H0dc/I0P0mFJ/20=<k6@030000003C>aT0dc/I00L0dc/I00<0?EV[0000003C
>aT02@3C>aT00`000000dc/I0=<k6@020=<k6@0403eIZ`3C>aT0dc/I0=<k6@H0?EV[203C>aT00`00
0000?EV[0=<k6@080=<k6@030000003C>aT0dc/I00L0dc/I00<0?EV[0000003C>aT01`3C>aT603eI
Z`<0dc/I00<0?EV[0=<k6@3C>aT00P3C>aT00`000000dc/I0=<k6@080=<k6@030000000mFJ/0e3dI
00P0dc/I00<000000=<k6@3C>aT00P0mFJ/60=<k6@040000003C>aT0dc/I03eIZ`80dc/I00@0?EV[
0=<k6@3C>aT0?EV[0P3C>aT2000000h0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0C0?ofkP030=@m
6@3om^h0ooK^0140ooK^00D0e3dI0?ofkP000000ooK^0=@m6@0F0?ofkP030=@m6@3om^h0ooK^01d0
ooK^00<000000?ofkP3om^h0<@3om^h10?ooo`00<`3om^h00`000000ooK^0?ofkP0M0?ofkP030=@m
6@3om^h0ooK^01@0ooK^00D0e3dI0?ofkP000000ooK^0=@m6@0C0?ofkP030=@m6@3om^h0ooK^0140
ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0>0?ofkP<0000000<0dc/I03eIZ`3C>aT00P3C>aT00`0m
FJ/0dc/I03eIZ`020=<k6@030000003C>aT0dc/I00D0dc/I00@0?EV[0=<k6@3C>aT000002@3C>aT0
0`0mFJ/000000=<k6@0:0=<k6@050000003C>aT0dc/I0=<k6@0mFJ/01P3C>aT00`000000dc/I0=<k
6@0603eIZ`80dc/I00<0000003eIZ`3C>aT0203C>aT00`000000dc/I0=<k6@070=<k6@0403eIZ`00
0000dc/I0=<k6@H0?EV[0P3C>aT00`000000dc/I0=<k6@040=<k6@0503eIZ`3C>aT0dc/I0=<k6@00
00002`3C>aT00`0mFJ/0dc/I0=<k6@080=<k6@040000003C>aT0dc/I03eIZ`L0dc/I00H000000=<k
6@3C>aT0?EV[0=<k6@0mFJ/30=<k6@0303eIZ`3C>aT00000008000003P3om^h01@3D?AT0ooK^0?of
kP3om^h0e3dI01<0ooK^00<0e3dI0?ofkP3om^h04@3om^h01@3D?AT0ooK^0000003om^h0e3dI01H0
ooK^00<0e3dI0?ofkP3om^h07@3om^h00`000000ooK^0?ofkP0a0?ofkP40oooo000d0?ofkP030000
003om^h0ooK^01`0ooK^00<0e3dI0?ofkP3om^h0503om^h01@3D?AT0ooK^0000003om^h0e3dI01<0
ooK^00<0e3dI0?ofkP3om^h04@3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00h0ooK^0`0000000`3C
>aT0?EV[0=<k6@030=<k6@80?EV[0`3C>aT00`000000dc/I0=<k6@040=<k6@<0?EV[00<000000=<k
6@3C>aT0203C>aT00`0mFJ/0dc/I0=<k6@090=<k6@050000003C>aT0dc/I0=<k6@0mFJ/01P3C>aT0
0`000000dc/I0=<k6@060=<k6A/0?EV[203C>aT00`000000dc/I0=<k6@040=<k6@0503eIZ`3C>aT0
dc/I0=<k6@0000002`3C>aT00`0mFJ/0dc/I0=<k6@080=<k6@040000000mFJ/0?EV[03eIZ`H0dc/I
00H000000=<k6@3C>aT0?EV[0=<k6@0mFJ/40=<k6@0303eIZ`3C>aT00000008000003P3om^h01@3D
?AT0ooK^0?ofkP3om^h0e3dI01<0ooK^00<0e3dI0?ofkP3om^h04@3om^h01@3D?AT0ooK^0000003o
m^h0e3dI01H0ooK^00<0e3dI0?ofkP3om^h0703om^h00`000000ooK^0?ofkP0b0?ofkP40oooo000d
0?ofkP030000003om^h0ooK^01`0ooK^00<0e3dI0?ofkP3om^h0503om^h01@3D?AT0ooK^0?ofkP00
0000e3dI01<0ooK^00<0e3dI0?ofkP3om^h04@3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00h0ooK^
0`0000000`3C>aT0?EV[0=<k6@030=<k6@0303eIZ`3C>aT0?EV[0080dc/I00<000000=<k6@3C>aT0
103C>aT00`0mFJ/0dc/I0=<k6@0203eIZ`T0dc/I00<0?EV[0=<k6@3C>aT02@3C>aT01@000000dc/I
0=<k6@3C>aT0?EV[00H0dc/I00<000000=<k6@3C>aT0203C>aT00`000000?EV[0=<k6@080=<k6@03
0000003C>aT0dc/I00L0dc/I00<0?EV[0000003C>aT02@3C>aT00`000000dc/I0=<k6@040=<k6@05
03eIZ`3C>aT0dc/I0=<k6@0000002`3C>aT00`0mFJ/0dc/I0=<k6@070=<k6@80?EV[0P3C>aT00`0m
FJ/0dc/I0=<k6@040=<k6@060000003C>aT0dc/I03eIZ`3C>aT0?EV[103C>aT00`0mFJ/0dc/I0000
0002000000h0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0C0?ofkP030=@m6@3om^h0ooK^0140ooK^
00D0e3dI0000003om^h0ooK^0=@m6@0F0?ofkP030=@m6@3om^h0ooK^01`0ooK^00<000000?ofkP3o
m^h0<P3om^h10?ooo`00=03om^h00`000000ooK^0?ofkP0L0?ofkP030=@m6@3om^h0ooK^01@0ooK^
00D0e3dI0?ofkP3om^h000000=@m6@0C0?ofkP030=@m6@3om^h0ooK^0140ooK^00D0e3dI0?ofkP3o
m^h0ooK^0=@m6@0?0?ofkP040000000A6Ch0000003eIZ`D0dc/I0P0mFJ/20=<k6@030000003C>aT0
dc/I00@0dc/I00D0?EV[0=<k6@3C>aT0dc/I0000000203eIZ`L0dc/I00<0?EV[0000003C>aT02@3C
>aT01@000000dc/I0=<k6@3C>aT0?EV[00H0dc/I00<000000=<k6@3C>aT0203C>aT00`000000?EV[
0=<k6@080=<k6@030000003C>aT0dc/I00L0dc/I00<0?EV[0000003C>aT02@3C>aT00`000000dc/I
0=<k6@040=<k6@0503eIZ`3C>aT0dc/I0=<k6@0000002P3C>aT00`000000?EV[0=<k6@060=<k6@80
?EV[00D000000=<k6@3C>aT0dc/I03eIZ`060=<k6@030000003C>aT0dc/I0080?EV[1@3C>aT0100m
FJ/0000004MY^`00000?0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT04P3om^h20=@m6A80ooK^00<0
e3dI0?ofkP0000000P3om^h00`3D?AT0ooK^0?ofkP0D0?ofkP030=@m6@3om^h0ooK^01`0ooK^00<0
00000?ofkP3om^h0<P3om^h10?ooo`00=@3om^h00`000000ooK^0?ofkP0K0?ofkUX0e3dI00<0?EV[
0=<k6@3C>aT00`3C>aT203eIZ`80dc/I00<000000=<k6@3C>aT0103C>aT01@0mFJ/0dc/I0=<k6@3C
>aT000000080dc/I00<0?EV[0=<k6@3C>aT0103C>aT00`0mFJ/000000=<k6@090=<k6@050000003C
>aT0dc/I0=<k6@0mFJ/01P3C>aT00`000000dc/I0=<k6@080=<k6@030000000mFJ/0dc/I00P0dc/I
00<000000=<k6@3C>aT01`3C>aT00`0mFJ/000000=<k6@090=<k6@030000003C>aT0dc/I00@0dc/I
00D0?EV[0=<k6@3C>aT0dc/I0000000:0=<k6@030000000mFJ/0dc/I00D0dc/I00@0?EV[0=<k6@3C
>aT000000`3C>aT00`0mFJ/0dc/I0=<k6@040=<k6@030000003C>aT0dc/I0080?EV[1@3C>aT00`0m
FJ/0e3dI0=@m6@1H0=@m6Ad0ooK^00<000000?ofkP3om^h0<`3om^h10?ooo`00=@3om^h00`000000
ooK^0?ofkP0K0?ofkP030=@m6@3om^h0ooK^01@0ooK^00H0e3dI0?ofkP3om^h000000?ofkP3D?ATB
0?ofkP80e3dI4P3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00l0ooK^0`0000070=<k6@0503eIZ`3C
>aT0dc/I0=<k6@0000001@3C>aT01@0mFJ/0dc/I0=<k6@3C>aT0000000<0dc/I0P0mFJ/40=<k6@03
03eIZ`000000dc/I00T0dc/I00D000000=<k6@3C>aT0dc/I03eIZ`060=<k6@030000003C>aT0dc/I
00P0dc/I00<0000003eIZ`3C>aT0203C>aT00`000000dc/I0=<k6@070=<k6@0303eIZ`000000dc/I
00T0dc/I00<000000=<k6@3C>aT0103C>aT01@0mFJ/0dc/I0=<k6@3C>aT0000000X0dc/I00<00000
03eIZ`3C>aT00`3C>aT203eIZ`<0dc/I00D000000=<k6@3C>aT0dc/I03eIZ`050=<k6@050000003C
>aT0dc/I0=<k6@0mFJ/01`3C>aT3000000l0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0B0?ofkP80
e3dI4P3om^h00`3D?AT0ooK^000000020?ofkP030=@m6@3om^h0ooK^01@0ooK^00<0e3dI0?ofkP3o
m^h06`3om^h00`000000ooK^0?ofkP0c0?ofkP40oooo000e0?ofkP030000003om^h0ooK^01/0ooK^
00<0e3dI0?ofkP3om^h0503om^h01P3D?AT0ooK^0?ofkP000000ooK^0=@m6A80ooK^0P3D?ATB0?of
kP050=@m6@3om^h0ooK^0?ofkP3D?AT03`3om^h200000003014I?P000000dc/I00D0dc/I0P0mFJ/2
0=<k6@030000003C>aT0dc/I00<0dc/I00D0?EV[0=<k6@3C>aT0dc/I000000050=<k6@80?EV[0P3C
>aT00`0mFJ/000000=<k6@0:0=<k6@040000003C>aT0dc/I03eIZ`L0dc/I00<000000=<k6@3C>aT0
1`3C>aT00`000000?EV[0=<k6@080=<k6@030000003C>aT0dc/I00L0dc/I00<0?EV[0000003C>aT0
203C>aT00`000000dc/I0=<k6@040=<k6@0503eIZ`3C>aT0dc/I0=<k6@0000002`3C>aT010000000
?EV[0=<k6@3C>aT203eIZ`D0dc/I00D000000=<k6@3C>aT0dc/I03eIZ`050=<k6@030000003C>aT0
dc/I0080?EV[1P3C>aT010000000AfVk00000000000?0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT0
4P3om^h20=@m6A80ooK^00<0e3dI0?ofkP0000000P3om^h00`3D?AT0ooK^0?ofkP0D0?ofkP030=@m
6@3om^h0ooK^01/0ooK^00<000000?ofkP3om^h0<`3om^h10?ooo`00=P3om^h00`000000ooK^0?of
kP0J0?ofkP030=@m6@3om^h0ooK^01@0ooK^00H0e3dI0?ofkP3om^h0ooK^0000003D?ATB0?ofkP80
e3dI4P3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00l0ooK^100000060=<k6@0503eIZ`3C>aT0?EV[
0=<k6@0000001@3C>aT00`0mFJ/0dc/I0=<k6@020=<k6@030000003C>aT0dc/I00@0dc/I0`0mFJ/0
0`3C>aT000000=<k6@090=<k6@050000003C>aT0dc/I0=<k6@0mFJ/01P3C>aT00`000000dc/I0=<k
6@070=<k6@030000000mFJ/0dc/I00P0dc/I00<000000=<k6@3C>aT01`3C>aT00`0mFJ/000000=<k
6@080=<k6@030000003C>aT0dc/I00@0dc/I00D0?EV[0=<k6@3C>aT0dc/I0000000:0=<k6@030000
003C>aT0?EV[0080?EV[1P3C>aT00`000000dc/I0=<k6@020=<k6@0303eIZ`3C>aT0dc/I00<0dc/I
00D000000=<k6@0mFJ/0dc/I03eIZ`060=<k6@@000003`3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI
0180ooK^0P3D?ATB0?ofkP030=@m6@000000ooK^0080ooK^00<0e3dI0?ofkP3om^h0503om^h00`3D
?AT0ooK^0?ofkP0J0?ofkP030000003om^h0ooK^03@0ooK^0@3oool003H0ooK^00<000000?ofkP3o
m^h06P3om^h00`3D?AT0ooK^0?ofkP0D0?ofkP060=@m6@3om^h0ooK^0?ofkP000000e3dI4P3om^h2
0=@m6A80ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0?0?ofkP<0000000<04ATn0000003C>aT0103C
>aT01P0mFJ/0dc/I0=<k6@0mFJ/0dc/I000000D0dc/I00D0?EV[0=<k6@3C>aT0dc/I000000080=<k
6@80?EV[00<000000=<k6@3C>aT0203C>aT01@000000dc/I0=<k6@3C>aT0?EV[00H0dc/I00<00000
0=<k6@3C>aT01`3C>aT00`000000?EV[0=<k6@080=<k6@030000003C>aT0dc/I00L0dc/I00<0?EV[
0000003C>aT0203C>aT00`000000dc/I0=<k6@040=<k6@0503eIZ`3C>aT0dc/I0=<k6@0000002P3C
>aT00`000000?EV[03eIZ`080=<k6@050000003C>aT0dc/I0=<k6@0mFJ/01@3C>aT00`000000dc/I
03eIZ`020=<k6@0303eIZ`3C>aT0dc/I00<0dc/I00<0000004MY^`0000000P00000?0?ofkP050=@m
6@3om^h0ooK^0?ofkP3D?AT04P3om^h20=@m6A80ooK^00<0e3dI0000003om^h00P3om^h00`3D?AT0
ooK^0?ofkP0D0?ofkP030=@m6@3om^h0ooK^01X0ooK^00<000000?ofkP3om^h0=03om^h10?ooo`00
=P3om^h00`000000ooK^0?ofkP0J0?ofkP030=@m6@3om^h0ooK^01@0ooK^00H0e3dI0?ofkP3om^h0
ooK^0000003D?ATB0?ofkP80e3dI4P3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00l0ooK^0`000000
0`0A6Ch00000000000040000000503eIZ`00000000000000000mFJ/01P0000000`0mFJ/000000000
000:0000000303eIZ`000000?EV[0080?EV[300000000`0mFJ/000000000000?0000000303eIZ`00
000000000100000000<0?EV[000000000000400000000`0mFJ/000000000000:000000<0?EV[00<0
000003eIZ`0000002`0000000`0mFJ/00000000000040000000503eIZ`00000000000000000mFJ/0
1`0000000`17JK/000000000000?0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT04P3om^h20=@m6A80
ooK^00<0e3dI0000003om^h00P3om^h00`3D?AT0ooK^0?ofkP0D0?ofkP030=@m6@3om^h0ooK^01X0
ooK^00<000000?ofkP3om^h0=03om^h10?ooo`00=`3om^h00`000000ooK^0?ofkP0I0?ofkP030=@m
6@3om^h0ooK^01@0ooK^00D0e3dI0?ofkP3om^h0ooK^0000000k0=@m6@80000000@04ATn00000000
00000000103M?QX00`0mFJ/0gChJ0=dn6P020=dn6P80?EV[103M?QX01@0mFJ/0gChJ0=dn6P3M?QX0
000000P0gChJ00<0?EV[0=dn6P0000000P3M?QX303eIZ`D0gChJ00D000000=dn6P3M?QX0gChJ03eI
Z`060=dn6P030000003M?QX0gChJ00L0gChJ00<000000=dn6P0mFJ/0203M?QX00`000000gChJ0=dn
6P060=dn6P0303eIZ`3M?QX0000000T0gChJ00<000000=dn6P3M?QX0103M?QX01@0mFJ/0gChJ0=dn
6P3M?QX0000000D0gChJ0`0mFJ/20=dn6P030000003M?QX0?EV[00P0gChJ00D000000=dn6P3M?QX0
gChJ03eIZ`040=dn6P80?EV[103M?QX00`0mFJ/0gChJ0=dn6P020=dn6P<0000000<0AfVk00000000
0000>`3D?AT01@000000ooK^0?ofkP3om^h0e3dI01H0ooK^00<0e3dI0?ofkP3om^h06@3om^h00`00
0000ooK^0?ofkP0e0?ofkP40oooo000g0?ofkP030000003om^h0ooK^01T0ooK^00<0e3dI0?ofkP3o
m^h0503om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^0100ooK^0P3D?ATB0?ofkP05
0=@m6@3om^h0ooK^0?ofkP3D?AT03`3om^h200000004014I?P0000000000000000@0gChJ00<0?EV[
0=dn6P3M?QX00`3M?QX00`000000?EV[0=dn6P020=dn6P0303eIZ`3M?QX0gChJ0080gChJ00<00000
0=dn6P3M?QX01@3M?QX0100mFJ/0gChJ0=dn6P0000040=dn6P80?EV[0`3M?QX01@000000gChJ0=dn
6P3M?QX0?EV[00H0gChJ00<000000=dn6P3M?QX01`3M?QX00`000000gChJ03eIZ`080=dn6P030000
003M?QX0gChJ00H0gChJ00<0?EV[0=dn6P0000002@3M?QX00`000000gChJ0=dn6P040=dn6P0503eI
Z`3M?QX0gChJ0=dn6P0000000`3M?QX203eIZ`@0gChJ00@000000=dn6P3M?QX0?EV[1`3M?QX00`00
0000gChJ0=dn6P020=dn6P0603eIZ`3M?QX0gChJ0=dn6P0mFJ/000001@3M?QX00`0mFJ/0gChJ0=dn
6P020=dn6P<0000000<0AfVk0000000000003`3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI0180ooK^
0P3D?ATB0?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h0503om^h00`3D?AT0ooK^
0?ofkP0I0?ofkP030000003om^h0ooK^03D0ooK^0@3oool003L0ooK^00<000000?ofkP3om^h06@3o
m^h00`3D?AT0ooK^0?ofkP0D0?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h0403o
m^h20=@m6A80ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0?0?ofkP<0000000@04ATn0000000G8eD0
00000`3M?QX00`0mFJ/0gChJ0=dn6P030=dn6P030000003M?QX0?EV[0080gChJ00<0?EV[0=dn6P3M
?QX00P3M?QX00`000000gChJ0=dn6P050=dn6P0403eIZ`3M?QX0gChJ000000H0gChJ0`0mFJ/01@3M
?QX000000=dn6P3M?QX0?EV[00H0gChJ00<000000=dn6P3M?QX01`3M?QX00`000000gChJ03eIZ`08
0=dn6P030000003M?QX0gChJ00H0gChJ00<0?EV[0=dn6P0000002@3M?QX00`000000gChJ0=dn6P04
0=dn6P0503eIZ`3M?QX0gChJ0000003M?QX00`0mFJ/60=dn6P040000003M?QX0gChJ03eIZ`L0gChJ
00<000000=dn6P3M?QX00P3M?QX01P0mFJ/0gChJ0=dn6P0mFJ/0gChJ000000@0gChJ00<0?EV[0=dn
6P3M?QX00P3M?QX30000000404MY^`0000000000000000l0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m
6@0B0?ofkP80e3dI4P3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^01@0ooK^00<0
e3dI0?ofkP3om^h06@3om^h00`000000ooK^0?ofkP0e0?ofkP40oooo000h0?ofkP030000003om^h0
ooK^01L0ooK^00<0e3dI0?ofkP3om^h05@3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0
ooK^0100ooK^0P3D?ATB0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT03`3om^h300000004014I?P00
00000000000000@0gChJ00<0?EV[0=dn6P3M?QX00`3M?QX01@000000gChJ03eIZ`3M?QX0?EV[00D0
gChJ00<000000=dn6P3M?QX0103M?QX0100mFJ/0gChJ0=dn6P0000090=dn6P<0?EV[00<0gChJ03eI
Z`3M?QX01P3M?QX00`000000gChJ0=dn6P060=dn6P030000003M?QX0?EV[00P0gChJ00<000000=dn
6P3M?QX01P3M?QX00`0mFJ/0gChJ000000080=dn6P030000003M?QX0gChJ00D0gChJ00<0?EV[0=dn
6P0mFJ/00P0mFJ/90=dn6P040000003M?QX0gChJ03eIZ`H0gChJ00<000000=dn6P3M?QX00`3M?QX0
1@0mFJ/0gChJ03eIZ`3M?QX0000000D0gChJ00<0?EV[0=dn6P3M?QX00P3M?QX30000000404MY^`00
00000000000000l0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0B0?ofkP80e3dI4P3om^h00`3D?AT0
ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^01@0ooK^00<0e3dI0?ofkP3om^h0603om^h00`000000
ooK^0?ofkP0f0?ofkP40oooo000h0?ofkP030000003om^h0ooK^01L0ooK^00<0e3dI0?ofkP3om^h0
5@3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^0100ooK^0P3D?ATB0?ofkP050=@m
6@3om^h0ooK^0?ofkP3D?AT03`3om^h400000004014I?P0000005b=E000000<0gChJ00<0?EV[0=dn
6P3M?QX00`3M?QX00`000000gChJ0=dn6P0203eIZ`D0gChJ00<000000=dn6P3M?QX0103M?QX01@0m
FJ/0gChJ0=dn6P3M?QX0000000T0gChJ00<000000=dn6P0mFJ/0100mFJ/40=dn6P030000003M?QX0
gChJ00H0gChJ00<000000=dn6P0mFJ/0203M?QX00`000000gChJ0=dn6P060=dn6P0303eIZ`3M?QX0
000000P0gChJ00<000000=dn6P3M?QX00P3M?QX503eIZ`030=dn6P000000gChJ00P0gChJ00D00000
0=dn6P3M?QX0gChJ03eIZ`060=dn6P030000003M?QX0gChJ00<0gChJ0P0mFJ/20=dn6P030000003M
?QX0gChJ00<0gChJ00P0?EV[0=dn6P3M?QX0gChJ0000001@MML0000004MY^`@000003`3om^h01@3D
?AT0ooK^0?ofkP3om^h0e3dI0180ooK^0P3D?ATB0?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI
0?ofkP3om^h05@3om^h00`3D?AT0ooK^0?ofkP0G0?ofkP030000003om^h0ooK^03H0ooK^0@3oool0
03P0ooK^00<000000?ofkP3om^h05`3om^h00`3D?AT0ooK^0?ofkP0E0?ofkP030=@m6@3om^h0ooK^
0080ooK^00<0e3dI0?ofkP3om^h0403om^h20=@m6A80ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0?
0?ofkP@0000000P04ATn0000000G8eD000000=dn6P0mFJ/0gChJ03eIZ`H0gChJ00@000000=dn6P3M
?QX0?EV[1@3M?QX00`000000gChJ0=dn6P040=dn6P0503eIZ`3M?QX0gChJ0=dn6P0000002@3M?QX0
10000000gChJ0=dn6P0mFJ/30=dn6PH0?EV[1`3M?QX00`000000gChJ03eIZ`080=dn6P030000003M
?QX0gChJ00H0gChJ00<0?EV[0=dn6P0000001`3M?QX603eIZ`<0gChJ00@0?EV[0=dn6P3M?QX00000
2@3M?QX01@000000gChJ0=dn6P3M?QX0?EV[00H0gChJ00<000000=dn6P3M?QX00`3M?QX0100mFJ/0
gChJ0=dn6P0000060=dn6P0803eIZ`3M?QX0?EV[0=dn6P000000D7GG00000017JK/4000000l0ooK^
00D0e3dI0?ofkP3om^h0ooK^0=@m6@0B0?ofkP80e3dI4P3om^h00`3D?AT0ooK^0?ofkP020?ofkP03
0=@m6@3om^h0ooK^01D0ooK^00<0e3dI0?ofkP3om^h05`3om^h00`000000ooK^0?ofkP0f0?ofkP40
oooo000i0?ofkP030000003om^h0ooK^01H0ooK^00<0e3dI0?ofkP3om^h05@3om^h00`3D?AT0ooK^
0?ofkP020?ofkP030=@m6@000000ooK^0100ooK^0P3D?ATB0?ofkP050=@m6@3om^h0ooK^0?ofkP3D
?AT03`3om^h300000003014I?P000000000000805b=E00@0e3dI03eIZ`3M?QX0?EV[1P3M?QX00`00
0000gChJ0=dn6P0303eIZ`@0gChJ00<000000=dn6P3M?QX00`3M?QX01@0mFJ/0gChJ0=dn6P3M?QX0
000000X0gChJ00<000000=dn6P0mFJ/01`3M?QX00`000000gChJ03eIZ`0503eIZ`80gChJ00<00000
03eIZ`3M?QX01`3M?QX00`000000gChJ0=dn6P060=dn6P0403eIZ`000000gChJ0=dn6PH0?EV[00<0
gChJ0000003M?QX01P3M?QX00`0mFJ/0gChJ0000000:0=dn6P040000003M?QX0gChJ03eIZ`H0gChJ
00<000000=dn6P3M?QX00P3M?QX303eIZ`80gChJ00<000000=dn6P3M?QX0103M?QX0100mFJ/0gChJ
03eIZ`3D?AT2051ee`80000000@0AfVk00000000000000003`3om^h01@3D?AT0ooK^0?ofkP3om^h0
e3dI0180ooK^0P3D?ATA0?ofkP030000003D?AT0ooK^00<0ooK^00<0e3dI0?ofkP3om^h05@3om^h0
0`3D?AT0ooK^0?ofkP0F0?ofkP030000003om^h0ooK^03L0ooK^0@3oool003T0ooK^00<000000?of
kP3om^h05P3om^h00`3D?AT0ooK^0?ofkP0E0?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0000
003om^h0403om^h20=@m6A80ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0?0?ofkP040=@m6@000000
0000014I?P<0000000<05b=E0=@m6@3M?QX00P0mFJ/70=dn6P030000003M?QX0?EV[0080gChJ00D0
?EV[0=dn6P3M?QX0gChJ000000060=dn6P0403eIZ`3M?QX0gChJ000000X0gChJ00<000000=dn6P0m
FJ/01`3M?QX00`000000gChJ0=dn6P050=dn6QT0?EV[1`3M?QX00`000000gChJ0=dn6P050=dn6P03
03eIZ`3M?QX0000000X0gChJ00@000000=dn6P3M?QX0?EV[1P3M?QX01@000000gChJ0=dn6P3M?QX0
?EV[0080gChJ00<0?EV[0=dn6P0000001`3M?QX203eIZ`030=dn6P3D?AT0D7GG00<0000000@0AfVk
000000000000e3dI3`3om^h0103D?AT0ooK^0?ofkP3D?ATC0?ofkP80e3dI4@3om^h00`000000e3dI
0?ofkP030?ofkP030=@m6@3om^h0ooK^01D0ooK^00<0e3dI0?ofkP3om^h05P3om^h00`000000ooK^
0?ofkP0g0?ofkP40oooo000i0?ofkP030000003om^h0ooK^01H0ooK^00<0e3dI0?ofkP3om^h05@3o
m^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@000000ooK^0100ooK^0P3D?ATC0?ofkP040=@m6@3o
m^h0ooK^0=@m6@l0ooK^00<0e3dI0000000000000P0A6Ch20000000301LSE@3D?AT000000080?EV[
1`3M?QX00`000000gChJ03eIZ`030=dn6P80?EV[00<0gChJ0000003M?QX01@3M?QX01@0mFJ/0gChJ
0=dn6P3M?QX0000000T0gChJ00<000000=dn6P0mFJ/01`3M?QX00`000000gChJ0=dn6P070=dn6P03
0000000mFJ/0gChJ00L0gChJ00<000000=dn6P3M?QX01P3M?QX00`0mFJ/000000=dn6P080=dn6P03
0000003M?QX0gChJ00D0gChJ00<0?EV[0=dn6P0000002@3M?QX01@000000gChJ0=dn6P3M?QX0?EV[
00H0gChJ00@000000=dn6P0mFJ/0?EV[0`3M?QX00`0mFJ/0gChJ000000070=dn6P80?EV[00<00000
0=@m6@1@MML00P00000204MY^`80000000<0e3dI0?ofkP3om^h03@3om^h0103D?AT0ooK^0?ofkP3D
?ATC0?ofkP80e3dI4@3om^h00`000000e3dI0?ofkP030?ofkP030=@m6@3om^h0ooK^01D0ooK^00<0
e3dI0?ofkP3om^h05P3om^h00`000000ooK^0?ofkP0g0?ofkP40oooo000i0?ofkP030000003om^h0
ooK^01H0ooK^00<0e3dI0?ofkP3om^h05@3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@000000
ooK^0100ooK^0P3D?ATC0?ofkP040=@m6@3om^h0ooK^0=@m6@l0ooK^00D0e3dI0000000000000000
014I?P03000000040=@m6@000000gChJ03eIZ`P0gChJ00<0000003eIZ`3M?QX0103M?QX00`0mFJ/0
gChJ000000050=dn6P0503eIZ`3M?QX0gChJ0=dn6P0000002@3M?QX00`000000gChJ03eIZ`080=dn
6P030000003M?QX0gChJ00H0gChJ00<0000003eIZ`3M?QX01`3M?QX00`000000gChJ0=dn6P060=dn
6P0303eIZ`000000gChJ00L0gChJ00<000000=dn6P3M?QX01P3M?QX00`0mFJ/0gChJ000000090=dn
6P050000003M?QX0gChJ0=dn6P0mFJ/01@3M?QX00`000000gChJ03eIZ`050=dn6P0303eIZ`000000
gChJ00L0gChJ00@0?EV[0=dn6P000000e3dI0`0000001@17JK/00000000000000000e3dI00l0ooK^
00@0e3dI0?ofkP3om^h0e3dI4`3om^h20=@m6A40ooK^00<000000=@m6@3om^h00`3om^h00`3D?AT0
ooK^0?ofkP0E0?ofkP030=@m6@3om^h0ooK^01H0ooK^00<000000?ofkP3om^h0=`3om^h10?ooo`00
>P3om^h00`000000ooK^0?ofkP0E0?ofkP030=@m6@3om^h0ooK^01D0ooK^00<0e3dI0?ofkP3om^h0
0P3om^h00`3D?AT0ooK^0000000@0?ofkP80e3dI4`3om^h0103D?AT0ooK^0?ofkP3D?AT?0?ofkP04
0=@m6@0000000000000000804ATn0P0000000`3D?AT05b=E0000000203eIZ`L0gChJ00<0000003eI
Z`3M?QX01@3M?QX203eIZ`D0gChJ00D0?EV[0=dn6P3M?QX0gChJ0000000:0=dn6P030000000mFJ/0
gChJ00L0gChJ00<000000=dn6P3M?QX01P3M?QX00`000000?EV[0=dn6P070=dn6P030000003M?QX0
gChJ00H0gChJ00<0?EV[0000003M?QX01`3M?QX00`000000gChJ0=dn6P060=dn6P0303eIZ`000000
gChJ00T0gChJ00D000000=dn6P3M?QX0gChJ03eIZ`050=dn6P80?EV[1P3M?QX00`0mFJ/000000=dn
6P060=dn6P80?EV[00<00000051ee`3D?AT00P00000204MY^`<0000000<0e3dI0?ofkP3om^h03@3o
m^h0103D?AT0ooK^0?ofkP3D?ATC0?ofkP80e3dI403om^h00`000000ooK^0=@m6@040?ofkP030=@m
6@3om^h0ooK^01D0ooK^00<0e3dI0?ofkP3om^h05@3om^h00`000000ooK^0?ofkP0h0?ofkP40oooo
000j0?ofkP030000003om^h0ooK^01D0ooK^00<0e3dI0?ofkP3om^h05@3om^h00`3D?AT0ooK^0?of
kP020?ofkP030=@m6@3om^h000000100ooK^0P3D?ATC0?ofkP040=@m6@3om^h0ooK^0=@m6@l0ooK^
00@0e3dI00000000000000000P0A6Ch0200000005b=E0=@m6@0G8eD0000003eIZ`3M?QX0?EV[1`3M
?QX00`0mFJ/0gChJ0=dn6P060=dn6P80?EV[00@0e3dI0=dn6P3M?QX0?EV[103M?QX00`000000gChJ
0=dn6P070=dn6P030000000mFJ/0gChJ0080gChJ00<0e3dI0=dn6P3M?QX00P3M?QX00`000000gChJ
0=dn6P060=dn6P030000000mFJ/0gChJ00L0gChJ00<0e3dI0=dn6P3M?QX01P3M?QX00`0mFJ/00000
0=dn6P070=dn6P030000003M?QX0gChJ0080gChJ00H0e3dI0=dn6P3M?QX0gChJ03eIZ`0000090=dn
6P030000003M?QX0gChJ0080gChJ00@0?EV[0=dn6P3M?QX0gChJ0P0mFJ/80=dn6P0303eIZ`3M?QX0
gChJ00D0gChJ00P0?EV[0=dn6P0mFJ/00000051ee`3D?AT0D7GG00000080AfVk0`0000000`3D?AT0
ooK^0?ofkP0=0?ofkP040=@m6@3om^h0ooK^0=@m6A<0ooK^0P3D?AT@0?ofkP030000003om^h0e3dI
00@0ooK^00<0e3dI0?ofkP3om^h05@3om^h00`3D?AT0ooK^0?ofkP0E0?ofkP030000003om^h0ooK^
03P0ooK^0@3oool003X0ooK^00<000000?ofkP3om^h05@3om^iS0=@m6@<0000000<0?EV[00000000
0000100000000`0mFJ/00000000000080000000403eIZ`000000000003eIZ`l0000000<0?EV[0000
00000000400000000`0mFJ/000000000000?0000000303eIZ`000000000000l0000000<0?EV[0000
000000003P000000100mFJ/000000000000mFJ/:0000000303eIZ`000000000000@0000000@0?EV[
0000000000000000H`3D?ATG0?ofkP030000003om^h0ooK^03P0ooK^0@3oool003/0ooK^00<00000
0?ofkP3om^h0503om^h00`3D?AT0ooK^0?ofkP0E0?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI
0?ofkP000000403om^h20=@m6A<0ooK^00@0e3dI0?ofkP3om^h0e3dI3`3om^h00`3D?AT000000000
000200000006014I?P00000000000=@m6@0000005b=E0P0000020>E16`0303eIZ`3U@A/0iD4K00@0
iD4K00<0?EV[0>E16`3U@A/01@3U@A/00`000000iD4K0>E16`0303eIZ`@0iD4K00<000000>E16`3U
@A/01`3U@A/00`000000iD4K03eIZ`070>E16`030000003U@A/0iD4K00H0iD4K00<0000003eIZ`3U
@A/01`3U@A/00`000000iD4K0>E16`060>E16`0303eIZ`000000iD4K00L0iD4K00<000000>E16`3U
@A/01@3U@A/00`0mFJ/0iD4K000000090>E16`030000003U@A/0iD4K0080iD4K0`0mFJ/20>E16`03
0000003U@A/0iD4K00D0iD4K00<0?EV[0>E16`3U@A/0103U@A/00`0mFJ/0iD4K0>E16`0200000003
051ee`000000e3dI0080000000H0AfVk00000000000000000?ofkP3D?AT?0?ofkP040=@m6@3om^h0
ooK^0=@m6A<0ooK^0P3D?AT@0?ofkP030000003om^h0e3dI00@0ooK^00<0e3dI0?ofkP3om^h05@3o
m^h00`3D?AT0ooK^0?ofkP0D0?ofkP030000003om^h0ooK^03T0ooK^0@3oool003/0ooK^00<00000
0?ofkP3om^h0503om^h00`3D?AT0ooK^0?ofkP0E0?ofkP030=@m6@3om^h0ooK^0080ooK^?@3D?AT2
00000007014I?P00000000000000003D?AT0000001LSE@02000000<0iD4K00<0?EV[0>E16`3U@A/0
0`3U@A/00`0mFJ/0iD4K0>E16`060>E16`040000003U@A/0iD4K0>E16`80?EV[103U@A/00`000000
iD4K0>E16`060>E16`030000003U@A/0?EV[00L0iD4K00<000000>E16`3U@A/01P3U@A/00`000000
?EV[0>E16`070>E16`030000003U@A/0iD4K00H0iD4K00<0?EV[0000003U@A/01`3U@A/00`000000
iD4K0>E16`050>E16`0303eIZ`3U@A/0000000P0iD4K00<000000>E16`3U@A/00P3U@A/203eIZ`<0
iD4K00<000000>E16`3U@A/01P3U@A/00`0mFJ/0iD4K0>E16`030>E16`0403eIZ`3U@A/0iD4K0>E1
6`80000000@0D7GG0000003D?AT0D7GG0P0000000`17JK/000000000000m0=@m6@@0ooK^00<0e3dI
0?ofkP3om^h05@3om^h00`3D?AT0ooK^0?ofkP0D0?ofkP030000003om^h0ooK^03T0ooK^0@3oool0
03/0ooK^00<000000?ofkP3om^h0503om^h00`3D?AT0ooK^0?ofkP0E0?ofkP030=@m6@3om^h0ooK^
0080ooK^00@0e3dI0?ofkP3om^h000003`3om^h20=@m6A<0ooK^00@0e3dI0?ofkP3om^h0e3dI3`3o
m^h00`3D?AT0ooK^000000040000000301LSE@3D?AT05b=E0080000000<07c9`0000003U@A/00P3U
@A/00`0mFJ/0iD4K0>E16`020>E16`0303eIZ`000000iD4K00H0iD4K00H000000>E16`3U@A/0iD4K
03eIZ`3U@A/303eIZ`030>E16`000000iD4K00P0iD4K00<0000003eIZ`3U@A/01P3U@A/00`000000
iD4K0>E16`060>E16`030000000mFJ/0iD4K00L0iD4K00<000000>E16`3U@A/01P3U@A/00`0mFJ/0
00000>E16`070>E16`030000003U@A/0iD4K00D0iD4K00<0?EV[0000003U@A/0203U@A/00`000000
iD4K03eIZ`0203eIZ`030>E16`0mFJ/0iD4K0080iD4K00<000000>E16`3U@A/01@3U@A/00`000000
?EV[0>E16`030>E16`0603eIZ`3U@A/0iD4K0>E16`000000E7cV0P0000000`1@MML0e3dI051ee`05
000000030?ofkP3D?AT0ooK^00h0ooK^00@0e3dI0?ofkP3om^h0e3dI4`3om^h20=@m6@l0ooK^00@0
00000?ofkP3om^h0e3dI103om^h00`3D?AT0ooK^0?ofkP0E0?ofkP030=@m6@3om^h0ooK^01@0ooK^
00<000000?ofkP3om^h0>@3om^h10?ooo`00?03om^h00`000000ooK^0?ofkP0C0?ofkP030=@m6@3o
m^h0ooK^01D0ooK^00<0e3dI0?ofkP3om^h00P3om^h0103D?AT0ooK^0?ofkP00000?0?ofkP80e3dI
4`3om^h0103D?AT0ooK^0?ofkP3D?AT?0?ofkP030=@m6@3om^h0000000@0000000<05b=E0=@m6@0G
8eD00P0000000`0O<W0000000>E16`030>E16`0603eIZ`3U@A/0iD4K0>E16`0mFJ/00000203U@A/0
10000000iD4K0>E16`0mFJ/40>E16`<0?EV[203U@A/00`000000?EV[0>E16`070>E16`030000003U
@A/0iD4K00D0iD4K00<0000003eIZ`3U@A/01`3U@A/00`000000iD4K0>E16`060>E16`0303eIZ`00
0000iD4K00H0iD4K00<000000>E16`3U@A/01P3U@A/00`0mFJ/000000>E16`070>E16`<0?EV[103U
@A/0100mFJ/0iD4K0>E16`0000080>E16`030000000mFJ/0iD4K0080iD4K00<0?EV[0>E16`3U@A/0
0P3U@A/00`000000E7cV00000002000000030=@m6@1@MML0000000@0000000<0ooK^0=@m6@3om^h0
3P3om^h0103D?AT0ooK^0?ofkP3D?ATC0?ofkP80e3dI3`3om^h010000000ooK^0?ofkP3D?AT40?of
kP030=@m6@3om^h0ooK^01D0ooK^00<0e3dI0?ofkP3om^h04`3om^h00`000000ooK^0?ofkP0j0?of
kP40oooo000l0?ofkP030000003om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h05@3om^h00`3D?AT0
ooK^0?ofkP020?ofkP040=@m6@3om^h0ooK^000000l0ooK^0P3D?ATC0?ofkP040=@m6@3om^h0ooK^
0=@m6@l0ooK^00<0e3dI0?ofkP0000000P0000001`0A6Ch0000001LSE@3D?AT0000001LSE@000000
0P0O<W000`000000iD4K0>E16`020>E16`0603eIZ`3U@A/0iD4K03eIZ`3U@A/000001`3U@A/01000
0000iD4K0>E16`0mFJ/60>E16`030000000mFJ/0?EV[00H0iD4K00<0000003eIZ`3U@A/01`3U@A/0
0`000000iD4K0>E16`050>E16`030000000mFJ/0iD4K00L0iD4K00<000000>E16`3U@A/01P3U@A/0
0`0mFJ/000000>E16`060>E16`030000003U@A/0iD4K00H0iD4K00<0?EV[0000003U@A/01@3U@A/2
03eIZ`030000003U@A/0iD4K00@0iD4K00@0?EV[0>E16`3U@A/000001`3U@A/00`000000iD4K03eI
Z`020>E16`0303eIZ`3U@A/0iD4K0080iD4K00X0000005AliP1DO>H00000051ee`000000e3dI051e
e`000000AfVk0`0000000`3om^h0e3dI0?ofkP0>0?ofkP040=@m6@3om^h0ooK^0=@m6A<0ooK^0P3D
?AT?0?ofkP040000003om^h0ooK^0=@m6@@0ooK^00<0e3dI0?ofkP3om^h05@3om^h00`3D?AT0ooK^
0?ofkP0C0?ofkP030000003om^h0ooK^03X0ooK^0@3oool003`0ooK^00<000000?ofkP3om^h04`3o
m^h00`3D?AT0ooK^0?ofkP0E0?ofkP030=@m6@3om^h0ooK^0080ooK^00@0e3dI0?ofkP3om^h00000
3`3om^h20=@m6A<0ooK^00@0e3dI0?ofkP3om^h0e3dI3`3om^h00`3D?AT0ooK^0000000400000006
01LSE@3D?AT0000001LSE@000000?EV[0P0O<W000`000000iD4K0>E16`020>E16`0503eIZ`3U@A/0
?EV[0>E16`000000203U@A/00`000000iD4K03eIZ`060>E16`030000003U@A/0iD4K00<0?EV[0`3U
@A/00`000000?EV[0>E16`070>E16`030000003U@A/0iD4K00D0iD4K00<0000003eIZ`3U@A/01`3U
@A/00`000000iD4K0>E16`060>E16`0303eIZ`000000iD4K00H0iD4K00<000000>E16`3U@A/01P3U
@A/00`0mFJ/000000>E16`020>E16`<0?EV[0P3U@A/00`000000iD4K0>E16`040>E16`0303eIZ`3U
@A/0000000P0iD4K00D000000>E16`0mFJ/0iD4K03eIZ`040>E16`040000001DO>H0E7cV05AliP80
000000<0D7GG0=@m6@1@MML01@0000000`3om^h0e3dI0?ofkP0>0?ofkP040=@m6@3om^h0ooK^0=@m
6A<0ooK^0P3D?AT?0?ofkP040000003om^h0ooK^0=@m6@@0ooK^00<0e3dI0?ofkP3om^h05@3om^h0
0`3D?AT0ooK^0?ofkP0C0?ofkP030000003om^h0ooK^03X0ooK^0@3oool003d0ooK^00<000000?of
kP3om^h04P3om^h00`3D?AT0ooK^0?ofkP0E0?ofkP030=@m6@3om^h0ooK^0080ooK^00D0e3dI0?of
kP3om^h0ooK^0000000>0?ofkP80e3dI4`3om^h0103D?AT0ooK^0?ofkP3D?AT?0?ofkP030=@m6@3o
m^h0000000D0000000<0e3dI01LSE@0000000P00000201lbL0030000003U@A/0iD4K00<0iD4K0P0m
FJ/20>E16`030000003U@A/0iD4K00D0iD4K00<000000>E16`0mFJ/01`3U@A/00`000000iD4K0>E1
6`020>E16`<0?EV[00<0iD4K03eIZ`3U@A/01`3U@A/00`000000iD4K0>E16`060>E16`0303eIZ`3U
@A/0iD4K00H0iD4K00<000000>E16`3U@A/01P3U@A/00`0mFJ/0iD4K0>E16`060>E16`030000003U
@A/0iD4K00H0iD4K00<0?EV[0>E16`0mFJ/00P0mFJ/40>E16`030000003U@A/0iD4K00D0iD4K00<0
?EV[0>E16`0000001`3U@A/00`000000iD4K0>E16`0203eIZ`D0iD4K00<0000005AliP1DO>H00`00
00000`1@MML0e3dI00000005000000030?ofkP3D?AT0ooK^00h0ooK^00@0e3dI0?ofkP3om^h0e3dI
4`3om^h20=@m6@h0ooK^00D000000?ofkP3om^h0ooK^0=@m6@040?ofkP030=@m6@3om^h0ooK^01D0
ooK^00<0e3dI0?ofkP3om^h04P3om^h00`000000ooK^0?ofkP0k0?ofkP40oooo000m0?ofkP030000
003om^h0ooK^0180ooK^00<0e3dI0?ofkP3om^h05@3om^h00`3D?AT0ooK^0?ofkP020?ofkP050=@m
6@3om^h0ooK^0?ofkP0000003P3om^h20=@m6A<0ooK^00@0e3dI0?ofkP3om^h0e3dI3`3om^h00`3D
?AT0ooK^0?ofkP0200000005014I?P00000000000=@m6@0G8eD00`00000301lbL0030000003U@A/0
iD4K00<0iD4K00@0?EV[0>E16`3U@A/00000203U@A/00`000000?EV[0>E16`060>E16`030000003U
@A/0iD4K00D0iD4K100mFJ/60>E16`030000003U@A/0iD4K00H0iD4K00<0?EV[0>E16`3U@A/01P3U
@A/00`000000iD4K0>E16`060>E16`0303eIZ`3U@A/0iD4K00H0iD4K00<000000>E16`3U@A/0103U
@A/403eIZ`L0iD4K00<000000>E16`3U@A/01@3U@A/00`0mFJ/000000>E16`070>E16`040000003U
@A/0iD4K03eIZ`D0iD4K00H0000005AliP1DO>H0000005AliP000002051ee`040=@m6@0000000000
04MY^`8000000P3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP040=@m6@3om^h0ooK^0=@m6A<0ooK^0P3D
?AT>0?ofkP050000003om^h0ooK^0?ofkP3D?AT0103om^h00`3D?AT0ooK^0?ofkP0E0?ofkP030=@m
6@3om^h0ooK^0180ooK^00<000000?ofkP3om^h0>`3om^h10?ooo`00?@3om^h00`000000ooK^0?of
kP0C0?ofkP030=@m6@3om^h0ooK^01@0ooK^00<0e3dI0?ofkP3om^h00P3om^h01@3D?AT0ooK^0?of
kP3om^h0000000h0ooK^0P3D?ATB0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT03`3om^h00`3D?AT0
ooK^0?ofkP0200000004014I?P0000005b=E0=@m6@805b=E0`00000301lbL0030000003U@A/0iD4K
0080iD4K0`0mFJ/00`3U@A/000000>E16`060>E16`030000000mFJ/0iD4K00H0iD4K00<000000>E1
6`3U@A/01P3U@A/00`0mFJ/0iD4K0>E16`0603eIZ`030000003U@A/0iD4K00H0iD4K00<0?EV[0>E1
6`3U@A/01P3U@A/00`000000iD4K0>E16`060>E16`0303eIZ`3U@A/0iD4K00H0iD4K00<0000003eI
Z`0mFJ/0100mFJ/20>E16`0303eIZ`3U@A/0iD4K00H0iD4K00<000000>E16`3U@A/0103U@A/00`0m
FJ/0iD4K000000070>E16`030000003U@A/0?EV[0080?EV[103U@A/010000000E7cV05AliP1DO>H3
00000080D7GG00@0e3dI000000000000AfVk0P0000020?ofkP030=@m6@3om^h0ooK^00d0ooK^00@0
e3dI0?ofkP3om^h0e3dI4`3om^h20=@m6@h0ooK^00D000000?ofkP3om^h0ooK^0=@m6@040?ofkP03
0=@m6@3om^h0ooK^01@0ooK^00<0e3dI0?ofkP3om^h04`3om^h00`000000ooK^0?ofkP0k0?ofkP40
oooo000n0?ofkP030000003om^h0ooK^0180ooK^00<0e3dI0?ofkP3om^h0503om^h00`3D?AT0ooK^
0?ofkP020?ofkP050=@m6@3om^h0ooK^0?ofkP0000003P3om^h20=@m6A80ooK^00D0e3dI0?ofkP3o
m^h0ooK^0=@m6@0?0?ofkP030=@m6@3om^h0ooK^00D0000000<0e3dI0000000G8eD00P0000001@0O
<W00000001lbL00O<W00000000@0iD4K00<0?EV[0>E16`3U@A/00P0mFJ/80>E16`030000000mFJ/0
iD4K00H0iD4K00<000000>E16`3U@A/01@3U@A/00`0mFJ/0iD4K0>E16`060>E16`H0?EV[0`3U@A/0
0`0mFJ/0iD4K0>E16`060>E16`030000003U@A/0iD4K00H0iD4K00@0?EV[0>E16`3U@A/0iD4K1P0m
FJ/80>E16`0303eIZ`3U@A/0iD4K00D0iD4K00<000000>E16`3U@A/01@3U@A/00`0mFJ/000000>E1
6`070>E16`80?EV[0P3U@A/00`0mFJ/0iD4K0>E16`020>E16`060000001DO>H0E7cV0000001DO>H0
00000P1@MML00`000000e3dI0000000400000080ooK^00<0e3dI0?ofkP3om^h03@3om^h01@3D?AT0
ooK^0?ofkP3om^h0e3dI0180ooK^0P3D?AT>0?ofkP050000003om^h0ooK^0?ofkP3D?AT0103om^h0
0`3D?AT0ooK^0?ofkP0D0?ofkP030=@m6@3om^h0ooK^0180ooK^00<000000?ofkP3om^h0?03om^h1
0?ooo`00?P3om^h00`000000ooK^0?ofkP0B0?ofkP030=@m6@3om^h0ooK^01@0ooK^00<0e3dI0?of
kP3om^h00P3om^h00`3D?AT0ooK^0?ofkP020?ofkP030000003om^h0ooK^00/0ooK^0P3D?ATB0?of
kP050=@m6@3om^h0ooK^0?ofkP3D?AT03`3om^h00`3D?AT0ooK^0?ofkP0300000004014I?P000000
e3dI000000805b=E00@0000001lbL00O<W0000000P0O<W001@000000iD4K0>E16`3U@A/0?EV[00@0
iD4K0P0mFJ/60>E16`030000000mFJ/0iD4K00H0iD4K00<000000>E16`3U@A/01@3U@A/00`0mFJ/0
00000>E16`070>E16`030000003U@A/0iD4K0080iD4K6@0mFJ/40>E16`030000003U@A/0iD4K00H0
iD4K00<0000003eIZ`3U@A/01P3U@A/00`000000iD4K0>E16`050>E16`0303eIZ`000000iD4K00D0
iD4K0P0mFJ/40>E16`0503eIZ`3U@A/0iD4K0>E16`0000000P1DO>H010000000E7cV05AliP000002
051ee`040000003D?AT0000004MY^`<000000P3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP050=@m6@3o
m^h0ooK^0?ofkP3D?AT04P3om^h20=@m6@d0ooK^00<000000?ofkP3om^h00P3om^h00`3D?AT0ooK^
0?ofkP020?ofkP030=@m6@3om^h0ooK^01@0ooK^00<0e3dI0?ofkP3om^h04P3om^h00`000000ooK^
0?ofkP0l0?ofkP40oooo000n0?ofkP030000003om^h0ooK^0180ooK^00<0e3dI0?ofkP3om^h0503o
m^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^0080ooK^00<000000?ofkP3om^h02`3o
m^h20=@m6A80ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0?0?ofkP030=@m6@3om^h0ooK^00800000
00L04ATn000000000000e3dI01LSE@0000005b=E0080000000D07c9`0000000O<W007c9`00000003
0>E16`0303eIZ`3U@A/0iD4K0080iD4K00<000000>E16`0mFJ/01P3U@A/00`0mFJ/0iD4K0>E16`06
0>E16`030000003U@A/0iD4K00@0iD4K00<0?EV[0000003U@A/01`3U@A/00`000000iD4K0>E16`05
0>E16`0303eIZ`3U@A/0iD4K00H0iD4K00<000000>E16`3U@A/01P3U@A/00`0mFJ/0iD4K0>E16`05
0>E16`030000003U@A/0iD4K00H0iD4K00<0000003eIZ`3U@A/01@3U@A/00`000000iD4K0>E16`06
0>E16`0303eIZ`3U@A/0iD4K00@0iD4K00<0?EV[0>E16`0000000`3U@A/00`0mFJ/0iD4K0>E16`02
0>E16`030000001DO>H000000080E7cV0P000000101@MML00000051ee`3D?AT20000000304MY^`00
000000000080ooK^00<0e3dI0?ofkP3om^h03@3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI0180ooK^
0P3D?AT=0?ofkP030000003om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^
0?ofkP0D0?ofkP030=@m6@3om^h0ooK^0180ooK^00<000000?ofkP3om^h0?03om^h10?ooo`00?`3o
m^h00`000000ooK^0?ofkP0A0?ofkP030=@m6@3om^h0ooK^01@0ooK^00<0e3dI0?ofkP3om^h00P3o
m^h00`3D?AT0ooK^0?ofkP020?ofkP030000003om^h0ooK^00/0ooK^0P3D?ATB0?ofkP050=@m6@3o
m^h0ooK^0?ofkP3D?AT03`3om^h00`3D?AT0ooK^0?ofkP0200000007014I?P00000000000=@m6@0G
8eD0000001LSE@02000000807c9`00<0000001lbL00O<W00100000000`0mFJ/00000000000040000
0080?EV[100000000`0mFJ/000000000000=0000000303eIZ`000000000000l0000000<0?EV[0000
000000003`0000000`0mFJ/000000000000?0000000303eIZ`000000000000d0000000<0?EV[0000
000000000P00000203eIZ`H0000000<0?EV[0000000000000P00000205AliP030000001DO>H0E7cV
0080000000@0D7GG0000001@MML0e3dI0P0000000`17JK/00000000000020?ofkP030=@m6@3om^h0
ooK^00d0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0B0?ofkP80e3dI3@3om^h00`000000ooK^0?of
kP020?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h0503om^h00`3D?AT0ooK^0?of
kP0A0?ofkP030000003om^h0ooK^03d0ooK^0@3oool003l0ooK^00<000000?ofkP3om^h04@3om^h0
0`3D?AT0ooK^0?ofkP0D0?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h00P3om^h0
0`000000ooK^0?ofkP0;0?ofkP80e3dI4P3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00l0ooK^00<0
e3dI0?ofkP3om^h00P000000100A6Ch000000000003D?AT201LSE@80000000H07c9`0000000O<W00
7c9`0000000O<W0200000080k4<L00<0?EV[0>a3703/@a`00`3/@a`00`000000k4<L0>a3700203eI
Z`80k4<L00<0?EV[0000003/@a`01P3/@a`00`000000k4<L0>a370040>a3700303eIZ`000000k4<L
00L0k4<L00<000000>a3703/@a`01@3/@a`00`0mFJ/0k4<L0>a370060>a370030000003/@a`0k4<L
00H0k4<L00<0?EV[0>a3703/@a`01@3/@a`00`000000k4<L0>a370060>a370030000000mFJ/0k4<L
00D0k4<L00<000000>a3703/@a`01@3/@a`010000000?EV[0>a3703/@a`203eIZ`80k4<L00<00000
0>a3703/@a`00`3/@a`00`0mFJ/0k4<L0>a370020000000405AliP000000E7cV05AliP80000000D0
D7GG0000001@MML0D7GG0=@m6@020000000304MY^`000000ooK^0080ooK^00<0e3dI0?ofkP3om^h0
3@3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI0180ooK^0P3D?AT=0?ofkP030000003om^h0ooK^0080
ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP0D0?ofkP030=@m6@3om^h0ooK^0140
ooK^00<000000?ofkP3om^h0?@3om^h10?ooo`00?`3om^h00`000000ooK^0?ofkP0A0?ofkP030=@m
6@3om^h0ooK^01@0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP020?ofkP030000
003om^h0ooK^00/0ooK^0P3D?ATB0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT03`3om^h01@3D?AT0
ooK^0?ofkP3om^h0000000804ATn00<000000=@m6@0000000P0G8eD20000000401lbL00000007c9`
01lbL080000000@0:d>>0000003/@a`0?EV[1@3/@a`00`000000k4<L0>a370020>a370<0?EV[00<0
00000>a3703/@a`01P3/@a`00`000000k4<L0>a370030>a3700303eIZ`3/@a`0000000L0k4<L00<0
00000>a3703/@a`01@3/@a`00`0mFJ/0k4<L0>a370060>a370030000003/@a`0k4<L00H0k4<L00<0
?EV[0>a3703/@a`01@3/@a`00`000000k4<L0>a370050>a370030000000mFJ/0k4<L00D0k4<L00<0
00000>a3703/@a`01P3/@a`010000000?EV[03eIZ`0mFJ/40>a370030000003/@a`0k4<L00<0k4<L
00@0?EV[0>a370000000EGk]0P00000205AliP040000001DO>H0000000000080D7GG00@000000=@m
6@000000AfVk0P0000030?ofkP030=@m6@3om^h0ooK^00d0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m
6@0B0?ofkP80e3dI3@3om^h00`000000ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^0080ooK^00<0
e3dI0?ofkP3om^h0503om^h00`3D?AT0ooK^0?ofkP0A0?ofkP030000003om^h0ooK^03d0ooK^0@3o
ool00400ooK^00<000000?ofkP3om^h0403om^h00`3D?AT0ooK^0?ofkP0D0?ofkP030=@m6@3om^h0
ooK^0080ooK^?`3D?AT200000004014I?P000000e3dI000000805b=E0P0000002P0O<W00000001lb
L00O<W00000001lbL0000000:d>>0000000mFJ/60>a370030000003/@a`0k4<L00<0k4<L0P0mFJ/0
0`000000k4<L0>a370050>a370030000003/@a`0k4<L00@0k4<L00<0?EV[0000003/@a`01`3/@a`0
0`000000k4<L0>a370040>a3700303eIZ`3/@a`0k4<L00H0k4<L00<000000>a3703/@a`01P3/@a`0
0`0mFJ/0k4<L0>a370040>a370030000003/@a`0k4<L00H0k4<L00<0000003eIZ`3/@a`01@3/@a`0
0`000000k4<L0>a370050>a370030000000mFJ/0?EV[00D0k4<L00<000000>a3703/@a`0103/@a`0
0`0mFJ/0000005Enk@02000000<0E7cV00@0000005AliP00000000000P1@MML010000000e3dI0000
0017JK/2000003l0e3dI103om^h00`3D?AT0ooK^0?ofkP0D0?ofkP030=@m6@3om^h0ooK^0100ooK^
00<000000?ofkP3om^h0?P3om^h10?ooo`00@03om^h00`000000ooK^0?ofkP0@0?ofkVh0e3dI00<0
?EV[0>a3703/@a`01@3/@a`00`000000k4<L0>a370020>a3700303eIZ`3/@a`0?EV[0080?EV[1P3/
@a`00`000000k4<L0>a370030>a3700303eIZ`3/@a`0000000L0k4<L00<000000>a3703/@a`0103/
@a`00`0mFJ/000000>a370060>a370030000003/@a`0k4<L00D0k4<L00<0000003eIZ`3/@a`01@3/
@a`00`000000k4<L0>a370050>a370030000003/@a`0?EV[00D0k4<L00<000000>a3703/@a`0103/
@a`303eIZ`030>a3700mFJ/0k4<L00<0k4<L00<000000>a3703/@a`01@3/@a`00`0mFJ/0e3dI0=@m
6@1/0=@m6A80ooK^00<000000?ofkP3om^h0?P3om^h10?ooo`00@03om^h00`000000ooK^0?ofkP0@
0?ofkP030=@m6@3om^h0ooK^01@0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP03
0?ofkP030000003om^h0ooK^00X0ooK^0P3D?ATB0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT03`3o
m^h0103D?AT0ooK^0?ofkP3om^h300000006014I?P3D?AT05b=E01LSE@0000005b=E0P00000201lb
L0040000000O<W007c9`00000080:d>>00<000000>a3703/@a`01@3/@a`00`000000k4<L0>a37002
0>a3700503eIZ`3/@a`0k4<L0000003/@a`00`0mFJ/30>a370030000003/@a`0k4<L00<0k4<L00<0
?EV[0>a3700000001`3/@a`00`000000k4<L0>a370040>a3700303eIZ`000000k4<L00H0k4<L00<0
00000>a3703/@a`01@3/@a`00`000000?EV[0>a370050>a370030000003/@a`0k4<L00D0k4<L00<0
00000>a3700mFJ/01@3/@a`010000000k4<L0>a3703/@a`303eIZ`050>a370000000k4<L0>a3700m
FJ/0103/@a`00`000000k4<L0>a370050>a370040000001EO^d0EGk]00000080E7cV00<0000005Al
iP1DO>H00P0000001P1@MML00000051ee`1@MML0e3dI04MY^`<000000`3om^h00`3D?AT0ooK^0?of
kP0=0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT04P3om^h20=@m6@`0ooK^00<000000?ofkP3om^h0
0`3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^01@0ooK^00<0e3dI0?ofkP3om^h0
403om^h00`000000ooK^0?ofkP0n0?ofkP40oooo00100?ofkP030000003om^h0ooK^0100ooK^00<0
e3dI0?ofkP3om^h0503om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0
00000?ofkP3om^h02P3om^h20=@m6A80ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0?0?ofkP040=@m
6@3om^h0ooK^0?ofkP<0000000H04ATn0=@m6@0000005b=E0000000G8eD2000000807c9`00<00000
01lbL00O<W000P00000202]3SP030000003/@a`0k4<L00D0k4<L00D000000>a3703/@a`0k4<L03eI
Z`030>a370040000003/@a`0k4<L0>a37080?EV[0P3/@a`00`000000k4<L0>a370020>a3700303eI
Z`3/@a`0000000L0k4<L00<000000>a3703/@a`0103/@a`00`0mFJ/000000>a370060>a370030000
003/@a`0k4<L00D0k4<L00<0000003eIZ`3/@a`01@3/@a`00`000000k4<L0>a370050>a370030000
003/@a`0?EV[00@0k4<L00<000000>a3703/@a`00P0mFJ/30>a370050000003/@a`0k4<L0>a3700m
FJ/00`3/@a`00`000000k4<L0>a370050>a370030000001EO^d0EGk]008000000P1DO>H00`000000
E7cV05AliP0200000007051ee`000000D7GG0000003D?AT0000004MY^`02000000<0ooK^00<0e3dI
0?ofkP3om^h03@3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI0180ooK^0P3D?AT<0?ofkP030000003o
m^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP0D0?ofkP030=@m6@3o
m^h0ooK^0100ooK^00<000000?ofkP3om^h0?P3om^h10?ooo`00@@3om^h00`000000ooK^0?ofkP0?
0?ofkP030=@m6@3om^h0ooK^01@0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP04
0?ofkP030000003om^h0ooK^00T0ooK^0P3D?ATB0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT03`3o
m^h0103D?AT0ooK^0?ofkP3om^h200000004014I?P000000e3dI000000805b=E0P0000002@0O<W00
000001lbL00O<W00000001lbL0000000:d>>0000000202]3SP030000003/@a`0k4<L00D0k4<L00@0
00000>a3703/@a`0?EV[0`3/@a`00`000000k4<L0>a370030>a370<0?EV[103/@a`0100mFJ/0k4<L
0>a3700000070>a370030000003/@a`0k4<L00<0k4<L00<0?EV[0000003/@a`01P3/@a`00`000000
k4<L0>a370050>a370030000000mFJ/0k4<L00@0k4<L00<000000>a3703/@a`01@3/@a`010000000
k4<L0>a3700mFJ/40>a370<0?EV[1@3/@a`01@000000k4<L0>a3703/@a`0?EV[0080k4<L00<00000
0>a3703/@a`01@3/@a`020000000EGk]05Enk@000000EGk]0000001DO>H000000P1DO>H010000000
E7cV000000000002051ee`050000003D?AT0000004MY^`000000103om^h00`3D?AT0ooK^0?ofkP0=
0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT04P3om^h20=@m6@/0ooK^00<000000?ofkP3om^h0103o
m^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^01@0ooK^00<0e3dI0?ofkP3om^h03`3o
m^h00`000000ooK^0?ofkP0o0?ofkP40oooo00110?ofkP030000003om^h0ooK^00l0ooK^00<0e3dI
0?ofkP3om^h0503om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00@0ooK^00<00000
0?ofkP3om^h02@3om^h20=@m6A80ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0?0?ofkP030=@m6@3o
m^h0ooK^0080ooK^00L00000014I?P000000e3dI01LSE@0000005b=E008000000P0O<W000`000000
7c9`01lbL0020000000302]3SP000000:d>>0080:d>>00<000000>a3703/@a`01@3/@a`00`000000
k4<L03eIZ`040>a370030000003/@a`0k4<L00D0k4<L0`0mFJ/01@3/@a`0?EV[0>a3703/@a`00000
00L0k4<L00<000000>a3703/@a`00`3/@a`00`0mFJ/000000>a370060>a370030000003/@a`0k4<L
00D0k4<L00<0000003eIZ`3/@a`0103/@a`00`000000k4<L0>a370050>a370050000003/@a`0k4<L
03eIZ`3/@a`00`0mFJ/70>a370030000003/@a`0k4<L0080k4<L00<0?EV[0>a3700000001`3/@a`0
10000000EGk]05Enk@00000205Enk@8000000P1DO>H00`000000E7cV05AliP0200000004051ee`00
000000000=@m6@80AfVk00<000000?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP050=@m
6@3om^h0ooK^0?ofkP3D?AT04P3om^h20=@m6@/0ooK^00<000000?ofkP3om^h0103om^h00`3D?AT0
ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^01@0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`000000
ooK^0?ofkP0o0?ofkP40oooo00110?ofkP030000003om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h0
503om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00@0ooK^00<000000?ofkP3om^h0
2@3om^h20=@m6A80ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0?0?ofkP030=@m6@3om^h0ooK^0080
ooK^0P000000100A6Ch0e3dI00000000000201LSE@060000000O<W007c9`01lbL00000007c9`0P00
000202]3SP050000000[@hh0:d>>02]3SP0000001P3/@a`00`000000k4<L03eIZ`050>a370030000
003/@a`0k4<L00@0k4<L00<000000>a3703/@a`0100mFJ/00`000000k4<L0>a370050>a370030000
003/@a`0k4<L00<0k4<L00<0?EV[0000003/@a`01P3/@a`00`000000k4<L0>a370050>a370030000
000mFJ/0k4<L00@0k4<L00<000000>a3703/@a`01@3/@a`00`000000?EV[03eIZ`0203eIZ`80k4<L
00<000000>a3703/@a`0103/@a`00`000000k4<L0>a370030>a3700303eIZ`3/@a`0000000H0k4<L
00D0000005Enk@1EO^d0EGk]0000000205Enk@80000000<0E7cV0000001DO>H00P1DO>H00`000000
D7GG051ee`02000000040=@m6@17JK/00000000000@0ooK^00<0e3dI0?ofkP3om^h03@3om^h01@3D
?AT0ooK^0?ofkP3om^h0e3dI0180ooK^0P3D?AT;0?ofkP030000003om^h0ooK^00@0ooK^00<0e3dI
0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP0D0?ofkP030=@m6@3om^h0ooK^00l0ooK^00<00000
0?ofkP3om^h0?`3om^h10?ooo`00@P3om^h00`000000ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^
01@0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@070?ofkP030000003om^h0ooK^00T0ooK^00<0e3dI
0?ofkP3om^h04@3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00l0ooK^00<0e3dI0?ofkP3om^h00P3o
m^h200000006014I?P3D?AT0000001LSE@0000005b=E0P00000201lbL0040000000O<W007c9`0000
00<0:d>>00@0000002]3SP0[@hh000001`3/@a`00`000000?EV[0>a370040>a370030000003/@a`0
k4<L00D0k4<L00@000000>a3703/@a`0?EV[0P3/@a`603eIZ`80k4<L00<000000>a3703/@a`00`3/
@a`00`0mFJ/0k4<L000000060>a370030000003/@a`0k4<L00@0k4<L00<000000>a3700mFJ/01@3/
@a`00`000000k4<L0>a3700603eIZ`80k4<L00@0?EV[0>a3703/@a`000001`3/@a`00`000000k4<L
0>a370020>a3700303eIZ`3/@a`0000000L0k4<L00@0000005Enk@1EO^d000000`1EO^d010000000
E7cV05AliP00000205AliP80000000H0D7GG0000001@MML000000=@m6@17JK/2000000@0ooK^00<0
e3dI0?ofkP3om^h03@3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI0180ooK^0P3D?AT;0?ofkP030000
003om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP0D0?ofkP030=@m
6@3om^h0ooK^00h0ooK^00<000000?ofkP3om^h0@03om^h10?ooo`00@P3om^h00`000000ooK^0?of
kP0>0?ofkP030=@m6@3om^h0ooK^01@0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@080?ofkP030000
003om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h04@3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00l0
ooK^00<0e3dI0?ofkP3om^h00P3om^h3000000040=@m6@0000005b=E01LSE@80000000H07c9`0000
000O<W007c9`0000000O<W02000000<0:d>>00@0000002]3SP0[@hh000001`3/@a`00`000000?EV[
0>a370040>a370030000003/@a`0k4<L00@0k4<L00@000000>a3703/@a`0?EV[0`3/@a`00`000000
k4<L0>a370020>a370H0?EV[0P3/@a`00`0mFJ/0k4<L000000060>a370030000003/@a`0k4<L00@0
k4<L00<000000>a3700mFJ/00P3/@a`603eIZ`@0k4<L00D000000>a3703/@a`0k4<L03eIZ`020>a3
70030000003/@a`0k4<L00@0k4<L00<000000>a3703/@a`00`3/@a`00`0mFJ/000000>a370060>a3
70040000001EO^d0EGk]000000<0EGk]0P0000001P1DO>H0000005AliP1DO>H0000005AliP800000
0P1@MML00`000000e3dI00000002000000@0ooK^00<0e3dI0?ofkP3om^h03@3om^h01@3D?AT0ooK^
0?ofkP3om^h0e3dI01<0ooK^00<0e3dI0?ofkP3om^h0203om^h00`000000ooK^0?ofkP060?ofkP05
0=@m6@3om^h0ooK^0?ofkP3D?AT05P3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030000003om^h0ooK^
0400ooK^0@3oool00480ooK^00<000000?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0D0?ofkP05
0=@m6@3om^h0ooK^0?ofkP3D?AT0203om^h00`000000ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^
0140ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0?0?ofkP030=@m6@3om^h0ooK^0080ooK^0`000000
103D?AT000000000000G8eD20000000301lbL00000007c9`00807c9`0P0000000`0[@hh0000002]3
SP0202]3SP040000000[@hh0:d>>000000H0k4<L00<0000003eIZ`3/@a`0103/@a`00`000000k4<L
0>a370050>a370030000003/@a`0?EV[00@0k4<L00<000000>a3703/@a`0103/@a`00`000000k4<L
0>a3700G03eIZ`80k4<L00<000000>a3703/@a`0103/@a`00`000000k4<L0>a370020>a3700303eI
Z`3/@a`0000000L0k4<L00<000000>a3703/@a`00`3/@a`00`0mFJ/000000>a370050>a370040000
001EO^d0EGk]000000<0EGk]00@0000005Enk@00000000000`1DO>H200000003051ee`000000D7GG
0080000000@0e3dI0000000000000000103om^h00`3D?AT0ooK^0?ofkP0=0?ofkP050=@m6@3om^h0
ooK^0?ofkP3D?AT04P3om^h20=@m6@X0ooK^00<000000?ofkP3om^h01P3om^h0103D?AT0ooK^0?of
kP3D?ATF0?ofkP030=@m6@3om^h0ooK^00l0ooK^00<000000?ofkP3om^h0@03om^h10?ooo`00@`3o
m^h00`000000ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^01@0ooK^00@0e3dI0?ofkP3om^h0e3dI
203om^h;00000080e3dI4P0000001@3D?AT00000000000000000e3dI00l0000000<0e3dI00000000
000010000000100A6Ch0e3dI00000000000201LSE@80000000<07c9`0000000O<W000P0O<W020000
000302]3SP000000:d>>0080:d>>00<0000002]3SP0[@hh01`0000000`0mFJ/000000000000=0000
000303eIZ`000000000000h0000000<0?EV[0000000000003`0000000`0mFJ/000000000000>0000
000303eIZ`000000000000d0000000<0?EV[0000000000001@00000205Enk@060000001EO^d0EGk]
05Enk@000000EGk]0P00000305AliP040000001DO>H0000000000080D7GG0P0000000`3D?AT0AfVk
00000005000000030=@m6@000000000000d0000000D0e3dI00000000000000000=@m6@0B00000080
e3dI2`0000080?ofkP040=@m6@3om^h0ooK^0=@m6AH0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`00
0000ooK^0?ofkP110?ofkP40oooo00130?ofkP030000003om^h0ooK^00h0ooK^00<0e3dI0?ofkP3o
m^h0503om^h0103D?AT0ooK^0?ofkP3D?AT80?ofkP030000003om^h0ooK^00P0ooK^0P3D?ATB0?of
kP050=@m6@3om^h0ooK^0?ofkP3D?AT03`3om^h00`3D?AT0ooK^0?ofkP020?ofkP80000000H04ATn
0=@m6@0000005b=E0000000G8eD2000000807c9`00<0000001lbL00O<W000P00000202]3SP040000
000[@hh0:d>>00000080:d>>0P0000050?957@0303eIZ`000000lTDM00D0lTDM00<000000?957@3b
AAd00`3bAAd00`000000lTDM03eIZ`040?957@030000003bAAd0lTDM00@0lTDM00<000000?957@3b
AAd00P3bAAd00`0mFJ/0lTDM000000060?957@030000003bAAd0lTDM00@0lTDM00<000000?957@0m
FJ/0103bAAd00`000000lTDM0?957@040?957@030000003bAAd0lTDM0080lTDM00<0?EV[0000003b
AAd01@3bAAd00`000000lTDM0?957@040?957@030000000mFJ/0lTDM00@0lTDM0P0000000`1EO^d0
000005Enk@0205Enk@030000001EO^d0EGk]008000000P1DO>H00`000000E7cV05AliP0200000006
051ee`000000D7GG0000003D?AT0AfVk0P0000040?ofkP030=@m6@3om^h0ooK^00d0ooK^00D0e3dI
0?ofkP3om^h0ooK^0=@m6@0B0?ofkP80e3dI2P3om^h00`000000ooK^0?ofkP060?ofkP040=@m6@3o
m^h0ooK^0=@m6AH0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`000000ooK^0?ofkP110?ofkP40oooo
00130?ofkP030000003om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h0503om^h0103D?AT0ooK^0?of
kP3D?AT80?ofkP030000003om^h0ooK^00P0ooK^0P3D?ATB0?ofkP050=@m6@3om^h0ooK^0?ofkP3D
?AT03`3om^h00`3D?AT0ooK^0?ofkP020?ofkP<0000000P0e3dI0000000G8eD05b=E0000000G8eD0
000003eIZ`807c9`00@0000001lbL00O<W0000000`0[@hh02@000000:d>>02]3SP000000:d>>0000
000dD:H0000003eIZ`030?957@0303eIZ`3bAAd0000000D0lTDM00<000000?957@3bAAd0103bAAd0
0`000000?EV[0?957@040?957@030000003bAAd0lTDM00<0lTDM00<000000?957@3bAAd00P3bAAd0
0`0mFJ/0lTDM000000060?957@030000003bAAd0lTDM00@0lTDM00<000000?957@0mFJ/00`3bAAd0
0`000000lTDM0?957@040?957@030000003bAAd0lTDM00<0lTDM00<0?EV[0000003bAAd01@3bAAd0
0`000000lTDM0?957@030?957@030000003bAAd0?EV[00<0lTDM00H0?EV[0000001DONh0000005En
k@00000205Enk@050000001EO^d0EGk]05Enk@0000000P1DO>H01`000000E7cV05AliP1DO>H00000
051ee`0000000P1@MML00`000000e3dI00000002000000@0ooK^00<0e3dI0?ofkP3om^h03@3om^h0
1@3D?AT0ooK^0?ofkP3om^h0e3dI0180ooK^0P3D?AT:0?ofkP030000003om^h0ooK^00H0ooK^00@0
e3dI0?ofkP3om^h0e3dI5P3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030000003om^h0ooK^0440ooK^
0@3oool004@0ooK^00<000000?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0D0?ofkP040=@m6@3o
m^h0ooK^0=@m6@P0ooK^00<000000?ofkP3om^h0203om^h20=@m6A80ooK^00D0e3dI0?ofkP3om^h0
ooK^0=@m6@0?0?ofkP030=@m6@3om^h0ooK^0080ooK^0`0000001P3D?AT0000001LSE@0G8eD00000
01LSE@8000000`0O<W00100000007c9`00000000000202]3SP040000000[@hh0:d>>02]3SP800000
00<0=52V0=@m6@0000000P0mFJ/0103bAAd0?EV[0?957@0000060?957@030000003bAAd0lTDM00<0
lTDM00<0000003eIZ`3bAAd0103bAAd00`000000lTDM0?957@040?957@070000003bAAd0lTDM0?95
7@0mFJ/0lTDM000000060?957@030000003bAAd0lTDM00<0lTDM00@000000?957@3bAAd0?EV[0`3b
AAd00`000000lTDM0?957@040?957@030000003bAAd0lTDM00<0lTDM00<0?EV[0?957@3bAAd0103b
AAd00`000000lTDM0?957@030?957@050000003bAAd0lTDM03eIZ`3bAAd00P0mFJ/00`000000e3dI
05AmkP02000000<0EGk]00<0000005Enk@1EO^d00P0000000`1DO>H0000005AliP0205AliP800000
00H0D7GG0000001@MML0D7GG0000003D?AT3000000@0ooK^00<0e3dI0?ofkP3om^h03@3om^h01@3D
?AT0ooK^0?ofkP3om^h0e3dI0180ooK^0P3D?AT:0?ofkP030000003om^h0ooK^00H0ooK^00@0e3dI
0?ofkP3om^h0e3dI5P3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030000003om^h0ooK^0480ooK^0@3o
ool004@0ooK^00<000000?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0D0?ofkP030=@m6@3om^h0
ooK^0440e3dI00@0000000/@9P000000e3dI0P00000201LSE@80000000T07c9`0000000O<W007c9`
0000000O<W00000002]3SP0000000P0[@hh02P000000:d>>02]3SP0[@hh0000003A@YP3D?AT0=52V
0000003bAAd303eIZ`030?957@000000lTDM00D0lTDM00<000000?957@3bAAd00`3bAAd00`0mFJ/0
lTDM0?957@040?957@030000003bAAd0lTDM00<0lTDM00D000000?957@3bAAd0lTDM03eIZ`020?95
7@030000003bAAd0lTDM00<0lTDM00<000000?957@3bAAd00`3bAAd010000000lTDM0?957@0mFJ/3
0?957@030000003bAAd0lTDM00<0lTDM00<000000?957@3bAAd0103bAAd00`0mFJ/0lTDM0?957@03
0?957@030000003bAAd0lTDM00@0lTDM00<000000?957@0mFJ/00P0mFJ/01P3bAAd0000005AmkP3D
?AT0E7g^000000<0EGk]00P0000005Enk@1EO^d0000005Enk@000000E7cV00000080E7cV00@00000
05AliP00000000000P1@MML2000000040=@m6@000000>UFC00000440e3dI0P3om^h00`3D?AT0ooK^
0?ofkP0D0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<000000?ofkP3om^h0@P3om^h10?ooo`00A03o
m^h00`000000ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^01@0ooK^00@0e3dI0?ofkP3om^h0e3dI
1`3om^h00`000000ooK^0?ofkP090?ofkP80e3dI4P3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00l0
ooK^00<0e3dI0?ofkP3om^h00P3om^h0100000002a0V0000003D?AT2000000<05b=E0P000000100O
<W00000001lbL00O<W0200000080:d>>00@0000002]3SP0[@hh000000P0[@hh2000000070=@m6@0d
D:H0=52V0000003bAAd0?EV[0?957@0203eIZ`030000003bAAd0lTDM00<0lTDM00<000000?957@3b
AAd00`3bAAd00`0mFJ/0lTDM0?957@040?957@030000003bAAd0lTDM00<0lTDM00D000000?957@3b
AAd0lTDM03eIZ`020?957@030000003bAAd0lTDM00<0lTDM00<000000?957@3bAAd00`3bAAd01000
0000lTDM0?957@0mFJ/30?957@030000003bAAd0lTDM00<0lTDM00<000000?957@3bAAd00`3bAAd0
0`000000?EV[0?957@040?957@030000003bAAd0lTDM00<0lTDM00L0000003eIZ`0mFJ/0lTDM03eI
Z`3bAAd000000080E7g^00<0e3dI0000000000000P1EO^d010000000EGk]05Enk@00000205Enk@80
00000P1DO>H010000000E7cV000000000003051ee`80000000@0e3dI0000000jEI<00000103om^h0
0`3D?AT0ooK^0?ofkP0=0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT04P3om^h20=@m6@/0ooK^00<0
00000?ofkP3om^h01@3om^h0103D?AT0ooK^0?ofkP3D?ATF0?ofkP030=@m6@3om^h0ooK^00d0ooK^
00<000000?ofkP3om^h0@P3om^h10?ooo`00A@3om^h00`000000ooK^0?ofkP0<0?ofkP030=@m6@3o
m^h0ooK^01@0ooK^00@0e3dI0?ofkP3om^h0e3dI1`3om^h00`000000ooK^0?ofkP090?ofkP80e3dI
4P3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00l0ooK^00<0e3dI0?ofkP3om^h00P3om^h300000004
0=@m6@0000005b=E000000805b=E0P00000201lbL0040000000O<W007c9`000000<0:d>>00P00000
02]3SP0[@hh0000002]3SP000000=52V0=@m6@80=52V00@000000?957@3bAAd0?EV[0P3bAAd303eI
Z`@0lTDM00<000000?957@3bAAd00P3bAAd00`0mFJ/000000?957@040?957@030000003bAAd0lTDM
00<0lTDM00D000000?957@3bAAd0lTDM03eIZ`020?957@030000003bAAd0lTDM00<0lTDM00<00000
0?957@3bAAd00`3bAAd010000000lTDM0?957@0mFJ/20?957@030000003bAAd0lTDM00<0lTDM00<0
00000?957@3bAAd0103bAAd00`000000?EV[0?957@030?957@030000003bAAd0lTDM0080lTDM0`0m
FJ/20?957@0303eIZ`3bAAd0000000<0E7g^00D0e3dI05AmkP000000EGk]0000000205Enk@050000
001EO^d0EGk]05Enk@0000000P1DO>H00`000000E7cV05AliP0200000080D7GG0`0000000`3D?AT0
0000000000050?ofkP030=@m6@3om^h0ooK^00d0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0B0?of
kP80e3dI2`3om^h00`000000ooK^0?ofkP050?ofkP040=@m6@3om^h0ooK^0=@m6AH0ooK^00<0e3dI
0?ofkP3om^h0303om^h00`000000ooK^0?ofkP130?ofkP40oooo00150?ofkP030000003om^h0ooK^
00`0ooK^N`3D?AT00`3bAAd0?EV[0?957@030?957@040000000mFJ/0?EV[03eIZ`80lTDM00H00000
0?957@3bAAd0lTDM03eIZ`0000060?957@030000003bAAd0lTDM00<0lTDM00@000000?957@3bAAd0
?EV[0P3bAAd00`000000lTDM0?957@030?957@030000003bAAd0lTDM00<0lTDM00@000000?957@3b
AAd0?EV[0P3bAAd00`000000lTDM0?957@030?957@030000003bAAd0lTDM00<0lTDM00<000000?95
7@0mFJ/00`3bAAd00`000000lTDM0?957@0303eIZ`030000003bAAd0lTDM0080lTDM00<0?EV[0?95
7@3D?AT0NP3D?AT>0?ofkP030000003om^h0ooK^04<0ooK^0@3oool004D0ooK^00<000000?ofkP3o
m^h0303om^h00`3D?AT0ooK^0?ofkP0D0?ofkP040=@m6@3om^h0ooK^0=@m6@L0ooK^00<000000?of
kP3om^h02@3om^h20=@m6A80ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0?0?ofkP030=@m6@3om^h0
ooK^00<0ooK^0P0000001@3D?AT04ATn0000000G8eD0000000805b=E00T0?EV[0000000O<W007c9`
0000000O<W00000002]3SP0000000`0[@hh020000000:d>>02]3SP000000=52V0=@m6@0dD:H00000
0P0dD:H00`000000lTDM0?957@040?957@030000003bAAd0lTDM0080?EV[00L000000?957@3bAAd0
lTDM03eIZ`3bAAd0000000D0lTDM00<000000?957@3bAAd00`3bAAd010000000lTDM0?957@0mFJ/2
0?957@030000003bAAd0lTDM00<0lTDM00<000000?957@3bAAd00`3bAAd010000000lTDM0?957@0m
FJ/20?957@030000003bAAd0lTDM00<0lTDM00<000000?957@3bAAd00`3bAAd00`000000lTDM03eI
Z`030?957@030000000mFJ/0?EV[0080lTDM00<000000?957@3bAAd0103bAAd020000000E7g^05Am
kP000000E7g^0=@m6@1DONh000000P1EO^d02@000000EGk]05Enk@1EO^d0000005Enk@000000E7cV
0000000205AliP8000000P1@MML01@000000D7GG00000017JK/0e3dI008000001@3om^h00`3D?AT0
ooK^0?ofkP0=0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT04P3om^h20=@m6@/0ooK^00<000000?of
kP3om^h01@3om^h0103D?AT0ooK^0?ofkP3D?ATF0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<00000
0?ofkP3om^h0@`3om^h10?ooo`00AP3om^h00`000000ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^
01@0ooK^00@0e3dI0?ofkP3om^h0e3dI1`3om^h00`000000ooK^0?ofkP090?ofkP80e3dI4P3om^h0
1@3D?AT0ooK^0?ofkP3om^h0e3dI00l0ooK^00<0e3dI0?ofkP3om^h00`3om^h2000000030=@m6@0A
6Ch0000000805b=E00D0000001LSE@0000007c9`0000000201lbL0050000000O<W00000002]3SP00
00000`0[@hh01@000000:d>>000000000000e3dI0080=52V00@0000003A@YP0dD:H000001@3bAAd0
0`000000lTDM0?957@020?957@<0?EV[00@0lTDM03eIZ`3bAAd000001P3bAAd00`000000lTDM0?95
7@020?957@040000003bAAd0lTDM03eIZ`80lTDM00<000000?957@3bAAd00`3bAAd00`000000lTDM
0?957@020?957@050000003bAAd0lTDM0?957@0mFJ/00P3bAAd00`000000lTDM0?957@020?957@03
0000003bAAd0lTDM00<0lTDM00D000000?957@3bAAd0?EV[0?957@0303eIZ`<0lTDM00<000000?95
7@3bAAd0103bAAd010000000E7g^05AmkP00000205AmkP050=@m6@000000000005Enk@0000000`1E
O^d01@000000EGk]0000001DO>H000000080E7cV00D0000005AliP000000D7GG00000002051ee`03
00000017JK/0e3dI008000001@3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP050=@m6@3om^h0ooK^0?of
kP3D?AT04P3om^h20=@m6@/0ooK^00<000000?ofkP3om^h01@3om^h0103D?AT0ooK^0?ofkP3D?ATF
0?ofkP030=@m6@3om^h0ooK^00/0ooK^00<000000?ofkP3om^h0A03om^h10?ooo`00AP3om^h00`00
0000ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^01@0ooK^00@0e3dI0?ofkP3om^h0e3dI1`3om^h0
0`000000ooK^0?ofkP090?ofkP80e3dI4P3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00l0ooK^00<0
e3dI0?ofkP3om^h00`3om^h2000000040=@m6@0000000000000000805b=E0P00000201lbL0030000
000O<W007c9`008000000P0[@hh010000000:d>>02]3SP0[@hh20000000303A@YP3D?AT0=52V0080
=52V00@0000003A@YP0dD:H000001@3bAAd00`000000lTDM0?957@030?957@030000000mFJ/0?EV[
0080?EV[00<000000?957@3bAAd00`3bAAd00`000000lTDM0?957@020?957@040000003bAAd0lTDM
03eIZ`<0lTDM00<000000?957@3bAAd00P3bAAd00`000000lTDM0?957@020?957@070000003bAAd0
lTDM0?957@0mFJ/0lTDM000000050?957@030000003bAAd0lTDM00<0lTDM00<0000003eIZ`0mFJ/0
0P0mFJ/00`000000lTDM0?957@030?957@030000003bAAd0lTDM00<0lTDM00@0000005AmkP1DONh0
00000`1DONh0103D?AT0000005Enk@00000305Enk@030000001EO^d0EGk]008000000P1DO>H00`00
0000E7cV05AliP0200000080D7GG0`0000000`3D?AT00000000000050?ofkP030=@m6@3om^h0ooK^
00d0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0B0?ofkP80e3dI2`3om^h00`000000ooK^0?ofkP05
0?ofkP040=@m6@3om^h0ooK^0=@m6AH0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`000000ooK^0?of
kP140?ofkP40oooo00160?ofkP030000003om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h05@3om^h2
0=@m6@P0ooK^00<000000?ofkP3om^h0203om^h00`3D?AT0ooK^0=@m6@0A0?ofkP030=@m6@3om^h0
ooK^0080ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP040?ofkP80000000@0e3dI
00000000000000000P0G8eD2000000807c9`00D0000001lbL00O<W007c9`0000000302]3SP800000
0P0[@hh2000000030=@m6@00000000000080=52V00@0000003A@YP0dD:H000001@3bAAd00`000000
lTDM0?957@020?957@030000003bAAd0?EV[0080lTDM1P0mFJ/00`3bAAd000000?957@030?957@03
0000003bAAd0?EV[00<0lTDM00<000000?957@3bAAd00P3bAAd00`000000lTDM0?957@020?957@07
0000003bAAd0lTDM0?957@0mFJ/0lTDM000000040?957@030000003bAAd0?EV[00D0?EV[0P3bAAd0
0`0mFJ/0lTDM000000040?957@030000003bAAd0lTDM00<0lTDM00@0000005AmkP1DONh000000P1D
ONh2000000030=@m6@00000000000080EGk]0P00000305Enk@040000001DO>H0E7cV000000<0E7cV
0P0000000`1@MML00000051ee`02000000030=@m6@000000000000H0ooK^00<0e3dI0?ofkP3om^h0
303om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3D?AT0
2P3om^h00`000000ooK^0?ofkP060?ofkP80e3dI5`3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030000
003om^h0ooK^04@0ooK^0@3oool004L0ooK^00<000000?ofkP3om^h02P3om^h00`3D?AT0ooK^0?of
kP0E0?ofkP80e3dI203om^h00`000000ooK^0?ofkP080?ofkP030=@m6@3om^h0e3dI0140ooK^00<0
e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00@0ooK^0P00
00001@3D?AT04ATn0000000G8eD0000000805b=E00D0000001lbL00O<W007c9`0000000201lbL080
0000100[@hh01@000000:d>>02]3SP000000e3dI0080=52V00@0000003A@YP0dD:H000000P0dD:H<
0000000303eIZ`000000000000H000001P0mFJ/20000000303eIZ`000000000000l0000000<0?EV[
0000000000001P0mFJ/80000000303eIZ`000000000000X000000P1DONh010000000E7g^05AmkP00
000205AmkP050=@m6@000000EGk]05Enk@000000101EO^d200000080E7cV00D0000005AliP1DO>H0
E7cV00000002051ee`<0000000<0AfVk0=@m6@0000001`3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP03
0=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0=@m6@0:0?ofkP03
0000003om^h0ooK^00H0ooK^0P3D?ATG0?ofkP030=@m6@3om^h0ooK^00X0ooK^00<000000?ofkP3o
m^h0A@3om^h10?ooo`00A`3om^h00`000000ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^01D0ooK^
0P3D?AT70?ofkP030000003om^h0ooK^00T0ooK^00<0e3dI0?ofkP3D?AT04@3om^h00`3D?AT0ooK^
0?ofkP020?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`000000e3dI
014I?P020000000301LSE@0000005b=E008000000`0O<W001@0000007c9`0000000[@hh0000000@0
:d>>00@0000002]3SP000000e3dI0`0dD:H01@000000=52V03A@YP000000=52V008000001@3hB1h0
0`000000n4PN0?Q87P020?Q87P0303eIZ`3hB1h0n4PN0080n4PN00<000000?Q87P3hB1h00P3hB1h0
0`000000n4PN0?Q87P020?Q87QL0?EV[103hB1h00`000000n4PN0?Q87P020?Q87P030000003hB1h0
n4PN0080n4PN00<0?EV[0?Q87P3hB1h00P3hB1h00`000000n4PN0?Q87P030?Q87P80000000D0E7g^
0000001DONh0E7g^0000000305AmkP040=@m6@000000EGk]000000@0EGk]00D0000005Enk@000000
E7cV0000000305AliP80000000P0D7GG0000001@MML0000003eIZ`17JK/0e3dI000000L0ooK^00<0
e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0
e3dI0?ofkP3D?AT02`3om^h00`000000ooK^0?ofkP050?ofkP80e3dI5`3om^h00`3D?AT0ooK^0?of
kP0:0?ofkP030000003om^h0ooK^04D0ooK^0@3oool004L0ooK^00<000000?ofkP3om^h02P3om^h0
0`3D?AT0ooK^0?ofkP0E0?ofkP80e3dI1`3om^h00`000000ooK^0?ofkP090?ofkP030=@m6@3om^h0
e3dI0140ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0
ooK^00D0ooK^00D000000=@m6@0A6Ch04ATn0000000201LSE@80000000<07c9`0000000O<W000P0O
<W0200000080:d>>00<0000002]3SP0[@hh00P0[@hh2000000030=@m6@00000000000080=52V00<0
000003A@YP0dD:H00P0000000`0lFkT000000?Q87P040?Q87P060000003hB1h0n4PN0?Q87P0mFJ/0
00000`3hB1h00`000000n4PN0?Q87P030?Q87P030000003hB1h0n4PN0080n4PN00<0000003eIZ`3h
B1h00P3hB1h00`000000n4PN0?Q87P020?Q87P030000003hB1h0n4PN0080n4PN00H000000?Q87P3h
B1h0n4PN03eIZ`0000040?Q87P030000003hB1h0n4PN00<0n4PN00H000000?Q87P3hB1h0n4PN0000
000mFJ/30?Q87P030000003hB1h0n4PN00<0n4PN00@00000059jj`00000000000P1DONh00`000000
E7g^05AmkP02000000030=@m6@000000000000@0EGk]00<0000005Enk@1EO^d00P00000305AliP04
0000001DO>H0000000000080D7GG00D0000004MY^`17JK/0e3dI000000070?ofkP030=@m6@3om^h0
ooK^00`0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0
e3dI00/0ooK^00<000000?ofkP3om^h01@3om^h20=@m6AL0ooK^00<0e3dI0?ofkP3om^h02P3om^h0
0`000000ooK^0?ofkP150?ofkP40oooo00180?ofkP030000003om^h0ooK^00X0ooK^00<0e3dI0?of
kP3om^h0503om^h20=@m6@L0ooK^00<000000?ofkP3om^h02@3om^h0103D?AT0ooK^0?ofkP3D?AT@
0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP05
0?ofkP80000000<0e3dI014I?P0000000P0G8eD01@0000005b=E0000000O<W00000000<07c9`00@0
000002]3SP0[@hh0:d>>0P00000302]3SP050000003D?AT0=52V03A@YP0000000P0dD:H010000000
=52V03A@YP00000203aK^@030000003hB1h0n4PN00<0n4PN00D000000?Q87P3hB1h0n4PN03eIZ`04
0?Q87P030000003hB1h0n4PN0080n4PN00<000000?Q87P3hB1h00P3hB1h00`000000?EV[0?Q87P02
0?Q87P030000003hB1h0n4PN0080n4PN00<000000?Q87P3hB1h00P3hB1h01P000000n4PN0?Q87P3h
B1h0?EV[000000@0n4PN00<000000?Q87P3hB1h00P3hB1h00`000000n4PN0?Q87P020?Q87P0503eI
Z`3hB1h0n4PN0?Q87P0000001@3hB1h010000000DW[[059jj`00000205AmkP040000001DONh0E7g^
00000080E7g^00<0e3dI0000001EO^d00P1EO^d2000000<0EGk]00H0000005AliP1DO>H0E7cV0000
001DO>H2000000<0D7GG00<0000004MY^`3D?AT00P0000070?ofkP030=@m6@3om^h0ooK^00/0ooK^
00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP040=@m6@3om^h0ooK^0=@m6@/0
ooK^00<000000?ofkP3om^h01@3om^h20=@m6AH0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`000000
ooK^0?ofkP160?ofkP40oooo00180?ofkP030000003om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h0
503om^h20=@m6@L0ooK^00<000000?ofkP3om^h02@3om^h0103D?AT0ooK^0?ofkP3D?AT@0?ofkP03
0=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP050?ofkP80
000000@0e3dI014I?P00000000000P0G8eD2000000807c9`00<0000001lbL00O<W000P00000402]3
SP050000000[@hh0:d>>0000003D?AT00P0dD:H0100mFJ/0000003A@YP0dD:H400000080?5^i00<0
00000?Q87P3hB1h00`3hB1h01@000000n4PN0?Q87P0mFJ/0000000@0n4PN00<000000?Q87P3hB1h0
0P3hB1h01P000000n4PN0?Q87P3hB1h0000003eIZ`<0n4PN00<000000?Q87P3hB1h00P3hB1h00`00
0000n4PN0?Q87P020?Q87P060000003hB1h0n4PN0?Q87P0mFJ/000000`3hB1h00`000000n4PN0?Q8
7P020?Q87P030000003hB1h0n4PN0080n4PN00D0000003eIZ`3hB1h0n4PN000000050?Q87P030000
001BN^/0DW[[00@000000P1DONh01P000000?EV[05AmkP1DONh0e3dI00000080EGk]00<0000005En
k@1EO^d00P1EO^d200000080E7cV00<0000005AliP1DO>H00P000002051ee`80000000@0AfVk0=@m
6@00000000001`3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI
0?ofkP3om^h03P3om^h0103D?AT0ooK^0?ofkP3D?AT;0?ofkP030000003om^h0ooK^00D0ooK^0P3D
?ATF0?ofkP030=@m6@3om^h0ooK^00X0ooK^00<000000?ofkP3om^h0AP3om^h10?ooo`00B03om^h0
0`000000ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^01@0ooK^A@3D?AT2000000040=@m6@0A6Ch0
0000000000<05b=E00P0000001lbL00O<W007c9`0000000O<W00000002]3SP8000000`0[@hh01000
0000:d>>0000003D?AT200000080=52V00@0000003A@YP0dD:H0=52V0`00000203aK^@030000003h
B1h0n4PN00<0n4PN00D000000?Q87P0mFJ/0n4PN000000030?Q87P030000003hB1h0n4PN0080n4PN
00<000000?Q87P3hB1h00P3hB1h01@0mFJ/0n4PN0?Q87P3hB1h0000000@0n4PN00<000000?Q87P3h
B1h00P3hB1h01@000000n4PN0?Q87P3hB1h0?EV[00@0n4PN00<000000?Q87P3hB1h00P3hB1h02@00
0000n4PN0?Q87P3hB1h000000?Q87P0mFJ/0n4PN000000050?Q87P030000001BN^/0000000<00000
0`1DONh00`000000E7g^05AmkP02000000040=@m6@000000EGk]000000<0EGk]0P000000101EO^d0
000005AliP00000305AliP040000001@MML0D7GG051ee`<0000000<0e3dI000000000000A@3D?ATF
0?ofkP030=@m6@3om^h0ooK^00X0ooK^00<000000?ofkP3om^h0AP3om^h10?ooo`00B03om^h00`00
0000ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^01@0ooK^0P3D?AT70?ofkP030000003om^h0ooK^
00T0ooK^00@0e3dI0?ofkP3om^h0e3dI403om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0
ooK^00/0ooK^00<0e3dI0?ofkP3om^h01@3om^h2000000050=@m6@000000000001LSE@0000000P0G
8eD2000000<07c9`00<0000001lbL00000000P0[@hh010000000:d>>02]3SP0[@hh2000000040=@m
6@0dD:H0=52V00000080=52V00D0000003A@YP0dD:H0=52V0000000203aK^@040000000lFkT00000
000000<0n4PN00<000000?Q87P0mFJ/00P3hB1h01@000000n4PN0?Q87P3hB1h0000000@0n4PN00D0
00000?Q87P3hB1h0n4PN03eIZ`040?Q87P050000003hB1h0n4PN0?Q87P0000000`3hB1h00`000000
n4PN0?Q87P020?Q87P0503eIZ`3hB1h0n4PN0?Q87P000000103hB1h01@000000n4PN0?Q87P3hB1h0
00000080n4PN00<0?EV[0?Q87P0000000`3hB1h200000005059jj`000000DW[[059jj`0000000`1D
ONh010000000E7g^05AmkP00000205AmkP030=@m6@000000000000<0EGk]00H0000005Enk@1EO^d0
000005AliP00000305AliP8000000P1@MML01P000000D7GG000000000000e3dI000000P0ooK^00<0
e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00h0ooK^00@0
e3dI0?ofkP3om^h0e3dI2`3om^h00`000000ooK^0?ofkP050?ofkP80e3dI5P3om^h00`3D?AT0ooK^
0?ofkP0:0?ofkP030000003om^h0ooK^04H0ooK^0@3oool004T0ooK^00<000000?ofkP3om^h02@3o
m^h00`3D?AT0ooK^0?ofkP0E0?ofkP030=@m6@3om^h0ooK^00D0ooK^00<000000?ofkP3om^h02@3o
m^h0103D?AT0ooK^0?ofkP3D?AT@0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h0
2`3om^h00`3D?AT0ooK^0?ofkP060?ofkP040000003D?AT00000000000805b=E00D0000001LSE@00
00007c9`0000000301lbL08000000`0[@hh01P000000:d>>02]3SP0[@hh000000=@m6@<0=52V00<0
000003A@YP0dD:H00P0000000`0dD:H000000000000203aK^@040000000lFkT0?5^i000000<0n4PN
00<0000003eIZ`3hB1h00P3hB1h010000000n4PN0?Q87P0000040?Q87P060000003hB1h0n4PN0?Q8
7P0mFJ/000000`3hB1h01@000000n4PN0?Q87P3hB1h0000000<0n4PN00H000000?Q87P3hB1h0n4PN
0000000mFJ/30?Q87P030000003hB1h0n4PN0080n4PN00@000000?Q87P3hB1h000000`3hB1h00`0m
FJ/000000?Q87P020?Q87P040000001BN^/0DW[[00000080DW[[0P0000000`1DONh0000000000002
05AmkP060000001DONh0E7g^05AmkP3D?AT000000`1EO^d010000000EGk]05Enk@1EO^d2000000<0
E7cV00D0000005AliP000000D7GG00000002051ee`0400000017JK/0e3dI000000P0ooK^00<0e3dI
0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00h0ooK^00@0e3dI
0?ofkP3om^h0e3dI2`3om^h00`000000ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^01D0ooK^00<0
e3dI0?ofkP3om^h02@3om^h00`000000ooK^0?ofkP170?ofkP40oooo00190?ofkP030000003om^h0
ooK^00T0ooK^00<0e3dI0?ofkP3om^h0503om^h20=@m6@L0ooK^00<000000?ofkP3om^h0203om^h0
1@3D?AT0ooK^0?ofkP3om^h0e3dI0100ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?of
kP0;0?ofkP030=@m6@3om^h0ooK^00H0ooK^00@000000=@m6@0A6Ch000000`0G8eD2000000807c9`
00D0000001lbL00O<W007c9`0000000402]3SP060000000[@hh0:d>>0000003D?AT000000`0dD:H0
10000000=52V03A@YP0dD:H20000000403aK^@000000000003aK^@80000000<0?5^i0000003hB1h0
0P3hB1h00`0mFJ/0n4PN0?Q87P020?Q87P040000003hB1h0n4PN000000@0n4PN00D000000?Q87P3h
B1h0?EV[000000030?Q87P050000003hB1h0n4PN0?Q87P0000000`3hB1h01P000000n4PN0?Q87P3h
B1h0000003eIZ`80n4PN00<000000?Q87P3hB1h00P3hB1h010000000n4PN0?Q87P0000040?Q87P06
03eIZ`3hB1h0n4PN0?Q87P000000DW[[0P000000101BN^/000000000001BN^/2000000<0E7g^00L0
000005AmkP1DONh0E7g^0000003D?AT000000080EGk]00<0000005Enk@1EO^d00P1EO^d01@000000
E7cV05AliP1DO>H000000080E7cV0P000003051ee`0400000017JK/0e3dI000000P0ooK^00<0e3dI
0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00h0ooK^00D0e3dI
0?ofkP3om^h0ooK^0=@m6@0:0?ofkP030000003om^h0ooK^00D0ooK^0P3D?ATF0?ofkP030=@m6@3o
m^h0ooK^00T0ooK^00<000000?ofkP3om^h0A`3om^h10?ooo`00B@3om^h00`000000ooK^0?ofkP09
0?ofkP030=@m6@3om^h0ooK^01@0ooK^0P3D?AT70?ofkP030000003om^h0ooK^00P0ooK^00D0e3dI
0?ofkP3om^h0ooK^0=@m6@0@0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h02`3o
m^h00`3D?AT0ooK^0?ofkP060?ofkP030000003D?AT00000008000000P0G8eD2000000<07c9`00<0
000001lbL00O<W000P00000402]3SP<0000000<0e3dI03A@YP0000000`0dD:H01@000000=52V03A@
YP0dD:H0000000<0?5^i00H0000003aK^@0lFkT0000003aK^@0000020?Q87P0303eIZ`000000e3dI
0080n4PN00D000000?Q87P3hB1h0n4PN000000030?Q87P050000003hB1h0n4PN03eIZ`0000000`3h
B1h01@000000n4PN0?Q87P3hB1h0000000<0n4PN00H000000?Q87P3hB1h0n4PN0000000mFJ/20?Q8
7P050000003hB1h0n4PN0?Q87P0000000`3hB1h01P000000n4PN0?Q87P3hB1h0000003eIZ`80n4PN
00H00000059jj`000000DW[[03eIZ`000003059jj`050000001DONh0E7g^05AmkP0000000`1DONh0
10000000E7g^0=@m6@1EO^d2000000@0EGk]0P00000205AliP040000001DO>H0E7cV05AliP800000
0P1@MML3000000030=@m6@000000ooK^00L0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^
0?ofkP030?ofkP030=@m6@3om^h0ooK^00h0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0:0?ofkP03
0000003om^h0ooK^00D0ooK^0P3D?ATF0?ofkP030=@m6@3om^h0ooK^00T0ooK^00<000000?ofkP3o
m^h0A`3om^h10?ooo`00BP3om^h00`000000ooK^0?ofkP080?ofkXT0e3dI00D000000?Q87P3hB1h0
n4PN000000030?Q87P040000003hB1h0n4PN000000@0n4PN00D000000?Q87P0mFJ/0n4PN00000002
0?Q87P050000003hB1h0n4PN0?Q87P0000000`3hB1h020000000n4PN0?Q87P000000n4PN03eIZ`3h
B1h00000103hB1h010000000n4PN0?Q87P0000030?Q87P050000003hB1h0n4PN0?Q87P000000R@3D
?AT:0?ofkP030000003om^h0ooK^04P0ooK^0@3oool004X0ooK^00<000000?ofkP3om^h0203om^h0
0`3D?AT0ooK^0?ofkP0D0?ofkP80e3dI1P3om^h00`000000ooK^0?ofkP090?ofkP050=@m6@3om^h0
ooK^0?ofkP3D?AT03`3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0
e3dI0?ofkP3om^h01`3om^h00`000000e3dI014I?P020000000301LSE@0000005b=E00800000100O
<W02000000<0:d>>00<0000002]3SP0[@hh00P0[@hh0103D?AT0=52V03A@YP0dD:H2000000<0=52V
0P00000203aK^@030000000lFkT0?5^i0080000000<0?5^i0000000000004@0000000`0mFJ/00000
0000000?0000000303eIZ`00000000000140000000<0DW[[0000000000000P1BN^/00`000000DW[[
059jj`02000000<0E7g^0P00000305AmkP030=@m6@1EO^d0EGk]0080EGk]00@0000005Enk@1EO^d0
EGk]0P00000405AliP80000000<0D7GG0000001@MML00P0000000`17JK/0e3dI000000090?ofkP03
0=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP0=0?ofkP05
0=@m6@3om^h0ooK^0?ofkP3D?AT02`3om^h00`000000ooK^0?ofkP040?ofkP80e3dI5P3om^h00`3D
?AT0ooK^0?ofkP080?ofkP030000003om^h0ooK^04P0ooK^0@3oool004X0ooK^00<000000?ofkP3o
m^h0203om^h00`3D?AT0ooK^0?ofkP0D0?ofkP80e3dI1P3om^h00`000000ooK^0?ofkP090?ofkP05
0=@m6@3om^h0ooK^0?ofkP3D?AT03`3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^
00X0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`000000e3dI014I?P020000000601LSE@0000005b=E
0000000O<W000000100O<W000`000000:d>>02]3SP0202]3SP050000000[@hh0:d>>02]3SP3D?AT0
0P00000303A@YP050000000dD:H0=52V03A@YP0000000`0lFkT200000080?5^i00<0000003aK^@0l
FkT00P0000030?e:7`030000003mBQl0?EV[0080?EV[0P3mBQl020000000oDXO0?e:7`3mBQl00000
03eIZ`3mBQl000000P3mBQl01@000000oDXO0?e:7`3mBQl0000000<0oDXO00L000000?e:7`3mBQl0
00000?e:7`0mFJ/0000000<0oDXO00<000000?e:7`3mBQl00`0mFJ/0103mBQl000000?e:7`3mBQl3
00000080DW[[00<00000059jj`1BN^/00P000003059jj`050000001DONh0E7g^05AmkP0000000`1D
ONh2000000050=@m6@1EO^d0EGk]05Enk@000000101EO^d00`000000E7cV05AliP0205AliP060000
001DO>H00000051ee`000000D7GG0`0000000`3D?AT000000?ofkP080?ofkP030=@m6@3om^h0ooK^
00X0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP0=0?ofkP050=@m6@3om^h0ooK^
0?ofkP3D?AT02`3om^h00`000000ooK^0?ofkP040?ofkP80e3dI5@3om^h00`3D?AT0ooK^0?ofkP09
0?ofkP030000003om^h0ooK^04P0ooK^0@3oool004/0ooK^00<000000?ofkP3om^h0203om^h00`3D
?AT0ooK^0?ofkP0C0?ofkP80e3dI1P3om^h00`000000ooK^0?ofkP090?ofkP050=@m6@3om^h0ooK^
0?ofkP3D?AT03`3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI
0?ofkP3om^h01`3om^h01@000000e3dI0000000A6Ch0000000805b=E00D0000001LSE@0000007c9`
0000000301lbL0<000000`0[@hh20000000402]3SP3D?AT0=52V03A@YP8000000P0dD:H00`000000
=52V03A@YP03000000<0?5^i00@0000003aK^@0lFkT000000P0lFkT00`000000@VC8000000020?e:
7`8000000P3mBQl503eIZ`030?e:7`000000?EV[0080oDXO00<000000?e:7`0000000`3mBQl01`00
0000oDXO0?e:7`3mBQl000000?e:7`0000000P3mBQl00`0mFJ/000000?e:7`0503eIZ`80oDXO0P00
00020?e:7`030000001?M^H000000080DW[[00@00000059jj`1BN^/000000`1BN^/300000080E7g^
00<0000005AmkP1DONh00P00000205AmkP040=@m6@1EO^d00000000000<0EGk]0`00000305AliP05
0000001DO>H00000051ee`0000000P1@MML01@000000AfVk0000003D?AT0000000T0ooK^00<0e3dI
0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI
0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP090?ofkP030000003om^h0ooK^00<0ooK^00<0e3dI
0?ofkP3D?AT05@3om^h00`3D?AT0ooK^0?ofkP080?ofkP030000003om^h0ooK^04T0ooK^0@3oool0
04/0ooK^00<000000?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP0B0?ofkP040=@m6@3om^h0ooK^
0=@m6@D0ooK^00<000000?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0
ooK^00`0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0
ooK^00L0ooK^00H000000=@m6@0000004ATn03eIZ`00000201LSE@8000000P0O<W020000000501lb
L0000000:d>>02]3SP000000100[@hh00`000000e3dI03A@YP0303A@YP030000000dD:H0=52V00<0
00000P0lFkT200000080?5^i0P0000000`0lFkT000000000000200000003049Tb0000000oDXO0080
oDXO00@000000?e:7`3mBQl000000P3mBQl00`000000?EV[03eIZ`0E03eIZ`040000003mBQl0oDXO
00000080oDXO00<000000?e:7`3mBQl00P0000000`1?M^H000000000000200000003059jj`000000
00000080DW[[0P000002059jj`<000000P1DONh00`000000E7g^05AmkP0205AmkP030=@m6@000000
EGk]00<0EGk]00D0000005Enk@1EO^d0000005AliP0200000080E7cV0P000002051ee`060000000m
FJ/000000000003D?AT000002@3om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^00D0
ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00P0
ooK^00<000000?ofkP3om^h00`3om^h0103D?AT0ooK^0?ofkP3D?ATD0?ofkP030=@m6@3om^h0ooK^
00P0ooK^00<000000?ofkP3om^h0B@3om^h10?ooo`00B`3om^h00`000000ooK^0?ofkP080?ofkP03
0=@m6@3om^h0ooK^0180ooK^00@0e3dI0?ofkP3om^h0e3dI1@3om^h00`000000ooK^0?ofkP080?of
kP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP050?of
kP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`000000e3dI000000030000
00<05b=E00<0000003eIZ`0O<W000P0O<W000`0000007c9`0000000202]3SP8000000`0[@hh00`3D
?AT0000003A@YP0303A@YP8000000P0dD:H00`000000?5^i03aK^@0203aK^@050000000lFkT0?5^i
03aK^@0000000P0lFkT01P000000@VC80=@m6@000000@VC800000080oDXO00@000000?e:7`3mBQl0
00000P3mBQl01P000000oDXO03eIZ`000000oDXO00000080oDXO00@000000?e:7`3mBQl000000P3m
BQl02@000000oDXO0?e:7`000000oDXO0000000mFJ/0oDXO000000020?e:7`040000003mBQl0oDXO
00000080oDXO00H0000004mfiP000000e3dI04mfiP000002059jj`050000001BN^/0DW[[059jj`00
0000101BN^/00`000000E7g^05AmkP02000000D0E7g^00@0e3dI05Enk@1EO^d0EGk]0P00000205En
k@030000001DO>H0000000@0E7cV00@00000051ee`1@MML0D7GG100000000`3D?AT000000?ofkP08
0?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP0<
0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h0203om^h00`000000ooK^0?ofkP03
0?ofkP040=@m6@3om^h0ooK^0=@m6A@0ooK^00<0e3dI0?ofkP3om^h0203om^h00`000000ooK^0?of
kP190?ofkP40oooo001<0?ofkP030000003om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h04P3om^i9
0=@m6@<0000000@05b=E0000000G8eD05b=E0P00000401lbL0800000100[@hh01@000000:d>>02]3
SP3D?AT0=52V00800000100dD:H5000000<0?5^i0P00000203aK^@@0000000<0e3dI049Tb0000000
0P0000020?e:7`090000003mBQl0oDXO0000003mBQl000000?e:7`0mFJ/000000080oDXO00<00000
0?e:7`0000000P3mBQl01P000000oDXO0?e:7`000000oDXO00000080oDXO00H0?EV[0?e:7`3mBQl0
00000?e:7`0000020?e:7`030000003mBQl0oDXO00<0000000<0CgKV0=@m6@0000000`000002059j
j`8000000`1BN^/5000000@0E7g^0P0000001@3D?AT0000005Enk@1EO^d0000000@0EGk]0P000004
05AliP8000000P1@MML30000000304MY^`3D?AT0e3dI04P0e3dI4`3om^h00`3D?AT0ooK^0?ofkP08
0?ofkP030000003om^h0ooK^04X0ooK^0@3oool004`0ooK^00<000000?ofkP3om^h0203om^h00`3D
?AT0ooK^0?ofkP0A0?ofkP040=@m6@3om^h0ooK^0=@m6@D0ooK^00<000000?ofkP3om^h0203om^h0
0`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h01@3om^h0
0`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^00P0ooK^00<000000=@m6@0A6Ch00P000000
1P0G8eD0000001LSE@0000007c9`000000@07c9`00<0000002]3SP0[@hh00`0[@hh3000000030=@m
6@0dD:H0=52V00800000100dD:H20000000303aK^@000000000000<0?5^i0P00000203aK^@040000
0012I<P0e3dI00000080@VC80`0000003P3mBQl000000?e:7`3mBQl000000?e:7`000000oDXO03eI
Z`000000oDXO0000003mBQl000000P3mBQl03@000000oDXO0?e:7`000000oDXO0000003mBQl00000
03eIZ`3mBQl000000?e:7`0000000P3mBQl00`000000oDXO000000020000000604mfiP0000000000
0=@m6@1?M^H000000P1BN^/2000000<0DW[[0P000002059jj`030000001DONh0E7g^0080E7g^0P00
000205AmkP040=@m6@0000000000000000D0EGk]00<0000005AliP1DO>H00P1DO>H01P000000E7cV
0000001@MML00000051ee`80000000<0AfVk0=@m6@0000002P3om^h00`3D?AT0ooK^0?ofkP090?of
kP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP030?of
kP030=@m6@3om^h0ooK^00P0ooK^00<000000?ofkP3om^h00`3om^h0103D?AT0ooK^0?ofkP3D?ATC
0?ofkP030=@m6@3om^h0ooK^00P0ooK^00<000000?ofkP3om^h0BP3om^h10?ooo`00C03om^h00`00
0000ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^0140ooK^00@0e3dI0?ofkP3om^h0e3dI103om^h0
0`000000ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h0303om^h0
0`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h0203om^h0
0`000000e3dI014I?P02000000805b=E0P00000201lbL08000000P0O<W03000000D0:d>>00<00000
0=@m6@0dD:H00`0dD:H200000080=52V00D0000003aK^@000000000003aK^@02000000<0?5^i1000
00001@3D?AT0@VC8049Tb0000000@VC800<0000000T0oDXO000000000000oDXO0000003mBQl00000
03eIZ`3mBQl00P0000020?e:7`050000003mBQl000000?e:7`0000000P3mBQl2000000060?e:7`0m
FJ/000000?e:7`000000oDXO0P0000001P3mBQl00000000000000000CgKV00000080CgKV00<0e3dI
0000000000000P000003059jj`80000000D0DW[[000000000000DW[[0000000205AmkP800000101D
ONh00`3D?AT0000005Enk@0405Enk@<000000P1DO>H200000080E7cV0P000002051ee`0500000017
JK/0AfVk0=@m6@0000002P3om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^00D0ooK^
00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00P0ooK^
00<000000?ofkP3om^h00`3om^h0103D?AT0ooK^0?ofkP3D?ATC0?ofkP030=@m6@3om^h0ooK^00P0
ooK^00<000000?ofkP3om^h0BP3om^h10?ooo`00C@3om^h00`000000ooK^0?ofkP070?ofkP030=@m
6@3om^h0ooK^0100ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@040?ofkP030000003om^h0ooK^00P0
ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00H0
ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP080?ofkP050000003D?AT00000014I
?P0000000P0G8eD2000000@07c9`00<0000001lbL00000000P0[@hh2000000<0:d>>00@000000=@m
6@0000000000100dD:H20000000403A@YP000000?5^i03aK^@80000000<0?5^i0000000000000`0l
FkT00`000000@VC80=@m6@0200000004049Tb00000000000049Tb0<0000001/0oDXO0000003mBQl0
00000?e:7`0mFJ/0oDXO0000003mBQl000000?e:7`000000oDXO0000003mBQl000000?e:7`000000
oDXO0000003mBQl0?EV[0?e:7`000000oDXO0000003mBQl00`000000101?M^H000000000001?M^H2
000000030=@m6@1?M^H0000000<0DW[[0P0000000`1BN^/0000000000002059jj`040000001DONh0
0000000000@0E7g^0P0000000`3D?AT0000005Enk@0205Enk@8000000P1EO^d00`000000E7cV0000
000405AliP8000000P1@MML01@000000AfVk0000003D?AT0000000X0ooK^00<0e3dI0?ofkP3om^h0
203om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h0
1@3om^h00`3D?AT0ooK^0?ofkP080?ofkP050000003om^h0ooK^0?ofkP3D?AT0103om^h00`3D?AT0
ooK^0?ofkP0@0?ofkP030=@m6@3om^h0ooK^00L0ooK^00<000000?ofkP3om^h0B`3om^h10?ooo`00
C@3om^h00`000000ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^0100ooK^00<0e3dI0?ofkP3om^h0
0P3om^h01@3D?AT0ooK^0?ofkP3om^h0000000X0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0
ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0
ooK^0?ofkP080?ofkP040000003D?AT00000014I?P8000000P0G8eD00`000000?EV[01lbL00301lb
L0800000100[@hh20000000302]3SP000000e3dI0080=52V0P00000403A@YP<000000`0lFkT50000
000403aK^@000000@VC80=@m6@80@VC80P0000000`12I<P000000000000Q0000000904mfiP000000
000004mfiP000000e3dI04mfiP000000DW[[00D00000101BN^/2000000@0E7g^0P00000205AmkP03
0=@m6@1EO^d0EGk]00800000101EO^d2000000D0E7cV00<00000051ee`1@MML00P0000000`17JK/0
00000=@m6@0;0?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0
ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h0203om^h01@000000
ooK^0?ofkP3om^h0e3dI00@0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP080?of
kP030000003om^h0ooK^04/0ooK^0@3oool004d0ooK^00<000000?ofkP3om^h0203om^h00`3D?AT0
ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^0080ooK^00D0e3dI0?ofkP3om^h0ooK^0000000:0?of
kP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP070?of
kP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h02P3om^h01`3D?AT04ATn000000000000
5b=E0000000G8eD00`00000401lbL0030000000[@hh0:d>>00@0:d>>0P0000000`3D?AT0=52V03A@
YP0203A@YP8000000`0dD:H00`000000?5^i00000002000000<0?5^i100000000`12I<P0e3dI049T
b00200000004049Tb00000000000049Tb0P0000000T0od/P0000003oBb0000000?m;80000000od/P
0000003oBb000`0000000`3oBb0000000?m;80080000000404mfiP000000000004mfiP80000000<0
CgKV0=@m6@1?M^H010000003059jj`<0000000<0DW[[0000001DONh00P1DONh2000000@0E7g^00<0
e3dI0000000000001P1EO^d00`000000E7cV05AliP0205AliP<0000000<0D7GG0000001@MML00P00
00000`17JK/0e3dI0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h01`3o
m^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h0203o
m^h01@000000ooK^0?ofkP3om^h0e3dI00@0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^
0?ofkP080?ofkP030000003om^h0ooK^04/0ooK^0@3oool004h0ooK^00<000000?ofkP3om^h01`3o
m^jD0=@m6@L0000000<0od/P0000000000000P000000103oBb0000000000003oBb03000000030?m;
80000000000000D00000U03D?AT90?ofkP030000003om^h0ooK^04`0ooK^0@3oool004h0ooK^00<0
00000?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^0080ooK^00D0
e3dI0?ofkP3om^h0ooK^0000000:0?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h0
2P3om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h0
2P3om^h0103D?AT00000014I?P00000201LSE@030000000G8eD0000000807c9`0P000000100O<W00
000002]3SP0[@hh2000000@0:d>>00@0e3dI03A@YP00000000001@0dD:H3000000D0?5^i0`000000
100lFkT0?EV[049Tb03D?AT500000003049Tb0000000000000T0000000@0od/P000000000000od/P
1P0000000`3oBb000000000000090000000304mfiP000000000000<0000000@0e3dI04mfiP000000
DW[[0`000006059jj`8000001@1DONh20000000305AmkP3D?AT0EGk]00<0EGk]0P000000101EO^d0
000005AliP1DO>H200000080E7cV00<00000051ee`0000000P1@MML010000000AfVk0000003D?AT<
0?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP0:
0?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h0203om^h01@000000ooK^0?ofkP3o
m^h0e3dI00@0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP070?ofkP030000003o
m^h0ooK^04`0ooK^0@3oool004h0ooK^00<000000?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP0>
0?ofkP030=@m6@3om^h0ooK^00<0ooK^00D0e3dI0?ofkP3om^h0ooK^000000090?ofkP030=@m6@3o
m^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3o
m^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h02P3om^h0103D?AT00000014I?P00000301LSE@800000
100O<W03000000<0:d>>0P00000202]3SP040=@m6@0dD:H0=52V03A@YP<000000`0dD:H00`000000
?5^i00000003000000@0?5^i0`0000000`3D?AT0@VC8049Tb00Y00000080CgKV00@0e3dI04mfiP00
00000000101BN^/400000003059jj`000000E7g^0080E7g^0`00000305AmkP030=@m6@1EO^d0EGk]
008000000`1EO^d3000000@0E7cV0P000003051ee`0400000017JK/000000=@m6@`0ooK^00<0e3dI
0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI
0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP070?ofkP050000003om^h0ooK^0?ofkP3D?AT01@3o
m^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00L0ooK^00<000000?ofkP3om^h0C03o
m^h10?ooo`00C`3om^h00`000000ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI
0?ofkP3om^h0103om^h0103D?AT0ooK^0?ofkP0000090?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0
e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0
e3dI0?ofkP3om^h02P3om^h00`3D?AT0?EV[00000002000000<05b=E00<0000003eIZ`0O<W00100O
<W000`000000:d>>02]3SP0302]3SP80000000<0e3dI03A@YP0dD:H0100dD:H20000000303A@YP00
0000?5^i00@0?5^i10000000100lFkT00000049Tb03D?AT300000080@VC88`00000204mfiP<00000
00@0e3dI04mfiP000000DW[[10000005059jj`040000001DONh00000000000H0E7g^00<0e3dI0000
000000001@1EO^d00`000000E7cV05AliP0405AliP040000001@MML0D7GG051ee`<0000000<0?EV[
0=@m6@3om^h02`3om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI
0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00L0ooK^00@00000
0?ofkP3om^h0e3dI1P3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0
00000?ofkP3om^h0C@3om^h10?ooo`00C`3om^h00`000000ooK^0?ofkP070?ofkP030=@m6@3om^h0
ooK^00d0ooK^CP3D?AT00`0000005b=E0000000201LSE@<00000100O<W03000000D0:d>>00<0e3dI
0000000dD:H01P0dD:H4000000L0?5^i0`000000103D?AT0@VC8049Tb012I<P400000003049Tb000
0000000001/0000000<0CgKV0000000000000P00000304mfiP040=@m6@1?M^H00000000000T0DW[[
0P00000805AmkP030=@m6@1EO^d0EGk]00<0EGk]0`00000405AliP<000000P1@MML00`000000D7GG
0000001>0=@m6@l0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`000000ooK^0?ofkP1=0?ofkP40oooo
001?0?ofkP030000003om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?of
kP040?ofkP030=@m6@3om^h0000000X0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?of
kP080?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?of
kP0;0?ofkP050=@m6@0mFJ/000000000000G8eD00`00000201lbL08000000P0O<W000`000000:d>>
02]3SP02000000<0:d>>00<000000=@m6@0000000P00000503A@YP030000000lFkT0?5^i00H00000
0P0lFkT00`000000@VC80=@m6@0600000003049Tb0000000000001d0000000<0CgKV000000000000
100000000`3D?AT0CgKV00000002059jj`H000000P1BN^/00`000000E7g^05AmkP0305AmkP<00000
00<0e3dI0000001EO^d00P1EO^d200000080EGk]00<0000005AliP1DO>H00P0000000`1DO>H00000
051ee`0200000005051ee`000000000003eIZ`3D?AT03@3om^h00`3D?AT0ooK^0?ofkP060?ofkP03
0=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP070?ofkP03
0=@m6@3om^h0ooK^00P0ooK^00<000000?ofkP3D?AT01P3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP03
0=@m6@3om^h0ooK^00L0ooK^00<000000?ofkP3om^h0C@3om^h10?ooo`00C`3om^h00`000000ooK^
0?ofkP070?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^
000000090?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^
0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h0303om^h0103D?AT0?EV[
03eIZ`00000201LSE@030=@m6@000000000000<07c9`0`00000402]3SP80000000<0:d>>0000003D
?AT00`0dD:H40000000303A@YP000000?5^i00L0?5^i10000000103D?AT00000000000000003049T
b24000001P1?M^H00`3D?AT0CgKV00000002000000P0DW[[00<0000005AmkP0000000`00000305Am
kP030=@m6@000000EGk]00800000101EO^d3000000<0E7cV0P000000103D?AT0D7GG051ee`000002
03eIZ`030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP0:
0?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP07
0?ofkP030000003om^h0e3dI00L0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP07
0?ofkP030000003om^h0ooK^04d0ooK^0@3oool00500ooK^00<000000?ofkP3om^h01`3om^h00`3D
?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0000003om^h0203om^h00`3D
?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D
?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00`0ooK^00@0e3dI03eIZ`0mFJ/00000100G8eD0
0`0000007c9`01lbL00301lbL08000001@0[@hh2000000030=@m6@000000=52V00D0=52V1`000005
03aK^@0300000012I<P0e3dI00<0@VC89`00000304mfiP030=@m6@1?M^H0000000D0DW[[1`000007
05AmkP030=@m6@000000000000H0EGk]00<0000005AliP1DO>H00`1DO>H00`000000D7GG051ee`02
051ee`040000000mFJ/0?EV[0=@m6@h0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?of
kP0:0?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?of
kP070?ofkP030000003D?AT0ooK^00L0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?of
kP070?ofkP030000003om^h0ooK^04h0ooK^0@3oool00500ooK^00<000000?ofkP3om^h01`3om^h0
0`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0000003om^h0203om^h0
0`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h02P3om^h0
0`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00`0ooK^00D0e3dI03eIZ`0mFJ/0ooK^0000
000301LSE@0303eIZ`000000000000<07c9`00@0000002]3SP0000000000100[@hh00`000000e3dI
03A@YP0500000080=52V00<0000003aK^@0lFkT00`0lFkT7000000030=@m6@000000000002/00000
00<0e3dI0000000000001@000005059jj`030000001DONh0E7g^00D0000000<0E7g^0=@m6@000000
101EO^d20000000305Enk@000000E7cV0080E7cV0`000003051ee`050000003om^h0?EV[03eIZ`3D
?AT03P3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3o
m^h01P3om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^00L0ooK^00<000000=@m6@3o
m^h0203om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00L0ooK^00<000000?ofkP3o
m^h0CP3om^h10?ooo`00D03om^h00`000000ooK^0?ofkP070?ofkY80e3dI6`00002B0=@m6@T0ooK^
00<000000?ofkP3om^h0CP3om^h10?ooo`00D@3om^h00`000000ooK^0?ofkP060?ofkP030=@m6@3o
m^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT000000?ofkP070?ofkP030=@m6@3o
m^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3o
m^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h03@3om^h02@3D?AT0?EV[03eIZ`0mFJ/0ooK^0=@m6@00
00005b=E0000000301lbL0<000001@0[@hh20000000302]3SP3D?AT0=52V00L0=52V00<0000003aK
^@0lFkT00`0lFkT7000000030=@m6@0000000000008000000`12I<P60000000304M[e00000000000
0080000000<0oD`P0000003mC2000`0000000`3mC20000000?e<80040000000304aagP0000000000
00@000000`1?M^H4000000030=@m6@000000000000D000001@1BN^/00`000000E7g^05AmkP0605Am
kP040=@m6@1EO^d00000000000D0EGk]0`00000305AliP050000001@MML000000=@m6@3om^h00`0m
FJ/00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h02`3o
m^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h01P3o
m^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h01`3o
m^h00`000000ooK^0?ofkP1?0?ofkP40oooo001A0?ofkP030000003om^h0ooK^00L0ooK^00<0e3dI
0?ofkP3om^h0203om^iH0=@m6@D07c9`0P00000602]3SP030000003D?AT0000000<00000100dD:H0
0`000000?5^i03aK^@0803aK^@040000000mFJ/0e3dI049Tb0H0000000D0@VC80000000000000000
04M[e005000000070?e<8000000000000000003mC20000000?e<8003000000030?e<800000000000
00<0000000D0C77N000000000000000004mfiP050000000404mfiP3D?AT0CgKV000000/0DW[[00<0
000005AmkP1DONh00P1DONh4000000030=@m6@000000EGk]00H0EGk]00<0000005AliP1DO>H00`1D
O>IH0=@m6@X0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`000000ooK^0?ofkP1?0?ofkP40oooo001A
0?ofkP030000003om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP0:
0?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP04
0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP0=
0?ofkP030=@m6@0mFJ/0ooK^0080?EV[00<0e3dI0?ofkP3om^h00P00000401lbL0030000000[@hh0
000000800000100[@hh00`3D?AT0=52V03A@YP0203A@YQ80000000@0e3dI049Tb012I<P0@VC81000
00000`12I<P000000000000I0000000304mfiP0000000000008000000`1?M^H00`3D?AT000000000
000@000000<0E7g^00<0e3dI0000001EO^d00`1EO^d30000000305Enk@000000E7cV00<0E7cV0P00
00020?ofkP050=@m6@0mFJ/0?EV[0?ofkP3D?AT0403om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m
6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m
6@3om^h0ooK^00D0ooK^00<0e3dI0000003om^h02`3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m
6@3om^h0ooK^00P0ooK^00<000000?ofkP3om^h0C`3om^h10?ooo`00DP3om^h00`000000ooK^0?of
kP070?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`000000e3dI0?of
kP050?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?of
kP0=0?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h03`3om^h01@3D?AT0?EV[03eI
Z`0mFJ/0e3dI00<0ooK^00<0?EV[0000000000000P0O<W000`000000:d>>02]3SP0202]3SP<00000
00<0:d>>0000003D?AT01`0dD:H00`000000?5^i03aK^@0903aK^@0303eIZ`12I<P0e3dI00<00000
00<0@VC80000000000001`000000100mFJ/000000000000000020>m97`050000003_BAl000000>m9
7`0000000P3_BAl30000000303eIZ`000000000000L0000000P0CgKV00000000000000000=@m6@1?
M^H0000003eIZ`X0DW[[00<0000005AmkP1DONh01@1DONh00`3D?AT0000005Enk@03000000<0EGk]
00@0000005AliP1DO>H0E7cV0P0000001@0mFJ/0ooK^0?ofkP3om^h0e3dI00<0?EV[00<0e3dI0?of
kP3om^h03`3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?of
kP3om^h00`3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0000
003om^h02`3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00L0ooK^00<000000?of
kP3om^h0D03om^h10?ooo`00DP3om^h00`000000ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00D0
ooK^00<0e3dI0?ofkP3om^h02P3om^h00`000000ooK^0=@m6@060?ofkP030=@m6@3om^h0ooK^00d0
ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP050=@m6@3om^h0ooK^0?of
kP3D?AT04@3om^h0103D?AT0?EV[03eIZ`3D?AT40?ofkP80?EV[00D0ooK^0000000000007c9`0000
000602]3SP80000000@0e3dI00000000000000001@0dD:H00`000000?5^i03aK^@0303aK^@L00000
00<0@VC80000000000002@0000001@3_BAl0000003eIZ`3_BAl000000080kdTO00@000000>m97`3_
BAl000000P3_BAl020000000kdTO0>m97`000000kdTO03eIZ`000000kdTO2`0000000`1?M^H00000
00000005000000D0DW[[00<0000005AmkP1DONh00`1DONh3000000030=@m6@000000000000H0EGk]
00D0000005AliP00000000000?ofkP0203eIZ`@0ooK^00@0e3dI03eIZ`0mFJ/0e3dI4@3om^h01@3D
?AT0ooK^0?ofkP3om^h0e3dI0100ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP0=
0?ofkP030=@m6@3om^h0ooK^00<0ooK^00@0e3dI0?ofkP3om^h00000303om^h00`3D?AT0ooK^0?of
kP040?ofkP030=@m6@3om^h0ooK^00P0ooK^00<000000?ofkP3om^h0D03om^h10?ooo`00DP3om^h0
0`000000ooK^0?ofkP080?ofkX<0e3dI1`00000303eIZ`L0000000<0?EV[0000000000003@000000
0`0mFJ/0000000000005000000<0?EV[1`0000230=@m6@X0ooK^00<000000?ofkP3om^h0D03om^h1
0?ooo`00D`3om^h00`000000ooK^0?ofkP080?ofkP80e3dI0P3om^iU0=@m6@0303eIZ`0000000000
0080:d>>00<000000=@m6@3D?AT01`0dD:H00`000000?5^i03aK^@080000000303eIZ`3:?a/00000
00H000001@0mFJ/00`3:?a/0000003eIZ`030<Xo6`050000003:?a/0bSlK0<Xo6`0000000`3:?a/0
1`000000bSlK0<Xo6`3:?a/0?EV[0000003:?a/01@0mFJ/7000000030<Xo6`0mFJ/0000000L00000
0P1BN^/00`000000E7g^05AmkP0505AmkP80e3dI00<0000005Enk@1EO^d00P0000000`0mFJ/0e3dI
0=@m6@1S0=@m6@80ooK^0P3D?AT:0?ofkP030000003om^h0ooK^0540ooK^0@3oool005<0ooK^00<0
00000?ofkP3om^h02P3om^ic0=@m6@0303eIZ`000000000000/0000000<0?EV[0000000000002`00
000E03eIZ`d0000000<0?EV[0000000000002`0000000`0mFJ/0e3dI0=@m6@1a0=@m6@`0ooK^00<0
00000?ofkP3om^h0D@3om^h10?ooo`00D`3om^h00`000000ooK^0?ofkP0K0?ofkP030000003om^h0
ooK^04<0ooK^0P0mFJ/20?ofkP0403eIZ`3om^h0ooK^03eIZ`@0ooK^00D0?EV[0?ofkP3om^h0ooK^
03eIZ`080?ofkP0403eIZ`3om^h0ooK^03eIZ`d0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0
ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h02`3om^h0100mFJ/0
ooK^0?ofkP0mFJ/80?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/0103om^h01@0mFJ/0ooK^0?ofkP0m
FJ/0ooK^00<0?EV[A@3om^h00`000000ooK^0?ofkP0K0?ofkP030000003om^h0ooK^0540ooK^0@3o
ool005@0ooK^00<000000?ofkP3om^h06P3om^h00`000000ooK^0?ofkP130?ofkP<0?EV[0P3om^h0
100mFJ/0ooK^0?ofkP0mFJ/40?ofkP0403eIZ`3om^h0ooK^03eIZ`T0ooK^0`0mFJ/=0?ofkP0303eI
Z`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eI
Z`3om^h0ooK^00/0ooK^0`0mFJ/90?ofkP0403eIZ`3om^h0ooK^03eIZ`@0ooK^00@0?EV[0?ofkP3o
m^h0?EV[0P3om^h303eIZdD0ooK^00<000000?ofkP3om^h06P3om^h00`000000ooK^0?ofkP1B0?of
kP40oooo001D0?ofkP030000003om^h0ooK^01X0ooK^00<000000?ofkP3om^h0@`3om^h303eIZ`80
ooK^00@0?EV[0?ofkP3om^h0?EV[1@3om^h0100mFJ/0ooK^0?ofkP0mFJ/:0?ofkP80?EV[303om^h0
0`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h03@3om^h0
0`0mFJ/0ooK^0?ofkP0:0?ofkP80?EV[2P3om^h0100mFJ/0ooK^0?ofkP0mFJ/50?ofkP0403eIZ`3o
m^h0ooK^03eIZ`80ooK^0`0mFJ]50?ofkP030000003om^h0ooK^01X0ooK^00<000000?ofkP3om^h0
DP3om^h10?ooo`00E03om^h00`000000ooK^0?ofkP0J0?ofkP030000003om^h0ooK^04<0ooK^0`0m
FJ/30?ofkP0303eIZ`3om^h0?EV[00H0ooK^00<0?EV[0?ofkP0mFJ/02P3om^h00`0mFJ/0ooK^03eI
Z`0203eIZ`T0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3o
m^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h01`3om^h303eIZ`030?ofkP0mFJ/0ooK^00T0ooK^00<0
?EV[0?ofkP0mFJ/01P3om^h00`0mFJ/0ooK^03eIZ`030?ofkP<0?EV[A@3om^h00`000000ooK^0?of
kP0J0?ofkP030000003om^h0ooK^0580ooK^0@3oool005D0ooK^00<000000?ofkP3om^h0603om^h0
0`000000ooK^0?ofkP140?ofkP<0?EV[103om^h203eIZ`L0ooK^0P0mFJ/:0?ofkP0303eIZ`3om^h0
ooK^0080ooK^0P0mFJ/70?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h03@3om^h0
0`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00D0ooK^0P0mFJ/40?ofkP0303eIZ`3om^h0
ooK^00P0ooK^0P0mFJ/70?ofkP80?EV[103om^h303eIZdH0ooK^00<000000?ofkP3om^h0603om^h0
0`000000ooK^0?ofkP1C0?ofkP40oooo001E0?ofkP030000003om^h0ooK^01P0ooK^00<000000?of
kP3om^h0A03om^h303eIZ`@0ooK^0P0mFJ/80?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?of
kP3om^h0103om^h303eIZ`@0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0=0?of
kP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h00P3om^h303eIZ`H0ooK^00<0?EV[0?of
kP3om^h0203om^h00`0mFJ/0ooK^0?ofkP060?ofkP80?EV[103om^h303eIZdH0ooK^00<000000?of
kP3om^h0603om^h00`000000ooK^0?ofkP1C0?ofkP40oooo001E0?ofkP030000003om^h0ooK^01P0
ooK^00<000000?ofkP3om^h0A03om^h403eIZ`@0ooK^00<0?EV[0?ofkP3om^h01P3om^h303eIZ`P0
ooK^00<0?EV[0?ofkP3om^h01`3om^h303eIZ`030?ofkP0mFJ/0ooK^00h0ooK^00<0?EV[0?ofkP3o
m^h03@3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0?EV[0080?EV[2@3om^h00`0mFJ/0
ooK^0?ofkP060?ofkP<0?EV[203om^h00`0mFJ/0ooK^0?ofkP020?ofkP@0?EV[AP3om^h00`000000
ooK^0?ofkP0H0?ofkP030000003om^h0ooK^05<0ooK^0@3oool005H0ooK^00<000000?ofkP3om^h0
5`3om^h00`000000ooK^0?ofkP140?ofkP@0?EV[103om^h203eIZ`L0ooK^00@0?EV[0?ofkP3om^h0
?EV[1`3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP@0?EV[3@3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP03
03eIZ`3om^h0ooK^00/0ooK^100mFJ/<0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00@0?EV[0?ofkP3o
m^h0?EV[1`3om^h203eIZ`@0ooK^100mFJ]60?ofkP030000003om^h0ooK^01L0ooK^00<000000?of
kP3om^h0E03om^h10?ooo`00EP3om^h00`000000ooK^0?ofkP0G0?ofkP030000003om^h0ooK^04@0
ooK^0P0mFJ/00`3om^h0?EV[03eIZ`030?ofkP0303eIZ`3om^h0?EV[00H0ooK^00@0?EV[0?ofkP3o
m^h0ooK^0P0mFJ/60?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h01@0mFJ/80?of
kP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h01P3om^h503eIZ`80ooK^00<0?EV[0?of
kP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP040?ofkP80?EV[0`3om^h00`0mFJ/0ooK^0?ofkP040?of
kP0303eIZ`3om^h0?EV[00<0ooK^0P0mFJ/00`3om^h0?EV[03eIZ`160?ofkP030000003om^h0ooK^
01L0ooK^00<000000?ofkP3om^h0E03om^h10?ooo`00EP3om^h00`000000ooK^0?ofkP0G0?ofkP03
0000003om^h0ooK^04D0ooK^0`0mFJ/01@3om^h0?EV[0?ofkP3om^h0?EV[0080ooK^00<0?EV[0?of
kP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?of
kP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP050?ofkPH0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP0=0?of
kP0303eIZ`3om^h0ooK^00H0?EV[1`3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^
00<0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0403eIZ`3om^h0ooK^
03eIZ`80ooK^00<0?EV[0?ofkP0mFJ/00P0mFJ]70?ofkP030000003om^h0ooK^01L0ooK^00<00000
0?ofkP3om^h0E03om^h10?ooo`00E`3om^h00`000000ooK^0?ofkP0F0?ofkP030000003om^h0ooK^
04D0ooK^0`0mFJ/01@3om^h0?EV[0?ofkP3om^h0?EV[00<0ooK^00<0?EV[0?ofkP3om^h00P3om^h0
0`0mFJ/0ooK^0?ofkP040?ofkP80?EV[0`3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0
ooK^00/0ooK^5@0mFJ/=0?ofkP0303eIZ`3om^h0ooK^00X0ooK^00@0?EV[0?ofkP3om^h0ooK^0P0m
FJ/50?ofkP0303eIZ`3om^h0ooK^00<0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`020?ofkP0303eI
Z`3om^h0?EV[0080?EV[A`3om^h00`000000ooK^0?ofkP0F0?ofkP030000003om^h0ooK^05D0ooK^
0@3oool005L0ooK^00<000000?ofkP3om^h05P3om^h00`000000ooK^0?ofkP150?ofkP0303eIZ`3o
m^h0?EV[0080ooK^00<0?EV[0?ofkP0mFJ/0103om^h203eIZ`<0ooK^00<0?EV[0?ofkP3om^h01@3o
m^h0100mFJ/0ooK^0?ofkP0mFJ/<0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h0
3@3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00X0ooK^00@0?EV[0?ofkP3om^h0
?EV[1`3om^h0100mFJ/0ooK^0?ofkP3om^h203eIZ`<0ooK^00@0?EV[0?ofkP3om^h0?EV[0P3om^h0
0`0mFJ/0ooK^03eIZ`170?ofkP030000003om^h0ooK^01H0ooK^00<000000?ofkP3om^h0E@3om^h1
0?ooo`00E`3om^h00`000000ooK^0?ofkP0F0?ofkP030000003om^h0ooK^04D0ooK^00<0?EV[0?of
kP0mFJ/00P3om^h0100mFJ/0ooK^0?ofkP0mFJ/50?ofkP0403eIZ`3om^h0ooK^03eIZ`P0ooK^0`0m
FJ/<0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?of
kP0=0?ofkP0303eIZ`3om^h0ooK^00X0ooK^0`0mFJ/80?ofkP0403eIZ`3om^h0ooK^03eIZ`D0ooK^
00@0?EV[0?ofkP3om^h0?EV[0P3om^h00`0mFJ/0ooK^03eIZ`170?ofkP030000003om^h0ooK^01H0
ooK^00<000000?ofkP3om^h0E@3om^h10?ooo`00E`3om^h00`000000ooK^0?ofkP0E0?ofkP030000
003om^h0ooK^04H0ooK^00@0?EV[0?ofkP0mFJ/0?EV[0P3om^h00`0mFJ/0ooK^03eIZ`060?ofkP03
03eIZ`3om^h0?EV[00X0ooK^0P0mFJ/<0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3o
m^h03@3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00X0ooK^0P0mFJ/:0?ofkP03
03eIZ`3om^h0?EV[00H0ooK^00<0?EV[0?ofkP0mFJ/00P3om^h203eIZ`030?ofkP0mFJ/0ooK^04L0
ooK^00<000000?ofkP3om^h05@3om^h00`000000ooK^0?ofkP1E0?ofkP40oooo001H0?ofkP030000
003om^h0ooK^01@0ooK^00<000000?ofkP3om^h0AP3om^h0100mFJ/0ooK^0?ofkP0mFJ/30?ofkP80
?EV[1`3om^h203eIZ`X0ooK^00<0?EV[0?ofkP0mFJ/00P0mFJ/90?ofkP0303eIZ`3om^h0ooK^00`0
ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00L0
ooK^0`0mFJ/00`3om^h0?EV[0?ofkP090?ofkP80?EV[1`3om^h203eIZ`<0ooK^00@0?EV[0?ofkP3o
m^h0?EV[B03om^h00`000000ooK^0?ofkP0D0?ofkP030000003om^h0ooK^05H0ooK^0@3oool005P0
ooK^00<000000?ofkP3om^h0503om^h00`000000ooK^0?ofkP170?ofkP0303eIZ`3om^h0?EV[00<0
ooK^0P0mFJ/80?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h00P3om^h203eIZ`L0
ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00`0
ooK^00<0?EV[0?ofkP3om^h01@3om^h203eIZ`@0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0
ooK^0?ofkP060?ofkP80?EV[0`3om^h00`0mFJ/0ooK^03eIZ`190?ofkP030000003om^h0ooK^01@0
ooK^00<000000?ofkP3om^h0EP3om^h10?ooo`00F03om^h00`000000ooK^0?ofkP0D0?ofkP030000
003om^h0ooK^04L0ooK^00@0?EV[0?ofkP0mFJ/0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP060?ofkP<0
?EV[203om^h00`0mFJ/0ooK^0?ofkP040?ofkP<0?EV[103om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP03
03eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP020?ofkP<0
?EV[1P3om^h00`0mFJ/0ooK^0?ofkP060?ofkP<0?EV[203om^h0100mFJ/0ooK^0?ofkP3om^h203eI
Z`030?ofkP0mFJ/0ooK^04P0ooK^00<000000?ofkP3om^h0503om^h00`000000ooK^0?ofkP1F0?of
kP40oooo001I0?ofkP030000003om^h0ooK^01<0ooK^00<000000?ofkP3om^h0A`3om^h0100mFJ/0
ooK^03eIZ`0mFJ/30?ofkP80?EV[1`3om^h0100mFJ/0ooK^0?ofkP0mFJ/70?ofkP0303eIZ`3om^h0
ooK^00L0ooK^0`0mFJ/00`3om^h0?EV[0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[
0?ofkP3om^h0303om^h00`0mFJ/0ooK^03eIZ`0203eIZ`T0ooK^00<0?EV[0?ofkP3om^h01@3om^h0
100mFJ/0ooK^0?ofkP0mFJ/70?ofkP80?EV[0`3om^h203eIZ`030?ofkP0mFJ/0ooK^04P0ooK^00<0
00000?ofkP3om^h04`3om^h00`000000ooK^0?ofkP1G0?ofkP40oooo001I0?ofkP030000003om^h0
ooK^01<0ooK^00<000000?ofkP3om^h0B03om^h203eIZ`070?ofkP0mFJ/0ooK^0?ofkP0mFJ/0ooK^
03eIZ`060?ofkP0403eIZ`3om^h0ooK^0?ofkP80?EV[1@3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP@0
?EV[303om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00X0ooK^100mFJ/;0?ofkP03
03eIZ`3om^h0ooK^00@0ooK^0P0mFJ/30?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP0m
FJ/00P3om^h0100mFJ/0ooK^03eIZ`0mFJ]:0?ofkP030000003om^h0ooK^01<0ooK^00<000000?of
kP3om^h0E`3om^h10?ooo`00F@3om^h00`000000ooK^0?ofkP0C0?ofkP030000003om^h0ooK^04P0
ooK^0P0mFJ/01@3om^h0?EV[0?ofkP3om^h0?EV[0080ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0m
FJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0m
FJ/0ooK^0?ofkP0503eIZ`L0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP050?of
kPD0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?of
kP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0403eIZ`3om^h0ooK^03eIZ`80ooK^00@0?EV[
0?ofkP0mFJ/0?EV[BP3om^h00`000000ooK^0?ofkP0C0?ofkP030000003om^h0ooK^05L0ooK^0@3o
ool005X0ooK^00<000000?ofkP3om^h04P3om^h00`000000ooK^0?ofkP180?ofkP80?EV[0P3om^h0
0`0mFJ/0ooK^03eIZ`030?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h0103om^h2
03eIZ`<0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP050?ofkPD0?EV[0P3om^h0
0`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00D0?EV[1`3om^h00`0mFJ/0ooK^0?ofkP0:
0?ofkP0403eIZ`3om^h0ooK^0?ofkP80?EV[1P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0;03eIZ`3o
m^h0ooK^0?ofkP0mFJ/0ooK^03eIZ`3om^h0?EV[0?ofkP0mFJ/0BP3om^h00`000000ooK^0?ofkP0B
0?ofkP030000003om^h0ooK^05P0ooK^0@3oool005X0ooK^00<000000?ofkP3om^h04@3om^h00`00
0000ooK^0?ofkP1:0?ofkP80?EV[00@0ooK^03eIZ`3om^h0?EV[103om^h00`0mFJ/0ooK^0?ofkP02
0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00@0?EV[0?ofkP3om^h0?EV[303om^h00`0mFJ/0ooK^0?of
kP0:0?ofkQD0?EV[303om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0403eIZ`3om^h0ooK^03eIZ`L0ooK^
00<0?EV[0?ofkP3om^h00P3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[0080ooK^00@0?EV[0?ofkP0m
FJ/0?EV[C03om^h00`000000ooK^0?ofkP0A0?ofkP030000003om^h0ooK^05P0ooK^0@3oool005X0
ooK^00<000000?ofkP3om^h04@3om^h00`000000ooK^0?ofkP1:0?ofkP80?EV[0P3om^h00`0mFJ/0
ooK^03eIZ`040?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/0203om^h303eIZ``0ooK^00<0?EV[0?of
kP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?of
kP3om^h02P3om^h303eIZ`P0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`040?ofkP0303eIZ`3om^h0
?EV[0080ooK^0P0mFJ]<0?ofkP030000003om^h0ooK^0140ooK^00<000000?ofkP3om^h0F03om^h1
0?ooo`00F`3om^h00`000000ooK^0?ofkP0@0?ofkP030000003om^h0ooK^04X0ooK^0P0mFJ/20?of
kP0303eIZ`3om^h0?EV[00D0ooK^00@0?EV[0?ofkP3om^h0?EV[2P3om^h203eIZ`/0ooK^00<0?EV[
0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[
0?ofkP3om^h02@3om^h203eIZ`X0ooK^00@0?EV[0?ofkP3om^h0?EV[1@3om^h00`0mFJ/0ooK^03eI
Z`020?ofkP80?EV[C03om^h00`000000ooK^0?ofkP0@0?ofkP030000003om^h0ooK^05T0ooK^0@3o
ool005/0ooK^00<000000?ofkP3om^h0403om^h00`000000ooK^0?ofkP1;0?ofkP0403eIZ`3om^h0
ooK^0?ofkP80?EV[1P3om^h00`0mFJ/0ooK^03eIZ`0:0?ofkP0403eIZ`3om^h0?EV[03eIZ`T0ooK^
00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00`0ooK^
00<0?EV[0?ofkP3om^h01`3om^h203eIZ`030?ofkP0mFJ/0ooK^00T0ooK^00<0?EV[0?ofkP0mFJ/0
1P3om^h203eIZ`<0ooK^00<0?EV[0?ofkP3om^h0B`3om^h00`000000ooK^0?ofkP0@0?ofkP030000
003om^h0ooK^05T0ooK^0@3oool005/0ooK^00<000000?ofkP3om^h0403om^h00`000000ooK^0?of
kP1;0?ofkP0403eIZ`3om^h0ooK^0?ofkP80?EV[1`3om^h203eIZ`X0ooK^00@0?EV[0?ofkP3om^h0
ooK^0P0mFJ/70?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0
ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00D0ooK^0P0mFJ/30?ofkP0303eIZ`3om^h0ooK^00P0
ooK^0P0mFJ/70?ofkP80?EV[0`3om^h00`0mFJ/0ooK^0?ofkP1;0?ofkP030000003om^h0ooK^0100
ooK^00<000000?ofkP3om^h0F@3om^h10?ooo`00G03om^h00`000000ooK^0?ofkP0?0?ofkP030000
003om^h0ooK^04`0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`080?ofkP0303eIZ`3om^h0ooK^00P0
ooK^00<0?EV[0?ofkP3om^h00`3om^h203eIZ`D0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0
ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h00`3om^h203eIZ`D0
ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP060?ofkP0503eIZ`3om^h0ooK^0?of
kP0mFJ/0CP3om^h00`000000ooK^0?ofkP0?0?ofkP030000003om^h0ooK^05X0ooK^0@3oool005`0
ooK^00<000000?ofkP3om^h03`3om^h00`000000ooK^0?ofkP1<0?ofkP0403eIZ`3om^h0ooK^0?of
kP80?EV[1`3om^h303eIZ`P0ooK^00<0?EV[0?ofkP3om^h01@3om^h203eIZ`<0ooK^00<0?EV[0?of
kP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00@0?EV[0?of
kP3om^h0ooK^0P0mFJ/70?ofkP0303eIZ`3om^h0ooK^00H0ooK^0`0mFJ/70?ofkP80?EV[0`3om^h0
0`0mFJ/0ooK^0?ofkP1<0?ofkP030000003om^h0ooK^00l0ooK^00<000000?ofkP3om^h0FP3om^h1
0?ooo`00G03om^h00`000000ooK^0?ofkP0?0?ofkP030000003om^h0ooK^04d0ooK^00H0?EV[0?of
kP3om^h0?EV[0?ofkP0mFJ/60?ofkP0403eIZ`3om^h0ooK^03eIZ`L0ooK^00<0?EV[0?ofkP3om^h0
1`3om^h203eIZ`030?ofkP0mFJ/0ooK^00d0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^
0?ofkP0<0?ofkP0403eIZ`3om^h0?EV[03eIZ`T0ooK^00<0?EV[0?ofkP3om^h01@3om^h0100mFJ/0
ooK^0?ofkP0mFJ/60?ofkP0303eIZ`3om^h0?EV[0080ooK^00<0?EV[0?ofkP3om^h0C@3om^h00`00
0000ooK^0?ofkP0?0?ofkP030000003om^h0ooK^05X0ooK^0@3oool005d0ooK^00<000000?ofkP3o
m^h03P3om^h00`000000ooK^0?ofkP1=0?ofkP0403eIZ`3om^h0ooK^03eIZ`80ooK^00<0?EV[0?of
kP3om^h00`3om^h0100mFJ/0ooK^0?ofkP3om^h203eIZ`D0ooK^00<0?EV[0?ofkP3om^h02@3om^h4
03eIZ``0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP@0?EV[2`3om^h0
0`0mFJ/0ooK^0?ofkP030?ofkP80?EV[0`3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0403eIZ`3om^h0
ooK^03eIZ`80ooK^00<0?EV[0?ofkP3om^h0C@3om^h00`000000ooK^0?ofkP0>0?ofkP030000003o
m^h0ooK^05/0ooK^0@3oool005d0ooK^00<000000?ofkP3om^h03@3om^h00`000000ooK^0?ofkP1?
0?ofkP0303eIZ`3om^h0?EV[00<0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP03
0?ofkP80?EV[0`3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00D0?EV[1`3om^h0
0`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00D0ooK^1@0mFJ/20?ofkP0303eIZ`3om^h0
ooK^00X0ooK^00@0?EV[0?ofkP3om^h0ooK^0P0mFJ/50?ofkP0303eIZ`3om^h0ooK^0080ooK^00L0
?EV[0?ofkP3om^h0ooK^03eIZ`3om^h0?EV[0540ooK^00<000000?ofkP3om^h03@3om^h00`000000
ooK^0?ofkP1K0?ofkP40oooo001M0?ofkP030000003om^h0ooK^00d0ooK^00<000000?ofkP3om^h0
C`3om^h00`0mFJ/0ooK^03eIZ`040?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/01`3om^h0100mFJ/0
ooK^0?ofkP0mFJ/<0?ofkP0303eIZ`3om^h0ooK^00D0ooK^1@0mFJ/20?ofkP0303eIZ`3om^h0ooK^
00d0ooK^00<0?EV[0?ofkP3om^h01@0mFJ/70?ofkP0303eIZ`3om^h0ooK^00X0ooK^00@0?EV[0?of
kP3om^h0?EV[1P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/00P3o
m^h00`0mFJ/0ooK^0?ofkP1?0?ofkP030000003om^h0ooK^00d0ooK^00<000000?ofkP3om^h0F`3o
m^h10?ooo`00GP3om^h00`000000ooK^0?ofkP0<0?ofkP030000003om^h0ooK^0500ooK^00<0?EV[
0?ofkP0mFJ/0103om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00L0ooK^0`0mFJ/<0?ofkP0303eIZ`3o
m^h0ooK^00X0ooK^5@0mFJ/<0?ofkP0303eIZ`3om^h0ooK^00X0ooK^0`0mFJ/70?ofkP0503eIZ`3o
m^h0ooK^0?ofkP0mFJ/0103om^h00`0mFJ/0ooK^03eIZ`1B0?ofkP030000003om^h0ooK^00`0ooK^
00<000000?ofkP3om^h0G03om^h10?ooo`00GP3om^h00`000000ooK^0?ofkP0<0?ofkP030000003o
m^h0ooK^0500ooK^00<0?EV[0?ofkP0mFJ/01@3om^h0100mFJ/0ooK^0?ofkP0mFJ/90?ofkP80?EV[
2`3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h0
303om^h00`0mFJ/0ooK^0?ofkP090?ofkP80?EV[2@3om^h0100mFJ/0ooK^0?ofkP0mFJ/50?ofkP03
03eIZ`3om^h0?EV[0580ooK^00<000000?ofkP3om^h0303om^h00`000000ooK^0?ofkP1L0?ofkP40
oooo001N0?ofkP030000003om^h0ooK^00`0ooK^00<000000?ofkP3om^h0D@3om^h203eIZ`H0ooK^
00<0?EV[0?ofkP0mFJ/02@3om^h0100mFJ/0ooK^03eIZ`0mFJ/90?ofkP0303eIZ`3om^h0ooK^00`0
ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00P0
ooK^0P0mFJ/00`3om^h0?EV[0?ofkP080?ofkP0303eIZ`3om^h0?EV[00H0ooK^0P0mFJ]C0?ofkP03
0000003om^h0ooK^00`0ooK^00<000000?ofkP3om^h0G03om^h10?ooo`00GP3om^h00`000000ooK^
0?ofkP0<0?ofkP030000003om^h0ooK^0540ooK^0P0mFJ/70?ofkP80?EV[2@3om^h0100mFJ/0ooK^
0?ofkP3om^h203eIZ`P0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP03
03eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h01P3om^h203eIZ`<0ooK^00<0?EV[0?ofkP3o
m^h01`3om^h203eIZ`L0ooK^0P0mFJ]C0?ofkP030000003om^h0ooK^00`0ooK^00<000000?ofkP3o
m^h0G03om^h10?ooo`00G`3om^h00`000000ooK^0?ofkP0;0?ofkP030000003om^h0ooK^0580ooK^
00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00<0ooK^
0`0mFJ/50?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^
0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00<0ooK^0`0mFJ/50?ofkP0303eIZ`3om^h0ooK^00L0ooK^
00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP1B0?ofkP030000003om^h0ooK^00/0ooK^
00<000000?ofkP3om^h0G@3om^h10?ooo`00G`3om^h00`000000ooK^0?ofkP0;0?ofkP030000003o
m^h0ooK^05<0ooK^00<0?EV[0?ofkP3om^h01@3om^h303eIZ`L0ooK^00<0?EV[0?ofkP3om^h01P3o
m^h203eIZ`<0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3o
m^h0ooK^00/0ooK^00@0?EV[0?ofkP3om^h0ooK^0P0mFJ/80?ofkP0303eIZ`3om^h0ooK^00D0ooK^
0`0mFJ/70?ofkP0303eIZ`3om^h0ooK^05<0ooK^00<000000?ofkP3om^h02`3om^h00`000000ooK^
0?ofkP1M0?ofkP40oooo001O0?ofkP030000003om^h0ooK^00X0ooK^00<000000?ofkP3om^h0E@3o
m^h00`0mFJ/0ooK^0?ofkP040?ofkP0403eIZ`3om^h0ooK^03eIZ`H0ooK^00<0?EV[0?ofkP3om^h0
203om^h203eIZ`030?ofkP0mFJ/0ooK^00d0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^
0?ofkP0;0?ofkP0403eIZ`3om^h0?EV[03eIZ`T0ooK^00<0?EV[0?ofkP3om^h01@3om^h0100mFJ/0
ooK^0?ofkP0mFJ/60?ofkP0303eIZ`3om^h0ooK^05@0ooK^00<000000?ofkP3om^h02`3om^h00`00
0000ooK^0?ofkP1M0?ofkP40oooo001P0?ofkP030000003om^h0ooK^00T0ooK^00<000000?ofkP3o
m^h0EP3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0403eIZ`3om^h0ooK^0?ofkP80?EV[1@3om^h00`0m
FJ/0ooK^0?ofkP090?ofkP@0?EV[303om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^
00T0ooK^100mFJ/;0?ofkP0303eIZ`3om^h0ooK^00<0ooK^0P0mFJ/30?ofkP0303eIZ`3om^h0ooK^
00<0ooK^00<0?EV[0?ofkP3om^h0EP3om^h00`000000ooK^0?ofkP090?ofkP030000003om^h0ooK^
05h0ooK^0@3oool00600ooK^00<000000?ofkP3om^h02@3om^h00`000000ooK^0?ofkP1G0?ofkP03
03eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h00`3om^h203eIZ`<0ooK^00<0?EV[0?ofkP3o
m^h02P3om^h00`0mFJ/0ooK^0?ofkP0503eIZ`L0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0
ooK^0?ofkP050?ofkP@0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0403eIZ`3om^h0ooK^0?of
kP80?EV[1@3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^05L0ooK^00<000000?of
kP3om^h02@3om^h00`000000ooK^0?ofkP1N0?ofkP40oooo001P0?ofkP030000003om^h0ooK^00T0
ooK^00<000000?ofkP3om^h0F03om^h203eIZ`<0ooK^00<0?EV[0?ofkP3om^h0103om^h0100mFJ/0
ooK^0?ofkP0mFJ/<0?ofkP0303eIZ`3om^h0ooK^00D0ooK^1@0mFJ/20?ofkP0303eIZ`3om^h0ooK^
00`0ooK^00<0?EV[0?ofkP3om^h01@0mFJ/60?ofkP0303eIZ`3om^h0ooK^00X0ooK^00@0?EV[0?of
kP3om^h0?EV[1P3om^h0100mFJ/0ooK^0?ofkP3om^h203eIZeX0ooK^00<000000?ofkP3om^h02@3o
m^h00`000000ooK^0?ofkP1N0?ofkP40oooo001Q0?ofkP030000003om^h0ooK^00P0ooK^00<00000
0?ofkP3om^h0FP3om^h0100mFJ/0ooK^0?ofkP0mFJ/70?ofkP<0?EV[303om^h00`0mFJ/0ooK^0?of
kP0:0?ofkQ@0?EV[2`3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP<0?EV[1`3om^h0100mFJ/0ooK^0?of
kP0mFJ]L0?ofkP030000003om^h0ooK^00P0ooK^00<000000?ofkP3om^h0G`3om^h10?ooo`00H@3o
m^h00`000000ooK^0?ofkP080?ofkP030000003om^h0ooK^05/0ooK^00<0?EV[0?ofkP0mFJ/02@3o
m^h203eIZ`/0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3o
m^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h02@3om^h203eIZ`T0ooK^00<0?EV[0?ofkP0mFJ/0G@3o
m^h00`000000ooK^0?ofkP080?ofkP030000003om^h0ooK^05l0ooK^0@3oool00640ooK^00<00000
0?ofkP3om^h0203om^h00`000000ooK^0?ofkP1L0?ofkP80?EV[2@3om^h0100mFJ/0ooK^03eIZ`0m
FJ/90?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?of
kP0;0?ofkP0303eIZ`3om^h0ooK^00L0ooK^0P0mFJ/00`3om^h0?EV[0?ofkP080?ofkP80?EV[GP3o
m^h00`000000ooK^0?ofkP080?ofkP030000003om^h0ooK^05l0ooK^0@3oool00680ooK^00<00000
0?ofkP3om^h01`3om^h00`000000ooK^0?ofkP1M0?ofkP0303eIZ`3om^h0ooK^00L0ooK^00@0?EV[
0?ofkP3om^h0ooK^0`0mFJ/60?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h0303o
m^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00@0ooK^0`0mFJ/30?ofkP0303eIZ`3o
m^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h0G@3om^h00`000000ooK^0?ofkP070?ofkP030000003o
m^h0ooK^0600ooK^0@3oool00680ooK^00<000000?ofkP3om^h01`3om^h00`000000ooK^0?ofkP1N
0?ofkP80?EV[1`3om^h00`0mFJ/0ooK^0?ofkP040?ofkP<0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP0<
0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h02`3om^h0100mFJ/0ooK^0?ofkP3o
m^h303eIZ`H0ooK^00<0?EV[0?ofkP3om^h01@3om^h203eIZf00ooK^00<000000?ofkP3om^h01`3o
m^h00`000000ooK^0?ofkP1P0?ofkP40oooo001R0?ofkP030000003om^h0ooK^00H0ooK^00<00000
0?ofkP3om^h0H@3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00L0ooK^0P0mFJ/0
0`3om^h0?EV[0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h0303om^h0
100mFJ/0ooK^03eIZ`0mFJ/90?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h0H@3o
m^h00`000000ooK^0?ofkP060?ofkP030000003om^h0ooK^0600ooK^0@3oool006<0ooK^00<00000
0?ofkP3om^h01@3om^h00`000000ooK^0?ofkP1R0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[
0?ofkP3om^h02@3om^h403eIZ``0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP0:
0?ofkP@0?EV[2P3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^0680ooK^00<00000
0?ofkP3om^h01@3om^h00`000000ooK^0?ofkP1Q0?ofkP40oooo001S0?ofkP030000003om^h0ooK^
00D0ooK^00<000000?ofkP3om^h0H`3om^h203eIZ`@0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0m
FJ/0ooK^0?ofkP0503eIZ`L0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP050?of
kPD0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^0080ooK^0P0mFJ]U0?of
kP030000003om^h0ooK^00D0ooK^00<000000?ofkP3om^h0H@3om^h10?ooo`00H`3om^h00`000000
ooK^0?ofkP050?ofkP030000003om^h0ooK^06D0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0;0?of
kP0303eIZ`3om^h0ooK^00D0ooK^1@0mFJ/20?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?of
kP3om^h01@0mFJ/70?ofkP0303eIZ`3om^h0ooK^00T0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`1W
0?ofkP030000003om^h0ooK^00D0ooK^00<000000?ofkP3om^h0H@3om^h10?ooo`00I03om^h00`00
0000ooK^0?ofkP040?ofkP030000003om^h0ooK^06H0ooK^00@0?EV[0?ofkP3om^h0?EV[2`3om^h0
0`0mFJ/0ooK^0?ofkP0:0?ofkQ<0?EV[303om^h00`0mFJ/0ooK^0?ofkP090?ofkP0403eIZ`3om^h0
ooK^03eIZfP0ooK^00<000000?ofkP3om^h0103om^h00`000000ooK^0?ofkP1R0?ofkP40oooo001T
0?ofkP030000003om^h0ooK^00@0ooK^00<000000?ofkP3om^h0I`3om^h303eIZ`/0ooK^00<0?EV[
0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[
0?ofkP3om^h02@3om^h303eIZfT0ooK^00<000000?ofkP3om^h0103om^h00`000000ooK^0?ofkP1R
0?ofkP40oooo001T0?ofkP030000003om^h0ooK^00@0ooK^00<000000?ofkP3om^h0J@3om^h203eI
Z`X0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^
00/0ooK^00<0?EV[0?ofkP3om^h02@3om^h203eIZf/0ooK^00<000000?ofkP3om^h0103om^h00`00
0000ooK^0?ofkP1R0?ofkP40oooo001U0?ofkP030000003om^h0ooK^00<0ooK^00<000000?ofkP3o
m^h0J`3om^h203eIZ`T0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP03
03eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h01`3om^h203eIZfd0ooK^00<000000?ofkP3o
m^h00`3om^h00`000000ooK^0?ofkP1S0?ofkP40oooo001U0?ofkP030000003om^h0ooK^00<0ooK^
00<000000?ofkP3om^h0K@3om^h303eIZ`H0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^
0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h0103om^h303eIZfl0ooK^
00<000000?ofkP3om^h00`3om^h00`000000ooK^0?ofkP1S0?ofkP40oooo001U0?ofkP030000003o
m^h0ooK^0080ooK^00<000000?ofkP3om^h0L@3om^h303eIZ`<0ooK^00<0?EV[0?ofkP3om^h02`3o
m^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00@0?EV[0?ofkP3om^h0ooK^
0`0mFJ]c0?ofkP030000003om^h0ooK^0080ooK^00<000000?ofkP3om^h0H`3om^h10?ooo`00I@3o
m^h00`000000ooK^0?ofkP020?ofkP030000003om^h0ooK^07@0ooK^0P0mFJ/00`3om^h0?EV[0?of
kP0<0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h02`3om^h0100mFJ/0ooK^03eI
Z`0mFJ]f0?ofkP030000003om^h0ooK^0080ooK^00<000000?ofkP3om^h0H`3om^h10?ooo`00IP3o
m^h01@000000ooK^0?ofkP3om^h0000007P0ooK^1@0mFJ/:0?ofkP0303eIZ`3om^h0ooK^00/0ooK^
00<0?EV[0?ofkP3om^h0203om^h503eIZgP0ooK^00D000000?ofkP3om^h0ooK^0000001V0?ofkP40
oooo001V0?ofkP050000003om^h0ooK^0?ofkP000000O@3om^h703eIZ`<0ooK^00<0?EV[0?ofkP3o
m^h02`3om^h0100mFJ/0ooK^0?ofkP3om^h703eIZgd0ooK^00D000000?ofkP3om^h0ooK^0000001V
0?ofkP40oooo001V0?ofkP050000003om^h0ooK^0?ofkP000000Q03om^hE03eIZh@0ooK^00D00000
0?ofkP3om^h0ooK^0000001V0?ofkP40oooo001W0?ofkP040000003om^h0ooK^00000?l0ooK^7P3o
m^h010000000ooK^0?ofkP00001W0?ofkP40oooo001W0?ofkP040000003om^h0ooK^00000?l0ooK^
7P3om^h010000000ooK^0?ofkP00001W0?ofkP40oooo001W0?ofkP040000003om^h0ooK^00000?l0
ooK^7P3om^h010000000ooK^0?ofkP00001W0?ofkP40oooo001X0?ofkP800000o`3om^hP0?ofkP80
0000J03om^h10?ooo`00J03om^h200000?l0ooK^803om^h2000006P0ooK^0@3oool006P0ooK^0P00
003o0?ofkR00ooK^0P00001X0?ofkP40oooo001Y0?ofkP030000003om^h0ooK^0?l0ooK^7P3om^h0
0`000000ooK^0?ofkP1W0?ofkP40oooo001Y0?ofk_l000008P00001Y0?ofkP40oooo003o0?ofk_@0
ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool0
0?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03o
m^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00
o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?of
kP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o
0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^
0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0
ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h1
0?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3o
m^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40
oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?of
k_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3o
ool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^
m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?oo
o`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd
0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo
003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0
ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool0
0?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03o
m^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00
o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?of
kP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o
0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^
0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0
ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h1
0?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3o
m^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40
oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?of
k_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3o
ool00?l0ooK^m03om^h10?ooo`00\
\>"],
  ImageRangeCache->{{{0, 499}, {499, 0}} -> {-5.00005*^-06, -5.00005*^-06, \
0.00200403, 0.00200403}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
%%ImageSize: 500 500 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics3D
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Background color
1 .961 .933 r
MFill
% Scaling calculations
0 1 0 1 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 0 r
.25 Mabswid
[ ] 0 setdash
.16861 .50547 m
.13045 .74993 L
s
.13045 .74993 m
.6978 .81857 L
s
.6978 .81857 m
.67872 .58361 L
s
.67872 .58361 m
.16861 .50547 L
s
.24028 .08168 m
.91053 .22236 L
s
.91053 .22236 m
.97075 .49223 L
s
.97075 .49223 m
.19793 .35868 L
s
.19793 .35868 m
.24028 .08168 L
s
.16861 .50547 m
.13045 .74993 L
s
.13045 .74993 m
.19793 .35868 L
s
.19793 .35868 m
.24028 .08168 L
s
.24028 .08168 m
.16861 .50547 L
s
.67872 .58361 m
.91053 .22236 L
s
.91053 .22236 m
.97075 .49223 L
s
.97075 .49223 m
.6978 .81857 L
s
.6978 .81857 m
.67872 .58361 L
s
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
.24 .35 .67 r
.5 Mabswid
.49565 .56818 m
.47256 .55588 L
s
.47256 .55588 m
.48149 .53577 L
s
.47256 .55588 m
.44775 .54761 L
s
.51618 .58405 m
.49565 .56818 L
s
.49565 .56818 m
.50501 .54826 L
s
.44775 .54761 m
.45626 .52733 L
s
.44775 .54761 m
.42217 .54369 L
s
.53334 .60293 m
.51618 .58405 L
s
.51618 .58405 m
.52593 .56436 L
s
.42217 .54369 m
.43025 .52327 L
s
.42217 .54369 m
.39675 .54431 L
s
.54642 .62415 m
.53334 .60293 L
s
.53334 .60293 m
.54345 .58347 L
s
.39675 .54431 m
.40443 .52378 L
s
.39675 .54431 m
.3725 .54952 L
s
.55482 .64691 m
.54642 .62415 L
s
.54642 .62415 m
.55683 .60493 L
s
.3725 .54952 m
.37979 .52894 L
s
.3725 .54952 m
.35037 .55922 L
s
.50501 .54826 m
.48149 .53577 L
s
.48149 .53577 m
.49075 .51493 L
s
.48149 .53577 m
.45626 .52733 L
s
.52593 .56436 m
.50501 .54826 L
s
.50501 .54826 m
.5147 .52763 L
s
.45626 .52733 m
.46508 .50631 L
s
.45626 .52733 m
.43025 .52327 L
s
.54345 .58347 m
.52593 .56436 L
s
.52593 .56436 m
.53603 .54395 L
s
.43025 .52327 m
.43863 .5021 L
s
.43025 .52327 m
.40443 .52378 L
s
.5581 .67035 m
.55482 .64691 L
s
.55482 .64691 m
.56548 .62794 L
s
.35037 .55922 m
.35733 .53862 L
s
.35037 .55922 m
.33134 .57313 L
s
.55683 .60493 m
.54345 .58347 L
s
.54345 .58347 m
.55392 .5633 L
s
.40443 .52378 m
.41238 .5025 L
s
.40443 .52378 m
.37979 .52894 L
s
.56548 .62794 m
.55683 .60493 L
s
.55683 .60493 m
.56763 .58501 L
s
.56892 .65162 m
.5581 .67035 L
s
.55595 .6935 m
.5581 .67035 L
s
.37979 .52894 m
.38735 .50759 L
s
.37979 .52894 m
.35733 .53862 L
s
.5147 .52763 m
.49075 .51493 L
s
.49075 .51493 m
.50036 .49333 L
s
.49075 .51493 m
.46508 .50631 L
s
.33134 .57313 m
.33801 .55258 L
s
.33134 .57313 m
.31627 .59079 L
s
.53603 .54395 m
.5147 .52763 L
s
.5147 .52763 m
.52475 .50624 L
s
.46508 .50631 m
.47422 .48451 L
s
.46508 .50631 m
.43863 .5021 L
s
.55392 .5633 m
.53603 .54395 L
s
.53603 .54395 m
.54651 .52279 L
s
.43863 .5021 m
.44731 .48015 L
s
.43863 .5021 m
.41238 .5025 L
s
.56892 .65162 m
.56548 .62794 L
s
.56548 .62794 m
.57654 .60827 L
s
.35733 .53862 m
.36454 .51727 L
s
.35733 .53862 m
.33801 .55258 L
s
.56763 .58501 m
.55392 .5633 L
s
.55392 .5633 m
.56479 .54239 L
s
.54831 .71538 m
.55595 .6935 L
s
.55595 .6935 m
.56686 .675 L
s
.41238 .5025 m
.42063 .48044 L
s
.41238 .5025 m
.38735 .50759 L
s
.31627 .59079 m
.32274 .57035 L
s
.31627 .59079 m
.30595 .61157 L
s
.57654 .60827 m
.56763 .58501 L
s
.56763 .58501 m
.57883 .56435 L
s
.58015 .63219 m
.56892 .65162 L
s
.56686 .675 m
.56892 .65162 L
s
.38735 .50759 m
.3952 .48545 L
s
.38735 .50759 m
.36454 .51727 L
s
.52475 .50624 m
.50036 .49333 L
s
.50036 .49333 m
.51032 .47091 L
s
.50036 .49333 m
.47422 .48451 L
s
.33801 .55258 m
.34494 .53126 L
s
.33801 .55258 m
.32274 .57035 L
s
.54651 .52279 m
.52475 .50624 L
s
.52475 .50624 m
.53518 .48405 L
s
.47422 .48451 m
.48371 .4619 L
s
.47422 .48451 m
.44731 .48015 L
s
.53532 .73497 m
.54831 .71538 L
s
.54831 .71538 m
.55919 .69708 L
s
.30595 .61157 m
.3123 .59129 L
s
.30595 .61157 m
.301 .63465 L
s
.56479 .54239 m
.54651 .52279 L
s
.54651 .52279 m
.55738 .50083 L
s
.44731 .48015 m
.45633 .45737 L
s
.44731 .48015 m
.42063 .48044 L
s
.58015 .63219 m
.57654 .60827 L
s
.57654 .60827 m
.58801 .58786 L
s
.36454 .51727 m
.37203 .4951 L
s
.36454 .51727 m
.34494 .53126 L
s
.57883 .56435 m
.56479 .54239 L
s
.56479 .54239 m
.57606 .52068 L
s
.55919 .69708 m
.56686 .675 L
s
.56686 .675 m
.57817 .6558 L
s
.83 .24 .1 r
.73 .54129 m
.73513 .51389 L
s
.69411 .53554 m
.73 .54129 L
s
.72692 .56888 m
.73 .54129 L
s
.24 .35 .67 r
.42063 .48044 m
.42919 .45753 L
s
.42063 .48044 m
.3952 .48545 L
s
.32274 .57035 m
.32946 .54912 L
s
.32274 .57035 m
.3123 .59129 L
s
.83 .24 .1 r
.73513 .51389 m
.74214 .48758 L
s
.69922 .50799 m
.73513 .51389 L
s
.69093 .56326 m
.72692 .56888 L
s
.726 .59574 m
.72692 .56888 L
s
.24 .35 .67 r
.51741 .75129 m
.53532 .73497 L
s
.53532 .73497 m
.54608 .71683 L
s
.301 .63465 m
.30733 .61457 L
s
.301 .63465 m
.30182 .65903 L
s
.83 .24 .1 r
.69922 .50799 m
.69411 .53554 L
s
.65787 .52974 m
.69411 .53554 L
s
.69411 .53554 m
.69093 .56326 L
s
.74214 .48758 m
.75083 .46327 L
s
.7061 .48153 m
.74214 .48758 L
s
.7061 .48153 m
.69922 .50799 L
s
.66296 .50204 m
.69922 .50799 L
s
.24 .35 .67 r
.58801 .58786 m
.57883 .56435 L
s
.59181 .61202 m
.58015 .63219 L
s
.57817 .6558 m
.58015 .63219 L
s
.83 .24 .1 r
.65459 .55758 m
.69093 .56326 L
s
.69093 .56326 m
.6898 .59022 L
s
.24 .35 .67 r
.3952 .48545 m
.40334 .46246 L
s
.3952 .48545 m
.37203 .4951 L
s
.53518 .48405 m
.51032 .47091 L
s
.51032 .47091 m
.52066 .44764 L
s
.51032 .47091 m
.48371 .4619 L
s
.83 .24 .1 r
.6898 .59022 m
.726 .59574 L
s
.72732 .62095 m
.726 .59574 L
s
.24 .35 .67 r
.34494 .53126 m
.35213 .50913 L
s
.34494 .53126 m
.32946 .54912 L
s
.55738 .50083 m
.53518 .48405 L
s
.48371 .4619 m
.49355 .43843 L
s
.48371 .4619 m
.45633 .45737 L
s
.83 .24 .1 r
.66296 .50204 m
.65787 .52974 L
s
.62126 .52387 m
.65787 .52974 L
s
.65787 .52974 m
.65459 .55758 L
s
.24 .35 .67 r
.54608 .71683 m
.55919 .69708 L
s
.55919 .69708 m
.57049 .67808 L
s
.83 .24 .1 r
.71453 .45704 m
.7061 .48153 L
s
.66969 .47541 m
.7061 .48153 L
s
.66969 .47541 m
.66296 .50204 L
s
.62632 .49603 m
.66296 .50204 L
s
.24 .35 .67 r
.3123 .59129 m
.3189 .57022 L
s
.3123 .59129 m
.30733 .61457 L
s
.57606 .52068 m
.55738 .50083 L
s
.83 .24 .1 r
.61787 .55184 m
.65459 .55758 L
s
.65459 .55758 m
.65323 .58464 L
s
.24 .35 .67 r
.49527 .76347 m
.51741 .75129 L
s
.51741 .75129 m
.52794 .73327 L
s
.45633 .45737 m
.46569 .43372 L
s
.45633 .45737 m
.42919 .45753 L
s
.83 .24 .1 r
.65323 .58464 m
.6898 .59022 L
s
.6898 .59022 m
.69079 .6155 L
s
.75083 .46327 m
.76094 .44185 L
s
.71453 .45704 m
.75083 .46327 L
s
.24 .35 .67 r
.30182 .65903 m
.30823 .63921 L
s
.30182 .65903 m
.30855 .6836 L
s
.83 .24 .1 r
.62632 .49603 m
.62126 .52387 L
s
.62126 .52387 m
.61787 .55184 L
s
.24 .35 .67 r
.59181 .61202 m
.58801 .58786 L
s
.83 .24 .1 r
.67787 .45075 m
.66969 .47541 L
s
.63291 .46924 m
.66969 .47541 L
s
.63291 .46924 m
.62632 .49603 L
s
.58932 .48996 m
.62632 .49603 L
s
.24 .35 .67 r
.37203 .4951 m
.3798 .47208 L
s
.37203 .4951 m
.35213 .50913 L
s
.83 .24 .1 r
.69079 .6155 m
.72732 .62095 L
s
.73089 .64356 m
.72732 .62095 L
s
.61787 .55184 m
.61629 .57901 L
s
.24 .35 .67 r
.57049 .67808 m
.57817 .6558 L
s
.57817 .6558 m
.58992 .63586 L
s
.83 .24 .1 r
.61629 .57901 m
.65323 .58464 L
s
.65323 .58464 m
.65388 .61 L
s
.24 .35 .67 r
.42919 .45753 m
.43808 .43375 L
s
.42919 .45753 m
.40334 .46246 L
s
.83 .24 .1 r
.72428 .43545 m
.71453 .45704 L
s
.67787 .45075 m
.71453 .45704 L
s
.24 .35 .67 r
.32946 .54912 m
.33643 .52708 L
s
.32946 .54912 m
.3189 .57022 L
s
.913 .257 .109 r
.56349 .51466 m .57871 .5171 L .58669 .54012 L p F P
0 0 0 r
s
.913 .257 .109 r
.58669 .54012 m .56993 .53748 L .56349 .51466 L p F P
0 0 0 r
s
.888 .248 .105 r
.56993 .53748 m .58669 .54012 L .59276 .5623 L p F P
0 0 0 r
s
.24 .35 .67 r
.57883 .56435 m
.5847 .55353 L
s
.136 .2 .437 r
.59851 .55191 m .59276 .5623 L .58669 .54012 L p F P
0 0 0 r
s
.136 .2 .437 r
.58669 .54012 m .59201 .53023 L .59851 .55191 L p F P
0 0 0 r
s
.83 .24 .1 r
.59754 .54866 m
.61787 .55184 L
s
.167 .247 .522 r
.59201 .53023 m .58669 .54012 L .57871 .5171 L p F P
0 0 0 r
s
.934 .265 .112 r
.55561 .49147 m .56897 .49365 L .57871 .5171 L p F P
0 0 0 r
s
.24 .35 .67 r
.55738 .50083 m
.55975 .49606 L
s
.934 .265 .112 r
.57871 .5171 m .56349 .51466 L .55561 .49147 L p F P
0 0 0 r
s
.167 .247 .522 r
.57871 .5171 m .58348 .50795 L .59201 .53023 L p F P
0 0 0 r
s
.83 .24 .1 r
.58751 .51847 m
.62126 .52387 L
s
.193 .286 .592 r
.58348 .50795 m .57871 .5171 L .56897 .49365 L p F P
0 0 0 r
s
.83 .24 .1 r
.58524 .51256 m
.58932 .48996 L
s
.64082 .4444 m
.63291 .46924 L
s
.59576 .463 m
.63291 .46924 L
s
.59576 .463 m
.58932 .48996 L
s
.24 .35 .67 r
.52794 .73327 m
.54608 .71683 L
s
.54608 .71683 m
.55725 .698 L
s
.934 .265 .112 r
.5422 .48928 m .55561 .49147 L .56349 .51466 L p F P
0 0 0 r
s
.934 .265 .112 r
.56349 .51466 m .54819 .51221 L .5422 .48928 L p F P
0 0 0 r
s
.913 .257 .109 r
.54819 .51221 m .56349 .51466 L .56993 .53748 L p F P
0 0 0 r
s
.913 .257 .109 r
.56993 .53748 m .5531 .53484 L .54819 .51221 L p F P
0 0 0 r
s
.888 .248 .105 r
.5531 .53484 m .56993 .53748 L .57484 .55954 L p F P
0 0 0 r
s
.888 .248 .105 r
.59276 .5623 m .57484 .55954 L .56993 .53748 L p F P
0 0 0 r
s
.83 .24 .1 r
.58078 .54605 m
.58313 .52713 L
s
.24 .35 .67 r
.58075 .52792 m
.59046 .5429 L
s
.5878 .5478 m
.59046 .5429 L
s
.83 .24 .1 r
.58078 .54605 m
.58916 .54736 L
s
.24 .35 .67 r
.46984 .77082 m
.49527 .76347 L
s
.49527 .76347 m
.50547 .74552 L
s
.858 .238 .1 r
.57484 .55954 m .59276 .5623 L .5968 .58325 L p F P
0 0 0 r
s
.098 .143 .332 r
.60284 .57261 m .5968 .58325 L .59276 .5623 L p F P
0 0 0 r
s
.24 .35 .67 r
.58801 .58786 m
.59294 .57908 L
s
.098 .143 .332 r
.59276 .5623 m .59851 .55191 L .60284 .57261 L p F P
0 0 0 r
s
.952 .272 .115 r
.54644 .4683 m .55761 .47016 L .56897 .49365 L p F P
0 0 0 r
s
.952 .272 .115 r
.56897 .49365 m .55561 .49147 L .54644 .4683 L p F P
0 0 0 r
s
.193 .286 .592 r
.56897 .49365 m .57307 .48547 L .58348 .50795 L p F P
0 0 0 r
s
.83 .24 .1 r
.57398 .48744 m
.58932 .48996 L
s
.215 .319 .651 r
.57307 .48547 m .56897 .49365 L .55761 .47016 L p F P
0 0 0 r
s
.83 .24 .1 r
.65388 .61 m
.69079 .6155 L
s
.69079 .6155 m
.69392 .63817 L
s
.24 .35 .67 r
.30733 .61457 m
.3139 .59372 L
s
.30733 .61457 m
.30823 .63921 L
s
.83 .24 .1 r
.60057 .57661 m
.61629 .57901 L
s
.61629 .57901 m
.6166 .60445 L
s
.24 .35 .67 r
.30855 .6836 m
.31515 .66408 L
s
.30855 .6836 m
.32101 .70718 L
s
.934 .265 .112 r
.52875 .48708 m .5422 .48928 L .54819 .51221 L p F P
0 0 0 r
s
.934 .265 .112 r
.54819 .51221 m .53284 .50975 L .52875 .48708 L p F P
0 0 0 r
s
.913 .257 .109 r
.53284 .50975 m .54819 .51221 L .5531 .53484 L p F P
0 0 0 r
s
.952 .272 .115 r
.53523 .46644 m .54644 .4683 L .55561 .49147 L p F P
0 0 0 r
s
.24 .35 .67 r
.53518 .48405 m
.54044 .47284 L
s
.952 .272 .115 r
.55561 .49147 m .5422 .48928 L .53523 .46644 L p F P
0 0 0 r
s
.83 .24 .1 r
.55193 .48382 m
.56624 .48617 L
s
.68724 .42897 m
.67787 .45075 L
s
.64082 .4444 m
.67787 .45075 L
s
.913 .257 .109 r
.5531 .53484 m .53619 .53218 L .53284 .50975 L p F P
0 0 0 r
s
.83 .24 .1 r
.54691 .51197 m
.57954 .51719 L
s
.888 .248 .105 r
.53619 .53218 m .5531 .53484 L .55683 .55676 L p F P
0 0 0 r
s
.888 .248 .105 r
.57484 .55954 m .55683 .55676 L .5531 .53484 L p F P
0 0 0 r
s
.858 .238 .1 r
.55683 .55676 m .57484 .55954 L .57811 .58042 L p F P
0 0 0 r
s
.858 .238 .1 r
.5968 .58325 m .57811 .58042 L .57484 .55954 L p F P
0 0 0 r
s
.83 .24 .1 r
.57897 .57332 m
.5958 .57589 L
s
.57897 .57332 m
.58078 .54605 L
s
.54691 .51197 m
.55193 .48382 L
s
.76094 .44185 m
.77214 .4242 L
s
.72428 .43545 m
.76094 .44185 L
s
.952 .272 .115 r
.52399 .46458 m .53523 .46644 L .5422 .48928 L p F P
0 0 0 r
s
.952 .272 .115 r
.5422 .48928 m .52875 .48708 L .52399 .46458 L p F P
0 0 0 r
s
.934 .265 .112 r
.51524 .48488 m .52875 .48708 L .53284 .50975 L p F P
0 0 0 r
s
.934 .265 .112 r
.53284 .50975 m .51742 .50728 L .51524 .48488 L p F P
0 0 0 r
s
.913 .257 .109 r
.51742 .50728 m .53284 .50975 L .53619 .53218 L p F P
0 0 0 r
s
.83 .24 .1 r
.6034 .43798 m
.59576 .463 L
s
.24 .35 .67 r
.40334 .46246 m
.3798 .47208 L
s
.913 .257 .109 r
.53619 .53218 m .5192 .52951 L .51742 .50728 L p F P
0 0 0 r
s
.888 .248 .105 r
.5192 .52951 m .53619 .53218 L .53874 .55397 L p F P
0 0 0 r
s
.888 .248 .105 r
.55683 .55676 m .53874 .55397 L .53619 .53218 L p F P
0 0 0 r
s
.83 .24 .1 r
.54331 .54019 m
.54691 .51197 L
s
.54331 .54019 m
.58078 .54605 L
s
.24 .35 .67 r
.52066 .44764 m
.49355 .43843 L
s
.821 .226 .095 r
.57811 .58042 m .5968 .58325 L .59871 .60259 L p F P
0 0 0 r
s
.067 .097 .237 r
.60489 .59192 m .59871 .60259 L .5968 .58325 L p F P
0 0 0 r
s
.067 .097 .237 r
.5968 .58325 m .60284 .57261 L .60489 .59192 L p F P
0 0 0 r
s
.969 .278 .118 r
.53611 .44559 m .54482 .44706 L .55761 .47016 L p F P
0 0 0 r
s
.969 .278 .118 r
.55761 .47016 m .54644 .4683 L .53611 .44559 L p F P
0 0 0 r
s
.24 .35 .67 r
.54286 .46771 m
.54454 .46413 L
s
.52066 .44764 m
.54221 .459 L
s
.215 .319 .651 r
.55761 .47016 m .56097 .46321 L .57307 .48547 L p F P
0 0 0 r
s
.234 .348 .702 r
.56097 .46321 m .55761 .47016 L .54482 .44706 L p F P
0 0 0 r
s
.83 .24 .1 r
.55751 .45975 m
.55822 .45669 L
s
.55193 .48382 m
.55642 .46449 L
s
.55822 .45669 m
.59576 .463 L
s
.858 .238 .1 r
.53874 .55397 m .55683 .55676 L .55932 .57757 L p F P
0 0 0 r
s
.858 .238 .1 r
.57811 .58042 m .55932 .57757 L .55683 .55676 L p F P
0 0 0 r
s
.83 .24 .1 r
.6166 .60445 m
.65388 .61 L
s
.65388 .61 m
.65658 .63272 L
s
.24 .35 .67 r
.35213 .50913 m
.3596 .48613 L
s
.35213 .50913 m
.33643 .52708 L
s
.167 .247 .522 r
.59742 .52016 m .59201 .53023 L .58348 .50795 L p F P
0 0 0 r
s
.167 .247 .522 r
.58348 .50795 m .58831 .49865 L .59742 .52016 L p F P
0 0 0 r
s
.193 .286 .592 r
.58831 .49865 m .58348 .50795 L .57307 .48547 L p F P
0 0 0 r
s
.952 .272 .115 r
.51272 .4627 m .52399 .46458 L .52875 .48708 L p F P
0 0 0 r
s
.952 .272 .115 r
.52875 .48708 m .51524 .48488 L .51272 .4627 L p F P
0 0 0 r
s
.934 .265 .112 r
.50169 .48267 m .51524 .48488 L .51742 .50728 L p F P
0 0 0 r
s
.934 .265 .112 r
.51742 .50728 m .50193 .5048 L .50169 .48267 L p F P
0 0 0 r
s
.913 .257 .109 r
.50193 .5048 m .51742 .50728 L .5192 .52951 L p F P
0 0 0 r
s
.24 .35 .67 r
.49355 .43843 m
.46569 .43372 L
s
.136 .2 .437 r
.60436 .54133 m .59851 .55191 L .59201 .53023 L p F P
0 0 0 r
s
.136 .2 .437 r
.59201 .53023 m .59742 .52016 L .60436 .54133 L p F P
0 0 0 r
s
.969 .278 .118 r
.52739 .44412 m .53611 .44559 L .54644 .4683 L p F P
0 0 0 r
s
.969 .278 .118 r
.54644 .4683 m .53523 .46644 L .52739 .44412 L p F P
0 0 0 r
s
.913 .257 .109 r
.5192 .52951 m .50213 .52683 L .50193 .5048 L p F P
0 0 0 r
s
.83 .24 .1 r
.50917 .50592 m
.54691 .51197 L
s
.888 .248 .105 r
.50213 .52683 m .5192 .52951 L .52055 .55116 L p F P
0 0 0 r
s
.888 .248 .105 r
.53874 .55397 m .52055 .55116 L .5192 .52951 L p F P
0 0 0 r
s
.193 .286 .592 r
.57307 .48547 m .57723 .47719 L .58831 .49865 L p F P
0 0 0 r
s
.215 .319 .651 r
.57723 .47719 m .57307 .48547 L .56097 .46321 L p F P
0 0 0 r
s
.24 .35 .67 r
.55248 .46587 m
.56867 .47804 L
s
.56431 .48683 m
.56867 .47804 L
s
.55725 .698 m
.57049 .67808 L
s
.57049 .67808 m
.58223 .65834 L
s
.83 .24 .1 r
.64981 .42243 m
.64082 .4444 L
s
.6034 .43798 m
.64082 .4444 L
s
.69392 .63817 m
.73089 .64356 L
s
.73666 .66268 m
.73089 .64356 L
s
.952 .272 .115 r
.50141 .46083 m .51272 .4627 L .51524 .48488 L p F P
0 0 0 r
s
.952 .272 .115 r
.51524 .48488 m .50169 .48267 L .50141 .46083 L p F P
0 0 0 r
s
.83 .24 .1 r
.51417 .47763 m
.55193 .48382 L
s
.858 .238 .1 r
.52055 .55116 m .53874 .55397 L .54044 .57471 L p F P
0 0 0 r
s
.858 .238 .1 r
.55932 .57757 m .54044 .57471 L .53874 .55397 L p F P
0 0 0 r
s
.83 .24 .1 r
.54126 .56757 m
.57897 .57332 L
s
.54126 .56757 m
.54331 .54019 L
s
.821 .226 .095 r
.55932 .57757 m .57811 .58042 L .57966 .59975 L p F P
0 0 0 r
s
.821 .226 .095 r
.59871 .60259 m .57966 .59975 L .57811 .58042 L p F P
0 0 0 r
s
.24 .35 .67 r
.44232 .77285 m
.46984 .77082 L
s
.46984 .77082 m
.47963 .75287 L
s
.83 .24 .1 r
.50917 .50592 m
.51417 .47763 L
s
.969 .278 .118 r
.51865 .44264 m .52739 .44412 L .53523 .46644 L p F P
0 0 0 r
s
.24 .35 .67 r
.52066 .44764 m
.52123 .44635 L
s
.969 .278 .118 r
.53523 .46644 m .52399 .46458 L .51865 .44264 L p F P
0 0 0 r
s
.934 .265 .112 r
.48808 .48045 m .50169 .48267 L .50193 .5048 L p F P
0 0 0 r
s
.934 .265 .112 r
.50193 .5048 m .48638 .50231 L .48808 .48045 L p F P
0 0 0 r
s
.913 .257 .109 r
.48638 .50231 m .50193 .5048 L .50213 .52683 L p F P
0 0 0 r
s
.83 .24 .1 r
.73502 .41761 m
.72428 .43545 L
s
.68724 .42897 m
.72428 .43545 L
s
.24 .35 .67 r
.3189 .57022 m
.32575 .54833 L
s
.3189 .57022 m
.3139 .59372 L
s
.32101 .70718 m
.32791 .68796 L
s
.32101 .70718 m
.33873 .72857 L
s
.83 .24 .1 r
.55369 .45593 m
.55822 .45669 L
s
.913 .257 .109 r
.50213 .52683 m .48498 .52413 L .48638 .50231 L p F P
0 0 0 r
s
.888 .248 .105 r
.48498 .52413 m .50213 .52683 L .50228 .54834 L p F P
0 0 0 r
s
.888 .248 .105 r
.52055 .55116 m .50228 .54834 L .50213 .52683 L p F P
0 0 0 r
s
.83 .24 .1 r
.50545 .53428 m
.50917 .50592 L
s
.50545 .53428 m
.54331 .54019 L
s
.952 .272 .115 r
.49007 .45894 m .50141 .46083 L .50169 .48267 L p F P
0 0 0 r
s
.952 .272 .115 r
.50169 .48267 m .48808 .48045 L .49007 .45894 L p F P
0 0 0 r
s
.098 .143 .332 r
.609 .56176 m .60284 .57261 L .59851 .55191 L p F P
0 0 0 r
s
.24 .35 .67 r
.5945 .5763 m
.59992 .56666 L
s
.098 .143 .332 r
.59851 .55191 m .60436 .54133 L .609 .56176 L p F P
0 0 0 r
s
.24 .35 .67 r
.59046 .5429 m
.59992 .56666 L
s
.969 .278 .118 r
.50988 .44116 m .51865 .44264 L .52399 .46458 L p F P
0 0 0 r
s
.969 .278 .118 r
.52399 .46458 m .51272 .4627 L .50988 .44116 L p F P
0 0 0 r
s
.83 .24 .1 r
.51417 .47763 m
.5203 .45032 L
s
.24 .35 .67 r
.50547 .74552 m
.52794 .73327 L
s
.52794 .73327 m
.53888 .71456 L
s
.46569 .43372 m
.43808 .43375 L
s
.858 .238 .1 r
.50228 .54834 m .52055 .55116 L .52146 .57184 L p F P
0 0 0 r
s
.858 .238 .1 r
.54044 .57471 m .52146 .57184 L .52055 .55116 L p F P
0 0 0 r
s
.821 .226 .095 r
.54044 .57471 m .55932 .57757 L .5605 .5969 L p F P
0 0 0 r
s
.821 .226 .095 r
.57966 .59975 m .5605 .5969 L .55932 .57757 L p F P
0 0 0 r
s
.934 .265 .112 r
.47443 .47822 m .48808 .48045 L .48638 .50231 L p F P
0 0 0 r
s
.934 .265 .112 r
.48638 .50231 m .47076 .49981 L .47443 .47822 L p F P
0 0 0 r
s
.913 .257 .109 r
.47076 .49981 m .48638 .50231 L .48498 .52413 L p F P
0 0 0 r
s
.83 .24 .1 r
.6166 .60445 m
.61884 .62721 L
s
.215 .319 .651 r
.56097 .46321 m .56436 .45617 L .57723 .47719 L p F P
0 0 0 r
s
.234 .348 .702 r
.56436 .45617 m .56097 .46321 L .54737 .44156 L p F P
0 0 0 r
s
.234 .348 .702 r
.54482 .44706 m .54737 .44156 L .56097 .46321 L p F P
0 0 0 r
s
.83 .24 .1 r
.5203 .45032 m
.55064 .45542 L
s
.969 .278 .118 r
.50109 .43968 m .50988 .44116 L .51272 .4627 L p F P
0 0 0 r
s
.969 .278 .118 r
.51272 .4627 m .50141 .46083 L .50109 .43968 L p F P
0 0 0 r
s
.952 .272 .115 r
.47869 .45705 m .49007 .45894 L .48808 .48045 L p F P
0 0 0 r
s
.952 .272 .115 r
.48808 .48045 m .47443 .47822 L .47869 .45705 L p F P
0 0 0 r
s
.24 .35 .67 r
.30823 .63921 m
.31489 .61862 L
s
.30823 .63921 m
.31515 .66408 L
s
.913 .257 .109 r
.48498 .52413 m .46775 .52142 L .47076 .49981 L p F P
0 0 0 r
s
.83 .24 .1 r
.47103 .49981 m
.50917 .50592 L
s
.888 .248 .105 r
.46775 .52142 m .48498 .52413 L .48391 .54551 L p F P
0 0 0 r
s
.888 .248 .105 r
.50228 .54834 m .48391 .54551 L .48498 .52413 L p F P
0 0 0 r
s
.774 .211 .088 r
.57966 .59975 m .59871 .60259 L .59841 .61991 L p F P
0 0 0 r
s
.24 .35 .67 r
.58992 .63586 m
.59175 .61275 L
s
.049 .072 .169 r
.60457 .60945 m .59841 .61991 L .59871 .60259 L p F P
0 0 0 r
s
.049 .072 .169 r
.59871 .60259 m .60489 .59192 L .60457 .60945 L p F P
0 0 0 r
s
.83 .24 .1 r
.6047 .60267 m
.6166 .60445 L
s
.982 .284 .121 r
.5248 .42375 m .53079 .42478 L .54482 .44706 L p F P
0 0 0 r
s
.982 .284 .121 r
.54482 .44706 m .53611 .44559 L .5248 .42375 L p F P
0 0 0 r
s
.251 .373 .747 r
.54737 .44156 m .54482 .44706 L .53079 .42478 L p F P
0 0 0 r
s
.934 .265 .112 r
.46073 .47599 m .47443 .47822 L .47076 .49981 L p F P
0 0 0 r
s
.934 .265 .112 r
.47076 .49981 m .45508 .4973 L .46073 .47599 L p F P
0 0 0 r
s
.913 .257 .109 r
.45508 .4973 m .47076 .49981 L .46775 .52142 L p F P
0 0 0 r
s
.83 .24 .1 r
.612 .41582 m
.6034 .43798 L
s
.858 .238 .1 r
.48391 .54551 m .50228 .54834 L .50238 .56895 L p F P
0 0 0 r
s
.858 .238 .1 r
.52146 .57184 m .50238 .56895 L .50228 .54834 L p F P
0 0 0 r
s
.83 .24 .1 r
.50317 .56176 m
.54126 .56757 L
s
.50317 .56176 m
.50545 .53428 L
s
.65658 .63272 m
.69392 .63817 L
s
.69392 .63817 m
.69917 .6573 L
s
.969 .278 .118 r
.49229 .43819 m .50109 .43968 L .50141 .46083 L p F P
0 0 0 r
s
.969 .278 .118 r
.50141 .46083 m .49007 .45894 L .49229 .43819 L p F P
0 0 0 r
s
.821 .226 .095 r
.52146 .57184 m .54044 .57471 L .54124 .59403 L p F P
0 0 0 r
s
.821 .226 .095 r
.5605 .5969 m .54124 .59403 L .54044 .57471 L p F P
0 0 0 r
s
.952 .272 .115 r
.46727 .45516 m .47869 .45705 L .47443 .47822 L p F P
0 0 0 r
s
.83 .24 .1 r
.47601 .47136 m
.51417 .47763 L
s
.952 .272 .115 r
.47443 .47822 m .46073 .47599 L .46727 .45516 L p F P
0 0 0 r
s
.83 .24 .1 r
.47103 .49981 m
.47601 .47136 L
s
.167 .247 .522 r
.60292 .50992 m .59742 .52016 L .58831 .49865 L p F P
0 0 0 r
s
.167 .247 .522 r
.58831 .49865 m .59323 .4892 L .60292 .50992 L p F P
0 0 0 r
s
.193 .286 .592 r
.59323 .4892 m .58831 .49865 L .57723 .47719 L p F P
0 0 0 r
s
.24 .35 .67 r
.57753 .51787 m
.58777 .49814 L
s
.982 .284 .121 r
.5188 .42272 m .5248 .42375 L .53611 .44559 L p F P
0 0 0 r
s
.982 .284 .121 r
.53611 .44559 m .52739 .44412 L .5188 .42272 L p F P
0 0 0 r
s
.24 .35 .67 r
.52258 .44331 m
.52494 .43801 L
s
.83 .24 .1 r
.69751 .41095 m
.68724 .42897 L
s
.64981 .42243 m
.68724 .42897 L
s
.193 .286 .592 r
.57723 .47719 m .58144 .46878 L .59323 .4892 L p F P
0 0 0 r
s
.24 .35 .67 r
.56867 .47804 m
.58777 .49814 L
s
.215 .319 .651 r
.58144 .46878 m .57723 .47719 L .56436 .45617 L p F P
0 0 0 r
s
.913 .257 .109 r
.46775 .52142 m .45045 .5187 L .45508 .4973 L p F P
0 0 0 r
s
.888 .248 .105 r
.45045 .5187 m .46775 .52142 L .46546 .54266 L p F P
0 0 0 r
s
.888 .248 .105 r
.48391 .54551 m .46546 .54266 L .46775 .52142 L p F P
0 0 0 r
s
.83 .24 .1 r
.46721 .5283 m
.50545 .53428 L
s
.46721 .5283 m
.47103 .49981 L
s
.24 .35 .67 r
.41404 .76938 m
.44232 .77285 L
s
.44232 .77285 m
.45162 .75484 L
s
.969 .278 .118 r
.48346 .4367 m .49229 .43819 L .49007 .45894 L p F P
0 0 0 r
s
.969 .278 .118 r
.49007 .45894 m .47869 .45705 L .48346 .4367 L p F P
0 0 0 r
s
.934 .265 .112 r
.44697 .47374 m .46073 .47599 L .45508 .4973 L p F P
0 0 0 r
s
.934 .265 .112 r
.45508 .4973 m .43933 .49478 L .44697 .47374 L p F P
0 0 0 r
s
.913 .257 .109 r
.43933 .49478 m .45508 .4973 L .45045 .5187 L p F P
0 0 0 r
s
.982 .284 .121 r
.5128 .42169 m .5188 .42272 L .52739 .44412 L p F P
0 0 0 r
s
.982 .284 .121 r
.52739 .44412 m .51865 .44264 L .5128 .42169 L p F P
0 0 0 r
s
.83 .24 .1 r
.5203 .45032 m
.52738 .42494 L
s
.067 .097 .237 r
.61119 .58104 m .60489 .59192 L .60284 .57261 L p F P
0 0 0 r
s
.067 .097 .237 r
.60284 .57261 m .609 .56176 L .61119 .58104 L p F P
0 0 0 r
s
.24 .35 .67 r
.59992 .56666 m
.60392 .59107 L
s
.33873 .72857 m
.34601 .70967 L
s
.33873 .72857 m
.3609 .74666 L
s
.58223 .65834 m
.58992 .63586 L
s
.774 .211 .088 r
.5605 .5969 m .57966 .59975 L .57941 .61713 L p F P
0 0 0 r
s
.83 .24 .1 r
.57893 .59883 m
.57897 .57332 L
s
.774 .211 .088 r
.59841 .61991 m .57941 .61713 L .57966 .59975 L p F P
0 0 0 r
s
.83 .24 .1 r
.57893 .59883 m
.59914 .60185 L
s
.24 .35 .67 r
.59738 .60239 m
.60392 .59107 L
s
.952 .272 .115 r
.45583 .45326 m .46727 .45516 L .46073 .47599 L p F P
0 0 0 r
s
.952 .272 .115 r
.46073 .47599 m .44697 .47374 L .45583 .45326 L p F P
0 0 0 r
s
.136 .2 .437 r
.61033 .53055 m .60436 .54133 L .59742 .52016 L p F P
0 0 0 r
s
.136 .2 .437 r
.59742 .52016 m .60292 .50992 L .61033 .53055 L p F P
0 0 0 r
s
.24 .35 .67 r
.59046 .5429 m
.60254 .52061 L
s
.858 .238 .1 r
.46546 .54266 m .48391 .54551 L .4832 .56604 L p F P
0 0 0 r
s
.858 .238 .1 r
.50238 .56895 m .4832 .56604 L .48391 .54551 L p F P
0 0 0 r
s
.821 .226 .095 r
.50238 .56895 m .52146 .57184 L .52189 .59115 L p F P
0 0 0 r
s
.821 .226 .095 r
.54124 .59403 m .52189 .59115 L .52146 .57184 L p F P
0 0 0 r
s
.969 .278 .118 r
.47461 .4352 m .48346 .4367 L .47869 .45705 L p F P
0 0 0 r
s
.83 .24 .1 r
.48198 .44389 m
.5203 .45032 L
s
.969 .278 .118 r
.47869 .45705 m .46727 .45516 L .47461 .4352 L p F P
0 0 0 r
s
.83 .24 .1 r
.47601 .47136 m
.48198 .44389 L
s
.982 .284 .121 r
.50678 .42066 m .5128 .42169 L .51865 .44264 L p F P
0 0 0 r
s
.982 .284 .121 r
.51865 .44264 m .50988 .44116 L .50678 .42066 L p F P
0 0 0 r
s
.913 .257 .109 r
.45045 .5187 m .43306 .51597 L .43933 .49478 L p F P
0 0 0 r
s
.888 .248 .105 r
.43306 .51597 m .45045 .5187 L .44691 .5398 L p F P
0 0 0 r
s
.888 .248 .105 r
.46546 .54266 m .44691 .5398 L .45045 .5187 L p F P
0 0 0 r
s
.215 .319 .651 r
.56436 .45617 m .5678 .44906 L .58144 .46878 L p F P
0 0 0 r
s
.234 .348 .702 r
.5678 .44906 m .56436 .45617 L .54994 .436 L p F P
0 0 0 r
s
.83 .24 .1 r
.55958 .45206 m
.56011 .45023 L
s
.56558 .43149 m
.6034 .43798 L
s
.234 .348 .702 r
.54737 .44156 m .54994 .436 L .56436 .45617 L p F P
0 0 0 r
s
.83 .24 .1 r
.56175 .44463 m
.56558 .43149 L
s
.934 .265 .112 r
.43317 .47149 m .44697 .47374 L .43933 .49478 L p F P
0 0 0 r
s
.934 .265 .112 r
.43933 .49478 m .42352 .49224 L .43317 .47149 L p F P
0 0 0 r
s
.913 .257 .109 r
.42352 .49224 m .43933 .49478 L .43306 .51597 L p F P
0 0 0 r
s
.83 .24 .1 r
.4325 .49364 m
.47103 .49981 L
s
.251 .373 .747 r
.54994 .436 m .54737 .44156 L .5325 .42094 L p F P
0 0 0 r
s
.251 .373 .747 r
.53079 .42478 m .5325 .42094 L .54737 .44156 L p F P
0 0 0 r
s
.952 .272 .115 r
.44434 .45135 m .45583 .45326 L .44697 .47374 L p F P
0 0 0 r
s
.952 .272 .115 r
.44697 .47374 m .43317 .47149 L .44434 .45135 L p F P
0 0 0 r
s
.24 .35 .67 r
.33643 .52708 m
.32575 .54833 L
s
.982 .284 .121 r
.50075 .41963 m .50678 .42066 L .50988 .44116 L p F P
0 0 0 r
s
.982 .284 .121 r
.50988 .44116 m .50109 .43968 L .50075 .41963 L p F P
0 0 0 r
s
.24 .35 .67 r
.5014 .41974 m
.5031 .41566 L
s
.969 .278 .118 r
.46574 .4337 m .47461 .4352 L .46727 .45516 L p F P
0 0 0 r
s
.969 .278 .118 r
.46727 .45516 m .45583 .45326 L .46574 .4337 L p F P
0 0 0 r
s
.83 .24 .1 r
.77214 .4242 m
.78407 .41113 L
s
.73502 .41761 m
.77214 .4242 L
s
.774 .211 .088 r
.54124 .59403 m .5605 .5969 L .56032 .61433 L p F P
0 0 0 r
s
.774 .211 .088 r
.57941 .61713 m .56032 .61433 L .5605 .5969 L p F P
0 0 0 r
s
.858 .238 .1 r
.44691 .5398 m .46546 .54266 L .46392 .56312 L p F P
0 0 0 r
s
.858 .238 .1 r
.4832 .56604 m .46392 .56312 L .46546 .54266 L p F P
0 0 0 r
s
.83 .24 .1 r
.46468 .55589 m
.46721 .5283 L
s
.46468 .55589 m
.50317 .56176 L
s
.24 .35 .67 r
.38643 .7605 m
.41404 .76938 L
s
.41404 .76938 m
.42282 .75122 L
s
.83 .24 .1 r
.61884 .62721 m
.65658 .63272 L
s
.65658 .63272 m
.66129 .65187 L
s
.821 .226 .095 r
.4832 .56604 m .50238 .56895 L .50243 .58825 L p F P
0 0 0 r
s
.821 .226 .095 r
.52189 .59115 m .50243 .58825 L .50238 .56895 L p F P
0 0 0 r
s
.24 .35 .67 r
.3609 .74666 m
.36864 .72805 L
s
.3609 .74666 m
.38643 .7605 L
s
.982 .284 .121 r
.49471 .41859 m .50075 .41963 L .50109 .43968 L p F P
0 0 0 r
s
.24 .35 .67 r
.49356 .4384 m
.49771 .42851 L
s
.982 .284 .121 r
.50109 .43968 m .49229 .43819 L .49471 .41859 L p F P
0 0 0 r
s
.24 .35 .67 r
.53888 .71456 m
.55725 .698 L
s
.55725 .698 m
.56887 .67842 L
s
.913 .257 .109 r
.43306 .51597 m .41559 .51322 L .42352 .49224 L p F P
0 0 0 r
s
.888 .248 .105 r
.41559 .51322 m .43306 .51597 L .42827 .53692 L p F P
0 0 0 r
s
.888 .248 .105 r
.44691 .5398 m .42827 .53692 L .43306 .51597 L p F P
0 0 0 r
s
.83 .24 .1 r
.42857 .52226 m
.46721 .5283 L
s
.42857 .52226 m
.4325 .49364 L
s
.952 .272 .115 r
.43282 .44943 m .44434 .45135 L .43317 .47149 L p F P
0 0 0 r
s
.83 .24 .1 r
.43746 .46504 m
.47601 .47136 L
s
.952 .272 .115 r
.43317 .47149 m .41931 .46923 L .43282 .44943 L p F P
0 0 0 r
s
.934 .265 .112 r
.41931 .46923 m .43317 .47149 L .42352 .49224 L p F P
0 0 0 r
s
.83 .24 .1 r
.4325 .49364 m
.43746 .46504 L
s
.098 .143 .332 r
.61528 .5507 m .609 .56176 L .60436 .54133 L p F P
0 0 0 r
s
.098 .143 .332 r
.60436 .54133 m .61033 .53055 L .61528 .5507 L p F P
0 0 0 r
s
.934 .265 .112 r
.42352 .49224 m .40764 .4897 L .41931 .46923 L p F P
0 0 0 r
s
.913 .257 .109 r
.40764 .4897 m .42352 .49224 L .41559 .51322 L p F P
0 0 0 r
s
.83 .24 .1 r
.6596 .40422 m
.64981 .42243 L
s
.612 .41582 m
.64981 .42243 L
s
.969 .278 .118 r
.45685 .4322 m .46574 .4337 L .45583 .45326 L p F P
0 0 0 r
s
.969 .278 .118 r
.45583 .45326 m .44434 .45135 L .45685 .4322 L p F P
0 0 0 r
s
.24 .35 .67 r
.38643 .7605 m
.39468 .74214 L
s
.47963 .75287 m
.50547 .74552 L
s
.50547 .74552 m
.51607 .72687 L
s
.982 .284 .121 r
.48867 .41755 m .49471 .41859 L .49229 .43819 L p F P
0 0 0 r
s
.982 .284 .121 r
.49229 .43819 m .48346 .4367 L .48867 .41755 L p F P
0 0 0 r
s
.858 .238 .1 r
.42827 .53692 m .44691 .5398 L .44455 .56018 L p F P
0 0 0 r
s
.858 .238 .1 r
.46392 .56312 m .44455 .56018 L .44691 .5398 L p F P
0 0 0 r
s
.774 .211 .088 r
.52189 .59115 m .54124 .59403 L .54112 .61151 L p F P
0 0 0 r
s
.83 .24 .1 r
.54086 .59316 m
.54126 .56757 L
s
.774 .211 .088 r
.56032 .61433 m .54112 .61151 L .54124 .59403 L p F P
0 0 0 r
s
.83 .24 .1 r
.54086 .59316 m
.57893 .59883 L
s
.24 .35 .67 r
.3139 .59372 m
.32073 .57204 L
s
.3139 .59372 m
.31489 .61862 L
s
.969 .278 .118 r
.44794 .4307 m .45685 .4322 L .44434 .45135 L p F P
0 0 0 r
s
.969 .278 .118 r
.44434 .45135 m .43282 .44943 L .44794 .4307 L p F P
0 0 0 r
s
.952 .272 .115 r
.42127 .44752 m .43282 .44943 L .41931 .46923 L p F P
0 0 0 r
s
.952 .272 .115 r
.41931 .46923 m .4054 .46696 L .42127 .44752 L p F P
0 0 0 r
s
.934 .265 .112 r
.4054 .46696 m .41931 .46923 L .40764 .4897 L p F P
0 0 0 r
s
.821 .226 .095 r
.46392 .56312 m .4832 .56604 L .48286 .58533 L p F P
0 0 0 r
s
.821 .226 .095 r
.50243 .58825 m .48286 .58533 L .4832 .56604 L p F P
0 0 0 r
s
.982 .284 .121 r
.48261 .41651 m .48867 .41755 L .48346 .4367 L p F P
0 0 0 r
s
.982 .284 .121 r
.48346 .4367 m .47461 .4352 L .48261 .41651 L p F P
0 0 0 r
s
.193 .286 .592 r
.59822 .4796 m .59323 .4892 L .58144 .46878 L p F P
0 0 0 r
s
.193 .286 .592 r
.58144 .46878 m .58572 .46027 L .59822 .4796 L p F P
0 0 0 r
s
.215 .319 .651 r
.58572 .46027 m .58144 .46878 L .5678 .44906 L p F P
0 0 0 r
s
.24 .35 .67 r
.31515 .66408 m
.322 .64378 L
s
.31515 .66408 m
.32791 .68796 L
s
.934 .265 .112 r
.40764 .4897 m .39169 .48715 L .4054 .46696 L p F P
0 0 0 r
s
.913 .257 .109 r
.39169 .48715 m .40764 .4897 L .39804 .51046 L p F P
0 0 0 r
s
.913 .257 .109 r
.41559 .51322 m .39804 .51046 L .40764 .4897 L p F P
0 0 0 r
s
.888 .248 .105 r
.39804 .51046 m .41559 .51322 L .40953 .53403 L p F P
0 0 0 r
s
.888 .248 .105 r
.42827 .53692 m .40953 .53403 L .41559 .51322 L p F P
0 0 0 r
s
.234 .348 .702 r
.54994 .436 m .55254 .4304 L .5678 .44906 L p F P
0 0 0 r
s
.251 .373 .747 r
.55254 .4304 m .54994 .436 L .53422 .41707 L p F P
0 0 0 r
s
.83 .24 .1 r
.55048 .4289 m
.56558 .43149 L
s
.251 .373 .747 r
.5325 .42094 m .53422 .41707 L .54994 .436 L p F P
0 0 0 r
s
.83 .24 .1 r
.52738 .42494 m
.53404 .42608 L
s
.167 .247 .522 r
.60852 .4995 m .60292 .50992 L .59323 .4892 L p F P
0 0 0 r
s
.167 .247 .522 r
.59323 .4892 m .59822 .4796 L .60852 .4995 L p F P
0 0 0 r
s
.24 .35 .67 r
.58777 .49814 m
.60254 .52061 L
s
.028 .04 .082 r
.60182 .6248 m .59585 .63484 L .59841 .61991 L p F P
0 0 0 r
s
.028 .04 .082 r
.59841 .61991 m .60457 .60945 L .60182 .6248 L p F P
0 0 0 r
s
.712 .19 .079 r
.57941 .61713 m .59841 .61991 L .59585 .63484 L p F P
0 0 0 r
s
.24 .35 .67 r
.58992 .63586 m
.59259 .63133 L
s
.992 .289 .123 r
.51269 .40323 m .51577 .40376 L .53079 .42478 L p F P
0 0 0 r
s
.992 .289 .123 r
.53079 .42478 m .5248 .42375 L .51269 .40323 L p F P
0 0 0 r
s
.267 .397 .787 r
.5325 .42094 m .53079 .42478 L .51577 .40376 L p F P
0 0 0 r
s
.24 .35 .67 r
.5295 .42774 m
.5314 .42347 L
s
.982 .284 .121 r
.47654 .41547 m .48261 .41651 L .47461 .4352 L p F P
0 0 0 r
s
.982 .284 .121 r
.47461 .4352 m .46574 .4337 L .47654 .41547 L p F P
0 0 0 r
s
.969 .278 .118 r
.439 .42919 m .44794 .4307 L .43282 .44943 L p F P
0 0 0 r
s
.83 .24 .1 r
.44327 .43739 m
.48198 .44389 L
s
.969 .278 .118 r
.43282 .44943 m .42127 .44752 L .439 .42919 L p F P
0 0 0 r
s
.049 .072 .169 r
.61085 .59877 m .60457 .60945 L .60489 .59192 L p F P
0 0 0 r
s
.049 .072 .169 r
.60489 .59192 m .61119 .58104 L .61085 .59877 L p F P
0 0 0 r
s
.83 .24 .1 r
.69917 .6573 m
.73666 .66268 L
s
.7445 .67739 m
.73666 .66268 L
s
.215 .319 .651 r
.5678 .44906 m .57127 .44186 L .58572 .46027 L p F P
0 0 0 r
s
.234 .348 .702 r
.57127 .44186 m .5678 .44906 L .55254 .4304 L p F P
0 0 0 r
s
.24 .35 .67 r
.54823 .45627 m
.55725 .43707 L
s
.952 .272 .115 r
.40968 .44559 m .42127 .44752 L .4054 .46696 L p F P
0 0 0 r
s
.952 .272 .115 r
.4054 .46696 m .39144 .46468 L .40968 .44559 L p F P
0 0 0 r
s
.934 .265 .112 r
.39144 .46468 m .4054 .46696 L .39169 .48715 L p F P
0 0 0 r
s
.992 .289 .123 r
.50962 .40269 m .51269 .40323 L .5248 .42375 L p F P
0 0 0 r
s
.992 .289 .123 r
.5248 .42375 m .5188 .42272 L .50962 .40269 L p F P
0 0 0 r
s
.858 .238 .1 r
.40953 .53403 m .42827 .53692 L .42507 .55723 L p F P
0 0 0 r
s
.858 .238 .1 r
.44455 .56018 m .42507 .55723 L .42827 .53692 L p F P
0 0 0 r
s
.83 .24 .1 r
.42578 .54996 m
.42857 .52226 L
s
.42578 .54996 m
.46468 .55589 L
s
.7464 .40437 m
.73502 .41761 L
s
.69751 .41095 m
.73502 .41761 L
s
.774 .211 .088 r
.50243 .58825 m .52189 .59115 L .52182 .60869 L p F P
0 0 0 r
s
.774 .211 .088 r
.54112 .61151 m .52182 .60869 L .52189 .59115 L p F P
0 0 0 r
s
.83 .24 .1 r
.60183 .62473 m
.61884 .62721 L
s
.61884 .62721 m
.62301 .64638 L
s
.982 .284 .121 r
.47046 .41443 m .47654 .41547 L .46574 .4337 L p F P
0 0 0 r
s
.24 .35 .67 r
.4657 .4337 m
.46582 .4334 L
s
.47314 .41489 m
.47477 .41078 L
s
.982 .284 .121 r
.46574 .4337 m .45685 .4322 L .47046 .41443 L p F P
0 0 0 r
s
.934 .265 .112 r
.39169 .48715 m .37567 .48458 L .39144 .46468 L p F P
0 0 0 r
s
.913 .257 .109 r
.37567 .48458 m .39169 .48715 L .3804 .50769 L p F P
0 0 0 r
s
.913 .257 .109 r
.39804 .51046 m .3804 .50769 L .39169 .48715 L p F P
0 0 0 r
s
.83 .24 .1 r
.39357 .48741 m
.4325 .49364 L
s
.821 .226 .095 r
.44455 .56018 m .46392 .56312 L .4632 .58241 L p F P
0 0 0 r
s
.821 .226 .095 r
.48286 .58533 m .4632 .58241 L .46392 .56312 L p F P
0 0 0 r
s
.83 .24 .1 r
.46354 .58164 m
.46468 .55589 L
s
.888 .248 .105 r
.3804 .50769 m .39804 .51046 L .3907 .53112 L p F P
0 0 0 r
s
.888 .248 .105 r
.40953 .53403 m .3907 .53112 L .39804 .51046 L p F P
0 0 0 r
s
.992 .289 .123 r
.50654 .40216 m .50962 .40269 L .5188 .42272 L p F P
0 0 0 r
s
.992 .289 .123 r
.5188 .42272 m .5128 .42169 L .50654 .40216 L p F P
0 0 0 r
s
.969 .278 .118 r
.43005 .42767 m .439 .42919 L .42127 .44752 L p F P
0 0 0 r
s
.83 .24 .1 r
.43746 .46504 m
.44327 .43739 L
s
.969 .278 .118 r
.42127 .44752 m .40968 .44559 L .43005 .42767 L p F P
0 0 0 r
s
.24 .35 .67 r
.4118 .43858 m
.41919 .43722 L
s
.4091 .44619 m
.4118 .43858 L
s
.136 .2 .437 r
.61641 .51957 m .61033 .53055 L .60292 .50992 L p F P
0 0 0 r
s
.136 .2 .437 r
.60292 .50992 m .60852 .4995 L .61641 .51957 L p F P
0 0 0 r
s
.24 .35 .67 r
.5314 .42347 m
.55725 .43707 L
s
.52127 .42001 m
.5314 .42347 L
s
.83 .24 .1 r
.62129 .39742 m
.612 .41582 L
s
.57379 .40915 m
.612 .41582 L
s
.992 .289 .123 r
.50347 .40162 m .50654 .40216 L .5128 .42169 L p F P
0 0 0 r
s
.992 .289 .123 r
.5128 .42169 m .50678 .42066 L .50347 .40162 L p F P
0 0 0 r
s
.952 .272 .115 r
.39805 .44366 m .40968 .44559 L .39144 .46468 L p F P
0 0 0 r
s
.83 .24 .1 r
.3985 .45864 m
.43746 .46504 L
s
.952 .272 .115 r
.39144 .46468 m .37743 .4624 L .39805 .44366 L p F P
0 0 0 r
s
.83 .24 .1 r
.39357 .48741 m
.3985 .45864 L
s
.24 .35 .67 r
.3798 .47208 m
.38278 .46327 L
s
.934 .265 .112 r
.37743 .4624 m .39144 .46468 L .37567 .48458 L p F P
0 0 0 r
s
.24 .35 .67 r
.3596 .48613 m
.37648 .47439 L
s
.982 .284 .121 r
.46438 .41338 m .47046 .41443 L .45685 .4322 L p F P
0 0 0 r
s
.982 .284 .121 r
.45685 .4322 m .44794 .4307 L .46438 .41338 L p F P
0 0 0 r
s
.712 .19 .079 r
.56032 .61433 m .57941 .61713 L .57734 .63217 L p F P
0 0 0 r
s
.712 .19 .079 r
.59585 .63484 m .57734 .63217 L .57941 .61713 L p F P
0 0 0 r
s
.83 .24 .1 r
.57893 .59883 m
.58071 .62165 L
s
.58071 .62165 m
.59791 .62416 L
s
.067 .097 .237 r
.61762 .56995 m .61119 .58104 L .609 .56176 L p F P
0 0 0 r
s
.067 .097 .237 r
.609 .56176 m .61528 .5507 L .61762 .56995 L p F P
0 0 0 r
s
.267 .397 .787 r
.53422 .41707 m .5325 .42094 L .51662 .40176 L p F P
0 0 0 r
s
.267 .397 .787 r
.51577 .40376 m .51662 .40176 L .5325 .42094 L p F P
0 0 0 r
s
.83 .24 .1 r
.52738 .42494 m
.53022 .41673 L
s
.992 .289 .123 r
.50038 .40108 m .50347 .40162 L .50678 .42066 L p F P
0 0 0 r
s
.992 .289 .123 r
.50678 .42066 m .50075 .41963 L .50038 .40108 L p F P
0 0 0 r
s
.858 .238 .1 r
.3907 .53112 m .40953 .53403 L .40549 .55427 L p F P
0 0 0 r
s
.858 .238 .1 r
.42507 .55723 m .40549 .55427 L .40953 .53403 L p F P
0 0 0 r
s
.969 .278 .118 r
.42107 .42616 m .43005 .42767 L .40968 .44559 L p F P
0 0 0 r
s
.969 .278 .118 r
.40968 .44559 m .39805 .44366 L .42107 .42616 L p F P
0 0 0 r
s
.934 .265 .112 r
.37567 .48458 m .35959 .482 L .37743 .4624 L p F P
0 0 0 r
s
.913 .257 .109 r
.35959 .482 m .37567 .48458 L .36269 .50491 L p F P
0 0 0 r
s
.24 .35 .67 r
.3596 .48613 m
.35999 .48495 L
s
.913 .257 .109 r
.3804 .50769 m .36269 .50491 L .37567 .48458 L p F P
0 0 0 r
s
.774 .211 .088 r
.48286 .58533 m .50243 .58825 L .50242 .60584 L p F P
0 0 0 r
s
.83 .24 .1 r
.5024 .58743 m
.50317 .56176 L
s
.774 .211 .088 r
.52182 .60869 m .50242 .60584 L .50243 .58825 L p F P
0 0 0 r
s
.83 .24 .1 r
.5024 .58743 m
.54086 .59316 L
s
.982 .284 .121 r
.45828 .41234 m .46438 .41338 L .44794 .4307 L p F P
0 0 0 r
s
.982 .284 .121 r
.44794 .4307 m .439 .42919 L .45828 .41234 L p F P
0 0 0 r
s
.888 .248 .105 r
.36269 .50491 m .3804 .50769 L .37178 .5282 L p F P
0 0 0 r
s
.888 .248 .105 r
.3907 .53112 m .37178 .5282 L .3804 .50769 L p F P
0 0 0 r
s
.83 .24 .1 r
.38952 .51616 m
.39357 .48741 L
s
.38952 .51616 m
.42857 .52226 L
s
.234 .348 .702 r
.55254 .4304 m .55516 .42475 L .57127 .44186 L p F P
0 0 0 r
s
.251 .373 .747 r
.55516 .42475 m .55254 .4304 L .53595 .41318 L p F P
0 0 0 r
s
.251 .373 .747 r
.53422 .41707 m .53595 .41318 L .55254 .4304 L p F P
0 0 0 r
s
.821 .226 .095 r
.42507 .55723 m .44455 .56018 L .44343 .57946 L p F P
0 0 0 r
s
.821 .226 .095 r
.4632 .58241 m .44343 .57946 L .44455 .56018 L p F P
0 0 0 r
s
.992 .289 .123 r
.4973 .40055 m .50038 .40108 L .50075 .41963 L p F P
0 0 0 r
s
.992 .289 .123 r
.50075 .41963 m .49471 .41859 L .4973 .40055 L p F P
0 0 0 r
s
.332 .492 .931 r
.38029 .45379 m .37743 .4624 L .39805 .44366 L p F P
0 0 0 r
s
.83 .24 .1 r
.38353 .45619 m
.3985 .45864 L
s
.33 .49 .916 r
.37743 .4624 m .38029 .45379 L .36273 .47229 L p F P
0 0 0 r
s
.83 .24 .1 r
.35914 .45218 m
.37876 .4554 L
s
.33 .49 .916 r
.36273 .47229 m .35959 .482 L .37743 .4624 L p F P
0 0 0 r
s
.24 .35 .67 r
.56887 .67842 m
.58223 .65834 L
s
.992 .289 .123 r
.49421 .40001 m .4973 .40055 L .49471 .41859 L p F P
0 0 0 r
s
.992 .289 .123 r
.49471 .41859 m .48867 .41755 L .49421 .40001 L p F P
0 0 0 r
s
.83 .24 .1 r
.48877 .41832 m
.52738 .42494 L
s
.48198 .44389 m
.48877 .41832 L
s
.982 .284 .121 r
.45217 .41129 m .45828 .41234 L .439 .42919 L p F P
0 0 0 r
s
.982 .284 .121 r
.439 .42919 m .43005 .42767 L .45217 .41129 L p F P
0 0 0 r
s
.327 .485 .926 r
.40055 .4364 m .39805 .44366 L .42107 .42616 L p F P
0 0 0 r
s
.83 .24 .1 r
.41204 .43214 m
.44327 .43739 L
s
.332 .492 .931 r
.39805 .44366 m .40055 .4364 L .38029 .45379 L p F P
0 0 0 r
s
.83 .24 .1 r
.3985 .45864 m
.40252 .43881 L
s
.712 .19 .079 r
.54112 .61151 m .56032 .61433 L .55874 .62948 L p F P
0 0 0 r
s
.712 .19 .079 r
.57734 .63217 m .55874 .62948 L .56032 .61433 L p F P
0 0 0 r
s
.913 .257 .109 r
.36269 .50491 m .34489 .50211 L .35959 .482 L p F P
0 0 0 r
s
.318 .471 .867 r
.35959 .482 m .36273 .47229 L .34823 .49155 L p F P
0 0 0 r
s
.83 .24 .1 r
.35423 .4811 m
.35589 .48137 L
s
.318 .471 .867 r
.34823 .49155 m .34489 .50211 L .35959 .482 L p F P
0 0 0 r
s
.83 .24 .1 r
.35926 .48191 m
.39357 .48741 L
s
.24 .35 .67 r
.45162 .75484 m
.47963 .75287 L
s
.47963 .75287 m
.4898 .73421 L
s
.992 .289 .123 r
.49112 .39947 m .49421 .40001 L .48867 .41755 L p F P
0 0 0 r
s
.992 .289 .123 r
.48867 .41755 m .48261 .41651 L .49112 .39947 L p F P
0 0 0 r
s
.83 .24 .1 r
.66129 .65187 m
.69917 .6573 L
s
.69917 .6573 m
.70642 .672 L
s
.858 .238 .1 r
.37178 .5282 m .3907 .53112 L .3858 .55128 L p F P
0 0 0 r
s
.858 .238 .1 r
.40549 .55427 m .3858 .55128 L .3907 .53112 L p F P
0 0 0 r
s
.83 .24 .1 r
.38648 .54397 m
.38952 .51616 L
s
.38648 .54397 m
.42578 .54996 L
s
.267 .397 .787 r
.53595 .41318 m .53422 .41707 L .51747 .39976 L p F P
0 0 0 r
s
.267 .397 .787 r
.51662 .40176 m .51747 .39976 L .53422 .41707 L p F P
0 0 0 r
s
.193 .286 .592 r
.60329 .46985 m .59822 .4796 L .58572 .46027 L p F P
0 0 0 r
s
.193 .286 .592 r
.58572 .46027 m .59005 .45163 L .60329 .46985 L p F P
0 0 0 r
s
.215 .319 .651 r
.59005 .45163 m .58572 .46027 L .57127 .44186 L p F P
0 0 0 r
s
.24 .35 .67 r
.56867 .47804 m
.5804 .45435 L
s
.982 .284 .121 r
.44605 .41024 m .45217 .41129 L .43005 .42767 L p F P
0 0 0 r
s
.982 .284 .121 r
.43005 .42767 m .42107 .42616 L .44605 .41024 L p F P
0 0 0 r
s
.83 .24 .1 r
.70833 .39753 m
.69751 .41095 L
s
.6596 .40422 m
.69751 .41095 L
s
.888 .248 .105 r
.34489 .50211 m .36269 .50491 L .35276 .52527 L p F P
0 0 0 r
s
.888 .248 .105 r
.37178 .5282 m .35276 .52527 L .36269 .50491 L p F P
0 0 0 r
s
.774 .211 .088 r
.4632 .58241 m .48286 .58533 L .48292 .60299 L p F P
0 0 0 r
s
.774 .211 .088 r
.50242 .60584 m .48292 .60299 L .48286 .58533 L p F P
0 0 0 r
s
.098 .143 .332 r
.62168 .53942 m .61528 .5507 L .61033 .53055 L p F P
0 0 0 r
s
.24 .35 .67 r
.59992 .56666 m
.6123 .54463 L
s
.098 .143 .332 r
.61033 .53055 m .61641 .51957 L .62168 .53942 L p F P
0 0 0 r
s
.24 .35 .67 r
.60254 .52061 m
.6123 .54463 L
s
.215 .319 .651 r
.57127 .44186 m .57479 .43458 L .59005 .45163 L p F P
0 0 0 r
s
.234 .348 .702 r
.57479 .43458 m .57127 .44186 L .55516 .42475 L p F P
0 0 0 r
s
.24 .35 .67 r
.55725 .43707 m
.5804 .45435 L
s
.83 .24 .1 r
.56606 .43021 m
.57379 .40915 L
s
.992 .289 .123 r
.48803 .39893 m .49112 .39947 L .48261 .41651 L p F P
0 0 0 r
s
.992 .289 .123 r
.48261 .41651 m .47654 .41547 L .48803 .39893 L p F P
0 0 0 r
s
.821 .226 .095 r
.40549 .55427 m .42507 .55723 L .42355 .5765 L p F P
0 0 0 r
s
.821 .226 .095 r
.44343 .57946 m .42355 .5765 L .42507 .55723 L p F P
0 0 0 r
s
.83 .24 .1 r
.42427 .57579 m
.42578 .54996 L
s
.24 .35 .67 r
.32575 .54833 m
.32073 .57204 L
s
.32791 .68796 m
.33507 .66798 L
s
.32791 .68796 m
.34601 .70967 L
s
.83 .24 .1 r
.35423 .4811 m
.35914 .45218 L
s
.31448 .47474 m
.35423 .4811 L
s
.35379 .48416 m
.35423 .4811 L
s
.318 .472 .909 r
.42311 .42047 m .42107 .42616 L .44605 .41024 L p F P
0 0 0 r
s
.327 .485 .926 r
.42107 .42616 m .42311 .42047 L .40055 .4364 L p F P
0 0 0 r
s
.83 .24 .1 r
.40415 .43082 m
.40763 .4314 L
s
.40343 .43437 m
.40415 .43082 L
s
.992 .289 .123 r
.48494 .39839 m .48803 .39893 L .47654 .41547 L p F P
0 0 0 r
s
.992 .289 .123 r
.47654 .41547 m .47046 .41443 L .48494 .39839 L p F P
0 0 0 r
s
.24 .35 .67 r
.51607 .72687 m
.53888 .71456 L
s
.53888 .71456 m
.55026 .69509 L
s
.167 .247 .522 r
.61422 .48889 m .60852 .4995 L .59822 .4796 L p F P
0 0 0 r
s
.167 .247 .522 r
.59822 .4796 m .60329 .46985 L .61422 .48889 L p F P
0 0 0 r
s
.24 .35 .67 r
.58777 .49814 m
.59994 .47471 L
s
.5804 .45435 m
.59994 .47471 L
s
.712 .19 .079 r
.52182 .60869 m .54112 .61151 L .54004 .62678 L p F P
0 0 0 r
s
.712 .19 .079 r
.55874 .62948 m .54004 .62678 L .54112 .61151 L p F P
0 0 0 r
s
.83 .24 .1 r
.54086 .59316 m
.54218 .61602 L
s
.54218 .61602 m
.58071 .62165 L
s
.992 .289 .123 r
.48184 .39786 m .48494 .39839 L .47046 .41443 L p F P
0 0 0 r
s
.992 .289 .123 r
.47046 .41443 m .46438 .41338 L .48184 .39786 L p F P
0 0 0 r
s
.858 .238 .1 r
.35276 .52527 m .37178 .5282 L .36602 .54829 L p F P
0 0 0 r
s
.858 .238 .1 r
.3858 .55128 m .36602 .54829 L .37178 .5282 L p F P
0 0 0 r
s
.234 .348 .702 r
.55516 .42475 m .55781 .41904 L .57479 .43458 L p F P
0 0 0 r
s
.251 .373 .747 r
.55781 .41904 m .55516 .42475 L .53769 .40926 L p F P
0 0 0 r
s
.251 .373 .747 r
.53595 .41318 m .53769 .40926 L .55516 .42475 L p F P
0 0 0 r
s
.83 .24 .1 r
.36461 .42418 m
.35914 .45218 L
s
.31936 .44566 m
.35914 .45218 L
s
.888 .248 .105 r
.35276 .52527 m .33364 .52232 L .34489 .50211 L p F P
0 0 0 r
s
.83 .24 .1 r
.35006 .51 m
.35287 .49055 L
s
.35006 .51 m
.38952 .51616 L
s
.24 .35 .67 r
.33643 .52708 m
.33774 .52295 L
s
.288 .426 .769 r
.34489 .50211 m .34823 .49155 L .33713 .51118 L p F P
0 0 0 r
s
.288 .426 .769 r
.33713 .51118 m .33364 .52232 L .34489 .50211 L p F P
0 0 0 r
s
.24 .35 .67 r
.34368 .50418 m
.35443 .49199 L
s
.34202 .50941 m
.34368 .50418 L
s
.992 .289 .123 r
.47874 .39732 m .48184 .39786 L .46438 .41338 L p F P
0 0 0 r
s
.992 .289 .123 r
.46438 .41338 m .45828 .41234 L .47874 .39732 L p F P
0 0 0 r
s
.774 .211 .088 r
.44343 .57946 m .4632 .58241 L .46331 .60011 L p F P
0 0 0 r
s
.774 .211 .088 r
.48292 .60299 m .46331 .60011 L .4632 .58241 L p F P
0 0 0 r
s
.83 .24 .1 r
.46354 .58164 m
.5024 .58743 L
s
.267 .397 .787 r
.53769 .40926 m .53595 .41318 L .51832 .39775 L p F P
0 0 0 r
s
.83 .24 .1 r
.53235 .41057 m
.53249 .41015 L
s
.267 .397 .787 r
.51747 .39976 m .51832 .39775 L .53595 .41318 L p F P
0 0 0 r
s
.821 .226 .095 r
.3858 .55128 m .40549 .55427 L .40357 .57353 L p F P
0 0 0 r
s
.821 .226 .095 r
.42355 .5765 m .40357 .57353 L .40549 .55427 L p F P
0 0 0 r
s
.24 .35 .67 r
.31489 .61862 m
.32181 .5972 L
s
.31489 .61862 m
.322 .64378 L
s
.028 .04 .082 r
.60791 .61456 m .60182 .6248 L .60457 .60945 L p F P
0 0 0 r
s
.24 .35 .67 r
.60214 .61514 m
.60392 .59107 L
s
.59658 .62456 m
.60214 .61514 L
s
.028 .04 .082 r
.60457 .60945 m .61085 .59877 L .60791 .61456 L p F P
0 0 0 r
s
.83 .24 .1 r
.34112 .5086 m
.35006 .51 L
s
.31019 .50376 m
.33879 .50823 L
s
.992 .289 .123 r
.47564 .39678 m .47874 .39732 L .45828 .41234 L p F P
0 0 0 r
s
.992 .289 .123 r
.45828 .41234 m .45217 .41129 L .47564 .39678 L p F P
0 0 0 r
s
.83 .24 .1 r
.44976 .41163 m
.48877 .41832 L
s
.049 .072 .169 r
.61726 .58789 m .61085 .59877 L .61119 .58104 L p F P
0 0 0 r
s
.049 .072 .169 r
.61119 .58104 m .61762 .56995 L .61726 .58789 L p F P
0 0 0 r
s
.712 .19 .079 r
.50242 .60584 m .52182 .60869 L .52124 .62407 L p F P
0 0 0 r
s
.712 .19 .079 r
.54004 .62678 m .52124 .62407 L .52182 .60869 L p F P
0 0 0 r
s
.992 .289 .123 r
.47253 .39623 m .47564 .39678 L .45217 .41129 L p F P
0 0 0 r
s
.992 .289 .123 r
.45217 .41129 m .44605 .41024 L .47253 .39623 L p F P
0 0 0 r
s
.327 .485 .926 r
.40309 .42906 m .40055 .4364 L .42311 .42047 L p F P
0 0 0 r
s
.332 .492 .931 r
.40055 .4364 m .40309 .42906 L .3832 .44506 L p F P
0 0 0 r
s
.83 .24 .1 r
.36461 .42418 m
.40146 .43037 L
s
.332 .492 .931 r
.3832 .44506 m .38029 .45379 L .40055 .4364 L p F P
0 0 0 r
s
.24 .35 .67 r
.38788 .44816 m
.405 .4413 L
s
.38477 .45739 m
.38788 .44816 L
s
.136 .2 .437 r
.6226 .50838 m .61641 .51957 L .60852 .4995 L p F P
0 0 0 r
s
.136 .2 .437 r
.60852 .4995 m .61422 .48889 L .6226 .50838 L p F P
0 0 0 r
s
.858 .238 .1 r
.33364 .52232 m .35276 .52527 L .34612 .54527 L p F P
0 0 0 r
s
.858 .238 .1 r
.36602 .54829 m .34612 .54527 L .35276 .52527 L p F P
0 0 0 r
s
.83 .24 .1 r
.34676 .53791 m
.35006 .51 L
s
.34676 .53791 m
.38648 .54397 L
s
.62301 .64638 m
.66129 .65187 L
s
.66129 .65187 m
.66793 .66656 L
s
.024 .035 .067 r
.59661 .63758 m .59099 .64701 L .59585 .63484 L p F P
0 0 0 r
s
.024 .035 .067 r
.59585 .63484 m .60182 .6248 L .59661 .63758 L p F P
0 0 0 r
s
.624 .162 .067 r
.57734 .63217 m .59585 .63484 L .59099 .64701 L p F P
0 0 0 r
s
.24 .35 .67 r
.59165 .64251 m
.59444 .63782 L
s
.33 .49 .916 r
.38029 .45379 m .3832 .44506 L .36593 .46242 L p F P
0 0 0 r
s
.33 .49 .916 r
.36593 .46242 m .36273 .47229 L .38029 .45379 L p F P
0 0 0 r
s
.997 .292 .125 r
.51577 .40376 m .51269 .40323 L .5 .38446 L closepath p F P
0 0 0 r
s
.281 .418 .824 r
.5 .38446 m .51662 .40176 L .51577 .40376 L closepath p F P
0 0 0 r
s
.307 .456 .885 r
.44752 .4063 m .44605 .41024 L .47253 .39623 L p F P
0 0 0 r
s
.318 .472 .909 r
.44605 .41024 m .44752 .4063 L .42311 .42047 L p F P
0 0 0 r
s
.83 .24 .1 r
.44327 .43739 m
.44976 .41163 L
s
.66985 .39061 m
.6596 .40422 L
s
.62129 .39742 m
.6596 .40422 L
s
.774 .211 .088 r
.42355 .5765 m .44343 .57946 L .4436 .59723 L p F P
0 0 0 r
s
.774 .211 .088 r
.46331 .60011 m .4436 .59723 L .44343 .57946 L p F P
0 0 0 r
s
.24 .35 .67 r
.42282 .75122 m
.45162 .75484 L
s
.45162 .75484 m
.4613 .7361 L
s
.318 .472 .909 r
.42517 .41472 m .42311 .42047 L .44752 .4063 L p F P
0 0 0 r
s
.83 .24 .1 r
.44294 .41046 m
.44976 .41163 L
s
.24 .35 .67 r
.44569 .41339 m
.44733 .40902 L
s
.44733 .40902 m
.45767 .40907 L
s
.327 .485 .926 r
.42311 .42047 m .42517 .41472 L .40309 .42906 L p F P
0 0 0 r
s
.997 .292 .125 r
.51269 .40323 m .50962 .40269 L .5 .38446 L closepath p F P
0 0 0 r
s
.821 .226 .095 r
.36602 .54829 m .3858 .55128 L .38348 .57054 L p F P
0 0 0 r
s
.821 .226 .095 r
.40357 .57353 m .38348 .57054 L .3858 .55128 L p F P
0 0 0 r
s
.83 .24 .1 r
.38458 .56987 m
.38648 .54397 L
s
.78407 .41113 m
.79628 .40341 L
s
.7464 .40437 m
.78407 .41113 L
s
.251 .373 .747 r
.53769 .40926 m .53944 .40532 L .55781 .41904 L p F P
0 0 0 r
s
.267 .397 .787 r
.53944 .40532 m .53769 .40926 L .51918 .39573 L p F P
0 0 0 r
s
.83 .24 .1 r
.53364 .40685 m
.53379 .40641 L
s
.267 .397 .787 r
.51832 .39775 m .51918 .39573 L .53769 .40926 L p F P
0 0 0 r
s
.83 .24 .1 r
.53491 .40318 m
.53518 .4024 L
s
.53518 .4024 m
.57379 .40915 L
s
.215 .319 .651 r
.59445 .44287 m .59005 .45163 L .57479 .43458 L p F P
0 0 0 r
s
.215 .319 .651 r
.57479 .43458 m .57835 .42722 L .59445 .44287 L p F P
0 0 0 r
s
.234 .348 .702 r
.57835 .42722 m .57479 .43458 L .55781 .41904 L p F P
0 0 0 r
s
.997 .292 .125 r
.50962 .40269 m .50654 .40216 L .5 .38446 L closepath p F P
0 0 0 r
s
.067 .097 .237 r
.62418 .55863 m .61762 .56995 L .61528 .5507 L p F P
0 0 0 r
s
.067 .097 .237 r
.61528 .5507 m .62168 .53942 L .62418 .55863 L p F P
0 0 0 r
s
.24 .35 .67 r
.6123 .54463 m
.61651 .56929 L
s
.83 .24 .1 r
.31936 .44566 m
.31448 .47474 L
s
.27431 .4683 m
.31448 .47474 L
s
.31448 .47474 m
.31019 .50376 L
s
.24 .35 .67 r
.34601 .70967 m
.35358 .69 L
s
.34601 .70967 m
.36864 .72805 L
s
.997 .292 .125 r
.50654 .40216 m .50347 .40162 L .5 .38446 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.53214 .40187 m
.53518 .4024 L
s
.234 .348 .702 r
.55781 .41904 m .56048 .41329 L .57835 .42722 L p F P
0 0 0 r
s
.251 .373 .747 r
.56048 .41329 m .55781 .41904 L .53944 .40532 L p F P
0 0 0 r
s
.281 .418 .824 r
.5 .38446 m .51747 .39976 L .51662 .40176 L closepath p F P
0 0 0 r
s
.712 .19 .079 r
.48292 .60299 m .50242 .60584 L .50236 .62134 L p F P
0 0 0 r
s
.712 .19 .079 r
.52124 .62407 m .50236 .62134 L .50242 .60584 L p F P
0 0 0 r
s
.83 .24 .1 r
.5024 .58743 m
.50324 .61034 L
s
.50324 .61034 m
.54218 .61602 L
s
.997 .292 .125 r
.50347 .40162 m .50038 .40108 L .5 .38446 L closepath p F P
0 0 0 r
s
.193 .286 .592 r
.60845 .45994 m .60329 .46985 L .59005 .45163 L p F P
0 0 0 r
s
.193 .286 .592 r
.59005 .45163 m .59445 .44287 L .60845 .45994 L p F P
0 0 0 r
s
.858 .238 .1 r
.34612 .54527 m .32613 .54224 L .33364 .52232 L p F P
0 0 0 r
s
.24 .35 .67 r
.32575 .54833 m
.32758 .54246 L
s
.238 .35 .612 r
.33364 .52232 m .33713 .51118 L .3297 .53079 L p F P
0 0 0 r
s
.238 .35 .612 r
.3297 .53079 m .32613 .54224 L .33364 .52232 L p F P
0 0 0 r
s
.997 .292 .125 r
.50038 .40108 m .4973 .40055 L .5 .38446 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.37049 .39803 m
.36461 .42418 L
s
.32466 .41747 m
.36461 .42418 L
s
.318 .471 .867 r
.36273 .47229 m .36593 .46242 L .35164 .4808 L p F P
0 0 0 r
s
.318 .471 .867 r
.35164 .4808 m .34823 .49155 L .36273 .47229 L p F P
0 0 0 r
s
.83 .24 .1 r
.32466 .41747 m
.31936 .44566 L
s
.27916 .43906 m
.31936 .44566 L
s
.624 .162 .067 r
.55874 .62948 m .57734 .63217 L .57341 .6445 L p F P
0 0 0 r
s
.624 .162 .067 r
.59099 .64701 m .57341 .6445 L .57734 .63217 L p F P
0 0 0 r
s
.83 .24 .1 r
.58071 .62165 m
.58432 .64083 L
s
.24 .35 .67 r
.58223 .65834 m
.58913 .64674 L
s
.997 .292 .125 r
.4973 .40055 m .49421 .40001 L .5 .38446 L closepath p F P
0 0 0 r
s
.774 .211 .088 r
.40357 .57353 m .42355 .5765 L .42379 .59432 L p F P
0 0 0 r
s
.774 .211 .088 r
.4436 .59723 m .42379 .59432 L .42355 .5765 L p F P
0 0 0 r
s
.83 .24 .1 r
.42427 .57579 m
.46354 .58164 L
s
.997 .292 .125 r
.49421 .40001 m .49112 .39947 L .5 .38446 L closepath p F P
0 0 0 r
s
.281 .418 .824 r
.5 .38446 m .51832 .39775 L .51747 .39976 L closepath p F P
0 0 0 r
s
.307 .456 .885 r
.47253 .39623 m .47332 .39421 L .44752 .4063 L p F P
0 0 0 r
s
.307 .456 .885 r
.449 .40235 m .44752 .4063 L .47332 .39421 L p F P
0 0 0 r
s
.83 .24 .1 r
.44976 .41163 m
.45229 .40327 L
s
.318 .472 .909 r
.44752 .4063 m .449 .40235 L .42517 .41472 L p F P
0 0 0 r
s
.821 .226 .095 r
.34612 .54527 m .36602 .54829 L .36329 .56753 L p F P
0 0 0 r
s
.821 .226 .095 r
.38348 .57054 m .36329 .56753 L .36602 .54829 L p F P
0 0 0 r
s
.997 .292 .125 r
.49112 .39947 m .48803 .39893 L .5 .38446 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.2699 .49747 m
.31019 .50376 L
s
.31019 .50376 m
.30663 .53179 L
s
.997 .292 .125 r
.48803 .39893 m .48494 .39839 L .5 .38446 L closepath p F P
0 0 0 r
s
.251 .373 .747 r
.53944 .40532 m .5412 .40136 L .56048 .41329 L p F P
0 0 0 r
s
.267 .397 .787 r
.5412 .40136 m .53944 .40532 L .52004 .39371 L p F P
0 0 0 r
s
.267 .397 .787 r
.51918 .39573 m .52004 .39371 L .53944 .40532 L p F P
0 0 0 r
s
.997 .292 .125 r
.48494 .39839 m .48184 .39786 L .5 .38446 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.39468 .74214 m
.42282 .75122 L
s
.42282 .75122 m
.43196 .73233 L
s
.167 .247 .522 r
.62003 .47809 m .61422 .48889 L .60329 .46985 L p F P
0 0 0 r
s
.167 .247 .522 r
.60329 .46985 m .60845 .45994 L .62003 .47809 L p F P
0 0 0 r
s
.712 .19 .079 r
.46331 .60011 m .48292 .60299 L .48337 .6186 L p F P
0 0 0 r
s
.712 .19 .079 r
.50236 .62134 m .48337 .6186 L .48292 .60299 L p F P
0 0 0 r
s
.098 .143 .332 r
.62821 .52791 m .62168 .53942 L .61641 .51957 L p F P
0 0 0 r
s
.098 .143 .332 r
.61641 .51957 m .6226 .50838 L .62821 .52791 L p F P
0 0 0 r
s
.83 .24 .1 r
.32876 .53516 m
.34676 .53791 L
s
.997 .292 .125 r
.48184 .39786 m .47874 .39732 L .5 .38446 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.36864 .72805 m
.37669 .70869 L
s
.36864 .72805 m
.39468 .74214 L
s
.281 .418 .824 r
.5 .38446 m .51918 .39573 L .51832 .39775 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.58432 .64083 m
.59307 .64209 L
s
.59385 .6422 m
.62301 .64638 L
s
.62301 .64638 m
.62902 .66105 L
s
.318 .472 .909 r
.42724 .40893 m .42517 .41472 L .449 .40235 L p F P
0 0 0 r
s
.83 .24 .1 r
.41033 .40486 m
.4297 .40818 L
s
.327 .485 .926 r
.42517 .41472 m .42724 .40893 L .40565 .42162 L p F P
0 0 0 r
s
.83 .24 .1 r
.40484 .42792 m
.4064 .42136 L
s
.327 .485 .926 r
.40565 .42162 m .40309 .42906 L .42517 .41472 L p F P
0 0 0 r
s
.83 .24 .1 r
.40645 .42115 m
.41033 .40486 L
s
.24 .35 .67 r
.55026 .69509 m
.56887 .67842 L
s
.56887 .67842 m
.58095 .65806 L
s
.997 .292 .125 r
.47874 .39732 m .47564 .39678 L .5 .38446 L closepath p F P
0 0 0 r
s
.624 .162 .067 r
.54004 .62678 m .55874 .62948 L .55574 .64198 L p F P
0 0 0 r
s
.624 .162 .067 r
.57341 .6445 m .55574 .64198 L .55874 .62948 L p F P
0 0 0 r
s
.332 .492 .931 r
.40309 .42906 m .40565 .42162 L .38615 .43621 L p F P
0 0 0 r
s
.332 .492 .931 r
.38615 .43621 m .3832 .44506 L .40309 .42906 L p F P
0 0 0 r
s
.83 .24 .1 r
.63095 .38363 m
.62129 .39742 L
s
.58258 .39055 m
.62129 .39742 L
s
.997 .292 .125 r
.47564 .39678 m .47253 .39623 L .5 .38446 L closepath p F P
0 0 0 r
s
.774 .211 .088 r
.38348 .57054 m .40357 .57353 L .40387 .5914 L p F P
0 0 0 r
s
.774 .211 .088 r
.42379 .59432 m .40387 .5914 L .40357 .57353 L p F P
0 0 0 r
s
.24 .35 .67 r
.39468 .74214 m
.40327 .72305 L
s
.821 .226 .095 r
.32613 .54224 m .34612 .54527 L .34298 .56451 L p F P
0 0 0 r
s
.821 .226 .095 r
.36329 .56753 m .34298 .56451 L .34612 .54527 L p F P
0 0 0 r
s
.83 .24 .1 r
.34447 .56389 m
.34676 .53791 L
s
.295 .438 .856 r
.47332 .39421 m .47253 .39623 L .5 .38446 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.48877 .41832 m
.49616 .39558 L
s
.24 .35 .67 r
.4898 .73421 m
.51607 .72687 L
s
.51607 .72687 m
.5271 .70746 L
s
.83 .24 .1 r
.758 .39647 m
.7464 .40437 L
s
.70833 .39753 m
.7464 .40437 L
s
.70642 .672 m
.7445 .67739 L
s
.75422 .68689 m
.7445 .67739 L
s
.234 .348 .702 r
.58194 .41976 m .57835 .42722 L .56048 .41329 L p F P
0 0 0 r
s
.234 .348 .702 r
.56048 .41329 m .56317 .40748 L .58194 .41976 L p F P
0 0 0 r
s
.251 .373 .747 r
.56317 .40748 m .56048 .41329 L .5412 .40136 L p F P
0 0 0 r
s
.288 .426 .769 r
.34823 .49155 m .35164 .4808 L .34068 .49983 L p F P
0 0 0 r
s
.288 .426 .769 r
.34068 .49983 m .33713 .51118 L .34823 .49155 L p F P
0 0 0 r
s
.307 .456 .885 r
.47332 .39421 m .47411 .39218 L .449 .40235 L p F P
0 0 0 r
s
.307 .456 .885 r
.45049 .39836 m .449 .40235 L .47411 .39218 L p F P
0 0 0 r
s
.318 .472 .909 r
.449 .40235 m .45049 .39836 L .42724 .40893 L p F P
0 0 0 r
s
.281 .418 .824 r
.5 .38446 m .52004 .39371 L .51918 .39573 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.49616 .39558 m
.51957 .39967 L
s
.27916 .43906 m
.27431 .4683 L
s
.23371 .4618 m
.27431 .4683 L
s
.27431 .4683 m
.2699 .49747 L
s
.215 .319 .651 r
.59891 .43398 m .59445 .44287 L .57835 .42722 L p F P
0 0 0 r
s
.215 .319 .651 r
.57835 .42722 m .58194 .41976 L .59891 .43398 L p F P
0 0 0 r
s
.712 .19 .079 r
.4436 .59723 m .46331 .60011 L .46429 .61584 L p F P
0 0 0 r
s
.712 .19 .079 r
.48337 .6186 m .46429 .61584 L .46331 .60011 L p F P
0 0 0 r
s
.24 .35 .67 r
.32073 .57204 m
.32181 .5972 L
s
.251 .373 .747 r
.5412 .40136 m .54297 .39737 L .56317 .40748 L p F P
0 0 0 r
s
.267 .397 .787 r
.54297 .39737 m .5412 .40136 L .52091 .39168 L p F P
0 0 0 r
s
.83 .24 .1 r
.5364 .39962 m
.5366 .39916 L
s
.267 .397 .787 r
.52004 .39371 m .52091 .39168 L .5412 .40136 L p F P
0 0 0 r
s
.24 .35 .67 r
.5314 .42347 m
.54257 .39834 L
s
.33 .49 .916 r
.3832 .44506 m .38615 .43621 L .36917 .45239 L p F P
0 0 0 r
s
.33 .49 .916 r
.36917 .45239 m .36593 .46242 L .3832 .44506 L p F P
0 0 0 r
s
.24 .35 .67 r
.322 .64378 m
.32914 .62267 L
s
.322 .64378 m
.33507 .66798 L
s
.295 .438 .856 r
.47411 .39218 m .47332 .39421 L .5 .38446 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.33022 .39112 m
.32466 .41747 L
s
.28428 .41069 m
.32466 .41747 L
s
.624 .162 .067 r
.52124 .62407 m .54004 .62678 L .53799 .63945 L p F P
0 0 0 r
s
.624 .162 .067 r
.55574 .64198 m .53799 .63945 L .54004 .62678 L p F P
0 0 0 r
s
.83 .24 .1 r
.54218 .61602 m
.54522 .63523 L
s
.28428 .41069 m
.27916 .43906 L
s
.23853 .43239 m
.27916 .43906 L
s
.281 .418 .824 r
.5 .38446 m .52091 .39168 L .52004 .39371 L closepath p F P
0 0 0 r
s
.028 .04 .082 r
.61411 .60412 m .60791 .61456 L .61085 .59877 L p F P
0 0 0 r
s
.028 .04 .082 r
.61085 .59877 m .61726 .58789 L .61411 .60412 L p F P
0 0 0 r
s
.24 .35 .67 r
.60392 .59107 m
.61651 .56929 L
s
.774 .211 .088 r
.36329 .56753 m .38348 .57054 L .38385 .58847 L p F P
0 0 0 r
s
.774 .211 .088 r
.40387 .5914 m .38385 .58847 L .38348 .57054 L p F P
0 0 0 r
s
.83 .24 .1 r
.38458 .56987 m
.42427 .57579 L
s
.136 .2 .437 r
.62892 .49697 m .6226 .50838 L .61422 .48889 L p F P
0 0 0 r
s
.24 .35 .67 r
.60254 .52061 m
.6151 .49745 L
s
.136 .2 .437 r
.61422 .48889 m .62003 .47809 L .62892 .49697 L p F P
0 0 0 r
s
.24 .35 .67 r
.59994 .47471 m
.6151 .49745 L
s
.821 .226 .095 r
.34298 .56451 m .32256 .56147 L .32613 .54224 L p F P
0 0 0 r
s
.024 .035 .067 r
.32613 .54224 m .3297 .53079 L .32617 .54997 L p F P
0 0 0 r
s
.83 .24 .1 r
.30663 .53179 m
.32763 .53499 L
s
.32763 .53499 m
.32835 .5351 L
s
.024 .035 .067 r
.32617 .54997 m .32256 .56147 L .32613 .54224 L p F P
0 0 0 r
s
.193 .286 .592 r
.61368 .44987 m .60845 .45994 L .59445 .44287 L p F P
0 0 0 r
s
.193 .286 .592 r
.59445 .44287 m .59891 .43398 L .61368 .44987 L p F P
0 0 0 r
s
.049 .072 .169 r
.62379 .57679 m .61726 .58789 L .61762 .56995 L p F P
0 0 0 r
s
.049 .072 .169 r
.61762 .56995 m .62418 .55863 L .62379 .57679 L p F P
0 0 0 r
s
.83 .24 .1 r
.22917 .4911 m
.2699 .49747 L
s
.2699 .49747 m
.26606 .5256 L
s
.295 .438 .856 r
.4749 .39015 m .47411 .39218 L .5 .38446 L closepath p F P
0 0 0 r
s
.307 .456 .885 r
.47411 .39218 m .4749 .39015 L .45049 .39836 L p F P
0 0 0 r
s
.307 .456 .885 r
.45198 .39436 m .45049 .39836 L .4749 .39015 L p F P
0 0 0 r
s
.83 .24 .1 r
.46888 .39081 m
.47013 .39103 L
s
.47259 .39146 m
.49616 .39558 L
s
.318 .472 .909 r
.45049 .39836 m .45198 .39436 L .42934 .40308 L p F P
0 0 0 r
s
.318 .472 .909 r
.42934 .40308 m .42724 .40893 L .45049 .39836 L p F P
0 0 0 r
s
.267 .397 .787 r
.52091 .39168 m .52177 .38964 L .54297 .39737 L p F P
0 0 0 r
s
.281 .418 .824 r
.5 .38446 m .52177 .38964 L .52091 .39168 L closepath p F P
0 0 0 r
s
.024 .035 .067 r
.60233 .62799 m .59661 .63758 L .60182 .6248 L p F P
0 0 0 r
s
.024 .035 .067 r
.60182 .6248 m .60791 .61456 L .60233 .62799 L p F P
0 0 0 r
s
.24 .35 .67 r
.59444 .63782 m
.60214 .61514 L
s
.327 .485 .926 r
.42724 .40893 m .42934 .40308 L .40824 .4141 L p F P
0 0 0 r
s
.83 .24 .1 r
.37049 .39803 m
.41033 .40486 L
s
.327 .485 .926 r
.40824 .4141 m .40565 .42162 L .42724 .40893 L p F P
0 0 0 r
s
.24 .35 .67 r
.42059 .41375 m
.44733 .40902 L
s
.41354 .43367 m
.42059 .41375 L
s
.712 .19 .079 r
.42379 .59432 m .4436 .59723 L .4451 .61307 L p F P
0 0 0 r
s
.712 .19 .079 r
.46429 .61584 m .4451 .61307 L .4436 .59723 L p F P
0 0 0 r
s
.83 .24 .1 r
.46388 .6046 m
.50324 .61034 L
s
.46354 .58164 m
.46388 .6046 L
s
.26606 .5256 m
.30663 .53179 L
s
.30663 .53179 m
.30392 .55785 L
s
.251 .373 .747 r
.56589 .40162 m .56317 .40748 L .54297 .39737 L p F P
0 0 0 r
s
.251 .373 .747 r
.54297 .39737 m .54476 .39336 L .56589 .40162 L p F P
0 0 0 r
s
.267 .397 .787 r
.54476 .39336 m .54297 .39737 L .52177 .38964 L p F P
0 0 0 r
s
.624 .162 .067 r
.50236 .62134 m .52124 .62407 L .52016 .6369 L p F P
0 0 0 r
s
.624 .162 .067 r
.53799 .63945 m .52016 .6369 L .52124 .62407 L p F P
0 0 0 r
s
.83 .24 .1 r
.54522 .63523 m
.58432 .64083 L
s
.318 .471 .867 r
.36593 .46242 m .36917 .45239 L .35511 .46985 L p F P
0 0 0 r
s
.24 .35 .67 r
.36737 .46223 m
.38788 .44816 L
s
.318 .471 .867 r
.35511 .46985 m .35164 .4808 L .36593 .46242 L p F P
0 0 0 r
s
.24 .35 .67 r
.36057 .48315 m
.36737 .46223 L
s
.295 .438 .856 r
.4757 .38811 m .4749 .39015 L .5 .38446 L closepath p F P
0 0 0 r
s
.307 .456 .885 r
.4749 .39015 m .4757 .38811 L .45198 .39436 L p F P
0 0 0 r
s
.83 .24 .1 r
.45672 .38868 m
.46682 .39045 L
s
.45526 .39349 m
.45672 .38868 L
s
.234 .348 .702 r
.58559 .41222 m .58194 .41976 L .56317 .40748 L p F P
0 0 0 r
s
.234 .348 .702 r
.56317 .40748 m .56589 .40162 L .58559 .41222 L p F P
0 0 0 r
s
.83 .24 .1 r
.57502 .40653 m
.58258 .39055 L
s
.24 .35 .67 r
.55725 .43707 m
.56895 .41218 L
s
.54257 .39834 m
.56895 .41218 L
s
.83 .24 .1 r
.37658 .37468 m
.37049 .39803 L
s
.33022 .39112 m
.37049 .39803 L
s
.067 .097 .237 r
.63087 .54708 m .62418 .55863 L .62168 .53942 L p F P
0 0 0 r
s
.067 .097 .237 r
.62168 .53942 m .62821 .52791 L .63087 .54708 L p F P
0 0 0 r
s
.267 .397 .787 r
.52177 .38964 m .52264 .3876 L .54476 .39336 L p F P
0 0 0 r
s
.281 .418 .824 r
.5 .38446 m .52264 .3876 L .52177 .38964 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.51442 .38869 m
.54257 .39834 L
s
.508 .40399 m
.51442 .38869 L
s
.774 .211 .088 r
.34298 .56451 m .36329 .56753 L .36371 .58552 L p F P
0 0 0 r
s
.774 .211 .088 r
.38385 .58847 m .36371 .58552 L .36329 .56753 L p F P
0 0 0 r
s
.332 .492 .931 r
.40565 .42162 m .40824 .4141 L .38914 .42723 L p F P
0 0 0 r
s
.332 .492 .931 r
.38914 .42723 m .38615 .43621 L .40565 .42162 L p F P
0 0 0 r
s
.83 .24 .1 r
.71929 .38947 m
.70833 .39753 L
s
.66985 .39061 m
.70833 .39753 L
s
.66793 .66656 m
.70642 .672 L
s
.70642 .672 m
.71548 .68145 L
s
.238 .35 .612 r
.33713 .51118 m .34068 .49983 L .33334 .51911 L p F P
0 0 0 r
s
.238 .35 .612 r
.33334 .51911 m .3297 .53079 L .33713 .51118 L p F P
0 0 0 r
s
.24 .35 .67 r
.33287 .52558 m
.34368 .50418 L
s
.32963 .53593 m
.33287 .52558 L
s
.83 .24 .1 r
.23853 .43239 m
.23371 .4618 L
s
.19268 .45523 m
.23371 .4618 L
s
.23371 .4618 m
.22917 .4911 L
s
.295 .438 .856 r
.4765 .38606 m .4757 .38811 L .5 .38446 L closepath p F P
0 0 0 r
s
.307 .456 .885 r
.4757 .38811 m .4765 .38606 L .45348 .39033 L p F P
0 0 0 r
s
.307 .456 .885 r
.45348 .39033 m .45198 .39436 L .4757 .38811 L p F P
0 0 0 r
s
.712 .19 .079 r
.40387 .5914 m .42379 .59432 L .42582 .61028 L p F P
0 0 0 r
s
.712 .19 .079 r
.4451 .61307 m .42582 .61028 L .42379 .59432 L p F P
0 0 0 r
s
.167 .247 .522 r
.62594 .4671 m .62003 .47809 L .60845 .45994 L p F P
0 0 0 r
s
.167 .247 .522 r
.60845 .45994 m .61368 .44987 L .62594 .4671 L p F P
0 0 0 r
s
.24 .35 .67 r
.59994 .47471 m
.6126 .45035 L
s
.318 .472 .909 r
.45198 .39436 m .45348 .39033 L .43145 .39718 L p F P
0 0 0 r
s
.318 .472 .909 r
.43145 .39718 m .42934 .40308 L .45198 .39436 L p F P
0 0 0 r
s
.267 .397 .787 r
.54655 .38932 m .54476 .39336 L .52264 .3876 L p F P
0 0 0 r
s
.267 .397 .787 r
.52264 .3876 m .52351 .38555 L .54655 .38932 L p F P
0 0 0 r
s
.281 .418 .824 r
.5 .38446 m .52351 .38555 L .52264 .3876 L closepath p F P
0 0 0 r
s
.215 .319 .651 r
.60343 .42497 m .59891 .43398 L .58194 .41976 L p F P
0 0 0 r
s
.24 .35 .67 r
.5804 .45435 m
.59259 .42972 L
s
.215 .319 .651 r
.58194 .41976 m .58559 .41222 L .60343 .42497 L p F P
0 0 0 r
s
.24 .35 .67 r
.56895 .41218 m
.59259 .42972 L
s
.624 .162 .067 r
.48337 .6186 m .50236 .62134 L .50223 .63434 L p F P
0 0 0 r
s
.624 .162 .067 r
.52016 .6369 m .50223 .63434 L .50236 .62134 L p F P
0 0 0 r
s
.83 .24 .1 r
.50324 .61034 m
.5057 .62956 L
s
.28952 .38414 m
.28428 .41069 L
s
.24347 .40383 m
.28428 .41069 L
s
.24347 .40383 m
.23853 .43239 L
s
.19747 .42565 m
.23853 .43239 L
s
.495 .122 .05 r
.57341 .6445 m .59099 .64701 L .58384 .65604 L p F P
0 0 0 r
s
.252 .38 .679 r
.58896 .64744 m .58384 .65604 L .59099 .64701 L p F P
0 0 0 r
s
.83 .24 .1 r
.58792 .65064 m
.5897 .65549 L
s
.58432 .64083 m
.58759 .64974 L
s
.252 .38 .679 r
.59099 .64701 m .59661 .63758 L .58896 .64744 L p F P
0 0 0 r
s
.24 .35 .67 r
.5854 .65138 m
.59444 .63782 L
s
.251 .373 .747 r
.56863 .3957 m .56589 .40162 L .54476 .39336 L p F P
0 0 0 r
s
.251 .373 .747 r
.54476 .39336 m .54655 .38932 L .56863 .3957 L p F P
0 0 0 r
s
.993 .294 .126 r
.5 .38446 m .51221 .37241 L .50907 .37185 L closepath p F P
0 0 0 r
s
.993 .294 .126 r
.5 .38446 m .50907 .37185 L .50592 .37129 L closepath p F P
0 0 0 r
s
.993 .294 .126 r
.5 .38446 m .50592 .37129 L .50276 .37073 L closepath p F P
0 0 0 r
s
.993 .294 .126 r
.5 .38446 m .50276 .37073 L .49961 .37016 L closepath p F P
0 0 0 r
s
.993 .294 .126 r
.5 .38446 m .49961 .37016 L .49645 .3696 L closepath p F P
0 0 0 r
s
.993 .294 .126 r
.5 .38446 m .49645 .3696 L .49329 .36904 L closepath p F P
0 0 0 r
s
.993 .294 .126 r
.5 .38446 m .49329 .36904 L .49012 .36847 L closepath p F P
0 0 0 r
s
.993 .294 .126 r
.5 .38446 m .49012 .36847 L .48696 .36791 L closepath p F P
0 0 0 r
s
.993 .294 .126 r
.5 .38446 m .48696 .36791 L .48379 .36734 L closepath p F P
0 0 0 r
s
.993 .294 .126 r
.5 .38446 m .52791 .37521 L .52478 .37465 L closepath p F P
0 0 0 r
s
.993 .294 .126 r
.5 .38446 m .52478 .37465 L .52164 .37409 L closepath p F P
0 0 0 r
s
.993 .294 .126 r
.5 .38446 m .52164 .37409 L .5185 .37353 L closepath p F P
0 0 0 r
s
.993 .294 .126 r
.5 .38446 m .5185 .37353 L .51536 .37297 L closepath p F P
0 0 0 r
s
.993 .294 .126 r
.5 .38446 m .51536 .37297 L .51221 .37241 L closepath p F P
0 0 0 r
s
.281 .418 .824 r
.5 .38446 m .52791 .37521 L .52703 .37729 L closepath p F P
0 0 0 r
s
.281 .418 .824 r
.5 .38446 m .52703 .37729 L .52615 .37937 L closepath p F P
0 0 0 r
s
.281 .418 .824 r
.5 .38446 m .52615 .37937 L .52527 .38144 L closepath p F P
0 0 0 r
s
.281 .418 .824 r
.5 .38446 m .52527 .38144 L .52439 .3835 L closepath p F P
0 0 0 r
s
.281 .418 .824 r
.5 .38446 m .52439 .3835 L .52351 .38555 L closepath p F P
0 0 0 r
s
.295 .438 .856 r
.4773 .38401 m .4765 .38606 L .5 .38446 L closepath p F P
0 0 0 r
s
.295 .438 .856 r
.4781 .38195 m .4773 .38401 L .5 .38446 L closepath p F P
0 0 0 r
s
.295 .438 .856 r
.4789 .37988 m .4781 .38195 L .5 .38446 L closepath p F P
0 0 0 r
s
.295 .438 .856 r
.47971 .37781 m .4789 .37988 L .5 .38446 L closepath p F P
0 0 0 r
s
.295 .438 .856 r
.48052 .37573 m .47971 .37781 L .5 .38446 L closepath p F P
0 0 0 r
s
.295 .438 .856 r
.48133 .37364 m .48052 .37573 L .5 .38446 L closepath p F P
0 0 0 r
s
.295 .438 .856 r
.48215 .37155 m .48133 .37364 L .5 .38446 L closepath p F P
0 0 0 r
s
.295 .438 .856 r
.48297 .36945 m .48215 .37155 L .5 .38446 L closepath p F P
0 0 0 r
s
.295 .438 .856 r
.48379 .36734 m .48297 .36945 L .5 .38446 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.49616 .39558 m
.5039 .37658 L
s
.24 .35 .67 r
.48552 .3836 m
.51442 .38869 L
s
.47942 .39902 m
.48552 .3836 L
s
.774 .211 .088 r
.32256 .56147 m .34298 .56451 L .34347 .58255 L p F P
0 0 0 r
s
.24 .35 .67 r
.32073 .57204 m
.3237 .56261 L
s
.774 .211 .088 r
.36371 .58552 m .34347 .58255 L .34298 .56451 L p F P
0 0 0 r
s
.83 .24 .1 r
.34447 .56389 m
.38458 .56987 L
s
.307 .456 .885 r
.4765 .38606 m .4773 .38401 L .455 .38627 L p F P
0 0 0 r
s
.307 .456 .885 r
.455 .38627 m .45348 .39033 L .4765 .38606 L p F P
0 0 0 r
s
.098 .143 .332 r
.63487 .51617 m .62821 .52791 L .6226 .50838 L p F P
0 0 0 r
s
.24 .35 .67 r
.6123 .54463 m
.62517 .52173 L
s
.098 .143 .332 r
.6226 .50838 m .62892 .49697 L .63487 .51617 L p F P
0 0 0 r
s
.24 .35 .67 r
.6151 .49745 m
.62517 .52173 L
s
.4613 .7361 m
.4898 .73421 L
s
.4898 .73421 m
.50039 .71479 L
s
.327 .485 .926 r
.42934 .40308 m .43145 .39718 L .41086 .4065 L p F P
0 0 0 r
s
.327 .485 .926 r
.41086 .4065 m .40824 .4141 L .42934 .40308 L p F P
0 0 0 r
s
.83 .24 .1 r
.41033 .40486 m
.41686 .38172 L
s
.267 .397 .787 r
.54836 .38526 m .54655 .38932 L .52351 .38555 L p F P
0 0 0 r
s
.267 .397 .787 r
.52351 .38555 m .52439 .3835 L .54836 .38526 L p F P
0 0 0 r
s
.33 .49 .916 r
.38615 .43621 m .38914 .42723 L .37248 .44219 L p F P
0 0 0 r
s
.33 .49 .916 r
.37248 .44219 m .36917 .45239 L .38615 .43621 L p F P
0 0 0 r
s
.83 .24 .1 r
.18801 .48467 m
.22917 .4911 L
s
.22917 .4911 m
.22506 .51935 L
s
.712 .19 .079 r
.38385 .58847 m .40387 .5914 L .40644 .60749 L p F P
0 0 0 r
s
.712 .19 .079 r
.42582 .61028 m .40644 .60749 L .40387 .5914 L p F P
0 0 0 r
s
.83 .24 .1 r
.42411 .59879 m
.46388 .6046 L
s
.42411 .59879 m
.42427 .57579 L
s
.288 .426 .769 r
.35164 .4808 m .35511 .46985 L .3443 .48825 L p F P
0 0 0 r
s
.288 .426 .769 r
.3443 .48825 m .34068 .49983 L .35164 .4808 L p F P
0 0 0 r
s
.83 .24 .1 r
.22506 .51935 m
.26606 .5256 L
s
.26606 .5256 m
.26294 .55175 L
s
.234 .348 .702 r
.58927 .40459 m .58559 .41222 L .56589 .40162 L p F P
0 0 0 r
s
.234 .348 .702 r
.56589 .40162 m .56863 .3957 L .58927 .40459 L p F P
0 0 0 r
s
.24 .35 .67 r
.33507 .66798 m
.34253 .64719 L
s
.33507 .66798 m
.35358 .69 L
s
.624 .162 .067 r
.46429 .61584 m .48337 .6186 L .48423 .63177 L p F P
0 0 0 r
s
.624 .162 .067 r
.50223 .63434 m .48423 .63177 L .48337 .6186 L p F P
0 0 0 r
s
.307 .456 .885 r
.4773 .38401 m .4781 .38195 L .45652 .38219 L p F P
0 0 0 r
s
.307 .456 .885 r
.45652 .38219 m .455 .38627 L .4773 .38401 L p F P
0 0 0 r
s
.318 .472 .909 r
.45348 .39033 m .455 .38627 L .43358 .39122 L p F P
0 0 0 r
s
.83 .24 .1 r
.41686 .38172 m
.44979 .38747 L
s
.318 .472 .909 r
.43358 .39122 m .43145 .39718 L .45348 .39033 L p F P
0 0 0 r
s
.83 .24 .1 r
.5057 .62956 m
.54522 .63523 L
s
.495 .122 .05 r
.55574 .64198 m .57341 .6445 L .56763 .65375 L p F P
0 0 0 r
s
.495 .122 .05 r
.58384 .65604 m .56763 .65375 L .57341 .6445 L p F P
0 0 0 r
s
.24 .35 .67 r
.58095 .65806 m
.58243 .65584 L
s
.267 .397 .787 r
.55017 .38117 m .54836 .38526 L .52439 .3835 L p F P
0 0 0 r
s
.83 .24 .1 r
.54868 .38453 m
.58258 .39055 L
s
.267 .397 .787 r
.52439 .3835 m .52527 .38144 L .55017 .38117 L p F P
0 0 0 r
s
.193 .286 .592 r
.61901 .43963 m .61368 .44987 L .59891 .43398 L p F P
0 0 0 r
s
.193 .286 .592 r
.59891 .43398 m .60343 .42497 L .61901 .43963 L p F P
0 0 0 r
s
.24 .35 .67 r
.59259 .42972 m
.6126 .45035 L
s
.5271 .70746 m
.55026 .69509 L
s
.55026 .69509 m
.5621 .67484 L
s
.45694 .38331 m
.48552 .3836 L
s
.83 .24 .1 r
.33585 .36756 m
.33022 .39112 L
s
.28952 .38414 m
.33022 .39112 L
s
.251 .373 .747 r
.5714 .38973 m .56863 .3957 L .54655 .38932 L p F P
0 0 0 r
s
.251 .373 .747 r
.54655 .38932 m .54836 .38526 L .5714 .38973 L p F P
0 0 0 r
s
.774 .211 .088 r
.34347 .58255 m .32312 .57957 L .32256 .56147 L p F P
0 0 0 r
s
.045 .065 .149 r
.32256 .56147 m .32617 .54997 L .32672 .5683 L p F P
0 0 0 r
s
.83 .24 .1 r
.30392 .55785 m
.32281 .56067 L
s
.045 .065 .149 r
.32672 .5683 m .32312 .57957 L .32256 .56147 L p F P
0 0 0 r
s
.83 .24 .1 r
.32651 .56122 m
.34447 .56389 L
s
.68017 .38238 m
.66985 .39061 L
s
.63095 .38363 m
.66985 .39061 L
s
.62902 .66105 m
.66793 .66656 L
s
.66793 .66656 m
.67633 .67596 L
s
.307 .456 .885 r
.4781 .38195 m .4789 .37988 L .45806 .37808 L p F P
0 0 0 r
s
.307 .456 .885 r
.45806 .37808 m .45652 .38219 L .4781 .38195 L p F P
0 0 0 r
s
.332 .492 .931 r
.40824 .4141 m .41086 .4065 L .39218 .41812 L p F P
0 0 0 r
s
.332 .492 .931 r
.39218 .41812 m .38914 .42723 L .40824 .4141 L p F P
0 0 0 r
s
.24 .35 .67 r
.39629 .42328 m
.42059 .41375 L
s
.38788 .44816 m
.39629 .42328 L
s
.83 .24 .1 r
.19747 .42565 m
.19268 .45523 L
s
.19268 .45523 m
.18801 .48467 L
s
.267 .397 .787 r
.552 .37705 m .55017 .38117 L .52527 .38144 L p F P
0 0 0 r
s
.267 .397 .787 r
.52527 .38144 m .52615 .37937 L .552 .37705 L p F P
0 0 0 r
s
.136 .2 .437 r
.63535 .48534 m .62892 .49697 L .62003 .47809 L p F P
0 0 0 r
s
.136 .2 .437 r
.62003 .47809 m .62594 .4671 L .63535 .48534 L p F P
0 0 0 r
s
.83 .24 .1 r
.37658 .37468 m
.41686 .38172 L
s
.712 .19 .079 r
.36371 .58552 m .38385 .58847 L .38696 .60467 L p F P
0 0 0 r
s
.712 .19 .079 r
.40644 .60749 m .38696 .60467 L .38385 .58847 L p F P
0 0 0 r
s
.624 .162 .067 r
.4451 .61307 m .46429 .61584 L .46613 .62919 L p F P
0 0 0 r
s
.624 .162 .067 r
.48423 .63177 m .46613 .62919 L .46429 .61584 L p F P
0 0 0 r
s
.495 .122 .05 r
.53799 .63945 m .55574 .64198 L .55134 .65145 L p F P
0 0 0 r
s
.495 .122 .05 r
.56763 .65375 m .55134 .65145 L .55574 .64198 L p F P
0 0 0 r
s
.028 .04 .082 r
.62043 .59347 m .61411 .60412 L .61726 .58789 L p F P
0 0 0 r
s
.24 .35 .67 r
.61484 .59358 m
.61651 .56929 L
s
.028 .04 .082 r
.61726 .58789 m .62379 .57679 L .62043 .59347 L p F P
0 0 0 r
s
.83 .24 .1 r
.24838 .37708 m
.24347 .40383 L
s
.20222 .39691 m
.24347 .40383 L
s
.024 .035 .067 r
.3297 .53079 m .33334 .51911 L .32985 .53825 L p F P
0 0 0 r
s
.024 .035 .067 r
.32985 .53825 m .32617 .54997 L .3297 .53079 L p F P
0 0 0 r
s
.83 .24 .1 r
.20222 .39691 m
.19747 .42565 L
s
.307 .456 .885 r
.4789 .37988 m .47971 .37781 L .4596 .37394 L p F P
0 0 0 r
s
.307 .456 .885 r
.4596 .37394 m .45806 .37808 L .4789 .37988 L p F P
0 0 0 r
s
.318 .471 .867 r
.36917 .45239 m .37248 .44219 L .35864 .45871 L p F P
0 0 0 r
s
.318 .471 .867 r
.35864 .45871 m .35511 .46985 L .36917 .45239 L p F P
0 0 0 r
s
.24 .35 .67 r
.35122 .48035 m
.36737 .46223 L
s
.215 .319 .651 r
.60802 .41583 m .60343 .42497 L .58559 .41222 L p F P
0 0 0 r
s
.215 .319 .651 r
.58559 .41222 m .58927 .40459 L .60802 .41583 L p F P
0 0 0 r
s
.83 .24 .1 r
.79628 .40341 m
.80828 .40163 L
s
.758 .39647 m
.79628 .40341 L
s
.327 .485 .926 r
.43145 .39718 m .43358 .39122 L .41352 .3988 L p F P
0 0 0 r
s
.327 .485 .926 r
.41352 .3988 m .41086 .4065 L .43145 .39718 L p F P
0 0 0 r
s
.318 .472 .909 r
.455 .38627 m .45652 .38219 L .43574 .38521 L p F P
0 0 0 r
s
.318 .472 .909 r
.43574 .38521 m .43358 .39122 L .455 .38627 L p F P
0 0 0 r
s
.267 .397 .787 r
.55384 .37291 m .552 .37705 L .52615 .37937 L p F P
0 0 0 r
s
.267 .397 .787 r
.52615 .37937 m .52703 .37729 L .55384 .37291 L p F P
0 0 0 r
s
.049 .072 .169 r
.63045 .56546 m .62379 .57679 L .62418 .55863 L p F P
0 0 0 r
s
.049 .072 .169 r
.62418 .55863 m .63087 .54708 L .63045 .56546 L p F P
0 0 0 r
s
.024 .035 .067 r
.60816 .61822 m .60233 .62799 L .60791 .61456 L p F P
0 0 0 r
s
.024 .035 .067 r
.60791 .61456 m .61411 .60412 L .60816 .61822 L p F P
0 0 0 r
s
.24 .35 .67 r
.60214 .61514 m
.61484 .59358 L
s
.251 .373 .747 r
.57419 .3837 m .5714 .38973 L .54836 .38526 L p F P
0 0 0 r
s
.251 .373 .747 r
.54836 .38526 m .55017 .38117 L .57419 .3837 L p F P
0 0 0 r
s
.83 .24 .1 r
.26294 .55175 m
.30392 .55785 L
s
.30392 .55785 m
.3022 .581 L
s
.18801 .48467 m
.18361 .51303 L
s
.234 .348 .702 r
.593 .39687 m .58927 .40459 L .56863 .3957 L p F P
0 0 0 r
s
.234 .348 .702 r
.56863 .3957 m .5714 .38973 L .593 .39687 L p F P
0 0 0 r
s
.307 .456 .885 r
.47971 .37781 m .48052 .37573 L .46115 .36978 L p F P
0 0 0 r
s
.307 .456 .885 r
.46115 .36978 m .4596 .37394 L .47971 .37781 L p F P
0 0 0 r
s
.24 .35 .67 r
.43196 .73233 m
.4613 .7361 L
s
.4613 .7361 m
.47138 .71659 L
s
.712 .19 .079 r
.34347 .58255 m .36371 .58552 L .36738 .60184 L p F P
0 0 0 r
s
.712 .19 .079 r
.38696 .60467 m .36738 .60184 L .36371 .58552 L p F P
0 0 0 r
s
.83 .24 .1 r
.38391 .59293 m
.42411 .59879 L
s
.38391 .59293 m
.38458 .56987 L
s
.495 .122 .05 r
.52016 .6369 m .53799 .63945 L .53499 .64914 L p F P
0 0 0 r
s
.495 .122 .05 r
.55134 .65145 m .53499 .64914 L .53799 .63945 L p F P
0 0 0 r
s
.267 .397 .787 r
.55569 .36874 m .55384 .37291 L .52703 .37729 L p F P
0 0 0 r
s
.267 .397 .787 r
.52703 .37729 m .52791 .37521 L .55569 .36874 L p F P
0 0 0 r
s
.83 .24 .1 r
.5039 .37658 m
.52764 .38079 L
s
.624 .162 .067 r
.42582 .61028 m .4451 .61307 L .44794 .6266 L p F P
0 0 0 r
s
.624 .162 .067 r
.46613 .62919 m .44794 .6266 L .4451 .61307 L p F P
0 0 0 r
s
.83 .24 .1 r
.46388 .6046 m
.46575 .62383 L
s
.18361 .51303 m
.22506 .51935 L
s
.22506 .51935 m
.22152 .54557 L
s
.167 .247 .522 r
.63195 .45591 m .62594 .4671 L .61368 .44987 L p F P
0 0 0 r
s
.167 .247 .522 r
.61368 .44987 m .61901 .43963 L .63195 .45591 L p F P
0 0 0 r
s
.067 .097 .237 r
.6377 .53529 m .63087 .54708 L .62821 .52791 L p F P
0 0 0 r
s
.067 .097 .237 r
.62821 .52791 m .63487 .51617 L .6377 .53529 L p F P
0 0 0 r
s
.24 .35 .67 r
.62517 .52173 m
.62961 .54663 L
s
.83 .24 .1 r
.46575 .62383 m
.5057 .62956 L
s
.24 .35 .67 r
.35358 .69 m
.36146 .66954 L
s
.35358 .69 m
.37669 .70869 L
s
.238 .35 .612 r
.34068 .49983 m .3443 .48825 L .33705 .50719 L p F P
0 0 0 r
s
.24 .35 .67 r
.34368 .50418 m
.35122 .48035 L
s
.238 .35 .612 r
.33705 .50719 m .33334 .51911 L .34068 .49983 L p F P
0 0 0 r
s
.33 .49 .916 r
.38914 .42723 m .39218 .41812 L .37583 .43183 L p F P
0 0 0 r
s
.33 .49 .916 r
.37583 .43183 m .37248 .44219 L .38914 .42723 L p F P
0 0 0 r
s
.83 .24 .1 r
.29469 .36037 m
.28952 .38414 L
s
.24838 .37708 m
.28952 .38414 L
s
.307 .456 .885 r
.48052 .37573 m .48133 .37364 L .46271 .3656 L p F P
0 0 0 r
s
.307 .456 .885 r
.46271 .3656 m .46115 .36978 L .48052 .37573 L p F P
0 0 0 r
s
.318 .472 .909 r
.45652 .38219 m .45806 .37808 L .43791 .37914 L p F P
0 0 0 r
s
.318 .472 .909 r
.43791 .37914 m .43574 .38521 L .45652 .38219 L p F P
0 0 0 r
s
.24 .35 .67 r
.44733 .40902 m
.45694 .38331 L
s
.83 .24 .1 r
.64062 .37522 m
.63095 .38363 L
s
.59164 .37656 m
.63095 .38363 L
s
.971 .291 .125 r
.52478 .37465 m .52791 .37521 L .55569 .36874 L p F P
0 0 0 r
s
.83 .24 .1 r
.5897 .65549 m
.62902 .66105 L
s
.62902 .66105 m
.63675 .6704 L
s
.252 .38 .679 r
.59416 .6387 m .58896 .64744 L .59661 .63758 L p F P
0 0 0 r
s
.252 .38 .679 r
.59661 .63758 m .60233 .62799 L .59416 .6387 L p F P
0 0 0 r
s
.971 .291 .125 r
.55569 .36874 m .54946 .36762 L .52478 .37465 L p F P
0 0 0 r
s
.971 .291 .125 r
.52164 .37409 m .52478 .37465 L .54946 .36762 L p F P
0 0 0 r
s
.251 .373 .747 r
.57701 .37762 m .57419 .3837 L .55017 .38117 L p F P
0 0 0 r
s
.251 .373 .747 r
.55017 .38117 m .552 .37705 L .57701 .37762 L p F P
0 0 0 r
s
.495 .122 .05 r
.50223 .63434 m .52016 .6369 L .51856 .64682 L p F P
0 0 0 r
s
.495 .122 .05 r
.53499 .64914 m .51856 .64682 L .52016 .6369 L p F P
0 0 0 r
s
.83 .24 .1 r
.38266 .35506 m
.37658 .37468 L
s
.33585 .36756 m
.37658 .37468 L
s
.971 .291 .125 r
.54946 .36762 m .54322 .3665 L .52164 .37409 L p F P
0 0 0 r
s
.83 .24 .1 r
.54877 .37468 m
.5519 .36942 L
s
.971 .291 .125 r
.5185 .37353 m .52164 .37409 L .54322 .3665 L p F P
0 0 0 r
s
.712 .19 .079 r
.32312 .57957 m .34347 .58255 L .34769 .599 L p F P
0 0 0 r
s
.712 .19 .079 r
.36738 .60184 m .34769 .599 L .34347 .58255 L p F P
0 0 0 r
s
.332 .492 .931 r
.41086 .4065 m .41352 .3988 L .39526 .40888 L p F P
0 0 0 r
s
.332 .492 .931 r
.39526 .40888 m .39218 .41812 L .41086 .4065 L p F P
0 0 0 r
s
.624 .162 .067 r
.40644 .60749 m .42582 .61028 L .42967 .62399 L p F P
0 0 0 r
s
.624 .162 .067 r
.44794 .6266 m .42967 .62399 L .42582 .61028 L p F P
0 0 0 r
s
.193 .286 .592 r
.62442 .42922 m .61901 .43963 L .60343 .42497 L p F P
0 0 0 r
s
.193 .286 .592 r
.60343 .42497 m .60802 .41583 L .62442 .42922 L p F P
0 0 0 r
s
.307 .456 .885 r
.48133 .37364 m .48215 .37155 L .46428 .36138 L p F P
0 0 0 r
s
.307 .456 .885 r
.46428 .36138 m .46271 .3656 L .48133 .37364 L p F P
0 0 0 r
s
.83 .24 .1 r
.48001 .37234 m
.5039 .37658 L
s
.327 .485 .926 r
.43358 .39122 m .43574 .38521 L .4162 .391 L p F P
0 0 0 r
s
.327 .485 .926 r
.4162 .391 m .41352 .3988 L .43358 .39122 L p F P
0 0 0 r
s
.971 .291 .125 r
.54322 .3665 m .53696 .36538 L .5185 .37353 L p F P
0 0 0 r
s
.971 .291 .125 r
.51536 .37297 m .5185 .37353 L .53696 .36538 L p F P
0 0 0 r
s
.24 .35 .67 r
.51442 .38869 m
.52099 .37301 L
s
.098 .143 .332 r
.64167 .50419 m .63487 .51617 L .62892 .49697 L p F P
0 0 0 r
s
.098 .143 .332 r
.62892 .49697 m .63535 .48534 L .64167 .50419 L p F P
0 0 0 r
s
.83 .24 .1 r
.20679 .36995 m
.20222 .39691 L
s
.971 .291 .125 r
.53696 .36538 m .5307 .36425 L .51536 .37297 L p F P
0 0 0 r
s
.971 .291 .125 r
.51221 .37241 m .51536 .37297 L .5307 .36425 L p F P
0 0 0 r
s
.83 .24 .1 r
.76933 .39455 m
.758 .39647 L
s
.71929 .38947 m
.758 .39647 L
s
.288 .426 .769 r
.35511 .46985 m .35864 .45871 L .34799 .47645 L p F P
0 0 0 r
s
.288 .426 .769 r
.34799 .47645 m .3443 .48825 L .35511 .46985 L p F P
0 0 0 r
s
.971 .291 .125 r
.5307 .36425 m .52442 .36312 L .51221 .37241 L p F P
0 0 0 r
s
.24 .35 .67 r
.52509 .36324 m
.52549 .3623 L
s
.971 .291 .125 r
.50907 .37185 m .51221 .37241 L .52442 .36312 L p F P
0 0 0 r
s
.24 .35 .67 r
.40327 .72305 m
.43196 .73233 L
s
.43196 .73233 m
.44147 .71267 L
s
.83 .24 .1 r
.71548 .68145 m
.75422 .68689 L
s
.76548 .69047 m
.75422 .68689 L
s
.234 .348 .702 r
.59677 .38905 m .593 .39687 L .5714 .38973 L p F P
0 0 0 r
s
.234 .348 .702 r
.5714 .38973 m .57419 .3837 L .59677 .38905 L p F P
0 0 0 r
s
.83 .24 .1 r
.58531 .38634 m
.59164 .37656 L
s
.215 .319 .651 r
.61267 .40656 m .60802 .41583 L .58927 .40459 L p F P
0 0 0 r
s
.215 .319 .651 r
.58927 .40459 m .593 .39687 L .61267 .40656 L p F P
0 0 0 r
s
.971 .291 .125 r
.52442 .36312 m .51814 .36199 L .50907 .37185 L p F P
0 0 0 r
s
.971 .291 .125 r
.50592 .37129 m .50907 .37185 L .51814 .36199 L p F P
0 0 0 r
s
.24 .35 .67 r
.37669 .70869 m
.38507 .68853 L
s
.37669 .70869 m
.40327 .72305 L
s
.307 .456 .885 r
.48215 .37155 m .48297 .36945 L .46587 .35714 L p F P
0 0 0 r
s
.307 .456 .885 r
.46587 .35714 m .46428 .36138 L .48215 .37155 L p F P
0 0 0 r
s
.318 .472 .909 r
.45806 .37808 m .4596 .37394 L .4401 .37302 L p F P
0 0 0 r
s
.318 .472 .909 r
.4401 .37302 m .43791 .37914 L .45806 .37808 L p F P
0 0 0 r
s
.24 .35 .67 r
.58095 .65806 m
.58228 .65582 L
s
.83 .24 .1 r
.22152 .54557 m
.26294 .55175 L
s
.26294 .55175 m
.26067 .57494 L
s
.971 .291 .125 r
.51814 .36199 m .51184 .36086 L .50592 .37129 L p F P
0 0 0 r
s
.971 .291 .125 r
.50276 .37073 m .50592 .37129 L .51184 .36086 L p F P
0 0 0 r
s
.495 .122 .05 r
.48423 .63177 m .50223 .63434 L .50206 .64449 L p F P
0 0 0 r
s
.495 .122 .05 r
.51856 .64682 m .50206 .64449 L .50223 .63434 L p F P
0 0 0 r
s
.83 .24 .1 r
.5057 .62956 m
.50976 .64418 L
s
.971 .291 .125 r
.51184 .36086 m .50553 .35972 L .50276 .37073 L p F P
0 0 0 r
s
.971 .291 .125 r
.49961 .37016 m .50276 .37073 L .50553 .35972 L p F P
0 0 0 r
s
.624 .162 .067 r
.38696 .60467 m .40644 .60749 L .4113 .62137 L p F P
0 0 0 r
s
.624 .162 .067 r
.42967 .62399 m .4113 .62137 L .40644 .60749 L p F P
0 0 0 r
s
.83 .24 .1 r
.42411 .59879 m
.42537 .61804 L
s
.712 .19 .079 r
.34769 .599 m .3279 .59614 L .32312 .57957 L p F P
0 0 0 r
s
.83 .24 .1 r
.34327 .587 m
.38391 .59293 L
s
.34327 .587 m
.34447 .56389 L
s
.24 .35 .67 r
.32181 .5972 m
.32914 .62267 L
s
.065 .095 .231 r
.32312 .57957 m .32672 .5683 L .33145 .58534 L p F P
0 0 0 r
s
.065 .095 .231 r
.33145 .58534 m .3279 .59614 L .32312 .57957 L p F P
0 0 0 r
s
.24 .35 .67 r
.32181 .5972 m
.32519 .58675 L
s
.40327 .72305 m
.4122 .70317 L
s
.251 .373 .747 r
.57985 .37149 m .57701 .37762 L .552 .37705 L p F P
0 0 0 r
s
.251 .373 .747 r
.552 .37705 m .55384 .37291 L .57985 .37149 L p F P
0 0 0 r
s
.971 .291 .125 r
.50553 .35972 m .49921 .35859 L .49961 .37016 L p F P
0 0 0 r
s
.83 .24 .1 r
.5039 .37658 m
.51172 .36221 L
s
.971 .291 .125 r
.49645 .3696 m .49961 .37016 L .49921 .35859 L p F P
0 0 0 r
s
.24 .35 .67 r
.50039 .71479 m
.5271 .70746 L
s
.5271 .70746 m
.53858 .68725 L
s
.83 .24 .1 r
.18361 .51303 m
.17964 .53933 L
s
.971 .291 .125 r
.49921 .35859 m .49288 .35745 L .49645 .3696 L p F P
0 0 0 r
s
.971 .291 .125 r
.49329 .36904 m .49645 .3696 L .49288 .35745 L p F P
0 0 0 r
s
.24 .35 .67 r
.49567 .35795 m
.49605 .35701 L
s
.83 .24 .1 r
.42537 .61804 m
.46575 .62383 L
s
.136 .2 .437 r
.64192 .47348 m .63535 .48534 L .62594 .4671 L p F P
0 0 0 r
s
.136 .2 .437 r
.62594 .4671 m .63195 .45591 L .64192 .47348 L p F P
0 0 0 r
s
.24 .35 .67 r
.6151 .49745 m
.62816 .47335 L
s
.307 .456 .885 r
.48297 .36945 m .48379 .36734 L .46746 .35288 L p F P
0 0 0 r
s
.307 .456 .885 r
.46746 .35288 m .46587 .35714 L .48297 .36945 L p F P
0 0 0 r
s
.045 .065 .149 r
.32617 .54997 m .32985 .53825 L .3304 .5568 L p F P
0 0 0 r
s
.24 .35 .67 r
.3263 .55436 m
.32717 .5516 L
s
.32989 .53972 m
.33287 .52558 L
s
.045 .065 .149 r
.3304 .5568 m .32672 .5683 L .32617 .54997 L p F P
0 0 0 r
s
.971 .291 .125 r
.49288 .35745 m .48654 .35631 L .49329 .36904 L p F P
0 0 0 r
s
.971 .291 .125 r
.49012 .36847 m .49329 .36904 L .48654 .35631 L p F P
0 0 0 r
s
.318 .471 .867 r
.37248 .44219 m .37583 .43183 L .36224 .44736 L p F P
0 0 0 r
s
.318 .471 .867 r
.36224 .44736 m .35864 .45871 L .37248 .44219 L p F P
0 0 0 r
s
.24 .35 .67 r
.36737 .46223 m
.37545 .43735 L
s
.83 .24 .1 r
.25307 .35309 m
.24838 .37708 L
s
.20679 .36995 m
.24838 .37708 L
s
.3022 .581 m
.32485 .58431 L
s
.33143 .58527 m
.34327 .587 L
s
.971 .291 .125 r
.48654 .35631 m .48019 .35517 L .49012 .36847 L p F P
0 0 0 r
s
.971 .291 .125 r
.48696 .36791 m .49012 .36847 L .48019 .35517 L p F P
0 0 0 r
s
.83 .24 .1 r
.57859 .37422 m
.59164 .37656 L
s
.5897 .65549 m
.59673 .66478 L
s
.24 .35 .67 r
.32914 .62267 m
.34253 .64719 L
s
.971 .291 .125 r
.48019 .35517 m .47383 .35402 L .48696 .36791 L p F P
0 0 0 r
s
.971 .291 .125 r
.48379 .36734 m .48696 .36791 L .47383 .35402 L p F P
0 0 0 r
s
.24 .35 .67 r
.48552 .3836 m
.49177 .3678 L
s
.495 .122 .05 r
.46613 .62919 m .48423 .63177 L .48548 .64214 L p F P
0 0 0 r
s
.495 .122 .05 r
.50206 .64449 m .48548 .64214 L .48423 .63177 L p F P
0 0 0 r
s
.327 .485 .926 r
.43574 .38521 m .43791 .37914 L .41892 .38311 L p F P
0 0 0 r
s
.83 .24 .1 r
.41686 .38172 m
.42351 .36231 L
s
.327 .485 .926 r
.41892 .38311 m .4162 .391 L .43574 .38521 L p F P
0 0 0 r
s
.24 .35 .67 r
.42974 .38792 m
.45694 .38331 L
s
.42059 .41375 m
.42974 .38792 L
s
.351 .078 .033 r
.56763 .65375 m .58384 .65604 L .57446 .66161 L p F P
0 0 0 r
s
.295 .444 .814 r
.57893 .65402 m .57446 .66161 L .58384 .65604 L p F P
0 0 0 r
s
.295 .444 .814 r
.58384 .65604 m .58896 .64744 L .57893 .65402 L p F P
0 0 0 r
s
.83 .24 .1 r
.58487 .6548 m
.5897 .65549 L
s
.58467 .65478 m
.58487 .6548 L
s
.971 .291 .125 r
.47383 .35402 m .46746 .35288 L .48379 .36734 L p F P
0 0 0 r
s
.318 .472 .909 r
.4596 .37394 m .46115 .36978 L .44232 .36684 L p F P
0 0 0 r
s
.318 .472 .909 r
.44232 .36684 m .4401 .37302 L .4596 .37394 L p F P
0 0 0 r
s
.028 .04 .082 r
.62689 .58262 m .62043 .59347 L .62379 .57679 L p F P
0 0 0 r
s
.028 .04 .082 r
.62379 .57679 m .63045 .56546 L .62689 .58262 L p F P
0 0 0 r
s
.24 .35 .67 r
.61651 .56929 m
.62961 .54663 L
s
.624 .162 .067 r
.36738 .60184 m .38696 .60467 L .39285 .61874 L p F P
0 0 0 r
s
.624 .162 .067 r
.4113 .62137 m .39285 .61874 L .38696 .60467 L p F P
0 0 0 r
s
.83 .24 .1 r
.34136 .34773 m
.33585 .36756 L
s
.29469 .36037 m
.33585 .36756 L
s
.024 .035 .067 r
.33334 .51911 m .33705 .50719 L .33361 .52627 L p F P
0 0 0 r
s
.24 .35 .67 r
.33287 .52558 m
.3335 .52355 L
s
.024 .035 .067 r
.33361 .52627 m .32985 .53825 L .33334 .51911 L p F P
0 0 0 r
s
.33 .49 .916 r
.39218 .41812 m .39526 .40888 L .37925 .42129 L p F P
0 0 0 r
s
.33 .49 .916 r
.37925 .42129 m .37583 .43183 L .39218 .41812 L p F P
0 0 0 r
s
.24 .35 .67 r
.37545 .43735 m
.39629 .42328 L
s
.024 .035 .067 r
.6141 .60827 m .60816 .61822 L .61411 .60412 L p F P
0 0 0 r
s
.024 .035 .067 r
.61411 .60412 m .62043 .59347 L .6141 .60827 L p F P
0 0 0 r
s
.24 .35 .67 r
.60714 .61646 m
.61484 .59358 L
s
.167 .247 .522 r
.63808 .44451 m .63195 .45591 L .61901 .43963 L p F P
0 0 0 r
s
.24 .35 .67 r
.6126 .45035 m
.62816 .47335 L
s
.167 .247 .522 r
.61901 .43963 m .62442 .42922 L .63808 .44451 L p F P
0 0 0 r
s
.251 .373 .747 r
.58273 .36529 m .57985 .37149 L .55384 .37291 L p F P
0 0 0 r
s
.251 .373 .747 r
.55384 .37291 m .55569 .36874 L .58273 .36529 L p F P
0 0 0 r
s
.24 .35 .67 r
.54257 .39834 m
.55419 .37219 L
s
.83 .24 .1 r
.5519 .36942 m
.55883 .37067 L
s
.332 .492 .931 r
.41352 .3988 m .4162 .391 L .39838 .3995 L p F P
0 0 0 r
s
.332 .492 .931 r
.39838 .3995 m .39526 .40888 L .41352 .3988 L p F P
0 0 0 r
s
.234 .348 .702 r
.60059 .38114 m .59677 .38905 L .57419 .3837 L p F P
0 0 0 r
s
.24 .35 .67 r
.56895 .41218 m
.58111 .38628 L
s
.234 .348 .702 r
.57419 .3837 m .57701 .37762 L .60059 .38114 L p F P
0 0 0 r
s
.049 .072 .169 r
.63726 .5539 m .63045 .56546 L .63087 .54708 L p F P
0 0 0 r
s
.049 .072 .169 r
.63087 .54708 m .6377 .53529 L .63726 .5539 L p F P
0 0 0 r
s
.83 .24 .1 r
.72996 .3874 m
.71929 .38947 L
s
.68017 .38238 m
.71929 .38947 L
s
.67633 .67596 m
.71548 .68145 L
s
.71548 .68145 m
.72608 .68495 L
s
.495 .122 .05 r
.44794 .6266 m .46613 .62919 L .46883 .63979 L p F P
0 0 0 r
s
.495 .122 .05 r
.48548 .64214 m .46883 .63979 L .46613 .62919 L p F P
0 0 0 r
s
.351 .078 .033 r
.55134 .65145 m .56763 .65375 L .56004 .65959 L p F P
0 0 0 r
s
.351 .078 .033 r
.57446 .66161 m .56004 .65959 L .56763 .65375 L p F P
0 0 0 r
s
.24 .35 .67 r
.5621 .67484 m
.58095 .65806 L
s
.193 .286 .592 r
.62993 .41864 m .62442 .42922 L .60802 .41583 L p F P
0 0 0 r
s
.193 .286 .592 r
.60802 .41583 m .61267 .40656 L .62993 .41864 L p F P
0 0 0 r
s
.83 .24 .1 r
.17964 .53933 m
.22152 .54557 L
s
.22152 .54557 m
.21869 .56882 L
s
.215 .319 .651 r
.61739 .39715 m .61267 .40656 L .593 .39687 L p F P
0 0 0 r
s
.24 .35 .67 r
.59259 .42972 m
.60528 .40408 L
s
.215 .319 .651 r
.593 .39687 m .59677 .38905 L .61739 .39715 L p F P
0 0 0 r
s
.24 .35 .67 r
.55419 .37219 m
.58111 .38628 L
s
.54367 .36856 m
.55419 .37219 L
s
.52549 .3623 m
.53161 .36441 L
s
.624 .162 .067 r
.34769 .599 m .36738 .60184 L .3743 .61609 L p F P
0 0 0 r
s
.624 .162 .067 r
.39285 .61874 m .3743 .61609 L .36738 .60184 L p F P
0 0 0 r
s
.83 .24 .1 r
.38391 .59293 m
.38455 .61219 L
s
.238 .35 .612 r
.3443 .48825 m .34799 .47645 L .34084 .49503 L p F P
0 0 0 r
s
.238 .35 .612 r
.34084 .49503 m .33705 .50719 L .3443 .48825 L p F P
0 0 0 r
s
.24 .35 .67 r
.34028 .50189 m
.35122 .48035 L
s
.33491 .51905 m
.34028 .50189 L
s
.067 .097 .237 r
.64467 .52326 m .6377 .53529 L .63487 .51617 L p F P
0 0 0 r
s
.067 .097 .237 r
.63487 .51617 m .64167 .50419 L .64467 .52326 L p F P
0 0 0 r
s
.318 .472 .909 r
.46115 .36978 m .46271 .3656 L .44455 .3606 L p F P
0 0 0 r
s
.318 .472 .909 r
.44455 .3606 m .44232 .36684 L .46115 .36978 L p F P
0 0 0 r
s
.83 .24 .1 r
.42351 .36231 m
.44272 .36572 L
s
.252 .38 .679 r
.59945 .6298 m .59416 .6387 L .60233 .62799 L p F P
0 0 0 r
s
.252 .38 .679 r
.60233 .62799 m .60816 .61822 L .59945 .6298 L p F P
0 0 0 r
s
.24 .35 .67 r
.59444 .63782 m
.60714 .61646 L
s
.83 .24 .1 r
.38455 .61219 m
.42537 .61804 L
s
.24 .35 .67 r
.58111 .38628 m
.60528 .40408 L
s
.91 .278 .12 r
.54946 .36762 m .55569 .36874 L .58273 .36529 L p F P
0 0 0 r
s
.83 .24 .1 r
.38266 .35506 m
.42351 .36231 L
s
.351 .078 .033 r
.53499 .64914 m .55134 .65145 L .54558 .65756 L p F P
0 0 0 r
s
.83 .24 .1 r
.54522 .63523 m
.54995 .64986 L
s
.351 .078 .033 r
.56004 .65959 m .54558 .65756 L .55134 .65145 L p F P
0 0 0 r
s
.83 .24 .1 r
.54995 .64986 m
.579 .65397 L
s
.211 .34574 m
.20679 .36995 L
s
.26067 .57494 m
.3022 .581 L
s
.3022 .581 m
.30155 .60029 L
s
.327 .485 .926 r
.43791 .37914 m .4401 .37302 L .42167 .37513 L p F P
0 0 0 r
s
.327 .485 .926 r
.42167 .37513 m .41892 .38311 L .43791 .37914 L p F P
0 0 0 r
s
.495 .122 .05 r
.42967 .62399 m .44794 .6266 L .45211 .63743 L p F P
0 0 0 r
s
.495 .122 .05 r
.46883 .63979 m .45211 .63743 L .44794 .6266 L p F P
0 0 0 r
s
.91 .278 .12 r
.58273 .36529 m .5735 .36362 L .54946 .36762 L p F P
0 0 0 r
s
.91 .278 .12 r
.54322 .3665 m .54946 .36762 L .5735 .36362 L p F P
0 0 0 r
s
.24 .35 .67 r
.55419 .37219 m
.55625 .36754 L
s
.288 .426 .769 r
.35864 .45871 m .36224 .44736 L .35175 .46441 L p F P
0 0 0 r
s
.288 .426 .769 r
.35175 .46441 m .34799 .47645 L .35864 .45871 L p F P
0 0 0 r
s
.098 .143 .332 r
.64861 .49197 m .64167 .50419 L .63535 .48534 L p F P
0 0 0 r
s
.24 .35 .67 r
.62517 .52173 m
.63857 .49788 L
s
.098 .143 .332 r
.63535 .48534 m .64192 .47348 L .64861 .49197 L p F P
0 0 0 r
s
.624 .162 .067 r
.3279 .59614 m .34769 .599 L .35566 .61343 L p F P
0 0 0 r
s
.624 .162 .067 r
.3743 .61609 m .35566 .61343 L .34769 .599 L p F P
0 0 0 r
s
.234 .348 .702 r
.60446 .37313 m .60059 .38114 L .57701 .37762 L p F P
0 0 0 r
s
.234 .348 .702 r
.57701 .37762 m .57985 .37149 L .60446 .37313 L p F P
0 0 0 r
s
.83 .24 .1 r
.29961 .34031 m
.29469 .36037 L
s
.25307 .35309 m
.29469 .36037 L
s
.91 .278 .12 r
.5735 .36362 m .56425 .36194 L .54322 .3665 L p F P
0 0 0 r
s
.91 .278 .12 r
.53696 .36538 m .54322 .3665 L .56425 .36194 L p F P
0 0 0 r
s
.24 .35 .67 r
.47138 .71659 m
.50039 .71479 L
s
.50039 .71479 m
.51142 .69456 L
s
.318 .472 .909 r
.46271 .3656 m .46428 .36138 L .44681 .3543 L p F P
0 0 0 r
s
.318 .472 .909 r
.44681 .3543 m .44455 .3606 L .46271 .3656 L p F P
0 0 0 r
s
.91 .278 .12 r
.56425 .36194 m .55497 .36027 L .53696 .36538 L p F P
0 0 0 r
s
.91 .278 .12 r
.5307 .36425 m .53696 .36538 L .55497 .36027 L p F P
0 0 0 r
s
.351 .078 .033 r
.51856 .64682 m .53499 .64914 L .53105 .65552 L p F P
0 0 0 r
s
.351 .078 .033 r
.54558 .65756 m .53105 .65552 L .53499 .64914 L p F P
0 0 0 r
s
.83 .24 .1 r
.69014 .38017 m
.68017 .38238 L
s
.64062 .37522 m
.68017 .38238 L
s
.318 .471 .867 r
.37583 .43183 m .37925 .42129 L .3659 .4358 L p F P
0 0 0 r
s
.318 .471 .867 r
.3659 .4358 m .36224 .44736 L .37583 .43183 L p F P
0 0 0 r
s
.332 .492 .931 r
.4162 .391 m .41892 .38311 L .40155 .38998 L p F P
0 0 0 r
s
.332 .492 .931 r
.40155 .38998 m .39838 .3995 L .4162 .391 L p F P
0 0 0 r
s
.24 .35 .67 r
.40503 .39738 m
.42974 .38792 L
s
.495 .122 .05 r
.4113 .62137 m .42967 .62399 L .43531 .63505 L p F P
0 0 0 r
s
.495 .122 .05 r
.45211 .63743 m .43531 .63505 L .42967 .62399 L p F P
0 0 0 r
s
.83 .24 .1 r
.63675 .6704 m
.67633 .67596 L
s
.67633 .67596 m
.68623 .67937 L
s
.24 .35 .67 r
.34253 .64719 m
.3503 .62554 L
s
.34253 .64719 m
.36146 .66954 L
s
.91 .278 .12 r
.55497 .36027 m .54567 .35858 L .5307 .36425 L p F P
0 0 0 r
s
.91 .278 .12 r
.52442 .36312 m .5307 .36425 L .54567 .35858 L p F P
0 0 0 r
s
.24 .35 .67 r
.49605 .35701 m
.52549 .3623 L
s
.136 .2 .437 r
.64861 .46138 m .64192 .47348 L .63195 .45591 L p F P
0 0 0 r
s
.24 .35 .67 r
.62816 .47335 m
.63857 .49788 L
s
.136 .2 .437 r
.63195 .45591 m .63808 .44451 L .64861 .46138 L p F P
0 0 0 r
s
.33 .49 .916 r
.39526 .40888 m .39838 .3995 L .38272 .41057 L p F P
0 0 0 r
s
.24 .35 .67 r
.39629 .42328 m
.40503 .39738 L
s
.33 .49 .916 r
.38272 .41057 m .37925 .42129 L .39526 .40888 L p F P
0 0 0 r
s
.065 .095 .231 r
.32672 .5683 m .3304 .5568 L .33507 .57433 L p F P
0 0 0 r
s
.065 .095 .231 r
.33507 .57433 m .33145 .58534 L .32672 .5683 L p F P
0 0 0 r
s
.83 .24 .1 r
.17964 .53933 m
.17625 .56262 L
s
.624 .162 .067 r
.35566 .61343 m .33693 .61076 L .3279 .59614 L p F P
0 0 0 r
s
.83 .24 .1 r
.34327 .587 m
.34328 .60627 L
s
.085 .126 .306 r
.3279 .59614 m .33145 .58534 L .34038 .60067 L p F P
0 0 0 r
s
.085 .126 .306 r
.34038 .60067 m .33693 .61076 L .3279 .59614 L p F P
0 0 0 r
s
.24 .35 .67 r
.32914 .62267 m
.3345 .60681 L
s
.53858 .68725 m
.5621 .67484 L
s
.48987 .35691 m
.49605 .35701 L
s
.295 .444 .814 r
.58346 .64632 m .57893 .65402 L .58896 .64744 L p F P
0 0 0 r
s
.295 .444 .814 r
.58896 .64744 m .59416 .6387 L .58346 .64632 L p F P
0 0 0 r
s
.91 .278 .12 r
.54567 .35858 m .53635 .3569 L .52442 .36312 L p F P
0 0 0 r
s
.91 .278 .12 r
.51814 .36199 m .52442 .36312 L .53635 .3569 L p F P
0 0 0 r
s
.83 .24 .1 r
.51172 .36221 m
.5519 .36942 L
s
.215 .319 .651 r
.62219 .3876 m .61739 .39715 L .59677 .38905 L p F P
0 0 0 r
s
.215 .319 .651 r
.59677 .38905 m .60059 .38114 L .62219 .3876 L p F P
0 0 0 r
s
.045 .065 .149 r
.32985 .53825 m .33361 .52627 L .33415 .54506 L p F P
0 0 0 r
s
.24 .35 .67 r
.32998 .54269 m
.33087 .53986 L
s
.045 .065 .149 r
.33415 .54506 m .3304 .5568 L .32985 .53825 L p F P
0 0 0 r
s
.351 .078 .033 r
.50206 .64449 m .51856 .64682 L .51647 .65347 L p F P
0 0 0 r
s
.351 .078 .033 r
.53105 .65552 m .51647 .65347 L .51856 .64682 L p F P
0 0 0 r
s
.83 .24 .1 r
.50976 .64418 m
.54995 .64986 L
s
.167 .247 .522 r
.64432 .43289 m .63808 .44451 L .62442 .42922 L p F P
0 0 0 r
s
.167 .247 .522 r
.62442 .42922 m .62993 .41864 L .64432 .43289 L p F P
0 0 0 r
s
.24 .35 .67 r
.6126 .45035 m
.62578 .42498 L
s
.91 .278 .12 r
.53635 .3569 m .52701 .35521 L .51814 .36199 L p F P
0 0 0 r
s
.91 .278 .12 r
.51184 .36086 m .51814 .36199 L .52701 .35521 L p F P
0 0 0 r
s
.327 .485 .926 r
.4401 .37302 m .44232 .36684 L .42446 .36705 L p F P
0 0 0 r
s
.327 .485 .926 r
.42446 .36705 m .42167 .37513 L .4401 .37302 L p F P
0 0 0 r
s
.83 .24 .1 r
.34328 .60627 m
.38455 .61219 L
s
.80828 .40163 m
.81951 .40621 L
s
.76933 .39455 m
.80828 .40163 L
s
.495 .122 .05 r
.39285 .61874 m .4113 .62137 L .41843 .63267 L p F P
0 0 0 r
s
.495 .122 .05 r
.43531 .63505 m .41843 .63267 L .4113 .62137 L p F P
0 0 0 r
s
.83 .24 .1 r
.42537 .61804 m
.42806 .63262 L
s
.193 .286 .592 r
.63553 .40788 m .62993 .41864 L .61267 .40656 L p F P
0 0 0 r
s
.193 .286 .592 r
.61267 .40656 m .61739 .39715 L .63553 .40788 L p F P
0 0 0 r
s
.24 .35 .67 r
.60528 .40408 m
.62578 .42498 L
s
.318 .472 .909 r
.46428 .36138 m .46587 .35714 L .44908 .34794 L p F P
0 0 0 r
s
.318 .472 .909 r
.44908 .34794 m .44681 .3543 L .46428 .36138 L p F P
0 0 0 r
s
.83 .24 .1 r
.38852 .34007 m
.38266 .35506 L
s
.34136 .34773 m
.38266 .35506 L
s
.21869 .56882 m
.26067 .57494 L
s
.26067 .57494 m
.25937 .59424 L
s
.91 .278 .12 r
.52701 .35521 m .51764 .35351 L .51184 .36086 L p F P
0 0 0 r
s
.91 .278 .12 r
.50553 .35972 m .51184 .36086 L .51764 .35351 L p F P
0 0 0 r
s
.24 .35 .67 r
.33178 .58434 m
.3327 .58749 L
s
.028 .04 .082 r
.63346 .57155 m .62689 .58262 L .63045 .56546 L p F P
0 0 0 r
s
.24 .35 .67 r
.62806 .57115 m
.62961 .54663 L
s
.028 .04 .082 r
.63045 .56546 m .63726 .5539 L .63346 .57155 L p F P
0 0 0 r
s
.234 .348 .702 r
.60838 .36502 m .60446 .37313 L .57985 .37149 L p F P
0 0 0 r
s
.234 .348 .702 r
.57985 .37149 m .58273 .36529 L .60838 .36502 L p F P
0 0 0 r
s
.024 .035 .067 r
.62015 .59813 m .6141 .60827 L .62043 .59347 L p F P
0 0 0 r
s
.024 .035 .067 r
.62043 .59347 m .62689 .58262 L .62015 .59813 L p F P
0 0 0 r
s
.24 .35 .67 r
.61484 .59358 m
.62806 .57115 L
s
.024 .035 .067 r
.33705 .50719 m .34084 .49503 L .33744 .51405 L p F P
0 0 0 r
s
.024 .035 .067 r
.33744 .51405 m .33361 .52627 L .33705 .50719 L p F P
0 0 0 r
s
.91 .278 .12 r
.51764 .35351 m .50824 .35181 L .50553 .35972 L p F P
0 0 0 r
s
.91 .278 .12 r
.49921 .35859 m .50553 .35972 L .50824 .35181 L p F P
0 0 0 r
s
.351 .078 .033 r
.48548 .64214 m .50206 .64449 L .50182 .65142 L p F P
0 0 0 r
s
.351 .078 .033 r
.51647 .65347 m .50182 .65142 L .50206 .64449 L p F P
0 0 0 r
s
.83 .24 .1 r
.25739 .33282 m
.25307 .35309 L
s
.211 .34574 m
.25307 .35309 L
s
.049 .072 .169 r
.6442 .5421 m .63726 .5539 L .6377 .53529 L p F P
0 0 0 r
s
.049 .072 .169 r
.6377 .53529 m .64467 .52326 L .6442 .5421 L p F P
0 0 0 r
s
.91 .278 .12 r
.50824 .35181 m .49883 .35011 L .49921 .35859 L p F P
0 0 0 r
s
.91 .278 .12 r
.49288 .35745 m .49921 .35859 L .49883 .35011 L p F P
0 0 0 r
s
.495 .122 .05 r
.3743 .61609 m .39285 .61874 L .40148 .63027 L p F P
0 0 0 r
s
.495 .122 .05 r
.41843 .63267 m .40148 .63027 L .39285 .61874 L p F P
0 0 0 r
s
.83 .24 .1 r
.64988 .37286 m
.64062 .37522 L
s
.252 .38 .679 r
.60483 .62076 m .59945 .6298 L .60816 .61822 L p F P
0 0 0 r
s
.252 .38 .679 r
.60816 .61822 m .6141 .60827 L .60483 .62076 L p F P
0 0 0 r
s
.24 .35 .67 r
.44147 .71267 m
.47138 .71659 L
s
.47138 .71659 m
.48187 .69627 L
s
.83 .24 .1 r
.59673 .66478 m
.63675 .6704 L
s
.63675 .6704 m
.64594 .67373 L
s
.91 .278 .12 r
.49883 .35011 m .48939 .3484 L .49288 .35745 L p F P
0 0 0 r
s
.91 .278 .12 r
.48654 .35631 m .49288 .35745 L .48939 .3484 L p F P
0 0 0 r
s
.238 .35 .612 r
.34799 .47645 m .35175 .46441 L .34471 .48262 L p F P
0 0 0 r
s
.238 .35 .612 r
.34471 .48262 m .34084 .49503 L .34799 .47645 L p F P
0 0 0 r
s
.318 .472 .909 r
.46587 .35714 m .46746 .35288 L .45138 .34152 L p F P
0 0 0 r
s
.24 .35 .67 r
.46694 .35654 m
.47767 .35671 L
s
.318 .472 .909 r
.45138 .34152 m .44908 .34794 L .46587 .35714 L p F P
0 0 0 r
s
.24 .35 .67 r
.45694 .38331 m
.46694 .35654 L
s
.332 .492 .931 r
.41892 .38311 m .42167 .37513 L .40477 .38033 L p F P
0 0 0 r
s
.332 .492 .931 r
.40477 .38033 m .40155 .38998 L .41892 .38311 L p F P
0 0 0 r
s
.067 .097 .237 r
.65179 .51097 m .64467 .52326 L .64167 .50419 L p F P
0 0 0 r
s
.067 .097 .237 r
.64167 .50419 m .64861 .49197 L .65179 .51097 L p F P
0 0 0 r
s
.24 .35 .67 r
.63857 .49788 m
.64325 .52303 L
s
.351 .078 .033 r
.46883 .63979 m .48548 .64214 L .48713 .64936 L p F P
0 0 0 r
s
.351 .078 .033 r
.50182 .65142 m .48713 .64936 L .48548 .64214 L p F P
0 0 0 r
s
.24 .35 .67 r
.36146 .66954 m
.36967 .64822 L
s
.36146 .66954 m
.38507 .68853 L
s
.91 .278 .12 r
.48939 .3484 m .47992 .34668 L .48654 .35631 L p F P
0 0 0 r
s
.91 .278 .12 r
.48019 .35517 m .48654 .35631 L .47992 .34668 L p F P
0 0 0 r
s
.327 .485 .926 r
.44232 .36684 m .44455 .3606 L .42728 .35887 L p F P
0 0 0 r
s
.327 .485 .926 r
.42728 .35887 m .42446 .36705 L .44232 .36684 L p F P
0 0 0 r
s
.24 .35 .67 r
.42974 .38792 m
.43927 .36102 L
s
.91 .278 .12 r
.47992 .34668 m .47043 .34497 L .48019 .35517 L p F P
0 0 0 r
s
.91 .278 .12 r
.47383 .35402 m .48019 .35517 L .47043 .34497 L p F P
0 0 0 r
s
.83 .24 .1 r
.46844 .36032 m
.47111 .35491 L
s
.47111 .35491 m
.51172 .36221 L
s
.288 .426 .769 r
.36224 .44736 m .3659 .4358 L .35559 .45213 L p F P
0 0 0 r
s
.288 .426 .769 r
.35559 .45213 m .35175 .46441 L .36224 .44736 L p F P
0 0 0 r
s
.24 .35 .67 r
.35907 .45555 m
.37545 .43735 L
s
.35122 .48035 m
.35907 .45555 L
s
.495 .122 .05 r
.35566 .61343 m .3743 .61609 L .38445 .62787 L p F P
0 0 0 r
s
.495 .122 .05 r
.40148 .63027 m .38445 .62787 L .3743 .61609 L p F P
0 0 0 r
s
.215 .319 .651 r
.62705 .3779 m .62219 .3876 L .60059 .38114 L p F P
0 0 0 r
s
.215 .319 .651 r
.60059 .38114 m .60446 .37313 L .62705 .3779 L p F P
0 0 0 r
s
.83 .24 .1 r
.60644 .36903 m
.64062 .37522 L
s
.33869 .60561 m
.34328 .60627 L
s
.77989 .39903 m
.76933 .39455 L
s
.72996 .3874 m
.76933 .39455 L
s
.72608 .68495 m
.76548 .69047 L
s
.77788 .68765 m
.76548 .69047 L
s
.33 .49 .916 r
.39838 .3995 m .40155 .38998 L .38624 .39967 L p F P
0 0 0 r
s
.33 .49 .916 r
.38624 .39967 m .38272 .41057 L .39838 .3995 L p F P
0 0 0 r
s
.776 .244 .106 r
.5735 .36362 m .58273 .36529 L .60838 .36502 L p F P
0 0 0 r
s
.098 .143 .332 r
.65569 .47949 m .64861 .49197 L .64192 .47348 L p F P
0 0 0 r
s
.098 .143 .332 r
.64192 .47348 m .64861 .46138 L .65569 .47949 L p F P
0 0 0 r
s
.91 .278 .12 r
.47043 .34497 m .46092 .34324 L .47383 .35402 L p F P
0 0 0 r
s
.91 .278 .12 r
.46746 .35288 m .47383 .35402 L .46092 .34324 L p F P
0 0 0 r
s
.83 .24 .1 r
.34654 .33253 m
.34136 .34773 L
s
.29961 .34031 m
.34136 .34773 L
s
.318 .471 .867 r
.37925 .42129 m .38272 .41057 L .36963 .42402 L p F P
0 0 0 r
s
.318 .471 .867 r
.36963 .42402 m .3659 .4358 L .37925 .42129 L p F P
0 0 0 r
s
.83 .24 .1 r
.17625 .56262 m
.21869 .56882 L
s
.21869 .56882 m
.21671 .58812 L
s
.351 .078 .033 r
.45211 .63743 m .46883 .63979 L .47237 .64728 L p F P
0 0 0 r
s
.83 .24 .1 r
.46575 .62383 m
.46913 .63843 L
s
.351 .078 .033 r
.48713 .64936 m .47237 .64728 L .46883 .63979 L p F P
0 0 0 r
s
.83 .24 .1 r
.46913 .63843 m
.50976 .64418 L
s
.46401 .35363 m
.47111 .35491 L
s
.256 .059 .025 r
.56004 .65959 m .57446 .66161 L .56294 .66343 L p F P
0 0 0 r
s
.317 .477 .891 r
.56665 .65703 m .56294 .66343 L .57446 .66161 L p F P
0 0 0 r
s
.24 .35 .67 r
.56927 .66257 m
.56936 .66242 L
s
.317 .477 .891 r
.57446 .66161 m .57893 .65402 L .56665 .65703 L p F P
0 0 0 r
s
.91 .278 .12 r
.46092 .34324 m .45138 .34152 L .46746 .35288 L p F P
0 0 0 r
s
.24 .35 .67 r
.46694 .35654 m
.46872 .35178 L
s
.776 .244 .106 r
.60838 .36502 m .59632 .36283 L .5735 .36362 L p F P
0 0 0 r
s
.24 .35 .67 r
.58111 .38628 m
.5912 .36482 L
s
.776 .244 .106 r
.56425 .36194 m .5735 .36362 L .59632 .36283 L p F P
0 0 0 r
s
.24 .35 .67 r
.4122 .70317 m
.44147 .71267 L
s
.44147 .71267 m
.45138 .69219 L
s
.295 .444 .814 r
.58807 .6385 m .58346 .64632 L .59416 .6387 L p F P
0 0 0 r
s
.295 .444 .814 r
.59416 .6387 m .59945 .6298 L .58807 .6385 L p F P
0 0 0 r
s
.24 .35 .67 r
.59697 .6317 m
.60714 .61646 L
s
.83 .24 .1 r
.2147 .32524 m
.211 .34574 L
s
.136 .2 .437 r
.65544 .44904 m .64861 .46138 L .63808 .44451 L p F P
0 0 0 r
s
.136 .2 .437 r
.63808 .44451 m .64432 .43289 L .65544 .44904 L p F P
0 0 0 r
s
.24 .35 .67 r
.62816 .47335 m
.64176 .44825 L
s
.193 .286 .592 r
.64122 .39693 m .63553 .40788 L .61739 .39715 L p F P
0 0 0 r
s
.193 .286 .592 r
.61739 .39715 m .62219 .3876 L .64122 .39693 L p F P
0 0 0 r
s
.495 .122 .05 r
.33693 .61076 m .35566 .61343 L .36734 .62545 L p F P
0 0 0 r
s
.495 .122 .05 r
.38445 .62787 m .36734 .62545 L .35566 .61343 L p F P
0 0 0 r
s
.24 .35 .67 r
.38507 .68853 m
.39381 .66753 L
s
.38507 .68853 m
.4122 .70317 L
s
.167 .247 .522 r
.65068 .42106 m .64432 .43289 L .62993 .41864 L p F P
0 0 0 r
s
.24 .35 .67 r
.62578 .42498 m
.64176 .44825 L
s
.167 .247 .522 r
.62993 .41864 m .63553 .40788 L .65068 .42106 L p F P
0 0 0 r
s
.776 .244 .106 r
.59632 .36283 m .58423 .36064 L .56425 .36194 L p F P
0 0 0 r
s
.24 .35 .67 r
.59246 .36213 m
.59378 .35932 L
s
.776 .244 .106 r
.55497 .36027 m .56425 .36194 L .58423 .36064 L p F P
0 0 0 r
s
.83 .24 .1 r
.5519 .36942 m
.5602 .36066 L
s
.5602 .36066 m
.59255 .36652 L
s
.351 .078 .033 r
.43531 .63505 m .45211 .63743 L .45755 .64521 L p F P
0 0 0 r
s
.351 .078 .033 r
.47237 .64728 m .45755 .64521 L .45211 .63743 L p F P
0 0 0 r
s
.256 .059 .025 r
.54558 .65756 m .56004 .65959 L .55074 .66172 L p F P
0 0 0 r
s
.256 .059 .025 r
.56294 .66343 m .55074 .66172 L .56004 .65959 L p F P
0 0 0 r
s
.24 .35 .67 r
.5621 .67484 m
.56927 .66257 L
s
.085 .126 .306 r
.33145 .58534 m .33507 .57433 L .34389 .59039 L p F P
0 0 0 r
s
.085 .126 .306 r
.34389 .59039 m .34038 .60067 L .33145 .58534 L p F P
0 0 0 r
s
.83 .24 .1 r
.30155 .60029 m
.33392 .60493 L
s
.065 .095 .231 r
.3304 .5568 m .33415 .54506 L .33876 .56309 L p F P
0 0 0 r
s
.065 .095 .231 r
.33876 .56309 m .33507 .57433 L .3304 .5568 L p F P
0 0 0 r
s
.83 .24 .1 r
.57305 .66146 m
.59673 .66478 L
s
.57175 .66128 m
.57305 .66146 L
s
.55627 .65911 m
.56475 .6603 L
s
.59673 .66478 m
.6052 .66802 L
s
.24 .35 .67 r
.4122 .70317 m
.42152 .68245 L
s
.51142 .69456 m
.53858 .68725 L
s
.53858 .68725 m
.55055 .6662 L
s
.327 .485 .926 r
.44455 .3606 m .44681 .3543 L .43013 .35058 L p F P
0 0 0 r
s
.327 .485 .926 r
.43013 .35058 m .42728 .35887 L .44455 .3606 L p F P
0 0 0 r
s
.24 .35 .67 r
.43927 .36102 m
.46694 .35654 L
s
.83 .24 .1 r
.43004 .34753 m
.44807 .35077 L
s
.42351 .36231 m
.43004 .34753 L
s
.776 .244 .106 r
.58423 .36064 m .5721 .35843 L .55497 .36027 L p F P
0 0 0 r
s
.776 .244 .106 r
.54567 .35858 m .55497 .36027 L .5721 .35843 L p F P
0 0 0 r
s
.045 .065 .149 r
.33361 .52627 m .33744 .51405 L .33797 .53307 L p F P
0 0 0 r
s
.24 .35 .67 r
.33374 .53077 m
.33464 .52789 L
s
.33748 .5153 m
.34028 .50189 L
s
.045 .065 .149 r
.33797 .53307 m .33415 .54506 L .33361 .52627 L p F P
0 0 0 r
s
.332 .492 .931 r
.42167 .37513 m .42446 .36705 L .40803 .37053 L p F P
0 0 0 r
s
.332 .492 .931 r
.40803 .37053 m .40477 .38033 L .42167 .37513 L p F P
0 0 0 r
s
.495 .122 .05 r
.36734 .62545 m .35015 .62302 L .33693 .61076 L p F P
0 0 0 r
s
.125 .189 .421 r
.33693 .61076 m .34038 .60067 L .35343 .61386 L p F P
0 0 0 r
s
.125 .189 .421 r
.35343 .61386 m .35015 .62302 L .33693 .61076 L p F P
0 0 0 r
s
.83 .24 .1 r
.34412 .61599 m
.34453 .6208 L
s
.24 .35 .67 r
.3476 .62065 m
.3503 .62554 L
s
.256 .059 .025 r
.53105 .65552 m .54558 .65756 L .5385 .66001 L p F P
0 0 0 r
s
.256 .059 .025 r
.55074 .66172 m .5385 .66001 L .54558 .65756 L p F P
0 0 0 r
s
.83 .24 .1 r
.54995 .64986 m
.55627 .65911 L
s
.351 .078 .033 r
.41843 .63267 m .43531 .63505 L .44268 .64312 L p F P
0 0 0 r
s
.351 .078 .033 r
.45755 .64521 m .44268 .64312 L .43531 .63505 L p F P
0 0 0 r
s
.83 .24 .1 r
.42806 .63262 m
.46913 .63843 L
s
.776 .244 .106 r
.5721 .35843 m .55993 .35622 L .54567 .35858 L p F P
0 0 0 r
s
.24 .35 .67 r
.56118 .35645 m
.56629 .34496 L
s
.776 .244 .106 r
.53635 .3569 m .54567 .35858 L .55993 .35622 L p F P
0 0 0 r
s
.83 .24 .1 r
.25937 .59424 m
.30155 .60029 L
s
.30155 .60029 m
.30206 .61479 L
s
.73982 .39177 m
.72996 .3874 L
s
.69014 .38017 m
.72996 .3874 L
s
.024 .035 .067 r
.62631 .5878 m .62015 .59813 L .62689 .58262 L p F P
0 0 0 r
s
.024 .035 .067 r
.62689 .58262 m .63346 .57155 L .62631 .5878 L p F P
0 0 0 r
s
.24 .35 .67 r
.62036 .59422 m
.62806 .57115 L
s
.028 .04 .082 r
.64018 .56026 m .63346 .57155 L .63726 .5539 L p F P
0 0 0 r
s
.028 .04 .082 r
.63726 .5539 m .6442 .5421 L .64018 .56026 L p F P
0 0 0 r
s
.24 .35 .67 r
.62961 .54663 m
.64325 .52303 L
s
.83 .24 .1 r
.68623 .67937 m
.72608 .68495 L
s
.72608 .68495 m
.7378 .68201 L
s
.30408 .3249 m
.29961 .34031 L
s
.25739 .33282 m
.29961 .34031 L
s
.215 .319 .651 r
.63199 .36807 m .62705 .3779 L .60446 .37313 L p F P
0 0 0 r
s
.24 .35 .67 r
.60528 .40408 m
.6185 .37739 L
s
.215 .319 .651 r
.60446 .37313 m .60838 .36502 L .63199 .36807 L p F P
0 0 0 r
s
.024 .035 .067 r
.34084 .49503 m .34471 .48262 L .34136 .50157 L p F P
0 0 0 r
s
.24 .35 .67 r
.34028 .50189 m
.34116 .49908 L
s
.024 .035 .067 r
.34136 .50157 m .33744 .51405 L .34084 .49503 L p F P
0 0 0 r
s
.83 .24 .1 r
.17625 .56262 m
.17357 .58194 L
s
.38852 .34007 m
.43004 .34753 L
s
.776 .244 .106 r
.55993 .35622 m .54772 .354 L .53635 .3569 L p F P
0 0 0 r
s
.776 .244 .106 r
.52701 .35521 m .53635 .3569 L .54772 .354 L p F P
0 0 0 r
s
.252 .38 .679 r
.6103 .61156 m .60483 .62076 L .6141 .60827 L p F P
0 0 0 r
s
.252 .38 .679 r
.6141 .60827 m .62015 .59813 L .6103 .61156 L p F P
0 0 0 r
s
.24 .35 .67 r
.60714 .61646 m
.62036 .59422 L
s
.049 .072 .169 r
.65129 .53005 m .6442 .5421 L .64467 .52326 L p F P
0 0 0 r
s
.049 .072 .169 r
.64467 .52326 m .65179 .51097 L .65129 .53005 L p F P
0 0 0 r
s
.256 .059 .025 r
.51647 .65347 m .53105 .65552 L .52622 .65829 L p F P
0 0 0 r
s
.256 .059 .025 r
.5385 .66001 m .52622 .65829 L .53105 .65552 L p F P
0 0 0 r
s
.351 .078 .033 r
.40148 .63027 m .41843 .63267 L .42774 .64102 L p F P
0 0 0 r
s
.351 .078 .033 r
.44268 .64312 m .42774 .64102 L .41843 .63267 L p F P
0 0 0 r
s
.33 .49 .916 r
.40155 .38998 m .40477 .38033 L .38983 .38858 L p F P
0 0 0 r
s
.33 .49 .916 r
.38983 .38858 m .38624 .39967 L .40155 .38998 L p F P
0 0 0 r
s
.238 .35 .612 r
.35175 .46441 m .35559 .45213 L .34866 .46994 L p F P
0 0 0 r
s
.238 .35 .612 r
.34866 .46994 m .34471 .48262 L .35175 .46441 L p F P
0 0 0 r
s
.24 .35 .67 r
.348 .47723 m
.35907 .45555 L
s
.34263 .49439 m
.348 .47723 L
s
.776 .244 .106 r
.54772 .354 m .53546 .35178 L .52701 .35521 L p F P
0 0 0 r
s
.776 .244 .106 r
.51764 .35351 m .52701 .35521 L .53546 .35178 L p F P
0 0 0 r
s
.24 .35 .67 r
.56629 .34496 m
.59378 .35932 L
s
.56629 .34496 m
.5789 .31658 L
s
.56629 .34496 m
.53701 .33483 L
s
.317 .477 .891 r
.5704 .65055 m .56665 .65703 L .57893 .65402 L p F P
0 0 0 r
s
.317 .477 .891 r
.57893 .65402 m .58346 .64632 L .5704 .65055 L p F P
0 0 0 r
s
.24 .35 .67 r
.58245 .64665 m
.58416 .64514 L
s
.327 .485 .926 r
.44681 .3543 m .44908 .34794 L .43302 .3422 L p F P
0 0 0 r
s
.327 .485 .926 r
.43302 .3422 m .43013 .35058 L .44681 .3543 L p F P
0 0 0 r
s
.83 .24 .1 r
.43004 .34753 m
.43244 .3439 L
s
.067 .097 .237 r
.65906 .49843 m .65179 .51097 L .64861 .49197 L p F P
0 0 0 r
s
.067 .097 .237 r
.64861 .49197 m .65569 .47949 L .65906 .49843 L p F P
0 0 0 r
s
.288 .426 .769 r
.3659 .4358 m .36963 .42402 L .35951 .43961 L p F P
0 0 0 r
s
.288 .426 .769 r
.35951 .43961 m .35559 .45213 L .3659 .4358 L p F P
0 0 0 r
s
.318 .471 .867 r
.38272 .41057 m .38624 .39967 L .37343 .41202 L p F P
0 0 0 r
s
.24 .35 .67 r
.38387 .41145 m
.40503 .39738 L
s
.318 .471 .867 r
.37343 .41202 m .36963 .42402 L .38272 .41057 L p F P
0 0 0 r
s
.24 .35 .67 r
.37545 .43735 m
.38387 .41145 L
s
.256 .059 .025 r
.50182 .65142 m .51647 .65347 L .5139 .65657 L p F P
0 0 0 r
s
.256 .059 .025 r
.52622 .65829 m .5139 .65657 L .51647 .65347 L p F P
0 0 0 r
s
.83 .24 .1 r
.51536 .65336 m
.55627 .65911 L
s
.776 .244 .106 r
.53546 .35178 m .52317 .34955 L .51764 .35351 L p F P
0 0 0 r
s
.24 .35 .67 r
.5303 .35084 m
.53701 .33483 L
s
.776 .244 .106 r
.50824 .35181 m .51764 .35351 L .52317 .34955 L p F P
0 0 0 r
s
.83 .24 .1 r
.51172 .36221 m
.51933 .35326 L
s
.51933 .35326 m
.5602 .36066 L
s
.193 .286 .592 r
.64701 .3858 m .64122 .39693 L .62219 .3876 L p F P
0 0 0 r
s
.193 .286 .592 r
.62219 .3876 m .62705 .3779 L .64701 .3858 L p F P
0 0 0 r
s
.24 .35 .67 r
.59378 .35932 m
.59935 .36338 L
s
.351 .078 .033 r
.38445 .62787 m .40148 .63027 L .41275 .63892 L p F P
0 0 0 r
s
.351 .078 .033 r
.42774 .64102 m .41275 .63892 L .40148 .63027 L p F P
0 0 0 r
s
.24 .35 .67 r
.53701 .33483 m
.54902 .30619 L
s
.53701 .33483 m
.50701 .32931 L
s
.098 .143 .332 r
.66292 .46675 m .65569 .47949 L .64861 .46138 L p F P
0 0 0 r
s
.24 .35 .67 r
.63857 .49788 m
.65252 .47305 L
s
.098 .143 .332 r
.64861 .46138 m .65544 .44904 L .66292 .46675 L p F P
0 0 0 r
s
.295 .444 .814 r
.59274 .63057 m .58807 .6385 L .59945 .6298 L p F P
0 0 0 r
s
.295 .444 .814 r
.59945 .6298 m .60483 .62076 L .59274 .63057 L p F P
0 0 0 r
s
.776 .244 .106 r
.52317 .34955 m .51083 .34731 L .50824 .35181 L p F P
0 0 0 r
s
.776 .244 .106 r
.49883 .35011 m .50824 .35181 L .51083 .34731 L p F P
0 0 0 r
s
.332 .492 .931 r
.42446 .36705 m .42728 .35887 L .41135 .36058 L p F P
0 0 0 r
s
.332 .492 .931 r
.41135 .36058 m .40803 .37053 L .42446 .36705 L p F P
0 0 0 r
s
.24 .35 .67 r
.41415 .3704 m
.43927 .36102 L
s
.83 .24 .1 r
.21671 .58812 m
.25937 .59424 L
s
.25937 .59424 m
.25912 .60871 L
s
.256 .059 .025 r
.48713 .64936 m .50182 .65142 L .50154 .65484 L p F P
0 0 0 r
s
.256 .059 .025 r
.5139 .65657 m .50154 .65484 L .50182 .65142 L p F P
0 0 0 r
s
.83 .24 .1 r
.50976 .64418 m
.51536 .65336 L
s
.69929 .38442 m
.69014 .38017 L
s
.64988 .37286 m
.69014 .38017 L
s
.167 .247 .522 r
.65716 .40901 m .65068 .42106 L .63553 .40788 L p F P
0 0 0 r
s
.167 .247 .522 r
.63553 .40788 m .64122 .39693 L .65716 .40901 L p F P
0 0 0 r
s
.24 .35 .67 r
.62578 .42498 m
.6395 .39856 L
s
.136 .2 .437 r
.66241 .43645 m .65544 .44904 L .64432 .43289 L p F P
0 0 0 r
s
.24 .35 .67 r
.64176 .44825 m
.65252 .47305 L
s
.136 .2 .437 r
.64432 .43289 m .65068 .42106 L .66241 .43645 L p F P
0 0 0 r
s
.83 .24 .1 r
.64594 .67373 m
.68623 .67937 L
s
.68623 .67937 m
.69727 .6763 L
s
.26115 .31719 m
.25739 .33282 L
s
.2147 .32524 m
.25739 .33282 L
s
.776 .244 .106 r
.51083 .34731 m .49846 .34506 L .49883 .35011 L p F P
0 0 0 r
s
.24 .35 .67 r
.49878 .3501 m
.49882 .35 L
s
.50062 .34545 m
.50701 .32931 L
s
.776 .244 .106 r
.48939 .3484 m .49883 .35011 L .49846 .34506 L p F P
0 0 0 r
s
.24 .35 .67 r
.48187 .69627 m
.51142 .69456 L
s
.51142 .69456 m
.52292 .67348 L
s
.543 .18 .079 r
.59632 .36283 m .60838 .36502 L .63199 .36807 L p F P
0 0 0 r
s
.24 .35 .67 r
.60084 .36448 m
.6185 .37739 L
s
.351 .078 .033 r
.36734 .62545 m .38445 .62787 L .39769 .6368 L p F P
0 0 0 r
s
.83 .24 .1 r
.38455 .61219 m
.38653 .62674 L
s
.351 .078 .033 r
.41275 .63892 m .39769 .6368 L .38445 .62787 L p F P
0 0 0 r
s
.83 .24 .1 r
.38653 .62674 m
.42806 .63262 L
s
.39391 .33056 m
.38852 .34007 L
s
.34654 .33253 m
.38852 .34007 L
s
.34453 .6208 m
.34989 .62156 L
s
.776 .244 .106 r
.49846 .34506 m .48604 .3428 L .48939 .3484 L p F P
0 0 0 r
s
.776 .244 .106 r
.47992 .34668 m .48939 .3484 L .48604 .3428 L p F P
0 0 0 r
s
.256 .059 .025 r
.47237 .64728 m .48713 .64936 L .48914 .6531 L p F P
0 0 0 r
s
.256 .059 .025 r
.50154 .65484 m .48914 .6531 L .48713 .64936 L p F P
0 0 0 r
s
.085 .126 .306 r
.33507 .57433 m .33876 .56309 L .34747 .57991 L p F P
0 0 0 r
s
.085 .126 .306 r
.34747 .57991 m .34389 .59039 L .33507 .57433 L p F P
0 0 0 r
s
.83 .24 .1 r
.81951 .40621 m
.82941 .41731 L
s
.77989 .39903 m
.81951 .40621 L
s
.327 .485 .926 r
.44908 .34794 m .45138 .34152 L .43595 .3337 L p F P
0 0 0 r
s
.327 .485 .926 r
.43595 .3337 m .43302 .3422 L .44908 .34794 L p F P
0 0 0 r
s
.065 .095 .231 r
.33415 .54506 m .33797 .53307 L .34253 .55162 L p F P
0 0 0 r
s
.065 .095 .231 r
.34253 .55162 m .33876 .56309 L .33415 .54506 L p F P
0 0 0 r
s
.543 .18 .079 r
.63199 .36807 m .61735 .36541 L .59632 .36283 L p F P
0 0 0 r
s
.24 .35 .67 r
.6185 .37739 m
.62369 .36691 L
s
.83 .24 .1 r
.60304 .36727 m
.60917 .36547 L
s
.543 .18 .079 r
.58423 .36064 m .59632 .36283 L .61735 .36541 L p F P
0 0 0 r
s
.125 .189 .421 r
.34038 .60067 m .34389 .59039 L .35676 .60454 L p F P
0 0 0 r
s
.125 .189 .421 r
.35676 .60454 m .35343 .61386 L .34038 .60067 L p F P
0 0 0 r
s
.24 .35 .67 r
.50701 .32931 m
.51843 .30044 L
s
.50701 .32931 m
.47737 .32866 L
s
.776 .244 .106 r
.48604 .3428 m .47358 .34054 L .47992 .34668 L p F P
0 0 0 r
s
.776 .244 .106 r
.47043 .34497 m .47992 .34668 L .47358 .34054 L p F P
0 0 0 r
s
.83 .24 .1 r
.47111 .35491 m
.47799 .34578 L
s
.47799 .34578 m
.51933 .35326 L
s
.351 .078 .033 r
.35015 .62302 m .36734 .62545 L .38257 .63468 L p F P
0 0 0 r
s
.24 .35 .67 r
.3503 .62554 m
.35108 .62336 L
s
.351 .078 .033 r
.39769 .6368 m .38257 .63468 L .36734 .62545 L p F P
0 0 0 r
s
.045 .065 .149 r
.33744 .51405 m .34136 .50157 L .34188 .52083 L p F P
0 0 0 r
s
.24 .35 .67 r
.33757 .51861 m
.3385 .51566 L
s
.045 .065 .149 r
.34188 .52083 m .33797 .53307 L .33744 .51405 L p F P
0 0 0 r
s
.256 .059 .025 r
.45755 .64521 m .47237 .64728 L .47669 .65136 L p F P
0 0 0 r
s
.256 .059 .025 r
.48914 .6531 m .47669 .65136 L .47237 .64728 L p F P
0 0 0 r
s
.33 .49 .916 r
.40477 .38033 m .40803 .37053 L .39349 .3773 L p F P
0 0 0 r
s
.24 .35 .67 r
.40503 .39738 m
.41415 .3704 L
s
.33 .49 .916 r
.39349 .3773 m .38983 .38858 L .40477 .38033 L p F P
0 0 0 r
s
.543 .18 .079 r
.61735 .36541 m .60266 .36273 L .58423 .36064 L p F P
0 0 0 r
s
.543 .18 .079 r
.5721 .35843 m .58423 .36064 L .60266 .36273 L p F P
0 0 0 r
s
.776 .244 .106 r
.47358 .34054 m .46108 .33827 L .47043 .34497 L p F P
0 0 0 r
s
.24 .35 .67 r
.47297 .34043 m
.47737 .32866 L
s
.776 .244 .106 r
.46092 .34324 m .47043 .34497 L .46108 .33827 L p F P
0 0 0 r
s
.024 .035 .067 r
.63259 .57727 m .62631 .5878 L .63346 .57155 L p F P
0 0 0 r
s
.024 .035 .067 r
.63346 .57155 m .64018 .56026 L .63259 .57727 L p F P
0 0 0 r
s
.24 .35 .67 r
.33937 .56124 m
.34151 .56839 L
s
.317 .477 .891 r
.57419 .64399 m .5704 .65055 L .58346 .64632 L p F P
0 0 0 r
s
.317 .477 .891 r
.58346 .64632 m .58807 .6385 L .57419 .64399 L p F P
0 0 0 r
s
.028 .04 .082 r
.64703 .54874 m .64018 .56026 L .6442 .5421 L p F P
0 0 0 r
s
.24 .35 .67 r
.62806 .57115 m
.64184 .54777 L
s
.64184 .54777 m
.64325 .52303 L
s
.028 .04 .082 r
.6442 .5421 m .65129 .53005 L .64703 .54874 L p F P
0 0 0 r
s
.252 .38 .679 r
.61587 .6022 m .6103 .61156 L .62015 .59813 L p F P
0 0 0 r
s
.252 .38 .679 r
.62015 .59813 m .62631 .5878 L .61587 .6022 L p F P
0 0 0 r
s
.024 .035 .067 r
.34471 .48262 m .34866 .46994 L .34536 .48882 L p F P
0 0 0 r
s
.024 .035 .067 r
.34536 .48882 m .34136 .50157 L .34471 .48262 L p F P
0 0 0 r
s
.83 .24 .1 r
.17357 .58194 m
.21671 .58812 L
s
.21671 .58812 m
.21568 .60257 L
s
.60917 .36547 m
.62476 .3683 L
s
.351 .078 .033 r
.38257 .63468 m .3674 .63255 L .35015 .62302 L p F P
0 0 0 r
s
.163 .246 .524 r
.35015 .62302 m .35343 .61386 L .37043 .62452 L p F P
0 0 0 r
s
.83 .24 .1 r
.3703 .62444 m
.38653 .62674 L
s
.163 .246 .524 r
.37043 .62452 m .3674 .63255 L .35015 .62302 L p F P
0 0 0 r
s
.24 .35 .67 r
.3503 .62554 m
.36967 .64822 L
s
.332 .492 .931 r
.42728 .35887 m .43013 .35058 L .41471 .35048 L p F P
0 0 0 r
s
.332 .492 .931 r
.41471 .35048 m .41135 .36058 L .42728 .35887 L p F P
0 0 0 r
s
.776 .244 .106 r
.46108 .33827 m .44854 .33599 L .46092 .34324 L p F P
0 0 0 r
s
.776 .244 .106 r
.45138 .34152 m .46092 .34324 L .44854 .33599 L p F P
0 0 0 r
s
.83 .24 .1 r
.6052 .66802 m
.64594 .67373 L
s
.64594 .67373 m
.65627 .67053 L
s
.193 .286 .592 r
.6529 .37447 m .64701 .3858 L .62705 .3779 L p F P
0 0 0 r
s
.193 .286 .592 r
.62705 .3779 m .63199 .36807 L .6529 .37447 L p F P
0 0 0 r
s
.24 .35 .67 r
.6185 .37739 m
.6395 .39856 L
s
.83 .24 .1 r
.64439 .37186 m
.64988 .37286 L
s
.256 .059 .025 r
.44268 .64312 m .45755 .64521 L .4642 .64961 L p F P
0 0 0 r
s
.256 .059 .025 r
.47669 .65136 m .4642 .64961 L .45755 .64521 L p F P
0 0 0 r
s
.83 .24 .1 r
.47399 .64756 m
.51536 .65336 L
s
.46913 .63843 m
.47399 .64756 L
s
.21773 .30939 m
.2147 .32524 L
s
.543 .18 .079 r
.60266 .36273 m .5879 .36005 L .5721 .35843 L p F P
0 0 0 r
s
.543 .18 .079 r
.55993 .35622 m .5721 .35843 L .5879 .36005 L p F P
0 0 0 r
s
.049 .072 .169 r
.65853 .51775 m .65129 .53005 L .65179 .51097 L p F P
0 0 0 r
s
.049 .072 .169 r
.65179 .51097 m .65906 .49843 L .65853 .51775 L p F P
0 0 0 r
s
.318 .471 .867 r
.38624 .39967 m .38983 .38858 L .37731 .3998 L p F P
0 0 0 r
s
.318 .471 .867 r
.37731 .3998 m .37343 .41202 L .38624 .39967 L p F P
0 0 0 r
s
.83 .24 .1 r
.35116 .32282 m
.34654 .33253 L
s
.30408 .3249 m
.34654 .33253 L
s
.30206 .61479 m
.34453 .6208 L
s
.34453 .6208 m
.34705 .62974 L
s
.238 .35 .612 r
.35559 .45213 m .35951 .43961 L .35269 .45699 L p F P
0 0 0 r
s
.238 .35 .612 r
.35269 .45699 m .34866 .46994 L .35559 .45213 L p F P
0 0 0 r
s
.323 .486 .92 r
.55231 .65621 m .54947 .66124 L .56294 .66343 L p F P
0 0 0 r
s
.323 .486 .92 r
.56294 .66343 m .56665 .65703 L .55231 .65621 L p F P
0 0 0 r
s
.512 .17 .075 r
.55074 .66172 m .56294 .66343 L .54947 .66124 L p F P
0 0 0 r
s
.24 .35 .67 r
.55055 .6662 m
.55638 .66316 L
s
.55638 .66316 m
.55744 .66261 L
s
.83 .24 .1 r
.56175 .66134 m
.56209 .66148 L
s
.56209 .66148 m
.56399 .66225 L
s
.776 .244 .106 r
.44854 .33599 m .43595 .3337 L .45138 .34152 L p F P
0 0 0 r
s
.24 .35 .67 r
.44817 .33592 m
.4492 .33299 L
s
.43927 .36102 m
.44718 .33872 L
s
.288 .426 .769 r
.36963 .42402 m .37343 .41202 L .36351 .42683 L p F P
0 0 0 r
s
.288 .426 .769 r
.36351 .42683 m .35951 .43961 L .36963 .42402 L p F P
0 0 0 r
s
.24 .35 .67 r
.36724 .4297 m
.38387 .41145 L
s
.35907 .45555 m
.36724 .4297 L
s
.45138 .69219 m
.48187 .69627 L
s
.48187 .69627 m
.49281 .67509 L
s
.543 .18 .079 r
.5879 .36005 m .57309 .35736 L .55993 .35622 L p F P
0 0 0 r
s
.83 .24 .1 r
.5602 .36066 m
.56801 .35799 L
s
.543 .18 .079 r
.54772 .354 m .55993 .35622 L .57309 .35736 L p F P
0 0 0 r
s
.295 .444 .814 r
.59749 .62251 m .59274 .63057 L .60483 .62076 L p F P
0 0 0 r
s
.295 .444 .814 r
.60483 .62076 m .6103 .61156 L .59749 .62251 L p F P
0 0 0 r
s
.24 .35 .67 r
.60675 .6146 m
.62036 .59422 L
s
.83 .24 .1 r
.78912 .41007 m
.77989 .39903 L
s
.73982 .39177 m
.77989 .39903 L
s
.7378 .68201 m
.77788 .68765 L
s
.79089 .67818 m
.77788 .68765 L
s
.256 .059 .025 r
.42774 .64102 m .44268 .64312 L .45167 .64786 L p F P
0 0 0 r
s
.256 .059 .025 r
.4642 .64961 m .45167 .64786 L .44268 .64312 L p F P
0 0 0 r
s
.067 .097 .237 r
.66649 .48561 m .65906 .49843 L .65569 .47949 L p F P
0 0 0 r
s
.067 .097 .237 r
.65569 .47949 m .66292 .46675 L .66649 .48561 L p F P
0 0 0 r
s
.24 .35 .67 r
.65252 .47305 m
.65747 .49844 L
s
.36967 .64822 m
.39381 .66753 L
s
.167 .247 .522 r
.66377 .39672 m .65716 .40901 L .64122 .39693 L p F P
0 0 0 r
s
.167 .247 .522 r
.64122 .39693 m .64701 .3858 L .66377 .39672 L p F P
0 0 0 r
s
.83 .24 .1 r
.44462 .33974 m
.47799 .34578 L
s
.512 .17 .075 r
.5385 .66001 m .55074 .66172 L .53986 .6599 L p F P
0 0 0 r
s
.512 .17 .075 r
.54947 .66124 m .53986 .6599 L .55074 .66172 L p F P
0 0 0 r
s
.098 .143 .332 r
.67031 .45373 m .66292 .46675 L .65544 .44904 L p F P
0 0 0 r
s
.098 .143 .332 r
.65544 .44904 m .66241 .43645 L .67031 .45373 L p F P
0 0 0 r
s
.543 .18 .079 r
.57309 .35736 m .55822 .35465 L .54772 .354 L p F P
0 0 0 r
s
.543 .18 .079 r
.53546 .35178 m .54772 .354 L .55822 .35465 L p F P
0 0 0 r
s
.24 .35 .67 r
.47737 .32866 m
.48823 .29958 L
s
.47737 .32866 m
.4492 .33299 L
s
.136 .2 .437 r
.66952 .42361 m .66241 .43645 L .65068 .42106 L p F P
0 0 0 r
s
.136 .2 .437 r
.65068 .42106 m .65716 .40901 L .66952 .42361 L p F P
0 0 0 r
s
.24 .35 .67 r
.6395 .39856 m
.65594 .4221 L
s
.64176 .44825 m
.65594 .4221 L
s
.256 .059 .025 r
.41275 .63892 m .42774 .64102 L .4391 .6461 L p F P
0 0 0 r
s
.256 .059 .025 r
.45167 .64786 m .4391 .6461 L .42774 .64102 L p F P
0 0 0 r
s
.512 .17 .075 r
.52622 .65829 m .5385 .66001 L .53024 .65855 L p F P
0 0 0 r
s
.512 .17 .075 r
.53986 .6599 m .53024 .65855 L .5385 .66001 L p F P
0 0 0 r
s
.543 .18 .079 r
.55822 .35465 m .54328 .35194 L .53546 .35178 L p F P
0 0 0 r
s
.543 .18 .079 r
.52317 .34955 m .53546 .35178 L .54328 .35194 L p F P
0 0 0 r
s
.83 .24 .1 r
.17357 .58194 m
.17175 .59635 L
s
.56399 .66225 m
.6052 .66802 L
s
.6052 .66802 m
.6148 .6647 L
s
.33 .49 .916 r
.40803 .37053 m .41135 .36058 L .3972 .36583 L p F P
0 0 0 r
s
.33 .49 .916 r
.3972 .36583 m .39349 .3773 L .40803 .37053 L p F P
0 0 0 r
s
.24 .35 .67 r
.42152 .68245 m
.45138 .69219 L
s
.45138 .69219 m
.46172 .67083 L
s
.332 .492 .931 r
.43013 .35058 m .43302 .3422 L .41813 .34023 L p F P
0 0 0 r
s
.332 .492 .931 r
.41813 .34023 m .41471 .35048 L .43013 .35058 L p F P
0 0 0 r
s
.24 .35 .67 r
.39381 .66753 m
.40292 .64564 L
s
.39381 .66753 m
.42152 .68245 L
s
.256 .059 .025 r
.39769 .6368 m .41275 .63892 L .42649 .64434 L p F P
0 0 0 r
s
.256 .059 .025 r
.4391 .6461 m .42649 .64434 L .41275 .63892 L p F P
0 0 0 r
s
.83 .24 .1 r
.43215 .64168 m
.47399 .64756 L
s
.42806 .63262 m
.43215 .64168 L
s
.512 .17 .075 r
.5139 .65657 m .52622 .65829 L .52059 .6572 L p F P
0 0 0 r
s
.512 .17 .075 r
.53024 .65855 m .52059 .6572 L .52622 .65829 L p F P
0 0 0 r
s
.085 .126 .306 r
.33876 .56309 m .34253 .55162 L .35111 .56923 L p F P
0 0 0 r
s
.085 .126 .306 r
.35111 .56923 m .34747 .57991 L .33876 .56309 L p F P
0 0 0 r
s
.83 .24 .1 r
.30791 .31499 m
.30408 .3249 L
s
.26115 .31719 m
.30408 .3249 L
s
.25912 .60871 m
.30206 .61479 L
s
.30206 .61479 m
.30377 .62367 L
s
.125 .189 .421 r
.34389 .59039 m .34747 .57991 L .36016 .59506 L p F P
0 0 0 r
s
.125 .189 .421 r
.36016 .59506 m .35676 .60454 L .34389 .59039 L p F P
0 0 0 r
s
.317 .477 .891 r
.57804 .63735 m .57419 .64399 L .58807 .6385 L p F P
0 0 0 r
s
.317 .477 .891 r
.58807 .6385 m .59274 .63057 L .57804 .63735 L p F P
0 0 0 r
s
.543 .18 .079 r
.54328 .35194 m .52829 .34921 L .52317 .34955 L p F P
0 0 0 r
s
.83 .24 .1 r
.51933 .35326 m
.52637 .35043 L
s
.543 .18 .079 r
.51083 .34731 m .52317 .34955 L .52829 .34921 L p F P
0 0 0 r
s
.065 .095 .231 r
.33797 .53307 m .34188 .52083 L .34638 .53992 L p F P
0 0 0 r
s
.065 .095 .231 r
.34638 .53992 m .34253 .55162 L .33797 .53307 L p F P
0 0 0 r
s
.24 .35 .67 r
.42152 .68245 m
.43123 .66085 L
s
.323 .486 .92 r
.55518 .65113 m .55231 .65621 L .56665 .65703 L p F P
0 0 0 r
s
.323 .486 .92 r
.56665 .65703 m .5704 .65055 L .55518 .65113 L p F P
0 0 0 r
s
.24 .35 .67 r
.52292 .67348 m
.55055 .6662 L
s
.55055 .6662 m
.55301 .66186 L
s
.24 .056 .023 r
.61735 .36541 m .63199 .36807 L .6529 .37447 L p F P
0 0 0 r
s
.24 .35 .67 r
.62385 .36659 m
.62413 .36602 L
s
.83 .24 .1 r
.74837 .40273 m
.73982 .39177 L
s
.69929 .38442 m
.73982 .39177 L
s
.69727 .6763 m
.7378 .68201 L
s
.7378 .68201 m
.75016 .67239 L
s
.512 .17 .075 r
.50154 .65484 m .5139 .65657 L .51091 .65585 L p F P
0 0 0 r
s
.512 .17 .075 r
.52059 .6572 m .51091 .65585 L .5139 .65657 L p F P
0 0 0 r
s
.83 .24 .1 r
.51536 .65336 m
.52232 .65641 L
s
.256 .059 .025 r
.38257 .63468 m .39769 .6368 L .41383 .64257 L p F P
0 0 0 r
s
.256 .059 .025 r
.42649 .64434 m .41383 .64257 L .39769 .6368 L p F P
0 0 0 r
s
.163 .246 .524 r
.35343 .61386 m .35676 .60454 L .3735 .61637 L p F P
0 0 0 r
s
.24 .35 .67 r
.35429 .6144 m
.35444 .61399 L
s
.163 .246 .524 r
.3735 .61637 m .37043 .62452 L .35343 .61386 L p F P
0 0 0 r
s
.543 .18 .079 r
.52829 .34921 m .51323 .34648 L .51083 .34731 L p F P
0 0 0 r
s
.543 .18 .079 r
.49846 .34506 m .51083 .34731 L .51323 .34648 L p F P
0 0 0 r
s
.045 .065 .149 r
.34136 .50157 m .34536 .48882 L .34588 .50833 L p F P
0 0 0 r
s
.24 .35 .67 r
.34148 .50618 m
.34243 .50318 L
s
.34539 .4898 m
.348 .47723 L
s
.045 .065 .149 r
.34588 .50833 m .34188 .52083 L .34136 .50157 L p F P
0 0 0 r
s
.024 .035 .067 r
.63899 .56654 m .63259 .57727 L .64018 .56026 L p F P
0 0 0 r
s
.024 .035 .067 r
.64018 .56026 m .64703 .54874 L .63899 .56654 L p F P
0 0 0 r
s
.24 .35 .67 r
.63415 .57104 m
.64184 .54777 L
s
.252 .38 .679 r
.62154 .59267 m .61587 .6022 L .62631 .5878 L p F P
0 0 0 r
s
.252 .38 .679 r
.62631 .5878 m .63259 .57727 L .62154 .59267 L p F P
0 0 0 r
s
.24 .35 .67 r
.62036 .59422 m
.63415 .57104 L
s
.318 .471 .867 r
.38983 .38858 m .39349 .3773 L .38126 .38733 L p F P
0 0 0 r
s
.24 .35 .67 r
.39264 .38445 m
.41415 .3704 L
s
.318 .471 .867 r
.38126 .38733 m .37731 .3998 L .38983 .38858 L p F P
0 0 0 r
s
.24 .35 .67 r
.38387 .41145 m
.39264 .38445 L
s
.512 .17 .075 r
.48914 .6531 m .50154 .65484 L .50121 .65449 L p F P
0 0 0 r
s
.512 .17 .075 r
.51091 .65585 m .50121 .65449 L .50154 .65484 L p F P
0 0 0 r
s
.24 .056 .023 r
.6529 .37447 m .63599 .3714 L .61735 .36541 L p F P
0 0 0 r
s
.24 .056 .023 r
.60266 .36273 m .61735 .36541 L .63599 .3714 L p F P
0 0 0 r
s
.83 .24 .1 r
.56801 .35799 m
.60917 .36547 L
s
.028 .04 .082 r
.65402 .53697 m .64703 .54874 L .65129 .53005 L p F P
0 0 0 r
s
.028 .04 .082 r
.65129 .53005 m .65853 .51775 L .65402 .53697 L p F P
0 0 0 r
s
.24 .35 .67 r
.64325 .52303 m
.65747 .49844 L
s
.024 .035 .067 r
.34866 .46994 m .35269 .45699 L .34945 .4758 L p F P
0 0 0 r
s
.24 .35 .67 r
.348 .47723 m
.34915 .47356 L
s
.024 .035 .067 r
.34945 .4758 m .34536 .48882 L .34866 .46994 L p F P
0 0 0 r
s
.256 .059 .025 r
.3674 .63255 m .38257 .63468 L .40113 .64079 L p F P
0 0 0 r
s
.256 .059 .025 r
.41383 .64257 m .40113 .64079 L .38257 .63468 L p F P
0 0 0 r
s
.543 .18 .079 r
.51323 .34648 m .49812 .34373 L .49846 .34506 L p F P
0 0 0 r
s
.543 .18 .079 r
.48604 .3428 m .49846 .34506 L .49812 .34373 L p F P
0 0 0 r
s
.295 .444 .814 r
.60231 .61433 m .59749 .62251 L .6103 .61156 L p F P
0 0 0 r
s
.295 .444 .814 r
.6103 .61156 m .61587 .6022 L .60231 .61433 L p F P
0 0 0 r
s
.288 .426 .769 r
.37343 .41202 m .37731 .3998 L .36759 .41378 L p F P
0 0 0 r
s
.288 .426 .769 r
.36759 .41378 m .36351 .42683 L .37343 .41202 L p F P
0 0 0 r
s
.238 .35 .612 r
.35951 .43961 m .36351 .42683 L .35682 .44377 L p F P
0 0 0 r
s
.238 .35 .612 r
.35682 .44377 m .35269 .45699 L .35951 .43961 L p F P
0 0 0 r
s
.24 .35 .67 r
.35605 .45151 m
.36724 .4297 L
s
.35068 .46867 m
.35605 .45151 L
s
.049 .072 .169 r
.66593 .50518 m .65853 .51775 L .65906 .49843 L p F P
0 0 0 r
s
.049 .072 .169 r
.65906 .49843 m .66649 .48561 L .66593 .50518 L p F P
0 0 0 r
s
.512 .17 .075 r
.47669 .65136 m .48914 .6531 L .49148 .65313 L p F P
0 0 0 r
s
.512 .17 .075 r
.50121 .65449 m .49148 .65313 L .48914 .6531 L p F P
0 0 0 r
s
.83 .24 .1 r
.55566 .66108 m
.56399 .66225 L
s
.52232 .65641 m
.55 .66029 L
s
.56399 .66225 m
.57286 .6588 L
s
.167 .247 .522 r
.6705 .38419 m .66377 .39672 L .64701 .3858 L p F P
0 0 0 r
s
.167 .247 .522 r
.64701 .3858 m .6529 .37447 L .6705 .38419 L p F P
0 0 0 r
s
.83 .24 .1 r
.64988 .37286 m
.65831 .377 L
s
.24 .056 .023 r
.63599 .3714 m .619 .36832 L .60266 .36273 L p F P
0 0 0 r
s
.24 .35 .67 r
.62413 .36602 m
.63228 .34956 L
s
.24 .056 .023 r
.5879 .36005 m .60266 .36273 L .619 .36832 L p F P
0 0 0 r
s
.543 .18 .079 r
.49812 .34373 m .48294 .34097 L .48604 .3428 L p F P
0 0 0 r
s
.543 .18 .079 r
.47358 .34054 m .48604 .3428 L .48294 .34097 L p F P
0 0 0 r
s
.83 .24 .1 r
.47799 .34578 m
.48426 .34278 L
s
.26417 .30707 m
.26115 .31719 L
s
.21773 .30939 m
.26115 .31719 L
s
.21568 .60257 m
.25912 .60871 L
s
.25912 .60871 m
.25999 .61752 L
s
.256 .059 .025 r
.40113 .64079 m .38839 .63901 L .3674 .63255 L p F P
0 0 0 r
s
.194 .292 .608 r
.3674 .63255 m .37043 .62452 L .39107 .6323 L p F P
0 0 0 r
s
.83 .24 .1 r
.38653 .62674 m
.38817 .63121 L
s
.194 .292 .608 r
.39107 .6323 m .38839 .63901 L .3674 .63255 L p F P
0 0 0 r
s
.83 .24 .1 r
.38977 .63555 m
.38984 .63575 L
s
.24 .35 .67 r
.36967 .64822 m
.37465 .6353 L
s
.37465 .6353 m
.37483 .63484 L
s
.83 .24 .1 r
.38984 .63575 m
.43215 .64168 L
s
.24 .35 .67 r
.44348 .33507 m
.4492 .33299 L
s
.332 .492 .931 r
.43302 .3422 m .43595 .3337 L .42159 .32981 L p F P
0 0 0 r
s
.332 .492 .931 r
.42159 .32981 m .41813 .34023 L .43302 .3422 L p F P
0 0 0 r
s
.83 .24 .1 r
.39391 .33056 m
.41979 .33524 L
s
.24 .35 .67 r
.60699 .33121 m
.5789 .31658 L
s
.5789 .31658 m
.59205 .28698 L
s
.5789 .31658 m
.54902 .30619 L
s
.067 .097 .237 r
.67407 .47251 m .66649 .48561 L .66292 .46675 L p F P
0 0 0 r
s
.067 .097 .237 r
.66292 .46675 m .67031 .45373 L .67407 .47251 L p F P
0 0 0 r
s
.512 .17 .075 r
.4642 .64961 m .47669 .65136 L .48173 .65176 L p F P
0 0 0 r
s
.512 .17 .075 r
.49148 .65313 m .48173 .65176 L .47669 .65136 L p F P
0 0 0 r
s
.33 .49 .916 r
.41135 .36058 m .41471 .35048 L .40098 .35415 L p F P
0 0 0 r
s
.33 .49 .916 r
.40098 .35415 m .3972 .36583 L .41135 .36058 L p F P
0 0 0 r
s
.136 .2 .437 r
.67677 .41049 m .66952 .42361 L .65716 .40901 L p F P
0 0 0 r
s
.136 .2 .437 r
.65716 .40901 m .66377 .39672 L .67677 .41049 L p F P
0 0 0 r
s
.83 .24 .1 r
.70715 .39532 m
.69929 .38442 L
s
.65831 .377 m
.69929 .38442 L
s
.65627 .67053 m
.69727 .6763 L
s
.69727 .6763 m
.70897 .66653 L
s
.098 .143 .332 r
.67785 .44044 m .67031 .45373 L .66241 .43645 L p F P
0 0 0 r
s
.24 .35 .67 r
.65252 .47305 m
.66707 .44716 L
s
.098 .143 .332 r
.66241 .43645 m .66952 .42361 L .67785 .44044 L p F P
0 0 0 r
s
.24 .35 .67 r
.65594 .4221 m
.66707 .44716 L
s
.543 .18 .079 r
.48294 .34097 m .4677 .3382 L .47358 .34054 L p F P
0 0 0 r
s
.543 .18 .079 r
.46108 .33827 m .47358 .34054 L .4677 .3382 L p F P
0 0 0 r
s
.24 .056 .023 r
.619 .36832 m .60193 .36522 L .5879 .36005 L p F P
0 0 0 r
s
.83 .24 .1 r
.6123 .3671 m
.61686 .36948 L
s
.24 .056 .023 r
.57309 .35736 m .5879 .36005 L .60193 .36522 L p F P
0 0 0 r
s
.24 .35 .67 r
.59438 .35804 m
.60699 .33121 L
s
.59378 .35932 m
.59438 .35804 L
s
.63228 .34956 m
.60699 .33121 L
s
.60699 .33121 m
.62076 .30189 L
s
.323 .486 .92 r
.55807 .646 m .55518 .65113 L .5704 .65055 L p F P
0 0 0 r
s
.323 .486 .92 r
.5704 .65055 m .57419 .64399 L .55807 .646 L p F P
0 0 0 r
s
.24 .35 .67 r
.54902 .30619 m
.56155 .27632 L
s
.54902 .30619 m
.51843 .30044 L
s
.317 .477 .891 r
.58193 .63062 m .57804 .63735 L .59274 .63057 L p F P
0 0 0 r
s
.317 .477 .891 r
.59274 .63057 m .59749 .62251 L .58193 .63062 L p F P
0 0 0 r
s
.83 .24 .1 r
.39858 .32722 m
.39391 .33056 L
s
.35116 .32282 m
.39391 .33056 L
s
.37221 .63327 m
.37358 .63346 L
s
.3897 .63573 m
.38984 .63575 L
s
.82941 .41731 m
.83742 .43474 L
s
.78912 .41007 m
.82941 .41731 L
s
.512 .17 .075 r
.45167 .64786 m .4642 .64961 L .47195 .6504 L p F P
0 0 0 r
s
.512 .17 .075 r
.48173 .65176 m .47195 .6504 L .4642 .64961 L p F P
0 0 0 r
s
.83 .24 .1 r
.47399 .64756 m
.48018 .65051 L
s
.543 .18 .079 r
.4677 .3382 m .45239 .33541 L .46108 .33827 L p F P
0 0 0 r
s
.543 .18 .079 r
.44854 .33599 m .46108 .33827 L .45239 .33541 L p F P
0 0 0 r
s
.24 .056 .023 r
.60193 .36522 m .58478 .36211 L .57309 .35736 L p F P
0 0 0 r
s
.24 .056 .023 r
.55822 .35465 m .57309 .35736 L .58478 .36211 L p F P
0 0 0 r
s
.83 .24 .1 r
.52637 .35043 m
.56801 .35799 L
s
.125 .189 .421 r
.34747 .57991 m .35111 .56923 L .36361 .58541 L p F P
0 0 0 r
s
.125 .189 .421 r
.36361 .58541 m .36016 .59506 L .34747 .57991 L p F P
0 0 0 r
s
.24 .35 .67 r
.49281 .67509 m
.52292 .67348 L
s
.512 .17 .075 r
.4391 .6461 m .45167 .64786 L .46214 .64902 L p F P
0 0 0 r
s
.512 .17 .075 r
.47195 .6504 m .46214 .64902 L .45167 .64786 L p F P
0 0 0 r
s
.085 .126 .306 r
.34253 .55162 m .34638 .53992 L .35483 .55834 L p F P
0 0 0 r
s
.085 .126 .306 r
.35483 .55834 m .35111 .56923 L .34253 .55162 L p F P
0 0 0 r
s
.543 .18 .079 r
.45239 .33541 m .43703 .33262 L .44854 .33599 L p F P
0 0 0 r
s
.543 .18 .079 r
.43595 .3337 m .44854 .33599 L .43703 .33262 L p F P
0 0 0 r
s
.83 .24 .1 r
.43773 .33732 m
.44166 .33505 L
s
.24 .35 .67 r
.42364 .34228 m
.44194 .33563 L
s
.163 .246 .524 r
.35676 .60454 m .36016 .59506 L .37662 .6081 L p F P
0 0 0 r
s
.24 .35 .67 r
.35761 .60514 m
.35776 .60472 L
s
.163 .246 .524 r
.37662 .6081 m .3735 .61637 L .35676 .60454 L p F P
0 0 0 r
s
.24 .35 .67 r
.63228 .34956 m
.64665 .32053 L
s
.065 .095 .231 r
.34188 .52083 m .34588 .50833 L .3503 .52798 L p F P
0 0 0 r
s
.065 .095 .231 r
.3503 .52798 m .34638 .53992 L .34188 .52083 L p F P
0 0 0 r
s
.24 .056 .023 r
.58478 .36211 m .56755 .35898 L .55822 .35465 L p F P
0 0 0 r
s
.24 .056 .023 r
.54328 .35194 m .55822 .35465 L .56755 .35898 L p F P
0 0 0 r
s
.83 .24 .1 r
.21992 .29906 m
.21773 .30939 L
s
.17175 .59635 m
.21568 .60257 L
s
.21568 .60257 m
.21571 .61131 L
s
.318 .471 .867 r
.39349 .3773 m .3972 .36583 L .38529 .37462 L p F P
0 0 0 r
s
.318 .471 .867 r
.38529 .37462 m .38126 .38733 L .39349 .3773 L p F P
0 0 0 r
s
.512 .17 .075 r
.42649 .64434 m .4391 .6461 L .45231 .64765 L p F P
0 0 0 r
s
.512 .17 .075 r
.46214 .64902 m .45231 .64765 L .4391 .6461 L p F P
0 0 0 r
s
.24 .35 .67 r
.51843 .30044 m
.53035 .27032 L
s
.51843 .30044 m
.48823 .29958 L
s
.252 .38 .679 r
.6273 .58298 m .62154 .59267 L .63259 .57727 L p F P
0 0 0 r
s
.252 .38 .679 r
.63259 .57727 m .63899 .56654 L .6273 .58298 L p F P
0 0 0 r
s
.24 .35 .67 r
.6203 .59173 m
.63415 .57104 L
s
.319 .48 .919 r
.53618 .6514 m .53426 .65491 L .54947 .66124 L p F P
0 0 0 r
s
.319 .48 .919 r
.54947 .66124 m .55231 .65621 L .53618 .6514 L p F P
0 0 0 r
s
.752 .239 .103 r
.53986 .6599 m .54947 .66124 L .53426 .65491 L p F P
0 0 0 r
s
.543 .18 .079 r
.43703 .33262 m .42159 .32981 L .43595 .3337 L p F P
0 0 0 r
s
.024 .035 .067 r
.64552 .5556 m .63899 .56654 L .64703 .54874 L p F P
0 0 0 r
s
.024 .035 .067 r
.64703 .54874 m .65402 .53697 L .64552 .5556 L p F P
0 0 0 r
s
.83 .24 .1 r
.65707 .37677 m
.65831 .377 L
s
.6148 .6647 m
.65627 .67053 L
s
.65627 .67053 m
.66731 .6606 L
s
.295 .444 .814 r
.6072 .60602 m .60231 .61433 L .61587 .6022 L p F P
0 0 0 r
s
.295 .444 .814 r
.61587 .6022 m .62154 .59267 L .6072 .60602 L p F P
0 0 0 r
s
.24 .35 .67 r
.61752 .59641 m
.6203 .59173 L
s
.045 .065 .149 r
.34536 .48882 m .34945 .4758 L .34996 .49556 L p F P
0 0 0 r
s
.24 .35 .67 r
.34548 .49349 m
.34645 .49042 L
s
.34957 .48053 m
.35098 .47604 L
s
.045 .065 .149 r
.34996 .49556 m .34588 .50833 L .34536 .48882 L p F P
0 0 0 r
s
.512 .17 .075 r
.41383 .64257 m .42649 .64434 L .44246 .64627 L p F P
0 0 0 r
s
.512 .17 .075 r
.45231 .64765 m .44246 .64627 L .42649 .64434 L p F P
0 0 0 r
s
.83 .24 .1 r
.75016 .67239 m
.79089 .67818 L
s
.80387 .6622 m
.79089 .67818 L
s
.24 .056 .023 r
.56755 .35898 m .55024 .35584 L .54328 .35194 L p F P
0 0 0 r
s
.24 .056 .023 r
.52829 .34921 m .54328 .35194 L .55024 .35584 L p F P
0 0 0 r
s
.194 .292 .608 r
.37043 .62452 m .3735 .61637 L .39378 .62551 L p F P
0 0 0 r
s
.194 .292 .608 r
.39378 .62551 m .39107 .6323 L .37043 .62452 L p F P
0 0 0 r
s
.83 .24 .1 r
.34705 .62974 m
.37221 .63327 L
s
.35499 .31931 m
.35116 .32282 L
s
.30791 .31499 m
.35116 .32282 L
s
.752 .239 .103 r
.53024 .65855 m .53986 .6599 L .5276 .65397 L p F P
0 0 0 r
s
.752 .239 .103 r
.53426 .65491 m .5276 .65397 L .53986 .6599 L p F P
0 0 0 r
s
.24 .35 .67 r
.53109 .65848 m
.53279 .65537 L
s
.323 .486 .92 r
.561 .64081 m .55807 .646 L .57419 .64399 L p F P
0 0 0 r
s
.323 .486 .92 r
.57419 .64399 m .57804 .63735 L .561 .64081 L p F P
0 0 0 r
s
.24 .35 .67 r
.57536 .63789 m
.57873 .63616 L
s
.347 .077 .032 r
.63599 .3714 m .6529 .37447 L .6705 .38419 L p F P
0 0 0 r
s
.83 .24 .1 r
.65831 .377 m
.65879 .37772 L
s
.24 .35 .67 r
.65196 .37458 m
.65203 .37444 L
s
.6395 .39856 m
.65077 .37688 L
s
.83 .24 .1 r
.30377 .62367 m
.34705 .62974 L
s
.34705 .62974 m
.3508 .63239 L
s
.7965 .42747 m
.78912 .41007 L
s
.74837 .40273 m
.78912 .41007 L
s
.028 .04 .082 r
.66115 .52497 m .65402 .53697 L .65853 .51775 L p F P
0 0 0 r
s
.24 .35 .67 r
.64184 .54777 m
.6562 .5234 L
s
.6562 .5234 m
.65747 .49844 L
s
.028 .04 .082 r
.65853 .51775 m .66593 .50518 L .66115 .52497 L p F P
0 0 0 r
s
.288 .426 .769 r
.37731 .3998 m .38126 .38733 L .37176 .40046 L p F P
0 0 0 r
s
.288 .426 .769 r
.37176 .40046 m .36759 .41378 L .37731 .3998 L p F P
0 0 0 r
s
.24 .35 .67 r
.37577 .40276 m
.39264 .38445 L
s
.024 .035 .067 r
.35269 .45699 m .35682 .44377 L .35362 .46248 L p F P
0 0 0 r
s
.024 .035 .067 r
.35362 .46248 m .34945 .4758 L .35269 .45699 L p F P
0 0 0 r
s
.24 .35 .67 r
.35098 .47604 m
.35605 .45151 L
s
.33 .49 .916 r
.41471 .35048 m .41813 .34023 L .40483 .34226 L p F P
0 0 0 r
s
.33 .49 .916 r
.40483 .34226 m .40098 .35415 L .41471 .35048 L p F P
0 0 0 r
s
.24 .35 .67 r
.41415 .3704 m
.42364 .34228 L
s
.238 .35 .612 r
.36351 .42683 m .36759 .41378 L .36103 .43026 L p F P
0 0 0 r
s
.24 .35 .67 r
.36724 .4297 m
.37577 .40276 L
s
.238 .35 .612 r
.36103 .43026 m .35682 .44377 L .36351 .42683 L p F P
0 0 0 r
s
.752 .239 .103 r
.52059 .6572 m .53024 .65855 L .52093 .65303 L p F P
0 0 0 r
s
.752 .239 .103 r
.5276 .65397 m .52093 .65303 L .53024 .65855 L p F P
0 0 0 r
s
.24 .35 .67 r
.52292 .67348 m
.53109 .65848 L
s
.512 .17 .075 r
.40113 .64079 m .41383 .64257 L .43257 .64489 L p F P
0 0 0 r
s
.512 .17 .075 r
.44246 .64627 m .43257 .64489 L .41383 .64257 L p F P
0 0 0 r
s
.317 .477 .891 r
.58588 .6238 m .58193 .63062 L .59749 .62251 L p F P
0 0 0 r
s
.317 .477 .891 r
.59749 .62251 m .60231 .61433 L .58588 .6238 L p F P
0 0 0 r
s
.24 .056 .023 r
.55024 .35584 m .53285 .35268 L .52829 .34921 L p F P
0 0 0 r
s
.24 .056 .023 r
.51323 .34648 m .52829 .34921 L .53285 .35268 L p F P
0 0 0 r
s
.83 .24 .1 r
.48426 .34278 m
.52486 .35016 L
s
.049 .072 .169 r
.67348 .49234 m .66593 .50518 L .66649 .48561 L p F P
0 0 0 r
s
.049 .072 .169 r
.66649 .48561 m .67407 .47251 L .67348 .49234 L p F P
0 0 0 r
s
.347 .077 .032 r
.6705 .38419 m .65168 .38079 L .63599 .3714 L p F P
0 0 0 r
s
.24 .35 .67 r
.65203 .37444 m
.65381 .37101 L
s
.347 .077 .032 r
.619 .36832 m .63599 .3714 L .65168 .38079 L p F P
0 0 0 r
s
.83 .24 .1 r
.61686 .36948 m
.62676 .37128 L
s
.24 .35 .67 r
.63228 .34956 m
.65381 .37101 L
s
.752 .239 .103 r
.51091 .65585 m .52059 .6572 L .51424 .65209 L p F P
0 0 0 r
s
.83 .24 .1 r
.48018 .65051 m
.51173 .65493 L
s
.51904 .65595 m
.52067 .65618 L
s
.752 .239 .103 r
.52093 .65303 m .51424 .65209 L .52059 .6572 L p F P
0 0 0 r
s
.24 .35 .67 r
.46172 .67083 m
.49281 .67509 L
s
.42364 .34228 m
.42738 .33123 L
s
.40179 .35629 m
.42364 .34228 L
s
.136 .2 .437 r
.68418 .39711 m .67677 .41049 L .66377 .39672 L p F P
0 0 0 r
s
.136 .2 .437 r
.66377 .39672 m .6705 .38419 L .68418 .39711 L p F P
0 0 0 r
s
.512 .17 .075 r
.38839 .63901 m .40113 .64079 L .42267 .6435 L p F P
0 0 0 r
s
.512 .17 .075 r
.43257 .64489 m .42267 .6435 L .40113 .64079 L p F P
0 0 0 r
s
.83 .24 .1 r
.43215 .64168 m
.43755 .64454 L
s
.067 .097 .237 r
.68183 .45913 m .67407 .47251 L .67031 .45373 L p F P
0 0 0 r
s
.067 .097 .237 r
.67031 .45373 m .67785 .44044 L .68183 .45913 L p F P
0 0 0 r
s
.24 .35 .67 r
.66707 .44716 m
.67229 .47279 L
s
.319 .48 .919 r
.5381 .64788 m .53618 .6514 L .55231 .65621 L p F P
0 0 0 r
s
.319 .48 .919 r
.55231 .65621 m .55518 .65113 L .5381 .64788 L p F P
0 0 0 r
s
.83 .24 .1 r
.17175 .59635 m
.1709 .60502 L
s
.24 .35 .67 r
.65381 .37101 m
.65932 .37876 L
s
.6621 .38267 m
.67073 .39482 L
s
.65381 .37101 m
.66875 .34227 L
s
.098 .143 .332 r
.68556 .42686 m .67785 .44044 L .66952 .42361 L p F P
0 0 0 r
s
.098 .143 .332 r
.66952 .42361 m .67677 .41049 L .68556 .42686 L p F P
0 0 0 r
s
.24 .35 .67 r
.65594 .4221 m
.67073 .39482 L
s
.24 .056 .023 r
.53285 .35268 m .51537 .34951 L .51323 .34648 L p F P
0 0 0 r
s
.83 .24 .1 r
.52887 .35196 m
.53251 .35419 L
s
.24 .056 .023 r
.49812 .34373 m .51323 .34648 L .51537 .34951 L p F P
0 0 0 r
s
.752 .239 .103 r
.50121 .65449 m .51091 .65585 L .50754 .65115 L p F P
0 0 0 r
s
.752 .239 .103 r
.51424 .65209 m .50754 .65115 L .51091 .65585 L p F P
0 0 0 r
s
.83 .24 .1 r
.57286 .6588 m
.6148 .6647 L
s
.6148 .6647 m
.62515 .6546 L
s
.347 .077 .032 r
.65168 .38079 m .63277 .37738 L .619 .36832 L p F P
0 0 0 r
s
.347 .077 .032 r
.60193 .36522 m .619 .36832 L .63277 .37738 L p F P
0 0 0 r
s
.512 .17 .075 r
.42267 .6435 m .41273 .64211 L .38839 .63901 L p F P
0 0 0 r
s
.22 .332 .677 r
.38839 .63901 m .39107 .6323 L .41494 .63689 L p F P
0 0 0 r
s
.22 .332 .677 r
.41494 .63689 m .41273 .64211 L .38839 .63901 L p F P
0 0 0 r
s
.83 .24 .1 r
.3933 .63782 m
.39443 .6385 L
s
.3931 .6377 m
.3933 .63782 L
s
.24 .35 .67 r
.39583 .64 m
.39691 .64086 L
s
.39691 .64086 m
.40292 .64564 L
s
.48823 .29958 m
.49958 .26924 L
s
.48823 .29958 m
.45956 .30375 L
s
.752 .239 .103 r
.49148 .65313 m .50121 .65449 L .50084 .65021 L p F P
0 0 0 r
s
.752 .239 .103 r
.50754 .65115 m .50084 .65021 L .50121 .65449 L p F P
0 0 0 r
s
.24 .35 .67 r
.49281 .67509 m
.50347 .65445 L
s
.50347 .65445 m
.50423 .65298 L
s
.83 .24 .1 r
.70897 .66653 m
.75016 .67239 L
s
.75016 .67239 m
.76258 .65622 L
s
.3109 .3113 m
.30791 .31499 L
s
.26417 .30707 m
.30791 .31499 L
s
.125 .189 .421 r
.35111 .56923 m .35483 .55834 L .36712 .57559 L p F P
0 0 0 r
s
.125 .189 .421 r
.36712 .57559 m .36361 .58541 L .35111 .56923 L p F P
0 0 0 r
s
.163 .246 .524 r
.36016 .59506 m .36361 .58541 L .37979 .5997 L p F P
0 0 0 r
s
.24 .35 .67 r
.36099 .59572 m
.36115 .59529 L
s
.163 .246 .524 r
.37979 .5997 m .37662 .6081 L .36016 .59506 L p F P
0 0 0 r
s
.83 .24 .1 r
.25999 .61752 m
.30377 .62367 L
s
.30377 .62367 m
.30667 .62621 L
s
.24 .056 .023 r
.51537 .34951 m .49781 .34632 L .49812 .34373 L p F P
0 0 0 r
s
.24 .056 .023 r
.48294 .34097 m .49812 .34373 L .49781 .34632 L p F P
0 0 0 r
s
.83 .24 .1 r
.75512 .42011 m
.74837 .40273 L
s
.70715 .39532 m
.74837 .40273 L
s
.323 .486 .92 r
.56395 .63558 m .561 .64081 L .57804 .63735 L p F P
0 0 0 r
s
.323 .486 .92 r
.57804 .63735 m .58193 .63062 L .56395 .63558 L p F P
0 0 0 r
s
.752 .239 .103 r
.48173 .65176 m .49148 .65313 L .49411 .64927 L p F P
0 0 0 r
s
.752 .239 .103 r
.50084 .65021 m .49411 .64927 L .49148 .65313 L p F P
0 0 0 r
s
.318 .471 .867 r
.3972 .36583 m .40098 .35415 L .38939 .36166 L p F P
0 0 0 r
s
.318 .471 .867 r
.38939 .36166 m .38529 .37462 L .3972 .36583 L p F P
0 0 0 r
s
.24 .35 .67 r
.39264 .38445 m
.40179 .35629 L
s
.085 .126 .306 r
.34638 .53992 m .3503 .52798 L .35862 .54724 L p F P
0 0 0 r
s
.085 .126 .306 r
.35862 .54724 m .35483 .55834 L .34638 .53992 L p F P
0 0 0 r
s
.24 .35 .67 r
.43123 .66085 m
.46172 .67083 L
s
.347 .077 .032 r
.63277 .37738 m .61375 .37395 L .60193 .36522 L p F P
0 0 0 r
s
.347 .077 .032 r
.58478 .36211 m .60193 .36522 L .61375 .37395 L p F P
0 0 0 r
s
.24 .35 .67 r
.40292 .64564 m
.40479 .64112 L
s
.40292 .64564 m
.43123 .66085 L
s
.194 .292 .608 r
.3735 .61637 m .37662 .6081 L .39653 .61863 L p F P
0 0 0 r
s
.194 .292 .608 r
.39653 .61863 m .39378 .62551 L .3735 .61637 L p F P
0 0 0 r
s
.752 .239 .103 r
.47195 .6504 m .48173 .65176 L .48738 .64832 L p F P
0 0 0 r
s
.83 .24 .1 r
.43755 .64454 m
.47573 .64989 L
s
.752 .239 .103 r
.49411 .64927 m .48738 .64832 L .48173 .65176 L p F P
0 0 0 r
s
.24 .056 .023 r
.49781 .34632 m .48017 .34312 L .48294 .34097 L p F P
0 0 0 r
s
.24 .056 .023 r
.4677 .3382 m .48294 .34097 L .48017 .34312 L p F P
0 0 0 r
s
.83 .24 .1 r
.44166 .33505 m
.47509 .34112 L
s
.295 .444 .814 r
.61217 .59759 m .6072 .60602 L .62154 .59267 L p F P
0 0 0 r
s
.295 .444 .814 r
.62154 .59267 m .6273 .58298 L .61217 .59759 L p F P
0 0 0 r
s
.252 .38 .679 r
.63317 .57312 m .6273 .58298 L .63899 .56654 L p F P
0 0 0 r
s
.252 .38 .679 r
.63899 .56654 m .64552 .5556 L .63317 .57312 L p F P
0 0 0 r
s
.83 .24 .1 r
.42529 .33207 m
.44166 .33505 L
s
.065 .095 .231 r
.34588 .50833 m .34996 .49556 L .35431 .51578 L p F P
0 0 0 r
s
.065 .095 .231 r
.35431 .51578 m .3503 .52798 L .34588 .50833 L p F P
0 0 0 r
s
.319 .48 .919 r
.54004 .64433 m .5381 .64788 L .55518 .65113 L p F P
0 0 0 r
s
.319 .48 .919 r
.55518 .65113 m .55807 .646 L .54004 .64433 L p F P
0 0 0 r
s
.83 .24 .1 r
.39443 .6385 m
.40313 .63972 L
s
.41315 .64112 m
.43755 .64454 L
s
.33 .49 .916 r
.41813 .34023 m .42159 .32981 L .40875 .33016 L p F P
0 0 0 r
s
.83 .24 .1 r
.39858 .32722 m
.41399 .33002 L
s
.33 .49 .916 r
.40875 .33016 m .40483 .34226 L .41813 .34023 L p F P
0 0 0 r
s
.24 .35 .67 r
.55671 .64587 m
.55839 .64544 L
s
.752 .239 .103 r
.46214 .64902 m .47195 .6504 L .48063 .64737 L p F P
0 0 0 r
s
.24 .35 .67 r
.46172 .67083 m
.47179 .65002 L
s
.752 .239 .103 r
.48738 .64832 m .48063 .64737 L .47195 .6504 L p F P
0 0 0 r
s
.024 .035 .067 r
.65218 .54445 m .64552 .5556 L .65402 .53697 L p F P
0 0 0 r
s
.24 .35 .67 r
.63415 .57104 m
.64853 .54685 L
s
.024 .035 .067 r
.65402 .53697 m .66115 .52497 L .65218 .54445 L p F P
0 0 0 r
s
.24 .35 .67 r
.64853 .54685 m
.6562 .5234 L
s
.317 .477 .891 r
.58987 .6169 m .58588 .6238 L .60231 .61433 L p F P
0 0 0 r
s
.317 .477 .891 r
.60231 .61433 m .6072 .60602 L .58987 .6169 L p F P
0 0 0 r
s
.347 .077 .032 r
.61375 .37395 m .59464 .3705 L .58478 .36211 L p F P
0 0 0 r
s
.347 .077 .032 r
.56755 .35898 m .58478 .36211 L .59464 .3705 L p F P
0 0 0 r
s
.24 .056 .023 r
.48017 .34312 m .46244 .33991 L .4677 .3382 L p F P
0 0 0 r
s
.24 .056 .023 r
.45239 .33541 m .4677 .3382 L .46244 .33991 L p F P
0 0 0 r
s
.045 .065 .149 r
.34945 .4758 m .35362 .46248 L .35412 .48251 L p F P
0 0 0 r
s
.045 .065 .149 r
.35412 .48251 m .34996 .49556 L .34945 .4758 L p F P
0 0 0 r
s
.288 .426 .769 r
.38126 .38733 m .38529 .37462 L .37601 .38686 L p F P
0 0 0 r
s
.288 .426 .769 r
.37601 .38686 m .37176 .40046 L .38126 .38733 L p F P
0 0 0 r
s
.24 .35 .67 r
.35486 .55826 m
.35519 .55885 L
s
.752 .239 .103 r
.45231 .64765 m .46214 .64902 L .47387 .64642 L p F P
0 0 0 r
s
.752 .239 .103 r
.48063 .64737 m .47387 .64642 L .46214 .64902 L p F P
0 0 0 r
s
.24 .35 .67 r
.47179 .65002 m
.47251 .64853 L
s
.83 .24 .1 r
.53783 .65387 m
.57286 .6588 L
s
.57286 .6588 m
.58251 .64853 L
s
.83742 .43474 m
.84301 .45788 L
s
.7965 .42747 m
.83742 .43474 L
s
.028 .04 .082 r
.66844 .51271 m .66115 .52497 L .66593 .50518 L p F P
0 0 0 r
s
.028 .04 .082 r
.66593 .50518 m .67348 .49234 L .66844 .51271 L p F P
0 0 0 r
s
.24 .35 .67 r
.65747 .49844 m
.67229 .47279 L
s
.22 .332 .677 r
.39107 .6323 m .39378 .62551 L .41718 .63161 L p F P
0 0 0 r
s
.22 .332 .677 r
.41718 .63161 m .41494 .63689 L .39107 .6323 L p F P
0 0 0 r
s
.83 .24 .1 r
.66731 .6606 m
.70897 .66653 L
s
.70897 .66653 m
.7208 .65017 L
s
.26629 .3032 m
.26417 .30707 L
s
.21992 .29906 m
.26417 .30707 L
s
.024 .035 .067 r
.35682 .44377 m .36103 .43026 L .35789 .44888 L p F P
0 0 0 r
s
.24 .35 .67 r
.35605 .45151 m
.35748 .44693 L
s
.024 .035 .067 r
.35789 .44888 m .35362 .46248 L .35682 .44377 L p F P
0 0 0 r
s
.238 .35 .612 r
.36759 .41378 m .37176 .40046 L .36533 .41646 L p F P
0 0 0 r
s
.238 .35 .612 r
.36533 .41646 m .36103 .43026 L .36759 .41378 L p F P
0 0 0 r
s
.24 .35 .67 r
.36444 .42469 m
.37577 .40276 L
s
.35908 .44182 m
.36444 .42469 L
s
.83 .24 .1 r
.21571 .61131 m
.25999 .61752 L
s
.25999 .61752 m
.26202 .61995 L
s
.71324 .41267 m
.70715 .39532 L
s
.752 .239 .103 r
.44246 .64627 m .45231 .64765 L .4671 .64547 L p F P
0 0 0 r
s
.752 .239 .103 r
.47387 .64642 m .4671 .64547 L .45231 .64765 L p F P
0 0 0 r
s
.347 .077 .032 r
.59464 .3705 m .57543 .36703 L .56755 .35898 L p F P
0 0 0 r
s
.347 .077 .032 r
.55024 .35584 m .56755 .35898 L .57543 .36703 L p F P
0 0 0 r
s
.24 .056 .023 r
.46244 .33991 m .44463 .33667 L .45239 .33541 L p F P
0 0 0 r
s
.24 .056 .023 r
.43703 .33262 m .45239 .33541 L .44463 .33667 L p F P
0 0 0 r
s
.24 .35 .67 r
.44967 .33167 m
.45956 .30375 L
s
.4492 .33299 m
.44967 .33167 L
s
.49 .12 .049 r
.65168 .38079 m .6705 .38419 L .68418 .39711 L p F P
0 0 0 r
s
.24 .35 .67 r
.67073 .39482 m
.67263 .39131 L
s
.323 .486 .92 r
.56694 .63029 m .56395 .63558 L .58193 .63062 L p F P
0 0 0 r
s
.323 .486 .92 r
.58193 .63062 m .58588 .6238 L .56694 .63029 L p F P
0 0 0 r
s
.049 .072 .169 r
.6812 .47922 m .67348 .49234 L .67407 .47251 L p F P
0 0 0 r
s
.049 .072 .169 r
.67407 .47251 m .68183 .45913 L .6812 .47922 L p F P
0 0 0 r
s
.752 .239 .103 r
.43257 .64489 m .44246 .64627 L .46032 .64452 L p F P
0 0 0 r
s
.24 .35 .67 r
.43123 .66085 m
.43814 .64547 L
s
.752 .239 .103 r
.4671 .64547 m .46032 .64452 L .44246 .64627 L p F P
0 0 0 r
s
.319 .48 .919 r
.54199 .64076 m .54004 .64433 L .55807 .646 L p F P
0 0 0 r
s
.319 .48 .919 r
.55807 .646 m .561 .64081 L .54199 .64076 L p F P
0 0 0 r
s
.24 .35 .67 r
.45956 .30375 m
.47038 .27323 L
s
.45956 .30375 m
.43356 .31292 L
s
.62076 .30189 m
.59205 .28698 L
s
.59205 .28698 m
.60579 .25608 L
s
.59205 .28698 m
.56155 .27632 L
s
.83 .24 .1 r
.35499 .31931 m
.39858 .32722 L
s
.067 .097 .237 r
.68975 .44545 m .68183 .45913 L .67785 .44044 L p F P
0 0 0 r
s
.067 .097 .237 r
.67785 .44044 m .68556 .42686 L .68975 .44545 L p F P
0 0 0 r
s
.098 .143 .332 r
.69344 .41298 m .68556 .42686 L .67677 .41049 L p F P
0 0 0 r
s
.24 .35 .67 r
.66707 .44716 m
.68225 .42014 L
s
.098 .143 .332 r
.67677 .41049 m .68418 .39711 L .69344 .41298 L p F P
0 0 0 r
s
.24 .056 .023 r
.44463 .33667 m .42673 .33343 L .43703 .33262 L p F P
0 0 0 r
s
.24 .056 .023 r
.42159 .32981 m .43703 .33262 L .42673 .33343 L p F P
0 0 0 r
s
.24 .35 .67 r
.42769 .33029 m
.43356 .31292 L
s
.42749 .33089 m
.42769 .33029 L
s
.347 .077 .032 r
.57543 .36703 m .55611 .36354 L .55024 .35584 L p F P
0 0 0 r
s
.347 .077 .032 r
.53285 .35268 m .55024 .35584 L .55611 .36354 L p F P
0 0 0 r
s
.83 .24 .1 r
.53251 .35419 m
.53836 .35526 L
s
.3508 .63239 m
.39443 .6385 L
s
.39443 .6385 m
.40015 .63449 L
s
.752 .239 .103 r
.42267 .6435 m .43257 .64489 L .45353 .64356 L p F P
0 0 0 r
s
.752 .239 .103 r
.46032 .64452 m .45353 .64356 L .43257 .64489 L p F P
0 0 0 r
s
.163 .246 .524 r
.36361 .58541 m .36712 .57559 L .38301 .59116 L p F P
0 0 0 r
s
.24 .35 .67 r
.36443 .58614 m
.36459 .5857 L
s
.163 .246 .524 r
.38301 .59116 m .37979 .5997 L .36361 .58541 L p F P
0 0 0 r
s
.24 .35 .67 r
.64665 .32053 m
.62076 .30189 L
s
.62076 .30189 m
.63514 .27128 L
s
.49 .12 .049 r
.68418 .39711 m .66389 .39347 L .65168 .38079 L p F P
0 0 0 r
s
.24 .35 .67 r
.67073 .39482 m
.68225 .42014 L
s
.83 .24 .1 r
.67643 .38979 m
.70715 .39532 L
s
.24 .35 .67 r
.67414 .38852 m
.68616 .36635 L
s
.49 .12 .049 r
.63277 .37738 m .65168 .38079 L .66389 .39347 L p F P
0 0 0 r
s
.194 .292 .608 r
.37662 .6081 m .37979 .5997 L .39932 .61166 L p F P
0 0 0 r
s
.194 .292 .608 r
.39932 .61166 m .39653 .61863 L .37662 .6081 L p F P
0 0 0 r
s
.125 .189 .421 r
.35483 .55834 m .35862 .54724 L .3707 .56559 L p F P
0 0 0 r
s
.125 .189 .421 r
.3707 .56559 m .36712 .57559 L .35483 .55834 L p F P
0 0 0 r
s
.83 .24 .1 r
.76258 .65622 m
.80387 .6622 L
s
.81616 .64023 m
.80387 .6622 L
s
.318 .471 .867 r
.40098 .35415 m .40483 .34226 L .39358 .34845 L p F P
0 0 0 r
s
.318 .471 .867 r
.39358 .34845 m .38939 .36166 L .40098 .35415 L p F P
0 0 0 r
s
.24 .35 .67 r
.56155 .27632 m
.57464 .24514 L
s
.56155 .27632 m
.53035 .27032 L
s
.752 .239 .103 r
.41273 .64211 m .42267 .6435 L .44672 .64261 L p F P
0 0 0 r
s
.752 .239 .103 r
.45353 .64356 m .44672 .64261 L .42267 .6435 L p F P
0 0 0 r
s
.309 .465 .9 r
.5186 .64255 m .51764 .64436 L .53426 .65491 L p F P
0 0 0 r
s
.24 .35 .67 r
.53313 .65475 m
.53336 .65433 L
s
.309 .465 .9 r
.53426 .65491 m .53618 .6514 L .5186 .64255 L p F P
0 0 0 r
s
.24 .35 .67 r
.53586 .65124 m
.53633 .65112 L
s
.911 .279 .12 r
.5276 .65397 m .53426 .65491 L .51764 .64436 L p F P
0 0 0 r
s
.24 .056 .023 r
.42673 .33343 m .40875 .33016 L .42159 .32981 L p F P
0 0 0 r
s
.347 .077 .032 r
.55611 .36354 m .5367 .36003 L .53285 .35268 L p F P
0 0 0 r
s
.347 .077 .032 r
.51537 .34951 m .53285 .35268 L .5367 .36003 L p F P
0 0 0 r
s
.83 .24 .1 r
.80156 .45065 m
.7965 .42747 L
s
.75512 .42011 m
.7965 .42747 L
s
.295 .444 .814 r
.61722 .58902 m .61217 .59759 L .6273 .58298 L p F P
0 0 0 r
s
.295 .444 .814 r
.6273 .58298 m .63317 .57312 L .61722 .58902 L p F P
0 0 0 r
s
.83 .24 .1 r
.62515 .6546 m
.66731 .6606 L
s
.66731 .6606 m
.67853 .64405 L
s
.911 .279 .12 r
.52093 .65303 m .5276 .65397 L .51421 .64388 L p F P
0 0 0 r
s
.911 .279 .12 r
.51764 .64436 m .51421 .64388 L .5276 .65397 L p F P
0 0 0 r
s
.085 .126 .306 r
.3503 .52798 m .35431 .51578 L .36248 .53592 L p F P
0 0 0 r
s
.085 .126 .306 r
.36248 .53592 m .35862 .54724 L .3503 .52798 L p F P
0 0 0 r
s
.752 .239 .103 r
.44672 .64261 m .4399 .64165 L .41273 .64211 L p F P
0 0 0 r
s
.24 .35 .67 r
.43814 .64547 m
.43957 .64229 L
s
.243 .365 .736 r
.41273 .64211 m .41494 .63689 L .44151 .63806 L p F P
0 0 0 r
s
.243 .365 .736 r
.44151 .63806 m .4399 .64165 L .41273 .64211 L p F P
0 0 0 r
s
.317 .477 .891 r
.59392 .60991 m .58987 .6169 L .6072 .60602 L p F P
0 0 0 r
s
.317 .477 .891 r
.6072 .60602 m .61217 .59759 L .59392 .60991 L p F P
0 0 0 r
s
.83 .24 .1 r
.22115 .295 m
.21992 .29906 L
s
.1709 .60502 m
.21571 .61131 L
s
.21571 .61131 m
.21684 .61362 L
s
.22 .332 .677 r
.39378 .62551 m .39653 .61863 L .41944 .62629 L p F P
0 0 0 r
s
.22 .332 .677 r
.41944 .62629 m .41718 .63161 L .39378 .62551 L p F P
0 0 0 r
s
.49 .12 .049 r
.66389 .39347 m .64348 .38982 L .63277 .37738 L p F P
0 0 0 r
s
.49 .12 .049 r
.61375 .37395 m .63277 .37738 L .64348 .38982 L p F P
0 0 0 r
s
.252 .38 .679 r
.63915 .56308 m .63317 .57312 L .64552 .5556 L p F P
0 0 0 r
s
.252 .38 .679 r
.64552 .5556 m .65218 .54445 L .63915 .56308 L p F P
0 0 0 r
s
.911 .279 .12 r
.51424 .65209 m .52093 .65303 L .51077 .64339 L p F P
0 0 0 r
s
.83 .24 .1 r
.51902 .65122 m
.51966 .65131 L
s
.911 .279 .12 r
.51421 .64388 m .51077 .64339 L .52093 .65303 L p F P
0 0 0 r
s
.24 .35 .67 r
.50423 .65298 m
.52045 .65219 L
s
.52045 .65219 m
.5237 .65203 L
s
.319 .48 .919 r
.54396 .63716 m .54199 .64076 L .561 .64081 L p F P
0 0 0 r
s
.319 .48 .919 r
.561 .64081 m .56395 .63558 L .54396 .63716 L p F P
0 0 0 r
s
.911 .279 .12 r
.50754 .65115 m .51424 .65209 L .50732 .6429 L p F P
0 0 0 r
s
.83 .24 .1 r
.51294 .65037 m
.51359 .65046 L
s
.911 .279 .12 r
.51077 .64339 m .50732 .6429 L .51424 .65209 L p F P
0 0 0 r
s
.24 .35 .67 r
.66875 .34227 m
.64665 .32053 L
s
.64665 .32053 m
.66166 .29022 L
s
.347 .077 .032 r
.5367 .36003 m .51718 .35651 L .51537 .34951 L p F P
0 0 0 r
s
.347 .077 .032 r
.49781 .34632 m .51537 .34951 L .51718 .35651 L p F P
0 0 0 r
s
.065 .095 .231 r
.34996 .49556 m .35412 .48251 L .3584 .50333 L p F P
0 0 0 r
s
.065 .095 .231 r
.3584 .50333 m .35431 .51578 L .34996 .49556 L p F P
0 0 0 r
s
.323 .486 .92 r
.56995 .62495 m .56694 .63029 L .58588 .6238 L p F P
0 0 0 r
s
.323 .486 .92 r
.58588 .6238 m .58987 .6169 L .56995 .62495 L p F P
0 0 0 r
s
.309 .465 .9 r
.51956 .64072 m .5186 .64255 L .53618 .6514 L p F P
0 0 0 r
s
.309 .465 .9 r
.53618 .6514 m .5381 .64788 L .51956 .64072 L p F P
0 0 0 r
s
.83 .24 .1 r
.53367 .64904 m
.53461 .64794 L
s
.024 .035 .067 r
.65896 .53307 m .65218 .54445 L .66115 .52497 L p F P
0 0 0 r
s
.024 .035 .067 r
.66115 .52497 m .66844 .51271 L .65896 .53307 L p F P
0 0 0 r
s
.911 .279 .12 r
.50084 .65021 m .50754 .65115 L .50388 .64242 L p F P
0 0 0 r
s
.83 .24 .1 r
.50686 .64951 m
.5075 .6496 L
s
.911 .279 .12 r
.50732 .6429 m .50388 .64242 L .50754 .65115 L p F P
0 0 0 r
s
.83 .24 .1 r
.35783 .32253 m
.35499 .31931 L
s
.3109 .3113 m
.35499 .31931 L
s
.24 .35 .67 r
.53035 .27032 m
.5428 .23886 L
s
.53035 .27032 m
.49958 .26924 L
s
.288 .426 .769 r
.38529 .37462 m .38939 .36166 L .38035 .37298 L p F P
0 0 0 r
s
.288 .426 .769 r
.38035 .37298 m .37601 .38686 L .38529 .37462 L p F P
0 0 0 r
s
.24 .35 .67 r
.38467 .37464 m
.40179 .35629 L
s
.83 .24 .1 r
.30667 .62621 m
.3508 .63239 L
s
.3508 .63239 m
.35569 .62824 L
s
.49 .12 .049 r
.64348 .38982 m .62296 .38614 L .61375 .37395 L p F P
0 0 0 r
s
.49 .12 .049 r
.59464 .3705 m .61375 .37395 L .62296 .38614 L p F P
0 0 0 r
s
.911 .279 .12 r
.49411 .64927 m .50084 .65021 L .50043 .64193 L p F P
0 0 0 r
s
.83 .24 .1 r
.50076 .64865 m
.50141 .64874 L
s
.911 .279 .12 r
.50388 .64242 m .50043 .64193 L .50084 .65021 L p F P
0 0 0 r
s
.045 .065 .149 r
.35362 .46248 m .35789 .44888 L .35838 .46917 L p F P
0 0 0 r
s
.24 .35 .67 r
.35374 .46728 m
.35475 .46407 L
s
.35801 .45374 m
.35937 .44941 L
s
.045 .065 .149 r
.35838 .46917 m .35412 .48251 L .35362 .46248 L p F P
0 0 0 r
s
.83 .24 .1 r
.7208 .65017 m
.76258 .65622 L
s
.76258 .65622 m
.77439 .63404 L
s
.347 .077 .032 r
.51718 .35651 m .49755 .35297 L .49781 .34632 L p F P
0 0 0 r
s
.347 .077 .032 r
.48017 .34312 m .49781 .34632 L .49755 .35297 L p F P
0 0 0 r
s
.911 .279 .12 r
.48738 .64832 m .49411 .64927 L .49698 .64144 L p F P
0 0 0 r
s
.83 .24 .1 r
.48751 .64679 m
.48919 .64702 L
s
.49465 .64779 m
.4953 .64788 L
s
.48512 .648 m
.48751 .64679 L
s
.911 .279 .12 r
.50043 .64193 m .49698 .64144 L .49411 .64927 L p F P
0 0 0 r
s
.028 .04 .082 r
.67588 .50019 m .66844 .51271 L .67348 .49234 L p F P
0 0 0 r
s
.24 .35 .67 r
.6562 .5234 m
.67118 .49797 L
s
.67118 .49797 m
.67229 .47279 L
s
.028 .04 .082 r
.67348 .49234 m .6812 .47922 L .67588 .50019 L p F P
0 0 0 r
s
.238 .35 .612 r
.37176 .40046 m .37601 .38686 L .36972 .40235 L p F P
0 0 0 r
s
.24 .35 .67 r
.37577 .40276 m
.38467 .37464 L
s
.238 .35 .612 r
.36972 .40235 m .36533 .41646 L .37176 .40046 L p F P
0 0 0 r
s
.243 .365 .736 r
.41494 .63689 m .41718 .63161 L .44314 .63444 L p F P
0 0 0 r
s
.243 .365 .736 r
.44314 .63444 m .44151 .63806 L .41494 .63689 L p F P
0 0 0 r
s
.024 .035 .067 r
.36103 .43026 m .36533 .41646 L .36226 .43497 L p F P
0 0 0 r
s
.024 .035 .067 r
.36226 .43497 m .35789 .44888 L .36103 .43026 L p F P
0 0 0 r
s
.24 .35 .67 r
.35937 .44941 m
.36444 .42469 L
s
.911 .279 .12 r
.48063 .64737 m .48738 .64832 L .49352 .64095 L p F P
0 0 0 r
s
.911 .279 .12 r
.49698 .64144 m .49352 .64095 L .48738 .64832 L p F P
0 0 0 r
s
.83 .24 .1 r
.75962 .44333 m
.75512 .42011 L
s
.71324 .41267 m
.75512 .42011 L
s
.58251 .64853 m
.62515 .6546 L
s
.62515 .6546 m
.63577 .63786 L
s
.309 .465 .9 r
.52052 .63889 m .51956 .64072 L .5381 .64788 L p F P
0 0 0 r
s
.309 .465 .9 r
.5381 .64788 m .54004 .64433 L .52052 .63889 L p F P
0 0 0 r
s
.194 .292 .608 r
.37979 .5997 m .38301 .59116 L .40214 .6046 L p F P
0 0 0 r
s
.194 .292 .608 r
.40214 .6046 m .39932 .61166 L .37979 .5997 L p F P
0 0 0 r
s
.49 .12 .049 r
.62296 .38614 m .60232 .38245 L .59464 .3705 L p F P
0 0 0 r
s
.49 .12 .049 r
.57543 .36703 m .59464 .3705 L .60232 .38245 L p F P
0 0 0 r
s
.83 .24 .1 r
.1709 .60502 m
.17113 .60722 L
s
.319 .48 .919 r
.54594 .63354 m .54396 .63716 L .56395 .63558 L p F P
0 0 0 r
s
.319 .48 .919 r
.56395 .63558 m .56694 .63029 L .54594 .63354 L p F P
0 0 0 r
s
.911 .279 .12 r
.47387 .64642 m .48063 .64737 L .49006 .64046 L p F P
0 0 0 r
s
.83 .24 .1 r
.48241 .64607 m
.48306 .64616 L
s
.911 .279 .12 r
.49352 .64095 m .49006 .64046 L .48063 .64737 L p F P
0 0 0 r
s
.163 .246 .524 r
.36712 .57559 m .3707 .56559 L .38628 .58249 L p F P
0 0 0 r
s
.24 .35 .67 r
.36793 .57638 m
.36809 .57594 L
s
.163 .246 .524 r
.38628 .58249 m .38301 .59116 L .36712 .57559 L p F P
0 0 0 r
s
.347 .077 .032 r
.49755 .35297 m .47783 .3494 L .48017 .34312 L p F P
0 0 0 r
s
.347 .077 .032 r
.46244 .33991 m .48017 .34312 L .47783 .3494 L p F P
0 0 0 r
s
.049 .072 .169 r
.6891 .46581 m .6812 .47922 L .68183 .45913 L p F P
0 0 0 r
s
.049 .072 .169 r
.68183 .45913 m .68975 .44545 L .6891 .46581 L p F P
0 0 0 r
s
.22 .332 .677 r
.39653 .61863 m .39932 .61166 L .42172 .62091 L p F P
0 0 0 r
s
.22 .332 .677 r
.42172 .62091 m .41944 .62629 L .39653 .61863 L p F P
0 0 0 r
s
.911 .279 .12 r
.4671 .64547 m .47387 .64642 L .4866 .63997 L p F P
0 0 0 r
s
.83 .24 .1 r
.47627 .64521 m
.47692 .6453 L
s
.911 .279 .12 r
.49006 .64046 m .4866 .63997 L .47387 .64642 L p F P
0 0 0 r
s
.318 .471 .867 r
.40483 .34226 m .40875 .33016 L .39785 .33496 L p F P
0 0 0 r
s
.318 .471 .867 r
.39785 .33496 m .39358 .34845 L .40483 .34226 L p F P
0 0 0 r
s
.24 .35 .67 r
.47251 .64853 m
.50423 .65298 L
s
.50423 .65298 m
.50895 .64384 L
s
.43356 .31292 m
.44391 .28227 L
s
.43356 .31292 m
.41134 .32689 L
s
.635 .165 .068 r
.66389 .39347 m .68418 .39711 L .69344 .41298 L p F P
0 0 0 r
s
.83 .24 .1 r
.84301 .45788 m
.80156 .45065 L
s
.84301 .45788 m
.84581 .48576 L
s
.067 .097 .237 r
.69786 .43146 m .68975 .44545 L .68556 .42686 L p F P
0 0 0 r
s
.067 .097 .237 r
.68556 .42686 m .69344 .41298 L .69786 .43146 L p F P
0 0 0 r
s
.24 .35 .67 r
.68225 .42014 m
.68777 .44602 L
s
.317 .477 .891 r
.59802 .60282 m .59392 .60991 L .61217 .59759 L p F P
0 0 0 r
s
.317 .477 .891 r
.61217 .59759 m .61722 .58902 L .59802 .60282 L p F P
0 0 0 r
s
.125 .189 .421 r
.35862 .54724 m .36248 .53592 L .37434 .55541 L p F P
0 0 0 r
s
.125 .189 .421 r
.37434 .55541 m .3707 .56559 L .35862 .54724 L p F P
0 0 0 r
s
.911 .279 .12 r
.46032 .64452 m .4671 .64547 L .48313 .63948 L p F P
0 0 0 r
s
.83 .24 .1 r
.47012 .64434 m
.47078 .64443 L
s
.911 .279 .12 r
.4866 .63997 m .48313 .63948 L .4671 .64547 L p F P
0 0 0 r
s
.24 .35 .67 r
.68616 .36635 m
.66875 .34227 L
s
.66875 .34227 m
.68434 .31224 L
s
.83 .24 .1 r
.31285 .31438 m
.3109 .3113 L
s
.26629 .3032 m
.3109 .3113 L
s
.49 .12 .049 r
.60232 .38245 m .58157 .37873 L .57543 .36703 L p F P
0 0 0 r
s
.49 .12 .049 r
.55611 .36354 m .57543 .36703 L .58157 .37873 L p F P
0 0 0 r
s
.323 .486 .92 r
.573 .61956 m .56995 .62495 L .58987 .6169 L p F P
0 0 0 r
s
.323 .486 .92 r
.58987 .6169 m .59392 .60991 L .573 .61956 L p F P
0 0 0 r
s
.295 .444 .814 r
.62234 .58031 m .61722 .58902 L .63317 .57312 L p F P
0 0 0 r
s
.295 .444 .814 r
.63317 .57312 m .63915 .56308 L .62234 .58031 L p F P
0 0 0 r
s
.24 .35 .67 r
.63443 .56791 m
.63457 .56769 L
s
.83 .24 .1 r
.26202 .61995 m
.30667 .62621 L
s
.30667 .62621 m
.31071 .62191 L
s
.347 .077 .032 r
.47783 .3494 m .45799 .34582 L .46244 .33991 L p F P
0 0 0 r
s
.347 .077 .032 r
.44463 .33667 m .46244 .33991 L .45799 .34582 L p F P
0 0 0 r
s
.83 .24 .1 r
.44619 .33855 m
.44779 .33884 L
s
.4435 .33647 m
.44619 .33855 L
s
.911 .279 .12 r
.45353 .64356 m .46032 .64452 L .47967 .63899 L p F P
0 0 0 r
s
.83 .24 .1 r
.46397 .64347 m
.46462 .64357 L
s
.911 .279 .12 r
.48313 .63948 m .47967 .63899 L .46032 .64452 L p F P
0 0 0 r
s
.309 .465 .9 r
.52148 .63705 m .52052 .63889 L .54004 .64433 L p F P
0 0 0 r
s
.309 .465 .9 r
.54004 .64433 m .54199 .64076 L .52148 .63705 L p F P
0 0 0 r
s
.83 .24 .1 r
.53461 .64794 m
.53936 .64239 L
s
.24 .35 .67 r
.49958 .26924 m
.51143 .23754 L
s
.49958 .26924 m
.47038 .27323 L
s
.911 .279 .12 r
.44672 .64261 m .45353 .64356 L .47619 .63849 L p F P
0 0 0 r
s
.83 .24 .1 r
.4578 .64261 m
.45846 .6427 L
s
.911 .279 .12 r
.47967 .63899 m .47619 .63849 L .45353 .64356 L p F P
0 0 0 r
s
.83 .24 .1 r
.67853 .64405 m
.7208 .65017 L
s
.7208 .65017 m
.73213 .62778 L
s
.243 .365 .736 r
.41718 .63161 m .41944 .62629 L .44478 .6308 L p F P
0 0 0 r
s
.243 .365 .736 r
.44478 .6308 m .44314 .63444 L .41718 .63161 L p F P
0 0 0 r
s
.635 .165 .068 r
.69344 .41298 m .67215 .40921 L .66389 .39347 L p F P
0 0 0 r
s
.24 .35 .67 r
.68225 .42014 m
.68693 .41183 L
s
.69031 .40581 m
.69811 .39193 L
s
.6893 .4076 m
.69031 .40581 L
s
.635 .165 .068 r
.64348 .38982 m .66389 .39347 L .67215 .40921 L p F P
0 0 0 r
s
.085 .126 .306 r
.35431 .51578 m .3584 .50333 L .36643 .52438 L p F P
0 0 0 r
s
.085 .126 .306 r
.36643 .52438 m .36248 .53592 L .35431 .51578 L p F P
0 0 0 r
s
.252 .38 .679 r
.64523 .55285 m .63915 .56308 L .65218 .54445 L p F P
0 0 0 r
s
.252 .38 .679 r
.65218 .54445 m .65896 .53307 L .64523 .55285 L p F P
0 0 0 r
s
.24 .35 .67 r
.63457 .56769 m
.64853 .54685 L
s
.911 .279 .12 r
.4399 .64165 m .44672 .64261 L .47272 .638 L p F P
0 0 0 r
s
.83 .24 .1 r
.44409 .64068 m
.44609 .64096 L
s
.45162 .64174 m
.45228 .64183 L
s
.44303 .6413 m
.44409 .64068 L
s
.911 .279 .12 r
.47619 .63849 m .47272 .638 L .44672 .64261 L p F P
0 0 0 r
s
.83 .24 .1 r
.40015 .63449 m
.43649 .63961 L
s
.44056 .64018 m
.44409 .64068 L
s
.49 .12 .049 r
.58157 .37873 m .56069 .37499 L .55611 .36354 L p F P
0 0 0 r
s
.49 .12 .049 r
.5367 .36003 m .55611 .36354 L .56069 .37499 L p F P
0 0 0 r
s
.319 .48 .919 r
.54793 .62989 m .54594 .63354 L .56694 .63029 L p F P
0 0 0 r
s
.319 .48 .919 r
.56694 .63029 m .56995 .62495 L .54793 .62989 L p F P
0 0 0 r
s
.83 .24 .1 r
.71718 .43592 m
.71324 .41267 L
s
.69095 .40871 m
.71324 .41267 L
s
.77439 .63404 m
.81616 .64023 L
s
.82705 .61323 m
.81616 .64023 L
s
.347 .077 .032 r
.45799 .34582 m .43805 .34222 L .44463 .33667 L p F P
0 0 0 r
s
.347 .077 .032 r
.42673 .33343 m .44463 .33667 L .43805 .34222 L p F P
0 0 0 r
s
.24 .35 .67 r
.4561 .64314 m
.47251 .64853 L
s
.4528 .64206 m
.4561 .64314 L
s
.83 .24 .1 r
.53936 .64239 m
.58251 .64853 L
s
.58251 .64853 m
.59249 .63159 L
s
.911 .279 .12 r
.47272 .638 m .46924 .63751 L .4399 .64165 L p F P
0 0 0 r
s
.24 .35 .67 r
.47251 .64853 m
.47697 .63931 L
s
.263 .395 .787 r
.4399 .64165 m .44151 .63806 L .47012 .63567 L p F P
0 0 0 r
s
.263 .395 .787 r
.47012 .63567 m .46924 .63751 L .4399 .64165 L p F P
0 0 0 r
s
.288 .426 .769 r
.38939 .36166 m .39358 .34845 L .38479 .35879 L p F P
0 0 0 r
s
.288 .426 .769 r
.38479 .35879 m .38035 .37298 L .38939 .36166 L p F P
0 0 0 r
s
.309 .465 .9 r
.52245 .63521 m .52148 .63705 L .54199 .64076 L p F P
0 0 0 r
s
.309 .465 .9 r
.54199 .64076 m .54396 .63716 L .52245 .63521 L p F P
0 0 0 r
s
.065 .095 .231 r
.35412 .48251 m .35838 .46917 L .36258 .49061 L p F P
0 0 0 r
s
.065 .095 .231 r
.36258 .49061 m .3584 .50333 L .35412 .48251 L p F P
0 0 0 r
s
.024 .035 .067 r
.66589 .52147 m .65896 .53307 L .66844 .51271 L p F P
0 0 0 r
s
.024 .035 .067 r
.66844 .51271 m .67588 .50019 L .66589 .52147 L p F P
0 0 0 r
s
.635 .165 .068 r
.67215 .40921 m .65074 .40541 L .64348 .38982 L p F P
0 0 0 r
s
.635 .165 .068 r
.62296 .38614 m .64348 .38982 L .65074 .40541 L p F P
0 0 0 r
s
.22 .332 .677 r
.39932 .61166 m .40214 .6046 L .42402 .61547 L p F P
0 0 0 r
s
.22 .332 .677 r
.42402 .61547 m .42172 .62091 L .39932 .61166 L p F P
0 0 0 r
s
.83 .24 .1 r
.80156 .45065 m
.75962 .44333 L
s
.80392 .47861 m
.80156 .45065 L
s
.194 .292 .608 r
.38301 .59116 m .38628 .58249 L .40499 .59744 L p F P
0 0 0 r
s
.194 .292 .608 r
.40499 .59744 m .40214 .6046 L .38301 .59116 L p F P
0 0 0 r
s
.347 .077 .032 r
.43805 .34222 m .41801 .3386 L .42673 .33343 L p F P
0 0 0 r
s
.347 .077 .032 r
.40875 .33016 m .42673 .33343 L .41801 .3386 L p F P
0 0 0 r
s
.83 .24 .1 r
.40788 .33161 m
.41094 .33216 L
s
.49 .12 .049 r
.56069 .37499 m .5397 .37123 L .5367 .36003 L p F P
0 0 0 r
s
.49 .12 .049 r
.51718 .35651 m .5367 .36003 L .5397 .37123 L p F P
0 0 0 r
s
.83 .24 .1 r
.26734 .30613 m
.26629 .3032 L
s
.22115 .295 m
.26629 .3032 L
s
.21684 .61362 m
.26202 .61995 L
s
.26202 .61995 m
.26519 .6155 L
s
.045 .065 .149 r
.35789 .44888 m .36226 .43497 L .36274 .45554 L p F P
0 0 0 r
s
.045 .065 .149 r
.36274 .45554 m .35838 .46917 L .35789 .44888 L p F P
0 0 0 r
s
.243 .365 .736 r
.41944 .62629 m .42172 .62091 L .44642 .62713 L p F P
0 0 0 r
s
.243 .365 .736 r
.44642 .62713 m .44478 .6308 L .41944 .62629 L p F P
0 0 0 r
s
.323 .486 .92 r
.57607 .61411 m .573 .61956 L .59392 .60991 L p F P
0 0 0 r
s
.323 .486 .92 r
.59392 .60991 m .59802 .60282 L .57607 .61411 L p F P
0 0 0 r
s
.263 .395 .787 r
.44151 .63806 m .44314 .63444 L .471 .63382 L p F P
0 0 0 r
s
.263 .395 .787 r
.471 .63382 m .47012 .63567 L .44151 .63806 L p F P
0 0 0 r
s
.83 .24 .1 r
.44678 .63676 m
.44757 .63563 L
s
.163 .246 .524 r
.3707 .56559 m .37434 .55541 L .3896 .57368 L p F P
0 0 0 r
s
.24 .35 .67 r
.37149 .56645 m
.37165 .566 L
s
.163 .246 .524 r
.3896 .57368 m .38628 .58249 L .3707 .56559 L p F P
0 0 0 r
s
.238 .35 .612 r
.37601 .38686 m .38035 .37298 L .37422 .38792 L p F P
0 0 0 r
s
.238 .35 .612 r
.37422 .38792 m .36972 .40235 L .37601 .38686 L p F P
0 0 0 r
s
.24 .35 .67 r
.37321 .39668 m
.38467 .37464 L
s
.317 .477 .891 r
.60218 .59565 m .59802 .60282 L .61722 .58902 L p F P
0 0 0 r
s
.317 .477 .891 r
.61722 .58902 m .62234 .58031 L .60218 .59565 L p F P
0 0 0 r
s
.028 .04 .082 r
.68348 .48741 m .67588 .50019 L .6812 .47922 L p F P
0 0 0 r
s
.028 .04 .082 r
.6812 .47922 m .6891 .46581 L .68348 .48741 L p F P
0 0 0 r
s
.24 .35 .67 r
.67229 .47279 m
.68777 .44602 L
s
.83 .24 .1 r
.63577 .63786 m
.67853 .64405 L
s
.67853 .64405 m
.68937 .62144 L
s
.635 .165 .068 r
.65074 .40541 m .6292 .4016 L .62296 .38614 L p F P
0 0 0 r
s
.635 .165 .068 r
.60232 .38245 m .62296 .38614 L .6292 .4016 L p F P
0 0 0 r
s
.024 .035 .067 r
.36533 .41646 m .36972 .40235 L .36672 .42074 L p F P
0 0 0 r
s
.24 .35 .67 r
.36444 .42469 m
.36619 .41911 L
s
.36786 .41377 m
.37321 .39668 L
s
.024 .035 .067 r
.36672 .42074 m .36226 .43497 L .36533 .41646 L p F P
0 0 0 r
s
.309 .465 .9 r
.52342 .63336 m .52245 .63521 L .54396 .63716 L p F P
0 0 0 r
s
.309 .465 .9 r
.54396 .63716 m .54594 .63354 L .52342 .63336 L p F P
0 0 0 r
s
.296 .445 .87 r
.51764 .64436 m .5186 .64255 L .5 .62969 L closepath p F P
0 0 0 r
s
.982 .295 .126 r
.5 .62969 m .51421 .64388 L .51764 .64436 L closepath p F P
0 0 0 r
s
.347 .077 .032 r
.41801 .3386 m .39785 .33496 L .40875 .33016 L p F P
0 0 0 r
s
.24 .35 .67 r
.41015 .33055 m
.41134 .32689 L
s
.40179 .35629 m
.40812 .33682 L
s
.4101 .3307 m
.41015 .33055 L
s
.83 .24 .1 r
.40227 .33059 m
.40618 .3313 L
s
.39858 .32722 m
.40227 .33059 L
s
.319 .48 .919 r
.54994 .62621 m .54793 .62989 L .56995 .62495 L p F P
0 0 0 r
s
.24 .35 .67 r
.54743 .62852 m
.54888 .62816 L
s
.319 .48 .919 r
.56995 .62495 m .573 .61956 L .54994 .62621 L p F P
0 0 0 r
s
.49 .12 .049 r
.5397 .37123 m .51859 .36745 L .51718 .35651 L p F P
0 0 0 r
s
.49 .12 .049 r
.49755 .35297 m .51718 .35651 L .51859 .36745 L p F P
0 0 0 r
s
.982 .295 .126 r
.5 .62969 m .51077 .64339 L .51421 .64388 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.69811 .39193 m
.68616 .36635 L
s
.68616 .36635 m
.70229 .3366 L
s
.83 .24 .1 r
.40227 .33059 m
.4028 .33279 L
s
.35783 .32253 m
.40227 .33059 L
s
.35569 .62824 m
.40015 .63449 L
s
.40015 .63449 m
.40681 .62353 L
s
.982 .295 .126 r
.5 .62969 m .50732 .6429 L .51077 .64339 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.73213 .62778 m
.77439 .63404 L
s
.77439 .63404 m
.78494 .60682 L
s
.52191 .6399 m
.53936 .64239 L
s
.295 .444 .814 r
.62755 .57147 m .62234 .58031 L .63915 .56308 L p F P
0 0 0 r
s
.295 .444 .814 r
.63915 .56308 m .64523 .55285 L .62755 .57147 L p F P
0 0 0 r
s
.982 .295 .126 r
.5 .62969 m .50388 .64242 L .50732 .6429 L closepath p F P
0 0 0 r
s
.049 .072 .169 r
.69717 .4521 m .6891 .46581 L .68975 .44545 L p F P
0 0 0 r
s
.049 .072 .169 r
.68975 .44545 m .69786 .43146 L .69717 .4521 L p F P
0 0 0 r
s
.296 .445 .87 r
.5186 .64255 m .51956 .64072 L .5 .62969 L closepath p F P
0 0 0 r
s
.125 .189 .421 r
.36248 .53592 m .36643 .52438 L .37805 .54505 L p F P
0 0 0 r
s
.125 .189 .421 r
.37805 .54505 m .37434 .55541 L .36248 .53592 L p F P
0 0 0 r
s
.24 .35 .67 r
.37497 .55363 m
.37566 .55483 L
s
.37512 .55635 m
.37566 .55483 L
s
.982 .295 .126 r
.5 .62969 m .50043 .64193 L .50388 .64242 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.84581 .48576 m
.84555 .51698 L
s
.80392 .47861 m
.84581 .48576 L
s
.24 .35 .67 r
.47038 .27323 m
.48168 .24133 L
s
.47038 .27323 m
.44391 .28227 L
s
.982 .295 .126 r
.5 .62969 m .49698 .64144 L .50043 .64193 L closepath p F P
0 0 0 r
s
.263 .395 .787 r
.44314 .63444 m .44478 .6308 L .47188 .63196 L p F P
0 0 0 r
s
.263 .395 .787 r
.47188 .63196 m .471 .63382 L .44314 .63444 L p F P
0 0 0 r
s
.24 .35 .67 r
.63514 .27128 m
.60579 .25608 L
s
.60579 .25608 m
.62014 .22379 L
s
.60579 .25608 m
.57464 .24514 L
s
.731 .196 .081 r
.67215 .40921 m .69344 .41298 L .69786 .43146 L p F P
0 0 0 r
s
.635 .165 .068 r
.6292 .4016 m .60753 .39776 L .60232 .38245 L p F P
0 0 0 r
s
.635 .165 .068 r
.58157 .37873 m .60232 .38245 L .60753 .39776 L p F P
0 0 0 r
s
.982 .295 .126 r
.5 .62969 m .49352 .64095 L .49698 .64144 L closepath p F P
0 0 0 r
s
.49 .12 .049 r
.51859 .36745 m .49735 .36364 L .49755 .35297 L p F P
0 0 0 r
s
.49 .12 .049 r
.47783 .3494 m .49755 .35297 L .49735 .36364 L p F P
0 0 0 r
s
.982 .295 .126 r
.5 .62969 m .49006 .64046 L .49352 .64095 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.75962 .44333 m
.71718 .43592 L
s
.76154 .47138 m
.75962 .44333 L
s
.24 .35 .67 r
.41134 .32689 m
.42132 .29617 L
s
.4057 .33285 m
.41134 .32689 L
s
.309 .465 .9 r
.5244 .6315 m .52342 .63336 L .54594 .63354 L p F P
0 0 0 r
s
.309 .465 .9 r
.54594 .63354 m .54793 .62989 L .5244 .6315 L p F P
0 0 0 r
s
.24 .35 .67 r
.54664 .62998 m
.54743 .62852 L
s
.296 .445 .87 r
.51956 .64072 m .52052 .63889 L .5 .62969 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.66166 .29022 m
.63514 .27128 L
s
.63514 .27128 m
.65017 .2393 L
s
.982 .295 .126 r
.5 .62969 m .4866 .63997 L .49006 .64046 L closepath p F P
0 0 0 r
s
.22 .332 .677 r
.40214 .6046 m .40499 .59744 L .42635 .60998 L p F P
0 0 0 r
s
.22 .332 .677 r
.42635 .60998 m .42402 .61547 L .40214 .6046 L p F P
0 0 0 r
s
.243 .365 .736 r
.42172 .62091 m .42402 .61547 L .44808 .62344 L p F P
0 0 0 r
s
.243 .365 .736 r
.44808 .62344 m .44642 .62713 L .42172 .62091 L p F P
0 0 0 r
s
.83 .24 .1 r
.22128 .29779 m
.22115 .295 L
s
.24 .35 .67 r
.57464 .24514 m
.58831 .21254 L
s
.57464 .24514 m
.5428 .23886 L
s
.982 .295 .126 r
.5 .62969 m .48313 .63948 L .4866 .63997 L closepath p F P
0 0 0 r
s
.252 .38 .679 r
.65142 .54244 m .64523 .55285 L .65896 .53307 L p F P
0 0 0 r
s
.252 .38 .679 r
.65896 .53307 m .66589 .52147 L .65142 .54244 L p F P
0 0 0 r
s
.24 .35 .67 r
.64853 .54685 m
.66355 .5216 L
s
.66355 .5216 m
.67118 .49797 L
s
.83 .24 .1 r
.17113 .60722 m
.21684 .61362 L
s
.21684 .61362 m
.21911 .60902 L
s
.982 .295 .126 r
.5 .62969 m .47967 .63899 L .48313 .63948 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.78494 .60682 m
.82705 .61323 L
s
.83591 .58255 m
.82705 .61323 L
s
.085 .126 .306 r
.3584 .50333 m .36258 .49061 L .37045 .5126 L p F P
0 0 0 r
s
.085 .126 .306 r
.37045 .5126 m .36643 .52438 L .3584 .50333 L p F P
0 0 0 r
s
.982 .295 .126 r
.5 .62969 m .47619 .63849 L .47967 .63899 L closepath p F P
0 0 0 r
s
.319 .48 .919 r
.55196 .62252 m .54994 .62621 L .573 .61956 L p F P
0 0 0 r
s
.319 .48 .919 r
.573 .61956 m .57607 .61411 L .55196 .62252 L p F P
0 0 0 r
s
.296 .445 .87 r
.52052 .63889 m .52148 .63705 L .5 .62969 L closepath p F P
0 0 0 r
s
.194 .292 .608 r
.38628 .58249 m .3896 .57368 L .40789 .59019 L p F P
0 0 0 r
s
.194 .292 .608 r
.40789 .59019 m .40499 .59744 L .38628 .58249 L p F P
0 0 0 r
s
.635 .165 .068 r
.60753 .39776 m .58573 .3939 L .58157 .37873 L p F P
0 0 0 r
s
.635 .165 .068 r
.56069 .37499 m .58157 .37873 L .58573 .3939 L p F P
0 0 0 r
s
.323 .486 .92 r
.57918 .60861 m .57607 .61411 L .59802 .60282 L p F P
0 0 0 r
s
.323 .486 .92 r
.59802 .60282 m .60218 .59565 L .57918 .60861 L p F P
0 0 0 r
s
.731 .196 .081 r
.69786 .43146 m .6761 .42766 L .67215 .40921 L p F P
0 0 0 r
s
.731 .196 .081 r
.65074 .40541 m .67215 .40921 L .6761 .42766 L p F P
0 0 0 r
s
.982 .295 .126 r
.5 .62969 m .47272 .638 L .47619 .63849 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.59249 .63159 m
.63577 .63786 L
s
.63577 .63786 m
.6461 .61503 L
s
.49 .12 .049 r
.49735 .36364 m .476 .35982 L .47783 .3494 L p F P
0 0 0 r
s
.49 .12 .049 r
.45799 .34582 m .47783 .3494 L .476 .35982 L p F P
0 0 0 r
s
.263 .395 .787 r
.44478 .6308 m .44642 .62713 L .47277 .6301 L p F P
0 0 0 r
s
.263 .395 .787 r
.47277 .6301 m .47188 .63196 L .44478 .6308 L p F P
0 0 0 r
s
.982 .295 .126 r
.5 .62969 m .46924 .63751 L .47272 .638 L closepath p F P
0 0 0 r
s
.288 .426 .769 r
.39358 .34845 m .39785 .33496 L .38932 .34429 L p F P
0 0 0 r
s
.288 .426 .769 r
.38932 .34429 m .38479 .35879 L .39358 .34845 L p F P
0 0 0 r
s
.83 .24 .1 r
.35946 .33276 m
.35783 .32253 L
s
.31285 .31438 m
.35783 .32253 L
s
.281 .421 .832 r
.5 .62969 m .46924 .63751 L .47012 .63567 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.31071 .62191 m
.35569 .62824 L
s
.35569 .62824 m
.36156 .61709 L
s
.309 .465 .9 r
.52538 .62964 m .5244 .6315 L .54793 .62989 L p F P
0 0 0 r
s
.309 .465 .9 r
.54793 .62989 m .54994 .62621 L .52538 .62964 L p F P
0 0 0 r
s
.296 .445 .87 r
.52148 .63705 m .52245 .63521 L .5 .62969 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.68937 .62144 m
.73213 .62778 L
s
.73213 .62778 m
.74234 .60033 L
s
.46514 .63183 m
.4693 .63242 L
s
.317 .477 .891 r
.60639 .58837 m .60218 .59565 L .62234 .58031 L p F P
0 0 0 r
s
.24 .35 .67 r
.61657 .58323 m
.62483 .5761 L
s
.317 .477 .891 r
.62234 .58031 m .62755 .57147 L .60639 .58837 L p F P
0 0 0 r
s
.024 .035 .067 r
.67295 .50963 m .66589 .52147 L .67588 .50019 L p F P
0 0 0 r
s
.024 .035 .067 r
.67588 .50019 m .68348 .48741 L .67295 .50963 L p F P
0 0 0 r
s
.24 .35 .67 r
.68434 .31224 m
.66166 .29022 L
s
.66166 .29022 m
.67735 .25853 L
s
.065 .095 .231 r
.35838 .46917 m .36274 .45554 L .36685 .47762 L p F P
0 0 0 r
s
.065 .095 .231 r
.36685 .47762 m .36258 .49061 L .35838 .46917 L p F P
0 0 0 r
s
.163 .246 .524 r
.37434 .55541 m .37805 .54505 L .39298 .56474 L p F P
0 0 0 r
s
.163 .246 .524 r
.39298 .56474 m .3896 .57368 L .37434 .55541 L p F P
0 0 0 r
s
.83 .24 .1 r
.80337 .50996 m
.80392 .47861 L
s
.76154 .47138 m
.80392 .47861 L
s
.635 .165 .068 r
.58573 .3939 m .5638 .39001 L .56069 .37499 L p F P
0 0 0 r
s
.635 .165 .068 r
.5397 .37123 m .56069 .37499 L .5638 .39001 L p F P
0 0 0 r
s
.281 .421 .832 r
.5 .62969 m .47012 .63567 L .471 .63382 L closepath p F P
0 0 0 r
s
.49 .12 .049 r
.476 .35982 m .45452 .35597 L .45799 .34582 L p F P
0 0 0 r
s
.49 .12 .049 r
.43805 .34222 m .45799 .34582 L .45452 .35597 L p F P
0 0 0 r
s
.731 .196 .081 r
.6761 .42766 m .6542 .42383 L .65074 .40541 L p F P
0 0 0 r
s
.83 .24 .1 r
.67407 .4273 m
.67423 .42843 L
s
.731 .196 .081 r
.6292 .4016 m .65074 .40541 L .6542 .42383 L p F P
0 0 0 r
s
.24 .35 .67 r
.5428 .23886 m
.55582 .20598 L
s
.5428 .23886 m
.51143 .23754 L
s
.296 .445 .87 r
.52245 .63521 m .52342 .63336 L .5 .62969 L closepath p F P
0 0 0 r
s
.243 .365 .736 r
.42402 .61547 m .42635 .60998 L .44976 .61972 L p F P
0 0 0 r
s
.243 .365 .736 r
.44976 .61972 m .44808 .62344 L .42402 .61547 L p F P
0 0 0 r
s
.83 .24 .1 r
.84555 .51698 m
.84219 .54985 L
s
.80337 .50996 m
.84555 .51698 L
s
.69782 .43254 m
.71718 .43592 L
s
.71864 .46406 m
.71718 .43592 L
s
.263 .395 .787 r
.44642 .62713 m .44808 .62344 L .47365 .62823 L p F P
0 0 0 r
s
.263 .395 .787 r
.47365 .62823 m .47277 .6301 L .44642 .62713 L p F P
0 0 0 r
s
.83 .24 .1 r
.45152 .62989 m
.46514 .63183 L
s
.44757 .63563 m
.45152 .62989 L
s
.238 .35 .612 r
.38035 .37298 m .38479 .35879 L .37882 .37317 L p F P
0 0 0 r
s
.238 .35 .612 r
.37882 .37317 m .37422 .38792 L .38035 .37298 L p F P
0 0 0 r
s
.045 .065 .149 r
.36226 .43497 m .36672 .42074 L .36719 .44159 L p F P
0 0 0 r
s
.24 .35 .67 r
.36237 .4399 m
.36343 .43654 L
s
.36684 .42574 m
.36814 .42159 L
s
.045 .065 .149 r
.36719 .44159 m .36274 .45554 L .36226 .43497 L p F P
0 0 0 r
s
.281 .421 .832 r
.5 .62969 m .471 .63382 L .47188 .63196 L closepath p F P
0 0 0 r
s
.309 .465 .9 r
.52636 .62777 m .52538 .62964 L .54994 .62621 L p F P
0 0 0 r
s
.309 .465 .9 r
.54994 .62621 m .55196 .62252 L .52636 .62777 L p F P
0 0 0 r
s
.319 .48 .919 r
.554 .61879 m .55196 .62252 L .57607 .61411 L p F P
0 0 0 r
s
.319 .48 .919 r
.57607 .61411 m .57918 .60861 L .554 .61879 L p F P
0 0 0 r
s
.83 .24 .1 r
.17113 .60722 m
.17248 .60246 L
s
.22 .332 .677 r
.40499 .59744 m .40789 .59019 L .4287 .60443 L p F P
0 0 0 r
s
.22 .332 .677 r
.4287 .60443 m .42635 .60998 L .40499 .59744 L p F P
0 0 0 r
s
.295 .444 .814 r
.63284 .56249 m .62755 .57147 L .64523 .55285 L p F P
0 0 0 r
s
.295 .444 .814 r
.64523 .55285 m .65142 .54244 L .63284 .56249 L p F P
0 0 0 r
s
.24 .35 .67 r
.6462 .54808 m
.64947 .54257 L
s
.296 .445 .87 r
.52342 .63336 m .5244 .6315 L .5 .62969 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.79361 .57592 m
.83591 .58255 L
s
.84219 .54985 m
.83591 .58255 L
s
.028 .04 .082 r
.69124 .47434 m .68348 .48741 L .6891 .46581 L p F P
0 0 0 r
s
.24 .35 .67 r
.67118 .49797 m
.68684 .47141 L
s
.028 .04 .082 r
.6891 .46581 m .69717 .4521 L .69124 .47434 L p F P
0 0 0 r
s
.83 .24 .1 r
.74234 .60033 m
.78494 .60682 L
s
.78494 .60682 m
.79361 .57592 L
s
.024 .035 .067 r
.36972 .40235 m .37422 .38792 L .37129 .40619 L p F P
0 0 0 r
s
.24 .35 .67 r
.37134 .40586 m
.37321 .39668 L
s
.024 .035 .067 r
.37129 .40619 m .36672 .42074 L .36972 .40235 L p F P
0 0 0 r
s
.24 .35 .67 r
.36814 .42159 m
.37125 .40632 L
s
.49 .12 .049 r
.45452 .35597 m .43291 .3521 L .43805 .34222 L p F P
0 0 0 r
s
.49 .12 .049 r
.41801 .3386 m .43805 .34222 L .43291 .3521 L p F P
0 0 0 r
s
.635 .165 .068 r
.5638 .39001 m .54174 .38611 L .5397 .37123 L p F P
0 0 0 r
s
.635 .165 .068 r
.51859 .36745 m .5397 .37123 L .54174 .38611 L p F P
0 0 0 r
s
.24 .35 .67 r
.70394 .41804 m
.69811 .39193 L
s
.69811 .39193 m
.71468 .36243 L
s
.731 .196 .081 r
.6542 .42383 m .63217 .41999 L .6292 .4016 L p F P
0 0 0 r
s
.731 .196 .081 r
.60753 .39776 m .6292 .4016 L .63217 .41999 L p F P
0 0 0 r
s
.125 .189 .421 r
.36643 .52438 m .37045 .5126 L .38182 .53449 L p F P
0 0 0 r
s
.125 .189 .421 r
.38182 .53449 m .37805 .54505 L .36643 .52438 L p F P
0 0 0 r
s
.281 .421 .832 r
.5 .62969 m .47188 .63196 L .47277 .6301 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.79988 .54302 m
.84219 .54985 L
s
.323 .486 .92 r
.58232 .60304 m .57918 .60861 L .60218 .59565 L p F P
0 0 0 r
s
.83 .24 .1 r
.59249 .63159 m
.6023 .60854 L
s
.323 .486 .92 r
.60218 .59565 m .60639 .58837 L .58232 .60304 L p F P
0 0 0 r
s
.296 .445 .87 r
.5244 .6315 m .52538 .62964 L .5 .62969 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.52178 .62965 m
.52546 .62948 L
s
.83 .24 .1 r
.31363 .32451 m
.31285 .31438 L
s
.26734 .30613 m
.31285 .31438 L
s
.26519 .6155 m
.31071 .62191 L
s
.31071 .62191 m
.31576 .61057 L
s
.799 .218 .091 r
.6761 .42766 m .69786 .43146 L .69717 .4521 L p F P
0 0 0 r
s
.24 .35 .67 r
.68684 .47141 m
.68777 .44602 L
s
.83 .24 .1 r
.67423 .42843 m
.6772 .42894 L
s
.24 .35 .67 r
.68777 .44602 m
.68944 .44313 L
s
.263 .395 .787 r
.44808 .62344 m .44976 .61972 L .47455 .62636 L p F P
0 0 0 r
s
.263 .395 .787 r
.47455 .62636 m .47365 .62823 L .44808 .62344 L p F P
0 0 0 r
s
.83 .24 .1 r
.6461 .61503 m
.68937 .62144 L
s
.68937 .62144 m
.69922 .59377 L
s
.24 .35 .67 r
.44391 .28227 m
.45474 .25022 L
s
.44391 .28227 m
.42132 .29617 L
s
.194 .292 .608 r
.3896 .57368 m .39298 .56474 L .41082 .58285 L p F P
0 0 0 r
s
.194 .292 .608 r
.41082 .58285 m .40789 .59019 L .3896 .57368 L p F P
0 0 0 r
s
.281 .421 .832 r
.5 .62969 m .47277 .6301 L .47365 .62823 L closepath p F P
0 0 0 r
s
.49 .12 .049 r
.43291 .3521 m .41118 .34821 L .41801 .3386 L p F P
0 0 0 r
s
.49 .12 .049 r
.39785 .33496 m .41801 .3386 L .41118 .34821 L p F P
0 0 0 r
s
.309 .465 .9 r
.52734 .62589 m .52636 .62777 L .55196 .62252 L p F P
0 0 0 r
s
.309 .465 .9 r
.55196 .62252 m .554 .61879 L .52734 .62589 L p F P
0 0 0 r
s
.296 .445 .87 r
.52538 .62964 m .52636 .62777 L .5 .62969 L closepath p F P
0 0 0 r
s
.635 .165 .068 r
.54174 .38611 m .51954 .38217 L .51859 .36745 L p F P
0 0 0 r
s
.635 .165 .068 r
.49735 .36364 m .51859 .36745 L .51954 .38217 L p F P
0 0 0 r
s
.24 .35 .67 r
.70229 .3366 m
.68434 .31224 L
s
.68434 .31224 m
.70065 .28084 L
s
.243 .365 .736 r
.42635 .60998 m .4287 .60443 L .45144 .61598 L p F P
0 0 0 r
s
.243 .365 .736 r
.45144 .61598 m .44976 .61972 L .42635 .60998 L p F P
0 0 0 r
s
.24 .35 .67 r
.45141 .61596 m
.45196 .61474 L
s
.83 .24 .1 r
.76068 .50287 m
.76154 .47138 L
s
.71864 .46406 m
.76154 .47138 L
s
.252 .38 .679 r
.65773 .53184 m .65142 .54244 L .66589 .52147 L p F P
0 0 0 r
s
.252 .38 .679 r
.66589 .52147 m .67295 .50963 L .65773 .53184 L p F P
0 0 0 r
s
.24 .35 .67 r
.64947 .54257 m
.66355 .5216 L
s
.731 .196 .081 r
.63217 .41999 m .61001 .41611 L .60753 .39776 L p F P
0 0 0 r
s
.83 .24 .1 r
.63063 .41972 m
.63077 .42084 L
s
.731 .196 .081 r
.58573 .3939 m .60753 .39776 L .61001 .41611 L p F P
0 0 0 r
s
.83 .24 .1 r
.79988 .54302 m
.80337 .50996 L
s
.76068 .50287 m
.80337 .50996 L
s
.317 .477 .891 r
.61065 .581 m .60639 .58837 L .62755 .57147 L p F P
0 0 0 r
s
.317 .477 .891 r
.62755 .57147 m .63284 .56249 L .61065 .581 L p F P
0 0 0 r
s
.281 .421 .832 r
.5 .62969 m .47365 .62823 L .47455 .62636 L closepath p F P
0 0 0 r
s
.319 .48 .919 r
.55605 .61504 m .554 .61879 L .57918 .60861 L p F P
0 0 0 r
s
.319 .48 .919 r
.57918 .60861 m .58232 .60304 L .55605 .61504 L p F P
0 0 0 r
s
.24 .35 .67 r
.51143 .23754 m
.52381 .2044 L
s
.51143 .23754 m
.48168 .24133 L
s
.085 .126 .306 r
.36258 .49061 m .36685 .47762 L .37455 .50058 L p F P
0 0 0 r
s
.085 .126 .306 r
.37455 .50058 m .37045 .5126 L .36258 .49061 L p F P
0 0 0 r
s
.296 .445 .87 r
.52636 .62777 m .52734 .62589 L .5 .62969 L closepath p F P
0 0 0 r
s
.799 .218 .091 r
.69717 .4521 m .67548 .44837 L .6761 .42766 L p F P
0 0 0 r
s
.24 .35 .67 r
.69634 .43119 m
.70394 .41804 L
s
.799 .218 .091 r
.6542 .42383 m .6761 .42766 L .67548 .44837 L p F P
0 0 0 r
s
.281 .421 .832 r
.5 .62969 m .47905 .61688 L .47996 .61497 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.49641 .62706 m
.5075 .62865 L
s
.83 .24 .1 r
.499 .62956 m
.49919 .6292 L
s
.281 .421 .832 r
.5 .62969 m .47996 .61497 L .48088 .61304 L closepath p F P
0 0 0 r
s
.281 .421 .832 r
.5 .62969 m .48088 .61304 L .4818 .61112 L closepath p F P
0 0 0 r
s
1 .298 .127 r
.5278 .61781 m .53132 .61832 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .298 .127 r
.52429 .61729 m .5278 .61781 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .298 .127 r
.52076 .61678 m .52429 .61729 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .298 .127 r
.51724 .61627 m .52076 .61678 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .298 .127 r
.51371 .61576 m .51724 .61627 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .298 .127 r
.51018 .61524 m .51371 .61576 L .5 .62969 L closepath p F P
0 0 0 r
s
.281 .421 .832 r
.5 .62969 m .47455 .62636 L .47544 .62448 L closepath p F P
0 0 0 r
s
.281 .421 .832 r
.5 .62969 m .47544 .62448 L .47634 .62259 L closepath p F P
0 0 0 r
s
.281 .421 .832 r
.5 .62969 m .47634 .62259 L .47724 .62069 L closepath p F P
0 0 0 r
s
.281 .421 .832 r
.5 .62969 m .47724 .62069 L .47815 .61879 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.49403 .62672 m
.49547 .62692 L
s
.281 .421 .832 r
.5 .62969 m .47815 .61879 L .47905 .61688 L closepath p F P
0 0 0 r
s
.296 .445 .87 r
.53032 .62022 m .53132 .61832 L .5 .62969 L closepath p F P
0 0 0 r
s
.296 .445 .87 r
.52932 .62212 m .53032 .62022 L .5 .62969 L closepath p F P
0 0 0 r
s
.296 .445 .87 r
.52833 .62401 m .52932 .62212 L .5 .62969 L closepath p F P
0 0 0 r
s
.296 .445 .87 r
.52734 .62589 m .52833 .62401 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .298 .127 r
.50664 .61473 m .51018 .61524 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .298 .127 r
.5031 .61421 m .50664 .61473 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .298 .127 r
.49956 .6137 m .5031 .61421 L .5 .62969 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.4993 .62898 m
.49994 .62768 L
s
1 .298 .127 r
.49601 .61318 m .49956 .6137 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .298 .127 r
.49246 .61267 m .49601 .61318 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .298 .127 r
.48891 .61215 m .49246 .61267 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .298 .127 r
.48536 .61163 m .48891 .61215 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .298 .127 r
.4818 .61112 m .48536 .61163 L .5 .62969 L closepath p F P
0 0 0 r
s
.263 .395 .787 r
.44976 .61972 m .45144 .61598 L .47544 .62448 L p F P
0 0 0 r
s
.263 .395 .787 r
.47544 .62448 m .47455 .62636 L .44976 .61972 L p F P
0 0 0 r
s
.49 .12 .049 r
.41118 .34821 m .38932 .34429 L .39785 .33496 L p F P
0 0 0 r
s
.24 .35 .67 r
.39397 .34526 m
.39407 .34515 L
s
.38467 .37464 m
.39397 .34526 L
s
.39612 .33846 m
.40369 .31454 L
s
.39397 .34526 m
.39401 .34513 L
s
.83 .24 .1 r
.75081 .56921 m
.79361 .57592 L
s
.79361 .57592 m
.79988 .54302 L
s
.69922 .59377 m
.74234 .60033 L
s
.74234 .60033 m
.75081 .56921 L
s
.635 .165 .068 r
.51954 .38217 m .49722 .37822 L .49735 .36364 L p F P
0 0 0 r
s
.635 .165 .068 r
.476 .35982 m .49735 .36364 L .49722 .37822 L p F P
0 0 0 r
s
.22 .332 .677 r
.40789 .59019 m .41082 .58285 L .43108 .59883 L p F P
0 0 0 r
s
.22 .332 .677 r
.43108 .59883 m .4287 .60443 L .40789 .59019 L p F P
0 0 0 r
s
.309 .465 .9 r
.52833 .62401 m .52734 .62589 L .554 .61879 L p F P
0 0 0 r
s
.83 .24 .1 r
.5487 .62525 m
.59249 .63159 L
s
.53936 .64239 m
.5487 .62525 L
s
.309 .465 .9 r
.554 .61879 m .55605 .61504 L .52833 .62401 L p F P
0 0 0 r
s
.163 .246 .524 r
.37805 .54505 m .38182 .53449 L .39641 .55564 L p F P
0 0 0 r
s
.24 .35 .67 r
.37881 .54605 m
.37898 .54559 L
s
.163 .246 .524 r
.39641 .55564 m .39298 .56474 L .37805 .54505 L p F P
0 0 0 r
s
.731 .196 .081 r
.61001 .41611 m .58772 .41222 L .58573 .3939 L p F P
0 0 0 r
s
.731 .196 .081 r
.5638 .39001 m .58573 .3939 L .58772 .41222 L p F P
0 0 0 r
s
.83 .24 .1 r
.75705 .5361 m
.79988 .54302 L
s
.24 .35 .67 r
.42944 .60269 m
.45196 .61474 L
s
.024 .035 .067 r
.68016 .49755 m .67295 .50963 L .68348 .48741 L p F P
0 0 0 r
s
.024 .035 .067 r
.68348 .48741 m .69124 .47434 L .68016 .49755 L p F P
0 0 0 r
s
.83 .24 .1 r
.26723 .31616 m
.26734 .30613 L
s
.22128 .29779 m
.26734 .30613 L
s
.21911 .60902 m
.26519 .6155 L
s
.26519 .6155 m
.2694 .60397 L
s
.323 .486 .92 r
.58549 .59743 m .58232 .60304 L .60639 .58837 L p F P
0 0 0 r
s
.323 .486 .92 r
.60639 .58837 m .61065 .581 L .58549 .59743 L p F P
0 0 0 r
s
.799 .218 .091 r
.67548 .44837 m .65366 .44462 L .6542 .42383 L p F P
0 0 0 r
s
.799 .218 .091 r
.63217 .41999 m .6542 .42383 L .65366 .44462 L p F P
0 0 0 r
s
.83 .24 .1 r
.63077 .42084 m
.63331 .42128 L
s
.263 .395 .787 r
.47634 .62259 m .47544 .62448 L .45144 .61598 L p F P
0 0 0 r
s
.24 .35 .67 r
.45196 .61474 m
.47321 .62176 L
s
.83 .24 .1 r
.40681 .62353 m
.45152 .62989 L
s
.065 .095 .231 r
.36274 .45554 m .36719 .44159 L .37121 .46434 L p F P
0 0 0 r
s
.065 .095 .231 r
.37121 .46434 m .36685 .47762 L .36274 .45554 L p F P
0 0 0 r
s
.83 .24 .1 r
.6023 .60854 m
.6461 .61503 L
s
.6461 .61503 m
.65557 .58713 L
s
.36156 .61709 m
.40681 .62353 L
s
.40681 .62353 m
.41411 .60576 L
s
.243 .365 .736 r
.4287 .60443 m .43108 .59883 L .45313 .61221 L p F P
0 0 0 r
s
.243 .365 .736 r
.45313 .61221 m .45144 .61598 L .4287 .60443 L p F P
0 0 0 r
s
.309 .465 .9 r
.52932 .62212 m .52833 .62401 L .55605 .61504 L p F P
0 0 0 r
s
.83 .24 .1 r
.53098 .62268 m
.53514 .62328 L
s
.53514 .62328 m
.5487 .62525 L
s
.295 .444 .814 r
.63822 .55336 m .63284 .56249 L .65142 .54244 L p F P
0 0 0 r
s
.295 .444 .814 r
.65142 .54244 m .65773 .53184 L .63822 .55336 L p F P
0 0 0 r
s
.83 .24 .1 r
.35946 .33276 m
.39416 .339 L
s
.635 .165 .068 r
.49722 .37822 m .47475 .37424 L .476 .35982 L p F P
0 0 0 r
s
.635 .165 .068 r
.45452 .35597 m .476 .35982 L .47475 .37424 L p F P
0 0 0 r
s
.263 .395 .787 r
.45144 .61598 m .45313 .61221 L .47634 .62259 L p F P
0 0 0 r
s
.83 .24 .1 r
.71748 .49569 m
.71864 .46406 L
s
.731 .196 .081 r
.58772 .41222 m .56528 .4083 L .5638 .39001 L p F P
0 0 0 r
s
.83 .24 .1 r
.58667 .41204 m
.58678 .41316 L
s
.731 .196 .081 r
.54174 .38611 m .5638 .39001 L .56528 .4083 L p F P
0 0 0 r
s
.319 .48 .919 r
.55811 .61126 m .55605 .61504 L .58232 .60304 L p F P
0 0 0 r
s
.319 .48 .919 r
.58232 .60304 m .58549 .59743 L .55811 .61126 L p F P
0 0 0 r
s
.238 .35 .612 r
.38479 .35879 m .38932 .34429 L .38352 .35808 L p F P
0 0 0 r
s
.238 .35 .612 r
.38352 .35808 m .37882 .37317 L .38479 .35879 L p F P
0 0 0 r
s
.263 .395 .787 r
.47724 .62069 m .47634 .62259 L .45313 .61221 L p F P
0 0 0 r
s
.309 .465 .9 r
.55605 .61504 m .55811 .61126 L .52932 .62212 L p F P
0 0 0 r
s
.309 .465 .9 r
.53032 .62022 m .52932 .62212 L .55811 .61126 L p F P
0 0 0 r
s
.83 .24 .1 r
.75705 .5361 m
.76068 .50287 L
s
.71748 .49569 m
.76068 .50287 L
s
.045 .065 .149 r
.36672 .42074 m .37129 .40619 L .37175 .42733 L p F P
0 0 0 r
s
.045 .065 .149 r
.37175 .42733 m .36719 .44159 L .36672 .42074 L p F P
0 0 0 r
s
.194 .292 .608 r
.39298 .56474 m .39641 .55564 L .4138 .5754 L p F P
0 0 0 r
s
.194 .292 .608 r
.4138 .5754 m .41082 .58285 L .39298 .56474 L p F P
0 0 0 r
s
.848 .235 .098 r
.67548 .44837 m .69717 .4521 L .69124 .47434 L p F P
0 0 0 r
s
.83 .24 .1 r
.69605 .4602 m
.71864 .46406 L
s
.69505 .46003 m
.69605 .4602 L
s
.24 .35 .67 r
.69457 .45829 m
.70321 .44363 L
s
.69411 .45907 m
.69457 .45829 L
s
.68684 .47141 m
.68813 .46921 L
s
.125 .189 .421 r
.37045 .5126 m .37455 .50058 L .38567 .52374 L p F P
0 0 0 r
s
.125 .189 .421 r
.38567 .52374 m .38182 .53449 L .37045 .5126 L p F P
0 0 0 r
s
.799 .218 .091 r
.65366 .44462 m .63171 .44085 L .63217 .41999 L p F P
0 0 0 r
s
.799 .218 .091 r
.61001 .41611 m .63217 .41999 L .63171 .44085 L p F P
0 0 0 r
s
.024 .035 .067 r
.37422 .38792 m .37882 .37317 L .37596 .3913 L p F P
0 0 0 r
s
.24 .35 .67 r
.37321 .39668 m
.3753 .39001 L
s
.37704 .38443 m
.38237 .3674 L
s
.024 .035 .067 r
.37596 .3913 m .37129 .40619 L .37422 .38792 L p F P
0 0 0 r
s
.263 .395 .787 r
.45313 .61221 m .45484 .60841 L .47724 .62069 L p F P
0 0 0 r
s
.263 .395 .787 r
.47815 .61879 m .47724 .62069 L .45484 .60841 L p F P
0 0 0 r
s
.83 .24 .1 r
.70749 .56242 m
.75081 .56921 L
s
.75081 .56921 m
.75705 .5361 L
s
.635 .165 .068 r
.47475 .37424 m .45215 .37024 L .45452 .35597 L p F P
0 0 0 r
s
.635 .165 .068 r
.43291 .3521 m .45452 .35597 L .45215 .37024 L p F P
0 0 0 r
s
.83 .24 .1 r
.65557 .58713 m
.69922 .59377 L
s
.69922 .59377 m
.70749 .56242 L
s
.309 .465 .9 r
.53132 .61832 m .53032 .62022 L .56019 .60746 L p F P
0 0 0 r
s
.309 .465 .9 r
.55811 .61126 m .56019 .60746 L .53032 .62022 L p F P
0 0 0 r
s
.83 .24 .1 r
.5487 .62525 m
.55356 .61306 L
s
.24 .35 .67 r
.71468 .36243 m
.70229 .3366 L
s
.70229 .3366 m
.71916 .30548 L
s
.317 .477 .891 r
.61498 .57353 m .61065 .581 L .63284 .56249 L p F P
0 0 0 r
s
.317 .477 .891 r
.63284 .56249 m .63822 .55336 L .61498 .57353 L p F P
0 0 0 r
s
.24 .35 .67 r
.62784 .56237 m
.62934 .55981 L
s
.243 .365 .736 r
.45484 .60841 m .45313 .61221 L .43108 .59883 L p F P
0 0 0 r
s
.24 .35 .67 r
.72086 .38877 m
.70394 .41804 L
s
.70321 .44363 m
.70394 .41804 L
s
.731 .196 .081 r
.56528 .4083 m .54271 .40436 L .54174 .38611 L p F P
0 0 0 r
s
.731 .196 .081 r
.51954 .38217 m .54174 .38611 L .54271 .40436 L p F P
0 0 0 r
s
.22 .332 .677 r
.41082 .58285 m .4138 .5754 L .43348 .59317 L p F P
0 0 0 r
s
.22 .332 .677 r
.43348 .59317 m .43108 .59883 L .41082 .58285 L p F P
0 0 0 r
s
.83 .24 .1 r
.7137 .5291 m
.75705 .5361 L
s
.263 .395 .787 r
.45484 .60841 m .45656 .60459 L .47815 .61879 L p F P
0 0 0 r
s
.263 .395 .787 r
.47905 .61688 m .47815 .61879 L .45656 .60459 L p F P
0 0 0 r
s
.319 .48 .919 r
.56019 .60746 m .55811 .61126 L .58549 .59743 L p F P
0 0 0 r
s
.252 .38 .679 r
.66416 .52104 m .65773 .53184 L .67295 .50963 L p F P
0 0 0 r
s
.252 .38 .679 r
.67295 .50963 m .68016 .49755 L .66416 .52104 L p F P
0 0 0 r
s
.24 .35 .67 r
.66355 .5216 m
.67924 .49521 L
s
.243 .365 .736 r
.43108 .59883 m .43348 .59317 L .45484 .60841 L p F P
0 0 0 r
s
.83 .24 .1 r
.22026 .30771 m
.22128 .29779 L
s
.17248 .60246 m
.21911 .60902 L
s
.21911 .60902 m
.22247 .59729 L
s
.24 .35 .67 r
.48168 .24133 m
.4935 .20796 L
s
.48168 .24133 m
.45474 .25022 L
s
.309 .465 .9 r
.56019 .60746 m .56228 .60363 L .53132 .61832 L p F P
0 0 0 r
s
1 .295 .126 r
.53132 .61832 m .5278 .61781 L .55532 .6026 L p F P
0 0 0 r
s
1 .295 .126 r
.55532 .6026 m .56228 .60363 L .53132 .61832 L p F P
0 0 0 r
s
.83 .24 .1 r
.55759 .60294 m
.55797 .60198 L
s
.848 .235 .098 r
.69124 .47434 m .67019 .47079 L .67548 .44837 L p F P
0 0 0 r
s
.24 .35 .67 r
.67924 .49521 m
.68618 .47349 L
s
.83 .24 .1 r
.67493 .44828 m
.67501 .45036 L
s
.848 .235 .098 r
.65366 .44462 m .67548 .44837 L .67019 .47079 L p F P
0 0 0 r
s
.24 .35 .67 r
.65017 .2393 m
.62014 .22379 L
s
.62014 .22379 m
.63515 .19001 L
s
.62014 .22379 m
.58831 .21254 L
s
.799 .218 .091 r
.63171 .44085 m .60962 .43706 L .61001 .41611 L p F P
0 0 0 r
s
.799 .218 .091 r
.58772 .41222 m .61001 .41611 L .60962 .43706 L p F P
0 0 0 r
s
.83 .24 .1 r
.58678 .41316 m
.58887 .41353 L
s
1 .295 .126 r
.5278 .61781 m .52429 .61729 L .54834 .60157 L p F P
0 0 0 r
s
1 .295 .126 r
.54834 .60157 m .55532 .6026 L .5278 .61781 L p F P
0 0 0 r
s
.83 .24 .1 r
.55356 .61306 m
.55454 .61059 L
s
.31576 .61057 m
.36156 .61709 L
s
.36156 .61709 m
.36815 .5991 L
s
.323 .486 .92 r
.5887 .59175 m .58549 .59743 L .61065 .581 L p F P
0 0 0 r
s
.323 .486 .92 r
.61065 .581 m .61498 .57353 L .5887 .59175 L p F P
0 0 0 r
s
.635 .165 .068 r
.45215 .37024 m .42942 .36621 L .43291 .3521 L p F P
0 0 0 r
s
.635 .165 .068 r
.41118 .34821 m .43291 .3521 L .42942 .36621 L p F P
0 0 0 r
s
1 .295 .126 r
.52429 .61729 m .52076 .61678 L .54135 .60053 L p F P
0 0 0 r
s
1 .295 .126 r
.54135 .60053 m .54834 .60157 L .52429 .61729 L p F P
0 0 0 r
s
.24 .35 .67 r
.42132 .29617 m
.43177 .26403 L
s
.42132 .29617 m
.40369 .31454 L
s
.319 .48 .919 r
.58549 .59743 m .5887 .59175 L .56019 .60746 L p F P
0 0 0 r
s
.83 .24 .1 r
.35975 .34987 m
.35946 .33276 L
s
.31363 .32451 m
.35946 .33276 L
s
.263 .395 .787 r
.45656 .60459 m .45829 .60073 L .47905 .61688 L p F P
0 0 0 r
s
.263 .395 .787 r
.47996 .61497 m .47905 .61688 L .45829 .60073 L p F P
0 0 0 r
s
.83 .24 .1 r
.47335 .61434 m
.47757 .61495 L
s
.24 .35 .67 r
.67735 .25853 m
.65017 .2393 L
s
.65017 .2393 m
.66589 .20583 L
s
1 .295 .126 r
.52076 .61678 m .51724 .61627 L .53434 .59949 L p F P
0 0 0 r
s
1 .295 .126 r
.53434 .59949 m .54135 .60053 L .52076 .61678 L p F P
0 0 0 r
s
.085 .126 .306 r
.36685 .47762 m .37121 .46434 L .37874 .48831 L p F P
0 0 0 r
s
.085 .126 .306 r
.37874 .48831 m .37455 .50058 L .36685 .47762 L p F P
0 0 0 r
s
.731 .196 .081 r
.54271 .40436 m .52 .40039 L .51954 .38217 L p F P
0 0 0 r
s
.83 .24 .1 r
.54218 .40426 m
.54225 .40539 L
s
.731 .196 .081 r
.49722 .37822 m .51954 .38217 L .52 .40039 L p F P
0 0 0 r
s
.163 .246 .524 r
.38182 .53449 m .38567 .52374 L .39989 .5464 L p F P
0 0 0 r
s
.24 .35 .67 r
.38257 .53558 m
.38274 .5351 L
s
.163 .246 .524 r
.39989 .5464 m .39641 .55564 L .38182 .53449 L p F P
0 0 0 r
s
.24 .35 .67 r
.58831 .21254 m
.60261 .17845 L
s
.58831 .21254 m
.55582 .20598 L
s
1 .295 .126 r
.51724 .61627 m .51371 .61576 L .52732 .59846 L p F P
0 0 0 r
s
1 .295 .126 r
.52732 .59846 m .53434 .59949 L .51724 .61627 L p F P
0 0 0 r
s
.243 .365 .736 r
.45656 .60459 m .45484 .60841 L .43348 .59317 L p F P
0 0 0 r
s
1 .295 .126 r
.51371 .61576 m .51018 .61524 L .52029 .59741 L p F P
0 0 0 r
s
1 .295 .126 r
.52029 .59741 m .52732 .59846 L .51371 .61576 L p F P
0 0 0 r
s
.24 .35 .67 r
.52473 .61328 m
.52862 .60575 L
s
.52355 .61556 m
.52473 .61328 L
s
.83 .24 .1 r
.7137 .5291 m
.71748 .49569 L
s
1 .295 .126 r
.51018 .61524 m .50664 .61473 L .51325 .59637 L p F P
0 0 0 r
s
1 .295 .126 r
.51325 .59637 m .52029 .59741 L .51018 .61524 L p F P
0 0 0 r
s
.848 .235 .098 r
.67019 .47079 m .64902 .46722 L .65366 .44462 L p F P
0 0 0 r
s
.848 .235 .098 r
.63171 .44085 m .65366 .44462 L .64902 .46722 L p F P
0 0 0 r
s
.319 .48 .919 r
.56228 .60363 m .56019 .60746 L .5887 .59175 L p F P
0 0 0 r
s
.83 .24 .1 r
.57193 .60404 m
.6023 .60854 L
s
.56833 .60351 m
.57193 .60404 L
s
.56571 .60312 m
.56833 .60351 L
s
.263 .395 .787 r
.45829 .60073 m .46003 .59686 L .47996 .61497 L p F P
0 0 0 r
s
.83 .24 .1 r
.45152 .62989 m
.45951 .61233 L
s
.263 .395 .787 r
.48088 .61304 m .47996 .61497 L .46003 .59686 L p F P
0 0 0 r
s
1 .295 .126 r
.50664 .61473 m .5031 .61421 L .50619 .59533 L p F P
0 0 0 r
s
1 .295 .126 r
.50619 .59533 m .51325 .59637 L .50664 .61473 L p F P
0 0 0 r
s
.83 .24 .1 r
.51275 .5963 m
.51311 .59533 L
s
.799 .218 .091 r
.60962 .43706 m .5874 .43324 L .58772 .41222 L p F P
0 0 0 r
s
.799 .218 .091 r
.56528 .4083 m .58772 .41222 L .5874 .43324 L p F P
0 0 0 r
s
1 .295 .126 r
.5031 .61421 m .49956 .6137 L .49912 .59428 L p F P
0 0 0 r
s
1 .295 .126 r
.49912 .59428 m .50619 .59533 L .5031 .61421 L p F P
0 0 0 r
s
.635 .165 .068 r
.42942 .36621 m .40654 .36216 L .41118 .34821 L p F P
0 0 0 r
s
.635 .165 .068 r
.38932 .34429 m .41118 .34821 L .40654 .36216 L p F P
0 0 0 r
s
.24 .35 .67 r
.38237 .3674 m
.39266 .34776 L
s
.83 .24 .1 r
.66364 .55555 m
.70749 .56242 L
s
.70749 .56242 m
.7137 .5291 L
s
.24 .35 .67 r
.52862 .60575 m
.54886 .60497 L
s
.295 .444 .814 r
.64369 .54408 m .63822 .55336 L .65773 .53184 L p F P
0 0 0 r
s
.24 .35 .67 r
.62934 .55981 m
.6396 .55102 L
s
.295 .444 .814 r
.65773 .53184 m .66416 .52104 L .64369 .54408 L p F P
0 0 0 r
s
.83 .24 .1 r
.65557 .58713 m
.66364 .55555 L
s
1 .295 .126 r
.49956 .6137 m .49601 .61318 L .49203 .59323 L p F P
0 0 0 r
s
1 .295 .126 r
.49203 .59323 m .49912 .59428 L .49956 .6137 L p F P
0 0 0 r
s
.887 .248 .104 r
.67019 .47079 m .69124 .47434 L .68016 .49755 L p F P
0 0 0 r
s
.24 .35 .67 r
.68288 .4891 m
.68381 .48753 L
s
.67924 .49521 m
.67927 .49517 L
s
.68381 .48753 m
.69566 .4676 L
s
.83 .24 .1 r
.68373 .49008 m
.71748 .49569 L
s
.194 .292 .608 r
.39641 .55564 m .39989 .5464 L .41681 .56786 L p F P
0 0 0 r
s
.24 .35 .67 r
.40593 .55406 m
.40625 .55324 L
s
.194 .292 .608 r
.41681 .56786 m .4138 .5754 L .39641 .55564 L p F P
0 0 0 r
s
1 .295 .126 r
.49601 .61318 m .49246 .61267 L .48494 .59218 L p F P
0 0 0 r
s
1 .295 .126 r
.48494 .59218 m .49203 .59323 L .49601 .61318 L p F P
0 0 0 r
s
.731 .196 .081 r
.52 .40039 m .49715 .3964 L .49722 .37822 L p F P
0 0 0 r
s
.731 .196 .081 r
.47475 .37424 m .49722 .37822 L .49715 .3964 L p F P
0 0 0 r
s
.263 .395 .787 r
.46003 .59686 m .46179 .59295 L .48088 .61304 L p F P
0 0 0 r
s
.263 .395 .787 r
.4818 .61112 m .48088 .61304 L .46179 .59295 L p F P
0 0 0 r
s
.83 .24 .1 r
.45951 .61233 m
.47335 .61434 L
s
.22 .332 .677 r
.4359 .58745 m .43348 .59317 L .4138 .5754 L p F P
0 0 0 r
s
.243 .365 .736 r
.43348 .59317 m .4359 .58745 L .45656 .60459 L p F P
0 0 0 r
s
.83 .24 .1 r
.41411 .60576 m
.45951 .61233 L
s
1 .295 .126 r
.49246 .61267 m .48891 .61215 L .47782 .59113 L p F P
0 0 0 r
s
1 .295 .126 r
.47782 .59113 m .48494 .59218 L .49246 .61267 L p F P
0 0 0 r
s
.24 .35 .67 r
.49077 .61079 m
.49188 .60849 L
s
.49188 .60849 m
.49556 .60089 L
s
.70065 .28084 m
.67735 .25853 L
s
.67735 .25853 m
.69376 .22537 L
s
.83 .24 .1 r
.66982 .52201 m
.7137 .5291 L
s
.065 .095 .231 r
.36719 .44159 m .37175 .42733 L .37568 .45076 L p F P
0 0 0 r
s
.065 .095 .231 r
.37568 .45076 m .37121 .46434 L .36719 .44159 L p F P
0 0 0 r
s
1 .295 .126 r
.48891 .61215 m .48536 .61163 L .4707 .59007 L p F P
0 0 0 r
s
1 .295 .126 r
.4707 .59007 m .47782 .59113 L .48891 .61215 L p F P
0 0 0 r
s
.22 .332 .677 r
.4138 .5754 m .41681 .56786 L .4359 .58745 L p F P
0 0 0 r
s
.243 .365 .736 r
.45829 .60073 m .45656 .60459 L .4359 .58745 L p F P
0 0 0 r
s
.83 .24 .1 r
.17248 .60246 m
.17496 .59053 L
s
.848 .235 .098 r
.64902 .46722 m .62772 .46363 L .63171 .44085 L p F P
0 0 0 r
s
.83 .24 .1 r
.63114 .44075 m
.63119 .4438 L
s
.848 .235 .098 r
.60962 .43706 m .63171 .44085 L .62772 .46363 L p F P
0 0 0 r
s
1 .295 .126 r
.48536 .61163 m .4818 .61112 L .46356 .58902 L p F P
0 0 0 r
s
1 .295 .126 r
.46356 .58902 m .4707 .59007 L .48536 .61163 L p F P
0 0 0 r
s
.319 .48 .919 r
.5887 .59175 m .59194 .58601 L .56228 .60363 L p F P
0 0 0 r
s
.83 .24 .1 r
.55797 .60198 m
.56365 .60282 L
s
.323 .486 .92 r
.59194 .58601 m .5887 .59175 L .61498 .57353 L p F P
0 0 0 r
s
.24 .35 .67 r
.55582 .20598 m
.56943 .17158 L
s
.55582 .20598 m
.52381 .2044 L
s
.799 .218 .091 r
.5874 .43324 m .56505 .4294 L .56528 .4083 L p F P
0 0 0 r
s
.799 .218 .091 r
.54271 .40436 m .56528 .4083 L .56505 .4294 L p F P
0 0 0 r
s
.83 .24 .1 r
.54225 .40539 m
.54389 .40568 L
s
.2694 .60397 m
.31576 .61057 L
s
.31576 .61057 m
.32161 .59236 L
s
1 .29 .123 r
.56228 .60363 m .55532 .6026 L .58169 .58447 L p F P
0 0 0 r
s
1 .29 .123 r
.58169 .58447 m .59194 .58601 L .56228 .60363 L p F P
0 0 0 r
s
.263 .395 .787 r
.46179 .59295 m .46356 .58902 L .4818 .61112 L p F P
0 0 0 r
s
.317 .477 .891 r
.61936 .56596 m .61498 .57353 L .63822 .55336 L p F P
0 0 0 r
s
.317 .477 .891 r
.63822 .55336 m .64369 .54408 L .61936 .56596 L p F P
0 0 0 r
s
.635 .165 .068 r
.40654 .36216 m .38352 .35808 L .38932 .34429 L p F P
0 0 0 r
s
.24 .35 .67 r
.38663 .35379 m
.38724 .35185 L
s
.38724 .35185 m
.39196 .33677 L
s
.83 .24 .1 r
.3131 .34158 m
.31363 .32451 L
s
.26723 .31616 m
.31363 .32451 L
s
.887 .248 .104 r
.68016 .49755 m .6603 .49427 L .67019 .47079 L p F P
0 0 0 r
s
.887 .248 .104 r
.64902 .46722 m .67019 .47079 L .6603 .49427 L p F P
0 0 0 r
s
.125 .189 .421 r
.37455 .50058 m .37874 .48831 L .38958 .51279 L p F P
0 0 0 r
s
.125 .189 .421 r
.38958 .51279 m .38567 .52374 L .37455 .50058 L p F P
0 0 0 r
s
.323 .486 .92 r
.61498 .57353 m .61936 .56596 L .59194 .58601 L p F P
0 0 0 r
s
.83 .24 .1 r
.6023 .60854 m
.6114 .5804 L
s
.6114 .5804 m
.65557 .58713 L
s
1 .29 .123 r
.55532 .6026 m .54834 .60157 L .57142 .58291 L p F P
0 0 0 r
s
.83 .24 .1 r
.55606 .60169 m
.55653 .60176 L
s
1 .29 .123 r
.57142 .58291 m .58169 .58447 L .55532 .6026 L p F P
0 0 0 r
s
.731 .196 .081 r
.49715 .3964 m .47416 .39238 L .47475 .37424 L p F P
0 0 0 r
s
.731 .196 .081 r
.45215 .37024 m .47475 .37424 L .47416 .39238 L p F P
0 0 0 r
s
.045 .065 .149 r
.37129 .40619 m .37596 .3913 L .37641 .41274 L p F P
0 0 0 r
s
.24 .35 .67 r
.3714 .41126 m
.3725 .40775 L
s
.37607 .39644 m
.37731 .39249 L
s
.045 .065 .149 r
.37641 .41274 m .37175 .42733 L .37129 .40619 L p F P
0 0 0 r
s
1 .29 .123 r
.54834 .60157 m .54135 .60053 L .56112 .58136 L p F P
0 0 0 r
s
.83 .24 .1 r
.54893 .60064 m
.5494 .60071 L
s
1 .29 .123 r
.56112 .58136 m .57142 .58291 L .54834 .60157 L p F P
0 0 0 r
s
.24 .35 .67 r
.56285 .60024 m
.56365 .59878 L
s
.024 .035 .067 r
.37882 .37317 m .38352 .35808 L .38074 .37606 L p F P
0 0 0 r
s
.24 .35 .67 r
.38237 .3674 m
.3852 .35838 L
s
.38113 .37358 m
.38237 .3674 L
s
.024 .035 .067 r
.38074 .37606 m .37596 .3913 L .37882 .37317 L p F P
0 0 0 r
s
.24 .35 .67 r
.37731 .39249 m
.38041 .37711 L
s
.72086 .38877 m
.71468 .36243 L
s
.71468 .36243 m
.73203 .33157 L
s
.848 .235 .098 r
.62772 .46363 m .60629 .46002 L .60962 .43706 L p F P
0 0 0 r
s
.848 .235 .098 r
.5874 .43324 m .60962 .43706 L .60629 .46002 L p F P
0 0 0 r
s
.243 .365 .736 r
.4359 .58745 m .43835 .58166 L .45829 .60073 L p F P
0 0 0 r
s
.243 .365 .736 r
.46003 .59686 m .45829 .60073 L .43835 .58166 L p F P
0 0 0 r
s
.83 .24 .1 r
.45951 .61233 m
.46379 .5999 L
s
.46379 .5999 m
.46466 .59738 L
s
.799 .218 .091 r
.56505 .4294 m .54256 .42554 L .54271 .40436 L p F P
0 0 0 r
s
.799 .218 .091 r
.52 .40039 m .54271 .40436 L .54256 .42554 L p F P
0 0 0 r
s
1 .29 .123 r
.54135 .60053 m .53434 .59949 L .55079 .5798 L p F P
0 0 0 r
s
.83 .24 .1 r
.54178 .59958 m
.54226 .59965 L
s
1 .29 .123 r
.55079 .5798 m .56112 .58136 L .54135 .60053 L p F P
0 0 0 r
s
.918 .259 .109 r
.6603 .49427 m .68016 .49755 L .66416 .52104 L p F P
0 0 0 r
s
.83 .24 .1 r
.66982 .52201 m
.67038 .51723 L
s
.67038 .51723 m
.67111 .511 L
s
.24 .35 .67 r
.66709 .51327 m
.66974 .50934 L
s
.66505 .5163 m
.66709 .51327 L
s
.83 .24 .1 r
.63768 .55148 m
.66364 .55555 L
s
.63625 .55125 m
.63768 .55148 L
s
.66364 .55555 m
.66982 .52201 L
s
.22 .332 .677 r
.43835 .58166 m .4359 .58745 L .41681 .56786 L p F P
0 0 0 r
s
.887 .248 .104 r
.6603 .49427 m .64033 .49098 L .64902 .46722 L p F P
0 0 0 r
s
.887 .248 .104 r
.62772 .46363 m .64902 .46722 L .64033 .49098 L p F P
0 0 0 r
s
1 .29 .123 r
.53434 .59949 m .52732 .59846 L .54043 .57823 L p F P
0 0 0 r
s
.83 .24 .1 r
.53462 .59852 m
.5351 .59859 L
s
1 .29 .123 r
.54043 .57823 m .55079 .5798 L .53434 .59949 L p F P
0 0 0 r
s
.731 .196 .081 r
.47416 .39238 m .45102 .38834 L .45215 .37024 L p F P
0 0 0 r
s
.731 .196 .081 r
.42942 .36621 m .45215 .37024 L .45102 .38834 L p F P
0 0 0 r
s
.83 .24 .1 r
.36815 .5991 m
.41411 .60576 L
s
.41411 .60576 m
.4217 .58179 L
s
.24 .35 .67 r
.49556 .60089 m
.52862 .60575 L
s
.163 .246 .524 r
.38567 .52374 m .38958 .51279 L .40344 .53701 L p F P
0 0 0 r
s
.24 .35 .67 r
.38639 .5249 m
.38657 .52442 L
s
.163 .246 .524 r
.40344 .53701 m .39989 .5464 L .38567 .52374 L p F P
0 0 0 r
s
.24 .35 .67 r
.39998 .54617 m
.40625 .55324 L
s
.45474 .25022 m
.46607 .21667 L
s
.45474 .25022 m
.43177 .26403 L
s
1 .29 .123 r
.52732 .59846 m .52029 .59741 L .53004 .57666 L p F P
0 0 0 r
s
.83 .24 .1 r
.52745 .59745 m
.52793 .59752 L
s
1 .29 .123 r
.53004 .57666 m .54043 .57823 L .52732 .59846 L p F P
0 0 0 r
s
.985 .284 .12 r
.59194 .58601 m .58169 .58447 L .60611 .56392 L p F P
0 0 0 r
s
.985 .284 .12 r
.60611 .56392 m .61936 .56596 L .59194 .58601 L p F P
0 0 0 r
s
.24 .35 .67 r
.61744 .56567 m
.62241 .56322 L
s
.83 .24 .1 r
.60246 .57904 m
.6114 .5804 L
s
.6114 .5804 m
.61364 .57134 L
s
.66421 .52111 m
.66982 .52201 L
s
.24 .35 .67 r
.71916 .30548 m
.70065 .28084 L
s
.70065 .28084 m
.71772 .24798 L
s
.69566 .4676 m
.70321 .44363 L
s
.70321 .44363 m
.72034 .41457 L
s
.848 .235 .098 r
.60629 .46002 m .58474 .45639 L .5874 .43324 L p F P
0 0 0 r
s
.848 .235 .098 r
.56505 .4294 m .5874 .43324 L .58474 .45639 L p F P
0 0 0 r
s
1 .29 .123 r
.52029 .59741 m .51325 .59637 L .51962 .57509 L p F P
0 0 0 r
s
.83 .24 .1 r
.51311 .59533 m
.51354 .59539 L
s
.52026 .59639 m
.52074 .59646 L
s
1 .29 .123 r
.51962 .57509 m .53004 .57666 L .52029 .59741 L p F P
0 0 0 r
s
.24 .35 .67 r
.52862 .60575 m
.54167 .58049 L
s
.83 .24 .1 r
.35975 .34987 m
.38508 .35437 L
s
.194 .292 .608 r
.41987 .56021 m .41681 .56786 L .39989 .5464 L p F P
0 0 0 r
s
.22 .332 .677 r
.41681 .56786 m .41987 .56021 L .43835 .58166 L p F P
0 0 0 r
s
.085 .126 .306 r
.37121 .46434 m .37568 .45076 L .38301 .47579 L p F P
0 0 0 r
s
.085 .126 .306 r
.38301 .47579 m .37874 .48831 L .37121 .46434 L p F P
0 0 0 r
s
.799 .218 .091 r
.54256 .42554 m .51993 .42165 L .52 .40039 L p F P
0 0 0 r
s
.799 .218 .091 r
.49715 .3964 m .52 .40039 L .51993 .42165 L p F P
0 0 0 r
s
.83 .24 .1 r
.49718 .39752 m
.49835 .39773 L
s
.49714 .3964 m
.49718 .39752 L
s
.918 .259 .109 r
.66416 .52104 m .64603 .51811 L .6603 .49427 L p F P
0 0 0 r
s
.24 .35 .67 r
.65839 .52753 m
.66241 .52076 L
s
.918 .259 .109 r
.64033 .49098 m .6603 .49427 L .64603 .51811 L p F P
0 0 0 r
s
.83 .24 .1 r
.22247 .59729 m
.2694 .60397 L
s
.2694 .60397 m
.27451 .58554 L
s
.985 .284 .12 r
.58169 .58447 m .57142 .58291 L .5928 .56186 L p F P
0 0 0 r
s
.24 .35 .67 r
.56365 .59878 m
.56474 .59677 L
s
.985 .284 .12 r
.5928 .56186 m .60611 .56392 L .58169 .58447 L p F P
0 0 0 r
s
.24 .35 .67 r
.60098 .57747 m
.60389 .57234 L
s
.60389 .57234 m
.61123 .56873 L
s
.194 .292 .608 r
.39989 .5464 m .40344 .53701 L .41987 .56021 L p F P
0 0 0 r
s
.243 .365 .736 r
.43835 .58166 m .44083 .57582 L .46003 .59686 L p F P
0 0 0 r
s
.243 .365 .736 r
.46179 .59295 m .46003 .59686 L .44083 .57582 L p F P
0 0 0 r
s
.887 .248 .104 r
.64033 .49098 m .62025 .48766 L .62772 .46363 L p F P
0 0 0 r
s
.887 .248 .104 r
.60629 .46002 m .62772 .46363 L .62025 .48766 L p F P
0 0 0 r
s
.83 .24 .1 r
.26588 .33319 m
.26723 .31616 L
s
.22026 .30771 m
.26723 .31616 L
s
1 .29 .123 r
.51325 .59637 m .50619 .59533 L .50917 .57351 L p F P
0 0 0 r
s
.83 .24 .1 r
.51306 .59532 m
.51311 .59533 L
s
1 .29 .123 r
.50917 .57351 m .51962 .57509 L .51325 .59637 L p F P
0 0 0 r
s
.24 .35 .67 r
.52381 .2044 m
.53678 .16971 L
s
.52381 .2044 m
.4935 .20796 L
s
.944 .268 .113 r
.64603 .51811 m .66416 .52104 L .64369 .54408 L p F P
0 0 0 r
s
.24 .35 .67 r
.66311 .51957 m
.66505 .5163 L
s
.66303 .51971 m
.66311 .51957 L
s
.731 .196 .081 r
.45102 .38834 m .42774 .38427 L .42942 .36621 L p F P
0 0 0 r
s
.731 .196 .081 r
.40654 .36216 m .42942 .36621 L .42774 .38427 L p F P
0 0 0 r
s
.966 .276 .117 r
.61936 .56596 m .60611 .56392 L .62778 .54157 L p F P
0 0 0 r
s
.966 .276 .117 r
.62778 .54157 m .64369 .54408 L .61936 .56596 L p F P
0 0 0 r
s
.24 .35 .67 r
.6351 .54995 m
.63559 .54912 L
s
.985 .284 .12 r
.57142 .58291 m .56112 .58136 L .57945 .5598 L p F P
0 0 0 r
s
.985 .284 .12 r
.57945 .5598 m .5928 .56186 L .57142 .58291 L p F P
0 0 0 r
s
1 .29 .123 r
.50619 .59533 m .49912 .59428 L .4987 .57193 L p F P
0 0 0 r
s
.83 .24 .1 r
.50585 .59425 m
.50633 .59432 L
s
1 .29 .123 r
.4987 .57193 m .50917 .57351 L .50619 .59533 L p F P
0 0 0 r
s
.24 .35 .67 r
.40369 .31454 m
.41386 .28238 L
s
.40369 .31454 m
.39196 .33677 L
s
.944 .268 .113 r
.64369 .54408 m .62778 .54157 L .64603 .51811 L p F P
0 0 0 r
s
1 .29 .123 r
.49912 .59428 m .49203 .59323 L .48819 .57034 L p F P
0 0 0 r
s
.83 .24 .1 r
.49862 .59318 m
.4991 .59325 L
s
1 .29 .123 r
.48819 .57034 m .4987 .57193 L .49912 .59428 L p F P
0 0 0 r
s
.848 .235 .098 r
.58474 .45639 m .56306 .45273 L .56505 .4294 L p F P
0 0 0 r
s
.848 .235 .098 r
.54256 .42554 m .56505 .4294 L .56306 .45273 L p F P
0 0 0 r
s
.22 .332 .677 r
.44083 .57582 m .43835 .58166 L .41987 .56021 L p F P
0 0 0 r
s
.918 .259 .109 r
.64603 .51811 m .6278 .51517 L .64033 .49098 L p F P
0 0 0 r
s
.918 .259 .109 r
.62025 .48766 m .64033 .49098 L .6278 .51517 L p F P
0 0 0 r
s
.83 .24 .1 r
.62541 .51484 m
.62611 .509 L
s
.24 .35 .67 r
.47842 .59521 m
.49556 .60089 L
s
.47498 .59407 m
.47842 .59521 L
s
.49556 .60089 m
.50789 .57539 L
s
.985 .284 .12 r
.56112 .58136 m .55079 .5798 L .56605 .55773 L p F P
0 0 0 r
s
.985 .284 .12 r
.56605 .55773 m .57945 .5598 L .56112 .58136 L p F P
0 0 0 r
s
.799 .218 .091 r
.51993 .42165 m .49716 .41774 L .49715 .3964 L p F P
0 0 0 r
s
.799 .218 .091 r
.47416 .39238 m .49715 .3964 L .49716 .41774 L p F P
0 0 0 r
s
.944 .268 .113 r
.6278 .51517 m .64603 .51811 L .62778 .54157 L p F P
0 0 0 r
s
.24 .35 .67 r
.63559 .54912 m
.64465 .5336 L
s
.966 .276 .117 r
.60611 .56392 m .5928 .56186 L .6118 .53905 L p F P
0 0 0 r
s
.966 .276 .117 r
.6118 .53905 m .62778 .54157 L .60611 .56392 L p F P
0 0 0 r
s
.887 .248 .104 r
.62025 .48766 m .60006 .48433 L .60629 .46002 L p F P
0 0 0 r
s
.887 .248 .104 r
.58474 .45639 m .60629 .46002 L .60006 .48433 L p F P
0 0 0 r
s
1 .29 .123 r
.49203 .59323 m .48494 .59218 L .47765 .56875 L p F P
0 0 0 r
s
.83 .24 .1 r
.49137 .59211 m
.49186 .59218 L
s
1 .29 .123 r
.47765 .56875 m .48819 .57034 L .49203 .59323 L p F P
0 0 0 r
s
.24 .35 .67 r
.64465 .5336 m
.66505 .5163 L
s
.66505 .5163 m
.68137 .48881 L
s
.243 .365 .736 r
.44083 .57582 m .44333 .56992 L .46179 .59295 L p F P
0 0 0 r
s
.243 .365 .736 r
.46356 .58902 m .46179 .59295 L .44333 .56992 L p F P
0 0 0 r
s
.065 .095 .231 r
.37175 .42733 m .37641 .41274 L .38024 .43689 L p F P
0 0 0 r
s
.065 .095 .231 r
.38024 .43689 m .37568 .45076 L .37175 .42733 L p F P
0 0 0 r
s
.731 .196 .081 r
.42774 .38427 m .40432 .38018 L .40654 .36216 L p F P
0 0 0 r
s
.731 .196 .081 r
.38352 .35808 m .40654 .36216 L .40432 .38018 L p F P
0 0 0 r
s
.985 .284 .12 r
.55079 .5798 m .54043 .57823 L .5526 .55566 L p F P
0 0 0 r
s
.985 .284 .12 r
.5526 .55566 m .56605 .55773 L .55079 .5798 L p F P
0 0 0 r
s
.24 .35 .67 r
.56474 .59677 m
.57421 .57941 L
s
.944 .268 .113 r
.62778 .54157 m .6118 .53905 L .6278 .51517 L p F P
0 0 0 r
s
.83 .24 .1 r
.62443 .5202 m
.62541 .51484 L
s
.62541 .51484 m
.62777 .51522 L
s
1 .29 .123 r
.48494 .59218 m .47782 .59113 L .46708 .56716 L p F P
0 0 0 r
s
.83 .24 .1 r
.48412 .59103 m
.4846 .5911 L
s
1 .29 .123 r
.46708 .56716 m .47765 .56875 L .48494 .59218 L p F P
0 0 0 r
s
.83 .24 .1 r
.32161 .59236 m
.36815 .5991 L
s
.36815 .5991 m
.37515 .57489 L
s
.24 .35 .67 r
.57421 .57941 m
.60389 .57234 L
s
.125 .189 .421 r
.37874 .48831 m .38301 .47579 L .39358 .50163 L p F P
0 0 0 r
s
.125 .189 .421 r
.39358 .50163 m .38958 .51279 L .37874 .48831 L p F P
0 0 0 r
s
.966 .276 .117 r
.5928 .56186 m .57945 .5598 L .59575 .53651 L p F P
0 0 0 r
s
.966 .276 .117 r
.59575 .53651 m .6118 .53905 L .5928 .56186 L p F P
0 0 0 r
s
.24 .35 .67 r
.60389 .57234 m
.61879 .54613 L
s
1 .29 .123 r
.47782 .59113 m .4707 .59007 L .45649 .56556 L p F P
0 0 0 r
s
.83 .24 .1 r
.47685 .58996 m
.47733 .59003 L
s
1 .29 .123 r
.45649 .56556 m .46708 .56716 L .47782 .59113 L p F P
0 0 0 r
s
.83 .24 .1 r
.46735 .58958 m
.46769 .5886 L
s
.46769 .5886 m
.47005 .58895 L
s
.918 .259 .109 r
.6278 .51517 m .60949 .51221 L .62025 .48766 L p F P
0 0 0 r
s
.918 .259 .109 r
.60006 .48433 m .62025 .48766 L .60949 .51221 L p F P
0 0 0 r
s
.848 .235 .098 r
.56306 .45273 m .54125 .44905 L .54256 .42554 L p F P
0 0 0 r
s
.848 .235 .098 r
.51993 .42165 m .54256 .42554 L .54125 .44905 L p F P
0 0 0 r
s
.944 .268 .113 r
.60949 .51221 m .6278 .51517 L .6118 .53905 L p F P
0 0 0 r
s
.985 .284 .12 r
.54043 .57823 m .53004 .57666 L .5391 .55357 L p F P
0 0 0 r
s
.985 .284 .12 r
.5391 .55357 m .5526 .55566 L .54043 .57823 L p F P
0 0 0 r
s
.83 .24 .1 r
.3586 .37334 m
.35975 .34987 L
s
.3131 .34158 m
.35975 .34987 L
s
.799 .218 .091 r
.49716 .41774 m .47425 .4138 L .47416 .39238 L p F P
0 0 0 r
s
.799 .218 .091 r
.45102 .38834 m .47416 .39238 L .47425 .4138 L p F P
0 0 0 r
s
.83 .24 .1 r
.45156 .38956 m
.45224 .38968 L
s
.45155 .38892 m
.45156 .38956 L
s
.17496 .59053 m
.22247 .59729 L
s
.22247 .59729 m
.22681 .57863 L
s
.887 .248 .104 r
.60006 .48433 m .57976 .48097 L .58474 .45639 L p F P
0 0 0 r
s
.887 .248 .104 r
.56306 .45273 m .58474 .45639 L .57976 .48097 L p F P
0 0 0 r
s
1 .29 .123 r
.4707 .59007 m .46356 .58902 L .44586 .56395 L p F P
0 0 0 r
s
.24 .35 .67 r
.46353 .58899 m
.46354 .58898 L
s
1 .29 .123 r
.44586 .56395 m .45649 .56556 L .4707 .59007 L p F P
0 0 0 r
s
.24 .35 .67 r
.46501 .58571 m
.46568 .58421 L
s
.83 .24 .1 r
.46227 .5878 m
.46275 .58787 L
s
.944 .268 .113 r
.6118 .53905 m .59575 .53651 L .60949 .51221 L p F P
0 0 0 r
s
.194 .292 .608 r
.42297 .55245 m .41987 .56021 L .40344 .53701 L p F P
0 0 0 r
s
.22 .332 .677 r
.41987 .56021 m .42297 .55245 L .44083 .57582 L p F P
0 0 0 r
s
.83 .24 .1 r
.21806 .32469 m
.22026 .30771 L
s
.045 .065 .149 r
.37596 .3913 m .38074 .37606 L .38118 .39781 L p F P
0 0 0 r
s
.045 .065 .149 r
.38118 .39781 m .37641 .41274 L .37596 .3913 L p F P
0 0 0 r
s
.966 .276 .117 r
.57945 .5598 m .56605 .55773 L .57963 .53397 L p F P
0 0 0 r
s
.966 .276 .117 r
.57963 .53397 m .59575 .53651 L .57945 .5598 L p F P
0 0 0 r
s
.985 .284 .12 r
.53004 .57666 m .51962 .57509 L .52555 .55148 L p F P
0 0 0 r
s
.985 .284 .12 r
.52555 .55148 m .5391 .55357 L .53004 .57666 L p F P
0 0 0 r
s
.243 .365 .736 r
.44333 .56992 m .44586 .56395 L .46356 .58902 L p F P
0 0 0 r
s
.83 .24 .1 r
.4217 .58179 m
.45974 .58742 L
s
.731 .196 .081 r
.40432 .38018 m .38074 .37606 L .38352 .35808 L p F P
0 0 0 r
s
.24 .35 .67 r
.38326 .37362 m
.38691 .36202 L
s
.163 .246 .524 r
.38958 .51279 m .39358 .50163 L .40704 .52746 L p F P
0 0 0 r
s
.24 .35 .67 r
.39029 .51403 m
.39047 .51354 L
s
.39427 .50296 m
.39453 .50223 L
s
.163 .246 .524 r
.40704 .52746 m .40344 .53701 L .38958 .51279 L p F P
0 0 0 r
s
.22 .332 .677 r
.44333 .56992 m .44083 .57582 L .42297 .55245 L p F P
0 0 0 r
s
.918 .259 .109 r
.60949 .51221 m .59109 .50924 L .60006 .48433 L p F P
0 0 0 r
s
.918 .259 .109 r
.57976 .48097 m .60006 .48433 L .59109 .50924 L p F P
0 0 0 r
s
.944 .268 .113 r
.59109 .50924 m .60949 .51221 L .59575 .53651 L p F P
0 0 0 r
s
.24 .35 .67 r
.73203 .33157 m
.71916 .30548 L
s
.71916 .30548 m
.73682 .27289 L
s
.194 .292 .608 r
.40344 .53701 m .40704 .52746 L .42297 .55245 L p F P
0 0 0 r
s
.985 .284 .12 r
.51962 .57509 m .50917 .57351 L .51195 .54938 L p F P
0 0 0 r
s
.985 .284 .12 r
.51195 .54938 m .52555 .55148 L .51962 .57509 L p F P
0 0 0 r
s
.848 .235 .098 r
.54125 .44905 m .51932 .44536 L .51993 .42165 L p F P
0 0 0 r
s
.848 .235 .098 r
.49716 .41774 m .51993 .42165 L .51932 .44536 L p F P
0 0 0 r
s
.944 .268 .113 r
.59575 .53651 m .57963 .53397 L .59109 .50924 L p F P
0 0 0 r
s
.966 .276 .117 r
.56605 .55773 m .5526 .55566 L .56344 .53141 L p F P
0 0 0 r
s
.966 .276 .117 r
.56344 .53141 m .57963 .53397 L .56605 .55773 L p F P
0 0 0 r
s
.24 .35 .67 r
.73857 .35813 m
.72086 .38877 L
s
.72034 .41457 m
.72086 .38877 L
s
.799 .218 .091 r
.47425 .4138 m .4512 .40984 L .45102 .38834 L p F P
0 0 0 r
s
.799 .218 .091 r
.42774 .38427 m .45102 .38834 L .4512 .40984 L p F P
0 0 0 r
s
.887 .248 .104 r
.57976 .48097 m .55934 .4776 L .56306 .45273 L p F P
0 0 0 r
s
.887 .248 .104 r
.54125 .44905 m .56306 .45273 L .55934 .4776 L p F P
0 0 0 r
s
.985 .284 .12 r
.50917 .57351 m .4987 .57193 L .4983 .54728 L p F P
0 0 0 r
s
.985 .284 .12 r
.4983 .54728 m .51195 .54938 L .50917 .57351 L p F P
0 0 0 r
s
.24 .35 .67 r
.4935 .20796 m
.50588 .17302 L
s
.4935 .20796 m
.46607 .21667 L
s
.63515 .19001 m
.66589 .20583 L
s
.60261 .17845 m
.63515 .19001 L
s
.966 .276 .117 r
.5526 .55566 m .5391 .55357 L .54717 .52884 L p F P
0 0 0 r
s
.966 .276 .117 r
.54717 .52884 m .56344 .53141 L .5526 .55566 L p F P
0 0 0 r
s
.83 .24 .1 r
.27451 .58554 m
.32161 .59236 L
s
.32161 .59236 m
.32801 .5679 L
s
.944 .268 .113 r
.57259 .50625 m .59109 .50924 L .57963 .53397 L p F P
0 0 0 r
s
.83 .24 .1 r
.5758 .53336 m
.57732 .5249 L
s
.918 .259 .109 r
.59109 .50924 m .57259 .50625 L .57976 .48097 L p F P
0 0 0 r
s
.085 .126 .306 r
.37568 .45076 m .38024 .43689 L .38738 .463 L p F P
0 0 0 r
s
.085 .126 .306 r
.38738 .463 m .38301 .47579 L .37568 .45076 L p F P
0 0 0 r
s
.944 .268 .113 r
.57963 .53397 m .56344 .53141 L .57259 .50625 L p F P
0 0 0 r
s
.918 .259 .109 r
.55934 .4776 m .57976 .48097 L .57259 .50625 L p F P
0 0 0 r
s
.24 .35 .67 r
.43177 .26403 m
.4427 .23037 L
s
.43177 .26403 m
.41386 .28238 L
s
.985 .284 .12 r
.4987 .57193 m .48819 .57034 L .4846 .54516 L p F P
0 0 0 r
s
.985 .284 .12 r
.4846 .54516 m .4983 .54728 L .4987 .57193 L p F P
0 0 0 r
s
.24 .35 .67 r
.66589 .20583 m
.69376 .22537 L
s
.848 .235 .098 r
.51932 .44536 m .49725 .44164 L .49716 .41774 L p F P
0 0 0 r
s
.848 .235 .098 r
.47425 .4138 m .49716 .41774 L .49725 .44164 L p F P
0 0 0 r
s
.83 .24 .1 r
.31125 .36507 m
.3131 .34158 L
s
.26588 .33319 m
.3131 .34158 L
s
.24 .35 .67 r
.56943 .17158 m
.60261 .17845 L
s
.83 .24 .1 r
.37515 .57489 m
.4217 .58179 L
s
.887 .248 .104 r
.55934 .4776 m .53882 .47421 L .54125 .44905 L p F P
0 0 0 r
s
.887 .248 .104 r
.51932 .44536 m .54125 .44905 L .53882 .47421 L p F P
0 0 0 r
s
.799 .218 .091 r
.4512 .40984 m .428 .40585 L .42774 .38427 L p F P
0 0 0 r
s
.799 .218 .091 r
.40432 .38018 m .42774 .38427 L .428 .40585 L p F P
0 0 0 r
s
.83 .24 .1 r
.40537 .3815 m
.40556 .38153 L
s
.40537 .3815 m
.40537 .38133 L
s
.17496 .59053 m
.17851 .57164 L
s
.966 .276 .117 r
.5391 .55357 m .52555 .55148 L .53084 .52626 L p F P
0 0 0 r
s
.966 .276 .117 r
.53084 .52626 m .54717 .52884 L .5391 .55357 L p F P
0 0 0 r
s
.985 .284 .12 r
.48819 .57034 m .47765 .56875 L .47085 .54304 L p F P
0 0 0 r
s
.24 .35 .67 r
.46568 .58421 m
.46661 .58215 L
s
.985 .284 .12 r
.47085 .54304 m .4846 .54516 L .48819 .57034 L p F P
0 0 0 r
s
.24 .35 .67 r
.68137 .48881 m
.69566 .4676 L
s
.69566 .4676 m
.71286 .43869 L
s
.944 .268 .113 r
.56344 .53141 m .54717 .52884 L .55399 .50325 L p F P
0 0 0 r
s
.944 .268 .113 r
.55399 .50325 m .57259 .50625 L .56344 .53141 L p F P
0 0 0 r
s
.22 .332 .677 r
.42297 .55245 m .42611 .54459 L .44333 .56992 L p F P
0 0 0 r
s
.22 .332 .677 r
.44586 .56395 m .44333 .56992 L .42611 .54459 L p F P
0 0 0 r
s
.918 .259 .109 r
.57259 .50625 m .55399 .50325 L .55934 .4776 L p F P
0 0 0 r
s
.194 .292 .608 r
.42611 .54459 m .42297 .55245 L .40704 .52746 L p F P
0 0 0 r
s
.918 .259 .109 r
.53882 .47421 m .55934 .4776 L .55399 .50325 L p F P
0 0 0 r
s
.24 .35 .67 r
.54167 .58049 m
.57421 .57941 L
s
.57421 .57941 m
.58855 .55311 L
s
.985 .284 .12 r
.47765 .56875 m .46708 .56716 L .45705 .54091 L p F P
0 0 0 r
s
.985 .284 .12 r
.45705 .54091 m .47085 .54304 L .47765 .56875 L p F P
0 0 0 r
s
.966 .276 .117 r
.52555 .55148 m .51195 .54938 L .51443 .52367 L p F P
0 0 0 r
s
.966 .276 .117 r
.51443 .52367 m .53084 .52626 L .52555 .55148 L p F P
0 0 0 r
s
.83 .24 .1 r
.3586 .37334 m
.3804 .37714 L
s
.848 .235 .098 r
.49725 .44164 m .47505 .43789 L .47425 .4138 L p F P
0 0 0 r
s
.848 .235 .098 r
.4512 .40984 m .47425 .4138 L .47505 .43789 L p F P
0 0 0 r
s
.887 .248 .104 r
.53882 .47421 m .51817 .47081 L .51932 .44536 L p F P
0 0 0 r
s
.887 .248 .104 r
.49725 .44164 m .51932 .44536 L .51817 .47081 L p F P
0 0 0 r
s
.125 .189 .421 r
.38301 .47579 m .38738 .463 L .39764 .49026 L p F P
0 0 0 r
s
.125 .189 .421 r
.39764 .49026 m .39358 .50163 L .38301 .47579 L p F P
0 0 0 r
s
.24 .35 .67 r
.3938 .50101 m
.39453 .50223 L
s
.944 .268 .113 r
.54717 .52884 m .53084 .52626 L .53531 .50023 L p F P
0 0 0 r
s
.944 .268 .113 r
.53531 .50023 m .55399 .50325 L .54717 .52884 L p F P
0 0 0 r
s
.799 .218 .091 r
.428 .40585 m .40466 .40184 L .40432 .38018 L p F P
0 0 0 r
s
.799 .218 .091 r
.38074 .37606 m .40432 .38018 L .40466 .40184 L p F P
0 0 0 r
s
.83 .24 .1 r
.38077 .3772 m
.382 .37742 L
s
.24 .35 .67 r
.38085 .38127 m
.38205 .37747 L
s
.39196 .33677 m
.402 .30468 L
s
.38691 .36202 m
.39196 .33677 L
s
.69376 .22537 m
.71772 .24798 L
s
.065 .095 .231 r
.37641 .41274 m .38118 .39781 L .3849 .42269 L p F P
0 0 0 r
s
.065 .095 .231 r
.3849 .42269 m .38024 .43689 L .37641 .41274 L p F P
0 0 0 r
s
.985 .284 .12 r
.46708 .56716 m .45649 .56556 L .44319 .53877 L p F P
0 0 0 r
s
.985 .284 .12 r
.44319 .53877 m .45705 .54091 L .46708 .56716 L p F P
0 0 0 r
s
.24 .35 .67 r
.46661 .58215 m
.47463 .56431 L
s
.918 .259 .109 r
.55399 .50325 m .53531 .50023 L .53882 .47421 L p F P
0 0 0 r
s
.966 .276 .117 r
.51195 .54938 m .4983 .54728 L .49795 .52107 L p F P
0 0 0 r
s
.966 .276 .117 r
.49795 .52107 m .51443 .52367 L .51195 .54938 L p F P
0 0 0 r
s
.24 .35 .67 r
.61879 .54613 m
.64465 .5336 L
s
.64465 .5336 m
.6607 .50615 L
s
.53678 .16971 m
.56943 .17158 L
s
.918 .259 .109 r
.51817 .47081 m .53882 .47421 L .53531 .50023 L p F P
0 0 0 r
s
.83 .24 .1 r
.53492 .50023 m
.53499 .49968 L
s
.5303 .52618 m
.53492 .50023 L
s
.53492 .50023 m
.5353 .50029 L
s
.163 .246 .524 r
.4107 .51776 m .40704 .52746 L .39358 .50163 L p F P
0 0 0 r
s
.24 .35 .67 r
.39453 .50223 m
.39619 .50409 L
s
.194 .292 .608 r
.40704 .52746 m .4107 .51776 L .42611 .54459 L p F P
0 0 0 r
s
.83 .24 .1 r
.22681 .57863 m
.27451 .58554 L
s
.27451 .58554 m
.28028 .56083 L
s
.985 .284 .12 r
.45649 .56556 m .44586 .56395 L .42929 .53663 L p F P
0 0 0 r
s
.985 .284 .12 r
.42929 .53663 m .44319 .53877 L .45649 .56556 L p F P
0 0 0 r
s
.163 .246 .524 r
.39358 .50163 m .39764 .49026 L .4107 .51776 L p F P
0 0 0 r
s
.944 .268 .113 r
.53084 .52626 m .51443 .52367 L .51653 .4972 L p F P
0 0 0 r
s
.944 .268 .113 r
.51653 .4972 m .53531 .50023 L .53084 .52626 L p F P
0 0 0 r
s
.848 .235 .098 r
.47505 .43789 m .45271 .43413 L .4512 .40984 L p F P
0 0 0 r
s
.848 .235 .098 r
.428 .40585 m .4512 .40984 L .45271 .43413 L p F P
0 0 0 r
s
.966 .276 .117 r
.4983 .54728 m .4846 .54516 L .48139 .51846 L p F P
0 0 0 r
s
.966 .276 .117 r
.48139 .51846 m .49795 .52107 L .4983 .54728 L p F P
0 0 0 r
s
.83 .24 .1 r
.2633 .3567 m
.26588 .33319 L
s
.21806 .32469 m
.26588 .33319 L
s
.887 .248 .104 r
.51817 .47081 m .49741 .46738 L .49725 .44164 L p F P
0 0 0 r
s
.887 .248 .104 r
.47505 .43789 m .49725 .44164 L .49741 .46738 L p F P
0 0 0 r
s
.83 .24 .1 r
.32801 .5679 m
.37515 .57489 L
s
.37515 .57489 m
.38221 .54552 L
s
.918 .259 .109 r
.53531 .50023 m .51653 .4972 L .51817 .47081 L p F P
0 0 0 r
s
.22 .332 .677 r
.42611 .54459 m .42929 .53663 L .44586 .56395 L p F P
0 0 0 r
s
.83 .24 .1 r
.42919 .55267 m
.43856 .5541 L
s
.24 .35 .67 r
.44138 .55315 m
.44361 .5478 L
s
.83 .24 .1 r
.4217 .58179 m
.42919 .55267 L
s
.799 .218 .091 r
.40466 .40184 m .38118 .39781 L .38074 .37606 L p F P
0 0 0 r
s
.24 .35 .67 r
.3824 .37635 m
.38326 .37362 L
s
.918 .259 .109 r
.49741 .46738 m .51817 .47081 L .51653 .4972 L p F P
0 0 0 r
s
.24 .35 .67 r
.73857 .35813 m
.73203 .33157 L
s
.73203 .33157 m
.7502 .29923 L
s
.944 .268 .113 r
.51443 .52367 m .49795 .52107 L .49765 .49415 L p F P
0 0 0 r
s
.944 .268 .113 r
.49765 .49415 m .51653 .4972 L .51443 .52367 L p F P
0 0 0 r
s
.966 .276 .117 r
.4846 .54516 m .47085 .54304 L .46476 .51583 L p F P
0 0 0 r
s
.966 .276 .117 r
.46476 .51583 m .48139 .51846 L .4846 .54516 L p F P
0 0 0 r
s
.194 .292 .608 r
.42929 .53663 m .42611 .54459 L .4107 .51776 L p F P
0 0 0 r
s
.83 .24 .1 r
.3586 .37334 m
.31125 .36507 L
s
.35602 .40217 m
.3586 .37334 L
s
.918 .259 .109 r
.51653 .4972 m .49765 .49415 L .49741 .46738 L p F P
0 0 0 r
s
.848 .235 .098 r
.45271 .43413 m .43024 .43034 L .428 .40585 L p F P
0 0 0 r
s
.848 .235 .098 r
.40466 .40184 m .428 .40585 L .43024 .43034 L p F P
0 0 0 r
s
.887 .248 .104 r
.49741 .46738 m .47654 .46393 L .47505 .43789 L p F P
0 0 0 r
s
.887 .248 .104 r
.45271 .43413 m .47505 .43789 L .47654 .46393 L p F P
0 0 0 r
s
.24 .35 .67 r
.50789 .57539 m
.54167 .58049 L
s
.54167 .58049 m
.55534 .55402 L
s
.46607 .21667 m
.47794 .18153 L
s
.46607 .21667 m
.4427 .23037 L
s
.966 .276 .117 r
.47085 .54304 m .45705 .54091 L .44806 .5132 L p F P
0 0 0 r
s
.966 .276 .117 r
.44806 .5132 m .46476 .51583 L .47085 .54304 L p F P
0 0 0 r
s
.085 .126 .306 r
.38024 .43689 m .3849 .42269 L .39184 .44995 L p F P
0 0 0 r
s
.085 .126 .306 r
.39184 .44995 m .38738 .463 L .38024 .43689 L p F P
0 0 0 r
s
.944 .268 .113 r
.49795 .52107 m .48139 .51846 L .47867 .49108 L p F P
0 0 0 r
s
.944 .268 .113 r
.47867 .49108 m .49765 .49415 L .49795 .52107 L p F P
0 0 0 r
s
.918 .259 .109 r
.47654 .46393 m .49741 .46738 L .49765 .49415 L p F P
0 0 0 r
s
.83 .24 .1 r
.38221 .54552 m
.42919 .55267 L
s
.42919 .55267 m
.43087 .54476 L
s
.43087 .54476 m
.43117 .54333 L
s
.24 .35 .67 r
.71772 .24798 m
.73682 .27289 L
s
.43581 .54175 m
.44361 .5478 L
s
.71286 .43869 m
.72034 .41457 L
s
.72034 .41457 m
.73828 .38411 L
s
.83 .24 .1 r
.17851 .57164 m
.22681 .57863 L
s
.22681 .57863 m
.23195 .55367 L
s
.918 .259 .109 r
.49765 .49415 m .47867 .49108 L .47654 .46393 L p F P
0 0 0 r
s
.966 .276 .117 r
.45705 .54091 m .44319 .53877 L .43128 .51055 L p F P
0 0 0 r
s
.966 .276 .117 r
.43128 .51055 m .44806 .5132 L .45705 .54091 L p F P
0 0 0 r
s
.24 .35 .67 r
.50588 .17302 m
.53678 .16971 L
s
.848 .235 .098 r
.43024 .43034 m .40764 .42653 L .40466 .40184 L p F P
0 0 0 r
s
.848 .235 .098 r
.38118 .39781 m .40466 .40184 L .40764 .42653 L p F P
0 0 0 r
s
.887 .248 .104 r
.47654 .46393 m .45554 .46046 L .45271 .43413 L p F P
0 0 0 r
s
.887 .248 .104 r
.43024 .43034 m .45271 .43413 L .45554 .46046 L p F P
0 0 0 r
s
.83 .24 .1 r
.44688 .4507 m
.44742 .45079 L
s
.44688 .4507 m
.44693 .45021 L
s
.944 .268 .113 r
.48139 .51846 m .46476 .51583 L .4596 .488 L p F P
0 0 0 r
s
.944 .268 .113 r
.4596 .488 m .47867 .49108 L .48139 .51846 L p F P
0 0 0 r
s
.83 .24 .1 r
.21474 .34823 m
.21806 .32469 L
s
.28028 .56083 m
.32801 .5679 L
s
.32801 .5679 m
.33463 .53828 L
s
.24 .35 .67 r
.41386 .28238 m
.42452 .24869 L
s
.41386 .28238 m
.402 .30468 L
s
.163 .246 .524 r
.41442 .50788 m .4107 .51776 L .39764 .49026 L p F P
0 0 0 r
s
.194 .292 .608 r
.4107 .51776 m .41442 .50788 L .42929 .53663 L p F P
0 0 0 r
s
.918 .259 .109 r
.45554 .46046 m .47654 .46393 L .47867 .49108 L p F P
0 0 0 r
s
.966 .276 .117 r
.44319 .53877 m .42929 .53663 L .41442 .50788 L p F P
0 0 0 r
s
.966 .276 .117 r
.41442 .50788 m .43128 .51055 L .44319 .53877 L p F P
0 0 0 r
s
.125 .189 .421 r
.38738 .463 m .39184 .44995 L .40179 .47867 L p F P
0 0 0 r
s
.125 .189 .421 r
.40179 .47867 m .39764 .49026 L .38738 .463 L p F P
0 0 0 r
s
.83 .24 .1 r
.35602 .40217 m
.38079 .4064 L
s
.24 .35 .67 r
.47463 .56431 m
.50789 .57539 L
s
.50789 .57539 m
.52082 .54868 L
s
.918 .259 .109 r
.47867 .49108 m .4596 .488 L .45554 .46046 L p F P
0 0 0 r
s
.24 .35 .67 r
.44361 .5478 m
.455 .52041 L
s
.44361 .5478 m
.47463 .56431 L
s
.944 .268 .113 r
.46476 .51583 m .44806 .5132 L .44043 .48491 L p F P
0 0 0 r
s
.944 .268 .113 r
.44043 .48491 m .4596 .488 L .46476 .51583 L p F P
0 0 0 r
s
.163 .246 .524 r
.39764 .49026 m .40179 .47867 L .41442 .50788 L p F P
0 0 0 r
s
.24 .35 .67 r
.6607 .50615 m
.68137 .48881 L
s
.68137 .48881 m
.69846 .45999 L
s
.83 .24 .1 r
.31125 .36507 m
.2633 .3567 L
s
.3081 .394 m
.31125 .36507 L
s
.887 .248 .104 r
.45554 .46046 m .43443 .45698 L .43024 .43034 L p F P
0 0 0 r
s
.887 .248 .104 r
.40764 .42653 m .43024 .43034 L .43443 .45698 L p F P
0 0 0 r
s
.848 .235 .098 r
.40764 .42653 m .3849 .42269 L .38118 .39781 L p F P
0 0 0 r
s
.83 .24 .1 r
.38079 .4064 m
.38212 .40663 L
s
.24 .35 .67 r
.38363 .40605 m
.3839 .4052 L
s
.3839 .4052 m
.38906 .38925 L
s
.47463 .56431 m
.48678 .53729 L
s
.918 .259 .109 r
.43443 .45698 m .45554 .46046 L .4596 .488 L p F P
0 0 0 r
s
.24 .35 .67 r
.58855 .55311 m
.61879 .54613 L
s
.61879 .54613 m
.6344 .51866 L
s
.83 .24 .1 r
.38892 .51249 m
.41669 .51684 L
s
.41669 .51684 m
.4182 .51708 L
s
.33463 .53828 m
.38221 .54552 L
s
.38221 .54552 m
.38892 .51249 L
s
.918 .259 .109 r
.4596 .488 m .44043 .48491 L .43443 .45698 L p F P
0 0 0 r
s
.944 .268 .113 r
.44806 .5132 m .43128 .51055 L .42116 .48179 L p F P
0 0 0 r
s
.24 .35 .67 r
.42048 .51628 m
.42082 .51539 L
s
.944 .268 .113 r
.42116 .48179 m .44043 .48491 L .44806 .5132 L p F P
0 0 0 r
s
.24 .35 .67 r
.38691 .36202 m
.39698 .33009 L
s
.38691 .36202 m
.38906 .38925 L
s
.83 .24 .1 r
.17851 .57164 m
.183 .54642 L
s
.887 .248 .104 r
.43443 .45698 m .41319 .45347 L .40764 .42653 L p F P
0 0 0 r
s
.887 .248 .104 r
.3849 .42269 m .40764 .42653 L .41319 .45347 L p F P
0 0 0 r
s
.83 .24 .1 r
.39979 .44288 m
.40411 .44359 L
s
.39979 .44288 m
.40017 .43931 L
s
.918 .259 .109 r
.41319 .45347 m .43443 .45698 L .44043 .48491 L p F P
0 0 0 r
s
.83 .24 .1 r
.23195 .55367 m
.28028 .56083 L
s
.28028 .56083 m
.28644 .53094 L
s
.944 .268 .113 r
.43128 .51055 m .41442 .50788 L .40179 .47867 L p F P
0 0 0 r
s
.944 .268 .113 r
.40179 .47867 m .42116 .48179 L .43128 .51055 L p F P
0 0 0 r
s
.24 .35 .67 r
.42082 .51539 m
.42715 .49894 L
s
.918 .259 .109 r
.44043 .48491 m .42116 .48179 L .41319 .45347 L p F P
0 0 0 r
s
.24 .35 .67 r
.73682 .27289 m
.7502 .29923 L
s
.83 .24 .1 r
.3521 .43495 m
.35602 .40217 L
s
.3081 .394 m
.35602 .40217 L
s
.24 .35 .67 r
.75714 .32601 m
.73857 .35813 L
s
.73828 .38411 m
.73857 .35813 L
s
.83 .24 .1 r
.2633 .3567 m
.21474 .34823 L
s
.25957 .38571 m
.2633 .3567 L
s
.887 .248 .104 r
.41319 .45347 m .39184 .44995 L .3849 .42269 L p F P
0 0 0 r
s
.83 .24 .1 r
.38636 .44064 m
.3891 .4411 L
s
.3521 .43495 m
.38636 .44064 L
s
.24 .35 .67 r
.3907 .4405 m
.39857 .41721 L
s
.47794 .18153 m
.50588 .17302 L
s
.918 .259 .109 r
.39184 .44995 m .41319 .45347 L .42116 .48179 L p F P
0 0 0 r
s
.918 .259 .109 r
.42116 .48179 m .40179 .47867 L .39184 .44995 L p F P
0 0 0 r
s
.24 .35 .67 r
.3993 .46519 m
.40463 .47407 L
s
.83 .24 .1 r
.39489 .47761 m
.40093 .47859 L
s
.24 .35 .67 r
.40337 .47758 m
.40463 .47407 L
s
.40332 .47772 m
.40337 .47758 L
s
.83 .24 .1 r
.39489 .47761 m
.3965 .46622 L
s
.24 .35 .67 r
.4427 .23037 m
.45417 .19509 L
s
.4427 .23037 m
.42452 .24869 L
s
.83 .24 .1 r
.34109 .50499 m
.38892 .51249 L
s
.38892 .51249 m
.39489 .47761 L
s
.28644 .53094 m
.33463 .53828 L
s
.33463 .53828 m
.34109 .50499 L
s
.34703 .46988 m
.39489 .47761 L
s
.24 .35 .67 r
.69846 .45999 m
.71286 .43869 L
s
.71286 .43869 m
.73088 .40837 L
s
.83 .24 .1 r
.183 .54642 m
.23195 .55367 L
s
.23195 .55367 m
.23764 .52352 L
s
.24 .35 .67 r
.55534 .55402 m
.58855 .55311 L
s
.58855 .55311 m
.60358 .52553 L
s
.83 .24 .1 r
.3038 .42692 m
.3081 .394 L
s
.25957 .38571 m
.3081 .394 L
s
.24 .35 .67 r
.402 .30468 m
.41253 .27104 L
s
.402 .30468 m
.39698 .33009 L
s
.40463 .47407 m
.41522 .44453 L
s
.40463 .47407 m
.42715 .49894 L
s
.83 .24 .1 r
.34703 .46988 m
.3521 .43495 L
s
.3038 .42692 m
.3521 .43495 L
s
.21042 .37733 m
.21474 .34823 L
s
.24 .35 .67 r
.6344 .51866 m
.6607 .50615 L
s
.6607 .50615 m
.67752 .47737 L
s
.83 .24 .1 r
.29265 .4974 m
.34109 .50499 L
s
.34109 .50499 m
.34703 .46988 L
s
.23764 .52352 m
.28644 .53094 L
s
.28644 .53094 m
.29265 .4974 L
s
.24 .35 .67 r
.38906 .38925 m
.39931 .35756 L
s
.38906 .38925 m
.39857 .41721 L
s
.83 .24 .1 r
.29855 .46205 m
.34703 .46988 L
s
.24 .35 .67 r
.7502 .29923 m
.75714 .32601 L
s
.83 .24 .1 r
.183 .54642 m
.18822 .51599 L
s
.25487 .41879 m
.25957 .38571 L
s
.21042 .37733 m
.25957 .38571 L
s
.24 .35 .67 r
.52082 .54868 m
.55534 .55402 L
s
.55534 .55402 m
.56968 .52626 L
s
.45417 .19509 m
.47794 .18153 L
s
.83 .24 .1 r
.29855 .46205 m
.3038 .42692 L
s
.25487 .41879 m
.3038 .42692 L
s
.24 .35 .67 r
.42715 .49894 m
.43837 .46981 L
s
.42715 .49894 m
.455 .52041 L
s
.73088 .40837 m
.73828 .38411 L
s
.73828 .38411 m
.75711 .35217 L
s
.83 .24 .1 r
.24359 .48971 m
.29265 .4974 L
s
.29265 .4974 m
.29855 .46205 L
s
.18822 .51599 m
.23764 .52352 L
s
.23764 .52352 m
.24359 .48971 L
s
.24 .35 .67 r
.42452 .24869 m
.43571 .21335 L
s
.42452 .24869 m
.41253 .27104 L
s
.83 .24 .1 r
.24944 .45412 m
.29855 .46205 L
s
.24 .35 .67 r
.48678 .53729 m
.52082 .54868 L
s
.52082 .54868 m
.53438 .52065 L
s
.455 .52041 m
.46695 .49167 L
s
.455 .52041 m
.48678 .53729 L
s
.67752 .47737 m
.69846 .45999 L
s
.69846 .45999 m
.7164 .42976 L
s
.83 .24 .1 r
.20532 .41055 m
.21042 .37733 L
s
.24 .35 .67 r
.48678 .53729 m
.49952 .50893 L
s
.60358 .52553 m
.6344 .51866 L
s
.6344 .51866 m
.65078 .48984 L
s
.83 .24 .1 r
.24944 .45412 m
.25487 .41879 L
s
.20532 .41055 m
.25487 .41879 L
s
.24 .35 .67 r
.39698 .33009 m
.40753 .29659 L
s
.39698 .33009 m
.39931 .35756 L
s
.39857 .41721 m
.40917 .38583 L
s
.39857 .41721 m
.41522 .44453 L
s
.83 .24 .1 r
.19389 .48192 m
.24359 .48971 L
s
.24359 .48971 m
.24944 .45412 L
s
.18822 .51599 m
.19389 .48192 L
s
.1997 .44609 m
.24944 .45412 L
s
.24 .35 .67 r
.75714 .32601 m
.75711 .35217 L
s
.43571 .21335 m
.45417 .19509 L
s
.83 .24 .1 r
.1997 .44609 m
.20532 .41055 L
s
.19389 .48192 m
.1997 .44609 L
s
.24 .35 .67 r
.7164 .42976 m
.73088 .40837 L
s
.73088 .40837 m
.74981 .37655 L
s
.56968 .52626 m
.60358 .52553 L
s
.60358 .52553 m
.61937 .49659 L
s
.41253 .27104 m
.42358 .23572 L
s
.41253 .27104 m
.40753 .29659 L
s
.41522 .44453 m
.42634 .41353 L
s
.41522 .44453 m
.43837 .46981 L
s
.65078 .48984 m
.67752 .47737 L
s
.67752 .47737 m
.69518 .44716 L
s
.39931 .35756 m
.41006 .32428 L
s
.39931 .35756 m
.40917 .38583 L
s
.53438 .52065 m
.56968 .52626 L
s
.56968 .52626 m
.58474 .4971 L
s
.43837 .46981 m
.45016 .43921 L
s
.43837 .46981 m
.46695 .49167 L
s
.75711 .35217 m
.74981 .37655 L
s
.42358 .23572 m
.43571 .21335 L
s
.49952 .50893 m
.53438 .52065 L
s
.53438 .52065 m
.54862 .49122 L
s
.46695 .49167 m
.47951 .46149 L
s
.46695 .49167 m
.49952 .50893 L
s
.69518 .44716 m
.7164 .42976 L
s
.7164 .42976 m
.73524 .39801 L
s
.49952 .50893 m
.51291 .47914 L
s
.61937 .49659 m
.65078 .48984 L
s
.65078 .48984 m
.66799 .45956 L
s
.40753 .29659 m
.41862 .2614 L
s
.40753 .29659 m
.41006 .32428 L
s
.40917 .38583 m
.42031 .35287 L
s
.40917 .38583 m
.42634 .41353 L
s
.74981 .37655 m
.73524 .39801 L
s
.58474 .4971 m
.61937 .49659 L
s
.61937 .49659 m
.63595 .46617 L
s
.41862 .2614 m
.42358 .23572 L
s
.42634 .41353 m
.43803 .38094 L
s
.42634 .41353 m
.45016 .43921 L
s
.66799 .45956 m
.69518 .44716 L
s
.69518 .44716 m
.71375 .4154 L
s
.41006 .32428 m
.42137 .28931 L
s
.41006 .32428 m
.42031 .35287 L
s
.54862 .49122 m
.58474 .4971 L
s
.58474 .4971 m
.60056 .46646 L
s
.45016 .43921 m
.46254 .40704 L
s
.45016 .43921 m
.47951 .46149 L
s
.51291 .47914 m
.54862 .49122 L
s
.54862 .49122 m
.5636 .46026 L
s
.47951 .46149 m
.49271 .42975 L
s
.47951 .46149 m
.51291 .47914 L
s
.73524 .39801 m
.71375 .4154 L
s
.51291 .47914 m
.527 .44782 L
s
.63595 .46617 m
.66799 .45956 L
s
.66799 .45956 m
.68609 .42772 L
s
.42137 .28931 m
.41862 .2614 L
s
.42031 .35287 m
.43202 .3182 L
s
.42031 .35287 m
.43803 .38094 L
s
.60056 .46646 m
.63595 .46617 L
s
.63595 .46617 m
.65341 .43416 L
s
.43803 .38094 m
.45033 .34665 L
s
.43803 .38094 m
.46254 .40704 L
s
.71375 .4154 m
.68609 .42772 L
s
.43202 .3182 m
.42137 .28931 L
s
.5636 .46026 m
.60056 .46646 L
s
.60056 .46646 m
.61723 .43419 L
s
.46254 .40704 m
.47559 .37317 L
s
.46254 .40704 m
.49271 .42975 L
s
.527 .44782 m
.5636 .46026 L
s
.5636 .46026 m
.57937 .42767 L
s
.49271 .42975 m
.50661 .39633 L
s
.49271 .42975 m
.527 .44782 L
s
.527 .44782 m
.54183 .41483 L
s
.68609 .42772 m
.65341 .43416 L
s
.45033 .34665 m
.43202 .3182 L
s
.65341 .43416 m
.61723 .43419 L
s
.47559 .37317 m
.45033 .34665 L
s
.61723 .43419 m
.57937 .42767 L
s
.50661 .39633 m
.47559 .37317 L
s
.57937 .42767 m
.54183 .41483 L
s
.54183 .41483 m
.50661 .39633 L
s
0 0 0 r
.25 Mabswid
.24028 .08168 m
.91053 .22236 L
s
.91053 .22236 m
.97075 .49223 L
s
.97075 .49223 m
.19793 .35868 L
s
.19793 .35868 m
.24028 .08168 L
s
.16861 .50547 m
.13045 .74993 L
s
.13045 .74993 m
.19793 .35868 L
s
.19793 .35868 m
.24028 .08168 L
s
.24028 .08168 m
.16861 .50547 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{500, 500},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40007d0001m2000`400?l00000o`00003oo`3ooooe
0?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3o
m^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40
oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?of
k_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3o
ool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^
m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?oo
o`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd
0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo
003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0
ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool0
0?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03o
m^h10?ooo`00o`3om^kd0?ofkP40oooo001g0?ofkP<00000o`3om^ij0?ofkP40oooo001g0?ofkP03
0000003om^h0ooK^00D00000o`3om^ie0?ofkP40oooo001g0?ofkP030000003om^h0ooK^00D0ooK^
1000003o0?ofkW40ooK^0@3oool007L0ooK^00<000000?ofkP3om^h02@3om^h500000?l0ooK^K03o
m^h10?ooo`00MP3om^h00`000000ooK^0?ofkP0?0?ofkPD00000o`3om^iW0?ofkP40oooo001f0?of
kP030000003om^h0ooK^01@0ooK^1@00003o0?ofkV80ooK^0@3oool007H0ooK^00<000000?ofkP3o
m^h06@3om^h500000?l0ooK^G@3om^h10?ooo`00MP3om^h00`000000ooK^0?ofkP0N0?ofkP@00000
o`3om^iI0?ofkP40oooo001f0?ofkP030000003om^h0ooK^0280ooK^1@00003o0?ofkU@0ooK^0@3o
ool007H0ooK^00<000000?ofkP3om^h09`3om^h500000?l0ooK^C`3om^h10?ooo`00M@3om^h00`00
0000ooK^0?ofkP0]0?ofkPD00000o`3om^i:0?ofkP40oooo001e0?ofkP030000003om^h0ooK^0380
ooK^1@00003o0?ofkTD0ooK^0@3oool007D0ooK^00<000000?ofkP3om^h0=`3om^h400000?l0ooK^
@@3om^h10?ooo`00M@3om^h00`000000ooK^0?ofkP0k0?ofkPD00000o`3om^hl0?ofkP40oooo001e
0?ofkP030000003om^h0ooK^0400ooK^1@00003o0?ofkSL0ooK^0@3oool007D0ooK^00<000000?of
kP3om^h0A@3om^h500000?l0ooK^<P3om^h10?ooo`00M03om^h2000004`0ooK^1000003o0?ofkRh0
ooK^0@3oool007@0ooK^00<000000?ofkP3om^h0C`3om^h500000?l0ooK^:@3om^h10?ooo`00M03o
m^h00`000000ooK^0?ofkP1D0?ofkPD00000o`3om^hT0?ofkP40oooo001d0?ofkP030000003om^h0
ooK^05T0ooK^1@00003o0?ofkQl0ooK^0@3oool007@0ooK^00<000000?ofkP3om^h0GP3om^h50000
0?l0ooK^6P3om^h10?ooo`00M03om^h00`000000ooK^0?ofkP1S0?ofkP@00000o`3om^hF0?ofkP40
oooo001c0?ofkP800000J@3om^h500000?l0ooK^4@3om^h10?ooo`00L`3om^h00`000000ooK^0?of
kP1]0?ofkPD00000o`3om^h<0?ofkP40oooo001c0?ofkP030000003om^h0ooK^0780ooK^1@00003o
0?ofkPL0ooK^0@3oool007<0ooK^00<000000?ofkP3om^h0M`3om^h500000?l0ooK^0P3om^h10?oo
o`00L`3om^h00`000000ooK^0?ofkP1l0?ofkP@00000o@3om^h10?ooo`00L`3om^h00`000000ooK^
0?ofkP200?ofkPD00000n03om^h10?ooo`00LP3om^h2000008L0ooK^1@00003c0?ofkP40oooo001b
0?ofkP800000S03om^h500000>h0ooK^0@3oool00780ooK^00<000000?ofkP3om^h0T03om^h40000
0>X0ooK^0@3oool00780ooK^00<000000?ofkP3om^h0U03om^h500000>D0ooK^0@3oool00780ooK^
00<000000?ofkP3om^h0V@3om^h500000>00ooK^0@3oool00780ooK^00<000000?ofkP3om^h0WP3o
m^h500000=/0ooK^0@3oool00740ooK^0P00002U0?ofkPD00000eP3om^h10?ooo`00L@3om^h20000
0:X0ooK^1000003B0?ofkP40oooo001a0?ofkP800000[P3om^h500000<d0ooK^0@3oool00740ooK^
00<000000?ofkP3om^h0/P3om^h500000<P0ooK^0@3oool00740ooK^00<000000?ofkP3om^h0]`3o
m^h500000<<0ooK^0@3oool00740ooK^00<000000?ofkP3om^h0_03om^h500000;h0ooK^0@3oool0
0700ooK^0P0000330?ofkP@00000^P3om^h10?ooo`00L03om^h200000<L0ooK^1@00002e0?ofkP40
oooo001`0?ofkP800000c03om^h500000;00ooK^0@3oool00700ooK^00<000000?ofkP3om^h0d03o
m^h500000:/0ooK^0@3oool00700ooK^00<000000?ofkP3om^h0U@3om^h<03eIZc@0ooK^1000002W
0?ofkP40oooo001`0?ofkP030000003om^h0ooK^08d0ooK^200mFJ/30?ofkP0303eIZ`3om^h0ooK^
00H0ooK^2P0mFJ/^0?ofkPD00000XP3om^h10?ooo`00K`3om^h2000008X0ooK^1@0mFJ/:0?ofkP03
03eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP0mFJ/00`0mFJ/_0?ofkPD00000W@3om^h10?ooo`00
K`3om^h2000008H0ooK^100mFJ/00`3om^h0?EV[0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00h0ooK^
00<0?EV[0?ofkP3om^h0103om^h403eIZc00ooK^1@00002H0?ofkP40oooo001_0?ofkP800000P`3o
m^h303eIZ`@0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3o
m^h0ooK^00P0ooK^100mFJ/a0?ofkPD00000T`3om^h10?ooo`00K`3om^h2000007l0ooK^100mFJ/7
0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0=
0?ofkP@0?EV[<P3om^h4000008l0ooK^0@3oool006l0ooK^00<000000?ofkP3om^h0O03om^h203eI
Z`/0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^
00l0ooK^00<0?EV[0?ofkP0mFJ/00P0mFJ/c0?ofkPD00000RP3om^h10?ooo`00K`3om^h00`000000
ooK^0?ofkP1j0?ofkP<0?EV[2`3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00h0
ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP<0?EV[=@3om^h5000008D0
ooK^0@3oool006h0ooK^0P00001j0?ofkP80?EV[00<0ooK^03eIZ`3om^h02`3om^h00`0mFJ/0ooK^
0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^
0?ofkP060?ofkP@0?EV[=P3om^h500000800ooK^0@3oool006h0ooK^0P00001i0?ofkP0503eIZ`3o
m^h0ooK^0?ofkP0mFJ/0303om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00h0ooK^
00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP<0?EV[>03om^h5000007/0ooK^
0@3oool006h0ooK^0P00001g0?ofkP80?EV[103om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3o
m^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3o
m^h0ooK^00h0ooK^0P0mFJ/k0?ofkP@00000M`3om^h10?ooo`00KP3om^h2000007D0ooK^0P0mFJ/5
0?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP0>
0?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h03`3om^h303eIZcd0ooK^1@00001b
0?ofkP40oooo001^0?ofkP030000003om^h0ooK^0780ooK^0P0mFJ/70?ofkP0303eIZ`3om^h0ooK^
00T0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^
00l0ooK^00<0?EV[0?ofkP3om^h03`3om^h0100mFJ/0ooK^0?ofkP3om^h203eIZd00ooK^1@00001]
0?ofkP40oooo001^0?ofkP030000003om^h0ooK^0740ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0m
FJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0m
FJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h00`3om^h203eI
Zd<0ooK^1@00001X0?ofkP40oooo001]0?ofkP800000LP3om^h203eIZ`P0ooK^00<0?EV[0?ofkP3o
m^h02P3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3o
m^h03P3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00H0ooK^0P0mFJ]60?ofkP@0
0000I03om^h10?ooo`00K@3om^h200000740ooK^0P0mFJ/90?ofkP0303eIZ`3om^h0ooK^00T0ooK^
00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00l0ooK^
00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP080?ofkP80?EV[B03om^h5000005l0ooK^
0@3oool006d0ooK^0P00001`0?ofkP0303eIZ`3om^h0?EV[00T0ooK^00<0?EV[0?ofkP3om^h02@3o
m^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h03P3o
m^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0303eIZ`3om^h0ooK^00X0ooK^0P0mFJ];0?ofkPD00000FP3o
m^h10?ooo`00K@3om^h2000006l0ooK^00@0?EV[0?ofkP3om^h0?EV[203om^h00`0mFJ/0ooK^0?of
kP0:0?ofkP0303eIZ`3om^h0ooK^00P0ooK^2`0mFJ/80?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0
?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP80?EV[CP3om^h5000005D0ooK^0@3o
ool006d0ooK^0P00001^0?ofkP0403eIZ`3om^h0ooK^03eIZ`T0ooK^00<0?EV[0?ofkP3om^h02@3o
m^h0100mFJ/0ooK^0?ofkP3om^h803eIZ`<0ooK^00<0?EV[0?ofkP3om^h01@3om^h:03eIZa00ooK^
00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP80?EV[D@3om^h500000500ooK^
0@3oool006d0ooK^00<000000?ofkP3om^h0K03om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00T0ooK^
00<0?EV[0?ofkP3om^h0203om^h503eIZ`X0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^
03eIZ`0303eIZ`/0ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP<0?EV[
E03om^h4000004`0ooK^0@3oool006`0ooK^0P00001]0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0
?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP060?ofkP<0?EV[00<0ooK^03eIZ`3om^h0303o
m^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00@0ooK^100mFJ/70?ofkP0303eIZ`3o
m^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h0403om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[05L0ooK^
1@0000170?ofkP40oooo001/0?ofkP800000K03om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3o
m^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h0103om^h203eIZ`<0ooK^00<0?EV[0?ofkP3om^h0303o
m^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00P0ooK^100mFJ/20?ofkP0303eIZ`3o
m^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h04@3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3o
m^h0ooK^05T0ooK^1@0000120?ofkP40oooo001/0?ofkP800000J`3om^h00`0mFJ/0ooK^0?ofkP03
0?ofkP0303eIZ`3om^h0ooK^00L0ooK^00@0?EV[0?ofkP3om^h0ooK^0`0mFJ/50?ofkP0303eIZ`3o
m^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP@0?EV[403o
m^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0303eIZ`3om^h0ooK^00@0ooK^0P0mFJ]N0?ofkPD00000?@3o
m^h10?ooo`00K03om^h2000006X0ooK^0P0mFJ/40?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[
0?ofkP0mFJ/00P0mFJ/80?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h03@3om^h0
0`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0?EV[0080?EV[3@3om^h00`0mFJ/0ooK^0?ofkP0@
0?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h0H03om^h5000003P0ooK^0@3oool0
06`0ooK^0P00001Z0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h01`3om^h203eI
Z`X0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^
00h0ooK^00<0?EV[0?ofkP3om^h00`3om^h303eIZ`T0ooK^00<0?EV[0?ofkP3om^h0403om^h00`0m
FJ/0ooK^0?ofkP080?ofkP80?EV[I@3om^h4000003@0ooK^0@3oool006`0ooK^00<000000?ofkP3o
m^h0J03om^h203eIZ`D0ooK^00<0?EV[0?ofkP3om^h01@3om^h303eIZ`/0ooK^00<0?EV[0?ofkP3o
m^h02`3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3o
m^h01P3om^h403eIZ`D0ooK^00<0?EV[0?ofkP3om^h0403om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP03
03eIZ`3om^h0ooK^06H0ooK^1@00000_0?ofkP40oooo001[0?ofkP800000JP3om^h203eIZ`@0ooK^
00<0?EV[0?ofkP3om^h0103om^h203eIZ`030?ofkP0mFJ/0ooK^00/0ooK^00<0?EV[0?ofkP3om^h0
2`3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h0
2`3om^h303eIZ`030?ofkP0mFJ/0ooK^0140ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^
0?ofkP1Z0?ofkP<00000;03om^h10?ooo`00J`3om^h2000006T0ooK^0P0mFJ/50?ofkP0303eIZ`3o
m^h0ooK^0080ooK^0P0mFJ/30?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h02`3o
m^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h03P3o
m^h203eIZa80ooK^00<0?EV[0?ofkP3om^h03@3om^h203eIZf/0ooK^0P00000/0?ofkP40oooo001[
0?ofkP800000J@3om^h203eIZ`D0ooK^00<0?EV[0?ofkP3om^h00P0mFJ/40?ofkP0303eIZ`3om^h0
ooK^00X0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0
ooK^00h0ooK^00<0?EV[0?ofkP3om^h0403om^h303eIZ`l0ooK^00<0?EV[0?ofkP3om^h0403om^h0
0`0mFJ/0ooK^0?ofkP1X0?ofkP800000;03om^h10?ooo`00J`3om^h2000006P0ooK^00<0?EV[0?of
kP0mFJ/0103om^h0100mFJ/0ooK^03eIZ`0mFJ/60?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[
0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[
0?ofkP3om^h03`3om^h0100mFJ/0ooK^0?ofkP3om^h203eIZ`d0ooK^00<0?EV[0?ofkP3om^h03`3o
m^h00`0mFJ/0ooK^03eIZ`1X0?ofkP040000003om^h0ooK^000002/0ooK^0@3oool006/0ooK^0P00
001X0?ofkP80?EV[1@3om^h203eIZ`P0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?of
kP0;0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?of
kP0@0?ofkP0303eIZ`3om^h0ooK^00<0ooK^0P0mFJ/:0?ofkP0303eIZ`3om^h0ooK^0100ooK^00@0
?EV[0?ofkP3om^h0?EV[IP3om^h01@000000ooK^0?ofkP3om^h0000002/0ooK^0@3oool006/0ooK^
0P00001W0?ofkP0303eIZ`3om^h0?EV[00@0ooK^0P0mFJ/80?ofkP0303eIZ`3om^h0ooK^00X0ooK^
00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00h0ooK^
00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP060?ofkP80?EV[203om^h00`0mFJ/0ooK^
0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h0H`3om^h01@000000ooK^
0?ofkP3om^h0000002/0ooK^0@3oool006X0ooK^0P00001X0?ofkP0303eIZ`3om^h0?EV[00<0ooK^
0P0mFJ/90?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^
0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^
0?ofkP080?ofkP80?EV[1@3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0303eIZ`3om^h0ooK^00<0ooK^
00<0?EV[0?ofkP3om^h0H@3om^h00`000000ooK^0?ofkP020?ofkP030000003om^h0ooK^02T0ooK^
0@3oool006X0ooK^0P00001W0?ofkP0303eIZ`3om^h0?EV[00<0ooK^00<0?EV[0?ofkP0mFJ/02@3o
m^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h03@3o
m^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h02`3o
m^h203eIZ`<0ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3o
m^h0ooK^0600ooK^00<000000?ofkP3om^h00`3om^h00`000000ooK^0?ofkP0X0?ofkP40oooo001Z
0?ofkP800000I`3om^h00`0mFJ/0ooK^03eIZ`020?ofkP0403eIZ`3om^h0ooK^03eIZ`P0ooK^00<0
?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP080?ofkP/0?EV[1`3om^h00`0mFJ/0ooK^0?of
kP0?0?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h03@3om^h303eIZa80ooK^00<0
?EV[0?ofkP3om^h01P3om^h203eIZel0ooK^00<000000?ofkP3om^h0103om^h00`000000ooK^0?of
kP0X0?ofkP40oooo001Z0?ofkP800000IP3om^h203eIZ`040?ofkP0mFJ/0ooK^03eIZ`<0ooK^00<0
?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP090?ofkP0403eIZ`3om^h0ooK^0?ofkPP0?EV[
0`3om^h00`0mFJ/0ooK^0?ofkP050?ofkPX0?EV[3P3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eI
Z`3om^h0ooK^0100ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eI
Z`3om^h0ooK^05/0ooK^00<000000?ofkP3om^h01@3om^h00`000000ooK^0?ofkP0X0?ofkP40oooo
001Z0?ofkP800000IP3om^h00`0mFJ/0ooK^03eIZ`020?ofkP0403eIZ`3om^h0ooK^03eIZ`P0ooK^
00<0?EV[0?ofkP3om^h02@3om^h503eIZ`X0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^
0?ofkP0503eIZ`T0ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eI
Z`3om^h0?EV[0100ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP1J0?ofkP030000
003om^h0ooK^00D0ooK^00<000000?ofkP3om^h0:03om^h10?ooo`00JP3om^h2000006H0ooK^00D0
?EV[0?ofkP0mFJ/0ooK^03eIZ`030?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h0
1@3om^h403eIZ`030?ofkP0mFJ/0ooK^00`0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^
0?ofkP060?ofkPH0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0303eIZ`3om^h0ooK^00l0ooK^
00<0?EV[0?ofkP3om^h00P0mFJ/=0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h0
F03om^h00`000000ooK^0?ofkP060?ofkP030000003om^h0ooK^02P0ooK^0@3oool006T0ooK^00<0
00000?ofkP000000I@3om^h203eIZ`030?ofkP0mFJ/0?EV[00@0ooK^00<0?EV[0?ofkP3om^h01P3o
m^h00`0mFJ/0ooK^0?ofkP020?ofkP<0?EV[103om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3o
m^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h0303om^h403eIZa00ooK^00<0?EV[0?ofkP3om^h03`3o
m^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h03@3o
m^h00`0mFJ/0ooK^0?ofkP1F0?ofkP030000003om^h0ooK^00P0ooK^00<000000?ofkP3om^h09`3o
m^h10?ooo`00J@3om^h2000006H0ooK^100mFJ/40?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[
0?ofkP0mFJ/00`0mFJ/70?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h0303om^h0
0`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0?EV[0080?EV[3@3om^h00`0mFJ/0ooK^0?ofkP0?
0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP0?
0?ofkP0303eIZ`3om^h0ooK^05D0ooK^00<000000?ofkP3om^h0203om^h00`000000ooK^0?ofkP0W
0?ofkP40oooo001Y0?ofkP800000IP3om^h00`0mFJ/0ooK^03eIZ`050?ofkP0303eIZ`3om^h0ooK^
00H0ooK^0P0mFJ/:0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0m
FJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00<0ooK^0`0mFJ/90?ofkP0303eIZ`3om^h0ooK^
00l0ooK^00<0?EV[0?ofkP3om^h01P3om^h203eIZ`P0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0m
FJ/0ooK^03eIZ`1E0?ofkP030000003om^h0ooK^00T0ooK^00<000000?ofkP3om^h09`3om^h10?oo
o`00J@3om^h2000006D0ooK^100mFJ/50?ofkP0303eIZ`3om^h0ooK^00@0ooK^0`0mFJ/;0?ofkP03
03eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP03
03eIZ`3om^h0ooK^00H0ooK^100mFJ/50?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3o
m^h0203om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP0m
FJ/0E03om^h00`000000ooK^0?ofkP0:0?ofkP030000003om^h0ooK^02L0ooK^0@3oool006T0ooK^
0P00001U0?ofkP<0?EV[1@3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0?EV[00`0ooK^
00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00h0ooK^
00<0?EV[0?ofkP3om^h02`3om^h303eIZ`030?ofkP0mFJ/0ooK^0100ooK^00<0?EV[0?ofkP3om^h0
2P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00h0ooK^00D0?EV[0?ofkP3om^h0
ooK^03eIZ`1C0?ofkP030000003om^h0ooK^00/0ooK^00<000000?ofkP3om^h09P3om^h10?ooo`00
J@3om^h2000006D0ooK^0`0mFJ/50?ofkP0303eIZ`3om^h0ooK^0080ooK^0P0mFJ/20?ofkP0303eI
Z`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eI
Z`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h03P3om^h203eIZa40ooK^00<0?EV[0?ofkP3om^h0
2`3om^h203eIZ`80ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eI
Z`3om^h0ooK^04l0ooK^00<000000?ofkP3om^h0303om^h00`000000ooK^0?ofkP0V0?ofkP40oooo
001X0?ofkP030000003om^h0000006@0ooK^100mFJ/50?ofkP0303eIZ`3om^h0ooK^0080?EV[103o
m^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h0303o
m^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00l0ooK^0`0mFJ/>0?ofkP0303eIZ`3o
m^h0ooK^00h0ooK^00<0?EV[0?ofkP0mFJ/0403om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3o
m^h0ooK^04h0ooK^00<000000?ofkP3om^h03@3om^h00`000000ooK^0?ofkP0V0?ofkP40oooo001X
0?ofkP800000I@3om^h303eIZ`H0ooK^00<0?EV[0?ofkP0mFJ/01@3om^h00`0mFJ/0ooK^0?ofkP0:
0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0>
0?ofkP0303eIZ`3om^h0ooK^00l0ooK^00@0?EV[0?ofkP3om^h0ooK^0P0mFJ/<0?ofkP0303eIZ`3o
m^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3o
m^h0ooK^04d0ooK^00<000000?ofkP3om^h03@3om^h00`000000ooK^0?ofkP0V0?ofkP40oooo001X
0?ofkP800000I@3om^h303eIZ`D0ooK^0`0mFJ/60?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[
0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[
0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP030?ofkP80?EV[2@3om^h00`0mFJ/0ooK^0?ofkP0@
0?ofkP80?EV[3`3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^04/0ooK^00<00000
0?ofkP3om^h03P3om^h00`000000ooK^0?ofkP0V0?ofkP40oooo001X0?ofkP800000I03om^h403eI
Z`D0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^
00/0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^
00l0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^
00l0ooK^00@0?EV[0?ofkP3om^h0?EV[3P3om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0
ooK^04X0ooK^00<000000?ofkP3om^h03`3om^h00`000000ooK^0?ofkP0U0?ofkP40oooo001X0?of
kP800000I03om^h303eIZ`D0ooK^0P0mFJ/70?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?of
kP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?of
kP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP070?ofkP80?EV[1@3om^h00`0mFJ/0ooK^0?ofkP0@0?of
kP0503eIZ`3om^h0ooK^0?ofkP0mFJ/0303om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0
ooK^04T0ooK^00<000000?ofkP3om^h0403om^h00`000000ooK^0?ofkP0U0?ofkP40oooo001X0?of
kP800000I03om^h303eIZ`@0ooK^0P0mFJ/80?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?of
kP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?of
kP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP80?EV[0`3om^h00`0mFJ/0ooK^0?ofkP0?0?of
kP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP090?of
kP0303eIZ`3om^h0ooK^04L0ooK^00<000000?ofkP3om^h04@3om^h00`000000ooK^0?ofkP0U0?of
kP40oooo001W0?ofkP030000003om^h0000006<0ooK^1@0mFJ/20?ofkP0303eIZ`3om^h0?EV[00P0
ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP080?ofkQD0?EV[3P3om^h00`0mFJ/0
ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00`0ooK^0`0mFJ/B0?ofkP0303eIZ`3om^h0ooK^00@0
ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^04H0
ooK^00<000000?ofkP3om^h04@3om^h00`000000ooK^0?ofkP0U0?ofkP40oooo001W0?ofkP030000
003om^h0000006<0ooK^00<0?EV[0?ofkP0mFJ/00P0mFJ/01@3om^h0?EV[0?ofkP3om^h0?EV[00P0
ooK^00<0?EV[0?ofkP3om^h0203om^h0100mFJ/0ooK^0?ofkP3om^h803eIZ`<0ooK^00<0?EV[0?of
kP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0503eIZ`T0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0m
FJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h01P3om^h203eI
Z`L0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP150?ofkP030000003om^h0ooK^
01<0ooK^00<000000?ofkP3om^h0903om^h10?ooo`00I`3om^h2000006@0ooK^0`0mFJ/00`3om^h0
?EV[03eIZ`020?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h0203om^h503eIZ`X0
ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP060?ofkPH0?EV[0P3om^h00`0mFJ/0
ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00l0ooK^0`0mFJ/?0?ofkP0303eIZ`3om^h0ooK^00P0
ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^04<0
ooK^00<000000?ofkP3om^h0503om^h00`000000ooK^0?ofkP0T0?ofkP40oooo001W0?ofkP800000
H`3om^h403eIZ`030?ofkP0mFJ/0ooK^0080ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^
0?ofkP050?ofkP<0?EV[00<0ooK^03eIZ`3om^h0303om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eI
Z`3om^h0ooK^00`0ooK^100mFJ/@0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00D0?EV[0?ofkP3om^h0
ooK^03eIZ`0=0?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0
ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0?EV[04@0ooK^00<000000?ofkP3om^h0503om^h00`000000
ooK^0?ofkP0T0?ofkP40oooo001W0?ofkP800000H`3om^h00`0mFJ/0ooK^03eIZ`0303eIZ`<0ooK^
00<0?EV[0?ofkP3om^h01P3om^h0100mFJ/0ooK^0?ofkP3om^h403eIZ`<0ooK^00<0?EV[0?ofkP3o
m^h02`3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00l0ooK^00@0?EV[0?ofkP0m
FJ/0?EV[3@3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^0080ooK^0P0mFJ/;0?of
kP0303eIZ`3om^h0ooK^00/0ooK^00@0?EV[0?ofkP3om^h0?EV[3`3om^h00`0mFJ/0ooK^03eIZ`13
0?ofkP030000003om^h0ooK^01D0ooK^00<000000?ofkP3om^h0903om^h10?ooo`00I`3om^h20000
06<0ooK^100mFJ/01@3om^h0?EV[0?ofkP3om^h0?EV[00P0ooK^00<0?EV[0?ofkP0mFJ/00P0mFJ/7
0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0>
0?ofkP0303eIZ`3om^h0ooK^0080ooK^0`0mFJ/:0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[
0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[
0?ofkP0mFJ/03P3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[0440ooK^00<000000?ofkP3om^h05P3o
m^h00`000000ooK^0?ofkP0T0?ofkP40oooo001V0?ofkP030000003om^h0000006<0ooK^0`0mFJ/2
0?ofkP0403eIZ`3om^h0ooK^03eIZ`P0ooK^0P0mFJ/:0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0
?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00D0ooK^0P0m
FJ/70?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h01P3om^h203eIZ`L0ooK^00<0
?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/0
@@3om^h00`000000ooK^0?ofkP0G0?ofkP030000003om^h0ooK^02<0ooK^0@3oool006H0ooK^00<0
00000?ofkP000000HP3om^h403eIZ`<0ooK^00<0?EV[0?ofkP0mFJ/01P3om^h303eIZ`X0ooK^00<0
?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0
?EV[0?ofkP3om^h0203om^h303eIZ`@0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?of
kP090?ofkP80?EV[103om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0?EV[00d0ooK^00<0
?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP0m0?ofkP030000003om^h0ooK^01P0ooK^00<0
00000?ofkP3om^h08`3om^h10?ooo`00IP3om^h2000006<0ooK^0`0mFJ/40?ofkP0303eIZ`3om^h0
?EV[00D0ooK^00<0?EV[0?ofkP0mFJ/02`3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0
ooK^00`0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP80?EV[00<0ooK^
03eIZ`3om^h0403om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/0403o
m^h00`0mFJ/0ooK^03eIZ`0=0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h0?03o
m^h00`000000ooK^0?ofkP0I0?ofkP030000003om^h0ooK^02<0ooK^0@3oool006H0ooK^0P00001S
0?ofkP<0?EV[103om^h203eIZ`@0ooK^0P0mFJ/20?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[
0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[
0?ofkP3om^h03P3om^h203eIZa00ooK^00<0?EV[0?ofkP3om^h03@3om^h303eIZa00ooK^00D0?EV[
0?ofkP3om^h0ooK^03eIZ`0;0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h0>`3o
m^h00`000000ooK^0?ofkP0I0?ofkP030000003om^h0ooK^02<0ooK^0@3oool006H0ooK^0P00001R
0?ofkP@0?EV[103om^h203eIZ`80ooK^0P0mFJ/40?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[
0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[
0?ofkP3om^h03P3om^h0100mFJ/0ooK^03eIZ`0mFJ/>0?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0
?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0
?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP0j0?ofkP030000003om^h0ooK^01/0ooK^00<0
00000?ofkP3om^h08P3om^h10?ooo`00IP3om^h200000680ooK^0`0mFJ/50?ofkP80?EV[00<0ooK^
03eIZ`3om^h0103om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[
0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00l0ooK^00@0?EV[
0?ofkP3om^h0ooK^0P0mFJ/;0?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP0mFJ/03P3o
m^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h01`3o
m^h00`0mFJ/0ooK^0?ofkP0i0?ofkP030000003om^h0ooK^01/0ooK^00<000000?ofkP3om^h08P3o
m^h10?ooo`00I@3om^h00`000000ooK^0000001R0?ofkP<0?EV[103om^h403eIZ`H0ooK^00<0?EV[
0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[
0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00@0ooK^0P0mFJ/9
0?ofkP0303eIZ`3om^h0ooK^00l0ooK^00@0?EV[0?ofkP3om^h0?EV[3@3om^h00`0mFJ/0ooK^0?of
kP040?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?of
kP0h0?ofkP030000003om^h0ooK^01`0ooK^00<000000?ofkP3om^h08P3om^h10?ooo`00I@3om^h0
0`000000ooK^000000060?ofkP<0e3dIF03om^h403eIZ`@0ooK^0`0mFJ/70?ofkP0303eIZ`3om^h0
ooK^00P0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0
ooK^00d0ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP060?ofkP80?EV[1P3om^h0
0`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h02@3om^h0
0`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h02@3om^h0
0`0mFJ/0ooK^0?ofkP0f0?ofkP030000003om^h0ooK^01d0ooK^00<000000?ofkP3om^h08P3om^h1
0?ooo`00I@3om^h00`000000ooK^000000050?ofkPX0e3dIDP3om^h303eIZ`D0ooK^0`0mFJ/60?of
kP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP0<0?of
kP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP090?of
kP80?EV[103om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?of
kP3om^h0203om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?of
kP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP0f0?ofkP030000003om^h0ooK^01d0ooK^00<000000?of
kP3om^h08P3om^h10?ooo`00I@3om^h2000000H0ooK^0`3D?AT00`3om^h0e3dI0=@m6@090=@m6Dd0
ooK^0`0mFJ/40?ofkP80?EV[0P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00T0
ooK^00<0?EV[0?ofkP3om^h01`3om^hE03eIZ`d0ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0
ooK^0?ofkP0;0?ofkP80?EV[00<0ooK^03eIZ`3om^h0403om^h00`0mFJ/0ooK^0?ofkP050?ofkP03
03eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h02@3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[
00d0ooK^00<0?EV[0?ofkP3om^h0=03om^h00`000000ooK^0?ofkP0O0?ofkP030000003om^h0ooK^
0240ooK^0@3oool006D0ooK^0P0000060?ofkP80e3dI00<0ooK^0=@m6@3D?AT0103D?AT00`3om^h0
e3dI0=@m6@090=@m6DL0ooK^0`0mFJ/30?ofkP<0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP03
03eIZ`3om^h0ooK^00P0ooK^00@0?EV[0?ofkP3om^h0ooK^1`0mFJ/30?ofkP0303eIZ`3om^h0ooK^
00`0ooK^00<0?EV[0?ofkP3om^h01@0mFJ/80?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?of
kP3om^h03P3om^h203eIZa40ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP050?of
kP0303eIZ`3om^h0ooK^00T0ooK^00@0?EV[0?ofkP3om^h0?EV[3@3om^h203eIZcD0ooK^00<00000
0?ofkP3om^h0803om^h00`000000ooK^0?ofkP0Q0?ofkP40oooo001U0?ofkP8000001P3om^h00`3D
?AT0ooK^0?ofkP060?ofkPD0e3dI0P3om^h:0=@m6D40ooK^00@0?EV[0?ofkP0mFJ/0?EV[0P3om^h0
100mFJ/0ooK^03eIZ`0mFJ/20?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h01`3o
m^h503eIZ`T0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP060?ofkPD0?EV[0P3o
m^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00l0ooK^0`0mFJ/>0?ofkP0303eIZ`3o
m^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3o
m^h0?EV[00d0ooK^0P0mFJ/e0?ofkP030000003om^h0ooK^0200ooK^00<000000?ofkP3om^h08@3o
m^h10?ooo`00I@3om^h2000000D0ooK^0P3D?AT=0?ofkPH0e3dI0P3om^h:0=@m6C/0ooK^00L0?EV[
0?ofkP0mFJ/0?EV[0?ofkP0mFJ/0ooK^0080?EV[103om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00P0
ooK^0P0mFJ/00`3om^h0?EV[0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3o
m^h02`3om^h403eIZ`l0ooK^00<0?EV[0?ofkP3om^h03`3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[
00d0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^
00`0ooK^00<0?EV[0?ofkP3om^h02`3om^h0100mFJ/0ooK^0?ofkP0mFJ/c0?ofkP030000003om^h0
ooK^0240ooK^00<000000?ofkP3om^h08@3om^h10?ooo`00I03om^h00`000000ooK^000000050?of
kP@0e3dI4@3om^h50=@m6@80ooK^2`3D?ATe0?ofkPD0?EV[0P3om^h203eIZ`@0ooK^00D0?EV[0?of
kP3om^h0ooK^03eIZ`050?ofkP<0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0
ooK^00/0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^03eIZ`0203eIZ``0ooK^00<0?EV[
0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP020?ofkP80?EV[2P3om^h00`0mFJ/0ooK^0?ofkP0;
0?ofkP0403eIZ`3om^h0ooK^03eIZ`h0ooK^00<0?EV[0?ofkP0mFJ/0303om^h0100mFJ/0ooK^0?of
kP0mFJ/b0?ofkP030000003om^h0ooK^02<0ooK^00<000000?ofkP3om^h0803om^h10?ooo`00I03o
m^h00`000000ooK^000000050?ofkP<0e3dI00<0ooK^0=@m6@3D?AT0103D?AT=0?ofkP030=@m6@3o
m^h0e3dI00H0e3dI0P3om^h;0=@m6Bh0ooK^1@0mFJ/20?ofkP0303eIZ`3om^h0?EV[00D0ooK^00@0
?EV[0?ofkP3om^h0?EV[0P3om^h303eIZ`D0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^
0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h00`3om^h303eIZ`P0ooK^
00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00L0ooK^
00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^03eIZ`0>0?ofkP0303eIZ`3om^h0?EV[00/0ooK^
00D0?EV[0?ofkP3om^h0ooK^03eIZ`0b0?ofkP030000003om^h0ooK^02<0ooK^00<000000?ofkP3o
m^h0803om^h10?ooo`00I03om^h2000000H0ooK^0P3D?AT00`3om^h0e3dI0=@m6@040=@m6@030?of
kP3D?AT0e3dI00@0e3dI1`3om^h00`3D?AT0ooK^0=@m6@060?ofkPD0e3dI0`3om^h:0=@m6BT0ooK^
00L0?EV[0?ofkP0mFJ/0?EV[0?ofkP0mFJ/0ooK^0080?EV[1P3om^h0100mFJ/0ooK^03eIZ`3om^h2
03eIZ`P0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0
ooK^00d0ooK^00<0?EV[0?ofkP3om^h01P3om^h303eIZ`D0ooK^00<0?EV[0?ofkP3om^h03`3om^h0
0`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h03P3om^h0
0`0mFJ/0ooK^0?ofkP0<0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/02P3om^h01@0mFJ/0ooK^0?of
kP3om^h0?EV[0340ooK^00<000000?ofkP3om^h0903om^h00`000000ooK^0?ofkP0P0?ofkP40oooo
001T0?ofkP8000001P3om^h20=@m6@L0ooK^1@3D?AT20?ofkPL0e3dI0P3om^h00`3D?AT0ooK^0?of
kP090?ofkPH0e3dI0`3om^h:0=@m6B<0ooK^0`0mFJ/20?ofkP0403eIZ`3om^h0?EV[03eIZ`H0ooK^
00@0?EV[0?ofkP0mFJ/0?EV[2@3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00/0
ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP<0?EV[00<0ooK^03eIZ`3o
m^h0403om^h00`0mFJ/0ooK^0?ofkP080?ofkP80?EV[1@3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP03
03eIZ`3om^h0?EV[00d0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`090?ofkP0303eIZ`3om^h0ooK^
00<0ooK^00<0?EV[0?ofkP3om^h0;P3om^h00`000000ooK^0?ofkP0T0?ofkP030000003om^h0ooK^
0200ooK^0@3oool006@0ooK^0P0000060?ofkP80e3dI303om^h60=@m6@80ooK^1P3D?AT?0?ofkPH0
e3dI0P3om^h:0=@m6Ad0ooK^100mFJ/20?ofkP80?EV[00<0ooK^03eIZ`3om^h01@3om^h303eIZ`X0
ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00d0
ooK^00<0?EV[0?ofkP3om^h03@3om^h203eIZa40ooK^00<0?EV[0?ofkP3om^h02P3om^h01@0mFJ/0
ooK^0?ofkP3om^h0?EV[0100ooK^00<0?EV[0?ofkP0mFJ/0303om^h00`0mFJ/0ooK^0?ofkP030?of
kP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0]0?of
kP030000003om^h0ooK^02D0ooK^00<000000?ofkP3om^h0803om^h10?ooo`00I03om^h2000000D0
ooK^0P3D?ATC0?ofkPH0e3dI0P3om^h60=@m6@/0ooK^00<0e3dI0?ofkP3om^h01P3D?AT30?ofkPX0
e3dI5`3om^h303eIZ`<0ooK^0P0mFJ/00`3om^h0?EV[0?ofkP040?ofkP0303eIZ`3om^h0?EV[00X0
ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00h0
ooK^00<0?EV[0?ofkP3om^h03P3om^h303eIZ`h0ooK^00<0?EV[0?ofkP3om^h0303om^h203eIZ`03
0?ofkP0mFJ/0ooK^00h0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0;0?ofkP0303eIZ`3om^h0ooK^
00<0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^
02`0ooK^00<000000?ofkP3om^h09`3om^h00`000000ooK^0?ofkP0O0?ofkP40oooo001S0?ofkP03
0000003om^h0000000D0ooK^0P3D?ATE0?ofkP030=@m6@3om^h0ooK^00D0e3dI103om^h60=@m6@@0
ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@050?ofkPD0e3dI0`3om^h:0=@m6A80ooK^0`0mFJ/30?of
kP<0?EV[103om^h203eIZ`80ooK^0P0mFJ/90?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?of
kP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00@0?EV[0?of
kP3om^h0ooK^0P0mFJ/<0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h03P3om^h0
0`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h01@3om^h0
0`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h0;03om^h0
0`000000ooK^0?ofkP0W0?ofkP030000003om^h0ooK^01l0ooK^0@3oool006<0ooK^00<000000?of
kP0000001@3om^h20=@m6A@0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@040?ofkPH0e3dI103om^h6
0=@m6@80ooK^00<0e3dI0?ofkP3om^h0203om^h60=@m6@<0ooK^2@3D?AT<0?ofkP0403eIZ`3om^h0
?EV[03eIZ`<0ooK^00<0?EV[0?ofkP0mFJ/00P3om^h203eIZ`<0ooK^00<0?EV[0?ofkP0mFJ/02@3o
m^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h03@3o
m^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00<0ooK^0P0mFJ/90?ofkP0303eIZ`3o
m^h0ooK^00l0ooK^0P0mFJ/>0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h01P3o
m^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h01P3o
m^h00`0mFJ/0ooK^0?ofkP0Z0?ofkP030000003om^h0ooK^02P0ooK^00<000000?ofkP3om^h07`3o
m^h10?ooo`00H`3om^h00`000000ooK^000000050?ofkP80e3dI503om^h01@3D?AT0ooK^0?ofkP3o
m^h0e3dI00X0ooK^1@3D?AT20?ofkP030=@m6@3om^h0ooK^00D0e3dI3P3om^h60=@m6@80ooK^2P3D
?AT60?ofkP<0?EV[103om^h01@0mFJ/0ooK^03eIZ`3om^h0?EV[00D0ooK^00@0?EV[0?ofkP3om^h0
?EV[1`3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3o
m^h03@3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3o
m^h01P3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0403eIZ`3om^h0ooK^03eIZ`d0ooK^00<0?EV[0?of
kP3om^h0103om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00L0ooK^00D0?EV[0?of
kP3om^h0ooK^03eIZ`090?ofkP0303eIZ`3om^h0ooK^02T0ooK^00<000000?ofkP3om^h0:@3om^h0
0`000000ooK^0?ofkP0O0?ofkP40oooo001S0?ofkP8000001P3om^h40=@m6A80ooK^00@0e3dI0?of
kP3om^h0e3dI403om^h60=@m6@040?ofkP3D?AT0ooK^0?ofkP@0e3dI2`3om^h0103D?AT0ooK^0?of
kP3om^h80=@m6@030?ofkP3D?AT0e3dI00L0e3dI00@0ooK^03eIZ`0mFJ/0?EV[103om^h403eIZ`H0
ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`060?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?of
kP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?of
kP3om^h01`3om^h203eIZ`D0ooK^00<0?EV[0?ofkP3om^h03`3om^h01@0mFJ/0ooK^0?ofkP3om^h0
?EV[00/0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0
ooK^00L0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`090?ofkP0303eIZ`3om^h0ooK^02T0ooK^00<0
00000?ofkP3om^h0:P3om^h00`000000ooK^0?ofkP0N0?ofkP40oooo001S0?ofkP8000001P3om^h2
0=@m6@030?ofkP3D?AT0e3dI00D0e3dI303om^h0103D?AT0ooK^0?ofkP3D?ATB0?ofkP040=@m6@3o
m^h0ooK^0?ofkPL0e3dI00<0ooK^0=@m6@3D?AT00`3D?AT50?ofkP030=@m6@3om^h0ooK^0080ooK^
00<0e3dI0?ofkP3om^h01@3om^h;0=@m6@<0?EV[0P3D?AT0103om^h0?EV[0?ofkP0mFJ/70?ofkP03
03eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP03
03eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP03
03eIZ`3om^h0ooK^00T0ooK^0P0mFJ/30?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3o
m^h00`3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3o
m^h00P3om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0?EV[00T0ooK^0P0mFJ/Z0?ofkP03
0000003om^h0ooK^02/0ooK^00<000000?ofkP3om^h07P3om^h10?ooo`00H`3om^h2000000H0ooK^
0P3D?AT60?ofkPP0e3dI1@3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI0140ooK^00<0e3dI0?ofkP3o
m^h00`3om^h00`3D?AT0ooK^0?ofkP030?ofkP`0e3dI1@3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP<0
e3dI0`0mFJ/20=@m6@030?ofkP3D?AT0?EV[0080?EV[1`0000000`0mFJ/0ooK^0?ofkP030?ofkP03
03eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h0203om^hD03eIZ`d0ooK^00<0?EV[0?ofkP3o
m^h03P3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP<0?EV[4@3om^h00`0mFJ/0ooK^0?ofkP040?ofkP03
03eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h02@3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[
00/0ooK^00<0?EV[0?ofkP0mFJ/02@3om^h203eIZbT0ooK^00<000000?ofkP3om^h0;03om^h00`00
0000ooK^0?ofkP0N0?ofkP40oooo001R0?ofkP030000003om^h0000000D0ooK^00<0e3dI0?ofkP3D
?AT0303om^h80=@m6@<0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP030?ofkP03
0=@m6@3om^h0ooK^00X0ooK^203D?AT20?ofkP030=@m6@3om^h0ooK^00d0ooK^00@0e3dI03eIZ`3o
m^h0?EV[103D?AT303eIZ`@000000`0m3PD00`0mFJ/00000000000030000000303eIZ`3om^h0ooK^
0080ooK^00@0?EV[0?ofkP3om^h0ooK^1`0mFJ/30?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[
0?ofkP3om^h01@0mFJ/80?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h03P3om^h0
0`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h01@3om^h0
0`0mFJ/0ooK^0?ofkP090?ofkP0403eIZ`3om^h0ooK^03eIZ`d0ooK^00<0?EV[0?ofkP3om^h01`3o
m^h00`0mFJ/0ooK^03eIZ`0Y0?ofkP030000003om^h0ooK^02`0ooK^00<000000?ofkP3om^h07P3o
m^h10?ooo`00HP3om^h00`000000ooK^000000050?ofkP030=@m6@3om^h0e3dI0140ooK^2@3D?AT?
0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP07
0=@m6@d0ooK^00L0e3dI03eIZ`0mFJ/0?EV[0000003D?AT0F1<80080?EV[0P1H4`P0100mFJ/0F1<8
05PC201H4`P20000000303eIZ`0000000000008000000`0m3PD0100mFJ/0000000000000000403eI
Z`T0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP060?ofkPD0?EV[0P3om^h00`0m
FJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00l0ooK^0`0mFJ/>0?ofkP0303eIZ`3om^h0ooK^
00L0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0?EV[
00`0ooK^0P0mFJ/90?ofkP0303eIZ`3om^h0?EV[02P0ooK^00<000000?ofkP3om^h0;@3om^h00`00
0000ooK^0?ofkP0N0?ofkP40oooo001R0?ofkP030000003om^h0000000D0ooK^00<0e3dI0?ofkP3D
?AT04`3om^h0103D?AT0ooK^0?ofkP3om^h90=@m6@T0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D
?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00D0ooK^2@3D?AT60?ofkP030=@m6@0mFJ/0ooK^
0080?EV[0`0000001@0mFJ/0F1<805PC201H4`P0?EV[00<0F1<80P0000000`0mFJ/0F1<805PC2002
05PC20@0000000<0?EV[0000000000001@0000080?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[
0?ofkP3om^h02`3om^h403eIZ`l0ooK^00<0?EV[0?ofkP3om^h03P3om^h01@0mFJ/0ooK^0?ofkP3o
m^h0?EV[00`0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3o
m^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h02`3om^h203eIZ`P0ooK^00@0?EV[0?ofkP3om^h0?EV[
9`3om^h00`000000ooK^0?ofkP0_0?ofkP030000003om^h0ooK^01d0ooK^0@3oool00680ooK^00<0
00000?ofkP0000001@3om^h20=@m6A@0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@060?ofkPP0e3dI
0P3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h0
1@3om^h00`3D?AT0ooK^0?ofkP040?ofkPT0e3dI00@0?EV[0?ofkP0mFJ/0?EV[0`1m7P`01@0mFJ/0
0000000000000000?EV[00@0000000<0F1<803eIZ`1H4`P01P1H4`P010000000?EV[05PC201H4`P4
0000000303d>1@000000000000@0000000<0ooK^03eIZ`3om^h0303om^h00`0mFJ/0ooK^0?ofkP0>
0?ofkP0303eIZ`3om^h0?EV[0080?EV[303om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0
ooK^0080ooK^0P0mFJ/:0?ofkP0303eIZ`3om^h0ooK^00X0ooK^00@0?EV[0?ofkP3om^h0?EV[3P3o
m^h203eIZ``0ooK^00@0?EV[0?ofkP3om^h0?EV[1`3om^h0100mFJ/0ooK^0?ofkP0mFJ/W0?ofkP03
0000003om^h0ooK^02l0ooK^00<000000?ofkP3om^h07@3om^h10?ooo`00HP3om^h2000000H0ooK^
0P3D?ATC0?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h02`3om^h70=@m6@<0ooK^
00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00T0ooK^
103D?AT203eIZ`0307dN300mFJ/0OAh<0080OAh<00<0?EV[07dN301m7P`00P1m7P`01@0mFJ/0OAh<
07dN301m7P`0?EV[00@000000`1H4`P010000000F1<805PC200mFJ/505PC20D000000P0m3PD40000
00/0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP030?ofkP<0?EV[203om^h00`0m
FJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0m
FJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0?EV[00h0ooK^00<0?EV[0?ofkP0mFJ/02`3om^h0100m
FJ/0ooK^0?ofkP0mFJ/60?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/09P3om^h00`000000ooK^0?of
kP0`0?ofkP030000003om^h0ooK^01d0ooK^0@3oool00680ooK^0P0000050?ofkP030=@m6@3om^h0
e3dI01<0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0
ooK^00L0e3dI303om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00/0ooK^00H0e3dI
03eIZ`0mFJ/0?EV[07dN300mFJ/207dN300303eIZ`1m7P`0OAh<00<0OAh<00D0?EV[07dN301m7P`0
OAh<03eIZ`0407dN30D000000P1H4`P00`0mFJ/0F1<805PC200305PC20040000001H4`P0F1<805PC
20@0000000<0e3dI03d>1@000000100000060?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?of
kP3om^h01P3om^h303eIZ`D0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP060?of
kP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0<0?of
kP0403eIZ`3om^h0ooK^03eIZ`X0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`050?ofkP0303eIZ`3o
m^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h0903om^h00`000000ooK^0?ofkP0`0?ofkP030000003o
m^h0ooK^01d0ooK^0@3oool00640ooK^00<000000?ofkP0000001@3om^h00`3D?AT0ooK^0=@m6@0C
0?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP04
0?ofkPT0e3dI1@3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00X0ooK^00L0e3dI
0?ofkP0mFJ/0000003eIZ`1m7P`0?EV[0080OAh<00<0?EV[07dN301m7P`00P1m7P`00`000000?EV[
07dN300207dN300303eIZ`1m7P`0OAh<00@0OAh<00<0000007dN301m7P`00P0000000`0mFJ/00000
0000000305PC20030000001H4`P0F1<800D0F1<83`00000=0?ofkP0303eIZ`3om^h0ooK^00X0ooK^
0`0mFJ/00`3om^h0?EV[0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00P0ooK^0P0mFJ/40?ofkP0303eI
Z`3om^h0ooK^00h0ooK^0P0mFJ/=0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/0203om^h00`0mFJ/0
ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0
ooK^0?ofkP0S0?ofkP030000003om^h0ooK^0380ooK^00<000000?ofkP3om^h0703om^h10?ooo`00
H@3om^h00`000000ooK^000000050?ofkP<0e3dI4`3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI0100
ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP040?ofkPP0e3dI203om^h00`3D?AT0
ooK^0?ofkP0:0?ofkP050=@m6@3om^h0?EV[03eIZ`2R:Q400P000000100mFJ/0000003eIZ`000003
07dN30050000001m7P`0?EV[07dN300mFJ/01P1m7P`00`000000OAh<07dN300407dN300303eIZ`1m
7P`0000000@00000201H4`P00`000000F1<805PC200205PC20L0000000<0?@h50000000000001000
00070?ofkP0303eIZ`3om^h0ooK^00d0ooK^0P0mFJ/@0?ofkP0303eIZ`3om^h0ooK^00X0ooK^00D0
?EV[0?ofkP3om^h0ooK^03eIZ`0?0?ofkP0303eIZ`3om^h0?EV[00`0ooK^00<0?EV[0?ofkP3om^h0
0P3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00<0ooK^00D0?EV[0?ofkP3om^h0
ooK^03eIZ`050?ofkP0303eIZ`3om^h0ooK^0280ooK^00<000000?ofkP3om^h0<`3om^h00`000000
ooK^0?ofkP0L0?ofkP40oooo001Q0?ofkP030000003om^h0000000D0ooK^00<0e3dI0?ofkP3D?AT0
1@3D?AT>0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT0403om^h00`3D?AT0ooK^0?ofkP050?ofkP03
0=@m6@3om^h0ooK^00T0ooK^2@3D?AT20?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP00
00000P0mFJ/30:8Z4@80?EV[0P2R:Q450000000303eIZ`1m7P`0?EV[00H0OAh<00<0000007dN301m
7P`0101m7P`203eIZ`80OAh<00<0000007dN301m7P`01@00000205PC20030000001H4`P0F1<800L0
F1<800<0000005PC201H4`P010000000100m3PD0000003d>1@0m3PD3000000<0ooK^00<0?EV[0?of
kP3om^h03P3om^h303eIZ`d0ooK^00<0?EV[0?ofkP3om^h0303om^h303eIZa00ooK^00@0?EV[0?of
kP3om^h0?EV[2`3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[
0?ofkP3om^h0103om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00D0ooK^00<0?EV[0?ofkP3om^h08P3o
m^h00`000000ooK^0?ofkP0c0?ofkP030000003om^h0ooK^01`0ooK^0@3oool00640ooK^00<00000
0?ofkP0000001@3om^h00`3D?AT0ooK^0=@m6@020?ofkPT0e3dI1`3om^h00`3D?AT0ooK^0?ofkP02
0?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP0;
0?ofkP030=@m6@3om^h0ooK^00X0e3dI203om^h00`3D?AT0ooK^03eIZ`0203eIZ`<0XRXA0P0mFJ/4
0:8Z4@060000002R:Q40XRXA03eIZ`000000?EV[0`00000207dN30030000001m7P`0OAh<00@0OAh<
00D0?EV[07dN301m7P`0?EV[0000000807dN30D000001`1H4`P00`000000F1<805PC200405PC20H0
000000<0?@h50000000000000`00000>0?ofkP0403eIZ`3om^h0ooK^0?ofkP80?EV[2`3om^h00`0m
FJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0m
FJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0m
FJ/0ooK^0?ofkP040?ofkP0403eIZ`3om^h0ooK^03eIZ`H0ooK^00<0?EV[0?ofkP3om^h08@3om^h0
0`000000ooK^0?ofkP0d0?ofkP030000003om^h0ooK^01`0ooK^0@3oool00640ooK^0P0000050?of
kP040=@m6@3om^h0ooK^0=@m6@P0ooK^203D?AT20?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI
0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI
0?ofkP3om^h01P3om^h;0=@m6@80ooK^00<0e3dI0000000mFJ/00P0mFJ/30:8Z4@80?EV[0`2R:Q40
0`000000XRXA0:8Z4@020:8Z4@0303eIZ`2R:Q40XRXA0080XRXA1@00000407dN300503eIZ`1m7P`0
OAh<07dN300mFJ/02P1m7P`00`000000OAh<07dN300500000080F1<800<0000005PC201H4`P01P1H
4`P010000000F1<805PC201H4`P>000000H0ooK^00<0?EV[0?ofkP3om^h00`3om^h203eIZ`P0ooK^
00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^03eIZ`0>0?ofkP0303eIZ`3om^h0ooK^00<0ooK^
00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^0080ooK^
00<0?EV[0?ofkP3om^h01@3om^h0100mFJ/0ooK^0?ofkP0mFJ/60?ofkP0303eIZ`3om^h0ooK^0200
ooK^00<000000?ofkP3om^h0=@3om^h00`000000ooK^0?ofkP0L0?ofkP40oooo001Q0?ofkP800000
1@3om^h0103D?AT0ooK^0?ofkP3D?AT>0?ofkPP0e3dI00<0ooK^0=@m6@3om^h03`3om^h00`3D?AT0
ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h01`3om^h0103D?AT0
ooK^0?ofkP3om^h50=@m6@030?ofkP3D?AT0e3dI0080e3dI00<0XRXA03eIZ`2R:Q400`2R:Q4203eI
Z`<0XRXA00<000000:8Z4@2R:Q400P2R:Q400`0mFJ/0XRXA0:8Z4@040:8Z4@030000002R:Q40XRXA
00@0000000H0?EV[07dN301m7P`0000007dN300mFJ/907dN30030000001m7P`0OAh<00D0OAh<1`00
000505PC20030000001H4`P0F1<800@0F1<800<0000005PC201H4`P01P0000000`0m3PD000000000
00030000000303eIZ`3om^h0ooK^00H0ooK^0P0mFJ/60?ofkP0303eIZ`3om^h0ooK^00h0ooK^00@0
?EV[0?ofkP3om^h0?EV[303om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00D0ooK^
00<0?EV[0?ofkP3om^h01P3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00T0ooK^0P0mFJ/60?ofkP80
?EV[8P3om^h00`000000ooK^0?ofkP0f0?ofkP030000003om^h0ooK^01/0ooK^0@3oool00600ooK^
00<000000?ofkP0000001@3om^h00`3D?AT0ooK^0=@m6@0C0?ofkP030=@m6@3om^h0e3dI00P0e3dI
2P3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h0
1`3om^h00`3D?AT0ooK^0?ofkP060?ofkP<0e3dI00@000000:8Z4@0mFJ/0?EV[102R:Q401@0mFJ/0
XRXA0:8Z4@2R:Q40000000D0XRXA0P0mFJ/40:8Z4@030000002R:Q40XRXA00@0XRXA00<0?EV[0:8Z
4@000000100000000`0mFJ/0OAh<07dN300507dN30030000001m7P`0OAh<00P0OAh<00<0000007dN
301m7P`00P1m7P`8000000D0F1<800<0000005PC201H4`P00`1H4`P500000080?@h50P0000000`0m
3PD00000000000070?ofkP80?EV[0`3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^
0080ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^
00@0ooK^00<0?EV[0?ofkP3om^h01`3om^h0100mFJ/0ooK^0?ofkP0mFJ/90?ofkP80?EV[1P3om^h0
0`0mFJ/0ooK^0?ofkP0P0?ofkP030000003om^h0ooK^03L0ooK^00<000000?ofkP3om^h06`3om^h1
0?ooo`00H03om^h00`000000ooK^00000002000000<0ooK^00<0e3dI0?ofkP3D?AT04P3om^h00`3D
?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00X0e3dI0`3om^h00`3D?AT0ooK^0?ofkP050?of
kP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP080?of
kP030=@m6@00000000000080?EV[102R:Q401@0mFJ/0XRXA0:8Z4@2R:Q40000000@0XRXA00<0?EV[
0:8Z4@0mFJ/0102R:Q400`000000XRXA0:8Z4@040:8Z4@0503eIZ`2R:Q40XRXA0:8Z4@0000000P2R
:Q400`000000?EV[0000000300000080OAh<00<0000007dN301m7P`0201m7P`00`000000OAh<07dN
300707dN30030000001m7P`0OAh<00@0000000<0F1<80000001H4`P01`1H4`P00`000000F1<80000
000500000080?@h5100000040?ofkP80?EV[00<0ooK^03eIZ`3om^h03`3om^h00`0mFJ/0ooK^0?of
kP030?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?of
kP020?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP0mFJ/02P3om^h00`0mFJ/0ooK^0?of
kP040?ofkP80?EV[8@3om^h00`000000ooK^0?ofkP0h0?ofkP030000003om^h0ooK^01/0ooK^0@3o
ool00600ooK^00<000000?ofkP0000000P3om^h600000180ooK^00<0e3dI0?ofkP3om^h00`3om^h0
0`3D?AT0ooK^0?ofkP050?ofkP@0e3dI00<0ooK^0=@m6@3D?AT0103D?AT50?ofkP030=@m6@3om^h0
ooK^00X0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP070?ofkP050=@m6@3om^h0
00000;/b500mFJ/01@000000100mFJ/0XRXA0:8Z4@0000050:8Z4@0403eIZ`2R:Q40XRXA03eIZ`<0
XRXA00<000000:8Z4@2R:Q40102R:Q401@0mFJ/0XRXA0:8Z4@2R:Q40000000<0XRXA00<0?EV[0:8Z
4@2R:Q400P2R:Q45000000P0OAh<00<0000007dN301m7P`01`1m7P`00`000000OAh<07dN300407dN
30D000001@1H4`P00`000000F1<805PC200305PC20H0000000<0?@h50000000000001@00000203eI
Z`l0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^
00P0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0;0?ofkP80?EV[2@3om^h203eIZ`H0ooK^0P0mFJ/Q
0?ofkP030000003om^h0ooK^03P0ooK^00<000000?ofkP3om^h06`3om^h10?ooo`00H03om^h00`00
0000ooK^000000050?ofkP030=@m6@3om^h0e3dI00H00000303om^h00`3D?AT0ooK^0?ofkP030?of
kP030=@m6@3om^h0ooK^00T0ooK^1@3D?AT20?ofkPH0e3dI303om^h00`3D?AT0ooK^0?ofkP070?of
kP030=@m6@3om^h0ooK^00P0ooK^00D0e3dI000000000000^c8D03eIZ`040;/b500303eIZ`2k<Q@0
?EV[00@000000`2R:Q401@0mFJ/0XRXA0:8Z4@2R:Q40?EV[0080XRXA00<000000:8Z4@2R:Q400`2R
:Q400`0mFJ/0XRXA0:8Z4@020:8Z4@030000002R:Q40XRXA0080XRXA00<0?EV[0:8Z4@2R:Q400`2R
:Q400`000000XRXA0:8Z4@0600000080OAh<00<0000007dN301m7P`01`1m7P`00`000000OAh<07dN
300607dN30030000001m7P`0OAh<00D0000000<0F1<80000001H4`P01P1H4`P00`000000F1<805PC
20070000000303d>1@0000000000008000003@3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3o
m^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h02@3om^h0100mFJ/0ooK^0?ofkP0mFJ/<0?ofkP0303eI
Z`3om^h0ooK^00P0ooK^0P0mFJ/50?ofkP0303eIZ`3om^h0?EV[0200ooK^00<000000?ofkP3om^h0
>P3om^h00`000000ooK^0?ofkP0J0?ofkP40oooo001P0?ofkP8000001@3om^h0103D?AT0ooK^0?of
kP3D?AT60?ofkPH000001P3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00d0ooK^
00<0e3dI0?ofkP3D?AT0103D?AT20?ofkPD0e3dI203om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m
6@3om^h0ooK^00P0ooK^00D0e3dI0000002k<Q@0^c8D03eIZ`040;/b500503eIZ`2k<Q@0?EV[0;/b
500000000P2k<Q@20000000803eIZ`00000000000000002R:Q40?EV[0:8Z4@0000060:8Z4@0503eI
Z`2R:Q40XRXA0:8Z4@0000001P2R:Q400`0mFJ/0XRXA0:8Z4@020:8Z4@030000002R:Q40XRXA00H0
XRXA1@00000707dN30030000001m7P`0OAh<00L0OAh<00<0000007dN301m7P`0101m7P`5000000D0
F1<800<0000005PC201H4`P0101H4`P00`000000F1<80000000400000080?@h50`0000070?ofkP03
03eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP03
03eIZ`3om^h0?EV[00/0ooK^0P0mFJ/90?ofkP0303eIZ`3om^h0?EV[00D0ooK^0P0mFJ/P0?ofkP03
0000003om^h0ooK^03/0ooK^00<000000?ofkP3om^h06P3om^h10?ooo`00H03om^h2000000D0ooK^
00@0e3dI0?ofkP3om^h0e3dI303om^h5000000030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3o
m^h03@3om^h00`3D?AT0ooK^0?ofkP040?ofkPD0e3dI0P3om^h50=@m6@80ooK^00<0e3dI0?ofkP3o
m^h0203om^h00`3D?AT0ooK^0?ofkP070?ofkP040=@m6@3om^h000000;/b5080?EV[102k<Q@01@0m
FJ/0^c8D03eIZ`2k<Q@0000000@0^c8D00@0?EV[0;/b502k<Q@0^c8D0P000000100mFJ/000000000
000000040:8Z4@0503eIZ`2R:Q40XRXA0:8Z4@0000001`2R:Q401@0mFJ/0XRXA0:8Z4@2R:Q400000
00X0XRXA00<000000:8Z4@2R:Q401@00000207dN30030000001m7P`0OAh<00L0OAh<00<0000007dN
301m7P`01P1m7P`00`000000OAh<07dN30050000000305PC20000000F1<800D0F1<80P00000305PC
20H0000000<0?@h5000000000000100000000`0mFJ/0ooK^0?ofkP090?ofkP0503eIZ`3om^h0ooK^
0?ofkP0mFJ/03P3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP80?EV[2@3om^h00`0mFJ/0ooK^03eIZ`04
0?ofkP0303eIZ`3om^h0?EV[0200ooK^00<000000?ofkP3om^h0>`3om^h00`000000ooK^0?ofkP0J
0?ofkP40oooo001O0?ofkP030000003om^h0000000D0ooK^00@0e3dI0?ofkP3om^h0e3dI4@3om^h6
000000030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP06
0=@m6@030?ofkP3D?AT0e3dI00@0e3dI1`3om^h00`3D?AT0ooK^0?ofkP070?ofkP040=@m6@3om^h0
00000;/b5080?EV[0`2k<Q@01P0mFJ/0^c8D0;/b502k<Q@0?EV[000000@0^c8D00<0?EV[0;/b502k
<Q@00`2k<Q@0100mFJ/000000;/b502k<Q@30000000303eIZ`00000000000080XRXA00<000000:8Z
4@2R:Q401P2R:Q400`0mFJ/0XRXA0000000;0:8Z4@030000002R:Q40XRXA00D0XRXA1@00000707dN
30030000001m7P`0OAh<00L0OAh<00<0000007dN301m7P`0101m7P`7000000<0F1<800<0000005PC
201H4`P00`1H4`P20000000305PC20000000000000/000001`3om^h0100mFJ/0ooK^0?ofkP0mFJ/=
0?ofkP80?EV[2`3om^h0100mFJ/0ooK^0?ofkP0mFJ/70?ofkP0403eIZ`3om^h0ooK^03eIZ`<0ooK^
00@0?EV[0?ofkP3om^h0?EV[7`3om^h00`000000ooK^0?ofkP0l0?ofkP030000003om^h0ooK^01X0
ooK^0@3oool005l0ooK^00<000000?ofkP0000001@3om^h40=@m6A40ooK^00<0e3dI0?ofkP3om^h0
0`3om^h6000000X0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP060?ofkPH0e3dI
00<0ooK^0=@m6@3D?AT0103D?AT00`3om^h0e3dI0?ofkP080?ofkP040=@m6@00000000000;/b5080
?EV[0`2k<Q@01P0mFJ/0^c8D0;/b502k<Q@0?EV[000000<0^c8D00<0?EV[0;/b502k<Q@01@2k<Q@0
0`0mFJ/0^c8D0;/b50030;/b500303eIZ`2k<Q@0^c8D00D000001`2R:Q400`0mFJ/000000:8Z4@0:
0:8Z4@030000002R:Q40XRXA00L0XRXA00<000000:8Z4@2R:Q401P00000207dN30030000001m7P`0
OAh<00H0OAh<00<0000007dN301m7P`01`1m7P`010000000OAh<07dN301m7P`7000000@0F1<800<0
000005PC201H4`P00`1H4`P70000000403d>1@0000000000000000D0ooK^0P0mFJ/>0?ofkP0303eI
Z`3om^h0?EV[00X0ooK^00@0?EV[0?ofkP3om^h0?EV[1P3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[
00<0ooK^00@0?EV[0?ofkP3om^h0?EV[7`3om^h00`000000ooK^0?ofkP0l0?ofkP030000003om^h0
ooK^01X0ooK^0@3oool005l0ooK^00<000000?ofkP0000001@3om^h00`3D?AT0ooK^0=@m6@050=@m
6@d0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP030?ofkPH000000`3om^h00`3D
?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00P0ooK^00@0e3dI0?ofkP3om^h0ooK^1P3D?AT0
0`3om^h0e3dI0=@m6@050=@m6@<0ooK^00L0e3dI0?ofkP000000^c8D03eIZ`2k<Q@0?EV[00<0^c8D
00D0?EV[0;/b502k<Q@0^c8D03eIZ`040;/b500303eIZ`2k<Q@0^c8D00D0^c8D00<0000003eIZ`2k
<Q@00`2k<Q@00`0mFJ/0^c8D0;/b50020;/b50030000002k<Q@0^c8D00H000000P2R:Q400`0mFJ/0
XRXA0:8Z4@090:8Z4@030000002R:Q40XRXA00L0XRXA00<000000:8Z4@2R:Q401P2R:Q45000000H0
OAh<00<0000007dN301m7P`01`1m7P`00`000000OAh<07dN300607dN30030000001m7P`0000000H0
00001@1H4`P010000000F1<805PC201H4`P900000080ooK^00<0?EV[0?ofkP3om^h02`3om^h0100m
FJ/0ooK^0?ofkP0mFJ/90?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/01P3om^h01@0mFJ/0ooK^0?of
kP3om^h0?EV[0080ooK^00@0?EV[0?ofkP3om^h0?EV[7`3om^h00`000000ooK^0?ofkP0n0?ofkP03
0000003om^h0ooK^01T0ooK^0@3oool005l0ooK^00<000000?ofkP0000001@3om^h00`3D?AT0ooK^
0=@m6@050?ofkPD0e3dI1`3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00T0ooK^
1@0000070?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h01`3om^h50=@m6@<0ooK^
1@3D?AT01@000000^c8D03eIZ`2k<Q@0?EV[0080^c8D00<0?EV[0;/b502k<Q@00P2k<Q@00`000000
?EV[0;/b50020;/b500303eIZ`2k<Q@0^c8D00D0^c8D00<0000003eIZ`2k<Q@00P2k<Q@00`0mFJ/0
^c8D0;/b50030;/b50030000002k<Q@0^c8D00H0^c8D0`0000000`0mFJ/000000:8Z4@080:8Z4@03
0000002R:Q40XRXA00L0XRXA00<000000:8Z4@2R:Q40202R:Q400`000000XRXA0:8Z4@0500000080
OAh<00<0000007dN301m7P`01`1m7P`00`000000OAh<07dN300507dN30030000001m7P`0OAh<00@0
OAh<1@00000305PC20030000001H4`P0F1<800<0F1<80P0000000`1H4`P000000000000200000003
03eIZ`3D?AT0?EV[00`0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`080?ofkP0503eIZ`3om^h0ooK^
0?ofkP0mFJ/01@3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0403eIZ`3om^h0ooK^03eIZ`80ooK^00<0
?EV[0?ofkP3om^h0703om^h00`000000ooK^0?ofkP0o0?ofkP030000003om^h0ooK^01T0ooK^0@3o
ool005l0ooK^0P0000050?ofkP040=@m6@3om^h0ooK^0=@m6@X0ooK^1@3D?AT20?ofkP030=@m6@3o
m^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^00000005000000030?ofkP3D
?AT0ooK^00X0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP070=@m6@060?ofkP00
0000?EV[0000002k<Q@0?EV[0P2k<Q@00`0mFJ/0^c8D0;/b50020;/b50030000000mFJ/0^c8D0080
^c8D00<0?EV[0;/b502k<Q@0102k<Q@010000000^c8D0;/b500mFJ/20;/b500303eIZ`2k<Q@0^c8D
00<0^c8D00<000000;/b502k<Q@0202k<Q@010000000?EV[03eIZ`0mFJ/5000000<0XRXA00<00000
0:8Z4@2R:Q40202R:Q400`000000XRXA0:8Z4@070:8Z4@030000002R:Q40XRXA00D0XRXA20000004
07dN30030000001m7P`0OAh<00H0OAh<00<0000007dN301m7P`01P1m7P`00`000000OAh<00000005
000000D0F1<800<0000005PC201H4`P00`1H4`P20000000303eIZ`3D?AT0e3dI00<0e3dI1@3om^h0
0`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h00`3om^h0
0`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP0mFJ/00`3om^h0
0`0mFJ/0ooK^0?ofkP0L0?ofkP030000003om^h0ooK^03l0ooK^00<000000?ofkP3om^h06@3om^h1
0?ooo`00G`3om^h2000000D0ooK^00<0e3dI0?ofkP3om^h00`3D?AT=0?ofkPH0e3dI0`3om^h00`3D
?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00D0ooK^1P0000070?ofkP030=@m6@3om^h0ooK^
00T0ooK^00<0e3dI0?ofkP3om^h01@3om^h30=@m6@030000000mFJ/0c3LG0080000000@0?EV[0000
000mFJ/000000`2k<Q@01@000000^c8D03eIZ`2k<Q@0?EV[00L0^c8D00L000000;/b502k<Q@0^c8D
03eIZ`2k<Q@0?EV[00D0^c8D00<000000;/b502k<Q@0202k<Q@01@0mFJ/0^c8D0;/b502k<Q@0?EV[
00@0^c8D1P0000080:8Z4@030000002R:Q40XRXA00L0XRXA00<000000:8Z4@2R:Q401`2R:Q400`00
0000XRXA0:8Z4@030:8Z4@P000001P1m7P`00`000000OAh<07dN300507dN30030000001m7P`0OAh<
00<0OAh<1@00000305PC208000001@1H4`P0103D?AT0?EV[0=@m6@3D?AT20?ofkPD0e3dI00<0?EV[
0=@m6@3om^h00`3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00<0ooK^00D0?EV[
0?ofkP3om^h0ooK^03eIZ`050?ofkP0303eIZ`3om^h0?EV[0080ooK^00<0?EV[0?ofkP3om^h0703o
m^h00`000000ooK^0?ofkP100?ofkP030000003om^h0ooK^01T0ooK^0@3oool005h0ooK^00<00000
0?ofkP0000001@3om^h0103D?AT0ooK^0?ofkP3D?AT20?ofkPH0e3dI2@3om^h0103D?AT0ooK^0?of
kP3om^h70=@m6@X0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP020?ofkPH00000
00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP050?ofkP040=@m6@3om^h00000000000@0
c3LG00@0?EV[0<`g5`0mFJ/0c3LG1@0000000`0mFJ/0^c8D03eIZ`070;/b50040000002k<Q@0^c8D
0;/b5080?EV[1P2k<Q@00`000000^c8D0;/b50080;/b500303eIZ`2k<Q@0^c8D0080^c8D00<0?EV[
0;/b502k<Q@0102k<Q@00`000000^c8D0;/b500600000080XRXA00<000000:8Z4@2R:Q40202R:Q40
0`000000XRXA0:8Z4@070:8Z4@030000002R:Q40XRXA00L0XRXA00<000000:8Z4@2R:Q401@000000
0`1m7P`0000007dN300707dN30030000001m7P`0OAh<00D0OAh<00<0000007dN300000001P000005
05PC208000001P3D?AT00`0mFJ/0ooK^0?ofkP040=@m6@0303eIZ`3D?AT0ooK^00<0ooK^00<0?EV[
0?ofkP3om^h0103om^h0100mFJ/0ooK^0?ofkP0mFJ/60?ofkP80?EV[0`3om^h00`0mFJ/0ooK^0?of
kP0K0?ofkP030000003om^h0ooK^0480ooK^00<000000?ofkP3om^h0603om^h10?ooo`00GP3om^h0
0`000000ooK^000000050?ofkP040=@m6@3om^h0ooK^0=@m6@P0ooK^1P3D?AT30?ofkP030=@m6@3o
m^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h00P3om^h70=@m6@<0ooK^00<0e3dI0?ofkP3om^h01`3o
m^h00`3D?AT0ooK^0?ofkP080?ofkPH000001`3om^h00`3D?AT0ooK^0?ofkP050?ofkP040=@m6@00
00000000000000@0c3LG0P0mFJ/50<`g5`050000003D?AT0?EV[0000000mFJ/0100000030;/b5003
0000002k<Q@0^c8D0080^c8D00<0?EV[0;/b502k<Q@0102k<Q@00`000000^c8D0;/b50070;/b5003
03eIZ`000000^c8D00@0^c8D0P0mFJ/40;/b50030000002k<Q@0^c8D00H0^c8D1@0000080:8Z4@03
0000002R:Q40XRXA00L0XRXA00<000000:8Z4@2R:Q401`2R:Q400`000000XRXA0:8Z4@050:8Z4@D0
00001P1m7P`00`000000OAh<07dN300507dN30030000001m7P`0OAh<00<0OAh<1`000000100mFJ/0
F1<80000000000020?ofkP80e3dI00<0?EV[0=@m6@3D?AT01@3D?AT00`0mFJ/0e3dI0=@m6@020=@m
6@0303eIZ`3om^h0ooK^00@0ooK^00@0?EV[0?ofkP3om^h0?EV[1P3om^h203eIZ`80ooK^00<0?EV[
0?ofkP3om^h0703om^h00`000000ooK^0?ofkP120?ofkP030000003om^h0ooK^01P0ooK^0@3oool0
05h0ooK^00<000000?ofkP000000103om^h0103D?AT0ooK^0?ofkP3D?AT?0?ofkPH0e3dI0`3om^h0
0`3D?AT0ooK^0?ofkP090?ofkPH0e3dI1`3om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0
ooK^00<0ooK^1@0000020?ofkP030=@m6@3om^h0ooK^00D0ooK^00@0e3dI0000000000000000103<
=aL203eIZ`D0c3LG00@000000<`g5`3<=aL0?EV[1@3<=aL600000080^c8D0P0mFJ/50;/b50030000
002k<Q@0^c8D00L0^c8D00<0?EV[0000002k<Q@01P2k<Q@01@0mFJ/0^c8D0;/b502k<Q@0000000X0
^c8D00<000000;/b502k<Q@01P0000020:8Z4@030000002R:Q40XRXA00L0XRXA00<000000:8Z4@2R
:Q40202R:Q400`000000XRXA0:8Z4@060:8Z4@030000002R:Q40XRXA00D0000000<0OAh<0000001m
7P`01`1m7P`00`000000OAh<07dN300507dN30040000001m7P`0OAh<07dN30D000000P3om^h00`0m
FJ/0e3dI0?ofkP020?ofkP@0e3dI00H0?EV[0=@m6@3D?AT0e3dI03eIZ`3om^h50=@m6@80ooK^0P0m
FJ/70?ofkP0403eIZ`3om^h0ooK^03eIZah0ooK^00<000000?ofkP3om^h0@`3om^h00`000000ooK^
0?ofkP0H0?ofkP40oooo001N0?ofkP030000003om^h0000000@0ooK^00@0e3dI0?ofkP3om^h0e3dI
4@3om^h0103D?AT0ooK^0?ofkP3om^h60=@m6@`0ooK^00<0e3dI0?ofkP3om^h01@3D?AT20?ofkP03
0=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h0203om^h6000000<0ooK^00<0e3dI00000006
21400P0000040<`g5`80?EV[1@3<=aL010000000c3LG0<`g5`0mFJ/80<`g5`050000003<=aL0c3LG
0000000mFJ/00P0000000`0mFJ/000000;/b50020;/b50030000002k<Q@0^c8D00L0^c8D00<0?EV[
0000002k<Q@01`2k<Q@0100mFJ/0^c8D0;/b5000000:0;/b50030000002k<Q@0^c8D00H0^c8D1@00
00070:8Z4@030000002R:Q40XRXA00P0XRXA00<000000:8Z4@2R:Q401`2R:Q400`000000XRXA0:8Z
4@040:8Z4@D000001P1m7P`00`000000OAh<07dN300507dN30030000001m7P`0OAh<00D0OAh<00<0
00000=@m6@0mFJ/02@3om^h0100mFJ/0e3dI0=@m6@0mFJ/50=@m6@030?ofkP3D?AT0e3dI0080?EV[
00<0e3dI0?ofkP3om^h00`3om^h203eIZ`030?ofkP0mFJ/0?EV[01d0ooK^00<000000?ofkP3om^h0
A03om^h00`000000ooK^0?ofkP0H0?ofkP40oooo001N0?ofkP8000001@3om^h0103D?AT0ooK^0?of
kP3D?ATA0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h01P3D?AT60?ofkP030=@m
6@3om^h0ooK^00D0ooK^1@3D?AT70?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h0
0P3om^h6000000802a0V00D000000<`g5`3<=aL0c3LG03eIZ`060<`g5`030000003<=aL0c3LG0080
?EV[1`3<=aL01@000000c3LG0<`g5`3<=aL0?EV[00<0c3LG00<0?EV[000000000000100000060;/b
500303eIZ`2k<Q@0000000T0^c8D0P0mFJ/00`000000^c8D0;/b50080;/b50030000002k<Q@0^c8D
00P0^c8D00<000000;/b502k<Q@01P0000020:8Z4@030000002R:Q40XRXA00L0XRXA00<000000:8Z
4@2R:Q401`2R:Q400`000000XRXA0:8Z4@060:8Z4@030000002R:Q40XRXA00H0000000<0OAh<0000
001m7P`01P1m7P`00`000000OAh<07dN300507dN300303eIZ`3om^h0ooK^00P0ooK^00@0?EV[0?of
kP0mFJ/0ooK^203D?AT00`0mFJ/0e3dI0=@m6@050=@m6@0403eIZ`3om^h0ooK^03eIZah0ooK^00<0
00000?ofkP3om^h0A03om^h00`000000ooK^0?ofkP0H0?ofkP40oooo001N0?ofkP8000001@3om^h0
103D?AT0ooK^0?ofkP3D?ATA0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h01P3o
m^h60=@m6@T0ooK^00@0e3dI0?ofkP3om^h0ooK^1@3D?AT20?ofkP030=@m6@3om^h0ooK^00X0ooK^
00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT00000000000060000000303eIZ`3<=aL0c3LG00@0c3LG
00D000000<`g5`0mFJ/0c3LG03eIZ`070<`g5`040000003<=aL0c3LG03eIZ`D0c3LG00@0?EV[0<`g
5`3<=aL000000P3<=aL60000000303eIZ`2k<Q@0000000/0^c8D00<0?EV[0;/b502k<Q@0202k<Q@0
0`000000^c8D0;/b50080;/b50030000002k<Q@0^c8D00H0^c8D1@0000070:8Z4@030000002R:Q40
XRXA00L0XRXA00<000000:8Z4@2R:Q401`2R:Q400`000000XRXA0:8Z4@050:8Z4@D000001@1m7P`0
0`000000OAh<07dN300507dN30<0e3dI203om^h203eIZ`030=@m6@3om^h0ooK^00<0ooK^0P3D?AT2
03eIZ`H0e3dI0P0mFJ/00`3D?AT0?EV[03eIZ`030=@m6AX0ooK^00<000000?ofkP3om^h0AP3om^h0
0`000000ooK^0?ofkP0G0?ofkP40oooo001M0?ofkP030000003om^h0000000D0ooK^00@0e3dI0?of
kP3om^h0e3dI4@3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00/0ooK^1`3D?AT3
0?ofkP030=@m6@3om^h0ooK^00H0ooK^1P3D?AT90?ofkP030=@m6@3om^h0ooK^00D0ooK^0`000002
00/@9P040000003<=aL0c3LG0<`g5`D000000P3<=aL00`000000c3LG03eIZ`020<`g5`0303eIZ`3<
=aL0c3LG00@0c3LG00@000000<`g5`3<=aL0?EV[1P3<=aL00`0mFJ/0c3LG000000070<`g5`0303eI
Z`000000000000<000002@2k<Q@00`000000?EV[0;/b50080;/b50030000002k<Q@0^c8D00P0^c8D
00<000000;/b502k<Q@0202k<Q@00`000000^c8D0;/b500600000080XRXA00<000000:8Z4@2R:Q40
1`2R:Q400`000000XRXA0:8Z4@060:8Z4@030000002R:Q40XRXA00L0XRXA00<000000:8Z4@2R:Q40
1@0000000`1m7P`0000007dN300307dN300403eIZ`1m7P`0OAh<000000H0e3dI0`3om^h0100mFJ/0
ooK^0?ofkP3D?AT50?ofkP030=@m6@0mFJ/0?EV[0080ooK^103D?AT403eIZ`80e3dI0P3om^h60=@m
6A@0ooK^00<000000?ofkP3om^h0AP3om^h00`000000ooK^0?ofkP0G0?ofkP40oooo001M0?ofkP03
0000003om^h0000000@0ooK^00@0e3dI0?ofkP3om^h0e3dI4P3om^h00`3D?AT0ooK^0?ofkP030?of
kP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h0103om^h60=@m6@P0ooK^00@0e3dI0?of
kP3om^h0ooK^1P3D?AT30?ofkP030=@m6@3om^h0ooK^00@0ooK^00@0e3dI00000000000000000P0;
42H01P000000c3LG0<`g5`0mFJ/0c3LG03eIZ`<0c3LG1P0000000`3<=aL0?EV[0<`g5`050<`g5`04
0000003<=aL0c3LG03eIZ`L0c3LG00<0?EV[0000003<=aL01P3<=aL0100mFJ/0c3LG0<`g5`000002
0<`g5`H000000`2k<Q@010000000^c8D03eIZ`0mFJ/70;/b50030000002k<Q@0^c8D00P0^c8D00<0
00000;/b502k<Q@0202k<Q@00`000000^c8D0;/b50060;/b50D000001`2R:Q400`000000XRXA0:8Z
4@060:8Z4@030000002R:Q40XRXA00P0XRXA00<000000:8Z4@2R:Q40102R:Q45000000D0OAh<00<0
00000?ofkP3om^h01@3D?AT203eIZ`030=@m6@3om^h0e3dI00<0ooK^0P3D?AT00`0mFJ/0ooK^03eI
Z`050?ofkP@0?EV[203D?AT30?ofkPH0e3dI3@3om^h00`000000ooK^0?ofkP170?ofkP030000003o
m^h0ooK^01L0ooK^0@3oool005d0ooK^00<000000?ofkP000000103om^h0103D?AT0ooK^0?ofkP3D
?ATB0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?of
kP070?ofkP030=@m6@3om^h0ooK^00H0e3dI0P3om^h00`3D?AT0ooK^0?ofkP070?ofkPL0e3dI0`3o
m^h0103D?AT0000000000000000200/@9P060000003<=aL0c3LG03eIZ`3<=aL0?EV[1@3<=aL01000
0000?EV[0<`g5`3<=aL600000080c3LG00<000000<`g5`0mFJ/0203<=aL00`0mFJ/000000<`g5`05
0<`g5`0503eIZ`3<=aL0c3LG0<`g5`000000203<=aL6000000030;/b500mFJ/0^c8D00D0^c8D00<0
00000;/b502k<Q@0202k<Q@00`000000^c8D0;/b50080;/b50030000002k<Q@0^c8D00P0^c8D00<0
00000;/b502k<Q@01P0000020:8Z4@030000002R:Q40XRXA00H0XRXA00<000000:8Z4@2R:Q401`2R
:Q400`000000XRXA0:8Z4@060:8Z4@030000002R:Q40XRXA00D0000000<0OAh<0000003om^h0103o
m^h00`3D?AT0?EV[03eIZ`070=@m6@040?ofkP0mFJ/0ooK^03eIZ`@0ooK^00<0?EV[0?ofkP0mFJ/0
0P0mFJ/20?ofkP040=@m6@3om^h0ooK^0?ofkPL0e3dI0P3om^h70=@m6@L0ooK^00<000000?ofkP3o
m^h0B03om^h00`000000ooK^0?ofkP0G0?ofkP40oooo001M0?ofkP030000003om^h0000000@0ooK^
103D?ATA0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^
0?ofkP080?ofkP030=@m6@3om^h0ooK^00H0ooK^1P3D?AT90?ofkP040=@m6@3om^h0ooK^0?ofkP@0
e3dI0`00000200/@9P80000000@0?EV[0<`g5`3<=aL0?EV[1@3<=aL00`000000?EV[0<`g5`030<`g
5`0403eIZ`3<=aL0c3LG0<`g5`H00000203<=aL00`0mFJ/0c3LG0<`g5`040<`g5`0503eIZ`3<=aL0
c3LG0<`g5`0000002`3<=aL010000000c3LG0<`g5`00000303eIZ`8000000P2k<Q@00`000000^c8D
0;/b50080;/b50030000002k<Q@0^c8D00P0^c8D00<000000;/b502k<Q@0202k<Q@00`000000^c8D
0;/b50060;/b50D000001P2R:Q400`000000XRXA0:8Z4@070:8Z4@030000002R:Q40XRXA00L0XRXA
00<000000:8Z4@2R:Q40102R:Q43000000@0ooK^00D0?EV[0?ofkP3om^h0?EV[0?ofkP050=@m6@04
03eIZ`3D?AT0e3dI03eIZ`<0e3dI00<0ooK^03eIZ`3om^h00P0mFJ/30?ofkP030=@m6@3om^h0ooK^
0080ooK^0P3D?AT30?ofkPL0e3dI0`3om^h50=@m6@80ooK^00<000000?ofkP3om^h0B@3om^h00`00
0000ooK^0?ofkP0F0?ofkP40oooo001M0?ofkP8000001@3om^h00`3D?AT0ooK^0?ofkP080=@m6@X0
ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00P0
ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP020?ofkPH0e3dI0`3om^h00`3D?AT0
ooK^0?ofkP040?ofkP@000000P0;42H00`000000fC`I03eIZ`020000000403eIZ`00000000000000
0080c3LG00<0?EV[0<`g5`3<=aL0103<=aL00`0mFJ/0c3LG0<`g5`020<`g5`040000003<=aL0?EV[
0<`g5`D000000`3<=aL00`000000?EV[0<`g5`040<`g5`0503eIZ`3<=aL0c3LG0<`g5`0000002`3<
=aL010000000c3LG0<`g5`0mFJ/30<`g5`80?EV[1@0000080;/b50030000002k<Q@0^c8D00T0^c8D
00<000000;/b502k<Q@01`2k<Q@00`000000^c8D0;/b50080;/b50030000002k<Q@0^c8D00D00000
0P2R:Q400`000000XRXA0:8Z4@070:8Z4@030000002R:Q40XRXA00H0XRXA00<000000:8Z4@2R:Q40
1`2R:Q401@000000ooK^0?ofkP3om^h0?EV[0080ooK^00<0?EV[0?ofkP3om^h00P3D?AT20?ofkP04
03eIZ`3D?AT0e3dI03eIZ`<0e3dI00@0?EV[0=@m6@0mFJ/0?EV[0`3D?AT20?ofkP040=@m6@3om^h0
ooK^0=@m6@X0ooK^1`3D?AT30?ofkPD0e3dIB@3om^h00`000000ooK^0?ofkP0F0?ofkP40oooo001M
0?ofkP8000001@3om^h0103D?AT0ooK^0?ofkP3D?AT70?ofkPL0e3dI0`3om^h00`3D?AT0ooK^0?of
kP040?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?of
kP070?ofkP030=@m6@3om^h0ooK^00P0ooK^1`3D?AT30?ofkP@0000000D02a0V000000000000fC`I
03eIZ`030=Tl6@0303eIZ`3I?1T0fC`I0080000000<0?EV[0000000000001@3<=aL01P0mFJ/0c3LG
0<`g5`3<=aL0000003eIZ`L0c3LG1P0000030<`g5`0303eIZ`3<=aL0c3LG0080c3LG00<000000<`g
5`3<=aL02@3<=aL010000000c3LG0<`g5`0mFJ/50<`g5`80?EV[00<000000<`g5`3<=aL01P000002
0;/b50030000002k<Q@0^c8D00T0^c8D00<000000;/b502k<Q@01`2k<Q@00`000000^c8D0;/b5008
0;/b50030000002k<Q@0^c8D00D0^c8D1@0000070:8Z4@030000002R:Q40XRXA00L0XRXA00<00000
0:8Z4@2R:Q401P2R:Q4010000000ooK^0?ofkP0mFJ/30?ofkP0303eIZ`3om^h0ooK^0080e3dI00<0
ooK^03eIZ`3om^h00P3om^h0100mFJ/0ooK^0?ofkP3om^h403eIZ`80e3dI00<0ooK^0=@m6@3D?AT0
103D?AT>0?ofkPT0e3dI0P3om^h40=@m6DD0ooK^00<000000?ofkP3om^h05P3om^h10?ooo`00G03o
m^h00`000000ooK^000000050?ofkP040=@m6@3om^h0ooK^0=@m6@h0ooK^1`3D?AT30?ofkP030=@m
6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m
6@3om^h0ooK^00/0ooK^00@0e3dI0?ofkP3om^h0ooK^1P3D?AT01@0000002a0V000000000000?EV[
00@0fC`I00<0?EV[0=Tl6@3I?1T00P3I?1T00`0mFJ/0fC`I0=Tl6@050000000603eIZ`3<=aL0c3LG
0<`g5`000000?EV[2P3<=aL00`000000c3LG0<`g5`0600000080c3LG00<000000<`g5`3<=aL02@3<
=aL00`000000c3LG03eIZ`080<`g5`80?EV[1`3<=aL5000000T0^c8D00<000000;/b502k<Q@0202k
<Q@00`000000^c8D0;/b50070;/b50030000002k<Q@0^c8D00L0^c8D00<000000;/b502k<Q@01P00
00020:8Z4@030000002R:Q40XRXA00H0XRXA00<000000:8Z4@2R:Q401`2R:Q400`000000ooK^03eI
Z`030?ofkP0703eIZ`3om^h0e3dI0?ofkP3D?AT0ooK^03eIZ`030?ofkP0303eIZ`3om^h0ooK^00@0
?EV[0`3om^h60=@m6@030?ofkP3D?AT0e3dI00<0e3dI2P3om^h0103D?AT0ooK^0?ofkP3om^h<0=@m
6D<0ooK^00<000000?ofkP3om^h05P3om^h10?ooo`00G03om^h00`000000ooK^000000040?ofkP04
0=@m6@3om^h0ooK^0=@m6A80ooK^00@0e3dI0?ofkP3om^h0ooK^1P3D?AT:0?ofkP030=@m6@3om^h0
ooK^00P0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0
ooK^00<0ooK^0`0000000`0;42H0e3dI0=@m6@020=@m6@0303eIZ`3I?1T0fC`I0080fC`I00H0?EV[
0=Tl6@3I?1T0fC`I03eIZ`0000080=Tl6@0403eIZ`000000000003eIZ`8000002@3<=aL010000000
c3LG0<`g5`3<=aL203eIZ`<0c3LG1P0000080<`g5`030000003<=aL0?EV[00P0c3LG00@000000<`g
5`0mFJ/0?EV[1`3<=aL00`000000e3dI0<`g5`06000000<0^c8D00<000000;/b502k<Q@0202k<Q@0
0`000000^c8D0;/b50070;/b50030000002k<Q@0^c8D00L0^c8D00<000000;/b502k<Q@01P2k<Q@5
000000L0XRXA00<000000:8Z4@2R:Q401P2R:Q400`000000?EV[0?ofkP040?ofkP0503eIZ`3om^h0
ooK^0?ofkP0mFJ/0103om^h01@0mFJ/0ooK^03eIZ`0mFJ/0ooK^0080?EV[1@3om^h00`3D?AT0ooK^
0?ofkP060=@m6@030?ofkP3D?AT0e3dI00<0e3dI1@3om^h0103D?AT0ooK^0?ofkP3om^h20=@m6@P0
ooK^103D?AU10?ofkP030000003om^h0ooK^01H0ooK^0@3oool005`0ooK^00<000000?ofkP000000
103om^h0103D?AT0ooK^0?ofkP3D?ATB0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3o
m^h01`3D?AT30?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0
ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00<0ooK^00@0000000H84@0000002a0V0P000002010H
>`030000003I?1T0fC`I00<0fC`I00D0?EV[0=Tl6@3I?1T0?EV[000000080=Tl6@0403eIZ`3I?1T0
fC`I03eIZ`80fC`I1P0000030<`g5`030000003<=aL0c3LG0080c3LG00<0?EV[0<`g5`3<=aL00`3<
=aL010000000c3LG0<`g5`3<=aL5000000<0c3LG00<000000<`g5`0mFJ/0203<=aL010000000c3LG
0<`g5`3<=aL203eIZ`D0c3LG00<000000<`g5`3<=aL01P3<=aL6000000P0^c8D00<000000;/b502k
<Q@0202k<Q@00`000000^c8D0;/b50070;/b50030000002k<Q@0^c8D00L0^c8D00<000000;/b502k
<Q@01P0000000`2R:Q4000000:8Z4@070:8Z4@0403eIZ`3D?AT0e3dI0=@m6@80ooK^00<0e3dI03eI
Z`3om^h00P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP<0?EV[00<0ooK^03eIZ`0mFJ/01@3om^h01@3D
?AT0ooK^0?ofkP3om^h0e3dI00D0ooK^103D?AT20?ofkPD0e3dI00@0ooK^0=@m6@3om^h0e3dI3P3o
m^h00`3D?AT0ooK^0?ofkP0o0?ofkP030000003om^h0ooK^01D0ooK^0@3oool005`0ooK^00<00000
0?ofkP000000103om^h00`3D?AT0ooK^0?ofkP040=@m6@l0ooK^00<0e3dI0?ofkP3om^h00`3om^h0
0`3D?AT0ooK^0?ofkP080?ofkPH0e3dI203om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0
ooK^00/0ooK^00<0e3dI0?ofkP3om^h00`3om^h30000000300/@9P00000041Pk008041Pk00<00000
0=Tl6@3I?1T00`3I?1T00`0mFJ/0fC`I03eIZ`020=Tl6@030000003I?1T0fC`I00H0fC`I00<0?EV[
0=Tl6@0mFJ/0203I?1T600000080c3LG0`0mFJ/30<`g5`030000003<=aL0c3LG00H0c3LG1P000008
0<`g5`030000003<=aL0c3LG00<0c3LG0P0mFJ/30<`g5`030000003<=aL0c3LG00T0c3LG00<00000
0<`g5`3<=aL01P0000020;/b50030000002k<Q@0^c8D00P0^c8D00<000000;/b502k<Q@01`2k<Q@0
0`000000^c8D0;/b50070;/b50030000002k<Q@0^c8D00H0^c8D1@0000070:8Z4@030000003om^h0
e3dI0080e3dI00H0?EV[0=@m6@3D?AT0?EV[0?ofkP3D?AT30?ofkP80?EV[0P3om^h00`0mFJ/0ooK^
0?ofkP030?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h01`3om^h50=@m6@80ooK^
1@3D?AT>0?ofkP030=@m6@3om^h0ooK^03h0ooK^00<000000?ofkP3om^h05@3om^h10?ooo`00G03o
m^h2000000D0ooK^00@0e3dI0?ofkP3om^h0e3dI0`3om^h60=@m6@P0ooK^00<0e3dI0?ofkP3om^h0
103om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00D0e3dI0`3om^h00`3D?AT0ooK^
0?ofkP070?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h00`3om^h01P3D?AT00000
0000000000002a0V000000<041Pk00<000000=Tl6@3I?1T00`3I?1T00`0mFJ/0fC`I03eIZ`020=Tl
6@030000003I?1T0fC`I00H0fC`I0P0mFJ/00`000000fC`I0=Tl6@090=Tl6@050000003I?1T0fC`I
0000000mFJ/00`000000100mFJ/0c3LG0<`g5`00000;0<`g5`030000000mFJ/0c3LG00H000000P3<
=aL00`000000c3LG0<`g5`050<`g5`80?EV[00<0c3LG0000003<=aL02P3<=aL00`000000c3LG0<`g
5`060<`g5`D00000202k<Q@00`000000^c8D0;/b50070;/b50030000002k<Q@0^c8D00P0^c8D00<0
00000;/b502k<Q@01`2k<Q@00`000000^c8D0;/b5006000000030:8Z4@000000e3dI00<0e3dI00@0
?EV[0?ofkP3om^h0?EV[103D?AT303eIZ`030?ofkP0mFJ/0?EV[00D0ooK^00<0e3dI0?ofkP3om^h0
0`3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP<0e3dI00@0ooK^0=@m6@3om^h0ooK^1@3D?AT90?ofkP03
0=@m6@3om^h0ooK^03h0ooK^00<000000?ofkP3om^h05@3om^h10?ooo`00G03om^h2000000D0ooK^
00@0e3dI0?ofkP3om^h0e3dI2@3om^h60=@m6@80ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0
ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00D0ooK^1P3D?AT70?ofkP030=@m6@3om^h0ooK^00/0
ooK^00<0e3dI0?ofkP3om^h00`3om^h20000000400/@9P0000002a0V000000<041Pk00<000000=Tl
6@3I?1T00`3I?1T00`0mFJ/0fC`I03eIZ`020=Tl6@030000003I?1T0fC`I00L0fC`I00<0?EV[0000
003I?1T02P3I?1T01@000000fC`I0=Tl6@3I?1T0?EV[00@0fC`I00<0?EV[0000000000000P000009
0<`g5`0303eIZ`3<=aL0c3LG00H0c3LG1P0000060<`g5`<0?EV[2P3<=aL00`000000c3LG0<`g5`08
0<`g5`030000003<=aL0c3LG00H000000P2k<Q@00`000000^c8D0;/b50070;/b50030000002k<Q@0
^c8D00P0^c8D00<000000;/b502k<Q@01`2k<Q@00`000000^c8D0;/b50060;/b50<0000000@0e3dI
0?ofkP3om^h0ooK^0P0mFJ/40=@m6@0403eIZ`3D?AT0?EV[0=@m6@80?EV[1@3om^h00`3D?AT0ooK^
0?ofkP040?ofkP030=@m6@3om^h0ooK^00`0ooK^00D0e3dI0?ofkP000000ooK^0=@m6@060?ofkPD0
e3dI1@3om^h00`3D?AT0ooK^0?ofkP0m0?ofkP030000003om^h0ooK^01D0ooK^0@3oool005/0ooK^
00<000000?ofkP0000001@3om^h00`3D?AT0ooK^0=@m6@0@0?ofkPH0e3dI0`3om^h00`3D?AT0ooK^
0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h01@3D?AT20?ofkP030=@m
6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h00`3om^h20000000400/@9P0000000000000000<0
41Pk00<000000=Tl6@3I?1T0103I?1T01@0mFJ/0fC`I0=Tl6@3I?1T0000000T0fC`I0P0mFJ/;0=Tl
6@040000003I?1T0fC`I03eIZ`H0fC`I0P0mFJ/20=Tl6@H000000`3<=aL00`0mFJ/0c3LG0<`g5`08
0<`g5`040000003<=aL0c3LG0<`g5`D000000P3<=aL00`0mFJ/0c3LG03eIZ`0203eIZ`L0c3LG00<0
00000<`g5`3<=aL0203<=aL00`000000c3LG0<`g5`060<`g5`D00000202k<Q@00`000000^c8D0;/b
50070;/b50030000002k<Q@0^c8D00P0^c8D00<000000;/b502k<Q@01`2k<Q@00`000000e3dI0?of
kP020?ofkP80?EV[0P3om^h203eIZ`040=@m6@0mFJ/0?EV[0=@m6@80?EV[1P3D?AT60?ofkP030=@m
6@3om^h0ooK^00/0ooK^00H0e3dI0?ofkP3om^h000000?ofkP3D?AT;0?ofkPD0e3dI00<0ooK^0=@m
6@3om^h0?P3om^h00`000000ooK^0?ofkP0D0?ofkP40oooo001K0?ofkP030000003om^h0000000D0
ooK^00<0e3dI0?ofkP3D?AT04P3om^h0103D?AT0ooK^0?ofkP3om^h60=@m6@X0ooK^00<0e3dI0?of
kP3om^h02@3om^h00`3D?AT0ooK^0?ofkP050?ofkPH0e3dI2P3om^h00`3D?AT0ooK^0?ofkP030?of
kP030000000;42H02a0V00<00000100@63/00`000000fC`I0=Tl6@030=Tl6@0503eIZ`3I?1T0fC`I
0=Tl6@000000203I?1T0100mFJ/0fC`I0000000mFJ/:0=Tl6@040000003I?1T0fC`I03eIZ`L0fC`I
00<0000003eIZ`3I?1T01P3I?1T20000000403eIZ`0000000000000000P0c3LG00<000000<`g5`3<
=aL01P3<=aL6000000030<`g5`0mFJ/0?EV[00D0c3LG00<000000<`g5`3<=aL0203<=aL00`000000
c3LG0<`g5`080<`g5`030000003<=aL0c3LG00H000000P2k<Q@00`000000^c8D0;/b50070;/b5003
0000002k<Q@0^c8D00P0^c8D00<000000;/b502k<Q@01`2k<Q@00`000000ooK^0?ofkP020?ofkP03
03eIZ`3om^h0?EV[0080?EV[0P3om^h01@0mFJ/0ooK^03eIZ`0mFJ/0ooK^00/0e3dI0P3om^h00`3D
?AT0ooK^0?ofkP090?ofkP040=@m6@3om^h0ooK^000000<0ooK^00<0e3dI0?ofkP3om^h03@3om^h3
0=@m6Ch0ooK^00<000000?ofkP3om^h0503om^h10?ooo`00F`3om^h00`000000ooK^000000040?of
kP040=@m6@3om^h0ooK^0=@m6A80ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP05
0=@m6@D0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP080?ofkP040=@m6@3om^h0
ooK^0?ofkPH0e3dI103om^h00`3D?AT0ooK^0?ofkP020?ofkP8000000P0;42H200000003010H>`00
000041Pk008041Pk00<000000=Tl6@3I?1T00`3I?1T203eIZ`80fC`I00<000000=Tl6@3I?1T01P3I
?1T01@0mFJ/0fC`I0=Tl6@000000?EV[00T0fC`I00@000000=Tl6@3I?1T0?EV[1`3I?1T00`000000
fC`I03eIZ`080=Tl6@0403eIZ`000000fC`I0=Tl6@H000000P3<=aL00`000000c3LG0<`g5`070<`g
5`0303eIZ`000000c3LG0080c3LG1P0000000`3<=aL000000<`g5`0:0<`g5`030000003<=aL0c3LG
00P0c3LG00<000000<`g5`3<=aL01P3<=aL5000000P0^c8D00<000000;/b502k<Q@01`2k<Q@00`00
0000^c8D0;/b50080;/b50030000003om^h0ooK^00<0?EV[0P3om^h01P0mFJ/0e3dI03eIZ`0mFJ/0
ooK^03eIZ`@0ooK^00<0e3dI0?ofkP3om^h00P3om^h90=@m6@P0ooK^00D0e3dI0?ofkP3om^h0ooK^
000000030?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h0?03om^h00`000000ooK^
0?ofkP0D0?ofkP40oooo001K0?ofkP030000003om^h0000000@0ooK^00@0e3dI0?ofkP3om^h0e3dI
4P3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00D0ooK^103D?AT00`3om^h0e3dI
0?ofkP090?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h01`3om^h60=@m6@<0ooK^
0P00000200/@9P80000000<041Pk0000000@63/00P0@63/300000080fC`I00<0?EV[0=Tl6@0mFJ/0
0`3I?1T00`000000fC`I0=Tl6@050=Tl6@0603eIZ`3I?1T0fC`I0000003I?1T0?EV[203I?1T00`00
0000fC`I03eIZ`080=Tl6@030000003I?1T0fC`I0080?EV[1P3I?1T00`0mFJ/000000=Tl6@070=Tl
6@D000001P3<=aL00`0mFJ/0c3LG000000090<`g5`H000001`3<=aL00`000000c3LG0<`g5`080<`g
5`030000003<=aL0c3LG00P0c3LG00<000000=@m6@3<=aL01P0000020;/b50030000002k<Q@0^c8D
00L0^c8D00<000000;/b502k<Q@0202k<Q@00`000000?EV[03eIZ`0203eIZ`80ooK^00<0?EV[0?of
kP3D?AT0100mFJ/40?ofkP030=@m6@3om^h0ooK^00P0ooK^203D?AT20?ofkP050=@m6@3om^h0ooK^
0?ofkP0000001@3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^03/0ooK^00<00000
0?ofkP3om^h0503om^h10?ooo`00F`3om^h2000000D0ooK^00@0e3dI0?ofkP3om^h0e3dI4P3om^h0
0`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00X0ooK^1@3D?AT70?ofkP030=@m6@3om^h0
ooK^00L0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0=@m6@020=@m6@8000000P0;42H0
1000000041Pk010H>`000003010H>`030000003S?aX0hclJ0080000000@0?EV[000000000000?EV[
0P3I?1T00`000000fC`I0=Tl6@040=Tl6@0503eIZ`3I?1T0fC`I0=Tl6@0000000P3I?1T00`0mFJ/0
fC`I0=Tl6@050=Tl6@030000003I?1T0?EV[00P0fC`I00<000000=Tl6@3I?1T00P3I?1T00`0mFJ/0
fC`I0=Tl6@020=Tl6@0303eIZ`3I?1T0000000X0fC`I00<000000=Tl6@3I?1T01P0000000`0mFJ/0
c3LG0000000:0<`g5`050000003<=aL0?EV[03eIZ`3<=aL01@0000020<`g5`030000003<=aL0c3LG
00P0c3LG00<000000<`g5`3<=aL0203<=aL00`000000c3LG0<`g5`060<`g5`D00000202k<Q@00`00
0000^c8D0;/b50060;/b5080?EV[00H0ooK^03eIZ`3om^h0?EV[0?ofkP0mFJ/20?ofkP80?EV[00<0
ooK^03eIZ`3om^h00`3om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^00<0ooK^203D
?AT60?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h0>`3om^h00`000000ooK^0?of
kP0D0?ofkP40oooo001K0?ofkP8000001@3om^h40=@m6A40ooK^00<0e3dI0?ofkP3om^h0103om^h0
0`3D?AT0ooK^0?ofkP0;0?ofkP040=@m6@3om^h0ooK^0?ofkPD0e3dI0P3om^h00`3D?AT0ooK^0?of
kP070?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h00P3om^h2000000802a0V00@0
0000010H>`0@63/000000P0@63/2000000@0hclJ00D0?EV[0><o6P3S?aX0hclJ03eIZ`04000000@0
fC`I00D0?EV[0=Tl6@3I?1T0fC`I000000030=Tl6@0303eIZ`3I?1T0fC`I00@0fC`I00<000000=Tl
6@0mFJ/0203I?1T00`000000fC`I0=Tl6@030=Tl6@0703eIZ`3I?1T0fC`I0=Tl6@0mFJ/0fC`I0000
000:0=Tl6@030000003I?1T0fC`I00D0fC`I00<0?EV[0000000000000`0000080<`g5`040000003<
=aL0c3LG0<`g5`<0?EV[0`3<=aL6000000L0c3LG00<000000<`g5`3<=aL0203<=aL00`000000c3LG
0<`g5`080<`g5`030000003<=aL0c3LG00H000000P2k<Q@00`000000^c8D0;/b50040;/b5080?EV[
00/0^c8D0000003om^h0?EV[0?ofkP0mFJ/0ooK^03eIZ`3om^h0?EV[0=@m6@0303eIZ`@0ooK^00<0
e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^0080ooK^00<0
00000=@m6@3D?AT00`3D?AT20?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h0>`3o
m^h00`000000ooK^0?ofkP0C0?ofkP40oooo001J0?ofkP030000003om^h0000000D0ooK^00@0e3dI
0?ofkP3D?AT0ooK^1`3D?AT:0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h02`3o
m^h00`3D?AT0ooK^0?ofkP060?ofkPD0e3dI1`3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3o
m^h0ooK^0080ooK^0`00000200/@9P040000000@63/041Pk0000008041Pk00<0000001DPCP000000
0P3S?aX00`0mFJ/0hclJ0><o6P020><o6P0303eIZ`3S?aX000000080hclJ100000001@0mFJ/00000
0=Tl6@3I?1T0000000<0fC`I00<0?EV[0=Tl6@3I?1T0103I?1T00`000000?EV[0=Tl6@090=Tl6@03
0000003I?1T0fC`I00<0fC`I0`0mFJ/20=Tl6@030000003I?1T0fC`I00P0fC`I00<000000=Tl6@3I
?1T01@3I?1T0100mFJ/0fC`I0=Tl6@0000020=Tl6@H000000P3<=aL00`000000c3LG0<`g5`040<`g
5`@0?EV[00<0c3LG0000003<=aL00P3<=aL6000000030<`g5`000000c3LG00T0c3LG00<000000<`g
5`3<=aL0203<=aL00`000000c3LG0<`g5`060<`g5`D00000100mFJ/40;/b500303eIZ`3om^h0ooK^
0080?EV[0P3om^h0100mFJ/0e3dI03eIZ`0mFJ/40?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI
0?ofkP3om^h0103om^h01@3D?AT0ooK^0?ofkP3om^h0000000H0ooK^1P3D?AT>0?ofkP030=@m6@3o
m^h0ooK^03/0ooK^00<000000?ofkP3om^h04`3om^h10?ooo`00FP3om^h00`000000ooK^00000005
0?ofkP030=@m6@3om^h0e3dI00P0ooK^1`3D?AT30?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI
0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00H0e3dI00<0ooK^
0=@m6@3om^h0303om^h00`3D?AT0ooK^0?ofkP020?ofkP<000000P0;42H01P00000041Pk010H>`00
000041Pk000000805B1>00@000000><o6P3S?aX0?EV[1@3S?aX00`0mFJ/000000><o6P040><o6P03
03eIZ`3S?aX0hclJ00D000000P3I?1T00`0mFJ/0fC`I0=Tl6@030=Tl6@030000000mFJ/0fC`I00T0
fC`I00<000000=Tl6@3I?1T01@3I?1T0100mFJ/0fC`I0=Tl6@00000:0=Tl6@030000003I?1T0fC`I
00@0fC`I00D0?EV[0=Tl6@3I?1T0fC`I000000080=Tl6@D00000103<=aL0100mFJ/0c3LG0<`g5`3<
=aL603eIZ`D0c3LG1P0000060<`g5`030000003<=aL0c3LG00P0c3LG00<000000<`g5`3<=aL01P3<
=aL503eIZ`030000000mFJ/0000000<000000P2k<Q@00`0mFJ/0ooK^0?ofkP0203eIZ`030?ofkP0m
FJ/0ooK^0080?EV[1@3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00<0ooK^00D0
e3dI0?ofkP3om^h0ooK^000000090?ofkP040=@m6@3om^h0ooK^0?ofkPH0e3dI2@3om^h00`3D?AT0
ooK^0?ofkP0j0?ofkP030000003om^h0ooK^01<0ooK^0@3oool005X0ooK^00<000000?ofkP000000
1@3om^h00`3D?AT0ooK^0=@m6@0?0?ofkPH0e3dI103om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m
6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h01P3om^h60=@m6@T0ooK^00<0e3dI0?ofkP3om^h0
0P3om^h00`0000002a0V00/@9P03000000<041Pk0P00000201DPCP030000003S?aX0?EV[00L0hclJ
00<0?EV[0000003S?aX00`3S?aX00`0mFJ/0hclJ0><o6P020><o6P030000003S?aX0hclJ00<00000
00<0?EV[0000000000000P3I?1T00`0mFJ/0fC`I0=Tl6@090=Tl6@030000003I?1T0fC`I00D0fC`I
0`0mFJ/00`000000fC`I0=Tl6@080=Tl6@030000003I?1T0fC`I00@0fC`I00D0?EV[0=Tl6@3I?1T0
fC`I0000000:0=Tl6@030000003I?1T0fC`I00@0000000<0?EV[0000003<=aL00P3<=aL00`000000
c3LG0<`g5`020<`g5`H0?EV[00<000000<`g5`3<=aL00P3<=aL7000000X0c3LG00<000000<`g5`3<
=aL01P0mFJ/20<`g5`050000003<=aL0c3LG0<`g5`0mFJ/0103<=aL010000000?EV[0000003D?AT2
03eIZ`80ooK^00@0?EV[0?ofkP0mFJ/0?EV[103om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3o
m^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h00P3om^h00`000000ooK^0?ofkP070?ofkP030=@m6@3o
m^h0ooK^00L0ooK^1`3D?AT20?ofkP030=@m6@3om^h0ooK^03X0ooK^00<000000?ofkP3om^h04`3o
m^h10?ooo`00FP3om^h00`000000ooK^000000040?ofkP040=@m6@3om^h0ooK^0=@m6A80ooK^00<0
e3dI0?ofkP3om^h01@3D?AT<0?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h01`3o
m^h00`3D?AT0ooK^0?ofkP030?ofkPH0e3dI0`3om^h0103D?AT0ooK^0?ofkP3om^h2000000802a0V
0P000000100@63/00000010H>`0@63/2000000805B1>00<000000><o6P0mFJ/0203S?aX00`0mFJ/0
hclJ0><o6P020><o6P0303eIZ`3S?aX0hclJ0080hclJ00<000000><o6P3S?aX0103S?aX01@0mFJ/0
hclJ000000000000?EV[008000002@3I?1T00`000000fC`I0=Tl6@040=Tl6@0403eIZ`3I?1T0fC`I
0=Tl6@80?EV[2@3I?1T00`000000fC`I0=Tl6@030=Tl6@0303eIZ`3I?1T0fC`I0080fC`I00<00000
0=Tl6@3I?1T0203I?1T00`000000fC`I0=Tl6@030=Tl6@0303eIZ`3I?1T0fC`I00H00000203<=aL;
03eIZ`D000002@0mFJ/80<`g5`040000003<=aL0c3LG03eIZ`L0c3LG00<000000?ofkP0mFJ/00P3D
?AT403eIZ`030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h03@3om^h01@3D?AT0ooK^0?of
kP3om^h0e3dI00<0ooK^00<000000?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP@0e3dI
?03om^h00`000000ooK^0?ofkP0B0?ofkP40oooo001J0?ofkP8000001@3om^h0103D?AT0ooK^0?of
kP3D?ATB0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3D?AT0103D?AT70?ofkP030=@m
6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP090?ofkPP0e3dI
00<0000003eIZ`0;42H00P0000001@0@63/00000010H>`0@63/0000000<05B1>00<000000><o6P0m
FJ/0203S?aX01@0mFJ/0hclJ0><o6P3S?aX0?EV[00D0hclJ00<000000><o6P3S?aX01@3S?aX0100m
FJ/0hclJ0><o6P0mFJ/20><o6PH000000`3I?1T00`000000fC`I0=Tl6@040=Tl6@0603eIZ`3I?1T0
fC`I0=Tl6@000000fC`I0P0mFJ/70=Tl6@030000003I?1T0fC`I00<0fC`I00<0?EV[0=Tl6@3I?1T0
0P3I?1T00`000000fC`I0=Tl6@080=Tl6@030000003I?1T0fC`I00<0fC`I00<0?EV[0=Tl6@3I?1T0
0`3I?1T00`000000fC`I0=Tl6@0600000080c3LG00<000000<`g5`0mFJ/0203<=aL00`000000c3LG
0<`g5`020<`g5`L000002P3<=aL010000000c3LG0<`g5`0mFJ/70<`g5`040000003om^h0?EV[0?of
kP80?EV[00<0ooK^03eIZ`0mFJ/01`3D?AT>0?ofkP040=@m6@3om^h0ooK^0=@m6@<0ooK^00<00000
0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP0@0?ofkP030=@m6@3om^h0ooK^03X0ooK^00<00000
0?ofkP3om^h04P3om^h10?ooo`00FP3om^h2000000D0ooK^00@0e3dI0?ofkP3om^h0e3dI4@3om^h0
0`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00@0ooK^1@3D?AT20?ofkP030=@m6@3om^h0
ooK^00P0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP050=@m6@3om^h0
ooK^0?ofkP000000203D?AT00`0@63/0000001DPCP0301DPCP0303eIZ`3S?aX0hclJ00L0hclJ00D0
000003eIZ`3S?aX0hclJ03eIZ`060><o6P030000003S?aX0hclJ00D0hclJ0P0mFJ/00`000000hclJ
0><o6P060><o6PH000000`3I?1T00`0mFJ/0fC`I0=Tl6@020=Tl6@040000003I?1T0fC`I0=Tl6@80
?EV[1@3I?1T00`000000fC`I0=Tl6@020=Tl6@0303eIZ`3I?1T0fC`I00<0fC`I00<000000=Tl6@3I
?1T0203I?1T00`000000fC`I0=Tl6@020=Tl6@0303eIZ`3I?1T0fC`I00@0fC`I00<000000=Tl6@3I
?1T01P3I?1T40000000403eIZ`0000000000000000D0c3LG00<000000<`g5`3<=aL01`3<=aL00`0m
FJ/0000000000004000000D0c3LG00<000000<`g5`0mFJ/0203<=aL01@000000?EV[03eIZ`3om^h0
?EV[0080ooK^00<0?EV[0?ofkP3D?AT00P3om^h:0=@m6@P0ooK^00<0e3dI0?ofkP3D?AT0103om^h0
0`000000ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^0100ooK^00<0e3dI0?ofkP3om^h0>P3om^h0
0`000000ooK^0?ofkP0B0?ofkP40oooo001I0?ofkP030000003om^h0000000D0ooK^00<0e3dI0?of
kP3D?AT04P3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00T0ooK^1P3D?AT70?of
kP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h0303om^h0103D?AT0ooK^0?ofkP3om^h2
000000802a0V00D00000010H>`0@63/00000010H>`050=@m6@0301DPCP0mFJ/0hclJ00P0hclJ00D0
00000><o6P0mFJ/0hclJ03eIZ`060><o6P030000003S?aX0hclJ00H0hclJ00<0?EV[0000003S?aX0
2P3S?aX00`000000hclJ0><o6P030000000303eIZ`00000000000080fC`I00<000000=Tl6@3I?1T0
0`3I?1T203eIZ`<0fC`I00<000000=Tl6@3I?1T00P3I?1T00`0mFJ/0fC`I0=Tl6@030=Tl6@030000
003I?1T0fC`I00P0fC`I00<000000=Tl6@3I?1T00P3I?1T00`0mFJ/0fC`I0=Tl6@030=Tl6@030000
003I?1T0fC`I00T0fC`I00<0000003eIZ`3I?1T00`3I?1T8000000H0c3LG00<0?EV[0<`g5`000000
1@3<=aL6000000030<`g5`0mFJ/0c3LG00L0c3LG00@0?EV[0?ofkP0mFJ/0?EV[0P3om^h0100mFJ/0
ooK^0?ofkP3D?AT20?ofkP030=@m6@3om^h0ooK^00<0ooK^2P3D?AT20?ofkP030=@m6@3om^h0e3dI
00<0ooK^00<000000?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP0A0?ofkP030=@m6@3om^h0ooK^
03T0ooK^00<000000?ofkP3om^h04P3om^h10?ooo`00F@3om^h00`000000ooK^000000050?ofkP03
0=@m6@3om^h0e3dI0180ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP0;0?ofkP04
0=@m6@3om^h0ooK^0?ofkPH0e3dI00<0ooK^0=@m6@3om^h01`3om^h00`3D?AT0ooK^0?ofkP0=0?of
kP030=@m6@3om^h0ooK^00<000000P0;42H02000000041Pk010H>`00000041Pk0000000E84h00000
0P0E84h20=@m6@X0hclJ00<0000003eIZ`0mFJ/01`3S?aX00`000000hclJ0><o6P060><o6P<0?EV[
2P3S?aX00`000000hclJ0><o6P030><o6P0303eIZ`3S?aX0hclJ00D000001@3I?1T203eIZ`030=Tl
6@000000fC`I0080fC`I00<0?EV[0=Tl6@3I?1T0103I?1T00`000000fC`I0=Tl6@070=Tl6@030000
003I?1T0fC`I0080fC`I00<0?EV[0=Tl6@3I?1T0103I?1T00`000000fC`I0=Tl6@090=Tl6@030000
000mFJ/0fC`I00P0fC`I00<000000=Tl6@3I?1T01P0000000`0mFJ/0c3LG0000000:0<`g5`H00000
103<=aL00`000000?EV[0?ofkP0203eIZ`030?ofkP0mFJ/0?EV[0080ooK^00@0e3dI0?ofkP3om^h0
e3dI2P3om^h90=@m6@@0ooK^00<000000?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP0A0?ofkP03
0=@m6@3om^h0ooK^03T0ooK^00<000000?ofkP3om^h04P3om^h10?ooo`00F@3om^h00`000000ooK^
000000050?ofkP030=@m6@3om^h0e3dI0180ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^
0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00L0ooK^1`3D?AT30?ofkP030=@m6@3om^h0ooK^00d0ooK^
00<0e3dI0?ofkP3om^h00`00000200/@9P080000000@63/041Pk0000000@63/0000001DPCP000003
01DPCP030000003S?aX0hclJ00P0hclJ00<000000><o6P0mFJ/01`3S?aX00`000000hclJ0><o6P05
0><o6P0503eIZ`3S?aX0hclJ0000000mFJ/02@3S?aX00`000000hclJ0><o6P020><o6P0303eIZ`3S
?aX0hclJ00<0hclJ00<000000><o6P3S?aX01P0000000`3I?1T0?EV[03eIZ`030=Tl6@0303eIZ`3I
?1T0fC`I00@0fC`I00<000000=Tl6@3I?1T01`3I?1T00`000000fC`I0=Tl6@020=Tl6@0303eIZ`3I
?1T0fC`I00@0fC`I00<000000=Tl6@3I?1T0203I?1T00`000000?EV[0=Tl6@090=Tl6@030000003I
?1T0fC`I00D0fC`I00<0?EV[0000000000000`0000080<`g5`0303eIZ`3<=aL0c3LG00<0c3LG1P00
000203eIZ`80ooK^00L0?EV[0?ofkP3om^h0ooK^0=@m6@3om^h0e3dI0140ooK^1P3D?AT00`000000
ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^0140ooK^00<0e3dI0?ofkP3om^h0>P3om^h00`000000
ooK^0?ofkP0A0?ofkP40oooo001I0?ofkP030000003om^h0000000D0ooK^00<0e3dI0?ofkP3D?AT0
0`3D?AT?0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^
0?ofkP080?ofkP030=@m6@3om^h0ooK^00@0ooK^1`3D?AT;0?ofkP080=@m6@3om^h0ooK^0?ofkP00
00002a0V0000000;42H2000000<041Pk0P0000000`0E84h0000001DPCP0301DPCP030000003S?aX0
hclJ00L0hclJ00@000000><o6P0mFJ/0?EV[1P3S?aX00`000000hclJ0><o6P050><o6P0603eIZ`3S
?aX0hclJ0000003S?aX0?EV[203S?aX00`000000hclJ0><o6P020><o6P0303eIZ`3S?aX0hclJ00<0
hclJ00<000000><o6P3S?aX01P3S?aX3000000<0?EV[1`3I?1T00`000000fC`I0=Tl6@070=Tl6@05
0000003I?1T0fC`I0=Tl6@0mFJ/01`3I?1T00`000000fC`I0=Tl6@080=Tl6@030000000mFJ/0fC`I
00P0fC`I00<000000=Tl6@3I?1T01P3I?1T0100mFJ/0fC`I0=Tl6@0000020=Tl6@H000000P3<=aL0
0`0mFJ/0c3LG0<`g5`070<`g5`0303eIZ`3om^h0000000D000000P3om^h00`3D?AT0ooK^0=@m6@0B
0?ofkP80e3dI0P3om^h00`000000e3dI0=@m6@040=@m6@X0ooK^00<0e3dI0?ofkP3om^h0403om^h0
0`3D?AT0ooK^0?ofkP0j0?ofkP030000003om^h0ooK^0140ooK^0@3oool005T0ooK^0P0000060?of
kP030=@m6@3om^h0e3dI00<0ooK^1P3D?AT80?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?of
kP3om^h02`3om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00L0ooK^00@0e3dI0?of
kP3om^h0ooK^1P3D?AT50?ofkP030=@m6@3om^h0ooK^008000000P0;42H200000005010H>`000000
41Pk010H>`0000000`0E84h01@0000005B1>01DPCP0E84h0000000T0hclJ00D0000003eIZ`3S?aX0
hclJ03eIZ`050><o6P030000003S?aX0hclJ00@0hclJ00D0?EV[0><o6P3S?aX0hclJ000000020><o
6P80?EV[1P3S?aX00`000000hclJ0><o6P020><o6P0303eIZ`3S?aX0hclJ00<0hclJ00<000000><o
6P3S?aX0203S?aX00`000000hclJ0><o6P0203eIZ`@000000P3I?1T00`000000fC`I0=Tl6@070=Tl
6@050000003I?1T0fC`I0=Tl6@0mFJ/01`3I?1T00`000000fC`I0=Tl6@080=Tl6@0303eIZ`3I?1T0
fC`I00P0fC`I00<000000=Tl6@3I?1T01@3I?1T0100mFJ/0fC`I0=Tl6@0000090=Tl6@030000000m
FJ/00000008000001@3<=aL203eIZ`030000003om^h0?EV[0080ooK^00<0?EV[0?ofkP3om^h01P00
000A0?ofkP80e3dI0P3om^h00`000000ooK^0?ofkP040?ofkPL0e3dI0`3om^h00`3D?AT0ooK^0?of
kP0A0?ofkP030=@m6@3om^h0ooK^03T0ooK^00<000000?ofkP3om^h04@3om^h10?ooo`00F@3om^h2
000000D0ooK^00@0e3dI0?ofkP3om^h0e3dI2@3om^h60=@m6@80ooK^00<0e3dI0?ofkP3om^h0103o
m^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h01`3o
m^h00`3D?AT0ooK^0?ofkP070?ofkPL0e3dI00<0ooK^0000000000000P0;42H200000005010H>`00
000041Pk010H>`0000000`0E84h0100000005B1>01DPCP0E84h3000000P0hclJ00D0?EV[0><o6P3S
?aX0hclJ03eIZ`040><o6P030000003S?aX0hclJ00@0hclJ00D0?EV[0=@m6@3S?aX0hclJ00000004
0><o6P0303eIZ`3S?aX0hclJ00<0hclJ00D000000><o6P3S?aX0hclJ03eIZ`060><o6P030000003S
?aX0hclJ00P0hclJ00D000000><o6P3S?aX0?EV[0><o6P0303eIZ`030><o6P000000000000D00000
1@3I?1T010000000fC`I0=Tl6@0mFJ/80=Tl6@030000003I?1T0fC`I00P0fC`I00<0?EV[0=Tl6@3I
?1T0203I?1T00`000000fC`I0=Tl6@040=Tl6@0503eIZ`3I?1T0fC`I0=Tl6@0000002P3I?1T0100m
FJ/000000=Tl6@3I?1T3000000<0?EV[00D0c3LG0000000mFJ/0?EV[0?ofkP0203eIZ`@0ooK^0P3D
?AT20?ofkPD000002`3om^h01@3D?AT0ooK^0=@m6@3om^h0000000h0ooK^1P3D?ATA0?ofkP030=@m
6@3om^h0ooK^03T0ooK^00<000000?ofkP3om^h04@3om^h10?ooo`00F03om^h00`000000ooK^0000
00050?ofkP030=@m6@3om^h0e3dI0100ooK^1P3D?AT30?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0
e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0
e3dI0?ofkP0000000P00000200/@9P80000000D041Pk0000000@63/041Pk0000000301DPCP050000
000E84h05B1>01DPCP0000000P3[@Q/6000000030><o6P0mFJ/0000000<0hclJ00<0?EV[0><o6P3S
?aX00`3S?aX00`000000hclJ0><o6P030><o6P0503eIZ`3S?aX0hclJ0><o6P0000001@3S?aX00`0m
FJ/0hclJ0><o6P020><o6P050000003S?aX0hclJ0><o6P0mFJ/01P3S?aX00`000000hclJ0><o6P08
0><o6P030000003S?aX0?EV[00D0hclJ0`0mFJ/00`000000hclJ0><o6P020><o6PP0000000<0?EV[
0=Tl6@3I?1T01@3I?1T00`000000fC`I0=Tl6@080=Tl6@0303eIZ`000000fC`I00T0fC`I00<00000
0=Tl6@3I?1T0103I?1T01@0mFJ/0fC`I0=Tl6@3I?1T0000000T0fC`I00<0?EV[0000003I?1T00`3I
?1T203eIZ`80fC`I00<0?EV[000000000000100mFJ/50?ofkP80e3dI1`3om^h6000000D0ooK^00@0
e3dI0?ofkP3D?AT000004P3om^h00`3D?AT0ooK^0?ofkP050=@m6@`0ooK^00<0e3dI0?ofkP3om^h0
>P3om^h00`000000ooK^0?ofkP0@0?ofkP40oooo001H0?ofkP030000003om^h0000000D0ooK^00<0
e3dI0?ofkP3D?AT04P3om^h0103D?AT0ooK^0?ofkP3om^h60=@m6@X0ooK^00<0e3dI0?ofkP3om^h0
2@3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP000000
0P00000200/@9P080000000@63/041Pk0000000@63/0000001DPCP00000201DPCP060000000E84h0
5B1>0000000O<6/000001`3[@Q/00`000000?EV[0000000200000080hclJ00<0?EV[0><o6P3S?aX0
0P3S?aX00`000000hclJ0><o6P020><o6P0303eIZ`3S?aX0hclJ00<0hclJ00<000000><o6P3S?aX0
0`3S?aX203eIZ`80hclJ00@000000><o6P3S?aX0?EV[1`3S?aX00`000000hclJ0><o6P080><o6P03
0000003S?aX0?EV[00P0hclJ100mFJ/60><o6P030000003S?aX0?EV[00H000000P3I?1T00`000000
fC`I0=Tl6@080=Tl6@0303eIZ`000000fC`I00T0fC`I00<000000=Tl6@3I?1T00`3I?1T00`0mFJ/0
fC`I0=Tl6@020=Tl6@030000003I?1T0fC`I00L0fC`I00@0?EV[0000003I?1T0fC`I0P0mFJ/30=Tl
6@0503eIZ`3I?1T0fC`I03eIZ`3D?AT00`0mFJ/50?ofkP80e3dI3@3om^h6000000030?ofkP3D?AT0
00000180ooK^00<0e3dI0?ofkP3om^h01@3om^h60=@m6@H0ooK^00<0e3dI0?ofkP3om^h0>P3om^h0
0`000000ooK^0?ofkP0@0?ofkP40oooo001H0?ofkP030000003om^h0000000D0ooK^103D?ATA0?of
kP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h01P3D?AT40?ofkP030=@m6@3om^h0ooK^
00T0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@0000001PPA
008000000P0;42H02000000041Pk010H>`00000041Pk0000000E84h000000`0E84h01@0000005B1>
0000000O<6/0000000P0jd8K00@0?EV[0000003[@Q/0jd8K0`0000001@0mFJ/000000><o6P3S?aX0
000000@0hclJ00<0?EV[0><o6P3S?aX00`3S?aX00`000000hclJ0><o6P050><o6P0303eIZ`3S?aX0
00000080hclJ00<0?EV[0><o6P3S?aX01@3S?aX00`000000hclJ0><o6P080><o6P030000000mFJ/0
hclJ00L0hclJ00<000000><o6P3S?aX00P3S?aX303eIZ`<0hclJ00<000000><o6P0mFJ/01P3S?aX5
000000L0fC`I00<0?EV[0000003I?1T02P3I?1T00`000000fC`I0=Tl6@030=Tl6@0503eIZ`3I?1T0
fC`I0=Tl6@0000002@3I?1T00`0mFJ/0fC`I0000000203eIZ`D0fC`I00<0?EV[0=Tl6@000000100m
FJ/30=@m6@80ooK^00<0e3dI0?ofkP3D?AT04@3om^h00`3D?AT0ooK^00000005000000l0ooK^00<0
e3dI0?ofkP3om^h02`3om^h50=@m6@80ooK^00<0e3dI0?ofkP3om^h0>@3om^h00`000000ooK^0?of
kP0@0?ofkP40oooo001H0?ofkP030000003om^h0000000D0ooK^00@0e3dI0?ofkP3D?AT0ooK^1P3D
?AT:0?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h01P3om^h60=@m6@T0ooK^00<0
e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@0000000000008000000P0;
42H02000000041Pk010H>`00000041Pk0000000E84h000000`0E84h01@0000005B1>0000000O<6/0
000000L0jd8K00@0?EV[0>]26`3[@Q/000001@3[@Q/00`0mFJ/00000000000040000000303eIZ`00
0000hclJ00@0hclJ00<000000><o6P3S?aX01P3S?aX01@0mFJ/000000><o6P3S?aX0?EV[00L0hclJ
00<000000><o6P3S?aX01`3S?aX00`000000hclJ03eIZ`080><o6P030000003S?aX0hclJ00D0hclJ
0`0mFJ/00`000000?EV[0><o6P080><o6P030000003S?aX0hclJ00H0000000<0fC`I03eIZ`000000
2P3I?1T00`000000fC`I0=Tl6@030=Tl6@0303eIZ`3I?1T0fC`I0080fC`I00<000000=Tl6@3I?1T0
1`3I?1T303eIZ`H0fC`I00D0?EV[0=Tl6@3I?1T0?EV[0?ofkP0303eIZ`<0ooK^1@3D?AT@0?ofkP05
0=@m6@3om^h0ooK^0000003D?AT0103om^h5000000/0ooK^00<0e3dI0?ofkP3om^h03`3om^h30=@m
6C/0ooK^00<000000?ofkP3om^h0403om^h10?ooo`00F03om^h2000000H0ooK^00<0e3dI0?ofkP3D
?AT01`3om^h70=@m6@<0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP0;0?ofkP03
0=@m6@3om^h0e3dI00D0e3dI0`3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00h0
ooK^00H0e3dI0000000000002a0V0000000;42H2000000<041Pk0P00000201DPCP060000000E84h0
5B1>0000000E84h000000P0O<6/00`000000jd8K0>]26`040>]26`0403eIZ`3[@Q/0jd8K000000H0
jd8K00<0?EV[0>]26`0000000`3[@Q/00`0mFJ/0jd8K00000007000000L0hclJ0`0mFJ/80><o6P03
0000003S?aX0hclJ00L0hclJ00<0000003eIZ`3S?aX0203S?aX00`000000hclJ0><o6P080><o6P@0
?EV[1`3S?aX00`000000hclJ0><o6P060><o6P0303eIZ`000000000000800000203I?1T00`000000
fC`I0=Tl6@030=Tl6@0303eIZ`3I?1T0fC`I0080fC`I00<000000=Tl6@3I?1T0103I?1T403eIZ`03
0000003I?1T0fC`I00D0fC`I00D0?EV[0=Tl6@3I?1T0?EV[0=@m6@0203eIZ`H0ooK^00<0e3dI0?of
kP3D?AT01P3D?AT:0?ofkP060=@m6@3om^h0ooK^0000003om^h0e3dI203om^h6000000D0ooK^00<0
e3dI0?ofkP3om^h04@3om^h00`3D?AT0ooK^0?ofkP0i0?ofkP030000003om^h0ooK^0100ooK^0@3o
ool005P0ooK^0P0000050?ofkP040=@m6@3om^h0ooK^0=@m6@h0ooK^1`3D?AT30?ofkP030=@m6@3o
m^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h01@3om^h70=@m6@D0ooK^00<0e3dI0?ofkP3om^h03@3o
m^h02P3D?AT000000000000000002a0V0000000;42H00000010H>`000002010H>`050000000E84h0
5B1>01DPCP0000000`0E84h01@0000007c1[01l`J`0O<6/0000000D0jd8K00D0?EV[0>]26`3[@Q/0
jd8K000000070>]26`0303eIZ`000000jd8K0080jd8K00<0?EV[0>]26`3[@Q/0103[@Q/00`000000
jd8K0>]26`0500000080hclJ00<000000><o6P0mFJ/0203S?aX00`000000hclJ0><o6P070><o6P03
0000000mFJ/0hclJ00P0hclJ00<000000><o6P3S?aX0203S?aX0100mFJ/0hclJ0><o6P3S?aX603eI
Z`030><o6P000000hclJ00L0hclJ00<0?EV[0><o6P0000000P3S?aX600000080fC`I00<000000=Tl
6@3I?1T00P3I?1T00`0mFJ/0fC`I0=Tl6@030=Tl6@030000003I?1T0?EV[00@0?EV[00D0fC`I03eI
Z`3I?1T0fC`I000000060=Tl6@0503eIZ`3I?1T0fC`I0=Tl6@0000000`0mFJ/60=@m6@80ooK^00<0
e3dI0?ofkP3om^h0103om^h60=@m6@<0ooK^00@0e3dI0?ofkP3om^h000000P3om^h00`3D?AT0ooK^
0?ofkP0<0?ofkPH000004`3om^h00`3D?AT0ooK^0?ofkP0j0?ofkP030000003om^h0ooK^00l0ooK^
0@3oool005L0ooK^00<000000?ofkP0000001@3om^h00`3D?AT0ooK^0=@m6@0B0?ofkP040=@m6@3o
m^h0ooK^0?ofkPH0e3dI2P3om^h00`3D?AT0ooK^0?ofkP090?ofkP040=@m6@3om^h0ooK^0?ofkPH0
e3dI3`3om^h01@3D?AT00000000000000000?EV[008000000P0@63/01000000041Pk010H>`000003
01DPCP050000000E84h05B1>01DPCP0000000`0O<6/00`000000jd8K0>]26`030>]26`0503eIZ`3[
@Q/0jd8K0>]26`0000001`3[@Q/01@0mFJ/0jd8K0000003[@Q/0?EV[00L0jd8K00<000000>]26`3[
@Q/01@3[@Q/4000000<0?EV[1P3S?aX00`000000hclJ0><o6P070><o6P0303eIZ`3S?aX0hclJ00P0
hclJ00<000000><o6P3S?aX0203S?aX00`0mFJ/0hclJ0><o6P070><o6PH0?EV[0`3S?aX00`0mFJ/0
hclJ000000090><o6PD000000P3I?1T00`0mFJ/0fC`I03eIZ`0503eIZ`H0fC`I00@0?EV[0=Tl6@3I
?1T000001P3I?1T0100mFJ/0fC`I0=Tl6@00000303eIZ`H0ooK^1P3D?AT:0?ofkP@0e3dI00<0ooK^
0000003om^h00P3om^h00`3D?AT0ooK^0?ofkP0A0?ofkP030=@m6@000000000000@000003@3om^h0
0`3D?AT0ooK^0?ofkP0j0?ofkP030000003om^h0ooK^00l0ooK^0@3oool005L0ooK^00<000000?of
kP0000001@3om^h00`3D?AT0ooK^0=@m6@0B0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?of
kP3om^h01`3D?AT30?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h01P3om^h70=@m
6@T0ooK^00D0e3dI03eIZ`000000000000/@9P020000008041Pk00@00000010H>`0@63/000000`0E
84h01@0000005B1>01DPCP0E84h0000000<07c1[00<0e3dI0000000mFJ/00`3[@Q/00`0mFJ/0jd8K
0>]26`020>]26`030000003[@Q/0jd8K00D0jd8K00@0?EV[0000003[@Q/0?EV[1`3[@Q/00`000000
jd8K0>]26`070>]26`030000000mFJ/0jd8K008000000P0mFJ/200000080hclJ00<000000><o6P3S
?aX01`3S?aX00`0mFJ/0hclJ0><o6P080><o6P030000003S?aX0hclJ00L0hclJ00<0?EV[0><o6P3S
?aX0203S?aX00`000000hclJ0><o6P030><o6QP0?EV[00@000000=Tl6@3I?1T000001`3I?1T01@0m
FJ/0fC`I0=Tl6@3I?1T0000000D0fC`I00@0?EV[0=Tl6@3I?1T0fC`I100mFJ/60?ofkP040=@m6@3o
m^h0ooK^0=@m6@80ooK^1P3D?AT70?ofkP030=@m6@3om^h0000000<0ooK^00<0e3dI0?ofkP3om^h0
4@3om^h00`3D?AT0ooK^0?ofkP040?ofkPD000002@3om^h00`3D?AT0ooK^0?ofkP0i0?ofkP030000
003om^h0ooK^00l0ooK^0@3oool005L0ooK^00<000000?ofkP0000001@3om^h00`3D?AT0ooK^0=@m
6@0B0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h01`3om^h70=@m6@P0ooK^00<0
e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP040?ofkPH0e3dI0`3om^h01P3D?AT000000000
000000002a0V000000<041Pk00@00000010H>`0000000000100E84h01@0000005B1>0000000O<6/0
000000807c1[00<0e3dI0000000mFJ/00P3[@Q/00`0mFJ/0jd8K0>]26`030>]26`030000003[@Q/0
jd8K00H0jd8K0P0mFJ/90>]26`030000003[@Q/0jd8K00H0jd8K00<0000003eIZ`3[@Q/0103[@Q/2
03eIZ`L000001@3S?aX00`0mFJ/0hclJ0><o6P070><o6P030000003S?aX0hclJ00P0hclJ00<0?EV[
0><o6P3S?aX0203S?aX00`000000hclJ0><o6P050><o6P0403eIZ`3S?aX0hclJ000000X0hclJ00D0
00000><o6P3S?aX0hclJ03eIZ`040><o6PP000000P3I?1T0100mFJ/0fC`I0=Tl6@0000060=Tl6@05
03eIZ`3I?1T0fC`I03eIZ`0000000P0mFJ/60?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT0203om^h5
0=@m6@040?ofkP3D?AT0ooK^000000@0ooK^00<0e3dI0?ofkP3om^h04@3om^h00`3D?AT0ooK^0?of
kP090?ofkPH000000`3om^h00`3D?AT0ooK^0?ofkP0i0?ofkP030000003om^h0ooK^00l0ooK^0@3o
ool005L0ooK^00<000000?ofkP000000103om^h0103D?AT0ooK^0?ofkP3D?ATA0?ofkP030=@m6@3o
m^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h02P3om^h0103D?AT0ooK^0?ofkP3om^h60=@m6@80ooK^
00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP0;0?ofkPH0e3dI00<0000000/@9P000000
0`0@63/01@00000041Pk0000000E84h0000000<05B1>00D0000001DPCP0000007c1[0000000201l`
J`060=@m6@0O<6/0000003eIZ`3[@Q/0?EV[1@3[@Q/00`000000jd8K0>]26`060>]26`030000000m
FJ/0jd8K00P0jd8K00<000000>]26`3[@Q/01P3[@Q/00`0mFJ/0jd8K0>]26`060>]26`0303eIZ`3[
@Q/0000000@0jd8K10000000100mFJ/000000000000000070><o6P030000003S?aX0hclJ00L0hclJ
00<0?EV[0000003S?aX02@3S?aX00`000000hclJ0><o6P050><o6P0403eIZ`3S?aX0hclJ000000X0
hclJ00D000000><o6P3S?aX0hclJ03eIZ`060><o6P030000003S?aX0hclJ00<0hclJ00<0000003eI
Z`0000001@0000030=Tl6@0503eIZ`3I?1T0?EV[03eIZ`3I?1T00P0mFJ/70?ofkP050=@m6@3om^h0
ooK^0?ofkP3D?AT03@3om^h60=@m6@80ooK^00<0e3dI0?ofkP3om^h04@3om^h00`3D?AT0ooK^0?of
kP0?0?ofkPH00000>P3om^h00`000000ooK^0?ofkP0>0?ofkP40oooo001G0?ofkP8000001@3om^h0
103D?AT0ooK^0?ofkP3D?ATA0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h02`3o
m^h00`3D?AT0ooK^0?ofkP070?ofkPL0e3dI0`3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@00
0000000000H0e3dI00D00000010H>`0000005B1>0000000301DPCP030000000E84h0000000807c1[
00D0000001l`J`3D?AT07c1[0000000203eIZ`L0jd8K00<000000>]26`3[@Q/01P3[@Q/303eIZ`L0
jd8K00<000000>]26`3[@Q/01P3[@Q/00`0mFJ/0jd8K0>]26`070>]26`80?EV[203[@Q/0100mFJ/0
00000>]26`3[@Q/500000080hclJ00<000000><o6P3S?aX01`3S?aX00`0mFJ/000000><o6P090><o
6P030000003S?aX0hclJ00@0hclJ00@0?EV[0><o6P3S?aX000002`3S?aX010000000hclJ0><o6P0m
FJ/60><o6P030000003S?aX0hclJ00@0hclJ00<0?EV[0><o6P3S?aX00P3S?aX00`000000hclJ0><o
6P0300000080?EV[0P3I?1T00`000000?EV[03eIZ`070?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT0
3P3om^h00`3D?AT000000?ofkP020?ofkPH0e3dI4@3om^h00`3D?AT0ooK^0?ofkP0A0?ofkP030=@m
6@3om^h0ooK^00H00000=03om^h00`000000ooK^0?ofkP0>0?ofkP40oooo001G0?ofkP8000001@3o
m^h0103D?AT0ooK^0?ofkP3D?ATA0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h0
2`3om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00<0ooK^1P3D?AT>0?ofkP030=@m
6@0000002a0V00<000000`0@63/60=@m6@<05B1>00/0000001l`J`0O<6/07c1[0000000O<6/0e3dI
01l`J`000000jd8K03eIZ`070>]26`030000003[@Q/0jd8K00D0jd8K00D0?EV[0000003[@Q/0jd8K
03eIZ`060>]26`030000003[@Q/0jd8K00H0jd8K00<0?EV[0>]26`3[@Q/0203[@Q/00`000000?EV[
03eIZ`050>]26`0303eIZ`3[@Q/0000000L0jd8K1@0000060><o6P0303eIZ`3S?aX0000000X0hclJ
00<000000><o6P3S?aX0103S?aX0100mFJ/0hclJ0><o6P00000:0><o6P050000003S?aX0hclJ0><o
6P0mFJ/01P3S?aX00`000000hclJ0><o6P040><o6P0503eIZ`3S?aX0hclJ0><o6P0000001@3S?aX2
03eIZ`030><o6P00000000000080?EV[1`3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0
ooK^00/0ooK^00<0e3dI0000003om^h01@3om^h0103D?AT0ooK^0?ofkP3om^h70=@m6@X0ooK^00<0
e3dI0?ofkP3om^h04@3om^h00`3D?AT0ooK^0?ofkP060?ofkPH00000;P3om^h00`000000ooK^0?of
kP0>0?ofkP40oooo001F0?ofkP030000003om^h0000000D0ooK^00<0e3dI0?ofkP3D?AT04P3om^h0
0`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h02@3om^h0
0`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00D0e3dI203om^h0103D?AT000000000000;
42H200000003010H>`00000041Pk008041Pk00D0000001DPCP0E84h0000001DPCP060=@m6@0401l`
J`0000007c1[0=@m6@807c1[00<0000003eIZ`0mFJ/01P3[@Q/00`000000jd8K0>]26`050>]26`03
03eIZ`000000jd8K0080jd8K00<0?EV[0>]26`3[@Q/00`3[@Q/00`000000jd8K0>]26`050>]26`03
03eIZ`000000jd8K00T0jd8K00<000000>]26`3[@Q/00P0mFJ/30>]26`0303eIZ`3[@Q/0000000T0
jd8K00<000000>]26`3[@Q/01P0000000`0mFJ/0hclJ000000090><o6P030000003S?aX0hclJ00@0
hclJ00D0?EV[0><o6P3S?aX0hclJ0000000:0><o6P040000003S?aX0hclJ03eIZ`L0hclJ00<00000
0><o6P3S?aX00`3S?aX00`0mFJ/0hclJ0><o6P020><o6P030000003S?aX0hclJ00<0hclJ00@0?EV[
0><o6P3S?aX0hclJ0`0mFJ/70?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h02`3o
m^h00`3D?AT000000?ofkP050?ofkP030=@m6@3om^h0ooK^00P0ooK^1`3D?AT30?ofkP030=@m6@3o
m^h0ooK^0140ooK^00<0e3dI0?ofkP3om^h0303om^h5000002T0ooK^00<000000?ofkP3om^h03P3o
m^h10?ooo`00EP3om^h00`000000ooK^000000050?ofkP030=@m6@3om^h0e3dI0180ooK^00<0e3dI
0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI
0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP050?ofkPD0e3dI0`3om^h0103D?AT000000000000;
42H200000003010H>`00000041Pk008041Pk00D0000001DPCP0E84h05B1>0000000201DPCP800000
0P0O<6/70=@m6@0303eIZ`000000?EV[00D0jd8K00<000000>]26`3[@Q/01@3[@Q/00`0mFJ/00000
0>]26`030>]26`80?EV[0`3[@Q/00`000000jd8K0>]26`050>]26`0303eIZ`000000jd8K00T0jd8K
00<000000>]26`3[@Q/00P3[@Q/303eIZ`80jd8K00<000000>]26`3[@Q/01`3[@Q/00`000000jd8K
0>]26`050>]26`0303eIZ`000000000000<000001`3S?aX00`000000hclJ0><o6P040><o6P0503eI
Z`3S?aX0hclJ0><o6P0000002P3S?aX010000000hclJ0><o6P0mFJ/60><o6P030000003S?aX0hclJ
00@0hclJ00D0?EV[0><o6P3S?aX0hclJ000000040><o6P80?EV[103S?aX203eIZ`P0ooK^00<0e3dI
0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI
0?ofkP3om^h03`3om^h60=@m6A40ooK^00<0e3dI0?ofkP3om^h04@3om^h6000002<0ooK^00<00000
0?ofkP3om^h03P3om^h10?ooo`00EP3om^h00`000000ooK^000000040?ofkP040=@m6@3om^h0ooK^
0=@m6A80ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0
ooK^00T0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP@0e3dI0P000000
1@0;42H00000010H>`0@63/00000008041Pk0P00000301DPCP060000000E84h05B1>0000000O<6/0
00000`0O<6/01@000000e3dI01l`J`0O<6/000000080lD@L00<0000003eIZ`0000000P0000020>]2
6`030000003[@Q/0jd8K00<0jd8K00@0?EV[0>]26`3[@Q/000001@3[@Q/0100mFJ/0jd8K0>]26`00
00060>]26`0403eIZ`3[@Q/0jd8K000000T0jd8K00<000000>]26`3[@Q/0103[@Q/203eIZ`030>]2
6`000000jd8K00P0jd8K00<000000>]26`3[@Q/01@3[@Q/0100mFJ/0jd8K0>]26`0000020>]26`D0
00000P3S?aX00`000000hclJ0><o6P030><o6P0503eIZ`3S?aX0hclJ0><o6P0000002P3S?aX01000
0000hclJ0><o6P0mFJ/70><o6P030000003S?aX0hclJ00<0hclJ00<0?EV[0><o6P3S?aX00P3S?aX0
0`000000hclJ0><o6P0303eIZ`@0hclJ0P0mFJ/50=@m6@<0ooK^00<0e3dI0?ofkP3om^h00`3om^h0
0`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h04P3om^h0
0`3D?AT0ooK^0?ofkP050=@m6@d0ooK^00<0e3dI0?ofkP3om^h05P3om^h6000001h0ooK^00<00000
0?ofkP3om^h03@3om^h10?ooo`00EP3om^h00`000000ooK^000000040?ofkP030=@m6@3om^h0ooK^
00@0e3dI3`3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?of
kP3om^h02@3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00h0ooK^00D0e3dI0000
000000002a0V00000002010H>`060000000@63/041Pk0000000E84h000000P0E84h00`0000005B1>
0000000201l`J`0:0000000O<6/07c1[01l`J`000000e3dI01l`J`000000:Cj6000000<0lD@L00<0
?EV[0?54703aA1`01`0000001@3[@Q/0?EV[0>]26`3[@Q/0000000H0jd8K00@0?EV[0>]26`3[@Q/0
00001@3[@Q/0100mFJ/0jd8K0>]26`0000090>]26`030000003[@Q/0jd8K00@0jd8K00<0?EV[0>]2
6`0mFJ/00P0mFJ/80>]26`030000003[@Q/0jd8K00@0jd8K00D0?EV[0>]26`3[@Q/0jd8K00000007
0>]26`L0000000<0hclJ03eIZ`3S?aX00P3S?aX00`000000hclJ0><o6P080><o6P040000003S?aX0
hclJ03eIZ`H0hclJ00<000000><o6P3S?aX00`3S?aX00`0mFJ/0hclJ0><o6P020><o6P040000003S
?aX0?EV[03eIZ`80hclJ00<0?EV[0><o6P3S?aX00P3S?aX203eIZ`D0ooK^1P3D?AT30?ofkP030=@m
6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP0B0?ofkP030=@m
6@3om^h0ooK^00D0ooK^1P3D?AT70?ofkP030=@m6@3om^h0ooK^01`0ooK^1P00000H0?ofkP030000
003om^h0ooK^00d0ooK^0@3oool005H0ooK^0P0000050?ofkP@0e3dI0`3om^h60=@m6@T0ooK^00<0
e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0
e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP050=@m6@000000000000/@9P000000
0P0@63/00`00000041Pk0000000201DPCP060000000E84h05B1>0000000E84h000000`0O<6/02@00
00007c1[01l`J`3D?AT0000001l`J`000000:Cj6000000040?54700503eIZ`3aA1`0lD@L0?547000
0000103aA1`00`0mFJ/0000000000004000000D0jd8K0P0mFJ/00`000000jd8K0>]26`030>]26`04
03eIZ`3[@Q/0jd8K000000T0jd8K00<000000>]26`3[@Q/00`3[@Q/0100mFJ/0jd8K0>]26`000002
0>]26`<0?EV[1@3[@Q/00`000000jd8K0>]26`040>]26`0403eIZ`3[@Q/0jd8K000000X0jd8K00<0
00000>]26`3[@Q/00P3[@Q/00`0mFJ/0000000000005000000P0hclJ00<000000><o6P0mFJ/01`3S
?aX00`000000hclJ0><o6P030><o6P0403eIZ`3S?aX0hclJ0><o6P<0?EV[0`3S?aX00`0mFJ/0hclJ
0><o6P020><o6P80?EV[2@3om^h00`3D?AT0ooK^0?ofkP060=@m6@T0ooK^00<000000=@m6@3om^h0
1`3om^h00`3D?AT0ooK^0?ofkP0B0?ofkP030=@m6@3om^h0ooK^00/0ooK^1@3D?AT20?ofkP030=@m
6@3om^h0ooK^0280ooK^1@00000C0?ofkP030000003om^h0ooK^00d0ooK^0@3oool005H0ooK^0P00
00050?ofkP030=@m6@3om^h0ooK^00D0e3dI1@3om^h60=@m6@80ooK^00<0e3dI0?ofkP3om^h0103o
m^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h01@3o
m^h00`3D?AT0ooK^0?ofkP0=0?ofkP0303eIZ`3D?AT02a0V00<000000`0@63/2000000805B1>00D0
000001DPCP0E84h05B1>0000000401l`J`070000000O<6/07c1[0=@m6@0000007c1[0000000202Tn
QP030000003aA1`0lD@L0080lD@L00D0?EV[0?54703aA1`0lD@L000000030?54700503eIZ`3aA1`0
lD@L0?54700000000P3aA1`500000080jd8K00<0?EV[0>]26`3[@Q/00P3[@Q/01@0mFJ/0jd8K0>]2
6`3[@Q/0000000T0jd8K00<000000>]26`3[@Q/00`3[@Q/0100mFJ/0jd8K0>]26`0000050>]26`<0
?EV[0P3[@Q/00`000000jd8K0>]26`030>]26`0503eIZ`3[@Q/0jd8K0>]26`0000002@3[@Q/00`00
0000jd8K0>]26`030>]26`0303eIZ`3[@Q/0jd8K0080jd8K00<000000>]26`3[@Q/01@0000020><o
6P040000003S?aX0hclJ03eIZ`L0hclJ00<000000><o6P3S?aX00P3S?aX00`0mFJ/0hclJ0><o6P02
03eIZ`030><o6P000000hclJ0080hclJ00<0?EV[0><o6P3S?aX00`3S?aX203eIZ`P0ooK^00<0e3dI
0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP060=@m6@80ooK^00<000000=@m6@3om^h0203om^h0
0`3D?AT0ooK^0?ofkP0B0?ofkP030=@m6@3om^h0ooK^0100ooK^0`3D?ATY0?ofkPH000003@3om^h0
0`000000ooK^0?ofkP0=0?ofkP40oooo001E0?ofkP030000003om^h0000000D0ooK^00<0e3dI0?of
kP3D?AT01@3om^h60=@m6@D0ooK^1P3D?AT30?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?of
kP3om^h02@3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0000
000;42H00P0000001@0@63/00000010H>`0@63/0000000<05B1>00D0000001DPCP0E84h05B1>0000
000401l`J`060000000O<6/07c1[0=@m6@0O<6/000000`0Y?XH00`000000lD@L0?5470030?547004
03eIZ`3aA1`0lD@L000000<0lD@L00<0?EV[0?54703aA1`00P3aA1`00`000000lD@L0?5470040?54
70<0000000D0?EV[0000003[@Q/0jd8K03eIZ`030>]26`030000003[@Q/0jd8K00L0jd8K00<00000
0>]26`3[@Q/00P3[@Q/01@0mFJ/0jd8K0>]26`3[@Q/0000000P0jd8K0`0mFJ/50>]26`0503eIZ`3[
@Q/0jd8K0>]26`0000002@3[@Q/00`000000jd8K0>]26`020>]26`0303eIZ`3[@Q/0jd8K0080jd8K
00<000000>]26`3[@Q/01P3[@Q/40000000303eIZ`000000000000D0hclJ00<000000><o6P3S?aX0
0`3S?aX303eIZ`80hclJ00<000000><o6P3S?aX00P3S?aX00`0mFJ/0hclJ0><o6P020><o6P80?EV[
2@3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00H0ooK^103D?AT80?ofkP030=@m
6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h04P3om^h00`3D?AT0ooK^0?ofkP0]0?ofkPH00000
203om^h00`000000ooK^0?ofkP0<0?ofkP40oooo001E0?ofkP030000003om^h0000000D0ooK^00<0
e3dI0?ofkP3D?AT02`3om^h50=@m6@80ooK^00@0e3dI0?ofkP3om^h0ooK^1`3D?AT:0?ofkP030=@m
6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m
6@0000002a0V0080000000D041Pk0000000@63/041Pk0000000401DPCP040000000E84h05B1>0000
00D07c1[00D0000001l`J`3D?AT07c1[0000000302TnQP030000003aA1`0lD@L00@0lD@L00<0?EV[
0?54700000000P3aA1`00`0mFJ/0lD@L0?5470030?5470030000003aA1`0lD@L00H0lD@L00<00000
0?54700mFJ/00P0mFJ/200000080jd8K00<000000>]26`3[@Q/01`3[@Q/00`000000jd8K0>]26`02
0>]26`0503eIZ`3[@Q/0jd8K0>]26`0000002@3[@Q/00`000000jd8K03eIZ`0203eIZ`030>]26`0m
FJ/0jd8K00<0jd8K00<000000>]26`3[@Q/01`3[@Q/00`000000jd8K0>]26`020>]26`0303eIZ`3[
@Q/0jd8K0080jd8K00<000000>]26`3[@Q/0203[@Q/00`000000jd8K03eIZ`020>]26`P00000100m
FJ/40><o6P050000003S?aX0hclJ0><o6P0mFJ/0103S?aX203eIZ`<0e3dI1`3om^h00`3D?AT0ooK^
0?ofkP040?ofkP030=@m6@3om^h0ooK^00L0ooK^00<000000?ofkP3D?AT0203om^h00`3D?AT0ooK^
0?ofkP0C0?ofkP030=@m6@3om^h0ooK^0180ooK^00<0e3dI0?ofkP3om^h0<`3om^h600000080ooK^
00<000000?ofkP3om^h0303om^h10?ooo`00E@3om^h00`000000ooK^000000040?ofkP040=@m6@3o
m^h0ooK^0=@m6A00ooK^1P3D?AT30?ofkP040=@m6@3om^h0ooK^0?ofkPH0e3dI0`3om^h00`3D?AT0
ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h0303om^h0100mFJ/0
e3dI0000000;42H200000005010H>`00000041Pk010H>`000000100E84h01@0000005B1>0000000O
<6/0000000@07c1[00D0000001l`J`3D?AT07c1[0000000402TnQP030000003aA1`0lD@L00@0lD@L
00D0?EV[0?5470000000lD@L03eIZ`050?5470030000003aA1`0lD@L00H0lD@L00D000000?54703a
A1`0lD@L03eIZ`020?5470L000001@3[@Q/01@000000jd8K0>]26`3[@Q/0?EV[00@0jd8K00<00000
0>]26`3[@Q/01`3[@Q/00`000000jd8K0>]26`020>]26`@0?EV[00<0jd8K0000003[@Q/0203[@Q/0
0`000000jd8K0>]26`020>]26`0303eIZ`3[@Q/0jd8K0080jd8K00<000000>]26`3[@Q/0203[@Q/0
0`000000jd8K03eIZ`060>]26`D0?EV[00<0000003eIZ`0000000P0000020><o6P050000003S?aX0
hclJ0><o6P0mFJ/00`3S?aX303eIZ`040000003om^h0ooK^0?ofkPL0e3dI1`3om^h00`3D?AT0ooK^
0?ofkP060?ofkP030000003om^h0e3dI00T0ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^
0?ofkP0B0?ofkP030=@m6@3om^h0ooK^03T0ooK^0`00000>0?ofkP40oooo001E0?ofkP030000003o
m^h0000000@0ooK^00@0e3dI0?ofkP3om^h0e3dI4P3om^h0103D?AT0ooK^0?ofkP3om^h60=@m6@L0
ooK^1P3D?AT90?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h0303om^h01@0mFJ/0
e3dI0000000;42H00000008041Pk00D00000010H>`0000005B1>0000000301DPCP050000000E84h0
000001l`J`000000100O<6/01P0000007c1[0=@m6@000000:Cj6000000<0:Cj600<000000?54703a
A1`01@3aA1`0100mFJ/000000?54700mFJ/50?5470030000003aA1`0lD@L00H0lD@L00@000000?54
703aA1`0lD@L0`0mFJ/20?5470030000003aA1`0lD@L0080lD@L200000000`3[@Q/0?EV[0>]26`03
0>]26`030000003[@Q/0jd8K00L0jd8K00<000000>]26`3[@Q/00P3[@Q/0100mFJ/0jd8K0>]26`3[
@Q/603eIZ`D0jd8K00<000000>]26`3[@Q/00P3[@Q/00`0mFJ/0jd8K0>]26`020>]26`030000003[
@Q/0jd8K00P0jd8K00@000000>]26`0mFJ/0jd8K1@0mFJ/00`3[@Q/000000>]26`030>]26`0403eI
Z`3[@Q/0jd8K0>]26`D0000000H0hclJ03eIZ`3S?aX0hclJ03eIZ`3S?aX203eIZ`030000003om^h0
ooK^00L0ooK^1P3D?AT20?ofkP030=@m6@3om^h0ooK^00H0ooK^00<000000?ofkP3D?AT02@3om^h0
0`3D?AT0ooK^0?ofkP0B0?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h0>P3om^h0
0`000000ooK^0?ofkP0=0?ofkP40oooo001E0?ofkP8000001@3om^h0103D?AT0ooK^0?ofkP3D?ATB
0?ofkP030=@m6@3om^h0ooK^00<0ooK^00@0e3dI0?ofkP3om^h0ooK^1`3D?AT30?ofkP030=@m6@3o
m^h0ooK^00H0e3dI0`3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00`0ooK^00D0
00000=@m6@0000002a0V00000002010H>`050000000@63/0000001DPCP0000000`0E84h00`000000
5B1>0000000201l`J`030000000O<6/07c1[00807c1[00D0e3dI01l`J`000000:Cj60000000402Tn
QP030000003aA1`0lD@L00D0lD@L0P0mFJ/70?5470030000003aA1`0lD@L00H0lD@L00<000000?54
700mFJ/00`3aA1`203eIZ`030000003aA1`0lD@L00L0lD@L00D000000?54703aA1`0000003eIZ`02
00000080jd8K00<000000>]26`3[@Q/01`3[@Q/00`000000jd8K0>]26`020>]26`0303eIZ`3[@Q/0
jd8K0080jd8K00<000000>]26`3[@Q/00P3[@Q/603eIZ`<0jd8K00<0?EV[0>]26`3[@Q/00`3[@Q/0
10000000jd8K0>]26`3[@Q/;03eIZ`H0jd8K00D000000>]26`3[@Q/0jd8K03eIZ`050>]26`050000
003[@Q/0jd8K0>]26`0mFJ/00P0000001@0mFJ/0000003eIZ`3S?aX0000000X0ooK^00<0e3dI0?of
kP3om^h00`3om^h60=@m6@@0ooK^00@000000?ofkP3om^h0e3dI2@3om^h00`3D?AT0ooK^0?ofkP0B
0?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h0>@3om^h00`000000ooK^0?ofkP0>
0?ofkP40oooo001E0?ofkP8000001@3om^h0103D?AT0ooK^0?ofkP3D?ATB0?ofkP030=@m6@3om^h0
ooK^00<0ooK^00<0e3dI0?ofkP3om^h0203om^h70=@m6@D0ooK^1`3D?AT40?ofkP030=@m6@3om^h0
ooK^00`0ooK^0P000000103D?AT0000000/@9P000002010H>`050000000@63/0000001DPCP000000
100E84h01@0000007c1[01l`J`0O<6/0000000@07c1[00<0e3dI01l`J`0000000P0Y?XH01@000000
:Cj602TnQP0Y?XH0000000P0lD@L00<0?EV[0?54703aA1`01@3aA1`00`000000lD@L0?5470060?54
70030000003aA1`0?EV[00D0lD@L0P0mFJ/80?5470040000003aA1`0lD@L03eIZ`<0lD@L1`000005
0>]26`050000003[@Q/0jd8K0>]26`0mFJ/01@3[@Q/00`000000jd8K0>]26`060>]26`030000003[
@Q/0?EV[00`0?EV[1P3[@Q/00`000000?EV[0>]26`070>]26`030000003[@Q/0jd8K0080jd8K00<0
?EV[0>]26`3[@Q/00`3[@Q/01`000000jd8K0>]26`3[@Q/0?EV[0>]26`0mFJ/00P3[@Q/00`0mFJ/0
00000000000:0?ofkP030=@m6@3om^h0ooK^00D0ooK^00@0e3dI0?ofkP3om^h0ooK^1`3D?AT:0?of
kP030=@m6@3om^h0ooK^0180ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP0h0?of
kP030000003om^h0ooK^00l0ooK^0@3oool005@0ooK^00<000000?ofkP0000001@3om^h00`3D?AT0
ooK^0=@m6@0B0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h02`3om^h0103D?AT0
ooK^0?ofkP3om^h60=@m6@80ooK^00@0e3dI0?ofkP3om^h0ooK^203D?AT;0?ofkP030000003D?AT0
2a0V00<000000`0@63/2000000805B1>00D0000001DPCP0E84h05B1>0000000401l`J`060000000O
<6/07c1[01l`J`3D?AT000000`0Y?XH01@000000:Cj602TnQP0Y?XH0000000P0lD@L0P0mFJ/60?54
70030000003aA1`0lD@L00H0lD@L00<0000003eIZ`3aA1`01P3aA1`00`000000?EV[03eIZ`060?54
70040000003aA1`0lD@L03eIZ`D0lD@L00<000000?54703aA1`00P3aA1`8000000030>]26`0mFJ/0
jd8K00<0jd8K00<000000>]26`3[@Q/01`3[@Q/01@000000jd8K0>]26`3[@Q/0?EV[00D0jd8K00<0
00000>]26`3[@Q/01`3[@Q/00`000000jd8K03eIZ`080>]26`050000003[@Q/0jd8K0>]26`0mFJ/0
1@3[@Q/01`000000jd8K0>]26`3[@Q/0?EV[0>]26`0mFJ/00P3[@Q/00`0mFJ/0jd8K0000000:0?of
kP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h0103om^h00`000000ooK^0?ofkP080=@m
6@<0ooK^00<0e3dI0?ofkP3om^h04P3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^
03P0ooK^00<000000?ofkP3om^h03`3om^h10?ooo`00E03om^h00`000000ooK^000000050?ofkP03
0=@m6@3om^h0e3dI0180ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP0;0?ofkP03
0=@m6@3om^h0ooK^00L0ooK^1`3D?AT30?ofkP040=@m6@3om^h0ooK^0?ofkPP0e3dI0`3om^h00`00
0000e3dI00/@9P0200000005010H>`00000041Pk010H>`0000000`0E84h01@0000005B1>01DPCP0E
84h0000000@07c1[00H0000001l`J`0O<6/07c1[0=@m6@00000402TnQP050000000Y?XH0:Cj602Tn
QP0000001P3aA1`00`0mFJ/0lD@L0000000203eIZ`@0lD@L00<000000?54703aA1`01P3aA1`00`00
0000?EV[0?5470060?5470030000003aA1`0lD@L0080?EV[103aA1`00`000000lD@L03eIZ`060?54
70030000003aA1`0lD@L00L0lD@L00@000000?54703aA1`0?EV[0`0000020>]26`030000003[@Q/0
jd8K00L0jd8K00D000000>]26`3[@Q/0jd8K03eIZ`050>]26`030000003[@Q/0jd8K00L0jd8K00<0
000003eIZ`3[@Q/01`3[@Q/00`000000jd8K0>]26`020>]26`0303eIZ`3[@Q/0jd8K00<0jd8K00<0
00000>]26`3[@Q/00`0mFJ/20>]26`0403eIZ`3[@Q/0jd8K000000X0ooK^00<0e3dI0?ofkP3om^h0
1P3om^h00`3D?AT0ooK^0?ofkP030?ofkP050000003om^h0ooK^0?ofkP3D?AT01`3om^h60=@m6A80
ooK^00<0e3dI0?ofkP3om^h04P3om^h00`3D?AT0ooK^0?ofkP0h0?ofkP030000003om^h0ooK^0100
ooK^0@3oool005@0ooK^00<000000?ofkP0000001@3om^h00`3D?AT0ooK^0=@m6@0B0?ofkP030=@m
6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m
6@3om^h0ooK^00<0ooK^1`3D?AT80?ofkPL0e3dI00<00000010H>`0000000P0@63/00`0000005B1>
01DPCP0201DPCP050000000E84h0000001l`J`000000100O<6/01@0000007c1[01l`J`3D?AT00000
00@0:Cj600D0000002TnQP0Y?XH0:Cj6000000060?54700303eIZ`3aA1`000000080lD@L00<0?EV[
0?54703aA1`00P3aA1`00`000000lD@L0?5470050?54700303eIZ`3aA1`0lD@L00H0lD@L00<00000
0?54703aA1`00P3aA1`203eIZ`80lD@L00<000000?54700mFJ/01P3aA1`00`000000lD@L0?547007
0?5470040000003aA1`0lD@L03eIZ`<0lD@L1`0000040>]26`050000003[@Q/0jd8K0>]26`0mFJ/0
1@3[@Q/00`000000jd8K0>]26`080>]26`030000000mFJ/0jd8K00L0jd8K00D000000>]26`3[@Q/0
jd8K03eIZ`050>]26`050000003[@Q/0jd8K0>]26`0mFJ/0103[@Q/0100mFJ/0jd8K0000003D?AT:
0?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h00`3om^h01@000000ooK^0?ofkP3o
m^h0e3dI00X0ooK^00<0e3dI0?ofkP3om^h01@3D?AT=0?ofkP030=@m6@3om^h0ooK^0180ooK^00<0
e3dI0?ofkP3om^h0=`3om^h00`000000ooK^0?ofkP0A0?ofkP40oooo001D0?ofkP@000000`3om^h0
103D?AT0ooK^0?ofkP3D?ATB0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h02P3o
m^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^00H0ooK^00@0e3dI0?ofkP3om^h0ooK^
203D?AT20?ofkP80000000<0e3dI00/@9P0000001P3D?AT401DPCP050000000E84h0000001l`J`00
0000100O<6/01P0000007c1[01l`J`3D?AT0:Cj6000000<0:Cj600<0000002TnQP0Y?XH00P0Y?XH0
0`000000lD@L0?5470020?54700403eIZ`3aA1`0lD@L000000<0lD@L00D0?EV[0?54703aA1`0lD@L
000000070?54700303eIZ`3aA1`0lD@L00H0lD@L00<000000?54703aA1`0103aA1`203eIZ`030000
000mFJ/0lD@L00H0lD@L00<000000?54703aA1`01P3aA1`010000000lD@L0?54700mFJ/60?547003
0000003aA1`0lD@L0080lD@L1`0000000`3[@Q/0?EV[0>]26`040>]26`030000003[@Q/0jd8K00L0
jd8K00<0000003eIZ`3[@Q/01`3[@Q/01@000000jd8K0>]26`3[@Q/0?EV[00D0jd8K00<000000>]2
6`3[@Q/00P0mFJ/40>]26`0303eIZ`3[@Q/000000080ooK^1P3D?AT30?ofkP030=@m6@3om^h0ooK^
00H0ooK^00<0e3dI0?ofkP3om^h00`3om^h01@000000ooK^0?ofkP3om^h0e3dI00/0ooK^00<0e3dI
0?ofkP3om^h01@3om^h60=@m6@L0ooK^00<0e3dI0?ofkP3om^h04P3om^h00`3D?AT0ooK^0?ofkP0f
0?ofkP030000003om^h0ooK^0180ooK^0@3oool005@0ooK^0P0000020?ofkP<0000000@0e3dI0000
00000000e3dI4P3om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI
0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00T0ooK^0P3D?AT2
000000030=@m6@0;42H00000008041Pk00@00000010H>`0000005B1>1P3D?AT0100000007c1[01l`
J`00000401l`J`030000003D?AT000000080:Cj600D0000002TnQP0Y?XH0:Cj60000000302TnQPD0
000000D0?EV[0?54703aA1`0lD@L000000030?54700403eIZ`3aA1`0lD@L000000L0lD@L00<0?EV[
0?54703aA1`01P3aA1`00`000000lD@L0?5470060?5470<0?EV[1P3aA1`00`000000lD@L0?547006
0?5470040000003aA1`0lD@L03eIZ`D0lD@L00<000000?54703aA1`01`3aA1`010000000lD@L0?54
700mFJ/300000080jd8K00<000000>]26`3[@Q/0203[@Q/00`000000?EV[0>]26`040>]26`040=@m
6@3[@Q/0jd8K000000<0jd8K00<0?EV[0>]26`3[@Q/00`3[@Q/010000000?EV[03eIZ`0mFJ/50>]2
6`0303eIZ`000000000000P0ooK^1P3D?AT60?ofkP030=@m6@3om^h0ooK^0080ooK^00<000000?of
kP3om^h00P3om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^00/0ooK^1@3D?AT20?of
kP030=@m6@3om^h0ooK^0180ooK^00<0e3dI0?ofkP3om^h0=@3om^h00`000000ooK^0?ofkP0C0?of
kP40oooo001D0?ofkP8000001@3om^h0103D?AT0ooK^0?ofkP3D?AT6000000`0ooK^00<0e3dI0?of
kP3om^h00`3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?of
kP3om^h01`3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP050000003D?AT0000000/@9P0000000P0@63/0
1@00000041Pk0000000E84h0000000@05B1>00<000000=@m6@3D?AT0103D?AT201l`J`030000003D
?AT0:Cj60080:Cj600D0000002TnQP0Y?XH0:Cj60000000302TnQP050000003gAQd0mdHM0?M67@0m
FJ/01P0000030?547080?EV[00<000000?54703aA1`0103aA1`00`0mFJ/0lD@L000000070?547003
0000003aA1`0lD@L00H0lD@L00<0000003eIZ`3aA1`00`0mFJ/30?5470030000003aA1`0lD@L00H0
lD@L00<000000?54700mFJ/01P3aA1`00`000000lD@L0?5470060?5470050000003aA1`0lD@L0?54
700mFJ/00`3aA1`7000000D0jd8K00<0000003eIZ`3[@Q/01`3[@Q/01@000000jd8K0>]26`3[@Q/0
?EV[00D0jd8K0P0mFJ/20>]26`0303eIZ`3[@Q/0jd8K0080jd8K0P0mFJ/00`000000ooK^0?ofkP0:
0?ofkP030=@m6@3om^h0ooK^00L0e3dI103om^h00`000000ooK^0?ofkP020?ofkP030=@m6@3om^h0
ooK^00T0ooK^00<0e3dI0?ofkP3om^h0403om^h60=@m6A40ooK^00<0e3dI0?ofkP3om^h0=03om^h0
0`000000ooK^0?ofkP0D0?ofkP40oooo001D0?ofkP8000001@3om^h30=@m6@L0ooK^1P0000060?of
kP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP080?of
kP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h02P3om^h2000000040=@m6@0000000000
000000<041Pk0P00000201DPCP050000000E84h05B1>01DPCP000000100O<6/00`0000007c1[0=@m
6@060=@m6@0302TnQP000000:Cj60080:Cj600D0000002TnQP000000<DZK000000020?M67@0303eI
Z`3gAQd0mdHM0080mdHM00<000000?M67@0000000`0000000`3aA1`0?EV[000000050?54700303eI
Z`3aA1`0000000P0lD@L00<000000?54703aA1`01@3aA1`00`0mFJ/0lD@L0?5470030?5470<0?EV[
2@3aA1`00`000000lD@L03eIZ`060?5470030000003aA1`0lD@L00H0lD@L00@000000?54703aA1`0
?EV[1P3aA1`00`000000lD@L0?5470020?5470H0000000<0?EV[0000003[@Q/01P3[@Q/01@000000
jd8K0>]26`3[@Q/0?EV[00<0jd8K0P0mFJ/010000000jd8K0>]26`0mFJ/40>]26`80?EV[00<0e3dI
0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP060?ofkPH0e3dI0`3om^h00`3D?AT0ooK^0?ofkP09
0?ofkP030=@m6@3om^h0ooK^01<0ooK^00@0e3dI0?ofkP3om^h0ooK^1`3D?AT:0?ofkP030=@m6@3o
m^h0ooK^03@0ooK^00<000000?ofkP3om^h0503om^h10?ooo`00D`3om^h00`000000ooK^00000005
0?ofkP030=@m6@3om^h0e3dI00D0e3dI203om^h5000000030=@m6@000000ooK^00@0ooK^00<0e3dI
0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI
0?ofkP3om^h02P3om^h2000000050=@m6@0000000000010H>`0000000P0@63/01@0000005B1>01DP
CP0E84h0000000<05B1>0P00000301l`J`030000000O<6/07c1[00807c1[00@0e3dI0000000Y?XH0
:Cj61P3D?AT01P0Y?XH00000035:V`0aBY/0000003eIZ`H0mdHM00<000000?M67@3gAQd00P3gAQd2
0000000603eIZ`00000000000000003aA1`0?EV[0P3aA1`00`000000lD@L0?5470060?5470030000
003aA1`0lD@L00D0lD@L00<0?EV[0?54703aA1`01@3aA1`00`000000?EV[03eIZ`060?5470030000
003aA1`0?EV[00L0lD@L00<000000?54703aA1`01P3aA1`010000000lD@L0?54700mFJ/50?547003
0000003aA1`0lD@L00L0lD@L00@0000003eIZ`3aA1`0lD@L100000020>]26`050000003[@Q/0jd8K
0>]26`0mFJ/00P3[@Q/203eIZ`030>]26`000000jd8K0080jd8K00<0?EV[0>]26`3[@Q/00P3[@Q/0
0`0mFJ/000000=@m6@0=0?ofkP030=@m6@3om^h0ooK^00H0ooK^00@0e3dI0?ofkP3om^h000000P3o
m^h40=@m6@/0ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP080?ofkPL0e3dI0`3o
m^h00`3D?AT0ooK^0?ofkP0c0?ofkP030000003om^h0ooK^01D0ooK^0@3oool005<0ooK^00<00000
0?ofkP0000001@3om^h00`3D?AT0ooK^0=@m6@030=@m6@80ooK^1P3D?AT70?ofkP030=@m6@3om^h0
000000@0000000<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0
ooK^00L0ooK^00<0e3dI0?ofkP3om^h02P3om^h2000000050=@m6@0000000000010H>`0000000P0@
63/01@0000005B1>01DPCP0E84h0000000805B1>00<0000001l`J`000000100O<6/01P0000007c1[
01l`J`000000e3dI000000@0:Cj600@0000002TnQP0Y?XH0:Cj6103D?AT00`000000?EV[0?M67@05
0?M67@030000003gAQd0mdHM00@0mdHM00H0000003eIZ`0mFJ/0mdHM0000000mFJ/7000000@0lD@L
00<000000?54703aA1`0103aA1`00`0mFJ/000000?5470060?5470030000003aA1`0lD@L00<0?EV[
0`3aA1`00`000000lD@L03eIZ`060?5470030000003aA1`0lD@L00H0lD@L00@000000?54703aA1`0
?EV[1P3aA1`00`000000lD@L0?5470070?5470030000000mFJ/0lD@L00D0lD@L1P00000303eIZ`<0
jd8K00@000000>]26`3[@Q/0?EV[103[@Q/0100mFJ/0000003eIZ`3D?AT<0?ofkP030=@m6@3om^h0
ooK^00L0ooK^00@0e3dI0?ofkP3om^h000001@3om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3o
m^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h03`3om^h40=@m6C@0ooK^00<000000?ofkP3om^h05P3o
m^h10?ooo`00D`3om^h00`000000ooK^000000050?ofkP030=@m6@3om^h0e3dI00<0ooK^1P3D?AT2
0?ofkPD0e3dI0P3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@000000000000D000001P3om^h0
0`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h02P3om^h2
000000030=@m6@0;42H00000008041Pk00@00000010H>`0@63/00000100E84h00`0000005B1>0000
000201l`J`050000000O<6/07c1[01l`J`0000000P0O<6/0103D?AT0:Cj602TnQP00000302TnQP05
0000000Y?XH0:Cj602TnQP0000000`0aBY/00`3D?AT000000?M67@060?M67@030000003gAQd0mdHM
00@0mdHM00@000000?M67@0mFJ/0?EV[0`3gAQd00`000000mdHM0?M67@020?M67@H000001@3aA1`0
0`0mFJ/000000?5470060?5470030000003aA1`0lD@L00<0lD@L0`0mFJ/00`000000?EV[0?547006
0?5470030000003aA1`0lD@L00H0lD@L00@000000?54703aA1`0?EV[1@3aA1`00`000000lD@L0?54
70070?5470030000000mFJ/0lD@L00L0lD@L00<000000?54703aA1`00`0mFJ/80000000603eIZ`3[
@Q/0jd8K0>]26`0mFJ/0jd8K0P0000000`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00L0
ooK^00<0e3dI0?ofkP0000001P3om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^01<0
ooK^00<0e3dI0?ofkP3om^h04P3om^h00`3D?AT0ooK^0?ofkP0a0?ofkP030000003om^h0ooK^01L0
ooK^0@3oool005<0ooK^0P0000050?ofkP040=@m6@3om^h0ooK^0=@m6@T0ooK^1P3D?AT00`3om^h0
e3dI0=@m6@040=@m6@80ooK^00<0e3dI0?ofkP3om^h01P3om^h5000000030=@m6@3om^h0ooK^00P0
ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP80000000<0e3dI00/@9P00
00000P0@63/01@00000041Pk0000000E84h0000000<05B1>00<0000001DPCP0000000P0O<6/00`00
00007c1[01l`J`0201l`J`030000000O<6/0e3dI0080:Cj600<0000002TnQP0Y?XH00P0Y?XH00`00
0000:Cj602TnQP02000000<0<DZK00<000000?M67@3gAQd01@3gAQd00`000000mdHM0?M67@040?M6
7@040000003gAQd0mdHM03eIZ`<0mdHM00<000000?M67@3gAQd01P3gAQd00`000000mdHM00000003
0000000303eIZ`3aA1`0000000L0lD@L00<000000?54703aA1`01P3aA1`403eIZ`D0lD@L00<00000
0?54703aA1`01P3aA1`00`000000lD@L03eIZ`060?5470030000003aA1`0lD@L00L0lD@L00<00000
03eIZ`3aA1`01P3aA1`503eIZ`D0lD@L00H000000?54703aA1`0lD@L03eIZ`3aA1`200000080?EV[
00@0000003eIZ`3om^h0e3dI303om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0000000H0
ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^0180
ooK^00<0e3dI0?ofkP3om^h0<03om^h00`000000ooK^0?ofkP0H0?ofkP40oooo001C0?ofkP800000
1@3om^h0103D?AT0ooK^0?ofkP3D?AT?0?ofkPH0e3dI00<0ooK^0=@m6@3D?AT0103D?AT:0?ofkP03
0=@m6@000000000000D000000`3om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00X0
ooK^0P0000000`3D?AT02a0V00000002010H>`050000000@63/0000001DPCP000000100E84h00`00
00007c1[01l`J`0201l`J`040000000O<6/07c1[01l`J`80000000D0e3dI02TnQP0Y?XH0:Cj60000
000302TnQP030000000Y?XH0:Cj600800000100aBY/00`000000mdHM0?M67@050?M67@030000003g
AQd0mdHM00@0mdHM00<000000?M67@0mFJ/00P0mFJ/20?M67@030000003gAQd0mdHM00D0mdHM00<0
00000?M67@3gAQd00`3gAQd00`0mFJ/0000000000003000000@0lD@L00<000000?54703aA1`01@3a
A1`00`000000?EV[0?5470020?5470H0?EV[203aA1`00`000000lD@L03eIZ`050?5470030000003a
A1`0lD@L00L0lD@L00<0000003eIZ`3aA1`00`3aA1`403eIZ`050000003aA1`0lD@L0?54700mFJ/0
103aA1`01@000000lD@L0?54703aA1`0?EV[00<0lD@L00<0?EV[0?54700000001P3D?AT:0?ofkP03
0=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP0000001P3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP03
0=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h04P3om^h00`3D?AT0ooK^0?ofkP0_0?ofkP03
0000003om^h0ooK^01T0ooK^0@3oool005<0ooK^0P0000050?ofkP030=@m6@3om^h0e3dI01<0ooK^
00<0e3dI0?ofkP3om^h03P3D?AT30?ofkP030=@m6@3om^h0ooK^00D0ooK^0`0000000`3D?AT00000
000000070?ofkP030=@m6@3om^h0ooK^00T0ooK^0P000000100;42H0e3dI000000000003010H>`80
00000P0E84h01@0000005B1>01DPCP0E84h0000000@07c1[00<0000001l`J`0O<6/00P0O<6/00`00
0000e3dI02TnQP0202TnQP030000000Y?XH0:Cj60080:Cj60P000002035:V`030000000aBY/0<DZK
0080<DZK00<000000?M67@3gAQd0103gAQd00`000000mdHM0?M67@040?M67@030000000mFJ/0mdHM
0080mdHM0P0mFJ/00`000000mdHM0?M67@050?M67@030000003gAQd0mdHM0080mdHM00@0?EV[0?M6
7@3gAQd000000`3gAQd8000000@0lD@L00<0000003eIZ`3aA1`01P3aA1`00`000000lD@L03eIZ`05
03eIZ`040?5470000000lD@L03eIZ`<0lD@L00@0e3dI0?54703aA1`00000203aA1`00`000000lD@L
03eIZ`0403eIZ`<0lD@L00D000000?54703aA1`0lD@L03eIZ`050?5470050000003aA1`0lD@L0?54
700mFJ/00P3aA1`00`0mFJ/0lD@L0000000200000080ooK^00<0e3dI0?ofkP3om^h01P3D?AT40?of
kP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0000003om^h01P3om^h00`3D?AT0ooK^0?ofkP0:0?of
kP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h04P3om^h00`3D?AT0ooK^0?ofkP0_0?of
kP030000003om^h0ooK^01T0ooK^0@3oool00580ooK^00<000000?ofkP0000001@3om^h00`3D?AT0
ooK^0=@m6@0C0?ofkP030=@m6@3om^h0ooK^00<0ooK^00@0e3dI0?ofkP3om^h0ooK^3P3D?AT60?of
kP040=@m6@3om^h0ooK^0?ofkPL0000000<0e3dI0?ofkP3om^h02@3om^h2000000050=@m6@000000
0000010H>`0000000P0@63/01@0000005B1>01DPCP0E84h0000000<05B1>0P00000401l`J`060000
000O<6/07c1[01l`J`3D?AT00000100Y?XH010000000:Cj602TnQP0Y?XH200000080<DZK00<00000
035:V`0aBY/00P0aBY/00`000000mdHM0?M67@040?M67@030000003gAQd0mdHM00@0mdHM00<00000
03eIZ`3gAQd0103gAQd00`0mFJ/0mdHM0?M67@050?M67@030000003gAQd0mdHM0080mdHM00@0?EV[
0?M67@3gAQd000001`3gAQd010000000mdHM0?M67@3gAQd40000000303eIZ`000000000000800000
103aA1`00`000000lD@L0?5470050?5471H0?EV[1P3aA1`00`000000lD@L0?5470020?54700303eI
Z`3aA1`0lD@L0080lD@L00H000000?54703aA1`0lD@L03eIZ`3aA1`203eIZ`030?54700000000000
008000000P3om^h00`3D?AT0ooK^0?ofkP060?ofkPD0e3dI203om^h00`3D?AT000000?ofkP060?of
kP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h04P3om^h00`3D?AT0ooK^0?ofkP0C0?of
kP030=@m6@3om^h0ooK^02h0ooK^00<000000?ofkP3om^h06P3om^h10?ooo`00DP3om^h00`000000
ooK^000000050?ofkP030=@m6@3om^h0e3dI0180ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0
ooK^0?ofkP090?ofkPd0e3dI2P3om^h00`3D?AT0000000000003000000D0ooK^0`0000001@3D?AT0
00000000000@63/00000008041Pk00D0000001DPCP0E84h05B1>0000000201DPCP030000000O<6/0
000000@07c1[00H0000001l`J`0O<6/000000=@m6@00000502TnQP050000000Y?XH0:Cj602TnQP00
00000`0aBY/00`000000<DZK035:V`02035:V`030000003gAQd0mdHM00@0mdHM00<000000?M67@3g
AQd00`3gAQd00`0mFJ/000000?M67@040?M67@030000000mFJ/0?EV[00D0mdHM00D000000?M67@3g
AQd0mdHM03eIZ`030?M67@030000003gAQd0mdHM00D0mdHM00<000000?M67@3gAQd01@3gAQd00`0m
FJ/0mdHM0?M67@020?M67@H000001`3aA1`00`000000?EV[0?5470050?5470030000003aA1`0lD@L
00H0lD@L00<0000003eIZ`3aA1`01`3aA1`01@000000lD@L0?54703aA1`0?EV[00@0lD@L00<00000
0?54703aA1`00P3aA1`203eIZ`<0lD@L0`0000020?ofkP030=@m6@3om^h0ooK^00/0ooK^1`3D?AT2
0?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP0C
0?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h0;@3om^h00`000000ooK^0?ofkP0K
0?ofkP40oooo001B0?ofkP030000003om^h0000000D0ooK^00<0e3dI0?ofkP3D?AT04P3om^h00`3D
?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h00`3om^h<0=@m
6@<0ooK^00<0e3dI0?ofkP3om^h00`3om^h8000000050=@m6@00000041Pk010H>`0000000P0@63/0
0`0000005B1>01DPCP0201DPCP030000000E84h0000000807c1[00<0000001l`J`0O<6/00P0O<6/0
1P0000007c1[0000003D?AT0:Cj6000000@0:Cj600H0000002TnQP0Y?XH00000035:V`000003035:
V`050000000aBY/0<DZK035:V`0000001P3gAQd00`000000mdHM0?M67@030?M67@0303eIZ`000000
mdHM00D0mdHM00@000000?M67@0mFJ/0?EV[0`3gAQd01@000000mdHM0?M67@3gAQd0?EV[00<0mdHM
00<000000?M67@3gAQd01@3gAQd00`000000mdHM0?M67@040?M67@0303eIZ`000000mdHM00L0mdHM
00<000000?M67@0000000`0000020?5470030000003aA1`0?EV[00H0lD@L00<000000?54703aA1`0
1P3aA1`00`000000?EV[0?5470060?5470030000003aA1`0lD@L0080lD@L00D0?EV[0?54703aA1`0
lD@L000000040?547080?EV[0`3aA1`3000000040=@m6@3om^h0ooK^0=@m6@`0ooK^00<0e3dI0?of
kP3om^h01@3om^h60=@m6@D0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP0C0?of
kP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h0;03om^h00`000000ooK^0?ofkP0L0?of
kP40oooo001B0?ofkP8000001P3om^h00`3D?AT0ooK^0=@m6@0B0?ofkP030=@m6@3om^h0ooK^00<0
ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00d0
e3dI1P3om^h3000000090=@m6@00000041Pk010H>`00000041Pk0000000E84h0000000<05B1>00<0
000001DPCP0000000P0O<6/00`0000007c1[01l`J`0201l`J`80000000D0:Cj60=@m6@0Y?XH0:Cj6
0000000402TnQP050000000Y?XH00000035:V`0000000`0aBY/00`000000<DZK035:V`02035:V`03
0000003gAQd0mdHM00@0mdHM00L000000?M67@3gAQd0mdHM03eIZ`3gAQd0000000H0mdHM00D00000
0?M67@3gAQd0mdHM03eIZ`020?M67@040000003gAQd0mdHM03eIZ`@0mdHM00<000000?M67@3gAQd0
1@3gAQd00`000000mdHM0?M67@040?M67@0303eIZ`000000mdHM00H0mdHM00<000000?M67@3gAQd0
103gAQd30000000303eIZ`000000000000@0lD@L00<000000?54703aA1`01P3aA1`00`000000?EV[
0?5470060?5470030000003aA1`0lD@L0080lD@L00<0?EV[0?54703aA1`00P3aA1`00`000000lD@L
0?5470020?54700703eIZ`3aA1`0lD@L0?5470000000Bg7@000000020?ofkPH0e3dI2@3om^h00`3D
?AT0ooK^0?ofkP060?ofkP030000003D?AT0ooK^0080ooK^1`3D?AT:0?ofkP030=@m6@3om^h0ooK^
01<0ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP0[0?ofkP030000003om^h0ooK^
01d0ooK^0@3oool00580ooK^0P0000050?ofkP040=@m6@3om^h0ooK^0=@m6A80ooK^00<0e3dI0?of
kP3om^h00`3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?of
kP3om^h01P3om^h60=@m6@030?ofkP3D?AT0e3dI00@0e3dI0P0000000`3D?AT02a0V00000002010H
>`050000000@63/0000001DPCP000000100E84h00`0000007c1[01l`J`0201l`J`030000000O<6/0
7c1[00807c1[00<000000=@m6@0Y?XH00P0Y?XH00`000000:Cj602TnQP0202TnQP8000000`0aBY/0
1@000000<DZK035:V`0aBY/0000000<0<DZK00<000000?M67@3gAQd0103gAQd01@000000mdHM0?M6
7@3gAQd0?EV[0080mdHM00<000000?M67@3gAQd00`3gAQd00`000000mdHM0?M67@020?M67@80?EV[
00@0mdHM0000003gAQd0?EV[103gAQd00`000000mdHM0?M67@050?M67@030000003gAQd0mdHM00<0
mdHM00<0?EV[0000003gAQd01`3gAQd00`000000mdHM0?M67@050?M67@030000003gAQd0?EV[0080
mdHM200000050?5470030000000mFJ/0lD@L00D0lD@L00<000000?54703aA1`00P3aA1`00`0mFJ/0
lD@L0?5470020?5470040000003aA1`0lD@L0?547080?EV[0`3aA1`010000000Bg7@000000000004
0?ofkP040=@m6@3om^h0ooK^0?ofkPH0e3dI0`3om^h00`3D?AT0ooK^0?ofkP050?ofkP030000003o
m^h0e3dI00P0ooK^00<0e3dI0?ofkP3D?AT01P3D?AT30?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0
e3dI0?ofkP3om^h04P3om^h00`3D?AT0ooK^0?ofkP0[0?ofkP030000003om^h0ooK^01h0ooK^0@3o
ool00580ooK^0P0000050?ofkP040=@m6@3om^h0ooK^0=@m6A80ooK^00<0e3dI0?ofkP3om^h00`3o
m^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h02@3o
m^h0103D?AT0ooK^0?ofkP3om^h60=@m6@80000000@02a0V0=@m6@00000000000`0@63/200000080
5B1>00D0000001DPCP0E84h05B1>0000000501l`J`060000000O<6/07c1[01l`J`0mFJ/0e3dI100Y
?XH00`000000:Cj602TnQP0202TnQP030000000aBY/0<DZK0080<DZK00D00000035:V`0aBY/0<DZK
00000003035:V`@000000`3gAQd010000000mdHM0?M67@0mFJ/20?M67@030000003gAQd0mdHM00<0
mdHM00<000000?M67@3gAQd0103gAQd303eIZ`D0mdHM00<000000?M67@3gAQd01@3gAQd00`000000
mdHM0?M67@030?M67@0303eIZ`000000mdHM00L0mdHM00<000000?M67@3gAQd01@3gAQd00`000000
?EV[0?M67@050?M67@030000003gAQd0mdHM0080mdHM1@0000000`0mFJ/00000000000050?547003
0000003aA1`0lD@L0080lD@L00D0?EV[0?54703aA1`0lD@L000000020?5470<0?EV[0`3aA1`01@00
0000Bg7@000000000000e3dI00@0ooK^00<0e3dI0?ofkP3om^h01`3om^h60=@m6@@0ooK^00<00000
0?ofkP3D?AT0203om^h00`3D?AT0ooK^0?ofkP070?ofkPL0e3dI4P3om^h00`3D?AT0ooK^0?ofkP0B
0?ofkP030=@m6@3om^h0ooK^02/0ooK^00<000000?ofkP3om^h07P3om^h10?ooo`00DP3om^h20000
00D0ooK^00@0e3dI0?ofkP3om^h0e3dI4P3om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0
ooK^00`0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0
ooK^00L0ooK^1P3D?AT01000000041Pk010H>`00000301DPCP040000000E84h05B1>01DPCP800000
100O<6/01P0000007c1[01l`J`000000:Cj60=@m6@@0:Cj600<0000002TnQP0Y?XH00P0Y?XH20000
00<0<DZK00D00000035:V`0aBY/0<DZK00000002035:V`030000000hE:d000000080o4PN1@000000
0`0mFJ/000000?M67@020?M67@030000003gAQd0mdHM00<0mdHM00<000000?M67@3gAQd0103gAQd0
0`000000?EV[03eIZ`040?M67@030000003gAQd0mdHM00@0mdHM00<000000?M67@3gAQd00`3gAQd0
0`0mFJ/0mdHM000000070?M67@030000003gAQd0mdHM00D0mdHM00<000000?M67@0mFJ/01P3gAQd0
0`000000mdHM0?M67@050?M67@030000000mFJ/0mdHM0080mdHM1P0000030?54700603eIZ`3aA1`0
lD@L0?5470000000lD@L0P0mFJ/20?54700503eIZ`3aA1`0lD@L0000001;LM000P0000000`3D?AT0
ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h01`3D?AT80?ofkP03
0=@m6@3om^h0ooK^00X0ooK^00@0e3dI0?ofkP3om^h0ooK^1`3D?AT;0?ofkP030=@m6@3om^h0ooK^
0180ooK^00<0e3dI0?ofkP3om^h0:P3om^h00`000000ooK^0?ofkP0O0?ofkP40oooo001A0?ofkP03
0000003om^h0000000D0ooK^103D?ATA0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3o
m^h0303om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3o
m^h01`3om^h30000000403eIZ`3D?AT00000010H>`H0e3dI00L05B1>0000000E84h05B1>0000000O
<6/0000000D07c1[00H0000001l`J`000000:Cj60=@m6@00000402TnQP060000000Y?XH0:Cj60000
000aBY/00000100aBY/02@000000<DZK035:V`0aBY/00000035:V`000000>5B]000000050?a87P04
0000003lB1h0?EV[0?a87PH000000`3gAQd00`000000mdHM0?M67@040?M67@030000000mFJ/0mdHM
00@0?EV[00<000000?M67@3gAQd0103gAQd00`000000mdHM0?M67@030?M67@0303eIZ`3gAQd00000
00L0mdHM00<000000?M67@3gAQd01@3gAQd00`000000?EV[0?M67@050?M67@030000003gAQd0mdHM
00H0mdHM00<0000003eIZ`3gAQd01@3gAQd00`000000mdHM0?M67@030000000403eIZ`3aA1`0lD@L
0?547080?EV[0`3aA1`0100mFJ/0lD@L0?54703aA1`20000000304]ad0000000e3dI00@0ooK^00<0
e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP030?ofkP030000003om^h0ooK^00H0e3dI0`3o
m^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00P0ooK^203D?AT30?ofkP030=@m6@3o
m^h0ooK^0180ooK^00<0e3dI0?ofkP3om^h0:@3om^h00`000000ooK^0?ofkP0P0?ofkP40oooo001A
0?ofkP030000003om^h0000000D0ooK^00@0e3dI0?ofkP3D?AT0ooK^1`3D?AT:0?ofkP030=@m6@3o
m^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3o
m^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h01`3om^h30000000500/@9P3D?AT041Pk010H>`000000
0P0@63/20000000301DPCP3D?AT0e3dI00@0e3dI00<07c1[0000000O<6/00`0O<6/20000000502Tn
QP3D?AT0:Cj602TnQP000000100Y?XH00`000000:Cj600000002035:V`030000000aBY/0<DZK0080
<DZK00<00000035:V`0aBY/00P00000303QD[@030000000mFJ/0o4PN00<0o4PN00<0?EV[0?a87P3l
B1h00`3lB1h00`000000o4PN0?a87P05000000D0mdHM00<0?EV[0?M67@3gAQd0103gAQd303eIZ`@0
mdHM00<000000?M67@3gAQd00P3gAQd0100mFJ/0mdHM0?M67@0000070?M67@030000003gAQd0mdHM
00@0mdHM00<000000?M67@0mFJ/01P3gAQd00`000000mdHM0?M67@050?M67@030000000mFJ/0mdHM
00D0mdHM00<000000?M67@3gAQd00`3gAQd00`0mFJ/0mdHM0000000203eIZ`<000000P3aA1`00`0m
FJ/0lD@L0?5470020000000404]ad0000000ooK^0=@m6@@0ooK^00<0e3dI0?ofkP3om^h02`3om^h0
0`3D?AT0ooK^0?ofkP020?ofkP050000003om^h0ooK^0?ofkP3D?AT01@3om^h40=@m6@/0ooK^00<0
e3dI0?ofkP3om^h04@3om^h60=@m6A80ooK^00<0e3dI0?ofkP3om^h0:03om^h00`000000ooK^0?of
kP0Q0?ofkP40oooo001A0?ofkP8000001P3om^h00`3D?AT0ooK^0=@m6@080?ofkPL0e3dI0`3om^h0
0`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h01`3om^h0
0`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00L0ooK^0`0000002@3D?AT00000010H>`0@
63/00000010H>`0000005B1>0000000301DPCP040000000E84h0000001l`J`H0e3dI00@07c1[0000
000Y?XH0e3dI0P0Y?XH00`000000:Cj602TnQP0202TnQP800000100aBY/01@000000<DZK035:V`0a
BY/0000000<0<DZK00L0000003QD[@0hE:d0e3dI0000003lB1h0?EV[00<0o4PN00<0?EV[0?a87P3l
B1h0103lB1h00`000000o4PN0?a87P020?a87P030000003lB1h0000000<0000000<0mdHM03eIZ`3g
AQd01@3gAQd00`000000mdHM0?M67@0303eIZ`030?M67@000000mdHM00<0mdHM00@0?EV[0?M67@3g
AQd000001`3gAQd00`000000mdHM0?M67@040?M67@030000000mFJ/0mdHM00D0mdHM00<000000?M6
7@3gAQd01@3gAQd00`000000?EV[0?M67@050?M67@030000003gAQd0mdHM00@0mdHM0`0mFJ/00`00
0000mdHM0?M67@020?M67@030000000mFJ/000000080000000H0Bg7@00000000000000000?ofkP3D
?AT40?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h00`3om^h01@000000ooK^0?of
kP3om^h0e3dI00P0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP0D0?ofkP030=@m
6@3om^h0ooK^00D0e3dI3@3om^h00`3D?AT0ooK^0?ofkP0W0?ofkP030000003om^h0ooK^0280ooK^
0@3oool00540ooK^0P0000050?ofkP030=@m6@3om^h0ooK^00<0e3dI3@3om^h70=@m6@80ooK^00<0
e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0
e3dI0?ofkP3om^h01`3om^h3000000070=@m6@00000041Pk010H>`00000041Pk0000000201DPCP05
0000000E84h05B1>01DPCP000000100O<6/0100000007c1[01l`J`0O<6/70=@m6@030000000Y?XH0
:Cj60080:Cj600<00000035:V`0aBY/00P0aBY/00`000000<DZK035:V`02035:V`040000000aBY/0
<DZK00000080>5B]00@0e3dI03QD[@000000o4PN0`0mFJ/00`3lB1h000000?a87P040?a87P030000
003lB1h0o4PN00<0o4PN00<000000?a87P3lB1h00P3lB1h00`0mFJ/0000000000002000000<0mdHM
00<000000?M67@3gAQd00`3gAQd403eIZ`050?M67@0mFJ/0mdHM0?M67@0000001`3gAQd00`000000
mdHM0?M67@040?M67@030000003gAQd0?EV[00D0mdHM00<000000?M67@3gAQd01P3gAQd00`000000
?EV[0?M67@050?M67@040000003gAQd0mdHM0?M67@@0?EV[00<0mdHM0000003gAQd01@3gAQd0100m
FJ/0mdHM0000001;LM0300000080ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP0:
0?ofkP030=@m6@3om^h0ooK^0080ooK^00D000000?ofkP3om^h0ooK^0=@m6@090?ofkP030=@m6@3o
m^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h0503om^h00`3D?AT0ooK^0?ofkP050?ofkPH0e3dI1`3o
m^h00`3D?AT0ooK^0?ofkP0V0?ofkP030000003om^h0ooK^02<0ooK^0@3oool00540ooK^0P000005
0?ofkP040=@m6@3om^h0ooK^0=@m6@80ooK^1P3D?AT:0?ofkP040=@m6@3om^h0ooK^0?ofkPL0e3dI
2P3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h0
1P3om^h20000000500/@9P000000e3dI010H>`0000000P0@63/2000000805B1>00D0000001DPCP0E
84h05B1>0000000501l`J`040000000O<6/07c1[00000080:Cj600@0e3dI02TnQP0Y?XH0:Cj6203D
?AT3035:V`030000000aBY/0<DZK0080<DZK0P0000000`0hE:d000000=@m6@0203QD[@070000003l
B1h0o4PN0?a87P0mFJ/0o4PN000000050?a87P030000003lB1h0o4PN00<0o4PN00<000000?a87P3l
B1h00P3lB1h00`0mFJ/000000?a87P020?a87PL000000`3gAQd00`000000mdHM0?M67@0403eIZ`03
0000003gAQd0mdHM00D0mdHM00<000000?M67@3gAQd0103gAQd00`000000?EV[0?M67@050?M67@03
0000003gAQd0mdHM00D0mdHM00<0000003eIZ`3gAQd01@3gAQd503eIZ`050?M67@0mFJ/0mdHM0?M6
7@0000001P3gAQd00`0mFJ/0mdHM0000000500000080ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D
?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^0080ooK^00D000000?ofkP3om^h0ooK^0=@m6@09
0?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP0<
0?ofkPD0e3dI0P3om^h00`3D?AT0ooK^0?ofkP0V0?ofkP030000003om^h0ooK^02<0ooK^0@3oool0
0540ooK^0P0000050?ofkP040=@m6@3om^h0ooK^0=@m6@P0ooK^1P3D?AT40?ofkP030=@m6@3om^h0
ooK^0080ooK^00<0e3dI0?ofkP3om^h00`3om^h70=@m6@<0ooK^00<0e3dI0?ofkP3om^h01P3om^h0
0`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^00H0ooK^0P0000001@0;42H000000=@m6@0@
63/00000008041Pk00<0000001DPCP0E84h00P0E84h00`0000005B1>01DPCP02000000@07c1[00@0
000001l`J`0O<6/000000P0Y?XH00`3D?AT0:Cj602TnQP0202TnQP070000000Y?XH0:Cj60000000a
BY/00000035:V`080=@m6@8000000P0hE:d01@3D?AT0>5B]03QD[@0hE:d000000080o4PN0`0mFJ/0
0`000000o4PN0?a87P030?a87P030000003lB1h0o4PN0080o4PN00L000000?a87P3lB1h0o4PN03eI
Z`3lB1h0000000H0o4PN00@000000?a87P3lB1h0o4PN1`0000000`0mFJ/0mdHM0?M67@0603eIZ`80
mdHM00<000000?M67@3gAQd00`3gAQd00`000000mdHM03eIZ`050?M67@030000003gAQd0mdHM00D0
mdHM00@000000?M67@0mFJ/0mdHM1@0mFJ/60?M67@0303eIZ`3gAQd0000000H0mdHM0P0mFJ/60000
00<0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP050=@m6@3om^h0ooK^
0?ofkP000000103om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI
0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP0A0?ofkP<0e3dI9`3om^h00`000000ooK^0?ofkP0T
0?ofkP40oooo001@0?ofkP030000003om^h0000000D0ooK^00@0e3dI0?ofkP3om^h0e3dI3P3om^h6
0=@m6@<0ooK^00<0e3dI0?ofkP3om^h02P3om^h70=@m6@D0ooK^00<0e3dI0?ofkP3om^h0203om^h0
0`3D?AT0ooK^0?ofkP070?ofkP80000000D0?EV[0000003D?AT041Pk00000002010H>`030000000E
84h05B1>00805B1>00<0000001DPCP0E84h00P00000501l`J`070000000O<6/0000002TnQP3D?AT0
:Cj60000000402TnQP030000000Y?XH000000080<DZK00<00000035:V`0aBY/00P0aBY/010000000
<DZK035:V`0aBY/60=@m6@<0>5B]00<0000003eIZ`3lB1h00P3lB1h203eIZ`@0o4PN00<000000?a8
7P3lB1h00`3lB1h01P000000o4PN0?a87P0mFJ/0o4PN000000H0o4PN00<000000?a87P3lB1h0103l
B1h010000000o4PN0?a87P0mFJ/700000080mdHM1P0mFJ/20?M67@030000000mFJ/0mdHM00D0mdHM
00<000000?M67@0mFJ/02@0mFJ/30?M67@030000003gAQd0mdHM00@0mdHM00<0?EV[0?M67@000000
203gAQd00`000000e3dI0=@m6@020=@m6@8000000P3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m
6@3om^h0ooK^00/0ooK^00@0e3dI0?ofkP3om^h000001@3om^h00`3D?AT0ooK^0?ofkP060?ofkP03
0=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP03
0=@m6@3om^h0ooK^02@0ooK^00<000000?ofkP3om^h09@3om^h10?ooo`00D03om^h2000000H0ooK^
00<0e3dI0?ofkP3D?AT04`3om^h00`3D?AT0ooK^0=@m6@060=@m6@`0ooK^00@0e3dI0?ofkP3om^h0
ooK^1P3D?AT:0?ofkP030=@m6@3om^h0ooK^00L0ooK^0P0000000`0;42H0e3dI010H>`02010H>`04
0000000@63/00000000000@05B1>0P00000201l`J`030000000O<6/07c1[00807c1[0P00000202Tn
QP040=@m6@0Y?XH0:Cj6000000<0:Cj60P000004035:V`030000000aBY/0<DZK0080<DZK00T00000
035:V`0aBY/0000003QD[@000000>5B]0=@m6@0000000`3D?AT00`000000?EV[0?a87P020?a87P04
0000003lB1h0?EV[03eIZ`80o4PN00<000000?a87P3lB1h00`3lB1h00`000000o4PN03eIZ`030?a8
7P030000003lB1h0o4PN00<0o4PN00<000000?a87P3lB1h0103lB1h010000000o4PN0?a87P0mFJ/3
0?a87P040000003lB1h0o4PN0?a87PH000000P3gAQd<03eIZ`D0mdHM00<0000003eIZ`3gAQd0103g
AQd00`000000mdHM0?M67@050?M67@0303eIZ`000000mdHM00L0mdHM00<00000055ji00000000`00
00060=@m6@<0ooK^00<0e3dI0?ofkP3om^h02`3om^h0103D?AT0ooK^0?ofkP0000050?ofkP030=@m
6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP0D0?ofkP030=@m
6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h08`3om^h00`000000ooK^0?ofkP0V0?ofkP40oooo
001@0?ofkP8000001P3om^h00`3D?AT0ooK^0=@m6@0C0?ofkP030=@m6@3om^h0ooK^0080ooK^00@0
e3dI0?ofkP3om^h0ooK^203D?AT40?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3D?AT0
1P3D?AT30?ofkP030=@m6@3om^h0ooK^00L0ooK^0P0000000`0;42H0e3dI010H>`02010H>`040000
000@63/00000000000@05B1>0P00000301l`J`030000000O<6/07c1[00807c1[00@0000002TnQP0Y
?XH0e3dI0`0Y?XH01@000000:Cj602TnQP0Y?XH0000000D0<DZK00<00000035:V`0aBY/00P0aBY/0
1P000000<DZK0000000hE:d000000=@m6@80>5B]00D0000003QD[@0hE:d0>5B]000000040?a87P03
0000003lB1h0o4PN0080?EV[00<0o4PN0000003lB1h00`3lB1h00`000000o4PN03eIZ`030?a87P03
0000003lB1h0o4PN00<0o4PN00<000000?a87P3lB1h0103lB1h00`000000o4PN03eIZ`030?a87P03
0000003lB1h0o4PN00D0o4PN00<000000?a87P3lB1h0100000000`0mFJ/00000000000040?M67@03
0000003gAQd0mdHM00@0mdHM00<000000?M67@0mFJ/0103gAQd00`000000mdHM0?M67@050?M67@03
03eIZ`000000mdHM00H0mdHM0P0000000`1AN^@000000000000200000003041Q[@000000ooK^0080
ooK^00<0e3dI0?ofkP3D?AT01P3D?AT:0?ofkP030=@m6@3om^h0000000H0ooK^00<0e3dI0?ofkP3o
m^h01P3om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^01@0ooK^00<0e3dI0?ofkP3o
m^h04P3om^h00`3D?AT0ooK^0?ofkP0S0?ofkP030000003om^h0ooK^02L0ooK^0@3oool00500ooK^
0P0000050?ofkP040=@m6@3om^h0ooK^0=@m6A80ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0
ooK^0?ofkP090?ofkPP0e3dI103om^h00`3D?AT0ooK^0?ofkP060?ofkPP0e3dI103om^h300000003
00/@9P3D?AT041Pk008041Pk0P00000201DPCP030000000E84h05B1>00805B1>00D0000001l`J`0O
<6/07c1[0000000401l`J`80000000<0:Cj60=@m6@0Y?XH00`0Y?XH00`000000:Cj602TnQP020000
00@0<DZK00<00000035:V`0aBY/00P0aBY/2000000<0>5B]00D0e3dI03QD[@0hE:d0>5B]00000002
03QD[@030000003lB1h0o4PN0080o4PN00<000000?a87P3lB1h00P3lB1h203eIZ`@0o4PN00<00000
03eIZ`3lB1h00`3lB1h00`000000o4PN0?a87P030?a87P030000003lB1h0o4PN00@0o4PN00<00000
0?a87P0mFJ/00`3lB1h00`000000o4PN0?a87P040?a87P030000003lB1h0o4PN00<0o4PN00<00000
0?a87P0mFJ/00P3lB1h7000000@0mdHM00<0000003eIZ`3gAQd0103gAQd00`000000mdHM0?M67@05
0?M67@0303eIZ`3gAQd0mdHM00D0mdHM00<00000055ji01AN^@00P0000001@1;LM00000000000000
0000ooK^00H0e3dI0P3om^h0103D?AT0ooK^0?ofkP3om^h70=@m6@80ooK^00<0e3dI0?ofkP000000
1P3om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h0
503om^h00`3D?AT0ooK^0?ofkP0B0?ofkP030=@m6@3om^h0ooK^0280ooK^00<000000?ofkP3om^h0
:03om^h10?ooo`00D03om^h2000000D0ooK^00@0e3dI0?ofkP3om^h0e3dI4P3om^h00`3D?AT0ooK^
0?ofkP020?ofkP030=@m6@3om^h0ooK^00h0ooK^00@0e3dI0?ofkP3om^h0ooK^1`3D?AT90?ofkP03
0=@m6@3om^h0ooK^0080ooK^1P3D?AT0100;42H000000=@m6@000003010H>`040000000E84h05B1>
000000@05B1>0P00000301l`J`040000000O<6/07c1[00000080:Cj600<0e3dI02TnQP0Y?XH00`0Y
?XH00`000000:Cj600000002035:V`030000000aBY/0<DZK0080<DZK00<00000035:V`0aBY/00P0a
BY/01P000000>5B]03QD[@0hE:d0e3dI000000<0>5B]00@0000003QD[@0hE:d00000103lB1h00`00
0000o4PN0?a87P030?a87P80?EV[0`3lB1h00`0mFJ/0o4PN0?a87P020?a87P030000003lB1h0o4PN
00<0o4PN00<000000?a87P3lB1h0103lB1h00`000000?EV[0?a87P030?a87P030000003lB1h0o4PN
00@0o4PN00<000000?a87P3lB1h00`3lB1h00`000000?EV[0?a87P040?a87P030000003lB1h0o4PN
0080o4PN1@0000000`0mFJ/0mdHM0?M67@020?M67@030000003gAQd0mdHM00D0mdHM00<0?EV[0?M6
7@3gAQd01@3gAQd00`000000DG[T000000020000000404]ad00000000000000000D0ooK^00<0e3dI
0?ofkP3om^h01P3D?AT70?ofkPP0e3dI0`3om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0
ooK^00T0ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0
ooK^0280ooK^00<000000?ofkP3om^h0:03om^h10?ooo`00D03om^h2000000D0ooK^103D?ATB0?of
kP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP050?of
kP030=@m6@3om^h0ooK^00H0e3dI0`3om^h00`3D?AT0ooK^0?ofkP060?ofkP060000000;42H0e3dI
0000003D?AT000000`0@63/01@0000005B1>01DPCP0E84h0000000805B1>00<0000001l`J`000000
100O<6/00`0000007c1[0000000202TnQP030=@m6@000000:Cj600@0:Cj60P000003035:V`030000
000aBY/0<DZK0080<DZK00H00000035:V`0aBY/0000003QD[@00000203QD[@030=@m6@000000>5B]
0080>5B]00@0000003QD[@0hE:d00000103lB1h00`000000o4PN0?a87P030?a87P030000003lB1h0
?EV[0080?EV[00<000000?a87P3lB1h00P3lB1h00`000000o4PN0?a87P030?a87P030000003lB1h0
o4PN00<0o4PN00<000000?a87P0mFJ/0103lB1h00`000000o4PN0?a87P030?a87P030000003lB1h0
o4PN00<0o4PN00<000000?a87P0mFJ/01@3lB1h00`000000o4PN0?a87P040?a87P040000003lB1h0
?EV[0?a87PL00000103gAQd00`000000?EV[0?M67@050?M67@060000001AN^@00000055ji0000000
Bg7@100000050?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT0103om^h60=@m6@<0ooK^00<0e3dI0000
003om^h00`3om^h60=@m6@H0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP0C0?of
kP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h08@3om^h00`000000ooK^0?ofkP0Y0?of
kP40oooo001?0?ofkP030000003om^h0000000D0ooK^00<0e3dI0?ofkP3om^h0203D?AT;0?ofkP03
0=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP060?ofkP03
0=@m6@3om^h0ooK^00H0ooK^1P3D?AT60?ofkP060000000;42H02a0V0=@m6@0@63/000000`0@63/0
1@0000005B1>01DPCP0E84h0000000805B1>00@0000001l`J`0O<6/000000`0O<6/2000000<0:Cj6
00<0e3dI02TnQP0000001@0Y?XH00`000000<DZK035:V`02035:V`030000000aBY/0<DZK0080<DZK
00<00000035:V`0000000P0hE:d01@000000e3dI03QD[@0hE:d0000000<0>5B]00<0000003QD[@0h
E:d00`0000020?a87P030000003lB1h0o4PN0080o4PN00@000000?a87P3lB1h0o4PN0P0mFJ/40?a8
7P030000003lB1h0o4PN00<0o4PN00<000000?a87P3lB1h00`3lB1h00`000000o4PN03eIZ`030?a8
7P030000003lB1h0o4PN00@0o4PN00<000000?a87P3lB1h00`3lB1h00`000000?EV[0?a87P040?a8
7P030000003lB1h0o4PN00@0o4PN00@000000?a87P3lB1h0?EV[0`3lB1h00`000000o4PN0?a87P02
0?a87P@0000000<0?EV[000000000000103gAQd010000000DG[T0000001AN^@6000000H0ooK^00D0
e3dI0?ofkP3om^h0ooK^0=@m6@0:0?ofkPP0e3dI103om^h00`3D?AT0ooK^0?ofkP050=@m6@030?of
kP3D?AT0ooK^00/0ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m
6@3om^h0ooK^0200ooK^00<000000?ofkP3om^h0:P3om^h10?ooo`00C`3om^h2000000H0ooK^00<0
e3dI0?ofkP3D?AT0203om^h80=@m6@<0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?of
kP0=0?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?of
kP060=@m6@040000000;42H02a0V0=@m6@8041Pk00D00000010H>`0000005B1>0000000301DPCP03
0000000E84h0000000<07c1[00H0000001l`J`0O<6/07c1[0000000mFJ/202TnQP030=@m6@0Y?XH0
000000D0:Cj60P000003035:V`030000000aBY/0<DZK0080<DZK0P00000303QD[@030000003D?AT0
>5B]0080>5B]00H0000003QD[@0hE:d0>5B]0000000hE:d2000000030?m:7`000000000000<00000
0`3lB1h01@000000o4PN0?a87P0mFJ/0o4PN00<0?EV[0P3lB1h00`000000o4PN0?a87P020?a87P03
0000003lB1h0o4PN00<0o4PN00<0000003eIZ`3lB1h00`3lB1h00`000000o4PN0?a87P030?a87P03
0000003lB1h0o4PN00<0o4PN00<000000?a87P0mFJ/0103lB1h00`000000o4PN0?a87P050?a87P03
0000003lB1h0?EV[00<0o4PN00<000000?a87P3lB1h01@3lB1h00`000000o4PN03eIZ`020?a87P@0
000000<0DG[T000000000000100000000`0mFJ/000000?ofkP060?ofkP050=@m6@3om^h0ooK^0?of
kP3D?AT03@3om^h00`3D?AT0ooK^0?ofkP020?ofkPT0e3dI0`3om^h60=@m6@L0ooK^00<0e3dI0?of
kP3om^h0503om^h00`3D?AT0ooK^0?ofkP0B0?ofkP030=@m6@3om^h0ooK^0200ooK^00<000000?of
kP3om^h0:`3om^h10?ooo`00C`3om^h2000000H0ooK^00<0e3dI0?ofkP3D?AT0403om^h70=@m6@03
0?ofkP3D?AT0ooK^00h0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP03
0=@m6@3om^h0ooK^00D0ooK^00<0?EV[0=@m6@3D?AT01@3D?AT0100@63/0000001DPCP00000301DP
CP800000100O<6/0100000007c1[01l`J`0O<6/200000080:Cj600@0e3dI02TnQP0Y?XH000000`0Y
?XH010000000<DZK035:V`000003035:V`030000000aBY/0<DZK0080<DZK00<0000003QD[@0hE:d0
0P0hE:d01@3D?AT0>5B]03QD[@0hE:d0000000<0>5B]0P0000000`0nGK`000000?m:7`030?m:7`03
0000003oBQl0000000@0000000<0?EV[0000000000000`00000303eIZ`@0o4PN00<000000?a87P3l
B1h00`3lB1h00`000000?EV[0?a87P030?a87P030000003lB1h0o4PN00<0o4PN00<000000?a87P3l
B1h00`3lB1h00`000000?EV[0?a87P030?a87P030000003lB1h0o4PN00D0o4PN00@000000?a87P3l
B1h0?EV[0P3lB1h00`000000o4PN0?a87P050?a87P030000003lB1h0?EV[0080o4PN00D0?EV[0?a8
7P0000000000055ji00200000080DG[T0P0000000`0mFJ/000000?ofkP070?ofkP040=@m6@3om^h0
ooK^0=@m6@d0ooK^00<000000=@m6@3om^h01P3om^h00`3D?AT0ooK^0?ofkP030?ofkPD0e3dI103o
m^h50=@m6@80ooK^00<0e3dI0?ofkP3om^h0503om^h00`3D?AT0ooK^0?ofkP0B0?ofkP030=@m6@3o
m^h0ooK^01l0ooK^00<000000?ofkP3om^h0;03om^h10?ooo`00C`3om^h2000000H0ooK^00<0e3dI
0?ofkP3D?AT04`3om^h0103D?AT0ooK^0?ofkP3om^h70=@m6@X0ooK^00<0e3dI0?ofkP3om^h01@3o
m^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^00H0ooK^00D0?EV[0000000;42H02a0V
0=@m6@02010H>`030000003D?AT0e3dI00H0e3dI00<0000001l`J`0O<6/00`0O<6/01`0000007c1[
01l`J`000000:Cj60000003D?AT0100Y?XH010000000:Cj602TnQP000003035:V`050000000aBY/0
<DZK035:V`0000000`0aBY/2000000<0>5B]00<0e3dI0000000hE:d00P0hE:d01@000000>5B]03QD
[@0hE:d000000080?Ufl00D000000?m:7`3oBQl0odXO000000040?m:7`030000003oBQl0?EV[0080
odXO00<000000?m:7`3oBQl00`00000203eIZ`80o4PN00<000000?a87P3lB1h00`3lB1h00`0mFJ/0
o4PN0?a87P030?a87P030000003lB1h0o4PN0080o4PN00<000000?a87P3lB1h00`3lB1h00`000000
o4PN03eIZ`040?a87P030000003lB1h0o4PN00@0o4PN00@000000?a87P3lB1h0?EV[0P3lB1h00`00
0000o4PN0?a87P040?a87P8000000P3lB1h303eIZ`030?a87P000000000000<000000P1AN^@20000
000304]ad0000000000000P0ooK^00@0e3dI0?ofkP3om^h0e3dI303om^h00`000000ooK^0=@m6@07
0?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h01`3om^h60=@m6A<0ooK^00<0e3dI
0?ofkP3om^h04P3om^h00`3D?AT0ooK^0?ofkP0N0?ofkP030000003om^h0ooK^02d0ooK^0@3oool0
04l0ooK^0P0000050?ofkP030=@m6@3om^h0ooK^00@0e3dI403om^h01@3D?AT0ooK^0?ofkP3om^h0
e3dI00H0ooK^1`3D?AT30?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h02@3om^h0
0`3D?AT0ooK^0?ofkP060?ofkP80?EV[00<000000=@m6@0000000`0@63/01@0000005B1>01DPCP0E
84h0000000<05B1>203D?AT01@000000:Cj602TnQP0Y?XH0e3dI00D0:Cj60P000005035:V`070000
000aBY/0<DZK035:V`000000<DZK0000000203QD[@030000000hE:d0e3dI0080>5B]00T0000003QD
[@0hE:d0>5B]0000000hE:d0000003iM_00000000P0nGK`01@000000odXO0?m:7`3oBQl0000000@0
odXO00D0?EV[0?m:7`3oBQl0odXO000000040?m:7`030000003oBQl0odXO00<0?EV[0P0000030?a8
7P0303eIZ`3lB1h0o4PN0080o4PN00<000000?a87P3lB1h00`3lB1h00`000000o4PN0?a87P030?a8
7P030000000mFJ/0o4PN00<0o4PN00<000000?a87P3lB1h0103lB1h01`000000o4PN0?a87P3lB1h0
?EV[0?a87P0000001P3lB1h00`000000o4PN0?a87P0303eIZ`80o4PN00D000000=@m6@000000DG[T
00000003055ji0@00000203om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00`0ooK^00<000000?ofkP3D
?AT01P3om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00T0ooK^00@0e3dI0?ofkP3o
m^h0ooK^1`3D?AT;0?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h07P3om^h00`00
0000ooK^0?ofkP0]0?ofkP40oooo001?0?ofkP8000001@3om^h0103D?AT0ooK^0?ofkP3D?AT30?of
kPP0e3dI203om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00d0ooK^1`3D?AT30?ofkP030=@m6@3om^h0
ooK^00X0ooK^00<0e3dI0?ofkP3om^h01@3om^h01`0mFJ/0ooK^03eIZ`000000e3dI010H>`000000
0P0@63/00`0000005B1>01DPCP0201DPCP050000000E84h0000001l`J`0000001@0O<6/00`000000
e3dI0=@m6@050=@m6@@0:Cj600<00000035:V`0aBY/0100aBY/010000000<DZK035:V`0aBY/20000
00<0>5B]00<000000=@m6@0hE:d00P0hE:d01P000000>5B]03QD[@000000>5B]00000080?Ufl00@0
000003iM_00nGK`000000P3oBQl00`000000odXO0?m:7`020?m:7`0303eIZ`3oBQl0odXO0080odXO
00D000000?m:7`3oBQl0odXO000000040?m:7`060000000mFJ/0?EV[03eIZ`000000?EV[20000002
0?a87P030000003lB1h0o4PN00<0o4PN00<000000?a87P0mFJ/00`3lB1h00`000000o4PN0?a87P04
0?a87P070000003lB1h0o4PN0?a87P0mFJ/0o4PN000000060?a87PD0?EV[0P3lB1h200000004059l
j`3D?AT0DG[T00000080DG[T1P0000080?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT02`3om^h01000
0000ooK^0?ofkP3D?AT60?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h0203om^h0
0`3D?AT0ooK^0?ofkP090?ofkPP0e3dI0`3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0
ooK^01d0ooK^00<000000?ofkP3om^h0;P3om^h10?ooo`00C`3om^h2000000D0ooK^00@0e3dI0?of
kP3om^h0e3dI2`3om^h90=@m6@<0ooK^00<0e3dI0?ofkP3om^h03P3om^h0103D?AT0ooK^0?ofkP3o
m^h60=@m6@X0ooK^00<0e3dI0?ofkP3om^h01@3om^h303eIZ`040000003D?AT041Pk0000008041Pk
00<0000001DPCP0E84h00P0E84h00`0000005B1>0000000201l`J`030000000O<6/07c1[00<07c1[
00L0000002TnQP0Y?XH0:Cj60=@m6@0Y?XH0000000H0e3dI1P0aBY/01@000000<DZK035:V`0aBY/0
000000@0>5B]00<0e3dI03QD[@0hE:d00P0hE:d010000000>5B]03QD[@00000303iM_0040000000n
GK`0?Ufl000000<0odXO00H000000?m:7`3oBQl0?EV[0?m:7`0000030?m:7`050000003oBQl0odXO
0?m:7`000000103oBQl010000000odXO0?m:7`3oBQl603eIZ`040?m:7`000000odXO0?m:7`D00000
0`3lB1h00`000000?EV[0?a87P020?a87P030000003lB1h0o4PN00@0o4PN00<000000?a87P3lB1h0
0P3lB1h00`0mFJ/000000?a87P020?a87P@0?EV[103lB1h00`0mFJ/0o4PN00000002059lj`030=@m
6@00000000000080DG[T1P0000090?ofkP040=@m6@3om^h0ooK^0=@m6@`0ooK^00@000000?ofkP3o
m^h0e3dI1P3om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?of
kP3om^h04@3om^h70=@m6A80ooK^00<0e3dI0?ofkP3om^h0703om^h00`000000ooK^0?ofkP0_0?of
kP40oooo001>0?ofkP8000001P3om^h00`3D?AT0ooK^0=@m6@0C0?ofkPP0e3dI3P3om^h00`3D?AT0
ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00L0e3dI0`3om^h00`3D?AT0ooK^0?ofkP050?ofkP<0
?EV[00P000000=@m6@0@63/00000010H>`0000005B1>000000@05B1>00<0000001l`J`0O<6/00P0O
<6/00`0000007c1[01l`J`0201l`J`80000000<0:Cj60=@m6@0Y?XH00P0Y?XH010000000:Cj602Tn
QP000002035:V`H0e3dI00@0<DZK0000000aBY/0<DZK0P00000303QD[@030=@m6@000000>5B]0080
>5B]00<0000003QD[@0hE:d00P00000303iM_0040000000nGK`0?Ufl00000080odXO00H000000?m:
7`3oBQl0?EV[0?m:7`0000030?m:7`030000003oBQl0odXO0080odXO00D000000?m:7`3oBQl0odXO
000000030?m:7`0303eIZ`3oBQl0000000<0odXO200mFJ/00`3oBQl00000000000020000000503eI
Z`3lB1h0o4PN0?a87P0000001P3lB1h01P000000o4PN0?a87P3lB1h0?EV[000000@0?EV[0P3lB1h0
0`000000o4PN0?a87P020?a87P0703eIZ`3D?AT0e3dI0=@m6@000000DWc[0=@m6@03055ji0050000
001AN^@000000000001;LM00200000030?ofkP040=@m6@3om^h0ooK^0=@m6@/0ooK^00D000000?of
kP3om^h0ooK^0=@m6@050?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h0203om^h0
0`3D?AT0ooK^0?ofkP0D0?ofkP040=@m6@3om^h0ooK^0?ofkPL0e3dI2P3om^h00`3D?AT0ooK^0?of
kP0L0?ofkP030000003om^h0ooK^0300ooK^0@3oool004h0ooK^0P0000060?ofkP030=@m6@3om^h0
e3dI01<0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP060=@m6@P0ooK^00<0e3dI
0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP070?ofkPH0e3dI103om^h403eIZ`080=@m6@0@63/0
41Pk0000000@63/0000001DPCP00000401DPCP030000000O<6/07c1[00<07c1[00@0000001l`J`0O
<6/000000P0Y?XH00`000000e3dI02TnQP0302TnQP800000100aBY/00`000000<DZK035:V`02035:
V`H0e3dI0P000000103D?AT0>5B]03QD[@00000303QD[@8000000P0nGK`01@000000?Ufl03iM_00n
GK`000000080?Ufl00D000000?m:7`3oBQl0000003eIZ`030?m:7`040000003oBQl0odXO000000@0
odXO00D000000?m:7`3oBQl0odXO000000030?m:7`0303eIZ`000000odXO00<0odXO00<000000?m:
7`3oBQl00P3oBQl00`000000odXO0?m:7`0F03eIZ`@0o4PN0P0000050?a87P040000001BO>/00000
000000H0e3dI00@0DG[T000000000000Bg7@0P0000000`3D?AT0ooK^0?ofkP040?ofkP<0000000@0
e3dI000000000000e3dI2P3om^h00`000000ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00<0ooK^
00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^01<0ooK^
00<0e3dI0?ofkP3om^h02@3om^h70=@m6@<0ooK^00<0e3dI0?ofkP3om^h06`3om^h00`000000ooK^
0?ofkP0a0?ofkP40oooo001>0?ofkP8000001P3om^h40=@m6A80ooK^00<0e3dI0?ofkP3om^h00P3o
m^h00`3D?AT0ooK^0?ofkP060?ofkPH0e3dI0P3om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3o
m^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h01P3D?AT203eIZ`040=@m6@0@63/041Pk010H>`800000
0P0E84h0100000005B1>01DPCP0E84h2000000@07c1[00@0000001l`J`0O<6/000000`0Y?XH00`3D
?AT0:Cj602TnQP0302TnQP030000000aBY/0<DZK00<0<DZK0P000005035:V`030000000hE:d0>5B]
00H0e3dI00D0000003QD[@0hE:d0>5B]0000000303iM_0050000000nGK`0?Ufl03iM_00000000P0n
GK`010000000odXO0?m:7`0mFJ/30?m:7`050000003oBQl0odXO0?m:7`0000000`3oBQl01@000000
odXO0?m:7`3oBQl000000080odXO00<0?EV[0?m:7`000000103oBQl00`000000odXO0?m:7`020?m:
7`030000003oBQl0odXO0080odXO00<0000003eIZ`3oBQl00P3oBQl010000000odXO0?m:7`3oBQl8
0000000303eIZ`000000000000<0o4PN00<000000?a87P3lB1h0103lB1h00`000000DWc[00000002
059lj`060000001AN^@0e3dI0000001AN^@0?EV[3@3D?AT30?ofkP040=@m6@3om^h0ooK^0=@m6@H0
0000103om^h00`000000ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3o
m^h02@3om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^01@0ooK^00<0e3dI0?ofkP3o
m^h0403om^h40=@m6A`0ooK^00<000000?ofkP3om^h0<P3om^h10?ooo`00CP3om^h2000000H0ooK^
00@0e3dI0?ofkP3D?AT0ooK^1`3D?AT;0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT03`3om^h60=@m
6@80ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP030?ofkP<0?EV[103D?AT2010H
>`050000000E84h05B1>01DPCP0000000P0E84h0100000007c1[01l`J`00000401l`J`8000000`0Y
?XH0103D?AT0:Cj600000000000302TnQP8000001P0aBY/01`000000<DZK035:V`0aBY/0000003QD
[@0000000`0hE:d0103D?AT0000003QD[@0hE:d60=@m6@<0?Ufl00L0000003iM_00nGK`0?Ufl0000
000nGK`000000080odXO00<0?EV[0?m:7`3oBQl00P3oBQl010000000odXO0?m:7`0000030?m:7`03
0000003oBQl0odXO0080odXO00D000000?m:7`0mFJ/0odXO000000040?m:7`050000003oBQl0odXO
0?m:7`000000103oBQl00`000000odXO03eIZ`020?m:7`030000003oBQl0odXO00@0odXO00<00000
0?m:7`3oBQl00P3oBQl010000000?EV[0?m:7`3oBQl5000000<0o4PN0P0000000`1BO>/00000059l
j`03000000040=@m6@000000DG[T03eIZ`8000000P1;LM0200000080ooK^3@3D?AT60?ofkP@00000
1@3om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h0
1`3om^h00`3D?AT0ooK^0?ofkP0D0?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h0
6P3om^h00`000000ooK^0?ofkP0b0?ofkP40oooo001>0?ofkP8000001P3om^h20=@m6@T0ooK^203D
?AT30?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT0403om^h00`3D?AT0ooK^0?ofkP020?ofkPH0e3dI
2P3om^h00`3D?AT0ooK^0?ofkP030?ofkPD0?EV[00D0e3dI03eIZ`0@63/041Pk0000000401DPCP03
0000000E84h0000000<07c1[00<0000001l`J`0O<6/00P0O<6/01@000000:Cj602TnQP0Y?XH0e3dI
00<0:Cj600<0000002TnQP0000000P0aBY/2000000D0<DZK00@00000035:V`0aBY/000000P0hE:d2
000000040=@m6@0hE:d0>5B]000000<0>5B]0P00000203iM_0H0e3dI0P0nGK`01P000000?Ufl0000
003oBQl0?EV[000000<0odXO00@000000?m:7`3oBQl000000`3oBQl00`000000odXO0?m:7`020?m:
7`050000000mFJ/0odXO0?m:7`0000000`3oBQl00`000000odXO0?m:7`020?m:7`030000003oBQl0
odXO0080odXO00<0000003eIZ`3oBQl00P3oBQl00`000000odXO0?m:7`030?m:7`030000003oBQl0
odXO0080odXO00<0000003eIZ`3oBQl00P3oBQl2000000<0odXO0`0000001P1BO>/000000000001B
O>/00000059lj`80000000D0e3dI055ji0000000DG[T0000000204]ad0<000002P3om^h;0=@m6@<0
ooK^00<000000?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00X0
ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^01<0
ooK^00<0e3dI0?ofkP3om^h06P3om^h00`000000ooK^0?ofkP0c0?ofkP40oooo001>0?ofkP800000
1P3om^h20=@m6A40ooK^203D?AT@0?ofkP030=@m6@3om^h0ooK^00@0ooK^00@0e3dI0?ofkP3om^h0
ooK^203D?AT20?ofkP030=@m6@3om^h0ooK^00<0ooK^0`0mFJ/0103om^h0e3dI0?ofkP0mFJ/2010H
>`8000000`0E84h2000000@07c1[00L0000001l`J`0O<6/07c1[0000000Y?XH000000080:Cj600<0
e3dI02TnQP0Y?XH00P0Y?XH2000000@0<DZK00<00000035:V`0aBY/00`0aBY/2000000D0>5B]00@0
e3dI03QD[@0hE:d0>5B]0P00000203QD[@050000000nGK`0?Ufl03iM_00000000`0nGK`00`000000
e3dI0=@m6@030=@m6@<0000000L0e3dI0?m:7`3oBQl0odXO0000003oBQl0000000<0odXO00<00000
0?m:7`3oBQl00P3oBQl01@000000?EV[0?m:7`3oBQl0000000<0odXO00D000000?m:7`3oBQl0odXO
000000040?m:7`030000003oBQl0?EV[0080odXO00<000000?m:7`3oBQl00`3oBQl010000000odXO
0?m:7`3oBQl20000000503eIZ`3oBQl0odXO0?m:7`0000001@3oBQl200000005059lj`000000DWc[
059lj`0000000P1BO>/01P000000DG[T0=@m6@000000DG[T00000080Bg7@0`00000<0?ofkP030=@m
6@3om^h0e3dI0080ooK^2`3D?AT30?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h0
2P3om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h0
4`3om^h00`3D?AT0ooK^0?ofkP0I0?ofkP030000003om^h0ooK^03@0ooK^0@3oool004d0ooK^0P00
00060?ofkP030=@m6@3om^h0e3dI0080e3dI4P3om^h0103D?AT0ooK^0?ofkP3om^h70=@m6@X0ooK^
00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP090?ofkPP0e3dI0P0mFJ/20?ofkP070=@m
6@0mFJ/00000010H>`0000005B1>0000000401DPCP030000000O<6/07c1[00<07c1[00@0000001l`
J`0O<6/000000P0Y?XH00`000000e3dI02TnQP0502TnQP030000000aBY/0<DZK00<0<DZK00<00000
035:V`0aBY/00`0aBY/00`000000>5B]03QD[@0303QD[@030=@m6@000000>5B]00<0>5B]0P000000
0`0nGK`0000003iM_00203iM_0050000000nGK`0?Ufl03iM_00000000P0nGK`20000000304=Ub@00
0000000000<0000000D0e3dI000000000000odXO000000030?m:7`050000003oBQl0odXO0?m:7`0m
FJ/00`3oBQl01@000000odXO0?m:7`3oBQl0000000<0odXO00L000000?m:7`3oBQl0odXO0000003o
BQl0?EV[0080odXO00<000000?m:7`3oBQl00`3oBQl01@000000odXO0?m:7`3oBQl000000080odXO
00@0?EV[0?m:7`0000000000103oBQl200000004055jj`0000000000059lj`80000000L0DWc[0000
00000000DG[T0=@m6@000000DG[T0080000000@0Bg7@0000001;LM0000003@3om^h20=@m6@P0ooK^
303D?AT20?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^
0?ofkP0D0?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h0603om^h00`000000ooK^
0?ofkP0e0?ofkP40oooo001=0?ofkP8000001P3om^h00`3D?AT0ooK^0=@m6@020?ofkPH0e3dI303o
m^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00H0ooK^1`3D?AT30?ofkP030=@m6@3om^h0ooK^00<0ooK^
00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP020?ofkP0303eIZ`3D?AT0e3dI00H0e3dI
00@0000001DPCP0E84h000000`0E84h2000000D07c1[0P00000402TnQP030=@m6@0Y?XH0:Cj600@0
:Cj60P000005035:V`030000000aBY/0<DZK0080<DZK0`00000203QD[@040=@m6@0hE:d0>5B]0000
00@0>5B]00<0000003iM_00nGK`00P00000203iM_08000000P0nGK`010000000?Ufl03iM_0000002
04=Ub@030000003oBb0000000080od/P00<000000?m;800000000P0000020?m:7`050000003oBQl0
odXO0=@m6@0mFJ/00P3oBQl00`000000odXO0?m:7`020?m:7`040000003oBQl0odXO000000@0odXO
00D000000?m:7`0mFJ/0odXO000000040?m:7`8000000`3oBQl01P000000odXO0?m:7`0mFJ/0odXO
000000D0odXO00@00000055jj`1AN^/000000P1BO>/01@000000DWc[000000000000DWc[00800000
00L0e3dI000000000000000004]ad0000000Bg7@008000003@3om^h20=@m6@/0ooK^00<000000?of
kP3om^h01@3D?AT00`3om^h0e3dI0=@m6@040=@m6@T0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D
?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h0603om^h00`00
0000ooK^0?ofkP0f0?ofkP40oooo001=0?ofkP8000001P3om^h00`3D?AT0ooK^0=@m6@080?ofkPH0
e3dI1P3om^h0103D?AT0ooK^0?ofkP3D?AT>0?ofkPL0e3dI0P3om^h00`3D?AT0ooK^0?ofkP0<0?of
kP030=@m6@3om^h0ooK^0080ooK^0P0mFJ/30?ofkP040=@m6@0mFJ/0ooK^000000P0e3dI00<07c1[
0000000O<6/0100O<6/00`000000:Cj602TnQP0202TnQP030=@m6@000000000000<0:Cj600<00000
035:V`0aBY/00P000004035:V`80000000<0<DZK0000000hE:d00P0hE:d00`000000>5B]0=@m6@03
03QD[@8000000P0hE:d2000000<0?Ufl00D0000003iM_00nGK`0?Ufl0000000203iM_080000000d0
@fG900000013ILT000000?m;80000000od/P03eIZ`3oBb0000000?m;80000000od/P00D0000000D0
?EV[000000000000odXO000000030?m:7`050000003oBQl0odXO0?m:7`0000000`3oBQl01@000000
odXO03eIZ`3oBQl0000000@0odXO00<000000?m:7`3oBQl00P3oBQl01P000000odXO0?m:7`3oBQl0
?EV[000000@0odXO0P000000201AN^/00000000000000000DWc[0000001BO>/000000P1BO>/20000
00040=@m6@000000DG[T055ji080000000<0Bg7@0000000000003P3om^h20=@m6@/0ooK^00<00000
0?ofkP3om^h00`3om^h00`3D?AT0ooK^0=@m6@050=@m6@030?ofkP3D?AT0e3dI00@0e3dI0`3om^h0
0`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h04`3om^h0
0`3D?AT0ooK^0?ofkP0G0?ofkP030000003om^h0ooK^03L0ooK^0@3oool004d0ooK^0P0000060?of
kP@0e3dI3@3om^h60=@m6@<0ooK^00<0e3dI0?ofkP3om^h03`3om^h0103D?AT0ooK^0?ofkP3om^h7
0=@m6@X0ooK^00@0e3dI0?ofkP3om^h0ooK^0`0mFJ/20?ofkP050=@m6@0mFJ/0ooK^0?ofkP000000
100E84h0100000005B1>0000000O<6/80=@m6@040000000Y?XH0:Cj60=@m6@<0:Cj600@0000002Tn
QP0Y?XH00000100aBY/00`000000<DZK035:V`03035:V`800000100hE:d00`000000e3dI03QD[@04
03QD[@8000000P0nGK`200000080?Ufl00D0000003iM_00nGK`0?Ufl0000000203iM_00900000013
ILT0@fG900000013ILT000000?m;80000000od/P00<0?EV[00D0od/P0000003oBb00od/P00000002
0?m;800303eIZ`000000od/P00L0000000<0odXO0000003oBQl00`3oBQl01@000000odXO03eIZ`3o
BQl0000000<0odXO00<000000?m:7`3oBQl00P3oBQl01P000000odXO0?m:7`3oBQl0?EV[000000<0
odXO0P000000101AN^/000000000001AN^/5000000<0DWc[00<00000055ji03D?AT00P1AN^@20000
000404]ad00000000000000000h0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`000000ooK^0?ofkP02
0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT00`3om^h;0=@m6@P0ooK^00<0e3dI0?ofkP3om^h04`3o
m^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^01L0ooK^00<000000?ofkP3om^h0=`3o
m^h10?ooo`00C@3om^h2000000H0ooK^0P3D?AT20?ofkPL0e3dI2`3om^h80=@m6@h0ooK^00<0e3dI
0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP020?ofkPL0e3dI0`3om^h0103D?AT0ooK^0?ofkP3o
m^h303eIZ`80ooK^00<0e3dI03eIZ`3om^h00P3om^h0100000005B1>01DPCP0E84h2000000D07c1[
00D0000001l`J`0O<6/07c1[000000060=@m6@80:Cj60P000006035:V`030000000aBY/0<DZK00<0
<DZK00<0000003QD[@0hE:d00P0hE:d00`3D?AT000000000000503QD[@030000000nGK`0?Ufl0080
?Ufl00@0000003iM_00nGK`000000`0nGK`20000000904=Ub@000000e3dI04=Ub@000000@fG90000
003oBb0000000080od/P00<0000003eIZ`0mFJ/00P0mFJ/01@000000od/P03eIZ`3oBb0000000080
od/P00H000000?m;803oBb00od/P0000003oBb070000000303eIZ`3D?AT0000000<0odXO00@00000
0?m:7`3oBQl0odXO0P0000030?m:7`030000000mFJ/0odXO0080odXO00@00000055jj`0000000000
0`1AN^/3000000<0DWc[100000001@3D?AT0DG[T055ji0000000Bg7@00<000003`3om^h20=@m6@`0
ooK^00<000000?ofkP3om^h00P3om^h0103D?AT0ooK^0?ofkP3D?AT;0?ofkPP0e3dI0`3om^h00`3D
?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h05`3om^h00`00
0000ooK^0?ofkP0h0?ofkP40oooo001=0?ofkP8000001P3om^h20=@m6@T0ooK^203D?AT30?ofkP05
0=@m6@3om^h0ooK^0?ofkP3D?AT00`3om^h80=@m6@H0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D
?AT0ooK^0?ofkP0:0?ofkPL0e3dI0`0mFJ/20?ofkP030=@m6@0mFJ/0ooK^0080ooK^00<0000001DP
CP0E84h00P0E84h00`0000007c1[01l`J`0401l`J`030000000O<6/0000000<0:Cj600@000000=@m
6@0Y?XH0:Cj61P3D?AT5035:V`8000000P0aBY/010000000>5B]00000000000203QD[@040=@m6@0h
E:d0>5B]000000<0>5B]00@0000003iM_000000000000`0nGK`00`000000?Ufl03iM_00200000080
?Ufl00@0000004=Ub@13ILT0e3dI0P13ILT01`000000@fG90000003oBb0000000?m;800000000P3o
Bb000`000000od/P03eIZ`0403eIZ`80od/P00@000000?m;803oBb0000000P3oBb001@000000od/P
0?m;803oBb0000000080od/P00<0?EV[000000000000100000000`3oBQl0e3dI000000030?m:7`80
000000<0?EV[0?m:7`3oBQl00P0000000`1AN^/00000055jj`02055jj`<000000`1BO>/200000005
059lj`000000DG[T0=@m6@1AN^@0100000000`1;LM0000000?ofkP0>0?ofkP030=@m6@3om^h0e3dI
00`0ooK^00<000000?ofkP3om^h00P3om^h0103D?AT0ooK^0?ofkP3D?AT>0?ofkP030=@m6@3om^h0
ooK^0080ooK^1`3D?ATB0?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h05P3om^h0
0`000000ooK^0?ofkP0i0?ofkP40oooo001=0?ofkP030000003om^h0ooK^00D0ooK^1@3D?AT>0?of
kPL0e3dI303om^h80=@m6@<0ooK^00<0e3dI0?ofkP3om^h03@3om^h0103D?AT0ooK^0?ofkP0mFJ/8
0=@m6@<0ooK^00@0000001DPCP0E84h05B1>0P00000601l`J`8000000`0Y?XH00`3D?AT000000000
000302TnQP040000000aBY/00000000000H0e3dI00@0<DZK0000000aBY/000000`0hE:d200000004
0=@m6@0hE:d0>5B]03QD[@80000000<0>5B]0000000nGK`00P0nGK`01@000000?Ufl03iM_00nGK`0
000000<0?Ufl0P0000001`13ILT0000004=Ub@3D?AT0000004=Ub@0000000P13ILT200000080od/P
00<000000?m;800000000P3oBb00100mFJ/0od/P0?m;8000000503eIZ`040000003oBb00od/P0000
0080od/P00D000000?m;803oBb00?EV[000000020?m;808000000P3oBb0700000080odXO0P000000
0`1AN^/0000000000002055jj`<000000`1BO>/200000080DWc[00@00000055ji01AN^@0e3dI0`00
000204]ad08000003`3om^h00`3D?AT0ooK^0=@m6@0<0?ofkP030000003om^h0ooK^0080ooK^00@0
e3dI0?ofkP3om^h0e3dI3P3om^h00`3D?AT0ooK^0?ofkP050?ofkP040=@m6@3om^h0ooK^0?ofkPL0
e3dI2`3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^01D0ooK^00<000000?ofkP3o
m^h0>P3om^h10?ooo`00C03om^h2000000L0ooK^0`3D?AT20?ofkPP0e3dI2@3om^h00`3D?AT0ooK^
0?ofkP080=@m6@/0ooK^00<0e3dI0?ofkP3D?AT01P3D?AT<0?ofkP030=@m6@3om^h0ooK^0080?EV[
00L0ooK^03eIZ`3om^h0e3dI03eIZ`3om^h0?EV[00D0e3dI0P0E84h00`0000007c1[0000000601l`
J`050000000Y?XH0:Cj602TnQP3D?AT00P0Y?XH010000000:Cj602TnQP000003035:V`800000100a
BY/60=@m6@80>5B]00<0e3dI0000000hE:d0100hE:d00`000000?Ufl03iM_00303iM_08000000P0n
GK`200000080?Ufl00T0000004=Ub@13ILT0e3dI00000013ILT0000004=Ub@0000000P13ILT20000
00040?m;80000000od/P00000080od/P00@0?EV[0?m;803oBb0000000P3oBb000`000000od/P0000
000603eIZ`040000003oBb00od/P03eIZ`80od/P00<000000?m;800mFJ/0100mFJ/00`3oBb000000
000000020?m;8080000000<0DG[[0000003D?AT01@3D?AT00`1AN^/00000059lj`0200000080DWc[
0P000002055ji0040000003D?AT0DG[T00000080Bg7@0P0000030=@m6@d0ooK^00<0e3dI0?ofkP3D
?AT0303om^h00`000000ooK^0?ofkP020?ofkP030=@m6@3om^h0e3dI00l0ooK^00<0e3dI0?ofkP3o
m^h0103om^h00`3D?AT0ooK^0?ofkP090?ofkPL0e3dI0`3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP03
0=@m6@3om^h0ooK^01D0ooK^00<000000?ofkP3om^h0>`3om^h10?ooo`00C03om^h2000000L0ooK^
00<0e3dI0?ofkP3om^h01P3D?AT40?ofkPP0e3dI00@0ooK^0=@m6@3om^h0e3dI203om^h80=@m6@<0
ooK^00<0e3dI0?ofkP3om^h00P3om^h0103D?AT0ooK^0?ofkP3om^h80=@m6@@0ooK^00<0e3dI0?of
kP3om^h00P0mFJ/01`3om^h0?EV[0?ofkP3D?AT0?EV[0?ofkP0mFJ/0103om^h00`0mFJ/000000000
000301l`J`030000000O<6/07c1[00<07c1[0P00000202TnQP040=@m6@0Y?XH0:Cj602TnQP800000
1P0aBY/00`000000<DZK035:V`03035:V`<0000000<0>5B]0=@m6@3D?AT0103D?AT303QD[@<00000
1@0nGK`200000080?Ufl0P0000001`13ILT0000004=Ub@3D?AT0@fG900000013ILT00`0000002P13
ILT000000?m;80000000od/P0000003oBb00000003eIZ`0000020?m;80030000003oBb0000000080
od/P00@000000?m;803oBb0000000P3oBb000`000000?EV[03eIZ`0603eIZ`040?m;80000000od/P
0?m;808000000P3oBb0500000080DG[[0`000002055jj`P0e3dI00H00000055ji0000000e3dI055j
i000000204]ad0<000000`3om^h60=@m6@H0ooK^00@0e3dI0?ofkP3om^h0e3dI303om^h00`000000
ooK^0?ofkP020?ofkP030=@m6@3om^h0e3dI00l0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0
ooK^0?ofkP0@0?ofkPL0e3dI4P3om^h00`3D?AT0ooK^0?ofkP0D0?ofkP030000003om^h0ooK^03`0
ooK^0@3oool004`0ooK^0P0000070?ofkP@0e3dI1@3om^h50=@m6@L0ooK^1P3D?AT>0?ofkPP0e3dI
303om^h80=@m6@0503eIZ`3om^h0ooK^0=@m6@0mFJ/00`3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[
00800000100O<6/01@0000007c1[01l`J`0O<6/000000080:Cj600<000000=@m6@0Y?XH0100Y?XH0
0`000000<DZK035:V`05035:V`8000000P0aBY/010000000>5B]03QD[@0hE:d20000000303QD[@3D
?AT0>5B]0080>5B]203D?AT503iM_0040000000nGK`0?Ufl000000<0@fG900<0e3dI04=Ub@13ILT0
0P0000001P13ILT0000000000013ILT000000?m;8080000000/0od/P0000000mFJ/0od/P0000003o
Bb0000000?m;80000000od/P000000020?m;80040000003oBb00od/P00000080od/P00@0?EV[0?m;
8000000000000P3oBb02000000030?m;8000000000000080od/P0P00000204mgiP030000001AN^/0
DG[[00<00000101AN^/00`000000DWc[059lj`0200000080DWc[00<000000=@m6@3D?AT01@3D?AT3
000000030=@m6@3om^h0ooK^00L0ooK^1`3D?AT20?ofkP030=@m6@3om^h0ooK^00X0ooK^00<00000
0?ofkP3om^h00P3om^h20=@m6A00ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP0C
0?ofkP040=@m6@3om^h0ooK^0?ofkPL0e3dI2`3om^h00`3D?AT0ooK^0?ofkP0D0?ofkP030000003o
m^h0ooK^03`0ooK^0@3oool004`0ooK^0P00000;0?ofkPP0e3dI0P3om^h60=@m6@80ooK^00<0e3dI
0?ofkP3D?AT00P3om^h60=@m6@/0ooK^00@0e3dI0?ofkP3om^h0ooK^1`3D?AT:0?ofkP040=@m6@3o
m^h0?EV[03eIZ`L0e3dI00D0ooK^03eIZ`3om^h0ooK^03eIZ`020?ofkP030000000O<6/07c1[00<0
7c1[00@0000001l`J`0O<6/000000`0Y?XH00`3D?AT0000002TnQP0302TnQP<000001`0aBY/30000
00D0>5B]00<0e3dI0000000hE:d0100hE:d2000000@0?Ufl203D?AT3000000040=@m6@13ILT00000
00000080@fG900D0000004=Ub@000000000004=Ub@020000000<0?m;80000000?EV[0000003oBb00
00000?m;80000000od/P0000003oBb0000000P3oBb000`000000od/P000000020?m;80030000000m
FJ/0000000<0od/P00@000000?m;803oBb0000000P3oBb020000000504mgiP3D?AT000000000001A
N^/00`000003055jj`<0000000<0DWc[000000000000101BO>/01@000000DG[T055ji0000000e3dI
0080000000<0Bg7@0=@m6@3D?AT01@3D?AT<0?ofkPH0e3dI2P3om^h00`000000ooK^0?ofkP020?of
kP80e3dI403om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?of
kP3om^h02@3om^h70=@m6@<0ooK^00<0e3dI0?ofkP3om^h0503om^h00`000000ooK^0?ofkP0m0?of
kP40oooo001<0?ofkP8000004`3om^h>0=@m6@L0ooK^1P3D?AT50?ofkP050=@m6@3om^h0ooK^0?of
kP3D?AT01P3om^h70=@m6@<0ooK^00@0e3dI0?ofkP0mFJ/0?EV[0`3om^h0103D?AT0?EV[0?ofkP3o
m^h80=@m6@030000000O<6/07c1[00<07c1[0P00000402TnQP030=@m6@0Y?XH000000080:Cj600@0
0000035:V`0aBY/0<DZK0P000007035:V`800000100hE:d0103D?AT0>5B]00000000000303QD[@04
0000000nGK`00000000000@0?Ufl0P00000403iM_0L0e3dI0P0000000`13ILT0000004=Ub@020000
000304M[e0000000000000D0000000<0od/P0000003oBb000P0000020?m;80080000003oBb00od/P
0000003oBb00000003eIZ`0000020?m;8080000000@0od/P000000000000od/P0P0000001@1?MnH0
00000000003D?AT0CgOV00<000000P1AN^/300000080DG[[0P000003059lj`<0000000@0DG[T0000
00000000e3dI0P00000204]ad080000000<0ooK^0=@m6@3om^h00P3om^h80=@m6@<0ooK^00D0e3dI
0?ofkP3om^h0ooK^0=@m6@020?ofkPH0e3dI103om^h00`000000ooK^0?ofkP020?ofkP80e3dI403o
m^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h0403o
m^h40=@m6AD0ooK^00<000000?ofkP3om^h0?P3om^h10?ooo`00C03om^h00`000000ooK^0?ofkP0J
0?ofkPd0e3dI1P3om^h60=@m6@80ooK^00<0e3dI0?ofkP3om^h0303om^h70=@m6@80ooK^00<0e3dI
03eIZ`0mFJ/0103om^h00`0mFJ/0ooK^03eIZ`030?ofkPP0e3dI0`0Y?XH0103D?AT0:Cj602TnQP0Y
?XH3000000D0<DZK0P000004035:V`030000000hE:d0>5B]00<0000000<0>5B]0=@m6@0hE:d00P0h
E:d3000000@0?Ufl0P00000403iM_080000000L0?Ufl00000013ILT0@fG90000003D?AT0@fG90080
00001P3D?AT20000000304M[e000000000000080000000<0od`P000000000000100000020?m;8004
0000003oBb0000000?m;8080000000D0?EV[0?m;803oBb0000000?m;8002000000030?m;80000000
0000008000000P1?MnH01@3D?AT00000000000000000DG[[00<00000101AN^/010000000DWc[059l
j`1BO>/200000080DWc[0P000002055ji0040=@m6@000000Bg7@04]ad08000000P3om^h00`3D?AT0
ooK^0?ofkP090?ofkPH0e3dI00<0ooK^0=@m6@3om^h01`3om^h60=@m6@<0ooK^00<0e3dI0?ofkP3o
m^h03`3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^01@0ooK^00<0e3dI0?ofkP3o
m^h04`3om^h00`3D?AT0ooK^0?ofkP0B0?ofkP030000003om^h0ooK^03l0ooK^0@3oool004/0ooK^
0P00000S0?ofkPh0e3dI0`3om^h70=@m6@h0ooK^00@0e3dI0?ofkP0mFJ/0?EV[1`3D?AT20?ofkP03
03eIZ`3om^h0?EV[00D0ooK^00H0e3dI01l`J`0O<6/07c1[0000000Y?XH60=@m6@<0:Cj600<00000
035:V`0aBY/01@0aBY/200000080<DZK00<0000003QD[@0hE:d00`0hE:d00`3D?AT0000003QD[@04
03QD[@8000001@0nGK`3000000<0?Ufl0P00000204=Ub@050=@m6@13ILT0000000000013ILT00P00
00001013ILT0000000000013ILT30000000404M[e000000000000?m<8080000000<0od`P0000003o
C2002@0000000`3oBb00?EV[00000003000000030?m;8000000000000080000000L0CgOV00000000
000000000=@m6@000000DG[[008000000`1AN^/400000080DWc[0P000003059lj`060000001AN^@0
DG[T055ji03D?AT000000P1;LM03000000<0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^
0?ofkP050=@m6@T0ooK^00<000000?ofkP3D?AT01`3D?AT=0?ofkP030=@m6@3om^h0ooK^0080ooK^
00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^0180ooK^
00<000000?ofkP3om^h0@03om^h10?ooo`00B`3om^h2000002X0ooK^3P3D?AT30?ofkPP0e3dI1P3o
m^h0103D?AT0?EV[03eIZ`0mFJ/20?ofkP030=@m6@0mFJ/0ooK^0080ooK^1`3D?AT30?ofkP050=@m
6@0000007c1[01l`J`0000000`0Y?XH0103D?AT0:Cj602TnQP0Y?XH60=@m6@L0<DZK0`00000503QD
[@030=@m6@0hE:d000000080000000@0>5B]0000000nGK`0?Ufl0`00000503iM_080000000H0?Ufl
00000013ILT0@fG90000003D?AT304=Ub@80000000H0@fG9000000000000@fG900000017Jm@30000
000504M[e000000000000000003oC200100000001@3oC20000000?m<80000000od`P0080000000<0
od`P0000000000001P0000000`1?MnH00000000000020000000304mgiP3D?AT0CgOV008000000P1A
N^/3000000<0DG[[0`000002059lj`<000000`1AN^@00`000000e3dI00000004000000@0ooK^00<0
e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP020?ofkP040=@m6@3om^h0ooK^0?ofkPH0e3dI
0`3om^h00`000000ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^0080ooK^2@3D?AT40?ofkP030=@m
6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m
6@3om^h0ooK^0140ooK^00<000000?ofkP3om^h0@@3om^h10?ooo`00B`3om^h200000380ooK^3@3D
?AT40?ofkPP0e3dI0P0mFJ/0103om^h0e3dI0?ofkP0mFJ/60?ofkP0403eIZ`3om^h0ooK^0?ofkPD0
e3dI00<0?EV[0000000Y?XH00`0Y?XH00`3D?AT000000000000302TnQP040000000aBY/0<DZK035:
V`H0e3dI0P0aBY/00`000000>5B]0000000200000080>5B]00<0e3dI03QD[@0hE:d00P0hE:d30000
00@0?Ufl0`00000403iM_0<0000000@0@fG90=@m6@13ILT0@fG90P0000001@0mFJ/0@fG900000000
0000@fG900@0000000<0Af_D000000000000200000000`3oC20000000000000200000080od`P3000
00001P1?MnH000000000003D?AT00000055jj`<000001@1AN^/200000004059lj`00000000000000
0080DWc[00D00000055ji000000000000=@m6@020000000304]ad0000000000000D0ooK^00<0e3dI
0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00L0ooK^1@3D?AT2
0?ofkP80e3dI3@3om^h50=@m6@<0ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP0D
0?ofkP030=@m6@3om^h0ooK^0140ooK^00<000000?ofkP3om^h0@@3om^h10?ooo`00B`3om^h20000
03T0ooK^3P3D?AT30?ofkPP0e3dI1@3om^h00`0mFJ/0ooK^0?ofkP040?ofkP040=@m6@3om^h0e3dI
000000<0:Cj600@0e3dI02TnQP0Y?XH0:Cj60`000006035:V`8000000P0aBY/60=@m6@0403QD[@00
0000e3dI000000D0>5B]00<0000003iM_00000000`00000303iM_0<0000000H0?Ufl00000013ILT0
@fG90000003D?AT2000000<0@fG90P0000001@0mFJ/00000000000000000Af_D00/0000000<0od`P
0000000000000P0000000`3oC20000000000000=0000000304mgiP3D?AT0CgOV008000000`1AN^/5
00000003059lj`000000000000@0DWc[0`000002055ji0030=@m6@000000Bg7@00<000001@3om^h0
0`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h02P3om^h0
0`000000e3dI0=@m6@040=@m6@l0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0E0?ofkP030=@m6@3o
m^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h04@3om^h00`000000ooK^0?ofkP120?ofkP40oooo001;
0?ofkP800000@@3om^h=0=@m6@040?ofkP0mFJ/0ooK^03eIZ`L0e3dI1P3om^h00`3D?AT0ooK^03eI
Z`020000000302TnQP3D?AT0:Cj600@0:Cj60P000007035:V`80000000<0<DZK0000000hE:d00`0h
E:d60=@m6@030000000hE:d0000000H0?Ufl1000000203iM_0@0000000@0e3dI04=Ub@13ILT0@fG9
1000000204=UbAh000002P3D?AT4000000@0DG[[0P000006059lj`070000001AN^@0DG[T055ji000
0000e3dI04]ad00300000080e3dI103om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^
00@0ooK^00<0e3dI0?ofkP3om^h02P3om^h01`000000ooK^0?ofkP3D?AT0ooK^0=@m6@3om^h01`3D
?AT80?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT05@3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m
6@3om^h0ooK^0100ooK^00<000000?ofkP3om^h0@`3om^h10?ooo`00B`3om^h00`000000ooK^0?of
kP180?ofkP`0e3dI00@0ooK^03eIZ`3om^h0?EV[203D?AT01@0mFJ/0ooK^0?ofkP3D?AT0000000D0
:Cj600<00000035:V`0000000P000006035:V`<00000100hE:d00`3D?AT0>5B]03QD[@0203QD[@L0
e3dI1P0nGK`6000000030=@m6@000000000000@0000000<0@fG90000000000008@00000404mgiP03
0=@m6@000000000000H0e3dI0P000004059lj`@000000P1AN^@2000000040=@m6@000000000004]a
d08000000P3om^h80=@m6@L0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP0:0?of
kP030000003om^h0e3dI0080ooK^00<0e3dI0?ofkP3om^h01P3om^h90=@m6@80ooK^00<0e3dI0?of
kP3om^h04`3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^0100ooK^00<000000?of
kP3om^h0A03om^h10?ooo`00BP3om^h2000004/0ooK^00H0?EV[0?ofkP0mFJ/0ooK^03eIZ`3om^h=
0=@m6@<0ooK^203D?AT202TnQP030000000aBY/0<DZK00<0<DZK0P000005035:V`030000000hE:d0
00000080000000<0e3dI03QD[@0hE:d01@0hE:d00`000000?Ufl03iM_002000000P0e3dI0`13ILT0
0`3D?AT00000000000040000000304=Ub@000000000001h0000000<0CgOV00000000000010000000
0`3D?AT00000055jj`04000000<0DG[[1@3D?AT010000000DWc[059lj`1BO>/300000080DG[T00<0
e3dI04]ad01;LM000P0000070?ofkP040=@m6@3om^h0ooK^0?ofkPH0e3dI00<0ooK^0=@m6@3om^h0
1P3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030000003om^h0e3dI0080ooK^00<0e3dI0?ofkP3om^h0
3P3om^h70=@m6A80ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030000
003om^h0ooK^04D0ooK^0@3oool004X0ooK^0P00001:0?ofkP80?EV[00@0ooK^03eIZ`3om^h0?EV[
0P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3D?AT0e3dI00d0e3dI0P3om^h70=@m6@<0<DZK
0`0000000`0aBY/0000003QD[@0403QD[@030=@m6@0000000000008000000P0hE:d00`000000?Ufl
03iM_00703iM_0@000001`3D?AT304=UbB8000001P1?MnH00`3D?AT0000000000007055jj`800000
0`1BO>/60=@m6@80DG[T00D0e3dI04]ad01;LM00Bg7@000000080?ofkP030=@m6@3om^h0ooK^00L0
ooK^1P3D?AT30?ofkP030=@m6@3om^h0ooK^00X0ooK^00<000000=@m6@3om^h00P3om^h00`3D?AT0
ooK^0?ofkP0?0?ofkP80e3dI103om^h70=@m6@/0ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0
ooK^0?ofkP0>0?ofkP030000003om^h0ooK^04H0ooK^0@3oool004X0ooK^0P00001:0?ofkP0303eI
Z`3om^h0ooK^0080?EV[103om^h0100mFJ/0ooK^0?ofkP0mFJ/30?ofkP0303eIZ`3om^h0ooK^00<0
ooK^3P3D?AT2035:V`P0e3dI0P00000203QD[@030=@m6@0hE:d0>5B]00<0>5B]2@00000603iM_004
00000013ILT0@fG90=@m6@<0@fG900<000000=@m6@3D?AT0103D?ATQ000000<0CgOV00@0e3dI0000
001AN^/0DG[[1@000002055jj`040000001BO>/0DWc[059lj`@000000`1AN^@60=@m6@030000003o
m^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP030?ofkPL0e3dI2@3o
m^h00`000000e3dI0?ofkP020?ofkP030=@m6@3om^h0ooK^00l0ooK^0P3D?AT;0?ofkPL0e3dI0`3o
m^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^00l0ooK^00<000000?ofkP3om^h0AP3o
m^h10?ooo`00BP3om^h2000004X0ooK^00<0?EV[0?ofkP3om^h00P0mFJ/40?ofkP0403eIZ`3om^h0
ooK^03eIZ`@0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3D
?AT0e3dI00H0e3dI00<0?EV[035:V`0aBY/0100aBY/00`000000>5B]0=@m6@050=@m6@8000000`0h
E:d00`000000?Ufl03iM_00503iM_0T0000000<0e3dI000000000000;0000000103D?AT000000000
00000006055jj`030000001BO>/00000008000000`1BO>/01`000000DG[T000000000000DG[T0=@m
6@1;LM000`0000070=@m6@<0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP060?of
kP040=@m6@3om^h0ooK^0?ofkPH0e3dI0`3om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0
ooK^00h0ooK^00<0e3dI0?ofkP3om^h04@3om^h70=@m6A80ooK^00<0e3dI0?ofkP3om^h03P3om^h0
0`000000ooK^0?ofkP170?ofkP40oooo001:0?ofkP800000BP3om^h0100mFJ/0ooK^0?ofkP0mFJ/5
0?ofkP0303eIZ`3om^h0?EV[00D0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP04
0?ofkP0303eIZ`3om^h0ooK^00@0ooK^1`3D?AT0100aBY/0000003QD[@0hE:d20=@m6@<0>5B]1P3D
?AT6000000H0?Ufl00@0000004=Ub@3D?AT0e3dI1013ILT?000000030?];80000000000000`00000
00<0Bg7N0000000000000P00000304mgiP@0000000<0e3dI0000000000002P000005059lj`<00000
0P1AN^@010000000e3dI0000001;LM02000000L0ooK^203D?AT30?ofkP030=@m6@3om^h0ooK^00L0
ooK^00<0e3dI0?ofkP3om^h01`3om^h60=@m6@<0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0
ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^0080ooK^1`3D?AT;0?ofkP030=@m6@3om^h0ooK^00d0
ooK^00<000000?ofkP3om^h0B03om^h10?ooo`00BP3om^h00`000000ooK^0?ofkP190?ofkP0403eI
Z`3om^h0ooK^03eIZ`D0ooK^00<0?EV[0?ofkP0mFJ/01P3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[
00H0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP030?ofkP030000003D?AT0e3dI
00@0e3dI1`0hE:d00`000000?Ufl0=@m6@050=@m6@h000000`13ILT:000000030?];800000000000
0080000000<0nd/P0000000000000P0000000`3kBb0000000000000700000080CgOV1000000304mg
iP030=@m6@1AN^/0DG[[00L0DG[[00@00000059lj`1BO>/0DWc[1@000004055ji0030=@m6@1;LM00
Bg7@008000002`3om^h00`3D?AT0ooK^0?ofkP020?ofkPL0e3dI1`3om^h00`3D?AT0ooK^0?ofkP08
0?ofkP040=@m6@000000ooK^0?ofkPH0e3dI3@3om^h20=@m6AD0ooK^00<0e3dI0?ofkP3om^h02@3o
m^h70=@m6@<0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`000000ooK^0?ofkP190?ofkP40oooo001:
0?ofkP030000003om^h0ooK^04T0ooK^00@0?EV[0?ofkP3om^h0?EV[1P3om^h203eIZ`H0ooK^00@0
?EV[0?ofkP3om^h0?EV[203om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00P0ooK^
00<0000003eIZ`0mFJ/00`3D?AT403QD[@030000000nGK`0?Ufl00D0?Ufl103D?AT00`0nGK`00000
04=Ub@0204=Ub@l0000000<0?EV[0>U77P0000001`0000000`3kBb0000000?];8009000000D0e3dI
0`1?MnH00`000000e3dI0000000=000000<0DWc[00<00000055ji01AN^@00P0000000`3D?AT0Bg7@
04]ad002000000`0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP020?ofkPP0e3dI
2P3om^h00`3D?AT000000?ofkP040?ofkP030=@m6@3om^h0ooK^00H0e3dI1`3om^h00`3D?AT0ooK^
0=@m6@0C0?ofkP030=@m6@3om^h0ooK^0140ooK^103D?AT>0?ofkP030000003om^h0ooK^04X0ooK^
0@3oool004T0ooK^0P00001;0?ofkP0503eIZ`3om^h0?EV[0?ofkP0mFJ/01@3om^h00`0mFJ/0ooK^
0?ofkP060?ofkP0303eIZ`3om^h0?EV[00T0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0=0?ofkP03
03eIZ`3om^h0?EV[01L00000100mFJ/600000080jDLN00<0?EV[0000000000000P0000001@3YAah0
00000>U77P000000jDLN00L0000000<0nd/P0000003kBb000P00000204mgiP80000000<0CgOV0000
003D?AT01`3D?AT6055jj`030000001BO>/0DWc[00D0DWc[0`000002055ji0040=@m6@0000000000
000000@0e3dI2P3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00X0ooK^1`3D?AT3
0?ofkP030=@m6@3om^h0000000D0ooK^00<0e3dI0?ofkP3om^h01P3om^h70=@m6@80ooK^00<0e3dI
0?ofkP3om^h04@3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<00000
0?ofkP3om^h0B`3om^h10?ooo`00B@3om^h2000004/0ooK^00D0?EV[0?ofkP0mFJ/0ooK^03eIZ`05
0?ofkP0303eIZ`3om^h0ooK^00H0ooK^0P0mFJ/;0?ofkP0403eIZ`3om^h0ooK^03eIZ`h0ooK^0P0m
FJ/60?ofkPT0000000<0`3dJ03eIZ`30?AX01030?AX500000080?EV[00H0e3dI0>U77P3YAah0e3dI
0000000mFJ/3000000050>U77P00000000000>U77P0000000P3YAah01`000000jDLN0000003YAah0
00000>U77P0mFJ/01`00000204mgiP8000000`1?MnH00`3D?AT0000000000002000000L0e3dI0`1B
O>/5000000<0DG[T00<0e3dI0000001;LM000P0000040?ofkPL0e3dI0`3om^h00`3D?AT0ooK^0?of
kP020?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h0103om^h70=@m6@D0ooK^00<0
e3dI0?ofkP3om^h02`3om^h40=@m6A80ooK^00<0e3dI0?ofkP3om^h0503om^h00`3D?AT0ooK^0?of
kP0<0?ofkP030000003om^h0ooK^04/0ooK^0@3oool004T0ooK^0P00001;0?ofkP0503eIZ`3om^h0
?EV[0?ofkP0mFJ/01@3om^h203eIZ`P0ooK^00<0?EV[0?ofkP3om^h02P3om^h203eIZa00ooK^00<0
?EV[0?ofkP3om^h0303om^h20000000303eIZ`000000000000@000001P30?AX303eIZ`80000000H0
?EV[0000003YAah0jDLN0000003D?AT20>U77P030000003YAah000000080jDLN00D000000>U77P3Y
Aah0?EV[0>U77P02000000030>U77P000000000000@000000P1?MnH2000000030=@m6@000000DG[[
00@0DG[[1P0000070=@m6@<0DG[T00D000000=@m6@1;LM00Bg7@0000000<0?ofkPP0e3dI3@3om^h0
0`3D?AT0ooK^0?ofkP060?ofkP050=@m6@3om^h0ooK^0?ofkP0000001`3D?AT;0?ofkP050=@m6@3o
m^h0ooK^0?ofkP3D?AT04P3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^00`0ooK^
00<000000?ofkP3om^h0C03om^h10?ooo`00B@3om^h2000004/0ooK^0P0mFJ/30?ofkP0703eIZ`3o
m^h0ooK^0?ofkP0mFJ/0ooK^03eIZ`080?ofkP80?EV[303om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP<0
?EV[3P3om^h0100mFJ/0ooK^0?ofkP3om^h<000000D0?EV[200000001P3D?AT0jDLN0000003D?AT0
jDLN03eIZ`80jDLN0`0000001@3YAah000000>U77P000000CgOV0080000000<0CgOV0=@m6@000000
1@000004055jj`030000001BO>/0DWc[00D0DWc[0P0000070=@m6A00ooK^00<0e3dI0?ofkP3om^h0
1`3D?AT90?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`000000ooK^
0?ofkP030?ofkP030=@m6@3om^h0e3dI00H0e3dI103om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m
6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h0503om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030000
003om^h0ooK^04d0ooK^0@3oool004T0ooK^00<000000?ofkP3om^h0BP3om^h203eIZ`<0ooK^00D0
?EV[0?ofkP3om^h0ooK^03eIZ`020?ofkP0303eIZ`3om^h0ooK^00@0ooK^00@0?EV[0?ofkP3om^h0
?EV[2`3om^h203eIZ`h0ooK^00@0?EV[0?ofkP3om^h0ooK^0P0mFJ/;0?ofkP0303eIZ`3om^h0ooK^
00P0ooK^1`000000100mFJ/0000000000030?AX803eIZ`060<0m6P00000000000000000mFJ/0e3dI
0`0000001P3D?AT0jDLN0000003YAah000000>U77P80000000@0CgOV0000001?MnH000001@1AN^/=
000000<0DG[T00D0e3dI04]ad0000000000003eIZ`070=@m6@X0ooK^0P3D?AT70?ofkPH0e3dI0`3o
m^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^0080ooK^00<000000?ofkP3om^h00`3o
m^h00`3D?AT0ooK^0?ofkP060?ofkPL0e3dI0P3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3o
m^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`000000ooK^0?ofkP1>0?ofkP40oooo0019
0?ofkP030000003om^h0ooK^04X0ooK^0P0mFJ/30?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/00P3o
m^h00`0mFJ/0ooK^0?ofkP040?ofkP0403eIZ`3om^h0ooK^03eIZ`X0ooK^00@0?EV[0?ofkP3om^h0
?EV[3@3om^h00`0mFJ/0ooK^0?ofkP030?ofkP80?EV[2@3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP03
03eIZ`000000000000X00000200mFJ/2000000D0?EV[00D000000>U77P000000000004mgiP020000
00L0DG[[00<00000059lj`1BO>/0101BO>/00`000000DG[T055ji002055ji0060=@m6@0000000000
04]ad0000000e3dI1`3om^h70=@m6@<0ooK^0P3D?AT=0?ofkPP0e3dI00<0ooK^0=@m6@3om^h0103o
m^h00`000000ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h00P3o
m^h70=@m6@/0ooK^00<0e3dI0?ofkP3om^h0503om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030000003o
m^h0ooK^04l0ooK^0@3oool004P0ooK^0P00001<0?ofkP80?EV[0`3om^h0100mFJ/0ooK^0?ofkP0m
FJ/40?ofkP0303eIZ`3om^h0ooK^00<0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`090?ofkP0403eI
Z`3om^h0ooK^0?ofkP80?EV[2P3om^h00`0mFJ/0ooK^0?ofkP060?ofkP80?EV[1P3om^h00`0mFJ/0
ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00X0ooK^100000001P0mFJ/0`3dJ0<0m6P000000e3dI
0<0m6P80000000<0`3dJ0000000000001P0000050=@m6@<0DG[[00<00000059lj`1BO>/0101BO>/0
1P000000DG[T055ji0000000e3dI00000080Bg7@0P3D?AT00`3om^h0e3dI0?ofkP0<0?ofkPL0e3dI
3`3om^h0103D?AT0ooK^0?ofkP3om^h:0=@m6@@0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0
ooK^0?ofkP060?ofkP040=@m6@3om^h0ooK^0?ofkPL0e3dI103om^h00`3D?AT0ooK^0?ofkP0C0?of
kP030=@m6@3om^h0ooK^00X0ooK^00<000000?ofkP3om^h0D03om^h10?ooo`00B03om^h2000004`0
ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^03eIZ`040?ofkP0303eIZ`3om^h0ooK^00<0
ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00<0
ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP080?ofkP80?EV[103om^h00`0mFJ/0
ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP000000300000000`0mFJ/0
`3dJ0<0m6P02000000<0DG[[203D?AT5000000030=@m6@000000Bg7@0080Bg7@00<000000?ofkP3D
?AT01@3D?AT;0?ofkP030=@m6@3om^h0e3dI0080ooK^1`3D?AT80?ofkP040=@m6@3om^h0ooK^0=@m
6@L0ooK^00<000000?ofkP3om^h0203D?AT50?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?of
kP3om^h0203om^h70=@m6A<0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`000000ooK^0?ofkP1@0?of
kP40oooo00180?ofkP800000C03om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0?EV[00D0
ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`060?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?of
kP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00/0ooK^0P0mFJ/00`3o
m^h0?EV[0?ofkP0@0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h01P3om^h60000
000303eIZ`00000000000080`3dJ0`0000000`1AN^/00000059lj`05059lj`P0e3dI00<0?EV[0000
003om^h00`3om^h0103D?AT0ooK^0?ofkP3om^h;0=@m6@<0ooK^00<0e3dI0?ofkP3om^h01P3om^h7
0=@m6@80ooK^00<0e3dI0?ofkP3D?AT01`3om^h00`000000ooK^0?ofkP040?ofkP040=@m6@3om^h0
ooK^0?ofkPH0e3dI203om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^0080ooK^1`3D
?AT;0?ofkP030=@m6@3om^h0ooK^00X0ooK^00<000000?ofkP3om^h0D@3om^h10?ooo`00B03om^h2
000004`0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^03eIZ`060?ofkP0403eIZ`3om^h0
ooK^03eIZ`L0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3o
m^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h03@3om^h303eIZ`l0ooK^00<0?EV[0?ofkP3om^h03P3o
m^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`000000000000T0000000<0DWc[0=@m6@3D?AT00P1B
O>/00`000000DG[T0=@m6@020=@m6@80000000<0?EV[0=@m6@3D?AT01@3D?AT<0?ofkPT0e3dI303o
m^h70=@m6@D0ooK^00<000000?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3o
m^h0ooK^00H0e3dI0`3om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00X0ooK^1`3D
?AT40?ofkP030=@m6@3om^h0ooK^00T0ooK^00<000000?ofkP3om^h0DP3om^h10?ooo`00B03om^h0
0`000000ooK^0?ofkP1;0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h01@3om^h0
100mFJ/0ooK^0?ofkP0mFJ/80?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/02P3om^h00`0mFJ/0ooK^
0?ofkP020?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP0mFJ/00P0mFJ/<0?ofkP0303eI
Z`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP040?ofkP@00000
00@0?EV[0000000mFJ/0?EV[303D?AT50?ofkPL0e3dI103om^h00`3D?AT0ooK^0?ofkP040?ofkP03
0=@m6@3om^h0ooK^00H0e3dI203om^h20=@m6@<0ooK^1`3D?AT60?ofkP030=@m6@3om^h0ooK^0080
ooK^00<0e3dI0?ofkP3om^h01`3om^h40=@m6@X0ooK^00<0e3dI0?ofkP3om^h04@3om^h40=@m6@/0
ooK^00<000000?ofkP3om^h0D`3om^h10?ooo`00B03om^h00`000000ooK^0?ofkP1<0?ofkP0303eI
Z`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^03eIZ`080?ofkP0503eI
Z`3om^h0ooK^0?ofkP0mFJ/02`3om^h203eIZ`80ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0
ooK^0?ofkP030?ofkP<0?EV[203om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00`0
ooK^00<0?EV[0?ofkP3om^h0203om^h303eIZ`H0000000<0?EV[0?ofkP3D?AT03`3D?AT20?ofkPL0
e3dI1@3om^h00`3D?AT0ooK^0?ofkP050?ofkPP0e3dI00<0ooK^0=@m6@3om^h01`3om^h00`000000
ooK^0=@m6@070=@m6@<0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP070?ofkP03
0=@m6@3om^h0ooK^01@0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`000000ooK^0?ofkP1D0?ofkP40
oooo00180?ofkP030000003om^h0ooK^04`0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^
0?ofkP060?ofkP80?EV[2P3om^h0100mFJ/0ooK^0?ofkP0mFJ/=0?ofkP80?EV[4@3om^h00`0mFJ/0
ooK^0?ofkP060?ofkP<0?EV[1@3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00`0
ooK^00<0?EV[0?ofkP3om^h0203om^h203eIZ`<0ooK^0P0mFJ/20?ofkPL0?EV[0P3om^h90=@m6@03
0?ofkP3D?AT0e3dI00@0e3dI0`3om^h70=@m6@`0ooK^203D?AT50?ofkP030000003om^h0ooK^00D0
ooK^1`3D?AT;0?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h0503om^h00`3D?AT0
ooK^0?ofkP090?ofkP030000003om^h0ooK^05D0ooK^0@3oool004L0ooK^0P00001>0?ofkP0303eI
Z`3om^h0ooK^0080ooK^00<0?EV[0?ofkP0mFJ/0203om^h00`0mFJ/0ooK^0?ofkP090?ofkP80?EV[
3`3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00X0ooK^0`0mFJ/00`3om^h0?EV[
0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h0103om^h503eIZ`@0ooK^
0P0mFJ/20?ofkP<0?EV[00<0ooK^03eIZ`0mFJ/02P3om^h70=@m6@80ooK^1`3D?AT20?ofkPP0e3dI
103om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00H0e3dI203om^h20=@m6@@0ooK^
1`3D?AT40?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h0503om^h00`3D?AT0ooK^
0?ofkP0:0?ofkP030000003om^h0ooK^05D0ooK^0@3oool004L0ooK^0P00001>0?ofkP0303eIZ`3o
m^h0ooK^0080ooK^00<0?EV[0?ofkP0mFJ/0203om^h203eIZ`/0ooK^00<0?EV[0?ofkP3om^h03@3o
m^h303eIZ`h0ooK^00<0?EV[0?ofkP3om^h03@3om^h503eIZ``0ooK^00<0?EV[0?ofkP3om^h0303o
m^h00`0mFJ/0ooK^0?ofkP020?ofkP<0?EV[103om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3o
m^h0ooK^00<0?EV[00<0ooK^03eIZ`0mFJ/04P3om^h70=@m6@80ooK^1`3D?AT30?ofkPL0e3dI103o
m^h00`3D?AT0ooK^0?ofkP040?ofkP030000003D?AT0e3dI00@0e3dI0P3om^h00`3D?AT0ooK^0?of
kP0:0?ofkPL0e3dI103om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0
00000?ofkP3om^h0EP3om^h10?ooo`00A`3om^h2000004l0ooK^00@0?EV[0?ofkP3om^h0?EV[0`3o
m^h00`0mFJ/0ooK^0?ofkP040?ofkP0403eIZ`3om^h0ooK^03eIZ`X0ooK^0P0mFJ/=0?ofkP0403eI
Z`3om^h0ooK^0?ofkP80?EV[2`3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0403eIZ`3om^h0ooK^0?of
kPP0?EV[103om^h00`0mFJ/0ooK^0?ofkP0<0?ofkPD0?EV[1P3om^h00`0mFJ/0ooK^0?ofkP030?of
kP0303eIZ`3om^h0ooK^00<0?EV[00<0ooK^03eIZ`0mFJ/06@3om^h?0=@m6@@0ooK^1P3D?AT50?of
kP030000003om^h0ooK^00@0ooK^1`3D?AT=0?ofkP030=@m6@3om^h0e3dI00H0e3dI4`3om^h00`3D
?AT0ooK^0?ofkP090?ofkP030000003om^h0ooK^05L0ooK^0@3oool004L0ooK^00<000000?ofkP3o
m^h0CP3om^h0100mFJ/0ooK^0?ofkP0mFJ/30?ofkP0303eIZ`3om^h0ooK^00@0ooK^00@0?EV[0?of
kP3om^h0?EV[2@3om^h00`0mFJ/0ooK^0?ofkP0203eIZ`/0ooK^00<0?EV[0?ofkP3om^h00`3om^h2
03eIZ`T0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkQ@0?EV[2P3om^h0
0`0mFJ/0ooK^0?ofkP030?ofkP0603eIZ`3om^h0?EV[0?ofkP0mFJ/0ooK^0P0mFJ/Q0?ofkPL0e3dI
00<0ooK^0=@m6@3D?AT01@3D?AT20?ofkPP0e3dI103om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m
6@3om^h0ooK^00H0e3dI203om^h0103D?AT0ooK^0?ofkP3D?AT40?ofkPH0e3dI303om^h00`3D?AT0
ooK^0?ofkP090?ofkP030000003om^h0ooK^05P0ooK^0@3oool004L0ooK^00<000000?ofkP3om^h0
CP3om^h0100mFJ/0ooK^0?ofkP0mFJ/40?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3o
m^h00P3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3o
m^h01`3om^h00`0mFJ/0ooK^0?ofkP060?ofkP80?EV[1P3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP03
03eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP090?ofkP03
03eIZ`3om^h0ooK^00@0ooK^0P0mFJ/0103om^h0?EV[03eIZ`3om^h203eIZbP0ooK^1P3D?AT20?of
kPL0e3dI00<0ooK^0000003om^h01`3D?AT30?ofkP030=@m6@3om^h0ooK^00D0ooK^1P3D?AT20?of
kP030=@m6@3om^h0e3dI00/0ooK^1`3D?AT40?ofkP030=@m6@3om^h0ooK^00T0ooK^00<000000?of
kP3om^h0F@3om^h10?ooo`00A`3om^h00`000000ooK^0?ofkP1>0?ofkP0303eIZ`3om^h0?EV[00D0
ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00@0
ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00P0
ooK^0P0mFJ/40?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0
ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h00`3om^h403eIZ`03
0?ofkP0mFJ/0ooK^0080?EV[;`3om^h?0=@m6@@0ooK^1`3D?AT:0?ofkP@0e3dI4`3om^h40=@m6@/0
ooK^00<000000?ofkP3om^h0FP3om^h10?ooo`00AP3om^h200000540ooK^0P0mFJ/60?ofkP0503eI
Z`3om^h0ooK^0?ofkP0mFJ/01P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00D0
ooK^0P0mFJ/60?ofkP0303eIZ`3om^h0ooK^00X0ooK^0P0mFJ/00`3om^h0?EV[0?ofkP0@0?ofkP03
03eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP090?ofkP04
03eIZ`3om^h0ooK^0?ofkP80?EV[0P3om^h00`0mFJ/0ooK^03eIZ`0303eIZcL0ooK^3`3D?AT20?of
kP030=@m6@3om^h0e3dI00H0e3dI103om^h0103D?AT0ooK^0?ofkP3D?ATD0?ofkP030=@m6@3om^h0
ooK^00X0ooK^00<000000?ofkP3om^h0FP3om^h10?ooo`00AP3om^h200000540ooK^00<0?EV[0?of
kP3om^h01@3om^h0100mFJ/0ooK^0?ofkP0mFJ/80?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[
0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00d0ooK^0`0mFJ/?
0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP08
0?ofkP0303eIZ`3om^h0ooK^0080?EV[0`3om^h203eIZ`030?ofkP0mFJ/0?EV[0080?EV[>P3om^h0
0`000000ooK^0?ofkP020?ofkPl0e3dI0`3om^h70=@m6@030?ofkP3D?AT0e3dI0140ooK^00<0e3dI
0?ofkP3om^h02P3om^h00`000000ooK^0?ofkP1K0?ofkP40oooo00160?ofkP800000D@3om^h00`0m
FJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0?EV[00T0ooK^00@0?EV[0?ofkP3om^h0?EV[2`3om^h0
1@0mFJ/0ooK^0?ofkP3om^h0?EV[00l0ooK^00<0?EV[0?ofkP3om^h00`0mFJ/<0?ofkP0303eIZ`3o
m^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP090?ofkP<0?EV[1@3o
m^h00`0mFJ/0ooK^03eIZ`0303eIZc/0ooK^00<000000?ofkP3om^h0303om^hE0=@m6@`0ooK^0P3D
?AT<0?ofkP030000003om^h0ooK^05`0ooK^0@3oool004H0ooK^00<000000?ofkP3om^h0D@3om^h0
0`0mFJ/0ooK^0?ofkP050?ofkP80?EV[2P3om^h0100mFJ/0ooK^0?ofkP0mFJ/<0?ofkP<0?EV[403o
m^h00`0mFJ/0ooK^0?ofkP030?ofkP<0?EV[203om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3o
m^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h01`3om^h303eIZ`H0ooK^1`0mFJ/k0?ofkP030000003o
m^h0ooK^01D0ooK^4`3D?AT40?ofkP030=@m6@3om^h0ooK^00/0ooK^00<000000?ofkP3om^h0G@3o
m^h10?ooo`00AP3om^h00`000000ooK^0?ofkP1A0?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[
0?ofkP3om^h02@3om^h203eIZ`l0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP07
0?ofkP<0?EV[1@3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[
0?ofkP3om^h01@3om^h303eIZ`030?ofkP0mFJ/0ooK^00H0ooK^0`0mFJ/00`3om^h0?EV[03eIZ`0l
0?ofkP030000003om^h0ooK^01/0ooK^203D?AT50?ofkP@0e3dI3@3om^h00`000000ooK^0?ofkP1N
0?ofkP40oooo00160?ofkP030000003om^h0ooK^0580ooK^00<0?EV[0?ofkP3om^h01@3om^h203eI
Z`/0ooK^00<0?EV[0?ofkP3om^h0303om^h0100mFJ/0ooK^03eIZ`0mFJ/=0?ofkP0303eIZ`3om^h0
ooK^00X0ooK^0`0mFJ/00`3om^h0?EV[0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00@0?EV[
0?ofkP3om^h0ooK^100mFJ/30?ofkP0303eIZ`3om^h0ooK^00D0ooK^100mFJ/00`3om^h0?EV[03eI
Z`0m0?ofkP030000003om^h0ooK^0200ooK^1`3D?AT@0?ofkP030000003om^h0ooK^05l0ooK^0@3o
ool004H0ooK^00<000000?ofkP3om^h0D`3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0403eIZ`3om^h0
ooK^03eIZ`X0ooK^0P0mFJ/=0?ofkP0403eIZ`3om^h0ooK^0?ofkP80?EV[2P3om^h00`0mFJ/0ooK^
0?ofkP0>0?ofkPD0?EV[303om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0?EV[0080?EV[
1`3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0403eIZ`3om^h0?EV[0?ofkP80?EV[?P3om^h00`000000
ooK^0?ofkP0g0?ofkP030000003om^h0ooK^05l0ooK^0@3oool004D0ooK^0P00001E0?ofkP0303eI
Z`3om^h0ooK^00<0ooK^00@0?EV[0?ofkP3om^h0?EV[2@3om^h00`0mFJ/0ooK^0?ofkP0203eIZ`X0
ooK^00<0?EV[0?ofkP3om^h0103om^h203eIZ`P0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0
ooK^0?ofkP020?ofkPP0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP050?ofkPT0?EV[2@3om^h00`0mFJ/0
ooK^0?ofkP050?ofkP0503eIZ`3om^h0ooK^03eIZ`3om^h00P0mFJ/n0?ofkP030000003om^h0ooK^
03H0ooK^00<000000?ofkP3om^h0H03om^h10?ooo`00A@3om^h2000005H0ooK^00<0?EV[0?ofkP3o
m^h00P3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00P0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0m
FJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00H0ooK^0P0mFJ/50?ofkP0303eIZ`3om^h0ooK^
00l0ooK^00<0?EV[0?ofkP3om^h02P3om^h;03eIZ`H0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0m
FJ/0ooK^0?ofkP030?ofkP80?EV[0`3om^h303eIZcl0ooK^00<000000?ofkP3om^h0=@3om^h00`00
0000ooK^0?ofkP1Q0?ofkP40oooo00150?ofkP030000003om^h0ooK^05D0ooK^00D0?EV[0?ofkP3o
m^h0ooK^03eIZ`050?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0m
FJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00T0ooK^0P0mFJ/30?ofkP0303eIZ`3om^h0ooK^
00h0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^
00P0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^03eIZ`020?ofkP0303eIZ`3om^h0?EV[
0400ooK^00<000000?ofkP3om^h0=03om^h00`000000ooK^0?ofkP1R0?ofkP40oooo00150?ofkP03
0000003om^h0ooK^05H0ooK^00@0?EV[0?ofkP3om^h0?EV[1P3om^h00`0mFJ/0ooK^0?ofkP030?of
kP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0;0?of
kP<0?EV[4@3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?of
kP3om^h02@3om^h0100mFJ/0ooK^0?ofkP3om^h203eIZ`030?ofkP0mFJ/0ooK^0080ooK^0`0mFJ]0
0?ofkP030000003om^h0ooK^03<0ooK^00<000000?ofkP3om^h0H`3om^h10?ooo`00A@3om^h00`00
0000ooK^0?ofkP1G0?ofkP0303eIZ`3om^h0?EV[00L0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0m
FJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h03P3om^h203eI
Z`l0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^
00P0ooK^00<0?EV[0?ofkP3om^h00P0mFJ/30?ofkP0303eIZ`3om^h0ooK^00<0?EV[@@3om^h00`00
0000ooK^0?ofkP0b0?ofkP030000003om^h0ooK^06@0ooK^0@3oool004D0ooK^00<000000?ofkP3o
m^h0E`3om^h203eIZ`T0ooK^00@0?EV[0?ofkP3om^h0?EV[2P3om^h203eIZ`80ooK^00<0?EV[0?of
kP3om^h03P3om^h00`0mFJ/0ooK^03eIZ`0203eIZ``0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0m
FJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP0mFJ/0103om^h00`0m
FJ/0ooK^0?ofkP0303eIZd80ooK^00<000000?ofkP3om^h0<P3om^h00`000000ooK^0?ofkP1T0?of
kP40oooo00140?ofkP800000FP3om^h00`0mFJ/0ooK^0?ofkP070?ofkP0403eIZ`3om^h0ooK^03eI
Z``0ooK^0P0mFJ/@0?ofkP0303eIZ`3om^h0ooK^00<0ooK^0`0mFJ/80?ofkP0303eIZ`3om^h0ooK^
00d0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP090?ofkP<0?EV[103om^h01@0m
FJ/0ooK^0?ofkP0mFJ/0ooK^0080?EV[@P3om^h00`000000ooK^0?ofkP0a0?ofkP030000003om^h0
ooK^06D0ooK^0@3oool004@0ooK^0P00001K0?ofkP0303eIZ`3om^h0ooK^00L0ooK^0P0mFJ/>0?of
kP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h01P3om^h303eIZ`D0ooK^00<0?EV[0?of
kP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00L0ooK^0`0mFJ/60?of
kP0403eIZ`3om^h0?EV[0?ofkP80?EV[@`3om^h00`000000ooK^0?ofkP0`0?ofkP030000003om^h0
ooK^06H0ooK^0@3oool004@0ooK^00<000000?ofkP3om^h0F`3om^h00`0mFJ/0ooK^0?ofkP070?of
kP0303eIZ`3om^h0ooK^00`0ooK^0`0mFJ/=0?ofkP0303eIZ`3om^h0ooK^00X0ooK^0`0mFJ/00`3o
m^h0?EV[0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h0103om^h403eI
Z`030?ofkP0mFJ/0ooK^00D0ooK^0`0mFJ/20?ofkP0303eIZ`3om^h0ooK^0480ooK^00<000000?of
kP3om^h0;`3om^h00`000000ooK^0?ofkP1W0?ofkP40oooo00140?ofkP030000003om^h0ooK^05/0
ooK^00<0?EV[0?ofkP3om^h01`3om^h203eIZ``0ooK^00@0?EV[0?ofkP3om^h0ooK^0P0mFJ/;0?of
kP0303eIZ`3om^h0ooK^00d0ooK^1@0mFJ/<0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?of
kP0mFJ/0100mFJ/50?ofkP0303eIZ`3om^h0ooK^00@0ooK^00@0?EV[0?ofkP3om^h0ooK^0P0mFJ]4
0?ofkP030000003om^h0ooK^02h0ooK^00<000000?ofkP3om^h0J03om^h10?ooo`00A03om^h00`00
0000ooK^0?ofkP1L0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h00P0mFJ/:0?of
kP0303eIZ`3om^h0ooK^00<0ooK^0P0mFJ/90?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?of
kP3om^h00P3om^h803eIZ`<0ooK^00<0?EV[0?ofkP3om^h01@3om^h903eIZ`T0ooK^00<0?EV[0?of
kP3om^h0103om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^04@0ooK^00<000000?of
kP3om^h0;03om^h00`000000ooK^0?ofkP1Y0?ofkP40oooo00140?ofkP030000003om^h0ooK^05d0
ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00H0
ooK^00<0?EV[0?ofkP3om^h01P3om^h203eIZ`H0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0
ooK^0?ofkP0:0?ofkP/0?EV[1@3om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^00<0
ooK^0P0mFJ/40?ofkP0303eIZ`3om^h0ooK^04D0ooK^00<000000?ofkP3om^h0;03om^h00`000000
ooK^0?ofkP1Y0?ofkP40oooo00130?ofkP800000H03om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eI
Z`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP080?ofkP80?EV[
103om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h0
2`3om^h00`0mFJ/0ooK^0?ofkP090?ofkP0403eIZ`3om^h0ooK^0?ofkP80?EV[00<0ooK^03eIZ`3o
m^h00P3om^h203eIZdL0ooK^00<000000?ofkP3om^h0:`3om^h00`000000ooK^0?ofkP1Z0?ofkP40
oooo00130?ofkP800000H@3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00L0ooK^00<0?EV[0?ofkP3o
m^h0103om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP80?EV[00<0ooK^03eIZ`3om^h03`3om^h00`0mFJ/0
ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0
ooK^0?ofkP0203eIZ`80ooK^00@0?EV[0?ofkP3om^h0ooK^0P0mFJ]80?ofkP030000003om^h0ooK^
02X0ooK^00<000000?ofkP3om^h0J`3om^h10?ooo`00@`3om^h00`000000ooK^0?ofkP1Q0?ofkP04
03eIZ`3om^h0ooK^03eIZ`P0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP0=0?of
kP<0?EV[3P3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?of
kP3om^h0203om^h0100mFJ/0ooK^03eIZ`0mFJ/40?ofkP0303eIZ`3om^h0ooK^00<0?EV[B03om^h0
0`000000ooK^0?ofkP0Y0?ofkP030000003om^h0ooK^06`0ooK^0@3oool004<0ooK^00<000000?of
kP3om^h0H@3om^h0100mFJ/0ooK^0?ofkP0mFJ/90?ofkP80?EV[0P3om^h00`0mFJ/0ooK^0?ofkP0=
0?ofkP0303eIZ`3om^h0ooK^00<0?EV[2`3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0
ooK^00X0ooK^00<0?EV[0?ofkP3om^h02@3om^h203eIZ`D0ooK^00H0?EV[0?ofkP0mFJ/0?EV[0?of
kP0mFJ]90?ofkP030000003om^h0ooK^02P0ooK^00<000000?ofkP3om^h0K@3om^h10?ooo`00@`3o
m^h00`000000ooK^0?ofkP1R0?ofkP80?EV[303om^h203eIZa00ooK^00<0?EV[0?ofkP3om^h00`3o
m^h203eIZ`P0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3o
m^h0ooK^00L0ooK^0P0mFJ/70?ofkP80?EV[0P3om^h00`0mFJ/0ooK^0?ofkP180?ofkP030000003o
m^h0ooK^02L0ooK^00<000000?ofkP3om^h0KP3om^h10?ooo`00@`3om^h00`000000ooK^0?ofkP1S
0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP06
0?ofkP<0?EV[1@3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[
0?ofkP3om^h01@3om^h403eIZ`L0ooK^0P0mFJ/30?ofkP0303eIZ`3om^h0ooK^04P0ooK^00<00000
0?ofkP3om^h09`3om^h00`000000ooK^0?ofkP1^0?ofkP40oooo00130?ofkP030000003om^h0ooK^
06@0ooK^00<0?EV[0?ofkP3om^h02P3om^h303eIZ`d0ooK^00<0?EV[0?ofkP3om^h02@3om^h303eI
Z`030?ofkP0mFJ/0ooK^00h0ooK^00<0?EV[0?ofkP3om^h02`3om^h0100mFJ/0ooK^0?ofkP3om^h4
03eIZ`<0ooK^00<0?EV[0?ofkP3om^h01@3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[04/0ooK^00<0
00000?ofkP3om^h09P3om^h00`000000ooK^0?ofkP1_0?ofkP40oooo00120?ofkP800000I`3om^h2
03eIZ`T0ooK^00@0?EV[0?ofkP3om^h0ooK^0P0mFJ/:0?ofkP0303eIZ`3om^h0ooK^00d0ooK^1@0m
FJ/<0?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP0mFJ/00P0mFJ/60?ofkP0303eIZ`3o
m^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP190?ofkP030000003o
m^h0ooK^02D0ooK^00<000000?ofkP3om^h0L03om^h10?ooo`00@P3om^h00`000000ooK^0?ofkP1X
0?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h00`3om^h203eIZ`P0ooK^00<0?EV[
0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP020?ofkPP0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP05
0?ofkPP0?EV[2@3om^h00`0mFJ/0ooK^0?ofkP030?ofkP80?EV[103om^h00`0mFJ/0ooK^0?ofkP1:
0?ofkP030000003om^h0ooK^02@0ooK^00<000000?ofkP3om^h0L@3om^h10?ooo`00@P3om^h00`00
0000ooK^0?ofkP1Y0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h01@3om^h203eI
Z`D0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP/0?EV[1@3om^h00`0m
FJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP0mFJ/00`3om^h00`0m
FJ/0ooK^0?ofkP1;0?ofkP030000003om^h0ooK^02<0ooK^00<000000?ofkP3om^h0LP3om^h10?oo
o`00@P3om^h00`000000ooK^0?ofkP1Z0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3o
m^h0203om^h203eIZ`<0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP03
03eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h0203om^h0100mFJ/0ooK^0?ofkP3om^h203eI
Z`030?ofkP0mFJ/0ooK^0080ooK^00<0?EV[0?ofkP3om^h0C@3om^h00`000000ooK^0?ofkP0Q0?of
kP030000003om^h0ooK^07<0ooK^0@3oool00480ooK^00<000000?ofkP3om^h0J`3om^h00`0mFJ/0
ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00X0ooK^0`0mFJ/@0?ofkP0303eIZ`3om^h0ooK^00d0
ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^0080
?EV[0`3om^h0100mFJ/0ooK^0?ofkP0mFJ]@0?ofkP030000003om^h0ooK^0240ooK^00<000000?of
kP3om^h0L`3om^h10?ooo`00@P3om^h00`000000ooK^0?ofkP1/0?ofkP80?EV[0P3om^h00`0mFJ/0
ooK^0?ofkP0<0?ofkP80?EV[3P3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00/0
ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^03eIZ`040?ofkP0403eIZ`3om^h0?EV[03eI
Ze40ooK^00<000000?ofkP3om^h0803om^h00`000000ooK^0?ofkP1d0?ofkP40oooo00110?ofkP80
0000L03om^h203eIZ`l0ooK^00<0?EV[0?ofkP0mFJ/00`0mFJ/:0?ofkP0303eIZ`3om^h0ooK^00d0
ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP080?ofkP<0?EV[1@3om^h203eIZe<0
ooK^00<000000?ofkP3om^h07`3om^h00`000000ooK^0?ofkP1e0?ofkP40oooo00110?ofkP030000
003om^h0ooK^0700ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP040?ofkP<0?EV[
1P3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h0
1P3om^h303eIZ`H0ooK^0P0mFJ]D0?ofkP030000003om^h0ooK^01h0ooK^00<000000?ofkP3om^h0
MP3om^h10?ooo`00@@3om^h00`000000ooK^0?ofkP1a0?ofkP80?EV[303om^h00`0mFJ/0ooK^0?of
kP070?ofkP@0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0
?EV[0?ofkP3om^h00`3om^h403eIZ`030?ofkP0mFJ/0ooK^00H0ooK^00<0?EV[0?ofkP3om^h0D`3o
m^h00`000000ooK^0?ofkP0M0?ofkP030000003om^h0ooK^07L0ooK^0@3oool00440ooK^1@00001a
0?ofkP80?EV[2@3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkPD0?EV[303om^h00`0mFJ/0ooK^0?ofkP0;
0?ofkP0303eIZ`3om^h0?EV[00<0?EV[1@3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0
ooK^05@0ooK^00<000000?ofkP3om^h0703om^h00`000000ooK^0?ofkP1h0?ofkP40oooo00160?of
kPP00000J`3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00d0ooK^00@0?EV[0?of
kP3om^h0ooK^200mFJ/40?ofkP0303eIZ`3om^h0ooK^00@0ooK^2@0mFJ/80?ofkP0303eIZ`3om^h0
ooK^00<0ooK^0P0mFJ]G0?ofkP030000003om^h0ooK^01`0ooK^00<000000?ofkP3om^h0N03om^h1
0?ooo`00CP3om^h8000006@0ooK^0P0mFJ/50?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?of
kP3om^h02P3om^h;03eIZ`D0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP020?of
kP80?EV[F@3om^h00`000000ooK^0?ofkP0K0?ofkP030000003om^h0ooK^07T0ooK^0@3oool005H0
ooK^2@00001M0?ofkP80?EV[0`3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00`0
ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^0080
?EV[F`3om^h00`000000ooK^0?ofkP0J0?ofkP030000003om^h0ooK^07X0ooK^0@3oool005l0ooK^
2000001G0?ofkP<0?EV[3`3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00X0ooK^
00<0?EV[0?ofkP3om^h0203om^h0100mFJ/0ooK^03eIZ`0mFJ]M0?ofkP030000003om^h0ooK^01T0
ooK^00<000000?ofkP3om^h0N`3om^h10?ooo`00I`3om^h800000540ooK^0P0mFJ/>0?ofkP0303eI
Z`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP080?ofkP80?EV[
H03om^h00`000000ooK^0?ofkP0G0?ofkP030000003om^h0ooK^07`0ooK^0@3oool006l0ooK^2@00
001:0?ofkP@0?EV[2@3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0
?EV[0?ofkP3om^h01`3om^h203eIZf80ooK^00<000000?ofkP3om^h05P3om^h00`000000ooK^0?of
kP1m0?ofkP40oooo001h0?ofkPP00000AP3om^h303eIZ`H0ooK^00<0?EV[0?ofkP3om^h0303om^h0
0`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00@0ooK^0`0mFJ]T0?ofkP030000003om^h0
ooK^01H0ooK^00<000000?ofkP3om^h0O@3om^h10?ooo`00P03om^h800000440ooK^100mFJ/00`3o
m^h0?EV[0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00X0ooK^00@0?EV[0?ofkP3om^h0ooK^100mFJ]W
0?ofkP030000003om^h0ooK^01D0ooK^00<000000?ofkP3om^h0OP3om^h10?ooo`00R03om^h90000
03`0ooK^1@0mFJ/;0?ofkP0303eIZ`3om^h0ooK^00/0ooK^100mFJ][0?ofkP030000003om^h0ooK^
01@0ooK^00<000000?ofkP3om^h0O`3om^h10?ooo`00T@3om^h8000003T0ooK^1`0mFJ/40?ofkP03
03eIZ`3om^h0ooK^00@0ooK^200mFJ]^0?ofkP030000003om^h0ooK^01<0ooK^00<000000?ofkP3o
m^h0P03om^h10?ooo`00V@3om^h8000003P0ooK^2`0mFJ]f0?ofkP030000003om^h0ooK^0180ooK^
00<000000?ofkP3om^h0P@3om^h10?ooo`00X@3om^h900000;00ooK^00<000000?ofkP3om^h04@3o
m^h00`000000ooK^0?ofkP220?ofkP40oooo002Z0?ofkPP00000Z03om^h00`000000ooK^0?ofkP0A
0?ofkP030000003om^h0ooK^0880ooK^0@3oool00;80ooK^2000002P0?ofkP030000003om^h0ooK^
0100ooK^00<000000?ofkP3om^h0P`3om^h10?ooo`00^P3om^h9000009L0ooK^00<000000?ofkP3o
m^h03`3om^h00`000000ooK^0?ofkP240?ofkP40oooo00330?ofkPP00000S`3om^h00`000000ooK^
0?ofkP0>0?ofkP030000003om^h0ooK^08D0ooK^0@3oool00</0ooK^200000280?ofkP030000003o
m^h0ooK^00`0ooK^00<000000?ofkP3om^h0QP3om^h10?ooo`00d`3om^h800000800ooK^00<00000
0?ofkP3om^h02`3om^h00`000000ooK^0?ofkP270?ofkP40oooo003K0?ofkPT00000M`3om^h00`00
0000ooK^0?ofkP0;0?ofkP030000003om^h0ooK^08L0ooK^0@3oool00>@0ooK^2000001_0?ofkP03
0000003om^h0ooK^00X0ooK^00<000000?ofkP3om^h0R03om^h10?ooo`00k03om^h8000006L0ooK^
00<000000?ofkP3om^h02@3om^h00`000000ooK^0?ofkP290?ofkP40oooo003d0?ofkPT00000GP3o
m^h00`000000ooK^0?ofkP080?ofkP030000003om^h0ooK^08X0ooK^0@3oool00?d0ooK^2000001F
0?ofkP030000003om^h0ooK^00L0ooK^00<000000?ofkP3om^h0R`3om^h10?ooo`00o`3om^h60?of
kPP00000CP3om^h00`000000ooK^0?ofkP060?ofkP030000003om^h0ooK^08`0ooK^0@3oool00?l0
ooK^3P3om^h9000004D0ooK^00<000000?ofkP3om^h01P3om^h00`000000ooK^0?ofkP2<0?ofkP40
oooo003o0?ofkQL0ooK^2000000m0?ofkP030000003om^h0ooK^00D0ooK^00<000000?ofkP3om^h0
S@3om^h10?ooo`00o`3om^hO0?ofkPP00000=@3om^h00`000000ooK^0?ofkP040?ofkP030000003o
m^h0ooK^08h0ooK^0@3oool00?l0ooK^9`3om^h9000002`0ooK^00<000000?ofkP3om^h00`3om^h0
0`000000ooK^0?ofkP2?0?ofkP40oooo003o0?ofkS00ooK^2000000U0?ofkP050000003om^h0ooK^
0?ofkP000000TP3om^h10?ooo`00o`3om^hh0?ofkPP000007@3om^h010000000ooK^0?ofkP00002C
0?ofkP40oooo003o0?ofkT00ooK^2@00000D0?ofkP040000003om^h0ooK^000009<0ooK^0@3oool0
0?l0ooK^B@3om^h8000000`0ooK^00<000000?ofkP000000U03om^h10?ooo`00o`3om^iA0?ofkPP0
0000103om^h2000009D0ooK^0@3oool00?l0ooK^F@3om^h5000009H0ooK^0@3oool00?l0ooK^m03o
m^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00
o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?of
kP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o
0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^
0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0
ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h1
0?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3o
m^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40
oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?of
k_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3o
ool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^
m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?oo
o`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd
0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo
003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0
ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool0
0?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03o
m^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00
o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?of
kP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o
0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^
0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0
ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h1
0?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3o
m^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40
oooo003o0?ofk_@0ooK^0@3oool00001\
\>"],
  ImageRangeCache->{{{0, 499}, {499, 0}} -> {-5.00005*^-06, -5.00005*^-06, \
0.00200403, 0.00200403}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
%%ImageSize: 500 500 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics3D
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Background color
1 .961 .933 r
MFill
% Scaling calculations
0 1 0 1 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 0 r
.25 Mabswid
[ ] 0 setdash
.11236 .44767 m
.06528 .69847 L
s
.06528 .69847 m
.60039 .8356 L
s
.60039 .8356 m
.59088 .60318 L
s
.59088 .60318 m
.11236 .44767 L
s
.36195 .03848 m
.93295 .30234 L
s
.93295 .30234 m
.99253 .5665 L
s
.99253 .5665 m
.33874 .3169 L
s
.33874 .3169 m
.36195 .03848 L
s
.11236 .44767 m
.06528 .69847 L
s
.06528 .69847 m
.33874 .3169 L
s
.33874 .3169 m
.36195 .03848 L
s
.36195 .03848 m
.11236 .44767 L
s
.59088 .60318 m
.93295 .30234 L
s
.93295 .30234 m
.99253 .5665 L
s
.99253 .5665 m
.60039 .8356 L
s
.60039 .8356 m
.59088 .60318 L
s
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
.24 .35 .67 r
.5 Mabswid
.447 .58135 m
.42857 .56253 L
s
.42857 .56253 m
.44572 .54453 L
s
.42857 .56253 m
.40755 .54684 L
s
.46216 .60261 m
.447 .58135 L
s
.447 .58135 m
.46445 .56364 L
s
.40755 .54684 m
.4244 .52855 L
s
.40755 .54684 m
.38469 .53486 L
s
.47346 .62555 m
.46216 .60261 L
s
.46216 .60261 m
.4799 .58518 L
s
.38469 .53486 m
.40124 .5163 L
s
.38469 .53486 m
.3608 .52709 L
s
.48042 .64934 m
.47346 .62555 L
s
.47346 .62555 m
.49148 .6084 L
s
.3608 .52709 m
.37708 .50827 L
s
.3608 .52709 m
.33678 .52391 L
s
.46445 .56364 m
.44572 .54453 L
s
.44572 .54453 m
.46342 .52595 L
s
.44572 .54453 m
.4244 .52855 L
s
.48268 .6731 m
.48042 .64934 L
s
.48042 .64934 m
.49869 .63245 L
s
.4799 .58518 m
.46445 .56364 L
s
.46445 .56364 m
.48246 .54535 L
s
.4244 .52855 m
.44179 .50967 L
s
.4244 .52855 m
.40124 .5163 L
s
.49148 .6084 m
.4799 .58518 L
s
.4799 .58518 m
.49822 .56719 L
s
.33678 .52391 m
.35282 .50487 L
s
.33678 .52391 m
.31356 .52555 L
s
.40124 .5163 m
.41833 .49713 L
s
.40124 .5163 m
.37708 .50827 L
s
.49869 .63245 m
.49148 .6084 L
s
.49148 .6084 m
.51009 .59069 L
s
.50117 .65643 m
.48268 .6731 L
s
.48002 .69588 m
.48268 .6731 L
s
.37708 .50827 m
.3939 .48884 L
s
.37708 .50827 m
.35282 .50487 L
s
.83 .24 .1 r
.6726 .57153 m
.68175 .54593 L
s
.64176 .56096 m
.6726 .57153 L
s
.6663 .59771 m
.6726 .57153 L
s
.68175 .54593 m
.69344 .5218 L
s
.65099 .53511 m
.68175 .54593 L
s
.24 .35 .67 r
.48246 .54535 m
.46342 .52595 L
s
.46342 .52595 m
.4817 .50675 L
s
.46342 .52595 m
.44179 .50967 L
s
.31356 .52555 m
.32938 .50634 L
s
.31356 .52555 m
.2921 .53211 L
s
.50117 .65643 m
.49869 .63245 L
s
.49869 .63245 m
.51757 .61499 L
s
.49822 .56719 m
.48246 .54535 L
s
.48246 .54535 m
.50107 .52646 L
s
.44179 .50967 m
.45975 .49016 L
s
.44179 .50967 m
.41833 .49713 L
s
.83 .24 .1 r
.63531 .58735 m
.6663 .59771 L
s
.66309 .62359 m
.6663 .59771 L
s
.69344 .5218 m
.70729 .49996 L
s
.66267 .51071 m
.69344 .5218 L
s
.24 .35 .67 r
.51009 .59069 m
.49822 .56719 L
s
.49822 .56719 m
.51714 .5486 L
s
.47238 .71672 m
.48002 .69588 L
s
.48002 .69588 m
.49867 .6794 L
s
.35282 .50487 m
.36938 .4852 L
s
.35282 .50487 m
.32938 .50634 L
s
.41833 .49713 m
.43599 .47732 L
s
.41833 .49713 m
.3939 .48884 L
s
.83 .24 .1 r
.63187 .61341 m
.66309 .62359 L
s
.66313 .64824 m
.66309 .62359 L
s
.24 .35 .67 r
.51757 .61499 m
.51009 .59069 L
s
.51009 .59069 m
.52932 .57239 L
s
.83 .24 .1 r
.65099 .53511 m
.64176 .56096 L
s
.61033 .55018 m
.64176 .56096 L
s
.64176 .56096 m
.63531 .58735 L
s
.66267 .51071 m
.65099 .53511 L
s
.61963 .52409 m
.65099 .53511 L
s
.24 .35 .67 r
.52027 .63921 m
.50117 .65643 L
s
.49867 .6794 m
.50117 .65643 L
s
.83 .24 .1 r
.70729 .49996 m
.72286 .48125 L
s
.67644 .48859 m
.70729 .49996 L
s
.24 .35 .67 r
.2921 .53211 m
.30775 .51278 L
s
.2921 .53211 m
.27335 .54349 L
s
.83 .24 .1 r
.60372 .5768 m
.63531 .58735 L
s
.63531 .58735 m
.63187 .61341 L
s
.67644 .48859 m
.66267 .51071 L
s
.63132 .49941 m
.66267 .51071 L
s
.24 .35 .67 r
.3939 .48884 m
.41127 .46875 L
s
.3939 .48884 m
.36938 .4852 L
s
.50107 .52646 m
.4817 .50675 L
s
.4817 .50675 m
.5006 .4869 L
s
.4817 .50675 m
.45975 .49016 L
s
.32938 .50634 m
.34573 .48648 L
s
.32938 .50634 m
.30775 .51278 L
s
.45991 .73466 m
.47238 .71672 L
s
.47238 .71672 m
.49113 .70039 L
s
.52027 .63921 m
.51757 .61499 L
s
.51757 .61499 m
.53707 .59696 L
s
.51714 .5486 m
.50107 .52646 L
s
.50107 .52646 m
.5203 .50694 L
s
.83 .24 .1 r
.63162 .63821 m
.66313 .64824 L
s
.66652 .67076 m
.66313 .64824 L
s
.60005 .60304 m
.63187 .61341 L
s
.63187 .61341 m
.63162 .63821 L
s
.24 .35 .67 r
.45975 .49016 m
.47832 .46999 L
s
.45975 .49016 m
.43599 .47732 L
s
.83 .24 .1 r
.61963 .52409 m
.61033 .55018 L
s
.57829 .5392 m
.61033 .55018 L
s
.61033 .55018 m
.60372 .5768 L
s
.63132 .49941 m
.61963 .52409 L
s
.58767 .51285 m
.61963 .52409 L
s
.69186 .46959 m
.67644 .48859 L
s
.64501 .477 m
.67644 .48859 L
s
.72286 .48125 m
.73962 .46644 L
s
.69186 .46959 m
.72286 .48125 L
s
.24 .35 .67 r
.52932 .57239 m
.51714 .5486 L
s
.51714 .5486 m
.5367 .52939 L
s
.49113 .70039 m
.49867 .6794 L
s
.49867 .6794 m
.51794 .66237 L
s
.83 .24 .1 r
.57152 .56604 m
.60372 .5768 L
s
.60372 .5768 m
.60005 .60304 L
s
.64501 .477 m
.63132 .49941 L
s
.59935 .48789 m
.63132 .49941 L
s
.24 .35 .67 r
.36938 .4852 m
.3865 .46487 L
s
.36938 .4852 m
.34573 .48648 L
s
.43599 .47732 m
.45425 .45684 L
s
.43599 .47732 m
.41127 .46875 L
s
.27335 .54349 m
.28888 .5241 L
s
.27335 .54349 m
.25823 .55936 L
s
.53707 .59696 m
.52932 .57239 L
s
.54001 .6214 m
.52027 .63921 L
s
.51794 .66237 m
.52027 .63921 L
s
.83 .24 .1 r
.5995 .62799 m
.63162 .63821 L
s
.63162 .63821 m
.63467 .66082 L
s
.56761 .59247 m
.60005 .60304 L
s
.60005 .60304 m
.5995 .62799 L
s
.58767 .51285 m
.57829 .5392 L
s
.57829 .5392 m
.57152 .56604 L
s
.59935 .48789 m
.58767 .51285 L
s
.55509 .50139 m
.58767 .51285 L
s
.24 .35 .67 r
.30775 .51278 m
.32393 .49279 L
s
.30775 .51278 m
.28888 .5241 L
s
.44296 .74882 m
.45991 .73466 L
s
.45991 .73466 m
.47868 .71843 L
s
.83 .24 .1 r
.66026 .4577 m
.64501 .477 L
s
.61295 .46519 m
.64501 .477 L
s
.70841 .45448 m
.69186 .46959 L
s
.66026 .4577 m
.69186 .46959 L
s
.63467 .66082 m
.66652 .67076 L
s
.67325 .6902 m
.66652 .67076 L
s
.24 .35 .67 r
.41127 .46875 m
.42924 .44798 L
s
.41127 .46875 m
.3865 .46487 L
s
.83 .24 .1 r
.57152 .56604 m
.56761 .59247 L
s
.73962 .46644 m
.757 .45621 L
s
.70841 .45448 m
.73962 .46644 L
s
.61295 .46519 m
.59935 .48789 L
s
.56677 .47615 m
.59935 .48789 L
s
.24 .35 .67 r
.5203 .50694 m
.5006 .4869 L
s
.5006 .4869 m
.47832 .46999 L
s
.34573 .48648 m
.36264 .46595 L
s
.34573 .48648 m
.32393 .49279 L
s
.47868 .71843 m
.49113 .70039 L
s
.49113 .70039 m
.51051 .6835 L
s
.54001 .6214 m
.53707 .59696 L
s
.5367 .52939 m
.5203 .50694 L
s
.47832 .46999 m
.49752 .44914 L
s
.47832 .46999 m
.45425 .45684 L
s
.25823 .55936 m
.27371 .53999 L
s
.25823 .55936 m
.24757 .57919 L
s
.83 .24 .1 r
.56675 .61756 m
.5995 .62799 L
s
.5995 .62799 m
.60219 .6507 L
s
.56761 .59247 m
.56675 .61756 L
s
.96 .271 .113 r
.52687 .52168 m .54043 .52633 L .54449 .55007 L p F P
0 0 0 r
s
.96 .271 .113 r
.54449 .55007 m .52958 .54506 L .52687 .52168 L p F P
0 0 0 r
s
.939 .263 .11 r
.52958 .54506 m .54449 .55007 L .54757 .57274 L p F P
0 0 0 r
s
.24 .35 .67 r
.52932 .57239 m
.54045 .56179 L
s
.169 .243 .509 r
.55732 .56361 m .54757 .57274 L .54449 .55007 L p F P
0 0 0 r
s
.83 .24 .1 r
.55411 .56022 m
.57152 .56604 L
s
.169 .243 .509 r
.54449 .55007 m .55357 .54137 L .55732 .56361 L p F P
0 0 0 r
s
.19 .276 .57 r
.55357 .54137 m .54449 .55007 L .54043 .52633 L p F P
0 0 0 r
s
.83 .24 .1 r
.54563 .528 m
.57829 .5392 L
s
.24 .35 .67 r
.51051 .6835 m
.51794 .66237 L
s
.51794 .66237 m
.53787 .64475 L
s
.83 .24 .1 r
.54563 .528 m
.55509 .50139 L
s
.54478 .53131 m
.54563 .528 L
s
.56677 .47615 m
.55509 .50139 L
s
.977 .277 .116 r
.52355 .49774 m .53545 .5019 L .54043 .52633 L p F P
0 0 0 r
s
.24 .35 .67 r
.5203 .50694 m
.52573 .50143 L
s
.977 .277 .116 r
.54043 .52633 m .52687 .52168 L .52355 .49774 L p F P
0 0 0 r
s
.19 .276 .57 r
.54043 .52633 m .54865 .51826 L .55357 .54137 L p F P
0 0 0 r
s
.209 .305 .622 r
.54865 .51826 m .54043 .52633 L .53545 .5019 L p F P
0 0 0 r
s
.83 .24 .1 r
.62804 .44558 m
.61295 .46519 L
s
.58027 .45314 m
.61295 .46519 L
s
.67658 .4423 m
.66026 .4577 L
s
.62804 .44558 m
.66026 .4577 L
s
.24 .35 .67 r
.3865 .46487 m
.40421 .44384 L
s
.3865 .46487 m
.36264 .46595 L
s
.83 .24 .1 r
.60219 .6507 m
.63467 .66082 L
s
.63467 .66082 m
.64101 .68032 L
s
.939 .263 .11 r
.54757 .57274 m .53164 .56749 L .52958 .54506 L p F P
0 0 0 r
s
.24 .35 .67 r
.54078 .53724 m
.5492 .55347 L
s
.83 .24 .1 r
.53869 .55507 m
.54336 .53684 L
s
.24 .35 .67 r
.54466 .55778 m
.5492 .55347 L
s
.83 .24 .1 r
.53869 .55507 m
.54614 .55756 L
s
.912 .254 .105 r
.53164 .56749 m .54757 .57274 L .54962 .59394 L p F P
0 0 0 r
s
.24 .35 .67 r
.53707 .59696 m
.54604 .58867 L
s
.144 .204 .437 r
.55981 .58459 m .54962 .59394 L .54757 .57274 L p F P
0 0 0 r
s
.83 .24 .1 r
.55552 .58853 m
.56761 .59247 L
s
.144 .204 .437 r
.54757 .57274 m .55732 .56361 L .55981 .58459 L p F P
0 0 0 r
s
.24 .35 .67 r
.45425 .45684 m
.47313 .43566 L
s
.45425 .45684 m
.42924 .44798 L
s
.28888 .5241 m
.30495 .50405 L
s
.28888 .5241 m
.27371 .53999 L
s
.83 .24 .1 r
.7255 .44399 m
.70841 .45448 L
s
.67658 .4423 m
.70841 .45448 L
s
.99 .283 .119 r
.51968 .47365 m .52965 .4772 L .53545 .5019 L p F P
0 0 0 r
s
.99 .283 .119 r
.53545 .5019 m .52355 .49774 L .51968 .47365 L p F P
0 0 0 r
s
.209 .305 .622 r
.53545 .5019 m .54263 .49468 L .54865 .51826 L p F P
0 0 0 r
s
.83 .24 .1 r
.54329 .49724 m
.55509 .50139 L
s
.226 .331 .669 r
.54263 .49468 m .53545 .5019 L .52965 .4772 L p F P
0 0 0 r
s
.83 .24 .1 r
.58027 .45314 m
.56677 .47615 L
s
.24 .35 .67 r
.42216 .75839 m
.44296 .74882 L
s
.44296 .74882 m
.46169 .73262 L
s
.96 .271 .113 r
.5132 .517 m .52687 .52168 L .52958 .54506 L p F P
0 0 0 r
s
.96 .271 .113 r
.52958 .54506 m .51454 .54001 L .5132 .517 L p F P
0 0 0 r
s
.939 .263 .11 r
.51454 .54001 m .52958 .54506 L .53164 .56749 L p F P
0 0 0 r
s
.977 .277 .116 r
.51157 .49355 m .52355 .49774 L .52687 .52168 L p F P
0 0 0 r
s
.977 .277 .116 r
.52687 .52168 m .5132 .517 L .51157 .49355 L p F P
0 0 0 r
s
.83 .24 .1 r
.64101 .68032 m
.67325 .6902 L
s
.68318 .70568 m
.67325 .6902 L
s
.912 .254 .105 r
.54962 .59394 m .53301 .58856 L .53164 .56749 L p F P
0 0 0 r
s
.83 .24 .1 r
.53453 .58169 m
.53869 .55507 L
s
.53453 .58169 m
.54949 .58656 L
s
.877 .242 .1 r
.53301 .58856 m .54962 .59394 L .55059 .61329 L p F P
0 0 0 r
s
.113 .157 .348 r
.56099 .60393 m .55059 .61329 L .54962 .59394 L p F P
0 0 0 r
s
.113 .157 .348 r
.54962 .59394 m .55981 .58459 L .56099 .60393 L p F P
0 0 0 r
s
.24 .35 .67 r
.54808 .58677 m
.55724 .5783 L
s
.939 .263 .11 r
.53164 .56749 m .51556 .56218 L .51454 .54001 L p F P
0 0 0 r
s
.912 .254 .105 r
.51556 .56218 m .53164 .56749 L .53301 .58856 L p F P
0 0 0 r
s
.169 .243 .509 r
.56723 .55433 m .55732 .56361 L .55357 .54137 L p F P
0 0 0 r
s
.169 .243 .509 r
.55357 .54137 m .5628 .53252 L .56723 .55433 L p F P
0 0 0 r
s
.24 .35 .67 r
.5492 .55347 m
.55724 .5783 L
s
.19 .276 .57 r
.5628 .53252 m .55357 .54137 L .54865 .51826 L p F P
0 0 0 r
s
.19 .276 .57 r
.54865 .51826 m .55699 .51007 L .5628 .53252 L p F P
0 0 0 r
s
.209 .305 .622 r
.55699 .51007 m .54865 .51826 L .54263 .49468 L p F P
0 0 0 r
s
.99 .283 .119 r
.50966 .47008 m .51968 .47365 L .52355 .49774 L p F P
0 0 0 r
s
.24 .35 .67 r
.5006 .4869 m
.51206 .47486 L
s
.99 .283 .119 r
.52355 .49774 m .51157 .49355 L .50966 .47008 L p F P
0 0 0 r
s
.24 .35 .67 r
.32393 .49279 m
.34067 .47212 L
s
.32393 .49279 m
.30495 .50405 L
s
.46169 .73262 m
.47868 .71843 L
s
.47868 .71843 m
.49811 .70163 L
s
.83 .24 .1 r
.757 .45621 m
.77432 .4512 L
s
.7255 .44399 m
.757 .45621 L
s
.977 .277 .116 r
.4995 .48933 m .51157 .49355 L .5132 .517 L p F P
0 0 0 r
s
.977 .277 .116 r
.5132 .517 m .49943 .51227 L .4995 .48933 L p F P
0 0 0 r
s
.96 .271 .113 r
.49943 .51227 m .5132 .517 L .51454 .54001 L p F P
0 0 0 r
s
.96 .271 .113 r
.51454 .54001 m .49937 .53491 L .49943 .51227 L p F P
0 0 0 r
s
.83 .24 .1 r
.51233 .51658 m
.54143 .52656 L
s
.939 .263 .11 r
.49937 .53491 m .51454 .54001 L .51556 .56218 L p F P
0 0 0 r
s
.83 .24 .1 r
.56675 .61756 m
.56907 .64037 L
s
.24 .35 .67 r
.42924 .44798 m
.44783 .4265 L
s
.42924 .44798 m
.40421 .44384 L
s
.144 .204 .437 r
.57018 .57508 m .55981 .58459 L .55732 .56361 L p F P
0 0 0 r
s
.144 .204 .437 r
.55732 .56361 m .56723 .55433 L .57018 .57508 L p F P
0 0 0 r
s
.83 .24 .1 r
.51233 .51658 m
.52187 .48971 L
s
1 .287 .121 r
.51532 .44983 m .52309 .45265 L .52965 .4772 L p F P
0 0 0 r
s
1 .287 .121 r
.52965 .4772 m .51968 .47365 L .51532 .44983 L p F P
0 0 0 r
s
.24 .35 .67 r
.51485 .47193 m
.51864 .46795 L
s
.226 .331 .669 r
.52965 .4772 m .53561 .47104 L .54263 .49468 L p F P
0 0 0 r
s
.83 .24 .1 r
.52187 .48971 m
.53462 .4942 L
s
.241 .354 .711 r
.53561 .47104 m .52965 .4772 L .52309 .45265 L p F P
0 0 0 r
s
.209 .305 .622 r
.54263 .49468 m .54989 .48737 L .55699 .51007 L p F P
0 0 0 r
s
.226 .331 .669 r
.54989 .48737 m .54263 .49468 L .53561 .47104 L p F P
0 0 0 r
s
.83 .24 .1 r
.53354 .46417 m
.56677 .47615 L
s
.24 .35 .67 r
.53252 .49453 m
.54018 .48675 L
s
.83 .24 .1 r
.52187 .48971 m
.53019 .4715 L
s
.53249 .46646 m
.53354 .46417 L
s
.912 .254 .105 r
.53301 .58856 m .51624 .58313 L .51556 .56218 L p F P
0 0 0 r
s
.877 .242 .1 r
.51624 .58313 m .53301 .58856 L .53366 .60791 L p F P
0 0 0 r
s
.877 .242 .1 r
.55059 .61329 m .53366 .60791 L .53301 .58856 L p F P
0 0 0 r
s
.83 .24 .1 r
.59518 .43322 m
.58027 .45314 L
s
.99 .283 .119 r
.49958 .46649 m .50966 .47008 L .51157 .49355 L p F P
0 0 0 r
s
.99 .283 .119 r
.51157 .49355 m .4995 .48933 L .49958 .46649 L p F P
0 0 0 r
s
.939 .263 .11 r
.51556 .56218 m .49932 .55683 L .49937 .53491 L p F P
0 0 0 r
s
.83 .24 .1 r
.50521 .54388 m
.51233 .51658 L
s
.50521 .54388 m
.53869 .55507 L
s
.912 .254 .105 r
.49932 .55683 m .51556 .56218 L .51624 .58313 L p F P
0 0 0 r
s
.83 .24 .1 r
.64411 .42987 m
.62804 .44558 L
s
.59518 .43322 m
.62804 .44558 L
s
.56907 .64037 m
.60219 .6507 L
s
.60219 .6507 m
.60813 .67024 L
s
.24 .35 .67 r
.24757 .57919 m
.26305 .55992 L
s
.24757 .57919 m
.24202 .6022 L
s
.52587 .47221 m
.54018 .48675 L
s
.36264 .46595 m
.38013 .44471 L
s
.36264 .46595 m
.34067 .47212 L
s
.49811 .70163 m
.51051 .6835 L
s
.51051 .6835 m
.53057 .66603 L
s
.977 .277 .116 r
.48734 .48509 m .4995 .48933 L .49943 .51227 L p F P
0 0 0 r
s
.977 .277 .116 r
.49943 .51227 m .48554 .50751 L .48734 .48509 L p F P
0 0 0 r
s
.96 .271 .113 r
.48554 .50751 m .49943 .51227 L .49937 .53491 L p F P
0 0 0 r
s
1 .287 .121 r
.50752 .447 m .51532 .44983 L .51968 .47365 L p F P
0 0 0 r
s
1 .287 .121 r
.51968 .47365 m .50966 .47008 L .50752 .447 L p F P
0 0 0 r
s
.24 .35 .67 r
.49752 .44914 m
.50849 .45751 L
s
.96 .271 .113 r
.49937 .53491 m .48406 .52976 L .48554 .50751 L p F P
0 0 0 r
s
.939 .263 .11 r
.48406 .52976 m .49937 .53491 L .49932 .55683 L p F P
0 0 0 r
s
.83 .226 .093 r
.53366 .60791 m .55059 .61329 L .55044 .63042 L p F P
0 0 0 r
s
.24 .35 .67 r
.54001 .6214 m
.54223 .6194 L
s
.53787 .64475 m
.54001 .6214 L
s
.079 .107 .249 r
.56081 .62123 m .55044 .63042 L .55059 .61329 L p F P
0 0 0 r
s
.079 .107 .249 r
.55059 .61329 m .56099 .60393 L .56081 .62123 L p F P
0 0 0 r
s
.83 .24 .1 r
.56087 .61568 m
.56675 .61756 L
s
.69338 .43152 m
.67658 .4423 L
s
.64411 .42987 m
.67658 .4423 L
s
.5301 .46294 m
.53354 .46417 L
s
.19 .276 .57 r
.57217 .52354 m .5628 .53252 L .55699 .51007 L p F P
0 0 0 r
s
.19 .276 .57 r
.55699 .51007 m .56544 .50177 L .57217 .52354 L p F P
0 0 0 r
s
.209 .305 .622 r
.56544 .50177 m .55699 .51007 L .54989 .48737 L p F P
0 0 0 r
s
.24 .35 .67 r
.53924 .5269 m
.55693 .50952 L
s
.99 .283 .119 r
.48944 .46288 m .49958 .46649 L .4995 .48933 L p F P
0 0 0 r
s
.99 .283 .119 r
.4995 .48933 m .48734 .48509 L .48944 .46288 L p F P
0 0 0 r
s
.113 .157 .348 r
.57157 .5944 m .56099 .60393 L .55981 .58459 L p F P
0 0 0 r
s
.113 .157 .348 r
.55981 .58459 m .57018 .57508 L .57157 .5944 L p F P
0 0 0 r
s
.24 .35 .67 r
.55724 .5783 m
.56044 .60298 L
s
.169 .243 .509 r
.5773 .54489 m .56723 .55433 L .5628 .53252 L p F P
0 0 0 r
s
.169 .243 .509 r
.5628 .53252 m .57217 .52354 L .5773 .54489 L p F P
0 0 0 r
s
.226 .331 .669 r
.53561 .47104 m .54164 .46482 L .54989 .48737 L p F P
0 0 0 r
s
.24 .35 .67 r
.54018 .48675 m
.55693 .50952 L
s
.241 .354 .711 r
.54164 .46482 m .53561 .47104 L .52771 .44776 L p F P
0 0 0 r
s
.241 .354 .711 r
.52309 .45265 m .52771 .44776 L .53561 .47104 L p F P
0 0 0 r
s
.83 .24 .1 r
.60813 .67024 m
.64101 .68032 L
s
.64101 .68032 m
.65054 .6958 L
s
.939 .263 .11 r
.49932 .55683 m .48293 .55142 L .48406 .52976 L p F P
0 0 0 r
s
.912 .254 .105 r
.48293 .55142 m .49932 .55683 L .49929 .57765 L p F P
0 0 0 r
s
.912 .254 .105 r
.51624 .58313 m .49929 .57765 L .49932 .55683 L p F P
0 0 0 r
s
.83 .24 .1 r
.5008 .57069 m
.50521 .54388 L
s
1 .287 .121 r
.49967 .44416 m .50752 .447 L .50966 .47008 L p F P
0 0 0 r
s
1 .287 .121 r
.50966 .47008 m .49958 .46649 L .49967 .44416 L p F P
0 0 0 r
s
.24 .35 .67 r
.49752 .44914 m
.49966 .44681 L
s
.877 .242 .1 r
.49929 .57765 m .51624 .58313 L .51656 .60246 L p F P
0 0 0 r
s
.83 .24 .1 r
.5008 .57069 m
.53453 .58169 L
s
.877 .242 .1 r
.53366 .60791 m .51656 .60246 L .51624 .58313 L p F P
0 0 0 r
s
.209 .305 .622 r
.54989 .48737 m .55725 .47997 L .56544 .50177 L p F P
0 0 0 r
s
.226 .331 .669 r
.55725 .47997 m .54989 .48737 L .54164 .46482 L p F P
0 0 0 r
s
.24 .35 .67 r
.27371 .53999 m
.28972 .51995 L
s
.27371 .53999 m
.26305 .55992 L
s
.39833 .76276 m
.42216 .75839 L
s
.42216 .75839 m
.44076 .74215 L
s
.977 .277 .116 r
.4751 .48081 m .48734 .48509 L .48554 .50751 L p F P
0 0 0 r
s
.977 .277 .116 r
.48554 .50751 m .47154 .50272 L .4751 .48081 L p F P
0 0 0 r
s
.96 .271 .113 r
.47154 .50272 m .48554 .50751 L .48406 .52976 L p F P
0 0 0 r
s
.96 .271 .113 r
.48406 .52976 m .46862 .52457 L .47154 .50272 L p F P
0 0 0 r
s
.83 .24 .1 r
.47836 .50494 m
.51233 .51658 L
s
.939 .263 .11 r
.46862 .52457 m .48406 .52976 L .48293 .55142 L p F P
0 0 0 r
s
.144 .204 .437 r
.58072 .56541 m .57018 .57508 L .56723 .55433 L p F P
0 0 0 r
s
.144 .204 .437 r
.56723 .55433 m .5773 .54489 L .58072 .56541 L p F P
0 0 0 r
s
.24 .35 .67 r
.5492 .55347 m
.56976 .5339 L
s
.83 .226 .093 r
.51656 .60246 m .53366 .60791 L .53356 .62513 L p F P
0 0 0 r
s
.83 .24 .1 r
.53335 .60692 m
.53453 .58169 L
s
.83 .226 .093 r
.55044 .63042 m .53356 .62513 L .53366 .60791 L p F P
0 0 0 r
s
.83 .24 .1 r
.53335 .60692 m
.55132 .61264 L
s
.24 .35 .67 r
.54941 .61292 m
.56044 .60298 L
s
.99 .283 .119 r
.47924 .45925 m .48944 .46288 L .48734 .48509 L p F P
0 0 0 r
s
.83 .24 .1 r
.48799 .4778 m
.52187 .48971 L
s
.99 .283 .119 r
.48734 .48509 m .4751 .48081 L .47924 .45925 L p F P
0 0 0 r
s
.83 .24 .1 r
.74249 .43872 m
.7255 .44399 L
s
.69338 .43152 m
.7255 .44399 L
s
1 .291 .123 r
.51054 .42672 m .51589 .42869 L .52309 .45265 L p F P
0 0 0 r
s
1 .291 .123 r
.52309 .45265 m .51532 .44983 L .51054 .42672 L p F P
0 0 0 r
s
.255 .376 .751 r
.52771 .44776 m .52309 .45265 L .51589 .42869 L p F P
0 0 0 r
s
.24 .35 .67 r
.40421 .44384 m
.42254 .42208 L
s
.40421 .44384 m
.38013 .44471 L
s
1 .287 .121 r
.4918 .4413 m .49967 .44416 L .49958 .46649 L p F P
0 0 0 r
s
.83 .24 .1 r
.49965 .45196 m
.52678 .46174 L
s
1 .287 .121 r
.49958 .46649 m .48944 .46288 L .4918 .4413 L p F P
0 0 0 r
s
.24 .35 .67 r
.47313 .43566 m
.49131 .44571 L
s
.83 .24 .1 r
.47836 .50494 m
.48799 .4778 L
s
.226 .331 .669 r
.54164 .46482 m .54773 .45853 L .55725 .47997 L p F P
0 0 0 r
s
.241 .354 .711 r
.54773 .45853 m .54164 .46482 L .53236 .44283 L p F P
0 0 0 r
s
.83 .24 .1 r
.53667 .45873 m
.53805 .45632 L
s
.54694 .44085 m
.58027 .45314 L
s
.241 .354 .711 r
.52771 .44776 m .53236 .44283 L .54164 .46482 L p F P
0 0 0 r
s
.83 .24 .1 r
.54083 .45148 m
.54694 .44085 L
s
.24 .35 .67 r
.30495 .50405 m
.32157 .4833 L
s
.30495 .50405 m
.28972 .51995 L
s
.939 .263 .11 r
.48293 .55142 m .46639 .54597 L .46862 .52457 L p F P
0 0 0 r
s
.83 .24 .1 r
.47107 .53248 m
.50521 .54388 L
s
.912 .254 .105 r
.46639 .54597 m .48293 .55142 L .48218 .57211 L p F P
0 0 0 r
s
.912 .254 .105 r
.49929 .57765 m .48218 .57211 L .48293 .55142 L p F P
0 0 0 r
s
.977 .277 .116 r
.46277 .4765 m .4751 .48081 L .47154 .50272 L p F P
0 0 0 r
s
.977 .277 .116 r
.47154 .50272 m .45743 .49788 L .46277 .4765 L p F P
0 0 0 r
s
.96 .271 .113 r
.45743 .49788 m .47154 .50272 L .46862 .52457 L p F P
0 0 0 r
s
.83 .24 .1 r
.47107 .53248 m
.47836 .50494 L
s
1 .291 .123 r
.50516 .42474 m .51054 .42672 L .51532 .44983 L p F P
0 0 0 r
s
1 .291 .123 r
.51532 .44983 m .50752 .447 L .50516 .42474 L p F P
0 0 0 r
s
.24 .35 .67 r
.5015 .44482 m
.50669 .43918 L
s
.877 .242 .1 r
.48218 .57211 m .49929 .57765 L .49928 .59697 L p F P
0 0 0 r
s
.877 .242 .1 r
.51656 .60246 m .49928 .59697 L .49929 .57765 L p F P
0 0 0 r
s
.83 .24 .1 r
.49929 .59608 m
.5008 .57069 L
s
.611 .41719 m
.59518 .43322 L
s
.56166 .4206 m
.59518 .43322 L
s
.56907 .64037 m
.57459 .65996 L
s
.24 .35 .67 r
.44076 .74215 m
.46169 .73262 L
s
.46169 .73262 m
.48108 .71585 L
s
.83 .24 .1 r
.65054 .6958 m
.68318 .70568 L
s
.69607 .71638 m
.68318 .70568 L
s
.19 .276 .57 r
.58169 .51442 m .57217 .52354 L .56544 .50177 L p F P
0 0 0 r
s
.19 .276 .57 r
.56544 .50177 m .57402 .49335 L .58169 .51442 L p F P
0 0 0 r
s
.24 .35 .67 r
.55693 .50952 m
.56976 .5339 L
s
.209 .305 .622 r
.57402 .49335 m .56544 .50177 L .55725 .47997 L p F P
0 0 0 r
s
.99 .283 .119 r
.46898 .45559 m .47924 .45925 L .4751 .48081 L p F P
0 0 0 r
s
.99 .283 .119 r
.4751 .48081 m .46277 .4765 L .46898 .45559 L p F P
0 0 0 r
s
.079 .107 .249 r
.57136 .61188 m .56081 .62123 L .56099 .60393 L p F P
0 0 0 r
s
.079 .107 .249 r
.56099 .60393 m .57157 .5944 L .57136 .61188 L p F P
0 0 0 r
s
1 .287 .121 r
.48388 .43843 m .4918 .4413 L .48944 .46288 L p F P
0 0 0 r
s
1 .287 .121 r
.48944 .46288 m .47924 .45925 L .48388 .43843 L p F P
0 0 0 r
s
.83 .24 .1 r
.48799 .4778 m
.49965 .45196 L
s
.96 .271 .113 r
.46862 .52457 m .45303 .51933 L .45743 .49788 L p F P
0 0 0 r
s
.939 .263 .11 r
.45303 .51933 m .46862 .52457 L .46639 .54597 L p F P
0 0 0 r
s
.209 .305 .622 r
.55725 .47997 m .56469 .47247 L .57402 .49335 L p F P
0 0 0 r
s
.226 .331 .669 r
.56469 .47247 m .55725 .47997 L .54773 .45853 L p F P
0 0 0 r
s
.255 .376 .751 r
.53236 .44283 m .52771 .44776 L .51904 .42527 L p F P
0 0 0 r
s
.255 .376 .751 r
.51589 .42869 m .51904 .42527 L .52771 .44776 L p F P
0 0 0 r
s
.047 .067 .154 r
.55923 .63611 m .54914 .64493 L .55044 .63042 L p F P
0 0 0 r
s
.83 .24 .1 r
.55822 .63698 m
.56907 .64037 L
s
.047 .067 .154 r
.55044 .63042 m .56081 .62123 L .55923 .63611 L p F P
0 0 0 r
s
.765 .205 .084 r
.53356 .62513 m .55044 .63042 L .54914 .64493 L p F P
0 0 0 r
s
.24 .35 .67 r
.53787 .64475 m
.54443 .63895 L
s
.169 .243 .509 r
.58754 .53529 m .5773 .54489 L .57217 .52354 L p F P
0 0 0 r
s
.169 .243 .509 r
.57217 .52354 m .58169 .51442 L .58754 .53529 L p F P
0 0 0 r
s
1 .291 .123 r
.49978 .42275 m .50516 .42474 L .50752 .447 L p F P
0 0 0 r
s
1 .291 .123 r
.50752 .447 m .49967 .44416 L .49978 .42275 L p F P
0 0 0 r
s
.83 .226 .093 r
.49928 .59697 m .51656 .60246 L .51651 .61979 L p F P
0 0 0 r
s
.83 .226 .093 r
.53356 .62513 m .51651 .61979 L .51656 .60246 L p F P
0 0 0 r
s
.113 .157 .348 r
.58234 .5847 m .57157 .5944 L .57018 .57508 L p F P
0 0 0 r
s
.113 .157 .348 r
.57018 .57508 m .58072 .56541 L .58234 .5847 L p F P
0 0 0 r
s
.24 .35 .67 r
.24202 .6022 m
.25759 .58311 L
s
.24202 .6022 m
.24203 .62739 L
s
.83 .24 .1 r
.6606 .4188 m
.64411 .42987 L
s
.611 .41719 m
.64411 .42987 L
s
.77432 .4512 m
.79087 .45184 L
s
.74249 .43872 m
.77432 .4512 L
s
.24 .35 .67 r
.34067 .47212 m
.35799 .45071 L
s
.34067 .47212 m
.32157 .4833 L
s
1 .287 .121 r
.47593 .43555 m .48388 .43843 L .47924 .45925 L p F P
0 0 0 r
s
1 .287 .121 r
.47924 .45925 m .46898 .45559 L .47593 .43555 L p F P
0 0 0 r
s
.24 .35 .67 r
.44783 .4265 m
.47313 .43566 L
s
.977 .277 .116 r
.45036 .47216 m .46277 .4765 L .45743 .49788 L p F P
0 0 0 r
s
.977 .277 .116 r
.45743 .49788 m .4432 .493 L .45036 .47216 L p F P
0 0 0 r
s
.96 .271 .113 r
.4432 .493 m .45743 .49788 L .45303 .51933 L p F P
0 0 0 r
s
.99 .283 .119 r
.45866 .45192 m .46898 .45559 L .46277 .4765 L p F P
0 0 0 r
s
.99 .283 .119 r
.46277 .4765 m .45036 .47216 L .45866 .45192 L p F P
0 0 0 r
s
.226 .331 .669 r
.54773 .45853 m .55388 .45218 L .56469 .47247 L p F P
0 0 0 r
s
.241 .354 .711 r
.55388 .45218 m .54773 .45853 L .53705 .43787 L p F P
0 0 0 r
s
.241 .354 .711 r
.53236 .44283 m .53705 .43787 L .54773 .45853 L p F P
0 0 0 r
s
.24 .35 .67 r
.52414 .46218 m
.54035 .44515 L
s
.939 .263 .11 r
.46639 .54597 m .44968 .54046 L .45303 .51933 L p F P
0 0 0 r
s
.912 .254 .105 r
.44968 .54046 m .46639 .54597 L .4649 .56651 L p F P
0 0 0 r
s
.912 .254 .105 r
.48218 .57211 m .4649 .56651 L .46639 .54597 L p F P
0 0 0 r
s
.83 .24 .1 r
.46639 .55948 m
.47107 .53248 L
s
1 .291 .123 r
.49437 .42076 m .49978 .42275 L .49967 .44416 L p F P
0 0 0 r
s
1 .291 .123 r
.49967 .44416 m .4918 .4413 L .49437 .42076 L p F P
0 0 0 r
s
.24 .35 .67 r
.48108 .71585 m
.49811 .70163 L
s
.49811 .70163 m
.51822 .68424 L
s
.83 .24 .1 r
.57459 .65996 m
.60813 .67024 L
s
.60813 .67024 m
.61723 .68572 L
s
.877 .242 .1 r
.4649 .56651 m .48218 .57211 L .48183 .59142 L p F P
0 0 0 r
s
.83 .24 .1 r
.46639 .55948 m
.5008 .57069 L
s
.877 .242 .1 r
.49928 .59697 m .48183 .59142 L .48218 .57211 L p F P
0 0 0 r
s
.144 .204 .437 r
.59145 .55556 m .58072 .56541 L .5773 .54489 L p F P
0 0 0 r
s
.24 .35 .67 r
.55724 .5783 m
.57812 .559 L
s
.144 .204 .437 r
.5773 .54489 m .58754 .53529 L .59145 .55556 L p F P
0 0 0 r
s
.24 .35 .67 r
.56976 .5339 m
.57812 .559 L
s
.44783 .4265 m
.42254 .42208 L
s
.255 .376 .751 r
.53705 .43787 m .53236 .44283 L .52221 .42183 L p F P
0 0 0 r
s
.83 .24 .1 r
.53613 .43687 m
.54694 .44085 L
s
.255 .376 .751 r
.51904 .42527 m .52221 .42183 L .53236 .44283 L p F P
0 0 0 r
s
.96 .271 .113 r
.45303 .51933 m .43731 .51404 L .4432 .493 L p F P
0 0 0 r
s
.83 .24 .1 r
.44372 .49306 m
.47836 .50494 L
s
.939 .263 .11 r
.43731 .51404 m .45303 .51933 L .44968 .54046 L p F P
0 0 0 r
s
.24 .35 .67 r
.37254 .76154 m
.39833 .76276 L
s
.39833 .76276 m
.41672 .74641 L
s
.765 .205 .084 r
.51651 .61979 m .53356 .62513 L .53269 .63986 L p F P
0 0 0 r
s
.765 .205 .084 r
.54914 .64493 m .53269 .63986 L .53356 .62513 L p F P
0 0 0 r
s
.83 .24 .1 r
.53335 .60692 m
.53529 .62983 L
s
.24 .35 .67 r
.53057 .66603 m
.53787 .64475 L
s
.54913 .6348 m
.5585 .62652 L
s
.83 .24 .1 r
.53529 .62983 m
.55057 .6346 L
s
1 .291 .123 r
.48895 .41876 m .49437 .42076 L .4918 .4413 L p F P
0 0 0 r
s
1 .291 .123 r
.4918 .4413 m .48388 .43843 L .48895 .41876 L p F P
0 0 0 r
s
1 .287 .121 r
.46794 .43265 m .47593 .43555 L .46898 .45559 L p F P
0 0 0 r
s
1 .287 .121 r
.46898 .45559 m .45866 .45192 L .46794 .43265 L p F P
0 0 0 r
s
.83 .226 .093 r
.48183 .59142 m .49928 .59697 L .49928 .6144 L p F P
0 0 0 r
s
.83 .226 .093 r
.51651 .61979 m .49928 .6144 L .49928 .59697 L p F P
0 0 0 r
s
.83 .24 .1 r
.49929 .59608 m
.53335 .60692 L
s
.71001 .42599 m
.69338 .43152 L
s
.6606 .4188 m
.69338 .43152 L
s
.209 .305 .622 r
.58272 .48481 m .57402 .49335 L .56469 .47247 L p F P
0 0 0 r
s
.209 .305 .622 r
.56469 .47247 m .57223 .46489 L .58272 .48481 L p F P
0 0 0 r
s
.226 .331 .669 r
.57223 .46489 m .56469 .47247 L .55388 .45218 L p F P
0 0 0 r
s
.24 .35 .67 r
.54018 .48675 m
.56076 .46586 L
s
.19 .276 .57 r
.59135 .50516 m .58169 .51442 L .57402 .49335 L p F P
0 0 0 r
s
.19 .276 .57 r
.57402 .49335 m .58272 .48481 L .59135 .50516 L p F P
0 0 0 r
s
.24 .35 .67 r
.55693 .50952 m
.57787 .48896 L
s
.99 .283 .119 r
.44827 .44822 m .45866 .45192 L .45036 .47216 L p F P
0 0 0 r
s
.83 .24 .1 r
.45344 .46565 m
.48799 .4778 L
s
.99 .283 .119 r
.45036 .47216 m .43785 .46779 L .44827 .44822 L p F P
0 0 0 r
s
.977 .277 .116 r
.43785 .46779 m .45036 .47216 L .4432 .493 L p F P
0 0 0 r
s
.977 .277 .116 r
.4432 .493 m .42885 .48808 L .43785 .46779 L p F P
0 0 0 r
s
.96 .271 .113 r
.42885 .48808 m .4432 .493 L .43731 .51404 L p F P
0 0 0 r
s
.24 .35 .67 r
.26305 .55992 m
.27909 .53997 L
s
.26305 .55992 m
.25759 .58311 L
s
.54035 .44515 m
.56076 .46586 L
s
1 .293 .125 r
.5054 .40477 m .50815 .4058 L .51589 .42869 L p F P
0 0 0 r
s
1 .293 .125 r
.51589 .42869 m .51054 .42672 L .5054 .40477 L p F P
0 0 0 r
s
.269 .398 .788 r
.51904 .42527 m .51589 .42869 L .50815 .4058 L p F P
0 0 0 r
s
.83 .24 .1 r
.49965 .45196 m
.51295 .42832 L
s
.24 .35 .67 r
.51389 .43136 m
.51739 .42756 L
s
.83 .24 .1 r
.51295 .42832 m
.5189 .43051 L
s
.24 .35 .67 r
.38013 .44471 m
.35799 .45071 L
s
.83 .24 .1 r
.44372 .49306 m
.45344 .46565 L
s
.24 .35 .67 r
.51822 .68424 m
.53057 .66603 L
s
.56076 .46586 m
.57787 .48896 L
s
1 .291 .123 r
.48351 .41675 m .48895 .41876 L .48388 .43843 L p F P
0 0 0 r
s
.24 .35 .67 r
.47389 .43481 m
.48363 .42388 L
s
.48838 .41855 m
.49137 .4152 L
s
1 .291 .123 r
.48388 .43843 m .47593 .43555 L .48351 .41675 L p F P
0 0 0 r
s
.939 .263 .11 r
.44968 .54046 m .43282 .53489 L .43731 .51404 L p F P
0 0 0 r
s
.912 .254 .105 r
.43282 .53489 m .44968 .54046 L .44745 .56086 L p F P
0 0 0 r
s
.912 .254 .105 r
.4649 .56651 m .44745 .56086 L .44968 .54046 L p F P
0 0 0 r
s
.241 .354 .711 r
.53705 .43787 m .54178 .43286 L .55388 .45218 L p F P
0 0 0 r
s
.255 .376 .751 r
.54178 .43286 m .53705 .43787 L .5254 .41836 L p F P
0 0 0 r
s
.255 .376 .751 r
.52221 .42183 m .5254 .41836 L .53705 .43787 L p F P
0 0 0 r
s
.24 .35 .67 r
.51739 .42756 m
.54035 .44515 L
s
.226 .331 .669 r
.55388 .45218 m .56009 .44577 L .57223 .46489 L p F P
0 0 0 r
s
.241 .354 .711 r
.56009 .44577 m .55388 .45218 L .54178 .43286 L p F P
0 0 0 r
s
.83 .24 .1 r
.54904 .43797 m
.56166 .4206 L
s
.079 .107 .249 r
.58209 .60236 m .57136 .61188 L .57157 .5944 L p F P
0 0 0 r
s
.079 .107 .249 r
.57157 .5944 m .58234 .5847 L .58209 .60236 L p F P
0 0 0 r
s
.169 .243 .509 r
.59796 .52554 m .58754 .53529 L .58169 .51442 L p F P
0 0 0 r
s
.169 .243 .509 r
.58169 .51442 m .59135 .50516 L .59796 .52554 L p F P
0 0 0 r
s
1 .287 .121 r
.45992 .42974 m .46794 .43265 L .45866 .45192 L p F P
0 0 0 r
s
.83 .24 .1 r
.46507 .4395 m
.49965 .45196 L
s
1 .287 .121 r
.45866 .45192 m .44827 .44822 L .45992 .42974 L p F P
0 0 0 r
s
.877 .242 .1 r
.44745 .56086 m .4649 .56651 L .4642 .58581 L p F P
0 0 0 r
s
.877 .242 .1 r
.48183 .59142 m .4642 .58581 L .4649 .56651 L p F P
0 0 0 r
s
.83 .24 .1 r
.46453 .58501 m
.46639 .55948 L
s
1 .293 .125 r
.50264 .40374 m .5054 .40477 L .51054 .42672 L p F P
0 0 0 r
s
1 .293 .125 r
.51054 .42672 m .50516 .42474 L .50264 .40374 L p F P
0 0 0 r
s
.96 .271 .113 r
.43731 .51404 m .42144 .50871 L .42885 .48808 L p F P
0 0 0 r
s
.939 .263 .11 r
.42144 .50871 m .43731 .51404 L .43282 .53489 L p F P
0 0 0 r
s
.83 .24 .1 r
.43625 .52084 m
.44372 .49306 L
s
.43625 .52084 m
.47107 .53248 L
s
.047 .067 .154 r
.56948 .62713 m .55923 .63611 L .56081 .62123 L p F P
0 0 0 r
s
.24 .35 .67 r
.5585 .62652 m
.56044 .60298 L
s
.047 .067 .154 r
.56081 .62123 m .57136 .61188 L .56948 .62713 L p F P
0 0 0 r
s
.83 .24 .1 r
.61723 .68572 m
.65054 .6958 L
s
.65054 .6958 m
.663 .70644 L
s
.113 .157 .348 r
.5933 .57483 m .58234 .5847 L .58072 .56541 L p F P
0 0 0 r
s
.113 .157 .348 r
.58072 .56541 m .59145 .55556 L .5933 .57483 L p F P
0 0 0 r
s
.24 .35 .67 r
.57812 .559 m
.58158 .58391 L
s
.269 .398 .788 r
.52221 .42183 m .51904 .42527 L .50975 .40402 L p F P
0 0 0 r
s
.269 .398 .788 r
.50815 .4058 m .50975 .40402 L .51904 .42527 L p F P
0 0 0 r
s
.83 .24 .1 r
.51295 .42832 m
.51824 .42082 L
s
.24 .35 .67 r
.50835 .42251 m
.51739 .42756 L
s
1 .291 .123 r
.47805 .41474 m .48351 .41675 L .47593 .43555 L p F P
0 0 0 r
s
1 .291 .123 r
.47593 .43555 m .46794 .43265 L .47805 .41474 L p F P
0 0 0 r
s
.99 .283 .119 r
.43783 .4445 m .44827 .44822 L .43785 .46779 L p F P
0 0 0 r
s
.99 .283 .119 r
.43785 .46779 m .42526 .46339 L .43783 .4445 L p F P
0 0 0 r
s
.977 .277 .116 r
.42526 .46339 m .43785 .46779 L .42885 .48808 L p F P
0 0 0 r
s
1 .293 .125 r
.49989 .40271 m .50264 .40374 L .50516 .42474 L p F P
0 0 0 r
s
1 .293 .125 r
.50516 .42474 m .49978 .42275 L .49989 .40271 L p F P
0 0 0 r
s
.765 .205 .084 r
.49928 .6144 m .51651 .61979 L .51608 .63473 L p F P
0 0 0 r
s
.765 .205 .084 r
.53269 .63986 m .51608 .63473 L .51651 .61979 L p F P
0 0 0 r
s
.977 .277 .116 r
.42885 .48808 m .41439 .48312 L .42526 .46339 L p F P
0 0 0 r
s
.96 .271 .113 r
.41439 .48312 m .42885 .48808 L .42144 .50871 L p F P
0 0 0 r
s
.83 .226 .093 r
.4642 .58581 m .48183 .59142 L .48188 .60895 L p F P
0 0 0 r
s
.83 .226 .093 r
.49928 .6144 m .48188 .60895 L .48183 .59142 L p F P
0 0 0 r
s
.24 .35 .67 r
.24203 .62739 m
.25776 .60854 L
s
.24203 .62739 m
.24777 .65357 L
s
.28972 .51995 m
.3063 .4992 L
s
.28972 .51995 m
.27909 .53997 L
s
.41672 .74641 m
.44076 .74215 L
s
.44076 .74215 m
.46001 .72534 L
s
1 .287 .121 r
.45186 .42682 m .45992 .42974 L .44827 .44822 L p F P
0 0 0 r
s
.83 .24 .1 r
.45344 .46565 m
.46507 .4395 L
s
1 .287 .121 r
.44827 .44822 m .43783 .4445 L .45186 .42682 L p F P
0 0 0 r
s
.83 .24 .1 r
.62716 .40581 m
.611 .41719 L
s
.57721 .40425 m
.611 .41719 L
s
1 .293 .125 r
.49712 .40167 m .49989 .40271 L .49978 .42275 L p F P
0 0 0 r
s
1 .293 .125 r
.49978 .42275 m .49437 .42076 L .49712 .40167 L p F P
0 0 0 r
s
.67 .175 .071 r
.53269 .63986 m .54914 .64493 L .54667 .65648 L p F P
0 0 0 r
s
.024 .036 .069 r
.55623 .64819 m .54667 .65648 L .54914 .64493 L p F P
0 0 0 r
s
.024 .036 .069 r
.54914 .64493 m .55923 .63611 L .55623 .64819 L p F P
0 0 0 r
s
.241 .354 .711 r
.54178 .43286 m .54654 .42781 L .56009 .44577 L p F P
0 0 0 r
s
.255 .376 .751 r
.54654 .42781 m .54178 .43286 L .5286 .41488 L p F P
0 0 0 r
s
.255 .376 .751 r
.5254 .41836 m .5286 .41488 L .54178 .43286 L p F P
0 0 0 r
s
.83 .24 .1 r
.75866 .43916 m
.74249 .43872 L
s
.71001 .42599 m
.74249 .43872 L
s
1 .291 .123 r
.47258 .41272 m .47805 .41474 L .46794 .43265 L p F P
0 0 0 r
s
1 .291 .123 r
.46794 .43265 m .45992 .42974 L .47258 .41272 L p F P
0 0 0 r
s
.144 .204 .437 r
.60237 .54555 m .59145 .55556 L .58754 .53529 L p F P
0 0 0 r
s
.144 .204 .437 r
.58754 .53529 m .59796 .52554 L .60237 .54555 L p F P
0 0 0 r
s
.24 .35 .67 r
.56976 .5339 m
.59104 .51364 L
s
.269 .398 .788 r
.5254 .41836 m .52221 .42183 L .51136 .40223 L p F P
0 0 0 r
s
.269 .398 .788 r
.50975 .40402 m .51136 .40223 L .52221 .42183 L p F P
0 0 0 r
s
.209 .305 .622 r
.59154 .47615 m .58272 .48481 L .57223 .46489 L p F P
0 0 0 r
s
.209 .305 .622 r
.57223 .46489 m .57986 .45721 L .59154 .47615 L p F P
0 0 0 r
s
.226 .331 .669 r
.57986 .45721 m .57223 .46489 L .56009 .44577 L p F P
0 0 0 r
s
.939 .263 .11 r
.43282 .53489 m .41578 .52928 L .42144 .50871 L p F P
0 0 0 r
s
.912 .254 .105 r
.41578 .52928 m .43282 .53489 L .42981 .55515 L p F P
0 0 0 r
s
.912 .254 .105 r
.44745 .56086 m .42981 .55515 L .43282 .53489 L p F P
0 0 0 r
s
.83 .24 .1 r
.43129 .54804 m
.43625 .52084 L
s
.96 .271 .113 r
.42144 .50871 m .40543 .50333 L .41439 .48312 L p F P
0 0 0 r
s
.939 .263 .11 r
.40543 .50333 m .42144 .50871 L .41578 .52928 L p F P
0 0 0 r
s
1 .293 .125 r
.49435 .40063 m .49712 .40167 L .49437 .42076 L p F P
0 0 0 r
s
1 .293 .125 r
.49437 .42076 m .48895 .41876 L .49435 .40063 L p F P
0 0 0 r
s
.83 .24 .1 r
.551 .65273 m
.57459 .65996 L
s
.57459 .65996 m
.58323 .67543 L
s
.226 .331 .669 r
.56009 .44577 m .56637 .43928 L .57986 .45721 L p F P
0 0 0 r
s
.241 .354 .711 r
.56637 .43928 m .56009 .44577 L .54654 .42781 L p F P
0 0 0 r
s
.19 .276 .57 r
.60117 .49575 m .59135 .50516 L .58272 .48481 L p F P
0 0 0 r
s
.19 .276 .57 r
.58272 .48481 m .59154 .47615 L .60117 .49575 L p F P
0 0 0 r
s
.24 .35 .67 r
.57787 .48896 m
.59104 .51364 L
s
.877 .242 .1 r
.42981 .55515 m .44745 .56086 L .44639 .58014 L p F P
0 0 0 r
s
.83 .24 .1 r
.43129 .54804 m
.46639 .55948 L
s
.877 .242 .1 r
.4642 .58581 m .44639 .58014 L .44745 .56086 L p F P
0 0 0 r
s
.99 .283 .119 r
.42732 .44076 m .43783 .4445 L .42526 .46339 L p F P
0 0 0 r
s
.99 .283 .119 r
.42526 .46339 m .41257 .45896 L .42732 .44076 L p F P
0 0 0 r
s
.977 .277 .116 r
.41257 .45896 m .42526 .46339 L .41439 .48312 L p F P
0 0 0 r
s
1 .287 .121 r
.44376 .42388 m .45186 .42682 L .43783 .4445 L p F P
0 0 0 r
s
1 .287 .121 r
.43783 .4445 m .42732 .44076 L .44376 .42388 L p F P
0 0 0 r
s
1 .291 .123 r
.46709 .41069 m .47258 .41272 L .45992 .42974 L p F P
0 0 0 r
s
1 .291 .123 r
.45992 .42974 m .45186 .42682 L .46709 .41069 L p F P
0 0 0 r
s
.24 .35 .67 r
.34603 .75463 m
.37254 .76154 L
s
.37254 .76154 m
.39065 .74501 L
s
.977 .277 .116 r
.41439 .48312 m .3998 .47813 L .41257 .45896 L p F P
0 0 0 r
s
.96 .271 .113 r
.3998 .47813 m .41439 .48312 L .40543 .50333 L p F P
0 0 0 r
s
.83 .24 .1 r
.40838 .48095 m
.44372 .49306 L
s
1 .293 .125 r
.49158 .3996 m .49435 .40063 L .48895 .41876 L p F P
0 0 0 r
s
1 .293 .125 r
.48895 .41876 m .48351 .41675 L .49158 .3996 L p F P
0 0 0 r
s
.269 .398 .788 r
.5286 .41488 m .5254 .41836 L .51297 .40043 L p F P
0 0 0 r
s
.269 .398 .788 r
.51136 .40223 m .51297 .40043 L .5254 .41836 L p F P
0 0 0 r
s
.765 .205 .084 r
.48188 .60895 m .49928 .6144 L .4993 .62955 L p F P
0 0 0 r
s
.765 .205 .084 r
.51608 .63473 m .4993 .62955 L .49928 .6144 L p F P
0 0 0 r
s
.83 .24 .1 r
.49929 .59608 m
.50082 .61908 L
s
.50082 .61908 m
.53529 .62983 L
s
.24 .35 .67 r
.32157 .4833 m
.33879 .4618 L
s
.32157 .4833 m
.3063 .4992 L
s
.83 .24 .1 r
.663 .70644 m
.69607 .71638 L
s
.71151 .72158 m
.69607 .71638 L
s
.83 .226 .093 r
.44639 .58014 m .4642 .58581 L .46431 .60345 L p F P
0 0 0 r
s
.83 .226 .093 r
.48188 .60895 m .46431 .60345 L .4642 .58581 L p F P
0 0 0 r
s
.83 .24 .1 r
.46453 .58501 m
.49929 .59608 L
s
.241 .354 .711 r
.54654 .42781 m .55135 .42272 L .56637 .43928 L p F P
0 0 0 r
s
.255 .376 .751 r
.55135 .42272 m .54654 .42781 L .53182 .41138 L p F P
0 0 0 r
s
.255 .376 .751 r
.5286 .41488 m .53182 .41138 L .54654 .42781 L p F P
0 0 0 r
s
.83 .24 .1 r
.67687 .41301 m
.6606 .4188 L
s
.62716 .40581 m
.6606 .4188 L
s
.169 .243 .509 r
.60855 .51561 m .59796 .52554 L .59135 .50516 L p F P
0 0 0 r
s
.169 .243 .509 r
.59135 .50516 m .60117 .49575 L .60855 .51561 L p F P
0 0 0 r
s
.24 .35 .67 r
.46001 .72534 m
.48108 .71585 L
s
.48108 .71585 m
.50115 .69848 L
s
1 .293 .125 r
.48881 .39856 m .49158 .3996 L .48351 .41675 L p F P
0 0 0 r
s
1 .293 .125 r
.48351 .41675 m .47805 .41474 L .48881 .39856 L p F P
0 0 0 r
s
.83 .24 .1 r
.47826 .41553 m
.51295 .42832 L
s
.67 .175 .071 r
.51608 .63473 m .53269 .63986 L .53104 .65171 L p F P
0 0 0 r
s
.67 .175 .071 r
.54667 .65648 m .53104 .65171 L .53269 .63986 L p F P
0 0 0 r
s
.83 .24 .1 r
.54037 .64947 m
.54814 .65185 L
s
.24 .35 .67 r
.5466 .65206 m
.55134 .64794 L
s
.53057 .66603 m
.54286 .65532 L
s
.83 .24 .1 r
.53529 .62983 m
.54037 .64947 L
s
1 .291 .123 r
.46158 .40866 m .46709 .41069 L .45186 .42682 L p F P
0 0 0 r
s
.83 .24 .1 r
.46507 .4395 m
.47826 .41553 L
s
.24 .35 .67 r
.44858 .42563 m
.45887 .41373 L
s
.46285 .40913 m
.46579 .40573 L
s
1 .291 .123 r
.45186 .42682 m .44376 .42388 L .46158 .40866 L p F P
0 0 0 r
s
.079 .107 .249 r
.59301 .59268 m .58209 .60236 L .58234 .5847 L p F P
0 0 0 r
s
.079 .107 .249 r
.58234 .5847 m .5933 .57483 L .59301 .59268 L p F P
0 0 0 r
s
.99 .283 .119 r
.41674 .43699 m .42732 .44076 L .41257 .45896 L p F P
0 0 0 r
s
.83 .24 .1 r
.41818 .45325 m
.45344 .46565 L
s
.99 .283 .119 r
.41257 .45896 m .39979 .45449 L .41674 .43699 L p F P
0 0 0 r
s
.977 .277 .116 r
.39979 .45449 m .41257 .45896 L .3998 .47813 L p F P
0 0 0 r
s
1 .287 .121 r
.43562 .42093 m .44376 .42388 L .42732 .44076 L p F P
0 0 0 r
s
1 .287 .121 r
.42732 .44076 m .41674 .43699 L .43562 .42093 L p F P
0 0 0 r
s
.83 .24 .1 r
.40838 .48095 m
.41818 .45325 L
s
.047 .067 .154 r
.57992 .618 m .56948 .62713 L .57136 .61188 L p F P
0 0 0 r
s
.047 .067 .154 r
.57136 .61188 m .58209 .60236 L .57992 .618 L p F P
0 0 0 r
s
.24 .35 .67 r
.56044 .60298 m
.58158 .58391 L
s
.939 .263 .11 r
.41578 .52928 m .39859 .5236 L .40543 .50333 L p F P
0 0 0 r
s
.912 .254 .105 r
.39859 .5236 m .41578 .52928 L .412 .54939 L p F P
0 0 0 r
s
.912 .254 .105 r
.42981 .55515 m .412 .54939 L .41578 .52928 L p F P
0 0 0 r
s
.96 .271 .113 r
.40543 .50333 m .38928 .49789 L .3998 .47813 L p F P
0 0 0 r
s
.939 .263 .11 r
.38928 .49789 m .40543 .50333 L .39859 .5236 L p F P
0 0 0 r
s
.83 .24 .1 r
.40071 .50897 m
.40838 .48095 L
s
.40071 .50897 m
.43625 .52084 L
s
.269 .398 .788 r
.53182 .41138 m .5286 .41488 L .51459 .39863 L p F P
0 0 0 r
s
.83 .24 .1 r
.52486 .41143 m
.52521 .41094 L
s
.269 .398 .788 r
.51297 .40043 m .51459 .39863 L .5286 .41488 L p F P
0 0 0 r
s
.83 .24 .1 r
.52727 .40801 m
.52747 .40774 L
s
.52747 .40774 m
.56166 .4206 L
s
1 .293 .125 r
.48603 .39751 m .48881 .39856 L .47805 .41474 L p F P
0 0 0 r
s
1 .293 .125 r
.47805 .41474 m .47258 .41272 L .48603 .39751 L p F P
0 0 0 r
s
.113 .157 .348 r
.60446 .56478 m .5933 .57483 L .59145 .55556 L p F P
0 0 0 r
s
.113 .157 .348 r
.59145 .55556 m .60237 .54555 L .60446 .56478 L p F P
0 0 0 r
s
.24 .35 .67 r
.25759 .58311 m
.27372 .56333 L
s
.25759 .58311 m
.25776 .60854 L
s
.226 .331 .669 r
.58759 .44943 m .57986 .45721 L .56637 .43928 L p F P
0 0 0 r
s
.226 .331 .669 r
.56637 .43928 m .57272 .43273 L .58759 .44943 L p F P
0 0 0 r
s
.241 .354 .711 r
.57272 .43273 m .56637 .43928 L .55135 .42272 L p F P
0 0 0 r
s
.877 .242 .1 r
.412 .54939 m .42981 .55515 L .42839 .57442 L p F P
0 0 0 r
s
.877 .242 .1 r
.44639 .58014 m .42839 .57442 L .42981 .55515 L p F P
0 0 0 r
s
.83 .24 .1 r
.42906 .57372 m
.43129 .54804 L
s
.209 .305 .622 r
.60049 .46737 m .59154 .47615 L .57986 .45721 L p F P
0 0 0 r
s
.209 .305 .622 r
.57986 .45721 m .58759 .44943 L .60049 .46737 L p F P
0 0 0 r
s
.83 .24 .1 r
.52631 .4073 m
.52747 .40774 L
s
.977 .277 .116 r
.3998 .47813 m .3851 .47308 L .39979 .45449 L p F P
0 0 0 r
s
.96 .271 .113 r
.3851 .47308 m .3998 .47813 L .38928 .49789 L p F P
0 0 0 r
s
.83 .24 .1 r
.79087 .45184 m
.80587 .4584 L
s
.75866 .43916 m
.79087 .45184 L
s
.58323 .67543 m
.61723 .68572 L
s
.61723 .68572 m
.62925 .69629 L
s
1 .291 .123 r
.45606 .40662 m .46158 .40866 L .44376 .42388 L p F P
0 0 0 r
s
1 .291 .123 r
.44376 .42388 m .43562 .42093 L .45606 .40662 L p F P
0 0 0 r
s
.24 .35 .67 r
.24777 .65357 m
.26374 .63504 L
s
.24777 .65357 m
.25909 .67945 L
s
1 .293 .125 r
.48324 .39647 m .48603 .39751 L .47258 .41272 L p F P
0 0 0 r
s
1 .293 .125 r
.47258 .41272 m .46709 .41069 L .48324 .39647 L p F P
0 0 0 r
s
1 .294 .125 r
.50815 .4058 m .5054 .40477 L .5 .38446 L closepath p F P
0 0 0 r
s
.282 .418 .823 r
.5 .38446 m .50975 .40402 L .50815 .4058 L closepath p F P
0 0 0 r
s
.241 .354 .711 r
.55135 .42272 m .55619 .4176 L .57272 .43273 L p F P
0 0 0 r
s
.83 .24 .1 r
.56166 .4206 m
.57721 .40425 L
s
.255 .376 .751 r
.55619 .4176 m .55135 .42272 L .53506 .40786 L p F P
0 0 0 r
s
.255 .376 .751 r
.53182 .41138 m .53506 .40786 L .55135 .42272 L p F P
0 0 0 r
s
.024 .036 .069 r
.56593 .63977 m .55623 .64819 L .55923 .63611 L p F P
0 0 0 r
s
.24 .35 .67 r
.55134 .64794 m
.5585 .62652 L
s
.024 .036 .069 r
.55923 .63611 m .56948 .62713 L .56593 .63977 L p F P
0 0 0 r
s
.765 .205 .084 r
.46431 .60345 m .48188 .60895 L .48236 .62432 L p F P
0 0 0 r
s
.765 .205 .084 r
.4993 .62955 m .48236 .62432 L .48188 .60895 L p F P
0 0 0 r
s
1 .287 .121 r
.42745 .41797 m .43562 .42093 L .41674 .43699 L p F P
0 0 0 r
s
.83 .24 .1 r
.4298 .42679 m
.46507 .4395 L
s
1 .287 .121 r
.41674 .43699 m .40611 .4332 L .42745 .41797 L p F P
0 0 0 r
s
.83 .24 .1 r
.41818 .45325 m
.4298 .42679 L
s
.99 .283 .119 r
.40611 .4332 m .41674 .43699 L .39979 .45449 L p F P
0 0 0 r
s
.19 .276 .57 r
.61115 .48619 m .60117 .49575 L .59154 .47615 L p F P
0 0 0 r
s
.19 .276 .57 r
.59154 .47615 m .60049 .46737 L .61115 .48619 L p F P
0 0 0 r
s
.24 .35 .67 r
.57787 .48896 m
.59955 .46767 L
s
.269 .398 .788 r
.53506 .40786 m .53182 .41138 L .51621 .39682 L p F P
0 0 0 r
s
.83 .24 .1 r
.52747 .40774 m
.52767 .40751 L
s
.269 .398 .788 r
.51459 .39863 m .51621 .39682 L .53182 .41138 L p F P
0 0 0 r
s
.24 .35 .67 r
.50115 .69848 m
.51822 .68424 L
s
.51822 .68424 m
.53904 .66623 L
s
1 .294 .125 r
.5054 .40477 m .50264 .40374 L .5 .38446 L closepath p F P
0 0 0 r
s
.144 .204 .437 r
.61348 .53535 m .60237 .54555 L .59796 .52554 L p F P
0 0 0 r
s
.24 .35 .67 r
.57812 .559 m
.59972 .53902 L
s
.144 .204 .437 r
.59796 .52554 m .60855 .51561 L .61348 .53535 L p F P
0 0 0 r
s
.24 .35 .67 r
.59104 .51364 m
.59972 .53902 L
s
.99 .283 .119 r
.39979 .45449 m .38692 .44999 L .40611 .4332 L p F P
0 0 0 r
s
.977 .277 .116 r
.38692 .44999 m .39979 .45449 L .3851 .47308 L p F P
0 0 0 r
s
.83 .226 .093 r
.42839 .57442 m .44639 .58014 L .44655 .59789 L p F P
0 0 0 r
s
.83 .226 .093 r
.46431 .60345 m .44655 .59789 L .44639 .58014 L p F P
0 0 0 r
s
1 .293 .125 r
.48045 .39542 m .48324 .39647 L .46709 .41069 L p F P
0 0 0 r
s
1 .293 .125 r
.46709 .41069 m .46158 .40866 L .48045 .39542 L p F P
0 0 0 r
s
.24 .35 .67 r
.46707 .40425 m
.46759 .40445 L
s
.46583 .40568 m
.46707 .40425 L
s
.282 .418 .823 r
.5 .38446 m .51136 .40223 L .50975 .40402 L closepath p F P
0 0 0 r
s
1 .294 .125 r
.50264 .40374 m .49989 .40271 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .291 .123 r
.45051 .40458 m .45606 .40662 L .43562 .42093 L p F P
0 0 0 r
s
1 .291 .123 r
.43562 .42093 m .42745 .41797 L .45051 .40458 L p F P
0 0 0 r
s
.67 .175 .071 r
.4993 .62955 m .51608 .63473 L .51526 .6469 L p F P
0 0 0 r
s
.67 .175 .071 r
.53104 .65171 m .51526 .6469 L .51608 .63473 L p F P
0 0 0 r
s
.24 .35 .67 r
.32014 .74226 m
.34603 .75463 L
s
.34603 .75463 m
.36381 .73785 L
s
.83 .24 .1 r
.72579 .42621 m
.71001 .42599 L
s
.67687 .41301 m
.71001 .42599 L
s
.96 .271 .113 r
.38928 .49789 m .37297 .49241 L .3851 .47308 L p F P
0 0 0 r
s
.939 .263 .11 r
.37297 .49241 m .38928 .49789 L .38122 .51788 L p F P
0 0 0 r
s
.939 .263 .11 r
.39859 .5236 m .38122 .51788 L .38928 .49789 L p F P
0 0 0 r
s
1 .294 .125 r
.49989 .40271 m .49712 .40167 L .5 .38446 L closepath p F P
0 0 0 r
s
.912 .254 .105 r
.38122 .51788 m .39859 .5236 L .39401 .54356 L p F P
0 0 0 r
s
.912 .254 .105 r
.412 .54939 m .39401 .54356 L .39859 .5236 L p F P
0 0 0 r
s
.83 .24 .1 r
.39547 .53636 m
.40071 .50897 L
s
.24 .35 .67 r
.39065 .74501 m
.41672 .74641 L
s
.41672 .74641 m
.43577 .72948 L
s
.282 .418 .823 r
.5 .38446 m .51297 .40043 L .51136 .40223 L closepath p F P
0 0 0 r
s
1 .293 .125 r
.47766 .39438 m .48045 .39542 L .46158 .40866 L p F P
0 0 0 r
s
1 .293 .125 r
.46158 .40866 m .45606 .40662 L .47766 .39438 L p F P
0 0 0 r
s
.977 .277 .116 r
.3851 .47308 m .37027 .468 L .38692 .44999 L p F P
0 0 0 r
s
.96 .271 .113 r
.37027 .468 m .3851 .47308 L .37297 .49241 L p F P
0 0 0 r
s
1 .294 .125 r
.49712 .40167 m .49435 .40063 L .5 .38446 L closepath p F P
0 0 0 r
s
.255 .376 .751 r
.53506 .40786 m .53832 .40433 L .55619 .4176 L p F P
0 0 0 r
s
.269 .398 .788 r
.53832 .40433 m .53506 .40786 L .51784 .39501 L p F P
0 0 0 r
s
.83 .24 .1 r
.53004 .40492 m
.53048 .40444 L
s
.269 .398 .788 r
.51621 .39682 m .51784 .39501 L .53506 .40786 L p F P
0 0 0 r
s
.24 .35 .67 r
.51739 .42756 m
.53796 .40522 L
s
1 .287 .121 r
.41923 .41499 m .42745 .41797 L .40611 .4332 L p F P
0 0 0 r
s
1 .287 .121 r
.40611 .4332 m .39541 .42939 L .41923 .41499 L p F P
0 0 0 r
s
.24 .35 .67 r
.39824 .42271 m
.40683 .42249 L
s
.99 .283 .119 r
.39541 .42939 m .40611 .4332 L .38692 .44999 L p F P
0 0 0 r
s
.877 .242 .1 r
.39401 .54356 m .412 .54939 L .41021 .56863 L p F P
0 0 0 r
s
.83 .24 .1 r
.39547 .53636 m
.43129 .54804 L
s
.877 .242 .1 r
.42839 .57442 m .41021 .56863 L .412 .54939 L p F P
0 0 0 r
s
.226 .331 .669 r
.59541 .44156 m .58759 .44943 L .57272 .43273 L p F P
0 0 0 r
s
.24 .35 .67 r
.56076 .46586 m
.58206 .44424 L
s
.226 .331 .669 r
.57272 .43273 m .57913 .42611 L .59541 .44156 L p F P
0 0 0 r
s
.241 .354 .711 r
.57913 .42611 m .57272 .43273 L .55619 .4176 L p F P
0 0 0 r
s
1 .291 .123 r
.44495 .40253 m .45051 .40458 L .42745 .41797 L p F P
0 0 0 r
s
1 .291 .123 r
.42745 .41797 m .41923 .41499 L .44495 .40253 L p F P
0 0 0 r
s
.24 .35 .67 r
.4349 .4074 m
.4355 .40669 L
s
1 .294 .125 r
.49435 .40063 m .49158 .3996 L .5 .38446 L closepath p F P
0 0 0 r
s
.282 .418 .823 r
.5 .38446 m .51459 .39863 L .51297 .40043 L closepath p F P
0 0 0 r
s
.169 .243 .509 r
.61932 .50552 m .60855 .51561 L .60117 .49575 L p F P
0 0 0 r
s
.169 .243 .509 r
.60117 .49575 m .61115 .48619 L .61932 .50552 L p F P
0 0 0 r
s
.241 .354 .711 r
.55619 .4176 m .56107 .41243 L .57913 .42611 L p F P
0 0 0 r
s
.24 .35 .67 r
.54035 .44515 m
.56129 .42317 L
s
.255 .376 .751 r
.56107 .41243 m .55619 .4176 L .53832 .40433 L p F P
0 0 0 r
s
.24 .35 .67 r
.27909 .53997 m
.29569 .51931 L
s
.27909 .53997 m
.27372 .56333 L
s
1 .293 .125 r
.47486 .39333 m .47766 .39438 L .45606 .40662 L p F P
0 0 0 r
s
1 .293 .125 r
.45606 .40662 m .45051 .40458 L .47486 .39333 L p F P
0 0 0 r
s
.24 .35 .67 r
.56129 .42317 m
.58206 .44424 L
s
.99 .283 .119 r
.38692 .44999 m .37395 .44546 L .39541 .42939 L p F P
0 0 0 r
s
.24 .35 .67 r
.38844 .43461 m
.39824 .42271 L
s
.977 .277 .116 r
.37395 .44546 m .38692 .44999 L .37027 .468 L p F P
0 0 0 r
s
1 .294 .125 r
.49158 .3996 m .48881 .39856 L .5 .38446 L closepath p F P
0 0 0 r
s
.209 .305 .622 r
.60957 .45845 m .60049 .46737 L .58759 .44943 L p F P
0 0 0 r
s
.209 .305 .622 r
.58759 .44943 m .59541 .44156 L .60957 .45845 L p F P
0 0 0 r
s
.24 .35 .67 r
.58206 .44424 m
.59955 .46767 L
s
.765 .205 .084 r
.44655 .59789 m .46431 .60345 L .46525 .61904 L p F P
0 0 0 r
s
.765 .205 .084 r
.48236 .62432 m .46525 .61904 L .46431 .60345 L p F P
0 0 0 r
s
.83 .24 .1 r
.46453 .58501 m
.46564 .60811 L
s
.46564 .60811 m
.50082 .61908 L
s
.24 .35 .67 r
.25909 .67945 m
.27536 .66127 L
s
.25909 .67945 m
.2755 .70368 L
s
.282 .418 .823 r
.5 .38446 m .51621 .39682 L .51459 .39863 L closepath p F P
0 0 0 r
s
.024 .035 .067 r
.55181 .65713 m .54304 .6647 L .54667 .65648 L p F P
0 0 0 r
s
.83 .24 .1 r
.54736 .6627 m
.54854 .66493 L
s
.54673 .66151 m
.54736 .6627 L
s
.024 .035 .067 r
.54667 .65648 m .55623 .64819 L .55181 .65713 L p F P
0 0 0 r
s
.528 .131 .051 r
.53104 .65171 m .54667 .65648 L .54304 .6647 L p F P
0 0 0 r
s
.24 .35 .67 r
.5431 .66019 m
.55134 .64794 L
s
1 .294 .125 r
.48881 .39856 m .48603 .39751 L .5 .38446 L closepath p F P
0 0 0 r
s
.079 .107 .249 r
.60413 .58282 m .59301 .59268 L .5933 .57483 L p F P
0 0 0 r
s
.079 .107 .249 r
.5933 .57483 m .60446 .56478 L .60413 .58282 L p F P
0 0 0 r
s
1 .293 .125 r
.47205 .39228 m .47486 .39333 L .45051 .40458 L p F P
0 0 0 r
s
1 .293 .125 r
.45051 .40458 m .44495 .40253 L .47205 .39228 L p F P
0 0 0 r
s
.83 .24 .1 r
.62925 .69629 m
.663 .70644 L
s
.663 .70644 m
.67802 .71152 L
s
.255 .376 .751 r
.53832 .40433 m .5416 .40077 L .56107 .41243 L p F P
0 0 0 r
s
.24 .35 .67 r
.53796 .40522 m
.56129 .42317 L
s
.269 .398 .788 r
.5416 .40077 m .53832 .40433 L .51947 .3932 L p F P
0 0 0 r
s
.83 .24 .1 r
.53286 .40184 m
.5333 .40136 L
s
.269 .398 .788 r
.51784 .39501 m .51947 .3932 L .53832 .40433 L p F P
0 0 0 r
s
1 .291 .123 r
.43937 .40047 m .44495 .40253 L .41923 .41499 L p F P
0 0 0 r
s
1 .291 .123 r
.41923 .41499 m .41098 .41199 L .43937 .40047 L p F P
0 0 0 r
s
1 .287 .121 r
.41098 .41199 m .41923 .41499 L .39541 .42939 L p F P
0 0 0 r
s
.83 .226 .093 r
.41021 .56863 m .42839 .57442 L .42862 .59227 L p F P
0 0 0 r
s
.83 .226 .093 r
.44655 .59789 m .42862 .59227 L .42839 .57442 L p F P
0 0 0 r
s
.83 .24 .1 r
.42906 .57372 m
.46453 .58501 L
s
.64304 .39975 m
.62716 .40581 L
s
.047 .067 .154 r
.59053 .60871 m .57992 .618 L .58209 .60236 L p F P
0 0 0 r
s
.24 .35 .67 r
.57986 .60765 m
.58158 .58391 L
s
.047 .067 .154 r
.58209 .60236 m .59301 .59268 L .59053 .60871 L p F P
0 0 0 r
s
1 .294 .125 r
.48603 .39751 m .48324 .39647 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .287 .121 r
.39541 .42939 m .38464 .42556 L .41098 .41199 L p F P
0 0 0 r
s
.99 .283 .119 r
.38464 .42556 m .39541 .42939 L .37395 .44546 L p F P
0 0 0 r
s
.83 .24 .1 r
.3822 .4406 m
.41818 .45325 L
s
.67 .175 .071 r
.48236 .62432 m .4993 .62955 L .49934 .64204 L p F P
0 0 0 r
s
.67 .175 .071 r
.51526 .6469 m .49934 .64204 L .4993 .62955 L p F P
0 0 0 r
s
.83 .24 .1 r
.50082 .61908 m
.50544 .63876 L
s
.282 .418 .823 r
.5 .38446 m .51784 .39501 L .51621 .39682 L closepath p F P
0 0 0 r
s
.96 .271 .113 r
.37297 .49241 m .35652 .48688 L .37027 .468 L p F P
0 0 0 r
s
.83 .24 .1 r
.37231 .46858 m
.40838 .48095 L
s
.939 .263 .11 r
.35652 .48688 m .37297 .49241 L .36368 .51209 L p F P
0 0 0 r
s
.939 .263 .11 r
.38122 .51788 m .36368 .51209 L .37297 .49241 L p F P
0 0 0 r
s
.83 .24 .1 r
.36445 .49685 m
.40071 .50897 L
s
.24 .35 .67 r
.29621 .72498 m
.32014 .74226 L
s
.32014 .74226 m
.33754 .72517 L
s
.113 .157 .348 r
.61582 .55455 m .60446 .56478 L .60237 .54555 L p F P
0 0 0 r
s
.113 .157 .348 r
.60237 .54555 m .61348 .53535 L .61582 .55455 L p F P
0 0 0 r
s
.24 .35 .67 r
.59972 .53902 m
.60347 .56417 L
s
1 .294 .125 r
.48324 .39647 m .48045 .39542 L .5 .38446 L closepath p F P
0 0 0 r
s
.977 .277 .116 r
.37027 .468 m .35532 .46288 L .37395 .44546 L p F P
0 0 0 r
s
.96 .271 .113 r
.35532 .46288 m .37027 .468 L .35652 .48688 L p F P
0 0 0 r
s
.912 .254 .105 r
.36368 .51209 m .38122 .51788 L .37583 .53768 L p F P
0 0 0 r
s
.912 .254 .105 r
.39401 .54356 m .37583 .53768 L .38122 .51788 L p F P
0 0 0 r
s
1 .293 .125 r
.46925 .39123 m .47205 .39228 L .44495 .40253 L p F P
0 0 0 r
s
1 .293 .125 r
.44495 .40253 m .43937 .40047 L .46925 .39123 L p F P
0 0 0 r
s
.83 .24 .1 r
.44286 .40248 m
.47826 .41553 L
s
.37231 .46858 m
.3822 .4406 L
s
.36445 .49685 m
.37231 .46858 L
s
.19 .276 .57 r
.62129 .47647 m .61115 .48619 L .60049 .46737 L p F P
0 0 0 r
s
.19 .276 .57 r
.60049 .46737 m .60957 .45845 L .62129 .47647 L p F P
0 0 0 r
s
1 .294 .125 r
.48045 .39542 m .47766 .39438 L .5 .38446 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.47826 .41553 m
.49257 .39461 L
s
.99 .283 .119 r
.37395 .44546 m .36089 .4409 L .38464 .42556 L p F P
0 0 0 r
s
.24 .35 .67 r
.35799 .45071 m
.36483 .44227 L
s
.977 .277 .116 r
.36089 .4409 m .37395 .44546 L .35532 .46288 L p F P
0 0 0 r
s
.241 .354 .711 r
.58561 .41942 m .57913 .42611 L .56107 .41243 L p F P
0 0 0 r
s
.241 .354 .711 r
.56107 .41243 m .56599 .40721 L .58561 .41942 L p F P
0 0 0 r
s
.255 .376 .751 r
.56599 .40721 m .56107 .41243 L .5416 .40077 L p F P
0 0 0 r
s
.282 .418 .823 r
.5 .38446 m .51947 .3932 L .51784 .39501 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.49257 .39461 m
.51355 .4025 L
s
.316 .473 .911 r
.41529 .40678 m .41098 .41199 L .43937 .40047 L p F P
0 0 0 r
s
.83 .24 .1 r
.4298 .42679 m
.44286 .40248 L
s
.322 .484 .924 r
.41098 .41199 m .41529 .40678 L .3901 .41886 L p F P
0 0 0 r
s
.322 .484 .924 r
.3901 .41886 m .38464 .42556 L .41098 .41199 L p F P
0 0 0 r
s
.83 .24 .1 r
.3938 .41382 m
.39769 .41522 L
s
.40109 .41645 m
.4298 .42679 L
s
.39201 .41794 m
.3938 .41382 L
s
.024 .036 .069 r
.5758 .63121 m .56593 .63977 L .56948 .62713 L p F P
0 0 0 r
s
.024 .036 .069 r
.56948 .62713 m .57992 .618 L .5758 .63121 L p F P
0 0 0 r
s
.24 .35 .67 r
.5585 .62652 m
.57986 .60765 L
s
.2755 .70368 m
.29212 .68587 L
s
.2755 .70368 m
.29621 .72498 L
s
.877 .242 .1 r
.37583 .53768 m .39401 .54356 L .39184 .56279 L p F P
0 0 0 r
s
.877 .242 .1 r
.41021 .56863 m .39184 .56279 L .39401 .54356 L p F P
0 0 0 r
s
.83 .24 .1 r
.39287 .56219 m
.39547 .53636 L
s
1 .294 .125 r
.47766 .39438 m .47486 .39333 L .5 .38446 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.25776 .60854 m
.27406 .58902 L
s
.25776 .60854 m
.26374 .63504 L
s
.3063 .4992 m
.29569 .51931 L
s
.255 .376 .751 r
.5416 .40077 m .54489 .39719 L .56599 .40721 L p F P
0 0 0 r
s
.269 .398 .788 r
.54489 .39719 m .5416 .40077 L .5211 .39138 L p F P
0 0 0 r
s
.83 .24 .1 r
.53569 .39875 m
.53613 .39826 L
s
.269 .398 .788 r
.51947 .3932 m .5211 .39138 L .5416 .40077 L p F P
0 0 0 r
s
.24 .35 .67 r
.43577 .72948 m
.46001 .72534 L
s
.46001 .72534 m
.47997 .70792 L
s
.226 .331 .669 r
.60334 .43358 m .59541 .44156 L .57913 .42611 L p F P
0 0 0 r
s
.226 .331 .669 r
.57913 .42611 m .58561 .41942 L .60334 .43358 L p F P
0 0 0 r
s
.83 .24 .1 r
.77326 .44557 m
.75866 .43916 L
s
.72579 .42621 m
.75866 .43916 L
s
.306 .457 .887 r
.44238 .39689 m .43937 .40047 L .46925 .39123 L p F P
0 0 0 r
s
.316 .473 .911 r
.43937 .40047 m .44238 .39689 L .41529 .40678 L p F P
0 0 0 r
s
.24 .35 .67 r
.44152 .39954 m
.45095 .40128 L
s
.43817 .40351 m
.44152 .39954 L
s
.83 .24 .1 r
.43664 .40019 m
.44286 .40248 L
s
.144 .204 .437 r
.62479 .52497 m .61348 .53535 L .60855 .51561 L p F P
0 0 0 r
s
.144 .204 .437 r
.60855 .51561 m .61932 .50552 L .62479 .52497 L p F P
0 0 0 r
s
.24 .35 .67 r
.29621 .72498 m
.31321 .70755 L
s
.83 .24 .1 r
.54854 .66493 m
.58323 .67543 L
s
.58323 .67543 m
.5948 .68593 L
s
.321 .483 .913 r
.38464 .42556 m .3901 .41886 L .36733 .43291 L p F P
0 0 0 r
s
.321 .483 .913 r
.36733 .43291 m .36089 .4409 L .38464 .42556 L p F P
0 0 0 r
s
.83 .24 .1 r
.36828 .4357 m
.3822 .4406 L
s
.3822 .4406 m
.39047 .42151 L
s
1 .294 .125 r
.47486 .39333 m .47205 .39228 L .5 .38446 L closepath p F P
0 0 0 r
s
.282 .418 .823 r
.5 .38446 m .5211 .39138 L .51947 .3932 L closepath p F P
0 0 0 r
s
.528 .131 .051 r
.51526 .6469 m .53104 .65171 L .52861 .66034 L p F P
0 0 0 r
s
.83 .24 .1 r
.50544 .63876 m
.54037 .64947 L
s
.528 .131 .051 r
.54304 .6647 m .52861 .66034 L .53104 .65171 L p F P
0 0 0 r
s
.24 .35 .67 r
.53904 .66623 m
.54057 .66396 L
s
.83 .24 .1 r
.54037 .64947 m
.54584 .65981 L
s
1 .294 .125 r
.47205 .39228 m .46925 .39123 L .5 .38446 L closepath p F P
0 0 0 r
s
.765 .205 .084 r
.42862 .59227 m .44655 .59789 L .44797 .61371 L p F P
0 0 0 r
s
.765 .205 .084 r
.46525 .61904 m .44797 .61371 L .44655 .59789 L p F P
0 0 0 r
s
.269 .398 .788 r
.5211 .39138 m .52274 .38955 L .54489 .39719 L p F P
0 0 0 r
s
.282 .418 .823 r
.5 .38446 m .52274 .38955 L .5211 .39138 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.5007 .40473 m
.51291 .39105 L
s
.294 .438 .857 r
.47081 .3894 m .46925 .39123 L .5 .38446 L closepath p F P
0 0 0 r
s
.306 .457 .887 r
.46925 .39123 m .47081 .3894 L .44238 .39689 L p F P
0 0 0 r
s
.209 .305 .622 r
.61878 .44941 m .60957 .45845 L .59541 .44156 L p F P
0 0 0 r
s
.209 .305 .622 r
.59541 .44156 m .60334 .43358 L .61878 .44941 L p F P
0 0 0 r
s
.67 .175 .071 r
.46525 .61904 m .48236 .62432 L .48326 .63714 L p F P
0 0 0 r
s
.67 .175 .071 r
.49934 .64204 m .48326 .63714 L .48236 .62432 L p F P
0 0 0 r
s
.977 .277 .116 r
.35532 .46288 m .34024 .45771 L .36089 .4409 L p F P
0 0 0 r
s
.96 .271 .113 r
.34024 .45771 m .35532 .46288 L .33991 .4813 L p F P
0 0 0 r
s
.24 .35 .67 r
.33879 .4618 m
.34019 .46099 L
s
.96 .271 .113 r
.35652 .48688 m .33991 .4813 L .35532 .46288 L p F P
0 0 0 r
s
.83 .226 .093 r
.39184 .56279 m .41021 .56863 L .41049 .5866 L p F P
0 0 0 r
s
.83 .226 .093 r
.42862 .59227 m .41049 .5866 L .41021 .56863 L p F P
0 0 0 r
s
.939 .263 .11 r
.33991 .4813 m .35652 .48688 L .34597 .50625 L p F P
0 0 0 r
s
.939 .263 .11 r
.36368 .51209 m .34597 .50625 L .35652 .48688 L p F P
0 0 0 r
s
.255 .376 .751 r
.57095 .40196 m .56599 .40721 L .54489 .39719 L p F P
0 0 0 r
s
.255 .376 .751 r
.54489 .39719 m .5482 .39359 L .57095 .40196 L p F P
0 0 0 r
s
.269 .398 .788 r
.5482 .39359 m .54489 .39719 L .52274 .38955 L p F P
0 0 0 r
s
.83 .24 .1 r
.54273 .39105 m
.57721 .40425 L
s
.24 .35 .67 r
.51291 .39105 m
.53796 .40522 L
s
.83 .24 .1 r
.54139 .39251 m
.54273 .39105 L
s
.305 .461 .857 r
.36089 .4409 m .36733 .43291 L .34748 .44865 L p F P
0 0 0 r
s
.305 .461 .857 r
.34748 .44865 m .34024 .45771 L .36089 .4409 L p F P
0 0 0 r
s
.306 .457 .887 r
.44541 .39329 m .44238 .39689 L .47081 .3894 L p F P
0 0 0 r
s
.316 .473 .911 r
.44238 .39689 m .44541 .39329 L .41964 .40152 L p F P
0 0 0 r
s
.83 .24 .1 r
.44286 .40248 m
.448 .39473 L
s
.43292 .39882 m
.435 .39959 L
s
.316 .473 .911 r
.41964 .40152 m .41529 .40678 L .44238 .39689 L p F P
0 0 0 r
s
.169 .243 .509 r
.63028 .49525 m .61932 .50552 L .61115 .48619 L p F P
0 0 0 r
s
.169 .243 .509 r
.61115 .48619 m .62129 .47647 L .63028 .49525 L p F P
0 0 0 r
s
.24 .35 .67 r
.59955 .46767 m
.61308 .49266 L
s
.59104 .51364 m
.61308 .49266 L
s
.912 .254 .105 r
.34597 .50625 m .36368 .51209 L .35747 .53173 L p F P
0 0 0 r
s
.912 .254 .105 r
.37583 .53768 m .35747 .53173 L .36368 .51209 L p F P
0 0 0 r
s
.83 .24 .1 r
.35891 .52445 m
.36445 .49685 L
s
.24 .35 .67 r
.36381 .73785 m
.39065 .74501 L
s
.39065 .74501 m
.40942 .72789 L
s
.241 .354 .711 r
.59216 .41266 m .58561 .41942 L .56599 .40721 L p F P
0 0 0 r
s
.241 .354 .711 r
.56599 .40721 m .57095 .40196 L .59216 .41266 L p F P
0 0 0 r
s
.269 .398 .788 r
.52274 .38955 m .52439 .38772 L .5482 .39359 L p F P
0 0 0 r
s
.282 .418 .823 r
.5 .38446 m .52439 .38772 L .52274 .38955 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.69223 .413 m
.67687 .41301 L
s
.64304 .39975 m
.67687 .41301 L
s
.294 .438 .857 r
.47238 .38757 m .47081 .3894 L .5 .38446 L closepath p F P
0 0 0 r
s
.306 .457 .887 r
.47081 .3894 m .47238 .38757 L .44541 .39329 L p F P
0 0 0 r
s
.322 .484 .924 r
.41529 .40678 m .41964 .40152 L .39561 .4121 L p F P
0 0 0 r
s
.322 .484 .924 r
.39561 .4121 m .3901 .41886 L .41529 .40678 L p F P
0 0 0 r
s
.83 .24 .1 r
.67802 .71152 m
.71151 .72158 L
s
.72891 .72076 m
.71151 .72158 L
s
.24 .35 .67 r
.33879 .4618 m
.34021 .46004 L
s
.024 .035 .067 r
.56072 .64944 m .55181 .65713 L .55623 .64819 L p F P
0 0 0 r
s
.024 .035 .067 r
.55623 .64819 m .56593 .63977 L .56072 .64944 L p F P
0 0 0 r
s
.877 .242 .1 r
.35747 .53173 m .37583 .53768 L .37328 .55688 L p F P
0 0 0 r
s
.83 .24 .1 r
.35891 .52445 m
.39547 .53636 L
s
.877 .242 .1 r
.39184 .56279 m .37328 .55688 L .37583 .53768 L p F P
0 0 0 r
s
.269 .398 .788 r
.55153 .38997 m .5482 .39359 L .52439 .38772 L p F P
0 0 0 r
s
.269 .398 .788 r
.52439 .38772 m .52604 .38588 L .55153 .38997 L p F P
0 0 0 r
s
.282 .418 .823 r
.5 .38446 m .52604 .38588 L .52439 .38772 L closepath p F P
0 0 0 r
s
.294 .438 .857 r
.47396 .38573 m .47238 .38757 L .5 .38446 L closepath p F P
0 0 0 r
s
.306 .457 .887 r
.47238 .38757 m .47396 .38573 L .44846 .38967 L p F P
0 0 0 r
s
.306 .457 .887 r
.44846 .38967 m .44541 .39329 L .47238 .38757 L p F P
0 0 0 r
s
.83 .24 .1 r
.47133 .38662 m
.49257 .39461 L
s
.24 .35 .67 r
.47997 .70792 m
.50115 .69848 L
s
.50115 .69848 m
.52195 .68048 L
s
.226 .331 .669 r
.61137 .4255 m .60334 .43358 L .58561 .41942 L p F P
0 0 0 r
s
.226 .331 .669 r
.58561 .41942 m .59216 .41266 L .61137 .4255 L p F P
0 0 0 r
s
.255 .376 .751 r
.57595 .39666 m .57095 .40196 L .5482 .39359 L p F P
0 0 0 r
s
.255 .376 .751 r
.5482 .39359 m .55153 .38997 L .57595 .39666 L p F P
0 0 0 r
s
.987 .292 .125 r
.5 .38446 m .53101 .38034 L .52823 .37927 L closepath p F P
0 0 0 r
s
.987 .292 .125 r
.5 .38446 m .52823 .37927 L .52544 .3782 L closepath p F P
0 0 0 r
s
.987 .292 .125 r
.5 .38446 m .52544 .3782 L .52264 .37712 L closepath p F P
0 0 0 r
s
.987 .292 .125 r
.5 .38446 m .52264 .37712 L .51984 .37605 L closepath p F P
0 0 0 r
s
.987 .292 .125 r
.5 .38446 m .51984 .37605 L .51704 .37497 L closepath p F P
0 0 0 r
s
.987 .292 .125 r
.5 .38446 m .51704 .37497 L .51423 .37389 L closepath p F P
0 0 0 r
s
.987 .292 .125 r
.5 .38446 m .51423 .37389 L .51142 .37281 L closepath p F P
0 0 0 r
s
.987 .292 .125 r
.5 .38446 m .51142 .37281 L .5086 .37172 L closepath p F P
0 0 0 r
s
.987 .292 .125 r
.5 .38446 m .5086 .37172 L .50578 .37064 L closepath p F P
0 0 0 r
s
.987 .292 .125 r
.5 .38446 m .50578 .37064 L .50295 .36955 L closepath p F P
0 0 0 r
s
.987 .292 .125 r
.5 .38446 m .50295 .36955 L .50012 .36846 L closepath p F P
0 0 0 r
s
.987 .292 .125 r
.5 .38446 m .50012 .36846 L .49728 .36737 L closepath p F P
0 0 0 r
s
.987 .292 .125 r
.5 .38446 m .49728 .36737 L .49444 .36627 L closepath p F P
0 0 0 r
s
.987 .292 .125 r
.5 .38446 m .49444 .36627 L .49159 .36518 L closepath p F P
0 0 0 r
s
.282 .418 .823 r
.5 .38446 m .53101 .38034 L .52935 .3822 L closepath p F P
0 0 0 r
s
.282 .418 .823 r
.5 .38446 m .52935 .3822 L .52769 .38404 L closepath p F P
0 0 0 r
s
.282 .418 .823 r
.5 .38446 m .52769 .38404 L .52604 .38588 L closepath p F P
0 0 0 r
s
.294 .438 .857 r
.47554 .38389 m .47396 .38573 L .5 .38446 L closepath p F P
0 0 0 r
s
.294 .438 .857 r
.47713 .38204 m .47554 .38389 L .5 .38446 L closepath p F P
0 0 0 r
s
.294 .438 .857 r
.47871 .38019 m .47713 .38204 L .5 .38446 L closepath p F P
0 0 0 r
s
.294 .438 .857 r
.48031 .37833 m .47871 .38019 L .5 .38446 L closepath p F P
0 0 0 r
s
.294 .438 .857 r
.48191 .37647 m .48031 .37833 L .5 .38446 L closepath p F P
0 0 0 r
s
.294 .438 .857 r
.48351 .3746 m .48191 .37647 L .5 .38446 L closepath p F P
0 0 0 r
s
.294 .438 .857 r
.48512 .37273 m .48351 .3746 L .5 .38446 L closepath p F P
0 0 0 r
s
.294 .438 .857 r
.48673 .37085 m .48512 .37273 L .5 .38446 L closepath p F P
0 0 0 r
s
.294 .438 .857 r
.48835 .36896 m .48673 .37085 L .5 .38446 L closepath p F P
0 0 0 r
s
.294 .438 .857 r
.48997 .36707 m .48835 .36896 L .5 .38446 L closepath p F P
0 0 0 r
s
.294 .438 .857 r
.49159 .36518 m .48997 .36707 L .5 .38446 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.49257 .39461 m
.50753 .37758 L
s
.24 .35 .67 r
.487 .38121 m
.51291 .39105 L
s
.316 .473 .911 r
.44541 .39329 m .44846 .38967 L .42402 .39622 L p F P
0 0 0 r
s
.83 .24 .1 r
.42537 .39603 m
.43068 .39799 L
s
.316 .473 .911 r
.42402 .39622 m .41964 .40152 L .44541 .39329 L p F P
0 0 0 r
s
.528 .131 .051 r
.49934 .64204 m .51526 .6469 L .51406 .65595 L p F P
0 0 0 r
s
.528 .131 .051 r
.52861 .66034 m .51406 .65595 L .51526 .6469 L p F P
0 0 0 r
s
.321 .483 .913 r
.3901 .41886 m .39561 .4121 L .37384 .42483 L p F P
0 0 0 r
s
.321 .483 .913 r
.37384 .42483 m .36733 .43291 L .3901 .41886 L p F P
0 0 0 r
s
.24 .35 .67 r
.37594 .42854 m
.39191 .42436 L
s
.36902 .43709 m
.37594 .42854 L
s
.079 .107 .249 r
.61546 .57279 m .60413 .58282 L .60446 .56478 L p F P
0 0 0 r
s
.079 .107 .249 r
.60446 .56478 m .61582 .55455 L .61546 .57279 L p F P
0 0 0 r
s
.19 .276 .57 r
.63159 .4666 m .62129 .47647 L .60957 .45845 L p F P
0 0 0 r
s
.19 .276 .57 r
.60957 .45845 m .61878 .44941 L .63159 .4666 L p F P
0 0 0 r
s
.047 .067 .154 r
.60133 .59926 m .59053 .60871 L .59301 .59268 L p F P
0 0 0 r
s
.047 .067 .154 r
.59301 .59268 m .60413 .58282 L .60133 .59926 L p F P
0 0 0 r
s
.24 .35 .67 r
.58158 .58391 m
.60347 .56417 L
s
.269 .398 .788 r
.55488 .38633 m .55153 .38997 L .52604 .38588 L p F P
0 0 0 r
s
.269 .398 .788 r
.52604 .38588 m .52769 .38404 L .55488 .38633 L p F P
0 0 0 r
s
.306 .457 .887 r
.47396 .38573 m .47554 .38389 L .45152 .38603 L p F P
0 0 0 r
s
.306 .457 .887 r
.45152 .38603 m .44846 .38967 L .47396 .38573 L p F P
0 0 0 r
s
.765 .205 .084 r
.41049 .5866 m .42862 .59227 L .43052 .60832 L p F P
0 0 0 r
s
.765 .205 .084 r
.44797 .61371 m .43052 .60832 L .42862 .59227 L p F P
0 0 0 r
s
.83 .24 .1 r
.42906 .57372 m
.42974 .59692 L
s
.42974 .59692 m
.46564 .60811 L
s
.96 .271 .113 r
.33991 .4813 m .32314 .47566 L .34024 .45771 L p F P
0 0 0 r
s
.266 .404 .736 r
.34024 .45771 m .34748 .44865 L .33103 .46577 L p F P
0 0 0 r
s
.83 .24 .1 r
.3355 .45596 m
.33923 .45724 L
s
.266 .404 .736 r
.33103 .46577 m .32314 .47566 L .34024 .45771 L p F P
0 0 0 r
s
.83 .24 .1 r
.34022 .45758 m
.37231 .46858 L
s
.113 .157 .348 r
.62739 .54413 m .61582 .55455 L .61348 .53535 L p F P
0 0 0 r
s
.113 .157 .348 r
.61348 .53535 m .62479 .52497 L .62739 .54413 L p F P
0 0 0 r
s
.83 .24 .1 r
.80587 .4584 m
.81855 .47088 L
s
.77326 .44557 m
.80587 .4584 L
s
.939 .263 .11 r
.32314 .47566 m .33991 .4813 L .32809 .50035 L p F P
0 0 0 r
s
.939 .263 .11 r
.34597 .50625 m .32809 .50035 L .33991 .4813 L p F P
0 0 0 r
s
.24 .35 .67 r
.27372 .56333 m
.29043 .54284 L
s
.27372 .56333 m
.27406 .58902 L
s
.83 .24 .1 r
.5948 .68593 m
.62925 .69629 L
s
.62925 .69629 m
.64384 .70125 L
s
.67 .175 .071 r
.44797 .61371 m .46525 .61904 L .46704 .63219 L p F P
0 0 0 r
s
.67 .175 .071 r
.48326 .63714 m .46704 .63219 L .46525 .61904 L p F P
0 0 0 r
s
.241 .354 .711 r
.59878 .40583 m .59216 .41266 L .57095 .40196 L p F P
0 0 0 r
s
.241 .354 .711 r
.57095 .40196 m .57595 .39666 L .59878 .40583 L p F P
0 0 0 r
s
.83 .24 .1 r
.59302 .39257 m
.62716 .40581 L
s
.58342 .39966 m
.59302 .39257 L
s
.83 .226 .093 r
.37328 .55688 m .39184 .56279 L .39218 .58087 L p F P
0 0 0 r
s
.83 .226 .093 r
.41049 .5866 m .39218 .58087 L .39184 .56279 L p F P
0 0 0 r
s
.83 .24 .1 r
.39287 .56219 m
.42906 .57372 L
s
.269 .398 .788 r
.55825 .38268 m .55488 .38633 L .52769 .38404 L p F P
0 0 0 r
s
.269 .398 .788 r
.52769 .38404 m .52935 .3822 L .55825 .38268 L p F P
0 0 0 r
s
.322 .484 .924 r
.41964 .40152 m .42402 .39622 L .40118 .40526 L p F P
0 0 0 r
s
.322 .484 .924 r
.40118 .40526 m .39561 .4121 L .41964 .40152 L p F P
0 0 0 r
s
.83 .24 .1 r
.3943 .41286 m
.40673 .38916 L
s
.306 .457 .887 r
.47554 .38389 m .47713 .38204 L .4546 .38237 L p F P
0 0 0 r
s
.306 .457 .887 r
.4546 .38237 m .45152 .38603 L .47554 .38389 L p F P
0 0 0 r
s
.912 .254 .105 r
.32809 .50035 m .34597 .50625 L .33891 .52572 L p F P
0 0 0 r
s
.912 .254 .105 r
.35747 .53173 m .33891 .52572 L .34597 .50625 L p F P
0 0 0 r
s
.24 .35 .67 r
.26374 .63504 m
.28029 .61583 L
s
.26374 .63504 m
.27536 .66127 L
s
.255 .376 .751 r
.581 .39132 m .57595 .39666 L .55153 .38997 L p F P
0 0 0 r
s
.255 .376 .751 r
.55153 .38997 m .55488 .38633 L .581 .39132 L p F P
0 0 0 r
s
.024 .036 .069 r
.58583 .62252 m .5758 .63121 L .57992 .618 L p F P
0 0 0 r
s
.24 .35 .67 r
.57285 .6292 m
.57986 .60765 L
s
.024 .036 .069 r
.57992 .618 m .59053 .60871 L .58583 .62252 L p F P
0 0 0 r
s
.316 .473 .911 r
.44846 .38967 m .45152 .38603 L .42844 .39087 L p F P
0 0 0 r
s
.316 .473 .911 r
.42844 .39087 m .42402 .39622 L .44846 .38967 L p F P
0 0 0 r
s
.83 .24 .1 r
.40673 .38916 m
.42445 .3957 L
s
.209 .305 .622 r
.62813 .44023 m .61878 .44941 L .60334 .43358 L p F P
0 0 0 r
s
.209 .305 .622 r
.60334 .43358 m .61137 .4255 L .62813 .44023 L p F P
0 0 0 r
s
.144 .204 .437 r
.63631 .5144 m .62479 .52497 L .61932 .50552 L p F P
0 0 0 r
s
.24 .35 .67 r
.59972 .53902 m
.62211 .51832 L
s
.144 .204 .437 r
.61932 .50552 m .63028 .49525 L .63631 .5144 L p F P
0 0 0 r
s
.83 .24 .1 r
.3355 .45596 m
.34548 .42769 L
s
.33344 .46327 m
.3355 .45596 L
s
.269 .398 .788 r
.56164 .379 m .55825 .38268 L .52935 .3822 L p F P
0 0 0 r
s
.269 .398 .788 r
.52935 .3822 m .53101 .38034 L .56164 .379 L p F P
0 0 0 r
s
.305 .461 .857 r
.36733 .43291 m .37384 .42483 L .35483 .43946 L p F P
0 0 0 r
s
.83 .24 .1 r
.36452 .43438 m
.36518 .43461 L
s
.305 .461 .857 r
.35483 .43946 m .34748 .44865 L .36733 .43291 L p F P
0 0 0 r
s
.83 .24 .1 r
.34548 .42769 m
.3624 .43364 L
s
.306 .457 .887 r
.47713 .38204 m .47871 .38019 L .45769 .37869 L p F P
0 0 0 r
s
.306 .457 .887 r
.45769 .37869 m .4546 .38237 L .47713 .38204 L p F P
0 0 0 r
s
.24 .35 .67 r
.47498 .39511 m
.487 .38121 L
s
.83 .24 .1 r
.34548 .42769 m
.35705 .40058 L
s
.30799 .4145 m
.34548 .42769 L
s
.24 .35 .67 r
.53904 .66623 m
.54139 .66421 L
s
.877 .242 .1 r
.33891 .52572 m .35747 .53173 L .35452 .55091 L p F P
0 0 0 r
s
.877 .242 .1 r
.37328 .55688 m .35452 .55091 L .35747 .53173 L p F P
0 0 0 r
s
.83 .24 .1 r
.35591 .55043 m
.35891 .52445 L
s
.36985 .37557 m
.40673 .38916 L
s
.528 .131 .051 r
.48326 .63714 m .49934 .64204 L .49939 .65151 L p F P
0 0 0 r
s
.83 .24 .1 r
.46979 .62783 m
.50544 .63876 L
s
.528 .131 .051 r
.51406 .65595 m .49939 .65151 L .49934 .64204 L p F P
0 0 0 r
s
.83 .24 .1 r
.73997 .43246 m
.72579 .42621 L
s
.69223 .413 m
.72579 .42621 L
s
.952 .285 .123 r
.52823 .37927 m .53101 .38034 L .56164 .379 L p F P
0 0 0 r
s
.226 .331 .669 r
.6195 .41732 m .61137 .4255 L .59216 .41266 L p F P
0 0 0 r
s
.24 .35 .67 r
.58206 .44424 m
.60413 .42183 L
s
.226 .331 .669 r
.59216 .41266 m .59878 .40583 L .6195 .41732 L p F P
0 0 0 r
s
.306 .457 .887 r
.47871 .38019 m .48031 .37833 L .4608 .37499 L p F P
0 0 0 r
s
.306 .457 .887 r
.4608 .37499 m .45769 .37869 L .47871 .38019 L p F P
0 0 0 r
s
.83 .24 .1 r
.54854 .66493 m
.55962 .67536 L
s
.24 .35 .67 r
.33754 .72517 m
.36381 .73785 L
s
.36381 .73785 m
.38223 .72047 L
s
.255 .376 .751 r
.58608 .38593 m .581 .39132 L .55488 .38633 L p F P
0 0 0 r
s
.83 .24 .1 r
.58336 .38881 m
.59302 .39257 L
s
.255 .376 .751 r
.55488 .38633 m .55825 .38268 L .58608 .38593 L p F P
0 0 0 r
s
.321 .483 .913 r
.39561 .4121 m .40118 .40526 L .38044 .41663 L p F P
0 0 0 r
s
.83 .24 .1 r
.35705 .40058 m
.38883 .41203 L
s
.392 .41317 m
.39309 .41357 L
s
.321 .483 .913 r
.38044 .41663 m .37384 .42483 L .39561 .4121 L p F P
0 0 0 r
s
.169 .243 .509 r
.64144 .4848 m .63028 .49525 L .62129 .47647 L p F P
0 0 0 r
s
.24 .35 .67 r
.61308 .49266 m
.62211 .51832 L
s
.169 .243 .509 r
.62129 .47647 m .63159 .4666 L .64144 .4848 L p F P
0 0 0 r
s
.316 .473 .911 r
.45152 .38603 m .4546 .38237 L .43289 .38548 L p F P
0 0 0 r
s
.316 .473 .911 r
.43289 .38548 m .42844 .39087 L .45152 .38603 L p F P
0 0 0 r
s
.952 .285 .123 r
.56164 .379 m .55615 .37686 L .52823 .37927 L p F P
0 0 0 r
s
.952 .285 .123 r
.52544 .3782 m .52823 .37927 L .55615 .37686 L p F P
0 0 0 r
s
.24 .35 .67 r
.40942 .72789 m
.43577 .72948 L
s
.43577 .72948 m
.45551 .71193 L
s
.241 .354 .711 r
.60547 .39892 m .59878 .40583 L .57595 .39666 L p F P
0 0 0 r
s
.24 .35 .67 r
.56129 .42317 m
.58297 .4004 L
s
.241 .354 .711 r
.57595 .39666 m .581 .39132 L .60547 .39892 L p F P
0 0 0 r
s
.765 .205 .084 r
.39218 .58087 m .41049 .5866 L .4129 .60288 L p F P
0 0 0 r
s
.765 .205 .084 r
.43052 .60832 m .4129 .60288 L .41049 .5866 L p F P
0 0 0 r
s
.939 .263 .11 r
.32809 .50035 m .31002 .49439 L .32314 .47566 L p F P
0 0 0 r
s
.83 .24 .1 r
.32744 .48448 m
.36445 .49685 L
s
.24 .35 .67 r
.3063 .4992 m
.31012 .49443 L
s
.024 .035 .067 r
.32314 .47566 m .33103 .46577 L .31838 .48393 L p F P
0 0 0 r
s
.24 .35 .67 r
.32348 .4777 m
.33383 .46696 L
s
.83 .24 .1 r
.32744 .48448 m
.33287 .46528 L
s
.024 .035 .067 r
.31838 .48393 m .31002 .49439 L .32314 .47566 L p F P
0 0 0 r
s
.24 .35 .67 r
.31956 .48261 m
.32348 .4777 L
s
.322 .484 .924 r
.42402 .39622 m .42844 .39087 L .40681 .39835 L p F P
0 0 0 r
s
.322 .484 .924 r
.40681 .39835 m .40118 .40526 L .42402 .39622 L p F P
0 0 0 r
s
.24 .35 .67 r
.40196 .4182 m
.417 .39992 L
s
.417 .39992 m
.44152 .39954 L
s
.024 .035 .067 r
.54602 .66257 m .53825 .66927 L .54304 .6647 L p F P
0 0 0 r
s
.83 .24 .1 r
.54465 .66375 m
.54854 .66493 L
s
.024 .035 .067 r
.54304 .6647 m .55181 .65713 L .54602 .66257 L p F P
0 0 0 r
s
.386 .087 .036 r
.52861 .66034 m .54304 .6647 L .53825 .66927 L p F P
0 0 0 r
s
.306 .457 .887 r
.48031 .37833 m .48191 .37647 L .46394 .37127 L p F P
0 0 0 r
s
.306 .457 .887 r
.46394 .37127 m .4608 .37499 L .48031 .37833 L p F P
0 0 0 r
s
.952 .285 .123 r
.55615 .37686 m .55064 .37472 L .52544 .3782 L p F P
0 0 0 r
s
.952 .285 .123 r
.52264 .37712 m .52544 .3782 L .55064 .37472 L p F P
0 0 0 r
s
.83 .24 .1 r
.50753 .37758 m
.52869 .38568 L
s
.31764 .48121 m
.319 .48166 L
s
.31978 .48192 m
.32744 .48448 L
s
.28965 .47185 m
.31764 .48121 L
s
.67 .175 .071 r
.43052 .60832 m .44797 .61371 L .45066 .6272 L p F P
0 0 0 r
s
.67 .175 .071 r
.46704 .63219 m .45066 .6272 L .44797 .61371 L p F P
0 0 0 r
s
.83 .24 .1 r
.46564 .60811 m
.46979 .62783 L
s
.024 .035 .067 r
.56976 .64163 m .56072 .64944 L .56593 .63977 L p F P
0 0 0 r
s
.024 .035 .067 r
.56593 .63977 m .5758 .63121 L .56976 .64163 L p F P
0 0 0 r
s
.24 .35 .67 r
.55134 .64794 m
.57285 .6292 L
s
.83 .226 .093 r
.35452 .55091 m .37328 .55688 L .37368 .57508 L p F P
0 0 0 r
s
.83 .226 .093 r
.39218 .58087 m .37368 .57508 L .37328 .55688 L p F P
0 0 0 r
s
.24 .35 .67 r
.29569 .51931 m
.29043 .54284 L
s
.952 .285 .123 r
.55064 .37472 m .54511 .37257 L .52264 .37712 L p F P
0 0 0 r
s
.952 .285 .123 r
.51984 .37605 m .52264 .37712 L .54511 .37257 L p F P
0 0 0 r
s
.24 .35 .67 r
.51291 .39105 m
.52537 .37706 L
s
.912 .254 .105 r
.31002 .49439 m .32809 .50035 L .32017 .51965 L p F P
0 0 0 r
s
.912 .254 .105 r
.33891 .52572 m .32017 .51965 L .32809 .50035 L p F P
0 0 0 r
s
.83 .24 .1 r
.32159 .51228 m
.32744 .48448 L
s
.36985 .37557 m
.35705 .40058 L
s
.31954 .38706 m
.35705 .40058 L
s
.24 .35 .67 r
.58297 .4004 m
.60413 .42183 L
s
.19 .276 .57 r
.64206 .45656 m .63159 .4666 L .61878 .44941 L p F P
0 0 0 r
s
.19 .276 .57 r
.61878 .44941 m .62813 .44023 L .64206 .45656 L p F P
0 0 0 r
s
.24 .35 .67 r
.59955 .46767 m
.622 .44562 L
s
.306 .457 .887 r
.48191 .37647 m .48351 .3746 L .46708 .36752 L p F P
0 0 0 r
s
.306 .457 .887 r
.46708 .36752 m .46394 .37127 L .48191 .37647 L p F P
0 0 0 r
s
.24 .35 .67 r
.46118 .37619 m
.487 .38121 L
s
.952 .285 .123 r
.54511 .37257 m .53956 .37042 L .51984 .37605 L p F P
0 0 0 r
s
.952 .285 .123 r
.51704 .37497 m .51984 .37605 L .53956 .37042 L p F P
0 0 0 r
s
.255 .376 .751 r
.59121 .3805 m .58608 .38593 L .55825 .38268 L p F P
0 0 0 r
s
.255 .376 .751 r
.55825 .38268 m .56164 .379 L .59121 .3805 L p F P
0 0 0 r
s
.24 .35 .67 r
.53796 .40522 m
.55927 .38208 L
s
.266 .404 .736 r
.34748 .44865 m .35483 .43946 L .33904 .45572 L p F P
0 0 0 r
s
.266 .404 .736 r
.33904 .45572 m .33103 .46577 L .34748 .44865 L p F P
0 0 0 r
s
.83 .24 .1 r
.29792 .44308 m
.3355 .45596 L
s
.316 .473 .911 r
.4546 .38237 m .45769 .37869 L .43738 .38005 L p F P
0 0 0 r
s
.316 .473 .911 r
.43738 .38005 m .43289 .38548 L .4546 .38237 L p F P
0 0 0 r
s
.83 .24 .1 r
.64384 .70125 m
.67802 .71152 L
s
.67802 .71152 m
.69504 .71052 L
s
.24 .35 .67 r
.27536 .66127 m
.29222 .64242 L
s
.27536 .66127 m
.29212 .68587 L
s
.952 .285 .123 r
.53956 .37042 m .534 .36826 L .51704 .37497 L p F P
0 0 0 r
s
.952 .285 .123 r
.51423 .37389 m .51704 .37497 L .534 .36826 L p F P
0 0 0 r
s
.306 .457 .887 r
.48351 .3746 m .48512 .37273 L .47025 .36376 L p F P
0 0 0 r
s
.306 .457 .887 r
.47025 .36376 m .46708 .36752 L .48351 .3746 L p F P
0 0 0 r
s
.079 .107 .249 r
.62698 .56257 m .61546 .57279 L .61582 .55455 L p F P
0 0 0 r
s
.079 .107 .249 r
.61582 .55455 m .62739 .54413 L .62698 .56257 L p F P
0 0 0 r
s
.528 .131 .051 r
.46704 .63219 m .48326 .63714 L .48459 .64704 L p F P
0 0 0 r
s
.528 .131 .051 r
.49939 .65151 m .48459 .64704 L .48326 .63714 L p F P
0 0 0 r
s
.209 .305 .622 r
.63762 .43091 m .62813 .44023 L .61137 .4255 L p F P
0 0 0 r
s
.209 .305 .622 r
.61137 .4255 m .6195 .41732 L .63762 .43091 L p F P
0 0 0 r
s
.24 .35 .67 r
.60413 .42183 m
.622 .44562 L
s
.047 .067 .154 r
.61232 .58964 m .60133 .59926 L .60413 .58282 L p F P
0 0 0 r
s
.24 .35 .67 r
.60199 .58809 m
.60347 .56417 L
s
.047 .067 .154 r
.60413 .58282 m .61546 .57279 L .61232 .58964 L p F P
0 0 0 r
s
.877 .242 .1 r
.32017 .51965 m .33891 .52572 L .33557 .54488 L p F P
0 0 0 r
s
.83 .24 .1 r
.32159 .51228 m
.35891 .52445 L
s
.877 .242 .1 r
.35452 .55091 m .33557 .54488 L .33891 .52572 L p F P
0 0 0 r
s
.952 .285 .123 r
.534 .36826 m .52842 .36609 L .51423 .37389 L p F P
0 0 0 r
s
.24 .35 .67 r
.53342 .36803 m
.53387 .36753 L
s
.952 .285 .123 r
.51142 .37281 m .51423 .37389 L .52842 .36609 L p F P
0 0 0 r
s
.241 .354 .711 r
.61223 .39194 m .60547 .39892 L .581 .39132 L p F P
0 0 0 r
s
.241 .354 .711 r
.581 .39132 m .58608 .38593 L .61223 .39194 L p F P
0 0 0 r
s
.24 .35 .67 r
.55927 .38208 m
.58297 .4004 L
s
.305 .461 .857 r
.37384 .42483 m .38044 .41663 L .36229 .43014 L p F P
0 0 0 r
s
.305 .461 .857 r
.36229 .43014 m .35483 .43946 L .37384 .42483 L p F P
0 0 0 r
s
.24 .35 .67 r
.53387 .36753 m
.53757 .36965 L
s
.113 .157 .348 r
.63917 .53352 m .62739 .54413 L .62479 .52497 L p F P
0 0 0 r
s
.113 .157 .348 r
.62479 .52497 m .63631 .5144 L .63917 .53352 L p F P
0 0 0 r
s
.24 .35 .67 r
.62211 .51832 m
.62616 .5437 L
s
.31321 .70755 m
.33754 .72517 L
s
.33754 .72517 m
.35557 .70747 L
s
.226 .331 .669 r
.62773 .40903 m .6195 .41732 L .59878 .40583 L p F P
0 0 0 r
s
.226 .331 .669 r
.59878 .40583 m .60547 .39892 L .62773 .40903 L p F P
0 0 0 r
s
.322 .484 .924 r
.42844 .39087 m .43289 .38548 L .4125 .39136 L p F P
0 0 0 r
s
.322 .484 .924 r
.4125 .39136 m .40681 .39835 L .42844 .39087 L p F P
0 0 0 r
s
.386 .087 .036 r
.51406 .65595 m .52861 .66034 L .52542 .66541 L p F P
0 0 0 r
s
.386 .087 .036 r
.53825 .66927 m .52542 .66541 L .52861 .66034 L p F P
0 0 0 r
s
.24 .35 .67 r
.52195 .68048 m
.53616 .66864 L
s
.952 .285 .123 r
.52842 .36609 m .52282 .36391 L .51142 .37281 L p F P
0 0 0 r
s
.952 .285 .123 r
.5086 .37172 m .51142 .37281 L .52282 .36391 L p F P
0 0 0 r
s
.306 .457 .887 r
.48512 .37273 m .48673 .37085 L .47344 .35997 L p F P
0 0 0 r
s
.306 .457 .887 r
.47344 .35997 m .47025 .36376 L .48512 .37273 L p F P
0 0 0 r
s
.321 .483 .913 r
.40118 .40526 m .40681 .39835 L .38712 .40833 L p F P
0 0 0 r
s
.321 .483 .913 r
.38712 .40833 m .38044 .41663 L .40118 .40526 L p F P
0 0 0 r
s
.882 .269 .117 r
.55615 .37686 m .56164 .379 L .59121 .3805 L p F P
0 0 0 r
s
.24 .35 .67 r
.54998 .37676 m
.55927 .38208 L
s
.83 .24 .1 r
.55818 .37904 m
.56428 .38141 L
s
.55245 .38349 m
.55818 .37904 L
s
.316 .473 .911 r
.45769 .37869 m .4608 .37499 L .44191 .37457 L p F P
0 0 0 r
s
.316 .473 .911 r
.44191 .37457 m .43738 .38005 L .45769 .37869 L p F P
0 0 0 r
s
.83 .24 .1 r
.42059 .36752 m
.44129 .37532 L
s
.24 .35 .67 r
.44152 .39954 m
.46118 .37619 L
s
.765 .205 .084 r
.37368 .57508 m .39218 .58087 L .39509 .59738 L p F P
0 0 0 r
s
.765 .205 .084 r
.4129 .60288 m .39509 .59738 L .39218 .58087 L p F P
0 0 0 r
s
.83 .24 .1 r
.39287 .56219 m
.39308 .58549 L
s
.39308 .58549 m
.42974 .59692 L
s
.024 .036 .069 r
.59602 .61367 m .58583 .62252 L .59053 .60871 L p F P
0 0 0 r
s
.024 .036 .069 r
.59053 .60871 m .60133 .59926 L .59602 .61367 L p F P
0 0 0 r
s
.24 .35 .67 r
.57986 .60765 m
.60199 .58809 L
s
.952 .285 .123 r
.52282 .36391 m .5172 .36173 L .5086 .37172 L p F P
0 0 0 r
s
.952 .285 .123 r
.50578 .37064 m .5086 .37172 L .5172 .36173 L p F P
0 0 0 r
s
.67 .175 .071 r
.4129 .60288 m .43052 .60832 L .43413 .62215 L p F P
0 0 0 r
s
.67 .175 .071 r
.45066 .6272 m .43413 .62215 L .43052 .60832 L p F P
0 0 0 r
s
.83 .24 .1 r
.78553 .45797 m
.77326 .44557 L
s
.73997 .43246 m
.77326 .44557 L
s
.144 .204 .437 r
.64804 .50364 m .63631 .5144 L .63028 .49525 L p F P
0 0 0 r
s
.144 .204 .437 r
.63028 .49525 m .64144 .4848 L .64804 .50364 L p F P
0 0 0 r
s
.83 .24 .1 r
.55962 .67536 m
.5948 .68593 L
s
.5948 .68593 m
.60893 .69076 L
s
.24 .35 .67 r
.29212 .68587 m
.30936 .66741 L
s
.29212 .68587 m
.31321 .70755 L
s
.27406 .58902 m
.29096 .56878 L
s
.27406 .58902 m
.28029 .61583 L
s
.306 .457 .887 r
.48673 .37085 m .48835 .36896 L .47664 .35616 L p F P
0 0 0 r
s
.306 .457 .887 r
.47664 .35616 m .47344 .35997 L .48673 .37085 L p F P
0 0 0 r
s
.24 .35 .67 r
.45551 .71193 m
.47997 .70792 L
s
.47997 .70792 m
.50065 .68986 L
s
.952 .285 .123 r
.5172 .36173 m .51156 .35954 L .50578 .37064 L p F P
0 0 0 r
s
.952 .285 .123 r
.50295 .36955 m .50578 .37064 L .51156 .35954 L p F P
0 0 0 r
s
.83 .226 .093 r
.33557 .54488 m .35452 .55091 L .35498 .56922 L p F P
0 0 0 r
s
.83 .226 .093 r
.37368 .57508 m .35498 .56922 L .35452 .55091 L p F P
0 0 0 r
s
.83 .24 .1 r
.35591 .55043 m
.39287 .56219 L
s
.912 .254 .105 r
.32017 .51965 m .30122 .51352 L .31002 .49439 L p F P
0 0 0 r
s
.024 .035 .067 r
.31002 .49439 m .31838 .48393 L .30989 .50274 L p F P
0 0 0 r
s
.024 .035 .067 r
.30989 .50274 m .30122 .51352 L .31002 .49439 L p F P
0 0 0 r
s
.24 .35 .67 r
.29569 .51931 m
.30239 .51098 L
s
.31321 .70755 m
.33084 .68948 L
s
.882 .269 .117 r
.59121 .3805 m .58315 .37734 L .55615 .37686 L p F P
0 0 0 r
s
.24 .35 .67 r
.55927 .38208 m
.56305 .37797 L
s
.882 .269 .117 r
.55064 .37472 m .55615 .37686 L .58315 .37734 L p F P
0 0 0 r
s
.952 .285 .123 r
.51156 .35954 m .50591 .35734 L .50295 .36955 L p F P
0 0 0 r
s
.24 .35 .67 r
.50721 .35785 m
.50765 .35733 L
s
.83 .24 .1 r
.50753 .37758 m
.5226 .36523 L
s
.952 .285 .123 r
.50012 .36846 m .50295 .36955 L .50591 .35734 L p F P
0 0 0 r
s
.83 .24 .1 r
.4861 .36937 m
.50753 .37758 L
s
.30624 .50728 m
.32159 .51228 L
s
.306 .457 .887 r
.48835 .36896 m .48997 .36707 L .47986 .35233 L p F P
0 0 0 r
s
.306 .457 .887 r
.47986 .35233 m .47664 .35616 L .48835 .36896 L p F P
0 0 0 r
s
.169 .243 .509 r
.65278 .47417 m .64144 .4848 L .63159 .4666 L p F P
0 0 0 r
s
.169 .243 .509 r
.63159 .4666 m .64206 .45656 L .65278 .47417 L p F P
0 0 0 r
s
.24 .35 .67 r
.61308 .49266 m
.63592 .47093 L
s
.83 .24 .1 r
.30799 .4145 m
.29792 .44308 L
s
.25955 .42993 m
.29792 .44308 L
s
.29792 .44308 m
.28965 .47185 L
s
.024 .035 .067 r
.55389 .65578 m .54602 .66257 L .55181 .65713 L p F P
0 0 0 r
s
.024 .035 .067 r
.55181 .65713 m .56072 .64944 L .55389 .65578 L p F P
0 0 0 r
s
.952 .285 .123 r
.50591 .35734 m .50024 .35514 L .50012 .36846 L p F P
0 0 0 r
s
.952 .285 .123 r
.49728 .36737 m .50012 .36846 L .50024 .35514 L p F P
0 0 0 r
s
.83 .24 .1 r
.31954 .38706 m
.30799 .4145 L
s
.26972 .40104 m
.30799 .4145 L
s
.316 .473 .911 r
.4608 .37499 m .46394 .37127 L .44648 .36904 L p F P
0 0 0 r
s
.316 .473 .911 r
.44648 .36904 m .44191 .37457 L .4608 .37499 L p F P
0 0 0 r
s
.528 .131 .051 r
.45066 .6272 m .46704 .63219 L .46966 .64252 L p F P
0 0 0 r
s
.528 .131 .051 r
.48459 .64704 m .46966 .64252 L .46704 .63219 L p F P
0 0 0 r
s
.241 .354 .711 r
.61907 .38488 m .61223 .39194 L .58608 .38593 L p F P
0 0 0 r
s
.241 .354 .711 r
.58608 .38593 m .59121 .3805 L .61907 .38488 L p F P
0 0 0 r
s
.024 .035 .067 r
.33103 .46577 m .33904 .45572 L .32689 .47328 L p F P
0 0 0 r
s
.024 .035 .067 r
.32689 .47328 m .31838 .48393 L .33103 .46577 L p F P
0 0 0 r
s
.882 .269 .117 r
.58315 .37734 m .57505 .37417 L .55064 .37472 L p F P
0 0 0 r
s
.882 .269 .117 r
.54511 .37257 m .55064 .37472 L .57505 .37417 L p F P
0 0 0 r
s
.322 .484 .924 r
.43289 .38548 m .43738 .38005 L .41825 .38429 L p F P
0 0 0 r
s
.322 .484 .924 r
.41825 .38429 m .4125 .39136 L .43289 .38548 L p F P
0 0 0 r
s
.83 .24 .1 r
.40673 .38916 m
.42059 .36752 L
s
.952 .285 .123 r
.50024 .35514 m .49454 .35293 L .49728 .36737 L p F P
0 0 0 r
s
.952 .285 .123 r
.49444 .36627 m .49728 .36737 L .49454 .35293 L p F P
0 0 0 r
s
.877 .242 .1 r
.30122 .51352 m .32017 .51965 L .31641 .53879 L p F P
0 0 0 r
s
.877 .242 .1 r
.33557 .54488 m .31641 .53879 L .32017 .51965 L p F P
0 0 0 r
s
.83 .24 .1 r
.31818 .53841 m
.32159 .51228 L
s
.69504 .71052 m
.72891 .72076 L
s
.74754 .71367 m
.72891 .72076 L
s
.386 .087 .036 r
.49939 .65151 m .51406 .65595 L .51249 .66153 L p F P
0 0 0 r
s
.83 .24 .1 r
.50544 .63876 m
.51312 .6542 L
s
.386 .087 .036 r
.52542 .66541 m .51249 .66153 L .51406 .65595 L p F P
0 0 0 r
s
.83 .24 .1 r
.51312 .6542 m
.54408 .66358 L
s
.38346 .35355 m
.36985 .37557 L
s
.33219 .36168 m
.36985 .37557 L
s
.306 .457 .887 r
.48997 .36707 m .49159 .36518 L .4831 .34848 L p F P
0 0 0 r
s
.306 .457 .887 r
.4831 .34848 m .47986 .35233 L .48997 .36707 L p F P
0 0 0 r
s
.24 .35 .67 r
.487 .38121 m
.49928 .36702 L
s
.024 .035 .067 r
.57894 .63371 m .56976 .64163 L .5758 .63121 L p F P
0 0 0 r
s
.024 .035 .067 r
.5758 .63121 m .58583 .62252 L .57894 .63371 L p F P
0 0 0 r
s
.83 .24 .1 r
.38346 .35355 m
.42059 .36752 L
s
.19 .276 .57 r
.65271 .44636 m .64206 .45656 L .62813 .44023 L p F P
0 0 0 r
s
.19 .276 .57 r
.62813 .44023 m .63762 .43091 L .65271 .44636 L p F P
0 0 0 r
s
.24 .35 .67 r
.622 .44562 m
.63592 .47093 L
s
.83 .24 .1 r
.70596 .41908 m
.69223 .413 L
s
.65797 .39951 m
.69223 .413 L
s
.952 .285 .123 r
.49454 .35293 m .48883 .35071 L .49444 .36627 L p F P
0 0 0 r
s
.952 .285 .123 r
.49159 .36518 m .49444 .36627 L .48883 .35071 L p F P
0 0 0 r
s
.24 .35 .67 r
.38223 .72047 m
.40942 .72789 L
s
.40942 .72789 m
.42888 .71013 L
s
.226 .331 .669 r
.63608 .40063 m .62773 .40903 L .60547 .39892 L p F P
0 0 0 r
s
.226 .331 .669 r
.60547 .39892 m .61223 .39194 L .63608 .40063 L p F P
0 0 0 r
s
.83 .24 .1 r
.61522 .38885 m
.64304 .39975 L
s
.266 .404 .736 r
.35483 .43946 m .36229 .43014 L .34719 .44551 L p F P
0 0 0 r
s
.266 .404 .736 r
.34719 .44551 m .33904 .45572 L .35483 .43946 L p F P
0 0 0 r
s
.24 .35 .67 r
.34103 .45902 m
.35664 .43953 L
s
.882 .269 .117 r
.57505 .37417 m .56691 .37098 L .54511 .37257 L p F P
0 0 0 r
s
.882 .269 .117 r
.53956 .37042 m .54511 .37257 L .56691 .37098 L p F P
0 0 0 r
s
.209 .305 .622 r
.64726 .42146 m .63762 .43091 L .6195 .41732 L p F P
0 0 0 r
s
.209 .305 .622 r
.6195 .41732 m .62773 .40903 L .64726 .42146 L p F P
0 0 0 r
s
.321 .483 .913 r
.40681 .39835 m .4125 .39136 L .3939 .39993 L p F P
0 0 0 r
s
.321 .483 .913 r
.3939 .39993 m .38712 .40833 L .40681 .39835 L p F P
0 0 0 r
s
.24 .35 .67 r
.39454 .40557 m
.417 .39992 L
s
.952 .285 .123 r
.48883 .35071 m .4831 .34848 L .49159 .36518 L p F P
0 0 0 r
s
.305 .461 .857 r
.38044 .41663 m .38712 .40833 L .36986 .42067 L p F P
0 0 0 r
s
.305 .461 .857 r
.36986 .42067 m .36229 .43014 L .38044 .41663 L p F P
0 0 0 r
s
.24 .35 .67 r
.37594 .42854 m
.39454 .40557 L
s
.35664 .43953 m
.37594 .42854 L
s
.765 .205 .084 r
.35498 .56922 m .37368 .57508 L .37711 .59183 L p F P
0 0 0 r
s
.765 .205 .084 r
.39509 .59738 m .37711 .59183 L .37368 .57508 L p F P
0 0 0 r
s
.67 .175 .071 r
.39509 .59738 m .4129 .60288 L .41744 .61706 L p F P
0 0 0 r
s
.67 .175 .071 r
.43413 .62215 m .41744 .61706 L .4129 .60288 L p F P
0 0 0 r
s
.83 .24 .1 r
.42974 .59692 m
.43339 .61668 L
s
.316 .473 .911 r
.46394 .37127 m .46708 .36752 L .45109 .36347 L p F P
0 0 0 r
s
.316 .473 .911 r
.45109 .36347 m .44648 .36904 L .46394 .37127 L p F P
0 0 0 r
s
.83 .24 .1 r
.25106 .45896 m
.28965 .47185 L
s
.28965 .47185 m
.28348 .49986 L
s
.24 .35 .67 r
.50065 .68986 m
.52195 .68048 L
s
.882 .269 .117 r
.56691 .37098 m .55873 .36778 L .53956 .37042 L p F P
0 0 0 r
s
.882 .269 .117 r
.534 .36826 m .53956 .37042 L .55873 .36778 L p F P
0 0 0 r
s
.83 .226 .093 r
.31641 .53879 m .33557 .54488 L .33609 .56331 L p F P
0 0 0 r
s
.83 .226 .093 r
.35498 .56922 m .33609 .56331 L .33557 .54488 L p F P
0 0 0 r
s
.83 .24 .1 r
.81855 .47088 m
.82818 .48898 L
s
.78553 .45797 m
.81855 .47088 L
s
.33219 .36168 m
.31954 .38706 L
s
.28123 .37326 m
.31954 .38706 L
s
.748 .235 .103 r
.58315 .37734 m .59121 .3805 L .61907 .38488 L p F P
0 0 0 r
s
.079 .107 .249 r
.63873 .55216 m .62698 .56257 L .62739 .54413 L p F P
0 0 0 r
s
.079 .107 .249 r
.62739 .54413 m .63917 .53352 L .63873 .55216 L p F P
0 0 0 r
s
.047 .067 .154 r
.6235 .57985 m .61232 .58964 L .61546 .57279 L p F P
0 0 0 r
s
.047 .067 .154 r
.61546 .57279 m .62698 .56257 L .6235 .57985 L p F P
0 0 0 r
s
.24 .35 .67 r
.60347 .56417 m
.62616 .5437 L
s
.322 .484 .924 r
.43738 .38005 m .44191 .37457 L .42407 .37715 L p F P
0 0 0 r
s
.322 .484 .924 r
.42407 .37715 m .41825 .38429 L .43738 .38005 L p F P
0 0 0 r
s
.528 .131 .051 r
.43413 .62215 m .45066 .6272 L .45461 .63797 L p F P
0 0 0 r
s
.528 .131 .051 r
.46966 .64252 m .45461 .63797 L .45066 .6272 L p F P
0 0 0 r
s
.83 .24 .1 r
.43339 .61668 m
.46979 .62783 L
s
.60893 .69076 m
.64384 .70125 L
s
.64384 .70125 m
.66045 .70007 L
s
.386 .087 .036 r
.48459 .64704 m .49939 .65151 L .49946 .65761 L p F P
0 0 0 r
s
.386 .087 .036 r
.51249 .66153 m .49946 .65761 L .49939 .65151 L p F P
0 0 0 r
s
.882 .269 .117 r
.55873 .36778 m .55051 .36456 L .534 .36826 L p F P
0 0 0 r
s
.882 .269 .117 r
.52842 .36609 m .534 .36826 L .55051 .36456 L p F P
0 0 0 r
s
.113 .157 .348 r
.65118 .52271 m .63917 .53352 L .63631 .5144 L p F P
0 0 0 r
s
.113 .157 .348 r
.63631 .5144 m .64804 .50364 L .65118 .52271 L p F P
0 0 0 r
s
.24 .35 .67 r
.29043 .54284 m
.29096 .56878 L
s
.316 .473 .911 r
.46708 .36752 m .47025 .36376 L .45573 .35785 L p F P
0 0 0 r
s
.316 .473 .911 r
.45573 .35785 m .45109 .36347 L .46708 .36752 L p F P
0 0 0 r
s
.024 .036 .069 r
.60639 .60468 m .59602 .61367 L .60133 .59926 L p F P
0 0 0 r
s
.024 .036 .069 r
.60133 .59926 m .61232 .58964 L .60639 .60468 L p F P
0 0 0 r
s
.24 .35 .67 r
.59515 .60977 m
.60199 .58809 L
s
.877 .242 .1 r
.31641 .53879 m .29704 .53263 L .30122 .51352 L p F P
0 0 0 r
s
.041 .06 .137 r
.30122 .51352 m .30989 .50274 L .30586 .5218 L p F P
0 0 0 r
s
.83 .24 .1 r
.28348 .49986 m
.30347 .50638 L
s
.30347 .50638 m
.30454 .50673 L
s
.041 .06 .137 r
.30586 .5218 m .29704 .53263 L .30122 .51352 L p F P
0 0 0 r
s
.144 .204 .437 r
.65998 .49268 m .64804 .50364 L .64144 .4848 L p F P
0 0 0 r
s
.24 .35 .67 r
.62211 .51832 m
.64531 .49687 L
s
.144 .204 .437 r
.64144 .4848 m .65278 .47417 L .65998 .49268 L p F P
0 0 0 r
s
.24 .35 .67 r
.28029 .61583 m
.29745 .5959 L
s
.28029 .61583 m
.29222 .64242 L
s
.748 .235 .103 r
.61907 .38488 m .60862 .38077 L .58315 .37734 L p F P
0 0 0 r
s
.24 .35 .67 r
.58297 .4004 m
.60086 .38161 L
s
.748 .235 .103 r
.57505 .37417 m .58315 .37734 L .60862 .38077 L p F P
0 0 0 r
s
.882 .269 .117 r
.55051 .36456 m .54226 .36133 L .52842 .36609 L p F P
0 0 0 r
s
.882 .269 .117 r
.52282 .36391 m .52842 .36609 L .54226 .36133 L p F P
0 0 0 r
s
.83 .24 .1 r
.5226 .36523 m
.55818 .37904 L
s
.226 .331 .669 r
.64453 .39212 m .63608 .40063 L .61223 .39194 L p F P
0 0 0 r
s
.24 .35 .67 r
.60413 .42183 m
.627 .39861 L
s
.83 .24 .1 r
.64304 .39975 m
.65797 .39951 L
s
.226 .331 .669 r
.61223 .39194 m .61907 .38488 L .64453 .39212 L p F P
0 0 0 r
s
.024 .035 .067 r
.56186 .64891 m .55389 .65578 L .56072 .64944 L p F P
0 0 0 r
s
.24 .35 .67 r
.54174 .6639 m
.56063 .64757 L
s
.024 .035 .067 r
.56072 .64944 m .56976 .64163 L .56186 .64891 L p F P
0 0 0 r
s
.24 .35 .67 r
.56063 .64757 m
.57285 .6292 L
s
.024 .035 .067 r
.31838 .48393 m .32689 .47328 L .31872 .49177 L p F P
0 0 0 r
s
.024 .035 .067 r
.31872 .49177 m .30989 .50274 L .31838 .48393 L p F P
0 0 0 r
s
.321 .483 .913 r
.4125 .39136 m .41825 .38429 L .40076 .39141 L p F P
0 0 0 r
s
.321 .483 .913 r
.40076 .39141 m .3939 .39993 L .4125 .39136 L p F P
0 0 0 r
s
.67 .175 .071 r
.37711 .59183 m .39509 .59738 L .40059 .61192 L p F P
0 0 0 r
s
.67 .175 .071 r
.41744 .61706 m .40059 .61192 L .39509 .59738 L p F P
0 0 0 r
s
.765 .205 .084 r
.33609 .56331 m .35498 .56922 L .35894 .58623 L p F P
0 0 0 r
s
.765 .205 .084 r
.37711 .59183 m .35894 .58623 L .35498 .56922 L p F P
0 0 0 r
s
.83 .24 .1 r
.35566 .57381 m
.35591 .55043 L
s
.35566 .57381 m
.39308 .58549 L
s
.169 .243 .509 r
.66433 .46335 m .65278 .47417 L .64206 .45656 L p F P
0 0 0 r
s
.24 .35 .67 r
.63592 .47093 m
.64531 .49687 L
s
.169 .243 .509 r
.64206 .45656 m .65271 .44636 L .66433 .46335 L p F P
0 0 0 r
s
.83 .24 .1 r
.7518 .44478 m
.73997 .43246 L
s
.70596 .41908 m
.73997 .43246 L
s
.209 .305 .622 r
.65703 .41186 m .64726 .42146 L .62773 .40903 L p F P
0 0 0 r
s
.209 .305 .622 r
.62773 .40903 m .63608 .40063 L .65703 .41186 L p F P
0 0 0 r
s
.83 .24 .1 r
.55962 .67536 m
.57327 .68005 L
s
.024 .035 .067 r
.33904 .45572 m .34719 .44551 L .33554 .46244 L p F P
0 0 0 r
s
.024 .035 .067 r
.33554 .46244 m .32689 .47328 L .33904 .45572 L p F P
0 0 0 r
s
.882 .269 .117 r
.54226 .36133 m .53396 .35808 L .52282 .36391 L p F P
0 0 0 r
s
.882 .269 .117 r
.5172 .36173 m .52282 .36391 L .53396 .35808 L p F P
0 0 0 r
s
.24 .35 .67 r
.50765 .35733 m
.51833 .36148 L
s
.19 .276 .57 r
.66353 .43599 m .65271 .44636 L .63762 .43091 L p F P
0 0 0 r
s
.19 .276 .57 r
.63762 .43091 m .64726 .42146 L .66353 .43599 L p F P
0 0 0 r
s
.24 .35 .67 r
.622 .44562 m
.64529 .42275 L
s
.316 .473 .911 r
.47025 .36376 m .47344 .35997 L .46041 .35218 L p F P
0 0 0 r
s
.316 .473 .911 r
.46041 .35218 m .45573 .35785 L .47025 .36376 L p F P
0 0 0 r
s
.83 .24 .1 r
.4349 .34977 m
.45579 .35777 L
s
.24 .35 .67 r
.5039 .35656 m
.50765 .35733 L
s
.322 .484 .924 r
.44191 .37457 m .44648 .36904 L .42995 .36993 L p F P
0 0 0 r
s
.322 .484 .924 r
.42995 .36993 m .42407 .37715 L .44191 .37457 L p F P
0 0 0 r
s
.24 .35 .67 r
.417 .39992 m
.43645 .3763 L
s
.43645 .3763 m
.46118 .37619 L
s
.305 .461 .857 r
.38712 .40833 m .3939 .39993 L .37755 .41106 L p F P
0 0 0 r
s
.305 .461 .857 r
.37755 .41106 m .36986 .42067 L .38712 .40833 L p F P
0 0 0 r
s
.83 .226 .093 r
.29704 .53263 m .31641 .53879 L .317 .55733 L p F P
0 0 0 r
s
.24 .35 .67 r
.29043 .54284 m
.2979 .53369 L
s
.83 .226 .093 r
.33609 .56331 m .317 .55733 L .31641 .53879 L p F P
0 0 0 r
s
.83 .24 .1 r
.31818 .53841 m
.35591 .55043 L
s
.748 .235 .103 r
.60862 .38077 m .59811 .37664 L .57505 .37417 L p F P
0 0 0 r
s
.24 .35 .67 r
.60356 .37878 m
.60544 .3768 L
s
.748 .235 .103 r
.56691 .37098 m .57505 .37417 L .59811 .37664 L p F P
0 0 0 r
s
.266 .404 .736 r
.36229 .43014 m .36986 .42067 L .35547 .43512 L p F P
0 0 0 r
s
.266 .404 .736 r
.35547 .43512 m .34719 .44551 L .36229 .43014 L p F P
0 0 0 r
s
.24 .35 .67 r
.34129 .45541 m
.35664 .43953 L
s
.024 .035 .067 r
.58826 .62567 m .57894 .63371 L .58583 .62252 L p F P
0 0 0 r
s
.024 .035 .067 r
.58583 .62252 m .59602 .61367 L .58826 .62567 L p F P
0 0 0 r
s
.24 .35 .67 r
.57285 .6292 m
.59515 .60977 L
s
.272 .062 .026 r
.52542 .66541 m .53825 .66927 L .53238 .6699 L p F P
0 0 0 r
s
.273 .421 .783 r
.53891 .66424 m .53238 .6699 L .53825 .66927 L p F P
0 0 0 r
s
.273 .421 .783 r
.53825 .66927 m .54602 .66257 L .53891 .66424 L p F P
0 0 0 r
s
.83 .24 .1 r
.53748 .6687 m
.53864 .66905 L
s
.53864 .66905 m
.55962 .67536 L
s
.24 .35 .67 r
.35557 .70747 m
.38223 .72047 L
s
.38223 .72047 m
.40133 .70243 L
s
.386 .087 .036 r
.46966 .64252 m .48459 .64704 L .48633 .65367 L p F P
0 0 0 r
s
.83 .24 .1 r
.46979 .62783 m
.47695 .64326 L
s
.386 .087 .036 r
.49946 .65761 m .48633 .65367 L .48459 .64704 L p F P
0 0 0 r
s
.83 .24 .1 r
.47695 .64326 m
.51312 .6542 L
s
.528 .131 .051 r
.41744 .61706 m .43413 .62215 L .43942 .63338 L p F P
0 0 0 r
s
.528 .131 .051 r
.45461 .63797 m .43942 .63338 L .43413 .62215 L p F P
0 0 0 r
s
.83 .24 .1 r
.24456 .48718 m
.28348 .49986 L
s
.28348 .49986 m
.27965 .52614 L
s
.24 .35 .67 r
.42888 .71013 m
.45551 .71193 L
s
.45551 .71193 m
.47599 .69373 L
s
.882 .269 .117 r
.53396 .35808 m .52562 .35482 L .5172 .36173 L p F P
0 0 0 r
s
.882 .269 .117 r
.51156 .35954 m .5172 .36173 L .52562 .35482 L p F P
0 0 0 r
s
.83 .24 .1 r
.26972 .40104 m
.25955 .42993 L
s
.22036 .41649 m
.25955 .42993 L
s
.25955 .42993 m
.25106 .45896 L
s
.28123 .37326 m
.26972 .40104 L
s
.23062 .3873 m
.26972 .40104 L
s
.66045 .70007 m
.69504 .71052 L
s
.69504 .71052 m
.71334 .70319 L
s
.316 .473 .911 r
.47344 .35997 m .47664 .35616 L .46514 .34646 L p F P
0 0 0 r
s
.316 .473 .911 r
.46514 .34646 m .46041 .35218 L .47344 .35997 L p F P
0 0 0 r
s
.83 .24 .1 r
.34553 .33929 m
.33219 .36168 L
s
.29372 .3475 m
.33219 .36168 L
s
.748 .235 .103 r
.59811 .37664 m .58754 .37248 L .56691 .37098 L p F P
0 0 0 r
s
.748 .235 .103 r
.55873 .36778 m .56691 .37098 L .58754 .37248 L p F P
0 0 0 r
s
.83 .24 .1 r
.39742 .33542 m
.38346 .35355 L
s
.34553 .33929 m
.38346 .35355 L
s
.882 .269 .117 r
.52562 .35482 m .51724 .35153 L .51156 .35954 L p F P
0 0 0 r
s
.882 .269 .117 r
.50591 .35734 m .51156 .35954 L .51724 .35153 L p F P
0 0 0 r
s
.24 .35 .67 r
.61161 .38304 m
.627 .39861 L
s
.60544 .3768 m
.60984 .38125 L
s
.541 .178 .08 r
.60862 .38077 m .61907 .38488 L .64453 .39212 L p F P
0 0 0 r
s
.67 .175 .071 r
.35894 .58623 m .37711 .59183 L .38358 .60673 L p F P
0 0 0 r
s
.67 .175 .071 r
.40059 .61192 m .38358 .60673 L .37711 .59183 L p F P
0 0 0 r
s
.83 .24 .1 r
.39308 .58549 m
.39622 .60528 L
s
.24 .35 .67 r
.29222 .64242 m
.30972 .62287 L
s
.29222 .64242 m
.30936 .66741 L
s
.321 .483 .913 r
.41825 .38429 m .42407 .37715 L .40771 .38278 L p F P
0 0 0 r
s
.321 .483 .913 r
.40771 .38278 m .40076 .39141 L .41825 .38429 L p F P
0 0 0 r
s
.765 .205 .084 r
.317 .55733 m .33609 .56331 L .34058 .58056 L p F P
0 0 0 r
s
.765 .205 .084 r
.35894 .58623 m .34058 .58056 L .33609 .56331 L p F P
0 0 0 r
s
.322 .484 .924 r
.44648 .36904 m .45109 .36347 L .43589 .36264 L p F P
0 0 0 r
s
.322 .484 .924 r
.43589 .36264 m .42995 .36993 L .44648 .36904 L p F P
0 0 0 r
s
.83 .24 .1 r
.42059 .36752 m
.4349 .34977 L
s
.272 .062 .026 r
.51249 .66153 m .52542 .66541 L .5215 .66664 L p F P
0 0 0 r
s
.272 .062 .026 r
.53238 .6699 m .5215 .66664 L .52542 .66541 L p F P
0 0 0 r
s
.83 .24 .1 r
.52369 .66456 m
.53471 .66787 L
s
.24 .35 .67 r
.52195 .68048 m
.53444 .66968 L
s
.882 .269 .117 r
.51724 .35153 m .50882 .34824 L .50591 .35734 L p F P
0 0 0 r
s
.882 .269 .117 r
.50024 .35514 m .50591 .35734 L .50882 .34824 L p F P
0 0 0 r
s
.83 .24 .1 r
.21165 .44579 m
.25106 .45896 L
s
.25106 .45896 m
.24456 .48718 L
s
.047 .067 .154 r
.63489 .56989 m .6235 .57985 L .62698 .56257 L p F P
0 0 0 r
s
.24 .35 .67 r
.62494 .56781 m
.62616 .5437 L
s
.047 .067 .154 r
.62698 .56257 m .63873 .55216 L .63489 .56989 L p F P
0 0 0 r
s
.079 .107 .249 r
.65069 .54156 m .63873 .55216 L .63917 .53352 L p F P
0 0 0 r
s
.079 .107 .249 r
.63917 .53352 m .65118 .52271 L .65069 .54156 L p F P
0 0 0 r
s
.386 .087 .036 r
.45461 .63797 m .46966 .64252 L .4731 .64969 L p F P
0 0 0 r
s
.386 .087 .036 r
.48633 .65367 m .4731 .64969 L .46966 .64252 L p F P
0 0 0 r
s
.748 .235 .103 r
.58754 .37248 m .5769 .36829 L .55873 .36778 L p F P
0 0 0 r
s
.24 .35 .67 r
.58137 .35808 m
.60544 .3768 L
s
.83 .24 .1 r
.55818 .37904 m
.57322 .37239 L
s
.57322 .37239 m
.60147 .38346 L
s
.748 .235 .103 r
.55051 .36456 m .55873 .36778 L .5769 .36829 L p F P
0 0 0 r
s
.24 .35 .67 r
.57254 .36767 m
.58137 .35808 L
s
.58137 .35808 m
.60429 .33319 L
s
.58137 .35808 m
.55561 .34314 L
s
.316 .473 .911 r
.47664 .35616 m .47986 .35233 L .4699 .3407 L p F P
0 0 0 r
s
.316 .473 .911 r
.4699 .3407 m .46514 .34646 L .47664 .35616 L p F P
0 0 0 r
s
.528 .131 .051 r
.40059 .61192 m .41744 .61706 L .4241 .62875 L p F P
0 0 0 r
s
.83 .24 .1 r
.39622 .60528 m
.43339 .61668 L
s
.528 .131 .051 r
.43942 .63338 m .4241 .62875 L .41744 .61706 L p F P
0 0 0 r
s
.83 .24 .1 r
.79476 .47606 m
.78553 .45797 L
s
.7518 .44478 m
.78553 .45797 L
s
.113 .157 .348 r
.66341 .51169 m .65118 .52271 L .64804 .50364 L p F P
0 0 0 r
s
.113 .157 .348 r
.64804 .50364 m .65998 .49268 L .66341 .51169 L p F P
0 0 0 r
s
.24 .35 .67 r
.64531 .49687 m
.64969 .52248 L
s
.83 .226 .093 r
.317 .55733 m .2977 .55129 L .29704 .53263 L p F P
0 0 0 r
s
.061 .089 .214 r
.29704 .53263 m .30586 .5218 L .30649 .54067 L p F P
0 0 0 r
s
.83 .24 .1 r
.30629 .53463 m
.31818 .53841 L
s
.27965 .52614 m
.29766 .53188 L
s
.061 .089 .214 r
.30649 .54067 m .2977 .55129 L .29704 .53263 L p F P
0 0 0 r
s
.83 .24 .1 r
.39742 .33542 m
.4349 .34977 L
s
.24 .35 .67 r
.33084 .68948 m
.35557 .70747 L
s
.35557 .70747 m
.37428 .6891 L
s
.83 .24 .1 r
.29372 .3475 m
.28123 .37326 L
s
.2421 .35916 m
.28123 .37326 L
s
.024 .035 .067 r
.56994 .64194 m .56186 .64891 L .56976 .64163 L p F P
0 0 0 r
s
.024 .035 .067 r
.56976 .64163 m .57894 .63371 L .56994 .64194 L p F P
0 0 0 r
s
.024 .036 .069 r
.61693 .59554 m .60639 .60468 L .61232 .58964 L p F P
0 0 0 r
s
.024 .036 .069 r
.61232 .58964 m .6235 .57985 L .61693 .59554 L p F P
0 0 0 r
s
.24 .35 .67 r
.60199 .58809 m
.62494 .56781 L
s
.209 .305 .622 r
.66696 .40212 m .65703 .41186 L .63608 .40063 L p F P
0 0 0 r
s
.209 .305 .622 r
.63608 .40063 m .64453 .39212 L .66696 .40212 L p F P
0 0 0 r
s
.24 .35 .67 r
.627 .39861 m
.64529 .42275 L
s
.882 .269 .117 r
.50882 .34824 m .50035 .34492 L .50024 .35514 L p F P
0 0 0 r
s
.882 .269 .117 r
.49454 .35293 m .50024 .35514 L .50035 .34492 L p F P
0 0 0 r
s
.041 .06 .137 r
.30989 .50274 m .31872 .49177 L .31484 .51077 L p F P
0 0 0 r
s
.041 .06 .137 r
.31484 .51077 m .30586 .5218 L .30989 .50274 L p F P
0 0 0 r
s
.144 .204 .437 r
.67215 .48152 m .65998 .49268 L .65278 .47417 L p F P
0 0 0 r
s
.144 .204 .437 r
.65278 .47417 m .66433 .46335 L .67215 .48152 L p F P
0 0 0 r
s
.305 .461 .857 r
.3939 .39993 m .40076 .39141 L .38535 .4013 L p F P
0 0 0 r
s
.305 .461 .857 r
.38535 .4013 m .37755 .41106 L .3939 .39993 L p F P
0 0 0 r
s
.83 .24 .1 r
.57327 .68005 m
.60893 .69076 L
s
.60893 .69076 m
.62512 .68938 L
s
.541 .178 .08 r
.64453 .39212 m .63195 .38715 L .60862 .38077 L p F P
0 0 0 r
s
.24 .35 .67 r
.627 .39861 m
.63595 .38953 L
s
.541 .178 .08 r
.59811 .37664 m .60862 .38077 L .63195 .38715 L p F P
0 0 0 r
s
.273 .421 .783 r
.54551 .65851 m .53891 .66424 L .54602 .66257 L p F P
0 0 0 r
s
.273 .421 .783 r
.54602 .66257 m .55389 .65578 L .54551 .65851 L p F P
0 0 0 r
s
.24 .35 .67 r
.54876 .65745 m
.56063 .64757 L
s
.169 .243 .509 r
.67609 .45233 m .66433 .46335 L .65271 .44636 L p F P
0 0 0 r
s
.169 .243 .509 r
.65271 .44636 m .66353 .43599 L .67609 .45233 L p F P
0 0 0 r
s
.24 .35 .67 r
.63592 .47093 m
.65961 .44838 L
s
.19 .276 .57 r
.67453 .42545 m .66353 .43599 L .64726 .42146 L p F P
0 0 0 r
s
.19 .276 .57 r
.64726 .42146 m .65703 .41186 L .67453 .42545 L p F P
0 0 0 r
s
.24 .35 .67 r
.64529 .42275 m
.65961 .44838 L
s
.024 .035 .067 r
.32689 .47328 m .33554 .46244 L .32772 .48059 L p F P
0 0 0 r
s
.24 .35 .67 r
.32673 .47364 m
.3269 .47342 L
s
.33539 .4628 m
.34129 .45541 L
s
.024 .035 .067 r
.32772 .48059 m .31872 .49177 L .32689 .47328 L p F P
0 0 0 r
s
.24 .35 .67 r
.30936 .66741 m
.32723 .64825 L
s
.30936 .66741 m
.33084 .68948 L
s
.29096 .56878 m
.29745 .5959 L
s
.83 .24 .1 r
.71334 .70319 m
.74754 .71367 L
s
.76652 .70035 m
.74754 .71367 L
s
.748 .235 .103 r
.5769 .36829 m .56619 .36407 L .55051 .36456 L p F P
0 0 0 r
s
.748 .235 .103 r
.54226 .36133 m .55051 .36456 L .56619 .36407 L p F P
0 0 0 r
s
.24 .35 .67 r
.47599 .69373 m
.50065 .68986 L
s
.50065 .68986 m
.52212 .67112 L
s
.266 .404 .736 r
.36986 .42067 m .37755 .41106 L .36389 .42456 L p F P
0 0 0 r
s
.24 .35 .67 r
.37514 .41644 m
.39454 .40557 L
s
.266 .404 .736 r
.36389 .42456 m .35547 .43512 L .36986 .42067 L p F P
0 0 0 r
s
.24 .35 .67 r
.35664 .43953 m
.37514 .41644 L
s
.024 .035 .067 r
.34719 .44551 m .35547 .43512 L .34436 .45141 L p F P
0 0 0 r
s
.024 .035 .067 r
.34436 .45141 m .33554 .46244 L .34719 .44551 L p F P
0 0 0 r
s
.882 .269 .117 r
.50035 .34492 m .49185 .34159 L .49454 .35293 L p F P
0 0 0 r
s
.882 .269 .117 r
.48883 .35071 m .49454 .35293 L .49185 .34159 L p F P
0 0 0 r
s
.83 .24 .1 r
.48626 .35113 m
.5226 .36523 L
s
.272 .062 .026 r
.49946 .65761 m .51249 .66153 L .51056 .66335 L p F P
0 0 0 r
s
.272 .062 .026 r
.5215 .66664 m .51056 .66335 L .51249 .66153 L p F P
0 0 0 r
s
.83 .24 .1 r
.51312 .6542 m
.52369 .66456 L
s
.24 .35 .67 r
.33084 .68948 m
.34913 .67073 L
s
.316 .473 .911 r
.47986 .35233 m .4831 .34848 L .47471 .33488 L p F P
0 0 0 r
s
.24 .35 .67 r
.48157 .35198 m
.4912 .35395 L
s
.83 .24 .1 r
.48083 .35583 m
.48626 .35113 L
s
.316 .473 .911 r
.47471 .33488 m .4699 .3407 L .47986 .35233 L p F P
0 0 0 r
s
.24 .35 .67 r
.46118 .37619 m
.48157 .35198 L
s
.322 .484 .924 r
.45109 .36347 m .45573 .35785 L .4419 .35525 L p F P
0 0 0 r
s
.322 .484 .924 r
.4419 .35525 m .43589 .36264 L .45109 .36347 L p F P
0 0 0 r
s
.024 .035 .067 r
.59772 .6175 m .58826 .62567 L .59602 .61367 L p F P
0 0 0 r
s
.024 .035 .067 r
.59602 .61367 m .60639 .60468 L .59772 .6175 L p F P
0 0 0 r
s
.67 .175 .071 r
.34058 .58056 m .35894 .58623 L .3664 .60149 L p F P
0 0 0 r
s
.67 .175 .071 r
.38358 .60673 m .3664 .60149 L .35894 .58623 L p F P
0 0 0 r
s
.386 .087 .036 r
.43942 .63338 m .45461 .63797 L .45977 .64568 L p F P
0 0 0 r
s
.386 .087 .036 r
.4731 .64969 m .45977 .64568 L .45461 .63797 L p F P
0 0 0 r
s
.765 .205 .084 r
.2977 .55129 m .317 .55733 L .32204 .57484 L p F P
0 0 0 r
s
.765 .205 .084 r
.34058 .58056 m .32204 .57484 L .317 .55733 L p F P
0 0 0 r
s
.83 .24 .1 r
.31743 .56189 m
.31818 .53841 L
s
.31743 .56189 m
.35566 .57381 L
s
.882 .269 .117 r
.49185 .34159 m .4833 .33825 L .48883 .35071 L p F P
0 0 0 r
s
.882 .269 .117 r
.4831 .34848 m .48883 .35071 L .4833 .33825 L p F P
0 0 0 r
s
.321 .483 .913 r
.42407 .37715 m .42995 .36993 L .41476 .37403 L p F P
0 0 0 r
s
.321 .483 .913 r
.41476 .37403 m .40771 .38278 L .42407 .37715 L p F P
0 0 0 r
s
.24 .35 .67 r
.41383 .38174 m
.43645 .3763 L
s
.83 .24 .1 r
.71735 .4313 m
.70596 .41908 L
s
.541 .178 .08 r
.63195 .38715 m .61926 .38215 L .59811 .37664 L p F P
0 0 0 r
s
.83 .24 .1 r
.61259 .38608 m
.62297 .38573 L
s
.541 .178 .08 r
.58754 .37248 m .59811 .37664 L .61926 .38215 L p F P
0 0 0 r
s
.748 .235 .103 r
.56619 .36407 m .55541 .35983 L .54226 .36133 L p F P
0 0 0 r
s
.748 .235 .103 r
.53396 .35808 m .54226 .36133 L .55541 .35983 L p F P
0 0 0 r
s
.24 .35 .67 r
.54173 .35872 m
.55561 .34314 L
s
.83 .24 .1 r
.82818 .48898 m
.83415 .51203 L
s
.79476 .47606 m
.82818 .48898 L
s
.528 .131 .051 r
.38358 .60673 m .40059 .61192 L .40864 .62408 L p F P
0 0 0 r
s
.528 .131 .051 r
.4241 .62875 m .40864 .62408 L .40059 .61192 L p F P
0 0 0 r
s
.24 .35 .67 r
.55561 .34314 m
.57817 .31784 L
s
.55561 .34314 m
.52908 .33257 L
s
.83 .24 .1 r
.47987 .34865 m
.48626 .35113 L
s
.24 .35 .67 r
.40133 .70243 m
.42888 .71013 L
s
.42888 .71013 m
.44907 .69171 L
s
.83 .24 .1 r
.24029 .51361 m
.27965 .52614 L
s
.27965 .52614 m
.27838 .54971 L
s
.882 .269 .117 r
.4833 .33825 m .47471 .33488 L .4831 .34848 L p F P
0 0 0 r
s
.24 .35 .67 r
.48157 .35198 m
.48519 .34768 L
s
.83 .24 .1 r
.2048 .47422 m
.24456 .48718 L
s
.24456 .48718 m
.24029 .51361 L
s
.272 .062 .026 r
.48633 .65367 m .49946 .65761 L .49954 .66005 L p F P
0 0 0 r
s
.272 .062 .026 r
.51056 .66335 m .49954 .66005 L .49946 .65761 L p F P
0 0 0 r
s
.83 .24 .1 r
.23062 .3873 m
.22036 .41649 L
s
.18033 .40277 m
.22036 .41649 L
s
.22036 .41649 m
.21165 .44579 L
s
.2421 .35916 m
.23062 .3873 L
s
.19069 .37325 m
.23062 .3873 L
s
.748 .235 .103 r
.55541 .35983 m .54456 .35556 L .53396 .35808 L p F P
0 0 0 r
s
.83 .24 .1 r
.5226 .36523 m
.53719 .35827 L
s
.748 .235 .103 r
.52562 .35482 m .53396 .35808 L .54456 .35556 L p F P
0 0 0 r
s
.322 .484 .924 r
.45573 .35785 m .46041 .35218 L .44798 .34779 L p F P
0 0 0 r
s
.322 .484 .924 r
.44798 .34779 m .4419 .35525 L .45573 .35785 L p F P
0 0 0 r
s
.254 .059 .024 r
.63195 .38715 m .64453 .39212 L .66696 .40212 L p F P
0 0 0 r
s
.83 .24 .1 r
.62297 .38573 m
.63641 .39102 L
s
.24 .35 .67 r
.63651 .38896 m
.63671 .38876 L
s
.83 .24 .1 r
.62512 .68938 m
.66045 .70007 L
s
.66045 .70007 m
.6784 .69249 L
s
.541 .178 .08 r
.61926 .38215 m .60648 .37711 L .58754 .37248 L p F P
0 0 0 r
s
.541 .178 .08 r
.5769 .36829 m .58754 .37248 L .60648 .37711 L p F P
0 0 0 r
s
.305 .461 .857 r
.40076 .39141 m .40771 .38278 L .39327 .3914 L p F P
0 0 0 r
s
.305 .461 .857 r
.39327 .3914 m .38535 .4013 L .40076 .39141 L p F P
0 0 0 r
s
.24 .35 .67 r
.39454 .40557 m
.41383 .38174 L
s
.83 .24 .1 r
.30679 .32471 m
.29372 .3475 L
s
.25443 .33302 m
.29372 .3475 L
s
.024 .035 .067 r
.57813 .63487 m .56994 .64194 L .57894 .63371 L p F P
0 0 0 r
s
.024 .035 .067 r
.57894 .63371 m .58826 .62567 L .57813 .63487 L p F P
0 0 0 r
s
.24 .35 .67 r
.56063 .64757 m
.58302 .62821 L
s
.58302 .62821 m
.59515 .60977 L
s
.83 .24 .1 r
.35912 .32076 m
.34553 .33929 L
s
.30679 .32471 m
.34553 .33929 L
s
.273 .421 .783 r
.55219 .65272 m .54551 .65851 L .55389 .65578 L p F P
0 0 0 r
s
.273 .421 .783 r
.55389 .65578 m .56186 .64891 L .55219 .65272 L p F P
0 0 0 r
s
.386 .087 .036 r
.4241 .62875 m .43942 .63338 L .44633 .64165 L p F P
0 0 0 r
s
.83 .24 .1 r
.43339 .61668 m
.44001 .63207 L
s
.386 .087 .036 r
.45977 .64568 m .44633 .64165 L .43942 .63338 L p F P
0 0 0 r
s
.83 .24 .1 r
.44001 .63207 m
.47695 .64326 L
s
.047 .067 .154 r
.64648 .55974 m .63489 .56989 L .63873 .55216 L p F P
0 0 0 r
s
.047 .067 .154 r
.63873 .55216 m .65069 .54156 L .64648 .55974 L p F P
0 0 0 r
s
.24 .35 .67 r
.62616 .5437 m
.64969 .52248 L
s
.079 .107 .249 r
.66287 .53076 m .65069 .54156 L .65118 .52271 L p F P
0 0 0 r
s
.079 .107 .249 r
.65118 .52271 m .66341 .51169 L .66287 .53076 L p F P
0 0 0 r
s
.67 .175 .071 r
.32204 .57484 m .34058 .58056 L .34906 .5962 L p F P
0 0 0 r
s
.67 .175 .071 r
.3664 .60149 m .34906 .5962 L .34058 .58056 L p F P
0 0 0 r
s
.83 .24 .1 r
.35566 .57381 m
.35825 .59364 L
s
.19 .276 .57 r
.68572 .41472 m .67453 .42545 L .65703 .41186 L p F P
0 0 0 r
s
.19 .276 .57 r
.65703 .41186 m .66696 .40212 L .68572 .41472 L p F P
0 0 0 r
s
.83 .24 .1 r
.67278 .40602 m
.70596 .41908 L
s
.113 .157 .348 r
.67587 .50047 m .66341 .51169 L .65998 .49268 L p F P
0 0 0 r
s
.113 .157 .348 r
.65998 .49268 m .67215 .48152 L .67587 .50047 L p F P
0 0 0 r
s
.765 .205 .084 r
.32204 .57484 m .3033 .56905 L .2977 .55129 L p F P
0 0 0 r
s
.098 .139 .32 r
.2977 .55129 m .30649 .54067 L .3119 .55889 L p F P
0 0 0 r
s
.098 .139 .32 r
.3119 .55889 m .3033 .56905 L .2977 .55129 L p F P
0 0 0 r
s
.83 .24 .1 r
.31104 .5599 m
.31743 .56189 L
s
.29886 .5561 m
.29996 .55645 L
s
.27838 .54971 m
.29886 .5561 L
s
.24 .35 .67 r
.29096 .56878 m
.29986 .55813 L
s
.024 .036 .069 r
.62765 .58624 m .61693 .59554 L .6235 .57985 L p F P
0 0 0 r
s
.024 .036 .069 r
.6235 .57985 m .63489 .56989 L .62765 .58624 L p F P
0 0 0 r
s
.24 .35 .67 r
.61828 .58962 m
.62494 .56781 L
s
.748 .235 .103 r
.54456 .35556 m .53364 .35127 L .52562 .35482 L p F P
0 0 0 r
s
.748 .235 .103 r
.51724 .35153 m .52562 .35482 L .53364 .35127 L p F P
0 0 0 r
s
.061 .089 .214 r
.30586 .5218 m .31484 .51077 L .31545 .52985 L p F P
0 0 0 r
s
.24 .35 .67 r
.30593 .52384 m
.30689 .52267 L
s
.061 .089 .214 r
.31545 .52985 m .30649 .54067 L .30586 .5218 L p F P
0 0 0 r
s
.528 .131 .051 r
.3664 .60149 m .38358 .60673 L .39305 .61936 L p F P
0 0 0 r
s
.83 .24 .1 r
.35825 .59364 m
.39622 .60528 L
s
.528 .131 .051 r
.40864 .62408 m .39305 .61936 L .38358 .60673 L p F P
0 0 0 r
s
.321 .483 .913 r
.42995 .36993 m .43589 .36264 L .4219 .36516 L p F P
0 0 0 r
s
.321 .483 .913 r
.4219 .36516 m .41476 .37403 L .42995 .36993 L p F P
0 0 0 r
s
.83 .24 .1 r
.17139 .43234 m
.21165 .44579 L
s
.21165 .44579 m
.2048 .47422 L
s
.144 .204 .437 r
.68455 .47015 m .67215 .48152 L .66433 .46335 L p F P
0 0 0 r
s
.24 .35 .67 r
.64531 .49687 m
.66938 .47461 L
s
.144 .204 .437 r
.66433 .46335 m .67609 .45233 L .68455 .47015 L p F P
0 0 0 r
s
.266 .404 .736 r
.37755 .41106 m .38535 .4013 L .37245 .41382 L p F P
0 0 0 r
s
.266 .404 .736 r
.37245 .41382 m .36389 .42456 L .37755 .41106 L p F P
0 0 0 r
s
.169 .243 .509 r
.68806 .44112 m .67609 .45233 L .66353 .43599 L p F P
0 0 0 r
s
.24 .35 .67 r
.65961 .44838 m
.66938 .47461 L
s
.169 .243 .509 r
.66353 .43599 m .67453 .42545 L .68806 .44112 L p F P
0 0 0 r
s
.041 .06 .137 r
.31872 .49177 m .32772 .48059 L .32399 .49953 L p F P
0 0 0 r
s
.041 .06 .137 r
.32399 .49953 m .31484 .51077 L .31872 .49177 L p F P
0 0 0 r
s
.272 .062 .026 r
.4731 .64969 m .48633 .65367 L .48846 .65673 L p F P
0 0 0 r
s
.272 .062 .026 r
.49954 .66005 m .48846 .65673 L .48633 .65367 L p F P
0 0 0 r
s
.024 .035 .067 r
.33554 .46244 m .34436 .45141 L .33688 .46919 L p F P
0 0 0 r
s
.024 .035 .067 r
.33688 .46919 m .32772 .48059 L .33554 .46244 L p F P
0 0 0 r
s
.83 .24 .1 r
.7606 .46286 m
.7518 .44478 L
s
.71735 .4313 m
.7518 .44478 L
s
.024 .035 .067 r
.35547 .43512 m .36389 .42456 L .35333 .44018 L p F P
0 0 0 r
s
.024 .035 .067 r
.35333 .44018 m .34436 .45141 L .35547 .43512 L p F P
0 0 0 r
s
.24 .35 .67 r
.29745 .5959 m
.30972 .62287 L
s
.83 .24 .1 r
.41122 .322 m
.39742 .33542 L
s
.35912 .32076 m
.39742 .33542 L
s
.541 .178 .08 r
.60648 .37711 m .5936 .37203 L .5769 .36829 L p F P
0 0 0 r
s
.24 .35 .67 r
.60551 .37673 m
.62876 .35232 L
s
.541 .178 .08 r
.56619 .36407 m .5769 .36829 L .5936 .37203 L p F P
0 0 0 r
s
.83 .24 .1 r
.53719 .35827 m
.57322 .37239 L
s
.25443 .33302 m
.2421 .35916 L
s
.20212 .34475 m
.2421 .35916 L
s
.254 .059 .024 r
.66696 .40212 m .65251 .39642 L .63195 .38715 L p F P
0 0 0 r
s
.254 .059 .024 r
.61926 .38215 m .63195 .38715 L .65251 .39642 L p F P
0 0 0 r
s
.322 .484 .924 r
.46041 .35218 m .46514 .34646 L .45413 .34025 L p F P
0 0 0 r
s
.322 .484 .924 r
.45413 .34025 m .44798 .34779 L .46041 .35218 L p F P
0 0 0 r
s
.24 .35 .67 r
.45662 .3518 m
.48157 .35198 L
s
.83 .24 .1 r
.4349 .34977 m
.44915 .33672 L
s
.024 .035 .067 r
.60733 .60921 m .59772 .6175 L .60639 .60468 L p F P
0 0 0 r
s
.024 .035 .067 r
.60639 .60468 m .61693 .59554 L .60733 .60921 L p F P
0 0 0 r
s
.24 .35 .67 r
.59515 .60977 m
.61828 .58962 L
s
.748 .235 .103 r
.53364 .35127 m .52265 .34694 L .51724 .35153 L p F P
0 0 0 r
s
.748 .235 .103 r
.50882 .34824 m .51724 .35153 L .52265 .34694 L p F P
0 0 0 r
s
.24 .35 .67 r
.51611 .34755 m
.52908 .33257 L
s
.83 .24 .1 r
.57327 .68005 m
.58901 .67847 L
s
.386 .087 .036 r
.40864 .62408 m .4241 .62875 L .43279 .63758 L p F P
0 0 0 r
s
.386 .087 .036 r
.44633 .64165 m .43279 .63758 L .4241 .62875 L p F P
0 0 0 r
s
.83 .24 .1 r
.6784 .69249 m
.71334 .70319 L
s
.71334 .70319 m
.73206 .68959 L
s
.24 .35 .67 r
.52908 .33257 m
.55131 .30686 L
s
.52908 .33257 m
.50272 .32686 L
s
.301 .46 .871 r
.53058 .66188 m .52548 .66634 L .53238 .6699 L p F P
0 0 0 r
s
.83 .24 .1 r
.52369 .66456 m
.52644 .66551 L
s
.301 .46 .871 r
.53238 .6699 m .53891 .66424 L .53058 .66188 L p F P
0 0 0 r
s
.83 .24 .1 r
.53303 .66778 m
.53361 .66798 L
s
.24 .35 .67 r
.53834 .66407 m
.53986 .66341 L
s
.83 .24 .1 r
.53684 .6691 m
.57327 .68005 L
s
.53361 .66798 m
.53684 .6691 L
s
.518 .171 .076 r
.5215 .66664 m .53238 .6699 L .52548 .66634 L p F P
0 0 0 r
s
.24 .35 .67 r
.52736 .66884 m
.5283 .66843 L
s
.52212 .67112 m
.52736 .66884 L
s
.37428 .6891 m
.40133 .70243 L
s
.40133 .70243 m
.42116 .68372 L
s
.67 .175 .071 r
.3033 .56905 m .32204 .57484 L .33155 .59086 L p F P
0 0 0 r
s
.67 .175 .071 r
.34906 .5962 m .33155 .59086 L .32204 .57484 L p F P
0 0 0 r
s
.272 .062 .026 r
.45977 .64568 m .4731 .64969 L .4773 .65338 L p F P
0 0 0 r
s
.272 .062 .026 r
.48846 .65673 m .4773 .65338 L .4731 .64969 L p F P
0 0 0 r
s
.83 .24 .1 r
.47695 .64326 m
.48699 .65352 L
s
.48699 .65352 m
.52369 .66456 L
s
.541 .178 .08 r
.5936 .37203 m .58062 .36691 L .56619 .36407 L p F P
0 0 0 r
s
.83 .24 .1 r
.57322 .37239 m
.58721 .37165 L
s
.541 .178 .08 r
.55541 .35983 m .56619 .36407 L .58062 .36691 L p F P
0 0 0 r
s
.24 .35 .67 r
.44907 .69171 m
.47599 .69373 L
s
.47599 .69373 m
.49725 .67484 L
s
.748 .235 .103 r
.52265 .34694 m .51159 .34259 L .50882 .34824 L p F P
0 0 0 r
s
.748 .235 .103 r
.50035 .34492 m .50882 .34824 L .51159 .34259 L p F P
0 0 0 r
s
.305 .461 .857 r
.40771 .38278 m .41476 .37403 L .40132 .38134 L p F P
0 0 0 r
s
.305 .461 .857 r
.40132 .38134 m .39327 .3914 L .40771 .38278 L p F P
0 0 0 r
s
.528 .131 .051 r
.34906 .5962 m .3664 .60149 L .37732 .61461 L p F P
0 0 0 r
s
.528 .131 .051 r
.39305 .61936 m .37732 .61461 L .3664 .60149 L p F P
0 0 0 r
s
.273 .421 .783 r
.55895 .64687 m .55219 .65272 L .56186 .64891 L p F P
0 0 0 r
s
.273 .421 .783 r
.56186 .64891 m .56994 .64194 L .55895 .64687 L p F P
0 0 0 r
s
.254 .059 .024 r
.65251 .39642 m .63793 .39068 L .61926 .38215 L p F P
0 0 0 r
s
.254 .059 .024 r
.60648 .37711 m .61926 .38215 L .63793 .39068 L p F P
0 0 0 r
s
.24 .35 .67 r
.63671 .38876 m
.65073 .37452 L
s
.321 .483 .913 r
.43589 .36264 m .4419 .35525 L .42913 .35618 L p F P
0 0 0 r
s
.24 .35 .67 r
.43645 .3763 m
.45662 .3518 L
s
.321 .483 .913 r
.42913 .35618 m .4219 .36516 L .43589 .36264 L p F P
0 0 0 r
s
.83 .24 .1 r
.80034 .49919 m
.79476 .47606 L
s
.7606 .46286 m
.79476 .47606 L
s
.024 .035 .067 r
.58642 .62771 m .57813 .63487 L .58826 .62567 L p F P
0 0 0 r
s
.024 .035 .067 r
.58826 .62567 m .59772 .6175 L .58642 .62771 L p F P
0 0 0 r
s
.83 .24 .1 r
.73206 .68959 m
.76652 .70035 L
s
.78489 .68126 m
.76652 .70035 L
s
.322 .484 .924 r
.46514 .34646 m .4699 .3407 L .46034 .33261 L p F P
0 0 0 r
s
.322 .484 .924 r
.46034 .33261 m .45413 .34025 L .46514 .34646 L p F P
0 0 0 r
s
.83 .24 .1 r
.44915 .33672 m
.45512 .33903 L
s
.41122 .322 m
.44915 .33672 L
s
.24 .35 .67 r
.65073 .37452 m
.62876 .35232 L
s
.62876 .35232 m
.65295 .32691 L
s
.62876 .35232 m
.60429 .33319 L
s
.518 .171 .076 r
.51056 .66335 m .5215 .66664 L .51691 .66377 L p F P
0 0 0 r
s
.518 .171 .076 r
.52548 .66634 m .51691 .66377 L .5215 .66664 L p F P
0 0 0 r
s
.83 .24 .1 r
.20007 .50081 m
.24029 .51361 L
s
.24029 .51361 m
.23848 .53727 L
s
.24 .35 .67 r
.65073 .37452 m
.67536 .34952 L
s
.748 .235 .103 r
.51159 .34259 m .50046 .33821 L .50035 .34492 L p F P
0 0 0 r
s
.748 .235 .103 r
.49185 .34159 m .50035 .34492 L .50046 .33821 L p F P
0 0 0 r
s
.83 .24 .1 r
.48626 .35113 m
.50039 .34385 L
s
.378 .084 .035 r
.65251 .39642 m .66696 .40212 L .68572 .41472 L p F P
0 0 0 r
s
.24 .35 .67 r
.65073 .37452 m
.66944 .39903 L
s
.66644 .40197 m
.66944 .39903 L
s
.66632 .40209 m
.66644 .40197 L
s
.64529 .42275 m
.66506 .40333 L
s
.83 .24 .1 r
.16417 .46098 m
.2048 .47422 L
s
.2048 .47422 m
.20007 .50081 L
s
.386 .087 .036 r
.39305 .61936 m .40864 .62408 L .41915 .63348 L p F P
0 0 0 r
s
.83 .24 .1 r
.39622 .60528 m
.40228 .62065 L
s
.386 .087 .036 r
.43279 .63758 m .41915 .63348 L .40864 .62408 L p F P
0 0 0 r
s
.83 .24 .1 r
.40228 .62065 m
.44001 .63207 L
s
.24 .35 .67 r
.30972 .62287 m
.32723 .64825 L
s
.83 .24 .1 r
.19069 .37325 m
.18033 .40277 L
s
.18033 .40277 m
.17139 .43234 L
s
.541 .178 .08 r
.58062 .36691 m .56754 .36175 L .55541 .35983 L p F P
0 0 0 r
s
.541 .178 .08 r
.54456 .35556 m .55541 .35983 L .56754 .36175 L p F P
0 0 0 r
s
.266 .404 .736 r
.38535 .4013 m .39327 .3914 L .38117 .4029 L p F P
0 0 0 r
s
.266 .404 .736 r
.38117 .4029 m .37245 .41382 L .38535 .4013 L p F P
0 0 0 r
s
.83 .24 .1 r
.20212 .34475 m
.19069 .37325 L
s
.83415 .51203 m
.80034 .49919 L
s
.83415 .51203 m
.83598 .53904 L
s
.272 .062 .026 r
.44633 .64165 m .45977 .64568 L .46607 .65002 L p F P
0 0 0 r
s
.272 .062 .026 r
.4773 .65338 m .46607 .65002 L .45977 .64568 L p F P
0 0 0 r
s
.047 .067 .154 r
.65828 .54941 m .64648 .55974 L .65069 .54156 L p F P
0 0 0 r
s
.24 .35 .67 r
.64874 .54677 m
.64969 .52248 L
s
.047 .067 .154 r
.65069 .54156 m .66287 .53076 L .65828 .54941 L p F P
0 0 0 r
s
.079 .107 .249 r
.67529 .51975 m .66287 .53076 L .66341 .51169 L p F P
0 0 0 r
s
.079 .107 .249 r
.66341 .51169 m .67587 .50047 L .67529 .51975 L p F P
0 0 0 r
s
.024 .036 .069 r
.63855 .57679 m .62765 .58624 L .63489 .56989 L p F P
0 0 0 r
s
.024 .036 .069 r
.63489 .56989 m .64648 .55974 L .63855 .57679 L p F P
0 0 0 r
s
.24 .35 .67 r
.62494 .56781 m
.64874 .54677 L
s
.169 .243 .509 r
.70025 .4297 m .68806 .44112 L .67453 .42545 L p F P
0 0 0 r
s
.169 .243 .509 r
.67453 .42545 m .68572 .41472 L .70025 .4297 L p F P
0 0 0 r
s
.83 .24 .1 r
.58901 .67847 m
.62512 .68938 L
s
.62512 .68938 m
.64269 .68155 L
s
.24 .35 .67 r
.60429 .33319 m
.62808 .30736 L
s
.60429 .33319 m
.57817 .31784 L
s
.301 .46 .871 r
.53573 .65738 m .53058 .66188 L .53891 .66424 L p F P
0 0 0 r
s
.301 .46 .871 r
.53891 .66424 m .54551 .65851 L .53573 .65738 L p F P
0 0 0 r
s
.83 .24 .1 r
.26721 .30982 m
.25443 .33302 L
s
.21428 .31822 m
.25443 .33302 L
s
.113 .157 .348 r
.68857 .48903 m .67587 .50047 L .67215 .48152 L p F P
0 0 0 r
s
.113 .157 .348 r
.67215 .48152 m .68455 .47015 L .68857 .48903 L p F P
0 0 0 r
s
.24 .35 .67 r
.66938 .47461 m
.67411 .50047 L
s
.098 .139 .32 r
.30649 .54067 m .31545 .52985 L .32065 .54855 L p F P
0 0 0 r
s
.098 .139 .32 r
.32065 .54855 m .3119 .55889 L .30649 .54067 L p F P
0 0 0 r
s
.83 .24 .1 r
.32 .30578 m
.30679 .32471 L
s
.26721 .30982 m
.30679 .32471 L
s
.24 .35 .67 r
.34913 .67073 m
.37428 .6891 L
s
.37428 .6891 m
.3937 .67003 L
s
.254 .059 .024 r
.63793 .39068 m .62322 .38488 L .60648 .37711 L p F P
0 0 0 r
s
.254 .059 .024 r
.5936 .37203 m .60648 .37711 L .62322 .38488 L p F P
0 0 0 r
s
.83 .24 .1 r
.58721 .37165 m
.62297 .38573 L
s
.144 .204 .437 r
.69718 .45856 m .68455 .47015 L .67609 .45233 L p F P
0 0 0 r
s
.144 .204 .437 r
.67609 .45233 m .68806 .44112 L .69718 .45856 L p F P
0 0 0 r
s
.24 .35 .67 r
.65961 .44838 m
.68419 .42499 L
s
.061 .089 .214 r
.31484 .51077 m .32399 .49953 L .32457 .51883 L p F P
0 0 0 r
s
.24 .35 .67 r
.31491 .51283 m
.31588 .51163 L
s
.32405 .50162 m
.32575 .49953 L
s
.061 .089 .214 r
.32457 .51883 m .31545 .52985 L .31484 .51077 L p F P
0 0 0 r
s
.83 .24 .1 r
.23848 .53727 m
.27838 .54971 L
s
.27838 .54971 m
.27981 .5696 L
s
.67 .175 .071 r
.33155 .59086 m .31387 .58547 L .3033 .56905 L p F P
0 0 0 r
s
.136 .196 .427 r
.3033 .56905 m .3119 .55889 L .32209 .576 L p F P
0 0 0 r
s
.83 .24 .1 r
.31743 .56189 m
.3182 .56947 L
s
.136 .196 .427 r
.32209 .576 m .31387 .58547 L .3033 .56905 L p F P
0 0 0 r
s
.83 .24 .1 r
.3192 .57932 m
.31945 .58175 L
s
.24 .35 .67 r
.29745 .5959 m
.31069 .58054 L
s
.024 .035 .067 r
.36389 .42456 m .37245 .41382 L .36247 .42874 L p F P
0 0 0 r
s
.024 .035 .067 r
.36247 .42874 m .35333 .44018 L .36389 .42456 L p F P
0 0 0 r
s
.24 .35 .67 r
.35977 .43229 m
.37514 .41644 L
s
.748 .235 .103 r
.50046 .33821 m .48926 .3338 L .49185 .34159 L p F P
0 0 0 r
s
.24 .35 .67 r
.49069 .34114 m
.49141 .34029 L
s
.49498 .33605 m
.50272 .32686 L
s
.748 .235 .103 r
.4833 .33825 m .49185 .34159 L .48926 .3338 L p F P
0 0 0 r
s
.528 .131 .051 r
.33155 .59086 m .34906 .5962 L .36145 .60981 L p F P
0 0 0 r
s
.83 .24 .1 r
.31945 .58175 m
.35825 .59364 L
s
.528 .131 .051 r
.37732 .61461 m .36145 .60981 L .34906 .5962 L p F P
0 0 0 r
s
.041 .06 .137 r
.32772 .48059 m .33688 .46919 L .33332 .48807 L p F P
0 0 0 r
s
.041 .06 .137 r
.33332 .48807 m .32399 .49953 L .32772 .48059 L p F P
0 0 0 r
s
.24 .35 .67 r
.32575 .49953 m
.32637 .49661 L
s
.518 .171 .076 r
.49954 .66005 m .51056 .66335 L .5083 .66119 L p F P
0 0 0 r
s
.518 .171 .076 r
.51691 .66377 m .5083 .66119 L .51056 .66335 L p F P
0 0 0 r
s
.024 .035 .067 r
.34436 .45141 m .35333 .44018 L .34622 .45759 L p F P
0 0 0 r
s
.24 .35 .67 r
.34421 .45176 m
.34439 .45153 L
s
.35319 .44052 m
.35977 .43229 L
s
.024 .035 .067 r
.34622 .45759 m .33688 .46919 L .34436 .45141 L p F P
0 0 0 r
s
.024 .035 .067 r
.61708 .60079 m .60733 .60921 L .61693 .59554 L p F P
0 0 0 r
s
.024 .035 .067 r
.61693 .59554 m .62765 .58624 L .61708 .60079 L p F P
0 0 0 r
s
.322 .484 .924 r
.4699 .3407 m .47471 .33488 L .46663 .3249 L p F P
0 0 0 r
s
.322 .484 .924 r
.46663 .3249 m .46034 .33261 L .4699 .3407 L p F P
0 0 0 r
s
.541 .178 .08 r
.56754 .36175 m .55435 .35655 L .54456 .35556 L p F P
0 0 0 r
s
.83 .24 .1 r
.53719 .35827 m
.55068 .35727 L
s
.541 .178 .08 r
.53364 .35127 m .54456 .35556 L .55435 .35655 L p F P
0 0 0 r
s
.83 .24 .1 r
.50039 .34385 m
.53719 .35827 L
s
.24 .35 .67 r
.32723 .64825 m
.34579 .62837 L
s
.32723 .64825 m
.34913 .67073 L
s
.83 .24 .1 r
.17139 .43234 m
.16417 .46098 L
s
.321 .483 .913 r
.4419 .35525 m .44798 .34779 L .43647 .34707 L p F P
0 0 0 r
s
.321 .483 .913 r
.43647 .34707 m .42913 .35618 L .4419 .35525 L p F P
0 0 0 r
s
.24 .35 .67 r
.43384 .35701 m
.45662 .3518 L
s
.49725 .67484 m
.52212 .67112 L
s
.52212 .67112 m
.52652 .66727 L
s
.34913 .67073 m
.36812 .65126 L
s
.305 .461 .857 r
.41476 .37403 m .4219 .36516 L .40949 .37112 L p F P
0 0 0 r
s
.305 .461 .857 r
.40949 .37112 m .40132 .38134 L .41476 .37403 L p F P
0 0 0 r
s
.378 .084 .035 r
.68572 .41472 m .66973 .40845 L .65251 .39642 L p F P
0 0 0 r
s
.24 .35 .67 r
.67624 .411 m
.68419 .42499 L
s
.378 .084 .035 r
.63793 .39068 m .65251 .39642 L .66973 .40845 L p F P
0 0 0 r
s
.24 .35 .67 r
.66944 .39903 m
.67425 .40749 L
s
.386 .087 .036 r
.37732 .61461 m .39305 .61936 L .40539 .62934 L p F P
0 0 0 r
s
.386 .087 .036 r
.41915 .63348 m .40539 .62934 L .39305 .61936 L p F P
0 0 0 r
s
.273 .421 .783 r
.56578 .64095 m .55895 .64687 L .56994 .64194 L p F P
0 0 0 r
s
.273 .421 .783 r
.56994 .64194 m .57813 .63487 L .56578 .64095 L p F P
0 0 0 r
s
.24 .35 .67 r
.5705 .63863 m
.58302 .62821 L
s
.83 .24 .1 r
.7257 .44937 m
.71735 .4313 L
s
.37246 .30695 m
.35912 .32076 L
s
.32 .30578 m
.35912 .32076 L
s
.272 .062 .026 r
.43279 .63758 m .44633 .64165 L .45477 .64663 L p F P
0 0 0 r
s
.272 .062 .026 r
.46607 .65002 m .45477 .64663 L .44633 .64165 L p F P
0 0 0 r
s
.83 .24 .1 r
.21428 .31822 m
.20212 .34475 L
s
.748 .235 .103 r
.48926 .3338 m .47798 .32936 L .4833 .33825 L p F P
0 0 0 r
s
.748 .235 .103 r
.47471 .33488 m .4833 .33825 L .47798 .32936 L p F P
0 0 0 r
s
.83 .24 .1 r
.46277 .32911 m
.4631 .32923 L
s
.518 .171 .076 r
.48846 .65673 m .49954 .66005 L .49964 .65859 L p F P
0 0 0 r
s
.518 .171 .076 r
.5083 .66119 m .49964 .65859 L .49954 .66005 L p F P
0 0 0 r
s
.254 .059 .024 r
.62322 .38488 m .60838 .37904 L .5936 .37203 L p F P
0 0 0 r
s
.254 .059 .024 r
.58062 .36691 m .5936 .37203 L .60838 .37904 L p F P
0 0 0 r
s
.83 .24 .1 r
.52942 .66687 m
.53684 .6691 L
s
.53684 .6691 m
.55211 .66731 L
s
.024 .035 .067 r
.59484 .62046 m .58642 .62771 L .59772 .6175 L p F P
0 0 0 r
s
.024 .035 .067 r
.59772 .6175 m .60733 .60921 L .59484 .62046 L p F P
0 0 0 r
s
.24 .35 .67 r
.50272 .32686 m
.52469 .30077 L
s
.83 .24 .1 r
.64269 .68155 m
.6784 .69249 L
s
.6784 .69249 m
.69684 .67858 L
s
.27981 .5696 m
.3106 .57904 L
s
.31759 .58118 m
.31945 .58175 L
s
.541 .178 .08 r
.55435 .35655 m .54106 .35131 L .53364 .35127 L p F P
0 0 0 r
s
.541 .178 .08 r
.52265 .34694 m .53364 .35127 L .54106 .35131 L p F P
0 0 0 r
s
.24 .35 .67 r
.57817 .31784 m
.60159 .29157 L
s
.57817 .31784 m
.55131 .30686 L
s
.301 .46 .871 r
.54093 .65283 m .53573 .65738 L .54551 .65851 L p F P
0 0 0 r
s
.301 .46 .871 r
.54551 .65851 m .55219 .65272 L .54093 .65283 L p F P
0 0 0 r
s
.528 .131 .051 r
.31387 .58547 m .33155 .59086 L .34544 .60497 L p F P
0 0 0 r
s
.528 .131 .051 r
.36145 .60981 m .34544 .60497 L .33155 .59086 L p F P
0 0 0 r
s
.83 .24 .1 r
.35825 .59364 m
.36372 .60898 L
s
.24 .35 .67 r
.42116 .68372 m
.44907 .69171 L
s
.44907 .69171 m
.47003 .67258 L
s
.748 .235 .103 r
.47798 .32936 m .46663 .3249 L .47471 .33488 L p F P
0 0 0 r
s
.24 .35 .67 r
.47756 .32637 m
.50272 .32686 L
s
.83 .24 .1 r
.47039 .33209 m
.50039 .34385 L
s
.24 .35 .67 r
.45662 .3518 m
.47329 .33156 L
s
.4758 .32851 m
.47756 .32637 L
s
.266 .404 .736 r
.39327 .3914 m .40132 .38134 L .39003 .39179 L p F P
0 0 0 r
s
.24 .35 .67 r
.39434 .39248 m
.41383 .38174 L
s
.266 .404 .736 r
.39003 .39179 m .38117 .4029 L .39327 .3914 L p F P
0 0 0 r
s
.24 .35 .67 r
.37514 .41644 m
.39434 .39248 L
s
.272 .062 .026 r
.41915 .63348 m .43279 .63758 L .44339 .64322 L p F P
0 0 0 r
s
.272 .062 .026 r
.45477 .64663 m .44339 .64322 L .43279 .63758 L p F P
0 0 0 r
s
.83 .24 .1 r
.44001 .63207 m
.44949 .64225 L
s
.378 .084 .035 r
.66973 .40845 m .65359 .40211 L .63793 .39068 L p F P
0 0 0 r
s
.24 .35 .67 r
.66944 .39903 m
.69452 .3744 L
s
.378 .084 .035 r
.62322 .38488 m .63793 .39068 L .65359 .40211 L p F P
0 0 0 r
s
.83 .24 .1 r
.62297 .38573 m
.63125 .38944 L
s
.386 .087 .036 r
.36145 .60981 m .37732 .61461 L .39154 .62518 L p F P
0 0 0 r
s
.386 .087 .036 r
.40539 .62934 m .39154 .62518 L .37732 .61461 L p F P
0 0 0 r
s
.83 .24 .1 r
.36372 .60898 m
.40228 .62065 L
s
.518 .171 .076 r
.4773 .65338 m .48846 .65673 L .49094 .65597 L p F P
0 0 0 r
s
.83 .24 .1 r
.44949 .64225 m
.48699 .65352 L
s
.518 .171 .076 r
.49964 .65859 m .49094 .65597 L .48846 .65673 L p F P
0 0 0 r
s
.83 .24 .1 r
.76579 .48607 m
.7606 .46286 L
s
.7257 .44937 m
.7606 .46286 L
s
.321 .483 .913 r
.44798 .34779 m .45413 .34025 L .44391 .33784 L p F P
0 0 0 r
s
.321 .483 .913 r
.44391 .33784 m .43647 .34707 L .44798 .34779 L p F P
0 0 0 r
s
.83 .24 .1 r
.69684 .67858 m
.73206 .68959 L
s
.73206 .68959 m
.75025 .67016 L
s
.254 .059 .024 r
.60838 .37904 m .59341 .37314 L .58062 .36691 L p F P
0 0 0 r
s
.254 .059 .024 r
.56754 .36175 m .58062 .36691 L .59341 .37314 L p F P
0 0 0 r
s
.83 .24 .1 r
.55068 .35727 m
.58721 .37165 L
s
.75025 .67016 m
.78489 .68126 L
s
.80165 .65721 m
.78489 .68126 L
s
.42432 .31404 m
.41122 .322 L
s
.37246 .30695 m
.41122 .322 L
s
.525 .13 .05 r
.66973 .40845 m .68572 .41472 L .70025 .4297 L p F P
0 0 0 r
s
.24 .35 .67 r
.68985 .4196 m
.69076 .41874 L
s
.68419 .42499 m
.68812 .42125 L
s
.541 .178 .08 r
.54106 .35131 m .52767 .34603 L .52265 .34694 L p F P
0 0 0 r
s
.541 .178 .08 r
.51159 .34259 m .52265 .34694 L .52767 .34603 L p F P
0 0 0 r
s
.047 .067 .154 r
.6703 .53889 m .65828 .54941 L .66287 .53076 L p F P
0 0 0 r
s
.047 .067 .154 r
.66287 .53076 m .67529 .51975 L .6703 .53889 L p F P
0 0 0 r
s
.24 .35 .67 r
.64969 .52248 m
.67411 .50047 L
s
.83 .24 .1 r
.15896 .48772 m
.20007 .50081 L
s
.20007 .50081 m
.19769 .52455 L
s
.024 .036 .069 r
.64964 .56717 m .63855 .57679 L .64648 .55974 L p F P
0 0 0 r
s
.024 .036 .069 r
.64648 .55974 m .65828 .54941 L .64964 .56717 L p F P
0 0 0 r
s
.24 .35 .67 r
.64229 .56871 m
.64874 .54677 L
s
.024 .035 .067 r
.37245 .41382 m .38117 .4029 L .37178 .4171 L p F P
0 0 0 r
s
.024 .035 .067 r
.37178 .4171 m .36247 .42874 L .37245 .41382 L p F P
0 0 0 r
s
.079 .107 .249 r
.68794 .50854 m .67529 .51975 L .67587 .50047 L p F P
0 0 0 r
s
.079 .107 .249 r
.67587 .50047 m .68857 .48903 L .68794 .50854 L p F P
0 0 0 r
s
.83 .24 .1 r
.16417 .46098 m
.15896 .48772 L
s
.305 .461 .857 r
.4219 .36516 m .42913 .35618 L .41778 .36074 L p F P
0 0 0 r
s
.305 .461 .857 r
.41778 .36074 m .40949 .37112 L .4219 .36516 L p F P
0 0 0 r
s
.24 .35 .67 r
.41383 .38174 m
.43384 .35701 L
s
.144 .204 .437 r
.71005 .44675 m .69718 .45856 L .68806 .44112 L p F P
0 0 0 r
s
.144 .204 .437 r
.68806 .44112 m .70025 .4297 L .71005 .44675 L p F P
0 0 0 r
s
.83 .24 .1 r
.6923 .42151 m
.71735 .4313 L
s
.113 .157 .348 r
.70152 .47737 m .68857 .48903 L .68455 .47015 L p F P
0 0 0 r
s
.113 .157 .348 r
.68455 .47015 m .69718 .45856 L .70152 .47737 L p F P
0 0 0 r
s
.24 .35 .67 r
.66938 .47461 m
.69436 .45151 L
s
.098 .139 .32 r
.31545 .52985 m .32457 .51883 L .32957 .53801 L p F P
0 0 0 r
s
.098 .139 .32 r
.32957 .53801 m .32065 .54855 L .31545 .52985 L p F P
0 0 0 r
s
.136 .196 .427 r
.3119 .55889 m .32065 .54855 L .33045 .56637 L p F P
0 0 0 r
s
.136 .196 .427 r
.33045 .56637 m .32209 .576 L .3119 .55889 L p F P
0 0 0 r
s
.273 .421 .783 r
.57269 .63496 m .56578 .64095 L .57813 .63487 L p F P
0 0 0 r
s
.273 .421 .783 r
.57813 .63487 m .58642 .62771 L .57269 .63496 L p F P
0 0 0 r
s
.24 .35 .67 r
.58302 .62821 m
.60625 .60812 L
s
.83 .24 .1 r
.83598 .53904 m
.83346 .56866 L
s
.80184 .52636 m
.83598 .53904 L
s
.061 .089 .214 r
.32399 .49953 m .33332 .48807 L .33388 .5076 L p F P
0 0 0 r
s
.061 .089 .214 r
.33388 .5076 m .32457 .51883 L .32399 .49953 L p F P
0 0 0 r
s
.024 .035 .067 r
.62699 .59224 m .61708 .60079 L .62765 .58624 L p F P
0 0 0 r
s
.24 .35 .67 r
.60625 .60812 m
.61828 .58962 L
s
.024 .035 .067 r
.62765 .58624 m .63855 .57679 L .62699 .59224 L p F P
0 0 0 r
s
.24 .35 .67 r
.61828 .58962 m
.64229 .56871 L
s
.024 .035 .067 r
.35333 .44018 m .36247 .42874 L .35573 .44576 L p F P
0 0 0 r
s
.024 .035 .067 r
.35573 .44576 m .34622 .45759 L .35333 .44018 L p F P
0 0 0 r
s
.83 .24 .1 r
.80034 .49919 m
.76579 .48607 L
s
.80184 .52636 m
.80034 .49919 L
s
.041 .06 .137 r
.33688 .46919 m .34622 .45759 L .34283 .47639 L p F P
0 0 0 r
s
.041 .06 .137 r
.34283 .47639 m .33332 .48807 L .33688 .46919 L p F P
0 0 0 r
s
.518 .171 .076 r
.46607 .65002 m .4773 .65338 L .4822 .65335 L p F P
0 0 0 r
s
.518 .171 .076 r
.49094 .65597 m .4822 .65335 L .4773 .65338 L p F P
0 0 0 r
s
.83 .24 .1 r
.48699 .65352 m
.49961 .65792 L
s
.528 .131 .051 r
.34544 .60497 m .32928 .60009 L .31387 .58547 L p F P
0 0 0 r
s
.24 .35 .67 r
.30972 .62287 m
.32788 .60257 L
s
.166 .243 .512 r
.31387 .58547 m .32209 .576 L .33694 .59152 L p F P
0 0 0 r
s
.166 .243 .512 r
.33694 .59152 m .32928 .60009 L .31387 .58547 L p F P
0 0 0 r
s
.83 .24 .1 r
.3227 .59198 m
.32361 .59484 L
s
.32361 .59484 m
.32431 .59705 L
s
.55211 .66731 m
.58901 .67847 L
s
.58901 .67847 m
.60619 .67037 L
s
.22675 .29459 m
.21428 .31822 L
s
.272 .062 .026 r
.40539 .62934 m .41915 .63348 L .43194 .63978 L p F P
0 0 0 r
s
.272 .062 .026 r
.44339 .64322 m .43194 .63978 L .41915 .63348 L p F P
0 0 0 r
s
.24 .35 .67 r
.32475 .59579 m
.32788 .60257 L
s
.83 .24 .1 r
.28 .29047 m
.26721 .30982 L
s
.22675 .29459 m
.26721 .30982 L
s
.301 .46 .871 r
.54617 .64825 m .54093 .65283 L .55219 .65272 L p F P
0 0 0 r
s
.301 .46 .871 r
.55219 .65272 m .55895 .64687 L .54617 .64825 L p F P
0 0 0 r
s
.24 .35 .67 r
.55447 .64735 m
.56223 .64403 L
s
.83 .24 .1 r
.19769 .52455 m
.23848 .53727 L
s
.23848 .53727 m
.23929 .55718 L
s
.541 .178 .08 r
.52767 .34603 m .51417 .34071 L .51159 .34259 L p F P
0 0 0 r
s
.541 .178 .08 r
.50046 .33821 m .51159 .34259 L .51417 .34071 L p F P
0 0 0 r
s
.83 .24 .1 r
.50039 .34385 m
.51334 .34257 L
s
.378 .084 .035 r
.65359 .40211 m .63728 .39571 L .62322 .38488 L p F P
0 0 0 r
s
.378 .084 .035 r
.60838 .37904 m .62322 .38488 L .63728 .39571 L p F P
0 0 0 r
s
.386 .087 .036 r
.34544 .60497 m .36145 .60981 L .37757 .62098 L p F P
0 0 0 r
s
.386 .087 .036 r
.39154 .62518 m .37757 .62098 L .36145 .60981 L p F P
0 0 0 r
s
.254 .059 .024 r
.59341 .37314 m .5783 .36718 L .56754 .36175 L p F P
0 0 0 r
s
.254 .059 .024 r
.55435 .35655 m .56754 .36175 L .5783 .36718 L p F P
0 0 0 r
s
.024 .035 .067 r
.60336 .6131 m .59484 .62046 L .60733 .60921 L p F P
0 0 0 r
s
.024 .035 .067 r
.60733 .60921 m .61708 .60079 L .60336 .6131 L p F P
0 0 0 r
s
.309 .47 .901 r
.52119 .65535 m .51767 .65847 L .52548 .66634 L p F P
0 0 0 r
s
.83 .24 .1 r
.52519 .6656 m
.52604 .66586 L
s
.309 .47 .901 r
.52548 .66634 m .53058 .66188 L .52119 .65535 L p F P
0 0 0 r
s
.736 .233 .102 r
.51691 .66377 m .52548 .66634 L .51767 .65847 L p F P
0 0 0 r
s
.83 .24 .1 r
.49961 .65792 m
.517 .66314 L
s
.24 .35 .67 r
.55131 .30686 m
.57441 .28017 L
s
.55131 .30686 m
.52469 .30077 L
s
.525 .13 .05 r
.70025 .4297 m .68308 .42301 L .66973 .40845 L p F P
0 0 0 r
s
.24 .35 .67 r
.68419 .42499 m
.69436 .45151 L
s
.525 .13 .05 r
.65359 .40211 m .66973 .40845 L .68308 .42301 L p F P
0 0 0 r
s
.321 .483 .913 r
.45413 .34025 m .46034 .33261 L .45145 .32848 L p F P
0 0 0 r
s
.83 .24 .1 r
.44915 .33672 m
.45285 .33465 L
s
.45824 .33164 m
.46277 .32911 L
s
.321 .483 .913 r
.45145 .32848 m .44391 .33784 L .45413 .34025 L p F P
0 0 0 r
s
.24 .35 .67 r
.3937 .67003 m
.42116 .68372 L
s
.42116 .68372 m
.44175 .66428 L
s
.518 .171 .076 r
.45477 .64663 m .46607 .65002 L .47341 .65071 L p F P
0 0 0 r
s
.518 .171 .076 r
.4822 .65335 m .47341 .65071 L .46607 .65002 L p F P
0 0 0 r
s
.83 .24 .1 r
.33285 .29157 m
.32 .30578 L
s
.28 .29047 m
.32 .30578 L
s
.24 .35 .67 r
.47003 .67258 m
.49725 .67484 L
s
.266 .404 .736 r
.40132 .38134 m .40949 .37112 L .39904 .38049 L p F P
0 0 0 r
s
.266 .404 .736 r
.39904 .38049 m .39003 .39179 L .40132 .38134 L p F P
0 0 0 r
s
.83 .24 .1 r
.46277 .32911 m
.46325 .32905 L
s
.272 .062 .026 r
.39154 .62518 m .40539 .62934 L .42041 .63633 L p F P
0 0 0 r
s
.272 .062 .026 r
.43194 .63978 m .42041 .63633 L .40539 .62934 L p F P
0 0 0 r
s
.83 .24 .1 r
.40228 .62065 m
.41117 .63073 L
s
.41117 .63073 m
.44949 .64225 L
s
.541 .178 .08 r
.51417 .34071 m .50057 .33534 L .50046 .33821 L p F P
0 0 0 r
s
.541 .178 .08 r
.48926 .3338 m .50046 .33821 L .50057 .33534 L p F P
0 0 0 r
s
.736 .233 .102 r
.5083 .66119 m .51691 .66377 L .51172 .65667 L p F P
0 0 0 r
s
.736 .233 .102 r
.51767 .65847 m .51172 .65667 L .51691 .66377 L p F P
0 0 0 r
s
.24 .35 .67 r
.49725 .67484 m
.51232 .66145 L
s
.51232 .66145 m
.51543 .65868 L
s
.83 .24 .1 r
.76691 .64576 m
.80165 .65721 L
s
.81583 .62942 m
.80165 .65721 L
s
.254 .059 .024 r
.5783 .36718 m .56305 .36118 L .55435 .35655 L p F P
0 0 0 r
s
.254 .059 .024 r
.54106 .35131 m .55435 .35655 L .56305 .36118 L p F P
0 0 0 r
s
.83 .24 .1 r
.60619 .67037 m
.64269 .68155 L
s
.64269 .68155 m
.66083 .66734 L
s
.23929 .55718 m
.27981 .5696 L
s
.27981 .5696 m
.28402 .58485 L
s
.305 .461 .857 r
.42913 .35618 m .43647 .34707 L .42622 .3502 L p F P
0 0 0 r
s
.305 .461 .857 r
.42622 .3502 m .41778 .36074 L .42913 .35618 L p F P
0 0 0 r
s
.378 .084 .035 r
.63728 .39571 m .62081 .38925 L .60838 .37904 L p F P
0 0 0 r
s
.378 .084 .035 r
.59341 .37314 m .60838 .37904 L .62081 .38925 L p F P
0 0 0 r
s
.83 .24 .1 r
.59948 .37718 m
.60191 .37814 L
s
.58721 .37165 m
.59948 .37718 L
s
.386 .087 .036 r
.32928 .60009 m .34544 .60497 L .36349 .61675 L p F P
0 0 0 r
s
.386 .087 .036 r
.37757 .62098 m .36349 .61675 L .34544 .60497 L p F P
0 0 0 r
s
.273 .421 .783 r
.57968 .62891 m .57269 .63496 L .58642 .62771 L p F P
0 0 0 r
s
.273 .421 .783 r
.58642 .62771 m .59484 .62046 L .57968 .62891 L p F P
0 0 0 r
s
.24 .35 .67 r
.67536 .34952 m
.65295 .32691 L
s
.65295 .32691 m
.67809 .30052 L
s
.65295 .32691 m
.62808 .30736 L
s
.47293 .32737 m
.47756 .32637 L
s
.301 .46 .871 r
.55146 .64362 m .54617 .64825 L .55895 .64687 L p F P
0 0 0 r
s
.301 .46 .871 r
.55895 .64687 m .56578 .64095 L .55146 .64362 L p F P
0 0 0 r
s
.83 .24 .1 r
.83346 .56866 m
.82664 .59935 L
s
.79905 .55622 m
.83346 .56866 L
s
.24 .35 .67 r
.69452 .3744 m
.67536 .34952 L
s
.67536 .34952 m
.70094 .32355 L
s
.518 .171 .076 r
.44339 .64322 m .45477 .64663 L .46457 .64806 L p F P
0 0 0 r
s
.518 .171 .076 r
.47341 .65071 m .46457 .64806 L .45477 .64663 L p F P
0 0 0 r
s
.24 .35 .67 r
.32788 .60257 m
.32985 .60037 L
s
.309 .47 .901 r
.52472 .65221 m .52119 .65535 L .53058 .66188 L p F P
0 0 0 r
s
.309 .47 .901 r
.53058 .66188 m .53573 .65738 L .52472 .65221 L p F P
0 0 0 r
s
.024 .035 .067 r
.38117 .4029 m .39003 .39179 L .38126 .40523 L p F P
0 0 0 r
s
.024 .035 .067 r
.38126 .40523 m .37178 .4171 L .38117 .4029 L p F P
0 0 0 r
s
.24 .35 .67 r
.37895 .40828 m
.39434 .39248 L
s
.024 .036 .069 r
.66092 .55738 m .64964 .56717 L .65828 .54941 L p F P
0 0 0 r
s
.024 .036 .069 r
.65828 .54941 m .6703 .53889 L .66092 .55738 L p F P
0 0 0 r
s
.541 .178 .08 r
.50057 .33534 m .48685 .32993 L .48926 .3338 L p F P
0 0 0 r
s
.541 .178 .08 r
.47798 .32936 m .48926 .3338 L .48685 .32993 L p F P
0 0 0 r
s
.047 .067 .154 r
.68255 .52817 m .6703 .53889 L .67529 .51975 L p F P
0 0 0 r
s
.24 .35 .67 r
.64874 .54677 m
.67345 .52494 L
s
.67345 .52494 m
.67411 .50047 L
s
.047 .067 .154 r
.67529 .51975 m .68794 .50854 L .68255 .52817 L p F P
0 0 0 r
s
.525 .13 .05 r
.68308 .42301 m .66573 .41625 L .65359 .40211 L p F P
0 0 0 r
s
.525 .13 .05 r
.63728 .39571 m .65359 .40211 L .66573 .41625 L p F P
0 0 0 r
s
.736 .233 .102 r
.49964 .65859 m .5083 .66119 L .50575 .65487 L p F P
0 0 0 r
s
.83 .24 .1 r
.49961 .65792 m
.50107 .65772 L
s
.736 .233 .102 r
.51172 .65667 m .50575 .65487 L .5083 .66119 L p F P
0 0 0 r
s
.024 .035 .067 r
.63706 .58355 m .62699 .59224 L .63855 .57679 L p F P
0 0 0 r
s
.024 .035 .067 r
.63855 .57679 m .64964 .56717 L .63706 .58355 L p F P
0 0 0 r
s
.686 .18 .072 r
.68308 .42301 m .70025 .4297 L .71005 .44675 L p F P
0 0 0 r
s
.83 .24 .1 r
.73047 .47265 m
.7257 .44937 L
s
.079 .107 .249 r
.70084 .4971 m .68794 .50854 L .68857 .48903 L p F P
0 0 0 r
s
.079 .107 .249 r
.68857 .48903 m .70152 .47737 L .70084 .4971 L p F P
0 0 0 r
s
.136 .196 .427 r
.32065 .54855 m .32957 .53801 L .33896 .55656 L p F P
0 0 0 r
s
.136 .196 .427 r
.33896 .55656 m .33045 .56637 L .32065 .54855 L p F P
0 0 0 r
s
.272 .062 .026 r
.37757 .62098 m .39154 .62518 L .40881 .63285 L p F P
0 0 0 r
s
.272 .062 .026 r
.42041 .63633 m .40881 .63285 L .39154 .62518 L p F P
0 0 0 r
s
.24 .35 .67 r
.62808 .30736 m
.65279 .28052 L
s
.62808 .30736 m
.60159 .29157 L
s
.83 .24 .1 r
.66083 .66734 m
.69684 .67858 L
s
.69684 .67858 m
.71483 .65882 L
s
.113 .157 .348 r
.71472 .46548 m .70152 .47737 L .69718 .45856 L p F P
0 0 0 r
s
.113 .157 .348 r
.69718 .45856 m .71005 .44675 L .71472 .46548 L p F P
0 0 0 r
s
.24 .35 .67 r
.69436 .45151 m
.69947 .4776 L
s
.098 .139 .32 r
.32457 .51883 m .33388 .5076 L .33865 .52728 L p F P
0 0 0 r
s
.098 .139 .32 r
.33865 .52728 m .32957 .53801 L .32457 .51883 L p F P
0 0 0 r
s
.83 .24 .1 r
.71483 .65882 m
.75025 .67016 L
s
.75025 .67016 m
.76691 .64576 L
s
.321 .483 .913 r
.46034 .33261 m .46663 .3249 L .45909 .31899 L p F P
0 0 0 r
s
.321 .483 .913 r
.45909 .31899 m .45145 .32848 L .46034 .33261 L p F P
0 0 0 r
s
.83 .24 .1 r
.42432 .31404 m
.45378 .32558 L
s
.24 .35 .67 r
.36812 .65126 m
.3937 .67003 L
s
.3937 .67003 m
.41387 .65022 L
s
.83 .24 .1 r
.38502 .29864 m
.37246 .30695 L
s
.33285 .29157 m
.37246 .30695 L
s
.166 .243 .512 r
.32209 .576 m .33045 .56637 L .34471 .58282 L p F P
0 0 0 r
s
.166 .243 .512 r
.34471 .58282 m .33694 .59152 L .32209 .576 L p F P
0 0 0 r
s
.024 .035 .067 r
.36247 .42874 m .37178 .4171 L .36544 .4337 L p F P
0 0 0 r
s
.24 .35 .67 r
.36234 .42908 m
.36253 .42884 L
s
.37165 .41742 m
.37895 .40828 L
s
.024 .035 .067 r
.36544 .4337 m .35573 .44576 L .36247 .42874 L p F P
0 0 0 r
s
.061 .089 .214 r
.33332 .48807 m .34283 .47639 L .34336 .49614 L p F P
0 0 0 r
s
.24 .35 .67 r
.33338 .49018 m
.3344 .48894 L
s
.34289 .47853 m
.34443 .47663 L
s
.061 .089 .214 r
.34336 .49614 m .33388 .5076 L .33332 .48807 L p F P
0 0 0 r
s
.041 .06 .137 r
.34622 .45759 m .35573 .44576 L .35252 .46448 L p F P
0 0 0 r
s
.041 .06 .137 r
.35252 .46448 m .34283 .47639 L .34622 .45759 L p F P
0 0 0 r
s
.24 .35 .67 r
.34443 .47663 m
.34503 .47369 L
s
.254 .059 .024 r
.56305 .36118 m .54767 .35511 L .54106 .35131 L p F P
0 0 0 r
s
.83 .24 .1 r
.55068 .35727 m
.56241 .36259 L
s
.254 .059 .024 r
.52767 .34603 m .54106 .35131 L .54767 .35511 L p F P
0 0 0 r
s
.83 .24 .1 r
.51334 .34257 m
.55068 .35727 L
s
.15896 .48772 m
.156 .51155 L
s
.78111 .61761 m
.81583 .62942 L
s
.82664 .59935 m
.81583 .62942 L
s
.024 .035 .067 r
.61201 .60564 m .60336 .6131 L .61708 .60079 L p F P
0 0 0 r
s
.024 .035 .067 r
.61708 .60079 m .62699 .59224 L .61201 .60564 L p F P
0 0 0 r
s
.518 .171 .076 r
.43194 .63978 m .44339 .64322 L .4557 .64539 L p F P
0 0 0 r
s
.518 .171 .076 r
.46457 .64806 m .4557 .64539 L .44339 .64322 L p F P
0 0 0 r
s
.83 .24 .1 r
.79202 .5872 m
.82664 .59935 L
s
.24 .35 .67 r
.70971 .40071 m
.69452 .3744 L
s
.69452 .3744 m
.72056 .34882 L
s
.378 .084 .035 r
.62081 .38925 m .60417 .38272 L .59341 .37314 L p F P
0 0 0 r
s
.378 .084 .035 r
.5783 .36718 m .59341 .37314 L .60417 .38272 L p F P
0 0 0 r
s
.83 .24 .1 r
.79905 .55622 m
.80184 .52636 L
s
.76694 .5134 m
.80184 .52636 L
s
.386 .087 .036 r
.36349 .61675 m .3493 .61249 L .32928 .60009 L p F P
0 0 0 r
s
.192 .282 .584 r
.32928 .60009 m .33694 .59152 L .35619 .60502 L p F P
0 0 0 r
s
.83 .24 .1 r
.34213 .60244 m
.36372 .60898 L
s
.32431 .59705 m
.32916 .59852 L
s
.32916 .59852 m
.32936 .59858 L
s
.192 .282 .584 r
.35619 .60502 m .3493 .61249 L .32928 .60009 L p F P
0 0 0 r
s
.24 .35 .67 r
.32788 .60257 m
.34579 .62837 L
s
.736 .233 .102 r
.49094 .65597 m .49964 .65859 L .49975 .65306 L p F P
0 0 0 r
s
.736 .233 .102 r
.50575 .65487 m .49975 .65306 L .49964 .65859 L p F P
0 0 0 r
s
.24 .35 .67 r
.34579 .62837 m
.36812 .65126 L
s
.32971 .53784 m
.32995 .53876 L
s
.83 .24 .1 r
.76579 .48607 m
.73047 .47265 L
s
.76694 .5134 m
.76579 .48607 L
s
.541 .178 .08 r
.48685 .32993 m .47303 .32448 L .47798 .32936 L p F P
0 0 0 r
s
.541 .178 .08 r
.46663 .3249 m .47798 .32936 L .47303 .32448 L p F P
0 0 0 r
s
.83 .24 .1 r
.46628 .32866 m
.47517 .32754 L
s
.24 .35 .67 r
.45463 .33133 m
.47106 .32778 L
s
.83 .24 .1 r
.5263 .65951 m
.55211 .66731 L
s
.521 .65791 m
.5263 .65951 L
s
.55211 .66731 m
.56888 .65894 L
s
.309 .47 .901 r
.52828 .64906 m .52472 .65221 L .53573 .65738 L p F P
0 0 0 r
s
.309 .47 .901 r
.53573 .65738 m .54093 .65283 L .52828 .64906 L p F P
0 0 0 r
s
.24 .35 .67 r
.5394 .65238 m
.54184 .65203 L
s
.83 .24 .1 r
.23911 .27481 m
.22675 .29459 L
s
.266 .404 .736 r
.40949 .37112 m .41778 .36074 L .40821 .36898 L p F P
0 0 0 r
s
.24 .35 .67 r
.41427 .3676 m
.43384 .35701 L
s
.266 .404 .736 r
.40821 .36898 m .39904 .38049 L .40949 .37112 L p F P
0 0 0 r
s
.24 .35 .67 r
.39434 .39248 m
.41427 .3676 L
s
.83 .24 .1 r
.156 .51155 m
.19769 .52455 L
s
.19769 .52455 m
.19786 .54448 L
s
.28402 .58485 m
.32431 .59705 L
s
.32431 .59705 m
.33194 .60691 L
s
.301 .46 .871 r
.55679 .63896 m .55146 .64362 L .56578 .64095 L p F P
0 0 0 r
s
.301 .46 .871 r
.56578 .64095 m .57269 .63496 L .55679 .63896 L p F P
0 0 0 r
s
.272 .062 .026 r
.36349 .61675 m .37757 .62098 L .39713 .62935 L p F P
0 0 0 r
s
.272 .062 .026 r
.40881 .63285 m .39713 .62935 L .37757 .62098 L p F P
0 0 0 r
s
.305 .461 .857 r
.43647 .34707 m .44391 .33784 L .43478 .33949 L p F P
0 0 0 r
s
.305 .461 .857 r
.43478 .33949 m .42622 .3502 L .43647 .34707 L p F P
0 0 0 r
s
.525 .13 .05 r
.66573 .41625 m .64819 .40942 L .63728 .39571 L p F P
0 0 0 r
s
.525 .13 .05 r
.62081 .38925 m .63728 .39571 L .64819 .40942 L p F P
0 0 0 r
s
.273 .421 .783 r
.58675 .62278 m .57968 .62891 L .59484 .62046 L p F P
0 0 0 r
s
.273 .421 .783 r
.59484 .62046 m .60336 .6131 L .58675 .62278 L p F P
0 0 0 r
s
.24 .35 .67 r
.59301 .61914 m
.60625 .60812 L
s
.736 .233 .102 r
.4822 .65335 m .49094 .65597 L .49373 .65124 L p F P
0 0 0 r
s
.83 .24 .1 r
.49127 .65541 m
.49199 .65563 L
s
.736 .233 .102 r
.49975 .65306 m .49373 .65124 L .49094 .65597 L p F P
0 0 0 r
s
.24 .35 .67 r
.52469 .30077 m
.54751 .27368 L
s
.52469 .30077 m
.49931 .29996 L
s
.518 .171 .076 r
.42041 .63633 m .43194 .63978 L .44677 .64271 L p F P
0 0 0 r
s
.518 .171 .076 r
.4557 .64539 m .44677 .64271 L .43194 .63978 L p F P
0 0 0 r
s
.83 .24 .1 r
.44949 .64225 m
.46156 .64648 L
s
.254 .059 .024 r
.54767 .35511 m .53214 .349 L .52767 .34603 L p F P
0 0 0 r
s
.254 .059 .024 r
.51417 .34071 m .52767 .34603 L .53214 .349 L p F P
0 0 0 r
s
.686 .18 .072 r
.71005 .44675 m .69209 .43982 L .68308 .42301 L p F P
0 0 0 r
s
.24 .35 .67 r
.69436 .45151 m
.70261 .44388 L
s
.83 .24 .1 r
.70752 .44234 m
.7257 .44937 L
s
.24 .35 .67 r
.70756 .4393 m
.72031 .42751 L
s
.70591 .44083 m
.70756 .4393 L
s
.686 .18 .072 r
.66573 .41625 m .68308 .42301 L .69209 .43982 L p F P
0 0 0 r
s
.24 .35 .67 r
.69131 .41822 m
.70971 .40071 L
s
.69076 .41874 m
.69131 .41822 L
s
.60159 .29157 m
.62592 .26427 L
s
.60159 .29157 m
.57441 .28017 L
s
.541 .178 .08 r
.47303 .32448 m .45909 .31899 L .46663 .3249 L p F P
0 0 0 r
s
.24 .35 .67 r
.44175 .66428 m
.47003 .67258 L
s
.47003 .67258 m
.49036 .65403 L
s
.83 .24 .1 r
.29234 .27585 m
.28 .29047 L
s
.23911 .27481 m
.28 .29047 L
s
.378 .084 .035 r
.60417 .38272 m .58736 .37612 L .5783 .36718 L p F P
0 0 0 r
s
.378 .084 .035 r
.56305 .36118 m .5783 .36718 L .58736 .37612 L p F P
0 0 0 r
s
.83 .24 .1 r
.56241 .36259 m
.5706 .36581 L
s
.43614 .31217 m
.42432 .31404 L
s
.38502 .29864 m
.42432 .31404 L
s
.736 .233 .102 r
.47341 .65071 m .4822 .65335 L .4877 .64942 L p F P
0 0 0 r
s
.83 .24 .1 r
.46156 .64648 m
.47511 .65056 L
s
.48285 .65288 m
.48357 .6531 L
s
.736 .233 .102 r
.49373 .65124 m .4877 .64942 L .4822 .65335 L p F P
0 0 0 r
s
.24 .35 .67 r
.49036 .65403 m
.49181 .65271 L
s
.024 .035 .067 r
.39003 .39179 m .39904 .38049 L .39091 .39314 L p F P
0 0 0 r
s
.024 .035 .067 r
.39091 .39314 m .38126 .40523 L .39003 .39179 L p F P
0 0 0 r
s
.309 .47 .901 r
.53185 .64589 m .52828 .64906 L .54093 .65283 L p F P
0 0 0 r
s
.309 .47 .901 r
.54093 .65283 m .54617 .64825 L .53185 .64589 L p F P
0 0 0 r
s
.272 .062 .026 r
.3493 .61249 m .36349 .61675 L .38537 .62582 L p F P
0 0 0 r
s
.272 .062 .026 r
.39713 .62935 m .38537 .62582 L .36349 .61675 L p F P
0 0 0 r
s
.83 .24 .1 r
.36372 .60898 m
.37199 .61895 L
s
.37199 .61895 m
.41117 .63073 L
s
.7314 .63406 m
.76691 .64576 L
s
.76691 .64576 m
.78111 .61761 L
s
.518 .171 .076 r
.40881 .63285 m .42041 .63633 L .4378 .64002 L p F P
0 0 0 r
s
.518 .171 .076 r
.44677 .64271 m .4378 .64002 L .42041 .63633 L p F P
0 0 0 r
s
.83 .24 .1 r
.56888 .65894 m
.60619 .67037 L
s
.60619 .67037 m
.62402 .65584 L
s
.24 .35 .67 r
.70971 .40071 m
.72031 .42751 L
s
.70971 .40071 m
.73623 .37547 L
s
.024 .035 .067 r
.64729 .57472 m .63706 .58355 L .64964 .56717 L p F P
0 0 0 r
s
.024 .035 .067 r
.64964 .56717 m .66092 .55738 L .64729 .57472 L p F P
0 0 0 r
s
.83 .24 .1 r
.19786 .54448 m
.23929 .55718 L
s
.23929 .55718 m
.24282 .57238 L
s
.024 .036 .069 r
.6724 .54742 m .66092 .55738 L .6703 .53889 L p F P
0 0 0 r
s
.024 .036 .069 r
.6703 .53889 m .68255 .52817 L .6724 .54742 L p F P
0 0 0 r
s
.24 .35 .67 r
.66723 .54698 m
.67345 .52494 L
s
.254 .059 .024 r
.53214 .349 m .51647 .34282 L .51417 .34071 L p F P
0 0 0 r
s
.254 .059 .024 r
.50057 .33534 m .51417 .34071 L .51647 .34282 L p F P
0 0 0 r
s
.047 .067 .154 r
.69502 .51726 m .68255 .52817 L .68794 .50854 L p F P
0 0 0 r
s
.047 .067 .154 r
.68794 .50854 m .70084 .4971 L .69502 .51726 L p F P
0 0 0 r
s
.24 .35 .67 r
.67411 .50047 m
.69947 .4776 L
s
.166 .243 .512 r
.33045 .56637 m .33896 .55656 L .35262 .57399 L p F P
0 0 0 r
s
.166 .243 .512 r
.35262 .57399 m .34471 .58282 L .33045 .56637 L p F P
0 0 0 r
s
.024 .035 .067 r
.62077 .59808 m .61201 .60564 L .62699 .59224 L p F P
0 0 0 r
s
.024 .035 .067 r
.62699 .59224 m .63706 .58355 L .62077 .59808 L p F P
0 0 0 r
s
.24 .35 .67 r
.63038 .58725 m
.64229 .56871 L
s
.136 .196 .427 r
.32957 .53801 m .33865 .52728 L .34762 .54659 L p F P
0 0 0 r
s
.136 .196 .427 r
.34762 .54659 m .33896 .55656 L .32957 .53801 L p F P
0 0 0 r
s
.83 .24 .1 r
.79202 .5872 m
.79905 .55622 L
s
.76386 .5435 m
.79905 .55622 L
s
.301 .46 .871 r
.56217 .63425 m .55679 .63896 L .57269 .63496 L p F P
0 0 0 r
s
.301 .46 .871 r
.57269 .63496 m .57968 .62891 L .56217 .63425 L p F P
0 0 0 r
s
.525 .13 .05 r
.64819 .40942 m .63046 .40251 L .62081 .38925 L p F P
0 0 0 r
s
.525 .13 .05 r
.60417 .38272 m .62081 .38925 L .63046 .40251 L p F P
0 0 0 r
s
.079 .107 .249 r
.71399 .48545 m .70084 .4971 L .70152 .47737 L p F P
0 0 0 r
s
.079 .107 .249 r
.70152 .47737 m .71472 .46548 L .71399 .48545 L p F P
0 0 0 r
s
.736 .233 .102 r
.46457 .64806 m .47341 .65071 L .48164 .64759 L p F P
0 0 0 r
s
.736 .233 .102 r
.4877 .64942 m .48164 .64759 L .47341 .65071 L p F P
0 0 0 r
s
.024 .035 .067 r
.37178 .4171 m .38126 .40523 L .37533 .4214 L p F P
0 0 0 r
s
.024 .035 .067 r
.37533 .4214 m .36544 .4337 L .37178 .4171 L p F P
0 0 0 r
s
.791 .213 .087 r
.69209 .43982 m .71005 .44675 L .71472 .46548 L p F P
0 0 0 r
s
.098 .139 .32 r
.33388 .5076 m .34336 .49614 L .3479 .51634 L p F P
0 0 0 r
s
.098 .139 .32 r
.3479 .51634 m .33865 .52728 L .33388 .5076 L p F P
0 0 0 r
s
.192 .282 .584 r
.33694 .59152 m .34471 .58282 L .36318 .59745 L p F P
0 0 0 r
s
.24 .35 .67 r
.33744 .59188 m
.33762 .59168 L
s
.192 .282 .584 r
.36318 .59745 m .35619 .60502 L .33694 .59152 L p F P
0 0 0 r
s
.686 .18 .072 r
.69209 .43982 m .67393 .43282 L .66573 .41625 L p F P
0 0 0 r
s
.686 .18 .072 r
.64819 .40942 m .66573 .41625 L .67393 .43282 L p F P
0 0 0 r
s
.061 .089 .214 r
.34283 .47639 m .35252 .46448 L .35303 .48447 L p F P
0 0 0 r
s
.061 .089 .214 r
.35303 .48447 m .34336 .49614 L .34283 .47639 L p F P
0 0 0 r
s
.041 .06 .137 r
.35573 .44576 m .36544 .4337 L .36241 .45234 L p F P
0 0 0 r
s
.041 .06 .137 r
.36241 .45234 m .35252 .46448 L .35573 .44576 L p F P
0 0 0 r
s
.378 .084 .035 r
.58736 .37612 m .57039 .36946 L .56305 .36118 L p F P
0 0 0 r
s
.378 .084 .035 r
.54767 .35511 m .56305 .36118 L .57039 .36946 L p F P
0 0 0 r
s
.305 .461 .857 r
.44391 .33784 m .45145 .32848 L .44348 .32861 L p F P
0 0 0 r
s
.305 .461 .857 r
.44348 .32861 m .43478 .33949 L .44391 .33784 L p F P
0 0 0 r
s
.24 .35 .67 r
.43384 .35701 m
.45463 .33133 L
s
.83 .24 .1 r
.62402 .65584 m
.66083 .66734 L
s
.66083 .66734 m
.67862 .64722 L
s
.266 .404 .736 r
.41778 .36074 m .42622 .3502 L .41755 .35728 L p F P
0 0 0 r
s
.266 .404 .736 r
.41755 .35728 m .40821 .36898 L .41778 .36074 L p F P
0 0 0 r
s
.83 .24 .1 r
.67862 .64722 m
.71483 .65882 L
s
.71483 .65882 m
.7314 .63406 L
s
.273 .421 .783 r
.5939 .61659 m .58675 .62278 L .60336 .6131 L p F P
0 0 0 r
s
.273 .421 .783 r
.60336 .6131 m .61201 .60564 L .5939 .61659 L p F P
0 0 0 r
s
.24 .35 .67 r
.60625 .60812 m
.63038 .58725 L
s
.518 .171 .076 r
.39713 .62935 m .40881 .63285 L .42879 .63731 L p F P
0 0 0 r
s
.518 .171 .076 r
.4378 .64002 m .42879 .63731 L .40881 .63285 L p F P
0 0 0 r
s
.83 .24 .1 r
.34482 .28288 m
.33285 .29157 L
s
.29234 .27585 m
.33285 .29157 L
s
.24 .35 .67 r
.43498 .34175 m
.45463 .33133 L
s
.272 .062 .026 r
.38537 .62582 m .37353 .62227 L .3493 .61249 L p F P
0 0 0 r
s
.213 .315 .645 r
.3493 .61249 m .35619 .60502 L .37945 .61607 L p F P
0 0 0 r
s
.213 .315 .645 r
.37945 .61607 m .37353 .62227 L .3493 .61249 L p F P
0 0 0 r
s
.83 .24 .1 r
.35554 .61401 m
.35682 .61439 L
s
.33194 .60691 m
.35554 .61401 L
s
.24 .35 .67 r
.35701 .61635 m
.35752 .61581 L
s
.34579 .62837 m
.35701 .61635 L
s
.309 .47 .901 r
.53545 .64269 m .53185 .64589 L .54617 .64825 L p F P
0 0 0 r
s
.309 .47 .901 r
.54617 .64825 m .55146 .64362 L .53545 .64269 L p F P
0 0 0 r
s
.736 .233 .102 r
.4557 .64539 m .46457 .64806 L .47556 .64575 L p F P
0 0 0 r
s
.736 .233 .102 r
.48164 .64759 m .47556 .64575 L .46457 .64806 L p F P
0 0 0 r
s
.83 .24 .1 r
.7456 .60554 m
.78111 .61761 L
s
.78111 .61761 m
.79202 .5872 L
s
.75663 .57479 m
.79202 .5872 L
s
.254 .059 .024 r
.51647 .34282 m .50066 .33659 L .50057 .33534 L p F P
0 0 0 r
s
.254 .059 .024 r
.48685 .32993 m .50057 .33534 L .50066 .33659 L p F P
0 0 0 r
s
.83 .24 .1 r
.47517 .32754 m
.51334 .34257 L
s
.76386 .5435 m
.76694 .5134 L
s
.73125 .50014 m
.76694 .5134 L
s
.305 .461 .894 r
.51091 .6446 m .50912 .64622 L .51767 .65847 L p F P
0 0 0 r
s
.83 .24 .1 r
.51678 .65663 m
.51899 .6573 L
s
.24 .35 .67 r
.51618 .65802 m
.51691 .65737 L
s
.305 .461 .894 r
.51767 .65847 m .52119 .65535 L .51091 .6446 L p F P
0 0 0 r
s
.24 .35 .67 r
.52085 .655 m
.52172 .65488 L
s
.895 .274 .118 r
.51172 .65667 m .51767 .65847 L .50912 .64622 L p F P
0 0 0 r
s
.83 .24 .1 r
.51081 .65639 m
.51162 .65628 L
s
.71468 .46666 m
.73047 .47265 L
s
.73125 .50014 m
.73047 .47265 L
s
.24 .35 .67 r
.57441 .28017 m
.59841 .25242 L
s
.57441 .28017 m
.54751 .27368 L
s
.41387 .65022 m
.44175 .66428 L
s
.525 .13 .05 r
.63046 .40251 m .61254 .39553 L .60417 .38272 L p F P
0 0 0 r
s
.83 .24 .1 r
.60404 .38267 m
.60448 .3832 L
s
.525 .13 .05 r
.58736 .37612 m .60417 .38272 L .61254 .39553 L p F P
0 0 0 r
s
.83 .24 .1 r
.156 .51155 m
.15549 .53149 L
s
.736 .233 .102 r
.44677 .64271 m .4557 .64539 L .46946 .64391 L p F P
0 0 0 r
s
.83 .24 .1 r
.45734 .64522 m
.45807 .64544 L
s
.736 .233 .102 r
.47556 .64575 m .46946 .64391 L .4557 .64539 L p F P
0 0 0 r
s
.24 .35 .67 r
.46174 .64542 m
.46316 .64408 L
s
.44175 .66428 m
.46174 .64542 L
s
.518 .171 .076 r
.38537 .62582 m .39713 .62935 L .41972 .63459 L p F P
0 0 0 r
s
.518 .171 .076 r
.42879 .63731 m .41972 .63459 L .39713 .62935 L p F P
0 0 0 r
s
.83 .24 .1 r
.24282 .57238 m
.28402 .58485 L
s
.28402 .58485 m
.29097 .5946 L
s
.301 .46 .871 r
.5676 .6295 m .56217 .63425 L .57968 .62891 L p F P
0 0 0 r
s
.301 .46 .871 r
.57968 .62891 m .58675 .62278 L .5676 .6295 L p F P
0 0 0 r
s
.895 .274 .118 r
.50575 .65487 m .51172 .65667 L .50604 .64528 L p F P
0 0 0 r
s
.83 .24 .1 r
.5108 .65482 m
.5113 .65497 L
s
.895 .274 .118 r
.50912 .64622 m .50604 .64528 L .51172 .65667 L p F P
0 0 0 r
s
.24 .35 .67 r
.50639 .65404 m
.50929 .6543 L
s
.791 .213 .087 r
.71472 .46548 m .69639 .45851 L .69209 .43982 L p F P
0 0 0 r
s
.791 .213 .087 r
.67393 .43282 m .69209 .43982 L .69639 .45851 L p F P
0 0 0 r
s
.378 .084 .035 r
.57039 .36946 m .55324 .36273 L .54767 .35511 L p F P
0 0 0 r
s
.378 .084 .035 r
.53214 .349 m .54767 .35511 L .55324 .36273 L p F P
0 0 0 r
s
.686 .18 .072 r
.67393 .43282 m .65556 .42574 L .64819 .40942 L p F P
0 0 0 r
s
.686 .18 .072 r
.63046 .40251 m .64819 .40942 L .65556 .42574 L p F P
0 0 0 r
s
.024 .035 .067 r
.39904 .38049 m .40821 .36898 L .40076 .38082 L p F P
0 0 0 r
s
.024 .035 .067 r
.40076 .38082 m .39091 .39314 L .39904 .38049 L p F P
0 0 0 r
s
.24 .35 .67 r
.39888 .38334 m
.41427 .3676 L
s
.309 .47 .901 r
.53907 .63948 m .53545 .64269 L .55146 .64362 L p F P
0 0 0 r
s
.309 .47 .901 r
.55146 .64362 m .55679 .63896 L .53907 .63948 L p F P
0 0 0 r
s
.305 .461 .894 r
.51271 .64297 m .51091 .6446 L .52119 .65535 L p F P
0 0 0 r
s
.305 .461 .894 r
.52119 .65535 m .52472 .65221 L .51271 .64297 L p F P
0 0 0 r
s
.24 .35 .67 r
.70094 .32355 m
.67809 .30052 L
s
.67809 .30052 m
.70422 .27308 L
s
.67809 .30052 m
.65279 .28052 L
s
.254 .059 .024 r
.50066 .33659 m .4847 .3303 L .48685 .32993 L p F P
0 0 0 r
s
.254 .059 .024 r
.47303 .32448 m .48685 .32993 L .4847 .3303 L p F P
0 0 0 r
s
.83 .24 .1 r
.46039 .32172 m
.47517 .32754 L
s
.24 .35 .67 r
.47855 .32518 m
.49931 .29996 L
s
.47763 .32629 m
.47855 .32518 L
s
.895 .274 .118 r
.49975 .65306 m .50575 .65487 L .50296 .64434 L p F P
0 0 0 r
s
.83 .24 .1 r
.50529 .65316 m
.50579 .65331 L
s
.895 .274 .118 r
.50604 .64528 m .50296 .64434 L .50575 .65487 L p F P
0 0 0 r
s
.024 .035 .067 r
.65768 .56575 m .64729 .57472 L .66092 .55738 L p F P
0 0 0 r
s
.024 .035 .067 r
.66092 .55738 m .6724 .54742 L .65768 .56575 L p F P
0 0 0 r
s
.24 .35 .67 r
.64229 .56871 m
.66723 .54698 L
s
.024 .035 .067 r
.62966 .59041 m .62077 .59808 L .63706 .58355 L p F P
0 0 0 r
s
.024 .035 .067 r
.63706 .58355 m .64729 .57472 L .62966 .59041 L p F P
0 0 0 r
s
.24 .35 .67 r
.49931 .29996 m
.52192 .2725 L
s
.49931 .29996 m
.47624 .30464 L
s
.736 .233 .102 r
.4378 .64002 m .44677 .64271 L .46334 .64206 L p F P
0 0 0 r
s
.83 .24 .1 r
.42265 .6348 m
.44086 .64026 L
s
.44875 .64264 m
.44948 .64286 L
s
.736 .233 .102 r
.46946 .64391 m .46334 .64206 L .44677 .64271 L p F P
0 0 0 r
s
.83 .24 .1 r
.25091 .25977 m
.23911 .27481 L
s
.24 .35 .67 r
.72581 .45384 m
.72031 .42751 L
s
.72031 .42751 m
.74729 .40257 L
s
.72056 .34882 m
.70094 .32355 L
s
.70094 .32355 m
.72754 .29655 L
s
.024 .036 .069 r
.68409 .53729 m .6724 .54742 L .68255 .52817 L p F P
0 0 0 r
s
.024 .036 .069 r
.68255 .52817 m .69502 .51726 L .68409 .53729 L p F P
0 0 0 r
s
.192 .282 .584 r
.34471 .58282 m .35262 .57399 L .37026 .58977 L p F P
0 0 0 r
s
.24 .35 .67 r
.3452 .58321 m
.34538 .58301 L
s
.192 .282 .584 r
.37026 .58977 m .36318 .59745 L .34471 .58282 L p F P
0 0 0 r
s
.166 .243 .512 r
.33896 .55656 m .34762 .54659 L .36064 .565 L p F P
0 0 0 r
s
.166 .243 .512 r
.36064 .565 m .35262 .57399 L .33896 .55656 L p F P
0 0 0 r
s
.305 .461 .857 r
.45145 .32848 m .45909 .31899 L .45233 .31755 L p F P
0 0 0 r
s
.24 .35 .67 r
.45463 .33133 m
.46277 .32127 L
s
.305 .461 .857 r
.45233 .31755 m .44348 .32861 L .45145 .32848 L p F P
0 0 0 r
s
.83 .24 .1 r
.43614 .31217 m
.45172 .3183 L
s
.518 .171 .076 r
.37353 .62227 m .38537 .62582 L .41061 .63186 L p F P
0 0 0 r
s
.518 .171 .076 r
.41972 .63459 m .41061 .63186 L .38537 .62582 L p F P
0 0 0 r
s
.83 .24 .1 r
.41117 .63073 m
.42265 .6348 L
s
.39622 .29645 m
.38502 .29864 L
s
.34482 .28288 m
.38502 .29864 L
s
.273 .421 .783 r
.60113 .61032 m .5939 .61659 L .61201 .60564 L p F P
0 0 0 r
s
.273 .421 .783 r
.61201 .60564 m .62077 .59808 L .60113 .61032 L p F P
0 0 0 r
s
.136 .196 .427 r
.33865 .52728 m .3479 .51634 L .35643 .53644 L p F P
0 0 0 r
s
.136 .196 .427 r
.35643 .53644 m .34762 .54659 L .33865 .52728 L p F P
0 0 0 r
s
.047 .067 .154 r
.70773 .50613 m .69502 .51726 L .70084 .4971 L p F P
0 0 0 r
s
.24 .35 .67 r
.67345 .52494 m
.69913 .50225 L
s
.047 .067 .154 r
.70084 .4971 m .71399 .48545 L .70773 .50613 L p F P
0 0 0 r
s
.895 .274 .118 r
.49373 .65124 m .49975 .65306 L .49987 .6434 L p F P
0 0 0 r
s
.83 .24 .1 r
.49977 .65149 m
.50027 .65164 L
s
.895 .274 .118 r
.50296 .64434 m .49987 .6434 L .49975 .65306 L p F P
0 0 0 r
s
.24 .35 .67 r
.49181 .65271 m
.50639 .65404 L
s
.213 .315 .645 r
.35619 .60502 m .36318 .59745 L .38544 .60979 L p F P
0 0 0 r
s
.213 .315 .645 r
.38544 .60979 m .37945 .61607 L .35619 .60502 L p F P
0 0 0 r
s
.024 .035 .067 r
.38126 .40523 m .39091 .39314 L .38541 .40886 L p F P
0 0 0 r
s
.24 .35 .67 r
.38114 .40555 m
.38134 .4053 L
s
.39081 .39345 m
.39888 .38334 L
s
.024 .035 .067 r
.38541 .40886 m .37533 .4214 L .38126 .40523 L p F P
0 0 0 r
s
.266 .404 .736 r
.42622 .3502 m .43478 .33949 L .42705 .34536 L p F P
0 0 0 r
s
.266 .404 .736 r
.42705 .34536 m .41755 .35728 L .42622 .3502 L p F P
0 0 0 r
s
.83 .24 .1 r
.69509 .62209 m
.7314 .63406 L
s
.7314 .63406 m
.7456 .60554 L
s
.24 .35 .67 r
.65279 .28052 m
.67849 .25262 L
s
.65279 .28052 m
.62592 .26427 L
s
.83 .24 .1 r
.56888 .65894 m
.58637 .64408 L
s
.862 .236 .097 r
.69639 .45851 m .71472 .46548 L .71399 .48545 L p F P
0 0 0 r
s
.24 .35 .67 r
.69913 .50225 m
.69947 .4776 L
s
.69947 .4776 m
.70538 .47227 L
s
.83 .24 .1 r
.69435 .45894 m
.69743 .46011 L
s
.098 .139 .32 r
.34336 .49614 m .35303 .48447 L .35733 .5052 L p F P
0 0 0 r
s
.098 .139 .32 r
.35733 .5052 m .3479 .51634 L .34336 .49614 L p F P
0 0 0 r
s
.83 .24 .1 r
.15549 .53149 m
.19786 .54448 L
s
.19786 .54448 m
.20068 .55963 L
s
.525 .13 .05 r
.61254 .39553 m .59442 .38847 L .58736 .37612 L p F P
0 0 0 r
s
.525 .13 .05 r
.57039 .36946 m .58736 .37612 L .59442 .38847 L p F P
0 0 0 r
s
.305 .461 .894 r
.51452 .64133 m .51271 .64297 L .52472 .65221 L p F P
0 0 0 r
s
.305 .461 .894 r
.52472 .65221 m .52828 .64906 L .51452 .64133 L p F P
0 0 0 r
s
.83 .24 .1 r
.52032 .65276 m
.52204 .65185 L
s
.736 .233 .102 r
.42879 .63731 m .4378 .64002 L .45719 .64021 L p F P
0 0 0 r
s
.736 .233 .102 r
.46334 .64206 m .45719 .64021 L .4378 .64002 L p F P
0 0 0 r
s
.378 .084 .035 r
.55324 .36273 m .53592 .35594 L .53214 .349 L p F P
0 0 0 r
s
.378 .084 .035 r
.51647 .34282 m .53214 .349 L .53592 .35594 L p F P
0 0 0 r
s
.83 .24 .1 r
.51334 .34257 m
.5219 .34649 L
s
.061 .089 .214 r
.35252 .46448 m .36241 .45234 L .36289 .47256 L p F P
0 0 0 r
s
.24 .35 .67 r
.35258 .46664 m
.35363 .46535 L
s
.36246 .45452 m
.36384 .45283 L
s
.061 .089 .214 r
.36289 .47256 m .35303 .48447 L .35252 .46448 L p F P
0 0 0 r
s
.041 .06 .137 r
.36544 .4337 m .37533 .4214 L .3725 .43995 L p F P
0 0 0 r
s
.041 .06 .137 r
.3725 .43995 m .36241 .45234 L .36544 .4337 L p F P
0 0 0 r
s
.24 .35 .67 r
.36384 .45283 m
.36442 .44987 L
s
.83 .24 .1 r
.75663 .57479 m
.76386 .5435 L
s
.72787 .53049 m
.76386 .5435 L
s
.895 .274 .118 r
.4877 .64942 m .49373 .65124 L .49678 .64246 L p F P
0 0 0 r
s
.83 .24 .1 r
.49423 .64981 m
.49473 .64997 L
s
.895 .274 .118 r
.49987 .6434 m .49678 .64246 L .49373 .65124 L p F P
0 0 0 r
s
.254 .059 .024 r
.4847 .3303 m .46859 .32396 L .47303 .32448 L p F P
0 0 0 r
s
.254 .059 .024 r
.45909 .31899 m .47303 .32448 L .46859 .32396 L p F P
0 0 0 r
s
.24 .35 .67 r
.46329 .32064 m
.46346 .32042 L
s
.309 .47 .901 r
.54272 .63625 m .53907 .63948 L .55679 .63896 L p F P
0 0 0 r
s
.309 .47 .901 r
.55679 .63896 m .56217 .63425 L .54272 .63625 L p F P
0 0 0 r
s
.791 .213 .087 r
.69639 .45851 m .67784 .45146 L .67393 .43282 L p F P
0 0 0 r
s
.83 .24 .1 r
.69411 .45764 m
.69435 .45894 L
s
.791 .213 .087 r
.65556 .42574 m .67393 .43282 L .67784 .45146 L p F P
0 0 0 r
s
.301 .46 .871 r
.57308 .62471 m .5676 .6295 L .58675 .62278 L p F P
0 0 0 r
s
.301 .46 .871 r
.58675 .62278 m .5939 .61659 L .57308 .62471 L p F P
0 0 0 r
s
.24 .35 .67 r
.73623 .37547 m
.72056 .34882 L
s
.72056 .34882 m
.74765 .32222 L
s
.686 .18 .072 r
.65556 .42574 m .63699 .41858 L .63046 .40251 L p F P
0 0 0 r
s
.686 .18 .072 r
.61254 .39553 m .63046 .40251 L .63699 .41858 L p F P
0 0 0 r
s
.518 .171 .076 r
.41061 .63186 m .40146 .62911 L .37353 .62227 L p F P
0 0 0 r
s
.24 .35 .67 r
.38785 .63104 m
.41387 .65022 L
s
.36812 .65126 m
.38785 .63104 L
s
.233 .345 .699 r
.37353 .62227 m .37945 .61607 L .40619 .62431 L p F P
0 0 0 r
s
.83 .24 .1 r
.37971 .62171 m
.38019 .62189 L
s
.233 .345 .699 r
.40619 .62431 m .40146 .62911 L .37353 .62227 L p F P
0 0 0 r
s
.24 .35 .67 r
.38133 .62436 m
.38785 .63104 L
s
.38785 .63104 m
.3919 .62688 L
s
.895 .274 .118 r
.48164 .64759 m .4877 .64942 L .49368 .64152 L p F P
0 0 0 r
s
.83 .24 .1 r
.48867 .64813 m
.48918 .64829 L
s
.895 .274 .118 r
.49678 .64246 m .49368 .64152 L .4877 .64942 L p F P
0 0 0 r
s
.83 .24 .1 r
.29097 .5946 m
.33194 .60691 L
s
.33194 .60691 m
.34217 .61062 L
s
.58637 .64408 m
.62402 .65584 L
s
.62402 .65584 m
.64159 .63537 L
s
.736 .233 .102 r
.41972 .63459 m .42879 .63731 L .45102 .63835 L p F P
0 0 0 r
s
.83 .24 .1 r
.40197 .62858 m
.42265 .6348 L
s
.736 .233 .102 r
.45719 .64021 m .45102 .63835 L .42879 .63731 L p F P
0 0 0 r
s
.83 .24 .1 r
.64159 .63537 m
.67862 .64722 L
s
.67862 .64722 m
.69509 .62209 L
s
.305 .461 .894 r
.51633 .63969 m .51452 .64133 L .52828 .64906 L p F P
0 0 0 r
s
.305 .461 .894 r
.52828 .64906 m .53185 .64589 L .51633 .63969 L p F P
0 0 0 r
s
.83 .24 .1 r
.52204 .65185 m
.53072 .64725 L
s
.53072 .64725 m
.56888 .65894 L
s
.30371 .26677 m
.29234 .27585 L
s
.25091 .25977 m
.29234 .27585 L
s
.70929 .59319 m
.7456 .60554 L
s
.7456 .60554 m
.75663 .57479 L
s
.72043 .56209 m
.75663 .57479 L
s
.895 .274 .118 r
.47556 .64575 m .48164 .64759 L .49058 .64057 L p F P
0 0 0 r
s
.83 .24 .1 r
.47581 .64425 m
.47801 .64491 L
s
.48309 .64645 m
.4836 .6466 L
s
.47236 .64479 m
.47581 .64425 L
s
.895 .274 .118 r
.49368 .64152 m .49058 .64057 L .48164 .64759 L p F P
0 0 0 r
s
.24 .35 .67 r
.54751 .27368 m
.57123 .2455 L
s
.54751 .27368 m
.52192 .2725 L
s
.83 .24 .1 r
.72787 .53049 m
.73125 .50014 L
s
.525 .13 .05 r
.59442 .38847 m .57611 .38134 L .57039 .36946 L p F P
0 0 0 r
s
.525 .13 .05 r
.55324 .36273 m .57039 .36946 L .57611 .38134 L p F P
0 0 0 r
s
.378 .084 .035 r
.53592 .35594 m .51842 .34907 L .51647 .34282 L p F P
0 0 0 r
s
.378 .084 .035 r
.50066 .33659 m .51647 .34282 L .51842 .34907 L p F P
0 0 0 r
s
.24 .35 .67 r
.62592 .26427 m
.65123 .23589 L
s
.62592 .26427 m
.59841 .25242 L
s
.254 .059 .024 r
.46859 .32396 m .45233 .31755 L .45909 .31899 L p F P
0 0 0 r
s
.24 .35 .67 r
.46346 .32042 m
.47624 .30464 L
s
.024 .035 .067 r
.40821 .36898 m .41755 .35728 L .41079 .36827 L p F P
0 0 0 r
s
.24 .35 .67 r
.41427 .3676 m
.43498 .34175 L
s
.024 .035 .067 r
.41079 .36827 m .40076 .38082 L .40821 .36898 L p F P
0 0 0 r
s
.024 .035 .067 r
.63868 .58263 m .62966 .59041 L .64729 .57472 L p F P
0 0 0 r
s
.024 .035 .067 r
.64729 .57472 m .65768 .56575 L .63868 .58263 L p F P
0 0 0 r
s
.24 .35 .67 r
.63038 .58725 m
.65546 .56557 L
s
.736 .233 .102 r
.41061 .63186 m .41972 .63459 L .44484 .63648 L p F P
0 0 0 r
s
.736 .233 .102 r
.45102 .63835 m .44484 .63648 L .41972 .63459 L p F P
0 0 0 r
s
.862 .236 .097 r
.71399 .48545 m .69571 .47861 L .69639 .45851 L p F P
0 0 0 r
s
.24 .35 .67 r
.71344 .46499 m
.72581 .45384 L
s
.862 .236 .097 r
.67784 .45146 m .69639 .45851 L .69571 .47861 L p F P
0 0 0 r
s
.273 .421 .783 r
.60845 .60398 m .60113 .61032 L .62077 .59808 L p F P
0 0 0 r
s
.273 .421 .783 r
.62077 .59808 m .62966 .59041 L .60845 .60398 L p F P
0 0 0 r
s
.24 .35 .67 r
.6163 .59896 m
.63038 .58725 L
s
.309 .47 .901 r
.54638 .63299 m .54272 .63625 L .56217 .63425 L p F P
0 0 0 r
s
.309 .47 .901 r
.56217 .63425 m .5676 .6295 L .54638 .63299 L p F P
0 0 0 r
s
.305 .461 .894 r
.51815 .63805 m .51633 .63969 L .53185 .64589 L p F P
0 0 0 r
s
.305 .461 .894 r
.53185 .64589 m .53545 .64269 L .51815 .63805 L p F P
0 0 0 r
s
.192 .282 .584 r
.35262 .57399 m .36064 .565 L .37745 .58198 L p F P
0 0 0 r
s
.24 .35 .67 r
.35308 .5744 m
.35327 .5742 L
s
.192 .282 .584 r
.37745 .58198 m .37026 .58977 L .35262 .57399 L p F P
0 0 0 r
s
.895 .274 .118 r
.46946 .64391 m .47556 .64575 L .48747 .63962 L p F P
0 0 0 r
s
.895 .274 .118 r
.49058 .64057 m .48747 .63962 L .47556 .64575 L p F P
0 0 0 r
s
.24 .35 .67 r
.46316 .64408 m
.49181 .65271 L
s
.024 .035 .067 r
.66824 .55664 m .65768 .56575 L .6724 .54742 L p F P
0 0 0 r
s
.24 .35 .67 r
.65546 .56557 m
.66723 .54698 L
s
.024 .035 .067 r
.6724 .54742 m .68409 .53729 L .66824 .55664 L p F P
0 0 0 r
s
.83 .24 .1 r
.44609 .31682 m
.43614 .31217 L
s
.39622 .29645 m
.43614 .31217 L
s
.213 .315 .645 r
.36318 .59745 m .37026 .58977 L .39149 .60345 L p F P
0 0 0 r
s
.213 .315 .645 r
.39149 .60345 m .38544 .60979 L .36318 .59745 L p F P
0 0 0 r
s
.83 .24 .1 r
.20068 .55963 m
.24282 .57238 L
s
.24282 .57238 m
.24907 .582 L
s
.166 .243 .512 r
.34762 .54659 m .35643 .53644 L .3688 .55588 L p F P
0 0 0 r
s
.166 .243 .512 r
.3688 .55588 m .36064 .565 L .34762 .54659 L p F P
0 0 0 r
s
.791 .213 .087 r
.67784 .45146 m .65908 .44432 L .65556 .42574 L p F P
0 0 0 r
s
.791 .213 .087 r
.63699 .41858 m .65556 .42574 L .65908 .44432 L p F P
0 0 0 r
s
.686 .18 .072 r
.63699 .41858 m .6182 .41134 L .61254 .39553 L p F P
0 0 0 r
s
.686 .18 .072 r
.59442 .38847 m .61254 .39553 L .6182 .41134 L p F P
0 0 0 r
s
.301 .46 .871 r
.57861 .61987 m .57308 .62471 L .5939 .61659 L p F P
0 0 0 r
s
.301 .46 .871 r
.5939 .61659 m .60113 .61032 L .57861 .61987 L p F P
0 0 0 r
s
.024 .036 .069 r
.69598 .52697 m .68409 .53729 L .69502 .51726 L p F P
0 0 0 r
s
.024 .036 .069 r
.69502 .51726 m .70773 .50613 L .69598 .52697 L p F P
0 0 0 r
s
.266 .404 .736 r
.43478 .33949 m .44348 .32861 L .43673 .33323 L p F P
0 0 0 r
s
.266 .404 .736 r
.43673 .33323 m .42705 .34536 L .43478 .33949 L p F P
0 0 0 r
s
.233 .345 .699 r
.37945 .61607 m .38544 .60979 L .41096 .61947 L p F P
0 0 0 r
s
.233 .345 .699 r
.41096 .61947 m .40619 .62431 L .37945 .61607 L p F P
0 0 0 r
s
.83 .24 .1 r
.38019 .62189 m
.38287 .62284 L
s
.38287 .62284 m
.39093 .62527 L
s
.895 .274 .118 r
.46334 .64206 m .46946 .64391 L .48435 .63867 L p F P
0 0 0 r
s
.83 .24 .1 r
.47189 .64306 m
.4724 .64321 L
s
.895 .274 .118 r
.48747 .63962 m .48435 .63867 L .46946 .64391 L p F P
0 0 0 r
s
.736 .233 .102 r
.40146 .62911 m .41061 .63186 L .43863 .6346 L p F P
0 0 0 r
s
.83 .24 .1 r
.42681 .63404 m
.42896 .63366 L
s
.736 .233 .102 r
.44484 .63648 m .43863 .6346 L .41061 .63186 L p F P
0 0 0 r
s
.24 .35 .67 r
.41387 .65022 m
.42818 .63616 L
s
.74729 .40257 m
.73623 .37547 L
s
.73623 .37547 m
.7638 .34922 L
s
.136 .196 .427 r
.3479 .51634 m .35733 .5052 L .3654 .52611 L p F P
0 0 0 r
s
.136 .196 .427 r
.3654 .52611 m .35643 .53644 L .3479 .51634 L p F P
0 0 0 r
s
.911 .252 .104 r
.69571 .47861 m .71399 .48545 L .70773 .50613 L p F P
0 0 0 r
s
.24 .35 .67 r
.71176 .49108 m
.72582 .47866 L
s
.83 .24 .1 r
.7123 .49311 m
.73125 .50014 L
s
.71173 .4929 m
.7123 .49311 L
s
.24 .35 .67 r
.71101 .49175 m
.71176 .49108 L
s
.69913 .50225 m
.70411 .49784 L
s
.024 .035 .067 r
.39091 .39314 m .40076 .38082 L .3957 .39608 L p F P
0 0 0 r
s
.024 .035 .067 r
.3957 .39608 m .38541 .40886 L .39091 .39314 L p F P
0 0 0 r
s
.305 .461 .894 r
.51998 .6364 m .51815 .63805 L .53545 .64269 L p F P
0 0 0 r
s
.305 .461 .894 r
.53545 .64269 m .53907 .63948 L .51998 .6364 L p F P
0 0 0 r
s
.24 .35 .67 r
.75321 .42913 m
.72581 .45384 L
s
.72582 .47866 m
.72581 .45384 L
s
.098 .139 .32 r
.35303 .48447 m .36289 .47256 L .36694 .49384 L p F P
0 0 0 r
s
.098 .139 .32 r
.36694 .49384 m .35733 .5052 L .35303 .48447 L p F P
0 0 0 r
s
.895 .274 .118 r
.45719 .64021 m .46334 .64206 L .48123 .63772 L p F P
0 0 0 r
s
.83 .24 .1 r
.46626 .64136 m
.46677 .64151 L
s
.895 .274 .118 r
.48435 .63867 m .48123 .63772 L .46334 .64206 L p F P
0 0 0 r
s
.378 .084 .035 r
.51842 .34907 m .50074 .34213 L .50066 .33659 L p F P
0 0 0 r
s
.378 .084 .035 r
.4847 .3303 m .50066 .33659 L .50074 .34213 L p F P
0 0 0 r
s
.83 .24 .1 r
.48574 .33242 m
.48967 .33397 L
s
.47517 .32754 m
.48574 .33242 L
s
.35538 .28037 m
.34482 .28288 L
s
.30371 .26677 m
.34482 .28288 L
s
.525 .13 .05 r
.57611 .38134 m .55759 .37413 L .55324 .36273 L p F P
0 0 0 r
s
.525 .13 .05 r
.53592 .35594 m .55324 .36273 L .55759 .37413 L p F P
0 0 0 r
s
.83 .24 .1 r
.34217 .61062 m
.38287 .62284 L
s
.38287 .62284 m
.396 .62012 L
s
.309 .47 .901 r
.55007 .62972 m .54638 .63299 L .5676 .6295 L p F P
0 0 0 r
s
.309 .47 .901 r
.5676 .6295 m .57308 .62471 L .55007 .62972 L p F P
0 0 0 r
s
.041 .06 .137 r
.37533 .4214 m .38541 .40886 L .38279 .42731 L p F P
0 0 0 r
s
.041 .06 .137 r
.38279 .42731 m .3725 .43995 L .37533 .4214 L p F P
0 0 0 r
s
.061 .089 .214 r
.36241 .45234 m .3725 .43995 L .37294 .46042 L p F P
0 0 0 r
s
.061 .089 .214 r
.37294 .46042 m .36289 .47256 L .36241 .45234 L p F P
0 0 0 r
s
.736 .233 .102 r
.43863 .6346 m .43239 .63272 L .40146 .62911 L p F P
0 0 0 r
s
.24 .35 .67 r
.42818 .63616 m
.43114 .63326 L
s
.25 .373 .748 r
.40146 .62911 m .40619 .62431 L .43573 .62945 L p F P
0 0 0 r
s
.25 .373 .748 r
.43573 .62945 m .43239 .63272 L .40146 .62911 L p F P
0 0 0 r
s
.83 .24 .1 r
.65794 .60985 m
.69509 .62209 L
s
.69509 .62209 m
.70929 .59319 L
s
.51516 .64249 m
.53072 .64725 L
s
.15549 .53149 m
.15757 .54658 L
s
.862 .236 .097 r
.69571 .47861 m .67723 .4717 L .67784 .45146 L p F P
0 0 0 r
s
.862 .236 .097 r
.65908 .44432 m .67784 .45146 L .67723 .4717 L p F P
0 0 0 r
s
.83 .24 .1 r
.65742 .44491 m
.66016 .44595 L
s
.895 .274 .118 r
.45102 .63835 m .45719 .64021 L .47811 .63677 L p F P
0 0 0 r
s
.83 .24 .1 r
.46061 .63965 m
.46112 .6398 L
s
.895 .274 .118 r
.48123 .63772 m .47811 .63677 L .45719 .64021 L p F P
0 0 0 r
s
.24 .35 .67 r
.47624 .30464 m
.49871 .27689 L
s
.47624 .30464 m
.45652 .31487 L
s
.83 .24 .1 r
.72043 .56209 m
.72787 .53049 L
s
.305 .461 .894 r
.52181 .63474 m .51998 .6364 L .53907 .63948 L p F P
0 0 0 r
s
.305 .461 .894 r
.53907 .63948 m .54272 .63625 L .52181 .63474 L p F P
0 0 0 r
s
.24 .35 .67 r
.54082 .63611 m
.54227 .63482 L
s
.54227 .63482 m
.54468 .6345 L
s
.686 .18 .072 r
.6182 .41134 m .5992 .40402 L .59442 .38847 L p F P
0 0 0 r
s
.686 .18 .072 r
.57611 .38134 m .59442 .38847 L .5992 .40402 L p F P
0 0 0 r
s
.791 .213 .087 r
.65908 .44432 m .6401 .43711 L .63699 .41858 L p F P
0 0 0 r
s
.83 .24 .1 r
.6572 .44361 m
.65742 .44491 L
s
.791 .213 .087 r
.6182 .41134 m .63699 .41858 L .6401 .43711 L p F P
0 0 0 r
s
.273 .421 .783 r
.61586 .59756 m .60845 .60398 L .62966 .59041 L p F P
0 0 0 r
s
.273 .421 .783 r
.62966 .59041 m .63868 .58263 L .61586 .59756 L p F P
0 0 0 r
s
.295 .444 .868 r
.50912 .64622 m .51091 .6446 L .5 .62969 L closepath p F P
0 0 0 r
s
.976 .293 .126 r
.5 .62969 m .50604 .64528 L .50912 .64622 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.49181 .65271 m
.49867 .64645 L
s
.301 .46 .871 r
.58419 .61499 m .57861 .61987 L .60113 .61032 L p F P
0 0 0 r
s
.301 .46 .871 r
.60113 .61032 m .60845 .60398 L .58419 .61499 L p F P
0 0 0 r
s
.213 .315 .645 r
.37026 .58977 m .37745 .58198 L .39762 .59702 L p F P
0 0 0 r
s
.213 .315 .645 r
.39762 .59702 m .39149 .60345 L .37026 .58977 L p F P
0 0 0 r
s
.895 .274 .118 r
.44484 .63648 m .45102 .63835 L .47497 .63582 L p F P
0 0 0 r
s
.83 .24 .1 r
.45494 .63793 m
.45545 .63809 L
s
.895 .274 .118 r
.47811 .63677 m .47497 .63582 L .45102 .63835 L p F P
0 0 0 r
s
.024 .035 .067 r
.64782 .57475 m .63868 .58263 L .65768 .56575 L p F P
0 0 0 r
s
.024 .035 .067 r
.65768 .56575 m .66824 .55664 L .64782 .57475 L p F P
0 0 0 r
s
.233 .345 .699 r
.38544 .60979 m .39149 .60345 L .41578 .61459 L p F P
0 0 0 r
s
.233 .345 .699 r
.41578 .61459 m .41096 .61947 L .38544 .60979 L p F P
0 0 0 r
s
.24 .35 .67 r
.59841 .25242 m
.62337 .22356 L
s
.59841 .25242 m
.57123 .2455 L
s
.976 .293 .126 r
.5 .62969 m .50296 .64434 L .50604 .64528 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.49867 .64645 m
.50078 .64452 L
s
.83 .24 .1 r
.24907 .582 m
.29097 .5946 L
s
.29097 .5946 m
.30054 .59811 L
s
.192 .282 .584 r
.36064 .565 m .3688 .55588 L .38473 .57409 L p F P
0 0 0 r
s
.24 .35 .67 r
.36109 .56545 m
.36128 .56524 L
s
.192 .282 .584 r
.38473 .57409 m .37745 .58198 L .36064 .565 L p F P
0 0 0 r
s
.83 .24 .1 r
.58637 .64408 m
.6037 .62323 L
s
.024 .035 .067 r
.41755 .35728 m .42705 .34536 L .42101 .35547 L p F P
0 0 0 r
s
.024 .035 .067 r
.42101 .35547 m .41079 .36827 L .41755 .35728 L p F P
0 0 0 r
s
.24 .35 .67 r
.4196 .35742 m
.43498 .34175 L
s
.295 .444 .868 r
.51091 .6446 m .51271 .64297 L .5 .62969 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.6037 .62323 m
.64159 .63537 L
s
.64159 .63537 m
.65794 .60985 L
s
.378 .084 .035 r
.50074 .34213 m .48287 .33512 L .4847 .3303 L p F P
0 0 0 r
s
.378 .084 .035 r
.46859 .32396 m .4847 .3303 L .48287 .33512 L p F P
0 0 0 r
s
.83 .24 .1 r
.26164 .25029 m
.25091 .25977 L
s
.911 .252 .104 r
.70773 .50613 m .68996 .49961 L .69571 .47861 L p F P
0 0 0 r
s
.83 .24 .1 r
.69463 .47821 m
.69469 .48235 L
s
.911 .252 .104 r
.67723 .4717 m .69571 .47861 L .68996 .49961 L p F P
0 0 0 r
s
.976 .293 .126 r
.5 .62969 m .49987 .6434 L .50296 .64434 L closepath p F P
0 0 0 r
s
.309 .47 .901 r
.55378 .62643 m .55007 .62972 L .57308 .62471 L p F P
0 0 0 r
s
.309 .47 .901 r
.57308 .62471 m .57861 .61987 L .55378 .62643 L p F P
0 0 0 r
s
.895 .274 .118 r
.43863 .6346 m .44484 .63648 L .47184 .63486 L p F P
0 0 0 r
s
.83 .24 .1 r
.44925 .63621 m
.44977 .63637 L
s
.895 .274 .118 r
.47497 .63582 m .47184 .63486 L .44484 .63648 L p F P
0 0 0 r
s
.24 .35 .67 r
.44827 .63648 m
.46316 .64408 L
s
.44527 .63495 m
.44827 .63648 L
s
.46316 .64408 m
.47198 .63575 L
s
.024 .035 .067 r
.67897 .54738 m .66824 .55664 L .68409 .53729 L p F P
0 0 0 r
s
.024 .035 .067 r
.68409 .53729 m .69598 .52697 L .67897 .54738 L p F P
0 0 0 r
s
.25 .373 .748 r
.40619 .62431 m .41096 .61947 L .43909 .62615 L p F P
0 0 0 r
s
.25 .373 .748 r
.43909 .62615 m .43573 .62945 L .40619 .62431 L p F P
0 0 0 r
s
.525 .13 .05 r
.55759 .37413 m .53887 .36683 L .53592 .35594 L p F P
0 0 0 r
s
.525 .13 .05 r
.51842 .34907 m .53592 .35594 L .53887 .36683 L p F P
0 0 0 r
s
.305 .461 .894 r
.52364 .63308 m .52181 .63474 L .54272 .63625 L p F P
0 0 0 r
s
.305 .461 .894 r
.54272 .63625 m .54638 .63299 L .52364 .63308 L p F P
0 0 0 r
s
.83 .24 .1 r
.67215 .58056 m
.70929 .59319 L
s
.70929 .59319 m
.72043 .56209 L
s
.976 .293 .126 r
.5 .62969 m .49678 .64246 L .49987 .6434 L closepath p F P
0 0 0 r
s
.266 .404 .736 r
.44348 .32861 m .45233 .31755 L .44658 .32088 L p F P
0 0 0 r
s
.266 .404 .736 r
.44658 .32088 m .43673 .33323 L .44348 .32861 L p F P
0 0 0 r
s
.83 .24 .1 r
.6834 .54909 m
.72043 .56209 L
s
.166 .243 .512 r
.35643 .53644 m .3654 .52611 L .3771 .5466 L p F P
0 0 0 r
s
.166 .243 .512 r
.3771 .5466 m .3688 .55588 L .35643 .53644 L p F P
0 0 0 r
s
.295 .444 .868 r
.51271 .64297 m .51452 .64133 L .5 .62969 L closepath p F P
0 0 0 r
s
.976 .293 .126 r
.5 .62969 m .49368 .64152 L .49678 .64246 L closepath p F P
0 0 0 r
s
.895 .274 .118 r
.43239 .63272 m .43863 .6346 L .46869 .6339 L p F P
0 0 0 r
s
.83 .24 .1 r
.43636 .63232 m
.43834 .63292 L
s
.44355 .63449 m
.44406 .63465 L
s
.43385 .63277 m
.43636 .63232 L
s
.895 .274 .118 r
.47184 .63486 m .46869 .6339 L .43863 .6346 L p F P
0 0 0 r
s
.24 .35 .67 r
.72754 .29655 m
.70422 .27308 L
s
.70422 .27308 m
.73139 .24454 L
s
.70422 .27308 m
.67849 .25262 L
s
.947 .265 .11 r
.68996 .49961 m .70773 .50613 L .69598 .52697 L p F P
0 0 0 r
s
.24 .35 .67 r
.66723 .54698 m
.69315 .5244 L
s
.69315 .5244 m
.6944 .51978 L
s
.83 .24 .1 r
.69973 .52032 m
.72787 .53049 L
s
.862 .236 .097 r
.67723 .4717 m .65853 .46471 L .65908 .44432 L p F P
0 0 0 r
s
.862 .236 .097 r
.6401 .43711 m .65908 .44432 L .65853 .46471 L p F P
0 0 0 r
s
.83 .24 .1 r
.42381 .62852 m
.42942 .63022 L
s
.43364 .6315 m
.43636 .63232 L
s
.976 .293 .126 r
.5 .62969 m .49058 .64057 L .49368 .64152 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.52192 .2725 m
.54544 .24394 L
s
.52192 .2725 m
.49871 .27689 L
s
.70067 .51785 m
.72012 .50091 L
s
.69913 .51919 m
.70067 .51785 L
s
.69315 .5244 m
.69505 .52274 L
s
.295 .444 .868 r
.51452 .64133 m .51633 .63969 L .5 .62969 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.75321 .42913 m
.74729 .40257 L
s
.74729 .40257 m
.77535 .37662 L
s
.74765 .32222 m
.72754 .29655 L
s
.72754 .29655 m
.7552 .26846 L
s
.83 .24 .1 r
.40551 .30085 m
.39622 .29645 L
s
.35538 .28037 m
.39622 .29645 L
s
.136 .196 .427 r
.35733 .5052 m .36694 .49384 L .37454 .51559 L p F P
0 0 0 r
s
.136 .196 .427 r
.37454 .51559 m .3654 .52611 L .35733 .5052 L p F P
0 0 0 r
s
.83 .24 .1 r
.15757 .54658 m
.20068 .55963 L
s
.20068 .55963 m
.20619 .56911 L
s
.686 .18 .072 r
.5992 .40402 m .57998 .39661 L .57611 .38134 L p F P
0 0 0 r
s
.686 .18 .072 r
.55759 .37413 m .57611 .38134 L .57998 .39661 L p F P
0 0 0 r
s
.976 .293 .126 r
.5 .62969 m .48747 .63962 L .49058 .64057 L closepath p F P
0 0 0 r
s
.024 .035 .067 r
.40076 .38082 m .41079 .36827 L .4062 .38303 L p F P
0 0 0 r
s
.24 .35 .67 r
.40066 .38112 m
.40086 .38087 L
s
.4107 .36856 m
.4196 .35742 L
s
.024 .035 .067 r
.4062 .38303 m .3957 .39608 L .40076 .38082 L p F P
0 0 0 r
s
.791 .213 .087 r
.6401 .43711 m .62091 .42981 L .6182 .41134 L p F P
0 0 0 r
s
.791 .213 .087 r
.5992 .40402 m .6182 .41134 L .62091 .42981 L p F P
0 0 0 r
s
.305 .461 .894 r
.52548 .63142 m .52364 .63308 L .54638 .63299 L p F P
0 0 0 r
s
.305 .461 .894 r
.54638 .63299 m .55007 .62972 L .52548 .63142 L p F P
0 0 0 r
s
.83 .24 .1 r
.53072 .64725 m
.54785 .63205 L
s
.54785 .63205 m
.58637 .64408 L
s
.895 .274 .118 r
.46869 .6339 m .46554 .63294 L .43239 .63272 L p F P
0 0 0 r
s
.267 .399 .792 r
.43239 .63272 m .43573 .62945 L .46729 .63128 L p F P
0 0 0 r
s
.267 .399 .792 r
.46729 .63128 m .46554 .63294 L .43239 .63272 L p F P
0 0 0 r
s
.301 .46 .871 r
.58982 .61007 m .58419 .61499 L .60845 .60398 L p F P
0 0 0 r
s
.24 .35 .67 r
.60261 .60589 m
.60959 .60299 L
s
.301 .46 .871 r
.60845 .60398 m .61586 .59756 L .58982 .61007 L p F P
0 0 0 r
s
.295 .444 .868 r
.51633 .63969 m .51815 .63805 L .5 .62969 L closepath p F P
0 0 0 r
s
.976 .293 .126 r
.5 .62969 m .48435 .63867 L .48747 .63962 L closepath p F P
0 0 0 r
s
.378 .084 .035 r
.48287 .33512 m .46482 .32804 L .46859 .32396 L p F P
0 0 0 r
s
.378 .084 .035 r
.45233 .31755 m .46859 .32396 L .46482 .32804 L p F P
0 0 0 r
s
.83 .24 .1 r
.45118 .31882 m
.45619 .32079 L
s
.309 .47 .901 r
.55752 .62311 m .55378 .62643 L .57861 .61987 L p F P
0 0 0 r
s
.309 .47 .901 r
.57861 .61987 m .58419 .61499 L .55752 .62311 L p F P
0 0 0 r
s
.233 .345 .699 r
.39149 .60345 m .39762 .59702 L .42064 .60966 L p F P
0 0 0 r
s
.233 .345 .699 r
.42064 .60966 m .41578 .61459 L .39149 .60345 L p F P
0 0 0 r
s
.24 .35 .67 r
.67849 .25262 m
.70522 .22359 L
s
.67849 .25262 m
.65123 .23589 L
s
.098 .139 .32 r
.36289 .47256 m .37294 .46042 L .37673 .48227 L p F P
0 0 0 r
s
.098 .139 .32 r
.37673 .48227 m .36694 .49384 L .36289 .47256 L p F P
0 0 0 r
s
.273 .421 .783 r
.62335 .59106 m .61586 .59756 L .63868 .58263 L p F P
0 0 0 r
s
.273 .421 .783 r
.63868 .58263 m .64782 .57475 L .62335 .59106 L p F P
0 0 0 r
s
.25 .373 .748 r
.41096 .61947 m .41578 .61459 L .44247 .62284 L p F P
0 0 0 r
s
.25 .373 .748 r
.44247 .62284 m .43909 .62615 L .41096 .61947 L p F P
0 0 0 r
s
.976 .293 .126 r
.5 .62969 m .48123 .63772 L .48435 .63867 L closepath p F P
0 0 0 r
s
.911 .252 .104 r
.68996 .49961 m .67199 .49302 L .67723 .4717 L p F P
0 0 0 r
s
.911 .252 .104 r
.65853 .46471 m .67723 .4717 L .67199 .49302 L p F P
0 0 0 r
s
.041 .06 .137 r
.38541 .40886 m .3957 .39608 L .39329 .41442 L p F P
0 0 0 r
s
.041 .06 .137 r
.39329 .41442 m .38279 .42731 L .38541 .40886 L p F P
0 0 0 r
s
.24 .35 .67 r
.38403 .42808 m
.38459 .4251 L
s
.213 .315 .645 r
.37745 .58198 m .38473 .57409 L .40382 .59052 L p F P
0 0 0 r
s
.213 .315 .645 r
.40382 .59052 m .39762 .59702 L .37745 .58198 L p F P
0 0 0 r
s
.525 .13 .05 r
.53887 .36683 m .51994 .35946 L .51842 .34907 L p F P
0 0 0 r
s
.525 .13 .05 r
.50074 .34213 m .51842 .34907 L .51994 .35946 L p F P
0 0 0 r
s
.061 .089 .214 r
.3725 .43995 m .38279 .42731 L .3832 .44803 L p F P
0 0 0 r
s
.24 .35 .67 r
.37255 .44216 m
.37364 .44082 L
s
.38283 .42955 m
.38403 .42808 L
s
.061 .089 .214 r
.3832 .44803 m .37294 .46042 L .3725 .43995 L p F P
0 0 0 r
s
.295 .444 .868 r
.51815 .63805 m .51998 .6364 L .5 .62969 L closepath p F P
0 0 0 r
s
.976 .293 .126 r
.5 .62969 m .47811 .63677 L .48123 .63772 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.7638 .34922 m
.74765 .32222 L
s
.74765 .32222 m
.77582 .29455 L
s
.83 .24 .1 r
.31359 .26392 m
.30371 .26677 L
s
.26164 .25029 m
.30371 .26677 L
s
.305 .461 .894 r
.52733 .62975 m .52548 .63142 L .55007 .62972 L p F P
0 0 0 r
s
.305 .461 .894 r
.55007 .62972 m .55378 .62643 L .52733 .62975 L p F P
0 0 0 r
s
.024 .035 .067 r
.65709 .56675 m .64782 .57475 L .66824 .55664 L p F P
0 0 0 r
s
.024 .035 .067 r
.66824 .55664 m .67897 .54738 L .65709 .56675 L p F P
0 0 0 r
s
.267 .399 .792 r
.43573 .62945 m .43909 .62615 L .46905 .62961 L p F P
0 0 0 r
s
.267 .399 .792 r
.46905 .62961 m .46729 .63128 L .43573 .62945 L p F P
0 0 0 r
s
.83 .24 .1 r
.30054 .59811 m
.34217 .61062 L
s
.34217 .61062 m
.35469 .60763 L
s
.976 .293 .126 r
.5 .62969 m .47497 .63582 L .47811 .63677 L closepath p F P
0 0 0 r
s
.295 .444 .868 r
.51998 .6364 m .52181 .63474 L .5 .62969 L closepath p F P
0 0 0 r
s
.192 .282 .584 r
.3688 .55588 m .3771 .5466 L .39213 .56608 L p F P
0 0 0 r
s
.24 .35 .67 r
.36923 .55636 m
.36942 .55615 L
s
.192 .282 .584 r
.39213 .56608 m .38473 .57409 L .3688 .55588 L p F P
0 0 0 r
s
.83 .24 .1 r
.65794 .60985 m
.67215 .58056 L
s
.947 .265 .11 r
.69598 .52697 m .67916 .52093 L .68996 .49961 L p F P
0 0 0 r
s
.947 .265 .11 r
.67199 .49302 m .68996 .49961 L .67916 .52093 L p F P
0 0 0 r
s
.976 .293 .126 r
.5 .62969 m .47184 .63486 L .47497 .63582 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.72012 .50091 m
.72582 .47866 L
s
.72582 .47866 m
.7536 .45411 L
s
.862 .236 .097 r
.65853 .46471 m .63962 .45764 L .6401 .43711 L p F P
0 0 0 r
s
.862 .236 .097 r
.62091 .42981 m .6401 .43711 L .63962 .45764 L p F P
0 0 0 r
s
.83 .24 .1 r
.61963 .43055 m
.62202 .43146 L
s
.024 .035 .067 r
.42705 .34536 m .43673 .33323 L .43143 .34243 L p F P
0 0 0 r
s
.024 .035 .067 r
.43143 .34243 m .42101 .35547 L .42705 .34536 L p F P
0 0 0 r
s
.686 .18 .072 r
.57998 .39661 m .56054 .38912 L .55759 .37413 L p F P
0 0 0 r
s
.686 .18 .072 r
.53887 .36683 m .55759 .37413 L .56054 .38912 L p F P
0 0 0 r
s
.976 .293 .126 r
.5 .62969 m .46869 .6339 L .47184 .63486 L closepath p F P
0 0 0 r
s
.295 .444 .868 r
.52181 .63474 m .52364 .63308 L .5 .62969 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.52087 .63268 m
.52376 .63297 L
s
.378 .084 .035 r
.46482 .32804 m .44658 .32088 L .45233 .31755 L p F P
0 0 0 r
s
.24 .35 .67 r
.43498 .34175 m
.45048 .32241 L
s
.45384 .31821 m
.45652 .31487 L
s
.45373 .31834 m
.45384 .31821 L
s
.83 .24 .1 r
.44609 .31682 m
.45055 .31857 L
s
.309 .47 .901 r
.56128 .61978 m .55752 .62311 L .58419 .61499 L p F P
0 0 0 r
s
.309 .47 .901 r
.58419 .61499 m .58982 .61007 L .56128 .61978 L p F P
0 0 0 r
s
.974 .275 .115 r
.67916 .52093 m .69598 .52697 L .67897 .54738 L p F P
0 0 0 r
s
.83 .24 .1 r
.6834 .54909 m
.68449 .54455 L
s
.68449 .54455 m
.68576 .53923 L
s
.24 .35 .67 r
.68321 .54033 m
.68538 .53686 L
s
.68154 .54301 m
.68321 .54033 L
s
.791 .213 .087 r
.62091 .42981 m .60148 .42243 L .5992 .40402 L p F P
0 0 0 r
s
.83 .24 .1 r
.61944 .42925 m
.61963 .43055 L
s
.791 .213 .087 r
.57998 .39661 m .5992 .40402 L .60148 .42243 L p F P
0 0 0 r
s
.25 .373 .748 r
.41578 .61459 m .42064 .60966 L .44587 .6195 L p F P
0 0 0 r
s
.25 .373 .748 r
.44587 .6195 m .44247 .62284 L .41578 .61459 L p F P
0 0 0 r
s
.83 .24 .1 r
.396 .62012 m
.42381 .62852 L
s
.24 .35 .67 r
.57123 .2455 m
.59592 .21618 L
s
.57123 .2455 m
.54544 .24394 L
s
.976 .293 .126 r
.5 .62969 m .46554 .63294 L .46869 .6339 L closepath p F P
0 0 0 r
s
.305 .461 .894 r
.52918 .62807 m .52733 .62975 L .55378 .62643 L p F P
0 0 0 r
s
.305 .461 .894 r
.55378 .62643 m .55752 .62311 L .52918 .62807 L p F P
0 0 0 r
s
.166 .243 .512 r
.3654 .52611 m .37454 .51559 L .38552 .53717 L p F P
0 0 0 r
s
.166 .243 .512 r
.38552 .53717 m .3771 .5466 L .3654 .52611 L p F P
0 0 0 r
s
.301 .46 .871 r
.5955 .6051 m .58982 .61007 L .61586 .59756 L p F P
0 0 0 r
s
.301 .46 .871 r
.61586 .59756 m .62335 .59106 L .5955 .6051 L p F P
0 0 0 r
s
.267 .399 .792 r
.43909 .62615 m .44247 .62284 L .47081 .62793 L p F P
0 0 0 r
s
.267 .399 .792 r
.47081 .62793 m .46905 .62961 L .43909 .62615 L p F P
0 0 0 r
s
.83 .24 .1 r
.44194 .62896 m
.44357 .62798 L
s
.24 .35 .67 r
.65123 .23589 m
.67756 .20636 L
s
.65123 .23589 m
.62337 .22356 L
s
.83 .24 .1 r
.44609 .31682 m
.44817 .31996 L
s
.40551 .30085 m
.44609 .31682 L
s
.295 .444 .868 r
.52364 .63308 m .52548 .63142 L .5 .62969 L closepath p F P
0 0 0 r
s
.233 .345 .699 r
.39762 .59702 m .40382 .59052 L .42555 .60469 L p F P
0 0 0 r
s
.233 .345 .699 r
.42555 .60469 m .42064 .60966 L .39762 .59702 L p F P
0 0 0 r
s
.282 .422 .833 r
.5 .62969 m .46554 .63294 L .46729 .63128 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.20619 .56911 m
.24907 .582 L
s
.24907 .582 m
.25792 .5853 L
s
.525 .13 .05 r
.51994 .35946 m .5008 .352 L .50074 .34213 L p F P
0 0 0 r
s
.525 .13 .05 r
.48287 .33512 m .50074 .34213 L .5008 .352 L p F P
0 0 0 r
s
.83 .24 .1 r
.53584 .6283 m
.54785 .63205 L
s
.911 .252 .104 r
.67199 .49302 m .65381 .48636 L .65853 .46471 L p F P
0 0 0 r
s
.911 .252 .104 r
.63962 .45764 m .65853 .46471 L .65381 .48636 L p F P
0 0 0 r
s
.24 .35 .67 r
.45652 .31487 m
.47893 .28689 L
s
.45154 .31991 m
.45652 .31487 L
s
.83 .24 .1 r
.67215 .58056 m
.6834 .54909 L
s
.295 .444 .868 r
.52548 .63142 m .52733 .62975 L .5 .62969 L closepath p F P
0 0 0 r
s
.273 .421 .783 r
.63094 .58449 m .62335 .59106 L .64782 .57475 L p F P
0 0 0 r
s
.273 .421 .783 r
.64782 .57475 m .65709 .56675 L .63094 .58449 L p F P
0 0 0 r
s
.24 .35 .67 r
.6404 .57807 m
.65546 .56557 L
s
.83 .24 .1 r
.64996 .57302 m
.67215 .58056 L
s
.64874 .5726 m
.64996 .57302 L
s
.282 .422 .833 r
.5 .62969 m .46729 .63128 L .46905 .62961 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.67884 .54749 m
.6834 .54909 L
s
.136 .196 .427 r
.36694 .49384 m .37673 .48227 L .38384 .50488 L p F P
0 0 0 r
s
.136 .196 .427 r
.38384 .50488 m .37454 .51559 L .36694 .49384 L p F P
0 0 0 r
s
.213 .315 .645 r
.38473 .57409 m .39213 .56608 L .4101 .58394 L p F P
0 0 0 r
s
.213 .315 .645 r
.4101 .58394 m .40382 .59052 L .38473 .57409 L p F P
0 0 0 r
s
.305 .461 .894 r
.53104 .62639 m .52918 .62807 L .55752 .62311 L p F P
0 0 0 r
s
.83 .24 .1 r
.53215 .62715 m
.53584 .6283 L
s
.305 .461 .894 r
.55752 .62311 m .56128 .61978 L .53104 .62639 L p F P
0 0 0 r
s
.024 .035 .067 r
.41079 .36827 m .42101 .35547 L .41691 .36972 L p F P
0 0 0 r
s
.024 .035 .067 r
.41691 .36972 m .4062 .38303 L .41079 .36827 L p F P
0 0 0 r
s
.267 .399 .792 r
.44247 .62284 m .44587 .6195 L .47258 .62625 L p F P
0 0 0 r
s
.267 .399 .792 r
.47258 .62625 m .47081 .62793 L .44247 .62284 L p F P
0 0 0 r
s
.24 .35 .67 r
.77535 .37662 m
.7638 .34922 L
s
.7638 .34922 m
.7925 .32191 L
s
.947 .265 .11 r
.67916 .52093 m .66216 .51483 L .67199 .49302 L p F P
0 0 0 r
s
.947 .265 .11 r
.65381 .48636 m .67199 .49302 L .66216 .51483 L p F P
0 0 0 r
s
.295 .444 .868 r
.52733 .62975 m .52918 .62807 L .5 .62969 L closepath p F P
0 0 0 r
s
.309 .47 .901 r
.56506 .61643 m .56128 .61978 L .58982 .61007 L p F P
0 0 0 r
s
.309 .47 .901 r
.58982 .61007 m .5955 .6051 L .56506 .61643 L p F P
0 0 0 r
s
.282 .422 .833 r
.5 .62969 m .46905 .62961 L .47081 .62793 L closepath p F P
0 0 0 r
s
.862 .236 .097 r
.63962 .45764 m .62048 .45048 L .62091 .42981 L p F P
0 0 0 r
s
.862 .236 .097 r
.60148 .42243 m .62091 .42981 L .62048 .45048 L p F P
0 0 0 r
s
.83 .24 .1 r
.35469 .60763 m
.396 .62012 L
s
.396 .62012 m
.41086 .61054 L
s
.25 .373 .748 r
.42064 .60966 m .42555 .60469 L .44929 .61615 L p F P
0 0 0 r
s
.25 .373 .748 r
.44929 .61615 m .44587 .6195 L .42064 .60966 L p F P
0 0 0 r
s
.686 .18 .072 r
.56054 .38912 m .54087 .38154 L .53887 .36683 L p F P
0 0 0 r
s
.686 .18 .072 r
.51994 .35946 m .53887 .36683 L .54087 .38154 L p F P
0 0 0 r
s
.83 .24 .1 r
.36398 .28451 m
.35538 .28037 L
s
.31359 .26392 m
.35538 .28037 L
s
.24 .35 .67 r
.78173 .40341 m
.75321 .42913 L
s
.7536 .45411 m
.75321 .42913 L
s
.974 .275 .115 r
.67897 .54738 m .66353 .54196 L .67916 .52093 L p F P
0 0 0 r
s
.24 .35 .67 r
.65546 .56557 m
.67721 .54676 L
s
.974 .275 .115 r
.66216 .51483 m .67916 .52093 L .66353 .54196 L p F P
0 0 0 r
s
.83 .24 .1 r
.15757 .54658 m
.1623 .55592 L
s
.098 .139 .32 r
.37294 .46042 m .3832 .44803 L .38672 .47047 L p F P
0 0 0 r
s
.098 .139 .32 r
.38672 .47047 m .37673 .48227 L .37294 .46042 L p F P
0 0 0 r
s
.995 .283 .118 r
.66353 .54196 m .67897 .54738 L .65709 .56675 L p F P
0 0 0 r
s
.24 .35 .67 r
.6783 .54582 m
.68154 .54301 L
s
.67817 .54593 m
.6783 .54582 L
s
.791 .213 .087 r
.60148 .42243 m .58183 .41496 L .57998 .39661 L p F P
0 0 0 r
s
.791 .213 .087 r
.56054 .38912 m .57998 .39661 L .58183 .41496 L p F P
0 0 0 r
s
.295 .444 .868 r
.52918 .62807 m .53104 .62639 L .5 .62969 L closepath p F P
0 0 0 r
s
.282 .422 .833 r
.5 .62969 m .47081 .62793 L .47258 .62625 L closepath p F P
0 0 0 r
s
.041 .06 .137 r
.3957 .39608 m .4062 .38303 L .404 .40125 L p F P
0 0 0 r
s
.041 .06 .137 r
.404 .40125 m .39329 .41442 L .3957 .39608 L p F P
0 0 0 r
s
.192 .282 .584 r
.3771 .5466 m .38552 .53717 L .39963 .55795 L p F P
0 0 0 r
s
.24 .35 .67 r
.37749 .54712 m
.37769 .5469 L
s
.192 .282 .584 r
.39963 .55795 m .39213 .56608 L .3771 .5466 L p F P
0 0 0 r
s
.061 .089 .214 r
.38279 .42731 m .39329 .41442 L .39367 .43539 L p F P
0 0 0 r
s
.061 .089 .214 r
.39367 .43539 m .3832 .44803 L .38279 .42731 L p F P
0 0 0 r
s
.301 .46 .871 r
.60124 .60008 m .5955 .6051 L .62335 .59106 L p F P
0 0 0 r
s
.301 .46 .871 r
.62335 .59106 m .63094 .58449 L .60124 .60008 L p F P
0 0 0 r
s
.83 .24 .1 r
.61993 .59732 m
.65794 .60985 L
s
.6037 .62323 m
.61993 .59732 L
s
.525 .13 .05 r
.5008 .352 m .48144 .34446 L .48287 .33512 L p F P
0 0 0 r
s
.525 .13 .05 r
.46482 .32804 m .48287 .33512 L .48144 .34446 L p F P
0 0 0 r
s
.305 .461 .894 r
.53291 .6247 m .53104 .62639 L .56128 .61978 L p F P
0 0 0 r
s
.305 .461 .894 r
.56128 .61978 m .56506 .61643 L .53291 .6247 L p F P
0 0 0 r
s
.83 .24 .1 r
.54785 .63205 m
.55681 .62092 L
s
.55681 .62092 m
.55862 .61867 L
s
.282 .422 .833 r
.5 .62969 m .4833 .61604 L .4851 .61433 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.49706 .62666 m
.5051 .62915 L
s
.83 .24 .1 r
.49799 .62944 m
.49878 .6287 L
s
.282 .422 .833 r
.5 .62969 m .4851 .61433 L .48692 .6126 L closepath p F P
0 0 0 r
s
.282 .422 .833 r
.5 .62969 m .48692 .6126 L .48874 .61087 L closepath p F P
0 0 0 r
s
.282 .422 .833 r
.5 .62969 m .48874 .61087 L .49056 .60913 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.53166 .62203 m .53478 .62301 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.52853 .62105 m .53166 .62203 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.5254 .62007 m .52853 .62105 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.52226 .61908 m .5254 .62007 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.51912 .61809 m .52226 .61908 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.51597 .61711 m .51912 .61809 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.51281 .61612 m .51597 .61711 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.50965 .61512 m .51281 .61612 L .5 .62969 L closepath p F P
0 0 0 r
s
.282 .422 .833 r
.5 .62969 m .47258 .62625 L .47435 .62456 L closepath p F P
0 0 0 r
s
.282 .422 .833 r
.5 .62969 m .47435 .62456 L .47613 .62287 L closepath p F P
0 0 0 r
s
.282 .422 .833 r
.5 .62969 m .47613 .62287 L .47791 .62117 L closepath p F P
0 0 0 r
s
.282 .422 .833 r
.5 .62969 m .47791 .62117 L .4797 .61947 L closepath p F P
0 0 0 r
s
.282 .422 .833 r
.5 .62969 m .4797 .61947 L .4815 .61776 L closepath p F P
0 0 0 r
s
.282 .422 .833 r
.5 .62969 m .4815 .61776 L .4833 .61604 L closepath p F P
0 0 0 r
s
.295 .444 .868 r
.53291 .6247 m .53478 .62301 L .5 .62969 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.51928 .62764 m
.52042 .6266 L
s
.295 .444 .868 r
.53104 .62639 m .53291 .6247 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.50648 .61413 m .50965 .61512 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.50331 .61313 m .50648 .61413 L .5 .62969 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.49932 .62821 m
.50052 .62709 L
s
1 .3 .128 r
.50013 .61214 m .50331 .61313 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.49695 .61114 m .50013 .61214 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.49376 .61014 m .49695 .61114 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.49056 .60913 m .49376 .61014 L .5 .62969 L closepath p F P
0 0 0 r
s
.267 .399 .792 r
.44587 .6195 m .44929 .61615 L .47435 .62456 L p F P
0 0 0 r
s
.267 .399 .792 r
.47435 .62456 m .47258 .62625 L .44587 .6195 L p F P
0 0 0 r
s
.233 .345 .699 r
.40382 .59052 m .4101 .58394 L .4305 .59967 L p F P
0 0 0 r
s
.233 .345 .699 r
.4305 .59967 m .42555 .60469 L .40382 .59052 L p F P
0 0 0 r
s
.24 .35 .67 r
.49871 .27689 m
.52209 .248 L
s
.49871 .27689 m
.47893 .28689 L
s
.911 .252 .104 r
.65381 .48636 m .63544 .47962 L .63962 .45764 L p F P
0 0 0 r
s
.911 .252 .104 r
.62048 .45048 m .63962 .45764 L .63544 .47962 L p F P
0 0 0 r
s
.024 .035 .067 r
.43673 .33323 m .44658 .32088 L .44206 .32912 L p F P
0 0 0 r
s
.024 .035 .067 r
.44206 .32912 m .43143 .34243 L .43673 .33323 L p F P
0 0 0 r
s
.24 .35 .67 r
.66455 .55711 m
.68154 .54301 L
s
.68154 .54301 m
.70869 .51954 L
s
.83 .24 .1 r
.27081 .24707 m
.26164 .25029 L
s
.309 .47 .901 r
.56886 .61305 m .56506 .61643 L .5955 .6051 L p F P
0 0 0 r
s
.83 .24 .1 r
.57718 .61474 m
.6037 .62323 L
s
.309 .47 .901 r
.5955 .6051 m .60124 .60008 L .56886 .61305 L p F P
0 0 0 r
s
.83 .24 .1 r
.57173 .613 m
.57718 .61474 L
s
.305 .461 .894 r
.53478 .62301 m .53291 .6247 L .56506 .61643 L p F P
0 0 0 r
s
.83 .24 .1 r
.25792 .5853 m
.30054 .59811 L
s
.30054 .59811 m
.31242 .59485 L
s
.267 .399 .792 r
.47613 .62287 m .47435 .62456 L .44929 .61615 L p F P
0 0 0 r
s
.83 .24 .1 r
.45174 .62306 m
.46787 .628 L
s
.44357 .62798 m
.45174 .62306 L
s
.25 .373 .748 r
.42555 .60469 m .4305 .59967 L .45273 .61277 L p F P
0 0 0 r
s
.25 .373 .748 r
.45273 .61277 m .44929 .61615 L .42555 .60469 L p F P
0 0 0 r
s
.24 .35 .67 r
.62337 .22356 m
.64936 .19352 L
s
.62337 .22356 m
.59592 .21618 L
s
.947 .265 .11 r
.66216 .51483 m .64498 .50866 L .65381 .48636 L p F P
0 0 0 r
s
.947 .265 .11 r
.63544 .47962 m .65381 .48636 L .64498 .50866 L p F P
0 0 0 r
s
.166 .243 .512 r
.37454 .51559 m .38384 .50488 L .39409 .52759 L p F P
0 0 0 r
s
.166 .243 .512 r
.39409 .52759 m .38552 .53717 L .37454 .51559 L p F P
0 0 0 r
s
.24 .35 .67 r
.38644 .53615 m
.38675 .53678 L
s
.3859 .53773 m
.38675 .53678 L
s
.305 .461 .894 r
.56506 .61643 m .56886 .61305 L .53478 .62301 L p F P
0 0 0 r
s
.83 .24 .1 r
.61219 .59477 m
.61993 .59732 L
s
.61993 .59732 m
.62336 .59015 L
s
.62336 .59015 m
.62398 .58885 L
s
1 .289 .122 r
.64346 .56207 m .65709 .56675 L .63094 .58449 L p F P
0 0 0 r
s
.24 .35 .67 r
.64826 .5712 m
.64909 .57048 L
s
.995 .283 .118 r
.65709 .56675 m .64346 .56207 L .66353 .54196 L p F P
0 0 0 r
s
.267 .399 .792 r
.44929 .61615 m .45273 .61277 L .47613 .62287 L p F P
0 0 0 r
s
.974 .275 .115 r
.66353 .54196 m .64795 .53649 L .66216 .51483 L p F P
0 0 0 r
s
.974 .275 .115 r
.64498 .50866 m .66216 .51483 L .64795 .53649 L p F P
0 0 0 r
s
.862 .236 .097 r
.62048 .45048 m .60113 .44324 L .60148 .42243 L p F P
0 0 0 r
s
.862 .236 .097 r
.58183 .41496 m .60148 .42243 L .60113 .44324 L p F P
0 0 0 r
s
.83 .24 .1 r
.58096 .41587 m
.58298 .41663 L
s
.995 .283 .118 r
.64795 .53649 m .66353 .54196 L .64346 .56207 L p F P
0 0 0 r
s
.24 .35 .67 r
.64909 .57048 m
.66455 .55711 L
s
.686 .18 .072 r
.54087 .38154 m .52097 .37387 L .51994 .35946 L p F P
0 0 0 r
s
.686 .18 .072 r
.5008 .352 m .51994 .35946 L .52097 .37387 L p F P
0 0 0 r
s
.213 .315 .645 r
.39213 .56608 m .39963 .55795 L .41645 .57729 L p F P
0 0 0 r
s
.24 .35 .67 r
.40536 .56455 m
.40597 .56389 L
s
.213 .315 .645 r
.41645 .57729 m .4101 .58394 L .39213 .56608 L p F P
0 0 0 r
s
1 .301 .128 r
.53478 .62301 m .53166 .62203 L .56274 .61109 L p F P
0 0 0 r
s
1 .301 .128 r
.56274 .61109 m .56886 .61305 L .53478 .62301 L p F P
0 0 0 r
s
.267 .399 .792 r
.47791 .62117 m .47613 .62287 L .45273 .61277 L p F P
0 0 0 r
s
.83 .24 .1 r
.6455 .5358 m
.64715 .52905 L
s
.791 .213 .087 r
.58183 .41496 m .56195 .4074 L .56054 .38912 L p F P
0 0 0 r
s
.83 .24 .1 r
.5808 .41456 m
.58096 .41587 L
s
.791 .213 .087 r
.54087 .38154 m .56054 .38912 L .56195 .4074 L p F P
0 0 0 r
s
1 .301 .128 r
.53166 .62203 m .52853 .62105 L .55659 .60912 L p F P
0 0 0 r
s
1 .301 .128 r
.55659 .60912 m .56274 .61109 L .53166 .62203 L p F P
0 0 0 r
s
.525 .13 .05 r
.48144 .34446 m .46186 .33684 L .46482 .32804 L p F P
0 0 0 r
s
.525 .13 .05 r
.44658 .32088 m .46482 .32804 L .46186 .33684 L p F P
0 0 0 r
s
.267 .399 .792 r
.45273 .61277 m .45619 .60937 L .47791 .62117 L p F P
0 0 0 r
s
.267 .399 .792 r
.4797 .61947 m .47791 .62117 L .45619 .60937 L p F P
0 0 0 r
s
1 .301 .128 r
.52853 .62105 m .5254 .62007 L .55043 .60715 L p F P
0 0 0 r
s
1 .301 .128 r
.55043 .60715 m .55659 .60912 L .52853 .62105 L p F P
0 0 0 r
s
1 .295 .124 r
.61949 .58066 m .63094 .58449 L .60124 .60008 L p F P
0 0 0 r
s
.24 .35 .67 r
.62198 .58642 m
.62294 .58603 L
s
.62861 .58372 m
.63218 .58226 L
s
1 .289 .122 r
.63094 .58449 m .61949 .58066 L .64346 .56207 L p F P
0 0 0 r
s
.83 .24 .1 r
.41233 .312 m
.40551 .30085 L
s
.36398 .28451 m
.40551 .30085 L
s
.24 .35 .67 r
.73139 .24454 m
.7552 .26846 L
s
.70522 .22359 m
.73139 .24454 L
s
.136 .196 .427 r
.37673 .48227 m .38672 .47047 L .39331 .49397 L p F P
0 0 0 r
s
.136 .196 .427 r
.39331 .49397 m .38384 .50488 L .37673 .48227 L p F P
0 0 0 r
s
1 .299 .126 r
.56886 .61305 m .56274 .61109 L .59231 .59717 L p F P
0 0 0 r
s
.83 .24 .1 r
.56984 .61239 m
.57021 .61251 L
s
1 .299 .126 r
.59231 .59717 m .60124 .60008 L .56886 .61305 L p F P
0 0 0 r
s
.83 .24 .1 r
.1623 .55592 m
.20619 .56911 L
s
.20619 .56911 m
.2143 .5722 L
s
.233 .345 .699 r
.4101 .58394 m .41645 .57729 L .4355 .5946 L p F P
0 0 0 r
s
.233 .345 .699 r
.4355 .5946 m .4305 .59967 L .4101 .58394 L p F P
0 0 0 r
s
.24 .35 .67 r
.42908 .58877 m
.4297 .58813 L
s
.54544 .24394 m
.56992 .2142 L
s
.54544 .24394 m
.52209 .248 L
s
.25 .373 .748 r
.45619 .60937 m .45273 .61277 L .4305 .59967 L p F P
0 0 0 r
s
.83 .24 .1 r
.41086 .61054 m
.45174 .62306 L
s
.24 .35 .67 r
.70869 .51954 m
.72012 .50091 L
s
.72012 .50091 m
.7482 .47645 L
s
.78173 .40341 m
.77535 .37662 L
s
.77535 .37662 m
.80456 .3496 L
s
1 .301 .128 r
.5254 .62007 m .52226 .61908 L .54424 .60517 L p F P
0 0 0 r
s
1 .301 .128 r
.54424 .60517 m .55043 .60715 L .5254 .62007 L p F P
0 0 0 r
s
.911 .252 .104 r
.63544 .47962 m .61686 .4728 L .62048 .45048 L p F P
0 0 0 r
s
.911 .252 .104 r
.60113 .44324 m .62048 .45048 L .61686 .4728 L p F P
0 0 0 r
s
.24 .35 .67 r
.7552 .26846 m
.77582 .29455 L
s
.024 .035 .067 r
.42101 .35547 m .43143 .34243 L .42783 .35613 L p F P
0 0 0 r
s
.24 .35 .67 r
.42093 .35575 m
.42114 .35549 L
s
.43136 .34269 m
.44116 .33044 L
s
.024 .035 .067 r
.42783 .35613 m .41691 .36972 L .42101 .35547 L p F P
0 0 0 r
s
1 .295 .124 r
.60124 .60008 m .59231 .59717 L .61949 .58066 L p F P
0 0 0 r
s
.267 .399 .792 r
.45619 .60937 m .45968 .60595 L .4797 .61947 L p F P
0 0 0 r
s
.24 .35 .67 r
.45666 .6082 m
.45714 .60844 L
s
.267 .399 .792 r
.4815 .61776 m .4797 .61947 L .45968 .60595 L p F P
0 0 0 r
s
.25 .373 .748 r
.4305 .59967 m .4355 .5946 L .45619 .60937 L p F P
0 0 0 r
s
.24 .35 .67 r
.45577 .60907 m
.45666 .6082 L
s
1 .289 .122 r
.62971 .55736 m .64346 .56207 L .61949 .58066 L p F P
0 0 0 r
s
.995 .283 .118 r
.64346 .56207 m .62971 .55736 L .64795 .53649 L p F P
0 0 0 r
s
.83 .24 .1 r
.6455 .5358 m
.64784 .53662 L
s
.64339 .5417 m
.6455 .5358 L
s
1 .301 .128 r
.52226 .61908 m .51912 .61809 L .53802 .60318 L p F P
0 0 0 r
s
1 .301 .128 r
.53802 .60318 m .54424 .60517 L .52226 .61908 L p F P
0 0 0 r
s
.192 .282 .584 r
.38552 .53717 m .39409 .52759 L .40724 .54971 L p F P
0 0 0 r
s
.192 .282 .584 r
.40724 .54971 m .39963 .55795 L .38552 .53717 L p F P
0 0 0 r
s
.24 .35 .67 r
.40083 .55664 m
.40597 .56389 L
s
1 .299 .126 r
.56274 .61109 m .55659 .60912 L .58334 .59423 L p F P
0 0 0 r
s
.83 .24 .1 r
.56359 .61039 m
.56397 .61051 L
s
.56559 .60975 m
.5668 .60777 L
s
1 .299 .126 r
.58334 .59423 m .59231 .59717 L .56274 .61109 L p F P
0 0 0 r
s
.24 .35 .67 r
.57038 .60984 m
.57183 .60855 L
s
.947 .265 .11 r
.64498 .50866 m .62762 .50243 L .63544 .47962 L p F P
0 0 0 r
s
.947 .265 .11 r
.61686 .4728 m .63544 .47962 L .62762 .50243 L p F P
0 0 0 r
s
.995 .283 .118 r
.63221 .53097 m .64795 .53649 L .62971 .55736 L p F P
0 0 0 r
s
.974 .275 .115 r
.64795 .53649 m .63221 .53097 L .64498 .50866 L p F P
0 0 0 r
s
1 .301 .128 r
.51912 .61809 m .51597 .61711 L .53179 .60119 L p F P
0 0 0 r
s
1 .301 .128 r
.53179 .60119 m .53802 .60318 L .51912 .61809 L p F P
0 0 0 r
s
.24 .35 .67 r
.52845 .61927 m
.53068 .61724 L
s
.53802 .61054 m
.55589 .61249 L
s
.098 .139 .32 r
.3832 .44803 m .39367 .43539 L .3969 .45843 L p F P
0 0 0 r
s
.098 .139 .32 r
.3969 .45843 m .38672 .47047 L .3832 .44803 L p F P
0 0 0 r
s
.24 .35 .67 r
.67756 .20636 m
.70522 .22359 L
s
.974 .275 .115 r
.62762 .50243 m .64498 .50866 L .63221 .53097 L p F P
0 0 0 r
s
.267 .399 .792 r
.45968 .60595 m .46319 .60251 L .4815 .61776 L p F P
0 0 0 r
s
.267 .399 .792 r
.4833 .61604 m .4815 .61776 L .46319 .60251 L p F P
0 0 0 r
s
.686 .18 .072 r
.52097 .37387 m .50084 .36611 L .5008 .352 L p F P
0 0 0 r
s
.686 .18 .072 r
.48144 .34446 m .5008 .352 L .50084 .36611 L p F P
0 0 0 r
s
1 .295 .124 r
.60796 .57681 m .61949 .58066 L .59231 .59717 L p F P
0 0 0 r
s
.24 .35 .67 r
.61664 .58859 m
.62198 .58642 L
s
.61153 .59306 m
.61664 .58859 L
s
1 .289 .122 r
.61949 .58066 m .60796 .57681 L .62971 .55736 L p F P
0 0 0 r
s
1 .301 .128 r
.51597 .61711 m .51281 .61612 L .52553 .59919 L p F P
0 0 0 r
s
1 .301 .128 r
.52553 .59919 m .53179 .60119 L .51597 .61711 L p F P
0 0 0 r
s
.24 .35 .67 r
.53068 .61724 m
.53802 .61054 L
s
.041 .06 .137 r
.4062 .38303 m .41691 .36972 L .41494 .38782 L p F P
0 0 0 r
s
.041 .06 .137 r
.41494 .38782 m .404 .40125 L .4062 .38303 L p F P
0 0 0 r
s
.24 .35 .67 r
.40504 .40232 m
.40557 .39932 L
s
.83 .24 .1 r
.31242 .59485 m
.35469 .60763 L
s
.35469 .60763 m
.36902 .59772 L
s
.862 .236 .097 r
.60113 .44324 m .58154 .43592 L .58183 .41496 L p F P
0 0 0 r
s
.862 .236 .097 r
.56195 .4074 m .58183 .41496 L .58154 .43592 L p F P
0 0 0 r
s
1 .295 .124 r
.59231 .59717 m .58334 .59423 L .60796 .57681 L p F P
0 0 0 r
s
.25 .373 .748 r
.45968 .60595 m .45619 .60937 L .4355 .5946 L p F P
0 0 0 r
s
.24 .35 .67 r
.4297 .58813 m
.44333 .59828 L
s
.83 .24 .1 r
.32146 .26777 m
.31359 .26392 L
s
.27081 .24707 m
.31359 .26392 L
s
1 .299 .126 r
.55659 .60912 m .55043 .60715 L .57432 .59129 L p F P
0 0 0 r
s
.83 .24 .1 r
.55733 .60838 m
.55771 .60851 L
s
1 .299 .126 r
.57432 .59129 m .58334 .59423 L .55659 .60912 L p F P
0 0 0 r
s
.24 .35 .67 r
.57183 .60855 m
.57382 .60678 L
s
.061 .089 .214 r
.39329 .41442 m .404 .40125 L .40435 .42249 L p F P
0 0 0 r
s
.24 .35 .67 r
.39333 .41668 m
.39447 .41528 L
s
.40404 .40355 m
.40504 .40232 L
s
.061 .089 .214 r
.40435 .42249 m .39367 .43539 L .39329 .41442 L p F P
0 0 0 r
s
1 .301 .128 r
.51281 .61612 m .50965 .61512 L .51925 .59718 L p F P
0 0 0 r
s
1 .301 .128 r
.51925 .59718 m .52553 .59919 L .51281 .61612 L p F P
0 0 0 r
s
.83 .24 .1 r
.52464 .5989 m
.52525 .59811 L
s
.525 .13 .05 r
.46186 .33684 m .44206 .32912 L .44658 .32088 L p F P
0 0 0 r
s
.24 .35 .67 r
.44116 .33044 m
.44235 .32923 L
s
.267 .399 .792 r
.46319 .60251 m .46672 .59904 L .4833 .61604 L p F P
0 0 0 r
s
.267 .399 .792 r
.4851 .61433 m .4833 .61604 L .46672 .59904 L p F P
0 0 0 r
s
.24 .35 .67 r
.77582 .29455 m
.7925 .32191 L
s
.791 .213 .087 r
.56195 .4074 m .54183 .39975 L .54087 .38154 L p F P
0 0 0 r
s
.791 .213 .087 r
.52097 .37387 m .54087 .38154 L .54183 .39975 L p F P
0 0 0 r
s
.213 .315 .645 r
.39963 .55795 m .40724 .54971 L .42288 .57055 L p F P
0 0 0 r
s
.213 .315 .645 r
.42288 .57055 m .41645 .57729 L .39963 .55795 L p F P
0 0 0 r
s
.24 .35 .67 r
.41775 .57592 m
.4297 .58813 L
s
.44613 .32421 m
.46361 .30235 L
s
.44116 .33044 m
.44217 .32917 L
s
1 .301 .128 r
.50965 .61512 m .50648 .61413 L .51294 .59516 L p F P
0 0 0 r
s
1 .301 .128 r
.51294 .59516 m .51925 .59718 L .50965 .61512 L p F P
0 0 0 r
s
1 .289 .122 r
.61585 .55261 m .62971 .55736 L .60796 .57681 L p F P
0 0 0 r
s
.24 .35 .67 r
.61664 .58859 m
.64271 .56583 L
s
.995 .283 .118 r
.62971 .55736 m .61585 .55261 L .63221 .53097 L p F P
0 0 0 r
s
1 .299 .126 r
.55043 .60715 m .54424 .60517 L .56526 .58832 L p F P
0 0 0 r
s
.83 .24 .1 r
.55104 .60637 m
.55142 .60649 L
s
1 .299 .126 r
.56526 .58832 m .57432 .59129 L .55043 .60715 L p F P
0 0 0 r
s
.24 .35 .67 r
.7482 .47645 m
.7536 .45411 L
s
.7536 .45411 m
.78252 .42855 L
s
.233 .345 .699 r
.44054 .58949 m .4355 .5946 L .41645 .57729 L p F P
0 0 0 r
s
.25 .373 .748 r
.4355 .5946 m .44054 .58949 L .45968 .60595 L p F P
0 0 0 r
s
.166 .243 .512 r
.38384 .50488 m .39331 .49397 L .40281 .51784 L p F P
0 0 0 r
s
.166 .243 .512 r
.40281 .51784 m .39409 .52759 L .38384 .50488 L p F P
0 0 0 r
s
.267 .399 .792 r
.46672 .59904 m .47027 .59555 L .4851 .61433 L p F P
0 0 0 r
s
.83 .24 .1 r
.45174 .62306 m
.4681 .60714 L
s
.267 .399 .792 r
.48692 .6126 m .4851 .61433 L .47027 .59555 L p F P
0 0 0 r
s
1 .301 .128 r
.50648 .61413 m .50331 .61313 L .50662 .59313 L p F P
0 0 0 r
s
1 .301 .128 r
.50662 .59313 m .51294 .59516 L .50648 .61413 L p F P
0 0 0 r
s
1 .295 .124 r
.58334 .59423 m .57432 .59129 L .59636 .57292 L p F P
0 0 0 r
s
.83 .24 .1 r
.57953 .58695 m
.58103 .5845 L
s
.58103 .5845 m
.58206 .58484 L
s
1 .295 .124 r
.59636 .57292 m .60796 .57681 L .58334 .59423 L p F P
0 0 0 r
s
.24 .35 .67 r
.57382 .60678 m
.59099 .59153 L
s
.233 .345 .699 r
.41645 .57729 m .42288 .57055 L .44054 .58949 L p F P
0 0 0 r
s
.911 .252 .104 r
.61686 .4728 m .59807 .46591 L .60113 .44324 L p F P
0 0 0 r
s
.911 .252 .104 r
.58154 .43592 m .60113 .44324 L .59807 .46591 L p F P
0 0 0 r
s
.83 .24 .1 r
.41233 .312 m
.44438 .32454 L
s
1 .289 .122 r
.60796 .57681 m .59636 .57292 L .61585 .55261 L p F P
0 0 0 r
s
.25 .373 .748 r
.46319 .60251 m .45968 .60595 L .44054 .58949 L p F P
0 0 0 r
s
1 .301 .128 r
.50331 .61313 m .50013 .61214 L .50026 .5911 L p F P
0 0 0 r
s
1 .301 .128 r
.50026 .5911 m .50662 .59313 L .50331 .61313 L p F P
0 0 0 r
s
.24 .35 .67 r
.50138 .608 m
.5086 .60119 L
s
.995 .283 .118 r
.61633 .5254 m .63221 .53097 L .61585 .55261 L p F P
0 0 0 r
s
.974 .275 .115 r
.63221 .53097 m .61633 .5254 L .62762 .50243 L p F P
0 0 0 r
s
1 .299 .126 r
.54424 .60517 m .53802 .60318 L .55614 .58534 L p F P
0 0 0 r
s
.83 .24 .1 r
.54473 .60435 m
.54511 .60447 L
s
1 .299 .126 r
.55614 .58534 m .56526 .58832 L .54424 .60517 L p F P
0 0 0 r
s
.267 .399 .792 r
.47027 .59555 m .47385 .59205 L .48692 .6126 L p F P
0 0 0 r
s
.267 .399 .792 r
.48874 .61087 m .48692 .6126 L .47385 .59205 L p F P
0 0 0 r
s
.83 .24 .1 r
.4806 .61104 m
.4844 .61223 L
s
.24 .35 .67 r
.59592 .21618 m
.62163 .18565 L
s
.59592 .21618 m
.56992 .2142 L
s
.947 .265 .11 r
.62762 .50243 m .61008 .49613 L .61686 .4728 L p F P
0 0 0 r
s
.947 .265 .11 r
.59807 .46591 m .61686 .4728 L .61008 .49613 L p F P
0 0 0 r
s
1 .301 .128 r
.50013 .61214 m .49695 .61114 L .49389 .58906 L p F P
0 0 0 r
s
1 .301 .128 r
.49389 .58906 m .50026 .5911 L .50013 .61214 L p F P
0 0 0 r
s
.24 .35 .67 r
.49919 .61007 m
.50138 .608 L
s
.974 .275 .115 r
.61008 .49613 m .62762 .50243 L .61633 .5254 L p F P
0 0 0 r
s
.83 .24 .1 r
.2143 .5722 m
.25792 .5853 L
s
.25792 .5853 m
.26913 .58176 L
s
.24 .35 .67 r
.64936 .19352 m
.67756 .20636 L
s
.686 .18 .072 r
.50084 .36611 m .48047 .35825 L .48144 .34446 L p F P
0 0 0 r
s
.686 .18 .072 r
.46186 .33684 m .48144 .34446 L .48047 .35825 L p F P
0 0 0 r
s
.83 .24 .1 r
.36902 .59772 m
.41086 .61054 L
s
.41086 .61054 m
.42681 .59424 L
s
1 .295 .124 r
.57432 .59129 m .56526 .58832 L .58467 .56901 L p F P
0 0 0 r
s
1 .295 .124 r
.58467 .56901 m .59636 .57292 L .57432 .59129 L p F P
0 0 0 r
s
.24 .35 .67 r
.59099 .59153 m
.61664 .58859 L
s
1 .301 .128 r
.49695 .61114 m .49376 .61014 L .48749 .58701 L p F P
0 0 0 r
s
1 .301 .128 r
.48749 .58701 m .49389 .58906 L .49695 .61114 L p F P
0 0 0 r
s
.267 .399 .792 r
.47385 .59205 m .47745 .58851 L .48874 .61087 L p F P
0 0 0 r
s
.267 .399 .792 r
.49056 .60913 m .48874 .61087 L .47745 .58851 L p F P
0 0 0 r
s
1 .299 .126 r
.53802 .60318 m .53179 .60119 L .54698 .58234 L p F P
0 0 0 r
s
.24 .35 .67 r
.5086 .60119 m
.53802 .61054 L
s
.83 .24 .1 r
.53839 .60232 m
.53878 .60244 L
s
1 .299 .126 r
.54698 .58234 m .55614 .58534 L .53802 .60318 L p F P
0 0 0 r
s
.862 .236 .097 r
.58154 .43592 m .56173 .42851 L .56195 .4074 L p F P
0 0 0 r
s
.862 .236 .097 r
.54183 .39975 m .56195 .4074 L .56173 .42851 L p F P
0 0 0 r
s
.83 .24 .1 r
.54138 .40083 m
.54301 .40145 L
s
1 .289 .122 r
.60187 .54782 m .61585 .55261 L .59636 .57292 L p F P
0 0 0 r
s
.995 .283 .118 r
.61585 .55261 m .60187 .54782 L .61633 .5254 L p F P
0 0 0 r
s
.136 .196 .427 r
.38672 .47047 m .3969 .45843 L .40295 .48287 L p F P
0 0 0 r
s
.136 .196 .427 r
.40295 .48287 m .39331 .49397 L .38672 .47047 L p F P
0 0 0 r
s
1 .301 .128 r
.49376 .61014 m .49056 .60913 L .48107 .58496 L p F P
0 0 0 r
s
1 .301 .128 r
.48107 .58496 m .48749 .58701 L .49376 .61014 L p F P
0 0 0 r
s
.24 .35 .67 r
.47893 .28689 m
.50227 .25776 L
s
.47893 .28689 m
.46361 .30235 L
s
.25 .373 .748 r
.44054 .58949 m .44563 .58433 L .46319 .60251 L p F P
0 0 0 r
s
.25 .373 .748 r
.46672 .59904 m .46319 .60251 L .44563 .58433 L p F P
0 0 0 r
s
.192 .282 .584 r
.39409 .52759 m .40281 .51784 L .41496 .54134 L p F P
0 0 0 r
s
.24 .35 .67 r
.39444 .52818 m
.39464 .52795 L
s
.192 .282 .584 r
.41496 .54134 m .40724 .54971 L .39409 .52759 L p F P
0 0 0 r
s
1 .289 .122 r
.59636 .57292 m .58467 .56901 L .60187 .54782 L p F P
0 0 0 r
s
.83 .24 .1 r
.59523 .55441 m
.59624 .55476 L
s
.59343 .55822 m
.59523 .55441 L
s
.791 .213 .087 r
.54183 .39975 m .52147 .392 L .52097 .37387 L p F P
0 0 0 r
s
.83 .24 .1 r
.54125 .39952 m
.54138 .40083 L
s
.791 .213 .087 r
.50084 .36611 m .52097 .37387 L .52147 .392 L p F P
0 0 0 r
s
.024 .035 .067 r
.43143 .34243 m .44206 .32912 L .43899 .34227 L p F P
0 0 0 r
s
.024 .035 .067 r
.43899 .34227 m .42783 .35613 L .43143 .34243 L p F P
0 0 0 r
s
.233 .345 .699 r
.44563 .58433 m .44054 .58949 L .42288 .57055 L p F P
0 0 0 r
s
.267 .399 .792 r
.47745 .58851 m .48107 .58496 L .49056 .60913 L p F P
0 0 0 r
s
.83 .24 .1 r
.4681 .60714 m
.4806 .61104 L
s
.24 .35 .67 r
.64271 .56583 m
.66455 .55711 L
s
.66455 .55711 m
.69177 .53356 L
s
1 .299 .126 r
.53179 .60119 m .52553 .59919 L .53776 .57933 L p F P
0 0 0 r
s
.83 .24 .1 r
.52525 .59811 m
.52604 .59836 L
s
.53204 .60028 m
.53242 .60041 L
s
1 .299 .126 r
.53776 .57933 m .54698 .58234 L .53179 .60119 L p F P
0 0 0 r
s
.24 .35 .67 r
.7925 .32191 m
.80456 .3496 L
s
1 .295 .124 r
.56526 .58832 m .55614 .58534 L .5729 .56508 L p F P
0 0 0 r
s
.24 .35 .67 r
.53959 .60911 m
.56256 .58814 L
s
.53802 .61054 m
.53959 .60911 L
s
1 .295 .124 r
.5729 .56508 m .58467 .56901 L .56526 .58832 L p F P
0 0 0 r
s
.83 .24 .1 r
.3701 .29548 m
.36398 .28451 L
s
.32146 .26777 m
.36398 .28451 L
s
.1623 .55592 m
.16963 .55878 L
s
.995 .283 .118 r
.60029 .51977 m .61633 .5254 L .60187 .54782 L p F P
0 0 0 r
s
.974 .275 .115 r
.61633 .5254 m .60029 .51977 L .61008 .49613 L p F P
0 0 0 r
s
.213 .315 .645 r
.40724 .54971 m .41496 .54134 L .42938 .56373 L p F P
0 0 0 r
s
.213 .315 .645 r
.42938 .56373 m .42288 .57055 L .40724 .54971 L p F P
0 0 0 r
s
.911 .252 .104 r
.59807 .46591 m .57906 .45894 L .58154 .43592 L p F P
0 0 0 r
s
.911 .252 .104 r
.56173 .42851 m .58154 .43592 L .57906 .45894 L p F P
0 0 0 r
s
.233 .345 .699 r
.42288 .57055 m .42938 .56373 L .44563 .58433 L p F P
0 0 0 r
s
.24 .35 .67 r
.81144 .37662 m
.78173 .40341 L
s
.78252 .42855 m
.78173 .40341 L
s
.098 .139 .32 r
.39367 .43539 m .40435 .42249 L .40729 .44616 L p F P
0 0 0 r
s
.098 .139 .32 r
.40729 .44616 m .3969 .45843 L .39367 .43539 L p F P
0 0 0 r
s
1 .299 .126 r
.52553 .59919 m .51925 .59718 L .52849 .5763 L p F P
0 0 0 r
s
1 .299 .126 r
.52849 .5763 m .53776 .57933 L .52553 .59919 L p F P
0 0 0 r
s
.25 .373 .748 r
.44563 .58433 m .45077 .57912 L .46672 .59904 L p F P
0 0 0 r
s
.25 .373 .748 r
.47027 .59555 m .46672 .59904 L .45077 .57912 L p F P
0 0 0 r
s
.83 .24 .1 r
.4681 .60714 m
.47677 .59559 L
s
.47677 .59559 m
.47852 .59325 L
s
.59523 .55441 m
.60128 .53742 L
s
.974 .275 .115 r
.59235 .48976 m .61008 .49613 L .60029 .51977 L p F P
0 0 0 r
s
.947 .265 .11 r
.61008 .49613 m .59235 .48976 L .59807 .46591 L p F P
0 0 0 r
s
.947 .265 .11 r
.57906 .45894 m .59807 .46591 L .59235 .48976 L p F P
0 0 0 r
s
.041 .06 .137 r
.41691 .36972 m .42783 .35613 L .42611 .3741 L p F P
0 0 0 r
s
.041 .06 .137 r
.42611 .3741 m .41494 .38782 L .41691 .36972 L p F P
0 0 0 r
s
1 .289 .122 r
.58467 .56901 m .5729 .56508 L .58777 .54299 L p F P
0 0 0 r
s
1 .289 .122 r
.58777 .54299 m .60187 .54782 L .58467 .56901 L p F P
0 0 0 r
s
.995 .283 .118 r
.60187 .54782 m .58777 .54299 L .60029 .51977 L p F P
0 0 0 r
s
.061 .089 .214 r
.404 .40125 m .41494 .38782 L .41525 .40933 L p F P
0 0 0 r
s
.24 .35 .67 r
.40504 .40232 m
.40521 .40212 L
s
.061 .089 .214 r
.41525 .40933 m .40435 .42249 L .404 .40125 L p F P
0 0 0 r
s
1 .295 .124 r
.55614 .58534 m .54698 .58234 L .56105 .56111 L p F P
0 0 0 r
s
1 .295 .124 r
.56105 .56111 m .5729 .56508 L .55614 .58534 L p F P
0 0 0 r
s
.686 .18 .072 r
.48047 .35825 m .45985 .35031 L .46186 .33684 L p F P
0 0 0 r
s
.686 .18 .072 r
.44206 .32912 m .46186 .33684 L .45985 .35031 L p F P
0 0 0 r
s
1 .299 .126 r
.51925 .59718 m .51294 .59516 L .51918 .57326 L p F P
0 0 0 r
s
.83 .24 .1 r
.51925 .59619 m
.51963 .59631 L
s
1 .299 .126 r
.51918 .57326 m .52849 .5763 L .51925 .59718 L p F P
0 0 0 r
s
.24 .35 .67 r
.52209 .248 m
.54646 .2179 L
s
.52209 .248 m
.50227 .25776 L
s
.166 .243 .512 r
.39331 .49397 m .40295 .48287 L .41167 .50793 L p F P
0 0 0 r
s
.166 .243 .512 r
.41167 .50793 m .40281 .51784 L .39331 .49397 L p F P
0 0 0 r
s
.83 .24 .1 r
.26913 .58176 m
.31242 .59485 L
s
.31242 .59485 m
.32617 .58459 L
s
.233 .345 .699 r
.45077 .57912 m .44563 .58433 L .42938 .56373 L p F P
0 0 0 r
s
.862 .236 .097 r
.56173 .42851 m .54168 .42102 L .54183 .39975 L p F P
0 0 0 r
s
.862 .236 .097 r
.52147 .392 m .54183 .39975 L .54168 .42102 L p F P
0 0 0 r
s
.83 .24 .1 r
.27792 .25064 m
.27081 .24707 L
s
.24 .35 .67 r
.69177 .53356 m
.70869 .51954 L
s
.70869 .51954 m
.73697 .49508 L
s
.791 .213 .087 r
.52147 .392 m .50086 .38417 L .50084 .36611 L p F P
0 0 0 r
s
.791 .213 .087 r
.48047 .35825 m .50084 .36611 L .50086 .38417 L p F P
0 0 0 r
s
.25 .373 .748 r
.45077 .57912 m .45596 .57386 L .47027 .59555 L p F P
0 0 0 r
s
.25 .373 .748 r
.47385 .59205 m .47027 .59555 L .45596 .57386 L p F P
0 0 0 r
s
.83 .24 .1 r
.42681 .59424 m
.4681 .60714 L
s
1 .299 .126 r
.51294 .59516 m .50662 .59313 L .50981 .57019 L p F P
0 0 0 r
s
.83 .24 .1 r
.51281 .59413 m
.5132 .59425 L
s
1 .299 .126 r
.50981 .57019 m .51918 .57326 L .51294 .59516 L p F P
0 0 0 r
s
.995 .283 .118 r
.5841 .51409 m .60029 .51977 L .58777 .54299 L p F P
0 0 0 r
s
.974 .275 .115 r
.60029 .51977 m .5841 .51409 L .59235 .48976 L p F P
0 0 0 r
s
.24 .35 .67 r
.62163 .18565 m
.64936 .19352 L
s
1 .295 .124 r
.54698 .58234 m .53776 .57933 L .54911 .55712 L p F P
0 0 0 r
s
1 .295 .124 r
.54911 .55712 m .56105 .56111 L .54698 .58234 L p F P
0 0 0 r
s
1 .289 .122 r
.5729 .56508 m .56105 .56111 L .57355 .53812 L p F P
0 0 0 r
s
1 .289 .122 r
.57355 .53812 m .58777 .54299 L .5729 .56508 L p F P
0 0 0 r
s
.24 .35 .67 r
.49324 .59315 m
.5086 .60119 L
s
.49014 .59152 m
.49324 .59315 L
s
.995 .283 .118 r
.58777 .54299 m .57355 .53812 L .5841 .51409 L p F P
0 0 0 r
s
.24 .35 .67 r
.56256 .58814 m
.59099 .59153 L
s
.59099 .59153 m
.61687 .56852 L
s
.911 .252 .104 r
.57906 .45894 m .55984 .45189 L .56173 .42851 L p F P
0 0 0 r
s
.911 .252 .104 r
.54168 .42102 m .56173 .42851 L .55984 .45189 L p F P
0 0 0 r
s
.192 .282 .584 r
.40281 .51784 m .41167 .50793 L .42279 .53285 L p F P
0 0 0 r
s
.24 .35 .67 r
.40313 .51847 m
.40333 .51824 L
s
.192 .282 .584 r
.42279 .53285 m .41496 .54134 L .40281 .51784 L p F P
0 0 0 r
s
.213 .315 .645 r
.43597 .55683 m .42938 .56373 L .41496 .54134 L p F P
0 0 0 r
s
.233 .345 .699 r
.42938 .56373 m .43597 .55683 L .45077 .57912 L p F P
0 0 0 r
s
.83 .24 .1 r
.41622 .32975 m
.41233 .312 L
s
.3701 .29548 m
.41233 .312 L
s
1 .299 .126 r
.50662 .59313 m .50026 .5911 L .50039 .56712 L p F P
0 0 0 r
s
.83 .24 .1 r
.50636 .59206 m
.50675 .59219 L
s
1 .299 .126 r
.50039 .56712 m .50981 .57019 L .50662 .59313 L p F P
0 0 0 r
s
.974 .275 .115 r
.57442 .48333 m .59235 .48976 L .5841 .51409 L p F P
0 0 0 r
s
.947 .265 .11 r
.59235 .48976 m .57442 .48333 L .57906 .45894 L p F P
0 0 0 r
s
.947 .265 .11 r
.55984 .45189 m .57906 .45894 L .57442 .48333 L p F P
0 0 0 r
s
.213 .315 .645 r
.41496 .54134 m .42279 .53285 L .43597 .55683 L p F P
0 0 0 r
s
.25 .373 .748 r
.45596 .57386 m .4612 .56855 L .47385 .59205 L p F P
0 0 0 r
s
.25 .373 .748 r
.47745 .58851 m .47385 .59205 L .4612 .56855 L p F P
0 0 0 r
s
.136 .196 .427 r
.3969 .45843 m .40729 .44616 L .41278 .47155 L p F P
0 0 0 r
s
.136 .196 .427 r
.41278 .47155 m .40295 .48287 L .3969 .45843 L p F P
0 0 0 r
s
1 .295 .124 r
.53776 .57933 m .52849 .5763 L .53709 .55309 L p F P
0 0 0 r
s
.24 .35 .67 r
.51014 .59973 m
.53274 .5784 L
s
.5086 .60119 m
.51014 .59973 L
s
1 .295 .124 r
.53709 .55309 m .54911 .55712 L .53776 .57933 L p F P
0 0 0 r
s
.83 .24 .1 r
.16963 .55878 m
.2143 .5722 L
s
.2143 .5722 m
.2248 .56836 L
s
.233 .345 .699 r
.45596 .57386 m .45077 .57912 L .43597 .55683 L p F P
0 0 0 r
s
.686 .18 .072 r
.45985 .35031 m .43899 .34227 L .44206 .32912 L p F P
0 0 0 r
s
.24 .35 .67 r
.4411 .3384 m
.44253 .33662 L
s
.44253 .33662 m
.45364 .3228 L
s
1 .299 .126 r
.50026 .5911 m .49389 .58906 L .49092 .56402 L p F P
0 0 0 r
s
.83 .24 .1 r
.49988 .58999 m
.50027 .59011 L
s
1 .299 .126 r
.49092 .56402 m .50039 .56712 L .50026 .5911 L p F P
0 0 0 r
s
.83 .24 .1 r
.32617 .58459 m
.36902 .59772 L
s
.36902 .59772 m
.38451 .58103 L
s
1 .289 .122 r
.56105 .56111 m .54911 .55712 L .55922 .53321 L p F P
0 0 0 r
s
1 .289 .122 r
.55922 .53321 m .57355 .53812 L .56105 .56111 L p F P
0 0 0 r
s
.24 .35 .67 r
.56992 .2142 m
.59544 .18321 L
s
.56992 .2142 m
.54646 .2179 L
s
.73697 .49508 m
.7482 .47645 L
s
.7482 .47645 m
.77745 .45096 L
s
.80456 .3496 m
.81144 .37662 L
s
.862 .236 .097 r
.54168 .42102 m .52139 .41343 L .52147 .392 L p F P
0 0 0 r
s
.862 .236 .097 r
.50086 .38417 m .52147 .392 L .52139 .41343 L p F P
0 0 0 r
s
.83 .24 .1 r
.50085 .38544 m
.50208 .38591 L
s
.995 .283 .118 r
.56774 .50835 m .5841 .51409 L .57355 .53812 L p F P
0 0 0 r
s
.974 .275 .115 r
.5841 .51409 m .56774 .50835 L .57442 .48333 L p F P
0 0 0 r
s
.791 .213 .087 r
.50086 .38417 m .48 .37624 L .48047 .35825 L p F P
0 0 0 r
s
.83 .24 .1 r
.50075 .38413 m
.50085 .38544 L
s
.791 .213 .087 r
.45985 .35031 m .48047 .35825 L .48 .37624 L p F P
0 0 0 r
s
1 .299 .126 r
.49389 .58906 m .48749 .58701 L .4814 .56091 L p F P
0 0 0 r
s
.83 .24 .1 r
.49338 .5879 m
.49377 .58803 L
s
1 .299 .126 r
.4814 .56091 m .49092 .56402 L .49389 .58906 L p F P
0 0 0 r
s
.83 .24 .1 r
.48403 .58591 m
.48463 .5851 L
s
.48463 .5851 m
.48724 .58594 L
s
.995 .283 .118 r
.57355 .53812 m .55922 .53321 L .56774 .50835 L p F P
0 0 0 r
s
1 .295 .124 r
.52849 .5763 m .51918 .57326 L .52498 .54904 L p F P
0 0 0 r
s
1 .295 .124 r
.52498 .54904 m .53709 .55309 L .52849 .5763 L p F P
0 0 0 r
s
.25 .373 .748 r
.4612 .56855 m .46648 .56319 L .47745 .58851 L p F P
0 0 0 r
s
.25 .373 .748 r
.48107 .58496 m .47745 .58851 L .46648 .56319 L p F P
0 0 0 r
s
.098 .139 .32 r
.40435 .42249 m .41525 .40933 L .41788 .43364 L p F P
0 0 0 r
s
.098 .139 .32 r
.41788 .43364 m .40729 .44616 L .40435 .42249 L p F P
0 0 0 r
s
.83 .24 .1 r
.32684 .27856 m
.32146 .26777 L
s
.27792 .25064 m
.32146 .26777 L
s
.41622 .32975 m
.4394 .33871 L
s
.041 .06 .137 r
.42783 .35613 m .43899 .34227 L .43752 .36009 L p F P
0 0 0 r
s
.041 .06 .137 r
.43752 .36009 m .42611 .3741 L .42783 .35613 L p F P
0 0 0 r
s
.24 .35 .67 r
.42693 .37549 m
.42743 .37247 L
s
.83 .24 .1 r
.38451 .58103 m
.42681 .59424 L
s
.974 .275 .115 r
.55631 .47683 m .57442 .48333 L .56774 .50835 L p F P
0 0 0 r
s
.83 .24 .1 r
.567 .50826 m
.56769 .5085 L
s
.567 .50826 m
.56729 .50711 L
s
.57344 .48297 m
.57373 .48183 L
s
.947 .265 .11 r
.57442 .48333 m .55631 .47683 L .55984 .45189 L p F P
0 0 0 r
s
1 .299 .126 r
.48749 .58701 m .48107 .58496 L .47182 .55777 L p F P
0 0 0 r
s
1 .299 .126 r
.47182 .55777 m .4814 .56091 L .48749 .58701 L p F P
0 0 0 r
s
.24 .35 .67 r
.48342 .58192 m
.4848 .58057 L
s
.48077 .58452 m
.48088 .58442 L
s
.83 .24 .1 r
.48022 .58369 m
.48069 .58384 L
s
.911 .252 .104 r
.55984 .45189 m .5404 .44476 L .54168 .42102 L p F P
0 0 0 r
s
.911 .252 .104 r
.52139 .41343 m .54168 .42102 L .5404 .44476 L p F P
0 0 0 r
s
1 .289 .122 r
.54911 .55712 m .53709 .55309 L .54475 .52825 L p F P
0 0 0 r
s
1 .289 .122 r
.54475 .52825 m .55922 .53321 L .54911 .55712 L p F P
0 0 0 r
s
.166 .243 .512 r
.40295 .48287 m .41278 .47155 L .42068 .49786 L p F P
0 0 0 r
s
.166 .243 .512 r
.42068 .49786 m .41167 .50793 L .40295 .48287 L p F P
0 0 0 r
s
.061 .089 .214 r
.41494 .38782 m .42611 .3741 L .42638 .39588 L p F P
0 0 0 r
s
.24 .35 .67 r
.41497 .39014 m
.41617 .38868 L
s
.42614 .37645 m
.42693 .37549 L
s
.061 .089 .214 r
.42638 .39588 m .41525 .40933 L .41494 .38782 L p F P
0 0 0 r
s
.213 .315 .645 r
.44263 .54984 m .43597 .55683 L .42279 .53285 L p F P
0 0 0 r
s
.233 .345 .699 r
.43597 .55683 m .44263 .54984 L .45596 .57386 L p F P
0 0 0 r
s
.233 .345 .699 r
.4612 .56855 m .45596 .57386 L .44263 .54984 L p F P
0 0 0 r
s
.83 .24 .1 r
.42681 .59424 m
.44303 .57178 L
s
.947 .265 .11 r
.5404 .44476 m .55984 .45189 L .55631 .47683 L p F P
0 0 0 r
s
.83 .24 .1 r
.55824 .53287 m
.567 .50826 L
s
1 .295 .124 r
.51918 .57326 m .50981 .57019 L .51279 .54496 L p F P
0 0 0 r
s
1 .295 .124 r
.51279 .54496 m .52498 .54904 L .51918 .57326 L p F P
0 0 0 r
s
.24 .35 .67 r
.46361 .30235 m
.487 .27307 L
s
.46361 .30235 m
.45364 .3228 L
s
.61687 .56852 m
.64271 .56583 L
s
.64271 .56583 m
.66989 .54211 L
s
.25 .373 .748 r
.46648 .56319 m .47182 .55777 L .48107 .58496 L p F P
0 0 0 r
s
.83 .24 .1 r
.44303 .57178 m
.4717 .58096 L
s
.4717 .58096 m
.47505 .58204 L
s
.47505 .58204 m
.47748 .58281 L
s
.24 .35 .67 r
.77745 .45096 m
.78252 .42855 L
s
.78252 .42855 m
.81266 .40191 L
s
.995 .283 .118 r
.55123 .50255 m .56774 .50835 L .55922 .53321 L p F P
0 0 0 r
s
.974 .275 .115 r
.56774 .50835 m .55123 .50255 L .55631 .47683 L p F P
0 0 0 r
s
.995 .283 .118 r
.55922 .53321 m .54475 .52825 L .55123 .50255 L p F P
0 0 0 r
s
.192 .282 .584 r
.41167 .50793 m .42068 .49786 L .43074 .52424 L p F P
0 0 0 r
s
.24 .35 .67 r
.41196 .5086 m
.41217 .50837 L
s
.192 .282 .584 r
.43074 .52424 m .42279 .53285 L .41167 .50793 L p F P
0 0 0 r
s
.213 .315 .645 r
.42279 .53285 m .43074 .52424 L .44263 .54984 L p F P
0 0 0 r
s
.83 .24 .1 r
.2248 .56836 m
.26913 .58176 L
s
.26913 .58176 m
.28227 .57115 L
s
.862 .236 .097 r
.52139 .41343 m .50086 .40575 L .50086 .38417 L p F P
0 0 0 r
s
.862 .236 .097 r
.48 .37624 m .50086 .38417 L .50086 .40575 L p F P
0 0 0 r
s
1 .289 .122 r
.53709 .55309 m .52498 .54904 L .53017 .52325 L p F P
0 0 0 r
s
1 .289 .122 r
.53017 .52325 m .54475 .52825 L .53709 .55309 L p F P
0 0 0 r
s
1 .295 .124 r
.50981 .57019 m .50039 .56712 L .50051 .54086 L p F P
0 0 0 r
s
.24 .35 .67 r
.4848 .58057 m
.4867 .57871 L
s
1 .295 .124 r
.50051 .54086 m .51279 .54496 L .50981 .57019 L p F P
0 0 0 r
s
.791 .213 .087 r
.48 .37624 m .45889 .36821 L .45985 .35031 L p F P
0 0 0 r
s
.791 .213 .087 r
.43899 .34227 m .45985 .35031 L .45889 .36821 L p F P
0 0 0 r
s
.24 .35 .67 r
.59544 .18321 m
.62163 .18565 L
s
.974 .275 .115 r
.538 .47025 m .55631 .47683 L .55123 .50255 L p F P
0 0 0 r
s
.947 .265 .11 r
.55631 .47683 m .538 .47025 L .5404 .44476 L p F P
0 0 0 r
s
.233 .345 .699 r
.44263 .54984 m .44938 .54277 L .4612 .56855 L p F P
0 0 0 r
s
.233 .345 .699 r
.46648 .56319 m .4612 .56855 L .44938 .54277 L p F P
0 0 0 r
s
.24 .35 .67 r
.53274 .5784 m
.56256 .58814 L
s
.56256 .58814 m
.58815 .5648 L
s
.136 .196 .427 r
.40729 .44616 m .41788 .43364 L .42279 .46002 L p F P
0 0 0 r
s
.136 .196 .427 r
.42279 .46002 m .41278 .47155 L .40729 .44616 L p F P
0 0 0 r
s
.911 .252 .104 r
.5404 .44476 m .52073 .43754 L .52139 .41343 L p F P
0 0 0 r
s
.911 .252 .104 r
.50086 .40575 m .52139 .41343 L .52073 .43754 L p F P
0 0 0 r
s
.83 .24 .1 r
.3733 .31316 m
.3701 .29548 L
s
.32684 .27856 m
.3701 .29548 L
s
.24 .35 .67 r
.50227 .25776 m
.52661 .22739 L
s
.50227 .25776 m
.487 .27307 L
s
1 .295 .124 r
.50039 .56712 m .49092 .56402 L .48814 .53672 L p F P
0 0 0 r
s
1 .295 .124 r
.48814 .53672 m .50051 .54086 L .50039 .56712 L p F P
0 0 0 r
s
.947 .265 .11 r
.52073 .43754 m .5404 .44476 L .538 .47025 L p F P
0 0 0 r
s
.213 .315 .645 r
.44938 .54277 m .44263 .54984 L .43074 .52424 L p F P
0 0 0 r
s
.995 .283 .118 r
.54475 .52825 m .53017 .52325 L .53456 .4967 L p F P
0 0 0 r
s
.995 .283 .118 r
.53456 .4967 m .55123 .50255 L .54475 .52825 L p F P
0 0 0 r
s
.974 .275 .115 r
.55123 .50255 m .53456 .4967 L .538 .47025 L p F P
0 0 0 r
s
1 .289 .122 r
.52498 .54904 m .51279 .54496 L .51546 .51821 L p F P
0 0 0 r
s
1 .289 .122 r
.51546 .51821 m .53017 .52325 L .52498 .54904 L p F P
0 0 0 r
s
.24 .35 .67 r
.66989 .54211 m
.69177 .53356 L
s
.69177 .53356 m
.72015 .50901 L
s
.83 .24 .1 r
.16963 .55878 m
.17938 .55462 L
s
.28227 .57115 m
.32617 .58459 L
s
.32617 .58459 m
.34119 .5675 L
s
.24 .35 .67 r
.81144 .37662 m
.81266 .40191 L
s
.098 .139 .32 r
.41525 .40933 m .42638 .39588 L .42869 .42087 L p F P
0 0 0 r
s
.098 .139 .32 r
.42869 .42087 m .41788 .43364 L .41525 .40933 L p F P
0 0 0 r
s
.862 .236 .097 r
.50086 .40575 m .48007 .39798 L .48 .37624 L p F P
0 0 0 r
s
.862 .236 .097 r
.45889 .36821 m .48 .37624 L .48007 .39798 L p F P
0 0 0 r
s
.83 .24 .1 r
.45935 .36967 m
.46015 .36998 L
s
.4593 .36879 m
.45935 .36967 L
s
1 .295 .124 r
.49092 .56402 m .4814 .56091 L .47568 .53255 L p F P
0 0 0 r
s
1 .295 .124 r
.47568 .53255 m .48814 .53672 L .49092 .56402 L p F P
0 0 0 r
s
.24 .35 .67 r
.4867 .57871 m
.50305 .56264 L
s
.166 .243 .512 r
.41278 .47155 m .42279 .46002 L .42984 .4876 L p F P
0 0 0 r
s
.166 .243 .512 r
.42984 .4876 m .42068 .49786 L .41278 .47155 L p F P
0 0 0 r
s
.791 .213 .087 r
.45889 .36821 m .43752 .36009 L .43899 .34227 L p F P
0 0 0 r
s
.24 .35 .67 r
.44107 .35815 m
.44974 .34751 L
s
.233 .345 .699 r
.44938 .54277 m .45622 .5356 L .46648 .56319 L p F P
0 0 0 r
s
.233 .345 .699 r
.47182 .55777 m .46648 .56319 L .45622 .5356 L p F P
0 0 0 r
s
.192 .282 .584 r
.43881 .51549 m .43074 .52424 L .42068 .49786 L p F P
0 0 0 r
s
.213 .315 .645 r
.43074 .52424 m .43881 .51549 L .44938 .54277 L p F P
0 0 0 r
s
.974 .275 .115 r
.51949 .46361 m .538 .47025 L .53456 .4967 L p F P
0 0 0 r
s
.83 .24 .1 r
.53296 .46844 m
.53431 .46326 L
s
.947 .265 .11 r
.538 .47025 m .51949 .46361 L .52073 .43754 L p F P
0 0 0 r
s
1 .289 .122 r
.51279 .54496 m .50051 .54086 L .50062 .51313 L p F P
0 0 0 r
s
1 .289 .122 r
.50062 .51313 m .51546 .51821 L .51279 .54496 L p F P
0 0 0 r
s
.061 .089 .214 r
.42611 .3741 m .43752 .36009 L .43775 .38215 L p F P
0 0 0 r
s
.24 .35 .67 r
.42693 .37549 m
.42736 .37496 L
s
.061 .089 .214 r
.43775 .38215 m .42638 .39588 L .42611 .3741 L p F P
0 0 0 r
s
.995 .283 .118 r
.53017 .52325 m .51546 .51821 L .51772 .49079 L p F P
0 0 0 r
s
.995 .283 .118 r
.51772 .49079 m .53456 .4967 L .53017 .52325 L p F P
0 0 0 r
s
.192 .282 .584 r
.42068 .49786 m .42984 .4876 L .43881 .51549 L p F P
0 0 0 r
s
.83 .24 .1 r
.28251 .26123 m
.27792 .25064 L
s
.24 .35 .67 r
.54646 .2179 m
.57186 .18652 L
s
.54646 .2179 m
.52661 .22739 L
s
.83 .24 .1 r
.41683 .35352 m
.41622 .32975 L
s
.3733 .31316 m
.41622 .32975 L
s
.34119 .5675 m
.38451 .58103 L
s
.38451 .58103 m
.40041 .55814 L
s
.40041 .55814 m
.44303 .57178 L
s
.911 .252 .104 r
.52073 .43754 m .50083 .43024 L .50086 .40575 L p F P
0 0 0 r
s
.911 .252 .104 r
.48007 .39798 m .50086 .40575 L .50083 .43024 L p F P
0 0 0 r
s
1 .295 .124 r
.4814 .56091 m .47182 .55777 L .46314 .52835 L p F P
0 0 0 r
s
1 .295 .124 r
.46314 .52835 m .47568 .53255 L .4814 .56091 L p F P
0 0 0 r
s
.24 .35 .67 r
.47253 .54422 m
.47508 .54161 L
s
.974 .275 .115 r
.53456 .4967 m .51772 .49079 L .51949 .46361 L p F P
0 0 0 r
s
.947 .265 .11 r
.50083 .43024 m .52073 .43754 L .51949 .46361 L p F P
0 0 0 r
s
.24 .35 .67 r
.72015 .50901 m
.73697 .49508 L
s
.73697 .49508 m
.76646 .46958 L
s
.213 .315 .645 r
.45622 .5356 m .44938 .54277 L .43881 .51549 L p F P
0 0 0 r
s
.24 .35 .67 r
.50305 .56264 m
.53274 .5784 L
s
.53274 .5784 m
.55792 .55464 L
s
.83 .24 .1 r
.41683 .35352 m
.43671 .36108 L
s
1 .289 .122 r
.50051 .54086 m .48814 .53672 L .48565 .508 L p F P
0 0 0 r
s
1 .289 .122 r
.48565 .508 m .50062 .51313 L .50051 .54086 L p F P
0 0 0 r
s
.24 .35 .67 r
.58815 .5648 m
.61687 .56852 L
s
.61687 .56852 m
.64386 .54453 L
s
.233 .345 .699 r
.45622 .5356 m .46314 .52835 L .47182 .55777 L p F P
0 0 0 r
s
.83 .24 .1 r
.46321 .54566 m
.46713 .54696 L
s
.45866 .54416 m
.46321 .54566 L
s
.24 .35 .67 r
.47035 .54646 m
.47253 .54422 L
s
.83 .24 .1 r
.44303 .57178 m
.45866 .54416 L
s
.17938 .55462 m
.2248 .56836 L
s
.2248 .56836 m
.2373 .55737 L
s
.995 .283 .118 r
.51546 .51821 m .50062 .51313 L .50071 .48483 L p F P
0 0 0 r
s
.995 .283 .118 r
.50071 .48483 m .51772 .49079 L .51546 .51821 L p F P
0 0 0 r
s
.862 .236 .097 r
.48007 .39798 m .45904 .39012 L .45889 .36821 L p F P
0 0 0 r
s
.862 .236 .097 r
.43752 .36009 m .45889 .36821 L .45904 .39012 L p F P
0 0 0 r
s
.83 .24 .1 r
.43753 .36139 m
.43879 .36187 L
s
.24 .35 .67 r
.43754 .36247 m
.43844 .36137 L
s
.136 .196 .427 r
.41788 .43364 m .42869 .42087 L .43299 .44826 L p F P
0 0 0 r
s
.136 .196 .427 r
.43299 .44826 m .42279 .46002 L .41788 .43364 L p F P
0 0 0 r
s
.974 .275 .115 r
.50078 .45689 m .51949 .46361 L .51772 .49079 L p F P
0 0 0 r
s
.947 .265 .11 r
.51949 .46361 m .50078 .45689 L .50083 .43024 L p F P
0 0 0 r
s
.24 .35 .67 r
.45364 .3228 m
.47718 .2935 L
s
.44974 .34751 m
.45364 .3228 L
s
.974 .275 .115 r
.51772 .49079 m .50071 .48483 L .50078 .45689 L p F P
0 0 0 r
s
.24 .35 .67 r
.57186 .18652 m
.59544 .18321 L
s
.76646 .46958 m
.77745 .45096 L
s
.77745 .45096 m
.80796 .42439 L
s
.192 .282 .584 r
.447 .50662 m .43881 .51549 L .42984 .4876 L p F P
0 0 0 r
s
.213 .315 .645 r
.43881 .51549 m .447 .50662 L .45622 .5356 L p F P
0 0 0 r
s
.911 .252 .104 r
.50083 .43024 m .4807 .42286 L .48007 .39798 L p F P
0 0 0 r
s
.911 .252 .104 r
.45904 .39012 m .48007 .39798 L .4807 .42286 L p F P
0 0 0 r
s
1 .289 .122 r
.48814 .53672 m .47568 .53255 L .47055 .50282 L p F P
0 0 0 r
s
1 .289 .122 r
.47055 .50282 m .48565 .508 L .48814 .53672 L p F P
0 0 0 r
s
.947 .265 .11 r
.4807 .42286 m .50083 .43024 L .50078 .45689 L p F P
0 0 0 r
s
.83 .24 .1 r
.32931 .29616 m
.32684 .27856 L
s
.28251 .26123 m
.32684 .27856 L
s
.213 .315 .645 r
.46314 .52835 m .45622 .5356 L .447 .50662 L p F P
0 0 0 r
s
.166 .243 .512 r
.42279 .46002 m .43299 .44826 L .43917 .47717 L p F P
0 0 0 r
s
.166 .243 .512 r
.43917 .47717 m .42984 .4876 L .42279 .46002 L p F P
0 0 0 r
s
.098 .139 .32 r
.42638 .39588 m .43775 .38215 L .43972 .40783 L p F P
0 0 0 r
s
.098 .139 .32 r
.43972 .40783 m .42869 .42087 L .42638 .39588 L p F P
0 0 0 r
s
.995 .283 .118 r
.50062 .51313 m .48565 .508 L .48353 .4788 L p F P
0 0 0 r
s
.995 .283 .118 r
.48353 .4788 m .50071 .48483 L .50062 .51313 L p F P
0 0 0 r
s
.192 .282 .584 r
.42984 .4876 m .43917 .47717 L .447 .50662 L p F P
0 0 0 r
s
.24 .35 .67 r
.47508 .54161 m
.50305 .56264 L
s
.50305 .56264 m
.52775 .5384 L
s
.83 .24 .1 r
.45866 .54416 m
.46208 .53658 L
s
.46208 .53658 m
.4627 .53521 L
s
.2373 .55737 m
.28227 .57115 L
s
.28227 .57115 m
.2968 .55363 L
s
.862 .236 .097 r
.45904 .39012 m .43775 .38215 L .43752 .36009 L p F P
0 0 0 r
s
.24 .35 .67 r
.43902 .36066 m
.44107 .35815 L
s
.974 .275 .115 r
.48186 .4501 m .50078 .45689 L .50071 .48483 L p F P
0 0 0 r
s
.947 .265 .11 r
.50078 .45689 m .48186 .4501 L .4807 .42286 L p F P
0 0 0 r
s
1 .289 .122 r
.47568 .53255 m .46314 .52835 L .45532 .49761 L p F P
0 0 0 r
s
1 .289 .122 r
.45532 .49761 m .47055 .50282 L .47568 .53255 L p F P
0 0 0 r
s
.83 .24 .1 r
.41586 .53006 m
.45866 .54416 L
s
.974 .275 .115 r
.50071 .48483 m .48353 .4788 L .48186 .4501 L p F P
0 0 0 r
s
.24 .35 .67 r
.46907 .53549 m
.47508 .54161 L
s
.46799 .53438 m
.46907 .53549 L
s
.487 .27307 m
.5114 .24253 L
s
.487 .27307 m
.47718 .2935 L
s
.64386 .54453 m
.66989 .54211 L
s
.66989 .54211 m
.69823 .51737 L
s
.47508 .54161 m
.49923 .51684 L
s
.81266 .40191 m
.80796 .42439 L
s
.83 .24 .1 r
.37325 .33698 m
.3733 .31316 L
s
.32931 .29616 m
.3733 .31316 L
s
.2968 .55363 m
.34119 .5675 L
s
.34119 .5675 m
.35674 .54415 L
s
.947 .265 .11 r
.46033 .41539 m .4807 .42286 L .48186 .4501 L p F P
0 0 0 r
s
.911 .252 .104 r
.4807 .42286 m .46033 .41539 L .45904 .39012 L p F P
0 0 0 r
s
.995 .283 .118 r
.48565 .508 m .47055 .50282 L .46618 .47271 L p F P
0 0 0 r
s
.995 .283 .118 r
.46618 .47271 m .48353 .4788 L .48565 .508 L p F P
0 0 0 r
s
.83 .24 .1 r
.35674 .54415 m
.40041 .55814 L
s
.40041 .55814 m
.41586 .53006 L
s
.911 .252 .104 r
.43775 .38215 m .45904 .39012 L .46033 .41539 L p F P
0 0 0 r
s
.192 .282 .584 r
.45532 .49761 m .447 .50662 L .43917 .47717 L p F P
0 0 0 r
s
.213 .315 .645 r
.447 .50662 m .45532 .49761 L .46314 .52835 L p F P
0 0 0 r
s
.83 .24 .1 r
.45523 .50681 m
.4566 .50728 L
s
.24 .35 .67 r
.45921 .50686 m
.45996 .50605 L
s
.136 .196 .427 r
.42869 .42087 m .43972 .40783 L .44339 .43629 L p F P
0 0 0 r
s
.136 .196 .427 r
.44339 .43629 m .43299 .44826 L .42869 .42087 L p F P
0 0 0 r
s
.83 .24 .1 r
.41396 .38232 m
.43656 .39071 L
s
.24 .35 .67 r
.55792 .55464 m
.58815 .5648 L
s
.58815 .5648 m
.61484 .54044 L
s
.83 .24 .1 r
.41683 .35352 m
.37325 .33698 L
s
.41396 .38232 m
.41683 .35352 L
s
.974 .275 .115 r
.46274 .44323 m .48186 .4501 L .48353 .4788 L p F P
0 0 0 r
s
.947 .265 .11 r
.48186 .4501 m .46274 .44323 L .46033 .41539 L p F P
0 0 0 r
s
.974 .275 .115 r
.48353 .4788 m .46618 .47271 L .46274 .44323 L p F P
0 0 0 r
s
.83 .24 .1 r
.17938 .55462 m
.19121 .54325 L
s
.24 .35 .67 r
.52661 .22739 m
.55199 .1957 L
s
.52661 .22739 m
.5114 .24253 L
s
.69823 .51737 m
.72015 .50901 L
s
.72015 .50901 m
.74975 .4834 L
s
.995 .283 .118 r
.47055 .50282 m .45532 .49761 L .44866 .46656 L p F P
0 0 0 r
s
.995 .283 .118 r
.44866 .46656 m .46618 .47271 L .47055 .50282 L p F P
0 0 0 r
s
.83 .24 .1 r
.42999 .49823 m
.45523 .50681 L
s
.24 .35 .67 r
.45996 .50605 m
.47393 .49109 L
s
.166 .243 .512 r
.44866 .46656 m .43917 .47717 L .43299 .44826 L p F P
0 0 0 r
s
.192 .282 .584 r
.43917 .47717 m .44866 .46656 L .45532 .49761 L p F P
0 0 0 r
s
.166 .243 .512 r
.43299 .44826 m .44339 .43629 L .44866 .46656 L p F P
0 0 0 r
s
.947 .265 .11 r
.43972 .40783 m .46033 .41539 L .46274 .44323 L p F P
0 0 0 r
s
.83 .24 .1 r
.4543 .41318 m
.45526 .40792 L
s
.911 .252 .104 r
.46033 .41539 m .43972 .40783 L .43775 .38215 L p F P
0 0 0 r
s
.83 .24 .1 r
.43656 .39071 m
.43778 .39117 L
s
.24 .35 .67 r
.44017 .39008 m
.45238 .37546 L
s
.43952 .39086 m
.44017 .39008 L
s
.83 .24 .1 r
.28422 .27873 m
.28251 .26123 L
s
.24 .35 .67 r
.44974 .34751 m
.47355 .31832 L
s
.44974 .34751 m
.45238 .37546 L
s
.974 .275 .115 r
.46618 .47271 m .44866 .46656 L .44339 .43629 L p F P
0 0 0 r
s
.974 .275 .115 r
.44339 .43629 m .46274 .44323 L .46618 .47271 L p F P
0 0 0 r
s
.24 .35 .67 r
.45032 .46573 m
.45319 .46252 L
s
.45021 .46586 m
.45032 .46573 L
s
.83 .24 .1 r
.44197 .46439 m
.44724 .46624 L
s
.44724 .46624 m
.44746 .46632 L
s
.24 .35 .67 r
.44822 .45271 m
.45319 .46252 L
s
.947 .265 .11 r
.46274 .44323 m .44339 .43629 L .43972 .40783 L p F P
0 0 0 r
s
.24 .35 .67 r
.44329 .42663 m
.46165 .40532 L
s
.55199 .1957 m
.57186 .18652 L
s
.83 .24 .1 r
.372 .5156 m
.41586 .53006 L
s
.41586 .53006 m
.42999 .49823 L
s
.19121 .54325 m
.2373 .55737 L
s
.2373 .55737 m
.25129 .53942 L
s
.24 .35 .67 r
.74975 .4834 m
.76646 .46958 L
s
.76646 .46958 m
.79724 .44297 L
s
.83 .24 .1 r
.44197 .46439 m
.44328 .45955 L
s
.44328 .45955 m
.44498 .45325 L
s
.40767 .41474 m
.43895 .42605 L
s
.43895 .42605 m
.44145 .42695 L
s
.24 .35 .67 r
.52775 .5384 m
.55792 .55464 L
s
.55792 .55464 m
.5842 .52984 L
s
.83 .24 .1 r
.32859 .32001 m
.32931 .29616 L
s
.28422 .27873 m
.32931 .29616 L
s
.24 .35 .67 r
.61484 .54044 m
.64386 .54453 L
s
.64386 .54453 m
.67204 .51949 L
s
.83 .24 .1 r
.25129 .53942 m
.2968 .55363 L
s
.2968 .55363 m
.31198 .52982 L
s
.31198 .52982 m
.35674 .54415 L
s
.35674 .54415 m
.372 .5156 L
s
.38609 .4833 m
.42999 .49823 L
s
.42999 .49823 m
.44197 .46439 L
s
.39821 .44904 m
.44197 .46439 L
s
.24 .35 .67 r
.47718 .2935 m
.50176 .26292 L
s
.47718 .2935 m
.47355 .31832 L
s
.83 .24 .1 r
.40767 .41474 m
.41396 .38232 L
s
.36983 .36593 m
.41396 .38232 L
s
.37325 .33698 m
.32859 .32001 L
s
.36983 .36593 m
.37325 .33698 L
s
.24 .35 .67 r
.80796 .42439 m
.79724 .44297 L
s
.45319 .46252 m
.47728 .4356 L
s
.45319 .46252 m
.47393 .49109 L
s
.49923 .51684 m
.52775 .5384 L
s
.52775 .5384 m
.55352 .51309 L
s
.47393 .49109 m
.49858 .46468 L
s
.47393 .49109 m
.49923 .51684 L
s
.45238 .37546 m
.47655 .3465 L
s
.45238 .37546 m
.46165 .40532 L
s
.5114 .24253 m
.53688 .21065 L
s
.5114 .24253 m
.50176 .26292 L
s
.67204 .51949 m
.69823 .51737 L
s
.69823 .51737 m
.72782 .49153 L
s
.49923 .51684 m
.52445 .49099 L
s
.83 .24 .1 r
.32703 .50078 m
.372 .5156 L
s
.372 .5156 m
.38609 .4833 L
s
.19121 .54325 m
.20464 .52485 L
s
.39821 .44904 m
.40767 .41474 L
s
.36309 .39862 m
.40767 .41474 L
s
.24 .35 .67 r
.5842 .52984 m
.61484 .54044 L
s
.61484 .54044 m
.64271 .51501 L
s
.83 .24 .1 r
.28279 .30262 m
.28422 .27873 L
s
.20464 .52485 m
.25129 .53942 L
s
.25129 .53942 m
.26609 .51512 L
s
.26609 .51512 m
.31198 .52982 L
s
.31198 .52982 m
.32703 .50078 L
s
.24 .35 .67 r
.53688 .21065 m
.55199 .1957 L
s
.72782 .49153 m
.74975 .4834 L
s
.74975 .4834 m
.78067 .45665 L
s
.83 .24 .1 r
.34108 .468 m
.38609 .4833 L
s
.38609 .4833 m
.39821 .44904 L
s
.35334 .43329 m
.39821 .44904 L
s
.36309 .39862 m
.36983 .36593 L
s
.32458 .34913 m
.36983 .36593 L
s
.32859 .32001 m
.28279 .30262 L
s
.32458 .34913 m
.32859 .32001 L
s
.24 .35 .67 r
.47355 .31832 m
.49842 .28784 L
s
.47355 .31832 m
.47655 .3465 L
s
.46165 .40532 m
.48629 .37673 L
s
.46165 .40532 m
.47728 .4356 L
s
.79724 .44297 m
.78067 .45665 L
s
.55352 .51309 m
.5842 .52984 L
s
.5842 .52984 m
.61165 .50393 L
s
.64271 .51501 m
.67204 .51949 L
s
.67204 .51949 m
.70146 .49333 L
s
.83 .24 .1 r
.28091 .48558 m
.32703 .50078 L
s
.32703 .50078 m
.34108 .468 L
s
.35334 .43329 m
.36309 .39862 L
s
.31738 .3821 m
.36309 .39862 L
s
.24 .35 .67 r
.50176 .26292 m
.52744 .23097 L
s
.50176 .26292 m
.49842 .28784 L
s
.47728 .4356 m
.50245 .40747 L
s
.47728 .4356 m
.49858 .46468 L
s
.83 .24 .1 r
.20464 .52485 m
.21902 .50005 L
s
.21902 .50005 m
.26609 .51512 L
s
.26609 .51512 m
.28091 .48558 L
s
.29492 .45231 m
.34108 .468 L
s
.34108 .468 m
.35334 .43329 L
s
.30731 .41715 m
.35334 .43329 L
s
.24 .35 .67 r
.52445 .49099 m
.55352 .51309 L
s
.55352 .51309 m
.58045 .48664 L
s
.83 .24 .1 r
.31738 .3821 m
.32458 .34913 L
s
.27817 .3319 m
.32458 .34913 L
s
.27817 .3319 m
.28279 .30262 L
s
.24 .35 .67 r
.49858 .46468 m
.52433 .43709 L
s
.49858 .46468 m
.52445 .49099 L
s
.47655 .3465 m
.50181 .31625 L
s
.47655 .3465 m
.48629 .37673 L
s
.52744 .23097 m
.53688 .21065 L
s
.70146 .49333 m
.72782 .49153 L
s
.72782 .49153 m
.75874 .46454 L
s
.52445 .49099 m
.55081 .46396 L
s
.61165 .50393 m
.64271 .51501 L
s
.64271 .51501 m
.67184 .48843 L
s
.83 .24 .1 r
.2336 .46998 m
.28091 .48558 L
s
.28091 .48558 m
.29492 .45231 L
s
.30731 .41715 m
.31738 .3821 L
s
.27048 .36514 m
.31738 .3821 L
s
.24 .35 .67 r
.78067 .45665 m
.75874 .46454 L
s
.83 .24 .1 r
.21902 .50005 m
.2336 .46998 L
s
.24 .35 .67 r
.49842 .28784 m
.52441 .25597 L
s
.49842 .28784 m
.50181 .31625 L
s
.83 .24 .1 r
.24756 .4362 m
.29492 .45231 L
s
.29492 .45231 m
.30731 .41715 L
s
.26009 .40058 m
.30731 .41715 L
s
.24 .35 .67 r
.48629 .37673 m
.51204 .34683 L
s
.48629 .37673 m
.50245 .40747 L
s
.83 .24 .1 r
.27048 .36514 m
.27817 .3319 L
s
.24 .35 .67 r
.58045 .48664 m
.61165 .50393 L
s
.61165 .50393 m
.64035 .47684 L
s
.67184 .48843 m
.70146 .49333 L
s
.70146 .49333 m
.73224 .46598 L
s
.52441 .25597 m
.52744 .23097 L
s
.50245 .40747 m
.52878 .37805 L
s
.50245 .40747 m
.52433 .43709 L
s
.83 .24 .1 r
.2336 .46998 m
.24756 .4362 L
s
.26009 .40058 m
.27048 .36514 L
s
.24 .35 .67 r
.55081 .46396 m
.58045 .48664 L
s
.58045 .48664 m
.60862 .45898 L
s
.52433 .43709 m
.55128 .40822 L
s
.52433 .43709 m
.55081 .46396 L
s
.50181 .31625 m
.52824 .2846 L
s
.50181 .31625 m
.51204 .34683 L
s
.75874 .46454 m
.73224 .46598 L
s
.55081 .46396 m
.57838 .4357 L
s
.83 .24 .1 r
.24756 .4362 m
.26009 .40058 L
s
.24 .35 .67 r
.64035 .47684 m
.67184 .48843 L
s
.67184 .48843 m
.70231 .46062 L
s
.52824 .2846 m
.52441 .25597 L
s
.51204 .34683 m
.53899 .31555 L
s
.51204 .34683 m
.52878 .37805 L
s
.60862 .45898 m
.64035 .47684 L
s
.64035 .47684 m
.67039 .44848 L
s
.73224 .46598 m
.70231 .46062 L
s
.52878 .37805 m
.55634 .34725 L
s
.52878 .37805 m
.55128 .40822 L
s
.57838 .4357 m
.60862 .45898 L
s
.60862 .45898 m
.63812 .43002 L
s
.55128 .40822 m
.57949 .378 L
s
.55128 .40822 m
.57838 .4357 L
s
.53899 .31555 m
.52824 .2846 L
s
.57838 .4357 m
.60725 .4061 L
s
.70231 .46062 m
.67039 .44848 L
s
.55634 .34725 m
.53899 .31555 L
s
.67039 .44848 m
.63812 .43002 L
s
.57949 .378 m
.55634 .34725 L
s
.63812 .43002 m
.60725 .4061 L
s
.60725 .4061 m
.57949 .378 L
s
0 0 0 r
.25 Mabswid
.36195 .03848 m
.93295 .30234 L
s
.93295 .30234 m
.99253 .5665 L
s
.99253 .5665 m
.33874 .3169 L
s
.33874 .3169 m
.36195 .03848 L
s
.11236 .44767 m
.06528 .69847 L
s
.06528 .69847 m
.33874 .3169 L
s
.33874 .3169 m
.36195 .03848 L
s
.36195 .03848 m
.11236 .44767 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{500, 500},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40007d0001m2000`400?l00000o`00003oo`3ooooe
0?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3o
m^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40
oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?of
k_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3o
ool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^
m03om^h10?ooo`00o`3om^kd0?ofkP40oooo002d0?ofkP800000o`3om^hn0?ofkP40oooo002c0?of
kP80000000<0ooK^000000000000o`3om^hl0?ofkP40oooo002c0?ofkP8000000`3om^h200000?l0
ooK^>P3om^h10?ooo`00/P3om^h00`000000ooK^000000050?ofkP800000o`3om^hh0?ofkP40oooo
002b0?ofkP030000003om^h0000000L0ooK^0P00003o0?ofkSH0ooK^0@3oool00;40ooK^00@00000
0?ofkP3om^h000002@3om^h200000?l0ooK^=03om^h10?ooo`00/03om^h01@000000ooK^0?ofkP3o
m^h0000000/0ooK^0`00003o0?ofkS40ooK^0@3oool00;00ooK^00@000000?ofkP3om^h000003`3o
m^h200000?l0ooK^;`3om^h10?ooo`00[`3om^h01@000000ooK^0?ofkP3om^h000000140ooK^0P00
003o0?ofkRd0ooK^0@3oool00:l0ooK^00D000000?ofkP3om^h0ooK^0000000C0?ofkP800000o`3o
m^h[0?ofkP40oooo002^0?ofkP030000003om^h0ooK^0080ooK^00<000000?ofkP3om^h04`3om^h2
00000?l0ooK^:@3om^h10?ooo`00[@3om^h00`000000ooK^0?ofkP030?ofkP030000003om^h0ooK^
01D0ooK^0`00003o0?ofkRH0ooK^0@3oool00:d0ooK^00<000000?ofkP3om^h00`3om^h00`000000
ooK^0?ofkP0H0?ofkP800000o`3om^hT0?ofkP40oooo002/0?ofkP030000003om^h0ooK^00@0ooK^
00<000000?ofkP3om^h06P3om^h200000?l0ooK^8P3om^h10?ooo`00Z`3om^h00`000000ooK^0?of
kP050?ofkP030000003om^h0ooK^01`0ooK^0P00003o0?ofkR00ooK^0@3oool00:/0ooK^00<00000
0?ofkP3om^h01@3om^h00`000000ooK^0?ofkP0N0?ofkP800000o`3om^hN0?ofkP40oooo002Z0?of
kP030000003om^h0ooK^00H0ooK^00<000000?ofkP3om^h0803om^h200000?l0ooK^703om^h10?oo
o`00ZP3om^h00`000000ooK^0?ofkP060?ofkP030000003om^h0ooK^0280ooK^0`00003o0?ofkQT0
ooK^0@3oool00:T0ooK^00<000000?ofkP3om^h01`3om^h00`000000ooK^0?ofkP0U0?ofkP800000
o`3om^hG0?ofkP40oooo002X0?ofkP030000003om^h0ooK^00L0ooK^00<000000?ofkP3om^h0:03o
m^h200000?l0ooK^5@3om^h10?ooo`00Z03om^h00`000000ooK^0?ofkP070?ofkP030000003om^h0
ooK^02X0ooK^0P00003o0?ofkQ<0ooK^0@3oool00:L0ooK^00<000000?ofkP3om^h0203om^h00`00
0000ooK^0?ofkP0/0?ofkP800000o`3om^hA0?ofkP40oooo002W0?ofkP030000003om^h0ooK^00P0
ooK^00<000000?ofkP3om^h0;P3om^h200000?l0ooK^3`3om^h10?ooo`00YP3om^h00`000000ooK^
0?ofkP090?ofkP030000003om^h0ooK^0300ooK^0`00003o0?ofkP`0ooK^0@3oool00:D0ooK^00<0
00000?ofkP3om^h02P3om^h00`000000ooK^0?ofkP0c0?ofkP800000o`3om^h:0?ofkP40oooo002U
0?ofkP030000003om^h0ooK^00X0ooK^00<000000?ofkP3om^h0=@3om^h200000?l0ooK^203om^h1
0?ooo`00Y03om^h00`000000ooK^0?ofkP0;0?ofkP030000003om^h0ooK^03L0ooK^0P00003o0?of
kPH0ooK^0@3oool00:@0ooK^00<000000?ofkP3om^h02`3om^h00`000000ooK^0?ofkP0i0?ofkP80
0000o`3om^h40?ofkP40oooo002S0?ofkP030000003om^h0ooK^00`0ooK^00<000000?ofkP3om^h0
>`3om^h300000?l0ooK^0@3om^h10?ooo`00XP3om^h00`000000ooK^0?ofkP0=0?ofkP030000003o
m^h0ooK^03h0ooK^0P00003n0?ofkP40oooo002R0?ofkP030000003om^h0ooK^00d0ooK^00<00000
0?ofkP3om^h0@03om^h200000?`0ooK^0@3oool00:40ooK^00<000000?ofkP3om^h03P3om^h00`00
0000ooK^0?ofkP120?ofkP800000nP3om^h10?ooo`00X@3om^h00`000000ooK^0?ofkP0=0?ofkP03
0000003om^h0ooK^04D0ooK^0P00003h0?ofkP40oooo002P0?ofkP030000003om^h0ooK^00h0ooK^
00<000000?ofkP3om^h0A`3om^h200000?H0ooK^0@3oool009l0ooK^00<000000?ofkP3om^h03`3o
m^h00`000000ooK^0?ofkP190?ofkP<00000l`3om^h10?ooo`00W`3om^h00`000000ooK^0?ofkP0?
0?ofkP030000003om^h0ooK^04`0ooK^0P00003a0?ofkP40oooo002N0?ofkP030000003om^h0ooK^
0100ooK^00<000000?ofkP3om^h0CP3om^h200000>l0ooK^0@3oool009h0ooK^00<000000?ofkP3o
m^h0403om^h00`000000ooK^0?ofkP1@0?ofkP800000k@3om^h10?ooo`00W@3om^h00`000000ooK^
0?ofkP0A0?ofkP030000003om^h0ooK^0580ooK^0P00003[0?ofkP40oooo002L0?ofkP030000003o
m^h0ooK^0180ooK^00<000000?ofkP3om^h0E03om^h200000>T0ooK^0@3oool009`0ooK^00<00000
0?ofkP3om^h04P3om^h00`000000ooK^0?ofkP1F0?ofkP<00000iP3om^h10?ooo`00V`3om^h00`00
0000ooK^0?ofkP0C0?ofkP030000003om^h0ooK^05T0ooK^0P00003T0?ofkP40oooo002J0?ofkP03
0000003om^h0ooK^01@0ooK^00<000000?ofkP3om^h0F`3om^h200000>80ooK^0@3oool009X0ooK^
00<000000?ofkP3om^h0503om^h00`000000ooK^0?ofkP1M0?ofkP800000h03om^h10?ooo`00V@3o
m^h00`000000ooK^0?ofkP0E0?ofkP030000003om^h0ooK^05l0ooK^0P00003N0?ofkP40oooo002I
0?ofkP030000003om^h0ooK^01@0ooK^00<000000?ofkP3om^h0HP3om^h200000=`0ooK^0@3oool0
09P0ooK^00<000000?ofkP3om^h05@3om^h00`000000ooK^0?ofkP1T0?ofkP<00000f@3om^h10?oo
o`00U`3om^h00`000000ooK^0?ofkP0F0?ofkP030000003om^h0ooK^06L0ooK^0P00003G0?ofkP40
oooo002G0?ofkP030000003om^h0ooK^01H0ooK^00<000000?ofkP3om^h0J@3om^h200000=D0ooK^
0@3oool009H0ooK^00<000000?ofkP3om^h05`3om^h00`000000ooK^0?ofkP1[0?ofkP800000d`3o
m^h10?ooo`00UP3om^h00`000000ooK^0?ofkP0G0?ofkP030000003om^h0ooK^06d0ooK^0P00003A
0?ofkP40oooo002E0?ofkP030000003om^h0ooK^01P0ooK^00<000000?ofkP3om^h0K`3om^h30000
0<h0ooK^0@3oool009@0ooK^00<000000?ofkP3om^h06@3om^h00`000000ooK^0?ofkP1b0?ofkP80
0000c03om^h10?ooo`00U03om^h00`000000ooK^0?ofkP0I0?ofkP030000003om^h0ooK^07@0ooK^
0P00003:0?ofkP40oooo002C0?ofkP030000003om^h0ooK^01X0ooK^00<000000?ofkP3om^h0MP3o
m^h200000<P0ooK^0@3oool009<0ooK^00<000000?ofkP3om^h06P3om^h00`000000ooK^0?ofkP1h
0?ofkP800000aP3om^h10?ooo`00TP3om^h00`000000ooK^0?ofkP0K0?ofkP030000003om^h0ooK^
07X0ooK^0P0000340?ofkP40oooo002A0?ofkP030000003om^h0ooK^01/0ooK^00<000000?ofkP3o
m^h0O@3om^h300000<40ooK^0@3oool00940ooK^00<000000?ofkP3om^h06`3om^h00`000000ooK^
0?ofkP200?ofkP800000_`3om^h10?ooo`00T03om^h00`000000ooK^0?ofkP0L0?ofkP030000003o
m^h0ooK^0880ooK^0P00002m0?ofkP40oooo002@0?ofkP030000003om^h0ooK^01`0ooK^00<00000
0?ofkP3om^h0Q03om^h200000;/0ooK^0@3oool008l0ooK^00<000000?ofkP3om^h07@3om^h00`00
0000ooK^0?ofkP260?ofkP800000^@3om^h10?ooo`00SP3om^h00`000000ooK^0?ofkP0N0?ofkP03
0000003om^h0ooK^08P0ooK^0P00002g0?ofkP40oooo002>0?ofkP030000003om^h0ooK^01h0ooK^
00<000000?ofkP3om^h0RP3om^h300000;@0ooK^0@3oool008d0ooK^00<000000?ofkP3om^h07`3o
m^h00`000000ooK^0?ofkP2=0?ofkP800000/P3om^h10?ooo`00S03om^h00`000000ooK^0?ofkP0P
0?ofkP030000003om^h0ooK^08l0ooK^0P00002`0?ofkP40oooo002<0?ofkP030000003om^h0ooK^
0200ooK^00<000000?ofkP3om^h0T@3om^h200000:h0ooK^0@3oool008/0ooK^00<000000?ofkP3o
m^h08@3om^h00`000000ooK^0?ofkP2C0?ofkP800000[03om^h10?ooo`00R`3om^h00`000000ooK^
0?ofkP0Q0?ofkP030000003om^h0ooK^09D0ooK^0`00002Y0?ofkP40oooo002:0?ofkP030000003o
m^h0ooK^0280ooK^00<000000?ofkP3om^h0V03om^h200000:L0ooK^0@3oool008T0ooK^00<00000
0?ofkP3om^h08P3om^h00`000000ooK^0?ofkP2K0?ofkP800000Y@3om^h10?ooo`00R@3om^h00`00
0000ooK^0?ofkP0R0?ofkP030000003om^h0ooK^09d0ooK^0P00002S0?ofkP40oooo00280?ofkP03
0000003om^h0ooK^02<0ooK^00<000000?ofkP3om^h0MP3om^h903eIZb00ooK^0P00002Q0?ofkP40
oooo00280?ofkP030000003om^h0ooK^02<0ooK^00<000000?ofkP3om^h0L03om^h603eIZ`030?of
kP0mFJ/0ooK^00H0ooK^200mFJ/J0?ofkP800000W`3om^h10?ooo`00Q`3om^h00`000000ooK^0?of
kP0T0?ofkP030000003om^h0ooK^06/0ooK^1@0mFJ/60?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0
?EV[0?ofkP3om^h0100mFJ/H0?ofkP<00000W03om^h10?ooo`00QP3om^h00`000000ooK^0?ofkP0U
0?ofkP030000003om^h0ooK^06T0ooK^0`0mFJ/90?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[
0?ofkP3om^h01@3om^h303eIZaP0ooK^0P00002J0?ofkP40oooo00260?ofkP030000003om^h0ooK^
02D0ooK^00<000000?ofkP3om^h0IP3om^h303eIZ`030?ofkP0mFJ/0ooK^00T0ooK^00<0?EV[0?of
kP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP090?ofkP@0?EV[5P3om^h2000009P0ooK^0@3oool008D0
ooK^00<000000?ofkP3om^h09P3om^h00`000000ooK^0?ofkP1T0?ofkP80?EV[0`3om^h00`0mFJ/0
ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h03@3om^h303eIZaD0
ooK^0P00002F0?ofkP40oooo00250?ofkP030000003om^h0ooK^02H0ooK^00<000000?ofkP3om^h0
HP3om^h203eIZ`D0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eI
Z`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h00P0mFJ/E0?ofkP800000U03om^h10?ooo`00Q03o
m^h00`000000ooK^0?ofkP0W0?ofkP030000003om^h0ooK^0640ooK^00<0?EV[0?ofkP3om^h0103o
m^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h03P3o
m^h00`0mFJ/0ooK^0?ofkP030?ofkP80?EV[5@3om^h200000980ooK^0@3oool008<0ooK^00<00000
0?ofkP3om^h0:03om^h00`000000ooK^0?ofkP1P0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[
0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[
0?ofkP3om^h01P3om^h303eIZa@0ooK^0`00002?0?ofkP40oooo00230?ofkP030000003om^h0ooK^
02P0ooK^00<000000?ofkP3om^h0G`3om^h203eIZ`D0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0m
FJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h02@3om^h203eI
ZaD0ooK^0P00002=0?ofkP40oooo00220?ofkP030000003om^h0ooK^02T0ooK^00<000000?ofkP3o
m^h0GP3om^h203eIZ`D0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP03
03eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h0303om^h203eIZaD0ooK^0P00002;0?ofkP40
oooo00220?ofkP030000003om^h0ooK^02P0ooK^00<000000?ofkP3om^h0GP3om^h203eIZ`D0ooK^
00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00l0ooK^
00<0?EV[0?ofkP3om^h03`3om^h203eIZaD0ooK^0P0000290?ofkP40oooo00210?ofkP030000003o
m^h0ooK^02T0ooK^00<000000?ofkP3om^h0G@3om^h203eIZ`D0ooK^00<0?EV[0?ofkP3om^h0203o
m^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h0403o
m^h0100mFJ/0ooK^03eIZ`0mFJ/E0?ofkP800000Q`3om^h10?ooo`00P03om^h00`000000ooK^0?of
kP0Z0?ofkP030000003om^h0ooK^05`0ooK^0P0mFJ/50?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0
?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^0100ooK^00<0
?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP<00000Q03om^h10?ooo`00P03om^h0
0`000000ooK^0?ofkP0Z0?ofkP030000003om^h0ooK^05/0ooK^0P0mFJ/60?ofkP0303eIZ`3om^h0
ooK^00L0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0
ooK^0100ooK^00<0?EV[0?ofkP3om^h0103om^h203eIZaL0ooK^0P0000220?ofkP40oooo001o0?of
kP030000003om^h0ooK^02/0ooK^00<000000?ofkP3om^h0FP3om^h303eIZ`D0ooK^00<0?EV[0?of
kP3om^h01@3om^h903eIZ`L0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0@0?of
kP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h05P3om^h200000800ooK^0@3oool007l0
ooK^00<000000?ofkP3om^h0:`3om^h00`000000ooK^0?ofkP1I0?ofkP<0?EV[1@3om^h00`0mFJ/0
ooK^0?ofkP0603eIZ`030?ofkP0mFJ/0ooK^00H0ooK^200mFJ/?0?ofkP0303eIZ`3om^h0ooK^0100
ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP0G0?ofkP800000OP3om^h10?ooo`00
OP3om^h00`000000ooK^0?ofkP0/0?ofkP030000003om^h0ooK^05T0ooK^0P0mFJ/50?ofkP@0?EV[
1P3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00@0?EV[2`3om^h00`0mFJ/0ooK^
0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00/0ooK^0P0mFJ/I0?ofkP800000O03om^h10?ooo`00O@3o
m^h00`000000ooK^0?ofkP0]0?ofkP030000003om^h0ooK^05P0ooK^0P0mFJ/40?ofkP80?EV[2P3o
m^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00D0ooK^0`0mFJ/70?ofkP0303eIZ`3o
m^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0H0?ofkP800000NP3o
m^h10?ooo`00O@3om^h00`000000ooK^0?ofkP0]0?ofkP030000003om^h0ooK^05L0ooK^0`0mFJ/2
0?ofkP<0?EV[2P3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00P0ooK^100mFJ/2
0?ofkP0303eIZ`3om^h0ooK^0100ooK^00<0?EV[0?ofkP3om^h03`3om^h203eIZaX0ooK^0`00001g
0?ofkP40oooo001l0?ofkP030000003om^h0ooK^02h0ooK^00<000000?ofkP3om^h0EP3om^h00`0m
FJ/0ooK^03eIZ`0303eIZ`80ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP0;0?of
kP0303eIZ`3om^h0ooK^00d0ooK^0`0mFJ/A0?ofkP0303eIZ`3om^h0ooK^0180ooK^00<0?EV[0?of
kP3om^h06P3om^h2000007D0ooK^0@3oool007/0ooK^00<000000?ofkP3om^h0;`3om^h00`000000
ooK^0?ofkP1F0?ofkP@0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00/0
ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0203eIZ`h0ooK^00<0?EV[0?ofkP3o
m^h04P3om^h00`0mFJ/0ooK^03eIZ`0M0?ofkP800000L`3om^h10?ooo`00N`3om^h00`000000ooK^
0?ofkP0_0?ofkP030000003om^h0ooK^05D0ooK^100mFJ/30?ofkP0303eIZ`3om^h0ooK^00L0ooK^
00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00<0ooK^
0P0mFJ/;0?ofkP0303eIZ`3om^h0ooK^0180ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0N0?ofkP80
0000L@3om^h10?ooo`00NP3om^h00`000000ooK^0?ofkP0_0?ofkP030000003om^h0ooK^05D0ooK^
0P0mFJ/00`3om^h0?EV[0?ofkP020?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h0
2P3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00H0ooK^0P0mFJ/80?ofkP0303eI
Z`3om^h0ooK^0180ooK^00<0?EV[0?ofkP3om^h00`3om^h203eIZah0ooK^0P00001_0?ofkP40oooo
001j0?ofkP030000003om^h0ooK^02l0ooK^00<000000?ofkP3om^h0E03om^h203eIZ`80ooK^00@0
?EV[0?ofkP3om^h0?EV[2P3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00d0ooK^
00<0?EV[0?ofkP3om^h02@3om^h203eIZ`D0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^
0?ofkP050?ofkP0303eIZ`3om^h0ooK^01d0ooK^0P00001]0?ofkP40oooo001i0?ofkP030000003o
m^h0ooK^0300ooK^00<000000?ofkP3om^h0E03om^h203eIZ`030?ofkP0mFJ/0?EV[0080ooK^00<0
?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0
?EV[0?ofkP3om^h0303om^h203eIZ`80ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?of
kP070?ofkP0303eIZ`3om^h0ooK^01h0ooK^0`00001Z0?ofkP40oooo001h0?ofkP030000003om^h0
ooK^0340ooK^00<000000?ofkP3om^h0D`3om^h203eIZ`060?ofkP0mFJ/0ooK^03eIZ`3om^h0?EV[
2@3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h0
3`3om^h203eIZaD0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP0P0?ofkP800000
J03om^h10?ooo`00N03om^h00`000000ooK^0?ofkP0a0?ofkP030000003om^h0ooK^0580ooK^0P0m
FJ/20?ofkP80?EV[00<0ooK^03eIZ`3om^h0203om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3o
m^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h0403om^h0100mFJ/0ooK^03eIZ`0mFJ/B0?ofkP0303eI
Z`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h08@3om^h2000006H0ooK^0@3oool007L0ooK^00<0
00000?ofkP3om^h0<P3om^h00`000000ooK^0?ofkP1A0?ofkP80?EV[0P3om^h0100mFJ/0ooK^03eI
Z`0mFJ/:0?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^
0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^
0?ofkP0=0?ofkP80?EV[8`3om^h2000006@0ooK^0@3oool007L0ooK^00<000000?ofkP3om^h0<P3o
m^h00`000000ooK^0?ofkP1A0?ofkP0403eIZ`3om^h0ooK^03eIZ`80ooK^00<0?EV[0?ofkP3om^h0
203om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h0
3`3om^h00`0mFJ/0ooK^0?ofkP040?ofkP80?EV[3@3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0303eI
Z`3om^h0ooK^0280ooK^0P00001R0?ofkP40oooo001f0?ofkP030000003om^h0ooK^03<0ooK^00<0
00000?ofkP3om^h0D03om^h203eIZ`030?ofkP0mFJ/0ooK^0080ooK^00<0?EV[0?ofkP3om^h01@3o
m^h903eIZ`L0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0303eIZ`3o
m^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP0303eIZ`3o
m^h0ooK^02<0ooK^0P00001P0?ofkP40oooo001e0?ofkP030000003om^h0ooK^03@0ooK^00<00000
0?ofkP3om^h0C`3om^h203eIZ`030?ofkP0mFJ/0ooK^0080ooK^0P0mFJ/00`3om^h0?EV[03eIZ`04
03eIZ`030?ofkP0mFJ/0ooK^00H0ooK^2@0mFJ/=0?ofkP0303eIZ`3om^h0ooK^0100ooK^00<0?EV[
0?ofkP3om^h0203om^h203eIZ`P0ooK^00<0?EV[0?ofkP3om^h0503om^h00`0mFJ/0ooK^0?ofkP0T
0?ofkP<00000G@3om^h10?ooo`00M@3om^h00`000000ooK^0?ofkP0=0?ofkP@0e3dI8`3om^h00`00
0000ooK^0?ofkP1>0?ofkP80?EV[00<0ooK^03eIZ`3om^h00P3om^h403eIZ`H0ooK^00<0?EV[0?of
kP3om^h02`3om^h0100mFJ/0ooK^0?ofkP3om^h403eIZ`P0ooK^00<0?EV[0?ofkP3om^h0403om^h0
0`0mFJ/0ooK^0?ofkP0;0?ofkP80?EV[1P3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0
?EV[02P0ooK^0P00001K0?ofkP40oooo001d0?ofkP030000003om^h0ooK^00/0ooK^0`3D?AT30?of
kP<0e3dI8@3om^h00`000000ooK^0?ofkP1>0?ofkP0503eIZ`3om^h0ooK^03eIZ`3om^h00P0mFJ/0
0`3om^h0?EV[0?ofkP060?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h01P3om^h4
03eIZ`<0ooK^00<0?EV[0?ofkP3om^h0403om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0
ooK^0080ooK^00<0?EV[0?ofkP3om^h04`3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[02T0ooK^0P00
001I0?ofkP40oooo001d0?ofkP030000003om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h00P3D?AT4
0?ofkP@0e3dI7P3om^h00`000000ooK^0?ofkP1=0?ofkP80?EV[00<0ooK^03eIZ`0mFJ/00P0mFJ/2
0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP0;
0?ofkP@0?EV[4@3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP80?EV[00<0ooK^03eIZ`3om^h0503om^h0
0`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^02P0ooK^0P00001G0?ofkP40oooo001c0?of
kP030000003om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h00`3om^h20=@m6@80ooK^00<0e3dI0?of
kP3D?AT0103D?ATK0?ofkP030000003om^h0ooK^04`0ooK^0P0mFJ/00`3om^h0?EV[03eIZ`020?of
kP0403eIZ`3om^h0ooK^03eIZ`H0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP0<
0?ofkP0303eIZ`3om^h0ooK^0080?EV[3P3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0
ooK^01<0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP0Y0?ofkP800000E@3om^h1
0?ooo`00LP3om^h00`000000ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00H0ooK^103D?AT30?of
kP@0e3dI603om^h00`000000ooK^0?ofkP1<0?ofkP@0?EV[0`3om^h01@0mFJ/0ooK^0?ofkP3om^h0
?EV[00D0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0
ooK^00<0ooK^0P0mFJ/;0?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP0mFJ/04`3om^h0
0`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^02X0ooK^0`00001B0?ofkP40oooo001b0?of
kP030000003om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h02P3om^h20=@m6@@0ooK^1@3D?ATE0?of
kP030000003om^h0ooK^04/0ooK^100mFJ/30?ofkP0403eIZ`3om^h0ooK^0?ofkP80?EV[103om^h0
0`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h01P3om^h3
03eIZ`P0ooK^00<0?EV[0?ofkP3om^h04P3om^h0100mFJ/0ooK^0?ofkP3om^h203eIZa00ooK^00<0
?EV[0?ofkP3om^h02@3om^h203eIZbd0ooK^0P00001@0?ofkP40oooo001a0?ofkP030000003om^h0
ooK^00T0ooK^0P3D?AT=0?ofkP<0e3dI1@3om^h50=@m6A80ooK^00<000000?ofkP3om^h0B`3om^h0
100mFJ/0ooK^03eIZ`0mFJ/20?ofkP0703eIZ`3om^h0ooK^0?ofkP0mFJ/0ooK^03eIZ`030?ofkP03
03eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP090?ofkP80
?EV[1@3om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3o
m^h0303om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^02`0ooK^0P00001>0?ofkP40
oooo001a0?ofkP030000003om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h00P3D?AT;0?ofkP80e3dI
00@0ooK^0=@m6@3D?AT0e3dI1@3om^h40=@m6A00ooK^00<000000?ofkP3om^h0BP3om^h0100mFJ/0
ooK^03eIZ`0mFJ/20?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP0mFJ/00P3om^h00`0m
FJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h0303om^h203eI
Z`80ooK^00<0?EV[0?ofkP3om^h04P3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^
00/0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0]0?ofkP800000C03om^h10?oo
o`00L03om^h00`000000ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00<0ooK^0`3D?AT80?ofkP04
0=@m6@3om^h0e3dI0=@m6@80ooK^0P3D?AT60?ofkP@0e3dI3@3om^h00`000000ooK^0?ofkP190?of
kP80?EV[00<0ooK^03eIZ`3om^h00P3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00<0ooK^0P0mFJ/=
0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h03`3om^h203eIZa@0ooK^00<0?EV[
0?ofkP3om^h0203om^h203eIZ`X0ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP0^
0?ofkP800000BP3om^h10?ooo`00K`3om^h00`000000ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^
00H0ooK^0P3D?AT60?ofkP040=@m6@3om^h0ooK^0?ofkP<0e3dI00<0ooK^0=@m6@3D?AT00`3om^h2
0=@m6@030?ofkP3D?AT0e3dI0080e3dI2`3om^h00`000000ooK^0?ofkP180?ofkP80?EV[00<0ooK^
03eIZ`0mFJ/00P3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00@0ooK^0P0mFJ/<0?ofkP0303eIZ`3o
m^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h0403om^h0100mFJ/0ooK^03eIZ`0mFJ/A0?ofkP0303eI
Z`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP0303eI
Z`3om^h0ooK^02l0ooK^0P0000180?ofkP40oooo001_0?ofkP030000003om^h0ooK^00P0ooK^00<0
e3dI0?ofkP3om^h02@3om^h30=@m6@<0ooK^00<0e3dI0?ofkP3om^h0103om^h20=@m6@040?ofkP3D
?AT0e3dI0=@m6@H0ooK^103D?AT80?ofkP030000003om^h0ooK^04L0ooK^0P0mFJ/01P3om^h0?EV[
0?ofkP0mFJ/0ooK^03eIZ`<0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP0;0?of
kP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h0403om^h00`0mFJ/0ooK^0?ofkP020?of
kP80?EV[3P3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?of
kP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP0`0?ofkP<00000A@3om^h10?ooo`00KP3om^h00`000000
ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00d0ooK^0P3D?AT00`3om^h0e3dI0?ofkP070?ofkP<0
e3dI00<0ooK^0=@m6@3D?AT01@3om^h00`3D?AT0ooK^0=@m6@030=@m6@D0ooK^00<000000?ofkP3o
m^h0A`3om^h00`0mFJ/0ooK^0?ofkP0203eIZ`030?ofkP0mFJ/0ooK^0080ooK^00<0?EV[0?ofkP3o
m^h00`3om^h203eIZ``0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP03
03eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP80
?EV[0`3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0?EV[03@0ooK^0P0000130?ofkP40
oooo001]0?ofkP030000003om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h0403om^h30=@m6@H0ooK^
00@0e3dI0?ofkP3om^h0ooK^1P3D?AT30?ofkP030=@m6@3om^h0ooK^00@0e3dI0`3om^h00`000000
ooK^0?ofkP160?ofkP0503eIZ`3om^h0ooK^03eIZ`3om^h00P0mFJ/30?ofkP0303eIZ`3om^h0ooK^
0080ooK^200mFJ/70?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h04@3om^h00`0m
FJ/0ooK^0?ofkP060?ofkP80?EV[2@3om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP0303eIZ`3om^h0?EV[
01D0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0e0?ofkP800000@@3om^h10?ooo`00K@3om^h00`00
0000ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^0180ooK^0`3D?AT20?ofkP80e3dI1`3om^h20=@m
6@030?ofkP3D?AT0e3dI0080e3dI1@3om^h40=@m6@030000003om^h0ooK^04D0ooK^0P0mFJ/0103o
m^h0?EV[0?ofkP3om^h203eIZ`<0ooK^1P0mFJ/20?ofkP0303eIZ`3om^h0ooK^0080ooK^2@0mFJ/=
0?ofkP0303eIZ`3om^h0ooK^0100ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP05
0?ofkP0303eIZ`3om^h0ooK^01@0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP03
0?ofkP0303eIZ`3om^h0ooK^03@0ooK^0P00000o0?ofkP40oooo001/0?ofkP030000003om^h0ooK^
00P0ooK^0P3D?ATD0?ofkP030=@m6@3om^h0ooK^00<0e3dI2P3om^h30=@m6@030?ofkP3D?AT0e3dI
00L0ooK^00@0e3dI0000003D?AT0e3dIA03om^h203eIZ`030?ofkP0mFJ/0ooK^0080ooK^00<0?EV[
0?ofkP0mFJ/00`0mFJ/30?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/02@3om^h0100mFJ/0ooK^0?of
kP3om^h403eIZ`P0ooK^00<0?EV[0?ofkP3om^h0403om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP80?EV[
103om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP0303eIZ`3om^h0?EV[01<0ooK^00<0?EV[0?ofkP3om^h0
103om^h00`0mFJ/0ooK^0?ofkP0f0?ofkP800000?@3om^h10?ooo`00K03om^h00`000000ooK^0?of
kP070?ofkP030=@m6@3om^h0ooK^00<0e3dI4@3om^h0103D?AT0ooK^0?ofkP3D?AT20?ofkP80e3dI
2`3om^h60=@m6@D0ooK^00<000000=@m6@3D?AT00P3D?AU10?ofkP80?EV[00<0ooK^03eIZ`3om^h0
0P3om^h303eIZ`030?ofkP0mFJ/0ooK^00@0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`080?ofkP03
03eIZ`3om^h0ooK^00H0ooK^100mFJ/30?ofkP0303eIZ`3om^h0ooK^0100ooK^00<0?EV[0?ofkP3o
m^h03P3om^h203eIZ`030?ofkP0mFJ/0ooK^01D0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0A0?of
kP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h0=`3om^h2000003/0ooK^0@3oool006/0
ooK^00<000000?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP030?ofkP<0e3dI3P3om^h30=@m6@D0
ooK^0`3D?AT:0?ofkP<0e3dI00@0ooK^0=@m6@3D?AT0e3dI0P3om^h010000000ooK^0?ofkP3om^h4
0=@m6Cd0ooK^0P0mFJ/20?ofkP0803eIZ`3om^h0?EV[03eIZ`3om^h0?EV[0?ofkP0mFJ/50?ofkP03
03eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP@0
?EV[4@3om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP0303eIZ`3om^h0ooK^01@0ooK^00<0?EV[0?ofkP3o
m^h00`3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3o
m^h0>03om^h3000003P0ooK^0@3oool006X0ooK^00<000000?ofkP3om^h0203om^h00`3D?AT0ooK^
0?ofkP070?ofkP80e3dI303om^h50=@m6@H0ooK^0`3D?AT80?ofkP040=@m6@3om^h0e3dI0=@m6@80
ooK^00<0e3dI0000003om^h00P3om^h20=@m6@80ooK^0`3D?ATk0?ofkP80?EV[00<0ooK^03eIZ`0m
FJ/00P0mFJ/0103om^h0?EV[0?ofkP0mFJ/50?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?of
kP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^0080?EV[3P3om^h00`0m
FJ/0ooK^0?ofkP0A0?ofkP0303eIZ`3om^h0?EV[01@0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0m
FJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h0>P3om^h20000
03H0ooK^0@3oool006X0ooK^00<000000?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP<0
e3dI2@3om^h20=@m6@<0ooK^0`3D?AT60?ofkP80e3dI1P3om^h0103D?AT0ooK^0?ofkP3om^h30=@m
6@040000003D?AT0e3dI0=@m6@H0ooK^103D?ATg0?ofkP80?EV[00<0ooK^03eIZ`0mFJ/00P3om^h0
1@0mFJ/0ooK^03eIZ`3om^h0?EV[00@0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?of
kP030?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h00`3om^h203eIZ`/0ooK^00<0
?EV[0?ofkP3om^h04@3om^h0100mFJ/0ooK^0?ofkP3om^h203eIZa40ooK^00<0?EV[0?ofkP3om^h0
1`3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h0
>`3om^h2000003@0ooK^0@3oool006T0ooK^00<000000?ofkP3om^h0203om^h00`3D?AT0ooK^0?of
kP0=0?ofkP<0e3dI1P3om^h00`3D?AT0ooK^0?ofkP050?ofkP<0e3dI1@3om^h30=@m6@<0ooK^00<0
e3dI0?ofkP3om^h0103om^h010000000e3dI0=@m6@3om^h20=@m6@D0ooK^00<0e3dI0?ofkP3D?AT0
0P3D?ATd0?ofkP@0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP0203eIZ`@0ooK^00<0?EV[0?ofkP3om^h0
1P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h0
1@3om^h303eIZ`P0ooK^00<0?EV[0?ofkP3om^h0403om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eI
Z`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h02@3om^h203eIZ`T0ooK^00<0?EV[0?ofkP3om^h0
3@3om^h00`0mFJ/0ooK^0?ofkP0l0?ofkP800000<P3om^h10?ooo`00J@3om^h00`000000ooK^0?of
kP070?ofkP030=@m6@3om^h0ooK^0140ooK^0`3D?AT20?ofkP80e3dI2P3om^h20=@m6@H0ooK^103D
?AT50?ofkP040=@m6@000000ooK^0?ofkP80e3dI00@0ooK^0=@m6@3D?AT0e3dI0`3om^h00`3D?AT0
ooK^0?ofkP040=@m6C00ooK^100mFJ/30?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/01@3om^h00`0m
FJ/0ooK^0?ofkP050?ofkP80?EV[0`3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^
00T0ooK^0P0mFJ/50?ofkP0303eIZ`3om^h0ooK^0140ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0m
FJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0m
FJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^03h0ooK^0P00000`0?ofkP40oooo001X0?ofkP03
0000003om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h05@3om^h40=@m6@`0ooK^0`3D?AT60?ofkP80
e3dI0P3om^h20=@m6@030?ofkP000000ooK^00<0ooK^0`3D?AT01@3om^h0e3dI0=@m6@3om^h0e3dI
00@0ooK^103D?AT]0?ofkP80?EV[00<0ooK^03eIZ`0mFJ/00P3om^h0100mFJ/0ooK^0?ofkP3om^h2
03eIZ`@0ooK^00<0?EV[0?ofkP3om^h01@3om^h01P0mFJ/0ooK^0?ofkP0mFJ/0ooK^03eIZ`l0ooK^
00<0?EV[0?ofkP3om^h0303om^h203eIZ`80ooK^00<0?EV[0?ofkP3om^h04@3om^h00`0mFJ/0ooK^
0?ofkP070?ofkP80?EV[2P3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00<0ooK^
00<0?EV[0?ofkP3om^h0403om^h00`0mFJ/0ooK^0?ofkP0o0?ofkP<00000;@3om^h10?ooo`00I`3o
m^h00`000000ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^01D0ooK^00<0e3dI0?ofkP3om^h00P3D
?AT>0?ofkP<0e3dI103om^h40=@m6@80ooK^00<000000?ofkP3om^h01@3om^h60=@m6@H0ooK^103D
?ATY0?ofkP80?EV[00<0ooK^03eIZ`0mFJ/00P3om^h01`0mFJ/0ooK^0?ofkP3om^h0?EV[0?ofkP0m
FJ/00`3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0403eIZ`3om^h0ooK^0?ofkP80?EV[3`3om^h00`0m
FJ/0ooK^0?ofkP0?0?ofkP80?EV[4`3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^
00H0ooK^00<0?EV[0?ofkP3om^h0403om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[01@0ooK^00<0?EV[
0?ofkP3om^h0@@3om^h2000002/0ooK^0@3oool006L0ooK^00<000000?ofkP3om^h01`3om^h20=@m
6AL0ooK^00D0e3dI0?ofkP3om^h0e3dI0?ofkP030=@m6@h0ooK^0`3D?AT00`3om^h0e3dI0=@m6@02
0?ofkP80e3dI00<000000?ofkP3om^h0203om^h50=@m6@H0ooK^103D?ATV0?ofkP<0?EV[00<0ooK^
03eIZ`3om^h00P3om^h01`0mFJ/0ooK^0?ofkP3om^h0?EV[0?ofkP0mFJ/00P3om^h00`0mFJ/0ooK^
0?ofkP060?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/03`3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP04
03eIZ`3om^h0?EV[03eIZa00ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP040?of
kP0303eIZ`3om^h0ooK^0180ooK^00<0?EV[0?ofkP0mFJ/05P3om^h00`0mFJ/0ooK^0?ofkP120?of
kP800000:@3om^h10?ooo`00IP3om^h00`000000ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^0080
e3dI503om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00@0ooK^0P3D?AT?0?ofkP<0e3dI103om^h00`00
0000e3dI0?ofkP0:0?ofkPH0e3dI1@3om^h50=@m6B<0ooK^0P0mFJ/00`3om^h0?EV[03eIZ`020?of
kP0503eIZ`3om^h0ooK^0?ofkP0mFJ/00`3om^h00`0mFJ/0ooK^03eIZ`070?ofkP0303eIZ`3om^h0
ooK^0080ooK^0P0mFJ/>0?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h00P3om^h2
03eIZ`d0ooK^00<0?EV[0?ofkP3om^h03P3om^h203eIZ`<0ooK^00<0?EV[0?ofkP3om^h0503om^h0
0`0mFJ/0ooK^0?ofkP0D0?ofkP0303eIZ`3om^h0?EV[04D0ooK^0P00000W0?ofkP40oooo001V0?of
kP030000003om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h00P3om^h30=@m6A40ooK^00D0e3dI0?of
kP3om^h0ooK^0=@m6@060?ofkP<0e3dI303om^h20=@m6@030?ofkP3D?AT0e3dI0080ooK^00<00000
0?ofkP3D?AT00P3D?AT90?ofkP050=@m6@3om^h0e3dI0=@m6@3om^h00P3D?AT30?ofkP80e3dI00<0
ooK^0=@m6@3D?AT00P3D?ATP0?ofkP80?EV[00H0ooK^03eIZ`3om^h0?EV[0?ofkP0mFJ/30?ofkP03
03eIZ`3om^h0ooK^0080ooK^0P0mFJ/70?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP0m
FJ/03@3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3o
m^h02@3om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP0303eIZ`3om^h0?EV[01H0ooK^00<0?EV[0?ofkP0m
FJ/0503om^h0100mFJ/0ooK^0?ofkP0mFJ]70?ofkP8000009@3om^h10?ooo`00I@3om^h00`000000
ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00H0ooK^0P3D?AT>0?ofkP030=@m6@3om^h0ooK^0080
ooK^00<0e3dI0?ofkP3om^h01`3om^h20=@m6@T0ooK^00<0e3dI0?ofkP3D?AT00`3om^h20=@m6@03
0000003om^h0ooK^0080ooK^0P3D?AT70?ofkP040=@m6@3om^h0ooK^0?ofkPH0e3dI1@3om^h50=@m
6A`0ooK^0P0mFJ/20?ofkP80?EV[00<0ooK^03eIZ`3om^h00P3om^h00`0mFJ/0ooK^0?ofkP020?of
kPL0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0403eIZ`3om^h0ooK^03eIZ``0ooK^00<0?EV[
0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP070?ofkP80?EV[203om^h00`0mFJ/0ooK^0?ofkP0C
0?ofkP0303eIZ`3om^h0ooK^01@0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0B0?ofkP0303eIZ`3o
m^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h0AP3om^h2000002<0ooK^0@3oool006@0ooK^00<00000
0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP080?ofkP<0e3dI2P3om^h00`3D?AT0ooK^0?ofkP03
0?ofkP030=@m6@3om^h0ooK^00T0ooK^0`3D?AT50?ofkP040=@m6@3om^h0ooK^0=@m6@D0ooK^00<0
00000=@m6@3D?AT0103om^h30=@m6@D0ooK^00<0e3dI0?ofkP3om^h00P3om^h70=@m6@@0ooK^1@3D
?ATI0?ofkP80?EV[0P3om^h01@0mFJ/0ooK^03eIZ`3om^h0?EV[0080ooK^00<0?EV[0?ofkP0mFJ/0
1@0mFJ/50?ofkPT0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00l0ooK^
00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^0180ooK^
00<0?EV[0?ofkP0mFJ/0503om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00l0ooK^
00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP180?ofkP8000008@3om^h10?ooo`00I03o
m^h00`000000ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00`0ooK^0P3D?AT80?ofkP030=@m6@3o
m^h0ooK^00<0ooK^0P3D?AT=0?ofkP80e3dI0P3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00D0ooK^
00<000000?ofkP3om^h00P3D?AT50?ofkP80e3dI0`3om^h00`3D?AT0ooK^0?ofkP020=@m6@@0ooK^
0P3D?AT00`3om^h0e3dI0=@m6@040?ofkPH0e3dI5@3om^h303eIZ`040?ofkP0mFJ/0ooK^0?ofkP80
?EV[00<0ooK^03eIZ`0mFJ/00P0mFJ/30?ofkP0303eIZ`3om^h0?EV[00D0ooK^00<0?EV[0?ofkP3o
m^h00P3om^h0100mFJ/0ooK^0?ofkP3om^h403eIZ`T0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0m
FJ/0ooK^0?ofkP0<0?ofkP80?EV[103om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP0503eIZ`3om^h0ooK^
0?ofkP0mFJ/04P3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[
0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP170?ofkP8000008@3om^h10?ooo`00H`3om^h00`00
0000ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00l0ooK^0`3D?AT40?ofkP030=@m6@3om^h0ooK^
00@0ooK^00<0e3dI0?ofkP3D?AT00P3D?AT<0?ofkP<0e3dI0`3om^h00`3D?AT0ooK^0?ofkP020?of
kP030000003om^h0ooK^00<0ooK^0`3D?AT40?ofkP80e3dI00@0ooK^0=@m6@3D?AT0e3dI203om^h6
0=@m6@040?ofkP3D?AT0ooK^0?ofkPD0e3dI4P3om^h303eIZ`030?ofkP0mFJ/0ooK^0080ooK^0`0m
FJ/00`3om^h0?EV[0?ofkP030?ofkP0403eIZ`3om^h0ooK^03eIZ`@0ooK^00<0?EV[0?ofkP3om^h0
0P3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0?EV[00@0?EV[0`3om^h00`0mFJ/0ooK^
0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00h0ooK^0P0mFJ/00`3om^h0?EV[0?ofkP0C0?ofkP0303eI
Z`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eI
Z`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP160?ofkP030000
003om^h000000240ooK^0@3oool006<0ooK^00<000000?ofkP3om^h01`3om^h00`3D?AT0ooK^0?of
kP0B0?ofkP80e3dI0P3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^0080ooK^0P3D
?AT:0?ofkP030=@m6@3om^h0ooK^00<0e3dI1@3om^h00`000000ooK^0?ofkP060?ofkP80e3dI103o
m^h30=@m6@`0ooK^1P3D?AT40?ofkPD0e3dI3`3om^h203eIZ`040?ofkP0mFJ/0ooK^0?ofkP<0?EV[
0P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0403eIZ`3om^h0ooK^03eIZ`<0ooK^00<0?EV[0?ofkP3o
m^h00P3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00<0ooK^100mFJ/@0?ofkP03
03eIZ`3om^h0ooK^0140ooK^00<0?EV[0?ofkP3om^h04P3om^h00`0mFJ/0ooK^0?ofkP050?ofkP03
03eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP090?ofkP03
03eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h0A03om^h01@000000ooK^0?ofkP3om^h00000
0200ooK^0@3oool00680ooK^00<000000?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP0E0?ofkP<0
e3dI1@3om^h00`3D?AT0ooK^0?ofkP050?ofkP<0e3dI1`3om^h00`3D?AT0ooK^0?ofkP020?ofkP<0
e3dI0`3om^h00`000000ooK^0?ofkP080?ofkP<0e3dI00<0ooK^0=@m6@3om^h0103D?AT<0?ofkPD0
e3dI103om^h50=@m6@`0ooK^0P0mFJ/20?ofkP@0?EV[00@0ooK^03eIZ`3om^h0?EV[1@3om^h00`0m
FJ/0ooK^0?ofkP020?ofkP0403eIZ`3om^h0ooK^03eIZ`@0ooK^00<0?EV[0?ofkP3om^h01P3om^h0
0`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^0080?EV[3@3om^h00`0mFJ/0ooK^0?ofkP0A
0?ofkP0303eIZ`3om^h0?EV[0180ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP0:
0?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP0:
0?ofkP0303eIZ`3om^h0ooK^0440ooK^0P0000040?ofkP030000003om^h0ooK^01h0ooK^0@3oool0
0640ooK^00<000000?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP0E0?ofkP030=@m6@3om^h0ooK^
0080e3dI0`3om^h00`3D?AT0ooK^0?ofkP080?ofkP<0e3dI0`3om^h00`3D?AT0ooK^0?ofkP030?of
kP030=@m6@3om^h0ooK^0080e3dI00<0ooK^0000003om^h0303om^h20=@m6@030?ofkP3D?AT0ooK^
0080ooK^0`3D?AT;0?ofkPH0e3dI103om^h50=@m6@P0ooK^00@0?EV[0?ofkP0mFJ/0ooK^0P0mFJ/0
1P3om^h0?EV[0?ofkP0mFJ/0ooK^03eIZ`D0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^
03eIZ`040?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^
0?ofkP030?ofkP<0?EV[2@3om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP0503eIZ`3om^h0ooK^0?ofkP0m
FJ/0403om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3o
m^h02`3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3o
m^h0@03om^h00`000000ooK^0?ofkP040?ofkP030000003om^h0ooK^01h0ooK^0@3oool00640ooK^
00<000000?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP0F0?ofkP030=@m6@3om^h0ooK^0080ooK^
103D?AT=0?ofkP@0e3dI1@3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@000000e3dI00/0ooK^
00<0e3dI0?ofkP3om^h00`3D?AT50?ofkP80e3dI2P3om^h01@3D?AT0ooK^0=@m6@3D?AT0ooK^00D0
e3dI00<0ooK^0=@m6@3D?AT00`3D?AT50?ofkP0303eIZ`3om^h0?EV[0080?EV[0`3om^h01@0mFJ/0
ooK^03eIZ`3om^h0?EV[00@0ooK^00<0?EV[0?ofkP3om^h0103om^h203eIZ`@0ooK^00<0?EV[0?of
kP3om^h02@3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00T0ooK^0`0mFJ/50?ofkP0303eIZ`3om^h0
ooK^0140ooK^00<0?EV[0?ofkP3om^h00`3om^h203eIZ`d0ooK^00<0?EV[0?ofkP3om^h02P3om^h0
0`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h0103om^h0
0`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^03h0ooK^00<000000?ofkP3om^h01@3om^h0
0`000000ooK^0?ofkP0N0?ofkP40oooo001P0?ofkP030000003om^h0ooK^00P0ooK^00<0e3dI0?of
kP3om^h05@3om^h00`3D?AT0ooK^0?ofkP060?ofkP80e3dI3P3om^h30=@m6@@0ooK^00<0e3dI0?of
kP3om^h00`3om^h010000000ooK^0=@m6@3D?AT90?ofkP060=@m6@3om^h0ooK^0?ofkP3D?AT0ooK^
0P3D?AT50?ofkP<0e3dI1`3om^h0103D?AT0ooK^0?ofkP3om^h30=@m6@030?ofkP3D?AT0e3dI00@0
ooK^1@3D?AT00`3om^h0?EV[0?ofkP0303eIZ`<0ooK^00<0?EV[0?ofkP3om^h00P0mFJ/40?ofkP03
03eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP04
03eIZ`3om^h0ooK^03eIZ`d0ooK^0P0mFJ/20?ofkP0303eIZ`3om^h0ooK^0140ooK^00<0?EV[0?of
kP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?of
kP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?of
kP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0m0?ofkP030000003om^h0ooK^00L0ooK^00<000000?of
kP3om^h07@3om^h10?ooo`00H03om^h00`000000ooK^0?ofkP070?ofkP80e3dI5`3om^h00`3D?AT0
ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00<0e3dI2P3om^h0103D?AT0ooK^0?ofkP3om^h30=@m
6@030?ofkP3D?AT0ooK^00@0ooK^0P0000020?ofkP<0e3dI1@3om^h00`3D?AT0ooK^0?ofkP020?of
kP040=@m6@3om^h0ooK^0?ofkP<0e3dI1@3om^h30=@m6@D0ooK^00<0e3dI0?ofkP3D?AT00`3om^h6
0=@m6@<0ooK^0`3D?AT00`0mFJ/0000003eIZ`0203eIZ`<0ooK^00D0?EV[0?ofkP3om^h0ooK^03eI
Z`040?ofkP0303eIZ`3om^h0ooK^00D0ooK^0P0mFJ/30?ofkP0303eIZ`3om^h0ooK^00X0ooK^00@0
?EV[0?ofkP0mFJ/0?EV[403om^h203eIZa<0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^
0?ofkP080?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^
0?ofkP0@0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/04P3om^h00`0mFJ/0ooK^0?ofkP0k0?ofkP03
0000003om^h0ooK^00P0ooK^00<000000?ofkP3om^h07@3om^h10?ooo`00G`3om^h00`000000ooK^
0?ofkP080?ofkP040=@m6@3om^h0e3dI0=@m6A@0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0
ooK^0?ofkP030?ofkP80e3dI203om^h00`3D?AT0ooK^0?ofkP040?ofkP<0e3dI0`3om^h00`000000
ooK^0?ofkP02000000<0ooK^0P3D?AT20?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3o
m^h0103om^h30=@m6@D0ooK^0`3D?AT20?ofkP80e3dI1`3om^h20=@m6@030?ofkP3D?AT0e3dI00<0
ooK^00@0e3dI03eIZ`0mFJ/0H1D80P0mFJ/20000000403eIZ`3om^h0ooK^0?ofkP80?EV[103om^h0
0`0mFJ/0ooK^0?ofkP040?ofkP0603eIZ`3om^h0ooK^03eIZ`3om^h0?EV[303om^h0100mFJ/0ooK^
0?ofkP0mFJ/A0?ofkP0403eIZ`3om^h0?EV[03eIZa00ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0m
FJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00l0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0D
0?ofkP0303eIZ`3om^h0?EV[01<0ooK^00<0?EV[0?ofkP3om^h0>P3om^h00`000000ooK^0?ofkP09
0?ofkP030000003om^h0ooK^01d0ooK^0@3oool005h0ooK^00<000000?ofkP3om^h0203om^h00`3D
?AT0ooK^0?ofkP020?ofkP<0e3dI403om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^
00D0ooK^0`3D?AT40?ofkP030=@m6@3om^h0ooK^00H0ooK^00H0e3dI0?ofkP3D?AT0e3dI0?ofkP00
00040?ofkP<000000P3om^h30=@m6@D0ooK^00<0e3dI0?ofkP3om^h01`3om^h20=@m6@H0ooK^0`3D
?AT:0?ofkPD0e3dI00@0000003eIZ`0mFJ/0H1D80P0mFJ/00`1P5@P00000000000030000000303eI
Z`3om^h0?EV[00<0ooK^00<0?EV[0?ofkP3om^h0103om^h01`0mFJ/0ooK^0?ofkP3om^h0?EV[0?of
kP0mFJ/0303om^h00`0mFJ/0ooK^0?ofkP0203eIZ`l0ooK^00<0?EV[0?ofkP3om^h00P3om^h203eI
Z`h0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^
0140ooK^00<0?EV[0?ofkP0mFJ/05P3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^
03P0ooK^00<000000?ofkP3om^h02P3om^h00`000000ooK^0?ofkP0M0?ofkP40oooo001N0?ofkP03
0000003om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h01@3om^h20=@m6@h0ooK^00<0e3dI0?ofkP3o
m^h01`3om^h00`3D?AT0ooK^0?ofkP080?ofkP80e3dI0P3om^h00`3D?AT0ooK^0?ofkP060?ofkP05
0=@m6@3om^h0ooK^0?ofkP0000000P3D?AT60?ofkP<000000P3om^h30=@m6@80ooK^00<0e3dI0?of
kP3om^h02@3om^h30=@m6@<0ooK^00<0e3dI0?ofkP3D?AT00P3D?AT;0?ofkP80e3dI00D0?EV[08HQ
30000000000003eIZ`05060E2080000000<0?EV[0000000mFJ/00P3om^h00`0mFJ/0ooK^0?ofkP05
0?ofkP0403eIZ`3om^h0ooK^0?ofkP80?EV[303om^h01P0mFJ/0ooK^0?ofkP0mFJ/0ooK^03eIZ`h0
ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00d0
ooK^0P0mFJ/30?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h0503om^h00`0mFJ/0
ooK^03eIZ`0C0?ofkP80?EV[>03om^h2000000d0ooK^00<000000?ofkP3om^h07@3om^h10?ooo`00
G@3om^h00`000000ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00P0ooK^0`3D?AT:0?ofkP030=@m
6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h02P3om^h30=@m6@P0ooK^00@0e3dI0?ofkP3om^h0
00000`3om^h20=@m6@D0ooK^00@0e3dI0?ofkP00000000000`3om^h30=@m6@h0ooK^0`3D?AT30?of
kP040=@m6@3om^h0e3dI0=@m6@T0ooK^0P00000308HQ3080?EV[0`000002060E20060000000mFJ/0
H1D80000000mFJ/0@@l61P0mFJ/20?ofkP0303eIZ`3om^h0ooK^0080ooK^0P0mFJ/;0?ofkP0403eI
Z`3om^h0ooK^03eIZ`<0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP060?ofkP80
?EV[2@3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0303eIZ`3om^h0?EV[01D0ooK^00<0?EV[0?ofkP0m
FJ/0503om^h0100mFJ/0ooK^0?ofkP0mFJ/B0?ofkP0403eIZ`3om^h0ooK^03eIZcH0ooK^00<00000
0?ofkP3om^h03P3om^h00`000000ooK^0?ofkP0L0?ofkP40oooo001L0?ofkP030000003om^h0ooK^
00T0ooK^00<0e3dI0?ofkP3om^h02`3om^h20=@m6@P0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D
?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00<0e3dI103om^h0103D?AT0ooK^0?ofkP000006
0?ofkP<0e3dI0P3om^h0103D?AT0ooK^0?ofkP3om^h300000080ooK^0`3D?AT=0?ofkP060=@m6@3o
m^h0e3dI0=@m6@3om^h0e3dI0`3om^h30=@m6@D0ooK^0P00000308HQ300303eIZ`268@`0?EV[00<0
QR4<0P0000001@0mFJ/0H1D8060E201P5@P0?EV[00@000000`3om^h:03eIZ`T0ooK^00@0?EV[0?of
kP3om^h0?EV[103om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[
0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^01<0ooK^00D0?EV[
0?ofkP3om^h0ooK^03eIZ`0B0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h03P3o
m^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[03D0ooK^00<000000?ofkP3om^h03`3om^h00`000000ooK^
0?ofkP0L0?ofkP40oooo001L0?ofkP030000003om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h03P3o
m^h30=@m6@@0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3o
m^h0ooK^00<0ooK^0P3D?AT20?ofkP040=@m6@3om^h0ooK^000000T0ooK^0`3D?AT60?ofkP<00000
0P3om^h30=@m6@T0ooK^00<0e3dI0?ofkP3om^h00P3om^h30=@m6@D0ooK^0P3D?AT30?ofkP<00000
00@0QR4<03eIZ`268@`0?EV[1@268@`01P0mFJ/0QR4<000000000000H1D803eIZ`<0H1D810000000
0`0mFJ/0ooK^0?ofkP020?ofkP0503eIZ`3om^h0ooK^03eIZ`3om^h01`0mFJ/01@3om^h0?EV[0?of
kP3om^h0?EV[00H0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP80?EV[
103om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP0303eIZ`3om^h0?EV[01<0ooK^00<0?EV[0?ofkP3om^h0
0P3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h0
3@3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^0340ooK^00<000000?ofkP3om^h0
403om^h00`000000ooK^0?ofkP0L0?ofkP40oooo001K0?ofkP030000003om^h0ooK^00T0ooK^00<0
e3dI0?ofkP3om^h04@3om^h20=@m6@80ooK^00<0e3dI0?ofkP3om^h0203om^h20=@m6@/0ooK^00<0
e3dI0?ofkP3om^h01P3om^h30=@m6@030?ofkP000000ooK^00T0ooK^00<0e3dI0?ofkP3om^h00P3D
?AT60?ofkP030=@m6@000000000000<0ooK^0P3D?AT60?ofkP030=@m6@3om^h0ooK^00@0ooK^00@0
e3dI0?ofkP3D?AT0e3dI1@3om^h20=@m6@<0000000D0[bhB03eIZ`000000QR4<03eIZ`0408HQ3003
03eIZ`000000QR4<0080QR4<00<0000003eIZ`1P5@P00`1P5@P00`000000H1D803eIZ`0200000080
ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`080?ofkPD0?EV[1P3om^h00`0mFJ/0ooK^0?ofkP070?of
kP0303eIZ`3om^h0ooK^00h0ooK^0P0mFJ/00`3om^h0?EV[0?ofkP0C0?ofkP0503eIZ`3om^h0ooK^
0?ofkP0mFJ/04@3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[
0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[
0?ofkP3om^h0<03om^h00`000000ooK^0?ofkP0A0?ofkP030000003om^h0ooK^01`0ooK^0@3oool0
05/0ooK^00<000000?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP<0e3dI2P3om^h0103D
?AT0ooK^0=@m6@3D?AT80?ofkP030=@m6@3om^h0ooK^00T0ooK^00@0e3dI0000003D?AT0e3dI203o
m^h00`3D?AT0ooK^0?ofkP030?ofkP<0e3dI0`3om^h00`3D?AT0ooK^0?ofkP0300000080ooK^0`3D
?AT20?ofkP030=@m6@3om^h0ooK^00D0ooK^00@0e3dI0?ofkP3om^h0ooK^0P3D?AT40?ofkP800000
00<01PPA0000000mFJ/00P2_;Q800`000000?EV[0000000308HQ300303eIZ`268@`0QR4<00@0QR4<
00P0?EV[0000001P5@P00000060E200mFJ/0H1D80=@m6@<000001@3om^h00`0mFJ/0ooK^0?ofkP05
0?ofkP0303eIZ`3om^h0?EV[0080ooK^0P0mFJ/50?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[
0?ofkP3om^h04@3om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[
0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[
0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[
0?ofkP3om^h0;P3om^h00`000000ooK^0?ofkP0C0?ofkP030000003om^h0ooK^01/0ooK^0@3oool0
05X0ooK^00<000000?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP0E0?ofkP030=@m6@3om^h0e3dI
0080e3dI1`3om^h0103D?AT0ooK^0?ofkP3om^h30=@m6@D0ooK^00<0e3dI0?ofkP3om^h02@3om^h0
103D?AT000000?ofkP3om^h20=@m6@H0ooK^00<0e3dI0?ofkP3om^h01P3om^h20=@m6@030?ofkP3D
?AT0ooK^00@0ooK^0P0000030?ofkP<0e3dI1`3om^h00`3D?AT0ooK^0?ofkP030?ofkP<0e3dI0P00
00000`062140000003eIZ`040:l^4P0603eIZ`2_;Q8000000000000mFJ/000001P268@`01@0mFJ/0
QR4<000000000000?EV[00H0H1D80`0000020?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?of
kP0mFJ/01@3om^h203eIZ`@0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP0A0?of
kP0303eIZ`3om^h0?EV[0180ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP0;0?of
kP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP080?of
kP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP0]0?of
kP030000003om^h0ooK^01@0ooK^00<000000?ofkP3om^h06`3om^h10?ooo`00F@3om^h00`000000
ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^01@0ooK^00<0e3dI0?ofkP3om^h00`3om^h30=@m6@<0
ooK^00<0e3dI0?ofkP3om^h01@3om^h20=@m6@80ooK^00<0e3dI0?ofkP3om^h02P3om^h00`000000
ooK^0?ofkP030?ofkP<0e3dI0P3om^h00`3D?AT0ooK^0?ofkP090?ofkP<0e3dI1P3om^h300000003
0=@m6@3om^h0ooK^00<0e3dI103om^h00`3D?AT0ooK^0?ofkP060?ofkP80e3dI00<01PPA0000000m
FJ/0102_;Q80100mFJ/0[bhB0:l^4P0mFJ/3000000D0QR4<00D0?EV[08HQ30268@`0?EV[08HQ3003
000000@0H1D800D00000060E20000000000003eIZ`050?ofkP0303eIZ`3om^h0?EV[00P0ooK^0P0m
FJ/20?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h0403om^h0100mFJ/0ooK^0?of
kP3om^h203eIZ`l0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eI
Z`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eI
Z`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP0[0?ofkP800000
5`3om^h00`000000ooK^0?ofkP0K0?ofkP40oooo001I0?ofkP030000003om^h0ooK^00T0ooK^00<0
e3dI0?ofkP3om^h05@3om^h00`3D?AT0ooK^0?ofkP060?ofkP80e3dI00<0ooK^0=@m6@3om^h0203o
m^h30=@m6@/0ooK^00<000000=@m6@3om^h01`3om^h30=@m6@`0ooK^00<0e3dI0?ofkP3D?AT00P3D
?AT50?ofkP040=@m6@0000000000000000<0ooK^0P3D?AT20?ofkP030=@m6@3om^h0ooK^00D0ooK^
0P0000000`062140e3dI0=@m6@050:l^4P0303eIZ`2_;Q80?EV[0080[bhB00<000000:l^4P000000
0P00000208HQ300403eIZ`268@`0QR4<03eIZ`@0QR4<0`000000101P5@P00000060E201P5@P20000
000703eIZ`3om^h0ooK^0?ofkP0mFJ/0ooK^03eIZ`0;0?ofkP80?EV[00<0ooK^03eIZ`3om^h00P3o
m^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h02`3o
m^h00`0mFJ/0ooK^0?ofkP090?ofkP80?EV[2@3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3o
m^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3o
m^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h0:@3om^h00`000000ooK^0?ofkP0G0?ofkP030000003o
m^h0ooK^01/0ooK^0@3oool005P0ooK^00<000000?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP0D
0?ofkP030=@m6@3om^h0ooK^00T0ooK^0`3D?AT90?ofkP030=@m6@3om^h0e3dI0080e3dI1`3om^h0
0`000000ooK^0=@m6@080?ofkP030=@m6@3om^h0ooK^00<0e3dI2@3om^h00`3D?AT0ooK^0?ofkP02
0?ofkP80e3dI0`3om^h0103D?AT0ooK^0?ofkP3om^h2000000<0ooK^0`3D?AT60?ofkP8000000`06
2142000000<0[bhB00<0?EV[0:l^4P0mFJ/00`2_;Q800`000000[bhB0:l^4P020:l^4P80000000@0
?EV[0000000mFJ/000001`268@`3000000<0H1D800@0?EV[0000003D?AT0?EV[0P3om^h00`0mFJ/0
ooK^0?ofkP0;0?ofkP80?EV[0P3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0303eIZ`3om^h0ooK^00H0
ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00D0
ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00d0
ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^02P0
ooK^00<000000?ofkP3om^h06@3om^h00`000000ooK^0?ofkP0J0?ofkP40oooo001H0?ofkP030000
003om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h05@3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m
6@3om^h0e3dI0080e3dI1@3om^h00`3D?AT0ooK^0?ofkP030?ofkP80e3dI1@3om^h00`000000e3dI
0?ofkP080?ofkP030=@m6@3om^h0ooK^00<0ooK^0P3D?AT70?ofkP030=@m6@3om^h0ooK^00@0ooK^
0`3D?AT60?ofkP<000000`3om^h30=@m6@<0ooK^0P00000200H84@80000000L0bSHF000000000000
[bhB03eIZ`2_;Q80?EV[0080[bhB00<000000:l^4P2_;Q801@2_;Q8203eIZ`<000001`268@`02P00
0000QR4<000000000000H1D803eIZ`1P5@P0000003eIZ`3D?AT3000000h0ooK^0P0mFJ/B0?ofkP03
03eIZ`3om^h0ooK^00P0ooK^0P0mFJ/80?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3o
m^h00`3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3o
m^h03P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3o
m^h09P3om^h00`000000ooK^0?ofkP0J0?ofkP030000003om^h0ooK^01X0ooK^0@3oool005L0ooK^
00<000000?ofkP3om^h02P3om^h20=@m6AD0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^
0?ofkP030?ofkP<0e3dI0P3om^h00`3D?AT0ooK^0?ofkP050?ofkP<0e3dI00@0ooK^0000003om^h0
e3dI203om^h00`3D?AT0ooK^0?ofkP060?ofkP<0e3dI0`3om^h00`3D?AT0ooK^0?ofkP060?ofkP03
0=@m6@3om^h0e3dI0080e3dI1P3om^h3000000030=@m6@3om^h0ooK^0080e3dI0P00000200H84@03
0000000:3b<0000000<0bSHF00<0000003eIZ`0mFJ/00`2_;Q800`000000[bhB0:l^4P050:l^4P05
03eIZ`2_;Q80[bhB0000002_;Q800P00000508HQ3004000000268@`0QR4<08HQ308000000P0mFJ/0
1@000000H1D80=@m6@3D?AT0@@l600800000303om^h0100mFJ/0ooK^03eIZ`0mFJ/?0?ofkP0303eI
Z`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0503eI
Z`3om^h0ooK^0?ofkP0mFJ/04@3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[0180ooK^00@0?EV[0?of
kP3om^h0?EV[403om^h00`0mFJ/0ooK^0?ofkP0U0?ofkP030000003om^h0ooK^01/0ooK^00<00000
0?ofkP3om^h06P3om^h10?ooo`00EP3om^h00`000000ooK^0?ofkP0;0?ofkP030=@m6@3om^h0e3dI
0080e3dI4P3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00H0ooK^0`3D?AT:0?of
kP040000003D?AT0ooK^0=@m6@L0ooK^00<0e3dI0?ofkP3om^h02P3om^h40=@m6@L0ooK^00<0e3dI
0?ofkP3om^h00`3om^h30=@m6@H0ooK^0P0000020?ofkP<0000000D01PPA0000000:3b<02PlS0000
00040<Xf5P0603eIZ`3:=QH000000000002_;Q8000001P2_;Q8203eIZ`80[bhB00@000000:l^4P2_
;Q80[bhB0P00000308HQ3003000000268@`0QR4<00<0QR4<00@0?EV[0000001P5@P000000P1P5@P5
000000T0ooK^00<0?EV[0?ofkP0mFJ/00P3om^h203eIZ`d0ooK^00<0?EV[0?ofkP3om^h0303om^h0
0`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^0180ooK^00<0?EV[0?ofkP0mFJ/04`3om^h0
0`0mFJ/0ooK^03eIZ`0C0?ofkP0303eIZ`3om^h0?EV[0180ooK^00<0?EV[0?ofkP3om^h08`3om^h0
0`000000ooK^0?ofkP0L0?ofkP030000003om^h0ooK^01X0ooK^0@3oool005H0ooK^00<000000?of
kP3om^h02P3om^h00`3D?AT0ooK^0?ofkP030?ofkP<0e3dI3P3om^h00`3D?AT0ooK^0?ofkP0;0?of
kP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3D?AT00P3D?AT60?ofkP030000003om^h0ooK^
00<0e3dI1P3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP80e3dI1P3om^h00`3D?AT0ooK^0?ofkP060?of
kP80e3dI103om^h00`3D?AT0ooK^000000020000000400H84@0000001PPA000000802PlS00@00000
0<Xf5P3:=QH0bSHF0P0mFJ/30<Xf5P<00000102_;Q801P0mFJ/0[bhB0:l^4P0mFJ/0[bhB000000D0
[bhB0P0000000`268@`0000008HQ300308HQ300303eIZ`268@`0?EV[00<00000101P5@P4000000H0
ooK^00D0?EV[0?ofkP0mFJ/0ooK^03eIZ`030?ofkP80?EV[2P3om^h00`0mFJ/0ooK^0?ofkP0>0?of
kP80?EV[00<0ooK^03eIZ`3om^h05@3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^
01<0ooK^00<0?EV[0?ofkP3om^h04@3om^h00`0mFJ/0ooK^0?ofkP0R0?ofkP030000003om^h0ooK^
01d0ooK^00<000000?ofkP3om^h06P3om^h10?ooo`00E@3om^h00`000000ooK^0?ofkP0;0?ofkP03
0=@m6@3om^h0ooK^00H0ooK^0P3D?AT<0?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3o
m^h01P3om^h00`3D?AT0ooK^0?ofkP030?ofkP80e3dI103om^h01P000000ooK^0?ofkP3om^h0e3dI
0?ofkP<0e3dI0P3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0e3dI0080e3dI0P3om^h0
0`3D?AT0ooK^0?ofkP090?ofkP<0e3dI00<0ooK^0=@m6@3om^h00P00000010062140000000000000
000200X?8`070000003:=QH0bSHF0<Xf5P0mFJ/0bSHF03eIZ`040<Xf5P040000003:=QH000000000
0080[bhB00D0?EV[0:l^4P2_;Q80?EV[000000080:l^4P<000000P268@`01`0mFJ/0QR4<08HQ300m
FJ/0QR4<000000268@`00`000003060E20D000000P3om^h00`0mFJ/0ooK^03eIZ`030?ofkP0303eI
Z`3om^h0ooK^0080ooK^0P0mFJ/70?ofkP0303eIZ`3om^h0ooK^0140ooK^00<0?EV[0?ofkP3om^h0
503om^h00`0mFJ/0ooK^03eIZ`0C0?ofkP0303eIZ`3om^h0?EV[01<0ooK^0P0mFJ/B0?ofkP80?EV[
8P3om^h200000240ooK^00<000000?ofkP3om^h06@3om^h10?ooo`00E@3om^h00`000000ooK^0?of
kP0;0?ofkP030=@m6@3om^h0ooK^00P0ooK^0`3D?AT80?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0
e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP050?ofkP<0e3dI00<000000?ofkP3om^h00P3o
m^h00`3D?AT0ooK^0?ofkP020?ofkP<0e3dI403om^h00`3D?AT0ooK^0?ofkP020?ofkP<0e3dI3P3o
m^h30=@m6@80000000@01PPA0000000000002PlS0`0000030<Xf5P0303eIZ`3:=QH0?EV[00@0bSHF
00L000000<Xf5P3:=QH0bSHF0000000mFJ/000000080[bhB00<0?EV[0000002_;Q80202_;Q801000
0000[bhB0000000mFJ/408HQ300303eIZ`000000QR4<00<0QR4<10000002060E20D0000000<0?EV[
0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP040?ofkP80?EV[103om^h00`0mFJ/0ooK^0?ofkP0A
0?ofkP0303eIZ`3om^h0?EV[01@0ooK^00@0?EV[0?ofkP3om^h0?EV[4P3om^h0100mFJ/0ooK^0?of
kP0mFJ/B0?ofkP0403eIZ`3om^h0ooK^03eIZa00ooK^00<0?EV[0?ofkP0mFJ/08@3om^h00`000000
ooK^0?ofkP0Q0?ofkP030000003om^h0ooK^01T0ooK^0@3oool005@0ooK^00<000000?ofkP3om^h0
2`3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP<0e3dI1@3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m
6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h0203om^h01P000000e3dI0=@m6@3D?AT0ooK^0=@m
6@H0ooK^00<0e3dI0?ofkP3D?AT00P3D?AT=0?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?of
kP3om^h00P3D?AT=0?ofkP060=@m6@000000e3dI0=@m6@0621400000100:3b<30000000403eIZ`3:
=QH0bSHF03eIZ`@0bSHF00D000000<Xf5P3:=QH0bSHF03eIZ`020<Xf5P80000000<0[bhB03eIZ`2_
;Q80202_;Q8010000000[bhB03eIZ`2_;Q830000000408HQ300mFJ/0QR4<000000H0QR4<0`000003
060E20030000000mFJ/0000000<000000P3om^h00`0mFJ/0ooK^0?ofkP050?ofkP80?EV[00<0ooK^
03eIZ`3om^h04P3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[0180ooK^00<0?EV[0?ofkP3om^h00P3o
m^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h03P3o
m^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00h0ooK^0P0mFJ/30?ofkP0303eIZ`3om^h0ooK^01d0ooK^
00<000000?ofkP3om^h08P3om^h00`000000ooK^0?ofkP0I0?ofkP40oooo001C0?ofkP030000003o
m^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h03`3om^h30=@m6@030?ofkP3D?AT0ooK^00d0ooK^00<0
e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP080?ofkP040000003om^h0ooK^0?ofkP80e3dI
1@3om^h00`3D?AT0ooK^0?ofkP030?ofkP80e3dI2`3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m
6@3om^h0ooK^0080ooK^0`3D?AT:0?ofkP040=@m6@000000000000H84@80e3dI100:3b<00`000000
bSHF03eIZ`02000000030<Xf5P0mFJ/0bSHF00<0bSHF00@000000<Xf5P3:=QH0?EV[1@3:=QH00`00
0000?EV[000000080:l^4P030000000mFJ/0[bhB00@0[bhB0P0000000`0mFJ/0000008HQ300608HQ
3007000000268@`000000000001P5@P0?EV[060E2006000000030?ofkP0mFJ/0ooK^00L0ooK^00<0
?EV[0?ofkP3om^h04@3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0
?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0
?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0
?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP0L0?ofkP030000003om^h0ooK^02<0ooK^00<0
00000?ofkP3om^h06@3om^h10?ooo`00D`3om^h00`000000ooK^0?ofkP0;0?ofkP030=@m6@3om^h0
ooK^01<0ooK^0`3D?AT=0?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h0203om^h0
0`000000ooK^0?ofkP030?ofkP@0e3dI0P3om^h00`3D?AT0ooK^0?ofkP050?ofkP<0e3dI1`3om^h0
0`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00H0ooK^0P3D?AT70?ofkP030000003D?AT0
000000801PPA0P0000020=@m6@802PlS00<0000003eIZ`3:=QH00P3:=QH300000080bSHF00@00000
0<Xf5P3:=QH0?EV[1`3:=QH0100mFJ/0bSHF0000000000060:l^4P0303eIZ`2_;Q80[bhB00H0[bhB
00<0?EV[0000000000001P268@`020000000QR4<08HQ30268@`0?EV[0000001P5@P000000P1P5@P5
0000000303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP0mFJ/04@3om^h00`0mFJ/0ooK^0?ofkP05
0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP0:
0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP04
0?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0K
0?ofkP030000003om^h0ooK^02D0ooK^00<000000?ofkP3om^h0603om^h10?ooo`00DP3om^h00`00
0000ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^01@0ooK^00<0e3dI0?ofkP3D?AT00P3D?AT90?of
kP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`000000ooK^0?ofkP040?of
kP040=@m6@3om^h0ooK^0?ofkP<0e3dI2P3om^h30=@m6@@0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m
6@0;0?ofkP<0e3dI0`3om^h020000000e3dI00H84@0000001PPA0000000:3b<000000P0:3b<20=@m
6@040000003L?1P0000000000080bSHF00<0?EV[0<Xf5P0000000P0000020<Xf5P0303eIZ`3:=QH0
bSHF00D0bSHF00@0000003eIZ`3:=QH0bSHF0`0000020:l^4P0303eIZ`000000[bhB00P0[bhB00@0
?EV[0:l^4P000000000010268@`010000000QR4<08HQ300mFJ/208HQ30<000000`1P5@P400000003
03eIZ`3om^h0ooK^0080ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0?0?ofkP0303eIZ`3om^h0ooK^
00L0ooK^00<0?EV[0?ofkP3om^h02@3om^h203eIZ`T0ooK^00<0?EV[0?ofkP3om^h0203om^h203eI
Z`T0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^
00P0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP0J0?ofkP030000003om^h0ooK^
02H0ooK^00<000000?ofkP3om^h0603om^h10?ooo`00DP3om^h00`000000ooK^0?ofkP0<0?ofkP03
0=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h00`3om^h30=@m6@H0ooK^00<0e3dI0?ofkP3o
m^h01@3om^h00`3D?AT0ooK^0?ofkP070?ofkP030000003om^h0ooK^00D0ooK^00<0e3dI0?ofkP3o
m^h00P3om^h00`3D?AT0ooK^0=@m6@020=@m6@X0ooK^0`3D?AT00`3om^h0e3dI0?ofkP020?ofkP03
0=@m6@3om^h0ooK^00`0ooK^0P3D?AT2000000040=@m6@0621400000000000802PlS00H0000000X?
8`0:3b<0000000lF=P0000030=`l60<0000000<0?EV[0<Xf5P3:=QH00`0000080<Xf5P030000000m
FJ/0bSHF00@0bSHF0P0000000`0mFJ/000000:l^4P080:l^4P0403eIZ`2_;Q80[bhB0:l^4P800000
0`268@`00`000000QR4<03eIZ`0408HQ30<000000`1P5@P00`000000e3dI03eIZ`02000000030?of
kP0mFJ/0ooK^00@0ooK^0P0mFJ/<0?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h0
1`3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h0
2@3om^h00`0mFJ/0ooK^0?ofkP070?ofkP80?EV[2@3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eI
Z`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h0603om^h00`000000ooK^0?ofkP0W0?ofkP030000
003om^h0ooK^01P0ooK^0@3oool00540ooK^00<000000?ofkP3om^h0303om^h00`3D?AT0ooK^0?of
kP0D0?ofkP030=@m6@3om^h0ooK^00H0ooK^0P3D?AT40?ofkP80e3dI1P3om^h00`3D?AT0ooK^0?of
kP070?ofkP030000003om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?of
kP030?ofkP80e3dI2`3om^h30=@m6@030?ofkP3D?AT0ooK^0100ooK^00D0000000H84@3D?AT01PPA
0000000200X?8`040000000:3b<02PlS000000803aHf00<000000=`l603L?1P0103L?1P01P0mFJ/0
00000<Xf5P000000?EV[0<Xf5P<000001@3:=QH00`000000?EV[0<Xf5P050<Xf5P0403eIZ`000000
0000000000P0[bhB00<0000003eIZ`2_;Q800`2_;Q820000000308HQ30000000?EV[00H0QR4<00@0
000008HQ3000000000000P1P5@P00`000000H1D803eIZ`03000000L0ooK^00<0?EV[0?ofkP3om^h0
2@3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h0
303om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h0
1@3om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h0
203om^h00`0mFJ/0ooK^0?ofkP0F0?ofkP800000:P3om^h00`000000ooK^0?ofkP0H0?ofkP40oooo
001@0?ofkP030000003om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h0503om^h00`3D?AT0ooK^0?of
kP080?ofkP<0e3dI00<0ooK^0=@m6@3om^h00`3D?AT20?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0
00000?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00D0ooK^0`3D
?AT90?ofkP030=@m6@3om^h0e3dI0080e3dI3`3om^h0100000001PPA00H84@3D?AT2000000802PlS
00@0000000X?8`0:3b<000000P0?5SH00`000000g3`H0=`l60040=`l600503eIZ`3L?1P0000003eI
Z`000000103:=QH300000080bSHF00<000000<Xf5P0mFJ/0103:=QH01@0mFJ/0bSHF0<Xf5P000000
bSHF008000001P2_;Q800`000000?EV[0:l^4P050:l^4P030000000mFJ/0000000L0QR4<00<00000
08HQ30268@`0100000000`1P5@P0?EV[060E2004000000D0ooK^00<0?EV[0?ofkP3om^h01`3om^h0
0`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h03P3om^h0
0`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h00`3om^h0
0`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h02@3om^h0
0`0mFJ/0ooK^0?ofkP0E0?ofkP030000003om^h0ooK^02X0ooK^00<000000?ofkP3om^h0603om^h1
0?ooo`00D03om^h00`000000ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?of
kP3om^h0303om^h30=@m6@<0ooK^0`3D?AT80?ofkP030000003om^h0ooK^00H0ooK^00D0e3dI0?of
kP3om^h0ooK^0=@m6@0;0?ofkP<0e3dI1P3om^h00`3D?AT0ooK^0=@m6@020?ofkP80e3dI303om^h2
000000801PPA00<0e3dI0000000:3b<00P0:3b<00`0000002PlS0000000300lF=P030000003L?1P0
g3`H00@0g3`H00D0?EV[0=`l600mFJ/000000=@m6@03000000@0bSHF0`0000000`3:=QH0?EV[0<Xf
5P020<Xf5P0503eIZ`3:=QH0bSHF0<Xf5P0000000`3:=QH3000000<0[bhB00<000000:l^4P0mFJ/0
1@2_;Q800`0mFJ/000000:l^4P03000000@0QR4<00<0000008HQ30268@`00`268@`30000000303eI
Z`1P5@P0H1D800H000000P3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00h0ooK^
00D0?EV[0?ofkP3om^h0ooK^03eIZ`0A0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/0403om^h00`0m
FJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00`0ooK^00@0?EV[0?ofkP3om^h0ooK^0P0mFJ/<
0?ofkP0303eIZ`3om^h0ooK^01@0ooK^00<000000?ofkP3om^h0;03om^h00`000000ooK^0?ofkP0G
0?ofkP40oooo001?0?ofkP030000003om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h0503om^h00`3D
?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00<0e3dI00<0ooK^0=@m6@3om^h00`3D?AT50?of
kP030000003om^h0ooK^00H0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0>0?ofkP80e3dI0`3om^h0
0`3D?AT0ooK^0=@m6@050?ofkP<0e3dI203om^h2000000<01PPA00<0e3dI0000000:3b<00P0:3b<2
000000@03aHf00<000000=`l603L?1P0103L?1P0100mFJ/0g3`H03eIZ`0000040=`l60800000103:
=QH300000080bSHF00<0?EV[0<Xf5P3:=QH00P3:=QH00`000000bSHF0<Xf5P040<Xf5P80000000@0
[bhB0000002_;Q80?EV[102_;Q800`0mFJ/0[bhB000000040:l^4P@0000000<0QR4<000000268@`0
10268@`01P000000QR4<0000000mFJ/00000060E20L0000000<0ooK^03eIZ`3om^h0103om^h00`0m
FJ/0ooK^0?ofkP0@0?ofkP0303eIZ`3om^h0?EV[01<0ooK^00<0?EV[0?ofkP0mFJ/04P3om^h0100m
FJ/0ooK^0?ofkP0mFJ/?0?ofkP0403eIZ`3om^h0ooK^03eIZ`l0ooK^00<0?EV[0?ofkP3om^h04P3o
m^h00`000000ooK^0?ofkP0]0?ofkP030000003om^h0ooK^01L0ooK^0@3oool004h0ooK^00<00000
0?ofkP3om^h03P3om^h20=@m6A@0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP03
0?ofkP<0e3dI0`3om^h30=@m6@030?ofkP000000ooK^00P0ooK^00@0e3dI0?ofkP3om^h0e3dI4@3o
m^h40=@m6@030?ofkP3D?AT0ooK^00L0ooK^0`3D?AT40?ofkP<000000P0621400`000000e3dI0000
000300X?8`030000000?5SH03aHf00<03aHf00<000000=`l603L?1P0103L?1P203eIZ`030=`l6000
0000g3`H00D0g3`H0`000000103:=QH000000<Xf5P3:=QH2000000D0bSHF00<000000<Xf5P3:=QH0
1P3:=QH3000000050:l^4P0mFJ/0[bhB0:l^4P0mFJ/00P2_;Q800`000000[bhB0:l^4P060:l^4P<0
00001@268@`010000000QR4<03eIZ`268@`400000080H1D81000000203eIZ`80ooK^00<0?EV[0?of
kP3om^h04P3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^0140ooK^00<0?EV[0?of
kP0mFJ/04@3om^h203eIZa00ooK^00<0?EV[0?ofkP3om^h04@3om^h00`000000ooK^0?ofkP0^0?of
kP030000003om^h0ooK^01L0ooK^0@3oool004h0ooK^00<000000?ofkP3om^h03P3om^h00`3D?AT0
ooK^0=@m6@020=@m6A40ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP040?ofkP03
0=@m6@3om^h0e3dI0080e3dI0`3om^h00`000000e3dI0=@m6@080?ofkP040=@m6@3om^h0ooK^0=@m
6A@0ooK^0`3D?AT;0?ofkP<0e3dI00T0ooK^000000062140000000H84@000000e3dI00X?8`000000
0P0:3b<2000000D03aHf00<000000=`l603L?1P0103L?1P0100mFJ/0g3`H0=`l600000090=`l60<0
000000<0bSHF03eIZ`3:=QH00`0000020<Xf5P030000003:=QH0bSHF00L0bSHF00H000000<Xf5P00
0000?EV[0:l^4P0mFJ/40:l^4P030000002_;Q80[bhB00H0[bhB00@000000:l^4P00000000000`26
8@`010000000QR4<08HQ300mFJ/308HQ30<000000P1P5@P400000080?EV[503om^h00`0mFJ/0ooK^
03eIZ`0C0?ofkP0303eIZ`3om^h0?EV[01<0ooK^00<0?EV[0?ofkP3om^h0403om^h00`0mFJ/0ooK^
0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^0100ooK^00<000000?ofkP3om^h0;`3om^h00`000000ooK^
0?ofkP0G0?ofkP40oooo001=0?ofkP030000003om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h00`3o
m^h30=@m6@h0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3o
m^h0ooK^00<0ooK^0P3D?AT010000000ooK^0?ofkP3om^h30=@m6@@0ooK^00@0e3dI0?ofkP3om^h0
e3dI5@3om^h00`3D?AT0ooK^0?ofkP020=@m6@`0ooK^0P3D?AT01`062140000000H84@000000e3dI
00X?8`0000000P0:3b<2000000D03aHf00<000000=`l603L?1P00`3L?1P203eIZ`80g3`H00<00000
0=`l603L?1P0203L?1P010000000g3`H03eIZ`0mFJ/40<Xf5P<000002@3:=QH01@000000bSHF0<Xf
5P3:=QH0?EV[008000000`2_;Q800`000000[bhB0:l^4P060:l^4P040000002_;Q80[bhB0:l^4P80
00000P268@`010000000QR4<08HQ300mFJ/308HQ3005000000268@`000000000001P5@P00P000000
103D?AT0000000000000000B0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/04@3om^h0100mFJ/0ooK^
0?ofkP0mFJ/B0?ofkP80?EV[4@3om^h203eIZa00ooK^0P0mFJ/A0?ofkP030000003om^h0ooK^0340
ooK^00<000000?ofkP3om^h05P3om^h10?ooo`00C@3om^h00`000000ooK^0?ofkP0>0?ofkP030=@m
6@3om^h0ooK^00H0ooK^0P3D?AT;0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h0
103om^h00`3D?AT0ooK^0?ofkP050?ofkP030000003D?AT0e3dI00@0ooK^0`3D?AT01@3om^h0e3dI
0?ofkP3om^h0e3dI01D0ooK^00<0e3dI0?ofkP3om^h00P3om^h30=@m6@P0ooK^0P0000001`062140
e3dI0=@m6@3D?AT02PlS0=@m6@0000000P0:3b<00`0000003aHf0000000500lF=P030000003L?1P0
g3`H0080g3`H00@0?EV[0=`l603L?1P0?EV[0P3L?1P00`000000g3`H0=`l60070=`l60050000000m
FJ/0g3`H0=`l600mFJ/00P0000030<Xf5P<000001`3:=QH01`000000bSHF0<Xf5P0mFJ/0bSHF03eI
Z`3:=QH00P0000000`2_;Q8000000:l^4P070:l^4P030000002_;Q80[bhB00<0[bhB0`0000001026
8@`0?EV[08HQ300mFJ/308HQ3003000000268@`0QR4<00@0000000<0H1D80000000000001000000=
0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP02
0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00@0?EV[0?ofkP3om^h0?EV[3`3om^h0100mFJ/0ooK^0?of
kP0mFJ/>0?ofkP0303eIZ`3om^h0?EV[00l0ooK^0P00000d0?ofkP030000003om^h0ooK^01H0ooK^
0@3oool004`0ooK^00<000000?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP090?ofkP<0e3dI203o
m^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h01@3o
m^h010000000ooK^0?ofkP3om^h30=@m6@@0ooK^103D?ATE0?ofkP030=@m6@3om^h0ooK^00H0ooK^
0P3D?AT50?ofkP80000000D0?EV[00H84@000000000000X?8`030=@m6@0500X?8`0000003aHf00lF
=P0000001@0?5SH200000080g3`H00D0?EV[0=`l603L?1P0g3`H03eIZ`020=`l60030000003L?1P0
g3`H00L0g3`H00D0000003eIZ`3L?1P0g3`H03eIZ`020=`l6080000000@0bSHF0000003:=QH0bSHF
0`0000040<Xf5P030000003:=QH0?EV[00<0bSHF00<0?EV[0<Xf5P3:=QH00`0000070:l^4P030000
002_;Q80[bhB00D0[bhB00<0000003eIZ`0000000P268@`0100mFJ/0QR4<08HQ3000000508HQ3080
00000P1P5@P300000004044?1P0000000000000000T0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0m
FJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h03@3om^h01@0m
FJ/0ooK^0?ofkP3om^h0?EV[00h0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0=0?ofkP0403eIZ`3o
m^h0ooK^03eIZ`h0ooK^00<000000?ofkP3om^h0=03om^h00`000000ooK^0?ofkP0F0?ofkP40oooo
001;0?ofkP030000003om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h0303om^h30=@m6@D0ooK^00<0
e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0
00000?ofkP3om^h01@3om^h20=@m6@<0ooK^00<0e3dI0?ofkP3D?AT00P3D?ATC0?ofkP030=@m6@3o
m^h0ooK^00P0ooK^0`3D?AT0103om^h0000000000000000200H84@060000000:3b<02PlS00X?8`3D
?AT000000`3D?AT00`0?5SH0000000lF=P0300lF=P80000000@0jD0J000000000000?EV[0`3L?1P0
100mFJ/0g3`H0=`l600000090=`l600303eIZ`3L?1P0g3`H0080g3`H00@0?EV[0=`l603L?1P0g3`H
0`0000040<Xf5P<000000P3:=QH00`0mFJ/0bSHF0<Xf5P020<Xf5P0603eIZ`3:=QH0bSHF0<Xf5P00
0000bSHF0P0000060:l^4P030000002_;Q80[bhB00@0[bhB00<0?EV[0000002_;Q800`000000100m
FJ/0QR4<08HQ3000000608HQ3080000000<0H1D80000001P5@P00P000002044?1P8000001P3om^h0
0`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h01@3om^h0
0`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h02P3om^h0
0`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00X0ooK^00D0?EV[0?ofkP3om^h0ooK^03eI
Z`0=0?ofkP030000003om^h0ooK^03D0ooK^00<000000?ofkP3om^h05P3om^h10?ooo`00B`3om^h0
0`000000ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^0100ooK^0`3D?AT00`3om^h0e3dI0?ofkP0>
0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h0103om^h00`000000ooK^0?ofkP08
0?ofkP<0e3dI00<0ooK^0=@m6@3om^h00P3om^h30=@m6@l0ooK^0P3D?AT=0?ofkP<000000P062142
000000<02PlS00<0e3dI0000000000000P0?5SH20=@m6@<03aHf00<0000001TSD@0000000P3Y@1X0
100mFJ/0jD0J0000000000020=`l600303eIZ`3L?1P0000000P0g3`H00<0?EV[0000003L?1P00`3L
?1P00`0mFJ/0g3`H0=`l60020=`l60030000003D?AT0000000800000103:=QH20000000303eIZ`3:
=QH0bSHF00<0bSHF00@0?EV[0<Xf5P3:=QH000000`3:=QH3000000<0[bhB00<000000:l^4P2_;Q80
0`2_;Q80100mFJ/0[bhB0:l^4P0000030:l^4P040000000mFJ/00000000000H0QR4<00<0000008HQ
300000000`0000001@1P5@P00000000000000000@@l6008000000`3om^h00`0mFJ/0ooK^0?ofkP08
0?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP09
0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP03
0?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP0:
0?ofkP030000003om^h0ooK^03L0ooK^00<000000?ofkP3om^h05@3om^h10?ooo`00BP3om^h00`00
0000ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^01<0ooK^0`3D?AT>0?ofkP030=@m6@3om^h0ooK^
00<0ooK^00<0e3dI0?ofkP3om^h0103om^h00`000000ooK^0?ofkP0:0?ofkP@0e3dI1@3om^h30=@m
6@`0ooK^0P3D?AT=0?ofkP<0000000@01PPA0000000:3b<000000P0:3b<00`3D?AT02PlS00000004
00lF=P040000003D?AT0e3dI0=@m6@806B=A00<000000>U06P0mFJ/0103Y@1X20000000303eIZ`3L
?1P0000000L0g3`H00<0?EV[0=`l600000001@3L?1P01@0mFJ/0g3`H0=`l603L?1P0000000@0g3`H
0P0000030<Xf5P0403eIZ`0000000000000000@0bSHF00<0?EV[0<Xf5P0000001P3:=QH200000003
0:l^4P000000[bhB00<0[bhB00D0?EV[0:l^4P2_;Q80[bhB000000050:l^4P0403eIZ`0000000000
000000D0QR4<00<0000008HQ30268@`00`000002060E20H0000000<0?EV[0?ofkP3om^h02@3om^h0
0`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h01`3om^h2
03eIZ`L0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0
ooK^00L0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP090?ofkP030000003om^h0
ooK^03P0ooK^00<000000?ofkP3om^h05@3om^h10?ooo`00BP3om^h00`000000ooK^0?ofkP0?0?of
kP030=@m6@3om^h0ooK^01@0ooK^00<0e3dI0?ofkP3D?AT00P3D?AT:0?ofkP030=@m6@3om^h0ooK^
00@0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`000000ooK^0?ofkP0;0?ofkP040=@m6@3om^h0e3dI
0?ofkP<0e3dI1@3om^h20=@m6@T0ooK^00<0e3dI0?ofkP3D?AT0303om^h20000000300H84@000000
000000802PlS00@0000000X?8`0:3b<0e3dI0P00000400lF=P040000000?5SH03aHf00000080e3dI
00<0000003eIZ`3Y@1X01P3Y@1X0100mFJ/000000000000000050=`l600403eIZ`3L?1P0g3`H0000
00D0g3`H00D0?EV[0=`l603L?1P0g3`H000000060=`l6080000000<0?EV[0<Xf5P0000000P3:=QH2
000000<0bSHF00<0?EV[0000003:=QH01`3:=QH300000080[bhB00<0?EV[0:l^4P2_;Q800P2_;Q80
0`000000[bhB0:l^4P040:l^4P0303eIZ`000000[bhB008000000`268@`00`000000QR4<08HQ3002
08HQ30<000000P1P5@P00`000000e3dI060E2004000000X0ooK^00<0?EV[0?ofkP3om^h01P3om^h0
0`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h0203om^h0
0`0mFJ/0ooK^0?ofkP050?ofkP80?EV[203om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0
ooK^00D0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`000000ooK^0?ofkP0i0?ofkP030000003om^h0
ooK^01D0ooK^0@3oool004T0ooK^00<000000?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP0D0?of
kP030=@m6@3om^h0ooK^00<0ooK^0P3D?AT80?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?of
kP3om^h00`3om^h00`000000ooK^0?ofkP0<0?ofkP80e3dI1@3om^h30=@m6@@0ooK^0`3D?AT60?of
kP030=@m6@3om^h0e3dI00/0ooK^00@0000000H84@0000001PPA0P00000200X?8`060000000:3b<0
2PlS0=@m6@0?5SH00000100?5SH00`0000003aHf0000000301TSD@030=@m6@0mFJ/0jD0J00L0jD0J
00<0?EV[0000003Y@1X00P0000030=`l600403eIZ`3L?1P0g3`H000000H0g3`H00@0?EV[0=`l603L
?1P000001`3L?1P00`0mFJ/0g3`H00000002000000<0bSHF0`0000000`3:=QH0?EV[000000080<Xf
5P050000003:=QH0000003eIZ`000000102_;Q800`000000[bhB0:l^4P050:l^4P0403eIZ`000000
[bhB0:l^4P8000000P268@`00`000000QR4<08HQ300308HQ30@0000000<0H1D80000001P5@P00P1P
5@P4000000P0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3o
m^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3o
m^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3o
m^h0ooK^00H0ooK^00<000000?ofkP3om^h0>P3om^h00`000000ooK^0?ofkP0E0?ofkP40oooo0018
0?ofkP030000003om^h0ooK^0100ooK^00<0e3dI0?ofkP3om^h0503om^h00`3D?AT0ooK^0?ofkP05
0?ofkP<0e3dI1@3om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00<0ooK^00<00000
0?ofkP3om^h02`3om^h00`3D?AT0ooK^0=@m6@080?ofkP@0e3dI0`3om^h30=@m6@80ooK^00<0e3dI
0?ofkP3D?AT02`3om^h0100000001PPA000000062142000000802PlS00L0000000X?8`0:3b<00000
0=@m6@0?5SH0000000@03aHf0P00000401TSD@030000003Y@1X0jD0J00L0jD0J00<0?EV[0000003Y
@1X00P3Y@1X20000000503eIZ`3L?1P0g3`H0=`l600000001P3L?1P0100mFJ/0g3`H0=`l60000006
0=`l600603eIZ`3L?1P0g3`H0=`l60000000g3`H0P0000040<Xf5P<00000203:=QH01@000000bSHF
0<Xf5P0mFJ/0bSHF00@0000000<0[bhB0000002_;Q801P2_;Q800`0mFJ/0[bhB0:l^4P020:l^4P<0
00001P268@`00`000000QR4<08HQ300400000080H1D81@0000070?ofkP0303eIZ`3om^h0ooK^0080
ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00X0
ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00<0
ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP040?ofkP800000?@3om^h00`000000
ooK^0?ofkP0E0?ofkP40oooo00180?ofkP030000003om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h0
503om^h00`3D?AT0ooK^0?ofkP090?ofkP<0e3dI0P3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m
6@3om^h0ooK^00<0ooK^00<000000?ofkP3om^h0303om^h20=@m6@d0ooK^0`3D?AT30?ofkP<0e3dI
00<0ooK^0=@m6@3om^h02P3om^h30000000300H84@0000002PlS00802PlS00L0000000X?8`0:3b<0
00000=@m6@0?5SH0000000@03aHf00<0000001TSD@0I8e40100I8e400`000000jD0J0>U06P060>U0
6P0303eIZ`000000jD0J00<0jD0J00H0?EV[0>U06P00000000000=`l600000070=`l600303eIZ`3L
?1P0000000D0g3`H00<0?EV[0=`l603L?1P00P3L?1P010000000g3`H0=`l603L?1P3000000<0bSHF
00<0?EV[0000000000001P3:=QH00`000000bSHF03eIZ`060<Xf5P<000001P2_;Q800`000000?EV[
0:l^4P040:l^4P<0000010268@`00`000000QR4<08HQ300308HQ30<000000P1P5@P00`000000H1D8
00000002000000D0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0@0?ofkP0403eIZ`3om^h0ooK^03eI
Z`h0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0=0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[
0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP030?ofkP030000003om^h0ooK^03h0ooK^00<00000
0?ofkP3om^h0503om^h10?ooo`00A`3om^h00`000000ooK^0?ofkP0@0?ofkP030=@m6@3om^h0ooK^
01@0ooK^00<0e3dI0?ofkP3om^h0303om^h20=@m6@D0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`00
0000ooK^0?ofkP0=0?ofkP80e3dI403om^h30=@m6@030?ofkP3D?AT0ooK^00<0e3dI2@3om^h30000
000300H84@000000000000<02PlS00@0000000X?8`000000e3dI0P0?5SH0100000003aHf00lF=P0?
5SH2000000H06B=A00<000000>U06P3Y@1X01`3Y@1X01@0mFJ/0jD0J0>U06P3Y@1X0?EV[00@0jD0J
0`0000060=`l600303eIZ`3L?1P0000000@0g3`H00<0?EV[0=`l603L?1P00`3L?1P00`000000g3`H
0=`l60040=`l6080000000@0bSHF0000000mFJ/0bSHF0`0000030<Xf5P030000000mFJ/0bSHF00L0
bSHF00@000000<Xf5P00000000001@2_;Q800`000000?EV[0:l^4P040:l^4P030000002_;Q800000
008000000P268@`00`000000QR4<08HQ300408HQ30<0000000@0H1D80000001P5@P0H1D80`000004
0?ofkP0303eIZ`3om^h0?EV[0140ooK^00<0?EV[0?ofkP0mFJ/03`3om^h0100mFJ/0ooK^0?ofkP0m
FJ/>0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/02`3om^h00`0mFJ/0ooK^0?ofkP020?ofkP030000
003om^h0ooK^03l0ooK^00<000000?ofkP3om^h0503om^h10?ooo`00A`3om^h00`000000ooK^0?of
kP0?0?ofkP030=@m6@3om^h0ooK^01@0ooK^00<0e3dI0?ofkP3om^h03P3om^h40=@m6@030?ofkP3D
?AT0ooK^00<0ooK^00<000000?ofkP3om^h03@3om^h20=@m6A@0ooK^0`3D?AT00`3om^h0e3dI0?of
kP030=@m6@D0ooK^0P0000000`062140000000H84@02000000<02PlS0P0000001@0?5SH0e3dI00lF
=P0?5SH0000000<03aHf0P00000601TSD@030000003Y@1X0jD0J00L0jD0J00@0?EV[0>U06P3Y@1X0
?EV[1P3Y@1X010000000jD0J0000000000050=`l600303eIZ`000000g3`H0080g3`H00<0?EV[0=`l
603L?1P0103L?1P00`000000g3`H0=`l60060=`l60<0000000@0?EV[0<Xf5P3:=QH0bSHF0`000000
0`0mFJ/000000<Xf5P070<Xf5P040000003:=QH0bSHF0<Xf5P<000000P2_;Q800`000000[bhB03eI
Z`050:l^4P040000002_;Q80[bhB0:l^4P@000001@268@`00`000000QR4<08HQ300400000080H1D8
0`0000030?ofkP0303eIZ`3om^h0ooK^0140ooK^00<0?EV[0?ofkP3om^h03`3om^h203eIZ`l0ooK^
00@0?EV[0?ofkP3om^h0?EV[303om^h01@0mFJ/0ooK^0?ofkP3om^h000000480ooK^00<000000?of
kP3om^h0503om^h10?ooo`00AP3om^h00`000000ooK^0?ofkP0@0?ofkP80e3dI5@3om^h00`3D?AT0
ooK^0?ofkP0>0?ofkP030=@m6@3om^h0e3dI00@0e3dI0`3om^h00`000000ooK^0?ofkP0=0?ofkP80
e3dI5@3om^h0103D?AT0ooK^0=@m6@3D?AT40?ofkP80e3dI0`3om^h30000000400H84@0000002PlS
000000<02PlS00@0000003eIZ`0?5SH0e3dI0P0?5SH01P0000003aHf00lF=P0000006B=A000000H0
6B=A00<000000>U06P3Y@1X01`3Y@1X0100mFJ/0jD0J0>U06P0mFJ/60>U06P040000003Y@1X0jD0J
0>U06P<000000P3L?1P00`0mFJ/000000=`l60020=`l600303eIZ`3L?1P0g3`H00@0g3`H00<00000
0=`l603L?1P01`3L?1P010000000g3`H0000000mFJ/40<Xf5P0303eIZ`000000000000P0bSHF00<0
00000<Xf5P3:=QH0103:=QH2000000040:l^4P000000[bhB03eIZ`@0[bhB00<000000:l^4P2_;Q80
102_;Q83000000@0QR4<00<0000008HQ30268@`00P268@`300000004060E200000000000000000<0
?EV[4P3om^h203eIZa40ooK^00<0?EV[0?ofkP3om^h03`3om^h203eIZ`d0ooK^00@0?EV[0?ofkP3o
m^h00000@`3om^h00`000000ooK^0?ofkP0D0?ofkP40oooo00150?ofkP030000003om^h0ooK^0140
ooK^00<0e3dI0?ofkP3D?AT00P3D?ATB0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3o
m^h00P3om^h50=@m6@030000003om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h04`3om^h01@3D?AT0
ooK^0?ofkP3D?AT0ooK^00<0e3dI0`3om^h30=@m6@040000000621400000000000802PlS00<00000
00X?8`0:3b<00P00000200lF=P060=@m6@0?5SH03aHf0000000?5SH000000P0I8e400`0000006B=A
01TSD@0401TSD@030000003Y@1X0jD0J00L0jD0J00<0000003eIZ`0mFJ/01`3Y@1X00`000000jD0J
0>U06P040>U06P80000000D0g3`H03eIZ`3L?1P0g3`H03eIZ`070=`l60030000003L?1P0g3`H00L0
g3`H00@000000=`l603L?1P0?EV[0`0000000`0mFJ/0bSHF0<Xf5P04000000D0bSHF00<000000<Xf
5P3:=QH01P3:=QH3000000030:l^4P0mFJ/0[bhB0080[bhB00<000000:l^4P2_;Q801@2_;Q801000
0000[bhB00000000000308HQ3003000000268@`0QR4<00<0QR4<0`0000000`1P5@P00000060E2002
0000000303eIZ`3om^h0ooK^00h0ooK^00@0?EV[0?ofkP3om^h0?EV[3`3om^h203eIZa40ooK^00<0
?EV[0?ofkP3om^h02`3om^h203eIZ`030?ofkP000000ooK^04@0ooK^00<000000?ofkP3om^h04`3o
m^h10?ooo`00A@3om^h00`000000ooK^0?ofkP0@0?ofkP030=@m6@3om^h0ooK^00<0ooK^0`3D?AT>
0?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h00P3om^h01@3D?AT0ooK^0?ofkP3D
?AT0000000@0e3dI3@3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP040=@m6@3om^h0ooK^0=@m6@@0ooK^
0`3D?AT00`3om^h00000000000030=@m6@802PlS00H0000000X?8`0:3b<0000000lF=P00000200lF
=P030=@m6@0?5SH03aHf008000000`0I8e400`0000006B=A01TSD@0401TSD@030000003Y@1X0jD0J
00L0jD0J00<0000003eIZ`3Y@1X01`3Y@1X00`000000jD0J0>U06P060>U06P040000000mFJ/00000
03eIZ`P0g3`H00<000000=`l603L?1P01`3L?1P01`000000g3`H0=`l603L?1P0?EV[0=`l600mFJ/0
0P0000000`3:=QH000000<Xf5P020<Xf5P8000000`3:=QH00`000000bSHF0<Xf5P070<Xf5P050000
003:=QH000000000000mFJ/00`2_;Q800`000000[bhB0:l^4P050:l^4P030000002_;Q80[bhB0080
00000P268@`00`000000QR4<08HQ300308HQ3003000000268@`0000000<0000000<0H1D803eIZ`00
00003P3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00h0ooK^00<0?EV[0?ofkP0mFJ/0403om^h203eI
Z``0ooK^00@0?EV[0?ofkP0mFJ/00000AP3om^h00`000000ooK^0?ofkP0C0?ofkP40oooo00140?of
kP030000003om^h0ooK^0140ooK^00<0e3dI0?ofkP3om^h01P3om^h20=@m6@`0ooK^00<0e3dI0?of
kP3om^h03P3om^h00`3D?AT0ooK^0?ofkP020?ofkP060=@m6@3om^h0ooK^0?ofkP000000ooK^0P3D
?AT00`3om^h0e3dI0=@m6@020=@m6@P0ooK^00<0e3dI0?ofkP3om^h04`3om^h01@3D?AT0ooK^0?of
kP3om^h0e3dI00L0ooK^0`0000000`0621400000000000030=@m6@0500X?8`0000003aHf00lF=P00
00000P0?5SH00`3D?AT03aHf00lF=P02000000<06B=A00<0000001TSD@0I8e40100I8e42000000H0
jD0J00D0e3dI0>U06P0mFJ/0jD0J03eIZ`070>U06P030000003Y@1X0jD0J00L0jD0J00<0000003eI
Z`0000000P0000060=`l60030000003L?1P0g3`H00L0g3`H00<000000=`l603L?1P00P3L?1P0100m
FJ/0g3`H0=`l603L?1P3000000@0bSHF0`0000000`3:=QH000000<Xf5P070<Xf5P060000003:=QH0
bSHF03eIZ`000000?EV[0P2_;Q800`000000[bhB0:l^4P050:l^4P030000002_;Q80[bhB0080[bhB
0`00000608HQ3004000000268@`0QR4<08HQ30<0000000<0?EV[0000003D?AT02`3om^h00`0mFJ/0
ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00/0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0>0?of
kP0303eIZ`3om^h0?EV[00X0ooK^0P0mFJ/00`3om^h0?EV[000000170?ofkP030000003om^h0ooK^
01<0ooK^0@3oool004@0ooK^00<000000?ofkP3om^h04@3om^h00`3D?AT0ooK^0?ofkP080?ofkP<0
e3dI203om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00<0ooK^00@0e3dI0?ofkP3o
m^h00000103om^h30=@m6@80ooK^0`3D?AT50?ofkP030=@m6@3om^h0ooK^01<0ooK^00@0e3dI0?of
kP3om^h0e3dI1`3om^h3000000801PPA00D0000000X?8`0:3b<02PlS000000020=@m6@803aHf00<0
000000lF=P3D?AT00`0?5SH00`0000006B=A01TSD@0301TSD@030000000I8e406B=A00806B=A0P00
00000`3b@a`00000000000050>U06P0403eIZ`000000jD0J03eIZ`L0jD0J00<000000>U06P3Y@1X0
1`3Y@1X00`0mFJ/0jD0J03eIZ`020>U06P800000103L?1P00`000000g3`H0=`l60070=`l60070000
003L?1P0g3`H0=`l600mFJ/0g3`H03eIZ`030=`l60040000003L?1P00000000000D0bSHF0`000007
0<Xf5P030000003:=QH0?EV[00<0bSHF0P0mFJ/00`2_;Q8000000:l^4P050:l^4P030000002_;Q80
[bhB00@0[bhB0`00000408HQ3003000000268@`0QR4<00<0QR4<0`000000101P5@P000000=@m6@3D
?AT60?ofkP80?EV[1P3om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0
?EV[0?ofkP3om^h02P3om^h203eIZ`80ooK^00<0?EV[0?ofkP3om^h01`3om^h01@0mFJ/0ooK^0?of
kP000000?EV[04P0ooK^00<000000?ofkP3om^h04`3om^h10?ooo`00@`3om^h00`000000ooK^0?of
kP0B0?ofkP030=@m6@3om^h0ooK^00/0ooK^0`3D?AT50?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0
e3dI0?ofkP3om^h00P3om^h0103D?AT0ooK^0?ofkP0000080?ofkP<0e3dI0P3om^h30=@m6@030?of
kP3D?AT0e3dI01@0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@060?ofkP80000000<01PPA00000006
21400P00000300X?8`80000000H03aHf0=@m6@3D?AT0e3dI00lF=P3D?AT200lF=P8000001@0I8e40
1`0000006B=A01TSD@0I8e400000028bK@0000000`3b@a`3000000040>U06P0mFJ/0jD0J00000080
jD0J00<0?EV[0>U06P3Y@1X0103Y@1X00`000000jD0J0>U06P060>U06P0403eIZ`000000jD0J03eI
Z`@0jD0J0`0000000`3L?1P000000=`l60080=`l60040000003L?1P0g3`H03eIZ`<0g3`H00@0?EV[
0=`l603L?1P000000`3L?1P3000000<0bSHF00@000000<Xf5P00000000001@3:=QH00`000000?EV[
0<Xf5P050<Xf5P0303eIZ`000000000000H0[bhB00<000000:l^4P2_;Q80102_;Q800`000000[bhB
0000000200000080QR4<00<0000008HQ30268@`00P268@`00`000000QR4<08HQ300400000080e3dI
0`3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h0
0`3om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h0
1P3om^h01P0mFJ/0ooK^0?ofkP000000ooK^03eIZdP0ooK^00<000000?ofkP3om^h04`3om^h10?oo
o`00@P3om^h00`000000ooK^0?ofkP0B0?ofkP030=@m6@3om^h0ooK^00l0ooK^0`3D?AT00`3om^h0
e3dI0?ofkP0@0?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP000000303om^h20=@m6@<0
ooK^0`3D?ATD0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT01@3om^h40000000400H84@0000002PlS
000000<02PlS00<0000000lF=P0?5SH00P0?5SH01`000000e3dI0=@m6@3D?AT0000001TSD@000000
1@0I8e40100000006B=A01TSD@000002028bK@030000003b@a`0lT<L00@0lT<L00@0?EV[0000003Y
@1X000000P3Y@1X00`0mFJ/0jD0J0>U06P040>U06P030000003Y@1X0jD0J00D0jD0J00<0?EV[0>U0
6P0000000P3Y@1X00`0mFJ/0jD0J0>U06P040>U06P<00000203L?1P00`000000g3`H03eIZ`050=`l
600303eIZ`3L?1P0000000H0g3`H0P0000000`3D?AT000000<Xf5P020<Xf5P<000000P3:=QH00`0m
FJ/000000<Xf5P060<Xf5P0303eIZ`3:=QH00000008000000`2_;Q800`000000[bhB0:l^4P050:l^
4P040000002_;Q80[bhB0:l^4P@0000010268@`00`000000QR4<08HQ300208HQ308000000`3D?AT0
0`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h0103om^h0
0`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h01@3om^h0
100mFJ/0ooK^0?ofkP0000020?ofkP0303eIZ`3om^h0ooK^04L0ooK^00<000000?ofkP3om^h04P3o
m^h10?ooo`00@P3om^h00`000000ooK^0?ofkP0B0?ofkP030=@m6@3om^h0ooK^0180ooK^0`3D?AT?
0?ofkP030=@m6@3om^h0ooK^0080ooK^00@0e3dI0?ofkP3om^h000003P3om^h30=@m6@030?ofkP3D
?AT0ooK^00<0e3dI4@3om^h0103D?AT0ooK^0?ofkP3D?AT50?ofkP04000000062140000000H84@80
00000P0:3b<00`0000002PlS00X?8`02000000@03aHf00@0000000lF=P3D?AT000000P3D?AT00`00
00006B=A01TSD@0301TSD@040000000I8e406B=A000000<08S9]00<000000?93703b@a`00P3b@a`0
0`0mFJ/0lT<L0?93700300000080jD0J00<0?EV[0>U06P3Y@1X00`3Y@1X00`000000jD0J0>U06P05
0>U06P0303eIZ`3Y@1X0000000<0jD0J00<0?EV[0>U06P3Y@1X0103Y@1X010000000jD0J00000000
00060=`l60030000000mFJ/0g3`H00H0g3`H00<0?EV[0000003L?1P01`3L?1P3000000D0bSHF1000
00070<Xf5P030000000mFJ/0bSHF0080bSHF0`0000000`2_;Q8000000:l^4P050:l^4P030000002_
;Q80[bhB00@0[bhB0P00000408HQ3003000000268@`0QR4<00<0QR4<00<000000?ofkP0mFJ/0103D
?AT70?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?of
kP070?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h0103om^h0100mFJ/0ooK^0?of
kP0000030?ofkP0303eIZ`3om^h0ooK^04L0ooK^00<000000?ofkP3om^h04P3om^h10?ooo`00@@3o
m^h00`000000ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3D?AT00P3D
?AT<0?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP0000004P3om^h30=@m6@<0ooK^0P3D
?AT>0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT0103om^h3000000801PPA0P00000200X?8`030000
000:3b<02PlS00800000100?5SH00`000000e3dI0000000301TSD@<0e3dI0`0I8e400`0000006B=A
00000004028bK@030000003b@a`0lT<L0080lT<L00H0?EV[0?93703b@a`0lT<L0000003b@a`20000
000303eIZ`3Y@1X0jD0J00<0jD0J00<000000>U06P3Y@1X0103Y@1X0100mFJ/0jD0J0>U06P000004
0>U06P0303eIZ`3Y@1X0jD0J00<0jD0J00@000000>U06P3Y@1X0jD0J0`0000030=`l600303eIZ`3L
?1P0g3`H00L0g3`H00<0?EV[0=`l603L?1P01`3L?1P00`000000g3`H0000000200000080bSHF00<0
?EV[0<Xf5P3:=QH00P0000060<Xf5P040000003:=QH0?EV[03eIZ`@0bSHF0`0000060:l^4P030000
002_;Q80[bhB00@0[bhB00<000000:l^4P0000000`268@`00`000000QR4<08HQ300308HQ300303eI
Z`3om^h0ooK^0080ooK^103D?AT40?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h0
1`3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h0
0`3om^h0100mFJ/0ooK^0?ofkP0000040?ofkP0303eIZ`3om^h0ooK^04L0ooK^00<000000?ofkP3o
m^h04P3om^h10?ooo`00@@3om^h00`000000ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^0180ooK^
00<0e3dI0?ofkP3om^h00`3om^h30=@m6@T0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT00000
0?ofkP0B0?ofkP80e3dI00@0ooK^0=@m6@3D?AT0e3dI0P3om^h30=@m6@/0ooK^00D0e3dI0?ofkP3o
m^h0ooK^0=@m6@040?ofkP<0000000<01PPA0000000000000P0:3b<01P0000002PlS00X?8`000000
3aHf000000@03aHf00<000000=@m6@0I8e400`0I8e400`0000006B=A01TSD@030=@m6@8000001@0R
<Vd01@000000lT<L0?93703b@a`0?EV[00@0lT<L00L000000?93703b@a`0lT<L0000000mFJ/00000
00<0jD0J00<000000>U06P3Y@1X00`3Y@1X01@0mFJ/0jD0J0>U06P3Y@1X0000000@0jD0J00<0?EV[
0>U06P3Y@1X00`3Y@1X00`000000jD0J0>U06P040>U06P80000000<0?EV[0000003L?1P0203L?1P0
0`000000?EV[0=`l60070=`l60030000003L?1P0g3`H0080g3`H00L0000003eIZ`00000000000<Xf
5P000000bSHF00<000000`3:=QH01@000000bSHF0<Xf5P3:=QH0?EV[00@0bSHF00@000000<Xf5P00
00000000102_;Q800`000000[bhB0:l^4P050:l^4P060000002_;Q800000000000268@`000001@26
8@`00`0mFJ/000000=@m6@040?ofkP@0e3dI0`3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3o
m^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3o
m^h0ooK^0080ooK^00@0?EV[0?ofkP3om^h00000103om^h00`0mFJ/0ooK^0?ofkP180?ofkP030000
003om^h0ooK^0180ooK^0@3oool00400ooK^00<000000?ofkP3om^h04`3om^h00`3D?AT0ooK^0?of
kP0C0?ofkP030=@m6@3om^h0ooK^00H0ooK^0P3D?AT60?ofkP030=@m6@3om^h0ooK^0080ooK^00<0
e3dI0?ofkP0000004`3om^h00`3D?AT0ooK^0?ofkP030?ofkP<0e3dI0P3om^h30=@m6@L0ooK^00<0
e3dI0?ofkP3om^h00P3om^h0103D?AT0ooK^0?ofkP3om^h3000000801PPA00L0000000X?8`0:3b<0
2PlS0000000:3b<0000000803aHf00<0000000lF=P0?5SH00P0?5SH00`000000e3dI01TSD@0301TS
D@030000000I8e406B=A00<06B=A0P3D?AT5028bK@040000003b@a`0lT<L03eIZ`D0lT<L00<00000
0?93703b@a`00P3b@a`01P0mFJ/0lT<L000000000000jD0J000000@0jD0J00<0?EV[0>U06P3Y@1X0
0P3Y@1X00`000000jD0J0>U06P030>U06P0303eIZ`3Y@1X0jD0J0080jD0J00<000000>U06P3Y@1X0
1@3Y@1X0100mFJ/000000000000000080=`l60030000000mFJ/0g3`H00L0g3`H00<000000=`l603L
?1P00P3L?1P0100mFJ/0g3`H0=`l603L?1P3000000<0bSHF0`0000000`3:=QH000000<Xf5P020<Xf
5P0503eIZ`3:=QH0bSHF0<Xf5P0000000`3:=QH300000080[bhB00<000000:l^4P2_;Q80102_;Q80
10000000[bhB0:l^4P2_;Q83000000D0QR4<1@3D?AT30?ofkPD0e3dI00D0?EV[0?ofkP3om^h0ooK^
03eIZ`0;0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^
0?ofkP0203eIZ`80ooK^00<000000?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP190?ofkP030000
003om^h0ooK^0140ooK^0@3oool003l0ooK^00<000000?ofkP3om^h0503om^h00`3D?AT0ooK^0?of
kP0C0?ofkP030=@m6@3om^h0ooK^00P0ooK^0`3D?AT30?ofkP030=@m6@3om^h0ooK^0080ooK^00<0
e3dI0000003om^h04P3om^h20=@m6@P0ooK^0`3D?AT20?ofkP80e3dI1@3om^h01@3D?AT0ooK^0?of
kP3om^h0e3dI00<0ooK^0P0000000`062140000000H84@02000000<02PlS0P00000300lF=P040000
000?5SH03aHf00lF=P80000000<0e3dI01TSD@0I8e400`0I8e40100000006B=A01TSD@0I8e420000
0004028bK@3D?AT0e3dI0=@m6@808S9]00<000000?93700mFJ/01P3b@a`00`000000lT<L0?937003
0?93700303eIZ`3b@a`0lT<L00<000000P3Y@1X00`0mFJ/0jD0J0>U06P030>U06P030000003Y@1X0
jD0J00@0jD0J00D0?EV[0>U06P3Y@1X0jD0J000000070>U06P0403eIZ`3Y@1X000000>U06P<00000
1@3L?1P00`000000g3`H03eIZ`070=`l60050000003L?1P0g3`H0=`l600mFJ/01@3L?1P010000000
g3`H0000000000040<Xf5P800000103:=QH01@0mFJ/0bSHF0<Xf5P3:=QH0000000D0bSHF0`000007
0:l^4P030000002_;Q80[bhB0080[bhB0`00000408HQ30040000003D?AT0e3dI0?ofkP<0e3dI00H0
ooK^0=@m6@3om^h0ooK^0=@m6@0mFJ/20=@m6@0303eIZ`3om^h0ooK^00X0ooK^00@0?EV[0?ofkP3o
m^h0ooK^0P0mFJ/:0?ofkP0303eIZ`3om^h0?EV[0080ooK^0P0000060?ofkP0303eIZ`3om^h0ooK^
04T0ooK^00<000000?ofkP3om^h04@3om^h10?ooo`00?`3om^h00`000000ooK^0?ofkP0D0?ofkP03
0=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h02`3om^h40=@m6@@0ooK^00<000000?ofkP3o
m^h04P3om^h20=@m6@/0ooK^0P3D?AT20?ofkP<0e3dI00<0ooK^0=@m6@3om^h00`3om^h00`3D?AT0
ooK^0?ofkP020000000600H84@0000001PPA0000000:3b<000000`0:3b<00`0mFJ/0000000lF=P02
00lF=P060000000?5SH03aHf00lF=P000000e3dI1P0I8e401P0000006B=A01TSD@0000008S9]0000
00@08S9]0P3D?AT00`000000?EV[0?9370060?9370030000003b@a`0lT<L00<0lT<L00T0?EV[0?93
703b@a`0lT<L0000003b@a`0000003eIZ`0000001@3Y@1X00`000000jD0J0>U06P050>U06P0303eI
Z`3Y@1X0000000L0jD0J00@0?EV[0>U06P3Y@1X00000103Y@1X4000000050=`l60000000g3`H0=`l
600mFJ/01P3L?1P010000000g3`H0=`l600mFJ/60=`l60040000003L?1P0g3`H0=`l608000000`3:
=QH400000080bSHF0P0mFJ/00`3:=QH000000<Xf5P060<Xf5P<000001@2_;Q800`000000[bhB0:l^
4P040:l^4P@000000P268@`010000000ooK^0=@m6@3D?AT20?ofkPH0e3dI0P0mFJ/30=@m6@/0ooK^
00<0?EV[0?ofkP0mFJ/0303om^h203eIZ`80ooK^00<000000?ofkP3om^h01@3om^h00`0mFJ/0ooK^
0?ofkP1:0?ofkP030000003om^h0ooK^0140ooK^0@3oool003h0ooK^00<000000?ofkP3om^h05@3o
m^h00`3D?AT0ooK^0?ofkP0B0?ofkP030=@m6@3om^h0ooK^00h0ooK^103D?AT00`3om^h000000?of
kP0D0?ofkP030=@m6@3om^h0ooK^00`0ooK^0`3D?AT20?ofkP<0e3dI0`3om^h0103D?AT0ooK^0?of
kP00000200H84@80000000<02PlS0000000:3b<00`0:3b<00`0000003aHf00lF=P0200lF=P060000
000?5SH03aHf0000000I8e40e3dI1P0I8e400`0000006B=A00000003028bK@030000000R<Vd08S9]
00<08S9]00<0e3dI0?93703b@a`01P3b@a`00`000000lT<L0?9370040?93700603eIZ`3b@a`0lT<L
0000003b@a`0?EV[0P3b@a`4000000030>U06P000000jD0J00H0jD0J00<0?EV[0>U06P0000001P3Y
@1X01@0mFJ/0jD0J0>U06P3Y@1X0000000P0jD0J0`0000020=`l600303eIZ`3L?1P0g3`H00<0g3`H
00<000000=`l600mFJ/01`3L?1P00`000000g3`H0=`l60030=`l6080000000<0bSHF0000003:=QH0
0P3:=QH200000080bSHF00<0?EV[0000003:=QH01`3:=QH00`000000bSHF00000002000000<0[bhB
00<000000:l^4P2_;Q800`2_;Q8010000000[bhB0:l^4P2_;Q84000000030?ofkP3D?AT0e3dI0080
e3dI00H0ooK^0=@m6@3D?AT0e3dI0?ofkP0mFJ/20?ofkP@0e3dI2@3om^h203eIZ`d0ooK^00@0?EV[
0?ofkP3om^h000001`3om^h203eIZd`0ooK^00<000000?ofkP3om^h04@3om^h10?ooo`00?@3om^h0
0`000000ooK^0?ofkP0E0?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h03P3om^h0
1`3D?AT0ooK^0?ofkP3om^h0e3dI0000003D?AT04`3om^h20=@m6A40ooK^103D?AT01P3om^h0e3dI
0=@m6@3om^h0e3dI0?ofkP8000000P0621420000000300X?8`0000002PlS00802PlS0P00000400lF
=P030000000?5SH0000000806B=A00<0e3dI0000000I8e40100I8e400`0000006B=A00000003028b
K@030000000R<Vd08S9]00@08S9]00<000000?93703b@a`01@3b@a`00`000000lT<L0?9370040?93
700603eIZ`3b@a`0lT<L0000003b@a`0?EV[1P3b@a`3000000L0jD0J00<0?EV[0000003Y@1X0103Y
@1X00`0mFJ/0jD0J0>U06P020>U06P030000003Y@1X0jD0J00L0jD0J00H000000>U06P0000000000
0=`l600mFJ/40=`l60030000000mFJ/0g3`H00L0g3`H00<000000=`l603L?1P01@3L?1P3000000@0
bSHF0`0000000`0mFJ/0bSHF0<Xf5P060<Xf5P030000003:=QH0bSHF0080bSHF100000060:l^4P03
0000002_;Q80[bhB00<0[bhB0P0000040?ofkP<0e3dI00@0ooK^03eIZ`0mFJ/0e3dI103om^h30=@m
6@L0ooK^00<0?EV[0?ofkP3om^h02`3om^h203eIZ`030?ofkP000000ooK^00H0ooK^0P0mFJ]>0?of
kP030000003om^h0ooK^0100ooK^0@3oool003d0ooK^00<000000?ofkP3om^h05@3om^h20=@m6A@0
ooK^00<0e3dI0?ofkP3om^h03P3om^h01`3D?AT0ooK^0?ofkP3om^h000000=@m6@3om^h00`3D?AT@
0?ofkP80e3dI4`3om^h40=@m6@030?ofkP3D?AT0e3dI008000000P062142000000802PlS00H00000
00X?8`0:3b<0000000lF=P00000400lF=P8000000P0I8e400`3D?AT06B=A0000000501TSD@800000
100R<Vd00`0000008S9]028bK@04028bK@030000003b@a`0lT<L00H0lT<L00<000000?93703b@a`0
103b@a`0100mFJ/0lT<L0000000mFJ/80?9370040000003b@a`00000000000H0jD0J00<0?EV[0>U0
6P3Y@1X00P3Y@1X00`0mFJ/0jD0J0>U06P030>U06P030000003Y@1X0jD0J00L0jD0J00@000000>U0
6P3Y@1X0jD0J0P0000001@0mFJ/0g3`H0=`l603L?1P0?EV[00T0g3`H00<000000=`l603L?1P01P3L
?1P010000000e3dI0000000000040<Xf5P0403eIZ`0000000000000000H0bSHF00<000000<Xf5P3:
=QH01@3:=QH3000000@0[bhB00<000000:l^4P2_;Q801@2_;Q800`000000ooK^0?ofkP030?ofkP05
0=@m6@0mFJ/0e3dI03eIZ`3om^h00`3D?AT40?ofkP<0e3dI0`3om^h203eIZ``0ooK^0P0mFJ/00`3o
m^h000000?ofkP050?ofkP80?EV[00<0ooK^03eIZ`3om^h0C@3om^h00`000000ooK^0?ofkP0@0?of
kP40oooo000l0?ofkP030000003om^h0ooK^01H0ooK^00<0e3dI0?ofkP3D?AT00P3D?ATA0?ofkP03
0=@m6@3om^h0ooK^00d0ooK^00H0e3dI0?ofkP3om^h0ooK^0000003D?AT50?ofkP80e3dI3P3om^h0
0`3D?AT0ooK^0?ofkP0B0?ofkP040=@m6@3om^h0ooK^0?ofkP<0e3dI0P00000200H84@070000000:
3b<02PlS00X?8`0000002PlS0000000200lF=P030000000?5SH03aHf00803aHf0P00000201TSD@03
0=@m6@0I8e40000000D06B=A00<00000028bK@0R<Vd00`0R<Vd00`0000008S9]028bK@04028bK@03
0000003b@a`0lT<L00H0lT<L00<000000?93703b@a`0103b@a`00`0mFJ/0lT<L03eIZ`090?937004
0000003b@a`0lT<L0?9370<000000`3Y@1X01@000000?EV[0>U06P3Y@1X0?EV[00D0jD0J00<00000
0>U06P3Y@1X0203Y@1X00`000000jD0J0>U06P040>U06P0403eIZ`000000?EV[000000P0g3`H00<0
00000=`l603L?1P01`3L?1P010000000g3`H0=`l603L?1P30000000503eIZ`3:=QH0bSHF0000003:
=QH00P0000040<Xf5P030000003:=QH0bSHF00H0bSHF00@000000<Xf5P00000000000`2_;Q800`00
0000[bhB0:l^4P040:l^4P030000003om^h0ooK^00<0ooK^00H0?EV[0?ofkP3D?AT0e3dI03eIZ`3D
?AT20?ofkP80e3dI103om^h30=@m6@0303eIZ`3om^h0?EV[00/0ooK^00@0?EV[0?ofkP0mFJ/00000
1P3om^h0100mFJ/0ooK^0?ofkP0mFJ]?0?ofkP030000003om^h0ooK^0100ooK^0@3oool003`0ooK^
00<000000?ofkP3om^h05@3om^h00`3D?AT0ooK^0?ofkP030?ofkP<0e3dI3@3om^h00`3D?AT0ooK^
0?ofkP0>0?ofkP80e3dI00@0ooK^0000003om^h0e3dI1`3om^h30=@m6@X0ooK^0P3D?ATD0?ofkP03
0=@m6@3om^h0ooK^0080ooK^00<0e3dI0000003D?AT00P3D?AT2000000802PlS00<0000000X?8`00
00000`0?5SH00`0000003aHf00lF=P0200lF=P070000000I8e406B=A01TSD@3D?AT06B=A00000004
01TSD@8000001P0R<Vd00`0000008S9]028bK@03028bK@8000001`3b@a`00`000000lT<L0?937005
0?93700303eIZ`000000lT<L00P0lT<L00<000000?93703b@a`0103b@a`2000000050>U06P000000
?EV[0>U06P0mFJ/01P3Y@1X00`000000jD0J0>U06P080>U06P030000003Y@1X0jD0J00D0jD0J00@0
?EV[00000000000000001`3L?1P00`000000g3`H0=`l60070=`l60030000003L?1P0g3`H00<0g3`H
00D0?EV[000000000000bSHF000000030<Xf5P<000000P3:=QH00`000000bSHF0<Xf5P050<Xf5P04
0000003:=QH0bSHF0<Xf5P8000000P2_;Q800`000000[bhB0:l^4P040:l^4P050000003D?AT0ooK^
0?ofkP0mFJ/00P3om^h0103D?AT0ooK^03eIZ`3om^h30=@m6@040?ofkP3D?AT0e3dI0=@m6@80ooK^
00D0e3dI03eIZ`3D?AT0e3dI03eIZ`0:0?ofkP0403eIZ`3om^h0ooK^03eIZ`H0ooK^00@0?EV[0?of
kP3om^h0?EV[D03om^h00`000000ooK^0?ofkP0@0?ofkP40oooo000k0?ofkP030000003om^h0ooK^
01H0ooK^00<0e3dI0?ofkP3om^h01P3om^h20=@m6@/0ooK^00<0e3dI0?ofkP3om^h03P3om^h0103D
?AT0ooK^0=@m6@0000020=@m6@X0ooK^0`3D?AT70?ofkP030=@m6@3om^h0ooK^0180ooK^00<0e3dI
0?ofkP3om^h00P3om^h01P3D?AT000000000000000001PPA00000080e3dI0P0:3b<2000000@03aHf
00@0000000lF=P0?5SH03aHf0P00000301TSD@030=@m6@0I8e40000000<06B=A00<00000028bK@00
00001P0R<Vd00`0000008S9]028bK@02028bK@80000000<0nDHM0000000000001@3b@a`00`000000
lT<L0?9370040?93700403eIZ`3b@a`0?EV[000000P0lT<L00<000000?93703b@a`01P3b@a`30000
000303eIZ`3Y@1X0jD0J00D0jD0J00<000000>U06P3Y@1X0203Y@1X00`000000jD0J0>U06P040>U0
6P0503eIZ`3Y@1X0?EV[0000003Y@1X00P0000050=`l60030000003L?1P0g3`H00L0g3`H00<00000
0=`l603L?1P00P3L?1P0100mFJ/0g3`H0=`l603L?1P3000000@0bSHF00@0?EV[0000000000000000
203:=QH00`000000bSHF0<Xf5P020<Xf5P<000001P2_;Q8010000000ooK^0=@m6@0mFJ/40?ofkP03
0=@m6@0mFJ/0ooK^00<0ooK^0`3D?AT0103om^h0e3dI0=@m6@0mFJ/20=@m6@030?ofkP0mFJ/0e3dI
00P0ooK^00D0?EV[0?ofkP000000000003eIZ`050?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/0D03o
m^h00`000000ooK^0?ofkP0@0?ofkP40oooo000j0?ofkP030000003om^h0ooK^01L0ooK^00<0e3dI
0?ofkP3om^h0203om^h30=@m6@P0ooK^00<0e3dI0?ofkP3om^h03@3om^h0103D?AT0ooK^0?ofkP00
00020?ofkP<0e3dI2`3om^h20=@m6@D0ooK^00<0e3dI0?ofkP3om^h04P3om^h00`3D?AT0ooK^0?of
kP020?ofkP030=@m6@0000001PPA0080000000<02PlS0000000:3b<00`3D?AT00`0mFJ/03aHf00lF
=P0200lF=P060000000?5SH03aHf0000000I8e4000000P0I8e40103D?AT06B=A01TSD@00000201TS
D@040000000R<Vd08S9]000000H08S9]00L00000028bK@0R<Vd08S9]0000000Z?X<0000000<0nDHM
0P0000030?9370030000003b@a`0lT<L00<0lT<L00D0?EV[0?93703b@a`0?EV[000000080?937003
0000003b@a`0lT<L00L0lT<L00D0000003eIZ`000000?EV[000000050>U06P030000003Y@1X0jD0J
00L0jD0J00<000000>U06P3Y@1X0103Y@1X0100mFJ/0jD0J0>U06P3Y@1X203eIZ`80jD0J0P000003
0=`l60030000003L?1P0g3`H00L0g3`H00D000000=`l603L?1P0g3`H03eIZ`050=`l60030000003L
?1P00000008000000P3:=QH203eIZ`<000001P3:=QH00`000000bSHF0<Xf5P040<Xf5P<000001@2_
;Q8203eIZ`070?ofkP3D?AT0e3dI0=@m6@3om^h0e3dI03eIZ`060?ofkP<0e3dI00<0?EV[0?ofkP3D
?AT00P3D?AT00`0mFJ/0e3dI0=@m6@020=@m6@@0ooK^00D0?EV[0?ofkP000000ooK^03eIZ`050?of
kP0503eIZ`3om^h0ooK^0?ofkP0mFJ/0DP3om^h00`000000ooK^0?ofkP0?0?ofkP40oooo000j0?of
kP030000003om^h0ooK^01L0ooK^00<0e3dI0?ofkP3om^h02`3om^h30=@m6@D0ooK^00<0e3dI0?of
kP3om^h03@3om^h00`3D?AT0ooK^000000020?ofkP040=@m6@3om^h0ooK^0?ofkP<0e3dI2P3om^h3
0=@m6@030?ofkP3D?AT0e3dI01<0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0000000H84@02
0000000400X?8`0000002PlS00X?8`8000000`3D?AT200lF=P030000000?5SH0000000<06B=A00<0
000001TSD@3D?AT00`0I8e400`0000006B=A00000003028bK@030000000R<Vd08S9]00<08S9]00@0
0000028bK@0R<Vd000000P0Z?X<00`000000nDHM0?U67@030?U67@80000000<0lT<L0000003b@a`0
0`3b@a`00`0mFJ/0lT<L0?9370020?93700303eIZ`3b@a`0lT<L00H0lT<L00<000000?93703b@a`0
1`3b@a`01@0mFJ/0lT<L0?93703b@a`0?EV[00@0000000<0jD0J0000003Y@1X0203Y@1X00`000000
jD0J0>U06P030>U06P0503eIZ`3Y@1X0jD0J0>U06P0000000P3Y@1X0100mFJ/0jD0J0>U06P3Y@1X2
000000030=`l60000000g3`H00P0g3`H00@000000=`l603L?1P0?EV[1P3L?1P00`000000g3`H0=`l
60020=`l60<0000000@0bSHF03eIZ`0mFJ/0bSHF0`0000030<Xf5P030000003:=QH0bSHF00D0bSHF
00<000000<Xf5P0000000P0000030:l^4P80e3dI0`3om^h30=@m6@0303eIZ`3om^h0ooK^00<0e3dI
00@0ooK^03eIZ`0mFJ/0ooK^103D?AT00`0mFJ/0ooK^0?ofkP020?ofkP80e3dI0P0mFJ/01@3om^h0
00000?ofkP3om^h0?EV[00@0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP1@0?of
kP030000003om^h0ooK^00l0ooK^0@3oool003T0ooK^00<000000?ofkP3om^h05`3om^h00`3D?AT0
ooK^0?ofkP0?0?ofkP<0e3dI00<0ooK^0=@m6@3om^h03P3om^h0103D?AT0ooK^0?ofkP0000020?of
kP030=@m6@3om^h0ooK^00@0ooK^0`3D?AT:0?ofkP<0e3dI4`3om^h00`3D?AT0ooK^0?ofkP020?of
kP030=@m6@0000001PPA008000000P0:3b<01@0000002PlS0000000?5SH0000000<03aHf0`3D?AT0
0`0?5SH0000001TSD@0201TSD@030000000I8e40e3dI00<06B=A0P000004028bK@030000000R<Vd0
8S9]00@08S9]00<00000028bK@0000000`0Z?X<00`000000nDHM0?U67@040?U67@<000000P3b@a`0
0`0mFJ/0lT<L0?9370030?9370030000000mFJ/0lT<L00H0lT<L00<000000?93703b@a`01P3b@a`0
0`0mFJ/000000?9370030?93700403eIZ`3b@a`0lT<L0?9370<00000203Y@1X00`000000jD0J0>U0
6P020>U06P0303eIZ`3Y@1X0jD0J0080jD0J00D000000>U06P3Y@1X0jD0J03eIZ`040>U06P<00000
203L?1P00`000000g3`H03eIZ`070=`l60030000003L?1P0g3`H00D0g3`H0`00000203eIZ`80bSHF
0P0000000`3:=QH000000<Xf5P060<Xf5P030000003:=QH0bSHF0080bSHF100000000`3om^h0e3dI
0=@m6@030?ofkP040=@m6@0mFJ/0e3dI0=@m6@<0ooK^00<0?EV[0?ofkP3om^h0103om^h20=@m6@03
03eIZ`3D?AT0ooK^0080ooK^00@0?EV[0=@m6@3D?AT0e3dI0`3om^h01@0mFJ/0ooK^0?ofkP3om^h0
?EV[00@0ooK^00<0?EV[0?ofkP3om^h0D@3om^h00`000000ooK^0?ofkP0?0?ofkP40oooo000i0?of
kP030000003om^h0ooK^01L0ooK^00<0e3dI0?ofkP3om^h04P3om^h30=@m6@h0ooK^00<0e3dI0?of
kP0000000`3om^h00`3D?AT0ooK^0?ofkP070?ofkP<0e3dI203om^h00`3D?AT0ooK^0=@m6@020=@m
6A00ooK^00T0e3dI0?ofkP3om^h0ooK^0000003D?AT0000000H84@0000000`0:3b<2000000803aHf
00<0000000lF=P0?5SH00`0?5SH00`000000e3dI0=@m6@0301TSD@030000000I8e40e3dI00<06B=A
00<00000028bK@0R<Vd00`0R<Vd00`0000008S9]028bK@04028bK@800000100Z?X<00`000000nDHM
0?U67@050?U67@050000003iAQd0000003eIZ`0000001@3b@a`00`000000lT<L03eIZ`060?937003
0000003b@a`0lT<L00D0lT<L00<0?EV[0?93700000001@3b@a`01P0mFJ/0lT<L0?93703b@a`00000
0?93708000001P3Y@1X01@000000jD0J0>U06P3Y@1X0?EV[00D0jD0J00<000000>U06P3Y@1X00P3Y
@1X00`0mFJ/0jD0J0>U06P020>U06P030000003Y@1X00000008000001@3L?1P00`000000?EV[0=`l
60070=`l60030000003L?1P0g3`H00H0g3`H00@000000=@m6@00000000000P0mFJ/20<Xf5P<00000
1`3:=QH00`000000bSHF0<Xf5P040<Xf5P8000000P3om^h20=@m6@030?ofkP3D?AT0?EV[0080ooK^
0P3D?AT00`0mFJ/0ooK^0?ofkP060?ofkP030=@m6@0mFJ/0e3dI0080e3dI00@0?EV[0?ofkP3om^h0
0000103D?AT0100mFJ/0ooK^03eIZ`0mFJ/40?ofkP0303eIZ`3om^h0ooK^0580ooK^00<000000?of
kP3om^h03`3om^h10?ooo`00>03om^h2000001T0ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0
ooK^0=@m6@020=@m6@/0ooK^00<0e3dI0000003om^h00`3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP<0
e3dI103om^h20=@m6@@0ooK^0`3D?AT<0?ofkP040=@m6@3om^h0ooK^0?ofkP80000000@0e3dI00H8
4@00000000000P0:3b<00`0000002PlS0000000200lF=P030000000?5SH03aHf00<03aHf00<00000
01TSD@0I8e400`3D?AT00`000000e3dI01TSD@0201TSD@8000001@0R<Vd00`0000008S9]028bK@04
028bK@030000000Z?X<0:Sj300<0:Sj300<000000?U67@3iAQd01@3iAQd00`000000nDHM03eIZ`02
0?U67@@0000000@0lT<L0000003b@a`0?EV[1P3b@a`00`000000lT<L0?9370040?93700403eIZ`3b
@a`0lT<L000000H0lT<L00@0?EV[0?93703b@a`000000`3b@a`3000000<0jD0J00@000000>U06P3Y
@1X0?EV[1P3Y@1X00`000000jD0J0>U06P030>U06P80?EV[0P3Y@1X00`000000jD0J0>U06P020>U0
6P@0000000<0g3`H03eIZ`3L?1P0203L?1P00`000000g3`H0=`l60060=`l60040000003L?1P0g3`H
0=`l608000000P0mFJ/20<Xf5P@00000103:=QH00`000000bSHF0<Xf5P050<Xf5P040000003om^h0
ooK^0?ofkP<0e3dI00D0?EV[0?ofkP3om^h0ooK^03eIZ`030=@m6@L0ooK^00@0?EV[0?ofkP3om^h0
?EV[0`3D?AT30?ofkP040=@m6@0mFJ/0e3dI03eIZ`@0ooK^0P0mFJ]F0?ofkP030000003om^h0ooK^
00h0ooK^0@3oool003P0ooK^00<000000?ofkP0000000P00000F0?ofkP030=@m6@3om^h0ooK^01<0
ooK^00<0e3dI0?ofkP3om^h00P3om^h30=@m6@L0ooK^00<0e3dI0000003om^h00`3om^h00`3D?AT0
ooK^0?ofkP0>0?ofkP<0e3dI00<0ooK^0=@m6@3om^h01`3om^h40=@m6@P0ooK^00<0e3dI0?ofkP3o
m^h00P0000001@3D?AT000000000000:3b<0000000802PlS0P00000300lF=P030000000?5SH03aHf
00803aHf0P00000501TSD@<0e3dI00@06B=A0000000R<Vd000001@0R<Vd00`0000008S9]028bK@03
028bK@8000001@0Z?X<00`000000nDHM0?U67@050?U67@030000003iAQd0?EV[00H0nDHM0`000000
0`3b@a`0?EV[0?9370040?9370030000003b@a`0lT<L00<0lT<L00D0?EV[0?93703b@a`0lT<L0000
00070?93700303eIZ`3b@a`0000000H0lT<L0P000000103Y@1X000000>U06P0mFJ/70>U06P030000
003Y@1X0jD0J00D0jD0J00<0?EV[0>U06P000000203Y@1X00`0mFJ/00000000000080=`l60030000
003L?1P0g3`H00H0g3`H00<000000=`l603L?1P00P3L?1P00`0mFJ/0g3`H0000000203eIZ`040000
003:=QH0bSHF0<Xf5P8000000P3:=QH00`000000bSHF0<Xf5P050<Xf5P040000003om^h0e3dI0=@m
6@<0ooK^00@0e3dI03eIZ`3D?AT0?EV[103om^h20=@m6@D0ooK^00<0?EV[0?ofkP0mFJ/00P3om^h4
0=@m6@80ooK^0P0mFJ/0103om^h0e3dI0=@m6@3D?AT203eIZeL0ooK^00<000000?ofkP3om^h03P3o
m^h10?ooo`00>03om^h00`000000ooK^0?ofkP020?ofkP<000004P3om^h00`3D?AT0ooK^0?ofkP0C
0?ofkP030=@m6@3om^h0ooK^00H0ooK^0P3D?AT50?ofkP030=@m6@000000ooK^00<0ooK^00<0e3dI
0?ofkP3om^h04@3om^h30=@m6@/0ooK^0`3D?AT50?ofkP090=@m6@3om^h0ooK^000000062140e3dI
0000000:3b<0000000<02PlS00<0000000lF=P0?5SH00`0?5SH01P0000003aHf00lF=P0000006B=A
000000D06B=A00<000000=@m6@0I8e400`3D?AT00`0000008S9]028bK@03028bK@030000000R<Vd0
8S9]00808S9]00<0000002XnP`0000001@0Z?X<00`000000?EV[0?U67@060?U67@0303eIZ`3iAQd0
nDHM00H0nDHM00D000000?U67@000000000003eIZ`040?9370030000003b@a`0lT<L0080lT<L00<0
?EV[0?93703b@a`00P3b@a`00`000000lT<L0?9370060?93700303eIZ`000000lT<L00L0lT<L0P00
00000`0mFJ/0jD0J0>U06P060>U06P030000003Y@1X0jD0J00H0jD0J00<0?EV[0000003Y@1X01P3Y
@1X0100mFJ/0jD0J0000003Y@1X2000000H0g3`H00<000000=`l603L?1P01P3L?1P01@000000g3`H
0=`l603L?1P0?EV[00@0g3`H00@0000003eIZ`0mFJ/0?EV[0`3:=QH3000000P0bSHF00<000000?of
kP3om^h0103om^h203eIZ`<0e3dI103om^h30=@m6@80ooK^0P0mFJ/00`3om^h00000000000020?of
kP@0e3dI00<0?EV[0=@m6@3D?AT00P3D?AT0100mFJ/0e3dI0=@m6@3D?AUF0?ofkP030000003om^h0
ooK^00h0ooK^0@3oool003L0ooK^00<000000?ofkP3om^h01P3om^h3000000l0ooK^00<0e3dI0?of
kP3om^h04`3om^h00`3D?AT0ooK^0?ofkP080?ofkP<0e3dI00<0ooK^0=@m6@0000001@3om^h00`3D
?AT0ooK^0?ofkP0B0?ofkP030=@m6@3om^h0e3dI0080e3dI2`3om^h30=@m6@040?ofkP3D?AT0ooK^
0?ofkP80000000D0e3dI0000000000002PlS0000000200X?8`8000001@0?5SH00`0000003aHf0000
000201TSD@030000000I8e406B=A00<06B=A00@0e3dI0000000I8e4000000P0R<Vd30=@m6@@08S9]
00@00000028bK@0R<Vd000000`0Z?X<00`000000:Sj302XnP`0202XnP`030=@m6@3iAQd0?EV[00D0
nDHM00<0?EV[0000003iAQd01`3iAQd01@000000nDHM0?U67@3iAQd0?EV[00<0000000<0lT<L0000
003b@a`00P3b@a`00`0mFJ/0lT<L0?9370030?9370030000003b@a`0lT<L00L0lT<L00<0?EV[0?93
703b@a`01`3b@a`0100mFJ/0lT<L0000000000050>U06P030000003Y@1X0jD0J00P0jD0J00<0?EV[
0>U06P3Y@1X0103Y@1X0100mFJ/0jD0J0>U06P0000030>U06P<000000`3L?1P00`000000g3`H0=`l
60060=`l60040000003L?1P0g3`H03eIZ`H0g3`H00<000000=`l600000000`0mFJ/30<Xf5P<00000
1@3:=QH00`000000ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^0080ooK^0`3D?AT40?ofkP80e3dI
00@0?EV[0=@m6@000000ooK^103D?AT20?ofkP0403eIZ`3D?AT0ooK^0=@m6@80?EV[0`3om^h30=@m
6E@0ooK^00<000000?ofkP3om^h03P3om^h10?ooo`00=`3om^h00`000000ooK^0?ofkP090?ofkP<0
0000303om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0000003D
?AT01@3om^h00`3D?AT0ooK^0?ofkP0A0?ofkP030=@m6@3om^h0ooK^00<0ooK^0`3D?AT;0?ofkP80
e3dI00H0ooK^0000000000001PPA0=@m6@00000200X?8`050000000:3b<0000000lF=P0000001@0?
5SH00`0000003aHf0000000201TSD@030000000I8e406B=A00<06B=A00<0e3dI000000000000100R
<Vd00`0000008S9]0=@m6@020=@m6@04028bK@0000008S9]000000@0:Sj300<0000002XnP`0Z?X<0
0P0Z?X<00`3D?AT0nDHM03eIZ`040?U67@0303eIZ`3iAQd0000000P0nDHM00<000000?U67@3iAQd0
0P3iAQd00`0mFJ/0nDHM0?U67@03000000030?93700mFJ/0lT<L00D0lT<L00<000000?93703b@a`0
1`3b@a`00`000000?EV[0?9370060?93700303eIZ`000000lT<L0080lT<L0P0000030>U06P030000
003Y@1X0jD0J00L0jD0J00@000000>U06P0mFJ/0?EV[0`3Y@1X0100mFJ/0jD0J0>U06P0000070>U0
6P80000000<0g3`H0000003L?1P01`3L?1P00`000000g3`H03eIZ`070=`l60030000003L?1P0g3`H
0080g3`H00D0000003eIZ`0mFJ/0bSHF000000020<Xf5P8000000`3:=QH00`000000e3dI0?ofkP03
0?ofkP80?EV[00<0e3dI0?ofkP3om^h0103om^h20=@m6@<0ooK^0P0mFJ/30=@m6@D0ooK^0P0mFJ/0
103om^h0?EV[03eIZ`0mFJ/70?ofkP<0e3dID@3om^h00`000000ooK^0?ofkP0>0?ofkP40oooo000g
0?ofkP030000003om^h0ooK^00`0ooK^0`0000090?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI
0?ofkP3om^h02`3om^h00`3D?AT000000?ofkP030=@m6@030?ofkP3D?AT0ooK^01<0ooK^00<0e3dI
0?ofkP3om^h01P3om^h30=@m6@T0ooK^00H0e3dI000000000000000000H84@3D?AT300X?8`800000
0P0?5SH00`0000003aHf00lF=P0300lF=P8000000`0I8e400`0000006B=A01TSD@0301TSD@030=@m
6@0000008S9]00@08S9]00<00000028bK@0R<Vd00P0R<Vd40=@m6@@0:Sj300H0000002XnP`0Z?X<0
:Sj30=@m6@0000020?U67@0403eIZ`3iAQd0nDHM03eIZ`80nDHM00<000000?U67@3iAQd01P3iAQd0
0`000000nDHM0?U67@030?U67@0703eIZ`3iAQd0nDHM0000003iAQd0?EV[000000060?9370030000
003b@a`0lT<L00H0lT<L00@000000?93703b@a`0?EV[1@3b@a`00`0mFJ/000000?9370050?937080
000000<0jD0J0000003Y@1X0203Y@1X01`000000jD0J0>U06P3Y@1X0?EV[0>U06P0mFJ/00`3Y@1X0
0`000000jD0J0>U06P070>U06P<000001`3L?1P00`000000?EV[0=`l60070=`l60030000003L?1P0
g3`H00D0g3`H0`0mFJ/30<Xf5P@0000000P0ooK^0=@m6@3D?AT0e3dI03eIZ`3om^h0?EV[0=@m6@P0
ooK^0P3D?AT203eIZ`030=@m6@3om^h0e3dI00@0ooK^1`0mFJ/30=@m6@P0ooK^0P3D?AU@0?ofkP03
0000003om^h0ooK^00d0ooK^0@3oool003L0ooK^00<000000?ofkP3om^h03`3om^h4000000@0ooK^
00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030000003om^h0ooK^00<0ooK^
0`3D?ATB0?ofkP80e3dI2`3om^h20=@m6@H0ooK^00L0e3dI0000000000001PPA0000003D?AT00000
00802PlS00<0000000X?8`0000000P0?5SH00`0000003aHf00lF=P0300lF=P030000000I8e406B=A
00<06B=A00D0000001TSD@0I8e406B=A0=@m6@02000000D08S9]00<00000028bK@0R<Vd00`0R<Vd0
0`000000:Sj302XnP`030=@m6@0302XnP`000000:Sj30080:Sj300L0e3dI02XnP`000000nDHM03eI
Z`3iAQd0?EV[00<0nDHM00<000000?U67@3iAQd01P3iAQd00`000000nDHM0?U67@040?U67@0403eI
Z`3iAQd0000003eIZ`80nDHM0`0000030?9370030000003b@a`0lT<L00H0lT<L00D000000?93703b
@a`0lT<L03eIZ`030?93700303eIZ`3b@a`0000000P0lT<L0`0000080>U06P030000003Y@1X0jD0J
0080jD0J00<0?EV[0>U06P3Y@1X00P3Y@1X00`000000jD0J0>U06P080>U06P030000003Y@1X00000
00800000103L?1P00`0mFJ/0g3`H0=`l60070=`l60030000003L?1P0g3`H00H0g3`H00<000000=@m
6@0mFJ/00`0mFJ/20<Xf5P8000000P3om^h01@0mFJ/0e3dI0=@m6@0mFJ/0e3dI00P0ooK^0P0mFJ/0
1P3D?AT0?EV[0=@m6@3D?AT0ooK^0=@m6@80ooK^100mFJ/00`3om^h0?EV[03eIZ`030?ofkP@0e3dI
1`3om^h00`3D?AT0ooK^0?ofkP1=0?ofkP030000003om^h0ooK^00d0ooK^0@3oool003L0ooK^00<0
00000?ofkP3om^h04`3om^h3000000030?ofkP3D?AT0e3dI01@0ooK^00<0e3dI0?ofkP3om^h02`3o
m^h00`000000e3dI0?ofkP050?ofkP030=@m6@3om^h0e3dI0080e3dI3`3om^h00`3D?AT0ooK^0?of
kP0<0?ofkP<0e3dI0`3om^h01`3D?AT0000000H84@0000001PPA0=@m6@0000000P0:3b<2000000<0
3aHf00<0000000lF=P0?5SH00P0?5SH2000000D06B=A00L0000001TSD@0I8e406B=A0=@m6@0R<Vd0
000000D08S9]00<00000028bK@0R<Vd00P0R<Vd2000000D0:Sj30`3D?AT01@0Z?X<0e3dI02XnP`0Z
?X<000000080nDHM00<0?EV[0?U67@3iAQd00P3iAQd00`000000nDHM0?U67@060?U67@030000003i
AQd0nDHM00@0nDHM00<0?EV[0?U67@0mFJ/01P3iAQd2000000030?9370000000lT<L00L0lT<L00<0
00000?93703b@a`00P3b@a`00`0mFJ/0lT<L03eIZ`020?9370030000003b@a`0lT<L00L0lT<L00<0
00000?93700000000P0000050>U06P060000003Y@1X0jD0J0>U06P0mFJ/0jD0J0P0mFJ/20>U06P03
0000003Y@1X0jD0J00P0jD0J00<000000>U06P3Y@1X00P3Y@1X200000080?EV[00<000000=`l603L
?1P01P3L?1P00`000000g3`H0=`l60070=`l60040000003L?1P0?EV[0=`l60800000100mFJ/30000
0080ooK^00<0?EV[0=@m6@3D?AT01P3om^h01@0mFJ/0e3dI0=@m6@000000?EV[0080ooK^0P3D?AT3
03eIZ`030?ofkP0mFJ/0ooK^0080?EV[103om^h0103D?AT0ooK^0?ofkP3om^h30=@m6@D0ooK^00<0
e3dI0?ofkP3om^h0C03om^h00`000000ooK^0?ofkP0=0?ofkP40oooo000f0?ofkP030000003om^h0
ooK^01L0ooK^00<000000=@m6@000000103D?AT@0?ofkP030=@m6@3om^h0ooK^00X0ooK^00<00000
0=@m6@3om^h01P3om^h00`3D?AT0ooK^0?ofkP020?ofkP<0e3dI303om^h00`3D?AT0ooK^0?ofkP0?
0?ofkP<0e3dI0P0000001@06214000000000003D?AT0000000802PlS00<0000000lF=P0?5SH00`0?
5SH01P0000003aHf00lF=P0000006B=A000000D06B=A00D0000001TSD@0I8e4000000=@m6@02028b
K@030000000R<Vd08S9]00808S9]00D00000028bK@0R<Vd08S9]0000000202XnP`030000000Z?X<0
:Sj300@0:Sj300X000000=@m6@3D?AT0e3dI02XnP`000000nDHM03eIZ`3iAQd0?EV[0`3iAQd00`00
0000nDHM0?U67@060?U67@030000003iAQd0nDHM00D0nDHM00<0?EV[0000003iAQd01`3iAQd30000
00L0lT<L00<000000?93703b@a`00`3b@a`01@0mFJ/0lT<L0?93703b@a`0000000T0lT<L00<00000
0?93703b@a`00P3b@a`4000000050>U06P000000jD0J0>U06P0mFJ/0103Y@1X203eIZ`030000003Y
@1X0jD0J00L0jD0J00<000000>U06P3Y@1X0103Y@1X00`0mFJ/0jD0J00000002000000L0g3`H00<0
00000=`l603L?1P01`3L?1P00`000000?EV[0=`l60030=`l6080000000<0bSHF0000000mFJ/00P0m
FJ/3000000030=@m6@3om^h0e3dI0080e3dI0P3om^h00`0mFJ/0e3dI03eIZ`0803eIZ`80e3dI00@0
ooK^03eIZ`0mFJ/0?EV[1P3om^h00`3D?AT0ooK^0?ofkP030?ofkP80e3dI103om^h00`3D?AT0ooK^
0?ofkP1;0?ofkP030000003om^h0ooK^00d0ooK^0@3oool003H0ooK^00<000000?ofkP3om^h0603o
m^h00`3D?AT0ooK^00000002000000040?ofkP3D?AT0e3dI0=@m6@d0ooK^00<0e3dI0?ofkP3om^h0
2P3om^h00`000000e3dI0?ofkP050?ofkP030=@m6@3om^h0ooK^00H0ooK^103D?AT70?ofkP80e3dI
4`3om^h02@000000e3dI0=@m6@3D?AT000000=@m6@0:3b<0000000X?8`02000000D03aHf00<00000
00lF=P0000000P0I8e400`0000006B=A01TSD@0301TSD@040000000I8e4000000=@m6@<08S9]00<0
0000028bK@0R<Vd00`0R<Vd00`0000008S9]0000000302XnP`030000000Z?X<0:Sj300@0:Sj300@0
000002XnP`3D?AT0:Sj30P3D?AT0100mFJ/0nDHM0?U67@0mFJ/40?U67@030000003iAQd0nDHM00H0
nDHM00<000000?U67@3iAQd00`3iAQd00`0mFJ/0nDHM03eIZ`090?U67@030000003iAQd000000080
0000103b@a`00`000000lT<L0?9370020?93700603eIZ`3b@a`0?EV[03eIZ`3b@a`00000203b@a`0
0`000000lT<L0?9370070?9370<0000000<0?EV[0>U06P3Y@1X01@3Y@1X203eIZ`P0jD0J00<00000
0>U06P3Y@1X00`3Y@1X01P0mFJ/0jD0J0>U06P3Y@1X000000>U06P8000001@3L?1P00`000000g3`H
0=`l60070=`l600303eIZ`3L?1P0g3`H00D0g3`H00<0000003eIZ`3D?AT0103om^h00`0mFJ/00000
0000000703eIZ`030000003om^h0?EV[0080ooK^00<0?EV[0?ofkP0mFJ/00`3om^h203eIZ`030=@m
6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h01@3om^h30=@m6@80ooK^00<0e3dI0?ofkP3om^h0
B`3om^h00`000000ooK^0?ofkP0<0?ofkP40oooo000f0?ofkP030000003om^h0ooK^01P0ooK^00<0
e3dI0?ofkP3om^h00P3om^h3000000030?ofkP3D?AT0e3dI0080e3dI2@3om^h00`3D?AT0ooK^0?of
kP090?ofkP030000003D?AT0ooK^00H0ooK^00<0e3dI0?ofkP3om^h02P3om^h30=@m6@@0ooK^0P3D
?ATB0?ofkP<0000000<01PPA0000003D?AT00P3D?AT200X?8`8000001@0?5SH00`0000003aHf0000
000201TSD@030000000I8e406B=A00<06B=A0P0000000`0R<Vd0e3dI028bK@02028bK@030000000R
<Vd08S9]00<08S9]00<00000028bK@0000000`0Z?X<00`000000:Sj302XnP`0402XnP`040000003D
?AT0:Sj302XnP`80000000D0oTPN000000000000000003eIZ`030?U67@030000003iAQd0nDHM00H0
nDHM00<000000?U67@3iAQd00P3iAQd01@0mFJ/0nDHM0?U67@000000?EV[00P0nDHM00<000000?U6
7@3iAQd00P3iAQd3000000030?9370000000lT<L0080lT<L00<0?EV[0?93703b@a`00P3b@a`00`0m
FJ/000000?9370070?9370030000003b@a`0lT<L00P0lT<L00<0000003eIZ`0000000P0000040>U0
6P030000003Y@1X0jD0J0080?EV[1P3Y@1X00`000000jD0J0>U06P020>U06P0303eIZ`3Y@1X0jD0J
0080jD0J00@000000>U06P3Y@1X0jD0J0P0000030=`l60030000003L?1P0g3`H00H0g3`H00<0?EV[
0000003L?1P01`3L?1P010000000ooK^0=@m6@3D?AT20?ofkP0303eIZ`3om^h0?EV[00<0000000<0
?EV[0?ofkP0000000`3om^h01`0mFJ/0ooK^03eIZ`3om^h0?EV[0?ofkP3D?AT00P3om^h00`0mFJ/0
ooK^0?ofkP020=@m6@H0ooK^00<0e3dI0?ofkP3om^h01`3om^h40=@m6D`0ooK^00<000000?ofkP3o
m^h0303om^h10?ooo`00=P3om^h00`000000ooK^0?ofkP0G0?ofkP030=@m6@3om^h0ooK^00H0ooK^
0`0000020?ofkP<0e3dI1@3om^h00`3D?AT0ooK^0?ofkP090?ofkP040000003om^h0e3dI0=@m6@H0
ooK^00<0e3dI0?ofkP3om^h03@3om^h50=@m6A80ooK^0`00000200H84@040000000:3b<0e3dI0000
00<0e3dI00<0000000lF=P0?5SH00`0?5SH2000000<06B=A00<0000001TSD@0I8e400`0I8e400`00
00008S9]0=@m6@04028bK@030000000R<Vd08S9]00<08S9]0P00000402XnP`030000000Z?X<0:Sj3
00@0:Sj300@000000=@m6@0Z?X<0:Sj30P0000040?i87P050000000mFJ/000000?U67@000000203i
AQd01@000000nDHM0?U67@3iAQd0?EV[00<0nDHM00<000000?U67@0mFJ/01`3iAQd00`000000nDHM
0?U67@050?U67@<0000000<0lT<L03eIZ`3b@a`0103b@a`00`000000?EV[0?9370070?9370030000
003b@a`0lT<L00L0lT<L00<0000003eIZ`3b@a`00`3b@a`3000000030>U06P000000jD0J00<0jD0J
0P0mFJ/40>U06P050000003Y@1X0jD0J0>U06P0mFJ/0103Y@1X00`000000jD0J0>U06P040>U06P80
000000<0g3`H0000003L?1P01P3L?1P00`0mFJ/0g3`H000000080=`l60040000003om^h0ooK^0?of
kP80e3dI0P0mFJ/0103D?AT0ooK^0?ofkP0mFJ/3000000<0ooK^100mFJ/20?ofkP030=@m6@0mFJ/0
?EV[00D0ooK^0P3D?AT40?ofkP030=@m6@3om^h0ooK^00X0ooK^0P3D?AU;0?ofkP030000003om^h0
ooK^00`0ooK^0@3oool003H0ooK^00<000000?ofkP3om^h05`3om^h00`3D?AT0ooK^0?ofkP090?of
kP<000000P3om^h40=@m6@030?ofkP3D?AT0ooK^00T0ooK^00D000000?ofkP3om^h0e3dI0?ofkP03
0=@m6@<0ooK^00<0e3dI0?ofkP3om^h0403om^h30=@m6A40ooK^0`0000001@06214000000000003D
?AT02PlS008000000P0?5SH20=@m6@@03aHf00<0000001TSD@0I8e400`0I8e40100000006B=A01TS
D@0I8e4200000003028bK@3D?AT08S9]00@08S9]00<00000028bK@0R<Vd00P0R<Vd00`000000:Sj3
02XnP`0402XnP`030000000Z?X<0:Sj300<0:Sj300@000000=@m6@0Z?X<000000P0aB9D00`000000
oTPN0?i87P020?i87P0303eIZ`3nB1h00000008000001`3iAQd01@000000nDHM0?U67@3iAQd0?EV[
00<0nDHM00@000000?U67@3iAQd0?EV[1P3iAQd00`000000nDHM0?U67@060?U67@030000003iAQd0
?EV[00800000103b@a`010000000lT<L03eIZ`0mFJ/60?9370030000003b@a`0lT<L00L0lT<L00<0
?EV[0?93703b@a`01P3b@a`3000000D0jD0J0P0mFJ/20>U06P040000003Y@1X0jD0J03eIZ`D0jD0J
00<000000>U06P3Y@1X01P3Y@1X3000000D0g3`H00@0?EV[0=`l603L?1P00000203L?1P00`000000
ooK^0?ofkP030?ofkP0303eIZ`3D?AT0e3dI0080?EV[00@0ooK^0000003om^h0ooK^0P0000000`3o
m^h0?EV[03eIZ`040?ofkP80?EV[203om^h30=@m6@80ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D
?AT0ooK^0?ofkP180?ofkP030000003om^h0ooK^00`0ooK^0@3oool003H0ooK^00<000000?ofkP3o
m^h05`3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP<000000`3om^h30=@m6@T0ooK^00<000000?ofkP3D
?AT01@3om^h30=@m6A80ooK^00@0e3dI0?ofkP3D?AT0ooK^0`3D?AT=0?ofkP<0000000H01PPA0000
000:3b<000000=@m6@0:3b<2000000803aHf00<0000000lF=P3D?AT00P3D?AT2000000D06B=A00@0
000001TSD@0I8e4000000P0R<Vd00`000000e3dI028bK@04028bK@040000000R<Vd08S9]028bK@80
00001P0Z?X<00`000000:Sj302XnP`0302XnP`030=@m6@000000000000<0<DRE00<000000?i87P3n
B1h00`3nB1h0100mFJ/0oTPN0000003nB1h3000000@0nDHM00@000000?U67@3iAQd0?EV[103iAQd0
1@000000nDHM0?U67@3iAQd0?EV[00D0nDHM00<000000?U67@3iAQd01P3iAQd00`000000?EV[0?U6
7@020?U67@<0000000<0lT<L0000003b@a`00P3b@a`00`0mFJ/0lT<L0?9370030?9370030000003b
@a`0lT<L00D0lT<L0P0mFJ/00`000000lT<L0?9370070?9370040000003b@a`00000000000D0jD0J
0P0mFJ/00`000000jD0J03eIZ`060>U06P030000003Y@1X0jD0J00L0jD0J00<000000>U06P000000
0P00000203eIZ`<0g3`H00<000000=`l603L?1P01P3L?1P00`000000ooK^0?ofkP020?ofkP80?EV[
00<0ooK^03eIZ`3D?AT00P3D?AT50?ofkP<000000`3om^h203eIZ``0ooK^0`3D?AT=0?ofkP030=@m
6@3om^h0ooK^04T0ooK^00<000000?ofkP3om^h02`3om^h10?ooo`00=@3om^h00`000000ooK^0?of
kP0H0?ofkP030=@m6@3om^h0ooK^00l0ooK^0`0000000`3om^h0e3dI0?ofkP030=@m6@D0ooK^00@0
00000?ofkP3om^h0e3dI1`3om^h40=@m6@l0ooK^00<0e3dI0?ofkP3D?AT0103om^h20=@m6@X0ooK^
1@0000000`0:3b<000000=@m6@0200X?8`030000000?5SH03aHf00803aHf00@0000000lF=P0?5SH0
00000`3D?AT401TSD@030000000I8e40000000<08S9]00<0e3dI028bK@0R<Vd0100R<Vd010000000
8S9]028bK@00000202XnP`030000000Z?X<0:Sj300<0:Sj300<0000002XnP`0Z?X<00`0Z?X<00`3D
?AT00000000000030358U@030000003nB1h0oTPN00@0oTPN00<0?EV[0000003nB1h00`3nB1h30000
00040?U67@000000nDHM03eIZ`D0nDHM00<000000?U67@3iAQd00P3iAQd00`0mFJ/0nDHM0?U67@02
0?U67@030000003iAQd0nDHM00H0nDHM00<0?EV[0?U67@3iAQd01@3iAQd3000000<0lT<L00<0?EV[
0?93703b@a`00P3b@a`00`000000lT<L0?9370040?93700403eIZ`3b@a`0lT<L000000P0lT<L00<0
00000?93703b@a`00P3b@a`3000000<0jD0J00@0000003eIZ`0mFJ/0?EV[1P3Y@1X00`000000jD0J
0>U06P070>U06P050000003Y@1X0jD0J0>U06P0mFJ/0100000000`3L?1P000000=`l60070=`l6006
0000003om^h0ooK^0?ofkP0mFJ/0ooK^0P0mFJ/0103D?AT0ooK^0000003om^h30=@m6@030?ofkP0m
FJ/0?EV[0080ooK^0`0000000`0mFJ/0ooK^0=@m6@0=0?ofkP<0e3dI303om^h00`3D?AT0ooK^0?of
kP180?ofkP030000003om^h0ooK^00/0ooK^0@3oool003D0ooK^00<000000?ofkP3om^h0603om^h0
0`3D?AT0ooK^0?ofkP0B0?ofkP030000003D?AT0000000<0ooK^0`3D?AT01@3om^h000000?ofkP3o
m^h0e3dI00P0ooK^00@0e3dI0?ofkP3om^h0ooK^0`3D?AT<0?ofkP80e3dI1`3om^h30=@m6@H0ooK^
1@00000200X?8`030000003D?AT02PlS00800000100?5SH00`0000003aHf0000000301TSD@080000
003D?AT0e3dI0=@m6@0I8e40000001TSD@000003028bK@030=@m6@0R<Vd08S9]00@08S9]00@00000
028bK@0R<Vd000000P0Z?X<00`000000:Sj302XnP`0402XnP`030000000Z?X<0:Sj30080:Sj300<0
e3dI0000000aB9D00`0aB9D00`000000oTPN0?i87P040?i87P0303eIZ`000000oTPN00H0oTPN0P00
00000`0mFJ/0nDHM0?U67@040?U67@030000003iAQd0nDHM0080nDHM00D0?EV[0?U67@3iAQd0nDHM
000000080?U67@0303eIZ`3iAQd0nDHM00L0nDHM00@000000?U67@00000000000P3b@a`203eIZ`03
0?9370000000lT<L00D0lT<L00@0?EV[0?93703b@a`000002@3b@a`00`000000lT<L0?9370050?93
7080000000<0jD0J0000000mFJ/00P3Y@1X203eIZ`@0jD0J00<000000>U06P3Y@1X01P3Y@1X01@00
0000jD0J0>U06P3Y@1X0?EV[00D0jD0J0`0000070=`l60040000003om^h0ooK^03eIZ`80ooK^00@0
?EV[0?ofkP3D?AT00000103om^h303eIZ`@0ooK^0P0mFJ/2000000030=@m6@3om^h0ooK^00`0ooK^
00<0e3dI0?ofkP3D?AT00P3D?AT90?ofkP030=@m6@3om^h0ooK^04P0ooK^00<000000?ofkP3om^h0
2`3om^h10?ooo`00=@3om^h00`000000ooK^0?ofkP0H0?ofkP030=@m6@3om^h0ooK^0180ooK^00<0
e3dI0?ofkP3om^h00`0000030?ofkP050=@m6@000000ooK^0?ofkP3D?AT0203om^h00`3D?AT0ooK^
0?ofkP040?ofkP<0e3dI203om^h00`3D?AT0ooK^0=@m6@0:0?ofkP<0e3dI0P3om^h20000000300H8
4@000000000000<02PlS00D0e3dI00X?8`0000003aHf0000000400lF=P030000000?5SH0000000<0
6B=A00@0000001TSD@0I8e406B=A0P3D?AT00`0000008S9]028bK@02028bK@030=@m6@0000008S9]
00D08S9]0P00000302XnP`030000000Z?X<0:Sj300@0:Sj300D0000002XnP`0Z?X<0:Sj30=@m6@02
000000D0<DRE00<000000?i87P3nB1h0103nB1h00`0mFJ/000000?i87P060?i87P0403eIZ`3nB1h0
0000000000@0nDHM00<000000?U67@3iAQd00`3iAQd0100mFJ/0nDHM0?U67@0000080?U67@0303eI
Z`3iAQd0nDHM00L0nDHM00@000000?U67@3iAQd0nDHM0P0000020?93700303eIZ`000000lT<L00@0
lT<L00D0?EV[0?93703b@a`0lT<L000000090?9370030000003b@a`0lT<L00L0lT<L00<0000003eI
Z`000000103Y@1X303eIZ`030>U06P000000jD0J00L0jD0J00@000000>U06P3Y@1X0?EV[1`3Y@1X0
10000000jD0J0000000000050=`l60030000000mFJ/0?EV[0080ooK^0P0mFJ/00`000000e3dI0?of
kP030?ofkP0403eIZ`3om^h0?EV[03eIZ`<0e3dI00<0?EV[0?ofkP3om^h00P3om^h3000000`0ooK^
00<0e3dI0?ofkP3om^h00P3om^h30=@m6@L0ooK^00<0e3dI0?ofkP3om^h0A`3om^h00`000000ooK^
0?ofkP0;0?ofkP40oooo000e0?ofkP030000003om^h0ooK^01L0ooK^00<0e3dI0?ofkP3om^h04`3o
m^h00`3D?AT0ooK^0?ofkP030?ofkP@0000000@0ooK^0=@m6@3D?AT0e3dI203om^h00`3D?AT0ooK^
0?ofkP070?ofkP<0e3dI1@3om^h00`3D?AT0ooK^0=@m6@0=0?ofkP80e3dI00<0000000H84@000000
0P00000300X?8`050=@m6@0000003aHf00lF=P000000100?5SH2000000@06B=A00<0000001TSD@0I
8e400P0I8e4020000000e3dI0=@m6@3D?AT08S9]0=@m6@0R<Vd000001P0R<Vd00`000000:Sj302Xn
P`0302XnP`030000000Z?X<0:Sj300<0:Sj300D0000002XnP`0Z?X<0:Sj30=@m6@020358U@030000
000aB9D0<DRE0080<DRE00<000000?i87P3nB1h01@3nB1h00`0mFJ/0oTPN0?i87P040?i87P0303eI
Z`000000oTPN0080oTPN0`0000000`3iAQd000000?U67@050?U67@0303eIZ`3iAQd0000000L0nDHM
00<0?EV[0000003iAQd0203iAQd00`000000nDHM0?U67@030?U67@80000000<0lT<L03eIZ`3b@a`0
0`3b@a`00`0mFJ/0lT<L0?9370020?9370030000003b@a`0lT<L00L0lT<L00<000000?93703b@a`0
1`3b@a`00`0mFJ/000000?937003000000@0jD0J0`0mFJ/70>U06P030000003Y@1X0?EV[00L0jD0J
00<000000>U06P3Y@1X00P3Y@1X2000000<0g3`H00@0?EV[0?ofkP3om^h0e3dI0P0mFJ/00`000000
ooK^0=@m6@030?ofkP@0?EV[0`3om^h0100mFJ/0e3dI0=@m6@3D?AT20?ofkP030=@m6@3om^h0ooK^
008000002`3om^h00`3D?AT0ooK^0?ofkP040?ofkP80e3dI1@3om^h00`3D?AT0ooK^0?ofkP170?of
kP030000003om^h0ooK^00/0ooK^0@3oool003D0ooK^00<000000?ofkP3om^h05`3om^h00`3D?AT0
ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^00D0ooK^00H000000?ofkP00000000000=@m6@3om^h3
0=@m6@@0ooK^00<0e3dI0?ofkP3om^h02`3om^h30=@m6@050?ofkP3D?AT0ooK^0?ofkP3D?AT03P3o
m^h00`0000001PPA00H84@03000000802PlS00<0e3dI00X?8`0000000P0?5SH00`0000003aHf00lF
=P0200lF=P030000000I8e406B=A00<06B=A00@0000001TSD@0I8e406B=A0P000003028bK@<0e3dI
00<00000028bK@0R<Vd00`0R<Vd2000000D0:Sj300<0000002XnP`0Z?X<00`0Z?X<010000000:Sj3
02XnP`3D?AT30358U@030000000aB9D0<DRE0080<DRE00<000000?i87P3nB1h01@3nB1h00`0mFJ/0
oTPN0?i87P030?i87P0303eIZ`3nB1h0000000H0oTPN0`0000060?U67@0303eIZ`000000nDHM00D0
nDHM00<0?EV[0?U67@000000203iAQd00`000000nDHM0?U67@060?U67@8000000P0mFJ/00`3b@a`0
?EV[0?9370040?9370030000003b@a`0lT<L00H0lT<L00<000000?93703b@a`01`3b@a`00`0mFJ/0
00000?9370040?9370<0000000@0jD0J0000003Y@1X0jD0J0P0mFJ/50>U06P030000000mFJ/0jD0J
00L0jD0J00<000000>U06P3Y@1X0103Y@1X20000000703eIZ`000000ooK^0?ofkP0mFJ/0ooK^03eI
Z`020?ofkP030=@m6@3om^h0ooK^0080?EV[0P3om^h0100mFJ/0ooK^03eIZ`0mFJ/40?ofkP80e3dI
00<0ooK^0=@m6@3om^h00P3om^h3000000P0ooK^00<0e3dI0?ofkP3om^h01P3om^h30=@m6@<0ooK^
00<0e3dI0?ofkP3om^h0A`3om^h00`000000ooK^0?ofkP0:0?ofkP40oooo000d0?ofkP030000003o
m^h0ooK^01P0ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP040?ofkP060000003o
m^h0ooK^0?ofkP3D?AT0ooK^0`0000001P3om^h0e3dI0=@m6@3D?AT0ooK^0=@m6A00ooK^103D?AT>
0?ofkP80000000@01PPA00000000000000000`0:3b<00`3D?AT0000000lF=P0200lF=P040000000?
5SH03aHf00lF=P8000001@0I8e401`0000006B=A01TSD@0I8e400000028bK@0000000`0R<Vd00`3D
?AT08S9]0=@m6@020=@m6@808S9]00@0000002XnP`0Z?X<00000100Z?X<00`000000:Sj302XnP`04
02XnP`80000000D0e3dI0358U@0aB9D0<DRE000000040358U@030000003nB1h0oTPN00D0oTPN00<0
000003eIZ`3nB1h00`3nB1h00`0mFJ/0oTPN000000070?i87P030000003nB1h0000000800000103i
AQd00`0mFJ/0nDHM0?U67@030?U67@0403eIZ`3iAQd0nDHM000000P0nDHM00<000000?U67@3iAQd0
1`3iAQd01@000000nDHM0000000mFJ/0000000@0lT<L00<000000?93703b@a`01`3b@a`00`000000
lT<L0?9370060?93700303eIZ`3b@a`0000000P0lT<L0`0000030>U06P<0?EV[0P3Y@1X00`0mFJ/0
jD0J0>U06P070>U06P030000003Y@1X0jD0J00D0jD0J00P0?EV[000000000000ooK^03eIZ`3om^h0
000003eIZ`80ooK^00@0e3dI0?ofkP0mFJ/0?EV[0P3om^h403eIZ`L0ooK^0`3D?AT50?ofkP<00000
1@3om^h00`3D?AT0ooK^0?ofkP090?ofkP@0e3dIB@3om^h00`000000ooK^0?ofkP0:0?ofkP40oooo
000d0?ofkP030000003om^h0ooK^01P0ooK^0P3D?ATC0?ofkP030=@m6@3om^h0ooK^00D0ooK^00D0
00000?ofkP3om^h0ooK^0=@m6@040?ofkP<0000000@0ooK^0=@m6@3D?AT0e3dI3`3om^h00`3D?AT0
ooK^0?ofkP030=@m6@/0ooK^0P00000200H84@030000000:3b<0000000<02PlS00<0e3dI00lF=P0?
5SH00P0?5SH01P0000003aHf00lF=P0000006B=A000000D06B=A00@0000001TSD@0I8e4000000P0R
<Vd0100000008S9]028bK@3D?AT3028bK@030000000R<Vd0e3dI0080e3dI0P0Z?X<00`000000:Sj3
02XnP`0202XnP`030000000Z?X<0:Sj300@0:Sj300<000000358U@3D?AT00`0aB9D00`000000<DRE
0358U@030358U@030000003nB1h0oTPN00@0oTPN00<000000?i87P0mFJ/00P3nB1h0100mFJ/0oTPN
0?i87P0000070?i87P030000003nB1h0oTPN0080oTPN0`0000000`3iAQd0000003eIZ`030?U67@05
03eIZ`3iAQd0nDHM0?U67@000000203iAQd00`000000nDHM0?U67@060?U67@050000003iAQd0nDHM
03eIZ`3iAQd00P0mFJ/2000000030?9370000000lT<L00P0lT<L00<000000?93703b@a`01@3b@a`0
100mFJ/0lT<L0?93700000090?9370040000003b@a`00000000000@0jD0J100mFJ/80>U06P030000
003Y@1X0jD0J00@0jD0J00T0?EV[0>U06P3Y@1X0000003eIZ`3om^h000000?ofkP0mFJ/00P3om^h0
103D?AT0?EV[03eIZ`3om^h203eIZ`030?ofkP0mFJ/0?EV[00T0ooK^00@0e3dI0?ofkP3D?AT0e3dI
1P3om^h2000000<0ooK^00<0e3dI0?ofkP3om^h0303om^h20=@m6DP0ooK^00<000000?ofkP3om^h0
2P3om^h10?ooo`00=03om^h00`000000ooK^0?ofkP0H0?ofkP030=@m6@3om^h0e3dI0080e3dI403o
m^h00`3D?AT0ooK^0?ofkP040?ofkP050000003om^h0ooK^0?ofkP3D?AT0203om^h2000000030=@m
6@3om^h0e3dI0080e3dI303om^h0103D?AT0ooK^0?ofkP3D?AT20?ofkP@0e3dI1`3om^h200000005
00H84@000000000000X?8`0000000P0:3b<00`3D?AT0000000lF=P0300lF=P030000000?5SH00000
00<06B=A00<0000001TSD@0I8e400`0I8e42000000<08S9]00@00000028bK@0R<Vd0e3dI0`0R<Vd0
1@0000008S9]028bK@000000:Sj300<0e3dI1@0Z?X<00`000000:Sj302XnP`0202XnP`80000000<0
e3dI0358U@0aB9D00`0aB9D00`000000<DRE0358U@020358U@030000003nB1h0oTPN00@0oTPN00D0
00000?i87P0mFJ/0oTPN03eIZ`030?i87P030000003nB1h0oTPN00D0oTPN00<000000?i87P3nB1h0
1@3nB1h30000000303eIZ`3iAQd0?EV[00<0nDHM00<000000?U67@3iAQd01`3iAQd00`000000nDHM
0?U67@060?U67@030000003iAQd0?EV[00@0nDHM0P0mFJ/3000000P0lT<L00<000000?93703b@a`0
103b@a`0100mFJ/0lT<L0?93700000090?9370030000003b@a`0lT<L0080lT<L0P0000020>U06P04
03eIZ`000000jD0J0>U06PD0?EV[0P3Y@1X00`000000jD0J0>U06P040>U06P0903eIZ`3Y@1X0jD0J
0000000mFJ/0ooK^0000003om^h0?EV[00<0ooK^100mFJ/0103om^h0?EV[03eIZ`0mFJ/:0?ofkP04
0=@m6@3om^h0ooK^0?ofkP<0e3dI1@3om^h3000000030?ofkP3D?AT0ooK^00d0ooK^00<0e3dI0?of
kP3om^h0AP3om^h00`000000ooK^0?ofkP0:0?ofkP40oooo000d0?ofkP030000003om^h0ooK^01P0
ooK^00<0e3dI0?ofkP3om^h00P3om^h40=@m6@`0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`000000
ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00P0ooK^00D0e3dI00000000000000000?ofkP030=@m
6@P0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@060?ofkP<0e3dI0`3om^h2000000801PPA00P00000
00X?8`0:3b<0000000X?8`000000e3dI000000@03aHf00<0000000lF=P0000000`0I8e400`000000
6B=A01TSD@0301TSD@800000100R<Vd00`000000e3dI028bK@04028bK@8000001@0Z?X<40=@m6@03
02XnP`000000:Sj30080:Sj300@000000358U@0aB9D0e3dI1@0aB9D00`000000<DRE0358U@020358
U@030000003nB1h0oTPN00@0oTPN00@000000?i87P3nB1h0?EV[103nB1h00`000000oTPN0?i87P05
0?i87P030000003nB1h0oTPN00H0oTPN00@000000?i87P000000?EV[103iAQd00`000000nDHM0?U6
7@070?U67@030000003iAQd0nDHM00H0nDHM00<0000003eIZ`3iAQd01P3iAQd203eIZ`040?U67@00
00000000000000@0lT<L00<000000?93703b@a`0103b@a`01@0mFJ/0lT<L0?93703b@a`0000000T0
lT<L00<000000?93703b@a`0103b@a`010000000?EV[0>U06P0000070>U06PD0?EV[0`3Y@1X00`0m
FJ/0jD0J0>U06P0203eIZ`030=@m6@0mFJ/0?EV[00H0?EV[0`3om^h203eIZ``0ooK^00<0e3dI0?of
kP3om^h0103om^h20=@m6@H0ooK^0`00000=0?ofkP030=@m6@3om^h0ooK^04L0ooK^00<000000?of
kP3om^h02@3om^h10?ooo`00=03om^h00`000000ooK^0?ofkP0G0?ofkP030=@m6@3om^h0ooK^00L0
ooK^0`3D?AT90?ofkP030=@m6@3om^h0ooK^00<0ooK^00D000000?ofkP3om^h0ooK^0=@m6@0:0?of
kP030=@m6@3om^h0ooK^0080ooK^0`0000000`3om^h0e3dI0=@m6@020=@m6@@0ooK^00D0e3dI0?of
kP3om^h0ooK^0=@m6@090?ofkP<0e3dI00<01PPA0000000621400P00000200X?8`80000000<0e3dI
00lF=P000000100?5SH2000000@06B=A00<0000001TSD@0I8e400`0I8e400`0000008S9]028bK@03
028bK@030000003D?AT08S9]00@08S9]00<0000002XnP`0Z?X<0100Z?X<010000000:Sj302XnP`0Z
?X<30=@m6@0302XnP`000000<DRE0080<DRE00<0e3dI0358U@0aB9D00`0aB9D00`000000<DRE0358
U@020358U@030000003nB1h0oTPN00@0oTPN00D000000?i87P0mFJ/0oTPN03eIZ`040?i87P030000
003nB1h0oTPN00@0oTPN00<000000?i87P3nB1h01P3nB1h010000000oTPN03eIZ`3nB1h203eIZ`03
0000003iAQd0000000T0nDHM00<000000?U67@3iAQd01P3iAQd00`0mFJ/0nDHM0?U67@060?U67@03
0000003iAQd0?EV[00<0nDHM0`0000000`3b@a`000000?9370040?93700503eIZ`3b@a`0lT<L0?93
700000002@3b@a`00`000000lT<L0?9370040?937080?EV[00@0lT<L0000000000000000203Y@1X0
0`000000jD0J0>U06P0903eIZ`<0ooK^00D0?EV[0?ofkP0mFJ/0?EV[0=@m6@030?ofkP0303eIZ`3o
m^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h01P3om^h20=@m6@D0ooK^00@0e3dI0?ofkP0000000000
303om^h00`3D?AT0ooK^0?ofkP160?ofkP030000003om^h0ooK^00T0ooK^0@3oool003<0ooK^00<0
00000?ofkP3om^h0603om^h00`3D?AT0ooK^0?ofkP0:0?ofkP<0e3dI1@3om^h00`3D?AT0ooK^0?of
kP030?ofkP030000003om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?of
kP050?ofkP<000000P3om^h40=@m6@<0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`0mFJ/000000=@m
6@030=@m6@080000000:3b<0000003eIZ`000000e3dI00lF=P00000400lF=P030000000I8e406B=A
00<06B=A00<0000001TSD@0I8e400P0I8e42000000D08S9]00<0e3dI0000000R<Vd00`0R<Vd20000
00H0:Sj300<0000002XnP`0Z?X<00`0Z?X<01`000000e3dI0=@m6@3D?AT0<DRE0=@m6@0000001P0a
B9D00`000000<DRE0358U@020358U@030000003nB1h0oTPN00@0oTPN00D0?EV[0?i87P3nB1h0oTPN
03eIZ`030?i87P030000003nB1h0oTPN00@0oTPN00<000000?i87P3nB1h01P3nB1h00`000000?EV[
0?i87P030?i87P0403eIZ`0000000000000000L0nDHM00<000000?U67@3iAQd01P3iAQd00`0mFJ/0
nDHM0?U67@070?U67@030000003iAQd0nDHM0080?EV[103iAQd3000000<0lT<L00<0?EV[0?93703b
@a`00P3b@a`00`000000lT<L0?9370070?9370030000003b@a`0lT<L00<0lT<L00D0?EV[0?93703b
@a`0lT<L000000020?9370<000001@3Y@1X01@000000jD0J0>U06P3Y@1X0?EV[00@0jD0J00<00000
0?ofkP3om^h00`3D?AT203eIZ`80ooK^00@0e3dI0?ofkP0mFJ/0?EV[3P3om^h00`3D?AT0ooK^0?of
kP080?ofkP<0e3dI0P3om^h0103D?AT0ooK^0?ofkP3om^h3000000T0ooK^00<0e3dI0?ofkP3om^h0
AP3om^h00`000000ooK^0?ofkP090?ofkP40oooo000c0?ofkP030000003om^h0ooK^01P0ooK^00<0
e3dI0?ofkP3om^h03@3om^h40=@m6@030?ofkP3D?AT0ooK^00<0ooK^00<000000?ofkP3om^h00P3o
m^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^00P0ooK^0`0000020?ofkP<0e3dI00<0
ooK^0=@m6@3om^h02P3om^h01P0000001PPA0000000000002PlS000000<0e3dI00D000000=@m6@0?
5SH03aHf0000000300lF=P8000001@0I8e401@0000006B=A01TSD@0I8e40000000808S9]00<00000
028bK@0R<Vd00P0R<Vd00`3D?AT00000028bK@02028bK@040000000Z?X<0:Sj3000000D0:Sj300<0
000002XnP`0Z?X<00`0Z?X<010000000<DRE0358U@0aB9D30=@m6@H0<DRE00<000000358U@0aB9D0
0P0aB9D2000000@0oTPN00<0?EV[0000003nB1h00`3nB1h0100mFJ/0oTPN0?i87P0000060?i87P03
0000003nB1h0oTPN00H0oTPN00<0?EV[0?i87P3nB1h0103nB1h00`0mFJ/000000?i87P03000000@0
nDHM00<000000?U67@3iAQd01@3iAQd00`0mFJ/000000?U67@080?U67@030000003iAQd0nDHM0080
nDHM0P0mFJ/30?U67@050000003iAQd000000000000mFJ/01@3b@a`00`000000lT<L0?9370060?93
70030000003b@a`0lT<L00<0lT<L00<0?EV[0?93703b@a`00P3b@a`00`000000lT<L0?9370030?93
70<0000000<0jD0J0000003Y@1X00P3Y@1X00`0mFJ/0jD0J0>U06P030>U06P030000003om^h0ooK^
0080ooK^0P0mFJ/20=@m6@040?ofkP3D?AT0?EV[03eIZ`l0ooK^00<0e3dI0?ofkP3om^h02`3om^h2
0=@m6@030?ofkP3D?AT0ooK^00@0ooK^0P0000070?ofkP030=@m6@3om^h0ooK^04H0ooK^00<00000
0?ofkP3om^h02@3om^h10?ooo`00<`3om^h00`000000ooK^0?ofkP0H0?ofkP030=@m6@3om^h0ooK^
0140ooK^0`3D?AT20?ofkP030000003om^h0ooK^00<0ooK^0P3D?AT:0?ofkP030=@m6@3om^h0ooK^
00/0ooK^00<000000=@m6@0000000P3om^h30=@m6@T0ooK^00@0?EV[00000000000000000P0:3b<0
100000002PlS00X?8`0000030=@m6@0700lF=P0000003aHf00lF=P0000006B=A0000000501TSD@04
0000000I8e406B=A000000<08S9]00L00000028bK@0R<Vd08S9]0=@m6@0R<Vd0000000808S9]00D0
000002XnP`0Z?X<0:Sj30000000602XnP`040000000Z?X<0:Sj302XnP`800000100aB9D00`3D?AT0
<DRE0=@m6@020=@m6@<0<DRE00@000000358U@0aB9D0<DRE0P0000001`3oBAl00000000000000000
?EV[0?i87P0000001@3nB1h00`0mFJ/0oTPN000000060?i87P030000003nB1h0oTPN00D0oTPN00<0
?EV[0000003nB1h01P3nB1h203eIZ`<0oTPN0`0000000`3iAQd000000?U67@050?U67@0303eIZ`3i
AQd0000000P0nDHM00<000000?U67@3iAQd01@3iAQd203eIZ`060000003iAQd0nDHM0?U67@0mFJ/0
nDHM0`0000000`3b@a`000000?9370080?9370030000003b@a`0lT<L0080lT<L00<0?EV[0?93703b
@a`00P3b@a`00`000000lT<L0?9370070?9370<000000P0mFJ/60>U06P040000003om^h0ooK^0?of
kP80?EV[0`3om^h00`3D?AT0?EV[03eIZ`0@0?ofkP030=@m6@3om^h0ooK^00d0ooK^0`3D?AT60?of
kP<00000103om^h00`3D?AT0ooK^0?ofkP160?ofkP030000003om^h0ooK^00T0ooK^0@3oool003<0
ooK^00<000000?ofkP3om^h0603om^h00`3D?AT0ooK^0?ofkP0B0?ofkP050=@m6@3om^h0e3dI0=@m
6@000000103om^h00`3D?AT0ooK^0?ofkP030=@m6@H0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D
?AT0ooK^00000002000000030=@m6@3om^h0e3dI0080e3dI1@3om^h0100mFJ/0000000H84@000003
00X?8`050000000:3b<000000000003D?AT00P0?5SH30=@m6@050000000I8e406B=A01TSD@000000
1@0I8e400`0000006B=A00000003028bK@050000000R<Vd08S9]028bK@3D?AT00P0R<Vd2000000D0
:Sj300<0000002XnP`0Z?X<00`0Z?X<010000000:Sj302XnP`0000020358U@040000000aB9D0<DRE
0=@m6@80<DRE00<000000358U@0aB9D0103D?AT20358U@040000000fD:D0=U2U00000080odTO00<0
?EV[0?m97`0000000P0000050?i87P0303eIZ`000000oTPN00D0oTPN00<000000?i87P3nB1h0103n
B1h00`0mFJ/0oTPN000000070?i87P030000003nB1h0?EV[00D0oTPN0`0000050?U67@0303eIZ`3i
AQd0000000P0nDHM00<000000?U67@3iAQd01`3iAQd203eIZ`030?U67@0mFJ/0nDHM00@0nDHM0`00
00070?9370030000003b@a`0lT<L0080lT<L00<0?EV[0?93703b@a`00`3b@a`00`000000lT<L0?93
70070?9370030000003b@a`0?EV[00<000001@3Y@1X00`000000ooK^0?ofkP0203eIZ`@0ooK^0P0m
FJ/00`3om^h0e3dI0=@m6@0>0?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3D?AT00P3D
?AT60?ofkP<000000P3om^h00`3D?AT0ooK^0?ofkP160?ofkP030000003om^h0ooK^00P0ooK^0@3o
ool003<0ooK^00<000000?ofkP3om^h0603om^h00`3D?AT0ooK^0?ofkP0B0?ofkP050=@m6@3om^h0
ooK^0000003om^h00`3D?AT00`3om^h0e3dI0?ofkP040?ofkP<0e3dI0`3om^h00`3D?AT0ooK^0?of
kP0<0?ofkP030=@m6@3om^h0ooK^00<0ooK^00D0e3dI00000000000000000?ofkP040=@m6@80?EV[
0`00000300X?8`80000000<03aHf0000003D?AT00`0?5SH0100000003aHf0=@m6@3D?AT201TSD@03
0000000I8e406B=A00<06B=A0P000004028bK@050000000R<Vd08S9]028bK@3D?AT00P0R<Vd00`00
0000:Sj302XnP`0402XnP`030000000Z?X<0:Sj300<0:Sj300@0000002XnP`0Z?X<000000P0aB9D0
10000000<DRE0358U@3D?AT20358U@030000000aB9D0<DRE00@0<DRE0`3D?AT203I@Y@030000003o
BAl0?EV[00<0odTO00@000000?m97`0000000000103nB1h203eIZ`D0oTPN00<000000?i87P3nB1h0
0`3nB1h00`0mFJ/0oTPN000000070?i87P050000003nB1h0oTPN0?i87P0mFJ/01@3nB1h010000000
oTPN0000000000020?U67@0303eIZ`3iAQd0000000T0nDHM00<000000?U67@3iAQd01P3iAQd00`00
0000nDHM0?U67@0203eIZ`D0nDHM00<000000?U67@3iAQd00P0000050?9370050000003b@a`0lT<L
0?93700mFJ/01@3b@a`00`000000lT<L0?9370080?9370030000000mFJ/0lT<L00<0lT<L0`000000
103Y@1X000000?ofkP3om^h303eIZ`80ooK^0P0mFJ/00`3om^h0e3dI0?ofkP020?ofkP<0e3dI2`3o
m^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^0080ooK^0`3D?AT60?ofkP80000000<0
e3dI0?ofkP3om^h0AP3om^h00`000000ooK^0?ofkP080?ofkP40oooo000b0?ofkP030000003om^h0
ooK^01P0ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^000000050?ofkP80e3dI203om^h4
0=@m6@h0ooK^00<0e3dI0?ofkP3om^h00`3om^h0103D?AT0ooK^0?ofkP3om^h300000080ooK^0P3D
?AT3000000802PlS00D0000000X?8`0000003aHf0=@m6@0400lF=P8000000P0I8e430=@m6@D06B=A
00<00000028bK@0R<Vd0100R<Vd00`0000008S9]0=@m6@02028bK@8000001P0Z?X<00`000000:Sj3
02XnP`0402XnP`800000100aB9D00`000000e3dI0358U@030358U@030000000aB9D0<DRE00<0<DRE
00<0000003I@Y@0fD:D00P3D?AT00`000000?EV[0?m97`030?m97`040000003oBAl0odTO0?m97`<0
000000@0oTPN0000003nB1h0?EV[103nB1h00`000000oTPN0?i87P020?i87P0403eIZ`3nB1h0oTPN
000000L0oTPN00<000000?i87P3nB1h00P3nB1h203eIZ`80oTPN00<000000?i87P3nB1h00P3nB1h0
1@000000?EV[0000003iAQd0000000P0nDHM00<000000?U67@3iAQd01`3iAQd00`000000nDHM03eI
Z`020?U67@<0?EV[0P3iAQd00`000000nDHM0?U67@020?U67@<0000000<0lT<L0000003b@a`00P3b
@a`00`0mFJ/0lT<L0?9370040?9370030000003b@a`0lT<L00L0lT<L00<0000003eIZ`3b@a`01`3b
@a`2000000040?ofkP0mFJ/0?EV[03eIZ`80ooK^0P0mFJ/20?ofkP030=@m6@3om^h0ooK^00@0ooK^
0P3D?AT90?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h01@3om^h20=@m6@H0ooK^
0`0000160?ofkP030000003om^h0ooK^00P0ooK^0@3oool00380ooK^00<000000?ofkP3om^h0603o
m^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@000000ooK^00D0ooK^00<0e3dI0?ofkP3D?AT00P3D
?AT80?ofkP80e3dI303om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0
000003eIZ`0mFJ/00`00000300X?8`8000000P0?5SH00`3D?AT03aHf00lF=P0200lF=P030000000I
8e406B=A00<06B=A00D000000=@m6@3D?AT0e3dI01TSD@02000000H08S9]00D00000028bK@3D?AT0
8S9]0000000202XnP`030000000Z?X<0:Sj300@0:Sj300<0000002XnP`0Z?X<00`0Z?X<00`000000
<DRE0358U@030358U@030000003D?AT0<DRE00<0<DRE00<000000358U@0aB9D00P0aB9D2000000<0
=U2U00<0e3dI0000003oBAl01@3oBAl00`000000odTO0?m97`030?m97`<0000000<0oTPN03eIZ`3n
B1h00P3nB1h01@000000oTPN0?i87P3nB1h0?EV[00<0oTPN00<000000?i87P3nB1h01@3nB1h00`00
0000oTPN0?i87P040?i87P0303eIZ`3nB1h0000000@0oTPN00<0?EV[0?i87P3nB1h00`0000070?U6
7@030000003iAQd0nDHM00H0nDHM00<000000?U67@0mFJ/01P3iAQd303eIZ`L0nDHM0`00000203eI
Z`H0lT<L00<000000?93703b@a`0203b@a`00`0mFJ/0lT<L0?9370070?9370050000003om^h0?EV[
03eIZ`3om^h0100mFJ/30?ofkP030=@m6@3om^h0ooK^00H0ooK^0`3D?AT60?ofkP030=@m6@3om^h0
ooK^00h0ooK^00<0e3dI0?ofkP3om^h01`3om^h30=@m6@<0ooK^00<0e3dI0?ofkP3om^h00`000013
0?ofkP030000003om^h0ooK^00P0ooK^0@3oool00380ooK^00<000000?ofkP3om^h0603om^h00`3D
?AT0ooK^0?ofkP0C0?ofkP030=@m6@000000ooK^00@0ooK^00<0e3dI0?ofkP3om^h00`3om^h30=@m
6@@0ooK^00<0e3dI0?ofkP3om^h00`3D?AT90?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?of
kP3om^h01@3om^h303eIZ`030000000:3b<0000000<02PlS00D0000000lF=P0?5SH0e3dI00000003
00lF=P8000001@0I8e40100000006B=A01TSD@0I8e430=@m6@030000000R<Vd08S9]00<08S9]00@0
00000=@m6@0R<Vd000000`0Z?X<00`000000:Sj302XnP`0402XnP`030000000Z?X<0:Sj30080:Sj3
0P0000050358U@030=@m6@0aB9D0<DRE00<0<DRE00D000000358U@0aB9D0<DRE0000000203I@Y@03
0000000fD:D0=U2U0080=U2U00<000000?m97`3oBAl00`3oBAl00`000000odTO0?m97`040?m97`05
0000003oBAl000000000000mFJ/00P3nB1h010000000oTPN0?i87P0mFJ/40?i87P030000003nB1h0
oTPN00D0oTPN00<000000?i87P3nB1h01@3nB1h00`0mFJ/000000?i87P020?i87P0303eIZ`3nB1h0
oTPN0080oTPN00@000000?i87P00000000001@3iAQd00`000000nDHM0?U67@060?U67@030000000m
FJ/0nDHM00L0nDHM00<000000?U67@0mFJ/00P0mFJ/40?U67@030000003iAQd0?EV[00<000001@3b
@a`00`000000lT<L0?9370070?93700303eIZ`3b@a`0lT<L00P0lT<L00@0000003eIZ`0mFJ/0ooK^
100mFJ/40?ofkP030=@m6@3om^h0ooK^00T0ooK^0`3D?AT30?ofkP030=@m6@3om^h0ooK^00h0ooK^
00<0e3dI0?ofkP3om^h02P3om^h30=@m6@030?ofkP3D?AT0ooK^00<0ooK^0P0000120?ofkP030000
003om^h0ooK^00L0ooK^0@3oool00380ooK^00<000000?ofkP3om^h0603om^h20=@m6A<0ooK^00<0
e3dI0000003om^h0103om^h00`3D?AT0ooK^0?ofkP070?ofkP<0e3dI00<0ooK^0=@m6@3om^h0103o
m^h30=@m6@D0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP040?ofkP<0?EV[0P00
0000100:3b<0000000X?8`0:3b<2000000803aHf00L0e3dI0000000?5SH03aHf0000000I8e400000
00H06B=A00<0000001TSD@0000000`0R<Vd20=@m6@@08S9]00@000000=@m6@0R<Vd00000100Z?X<0
0`000000:Sj302XnP`0402XnP`040000000Z?X<0:Sj300000080<DRE00<000000358U@0aB9D00P0a
B9D00`3D?AT000000358U@030358U@040000000aB9D0<DRE000000<0=U2U00<0000003I@Y@0fD:D0
0P0fD:D00`000000odTO0?m97`030?m97`030000003oBAl0odTO00@0odTO00X000000?m97`3oBAl0
odTO0000000mFJ/0oTPN0000003nB1h0?EV[1@3nB1h00`000000oTPN0?i87P050?i87P030000003n
B1h0oTPN00D0oTPN00D0000003eIZ`0mFJ/0oTPN03eIZ`040?i87P030000003nB1h0oTPN0080oTPN
0`0000000`3iAQd000000?U67@080?U67@0303eIZ`3iAQd0nDHM00H0nDHM00<000000?U67@3iAQd0
0`3iAQd303eIZ`030?U67@000000?EV[00@0nDHM0`0000000`3b@a`000000?9370080?93700303eI
Z`3b@a`0lT<L00P0lT<L0P0mFJ/0103om^h0?EV[03eIZ`3om^h203eIZ`D0ooK^00<0e3dI0?ofkP3o
m^h0303om^h20=@m6@030?ofkP3D?AT0ooK^00l0ooK^00<0e3dI0?ofkP3om^h03@3om^h20=@m6@H0
ooK^0`00000o0?ofkP030000003om^h0ooK^00L0ooK^0@3oool00380ooK^00<000000?ofkP3om^h0
603om^h00`3D?AT0ooK^0=@m6@030=@m6@l0ooK^00<000000?ofkP3om^h0103om^h00`3D?AT0ooK^
0?ofkP0:0?ofkP<0e3dI1`3om^h30=@m6@80ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^
0?ofkP030?ofkP@0?EV[00h0000000X?8`0:3b<0000000X?8`0000003aHf0000000?5SH0e3dI00lF
=P0000003aHf000000<06B=A00<0000001TSD@0I8e400`0I8e42000000D08S9]00H000000=@m6@3D
?AT0e3dI028bK@3D?AT2000000D0:Sj300<0000002XnP`0Z?X<0100Z?X<010000000:Sj302XnP`00
00020358U@070000000aB9D0<DRE0358U@3D?AT0<DRE000000050358U@800000100fD:D00`000000
=U2U03I@Y@0203I@Y@030000003oBAl0odTO00<0odTO00<000000?m97`3oBAl0103oBAl00`000000
odTO0?m97`030?m97`0303eIZ`000000?EV[00H0oTPN00<000000?i87P3nB1h01@3nB1h00`000000
oTPN0?i87P050?i87P040000003nB1h0oTPN03eIZ`D0oTPN00<000000?i87P3nB1h01@3nB1h30000
00L0nDHM00<0?EV[0?U67@3iAQd01`3iAQd00`000000nDHM0?U67@060?U67@@0?EV[1P3iAQd30000
00H0lT<L0P0mFJ/00`000000lT<L0?9370070?9370@0?EV[00@0ooK^03eIZ`0mFJ/0?EV[1P3om^h0
0`3D?AT0ooK^0?ofkP0>0?ofkP<0e3dI403om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0
ooK^00L0ooK^0P00000m0?ofkP030000003om^h0ooK^00L0ooK^0@3oool00340ooK^00<000000?of
kP3om^h06@3om^h00`3D?AT0ooK^0?ofkP030?ofkP<0e3dI303om^h00`000000ooK^0?ofkP030?of
kP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3D?AT00P3D?AT70?ofkP<0e3dI1P3om^h00`3D
?AT0ooK^0?ofkP030?ofkP<0?EV[00@0ooK^0000000:3b<02PlS0P00000200lF=P040000000?5SH0
e3dI00lF=P800000100I8e400`0000006B=A01TSD@0301TSD@030000000R<Vd08S9]00@08S9]00@0
0000028bK@0R<Vd08S9]0`3D?AT602XnP`030000000Z?X<0:Sj300D0:Sj30P0000040358U@060000
000aB9D0<DRE0=@m6@0aB9D000001@0aB9D00`000000=U2U03I@Y@0303I@Y@030000000fD:D0=U2U
0080=U2U00<000000?m97`3oBAl00`3oBAl00`000000odTO0?m97`040?m97`030000003oBAl0odTO
00@0odTO00<0?EV[0?m97`0000000`0000020?i87P030000003nB1h0oTPN00D0oTPN00<000000?i8
7P3nB1h01@3nB1h010000000oTPN03eIZ`3nB1h203eIZ`<0oTPN00<000000?i87P3nB1h01P3nB1h0
10000000oTPN0000000000040?U67@0303eIZ`000000nDHM00L0nDHM00<000000?U67@3iAQd01`3i
AQd0100mFJ/0nDHM0?U67@3iAQd503eIZ`040?U67@000000nDHM0?U67@8000000`3b@a`00`0mFJ/0
lT<L000000090?9370<0?EV[0P3om^h203eIZ`L0ooK^00<0e3dI0?ofkP3om^h0403om^h00`3D?AT0
ooK^0=@m6@020=@m6@d0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP090?ofkP<0
0000>P3om^h00`000000ooK^0?ofkP070?ofkP40oooo000a0?ofkP030000003om^h0ooK^01T0ooK^
00<0e3dI0?ofkP3om^h01P3om^h40=@m6@L0ooK^00<000000=@m6@3om^h0103om^h00`3D?AT0ooK^
0?ofkP0<0?ofkP030=@m6@3om^h0ooK^0080ooK^103D?AT30?ofkP030=@m6@3om^h0ooK^00<0e3dI
0`3om^h00`3D?AT0ooK^0?ofkP020?ofkPD0?EV[00D0000000X?8`0000002PlS0000000200lF=P05
0000003D?AT03aHf00lF=P0000001@0I8e400`0000006B=A01TSD@0201TSD@8000001P0R<Vd01`00
00008S9]028bK@0R<Vd0e3dI0000000Z?X<00`3D?AT402XnP`030000000Z?X<0:Sj300@0:Sj300<0
00000358U@0aB9D00`0aB9D010000000<DRE0358U@3D?AT20358U@040000000aB9D0<DRE0358U@80
00001P0fD:D00`000000=U2U03I@Y@0203I@Y@030000003oBAl0odTO00<0odTO00<000000?m97`3o
BAl00`3oBAl00`000000odTO0?m97`030?m97`0303eIZ`000000?EV[00@0odTO100000050?i87P03
0000003nB1h0oTPN00H0oTPN00<0000003eIZ`3nB1h00`3nB1h203eIZ`030000003nB1h0oTPN00H0
oTPN00<000000?i87P3nB1h00P3nB1h200000080?EV[00<000000?U67@3iAQd01`3iAQd00`000000
nDHM0?U67@060?U67@0303eIZ`3iAQd0nDHM00L0nDHM1@0mFJ/0103iAQd000000000000mFJ/20?93
70030000003b@a`0lT<L00P0?EV[103om^h00`0mFJ/0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^
0100ooK^00<0e3dI0?ofkP3om^h00P3om^h30=@m6@X0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D
?AT0ooK^0?ofkP0<0?ofkP<00000>03om^h00`000000ooK^0?ofkP060?ofkP40oooo000a0?ofkP03
0000003om^h0ooK^01T0ooK^00<0e3dI0?ofkP3om^h02P3om^h30=@m6@<0ooK^00<000000?ofkP3D
?AT0103om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00H0ooK^103D?AT50?ofkP@0
e3dI0`3om^h01P0mFJ/0ooK^03eIZ`0mFJ/0ooK^000000802PlS0P00000300lF=P030000003D?AT0
3aHf008000001@0I8e401@0000006B=A01TSD@0I8e40000000808S9]00<00000028bK@0R<Vd0100R
<Vd0100000008S9]028bK@3D?AT202XnP`030000000Z?X<0:Sj300<0e3dI00<0:Sj30000000Z?X<0
100Z?X<2000000D0<DRE00<000000358U@3D?AT00`0aB9D010000000<DRE0358U@00000203I@Y@03
0000000fD:D0=U2U00<0=U2U00<0000003I@Y@0fD:D00P0fD:D00`000000odTO0?m97`030?m97`03
0000003oBAl0odTO00<0odTO00<000000?m97`3oBAl00P3oBAl0100mFJ/0odTO0000003oBAl203eI
Z`@0odTO00@000000?m97`00000000000`3nB1h00`000000oTPN0?i87P050?i87P030000000mFJ/0
oTPN00H0oTPN0P0mFJ/70?i87P030000003nB1h0oTPN00<0oTPN00<0?EV[0?i87P0000000P000007
0?U67@030000003iAQd0nDHM00H0nDHM00<0?EV[0000003iAQd0203iAQd00`000000nDHM0?U67@02
0?U67@T0?EV[1@3b@a`203eIZ`80e3dI0P3om^h00`0mFJ/0ooK^0?ofkP070?ofkP030=@m6@3om^h0
ooK^0100ooK^00<0e3dI0?ofkP3om^h01@3om^h30=@m6@L0ooK^00<0e3dI0?ofkP3om^h03@3om^h0
0`3D?AT0ooK^0?ofkP0?0?ofkP800000=P3om^h00`000000ooK^0?ofkP060?ofkP40oooo000a0?of
kP030000003om^h0ooK^01T0ooK^00<0e3dI0?ofkP3om^h03@3om^h20=@m6@040000003D?AT0ooK^
0=@m6@@0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP080?ofkP@0e3dI1@3om^h0
0`3D?AT0ooK^0=@m6@020=@m6@060?ofkP0mFJ/0?EV[03eIZ`3om^h000000P0:3b<00`000000?EV[
00lF=P0200lF=P060=@m6@0?5SH03aHf0000000I8e400000100I8e40100000006B=A01TSD@000003
028bK@030000000R<Vd08S9]00@08S9]00@00000028bK@3D?AT000000`0Z?X<00`000000:Sj302Xn
P`0202XnP`<0e3dI0`0Z?X<010000000<DRE0358U@0000050358U@030000003D?AT0<DRE00<0<DRE
0P00000303I@Y@030000000fD:D0=U2U00<0=U2U00<0000003I@Y@0fD:D00P0fD:D00`000000odTO
0?m97`030?m97`030000003oBAl0odTO00<0odTO00D000000?m97`3oBAl0odTO03eIZ`020?m97`05
0000003oBAl0odTO0?m97`0mFJ/00`3oBAl010000000odTO0?m97`3oBAl2000000030?i87P000000
oTPN00H0oTPN00<0?EV[0?i87P3nB1h01P3nB1h010000000oTPN03eIZ`0mFJ/40?i87P030000003n
B1h0oTPN00<0oTPN00@0?EV[0?i87P3nB1h000000P3nB1h2000000D0nDHM00<000000?U67@3iAQd0
1@3iAQd00`0mFJ/000000?U67@080?U67@030000003iAQd0nDHM00@0nDHM00@0?EV[0?U67@3iAQd0
00000P3iAQd3000000<0lT<L00<0?EV[0?93700000000P3om^h203eIZ`030=@m6@3om^h0ooK^00L0
ooK^00<0e3dI0?ofkP3om^h0403om^h00`3D?AT0ooK^0?ofkP080?ofkP<0e3dI103om^h00`3D?AT0
ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^0140ooK^0`00000c0?ofkP030000003om^h0ooK^00H0
ooK^0@3oool00340ooK^00<000000?ofkP3om^h06@3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030000
003om^h0e3dI0080e3dI0P3om^h20=@m6@l0ooK^00<0e3dI0?ofkP3om^h0203om^h0103D?AT0ooK^
0?ofkP3om^h40=@m6@040?ofkP3D?AT0ooK^0?ofkP80?EV[0`3D?AT0103om^h0?EV[0000000:3b<2
000000@03aHf00<0e3dI00lF=P0000000P0I8e400`0000006B=A01TSD@0301TSD@030000000I8e40
000000@08S9]00<00000028bK@0R<Vd0100R<Vd00`000000e3dI02XnP`0302XnP`030000000Z?X<0
:Sj300@0:Sj300<000000=@m6@3D?AT00P3D?AT20358U@030000000aB9D0<DRE00<0<DRE00<0e3dI
0358U@0aB9D00`0aB9D00`000000=U2U03I@Y@0303I@Y@030000000fD:D0=U2U0080=U2U00<00000
03I@Y@0fD:D00P0fD:D00`000000odTO0?m97`030?m97`030000003oBAl0odTO00@0odTO00<00000
0?m97`0mFJ/00`3oBAl00`000000odTO0?m97`020?m97`0403eIZ`3oBAl0odTO000000D0odTO0`00
00050?i87P0303eIZ`000000oTPN00L0oTPN00@000000?i87P3nB1h0oTPN0P0mFJ/20?i87P030000
003nB1h0oTPN0080oTPN00D0?EV[0?i87P3nB1h0oTPN000000040?i87P<0000000<0nDHM0000003i
AQd01P3iAQd00`0mFJ/0nDHM000000090?U67@030000003iAQd0nDHM00<0nDHM00D0?EV[0?U67@3i
AQd0nDHM000000050?U67@030000000mFJ/0?EV[0080lT<L00@000000?ofkP0mFJ/0?EV[0P3om^h2
0=@m6@L0ooK^00<0e3dI0?ofkP3om^h0403om^h00`3D?AT0ooK^0?ofkP0;0?ofkP<0e3dI00<0ooK^
0=@m6@3om^h03P3om^h00`3D?AT0ooK^0?ofkP0D0?ofkP<00000<03om^h00`000000ooK^0?ofkP06
0?ofkP40oooo000a0?ofkP030000003om^h0ooK^01T0ooK^00<0e3dI0?ofkP3om^h03P3om^h01P00
0000ooK^0?ofkP3om^h0e3dI0?ofkP<0e3dI00@0ooK^0=@m6@3D?AT0e3dI303om^h00`3D?AT0ooK^
0?ofkP070?ofkP030=@m6@3om^h0ooK^00H0ooK^0`3D?AT0103om^h0?EV[03eIZ`3om^h203eIZ`@0
e3dI00<03aHf0000000?5SH00P0?5SH00`3D?AT000000000000301TSD@030000000I8e406B=A00<0
6B=A0P000005028bK@030000000R<Vd08S9]00@08S9]00<0e3dI02XnP`0Z?X<0100Z?X<00`000000
:Sj302XnP`0402XnP`8000000P0aB9D30=@m6@030000000aB9D0<DRE0080<DRE00<0e3dI0000000a
B9D00P0aB9D2000000D0=U2U00<0000003I@Y@0fD:D00`0fD:D00`000000=U2U03I@Y@0203I@Y@03
0000003oBAl0odTO0080odTO00<000000?m97`3oBAl0103oBAl00`000000?EV[0?m97`030?m97`03
0000003oBAl0odTO00<0odTO00<0?EV[0000003oBAl01P3oBAl00`000000odTO0000000200000080
?EV[00<000000?i87P3nB1h01P3nB1h00`000000oTPN0?i87P040?i87P80?EV[103nB1h01@0mFJ/0
oTPN0?i87P3nB1h0000000P0oTPN0`0000050?U67@0303eIZ`3iAQd0000000T0nDHM00<000000?U6
7@3iAQd00P3iAQd203eIZ`<0nDHM00<000000?U67@3iAQd0103iAQd00`0mFJ/0nDHM0?U67@020000
00030?ofkP0mFJ/0?EV[00D0ooK^0`3D?AT40?ofkP030=@m6@3om^h0ooK^0100ooK^00<0e3dI0?of
kP3om^h03P3om^h30=@m6@l0ooK^00<0e3dI0?ofkP3om^h05P3om^h2000002h0ooK^00<000000?of
kP3om^h01P3om^h10?ooo`00<03om^h00`000000ooK^0?ofkP0J0?ofkP030=@m6@3om^h0ooK^00d0
ooK^00<000000?ofkP3om^h00P3om^h01@3D?AT0ooK^0?ofkP3D?AT0ooK^00<0e3dI00@0ooK^0=@m
6@3D?AT0e3dI2@3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI
0?ofkP3D?AT00P3D?AT01`0mFJ/0ooK^03eIZ`0mFJ/0000000X?8`0000000`3D?AT200lF=P030=@m
6@000000000000<06B=A00<0000001TSD@0I8e400`0I8e400`0000008S9]028bK@04028bK@030000
000R<Vd08S9]00<08S9]00<000000=@m6@0000001@0Z?X<00`000000:Sj302XnP`0402XnP`030000
000aB9D0<DRE00@0<DRE0`3D?AT0100aB9D0e3dI0358U@0000020358U@040000000fD:D0=U2U0000
00D0=U2U00<0000003I@Y@0fD:D00P0fD:D00`000000=U2U03I@Y@0203I@Y@800000103oBAl00`00
0000odTO0?m97`030?m97`0303eIZ`3oBAl0odTO00<0odTO00<000000?m97`3oBAl0103oBAl203eI
Z`D0odTO00<000000?m97`3oBAl00P3oBAl00`0mFJ/0odTO00000002000000L0oTPN00<000000?i8
7P3nB1h01@3nB1h01@000000?EV[03eIZ`3nB1h0?EV[00@0oTPN00<000000?i87P3nB1h01P3nB1h0
0`000000oTPN0?i87P0300000080?EV[0P3iAQd00`000000nDHM0?U67@070?U67@050000003iAQd0
nDHM0?U67@0mFJ/0103iAQd00`000000nDHM0?U67@040?U67@0603eIZ`3iAQd0nDHM0?U67@000000
ooK^0P0mFJ/90?ofkP<0e3dI00<0ooK^0=@m6@3om^h04@3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP03
0=@m6@3om^h0e3dI0080e3dI303om^h00`3D?AT0ooK^0?ofkP0H0?ofkP<00000;03om^h00`000000
ooK^0?ofkP050?ofkP40oooo000`0?ofkP030000003om^h0ooK^01X0ooK^00<0e3dI0?ofkP3om^h0
3@3om^h00`000000ooK^0?ofkP020?ofkP030=@m6@3om^h0e3dI00D0ooK^0`3D?AT0103om^h0e3dI
0=@m6@3D?AT60?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0
?EV[03eIZ`0203eIZ`<0e3dI00<0?EV[0000000000000P0?5SH00`0000003aHf0=@m6@020=@m6@03
0000000I8e406B=A00<06B=A00L0000001TSD@0I8e406B=A0000000R<Vd0000000H08S9]00P00000
028bK@0R<Vd08S9]0000003D?AT0:Sj3000000H0:Sj300<0000002XnP`0Z?X<00P0Z?X<00`000000
<DRE000000060358U@030000000aB9D0e3dI0080e3dI00<0<DRE0000000000000`0fD:D00`000000
=U2U03I@Y@0303I@Y@030000000fD:D0=U2U0080=U2U00@0000003I@Y@0fD:D0=U2U0P0000001P3o
Bal00000000000000000odTO000000D0odTO00<0?EV[0?m97`3oBAl00`3oBAl00`000000odTO0?m9
7`040?m97`030000003oBAl0?EV[00@0odTO00D000000?m97`3oBAl0odTO03eIZ`030?m97`040000
003oBAl00000000000D0oTPN00<000000?i87P3nB1h01@3nB1h00`000000oTPN0?i87P0203eIZ`<0
oTPN00<000000?i87P3nB1h01`3nB1h00`000000oTPN0?i87P020?i87P0303eIZ`3nB1h0000000<0
0000203iAQd01@000000nDHM0?U67@3iAQd0?EV[00D0nDHM00<000000?U67@3iAQd00`3iAQd01`0m
FJ/0nDHM0?U67@3iAQd000000?ofkP0mFJ/03P3om^h30=@m6A00ooK^00<0e3dI0?ofkP3om^h0403o
m^h00`3D?AT0ooK^0?ofkP020?ofkP<0e3dI2@3om^h00`3D?AT0ooK^0?ofkP0K0?ofkP800000:P3o
m^h00`000000ooK^0?ofkP050?ofkP40oooo000`0?ofkP030000003om^h0ooK^01X0ooK^0P3D?AT=
0?ofkP030000003om^h0ooK^00<0ooK^0P3D?AT90?ofkP<0e3dI00<0ooK^0=@m6@3D?AT0103om^h0
0`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00T0ooK^00@0e3dI03eIZ`0mFJ/0?EV[0P3o
m^h203eIZ`030=@m6@0000003aHf00803aHf00D0000000lF=P3D?AT03aHf000000030=@m6@<06B=A
00@0000001TSD@0I8e4000000P0R<Vd00`0000008S9]028bK@04028bK@060000000R<Vd08S9]0000
000Z?X<0e3dI0P0Z?X<00`000000:Sj302XnP`0302XnP`050000000Z?X<0:Sj302XnP`0000000P0a
B9D00`000000<DRE0358U@040358U@030000000aB9D0e3dI0080<DRE0`3D?AT403I@Y@030000000f
D:D0=U2U00<0=U2U00D0000003I@Y@0fD:D0=U2U0000000203I@Y@040000000kF;80>eRb000000<0
od/O0`0000030?m97`0303eIZ`000000odTO00@0odTO00<000000?m97`3oBAl0103oBAl010000000
odTO0?m97`0mFJ/30?m97`040000003oBAl0odTO03eIZ`<0odTO00<000000?m97`3oBAl00P3oBAl3
000000030?i87P000000oTPN00H0oTPN00@000000?i87P3nB1h0?EV[0P3nB1h303eIZ`030000003n
B1h0oTPN00H0oTPN00<000000?i87P3nB1h00P3nB1h01@0mFJ/0oTPN0?i87P3nB1h000000080oTPN
0P0000050?U67@050000003iAQd0nDHM0?U67@0mFJ/01@3iAQd00`000000nDHM0?U67@030?U67@03
03eIZ`3iAQd0nDHM0080nDHM00<0000003eIZ`3om^h03`3om^h0103D?AT0ooK^0=@m6@3D?AT>0?of
kP030=@m6@3om^h0ooK^0100ooK^00<0e3dI0?ofkP3om^h01@3om^h20=@m6@L0ooK^00<0e3dI0?of
kP3om^h07@3om^h3000002L0ooK^00<000000?ofkP3om^h01@3om^h10?ooo`00<03om^h00`000000
ooK^0?ofkP0J0?ofkP030=@m6@3om^h0e3dI00<0e3dI203om^h00`000000ooK^0?ofkP040?ofkP03
0=@m6@3om^h0ooK^00/0ooK^1P3D?AT00`3om^h0e3dI0?ofkP060?ofkP030=@m6@3om^h0ooK^00P0
ooK^00D0?EV[0=@m6@0mFJ/0?EV[0?ofkP0303eIZ`80ooK^00P0000000lF=P0?5SH03aHf0000000?
5SH0e3dI000000806B=A00<0000001TSD@3D?AT00`3D?AT201TSD@050000000R<Vd08S9]028bK@00
00001P0R<Vd20000000302XnP`3D?AT0:Sj30080:Sj300<0000002XnP`0Z?X<0100Z?X<010000000
:Sj302XnP`0000030358U@030000000aB9D0<DRE00@0<DRE00L000000=@m6@0aB9D0<DRE0000000f
D:D0000000<0e3dI00<0=U2U0000000fD:D0100fD:D00`000000=U2U03I@Y@0203I@Y@8000000`0k
F;800`000000?EV[0?m;7`020?m;7`070000003oBal000000000000mFJ/0odTO000000050?m97`03
0000003oBAl0odTO00@0odTO00@000000?m97`3oBAl0odTO0P0mFJ/0103oBAl000000?m97`0mFJ/4
0?m97`030000003oBAl0odTO00D0odTO0`0000060?i87P030000003nB1h0?EV[00D0oTPN00@00000
03eIZ`0mFJ/0?EV[1@3nB1h00`000000oTPN0?i87P020?i87P0303eIZ`3nB1h0oTPN0080oTPN00<0
00000?i87P3nB1h00P3nB1h300000080nDHM00@000000?U67@3iAQd0?EV[1P3iAQd00`000000nDHM
0?U67@020?U67@0303eIZ`3iAQd0nDHM0080nDHM0P0mFJ/@0?ofkP030=@m6@3om^h0ooK^0080ooK^
0`3D?AT;0?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h0203om^h30=@m6@@0ooK^
00<0e3dI0?ofkP3om^h0803om^h3000002@0ooK^00<000000?ofkP3om^h01@3om^h10?ooo`00<03o
m^h00`000000ooK^0?ofkP0J0?ofkP030=@m6@3om^h0ooK^00<0ooK^0`3D?AT40?ofkP030000003o
m^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h03P3om^h60=@m6@D0ooK^00<0e3dI0?ofkP3om^h02@3o
m^h00`0mFJ/0e3dI03eIZ`0203eIZ`80ooK^00@0?EV[0?ofkP0mFJ/000000`0?5SH00`000000e3dI
0000000301TSD@030000000I8e406B=A00<06B=A0`3D?AT3028bK@030000000R<Vd08S9]00@08S9]
00@0000002XnP`0Z?X<0e3dI100Z?X<00`000000:Sj302XnP`0302XnP`030000000mFJ/0000000D0
<DRE00<000000358U@0aB9D00`0aB9D01`3D?AT0<DRE0358U@0aB9D0000003I@Y@0000000`0fD:D3
0=@m6@D0=U2U00D0000003I@Y@0fD:D0=U2U0000000203]H/P050=@m6@0kF;8000000?m;7`0mFJ/0
0P3oBal01@000000od/O0?m;7`0mFJ/0od/O00<00000103oBAl00`000000odTO0?m97`040?m97`03
0000003oBAl0odTO00<0odTO00<0?EV[0?m97`0mFJ/01@3oBAl00`000000odTO0?m97`060?m97`03
0000003oBAl0000000<0000000@0oTPN0000003nB1h0?EV[1P3nB1h010000000oTPN0?i87P3nB1h3
03eIZ`80oTPN00D000000?i87P3nB1h0oTPN03eIZ`040?i87P030000003nB1h0oTPN00H0oTPN0`00
00000`3iAQd0?EV[0?U67@050?U67@040000003iAQd0nDHM0?U67@80?EV[0P3iAQd403eIZa40ooK^
00<0e3dI0?ofkP3om^h01@3om^h20=@m6@T0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^
0?ofkP0;0?ofkP<0e3dI00<0ooK^0=@m6@3om^h0903om^h2000002<0ooK^00<000000?ofkP3om^h0
103om^h10?ooo`00;`3om^h00`000000ooK^0?ofkP0K0?ofkP030=@m6@3om^h0ooK^00H0ooK^103D
?AT00`000000ooK^0?ofkP040?ofkP80e3dI4`3om^h60=@m6@80ooK^00<0e3dI0?ofkP3om^h0203o
m^h00`0mFJ/0e3dI03eIZ`0203eIZ`<0ooK^0P0mFJ/00`3om^h0000000lF=P0200lF=P030000003D
?AT06B=A00<06B=A00<0000001TSD@0I8e400`0I8e400`0000008S9]028bK@030=@m6@03028bK@00
00008S9]00<08S9]00@0000002XnP`000000e3dI1P0Z?X<00`000000:Sj302XnP`0302XnP`030000
000aB9D0<DRE00@0<DRE00<000000358U@0aB9D00`0aB9D0103D?AT000000358U@00000303I@Y@03
0000000fD:D0=U2U0080=U2U00@000000=@m6@3D?AT0e3dI0P0fD:D00`000000=U2U03I@Y@020000
000503]H/P3D?AT0>eRb03]H/P0000000P3oBal01@0mFJ/0od/O0?m;7`000000?EV[00<0od/O00<0
00000?m;7`0000000P0000000`3oBAl000000?m97`040?m97`030000003oBAl0odTO00@0odTO00<0
000003eIZ`3oBAl01@3oBAl00`000000odTO0?m97`050?m97`030000003oBAl0odTO00@0odTO0P00
00000`0mFJ/0oTPN0?i87P040?i87P030000003nB1h0oTPN00<0oTPN00<0e3dI0?i87P0mFJ/00P0m
FJ/20?i87P0303eIZ`3nB1h0oTPN0080oTPN00<000000?i87P3nB1h01`3nB1h01@000000oTPN03eI
Z`0mFJ/0000000D0nDHM00D000000?U67@3iAQd0nDHM03eIZ`020?U67@D0?EV[4P3om^h00`3D?AT0
ooK^0?ofkP070?ofkP<0e3dI1P3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00h0
ooK^0P3D?ATW0?ofkP<00000803om^h00`000000ooK^0?ofkP040?ofkP40oooo000_0?ofkP030000
003om^h0ooK^01`0ooK^00<0e3dI0?ofkP3om^h0203om^h010000000e3dI0=@m6@3D?AT30?ofkP03
0=@m6@3om^h0e3dI01@0ooK^00<0e3dI0?ofkP3D?AT01@3D?AT90?ofkP0403eIZ`3om^h0e3dI03eI
Z`@0ooK^0P0mFJ/20?ofkP050000000?5SH03aHf00lF=P3D?AT01P0I8e401`0000006B=A01TSD@0I
8e400000028bK@000000100R<Vd40=@m6@06028bK@000000:Sj302XnP`000000e3dI1P0Z?X<00`00
0000:Sj302XnP`0202XnP`030000000aB9D0000000H0<DRE00T000000358U@0aB9D0<DRE0=@m6@0a
B9D000000358U@0000000`0fD:D00`000000=U2U03I@Y@0303I@Y@030000000fD:D0=U2U00<0e3dI
0P00000203]H/P030000003D?AT0>eRb0080>eRb00H000000?m;7`3oBal0?EV[0?m;7`0mFJ/40?m;
7`030000003oBal0od/O0080od/O0`0000040?m97`030000003oBAl0odTO00@0odTO00@0?EV[0?m9
7`0mFJ/0?EV[0`3oBAl00`000000odTO0?m97`060?m97`030000003oBAl0odTO00@0odTO00<00000
03eIZ`3oBAl0100000020?i87P030000003nB1h0oTPN00<0oTPN00D0e3dI0?i87P3nB1h000000?i8
7P0503eIZ`030?i87P000000oTPN00P0oTPN00<000000?i87P0mFJ/00`3nB1h300000080nDHM00<0
00000?U67@3iAQd0100mFJ/0103iAQd0?EV[03eIZ`3D?ATC0?ofkP030=@m6@3om^h0ooK^00X0ooK^
0`3D?AT30?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^
0?ofkP0X0?ofkP<000007@3om^h00`000000ooK^0?ofkP040?ofkP40oooo000_0?ofkP030000003o
m^h0ooK^01`0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`000000ooK^0?ofkP020?ofkP@0e3dI00<0
ooK^0=@m6@3om^h04`3om^h00`3D?AT0ooK^0?ofkP020?ofkPH0e3dI1@3om^h01@0mFJ/0ooK^03eI
Z`3D?AT0?EV[00@0ooK^00D0?EV[0?ofkP3om^h0ooK^0000000200lF=P030=@m6@0000006B=A00D0
6B=A00@0000001TSD@0I8e4000000P0R<Vd00`0000008S9]028bK@04028bK@030000000R<Vd0e3dI
0080e3dI00<0:Sj30=@m6@0000001`0Z?X<010000000:Sj302XnP`0000020358U@030000000aB9D0
<DRE00@0<DRE00D000000358U@0aB9D0<DRE0=@m6@020358U@030000000fD:D0=U2U00<0=U2U00<0
000003I@Y@0fD:D00P0fD:D00`000000=U2U03I@Y@0303I@Y@<0e3dI00<0>eRb0=@m6@0kF;800`0k
F;801P000000od/O0?m;7`3oBal0?EV[000000@0od/O00<000000?m;7`3oBal00`3oBal00`000000
od/O00000002000000030?m97`000000odTO00@0odTO00<0?EV[0000003oBAl00P3oBAl203eIZ`03
0?m97`000000odTO00H0odTO00<000000?m97`3oBAl0103oBAl203eIZ`H0odTO0`0000070?i87P04
0000003nB1h0oTPN03eIZ`@0oTPN200mFJ/30?i87P030000000mFJ/0oTPN00@0oTPN200mFJ/40?U6
7@0303eIZ`3D?AT0ooK^0180ooK^00<0e3dI0?ofkP3om^h03P3om^h20=@m6@030?ofkP3D?AT0ooK^
0100ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP0[0?ofkP8000006`3om^h00`00
0000ooK^0?ofkP040?ofkP40oooo000_0?ofkP030000003om^h0ooK^01`0ooK^00<0e3dI0?ofkP3o
m^h01`3om^h00`000000ooK^0?ofkP040?ofkPD0e3dI4`3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI
00<0ooK^1`3D?AT403eIZ`030=@m6@3om^h0ooK^0080ooK^0P0mFJ/30?ofkP060000000?5SH03aHf
0=@m6@0I8e4000001@0I8e40100000006B=A01TSD@000003028bK@030000000R<Vd08S9]00<08S9]
00<00000028bK@0000000P0Z?X<30=@m6@030000000Z?X<0:Sj300@0:Sj300<0000002XnP`000000
100aB9D00`000000<DRE0358U@040358U@030000000aB9D0e3dI0080<DRE00<0000003I@Y@000000
100fD:D00`000000=U2U03I@Y@0303I@Y@040000000fD:D0=U2U03I@Y@8000000P0kF;830=@m6@<0
>eRb00D000000?m;7`0mFJ/0?EV[0?m;7`0203eIZ`<0od/O00<000000?m;7`3oBal00`3oBal00`00
0000od/O0?m;7`020?m;7`<000000`3oBAl00`0mFJ/000000?m97`050?m97`80?EV[1`3oBAl00`00
0000odTO0?m97`030?m97`0303eIZ`000000odTO00H0odTO00<000000?m97`3oBAl00P0000040?i8
7P040000003nB1h0oTPN03eIZ`D0oTPN00<000000?i87P3nB1h01@3nB1h:03eIZ`80oTPN00D00000
0?i87P3nB1h0?EV[000000040?U67@0303eIZ`000000e3dI01<0ooK^00<0e3dI0?ofkP3om^h0403o
m^h30=@m6A00ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP0]0?ofkP<00000603o
m^h00`000000ooK^0?ofkP040?ofkP40oooo000_0?ofkP030000003om^h0ooK^01`0ooK^0P3D?AT7
0?ofkP030000003om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h01P3D?AT@0?ofkP050=@m6@3om^h0
ooK^0?ofkP3D?AT01`3om^h60=@m6@0303eIZ`3D?AT0ooK^00<0ooK^0P0mFJ/30?ofkP030000000?
5SH0e3dI00806B=A00<0000001TSD@0I8e40100I8e42000000@08S9]00<00000028bK@0R<Vd0100R
<Vd01@000000:Sj302XnP`0Z?X<0e3dI0080:Sj30`3D?AT502XnP`030000000aB9D0<DRE00@0<DRE
00<000000358U@0aB9D0100aB9D0103D?AT0<DRE0358U@00000203I@Y@030000000fD:D0=U2U00<0
=U2U00<0000003I@Y@0fD:D00P0fD:D010000000=U2U03I@Y@00000203]H/P050000000kF;80e3dI
03]H/P000000103D?AT01`0mFJ/0od/O0?m;7`3oBal000000?m;7`0mFJ/00P3oBal00`000000od/O
0?m;7`030?m;7`030000003oBal0od/O00<0od/O00L000000?m;7`000000000003eIZ`3oBAl00000
00L0odTO00<0000003eIZ`0mFJ/0103oBAl00`000000odTO0?m97`030?m97`0303eIZ`000000odTO
00L0odTO00<000000?m97`3oBAl00P3oBAl200000080oTPN00<000000?i87P0mFJ/01@3nB1h00`00
0000oTPN0?i87P070?i87P030000000mFJ/0oTPN00L0oTPN00@000000?i87P3nB1h0?EV[0P3nB1h2
00000080?EV[00<000000=@m6@3D?AT04`3om^h00`3D?AT0ooK^0?ofkP0A0?ofkP030=@m6@3om^h0
e3dI0080e3dI3@3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^0340ooK^0`00000F
0?ofkP030000003om^h0ooK^00<0ooK^0@3oool002h0ooK^00<000000?ofkP3om^h07@3om^h00`3D
?AT0ooK^0=@m6@020=@m6@<0ooK^00<000000?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP020?of
kP030=@m6@3om^h0e3dI00D0e3dI3@3om^h0103D?AT0ooK^0?ofkP3D?AT:0?ofkP0303eIZ`3D?AT0
e3dI00@0e3dI0P3om^h00`0mFJ/0ooK^03eIZ`030?ofkP80000000@0e3dI01TSD@0I8e4000001P0I
8e400`0000008S9]028bK@04028bK@030000000R<Vd08S9]00808S9]00<0000002XnP`0000000P0Z
?X<01P3D?AT0:Sj302XnP`0Z?X<0000002XnP`<0e3dI00@0:Sj30000000mFJ/000001@0aB9D00`00
0000<DRE0358U@040358U@030=@m6@0aB9D0000000@0=U2U00<0000003I@Y@0fD:D00`0fD:D00`00
0000=U2U03I@Y@0203I@Y@8000000`0kF;801@000000>eRb0=@m6@0kF;80000000@0>eRb00<00000
0?m;7`3oBal00P3oBal01@000000od/O03eIZ`3oBal0000000D0od/O00<000000?m;7`3oBal00`3o
Bal01@000000od/O0?m;7`0mFJ/0od/O00<000001@3oBAl010000000odTO0?m97`3oBAl203eIZ`80
odTO00<000000?m97`3oBAl00P3oBAl00`0mFJ/0odTO000000070?m97`030000003oBAl0odTO00D0
odTO0`0000000`0mFJ/0oTPN0?i87P030?i87P030000003nB1h0oTPN00L0oTPN00<0000003eIZ`3n
B1h01`3nB1h010000000oTPN03eIZ`0mFJ/40?i87P0303eIZ`000000000000@0e3dI4P3om^h00`3D
?AT0ooK^0?ofkP0@0?ofkP030=@m6@3om^h0ooK^00<0ooK^0`3D?AT:0?ofkP030=@m6@3om^h0ooK^
00h0ooK^00<0e3dI0?ofkP3om^h0=03om^h2000001@0ooK^00<000000?ofkP3om^h00`3om^h10?oo
o`00;P3om^h00`000000ooK^0?ofkP0N0?ofkP040=@m6@3om^h0ooK^0?ofkP80e3dI00<000000?of
kP3om^h00`3om^h20=@m6@H0ooK^00<0e3dI0?ofkP3om^h00P3om^h50=@m6@X0ooK^00<0e3dI0?of
kP3D?AT02P3om^h203eIZ`030?ofkP0mFJ/0ooK^00L0e3dI00H0?EV[0?ofkP3om^h0ooK^0000003D
?AT401TSD@030000000I8e406B=A00806B=A0P000006028bK@050000000R<Vd08S9]028bK@000000
0P0Z?X<00`000000:Sj30=@m6@0502XnP`040000000Z?X<0:Sj302XnP`<0e3dI00<000000358U@0a
B9D0100aB9D00`000000<DRE0358U@020358U@030=@m6@0aB9D0000000H0=U2U00<0000003I@Y@0f
D:D00P0fD:D00`000000=U2U03I@Y@0203I@Y@030000000kF;80>eRb00<0>eRb00@0e3dI03]H/P0k
F;800000100kF;800`000000od/O0?m;7`020?m;7`030000003oBal0od/O0080?EV[1@3oBal00`00
0000od/O0?m;7`030?m;7`030000003oBal0?EV[00<0od/O00<000000?m;7`0000000`0000000`3o
BAl000000?m97`040?m97`80?EV[00L000000?m97`3oBAl0odTO03eIZ`3oBAl0000000L0odTO00<0
00000?m97`3oBAl01P3oBAl00`000000odTO03eIZ`0400000080oTPN00<000000?i87P3nB1h01P3n
B1h203eIZ`P0oTPN00<000000?i87P0mFJ/01@3nB1h0200mFJ/0oTPN0000003om^h0e3dI0?ofkP3D
?AT0ooK^0P3D?AT?0?ofkP030=@m6@3om^h0ooK^0140ooK^00<0e3dI0?ofkP3om^h01P3om^h20=@m
6@L0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP0f0?ofkP<000004@3om^h00`00
0000ooK^0?ofkP030?ofkP40oooo000^0?ofkP030000003om^h0ooK^01h0ooK^00<0e3dI0?ofkP3o
m^h00`3om^h01P000000e3dI0=@m6@3D?AT0ooK^0=@m6@P0ooK^00<0e3dI0?ofkP3om^h01@3om^h5
0=@m6@L0ooK^0P3D?AT:0?ofkP@0?EV[0P3om^h00`0mFJ/0e3dI0?ofkP070=@m6@030?ofkP000000
e3dI00@06B=A00D0000001TSD@0I8e406B=A00000002028bK@030000000R<Vd08S9]00@08S9]00@0
0000028bK@0R<Vd000000`0Z?X<00`3D?AT0:Sj302XnP`0502XnP`040000000Z?X<0:Sj300000080
<DRE0`3D?AT50358U@080000000aB9D0<DRE0358U@3D?AT0000003I@Y@00000503I@Y@030000000f
D:D0=U2U00<0=U2U00H0000003I@Y@0fD:D0000003]H/P00000403]H/P050=@m6@0kF;80>eRb03]H
/P0000000`0kF;800`000000od/O0?m;7`020?m;7`030000003oBal0od/O0080od/O00<0?EV[0?m;
7`3oBal00P3oBal00`000000od/O0?m;7`030?m;7`030000000mFJ/0od/O00<0od/O00<000000?m;
7`3oBal00`3oBal2000000H0odTO00D0000003eIZ`0mFJ/0odTO03eIZ`020?m97`030000003oBAl0
odTO00@0odTO00<000000?m97`3oBAl01P3oBAl00`000000?EV[03eIZ`050?m97`<000001`3nB1h0
0`0mFJ/0oTPN0?i87P070?i87P030000003nB1h0?EV[00@0oTPN0P0mFJ/200000080ooK^0P3D?AT4
0?ofkP<0e3dI303om^h00`3D?AT0ooK^0?ofkP0A0?ofkP030=@m6@3om^h0ooK^00P0ooK^0`3D?AT4
0?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h0>@3om^h2000000l0ooK^00<00000
0?ofkP3om^h00`3om^h10?ooo`00;P3om^h00`000000ooK^0?ofkP0O0?ofkP050=@m6@3om^h0ooK^
0?ofkP0000000`3om^h50=@m6@H0ooK^00<0e3dI0?ofkP3om^h0203om^h50=@m6@@0ooK^0P3D?AT9
0?ofkP@0?EV[0`3om^h0100mFJ/0e3dI0?ofkP0mFJ/30?ofkPH0e3dI100I8e40100000006B=A01TS
D@000003028bK@030000000R<Vd08S9]00@08S9]00<00000028bK@000000100Z?X<00`3D?AT00000
02XnP`0502XnP`030000000Z?X<0000000D0<DRE00@000000=@m6@3D?AT0e3dI0`0aB9D010000000
<DRE0=@m6@00000303I@Y@030000000fD:D0=U2U00<0=U2U00<0000003I@Y@0fD:D00P0fD:D00`00
0000=U2U0000000203]H/P070000000kF;80>eRb03]H/P3D?AT0>eRb0000000203]H/P050000000k
F;80>eRb03]H/P000000103oBal00`000000od/O0?m;7`020?m;7`030000000mFJ/0?EV[0080od/O
00<000000?m;7`3oBal00`3oBal00`0mFJ/0od/O0?m;7`030?m;7`030000003oBal0od/O00@0od/O
0`0000040?m97`030000003oBAl0odTO0080?EV[00<0odTO0000003oBAl01P3oBAl00`000000odTO
0?m97`050?m97`030000000mFJ/0odTO00H0odTO00<000000?m97`3oBAl00P0000040?i87P0303eI
Z`000000oTPN00L0oTPN00<000000?i87P0mFJ/0103nB1h00`0mFJ/0oTPN000000030?ofkP030=@m
6@3om^h0e3dI00L0ooK^0P3D?AT:0?ofkP030=@m6@3om^h0ooK^0140ooK^00<0e3dI0?ofkP3om^h0
2`3om^h30=@m6@030?ofkP3D?AT0ooK^0100ooK^00<0e3dI0?ofkP3om^h0>`3om^h3000000d0ooK^
00<000000?ofkP3om^h00P3om^h10?ooo`00;P3om^h00`000000ooK^0?ofkP0O0?ofkP80e3dI00@0
ooK^0000003om^h0ooK^0P3D?AT30?ofkPD0e3dI0`3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP@0e3dI
00<0ooK^0=@m6@3om^h02@3om^h0100mFJ/0ooK^03eIZ`0mFJ/30?ofkP0303eIZ`3D?AT0?EV[00D0
ooK^00<0?EV[0?ofkP3D?AT01@3D?AT201TSD@8000001@0R<Vd00`0000008S9]028bK@04028bK@03
0000000Z?X<0:Sj30080:Sj300<0e3dI02XnP`0000001`0Z?X<00`000000<DRE0358U@040358U@04
0000000aB9D0<DRE0358U@<0e3dI00<000000358U@3D?AT0100fD:D00`000000=U2U03I@Y@0303I@
Y@030000000fD:D0=U2U00<0=U2U00<0000003]H/P0kF;800P0kF;801P000000>eRb03]H/P3D?AT0
>eRb000000<0>eRb00D0000003]H/P0kF;80>eRb000000040?m;7`050000003oBal0od/O0?m;7`00
00000P3oBal00`0mFJ/0od/O000000040?m;7`0303eIZ`000000od/O00<0od/O00<000000?m;7`3o
Bal0103oBal010000000od/O0?m;7`3oBal2000000050?m97`000000odTO0?m97`0mFJ/00P3oBAl3
03eIZ`D0odTO00<000000?m97`3oBAl01@3oBAl00`000000?EV[0?m97`060?m97`030000003oBAl0
odTO00<0odTO0P0000000`3nB1h0?EV[000000080?i87P030000003nB1h0?EV[00<0oTPN0P0mFJ/0
0`3nB1h000000?ofkP030?ofkP80e3dI2P3om^h30=@m6@L0ooK^00<0e3dI0?ofkP3om^h0403om^h0
0`3D?AT0ooK^0?ofkP0?0?ofkP<0e3dI403om^h00`3D?AT0ooK^0?ofkP0n0?ofkP<000002P3om^h0
0`000000ooK^0?ofkP020?ofkP40oooo000]0?ofkP030000003om^h0ooK^0280ooK^00@000000=@m
6@3D?AT0e3dI203om^h50=@m6@030?ofkP3D?AT0ooK^00l0ooK^103D?AT80?ofkP0403eIZ`3om^h0
?EV[03eIZ`@0ooK^00<0?EV[0=@m6@3om^h01@3om^h01@0mFJ/0e3dI0?ofkP3om^h0?EV[00<06B=A
0`3D?AT6028bK@030000000R<Vd08S9]00<08S9]00<0000002XnP`0000000P0Z?X<01@3D?AT0:Sj3
02XnP`0Z?X<0000000D0:Sj300<000000358U@0000001P0aB9D00`000000<DRE0358U@030358U@<0
e3dI1@0fD:D00`000000=U2U03I@Y@0303I@Y@070000000fD:D0=U2U03I@Y@000000>eRb00000003
03]H/P030000000kF;80e3dI00<0>eRb00@0000003]H/P0kF;8000000`0kF;8300000080od/O00D0
00000?m;7`3oBal0od/O000000030?m;7`0303eIZ`000000od/O0080od/O00<0?EV[0000003oBal0
103oBal00`000000od/O0?m;7`040?m;7`030000003oBal0od/O00<0od/O0`0000001@0mFJ/0odTO
0?m97`3oBAl000000080odTO0`0mFJ/00`3oBAl000000?m97`060?m97`030000000mFJ/0odTO00H0
odTO00<000000?m97`3oBAl01P3oBAl00`0mFJ/00000000000070?i87P030000003nB1h0?EV[0080
oTPN0`0mFJ/00`3nB1h000000?ofkP040?ofkP80e3dI3@3om^h30=@m6@<0ooK^00<0e3dI0?ofkP3o
m^h04@3om^h00`3D?AT0ooK^0?ofkP0@0?ofkP030=@m6@3om^h0e3dI0080e3dI3@3om^h00`3D?AT0
ooK^0?ofkP110?ofkP800000203om^h00`000000ooK^0?ofkP020?ofkP40oooo000]0?ofkP030000
003om^h0ooK^0280ooK^00@000000?ofkP3om^h0ooK^103D?AT80?ofkP@0e3dI3`3om^h00`3D?AT0
ooK^0=@m6@040=@m6@@0ooK^00@0?EV[0?ofkP3om^h0?EV[103om^h203eIZ`030=@m6@3om^h0ooK^
00@0ooK^00D0e3dI0?ofkP3om^h0?EV[0000000401TSD@030000000R<Vd0e3dI0080e3dI100R<Vd0
1@0000008S9]028bK@0R<Vd000000080:Sj300@0000002XnP`0Z?X<0e3dI100Z?X<00`000000:Sj3
02XnP`02000000<0<DRE00<000000358U@0aB9D0100aB9D00`000000<DRE0358U@020358U@030=@m
6@0fD:D0000000<0e3dI0`0fD:D00`000000=U2U03I@Y@0303I@Y@030000000fD:D000000080>eRb
00<0000003]H/P0kF;800P0kF;800`000000e3dI03]H/P0203]H/P040000000kF;80>eRb00000080
>eRb0P0000020?m<80<000000`3oBal00`000000od/O0?m;7`020?m;7`80?EV[00@0od/O03eIZ`3o
Bal000001@3oBal00`000000od/O0?m;7`030?m;7`030000003oBal0od/O00@0od/O00@000000?m;
7`0mFJ/0od/O100000050?m97`<0?EV[1P3oBAl00`0mFJ/0odTO0?m97`050?m97`030000003oBAl0
odTO00H0odTO00@0?EV[0000003oBAl0odTO100000020?i87P040000000mFJ/0?EV[0?i87P80?EV[
00@0oTPN03eIZ`3nB1h000001@3om^h00`3D?AT0ooK^0=@m6@0@0?ofkP80e3dI00<0ooK^0=@m6@3o
m^h04P3om^h00`3D?AT0ooK^0?ofkP0@0?ofkP030=@m6@3om^h0ooK^0080ooK^0`3D?AT:0?ofkP03
0=@m6@3om^h0ooK^04<0ooK^0`0000050?ofkP030000003om^h0ooK^0080ooK^0@3oool002d0ooK^
00<000000?ofkP3om^h08@3om^h00`000000ooK^0?ofkP050?ofkP@0e3dI1`3om^h60=@m6@X0ooK^
00D0e3dI0?ofkP3om^h0ooK^0=@m6@020?ofkPD0e3dI0P3om^h203eIZ`@0ooK^0P0mFJ/00`3om^h0
e3dI0?ofkP030?ofkP040=@m6@0mFJ/0ooK^03eIZ`80ooK^00@0000001TSD@0I8e4000000P0R<Vd0
0`0000008S9]028bK@040=@m6@040000000R<Vd08S9]000000@0:Sj300<000000=@m6@0Z?X<0100Z
?X<00`000000:Sj3000000050358U@030000000aB9D0<DRE00D0<DRE00D000000358U@0aB9D00000
0=@m6@0203I@Y@030000000fD:D0=U2U00<0e3dI00<0=U2U0000000fD:D00`0fD:D00`000000=U2U
0000000303]H/P050000000kF;80>eRb03]H/P3D?AT01@0kF;800`000000>eRb03]H/P0200000080
?eno00@000000?m<803oC200od`P0`0000000`3oBal000000?m;7`030?m;7`030000003oBal0?EV[
0080od/O00<000000?m;7`3oBal00`3oBal00`000000od/O0?m;7`030?m;7`030000003oBal0od/O
00@0od/O00<0000003eIZ`3oBal00P3oBal00`000000od/O0?m;7`0300000080odTO00<000000?m9
7`3oBAl00`0mFJ/20?m97`0303eIZ`3oBAl0odTO00D0odTO00<000000?m97`3oBAl01@3oBAl203eI
Z`030000003oBAl0odTO00D0odTO0P000000100mFJ/0oTPN03eIZ`0mFJ/20?i87P0303eIZ`000000
000000H0ooK^0P3D?ATC0?ofkP<0e3dI4P3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0
ooK^00H0ooK^0P3D?AT70?ofkP030=@m6@3om^h0ooK^04L0ooK^0`0000030?ofkP040000003om^h0
ooK^0?ofkP40oooo000]0?ofkP030000003om^h0ooK^0200ooK^00<000000?ofkP3om^h02@3om^h5
0=@m6@@0ooK^00<0e3dI0?ofkP3om^h01@3D?AT50?ofkP80e3dI103om^h00`3D?AT0ooK^0?ofkP03
0?ofkPD0e3dI1@3om^h0100mFJ/0ooK^0?ofkP3D?AT40?ofkP040=@m6@0mFJ/0ooK^03eIZ`80ooK^
00@0000001TSD@0I8e4000000`0R<Vd00`0000008S9]028bK@03028bK@<0e3dI1@0Z?X<00`3D?AT0
000002XnP`0502XnP`030000000aB9D0<DRE00D0<DRE00<000000358U@0aB9D0100aB9D010000000
<DRE0000003D?AT303I@Y@030000000fD:D0=U2U00<0=U2U0`3D?AT403I@Y@030000000kF;80>eRb
00<0>eRb00D0000003]H/P0kF;80e3dI0000000403]H/P040000000kF;80>eRb000000<0?eno00D0
00000?m<803oC200od`P000000020?m<80@000000P3oBal00`000000?EV[0?m;7`0203eIZ`030000
003oBal0od/O00<0od/O00<000000?m;7`3oBal00P3oBal00`000000od/O0?m;7`040?m;7`030000
000mFJ/0od/O00<0od/O00<000000?m;7`3oBal00`3oBal3000000D0odTO1@0mFJ/40?m97`030000
003oBAl0odTO00D0odTO00<0?EV[0000003oBAl0203oBAl010000000?EV[03eIZ`0mFJ/200000080
?EV[0P0000070?ofkP80e3dI503om^h00`3D?AT0ooK^0=@m6@020=@m6@h0ooK^00<0e3dI0?ofkP3o
m^h0403om^h00`3D?AT0ooK^0?ofkP080?ofkP<0e3dI103om^h00`3D?AT0ooK^0?ofkP1:0?ofkP80
000000<0ooK^0000003om^h00P3om^h10?ooo`00;@3om^h00`000000ooK^0?ofkP0P0?ofkP030000
003om^h0ooK^00`0ooK^1`3D?AT60?ofkPH0e3dI1P3om^h00`3D?AT0ooK^0?ofkP030?ofkP0303eI
Z`3om^h0ooK^00D0e3dI00<0ooK^03eIZ`0mFJ/00P3om^h01P3D?AT0ooK^0?ofkP3om^h0e3dI0?of
kP80?EV[103om^h2000000@08S9]00<00000028bK@0R<Vd0100R<Vd00`000000:Sj30=@m6@020=@m
6@80:Sj300<0e3dI0000000Z?X<0100Z?X<00`000000<DRE000000070358U@030000000aB9D0<DRE
00@0<DRE00<000000=@m6@0fD:D0100fD:D00`000000=U2U03I@Y@0403I@Y@030000003D?AT0e3dI
0080e3dI00<0>eRb0000000kF;800`0kF;800`000000>eRb0=@m6@0203]H/P030000000kF;80>eRb
0080>eRb0`00000403mO_`050000003oC200od`P0?m<800000000P3oC2000`000000od`P0?m<8002
0000000303eIZ`000000od/O0080od/O0P0mFJ/40?m;7`030000003oBal0od/O0080od/O00<00000
0?m;7`3oBal00`3oBal203eIZ`@0od/O00<000000?m;7`3oBal0103oBal00`000000od/O0?m;7`03
00000080odTO00<0?EV[0?m97`3oBAl00P3oBAl703eIZ`@0odTO00<0?EV[0000003oBAl00`3oBAl8
03eIZ`<0odTO00@0?EV[00000000000000001`3om^h00`3D?AT0ooK^0=@m6@0C0?ofkP030=@m6@3o
m^h0ooK^00<0ooK^0`3D?AT;0?ofkP030=@m6@3om^h0ooK^0100ooK^00<0e3dI0?ofkP3om^h02`3o
m^h30=@m6@030?ofkP3D?AT0ooK^04d0ooK^0P0000030?ofkP40oooo000/0?ofkP030000003om^h0
ooK^0200ooK^00<000000?ofkP3om^h04@3om^h50=@m6@L0ooK^1@3D?AT40?ofkP030=@m6@3om^h0
ooK^00<0ooK^00D0?EV[0?ofkP0mFJ/0ooK^03eIZ`020?ofkPD0e3dI00D0ooK^0=@m6@3om^h0ooK^
0=@m6@020?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<00000028bK@0R<Vd0100R<Vd00`0000008S9]
028bK@02028bK@030000000Z?X<0000000<0:Sj30`3D?AT00`0Z?X<0000002XnP`0202XnP`050000
000aB9D0<DRE0358U@0000001`0aB9D00`000000<DRE0358U@020358U@030000003D?AT0000000H0
=U2U00<0000003I@Y@0fD:D0100fD:D010000000=U2U0000000kF;830=@m6@@0>eRb00D000000=@m
6@0kF;80>eRb0000000403]H/P040000000oGkl0?eno000000<0?eno00D000000?m<803oC200od`P
000000020?m<80070000003oC200od`P0?m<800mFJ/000000?m<8002000000030?m;7`000000od/O
0080?EV[00<0od/O0000003oBal0103oBal00`000000od/O0?m;7`020?m;7`0303eIZ`000000od/O
00<0od/O00<000000?m;7`3oBal01@3oBal00`000000od/O0?m;7`030?m;7`030000000mFJ/00000
00H0odTO00<000000?m97`3oBAl00P3oBAl:03eIZ`<0odTO00<000000?m97`0mFJ/0103oBAl01@0m
FJ/00000000000000000ooK^00<0e3dI103om^h20=@m6A@0ooK^00<0e3dI0?ofkP3om^h01P3om^h3
0=@m6@P0ooK^00<0e3dI0?ofkP3om^h0403om^h00`3D?AT0ooK^0?ofkP0>0?ofkP80e3dIC@3om^h2
000000@0ooK^0@3oool002`0ooK^00<000000?ofkP3om^h07`3om^h00`000000ooK^0?ofkP0E0?of
kPD0e3dI00@0ooK^0=@m6@3D?AT0e3dI0`3om^h60=@m6@030?ofkP3D?AT0ooK^0080ooK^00<0?EV[
0?ofkP0mFJ/00P3om^h0100mFJ/0ooK^0?ofkP0mFJ/20?ofkPH0e3dI0P3om^h203eIZ`H0ooK^00<0
0000028bK@0R<Vd00`0R<Vd01@0000008S9]028bK@0R<Vd0000000<0:Sj300@0000002XnP`0Z?X<0
e3dI0P0Z?X<40=@m6@0302XnP`000000<DRE00<0<DRE00<000000358U@0aB9D0100aB9D02@000000
<DRE0358U@0aB9D0000003I@Y@3D?AT0=U2U0000000603I@Y@030000000fD:D0=U2U00@0=U2U00<0
000003]H/P0kF;800P0kF;801P000000e3dI0=@m6@3D?AT0>eRb0=@m6@@0>eRb00<0000003]H/P0k
F;800P00000203mO_`050000000oGkl0?eno03mO_`0000000`3oC2001@000000od`P0?m<80000000
od`P0080?EV[00<0od`P0000003oC2000P3oC20300000080od/O00<0?EV[0000003oBal00`3oBal0
0`000000od/O0?m;7`020?m;7`0303eIZ`3oBal0000000@0od/O00<000000?m;7`3oBal0103oBal0
0`000000od/O0?m;7`040?m;7`0303eIZ`3oBal0od/O00<000000P3oBAl00`000000odTO0?m97`05
0?m97`0303eIZ`000000odTO00L0odTO00<000000?m97`0mFJ/0103oBAl0100mFJ/0000003eIZ`00
00050?ofkP80e3dI00@0ooK^0=@m6@3om^h0e3dI4`3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP<0e3dI
1@3om^h00`3D?AT0ooK^0?ofkP0@0?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h0
BP3om^h00`000000ooK^0?ofkP040?ofkP40oooo000/0?ofkP030000003om^h0ooK^01h0ooK^00<0
00000?ofkP3om^h06@3om^h50=@m6@L0ooK^1P3D?AT20?ofkP80?EV[0P3om^h0100mFJ/0ooK^0?of
kP0mFJ/30?ofkP0303eIZ`3om^h0ooK^00H0e3dI00<0?EV[0?ofkP3om^h0103om^h00`0000008S9]
028bK@04028bK@040000000R<Vd08S9]000000@0:Sj300<000000=@m6@0Z?X<0100Z?X<00`000000
:Sj30=@m6@020=@m6@@0<DRE00<000000358U@0aB9D0100aB9D01@000000<DRE0000000fD:D0e3dI
00<0=U2U00<0000003I@Y@0fD:D0100fD:D00`000000=U2U03I@Y@0203I@Y@030000000kF;800000
00@0>eRb00<0000003]H/P0kF;800`3D?AT303]H/P030000000kF;8000000080?eno00@0000003mO
_`0oGkl000000`0oGkl010000000od`P0?m<800000030?m<800503eIZ`3oC200od`P0?m<80000000
103oC2001@000000od`P000000000000od/O0080?EV[0`3oBal01`000000od/O0?m;7`3oBal0?EV[
0?m;7`000000103oBal00`000000od/O0?m;7`040?m;7`030000003oBal0od/O00@0od/O00<0?EV[
0?m;7`3oBal0103oBal3000000H0odTO00<0?EV[0000003oBAl01P3oBAl200000080?EV[103oBAl0
10000000?EV[0=@m6@3D?AT80?ofkP<0e3dI503om^h00`3D?AT0ooK^0?ofkP0=0?ofkP<0e3dI00<0
ooK^0=@m6@3om^h04@3om^h00`3D?AT0ooK^0?ofkP0@0?ofkP030=@m6@3om^h0ooK^04P0ooK^0P00
00070?ofkP40oooo000/0?ofkP030000003om^h0ooK^01h0ooK^00<000000?ofkP3om^h0703om^h5
0=@m6@L0ooK^1P3D?AT30?ofkP0403eIZ`3om^h0ooK^03eIZ`<0ooK^00<0?EV[0?ofkP3om^h00P3D
?AT00`3om^h0e3dI0=@m6@050=@m6@@0ooK^00<00000028bK@0R<Vd00`0R<Vd00`0000008S9]0000
000502XnP`030=@m6@000000:Sj300D0:Sj300@0000003eIZ`0aB9D0<DRE103D?AT00`0aB9D00000
0358U@050358U@030000000fD:D0e3dI00D0=U2U00<0000003I@Y@0fD:D00`0fD:D01@000000=U2U
03I@Y@0fD:D0000000<0>eRb00<0000003]H/P0kF;800P0kF;800`000000>eRb0=@m6@0203]H/P@0
e3dI00D0000003mO_`0oGkl0?eno0000000203mO_`050000000oGkl0?eno03mO_`0000000`3oC200
10000000od`P03eIZ`0000030?m<80030000003oC200od`P0080od`P00@000000?m<803oC200od`P
0`00000203eIZ`050000003oBal0od/O0?m;7`0mFJ/00P3oBal00`000000od/O0?m;7`020?m;7`03
0000003oBal0od/O00<0od/O00<000000?m;7`3oBal0103oBal00`0mFJ/0od/O0?m;7`050?m;7`03
0000003oBal0od/O00<000000P3oBAl00`0mFJ/0odTO0?m97`060?m97`030000003oBAl0?EV[00D0
odTO00<0000003eIZ`0000000P3om^h30=@m6@H0ooK^0P3D?ATD0?ofkP030=@m6@3om^h0ooK^0100
ooK^0`3D?ATA0?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h0B03om^h00`000000
ooK^0?ofkP070?ofkP40oooo000/0?ofkP030000003om^h0ooK^01d0ooK^00<000000?ofkP3om^h0
803om^h60=@m6@D0ooK^203D?AT00`3om^h0?EV[0?ofkP030?ofkP0603eIZ`3om^h0e3dI0?ofkP3D
?AT0?EV[103om^h70=@m6@030000000R<Vd08S9]00@08S9]00<0000002XnP`0Z?X<00`0Z?X<0103D
?AT0:Sj302XnP`00000402XnP`030000000aB9D0000000H0<DRE0`3D?AT40358U@030000000fD:D0
e3dI00L0=U2U00<0000003I@Y@0fD:D00`0fD:D00`000000=U2U0000000403]H/P030000000kF;80
>eRb00<0>eRb00H0e3dI03]H/P0kF;80>eRb0000000kF;82000000<0e3dI0P0oGkl010000000?eno
03mO_`00000203mO_`080000003oC200od`P0?m<80000000?EV[0?m<800000030?m<80050000003o
C200od`P0?m<800000001@3oC20010000000od`P00000000000203eIZ`050?m;7`0mFJ/0od/O0?m;
7`000000103oBal00`000000od/O0?m;7`040?m;7`030000003oBal0od/O0080od/O0P0mFJ/70?m;
7`030000003oBal0od/O00@0od/O00<0000003eIZ`0000001`3oBAl00`000000odTO03eIZ`050?m9
7`030000000mFJ/0000000H0ooK^0P3D?AT40?ofkP80e3dI4`3om^h00`3D?AT0ooK^0?ofkP0B0?of
kP040=@m6@3om^h0e3dI0=@m6@l0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP16
0?ofkP8000002P3om^h10?ooo`00;03om^h00`000000ooK^0?ofkP0L0?ofkP030000003om^h0ooK^
02@0ooK^1P3D?AT30?ofkP040=@m6@0mFJ/0ooK^0?ofkPH0e3dI0`3om^h20=@m6@80ooK^00<0e3dI
0?ofkP3om^h00`3om^h0100mFJ/0ooK^0?ofkP3om^h50=@m6@@08S9]00<0000002XnP`0000000`0Z
?X<00`3D?AT0:Sj302XnP`0202XnP`040000000Z?X<0:Sj3000000<0<DRE00<000000358U@0aB9D0
1P0aB9D40=@m6@80=U2U00<0e3dI0000000000001P0fD:D00`000000=U2U03I@Y@0303I@Y@030000
000kF;80>eRb00@0>eRb00<0000003]H/P0kF;800P0kF;800`3D?AT0000003]H/P0203]H/P060000
000oGkl0?eno03mO_`000000?eno103D?AT00`0oGkl0000003mO_`0203mO_`040000003oC200od`P
03eIZ`80od`P00D000000?m<803oC200od`P000000030?m<80030000003oC200od`P0080od`P00<0
00000?m<803oC2000P3oC20010000000od`P03eIZ`0mFJ/20?m;7`050000003oBal0od/O0?m;7`00
00001P3oBal00`000000od/O0?m;7`020?m;7`0303eIZ`000000od/O00H0od/O00<000000?m;7`3o
Bal01@3oBal00`0mFJ/0od/O0?m;7`0300000080odTO0P0000000`3oBAl0?EV[0?m97`030?m97`@0
00002@3om^h50=@m6A@0ooK^00<0e3dI0?ofkP3om^h04@3om^h00`3D?AT0ooK^0?ofkP020?ofkP<0
e3dI303om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^04D0ooK^00<000000?ofkP3o
m^h02P3om^h10?ooo`00:`3om^h00`000000ooK^0?ofkP0M0?ofkP030000003om^h0ooK^02L0ooK^
1`3D?AT40?ofkP80?EV[1P3D?AT01@0mFJ/0ooK^0?ofkP3om^h0e3dI00D0ooK^00<0?EV[0?ofkP3o
m^h0103om^h40=@m6@03028bK@000000:Sj30080:Sj300<0000002XnP`3D?AT01P0Z?X<00`000000
:Sj3000000040358U@030000000aB9D0<DRE00H0<DRE00<000000358U@0000000`3D?AT203I@Y@03
0000000fD:D0=U2U00@0=U2U00L0000003I@Y@0fD:D0=U2U0000000kF;80000000H0>eRb00H00000
03]H/P0kF;80e3dI03]H/P00000203]H/P030000000oGkl0000000<0?eno00D0000003mO_`0oGkl0
?eno000000020=@m6@070000000oGkl0?eno0000003oC200?EV[000000020?m<80050000003oC200
od`P0?m<800000000`3oC2000`000000od`P0?m<80020?m<80070000003oC200od`P0?m<80000000
od`P03eIZ`020?m<80<0?EV[0`3oBal00`000000od/O0?m;7`030?m;7`030000003oBal0od/O0080
od/O00<0?EV[0?m;7`0000001P3oBal00`000000od/O0?m;7`040?m;7`80?EV[1P3oBal300000003
0?m97`0mFJ/0odTO00<0odTO0`00000>0?ofkP<0e3dI4P3om^h00`3D?AT0ooK^0?ofkP0B0?ofkP03
0=@m6@3om^h0ooK^00D0ooK^0P3D?AT:0?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3o
m^h0A03om^h00`000000ooK^0?ofkP0;0?ofkP40oooo000[0?ofkP030000003om^h0ooK^01`0ooK^
00<000000?ofkP3om^h0;03om^h50=@m6@80ooK^00<0?EV[0?ofkP3om^h00P3om^h70=@m6@030?of
kP3D?AT0ooK^00<0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/00000028bK@040=@m6@80:Sj3
00<0e3dI02XnP`0Z?X<01P0Z?X<00`000000<DRE0358U@040358U@8000001`0aB9D00`000000=U2U
0=@m6@0203I@Y@<0e3dI00<0000003I@Y@0fD:D0100fD:D00`000000=U2U0000000303]H/P800000
1@0kF;800`000000e3dI03]H/P0203]H/P030000000kF;8000000080?eno00D0000003mO_`0oGkl0
?eno0000000203mO_`030000000oGkl0?eno00<0e3dI00L0?eno0000000mFJ/0od`P0000003oC200
000000<0od`P00D000000?m<803oC200od`P000000030?m<80030000003oC200od`P0080od`P00<0
000003eIZ`3oC2000P3oC2000`000000od`P0?m<800303eIZ`030000003oBal0od/O0080od/O00<0
00000?m;7`3oBal00P3oBal00`0mFJ/0od/O000000050?m;7`8000001P3oBal00`0mFJ/0od/O0?m;
7`050?m;7`80000000@0od/O03eIZ`0mFJ/000000P3oBAl0100mFJ/0000000000000000?0?ofkP80
e3dI00@0ooK^0=@m6@3D?AT0e3dI3`3om^h00`3D?AT0ooK^0?ofkP0B0?ofkP030=@m6@3om^h0ooK^
00L0ooK^0`3D?AT70?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h0@P3om^h20000
00h0ooK^0@3oool002/0ooK^00<000000?ofkP3om^h06`3om^h00`000000ooK^0?ofkP0^0?ofkP03
03eIZ`3om^h0e3dI00P0e3dI0`3om^h70=@m6@@0ooK^00<0?EV[0?ofkP3om^h00`3om^h01@0mFJ/0
ooK^0000000R<Vd0000000<0:Sj30`3D?AT00`000000:Sj302XnP`0402XnP`030000000mFJ/00000
00L0<DRE00<000000358U@0aB9D00`0aB9D010000000=U2U0=@m6@00000503I@Y@<0e3dI1@0fD:D0
0`000000>eRb03]H/P0403]H/P030000000kF;80>eRb0080>eRb00<0e3dI0000000kF;800`0kF;80
1@000000?eno03mO_`0oGkl0000000<0?eno00D0000003mO_`0oGkl0?eno0000000203mO_`030000
000oGkl0e3dI0080000000D0od`P0000003oC200od`P000000020?m<80050000003oC200od`P0?m<
800000000`3oC2001P000000od`P0?m<803oC200000003eIZ`@0od`P00H000000?m<803oC200od`P
0000003oC20303eIZ`80od/O00L000000?m;7`3oBal0od/O03eIZ`3oBal0000000D0od/O00<00000
0?m;7`3oBal01@3oBal00`0mFJ/0od/O0?m;7`040?m;7`8000000P3oBal0100mFJ/0od/O0?m;7`3o
Bal500000100ooK^00<0e3dI0?ofkP3om^h00`3om^h30=@m6@`0ooK^00<0e3dI0?ofkP3om^h04@3o
m^h00`3D?AT0ooK^0?ofkP0;0?ofkP<0e3dI0`3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3o
m^h0ooK^0480ooK^00<000000?ofkP3om^h03P3om^h10?ooo`00:`3om^h00`000000ooK^0?ofkP0J
0?ofkP030000003om^h0ooK^02l0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`060=@m6@<0ooK^0P0m
FJ/20?ofkPH0e3dI00<0ooK^03eIZ`3om^h00`3om^h01@0mFJ/0ooK^0?ofkP3om^h0000000<0:Sj3
0P3D?AT202XnP`<0e3dI0`0Z?X<01@000000<DRE0358U@0aB9D0000000L0<DRE00D000000358U@0a
B9D0<DRE0000000203I@Y@030=@m6@0fD:D0000000H0=U2U00P000000=@m6@3D?AT0e3dI03I@Y@00
0000>eRb000000H0>eRb00H0000003]H/P0kF;80e3dI03]H/P00000303]H/P030000000oGkl00000
00<0?eno00D0000003mO_`0oGkl0?eno0000000203mO_`050000000oGkl0?eno0000000oGkl00P00
00001P3D?AT00000000000000000od`P00000080od`P00D000000?m<803oC200od`P000000030?m<
80050000003oC200od`P0?m<800mFJ/0103oC2001@000000od`P0?m<803oC200000000D0od`P0`0m
FJ/01@000000od/O03eIZ`3oBal0000000D0od/O00<000000?m;7`3oBal0103oBal00`000000?EV[
0?m;7`040?m;7`8000000`3oBal303eIZ`030?m;7`000000000000<0000000<0e3dI0?ofkP3om^h0
3@3om^h20=@m6@P0ooK^0`3D?AT80?ofkP030=@m6@3om^h0ooK^0180ooK^00<0e3dI0?ofkP3om^h0
3P3om^h20=@m6@030?ofkP3D?AT0ooK^0100ooK^00<0e3dI0?ofkP3om^h0@03om^h200000140ooK^
0@3oool002/0ooK^00<000000?ofkP3om^h06P3om^h00`000000ooK^0?ofkP0_0?ofkP0803eIZ`3o
m^h0ooK^0?ofkP0mFJ/0ooK^03eIZ`3om^h70=@m6@H0ooK^1`3D?AT00`3om^h0?EV[0?ofkP040?of
kP030000000Z?X<0e3dI00H0:Sj300D000000=@m6@3D?AT0e3dI000000040358U@030000000aB9D0
<DRE00D0<DRE00<000000358U@0000000P0fD:D01@3D?AT0=U2U03I@Y@0fD:D0000000L0=U2U00<0
000003I@Y@3D?AT00P3D?AT00`0kF;8000000000000503]H/P030000003D?AT0>eRb0080>eRb00<0
000003]H/P0000000`0oGkl01@000000?eno03mO_`0oGkl000000080?eno00D0000003mO_`0oGkl0
?eno0000000203mO_`0700000014I/X0A6K:0000003oCB0000000?m=8003000000050?m<80000000
od`P0?m<800000000`3oC2001P000000od`P0?m<803oC200?EV[000000<0od`P00<000000?m<803o
C2000P3oC2000`000000od`P0?m<80030?m<80030000003oC200od`P00D0?EV[103oBal00`000000
od/O0?m;7`040?m;7`030000000mFJ/0od/O00@0od/O00<000000?m;7`0mFJ/0100mFJ/00`3oBal0
000000000004000000<0e3dI3P3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP<0e3dI1@3om^h00`3D?AT0
ooK^0?ofkP0B0?ofkP030=@m6@3om^h0ooK^0100ooK^0`3D?AT@0?ofkP030=@m6@3om^h0ooK^03l0
ooK^00<000000?ofkP3om^h04@3om^h10?ooo`00:P3om^h00`000000ooK^0?ofkP0J0?ofkP030000
003om^h0ooK^0300ooK^00@0?EV[0?ofkP3om^h0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP030?ofkPH0
e3dI0`3om^h0103D?AT0ooK^0?ofkP3om^h60=@m6@D0ooK^00<0e3dI02XnP`0Z?X<01P0Z?X<00`00
0000:Sj3000000030=@m6@<0<DRE0P0000060358U@040000000fD:D0=U2U0=@m6@D0=U2U0P000006
03I@Y@040000000kF;80>eRb03]H/P<0e3dI00<0000003]H/P0kF;800`0kF;800`3D?AT0000003]H
/P0203]H/P030000000oGkl0?eno00<0?eno00D0000003mO_`0oGkl0?eno0000000203mO_`050000
000oGkl0?eno0000000oGkl00P00000204AVbP030000003oCB0000000080oddP00<000000?m=8000
00000P0000000`3oC20000000?m<80020?m<80050000003oC200od`P03eIZ`000000103oC2001@00
0000od`P0?m<803oC200000000D0od`P00D000000?m<803oC200od`P03eIZ`02000000030?m<8000
0000?EV[00H0?EV[0`3oBal010000000?EV[0?m;7`3oBal603eIZ`80od/O00H0?EV[0?m;7`000000
000004eegP3D?AT300000080ooK^00<0e3dI0?ofkP3D?AT00P3D?AT;0?ofkP030=@m6@3om^h0ooK^
00d0ooK^0`3D?AT00`3om^h0e3dI0?ofkP0C0?ofkP030=@m6@3om^h0ooK^0180ooK^00<0e3dI0?of
kP3D?AT00P3D?AT=0?ofkP030=@m6@3om^h0ooK^03d0ooK^0P00000D0?ofkP40oooo000Z0?ofkP03
0000003om^h0ooK^01T0ooK^00<000000?ofkP3om^h0<03om^h0100mFJ/0ooK^0?ofkP0mFJ/30?of
kP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP0mFJ/0203D?AT30?ofkP0303eIZ`3om^h0e3dI
00L0e3dI00@0ooK^0000000Z?X<0e3dI1P0Z?X<00`000000<DRE0358U@020358U@@0e3dI00<0<DRE
0000000aB9D00`0aB9D010000000=U2U0000003D?AT803I@Y@030000000fD:D0=U2U0080=U2U00@0
000003]H/P0000000000100kF;830=@m6@80>eRb00P0e3dI03]H/P0kF;80000003]H/P000000?eno
000000D0?eno00D0000003mO_`0oGkl0?eno0000000203mO_`040000000oGkl0?eno00000080A6K:
00<0000004AVbP0000000P3oCB0303eIZ`80oddP00<000000?m=800000000P0000001`3oC2000000
0?m<803oC200?EV[0?m<800000000`3oC2001@000000od`P0?m<803oC200000000D0od`P00H00000
0?m<803oC200od`P03eIZ`0000050?m<80@000000P3oBal703eIZ`8000001@3oBal02@0mFJ/0od/O
0000001=MMh000000=@m6@000000AF_8000000030?ofkP030=@m6@3om^h0ooK^0080ooK^0`3D?AT7
0?ofkP80e3dI4P3om^h30=@m6A<0ooK^00<0e3dI0?ofkP3om^h04@3om^h00`3D?AT0ooK^0?ofkP03
0?ofkP<0e3dI2P3om^h00`3D?AT0ooK^0?ofkP0l0?ofkP030000003om^h0ooK^01@0ooK^0@3oool0
02X0ooK^00<000000?ofkP3om^h0603om^h00`000000ooK^0?ofkP0a0?ofkP0303eIZ`3om^h0?EV[
00@0ooK^00<0?EV[0?ofkP3om^h00`3om^h0100mFJ/0ooK^0?ofkP0mFJ/30?ofkPH0e3dI00<0ooK^
03eIZ`0mFJ/0103om^h60=@m6@030000003D?AT0:Sj300@0:Sj300@000000358U@00000000001P0a
B9D30=@m6@80<DRE00H0000003I@Y@0fD:D0=U2U0=@m6@00000803I@Y@80000000<0=U2U0000000k
F;800`0kF;800`000000>eRb03]H/P0303]H/P040000003D?AT0e3dI0=@m6@<0>eRb00@0000003mO
_`0oGkl0?eno0P00000403mO_`040000000oGkl0?eno00000080?eno00<0000003mO_`0000000P14
I/X02@3D?AT0000004AVbP14I/X000000?m=80000000oddP0000000203eIZ`050000003oCB00oddP
0000003oCB000P000000103D?AT0?EV[0?m<800000030?m<80050000003oC200od`P0?m<80000000
103oC202000000<0od`P00<0?EV[0000003oC200103oC202000000<0od`P100000000`0mFJ/0od/O
0?m;7`02000000L0od/O1@0000000`3D?AT00000000000040?ofkP030=@m6@3om^h0ooK^00D0ooK^
0`3D?AT40?ofkP030=@m6@3om^h0ooK^0180ooK^00<0e3dI0?ofkP3D?AT00P3D?AT@0?ofkP030=@m
6@3om^h0ooK^0140ooK^00<0e3dI0?ofkP3om^h01P3om^h20=@m6@P0ooK^00<0e3dI0?ofkP3om^h0
>P3om^h2000001L0ooK^0@3oool002X0ooK^00<000000?ofkP3om^h0603om^h00`000000ooK^0?of
kP0a0?ofkP80?EV[1@3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/0
1P3om^h60=@m6@040?ofkP3D?AT0e3dI0=@m6@<0ooK^1P3D?AT302XnP`030000000aB9D0<DRE0080
<DRE00<000000358U@0aB9D01P0aB9D30=@m6@80=U2U00<0e3dI03I@Y@0fD:D00P00000803I@Y@03
0000000kF;80>eRb00@0>eRb0P00000403]H/P030=@m6@000000>eRb00@0e3dI00<0000003mO_`0o
Gkl00P0oGkl00`000000?eno03mO_`0203mO_`040000000oGkl0?eno00000080?eno00@0000004AV
bP14I/X0e3dI0P14I/X01`000000A6K:0000003oCB0000000?m=800000000P3oCB0203eIZ`060?m=
80000000oddP0?m=80000000?EV[100000020?m<80050000003oC200od`P0?m<800000000`3oC200
0`000000od`P0?m<80020?m<800303eIZ`000000od`P00<0od`P0P0000050?m<8080000000<0od`P
03eIZ`0000000`0000060?m;7`<000000P3D?AT00`000000e3dI000000050?ofkP030=@m6@3om^h0
ooK^00T0ooK^1@3D?ATC0?ofkP030=@m6@3om^h0ooK^00<0ooK^0P3D?AT>0?ofkP030=@m6@3om^h0
ooK^0100ooK^00<0e3dI0?ofkP3om^h02@3om^h30=@m6@@0ooK^00<0e3dI0?ofkP3om^h0>P3om^h0
0`000000ooK^0?ofkP0G0?ofkP40oooo000Z0?ofkP030000003om^h0ooK^01L0ooK^00<000000?of
kP3om^h0<P3om^h203eIZ`D0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`040?ofkP0303eIZ`3om^h0
ooK^00L0ooK^00<0?EV[0=@m6@3D?AT0103D?AT60?ofkPD0e3dI00<000000358U@0aB9D0100aB9D2
000000L0<DRE00<0000003I@Y@3D?AT00P3D?AT403I@Y@8000001@0fD:D010000000>eRb00000000
000603]H/P80000000L0>eRb0=@m6@0kF;80>eRb0000000kF;8000000080?eno0`3D?AT303mO_`03
0000000oGkl0?eno0080?eno00<0000003mO_`0oGkl00P00000204AVbP0;0=@m6@14I/X0000004AV
bP000000A6K:0000003oCB0000000?m=800000000P3oCB001`000000oddP03eIZ`0mFJ/0oddP0000
000mFJ/00P3oCB000`000000oddP0?m=800300000080od`P00D000000?m<803oC200od`P00000003
0?m<8080?EV[1@3oC2000`000000od`P0?m<80030?m<808000000P3oC2000`0mFJ/0000000000003
0?m<808000000P3oBal400000080CGGN00@000000=@m6@3D?AT0e3dI1@3om^h00`3D?AT0ooK^0?of
kP0<0?ofkP80e3dI4`3om^h00`3D?AT0ooK^0?ofkP050?ofkP<0e3dI2P3om^h00`3D?AT0ooK^0?of
kP0A0?ofkP030=@m6@3om^h0ooK^00`0ooK^0`3D?AT00`3om^h0e3dI0?ofkP0i0?ofkP8000006P3o
m^h10?ooo`00:@3om^h00`000000ooK^0?ofkP0G0?ofkP030000003om^h0ooK^0380ooK^0P0mFJ/6
0?ofkP0403eIZ`3om^h0ooK^03eIZ`D0ooK^00<0?EV[0?ofkP3om^h01P3om^h01@0mFJ/0ooK^0?of
kP0mFJ/0ooK^00H0e3dI1P3om^h30=@m6@P0<DRE00<000000358U@0aB9D00`0aB9D010000000=U2U
0=@m6@3D?AT203I@Y@@0e3dI0P0fD:D01@000000=U2U03I@Y@0fD:D0000000@0>eRb00<0000003]H
/P0kF;801@0kF;800`3D?AT0>eRb03]H/P0203]H/P030000000oGkl0?eno00@0?eno103D?AT00`00
0000?eno03mO_`0203mO_`80000000@0A6K:00000014I/X0e3dI0P14I/X030000000A6K:04AVbP00
0000A6K:0000003oCB0000000?m=80000000oddP00000080oddP00<0000003eIZ`0mFJ/00`3oCB00
10000000oddP0?m=800000020?m=80<000000P3oC2001P000000od`P0?m<803oC200?EV[000000@0
od`P0P0000040?m<808000000P3oC20203eIZ`030000003oC200od`P00D0od`P100000000`1=MMh0
000000000002000000030=@m6@3om^h0ooK^00<0e3dI0P3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP03
0=@m6@3om^h0e3dI0180ooK^00<0e3dI0?ofkP3om^h02@3om^h30=@m6@L0ooK^00<0e3dI0?ofkP3o
m^h04@3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP80e3dI>@3om^h00`000000ooK^0?ofkP0J0?ofkP40
oooo000Y0?ofkP030000003om^h0ooK^01L0ooK^00<000000?ofkP3om^h0<P3om^h00`0mFJ/0ooK^
0?ofkP050?ofkP0303eIZ`3om^h0?EV[00H0ooK^00<0?EV[0?ofkP3om^h01@3om^h01@0mFJ/0ooK^
0?ofkP3om^h0?EV[00D0ooK^1@3D?AT30?ofkP030=@m6@3om^h0000000<0e3dI0P0aB9D0103D?AT0
<DRE0358U@0aB9D2000000050358U@000000000003I@Y@3D?AT00P0fD:D2000000@0=U2U0`3D?AT2
0000000303I@Y@000000>eRb00@0>eRb0P00000403]H/P070=@m6@0kF;8000000000000kF;800000
03mO_`02000000D0?eno00<0000003mO_`0oGkl00`3D?AT303mO_`0500000014I/X0A6K:0000003D
?AT00`14I/X040000000A6K:00000014I/X000000?m=80000000oddP0000003oCB0000000?m=8000
0000?EV[0?m=8000000303eIZ`80oddP00D000000?m=803oCB00oddP000000020?m=80<000000P3o
C2000`0mFJ/000000?m<80020?m<80800000103oC202000000<0od`P00<0?EV[0000003oC2001@3o
C2050000000304eegP000000000000@0000000<0e3dI0?ofkP3om^h00`3om^h30=@m6@d0ooK^00<0
e3dI0?ofkP3D?AT04P3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP80e3dI1@3om^h00`3D?AT0ooK^0?of
kP0@0?ofkP030=@m6@3om^h0ooK^0140ooK^00<0e3dI0?ofkP3om^h0=@3om^h2000001d0ooK^0@3o
ool002T0ooK^00<000000?ofkP3om^h05P3om^h00`000000ooK^0?ofkP0c0?ofkP0303eIZ`3om^h0
ooK^00D0ooK^00<0?EV[0?ofkP0mFJ/01`3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0
ooK^00<0ooK^00<0?EV[0?ofkP3om^h01@3om^h70=@m6@80ooK^0P0000030=@m6@D0<DRE00@00000
03I@Y@3D?AT0e3dI1@0fD:D2000000D0=U2U103D?AT703]H/P8000000P0kF;801@3D?AT0>eRb03]H
/P0kF;80000000@0?eno0P00000403mO_`030000000oGkl0?eno0080?eno103D?AT010000000A6K:
0=@m6@00000404AVbP0>00000014I/X000000000003oCB0000000?m=80000000oddP0000003oCB00
?EV[0?m=800000030?m=80040000000mFJ/0?EV[03eIZ`80oddP00D000000?m=803oCB00oddP0000
00020?m=80030000000mFJ/0e3dI0080od`P0P0000040?m<808000000`3oC2000`000000?EV[0?m<
80040?m<80<0000000@0CgSV000000000000CGGN0P0000001P1=MMh0000000000015JlP000000=@m
6@P0ooK^1@3D?AT80?ofkP040=@m6@3om^h0ooK^0=@m6A40ooK^00<0e3dI0?ofkP3om^h03`3om^h3
0=@m6@030?ofkP3D?AT0ooK^0180ooK^00<0e3dI0?ofkP3om^h0403om^h00`3D?AT0ooK^0?ofkP0e
0?ofkP030000003om^h0ooK^01d0ooK^0@3oool002T0ooK^00<000000?ofkP3om^h05@3om^h00`00
0000ooK^0?ofkP0d0?ofkP0303eIZ`3om^h0ooK^00D0ooK^0P0mFJ/80?ofkP0303eIZ`3om^h0ooK^
0080ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3D?AT0e3dI
00<0e3dI0P3om^h00`000000<DRE0358U@030=@m6@050358U@000000e3dI0=@m6@000000200fD:D2
000000@0=U2U00<0000003]H/P0kF;800`3D?AT603]H/P030000003D?AT0>eRb0080>eRb00@00000
03mO_`0000000000100oGkl2000000<0?eno0P00000303mO_`0300000014I/X0A6K:00<0e3dI00T0
A6K:00000014I/X0000004AVbP000000A6K:00000014I/X00P000000203oCB0000000?m=80000000
oddP03eIZ`3oCB0000000P3oCB001@000000oddP0?m=80000000oddP00<0?EV[0P3oCB001@000000
oddP0?m=80000000?EV[0080oddP0P000000103D?AT0od`P0?m<803oC202000000<0od`P0P000000
0`0mFJ/0od`P0?m<80020?m<8080000000D0CgSV000000000000000004eegP0200000080?EV[0P00
00000`15JlP000000=@m6@090?ofkP030=@m6@3om^h0ooK^0080ooK^0`3D?AT50?ofkP030=@m6@3o
m^h0e3dI0180ooK^00<0e3dI0?ofkP3om^h04P3om^h30=@m6A40ooK^00<0e3dI0?ofkP3om^h04@3o
m^h00`3D?AT0ooK^0?ofkP0d0?ofkP030000003om^h0ooK^01h0ooK^0@3oool002T0ooK^00<00000
0?ofkP3om^h0503om^h00`000000ooK^0?ofkP0e0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[
0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[
0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP020?ofkPD0e3dI0P0000020358U@@0e3dI0P0fD:D2
000000P0=U2U0P0000000`0fD:D0000003]H/P0403]H/P030000003D?AT0e3dI0080e3dI0P0kF;80
1@3D?AT000000000000kF;80000000@0?eno0P00000403mO_`8000000`0oGkl02@000000?eno0000
0014I/X0000004AVbP3D?AT0A6K:000000030=@m6@0504AVbP000000A6K:00000014I/X00P000000
2@3oCB0000000000003oCB00000003eIZ`000000oddP000000020?m=80030000003oCB0000000080
oddP00<000000?m=803oCB000`0mFJ/00`3oCB00000003eIZ`020?m=808000000P3oCB03000000<0
od`P0P000000103oC200?EV[0?m<803oC2060000000304mhiP000000000000D0000000@0AF_80000
00000000ooK^0`3D?AT60?ofkP030=@m6@3om^h0ooK^00H0ooK^0`3D?AT01@3om^h0e3dI0?ofkP3o
m^h0e3dI0140ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP030=@m6@h0ooK^00<0
e3dI0?ofkP3om^h04@3om^h00`3D?AT0ooK^0?ofkP0b0?ofkP8000008@3om^h10?ooo`00:03om^h0
0`000000ooK^0?ofkP0E0?ofkP030000003om^h0ooK^03D0ooK^00<0?EV[0?ofkP3om^h0103om^h2
03eIZ`T0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`080?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0
?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP050=@m6@040358U@000000=U2U03I@Y@@0e3dI
0P00000803I@Y@8000001`0kF;83000000<0e3dI0P0kF;82000000H0?eno0P00000403mO_`800000
0P0oGkl01P000000A6K:04AVbP14I/X0e3dI00000080A6K:0P0000000`14I/X0e3dI0=@m6@020000
000304AVbP000000000000<0000000X0oddP03eIZ`3oCB0000000?m=80000000oddP0000003oCB00
00000P3oCB000`000000oddP0?m=8002000000030?m=80000000?EV[00D0?EV[00<0oddP00000000
00000`3oCB03000000030=@m6@3oC200?EV[00H000000`1?N>H40000000304eegP000000AF_800<0
000000<0ooK^0=@m6@3om^h00P3om^h20=@m6@@0ooK^00<0e3dI0?ofkP3om^h02@3om^h30=@m6@03
0?ofkP3D?AT0ooK^0100ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP030?ofkP<0
e3dI2`3om^h00`3D?AT0ooK^0?ofkP0@0?ofkP030=@m6@3om^h0ooK^0380ooK^00<000000?ofkP3o
m^h08@3om^h10?ooo`00:03om^h00`000000ooK^0?ofkP0D0?ofkP030000003om^h0ooK^03H0ooK^
00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^03eIZ`0:0?ofkP0303eIZ`3om^h0?EV[00X0ooK^
00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00<0ooK^
103D?AT603I@Y@<0e3dI00<0000003I@Y@0fD:D00`0fD:D00`000000>eRb03]H/P02000000L0>eRb
0P3D?AT00`000000>eRb0=@m6@020=@m6@0303mO_`000000000000H0?eno0P00000403mO_`800000
0P14I/X01@000000e3dI04AVbP14I/X0000000<0A6K:00<0000004AVbP0000000P3D?AT00`000000
B6cE0000000800000080oddP00D000000?m=80000000oddP000000020?m=80080000003oCB000000
0000003oCB00?EV[0?m=800000020?m=80030000000mFJ/0?EV[00<0?EV[00@000000?m=803oCB00
oddP0`0000020=@m6@030000001?N>H0CgSV00D0000000<0CGGN000000000000100000020?ofkP03
0=@m6@3om^h0ooK^00@0ooK^0`3D?AT00`3om^h0e3dI0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00<0
e3dI3`3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^00L0ooK^0P3D?AT80?ofkP03
0=@m6@3om^h0ooK^0140ooK^00<0e3dI0?ofkP3om^h0<03om^h2000002@0ooK^0@3oool002P0ooK^
00<000000?ofkP3om^h04`3om^h00`000000ooK^0?ofkP0g0?ofkP0303eIZ`3om^h0ooK^00<0ooK^
00@0?EV[0?ofkP3om^h0?EV[2@3om^h203eIZ`/0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0
ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00H0ooK^0`3D?AT603I@Y@@0e3dI00<0=U2U0000000k
F;80100kF;83000000<0>eRb00@0e3dI03]H/P0kF;80>eRb0`0000000`0oGkl0e3dI0=@m6@020=@m
6@8000001@0oGkl20000000403mO_`000000A6K:04AVbP80000000<0e3dI04AVbP0000000P14I/X2
00000080A6K:00@0000004AVbP000000A6K:100000001@3oC20000000?m<80000000od`P00@00000
00@0oddP0000003oCB0000000P3oCB000`000000oddP000000020?m=800303eIZ`000000000000<0
00000P3oCB03000000030?m=80000000000000H0000000D0CgSV0=@m6@3D?AT0e3dI04mhiP020000
000404eegP000000000004eegP@000000`3om^h00`3D?AT0ooK^0?ofkP070?ofkP<0e3dI2P3om^h0
1P3D?AT0ooK^0?ofkP3om^h0e3dI0?ofkP<0e3dI303om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m
6@3om^h0ooK^00T0ooK^0`3D?AT50?ofkP030=@m6@3om^h0ooK^0140ooK^00<0e3dI0?ofkP3om^h0
;`3om^h00`000000ooK^0?ofkP0T0?ofkP40oooo000X0?ofkP030000003om^h0ooK^01<0ooK^00<0
00000?ofkP3om^h0=`3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/0
2@3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/02P3om^h00`0mFJ/0
ooK^0?ofkP070?ofkP0303eIZ`3D?AT0e3dI0080e3dI1@0fD:D010000000e3dI0=@m6@3D?AT703]H
/P030000003D?AT0e3dI00@0>eRb00<0000003mO_`0oGkl00`00000203mO_`<0e3dI0P00000403mO
_`8000000`14I/X00`3D?AT000000000000204AVbP80000000P0A6K:00000014I/X0A6K:00000014
I/X0000004Q/e@L0000000D0od`P00000000000000000?m<800300000080oddP0`0000020?m=8004
03eIZ`0000000000000000<0oddP0P000000103oCB00000000000000000304ifi08000000P1?N>H5
000000<0e3dI00<0000004eegP1=MMh0100000030?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI
0?ofkP3D?AT00P3D?AT60?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h00P3om^h3
0=@m6@P0ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP<0e3dI00<0ooK^
0=@m6@3om^h04P3om^h00`3D?AT0ooK^0?ofkP0^0?ofkP8000009`3om^h10?ooo`00:03om^h00`00
0000ooK^0?ofkP0B0?ofkP030000003om^h0ooK^03P0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`04
0?ofkP0303eIZ`3om^h0ooK^00H0ooK^0P0mFJ/=0?ofkP0403eIZ`3om^h0ooK^03eIZ``0ooK^00<0
?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP03000000<0e3dI0P0fD:D010000000>eRb03]H
/P0000040=@m6@80>eRb0P3D?AT203]H/P8000000P0kF;800`000000?eno03mO_`0303mO_`@00000
00D0?eno0=@m6@3D?AT0e3dI0000000203mO_`0600000014I/X0A6K:0000003D?AT000000P14I/X3
0000000304AVbP00000000000080000000D0A6K:00000018K=D0000004Q/e@08000000060?m<8000
000000000?m<80000000od`P0`0000020?m=80040000000mFJ/0000000000080oddP1P0000000`1>
M^@00000000000030000000304mhiP000000000000<000000P1?N>H4000000@0e3dI0P000000103D
?AT0ooK^0?ofkP3D?AT<0?ofkP030=@m6@3om^h0ooK^0080ooK^0`3D?AT30?ofkP050=@m6@3om^h0
ooK^0?ofkP3D?AT0203om^h30=@m6@D0ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?of
kP0@0?ofkP<0e3dI4P3om^h00`3D?AT0ooK^0?ofkP0]0?ofkP030000003om^h0ooK^02L0ooK^0@3o
ool002L0ooK^00<000000?ofkP3om^h04P3om^h00`000000ooK^0?ofkP0i0?ofkP0403eIZ`3om^h0
ooK^03eIZ`D0ooK^00<0?EV[0?ofkP3om^h01@3om^h0100mFJ/0ooK^0?ofkP0mFJ/=0?ofkP80?EV[
3@3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00@0ooK^0P0000000`0fD:D0e3dI
0=@m6@020=@m6@@0>eRb00<000000=@m6@3D?AT00P3D?AT503]H/P@00000200oGkl30000000303mO
_`3D?AT0e3dI0080e3dI00<0000004AVbP3D?AT00P14I/X300000080A6K:0P0000001@14I/X00000
000000000000B6cE00<0000000<0B6cE0000000000001`0000000`3oC20000000?m<800300000005
0?m<80000000000003eIZ`0000000P3oCB090000000404ifi03D?AT0CWKT04ifi0<000001@1?N>H4
0000000504eegP000000000004E[b00000000`3D?AT20?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0
e3dI0?ofkP3om^h01@3om^h30=@m6@@0ooK^00<0e3dI0?ofkP3om^h02@3om^h30=@m6@030?ofkP3D
?AT0ooK^01@0ooK^00<0e3dI0?ofkP3om^h04@3om^h00`3D?AT0ooK^0?ofkP030=@m6@l0ooK^00<0
e3dI0?ofkP3om^h0:`3om^h2000002X0ooK^0@3oool002L0ooK^00<000000?ofkP3om^h04@3om^h0
0`000000ooK^0?ofkP0j0?ofkP0303eIZ`3om^h0?EV[00L0ooK^00<0?EV[0?ofkP3om^h00`3om^h0
1@0mFJ/0ooK^0?ofkP3om^h0?EV[00d0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?of
kP020?ofkP0303eIZ`3om^h0ooK^00L0ooK^100000060=@m6@<0>eRb00<000000=@m6@3D?AT00P3D
?AT2000000<0?eno1000000703mO_`@0000000@0A6K:0=@m6@3D?AT0e3dI0P00000304AVbP<00000
00D0A6K:000000000000000004Q/e@020000000304Q/e@000000000000P0000000<0od`P00000000
00000P000000103oC20000000000000000020?m<80P0000000D0CWKT00000000000000000=@m6@03
000000<0CgSV1`00000204eegP0300000015JlP00000008000000P3om^h40=@m6@`0ooK^00<0e3dI
0?ofkP3om^h01P3om^h00`3D?AT0ooK^0=@m6@020=@m6@030?ofkP3D?AT0ooK^00d0ooK^0`3D?ATC
0?ofkP030=@m6@3om^h0ooK^0180ooK^00<0e3dI0?ofkP3om^h00`3om^h30=@m6@/0ooK^00<0e3dI
0?ofkP3om^h0:`3om^h00`000000ooK^0?ofkP0Z0?ofkP40oooo000W0?ofkP030000003om^h0ooK^
0140ooK^00<000000?ofkP3om^h0>P3om^h00`0mFJ/0ooK^03eIZ`070?ofkP0303eIZ`3om^h0ooK^
0080ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0?EV[
00l0ooK^00@0?EV[0?ofkP3om^h0?EV[3@3om^h20000000403eIZ`000000e3dI0=@m6@L0>eRb0P00
00030=@m6@H0?eno1@00000203mO_`0600000014I/X0A6K:04AVbP000000e3dI0P0000020=@m6@@0
00000P14I/XH000000030?m<80000000000000h0000000<0e3dI0000001?N>H01000000204mhiP80
00000P1=MMh7000000<0ooK^0P3D?AT20?ofkP<0e3dI2@3om^h00`3D?AT0ooK^0?ofkP060?ofkP03
0=@m6@3om^h0ooK^0080ooK^0P3D?AT>0?ofkP030=@m6@3om^h0ooK^00<0e3dI403om^h00`3D?AT0
ooK^0?ofkP0A0?ofkP030=@m6@3om^h0ooK^00L0ooK^0`3D?AT80?ofkP030=@m6@3om^h0ooK^02T0
ooK^0P00000]0?ofkP40oooo000W0?ofkP030000003om^h0ooK^0100ooK^00<000000?ofkP3om^h0
>`3om^h203eIZ`P0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eI
Z`3om^h0ooK^00P0ooK^00@0?EV[0?ofkP3om^h0?EV[3`3om^h00`0mFJ/0ooK^03eIZ`0A0?ofkP03
03eIZ`00000000000080e3dI0P00000303]H/P050000000oGkl0?eno03mO_`000000103D?AT703mO
_`D000000P3D?AT304AVbP8000000`3D?AT00`14I/X000000000000U000000<0CWKT00D0e3dI0000
00000000000004mhiP0500000080CGGN0P0000001@1=MMh0000000000015JlP0000000@0e3dI00<0
ooK^0=@m6@3om^h01@3om^h20=@m6@L0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?of
kP040?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h00`3om^h30=@m6@`0ooK^00<0
e3dI0?ofkP3om^h04P3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP<0e3dI1@3om^h00`3D?AT0ooK^0?of
kP0X0?ofkP030000003om^h0ooK^02d0ooK^0@3oool002L0ooK^00<000000?ofkP3om^h03`3om^h0
0`000000ooK^0?ofkP0l0?ofkP0303eIZ`3om^h0ooK^00L0ooK^00D0?EV[0?ofkP3om^h0ooK^03eI
Z`070?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?of
kP0=0?ofkP0303eIZ`3om^h0ooK^0140ooK^00<0?EV[0?ofkP0mFJ/00P0000000`24:a<000000000
0004000000H0?eno0`3D?AT2000000<0?eno00D0000004AVbP3D?AT0e3dI04AVbP080000000304AV
bP3D?AT0e3dI020000000`3D?AT40000000304ifi03D?AT0000000@00000101?N>H300000080CGGN
00@0000004E[b015JlP000000P3om^h00`000000ooK^0?ofkP030=@m6@L0ooK^0`3D?AT40?ofkP03
0=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP03
0=@m6@3om^h0ooK^00L0ooK^0`3D?AT90?ofkP030=@m6@3om^h0ooK^0140ooK^00<0e3dI0?ofkP3o
m^h03P3om^h30=@m6@030?ofkP3D?AT0ooK^02P0ooK^0P00000`0?ofkP40oooo000W0?ofkP030000
003om^h0ooK^00l0ooK^00<000000?ofkP3om^h0?03om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eI
Z`3om^h0?EV[00P0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eI
Z`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP0mFJ/04`3om^h0100mFJ/0ooK^0?ofkP3om^h600000003
0;`k6P000000000000H0000000<0?eno0=@m6@3D?AT02P00000604AVbR@000000P1>M^@30=@m6@80
CWKT00<0e3dI0000001?N>H01P1?N>H9000000<0ooK^00<000000?ofkP3om^h00P3D?AT0103om^h0
e3dI0=@m6@3D?AT70?ofkP<0e3dI00<0ooK^0=@m6@3om^h01@3om^h00`3D?AT0ooK^0?ofkP050?of
kP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h02`3om^h30=@m6@D0ooK^00<0e3dI0?of
kP3om^h04P3om^h00`3D?AT0ooK^0?ofkP0A0?ofkP80e3dI:03om^h00`000000ooK^0?ofkP0`0?of
kP40oooo000V0?ofkP030000003om^h0ooK^00l0ooK^00<000000?ofkP3om^h0?@3om^h00`0mFJ/0
ooK^0?ofkP080?ofkP80?EV[2P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00D0
ooK^00<0?EV[0?ofkP3om^h02P3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[0140ooK^00<0?EV[0?of
kP0mFJ/01P3om^h:000000030;`k6P000000000003L000000`1>M^@30=@m6@<000000`1?N>H40000
000304eegP000000000000<00000103om^h01@000000ooK^0=@m6@3om^h0e3dI00@0ooK^0`3D?AT7
0?ofkP80e3dI1@3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI
0?ofkP3om^h03P3om^h30=@m6@80ooK^00<0e3dI0?ofkP3om^h04@3om^h00`3D?AT0ooK^0?ofkP0B
0?ofkP030=@m6@3om^h0ooK^02H0ooK^00<000000?ofkP3om^h0<@3om^h10?ooo`009P3om^h00`00
0000ooK^0?ofkP0>0?ofkP030000003om^h0ooK^03l0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0m
FJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0m
FJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h03@3om^h0100m
FJ/0ooK^0?ofkP3om^h203eIZ`P0ooK^00<0000008@[4`0000001P0000000`0mFJ/000000000000F
000000030?U;80000000000001L000001P1>M^@010000000e3dI04mhiP1?N>H30=@m6@@000000`1=
MMh20000000304E[b0000000ooK^00D0ooK^00D000000=@m6@3om^h0ooK^0=@m6@070?ofkP@0e3dI
103om^h40=@m6@80ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m
6@3om^h0ooK^0180ooK^0`3D?ATC0?ofkP030=@m6@3om^h0ooK^0180ooK^00<0e3dI0?ofkP3om^h0
903om^h2000003@0ooK^0@3oool002H0ooK^00<000000?ofkP3om^h03@3om^h00`000000ooK^0?of
kP100?ofkP0303eIZ`3om^h0ooK^00H0ooK^0P0mFJ/<0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/0
2P3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h0
2`3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00P0ooK^100000000`2l>aX0?EV[
0;`k6P080000000303eIZ`000000000000<000001P3UAQh00`0mFJ/000000000000200000080nD/P
3`0000000`1;LMh0000000000002000000<0CWKT1@0000020=@m6@@000000P1?N>H30=@m6@@00000
00<0AF_80000000000001`3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00/0ooK^0`3D?AT00`3om^h0
e3dI0?ofkP020?ofkP<0e3dI203om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^01<0
ooK^00<0e3dI0?ofkP3om^h00`3D?AT?0?ofkP030=@m6@3om^h0ooK^0180ooK^00<0e3dI0?ofkP3o
m^h0903om^h00`000000ooK^0?ofkP0d0?ofkP40oooo000V0?ofkP030000003om^h0ooK^00d0ooK^
00<000000?ofkP3om^h0@03om^h00`0mFJ/0ooK^0?ofkP050?ofkP0403eIZ`3om^h0ooK^03eIZ`/0
ooK^00@0?EV[0?ofkP3om^h0?EV[303om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^
00L0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^
00X0ooK^00<0000003eIZ`0000002P00000203eIZ`P0000000<0?EV[0000003UAQh00P3UAQh40000
00040?U;8000000000000?U;80h0000000<0CWKT0000000000000P00000304ifi0040=@m6@1?N>H0
CgSV04mhiPL0000000<0CGGN0=@m6@3D?AT00P3D?AT2000000L0ooK^00<0e3dI0000003om^h00P3o
m^h00`3D?AT0ooK^0?ofkP0<0?ofkP<0e3dI0P3om^h00`3D?AT0ooK^0?ofkP040=@m6@@0ooK^00<0
e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^00<0ooK^0`3D
?AT<0?ofkP030=@m6@3om^h0ooK^0180ooK^00<0e3dI0?ofkP3om^h08P3om^h2000003L0ooK^0@3o
ool002H0ooK^00<000000?ofkP3om^h0303om^h00`000000ooK^0?ofkP110?ofkP0303eIZ`3om^h0
ooK^00D0ooK^00@0?EV[0?ofkP3om^h0?EV[303om^h203eIZ`d0ooK^00<0?EV[0?ofkP3om^h0103o
m^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h0203o
m^h203eIZ`X0ooK^00<0?EV[0?ofkP3om^h03000000203eIZ`<000000P3UAQh00`0mFJ/000000000
000400000080iDHN0`000000103iBb0000000000003iBb070000000304]agP00000000000080CWKT
10000000101>M^@000000000003D?AT4000000<0CgSV00<0000004eegP1=MMh00P1=MMh300000004
04E[b03D?AT0e3dI0=@m6@H0ooK^00<0e3dI0000003om^h00`3om^h00`3D?AT0ooK^0?ofkP0<0?of
kP030=@m6@3om^h0e3dI0080e3dI1P3om^h30=@m6@030?ofkP3D?AT0ooK^00P0ooK^00<0e3dI0?of
kP3om^h04`3om^h00`3D?AT0ooK^0?ofkP070?ofkP<0e3dI203om^h00`3D?AT0ooK^0?ofkP0B0?of
kP030=@m6@3om^h0ooK^0280ooK^00<000000?ofkP3om^h0=`3om^h10?ooo`009@3om^h00`000000
ooK^0?ofkP0<0?ofkP030000003om^h0ooK^04<0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0
ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0
ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0
ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h01@3om^h:00000080
?EV[0P000000100mFJ/000000>E67P3D?AT2000000<0iDHN0`0000001@3UAQh00000000000000000
nD/P0080000000@0nD/P000000000000Bg7N0P0000020=@m6@800000101>M^@00`000000e3dI0=@m
6@03000000D0CgSV1P0000000`15JlP00000000000060=@m6@80ooK^00<0e3dI0?ofkP000000103o
m^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0e3dI0080ooK^0`3D?AT60?ofkP@0e3dI1P3o
m^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^00/0ooK^0`3D?AT50?ofkP030=@m6@3o
m^h0ooK^0180ooK^00<0e3dI0?ofkP3om^h0803om^h2000003X0ooK^0@3oool002D0ooK^00<00000
0?ofkP3om^h02`3om^h00`000000ooK^0?ofkP140?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[
0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0?EV[00l0ooK^00@0?EV[
0?ofkP3om^h0?EV[3P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0
?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0308@[4`00000000000080_3/J00<0
e3dI0;`k6P0mFJ/00P0mFJ/3000000<0iDHN0P0000001P3UAQh000000>E67P3UAQh000000>E67PP0
000000@0CWKT0000001>M^@00000103D?AT010000000CWKT0=@m6@00000404mhiPH000000P1=MMh5
000000030=@m6@3om^h0ooK^0080ooK^1@3D?AT00`3om^h000000?ofkP030?ofkP030=@m6@3om^h0
ooK^00`0ooK^0P3D?AT60?ofkP<0e3dI103om^h00`3D?AT0ooK^0?ofkP040=@m6@80ooK^00<0e3dI
0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP<0e3dI00<0ooK^0=@m6@3om^h04`3om^h0
0`3D?AT0ooK^0?ofkP0P0?ofkP030000003om^h0ooK^03X0ooK^0@3oool002D0ooK^00<000000?of
kP3om^h02`3om^h00`000000ooK^0?ofkP140?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/01`3om^h0
0`0mFJ/0ooK^0?ofkP060?ofkP0403eIZ`3om^h0ooK^03eIZ`l0ooK^00<0?EV[0?ofkP0mFJ/0403o
m^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[0140ooK^0P0mFJ/30?ofkP0303eIZ`3om^h0ooK^00h0ooK^
1@0000000`0mFJ/0_3/J0;`k6P0403eIZ`8000000P3UAQh020000000iDHN0>E67P000000iDHN0000
003UAQh0?EV[0P0000000`3UAQh00000000000020000000404ifi0000000CWKT04ifi080000000<0
CWKT0=@m6@3D?AT01000000404mhiP80000000H0CGGN000000000000000003eIZ`15JlP200000003
0?ofkP3D?AT0ooK^00D0ooK^1P3D?AT30?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3o
m^h0203om^h30=@m6@030?ofkP3D?AT0ooK^00D0ooK^0`3D?ATD0?ofkP030=@m6@3om^h0ooK^0180
ooK^0`3D?ATC0?ofkP030=@m6@3om^h0ooK^01h0ooK^0P00000m0?ofkP40oooo000U0?ofkP030000
003om^h0ooK^00X0ooK^00<000000?ofkP3om^h0A@3om^h0100mFJ/0ooK^0?ofkP0mFJ/80?ofkP03
03eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP03
03eIZ`3om^h0ooK^0100ooK^00<0?EV[0?ofkP0mFJ/0503om^h00`0mFJ/0ooK^03eIZ`0D0?ofkP03
0000000mFJ/0000000@000000P2l>aX303eIZ`80000000d0iDHN0=@m6@000000iDHN0000000mFJ/0
iDHN0000003UAQh000000>E67P000000iDHN0080000000<0CWKT0000001>M^@00P1>M^@010000000
e3dI0000001?N>H30=@m6@L000000P0mFJ/00`15JlP00000000000030?ofkP030=@m6@3om^h0ooK^
0080ooK^0P3D?AT40?ofkPH0e3dI3P3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP80e3dI1P3om^h00`3D
?AT0ooK^0?ofkP030=@m6A00ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP040=@m
6@h0ooK^00<0e3dI0?ofkP3om^h07P3om^h00`000000ooK^0?ofkP0m0?ofkP40oooo000U0?ofkP03
0000003om^h0ooK^00T0ooK^00<000000?ofkP3om^h0A`3om^h00`0mFJ/0ooK^03eIZ`090?ofkP03
03eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP03
03eIZ`3om^h0?EV[0180ooK^00<0?EV[0?ofkP3om^h0503om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP03
03eIZ`3om^h0ooK^00P0000000<0_3/J03eIZ`0mFJ/00P0mFJ/20000000<03eIZ`000000iDHN0000
003UAQh000000>E67P000000iDHN0000001>M^@000000`1>M^@20=@m6@80CgSV0`000000101?N>H0
e3dI0=@m6@3D?AT404eegP@00000103om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00H0ooK^00@00000
0?ofkP3om^h0ooK^1@3D?AT:0?ofkP030=@m6@3om^h0e3dI00d0ooK^00<0e3dI0?ofkP3om^h00`3o
m^h00`3D?AT0ooK^0?ofkP040?ofkP<0e3dI3@3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3o
m^h0ooK^00@0ooK^0`3D?AT;0?ofkP030=@m6@3om^h0ooK^01`0ooK^0P0000100?ofkP40oooo000T
0?ofkP030000003om^h0ooK^00X0ooK^00<000000?ofkP3om^h0A`3om^h203eIZ`X0ooK^00<0?EV[
0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00X0ooK^00D0?EV[
0?ofkP3om^h0ooK^03eIZ`0@0?ofkP0303eIZ`3om^h0?EV[01@0ooK^00@0?EV[0?ofkP0mFJ/0?EV[
4P3om^h00`0mFJ/0ooK^0?ofkP040?ofkP80000000D0Q2/C000000000000_3/J0=@m6@0200000003
0;`k6P0mFJ/0?EV[00<0?EV[0P000000203UAQh000000>E67P000000iDHN0000001>M^@000000P3D
?AT00`000000CgSV04mhiP0404mhiP80000000<0?EV[0000003D?AT00`3D?AT00`000000AF_80000
00060?ofkP030=@m6@3om^h0e3dI00L0ooK^00<000000?ofkP3om^h00P3om^h00`3D?AT0ooK^0=@m
6@040=@m6@H0ooK^00@0e3dI0?ofkP3om^h0e3dI3@3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m
6@3om^h0ooK^00P0ooK^0`3D?AT90?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h0
203om^h40=@m6@H0ooK^00<0e3dI0?ofkP3om^h0703om^h00`000000ooK^0?ofkP100?ofkP40oooo
000T0?ofkP030000003om^h0ooK^00T0ooK^00<000000?ofkP3om^h0B03om^h00`0mFJ/0ooK^0?of
kP0:0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/0203om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eI
Z`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h0303om^h0100mFJ/0ooK^0?ofkP3om^h203eIZa40
ooK^00<0?EV[0?ofkP3om^h00P3om^h203eIZ`l0ooK^00<0?EV[0?ofkP3om^h0203om^h500000080
_3/J00<0?EV[0000002l>aX00P2l>aX603eIZ`040=@m6@3UAQh0000004ifi080000000<0CgSV0000
00000000101?N>H00`000000CGGN04eegP0304eegP0300000015JlP0e3dI0080e3dI1P3om^h20=@m
6@P0ooK^00<000000?ofkP3om^h00`3om^h0103D?AT0ooK^0?ofkP3om^h50=@m6@80ooK^00D0e3dI
0?ofkP3om^h0ooK^0=@m6@0>0?ofkP040=@m6@3om^h0ooK^0=@m6@h0ooK^0`3D?AT50?ofkP030=@m
6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h03@3om^h40=@m6@80ooK^00<0e3dI0?ofkP3om^h0
6P3om^h2000004<0ooK^0@3oool002@0ooK^00<000000?ofkP3om^h0203om^h00`000000ooK^0?of
kP190?ofkP0303eIZ`3om^h0ooK^00X0ooK^00@0?EV[0?ofkP3om^h0?EV[2P3om^h00`0mFJ/0ooK^
0?ofkP060?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^
0?ofkP040?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h01@3om^h203eIZ`/0ooK^
0P0mFJ/=0?ofkP0803eIZ`3om^h000000000000mFJ/000000=@m6@0000020;`k6P050000002l>aX0
_3/J0000002l>aX01000000204ifi0040000001?N>H0CgSV04mhiP8000000P1?N>H00`000000CGGN
04eegP0204eegP0400000015JlP0000000000080ooK^0`3D?AT20?ofkP80e3dI2@3om^h00`000000
ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00@0ooK^1@3D?AT30?ofkP030=@m6@3om^h0ooK^00`0
ooK^00<0e3dI0?ofkP3D?AT04P3om^h30=@m6@80ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0
ooK^0?ofkP0A0?ofkP80e3dI703om^h00`000000ooK^0?ofkP130?ofkP40oooo000T0?ofkP030000
003om^h0ooK^00L0ooK^00<000000?ofkP3om^h0B`3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP80?EV[
303om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h0
203om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h0
203om^h203eIZ`P0ooK^00<0?EV[0?ofkP3om^h03@3om^h0100mFJ/0ooK^0?ofkP0mFJ/20?ofkPD0
000000L0e3dI0;`k6P2l>aX000000;`k6P000000_3/J00<0000000<0e3dI0000001?N>H00`1?N>H:
000000H0ooK^0`3D?AT00`3om^h0e3dI0?ofkP070?ofkP030000003om^h0ooK^00<0ooK^00<0e3dI
0?ofkP3om^h01P3om^h00`3D?AT0ooK^0=@m6@040=@m6@h0ooK^00<0e3dI0?ofkP3D?AT05@3om^h3
0=@m6A@0ooK^00<0e3dI0?ofkP3om^h04P3om^h00`3D?AT0ooK^0?ofkP0I0?ofkP800000AP3om^h1
0?ooo`00903om^h00`000000ooK^0?ofkP070?ofkP030000003om^h0ooK^04/0ooK^00<0?EV[0?of
kP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?of
kP3om^h0203om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00P0ooK^0P0mFJ/:0?of
kP0303eIZ`3om^h0ooK^00/0ooK^0P0mFJ/50?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?of
kP0mFJ/01@3om^h0100mFJ/0000000000024:a<300000080_3/J00D0?EV[0;`k6P2l>aX0000004mh
iP040=@m6@800000101=MMh010000000AF_80000000000060?ofkP80e3dI0P3om^h30=@m6@L0ooK^
00<000000?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP040?ofkP80e3dI1@3om^h50=@m6@/0ooK^
0P3D?ATF0?ofkP030=@m6@3om^h0ooK^00<0e3dI403om^h00`3D?AT0ooK^0?ofkP0B0?ofkP030=@m
6@3om^h0ooK^01T0ooK^00<000000?ofkP3om^h0AP3om^h10?ooo`008`3om^h00`000000ooK^0?of
kP070?ofkP030000003om^h0ooK^04d0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^03eI
Z`0=0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?of
kP050?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?of
kP0>0?ofkP80?EV[0P3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00D0
?EV[0?ofkP3om^h0?EV[0?ofkP040000000303eIZ`000000_3/J0080_3/J00D0000004mhiP1?N>H0
CgSV000000040=@m6@@0000000<0e3dI0?ofkP3om^h00`3om^h20=@m6@H0ooK^1@3D?AT30?ofkP03
0000003om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP060?ofkP03
0=@m6@3om^h0e3dI00D0e3dI1`3om^h00`3D?AT0ooK^0?ofkP0D0?ofkP030=@m6@3om^h0ooK^00@0
ooK^0`3D?AT=0?ofkP030=@m6@3om^h0ooK^0180ooK^00<0e3dI0?ofkP3om^h0603om^h00`000000
ooK^0?ofkP170?ofkP40oooo000S0?ofkP030000003om^h0ooK^00H0ooK^00<000000?ofkP3om^h0
CP3om^h00`0mFJ/0ooK^0?ofkP070?ofkP0403eIZ`3om^h0ooK^03eIZ`h0ooK^00@0?EV[0?ofkP3o
m^h0?EV[3P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?of
kP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP<0?EV[403om^h303eIZ`@0ooK^00D0?EV[0?of
kP3om^h0ooK^03eIZ`030?ofkP030000000mFJ/0Q2/C00@0000000@0_3/J0000001?N>H000000P1=
MMh3000000H0e3dI0P3om^h20=@m6@P0ooK^00@0e3dI0?ofkP3om^h0ooK^103D?AT00`000000ooK^
0?ofkP040?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT02P3om^h0103D?AT0ooK^0?ofkP3om^h70=@m
6@80ooK^0P3D?ATE0?ofkP030=@m6@3om^h0ooK^00P0ooK^0`3D?AT90?ofkP030=@m6@3om^h0ooK^
0180ooK^00<0e3dI0?ofkP3om^h05`3om^h2000004X0ooK^0@3oool002<0ooK^00<000000?ofkP3o
m^h01P3om^h00`000000ooK^0?ofkP1?0?ofkP0303eIZ`3om^h0ooK^00H0ooK^00D0?EV[0?ofkP3o
m^h0ooK^03eIZ`0=0?ofkP0303eIZ`3om^h0?EV[0100ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0@
0?ofkP80?EV[0`3om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^00@0?EV[2`3om^h0
100mFJ/0ooK^0?ofkP0mFJ/30?ofkP0303eIZ`3om^h0ooK^0080ooK^00D0?EV[0?ofkP3om^h0ooK^
03eIZ`020?ofkP0303eIZ`000000000000@0000000H0CGGN0=@m6@3D?AT0CGGN00000015JlP20000
00030?ofkP3D?AT0e3dI00@0e3dI2P3om^h00`3D?AT0ooK^0?ofkP040?ofkP<0e3dI103om^h0103D
?AT0ooK^0=@m6@3D?AT;0?ofkP030=@m6@3om^h0ooK^00@0ooK^1`3D?AT00`3om^h0e3dI0?ofkP0B
0?ofkP030=@m6@3om^h0ooK^00`0ooK^0`3D?AT50?ofkP030=@m6@3om^h0ooK^0180ooK^00<0e3dI
0?ofkP3om^h05`3om^h00`000000ooK^0?ofkP1:0?ofkP40oooo000S0?ofkP030000003om^h0ooK^
00D0ooK^00<000000?ofkP3om^h0D03om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^
0080ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0303eIZ`3om^h0?EV[
01<0ooK^00<0?EV[0?ofkP0mFJ/0503om^h00`0mFJ/0ooK^0?ofkP050?ofkP<0?EV[1`3om^h01P0m
FJ/0ooK^0?ofkP3om^h0?EV[0?ofkP80?EV[1@3om^h0100mFJ/0ooK^03eIZ`0mFJ/20?ofkP0303eI
Z`3om^h0?EV[00<0ooK^0`0mFJ/00`000000e3dI0=@m6@050=@m6@<0ooK^00<0e3dI0?ofkP3D?AT0
0`3D?AT70?ofkP030=@m6@3om^h0ooK^00@0ooK^00<000000?ofkP3om^h0103D?AT00`3om^h0e3dI
0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00P0ooK^1P3D?ATA0?ofkP030=@m6@3om^h0ooK^0100ooK^
0`3D?AT20?ofkP030=@m6@3om^h0ooK^0140ooK^00<0e3dI0?ofkP3om^h05P3om^h2000004d0ooK^
0@3oool002<0ooK^00<000000?ofkP3om^h0103om^h00`000000ooK^0?ofkP1B0?ofkP0303eIZ`3o
m^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3o
m^h0?EV[0180ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP0303eIZ`3o
m^h0ooK^00T0ooK^100mFJ/20?ofkP0303eIZ`3om^h0ooK^0080ooK^0P0mFJ/70?ofkP80?EV[0`3o
m^h00`0mFJ/0ooK^0?ofkP0703eIZ`80000000<0?EV[0?ofkP3om^h0103D?AT30?ofkP040=@m6@3o
m^h0ooK^0?ofkP@0e3dI1@3om^h00`3D?AT0ooK^0?ofkP030?ofkP030000003om^h0ooK^00<0ooK^
103D?AT<0?ofkP030=@m6@3om^h0ooK^00L0ooK^00@0e3dI0?ofkP3om^h0ooK^0P3D?AT0103om^h0
e3dI0=@m6@3D?AT>0?ofkP030=@m6@3om^h0ooK^01<0ooK^0`3D?ATC0?ofkP030=@m6@3om^h0ooK^
01D0ooK^00<000000?ofkP3om^h0C@3om^h10?ooo`008P3om^h00`000000ooK^0?ofkP040?ofkP03
0000003om^h0ooK^05<0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP060?ofkP03
03eIZ`3om^h0ooK^00P0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0@0?ofkP0303eIZ`3om^h0?EV[
01<0ooK^00@0?EV[0?ofkP0mFJ/0?EV[4@3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkPP0?EV[203om^h0
0`0mFJ/0ooK^0?ofkP0603eIZ`030?ofkP0mFJ/0ooK^0080?EV[0P3om^h00`0mFJ/0ooK^0?ofkP04
0?ofkP<0e3dI0P3om^h00`3D?AT0ooK^0?ofkP030?ofkP@0e3dI0`3om^h00`3D?AT0ooK^0?ofkP03
0?ofkP030000003om^h0ooK^0080e3dI0P3om^h50=@m6@X0ooK^00<0e3dI0?ofkP3om^h01@3om^h0
0`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^0080ooK^0`3D?AT:0?ofkP030=@m6@3om^h0
ooK^01@0ooK^00<0e3dI0?ofkP3om^h0103D?AT>0?ofkP030=@m6@3om^h0ooK^01@0ooK^0P00001@
0?ofkP40oooo000R0?ofkP030000003om^h0ooK^00@0ooK^00<000000?ofkP3om^h0E03om^h0100m
FJ/0ooK^0?ofkP0mFJ/90?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h00`3om^h0
0`0mFJ/0ooK^0?ofkP0<0?ofkP0403eIZ`3om^h0ooK^0?ofkP80?EV[403om^h00`0mFJ/0ooK^0?of
kP020?ofkP80?EV[3P3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00@0ooK^300m
FJ/40?ofkP0403eIZ`3om^h0?EV[0?ofkP80?EV[00<0ooK^03eIZ`0mFJ/02P3om^h40=@m6@L0ooK^
1@3D?AT50?ofkP030000003D?AT0e3dI00D0ooK^00<0e3dI0?ofkP3om^h0103D?AT70?ofkP030=@m
6@3om^h0ooK^00<0ooK^0P3D?AT70?ofkP030=@m6@3om^h0ooK^00@0ooK^0`3D?AT60?ofkP030=@m
6@3om^h0ooK^01@0ooK^00<0e3dI0?ofkP3om^h01@3om^h30=@m6@X0ooK^00<0e3dI0?ofkP3om^h0
503om^h00`000000ooK^0?ofkP1@0?ofkP40oooo000R0?ofkP030000003om^h0ooK^00<0ooK^00<0
00000?ofkP3om^h0E@3om^h0100mFJ/0ooK^0?ofkP0mFJ/:0?ofkP0303eIZ`3om^h0ooK^00D0ooK^
00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00@0ooK^
00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP050?ofkP80?EV[2`3om^h00`0mFJ/0ooK^
0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h0103om^h203eIZ`030?of
kP0mFJ/0ooK^00<0ooK^00<0?EV[0?ofkP0mFJ/00P0mFJ/0103om^h0?EV[03eIZ`0mFJ/>0?ofkP@0
e3dI1`3om^h40=@m6@80ooK^0P3D?AT70?ofkP030=@m6@3om^h0ooK^00<0ooK^1@3D?AT30?ofkP03
0=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP070?ofkP<0
e3dI0P3om^h00`3D?AT0ooK^0?ofkP0D0?ofkP030=@m6@3om^h0ooK^00T0ooK^0`3D?AT60?ofkP03
0=@m6@3om^h0ooK^01<0ooK^0P00001C0?ofkP40oooo000R0?ofkP030000003om^h0ooK^0080ooK^
00<000000?ofkP3om^h0E`3om^h203eIZ``0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^
0?ofkP070?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^
0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00P0ooK^0P0mFJ/80?ofkP0303eIZ`3om^h0ooK^00l0ooK^
00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0403eIZ`3om^h0?EV[03eIZ`D0
ooK^0`0mFJ/20?ofkP80?EV[4`3om^h40=@m6@D0ooK^1P3D?AT00`000000ooK^0?ofkP060?ofkP03
0=@m6@3om^h0ooK^00D0ooK^1@3D?AT01@3om^h0e3dI0?ofkP3om^h0e3dI00X0ooK^00<0e3dI0?of
kP3om^h02P3om^h30=@m6AD0ooK^00<0e3dI0?ofkP3om^h03@3om^h40=@m6@80ooK^00<0e3dI0?of
kP3om^h04P3om^h00`000000ooK^0?ofkP1C0?ofkP40oooo000R0?ofkP050000003om^h0ooK^0?of
kP000000FP3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?of
kP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00P0ooK^0P0mFJ/80?of
kP80?EV[3@3om^h203eIZ`D0ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP070?of
kP0303eIZ`3om^h0ooK^0080ooK^00@0?EV[0?ofkP3om^h0?EV[1@3om^h303eIZ`80ooK^0P0mFJ/H
0?ofkPD0e3dI0`3om^h00`3D?AT0ooK^0=@m6@030=@m6@H0ooK^00<0e3dI0?ofkP3om^h0203om^h6
0=@m6@/0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP030=@m6A40ooK^00<0e3dI
0?ofkP3om^h04P3om^h20=@m6A<0ooK^0P00001F0?ofkP40oooo000R0?ofkP050000003om^h0ooK^
0?ofkP000000F`3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0403eIZ`3om^h0ooK^03eIZ`d0ooK^00<0
?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0
?EV[0?ofkP3om^h03`3om^h203eIZ`80ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?of
kP080?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/00P3om^h203eIZ`@0ooK^0`0mFJ/0103om^h0?EV[
03eIZ`0mFJ/L0?ofkP@0e3dI0P3om^h00`3D?AT0ooK^000000020?ofkP@0e3dI0`3om^h00`3D?AT0
ooK^0?ofkP0:0?ofkPD0e3dI2P3om^h00`3D?AT0ooK^0?ofkP070?ofkP80e3dI1P3om^h30=@m6@h0
ooK^00<0e3dI0?ofkP3om^h04P3om^h00`3D?AT0ooK^0?ofkP0A0?ofkP030000003om^h0ooK^05H0
ooK^0@3oool00240ooK^00D000000?ofkP3om^h0ooK^0000001L0?ofkP0303eIZ`3om^h0ooK^00/0
ooK^00<0?EV[0?ofkP0mFJ/03`3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00`0
ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP<0?EV[403om^h00`0mFJ/0
ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^0080?EV[0P3om^h203eIZ`@0ooK^00<0?EV[0?ofkP0m
FJ/00P0mFJ/00`3om^h0?EV[0?ofkP0O0?ofkPD0e3dI00<000000?ofkP3om^h00`3om^h50=@m6@T0
ooK^0`3D?AT00`3om^h0e3dI0?ofkP050=@m6@L0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0
ooK^0?ofkP090?ofkP<0e3dI2P3om^h00`3D?AT0ooK^0?ofkP0B0?ofkP030=@m6@3om^h0ooK^0100
ooK^0P00001I0?ofkP40oooo000Q0?ofkP040000003om^h0ooK^000005h0ooK^00<0?EV[0?ofkP3o
m^h02`3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/0403om^h203eI
Z`030?ofkP0mFJ/0ooK^01@0ooK^00<0?EV[0?ofkP3om^h0100mFJ/;0?ofkP0303eIZ`3om^h0ooK^
00T0ooK^00<0?EV[0?ofkP0mFJ/00`3om^h00`0mFJ/0ooK^03eIZ`030?ofkP0403eIZ`3om^h0?EV[
03eIZ`80ooK^00<0?EV[0?ofkP3om^h08`3om^h30=@m6@P0ooK^103D?AT30?ofkP<0e3dI1@3om^h0
0`3D?AT0ooK^0?ofkP020?ofkPD0e3dI0`3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0
ooK^00d0ooK^0`3D?AT60?ofkP030=@m6@3om^h0ooK^0180ooK^00<0e3dI0?ofkP3om^h0403om^h0
0`000000ooK^0?ofkP1I0?ofkP40oooo000Q0?ofkP040000003om^h0ooK^000005l0ooK^00<0?EV[
0?ofkP3om^h02@3om^h00`0mFJ/0ooK^03eIZ`0A0?ofkP0303eIZ`3om^h0?EV[01<0ooK^00<0?EV[
0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP050?ofkP<0?EV[1`3om^h00`0mFJ/0ooK^0?ofkP0:
0?ofkP80?EV[0P3om^h203eIZ`80ooK^00<0?EV[0?ofkP3om^h0100mFJ/20?ofkP0303eIZ`3om^h0
ooK^02D0ooK^00<000000?ofkP3D?AT00`3D?AT60?ofkPD0e3dI203om^h00`3D?AT0ooK^0?ofkP05
0?ofkPD0e3dI00<0ooK^0=@m6@3om^h00`3om^h20=@m6A<0ooK^0`3D?AT20?ofkP030=@m6@3om^h0
ooK^0180ooK^00<0e3dI0?ofkP3om^h0403om^h00`000000ooK^0?ofkP1J0?ofkP40oooo000Q0?of
kP030000003om^h000000600ooK^00<0?EV[0?ofkP3om^h0203om^h01@0mFJ/0ooK^0?ofkP3om^h0
?EV[0140ooK^00<0?EV[0?ofkP3om^h04@3om^h0100mFJ/0ooK^03eIZ`0mFJ/B0?ofkP0303eIZ`3o
m^h0ooK^00T0ooK^100mFJ/20?ofkP0303eIZ`3om^h0ooK^00/0ooK^00@0?EV[0?ofkP3om^h0?EV[
0`3om^h703eIZ`030?ofkP0mFJ/0?EV[02P0ooK^00<000000?ofkP3om^h00`3om^h60=@m6@030?of
kP3D?AT0ooK^0080ooK^0`3D?AT60?ofkP030=@m6@3om^h0ooK^00P0ooK^103D?AT20?ofkP030=@m
6@3om^h0ooK^01H0ooK^0`3D?ATC0?ofkP030=@m6@3om^h0ooK^00l0ooK^0P00001M0?ofkP40oooo
000Q0?ofkP800000HP3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0
?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^03eIZ`0A0?ofkP0303eIZ`3om^h0ooK^0080ooK^0P0m
FJ/?0?ofkP0303eIZ`3om^h0ooK^00h0ooK^200mFJ/70?ofkP80?EV[00<0ooK^03eIZ`0mFJ/0100m
FJ/00`3om^h0?EV[03eIZ`0203eIZ`030?ofkP0mFJ/0?EV[02T0ooK^00<000000?ofkP3om^h01P3o
m^h40=@m6@030?ofkP3D?AT0e3dI00@0ooK^0`3D?AT40?ofkP030=@m6@3om^h0ooK^00X0ooK^103D
?ATG0?ofkP80e3dI0P3om^h40=@m6@l0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`000000ooK^0?of
kP1M0?ofkP40oooo000P0?ofkP800000I03om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0
ooK^00D0ooK^00<0?EV[0?ofkP3om^h02`3om^h0100mFJ/0ooK^0?ofkP3om^h203eIZ`h0ooK^00<0
?EV[0?ofkP3om^h01@3om^h203eIZ`/0ooK^0P0mFJ/A0?ofkP0303eIZ`3om^h0ooK^00D0ooK^2P0m
FJ/50?ofkP<0?EV[0P3om^h303eIZbX0ooK^00<000000?ofkP3om^h02@3om^h50=@m6@H0ooK^1@3D
?AT;0?ofkP80e3dI0`3om^h40=@m6A40ooK^0P3D?AT80?ofkP<0e3dI2`3om^h00`3D?AT0ooK^0?of
kP0=0?ofkP800000H03om^h10?ooo`00803om^h2000006@0ooK^00<0?EV[0?ofkP3om^h0103om^h0
0`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h0103om^h0
0`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00P0ooK^0P0mFJ/80?ofkP0303eIZ`3om^h0
ooK^0100ooK^00<0?EV[0?ofkP3om^h02`3om^h0100mFJ/0ooK^0?ofkP0mFJ/60?ofkP80?EV[0P3o
m^h203eIZb`0ooK^00<000000?ofkP3om^h03@3om^h40=@m6@H0ooK^103D?AT70?ofkP80e3dI0P3o
m^h00`3D?AT0ooK^0?ofkP040?ofkP<0e3dI3@3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP<0e3dI1`3o
m^h00`3D?AT0ooK^0?ofkP0=0?ofkP030000003om^h0ooK^0600ooK^0@3oool00200ooK^0P00001U
0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP07
0?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP0;
0?ofkP80?EV[1@3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00D0?EV[
0?ofkP3om^h0ooK^03eIZ`050?ofkP80?EV[0P3om^h203eIZbd0ooK^00<000000?ofkP3om^h0403o
m^h50=@m6@D0ooK^103D?AT20?ofkP80e3dI103om^h00`3D?AT0ooK^0?ofkP070?ofkP<0e3dI203o
m^h20=@m6A40ooK^103D?AT20?ofkP030=@m6@3om^h0ooK^00`0ooK^0P00001S0?ofkP40oooo000R
0?ofkP@00000HP3om^h0100mFJ/0ooK^0?ofkP0mFJ/<0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0
?EV[0?ofkP3om^h0203om^h203eIZ`P0ooK^00<0?EV[0?ofkP3om^h03@3om^h203eIZ`80ooK^00<0
?EV[0?ofkP3om^h0403om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/0
103om^h303eIZ`040?ofkP0mFJ/0?EV[03eIZbh0ooK^00<000000?ofkP3om^h0503om^h=0=@m6@H0
ooK^00<0e3dI0?ofkP3om^h02@3om^h40=@m6@80ooK^0P3D?ATG0?ofkP80e3dI3P3om^h00`000000
ooK^0?ofkP1S0?ofkP40oooo000V0?ofkP@00000GP3om^h00`0mFJ/0ooK^03eIZ`0>0?ofkP0303eI
Z`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eI
Z`3om^h0ooK^0100ooK^0`0mFJ/@0?ofkP80?EV[3@3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0603eI
Z`3om^h0ooK^0?ofkP0mFJ/0ooK^0`0mFJ/00`3om^h0?EV[0?ofkP0^0?ofkP030000003om^h0ooK^
01L0ooK^103D?AT00`3om^h0e3dI0=@m6@020?ofkPD0e3dI0`3om^h00`3D?AT0ooK^0?ofkP0<0?of
kP<0e3dI603om^h00`3D?AT0ooK^0?ofkP0;0?ofkP800000IP3om^h10?ooo`00:P3om^h4000005/0
ooK^00<0?EV[0?ofkP3om^h03P3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00l0ooK^00<0?EV[0?of
kP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP0303eIZ`3om^h0ooK^00@0?EV[2`3om^h00`0m
FJ/0ooK^0?ofkP0;0?ofkP80?EV[103om^h0100mFJ/0ooK^0?ofkP3om^h403eIZ`80ooK^00<0?EV[
0?ofkP3om^h0;P3om^h00`000000ooK^0?ofkP0J0?ofkPD0e3dI1@3om^h50=@m6@`0ooK^0P3D?AT3
0?ofkP<0e3dI4`3om^h20=@m6@d0ooK^00<000000?ofkP3om^h0IP3om^h10?ooo`00;P3om^h40000
05P0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^03eIZ`0A0?ofkP80?EV[00<0ooK^03eI
Z`3om^h04P3om^h00`0mFJ/0ooK^0?ofkP050?ofkP<0?EV[1`3om^h00`0mFJ/0ooK^0?ofkP0;0?of
kP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h0100mFJ/00`3om^h0?EV[03eIZ`0a0?of
kP030000003om^h0ooK^01h0ooK^0`3D?AT60?ofkP<0e3dI2@3om^h20=@m6@P0ooK^0`3D?AT?0?of
kP030=@m6@3om^h0ooK^00/0ooK^0P00001Y0?ofkP40oooo000b0?ofkP@00000E@3om^h00`0mFJ/0
ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^0180ooK^0P0mFJ/B0?ofkP0303eIZ`3om^h0ooK^00T0
ooK^100mFJ/20?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h01@3om^h403eIZ`03
0?ofkP0mFJ/0ooK^0080?EV[<P3om^h00`000000ooK^0?ofkP0P0?ofkPD0e3dI1@3om^h40=@m6@<0
ooK^0P3D?AT=0?ofkP<0e3dI2`3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030000003om^h0ooK^06T0
ooK^0@3oool003H0ooK^1000001B0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00@0?EV[0?ofkP0mFJ/0
?EV[4@3om^h00`0mFJ/0ooK^0?ofkP0203eIZ`l0ooK^00<0?EV[0?ofkP3om^h03P3om^h803eIZ`L0
ooK^00<0?EV[0?ofkP3om^h01P0mFJ/01P3om^h0?EV[03eIZ`3om^h0?EV[0?ofkP80?EV[<`3om^h0
0`000000ooK^0?ofkP0S0?ofkPD0e3dI103om^h50=@m6A80ooK^0`3D?AT60?ofkP80e3dI303om^h2
000006`0ooK^0@3oool003X0ooK^1000001?0?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?of
kP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00<0ooK^0P0mFJ/;0?of
kP80?EV[4@3om^h00`0mFJ/0ooK^0?ofkP050?ofkPX0?EV[1@3om^h303eIZ`040?ofkP0mFJ/0ooK^
03eIZcD0ooK^00<000000?ofkP3om^h09P3om^h60=@m6@030?ofkP3D?AT0ooK^0080ooK^103D?ATA
0?ofkP<0e3dI0P3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030000003om^h0ooK^06`0ooK^0@3oool0
03h0ooK^1000001<0?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h0103om^h203eI
Z``0ooK^00<0?EV[0?ofkP3om^h01P3om^h203eIZ`P0ooK^00<0?EV[0?ofkP3om^h0403om^h00`0m
FJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00H0ooK^0P0mFJ/30?ofkP80?EV[=P3om^h00`00
0000ooK^0?ofkP0Y0?ofkPL0e3dI1@3om^h30=@m6A40ooK^0P3D?AT=0?ofkP030000003om^h0ooK^
06d0ooK^0@3oool00480ooK^100000190?ofkP0303eIZ`3om^h0ooK^00D0ooK^0P0mFJ/90?ofkP03
03eIZ`3om^h0ooK^00L0ooK^0P0mFJ/;0?ofkP80?EV[1@3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP03
03eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h01P3om^h203eIZ`<0ooK^0P0mFJ/g0?ofkP03
0000003om^h0ooK^02d0ooK^1@3D?AT60?ofkP<0e3dI2`3om^h30=@m6@d0ooK^0P00001`0?ofkP40
oooo00160?ofkP@00000AP3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00X0ooK^
0P0mFJ/60?ofkP0303eIZ`3om^h0ooK^00d0ooK^0P0mFJ/20?ofkP0303eIZ`3om^h0ooK^0100ooK^
00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP060?ofkP80?EV[00<0ooK^03eIZ`0mFJ/0
0P0mFJ/h0?ofkP030000003om^h0ooK^0300ooK^103D?AT70?ofkP@0e3dI0`3om^h40=@m6@l0ooK^
00<000000?ofkP3om^h0L03om^h10?ooo`00BP3om^h4000004<0ooK^00D0?EV[0?ofkP3om^h0ooK^
03eIZ`0?0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h0403om^h303eIZa00ooK^
0P0mFJ/=0?ofkP0303eIZ`3om^h0ooK^00D0ooK^0P0mFJ/0103om^h0?EV[03eIZ`3om^h203eIZcX0
ooK^00<000000?ofkP3om^h0<P3om^h40=@m6@H0ooK^1@3D?ATA0?ofkP800000L`3om^h10?ooo`00
CP3om^h400000400ooK^00<0?EV[0?ofkP0mFJ/04@3om^h203eIZ`030?ofkP0mFJ/0ooK^0180ooK^
00<0?EV[0?ofkP3om^h0100mFJ/;0?ofkP0303eIZ`3om^h0ooK^00/0ooK^0P0mFJ/70?ofkP@0?EV[
0P3om^h00`0mFJ/0ooK^0?ofkP0j0?ofkP030000003om^h0ooK^03H0ooK^1P3D?ATE0?ofkP030000
003om^h0ooK^07<0ooK^0@3oool00580ooK^1000000m0?ofkP0303eIZ`3om^h0ooK^0180ooK^00<0
?EV[0?ofkP3om^h04@3om^h00`0mFJ/0ooK^0?ofkP050?ofkP<0?EV[1`3om^h00`0mFJ/0ooK^0?of
kP0;0?ofkP0303eIZ`3om^h0ooK^00D0ooK^0`0mFJ/01@3om^h0?EV[0?ofkP3om^h0?EV[03d0ooK^
00<000000?ofkP3om^h0C`3om^h2000007H0ooK^0@3oool005H0ooK^0`00000k0?ofkP0303eIZ`3o
m^h0ooK^0100ooK^00@0?EV[0?ofkP0mFJ/0?EV[403om^h00`0mFJ/0ooK^0?ofkP090?ofkP@0?EV[
0P3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^0080ooK^1@0mFJ/30?ofkP<0?EV[
?P3om^h00`000000ooK^0?ofkP1>0?ofkP030000003om^h0ooK^07H0ooK^0@3oool005T0ooK^1000
000h0?ofkP80?EV[3`3om^h00`0mFJ/0ooK^0?ofkP020?ofkP80?EV[3@3om^h00`0mFJ/0ooK^0?of
kP0>0?ofkPP0?EV[1`3om^h00`0mFJ/0ooK^03eIZ`0303eIZ`<0ooK^00@0?EV[0?ofkP3om^h0ooK^
0`0mFJ/o0?ofkP030000003om^h0ooK^04`0ooK^0P00001i0?ofkP40oooo001M0?ofkP@00000=P3o
m^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00D0ooK^0P0mFJ/:0?ofkP0303eIZ`3o
m^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h01@3om^h903eIZ`H0ooK^00@0?EV[0?ofkP3om^h0ooK^
0P0mFJ]10?ofkP030000003om^h0ooK^04/0ooK^00<000000?ofkP3om^h0N@3om^h10?ooo`00H@3o
m^h4000003<0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP080?ofkP80?EV[1`3o
m^h00`0mFJ/0ooK^0?ofkP0>0?ofkP80?EV[3@3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0403eIZ`3o
m^h0ooK^0?ofkP80?EV[@P3om^h00`000000ooK^0?ofkP190?ofkP800000O03om^h10?ooo`00I@3o
m^h400000300ooK^0P0mFJ/80?ofkP0303eIZ`3om^h0ooK^00/0ooK^0P0mFJ/40?ofkP0303eIZ`3o
m^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h02`3om^h203eIZ`L0ooK^0P0mFJ/20?ofkP<0?EV[@`3o
m^h00`000000ooK^0?ofkP180?ofkP030000003om^h0ooK^07`0ooK^0@3oool006T0ooK^1000000^
0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h03P3om^h203eIZ`030?ofkP0mFJ/0
ooK^00l0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0
ooK^0080?EV[00<0ooK^03eIZ`3om^h0@`3om^h00`000000ooK^0?ofkP160?ofkP800000O`3om^h1
0?ooo`00K@3om^h4000002/0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP0A0?of
kP<0?EV[3P3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00H0ooK^00@0?EV[0?of
kP0mFJ/0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP130?ofkP030000003om^h0ooK^04D0ooK^00<00000
0?ofkP3om^h0O`3om^h10?ooo`00L@3om^h4000002P0ooK^0P0mFJ/00`3om^h0?EV[0?ofkP0B0?of
kP0403eIZ`3om^h0ooK^0?ofkP@0?EV[203om^h203eIZ`d0ooK^00<0?EV[0?ofkP3om^h01P3om^h3
03eIZ`80ooK^0P0mFJ]60?ofkP030000003om^h0ooK^04@0ooK^00<000000?ofkP3om^h0P03om^h1
0?ooo`00M@3om^h4000002H0ooK^0P0mFJ/B0?ofkP0303eIZ`3om^h0ooK^00H0ooK^100mFJ/30?of
kP0303eIZ`3om^h0ooK^00/0ooK^0P0mFJ/60?ofkP@0?EV[0`3om^h203eIZdL0ooK^00<000000?of
kP3om^h0@P3om^h2000008<0ooK^0@3oool007T0ooK^1000000T0?ofkP80?EV[3`3om^h00`0mFJ/0
ooK^0?ofkP0;0?ofkPT0?EV[1`3om^h00`0mFJ/0ooK^0?ofkP0603eIZ`030?ofkP0mFJ/0ooK^00<0
ooK^00<0?EV[0?ofkP3om^h0A`3om^h00`000000ooK^0?ofkP110?ofkP030000003om^h0ooK^08<0
ooK^0@3oool007d0ooK^1000000R0?ofkP80?EV[2`3om^h203eIZ`l0ooK^00<0?EV[0?ofkP3om^h0
1@3om^h:03eIZ`H0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP180?ofkP030000
003om^h0ooK^03l0ooK^0P0000260?ofkP40oooo00210?ofkP@00000803om^h203eIZ`P0ooK^00<0
?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00L0ooK^00@0
?EV[0?ofkP3om^h0ooK^0P0mFJ];0?ofkP030000003om^h0ooK^03h0ooK^00<000000?ofkP3om^h0
QP3om^h10?ooo`00Q@3om^h4000001h0ooK^0P0mFJ/50?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0
?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP060?ofkP80?EV[0P3om^h203eIZdd0ooK^00<0
00000?ofkP3om^h0?03om^h2000008T0ooK^0@3oool008T0ooK^0`00000M0?ofkP80?EV[0P3om^h0
0`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h01P3om^h0
0`0mFJ/0ooK^0?ofkP0203eIZdl0ooK^00<000000?ofkP3om^h0>`3om^h00`000000ooK^0?ofkP29
0?ofkP40oooo002<0?ofkP@000006`3om^h303eIZ`l0ooK^00<0?EV[0?ofkP3om^h02P3om^h203eI
Z`P0ooK^00@0?EV[0?ofkP0mFJ/0?EV[D@3om^h00`000000ooK^0?ofkP0i0?ofkP800000S03om^h1
0?ooo`00T03om^h4000001X0ooK^0`0mFJ/;0?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?of
kP3om^h01`3om^h303eIZe<0ooK^00<000000?ofkP3om^h0>03om^h00`000000ooK^0?ofkP2<0?of
kP40oooo002D0?ofkP@000006@3om^h403eIZ`H0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0
ooK^0?ofkP050?ofkP@0?EV[E@3om^h00`000000ooK^0?ofkP0f0?ofkP800000S`3om^h10?ooo`00
V03om^h4000001T0ooK^0`0mFJ/20?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h0
1P0mFJ]I0?ofkP030000003om^h0ooK^03D0ooK^00<000000?ofkP3om^h0S`3om^h10?ooo`00W03o
m^h4000001P0ooK^4P0mFJ]O0?ofkP030000003om^h0ooK^03<0ooK^0P00002B0?ofkP40oooo002P
0?ofkP@00000Q@3om^h00`000000ooK^0?ofkP0b0?ofkP030000003om^h0ooK^0980ooK^0@3oool0
0:@0ooK^100000220?ofkP030000003om^h0ooK^0300ooK^00<000000?ofkP3om^h0T`3om^h10?oo
o`00Z03om^h4000007h0ooK^00<000000?ofkP3om^h0;P3om^h2000009H0ooK^0@3oool00:`0ooK^
1000001j0?ofkP030000003om^h0ooK^02d0ooK^00<000000?ofkP3om^h0UP3om^h10?ooo`00/03o
m^h4000007H0ooK^00<000000?ofkP3om^h0:`3om^h2000009T0ooK^0@3oool00;@0ooK^1000001b
0?ofkP030000003om^h0ooK^02X0ooK^00<000000?ofkP3om^h0V@3om^h10?ooo`00^03om^h40000
06h0ooK^00<000000?ofkP3om^h0:03om^h2000009`0ooK^0@3oool00;`0ooK^1000001Z0?ofkP03
0000003om^h0ooK^02L0ooK^00<000000?ofkP3om^h0W03om^h10?ooo`00`03om^h3000006L0ooK^
00<000000?ofkP3om^h09@3om^h2000009l0ooK^0@3oool00<<0ooK^1000001S0?ofkP030000003o
m^h0ooK^02@0ooK^00<000000?ofkP3om^h0W`3om^h10?ooo`00a`3om^h4000005l0ooK^00<00000
0?ofkP3om^h08P3om^h200000:80ooK^0@3oool00</0ooK^1000001K0?ofkP030000003om^h0ooK^
0240ooK^00<000000?ofkP3om^h0XP3om^h10?ooo`00c`3om^h4000005L0ooK^00<000000?ofkP3o
m^h07`3om^h200000:D0ooK^0@3oool00=<0ooK^1000001C0?ofkP030000003om^h0ooK^01h0ooK^
00<000000?ofkP3om^h0Y@3om^h10?ooo`00e`3om^h4000004l0ooK^00<000000?ofkP3om^h0703o
m^h200000:P0ooK^0@3oool00=/0ooK^1000001;0?ofkP030000003om^h0ooK^01/0ooK^00<00000
0?ofkP3om^h0Z03om^h10?ooo`00g`3om^h4000004L0ooK^00<000000?ofkP3om^h06P3om^h00`00
0000ooK^0?ofkP2Y0?ofkP40oooo003S0?ofkP@00000@`3om^h00`000000ooK^0?ofkP0H0?ofkP80
0000[03om^h10?ooo`00i`3om^h4000003l0ooK^00<000000?ofkP3om^h05`3om^h00`000000ooK^
0?ofkP2/0?ofkP40oooo003[0?ofkP@00000>`3om^h00`000000ooK^0?ofkP0E0?ofkP800000[`3o
m^h10?ooo`00k`3om^h4000003L0ooK^00<000000?ofkP3om^h0503om^h00`000000ooK^0?ofkP2_
0?ofkP40oooo003c0?ofkP<00000=03om^h00`000000ooK^0?ofkP0B0?ofkP800000/P3om^h10?oo
o`00mP3om^h400000300ooK^00<000000?ofkP3om^h04@3om^h00`000000ooK^0?ofkP2b0?ofkP40
oooo003j0?ofkP@00000;03om^h00`000000ooK^0?ofkP0?0?ofkP800000]@3om^h10?ooo`00oP3o
m^h4000002T0ooK^00<000000?ofkP3om^h03@3om^h00`000000ooK^0?ofkP2e0?ofkP40oooo003o
0?ofkP<0ooK^1000000U0?ofkP030000003om^h0ooK^00/0ooK^0P00002h0?ofkP40oooo003o0?of
kPL0ooK^1000000Q0?ofkP030000003om^h0ooK^00X0ooK^00<000000?ofkP3om^h0^03om^h10?oo
o`00o`3om^h;0?ofkP@000007@3om^h00`000000ooK^0?ofkP080?ofkP800000^`3om^h10?ooo`00
o`3om^h?0?ofkP@000006@3om^h00`000000ooK^0?ofkP070?ofkP030000003om^h0ooK^0;/0ooK^
0@3oool00?l0ooK^4`3om^h4000001D0ooK^00<000000?ofkP3om^h01P3om^h00`000000ooK^0?of
kP2l0?ofkP40oooo003o0?ofkQL0ooK^1000000A0?ofkP030000003om^h0ooK^00@0ooK^0P00002o
0?ofkP40oooo003o0?ofkQ/0ooK^1000000=0?ofkP030000003om^h0ooK^00<0ooK^00<000000?of
kP3om^h0_`3om^h10?ooo`00o`3om^hO0?ofkP@000002@3om^h010000000ooK^0?ofkP3om^h20000
0<80ooK^0@3oool00?l0ooK^8`3om^h4000000D0ooK^00@000000?ofkP3om^h00000a03om^h10?oo
o`00o`3om^hW0?ofkP@0000000@0ooK^0000000000000000a@3om^h10?ooo`00o`3om^h[0?ofkP80
0000a`3om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h1
0?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3o
m^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40
oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?of
k_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3o
ool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^
m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?oo
o`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd
0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo
003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0
ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool0
0?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03o
m^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00
o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?of
kP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o
0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^
0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0
ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h1
0?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3o
m^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40
oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?of
k_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3o
ool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^
m03om^h10?ooo`00o`3om^kd0?ofkP40oooo0000\
\>"],
  ImageRangeCache->{{{0, 499}, {499, 0}} -> {-5.00005*^-06, -5.00005*^-06, \
0.00200403, 0.00200403}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
%%ImageSize: 500 500 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics3D
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Background color
1 .961 .933 r
MFill
% Scaling calculations
0 1 0 1 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 0 r
.25 Mabswid
[ ] 0 setdash
.07653 .37901 m
.02189 .6366 L
s
.02189 .6366 m
.5 .84126 L
s
.5 .84126 m
.5 .60969 L
s
.5 .60969 m
.07653 .37901 L
s
.5 .02321 m
.92347 .37901 L
s
.92347 .37901 m
.97811 .6366 L
s
.97811 .6366 m
.5 .30205 L
s
.5 .30205 m
.5 .02321 L
s
.07653 .37901 m
.02189 .6366 L
s
.02189 .6366 m
.5 .30205 L
s
.5 .30205 m
.5 .02321 L
s
.5 .02321 m
.07653 .37901 L
s
.5 .60969 m
.92347 .37901 L
s
.92347 .37901 m
.97811 .6366 L
s
.97811 .6366 m
.5 .84126 L
s
.5 .84126 m
.5 .60969 L
s
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
.24 .35 .67 r
.5 Mabswid
.39252 .59209 m
.38003 .56857 L
s
.38003 .56857 m
.40454 .55382 L
s
.38003 .56857 m
.36454 .54698 L
s
.83 .24 .1 r
.61997 .56857 m
.63546 .54698 L
s
.59546 .55382 m
.61997 .56857 L
s
.60748 .59209 m
.61997 .56857 L
s
.58277 .57763 m
.60748 .59209 L
s
.59844 .6167 m
.60748 .59209 L
s
.24 .35 .67 r
.40156 .6167 m
.39252 .59209 L
s
.39252 .59209 m
.41723 .57763 L
s
.36454 .54698 m
.3889 .53191 L
s
.36454 .54698 m
.34659 .52807 L
s
.83 .24 .1 r
.63546 .54698 m
.65341 .52807 L
s
.6111 .53191 m
.63546 .54698 L
s
.24 .35 .67 r
.40679 .64154 m
.40156 .6167 L
s
.40156 .6167 m
.42649 .6025 L
s
.83 .24 .1 r
.57351 .6025 m
.59844 .6167 L
s
.59321 .64154 m
.59844 .6167 L
s
.65341 .52807 m
.67321 .51257 L
s
.62917 .51268 m
.65341 .52807 L
s
.24 .35 .67 r
.34659 .52807 m
.37083 .51268 L
s
.34659 .52807 m
.32679 .51257 L
s
.83 .24 .1 r
.56804 .62758 m
.59321 .64154 L
s
.59206 .6657 m
.59321 .64154 L
s
.24 .35 .67 r
.40794 .6657 m
.40679 .64154 L
s
.40679 .64154 m
.43196 .62758 L
s
.41723 .57763 m
.40454 .55382 L
s
.40454 .55382 m
.42972 .53867 L
s
.40454 .55382 m
.3889 .53191 L
s
.83 .24 .1 r
.6111 .53191 m
.59546 .55382 L
s
.57028 .53867 m
.59546 .55382 L
s
.59546 .55382 m
.58277 .57763 L
s
.67321 .51257 m
.69419 .50112 L
s
.64906 .49686 m
.67321 .51257 L
s
.24 .35 .67 r
.32679 .51257 m
.35094 .49686 L
s
.32679 .51257 m
.30581 .50112 L
s
.42649 .6025 m
.41723 .57763 L
s
.41723 .57763 m
.4426 .56278 L
s
.83 .24 .1 r
.5574 .56278 m
.58277 .57763 L
s
.58277 .57763 m
.57351 .6025 L
s
.62917 .51268 m
.6111 .53191 L
s
.58609 .51644 m
.6111 .53191 L
s
.24 .35 .67 r
.3889 .53191 m
.41391 .51644 L
s
.3889 .53191 m
.37083 .51268 L
s
.43196 .62758 m
.42649 .6025 L
s
.42649 .6025 m
.45208 .58793 L
s
.83 .24 .1 r
.54792 .58793 m
.57351 .6025 L
s
.57351 .6025 m
.56804 .62758 L
s
.24 .35 .67 r
.37083 .51268 m
.39571 .49688 L
s
.37083 .51268 m
.35094 .49686 L
s
.83 .24 .1 r
.64906 .49686 m
.62917 .51268 L
s
.60429 .49688 m
.62917 .51268 L
s
.24 .35 .67 r
.43336 .65194 m
.40794 .6657 L
s
.40486 .68827 m
.40794 .6657 L
s
.83 .24 .1 r
.56664 .65194 m
.59206 .6657 L
s
.59514 .68827 m
.59206 .6657 L
s
.69419 .50112 m
.71557 .49427 L
s
.67008 .4851 m
.69419 .50112 L
s
.24 .35 .67 r
.30581 .50112 m
.32992 .4851 L
s
.30581 .50112 m
.28443 .49427 L
s
.43336 .65194 m
.43196 .62758 L
s
.43196 .62758 m
.45781 .61324 L
s
.83 .24 .1 r
.54219 .61324 m
.56804 .62758 L
s
.56804 .62758 m
.56664 .65194 L
s
.24 .35 .67 r
.4426 .56278 m
.42972 .53867 L
s
.42972 .53867 m
.45557 .52311 L
s
.42972 .53867 m
.41391 .51644 L
s
.83 .24 .1 r
.58609 .51644 m
.57028 .53867 L
s
.54443 .52311 m
.57028 .53867 L
s
.57028 .53867 m
.5574 .56278 L
s
.67008 .4851 m
.64906 .49686 L
s
.62426 .48073 m
.64906 .49686 L
s
.24 .35 .67 r
.35094 .49686 m
.37574 .48073 L
s
.35094 .49686 m
.32992 .4851 L
s
.45208 .58793 m
.4426 .56278 L
s
.4426 .56278 m
.46865 .54753 L
s
.83 .24 .1 r
.53135 .54753 m
.5574 .56278 L
s
.5574 .56278 m
.54792 .58793 L
s
.24 .35 .67 r
.41391 .51644 m
.43959 .50056 L
s
.41391 .51644 m
.39571 .49688 L
s
.83 .24 .1 r
.60429 .49688 m
.58609 .51644 L
s
.56041 .50056 m
.58609 .51644 L
s
.24 .35 .67 r
.45781 .61324 m
.45208 .58793 L
s
.45208 .58793 m
.47838 .57296 L
s
.83 .24 .1 r
.52162 .57296 m
.54792 .58793 L
s
.54792 .58793 m
.54219 .61324 L
s
.24 .35 .67 r
.39752 .70829 m
.40486 .68827 L
s
.40486 .68827 m
.43053 .67465 L
s
.83 .24 .1 r
.56947 .67465 m
.59514 .68827 L
s
.60248 .70829 m
.59514 .68827 L
s
.62426 .48073 m
.60429 .49688 L
s
.57873 .48066 m
.60429 .49688 L
s
.24 .35 .67 r
.39571 .49688 m
.42127 .48066 L
s
.39571 .49688 m
.37574 .48073 L
s
.45947 .63779 m
.43336 .65194 L
s
.43053 .67465 m
.43336 .65194 L
s
.83 .24 .1 r
.54053 .63779 m
.56664 .65194 L
s
.56664 .65194 m
.56947 .67465 L
s
.71557 .49427 m
.73652 .49245 L
s
.69146 .47797 m
.71557 .49427 L
s
.24 .35 .67 r
.28443 .49427 m
.30854 .47797 L
s
.28443 .49427 m
.26348 .49245 L
s
.83 .24 .1 r
.69146 .47797 m
.67008 .4851 L
s
.64532 .46865 m
.67008 .4851 L
s
.24 .35 .67 r
.32992 .4851 m
.35468 .46865 L
s
.32992 .4851 m
.30854 .47797 L
s
.45947 .63779 m
.45781 .61324 L
s
.45781 .61324 m
.48436 .59851 L
s
.83 .24 .1 r
.51564 .59851 m
.54219 .61324 L
s
.54219 .61324 m
.54053 .63779 L
s
.24 .35 .67 r
.46865 .54753 m
.45557 .52311 L
s
.45557 .52311 m
.48212 .50713 L
s
.45557 .52311 m
.43959 .50056 L
s
.83 .24 .1 r
.56041 .50056 m
.54443 .52311 L
s
.51788 .50713 m
.54443 .52311 L
s
.54443 .52311 m
.53135 .54753 L
s
.64532 .46865 m
.62426 .48073 L
s
.59878 .46416 m
.62426 .48073 L
s
.24 .35 .67 r
.37574 .48073 m
.40122 .46416 L
s
.37574 .48073 m
.35468 .46865 L
s
.47838 .57296 m
.46865 .54753 L
s
.46865 .54753 m
.49542 .53186 L
s
.83 .24 .1 r
.50458 .53186 m
.53135 .54753 L
s
.53135 .54753 m
.52162 .57296 L
s
.24 .35 .67 r
.43959 .50056 m
.46598 .48423 L
s
.43959 .50056 m
.42127 .48066 L
s
.83 .24 .1 r
.57873 .48066 m
.56041 .50056 L
s
.53402 .48423 m
.56041 .50056 L
s
.52162 .57296 m
.51564 .59851 L
s
.24 .35 .67 r
.48436 .59851 m
.47838 .57296 L
s
.38606 .72487 m
.39752 .70829 L
s
.39752 .70829 m
.42343 .69477 L
s
.83 .24 .1 r
.57657 .69477 m
.60248 .70829 L
s
.61394 .72487 m
.60248 .70829 L
s
.24 .35 .67 r
.42343 .69477 m
.43053 .67465 L
s
.43053 .67465 m
.45691 .66065 L
s
.83 .24 .1 r
.54309 .66065 m
.56947 .67465 L
s
.56947 .67465 m
.57657 .69477 L
s
.59878 .46416 m
.57873 .48066 L
s
.55247 .46398 m
.57873 .48066 L
s
.24 .35 .67 r
.42127 .48066 m
.44753 .46398 L
s
.42127 .48066 m
.40122 .46416 L
s
.4863 .62326 m
.45947 .63779 L
s
.45691 .66065 m
.45947 .63779 L
s
.83 .24 .1 r
.5137 .62326 m
.54053 .63779 L
s
.54053 .63779 m
.54309 .66065 L
s
.73652 .49245 m
.75618 .49594 L
s
.71238 .4759 m
.73652 .49245 L
s
.24 .35 .67 r
.26348 .49245 m
.28762 .4759 L
s
.26348 .49245 m
.24382 .49594 L
s
.83 .24 .1 r
.71238 .4759 m
.69146 .47797 L
s
.6667 .46122 m
.69146 .47797 L
s
.24 .35 .67 r
.30854 .47797 m
.3333 .46122 L
s
.30854 .47797 m
.28762 .4759 L
s
.83 .24 .1 r
.6667 .46122 m
.64532 .46865 L
s
.61987 .45174 m
.64532 .46865 L
s
.24 .35 .67 r
.35468 .46865 m
.38013 .45174 L
s
.35468 .46865 m
.3333 .46122 L
s
.49542 .53186 m
.48212 .50713 L
s
.48212 .50713 m
.46598 .48423 L
s
.83 .24 .1 r
.53402 .48423 m
.51788 .50713 L
s
.51788 .50713 m
.50458 .53186 L
s
.61987 .45174 m
.59878 .46416 L
s
.5726 .44712 m
.59878 .46416 L
s
.24 .35 .67 r
.40122 .46416 m
.4274 .44712 L
s
.40122 .46416 m
.38013 .45174 L
s
1 .286 .119 r
.48881 .52289 m .5 .52944 L .5 .55343 L p F P
0 0 0 r
s
1 .286 .119 r
.5 .55343 m .48768 .54637 L .48881 .52289 L p F P
0 0 0 r
s
.992 .279 .115 r
.48768 .54637 m .5 .55343 L .5 .57626 L p F P
0 0 0 r
s
.24 .35 .67 r
.47838 .57296 m
.49479 .56361 L
s
.193 .274 .56 r
.51317 .56886 m .5 .57626 L .5 .55343 L p F P
0 0 0 r
s
.83 .24 .1 r
.51199 .56747 m
.52162 .57296 L
s
.193 .274 .56 r
.5 .55343 m .51232 .54637 L .51317 .56886 L p F P
0 0 0 r
s
.209 .299 .607 r
.51232 .54637 m .5 .55343 L .5 .52944 L p F P
0 0 0 r
s
.83 .24 .1 r
.5036 .53439 m
.50458 .53186 L
s
.55247 .46398 m
.53402 .48423 L
s
.24 .35 .67 r
.46598 .48423 m
.44753 .46398 L
s
1 .291 .121 r
.49019 .49883 m .5 .50469 L .5 .52944 L p F P
0 0 0 r
s
1 .291 .121 r
.5 .52944 m .48881 .52289 L .49019 .49883 L p F P
0 0 0 r
s
.24 .35 .67 r
.48212 .50713 m
.48999 .5024 L
s
.209 .299 .607 r
.5 .52944 m .51119 .52289 L .51232 .54637 L p F P
0 0 0 r
s
.223 .322 .648 r
.51119 .52289 m .5 .52944 L .5 .50469 L p F P
0 0 0 r
s
.992 .279 .115 r
.5 .57626 m .48683 .56886 L .48768 .54637 L p F P
0 0 0 r
s
.24 .35 .67 r
.49867 .54025 m
.50539 .55757 L
s
.83 .24 .1 r
.49461 .55757 m
.50133 .54025 L
s
.49461 .55757 m
.50076 .56107 L
s
.24 .35 .67 r
.49924 .56107 m
.50539 .55757 L
s
.967 .27 .111 r
.48683 .56886 m .5 .57626 L .5 .59754 L p F P
0 0 0 r
s
.24 .35 .67 r
.48436 .59851 m
.49718 .5914 L
s
.175 .246 .506 r
.51374 .58997 m .5 .59754 L .5 .57626 L p F P
0 0 0 r
s
.83 .24 .1 r
.50697 .5937 m
.51564 .59851 L
s
.175 .246 .506 r
.5 .57626 m .51317 .56886 L .51374 .58997 L p F P
0 0 0 r
s
.24 .35 .67 r
.50539 .55757 m
.51165 .58337 L
s
.41218 .71138 m
.42343 .69477 L
s
.42343 .69477 m
.45007 .68087 L
s
.83 .24 .1 r
.54993 .68087 m
.57657 .69477 L
s
.57657 .69477 m
.58782 .71138 L
s
.24 .35 .67 r
.45007 .68087 m
.45691 .66065 L
s
.45691 .66065 m
.48402 .64627 L
s
.83 .24 .1 r
.51598 .64627 m
.54309 .66065 L
s
.54309 .66065 m
.54993 .68087 L
s
1 .295 .123 r
.4918 .47458 m .5 .47958 L .5 .50469 L p F P
0 0 0 r
s
1 .295 .123 r
.5 .50469 m .49019 .49883 L .4918 .47458 L p F P
0 0 0 r
s
.223 .322 .648 r
.5 .50469 m .50981 .49883 L .51119 .52289 L p F P
0 0 0 r
s
.83 .24 .1 r
.51001 .5024 m
.51788 .50713 L
s
.236 .343 .687 r
.50981 .49883 m .5 .50469 L .5 .47958 L p F P
0 0 0 r
s
.24 .35 .67 r
.37078 .73714 m
.38606 .72487 L
s
.38606 .72487 m
.41218 .71138 L
s
.83 .24 .1 r
.58782 .71138 m
.61394 .72487 L
s
.62922 .73714 m
.61394 .72487 L
s
.24 .35 .67 r
.44753 .46398 m
.47453 .44684 L
s
.44753 .46398 m
.4274 .44712 L
s
.83 .24 .1 r
.5726 .44712 m
.55247 .46398 L
s
.52547 .44684 m
.55247 .46398 L
s
.967 .27 .111 r
.5 .59754 m .48626 .58997 L .48683 .56886 L p F P
0 0 0 r
s
.83 .24 .1 r
.48835 .58337 m
.49461 .55757 L
s
.931 .257 .105 r
.48626 .58997 m .5 .59754 L .5 .6169 L p F P
0 0 0 r
s
.24 .35 .67 r
.48436 .59851 m
.4863 .62326 L
s
.153 .212 .442 r
.51401 .60931 m .5 .6169 L .5 .59754 L p F P
0 0 0 r
s
.153 .212 .442 r
.5 .59754 m .51374 .58997 L .51401 .60931 L p F P
0 0 0 r
s
.83 .24 .1 r
.5137 .62326 m
.51564 .59851 L
s
.24 .35 .67 r
.49928 .59023 m
.51165 .58337 L
s
.83 .24 .1 r
.48835 .58337 m
.50072 .59023 L
s
1 .286 .119 r
.47749 .51627 m .48881 .52289 L .48768 .54637 L p F P
0 0 0 r
s
1 .286 .119 r
.48768 .54637 m .47521 .53922 L .47749 .51627 L p F P
0 0 0 r
s
.992 .279 .115 r
.47521 .53922 m .48768 .54637 L .48683 .56886 L p F P
0 0 0 r
s
.193 .274 .56 r
.52652 .56136 m .51317 .56886 L .51232 .54637 L p F P
0 0 0 r
s
.193 .274 .56 r
.51232 .54637 m .52479 .53922 L .52652 .56136 L p F P
0 0 0 r
s
.209 .299 .607 r
.52479 .53922 m .51232 .54637 L .51119 .52289 L p F P
0 0 0 r
s
1 .291 .121 r
.48028 .49291 m .49019 .49883 L .48881 .52289 L p F P
0 0 0 r
s
1 .291 .121 r
.48881 .52289 m .47749 .51627 L .48028 .49291 L p F P
0 0 0 r
s
.209 .299 .607 r
.51119 .52289 m .52251 .51627 L .52479 .53922 L p F P
0 0 0 r
s
.223 .322 .648 r
.52251 .51627 m .51119 .52289 L .50981 .49883 L p F P
0 0 0 r
s
.83 .24 .1 r
.73196 .4792 m
.71238 .4759 L
s
.68757 .45889 m
.71238 .4759 L
s
.24 .35 .67 r
.28762 .4759 m
.31243 .45889 L
s
.28762 .4759 m
.26804 .4792 L
s
.83 .24 .1 r
.68757 .45889 m
.6667 .46122 L
s
.64124 .444 m
.6667 .46122 L
s
.24 .35 .67 r
.3333 .46122 m
.35876 .444 L
s
.3333 .46122 m
.31243 .45889 L
s
.83 .24 .1 r
.75618 .49594 m
.77364 .50483 L
s
.73196 .4792 m
.75618 .49594 L
s
.24 .35 .67 r
.24382 .49594 m
.26804 .4792 L
s
.24382 .49594 m
.22636 .50483 L
s
.992 .279 .115 r
.48683 .56886 m .47348 .56136 L .47521 .53922 L p F P
0 0 0 r
s
.967 .27 .111 r
.47348 .56136 m .48683 .56886 L .48626 .58997 L p F P
0 0 0 r
s
.175 .246 .506 r
.52768 .58229 m .51374 .58997 L .51317 .56886 L p F P
0 0 0 r
s
.175 .246 .506 r
.51317 .56886 m .52652 .56136 L .52768 .58229 L p F P
0 0 0 r
s
.83 .24 .1 r
.64124 .444 m
.61987 .45174 L
s
.59371 .43436 m
.61987 .45174 L
s
.24 .35 .67 r
.38013 .45174 m
.40629 .43436 L
s
.38013 .45174 m
.35876 .444 L
s
1 .295 .123 r
.48353 .46953 m .4918 .47458 L .49019 .49883 L p F P
0 0 0 r
s
1 .295 .123 r
.49019 .49883 m .48028 .49291 L .48353 .46953 L p F P
0 0 0 r
s
.24 .35 .67 r
.46598 .48423 m
.48295 .47374 L
s
.223 .322 .648 r
.50981 .49883 m .51972 .49291 L .52251 .51627 L p F P
0 0 0 r
s
.236 .343 .687 r
.51972 .49291 m .50981 .49883 L .5082 .47458 L p F P
0 0 0 r
s
.236 .343 .687 r
.5 .47958 m .5082 .47458 L .50981 .49883 L p F P
0 0 0 r
s
.24 .35 .67 r
.49892 .49702 m
.50942 .4907 L
s
.83 .24 .1 r
.49058 .4907 m
.50108 .49702 L
s
1 .297 .125 r
.49362 .45057 m .5 .45454 L .5 .47958 L p F P
0 0 0 r
s
1 .297 .125 r
.5 .47958 m .4918 .47458 L .49362 .45057 L p F P
0 0 0 r
s
.24 .35 .67 r
.48666 .47144 m
.4923 .46795 L
s
.248 .362 .723 r
.5082 .47458 m .5 .47958 L .5 .45454 L p F P
0 0 0 r
s
.83 .24 .1 r
.5069 .46746 m
.53402 .48423 L
s
1 .291 .121 r
.47028 .48693 m .48028 .49291 L .47749 .51627 L p F P
0 0 0 r
s
1 .291 .121 r
.47749 .51627 m .46605 .50958 L .47028 .48693 L p F P
0 0 0 r
s
1 .286 .119 r
.46605 .50958 m .47749 .51627 L .47521 .53922 L p F P
0 0 0 r
s
.83 .24 .1 r
.47707 .51576 m
.50113 .52984 L
s
.209 .299 .607 r
.53742 .53199 m .52479 .53922 L .52251 .51627 L p F P
0 0 0 r
s
.209 .299 .607 r
.52251 .51627 m .53395 .50958 L .53742 .53199 L p F P
0 0 0 r
s
.223 .322 .648 r
.53395 .50958 m .52251 .51627 L .51972 .49291 L p F P
0 0 0 r
s
.24 .35 .67 r
.49887 .52984 m
.52293 .51576 L
s
1 .286 .119 r
.47521 .53922 m .46258 .53199 L .46605 .50958 L p F P
0 0 0 r
s
.992 .279 .115 r
.46258 .53199 m .47521 .53922 L .47348 .56136 L p F P
0 0 0 r
s
.193 .274 .56 r
.54006 .55376 m .52652 .56136 L .52479 .53922 L p F P
0 0 0 r
s
.193 .274 .56 r
.52479 .53922 m .53742 .53199 L .54006 .55376 L p F P
0 0 0 r
s
.24 .35 .67 r
.50942 .4907 m
.52293 .51576 L
s
.49778 .47412 m
.50942 .4907 L
s
.83 .24 .1 r
.49058 .4907 m
.50222 .47412 L
s
.50588 .46891 m
.5069 .46746 L
s
.47707 .51576 m
.49058 .4907 L
s
.967 .27 .111 r
.48626 .58997 m .47232 .58229 L .47348 .56136 L p F P
0 0 0 r
s
.931 .257 .105 r
.47232 .58229 m .48626 .58997 L .48599 .60931 L p F P
0 0 0 r
s
.931 .257 .105 r
.5 .6169 m .48599 .60931 L .48626 .58997 L p F P
0 0 0 r
s
.83 .24 .1 r
.48611 .60832 m
.48835 .58337 L
s
.153 .212 .442 r
.52823 .60162 m .51401 .60931 L .51374 .58997 L p F P
0 0 0 r
s
.153 .212 .442 r
.51374 .58997 m .52768 .58229 L .52823 .60162 L p F P
0 0 0 r
s
.24 .35 .67 r
.51165 .58337 m
.51389 .60832 L
s
.88 .24 .097 r
.48599 .60931 m .5 .6169 L .5 .63395 L p F P
0 0 0 r
s
.24 .35 .67 r
.4863 .62326 m
.49213 .62011 L
s
.48402 .64627 m
.4863 .62326 L
s
.126 .17 .362 r
.51397 .62651 m .5 .63395 L .5 .6169 L p F P
0 0 0 r
s
.126 .17 .362 r
.5 .6169 m .51401 .60931 L .51397 .62651 L p F P
0 0 0 r
s
.83 .24 .1 r
.51397 .62606 m
.51598 .64627 L
s
.59371 .43436 m
.5726 .44712 L
s
.54567 .42961 m
.5726 .44712 L
s
.24 .35 .67 r
.4274 .44712 m
.45433 .42961 L
s
.4274 .44712 m
.40629 .43436 L
s
.52293 .51576 m
.53316 .54176 L
s
1 .295 .123 r
.47519 .46444 m .48353 .46953 L .48028 .49291 L p F P
0 0 0 r
s
1 .295 .123 r
.48028 .49291 m .47028 .48693 L .47519 .46444 L p F P
0 0 0 r
s
.223 .322 .648 r
.51972 .49291 m .52972 .48693 L .53395 .50958 L p F P
0 0 0 r
s
.236 .343 .687 r
.52972 .48693 m .51972 .49291 L .51647 .46953 L p F P
0 0 0 r
s
.236 .343 .687 r
.5082 .47458 m .51647 .46953 L .51972 .49291 L p F P
0 0 0 r
s
.175 .246 .506 r
.54181 .57451 m .52768 .58229 L .52652 .56136 L p F P
0 0 0 r
s
.175 .246 .506 r
.52652 .56136 m .54006 .55376 L .54181 .57451 L p F P
0 0 0 r
s
.24 .35 .67 r
.50539 .55757 m
.53316 .54176 L
s
.992 .279 .115 r
.47348 .56136 m .45994 .55376 L .46258 .53199 L p F P
0 0 0 r
s
.83 .24 .1 r
.46684 .54176 m
.47707 .51576 L
s
.967 .27 .111 r
.45994 .55376 m .47348 .56136 L .47232 .58229 L p F P
0 0 0 r
s
.83 .24 .1 r
.46684 .54176 m
.49461 .55757 L
s
1 .297 .125 r
.48719 .44656 m .49362 .45057 L .4918 .47458 L p F P
0 0 0 r
s
1 .297 .125 r
.4918 .47458 m .48353 .46953 L .48719 .44656 L p F P
0 0 0 r
s
.24 .35 .67 r
.47453 .44684 m
.48525 .45874 L
s
.248 .362 .723 r
.51647 .46953 m .5082 .47458 L .50638 .45057 L p F P
0 0 0 r
s
.83 .24 .1 r
.5069 .46746 m
.5076 .46668 L
s
.51222 .46155 m
.52547 .44684 L
s
.248 .362 .723 r
.5 .45454 m .50638 .45057 L .5082 .47458 L p F P
0 0 0 r
s
1 .291 .121 r
.46017 .48089 m .47028 .48693 L .46605 .50958 L p F P
0 0 0 r
s
1 .291 .121 r
.46605 .50958 m .45447 .5028 L .46017 .48089 L p F P
0 0 0 r
s
1 .286 .119 r
.45447 .5028 m .46605 .50958 L .46258 .53199 L p F P
0 0 0 r
s
.209 .299 .607 r
.5502 .52466 m .53742 .53199 L .53395 .50958 L p F P
0 0 0 r
s
.209 .299 .607 r
.53395 .50958 m .54553 .5028 L .5502 .52466 L p F P
0 0 0 r
s
.223 .322 .648 r
.54553 .5028 m .53395 .50958 L .52972 .48693 L p F P
0 0 0 r
s
.24 .35 .67 r
.43905 .69751 m
.45007 .68087 L
s
.45007 .68087 m
.47745 .66657 L
s
.83 .24 .1 r
.52255 .66657 m
.54993 .68087 L
s
.54993 .68087 m
.56095 .69751 L
s
1 .286 .119 r
.46258 .53199 m .4498 .52466 L .45447 .5028 L p F P
0 0 0 r
s
.992 .279 .115 r
.4498 .52466 m .46258 .53199 L .45994 .55376 L p F P
0 0 0 r
s
.193 .274 .56 r
.55377 .54606 m .54006 .55376 L .53742 .53199 L p F P
0 0 0 r
s
.193 .274 .56 r
.53742 .53199 m .5502 .52466 L .55377 .54606 L p F P
0 0 0 r
s
.24 .35 .67 r
.53316 .54176 m
.53971 .5678 L
s
.47745 .66657 m
.48402 .64627 L
s
.83 .24 .1 r
.51598 .64627 m
.52255 .66657 L
s
.24 .35 .67 r
.39708 .72362 m
.41218 .71138 L
s
.41218 .71138 m
.43905 .69751 L
s
.83 .24 .1 r
.56095 .69751 m
.58782 .71138 L
s
.58782 .71138 m
.60292 .72362 L
s
1 .297 .125 r
.48072 .44254 m .48719 .44656 L .48353 .46953 L p F P
0 0 0 r
s
1 .297 .125 r
.48353 .46953 m .47519 .46444 L .48072 .44254 L p F P
0 0 0 r
s
.24 .35 .67 r
.47453 .44684 m
.48061 .44298 L
s
.236 .343 .687 r
.51647 .46953 m .52481 .46444 L .52972 .48693 L p F P
0 0 0 r
s
.248 .362 .723 r
.52481 .46444 m .51647 .46953 L .51281 .44656 L p F P
0 0 0 r
s
.248 .362 .723 r
.50638 .45057 m .51281 .44656 L .51647 .46953 L p F P
0 0 0 r
s
.24 .35 .67 r
.35219 .74436 m
.37078 .73714 L
s
.37078 .73714 m
.39708 .72362 L
s
.83 .24 .1 r
.60292 .72362 m
.62922 .73714 L
s
.64781 .74436 m
.62922 .73714 L
s
1 .295 .123 r
.46679 .45931 m .47519 .46444 L .47028 .48693 L p F P
0 0 0 r
s
1 .295 .123 r
.47028 .48693 m .46017 .48089 L .46679 .45931 L p F P
0 0 0 r
s
.223 .322 .648 r
.52972 .48693 m .53983 .48089 L .54553 .5028 L p F P
0 0 0 r
s
.236 .343 .687 r
.53983 .48089 m .52972 .48693 L .52481 .46444 L p F P
0 0 0 r
s
.153 .212 .442 r
.54265 .59382 m .52823 .60162 L .52768 .58229 L p F P
0 0 0 r
s
.153 .212 .442 r
.52768 .58229 m .54181 .57451 L .54265 .59382 L p F P
0 0 0 r
s
.24 .35 .67 r
.51165 .58337 m
.53971 .5678 L
s
.967 .27 .111 r
.47232 .58229 m .45819 .57451 L .45994 .55376 L p F P
0 0 0 r
s
.83 .24 .1 r
.46029 .5678 m
.46684 .54176 L
s
.931 .257 .105 r
.45819 .57451 m .47232 .58229 L .47177 .60162 L p F P
0 0 0 r
s
.931 .257 .105 r
.48599 .60931 m .47177 .60162 L .47232 .58229 L p F P
0 0 0 r
s
.83 .24 .1 r
.46029 .5678 m
.48835 .58337 L
s
.88 .24 .097 r
.47177 .60162 m .48599 .60931 L .48603 .62651 L p F P
0 0 0 r
s
.88 .24 .097 r
.5 .63395 m .48603 .62651 L .48599 .60931 L p F P
0 0 0 r
s
.24 .35 .67 r
.49903 .61637 m
.51389 .60832 L
s
.83 .24 .1 r
.48611 .60832 m
.50097 .61637 L
s
.126 .17 .362 r
.52814 .61897 m .51397 .62651 L .51401 .60931 L p F P
0 0 0 r
s
.126 .17 .362 r
.51401 .60931 m .52823 .60162 L .52814 .61897 L p F P
0 0 0 r
s
1 .298 .126 r
.49561 .42723 m .5 .43002 L .5 .45454 L p F P
0 0 0 r
s
1 .298 .126 r
.5 .45454 m .49362 .45057 L .49561 .42723 L p F P
0 0 0 r
s
.26 .381 .757 r
.50638 .45057 m .5 .45454 L .5 .43002 L p F P
0 0 0 r
s
.83 .24 .1 r
.70706 .46199 m
.68757 .45889 L
s
.66205 .4414 m
.68757 .45889 L
s
.24 .35 .67 r
.31243 .45889 m
.33795 .4414 L
s
.31243 .45889 m
.29294 .46199 L
s
.83 .24 .1 r
.66205 .4414 m
.64124 .444 L
s
.61506 .42629 m
.64124 .444 L
s
.24 .35 .67 r
.35876 .444 m
.38494 .42629 L
s
.35876 .444 m
.33795 .4414 L
s
.992 .279 .115 r
.45994 .55376 m .44623 .54606 L .4498 .52466 L p F P
0 0 0 r
s
.967 .27 .111 r
.44623 .54606 m .45994 .55376 L .45819 .57451 L p F P
0 0 0 r
s
.175 .246 .506 r
.55615 .56661 m .54181 .57451 L .54006 .55376 L p F P
0 0 0 r
s
.175 .246 .506 r
.54006 .55376 m .55377 .54606 L .55615 .56661 L p F P
0 0 0 r
s
.83 .24 .1 r
.7493 .48796 m
.73196 .4792 L
s
.70706 .46199 m
.73196 .4792 L
s
.24 .35 .67 r
.26804 .4792 m
.29294 .46199 L
s
.26804 .4792 m
.2507 .48796 L
s
.092 .118 .262 r
.51361 .64118 m .5 .64833 L .5 .63395 L p F P
0 0 0 r
s
.83 .24 .1 r
.50999 .64309 m
.51598 .64627 L
s
.092 .118 .262 r
.5 .63395 m .51397 .62651 L .51361 .64118 L p F P
0 0 0 r
s
.804 .216 .086 r
.48603 .62651 m .5 .63395 L .5 .64833 L p F P
0 0 0 r
s
.24 .35 .67 r
.48402 .64627 m
.49496 .64046 L
s
.22636 .50483 m
.2507 .48796 L
s
.22636 .50483 m
.21199 .51895 L
s
.83 .24 .1 r
.77364 .50483 m
.78801 .51895 L
s
.7493 .48796 m
.77364 .50483 L
s
.61506 .42629 m
.59371 .43436 L
s
.56681 .41648 m
.59371 .43436 L
s
.24 .35 .67 r
.40629 .43436 m
.43319 .41648 L
s
.40629 .43436 m
.38494 .42629 L
s
1 .298 .126 r
.4912 .42443 m .49561 .42723 L .49362 .45057 L p F P
0 0 0 r
s
1 .298 .126 r
.49362 .45057 m .48719 .44656 L .4912 .42443 L p F P
0 0 0 r
s
.24 .35 .67 r
.48102 .44272 m
.48878 .43779 L
s
.26 .381 .757 r
.51281 .44656 m .50638 .45057 L .50439 .42723 L p F P
0 0 0 r
s
.26 .381 .757 r
.5 .43002 m .50439 .42723 L .50638 .45057 L p F P
0 0 0 r
s
1 .297 .125 r
.47421 .43848 m .48072 .44254 L .47519 .46444 L p F P
0 0 0 r
s
.83 .24 .1 r
.47901 .45021 m
.50136 .46403 L
s
1 .297 .125 r
.47519 .46444 m .46679 .45931 L .47421 .43848 L p F P
0 0 0 r
s
.24 .35 .67 r
.45433 .42961 m
.472 .44468 L
s
.236 .343 .687 r
.52481 .46444 m .53321 .45931 L .53983 .48089 L p F P
0 0 0 r
s
.248 .362 .723 r
.53321 .45931 m .52481 .46444 L .51928 .44254 L p F P
0 0 0 r
s
.83 .24 .1 r
.51993 .44332 m
.52547 .44684 L
s
.52547 .44684 m
.54567 .42961 L
s
.248 .362 .723 r
.51281 .44656 m .51928 .44254 L .52481 .46444 L p F P
0 0 0 r
s
1 .291 .121 r
.44996 .47478 m .46017 .48089 L .45447 .5028 L p F P
0 0 0 r
s
1 .291 .121 r
.45447 .5028 m .44276 .49595 L .44996 .47478 L p F P
0 0 0 r
s
1 .286 .119 r
.44276 .49595 m .45447 .5028 L .4498 .52466 L p F P
0 0 0 r
s
.209 .299 .607 r
.56315 .51724 m .5502 .52466 L .54553 .5028 L p F P
0 0 0 r
s
.209 .299 .607 r
.54553 .5028 m .55724 .49595 L .56315 .51724 L p F P
0 0 0 r
s
.223 .322 .648 r
.55724 .49595 m .54553 .5028 L .53983 .48089 L p F P
0 0 0 r
s
.24 .35 .67 r
.52293 .51576 m
.55122 .4992 L
s
1 .295 .123 r
.45831 .45414 m .46679 .45931 L .46017 .48089 L p F P
0 0 0 r
s
.83 .24 .1 r
.46252 .47381 m
.49058 .4907 L
s
1 .295 .123 r
.46017 .48089 m .44996 .47478 L .45831 .45414 L p F P
0 0 0 r
s
.223 .322 .648 r
.53983 .48089 m .55004 .47478 L .55724 .49595 L p F P
0 0 0 r
s
.236 .343 .687 r
.55004 .47478 m .53983 .48089 L .53321 .45931 L p F P
0 0 0 r
s
.24 .35 .67 r
.50942 .4907 m
.53748 .47381 L
s
.193 .274 .56 r
.56767 .53826 m .55377 .54606 L .5502 .52466 L p F P
0 0 0 r
s
.193 .274 .56 r
.5502 .52466 m .56315 .51724 L .56767 .53826 L p F P
0 0 0 r
s
1 .286 .119 r
.4498 .52466 m .43685 .51724 L .44276 .49595 L p F P
0 0 0 r
s
.83 .24 .1 r
.44878 .4992 m
.47707 .51576 L
s
.992 .279 .115 r
.43685 .51724 m .4498 .52466 L .44623 .54606 L p F P
0 0 0 r
s
.24 .35 .67 r
.53748 .47381 m
.55122 .4992 L
s
.83 .24 .1 r
.44878 .4992 m
.46252 .47381 L
s
1 .298 .126 r
.48677 .42162 m .4912 .42443 L .48719 .44656 L p F P
0 0 0 r
s
1 .298 .126 r
.48719 .44656 m .48072 .44254 L .48677 .42162 L p F P
0 0 0 r
s
.26 .381 .757 r
.51928 .44254 m .51281 .44656 L .5088 .42443 L p F P
0 0 0 r
s
.26 .381 .757 r
.50439 .42723 m .5088 .42443 L .51281 .44656 L p F P
0 0 0 r
s
.153 .212 .442 r
.55727 .58591 m .54265 .59382 L .54181 .57451 L p F P
0 0 0 r
s
.153 .212 .442 r
.54181 .57451 m .55615 .56661 L .55727 .58591 L p F P
0 0 0 r
s
.24 .35 .67 r
.53971 .5678 m
.54225 .59296 L
s
.967 .27 .111 r
.45819 .57451 m .44385 .56661 L .44623 .54606 L p F P
0 0 0 r
s
.931 .257 .105 r
.44385 .56661 m .45819 .57451 L .45735 .59382 L p F P
0 0 0 r
s
.931 .257 .105 r
.47177 .60162 m .45735 .59382 L .45819 .57451 L p F P
0 0 0 r
s
.83 .24 .1 r
.45775 .59296 m
.46029 .5678 L
s
.126 .17 .362 r
.54252 .61131 m .52814 .61897 L .52823 .60162 L p F P
0 0 0 r
s
.126 .17 .362 r
.52823 .60162 m .54265 .59382 L .54252 .61131 L p F P
0 0 0 r
s
.24 .35 .67 r
.51389 .60832 m
.54225 .59296 L
s
.88 .24 .097 r
.45735 .59382 m .47177 .60162 L .47186 .61897 L p F P
0 0 0 r
s
.88 .24 .097 r
.48603 .62651 m .47186 .61897 L .47177 .60162 L p F P
0 0 0 r
s
.83 .24 .1 r
.56681 .41648 m
.54567 .42961 L
s
1 .297 .125 r
.46766 .4344 m .47421 .43848 L .46679 .45931 L p F P
0 0 0 r
s
1 .297 .125 r
.46679 .45931 m .45831 .45414 L .46766 .4344 L p F P
0 0 0 r
s
.83 .24 .1 r
.46252 .47381 m
.47901 .45021 L
s
.236 .343 .687 r
.53321 .45931 m .54169 .45414 L .55004 .47478 L p F P
0 0 0 r
s
.248 .362 .723 r
.54169 .45414 m .53321 .45931 L .52579 .43848 L p F P
0 0 0 r
s
.248 .362 .723 r
.51928 .44254 m .52579 .43848 L .53321 .45931 L p F P
0 0 0 r
s
.24 .35 .67 r
.52099 .45021 m
.53748 .47381 L
s
.49864 .46403 m
.52099 .45021 L
s
.175 .246 .506 r
.57068 .5586 m .55615 .56661 L .55377 .54606 L p F P
0 0 0 r
s
.175 .246 .506 r
.55377 .54606 m .56767 .53826 L .57068 .5586 L p F P
0 0 0 r
s
.24 .35 .67 r
.53316 .54176 m
.56172 .5255 L
s
.992 .279 .115 r
.44623 .54606 m .43233 .53826 L .43685 .51724 L p F P
0 0 0 r
s
.967 .27 .111 r
.43233 .53826 m .44623 .54606 L .44385 .56661 L p F P
0 0 0 r
s
.83 .24 .1 r
.43828 .5255 m
.46684 .54176 L
s
.092 .118 .262 r
.52741 .63394 m .51361 .64118 L .51397 .62651 L p F P
0 0 0 r
s
.24 .35 .67 r
.5119 .63147 m
.51389 .60832 L
s
.092 .118 .262 r
.51397 .62651 m .52814 .61897 L .52741 .63394 L p F P
0 0 0 r
s
.804 .216 .086 r
.47186 .61897 m .48603 .62651 L .48639 .64118 L p F P
0 0 0 r
s
.804 .216 .086 r
.5 .64833 m .48639 .64118 L .48603 .62651 L p F P
0 0 0 r
s
.83 .24 .1 r
.48611 .60832 m
.4881 .63147 L
s
.4881 .63147 m
.50074 .63818 L
s
.24 .35 .67 r
.49926 .63818 m
.5119 .63147 L
s
1 .291 .121 r
.43965 .46862 m .44996 .47478 L .44276 .49595 L p F P
0 0 0 r
s
1 .291 .121 r
.44276 .49595 m .43092 .48902 L .43965 .46862 L p F P
0 0 0 r
s
1 .286 .119 r
.43092 .48902 m .44276 .49595 L .43685 .51724 L p F P
0 0 0 r
s
.83 .24 .1 r
.43828 .5255 m
.44878 .4992 L
s
.209 .299 .607 r
.57627 .50972 m .56315 .51724 L .55724 .49595 L p F P
0 0 0 r
s
.209 .299 .607 r
.55724 .49595 m .56908 .48902 L .57627 .50972 L p F P
0 0 0 r
s
.24 .35 .67 r
.55122 .4992 m
.56172 .5255 L
s
.223 .322 .648 r
.56908 .48902 m .55724 .49595 L .55004 .47478 L p F P
0 0 0 r
s
1 .295 .123 r
.44976 .44892 m .45831 .45414 L .44996 .47478 L p F P
0 0 0 r
s
1 .295 .123 r
.44996 .47478 m .43965 .46862 L .44976 .44892 L p F P
0 0 0 r
s
.223 .322 .648 r
.55004 .47478 m .56035 .46862 L .56908 .48902 L p F P
0 0 0 r
s
.236 .343 .687 r
.56035 .46862 m .55004 .47478 L .54169 .45414 L p F P
0 0 0 r
s
1 .298 .126 r
.48232 .41879 m .48677 .42162 L .48072 .44254 L p F P
0 0 0 r
s
1 .298 .126 r
.48072 .44254 m .47421 .43848 L .48232 .41879 L p F P
0 0 0 r
s
.26 .381 .757 r
.52579 .43848 m .51928 .44254 L .51323 .42162 L p F P
0 0 0 r
s
.26 .381 .757 r
.5088 .42443 m .51323 .42162 L .51928 .44254 L p F P
0 0 0 r
s
1 .286 .119 r
.43685 .51724 m .42373 .50972 L .43092 .48902 L p F P
0 0 0 r
s
.992 .279 .115 r
.42373 .50972 m .43685 .51724 L .43233 .53826 L p F P
0 0 0 r
s
.193 .274 .56 r
.58176 .53034 m .56767 .53826 L .56315 .51724 L p F P
0 0 0 r
s
.193 .274 .56 r
.56315 .51724 m .57627 .50972 L .58176 .53034 L p F P
0 0 0 r
s
1 .298 .126 r
.49775 .40504 m .5 .4065 L .5 .43002 L p F P
0 0 0 r
s
1 .298 .126 r
.5 .43002 m .49561 .42723 L .49775 .40504 L p F P
0 0 0 r
s
.271 .4 .791 r
.50439 .42723 m .5 .43002 L .5 .4065 L p F P
0 0 0 r
s
.83 .24 .1 r
.49771 .42921 m
.50258 .43231 L
s
.24 .35 .67 r
.49742 .43231 m
.50229 .42921 L
s
1 .297 .125 r
.46107 .43029 m .46766 .4344 L .45831 .45414 L p F P
0 0 0 r
s
1 .297 .125 r
.45831 .45414 m .44976 .44892 L .46107 .43029 L p F P
0 0 0 r
s
.236 .343 .687 r
.54169 .45414 m .55024 .44892 L .56035 .46862 L p F P
0 0 0 r
s
.248 .362 .723 r
.55024 .44892 m .54169 .45414 L .53234 .4344 L p F P
0 0 0 r
s
.248 .362 .723 r
.52579 .43848 m .53234 .4344 L .54169 .45414 L p F P
0 0 0 r
s
.24 .35 .67 r
.46668 .68324 m
.47745 .66657 L
s
.83 .24 .1 r
.52255 .66657 m
.53332 .68324 L
s
.24 .35 .67 r
.42414 .70971 m
.43905 .69751 L
s
.43905 .69751 m
.46668 .68324 L
s
.83 .24 .1 r
.53332 .68324 m
.56095 .69751 L
s
.56095 .69751 m
.57586 .70971 L
s
1 .298 .126 r
.47785 .41595 m .48232 .41879 L .47421 .43848 L p F P
0 0 0 r
s
.83 .24 .1 r
.47901 .45021 m
.49771 .42921 L
s
1 .298 .126 r
.47421 .43848 m .46766 .4344 L .47785 .41595 L p F P
0 0 0 r
s
.26 .381 .757 r
.53234 .4344 m .52579 .43848 L .51768 .41879 L p F P
0 0 0 r
s
.26 .381 .757 r
.51323 .42162 m .51768 .41879 L .52579 .43848 L p F P
0 0 0 r
s
.24 .35 .67 r
.50229 .42921 m
.52099 .45021 L
s
1 .298 .126 r
.49549 .40358 m .49775 .40504 L .49561 .42723 L p F P
0 0 0 r
s
1 .298 .126 r
.49561 .42723 m .4912 .42443 L .49549 .40358 L p F P
0 0 0 r
s
.271 .4 .791 r
.5088 .42443 m .50439 .42723 L .50225 .40504 L p F P
0 0 0 r
s
.271 .4 .791 r
.5 .4065 m .50225 .40504 L .50439 .42723 L p F P
0 0 0 r
s
.24 .35 .67 r
.37862 .73074 m
.39708 .72362 L
s
.39708 .72362 m
.42414 .70971 L
s
.83 .24 .1 r
.57586 .70971 m
.60292 .72362 L
s
.60292 .72362 m
.62138 .73074 L
s
.967 .27 .111 r
.44385 .56661 m .42932 .5586 L .43233 .53826 L p F P
0 0 0 r
s
.931 .257 .105 r
.42932 .5586 m .44385 .56661 L .44273 .58591 L p F P
0 0 0 r
s
.931 .257 .105 r
.45735 .59382 m .44273 .58591 L .44385 .56661 L p F P
0 0 0 r
s
.153 .212 .442 r
.57211 .57788 m .55727 .58591 L .55615 .56661 L p F P
0 0 0 r
s
.153 .212 .442 r
.55615 .56661 m .57068 .5586 L .57211 .57788 L p F P
0 0 0 r
s
.689 .18 .07 r
.48639 .64118 m .5 .64833 L .5 .65967 L p F P
0 0 0 r
s
.062 .08 .171 r
.51292 .65296 m .5 .65967 L .5 .64833 L p F P
0 0 0 r
s
.83 .24 .1 r
.50468 .65724 m
.52255 .66657 L
s
.062 .08 .171 r
.5 .64833 m .51361 .64118 L .51292 .65296 L p F P
0 0 0 r
s
.24 .35 .67 r
.50563 .65186 m
.5119 .63147 L
s
.88 .24 .097 r
.44273 .58591 m .45735 .59382 L .45748 .61131 L p F P
0 0 0 r
s
.88 .24 .097 r
.47186 .61897 m .45748 .61131 L .45735 .59382 L p F P
0 0 0 r
s
.83 .24 .1 r
.45775 .59296 m
.48611 .60832 L
s
.126 .17 .362 r
.5571 .60355 m .54252 .61131 L .54265 .59382 L p F P
0 0 0 r
s
.126 .17 .362 r
.54265 .59382 m .55727 .58591 L .5571 .60355 L p F P
0 0 0 r
s
.24 .35 .67 r
.33101 .74598 m
.35219 .74436 L
s
.35219 .74436 m
.37862 .73074 L
s
.83 .24 .1 r
.62138 .73074 m
.64781 .74436 L
s
.66899 .74598 m
.64781 .74436 L
s
1 .295 .123 r
.44114 .44366 m .44976 .44892 L .43965 .46862 L p F P
0 0 0 r
s
1 .295 .123 r
.43965 .46862 m .42923 .4624 L .44114 .44366 L p F P
0 0 0 r
s
1 .291 .121 r
.42923 .4624 m .43965 .46862 L .43092 .48902 L p F P
0 0 0 r
s
.223 .322 .648 r
.58107 .482 m .56908 .48902 L .56035 .46862 L p F P
0 0 0 r
s
.223 .322 .648 r
.56035 .46862 m .57077 .4624 L .58107 .482 L p F P
0 0 0 r
s
.236 .343 .687 r
.57077 .4624 m .56035 .46862 L .55024 .44892 L p F P
0 0 0 r
s
.992 .279 .115 r
.43233 .53826 m .41824 .53034 L .42373 .50972 L p F P
0 0 0 r
s
.967 .27 .111 r
.41824 .53034 m .43233 .53826 L .42932 .5586 L p F P
0 0 0 r
s
.83 .24 .1 r
.43144 .5518 m
.43828 .5255 L
s
.43144 .5518 m
.46029 .5678 L
s
.175 .246 .506 r
.58543 .55048 m .57068 .5586 L .56767 .53826 L p F P
0 0 0 r
s
.24 .35 .67 r
.53971 .5678 m
.56856 .5518 L
s
.175 .246 .506 r
.56767 .53826 m .58176 .53034 L .58543 .55048 L p F P
0 0 0 r
s
.24 .35 .67 r
.56172 .5255 m
.56856 .5518 L
s
1 .291 .121 r
.43092 .48902 m .41893 .482 L .42923 .4624 L p F P
0 0 0 r
s
1 .286 .119 r
.41893 .482 m .43092 .48902 L .42373 .50972 L p F P
0 0 0 r
s
.209 .299 .607 r
.58955 .50211 m .57627 .50972 L .56908 .48902 L p F P
0 0 0 r
s
.209 .299 .607 r
.56908 .48902 m .58107 .482 L .58955 .50211 L p F P
0 0 0 r
s
.24 .35 .67 r
.55122 .4992 m
.58032 .48217 L
s
.83 .24 .1 r
.68143 .44427 m
.66205 .4414 L
s
.6358 .4234 m
.66205 .4414 L
s
.24 .35 .67 r
.33795 .4414 m
.3642 .4234 L
s
.33795 .4414 m
.31857 .44427 L
s
.83 .24 .1 r
.6358 .4234 m
.61506 .42629 L
s
.58812 .40807 m
.61506 .42629 L
s
.24 .35 .67 r
.38494 .42629 m
.41188 .40807 L
s
.38494 .42629 m
.3642 .4234 L
s
1 .298 .126 r
.49323 .40212 m .49549 .40358 L .4912 .42443 L p F P
0 0 0 r
s
1 .298 .126 r
.4912 .42443 m .48677 .42162 L .49323 .40212 L p F P
0 0 0 r
s
.271 .4 .791 r
.51323 .42162 m .5088 .42443 L .50451 .40358 L p F P
0 0 0 r
s
.271 .4 .791 r
.50225 .40504 m .50451 .40358 L .5088 .42443 L p F P
0 0 0 r
s
.83 .24 .1 r
.49771 .42921 m
.50511 .42278 L
s
.24 .35 .67 r
.49489 .42278 m
.50229 .42921 L
s
.83 .24 .1 r
.72426 .47061 m
.70706 .46199 L
s
.68143 .44427 m
.70706 .46199 L
s
.24 .35 .67 r
.29294 .46199 m
.31857 .44427 L
s
.29294 .46199 m
.27574 .47061 L
s
1 .297 .125 r
.45443 .42616 m .46107 .43029 L .44976 .44892 L p F P
0 0 0 r
s
1 .297 .125 r
.44976 .44892 m .44114 .44366 L .45443 .42616 L p F P
0 0 0 r
s
.24 .35 .67 r
.43319 .41648 m
.45262 .42855 L
s
.236 .343 .687 r
.55024 .44892 m .55886 .44366 L .57077 .4624 L p F P
0 0 0 r
s
.248 .362 .723 r
.55886 .44366 m .55024 .44892 L .53893 .43029 L p F P
0 0 0 r
s
.248 .362 .723 r
.53234 .4344 m .53893 .43029 L .55024 .44892 L p F P
0 0 0 r
s
1 .298 .126 r
.47336 .4131 m .47785 .41595 L .46766 .4344 L p F P
0 0 0 r
s
.24 .35 .67 r
.45709 .42782 m
.47203 .4181 L
s
1 .298 .126 r
.46766 .4344 m .46107 .43029 L .47336 .4131 L p F P
0 0 0 r
s
.26 .381 .757 r
.53893 .43029 m .53234 .4344 L .52215 .41595 L p F P
0 0 0 r
s
.26 .381 .757 r
.51768 .41879 m .52215 .41595 L .53234 .4344 L p F P
0 0 0 r
s
.092 .118 .262 r
.5414 .62659 m .52741 .63394 L .52814 .61897 L p F P
0 0 0 r
s
.092 .118 .262 r
.52814 .61897 m .54252 .61131 L .5414 .62659 L p F P
0 0 0 r
s
.24 .35 .67 r
.5119 .63147 m
.54059 .61625 L
s
.804 .216 .086 r
.45748 .61131 m .47186 .61897 L .47259 .63394 L p F P
0 0 0 r
s
.804 .216 .086 r
.48639 .64118 m .47259 .63394 L .47186 .61897 L p F P
0 0 0 r
s
.24 .35 .67 r
.2507 .48796 m
.27574 .47061 L
s
.2507 .48796 m
.23648 .50203 L
s
.83 .24 .1 r
.76352 .50203 m
.7493 .48796 L
s
.72426 .47061 m
.7493 .48796 L
s
.24 .35 .67 r
.21199 .51895 m
.23648 .50203 L
s
.21199 .51895 m
.20151 .53787 L
s
.83 .24 .1 r
.78801 .51895 m
.79849 .53787 L
s
.76352 .50203 m
.78801 .51895 L
s
1 .286 .119 r
.42373 .50972 m .41045 .50211 L .41893 .482 L p F P
0 0 0 r
s
.83 .24 .1 r
.41968 .48217 m
.44878 .4992 L
s
.992 .279 .115 r
.41045 .50211 m .42373 .50972 L .41824 .53034 L p F P
0 0 0 r
s
.193 .274 .56 r
.59605 .52232 m .58176 .53034 L .57627 .50972 L p F P
0 0 0 r
s
.193 .274 .56 r
.57627 .50972 m .58955 .50211 L .59605 .52232 L p F P
0 0 0 r
s
1 .298 .126 r
.49097 .40065 m .49323 .40212 L .48677 .42162 L p F P
0 0 0 r
s
1 .298 .126 r
.48677 .42162 m .48232 .41879 L .49097 .40065 L p F P
0 0 0 r
s
.271 .4 .791 r
.51768 .41879 m .51323 .42162 L .50677 .40212 L p F P
0 0 0 r
s
.271 .4 .791 r
.50451 .40358 m .50677 .40212 L .51323 .42162 L p F P
0 0 0 r
s
.248 .362 .723 r
.53893 .43029 m .54557 .42616 L .55886 .44366 L p F P
0 0 0 r
s
.26 .381 .757 r
.54557 .42616 m .53893 .43029 L .52664 .4131 L p F P
0 0 0 r
s
.26 .381 .757 r
.52215 .41595 m .52664 .4131 L .53893 .43029 L p F P
0 0 0 r
s
1 .298 .126 r
.46885 .41024 m .47336 .4131 L .46107 .43029 L p F P
0 0 0 r
s
1 .298 .126 r
.46107 .43029 m .45443 .42616 L .46885 .41024 L p F P
0 0 0 r
s
1 .295 .123 r
.43245 .43835 m .44114 .44366 L .42923 .4624 L p F P
0 0 0 r
s
.83 .24 .1 r
.43365 .45644 m
.46252 .47381 L
s
1 .295 .123 r
.42923 .4624 m .41871 .45611 L .43245 .43835 L p F P
0 0 0 r
s
1 .291 .121 r
.41871 .45611 m .42923 .4624 L .41893 .482 L p F P
0 0 0 r
s
.223 .322 .648 r
.59319 .47491 m .58107 .482 L .57077 .4624 L p F P
0 0 0 r
s
.223 .322 .648 r
.57077 .4624 m .58129 .45611 L .59319 .47491 L p F P
0 0 0 r
s
.236 .343 .687 r
.58129 .45611 m .57077 .4624 L .55886 .44366 L p F P
0 0 0 r
s
.24 .35 .67 r
.53748 .47381 m
.56635 .45644 L
s
1 .298 .126 r
.4887 .39918 m .49097 .40065 L .48232 .41879 L p F P
0 0 0 r
s
1 .298 .126 r
.48232 .41879 m .47785 .41595 L .4887 .39918 L p F P
0 0 0 r
s
.24 .35 .67 r
.47658 .41514 m
.47969 .41312 L
s
.271 .4 .791 r
.52215 .41595 m .51768 .41879 L .50903 .40065 L p F P
0 0 0 r
s
.83 .24 .1 r
.51981 .41279 m
.52342 .41514 L
s
.51897 .41224 m
.51981 .41279 L
s
.51478 .41437 m
.51534 .41389 L
s
.271 .4 .791 r
.50677 .40212 m .50903 .40065 L .51768 .41879 L p F P
0 0 0 r
s
1 .297 .125 r
.44775 .422 m .45443 .42616 L .44114 .44366 L p F P
0 0 0 r
s
.83 .24 .1 r
.45033 .43247 m
.47901 .45021 L
s
1 .297 .125 r
.44114 .44366 m .43245 .43835 L .44775 .422 L p F P
0 0 0 r
s
.236 .343 .687 r
.55886 .44366 m .56755 .43835 L .58129 .45611 L p F P
0 0 0 r
s
.248 .362 .723 r
.56755 .43835 m .55886 .44366 L .54557 .42616 L p F P
0 0 0 r
s
.24 .35 .67 r
.52099 .45021 m
.54967 .43247 L
s
.56635 .45644 m
.58032 .48217 L
s
.54967 .43247 m
.56635 .45644 L
s
.83 .24 .1 r
.43365 .45644 m
.45033 .43247 L
s
.41968 .48217 m
.43365 .45644 L
s
.689 .18 .07 r
.47259 .63394 m .48639 .64118 L .48708 .65296 L p F P
0 0 0 r
s
.689 .18 .07 r
.5 .65967 m .48708 .65296 L .48639 .64118 L p F P
0 0 0 r
s
.24 .35 .67 r
.49921 .65521 m
.50563 .65186 L
s
.83 .24 .1 r
.49437 .65186 m
.50079 .65521 L
s
.24 .35 .67 r
.47745 .66657 m
.49532 .65724 L
s
.83 .24 .1 r
.4881 .63147 m
.49437 .65186 L
s
.062 .08 .171 r
.52602 .64616 m .51292 .65296 L .51361 .64118 L p F P
0 0 0 r
s
.062 .08 .171 r
.51361 .64118 m .52741 .63394 L .52602 .64616 L p F P
0 0 0 r
s
.153 .212 .442 r
.58716 .56973 m .57211 .57788 L .57068 .5586 L p F P
0 0 0 r
s
.153 .212 .442 r
.57068 .5586 m .58543 .55048 L .58716 .56973 L p F P
0 0 0 r
s
.24 .35 .67 r
.56856 .5518 m
.57144 .57715 L
s
.967 .27 .111 r
.42932 .5586 m .41457 .55048 L .41824 .53034 L p F P
0 0 0 r
s
.931 .257 .105 r
.41457 .55048 m .42932 .5586 L .42789 .57788 L p F P
0 0 0 r
s
.931 .257 .105 r
.44273 .58591 m .42789 .57788 L .42932 .5586 L p F P
0 0 0 r
s
.83 .24 .1 r
.42856 .57715 m
.43144 .5518 L
s
1 .291 .121 r
.41893 .482 m .40681 .47491 L .41871 .45611 L p F P
0 0 0 r
s
1 .286 .119 r
.40681 .47491 m .41893 .482 L .41045 .50211 L p F P
0 0 0 r
s
.209 .299 .607 r
.60301 .4944 m .58955 .50211 L .58107 .482 L p F P
0 0 0 r
s
.209 .299 .607 r
.58107 .482 m .59319 .47491 L .60301 .4944 L p F P
0 0 0 r
s
.126 .17 .362 r
.57189 .59567 m .5571 .60355 L .55727 .58591 L p F P
0 0 0 r
s
.126 .17 .362 r
.55727 .58591 m .57211 .57788 L .57189 .59567 L p F P
0 0 0 r
s
.24 .35 .67 r
.54225 .59296 m
.57144 .57715 L
s
.88 .24 .097 r
.42789 .57788 m .44273 .58591 L .4429 .60355 L p F P
0 0 0 r
s
.88 .24 .097 r
.45748 .61131 m .4429 .60355 L .44273 .58591 L p F P
0 0 0 r
s
.175 .246 .506 r
.60039 .54224 m .58543 .55048 L .58176 .53034 L p F P
0 0 0 r
s
.175 .246 .506 r
.58176 .53034 m .59605 .52232 L .60039 .54224 L p F P
0 0 0 r
s
.992 .279 .115 r
.41824 .53034 m .40395 .52232 L .41045 .50211 L p F P
0 0 0 r
s
.967 .27 .111 r
.40395 .52232 m .41824 .53034 L .41457 .55048 L p F P
0 0 0 r
s
1 .298 .126 r
.48642 .39771 m .4887 .39918 L .47785 .41595 L p F P
0 0 0 r
s
1 .298 .126 r
.47785 .41595 m .47336 .4131 L .48642 .39771 L p F P
0 0 0 r
s
.271 .4 .791 r
.52664 .4131 m .52215 .41595 L .5113 .39918 L p F P
0 0 0 r
s
.83 .24 .1 r
.51826 .41142 m
.51893 .41099 L
s
.271 .4 .791 r
.50903 .40065 m .5113 .39918 L .52215 .41595 L p F P
0 0 0 r
s
1 .298 .126 r
.46433 .40736 m .46885 .41024 L .45443 .42616 L p F P
0 0 0 r
s
1 .298 .126 r
.45443 .42616 m .44775 .422 L .46433 .40736 L p F P
0 0 0 r
s
.248 .362 .723 r
.54557 .42616 m .55225 .422 L .56755 .43835 L p F P
0 0 0 r
s
.26 .381 .757 r
.55225 .422 m .54557 .42616 L .53115 .41024 L p F P
0 0 0 r
s
.26 .381 .757 r
.52664 .4131 m .53115 .41024 L .54557 .42616 L p F P
0 0 0 r
s
.092 .118 .262 r
.55558 .61914 m .5414 .62659 L .54252 .61131 L p F P
0 0 0 r
s
.24 .35 .67 r
.54059 .61625 m
.54225 .59296 L
s
.092 .118 .262 r
.54252 .61131 m .5571 .60355 L .55558 .61914 L p F P
0 0 0 r
s
.804 .216 .086 r
.4429 .60355 m .45748 .61131 L .4586 .62659 L p F P
0 0 0 r
s
.804 .216 .086 r
.47259 .63394 m .4586 .62659 L .45748 .61131 L p F P
0 0 0 r
s
.83 .24 .1 r
.45775 .59296 m
.45941 .61625 L
s
.45941 .61625 m
.4881 .63147 L
s
.193 .274 .56 r
.61053 .51419 m .59605 .52232 L .58955 .50211 L p F P
0 0 0 r
s
.193 .274 .56 r
.58955 .50211 m .60301 .4944 L .61053 .51419 L p F P
0 0 0 r
s
.24 .35 .67 r
.58032 .48217 m
.59109 .50877 L
s
.56172 .5255 m
.59109 .50877 L
s
1 .286 .119 r
.41045 .50211 m .39699 .4944 L .40681 .47491 L p F P
0 0 0 r
s
.992 .279 .115 r
.39699 .4944 m .41045 .50211 L .40395 .52232 L p F P
0 0 0 r
s
.83 .24 .1 r
.40891 .50877 m
.41968 .48217 L
s
.40891 .50877 m
.43828 .5255 L
s
1 .298 .126 r
.48414 .39623 m .48642 .39771 L .47336 .4131 L p F P
0 0 0 r
s
1 .298 .126 r
.47336 .4131 m .46885 .41024 L .48414 .39623 L p F P
0 0 0 r
s
.83 .24 .1 r
.46915 .41108 m
.49771 .42921 L
s
.271 .4 .791 r
.53115 .41024 m .52664 .4131 L .51358 .39771 L p F P
0 0 0 r
s
.83 .24 .1 r
.52209 .40897 m
.52277 .40854 L
s
.271 .4 .791 r
.5113 .39918 m .51358 .39771 L .52664 .4131 L p F P
0 0 0 r
s
.24 .35 .67 r
.50229 .42921 m
.53085 .41108 L
s
1 .297 .125 r
.44102 .41781 m .44775 .422 L .43245 .43835 L p F P
0 0 0 r
s
1 .297 .125 r
.43245 .43835 m .42368 .433 L .44102 .41781 L p F P
0 0 0 r
s
1 .295 .123 r
.42368 .433 m .43245 .43835 L .41871 .45611 L p F P
0 0 0 r
s
.236 .343 .687 r
.59192 .44975 m .58129 .45611 L .56755 .43835 L p F P
0 0 0 r
s
.236 .343 .687 r
.56755 .43835 m .57632 .433 L .59192 .44975 L p F P
0 0 0 r
s
.248 .362 .723 r
.57632 .433 m .56755 .43835 L .55225 .422 L p F P
0 0 0 r
s
1 .296 .126 r
.5 .4065 m .49775 .40504 L .5 .38446 L closepath p F P
0 0 0 r
s
.283 .419 .824 r
.5 .38446 m .50225 .40504 L .5 .4065 L closepath p F P
0 0 0 r
s
1 .295 .123 r
.41871 .45611 m .40808 .44975 L .42368 .433 L p F P
0 0 0 r
s
1 .291 .121 r
.40808 .44975 m .41871 .45611 L .40681 .47491 L p F P
0 0 0 r
s
.223 .322 .648 r
.60546 .46773 m .59319 .47491 L .58129 .45611 L p F P
0 0 0 r
s
.223 .322 .648 r
.58129 .45611 m .59192 .44975 L .60546 .46773 L p F P
0 0 0 r
s
1 .296 .126 r
.49775 .40504 m .49549 .40358 L .5 .38446 L closepath p F P
0 0 0 r
s
.283 .419 .824 r
.5 .38446 m .50451 .40358 L .50225 .40504 L closepath p F P
0 0 0 r
s
1 .298 .126 r
.45978 .40447 m .46433 .40736 L .44775 .422 L p F P
0 0 0 r
s
1 .298 .126 r
.44775 .422 m .44102 .41781 L .45978 .40447 L p F P
0 0 0 r
s
.83 .24 .1 r
.45033 .43247 m
.46915 .41108 L
s
.248 .362 .723 r
.55225 .422 m .55898 .41781 L .57632 .433 L p F P
0 0 0 r
s
.26 .381 .757 r
.55898 .41781 m .55225 .422 L .53567 .40736 L p F P
0 0 0 r
s
.26 .381 .757 r
.53115 .41024 m .53567 .40736 L .55225 .422 L p F P
0 0 0 r
s
.24 .35 .67 r
.53085 .41108 m
.54967 .43247 L
s
1 .298 .126 r
.48186 .39476 m .48414 .39623 L .46885 .41024 L p F P
0 0 0 r
s
1 .298 .126 r
.46885 .41024 m .46433 .40736 L .48186 .39476 L p F P
0 0 0 r
s
.271 .4 .791 r
.53567 .40736 m .53115 .41024 L .51586 .39623 L p F P
0 0 0 r
s
.83 .24 .1 r
.52593 .40652 m
.52661 .40608 L
s
.271 .4 .791 r
.51358 .39771 m .51586 .39623 L .53115 .41024 L p F P
0 0 0 r
s
.209 .299 .607 r
.61665 .48658 m .60301 .4944 L .59319 .47491 L p F P
0 0 0 r
s
.209 .299 .607 r
.59319 .47491 m .60546 .46773 L .61665 .48658 L p F P
0 0 0 r
s
1 .291 .121 r
.40681 .47491 m .39454 .46773 L .40808 .44975 L p F P
0 0 0 r
s
1 .286 .119 r
.39454 .46773 m .40681 .47491 L .39699 .4944 L p F P
0 0 0 r
s
1 .296 .126 r
.49549 .40358 m .49323 .40212 L .5 .38446 L closepath p F P
0 0 0 r
s
.283 .419 .824 r
.5 .38446 m .50677 .40212 L .50451 .40358 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.45199 .69539 m
.46668 .68324 L
s
.46668 .68324 m
.49513 .66855 L
s
.83 .24 .1 r
.50487 .66855 m
.53332 .68324 L
s
.53332 .68324 m
.54801 .69539 L
s
.062 .08 .171 r
.53928 .63926 m .52602 .64616 L .52741 .63394 L p F P
0 0 0 r
s
.062 .08 .171 r
.52741 .63394 m .5414 .62659 L .53928 .63926 L p F P
0 0 0 r
s
.689 .18 .07 r
.4586 .62659 m .47259 .63394 L .47398 .64616 L p F P
0 0 0 r
s
.689 .18 .07 r
.48708 .65296 m .47398 .64616 L .47259 .63394 L p F P
0 0 0 r
s
.029 .04 .077 r
.51191 .66148 m .5 .66762 L .5 .65967 L p F P
0 0 0 r
s
.83 .24 .1 r
.50336 .66615 m
.50487 .66855 L
s
.50324 .66595 m
.50336 .66615 L
s
.029 .04 .077 r
.5 .65967 m .51292 .65296 L .51191 .66148 L p F P
0 0 0 r
s
.54 .134 .052 r
.48708 .65296 m .5 .65967 L .5 .66762 L p F P
0 0 0 r
s
.24 .35 .67 r
.40583 .71672 m
.42414 .70971 L
s
.42414 .70971 m
.45199 .69539 L
s
.83 .24 .1 r
.54801 .69539 m
.57586 .70971 L
s
.57586 .70971 m
.59417 .71672 L
s
.967 .27 .111 r
.41457 .55048 m .39961 .54224 L .40395 .52232 L p F P
0 0 0 r
s
.931 .257 .105 r
.39961 .54224 m .41457 .55048 L .41284 .56973 L p F P
0 0 0 r
s
.931 .257 .105 r
.42789 .57788 m .41284 .56973 L .41457 .55048 L p F P
0 0 0 r
s
.153 .212 .442 r
.60244 .56147 m .58716 .56973 L .58543 .55048 L p F P
0 0 0 r
s
.153 .212 .442 r
.58543 .55048 m .60039 .54224 L .60244 .56147 L p F P
0 0 0 r
s
1 .296 .126 r
.49323 .40212 m .49097 .40065 L .5 .38446 L closepath p F P
0 0 0 r
s
.283 .419 .824 r
.5 .38446 m .50903 .40065 L .50677 .40212 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.30815 .74169 m
.33101 .74598 L
s
.33101 .74598 m
.35751 .73219 L
s
.83 .24 .1 r
.64249 .73219 m
.66899 .74598 L
s
.69185 .74169 m
.66899 .74598 L
s
.88 .24 .097 r
.41284 .56973 m .42789 .57788 L .42811 .59567 L p F P
0 0 0 r
s
.88 .24 .097 r
.4429 .60355 m .42811 .59567 L .42789 .57788 L p F P
0 0 0 r
s
.83 .24 .1 r
.42856 .57715 m
.45775 .59296 L
s
.126 .17 .362 r
.58689 .58768 m .57189 .59567 L .57211 .57788 L p F P
0 0 0 r
s
.126 .17 .362 r
.57211 .57788 m .58716 .56973 L .58689 .58768 L p F P
0 0 0 r
s
.24 .35 .67 r
.35751 .73219 m
.37862 .73074 L
s
.37862 .73074 m
.40583 .71672 L
s
.83 .24 .1 r
.59417 .71672 m
.62138 .73074 L
s
.62138 .73074 m
.64249 .73219 L
s
.175 .246 .506 r
.61556 .53388 m .60039 .54224 L .59605 .52232 L p F P
0 0 0 r
s
.24 .35 .67 r
.56856 .5518 m
.59825 .53532 L
s
.175 .246 .506 r
.59605 .52232 m .61053 .51419 L .61556 .53388 L p F P
0 0 0 r
s
.24 .35 .67 r
.59109 .50877 m
.59825 .53532 L
s
.992 .279 .115 r
.40395 .52232 m .38947 .51419 L .39699 .4944 L p F P
0 0 0 r
s
.967 .27 .111 r
.38947 .51419 m .40395 .52232 L .39961 .54224 L p F P
0 0 0 r
s
.83 .24 .1 r
.40175 .53532 m
.40891 .50877 L
s
.40175 .53532 m
.43144 .5518 L
s
1 .297 .125 r
.43425 .41359 m .44102 .41781 L .42368 .433 L p F P
0 0 0 r
s
1 .297 .125 r
.42368 .433 m .41483 .4276 L .43425 .41359 L p F P
0 0 0 r
s
.24 .35 .67 r
.41188 .40807 m
.43129 .41573 L
s
1 .295 .123 r
.41483 .4276 m .42368 .433 L .40808 .44975 L p F P
0 0 0 r
s
.236 .343 .687 r
.60267 .44333 m .59192 .44975 L .57632 .433 L p F P
0 0 0 r
s
.236 .343 .687 r
.57632 .433 m .58517 .4276 L .60267 .44333 L p F P
0 0 0 r
s
.248 .362 .723 r
.58517 .4276 m .57632 .433 L .55898 .41781 L p F P
0 0 0 r
s
1 .298 .126 r
.47956 .39327 m .48186 .39476 L .46433 .40736 L p F P
0 0 0 r
s
1 .298 .126 r
.46433 .40736 m .45978 .40447 L .47956 .39327 L p F P
0 0 0 r
s
.26 .381 .757 r
.53567 .40736 m .54022 .40447 L .55898 .41781 L p F P
0 0 0 r
s
.271 .4 .791 r
.54022 .40447 m .53567 .40736 L .51814 .39476 L p F P
0 0 0 r
s
.83 .24 .1 r
.52979 .40405 m
.53047 .40362 L
s
.271 .4 .791 r
.51586 .39623 m .51814 .39476 L .53567 .40736 L p F P
0 0 0 r
s
1 .296 .126 r
.49097 .40065 m .4887 .39918 L .5 .38446 L closepath p F P
0 0 0 r
s
.283 .419 .824 r
.5 .38446 m .5113 .39918 L .50903 .40065 L closepath p F P
0 0 0 r
s
1 .298 .126 r
.45521 .40157 m .45978 .40447 L .44102 .41781 L p F P
0 0 0 r
s
.24 .35 .67 r
.43595 .41465 m
.45461 .40225 L
s
.45543 .40171 m
.45905 .3993 L
s
1 .298 .126 r
.44102 .41781 m .43425 .41359 L .45521 .40157 L p F P
0 0 0 r
s
.248 .362 .723 r
.55898 .41781 m .56575 .41359 L .58517 .4276 L p F P
0 0 0 r
s
.83 .24 .1 r
.56871 .41573 m
.58812 .40807 L
s
.26 .381 .757 r
.56575 .41359 m .55898 .41781 L .54022 .40447 L p F P
0 0 0 r
s
.83 .24 .1 r
.54095 .3993 m
.55863 .41105 L
s
.65506 .42604 m
.6358 .4234 L
s
.24 .35 .67 r
.3642 .4234 m
.34494 .42604 L
s
1 .295 .123 r
.40808 .44975 m .39733 .44333 L .41483 .4276 L p F P
0 0 0 r
s
1 .291 .121 r
.39733 .44333 m .40808 .44975 L .39454 .46773 L p F P
0 0 0 r
s
.223 .322 .648 r
.61787 .46047 m .60546 .46773 L .59192 .44975 L p F P
0 0 0 r
s
.223 .322 .648 r
.59192 .44975 m .60267 .44333 L .61787 .46047 L p F P
0 0 0 r
s
.83 .24 .1 r
.69849 .45274 m
.68143 .44427 L
s
.65506 .42604 m
.68143 .44427 L
s
.24 .35 .67 r
.31857 .44427 m
.34494 .42604 L
s
.31857 .44427 m
.30151 .45274 L
s
1 .296 .126 r
.4887 .39918 m .48642 .39771 L .5 .38446 L closepath p F P
0 0 0 r
s
.283 .419 .824 r
.5 .38446 m .51358 .39771 L .5113 .39918 L closepath p F P
0 0 0 r
s
.193 .274 .56 r
.62522 .50594 m .61053 .51419 L .60301 .4944 L p F P
0 0 0 r
s
.193 .274 .56 r
.60301 .4944 m .61665 .48658 L .62522 .50594 L p F P
0 0 0 r
s
1 .286 .119 r
.39699 .4944 m .38335 .48658 L .39454 .46773 L p F P
0 0 0 r
s
.992 .279 .115 r
.38335 .48658 m .39699 .4944 L .38947 .51419 L p F P
0 0 0 r
s
.092 .118 .262 r
.56997 .61158 m .55558 .61914 L .5571 .60355 L p F P
0 0 0 r
s
.092 .118 .262 r
.5571 .60355 m .57189 .59567 L .56997 .61158 L p F P
0 0 0 r
s
.804 .216 .086 r
.42811 .59567 m .4429 .60355 L .44442 .61914 L p F P
0 0 0 r
s
.804 .216 .086 r
.4586 .62659 m .44442 .61914 L .4429 .60355 L p F P
0 0 0 r
s
.24 .35 .67 r
.27574 .47061 m
.30151 .45274 L
s
.27574 .47061 m
.26169 .48462 L
s
.83 .24 .1 r
.73831 .48462 m
.72426 .47061 L
s
.69849 .45274 m
.72426 .47061 L
s
.24 .35 .67 r
.20151 .53787 m
.22619 .521 L
s
.20151 .53787 m
.19559 .56088 L
s
.83 .24 .1 r
.79849 .53787 m
.80441 .56088 L
s
.77381 .521 m
.79849 .53787 L
s
1 .298 .126 r
.47727 .39179 m .47956 .39327 L .45978 .40447 L p F P
0 0 0 r
s
1 .298 .126 r
.45978 .40447 m .45521 .40157 L .47727 .39179 L p F P
0 0 0 r
s
.24 .35 .67 r
.46087 .39809 m
.46177 .39866 L
s
.45905 .3993 m
.46087 .39809 L
s
.26 .381 .757 r
.54022 .40447 m .54479 .40157 L .56575 .41359 L p F P
0 0 0 r
s
.271 .4 .791 r
.54479 .40157 m .54022 .40447 L .52044 .39327 L p F P
0 0 0 r
s
.83 .24 .1 r
.53366 .40158 m
.53434 .40114 L
s
.271 .4 .791 r
.51814 .39476 m .52044 .39327 L .54022 .40447 L p F P
0 0 0 r
s
.83 .24 .1 r
.53755 .3991 m
.53913 .39809 L
s
.53913 .39809 m
.54095 .3993 L
s
1 .296 .126 r
.48642 .39771 m .48414 .39623 L .5 .38446 L closepath p F P
0 0 0 r
s
.283 .419 .824 r
.5 .38446 m .51586 .39623 L .51358 .39771 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.23648 .50203 m
.26169 .48462 L
s
.23648 .50203 m
.22619 .521 L
s
.83 .24 .1 r
.77381 .521 m
.76352 .50203 L
s
.73831 .48462 m
.76352 .50203 L
s
1 .298 .126 r
.45061 .39865 m .45521 .40157 L .43425 .41359 L p F P
0 0 0 r
s
1 .298 .126 r
.43425 .41359 m .42744 .40934 L .45061 .39865 L p F P
0 0 0 r
s
1 .297 .125 r
.42744 .40934 m .43425 .41359 L .41483 .4276 L p F P
0 0 0 r
s
.248 .362 .723 r
.59409 .42216 m .58517 .4276 L .56575 .41359 L p F P
0 0 0 r
s
.248 .362 .723 r
.56575 .41359 m .57256 .40934 L .59409 .42216 L p F P
0 0 0 r
s
.26 .381 .757 r
.57256 .40934 m .56575 .41359 L .54479 .40157 L p F P
0 0 0 r
s
1 .296 .126 r
.48414 .39623 m .48186 .39476 L .5 .38446 L closepath p F P
0 0 0 r
s
.283 .419 .824 r
.5 .38446 m .51814 .39476 L .51586 .39623 L closepath p F P
0 0 0 r
s
.209 .299 .607 r
.63046 .47867 m .61665 .48658 L .60546 .46773 L p F P
0 0 0 r
s
.209 .299 .607 r
.60546 .46773 m .61787 .46047 L .63046 .47867 L p F P
0 0 0 r
s
.24 .35 .67 r
.58032 .48217 m
.61026 .46465 L
s
1 .291 .121 r
.39454 .46773 m .38213 .46047 L .39733 .44333 L p F P
0 0 0 r
s
1 .286 .119 r
.38213 .46047 m .39454 .46773 L .38335 .48658 L p F P
0 0 0 r
s
.83 .24 .1 r
.38974 .46465 m
.41968 .48217 L
s
1 .297 .125 r
.41483 .4276 m .40591 .42216 L .42744 .40934 L p F P
0 0 0 r
s
1 .295 .123 r
.40591 .42216 m .41483 .4276 L .39733 .44333 L p F P
0 0 0 r
s
.83 .24 .1 r
.40395 .43857 m
.43365 .45644 L
s
.236 .343 .687 r
.61352 .43685 m .60267 .44333 L .58517 .4276 L p F P
0 0 0 r
s
.24 .35 .67 r
.56635 .45644 m
.59605 .43857 L
s
.236 .343 .687 r
.58517 .4276 m .59409 .42216 L .61352 .43685 L p F P
0 0 0 r
s
1 .298 .126 r
.47497 .3903 m .47727 .39179 L .45521 .40157 L p F P
0 0 0 r
s
1 .298 .126 r
.45521 .40157 m .45061 .39865 L .47497 .3903 L p F P
0 0 0 r
s
.26 .381 .757 r
.54479 .40157 m .54939 .39865 L .57256 .40934 L p F P
0 0 0 r
s
.271 .4 .791 r
.54939 .39865 m .54479 .40157 L .52273 .39179 L p F P
0 0 0 r
s
.271 .4 .791 r
.52044 .39327 m .52273 .39179 L .54479 .40157 L p F P
0 0 0 r
s
1 .296 .126 r
.48186 .39476 m .47956 .39327 L .5 .38446 L closepath p F P
0 0 0 r
s
.283 .419 .824 r
.5 .38446 m .52044 .39327 L .51814 .39476 L closepath p F P
0 0 0 r
s
.029 .04 .077 r
.52397 .65527 m .51191 .66148 L .51292 .65296 L p F P
0 0 0 r
s
.029 .04 .077 r
.51292 .65296 m .52602 .64616 L .52397 .65527 L p F P
0 0 0 r
s
.54 .134 .052 r
.47398 .64616 m .48708 .65296 L .48809 .66148 L p F P
0 0 0 r
s
.54 .134 .052 r
.5 .66762 m .48809 .66148 L .48708 .65296 L p F P
0 0 0 r
s
.24 .35 .67 r
.49513 .66855 m
.49664 .66615 L
s
.49664 .66615 m
.49676 .66595 L
s
.4986 .66303 m
.50563 .65186 L
s
.83 .24 .1 r
.49437 .65186 m
.5014 .66303 L
s
.689 .18 .07 r
.44442 .61914 m .4586 .62659 L .46072 .63926 L p F P
0 0 0 r
s
.689 .18 .07 r
.47398 .64616 m .46072 .63926 L .4586 .62659 L p F P
0 0 0 r
s
.83 .24 .1 r
.45941 .61625 m
.46538 .63673 L
s
.062 .08 .171 r
.55273 .63228 m .53928 .63926 L .5414 .62659 L p F P
0 0 0 r
s
.24 .35 .67 r
.53462 .63673 m
.54059 .61625 L
s
.062 .08 .171 r
.5414 .62659 m .55558 .61914 L .55273 .63228 L p F P
0 0 0 r
s
1 .296 .126 r
.47956 .39327 m .47727 .39179 L .5 .38446 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.46915 .41108 m
.48948 .39306 L
s
.283 .419 .824 r
.5 .38446 m .52273 .39179 L .52044 .39327 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.48948 .39306 m
.50664 .40423 L
s
.24 .35 .67 r
.49336 .40423 m
.51052 .39306 L
s
.51052 .39306 m
.53085 .41108 L
s
.223 .322 .648 r
.63044 .45311 m .61787 .46047 L .60267 .44333 L p F P
0 0 0 r
s
.223 .322 .648 r
.60267 .44333 m .61352 .43685 L .63044 .45311 L p F P
0 0 0 r
s
.24 .35 .67 r
.59605 .43857 m
.61026 .46465 L
s
1 .295 .123 r
.39733 .44333 m .38648 .43685 L .40591 .42216 L p F P
0 0 0 r
s
1 .291 .121 r
.38648 .43685 m .39733 .44333 L .38213 .46047 L p F P
0 0 0 r
s
.83 .24 .1 r
.38974 .46465 m
.40395 .43857 L
s
.967 .27 .111 r
.39961 .54224 m .38444 .53388 L .38947 .51419 L p F P
0 0 0 r
s
.931 .257 .105 r
.38444 .53388 m .39961 .54224 L .39756 .56147 L p F P
0 0 0 r
s
.931 .257 .105 r
.41284 .56973 m .39756 .56147 L .39961 .54224 L p F P
0 0 0 r
s
.83 .24 .1 r
.39853 .56088 m
.40175 .53532 L
s
.153 .212 .442 r
.61795 .55308 m .60244 .56147 L .60039 .54224 L p F P
0 0 0 r
s
.153 .212 .442 r
.60039 .54224 m .61556 .53388 L .61795 .55308 L p F P
0 0 0 r
s
.24 .35 .67 r
.59825 .53532 m
.60147 .56088 L
s
.175 .246 .506 r
.63096 .5254 m .61556 .53388 L .61053 .51419 L p F P
0 0 0 r
s
.175 .246 .506 r
.61053 .51419 m .62522 .50594 L .63096 .5254 L p F P
0 0 0 r
s
.992 .279 .115 r
.38947 .51419 m .37478 .50594 L .38335 .48658 L p F P
0 0 0 r
s
.967 .27 .111 r
.37478 .50594 m .38947 .51419 L .38444 .53388 L p F P
0 0 0 r
s
.88 .24 .097 r
.39756 .56147 m .41284 .56973 L .41311 .58768 L p F P
0 0 0 r
s
.88 .24 .097 r
.42811 .59567 m .41311 .58768 L .41284 .56973 L p F P
0 0 0 r
s
.126 .17 .362 r
.60212 .57957 m .58689 .58768 L .58716 .56973 L p F P
0 0 0 r
s
.126 .17 .362 r
.58716 .56973 m .60244 .56147 L .60212 .57957 L p F P
0 0 0 r
s
.24 .35 .67 r
.57144 .57715 m
.60147 .56088 L
s
1 .298 .126 r
.47266 .3888 m .47497 .3903 L .45061 .39865 L p F P
0 0 0 r
s
1 .298 .126 r
.45061 .39865 m .446 .39572 L .47266 .3888 L p F P
0 0 0 r
s
1 .298 .126 r
.446 .39572 m .45061 .39865 L .42744 .40934 L p F P
0 0 0 r
s
.26 .381 .757 r
.57942 .40507 m .57256 .40934 L .54939 .39865 L p F P
0 0 0 r
s
.26 .381 .757 r
.54939 .39865 m .554 .39572 L .57942 .40507 L p F P
0 0 0 r
s
.271 .4 .791 r
.554 .39572 m .54939 .39865 L .52503 .3903 L p F P
0 0 0 r
s
.83 .24 .1 r
.54223 .39681 m
.54304 .39647 L
s
.271 .4 .791 r
.52273 .39179 m .52503 .3903 L .54939 .39865 L p F P
0 0 0 r
s
1 .298 .126 r
.42744 .40934 m .42058 .40507 L .446 .39572 L p F P
0 0 0 r
s
1 .297 .125 r
.42058 .40507 m .42744 .40934 L .40591 .42216 L p F P
0 0 0 r
s
.83 .24 .1 r
.40395 .43857 m
.42081 .41421 L
s
.42081 .41421 m
.45033 .43247 L
s
.248 .362 .723 r
.60309 .41667 m .59409 .42216 L .57256 .40934 L p F P
0 0 0 r
s
.248 .362 .723 r
.57256 .40934 m .57942 .40507 L .60309 .41667 L p F P
0 0 0 r
s
.24 .35 .67 r
.54967 .43247 m
.57919 .41421 L
s
.57919 .41421 m
.59605 .43857 L
s
1 .296 .126 r
.47727 .39179 m .47497 .3903 L .5 .38446 L closepath p F P
0 0 0 r
s
.283 .419 .824 r
.5 .38446 m .52503 .3903 L .52273 .39179 L closepath p F P
0 0 0 r
s
.193 .274 .56 r
.64011 .49757 m .62522 .50594 L .61665 .48658 L p F P
0 0 0 r
s
.193 .274 .56 r
.61665 .48658 m .63046 .47867 L .64011 .49757 L p F P
0 0 0 r
s
.24 .35 .67 r
.59109 .50877 m
.62132 .49156 L
s
1 .286 .119 r
.38335 .48658 m .36954 .47867 L .38213 .46047 L p F P
0 0 0 r
s
.992 .279 .115 r
.36954 .47867 m .38335 .48658 L .37478 .50594 L p F P
0 0 0 r
s
.83 .24 .1 r
.37868 .49156 m
.40891 .50877 L
s
1 .296 .126 r
.47497 .3903 m .47266 .3888 L .5 .38446 L closepath p F P
0 0 0 r
s
.271 .4 .791 r
.52503 .3903 m .52734 .3888 L .554 .39572 L p F P
0 0 0 r
s
.283 .419 .824 r
.5 .38446 m .52734 .3888 L .52503 .3903 L closepath p F P
0 0 0 r
s
.236 .343 .687 r
.62449 .43029 m .61352 .43685 L .59409 .42216 L p F P
0 0 0 r
s
.236 .343 .687 r
.59409 .42216 m .60309 .41667 L .62449 .43029 L p F P
0 0 0 r
s
1 .297 .125 r
.40591 .42216 m .39691 .41667 L .42058 .40507 L p F P
0 0 0 r
s
1 .295 .123 r
.39691 .41667 m .40591 .42216 L .38648 .43685 L p F P
0 0 0 r
s
.092 .118 .262 r
.58456 .60391 m .56997 .61158 L .57189 .59567 L p F P
0 0 0 r
s
.24 .35 .67 r
.57011 .60059 m
.57144 .57715 L
s
.54059 .61625 m
.57011 .60059 L
s
.092 .118 .262 r
.57189 .59567 m .58689 .58768 L .58456 .60391 L p F P
0 0 0 r
s
.804 .216 .086 r
.41311 .58768 m .42811 .59567 L .43003 .61158 L p F P
0 0 0 r
s
.804 .216 .086 r
.44442 .61914 m .43003 .61158 L .42811 .59567 L p F P
0 0 0 r
s
.83 .24 .1 r
.42856 .57715 m
.42989 .60059 L
s
.42989 .60059 m
.45941 .61625 L
s
1 .298 .126 r
.47035 .38731 m .47266 .3888 L .446 .39572 L p F P
0 0 0 r
s
1 .298 .126 r
.446 .39572 m .44137 .39278 L .47035 .38731 L p F P
0 0 0 r
s
1 .298 .126 r
.44137 .39278 m .446 .39572 L .42058 .40507 L p F P
0 0 0 r
s
.26 .381 .757 r
.58633 .40077 m .57942 .40507 L .554 .39572 L p F P
0 0 0 r
s
.83 .24 .1 r
.58164 .40369 m
.58812 .40807 L
s
.26 .381 .757 r
.554 .39572 m .55863 .39278 L .58633 .40077 L p F P
0 0 0 r
s
.83 .24 .1 r
.56917 .39525 m
.57063 .39624 L
s
.271 .4 .791 r
.55863 .39278 m .554 .39572 L .52734 .3888 L p F P
0 0 0 r
s
1 .296 .126 r
.47266 .3888 m .47035 .38731 L .5 .38446 L closepath p F P
0 0 0 r
s
.271 .4 .791 r
.52734 .3888 m .52965 .38731 L .55863 .39278 L p F P
0 0 0 r
s
.283 .419 .824 r
.5 .38446 m .52965 .38731 L .52734 .3888 L closepath p F P
0 0 0 r
s
1 .291 .121 r
.38213 .46047 m .36956 .45311 L .38648 .43685 L p F P
0 0 0 r
s
1 .286 .119 r
.36956 .45311 m .38213 .46047 L .36954 .47867 L p F P
0 0 0 r
s
.83 .24 .1 r
.37868 .49156 m
.38974 .46465 L
s
.209 .299 .607 r
.64445 .47065 m .63046 .47867 L .61787 .46047 L p F P
0 0 0 r
s
.209 .299 .607 r
.61787 .46047 m .63044 .45311 L .64445 .47065 L p F P
0 0 0 r
s
.24 .35 .67 r
.61026 .46465 m
.62132 .49156 L
s
1 .298 .126 r
.42058 .40507 m .41367 .40077 L .44137 .39278 L p F P
0 0 0 r
s
.24 .35 .67 r
.41188 .40807 m
.41836 .40369 L
s
.42937 .39624 m
.43083 .39525 L
s
1 .297 .125 r
.41367 .40077 m .42058 .40507 L .39691 .41667 L p F P
0 0 0 r
s
.248 .362 .723 r
.61216 .41113 m .60309 .41667 L .57942 .40507 L p F P
0 0 0 r
s
.248 .362 .723 r
.57942 .40507 m .58633 .40077 L .61216 .41113 L p F P
0 0 0 r
s
1 .296 .126 r
.47035 .38731 m .46803 .38581 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .298 .126 r
.46803 .38581 m .47035 .38731 L .44137 .39278 L p F P
0 0 0 r
s
.271 .4 .791 r
.56328 .38982 m .55863 .39278 L .52965 .38731 L p F P
0 0 0 r
s
.271 .4 .791 r
.52965 .38731 m .53197 .38581 L .56328 .38982 L p F P
0 0 0 r
s
.283 .419 .824 r
.5 .38446 m .53197 .38581 L .52965 .38731 L closepath p F P
0 0 0 r
s
.982 .29 .124 r
.5 .38446 m .51154 .37215 L .50924 .37062 L closepath p F P
0 0 0 r
s
.982 .29 .124 r
.5 .38446 m .50924 .37062 L .50694 .36908 L closepath p F P
0 0 0 r
s
.982 .29 .124 r
.5 .38446 m .50694 .36908 L .50463 .36754 L closepath p F P
0 0 0 r
s
.982 .29 .124 r
.5 .38446 m .50463 .36754 L .50232 .36599 L closepath p F P
0 0 0 r
s
.982 .29 .124 r
.5 .38446 m .50232 .36599 L .5 .36444 L closepath p F P
0 0 0 r
s
.982 .29 .124 r
.5 .38446 m .52521 .38129 L .52294 .37977 L closepath p F P
0 0 0 r
s
.982 .29 .124 r
.5 .38446 m .52294 .37977 L .52067 .37826 L closepath p F P
0 0 0 r
s
.982 .29 .124 r
.5 .38446 m .52067 .37826 L .5184 .37673 L closepath p F P
0 0 0 r
s
.982 .29 .124 r
.5 .38446 m .5184 .37673 L .51612 .37521 L closepath p F P
0 0 0 r
s
.982 .29 .124 r
.5 .38446 m .51612 .37521 L .51383 .37368 L closepath p F P
0 0 0 r
s
.982 .29 .124 r
.5 .38446 m .51383 .37368 L .51154 .37215 L closepath p F P
0 0 0 r
s
.982 .29 .124 r
.5 .38446 m .53197 .38581 L .52972 .3843 L closepath p F P
0 0 0 r
s
.982 .29 .124 r
.5 .38446 m .52972 .3843 L .52747 .3828 L closepath p F P
0 0 0 r
s
.982 .29 .124 r
.5 .38446 m .52747 .3828 L .52521 .38129 L closepath p F P
0 0 0 r
s
.294 .437 .856 r
.47028 .3843 m .46803 .38581 L .5 .38446 L closepath p F P
0 0 0 r
s
.294 .437 .856 r
.47253 .3828 m .47028 .3843 L .5 .38446 L closepath p F P
0 0 0 r
s
.294 .437 .856 r
.47479 .38129 m .47253 .3828 L .5 .38446 L closepath p F P
0 0 0 r
s
.294 .437 .856 r
.47706 .37977 m .47479 .38129 L .5 .38446 L closepath p F P
0 0 0 r
s
.294 .437 .856 r
.47933 .37826 m .47706 .37977 L .5 .38446 L closepath p F P
0 0 0 r
s
.294 .437 .856 r
.4816 .37673 m .47933 .37826 L .5 .38446 L closepath p F P
0 0 0 r
s
.294 .437 .856 r
.48388 .37521 m .4816 .37673 L .5 .38446 L closepath p F P
0 0 0 r
s
.294 .437 .856 r
.48617 .37368 m .48388 .37521 L .5 .38446 L closepath p F P
0 0 0 r
s
.294 .437 .856 r
.48846 .37215 m .48617 .37368 L .5 .38446 L closepath p F P
0 0 0 r
s
.294 .437 .856 r
.49076 .37062 m .48846 .37215 L .5 .38446 L closepath p F P
0 0 0 r
s
.294 .437 .856 r
.49306 .36908 m .49076 .37062 L .5 .38446 L closepath p F P
0 0 0 r
s
.294 .437 .856 r
.49537 .36754 m .49306 .36908 L .5 .38446 L closepath p F P
0 0 0 r
s
.294 .437 .856 r
.49768 .36599 m .49537 .36754 L .5 .38446 L closepath p F P
0 0 0 r
s
.294 .437 .856 r
.5 .36444 m .49768 .36599 L .5 .38446 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.48948 .39306 m
.51063 .37916 L
s
.24 .35 .67 r
.48937 .37916 m
.51052 .39306 L
s
1 .295 .123 r
.38648 .43685 m .37551 .43029 L .39691 .41667 L p F P
0 0 0 r
s
1 .291 .121 r
.37551 .43029 m .38648 .43685 L .36956 .45311 L p F P
0 0 0 r
s
.223 .322 .648 r
.64315 .44568 m .63044 .45311 L .61352 .43685 L p F P
0 0 0 r
s
.223 .322 .648 r
.61352 .43685 m .62449 .43029 L .64315 .44568 L p F P
0 0 0 r
s
1 .298 .126 r
.44137 .39278 m .43672 .38982 L .46803 .38581 L p F P
0 0 0 r
s
1 .298 .126 r
.43672 .38982 m .44137 .39278 L .41367 .40077 L p F P
0 0 0 r
s
.83 .24 .1 r
.42081 .41421 m
.43975 .39241 L
s
.43975 .39241 m
.46915 .41108 L
s
.26 .381 .757 r
.59328 .39644 m .58633 .40077 L .55863 .39278 L p F P
0 0 0 r
s
.26 .381 .757 r
.55863 .39278 m .56328 .38982 L .59328 .39644 L p F P
0 0 0 r
s
.24 .35 .67 r
.53085 .41108 m
.56025 .39241 L
s
.56025 .39241 m
.57919 .41421 L
s
.937 .28 .121 r
.52972 .3843 m .53197 .38581 L .56328 .38982 L p F P
0 0 0 r
s
.303 .454 .884 r
.46803 .38581 m .47028 .3843 L .4411 .38685 L p F P
0 0 0 r
s
.303 .454 .884 r
.4411 .38685 m .43672 .38982 L .46803 .38581 L p F P
0 0 0 r
s
.029 .04 .077 r
.53618 .64897 m .52397 .65527 L .52602 .64616 L p F P
0 0 0 r
s
.029 .04 .077 r
.52602 .64616 m .53928 .63926 L .53618 .64897 L p F P
0 0 0 r
s
.24 .35 .67 r
.50563 .65186 m
.53462 .63673 L
s
.54 .134 .052 r
.46072 .63926 m .47398 .64616 L .47603 .65527 L p F P
0 0 0 r
s
.54 .134 .052 r
.48809 .66148 m .47603 .65527 L .47398 .64616 L p F P
0 0 0 r
s
.83 .24 .1 r
.46538 .63673 m
.49437 .65186 L
s
.24 .35 .67 r
.2847 .73146 m
.30815 .74169 L
s
.30815 .74169 m
.33466 .72765 L
s
.83 .24 .1 r
.66534 .72765 m
.69185 .74169 L
s
.7153 .73146 m
.69185 .74169 L
s
.24 .35 .67 r
.49513 .66855 m
.49846 .66683 L
s
.83 .24 .1 r
.50154 .66683 m
.50487 .66855 L
s
.062 .08 .171 r
.56635 .6252 m .55273 .63228 L .55558 .61914 L p F P
0 0 0 r
s
.062 .08 .171 r
.55558 .61914 m .56997 .61158 L .56635 .6252 L p F P
0 0 0 r
s
.689 .18 .07 r
.43003 .61158 m .44442 .61914 L .44727 .63228 L p F P
0 0 0 r
s
.689 .18 .07 r
.46072 .63926 m .44727 .63228 L .44442 .61914 L p F P
0 0 0 r
s
1 .297 .125 r
.39691 .41667 m .38784 .41113 L .41367 .40077 L p F P
0 0 0 r
s
1 .295 .123 r
.38784 .41113 m .39691 .41667 L .37551 .43029 L p F P
0 0 0 r
s
.236 .343 .687 r
.63557 .42367 m .62449 .43029 L .60309 .41667 L p F P
0 0 0 r
s
.236 .343 .687 r
.60309 .41667 m .61216 .41113 L .63557 .42367 L p F P
0 0 0 r
s
.937 .28 .121 r
.56328 .38982 m .5589 .38685 L .52972 .3843 L p F P
0 0 0 r
s
.937 .28 .121 r
.52747 .3828 m .52972 .3843 L .5589 .38685 L p F P
0 0 0 r
s
.303 .454 .884 r
.47028 .3843 m .47253 .3828 L .44551 .38387 L p F P
0 0 0 r
s
.303 .454 .884 r
.44551 .38387 m .4411 .38685 L .47028 .3843 L p F P
0 0 0 r
s
.24 .35 .67 r
.43384 .70229 m
.45199 .69539 L
s
.45199 .69539 m
.48066 .68066 L
s
.83 .24 .1 r
.51934 .68066 m
.54801 .69539 L
s
.54801 .69539 m
.56616 .70229 L
s
.153 .212 .442 r
.63368 .54456 m .61795 .55308 L .61556 .53388 L p F P
0 0 0 r
s
.153 .212 .442 r
.61556 .53388 m .63096 .5254 L .63368 .54456 L p F P
0 0 0 r
s
.967 .27 .111 r
.38444 .53388 m .36904 .5254 L .37478 .50594 L p F P
0 0 0 r
s
.931 .257 .105 r
.36904 .5254 m .38444 .53388 L .38205 .55308 L p F P
0 0 0 r
s
.931 .257 .105 r
.39756 .56147 m .38205 .55308 L .38444 .53388 L p F P
0 0 0 r
s
1 .298 .126 r
.41367 .40077 m .40672 .39644 L .43672 .38982 L p F P
0 0 0 r
s
1 .297 .125 r
.40672 .39644 m .41367 .40077 L .38784 .41113 L p F P
0 0 0 r
s
.24 .35 .67 r
.3642 .4234 m
.39123 .40488 L
s
.39123 .40488 m
.3951 .40548 L
s
.248 .362 .723 r
.62132 .40554 m .61216 .41113 L .58633 .40077 L p F P
0 0 0 r
s
.83 .24 .1 r
.61519 .40928 m
.6358 .4234 L
s
.248 .362 .723 r
.58633 .40077 m .59328 .39644 L .62132 .40554 L p F P
0 0 0 r
s
.864 .262 .114 r
.5589 .38685 m .56328 .38982 L .59328 .39644 L p F P
0 0 0 r
s
.24 .35 .67 r
.56025 .39241 m
.56544 .38912 L
s
.83 .24 .1 r
.56039 .38932 m
.56527 .39261 L
s
.55253 .39256 m
.56039 .38932 L
s
.31 .467 .903 r
.43672 .38982 m .4411 .38685 L .41309 .39208 L p F P
0 0 0 r
s
.24 .35 .67 r
.43961 .38932 m
.44747 .39256 L
s
.31 .467 .903 r
.41309 .39208 m .40672 .39644 L .43672 .38982 L p F P
0 0 0 r
s
.83 .24 .1 r
.43456 .38912 m
.43975 .39241 L
s
.24 .35 .67 r
.43473 .39261 m
.43961 .38932 L
s
.175 .246 .506 r
.64658 .51679 m .63096 .5254 L .62522 .50594 L p F P
0 0 0 r
s
.24 .35 .67 r
.59825 .53532 m
.62882 .51837 L
s
.175 .246 .506 r
.62522 .50594 m .64011 .49757 L .64658 .51679 L p F P
0 0 0 r
s
.24 .35 .67 r
.62132 .49156 m
.62882 .51837 L
s
.992 .279 .115 r
.37478 .50594 m .35989 .49757 L .36954 .47867 L p F P
0 0 0 r
s
.967 .27 .111 r
.35989 .49757 m .37478 .50594 L .36904 .5254 L p F P
0 0 0 r
s
.83 .24 .1 r
.37118 .51837 m
.37868 .49156 L
s
.37118 .51837 m
.40175 .53532 L
s
.24 .35 .67 r
.33466 .72765 m
.35751 .73219 L
s
.35751 .73219 m
.3848 .71799 L
s
.83 .24 .1 r
.6152 .71799 m
.64249 .73219 L
s
.64249 .73219 m
.66534 .72765 L
s
.937 .28 .121 r
.5589 .38685 m .55449 .38387 L .52747 .3828 L p F P
0 0 0 r
s
.937 .28 .121 r
.52521 .38129 m .52747 .3828 L .55449 .38387 L p F P
0 0 0 r
s
.303 .454 .884 r
.47253 .3828 m .47479 .38129 L .44993 .38087 L p F P
0 0 0 r
s
.303 .454 .884 r
.44993 .38087 m .44551 .38387 L .47253 .3828 L p F P
0 0 0 r
s
.83 .24 .1 r
.47201 .3817 m
.48948 .39306 L
s
.88 .24 .097 r
.38205 .55308 m .39756 .56147 L .39788 .57957 L p F P
0 0 0 r
s
.88 .24 .097 r
.41311 .58768 m .39788 .57957 L .39756 .56147 L p F P
0 0 0 r
s
.83 .24 .1 r
.39853 .56088 m
.42856 .57715 L
s
.126 .17 .362 r
.61757 .57134 m .60212 .57957 L .60244 .56147 L p F P
0 0 0 r
s
.126 .17 .362 r
.60244 .56147 m .61795 .55308 L .61757 .57134 L p F P
0 0 0 r
s
.24 .35 .67 r
.3848 .71799 m
.40583 .71672 L
s
.40583 .71672 m
.43384 .70229 L
s
.83 .24 .1 r
.56616 .70229 m
.59417 .71672 L
s
.59417 .71672 m
.6152 .71799 L
s
.024 .035 .067 r
.51059 .66642 m .5 .67186 L .5 .66762 L p F P
0 0 0 r
s
.83 .24 .1 r
.50547 .66905 m
.51934 .68066 L
s
.024 .035 .067 r
.5 .66762 m .51191 .66148 L .51059 .66642 L p F P
0 0 0 r
s
.383 .086 .036 r
.48809 .66148 m .5 .66762 L .5 .67186 L p F P
0 0 0 r
s
.193 .274 .56 r
.65522 .48909 m .64011 .49757 L .63046 .47867 L p F P
0 0 0 r
s
.193 .274 .56 r
.63046 .47867 m .64445 .47065 L .65522 .48909 L p F P
0 0 0 r
s
1 .286 .119 r
.36954 .47867 m .35555 .47065 L .36956 .45311 L p F P
0 0 0 r
s
.992 .279 .115 r
.35555 .47065 m .36954 .47867 L .35989 .49757 L p F P
0 0 0 r
s
.83 .24 .1 r
.80441 .56088 m
.7795 .54413 L
s
.24 .35 .67 r
.19559 .56088 m
.2205 .54413 L
s
.19559 .56088 m
.19471 .58696 L
s
.83 .24 .1 r
.80441 .56088 m
.80529 .58696 L
s
.937 .28 .121 r
.55449 .38387 m .55007 .38087 L .52521 .38129 L p F P
0 0 0 r
s
.24 .35 .67 r
.51052 .39306 m
.52799 .3817 L
s
.937 .28 .121 r
.52294 .37977 m .52521 .38129 L .55007 .38087 L p F P
0 0 0 r
s
.303 .454 .884 r
.47479 .38129 m .47706 .37977 L .45438 .37786 L p F P
0 0 0 r
s
.303 .454 .884 r
.45438 .37786 m .44993 .38087 L .47479 .38129 L p F P
0 0 0 r
s
.209 .299 .607 r
.65863 .46252 m .64445 .47065 L .63044 .45311 L p F P
0 0 0 r
s
.209 .299 .607 r
.63044 .45311 m .64315 .44568 L .65863 .46252 L p F P
0 0 0 r
s
.24 .35 .67 r
.61026 .46465 m
.64108 .44661 L
s
1 .291 .121 r
.36956 .45311 m .35685 .44568 L .37551 .43029 L p F P
0 0 0 r
s
1 .286 .119 r
.35685 .44568 m .36956 .45311 L .35555 .47065 L p F P
0 0 0 r
s
.83 .24 .1 r
.35892 .44661 m
.38974 .46465 L
s
.864 .262 .114 r
.59328 .39644 m .58691 .39208 L .5589 .38685 L p F P
0 0 0 r
s
.864 .262 .114 r
.55449 .38387 m .5589 .38685 L .58691 .39208 L p F P
0 0 0 r
s
.24 .35 .67 r
.5528 .38568 m
.56025 .39241 L
s
.31 .467 .903 r
.4411 .38685 m .44551 .38387 L .41951 .38769 L p F P
0 0 0 r
s
.31 .467 .903 r
.41951 .38769 m .41309 .39208 L .4411 .38685 L p F P
0 0 0 r
s
.83 .24 .1 r
.43975 .39241 m
.4472 .38568 L
s
.092 .118 .262 r
.59936 .59614 m .58456 .60391 L .58689 .58768 L p F P
0 0 0 r
s
.092 .118 .262 r
.58689 .58768 m .60212 .57957 L .59936 .59614 L p F P
0 0 0 r
s
.804 .216 .086 r
.39788 .57957 m .41311 .58768 L .41544 .60391 L p F P
0 0 0 r
s
.804 .216 .086 r
.43003 .61158 m .41544 .60391 L .41311 .58768 L p F P
0 0 0 r
s
.937 .28 .121 r
.55007 .38087 m .54562 .37786 L .52294 .37977 L p F P
0 0 0 r
s
.937 .28 .121 r
.52067 .37826 m .52294 .37977 L .54562 .37786 L p F P
0 0 0 r
s
.83 .24 .1 r
.51063 .37916 m
.5278 .39056 L
s
.303 .454 .884 r
.47706 .37977 m .47933 .37826 L .45885 .37484 L p F P
0 0 0 r
s
.303 .454 .884 r
.45885 .37484 m .45438 .37786 L .47706 .37977 L p F P
0 0 0 r
s
.24 .35 .67 r
.4722 .39056 m
.48937 .37916 L
s
1 .295 .123 r
.37551 .43029 m .36443 .42367 L .38784 .41113 L p F P
0 0 0 r
s
1 .291 .121 r
.36443 .42367 m .37551 .43029 L .35685 .44568 L p F P
0 0 0 r
s
.223 .322 .648 r
.65602 .43815 m .64315 .44568 L .62449 .43029 L p F P
0 0 0 r
s
.223 .322 .648 r
.62449 .43029 m .63557 .42367 L .65602 .43815 L p F P
0 0 0 r
s
.24 .35 .67 r
.30151 .45274 m
.28765 .46669 L
s
.83 .24 .1 r
.71235 .46669 m
.69849 .45274 L
s
.24 .35 .67 r
.22619 .521 m
.25161 .50362 L
s
.22619 .521 m
.2205 .54413 L
s
.83 .24 .1 r
.7795 .54413 m
.77381 .521 L
s
.74839 .50362 m
.77381 .521 L
s
1 .297 .125 r
.38784 .41113 m .37868 .40554 L .40672 .39644 L p F P
0 0 0 r
s
.742 .231 .102 r
.58691 .39208 m .59328 .39644 L .62132 .40554 L p F P
0 0 0 r
s
.24 .35 .67 r
.57919 .41421 m
.6034 .39923 L
s
.309 .47 .9 r
.40672 .39644 m .41309 .39208 L .38685 .39991 L p F P
0 0 0 r
s
.309 .47 .9 r
.38685 .39991 m .37868 .40554 L .40672 .39644 L p F P
0 0 0 r
s
.83 .24 .1 r
.3966 .39923 m
.42081 .41421 L
s
.236 .343 .687 r
.64677 .41697 m .63557 .42367 L .61216 .41113 L p F P
0 0 0 r
s
.83 .24 .1 r
.64418 .41852 m
.65506 .42604 L
s
.24 .35 .67 r
.59605 .43857 m
.62662 .42017 L
s
.236 .343 .687 r
.61216 .41113 m .62132 .40554 L .64677 .41697 L p F P
0 0 0 r
s
1 .295 .123 r
.37868 .40554 m .38784 .41113 L .36443 .42367 L p F P
0 0 0 r
s
.83 .24 .1 r
.37338 .42017 m
.40395 .43857 L
s
.24 .35 .67 r
.26169 .48462 m
.28765 .46669 L
s
.26169 .48462 m
.25161 .50362 L
s
.83 .24 .1 r
.74839 .50362 m
.73831 .48462 L
s
.71235 .46669 m
.73831 .48462 L
s
.937 .28 .121 r
.54562 .37786 m .54115 .37484 L .52067 .37826 L p F P
0 0 0 r
s
.937 .28 .121 r
.5184 .37673 m .52067 .37826 L .54115 .37484 L p F P
0 0 0 r
s
.303 .454 .884 r
.47933 .37826 m .4816 .37673 L .46334 .3718 L p F P
0 0 0 r
s
.303 .454 .884 r
.46334 .3718 m .45885 .37484 L .47933 .37826 L p F P
0 0 0 r
s
.864 .262 .114 r
.58691 .39208 m .58049 .38769 L .55449 .38387 L p F P
0 0 0 r
s
.864 .262 .114 r
.55007 .38087 m .55449 .38387 L .58049 .38769 L p F P
0 0 0 r
s
.31 .467 .903 r
.44551 .38387 m .44993 .38087 L .42596 .38327 L p F P
0 0 0 r
s
.31 .467 .903 r
.42596 .38327 m .41951 .38769 L .44551 .38387 L p F P
0 0 0 r
s
.029 .04 .077 r
.54853 .6426 m .53618 .64897 L .53928 .63926 L p F P
0 0 0 r
s
.029 .04 .077 r
.53928 .63926 m .55273 .63228 L .54853 .6426 L p F P
0 0 0 r
s
.54 .134 .052 r
.44727 .63228 m .46072 .63926 L .46382 .64897 L p F P
0 0 0 r
s
.54 .134 .052 r
.47603 .65527 m .46382 .64897 L .46072 .63926 L p F P
0 0 0 r
s
.937 .28 .121 r
.54115 .37484 m .53666 .3718 L .5184 .37673 L p F P
0 0 0 r
s
.937 .28 .121 r
.51612 .37521 m .5184 .37673 L .53666 .3718 L p F P
0 0 0 r
s
.303 .454 .884 r
.4816 .37673 m .48388 .37521 L .46785 .36874 L p F P
0 0 0 r
s
.303 .454 .884 r
.46785 .36874 m .46334 .3718 L .4816 .37673 L p F P
0 0 0 r
s
.062 .08 .171 r
.58015 .61803 m .56635 .6252 L .56997 .61158 L p F P
0 0 0 r
s
.062 .08 .171 r
.56997 .61158 m .58456 .60391 L .58015 .61803 L p F P
0 0 0 r
s
.24 .35 .67 r
.56447 .62114 m
.57011 .60059 L
s
.689 .18 .07 r
.41544 .60391 m .43003 .61158 L .43365 .6252 L p F P
0 0 0 r
s
.689 .18 .07 r
.44727 .63228 m .43365 .6252 L .43003 .61158 L p F P
0 0 0 r
s
.83 .24 .1 r
.42989 .60059 m
.43553 .62114 L
s
.937 .28 .121 r
.53666 .3718 m .53215 .36874 L .51612 .37521 L p F P
0 0 0 r
s
.937 .28 .121 r
.51383 .37368 m .51612 .37521 L .53215 .36874 L p F P
0 0 0 r
s
.303 .454 .884 r
.48388 .37521 m .48617 .37368 L .47237 .36568 L p F P
0 0 0 r
s
.303 .454 .884 r
.47237 .36568 m .46785 .36874 L .48388 .37521 L p F P
0 0 0 r
s
.742 .231 .102 r
.62132 .40554 m .61315 .39991 L .58691 .39208 L p F P
0 0 0 r
s
.742 .231 .102 r
.58049 .38769 m .58691 .39208 L .61315 .39991 L p F P
0 0 0 r
s
.24 .35 .67 r
.60639 .39738 m
.60957 .39541 L
s
.309 .47 .9 r
.41309 .39208 m .41951 .38769 L .3951 .39422 L p F P
0 0 0 r
s
.309 .47 .9 r
.3951 .39422 m .38685 .39991 L .41309 .39208 L p F P
0 0 0 r
s
.83 .24 .1 r
.39043 .39541 m
.39198 .39637 L
s
.024 .035 .067 r
.52129 .66093 m .51059 .66642 L .51191 .66148 L p F P
0 0 0 r
s
.024 .035 .067 r
.51191 .66148 m .52397 .65527 L .52129 .66093 L p F P
0 0 0 r
s
.383 .086 .036 r
.47603 .65527 m .48809 .66148 L .48941 .66642 L p F P
0 0 0 r
s
.383 .086 .036 r
.5 .67186 m .48941 .66642 L .48809 .66148 L p F P
0 0 0 r
s
.24 .35 .67 r
.48066 .68066 m
.49453 .66905 L
s
.62662 .42017 m
.64108 .44661 L
s
.60957 .39541 m
.6125 .39967 L
s
.83 .24 .1 r
.38776 .39928 m
.39043 .39541 L
s
.864 .262 .114 r
.58049 .38769 m .57404 .38327 L .55007 .38087 L p F P
0 0 0 r
s
.864 .262 .114 r
.54562 .37786 m .55007 .38087 L .57404 .38327 L p F P
0 0 0 r
s
.31 .467 .903 r
.44993 .38087 m .45438 .37786 L .43246 .37882 L p F P
0 0 0 r
s
.31 .467 .903 r
.43246 .37882 m .42596 .38327 L .44993 .38087 L p F P
0 0 0 r
s
.153 .212 .442 r
.64966 .53592 m .63368 .54456 L .63096 .5254 L p F P
0 0 0 r
s
.153 .212 .442 r
.63096 .5254 m .64658 .51679 L .64966 .53592 L p F P
0 0 0 r
s
.24 .35 .67 r
.62882 .51837 m
.6324 .54413 L
s
.967 .27 .111 r
.36904 .5254 m .35342 .51679 L .35989 .49757 L p F P
0 0 0 r
s
.931 .257 .105 r
.35342 .51679 m .36904 .5254 L .36632 .54456 L p F P
0 0 0 r
s
.931 .257 .105 r
.38205 .55308 m .36632 .54456 L .36904 .5254 L p F P
0 0 0 r
s
.83 .24 .1 r
.3676 .54413 m
.37118 .51837 L
s
.175 .246 .506 r
.66244 .50806 m .64658 .51679 L .64011 .49757 L p F P
0 0 0 r
s
.175 .246 .506 r
.64011 .49757 m .65522 .48909 L .66244 .50806 L p F P
0 0 0 r
s
.992 .279 .115 r
.35989 .49757 m .34478 .48909 L .35555 .47065 L p F P
0 0 0 r
s
.967 .27 .111 r
.34478 .48909 m .35989 .49757 L .35342 .51679 L p F P
0 0 0 r
s
.937 .28 .121 r
.53215 .36874 m .52763 .36568 L .51383 .37368 L p F P
0 0 0 r
s
.937 .28 .121 r
.51154 .37215 m .51383 .37368 L .52763 .36568 L p F P
0 0 0 r
s
.303 .454 .884 r
.48617 .37368 m .48846 .37215 L .47693 .3626 L p F P
0 0 0 r
s
.303 .454 .884 r
.47693 .3626 m .47237 .36568 L .48617 .37368 L p F P
0 0 0 r
s
.193 .274 .56 r
.67055 .48048 m .65522 .48909 L .64445 .47065 L p F P
0 0 0 r
s
.193 .274 .56 r
.64445 .47065 m .65863 .46252 L .67055 .48048 L p F P
0 0 0 r
s
.24 .35 .67 r
.62132 .49156 m
.65245 .47383 L
s
1 .286 .119 r
.35555 .47065 m .34137 .46252 L .35685 .44568 L p F P
0 0 0 r
s
.992 .279 .115 r
.34137 .46252 m .35555 .47065 L .34478 .48909 L p F P
0 0 0 r
s
.83 .24 .1 r
.34755 .47383 m
.37868 .49156 L
s
1 .295 .123 r
.36443 .42367 m .35323 .41697 L .37868 .40554 L p F P
0 0 0 r
s
.549 .179 .082 r
.61315 .39991 m .62132 .40554 L .64677 .41697 L p F P
0 0 0 r
s
.24 .35 .67 r
.61446 .40251 m
.62662 .42017 L
s
.292 .449 .849 r
.37868 .40554 m .38685 .39991 L .36299 .41021 L p F P
0 0 0 r
s
.292 .449 .849 r
.36299 .41021 m .35323 .41697 L .37868 .40554 L p F P
0 0 0 r
s
.83 .24 .1 r
.37338 .42017 m
.38554 .40251 L
s
.126 .17 .362 r
.63326 .56299 m .61757 .57134 L .61795 .55308 L p F P
0 0 0 r
s
.126 .17 .362 r
.61795 .55308 m .63368 .54456 L .63326 .56299 L p F P
0 0 0 r
s
.24 .35 .67 r
.60147 .56088 m
.6324 .54413 L
s
.88 .24 .097 r
.36632 .54456 m .38205 .55308 L .38243 .57134 L p F P
0 0 0 r
s
.88 .24 .097 r
.39788 .57957 m .38243 .57134 L .38205 .55308 L p F P
0 0 0 r
s
.209 .299 .607 r
.67301 .45428 m .65863 .46252 L .64315 .44568 L p F P
0 0 0 r
s
.209 .299 .607 r
.64315 .44568 m .65602 .43815 L .67301 .45428 L p F P
0 0 0 r
s
1 .291 .121 r
.35685 .44568 m .34398 .43815 L .36443 .42367 L p F P
0 0 0 r
s
.24 .35 .67 r
.34494 .42604 m
.35582 .41852 L
s
.83 .24 .1 r
.35892 .44661 m
.37338 .42017 L
s
1 .286 .119 r
.34398 .43815 m .35685 .44568 L .34137 .46252 L p F P
0 0 0 r
s
.24 .35 .67 r
.64108 .44661 m
.65245 .47383 L
s
.83 .24 .1 r
.34755 .47383 m
.35892 .44661 L
s
.223 .322 .648 r
.66904 .43053 m .65602 .43815 L .63557 .42367 L p F P
0 0 0 r
s
.83 .24 .1 r
.65506 .42604 m
.6607 .42882 L
s
.223 .322 .648 r
.63557 .42367 m .64677 .41697 L .66904 .43053 L p F P
0 0 0 r
s
1 .291 .121 r
.35323 .41697 m .36443 .42367 L .34398 .43815 L p F P
0 0 0 r
s
.83 .24 .1 r
.36148 .41301 m
.37338 .42017 L
s
.937 .28 .121 r
.52763 .36568 m .52307 .3626 L .51154 .37215 L p F P
0 0 0 r
s
.937 .28 .121 r
.50924 .37062 m .51154 .37215 L .52307 .3626 L p F P
0 0 0 r
s
.303 .454 .884 r
.48846 .37215 m .49076 .37062 L .4815 .3595 L p F P
0 0 0 r
s
.303 .454 .884 r
.4815 .3595 m .47693 .3626 L .48846 .37215 L p F P
0 0 0 r
s
.24 .35 .67 r
.26183 .71564 m
.2847 .73146 L
s
.2847 .73146 m
.31115 .71712 L
s
.83 .24 .1 r
.68885 .71712 m
.7153 .73146 L
s
.73817 .71564 m
.7153 .73146 L
s
.864 .262 .114 r
.57404 .38327 m .56754 .37882 L .54562 .37786 L p F P
0 0 0 r
s
.864 .262 .114 r
.54115 .37484 m .54562 .37786 L .56754 .37882 L p F P
0 0 0 r
s
.31 .467 .903 r
.45438 .37786 m .45885 .37484 L .43901 .37434 L p F P
0 0 0 r
s
.31 .467 .903 r
.43901 .37434 m .43246 .37882 L .45438 .37786 L p F P
0 0 0 r
s
.937 .28 .121 r
.52307 .3626 m .5185 .3595 L .50924 .37062 L p F P
0 0 0 r
s
.937 .28 .121 r
.50694 .36908 m .50924 .37062 L .5185 .3595 L p F P
0 0 0 r
s
.83 .24 .1 r
.51063 .37916 m
.53184 .37001 L
s
.303 .454 .884 r
.49076 .37062 m .49306 .36908 L .48609 .35639 L p F P
0 0 0 r
s
.303 .454 .884 r
.48609 .35639 m .4815 .3595 L .49076 .37062 L p F P
0 0 0 r
s
.24 .35 .67 r
.46816 .37001 m
.48937 .37916 L
s
.092 .118 .262 r
.61437 .58826 m .59936 .59614 L .60212 .57957 L p F P
0 0 0 r
s
.24 .35 .67 r
.6005 .58447 m
.60147 .56088 L
s
.092 .118 .262 r
.60212 .57957 m .61757 .57134 L .61437 .58826 L p F P
0 0 0 r
s
.804 .216 .086 r
.38243 .57134 m .39788 .57957 L .40064 .59614 L p F P
0 0 0 r
s
.804 .216 .086 r
.41544 .60391 m .40064 .59614 L .39788 .57957 L p F P
0 0 0 r
s
.83 .24 .1 r
.39853 .56088 m
.3995 .58447 L
s
.742 .231 .102 r
.61315 .39991 m .6049 .39422 L .58049 .38769 L p F P
0 0 0 r
s
.742 .231 .102 r
.57404 .38327 m .58049 .38769 L .6049 .39422 L p F P
0 0 0 r
s
.309 .47 .9 r
.41951 .38769 m .42596 .38327 L .40341 .38848 L p F P
0 0 0 r
s
.309 .47 .9 r
.40341 .38848 m .3951 .39422 L .41951 .38769 L p F P
0 0 0 r
s
.937 .28 .121 r
.5185 .3595 m .51391 .35639 L .50694 .36908 L p F P
0 0 0 r
s
.937 .28 .121 r
.50463 .36754 m .50694 .36908 L .51391 .35639 L p F P
0 0 0 r
s
.303 .454 .884 r
.49306 .36908 m .49537 .36754 L .49071 .35327 L p F P
0 0 0 r
s
.83 .24 .1 r
.49317 .36755 m
.51063 .37916 L
s
.303 .454 .884 r
.49071 .35327 m .48609 .35639 L .49306 .36908 L p F P
0 0 0 r
s
.24 .35 .67 r
.48937 .37916 m
.50683 .36755 L
s
.19471 .58696 m
.21986 .57043 L
s
.19471 .58696 m
.19906 .61486 L
s
.83 .24 .1 r
.80529 .58696 m
.80094 .61486 L
s
.78014 .57043 m
.80529 .58696 L
s
.029 .04 .077 r
.56104 .63616 m .54853 .6426 L .55273 .63228 L p F P
0 0 0 r
s
.029 .04 .077 r
.55273 .63228 m .56635 .6252 L .56104 .63616 L p F P
0 0 0 r
s
.24 .35 .67 r
.53462 .63673 m
.56447 .62114 L
s
.54 .134 .052 r
.43365 .6252 m .44727 .63228 L .45147 .6426 L p F P
0 0 0 r
s
.54 .134 .052 r
.46382 .64897 m .45147 .6426 L .44727 .63228 L p F P
0 0 0 r
s
.83 .24 .1 r
.43553 .62114 m
.46538 .63673 L
s
.864 .262 .114 r
.56754 .37882 m .56099 .37434 L .54115 .37484 L p F P
0 0 0 r
s
.864 .262 .114 r
.53666 .3718 m .54115 .37484 L .56099 .37434 L p F P
0 0 0 r
s
.31 .467 .903 r
.45885 .37484 m .46334 .3718 L .4456 .36983 L p F P
0 0 0 r
s
.31 .467 .903 r
.4456 .36983 m .43901 .37434 L .45885 .37484 L p F P
0 0 0 r
s
.937 .28 .121 r
.51391 .35639 m .50929 .35327 L .50463 .36754 L p F P
0 0 0 r
s
.937 .28 .121 r
.50232 .36599 m .50463 .36754 L .50929 .35327 L p F P
0 0 0 r
s
.303 .454 .884 r
.49537 .36754 m .49768 .36599 L .49534 .35013 L p F P
0 0 0 r
s
.303 .454 .884 r
.49534 .35013 m .49071 .35327 L .49537 .36754 L p F P
0 0 0 r
s
.549 .179 .082 r
.64677 .41697 m .63701 .41021 L .61315 .39991 L p F P
0 0 0 r
s
.24 .35 .67 r
.62662 .42017 m
.63852 .41301 L
s
.549 .179 .082 r
.6049 .39422 m .61315 .39991 L .63701 .41021 L p F P
0 0 0 r
s
.292 .449 .849 r
.38685 .39991 m .3951 .39422 L .37286 .40337 L p F P
0 0 0 r
s
.292 .449 .849 r
.37286 .40337 m .36299 .41021 L .38685 .39991 L p F P
0 0 0 r
s
.24 .35 .67 r
.3721 .40727 m
.38581 .40556 L
s
.024 .035 .067 r
.5321 .65537 m .52129 .66093 L .52397 .65527 L p F P
0 0 0 r
s
.024 .035 .067 r
.52397 .65527 m .53618 .64897 L .5321 .65537 L p F P
0 0 0 r
s
.24 .35 .67 r
.4988 .66665 m
.52441 .65343 L
s
.52441 .65343 m
.53462 .63673 L
s
.383 .086 .036 r
.46382 .64897 m .47603 .65527 L .47871 .66093 L p F P
0 0 0 r
s
.83 .24 .1 r
.46538 .63673 m
.47559 .65343 L
s
.383 .086 .036 r
.48941 .66642 m .47871 .66093 L .47603 .65527 L p F P
0 0 0 r
s
.83 .24 .1 r
.47559 .65343 m
.5012 .66665 L
s
.062 .08 .171 r
.59415 .61076 m .58015 .61803 L .58456 .60391 L p F P
0 0 0 r
s
.062 .08 .171 r
.58456 .60391 m .59936 .59614 L .59415 .61076 L p F P
0 0 0 r
s
.24 .35 .67 r
.57011 .60059 m
.6005 .58447 L
s
.689 .18 .07 r
.40064 .59614 m .41544 .60391 L .41985 .61803 L p F P
0 0 0 r
s
.83 .24 .1 r
.3995 .58447 m
.42989 .60059 L
s
.689 .18 .07 r
.43365 .6252 m .41985 .61803 L .41544 .60391 L p F P
0 0 0 r
s
.937 .28 .121 r
.50929 .35327 m .50466 .35013 L .50232 .36599 L p F P
0 0 0 r
s
.937 .28 .121 r
.5 .36444 m .50232 .36599 L .50466 .35013 L p F P
0 0 0 r
s
.303 .454 .884 r
.49768 .36599 m .5 .36444 L .5 .34697 L p F P
0 0 0 r
s
.303 .454 .884 r
.5 .34697 m .49534 .35013 L .49768 .36599 L p F P
0 0 0 r
s
.24 .35 .67 r
.31115 .71712 m
.33466 .72765 L
s
.33466 .72765 m
.36197 .7132 L
s
.83 .24 .1 r
.63803 .7132 m
.66534 .72765 L
s
.66534 .72765 m
.68885 .71712 L
s
.742 .231 .102 r
.6049 .39422 m .59659 .38848 L .57404 .38327 L p F P
0 0 0 r
s
.742 .231 .102 r
.56754 .37882 m .57404 .38327 L .59659 .38848 L p F P
0 0 0 r
s
.83 .24 .1 r
.58095 .38581 m
.60325 .40109 L
s
.56039 .38932 m
.58095 .38581 L
s
.24 .35 .67 r
.5768 .3819 m
.59051 .3732 L
s
.59051 .3732 m
.60957 .39541 L
s
.309 .47 .9 r
.42596 .38327 m .43246 .37882 L .41181 .3827 L p F P
0 0 0 r
s
.83 .24 .1 r
.40949 .3732 m
.42156 .38087 L
s
.42531 .38324 m
.42551 .38337 L
s
.309 .47 .9 r
.41181 .3827 m .40341 .38848 L .42596 .38327 L p F P
0 0 0 r
s
.83 .24 .1 r
.39043 .39541 m
.40949 .3732 L
s
.24 .35 .67 r
.39675 .40109 m
.41905 .38581 L
s
.41905 .38581 m
.43961 .38932 L
s
1 .291 .121 r
.34398 .43815 m .33096 .43053 L .35323 .41697 L p F P
0 0 0 r
s
.411 .13 .062 r
.63701 .41021 m .64677 .41697 L .66904 .43053 L p F P
0 0 0 r
s
.249 .388 .721 r
.35323 .41697 m .36299 .41021 L .34207 .42281 L p F P
0 0 0 r
s
.24 .35 .67 r
.36164 .4145 m
.3721 .40727 L
s
.249 .388 .721 r
.34207 .42281 m .33096 .43053 L .35323 .41697 L p F P
0 0 0 r
s
.864 .262 .114 r
.56099 .37434 m .5544 .36983 L .53666 .3718 L p F P
0 0 0 r
s
.864 .262 .114 r
.53215 .36874 m .53666 .3718 L .5544 .36983 L p F P
0 0 0 r
s
.83 .24 .1 r
.53184 .37001 m
.56039 .38932 L
s
.31 .467 .903 r
.46334 .3718 m .46785 .36874 L .45224 .36529 L p F P
0 0 0 r
s
.31 .467 .903 r
.45224 .36529 m .4456 .36983 L .46334 .3718 L p F P
0 0 0 r
s
.83 .24 .1 r
.42993 .35433 m
.44958 .36711 L
s
.24 .35 .67 r
.43961 .38932 m
.46816 .37001 L
s
.209 .299 .607 r
.68757 .44594 m .67301 .45428 L .65602 .43815 L p F P
0 0 0 r
s
.209 .299 .607 r
.65602 .43815 m .66904 .43053 L .68757 .44594 L p F P
0 0 0 r
s
.83 .24 .1 r
.68209 .44137 m
.69849 .45274 L
s
1 .286 .119 r
.33096 .43053 m .34398 .43815 L .32699 .45428 L p F P
0 0 0 r
s
.24 .35 .67 r
.32805 .43435 m
.33052 .43313 L
s
1 .286 .119 r
.34137 .46252 m .32699 .45428 L .34398 .43815 L p F P
0 0 0 r
s
.24 .35 .67 r
.30151 .45274 m
.32805 .43435 L
s
.59051 .3732 m
.62169 .35341 L
s
.83 .24 .1 r
.37831 .35341 m
.40949 .3732 L
s
.193 .274 .56 r
.68609 .47175 m .67055 .48048 L .65863 .46252 L p F P
0 0 0 r
s
.193 .274 .56 r
.65863 .46252 m .67301 .45428 L .68609 .47175 L p F P
0 0 0 r
s
.992 .279 .115 r
.32699 .45428 m .34137 .46252 L .32945 .48048 L p F P
0 0 0 r
s
.992 .279 .115 r
.34478 .48909 m .32945 .48048 L .34137 .46252 L p F P
0 0 0 r
s
.175 .246 .506 r
.67854 .49919 m .66244 .50806 L .65522 .48909 L p F P
0 0 0 r
s
.175 .246 .506 r
.65522 .48909 m .67055 .48048 L .67854 .49919 L p F P
0 0 0 r
s
.24 .35 .67 r
.65245 .47383 m
.66029 .50091 L
s
.967 .27 .111 r
.32945 .48048 m .34478 .48909 L .33756 .50806 L p F P
0 0 0 r
s
.967 .27 .111 r
.35342 .51679 m .33756 .50806 L .34478 .48909 L p F P
0 0 0 r
s
.83 .24 .1 r
.33971 .50091 m
.34755 .47383 L
s
.937 .28 .121 r
.50466 .35013 m .5 .34697 L .5 .36444 L p F P
0 0 0 r
s
.24 .35 .67 r
.46269 .68742 m
.48066 .68066 L
s
.83 .24 .1 r
.51934 .68066 m
.53731 .68742 L
s
.153 .212 .442 r
.66587 .52714 m .64966 .53592 L .64658 .51679 L p F P
0 0 0 r
s
.153 .212 .442 r
.64658 .51679 m .66244 .50806 L .66587 .52714 L p F P
0 0 0 r
s
.24 .35 .67 r
.62882 .51837 m
.66029 .50091 L
s
.931 .257 .105 r
.33756 .50806 m .35342 .51679 L .35034 .53592 L p F P
0 0 0 r
s
.931 .257 .105 r
.36632 .54456 m .35034 .53592 L .35342 .51679 L p F P
0 0 0 r
s
.83 .24 .1 r
.33971 .50091 m
.37118 .51837 L
s
.24 .35 .67 r
.36197 .7132 m
.3848 .71799 L
s
.3848 .71799 m
.41291 .70336 L
s
.83 .24 .1 r
.58709 .70336 m
.6152 .71799 L
s
.6152 .71799 m
.63803 .7132 L
s
.24 .35 .67 r
.41291 .70336 m
.43384 .70229 L
s
.43384 .70229 m
.46269 .68742 L
s
.83 .24 .1 r
.53731 .68742 m
.56616 .70229 L
s
.56616 .70229 m
.58709 .70336 L
s
.126 .17 .362 r
.64918 .55451 m .63326 .56299 L .63368 .54456 L p F P
0 0 0 r
s
.126 .17 .362 r
.63368 .54456 m .64966 .53592 L .64918 .55451 L p F P
0 0 0 r
s
.88 .24 .097 r
.35034 .53592 m .36632 .54456 L .36674 .56299 L p F P
0 0 0 r
s
.88 .24 .097 r
.38243 .57134 m .36674 .56299 L .36632 .54456 L p F P
0 0 0 r
s
.83 .24 .1 r
.3676 .54413 m
.39853 .56088 L
s
.7795 .54413 m
.75384 .52688 L
s
.24 .35 .67 r
.2205 .54413 m
.24616 .52688 L
s
.2205 .54413 m
.21986 .57043 L
s
.83 .24 .1 r
.78014 .57043 m
.7795 .54413 L
s
.864 .262 .114 r
.5544 .36983 m .54776 .36529 L .53215 .36874 L p F P
0 0 0 r
s
.24 .35 .67 r
.55042 .36711 m
.57007 .35433 L
s
.864 .262 .114 r
.52763 .36568 m .53215 .36874 L .54776 .36529 L p F P
0 0 0 r
s
.31 .467 .903 r
.46785 .36874 m .47237 .36568 L .45892 .36072 L p F P
0 0 0 r
s
.31 .467 .903 r
.45892 .36072 m .45224 .36529 L .46785 .36874 L p F P
0 0 0 r
s
.549 .179 .082 r
.63701 .41021 m .62714 .40337 L .6049 .39422 L p F P
0 0 0 r
s
.83 .24 .1 r
.6279 .40727 m
.63836 .4145 L
s
.61419 .40556 m
.6279 .40727 L
s
.549 .179 .082 r
.59659 .38848 m .6049 .39422 L .62714 .40337 L p F P
0 0 0 r
s
.292 .449 .849 r
.3951 .39422 m .40341 .38848 L .38282 .39646 L p F P
0 0 0 r
s
.83 .24 .1 r
.39 .39515 m
.39043 .39541 L
s
.292 .449 .849 r
.38282 .39646 m .37286 .40337 L .3951 .39422 L p F P
0 0 0 r
s
.742 .231 .102 r
.59659 .38848 m .58819 .3827 L .56754 .37882 L p F P
0 0 0 r
s
.742 .231 .102 r
.56099 .37434 m .56754 .37882 L .58819 .3827 L p F P
0 0 0 r
s
.309 .47 .9 r
.43246 .37882 m .43901 .37434 L .42027 .37686 L p F P
0 0 0 r
s
.309 .47 .9 r
.42027 .37686 m .41181 .3827 L .43246 .37882 L p F P
0 0 0 r
s
.092 .118 .262 r
.6296 .58026 m .61437 .58826 L .61757 .57134 L p F P
0 0 0 r
s
.092 .118 .262 r
.61757 .57134 m .63326 .56299 L .6296 .58026 L p F P
0 0 0 r
s
.804 .216 .086 r
.36674 .56299 m .38243 .57134 L .38563 .58826 L p F P
0 0 0 r
s
.804 .216 .086 r
.40064 .59614 m .38563 .58826 L .38243 .57134 L p F P
0 0 0 r
s
.24 .35 .67 r
.24078 .69491 m
.26183 .71564 L
s
.26183 .71564 m
.28816 .70094 L
s
.83 .24 .1 r
.71184 .70094 m
.73817 .71564 L
s
.75922 .69491 m
.73817 .71564 L
s
.24 .35 .67 r
.32805 .43435 m
.33062 .43257 L
s
.25161 .50362 m
.2778 .48571 L
s
.25161 .50362 m
.24616 .52688 L
s
.83 .24 .1 r
.75384 .52688 m
.74839 .50362 L
s
.7222 .48571 m
.74839 .50362 L
s
.024 .035 .067 r
.50896 .66749 m .5 .67208 L .5 .67186 L p F P
0 0 0 r
s
.024 .035 .067 r
.5 .67186 m .51059 .66642 L .50896 .66749 L p F P
0 0 0 r
s
.83 .24 .1 r
.50133 .6714 m
.50212 .67181 L
s
.50212 .67181 m
.51934 .68066 L
s
.252 .058 .024 r
.48941 .66642 m .5 .67186 L .5 .67208 L p F P
0 0 0 r
s
.24 .35 .67 r
.48066 .68066 m
.49788 .67181 L
s
.029 .04 .077 r
.5737 .62963 m .56104 .63616 L .56635 .6252 L p F P
0 0 0 r
s
.029 .04 .077 r
.56635 .6252 m .58015 .61803 L .5737 .62963 L p F P
0 0 0 r
s
.54 .134 .052 r
.41985 .61803 m .43365 .6252 L .43896 .63616 L p F P
0 0 0 r
s
.54 .134 .052 r
.45147 .6426 m .43896 .63616 L .43365 .6252 L p F P
0 0 0 r
s
.864 .262 .114 r
.54776 .36529 m .54108 .36072 L .52763 .36568 L p F P
0 0 0 r
s
.864 .262 .114 r
.52307 .3626 m .52763 .36568 L .54108 .36072 L p F P
0 0 0 r
s
.31 .467 .903 r
.47237 .36568 m .47693 .3626 L .46565 .35611 L p F P
0 0 0 r
s
.31 .467 .903 r
.46565 .35611 m .45892 .36072 L .47237 .36568 L p F P
0 0 0 r
s
.24 .35 .67 r
.28765 .46669 m
.2778 .48571 L
s
.83 .24 .1 r
.7222 .48571 m
.71235 .46669 L
s
.411 .13 .062 r
.66904 .43053 m .65793 .42281 L .63701 .41021 L p F P
0 0 0 r
s
.411 .13 .062 r
.62714 .40337 m .63701 .41021 L .65793 .42281 L p F P
0 0 0 r
s
.24 .35 .67 r
.64051 .41181 m
.6581 .40122 L
s
.249 .388 .721 r
.36299 .41021 m .37286 .40337 L .35332 .415 L p F P
0 0 0 r
s
.83 .24 .1 r
.35961 .41188 m
.35991 .41206 L
s
.249 .388 .721 r
.35332 .415 m .34207 .42281 L .36299 .41021 L p F P
0 0 0 r
s
.83 .24 .1 r
.3419 .40122 m
.35909 .41157 L
s
.24 .35 .67 r
.19906 .61486 m
.22447 .59862 L
s
.19906 .61486 m
.20852 .64315 L
s
.83 .24 .1 r
.80094 .61486 m
.79148 .64315 L
s
.77553 .59862 m
.80094 .61486 L
s
.024 .035 .067 r
.54304 .64976 m .5321 .65537 L .53618 .64897 L p F P
0 0 0 r
s
.024 .035 .067 r
.53618 .64897 m .54853 .6426 L .54304 .64976 L p F P
0 0 0 r
s
.383 .086 .036 r
.45147 .6426 m .46382 .64897 L .4679 .65537 L p F P
0 0 0 r
s
.383 .086 .036 r
.47871 .66093 m .4679 .65537 L .46382 .64897 L p F P
0 0 0 r
s
1 .286 .119 r
.32699 .45428 m .31243 .44594 L .33096 .43053 L p F P
0 0 0 r
s
.36 .08 .033 r
.65793 .42281 m .66904 .43053 L .68757 .44594 L p F P
0 0 0 r
s
.24 .35 .67 r
.66889 .43033 m
.67282 .42803 L
s
.66873 .43042 m
.66889 .43033 L
s
.64108 .44661 m
.66813 .43077 L
s
.024 .035 .067 r
.33096 .43053 m .34207 .42281 L .32464 .43747 L p F P
0 0 0 r
s
.83 .24 .1 r
.33111 .43033 m
.33127 .43042 L
s
.33231 .43103 m
.35892 .44661 L
s
.32718 .42803 m
.33111 .43033 L
s
.024 .035 .067 r
.32464 .43747 m .31243 .44594 L .33096 .43053 L p F P
0 0 0 r
s
.062 .08 .171 r
.60833 .60339 m .59415 .61076 L .59936 .59614 L p F P
0 0 0 r
s
.062 .08 .171 r
.59936 .59614 m .61437 .58826 L .60833 .60339 L p F P
0 0 0 r
s
.24 .35 .67 r
.59522 .60509 m
.6005 .58447 L
s
.689 .18 .07 r
.38563 .58826 m .40064 .59614 L .40585 .61076 L p F P
0 0 0 r
s
.689 .18 .07 r
.41985 .61803 m .40585 .61076 L .40064 .59614 L p F P
0 0 0 r
s
.742 .231 .102 r
.58819 .3827 m .57973 .37686 L .56099 .37434 L p F P
0 0 0 r
s
.742 .231 .102 r
.5544 .36983 m .56099 .37434 L .57973 .37686 L p F P
0 0 0 r
s
.24 .35 .67 r
.57007 .35433 m
.59051 .3732 L
s
.309 .47 .9 r
.43901 .37434 m .4456 .36983 L .42881 .37097 L p F P
0 0 0 r
s
.309 .47 .9 r
.42881 .37097 m .42027 .37686 L .43901 .37434 L p F P
0 0 0 r
s
.83 .24 .1 r
.40949 .3732 m
.42993 .35433 L
s
.864 .262 .114 r
.54108 .36072 m .53435 .35611 L .52307 .3626 L p F P
0 0 0 r
s
.864 .262 .114 r
.5185 .3595 m .52307 .3626 L .53435 .35611 L p F P
0 0 0 r
s
.31 .467 .903 r
.47693 .3626 m .4815 .3595 L .47242 .35148 L p F P
0 0 0 r
s
.31 .467 .903 r
.47242 .35148 m .46565 .35611 L .47693 .3626 L p F P
0 0 0 r
s
.83 .24 .1 r
.45107 .33958 m
.47072 .35264 L
s
.193 .274 .56 r
.70186 .4629 m .68609 .47175 L .67301 .45428 L p F P
0 0 0 r
s
.193 .274 .56 r
.67301 .45428 m .68757 .44594 L .70186 .4629 L p F P
0 0 0 r
s
.992 .279 .115 r
.31243 .44594 m .32699 .45428 L .31391 .47175 L p F P
0 0 0 r
s
.992 .279 .115 r
.32945 .48048 m .31391 .47175 L .32699 .45428 L p F P
0 0 0 r
s
.549 .179 .082 r
.62714 .40337 m .61718 .39646 L .59659 .38848 L p F P
0 0 0 r
s
.549 .179 .082 r
.58819 .3827 m .59659 .38848 L .61718 .39646 L p F P
0 0 0 r
s
.24 .35 .67 r
.61192 .39397 m
.64087 .37606 L
s
.292 .449 .849 r
.40341 .38848 m .41181 .3827 L .3929 .38948 L p F P
0 0 0 r
s
.292 .449 .849 r
.3929 .38948 m .38282 .39646 L .40341 .38848 L p F P
0 0 0 r
s
.83 .24 .1 r
.35913 .37606 m
.38721 .39342 L
s
.175 .246 .506 r
.69488 .49019 m .67854 .49919 L .67055 .48048 L p F P
0 0 0 r
s
.175 .246 .506 r
.67055 .48048 m .68609 .47175 L .69488 .49019 L p F P
0 0 0 r
s
.24 .35 .67 r
.65245 .47383 m
.6845 .45558 L
s
.967 .27 .111 r
.31391 .47175 m .32945 .48048 L .32146 .49919 L p F P
0 0 0 r
s
.83 .24 .1 r
.3155 .45558 m
.34755 .47383 L
s
.967 .27 .111 r
.33756 .50806 m .32146 .49919 L .32945 .48048 L p F P
0 0 0 r
s
.24 .35 .67 r
.6581 .40122 m
.67282 .42803 L
s
.6581 .40122 m
.69054 .3817 L
s
.6581 .40122 m
.64087 .37606 L
s
.83 .24 .1 r
.35913 .37606 m
.3419 .40122 L
s
.30946 .3817 m
.3419 .40122 L
s
.32718 .42803 m
.3419 .40122 L
s
.153 .212 .442 r
.68234 .51823 m .66587 .52714 L .66244 .50806 L p F P
0 0 0 r
s
.153 .212 .442 r
.66244 .50806 m .67854 .49919 L .68234 .51823 L p F P
0 0 0 r
s
.24 .35 .67 r
.66029 .50091 m
.66425 .52688 L
s
.931 .257 .105 r
.32146 .49919 m .33756 .50806 L .33413 .52714 L p F P
0 0 0 r
s
.931 .257 .105 r
.35034 .53592 m .33413 .52714 L .33756 .50806 L p F P
0 0 0 r
s
.83 .24 .1 r
.33575 .52688 m
.33971 .50091 L
s
.39881 .33409 m
.42993 .35433 L
s
.24 .35 .67 r
.57007 .35433 m
.60119 .33409 L
s
.57007 .35433 m
.54893 .33958 L
s
.22268 .67032 m
.24078 .69491 L
s
.24078 .69491 m
.26692 .67982 L
s
.83 .24 .1 r
.73308 .67982 m
.75922 .69491 L
s
.77732 .67032 m
.75922 .69491 L
s
.126 .17 .362 r
.66534 .54591 m .64918 .55451 L .64966 .53592 L p F P
0 0 0 r
s
.126 .17 .362 r
.64966 .53592 m .66587 .52714 L .66534 .54591 L p F P
0 0 0 r
s
.24 .35 .67 r
.6324 .54413 m
.66425 .52688 L
s
.88 .24 .097 r
.33413 .52714 m .35034 .53592 L .35082 .55451 L p F P
0 0 0 r
s
.88 .24 .097 r
.36674 .56299 m .35082 .55451 L .35034 .53592 L p F P
0 0 0 r
s
.24 .35 .67 r
.67282 .42803 m
.67663 .43702 L
s
.83 .24 .1 r
.32337 .43702 m
.32718 .42803 L
s
.3155 .45558 m
.32257 .43891 L
s
.864 .262 .114 r
.53435 .35611 m .52758 .35148 L .5185 .3595 L p F P
0 0 0 r
s
.24 .35 .67 r
.52928 .35264 m
.54893 .33958 L
s
.864 .262 .114 r
.51391 .35639 m .5185 .3595 L .52758 .35148 L p F P
0 0 0 r
s
.31 .467 .903 r
.4815 .3595 m .48609 .35639 L .47925 .34681 L p F P
0 0 0 r
s
.31 .467 .903 r
.47925 .34681 m .47242 .35148 L .4815 .3595 L p F P
0 0 0 r
s
.024 .035 .067 r
.51799 .66285 m .50896 .66749 L .51059 .66642 L p F P
0 0 0 r
s
.024 .035 .067 r
.51059 .66642 m .52129 .66093 L .51799 .66285 L p F P
0 0 0 r
s
.252 .058 .024 r
.47871 .66093 m .48941 .66642 L .49104 .66749 L p F P
0 0 0 r
s
.252 .058 .024 r
.5 .67208 m .49104 .66749 L .48941 .66642 L p F P
0 0 0 r
s
.24 .35 .67 r
.49883 .67132 m
.5102 .66547 L
s
.49788 .67181 m
.49867 .6714 L
s
.20852 .64315 m
.2342 .62726 L
s
.20852 .64315 m
.22268 .67032 L
s
.83 .24 .1 r
.79148 .64315 m
.77732 .67032 L
s
.7658 .62726 m
.79148 .64315 L
s
.742 .231 .102 r
.57973 .37686 m .57119 .37097 L .5544 .36983 L p F P
0 0 0 r
s
.742 .231 .102 r
.54776 .36529 m .5544 .36983 L .57119 .37097 L p F P
0 0 0 r
s
.309 .47 .9 r
.4456 .36983 m .45224 .36529 L .43743 .36502 L p F P
0 0 0 r
s
.24 .35 .67 r
.44771 .36616 m
.46816 .37001 L
s
.309 .47 .9 r
.43743 .36502 m .42881 .37097 L .4456 .36983 L p F P
0 0 0 r
s
.24 .35 .67 r
.64087 .37606 m
.67311 .35611 L
s
.64087 .37606 m
.62169 .35341 L
s
.83 .24 .1 r
.37831 .35341 m
.35913 .37606 L
s
.32689 .35611 m
.35913 .37606 L
s
.24 .35 .67 r
.28816 .70094 m
.31115 .71712 L
s
.31115 .71712 m
.3384 .70234 L
s
.83 .24 .1 r
.6616 .70234 m
.68885 .71712 L
s
.68885 .71712 m
.71184 .70094 L
s
.411 .13 .062 r
.65793 .42281 m .64668 .415 L .62714 .40337 L p F P
0 0 0 r
s
.411 .13 .062 r
.61718 .39646 m .62714 .40337 L .64668 .415 L p F P
0 0 0 r
s
.249 .388 .721 r
.37286 .40337 m .38282 .39646 L .36471 .4071 L p F P
0 0 0 r
s
.249 .388 .721 r
.36471 .4071 m .35332 .415 L .37286 .40337 L p F P
0 0 0 r
s
.092 .118 .262 r
.64505 .57214 m .6296 .58026 L .63326 .56299 L p F P
0 0 0 r
s
.24 .35 .67 r
.6318 .56786 m
.6324 .54413 L
s
.092 .118 .262 r
.63326 .56299 m .64918 .55451 L .64505 .57214 L p F P
0 0 0 r
s
.804 .216 .086 r
.35082 .55451 m .36674 .56299 L .3704 .58026 L p F P
0 0 0 r
s
.804 .216 .086 r
.38563 .58826 m .3704 .58026 L .36674 .56299 L p F P
0 0 0 r
s
.83 .24 .1 r
.3676 .54413 m
.3682 .56786 L
s
.24 .35 .67 r
.22268 .67032 m
.2486 .65483 L
s
.83 .24 .1 r
.7514 .65483 m
.77732 .67032 L
s
.029 .04 .077 r
.58651 .62302 m .5737 .62963 L .58015 .61803 L p F P
0 0 0 r
s
.029 .04 .077 r
.58015 .61803 m .59415 .61076 L .58651 .62302 L p F P
0 0 0 r
s
.24 .35 .67 r
.56447 .62114 m
.59522 .60509 L
s
.54 .134 .052 r
.40585 .61076 m .41985 .61803 L .4263 .62963 L p F P
0 0 0 r
s
.54 .134 .052 r
.43896 .63616 m .4263 .62963 L .41985 .61803 L p F P
0 0 0 r
s
.024 .035 .067 r
.55409 .64409 m .54304 .64976 L .54853 .6426 L p F P
0 0 0 r
s
.024 .035 .067 r
.54853 .6426 m .56104 .63616 L .55409 .64409 L p F P
0 0 0 r
s
.24 .35 .67 r
.52441 .65343 m
.55457 .63785 L
s
.55457 .63785 m
.56447 .62114 L
s
.383 .086 .036 r
.43896 .63616 m .45147 .6426 L .45696 .64976 L p F P
0 0 0 r
s
.83 .24 .1 r
.43553 .62114 m
.44543 .63785 L
s
.383 .086 .036 r
.4679 .65537 m .45696 .64976 L .45147 .6426 L p F P
0 0 0 r
s
.83 .24 .1 r
.44543 .63785 m
.47559 .65343 L
s
.864 .262 .114 r
.52758 .35148 m .52075 .34681 L .51391 .35639 L p F P
0 0 0 r
s
.864 .262 .114 r
.50929 .35327 m .51391 .35639 L .52075 .34681 L p F P
0 0 0 r
s
.31 .467 .903 r
.48609 .35639 m .49071 .35327 L .48611 .34211 L p F P
0 0 0 r
s
.31 .467 .903 r
.48611 .34211 m .47925 .34681 L .48609 .35639 L p F P
0 0 0 r
s
.549 .179 .082 r
.61718 .39646 m .6071 .38948 L .58819 .3827 L p F P
0 0 0 r
s
.549 .179 .082 r
.57973 .37686 m .58819 .3827 L .6071 .38948 L p F P
0 0 0 r
s
.292 .449 .849 r
.41181 .3827 m .42027 .37686 L .40309 .38242 L p F P
0 0 0 r
s
.292 .449 .849 r
.40309 .38242 m .3929 .38948 L .41181 .3827 L p F P
0 0 0 r
s
.24 .35 .67 r
.40007 .38793 m
.41905 .38581 L
s
.21986 .57043 m
.24578 .55339 L
s
.21986 .57043 m
.22447 .59862 L
s
.83 .24 .1 r
.77553 .59862 m
.78014 .57043 L
s
.75422 .55339 m
.78014 .57043 L
s
.36 .08 .033 r
.68757 .44594 m .67536 .43747 L .65793 .42281 L p F P
0 0 0 r
s
.24 .35 .67 r
.67743 .43891 m
.6845 .45558 L
s
.36 .08 .033 r
.64668 .415 m .65793 .42281 L .67536 .43747 L p F P
0 0 0 r
s
.024 .035 .067 r
.34207 .42281 m .35332 .415 L .33702 .4289 L p F P
0 0 0 r
s
.24 .35 .67 r
.33148 .43197 m
.33853 .42709 L
s
.024 .035 .067 r
.33702 .4289 m .32464 .43747 L .34207 .42281 L p F P
0 0 0 r
s
.83 .24 .1 r
.29448 .40889 m
.32718 .42803 L
s
.742 .231 .102 r
.57119 .37097 m .56257 .36502 L .54776 .36529 L p F P
0 0 0 r
s
.83 .24 .1 r
.53184 .37001 m
.55229 .36616 L
s
.742 .231 .102 r
.54108 .36072 m .54776 .36529 L .56257 .36502 L p F P
0 0 0 r
s
.309 .47 .9 r
.45224 .36529 m .45892 .36072 L .44613 .35903 L p F P
0 0 0 r
s
.309 .47 .9 r
.44613 .35903 m .43743 .36502 L .45224 .36529 L p F P
0 0 0 r
s
.062 .08 .171 r
.62271 .59592 m .60833 .60339 L .61437 .58826 L p F P
0 0 0 r
s
.062 .08 .171 r
.61437 .58826 m .6296 .58026 L .62271 .59592 L p F P
0 0 0 r
s
.24 .35 .67 r
.6005 .58447 m
.6318 .56786 L
s
.689 .18 .07 r
.3704 .58026 m .38563 .58826 L .39167 .60339 L p F P
0 0 0 r
s
.83 .24 .1 r
.3682 .56786 m
.3995 .58447 L
s
.689 .18 .07 r
.40585 .61076 m .39167 .60339 L .38563 .58826 L p F P
0 0 0 r
s
.83 .24 .1 r
.40478 .60509 m
.43553 .62114 L
s
.3995 .58447 m
.40478 .60509 L
s
.992 .279 .115 r
.31391 .47175 m .29814 .4629 L .31243 .44594 L p F P
0 0 0 r
s
.542 .135 .052 r
.67536 .43747 m .68757 .44594 L .70186 .4629 L p F P
0 0 0 r
s
.24 .35 .67 r
.69185 .45139 m
.69304 .45072 L
s
.6845 .45558 m
.69061 .4521 L
s
.83 .24 .1 r
.67637 .43884 m
.6856 .44822 L
s
.6856 .44822 m
.68901 .45057 L
s
.69491 .45465 m
.71235 .46669 L
s
.024 .035 .067 r
.31243 .44594 m .32464 .43747 L .31119 .45391 L p F P
0 0 0 r
s
.24 .35 .67 r
.32301 .43947 m
.32363 .43884 L
s
.024 .035 .067 r
.31119 .45391 m .29814 .4629 L .31243 .44594 L p F P
0 0 0 r
s
.83 .24 .1 r
.31163 .45337 m
.3155 .45558 L
s
.30696 .45072 m
.30815 .45139 L
s
.24 .35 .67 r
.28765 .46669 m
.30509 .45465 L
s
.83 .24 .1 r
.28246 .43677 m
.30696 .45072 L
s
.864 .262 .114 r
.52075 .34681 m .51389 .34211 L .50929 .35327 L p F P
0 0 0 r
s
.864 .262 .114 r
.50466 .35013 m .50929 .35327 L .51389 .34211 L p F P
0 0 0 r
s
.31 .467 .903 r
.49071 .35327 m .49534 .35013 L .49303 .33737 L p F P
0 0 0 r
s
.31 .467 .903 r
.49303 .33737 m .48611 .34211 L .49071 .35327 L p F P
0 0 0 r
s
.24 .35 .67 r
.3384 .70234 m
.36197 .7132 L
s
.36197 .7132 m
.3901 .6983 L
s
.83 .24 .1 r
.6099 .6983 m
.63803 .7132 L
s
.63803 .7132 m
.6616 .70234 L
s
.175 .246 .506 r
.71146 .48105 m .69488 .49019 L .68609 .47175 L p F P
0 0 0 r
s
.175 .246 .506 r
.68609 .47175 m .70186 .4629 L .71146 .48105 L p F P
0 0 0 r
s
.967 .27 .111 r
.29814 .4629 m .31391 .47175 L .30512 .49019 L p F P
0 0 0 r
s
.967 .27 .111 r
.32146 .49919 m .30512 .49019 L .31391 .47175 L p F P
0 0 0 r
s
.83 .24 .1 r
.30729 .48292 m
.3155 .45558 L
s
.024 .035 .067 r
.52711 .65817 m .51799 .66285 L .52129 .66093 L p F P
0 0 0 r
s
.024 .035 .067 r
.52129 .66093 m .5321 .65537 L .52711 .65817 L p F P
0 0 0 r
s
.24 .35 .67 r
.5102 .66547 m
.52441 .65343 L
s
.252 .058 .024 r
.4679 .65537 m .47871 .66093 L .48201 .66285 L p F P
0 0 0 r
s
.252 .058 .024 r
.49104 .66749 m .48201 .66285 L .47871 .66093 L p F P
0 0 0 r
s
.83 .24 .1 r
.47559 .65343 m
.4898 .66547 L
s
.4898 .66547 m
.50117 .67132 L
s
.24 .35 .67 r
.62169 .35341 m
.65381 .33301 L
s
.62169 .35341 m
.60119 .33409 L
s
.83 .24 .1 r
.39881 .33409 m
.37831 .35341 L
s
.34619 .33301 m
.37831 .35341 L
s
.153 .212 .442 r
.69906 .50919 m .68234 .51823 L .67854 .49919 L p F P
0 0 0 r
s
.153 .212 .442 r
.67854 .49919 m .69488 .49019 L .69906 .50919 L p F P
0 0 0 r
s
.24 .35 .67 r
.66029 .50091 m
.69271 .48292 L
s
.931 .257 .105 r
.30512 .49019 m .32146 .49919 L .31766 .51823 L p F P
0 0 0 r
s
.931 .257 .105 r
.33413 .52714 m .31766 .51823 L .32146 .49919 L p F P
0 0 0 r
s
.83 .24 .1 r
.30729 .48292 m
.33971 .50091 L
s
.411 .13 .062 r
.64668 .415 m .63529 .4071 L .61718 .39646 L p F P
0 0 0 r
s
.411 .13 .062 r
.6071 .38948 m .61718 .39646 L .63529 .4071 L p F P
0 0 0 r
s
.249 .388 .721 r
.38282 .39646 m .3929 .38948 L .37625 .39909 L p F P
0 0 0 r
s
.249 .388 .721 r
.37625 .39909 m .36471 .4071 L .38282 .39646 L p F P
0 0 0 r
s
.24 .35 .67 r
.3721 .40727 m
.40007 .38793 L
s
.3901 .6983 m
.41291 .70336 L
s
.41291 .70336 m
.44188 .68829 L
s
.83 .24 .1 r
.55812 .68829 m
.58709 .70336 L
s
.58709 .70336 m
.6099 .6983 L
s
.549 .179 .082 r
.6071 .38948 m .59691 .38242 L .57973 .37686 L p F P
0 0 0 r
s
.83 .24 .1 r
.59993 .38793 m
.6279 .40727 L
s
.58095 .38581 m
.59993 .38793 L
s
.549 .179 .082 r
.57119 .37097 m .57973 .37686 L .59691 .38242 L p F P
0 0 0 r
s
.83 .24 .1 r
.55229 .36616 m
.58095 .38581 L
s
.292 .449 .849 r
.42027 .37686 m .42881 .37097 L .41339 .37528 L p F P
0 0 0 r
s
.292 .449 .849 r
.41339 .37528 m .40309 .38242 L .42027 .37686 L p F P
0 0 0 r
s
.24 .35 .67 r
.41905 .38581 m
.44771 .36616 L
s
.864 .262 .114 r
.51389 .34211 m .50697 .33737 L .50466 .35013 L p F P
0 0 0 r
s
.864 .262 .114 r
.5 .34697 m .50466 .35013 L .50697 .33737 L p F P
0 0 0 r
s
.83 .24 .1 r
.50244 .35012 m
.53184 .37001 L
s
.31 .467 .903 r
.49534 .35013 m .5 .34697 L .5 .3326 L p F P
0 0 0 r
s
.31 .467 .903 r
.5 .3326 m .49303 .33737 L .49534 .35013 L p F P
0 0 0 r
s
.24 .35 .67 r
.46816 .37001 m
.49756 .35012 L
s
.49756 .35012 m
.50539 .35365 L
s
.83 .24 .1 r
.49461 .35365 m
.50244 .35012 L
s
.24 .35 .67 r
.44188 .68829 m
.46269 .68742 L
s
.46269 .68742 m
.49242 .6721 L
s
.83 .24 .1 r
.50758 .6721 m
.53731 .68742 L
s
.53731 .68742 m
.55812 .68829 L
s
.126 .17 .362 r
.68174 .53717 m .66534 .54591 L .66587 .52714 L p F P
0 0 0 r
s
.126 .17 .362 r
.66587 .52714 m .68234 .51823 L .68174 .53717 L p F P
0 0 0 r
s
.88 .24 .097 r
.31766 .51823 m .33413 .52714 L .33466 .54591 L p F P
0 0 0 r
s
.88 .24 .097 r
.35082 .55451 m .33466 .54591 L .33413 .52714 L p F P
0 0 0 r
s
.83 .24 .1 r
.33575 .52688 m
.3676 .54413 L
s
.742 .231 .102 r
.56257 .36502 m .55387 .35903 L .54108 .36072 L p F P
0 0 0 r
s
.742 .231 .102 r
.53435 .35611 m .54108 .36072 L .55387 .35903 L p F P
0 0 0 r
s
.309 .47 .9 r
.45892 .36072 m .46565 .35611 L .4549 .35297 L p F P
0 0 0 r
s
.309 .47 .9 r
.4549 .35297 m .44613 .35903 L .45892 .36072 L p F P
0 0 0 r
s
.83 .24 .1 r
.42993 .35433 m
.45107 .33958 L
s
.75384 .52688 m
.7274 .5091 L
s
.24 .35 .67 r
.24616 .52688 m
.2726 .5091 L
s
.24616 .52688 m
.24578 .55339 L
s
.83 .24 .1 r
.75422 .55339 m
.75384 .52688 L
s
.024 .035 .067 r
.56526 .63835 m .55409 .64409 L .56104 .63616 L p F P
0 0 0 r
s
.024 .035 .067 r
.56104 .63616 m .5737 .62963 L .56526 .63835 L p F P
0 0 0 r
s
.383 .086 .036 r
.4263 .62963 m .43896 .63616 L .44591 .64409 L p F P
0 0 0 r
s
.383 .086 .036 r
.45696 .64976 m .44591 .64409 L .43896 .63616 L p F P
0 0 0 r
s
.029 .04 .077 r
.59949 .61633 m .58651 .62302 L .59415 .61076 L p F P
0 0 0 r
s
.029 .04 .077 r
.59415 .61076 m .60833 .60339 L .59949 .61633 L p F P
0 0 0 r
s
.54 .134 .052 r
.39167 .60339 m .40585 .61076 L .41349 .62302 L p F P
0 0 0 r
s
.54 .134 .052 r
.4263 .62963 m .41349 .62302 L .40585 .61076 L p F P
0 0 0 r
s
.092 .118 .262 r
.66073 .5639 m .64505 .57214 L .64918 .55451 L p F P
0 0 0 r
s
.092 .118 .262 r
.64918 .55451 m .66534 .54591 L .66073 .5639 L p F P
0 0 0 r
s
.804 .216 .086 r
.33466 .54591 m .35082 .55451 L .35495 .57214 L p F P
0 0 0 r
s
.804 .216 .086 r
.3704 .58026 m .35495 .57214 L .35082 .55451 L p F P
0 0 0 r
s
.24 .35 .67 r
.26692 .67982 m
.28816 .70094 L
s
.28816 .70094 m
.31529 .68579 L
s
.83 .24 .1 r
.68471 .68579 m
.71184 .70094 L
s
.71184 .70094 m
.73308 .67982 L
s
.36 .08 .033 r
.67536 .43747 m .66298 .4289 L .64668 .415 L p F P
0 0 0 r
s
.24 .35 .67 r
.67282 .42803 m
.70552 .40889 L
s
.36 .08 .033 r
.63529 .4071 m .64668 .415 L .66298 .4289 L p F P
0 0 0 r
s
.83 .24 .1 r
.64461 .4154 m
.65481 .42247 L
s
.6279 .40727 m
.64461 .4154 L
s
.024 .035 .067 r
.35332 .415 m .36471 .4071 L .34958 .4202 L p F P
0 0 0 r
s
.24 .35 .67 r
.34185 .42478 m
.35069 .41865 L
s
.35406 .41632 m
.35539 .4154 L
s
.35539 .4154 m
.3721 .40727 L
s
.024 .035 .067 r
.34958 .4202 m .33702 .4289 L .35332 .415 L p F P
0 0 0 r
s
.864 .262 .114 r
.50697 .33737 m .5 .3326 L .5 .34697 L p F P
0 0 0 r
s
.24 .35 .67 r
.49756 .35012 m
.50276 .3466 L
s
.83 .24 .1 r
.49724 .3466 m
.50244 .35012 L
s
.24 .35 .67 r
.2778 .48571 m
.2726 .5091 L
s
.83 .24 .1 r
.7274 .5091 m
.7222 .48571 L
s
.47213 .32962 m
.45107 .33958 L
s
.41992 .31888 m
.45107 .33958 L
s
.24 .35 .67 r
.54893 .33958 m
.58008 .31888 L
s
.54893 .33958 m
.52787 .32962 L
s
.22447 .59862 m
.25066 .58189 L
s
.22447 .59862 m
.2342 .62726 L
s
.83 .24 .1 r
.7658 .62726 m
.77553 .59862 L
s
.74934 .58189 m
.77553 .59862 L
s
.742 .231 .102 r
.55387 .35903 m .5451 .35297 L .53435 .35611 L p F P
0 0 0 r
s
.742 .231 .102 r
.52758 .35148 m .53435 .35611 L .5451 .35297 L p F P
0 0 0 r
s
.309 .47 .9 r
.46565 .35611 m .47242 .35148 L .46376 .34686 L p F P
0 0 0 r
s
.309 .47 .9 r
.46376 .34686 m .4549 .35297 L .46565 .35611 L p F P
0 0 0 r
s
.024 .035 .067 r
.53632 .65344 m .52711 .65817 L .5321 .65537 L p F P
0 0 0 r
s
.024 .035 .067 r
.5321 .65537 m .54304 .64976 L .53632 .65344 L p F P
0 0 0 r
s
.252 .058 .024 r
.45696 .64976 m .4679 .65537 L .47289 .65817 L p F P
0 0 0 r
s
.252 .058 .024 r
.48201 .66285 m .47289 .65817 L .4679 .65537 L p F P
0 0 0 r
s
.549 .179 .082 r
.59691 .38242 m .58661 .37528 L .57119 .37097 L p F P
0 0 0 r
s
.549 .179 .082 r
.56257 .36502 m .57119 .37097 L .58661 .37528 L p F P
0 0 0 r
s
.292 .449 .849 r
.42881 .37097 m .43743 .36502 L .4238 .36807 L p F P
0 0 0 r
s
.292 .449 .849 r
.4238 .36807 m .41339 .37528 L .42881 .37097 L p F P
0 0 0 r
s
.542 .135 .052 r
.70186 .4629 m .68881 .45391 L .67536 .43747 L p F P
0 0 0 r
s
.24 .35 .67 r
.6845 .45558 m
.69271 .48292 L
s
.69304 .45072 m
.71754 .43677 L
s
.542 .135 .052 r
.66298 .4289 m .67536 .43747 L .68881 .45391 L p F P
0 0 0 r
s
.024 .035 .067 r
.32464 .43747 m .33702 .4289 L .32443 .44479 L p F P
0 0 0 r
s
.024 .035 .067 r
.32443 .44479 m .31119 .45391 L .32464 .43747 L p F P
0 0 0 r
s
.062 .08 .171 r
.63728 .58835 m .62271 .59592 L .6296 .58026 L p F P
0 0 0 r
s
.062 .08 .171 r
.6296 .58026 m .64505 .57214 L .63728 .58835 L p F P
0 0 0 r
s
.24 .35 .67 r
.6269 .58855 m
.6318 .56786 L
s
.689 .18 .07 r
.35495 .57214 m .3704 .58026 L .37729 .59592 L p F P
0 0 0 r
s
.689 .18 .07 r
.39167 .60339 m .37729 .59592 L .3704 .58026 L p F P
0 0 0 r
s
.411 .13 .062 r
.63529 .4071 m .62375 .39909 L .6071 .38948 L p F P
0 0 0 r
s
.411 .13 .062 r
.59691 .38242 m .6071 .38948 L .62375 .39909 L p F P
0 0 0 r
s
.249 .388 .721 r
.3929 .38948 m .40309 .38242 L .38792 .39099 L p F P
0 0 0 r
s
.249 .388 .721 r
.38792 .39099 m .37625 .39909 L .3929 .38948 L p F P
0 0 0 r
s
.967 .27 .111 r
.30512 .49019 m .28854 .48105 L .29814 .4629 L p F P
0 0 0 r
s
.698 .183 .07 r
.68881 .45391 m .70186 .4629 L .71146 .48105 L p F P
0 0 0 r
s
.043 .059 .127 r
.29814 .4629 m .31119 .45391 L .30213 .47178 L p F P
0 0 0 r
s
.043 .059 .127 r
.30213 .47178 m .28854 .48105 L .29814 .4629 L p F P
0 0 0 r
s
.264 .412 .783 r
.50704 .66444 m .5 .66807 L .5 .67208 L p F P
0 0 0 r
s
.24 .35 .67 r
.50394 .66781 m
.5102 .66547 L
s
.264 .412 .783 r
.5 .67208 m .50896 .66749 L .50704 .66444 L p F P
0 0 0 r
s
.83 .24 .1 r
.50243 .67018 m
.50321 .67048 L
s
.50321 .67048 m
.50758 .6721 L
s
.538 .176 .08 r
.49104 .66749 m .5 .67208 L .5 .66807 L p F P
0 0 0 r
s
.83 .24 .1 r
.4898 .66547 m
.49608 .66782 L
s
.24 .35 .67 r
.49679 .67048 m
.49757 .67018 L
s
.49242 .6721 m
.49679 .67048 L
s
.70552 .40889 m
.69054 .3817 L
s
.69054 .3817 m
.72397 .36158 L
s
.69054 .3817 m
.67311 .35611 L
s
.83 .24 .1 r
.32689 .35611 m
.30946 .3817 L
s
.27603 .36158 m
.30946 .3817 L
s
.30946 .3817 m
.29448 .40889 L
s
.153 .212 .442 r
.71603 .5 m .69906 .50919 L .69488 .49019 L p F P
0 0 0 r
s
.153 .212 .442 r
.69488 .49019 m .71146 .48105 L .71603 .5 L p F P
0 0 0 r
s
.24 .35 .67 r
.69271 .48292 m
.69708 .5091 L
s
.83 .24 .1 r
.70924 .47685 m
.7222 .48571 L
s
.24 .35 .67 r
.69271 .48292 m
.7066 .47522 L
s
.931 .257 .105 r
.28854 .48105 m .30512 .49019 L .30094 .50919 L p F P
0 0 0 r
s
.24 .35 .67 r
.2778 .48571 m
.29076 .47685 L
s
.83 .24 .1 r
.29543 .47635 m
.30729 .48292 L
s
.931 .257 .105 r
.31766 .51823 m .30094 .50919 L .30512 .49019 L p F P
0 0 0 r
s
.83 .24 .1 r
.30292 .5091 m
.30729 .48292 L
s
.024 .035 .067 r
.57656 .63255 m .56526 .63835 L .5737 .62963 L p F P
0 0 0 r
s
.024 .035 .067 r
.5737 .62963 m .58651 .62302 L .57656 .63255 L p F P
0 0 0 r
s
.383 .086 .036 r
.41349 .62302 m .4263 .62963 L .43474 .63835 L p F P
0 0 0 r
s
.383 .086 .036 r
.44591 .64409 m .43474 .63835 L .4263 .62963 L p F P
0 0 0 r
s
.83 .24 .1 r
.41992 .31888 m
.39881 .33409 L
s
.36673 .31322 m
.39881 .33409 L
s
.24 .35 .67 r
.60119 .33409 m
.63327 .31322 L
s
.60119 .33409 m
.58008 .31888 L
s
.742 .231 .102 r
.5451 .35297 m .53624 .34686 L .52758 .35148 L p F P
0 0 0 r
s
.742 .231 .102 r
.52075 .34681 m .52758 .35148 L .53624 .34686 L p F P
0 0 0 r
s
.309 .47 .9 r
.47242 .35148 m .47925 .34681 L .47269 .3407 L p F P
0 0 0 r
s
.309 .47 .9 r
.47269 .3407 m .46376 .34686 L .47242 .35148 L p F P
0 0 0 r
s
.24 .35 .67 r
.2486 .65483 m
.26692 .67982 L
s
.26692 .67982 m
.29388 .66427 L
s
.83 .24 .1 r
.70612 .66427 m
.73308 .67982 L
s
.73308 .67982 m
.7514 .65483 L
s
.24 .35 .67 r
.71754 .43677 m
.70552 .40889 L
s
.70552 .40889 m
.73923 .38916 L
s
.83 .24 .1 r
.26077 .38916 m
.29448 .40889 L
s
.29448 .40889 m
.28246 .43677 L
s
.126 .17 .362 r
.6984 .5283 m .68174 .53717 L .68234 .51823 L p F P
0 0 0 r
s
.126 .17 .362 r
.68234 .51823 m .69906 .50919 L .6984 .5283 L p F P
0 0 0 r
s
.24 .35 .67 r
.66425 .52688 m
.69708 .5091 L
s
.88 .24 .097 r
.30094 .50919 m .31766 .51823 L .31826 .53717 L p F P
0 0 0 r
s
.88 .24 .097 r
.33466 .54591 m .31826 .53717 L .31766 .51823 L p F P
0 0 0 r
s
.029 .04 .077 r
.61263 .60956 m .59949 .61633 L .60833 .60339 L p F P
0 0 0 r
s
.029 .04 .077 r
.60833 .60339 m .62271 .59592 L .61263 .60956 L p F P
0 0 0 r
s
.24 .35 .67 r
.59522 .60509 m
.6269 .58855 L
s
.54 .134 .052 r
.37729 .59592 m .39167 .60339 L .40051 .61633 L p F P
0 0 0 r
s
.54 .134 .052 r
.41349 .62302 m .40051 .61633 L .39167 .60339 L p F P
0 0 0 r
s
.24 .35 .67 r
.2342 .62726 m
.26067 .61089 L
s
.2342 .62726 m
.2486 .65483 L
s
.83 .24 .1 r
.7514 .65483 m
.7658 .62726 L
s
.73933 .61089 m
.7658 .62726 L
s
.36 .08 .033 r
.66298 .4289 m .65042 .4202 L .63529 .4071 L p F P
0 0 0 r
s
.36 .08 .033 r
.62375 .39909 m .63529 .4071 L .65042 .4202 L p F P
0 0 0 r
s
.024 .035 .067 r
.36471 .4071 m .37625 .39909 L .3623 .41139 L p F P
0 0 0 r
s
.24 .35 .67 r
.35539 .4154 m
.36302 .41011 L
s
.024 .035 .067 r
.3623 .41139 m .34958 .4202 L .36471 .4071 L p F P
0 0 0 r
s
.24 .35 .67 r
.67311 .35611 m
.70635 .33556 L
s
.67311 .35611 m
.65381 .33301 L
s
.83 .24 .1 r
.34619 .33301 m
.32689 .35611 L
s
.29365 .33556 m
.32689 .35611 L
s
.549 .179 .082 r
.58661 .37528 m .5762 .36807 L .56257 .36502 L p F P
0 0 0 r
s
.549 .179 .082 r
.55387 .35903 m .56257 .36502 L .5762 .36807 L p F P
0 0 0 r
s
.292 .449 .849 r
.43743 .36502 m .44613 .35903 L .43432 .36077 L p F P
0 0 0 r
s
.292 .449 .849 r
.43432 .36077 m .4238 .36807 L .43743 .36502 L p F P
0 0 0 r
s
.24 .35 .67 r
.4289 .368 m
.44771 .36616 L
s
.31529 .68579 m
.3384 .70234 L
s
.3384 .70234 m
.36649 .68711 L
s
.83 .24 .1 r
.63351 .68711 m
.6616 .70234 L
s
.6616 .70234 m
.68471 .68579 L
s
.024 .035 .067 r
.5456 .64867 m .53632 .65344 L .54304 .64976 L p F P
0 0 0 r
s
.024 .035 .067 r
.54304 .64976 m .55409 .64409 L .5456 .64867 L p F P
0 0 0 r
s
.24 .35 .67 r
.54064 .64983 m
.55457 .63785 L
s
.252 .058 .024 r
.44591 .64409 m .45696 .64976 L .46368 .65344 L p F P
0 0 0 r
s
.252 .058 .024 r
.47289 .65817 m .46368 .65344 L .45696 .64976 L p F P
0 0 0 r
s
.83 .24 .1 r
.44543 .63785 m
.45936 .64983 L
s
.092 .118 .262 r
.67665 .55554 m .66073 .5639 L .66534 .54591 L p F P
0 0 0 r
s
.24 .35 .67 r
.66406 .55074 m
.66425 .52688 L
s
.092 .118 .262 r
.66534 .54591 m .68174 .53717 L .67665 .55554 L p F P
0 0 0 r
s
.804 .216 .086 r
.31826 .53717 m .33466 .54591 L .33927 .5639 L p F P
0 0 0 r
s
.804 .216 .086 r
.35495 .57214 m .33927 .5639 L .33466 .54591 L p F P
0 0 0 r
s
.83 .24 .1 r
.33575 .52688 m
.33594 .55074 L
s
.24 .35 .67 r
.2486 .65483 m
.27533 .63885 L
s
.83 .24 .1 r
.72467 .63885 m
.7514 .65483 L
s
.411 .13 .062 r
.62375 .39909 m .61208 .39099 L .59691 .38242 L p F P
0 0 0 r
s
.411 .13 .062 r
.58661 .37528 m .59691 .38242 L .61208 .39099 L p F P
0 0 0 r
s
.249 .388 .721 r
.40309 .38242 m .41339 .37528 L .39975 .38278 L p F P
0 0 0 r
s
.249 .388 .721 r
.39975 .38278 m .38792 .39099 L .40309 .38242 L p F P
0 0 0 r
s
.264 .412 .783 r
.51414 .66079 m .50704 .66444 L .50896 .66749 L p F P
0 0 0 r
s
.264 .412 .783 r
.50896 .66749 m .51799 .66285 L .51414 .66079 L p F P
0 0 0 r
s
.24 .35 .67 r
.51668 .66214 m
.54064 .64983 L
s
.538 .176 .08 r
.48201 .66285 m .49104 .66749 L .49296 .66444 L p F P
0 0 0 r
s
.83 .24 .1 r
.45936 .64983 m
.48575 .66339 L
s
.538 .176 .08 r
.5 .66807 m .49296 .66444 L .49104 .66749 L p F P
0 0 0 r
s
.742 .231 .102 r
.53624 .34686 m .52731 .3407 L .52075 .34681 L p F P
0 0 0 r
s
.742 .231 .102 r
.51389 .34211 m .52075 .34681 L .52731 .3407 L p F P
0 0 0 r
s
.83 .24 .1 r
.50244 .35012 m
.52275 .34591 L
s
.309 .47 .9 r
.47925 .34681 m .48611 .34211 L .48171 .33448 L p F P
0 0 0 r
s
.83 .24 .1 r
.48325 .33714 m
.48834 .34058 L
s
.309 .47 .9 r
.48171 .33448 m .47269 .3407 L .47925 .34681 L p F P
0 0 0 r
s
.83 .24 .1 r
.47213 .32962 m
.48052 .3353 L
s
.24 .35 .67 r
.47725 .34591 m
.49756 .35012 L
s
.24578 .55339 m
.2725 .53583 L
s
.24578 .55339 m
.25066 .58189 L
s
.83 .24 .1 r
.74934 .58189 m
.75422 .55339 L
s
.7275 .53583 m
.75422 .55339 L
s
.542 .135 .052 r
.68881 .45391 m .67557 .44479 L .66298 .4289 L p F P
0 0 0 r
s
.542 .135 .052 r
.65042 .4202 m .66298 .4289 L .67557 .44479 L p F P
0 0 0 r
s
.024 .035 .067 r
.33702 .4289 m .34958 .4202 L .33786 .43554 L p F P
0 0 0 r
s
.24 .35 .67 r
.34547 .42558 m
.35306 .41779 L
s
.024 .035 .067 r
.33786 .43554 m .32443 .44479 L .33702 .4289 L p F P
0 0 0 r
s
.062 .08 .171 r
.65207 .58067 m .63728 .58835 L .64505 .57214 L p F P
0 0 0 r
s
.062 .08 .171 r
.64505 .57214 m .66073 .5639 L .65207 .58067 L p F P
0 0 0 r
s
.24 .35 .67 r
.6318 .56786 m
.66406 .55074 L
s
.689 .18 .07 r
.33927 .5639 m .35495 .57214 L .36272 .58835 L p F P
0 0 0 r
s
.83 .24 .1 r
.33594 .55074 m
.3682 .56786 L
s
.689 .18 .07 r
.37729 .59592 m .36272 .58835 L .35495 .57214 L p F P
0 0 0 r
s
.83 .24 .1 r
.3731 .58855 m
.40478 .60509 L
s
.3682 .56786 m
.3731 .58855 L
s
.24 .35 .67 r
.72613 .46438 m
.71754 .43677 L
s
.71754 .43677 m
.75159 .41737 L
s
.83 .24 .1 r
.24841 .41737 m
.28246 .43677 L
s
.28246 .43677 m
.27387 .46438 L
s
.698 .183 .07 r
.71146 .48105 m .69787 .47178 L .68881 .45391 L p F P
0 0 0 r
s
.698 .183 .07 r
.67557 .44479 m .68881 .45391 L .69787 .47178 L p F P
0 0 0 r
s
.043 .059 .127 r
.31119 .45391 m .32443 .44479 L .31594 .46236 L p F P
0 0 0 r
s
.043 .059 .127 r
.31594 .46236 m .30213 .47178 L .31119 .45391 L p F P
0 0 0 r
s
.24 .35 .67 r
.36649 .68711 m
.3901 .6983 L
s
.3901 .6983 m
.41911 .68294 L
s
.83 .24 .1 r
.58089 .68294 m
.6099 .6983 L
s
.6099 .6983 m
.63351 .68711 L
s
.549 .179 .082 r
.5762 .36807 m .56568 .36077 L .55387 .35903 L p F P
0 0 0 r
s
.83 .24 .1 r
.55229 .36616 m
.5711 .368 L
s
.549 .179 .082 r
.5451 .35297 m .55387 .35903 L .56568 .36077 L p F P
0 0 0 r
s
.83 .24 .1 r
.52275 .34591 m
.55229 .36616 L
s
.292 .449 .849 r
.44613 .35903 m .4549 .35297 L .44497 .3534 L p F P
0 0 0 r
s
.24 .35 .67 r
.44771 .36616 m
.47725 .34591 L
s
.292 .449 .849 r
.44497 .3534 m .43432 .36077 L .44613 .35903 L p F P
0 0 0 r
s
.024 .035 .067 r
.58798 .62669 m .57656 .63255 L .58651 .62302 L p F P
0 0 0 r
s
.24 .35 .67 r
.55457 .63785 m
.58566 .6218 L
s
.024 .035 .067 r
.58651 .62302 m .59949 .61633 L .58798 .62669 L p F P
0 0 0 r
s
.24 .35 .67 r
.58566 .6218 m
.59522 .60509 L
s
.383 .086 .036 r
.40051 .61633 m .41349 .62302 L .42344 .63255 L p F P
0 0 0 r
s
.83 .24 .1 r
.40478 .60509 m
.41434 .6218 L
s
.383 .086 .036 r
.43474 .63835 m .42344 .63255 L .41349 .62302 L p F P
0 0 0 r
s
.83 .24 .1 r
.41434 .6218 m
.44543 .63785 L
s
.24 .35 .67 r
.65381 .33301 m
.68693 .31198 L
s
.65381 .33301 m
.63327 .31322 L
s
.83 .24 .1 r
.36673 .31322 m
.34619 .33301 L
s
.31307 .31198 m
.34619 .33301 L
s
.742 .231 .102 r
.52731 .3407 m .51829 .33448 L .51389 .34211 L p F P
0 0 0 r
s
.24 .35 .67 r
.51166 .34058 m
.51675 .33714 L
s
.51948 .3353 m
.52787 .32962 L
s
.742 .231 .102 r
.50697 .33737 m .51389 .34211 L .51829 .33448 L p F P
0 0 0 r
s
.309 .47 .9 r
.48611 .34211 m .49303 .33737 L .49081 .3282 L p F P
0 0 0 r
s
.309 .47 .9 r
.49081 .3282 m .48171 .33448 L .48611 .34211 L p F P
0 0 0 r
s
.931 .257 .105 r
.30094 .50919 m .28397 .5 L .28854 .48105 L p F P
0 0 0 r
s
.831 .224 .089 r
.69787 .47178 m .71146 .48105 L .71603 .5 L p F P
0 0 0 r
s
.24 .35 .67 r
.70856 .47413 m
.72613 .46438 L
s
.70762 .47465 m
.70856 .47413 L
s
.08 .105 .237 r
.28854 .48105 m .30213 .47178 L .29783 .49067 L p F P
0 0 0 r
s
.83 .24 .1 r
.27387 .46438 m
.29144 .47413 L
s
.29144 .47413 m
.29238 .47465 L
s
.08 .105 .237 r
.29783 .49067 m .28397 .5 L .28854 .48105 L p F P
0 0 0 r
s
.36 .08 .033 r
.65042 .4202 m .6377 .41139 L .62375 .39909 L p F P
0 0 0 r
s
.36 .08 .033 r
.61208 .39099 m .62375 .39909 L .6377 .41139 L p F P
0 0 0 r
s
.83 .24 .1 r
.61644 .39587 m
.63013 .40536 L
s
.024 .035 .067 r
.37625 .39909 m .38792 .39099 L .37521 .40245 L p F P
0 0 0 r
s
.24 .35 .67 r
.38356 .39587 m
.40007 .38793 L
s
.36644 .40774 m
.37552 .40145 L
s
.37898 .39905 m
.38356 .39587 L
s
.024 .035 .067 r
.37521 .40245 m .3623 .41139 L .37625 .39909 L p F P
0 0 0 r
s
.024 .035 .067 r
.55498 .64386 m .5456 .64867 L .55409 .64409 L p F P
0 0 0 r
s
.024 .035 .067 r
.55409 .64409 m .56526 .63835 L .55498 .64386 L p F P
0 0 0 r
s
.252 .058 .024 r
.43474 .63835 m .44591 .64409 L .4544 .64867 L p F P
0 0 0 r
s
.252 .058 .024 r
.46368 .65344 m .4544 .64867 L .44591 .64409 L p F P
0 0 0 r
s
.24 .35 .67 r
.41911 .68294 m
.44188 .68829 L
s
.44188 .68829 m
.47174 .67275 L
s
.83 .24 .1 r
.52826 .67275 m
.55812 .68829 L
s
.55812 .68829 m
.58089 .68294 L
s
.029 .04 .077 r
.62594 .60269 m .61263 .60956 L .62271 .59592 L p F P
0 0 0 r
s
.029 .04 .077 r
.62271 .59592 m .63728 .58835 L .62594 .60269 L p F P
0 0 0 r
s
.54 .134 .052 r
.36272 .58835 m .37729 .59592 L .38737 .60956 L p F P
0 0 0 r
s
.54 .134 .052 r
.40051 .61633 m .38737 .60956 L .37729 .59592 L p F P
0 0 0 r
s
.24 .35 .67 r
.47174 .67275 m
.49242 .6721 L
s
.49242 .6721 m
.49851 .66897 L
s
.83 .24 .1 r
.50149 .66897 m
.50758 .6721 L
s
.50758 .6721 m
.52826 .67275 L
s
.264 .412 .783 r
.52128 .6571 m .51414 .66079 L .51799 .66285 L p F P
0 0 0 r
s
.264 .412 .783 r
.51799 .66285 m .52711 .65817 L .52128 .6571 L p F P
0 0 0 r
s
.538 .176 .08 r
.47289 .65817 m .48201 .66285 L .48586 .66079 L p F P
0 0 0 r
s
.538 .176 .08 r
.49296 .66444 m .48586 .66079 L .48201 .66285 L p F P
0 0 0 r
s
.411 .13 .062 r
.61208 .39099 m .60025 .38278 L .58661 .37528 L p F P
0 0 0 r
s
.83 .24 .1 r
.59993 .38793 m
.61644 .39587 L
s
.411 .13 .062 r
.5762 .36807 m .58661 .37528 L .60025 .38278 L p F P
0 0 0 r
s
.83 .24 .1 r
.5711 .368 m
.59993 .38793 L
s
.249 .388 .721 r
.41339 .37528 m .4238 .36807 L .41172 .37447 L p F P
0 0 0 r
s
.249 .388 .721 r
.41172 .37447 m .39975 .38278 L .41339 .37528 L p F P
0 0 0 r
s
.24 .35 .67 r
.40007 .38793 m
.4289 .368 L
s
.126 .17 .362 r
.71532 .51929 m .6984 .5283 L .69906 .50919 L p F P
0 0 0 r
s
.126 .17 .362 r
.69906 .50919 m .71603 .5 L .71532 .51929 L p F P
0 0 0 r
s
.88 .24 .097 r
.28397 .5 m .30094 .50919 L .3016 .5283 L p F P
0 0 0 r
s
.88 .24 .097 r
.31826 .53717 m .3016 .5283 L .30094 .50919 L p F P
0 0 0 r
s
.83 .24 .1 r
.30292 .5091 m
.33575 .52688 L
s
.71598 .50142 m
.7274 .5091 L
s
.24 .35 .67 r
.2726 .5091 m
.2846 .50102 L
s
.2726 .5091 m
.2725 .53583 L
s
.83 .24 .1 r
.7275 .53583 m
.7274 .5091 L
s
.44088 .30849 m
.47213 .32962 L
s
.24 .35 .67 r
.52787 .32962 m
.55912 .30849 L
s
.092 .118 .262 r
.6928 .54706 m .67665 .55554 L .68174 .53717 L p F P
0 0 0 r
s
.092 .118 .262 r
.68174 .53717 m .6984 .5283 L .6928 .54706 L p F P
0 0 0 r
s
.804 .216 .086 r
.3016 .5283 m .31826 .53717 L .32335 .55554 L p F P
0 0 0 r
s
.804 .216 .086 r
.33927 .5639 m .32335 .55554 L .31826 .53717 L p F P
0 0 0 r
s
.24 .35 .67 r
.29388 .66427 m
.31529 .68579 L
s
.31529 .68579 m
.34326 .67017 L
s
.83 .24 .1 r
.65674 .67017 m
.68471 .68579 L
s
.68471 .68579 m
.70612 .66427 L
s
.549 .179 .082 r
.56568 .36077 m .55503 .3534 L .5451 .35297 L p F P
0 0 0 r
s
.549 .179 .082 r
.53624 .34686 m .5451 .35297 L .55503 .3534 L p F P
0 0 0 r
s
.292 .449 .849 r
.4549 .35297 m .46376 .34686 L .45573 .34594 L p F P
0 0 0 r
s
.292 .449 .849 r
.45573 .34594 m .44497 .3534 L .4549 .35297 L p F P
0 0 0 r
s
.742 .231 .102 r
.51829 .33448 m .50919 .3282 L .50697 .33737 L p F P
0 0 0 r
s
.742 .231 .102 r
.5 .3326 m .50697 .33737 L .50919 .3282 L p F P
0 0 0 r
s
.309 .47 .9 r
.49303 .33737 m .5 .3326 L .5 .32187 L p F P
0 0 0 r
s
.309 .47 .9 r
.5 .32187 m .49081 .3282 L .49303 .33737 L p F P
0 0 0 r
s
.83 .24 .1 r
.4923 .32504 m
.49385 .3261 L
s
.542 .135 .052 r
.67557 .44479 m .66214 .43554 L .65042 .4202 L p F P
0 0 0 r
s
.83 .24 .1 r
.64694 .41779 m
.65453 .42558 L
s
.542 .135 .052 r
.6377 .41139 m .65042 .4202 L .66214 .43554 L p F P
0 0 0 r
s
.024 .035 .067 r
.34958 .4202 m .3623 .41139 L .3515 .42615 L p F P
0 0 0 r
s
.024 .035 .067 r
.3515 .42615 m .33786 .43554 L .34958 .4202 L p F P
0 0 0 r
s
.83 .24 .1 r
.44088 .30849 m
.41992 .31888 L
s
.3878 .29754 m
.41992 .31888 L
s
.24 .35 .67 r
.58008 .31888 m
.6122 .29754 L
s
.58008 .31888 m
.55912 .30849 L
s
.25066 .58189 m
.27767 .56463 L
s
.25066 .58189 m
.26067 .61089 L
s
.83 .24 .1 r
.73933 .61089 m
.74934 .58189 L
s
.72233 .56463 m
.74934 .58189 L
s
.062 .08 .171 r
.66705 .57288 m .65207 .58067 L .66073 .5639 L p F P
0 0 0 r
s
.062 .08 .171 r
.66073 .5639 m .67665 .55554 L .66705 .57288 L p F P
0 0 0 r
s
.24 .35 .67 r
.65957 .5715 m
.66406 .55074 L
s
.689 .18 .07 r
.32335 .55554 m .33927 .5639 L .34793 .58067 L p F P
0 0 0 r
s
.689 .18 .07 r
.36272 .58835 m .34793 .58067 L .33927 .5639 L p F P
0 0 0 r
s
.024 .035 .067 r
.59953 .62076 m .58798 .62669 L .59949 .61633 L p F P
0 0 0 r
s
.024 .035 .067 r
.59949 .61633 m .61263 .60956 L .59953 .62076 L p F P
0 0 0 r
s
.383 .086 .036 r
.38737 .60956 m .40051 .61633 L .41202 .62669 L p F P
0 0 0 r
s
.383 .086 .036 r
.42344 .63255 m .41202 .62669 L .40051 .61633 L p F P
0 0 0 r
s
.264 .412 .783 r
.52848 .6534 m .52128 .6571 L .52711 .65817 L p F P
0 0 0 r
s
.264 .412 .783 r
.52711 .65817 m .53632 .65344 L .52848 .6534 L p F P
0 0 0 r
s
.24 .35 .67 r
.53093 .65341 m
.54064 .64983 L
s
.538 .176 .08 r
.46368 .65344 m .47289 .65817 L .47872 .6571 L p F P
0 0 0 r
s
.538 .176 .08 r
.48586 .66079 m .47872 .6571 L .47289 .65817 L p F P
0 0 0 r
s
.024 .035 .067 r
.56444 .63901 m .55498 .64386 L .56526 .63835 L p F P
0 0 0 r
s
.024 .035 .067 r
.56526 .63835 m .57656 .63255 L .56444 .63901 L p F P
0 0 0 r
s
.252 .058 .024 r
.42344 .63255 m .43474 .63835 L .44502 .64386 L p F P
0 0 0 r
s
.252 .058 .024 r
.4544 .64867 m .44502 .64386 L .43474 .63835 L p F P
0 0 0 r
s
.698 .183 .07 r
.69787 .47178 m .68406 .46236 L .67557 .44479 L p F P
0 0 0 r
s
.698 .183 .07 r
.66214 .43554 m .67557 .44479 L .68406 .46236 L p F P
0 0 0 r
s
.043 .059 .127 r
.32443 .44479 m .33786 .43554 L .32997 .45279 L p F P
0 0 0 r
s
.043 .059 .127 r
.32997 .45279 m .31594 .46236 L .32443 .44479 L p F P
0 0 0 r
s
.24 .35 .67 r
.73093 .49076 m
.72613 .46438 L
s
.72613 .46438 m
.76059 .44527 L
s
.83 .24 .1 r
.23941 .44527 m
.27387 .46438 L
s
.27387 .46438 m
.26907 .49076 L
s
.36 .08 .033 r
.6377 .41139 m .62479 .40245 L .61208 .39099 L p F P
0 0 0 r
s
.36 .08 .033 r
.60025 .38278 m .61208 .39099 L .62479 .40245 L p F P
0 0 0 r
s
.024 .035 .067 r
.38792 .39099 m .39975 .38278 L .38829 .39338 L p F P
0 0 0 r
s
.24 .35 .67 r
.38356 .39587 m
.38818 .39267 L
s
.024 .035 .067 r
.38829 .39338 m .37521 .40245 L .38792 .39099 L p F P
0 0 0 r
s
.411 .13 .062 r
.60025 .38278 m .58828 .37447 L .5762 .36807 L p F P
0 0 0 r
s
.411 .13 .062 r
.56568 .36077 m .5762 .36807 L .58828 .37447 L p F P
0 0 0 r
s
.249 .388 .721 r
.4238 .36807 m .43432 .36077 L .42385 .36605 L p F P
0 0 0 r
s
.249 .388 .721 r
.42385 .36605 m .41172 .37447 L .4238 .36807 L p F P
0 0 0 r
s
.24 .35 .67 r
.41261 .37574 m
.4289 .368 L
s
.742 .231 .102 r
.50919 .3282 m .5 .32187 L .5 .3326 L p F P
0 0 0 r
s
.24 .35 .67 r
.50615 .3261 m
.5077 .32504 L
s
.73923 .38916 m
.72397 .36158 L
s
.72397 .36158 m
.75845 .34083 L
s
.72397 .36158 m
.70635 .33556 L
s
.83 .24 .1 r
.29365 .33556 m
.27603 .36158 L
s
.24155 .34083 m
.27603 .36158 L
s
.27603 .36158 m
.26077 .38916 L
s
.029 .04 .077 r
.63942 .59574 m .62594 .60269 L .63728 .58835 L p F P
0 0 0 r
s
.029 .04 .077 r
.63728 .58835 m .65207 .58067 L .63942 .59574 L p F P
0 0 0 r
s
.24 .35 .67 r
.6269 .58855 m
.65957 .5715 L
s
.54 .134 .052 r
.34793 .58067 m .36272 .58835 L .37406 .60269 L p F P
0 0 0 r
s
.54 .134 .052 r
.38737 .60956 m .37406 .60269 L .36272 .58835 L p F P
0 0 0 r
s
.831 .224 .089 r
.71603 .5 m .70217 .49067 L .69787 .47178 L p F P
0 0 0 r
s
.831 .224 .089 r
.68406 .46236 m .69787 .47178 L .70217 .49067 L p F P
0 0 0 r
s
.08 .105 .237 r
.30213 .47178 m .31594 .46236 L .3119 .48119 L p F P
0 0 0 r
s
.08 .105 .237 r
.3119 .48119 m .29783 .49067 L .30213 .47178 L p F P
0 0 0 r
s
.24 .35 .67 r
.29986 .49076 m
.30022 .48906 L
s
.549 .179 .082 r
.55503 .3534 m .54427 .34594 L .53624 .34686 L p F P
0 0 0 r
s
.549 .179 .082 r
.52731 .3407 m .53624 .34686 L .54427 .34594 L p F P
0 0 0 r
s
.292 .449 .849 r
.46376 .34686 m .47269 .3407 L .46661 .3384 L p F P
0 0 0 r
s
.292 .449 .849 r
.46661 .3384 m .45573 .34594 L .46376 .34686 L p F P
0 0 0 r
s
.24 .35 .67 r
.45863 .34746 m
.47725 .34591 L
s
.83 .24 .1 r
.3878 .29754 m
.36673 .31322 L
s
.33364 .2917 m
.36673 .31322 L
s
.24 .35 .67 r
.63327 .31322 m
.66636 .2917 L
s
.63327 .31322 m
.6122 .29754 L
s
.27533 .63885 m
.29388 .66427 L
s
.29388 .66427 m
.32167 .64822 L
s
.83 .24 .1 r
.67833 .64822 m
.70612 .66427 L
s
.70612 .66427 m
.72467 .63885 L
s
.24 .35 .67 r
.75159 .41737 m
.73923 .38916 L
s
.73923 .38916 m
.77399 .36881 L
s
.83 .24 .1 r
.22601 .36881 m
.26077 .38916 L
s
.26077 .38916 m
.24841 .41737 L
s
.88 .24 .097 r
.3016 .5283 m .28468 .51929 L .28397 .5 L p F P
0 0 0 r
s
.916 .251 .101 r
.70217 .49067 m .71603 .5 L .71532 .51929 L p F P
0 0 0 r
s
.24 .35 .67 r
.71507 .49935 m
.73093 .49076 L
s
.69708 .5091 m
.70794 .50322 L
s
.83 .24 .1 r
.70014 .49076 m
.70315 .49279 L
s
.116 .157 .342 r
.28397 .5 m .29783 .49067 L .2985 .51014 L p F P
0 0 0 r
s
.24 .35 .67 r
.29787 .4921 m
.29986 .49076 L
s
.83 .24 .1 r
.29838 .50664 m
.30292 .5091 L
s
.26907 .49076 m
.28493 .49935 L
s
.116 .157 .342 r
.2985 .51014 m .28468 .51929 L .28397 .5 L p F P
0 0 0 r
s
.24 .35 .67 r
.26067 .61089 m
.28796 .594 L
s
.26067 .61089 m
.27533 .63885 L
s
.83 .24 .1 r
.72467 .63885 m
.73933 .61089 L
s
.71204 .594 m
.73933 .61089 L
s
.24 .35 .67 r
.70635 .33556 m
.74062 .31435 L
s
.70635 .33556 m
.68693 .31198 L
s
.83 .24 .1 r
.31307 .31198 m
.29365 .33556 L
s
.25938 .31435 m
.29365 .33556 L
s
.24 .35 .67 r
.34326 .67017 m
.36649 .68711 L
s
.36649 .68711 m
.39546 .6714 L
s
.83 .24 .1 r
.60454 .6714 m
.63351 .68711 L
s
.63351 .68711 m
.65674 .67017 L
s
.264 .412 .783 r
.53573 .64966 m .52848 .6534 L .53632 .65344 L p F P
0 0 0 r
s
.264 .412 .783 r
.53632 .65344 m .5456 .64867 L .53573 .64966 L p F P
0 0 0 r
s
.538 .176 .08 r
.4544 .64867 m .46368 .65344 L .47152 .6534 L p F P
0 0 0 r
s
.83 .24 .1 r
.45936 .64983 m
.46167 .65068 L
s
.538 .176 .08 r
.47872 .6571 m .47152 .6534 L .46368 .65344 L p F P
0 0 0 r
s
.092 .118 .262 r
.70919 .53845 m .6928 .54706 L .6984 .5283 L p F P
0 0 0 r
s
.24 .35 .67 r
.69708 .5091 m
.69732 .5331 L
s
.092 .118 .262 r
.6984 .5283 m .71532 .51929 L .70919 .53845 L p F P
0 0 0 r
s
.804 .216 .086 r
.28468 .51929 m .3016 .5283 L .3072 .54706 L p F P
0 0 0 r
s
.804 .216 .086 r
.32335 .55554 m .3072 .54706 L .3016 .5283 L p F P
0 0 0 r
s
.83 .24 .1 r
.30268 .5331 m
.30292 .5091 L
s
.542 .135 .052 r
.66214 .43554 m .6485 .42615 L .6377 .41139 L p F P
0 0 0 r
s
.542 .135 .052 r
.62479 .40245 m .6377 .41139 L .6485 .42615 L p F P
0 0 0 r
s
.024 .035 .067 r
.3623 .41139 m .37521 .40245 L .36534 .41661 L p F P
0 0 0 r
s
.024 .035 .067 r
.36534 .41661 m .3515 .42615 L .3623 .41139 L p F P
0 0 0 r
s
.24 .35 .67 r
.27533 .63885 m
.30289 .62238 L
s
.83 .24 .1 r
.69711 .62238 m
.72467 .63885 L
s
.292 .449 .863 r
.50488 .65714 m .5 .65968 L .5 .66807 L p F P
0 0 0 r
s
.292 .449 .863 r
.5 .66807 m .50704 .66444 L .50488 .65714 L p F P
0 0 0 r
s
.742 .233 .103 r
.49296 .66444 m .5 .66807 L .5 .65968 L p F P
0 0 0 r
s
.024 .035 .067 r
.57399 .63411 m .56444 .63901 L .57656 .63255 L p F P
0 0 0 r
s
.024 .035 .067 r
.57656 .63255 m .58798 .62669 L .57399 .63411 L p F P
0 0 0 r
s
.24 .35 .67 r
.57202 .6337 m
.58566 .6218 L
s
.252 .058 .024 r
.41202 .62669 m .42344 .63255 L .43556 .63901 L p F P
0 0 0 r
s
.252 .058 .024 r
.44502 .64386 m .43556 .63901 L .42344 .63255 L p F P
0 0 0 r
s
.83 .24 .1 r
.41434 .6218 m
.42798 .6337 L
s
.024 .035 .067 r
.61121 .61476 m .59953 .62076 L .61263 .60956 L p F P
0 0 0 r
s
.024 .035 .067 r
.61263 .60956 m .62594 .60269 L .61121 .61476 L p F P
0 0 0 r
s
.24 .35 .67 r
.58566 .6218 m
.6177 .60526 L
s
.6177 .60526 m
.6269 .58855 L
s
.383 .086 .036 r
.37406 .60269 m .38737 .60956 L .40047 .62076 L p F P
0 0 0 r
s
.83 .24 .1 r
.3731 .58855 m
.3823 .60526 L
s
.383 .086 .036 r
.41202 .62669 m .40047 .62076 L .38737 .60956 L p F P
0 0 0 r
s
.83 .24 .1 r
.3823 .60526 m
.41434 .6218 L
s
.24 .35 .67 r
.2725 .53583 m
.27767 .56463 L
s
.83 .24 .1 r
.72233 .56463 m
.7275 .53583 L
s
.062 .08 .171 r
.68225 .56498 m .66705 .57288 L .67665 .55554 L p F P
0 0 0 r
s
.062 .08 .171 r
.67665 .55554 m .6928 .54706 L .68225 .56498 L p F P
0 0 0 r
s
.24 .35 .67 r
.66406 .55074 m
.69732 .5331 L
s
.689 .18 .07 r
.3072 .54706 m .32335 .55554 L .33295 .57288 L p F P
0 0 0 r
s
.83 .24 .1 r
.30268 .5331 m
.33594 .55074 L
s
.689 .18 .07 r
.34793 .58067 m .33295 .57288 L .32335 .55554 L p F P
0 0 0 r
s
.83 .24 .1 r
.34043 .5715 m
.3731 .58855 L
s
.33594 .55074 m
.34043 .5715 L
s
.411 .13 .062 r
.58828 .37447 m .57615 .36605 L .56568 .36077 L p F P
0 0 0 r
s
.83 .24 .1 r
.5711 .368 m
.58739 .37574 L
s
.411 .13 .062 r
.55503 .3534 m .56568 .36077 L .57615 .36605 L p F P
0 0 0 r
s
.249 .388 .721 r
.43432 .36077 m .44497 .3534 L .43613 .35752 L p F P
0 0 0 r
s
.249 .388 .721 r
.43613 .35752 m .42385 .36605 L .43432 .36077 L p F P
0 0 0 r
s
.549 .179 .082 r
.54427 .34594 m .53339 .3384 L .52731 .3407 L p F P
0 0 0 r
s
.83 .24 .1 r
.52275 .34591 m
.54137 .34746 L
s
.549 .179 .082 r
.51829 .33448 m .52731 .3407 L .53339 .3384 L p F P
0 0 0 r
s
.83 .24 .1 r
.49849 .32928 m
.52275 .34591 L
s
.292 .449 .849 r
.47269 .3407 m .48171 .33448 L .47761 .33077 L p F P
0 0 0 r
s
.292 .449 .849 r
.47761 .33077 m .46661 .3384 L .47269 .3407 L p F P
0 0 0 r
s
.24 .35 .67 r
.47725 .34591 m
.50151 .32928 L
s
.36 .08 .033 r
.62479 .40245 m .61171 .39338 L .60025 .38278 L p F P
0 0 0 r
s
.36 .08 .033 r
.58828 .37447 m .60025 .38278 L .61171 .39338 L p F P
0 0 0 r
s
.83 .24 .1 r
.58739 .37574 m
.60478 .38779 L
s
.024 .035 .067 r
.39975 .38278 m .41172 .37447 L .40156 .38419 L p F P
0 0 0 r
s
.24 .35 .67 r
.40458 .3813 m
.41261 .37574 L
s
.024 .035 .067 r
.40156 .38419 m .38829 .39338 L .39975 .38278 L p F P
0 0 0 r
s
.698 .183 .07 r
.68406 .46236 m .67003 .45279 L .66214 .43554 L p F P
0 0 0 r
s
.698 .183 .07 r
.6485 .42615 m .66214 .43554 L .67003 .45279 L p F P
0 0 0 r
s
.043 .059 .127 r
.33786 .43554 m .3515 .42615 L .34421 .44307 L p F P
0 0 0 r
s
.043 .059 .127 r
.34421 .44307 m .32997 .45279 L .33786 .43554 L p F P
0 0 0 r
s
.24 .35 .67 r
.76059 .44527 m
.75159 .41737 L
s
.75159 .41737 m
.78672 .39737 L
s
.83 .24 .1 r
.21328 .39737 m
.24841 .41737 L
s
.24841 .41737 m
.23941 .44527 L
s
.24 .35 .67 r
.39546 .6714 m
.41911 .68294 L
s
.41911 .68294 m
.44903 .6671 L
s
.83 .24 .1 r
.55097 .6671 m
.58089 .68294 L
s
.58089 .68294 m
.60454 .6714 L
s
.029 .04 .077 r
.65308 .58871 m .63942 .59574 L .65207 .58067 L p F P
0 0 0 r
s
.029 .04 .077 r
.65207 .58067 m .66705 .57288 L .65308 .58871 L p F P
0 0 0 r
s
.54 .134 .052 r
.33295 .57288 m .34793 .58067 L .36058 .59574 L p F P
0 0 0 r
s
.54 .134 .052 r
.37406 .60269 m .36058 .59574 L .34793 .58067 L p F P
0 0 0 r
s
.292 .449 .863 r
.50979 .65459 m .50488 .65714 L .50704 .66444 L p F P
0 0 0 r
s
.292 .449 .863 r
.50704 .66444 m .51414 .66079 L .50979 .65459 L p F P
0 0 0 r
s
.742 .233 .103 r
.48586 .66079 m .49296 .66444 L .49512 .65714 L p F P
0 0 0 r
s
.742 .233 .103 r
.5 .65968 m .49512 .65714 L .49296 .66444 L p F P
0 0 0 r
s
.264 .412 .783 r
.54303 .6459 m .53573 .64966 L .5456 .64867 L p F P
0 0 0 r
s
.264 .412 .783 r
.5456 .64867 m .55498 .64386 L .54303 .6459 L p F P
0 0 0 r
s
.24 .35 .67 r
.55089 .64456 m
.57202 .6337 L
s
.538 .176 .08 r
.44502 .64386 m .4544 .64867 L .46427 .64966 L p F P
0 0 0 r
s
.83 .24 .1 r
.42798 .6337 m
.45163 .64585 L
s
.45777 .64901 m
.45936 .64983 L
s
.538 .176 .08 r
.47152 .6534 m .46427 .64966 L .4544 .64867 L p F P
0 0 0 r
s
.24 .35 .67 r
.68693 .31198 m
.72109 .29029 L
s
.68693 .31198 m
.66636 .2917 L
s
.83 .24 .1 r
.33364 .2917 m
.31307 .31198 L
s
.27891 .29029 m
.31307 .31198 L
s
.831 .224 .089 r
.70217 .49067 m .6881 .48119 L .68406 .46236 L p F P
0 0 0 r
s
.83 .24 .1 r
.69978 .48906 m
.70014 .49076 L
s
.831 .224 .089 r
.67003 .45279 m .68406 .46236 L .6881 .48119 L p F P
0 0 0 r
s
.08 .105 .237 r
.31594 .46236 m .32997 .45279 L .32621 .47156 L p F P
0 0 0 r
s
.08 .105 .237 r
.32621 .47156 m .3119 .48119 L .31594 .46236 L p F P
0 0 0 r
s
.24 .35 .67 r
.44903 .6671 m
.47174 .67275 L
s
.47174 .67275 m
.49279 .6618 L
s
.83 .24 .1 r
.50721 .6618 m
.52826 .67275 L
s
.50287 .65954 m
.50721 .6618 L
s
.52826 .67275 m
.55097 .6671 L
s
.24 .35 .67 r
.76584 .47185 m
.73093 .49076 L
s
.73162 .5149 m
.73093 .49076 L
s
.83 .24 .1 r
.23416 .47185 m
.26907 .49076 L
s
.26907 .49076 m
.26838 .5149 L
s
.916 .251 .101 r
.71532 .51929 m .7015 .51014 L .70217 .49067 L p F P
0 0 0 r
s
.916 .251 .101 r
.6881 .48119 m .70217 .49067 L .7015 .51014 L p F P
0 0 0 r
s
.116 .157 .342 r
.29783 .49067 m .3119 .48119 L .31254 .50085 L p F P
0 0 0 r
s
.116 .157 .342 r
.31254 .50085 m .2985 .51014 L .29783 .49067 L p F P
0 0 0 r
s
.024 .035 .067 r
.58363 .62916 m .57399 .63411 L .58798 .62669 L p F P
0 0 0 r
s
.024 .035 .067 r
.58798 .62669 m .59953 .62076 L .58363 .62916 L p F P
0 0 0 r
s
.252 .058 .024 r
.40047 .62076 m .41202 .62669 L .42601 .63411 L p F P
0 0 0 r
s
.252 .058 .024 r
.43556 .63901 m .42601 .63411 L .41202 .62669 L p F P
0 0 0 r
s
.549 .179 .082 r
.53339 .3384 m .52239 .33077 L .51829 .33448 L p F P
0 0 0 r
s
.549 .179 .082 r
.50919 .3282 m .51829 .33448 L .52239 .33077 L p F P
0 0 0 r
s
.24 .35 .67 r
.5077 .32504 m
.52787 .32962 L
s
.292 .449 .849 r
.48171 .33448 m .49081 .3282 L .48874 .32305 L p F P
0 0 0 r
s
.83 .24 .1 r
.47213 .32962 m
.48675 .3263 L
s
.48977 .32561 m
.4923 .32504 L
s
.292 .449 .849 r
.48874 .32305 m .47761 .33077 L .48171 .33448 L p F P
0 0 0 r
s
.83 .24 .1 r
.4923 .32504 m
.49513 .32523 L
s
.24 .35 .67 r
.50487 .32523 m
.5077 .32504 L
s
.542 .135 .052 r
.6485 .42615 m .63466 .41661 L .62479 .40245 L p F P
0 0 0 r
s
.542 .135 .052 r
.61171 .39338 m .62479 .40245 L .63466 .41661 L p F P
0 0 0 r
s
.024 .035 .067 r
.37521 .40245 m .38829 .39338 L .37939 .40693 L p F P
0 0 0 r
s
.024 .035 .067 r
.37939 .40693 m .36534 .41661 L .37521 .40245 L p F P
0 0 0 r
s
.83 .24 .1 r
.46088 .3035 m
.44088 .30849 L
s
.40865 .28669 m
.44088 .30849 L
s
.24 .35 .67 r
.55912 .30849 m
.59135 .28669 L
s
.55912 .30849 m
.53912 .3035 L
s
.411 .13 .062 r
.57615 .36605 m .56387 .35752 L .55503 .3534 L p F P
0 0 0 r
s
.411 .13 .062 r
.54427 .34594 m .55503 .3534 L .56387 .35752 L p F P
0 0 0 r
s
.83 .24 .1 r
.54137 .34746 m
.5711 .368 L
s
.249 .388 .721 r
.44497 .3534 m .45573 .34594 L .44857 .34889 L p F P
0 0 0 r
s
.249 .388 .721 r
.44857 .34889 m .43613 .35752 L .44497 .3534 L p F P
0 0 0 r
s
.24 .35 .67 r
.4289 .368 m
.45863 .34746 L
s
.024 .035 .067 r
.62302 .6087 m .61121 .61476 L .62594 .60269 L p F P
0 0 0 r
s
.024 .035 .067 r
.62594 .60269 m .63942 .59574 L .62302 .6087 L p F P
0 0 0 r
s
.383 .086 .036 r
.36058 .59574 m .37406 .60269 L .38879 .61476 L p F P
0 0 0 r
s
.383 .086 .036 r
.40047 .62076 m .38879 .61476 L .37406 .60269 L p F P
0 0 0 r
s
.804 .216 .086 r
.3072 .54706 m .29081 .53845 L .28468 .51929 L p F P
0 0 0 r
s
.971 .27 .11 r
.7015 .51014 m .71532 .51929 L .70919 .53845 L p F P
0 0 0 r
s
.24 .35 .67 r
.71358 .52447 m
.73162 .5149 L
s
.71262 .52498 m
.71358 .52447 L
s
.69732 .5331 m
.70642 .52826 L
s
.83 .24 .1 r
.71322 .52645 m
.7275 .53583 L
s
.71306 .52634 m
.71322 .52645 L
s
.148 .206 .436 r
.28468 .51929 m .2985 .51014 L .30428 .52971 L p F P
0 0 0 r
s
.148 .206 .436 r
.30428 .52971 m .29081 .53845 L .28468 .51929 L p F P
0 0 0 r
s
.83 .24 .1 r
.30069 .53204 m
.30268 .5331 L
s
.28642 .52447 m
.28738 .52498 L
s
.26838 .5149 m
.28642 .52447 L
s
.24 .35 .67 r
.2725 .53583 m
.28678 .52645 L
s
.28678 .52645 m
.28694 .52634 L
s
.292 .449 .863 r
.51472 .65203 m .50979 .65459 L .51414 .66079 L p F P
0 0 0 r
s
.292 .449 .863 r
.51414 .66079 m .52128 .6571 L .51472 .65203 L p F P
0 0 0 r
s
.24 .35 .67 r
.52033 .65636 m
.52282 .65631 L
s
.742 .233 .103 r
.47872 .6571 m .48586 .66079 L .49021 .65459 L p F P
0 0 0 r
s
.83 .24 .1 r
.47718 .65631 m
.4819 .65641 L
s
.742 .233 .103 r
.49512 .65714 m .49021 .65459 L .48586 .66079 L p F P
0 0 0 r
s
.24 .35 .67 r
.49279 .6618 m
.49713 .65954 L
s
.32167 .64822 m
.34326 .67017 L
s
.34326 .67017 m
.37212 .65406 L
s
.83 .24 .1 r
.62788 .65406 m
.65674 .67017 L
s
.65674 .67017 m
.67833 .64822 L
s
.36 .08 .033 r
.61171 .39338 m .59844 .38419 L .58828 .37447 L p F P
0 0 0 r
s
.36 .08 .033 r
.57615 .36605 m .58828 .37447 L .59844 .38419 L p F P
0 0 0 r
s
.024 .035 .067 r
.41172 .37447 m .42385 .36605 L .41502 .37487 L p F P
0 0 0 r
s
.024 .035 .067 r
.41502 .37487 m .40156 .38419 L .41172 .37447 L p F P
0 0 0 r
s
.264 .412 .783 r
.55039 .64211 m .54303 .6459 L .55498 .64386 L p F P
0 0 0 r
s
.264 .412 .783 r
.55498 .64386 m .56444 .63901 L .55039 .64211 L p F P
0 0 0 r
s
.538 .176 .08 r
.43556 .63901 m .44502 .64386 L .45697 .6459 L p F P
0 0 0 r
s
.538 .176 .08 r
.46427 .64966 m .45697 .6459 L .44502 .64386 L p F P
0 0 0 r
s
.83 .24 .1 r
.40865 .28669 m
.3878 .29754 L
s
.35467 .27553 m
.3878 .29754 L
s
.24 .35 .67 r
.6122 .29754 m
.64533 .27553 L
s
.6122 .29754 m
.59135 .28669 L
s
.062 .08 .171 r
.69767 .55697 m .68225 .56498 L .6928 .54706 L p F P
0 0 0 r
s
.062 .08 .171 r
.6928 .54706 m .70919 .53845 L .69767 .55697 L p F P
0 0 0 r
s
.689 .18 .07 r
.29081 .53845 m .3072 .54706 L .31775 .56498 L p F P
0 0 0 r
s
.689 .18 .07 r
.33295 .57288 m .31775 .56498 L .3072 .54706 L p F P
0 0 0 r
s
.24 .35 .67 r
.27767 .56463 m
.28796 .594 L
s
.83 .24 .1 r
.71204 .594 m
.72233 .56463 L
s
.698 .183 .07 r
.67003 .45279 m .65579 .44307 L .6485 .42615 L p F P
0 0 0 r
s
.698 .183 .07 r
.63466 .41661 m .6485 .42615 L .65579 .44307 L p F P
0 0 0 r
s
.043 .059 .127 r
.3515 .42615 m .36534 .41661 L .35868 .4332 L p F P
0 0 0 r
s
.043 .059 .127 r
.35868 .4332 m .34421 .44307 L .3515 .42615 L p F P
0 0 0 r
s
.029 .04 .077 r
.6669 .58158 m .65308 .58871 L .66705 .57288 L p F P
0 0 0 r
s
.24 .35 .67 r
.65075 .58819 m
.65957 .5715 L
s
.029 .04 .077 r
.66705 .57288 m .68225 .56498 L .6669 .58158 L p F P
0 0 0 r
s
.54 .134 .052 r
.31775 .56498 m .33295 .57288 L .34692 .58871 L p F P
0 0 0 r
s
.54 .134 .052 r
.36058 .59574 m .34692 .58871 L .33295 .57288 L p F P
0 0 0 r
s
.24 .35 .67 r
.76584 .47185 m
.76059 .44527 L
s
.76059 .44527 m
.79615 .42555 L
s
.83 .24 .1 r
.20385 .42555 m
.23941 .44527 L
s
.23941 .44527 m
.23416 .47185 L
s
.292 .449 .863 r
.51968 .64945 m .51472 .65203 L .52128 .6571 L p F P
0 0 0 r
s
.292 .449 .863 r
.52128 .6571 m .52848 .6534 L .51968 .64945 L p F P
0 0 0 r
s
.742 .233 .103 r
.47152 .6534 m .47872 .6571 L .48528 .65203 L p F P
0 0 0 r
s
.742 .233 .103 r
.49021 .65459 m .48528 .65203 L .47872 .6571 L p F P
0 0 0 r
s
.549 .179 .082 r
.52239 .33077 m .51126 .32305 L .50919 .3282 L p F P
0 0 0 r
s
.549 .179 .082 r
.5 .32187 m .50919 .3282 L .51126 .32305 L p F P
0 0 0 r
s
.292 .449 .849 r
.49081 .3282 m .5 .32187 L .5 .31525 L p F P
0 0 0 r
s
.292 .449 .849 r
.5 .31525 m .48874 .32305 L .49081 .3282 L p F P
0 0 0 r
s
.83 .24 .1 r
.46088 .3035 m
.48907 .32283 L
s
.49751 .32538 m
.51071 .32626 L
s
.24 .35 .67 r
.48929 .32626 m
.50249 .32538 L
s
.024 .035 .067 r
.59335 .62416 m .58363 .62916 L .59953 .62076 L p F P
0 0 0 r
s
.024 .035 .067 r
.59953 .62076 m .61121 .61476 L .59335 .62416 L p F P
0 0 0 r
s
.252 .058 .024 r
.38879 .61476 m .40047 .62076 L .41637 .62916 L p F P
0 0 0 r
s
.252 .058 .024 r
.42601 .63411 m .41637 .62916 L .40047 .62076 L p F P
0 0 0 r
s
.24 .35 .67 r
.77399 .36881 m
.75845 .34083 L
s
.75845 .34083 m
.79402 .31942 L
s
.75845 .34083 m
.74062 .31435 L
s
.83 .24 .1 r
.25938 .31435 m
.24155 .34083 L
s
.20598 .31942 m
.24155 .34083 L
s
.24155 .34083 m
.22601 .36881 L
s
.831 .224 .089 r
.6881 .48119 m .67379 .47156 L .67003 .45279 L p F P
0 0 0 r
s
.831 .224 .089 r
.65579 .44307 m .67003 .45279 L .67379 .47156 L p F P
0 0 0 r
s
.08 .105 .237 r
.32997 .45279 m .34421 .44307 L .34074 .46178 L p F P
0 0 0 r
s
.08 .105 .237 r
.34074 .46178 m .32621 .47156 L .32997 .45279 L p F P
0 0 0 r
s
.24 .35 .67 r
.32798 .47185 m
.32832 .47014 L
s
.411 .13 .062 r
.56387 .35752 m .55143 .34889 L .54427 .34594 L p F P
0 0 0 r
s
.411 .13 .062 r
.53339 .3384 m .54427 .34594 L .55143 .34889 L p F P
0 0 0 r
s
.249 .388 .721 r
.45573 .34594 m .46661 .3384 L .46118 .34014 L p F P
0 0 0 r
s
.249 .388 .721 r
.46118 .34014 m .44857 .34889 L .45573 .34594 L p F P
0 0 0 r
s
.83 .24 .1 r
.35467 .27553 m
.33364 .2917 L
s
.29951 .2695 m
.33364 .2917 L
s
.24 .35 .67 r
.66636 .2917 m
.70049 .2695 L
s
.66636 .2917 m
.64533 .27553 L
s
.264 .412 .783 r
.55779 .63829 m .55039 .64211 L .56444 .63901 L p F P
0 0 0 r
s
.264 .412 .783 r
.56444 .63901 m .57399 .63411 L .55779 .63829 L p F P
0 0 0 r
s
.24 .35 .67 r
.56341 .63684 m
.57202 .6337 L
s
.538 .176 .08 r
.42601 .63411 m .43556 .63901 L .44961 .64211 L p F P
0 0 0 r
s
.538 .176 .08 r
.45697 .6459 m .44961 .64211 L .43556 .63901 L p F P
0 0 0 r
s
.24 .35 .67 r
.30289 .62238 m
.32167 .64822 L
s
.32167 .64822 m
.35034 .63167 L
s
.83 .24 .1 r
.64966 .63167 m
.67833 .64822 L
s
.67833 .64822 m
.69711 .62238 L
s
.024 .035 .067 r
.63496 .60257 m .62302 .6087 L .63942 .59574 L p F P
0 0 0 r
s
.024 .035 .067 r
.63942 .59574 m .65308 .58871 L .63496 .60257 L p F P
0 0 0 r
s
.24 .35 .67 r
.6177 .60526 m
.65075 .58819 L
s
.383 .086 .036 r
.34692 .58871 m .36058 .59574 L .37698 .6087 L p F P
0 0 0 r
s
.383 .086 .036 r
.38879 .61476 m .37698 .6087 L .36058 .59574 L p F P
0 0 0 r
s
.83 .24 .1 r
.34925 .58819 m
.3823 .60526 L
s
.24 .35 .67 r
.78672 .39737 m
.77399 .36881 L
s
.77399 .36881 m
.80986 .34782 L
s
.83 .24 .1 r
.19014 .34782 m
.22601 .36881 L
s
.22601 .36881 m
.21328 .39737 L
s
.542 .135 .052 r
.63466 .41661 m .62061 .40693 L .61171 .39338 L p F P
0 0 0 r
s
.542 .135 .052 r
.59844 .38419 m .61171 .39338 L .62061 .40693 L p F P
0 0 0 r
s
.024 .035 .067 r
.38829 .39338 m .40156 .38419 L .39366 .39711 L p F P
0 0 0 r
s
.024 .035 .067 r
.39366 .39711 m .37939 .40693 L .38829 .39338 L p F P
0 0 0 r
s
.916 .251 .101 r
.7015 .51014 m .68746 .50085 L .6881 .48119 L p F P
0 0 0 r
s
.916 .251 .101 r
.67379 .47156 m .6881 .48119 L .68746 .50085 L p F P
0 0 0 r
s
.83 .24 .1 r
.67202 .47185 m
.67481 .47373 L
s
.116 .157 .342 r
.3119 .48119 m .32621 .47156 L .3268 .49141 L p F P
0 0 0 r
s
.24 .35 .67 r
.31195 .48263 m
.31299 .48194 L
s
.32625 .47302 m
.32798 .47185 L
s
.116 .157 .342 r
.3268 .49141 m .31254 .50085 L .3119 .48119 L p F P
0 0 0 r
s
.24 .35 .67 r
.28796 .594 m
.30289 .62238 L
s
.83 .24 .1 r
.69711 .62238 m
.71204 .594 L
s
.68387 .57657 m
.71204 .594 L
s
.24 .35 .67 r
.74062 .31435 m
.77599 .29248 L
s
.74062 .31435 m
.72109 .29029 L
s
.83 .24 .1 r
.27891 .29029 m
.25938 .31435 L
s
.22401 .29248 m
.25938 .31435 L
s
.292 .449 .863 r
.52466 .64686 m .51968 .64945 L .52848 .6534 L p F P
0 0 0 r
s
.292 .449 .863 r
.52848 .6534 m .53573 .64966 L .52466 .64686 L p F P
0 0 0 r
s
.742 .233 .103 r
.46427 .64966 m .47152 .6534 L .48032 .64945 L p F P
0 0 0 r
s
.742 .233 .103 r
.48528 .65203 m .48032 .64945 L .47152 .6534 L p F P
0 0 0 r
s
.24 .35 .67 r
.37212 .65406 m
.39546 .6714 L
s
.39546 .6714 m
.42535 .6552 L
s
.83 .24 .1 r
.57465 .6552 m
.60454 .6714 L
s
.60454 .6714 m
.62788 .65406 L
s
.36 .08 .033 r
.59844 .38419 m .58498 .37487 L .57615 .36605 L p F P
0 0 0 r
s
.36 .08 .033 r
.56387 .35752 m .57615 .36605 L .58498 .37487 L p F P
0 0 0 r
s
.024 .035 .067 r
.42385 .36605 m .43613 .35752 L .42868 .36541 L p F P
0 0 0 r
s
.024 .035 .067 r
.42868 .36541 m .41502 .37487 L .42385 .36605 L p F P
0 0 0 r
s
.971 .27 .11 r
.70919 .53845 m .69572 .52971 L .7015 .51014 L p F P
0 0 0 r
s
.971 .27 .11 r
.68746 .50085 m .7015 .51014 L .69572 .52971 L p F P
0 0 0 r
s
.148 .206 .436 r
.2985 .51014 m .31254 .50085 L .31795 .52083 L p F P
0 0 0 r
s
.148 .206 .436 r
.31795 .52083 m .30428 .52971 L .2985 .51014 L p F P
0 0 0 r
s
.24 .35 .67 r
.30289 .62238 m
.33133 .60538 L
s
.83 .24 .1 r
.66867 .60538 m
.69711 .62238 L
s
.549 .179 .082 r
.51126 .32305 m .5 .31525 L .5 .32187 L p F P
0 0 0 r
s
.24 .35 .67 r
.51093 .32283 m
.53912 .3035 L
s
.689 .18 .07 r
.31775 .56498 m .30233 .55697 L .29081 .53845 L p F P
0 0 0 r
s
1 .283 .116 r
.69572 .52971 m .70919 .53845 L .69767 .55697 L p F P
0 0 0 r
s
.24 .35 .67 r
.69326 .55392 m
.69633 .53818 L
s
.83 .24 .1 r
.70243 .55191 m
.72233 .56463 L
s
.70128 .55117 m
.70243 .55191 L
s
.173 .246 .511 r
.29081 .53845 m .30428 .52971 L .31514 .54885 L p F P
0 0 0 r
s
.173 .246 .511 r
.31514 .54885 m .30233 .55697 L .29081 .53845 L p F P
0 0 0 r
s
.24 .35 .67 r
.29757 .55191 m
.29872 .55117 L
s
.27767 .56463 m
.29757 .55191 L
s
.024 .035 .067 r
.60317 .61912 m .59335 .62416 L .61121 .61476 L p F P
0 0 0 r
s
.024 .035 .067 r
.61121 .61476 m .62302 .6087 L .60317 .61912 L p F P
0 0 0 r
s
.24 .35 .67 r
.60438 .61706 m
.6177 .60526 L
s
.252 .058 .024 r
.37698 .6087 m .38879 .61476 L .40665 .62416 L p F P
0 0 0 r
s
.252 .058 .024 r
.41637 .62916 m .40665 .62416 L .38879 .61476 L p F P
0 0 0 r
s
.83 .24 .1 r
.3823 .60526 m
.39562 .61706 L
s
.698 .183 .07 r
.65579 .44307 m .64132 .4332 L .63466 .41661 L p F P
0 0 0 r
s
.698 .183 .07 r
.62061 .40693 m .63466 .41661 L .64132 .4332 L p F P
0 0 0 r
s
.043 .059 .127 r
.36534 .41661 m .37939 .40693 L .37338 .42317 L p F P
0 0 0 r
s
.043 .059 .127 r
.37338 .42317 m .35868 .4332 L .36534 .41661 L p F P
0 0 0 r
s
.029 .04 .077 r
.68091 .57435 m .6669 .58158 L .68225 .56498 L p F P
0 0 0 r
s
.029 .04 .077 r
.68225 .56498 m .69767 .55697 L .68091 .57435 L p F P
0 0 0 r
s
.24 .35 .67 r
.65957 .5715 m
.69326 .55392 L
s
.54 .134 .052 r
.30233 .55697 m .31775 .56498 L .3331 .58158 L p F P
0 0 0 r
s
.54 .134 .052 r
.34692 .58871 m .3331 .58158 L .31775 .56498 L p F P
0 0 0 r
s
.83 .24 .1 r
.30697 .55403 m
.34043 .5715 L
s
.34043 .5715 m
.34925 .58819 L
s
.264 .412 .783 r
.56525 .63445 m .55779 .63829 L .57399 .63411 L p F P
0 0 0 r
s
.264 .412 .783 r
.57399 .63411 m .58363 .62916 L .56525 .63445 L p F P
0 0 0 r
s
.24 .35 .67 r
.57733 .63097 m
.60438 .61706 L
s
.538 .176 .08 r
.41637 .62916 m .42601 .63411 L .44221 .63829 L p F P
0 0 0 r
s
.83 .24 .1 r
.39562 .61706 m
.42525 .6323 L
s
.538 .176 .08 r
.44961 .64211 m .44221 .63829 L .42601 .63411 L p F P
0 0 0 r
s
.411 .13 .062 r
.55143 .34889 m .53882 .34014 L .53339 .3384 L p F P
0 0 0 r
s
.411 .13 .062 r
.52239 .33077 m .53339 .3384 L .53882 .34014 L p F P
0 0 0 r
s
.83 .24 .1 r
.51071 .32626 m
.54137 .34746 L
s
.249 .388 .721 r
.46661 .3384 m .47761 .33077 L .47395 .33127 L p F P
0 0 0 r
s
.249 .388 .721 r
.47395 .33127 m .46118 .34014 L .46661 .3384 L p F P
0 0 0 r
s
.24 .35 .67 r
.45863 .34746 m
.48929 .32626 L
s
.292 .449 .863 r
.52967 .64426 m .52466 .64686 L .53573 .64966 L p F P
0 0 0 r
s
.292 .449 .863 r
.53573 .64966 m .54303 .6459 L .52967 .64426 L p F P
0 0 0 r
s
.742 .233 .103 r
.45697 .6459 m .46427 .64966 L .47534 .64686 L p F P
0 0 0 r
s
.742 .233 .103 r
.48032 .64945 m .47534 .64686 L .46427 .64966 L p F P
0 0 0 r
s
.24 .35 .67 r
.79615 .42555 m
.78672 .39737 L
s
.78672 .39737 m
.82296 .37673 L
s
.83 .24 .1 r
.17704 .37673 m
.21328 .39737 L
s
.21328 .39737 m
.20385 .42555 L
s
.24 .35 .67 r
.70298 .54884 m
.72802 .53577 L
s
.70099 .54988 m
.70298 .54884 L
s
.69326 .55392 m
.6973 .55181 L
s
.83 .24 .1 r
.27198 .53577 m
.29702 .54884 L
s
.29702 .54884 m
.29901 .54988 L
s
.24 .35 .67 r
.42535 .6552 m
.44903 .6671 L
s
.44903 .6671 m
.47991 .65076 L
s
.83 .24 .1 r
.52009 .65076 m
.55097 .6671 L
s
.55097 .6671 m
.57465 .6552 L
s
.24 .35 .67 r
.72802 .53577 m
.73162 .5149 L
s
.73162 .5149 m
.76702 .49611 L
s
.83 .24 .1 r
.23298 .49611 m
.26838 .5149 L
s
.26838 .5149 m
.27198 .53577 L
s
.298 .454 .881 r
.50252 .64553 m .5 .64685 L .5 .65968 L p F P
0 0 0 r
s
.83 .24 .1 r
.50027 .65818 m
.50157 .65886 L
s
.24 .35 .67 r
.49843 .65886 m
.5 .65804 L
s
.298 .454 .881 r
.5 .65968 m .50488 .65714 L .50252 .64553 L p F P
0 0 0 r
s
.24 .35 .67 r
.50479 .65667 m
.50582 .65665 L
s
.887 .271 .117 r
.49512 .65714 m .5 .65968 L .5 .64685 L p F P
0 0 0 r
s
.83 .24 .1 r
.49418 .65665 m
.49534 .65668 L
s
.024 .035 .067 r
.64704 .59636 m .63496 .60257 L .65308 .58871 L p F P
0 0 0 r
s
.024 .035 .067 r
.65308 .58871 m .6669 .58158 L .64704 .59636 L p F P
0 0 0 r
s
.383 .086 .036 r
.3331 .58158 m .34692 .58871 L .36504 .60257 L p F P
0 0 0 r
s
.383 .086 .036 r
.37698 .6087 m .36504 .60257 L .34692 .58871 L p F P
0 0 0 r
s
.24 .35 .67 r
.72109 .29029 m
.75634 .26791 L
s
.72109 .29029 m
.70049 .2695 L
s
.83 .24 .1 r
.29951 .2695 m
.27891 .29029 L
s
.24366 .26791 m
.27891 .29029 L
s
.831 .224 .089 r
.67379 .47156 m .65926 .46178 L .65579 .44307 L p F P
0 0 0 r
s
.83 .24 .1 r
.67168 .47014 m
.67202 .47185 L
s
.831 .224 .089 r
.64132 .4332 m .65579 .44307 L .65926 .46178 L p F P
0 0 0 r
s
.08 .105 .237 r
.34421 .44307 m .35868 .4332 L .3555 .45183 L p F P
0 0 0 r
s
.08 .105 .237 r
.3555 .45183 m .34074 .46178 L .34421 .44307 L p F P
0 0 0 r
s
.542 .135 .052 r
.62061 .40693 m .60634 .39711 L .59844 .38419 L p F P
0 0 0 r
s
.542 .135 .052 r
.58498 .37487 m .59844 .38419 L .60634 .39711 L p F P
0 0 0 r
s
.024 .035 .067 r
.40156 .38419 m .41502 .37487 L .40815 .38713 L p F P
0 0 0 r
s
.024 .035 .067 r
.40815 .38713 m .39366 .39711 L .40156 .38419 L p F P
0 0 0 r
s
.36 .08 .033 r
.58498 .37487 m .57132 .36541 L .56387 .35752 L p F P
0 0 0 r
s
.36 .08 .033 r
.55143 .34889 m .56387 .35752 L .57132 .36541 L p F P
0 0 0 r
s
.83 .24 .1 r
.55742 .35496 m
.56543 .36052 L
s
.54137 .34746 m
.55742 .35496 L
s
.024 .035 .067 r
.43613 .35752 m .44857 .34889 L .44253 .35582 L p F P
0 0 0 r
s
.24 .35 .67 r
.44375 .35442 m
.45863 .34746 L
s
.024 .035 .067 r
.44253 .35582 m .42868 .36541 L .43613 .35752 L p F P
0 0 0 r
s
.24 .35 .67 r
.80187 .45234 m
.76584 .47185 L
s
.76702 .49611 m
.76584 .47185 L
s
.83 .24 .1 r
.19813 .45234 m
.23416 .47185 L
s
.23416 .47185 m
.23298 .49611 L
s
.292 .449 .863 r
.5347 .64165 m .52967 .64426 L .54303 .6459 L p F P
0 0 0 r
s
.292 .449 .863 r
.54303 .6459 m .55039 .64211 L .5347 .64165 L p F P
0 0 0 r
s
.742 .233 .103 r
.44961 .64211 m .45697 .6459 L .47033 .64426 L p F P
0 0 0 r
s
.742 .233 .103 r
.47534 .64686 m .47033 .64426 L .45697 .6459 L p F P
0 0 0 r
s
.916 .251 .101 r
.68746 .50085 m .6732 .49141 L .67379 .47156 L p F P
0 0 0 r
s
.916 .251 .101 r
.65926 .46178 m .67379 .47156 L .6732 .49141 L p F P
0 0 0 r
s
.116 .157 .342 r
.32621 .47156 m .34074 .46178 L .34128 .48182 L p F P
0 0 0 r
s
.116 .157 .342 r
.34128 .48182 m .3268 .49141 L .32621 .47156 L p F P
0 0 0 r
s
.83 .24 .1 r
.47906 .30438 m
.46088 .3035 L
s
.42846 .28128 m
.46088 .3035 L
s
.24 .35 .67 r
.53912 .3035 m
.57154 .28128 L
s
.53912 .3035 m
.52094 .30438 L
s
.298 .454 .881 r
.50504 .6442 m .50252 .64553 L .50488 .65714 L p F P
0 0 0 r
s
.298 .454 .881 r
.50488 .65714 m .50979 .65459 L .50504 .6442 L p F P
0 0 0 r
s
.887 .271 .117 r
.49021 .65459 m .49512 .65714 L .49748 .64553 L p F P
0 0 0 r
s
.83 .24 .1 r
.49542 .65566 m
.49574 .65583 L
s
.887 .271 .117 r
.5 .64685 m .49748 .64553 L .49512 .65714 L p F P
0 0 0 r
s
.264 .412 .783 r
.57277 .63057 m .56525 .63445 L .58363 .62916 L p F P
0 0 0 r
s
.264 .412 .783 r
.58363 .62916 m .59335 .62416 L .57277 .63057 L p F P
0 0 0 r
s
.538 .176 .08 r
.40665 .62416 m .41637 .62916 L .43475 .63445 L p F P
0 0 0 r
s
.538 .176 .08 r
.44221 .63829 m .43475 .63445 L .41637 .62916 L p F P
0 0 0 r
s
.83 .24 .1 r
.42846 .28128 m
.40865 .28669 L
s
.37539 .26419 m
.40865 .28669 L
s
.24 .35 .67 r
.59135 .28669 m
.62461 .26419 L
s
.59135 .28669 m
.57154 .28128 L
s
.024 .035 .067 r
.61309 .61403 m .60317 .61912 L .62302 .6087 L p F P
0 0 0 r
s
.024 .035 .067 r
.62302 .6087 m .63496 .60257 L .61309 .61403 L p F P
0 0 0 r
s
.252 .058 .024 r
.36504 .60257 m .37698 .6087 L .39683 .61912 L p F P
0 0 0 r
s
.252 .058 .024 r
.40665 .62416 m .39683 .61912 L .37698 .6087 L p F P
0 0 0 r
s
.83 .24 .1 r
.49876 .318 m
.51071 .32626 L
s
.24 .35 .67 r
.48929 .32626 m
.50124 .318 L
s
.971 .27 .11 r
.69572 .52971 m .68205 .52083 L .68746 .50085 L p F P
0 0 0 r
s
.971 .27 .11 r
.6732 .49141 m .68746 .50085 L .68205 .52083 L p F P
0 0 0 r
s
.148 .206 .436 r
.31254 .50085 m .3268 .49141 L .33184 .51182 L p F P
0 0 0 r
s
.148 .206 .436 r
.33184 .51182 m .31795 .52083 L .31254 .50085 L p F P
0 0 0 r
s
.24 .35 .67 r
.35034 .63167 m
.37212 .65406 L
s
.37212 .65406 m
.4019 .63743 L
s
.83 .24 .1 r
.5981 .63743 m
.62788 .65406 L
s
.62788 .65406 m
.64966 .63167 L
s
.411 .13 .062 r
.53882 .34014 m .52605 .33127 L .52239 .33077 L p F P
0 0 0 r
s
.411 .13 .062 r
.51126 .32305 m .52239 .33077 L .52605 .33127 L p F P
0 0 0 r
s
.249 .388 .721 r
.47761 .33077 m .48874 .32305 L .48689 .32229 L p F P
0 0 0 r
s
.249 .388 .721 r
.48689 .32229 m .47395 .33127 L .47761 .33077 L p F P
0 0 0 r
s
1 .283 .116 r
.69767 .55697 m .68486 .54885 L .69572 .52971 L p F P
0 0 0 r
s
1 .283 .116 r
.68205 .52083 m .69572 .52971 L .68486 .54885 L p F P
0 0 0 r
s
.173 .246 .511 r
.30428 .52971 m .31795 .52083 L .32813 .54061 L p F P
0 0 0 r
s
.173 .246 .511 r
.32813 .54061 m .31514 .54885 L .30428 .52971 L p F P
0 0 0 r
s
.83 .24 .1 r
.37539 .26419 m
.35467 .27553 L
s
.32047 .2528 m
.35467 .27553 L
s
.24 .35 .67 r
.64533 .27553 m
.67953 .2528 L
s
.64533 .27553 m
.62461 .26419 L
s
.298 .454 .881 r
.50757 .64287 m .50504 .6442 L .50979 .65459 L p F P
0 0 0 r
s
.298 .454 .881 r
.50979 .65459 m .51472 .65203 L .50757 .64287 L p F P
0 0 0 r
s
.83 .24 .1 r
.50569 .65455 m
.50808 .65392 L
s
.887 .271 .117 r
.48528 .65203 m .49021 .65459 L .49496 .6442 L p F P
0 0 0 r
s
.83 .24 .1 r
.49081 .65326 m
.49114 .65343 L
s
.887 .271 .117 r
.49748 .64553 m .49496 .6442 L .49021 .65459 L p F P
0 0 0 r
s
.24 .35 .67 r
.49192 .65392 m
.49431 .65455 L
s
.54 .134 .052 r
.3331 .58158 m .31909 .57435 L .30233 .55697 L p F P
0 0 0 r
s
.24 .35 .67 r
.28796 .594 m
.31613 .57657 L
s
1 .292 .121 r
.68486 .54885 m .69767 .55697 L .68091 .57435 L p F P
0 0 0 r
s
.24 .35 .67 r
.68607 .56818 m
.68764 .56506 L
s
.194 .28 .573 r
.30233 .55697 m .31514 .54885 L .33091 .56704 L p F P
0 0 0 r
s
.194 .28 .573 r
.33091 .56704 m .31909 .57435 L .30233 .55697 L p F P
0 0 0 r
s
.83 .24 .1 r
.31236 .56506 m
.31393 .56818 L
s
.31393 .56818 m
.31514 .57058 L
s
.24 .35 .67 r
.31314 .56819 m
.31613 .57657 L
s
.83 .24 .1 r
.68387 .57657 m
.68686 .56819 L
s
.698 .183 .07 r
.64132 .4332 m .62662 .42317 L .62061 .40693 L p F P
0 0 0 r
s
.698 .183 .07 r
.60634 .39711 m .62061 .40693 L .62662 .42317 L p F P
0 0 0 r
s
.043 .059 .127 r
.37939 .40693 m .39366 .39711 L .38832 .41298 L p F P
0 0 0 r
s
.043 .059 .127 r
.38832 .41298 m .37338 .42317 L .37939 .40693 L p F P
0 0 0 r
s
.292 .449 .863 r
.53976 .63902 m .5347 .64165 L .55039 .64211 L p F P
0 0 0 r
s
.292 .449 .863 r
.55039 .64211 m .55779 .63829 L .53976 .63902 L p F P
0 0 0 r
s
.742 .233 .103 r
.44221 .63829 m .44961 .64211 L .4653 .64165 L p F P
0 0 0 r
s
.742 .233 .103 r
.47033 .64426 m .4653 .64165 L .44961 .64211 L p F P
0 0 0 r
s
.024 .035 .067 r
.65926 .59009 m .64704 .59636 L .6669 .58158 L p F P
0 0 0 r
s
.024 .035 .067 r
.6669 .58158 m .68091 .57435 L .65926 .59009 L p F P
0 0 0 r
s
.383 .086 .036 r
.31909 .57435 m .3331 .58158 L .35296 .59636 L p F P
0 0 0 r
s
.383 .086 .036 r
.36504 .60257 m .35296 .59636 L .3331 .58158 L p F P
0 0 0 r
s
.83 .24 .1 r
.32062 .57341 m
.34925 .58819 L
s
.24 .35 .67 r
.80187 .45234 m
.79615 .42555 L
s
.79615 .42555 m
.83284 .40519 L
s
.83 .24 .1 r
.16716 .40519 m
.20385 .42555 L
s
.20385 .42555 m
.19813 .45234 L
s
.538 .176 .08 r
.39683 .61912 m .40665 .62416 L .42723 .63057 L p F P
0 0 0 r
s
.538 .176 .08 r
.43475 .63445 m .42723 .63057 L .40665 .62416 L p F P
0 0 0 r
s
.264 .412 .783 r
.58034 .62667 m .57277 .63057 L .59335 .62416 L p F P
0 0 0 r
s
.264 .412 .783 r
.59335 .62416 m .60317 .61912 L .58034 .62667 L p F P
0 0 0 r
s
.298 .454 .881 r
.51011 .64153 m .50757 .64287 L .51472 .65203 L p F P
0 0 0 r
s
.298 .454 .881 r
.51472 .65203 m .51968 .64945 L .51011 .64153 L p F P
0 0 0 r
s
.83 .24 .1 r
.50808 .65392 m
.52009 .65076 L
s
.887 .271 .117 r
.48032 .64945 m .48528 .65203 L .49243 .64287 L p F P
0 0 0 r
s
.83 .24 .1 r
.48619 .65086 m
.48651 .65103 L
s
.887 .271 .117 r
.49496 .6442 m .49243 .64287 L .48528 .65203 L p F P
0 0 0 r
s
.24 .35 .67 r
.47991 .65076 m
.49192 .65392 L
s
.36 .08 .033 r
.57132 .36541 m .55747 .35582 L .55143 .34889 L p F P
0 0 0 r
s
.36 .08 .033 r
.53882 .34014 m .55143 .34889 L .55747 .35582 L p F P
0 0 0 r
s
.024 .035 .067 r
.44857 .34889 m .46118 .34014 L .45658 .34608 L p F P
0 0 0 r
s
.024 .035 .067 r
.45658 .34608 m .44253 .35582 L .44857 .34889 L p F P
0 0 0 r
s
.542 .135 .052 r
.60634 .39711 m .59185 .38713 L .58498 .37487 L p F P
0 0 0 r
s
.542 .135 .052 r
.57132 .36541 m .58498 .37487 L .59185 .38713 L p F P
0 0 0 r
s
.024 .035 .067 r
.41502 .37487 m .42868 .36541 L .42286 .377 L p F P
0 0 0 r
s
.024 .035 .067 r
.42286 .377 m .40815 .38713 L .41502 .37487 L p F P
0 0 0 r
s
.24 .35 .67 r
.79402 .31942 m
.80986 .34782 L
s
.77599 .29248 m
.79402 .31942 L
s
.83 .24 .1 r
.22401 .29248 m
.20598 .31942 L
s
.20598 .31942 m
.19014 .34782 L
s
.831 .224 .089 r
.65926 .46178 m .6445 .45183 L .64132 .4332 L p F P
0 0 0 r
s
.831 .224 .089 r
.62662 .42317 m .64132 .4332 L .6445 .45183 L p F P
0 0 0 r
s
.08 .105 .237 r
.35868 .4332 m .37338 .42317 L .37051 .44173 L p F P
0 0 0 r
s
.08 .105 .237 r
.37051 .44173 m .3555 .45183 L .35868 .4332 L p F P
0 0 0 r
s
.24 .35 .67 r
.35701 .45234 m
.35732 .45061 L
s
.024 .035 .067 r
.6231 .6089 m .61309 .61403 L .63496 .60257 L p F P
0 0 0 r
s
.024 .035 .067 r
.63496 .60257 m .64704 .59636 L .6231 .6089 L p F P
0 0 0 r
s
.252 .058 .024 r
.35296 .59636 m .36504 .60257 L .38691 .61403 L p F P
0 0 0 r
s
.252 .058 .024 r
.39683 .61912 m .38691 .61403 L .36504 .60257 L p F P
0 0 0 r
s
.83 .24 .1 r
.32047 .2528 m
.29951 .2695 L
s
.26427 .24658 m
.29951 .2695 L
s
.24 .35 .67 r
.70049 .2695 m
.73573 .24658 L
s
.70049 .2695 m
.67953 .2528 L
s
.33133 .60538 m
.35034 .63167 L
s
.83 .24 .1 r
.64966 .63167 m
.66867 .60538 L
s
.292 .449 .863 r
.54484 .63638 m .53976 .63902 L .55779 .63829 L p F P
0 0 0 r
s
.292 .449 .863 r
.55779 .63829 m .56525 .63445 L .54484 .63638 L p F P
0 0 0 r
s
.742 .233 .103 r
.43475 .63445 m .44221 .63829 L .46024 .63902 L p F P
0 0 0 r
s
.742 .233 .103 r
.4653 .64165 m .46024 .63902 L .44221 .63829 L p F P
0 0 0 r
s
.24 .35 .67 r
.80986 .34782 m
.82296 .37673 L
s
.83 .24 .1 r
.19014 .34782 m
.17704 .37673 L
s
.411 .13 .062 r
.52605 .33127 m .51311 .32229 L .51126 .32305 L p F P
0 0 0 r
s
.411 .13 .062 r
.5 .31525 m .51126 .32305 L .51311 .32229 L p F P
0 0 0 r
s
.249 .388 .721 r
.48874 .32305 m .5 .31525 L .5 .31319 L p F P
0 0 0 r
s
.249 .388 .721 r
.5 .31319 m .48689 .32229 L .48874 .32305 L p F P
0 0 0 r
s
.83 .24 .1 r
.47906 .30438 m
.49591 .31603 L
s
.298 .454 .881 r
.51265 .6402 m .51011 .64153 L .51968 .64945 L p F P
0 0 0 r
s
.298 .454 .881 r
.51968 .64945 m .52466 .64686 L .51265 .6402 L p F P
0 0 0 r
s
.887 .271 .117 r
.47534 .64686 m .48032 .64945 L .48989 .64153 L p F P
0 0 0 r
s
.83 .24 .1 r
.48154 .64844 m
.48187 .64861 L
s
.887 .271 .117 r
.49243 .64287 m .48989 .64153 L .48032 .64945 L p F P
0 0 0 r
s
.24 .35 .67 r
.31613 .57657 m
.31939 .57455 L
s
.31613 .57657 m
.33133 .60538 L
s
.83 .24 .1 r
.66867 .60538 m
.68387 .57657 L
s
.68062 .57456 m
.68387 .57657 L
s
.916 .251 .101 r
.6732 .49141 m .65872 .48182 L .65926 .46178 L p F P
0 0 0 r
s
.916 .251 .101 r
.6445 .45183 m .65926 .46178 L .65872 .48182 L p F P
0 0 0 r
s
.83 .24 .1 r
.64299 .45234 m
.64555 .45405 L
s
.116 .157 .342 r
.34074 .46178 m .3555 .45183 L .356 .47207 L p F P
0 0 0 r
s
.24 .35 .67 r
.34078 .46325 m
.34185 .46253 L
s
.35554 .45332 m
.35701 .45234 L
s
.116 .157 .342 r
.356 .47207 m .34128 .48182 L .34074 .46178 L p F P
0 0 0 r
s
.24 .35 .67 r
.75634 .26791 m
.77599 .29248 L
s
.83 .24 .1 r
.24366 .26791 m
.22401 .29248 L
s
.24 .35 .67 r
.4019 .63743 m
.42535 .6552 L
s
.83 .24 .1 r
.57465 .6552 m
.5981 .63743 L
s
.971 .27 .11 r
.68205 .52083 m .66816 .51182 L .6732 .49141 L p F P
0 0 0 r
s
.971 .27 .11 r
.65872 .48182 m .6732 .49141 L .66816 .51182 L p F P
0 0 0 r
s
.148 .206 .436 r
.3268 .49141 m .34128 .48182 L .34594 .50267 L p F P
0 0 0 r
s
.148 .206 .436 r
.34594 .50267 m .33184 .51182 L .3268 .49141 L p F P
0 0 0 r
s
1 .283 .116 r
.68486 .54885 m .67187 .54061 L .68205 .52083 L p F P
0 0 0 r
s
1 .283 .116 r
.66816 .51182 m .68205 .52083 L .67187 .54061 L p F P
0 0 0 r
s
.173 .246 .511 r
.31795 .52083 m .33184 .51182 L .3413 .53225 L p F P
0 0 0 r
s
.173 .246 .511 r
.3413 .53225 m .32813 .54061 L .31795 .52083 L p F P
0 0 0 r
s
.264 .412 .783 r
.58797 .62274 m .58034 .62667 L .60317 .61912 L p F P
0 0 0 r
s
.264 .412 .783 r
.60317 .61912 m .61309 .61403 L .58797 .62274 L p F P
0 0 0 r
s
.538 .176 .08 r
.38691 .61403 m .39683 .61912 L .41966 .62667 L p F P
0 0 0 r
s
.538 .176 .08 r
.42723 .63057 m .41966 .62667 L .39683 .61912 L p F P
0 0 0 r
s
1 .292 .121 r
.68091 .57435 m .66909 .56704 L .68486 .54885 L p F P
0 0 0 r
s
.24 .35 .67 r
.65075 .58819 m
.67938 .57341 L
s
.68486 .57058 m
.68607 .56818 L
s
1 .292 .121 r
.67187 .54061 m .68486 .54885 L .66909 .56704 L p F P
0 0 0 r
s
.194 .28 .573 r
.31514 .54885 m .32813 .54061 L .34289 .55962 L p F P
0 0 0 r
s
.194 .28 .573 r
.34289 .55962 m .33091 .56704 L .31514 .54885 L p F P
0 0 0 r
s
.298 .454 .881 r
.5152 .63885 m .51265 .6402 L .52466 .64686 L p F P
0 0 0 r
s
.298 .454 .881 r
.52466 .64686 m .52967 .64426 L .5152 .63885 L p F P
0 0 0 r
s
.887 .271 .117 r
.47033 .64426 m .47534 .64686 L .48735 .6402 L p F P
0 0 0 r
s
.83 .24 .1 r
.47687 .64601 m
.4772 .64618 L
s
.887 .271 .117 r
.48989 .64153 m .48735 .6402 L .47534 .64686 L p F P
0 0 0 r
s
.292 .449 .863 r
.54995 .63373 m .54484 .63638 L .56525 .63445 L p F P
0 0 0 r
s
.292 .449 .863 r
.56525 .63445 m .57277 .63057 L .54995 .63373 L p F P
0 0 0 r
s
.742 .233 .103 r
.42723 .63057 m .43475 .63445 L .45516 .63638 L p F P
0 0 0 r
s
.742 .233 .103 r
.46024 .63902 m .45516 .63638 L .43475 .63445 L p F P
0 0 0 r
s
.698 .183 .07 r
.62662 .42317 m .61168 .41298 L .60634 .39711 L p F P
0 0 0 r
s
.698 .183 .07 r
.59185 .38713 m .60634 .39711 L .61168 .41298 L p F P
0 0 0 r
s
.043 .059 .127 r
.39366 .39711 m .40815 .38713 L .4035 .40262 L p F P
0 0 0 r
s
.043 .059 .127 r
.4035 .40262 m .38832 .41298 L .39366 .39711 L p F P
0 0 0 r
s
.383 .086 .036 r
.35296 .59636 m .34074 .59009 L .31909 .57435 L p F P
0 0 0 r
s
1 .299 .124 r
.66909 .56704 m .68091 .57435 L .65926 .59009 L p F P
0 0 0 r
s
.24 .35 .67 r
.68064 .57276 m
.68486 .57058 L
s
.68047 .57285 m
.68064 .57276 L
s
.213 .308 .627 r
.31909 .57435 m .33091 .56704 L .35126 .58375 L p F P
0 0 0 r
s
.83 .24 .1 r
.31514 .57058 m
.31936 .57276 L
s
.31936 .57276 m
.31953 .57285 L
s
.213 .308 .627 r
.35126 .58375 m .34074 .59009 L .31909 .57435 L p F P
0 0 0 r
s
.36 .08 .033 r
.55747 .35582 m .54342 .34608 L .53882 .34014 L p F P
0 0 0 r
s
.36 .08 .033 r
.52605 .33127 m .53882 .34014 L .54342 .34608 L p F P
0 0 0 r
s
.83 .24 .1 r
.52649 .33352 m
.53827 .34169 L
s
.51071 .32626 m
.52649 .33352 L
s
.024 .035 .067 r
.46118 .34014 m .47395 .33127 L .47084 .3362 L p F P
0 0 0 r
s
.24 .35 .67 r
.47177 .33473 m
.47351 .33352 L
s
.47351 .33352 m
.48929 .32626 L
s
.024 .035 .067 r
.47084 .3362 m .45658 .34608 L .46118 .34014 L p F P
0 0 0 r
s
.24 .35 .67 r
.82296 .37673 m
.83284 .40519 L
s
.83 .24 .1 r
.17704 .37673 m
.16716 .40519 L
s
.024 .035 .067 r
.6332 .60371 m .6231 .6089 L .64704 .59636 L p F P
0 0 0 r
s
.024 .035 .067 r
.64704 .59636 m .65926 .59009 L .6332 .60371 L p F P
0 0 0 r
s
.24 .35 .67 r
.63779 .59989 m
.65075 .58819 L
s
.60446 .61703 m
.63779 .59989 L
s
.252 .058 .024 r
.34074 .59009 m .35296 .59636 L .3769 .6089 L p F P
0 0 0 r
s
.252 .058 .024 r
.38691 .61403 m .3769 .6089 L .35296 .59636 L p F P
0 0 0 r
s
.83 .24 .1 r
.36221 .59989 m
.39562 .61706 L
s
.34925 .58819 m
.36221 .59989 L
s
.24 .35 .67 r
.72008 .5524 m
.72802 .53577 L
s
.72802 .53577 m
.76392 .51703 L
s
.83 .24 .1 r
.23608 .51703 m
.27198 .53577 L
s
.27198 .53577 m
.27992 .5524 L
s
.298 .454 .881 r
.51776 .63751 m .5152 .63885 L .52967 .64426 L p F P
0 0 0 r
s
.298 .454 .881 r
.52967 .64426 m .5347 .64165 L .51776 .63751 L p F P
0 0 0 r
s
.24 .35 .67 r
.53253 .64112 m
.53434 .64018 L
s
.53434 .64018 m
.53758 .64015 L
s
.887 .271 .117 r
.4653 .64165 m .47033 .64426 L .4848 .63885 L p F P
0 0 0 r
s
.83 .24 .1 r
.46566 .64018 m
.4678 .64129 L
s
.47218 .64357 m
.47251 .64374 L
s
.46242 .64015 m
.46566 .64018 L
s
.887 .271 .117 r
.48735 .6402 m .4848 .63885 L .47033 .64426 L p F P
0 0 0 r
s
.24 .35 .67 r
.47991 .65076 m
.49257 .64406 L
s
.83 .24 .1 r
.50743 .64406 m
.52009 .65076 L
s
.542 .135 .052 r
.59185 .38713 m .57714 .377 L .57132 .36541 L p F P
0 0 0 r
s
.542 .135 .052 r
.55747 .35582 m .57132 .36541 L .57714 .377 L p F P
0 0 0 r
s
.024 .035 .067 r
.42868 .36541 m .44253 .35582 L .43781 .3667 L p F P
0 0 0 r
s
.024 .035 .067 r
.43781 .3667 m .42286 .377 L .42868 .36541 L p F P
0 0 0 r
s
.411 .13 .062 r
.51311 .32229 m .5 .31319 L .5 .31525 L p F P
0 0 0 r
s
.24 .35 .67 r
.50409 .31603 m
.52094 .30438 L
s
.76392 .51703 m
.76702 .49611 L
s
.76702 .49611 m
.80357 .47672 L
s
.83 .24 .1 r
.19643 .47672 m
.23298 .49611 L
s
.23298 .49611 m
.23608 .51703 L
s
.24 .35 .67 r
.67228 .58217 m
.68486 .57058 L
s
.68486 .57058 m
.72008 .5524 L
s
.83 .24 .1 r
.27992 .5524 m
.31514 .57058 L
s
.31514 .57058 m
.32772 .58217 L
s
.24 .35 .67 r
.73573 .24658 m
.75634 .26791 L
s
.83 .24 .1 r
.26427 .24658 m
.24366 .26791 L
s
.831 .224 .089 r
.6445 .45183 m .62949 .44173 L .62662 .42317 L p F P
0 0 0 r
s
.83 .24 .1 r
.64268 .45061 m
.64299 .45234 L
s
.831 .224 .089 r
.61168 .41298 m .62662 .42317 L .62949 .44173 L p F P
0 0 0 r
s
.08 .105 .237 r
.37338 .42317 m .38832 .41298 L .38577 .43146 L p F P
0 0 0 r
s
.08 .105 .237 r
.38577 .43146 m .37051 .44173 L .37338 .42317 L p F P
0 0 0 r
s
.292 .449 .863 r
.55508 .63106 m .54995 .63373 L .57277 .63057 L p F P
0 0 0 r
s
.292 .449 .863 r
.57277 .63057 m .58034 .62667 L .55508 .63106 L p F P
0 0 0 r
s
.742 .233 .103 r
.41966 .62667 m .42723 .63057 L .45005 .63373 L p F P
0 0 0 r
s
.742 .233 .103 r
.45516 .63638 m .45005 .63373 L .42723 .63057 L p F P
0 0 0 r
s
.264 .412 .783 r
.59565 .61878 m .58797 .62274 L .61309 .61403 L p F P
0 0 0 r
s
.264 .412 .783 r
.61309 .61403 m .6231 .6089 L .59565 .61878 L p F P
0 0 0 r
s
.538 .176 .08 r
.3769 .6089 m .38691 .61403 L .41203 .62274 L p F P
0 0 0 r
s
.538 .176 .08 r
.41966 .62667 m .41203 .62274 L .38691 .61403 L p F P
0 0 0 r
s
.298 .454 .881 r
.52032 .63616 m .51776 .63751 L .5347 .64165 L p F P
0 0 0 r
s
.298 .454 .881 r
.5347 .64165 m .53976 .63902 L .52032 .63616 L p F P
0 0 0 r
s
.887 .271 .117 r
.46024 .63902 m .4653 .64165 L .48224 .63751 L p F P
0 0 0 r
s
.887 .271 .117 r
.4848 .63885 m .48224 .63751 L .4653 .64165 L p F P
0 0 0 r
s
.24 .35 .67 r
.83908 .43218 m
.80187 .45234 L
s
.80357 .47672 m
.80187 .45234 L
s
.83 .24 .1 r
.16092 .43218 m
.19813 .45234 L
s
.19813 .45234 m
.19643 .47672 L
s
.916 .251 .101 r
.65872 .48182 m .644 .47207 L .6445 .45183 L p F P
0 0 0 r
s
.916 .251 .101 r
.62949 .44173 m .6445 .45183 L .644 .47207 L p F P
0 0 0 r
s
.116 .157 .342 r
.3555 .45183 m .37051 .44173 L .37096 .46217 L p F P
0 0 0 r
s
.116 .157 .342 r
.37096 .46217 m .356 .47207 L .3555 .45183 L p F P
0 0 0 r
s
.83 .24 .1 r
.44638 .28179 m
.42846 .28128 L
s
.39499 .25833 m
.42846 .28128 L
s
.24 .35 .67 r
.57154 .28128 m
.60501 .25833 L
s
.57154 .28128 m
.55362 .28179 L
s
.83 .24 .1 r
.39499 .25833 m
.37539 .26419 L
s
.34104 .24096 m
.37539 .26419 L
s
.24 .35 .67 r
.62461 .26419 m
.65896 .24096 L
s
.62461 .26419 m
.60501 .25833 L
s
.971 .27 .11 r
.66816 .51182 m .65406 .50267 L .65872 .48182 L p F P
0 0 0 r
s
.971 .27 .11 r
.644 .47207 m .65872 .48182 L .65406 .50267 L p F P
0 0 0 r
s
.148 .206 .436 r
.34128 .48182 m .356 .47207 L .36026 .49337 L p F P
0 0 0 r
s
.148 .206 .436 r
.36026 .49337 m .34594 .50267 L .34128 .48182 L p F P
0 0 0 r
s
.83 .24 .1 r
.49455 .31139 m
.47906 .30438 L
s
.44638 .28179 m
.47906 .30438 L
s
.24 .35 .67 r
.52094 .30438 m
.55362 .28179 L
s
.52094 .30438 m
.50545 .31139 L
s
.293 .442 .866 r
.5 .64685 m .50252 .64553 L .5 .62969 L closepath p F P
0 0 0 r
s
.971 .291 .125 r
.5 .62969 m .49748 .64553 L .5 .64685 L closepath p F P
0 0 0 r
s
1 .283 .116 r
.67187 .54061 m .6587 .53225 L .66816 .51182 L p F P
0 0 0 r
s
1 .283 .116 r
.65406 .50267 m .66816 .51182 L .6587 .53225 L p F P
0 0 0 r
s
.173 .246 .511 r
.33184 .51182 m .34594 .50267 L .35467 .52376 L p F P
0 0 0 r
s
.173 .246 .511 r
.35467 .52376 m .3413 .53225 L .33184 .51182 L p F P
0 0 0 r
s
1 .292 .121 r
.66909 .56704 m .65711 .55962 L .67187 .54061 L p F P
0 0 0 r
s
1 .292 .121 r
.6587 .53225 m .67187 .54061 L .65711 .55962 L p F P
0 0 0 r
s
.194 .28 .573 r
.32813 .54061 m .3413 .53225 L .35502 .55211 L p F P
0 0 0 r
s
.194 .28 .573 r
.35502 .55211 m .34289 .55962 L .32813 .54061 L p F P
0 0 0 r
s
1 .299 .124 r
.65926 .59009 m .64874 .58375 L .66909 .56704 L p F P
0 0 0 r
s
1 .299 .124 r
.65711 .55962 m .66909 .56704 L .64874 .58375 L p F P
0 0 0 r
s
.213 .308 .627 r
.33091 .56704 m .34289 .55962 L .36191 .57733 L p F P
0 0 0 r
s
.24 .35 .67 r
.33118 .56726 m
.33132 .56717 L
s
.34314 .55986 m
.3452 .55859 L
s
.213 .308 .627 r
.36191 .57733 m .35126 .58375 L .33091 .56704 L p F P
0 0 0 r
s
.298 .454 .881 r
.52289 .63481 m .52032 .63616 L .53976 .63902 L p F P
0 0 0 r
s
.298 .454 .881 r
.53976 .63902 m .54484 .63638 L .52289 .63481 L p F P
0 0 0 r
s
.83 .24 .1 r
.52009 .65076 m
.54379 .63847 L
s
.54379 .63847 m
.57465 .6552 L
s
.887 .271 .117 r
.45516 .63638 m .46024 .63902 L .47968 .63616 L p F P
0 0 0 r
s
.83 .24 .1 r
.46274 .63865 m
.46307 .63883 L
s
.24 .35 .67 r
.42535 .6552 m
.45621 .63847 L
s
.887 .271 .117 r
.48224 .63751 m .47968 .63616 L .46024 .63902 L p F P
0 0 0 r
s
.24 .35 .67 r
.45621 .63847 m
.47991 .65076 L
s
.252 .058 .024 r
.3769 .6089 m .3668 .60371 L .34074 .59009 L p F P
0 0 0 r
s
1 .304 .127 r
.64874 .58375 m .65926 .59009 L .6332 .60371 L p F P
0 0 0 r
s
.24 .35 .67 r
.65081 .5932 m
.65191 .59263 L
s
.83 .24 .1 r
.65063 .5946 m
.65156 .59516 L
s
.65156 .59516 m
.66867 .60538 L
s
.229 .334 .674 r
.34074 .59009 m .35126 .58375 L .37572 .59847 L p F P
0 0 0 r
s
.229 .334 .674 r
.37572 .59847 m .3668 .60371 L .34074 .59009 L p F P
0 0 0 r
s
.83 .24 .1 r
.32772 .58217 m
.34809 .59263 L
s
.34809 .59263 m
.34919 .5932 L
s
.24 .35 .67 r
.33133 .60538 m
.34844 .59516 L
s
.34844 .59516 m
.34937 .5946 L
s
.292 .449 .863 r
.56024 .62838 m .55508 .63106 L .58034 .62667 L p F P
0 0 0 r
s
.292 .449 .863 r
.58034 .62667 m .58797 .62274 L .56024 .62838 L p F P
0 0 0 r
s
.742 .233 .103 r
.41203 .62274 m .41966 .62667 L .44492 .63106 L p F P
0 0 0 r
s
.742 .233 .103 r
.45005 .63373 m .44492 .63106 L .41966 .62667 L p F P
0 0 0 r
s
.83 .24 .1 r
.34104 .24096 m
.32047 .2528 L
s
.28515 .22934 m
.32047 .2528 L
s
.24 .35 .67 r
.67953 .2528 m
.71485 .22934 L
s
.67953 .2528 m
.65896 .24096 L
s
.293 .442 .866 r
.50252 .64553 m .50504 .6442 L .5 .62969 L closepath p F P
0 0 0 r
s
.971 .291 .125 r
.5 .62969 m .49496 .6442 L .49748 .64553 L closepath p F P
0 0 0 r
s
.698 .183 .07 r
.61168 .41298 m .5965 .40262 L .59185 .38713 L p F P
0 0 0 r
s
.698 .183 .07 r
.57714 .377 m .59185 .38713 L .5965 .40262 L p F P
0 0 0 r
s
.043 .059 .127 r
.40815 .38713 m .42286 .377 L .41892 .3921 L p F P
0 0 0 r
s
.043 .059 .127 r
.41892 .3921 m .4035 .40262 L .40815 .38713 L p F P
0 0 0 r
s
.36 .08 .033 r
.54342 .34608 m .52916 .3362 L .52605 .33127 L p F P
0 0 0 r
s
.36 .08 .033 r
.51311 .32229 m .52605 .33127 L .52916 .3362 L p F P
0 0 0 r
s
.024 .035 .067 r
.47395 .33127 m .48689 .32229 L .48531 .32618 L p F P
0 0 0 r
s
.024 .035 .067 r
.48531 .32618 m .47084 .3362 L .47395 .33127 L p F P
0 0 0 r
s
.24 .35 .67 r
.34508 .55826 m
.3452 .55859 L
s
.83 .24 .1 r
.6548 .55859 m
.65763 .55078 L
s
.264 .412 .783 r
.60339 .61479 m .59565 .61878 L .6231 .6089 L p F P
0 0 0 r
s
.264 .412 .783 r
.6231 .6089 m .6332 .60371 L .60339 .61479 L p F P
0 0 0 r
s
.83 .24 .1 r
.62005 .61459 m
.64966 .63167 L
s
.5981 .63743 m
.62005 .61459 L
s
.538 .176 .08 r
.3668 .60371 m .3769 .6089 L .40435 .61878 L p F P
0 0 0 r
s
.538 .176 .08 r
.41203 .62274 m .40435 .61878 L .3769 .6089 L p F P
0 0 0 r
s
.24 .35 .67 r
.35034 .63167 m
.37995 .61459 L
s
.37995 .61459 m
.4019 .63743 L
s
.293 .442 .866 r
.50504 .6442 m .50757 .64287 L .5 .62969 L closepath p F P
0 0 0 r
s
.971 .291 .125 r
.5 .62969 m .49243 .64287 L .49496 .6442 L closepath p F P
0 0 0 r
s
.298 .454 .881 r
.52547 .63346 m .52289 .63481 L .54484 .63638 L p F P
0 0 0 r
s
.298 .454 .881 r
.54484 .63638 m .54995 .63373 L .52547 .63346 L p F P
0 0 0 r
s
.887 .271 .117 r
.45005 .63373 m .45516 .63638 L .47711 .63481 L p F P
0 0 0 r
s
.83 .24 .1 r
.45798 .63618 m
.45831 .63635 L
s
.887 .271 .117 r
.47968 .63616 m .47711 .63481 L .45516 .63638 L p F P
0 0 0 r
s
.542 .135 .052 r
.57714 .377 m .56219 .3667 L .55747 .35582 L p F P
0 0 0 r
s
.542 .135 .052 r
.54342 .34608 m .55747 .35582 L .56219 .3667 L p F P
0 0 0 r
s
.024 .035 .067 r
.44253 .35582 m .45658 .34608 L .45299 .35625 L p F P
0 0 0 r
s
.024 .035 .067 r
.45299 .35625 m .43781 .3667 L .44253 .35582 L p F P
0 0 0 r
s
.24 .35 .67 r
.83284 .40519 m
.83908 .43218 L
s
.83 .24 .1 r
.16716 .40519 m
.16092 .43218 L
s
.293 .442 .866 r
.50757 .64287 m .51011 .64153 L .5 .62969 L closepath p F P
0 0 0 r
s
.971 .291 .125 r
.5 .62969 m .48989 .64153 L .49243 .64287 L closepath p F P
0 0 0 r
s
.292 .449 .863 r
.56542 .62568 m .56024 .62838 L .58797 .62274 L p F P
0 0 0 r
s
.83 .24 .1 r
.57709 .6257 m
.5981 .63743 L
s
.292 .449 .863 r
.58797 .62274 m .59565 .61878 L .56542 .62568 L p F P
0 0 0 r
s
.742 .233 .103 r
.40435 .61878 m .41203 .62274 L .43976 .62838 L p F P
0 0 0 r
s
.83 .24 .1 r
.41382 .62319 m
.41425 .62319 L
s
.742 .233 .103 r
.44492 .63106 m .43976 .62838 L .41203 .62274 L p F P
0 0 0 r
s
.831 .224 .089 r
.62949 .44173 m .61423 .43146 L .61168 .41298 L p F P
0 0 0 r
s
.831 .224 .089 r
.5965 .40262 m .61168 .41298 L .61423 .43146 L p F P
0 0 0 r
s
.08 .105 .237 r
.38832 .41298 m .4035 .40262 L .40127 .42102 L p F P
0 0 0 r
s
.08 .105 .237 r
.40127 .42102 m .38577 .43146 L .38832 .41298 L p F P
0 0 0 r
s
.24 .35 .67 r
.38697 .43218 m
.38726 .43045 L
s
.293 .442 .866 r
.51011 .64153 m .51265 .6402 L .5 .62969 L closepath p F P
0 0 0 r
s
.971 .291 .125 r
.5 .62969 m .48735 .6402 L .48989 .64153 L closepath p F P
0 0 0 r
s
.298 .454 .881 r
.52805 .6321 m .52547 .63346 L .54995 .63373 L p F P
0 0 0 r
s
.298 .454 .881 r
.54995 .63373 m .55508 .63106 L .52805 .6321 L p F P
0 0 0 r
s
.887 .271 .117 r
.44492 .63106 m .45005 .63373 L .47453 .63346 L p F P
0 0 0 r
s
.83 .24 .1 r
.4532 .63369 m
.45354 .63387 L
s
.887 .271 .117 r
.47711 .63481 m .47453 .63346 L .45005 .63373 L p F P
0 0 0 r
s
.83 .24 .1 r
.28515 .22934 m
.26427 .24658 L
s
.24 .35 .67 r
.71485 .22934 m
.73573 .24658 L
s
.37444 .60694 m
.37528 .60811 L
s
.37054 .60152 m
.37428 .60671 L
s
.37528 .60811 m
.37995 .61459 L
s
.83 .24 .1 r
.62472 .60811 m
.62556 .60694 L
s
.62005 .61459 m
.62472 .60811 L
s
.293 .442 .866 r
.51265 .6402 m .5152 .63885 L .5 .62969 L closepath p F P
0 0 0 r
s
.971 .291 .125 r
.5 .62969 m .4848 .63885 L .48735 .6402 L closepath p F P
0 0 0 r
s
1 .304 .127 r
.6332 .60371 m .62428 .59847 L .64874 .58375 L p F P
0 0 0 r
s
.83 .24 .1 r
.62594 .60641 m
.62946 .60152 L
s
1 .304 .127 r
.63809 .57733 m .64874 .58375 L .62428 .59847 L p F P
0 0 0 r
s
1 .299 .124 r
.64874 .58375 m .63809 .57733 L .65711 .55962 L p F P
0 0 0 r
s
.24 .35 .67 r
.65191 .59263 m
.67228 .58217 L
s
.83 .24 .1 r
.6548 .55859 m
.65686 .55986 L
s
.229 .334 .674 r
.35126 .58375 m .36191 .57733 L .38472 .59319 L p F P
0 0 0 r
s
.229 .334 .674 r
.38472 .59319 m .37572 .59847 L .35126 .58375 L p F P
0 0 0 r
s
1 .299 .124 r
.64498 .55211 m .65711 .55962 L .63809 .57733 L p F P
0 0 0 r
s
1 .292 .121 r
.65711 .55962 m .64498 .55211 L .6587 .53225 L p F P
0 0 0 r
s
.213 .308 .627 r
.34289 .55962 m .35502 .55211 L .37268 .57083 L p F P
0 0 0 r
s
.213 .308 .627 r
.37268 .57083 m .36191 .57733 L .34289 .55962 L p F P
0 0 0 r
s
.916 .251 .101 r
.644 .47207 m .62904 .46217 L .62949 .44173 L p F P
0 0 0 r
s
.916 .251 .101 r
.61423 .43146 m .62949 .44173 L .62904 .46217 L p F P
0 0 0 r
s
.83 .24 .1 r
.61303 .43218 m
.61533 .43373 L
s
.116 .157 .342 r
.37051 .44173 m .38577 .43146 L .38617 .4521 L p F P
0 0 0 r
s
.24 .35 .67 r
.37055 .44323 m
.37165 .44249 L
s
.3858 .43298 m
.38697 .43218 L
s
.116 .157 .342 r
.38617 .4521 m .37096 .46217 L .37051 .44173 L p F P
0 0 0 r
s
.538 .176 .08 r
.40435 .61878 m .39661 .61479 L .3668 .60371 L p F P
0 0 0 r
s
1 .307 .128 r
.62428 .59847 m .6332 .60371 L .60339 .61479 L p F P
0 0 0 r
s
.24 .35 .67 r
.62515 .60438 m
.62589 .60412 L
s
.83 .24 .1 r
.61399 .61109 m
.62005 .61459 L
s
.244 .358 .718 r
.3668 .60371 m .37572 .59847 L .40363 .61077 L p F P
0 0 0 r
s
.244 .358 .718 r
.40363 .61077 m .39661 .61479 L .3668 .60371 L p F P
0 0 0 r
s
.83 .24 .1 r
.37411 .60412 m
.37485 .60438 L
s
.24 .35 .67 r
.37995 .61459 m
.38601 .61109 L
s
1 .292 .121 r
.64533 .52376 m .6587 .53225 L .64498 .55211 L p F P
0 0 0 r
s
1 .283 .116 r
.6587 .53225 m .64533 .52376 L .65406 .50267 L p F P
0 0 0 r
s
.194 .28 .573 r
.3413 .53225 m .35467 .52376 L .36732 .5445 L p F P
0 0 0 r
s
.194 .28 .573 r
.36732 .5445 m .35502 .55211 L .3413 .53225 L p F P
0 0 0 r
s
.971 .291 .125 r
.5 .62969 m .48224 .63751 L .4848 .63885 L closepath p F P
0 0 0 r
s
.293 .442 .866 r
.5152 .63885 m .51776 .63751 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .283 .116 r
.63974 .49337 m .65406 .50267 L .64533 .52376 L p F P
0 0 0 r
s
.971 .27 .11 r
.65406 .50267 m .63974 .49337 L .644 .47207 L p F P
0 0 0 r
s
.173 .246 .511 r
.34594 .50267 m .36026 .49337 L .36824 .51516 L p F P
0 0 0 r
s
.173 .246 .511 r
.36824 .51516 m .35467 .52376 L .34594 .50267 L p F P
0 0 0 r
s
.971 .27 .11 r
.62904 .46217 m .644 .47207 L .63974 .49337 L p F P
0 0 0 r
s
.148 .206 .436 r
.356 .47207 m .37096 .46217 L .37481 .48393 L p F P
0 0 0 r
s
.148 .206 .436 r
.37481 .48393 m .36026 .49337 L .356 .47207 L p F P
0 0 0 r
s
.298 .454 .881 r
.53064 .63073 m .52805 .6321 L .55508 .63106 L p F P
0 0 0 r
s
.83 .24 .1 r
.53113 .6316 m
.54379 .63847 L
s
.298 .454 .881 r
.55508 .63106 m .56024 .62838 L .53064 .63073 L p F P
0 0 0 r
s
.887 .271 .117 r
.43976 .62838 m .44492 .63106 L .47195 .6321 L p F P
0 0 0 r
s
.83 .24 .1 r
.4484 .63119 m
.44874 .63137 L
s
.887 .271 .117 r
.47453 .63346 m .47195 .6321 L .44492 .63106 L p F P
0 0 0 r
s
.36 .08 .033 r
.52916 .3362 m .51469 .32618 L .51311 .32229 L p F P
0 0 0 r
s
.36 .08 .033 r
.5 .31319 m .51311 .32229 L .51469 .32618 L p F P
0 0 0 r
s
.024 .035 .067 r
.48689 .32229 m .5 .31319 L .5 .316 L p F P
0 0 0 r
s
.83 .24 .1 r
.4985 .31413 m
.49866 .31424 L
s
.49455 .31139 m
.4985 .31413 L
s
.024 .035 .067 r
.5 .316 m .48531 .32618 L .48689 .32229 L p F P
0 0 0 r
s
.83 .24 .1 r
.5 .31517 m
.51033 .32233 L
s
.742 .233 .103 r
.39661 .61479 m .40435 .61878 L .43458 .62568 L p F P
0 0 0 r
s
.83 .24 .1 r
.4205 .62316 m
.42345 .62314 L
s
.742 .233 .103 r
.43976 .62838 m .43458 .62568 L .40435 .61878 L p F P
0 0 0 r
s
.24 .35 .67 r
.4019 .63743 m
.42291 .6257 L
s
.292 .449 .863 r
.57064 .62298 m .56542 .62568 L .59565 .61878 L p F P
0 0 0 r
s
.83 .24 .1 r
.57276 .62328 m
.57709 .6257 L
s
.292 .449 .863 r
.59565 .61878 m .60339 .61479 L .57064 .62298 L p F P
0 0 0 r
s
.293 .442 .866 r
.51776 .63751 m .52032 .63616 L .5 .62969 L closepath p F P
0 0 0 r
s
.971 .291 .125 r
.5 .62969 m .47968 .63616 L .48224 .63751 L closepath p F P
0 0 0 r
s
.698 .183 .07 r
.5965 .40262 m .58108 .3921 L .57714 .377 L p F P
0 0 0 r
s
.698 .183 .07 r
.56219 .3667 m .57714 .377 L .58108 .3921 L p F P
0 0 0 r
s
.043 .059 .127 r
.42286 .377 m .43781 .3667 L .43461 .3814 L p F P
0 0 0 r
s
.043 .059 .127 r
.43461 .3814 m .41892 .3921 L .42286 .377 L p F P
0 0 0 r
s
.24 .35 .67 r
.36062 .49314 m
.3612 .49595 L
s
.971 .291 .125 r
.5 .62969 m .47711 .63481 L .47968 .63616 L closepath p F P
0 0 0 r
s
.293 .442 .866 r
.52032 .63616 m .52289 .63481 L .5 .62969 L closepath p F P
0 0 0 r
s
.542 .135 .052 r
.56219 .3667 m .54701 .35625 L .54342 .34608 L p F P
0 0 0 r
s
.542 .135 .052 r
.52916 .3362 m .54342 .34608 L .54701 .35625 L p F P
0 0 0 r
s
.83 .24 .1 r
.52862 .33583 m
.53412 .34178 L
s
.024 .035 .067 r
.45658 .34608 m .47084 .3362 L .46841 .34563 L p F P
0 0 0 r
s
.24 .35 .67 r
.47077 .33649 m
.47138 .33583 L
s
.024 .035 .067 r
.46841 .34563 m .45299 .35625 L .45658 .34608 L p F P
0 0 0 r
s
.298 .454 .881 r
.53324 .62937 m .53064 .63073 L .56024 .62838 L p F P
0 0 0 r
s
.298 .454 .881 r
.56024 .62838 m .56542 .62568 L .53324 .62937 L p F P
0 0 0 r
s
.83 .24 .1 r
.54379 .63847 m
.55615 .62891 L
s
.55615 .62891 m
.55865 .62698 L
s
.887 .271 .117 r
.43458 .62568 m .43976 .62838 L .46936 .63073 L p F P
0 0 0 r
s
.83 .24 .1 r
.44357 .62868 m
.44391 .62886 L
s
.887 .271 .117 r
.47195 .6321 m .46936 .63073 L .43976 .62838 L p F P
0 0 0 r
s
.24 .35 .67 r
.44135 .62698 m
.44385 .62891 L
s
.44385 .62891 m
.45621 .63847 L
s
.45621 .63847 m
.46887 .6316 L
s
.971 .291 .125 r
.5 .62969 m .47453 .63346 L .47711 .63481 L closepath p F P
0 0 0 r
s
.293 .442 .866 r
.52289 .63481 m .52547 .63346 L .5 .62969 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.75645 .53361 m
.76392 .51703 L
s
.76392 .51703 m
.80099 .49768 L
s
.83 .24 .1 r
.19901 .49768 m
.23608 .51703 L
s
.23608 .51703 m
.24355 .53361 L
s
1 .307 .128 r
.60339 .61479 m .59637 .61077 L .62428 .59847 L p F P
0 0 0 r
s
1 .307 .128 r
.61528 .59319 m .62428 .59847 L .59637 .61077 L p F P
0 0 0 r
s
.24 .35 .67 r
.62103 .60584 m
.62515 .60438 L
s
.61417 .60937 m
.62103 .60584 L
s
1 .304 .127 r
.62428 .59847 m .61528 .59319 L .63809 .57733 L p F P
0 0 0 r
s
.244 .358 .718 r
.37572 .59847 m .38472 .59319 L .41071 .60672 L p F P
0 0 0 r
s
.244 .358 .718 r
.41071 .60672 m .40363 .61077 L .37572 .59847 L p F P
0 0 0 r
s
.83 .24 .1 r
.37897 .60584 m
.38583 .60937 L
s
.37485 .60438 m
.37897 .60584 L
s
.742 .233 .103 r
.43458 .62568 m .42936 .62298 L .39661 .61479 L p F P
0 0 0 r
s
.24 .35 .67 r
.42291 .6257 m
.42724 .62328 L
s
1 .308 .13 r
.59637 .61077 m .60339 .61479 L .57064 .62298 L p F P
0 0 0 r
s
.258 .381 .76 r
.39661 .61479 m .40363 .61077 L .43424 .62026 L p F P
0 0 0 r
s
.258 .381 .76 r
.43424 .62026 m .42936 .62298 L .39661 .61479 L p F P
0 0 0 r
s
.24 .35 .67 r
.80099 .49768 m
.80357 .47672 L
s
.80357 .47672 m
.84132 .45669 L
s
.83 .24 .1 r
.15868 .45669 m
.19643 .47672 L
s
.19643 .47672 m
.19901 .49768 L
s
.24 .35 .67 r
.7079 .56386 m
.72008 .5524 L
s
.72008 .5524 m
.75645 .53361 L
s
.83 .24 .1 r
.24355 .53361 m
.27992 .5524 L
s
.27992 .5524 m
.2921 .56386 L
s
1 .304 .127 r
.62732 .57083 m .63809 .57733 L .61528 .59319 L p F P
0 0 0 r
s
1 .299 .124 r
.63809 .57733 m .62732 .57083 L .64498 .55211 L p F P
0 0 0 r
s
.229 .334 .674 r
.36191 .57733 m .37268 .57083 L .39381 .58785 L p F P
0 0 0 r
s
.229 .334 .674 r
.39381 .58785 m .38472 .59319 L .36191 .57733 L p F P
0 0 0 r
s
.971 .291 .125 r
.5 .62969 m .47195 .6321 L .47453 .63346 L closepath p F P
0 0 0 r
s
.293 .442 .866 r
.52547 .63346 m .52805 .6321 L .5 .62969 L closepath p F P
0 0 0 r
s
.831 .224 .089 r
.61423 .43146 m .59873 .42102 L .5965 .40262 L p F P
0 0 0 r
s
.83 .24 .1 r
.61274 .43045 m
.61303 .43218 L
s
.831 .224 .089 r
.58108 .3921 m .5965 .40262 L .59873 .42102 L p F P
0 0 0 r
s
.08 .105 .237 r
.4035 .40262 m .41892 .3921 L .41704 .4104 L p F P
0 0 0 r
s
.08 .105 .237 r
.41704 .4104 m .40127 .42102 L .4035 .40262 L p F P
0 0 0 r
s
.298 .454 .881 r
.53584 .628 m .53324 .62937 L .56542 .62568 L p F P
0 0 0 r
s
.298 .454 .881 r
.56542 .62568 m .57064 .62298 L .53584 .628 L p F P
0 0 0 r
s
.24 .35 .67 r
.56614 .62363 m
.56716 .62309 L
s
.56716 .62309 m
.56973 .62311 L
s
.887 .271 .117 r
.42936 .62298 m .43458 .62568 L .46676 .62937 L p F P
0 0 0 r
s
.83 .24 .1 r
.43013 .62311 m
.43284 .62309 L
s
.43284 .62309 m
.4342 .6238 L
s
.43873 .62616 m
.43907 .62634 L
s
.887 .271 .117 r
.46936 .63073 m .46676 .62937 L .43458 .62568 L p F P
0 0 0 r
s
.24 .35 .67 r
.65584 .5879 m
.67228 .58217 L
s
.67228 .58217 m
.7079 .56386 L
s
.83 .24 .1 r
.2921 .56386 m
.32772 .58217 L
s
.32772 .58217 m
.34416 .5879 L
s
1 .299 .124 r
.63268 .5445 m .64498 .55211 L .62732 .57083 L p F P
0 0 0 r
s
1 .292 .121 r
.64498 .55211 m .63268 .5445 L .64533 .52376 L p F P
0 0 0 r
s
.213 .308 .627 r
.35502 .55211 m .36732 .5445 L .38357 .56426 L p F P
0 0 0 r
s
.24 .35 .67 r
.35526 .55236 m
.3554 .55227 L
s
.213 .308 .627 r
.38357 .56426 m .37268 .57083 L .35502 .55211 L p F P
0 0 0 r
s
.83 .24 .1 r
.43093 .6221 m
.43284 .62309 L
s
.34416 .5879 m
.37897 .60584 L
s
.971 .291 .125 r
.5 .62969 m .46936 .63073 L .47195 .6321 L closepath p F P
0 0 0 r
s
.293 .442 .866 r
.52805 .6321 m .53064 .63073 L .5 .62969 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.83908 .43218 m
.84132 .45669 L
s
.83 .24 .1 r
.16092 .43218 m
.15868 .45669 L
s
1 .292 .121 r
.63176 .51516 m .64533 .52376 L .63268 .5445 L p F P
0 0 0 r
s
1 .283 .116 r
.64533 .52376 m .63176 .51516 L .63974 .49337 L p F P
0 0 0 r
s
.83 .24 .1 r
.6388 .49595 m
.63948 .49262 L
s
.194 .28 .573 r
.35467 .52376 m .36824 .51516 L .37979 .53678 L p F P
0 0 0 r
s
.194 .28 .573 r
.37979 .53678 m .36732 .5445 L .35467 .52376 L p F P
0 0 0 r
s
.36 .08 .033 r
.51469 .32618 m .5 .316 L .5 .31319 L p F P
0 0 0 r
s
.24 .35 .67 r
.5015 .31413 m
.50545 .31139 L
s
.50134 .31424 m
.5015 .31413 L
s
.83 .24 .1 r
.41262 .25846 m
.39499 .25833 L
s
.3604 .23463 m
.39499 .25833 L
s
.24 .35 .67 r
.60501 .25833 m
.6396 .23463 L
s
.60501 .25833 m
.58738 .25846 L
s
.916 .251 .101 r
.62904 .46217 m .61383 .4521 L .61423 .43146 L p F P
0 0 0 r
s
.916 .251 .101 r
.59873 .42102 m .61423 .43146 L .61383 .4521 L p F P
0 0 0 r
s
.116 .157 .342 r
.38577 .43146 m .40127 .42102 L .40162 .44186 L p F P
0 0 0 r
s
.116 .157 .342 r
.40162 .44186 m .38617 .4521 L .38577 .43146 L p F P
0 0 0 r
s
.971 .291 .125 r
.5 .62969 m .46676 .62937 L .46936 .63073 L closepath p F P
0 0 0 r
s
.293 .442 .866 r
.53064 .63073 m .53324 .62937 L .5 .62969 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.3604 .23463 m
.34104 .24096 L
s
.30555 .21696 m
.34104 .24096 L
s
.24 .35 .67 r
.65896 .24096 m
.69445 .21696 L
s
.65896 .24096 m
.6396 .23463 L
s
1 .283 .116 r
.62519 .48393 m .63974 .49337 L .63176 .51516 L p F P
0 0 0 r
s
.971 .27 .11 r
.63974 .49337 m .62519 .48393 L .62904 .46217 L p F P
0 0 0 r
s
.173 .246 .511 r
.36026 .49337 m .37481 .48393 L .38201 .50642 L p F P
0 0 0 r
s
.173 .246 .511 r
.38201 .50642 m .36824 .51516 L .36026 .49337 L p F P
0 0 0 r
s
.887 .271 .117 r
.46676 .62937 m .46416 .628 L .42936 .62298 L p F P
0 0 0 r
s
1 .306 .13 r
.56576 .62026 m .57064 .62298 L .53584 .628 L p F P
0 0 0 r
s
1 .308 .13 r
.57064 .62298 m .56576 .62026 L .59637 .61077 L p F P
0 0 0 r
s
.271 .403 .799 r
.42936 .62298 m .43424 .62026 L .46668 .62663 L p F P
0 0 0 r
s
.24 .35 .67 r
.43716 .62374 m
.43774 .62419 L
s
.271 .403 .799 r
.46668 .62663 m .46416 .628 L .42936 .62298 L p F P
0 0 0 r
s
1 .308 .13 r
.58929 .60672 m .59637 .61077 L .56576 .62026 L p F P
0 0 0 r
s
1 .307 .128 r
.59637 .61077 m .58929 .60672 L .61528 .59319 L p F P
0 0 0 r
s
.258 .381 .76 r
.40363 .61077 m .41071 .60672 L .43915 .61752 L p F P
0 0 0 r
s
.258 .381 .76 r
.43915 .61752 m .43424 .62026 L .40363 .61077 L p F P
0 0 0 r
s
.83 .24 .1 r
.42233 .61763 m
.42703 .62007 L
s
.971 .27 .11 r
.61383 .4521 m .62904 .46217 L .62519 .48393 L p F P
0 0 0 r
s
.148 .206 .436 r
.37096 .46217 m .38617 .4521 L .38959 .47434 L p F P
0 0 0 r
s
.148 .206 .436 r
.38959 .47434 m .37481 .48393 L .37096 .46217 L p F P
0 0 0 r
s
.83 .24 .1 r
.46155 .28851 m
.44638 .28179 L
s
.41262 .25846 m
.44638 .28179 L
s
.24 .35 .67 r
.55362 .28179 m
.58738 .25846 L
s
.55362 .28179 m
.53845 .28851 L
s
.971 .291 .125 r
.5 .62969 m .46416 .628 L .46676 .62937 L closepath p F P
0 0 0 r
s
.293 .442 .866 r
.53324 .62937 m .53584 .628 L .5 .62969 L closepath p F P
0 0 0 r
s
.244 .358 .718 r
.38472 .59319 m .39381 .58785 L .41784 .60264 L p F P
0 0 0 r
s
.244 .358 .718 r
.41784 .60264 m .41071 .60672 L .38472 .59319 L p F P
0 0 0 r
s
.83 .24 .1 r
.37897 .60584 m
.39893 .60545 L
s
1 .307 .128 r
.60619 .58785 m .61528 .59319 L .58929 .60672 L p F P
0 0 0 r
s
1 .304 .127 r
.61528 .59319 m .60619 .58785 L .62732 .57083 L p F P
0 0 0 r
s
.24 .35 .67 r
.62103 .60584 m
.65584 .5879 L
s
.698 .183 .07 r
.58108 .3921 m .56539 .3814 L .56219 .3667 L p F P
0 0 0 r
s
.698 .183 .07 r
.54701 .35625 m .56219 .3667 L .56539 .3814 L p F P
0 0 0 r
s
.043 .059 .127 r
.43781 .3667 m .45299 .35625 L .45055 .37053 L p F P
0 0 0 r
s
.043 .059 .127 r
.45055 .37053 m .43461 .3814 L .43781 .3667 L p F P
0 0 0 r
s
.24 .35 .67 r
.50545 .31139 m
.53845 .28851 L
s
.50158 .31564 m
.50545 .31139 L
s
.83 .24 .1 r
.49455 .31139 m
.49842 .31564 L
s
.46155 .28851 m
.49455 .31139 L
s
.30555 .21696 m
.28515 .22934 L
s
.24 .35 .67 r
.69445 .21696 m
.71485 .22934 L
s
.542 .135 .052 r
.54701 .35625 m .53159 .34563 L .52916 .3362 L p F P
0 0 0 r
s
.542 .135 .052 r
.51469 .32618 m .52916 .3362 L .53159 .34563 L p F P
0 0 0 r
s
.024 .035 .067 r
.47084 .3362 m .48531 .32618 L .48408 .33484 L p F P
0 0 0 r
s
.024 .035 .067 r
.48408 .33484 m .46841 .34563 L .47084 .3362 L p F P
0 0 0 r
s
1 .302 .128 r
.53332 .62663 m .53584 .628 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .306 .13 r
.53584 .628 m .53332 .62663 L .56576 .62026 L p F P
0 0 0 r
s
.283 .424 .835 r
.5 .62969 m .46416 .628 L .46668 .62663 L closepath p F P
0 0 0 r
s
1 .306 .13 r
.56085 .61752 m .56576 .62026 L .53332 .62663 L p F P
0 0 0 r
s
1 .308 .13 r
.56576 .62026 m .56085 .61752 L .58929 .60672 L p F P
0 0 0 r
s
.24 .35 .67 r
.57297 .62007 m
.57767 .61763 L
s
.271 .403 .799 r
.43424 .62026 m .43915 .61752 L .4692 .62525 L p F P
0 0 0 r
s
.271 .403 .799 r
.4692 .62525 m .46668 .62663 L .43424 .62026 L p F P
0 0 0 r
s
1 .304 .127 r
.61643 .56426 m .62732 .57083 L .60619 .58785 L p F P
0 0 0 r
s
1 .299 .124 r
.62732 .57083 m .61643 .56426 L .63268 .5445 L p F P
0 0 0 r
s
.229 .334 .674 r
.37268 .57083 m .38357 .56426 L .403 .58246 L p F P
0 0 0 r
s
.229 .334 .674 r
.403 .58246 m .39381 .58785 L .37268 .57083 L p F P
0 0 0 r
s
.283 .424 .835 r
.5 .62969 m .48705 .61552 L .48963 .61411 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.49662 .62938 m
.4987 .62827 L
s
.283 .424 .835 r
.5 .62969 m .48963 .61411 L .49221 .6127 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.49871 .62688 m
.50338 .62938 L
s
.283 .424 .835 r
.5 .62969 m .49221 .6127 L .4948 .61129 L closepath p F P
0 0 0 r
s
.283 .424 .835 r
.5 .62969 m .4948 .61129 L .4974 .60988 L closepath p F P
0 0 0 r
s
.283 .424 .835 r
.5 .62969 m .4974 .60988 L .5 .60846 L closepath p F P
0 0 0 r
s
1 .302 .128 r
.5308 .62525 m .53332 .62663 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .302 .128 r
.52827 .62387 m .5308 .62525 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .302 .128 r
.52573 .62249 m .52827 .62387 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .302 .128 r
.52319 .6211 m .52573 .62249 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .302 .128 r
.52064 .61971 m .52319 .6211 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .302 .128 r
.51808 .61832 m .52064 .61971 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .302 .128 r
.51552 .61692 m .51808 .61832 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .302 .128 r
.51295 .61552 m .51552 .61692 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .302 .128 r
.51037 .61411 m .51295 .61552 L .5 .62969 L closepath p F P
0 0 0 r
s
.283 .424 .835 r
.5 .62969 m .46668 .62663 L .4692 .62525 L closepath p F P
0 0 0 r
s
.283 .424 .835 r
.5 .62969 m .4692 .62525 L .47173 .62387 L closepath p F P
0 0 0 r
s
.283 .424 .835 r
.5 .62969 m .47173 .62387 L .47427 .62249 L closepath p F P
0 0 0 r
s
.283 .424 .835 r
.5 .62969 m .47427 .62249 L .47681 .6211 L closepath p F P
0 0 0 r
s
.283 .424 .835 r
.5 .62969 m .47681 .6211 L .47936 .61971 L closepath p F P
0 0 0 r
s
.283 .424 .835 r
.5 .62969 m .47936 .61971 L .48192 .61832 L closepath p F P
0 0 0 r
s
.283 .424 .835 r
.5 .62969 m .48192 .61832 L .48448 .61692 L closepath p F P
0 0 0 r
s
.283 .424 .835 r
.5 .62969 m .48448 .61692 L .48705 .61552 L closepath p F P
0 0 0 r
s
1 .302 .128 r
.50779 .6127 m .51037 .61411 L .5 .62969 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.5 .62757 m
.50129 .62688 L
s
1 .302 .128 r
.5052 .61129 m .50779 .6127 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .302 .128 r
.5026 .60988 m .5052 .61129 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .302 .128 r
.5 .60846 m .5026 .60988 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .306 .13 r
.53332 .62663 m .5308 .62525 L .56085 .61752 L p F P
0 0 0 r
s
1 .308 .13 r
.58216 .60264 m .58929 .60672 L .56085 .61752 L p F P
0 0 0 r
s
1 .307 .128 r
.58929 .60672 m .58216 .60264 L .60619 .58785 L p F P
0 0 0 r
s
.24 .35 .67 r
.60107 .60545 m
.62103 .60584 L
s
.258 .381 .76 r
.41071 .60672 m .41784 .60264 L .44407 .61477 L p F P
0 0 0 r
s
.24 .35 .67 r
.42251 .60957 m
.42493 .61212 L
s
.258 .381 .76 r
.44407 .61477 m .43915 .61752 L .41071 .60672 L p F P
0 0 0 r
s
1 .299 .124 r
.62021 .53678 m .63268 .5445 L .61643 .56426 L p F P
0 0 0 r
s
1 .292 .121 r
.63268 .5445 m .62021 .53678 L .63176 .51516 L p F P
0 0 0 r
s
.213 .308 .627 r
.36732 .5445 m .37979 .53678 L .3946 .55761 L p F P
0 0 0 r
s
.24 .35 .67 r
.36754 .54476 m
.36768 .54467 L
s
.213 .308 .627 r
.3946 .55761 m .38357 .56426 L .36732 .5445 L p F P
0 0 0 r
s
.271 .403 .799 r
.47173 .62387 m .4692 .62525 L .43915 .61752 L p F P
0 0 0 r
s
.83 .24 .1 r
.441 .62068 m
.44337 .61998 L
s
1 .306 .13 r
.5308 .62525 m .52827 .62387 L .55593 .61477 L p F P
0 0 0 r
s
1 .306 .13 r
.55593 .61477 m .56085 .61752 L .5308 .62525 L p F P
0 0 0 r
s
1 .308 .13 r
.56085 .61752 m .55593 .61477 L .58216 .60264 L p F P
0 0 0 r
s
.24 .35 .67 r
.55663 .61998 m
.559 .62068 L
s
.271 .403 .799 r
.43915 .61752 m .44407 .61477 L .47173 .62387 L p F P
0 0 0 r
s
.831 .224 .089 r
.59873 .42102 m .58296 .4104 L .58108 .3921 L p F P
0 0 0 r
s
.831 .224 .089 r
.56539 .3814 m .58108 .3921 L .58296 .4104 L p F P
0 0 0 r
s
.08 .105 .237 r
.41892 .3921 m .43461 .3814 L .43307 .39961 L p F P
0 0 0 r
s
.08 .105 .237 r
.43307 .39961 m .41704 .4104 L .41892 .3921 L p F P
0 0 0 r
s
.24 .35 .67 r
.41793 .41137 m
.41819 .40963 L
s
.244 .358 .718 r
.39381 .58785 m .403 .58246 L .42503 .59853 L p F P
0 0 0 r
s
.244 .358 .718 r
.42503 .59853 m .41784 .60264 L .39381 .58785 L p F P
0 0 0 r
s
1 .307 .128 r
.597 .58246 m .60619 .58785 L .58216 .60264 L p F P
0 0 0 r
s
1 .304 .127 r
.60619 .58785 m .597 .58246 L .61643 .56426 L p F P
0 0 0 r
s
1 .306 .13 r
.52827 .62387 m .52573 .62249 L .55097 .61201 L p F P
0 0 0 r
s
1 .306 .13 r
.55097 .61201 m .55593 .61477 L .52827 .62387 L p F P
0 0 0 r
s
.271 .403 .799 r
.47427 .62249 m .47173 .62387 L .44407 .61477 L p F P
0 0 0 r
s
1 .292 .121 r
.61799 .50642 m .63176 .51516 L .62021 .53678 L p F P
0 0 0 r
s
1 .283 .116 r
.63176 .51516 m .61799 .50642 L .62519 .48393 L p F P
0 0 0 r
s
.194 .28 .573 r
.36824 .51516 m .38201 .50642 L .39242 .52897 L p F P
0 0 0 r
s
.194 .28 .573 r
.39242 .52897 m .37979 .53678 L .36824 .51516 L p F P
0 0 0 r
s
1 .306 .13 r
.52573 .62249 m .52319 .6211 L .54599 .60923 L p F P
0 0 0 r
s
1 .306 .13 r
.54599 .60923 m .55097 .61201 L .52573 .62249 L p F P
0 0 0 r
s
.271 .403 .799 r
.44407 .61477 m .44903 .61201 L .47427 .62249 L p F P
0 0 0 r
s
.271 .403 .799 r
.47681 .6211 m .47427 .62249 L .44903 .61201 L p F P
0 0 0 r
s
1 .308 .13 r
.57497 .59853 m .58216 .60264 L .55593 .61477 L p F P
0 0 0 r
s
.24 .35 .67 r
.57767 .61763 m
.60107 .60545 L
s
1 .307 .128 r
.58216 .60264 m .57497 .59853 L .597 .58246 L p F P
0 0 0 r
s
.258 .381 .76 r
.41784 .60264 m .42503 .59853 L .44903 .61201 L p F P
0 0 0 r
s
.258 .381 .76 r
.44903 .61201 m .44407 .61477 L .41784 .60264 L p F P
0 0 0 r
s
.83 .24 .1 r
.39893 .60545 m
.42233 .61763 L
s
1 .308 .13 r
.55593 .61477 m .55097 .61201 L .57497 .59853 L p F P
0 0 0 r
s
.916 .251 .101 r
.61383 .4521 m .59838 .44186 L .59873 .42102 L p F P
0 0 0 r
s
.916 .251 .101 r
.58296 .4104 m .59873 .42102 L .59838 .44186 L p F P
0 0 0 r
s
.83 .24 .1 r
.58207 .41137 m
.5841 .41273 L
s
.116 .157 .342 r
.40127 .42102 m .41704 .4104 L .41734 .43146 L p F P
0 0 0 r
s
.24 .35 .67 r
.4013 .42255 m
.40245 .42178 L
s
.41706 .41195 m
.41793 .41137 L
s
.116 .157 .342 r
.41734 .43146 m .40162 .44186 L .40127 .42102 L p F P
0 0 0 r
s
1 .283 .116 r
.61041 .47434 m .62519 .48393 L .61799 .50642 L p F P
0 0 0 r
s
.971 .27 .11 r
.62519 .48393 m .61041 .47434 L .61383 .4521 L p F P
0 0 0 r
s
.173 .246 .511 r
.37481 .48393 m .38959 .47434 L .39599 .49755 L p F P
0 0 0 r
s
.173 .246 .511 r
.39599 .49755 m .38201 .50642 L .37481 .48393 L p F P
0 0 0 r
s
.971 .27 .11 r
.59838 .44186 m .61383 .4521 L .61041 .47434 L p F P
0 0 0 r
s
.148 .206 .436 r
.38617 .4521 m .40162 .44186 L .4046 .46459 L p F P
0 0 0 r
s
.148 .206 .436 r
.4046 .46459 m .38959 .47434 L .38617 .4521 L p F P
0 0 0 r
s
1 .304 .127 r
.6054 .55761 m .61643 .56426 L .597 .58246 L p F P
0 0 0 r
s
.83 .24 .1 r
.61299 .56219 m
.61802 .55272 L
s
1 .299 .124 r
.61643 .56426 m .6054 .55761 L .62021 .53678 L p F P
0 0 0 r
s
.229 .334 .674 r
.38357 .56426 m .3946 .55761 L .41227 .57701 L p F P
0 0 0 r
s
.229 .334 .674 r
.41227 .57701 m .403 .58246 L .38357 .56426 L p F P
0 0 0 r
s
.271 .403 .799 r
.44903 .61201 m .45401 .60923 L .47681 .6211 L p F P
0 0 0 r
s
.271 .403 .799 r
.47936 .61971 m .47681 .6211 L .45401 .60923 L p F P
0 0 0 r
s
1 .306 .13 r
.52319 .6211 m .52064 .61971 L .54099 .60644 L p F P
0 0 0 r
s
1 .306 .13 r
.54099 .60644 m .54599 .60923 L .52319 .6211 L p F P
0 0 0 r
s
.24 .35 .67 r
.54471 .61645 m
.55663 .61998 L
s
.698 .183 .07 r
.56539 .3814 m .54945 .37053 L .54701 .35625 L p F P
0 0 0 r
s
.698 .183 .07 r
.53159 .34563 m .54701 .35625 L .54945 .37053 L p F P
0 0 0 r
s
.043 .059 .127 r
.45299 .35625 m .46841 .34563 L .46675 .35947 L p F P
0 0 0 r
s
.043 .059 .127 r
.46675 .35947 m .45055 .37053 L .45299 .35625 L p F P
0 0 0 r
s
.542 .135 .052 r
.53159 .34563 m .51592 .33484 L .51469 .32618 L p F P
0 0 0 r
s
.542 .135 .052 r
.5 .316 m .51469 .32618 L .51592 .33484 L p F P
0 0 0 r
s
.024 .035 .067 r
.48531 .32618 m .5 .316 L .5 .32387 L p F P
0 0 0 r
s
.24 .35 .67 r
.5 .31738 m
.5006 .31672 L
s
.024 .035 .067 r
.5 .32387 m .48408 .33484 L .48531 .32618 L p F P
0 0 0 r
s
.271 .403 .799 r
.45401 .60923 m .45901 .60644 L .47936 .61971 L p F P
0 0 0 r
s
.83 .24 .1 r
.44337 .61998 m
.45529 .61645 L
s
.271 .403 .799 r
.48192 .61832 m .47936 .61971 L .45901 .60644 L p F P
0 0 0 r
s
1 .306 .13 r
.52064 .61971 m .51808 .61832 L .53596 .60363 L p F P
0 0 0 r
s
1 .306 .13 r
.53596 .60363 m .54099 .60644 L .52064 .61971 L p F P
0 0 0 r
s
1 .308 .13 r
.55097 .61201 m .54599 .60923 L .56773 .59439 L p F P
0 0 0 r
s
.83 .24 .1 r
.55153 .61142 m
.55177 .61156 L
s
1 .308 .13 r
.56773 .59439 m .57497 .59853 L .55097 .61201 L p F P
0 0 0 r
s
.258 .381 .76 r
.45401 .60923 m .44903 .61201 L .42503 .59853 L p F P
0 0 0 r
s
1 .307 .128 r
.58773 .57701 m .597 .58246 L .57497 .59853 L p F P
0 0 0 r
s
1 .304 .127 r
.597 .58246 m .58773 .57701 L .6054 .55761 L p F P
0 0 0 r
s
.244 .358 .718 r
.403 .58246 m .41227 .57701 L .43227 .59439 L p F P
0 0 0 r
s
.244 .358 .718 r
.43227 .59439 m .42503 .59853 L .403 .58246 L p F P
0 0 0 r
s
1 .299 .124 r
.60758 .52897 m .62021 .53678 L .6054 .55761 L p F P
0 0 0 r
s
1 .292 .121 r
.62021 .53678 m .60758 .52897 L .61799 .50642 L p F P
0 0 0 r
s
.213 .308 .627 r
.37979 .53678 m .39242 .52897 L .40575 .55089 L p F P
0 0 0 r
s
.24 .35 .67 r
.37998 .53706 m
.38013 .53697 L
s
.213 .308 .627 r
.40575 .55089 m .3946 .55761 L .37979 .53678 L p F P
0 0 0 r
s
1 .306 .13 r
.51808 .61832 m .51552 .61692 L .5309 .60081 L p F P
0 0 0 r
s
1 .306 .13 r
.5309 .60081 m .53596 .60363 L .51808 .61832 L p F P
0 0 0 r
s
.83 .24 .1 r
.5349 .60304 m
.53557 .60251 L
s
.24 .35 .67 r
.53137 .62351 m
.54471 .61645 L
s
.271 .403 .799 r
.45901 .60644 m .46404 .60363 L .48192 .61832 L p F P
0 0 0 r
s
.271 .403 .799 r
.48448 .61692 m .48192 .61832 L .46404 .60363 L p F P
0 0 0 r
s
.83 .24 .1 r
.45529 .61645 m
.46863 .62351 L
s
1 .307 .128 r
.57497 .59853 m .56773 .59439 L .58773 .57701 L p F P
0 0 0 r
s
.258 .381 .76 r
.42503 .59853 m .43227 .59439 L .45401 .60923 L p F P
0 0 0 r
s
.24 .35 .67 r
.79405 .5142 m
.80099 .49768 L
s
.80099 .49768 m
.83931 .47767 L
s
.83 .24 .1 r
.16069 .47767 m
.19901 .49768 L
s
.19901 .49768 m
.20595 .5142 L
s
.24 .35 .67 r
.54471 .61645 m
.54689 .6153 L
s
.83 .24 .1 r
.45311 .6153 m
.45529 .61645 L
s
.271 .403 .799 r
.46404 .60363 m .4691 .60081 L .48448 .61692 L p F P
0 0 0 r
s
.24 .35 .67 r
.46443 .60251 m
.4651 .60304 L
s
.271 .403 .799 r
.48705 .61552 m .48448 .61692 L .4691 .60081 L p F P
0 0 0 r
s
1 .306 .13 r
.51552 .61692 m .51295 .61552 L .52582 .59797 L p F P
0 0 0 r
s
1 .306 .13 r
.52582 .59797 m .5309 .60081 L .51552 .61692 L p F P
0 0 0 r
s
1 .308 .13 r
.54599 .60923 m .54099 .60644 L .56043 .59022 L p F P
0 0 0 r
s
.83 .24 .1 r
.54647 .6086 m
.54671 .60874 L
s
1 .308 .13 r
.56043 .59022 m .56773 .59439 L .54599 .60923 L p F P
0 0 0 r
s
.258 .381 .76 r
.45901 .60644 m .45401 .60923 L .43227 .59439 L p F P
0 0 0 r
s
.24 .35 .67 r
.84132 .45669 m
.83931 .47767 L
s
.83 .24 .1 r
.15868 .45669 m
.16069 .47767 L
s
.24 .35 .67 r
.74473 .54493 m
.75645 .53361 L
s
.75645 .53361 m
.79405 .5142 L
s
.83 .24 .1 r
.20595 .5142 m
.24355 .53361 L
s
.24355 .53361 m
.25527 .54493 L
s
.831 .224 .089 r
.58296 .4104 m .56693 .39961 L .56539 .3814 L p F P
0 0 0 r
s
.83 .24 .1 r
.58181 .40963 m
.58207 .41137 L
s
.831 .224 .089 r
.54945 .37053 m .56539 .3814 L .56693 .39961 L p F P
0 0 0 r
s
.08 .105 .237 r
.43461 .3814 m .45055 .37053 L .44938 .38863 L p F P
0 0 0 r
s
.08 .105 .237 r
.44938 .38863 m .43307 .39961 L .43461 .3814 L p F P
0 0 0 r
s
1 .292 .121 r
.60401 .49755 m .61799 .50642 L .60758 .52897 L p F P
0 0 0 r
s
1 .283 .116 r
.61799 .50642 m .60401 .49755 L .61041 .47434 L p F P
0 0 0 r
s
.194 .28 .573 r
.38201 .50642 m .39599 .49755 L .40522 .52104 L p F P
0 0 0 r
s
.194 .28 .573 r
.40522 .52104 m .39242 .52897 L .38201 .50642 L p F P
0 0 0 r
s
.271 .403 .799 r
.4691 .60081 m .47418 .59797 L .48705 .61552 L p F P
0 0 0 r
s
.271 .403 .799 r
.48963 .61411 m .48705 .61552 L .47418 .59797 L p F P
0 0 0 r
s
1 .306 .13 r
.51295 .61552 m .51037 .61411 L .52071 .59512 L p F P
0 0 0 r
s
1 .306 .13 r
.52071 .59512 m .52582 .59797 L .51295 .61552 L p F P
0 0 0 r
s
.24 .35 .67 r
.69182 .56936 m
.7079 .56386 L
s
.7079 .56386 m
.74473 .54493 L
s
.83 .24 .1 r
.25527 .54493 m
.2921 .56386 L
s
.2921 .56386 m
.30818 .56936 L
s
1 .304 .127 r
.59425 .55089 m .6054 .55761 L .58773 .57701 L p F P
0 0 0 r
s
1 .299 .124 r
.6054 .55761 m .59425 .55089 L .60758 .52897 L p F P
0 0 0 r
s
.229 .334 .674 r
.3946 .55761 m .40575 .55089 L .42163 .57152 L p F P
0 0 0 r
s
.229 .334 .674 r
.42163 .57152 m .41227 .57701 L .3946 .55761 L p F P
0 0 0 r
s
.24 .35 .67 r
.57874 .59844 m
.60107 .60545 L
s
.60107 .60545 m
.63612 .58721 L
s
.83 .24 .1 r
.36388 .58721 m
.39893 .60545 L
s
.39893 .60545 m
.42126 .59844 L
s
.24 .35 .67 r
.63612 .58721 m
.65584 .5879 L
s
.65584 .5879 m
.69182 .56936 L
s
.83 .24 .1 r
.30818 .56936 m
.34416 .5879 L
s
.34416 .5879 m
.36388 .58721 L
s
1 .307 .128 r
.56773 .59439 m .56043 .59022 L .57837 .57152 L p F P
0 0 0 r
s
1 .307 .128 r
.57837 .57152 m .58773 .57701 L .56773 .59439 L p F P
0 0 0 r
s
.244 .358 .718 r
.43957 .59022 m .43227 .59439 L .41227 .57701 L p F P
0 0 0 r
s
.258 .381 .76 r
.43227 .59439 m .43957 .59022 L .45901 .60644 L p F P
0 0 0 r
s
1 .306 .13 r
.51037 .61411 m .50779 .6127 L .51557 .59226 L p F P
0 0 0 r
s
1 .306 .13 r
.51557 .59226 m .52071 .59512 L .51037 .61411 L p F P
0 0 0 r
s
.271 .403 .799 r
.47418 .59797 m .47929 .59512 L .48963 .61411 L p F P
0 0 0 r
s
.271 .403 .799 r
.49221 .6127 m .48963 .61411 L .47929 .59512 L p F P
0 0 0 r
s
1 .308 .13 r
.54099 .60644 m .53596 .60363 L .55308 .58601 L p F P
0 0 0 r
s
.83 .24 .1 r
.53557 .60251 m
.53652 .60305 L
s
.54139 .60576 m
.54163 .6059 L
s
1 .308 .13 r
.55308 .58601 m .56043 .59022 L .54099 .60644 L p F P
0 0 0 r
s
.258 .381 .76 r
.46404 .60363 m .45901 .60644 L .43957 .59022 L p F P
0 0 0 r
s
.24 .35 .67 r
.46323 .60318 m
.46443 .60251 L
s
1 .304 .127 r
.58773 .57701 m .57837 .57152 L .59425 .55089 L p F P
0 0 0 r
s
.244 .358 .718 r
.41227 .57701 m .42163 .57152 L .43957 .59022 L p F P
0 0 0 r
s
1 .283 .116 r
.5954 .46459 m .61041 .47434 L .60401 .49755 L p F P
0 0 0 r
s
.83 .24 .1 r
.60889 .47335 m
.60932 .47138 L
s
.971 .27 .11 r
.61041 .47434 m .5954 .46459 L .59838 .44186 L p F P
0 0 0 r
s
.173 .246 .511 r
.38959 .47434 m .4046 .46459 L .41017 .48855 L p F P
0 0 0 r
s
.173 .246 .511 r
.41017 .48855 m .39599 .49755 L .38959 .47434 L p F P
0 0 0 r
s
.83 .24 .1 r
.37773 .23433 m
.3604 .23463 L
s
.32466 .21012 m
.3604 .23463 L
s
.24 .35 .67 r
.6396 .23463 m
.67534 .21012 L
s
.6396 .23463 m
.62227 .23433 L
s
.916 .251 .101 r
.59838 .44186 m .58266 .43146 L .58296 .4104 L p F P
0 0 0 r
s
.916 .251 .101 r
.56693 .39961 m .58296 .4104 L .58266 .43146 L p F P
0 0 0 r
s
.116 .157 .342 r
.41704 .4104 m .43307 .39961 L .43331 .42088 L p F P
0 0 0 r
s
.24 .35 .67 r
.41793 .41137 m
.41823 .41117 L
s
.116 .157 .342 r
.43331 .42088 m .41734 .43146 L .41704 .4104 L p F P
0 0 0 r
s
.83 .24 .1 r
.32466 .21012 m
.30555 .21696 L
s
.24 .35 .67 r
.67534 .21012 m
.69445 .21696 L
s
.271 .403 .799 r
.47929 .59512 m .48443 .59226 L .49221 .6127 L p F P
0 0 0 r
s
.271 .403 .799 r
.4948 .61129 m .49221 .6127 L .48443 .59226 L p F P
0 0 0 r
s
1 .306 .13 r
.50779 .6127 m .5052 .61129 L .51041 .58938 L p F P
0 0 0 r
s
1 .306 .13 r
.51041 .58938 m .51557 .59226 L .50779 .6127 L p F P
0 0 0 r
s
.24 .35 .67 r
.51078 .60888 m
.52101 .60333 L
s
.971 .27 .11 r
.58266 .43146 m .59838 .44186 L .5954 .46459 L p F P
0 0 0 r
s
.148 .206 .436 r
.40162 .44186 m .41734 .43146 L .41986 .45469 L p F P
0 0 0 r
s
.148 .206 .436 r
.41986 .45469 m .4046 .46459 L .40162 .44186 L p F P
0 0 0 r
s
.83 .24 .1 r
.42744 .26487 m
.41262 .25846 L
s
.37773 .23433 m
.41262 .25846 L
s
.24 .35 .67 r
.58738 .25846 m
.62227 .23433 L
s
.58738 .25846 m
.57256 .26487 L
s
.542 .135 .052 r
.51592 .33484 m .5 .32387 L .5 .316 L p F P
0 0 0 r
s
.698 .183 .07 r
.54945 .37053 m .53325 .35947 L .53159 .34563 L p F P
0 0 0 r
s
.698 .183 .07 r
.51592 .33484 m .53159 .34563 L .53325 .35947 L p F P
0 0 0 r
s
.043 .059 .127 r
.46841 .34563 m .48408 .33484 L .48324 .34822 L p F P
0 0 0 r
s
.043 .059 .127 r
.48324 .34822 m .46675 .35947 L .46841 .34563 L p F P
0 0 0 r
s
.24 .35 .67 r
.53845 .28851 m
.57256 .26487 L
s
.53845 .28851 m
.52687 .30147 L
s
.83 .24 .1 r
.47313 .30147 m
.46155 .28851 L
s
.42744 .26487 m
.46155 .28851 L
s
.271 .403 .799 r
.48443 .59226 m .48959 .58938 L .4948 .61129 L p F P
0 0 0 r
s
.83 .24 .1 r
.47899 .60333 m
.48922 .60888 L
s
.271 .403 .799 r
.4974 .60988 m .4948 .61129 L .48959 .58938 L p F P
0 0 0 r
s
1 .306 .13 r
.5052 .61129 m .5026 .60988 L .50522 .58648 L p F P
0 0 0 r
s
1 .306 .13 r
.50522 .58648 m .51041 .58938 L .5052 .61129 L p F P
0 0 0 r
s
.24 .35 .67 r
.50767 .61056 m
.51078 .60888 L
s
1 .299 .124 r
.59478 .52104 m .60758 .52897 L .59425 .55089 L p F P
0 0 0 r
s
1 .292 .121 r
.60758 .52897 m .59478 .52104 L .60401 .49755 L p F P
0 0 0 r
s
.213 .308 .627 r
.39242 .52897 m .40522 .52104 L .41704 .54408 L p F P
0 0 0 r
s
.24 .35 .67 r
.3926 .52926 m
.39275 .52917 L
s
.213 .308 .627 r
.41704 .54408 m .40575 .55089 L .39242 .52897 L p F P
0 0 0 r
s
1 .308 .13 r
.53596 .60363 m .5309 .60081 L .54567 .58178 L p F P
0 0 0 r
s
1 .308 .13 r
.54567 .58178 m .55308 .58601 L .53596 .60363 L p F P
0 0 0 r
s
.24 .35 .67 r
.52101 .60333 m
.54471 .61645 L
s
.54689 .6153 m
.57874 .59844 L
s
.258 .381 .76 r
.43957 .59022 m .44692 .58601 L .46404 .60363 L p F P
0 0 0 r
s
.258 .381 .76 r
.4691 .60081 m .46404 .60363 L .44692 .58601 L p F P
0 0 0 r
s
.83 .24 .1 r
.45529 .61645 m
.47899 .60333 L
s
.24 .35 .67 r
.50092 .31939 m
.52687 .30147 L
s
.83 .24 .1 r
.47313 .30147 m
.49908 .31939 L
s
1 .307 .128 r
.56043 .59022 m .55308 .58601 L .56891 .56596 L p F P
0 0 0 r
s
1 .307 .128 r
.56891 .56596 m .57837 .57152 L .56043 .59022 L p F P
0 0 0 r
s
.244 .358 .718 r
.44692 .58601 m .43957 .59022 L .42163 .57152 L p F P
0 0 0 r
s
.271 .403 .799 r
.48959 .58938 m .49478 .58648 L .4974 .60988 L p F P
0 0 0 r
s
.83 .24 .1 r
.48922 .60888 m
.49233 .61056 L
s
.271 .403 .799 r
.5 .60846 m .4974 .60988 L .49478 .58648 L p F P
0 0 0 r
s
1 .306 .13 r
.5026 .60988 m .5 .60846 L .5 .58357 L p F P
0 0 0 r
s
1 .306 .13 r
.5 .58357 m .50522 .58648 L .5026 .60988 L p F P
0 0 0 r
s
1 .304 .127 r
.58296 .54408 m .59425 .55089 L .57837 .57152 L p F P
0 0 0 r
s
1 .299 .124 r
.59425 .55089 m .58296 .54408 L .59478 .52104 L p F P
0 0 0 r
s
.229 .334 .674 r
.40575 .55089 m .41704 .54408 L .43109 .56596 L p F P
0 0 0 r
s
.229 .334 .674 r
.43109 .56596 m .42163 .57152 L .40575 .55089 L p F P
0 0 0 r
s
.24 .35 .67 r
.42171 .55136 m
.42235 .55098 L
s
.271 .403 .799 r
.49478 .58648 m .5 .58357 L .5 .60846 L p F P
0 0 0 r
s
1 .304 .127 r
.57837 .57152 m .56891 .56596 L .58296 .54408 L p F P
0 0 0 r
s
.83 .24 .1 r
.57765 .55098 m
.57829 .55136 L
s
.244 .358 .718 r
.42163 .57152 m .43109 .56596 L .44692 .58601 L p F P
0 0 0 r
s
1 .308 .13 r
.5309 .60081 m .52582 .59797 L .53821 .57751 L p F P
0 0 0 r
s
.83 .24 .1 r
.53114 .60004 m
.53139 .60018 L
s
1 .308 .13 r
.53821 .57751 m .54567 .58178 L .5309 .60081 L p F P
0 0 0 r
s
.258 .381 .76 r
.44692 .58601 m .45433 .58178 L .4691 .60081 L p F P
0 0 0 r
s
.83 .24 .1 r
.42126 .59844 m
.45311 .6153 L
s
.258 .381 .76 r
.47418 .59797 m .4691 .60081 L .45433 .58178 L p F P
0 0 0 r
s
1 .292 .121 r
.58983 .48855 m .60401 .49755 L .59478 .52104 L p F P
0 0 0 r
s
.83 .24 .1 r
.59375 .52081 m
.59462 .52135 L
s
.59375 .52081 m
.59445 .51893 L
s
.60275 .49675 m
.60337 .49509 L
s
1 .283 .116 r
.60401 .49755 m .58983 .48855 L .5954 .46459 L p F P
0 0 0 r
s
.194 .28 .573 r
.39599 .49755 m .41017 .48855 L .41821 .513 L p F P
0 0 0 r
s
.194 .28 .573 r
.41821 .513 m .40522 .52104 L .39599 .49755 L p F P
0 0 0 r
s
.24 .35 .67 r
.40613 .52048 m
.40625 .52081 L
s
.40538 .52135 m
.40625 .52081 L
s
.831 .224 .089 r
.56693 .39961 m .55062 .38863 L .54945 .37053 L p F P
0 0 0 r
s
.831 .224 .089 r
.53325 .35947 m .54945 .37053 L .55062 .38863 L p F P
0 0 0 r
s
.08 .105 .237 r
.45055 .37053 m .46675 .35947 L .46596 .37747 L p F P
0 0 0 r
s
.08 .105 .237 r
.46596 .37747 m .44938 .38863 L .45055 .37053 L p F P
0 0 0 r
s
.24 .35 .67 r
.44993 .38985 m
.45017 .3881 L
s
1 .307 .128 r
.55308 .58601 m .54567 .58178 L .55936 .56036 L p F P
0 0 0 r
s
1 .307 .128 r
.55936 .56036 m .56891 .56596 L .55308 .58601 L p F P
0 0 0 r
s
.244 .358 .718 r
.45433 .58178 m .44692 .58601 L .43109 .56596 L p F P
0 0 0 r
s
.24 .35 .67 r
.42235 .55098 m
.43485 .56852 L
s
.83 .24 .1 r
.56755 .56516 m
.57765 .55098 L
s
1 .308 .13 r
.52582 .59797 m .52071 .59512 L .53068 .5732 L p F P
0 0 0 r
s
.83 .24 .1 r
.52598 .59716 m
.52623 .5973 L
s
1 .308 .13 r
.53068 .5732 m .53821 .57751 L .52582 .59797 L p F P
0 0 0 r
s
.258 .381 .76 r
.45433 .58178 m .46179 .57751 L .47418 .59797 L p F P
0 0 0 r
s
.258 .381 .76 r
.47929 .59512 m .47418 .59797 L .46179 .57751 L p F P
0 0 0 r
s
1 .283 .116 r
.58014 .45469 m .5954 .46459 L .58983 .48855 L p F P
0 0 0 r
s
.971 .27 .11 r
.5954 .46459 m .58014 .45469 L .58266 .43146 L p F P
0 0 0 r
s
.173 .246 .511 r
.4046 .46459 m .41986 .45469 L .42458 .47941 L p F P
0 0 0 r
s
.173 .246 .511 r
.42458 .47941 m .41017 .48855 L .4046 .46459 L p F P
0 0 0 r
s
.916 .251 .101 r
.58266 .43146 m .56669 .42088 L .56693 .39961 L p F P
0 0 0 r
s
.916 .251 .101 r
.55062 .38863 m .56693 .39961 L .56669 .42088 L p F P
0 0 0 r
s
.83 .24 .1 r
.55007 .38985 m
.55181 .39102 L
s
.116 .157 .342 r
.43307 .39961 m .44938 .38863 L .44956 .41012 L p F P
0 0 0 r
s
.24 .35 .67 r
.43309 .40117 m
.43428 .40038 L
s
.44939 .39021 m
.44993 .38985 L
s
.116 .157 .342 r
.44956 .41012 m .43331 .42088 L .43307 .39961 L p F P
0 0 0 r
s
.24 .35 .67 r
.50604 .59125 m
.50855 .59328 L
s
.52101 .60333 m
.5232 .60214 L
s
.83 .24 .1 r
.4768 .60214 m
.47899 .60333 L
s
.49145 .59328 m
.49396 .59125 L
s
1 .299 .124 r
.58179 .513 m .59478 .52104 L .58296 .54408 L p F P
0 0 0 r
s
.83 .24 .1 r
.57765 .55098 m
.58285 .54123 L
s
1 .292 .121 r
.59478 .52104 m .58179 .513 L .58983 .48855 L p F P
0 0 0 r
s
.213 .308 .627 r
.40522 .52104 m .41821 .513 L .42847 .53719 L p F P
0 0 0 r
s
.213 .308 .627 r
.42847 .53719 m .41704 .54408 L .40522 .52104 L p F P
0 0 0 r
s
.24 .35 .67 r
.41827 .54334 m
.42235 .55098 L
s
.971 .27 .11 r
.56669 .42088 m .58266 .43146 L .58014 .45469 L p F P
0 0 0 r
s
.148 .206 .436 r
.41734 .43146 m .43331 .42088 L .43537 .44463 L p F P
0 0 0 r
s
.148 .206 .436 r
.43537 .44463 m .41986 .45469 L .41734 .43146 L p F P
0 0 0 r
s
.698 .183 .07 r
.53325 .35947 m .51676 .34822 L .51592 .33484 L p F P
0 0 0 r
s
.698 .183 .07 r
.5 .32387 m .51592 .33484 L .51676 .34822 L p F P
0 0 0 r
s
.043 .059 .127 r
.48408 .33484 m .5 .32387 L .5 .33679 L p F P
0 0 0 r
s
.043 .059 .127 r
.5 .33679 m .48324 .34822 L .48408 .33484 L p F P
0 0 0 r
s
.229 .334 .674 r
.44064 .56036 m .43109 .56596 L .41704 .54408 L p F P
0 0 0 r
s
.244 .358 .718 r
.43109 .56596 m .44064 .56036 L .45433 .58178 L p F P
0 0 0 r
s
1 .304 .127 r
.56891 .56596 m .55936 .56036 L .57153 .53719 L p F P
0 0 0 r
s
1 .304 .127 r
.57153 .53719 m .58296 .54408 L .56891 .56596 L p F P
0 0 0 r
s
1 .308 .13 r
.52071 .59512 m .51557 .59226 L .5231 .56887 L p F P
0 0 0 r
s
.83 .24 .1 r
.52079 .59426 m
.52104 .5944 L
s
1 .308 .13 r
.5231 .56887 m .53068 .5732 L .52071 .59512 L p F P
0 0 0 r
s
.24 .35 .67 r
.50855 .59328 m
.52101 .60333 L
s
.5232 .60214 m
.55506 .58487 L
s
.258 .381 .76 r
.46179 .57751 m .46932 .5732 L .47929 .59512 L p F P
0 0 0 r
s
.258 .381 .76 r
.48443 .59226 m .47929 .59512 L .46932 .5732 L p F P
0 0 0 r
s
.83 .24 .1 r
.47899 .60333 m
.49145 .59328 L
s
1 .299 .124 r
.58296 .54408 m .57153 .53719 L .58179 .513 L p F P
0 0 0 r
s
.229 .334 .674 r
.41704 .54408 m .42847 .53719 L .44064 .56036 L p F P
0 0 0 r
s
1 .307 .128 r
.54567 .58178 m .53821 .57751 L .54972 .55469 L p F P
0 0 0 r
s
1 .307 .128 r
.54972 .55469 m .55936 .56036 L .54567 .58178 L p F P
0 0 0 r
s
.244 .358 .718 r
.46179 .57751 m .45433 .58178 L .44064 .56036 L p F P
0 0 0 r
s
1 .308 .13 r
.51557 .59226 m .51041 .58938 L .51546 .5645 L p F P
0 0 0 r
s
.83 .24 .1 r
.51557 .59135 m
.51582 .59149 L
s
1 .308 .13 r
.51546 .5645 m .5231 .56887 L .51557 .59226 L p F P
0 0 0 r
s
.258 .381 .76 r
.46932 .5732 m .4769 .56887 L .48443 .59226 L p F P
0 0 0 r
s
.83 .24 .1 r
.44494 .58487 m
.4768 .60214 L
s
.258 .381 .76 r
.48959 .58938 m .48443 .59226 L .4769 .56887 L p F P
0 0 0 r
s
1 .292 .121 r
.57542 .47941 m .58983 .48855 L .58179 .513 L p F P
0 0 0 r
s
1 .283 .116 r
.58983 .48855 m .57542 .47941 L .58014 .45469 L p F P
0 0 0 r
s
.194 .28 .573 r
.41017 .48855 m .42458 .47941 L .43137 .50486 L p F P
0 0 0 r
s
.194 .28 .573 r
.43137 .50486 m .41821 .513 L .41017 .48855 L p F P
0 0 0 r
s
.24 .35 .67 r
.83931 .47767 m
.83293 .49412 L
s
.83 .24 .1 r
.16069 .47767 m
.16707 .49412 L
s
.24 .35 .67 r
.55506 .58487 m
.57874 .59844 L
s
.57874 .59844 m
.61393 .5798 L
s
.83 .24 .1 r
.38607 .5798 m
.42126 .59844 L
s
.42126 .59844 m
.44494 .58487 L
s
.24 .35 .67 r
.78281 .52535 m
.79405 .5142 L
s
.79405 .5142 m
.83293 .49412 L
s
.83 .24 .1 r
.16707 .49412 m
.20595 .5142 L
s
.20595 .5142 m
.21719 .52535 L
s
.831 .224 .089 r
.55062 .38863 m .53404 .37747 L .53325 .35947 L p F P
0 0 0 r
s
.83 .24 .1 r
.54983 .3881 m
.55007 .38985 L
s
.831 .224 .089 r
.51676 .34822 m .53325 .35947 L .53404 .37747 L p F P
0 0 0 r
s
.08 .105 .237 r
.46675 .35947 m .48324 .34822 L .48283 .36611 L p F P
0 0 0 r
s
.08 .105 .237 r
.48283 .36611 m .46596 .37747 L .46675 .35947 L p F P
0 0 0 r
s
1 .307 .128 r
.53821 .57751 m .53068 .5732 L .53997 .54897 L p F P
0 0 0 r
s
1 .307 .128 r
.53997 .54897 m .54972 .55469 L .53821 .57751 L p F P
0 0 0 r
s
.244 .358 .718 r
.44064 .56036 m .45028 .55469 L .46179 .57751 L p F P
0 0 0 r
s
.244 .358 .718 r
.46932 .5732 m .46179 .57751 L .45028 .55469 L p F P
0 0 0 r
s
.229 .334 .674 r
.45028 .55469 m .44064 .56036 L .42847 .53719 L p F P
0 0 0 r
s
1 .304 .127 r
.55936 .56036 m .54972 .55469 L .55997 .53022 L p F P
0 0 0 r
s
1 .304 .127 r
.55997 .53022 m .57153 .53719 L .55936 .56036 L p F P
0 0 0 r
s
.24 .35 .67 r
.72903 .55019 m
.74473 .54493 L
s
.74473 .54493 m
.78281 .52535 L
s
.83 .24 .1 r
.21719 .52535 m
.25527 .54493 L
s
.25527 .54493 m
.27097 .55019 L
s
1 .308 .13 r
.51041 .58938 m .50522 .58648 L .50776 .56009 L p F P
0 0 0 r
s
.83 .24 .1 r
.51032 .58842 m
.51057 .58856 L
s
1 .308 .13 r
.50776 .56009 m .51546 .5645 L .51041 .58938 L p F P
0 0 0 r
s
.258 .381 .76 r
.4769 .56887 m .48454 .5645 L .48959 .58938 L p F P
0 0 0 r
s
.258 .381 .76 r
.49478 .58648 m .48959 .58938 L .48454 .5645 L p F P
0 0 0 r
s
.24 .35 .67 r
.61393 .5798 m
.63612 .58721 L
s
.63612 .58721 m
.67237 .56835 L
s
.83 .24 .1 r
.32763 .56835 m
.36388 .58721 L
s
.36388 .58721 m
.38607 .5798 L
s
.24 .35 .67 r
.67237 .56835 m
.69182 .56936 L
s
.69182 .56936 m
.72903 .55019 L
s
.83 .24 .1 r
.27097 .55019 m
.30818 .56936 L
s
.30818 .56936 m
.32763 .56835 L
s
1 .299 .124 r
.56863 .50486 m .58179 .513 L .57153 .53719 L p F P
0 0 0 r
s
1 .292 .121 r
.58179 .513 m .56863 .50486 L .57542 .47941 L p F P
0 0 0 r
s
.213 .308 .627 r
.41821 .513 m .43137 .50486 L .44003 .53022 L p F P
0 0 0 r
s
.24 .35 .67 r
.41834 .51333 m
.4185 .51323 L
s
.213 .308 .627 r
.44003 .53022 m .42847 .53719 L .41821 .513 L p F P
0 0 0 r
s
1 .283 .116 r
.56463 .44463 m .58014 .45469 L .57542 .47941 L p F P
0 0 0 r
s
.83 .24 .1 r
.57738 .4529 m
.57812 .44962 L
s
.971 .27 .11 r
.58014 .45469 m .56463 .44463 L .56669 .42088 L p F P
0 0 0 r
s
.173 .246 .511 r
.41986 .45469 m .43537 .44463 L .4392 .47013 L p F P
0 0 0 r
s
.173 .246 .511 r
.4392 .47013 m .42458 .47941 L .41986 .45469 L p F P
0 0 0 r
s
1 .299 .124 r
.57153 .53719 m .55997 .53022 L .56863 .50486 L p F P
0 0 0 r
s
.229 .334 .674 r
.42847 .53719 m .44003 .53022 L .45028 .55469 L p F P
0 0 0 r
s
.83 .24 .1 r
.34163 .20938 m
.32466 .21012 L
s
.24 .35 .67 r
.65837 .20938 m
.67534 .21012 L
s
.916 .251 .101 r
.56669 .42088 m .55044 .41012 L .55062 .38863 L p F P
0 0 0 r
s
.916 .251 .101 r
.53404 .37747 m .55062 .38863 L .55044 .41012 L p F P
0 0 0 r
s
.116 .157 .342 r
.44938 .38863 m .46596 .37747 L .46609 .39918 L p F P
0 0 0 r
s
.24 .35 .67 r
.44993 .38985 m
.4506 .3894 L
s
.116 .157 .342 r
.46609 .39918 m .44956 .41012 L .44938 .38863 L p F P
0 0 0 r
s
.698 .183 .07 r
.51676 .34822 m .5 .33679 L .5 .32387 L p F P
0 0 0 r
s
.971 .27 .11 r
.55044 .41012 m .56669 .42088 L .56463 .44463 L p F P
0 0 0 r
s
.148 .206 .436 r
.43331 .42088 m .44956 .41012 L .45113 .4344 L p F P
0 0 0 r
s
.148 .206 .436 r
.45113 .4344 m .43537 .44463 L .43331 .42088 L p F P
0 0 0 r
s
.83 .24 .1 r
.39215 .24042 m
.37773 .23433 L
s
.34163 .20938 m
.37773 .23433 L
s
.24 .35 .67 r
.62227 .23433 m
.65837 .20938 L
s
.62227 .23433 m
.60785 .24042 L
s
1 .308 .13 r
.50522 .58648 m .5 .58357 L .5 .55565 L p F P
0 0 0 r
s
.83 .24 .1 r
.50505 .58547 m
.5053 .58561 L
s
1 .308 .13 r
.5 .55565 m .50776 .56009 L .50522 .58648 L p F P
0 0 0 r
s
.258 .381 .76 r
.48454 .5645 m .49224 .56009 L .49478 .58648 L p F P
0 0 0 r
s
.258 .381 .76 r
.5 .58357 m .49478 .58648 L .49224 .56009 L p F P
0 0 0 r
s
.24 .35 .67 r
.50507 .57982 m
.5078 .5783 L
s
.50309 .58093 m
.50507 .57982 L
s
.49974 .5828 m
.5 .58265 L
s
.83 .24 .1 r
.49963 .58245 m
.5 .58265 L
s
1 .307 .128 r
.53068 .5732 m .5231 .56887 L .53013 .54319 L p F P
0 0 0 r
s
1 .307 .128 r
.53013 .54319 m .53997 .54897 L .53068 .5732 L p F P
0 0 0 r
s
.244 .358 .718 r
.45028 .55469 m .46003 .54897 L .46932 .5732 L p F P
0 0 0 r
s
.244 .358 .718 r
.4769 .56887 m .46932 .5732 L .46003 .54897 L p F P
0 0 0 r
s
.24 .35 .67 r
.57256 .26487 m
.60785 .24042 L
s
.57256 .26487 m
.5614 .27762 L
s
.83 .24 .1 r
.4386 .27762 m
.42744 .26487 L
s
.39215 .24042 m
.42744 .26487 L
s
.24 .35 .67 r
.50089 .33317 m
.51962 .32037 L
s
.83 .24 .1 r
.48038 .32037 m
.49911 .33317 L
s
.24 .35 .67 r
.52687 .30147 m
.5614 .27762 L
s
.52687 .30147 m
.51962 .32037 L
s
.83 .24 .1 r
.48038 .32037 m
.47313 .30147 L
s
.4386 .27762 m
.47313 .30147 L
s
1 .304 .127 r
.54972 .55469 m .53997 .54897 L .54827 .52316 L p F P
0 0 0 r
s
1 .304 .127 r
.54827 .52316 m .55997 .53022 L .54972 .55469 L p F P
0 0 0 r
s
.229 .334 .674 r
.46003 .54897 m .45028 .55469 L .44003 .53022 L p F P
0 0 0 r
s
.258 .381 .76 r
.49224 .56009 m .5 .55565 L .5 .58357 L p F P
0 0 0 r
s
.83 .24 .1 r
.4922 .5783 m
.49493 .57982 L
s
.49493 .57982 m
.49691 .58093 L
s
1 .292 .121 r
.5608 .47013 m .57542 .47941 L .56863 .50486 L p F P
0 0 0 r
s
1 .283 .116 r
.57542 .47941 m .5608 .47013 L .56463 .44463 L p F P
0 0 0 r
s
.194 .28 .573 r
.42458 .47941 m .4392 .47013 L .44471 .4966 L p F P
0 0 0 r
s
.194 .28 .573 r
.44471 .4966 m .43137 .50486 L .42458 .47941 L p F P
0 0 0 r
s
1 .307 .128 r
.5231 .56887 m .51546 .5645 L .52019 .53736 L p F P
0 0 0 r
s
1 .307 .128 r
.52019 .53736 m .53013 .54319 L .5231 .56887 L p F P
0 0 0 r
s
.24 .35 .67 r
.5078 .5783 m
.53124 .56521 L
s
.244 .358 .718 r
.46003 .54897 m .46987 .54319 L .4769 .56887 L p F P
0 0 0 r
s
.244 .358 .718 r
.48454 .5645 m .4769 .56887 L .46987 .54319 L p F P
0 0 0 r
s
.83 .24 .1 r
.46876 .56521 m
.4922 .5783 L
s
1 .299 .124 r
.55997 .53022 m .54827 .52316 L .55529 .4966 L p F P
0 0 0 r
s
1 .299 .124 r
.55529 .4966 m .56863 .50486 L .55997 .53022 L p F P
0 0 0 r
s
.213 .308 .627 r
.45173 .52316 m .44003 .53022 L .43137 .50486 L p F P
0 0 0 r
s
.229 .334 .674 r
.44003 .53022 m .45173 .52316 L .46003 .54897 L p F P
0 0 0 r
s
1 .292 .121 r
.56863 .50486 m .55529 .4966 L .5608 .47013 L p F P
0 0 0 r
s
.213 .308 .627 r
.43137 .50486 m .44471 .4966 L .45173 .52316 L p F P
0 0 0 r
s
.831 .224 .089 r
.53404 .37747 m .51717 .36611 L .51676 .34822 L p F P
0 0 0 r
s
.831 .224 .089 r
.5 .33679 m .51676 .34822 L .51717 .36611 L p F P
0 0 0 r
s
.08 .105 .237 r
.48324 .34822 m .5 .33679 L .5 .35455 L p F P
0 0 0 r
s
.08 .105 .237 r
.5 .35455 m .48283 .36611 L .48324 .34822 L p F P
0 0 0 r
s
.24 .35 .67 r
.48302 .36759 m
.48323 .36584 L
s
1 .283 .116 r
.54887 .4344 m .56463 .44463 L .5608 .47013 L p F P
0 0 0 r
s
.971 .27 .11 r
.56463 .44463 m .54887 .4344 L .55044 .41012 L p F P
0 0 0 r
s
.173 .246 .511 r
.43537 .44463 m .45113 .4344 L .45405 .46071 L p F P
0 0 0 r
s
.173 .246 .511 r
.45405 .46071 m .4392 .47013 L .43537 .44463 L p F P
0 0 0 r
s
1 .304 .127 r
.53997 .54897 m .53013 .54319 L .53642 .51602 L p F P
0 0 0 r
s
1 .304 .127 r
.53642 .51602 m .54827 .52316 L .53997 .54897 L p F P
0 0 0 r
s
.229 .334 .674 r
.46987 .54319 m .46003 .54897 L .45173 .52316 L p F P
0 0 0 r
s
.24 .35 .67 r
.53124 .56521 m
.55506 .58487 L
s
.55506 .58487 m
.59029 .56576 L
s
.83 .24 .1 r
.40971 .56576 m
.44494 .58487 L
s
.44494 .58487 m
.46876 .56521 L
s
.916 .251 .101 r
.55044 .41012 m .53391 .39918 L .53404 .37747 L p F P
0 0 0 r
s
.916 .251 .101 r
.51717 .36611 m .53404 .37747 L .53391 .39918 L p F P
0 0 0 r
s
.83 .24 .1 r
.51698 .36759 m
.51841 .36856 L
s
.116 .157 .342 r
.46596 .37747 m .48283 .36611 L .4829 .38805 L p F P
0 0 0 r
s
.24 .35 .67 r
.46597 .37906 m
.4672 .37824 L
s
.48284 .36772 m
.48302 .36759 L
s
.116 .157 .342 r
.4829 .38805 m .46609 .39918 L .46596 .37747 L p F P
0 0 0 r
s
.971 .27 .11 r
.53391 .39918 m .55044 .41012 L .54887 .4344 L p F P
0 0 0 r
s
.148 .206 .436 r
.44956 .41012 m .46609 .39918 L .46715 .424 L p F P
0 0 0 r
s
.148 .206 .436 r
.46715 .424 m .45113 .4344 L .44956 .41012 L p F P
0 0 0 r
s
1 .307 .128 r
.51546 .5645 m .50776 .56009 L .51015 .53146 L p F P
0 0 0 r
s
1 .307 .128 r
.51015 .53146 m .52019 .53736 L .51546 .5645 L p F P
0 0 0 r
s
.244 .358 .718 r
.46987 .54319 m .47981 .53736 L .48454 .5645 L p F P
0 0 0 r
s
.244 .358 .718 r
.49224 .56009 m .48454 .5645 L .47981 .53736 L p F P
0 0 0 r
s
1 .292 .121 r
.54595 .46071 m .5608 .47013 L .55529 .4966 L p F P
0 0 0 r
s
1 .283 .116 r
.5608 .47013 m .54595 .46071 L .54887 .4344 L p F P
0 0 0 r
s
.194 .28 .573 r
.4392 .47013 m .45405 .46071 L .45824 .48822 L p F P
0 0 0 r
s
.194 .28 .573 r
.45824 .48822 m .44471 .4966 L .4392 .47013 L p F P
0 0 0 r
s
1 .299 .124 r
.54827 .52316 m .53642 .51602 L .54176 .48822 L p F P
0 0 0 r
s
1 .299 .124 r
.54176 .48822 m .55529 .4966 L .54827 .52316 L p F P
0 0 0 r
s
.213 .308 .627 r
.46358 .51602 m .45173 .52316 L .44471 .4966 L p F P
0 0 0 r
s
.229 .334 .674 r
.45173 .52316 m .46358 .51602 L .46987 .54319 L p F P
0 0 0 r
s
1 .292 .121 r
.55529 .4966 m .54176 .48822 L .54595 .46071 L p F P
0 0 0 r
s
.213 .308 .627 r
.44471 .4966 m .45824 .48822 L .46358 .51602 L p F P
0 0 0 r
s
1 .304 .127 r
.53013 .54319 m .52019 .53736 L .52443 .50879 L p F P
0 0 0 r
s
1 .304 .127 r
.52443 .50879 m .53642 .51602 L .53013 .54319 L p F P
0 0 0 r
s
.229 .334 .674 r
.47981 .53736 m .46987 .54319 L .46358 .51602 L p F P
0 0 0 r
s
1 .307 .128 r
.50776 .56009 m .5 .55565 L .5 .5255 L p F P
0 0 0 r
s
1 .307 .128 r
.5 .5255 m .51015 .53146 L .50776 .56009 L p F P
0 0 0 r
s
.24 .35 .67 r
.50486 .54249 m
.50856 .54036 L
s
.50167 .54433 m
.50486 .54249 L
s
.244 .358 .718 r
.47981 .53736 m .48985 .53146 L .49224 .56009 L p F P
0 0 0 r
s
.244 .358 .718 r
.5 .55565 m .49224 .56009 L .48985 .53146 L p F P
0 0 0 r
s
.24 .35 .67 r
.59029 .56576 m
.61393 .5798 L
s
.61393 .5798 m
.65035 .56053 L
s
.83 .24 .1 r
.34965 .56053 m
.38607 .5798 L
s
.38607 .5798 m
.40971 .56576 L
s
.24 .35 .67 r
.83293 .49412 m
.82221 .5051 L
s
.83 .24 .1 r
.16707 .49412 m
.17779 .5051 L
s
.831 .224 .089 r
.51717 .36611 m .5 .35455 L .5 .33679 L p F P
0 0 0 r
s
.83 .24 .1 r
.51677 .36584 m
.51698 .36759 L
s
.24 .35 .67 r
.76753 .53035 m
.78281 .52535 L
s
.78281 .52535 m
.82221 .5051 L
s
.83 .24 .1 r
.17779 .5051 m
.21719 .52535 L
s
.21719 .52535 m
.23247 .53035 L
s
1 .283 .116 r
.53285 .424 m .54887 .4344 L .54595 .46071 L p F P
0 0 0 r
s
.83 .24 .1 r
.5448 .43175 m
.54585 .42729 L
s
.971 .27 .11 r
.54887 .4344 m .53285 .424 L .53391 .39918 L p F P
0 0 0 r
s
.173 .246 .511 r
.45113 .4344 m .46715 .424 L .46913 .45115 L p F P
0 0 0 r
s
.173 .246 .511 r
.46913 .45115 m .45405 .46071 L .45113 .4344 L p F P
0 0 0 r
s
.24 .35 .67 r
.65035 .56053 m
.67237 .56835 L
s
.67237 .56835 m
.70988 .54883 L
s
.83 .24 .1 r
.29012 .54883 m
.32763 .56835 L
s
.32763 .56835 m
.34965 .56053 L
s
.24 .35 .67 r
.70988 .54883 m
.72903 .55019 L
s
.72903 .55019 m
.76753 .53035 L
s
.83 .24 .1 r
.23247 .53035 m
.27097 .55019 L
s
.27097 .55019 m
.29012 .54883 L
s
.244 .358 .718 r
.48985 .53146 m .5 .5255 L .5 .55565 L p F P
0 0 0 r
s
.83 .24 .1 r
.49514 .54249 m
.49833 .54433 L
s
.49144 .54036 m
.49514 .54249 L
s
.916 .251 .101 r
.53391 .39918 m .5171 .38805 L .51717 .36611 L p F P
0 0 0 r
s
.916 .251 .101 r
.5 .35455 m .51717 .36611 L .5171 .38805 L p F P
0 0 0 r
s
.116 .157 .342 r
.48283 .36611 m .5 .35455 L .5 .37673 L p F P
0 0 0 r
s
.83 .24 .1 r
.5 .35618 m
.50127 .35703 L
s
.24 .35 .67 r
.48302 .36759 m
.48409 .36688 L
s
.5 .35618 m
.50062 .35576 L
s
.83 .24 .1 r
.48273 .34457 m
.49879 .35536 L
s
.116 .157 .342 r
.5 .37673 m .4829 .38805 L .48283 .36611 L p F P
0 0 0 r
s
.971 .27 .11 r
.5171 .38805 m .53391 .39918 L .53285 .424 L p F P
0 0 0 r
s
.148 .206 .436 r
.46609 .39918 m .4829 .38805 L .48344 .41343 L p F P
0 0 0 r
s
.148 .206 .436 r
.48344 .41343 m .46715 .424 L .46609 .39918 L p F P
0 0 0 r
s
1 .299 .124 r
.53642 .51602 m .52443 .50879 L .52803 .47973 L p F P
0 0 0 r
s
1 .299 .124 r
.52803 .47973 m .54176 .48822 L .53642 .51602 L p F P
0 0 0 r
s
.213 .308 .627 r
.47557 .50879 m .46358 .51602 L .45824 .48822 L p F P
0 0 0 r
s
.229 .334 .674 r
.46358 .51602 m .47557 .50879 L .47981 .53736 L p F P
0 0 0 r
s
.83 .24 .1 r
.35564 .21511 m
.34163 .20938 L
s
.24 .35 .67 r
.64436 .21511 m
.65837 .20938 L
s
1 .304 .127 r
.52019 .53736 m .51015 .53146 L .51229 .50147 L p F P
0 0 0 r
s
1 .304 .127 r
.51229 .50147 m .52443 .50879 L .52019 .53736 L p F P
0 0 0 r
s
.229 .334 .674 r
.48985 .53146 m .47981 .53736 L .47557 .50879 L p F P
0 0 0 r
s
.24 .35 .67 r
.50856 .54036 m
.53124 .56521 L
s
.53124 .56521 m
.56639 .54558 L
s
.83 .24 .1 r
.43361 .54558 m
.46876 .56521 L
s
.46876 .56521 m
.49144 .54036 L
s
.24 .35 .67 r
.60785 .24042 m
.64436 .21511 L
s
.60785 .24042 m
.59712 .25295 L
s
.83 .24 .1 r
.40288 .25295 m
.39215 .24042 L
s
.35564 .21511 m
.39215 .24042 L
s
.24 .35 .67 r
.51962 .32037 m
.5546 .29645 L
s
.51962 .32037 m
.51727 .34457 L
s
.83 .24 .1 r
.48273 .34457 m
.48038 .32037 L
s
.4454 .29645 m
.48038 .32037 L
s
1 .292 .121 r
.53087 .45115 m .54595 .46071 L .54176 .48822 L p F P
0 0 0 r
s
1 .283 .116 r
.54595 .46071 m .53087 .45115 L .53285 .424 L p F P
0 0 0 r
s
.194 .28 .573 r
.45405 .46071 m .46913 .45115 L .47197 .47973 L p F P
0 0 0 r
s
.194 .28 .573 r
.47197 .47973 m .45824 .48822 L .45405 .46071 L p F P
0 0 0 r
s
.24 .35 .67 r
.5614 .27762 m
.59712 .25295 L
s
.5614 .27762 m
.5546 .29645 L
s
.83 .24 .1 r
.4454 .29645 m
.4386 .27762 L
s
.40288 .25295 m
.4386 .27762 L
s
1 .292 .121 r
.54176 .48822 m .52803 .47973 L .53087 .45115 L p F P
0 0 0 r
s
.213 .308 .627 r
.45824 .48822 m .47197 .47973 L .47557 .50879 L p F P
0 0 0 r
s
.229 .334 .674 r
.47557 .50879 m .48771 .50147 L .48985 .53146 L p F P
0 0 0 r
s
.229 .334 .674 r
.5 .5255 m .48985 .53146 L .48771 .50147 L p F P
0 0 0 r
s
1 .304 .127 r
.51015 .53146 m .5 .5255 L .5 .49406 L p F P
0 0 0 r
s
1 .304 .127 r
.5 .49406 m .51229 .50147 L .51015 .53146 L p F P
0 0 0 r
s
1 .283 .116 r
.51656 .41343 m .53285 .424 L .53087 .45115 L p F P
0 0 0 r
s
.971 .27 .11 r
.53285 .424 m .51656 .41343 L .5171 .38805 L p F P
0 0 0 r
s
.173 .246 .511 r
.46715 .424 m .48344 .41343 L .48444 .44143 L p F P
0 0 0 r
s
.173 .246 .511 r
.48444 .44143 m .46913 .45115 L .46715 .424 L p F P
0 0 0 r
s
1 .299 .124 r
.52443 .50879 m .51229 .50147 L .51412 .47112 L p F P
0 0 0 r
s
1 .299 .124 r
.51412 .47112 m .52803 .47973 L .52443 .50879 L p F P
0 0 0 r
s
.213 .308 .627 r
.48771 .50147 m .47557 .50879 L .47197 .47973 L p F P
0 0 0 r
s
.24 .35 .67 r
.50276 .53213 m
.50856 .54036 L
s
.50856 .54036 m
.54353 .52017 L
s
.83 .24 .1 r
.49144 .54036 m
.49724 .53213 L
s
.24 .35 .67 r
.56639 .54558 m
.59029 .56576 L
s
.59029 .56576 m
.62676 .54599 L
s
.83 .24 .1 r
.37324 .54599 m
.40971 .56576 L
s
.40971 .56576 m
.43361 .54558 L
s
.916 .251 .101 r
.5171 .38805 m .5 .37673 L .5 .35455 L p F P
0 0 0 r
s
.24 .35 .67 r
.50121 .35536 m
.51727 .34457 L
s
.971 .27 .11 r
.5 .37673 m .5171 .38805 L .51656 .41343 L p F P
0 0 0 r
s
.148 .206 .436 r
.4829 .38805 m .5 .37673 L .5 .40268 L p F P
0 0 0 r
s
.148 .206 .436 r
.5 .40268 m .48344 .41343 L .4829 .38805 L p F P
0 0 0 r
s
.24 .35 .67 r
.50136 .50375 m
.50247 .50309 L
s
.194 .28 .573 r
.46913 .45115 m .48444 .44143 L .48588 .47112 L p F P
0 0 0 r
s
.194 .28 .573 r
.48588 .47112 m .47197 .47973 L .46913 .45115 L p F P
0 0 0 r
s
1 .292 .121 r
.51556 .44143 m .53087 .45115 L .52803 .47973 L p F P
0 0 0 r
s
1 .283 .116 r
.53087 .45115 m .51556 .44143 L .51656 .41343 L p F P
0 0 0 r
s
1 .292 .121 r
.52803 .47973 m .51412 .47112 L .51556 .44143 L p F P
0 0 0 r
s
.213 .308 .627 r
.47197 .47973 m .48588 .47112 L .48771 .50147 L p F P
0 0 0 r
s
.229 .334 .674 r
.48771 .50147 m .5 .49406 L .5 .5255 L p F P
0 0 0 r
s
.83 .24 .1 r
.49753 .50309 m
.49864 .50375 L
s
.45647 .52017 m
.49144 .54036 L
s
.47984 .37305 m
.49811 .38506 L
s
.49811 .38506 m
.49909 .3857 L
s
1 .299 .124 r
.51229 .50147 m .5 .49406 L .5 .46238 L p F P
0 0 0 r
s
1 .299 .124 r
.5 .46238 m .51412 .47112 L .51229 .50147 L p F P
0 0 0 r
s
.24 .35 .67 r
.50247 .50309 m
.52297 .49084 L
s
.213 .308 .627 r
.5 .49406 m .48771 .50147 L .48588 .47112 L p F P
0 0 0 r
s
.24 .35 .67 r
.62676 .54599 m
.65035 .56053 L
s
.65035 .56053 m
.68805 .54057 L
s
.83 .24 .1 r
.31195 .54057 m
.34965 .56053 L
s
.34965 .56053 m
.37324 .54599 L
s
1 .283 .116 r
.5 .40268 m .51656 .41343 L .51556 .44143 L p F P
0 0 0 r
s
.971 .27 .11 r
.51656 .41343 m .5 .40268 L .5 .37673 L p F P
0 0 0 r
s
.24 .35 .67 r
.50091 .3857 m
.52016 .37305 L
s
.173 .246 .511 r
.48344 .41343 m .5 .40268 L .5 .43156 L p F P
0 0 0 r
s
.173 .246 .511 r
.5 .43156 m .48444 .44143 L .48344 .41343 L p F P
0 0 0 r
s
.24 .35 .67 r
.82221 .5051 m
.8074 .50981 L
s
.83 .24 .1 r
.17779 .5051 m
.1926 .50981 L
s
.24 .35 .67 r
.68805 .54057 m
.70988 .54883 L
s
.70988 .54883 m
.74871 .52862 L
s
.83 .24 .1 r
.25129 .52862 m
.29012 .54883 L
s
.29012 .54883 m
.31195 .54057 L
s
.24 .35 .67 r
.74871 .52862 m
.76753 .53035 L
s
.76753 .53035 m
.8074 .50981 L
s
.83 .24 .1 r
.1926 .50981 m
.23247 .53035 L
s
.23247 .53035 m
.25129 .52862 L
s
.48273 .34457 m
.44727 .32072 L
s
.24 .35 .67 r
.51727 .34457 m
.55273 .32072 L
s
.51727 .34457 m
.52016 .37305 L
s
.83 .24 .1 r
.47984 .37305 m
.48273 .34457 L
s
1 .292 .121 r
.51412 .47112 m .5 .46238 L .5 .43156 L p F P
0 0 0 r
s
1 .292 .121 r
.5 .43156 m .51556 .44143 L .51412 .47112 L p F P
0 0 0 r
s
.24 .35 .67 r
.50161 .46181 m
.50587 .45917 L
s
.50144 .46192 m
.50161 .46181 L
s
.194 .28 .573 r
.5 .46238 m .48588 .47112 L .48444 .44143 L p F P
0 0 0 r
s
.213 .308 .627 r
.48588 .47112 m .5 .46238 L .5 .49406 L p F P
0 0 0 r
s
.83 .24 .1 r
.47703 .49084 m
.49753 .50309 L
s
1 .283 .116 r
.51556 .44143 m .5 .43156 L .5 .40268 L p F P
0 0 0 r
s
.194 .28 .573 r
.48444 .44143 m .5 .43156 L .5 .46238 L p F P
0 0 0 r
s
.83 .24 .1 r
.49413 .45917 m
.49856 .46192 L
s
.24 .35 .67 r
.54353 .52017 m
.56639 .54558 L
s
.56639 .54558 m
.6028 .52526 L
s
.83 .24 .1 r
.3972 .52526 m
.43361 .54558 L
s
.43361 .54558 m
.45647 .52017 L
s
.24 .35 .67 r
.63412 .2274 m
.64436 .21511 L
s
.83 .24 .1 r
.36588 .2274 m
.35564 .21511 L
s
.24 .35 .67 r
.5546 .29645 m
.59081 .27169 L
s
.5546 .29645 m
.55273 .32072 L
s
.83 .24 .1 r
.44727 .32072 m
.4454 .29645 L
s
.40919 .27169 m
.4454 .29645 L
s
.24 .35 .67 r
.59712 .25295 m
.63412 .2274 L
s
.59712 .25295 m
.59081 .27169 L
s
.83 .24 .1 r
.40919 .27169 m
.40288 .25295 L
s
.36588 .2274 m
.40288 .25295 L
s
.24 .35 .67 r
.50097 .42194 m
.52832 .40446 L
s
.50406 .45457 m
.50587 .45917 L
s
.50169 .44858 m
.50406 .45457 L
s
.83 .24 .1 r
.49413 .45917 m
.49594 .45457 L
s
.49594 .45457 m
.49831 .44858 L
s
.47168 .40446 m
.49702 .42065 L
s
.49702 .42065 m
.49903 .42194 L
s
.24 .35 .67 r
.52297 .49084 m
.54353 .52017 L
s
.54353 .52017 m
.57975 .49927 L
s
.83 .24 .1 r
.42025 .49927 m
.45647 .52017 L
s
.45647 .52017 m
.47703 .49084 L
s
.24 .35 .67 r
.50587 .45917 m
.54145 .43716 L
s
.50587 .45917 m
.52297 .49084 L
s
.83 .24 .1 r
.47703 .49084 m
.49413 .45917 L
s
.45855 .43716 m
.49413 .45917 L
s
.24 .35 .67 r
.6028 .52526 m
.62676 .54599 L
s
.62676 .54599 m
.66453 .52551 L
s
.83 .24 .1 r
.33547 .52551 m
.37324 .54599 L
s
.37324 .54599 m
.3972 .52526 L
s
.24 .35 .67 r
.52297 .49084 m
.55891 .46936 L
s
.83 .24 .1 r
.44109 .46936 m
.47703 .49084 L
s
.24 .35 .67 r
.52016 .37305 m
.55611 .34942 L
s
.52016 .37305 m
.52832 .40446 L
s
.83 .24 .1 r
.47168 .40446 m
.47984 .37305 L
s
.44389 .34942 m
.47984 .37305 L
s
.24 .35 .67 r
.66453 .52551 m
.68805 .54057 L
s
.68805 .54057 m
.7271 .51989 L
s
.83 .24 .1 r
.2729 .51989 m
.31195 .54057 L
s
.31195 .54057 m
.33547 .52551 L
s
.24 .35 .67 r
.7271 .51989 m
.74871 .52862 L
s
.74871 .52862 m
.78895 .50768 L
s
.83 .24 .1 r
.21105 .50768 m
.25129 .52862 L
s
.25129 .52862 m
.2729 .51989 L
s
.24 .35 .67 r
.8074 .50981 m
.78895 .50768 L
s
.83 .24 .1 r
.1926 .50981 m
.21105 .50768 L
s
.44727 .32072 m
.41053 .29602 L
s
.24 .35 .67 r
.55273 .32072 m
.58947 .29602 L
s
.55273 .32072 m
.55611 .34942 L
s
.83 .24 .1 r
.44389 .34942 m
.44727 .32072 L
s
.24 .35 .67 r
.57975 .49927 m
.6028 .52526 L
s
.6028 .52526 m
.64051 .5042 L
s
.83 .24 .1 r
.35949 .5042 m
.3972 .52526 L
s
.3972 .52526 m
.42025 .49927 L
s
.24 .35 .67 r
.59081 .27169 m
.62834 .24603 L
s
.59081 .27169 m
.58947 .29602 L
s
.83 .24 .1 r
.41053 .29602 m
.40919 .27169 L
s
.37166 .24603 m
.40919 .27169 L
s
.24 .35 .67 r
.62834 .24603 m
.63412 .2274 L
s
.83 .24 .1 r
.37166 .24603 m
.36588 .2274 L
s
.24 .35 .67 r
.52832 .40446 m
.56475 .38118 L
s
.52832 .40446 m
.54145 .43716 L
s
.83 .24 .1 r
.45855 .43716 m
.47168 .40446 L
s
.43525 .38118 m
.47168 .40446 L
s
.24 .35 .67 r
.55891 .46936 m
.57975 .49927 L
s
.57975 .49927 m
.61729 .4776 L
s
.83 .24 .1 r
.38271 .4776 m
.42025 .49927 L
s
.42025 .49927 m
.44109 .46936 L
s
.24 .35 .67 r
.54145 .43716 m
.57833 .41434 L
s
.54145 .43716 m
.55891 .46936 L
s
.83 .24 .1 r
.44109 .46936 m
.45855 .43716 L
s
.42167 .41434 m
.45855 .43716 L
s
.24 .35 .67 r
.64051 .5042 m
.66453 .52551 L
s
.66453 .52551 m
.70367 .50429 L
s
.83 .24 .1 r
.29633 .50429 m
.33547 .52551 L
s
.33547 .52551 m
.35949 .5042 L
s
.24 .35 .67 r
.55891 .46936 m
.59616 .44709 L
s
.83 .24 .1 r
.40384 .44709 m
.44109 .46936 L
s
.24 .35 .67 r
.55611 .34942 m
.59337 .32493 L
s
.55611 .34942 m
.56475 .38118 L
s
.83 .24 .1 r
.43525 .38118 m
.44389 .34942 L
s
.40663 .32493 m
.44389 .34942 L
s
.24 .35 .67 r
.70367 .50429 m
.7271 .51989 L
s
.7271 .51989 m
.76758 .49846 L
s
.83 .24 .1 r
.23242 .49846 m
.2729 .51989 L
s
.2729 .51989 m
.29633 .50429 L
s
.24 .35 .67 r
.78895 .50768 m
.76758 .49846 L
s
.83 .24 .1 r
.21105 .50768 m
.23242 .49846 L
s
.41053 .29602 m
.37245 .27041 L
s
.24 .35 .67 r
.58947 .29602 m
.62755 .27041 L
s
.58947 .29602 m
.59337 .32493 L
s
.83 .24 .1 r
.40663 .32493 m
.41053 .29602 L
s
.24 .35 .67 r
.61729 .4776 m
.64051 .5042 L
s
.64051 .5042 m
.67962 .48236 L
s
.83 .24 .1 r
.32038 .48236 m
.35949 .5042 L
s
.35949 .5042 m
.38271 .4776 L
s
.24 .35 .67 r
.62755 .27041 m
.62834 .24603 L
s
.83 .24 .1 r
.37245 .27041 m
.37166 .24603 L
s
.24 .35 .67 r
.56475 .38118 m
.60253 .35704 L
s
.56475 .38118 m
.57833 .41434 L
s
.83 .24 .1 r
.42167 .41434 m
.43525 .38118 L
s
.39747 .35704 m
.43525 .38118 L
s
.24 .35 .67 r
.59616 .44709 m
.61729 .4776 L
s
.61729 .4776 m
.65622 .45513 L
s
.83 .24 .1 r
.34378 .45513 m
.38271 .4776 L
s
.38271 .4776 m
.40384 .44709 L
s
.24 .35 .67 r
.57833 .41434 m
.61657 .39068 L
s
.57833 .41434 m
.59616 .44709 L
s
.83 .24 .1 r
.40384 .44709 m
.42167 .41434 L
s
.38343 .39068 m
.42167 .41434 L
s
.24 .35 .67 r
.67962 .48236 m
.70367 .50429 L
s
.70367 .50429 m
.74427 .48227 L
s
.83 .24 .1 r
.25573 .48227 m
.29633 .50429 L
s
.29633 .50429 m
.32038 .48236 L
s
.24 .35 .67 r
.59616 .44709 m
.6348 .424 L
s
.83 .24 .1 r
.3652 .424 m
.40384 .44709 L
s
.24 .35 .67 r
.59337 .32493 m
.63203 .29952 L
s
.59337 .32493 m
.60253 .35704 L
s
.83 .24 .1 r
.39747 .35704 m
.40663 .32493 L
s
.36797 .29952 m
.40663 .32493 L
s
.24 .35 .67 r
.76758 .49846 m
.74427 .48227 L
s
.83 .24 .1 r
.23242 .49846 m
.25573 .48227 L
s
.36797 .29952 m
.37245 .27041 L
s
.24 .35 .67 r
.63203 .29952 m
.62755 .27041 L
s
.65622 .45513 m
.67962 .48236 L
s
.67962 .48236 m
.72019 .45971 L
s
.83 .24 .1 r
.27981 .45971 m
.32038 .48236 L
s
.32038 .48236 m
.34378 .45513 L
s
.24 .35 .67 r
.60253 .35704 m
.64172 .33199 L
s
.60253 .35704 m
.61657 .39068 L
s
.83 .24 .1 r
.38343 .39068 m
.39747 .35704 L
s
.35828 .33199 m
.39747 .35704 L
s
.24 .35 .67 r
.6348 .424 m
.65622 .45513 L
s
.65622 .45513 m
.69662 .43181 L
s
.83 .24 .1 r
.30338 .43181 m
.34378 .45513 L
s
.34378 .45513 m
.3652 .424 L
s
.24 .35 .67 r
.61657 .39068 m
.65626 .36612 L
s
.61657 .39068 m
.6348 .424 L
s
.83 .24 .1 r
.3652 .424 m
.38343 .39068 L
s
.34374 .36612 m
.38343 .39068 L
s
.24 .35 .67 r
.74427 .48227 m
.72019 .45971 L
s
.83 .24 .1 r
.25573 .48227 m
.27981 .45971 L
s
.24 .35 .67 r
.6348 .424 m
.6749 .40003 L
s
.83 .24 .1 r
.3251 .40003 m
.3652 .424 L
s
.24 .35 .67 r
.64172 .33199 m
.63203 .29952 L
s
.83 .24 .1 r
.35828 .33199 m
.36797 .29952 L
s
.24 .35 .67 r
.72019 .45971 m
.69662 .43181 L
s
.83 .24 .1 r
.27981 .45971 m
.30338 .43181 L
s
.24 .35 .67 r
.65626 .36612 m
.64172 .33199 L
s
.83 .24 .1 r
.34374 .36612 m
.35828 .33199 L
s
.24 .35 .67 r
.69662 .43181 m
.6749 .40003 L
s
.83 .24 .1 r
.30338 .43181 m
.3251 .40003 L
s
.24 .35 .67 r
.6749 .40003 m
.65626 .36612 L
s
.83 .24 .1 r
.3251 .40003 m
.34374 .36612 L
s
0 0 0 r
.25 Mabswid
.5 .02321 m
.92347 .37901 L
s
.92347 .37901 m
.97811 .6366 L
s
.97811 .6366 m
.5 .30205 L
s
.5 .30205 m
.5 .02321 L
s
.07653 .37901 m
.02189 .6366 L
s
.02189 .6366 m
.5 .30205 L
s
.5 .30205 m
.5 .02321 L
s
.5 .02321 m
.07653 .37901 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{500, 500},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40007d0001m2000`400?l00000o`00003oo`3ooooe
0?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3o
m^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40
oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?of
k_@0ooK^0@3oool00?T0ooK^00<000000?ofkP3om^h0m`3om^h10?ooo`00n03om^h300000?P0ooK^
0@3oool00?L0ooK^00D000000?ofkP000000ooK^0000003g0?ofkP40oooo003e0?ofkP8000000P3o
m^h00`000000ooK^0?ofkP0200000?D0ooK^0@3oool00?@0ooK^00<000000?ofkP3om^h00P3om^h0
0`000000ooK^0?ofkP020?ofkP030000003om^h0ooK^0?80ooK^0@3oool00?<0ooK^00<000000?of
kP3om^h00`3om^h00`000000ooK^0?ofkP030?ofkP030000003om^h0ooK^0?40ooK^0@3oool00?80
ooK^00<000000?ofkP3om^h0103om^h00`000000ooK^0?ofkP040?ofkP030000003om^h0ooK^0?00
ooK^0@3oool00?40ooK^00<000000?ofkP3om^h01@3om^h00`000000ooK^0?ofkP050?ofkP030000
003om^h0ooK^0>l0ooK^0@3oool00>l0ooK^0P0000080?ofkP030000003om^h0ooK^00H0ooK^0P00
003_0?ofkP40oooo003^0?ofkP030000003om^h0ooK^00P0ooK^00<000000?ofkP3om^h0203om^h0
0`000000ooK^0?ofkP3/0?ofkP40oooo003]0?ofkP030000003om^h0ooK^00T0ooK^00<000000?of
kP3om^h02@3om^h00`000000ooK^0?ofkP3[0?ofkP40oooo003/0?ofkP030000003om^h0ooK^00X0
ooK^00<000000?ofkP3om^h02P3om^h00`000000ooK^0?ofkP3Z0?ofkP40oooo003[0?ofkP030000
003om^h0ooK^00/0ooK^00<000000?ofkP3om^h02`3om^h00`000000ooK^0?ofkP3Y0?ofkP40oooo
003Y0?ofkP8000003P3om^h00`000000ooK^0?ofkP0<0?ofkP800000j@3om^h10?ooo`00j03om^h0
0`000000ooK^0?ofkP0>0?ofkP030000003om^h0ooK^00h0ooK^00<000000?ofkP3om^h0iP3om^h1
0?ooo`00i`3om^h00`000000ooK^0?ofkP0?0?ofkP030000003om^h0ooK^00l0ooK^00<000000?of
kP3om^h0i@3om^h10?ooo`00iP3om^h00`000000ooK^0?ofkP0@0?ofkP030000003om^h0ooK^0100
ooK^00<000000?ofkP3om^h0i03om^h10?ooo`00i@3om^h00`000000ooK^0?ofkP0A0?ofkP030000
003om^h0ooK^0140ooK^00<000000?ofkP3om^h0h`3om^h10?ooo`00i03om^h00`000000ooK^0?of
kP0B0?ofkP030000003om^h0ooK^0180ooK^00<000000?ofkP3om^h0hP3om^h10?ooo`00hP3om^h2
000001D0ooK^00<000000?ofkP3om^h04`3om^h200000>80ooK^0@3oool00>40ooK^00<000000?of
kP3om^h05@3om^h00`000000ooK^0?ofkP0E0?ofkP030000003om^h0ooK^0=l0ooK^0@3oool00>00
ooK^00<000000?ofkP3om^h05P3om^h00`000000ooK^0?ofkP0F0?ofkP030000003om^h0ooK^0=h0
ooK^0@3oool00=l0ooK^00<000000?ofkP3om^h05`3om^h00`000000ooK^0?ofkP0G0?ofkP030000
003om^h0ooK^0=d0ooK^0@3oool00=h0ooK^00<000000?ofkP3om^h0603om^h00`000000ooK^0?of
kP0H0?ofkP030000003om^h0ooK^0=`0ooK^0@3oool00=`0ooK^0P00000K0?ofkP030000003om^h0
ooK^01T0ooK^0P00003L0?ofkP40oooo003K0?ofkP030000003om^h0ooK^01/0ooK^00<000000?of
kP3om^h06`3om^h00`000000ooK^0?ofkP3I0?ofkP40oooo003J0?ofkP030000003om^h0ooK^01`0
ooK^00<000000?ofkP3om^h0703om^h00`000000ooK^0?ofkP3H0?ofkP40oooo003I0?ofkP030000
003om^h0ooK^01d0ooK^00<000000?ofkP3om^h07@3om^h00`000000ooK^0?ofkP3G0?ofkP40oooo
003H0?ofkP030000003om^h0ooK^01h0ooK^00<000000?ofkP3om^h07P3om^h00`000000ooK^0?of
kP3F0?ofkP40oooo003G0?ofkP030000003om^h0ooK^01l0ooK^00<000000?ofkP3om^h07`3om^h0
0`000000ooK^0?ofkP3E0?ofkP40oooo003E0?ofkP8000008P3om^h00`000000ooK^0?ofkP0P0?of
kP800000e@3om^h10?ooo`00e03om^h00`000000ooK^0?ofkP0R0?ofkP030000003om^h0ooK^0280
ooK^00<000000?ofkP3om^h0dP3om^h10?ooo`00d`3om^h00`000000ooK^0?ofkP0S0?ofkP030000
003om^h0ooK^02<0ooK^00<000000?ofkP3om^h0d@3om^h10?ooo`00dP3om^h00`000000ooK^0?of
kP0T0?ofkP030000003om^h0ooK^02@0ooK^00<000000?ofkP3om^h0d03om^h10?ooo`00d@3om^h0
0`000000ooK^0?ofkP0U0?ofkP030000003om^h0ooK^02D0ooK^00<000000?ofkP3om^h0c`3om^h1
0?ooo`00c`3om^h2000002P0ooK^00<000000?ofkP3om^h09P3om^h200000<l0ooK^0@3oool00<h0
ooK^00<000000?ofkP3om^h0:03om^h00`000000ooK^0?ofkP0X0?ofkP030000003om^h0ooK^0<`0
ooK^0@3oool00<d0ooK^00<000000?ofkP3om^h0:@3om^h00`000000ooK^0?ofkP0Y0?ofkP030000
003om^h0ooK^0</0ooK^0@3oool00<`0ooK^00<000000?ofkP3om^h0:P3om^h00`000000ooK^0?of
kP0Z0?ofkP030000003om^h0ooK^0<X0ooK^0@3oool00</0ooK^00<000000?ofkP3om^h0:`3om^h0
0`000000ooK^0?ofkP0[0?ofkP030000003om^h0ooK^0<T0ooK^0@3oool00<T0ooK^0P00000^0?of
kP030000003om^h0ooK^02`0ooK^0P0000390?ofkP40oooo00380?ofkP030000003om^h0ooK^02h0
ooK^00<000000?ofkP3om^h0;P3om^h00`000000ooK^0?ofkP360?ofkP40oooo00370?ofkP030000
003om^h0ooK^02l0ooK^00<000000?ofkP3om^h0;`3om^h00`000000ooK^0?ofkP350?ofkP40oooo
00360?ofkP030000003om^h0ooK^0300ooK^00<000000?ofkP3om^h0<03om^h00`000000ooK^0?of
kP340?ofkP40oooo00350?ofkP030000003om^h0ooK^0340ooK^00<000000?ofkP3om^h0<@3om^h0
0`000000ooK^0?ofkP330?ofkP40oooo00340?ofkP030000003om^h0ooK^0380ooK^00<000000?of
kP3om^h0<P3om^h00`000000ooK^0?ofkP320?ofkP40oooo00320?ofkP800000=@3om^h00`000000
ooK^0?ofkP0c0?ofkP800000`P3om^h10?ooo`00`@3om^h00`000000ooK^0?ofkP0e0?ofkP030000
003om^h0ooK^03D0ooK^00<000000?ofkP3om^h0_`3om^h10?ooo`00`03om^h00`000000ooK^0?of
kP0f0?ofkP030000003om^h0ooK^03H0ooK^00<000000?ofkP3om^h0_P3om^h10?ooo`00_`3om^h0
0`000000ooK^0?ofkP0g0?ofkP030000003om^h0ooK^03L0ooK^00<000000?ofkP3om^h0_@3om^h1
0?ooo`00_P3om^h00`000000ooK^0?ofkP0h0?ofkP030000003om^h0ooK^03P0ooK^00<000000?of
kP3om^h0_03om^h10?ooo`00_03om^h2000003/0ooK^00<000000?ofkP3om^h0>@3om^h200000;`0
ooK^0@3oool00;/0ooK^00<000000?ofkP3om^h0>`3om^h00`000000ooK^0?ofkP0k0?ofkP030000
003om^h0ooK^0;T0ooK^0@3oool00;X0ooK^00<000000?ofkP3om^h0?03om^h00`000000ooK^0?of
kP0l0?ofkP030000003om^h0ooK^0;P0ooK^0@3oool00;T0ooK^00<000000?ofkP3om^h0?@3om^h0
0`000000ooK^0?ofkP0m0?ofkP030000003om^h0ooK^0;L0ooK^0@3oool00;P0ooK^00<000000?of
kP3om^h0?P3om^h00`000000ooK^0?ofkP0n0?ofkP030000003om^h0ooK^0;H0ooK^0@3oool00;L0
ooK^00<000000?ofkP3om^h0?`3om^h00`000000ooK^0?ofkP0o0?ofkP030000003om^h0ooK^0;D0
ooK^0@3oool00;D0ooK^0P0000120?ofkP030000003om^h0ooK^0400ooK^0P00002e0?ofkP40oooo
002d0?ofkP030000003om^h0ooK^0480ooK^00<000000?ofkP3om^h0@P3om^h00`000000ooK^0?of
kP2b0?ofkP40oooo002c0?ofkP030000003om^h0ooK^04<0ooK^00<000000?ofkP3om^h0@`3om^h0
0`000000ooK^0?ofkP2a0?ofkP40oooo002b0?ofkP030000003om^h0ooK^04@0ooK^00<000000?of
kP3om^h0A03om^h00`000000ooK^0?ofkP2`0?ofkP40oooo002a0?ofkP030000003om^h0ooK^04D0
ooK^00<000000?ofkP3om^h0A@3om^h00`000000ooK^0?ofkP2_0?ofkP40oooo002_0?ofkP800000
B03om^h00`000000ooK^0?ofkP160?ofkP800000[`3om^h10?ooo`00[P3om^h00`000000ooK^0?of
kP180?ofkP030000003om^h0ooK^04P0ooK^00<000000?ofkP3om^h0[03om^h10?ooo`00[@3om^h0
0`000000ooK^0?ofkP190?ofkP030000003om^h0ooK^04T0ooK^00<000000?ofkP3om^h0Z`3om^h1
0?ooo`00[03om^h00`000000ooK^0?ofkP1:0?ofkP030000003om^h0ooK^04X0ooK^00<000000?of
kP3om^h0ZP3om^h10?ooo`00Z`3om^h00`000000ooK^0?ofkP1;0?ofkP030000003om^h0ooK^04/0
ooK^00<000000?ofkP3om^h0Z@3om^h10?ooo`00Z@3om^h2000004h0ooK^00<000000?ofkP3om^h0
C03om^h200000:T0ooK^0@3oool00:P0ooK^00<000000?ofkP3om^h0CP3om^h00`000000ooK^0?of
kP1>0?ofkP030000003om^h0ooK^0:H0ooK^0@3oool00:L0ooK^00<000000?ofkP3om^h0C`3om^h0
0`000000ooK^0?ofkP1?0?ofkP030000003om^h0ooK^0:D0ooK^0@3oool00:H0ooK^00<000000?of
kP3om^h0D03om^h00`000000ooK^0?ofkP1@0?ofkP030000003om^h0ooK^0:@0ooK^0@3oool00:D0
ooK^00<000000?ofkP3om^h0D@3om^h00`000000ooK^0?ofkP1A0?ofkP030000003om^h0ooK^0:<0
ooK^0@3oool00:@0ooK^00<000000?ofkP3om^h0DP3om^h00`000000ooK^0?ofkP1B0?ofkP030000
003om^h0ooK^0:80ooK^0@3oool00:80ooK^0P00001E0?ofkP030000003om^h0ooK^05<0ooK^0P00
002R0?ofkP40oooo002Q0?ofkP030000003om^h0ooK^05D0ooK^00<000000?ofkP3om^h0E@3om^h0
0`000000ooK^0?ofkP2O0?ofkP40oooo002P0?ofkP030000003om^h0ooK^05H0ooK^00<000000?of
kP3om^h0EP3om^h00`000000ooK^0?ofkP2N0?ofkP40oooo002O0?ofkP030000003om^h0ooK^05L0
ooK^00<000000?ofkP3om^h0E`3om^h00`000000ooK^0?ofkP2M0?ofkP40oooo002N0?ofkP030000
003om^h0ooK^05P0ooK^00<000000?ofkP3om^h0F03om^h00`000000ooK^0?ofkP2L0?ofkP40oooo
002L0?ofkP800000F`3om^h00`000000ooK^0?ofkP1I0?ofkP800000W03om^h10?ooo`00V`3om^h0
0`000000ooK^0?ofkP1K0?ofkP030000003om^h0ooK^05/0ooK^00<000000?ofkP3om^h0V@3om^h1
0?ooo`00VP3om^h00`000000ooK^0?ofkP1L0?ofkP030000003om^h0ooK^05`0ooK^00<000000?of
kP3om^h0V03om^h10?ooo`00V@3om^h00`000000ooK^0?ofkP1M0?ofkP030000003om^h0ooK^05d0
ooK^00<000000?ofkP3om^h0U`3om^h10?ooo`00V03om^h00`000000ooK^0?ofkP1N0?ofkP030000
003om^h0ooK^05h0ooK^00<000000?ofkP3om^h0UP3om^h10?ooo`00U`3om^h00`000000ooK^0?of
kP1O0?ofkP030000003om^h0ooK^05l0ooK^00<000000?ofkP3om^h0U@3om^h10?ooo`00U@3om^h2
00000680ooK^00<000000?ofkP3om^h0H03om^h2000009D0ooK^0@3oool009@0ooK^00<000000?of
kP3om^h0HP3om^h00`000000ooK^0?ofkP1R0?ofkP030000003om^h0ooK^0980ooK^0@3oool009<0
ooK^00<000000?ofkP3om^h0H`3om^h00`000000ooK^0?ofkP1S0?ofkP030000003om^h0ooK^0940
ooK^0@3oool00980ooK^00<000000?ofkP3om^h0I03om^h00`000000ooK^0?ofkP1T0?ofkP030000
003om^h0ooK^0900ooK^0@3oool00940ooK^00<000000?ofkP3om^h0I@3om^h00`000000ooK^0?of
kP1U0?ofkP030000003om^h0ooK^08l0ooK^0@3oool008l0ooK^0P00001X0?ofkP030000003om^h0
ooK^06H0ooK^0P00002?0?ofkP40oooo002>0?ofkP030000003om^h0ooK^06P0ooK^00<000000?of
kP3om^h0J03om^h00`000000ooK^0?ofkP2<0?ofkP40oooo002=0?ofkP030000003om^h0ooK^06T0
ooK^00<000000?ofkP3om^h0J@3om^h00`000000ooK^0?ofkP2;0?ofkP40oooo002<0?ofkP030000
003om^h0ooK^06X0ooK^00<000000?ofkP3om^h0JP3om^h00`000000ooK^0?ofkP2:0?ofkP40oooo
002;0?ofkP030000003om^h0ooK^01<0ooK^2`3D?AU=0?ofkP030000003om^h0ooK^04/0ooK^2`0m
FJ/E0?ofkP030000003om^h0ooK^08T0ooK^0@3oool008T0ooK^0P00000D0?ofkP80e3dI0P3om^h0
0`3D?AT0ooK^0?ofkP050?ofkP<0e3dIB`3om^h00`000000ooK^0?ofkP190?ofkP<0?EV[1`3om^h0
0`0mFJ/0ooK^0?ofkP0203eIZa@0ooK^0P0000290?ofkP40oooo00280?ofkP030000003om^h0ooK^
0140ooK^0`3D?AT50?ofkP80e3dI1`3om^h30=@m6DT0ooK^00<000000?ofkP3om^h0A`3om^h303eI
Z`L0ooK^0P0mFJ/50?ofkP<0?EV[4`3om^h00`000000ooK^0?ofkP260?ofkP40oooo00270?ofkP03
0000003om^h0ooK^0100ooK^0P3D?AT:0?ofkP030=@m6@3om^h0ooK^00D0ooK^103D?AU70?ofkP03
0000003om^h0ooK^04D0ooK^100mFJ/70?ofkP0303eIZ`3om^h0ooK^00P0ooK^0P0mFJ/B0?ofkP03
0000003om^h0ooK^08D0ooK^0@3oool008H0ooK^00<000000?ofkP3om^h03`3om^h20=@m6@d0ooK^
00<0e3dI0?ofkP3om^h01P3om^h0103D?AT0ooK^0=@m6@3D?AU50?ofkP030000003om^h0ooK^04<0
ooK^0P0mFJ/00`3om^h0?EV[0?ofkP070?ofkP0303eIZ`3om^h0ooK^00/0ooK^0P0mFJ/A0?ofkP03
0000003om^h0ooK^08@0ooK^0@3oool008D0ooK^00<000000?ofkP3om^h03P3om^h20=@m6@030?of
kP3D?AT0e3dI00d0ooK^0P3D?AT70?ofkP@0e3dIA03om^h00`000000ooK^0?ofkP120?ofkP@0?EV[
1`3om^h203eIZ`d0ooK^0P0mFJ/00`3om^h0?EV[03eIZ`0@0?ofkP030000003om^h0ooK^08<0ooK^
0@3oool008@0ooK^00<000000?ofkP3om^h03@3om^h20=@m6@D0ooK^00<0e3dI0?ofkP3om^h0303o
m^h00`3D?AT0ooK^0?ofkP060?ofkP040=@m6@3om^h0e3dI0=@m6D80ooK^00<000000?ofkP3om^h0
@03om^h403eIZ`P0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP030?ofkP80?EV[
3`3om^h00`000000ooK^0?ofkP220?ofkP40oooo00220?ofkP8000003`3om^h00`3D?AT0ooK^0?of
kP060?ofkP80e3dI3@3om^h00`3D?AT0ooK^0?ofkP060?ofkP80e3dI00<0ooK^0=@m6@3om^h0@03o
m^h00`000000ooK^0?ofkP0o0?ofkP0403eIZ`3om^h0?EV[03eIZ`P0ooK^00<0?EV[0?ofkP3om^h0
2`3om^h203eIZ`P0ooK^00<0?EV[0?ofkP3om^h03@3om^h200000880ooK^0@3oool00840ooK^00<0
00000?ofkP3om^h03@3om^h20=@m6@/0ooK^00<0e3dI0?ofkP3om^h02`3om^h20=@m6@L0ooK^0P3D
?AT00`3om^h0e3dI0=@m6@0o0?ofkP030000003om^h0ooK^03d0ooK^0P0mFJ/00`3om^h0?EV[03eI
Z`070?ofkP80?EV[3@3om^h00`0mFJ/0ooK^0?ofkP090?ofkP80?EV[3`3om^h00`000000ooK^0?of
kP1o0?ofkP40oooo00200?ofkP030000003om^h0ooK^00`0ooK^0P3D?AT>0?ofkP80e3dI3@3om^h0
0`3D?AT0ooK^0?ofkP050?ofkP<0e3dI00<0ooK^0=@m6@3om^h0?@3om^h00`000000ooK^0?ofkP0l
0?ofkP0303eIZ`3om^h0?EV[0080?EV[1`3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP80?EV[3P3om^h2
03eIZ`h0ooK^00<000000?ofkP3om^h0OP3om^h10?ooo`00O`3om^h00`000000ooK^0?ofkP0<0?of
kP030=@m6@3om^h0ooK^0100ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP040?of
kP@0e3dI00<0ooK^0=@m6@3D?AT0?03om^h00`000000ooK^0?ofkP0j0?ofkP80?EV[00<0ooK^03eI
Z`0mFJ/00P0mFJ/60?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h0403om^h00`0m
FJ/0ooK^0?ofkP0<0?ofkP030000003om^h0ooK^07d0ooK^0@3oool007h0ooK^00<000000?ofkP3o
m^h0303om^h0103D?AT0ooK^0=@m6@3D?ATA0?ofkP80e3dI303om^h20=@m6@D0ooK^00<0e3dI0?of
kP3D?AT00P3D?AT00`3om^h0e3dI0?ofkP0j0?ofkP030000003om^h0ooK^03T0ooK^00<0?EV[0?of
kP0mFJ/00P0mFJ/00`3om^h0?EV[0?ofkP040?ofkP80?EV[303om^h203eIZa40ooK^0P0mFJ/00`3o
m^h0?EV[0?ofkP0=0?ofkP030000003om^h0ooK^07`0ooK^0@3oool007`0ooK^0P00000=0?ofkP80
e3dI103om^h00`3D?AT0ooK^0?ofkP0@0?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3o
m^h00P3om^h90=@m6CT0ooK^00<000000?ofkP3om^h0=`3om^h903eIZ`@0ooK^00<0?EV[0?ofkP3o
m^h02`3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0303eIZ`3om^h0ooK^0080ooK^0P0mFJ/=0?ofkP80
0000O03om^h10?ooo`00N`3om^h00`000000ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00D0ooK^
00<0e3dI0?ofkP3om^h0403om^h20=@m6@/0ooK^1P3D?AT40?ofkPD0e3dI>03om^h00`000000ooK^
0?ofkP0f0?ofkPD0?EV[103om^h603eIZ`/0ooK^0P0mFJ/B0?ofkP0303eIZ`3om^h0ooK^00D0ooK^
00<0?EV[0?ofkP3om^h0303om^h00`000000ooK^0?ofkP1i0?ofkP40oooo001j0?ofkP030000003o
m^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h01`3om^h20=@m6A80ooK^00<0e3dI0?ofkP3om^h01@3o
m^h30=@m6@80ooK^0P3D?AT20?ofkP030=@m6@3om^h0ooK^0080ooK^1P3D?ATf0?ofkP030000003o
m^h0ooK^03@0ooK^1P0mFJ/40?ofkP0303eIZ`3om^h0ooK^0080?EV[0P3om^h303eIZ`L0ooK^00<0
?EV[0?ofkP3om^h0403om^h203eIZ`T0ooK^00<0?EV[0?ofkP3om^h0303om^h00`000000ooK^0?of
kP1h0?ofkP40oooo001i0?ofkP030000003om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h02P3om^h0
0`3D?AT0ooK^0?ofkP0@0?ofkP80e3dI0P3om^h30=@m6@L0ooK^0`3D?AT60?ofkP80e3dI00<0ooK^
0=@m6@3D?AT0=@3om^h00`000000ooK^0?ofkP0c0?ofkP80?EV[00<0ooK^03eIZ`0mFJ/01P3om^h3
03eIZ`L0ooK^0`0mFJ/20?ofkP80?EV[4P3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0
ooK^00`0ooK^00<000000?ofkP3om^h0M`3om^h10?ooo`00N03om^h00`000000ooK^0?ofkP0<0?of
kP030=@m6@3om^h0ooK^00`0ooK^0P3D?ATB0?ofkP80e3dI303om^h00`3D?AT0ooK^0?ofkP050?of
kP<0e3dI00<0ooK^0=@m6@3D?AT0<`3om^h00`000000ooK^0?ofkP0a0?ofkP80?EV[00@0ooK^03eI
Z`0mFJ/0?EV[1`3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP80?EV[4P3om^h203eIZ`h0ooK^00<0?EV[
0?ofkP3om^h0303om^h00`000000ooK^0?ofkP1f0?ofkP40oooo001g0?ofkP030000003om^h0ooK^
00/0ooK^0P3D?ATA0?ofkP030=@m6@3om^h0ooK^00d0ooK^0P3D?AT00`3om^h0e3dI0=@m6@0<0?of
kP80e3dI1P3om^h30=@m6@030?ofkP3D?AT0e3dI0380ooK^00<000000?ofkP3om^h0<03om^h203eI
Z`040?ofkP0mFJ/0?EV[03eIZ`H0ooK^0P0mFJ/<0?ofkP80?EV[00<0ooK^03eIZ`0mFJ/03`3om^h0
0`0mFJ/0ooK^0?ofkP0?0?ofkP80?EV[3@3om^h00`000000ooK^0?ofkP1e0?ofkP40oooo001e0?of
kP8000003@3om^h00`3D?AT0ooK^0?ofkP0B0?ofkP80e3dI2`3om^h20=@m6@D0ooK^00<0e3dI0?of
kP3om^h02@3om^h00`3D?AT0ooK^0=@m6@070?ofkPD0e3dI<@3om^h00`000000ooK^0?ofkP0_0?of
kPD0?EV[1`3om^h00`0mFJ/0ooK^03eIZ`0;0?ofkP0303eIZ`3om^h0ooK^00<0ooK^0P0mFJ/;0?of
kP80?EV[503om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP800000M@3om^h10?ooo`00M03om^h00`000000
ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^01D0ooK^00<0e3dI0?ofkP3om^h01P3om^h20=@m6@P0
ooK^0P3D?AT90?ofkPD0e3dI1P3om^h30=@m6@030?ofkP3D?AT0e3dI02l0ooK^00<000000?ofkP3o
m^h0;@3om^h203eIZ`040?ofkP0mFJ/0?EV[03eIZ`H0ooK^1@0mFJ/90?ofkP80?EV[203om^h203eI
Z`P0ooK^00<0?EV[0?ofkP3om^h05@3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP030000003om^h0ooK^
0780ooK^0@3oool007<0ooK^00<000000?ofkP3om^h0303om^h0103D?AT0ooK^0=@m6@3D?ATF0?of
kP030=@m6@3om^h0ooK^00<0ooK^0P3D?AT<0?ofkP030=@m6@3om^h0ooK^00H0ooK^00D0e3dI0?of
kP3om^h0e3dI0?ofkP020=@m6@H0ooK^0`3D?AT00`3om^h0e3dI0?ofkP0]0?ofkP030000003om^h0
ooK^02`0ooK^00<0?EV[0?ofkP0mFJ/00P0mFJ/60?ofkP80?EV[00D0ooK^03eIZ`3om^h0ooK^03eI
Z`080?ofkP0303eIZ`3om^h0ooK^00X0ooK^0P0mFJ/50?ofkP0303eIZ`3om^h0ooK^01@0ooK^0P0m
FJ/00`3om^h0?EV[0?ofkP0=0?ofkP030000003om^h0ooK^0740ooK^0@3oool00780ooK^00<00000
0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP020?ofkP80e3dI5@3om^h20=@m6@030?ofkP3D?AT0
e3dI00l0ooK^0P3D?AT60?ofkP040=@m6@3om^h0ooK^0?ofkP80e3dI00<0ooK^0=@m6@3om^h01@3o
m^h30=@m6@030?ofkP3D?AT0ooK^02`0ooK^00<000000?ofkP3om^h0:`3om^h00`0mFJ/0ooK^03eI
Z`0203eIZ`H0ooK^00@0?EV[0?ofkP0mFJ/0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP040?ofkP80?EV[
3`3om^h203eIZ`030?ofkP0mFJ/0?EV[01D0ooK^0P0mFJ/40?ofkP0303eIZ`3om^h0ooK^00`0ooK^
00<000000?ofkP3om^h0L03om^h10?ooo`00L@3om^h00`000000ooK^0?ofkP0<0?ofkP030=@m6@3o
m^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h0503om^h00`3D?AT0ooK^0?ofkP0A0?ofkP80e3dI103o
m^h00`3D?AT0ooK^0?ofkP030?ofkP040=@m6@3om^h0e3dI0=@m6@H0ooK^0P3D?AT00`3om^h0e3dI
0=@m6@0[0?ofkP030000003om^h0ooK^02T0ooK^0P0mFJ/00`3om^h0?EV[03eIZ`060?ofkP80?EV[
00<0ooK^03eIZ`3om^h0103om^h00`0mFJ/0ooK^0?ofkP020?ofkP80?EV[4`3om^h00`0mFJ/0ooK^
0?ofkP0D0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h0303om^h00`000000ooK^
0?ofkP1_0?ofkP40oooo001_0?ofkP8000003P3om^h00`3D?AT0ooK^0?ofkP070?ofkP80e3dI4`3o
m^h0103D?AT0ooK^0=@m6@3D?ATC0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT01P3om^h20=@m6@03
0?ofkP3D?AT0e3dI00@0ooK^103D?AT00`3om^h0e3dI0?ofkP0Y0?ofkP030000003om^h0ooK^02P0
ooK^00<0?EV[0?ofkP0mFJ/00`0mFJ/40?ofkP80?EV[00<0ooK^03eIZ`0mFJ/01P3om^h01@0mFJ/0
ooK^0?ofkP3om^h0?EV[01<0ooK^0P0mFJ/00`3om^h0?EV[0?ofkP0B0?ofkP80?EV[2@3om^h00`0m
FJ/0ooK^0?ofkP0<0?ofkP800000K`3om^h10?ooo`00KP3om^h00`000000ooK^0?ofkP0=0?ofkP03
0=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h03P3om^h20=@m6@@0ooK^00<0e3dI0?ofkP3o
m^h04@3om^h20=@m6@030?ofkP3D?AT0ooK^00L0ooK^00<0e3dI0?ofkP3D?AT02@3D?AT00`3om^h0
e3dI0=@m6@0X0?ofkP030000003om^h0ooK^02H0ooK^0P0mFJ/00`3om^h0?EV[03eIZ`0803eIZ`03
0?ofkP0mFJ/0ooK^00L0ooK^00@0?EV[0?ofkP0mFJ/0?EV[4`3om^h00`0mFJ/0ooK^0?ofkP020?of
kP80?EV[403om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<000000?of
kP3om^h0K03om^h10?ooo`00K@3om^h00`000000ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00`0
ooK^0P3D?AT=0?ofkP030=@m6@3om^h0ooK^00D0ooK^0P3D?ATC0?ofkP80e3dI1`3om^h30=@m6@80
ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@020?ofkP<0e3dI00<0ooK^0=@m6@3om^h09P3om^h00`00
0000ooK^0?ofkP0U0?ofkP0303eIZ`3om^h0?EV[0080?EV[0P3om^h01@0mFJ/0ooK^0?ofkP3om^h0
?EV[0080ooK^0`0mFJ/70?ofkP80?EV[4`3om^h203eIZ`L0ooK^00<0?EV[0?ofkP3om^h02`3om^h2
03eIZ`h0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`000000ooK^0?ofkP1[0?ofkP40oooo001/0?of
kP030000003om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h03`3om^h20=@m6@X0ooK^00<0e3dI0?of
kP3om^h0203om^h00`3D?AT0ooK^0?ofkP0A0?ofkP80e3dI0P3om^h40=@m6@<0ooK^0P3D?AT01@3o
m^h0e3dI0=@m6@3om^h0e3dI00<0ooK^1@3D?ATV0?ofkP030000003om^h0ooK^02@0ooK^1@0mFJ/3
0?ofkP0503eIZ`3om^h0?EV[03eIZ`3om^h00P0mFJ/30?ofkP@0?EV[0P3om^h203eIZa<0ooK^00<0
?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP080?ofkP80?EV[4@3om^h00`0mFJ/0ooK^0?of
kP0=0?ofkP030000003om^h0ooK^06X0ooK^0@3oool006/0ooK^00<000000?ofkP3om^h03@3om^h0
0`3D?AT0ooK^0?ofkP0B0?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h02P3om^h2
0=@m6A40ooK^00@0e3dI0?ofkP3D?AT0e3dI2@3om^h01P3D?AT0ooK^0?ofkP3D?AT0ooK^0=@m6@@0
ooK^1@3D?ATT0?ofkP030000003om^h0ooK^0280ooK^1@0mFJ/40?ofkP0303eIZ`3om^h0?EV[0080
ooK^00<0?EV[0?ofkP3om^h01`3om^h203eIZ`030?ofkP0mFJ/0ooK^0100ooK^0P0mFJ/<0?ofkP03
03eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h04P3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP03
0000003om^h0ooK^06T0ooK^0@3oool006T0ooK^0P00000?0?ofkP030=@m6@3om^h0ooK^01@0ooK^
0P3D?AT40?ofkP80e3dI3`3om^h20=@m6@l0ooK^0P3D?AT00`3om^h0e3dI0?ofkP090?ofkP80e3dI
00<0ooK^0=@m6@3D?AT01@3om^h50=@m6B<0ooK^00<000000?ofkP3om^h08@3om^h503eIZ`D0ooK^
0P0mFJ/00`3om^h0?EV[03eIZ`0:0?ofkP0403eIZ`3om^h0?EV[03eIZ`l0ooK^0P0mFJ/?0?ofkP80
?EV[103om^h203eIZaH0ooK^00<0?EV[0?ofkP3om^h03@3om^h2000006T0ooK^0@3oool006P0ooK^
00<000000?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0G0?ofkP80e3dI00<0ooK^0=@m6@3om^h0
4P3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP<0e3dI0`3om^h20=@m6@X0ooK^00@0e3dI0?ofkP3D?AT0
e3dI1P3om^h20=@m6@030?ofkP3D?AT0e3dI0240ooK^00<000000?ofkP3om^h07`3om^h203eIZ`03
0?ofkP0mFJ/0?EV[00H0ooK^0P0mFJ/00`3om^h0?EV[0?ofkP090?ofkP80?EV[0`3om^h303eIZ``0
ooK^00<0?EV[0?ofkP3om^h04@3om^h0100mFJ/0ooK^03eIZ`0mFJ/I0?ofkP0303eIZ`3om^h0ooK^
00h0ooK^00<000000?ofkP3om^h0IP3om^h10?ooo`00I`3om^h00`000000ooK^0?ofkP0>0?ofkP04
0=@m6@3om^h0e3dI0=@m6AT0ooK^00<0e3dI0?ofkP3om^h04`3om^h20=@m6@P0ooK^0P3D?AT20?of
kP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h0203om^h40=@m6@H0ooK^1@3D?ATP0?of
kP030000003om^h0ooK^01h0ooK^1@0mFJ/60?ofkP@0?EV[2P3om^h00`0mFJ/0ooK^0?ofkP030?of
kP0303eIZ`3om^h0ooK^0080?EV[203om^h203eIZaD0ooK^00<0?EV[0?ofkP3om^h05`3om^h203eI
Z`030?ofkP0mFJ/0ooK^00l0ooK^00<000000?ofkP3om^h0I@3om^h10?ooo`00IP3om^h00`000000
ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^0080ooK^0P3D?ATF0?ofkP040=@m6@3om^h0e3dI0=@m
6AD0ooK^00<0e3dI0?ofkP3om^h00`3om^h20=@m6@@0ooK^0`3D?AT40?ofkP030=@m6@3om^h0ooK^
00T0ooK^00<0e3dI0?ofkP3D?AT01`3om^h20=@m6@030?ofkP3D?AT0e3dI01h0ooK^00<000000?of
kP3om^h0703om^h503eIZ`L0ooK^00<0?EV[0?ofkP0mFJ/02`3om^h00`0mFJ/0ooK^0?ofkP020?of
kP<0?EV[103om^h203eIZ`D0ooK^00<0?EV[0?ofkP3om^h04`3om^h203eIZ`030?ofkP0mFJ/0ooK^
01D0ooK^0P0mFJ/40?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<000000?ofkP3om^h0I03om^h10?oo
o`00I@3om^h00`000000ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3o
m^h04P3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^01<0ooK^0P3D?AT00`3om^h0
e3dI0=@m6@060?ofkP040=@m6@3om^h0ooK^0=@m6@@0ooK^0P3D?AT90?ofkPD0e3dI1P3om^h30=@m
6@030?ofkP3D?AT0ooK^01`0ooK^00<000000?ofkP3om^h06`3om^h00`0mFJ/0ooK^03eIZ`0203eI
Z`H0ooK^1@0mFJ/90?ofkP80?EV[103om^h0100mFJ/0ooK^0?ofkP0mFJ/60?ofkP80?EV[00<0ooK^
03eIZ`0mFJ/05@3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^0180ooK^00<0?EV[
0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP030000003om^h0ooK^06<0ooK^0@3oool0
06@0ooK^00<000000?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP060?ofkP80e3dI4@3om^h00`3D
?AT0ooK^0?ofkP040?ofkP80e3dI5@3om^h00`3D?AT0ooK^0?ofkP060?ofkP040=@m6@3om^h0ooK^
0?ofkP80e3dI103om^h00`3D?AT0ooK^0?ofkP060?ofkP060=@m6@3om^h0ooK^0=@m6@3om^h0e3dI
1P3om^h30=@m6@030?ofkP3D?AT0e3dI01/0ooK^00<000000?ofkP3om^h06@3om^h203eIZ`040?of
kP0mFJ/0?EV[03eIZ`H0ooK^00<0?EV[0?ofkP0mFJ/00P3om^h00`0mFJ/0ooK^0?ofkP060?ofkP03
03eIZ`3om^h0ooK^0080ooK^0P0mFJ/30?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3o
m^h04`3om^h203eIZ`H0ooK^00<0?EV[0?ofkP3om^h03`3om^h203eIZ`P0ooK^00<0?EV[0?ofkP3o
m^h03`3om^h00`000000ooK^0?ofkP1R0?ofkP40oooo001R0?ofkP8000004@3om^h00`3D?AT0ooK^
0?ofkP090?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^
0?ofkP0A0?ofkP040=@m6@3om^h0e3dI0=@m6@D0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0
ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00D0ooK^00@0e3dI0?ofkP3om^h0ooK^0`3D?AT70?of
kP80e3dI0P3om^h20=@m6AT0ooK^00<000000?ofkP3om^h05`3om^h203eIZ`80ooK^0P0mFJ/70?of
kP<0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?of
kP3om^h0103om^h00`0mFJ/0ooK^0?ofkP030?ofkP80?EV[00<0ooK^03eIZ`3om^h04P3om^h00`0m
FJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0m
FJ/0ooK^0?ofkP0?0?ofkP800000HP3om^h10?ooo`00H@3om^h00`000000ooK^0?ofkP0@0?ofkP03
0=@m6@3om^h0ooK^00/0ooK^0P3D?AT<0?ofkP030=@m6@3om^h0ooK^00T0ooK^0P3D?AT?0?ofkP80
e3dI103om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00D0ooK^0P3D?AT30?ofkP80
e3dI1@3om^h00`3D?AT0ooK^0?ofkP030?ofkP<0e3dI1@3om^h40=@m6@80ooK^00<0e3dI0?ofkP3o
m^h05P3om^h00`000000ooK^0?ofkP0F0?ofkP0303eIZ`3om^h0ooK^00@0?EV[1@3om^h303eIZ`D0
ooK^00<0?EV[0?ofkP3om^h00`3om^h203eIZ`<0ooK^0P0mFJ/70?ofkP0303eIZ`3om^h0ooK^0080
ooK^00<0?EV[0?ofkP3om^h00P3om^h203eIZ`l0ooK^0P0mFJ/;0?ofkP0303eIZ`3om^h0ooK^00X0
ooK^0P0mFJ/=0?ofkP0303eIZ`3om^h0ooK^0100ooK^00<000000?ofkP3om^h0G`3om^h10?ooo`00
H03om^h00`000000ooK^0?ofkP0@0?ofkP030=@m6@3om^h0ooK^00h0ooK^0P3D?AT90?ofkP030=@m
6@3om^h0ooK^00`0ooK^0P3D?AT<0?ofkP030=@m6@3om^h0ooK^00D0ooK^0P3D?AT20?ofkP030=@m
6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m
6@3om^h0ooK^00@0ooK^3@3D?AT00`3om^h0e3dI0=@m6@0F0?ofkP030000003om^h0ooK^01@0ooK^
0P0mFJ/00`3om^h0?EV[03eIZ`0;03eIZ`H0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^
0?ofkP020?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h00P0mFJ/70?ofkP0303eI
Z`3om^h0ooK^00X0ooK^0P0mFJ/>0?ofkP0303eIZ`3om^h0ooK^00L0ooK^0P0mFJ/@0?ofkP0303eI
Z`3om^h0ooK^0100ooK^00<000000?ofkP3om^h0GP3om^h10?ooo`00G`3om^h00`000000ooK^0?of
kP0@0?ofkP030=@m6@3om^h0ooK^0140ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?of
kP0?0?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0=@m
6@0:0?ofkP030=@m6@3om^h0ooK^0080ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@040?ofkP<0e3dI
00@0ooK^0=@m6@3D?AT0e3dI0`3om^h00`3D?AT0ooK^0?ofkP040=@m6@030?ofkP3D?AT0ooK^01@0
ooK^00<000000?ofkP3om^h04`3om^h00`0mFJ/0ooK^03eIZ`0303eIZ`80ooK^00@0?EV[0?ofkP3o
m^h0ooK^0`0mFJ/0103om^h0?EV[03eIZ`0mFJ/40?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/0103o
m^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0?EV[00X0ooK^00<0?EV[0?ofkP3om^h0203o
m^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h04@3o
m^h00`0mFJ/0ooK^0?ofkP0@0?ofkP030000003om^h0ooK^05d0ooK^0@3oool005h0ooK^00<00000
0?ofkP3om^h0403om^h00`3D?AT0ooK^0?ofkP0C0?ofkP80e3dI103om^h00`3D?AT0ooK^0?ofkP0A
0?ofkP80e3dI1`3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP80e3dI2`3om^h20=@m6@<0ooK^0P3D?AT0
0`3om^h0e3dI0=@m6@030=@m6@D0ooK^0`3D?AT30?ofkP040=@m6@3om^h0ooK^0?ofkPH0e3dI4`3o
m^h00`000000ooK^0?ofkP0A0?ofkPH0?EV[0`3om^h0100mFJ/0ooK^0?ofkP3om^h303eIZ`D0ooK^
1@0mFJ/00`3om^h0?EV[03eIZ`030?ofkP80?EV[2`3om^h203eIZ``0ooK^00<0?EV[0?ofkP3om^h0
1@3om^h203eIZa<0ooK^00<0?EV[0?ofkP3om^h00P3om^h203eIZa@0ooK^00<0?EV[0?ofkP3om^h0
4@3om^h00`000000ooK^0?ofkP1L0?ofkP40oooo001L0?ofkP8000004`3om^h00`3D?AT0ooK^0?of
kP0E0?ofkP80e3dI00<0ooK^0=@m6@3om^h05@3om^h00`3D?AT0ooK^0?ofkP020?ofkP80e3dI3P3o
m^h30=@m6@/0ooK^00<0e3dI0?ofkP3om^h00P3om^h20=@m6@/0ooK^0`3D?AT00`3om^h0e3dI0?of
kP030?ofkP<0e3dI00<0ooK^0=@m6@3D?AT04P3om^h00`000000ooK^0?ofkP0@0?ofkP80?EV[00@0
ooK^03eIZ`0mFJ/0?EV[103om^h00`0mFJ/0ooK^03eIZ`0203eIZ`/0ooK^0P0mFJ/40?ofkP0303eI
Z`3om^h0ooK^00T0ooK^0`0mFJ/>0?ofkP80?EV[103om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP0403eI
Z`3om^h0?EV[03eIZaL0ooK^00<0?EV[0?ofkP3om^h04@3om^h2000005`0ooK^0@3oool005/0ooK^
00<000000?ofkP3om^h04P3om^h00`3D?AT0ooK^0?ofkP0H0?ofkP030=@m6@3om^h0ooK^01H0ooK^
0P3D?AT00`3om^h0e3dI0?ofkP0?0?ofkP040=@m6@3om^h0ooK^0=@m6@/0ooK^103D?AT00`3om^h0
e3dI0=@m6@0;0?ofkP<0e3dI00<0ooK^0=@m6@3om^h0103om^h20=@m6@80ooK^00<0e3dI0?ofkP3o
m^h03`3om^h00`000000ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^0080?EV[1@3om^h00`0mFJ/0
ooK^03eIZ`0203eIZ`/0ooK^0P0mFJ/00`3om^h0?EV[03eIZ`0203eIZ`/0ooK^00@0?EV[0?ofkP3o
m^h0?EV[403om^h0100mFJ/0ooK^03eIZ`0mFJ/H0?ofkP0303eIZ`3om^h0ooK^01P0ooK^00<0?EV[
0?ofkP3om^h04P3om^h00`000000ooK^0?ofkP1I0?ofkP40oooo001J0?ofkP030000003om^h0ooK^
0180ooK^00<0e3dI0?ofkP3om^h0603om^h0103D?AT0ooK^0=@m6@3D?ATH0?ofkP030=@m6@3om^h0
ooK^00l0ooK^00@0e3dI0?ofkP3om^h0ooK^0P3D?AT90?ofkP<0e3dI0P3om^h0103D?AT0ooK^0=@m
6@3D?AT;0?ofkP<0e3dI1P3om^h30=@m6@030?ofkP3D?AT0e3dI00l0ooK^00<000000?ofkP3om^h0
3@3om^h203eIZ`040?ofkP0mFJ/0?EV[03eIZ`H0ooK^0`0mFJ/<0?ofkP0303eIZ`3om^h0?EV[0080
ooK^0`0mFJ/90?ofkP80?EV[0`3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^01H0
ooK^0P0mFJ/00`3om^h0?EV[0?ofkP0I0?ofkP0303eIZ`3om^h0ooK^0180ooK^00<000000?ofkP3o
m^h0F03om^h10?ooo`00F@3om^h00`000000ooK^0?ofkP0B0?ofkP040=@m6@3om^h0e3dI0=@m6AL0
ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP0D0?ofkP040=@m6@3om^h0e3dI0=@m
6@h0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP040?ofkP80e3dI0`3om^h30=@m
6@<0ooK^00<0e3dI0?ofkP3om^h02@3om^h30=@m6@L0ooK^1@3D?AT>0?ofkP030000003om^h0ooK^
00`0ooK^1@0mFJ/70?ofkP<0?EV[2`3om^h203eIZ`80ooK^0`0mFJ/30?ofkP80?EV[1P3om^h00`0m
FJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00`0ooK^0P0mFJ/00`3om^h0?EV[0?ofkP0E0?of
kP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h05@3om^h203eIZ`030?ofkP0mFJ/0ooK^
01<0ooK^00<000000?ofkP3om^h0E`3om^h10?ooo`00F03om^h00`000000ooK^0?ofkP0C0?ofkP04
0=@m6@3om^h0ooK^0?ofkP80e3dI503om^h00`3D?AT0ooK^0?ofkP040?ofkP80e3dI4`3om^h00`3D
?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h01@3om^h20=@m
6@80ooK^0P3D?AT70?ofkP030=@m6@3om^h0ooK^0080ooK^0P3D?AT;0?ofkP80e3dI1`3om^h30=@m
6@030?ofkP3D?AT0ooK^00`0ooK^00<000000?ofkP3om^h02`3om^h00`0mFJ/0ooK^03eIZ`0203eI
Z`L0ooK^0P0mFJ/;0?ofkP80?EV[103om^h00`0mFJ/0ooK^0?ofkP050?ofkP80?EV[0P3om^h203eI
Z`L0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^
0140ooK^0P0mFJ/50?ofkP0303eIZ`3om^h0ooK^01<0ooK^0P0mFJ/30?ofkP0303eIZ`3om^h0ooK^
01<0ooK^00<000000?ofkP3om^h0EP3om^h10?ooo`00E`3om^h00`000000ooK^0?ofkP0C0?ofkP03
0=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h04@3om^h00`3D?AT0ooK^0?ofkP060?ofkP03
0=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h0103om^h20=@m6@/0ooK^00<0e3dI0?ofkP3o
m^h01`3om^h20=@m6@T0ooK^0`3D?AT40?ofkP80e3dI2@3om^h40=@m6@L0ooK^1@3D?AT;0?ofkP03
0000003om^h0ooK^00T0ooK^1@0mFJ/70?ofkP@0?EV[2P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP<0
?EV[2@3om^h203eIZ`T0ooK^00<0?EV[0?ofkP3om^h02@3om^h203eIZ`H0ooK^00<0?EV[0?ofkP3o
m^h03`3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^0140ooK^00<0?EV[0?ofkP3o
m^h0103om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP030000003om^h0ooK^05D0ooK^0@3oool005D0ooK^
0P00000E0?ofkP030=@m6@3om^h0ooK^00H0ooK^0P3D?AT@0?ofkP030=@m6@3om^h0ooK^00P0ooK^
0P3D?AT>0?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^
0?ofkP060?ofkP040=@m6@3om^h0e3dI0=@m6@P0ooK^00@0e3dI0?ofkP3om^h0e3dI1@3om^h20=@m
6@L0ooK^00<0e3dI0?ofkP3om^h00P3D?AT70?ofkP<0e3dI00<0ooK^0=@m6@3om^h02@3om^h00`00
0000ooK^0?ofkP080?ofkP0303eIZ`3om^h0?EV[0080?EV[1`3om^h203eIZ`80ooK^00<0?EV[0?of
kP3om^h01P3om^h203eIZ`@0ooK^00@0?EV[0?ofkP3om^h0?EV[203om^h203eIZ`030?ofkP0mFJ/0
?EV[00L0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0
ooK^00`0ooK^0P0mFJ/:0?ofkP0303eIZ`3om^h0ooK^00h0ooK^0P0mFJ/80?ofkP0303eIZ`3om^h0
ooK^01<0ooK^0P00001E0?ofkP40oooo001D0?ofkP030000003om^h0ooK^01D0ooK^00<0e3dI0?of
kP3om^h0203om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00/0ooK^0P3D?AT;0?of
kP030=@m6@3om^h0ooK^00T0ooK^0P3D?AT80?ofkP<0e3dI103om^h20=@m6@@0ooK^00<0e3dI0?of
kP3om^h01@3om^h0103D?AT0ooK^0?ofkP3om^h20=@m6@D0ooK^00<0e3dI0?ofkP3om^h0103om^h0
103D?AT0ooK^0?ofkP3om^h30=@m6@L0ooK^103D?AT90?ofkP030000003om^h0ooK^00L0ooK^100m
FJ/70?ofkP<0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^0080ooK^0P0m
FJ/30?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?of
kP020?ofkP<0?EV[2@3om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^00T0ooK^0P0m
FJ/=0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?of
kP0E0?ofkP030000003om^h0ooK^0580ooK^0@3oool005<0ooK^00<000000?ofkP3om^h05@3om^h0
0`3D?AT0ooK^0?ofkP0:0?ofkP80e3dI2`3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0
ooK^00L0ooK^00<0e3dI0?ofkP3om^h0303om^h20=@m6@D0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m
6@020?ofkP030=@m6@3om^h0ooK^00D0ooK^0P3D?AT40?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0
e3dI0?ofkP3om^h00`3om^h20=@m6@@0ooK^00<0e3dI0?ofkP3om^h00P3om^h?0=@m6@D0ooK^0P00
00000`3om^h00000000000050?ofkPl0?EV[103om^h00`0mFJ/0ooK^0?ofkP030?ofkP80?EV[103o
m^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^0080ooK^0P0mFJ/70?ofkP0403eIZ`3o
m^h0ooK^03eIZ`<0ooK^00<0?EV[0?ofkP3om^h0103om^h203eIZ`d0ooK^00<0?EV[0?ofkP3om^h0
1`3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00T0ooK^0P0mFJ/<0?ofkP0303eI
Z`3om^h0ooK^01D0ooK^00<000000?ofkP3om^h0D@3om^h10?ooo`00DP3om^h00`000000ooK^0?of
kP0E0?ofkP030=@m6@3om^h0ooK^00d0ooK^0P3D?AT80?ofkP030=@m6@3om^h0ooK^0100ooK^0P3D
?AT60?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?of
kP020?ofkP80e3dI2P3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00L0ooK^0P3D?AT50?ofkP80e3dI
0P3om^h50=@m6@80ooK^0`3D?AT50?ofkP030=@m6@3om^h0e3dI00<0e3dI0`3om^h00`000000ooK^
0?ofkP030?ofkP040000003om^h0ooK^0?ofkP@0?EV[00<0ooK^03eIZ`3om^h0103om^h303eIZ`80
ooK^1@0mFJ/30?ofkP80?EV[103om^h203eIZ`L0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0:0?of
kP80?EV[103om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?of
kP3om^h0103om^h203eIZa80ooK^00<0?EV[0?ofkP3om^h01P3om^h203eIZ`h0ooK^00<0?EV[0?of
kP3om^h05P3om^h00`000000ooK^0?ofkP1@0?ofkP40oooo001A0?ofkP030000003om^h0ooK^01H0
ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^01<0
ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP0A0?ofkP80e3dI0P3om^h00`3D?AT0
ooK^0?ofkP020?ofkP030=@m6@3om^h0e3dI00X0ooK^00@0e3dI0?ofkP3om^h0e3dI2@3om^h00`3D
?AT0ooK^0?ofkP040?ofkP<0e3dI1`3om^h30=@m6@@0ooK^00<0e3dI0?ofkP3om^h0103D?AT20000
00L0ooK^0P00000403eIZ`80ooK^00<0?EV[0?ofkP3om^h00P3om^h303eIZ`L0ooK^100mFJ/50?of
kP0303eIZ`3om^h0ooK^00L0ooK^00@0?EV[0?ofkP3om^h0?EV[2P3om^h0100mFJ/0ooK^0?ofkP0m
FJ/30?ofkP0403eIZ`3om^h0ooK^0?ofkP80?EV[4P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eI
Z`3om^h0ooK^0180ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eI
Z`3om^h0ooK^01H0ooK^00<000000?ofkP3om^h0C`3om^h10?ooo`00C`3om^h2000001P0ooK^00<0
e3dI0?ofkP3om^h04@3om^h20=@m6@@0ooK^00<0e3dI0?ofkP3om^h0503om^h20=@m6@030?ofkP3D
?AT0ooK^01D0ooK^0P3D?AT30?ofkP80e3dI0`3om^h20=@m6@T0ooK^0`3D?AT:0?ofkP040=@m6@3o
m^h0ooK^0?ofkP80e3dI00@0ooK^0=@m6@3D?AT0e3dI203om^h30=@m6@80ooK^00<0e3dI0?ofkP3o
m^h00P3om^h0103D?AT000000=@m6@3D?AT70?ofkP80?EV[00<0000003eIZ`3om^h00`3om^h00`0m
FJ/0ooK^0?ofkP0303eIZ`P0ooK^00D0?EV[0?ofkP0mFJ/0?EV[0?ofkP0203eIZ`80ooK^00<0?EV[
0?ofkP3om^h0203om^h303eIZ`T0ooK^0P0mFJ/40?ofkP0703eIZ`3om^h0ooK^0?ofkP0mFJ/0ooK^
03eIZ`0E0?ofkP0403eIZ`3om^h0?EV[03eIZaH0ooK^00<0?EV[0?ofkP3om^h00P3om^h203eIZa<0
ooK^00<0?EV[0?ofkP3om^h05P3om^h2000004l0ooK^0@3oool004h0ooK^00<000000?ofkP3om^h0
603om^h00`3D?AT0ooK^0?ofkP0C0?ofkP80e3dI00<0ooK^0=@m6@3om^h0603om^h00`3D?AT0ooK^
0?ofkP0F0?ofkP80e3dI00<0ooK^0=@m6@3om^h01P3om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m
6@3om^h0ooK^00T0ooK^0`3D?AT50?ofkP030=@m6@3om^h0ooK^00L0ooK^0`3D?AT20?ofkP050=@m
6@3om^h0ooK^0?ofkP0000000P3D?AT00`3om^h0e3dI0?ofkP040?ofkP0503eIZ`3om^h0?EV[03eI
Z`0000000`3om^h00`0mFJ/0ooK^0?ofkP0303eIZ`T0ooK^0P0mFJ/50?ofkP80?EV[2`3om^h00`0m
FJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00D0ooK^0P0mFJ/00`3om^h0?EV[03eIZ`0G0?of
kP0303eIZ`3om^h0ooK^01L0ooK^00@0?EV[0?ofkP0mFJ/0?EV[5@3om^h00`0mFJ/0ooK^0?ofkP0H
0?ofkP030000003om^h0ooK^04`0ooK^0@3oool004d0ooK^00<000000?ofkP3om^h0603om^h00`3D
?AT0ooK^0?ofkP0F0?ofkP030=@m6@3om^h0ooK^01L0ooK^00@0e3dI0?ofkP3D?AT0e3dI5P3om^h0
0`3D?AT0ooK^0=@m6@090?ofkP030=@m6@3om^h0ooK^00L0ooK^0`3D?AT80?ofkP80e3dI00<0ooK^
0=@m6@3om^h0103om^h20=@m6@X0ooK^103D?AT00`3om^h00000000000020?ofkPD0e3dI00<00000
03eIZ`0mFJ/00`0mFJ/20?ofkP80000000<0ooK^03eIZ`0mFJ/00P0mFJ/:0?ofkP80?EV[1@3om^h0
100mFJ/0ooK^0?ofkP0mFJ/80?ofkP<0?EV[2@3om^h00`0mFJ/0ooK^0?ofkP080?ofkP80?EV[5P3o
m^h203eIZ`030?ofkP0mFJ/0ooK^01P0ooK^00<0?EV[0?ofkP3om^h05P3om^h00`0mFJ/0ooK^0?of
kP0H0?ofkP030000003om^h0ooK^04/0ooK^0@3oool004`0ooK^00<000000?ofkP3om^h0603om^h0
0`3D?AT0ooK^0?ofkP0F0?ofkP040=@m6@3om^h0e3dI0=@m6AH0ooK^00<0e3dI0?ofkP3om^h00P3o
m^h00`3D?AT0ooK^0?ofkP0B0?ofkP040=@m6@3om^h0e3dI0?ofkP80e3dI203om^h20=@m6@L0ooK^
00@0e3dI0?ofkP3om^h0e3dI1@3om^h20=@m6@@0ooK^0P3D?AT30?ofkP040=@m6@3om^h0e3dI0=@m
6@T0ooK^00@0e3dI0?ofkP3D?AT000001P3om^h01`3D?AT000000=@m6@000000?EV[0000000mFJ/0
1P3om^h010000000?EV[0?ofkP0mFJ/:0?ofkP0303eIZ`3om^h0?EV[00<0ooK^0P0mFJ/40?ofkP80
?EV[1@3om^h0100mFJ/0ooK^0?ofkP0mFJ/70?ofkP80?EV[2@3om^h203eIZ`030?ofkP0mFJ/0ooK^
01@0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP80?EV[00<0ooK^03eI
Z`3om^h05`3om^h00`0mFJ/0ooK^0?ofkP0H0?ofkP030000003om^h0ooK^04X0ooK^0@3oool004/0
ooK^00<000000?ofkP3om^h06@3om^h00`3D?AT0ooK^0?ofkP0F0?ofkP050=@m6@3om^h0ooK^0?of
kP3D?AT0503om^h00`3D?AT0ooK^0?ofkP040?ofkP80e3dI4P3om^h20=@m6@@0ooK^00<0e3dI0?of
kP3om^h01`3om^h00`3D?AT0ooK^0?ofkP040?ofkP040=@m6@3om^h0ooK^0?ofkP80e3dI00<0ooK^
0=@m6@3D?AT0203om^h0103D?AT0ooK^0?ofkP3D?AT30?ofkP030=@m6@3om^h0ooK^00L0ooK^0P00
00020=@m6@@0ooK^0P0000020=@m6@030000000mFJ/0?EV[00800000103om^h203eIZ`8000002P3o
m^h0100mFJ/0ooK^0?ofkP0mFJ/20?ofkP0303eIZ`3om^h0ooK^00H0ooK^0P0mFJ/00`3om^h0?EV[
03eIZ`030?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h01`3om^h203eIZ`@0ooK^
00<0?EV[0?ofkP3om^h0403om^h203eIZ`D0ooK^00<0?EV[0?ofkP3om^h04`3om^h01@0mFJ/0ooK^
0?ofkP3om^h0?EV[01P0ooK^00<0?EV[0?ofkP3om^h06@3om^h00`000000ooK^0?ofkP190?ofkP40
oooo00190?ofkP8000006`3om^h00`3D?AT0ooK^0?ofkP0F0?ofkP030=@m6@3om^h0ooK^00<0ooK^
0P3D?ATB0?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^
0?ofkP040?ofkP80e3dI203om^h20=@m6@<0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^
0?ofkP090?ofkP<0e3dI103om^h00`3D?AT0ooK^0?ofkP050?ofkP070000003om^h0ooK^0=@m6@3o
m^h0e3dI0?ofkP020000000500H84@0000001PPA00H84@3D?AT00P2:8Pd020000000e3dI00000000
0000ooK^03eIZ`3om^h0?EV[0P3om^h00`000000ooK^0?ofkP050?ofkP80?EV[0`3om^h303eIZ`/0
ooK^00<0?EV[0?ofkP3om^h0103om^h0100mFJ/0ooK^0?ofkP3om^h203eIZ`T0ooK^00<0?EV[0?of
kP3om^h0103om^h203eIZa00ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP0@0?of
kP80?EV[1@3om^h00`0mFJ/0ooK^0?ofkP0F0?ofkP0303eIZ`3om^h0ooK^01T0ooK^0P0000190?of
kP40oooo00180?ofkP030000003om^h0ooK^01X0ooK^00@0e3dI0?ofkP3D?AT0e3dI5@3om^h00`3D
?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D
?AT0ooK^0?ofkP0=0?ofkP80e3dI203om^h20=@m6@P0ooK^00@0e3dI0?ofkP3om^h0e3dI103om^h2
0=@m6@030?ofkP3D?AT0e3dI00/0ooK^00<0e3dI0?ofkP3om^h00`3om^h20=@m6@<0ooK^0P000003
0?ofkP<0e3dI00@0000000H84@06214000000`06214020000000RR8=08XR3@2:8Pd000000=@m6@1L
50P000000`0mFJ/30?ofkP800000103om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^
00T0ooK^0P0mFJ/00`3om^h0?EV[03eIZ`040?ofkP0403eIZ`3om^h0ooK^03eIZ`T0ooK^0P0mFJ/7
0?ofkP0303eIZ`3om^h0?EV[00h0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP0>
0?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h04`3om^h203eIZ`030?ofkP0mFJ/0
ooK^01/0ooK^00<000000?ofkP3om^h0AP3om^h10?ooo`00A`3om^h00`000000ooK^0?ofkP0K0?of
kP040=@m6@3om^h0ooK^0?ofkP80e3dI4`3om^h00`3D?AT0ooK^0?ofkP070?ofkP80e3dI3@3om^h0
0`3D?AT0ooK^0?ofkP0:0?ofkP80e3dI2`3om^h30=@m6@/0ooK^00<0e3dI0?ofkP3om^h01P3om^h3
0=@m6@<0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP080?ofkP<0e3dI1@3om^h0
0`3D?AT0ooK^000000050?ofkP040=@m6@3om^h000000=@m6@800000100621400`000000RR8=08XR
3@0208XR3@80000000@0?EV[05`D203om^h0?EV[1@3om^h010000000ooK^03eIZ`0mFJ/40?ofkP<0
?EV[2P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0403eIZ`3om^h0ooK^0?ofkP<0?EV[203om^h203eI
Z`X0ooK^00<0?EV[0?ofkP0mFJ/02`3om^h203eIZ``0ooK^00<0?EV[0?ofkP3om^h02`3om^h203eI
Z`T0ooK^00<0?EV[0?ofkP3om^h04@3om^h203eIZ`<0ooK^00<0?EV[0?ofkP3om^h06`3om^h00`00
0000ooK^0?ofkP150?ofkP40oooo00160?ofkP030000003om^h0ooK^01/0ooK^00<0e3dI0?ofkP3o
m^h0103om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00X0ooK^0P3D?AT:0?ofkP03
0=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h01`3om^h0103D?AT0ooK^0?ofkP3D?AT<0?of
kP80e3dI203om^h0103D?AT0ooK^0?ofkP3D?AT70?ofkP80e3dI203om^h0103D?AT0ooK^0?ofkP3D
?AT50?ofkP030000003om^h0ooK^00@0ooK^00D0e3dI00000006214000000=@m6@0400H84@<00000
102:8Pd01@0mFJ/0000005`D201L50P0?EV[00H0ooK^00<000000?ofkP3om^h00`3om^h0100mFJ/0
ooK^0?ofkP0mFJ/80?ofkP80?EV[1`3om^h0100mFJ/0ooK^0?ofkP0mFJ/80?ofkP80?EV[303om^h0
100mFJ/0ooK^0?ofkP0mFJ/90?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h0203o
m^h203eIZ``0ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3o
m^h0ooK^01/0ooK^00<000000?ofkP3om^h0A03om^h10?ooo`00A@3om^h00`000000ooK^0?ofkP0L
0?ofkP030=@m6@3om^h0ooK^00D0ooK^0P3D?AT>0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI
0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP80e3dI1P3om^h01@3D?AT0ooK^0?ofkP3o
m^h0e3dI00h0ooK^00<0e3dI0?ofkP3om^h01@3om^h30=@m6@X0ooK^0P3D?AT60?ofkP040=@m6@3o
m^h0ooK^0?ofkP80e3dI00@0ooK^000000000000ooK^0P3D?AT20?ofkP030=@m6@000000e3dI00<0
000000<01PPA0=@m6@3D?AT00P0000000`0;3b0000000;8^4@0200000080?EV[00H0RR8=00000000
0000000003eIZ`0000030?ofkP80?EV[00@0ooK^000000000000ooK^0P0mFJ/30?ofkP0303eIZ`3o
m^h0ooK^00@0ooK^0P0mFJ/:0?ofkP<0?EV[1`3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0503eIZ`3o
m^h0ooK^0?ofkP0mFJ/01P3om^h203eIZa40ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^
0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00d0ooK^0P0mFJ/70?ofkP0303eIZ`3om^h0ooK^01`0ooK^
00<000000?ofkP3om^h0@`3om^h10?ooo`00A03om^h00`000000ooK^0?ofkP0L0?ofkP030=@m6@3o
m^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP80e3dI1@3o
m^h00`3D?AT0ooK^0?ofkP0B0?ofkP030=@m6@3om^h0ooK^0080ooK^00D0e3dI0?ofkP3om^h0ooK^
0=@m6@0@0?ofkP80e3dI103om^h20=@m6@80ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^
0?ofkP020?ofkP030=@m6@3om^h0ooK^00@0ooK^00<000000?ofkP3om^h00`3om^h20=@m6@030000
00062140e3dI00801PPA00D0000000H84@06214000000=@m6@0200/?80050000002b;Q40/RhA03eI
Z`0000000P2:8Pd01P000000RR8=08XR3@0mFJ/0G1@800000080?EV[1@3om^h00`000000ooK^0?of
kP040?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h02@3om^h0100mFJ/0ooK^0?of
kP0mFJ/50?ofkP80?EV[403om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00@0ooK^00<0?EV[0?ofkP3o
m^h04@3om^h00`0mFJ/0ooK^0?ofkP040?ofkP80?EV[403om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP03
03eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h0703om^h00`000000ooK^0?ofkP120?ofkP40
oooo00120?ofkP8000007`3om^h00`3D?AT0ooK^0?ofkP090?ofkP80e3dI2P3om^h00`3D?AT0ooK^
0?ofkP0A0?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h04`3om^h20=@m6@030?of
kP3D?AT0ooK^00<0ooK^00<0e3dI0?ofkP3om^h0403om^h20=@m6@030?ofkP3D?AT0e3dI00@0ooK^
0P3D?AT:0?ofkP80e3dI0P3om^h00`3D?AT0ooK^0?ofkP020?ofkP80000000@0ooK^0=@m6@3D?AT0
ooK^0P3D?AT01`3om^h00000000000000000e3dI00H84@0000000P0621400`0000002`lP00/?8002
0=@m6@030000000mFJ/0?EV[0080/RhA00H0000008XR3@2:8Pd0000003eIZ`2:8Pd3000000040?of
kP0mFJ/0?EV[0?ofkP80?EV[00<0ooK^000000000000103om^h00`0mFJ/0ooK^0?ofkP0203eIZ`X0
ooK^0P0mFJ/40?ofkP80?EV[00<0ooK^03eIZ`0mFJ/04P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP04
03eIZ`3om^h0?EV[03eIZaD0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP0A0?of
kP0303eIZ`3om^h0ooK^00P0ooK^0P0mFJ/;0?ofkP0303eIZ`3om^h0ooK^01d0ooK^0P0000120?of
kP40oooo00110?ofkP030000003om^h0ooK^01h0ooK^00<0e3dI0?ofkP3om^h0303om^h20=@m6@P0
ooK^00<0e3dI0?ofkP3om^h04P3om^h20=@m6@030?ofkP3D?AT0ooK^01L0ooK^00<0e3dI0?ofkP3o
m^h00`3om^h30=@m6A80ooK^00<0e3dI0?ofkP3D?AT01P3om^h20=@m6@X0ooK^00<0e3dI0?ofkP3D
?AT00`3om^h00`000000ooK^0?ofkP020?ofkP<0e3dI0`00000300H84@040=@m6@00000000000000
00D02`lP00<0e3dI0;8^4@2b;Q400`2b;Q430000000403eIZ`2:8Pd0RR8=08XR3@<000000`0mFJ/4
0?ofkP070000003om^h0ooK^0?ofkP0mFJ/0ooK^03eIZ`0:0?ofkP80?EV[1P3om^h00`0mFJ/0ooK^
03eIZ`0B0?ofkP<0?EV[1@3om^h00`0mFJ/0ooK^0?ofkP0F0?ofkP0403eIZ`3om^h0?EV[03eIZa@0
ooK^00<0?EV[0?ofkP3om^h01P3om^h203eIZ`h0ooK^00<0?EV[0?ofkP3om^h07P3om^h00`000000
ooK^0?ofkP0o0?ofkP40oooo00100?ofkP030000003om^h0ooK^01h0ooK^00<0e3dI0?ofkP3om^h0
3`3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^01D0ooK^00<0e3dI0?ofkP3om^h0
5P3om^h0103D?AT0ooK^0=@m6@3D?AT20?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT0403om^h0103D
?AT0ooK^0=@m6@3D?AT80?ofkP030=@m6@3om^h0ooK^00P0ooK^0P3D?AT00`3om^h0000000000003
0?ofkP80e3dI0P3om^h00`000000e3dI00H84@0400H84@030=@m6@0000002`lP00H02`lP00<00000
0;8^4@2b;Q401@2b;Q400`000000?EV[08XR3@0408XR3@0403eIZ`000000ooK^0?ofkP80?EV[0`3o
m^h2000000030?ofkP0mFJ/0?EV[00X0ooK^00<0?EV[0?ofkP3om^h01P3om^h203eIZ`030?ofkP0m
FJ/0ooK^00l0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`020?ofkP80?EV[00<0ooK^03eIZ`3om^h0
5`3om^h00`0mFJ/0ooK^0?ofkP0E0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h0
3`3om^h00`0mFJ/0ooK^0?ofkP0N0?ofkP030000003om^h0ooK^03h0ooK^0@3oool003l0ooK^00<0
00000?ofkP3om^h07`3om^h00`3D?AT0ooK^0?ofkP0@0?ofkP80e3dI0`3om^h00`3D?AT0ooK^0?of
kP0E0?ofkP040=@m6@3om^h0e3dI0=@m6AD0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^
0=@m6@040?ofkP80e3dI3@3om^h01P3D?AT0ooK^0?ofkP3D?AT0ooK^0=@m6@P0ooK^0P3D?AT90?of
kP030=@m6@000000e3dI0080ooK^0P3D?AT20?ofkP@000000P3D?AT200H84@030000003D?AT00000
00L02`lP00<000000;8^4@2b;Q401@2b;Q400`000000?EV[0000000208XR3@80?EV[100000020?of
kP80?EV[0P3om^h00`0mFJ/0000003eIZ`090?ofkP80?EV[203om^h203eIZ`<0ooK^00<0?EV[0?of
kP3om^h02`3om^h203eIZ`@0ooK^00<0?EV[0?ofkP0mFJ/0103om^h00`0mFJ/0ooK^0?ofkP0C0?of
kP80?EV[00<0ooK^03eIZ`3om^h05P3om^h0100mFJ/0ooK^0?ofkP3om^h203eIZa80ooK^00<0?EV[
0?ofkP3om^h07`3om^h00`000000ooK^0?ofkP0m0?ofkP40oooo000n0?ofkP030000003om^h0ooK^
01l0ooK^00<0e3dI0?ofkP3om^h04`3om^h20=@m6@030?ofkP3D?AT0ooK^01H0ooK^00@0e3dI0?of
kP3om^h0ooK^0P3D?ATC0?ofkP030=@m6@3om^h0ooK^00<0ooK^0P3D?AT60?ofkP030=@m6@3om^h0
ooK^00T0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@020?ofkP80e3dI203om^h00`3D?AT0ooK^0?of
kP060?ofkP030000003om^h0ooK^0080e3dI0`3om^h2000000801PPA00P0000000H84@062140e3dI
0000000;3b00e3dI000000D02`lP1@0000050;8^4@050000000mFJ/0/RhA0000000mFJ/00P2:8Pd0
0`000000RR8=08XR3@02000000<0ooK^0P0mFJ/20?ofkP030000003om^h0ooK^00H0ooK^00<0?EV[
0?ofkP3om^h01P3om^h203eIZ`80ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0;0?ofkP0303eIZ`3o
m^h0ooK^00@0ooK^0P0mFJ/50?ofkP0303eIZ`3om^h0ooK^0140ooK^0P0mFJ/30?ofkP0303eIZ`3o
m^h0ooK^01D0ooK^00@0?EV[0?ofkP0mFJ/0?EV[5@3om^h00`0mFJ/0ooK^0?ofkP0O0?ofkP030000
003om^h0ooK^03`0ooK^0@3oool003`0ooK^0P00000R0?ofkP030=@m6@3om^h0ooK^01D0ooK^00<0
e3dI0?ofkP3om^h05@3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0
e3dI0?ofkP3om^h0103om^h0103D?AT0ooK^0=@m6@3D?AT50?ofkP80e3dI203om^h00`3D?AT0ooK^
0?ofkP020?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h01P3om^h20=@m6@@0ooK^
0P0000030=@m6@030?ofkP3D?AT0e3dI00<000000P0621400`0000001PPA00H84@02000000<0e3dI
00<0000000/?800;3b000P0;3b001000000051Xl01@J?00000020=@i5P030000002b;Q40/RhA0080
/RhA00@0000003eIZ`0mFJ/0?EV[0P00000208XR3@030000002:8Pd0RR8=00<000000P0mFJ/0103o
m^h0?EV[03eIZ`0mFJ/2000000@0ooK^0P0mFJ/80?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[
0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP060?ofkP80?EV[1@3om^h203eIZ`030?ofkP0mFJ/0
ooK^00D0ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0
ooK^01D0ooK^00<0?EV[0?ofkP3om^h05@3om^h00`0mFJ/0ooK^0?ofkP0P0?ofkP800000?03om^h1
0?ooo`00>`3om^h00`000000ooK^0?ofkP0Q0?ofkP030=@m6@3om^h0ooK^01D0ooK^00@0e3dI0?of
kP3D?AT0e3dI503om^h00`3D?AT0ooK^0?ofkP060?ofkP80e3dI3P3om^h00`3D?AT0ooK^0?ofkP05
0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT01P3om^h00`3D?AT0ooK^0?ofkP030?ofkP80e3dI1@3o
m^h00`3D?AT0ooK^0?ofkP030?ofkP80e3dI203om^h20=@m6@030?ofkP000000ooK^0080e3dI103o
m^h3000000<01PPA0`00000400/?80040=@m6@0000002`lP00/?808000000`0D6S`010000000e3TF
0=@i5P3D>AH200000080/RhA00<0000003eIZ`2b;Q400`2b;Q43000000<0RR8=0`0000040?ofkP80
?EV[00<0ooK^0000003om^h00P0mFJ/80?ofkP80?EV[1@3om^h00`0mFJ/0ooK^0?ofkP030?ofkP80
?EV[1@3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/01`3om^h00`0m
FJ/0ooK^0?ofkP0<0?ofkP80?EV[203om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP80?EV[00<0ooK^03eI
Z`3om^h05P3om^h00`0mFJ/0ooK^0?ofkP0Q0?ofkP030000003om^h0ooK^03T0ooK^0@3oool003X0
ooK^00<000000?ofkP3om^h08P3om^h00`3D?AT0ooK^0?ofkP0E0?ofkP040=@m6@3om^h0ooK^0?of
kP80e3dI4P3om^h00`3D?AT0ooK^0?ofkP080?ofkP80e3dI2`3om^h00`3D?AT0ooK^0?ofkP050?of
kP030=@m6@3om^h0ooK^00<0ooK^0P3D?AT50?ofkP80e3dI0P3om^h00`3D?AT0ooK^0?ofkP040?of
kP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h01P3om^h2000000030?ofkP3D?AT0e3dI
00@0ooK^0P00000500H84@030000000;3b002`lP00@02`lP0P3D?AT2000000D051Xl00<000000=@i
5P3D>AH00`3D>AH200000080?EV[1P2b;Q400`000000RR8=08XR3@0308XR3@800000103om^h203eI
Z`030?ofkP000000000000P0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP050?of
kP0303eIZ`3om^h0ooK^0080?EV[1@3om^h203eIZ`D0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0m
FJ/0ooK^0?ofkP090?ofkP80?EV[2P3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP80?EV[0`3om^h00`0m
FJ/0ooK^0?ofkP0E0?ofkP0303eIZ`3om^h0ooK^0280ooK^00<000000?ofkP3om^h0>03om^h10?oo
o`00>@3om^h00`000000ooK^0?ofkP0R0?ofkP030=@m6@3om^h0ooK^01D0ooK^00<0e3dI0?ofkP3o
m^h0103om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00/0ooK^0P3D?AT80?ofkP03
0=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP040?ofkP80
e3dI1`3om^h00`3D?AT0ooK^0?ofkP070?ofkP80e3dI1@3om^h00`000000ooK^0=@m6@030=@m6@80
ooK^1000000300H84@<000001P0;3b00103D?AT000000=@m6@3D?AT501@J?0030000003D>AH0e3TF
00<0e3TF0P0mFJ/00`000000?EV[0;8^4@050;8^4@<000000`2:8Pd400000080ooK^100mFJ/00`3o
m^h000000?ofkP040?ofkP80?EV[2@3om^h00`0mFJ/0ooK^0?ofkP050?ofkP80?EV[1P3om^h00`0m
FJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h01P3om^h203eI
Z`d0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^
01D0ooK^00<0?EV[0?ofkP3om^h08P3om^h00`000000ooK^0?ofkP0g0?ofkP40oooo000h0?ofkP03
0000003om^h0ooK^02<0ooK^0`3D?ATE0?ofkP030=@m6@3om^h0ooK^00D0ooK^0P3D?AT=0?ofkP03
0=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP060?ofkP03
0=@m6@3om^h0ooK^00L0ooK^0P3D?AT40?ofkP030=@m6@3om^h0e3dI00H0ooK^00<0e3dI0?ofkP3o
m^h02@3om^h00`3D?AT0ooK^0?ofkP02000000030?ofkP3D?AT0ooK^0080ooK^00@0e3dI0?ofkP00
000000000P062140100000001PPA00H84@00000200/?80030000000;3b002`lP00<02`lP00<00000
0=@m6@0000000P0D6S`00`3D?AT051Xl01@J?00201@J?0030000003D>AH0e3TF0080e3TF00H0?EV[
0=@i5P3D>AH0000003eIZ`0000050;8^4@040000002b;Q40/RhA00000080RR8=00<0000008XR3@2:
8Pd00P0000000`3om^h0?EV[0?ofkP020?ofkP0403eIZ`3om^h0000000000080ooK^00<0?EV[0?of
kP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0?EV[00@0ooK^0P0mFJ/90?of
kP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0>0?of
kP0303eIZ`3om^h0ooK^00/0ooK^0P0mFJ/70?ofkP0303eIZ`3om^h0ooK^01<0ooK^0`0mFJ/U0?of
kP030000003om^h0ooK^03H0ooK^0@3oool003L0ooK^00<000000?ofkP3om^h08`3om^h0103D?AT0
ooK^0?ofkP3om^h20=@m6A80ooK^00<0e3dI0?ofkP3om^h0203om^h20=@m6@X0ooK^00<0e3dI0?of
kP3om^h0403om^h20=@m6@@0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP090?of
kP80e3dI00<0ooK^0=@m6@3om^h00P3om^h20=@m6@@0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D
?AT000000?ofkP020=@m6@@0ooK^0`3D?AT200H84@040000000621401PPA000000<02`lP00<00000
00/?800;3b000P0;3b001000000051Xl0=@m6@00000301@J?0050=@m6@0D6S`051Xl01@J?0000000
0`3D>AH0200mFJ/0e3TF0=@i5P3D>AH0000003eIZ`3D>AH00000102b;Q401@000000/RhA0;8^4@2b
;Q4000000080RR8=00<0000008XR3@2:8Pd00`0mFJ/40?ofkP80?EV[00<0ooK^0000000mFJ/0303o
m^h00`0mFJ/0ooK^0?ofkP020?ofkP80?EV[0`3om^h0100mFJ/0ooK^03eIZ`0mFJ/;0?ofkP0303eI
Z`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h00P3om^h203eIZa80ooK^00<0?EV[0?ofkP3om^h0
203om^h203eIZ`X0ooK^00<0?EV[0?ofkP3om^h0403om^h203eIZ`<0ooK^00<0?EV[0?ofkP3om^h0
8`3om^h00`000000ooK^0?ofkP0e0?ofkP40oooo000e0?ofkP8000009P3om^h00`3D?AT0ooK^0?of
kP030?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h02P3om^h20=@m6@P0ooK^00<0
e3dI0?ofkP3om^h04P3om^h20=@m6@030?ofkP3D?AT0ooK^00L0ooK^00<0e3dI0?ofkP3om^h0303o
m^h00`3D?AT0ooK^0?ofkP040?ofkP040=@m6@3om^h0ooK^0=@m6@d0ooK^00<000000?ofkP3D?AT0
1@3om^h01P3D?AT00000000000062140e3dI00H84@<000000`0;3b00100000002`lP00/?800;3b02
0000008051Xl00<0e3dI0000000D6S`00`0D6S`20=@m6@0301@J?0000000e3TF0080?EV[103D>AH0
10000000?EV[0=@i5P3D>AH2000000<0/RhA00@000000;8^4@2b;Q40/RhA0`0000001P2:8Pd0?EV[
08XR3@000000?EV[000000D0ooK^00<0?EV[0?ofkP000000303om^h01@0mFJ/0ooK^0?ofkP3om^h0
?EV[00H0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP060?ofkP0403eIZ`3om^h0
?EV[03eIZa@0ooK^00<0?EV[0?ofkP3om^h01P3om^h203eIZ``0ooK^00<0?EV[0?ofkP3om^h03`3o
m^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^02@0ooK^0P00000e0?ofkP40oooo000d
0?ofkP030000003om^h0ooK^02D0ooK^00<0e3dI0?ofkP3om^h01@3om^h20=@m6@h0ooK^00<0e3dI
0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^01D0ooK^00<0e3dI
0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP040=@m6@3om^h0e3dI0=@m6@D0ooK^0`3D
?AT;0?ofkP80000000<0ooK^0=@m6@3om^h00P3D?AT0103om^h000000000003D?AT400H84@80e3dI
1@0;3b00100000002`lP00/?8000000401@J?0030=@m6@00000051Xl00@051Xl00D000000=@m6@00
0000?EV[000000050=@i5P030000000mFJ/0e3TF00<0e3TF00@000000;8^4@2b;Q4000001@2b;Q42
03eIZ`@0RR8=00@0?EV[000000000000ooK^0P0mFJ/00`3om^h0?EV[0?ofkP02000000/0ooK^0`0m
FJ/50?ofkP80?EV[00<0ooK^03eIZ`3om^h0303om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3o
m^h0ooK^01D0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3o
m^h0ooK^00`0ooK^0P0mFJ/70?ofkP0303eIZ`3om^h0ooK^02D0ooK^00<000000?ofkP3om^h0<P3o
m^h10?ooo`00<`3om^h00`000000ooK^0?ofkP0V0?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI
0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP80e3dI0`3om^h00`3D?AT0ooK^0?ofkP0E
0?ofkP040=@m6@3om^h0e3dI0=@m6@L0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?of
kP020?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h0203om^h010000000ooK^0?of
kP3D?AT40?ofkP<0000000@0e3dI00H84@0621401PPA0`0000000`3D?AT02`lP00/?800200/?80<0
00001@0D6S`00`3D?AT051Xl01@J?00301@J?0040000000M:5L07BQG00000080jT0I00<000000=@i
5P3D>AH00`3D>AH00`0mFJ/0e3TF0=@i5P030=@i5P<00000102b;Q40100mFJ/00000000000000003
08XR3@0403eIZ`0000000000000000@0ooK^00@0?EV[0?ofkP3om^h000002P3om^h00`0mFJ/0ooK^
0?ofkP040?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^
0?ofkP050?ofkP80?EV[00<0ooK^03eIZ`3om^h05P3om^h0100mFJ/0ooK^0?ofkP3om^h203eIZa40
ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^02H0
ooK^00<000000?ofkP3om^h0<@3om^h10?ooo`00<P3om^h00`000000ooK^0?ofkP0V0?ofkP030=@m
6@3om^h0ooK^00T0ooK^0P3D?AT:0?ofkP030=@m6@3om^h0ooK^0140ooK^0P3D?AT00`3om^h0e3dI
0?ofkP0F0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT01@3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP03
0=@m6@3om^h0ooK^00<0ooK^0P3D?AT40?ofkP<0e3dI1P3om^h200000080ooK^00@0e3dI0?ofkP3o
m^h0ooK^0`0000000`06214000000=@m6@0200H84@030000000;3b00000000802`lP0P3D?AT200/?
80030000000D6S`051Xl00@051Xl00<0e3dI0000000D6S`00P0D6S`2000000<07BQG00@000000>Y0
6@3Z@1T0jT0I0P0000030=@i5P030000000mFJ/0e3TF00D0e3TF00<000000;8^4@2b;Q400P0mFJ/2
0;8^4@030000002b;Q4000000080RR8=00H0?EV[0000002:8Pd000000=@m6@0000030?ofkP0303eI
Z`3om^h0ooK^008000001P3om^h303eIZ`@0ooK^0P0mFJ/50?ofkP0303eIZ`3om^h0ooK^00/0ooK^
00<0?EV[0?ofkP3om^h00`3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[01L0ooK^00@0?EV[0?ofkP0m
FJ/0?EV[4`3om^h00`0mFJ/0ooK^0?ofkP080?ofkP80?EV[2`3om^h00`0mFJ/0ooK^0?ofkP0V0?of
kP030000003om^h0ooK^0300ooK^0@3oool00340ooK^00<000000?ofkP3om^h09`3om^h00`3D?AT0
ooK^0?ofkP0;0?ofkP80e3dI1`3om^h00`3D?AT0ooK^0?ofkP0D0?ofkP030=@m6@3om^h0ooK^01D0
ooK^00<0e3dI0?ofkP3om^h00`3om^h20=@m6@<0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0
ooK^0?ofkP060?ofkP80e3dI00<0ooK^0=@m6@3om^h00P3om^h00`3D?AT0ooK^0?ofkP020?ofkP05
0000003om^h0ooK^0?ofkP3D?AT00`3om^h3000000801PPA00@0e3dI00H84@00000000000P0;3b00
0`0000002`lP00/?800200/?80030=@m6@000000000000H051Xl00D0e3dI0000000D6S`051Xl0000
000501dXE`030000003Z@1T0jT0I00<0jT0I00D000000=@i5P3D>AH0000003eIZ`060=@i5P800000
00<0?EV[0;8^4@2b;Q400P2b;Q400`000000/RhA0;8^4@020000000403eIZ`000000RR8=08XR3@<0
00000`3om^h01@0mFJ/0ooK^0?ofkP3om^h0000000@0ooK^00H0?EV[0?ofkP3om^h0ooK^03eIZ`3o
m^h203eIZ`P0ooK^00<0?EV[0?ofkP3om^h02P3om^h0100mFJ/0ooK^0?ofkP3om^h203eIZ`D0ooK^
00<0?EV[0?ofkP3om^h05@3om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP0303eIZ`3om^h0ooK^00D0ooK^
0P0mFJ/=0?ofkP0303eIZ`3om^h0ooK^02L0ooK^00<000000?ofkP3om^h0;`3om^h10?ooo`00;`3o
m^h2000002X0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3o
m^h0ooK^01<0ooK^00@0e3dI0?ofkP3D?AT0e3dI503om^h00`3D?AT0ooK^0?ofkP060?ofkP<0e3dI
303om^h00`3D?AT0ooK^0?ofkP090?ofkP80e3dI103om^h20=@m6@8000000`3om^h00`3D?AT0ooK^
0?ofkP04000000801PPA00<000000=@m6@000000100;3b001P0000002`lP00/?800;3b00000001@J
?080e3dI1P0D6S`0103D?AT0000000000000000601dXE`030000003Z@1T0jT0I00@0jT0I0`000000
0`0mFJ/0e3TF0=@i5P040=@i5P80?EV[00<0e3TF0000002b;Q400P2b;Q400`000000/RhA0;8^4@02
0;8^4@030000000mFJ/000000080RR8=100000020?ofkP0403eIZ`3om^h0ooK^0?ofkP8000000P0m
FJ/40?ofkP80?EV[2`3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP<0?EV[203om^h00`0mFJ/0ooK^0?of
kP0B0?ofkP<0?EV[5P3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0
?EV[0?ofkP3om^h0:03om^h2000002l0ooK^0@3oool002h0ooK^00<000000?ofkP3om^h0:@3om^h0
0`3D?AT0ooK^0?ofkP0?0?ofkP80e3dI0`3om^h00`3D?AT0ooK^0?ofkP0D0?ofkP040=@m6@3om^h0
ooK^0?ofkP80e3dI4P3om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0
e3dI0?ofkP3om^h02P3om^h30=@m6@@0ooK^00<000000=@m6@3D?AT00P3om^h01P3D?AT0ooK^0?of
kP0000001PPA000000@01PPA00<000000=@m6@0;3b00100;3b00100000002`lP00000000000301@J
?0030000003D?AT051Xl00@051Xl00<0e3dI0000000M:5L01`0M:5L00`000000jT0I0>Y06@060>Y0
6@030000000mFJ/0e3TF00@0e3TF00<0?EV[0000003D>AH00P3D>AH2000000030;8^4@000000/RhA
00@0/RhA00<0?EV[0000002:8Pd00`2:8Pd00`000000G1@8000000020?ofkP0303eIZ`3om^h0ooK^
0080?EV[00<000000?ofkP3om^h00P3om^h303eIZ``0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0m
FJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^0100ooK^0P0mFJ/30?ofkP0303eIZ`3om^h0ooK^
01@0ooK^00@0?EV[0?ofkP3om^h0ooK^0P0mFJ/A0?ofkP0303eIZ`3om^h0ooK^02T0ooK^00<00000
0?ofkP3om^h0;03om^h10?ooo`00;@3om^h00`000000ooK^0?ofkP0Z0?ofkP030=@m6@3om^h0ooK^
0140ooK^0P3D?AT00`3om^h0e3dI0?ofkP0D0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?of
kP3om^h03P3om^h00`3D?AT0ooK^0?ofkP080?ofkP040=@m6@3om^h0e3dI0=@m6@P0ooK^00<0e3dI
0?ofkP3om^h02`3om^h0103D?AT0ooK^0?ofkP3D?AT20?ofkP040000003om^h0ooK^0?ofkP80e3dI
00@0ooK^0000000000001PPA0P00000300H84@80000000<0e3dI00/?800;3b000P0;3b03000000D0
51Xl00@0000001@J?03D?AT0e3dI0`0D6S`00`3D?AT0000001dXE`0701dXE`030000003Z@1T0jT0I
00H0jT0I00<0000003eIZ`3D>AH00P3D>AH203eIZ`030=@i5P000000e3TF00@0e3TF0`0000040;8^
4@0303eIZ`000000000000<0RR8=0P000000101L50P000000000003om^h203eIZ`<0ooK^00@00000
0?ofkP3om^h0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00H0ooK^0P0m
FJ/00`3om^h0?EV[0?ofkP090?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h00`3o
m^h00`0mFJ/0ooK^0?ofkP0D0?ofkP0403eIZ`3om^h0?EV[03eIZa<0ooK^00<0?EV[0?ofkP3om^h0
:P3om^h00`000000ooK^0?ofkP0[0?ofkP40oooo000/0?ofkP030000003om^h0ooK^02X0ooK^00<0
e3dI0?ofkP3om^h0503om^h00`3D?AT0ooK^0?ofkP0D0?ofkP030=@m6@3om^h0ooK^00D0ooK^0P3D
?AT=0?ofkP030=@m6@3om^h0ooK^00T0ooK^00@0e3dI0?ofkP3om^h0ooK^0P3D?AT50?ofkP030=@m
6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h00P3om^h2000000@0ooK^0`3D?AT0100000001PPA
00000000000300H84@80000000<0e3dI00/?800;3b000`0;3b000`00000051Xl01@J?00501@J?005
0000000D6S`051Xl01@J?03D?AT00P0000000`3D?AT0000001dXE`0701dXE`030000003Z@1T0jT0I
00H0jT0I00D0000003eIZ`000000000003eIZ`030=@i5P030000003D>AH0e3TF00D0e3TF00<00000
0;8^4@2b;Q400P2b;Q40100mFJ/000000;8^4@00000308XR3@80000000<0G1@80000000mFJ/00P0m
FJ/40?ofkP800000103om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00<0ooK^0P0m
FJ/30?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h02`3om^h203eIZ`L0ooK^00<0
?EV[0?ofkP3om^h0503om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP0303eIZ`3om^h0ooK^02X0ooK^00<0
00000?ofkP3om^h0:P3om^h10?ooo`00:`3om^h00`000000ooK^0?ofkP0[0?ofkP030=@m6@3om^h0
ooK^01@0ooK^0`3D?ATC0?ofkP030=@m6@3om^h0ooK^00P0ooK^0P3D?AT:0?ofkP030=@m6@3om^h0
ooK^00T0ooK^00<0e3dI0?ofkP3om^h00`3om^h20=@m6@@0ooK^00<0e3dI0?ofkP3om^h02`3om^h0
1@3D?AT0ooK^0?ofkP3om^h000000080ooK^0P3D?AT02P3om^h0e3dI0000000000001PPA0=@m6@00
00001PPA0000000621420000000300/?80000000e3dI00@02`lP0P00000701@J?0050000000D6S`0
51Xl01@J?00000000`3D?AT00`0000007BQG01dXE`0601dXE`030000003Z@1T0jT0I00H0jT0I00D0
000003eIZ`0mFJ/0?EV[000000030=@i5P030000003D>AH0e3TF00D0e3TF0P0000040;8^4@0303eI
Z`000000/RhA0080000000H0RR8=0000002:8Pd0000003eIZ`1L50P20000000403eIZ`3om^h0?EV[
03eIZ`80ooK^00D000000?ofkP3om^h0ooK^03eIZ`0=0?ofkP0303eIZ`3om^h0ooK^0080ooK^0P0m
FJ/50?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h0203om^h203eIZ`T0ooK^00<0
?EV[0?ofkP3om^h04P3om^h303eIZaH0ooK^00<0?EV[0?ofkP3om^h0:`3om^h00`000000ooK^0?of
kP0Y0?ofkP40oooo000Y0?ofkP800000;@3om^h00`3D?AT0ooK^0?ofkP0D0?ofkP040=@m6@3om^h0
ooK^0?ofkP80e3dI4@3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP80e3dI203om^h00`3D?AT0ooK^0?of
kP090?ofkP030=@m6@3om^h0ooK^00D0ooK^0P3D?AT00`3om^h0e3dI0?ofkP0<0?ofkP030=@m6@3o
m^h0ooK^008000001@3om^h01P3D?AT0000000H84@062140000000H84@80e3dI0P00000300/?8004
0000003D?AT02`lP00/?8080000000<051Xl0000000D6S`01P0D6S`01000000051Xl01@J?0000003
01dXE`030=@m6@0000007BQG00L07BQG00<000000>Y06@3Z@1T01P3Z@1T00`000000?EV[0>Y06@02
0>Y06@040000003D>AH0e3TF000000L0e3TF00@000000=@i5P00000000000P2b;Q400`0mFJ/00000
0;8^4@020;8^4@8000000P0mFJ/01P2:8Pd0000005`D201L50P0000003eIZ`D0ooK^0P0000000`3o
m^h0?EV[0?ofkP0=0?ofkP0403eIZ`3om^h0?EV[03eIZ`L0ooK^00<0?EV[0?ofkP3om^h02@3om^h0
0`0mFJ/0ooK^0?ofkP060?ofkP80?EV[303om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP80?EV[0`3om^h0
0`0mFJ/0ooK^0?ofkP0D0?ofkP0303eIZ`3om^h0ooK^02/0ooK^0P00000Y0?ofkP40oooo000X0?of
kP030000003om^h0ooK^02d0ooK^00<0e3dI0?ofkP3om^h0503om^h00`3D?AT0ooK^0?ofkP030?of
kP80e3dI3P3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?of
kP3om^h02@3om^h00`3D?AT0ooK^0?ofkP080?ofkP80e3dI3@3om^h00`3D?AT0ooK^000000060?of
kP050=@m6@0000001PPA00H84@0000000`0621400`000000e3dI0=@m6@0300/?80040000003D?AT0
2`lP000000<051Xl00<0000001@J?00D6S`01@0D6S`3000000@07BQG0`3D?AT701dXE`030000003Z
@1T0jT0I00D0jT0I0`0mFJ/40>Y06@<000001`3D>AH020000000e3TF0=@i5P3D>AH000000;8^4@0m
FJ/000000`2b;Q4203eIZ`050000002:8Pd0RR8=08XR3@0000000P1L50P00`000000?EV[0?ofkP05
0?ofkP030000003om^h0?EV[00d0ooK^0P0mFJ/:0?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[
0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00d0ooK^0P0mFJ/5
0?ofkP0303eIZ`3om^h0ooK^01@0ooK^00<0?EV[0?ofkP3om^h0;@3om^h00`000000ooK^0?ofkP0V
0?ofkP40oooo000W0?ofkP030000003om^h0ooK^02h0ooK^0`3D?ATC0?ofkP030=@m6@3om^h0ooK^
00H0ooK^0P3D?AT<0?ofkP030=@m6@3om^h0ooK^00h0ooK^0P3D?AT30?ofkP030=@m6@3om^h0ooK^
00X0ooK^00<0e3dI0?ofkP3om^h01`3om^h0103D?AT0ooK^0=@m6@3D?AT<0?ofkP8000001P3om^h0
0`3D?AT0000000H84@02000000@01PPA00T0000000/?800;3b00e3dI00/?80000000e3dI00/?8000
0000100D6S`00`00000051Xl01@J?00501@J?0030000000mFJ/07BQG00<07BQG00D0e3dI01dXE`00
00007BQG0=@m6@0401dXE`D000000`3Z@1T203eIZ`040>Y06@000000jT0I03eIZ`D0jT0I00<00000
0=@i5P3D>AH01@3D>AH00`000000e3TF0=@i5P020=@i5P030000000mFJ/000000080/RhA00@0?EV[
0;8^4@2b;Q400000102:8Pd20000000305`D20000000?EV[00H0ooK^0P00000<0?ofkP80?EV[00<0
ooK^03eIZ`3om^h0203om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0403eIZ`3om^h0ooK^0?ofkP80?EV[
403om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP80?EV[203om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP<0?EV[
<03om^h00`000000ooK^0?ofkP0U0?ofkP40oooo000V0?ofkP030000003om^h0ooK^02h0ooK^00@0
e3dI0?ofkP3om^h0ooK^0P3D?ATA0?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h0
203om^h00`3D?AT0ooK^0?ofkP0A0?ofkP80e3dI00<0ooK^0=@m6@3om^h02P3om^h00`3D?AT0ooK^
0?ofkP080?ofkP040=@m6@3om^h0ooK^0?ofkP80e3dI2@3om^h00`000000ooK^0?ofkP050?ofkP@0
000000@01PPA0000000621401PPA0`00000300/?80<0e3dI00<0000001@J?00D6S`00`0D6S`00`00
000051Xl01@J?00301@J?0<000001@0M:5L00`3D?AT07BQG0000000201dXE`80e3dI00D07BQG0000
000U=6l09CA_000000020?Q570030000003Z@1T0?EV[00<0jT0I00<000000>Y06@0mFJ/01@3Z@1T3
000000D0e3TF00<000000=@i5P3D>AH00`3D>AH010000000?EV[03eIZ`0mFJ/30;8^4@<000000P2:
8Pd00`000000RR8=00000003000000L0ooK^00<000000?ofkP3om^h01`3om^h203eIZ`<0ooK^00<0
?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP090?ofkP0403eIZ`3om^h0?EV[03eIZa80ooK^
00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00l0ooK^
0P0mFJ/30?ofkP0303eIZ`3om^h0ooK^02h0ooK^00<000000?ofkP3om^h0903om^h10?ooo`009P3o
m^h3000002h0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3o
m^h0ooK^00X0ooK^0P3D?AT80?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h02P3o
m^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00<0ooK^0`3D?AT60?ofkP030000003D
?AT0ooK^00D0ooK^0`00000200H84@060000000621401PPA0000000;3b0000001@0;3b000`000000
e3dI01@J?00501@J?0030000000D6S`051Xl008051Xl00@0000001dXE`0M:5L000001@0M:5L00`3D
?AT07BQG0000000301dXE`030000003D?AT09CA_00809CA_00<000000?Q5703hAA`00P0mFJ/01`00
0000jT0I0>Y06@3Z@1T000000>Y06@0mFJ/01@3Z@1T010000000jT0I0>Y06@0000040=@i5P030000
003D>AH0e3TF00@0e3TF00<0?EV[0000002b;Q40102b;Q400`000000/RhA0000000208XR3@030000
002:8Pd0RR8=00<000001P3om^h00`0mFJ/000000?ofkP050?ofkP<0?EV[1@3om^h00`0mFJ/0ooK^
0?ofkP070?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^
0?ofkP060?ofkP80?EV[303om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00<0ooK^
00<0?EV[0?ofkP3om^h0;03om^h3000002H0ooK^0@3oool002H0ooK^00<000000?ofkP3om^h00P00
000/0?ofkP030=@m6@3om^h0ooK^00@0ooK^0P3D?AT=0?ofkP030=@m6@3om^h0ooK^00`0ooK^0P3D
?AT50?ofkP030=@m6@3om^h0ooK^01<0ooK^00@0e3dI0?ofkP3D?AT0e3dI2@3om^h00`3D?AT0ooK^
0?ofkP070?ofkP030=@m6@3om^h0ooK^00H0ooK^0P3D?AT30?ofkP80000000<0e3dI0?ofkP3om^h0
103om^h2000000<01PPA00@0000000H84@00000000000P0;3b00100000002`lP00/?800;3b030000
00<0e3dI100D6S`00`00000051Xl01@J?002000000<07BQG00<0000001dXE`0M:5L00`0M:5L00`3D
?AT07BQG0000000201dXE`030000000U=6l09CA_0080e3dI00@09CA_0000000mFJ/0?EV[0`3hAA`0
1P000000jT0I0>Y06@000000jT0I03eIZ`D0jT0I00@000000>Y06@3Z@1T0jT0I0P0000020=@i5P03
0000003D>AH0e3TF0080e3TF0`0mFJ/3000000<0/RhA00<000000;8^4@2b;Q400P0000000`2:8Pd0
000008XR3@0208XR3@8000001P3om^h00`0mFJ/00000000000030?ofkP80?EV[203om^h00`0mFJ/0
ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00L0ooK^0P0mFJ/00`3om^h0?EV[0?ofkP0C0?ofkP03
03eIZ`3om^h0ooK^00@0ooK^0P0mFJ/>0?ofkP0303eIZ`3om^h0ooK^00/0ooK^0P0mFJ/60?ofkP03
03eIZ`3om^h0ooK^02X0ooK^0P0000020?ofkP030000003om^h0ooK^02@0ooK^0@3oool002D0ooK^
00<000000?ofkP3om^h00`3om^h2000002T0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^
0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00h0ooK^0P3D?AT30?ofkP030=@m6@3om^h0ooK^01<0ooK^
00D0e3dI0?ofkP3om^h0ooK^0=@m6@080?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3o
m^h01`3om^h30=@m6@040000003om^h0ooK^0=@m6@@0ooK^0`00000400H84@800000100;3b001000
00002`lP00/?8000000201@J?0040=@m6@0D6S`051Xl01@J?080e3dI0P0D6S`3000000D07BQG00<0
000001dXE`0M:5L00P0M:5L00`3D?AT07BQG01dXE`03000000D09CA_00<0e3dI03eIZ`3hAA`01@3h
AA`300000080jT0I00<0?EV[0>Y06@3Z@1T00P3Z@1T00`000000jT0I0>Y06@030>Y06@<000000P3D
>AH203eIZ`<0e3TF00@0?EV[0=@i5P3D>AH000000P2b;Q400`000000/RhA0;8^4@020;8^4@800000
102:8Pd3000000@0ooK^00@0?EV[0?ofkP3om^h000000`0mFJ/90?ofkP0303eIZ`3om^h0ooK^00L0
ooK^00<0?EV[0?ofkP3om^h01P3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[01D0ooK^00@0?EV[0?of
kP3om^h0ooK^0P0mFJ/@0?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h01`3om^h0
0`0mFJ/0ooK^0?ofkP0W0?ofkP8000001@3om^h00`000000ooK^0?ofkP0S0?ofkP40oooo000U0?of
kP030000003om^h0ooK^00D0ooK^0P00000W0?ofkP030=@m6@3om^h0ooK^00P0ooK^0P3D?AT90?of
kP030=@m6@3om^h0ooK^0140ooK^0`3D?ATE0?ofkP030=@m6@3om^h0ooK^00<0ooK^0P3D?AT50?of
kP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h02@3om^h2000000<0e3dI103om^h20000
000300H84@0000001PPA00801PPA00<0000000/?800;3b00100;3b000`0000002`lP0000000301@J
?0030=@m6@0D6S`051Xl00<051Xl00<0e3dI01@J?00000001`0M:5L00`0000007BQG01dXE`0201dX
E`040=@m6@0M:5L07BQG000000P09CA_00<000000?Q5703hAA`01P3hAA`010000000jT0I0>Y06@0m
FJ/40>Y06@030000003Z@1T0jT0I00D0jT0I00<000000=@i5P0mFJ/01@3D>AH01`0mFJ/0e3TF0=@i
5P3D>AH000000;8^4@0000001P2b;Q401P000000RR8=08XR3@2:8Pd0000008XR3@800000103om^h3
03eIZ`8000002`3om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00<0ooK^0P0mFJ/5
0?ofkP0303eIZ`3om^h0ooK^0180ooK^00@0?EV[0?ofkP0mFJ/0?EV[4`3om^h00`0mFJ/0ooK^0?of
kP070?ofkP80?EV[2P3om^h00`0mFJ/0ooK^0?ofkP0U0?ofkP8000001`3om^h00`000000ooK^0?of
kP0S0?ofkP40oooo000U0?ofkP030000003om^h0ooK^00L0ooK^0P00000U0?ofkP030=@m6@3om^h0
ooK^00X0ooK^0P3D?AT70?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h04`3om^h0
0`3D?AT0ooK^0?ofkP050?ofkP80e3dI0`3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0
ooK^00T0ooK^00@000000?ofkP3om^h0ooK^0P3D?AT20?ofkP<0000000@01PPA0000000621401PPA
0`00000500/?80<000000`0D6S`00`3D?AT0000001@J?00501@J?080e3dI1`0M:5L00`0000007BQG
01dXE`0201dXE`040=@m6@0M:5L00000000000P09CA_00<000000?Q5703hAA`01P3hAA`200000003
0>Y06@0mFJ/0jT0I00<0jT0I00<000000>Y06@3Z@1T01@3Z@1T203eIZ`H0e3TF00<0000003eIZ`3D
>AH00P3D>AH3000000D0/RhA0`00000208XR3@030000002:8Pd00000008000000P3om^h203eIZ`<0
ooK^00<000000?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0403eIZ`3om^h0ooK^0?of
kP80?EV[1`3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?of
kP3om^h01@3om^h203eIZ``0ooK^00<0?EV[0?ofkP3om^h08`3om^h2000000T0ooK^00<000000?of
kP3om^h08`3om^h10?ooo`009@3om^h00`000000ooK^0?ofkP090?ofkP030000003om^h0ooK^0240
ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^01<0
ooK^00@0e3dI0?ofkP3D?AT0e3dI4P3om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0e3dI
00P0ooK^00<0e3dI0?ofkP3om^h0203om^h2000000@0ooK^103D?AT2000000801PPA00D0000000H8
4@0000002`lP0000000600/?80030000000D6S`051Xl00<051Xl00<0e3dI0000000D6S`00`0D6S`2
0000000301dXE`000000e3dI00H07BQG00<0000001dXE`0M:5L00P0M:5L0103D?AT0000002DdK`00
000802DdK`030000003hAA`0n4DL00H0n4DL00@000000?Q570000000?EV[103Z@1T00`000000jT0I
0>Y06@040>Y06@0303eIZ`000000e3dI00800000103D>AH00`000000?EV[0=@i5P040=@i5P030000
002b;Q40/RhA00@0/RhA00D000000;8^4@000000RR8=0000000208XR3@800000100mFJ/40?ofkP80
00002P3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0?EV[00X0ooK^00<0?EV[0?ofkP3o
m^h0403om^h303eIZaH0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP03
03eIZ`3om^h0ooK^0240ooK^00<000000?ofkP3om^h02@3om^h00`000000ooK^0?ofkP0S0?ofkP40
oooo000T0?ofkP030000003om^h0ooK^00/0ooK^0P00000Q0?ofkP030=@m6@3om^h0ooK^00h0ooK^
0P3D?AT30?ofkP030=@m6@3om^h0ooK^01<0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0A0?ofkP03
0=@m6@3om^h0ooK^00T0ooK^0P3D?AT80?ofkP030=@m6@3om^h0ooK^00L0ooK^00<000000?ofkP3o
m^h0103om^h01@3D?AT00000000000000000e3dI00801PPA00<0000000H84@0000000P0;3b000`00
00002`lP00/?800200/?80<00000100D6S`00`3D?AT051Xl0000000301@J?0060000000M:5L07BQG
01dXE`0000007BQG0P3D?AT401dXE`050000000M:5L07BQG01dXE`3D?AT00`0U=6l00`0000009CA_
02DdK`0602DdK`030000003hAA`0n4DL00H0n4DL00D000000?Q5703hAA`0n4DL03eIZ`030>Y06@03
0000003Z@1T0jT0I0080jT0I0P0mFJ/00`3Z@1T000000>Y06@020>Y06@070000003D>AH0e3TF0=@i
5P000000e3TF03eIZ`040=@i5P<00000102b;Q401P000000/RhA0;8^4@000000RR8=00000080RR8=
00D0?EV[000000000000000003eIZ`060?ofkP030000003om^h0ooK^00L0ooK^00<0?EV[0?ofkP3o
m^h01P3om^h203eIZ`/0ooK^00<0?EV[0?ofkP3om^h03`3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[
01D0ooK^00@0?EV[0?ofkP3om^h0ooK^0P0mFJ/@0?ofkP0303eIZ`3om^h0ooK^01l0ooK^0P00000=
0?ofkP030000003om^h0ooK^0280ooK^0@3oool002@0ooK^00<000000?ofkP3om^h03@3om^h20000
01l0ooK^00<0e3dI0?ofkP3om^h0403om^h30=@m6AD0ooK^00<0e3dI0?ofkP3om^h00`3om^h20=@m
6@h0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0=@m6@060?ofkP030=@m6@3om^h0ooK^
00L0ooK^00<000000?ofkP3om^h0103om^h0103D?AT0000000000000000200H84@80e3dI0P000003
00/?80050000000;3b002`lP00/?800000000P0D6S`00`00000051Xl01@J?00201@J?0030=@m6@0D
6S`00000008051Xl00<0000001dXE`0M:5L00P0M:5L0100000007BQG01dXE`0M:5L20=@m6@807BQG
00D0000001dXE`0M:5L000000=@m6@0302DdK`030000000U=6l09CA_00H09CA_00<000000?Q5703h
AA`01P3hAA`01P000000n4DL0?Q5703hAA`0?EV[00000080jT0I00<000000>Y06@3Z@1T00P0mFJ/3
0>Y06@030000003Z@1T0jT0I0080jT0I00H000000=@i5P3D>AH000000=@i5P0mFJ/40=@i5P040000
003D>AH0e3TF000000<0/RhA00@000000;8^4@2b;Q40/RhA0P00000203eIZ`80RR8=0`0000000`0m
FJ/0ooK^0?ofkP040?ofkP030000003om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0m
FJ/0ooK^03eIZ`0<0?ofkP0303eIZ`3om^h0ooK^00`0ooK^0P0mFJ/40?ofkP0303eIZ`3om^h0ooK^
01@0ooK^0`0mFJ/B0?ofkP0303eIZ`3om^h0ooK^01d0ooK^0P00000?0?ofkP030000003om^h0ooK^
0280ooK^0@3oool002@0ooK^00<000000?ofkP3om^h03`3om^h2000001`0ooK^00<0e3dI0?ofkP3o
m^h04`3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^00D0ooK^0P3D?AT;0?ofkP03
0=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h00P3D?AT30?ofkP030=@m6@3om^h0ooK^00H0
ooK^0P0000060?ofkP050000003D?AT0000000H84@0000000`0621400`000000e3dI0=@m6@0300/?
80040000000;3b000000000000<051Xl00D0000001@J?00D6S`051Xl0=@m6@0201@J?0<000001@0M
:5L00`0000007BQG01dXE`0301dXE`030=@m6@0M:5L000000080000000<09CA_0=@m6@0U=6l00P0U
=6l00`0000009CA_02DdK`0602DdK`030000003hAA`0n4DL00H0n4DL00H000000?Q5703hAA`0n4DL
03eIZ`3hAA`3000000030>Y06@0mFJ/0jT0I00@0jT0I00<000000>Y06@3Z@1T00`3Z@1T300000003
0=@i5P0mFJ/0e3TF00<0e3TF00@000000=@i5P3D>AH0e3TF0P0000000`2b;Q4000000;8^4@020;8^
4@80?EV[00T0000008XR3@2:8Pd0RR8=0000002:8Pd0000003eIZ`0000001P3om^h2000000P0ooK^
00@0?EV[0?ofkP3om^h0ooK^0P0mFJ/20?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3o
m^h02@3om^h203eIZ`L0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP03
03eIZ`3om^h0ooK^01X0ooK^0P00000A0?ofkP030000003om^h0ooK^0280ooK^0@3oool002@0ooK^
00<000000?ofkP3om^h04@3om^h2000001X0ooK^00<0e3dI0?ofkP3om^h04`3om^h30=@m6A80ooK^
00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00X0ooK^
00<0e3dI0?ofkP3om^h00`3om^h20=@m6@030?ofkP3D?AT0ooK^00H0ooK^00<000000?ofkP3om^h0
1@3om^h01@000000e3dI000000062140000000801PPA0`00000200/?80030=@m6@0;3b0000000080
00001@0D6S`01@00000051Xl01@J?00D6S`0e3dI008051Xl00<0000001dXE`0M:5L01@0M:5L00`00
00007BQG01dXE`0401dXE`80e3dI0`0U=6l01@3D?AT09CA_02DdK`0U=6l0000000P09CA_00<00000
0?Q5703hAA`01P3hAA`01@000000n4DL0?Q5703hAA`0?EV[00<0n4DL0P0mFJ/60>Y06@030000003Z
@1T0jT0I00D0jT0I00@000000=@i5P3D>AH0?EV[0`3D>AH00`000000e3TF0=@i5P030=@i5P<00000
00@0/RhA03eIZ`2b;Q40/RhA0`00000208XR3@050000002:8Pd0000003eIZ`0000001`3om^h00`00
0000ooK^0?ofkP050?ofkP0403eIZ`3om^h0?EV[03eIZ`D0ooK^00<0?EV[0?ofkP3om^h02P3om^h0
0`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h04@3om^h3
03eIZaD0ooK^00<0?EV[0?ofkP3om^h0603om^h2000001<0ooK^00<000000?ofkP3om^h08P3om^h1
0?ooo`00903om^h00`000000ooK^0?ofkP0C0?ofkP800000603om^h00`3D?AT0ooK^0?ofkP0B0?of
kP040=@m6@3om^h0ooK^0?ofkP80e3dI403om^h00`3D?AT0ooK^0?ofkP090?ofkP80e3dI1`3om^h0
0`3D?AT0ooK^0?ofkP0:0?ofkP040=@m6@3om^h0e3dI0=@m6@D0ooK^00<0e3dI0?ofkP3om^h0103o
m^h2000000H0ooK^0`000000203D?AT01PPA00H84@0000001PPA0000000;3b000000100;3b020=@m
6@H051Xl00<0000001@J?00D6S`00P0D6S`0103D?AT0000000000000000701dXE`030000000M:5L0
7BQG00<07BQG0`0000030=@m6@D09CA_00<0000002DdK`0U=6l01@0U=6l00`000000n4DL0?Q57005
0?Q570030000003hAA`0n4DL00<0n4DL0`0mFJ/3000000D0jT0I00<000000>Y06@3Z@1T01@3Z@1T3
0000000303eIZ`3D>AH0e3TF0080e3TF00<000000=@i5P3D>AH0103D>AH203eIZ`@0/RhA00D00000
0;8^4@000000RR8=0000000208XR3@0403eIZ`0000000000000000H0ooK^0P0000060?ofkP0303eI
Z`3om^h0ooK^00<0ooK^0P0mFJ/00`3om^h0?EV[0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00D0ooK^
0P0mFJ/;0?ofkP0303eIZ`3om^h0ooK^00h0ooK^0P0mFJ/30?ofkP0303eIZ`3om^h0ooK^0180ooK^
00<0?EV[0?ofkP3om^h05P3om^h2000001D0ooK^00<000000?ofkP3om^h08P3om^h10?ooo`008`3o
m^h00`000000ooK^0?ofkP0F0?ofkP030000003om^h0ooK^01@0ooK^00<0e3dI0?ofkP3om^h04`3o
m^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h0303o
m^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00X0ooK^00@0e3dI0?ofkP3om^h0ooK^
0P3D?AT20?ofkP040=@m6@3om^h0e3dI0=@m6@<0ooK^00<000000?ofkP3om^h01@3om^h300000006
0=@m6@0621401PPA00000006214000000P0;3b000`0000002`lP00/?800200/?8080000000<0e3dI
01@J?00D6S`00`0D6S`01P00000051Xl01@J?00D6S`0e3dI000000807BQG00<0000001dXE`0M:5L0
1@0M:5L00`0000007BQG01dXE`0201dXE`040000000U=6l09CA_000000809CA_00<0e3dI02DdK`0U
=6l00`0U=6l00`0000009CA_02DdK`0402DdK`<000001P3hAA`00`000000n4DL0?Q570030?Q57004
03eIZ`3hAA`0n4DL00000080n4DL00<000000>Y06@3Z@1T00P3Z@1T00`000000jT0I0>Y06@050>Y0
6@050000003Z@1T0jT0I0000000mFJ/00`3D>AH00`000000e3TF0=@i5P030=@i5P0303eIZ`000000
000000@0/RhA00H000000;8^4@2b;Q40000008XR3@00000208XR3@0403eIZ`0000000000000000L0
ooK^00@000000?ofkP3om^h0ooK^0P0mFJ/0103om^h0?EV[0?ofkP3om^h203eIZ`<0ooK^00<0?EV[
0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[
0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[
0?ofkP3om^h0503om^h00`000000ooK^0?ofkP0F0?ofkP030000003om^h0ooK^0240ooK^0@3oool0
02<0ooK^00<000000?ofkP3om^h05`3om^h2000001@0ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D
?AT0ooK^0?ofkP040?ofkP80e3dI303om^h00`3D?AT0ooK^0?ofkP0=0?ofkP80e3dI0`3om^h00`3D
?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3D?AT00`3om^h00`3D
?AT00000000000060?ofkP<0000000<01PPA0000003D?AT00P062142000000802`lP00@0000000/?
800;3b002`lP0P0000000`0D6S`0000001@J?0020=@m6@<051Xl00D0000001@J?00D6S`000000=@m
6@0301dXE`030000000M:5L07BQG00D07BQG00<0000001dXE`0M:5L00P00000302DdK`030000000U
=6l09CA_00<0e3dI0`0U=6l00`0000009CA_02DdK`0202DdK`80000000<0;3j20000003oB1d00P00
00040?Q570040000003hAA`0n4DL0?Q570<0?EV[0P3hAA`010000000n4DL0?Q5703hAA`200000080
jT0I00<000000>Y06@3Z@1T01@3Z@1T01P000000jT0I0>Y06@3Z@1T0?EV[00000080e3TF00@00000
0=@i5P3D>AH0e3TF0P0mFJ/00`3D>AH000000=@i5P0200000080/RhA00@000000;8^4@2b;Q40/RhA
0P00000208XR3@0303eIZ`000000RR8=00<000001P3om^h20000000703eIZ`3om^h0ooK^0?ofkP0m
FJ/0ooK^03eIZ`060?ofkP0303eIZ`3om^h0ooK^00X0ooK^00@0?EV[0?ofkP3om^h0ooK^0P0mFJ/?
0?ofkP0303eIZ`3om^h0ooK^00X0ooK^0P0mFJ/60?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[
0?ofkP3om^h04P3om^h2000001T0ooK^00<000000?ofkP3om^h08@3om^h10?ooo`008`3om^h00`00
0000ooK^0?ofkP0I0?ofkP8000004P3om^h30=@m6A80ooK^00<0e3dI0?ofkP3om^h01`3om^h20=@m
6@T0ooK^00<0e3dI0?ofkP3om^h0403om^h20=@m6@030?ofkP3D?AT0ooK^00X0ooK^00<0e3dI0?of
kP3om^h01P3om^h20=@m6@<0ooK^00@000000?ofkP3D?AT0e3dI103om^h30000000300H84@000000
e3dI00801PPA00<0000000/?800;3b000P0;3b00100000002`lP00/?8000000301@J?0040000000D
6S`051Xl01@J?080e3dI00D051Xl00000000000000000=@m6@0401dXE`030000000M:5L07BQG00D0
7BQG0`00000502DdK`030000000U=6l0e3dI00<09CA_0P3D?AT00`0U=6l0000002DdK`0202DdK`05
0000000/?X80;3j202`nPP0000000`3oB1d01@000000n4DL0?Q5703hAA`000000080n4DL00L0?EV[
0?Q5703hAA`0n4DL03eIZ`3hAA`0000000D0n4DL0`0000070>Y06@030000003Z@1T0jT0I0080jT0I
00D0?EV[00000000000000000=@i5P0203eIZ`<0e3TF00D000000=@i5P3D>AH0e3TF000000020;8^
4@030000002b;Q40/RhA0080/RhA00H0000008XR3@2:8Pd0?EV[0000002:8Pd3000000@0ooK^0P0m
FJ/00`3om^h000000?ofkP020?ofkP80?EV[203om^h00`0mFJ/0ooK^0?ofkP090?ofkP0403eIZ`3o
m^h0?EV[03eIZa40ooK^00<0?EV[0?ofkP3om^h0203om^h203eIZ`T0ooK^00<0?EV[0?ofkP3om^h0
403om^h303eIZa80ooK^0P00000K0?ofkP030000003om^h0ooK^0240ooK^0@3oool002<0ooK^00<0
00000?ofkP3om^h06`3om^h200000100ooK^00<0e3dI0?ofkP3om^h00P3D?AT@0?ofkP030=@m6@3o
m^h0ooK^00T0ooK^0P3D?AT70?ofkP030=@m6@3om^h0ooK^0180ooK^00<0e3dI0?ofkP3om^h02P3o
m^h00`3D?AT0ooK^0?ofkP060?ofkP050=@m6@3om^h0e3dI0=@m6@000000103om^h20=@m6@080?of
kP0000000000000000062140000000H84@3D?AT3000000@02`lP00<0000000/?80000000100D6S`0
0`00000051Xl01@J?00301@J?0050=@m6@0000007BQG01dXE`3D?AT0100M:5L00`0000007BQG01dX
E`0501dXE`030000000U=6l09CA_00D09CA_00<0000002DdK`3D?AT01@0U=6l01@3D?AT0000002Dd
K`0U=6l0000000@0;3j200<000000?m87@3oB1d00P3oB1d010000000n4DL0?Q57000000203eIZ`@0
n4DL00<0?EV[0?Q5700000001`3hAA`00`000000jT0I0>Y06@050>Y06@030000003Z@1T0jT0I0080
jT0I00D0?EV[0>Y06@3Z@1T0000003eIZ`050=@i5P030000003D>AH0e3TF0080e3TF00<000000;8^
4@000000102b;Q430000000403eIZ`2:8Pd0000008XR3@<0000000<0ooK^03eIZ`0mFJ/0103om^h0
1@000000?EV[03eIZ`3om^h0?EV[00P0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?of
kP0B0?ofkP0303eIZ`3om^h0ooK^00D0ooK^0P0mFJ/;0?ofkP0303eIZ`3om^h0ooK^00h0ooK^0P0m
FJ/20?ofkP0303eIZ`3om^h0ooK^00h0ooK^0P00000M0?ofkP030000003om^h0ooK^0240ooK^0@3o
ool00280ooK^00<000000?ofkP3om^h07P3om^h2000000d0ooK^00<0e3dI0?ofkP3om^h00`3om^h2
0=@m6@d0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0
ooK^01<0ooK^0`3D?AT90?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h00P000000
0`3D?AT0ooK^0?ofkP030?ofkP<000000P0621401P0000001PPA0=@m6@0000002`lP000000@02`lP
0`00000401@J?0030000000D6S`051Xl00@051Xl00@000000=@m6@3D?AT0e3dI1@0M:5L00`000000
7BQG01dXE`0401dXE`8000001`0U=6l00`000000e3dI02DdK`0602DdK`80e3dI00<0000002`nPP0/
?X800`0/?X800`000000odPM0?m87@030?m87@80000000<0?EV[0?Q5703hAA`01@3hAA`00`0mFJ/0
n4DL0?Q570060?Q5708000001P3Z@1T00`000000jT0I0>Y06@030>Y06@<0?EV[00<0e3dI0=@i5P3D
>AH00`3D>AH00`000000e3TF0=@i5P030=@i5P<00000102b;Q401P000000/RhA0000000mFJ/0RR8=
00000080RR8=0`0000050?ofkP0303eIZ`00000000000080ooK^00<0?EV[0?ofkP3om^h01P3om^h0
0`0mFJ/0ooK^0?ofkP070?ofkP<0?EV[503om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0
ooK^00/0ooK^00<0?EV[0?ofkP3om^h0303om^h203eIZ`D0ooK^00<0?EV[0?ofkP3om^h02`3om^h2
000001l0ooK^00<000000?ofkP3om^h08@3om^h10?ooo`008P3om^h00`000000ooK^0?ofkP0P0?of
kP8000002`3om^h00`3D?AT0ooK^0?ofkP050?ofkP80e3dI2`3om^h00`3D?AT0ooK^0?ofkP0=0?of
kP80e3dI0`3om^h00`3D?AT0ooK^0?ofkP0B0?ofkP040=@m6@3om^h0ooK^0?ofkP80e3dI1P3om^h0
0`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0000000<0ooK^0P3D?AT20?ofkP<000000`062142
000000040=@m6@0;3b002`lP000000@02`lP00<0000001@J?00D6S`0100D6S`00`00000051Xl01@J
?00201@J?080000000@07BQG0000000M:5L0e3dI1@0M:5L00`0000007BQG01dXE`0201dXE`800000
00<09CA_0000000U=6l01`0U=6l00`3D?AT09CA_02DdK`0502DdK`030000000/?X80e3dI00D0;3j2
00<000000?m87@3oB1d00`3oB1d203eIZ`030000003hAA`0n4DL00D0n4DL00<0?EV[0?Q5703hAA`0
1P3hAA`010000000n4DL0000000000040>Y06@030000003Z@1T0jT0I00<0jT0I00@0?EV[0>Y06@00
0000jT0I0P0000040=@i5P030000003D>AH0e3TF00@0e3TF00<000000;8^4@2b;Q400P2b;Q401000
0000/RhA0;8^4@0mFJ/2000000<0RR8=0`0000020?ofkP80?EV[0`3om^h00`000000ooK^03eIZ`09
0?ofkP0303eIZ`3om^h0ooK^00@0ooK^0P0mFJ/30?ofkP0303eIZ`3om^h0ooK^0180ooK^00@0?EV[
0?ofkP3om^h0ooK^0P0mFJ/?0?ofkP0303eIZ`3om^h0ooK^00T0ooK^0P0mFJ/70?ofkP0303eIZ`3o
m^h0ooK^00T0ooK^0P00000R0?ofkP030000003om^h0ooK^0200ooK^0@3oool00280ooK^00<00000
0?ofkP3om^h08P3om^h00`000000ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI
0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP0?0?ofkP<0e3dI5@3om^h00`3D?AT0ooK^0?ofkP03
0?ofkP80e3dI0`3om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@000000000000H0ooK^0P3D?AT0
0`0000001PPA0000000200H84@030000000;3b00e3dI00802`lP00@0000000/?800;3b002`lP0`00
000601@J?0050000000D6S`051Xl01@J?00000000`0M:5L00`000000e3dI01dXE`020=@m6@<07BQG
00D0000001dXE`0M:5L07BQG0000000302DdK`030000000U=6l09CA_00H09CA_00<0e3dI02DdK`0U
=6l00`0U=6l300000080;3j20P3D?AT302`nPP040000003oB1d0odPM0?m87@80?EV[0P3oB1d30000
00D0n4DL00<0?EV[0?Q5703hAA`01P3hAA`01@000000n4DL0?Q5703hAA`0000000<0jT0I00@00000
0>Y06@3Z@1T0jT0I0P0mFJ/00`3Z@1T0?EV[000000030>Y06@050000003D>AH0e3TF0=@i5P000000
1P3D>AH300000080/RhA00L000000;8^4@2b;Q40/RhA03eIZ`2b;Q4000000080RR8=00<0000008XR
3@0000000P0mFJ/60?ofkP80000000<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP020?of
kP80?EV[1@3om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP0403eIZ`3om^h0?EV[03eIZa40ooK^00<0?EV[
0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<00000
0?ofkP3om^h08P3om^h00`000000ooK^0?ofkP0P0?ofkP40oooo000R0?ofkP030000003om^h0ooK^
02<0ooK^0P0000080?ofkP030=@m6@3om^h0ooK^00P0ooK^0P3D?AT70?ofkP030=@m6@3om^h0ooK^
0180ooK^00<0e3dI0?ofkP3om^h04P3om^h00`3D?AT0ooK^0?ofkP060?ofkP80e3dI00<0ooK^0=@m
6@3om^h0203om^h00`000000ooK^0?ofkP040?ofkP070000000mFJ/000000000003D?AT0000000H8
4@030000000500/?803D?AT02`lP00/?800000000P0;3b001000000051Xl01@J?000000601@J?004
0000000D6S`051Xl000000@07BQG00<000000=@m6@0M:5L00P0M:5L0103D?AT07BQG01dXE`000002
01dXE`030000000U=6l09CA_00809CA_00<0000002DdK`0U=6l01@0U=6l00`3D?AT0000002DdK`03
02DdK`040000000/?X80;3j2000000@0;3j20P3D?AT01@0/?X8000000?m87@3oB1d0?EV[00@0odPM
00@000000?m87@3oB1d00000103hAA`00`000000?EV[0?Q570060?Q570030000003hAA`0n4DL0080
n4DL00@000000>Y06@3Z@1T000000P3Z@1T01P0mFJ/0jT0I0>Y06@3Z@1T0?EV[000000@0jT0I00@0
00000=@i5P3D>AH000001P3D>AH010000000e3TF0=@i5P0000020;8^4@050000002b;Q40/RhA03eI
Z`2b;Q400`0000000`2:8Pd0000003eIZ`04000000H0ooK^00<000000?ofkP3om^h01`3om^h0100m
FJ/0ooK^03eIZ`0mFJ/80?ofkP0303eIZ`3om^h0ooK^0180ooK^00<0?EV[0?ofkP3om^h04P3om^h0
0`0mFJ/0ooK^0?ofkP050?ofkP80?EV[2P3om^h00`0mFJ/0ooK^0?ofkP060?ofkP8000009@3om^h0
0`000000ooK^0?ofkP0P0?ofkP40oooo000R0?ofkP030000003om^h0ooK^02D0ooK^0P0000050?of
kP030=@m6@3om^h0ooK^00/0ooK^0P3D?AT50?ofkP030=@m6@3om^h0ooK^0180ooK^0`3D?ATB0?of
kP030=@m6@3om^h0ooK^00P0ooK^0P3D?AT70?ofkP8000001@3om^h20000000503eIZ`0000001PPA
00H84@0000000P3D?AT0100;3b00000000/?803D?AT300/?80030000000;3b00000000<051Xl00<0
000001@J?00D6S`0100D6S`3000000D07BQG00<0e3dI01dXE`0M:5L00`0M:5L20=@m6@<000001@0U
=6l00`0000009CA_02DdK`0502DdK`040=@m6@0000009CA_02DdK`8000000`0/?X800`000000;3j2
02`nPP0402`nPP040=@m6@000000?EV[03eIZ`D0odPM00@000000?m87@3oB1d0odPM0P0000020?Q5
70030000000mFJ/0n4DL00H0n4DL00<000000?Q5703hAA`00`3hAA`300000080?EV[1@3Z@1T00`0m
FJ/0jT0I0>Y06@030>Y06@<000001P3D>AH01`000000e3TF0=@i5P3D>AH000000;8^4@0000000`2b
;Q40100mFJ/0/RhA0000002b;Q4203eIZ`050000002:8Pd0RR8=0000003D?AT00P0000050?ofkP80
00001`3om^h203eIZ`X0ooK^00<0?EV[0?ofkP3om^h0403om^h303eIZa@0ooK^00<0?EV[0?ofkP3o
m^h00`3om^h203eIZ`d0ooK^00<0?EV[0?ofkP3om^h00`3om^h2000002L0ooK^00<000000?ofkP3o
m^h0803om^h10?ooo`008@3om^h00`000000ooK^0?ofkP0X0?ofkP8000000`3om^h00`3D?AT0ooK^
0?ofkP0=0?ofkP80e3dI0`3om^h00`3D?AT0ooK^0?ofkP0A0?ofkP040=@m6@3om^h0ooK^0?ofkP80
e3dI3`3om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^0080e3dI103om^h00`000000
ooK^0=@m6@040?ofkP040000000mFJ/0?EV[000000801PPA00@0000000H84@0000002`lP0P3D?AT0
100;3b00e3dI00/?800;3b03000000@051Xl00<0000001@J?00D6S`0100D6S`00`0000007BQG01dX
E`0501dXE`030=@m6@0M:5L07BQG00D07BQG00<0e3dI02DdK`0U=6l01@0U=6l00`0000009CA_02Dd
K`0402DdK`030=@m6@0U=6l00000008000001@0/?X800`000000;3j202`nPP0502`nPP030=@m6@3o
B1d0odPM00D0odPM00<000000?m87@3oB1d00`3oB1d3000000030?Q5700mFJ/0n4DL00@0n4DL00<0
00000?Q5703hAA`01P3hAA`00`0mFJ/0jT0I0>Y06@050>Y06@0303eIZ`3Z@1T0jT0I00D0jT0I00<0
00000=@i5P3D>AH0103D>AH00`000000e3TF0=@i5P020=@i5P<000000P2b;Q40200mFJ/0/RhA03eI
Z`0mFJ/0/RhA0000002:8Pd000000P2:8Pd010000000e3dI0000000000040?ofkP0303eIZ`3om^h0
000000@0ooK^0P0mFJ/20?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h03@3om^h2
03eIZ`<0ooK^00<0?EV[0?ofkP3om^h04@3om^h0100mFJ/0ooK^0?ofkP3om^h203eIZ`l0ooK^00@0
?EV[0?ofkP3om^h0ooK^0P00000Z0?ofkP030000003om^h0ooK^01l0ooK^0@3oool00240ooK^00<0
00000?ofkP3om^h0:P3om^h2000000030?ofkP3D?AT0ooK^0100ooK^0`3D?ATD0?ofkP030=@m6@3o
m^h0ooK^00<0ooK^0P3D?AT=0?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h00P3o
m^h20=@m6@80000000<0ooK^0=@m6@3om^h00`3om^h010000000?EV[00000000000300H84@800000
0P0;3b000`0000002`lP0=@m6@0300/?80030000000D6S`051Xl00<051Xl00<0000001@J?00D6S`0
0`0D6S`3000000H07BQG00<0e3dI0000000M:5L0100M:5L300000080e3dI1P0U=6l00`0000009CA_
02DdK`0302DdK`030=@m6@0U=6l0000000L0;3j200<0000002`nPP0/?X801@0/?X800`000000odPM
0?m87@050?m87@030000003oB1d0odPM00D0odPM00<000000?Q5700mFJ/01@3hAA`00`000000n4DL
0?Q570040?Q57080?EV[0`0000050>Y06@030000000mFJ/0jT0I00D0jT0I0`0000050=@i5P030000
003D>AH0e3TF00<0e3TF00L000000;8^4@2b;Q40/RhA03eIZ`2b;Q4000000080/RhA0P00000208XR
3@050000002:8Pd0000005`D20000000103om^h0100mFJ/0ooK^00000000000203eIZ`@0ooK^00<0
?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP80?EV[1@3om^h00`0mFJ/0ooK^0?of
kP0B0?ofkP<0?EV[4@3om^h0100mFJ/0ooK^00000000000/0?ofkP030000003om^h0ooK^01l0ooK^
0@3oool00240ooK^00<000000?ofkP3om^h0;03om^h00`000000e3dI0?ofkP0B0?ofkP030=@m6@3o
m^h0ooK^0180ooK^00<0e3dI0?ofkP3om^h01@3om^h20=@m6@X0ooK^00<0e3dI0?ofkP3om^h0203o
m^h00`3D?AT0ooK^0?ofkP040?ofkP050000003D?AT0e3dI0?ofkP3D?AT00P3om^h20000000400H8
4@0000000000000000801PPA00<0000000/?800;3b000P0;3b000`000000e3dI00/?80020=@m6@80
00001@0D6S`00`00000051Xl01@J?00201@J?0040000000M:5L07BQG000000H07BQG00<0e3dI0000
000M:5L00`0M:5L0100000009CA_02DdK`00000202DdK`030=@m6@0U=6l09CA_00<09CA_00<00000
02DdK`0U=6l00P0U=6l0103D?AT0000000000000000702`nPP030000000/?X80;3j200D0;3j200<0
00000?m87@3oB1d01@3oB1d00`000000odPM0?m87@050?m87@<0000000<0?EV[0?Q5703hAA`00P3h
AA`00`000000n4DL0?Q570030?Q5700403eIZ`3hAA`0n4DL00000080n4DL00<000000>Y06@3Z@1T0
0P3Z@1T00`000000?EV[0>Y06@050>Y06@040000003Z@1T0jT0I000000@0e3TF00<000000=@i5P3D
>AH00`3D>AH200000080?EV[00<0/RhA03eIZ`000000102b;Q401`000000RR8=08XR3@000000RR8=
0000001L50P00P0000020?ofkP0503eIZ`3om^h0?EV[03eIZ`0000001P3om^h00`0mFJ/0ooK^0?of
kP080?ofkP0303eIZ`3om^h0ooK^00P0ooK^0P0mFJ/70?ofkP0303eIZ`3om^h0ooK^0180ooK^00<0
?EV[0?ofkP3om^h04@3om^h00`0mFJ/000000?ofkP0]0?ofkP030000003om^h0ooK^01l0ooK^0@3o
ool00240ooK^00<000000?ofkP3om^h0;03om^h00`3D?AT0ooK^0000000B0?ofkP<0e3dI4P3om^h0
0`3D?AT0ooK^0?ofkP070?ofkP80e3dI203om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0
ooK^00@0ooK^00D000000?ofkP3om^h0ooK^0=@m6@020?ofkP80000000D01PPA0000000621400000
00H84@03000000<02`lP00P0000000/?803D?AT02`lP0000000D6S`0e3dI000000D051Xl00<00000
01@J?00D6S`00P00000301dXE`030000000M:5L07BQG00<07BQG00<0e3dI01dXE`0000000P0M:5L2
000000<09CA_00@0000002DdK`0U=6l09CA_0P3D?AT302DdK`030000000U=6l09CA_00809CA_00@0
e3dI02`nPP0/?X8000001`0/?X800`000000;3j202`nPP0502`nPP030000003oB1d0odPM00D0odPM
00<000000?m87@3oB1d01@3oB1d010000000odPM0?m87@0mFJ/30?Q570030=@m6@000000n4DL0080
n4DL0P0mFJ/30?Q570040000003hAA`0n4DL0?Q5708000000P3Z@1T00`000000jT0I03eIZ`050>Y0
6@040000003Z@1T0jT0I0>Y06@8000000P3D>AH00`000000e3TF0=@i5P030=@i5P080000000mFJ/0
e3TF0000002b;Q40?EV[0;8^4@0000030;8^4@<0000000D0RR8=0000002:8Pd0000005`D20020000
0080ooK^00D0?EV[0?ofkP3om^h0ooK^000000060?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[
0?ofkP3om^h01P3om^h203eIZ`T0ooK^00<0?EV[0?ofkP3om^h0403om^h303eIZa80ooK^00<00000
0?ofkP0mFJ/0;P3om^h00`000000ooK^0?ofkP0O0?ofkP40oooo000Q0?ofkP030000003om^h0ooK^
02`0ooK^00<0e3dI0?ofkP3om^h00P00000@0?ofkP030=@m6@3om^h0ooK^0080e3dI3`3om^h00`3D
?AT0ooK^0?ofkP0:0?ofkP80e3dI1@3om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^
0080ooK^0P0000040?ofkP80e3dI0P00000020062140000000H84@0000001PPA0000000;3b000000
100;3b0010000000e3dI00000000000201@J?0030000003D?AT0e3dI00@051Xl0`00000501dXE`03
0000000M:5L07BQG00<07BQG00<0e3dI01dXE`0000000P00000502DdK`030000000U=6l09CA_00<0
9CA_00@0e3dI02DdK`0U=6l000000P0U=6l2000000040=@m6@0/?X80;3j2000000L0;3j200<00000
02`nPP0/?X801@0/?X800`000000odPM0?m87@050?m87@030000003oB1d0odPM00D0odPM00@00000
0?m87@3oB1d0?EV[0P0000020?Q570040000003hAA`0n4DL03eIZ`D0n4DL00<000000?Q5703hAA`0
0`3hAA`3000000030>Y06@0mFJ/0jT0I00@0jT0I00<000000>Y06@3Z@1T00`3Z@1T3000000@0e3TF
0P0mFJ/00`000000e3TF0=@i5P020000000303eIZ`000000/RhA00<0/RhA00P000000;8^4@000000
RR8=0000002:8Pd0000005`D208000000P0mFJ/40?ofkP800000103om^h00`0mFJ/0ooK^0?ofkP08
0?ofkP0303eIZ`3om^h0ooK^00<0ooK^0P0mFJ/<0?ofkP0303eIZ`3om^h0ooK^00d0ooK^0P0mFJ/2
0?ofkP0303eIZ`3om^h0ooK^00h0ooK^0P0000020?ofkP0303eIZ`3om^h0ooK^02`0ooK^00<00000
0?ofkP3om^h07`3om^h10?ooo`00803om^h00`000000ooK^0?ofkP0]0?ofkP030=@m6@3om^h0ooK^
0080ooK^0P00000=0?ofkP030=@m6@3om^h0ooK^00<0ooK^0P3D?AT=0?ofkP030=@m6@3om^h0ooK^
00`0ooK^0P3D?AT30?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`00
0000ooK^0?ofkP030?ofkP040=@m6@3om^h0000000H84@80000000@01PPA00000006214000000P0;
3b001`0000002`lP00/?800;3b0000000=@m6@000000100D6S`00`00000051Xl01@J?0020=@m6@80
51Xl00<0000001dXE`0M:5L01@0M:5L00`0000007BQG01dXE`0201dXE`040=@m6@0M:5L07BQG0000
00L09CA_00<0000002DdK`0U=6l0100U=6l20=@m6@<0000000<0;3j20=@m6@0/?X800P0/?X800`00
0000;3j202`nPP0502`nPP030000000/?X80;3j200D0;3j200<000000?m87@3oB1d01@3oB1d00`00
0000odPM0?m87@050?m87@060000003oB1d0odPM0?m87@0mFJ/0odPM0`00000203eIZ`H0n4DL00<0
00000?Q5703hAA`01@3hAA`010000000jT0I0>Y06@0mFJ/40>Y06@030000003Z@1T0jT0I00D0jT0I
00<000000=@i5P3D>AH00P0mFJ/20=@i5P030000003D>AH0e3TF0080e3TF00<0000003eIZ`000000
0`2b;Q400`000000/RhA0;8^4@0200000080RR8=0P000000101L50P000000?ofkP0mFJ/50?ofkP03
0000003om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h01`3om^h0100mFJ/0ooK^0?ofkP3om^h203eI
Z`h0ooK^00<0?EV[0?ofkP3om^h02`3om^h203eIZ`D0ooK^00<0?EV[0?ofkP3om^h02`3om^h20000
00@0ooK^00<0?EV[0?ofkP3om^h0;@3om^h00`000000ooK^0?ofkP0N0?ofkP40oooo000P0?ofkP03
0000003om^h0ooK^02d0ooK^0`3D?AT40?ofkP8000002`3om^h00`3D?AT0ooK^0?ofkP050?ofkP80
e3dI2`3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP<0e3dI2@3om^h0103D?AT0ooK^0=@m6@3D?AT20000
00H0ooK^00<0e3dI0000000000000P00000200H84@8000000P0;3b000`0000002`lP00/?800200/?
80030000003D?AT051Xl00@051Xl00<0000001@J?00D6S`00P0D6S`00`3D?AT000000000000701dX
E`030000000M:5L07BQG00807BQG00@0e3dI0000000000000000200U=6l00`0000009CA_02DdK`05
02DdK`050=@m6@0/?X80;3j202`nPP3D?AT00`0/?X800`000000;3j202`nPP0502`nPP030000000/
?X80;3j200<0;3j21@0000050?m87@030000003oB1d0odPM00D0odPM00D000000?m87@3oB1d0odPM
03eIZ`030?m87@0303eIZ`3hAA`0n4DL00D0n4DL00<000000?Q5703hAA`01P3hAA`30000000303eI
Z`3Z@1T0jT0I0080jT0I00<000000>Y06@3Z@1T01@3Z@1T00`000000e3dI03eIZ`040=@i5P030000
003D>AH0e3TF00<0e3TF00<0?EV[0000002b;Q400`2b;Q400`000000/RhA0;8^4@0200000080RR8=
100000000`0mFJ/0ooK^0?ofkP040?ofkP8000000P0mFJ/00`3om^h0?EV[0?ofkP080?ofkP<0?EV[
403om^h00`0mFJ/0ooK^0?ofkP090?ofkP80?EV[1`3om^h00`0mFJ/0ooK^0?ofkP090?ofkP800000
103om^h303eIZbl0ooK^00<000000?ofkP3om^h07P3om^h10?ooo`00803om^h00`000000ooK^0?of
kP0]0?ofkP030=@m6@3om^h0ooK^0080e3dI103om^h2000000T0ooK^00<0e3dI0?ofkP3om^h01`3o
m^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^0140ooK^00<0e3dI0?ofkP3om^h01P3o
m^h01@3D?AT0ooK^0?ofkP3om^h000000080e3dI1@3om^h01@3D?AT0000000000006214000000080
1PPA00<0000000/?800;3b000P0;3b000`0000002`lP00/?8002000000030=@m6@0D6S`051Xl00@0
51Xl00H0000001@J?00D6S`051Xl0000000M:5L20=@m6@L07BQG00H0000001dXE`0M:5L07BQG0=@m
6@00000202DdK`030000000U=6l09CA_00H09CA_00<0000002DdK`0U=6l00`0U=6l3000000<0e3dI
100/?X800`000000;3j202`nPP0502`nPP030000000/?X80;3j20080;3j200@000000357TP0aAi80
00000P3oBQh00`000000odPM0?m87@020?m87@030000003oB1d0odPM00D0odPM00<000000?m87@3o
B1d00P3oB1d303eIZ`<000001@3hAA`00`000000n4DL0?Q570060?Q570050000003hAA`0n4DL0000
000mFJ/00`3Z@1T00`000000jT0I0>Y06@050>Y06@80?EV[00<0jT0I0000003D>AH00P3D>AH00`00
0000e3TF0=@i5P040=@i5P0303eIZ`00000000000080/RhA00<000000;8^4@2b;Q400P2b;Q401@00
0000RR8=08XR3@000000RR8=0080000000<0?EV[0?ofkP3om^h00`3om^h203eIZ`050000003om^h0
ooK^0?ofkP0mFJ/0203om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0
?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP070?ofkP800000103om^h203eIZ`80ooK^00<0
?EV[0?ofkP3om^h0;@3om^h00`000000ooK^0?ofkP0N0?ofkP40oooo000P0?ofkP030000003om^h0
ooK^02d0ooK^00<0e3dI0?ofkP3om^h00P3om^h20=@m6@@0ooK^0P0000070?ofkP030=@m6@3om^h0
ooK^00P0ooK^0P3D?AT70?ofkP030=@m6@3om^h0ooK^0140ooK^0`3D?AT50?ofkP030=@m6@3om^h0
ooK^008000000`3om^h0103D?AT0ooK^0?ofkP3om^h2000000801PPA00@0000000H84@0000000000
100;3b001`0000002`lP00/?8000000051Xl0=@m6@0000001@0D6S`00`00000051Xl01@J?0020000
00<07BQG00<000000=@m6@0M:5L01@0M:5L01@0000007BQG01dXE`000000e3dI00<09CA_00<00000
02DdK`0U=6l01P0U=6l00`0000009CA_02DdK`0202DdK`040000000/?X80;3j200000080;3j200<0
e3dI02`nPP0/?X800P0/?X800`000000;3j202`nPP0502`nPP030000000/?X80;3j2008000000`0a
Ai8010000000odXN0?m:7P3oBQh200000080odPM00<000000?m87@3oB1d0103oB1d00`000000odPM
0?m87@030?m87@0403eIZ`3oB1d0odPM00000080odPM00<000000?Q5703hAA`00P3hAA`00`000000
n4DL0?Q570060?Q570060000003hAA`0n4DL0?Q5700mFJ/000000P3Z@1T00`000000jT0I0>Y06@04
0>Y06@0303eIZ`000000jT0I0080jT0I0P0000020=@i5P030000003D>AH0e3TF00<0e3TF00@00000
03eIZ`3D>AH000000P2b;Q4010000000/RhA0;8^4@2b;Q430000000408XR3@000000RR8=08XR3@80
00000`3om^h0100mFJ/0ooK^0?ofkP3om^h200000080ooK^00<0?EV[0?ofkP3om^h00`3om^h303eI
Za<0ooK^00<0?EV[0?ofkP3om^h01@3om^h203eIZ`X0ooK^00<0?EV[0?ofkP3om^h01@3om^h20000
00@0ooK^0P0mFJ/40?ofkP0303eIZ`3om^h0ooK^02d0ooK^00<000000?ofkP3om^h07P3om^h10?oo
o`007`3om^h00`000000ooK^0?ofkP0^0?ofkP030=@m6@3om^h0ooK^00@0ooK^0P3D?AT40?ofkP03
0000003om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h02`3om^h20=@m6@D0ooK^00<0e3dI0?ofkP3o
m^h0403om^h0103D?AT0ooK^0?ofkP3om^h20=@m6@<0ooK^00<0e3dI0?ofkP0000001P3om^h20=@m
6@8000000P0621430000000300/?800000002`lP00<02`lP00L0000000/?8000000051Xl0=@m6@0D
6S`0000000D051Xl0`00000501dXE`040000000M:5L0e3dI0=@m6@@07BQG0`0000000`3D?AT09CA_
02DdK`0202DdK`030000000U=6l09CA_00H09CA_00<0000002DdK`0U=6l00P00000302`nPP040000
000/?X80e3dI02`nPP80e3dI0`0/?X800`000000;3j202`nPP0402`nPP<000001@0aAi800`000000
odXN0?m:7P030?m:7P<000001P3oB1d010000000odPM0?m87@3oB1d303eIZ`80odPM00@000000?m8
7@3oB1d0odPM0P0000020?Q570030000003hAA`0n4DL00H0n4DL00<000000?Q5703hAA`00P3hAA`0
100mFJ/000000000000000040>Y06@80?EV[00<0jT0I0000003Z@1T0103Z@1T3000000D0e3TF00L0
000003eIZ`3D>AH0e3TF0000002b;Q40000000@0/RhA00<000000;8^4@0000000P00000208XR3@80
00000P0mFJ/60?ofkP030000003om^h0?EV[00<0ooK^0P0mFJ/30?ofkP0303eIZ`3om^h0ooK^0100
ooK^00<0?EV[0?ofkP3om^h00`3om^h203eIZ`d0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`000000
ooK^0?ofkP020?ofkP80?EV[1P3om^h00`0mFJ/0ooK^0?ofkP0^0?ofkP030000003om^h0ooK^01d0
ooK^0@3oool001l0ooK^00<000000?ofkP3om^h0;P3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m
6@3om^h0ooK^0080ooK^0P0000030?ofkP030=@m6@3om^h0ooK^00d0ooK^0P3D?AT30?ofkP030=@m
6@3om^h0ooK^0100ooK^00<0e3dI0?ofkP3om^h00`3om^h30=@m6@030?ofkP000000ooK^00H0ooK^
0P0000020=@m6@0300H84@000000000000802`lP00<0000000/?800;3b000P0;3b030000008051Xl
00<0e3dI01@J?00000001@0D6S`00`000000?EV[01dXE`0501dXE`040000000M:5L07BQG01dXE`80
e3dI0P0M:5L0100000009CA_02DdK`3D?AT402DdK`030000000U=6l09CA_00H09CA_0`00000502`n
PP030000000/?X80e3dI00<0;3j20P3D?AT00`0/?X80000002`nPP0502`nPP030000000aAi80<DNB
00D0<DNB00<000000?m:7P3oBQh01@3oBQh00`000000odPM0?m87@040?m87@040000003oB1d0?EV[
03eIZ`<0odPM00<0?EV[0?m87@0000001@3oB1d3000000P0n4DL00<000000?Q5703hAA`00P3hAA`0
100mFJ/0n4DL0?Q5700000020>Y06@80?EV[0`3Z@1T00`000000jT0I0>Y06@050>Y06@030000003D
>AH0e3TF00<0e3TF00<000000=@i5P0mFJ/00P3D>AH3000000<0/RhA00@000000;8^4@2b;Q40/RhA
0P0000000`2:8Pd0?EV[03eIZ`02000000L0ooK^00<000000?ofkP0mFJ/00P0mFJ/50?ofkP0303eI
Z`3om^h0ooK^0100ooK^00@0?EV[0?ofkP3om^h0ooK^0P0mFJ/?0?ofkP0403eIZ`3om^h0ooK^0?of
kP800000103om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^02h0ooK^00<000000?of
kP3om^h07@3om^h10?ooo`007`3om^h00`000000ooK^0?ofkP0]0?ofkP030=@m6@3om^h0ooK^00P0
ooK^0P3D?AT40?ofkP80000000<0ooK^0=@m6@3om^h0403om^h30=@m6A<0ooK^00<0e3dI0?ofkP3o
m^h0103om^h00`3D?AT00000000000070?ofkP80000000@01PPA000000062140e3dI100;3b000`00
00002`lP00/?800200/?80070000000D6S`051Xl01@J?03D?AT051Xl0000000401@J?0<000001`0M
:5L00`0000007BQG01dXE`0301dXE`050=@m6@000000000002DdK`3D?AT01P0U=6l00`0000009CA_
02DdK`0502DdK`030000000/?X80;3j200D0;3j200<000000=@m6@0/?X801@0/?X800`3D?AT00000
02`nPP0302`nPP<000001`0aAi800`000000odXN0?m:7P050?m:7P<00000103oB1d00`000000?EV[
0?m87@040?m87@0303eIZ`3oB1d0000000L0odPM00<000000?Q5703hAA`01@3hAA`00`000000n4DL
0?Q570040?Q5700503eIZ`3hAA`000000000000mFJ/01@3Z@1T00`000000jT0I0>Y06@050>Y06@<0
0000103D>AH00`000000e3TF03eIZ`030=@i5P030000002b;Q40/RhA0080/RhA00<000000;8^4@2b
;Q400P2b;Q40100mFJ/0RR8=0000002:8Pd2000000L0ooK^0P0000000`0mFJ/0ooK^0?ofkP040?of
kP0303eIZ`3om^h0ooK^0140ooK^0`0mFJ/A0?ofkP0403eIZ`3om^h00000000000@0ooK^0P0mFJ/9
0?ofkP0303eIZ`3om^h0ooK^02h0ooK^00<000000?ofkP3om^h07@3om^h10?ooo`007`3om^h00`00
0000ooK^0?ofkP0]0?ofkP030=@m6@3om^h0ooK^00X0ooK^0P3D?AT40?ofkP030000003D?AT0ooK^
0180ooK^00<0e3dI0?ofkP3om^h04@3om^h00`3D?AT0ooK^0?ofkP030?ofkP040=@m6@000000ooK^
0?ofkP80e3dI0`3om^h01P0mFJ/0000000H84@062140000000H84@8000000P3D?AT00`0;3b000000
00/?800200/?80<000000P0D6S`0103D?AT051Xl01@J?000000301@J?0040000000M:5L07BQG0000
00L07BQG00<0000001dXE`0M:5L00P0M:5L01P0000009CA_0=@m6@3D?AT09CA_0=@m6@H09CA_00<0
000002DdK`0U=6l00`0U=6l3000000L0;3j200<000000=@m6@0/?X801P0/?X820=@m6@80;3j200@0
00000357TP0aAi8000001`0aAi800`000000odXN0?m:7P050?m:7P040000003oBQh0odXN00000080
odPM0P0mFJ/70?m87@0303eIZ`000000odPM00H0odPM0`0000050?Q570030000003hAA`0n4DL00@0
n4DL00H0?EV[0?Q5700mFJ/0?EV[0?Q5700000040>Y06@030000003Z@1T0jT0I00D0jT0I00@00000
0>Y06@3Z@1T000000`3D>AH010000000e3TF0=@i5P0mFJ/20=@i5P<000000P2b;Q400`000000/RhA
0;8^4@0203eIZ`80000000D0RR8=0000002:8Pd0RR8=000000040?ofkP80?EV[0P3om^h00`000000
?EV[0?ofkP040?ofkP0303eIZ`3om^h0ooK^0140ooK^00<0?EV[0?ofkP3om^h04@3om^h00`0mFJ/0
00000?ofkP030?ofkP80?EV[303om^h00`0mFJ/0ooK^0?ofkP0]0?ofkP030000003om^h0ooK^01d0
ooK^0@3oool001l0ooK^00<000000?ofkP3om^h0;@3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP80e3dI
0P3om^h0103D?AT0ooK^00000000000A0?ofkP<0e3dI403om^h00`3D?AT0ooK^0?ofkP030?ofkP80
00001@3om^h20=@m6@0603eIZ`0000001PPA00H84@0000001PPA0P00000300/?8080e3dI00<02`lP
0000000000000P0D6S`01000000051Xl01@J?03D?AT201@J?0040000000D6S`051Xl000000<07BQG
00<0000001dXE`0M:5L01@0M:5L00`0000007BQG01dXE`02000000<09CA_00<000000=@m6@0U=6l0
1P0U=6l00`0000009CA_02DdK`0202DdK`040000000/?X80;3j2000000L0;3j200<0e3dI0000000/
?X801P0/?X8010000000;3j20=@m6@0000030357TP030000000aAi80<DNB00@0<DNB00<0e3dI0000
000mFJ/01P3oBQh020000000odXN0?m:7P3oBQh0000003eIZ`3oB1d000001`3oB1d00`0mFJ/0odPM
0?m87@060?m87@040000003oB1d0odPM000000@0n4DL00<000000?Q5703hAA`01@3hAA`00`0mFJ/0
00000?Q570020?Q5708000000P3Z@1T00`000000jT0I0>Y06@050>Y06@050000003Z@1T0jT0I0>Y0
6@0000000P3D>AH010000000e3TF0=@i5P0mFJ/20=@i5P030000003D>AH0e3TF0080000000<0/RhA
03eIZ`0mFJ/00`2b;Q420000000608XR3@000000RR8=08XR3@000000e3dI0P0mFJ/50?ofkP800000
1@3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP<0?EV[4@3om^h2000000040?ofkP0mFJ/0ooK^0?ofkP80
?EV[3P3om^h00`0mFJ/0ooK^0?ofkP0]0?ofkP030000003om^h0ooK^01d0ooK^0@3oool001h0ooK^
00<000000?ofkP3om^h0;P3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP<0e3dI0`3om^h2000000l0ooK^
00<0e3dI0?ofkP3om^h00P3D?AT>0?ofkP030=@m6@3om^h0ooK^0080ooK^00<000000?ofkP3om^h0
1@3om^h203eIZ`030=@m6@0621401PPA00<0000000<02`lP0000000;3b000P0;3b02000000030=@m
6@0D6S`051Xl008051Xl00<0000001@J?03D?AT00`0D6S`3000000@07BQG00<0000001dXE`0M:5L0
1@0M:5L3000000D09CA_00@0e3dI02DdK`3D?AT0e3dI1@0U=6l00`0000009CA_02DdK`02000000<0
;3j200<0000002`nPP0/?X801@0/?X800`3D?AT0000002`nPP0602`nPP<000000P3D?AT20357TP03
0000000aAi80<DNB00@0<DNB00<0e3dI0000000mFJ/01P3oBQh00`000000odXN0?m:7P0203eIZ`<0
00001`3oB1d00`000000?EV[0?m87@060?m87@040000003oB1d0odPM0?m87@8000000P3hAA`00`00
0000n4DL0?Q570030?Q57080?EV[00<0n4DL03eIZ`3hAA`0103hAA`3000000L0jT0I00<000000>Y0
6@3Z@1T00P3Z@1T3000000<0e3TF00<0?EV[0=@i5P000000103D>AH00`0mFJ/000000;8^4@030;8^
4@040000002b;Q400000000000<0RR8=00<0?EV[0=@m6@3D?AT01`3om^h00`000000ooK^0?ofkP02
0?ofkP0303eIZ`3om^h0ooK^00`0ooK^0P0mFJ/20?ofkP0303eIZ`3om^h0ooK^00d0ooK^0P000003
0?ofkP<0?EV[403om^h00`0mFJ/0ooK^0?ofkP0^0?ofkP030000003om^h0ooK^01`0ooK^0@3oool0
01h0ooK^00<000000?ofkP3om^h0;P3om^h00`3D?AT0ooK^0?ofkP0@0?ofkP030=@m6@3om^h0ooK^
00<0ooK^00<000000?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP030?ofkP80e3dI303om^h00`3D
?AT0ooK^0?ofkP02000000L0ooK^0P0mFJ/01@000000e3dI00H84@062140000000802`lP00<00000
00/?800;3b000P0;3b000`00000051Xl01@J?0020=@m6@8051Xl00<000000=@m6@0D6S`00`0D6S`0
0`0000007BQG01dXE`0401dXE`030000000M:5L07BQG00D07BQG00<0000002DdK`0U=6l01@0U=6l0
103D?AT09CA_02DdK`0U=6l20=@m6@<09CA_0`00000602`nPP030000000/?X80;3j200<0;3j200<0
e3dI02`nPP0000001`0/?X800`000000<DNB0357TP020357TP80e3dI00<000000357TP0aAi800`0a
Ai801@3D?AT0<DNB0000003oBQh0?EV[00D0odXN00<0000003eIZ`0mFJ/0103oBQh00`000000odPM
0?m87@050?m87@030000000mFJ/0odPM00D0odPM00<000000?m87@3oB1d0103oB1d3000000<0n4DL
0P0mFJ/30?Q5700303eIZ`3hAA`0n4DL00D0n4DL00<000000>Y06@3Z@1T0103Z@1T00`000000jT0I
0>Y06@050>Y06@030000003D>AH0e3TF0080e3TF00@0?EV[0000003D>AH0e3TF0P0mFJ/20=@i5P03
0000002b;Q40/RhA0080/RhA00@000000;8^4@2b;Q4000000P2:8Pd0100mFJ/000000=@m6@3D?AT7
0?ofkP8000000P3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP80?EV[1@3om^h00`0mFJ/0ooK^0?ofkP0;
0?ofkP030000003om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h0403om^h00`0mFJ/0ooK^0?ofkP0^
0?ofkP030000003om^h0ooK^01`0ooK^0@3oool001h0ooK^00<000000?ofkP3om^h0;P3om^h00`3D
?AT0ooK^0?ofkP0@0?ofkP<0e3dI103om^h2000000/0ooK^00<0e3dI0?ofkP3om^h01@3om^h20=@m
6@T0ooK^00H0e3dI0?ofkP3om^h000000?ofkP3D?AT50?ofkP80?EV[00<0ooK^0000000mFJ/00P06
21401@0000002`lP00/?800;3b00000000802`lP0`00000401@J?080e3dI00@051Xl0=@m6@0D6S`0
51Xl0`00000701dXE`030000000M:5L07BQG00807BQG0`00000602DdK`030=@m6@0U=6l0000000@0
9CA_0P3D?AT00`0U=6l0000002`nPP0702`nPP030000000/?X80;3j200<0;3j200<0e3dI02`nPP00
00001@0/?X83000000H0<DNB00<0e3dI0357TP0aAi800`0aAi801@3D?AT0<DNB0000003oBQh0?EV[
00D0odXN00<0?EV[0?m:7P3oBQh0103oBQh3000000D0odPM00<000000?m87@0mFJ/01@3oB1d00`00
0000odPM0?m87@060?m87@040000003hAA`0?EV[03eIZ`@0n4DL00<000000?Q5700mFJ/01P3hAA`3
000000@0jT0I00<000000>Y06@3Z@1T01@3Z@1T00`000000e3dI000000020=@i5P0403eIZ`3D>AH0
?EV[03eIZ`@0e3TF0`0000020;8^4@050000002b;Q40/RhA0;8^4@0000000P2:8Pd20=@m6@030?of
kP3D?AT0e3dI00D0ooK^00<0?EV[0?ofkP0000000P3om^h00`0mFJ/0ooK^0?ofkP070?ofkP80?EV[
1`3om^h00`0mFJ/0ooK^0?ofkP090?ofkP800000103om^h303eIZa80ooK^00<0?EV[0?ofkP3om^h0
;P3om^h00`000000ooK^0?ofkP0L0?ofkP40oooo000N0?ofkP030000003om^h0ooK^02h0ooK^00<0
e3dI0?ofkP3om^h0403om^h00`3D?AT0ooK^0?ofkP020=@m6@@0ooK^0P0000090?ofkP030=@m6@3o
m^h0ooK^00L0ooK^0P3D?AT70?ofkP050=@m6@3om^h000000?ofkP3D?AT01@3om^h203eIZ`040?of
kP0mFJ/0?EV[00H84@8000000`0;3b00100000002`lP00/?8000000201@J?0030000000D6S`051Xl
00<051Xl00D000000=@m6@0D6S`051Xl0000000201dXE`030000000M:5L07BQG00D07BQG00D00000
01dXE`0M:5L07BQG0000000202DdK`030000000U=6l09CA_00<09CA_00@0e3dI02DdK`0U=6l00000
1@0U=6l00`000000e3dI0000000802`nPP030000000/?X80;3j20080;3j200@0e3dI02`nPP0/?X80
00000`0/?X8200000080<DNB00<000000357TP0aAi80100aAi800`000000e3dI0=@m6@030357TP05
0=@m6@0aAi8000000?m:7P0mFJ/00`3oBQh203eIZ`030000003oBQh0odXN00@0odXN00<000000?m:
7P3oBQh00P0000030?m87@030000003oB1d0?EV[00D0odPM00<000000?m87@3oB1d01P3oB1d00`00
0000?EV[000000050?Q570040000003hAA`0n4DL03eIZ`D0n4DL00@000000?Q5703hAA`000000`3Z
@1T00`000000jT0I0>Y06@050>Y06@040000003Z@1T0jT0I00000080e3TF00<0?EV[0000003D>AH0
103D>AH010000000e3TF0=@i5P0000020;8^4@040000002b;Q40/RhA0;8^4@80000000@0RR8=0=@m
6@3D?AT0ooK^0P3D?AT50?ofkP0503eIZ`3om^h000000?ofkP0mFJ/01`3om^h203eIZ`T0ooK^00<0
?EV[0?ofkP3om^h01`3om^h2000000@0ooK^0P0mFJ/20?ofkP0303eIZ`3om^h0ooK^0100ooK^00<0
?EV[0?ofkP3om^h0;P3om^h00`000000ooK^0?ofkP0L0?ofkP40oooo000M0?ofkP030000003om^h0
ooK^02l0ooK^0`3D?AT@0?ofkP030=@m6@3om^h0ooK^0080ooK^0P3D?AT40?ofkP8000001`3om^h0
0`3D?AT0ooK^0?ofkP090?ofkP80e3dI1@3om^h2000000030?ofkP3D?AT0ooK^00<0ooK^0`0mFJ/0
0`3om^h0?EV[000000020000000300/?800000002`lP00802`lP00<0000000/?800000000P0D6S`0
0`00000051Xl01@J?00401@J?0040=@m6@0D6S`0e3dI0=@m6@<07BQG00<0000001dXE`0M:5L01@0M
:5L0100000007BQG01dXE`00000402DdK`050000000U=6l09CA_02DdK`3D?AT00`0U=6l00`000000
9CA_02DdK`0202DdK`030000000/?X80;3j20080e3dI1`0/?X800`000000;3j202`nPP0202`nPP05
0=@m6@0/?X80;3j20000000/?X800P0000040357TP030000000aAi80<DNB00D0<DNB00<000000357
TP3D?AT00P3D?AT20357TP030000003oBQh0odXN00<0?EV[00<0odXN0000003oBQh01P3oBQh00`00
0000odXN0?m:7P020?m:7P80000000D0odPM0000003oB1d0odPM03eIZ`040?m87@030000003oB1d0
odPM00D0odPM0P0mFJ/20?m87@030000003hAA`0n4DL0080n4DL00D000000?Q5703hAA`0n4DL03eI
Z`030?Q570030000003hAA`0n4DL0080n4DL00@000000>Y06@3Z@1T000001`3Z@1T010000000jT0I
0>Y06@3Z@1T203eIZ`030=@i5P0mFJ/0e3TF00D0e3TF00H000000=@i5P3D>AH000000;8^4@000003
0;8^4@030000002b;Q4000000080000000<0e3dI0?ofkP3D?AT00P3D?AT40?ofkP0403eIZ`3om^h0
0000000000D0ooK^0P0mFJ/;0?ofkP0303eIZ`3om^h0ooK^00D0ooK^0P0000040?ofkP80?EV[103o
m^h00`0mFJ/0ooK^0?ofkP0>0?ofkP<0?EV[<@3om^h00`000000ooK^0?ofkP0K0?ofkP40oooo000M
0?ofkP030000003om^h0ooK^02l0ooK^00<0e3dI0?ofkP3om^h00P3D?AT>0?ofkP030=@m6@3om^h0
ooK^00@0ooK^0P3D?AT40?ofkP800000103om^h00`3D?AT0ooK^0?ofkP0<0?ofkP80e3dI0P3om^h0
10000000e3dI0?ofkP3D?AT40?ofkP0303eIZ`3om^h0?EV[0080?EV[0P00000200/?80040000000;
3b002`lP00/?80<000000`0D6S`00`00000051Xl01@J?00301@J?0050=@m6@00000000000000000M
:5L00P3D?AT00`0M:5L0000001dXE`0601dXE`<000001@0U=6l01@0000009CA_02DdK`0U=6l0e3dI
00<09CA_00<0000002DdK`0U=6l00P00000302`nPP040000000/?X80e3dI0=@m6@D0;3j200D00000
02`nPP0/?X80;3j20=@m6@0302`nPP8000001P0aAi800`000000<DNB0357TP050357TP050000000a
Ai80<DNB0357TP3D?AT00P0aAi8010000000odXN0?m:7P0mFJ/30?m:7P030000003oBQh0odXN00D0
odXN00<000000?m:7P3oBQh0103oBQh200000080odPM00<0?EV[0?m87@3oB1d00P3oB1d00`000000
odPM0?m87@030?m87@80?EV[00<0odPM0000003oB1d00P3oB1d200000080n4DL00D000000?Q5703h
AA`0n4DL03eIZ`030?Q570030000003hAA`0n4DL00<0n4DL0`0000070>Y06@050000003Z@1T0?EV[
03eIZ`3Z@1T00`0000000`0mFJ/0e3TF0=@i5P030=@i5P040000003D>AH0e3TF0=@i5P<000000`2b
;Q400`000000/RhA0;8^4@02000000<0e3dI00<0ooK^0=@m6@3om^h00`3om^h0100mFJ/0ooK^03eI
Z`0000020?ofkP80?EV[3P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP800000103om^h203eIZ`H0ooK^
00<0?EV[0?ofkP3om^h0303om^h203eIZ`80ooK^00<0?EV[0?ofkP3om^h0;`3om^h00`000000ooK^
0?ofkP0K0?ofkP40oooo000M0?ofkP030000003om^h0ooK^02l0ooK^00<0e3dI0?ofkP3om^h00P3o
m^h20=@m6@`0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP030?ofkP8000000P3o
m^h00`3D?AT0ooK^0?ofkP0>0?ofkP80000000@0e3dI0?ofkP3D?AT0ooK^0P3D?AT00`3om^h0?EV[
0?ofkP0303eIZ`030000000;3b002`lP00802`lP00D0000000/?800;3b002`lP0000000501@J?003
0000000D6S`051Xl008051Xl00<0e3dI01@J?00000001@0M:5L20=@m6@L07BQG00<0000002DdK`0U
=6l01@0U=6l0100000009CA_02DdK`3D?AT402DdK`<000001P0/?X8010000000;3j202`nPP3D?AT4
02`nPP060000000/?X80;3j202`nPP3D?AT0;3j20`0000070357TP030000000aAi80<DNB00D0<DNB
00D000000357TP0aAi80e3dI0357TP020=@m6@050000000mFJ/0?EV[0?m:7P0mFJ/00P3oBQh00`00
0000odXN0?m:7P050?m:7P030000003oBQh0odXN00D0odXN0`0000000`3oB1d0?EV[0?m87@020?m8
7@030000003oB1d0odPM0080odPM00@0?EV[0?m87@3oB1d000001P3oB1d3000000@0n4DL00@0?EV[
0?Q5703hAA`000001`3hAA`00`000000jT0I0>Y06@050>Y06@80?EV[1@3Z@1T00`000000e3TF03eI
Z`040=@i5P030000003D>AH0e3TF00<0e3TF00D000000;8^4@2b;Q40/RhA000000040;8^4@070000
003D?AT0e3dI0=@m6@3om^h0e3dI0?ofkP0203eIZ`040?ofkP0mFJ/0ooK^03eIZ`800000403om^h0
0`0mFJ/0ooK^0?ofkP02000000D0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP0:
0?ofkP80?EV[103om^h00`0mFJ/0ooK^0?ofkP0_0?ofkP030000003om^h0ooK^01/0ooK^0@3oool0
01d0ooK^00<000000?ofkP3om^h0;`3om^h00`3D?AT0ooK^0?ofkP040?ofkP80e3dI2P3om^h00`3D
?AT0ooK^0?ofkP070?ofkP80e3dI1@3om^h00`000000ooK^0=@m6@0?0?ofkP030000003om^h0ooK^
0080e3dI0`3om^h00`0mFJ/0e3dI0=@m6@0203eIZ`030?ofkP0000002`lP00<02`lP00<0000000/?
800;3b000`00000501@J?0050000000D6S`051Xl01@J?03D?AT00`00000601dXE`030000003D?AT0
7BQG00<07BQG0`00000702DdK`030000000U=6l0e3dI00D09CA_00<0000002`nPP0/?X801P0/?X80
10000000;3j202`nPP0/?X820=@m6@<0;3j200D0000002`nPP3D?AT0;3j2000000020357TP030000
000aAi80<DNB00D0<DNB00<000000357TP0aAi801@0aAi801@000000<DNB0357TP3D?AT0<DNB00D0
000000D0odXN03eIZ`3oBQh0odXN000000070?m:7P030000003oBQh0odXN00D0odXN00D000000?m:
7P3oBQh0000003eIZ`020?m87@040000003oB1d0odPM0?m87@80?EV[0`3oB1d00`000000odPM0?m8
7@060?m87@030000003hAA`0n4DL00<0n4DL00<0?EV[0?Q5700000001`3hAA`3000000@0jT0I00<0
?EV[0000003Z@1T01@3Z@1T30000000503eIZ`3D>AH0e3TF0=@i5P0000001@3D>AH300000080/RhA
00D000000;8^4@2b;Q40/RhA000000020?ofkP80e3dI0P0mFJ/0103D?AT0ooK^0?ofkP3om^h203eI
Z`80ooK^00<000000?ofkP3om^h03@3om^h00`0mFJ/0ooK^000000050?ofkP80?EV[2@3om^h00`0m
FJ/0ooK^0?ofkP080?ofkP80?EV[1P3om^h00`0mFJ/0ooK^0?ofkP0_0?ofkP030000003om^h0ooK^
01/0ooK^0@3oool001d0ooK^00<000000?ofkP3om^h0;`3om^h00`3D?AT0ooK^0?ofkP060?ofkP80
e3dI203om^h00`3D?AT0ooK^0?ofkP090?ofkP80e3dI103om^h00`000000e3dI0?ofkP0<0?ofkP80
00000`3om^h30=@m6@030?ofkP0mFJ/0?EV[0080?EV[0P3D?AT00`3om^h0000000/?800300/?8003
0000000;3b000000008051Xl00<0000001@J?00D6S`00`0D6S`01@00000051Xl01@J?03D?AT00000
00807BQG00<0000001dXE`0M:5L0100M:5L01P0000007BQG0=@m6@3D?AT07BQG000000809CA_00<0
000002DdK`0U=6l01@0U=6l00`000000e3dI02DdK`0302DdK`<00000200/?X800`000000;3j202`n
PP0302`nPP80e3dI00D0;3j20000000/?X80e3dI000000030357TP030000000aAi80<DNB00D0<DNB
00<000000357TP0aAi801@0aAi801@000000<DNB0=@m6@0aAi8000000080=TjP00P000000?m<7`3o
C1l000000?m:7P0mFJ/0odXN000000H0odXN00<000000?m:7P3oBQh01P3oBQh02@000000odXN0?m:
7P3oBQh0000003eIZ`3oB1d000000?m87@0203eIZ`D0odPM00<000000?m87@3oB1d01P3oB1d30000
00@0n4DL00<0?EV[0000003hAA`01P3hAA`01@000000n4DL0?Q570000000jT0I0080?EV[00<0jT0I
0000003Z@1T01@3Z@1T01@000000jT0I0>Y06@000000?EV[0080e3TF00<000000=@i5P3D>AH00`3D
>AH01P000000e3TF0=@i5P000000/RhA000000@0/RhA00@000000?ofkP0mFJ/0?EV[103D?AT0103o
m^h0?EV[03eIZ`0mFJ/30?ofkP8000003@3om^h00`0mFJ/000000?ofkP030?ofkP80?EV[2`3om^h0
0`0mFJ/0ooK^0?ofkP060?ofkP80?EV[203om^h00`0mFJ/0ooK^0?ofkP0_0?ofkP030000003om^h0
ooK^01/0ooK^0@3oool001`0ooK^00<000000?ofkP3om^h0<@3om^h00`3D?AT0ooK^0?ofkP070?of
kP80e3dI1P3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP80e3dI0P3om^h0103D?AT0ooK^00000000000:
0?ofkP030000003om^h0ooK^0080ooK^0P3D?AT0103om^h0?EV[0=@m6@3D?AT203eIZ`<0ooK^0P3D
?AT300/?80030000000;3b000000008051Xl00<0000001@J?00D6S`00`0D6S`01@00000051Xl01@J
?03D?AT0000000<07BQG00<0000001dXE`0M:5L0100M:5L0100000007BQG01dXE`0000020=@m6@<0
9CA_00<0000002DdK`0U=6l0100U=6l00`000000e3dI02DdK`0202DdK`040000000/?X80;3j20000
00P0;3j200<0000002`nPP0/?X801@0/?X830=@m6@030000000aAi80<DNB00<0<DNB00<000000357
TP0aAi801@0aAi800`000000<DNB0357TP040357TP040000000aAi80e3dI000000<0=TjP00P00000
0?m<7`3oC1l0od`O0000000mFJ/0odXN000000H0odXN00<000000?m:7P3oBQh01@3oBQh00`000000
odXN0?m:7P030?m:7P0403eIZ`000000?EV[03eIZ`L0odPM00<000000?m87@3oB1d01@3oB1d01@00
0000odPM0?m87@3oB1d0000000<0n4DL00<0?EV[0000003hAA`01@3hAA`010000000n4DL0?Q5703h
AA`203eIZ`040000003Z@1T0jT0I000000H0jT0I00H000000>Y06@3Z@1T0jT0I0000000mFJ/20=@i
5P030000003D>AH0e3TF00<0e3TF00H000000=@i5P3D>AH000000;8^4@0000030;8^4@80?EV[0P3o
m^h30=@m6@80?EV[00@0e3dI0?ofkP0mFJ/0?EV[103om^h00`000000ooK^0?ofkP080?ofkP800000
00@0ooK^03eIZ`3om^h0ooK^0P0mFJ/=0?ofkP0303eIZ`3om^h0ooK^00@0ooK^0P0mFJ/90?ofkP03
03eIZ`3om^h0ooK^0340ooK^00<000000?ofkP3om^h06P3om^h10?ooo`00703om^h00`000000ooK^
0?ofkP0a0?ofkP030=@m6@3om^h0ooK^00T0ooK^0P3D?AT40?ofkP030=@m6@3om^h0ooK^00d0ooK^
0`3D?AT30?ofkP8000001`3om^h00`000000ooK^0?ofkP020?ofkP030=@m6@3om^h0e3dI0080?EV[
00@0ooK^03eIZ`3D?AT0e3dI0`3om^h00`0000002`lP0=@m6@0200/?808000000`0D6S`00`000000
51Xl01@J?00301@J?0<0000000<0e3dI01dXE`0M:5L00P0M:5L00`0000007BQG01dXE`0401dXE`<0
00000`0U=6l0103D?AT09CA_02DdK`00000602DdK`050=@m6@0000009CA_02DdK`000000100/?X80
0`000000;3j202`nPP0502`nPP030000000/?X80;3j200H0;3j200<000000=@m6@0aAi801@0aAi80
0`000000<DNB0357TP050357TP030000000aAi80<DNB00@0<DNB00<000000=@m6@000000100fCZ00
0`000000od`O0?m<7`020?m<7`030000000mFJ/0000000H0odXN00<000000?m:7P3oBQh01@3oBQh0
0`000000odXN0?m:7P040?m:7P0303eIZ`000000odPM00L0odPM00<000000?m87@3oB1d01@3oB1d0
0`000000odPM0?m87@020?m87@050000003hAA`0n4DL0000000mFJ/01P3hAA`010000000n4DL0?Q5
700mFJ/30?Q570<000001P3Z@1T00`000000jT0I0>Y06@020>Y06@0403eIZ`0000000000000000D0
e3TF00@000000=@i5P3D>AH0e3TF0P0000020;8^4@0303eIZ`2b;Q40000000<0ooK^0P0mFJ/01`3D
?AT0ooK^0=@m6@3D?AT0?EV[0?ofkP0mFJ/0103om^h00`000000ooK^0?ofkP050?ofkP8000000`3o
m^h303eIZ`l0ooK^00<0?EV[0?ofkP3om^h00P3om^h203eIZ`/0ooK^00<0?EV[0?ofkP3om^h0<@3o
m^h00`000000ooK^0?ofkP0J0?ofkP40oooo000L0?ofkP030000003om^h0ooK^0340ooK^00<0e3dI
0?ofkP3om^h02`3om^h20=@m6@80ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP03
0?ofkP8000000`3om^h2000000<0ooK^0P3D?AT0103om^h0e3dI03eIZ`3om^h203eIZ`030?ofkP0m
FJ/0ooK^0080e3dI00@0000000/?800;3b002`lP0P3D?AT501@J?0030000000D6S`051Xl00<051Xl
00<0000001dXE`3D?AT01@0M:5L00`0000007BQG01dXE`0401dXE`030000000U=6l09CA_00@09CA_
0P3D?AT00`0000009CA_02DdK`0302DdK`030=@m6@0U=6l00000008000001@0/?X800`000000;3j2
02`nPP0502`nPP030000000/?X80;3j200@0;3j20P000000103D?AT0<DNB0=@m6@3D?AT40357TP03
0000000aAi80<DNB00D0<DNB00<000000357TP0aAi80100aAi800`000000e3dI03I>X00403I>X003
0000003oC1l0od`O00<0od`O00<0?EV[0000003oBQh01@3oBQh00`000000odXN0?m:7P050?m:7P03
0000003oBQh0odXN0080odXN0P0mFJ/0103oBQh0?EV[0000000000060?m87@030000003oB1d0odPM
00D0odPM00<000000?m87@3oB1d00`3oB1d2000000030=@m6@3hAA`0?EV[00D0n4DL00<0000003eI
Z`0mFJ/01P3hAA`00`000000jT0I0>Y06@040>Y06@030000003Z@1T0jT0I00<0jT0I00<0?EV[0>Y0
6@0000001@3D>AH00`000000e3TF0=@i5P030=@i5P80?EV[0P2b;Q401@000000ooK^03eIZ`0mFJ/0
e3dI0080ooK^0P3D?AT0103om^h0e3dI03eIZ`3om^h203eIZ`<0ooK^0P0000030?ofkP8000001@3o
m^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^0080?EV[3@3om^h00`0mFJ/0ooK^0?of
kP0a0?ofkP030000003om^h0ooK^01X0ooK^0@3oool001`0ooK^00<000000?ofkP3om^h0<@3om^h0
0`3D?AT0ooK^0?ofkP0=0?ofkP<0e3dI4@3om^h30=@m6@D0ooK^0`0000040?ofkP060=@m6@3om^h0
ooK^03eIZ`3D?AT0ooK^0P0mFJ/20?ofkP0503eIZ`3om^h0ooK^03eIZ`3D?AT00P0;3b0300000080
e3dI0`0D6S`01000000051Xl01@J?00D6S`3000000030=@m6@0M:5L07BQG00@07BQG00<0000001dX
E`0M:5L00P0M:5L3000000P09CA_0P3D?AT302DdK`040=@m6@0U=6l09CA_000000L0;3j200<00000
02`nPP0/?X801P0/?X800`000000;3j202`nPP0202`nPP040000000aAi80<DNB0=@m6@<0<DNB0P3D
?AT20357TP030000000aAi80<DNB00D0<DNB00<000000357TP0aAi800P0aAi82000000030=@m6@0f
CZ00=TjP00@0=TjP00<000000?m<7`3oC1l0103oC1l00`0mFJ/00000000000040?m:7P030000003o
BQh0odXN00D0odXN00<000000?m:7P3oBQh00P0mFJ/30?m:7P0403eIZ`3oBQh0odXN000000@0odPM
00<000000?m87@3oB1d01P3oB1d00`000000odPM0?m87@040?m87@050=@m6@000000n4DL0?Q5700m
FJ/00`3hAA`203eIZ`P0n4DL0`0000040>Y06@030000003Z@1T0jT0I00@0jT0I00@0?EV[00000000
000000000`3D>AH010000000e3TF0=@i5P3D>AH203eIZ`<000000P2b;Q401@0mFJ/0e3dI0?ofkP3o
m^h0e3dI0080ooK^0P3D?AT00`3om^h0?EV[0=@m6@020?ofkP0303eIZ`3om^h0ooK^0080ooK^0`00
00050?ofkP<0?EV[4@3om^h303eIZ`l0ooK^00<0?EV[0?ofkP3om^h0<@3om^h00`000000ooK^0?of
kP0J0?ofkP40oooo000K0?ofkP030000003om^h0ooK^0380ooK^00<0e3dI0?ofkP3om^h03`3om^h0
0`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^0080e3dI0`3om^h3000000<0ooK^00<0e3dI
0?ofkP3om^h00P0mFJ/00`3D?AT0?EV[0?ofkP020?ofkP@0?EV[00@0000003eIZ`0;3b0000000P0D
6S`00`00000051Xl01@J?0020=@m6@0501@J?000000051Xl01@J?00000000P0M:5L00`3D?AT07BQG
01dXE`0501dXE`050000000M:5L07BQG01dXE`0000000P0U=6l00`0000009CA_02DdK`0602DdK`06
0000000U=6l0e3dI0=@m6@0U=6l0e3dI0`00000702`nPP030000000/?X80;3j200H0;3j200<00000
02`nPP0/?X800P0000020357TP030=@m6@000000<DNB00@0<DNB0P3D?AT00`000000<DNB0357TP05
0357TP030000000aAi80<DNB008000000P0fCZ000`3D?AT0=TjP03I>X00403I>X0030000003oC1l0
od`O00@0od`O00<0?EV[0?m<7`3oC1l00P0000020?m:7P030000003oBQh0odXN00D0odXN00<00000
03eIZ`0mFJ/01@3oBQh010000000?EV[0?m:7P3oBQh200000080odPM00<000000?m87@3oB1d01@3o
B1d00`000000odPM0?m87@060?m87@<0000000H0?EV[0?Q5700mFJ/0?EV[0?Q5700000080?Q57004
0000003hAA`0n4DL000000<0jT0I00<000000>Y06@3Z@1T01@3Z@1T0100mFJ/0jT0I0>Y06@000002
0=@i5P040000003D>AH0?EV[03eIZ`80e3TF00D000000=@i5P3D>AH000000;8^4@050=@m6@@0ooK^
00@0e3dI03eIZ`3D?AT0e3dI0P3om^h0100mFJ/0ooK^0?ofkP3om^h3000000<0ooK^0P0mFJ/20?of
kP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP0a0?of
kP030000003om^h0ooK^01X0ooK^0@3oool001/0ooK^00<000000?ofkP3om^h0<P3om^h00`3D?AT0
ooK^0?ofkP0?0?ofkP<0e3dI3`3om^h00`3D?AT0ooK^0?ofkP020?ofkP80e3dI00@000000?ofkP3o
m^h0ooK^0P0000000`3D?AT0ooK^0?ofkP0303eIZ`030=@m6@0mFJ/0?EV[00L0?EV[00D02`lP0000
000D6S`051Xl0000000501@J?080e3dI00H051Xl0000000M:5L07BQG0=@m6@00000701dXE`040000
000M:5L07BQG000000@09CA_00<0000002DdK`0U=6l01@0U=6l01P0000009CA_02DdK`0U=6l0e3dI
00000080;3j200<0000002`nPP0/?X801P0/?X800`000000;3j202`nPP0502`nPP<000000`0aAi80
103D?AT0<DNB0357TP0000060357TP80e3dI1P0aAi83000000<0=TjP00<0e3dI0000000fCZ001@0f
CZ000`000000od`O0?m<7`040?m<7`030000000mFJ/0od`O0080od`O0`0000060?m:7P80?EV[1P3o
BQh010000000odXN0?m:7P0mFJ/30?m:7P<000001`3oB1d00`000000odPM0?m87@050?m87@060000
003oB1d0odPM0?m87@000000?EV[0`3hAA`00`000000n4DL0?Q570050?Q570030000003hAA`0n4DL
0080n4DL00@000000>Y06@3Z@1T000001`3Z@1T01P000000?EV[0>Y06@3Z@1T000000=@i5P80?EV[
1@3D>AH01@000000e3TF0=@i5P000000/RhA00T0e3dI00@0?EV[0=@m6@3D?AT0e3dI0P3om^h00`0m
FJ/00000000000030?ofkP030000000mFJ/0?EV[00@0ooK^00<0?EV[0?ofkP3om^h03@3om^h303eI
Za40ooK^00<0?EV[0?ofkP3om^h0<P3om^h00`000000ooK^0?ofkP0I0?ofkP40oooo000K0?ofkP03
0000003om^h0ooK^0380ooK^0`3D?AT?0?ofkP030=@m6@3om^h0ooK^0080e3dI3@3om^h00`3D?AT0
ooK^0?ofkP020?ofkP8000000P3D?AT30?ofkP030=@m6@000000?EV[00@0?EV[00@0e3dI0?ofkP3o
m^h0ooK^0P0mFJ/00`3om^h0?EV[00000002000000<051Xl00<0000001@J?00D6S`00`0D6S`20000
0080e3dI00@07BQG0=@m6@0M:5L000001`0M:5L3000000D09CA_00<0000002DdK`0U=6l01P0U=6l0
100000009CA_0=@m6@0000020=@m6@80;3j200<0000002`nPP0/?X801@0/?X800`000000;3j202`n
PP0502`nPP030000000aAi80<DNB0080<DNB00D0e3dI0357TP0aAi80<DNB000000060357TP030000
000aAi80e3dI00D0<DNB00<0000003I>X00fCZ000`0fCZ000`3D?AT0000003I>X00503I>X0030000
003oC1l0od`O00@0od`O00<0000003eIZ`3oC1l0103oC1l00`000000odXN0?m:7P030?m:7P0303eI
Z`3oBQh0000000H0odXN00D000000?m:7P3oBQh0odXN03eIZ`040?m:7P030000003oB1d0odPM00D0
odPM00<000000?m87@3oB1d01@3oB1d00`000000odPM0?m87@0203eIZ`040000000mFJ/0n4DL0000
00P0n4DL00<000000?Q5703hAA`00`3hAA`3000000L0jT0I00@000000>Y06@0mFJ/0jT0I0P0mFJ/2
000000D0e3TF00@000000=@i5P3D>AH0e3TF0P000000103om^h0e3dI0?ofkP3D?AT40?ofkP0303eI
Z`3D?AT0e3dI00<0e3dI00<0000003eIZ`3om^h00P3om^h203eIZ`800000103om^h00`0mFJ/0ooK^
0?ofkP0;0?ofkP80?EV[0P3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP<0?EV[=03om^h00`000000ooK^
0?ofkP0I0?ofkP40oooo000K0?ofkP030000003om^h0ooK^03<0ooK^00@0e3dI0?ofkP3D?AT0e3dI
3@3om^h00`3D?AT0ooK^0?ofkP020?ofkP80e3dI2`3om^h01@3D?AT0ooK^0?ofkP3om^h0000000@0
ooK^0`3D?AT00`3om^h0?EV[0?ofkP0203eIZ`80ooK^00<0e3dI0?ofkP3om^h00P0mFJ/0103om^h0
?EV[0?ofkP00000501@J?0030000000D6S`051Xl00<051Xl00D0000003eIZ`0M:5L07BQG0=@m6@02
01dXE`030000000M:5L07BQG00D07BQG00<0000002DdK`0U=6l01@0U=6l00`0000009CA_02DdK`06
02DdK`030000003D?AT0000000<0;3j20P3D?AT00`000000;3j202`nPP0502`nPP030000000/?X80
;3j200<0;3j20`0000040357TP050=@m6@0aAi80<DNB0357TP0000001`0aAi801@000000<DNB0=@m
6@3D?AT0<DNB00<00000100fCZ000`3D?AT0=TjP0000000603I>X0030000003oC1l0od`O00@0od`O
00<000000?m<7`0mFJ/0103oC1l3000000050?m:7P0mFJ/0?EV[0?m:7P0000001`3oBQh01@000000
odXN0?m:7P3oBQh0?EV[00@0odXN0`0000050?m87@030000003oB1d0odPM00D0odPM00<0000003eI
Z`0mFJ/00`3oB1d00`000000?EV[000000080?Q570030000003hAA`0n4DL00D0n4DL00<000000>Y0
6@3Z@1T0103Z@1T01@000000jT0I0>Y06@3Z@1T0?EV[00<0jT0I00<000000=@i5P3D>AH00`3D>AH0
0`000000e3TF0=@i5P030=@i5P040000003om^h0e3dI0?ofkP80e3dI0P3om^h00`0mFJ/0ooK^0?of
kP020=@m6@030?ofkP3D?AT0ooK^00<0?EV[103om^h01@000000ooK^0?ofkP3om^h0?EV[00/0ooK^
0P0mFJ/40?ofkP0303eIZ`3om^h0ooK^00/0ooK^0P0mFJ/00`3om^h0?EV[0?ofkP0d0?ofkP030000
003om^h0ooK^01T0ooK^0@3oool001/0ooK^00<000000?ofkP3om^h0<`3om^h0103D?AT0ooK^0?of
kP3om^h20=@m6@/0ooK^00<0e3dI0?ofkP3om^h0103om^h20=@m6@T0ooK^00@0e3dI0?ofkP3om^h0
00001@3om^h50=@m6@0503eIZ`3om^h0ooK^0000003D?AT00P3om^h403eIZ`80ooK^00<0000001@J
?00D6S`00`0D6S`01000000051Xl01@J?00D6S`3000000807BQG00H0e3dI01dXE`3D?AT0e3dI01dX
E`00000401dXE`<000001`0U=6l00`0000009CA_02DdK`0602DdK`030=@m6@0/?X80;3j200D0;3j2
0P3D?AT602`nPP040000000/?X80;3j202`nPP8000000`0aAi8010000000<DNB0357TP3D?AT40357
TP030000000aAi80<DNB00D0<DNB00@000000357TP0aAi8000000P3D?AT00`0fCZ00000003I>X003
03I>X0030=@m6@0fCZ00000000H0=TjP00<000000?m<7`3oC1l0103oC1l00`000000od`O03eIZ`04
0?m<7`050000003oC1l0?EV[03eIZ`0000000P3oBQh00`000000odXN0?m:7P050?m:7P030000003o
BQh0odXN0080odXN00@0?EV[0?m:7P3oBQh000000`3oBQh200000080odPM00<000000?m87@3oB1d0
1@3oB1d203eIZ`L0odPM00<0?EV[0?Q5703hAA`01P3hAA`00`000000n4DL0?Q570050?Q570<00000
103Z@1T01P000000jT0I03eIZ`0mFJ/0jT0I03eIZ`80jT0I0`0000030=@i5P030000003D>AH0e3TF
00<0e3TF00<000000?ofkP3om^h00P3D?AT01P3om^h0e3dI0?ofkP3om^h0?EV[00000080ooK^00<0
e3dI03eIZ`0mFJ/00`0mFJ/50?ofkP040000003om^h0ooK^03eIZ`T0ooK^0P0mFJ/60?ofkP0303eI
Z`3om^h0ooK^00T0ooK^0P0mFJ/30?ofkP0303eIZ`3om^h0ooK^03<0ooK^00<000000?ofkP3om^h0
6@3om^h10?ooo`006P3om^h00`000000ooK^0?ofkP0d0?ofkP030=@m6@3om^h0ooK^00<0ooK^0P3D
?AT90?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT000000000
00050?ofkP030=@m6@3om^h0?EV[0080?EV[0`3D?AT20?ofkP050=@m6@0mFJ/0?EV[0?ofkP0mFJ/0
103om^h00`00000051Xl01@J?00201@J?0030000000D6S`051Xl008000000P0M:5L00`0000007BQG
0=@m6@0401dXE`80e3dI0`0M:5L0100000009CA_02DdK`00000702DdK`030000000U=6l09CA_00@0
9CA_0P0000000`3D?AT0;3j202`nPP0502`nPP030000000/?X80e3dI00H0;3j20`0000050357TP03
0000000aAi80e3dI00D0<DNB00<000000357TP0aAi801@0aAi83000000<0=TjP0P3D?AT303I>X004
0=@m6@0fCZ00=TjP000000H0=TjP00<000000?m<7`3oC1l0103oC1l010000000od`O0?m<7`0mFJ/3
0?m<7`80?EV[0`3oC1l3000000L0odXN00<000000?m:7P3oBQh00`3oBQh00`0mFJ/0odXN00000005
0?m:7P<000001P3oB1d00`0mFJ/000000?m87@070?m87@0303eIZ`000000000000H0n4DL00<00000
0?Q5703hAA`01@3hAA`010000000n4DL0?Q5700000030>Y06@80?EV[103Z@1T00`0mFJ/0jT0I0000
00020>Y06@8000000P3D>AH00`000000e3TF0=@i5P020=@i5P030000003om^h0ooK^0080ooK^00D0
e3dI0?ofkP3D?AT0e3dI03eIZ`020?ofkP<0?EV[0`3D?AT00`3om^h0?EV[0?ofkP040?ofkP800000
00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00L0ooK^
0P0mFJ/40?ofkP0303eIZ`3om^h0ooK^03D0ooK^00<000000?ofkP3om^h0603om^h10?ooo`006P3o
m^h00`000000ooK^0?ofkP0e0?ofkP030=@m6@3om^h0ooK^00@0ooK^0P3D?AT80?ofkP030=@m6@3o
m^h0ooK^00H0ooK^0P3D?AT60?ofkP030000003om^h0ooK^00<0ooK^0P3D?AT00`3om^h0?EV[03eI
Z`0303eIZ`030?ofkP3D?AT0e3dI0080e3dI00@0ooK^03eIZ`0mFJ/0?EV[0`3om^h00`00000051Xl
01@J?00301@J?0<00000100M:5L00`000000e3dI01dXE`0501dXE`040000003D?AT0e3dI000000@0
9CA_00<0000002DdK`0U=6l0100U=6l00`0000009CA_02DdK`0302DdK`050000000/?X80e3dI02`n
PP0000001`0/?X8010000000;3j20=@m6@3D?AT402`nPP030000000aAi80<DNB00D0<DNB00<00000
0=@m6@0aAi801@0aAi800`000000<DNB0357TP050357TP030000000fCZ00=TjP00D0=TjP0P3D?AT0
0`0fCZ00e3dI03I>X00203I>X0030000000fCZ00=TjP00<0=TjP00<000000?m<7`3oC1l00`3oC1l0
1P000000od`O0?m<7`3oC1l0?EV[0?m<7`80?EV[1`3oC1l00`000000odXN0?m:7P050?m:7P030000
003oBQh0odXN00@0odXN00<0?EV[0000003oBQh01P3oBQh00`000000odPM0?m87@020?m87@80?EV[
00<0odPM0000003oB1d01P3oB1d01@000000odPM03eIZ`3oB1d0000000D0n4DL00<000000?Q5703h
AA`0103hAA`00`000000n4DL0?Q570020?Q570040000000mFJ/0?EV[000000H0jT0I00<0?EV[0000
003Z@1T00`3Z@1T3000000D0e3TF00@000000?ofkP3om^h0ooK^0`3D?AT00`3om^h0?EV[03eIZ`02
03eIZ`030?ofkP3D?AT0e3dI00<0e3dI00<0ooK^03eIZ`0mFJ/01@3om^h00`000000ooK^0?ofkP04
0?ofkP80?EV[203om^h00`0mFJ/0ooK^0?ofkP060?ofkP80?EV[1P3om^h00`0mFJ/0ooK^0?ofkP0e
0?ofkP030000003om^h0ooK^01P0ooK^0@3oool001X0ooK^00<000000?ofkP3om^h0=@3om^h00`3D
?AT0ooK^0?ofkP060?ofkP80e3dI1P3om^h00`3D?AT0ooK^0?ofkP080?ofkP80e3dI0P3om^h20000
00030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP0mFJ/00`0mFJ/00`3om^h0?EV[0?ofkP020?of
kP0403eIZ`3D?AT0e3dI0=@m6@80ooK^00D0?EV[0000003om^h0ooK^0000000501@J?0030000000M
:5L07BQG00@07BQG00<0e3dI01dXE`0M:5L01@0M:5L300000080e3dI0`0U=6l00`0000009CA_02Dd
K`0502DdK`030000000U=6l09CA_0080000000D0;3j20=@m6@0/?X80;3j20000000702`nPP040000
000/?X80;3j202`nPP80e3dI0`0000080357TP030=@m6@0aAi80<DNB00D0<DNB00<000000357TP0a
Ai800P0aAi83000000L0=TjP00<0000003I>X03D?AT0100fCZ000`000000=TjP03I>X00303I>X003
0000003oC1l0od`O00<0od`O00<000000?m<7`3oC1l00P3oC1l00`0mFJ/0od`O000000070?m<7`<0
0000103oBQh00`000000odXN0?m:7P050?m:7P0303eIZ`3oBQh0odXN00H0odXN0`00000203eIZ`<0
odPM00<000000?m87@3oB1d01@3oB1d01@000000odPM0?m87@0mFJ/0odPM008000000P3hAA`00`00
0000n4DL0?Q570050?Q570040000003hAA`0n4DL0?Q57080?EV[0`0000070>Y06@0303eIZ`3Z@1T0
jT0I00@0jT0I00<000000=@i5P3D>AH00`3D>AH01@000000ooK^0?ofkP000000e3dI0080ooK^0`0m
FJ/0103D?AT0ooK^0?ofkP3D?AT20?ofkP@0e3dI00<0ooK^03eIZ`3om^h00`3om^h00`0mFJ/00000
000000020?ofkP80?EV[2P3om^h00`0mFJ/0ooK^0?ofkP040?ofkP80?EV[203om^h00`0mFJ/0ooK^
0?ofkP0e0?ofkP030000003om^h0ooK^01P0ooK^0@3oool001X0ooK^00<000000?ofkP3om^h0=P3o
m^h00`3D?AT0ooK^0?ofkP070?ofkP80e3dI103om^h00`3D?AT0ooK^0?ofkP0:0?ofkP050=@m6@00
0000ooK^0?ofkP3D?AT00P3om^h20=@m6@D0?EV[0P3om^h603eIZ`<0e3dI00<0?EV[0?ofkP3om^h0
0`00000301@J?0<000001@0M:5L00`3D?AT0000001dXE`0601dXE`030000000U=6l09CA_00809CA_
00@0e3dI02DdK`0U=6l000001`0U=6l300000080;3j200D0e3dI02`nPP0/?X80;3j20000000702`n
PP030000000/?X80;3j20080;3j200D000000=@m6@0aAi80<DNB000000060357TP030=@m6@000000
<DNB00H0<DNB00<000000357TP0aAi800P00000203I>X0030000000fCZ00=TjP00D0=TjP00<00000
0=@m6@0fCZ000P3D?AT203I>X0030000000fCZ00=TjP00<0=TjP00<000000?m<7`3oC1l00`3oC1l0
0`000000od`O0?m<7`0203eIZ`030?m<7`0mFJ/0000000L0od`O00<000000?m<7`3oC1l00P000002
0?m:7P030000003oBQh0odXN00D0odXN00<0000003eIZ`3oBQh01@3oBQh01@000000odXN0?m:7P0m
FJ/0000000@0odPM00<000000?m87@3oB1d01@3oB1d01@000000odPM0?m87@3oB1d0?EV[0080odPM
0P0000000`3D?AT0n4DL0?Q570050?Q570040000003hAA`0n4DL03eIZ`@0n4DL00<000000>Y06@3Z
@1T01@3Z@1T00`000000?EV[0>Y06@040>Y06@<000000`3D>AH3000000030?ofkP3D?AT0ooK^00<0
?EV[1P3D?AT20?ofkPD0e3dI0P0mFJ/20?ofkP0503eIZ`3om^h0ooK^0000000mFJ/0303om^h00`0m
FJ/0ooK^0?ofkP020?ofkP80?EV[2@3om^h00`0mFJ/0ooK^0?ofkP0f0?ofkP030000003om^h0ooK^
01P0ooK^0@3oool001X0ooK^00<000000?ofkP3om^h0=P3om^h00`3D?AT0ooK^0?ofkP090?ofkP80
e3dI0P3om^h00`3D?AT0ooK^0?ofkP090?ofkP80000000T0ooK^0=@m6@3D?AT0e3dI0?ofkP3D?AT0
ooK^03eIZ`3om^h01`0mFJ/30?ofkP0503eIZ`3om^h0e3dI0?ofkP0mFJ/00P3D?AT303eIZ`040000
000D6S`051Xl000000807BQG00@0000001dXE`0M:5L07BQG0P3D?AT00`0M:5L0000001dXE`0401dX
E`<000001@0U=6l20=@m6@030000000U=6l09CA_00D09CA_00D0000002`nPP0/?X80;3j20=@m6@04
02`nPP030000000/?X80;3j200D0;3j200D0000002`nPP0/?X80;3j2000000020357TP80e3dI00<0
00000357TP0aAi800`0aAi800`3D?AT0<DNB000000070357TP<000001@0fCZ000`000000=TjP03I>
X00403I>X0030000003D?AT0=TjP0080=TjP00<0e3dI03I>X00000001@0fCZ000`000000od`O0?m<
7`030?m<7`030000003oC1l0?EV[00<0od`O00<0?EV[0000003oC1l01@3oC1l00`000000od`O0?m<
7`030?m<7`<000001`3oBQh00`000000odXN03eIZ`050?m:7P030000000mFJ/0?EV[0080odXN00@0
00000?m87@3oB1d00000203oB1d00`000000odPM0?m87@020?m87@0503eIZ`3oB1d0odPM0?m87@00
00001`3hAA`00`000000?EV[03eIZ`050?Q570<000001@3Z@1T010000000jT0I03eIZ`0mFJ/30>Y0
6@040000003Z@1T0jT0I00000080e3TF00@000000=@m6@3D?AT0e3dI0P0mFJ/01@3D?AT0ooK^03eI
Z`3om^h0e3dI00<0ooK^1`3D?AT01@3om^h0e3dI0?ofkP0mFJ/0ooK^00<0?EV[00<0ooK^00000000
00002`3om^h00`0mFJ/0ooK^0?ofkP0203eIZ`/0ooK^00<0?EV[0?ofkP3om^h0=P3om^h00`000000
ooK^0?ofkP0H0?ofkP40oooo000I0?ofkP030000003om^h0ooK^03P0ooK^0P3D?AT;0?ofkP<0e3dI
2P3om^h00`000000ooK^0?ofkP030?ofkP80e3dI1P0mFJ/30?ofkP0503eIZ`3om^h0ooK^0?ofkP0m
FJ/00P3om^h0103D?AT0ooK^0?ofkP0mFJ/30=@m6@040000000D6S`051Xl000000<07BQG00@00000
01dXE`0M:5L0e3dI0`0M:5L0100000007BQG01dXE`0M:5L2000000809CA_00<0000002DdK`0U=6l0
1@0U=6l20=@m6@@09CA_0`00000202`nPP030=@m6@0/?X80;3j200@0;3j200<0000002`nPP0/?X80
1@0/?X83000000D0<DNB0P3D?AT30357TP050=@m6@0aAi80<DNB0357TP0000001P0aAi800`000000
=TjP03I>X00503I>X0030000000fCZ00=TjP00@0=TjP00<0e3dI03I>X00fCZ000`0fCZ000`3D?AT0
000003I>X00203I>X0D000000`3oC1l00`000000?EV[0?m<7`040?m<7`0303eIZ`3oC1l0od`O00@0
od`O00<000000?m<7`3oC1l01@3oC1l00`000000odXN0?m:7P040?m:7P050000003oBQh0odXN0?m:
7P0mFJ/00`3oBQh203eIZ`D0odXN0P0000000`3D?AT0odPM0?m87@050?m87@030000003oB1d0odPM
00@0odPM00<0?EV[0?m87@3oB1d00`0000040?Q57080?EV[1`3hAA`00`000000n4DL0?Q570020000
00<0jT0I00D000000>Y06@3Z@1T0jT0I03eIZ`020>Y06@050000003Z@1T0jT0I0>Y06@0000000P3D
>AH01@000000?EV[03eIZ`0mFJ/0e3dI0080ooK^00@0?EV[0?ofkP3om^h0e3dI0`3om^h0103D?AT0
ooK^0?ofkP3om^h60=@m6@80?EV[1@3om^h00`000000ooK^0?ofkP080?ofkP<0?EV[2`3om^h203eI
ZcX0ooK^00<000000?ofkP3om^h05`3om^h10?ooo`006@3om^h00`000000ooK^0?ofkP0i0?ofkP<0
e3dI2`3om^h00`3D?AT0ooK^0?ofkP070?ofkP030000003om^h0ooK^00<0ooK^103D?AT303eIZ`@0
ooK^00<0?EV[0?ofkP3om^h00P0mFJ/30?ofkP040=@m6@3om^h0ooK^03eIZ`80ooK^0`3D?AT00`00
00007BQG01dXE`0201dXE`030000000M:5L0e3dI00@07BQG00@0000001dXE`00000000001@0U=6l0
0`0000009CA_02DdK`0502DdK`030000003D?AT0e3dI008000000`0/?X800`000000;3j20=@m6@06
02`nPP030000000/?X80;3j200D0;3j200<000000357TP0aAi801P0aAi801@000000e3dI0=@m6@0a
Ai80e3dI00<0<DNB00<000000357TP0aAi800P0aAi83000000L0=TjP00<0000003I>X00fCZ000`0f
CZ000`3D?AT0000003I>X00503I>X080e3dI00D0=TjP0000000jEJ`0>UF/000000020?m=80040000
003oC1l0?EV[03eIZ`H0od`O00<0000003eIZ`3oC1l0103oC1l00`000000od`O0?m<7`050?m<7`<0
0000103oBQh01P000000odXN0?m:7P3oBQh0?EV[0?m:7P80?EV[00<000000?m:7P3oBQh01P3oBQh0
0`000000odPM0?m87@050?m87@030000003oB1d0odPM00@0odPM00<0?EV[0?m87@0000000`3oB1d2
00000080?EV[00<000000?Q5703hAA`01@3hAA`00`000000n4DL0?Q570030?Q57080000000<0jT0I
0000003Z@1T00`3Z@1T00`0mFJ/0jT0I000000040>Y06@040000000mFJ/0?EV[03eIZ`80ooK^00@0
e3dI0?ofkP3om^h0?EV[0`3om^h20=@m6@030?ofkP3D?AT0ooK^00@0ooK^0`3D?AT403eIZ`D0ooK^
00<000000?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP090?ofkP<0?EV[>`3om^h00`000000ooK^
0?ofkP0G0?ofkP40oooo000I0?ofkP030000003om^h0ooK^03T0ooK^00<0e3dI0?ofkP3om^h00P3D
?AT90?ofkP<0e3dI1@3om^h2000000@0ooK^0P3D?AT0100mFJ/0e3dI0=@m6@3om^h20=@m6@D0ooK^
00<0?EV[0?ofkP0mFJ/01@3om^h0103D?AT0ooK^0?ofkP0mFJ/30?ofkP040000003D?AT0e3dI0=@m
6@<07BQG00<000000=@m6@0M:5L0100M:5L2000000L09CA_00<0000002DdK`0U=6l01@0U=6l30000
0080e3dI0`0/?X800`000000e3dI02`nPP0602`nPP030000000/?X80;3j200<0;3j20`0000080357
TP040000000aAi80<DNB0=@m6@@0<DNB00D000000357TP0aAi80<DNB0000000303I>X0030000000f
CZ00=TjP00@0=TjP00<0000003I>X00fCZ000P0fCZ000`3D?AT0=TjP0000000603I>X080000000D0
e3dI03YE[00jEJ`0>UF/000000030?m=800303eIZ`000000000000H0od`O00<000000?m<7`0mFJ/0
103oC1l00`000000od`O0?m<7`040?m<7`050000003oC1l0od`O0?m<7`0000000`3oBQh00`000000
odXN0?m:7P020?m:7P0403eIZ`3oBQh0odXN000000P0odXN0`0000050?m87@030000003oB1d0odPM
00D0odPM00<0?EV[0000003oB1d00P3oB1d203eIZ`<000001`3hAA`00`000000n4DL0?Q570050?Q5
708000001@3Z@1T00`0mFJ/000000>Y06@020>Y06@<0?EV[00D000000?ofkP3om^h0ooK^0=@m6@02
0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3D?AT01@3om^h203eIZ`040?ofkP0mFJ/0
?EV[0=@m6@80?EV[103om^h2000000D0ooK^0`0mFJ/90?ofkP80?EV[00<0ooK^03eIZ`3om^h0>`3o
m^h00`000000ooK^0?ofkP0G0?ofkP40oooo000I0?ofkP030000003om^h0ooK^03X0ooK^00@0e3dI
0?ofkP3om^h0ooK^0P3D?AT80?ofkP040=@m6@3om^h0e3dI0=@m6@80ooK^00<000000?ofkP3om^h0
0P3om^h20=@m6@<0?EV[00D0e3dI0?ofkP3D?AT0e3dI0?ofkP020=@m6@80ooK^0`0mFJ/50?ofkP05
0=@m6@3om^h0ooK^0?ofkP0mFJ/00`3om^h0100000007BQG01dXE`0M:5L20=@m6@0301dXE`3D?AT0
7BQG00<07BQG0`00000802DdK`030000000U=6l09CA_00D09CA_00<0000002`nPP0/?X800P0/?X82
0=@m6@0302`nPP3D?AT0;3j200L0;3j200@0000002`nPP0/?X80;3j20P0000030357TP030000000a
Ai80<DNB00D0<DNB00@000000357TP3D?AT0<DNB0P3D?AT30357TP<00000100fCZ000`000000=TjP
03I>X00403I>X0030000000fCZ00=TjP0080=TjP00@0e3dI03I>X00fCZ0000001@0fCZ000`000000
>UF/03YE[0020=@m6@0303YE[0000000oddP0080?EV[0P3oCB000`000000od`O0?m<7`030?m<7`04
0000003oC1l0od`O03eIZ`<0od`O00<000000?m<7`3oC1l01@3oC1l00`000000od`O0?m<7`020?m<
7`<000000`3oBQh203eIZ`040?m:7P0mFJ/0odXN000000L0odXN00@000000?m:7P3oBQh0odXN0P00
00030?m87@030000003oB1d0odPM00H0odPM00@0?EV[0?m87@0mFJ/0?EV[103oB1d00`000000n4DL
0?Q570050?Q570030000003hAA`0n4DL00H0n4DL0`0000040>Y06@0403eIZ`3Z@1T0?EV[03eIZ`<0
jT0I00D000000?ofkP3om^h0ooK^0=@m6@020?ofkP0303eIZ`3om^h0ooK^00@0ooK^0P3D?AT30?of
kP80?EV[00D0ooK^03eIZ`0mFJ/0ooK^03eIZ`030=@m6@80?EV[103om^h00`000000ooK^0?ofkP02
03eIZ`030?ofkP0mFJ/0ooK^00L0ooK^0P0mFJ/30?ofkP0303eIZ`3om^h0ooK^03X0ooK^00<00000
0?ofkP3om^h05`3om^h10?ooo`00603om^h00`000000ooK^0?ofkP0l0?ofkP030=@m6@3om^h0ooK^
0080ooK^0P3D?AT60?ofkP040=@m6@3om^h0ooK^0?ofkP8000000`3om^h20=@m6@030?ofkP0mFJ/0
?EV[0080ooK^00@0e3dI03eIZ`3om^h0ooK^0P3D?AT0103om^h0e3dI0=@m6@0mFJ/70?ofkP040=@m
6@3om^h0ooK^03eIZ`<0ooK^00<0?EV[0000000M:5L0100M:5L00`3D?AT0000001dXE`0201dXE`05
0000000U=6l09CA_02DdK`0000001`0U=6l00`0000009CA_02DdK`0302DdK`<000001P0/?X800`3D
?AT0;3j20000000802`nPP<000001@0aAi800`000000<DNB0357TP060357TP030=@m6@0aAi80<DNB
0080<DNB0P3D?AT00`0aAi80000003I>X00503I>X0030000000fCZ00=TjP00D0=TjP00@0000003I>
X00fCZ00e3dI0`0fCZ0010000000=TjP03I>X00fCZ03000000@0>UF/00<0e3dI0000000mFJ/0103o
CB03000000<0od`O00D000000?m<7`3oC1l0od`O03eIZ`020?m<7`030000003oC1l0od`O00D0od`O
00<000000?m<7`3oC1l0103oC1l010000000odXN03eIZ`0mFJ/40?m:7P0303eIZ`3oBQh0odXN00H0
odXN00<000000?m:7P3oBQh00`3oBQh3000000P0odPM00<000000?m87@0mFJ/01P3oB1d3000000D0
n4DL00<000000?Q5703hAA`01@3hAA`01@000000n4DL0?Q5703hAA`0000000<0jT0I00@0000003eI
Z`3Z@1T0?EV[0`3Z@1T01@000000e3dI0?ofkP3om^h0e3dI00<0ooK^00<0?EV[0?ofkP3om^h01@3o
m^h0103D?AT0?EV[03eIZ`3om^h203eIZ`80ooK^00@0e3dI03eIZ`3om^h0ooK^0P3D?AT00`3om^h0
?EV[03eIZ`030?ofkP8000000`3om^h00`0mFJ/0ooK^0?ofkP040?ofkP80?EV[103om^h00`0mFJ/0
ooK^0?ofkP0l0?ofkP030000003om^h0ooK^01H0ooK^0@3oool001P0ooK^00<000000?ofkP3om^h0
?@3om^h20=@m6@@0ooK^0P3D?AT40?ofkP040=@m6@3om^h0ooK^00000080ooK^0`3D?AT20?ofkP03
03eIZ`3om^h0ooK^0080?EV[00<0e3dI03eIZ`3om^h00`3om^h20=@m6@0303eIZ`3D?AT0e3dI00H0
ooK^00@0e3dI0?ofkP3om^h0?EV[0P3om^h00`0mFJ/0ooK^0000000301dXE`80e3dI00D07BQG0=@m
6@3D?AT07BQG0000000402DdK`030000000U=6l09CA_00D09CA_00<0000002DdK`0U=6l00P0U=6l0
1@000000;3j202`nPP0/?X80000000@0;3j200@0e3dI02`nPP3D?AT0e3dI200/?X800`000000<DNB
0357TP060357TP030000000aAi80<DNB00@0<DNB00<0e3dI0000000aAi80100aAi800`000000e3dI
0=@m6@0603I>X0030000000fCZ00=TjP00D0=TjP00<0000003I>X03D?AT0100fCZ0010000000=TjP
00000000000203YE[0030000000jEJ`0>UF/00<0>UF/00<000000?m=803oCB000`3oCB000`000000
oddP0?m=8002000000030?m<7`000000od`O00<0od`O00<0?EV[0?m<7`0000001`3oC1l00`000000
od`O0?m<7`040?m<7`80?EV[00<000000?m:7P3oBQh00`3oBQh00`000000?EV[0?m:7P050?m:7P03
0000003oBQh0odXN00H0odXN00<000000?m87@3oB1d01P3oB1d203eIZ`030?m87@0mFJ/0odPM00<0
odPM00D000000?m87@3oB1d0odPM000000040?Q570030000003hAA`0n4DL00D0n4DL00<000000?Q5
703hAA`00P3hAA`01@000000jT0I03eIZ`0mFJ/0jT0I0080?EV[0`3Z@1T01P000000ooK^0=@m6@3D
?AT0ooK^0=@m6@80ooK^00<0?EV[0?ofkP3om^h0103om^h203eIZ`030=@m6@0mFJ/0?EV[00@0ooK^
00@0?EV[0?ofkP3D?AT0e3dI0P3om^h00`3D?AT0ooK^0?ofkP0303eIZ`80ooK^00<000000?ofkP0m
FJ/01@3om^h203eIZ`@0ooK^0P0mFJ/o0?ofkP030000003om^h0ooK^01H0ooK^0@3oool001P0ooK^
00<000000?ofkP3om^h0?P3om^h50=@m6@80ooK^0P3D?AT30?ofkP800000103D?AT0103om^h0e3dI
0=@m6@0mFJ/20?ofkP0503eIZ`3om^h0ooK^03eIZ`3D?AT00`3om^h203eIZ`040?ofkP3D?AT0e3dI
0?ofkP80e3dI103om^h00`3D?AT0ooK^0?ofkP0303eIZ`80ooK^00@0000001dXE`0M:5L0e3dI0`0M
:5L200000080e3dI100U=6l00`0000009CA_02DdK`0602DdK`040000000U=6l09CA_000000@0;3j2
00D0000002`nPP0/?X80;3j20=@m6@0402`nPP80e3dI100/?X83000000P0<DNB00<000000357TP0a
Ai80100aAi800`3D?AT000000357TP020357TP8000000`0fCZ020=@m6@D0=TjP00<0000003I>X00f
CZ00100fCZ000`000000e3dI03I>X00403I>X0800000100jEJ`00`000000>UF/03YE[00303YE[003
0000003oCB00oddP00<0oddP00<000000?m=803oCB000P3oCB02000000D0od`O00<0?EV[0000003o
C1l01@3oC1l00`000000od`O0?m<7`030?m<7`80?EV[0`3oC1l2000000<0odXN00<0000003eIZ`3o
BQh01@3oBQh00`000000odXN0?m:7P060?m:7P<00000103oB1d203eIZ`@0odPM00D0?EV[0?m87@3o
B1d0odPM000000040?m87@040000003hAA`0n4DL000000P0n4DL00<000000?Q5703hAA`00P3hAA`2
03eIZ`8000000`3Z@1T0100mFJ/0jT0I0>Y06@0000030?ofkP80e3dI0P3om^h00`0mFJ/0ooK^0?of
kP020?ofkP80?EV[00@0ooK^03eIZ`0mFJ/0ooK^0P3D?AT30?ofkP0503eIZ`3D?AT0ooK^0?ofkP3D
?AT00P3om^h0103D?AT0?EV[03eIZ`3om^h403eIZ`8000000`3om^h203eIZ`80ooK^1@0mFJ]00?of
kP030000003om^h0ooK^01H0ooK^0@3oool001P0ooK^00<000000?ofkP3om^h0@03om^h20=@m6@03
0?ofkP3D?AT0e3dI00@0e3dI00<000000=@m6@3om^h00`3om^h20=@m6@050?ofkP0mFJ/0e3dI0=@m
6@0mFJ/00P3om^h00`0mFJ/0ooK^0=@m6@020?ofkP0603eIZ`3om^h0ooK^0?ofkP0mFJ/0ooK^0P3D
?AT00`3om^h0e3dI0=@m6@020?ofkP040=@m6@3om^h0ooK^03eIZ`@0ooK^00<0000001dXE`3D?AT0
100M:5L0100000009CA_02DdK`0U=6l20=@m6@809CA_00<0000002DdK`0U=6l01P0U=6l3000000D0
;3j200@0000002`nPP0/?X80e3dI1@0/?X801P000000;3j20=@m6@3D?AT0;3j2000000<0<DNB00<0
00000357TP0aAi801P0aAi800`000000<DNB0357TP020357TP030=@m6@0aAi80<DNB00<000001@0f
CZ000`000000=TjP0=@m6@0403I>X0030000000fCZ00=TjP00@0=TjP00<000000=@m6@0fCZ000P0f
CZ03000000D0>UF/00<0000003YE[00jEJ`00`0jEJ`00`000000oddP0?m=80030?m=80030000003o
CB00oddP00<0oddP0`0000030?m<7`0303eIZ`000000od`O00D0od`O00<000000?m<7`3oC1l00P3o
C1l00`0mFJ/0od`O000000050?m<7`<000000P3oBQh00`0mFJ/0odXN0?m:7P020?m:7P030000003o
BQh0odXN00H0odXN00H000000?m:7P3oBQh0odXN0000003oB1d203eIZ`030?m87@000000odPM00@0
odPM00@0?EV[0?m87@3oB1d000001@3oB1d3000000L0n4DL00@000000?Q5703hAA`0n4DL0P0mFJ/3
0?Q570030000003Z@1T0jT0I0080jT0I00<0?EV[0000003om^h0103om^h0103D?AT0ooK^0?ofkP0m
FJ/20?ofkP80?EV[00D0ooK^03eIZ`0mFJ/0ooK^0=@m6@030?ofkP060=@m6@3om^h0ooK^03eIZ`3o
m^h0e3dI0P3om^h01@3D?AT0?EV[03eIZ`3D?AT0ooK^0080?EV[103om^h00`0mFJ/0000003eIZ`05
03eIZ`030?ofkP0mFJ/0?EV[0480ooK^00<000000?ofkP3om^h05P3om^h10?ooo`00603om^h00`00
0000ooK^0?ofkP120?ofkP80e3dI0P3om^h20=@m6@040000003D?AT0e3dI0=@m6@D0ooK^0P3D?AT0
200mFJ/0ooK^0=@m6@3D?AT0ooK^03eIZ`3om^h0e3dI0P0mFJ/40?ofkP0403eIZ`3om^h0ooK^0?of
kP80e3dI00@0ooK^0=@m6@3D?AT0e3dI0`0mFJ/40?ofkP80e3dI100M:5L2000000D09CA_0P3D?AT0
0`0U=6l0000002DdK`0602DdK`030000000/?X80;3j200H0;3j200<000000=@m6@0/?X801@0/?X80
1@000000;3j202`nPP0/?X80e3dI00@0<DNB00<000000357TP0aAi801P0aAi801@000000<DNB0357
TP0aAi80e3dI00<0<DNB00<0000003I>X00fCZ001@0fCZ000`000000=TjP03I>X0020=@m6@80=TjP
00<0000003I>X00fCZ00100fCZ001@3D?AT0000003I>X00fCZ0000000080>UF/00<0000003YE[00j
EJ`00`0jEJ`00`000000>UF/03YE[00303YE[0030000003oCB00oddP00<0oddP00<000000?m=803o
CB000`3oCB0010000000oddP0?m=800000020?m<7`030000000mFJ/0od`O00D0od`O00<000000?m<
7`3oC1l00P0mFJ/20?m<7`030000003oC1l0od`O00D0od`O00D000000?m:7P3oBQh0odXN03eIZ`03
0?m:7P030000003oBQh0odXN00H0odXN00<000000?m:7P3oBQh00P3oBQh01@0mFJ/0odPM0?m87@3o
B1d0000000H0odPM00<0?EV[0000003oB1d01`3oB1d00`000000n4DL0?Q570050?Q570040000003h
AA`0?EV[03eIZ`D0n4DL0P0000040>Y06@80?EV[103om^h30=@m6@<0?EV[00<0ooK^03eIZ`0mFJ/0
0`3om^h00`3D?AT0ooK^0?ofkP020?ofkP80e3dI00@0?EV[0?ofkP3D?AT0ooK^0P0mFJ/0103om^h0
e3dI03eIZ`0mFJ/50?ofkP<0?EV[00<0000003eIZ`0mFJ/00P3om^h203eIZd@0ooK^00<000000?of
kP3om^h05P3om^h10?ooo`005`3om^h00`000000ooK^0?ofkP150?ofkP80e3dI0P0000020=@m6@03
0?ofkP3D?AT0ooK^00<0ooK^0`0mFJ/20=@m6@80ooK^0P3D?AT00`3om^h0e3dI0?ofkP050?ofkP03
03eIZ`3om^h0ooK^00<0ooK^0P3D?AT01@0mFJ/0e3dI0?ofkP3om^h0?EV[00<0ooK^00<0e3dI0?of
kP0000000`0M:5L0100000009CA_02DdK`00000602DdK`030=@m6@0000009CA_00@09CA_0`000008
02`nPP030=@m6@0/?X80;3j200H0;3j20`0000000`0aAi80e3dI0=@m6@030357TP030000000aAi80
<DNB00H0<DNB00<000000357TP3D?AT00P0aAi83000000P0=TjP00@0000003I>X00fCZ00=TjP0P3D
?AT00`0fCZ00000003I>X00303I>X0030=@m6@0fCZ000000008000000`0jEJ`00`000000>UF/03YE
[00303YE[0030000000jEJ`0>UF/00<0>UF/00<000000?m=803oCB000`3oCB000`000000oddP0?m=
80030?m=80040000003oCB00oddP0?m=80<0000000<0od`O03eIZ`3oC1l00`3oC1l010000000od`O
03eIZ`0mFJ/30?m<7`030000003oC1l0od`O00H0od`O0`0000020?m:7P0303eIZ`3oBQh0000000P0
odXN00@000000?m:7P3oBQh0odXN0P0mFJ/0103oBQh000000000000000080?m87@0303eIZ`3oB1d0
odPM00D0odPM00@000000?m87@00000000001@3hAA`00`000000?EV[0?Q570050?Q570040000003h
AA`0n4DL000000<0jT0I00<000000?ofkP0mFJ/00`3om^h01@3D?AT0ooK^0?ofkP0mFJ/0e3dI0080
?EV[1@3om^h00`3D?AT0ooK^0?ofkP040?ofkP0403eIZ`3om^h0?EV[03eIZ`80ooK^0P0mFJ/30=@m
6@@0ooK^00@0?EV[0?ofkP0mFJ/0?EV[0P00000203eIZdL0ooK^00<000000?ofkP3om^h05@3om^h1
0?ooo`005`3om^h00`000000ooK^0?ofkP160?ofkP030000003D?AT0e3dI0080ooK^103D?AT00`3o
m^h0?EV[03eIZ`040?ofkP80e3dI00@0ooK^03eIZ`3D?AT0e3dI1@3om^h00`0mFJ/0ooK^0?ofkP04
0?ofkP80?EV[103D?AT0100mFJ/0ooK^0?ofkP3D?AT20?ofkP040000000M:5L00000000000<09CA_
00<0000002DdK`0U=6l01@0U=6l20=@m6@809CA_0P00000302`nPP030000000/?X80;3j200<0;3j2
0P3D?AT00`0/?X80000002`nPP0602`nPP030000000aAi80<DNB00<0<DNB0P3D?AT00`0aAi800000
0357TP070357TP050000003D?AT0<DNB0357TP0000000`0fCZ000`000000=TjP03I>X00503I>X003
0000000fCZ00=TjP00<0=TjP0P3D?AT303I>X0040=@m6@0fCZ00=TjP000000H0>UF/00<0000003YE
[00jEJ`00P0jEJ`00`000000>UF/03YE[00303YE[0030000003oCB00oddP00<0oddP00<000000?m=
803oCB000P3oCB000`000000oddP0?m=80040?m=80040000003oC1l0od`O03eIZ`<0od`O0P0mFJ/5
0?m<7`030000003oC1l0od`O00D0od`O00D000000?m<7`3oC1l0od`O000000020?m:7P0303eIZ`00
0000odXN00L0odXN00@000000?m:7P0mFJ/0?EV[1@3oBQh00`000000odPM0?m87@050?m87@040000
003oB1d0?EV[03eIZ`D0odPM00@000000?m87@3oB1d0odPM0P0000020?Q57080?EV[1`3hAA`01000
0000n4DL0?Q5703hAA`2000000050>Y06@000000ooK^0?ofkP0mFJ/00P3om^h00`3D?AT0?EV[03eI
Z`0203eIZ`80e3dI1P3om^h00`3D?AT0ooK^0?ofkP030?ofkP80?EV[00@0e3dI0?ofkP0mFJ/0?EV[
103om^h20=@m6@030?ofkP0mFJ/0?EV[0080?EV[0P3om^h203eIZ`030000003om^h0ooK^04H0ooK^
00<000000?ofkP3om^h05@3om^h10?ooo`005`3om^h00`000000ooK^0?ofkP140?ofkP8000000`3o
m^h20=@m6@80ooK^103D?AT60?ofkP0403eIZ`3D?AT0e3dI0?ofkP<0e3dI0`3om^h00`0mFJ/0ooK^
0?ofkP030?ofkP0403eIZ`3om^h0ooK^0?ofkPH0e3dI0`3om^h2000000D09CA_00<0000002DdK`0U
=6l01P0U=6l00`000000e3dI0=@m6@0502`nPP030000000/?X80;3j20080;3j200D0e3dI02`nPP0/
?X80;3j20000000502`nPP80000000<0<DNB0000000aAi801@0aAi800`3D?AT0<DNB000000070357
TP040=@m6@0000000000000000@0=TjP00<0000003I>X00fCZ001@0fCZ000`000000=TjP03I>X004
03I>X0050000003D?AT0e3dI03I>X03D?AT00`00000603YE[0030000000jEJ`0>UF/00<0>UF/00<0
000003YE[00jEJ`00P0jEJ`00`000000oddP0?m=80020?m=80030000003oCB00oddP00<0oddP00<0
00000?m=803oCB00103oCB030000000503eIZ`3oC1l0?EV[03eIZ`0000001P3oC1l00`000000od`O
0?m<7`050?m<7`030000003oC1l0od`O0080od`O0P0000000`3D?AT0?EV[0?m:7P060?m:7P030000
003oBQh0?EV[00H0odXN00@000000?m:7P00000000001@3oB1d01@000000odPM0?m87@3oB1d0?EV[
00<0odPM00<000000?m87@3oB1d0103oB1d203eIZ`030000003hAA`0n4DL00H0n4DL00<000000?Q5
703hAA`00`3hAA`2000000<0ooK^1P0mFJ/30?ofkP030=@m6@3om^h0ooK^00<0ooK^00@0e3dI0?of
kP3om^h0ooK^0`0mFJ/0103om^h0?EV[03eIZ`3D?AT60?ofkP@0?EV[0P3om^h203eIZ`<0ooK^0P00
00160?ofkP030000003om^h0ooK^01D0ooK^0@3oool001L0ooK^00<000000?ofkP3om^h0@`3om^h0
0`000000ooK^0?ofkP050?ofkP80e3dI00<0ooK^03eIZ`3D?AT00`3D?AT30?ofkP0403eIZ`3om^h0
ooK^0?ofkP<0e3dI00D0ooK^0=@m6@3D?AT0ooK^03eIZ`030?ofkP80?EV[1@3om^h30=@m6@030?of
kP3D?AT0e3dI0080ooK^00<0000002DdK`0U=6l0100U=6l00`0000009CA_02DdK`0602DdK`030000
000/?X80;3j20080e3dI100/?X8010000000;3j202`nPP3D?AT402`nPP040000000/?X80;3j202`n
PP8000000`0aAi800`000000<DNB0357TP050357TP80e3dI1`0aAi800`3D?AT0000003I>X00603I>
X0030000000fCZ00=TjP00@0=TjP00<0000003I>X00fCZ00100fCZ001@000000=TjP03I>X03D?AT0
00000080>UF/00<0000003YE[00jEJ`0100jEJ`00`000000>UF/03YE[00303YE[0030000000jEJ`0
>UF/0080>UF/00<000000?m=803oCB000P3oCB000`000000oddP0?m=80030?m=80030000003oCB00
oddP00@0oddP00D000000?m=803oCB00000003eIZ`020?m<7`030000003oC1l0od`O00@0od`O00<0
00000?m<7`3oC1l0103oC1l00`000000od`O0?m<7`050?m<7`030000000mFJ/0odXN00H0odXN0P0m
FJ/70?m:7P040000003oBQh0odXN0?m:7P8000000`3oB1d00`000000odPM0?m87@020?m87@0403eI
Z`3oB1d0odPM000000@0odPM0P0mFJ/20?m87@030000003hAA`0n4DL00D0n4DL00<000000?Q5703h
AA`01@3hAA`00`000000ooK^0?ofkP0203eIZ`040?ofkP0mFJ/0?EV[03eIZ`D0ooK^0P3D?AT30?of
kP050=@m6@3om^h0?EV[03eIZ`3om^h00`0mFJ/30?ofkP040=@m6@3om^h0ooK^0?ofkP@0?EV[0P3o
m^h203eIZ`L0ooK^00<000000?ofkP3om^h0@`3om^h00`000000ooK^0?ofkP0E0?ofkP40oooo000F
0?ofkP030000003om^h0ooK^0480ooK^0P00000:0?ofkP80e3dI00<0ooK^0=@m6@3D?AT00`3D?AT2
03eIZ`D0ooK^0P3D?AT20?ofkP80e3dI00<0ooK^03eIZ`0mFJ/01@3om^h30=@m6@050?ofkP0mFJ/0
e3dI0=@m6@3om^h00P3D?AT00`0000009CA_02DdK`0502DdK`030000000U=6l09CA_00<09CA_0`00
000402`nPP80e3dI0P0/?X800`000000;3j20=@m6@0602`nPP<000001P0aAi800`000000<DNB0357
TP060357TP80e3dI100aAi800`3D?AT000000000000703I>X0030000000fCZ00=TjP00D0=TjP00<0
000003I>X00fCZ00100fCZ000`000000e3dI000000020=@m6@80>UF/00<0000003YE[00jEJ`00`0j
EJ`00`000000>UF/03YE[00303YE[0030000000jEJ`0>UF/0080>UF/00<000000?m=803oCB000P3o
CB000`000000oddP0?m=80030?m=80030000003oCB00oddP00<0oddP00<000000?m=803oCB000P0m
FJ/00`000000?EV[000000060?m<7`030000003oC1l0od`O00D0od`O00<000000?m<7`3oC1l0103o
C1l010000000e3dI0000000mFJ/40?m:7P80?EV[203oBQh00`000000odXN0?m:7P040?m:7P<00000
1P3oB1d00`0mFJ/000000?m87@020?m87@80?EV[0`3oB1d010000000odPM0000000000050?Q57003
0000003hAA`0n4DL00D0n4DL00@0000003eIZ`0mFJ/0ooK^0P0mFJ/00`3D?AT0ooK^03eIZ`0203eI
Z`D0ooK^0P3D?AT00`3om^h0?EV[03eIZ`020?ofkP80?EV[1@3om^h20=@m6@D0?EV[00<0ooK^03eI
Z`0mFJ/02P3om^h2000004@0ooK^00<000000?ofkP3om^h0503om^h10?ooo`005P3om^h00`000000
ooK^0?ofkP110?ofkP030000003om^h0ooK^00X0ooK^00<0?EV[0?ofkP3D?AT00P3D?AT00`3om^h0
e3dI0=@m6@020=@m6@H0ooK^0`3D?AT203eIZ`80e3dI103om^h20=@m6@80ooK^00<0e3dI03eIZ`3o
m^h00P3om^h20=@m6@030?ofkP3D?AT0e3dI00H09CA_00<0000002DdK`0U=6l00P0U=6l01@000000
;3j202`nPP0/?X80000000D0;3j20P3D?AT00`0/?X80e3dI02`nPP0602`nPP030000000aAi80<DNB
00H0<DNB00<000000357TP0aAi801P0aAi801P000000<DNB0=@m6@3D?AT000000=@m6@<0=TjP00<0
000003I>X00fCZ00100fCZ000`000000=TjP03I>X00503I>X0030000000fCZ00=TjP00@0=TjP00<0
e3dI03YE[00jEJ`00P0jEJ`20=@m6@030000000jEJ`0>UF/00<0>UF/00<0000003YE[00jEJ`00`0j
EJ`00`000000>UF/03YE[00203YE[0030000003oCB00oddP0080oddP00<000000?m=803oCB000`3o
CB000`000000oddP0?m=80030?m=80030000000mFJ/0?EV[00@0oddP00<0?EV[0?m<7`3oC1l0103o
C1l00`000000od`O0?m<7`050?m<7`030000003oC1l0od`O00@0od`O00H000000?m<7`3oC1l0od`O
03eIZ`00000203eIZ`030?m:7P000000odXN00L0odXN00<000000?m:7P3oBQh01P3oBQh00`000000
odPM0?m87@050?m87@0403eIZ`3oB1d0?EV[03eIZ`D0odPM00D000000?m87@3oB1d0odPM00000004
0?Q570030000003hAA`0n4DL00@0n4DL0P0mFJ/00`3om^h0?EV[03eIZ`030?ofkP040=@m6@0mFJ/0
ooK^0?ofkP80?EV[103om^h203eIZ`80e3dI0`0mFJ/60?ofkP@0?EV[00D0ooK^03eIZ`0mFJ/0?EV[
0=@m6@0=0?ofkP030000003om^h0ooK^0440ooK^00<000000?ofkP3om^h0503om^h10?ooo`005P3o
m^h00`000000ooK^0?ofkP0o0?ofkP8000003@3om^h0100mFJ/0ooK^0?ofkP3om^h30=@m6@030?of
kP3D?AT0e3dI0080e3dI103om^h00`3D?AT0ooK^0?ofkP020=@m6@80ooK^103D?AT40?ofkP030=@m
6@0mFJ/0ooK^00@0ooK^0P3D?AT00`0mFJ/09CA_02DdK`0402DdK`050000000U=6l09CA_02DdK`00
0000100/?X800`000000;3j202`nPP0502`nPP030=@m6@000000;3j200@0;3j20P0000000`0aAi80
00000357TP070357TP030000000aAi80<DNB00H0<DNB0`0000000`3D?AT0=TjP03I>X00203I>X003
0000000fCZ00=TjP00D0=TjP00<0000003I>X00fCZ00100fCZ000`000000=TjP03I>X00203I>X003
0000003D?AT0000000H0>UF/0P3D?AT403YE[0030000000jEJ`0>UF/00<0>UF/00<0000003YE[00j
EJ`00P0jEJ`00`000000oddP0?m=80020?m=80030000003oCB00oddP00<0oddP00<000000?m=803o
CB000P3oCB0203eIZ`H0oddP00<0000003eIZ`000000103oC1l00`000000od`O0?m<7`040?m<7`03
0000003oC1l0od`O00@0od`O00<000000?m<7`3oC1l00`3oC1l0100mFJ/000000000000000080?m:
7P030000003oBQh0odXN00H0odXN00@000000?m:7P0000000000103oB1d00`000000odPM03eIZ`06
0?m87@030000003oB1d0odPM00<0odPM00D000000?Q5703hAA`0n4DL000000060?Q570030=@m6@0m
FJ/0?EV[00D0ooK^00<0e3dI03eIZ`3om^h00`3om^h403eIZ`80ooK^0P0mFJ/20?ofkP0303eIZ`3o
m^h0ooK^0080ooK^100mFJ/0103om^h0?EV[03eIZ`0mFJ/30?ofkP030=@m6@3om^h0ooK^00/0ooK^
0P0000110?ofkP030000003om^h0ooK^01@0ooK^0@3oool001H0ooK^00<000000?ofkP3om^h0?P3o
m^h00`000000ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h01`3D
?AT30?ofkPT0e3dI1@3om^h00`3D?AT0?EV[0?ofkP040?ofkP80?EV[0P3D?AT602DdK`<000001P0/
?X800`000000;3j202`nPP0202`nPP80e3dI00<0;3j20=@m6@3D?AT00`0/?X801@000000<DNB0357
TP0aAi80000000T0<DNB00<000000357TP0aAi801@0aAi8010000000=TjP0=@m6@0fCZ020=@m6@<0
=TjP00<0000003I>X00fCZ00100fCZ000`000000=TjP03I>X00503I>X0080000000fCZ0000000000
000jEJ`0e3dI03YE[000000503YE[0040000000jEJ`0e3dI0=@m6@80>UF/00<0000003YE[00jEJ`0
0`0jEJ`00`000000>UF/03YE[00500000080oddP00<000000?m=803oCB000`3oCB000`000000oddP
0?m=800203eIZ`030?m=80000000oddP00@0oddP00@000000?m=800mFJ/0oddP0P0000000`3oC1l0
00000?m<7`060?m<7`030000003oC1l0od`O00@0od`O00@000000?m<7`3oC1l0od`O0P0mFJ/0103o
C1l0?EV[0?m<7`0000070?m:7P030000003oBQh0odXN00L0odXN00D000000?m:7P3oBQh0odXN0000
00030?m87@80?EV[00<0odPM03eIZ`0mFJ/0103oB1d00`000000odPM0?m87@040?m87@<00000103h
AA`0100mFJ/0n4DL03eIZ`0mFJ/20=@m6@D0ooK^00<0e3dI03eIZ`3om^h0103om^h903eIZ`<0ooK^
1`0mFJ/20?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT03`3om^h00`000000ooK^0?ofkP0n0?ofkP03
0000003om^h0ooK^01@0ooK^0@3oool001H0ooK^00<000000?ofkP3om^h0?@3om^h00`000000ooK^
0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^0080?EV[103om^h00`0mFJ/0e3dI0=@m6@070=@m6@030?of
kP0mFJ/0ooK^0080ooK^0P3D?AT00`3om^h0e3dI0=@m6@030?ofkP030=@m6@0mFJ/0ooK^00<0ooK^
00D0?EV[0?ofkP3om^h0ooK^000000020=@m6@@09CA_00<0000002`nPP0/?X801P0/?X800`000000
;3j202`nPP020=@m6@@0;3j200@000000=@m6@3D?AT000001@0aAi800`000000<DNB0357TP060357
TP030000000aAi80<DNB00<0<DNB0P0000000`0mFJ/0e3dI03I>X00303I>X080e3dI00<0=TjP0000
000fCZ001@0fCZ000`000000=TjP03I>X00503I>X08000000P0jEJ`0103D?AT0>UF/03YE[0000005
03YE[0070000000jEJ`0>UF/03YE[03D?AT0>UF/0000000503YE[0<000000P0nFkL00`000000odhP
0?m>8003000000D0oddP00<000000?m=800mFJ/00P3oCB000`000000oddP0?m=80040?m=80040000
003oCB00oddP03eIZ`80oddP0P0000070?m<7`030000003oC1l0od`O00<0od`O00<000000?m<7`3o
C1l00P0mFJ/40?m<7`0403eIZ`3oC1l00000000000D0odXN00<000000?m:7P3oBQh01P3oBQh00`00
0000odXN0?m:7P030?m:7P030000000mFJ/0?EV[00D0odPM0P0mFJ/00`3oB1d000000?m87@080?m8
7@030000003hAA`0n4DL0080n4DL0P0mFJ/01@000000ooK^0?ofkP3om^h0e3dI00@0ooK^00<0e3dI
03eIZ`3om^h00P3om^h203eIZ`030?ofkP0mFJ/0?EV[00<0ooK^00<0e3dI0?ofkP0mFJ/0200mFJ/0
0`3D?AT0ooK^0?ofkP020?ofkP80e3dI0P3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030000003om^h0
ooK^03d0ooK^00<000000?ofkP3om^h0503om^h10?ooo`005@3om^h00`000000ooK^0?ofkP0l0?of
kP8000003`3om^h0100mFJ/0ooK^0?ofkP0mFJ/60?ofkP0303eIZ`3om^h0ooK^0080e3dI00<0ooK^
0=@m6@3D?AT00`3D?AT00`0mFJ/0ooK^0?ofkP030?ofkP80e3dI00<0ooK^0=@m6@3D?AT00P3om^h0
0`3D?AT0ooK^0?ofkP0203eIZ`@0ooK^00<0000002DdK`0U=6l00P3D?AT20000000302`nPP000000
;3j200L0;3j200<000000=@m6@0/?X801P0/?X8010000000<DNB0=@m6@3D?AT50357TP030000000a
Ai80<DNB00H0<DNB00H000000357TP0aAi80<DNB0000000fCZ020=@m6@030000000fCZ00=TjP00@0
=TjP0P3D?AT00`000000=TjP03I>X00403I>X0030000000fCZ00=TjP0080=TjP0`00000203YE[005
0=@m6@0jEJ`0>UF/03YE[00000001P0jEJ`010000000>UF/03YE[00jEJ`20=@m6@030000000jEJ`0
>UF/0080>UF/00L0000003iK]`0nFkL0?U^g0=@m6@000000?EV[00<0odhP00<000000?m=803oCB00
0P3oCB000`000000?EV[03eIZ`030?m=80030000003oCB00oddP00@0oddP00D000000?m=803oCB00
oddP03eIZ`020?m=80<00000103oC1l00`000000od`O0?m<7`040?m<7`030000000mFJ/0?EV[00H0
od`O00D0000003eIZ`0mFJ/0od`O000000030?m:7P030000003oBQh0odXN00H0odXN00<000000?m:
7P3oBQh00`3oBQh203eIZ`030?m:7P000000odPM00H0odPM00<0?EV[0000003oB1d01`3oB1d01000
0000odPM00000000000203eIZ`80n4DL00<000000?ofkP3om^h00P3om^h20=@m6@80ooK^00<0?EV[
0?ofkP3om^h00P0mFJ/00`3om^h0?EV[03eIZ`050?ofkP030=@m6@0mFJ/0?EV[00<0?EV[00<0ooK^
03eIZ`0mFJ/00P3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0e3dI0100ooK^0P00000n
0?ofkP030000003om^h0ooK^01<0ooK^0@3oool001D0ooK^00<000000?ofkP3om^h0>`3om^h00`00
0000ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0?EV[00L0ooK^00<0?EV[0?ofkP3om^h00P3om^h20=@m
6@050?ofkP3D?AT0e3dI0=@m6@0mFJ/01`3om^h20=@m6@040?ofkP3D?AT0e3dI0=@m6@80?EV[1P3o
m^h01@0000009CA_02DdK`0U=6l000000080e3dI00<0;3j20000000/?X801P0/?X820=@m6@H0;3j2
0P000000100aAi8000000357TP0aAi820=@m6@<0<DNB00<000000357TP0aAi801P0aAi801P000000
<DNB000000000000=TjP0=@m6@<0=TjP00<0000003I>X00fCZ001@0fCZ020=@m6@D0=TjP00D00000
03I>X00fCZ00=TjP0000000303YE[0030000003D?AT0>UF/00@0>UF/00<0000003YE[00jEJ`00`0j
EJ`00`000000>UF/03YE[00303YE[080e3dI00@0>UF/00000000000000000P0nFkL01@3D?AT0?U^g
0000003oCR00?EV[0080odhP0`0000000`3oCB00?EV[03eIZ`050?m=80030000003oCB00oddP00<0
oddP00<000000?m=803oCB000`3oCB000`0mFJ/000000?m=80020?m=80050000003oC1l0od`O0?m<
7`0000001@3oC1l203eIZ`L0od`O00H000000?m<7`3oC1l0od`O03eIZ`3oC1l2000000030?m:7P00
0000odXN00H0odXN00<000000?m:7P3oBQh00P3oBQh203eIZ`80odXN00@000000?m:7P0000000000
1@3oB1d00`000000?EV[03eIZ`070?m87@050000003oB1d0?EV[03eIZ`0000000`3hAA`00`000000
ooK^0?ofkP040?ofkP80e3dI0`0mFJ/00`3om^h0?EV[03eIZ`070?ofkP050=@m6@0mFJ/0?EV[03eI
Z`3om^h00P0mFJ/40?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3D?AT04@3om^h00`00
0000ooK^0?ofkP0k0?ofkP030000003om^h0ooK^01<0ooK^0@3oool001D0ooK^00<000000?ofkP3o
m^h0>@3om^h200000140ooK^0`0mFJ/80?ofkP0403eIZ`3om^h0ooK^0?ofkP80?EV[00@0ooK^0=@m
6@3D?AT0ooK^0`3D?AT80?ofkP80e3dI00<0ooK^0=@m6@3D?AT0203om^h3000000<0;3j20P3D?AT0
0`000000;3j202`nPP0202`nPP80e3dI0P0/?X8010000000;3j202`nPP0/?X82000000<0<DNB00<0
00000357TP0aAi800P0aAi820=@m6@80<DNB00<000000357TP0aAi801P0aAi8010000000=TjP03I>
X03D?AT503I>X0030000000fCZ00=TjP00D0=TjP00<000000=@m6@0fCZ00100fCZ03000000@0>UF/
00<0e3dI03YE[00jEJ`0100jEJ`00`000000>UF/03YE[00303YE[0030000000jEJ`0>UF/00<0>UF/
0P0000020=@m6@0403iK]`000000?U^g0=@m6@80?U^g00<000000?m>800mFJ/00P3oCR0010000000
odhP03eIZ`0mFJ/2000000D0oddP00<000000?m=803oCB000`3oCB000`000000oddP0?m=80040?m=
800303eIZ`3oCB00oddP0080oddP0`0000050?m<7`0303eIZ`000000od`O00H0od`O00<000000?m<
7`3oC1l00`3oC1l0100mFJ/0od`O0?m<7`0000080?m:7P030000003oBQh0odXN0080?EV[103oBQh0
10000000odXN0?m:7P3oBQh2000000<0odPM00<000000?m87@3oB1d00P0mFJ/40?m87@030000000m
FJ/0?EV[00<0odPM0`0000080?ofkP80?EV[00<0ooK^03eIZ`0mFJ/0203om^h303eIZ`040?ofkP0m
FJ/0?EV[0?ofkP80e3dI0`3om^h00`3D?AT0ooK^0?ofkP060?ofkP80e3dI4P3om^h2000003/0ooK^
00<000000?ofkP3om^h04`3om^h10?ooo`005@3om^h00`000000ooK^0?ofkP0h0?ofkP030000003o
m^h0ooK^0140ooK^00<0?EV[0?ofkP3om^h01`3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00D0ooK^
0P3D?AT0100mFJ/0e3dI0=@m6@3D?AT70?ofkP0403eIZ`3D?AT0e3dI0?ofkP80e3dI1P3om^h00`00
0000;3j202`nPP0502`nPP80e3dI00<0;3j20=@m6@3D?AT0100/?X8010000000;3j2000000000006
0357TP030000000aAi80<DNB00<0<DNB0P3D?AT00`0aAi8000000357TP040357TP80000000<0=TjP
0000003D?AT01P0fCZ000`000000=TjP03I>X00503I>X0040000000fCZ00e3dI0=@m6@<0=TjP00<0
000003YE[00jEJ`00`0jEJ`00`3D?AT0>UF/0000000503YE[0030000000jEJ`0>UF/00<0>UF/00<0
000003YE[00jEJ`00`0jEJ`010000000?U^g03iK]`0nFkL20=@m6@0503iK]`3D?AT0?U^g03iK]`00
00000P3oCR00100mFJ/0odhP03eIZ`0mFJ/30?m>80030000003oCB00oddP00<0oddP00<000000?m=
803oCB000`3oCB000`000000oddP0?m=80030?m=80030000003oCB00?EV[00D0oddP00@000000?m<
7`3oC1l0od`O0P0mFJ/00`000000od`O0?m<7`060?m<7`030000003oC1l0od`O00@0od`O00<0?EV[
0000003oC1l00P0000050?m:7P040000003oBQh0?EV[03eIZ`D0odXN00<000000?m:7P3oBQh0103o
BQh3000000D0odPM0P0mFJ/00`3oB1d0?EV[03eIZ`070?m87@030000003om^h0ooK^00@0ooK^1@0m
FJ/00`3D?AT0ooK^0?ofkP050?ofkP<0?EV[00<0e3dI03eIZ`0mFJ/01@3om^h0103D?AT0ooK^0?of
kP3D?AT:0?ofkP030=@m6@3om^h0ooK^0140ooK^00<000000?ofkP3om^h0>03om^h00`000000ooK^
0?ofkP0C0?ofkP40oooo000D0?ofkP030000003om^h0ooK^03L0ooK^0P00000D0?ofkP0303eIZ`3o
m^h0ooK^00L0ooK^00@0?EV[0?ofkP3om^h0?EV[203om^h60=@m6@@0ooK^00@0?EV[0?ofkP3om^h0
?EV[0P3D?AT00`3om^h0e3dI0=@m6@050?ofkP030000000/?X80;3j200D0;3j20P3D?AT702`nPP03
0000000aAi80<DNB00L0<DNB00<000000357TP0aAi80100aAi820=@m6@050000000aAi80<DNB0357
TP0000000`0fCZ000`3D?AT0=TjP03I>X00603I>X0030000000fCZ00=TjP00D0=TjP00<0000003I>
X00fCZ000P3D?AT00`000000>UF/0000000403YE[0030=@m6@0jEJ`0000000H0>UF/00<0000003YE
[00jEJ`00`0jEJ`00`000000>UF/03YE[003000000@0?U^g00<000000=@m6@0nFkL00P0nFkL01P00
0000odhP0?m>803oCR00?EV[000000@0odhP0`0000020?m=80030000003oCB00oddP00<0oddP00<0
00000?m=803oCB00103oCB000`000000oddP03eIZ`040?m=80030000003oCB0000000080?EV[0P3o
C1l00`000000od`O0?m<7`050?m<7`030000003oC1l0od`O00H0od`O00D0?EV[0?m<7`3oC1l0od`O
000000030?m:7P030000000mFJ/0?EV[00H0odXN00<000000?m:7P3oBQh01`3oBQh00`000000odPM
0?m87@050?m87@80?EV[1`3oB1d00`000000ooK^0?ofkP030?ofkP80?EV[00@0ooK^03eIZ`0mFJ/0
e3dI0P3om^h00`3D?AT0ooK^0?ofkP020?ofkPH0?EV[203om^h0103D?AT0ooK^0?ofkP3D?AT90?of
kP030=@m6@3om^h0ooK^0180ooK^0P00000h0?ofkP030000003om^h0ooK^01<0ooK^0@3oool001@0
ooK^00<000000?ofkP3om^h0=P3om^h00`000000ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^00P0
ooK^0`0mFJ/90?ofkP0303eIZ`3om^h0e3dI00D0e3dI0P0mFJ/40?ofkP050=@m6@3om^h0e3dI0=@m
6@3om^h00P3D?AT30?ofkP030000000/?X80;3j20080;3j20`3D?AT0100/?X8000000=@m6@3D?AT3
02`nPP80000000<0<DNB0000000aAi801`0aAi800`000000<DNB0357TP060357TP80e3dI0P000002
03I>X080e3dI00<0=TjP0000000fCZ001P0fCZ000`000000=TjP03I>X00503I>X0050000000fCZ00
00000000000jEJ`00P3D?AT01@000000>UF/03YE[00jEJ`0e3dI0080>UF/00<0000003YE[00jEJ`0
100jEJ`00`000000>UF/03YE[00303YE[0<000000P0nFkL00`000000?U^g03iK]`0203iK]`070=@m
6@0nFkL0e3dI0=@m6@0nFkL000000?m>800203eIZ`030?m>800mFJ/0odhP00<0odhP00<000000?m>
803oCR000`0000050?m=80030000003oCB00oddP00<0oddP00D000000?m=803oCB00oddP03eIZ`03
0?m=80040000000mFJ/0?EV[0?m=8080000000<0e3dI0?m<7`3oC1l01P3oC1l00`000000od`O0?m<
7`050?m<7`040000003oC1l0?EV[03eIZ`80od`O0P00000203eIZ`L0odXN00<000000?m:7P3oBQh0
1`3oBQh010000000odXN0000000000030?m87@80?EV[00<000000?m87@0mFJ/00P0mFJ/40?m87@04
0000003om^h0ooK^0?ofkP80?EV[00D0ooK^03eIZ`0mFJ/0?EV[0=@m6@040?ofkP80e3dI1P0mFJ/0
0`3om^h0e3dI0?ofkP080?ofkP<0e3dI2P3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030000003om^h0
ooK^03H0ooK^00<000000?ofkP3om^h04P3om^h10?ooo`00503om^h00`000000ooK^0?ofkP0e0?of
kP030000003om^h0ooK^01@0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP090?of
kP0403eIZ`3om^h0ooK^0?ofkPH0e3dI103om^h0100mFJ/0e3dI0?ofkP3om^h20=@m6@030?ofkP3D
?AT0e3dI0080ooK^00@0000002`nPP3D?AT0e3dI1@0/?X801@000000;3j20=@m6@3D?AT0000000@0
<DNB00<000000357TP0aAi801P0aAi800`000000<DNB0357TP060357TP050000003D?AT0e3dI03I>
X03D?AT0100fCZ000`000000=TjP03I>X00503I>X0030000000fCZ00=TjP00D0=TjP00<0000003YE
[00jEJ`00`0jEJ`20=@m6@0303YE[03D?AT0>UF/00<0>UF/00<0000003YE[00jEJ`00`0jEJ`00`00
0000>UF/03YE[00203YE[0800000100nFkL01P000000?U^g03iK]`0nFkL0e3dI000000<0?U^g00<0
e3dI0000000mFJ/00`3oCR000`000000?EV[0?m>80020?m>80030000003oCR00odhP0080odhP0P00
00040?m=80030000003oCB00oddP00<0oddP00<000000?m=803oCB000P3oCB00100mFJ/0oddP03eI
Z`0mFJ/50?m=80030000003oC1l0od`O00D0od`O00<000000?m<7`3oC1l01@3oC1l00`000000od`O
0?m<7`020?m<7`0503eIZ`3oC1l0?EV[03eIZ`000000203oBQh00`000000odXN0?m:7P060?m:7P03
0000003oBQh0odXN0080odXN00D0000003eIZ`0mFJ/0odPM000000050?m87@80?EV[00@0odPM0000
003om^h0ooK^0P0mFJ/00`3om^h0?EV[03eIZ`020?ofkP0303eIZ`3D?AT0ooK^00<0ooK^1P0mFJ/3
0?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP0D
0?ofkP030000003om^h0ooK^03D0ooK^00<000000?ofkP3om^h04P3om^h10?ooo`00503om^h00`00
0000ooK^0?ofkP0c0?ofkP8000005`3om^h00`0mFJ/0ooK^0?ofkP060?ofkP<0?EV[2`3om^h00`0m
FJ/0ooK^0?ofkP030?ofkPH0e3dI0P3om^h00`0mFJ/0e3dI0?ofkP030?ofkP80e3dI00<0ooK^0=@m
6@3D?AT00P3D?AT702`nPP040000000/?X80000000000080e3dI0`0aAi800`000000<DNB0357TP07
0357TP030000000aAi80<DNB00<0<DNB0P000000100fCZ00000003I>X03D?AT503I>X0030000000f
CZ00=TjP00H0=TjP00<0000003I>X00fCZ000P0fCZ020000000303YE[0000000>UF/00@0>UF/00<0
00000=@m6@0jEJ`0100jEJ`00`000000>UF/03YE[00403YE[0060000000jEJ`000000000000nFkL0
00001@0nFkL01@000000?U^g0=@m6@0nFkL0000000@0?U^g00D000000?m>803oCR00odhP00000002
0?m>800303eIZ`3oCR00000000D0odhP00H000000?m>8000000000000?m=800000060?m=80030000
003oCB00oddP00<0oddP00<0?EV[0000003oCB00103oCB0010000000oddP0000000000040?m<7`03
0000003oC1l0od`O00H0od`O00<000000?m<7`3oC1l00`3oC1l0100mFJ/0od`O0000003oC1l20000
00D0odXN00<000000?m:7P3oBQh01`3oBQh010000000odXN0?m:7P3oBQh203eIZ`80000000<0odPM
0000003oB1d01P3oB1d403eIZ`030?ofkP0mFJ/0?EV[00<0ooK^00<0?EV[0?ofkP3D?AT00P3om^h6
03eIZ`D0ooK^00<0e3dI0?ofkP3om^h02@3om^h30=@m6@P0ooK^00<0e3dI0?ofkP3om^h05@3om^h2
000003D0ooK^00<000000?ofkP3om^h04P3om^h10?ooo`00503om^h00`000000ooK^0?ofkP0b0?of
kP030000003om^h0ooK^01L0ooK^00<0?EV[0?ofkP3om^h0103om^h203eIZ`80ooK^00<0?EV[0?of
kP3om^h02@3om^h0100mFJ/0ooK^0?ofkP3om^h203eIZ`80ooK^1P3D?AT0100mFJ/0ooK^0=@m6@3o
m^h60=@m6@030?ofkP3D?AT0e3dI00P0;3j200<000000357TP0aAi800P0aAi820=@m6@80<DNB00<0
00000357TP0aAi801`0aAi801@000000<DNB0357TP0aAi80000000<0=TjP0P3D?AT00`0fCZ00e3dI
0=@m6@0403I>X0030000000fCZ00=TjP00D0=TjP00<0000003I>X00fCZ000P00000303YE[0030000
000jEJ`0>UF/00<0>UF/00@0e3dI0000003D?AT0e3dI100jEJ`00`000000>UF/03YE[00303YE[080
00000`0nFkL00`000000?U^g03iK]`0303iK]`030000003D?AT0?U^g0080?U^g00D0000003iK]`0n
FkL0?U^g000000030?m>80060000003oCR00odhP0?m>800mFJ/00000103oCR000`000000odhP0?m>
80020?m>808000001@3oCB000`000000oddP0?m=80020?m=8080?EV[00<0000003eIZ`3oCB00103o
CB0010000000oddP0?m=803oCB0200000080od`O00<000000?m<7`3oC1l01@3oC1l00`000000od`O
0?m<7`020?m<7`80?EV[00<0od`O03eIZ`0mFJ/00`3oC1l01@000000odXN0?m:7P3oBQh0000000T0
odXN00<000000?m:7P3oBQh00P0mFJ/40?m:7P030000003oB1d0odPM00H0odPM0P0mFJ/00`3om^h0
?EV[03eIZ`0403eIZ`040?ofkP0mFJ/0ooK^0=@m6@H0?EV[0P3om^h20=@m6@<0ooK^00<0e3dI0?of
kP3om^h02@3om^h00`3D?AT0ooK^0?ofkP020=@m6@H0ooK^00<0e3dI0?ofkP3om^h05`3om^h00`00
0000ooK^0?ofkP0b0?ofkP030000003om^h0ooK^0180ooK^0@3oool001<0ooK^00<000000?ofkP3o
m^h0<@3om^h2000001T0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP020?ofkP03
03eIZ`3om^h0ooK^00T0ooK^00@0?EV[0?ofkP3om^h0?EV[1P3om^h80=@m6@D0ooK^0P3D?AT00`3o
m^h000000=@m6@0502`nPP80000000<0<DNB0000000aAi80100aAi820=@m6@030357TP000000<DNB
00L0<DNB00@000000357TP00000000000P0fCZ020=@m6@0303I>X0000000=TjP0080=TjP0P3D?AT2
03I>X0030000000fCZ00=TjP00H0=TjP0P00000603YE[0070000000jEJ`0>UF/03YE[03D?AT0>UF/
0000000203YE[080e3dI0P0jEJ`010000000>UF/03YE[00jEJ`3000000D0?U^g00<0000003iK]`0n
FkL00P0nFkL00`3D?AT0?U^g03iK]`0203iK]`050000000nFkL0?U^g03iK]`0000000`3oCR000`00
0000odhP0?m>80020?m>800303eIZ`3oCR00odhP0080odhP00<000000?m>803oCR000`3oCR030000
00<0oddP00<000000?m=803oCB000P0mFJ/20?m=80030000003oCB00?EV[00<0oddP00<000000?m=
803oCB00103oCB02000000P0od`O00<000000?m<7`3oC1l00P0mFJ/30?m<7`040000003oC1l0?EV[
03eIZ`80od`O0P0000000`3oBQh000000?m:7P040?m:7P050=@m6@3oBQh0odXN0000003oBQh00P0m
FJ/50?m:7P040000003oBQh00000000000D0odPM00<0?EV[0000003om^h00P0mFJ/50?ofkPP0?EV[
1P3om^h0103D?AT0ooK^0?ofkP3D?AT;0?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3o
m^h0103om^h00`3D?AT0ooK^0?ofkP0G0?ofkP800000<`3om^h00`000000ooK^0?ofkP0A0?ofkP40
oooo000C0?ofkP030000003om^h0ooK^0300ooK^00<000000?ofkP3om^h06@3om^h00`0mFJ/0ooK^
0?ofkP020?ofkP80?EV[1@3om^h00`0mFJ/0ooK^0?ofkP090?ofkP<0?EV[2@3om^h60=@m6@L0ooK^
0P3D?AT0100mFJ/0;3j202`nPP0/?X82000000@0<DNB00<000000357TP0aAi80100aAi820=@m6@03
0000000aAi80<DNB00H0<DNB00D0000003I>X00fCZ00=TjP0=@m6@0403I>X0030000000fCZ00=TjP
0080=TjP0P3D?AT00`0fCZ00000003I>X00403I>X080000000<0>UF/0000000jEJ`01@0jEJ`0100m
FJ/000000=@m6@3D?AT303YE[0050000000jEJ`0>UF/03YE[03D?AT00P0jEJ`3000000<0?U^g00<0
000003iK]`0nFkL00P0nFkL01P000000?U^g03iK]`0nFkL0e3dI000000@0?U^g00D0000003iK]`0n
FkL0?U^g000000030?m>80030000003oCR00odhP0080odhP00<0000003eIZ`3oCR000P3oCR000`00
0000odhP0?m>80020?m>80040000003oCR00odhP0?m>80<000000P3oCB001@0mFJ/0oddP0?m=803o
CB00000000<0oddP0P0mFJ/00`000000e3dI0?m=80050?m=80040000003oCB000000000000D0od`O
00D000000?m<7`0mFJ/0?EV[0=@m6@030?m<7`030000003oC1l0od`O0080od`O00D0?EV[0?m<7`3o
C1l0od`O000000080?m:7P030000000mFJ/0?EV[00H0odXN00<000000?m:7P3oBQh00P3oBQh20000
00<0odPM00<0e3dI03eIZ`0mFJ/01`3om^h603eIZ`T0ooK^0`3D?AT;0?ofkP030=@m6@3om^h0ooK^
00<0ooK^0P3D?AT40?ofkP030=@m6@3om^h0ooK^01T0ooK^00<000000?ofkP3om^h0<03om^h00`00
0000ooK^0?ofkP0A0?ofkP40oooo000C0?ofkP030000003om^h0ooK^02h0ooK^0P00000L0?ofkP05
03eIZ`3om^h0ooK^0?ofkP0mFJ/01`3om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^
00/0ooK^00<0e3dI03eIZ`3D?AT00`3D?AT40?ofkP80?EV[00<0ooK^0=@m6@3D?AT00P0000070357
TP030000000aAi80<DNB00D0<DNB0P3D?AT50357TP80000000@0=TjP0000003D?AT0e3dI1P0fCZ00
0`000000=TjP03I>X00303I>X080e3dI00D0000003I>X00fCZ00=TjP0000000303YE[0030000000j
EJ`0>UF/00D0>UF/00<0e3dI03YE[00jEJ`00`0jEJ`00`000000>UF/03YE[00203YE[080e3dI00<0
000003iK]`0nFkL00`0nFkL00`000000?U^g03iK]`0203iK]`060000000nFkL0?U^g03iK]`3D?AT0
0000100nFkL01@000000?U^g03iK]`0nFkL0000000<0odhP00<000000?m>803oCR000P3oCR000`00
0000?EV[0?m>80020?m>80030000003oCR00odhP0080odhP00<000000?m>803oCR000`3oCR000`00
0000?EV[03eIZ`040?m=80030000003oCB00oddP00<0oddP00<0?EV[0?m=803oCB001@3oCB001@00
0000oddP0?m=803oCB00000000<0od`O00<0000003eIZ`0mFJ/01@3oC1l00`000000od`O0?m<7`04
0?m<7`80?EV[00@000000?m<7`00000000001@3oBQh203eIZ`L0odXN00<000000?m:7P3oBQh01@3o
BQh200000080?EV[00<0ooK^0=@m6@3D?AT0103om^h403eIZ`030=@m6@0mFJ/0ooK^00`0ooK^00<0
e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP050?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT0
703om^h200000300ooK^00<000000?ofkP3om^h04@3om^h10?ooo`004`3om^h00`000000ooK^0?of
kP0]0?ofkP030000003om^h0ooK^01`0ooK^00@0?EV[0?ofkP0mFJ/0?EV[203om^h00`0mFJ/0ooK^
0?ofkP070?ofkP<0?EV[3P3om^h20=@m6@030?ofkP3D?AT0e3dI0080e3dI0P0mFJ/40?ofkP030000
003D?AT0e3dI00P0<DNB00<000000357TP0aAi801@0aAi800`000000e3dI0=@m6@020357TP030000
000fCZ00=TjP0080e3dI00<0000003I>X00fCZ001P0fCZ000`000000=TjP03I>X00403I>X0040=@m
6@0fCZ000000000000D0>UF/00<0000003YE[00jEJ`00`0jEJ`00`3D?AT0>UF/0000000503YE[004
0000000jEJ`0>UF/03YE[08000000P3D?AT503iK]`050000000nFkL0?U^g03iK]`0000000P0nFkL0
0`3D?AT0?U^g0000000403iK]`050000000nFkL0?U^g03iK]`0000000`3oCR000`000000odhP0?m>
80020?m>80050000003oCR00?EV[0?m>80000000103oCR000`000000odhP0?m>80030?m>8080?EV[
0P0000030?m=80030000003oCB00oddP00<0oddP00<000000?m=800mFJ/01@3oCB000`000000oddP
0?m=80030?m=8080000000<0od`O03eIZ`3oC1l01@3oC1l00`000000od`O0?m<7`060?m<7`030000
000mFJ/0?EV[0080od`O00<000000?m:7P3oBQh00P0mFJ/00`000000odXN0?m:7P050?m:7P030000
003oBQh0odXN00H0odXN0P0mFJ/00`000000ooK^0?ofkP020?ofkP80e3dI100mFJ/00`3om^h0?EV[
03eIZ`0>0?ofkP<0e3dI2@3om^h00`3D?AT0ooK^0?ofkP060?ofkP80e3dI00<0ooK^0=@m6@3om^h0
7@3om^h00`000000ooK^0?ofkP0]0?ofkP030000003om^h0ooK^0140ooK^0@3oool001<0ooK^00<0
00000?ofkP3om^h0;03om^h00`000000ooK^0?ofkP0L0?ofkP<0?EV[2@3om^h00`0mFJ/0ooK^0?of
kP060?ofkP80?EV[0P3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0503eIZ`3om^h0e3dI0=@m6@3om^h0
103D?AT50?ofkP040000000aAi80e3dI0=@m6@H0<DNB00<000000357TP0aAi801P0aAi801@000000
<DNB0=@m6@3D?AT0=TjP0080e3dI0`0fCZ000`000000=TjP03I>X00603I>X0030000000fCZ00=TjP
00@0=TjP0P3D?AT703YE[0050000000jEJ`0>UF/03YE[03D?AT00P0jEJ`00`000000>UF/03YE[003
03YE[0040000000jEJ`00000000000<0?U^g00<000000=@m6@3D?AT00`0nFkL00`000000?U^g03iK
]`0203iK]`030000003D?AT0?U^g0080?U^g00H0000003iK]`0nFkL0?U^g0000000nFkL500000003
0?m>80000000odhP0080odhP00H000000?m>803oCR00odhP03eIZ`0000040?m>80040000003oCR00
odhP0?m>8080?EV[00@000000?m>803oCR00odhP0P0000000`3oCB0000000?m=80040?m=80040000
003oCB00oddP03eIZ`<0oddP00<000000?m=803oCB001@3oCB0203eIZ`H0od`O00<000000?m<7`3o
C1l01P3oC1l010000000od`O0?m<7`3oC1l203eIZ`050?m<7`0mFJ/0?EV[0?m:7P000000203oBQh0
0`000000odXN0?m:7P040?m:7P80?EV[00<0odXN0000003om^h0103om^h403eIZ`050?ofkP0mFJ/0
?EV[0?ofkP3D?AT03P3om^h00`3D?AT0ooK^0?ofkP020=@m6@P0ooK^00<0e3dI0?ofkP3om^h01`3o
m^h30=@m6Ah0ooK^00<000000?ofkP3om^h0;03om^h00`000000ooK^0?ofkP0A0?ofkP40oooo000B
0?ofkP030000003om^h0ooK^02/0ooK^0P00000O0?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[
0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[
0?ofkP3om^h0103D?AT00`3om^h0e3dI0=@m6@040?ofkP030000000aAi80<DNB0080e3dI1@0aAi80
0`000000<DNB0357TP060357TP040000000fCZ00e3dI0=@m6@H0=TjP00<0000003I>X00fCZ001@0f
CZ000`000000=TjP03I>X00203I>X080000000@0>UF/0000003D?AT0e3dI1P0jEJ`00`000000>UF/
0=@m6@0403YE[0030000000jEJ`0>UF/00<0>UF/00<0000003iK]`0nFkL00`0nFkL010000000?U^g
03iK]`3D?AT203iK]`030000000nFkL0?U^g0080?U^g00<0e3dI03iK]`0nFkL00P0nFkL010000000
?U^g03iK]`0nFkL200000080@V7200<000000?m>8@3oCR400P0000030?m>80030000003oCR00odhP
0080odhP00<0?EV[0?m>803oCR000P3oCR001P000000odhP0?m>800mFJ/0odhP000000H0odhP00<0
00000?m=803oCB000`3oCB000`000000oddP0?m=80020?m=800303eIZ`3oCB00000000H0oddP0P0m
FJ/010000000oddP0000000000040?m<7`030000003oC1l0od`O00D0od`O00<000000?m<7`3oC1l0
103oC1l203eIZ`030?m<7`000000odXN00L0odXN00<000000?m:7P3oBQh00`3oBQh203eIZ`80odXN
00<000000?ofkP3om^h00P3om^h203eIZ`030?ofkP0mFJ/0?EV[0080?EV[0P3om^h00`3D?AT0ooK^
0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^
0?ofkP090?ofkP030=@m6@3om^h0ooK^01d0ooK^0P00000]0?ofkP030000003om^h0ooK^0100ooK^
0@3oool00180ooK^00<000000?ofkP3om^h0:P3om^h00`000000ooK^0?ofkP0O0?ofkP0303eIZ`3o
m^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h00`3om^h203eIZ`H0ooK^00<0?EV[0?ofkP3om^h0303o
m^h303eIZ`80ooK^103D?AT00`3om^h0e3dI0=@m6@030?ofkP040000000aAi80<DNB0357TP80e3dI
100aAi800`000000<DNB0357TP030357TP040000003D?AT0e3dI0=@m6@80=TjP0P3D?AT403I>X003
0000000fCZ00=TjP00H0=TjP00@0000003I>X00000000000100jEJ`010000000>UF/0=@m6@3D?AT4
03YE[080e3dI1P0jEJ`01`000000>UF/03YE[00jEJ`0000003iK]`0000001@0nFkL00`000000?U^g
03iK]`020=@m6@0603iK]`000000?U^g03iK]`3D?AT00000100nFkL00`000000?U^g000000020000
00<0@V7200@000000?m>8@3oCR40odhQ0`0000000`3oCR0000000?m>80030?m>80060000000mFJ/0
odhP0?m>80000000odhP0P0mFJ/20?m>80030000003oCR00odhP00<0odhP00<000000?m>80000000
0`3oCB000`000000oddP0?m=80040?m=8080?EV[103oCB0203eIZ`030?m=80000000oddP00<0oddP
0P0000000`3oC1l000000?m<7`070?m<7`030000003oC1l0od`O0080od`O0P0mFJ/20?m<7`<0?EV[
00<000000?m:7P3oBQh00`3oBQh00`000000odXN0?m:7P020?m:7P80?EV[0`3oBQh010000000ooK^
0?ofkP3om^h203eIZ`030?ofkP0mFJ/0?EV[0080?EV[0P3om^h30=@m6@h0ooK^00<0e3dI0?ofkP3o
m^h0103om^h20=@m6@D0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP0O0?ofkP03
0000003om^h0ooK^02X0ooK^00<000000?ofkP3om^h0403om^h10?ooo`004P3om^h00`000000ooK^
0?ofkP0X0?ofkP8000008P3om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^0080ooK^
00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00@0ooK^
103D?AT00`3om^h0e3dI0=@m6@020?ofkP030000003D?AT0<DNB0080<DNB0P3D?AT30357TP040000
000aAi80<DNB00000080e3dI0`0fCZ0010000000=TjP03I>X00fCZ020=@m6@<0=TjP00<0000003I>
X00fCZ001P0fCZ000`000000>UF/03YE[00503YE[0030000000jEJ`0>UF/0080e3dI00@0>UF/0=@m
6@0jEJ`000001P0jEJ`010000000>UF/00000000000203iK]`030000000nFkL0?U^g00<0?U^g00<0
000003iK]`0nFkL00P0nFkL20=@m6@0403iK]`3D?AT0?U^g000000@0?U^g0P000002049Q`P050000
0012HL80@V72049Q`P0000000`3oCR400`000000odhQ0?m>8@02000000<0odhP00D000000?m>803o
CR00?EV[0?m>800203eIZ`<0odhP00<000000?m>803oCR00103oCR000`000000odhP0?m>80020000
00030?m=80000000oddP00D0oddP00@000000?m=800mFJ/0oddP0P0mFJ/20?m=80030000003oCB00
oddP00D0oddP00<000000?m<7`3oC1l01P3oC1l010000000od`O0?m<7`3oC1l203eIZ`<0od`O00@0
00000?m<7`3oC1l0od`O0P0mFJ/010000000odXN0?m:7P0000030?m:7P80?EV[0`3oBQh0100mFJ/0
00000?ofkP3om^h203eIZ`030?ofkP0mFJ/0?EV[0080?EV[1P3om^h00`3D?AT0ooK^0?ofkP0<0?of
kP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP090?of
kP030=@m6@3om^h0ooK^0200ooK^0P00000Z0?ofkP030000003om^h0ooK^0100ooK^0@3oool00180
ooK^00<000000?ofkP3om^h09`3om^h00`000000ooK^0?ofkP0R0?ofkP0303eIZ`3om^h0ooK^00T0
ooK^00<0?EV[0?ofkP3om^h00P0mFJ/90?ofkP0303eIZ`3om^h0ooK^00X0ooK^0`0mFJ/70?ofkPD0
e3dI00D0ooK^0=@m6@3D?AT0ooK^0=@m6@050357TP80e3dI0P0aAi830=@m6@H0=TjP00<0000003I>
X00fCZ000P0fCZ020=@m6@80=TjP00<0000003I>X00fCZ000`0fCZ020000000303YE[0000000>UF/
00H0>UF/00D0000003YE[00jEJ`0>UF/0=@m6@0303YE[0030000000jEJ`0>UF/00@0>UF/00<00000
03iK]`0nFkL00`0nFkL00`000000?U^g03iK]`0303iK]`030000000nFkL0?U^g0080?U^g00<00000
0=@m6@0nFkL00P0nFkL00`000000?U^g00000002000000<0@V7200D00000049Q`P12HL80@V720000
00030?m>8@040000003oCR40odhQ0?m>8@<0000000<0odhP0000003oCR000P3oCR000`0mFJ/00000
0?m>80030?m>80030000003oCR00odhP00<0odhP00<000000?m>803oCR000`3oCR000`000000oddP
0?m=80040?m=80050000003oCB00oddP0?m=800mFJ/00`3oCB000`000000oddP0?m=80050?m=8004
0000003oCB000000000000D0od`O00<000000?m<7`3oC1l00P0mFJ/40?m<7`030000003oC1l0od`O
00@0od`O0`0mFJ/20?m:7P80?EV[103oBQh00`0mFJ/000000?ofkP0203eIZ`030?ofkP0mFJ/0?EV[
00<0?EV[1`3om^h30=@m6@`0ooK^00<0e3dI0?ofkP3om^h01`3om^h20=@m6@80ooK^00<0e3dI0?of
kP3om^h02@3om^h00`3D?AT0ooK^0?ofkP0R0?ofkP030000003om^h0ooK^02L0ooK^00<000000?of
kP3om^h0403om^h10?ooo`004@3om^h00`000000ooK^0?ofkP0V0?ofkP8000009@3om^h00`0mFJ/0
ooK^0?ofkP090?ofkP<0?EV[2`3om^h00`0mFJ/0ooK^0?ofkP090?ofkP0503eIZ`3om^h0ooK^0?of
kP0mFJ/0203om^h50=@m6@040?ofkP3D?AT0e3dI03eIZ`80<DNB1P3D?AT00`0mFJ/0000003I>X007
03I>X0030000000fCZ00=TjP00<0=TjP0P3D?AT0100fCZ00000003I>X00fCZ02000000@0>UF/00<0
000003YE[00jEJ`01@0jEJ`010000000e3dI0=@m6@0jEJ`20=@m6@80>UF/00@0000003YE[00jEJ`0
>UF/0P0000000`0nFkL0?EV[03iK]`0403iK]`030000000nFkL0?U^g0080?U^g00<0000003iK]`0n
FkL00P0nFkL01@3D?AT000000=@m6@3D?AT0?U^g008000000P12HL801@000000@V72049Q`P12HL80
000000<0@V7200D000000?m>8@3oCR40odhQ000000030?m>8@030000003oCR40odhQ0080000000D0
odhP03eIZ`0mFJ/0000003eIZ`030?m>80030000003oCR00odhP00<0odhP00<000000?m>803oCR00
0`3oCR0010000000odhP0000000000030?m=80030000003oCB00oddP0080?EV[00@0oddP03eIZ`0m
FJ/000001`3oCB000`000000oddP0?m=80020?m=808000000P3oC1l010000000od`O03eIZ`0mFJ/5
0?m<7`030000003oC1l0od`O00H0od`O00<000000?m<7`0mFJ/01@0mFJ/20?m:7P<0?EV[00<0ooK^
03eIZ`0mFJ/00`0mFJ/80?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT02P3om^h00`3D?AT0ooK^0?of
kP0:0?ofkP<0e3dI2`3om^h00`3D?AT0ooK^0?ofkP0S0?ofkP800000:03om^h00`000000ooK^0?of
kP0?0?ofkP40oooo000A0?ofkP030000003om^h0ooK^02D0ooK^00<000000?ofkP3om^h09@3om^h0
0`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h01P3om^h2
03eIZ`@0ooK^00<0?EV[0?ofkP3om^h0203om^h90=@m6@<0<DNB00H0000003I>X03D?AT0e3dI03I>
X000000803I>X0030000000fCZ00=TjP00@0=TjP00@0e3dI03I>X000000000001`0jEJ`00`000000
>UF/03YE[00303YE[080e3dI00<0000003YE[00jEJ`00P0jEJ`20=@m6@040000000jEJ`000000000
00@0?U^g00<0000003iK]`0nFkL00P0nFkL00`000000?U^g03iK]`0303iK]`060000000nFkL0e3dI
0=@m6@0nFkL000000P0nFkL20=@m6@@0@V7200@00000049Q`P12HL8000000`12HL801@000000odhQ
0?m>8@3oCR4000000080odhQ00<000000?m>8@3oCR400P3oCR4203eIZ`80odhP00H000000?m>800m
FJ/0?EV[0?m>800000050?m>80030000003oCR00odhP0080odhP00<000000?m>803oCR000P3oCR02
000000040?m=80000000?EV[03eIZ`@0oddP00<0000003eIZ`0mFJ/01@3oCB000`000000oddP0?m=
80050?m=8080000000<0od`O03eIZ`3oC1l01@3oC1l00`000000od`O0?m<7`060?m<7`060000003o
C1l0?EV[03eIZ`3oC1l000000`3oBQh903eIZ`X0ooK^00<0e3dI0?ofkP3om^h00P3om^h20=@m6@P0
ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^02D0
ooK^00<000000?ofkP3om^h09@3om^h00`000000ooK^0?ofkP0?0?ofkP40oooo000A0?ofkP030000
003om^h0ooK^02@0ooK^00<000000?ofkP3om^h09P3om^h00`0mFJ/0ooK^0?ofkP070?ofkP<0?EV[
3P3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h0
2P3om^h40=@m6@0403eIZ`3om^h0e3dI0=@m6@800000100fCZ020=@m6@030000000fCZ00=TjP00H0
=TjP00<0000003I>X00fCZ00100fCZ020=@m6@030000000jEJ`0>UF/00H0>UF/00D0000003YE[00j
EJ`0>UF/0=@m6@0303YE[0030000000jEJ`0>UF/00<0>UF/0P3D?AT603iK]`030000000nFkL0?U^g
00<0?U^g00<0000003iK]`0nFkL00P0nFkL00`000000e3dI03iK]`0303iK]`8000000P12HL820=@m
6@80@V7200@00000049Q`P12HL8000000`12HL801@000000odhQ0?m>8@3oCR4000000080odhQ00<0
00000?m>8@3oCR400P0mFJ/20?m>8@800000103oCR000`0mFJ/0odhP0?m>80030?m>80030000003o
CR00odhP00<0odhP00<000000?m>803oCR00103oCR0203eIZ`D0oddP00D000000?m=803oCB00oddP
03eIZ`030?m=80030000003oCB00oddP00H0oddP00<0000003eIZ`0mFJ/01P3oC1l00`000000od`O
0?m<7`060?m<7`030000000mFJ/0?EV[00@0od`O0P00000203eIZ`030=@m6@3om^h0?EV[00<0?EV[
303om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h0
303om^h30=@m6@T0ooK^00<0e3dI0?ofkP3om^h09P3om^h00`000000ooK^0?ofkP0T0?ofkP030000
003om^h0ooK^00l0ooK^0@3oool00140ooK^00<000000?ofkP3om^h08P3om^h2000002T0ooK^00<0
?EV[0?ofkP3om^h01P3om^h0100mFJ/0ooK^0?ofkP0mFJ/>0?ofkP0303eIZ`3om^h0ooK^00@0ooK^
00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP@0e3dI00<0ooK^0=@m6@0fCZ00
1`0fCZ020=@m6@P0=TjP00@0000003I>X00fCZ00=TjP0P00000203YE[080e3dI00<0000003YE[00j
EJ`01@0jEJ`00`000000e3dI0=@m6@0503YE[0030000000jEJ`0>UF/008000000P0nFkL20=@m6@D0
?U^g00<0000003iK]`0nFkL00P0nFkL00`000000?U^g03iK]`0203iK]`030=@m6@000000?U^g00<0
?U^g00H00000049Q`P12HL80@V7200000012HL820=@m6@0500000012HL80@V72049Q`P0000000P12
HL8010000000odhQ0?m>8@0000030?m>8@050000000mFJ/0?EV[0?m>8@0000000`3oCR400`000000
odhP0?m>80020?m>80030000000mFJ/0odhP00<0odhP00<000000?m>803oCR000P3oCR000`000000
odhP0?m>80030?m>8080?EV[0P3oCR0200000080oddP00<000000?m=803oCB000`3oCB0203eIZ`03
0000003oCB00oddP00D0oddP00<0000003eIZ`0mFJ/00P3oCB02000000<0od`O00<000000?m<7`3o
C1l01P3oC1l203eIZ`P0od`O00<0?EV[0?ofkP0mFJ/00`0mFJ/=0?ofkP030=@m6@3om^h0ooK^00H0
ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP0<0?ofkP040=@m6@3om^h0ooK^0=@m
6@P0ooK^00<0e3dI0?ofkP3om^h09`3om^h2000002@0ooK^00<000000?ofkP3om^h03`3om^h10?oo
o`004@3om^h00`000000ooK^0?ofkP0Q0?ofkP030000003om^h0ooK^02T0ooK^00<0?EV[0?ofkP3o
m^h0103om^h203eIZ`@0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP020?ofkP80
?EV[2@3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkPD0e3dI00<0000003I>X00fCZ001P0fCZ020=@m6@L0
=TjP00<0000003I>X00000001P0jEJ`20=@m6@D0>UF/0P3D?AT00`0jEJ`0000003YE[00503YE[080
00001@0nFkL00`000000e3dI0=@m6@0403iK]`030000000nFkL0?U^g0080?U^g00H0000003iK]`0n
FkL0e3dI03iK]`00000203iK]`<000000`12HL8010000000@V72049Q`P12HL820=@m6@80@V7200@0
0000049Q`P12HL8000000P3oCR400`000000odhQ0?m>8@0203eIZ`<0odhQ00D000000?m>8@3oCR40
00000?m>8@02000000050?m>80000000odhP0?m>800mFJ/00P3oCR000`000000odhP0?m>80020?m>
80030000003oCR00odhP0080odhP0P0mFJ/00`000000odhP0?m>80030?m>808000001P3oCB001000
0000oddP03eIZ`0mFJ/50?m=8080?EV[1P3oCB000`000000od`O000000070?m<7`80?EV[203oC1l0
0`000000?EV[03eIZ`0303eIZ`l0ooK^00<0e3dI0?ofkP3om^h01`3om^h20=@m6@@0ooK^00<0e3dI
0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP020?ofkP80e3dI1P3om^h00`3D?AT0ooK^0?ofkP0Y
0?ofkP030000003om^h0ooK^0240ooK^00<000000?ofkP3om^h03`3om^h10?ooo`00403om^h00`00
0000ooK^0?ofkP0P0?ofkP800000;03om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^
00@0ooK^00<0?EV[0?ofkP3om^h0303om^h0100mFJ/0ooK^0?ofkP0mFJ/;0?ofkP0303eIZ`3om^h0
ooK^00`0ooK^0P0mFJ/00`3om^h0e3dI0=@m6@020=@m6@030000000fCZ00=TjP00L0=TjP00<0e3dI
03I>X00fCZ001@0fCZ000`000000>UF/03YE[00703YE[080e3dI00<0>UF/0=@m6@3D?AT0100jEJ`0
0`000000>UF/03YE[00203YE[0030000000nFkL0000000H0?U^g00@0000003iK]`3D?AT0e3dI0`0n
FkL00`000000?U^g03iK]`0203iK]`030000003D?AT0?U^g0080?U^g0P000003049Q`P0500000012
HL80@V72049Q`P0000000`12HL8010000000e3dI0=@m6@000002049Q`P040000003oCR40odhQ0000
0080?EV[00D000000?m>8@3oCR40odhQ000000030?m>8@040000003oCR40odhQ0?m>8@8000000`3o
CR000`0mFJ/000000?m>80030?m>80040000003oCR00odhP0?m>8080?EV[00<0odhP0000003oCR00
1@3oCR000`000000odhP000000040?m=80030000003oCB00oddP0080oddP0P0mFJ/00`3oCB00?EV[
03eIZ`090?m=80030000003oC1l0od`O00D0od`O00<0?EV[0?m<7`3oC1l01`3oC1l00`000000?EV[
03eIZ`0203eIZ`030?ofkP3D?AT0e3dI00h0ooK^00<0e3dI0?ofkP3om^h02@3om^h0103D?AT0ooK^
0?ofkP3D?AT>0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0
ooK^0?ofkP0Z0?ofkP8000008P3om^h00`000000ooK^0?ofkP0>0?ofkP40oooo000@0?ofkP030000
003om^h0ooK^01l0ooK^00<000000?ofkP3om^h0;03om^h0100mFJ/0ooK^0?ofkP3om^h203eIZ`L0
ooK^00<0?EV[0?ofkP3om^h0303om^h303eIZ`d0ooK^00<0?EV[0?ofkP3om^h02P3om^h01P0mFJ/0
ooK^0?ofkP3om^h0?EV[0?ofkP@0e3dI2@0fCZ020=@m6@<0=TjP0P0000000`0jEJ`0000000000008
03YE[080e3dI1`0jEJ`010000000>UF/00000000000303iK]`030000000nFkL0?U^g00@0?U^g00<0
000003iK]`0nFkL00P3D?AT203iK]`030000000nFkL0?U^g0080e3dI0P0nFkL200000003049Q`P00
0000@V720080@V7200D00000049Q`P12HL80@V7200000003049Q`P0300000012HL80@V720080e3dI
00<0@V720000003oCR400P0mFJ/20?m>8@050000003oCR40odhQ0?m>8@0000000P3oCR400`000000
odhQ0?m>8@020?m>8@040000003oCR40000000000080odhP0P0mFJ/20?m>80030000003oCR00odhP
0080?EV[0P3oCR000`000000odhP0?m>80040?m>80040000003oCR00odhP0?m>8080000000<0oddP
0000003oCB001P3oCB0203eIZ`P0oddP0P0000000`3oCB000000000000030?m<7`80?EV[2@3oC1l4
03eIZ`030?ofkP3D?AT0ooK^0080ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP0;
0?ofkP<0e3dI3P3om^h00`3D?AT0ooK^0?ofkP050?ofkP80e3dI0`3om^h00`3D?AT0ooK^0?ofkP0/
0?ofkP030000003om^h0ooK^01l0ooK^00<000000?ofkP3om^h03P3om^h10?ooo`00403om^h00`00
0000ooK^0?ofkP0M0?ofkP800000;`3om^h0100mFJ/0ooK^0?ofkP0mFJ/90?ofkP0303eIZ`3om^h0
ooK^00`0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP080?ofkP80?EV[1@3om^h0
0`0mFJ/0ooK^0?ofkP040=@m6@P0=TjP00@000000=@m6@3D?AT000001@0jEJ`00`000000>UF/03YE
[00203YE[0<0e3dI00@0>UF/0000003D?AT0e3dI1P0jEJ`00`000000?U^g03iK]`0403iK]`030000
000nFkL0?U^g00@0?U^g00@0000003iK]`0nFkL0?U^g0P3D?AT00`000000?U^g0=@m6@0203iK]`80
00000`12HL800`000000@V72049Q`P02049Q`P0400000012HL80@V72000000<0@V7200@00000049Q
`P12HL8000000P12HL8010000000odhQ0?m>8@0000020?m>8@050000003oCR40odhQ0?m>8@000000
0P3oCR400`000000odhQ0?m>8@020?m>8@040000003oCR40odhQ0?m>8@8000000P3oCR000`0mFJ/0
odhP0000000203eIZ`<0odhP00<000000?m>803oCR00103oCR000`000000odhP0?m>80040?m>8003
0000003oCB00oddP00@0oddP0P0mFJ/00`000000oddP03eIZ`0203eIZ`@0oddP00<000000?m=803o
CB000`3oCB0010000000?EV[03eIZ`0000080?m<7`@0?EV[0P3om^h00`3D?AT0ooK^0?ofkP030?of
kP80e3dI2P3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?of
kP3om^h01`3om^h0103D?AT0ooK^0?ofkP3D?AT_0?ofkP8000007`3om^h00`000000ooK^0?ofkP0>
0?ofkP40oooo000@0?ofkP030000003om^h0ooK^01`0ooK^00<000000?ofkP3om^h0;`3om^h303eI
Z`X0ooK^00<0?EV[0?ofkP3om^h02P3om^h303eIZ`l0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0m
FJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^0080ooK^103D?AT703I>X0040000000jEJ`0e3dI
0=@m6@D0>UF/0P0000020=@m6@D0>UF/0P0000020=@m6@80>UF/0P0000000`0nFkL0000000000005
03iK]`030000000nFkL0?U^g00@0?U^g00<0000003iK]`0nFkL00P0nFkL20=@m6@0503iK]`000000
0000049Q`P0000001012HL801@000000@V72049Q`P12HL80000000<0@V7200@00000049Q`P12HL80
00000P12HL800`000000@V7200000002000000050?m>8@000000odhQ0?m>8@0000000P3oCR401000
0000odhQ0?m>8@0000040?m>8@030000003oCR40odhQ0080odhQ00D000000?m>8@00000000000?m>
800203eIZ`@0odhP00<000000?m>803oCR00103oCR000`000000odhP0?m>80030?m>8080000000<0
odhP0000000000000P3oCB0203eIZ`8000001@3oCB0203eIZ`8000001@3oCB0203eIZ`030?m=8000
0000od`O00H0od`O100mFJ/40?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h01`3o
m^h00`3D?AT0ooK^0?ofkP0=0?ofkP<0e3dI2`3om^h00`3D?AT0ooK^0?ofkP090?ofkP<0e3dI<@3o
m^h00`000000ooK^0?ofkP0L0?ofkP030000003om^h0ooK^00h0ooK^0@3oool000l0ooK^00<00000
0?ofkP3om^h0703om^h00`000000ooK^0?ofkP0`0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[
0?ofkP3om^h01`3om^h203eIZ`<0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP04
0?ofkP80?EV[2@3om^h00`0mFJ/0ooK^0?ofkP030?ofkP@0e3dI0`0fCZ020000000403YE[0000000
000003YE[080e3dI0P0jEJ`30=@m6@8000001`0jEJ`010000000>UF/0=@m6@3D?AT503iK]`030000
000nFkL0?U^g00<0?U^g0P00000503iK]`030000000nFkL0?U^g0080e3dI00<0?U^g0=@m6@3D?AT0
0`12HL801@000000@V72049Q`P12HL80000000@0@V7200@00000049Q`P12HL8000000`12HL801`00
0000@V72000000000000AFO<0000003oCR400P0000000`3oCR4000000?m>8@020?m>8@040000003o
CR40odhQ000000@0odhQ00D000000?m>8@3oCR40odhQ000000030?m>8@80?EV[00<0odhP03eIZ`0m
FJ/00P3oCR000`000000odhP0?m>80030?m>808000001@3oCR000`000000odhP0?m>80030?m>8080
?EV[00<0oddP0000003oCB001P3oCB02000000<0?EV[0P3oCB0203eIZ`040?m=8000000000000?m=
808000000`3oC1l403eIZ`D0ooK^00<0e3dI0?ofkP3om^h01`3om^h20=@m6@H0ooK^00<0e3dI0?of
kP3om^h03@3om^h0103D?AT0ooK^0?ofkP3om^h20=@m6@T0ooK^00<0e3dI0?ofkP3om^h02`3om^h0
0`3D?AT0ooK^0?ofkP0`0?ofkP030000003om^h0ooK^01`0ooK^00<000000?ofkP3om^h03@3om^h1
0?ooo`003`3om^h00`000000ooK^0?ofkP0J0?ofkP800000<`3om^h00`0mFJ/0ooK^0?ofkP0;0?of
kP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP0=0?of
kP0303eIZ`3om^h0ooK^0080ooK^0P0mFJ/;0?ofkP0303eIZ`3om^h0ooK^00D0ooK^3`3D?AT503YE
[0030000000jEJ`0>UF/00@0>UF/0P00000203iK]`80e3dI100nFkL00`000000?U^g03iK]`0403iK
]`030000000nFkL0?U^g00<0?U^g0P3D?AT01@0nFkL0000000000012HL8000000080e3dI0P12HL80
1@000000@V72049Q`P12HL80000000<0@V7200@00000049Q`P12HL8000000`12HL8300000080AFO<
00<000000?m>8@3oCR400`0000030?m>8@030000003oCR40000000@0odhQ00D000000?m>8@3oCR40
odhQ000000020?m>8@80?EV[00D000000?m>8@00000000000?m>800203eIZ`D0odhP00<000000?m>
803oCR00103oCR000`000000odhP0?m>80020?m>8080?EV[0P3oCR02000000H0oddP00<000000?m=
803oCB000`3oCB0?03eIZ`L0ooK^00<0e3dI0?ofkP3om^h02@3om^h20=@m6@@0ooK^00<0e3dI0?of
kP3om^h03@3om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?of
kP3om^h02`3om^h00`3D?AT0ooK^0?ofkP0a0?ofkP800000703om^h00`000000ooK^0?ofkP0=0?of
kP40oooo000?0?ofkP030000003om^h0ooK^01T0ooK^00<000000?ofkP3om^h0<`3om^h00`0mFJ/0
ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00@0ooK^0P0mFJ/60?ofkP0303eIZ`3om^h0ooK^00d0
ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0>0?ofkP0303eIZ`3om^h0ooK^00H0ooK^103D?AT603YE
[0040000000jEJ`0e3dI0=@m6@D0>UF/0P00000203YE[08000000P0nFkL200000080?U^g0P3D?AT3
03iK]`8000001@0nFkL01P000000?U^g03iK]`0nFkL0e3dI03iK]`8000001012HL800`000000@V72
0=@m6@02049Q`P0500000012HL80@V72049Q`P0000000`12HL801@000000@V72049Q`P000000@V72
0080000000D0AFO<00000015Il`0AFO<000000020?m>8@060000003oCR4000000000003oCR400000
0P3oCR401@000000odhQ0?m>8@3oCR40000000<0odhQ00H000000?m>8@3oCR40?EV[0?m>8@000004
0?m>8@80000000<0odhP03eIZ`3oCR000P3oCR000`000000odhP0?m>80030?m>808000000`3oCR02
03eIZ`80odhP0P0000020?m>808000000P3oCB02000000D0oddP0P0mFJ/00`3oCB0000000?m=8005
0?m=80@0?EV[203om^h00`3D?AT0ooK^0?ofkP0<0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT03`3o
m^h00`3D?AT0ooK^0?ofkP040?ofkP80e3dI1P3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3o
m^h0ooK^03<0ooK^00<000000?ofkP3om^h06@3om^h00`000000ooK^0?ofkP0=0?ofkP40oooo000?
0?ofkP030000003om^h0ooK^01L0ooK^0P00000f0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[
0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00d0ooK^0`0mFJ/?
0?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<000000=@m6@3D?AT00P3D?AT503YE[080000000<0>UF/
0=@m6@3D?AT01@0jEJ`2000000H0?U^g0P00000203iK]`80e3dI0`0nFkL00`000000?U^g03iK]`03
03iK]`030000003D?AT0e3dI0080000000<0@V7200000012HL801012HL801@000000@V720=@m6@3D
?AT0000000<0@V7200D00000049Q`P12HL80@V7200000002049Q`P80000000@0AFO<00000015Il`0
e3dI0P15Il`01`000000odhQ0000000mFJ/0odhQ0000003oCR400P0000000`3oCR4000000?m>8@03
0?m>8@050000003oCR40odhQ0?m>8@0000000P0mFJ/00`3oCR4000000?m>8@040?m>8@040000003o
CR40000000000080?EV[00<000000?m>803oCR000`3oCR0010000000odhP0?m>803oCR0203eIZ`80
odhP0P0000060?m>808000001@3oCB0203eIZ`030?m=80000000000000D0oddP100mFJ/00`000000
ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00d0ooK^0`3D?AT?0?ofkP030=@m6@3om^h0ooK^00L0
ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^03@0
ooK^0P00000I0?ofkP030000003om^h0ooK^00d0ooK^0@3oool000l0ooK^00<000000?ofkP3om^h0
5P3om^h00`000000ooK^0?ofkP0g0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h0
0P0mFJ/:0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h0403om^h00`0mFJ/0ooK^
0?ofkP080?ofkP80?EV[00<0>UF/0=@m6@3D?AT01@0jEJ`20000000303YE[03D?AT0e3dI0080>UF/
00@0000003iK]`00000000001`0nFkL010000000?U^g03iK]`0nFkL20=@m6@80?U^g00@0000003iK
]`0nFkL0?U^g0P3D?AT2000000@0@V720P000004049Q`P0300000012HL80@V720080e3dI0`12HL80
10000000@V72049Q`P12HL8300000080AFO<00/000000=@m6@15Il`0000004EWc0000000odhQ0000
003oCR40?EV[000000020?m>8@<0000000@0e3dI0?m>8@3oCR4000000`3oCR4203eIZ`80odhQ00<0
00000?m>8@3oCR400P3oCR42000000@0odhQ0P00000203eIZ`<0odhP00<000000?m>803oCR000P0m
FJ/30?m>80030000003oCR00odhP00D0odhP0P000000103oCR0000000?m=803oCB0203eIZ`030?m=
80000000000000D0oddP0P0mFJ/00`3oCB00e3dI0=@m6@0:0?ofkP030=@m6@3om^h0ooK^0100ooK^
00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP080?ofkP80e3dI0P3om^h00`3D?AT0ooK^
0?ofkP0;0?ofkP030=@m6@3om^h0ooK^03L0ooK^00<000000?ofkP3om^h05P3om^h00`000000ooK^
0?ofkP0=0?ofkP40oooo000>0?ofkP030000003om^h0ooK^01D0ooK^0P00000j0?ofkP0303eIZ`3o
m^h0ooK^00/0ooK^0`0mFJ/<0?ofkP0303eIZ`3om^h0ooK^00/0ooK^0P0mFJ/00`3om^h0?EV[0?of
kP0@0?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h00P0000000`0jEJ`0e3dI0=@m
6@0503YE[080000000<0>UF/0=@m6@3D?AT0100nFkL2000000H0?U^g0P00000303iK]`80e3dI00@0
?U^g0000003D?AT0e3dI0P0000000`12HL80000000000005049Q`P0500000012HL80@V72049Q`P00
00001012HL801@3D?AT0@V72049Q`P000000@V7200<000001015Il`0403D?AT0000004EWc0000000
AFO<0000003oCR4000000?m>8@000000?EV[0?m>8@000000odhQ0000003oCR42000000050=@m6@00
0000odhQ0?m>8@0mFJ/0103oCR401@000000odhQ0?m>8@3oCR40000000D0odhQ0P0000000`3oCR40
00000000000203eIZ`040000003oCR00?EV[03eIZ`<0odhP0P0000060?m>80800000103oCR0203eI
Z`030?m=80000000000000D0oddP0P0mFJ/00`3oCB000000000000020?ofkP030=@m6@3om^h0ooK^
00L0ooK^00<0e3dI0?ofkP3om^h03`3om^h0103D?AT0ooK^0=@m6@3D?AT<0?ofkP030=@m6@3om^h0
ooK^00/0ooK^0`3D?AT=0?ofkP030=@m6@3om^h0ooK^03P0ooK^0P00000G0?ofkP030000003om^h0
ooK^00`0ooK^0@3oool000h0ooK^00<000000?ofkP3om^h0503om^h00`000000ooK^0?ofkP0j0?of
kP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP080?of
kP80?EV[0`3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0303eIZ`3om^h0ooK^00@0ooK^0P0mFJ/50?of
kP80000000<0>UF/0=@m6@3D?AT01@0jEJ`20000000303iK]`3D?AT0e3dI00@0?U^g0P00000603iK
]`8000000`0nFkL20=@m6@0303iK]`000000@V7200@0@V7200<00000049Q`P12HL800`12HL801@00
0000@V72049Q`P12HL80000000@0@V720P3D?AT00`12HL80000004EWc00204EWc00C00000015Il`0
00000=@m6@15Il`0000004EWc0000000AFO<0000003oCR4000000?m>8@000000odhQ03eIZ`000000
odhQ000000030?m>8@040000003oCR40?EV[03eIZ`@0odhQ00D000000?m>8@3oCR40odhQ00000005
0?m>8@030000003oCR40odhQ00<0odhQ00@000000?m>800mFJ/0?EV[0`3oCR02000000H0odhP0P00
00040?m>8080?EV[00<0odhP0000000000001@3oCB0203eIZ`030?m=80000000000000D0ooK^0P3D
?AT60?ofkP030=@m6@3om^h0ooK^0100ooK^00@0e3dI0?ofkP3om^h0ooK^0P3D?AT:0?ofkP030=@m
6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP0j0?ofkP030000
003om^h0ooK^01@0ooK^00<000000?ofkP3om^h0303om^h10?ooo`003P3om^h00`000000ooK^0?of
kP0C0?ofkP030000003om^h0ooK^03/0ooK^00<0?EV[0?ofkP3om^h02@3om^h303eIZ`l0ooK^00<0
?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0
?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP070?ofkP80000000<0>UF/0=@m6@3D?AT00P0j
EJ`00`000000?U^g03iK]`020000000303iK]`3D?AT0e3dI00@0?U^g0P00000603iK]`<0e3dI00@0
?U^g0000003D?AT0e3dI0P000004049Q`P0300000012HL80@V7200<0@V7200D00000049Q`P12HL80
@V7200000004049Q`P030000003D?AT0e3dI00<0AFO<00<000000=@m6@3D?AT00P15Il`02`000000
AFO<00000015Il`000000?m>8@000000odhQ0000003oCR4000000080?EV[0`3oCR401@000000?EV[
03eIZ`000000e3dI00<0odhQ00D000000?m>8@3oCR40odhQ000000050?m>8@030000003oCR40odhQ
0080odhQ0P00000203eIZ`030000003oCR00?EV[0080?EV[1P3oCR02000000@0odhP0P0mFJ/00`3o
CR000000000000020?m>80030000003oCB00oddP0080?EV[00<0oddP0000000000002@3om^h00`3D
?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D
?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00d0ooK^0`3D?AT;0?ofkP030=@m6@3om^h0ooK^
03/0ooK^00<000000?ofkP3om^h04`3om^h00`000000ooK^0?ofkP0<0?ofkP40oooo000>0?ofkP03
0000003om^h0ooK^0140ooK^0P00000n0?ofkP0303eIZ`3om^h0ooK^00L0ooK^0P0mFJ/30?ofkP03
03eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h0103om^h203eIZ`L0ooK^00<0?EV[0?ofkP3o
m^h0403om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00`0ooK^0P0000000`0jEJ`0e3dI0=@m6@0503iK
]`80000000<0?U^g0=@m6@3D?AT0100nFkL200000080?U^g0P3D?AT203iK]`8000000`12HL820=@m
6@8000000`12HL82000000@0@V720P000002049Q`P0800000012HL80000000000015Il`0000004EW
c03D?AT204EWc00I0=@m6@000000AFO<00000015Il`0000004EWc0000000AFO<0000003oCR400000
0?m>8@000000odhQ0000003oCR40000003eIZ`3oCR40000003eIZ`3oCR4000000?m>8@0200000004
0?m>8@000000odhQ0?m>8@800000103oCR42000000<0odhQ0P00000203eIZ`<0odhQ0P0000020?m>
8080?EV[0P3oCR02000000@0odhP0P0mFJ/00`3oCR000000000000050?m>8080?EV[00<0oddP0000
00000000303om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI0180ooK^00<0e3dI0?ofkP3om^h01@3om^h2
0=@m6@H0ooK^00<0e3dI0?ofkP3om^h03@3om^h0103D?AT0ooK^0?ofkP3om^h20=@m6@T0ooK^00<0
e3dI0?ofkP3om^h0?03om^h2000001<0ooK^00<000000?ofkP3om^h0303om^h10?ooo`003@3om^h0
0`000000ooK^0?ofkP0A0?ofkP030000003om^h0ooK^03h0ooK^00<0?EV[0?ofkP3om^h01P3om^h0
0`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h00`3om^h0
0`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00l0ooK^00@0?EV[0?ofkP0mFJ/0?EV[3`3o
m^h20000000303iK]`3D?AT0e3dI00D0?U^g0`0000020=@m6@<0?U^g0`3D?AT203iK]`8000000P12
HL82000000<0@V720P3D?AT00`000000@V72049Q`P02049Q`P0300000012HL80@V7200<0@V7200@0
0000049Q`P12HL8000001015Il`00`000000AFO<0=@m6@020=@m6@0800000015Il`0000004EWc000
0000AFO<00000015Il`200000080odhQ00D000000?m>8@00000000000?m>8@0303eIZ`030?m>8@00
0000odhQ00<0odhQ00@000000?m>8@3oCR4000001@3oCR400`000000odhQ0?m>8@020?m>8@030000
000mFJ/0?EV[00<0odhQ0P0000020?m>8@8000000P3oCR0303eIZ`<0odhP0P0mFJ/3000000D0odhP
0P0mFJ/00`3oCR0000000000000?0?ofkP80e3dI00<0ooK^0=@m6@3om^h0403om^h00`3D?AT0ooK^
0?ofkP080?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^
0?ofkP030?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h0?P3om^h00`000000ooK^
0?ofkP0@0?ofkP030000003om^h0ooK^00`0ooK^0@3oool000d0ooK^00<000000?ofkP3om^h03`3o
m^h200000440ooK^00<0?EV[0?ofkP3om^h0103om^h203eIZ`H0ooK^00<0?EV[0?ofkP3om^h03@3o
m^h0100mFJ/0ooK^0?ofkP3om^h203eIZ`/0ooK^00<0?EV[0?ofkP3om^h0403om^h00`0mFJ/0ooK^
0?ofkP0A0?ofkP<000003@3D?AT303iK]`8000001P12HL82000000<0@V7200<0e3dI000000000000
0`12HL800`000000@V72049Q`P03049Q`P80000000<0AFO<00000015Il`00`15Il`20=@m6@050000
0015Il`0e3dI0=@m6@15Il`00P00000204EWc0<000000P3oCR42000000050?m>8@0mFJ/0?EV[0?m>
8@0000000P0mFJ/40?m>8@050000003oCR4000000000003D?AT0103oCR4010000000odhQ0?m>8@3o
CR420000000403eIZ`3oCR40odhQ0?m>8@8000001P3oCR42000000<0odhP3@0mFJ/3000001<0ooK^
00<0e3dI0?ofkP3om^h0403om^h00`3D?AT0ooK^0?ofkP090?ofkP80e3dI0`3om^h00`3D?AT0ooK^
0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00@0ooK^0P3D?AT60?ofkP030=@m6@3om^h0ooK^03l0ooK^
0P00000A0?ofkP030000003om^h0ooK^00/0ooK^0@3oool000d0ooK^00<000000?ofkP3om^h03P3o
m^h00`000000ooK^0?ofkP120?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h01P3o
m^h00`0mFJ/0ooK^0?ofkP0>0?ofkP<0?EV[3P3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP80?EV[00<0
ooK^03eIZ`3om^h04`3om^h00`0mFJ/00000000000020=@m6@H0?U^g0P0000020=@m6@8000000P12
HL82000000H0@V720P000002049Q`P80e3dI0P000002049Q`P80000000D0@V72000000000000AFO<
0000000204EWc08000000P3D?AT01P000000AFO<04EWc0000000AFO<00000080e3dI00<0AFO<0000
0015Il`00`0000000`3oCR4000000?m>8@0203eIZ`80odhQ00@000000?m>8@000000odhQ0P0mFJ/2
000000040?m>8@00000000000?m>8@80000000<0e3dI0000000000000P3oCR4200000080?EV[0P3o
CR42000000H0odhQ0P0000020?m>8@8000000P0mFJ/2000000H0odhP0P0mFJ/2000000030=@m6@3o
m^h0ooK^0180ooK^00@0e3dI0?ofkP3D?AT0e3dI3`3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP<0e3dI
403om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h0
@P3om^h00`000000ooK^0?ofkP0>0?ofkP030000003om^h0ooK^00/0ooK^0@3oool000d0ooK^00<0
00000?ofkP3om^h0303om^h2000004D0ooK^00<0?EV[0?ofkP3om^h00P0mFJ/:0?ofkP0303eIZ`3o
m^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP80?EV[0`3o
m^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0503eIZ`00000000000000003D?AT01`0nFkL200000080e3dI
1012HL83000000D0@V720P000002049Q`P80e3dI0P000002049Q`P0300000015Il`0AFO<00<0AFO<
00@000000=@m6@3D?AT000000P15Il`02P000000AFO<04EWc0000000AFO<00000015Il`0e3dI0000
0015Il`3000000070?m>8@000000?EV[0?m>8@000000odhQ000000020?m>8@040000003oCR40odhQ
00000080?EV[00<000000?m>8@3oCR400P3oCR4200000080odhQ0P00000203eIZ`80odhQ0P000005
0?m>8@<00000103oCR4203eIZ`8000001`3oCR001@0mFJ/00000000000000000e3dI01D0ooK^00@0
e3dI0?ofkP3om^h0ooK^0P3D?AT<0?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h0
3@3om^h00`3D?AT0ooK^0?ofkP080?ofkP80e3dI0P3om^h00`3D?AT0ooK^0?ofkP130?ofkP800000
3P3om^h00`000000ooK^0?ofkP0;0?ofkP40oooo000=0?ofkP030000003om^h0ooK^00/0ooK^00<0
00000?ofkP3om^h0A@3om^h303eIZ``0ooK^00<0?EV[0?ofkP3om^h02`3om^h303eIZa40ooK^00<0
?EV[0?ofkP3om^h0203om^h203eIZ`H0ooK^00<0?EV[0?ofkP3om^h04P3om^h0100mFJ/0ooK^03eI
Z`0mFJ/4000000<0?U^g0P000002049Q`P030000003D?AT0e3dI00D0@V720P000005049Q`P800000
0P12HL820=@m6@8000000P15Il`00`000000AFO<04EWc0020=@m6@0400000015Il`0AFO<00000080
AFO<00H0000004EWc0000000AFO<00000015Il`:00000080odhQ00<000000?m>8@0000000P3oCR40
10000000odhQ0?m>8@00000203eIZ`030?m>8@00000000000080odhQ0P00000203eIZ`80odhQ0P00
00050?m>8@8000001@3oCR4203eIZ`030000003oCR40odhQ008000000`3oCR0400000080e3dI00<0
ooK^0=@m6@3om^h04`3om^h00`3D?AT0ooK^0?ofkP040?ofkP80e3dI2P3om^h00`3D?AT0ooK^0?of
kP0>0?ofkP040=@m6@3om^h0e3dI0=@m6@d0ooK^00<0e3dI0?ofkP3om^h02P3om^h30=@m6DL0ooK^
00<000000?ofkP3om^h02`3om^h00`000000ooK^0?ofkP0;0?ofkP40oooo000<0?ofkP030000003o
m^h0ooK^00/0ooK^00<000000?ofkP3om^h0AP3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3o
m^h0ooK^00X0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0A0?ofkP0303eIZ`3om^h0ooK^00H0ooK^
00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP0403eIZ`3om^h0ooK^0?ofkPL0
00001P12HL820=@m6@0300000012HL80@V720080@V720`000004049Q`P<0000000<0AFO<0=@m6@3D
?AT00P0000001015Il`0e3dI0=@m6@00000204EWc080000000P0AFO<000000000000AFO<00000015
Il`0000004EWc0<0000000D0B6cE00000000000000000?m=8003000000050?m>8@000000odhQ0000
003oCR400P0000000`3oCR400000000000020?m>8@040000000mFJ/0?EV[0?m>8@8000000P0mFJ/0
103oCR4000000000000000040?m>8@<00000103oCR400`000000?EV[03eIZ`060?m>8@D0000000<0
@fW80000003om^h00P3om^h00`3D?AT0ooK^0?ofkP0B0?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0
e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT0
303om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^04H0ooK^00<000000?ofkP3om^h0
2`3om^h00`000000ooK^0?ofkP0:0?ofkP40oooo000<0?ofkP030000003om^h0ooK^00T0ooK^0P00
00190?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h0203om^h203eIZ`@0ooK^00<0
?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP040?ofkP80?EV[2P3om^h00`0mFJ/0ooK^0?of
kP0@0?ofkP80?EV[00<0ooK^03eIZ`3om^h00`3om^h9000000@0@V720P3D?AT2000000@0@V720P00
0002049Q`P0300000015Il`0AFO<0080000000D0AFO<0=@m6@3D?AT0e3dI0000000204EWc0800000
0P15Il`01@000000AFO<04EWc0000000AFO<00<0000000<0B6cE0000000000001`0000001P3oCB00
0000000000000000odhQ00000080odhQ00<000000?m>8@3oCR400P0000020?m>8@040000000mFJ/0
?EV[03eIZ`<000000P3oCR400`000000odhQ0?m>8@02000000@0odhQ0P00000203eIZ`@0odhQ2@00
00040?ofkP040=@m6@3om^h0e3dI0=@m6A80ooK^00<0e3dI0?ofkP3om^h0203om^h20=@m6@H0ooK^
00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP030?ofkP80e3dI2P3om^h00`3D?AT0ooK^
0?ofkP0<0?ofkP030=@m6@3om^h0ooK^04L0ooK^0P00000;0?ofkP030000003om^h0ooK^00X0ooK^
0@3oool000`0ooK^00<000000?ofkP3om^h0203om^h00`000000ooK^0?ofkP1:0?ofkP0303eIZ`3o
m^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3o
m^h0ooK^00l0ooK^00@0?EV[0?ofkP3om^h0ooK^0P0mFJ/=0?ofkP0303eIZ`3om^h0ooK^00d0ooK^
0P0mFJ/40?ofkP0303eIZ`3om^h0ooK^00<0ooK^1P0000000`2m>aX000000000000200000080@V72
0P3D?AT3000000<0@V720P00000304EWc0<0e3dI0P0000020=@m6@<0000000@0AFO<000000000000
AFO<0P0000001@15Il`0000004Q/e@000000B6cE00/0000000D0oddP0000003oCB0000000?m>8@02
000000040?m>8@00000000000?m>8@<000000P0mFJ/2000000<0?EV[00<0odhQ0000000000000P00
00030?m>8@<000000P0mFJ/20?m>8@@000000P1:L]`5000000D0ooK^00<0e3dI0?ofkP3om^h00P3o
m^h20=@m6@l0ooK^00<0e3dI0?ofkP3om^h02`3om^h20=@m6@<0ooK^00<0e3dI0?ofkP3om^h03`3o
m^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h0303o
m^h00`3D?AT0ooK^0?ofkP1:0?ofkP030000003om^h0ooK^00P0ooK^00<000000?ofkP3om^h02P3o
m^h10?ooo`00303om^h00`000000ooK^0?ofkP060?ofkP800000C@3om^h00`0mFJ/0ooK^0?ofkP0<
0?ofkP0303eIZ`3om^h0ooK^00@0ooK^0P0mFJ/80?ofkP0303eIZ`3om^h0ooK^00l0ooK^00@0?EV[
0?ofkP0mFJ/0?EV[403om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0
?EV[0?ofkP3om^h00`3om^h9000000030;dk6P0000000000008000000P3D?AT00`12HL8000000000
00020000000404EWc03D?AT0e3dI0=@m6@8000000`15Il`2000000030=@m6@15Il`0AFO<00800000
00<0AFO<0000000000000P0000001@18K=D00000000000000000B6cE00D0000000D0oddP00000000
000000000?m=8003000000030?m=8000000000000080000000<0odhQ0000000000000P3oCR40100m
FJ/000000000003oCR44000000<0?EV[00<0odhQ0000000000000P0000000`3oCR40?EV[03eIZ`04
0000000304Ybg0000000000000L000001@3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0
ooK^00/0ooK^00<0e3dI0?ofkP3om^h03P3om^h20=@m6@030?ofkP3D?AT0ooK^00l0ooK^00<0e3dI
0?ofkP3om^h01`3om^h20=@m6@H0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP1;
0?ofkP800000203om^h00`000000ooK^0?ofkP0:0?ofkP40oooo000<0?ofkP030000003om^h0ooK^
00D0ooK^00<000000?ofkP3om^h0C@3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^
0080ooK^0P0mFJ/;0?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h04@3om^h00`0m
FJ/0ooK^0?ofkP080?ofkP80?EV[2@3om^h00`0mFJ/0ooK^0?ofkP040?ofkP80000000<0RBdD0000
000000001@0000020;dk6PD000000P15Il`5000000<0AFO<0`0000001@15Il`0e3dI0=@m6@000000
AFO<00<0000000D0B6cE000000000000000004Q/e@020000000304Q/e@000000000000D0000000@0
oddP000000000000oddP0`0000001P3oCB000000000000000000odhQ00000080?EV[100000030?m>
8@D000000P3oCR450000000304Ybg000000000000080000000D0BW;L000000000000000004=Yb002
000000H0ooK^00<0e3dI0?ofkP3om^h01`3om^h20=@m6@X0ooK^00<0e3dI0?ofkP3om^h04@3om^h0
0`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00T0ooK^0P3D?AT40?ofkP030=@m6@3om^h0
ooK^00`0ooK^00<0e3dI0?ofkP3om^h0C@3om^h00`000000ooK^0?ofkP050?ofkP030000003om^h0
ooK^00X0ooK^0@3oool000/0ooK^00<000000?ofkP3om^h0103om^h200000540ooK^00<0?EV[0?of
kP3om^h02`3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00d0ooK^00<0?EV[0?ofkP3om^h03@3om^h2
03eIZ`030?ofkP0mFJ/0ooK^0140ooK^00<0?EV[0?ofkP3om^h01P3om^h203eIZ``0ooK^00<0?EV[
0?ofkP3om^h0103om^h0100mFJ/0000000000029;A@80000000403eIZ`2m>aX000000=@m6@H00000
00<0AFO<0000000000001000000204EWc0030000003D?AT0000001h0000000<0?EV[0000003oCR40
0P3oCR45000000030?m>8@000000000000@0000000@0?EV[000000000000e3dI2000000204=Yb003
0000003D?AT0ooK^00D0ooK^00<0e3dI0?ofkP3om^h02P3om^h20=@m6@P0ooK^00<0e3dI0?ofkP3o
m^h0403om^h0103D?AT0ooK^0=@m6@3D?AT>0?ofkP030=@m6@3om^h0ooK^00`0ooK^00D0e3dI0?of
kP3om^h0ooK^0=@m6@0=0?ofkP030=@m6@3om^h0ooK^04l0ooK^0P0000060?ofkP030000003om^h0
ooK^00T0ooK^0@3oool000/0ooK^00<000000?ofkP3om^h00`3om^h00`000000ooK^0?ofkP1A0?of
kP0303eIZ`3om^h0ooK^00`0ooK^0`0mFJ/?0?ofkP0303eIZ`3om^h0ooK^00X0ooK^0P0mFJ/30?of
kP0303eIZ`3om^h0ooK^0140ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0<0?of
kP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h01`00000203eIZ`L000000`3SAAd60000
000304EWc0000000000002D000000P3oCR45000000H0C7CQ100000020=@m6@0304Ybg00000000000
00@000000P3om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?of
kP3om^h0103om^h00`3D?AT0ooK^0?ofkP0A0?ofkP040=@m6@3om^h0ooK^0?ofkP80e3dI303om^h0
0`3D?AT0ooK^0?ofkP0=0?ofkP<0e3dI3P3om^h00`3D?AT0ooK^0?ofkP1A0?ofkP030000003om^h0
ooK^00<0ooK^00<000000?ofkP3om^h02@3om^h10?ooo`002`3om^h00`000000ooK^0?ofkP020?of
kP030000003om^h0ooK^0580ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0?0?of
kP0303eIZ`3om^h0ooK^00P0ooK^0P0mFJ/60?ofkP0303eIZ`3om^h0ooK^0140ooK^00@0?EV[0?of
kP3om^h0ooK^0P0mFJ/@0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h00P3om^h3
00000080?EV[00<000000;dk6P0000003P0000000`3SAAd000000000000W0000000304adh@000000
000000d0000000@0BW;L0000003D?AT0e3dI0`0000040?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0
e3dI0?ofkP3om^h03P3om^h20=@m6@<0ooK^00<0e3dI0?ofkP3om^h04@3om^h00`3D?AT0ooK^0?of
kP040?ofkP80e3dI2@3om^h00`3D?AT0ooK^0?ofkP0@0?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0
e3dI0?ofkP3om^h0D`3om^h00`000000ooK^0?ofkP020?ofkP030000003om^h0ooK^00T0ooK^0@3o
ool000/0ooK^00<000000?ofkP3om^h00P00001F0?ofkP0303eIZ`3om^h0ooK^00T0ooK^0P0mFJ/0
0`3om^h0?EV[0?ofkP0@0?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h01`3om^h0
0`0mFJ/0ooK^0?ofkP0@0?ofkP0403eIZ`3om^h0?EV[03eIZa<0ooK^00<0?EV[0?ofkP3om^h00P3o
m^h00`0mFJ/0ooK^0?ofkP030?ofkP80?EV[0P0000000`29;A@0000000000002000000<0_C/J0`00
00000`0mFJ/000000000000_000000@0C7CQ00@0e3dI00000000000000001@1:L]`500000080e3dI
1@3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^0140ooK^0P3D?AT00`3om^h0e3dI
0?ofkP0A0?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^
0?ofkP0?0?ofkP040=@m6@3om^h0e3dI0=@m6@/0ooK^00<0e3dI0?ofkP3om^h0E03om^h200000080
ooK^00<000000?ofkP3om^h02@3om^h10?ooo`002P3om^h010000000ooK^0?ofkP00001H0?ofkP03
03eIZ`3om^h0ooK^00L0ooK^0P0mFJ/30?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3o
m^h0103om^h203eIZ`X0ooK^00<0?EV[0?ofkP3om^h04@3om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP05
03eIZ`3om^h0ooK^0?ofkP0mFJ/00`3om^h203eIZ`<0ooK^2`0000020;dk6P0303eIZ`3SAAd0hdDM
00<0hdDM100000000`0mFJ/000000000000M000000030=@m6@0000000000008000001@1<M>400`3D
?AT0BW;L0000000;000000<0ooK^0P3D?AT30?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT05P3om^h0
0`3D?AT0ooK^0?ofkP0A0?ofkP030=@m6@3om^h0ooK^00P0ooK^0P3D?AT50?ofkP030=@m6@3om^h0
ooK^0100ooK^00@0e3dI0?ofkP3om^h0ooK^0P3D?AT90?ofkP030=@m6@3om^h0ooK^05H0ooK^00@0
00000?ofkP3om^h000002P3om^h10?ooo`002P3om^h3000005X0ooK^00<0?EV[0?ofkP3om^h01@3o
m^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00l0ooK^00@0?EV[0?ofkP3om^h0ooK^
0P0mFJ/=0?ofkP0303eIZ`3om^h0ooK^00h0ooK^0P0mFJ/00`3om^h0?EV[0?ofkP0E0?ofkP0503eI
Z`3om^h0ooK^03eIZ`3om^h00P0mFJ/40?ofkP80?EV[00@0ooK^000000000000RBdD2@00000203eI
Z`D000000P0mFJ/Q00000080e3dI1@0000020=@m6@8000001@1:L]`200000080@fW800@000000?of
kP3D?AT0e3dI103om^h20=@m6@050?ofkP3D?AT0ooK^0?ofkP3D?AT05P3om^h0103D?AT0ooK^0=@m
6@3D?AT@0?ofkP030=@m6@3om^h0ooK^00/0ooK^0P3D?AT30?ofkP030=@m6@3om^h0ooK^00l0ooK^
00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^05P0ooK^
0`00000:0?ofkP40oooo000:0?ofkP800000F`3om^h00`0mFJ/0ooK^0?ofkP030?ofkP80?EV[1`3o
m^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0403eIZ`3om^h0?EV[03eIZa00ooK^00<0?EV[0?ofkP3om^h0
2`3om^h203eIZ`@0ooK^00<0?EV[0?ofkP3om^h0503om^h0100mFJ/0ooK^03eIZ`0mFJ/40?ofkP80
?EV[1@3om^h5000000<0_C/J100000000`0mFJ/000000000000203eIZ`8000001P3SAAd200000003
0?Q:7`000000000000d0000000<0Bg7M0000000000001000000204adh@8000000P3D?AT200000003
0=@m6@0000000000008000000`1:L]`5000000D0ooK^0P3D?AT40?ofkP80e3dI00<0ooK^0=@m6@3o
m^h05@3om^h00`3D?AT0ooK^0?ofkP020?ofkP80e3dI3@3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP<0
e3dI4P3om^h00`3D?AT0ooK^0?ofkP050?ofkP80e3dI1@3om^h00`3D?AT0ooK^0?ofkP1I0?ofkP80
00002P3om^h10?ooo`00303om^h2000005T0ooK^00@0?EV[0?ofkP3om^h0ooK^0P0mFJ/:0?ofkP03
03eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h04@3om^h00`0mFJ/0ooK^0?ofkP080?ofkP80
?EV[1`3om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP0303eIZ`3om^h0?EV[0080ooK^0P0mFJ/80?ofkP03
03eIZ`000000000000T000000P0mFJ/6000000D0hdDM0`0000000`3hBQl000000?Q:7`0400000006
04]ag@000000000004]ag@000000Bg7M1000000404adh@H000000P3D?AT;000000030=@m6@3om^h0
ooK^00H0ooK^0P3D?AT20?ofkP030=@m6@3om^h0e3dI01H0ooK^00<0e3dI0?ofkP3om^h01@3om^h2
0=@m6@X0ooK^00<0e3dI0?ofkP3om^h04@3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0
ooK^00P0ooK^0P3D?AT30?ofkP030=@m6@3om^h0ooK^05L0ooK^0P00000<0?ofkP40oooo000>0?of
kP800000F03om^h303eIZ`d0ooK^00<0?EV[0?ofkP3om^h0303om^h203eIZ`030?ofkP0mFJ/0ooK^
0140ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^
0140ooK^0P0mFJ/00`3om^h0?EV[03eIZ`0203eIZ`X0ooK^00<0?EV[0?ofkP0000001@0000020;dk
6P80?EV[00<0_C/J03eIZ`0mFJ/00P0000030>=57@D000000P3SAAd2000000030?Q:7`0000000000
00L0000000<0Bg7M0000000000000P1<M>45000000<0C7CQ0P0000020=@m6@0304Ybg03D?AT0e3dI
0080BW;L1P0000000`3D?AT0ooK^0?ofkP090?ofkP@0e3dI00<0ooK^0=@m6@3D?AT04`3om^h00`3D
?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h0403om^h0103D
?AT0ooK^0=@m6@3D?AT>0?ofkP030=@m6@3om^h0ooK^00/0ooK^0`3D?AUH0?ofkP8000003P3om^h1
0?ooo`00403om^h3000005D0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0:0?of
kP80?EV[0`3om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP0303eIZ`3om^h0ooK^00@0ooK^0P0mFJ/<0?of
kP0303eIZ`3om^h0ooK^00h0ooK^0P0mFJ/40?ofkP80?EV[303om^h00`0mFJ/0ooK^0?ofkP030000
000308T]500mFJ/0?EV[00D000000P0mFJ/3000000030>=57@000000000000<0hdDM0P0000001@3S
AAd00000000000000000n4XO00<0000000D0Bg7M000000000000000004adh@02000000<0C7CQ00<0
000004adh@1<M>400`0000020=@m6@D000000P3D?AT01013JLP000000000000000020?ofkP030=@m
6@3om^h0ooK^00X0ooK^0P3D?AT40?ofkP80e3dI403om^h00`3D?AT0ooK^0?ofkP0:0?ofkP80e3dI
1P3om^h00`3D?AT0ooK^0?ofkP0A0?ofkP040=@m6@3om^h0ooK^0?ofkP80e3dI303om^h00`3D?AT0
ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^05<0ooK^0`00000@0?ofkP40oooo000C0?ofkP800000
D`3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h0
103om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP0403eIZ`3om^h0ooK^0?ofkP80?EV[3`3om^h00`0mFJ/0
ooK^0?ofkP0;0?ofkP80?EV[1P3om^h0100mFJ/0ooK^03eIZ`0mFJ/:0?ofkP0303eIZ`3om^h0ooK^
0080ooK^0P0mFJ/4000000D0_C/J0P0mFJ/2000000<0hdDM0P0000020>=57@80000000<0?EV[0000
003hBQl00`0000000`1;LMd000000=@m6@0200000080C7CQ0P00000304adh@8000000P3D?AT504Yb
g0@000000P3D?AT40?ofkP030=@m6@3om^h0ooK^00P0ooK^0P3D?AT00`3om^h0e3dI0?ofkP050?of
kP80e3dI3@3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP80e3dI0`3om^h00`3D?AT0ooK^0?ofkP0A0?of
kP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP0=0?of
kP030=@m6@3om^h0ooK^0580ooK^0P00000C0?ofkP40oooo000E0?ofkP800000DP3om^h00`0mFJ/0
ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00D0ooK^0P0mFJ/80?ofkP0303eIZ`3om^h0ooK^0100
ooK^00@0?EV[0?ofkP0mFJ/0?EV[4P3om^h00`0mFJ/0ooK^0?ofkP080?ofkP80?EV[203om^h01@0m
FJ/0ooK^0?ofkP3om^h0?EV[00T0ooK^00<0?EV[0?ofkP3om^h0100mFJ/00`000000e3dI00000006
00000080_C/J0P0mFJ/300000080hdDM0P00000203eIZ`030>=57@000000000000D0000000<0C7CQ
0=@m6@3D?AT00P00000204adh@<000000P3D?AT204Ybg0T00000103D?AT20?ofkP030=@m6@3om^h0
ooK^00L0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@080?ofkP80e3dI2P3om^h00`3D?AT0ooK^0?of
kP0@0?ofkP80e3dI00<0ooK^0=@m6@3om^h04@3om^h00`3D?AT0ooK^0?ofkP060?ofkP80e3dI1`3o
m^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^0500ooK^0P00000E0?ofkP40oooo000G
0?ofkP<00000C`3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[
0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[
0?ofkP3om^h01@3om^h203eIZ`X0ooK^00<0?EV[0?ofkP3om^h00P3om^h203eIZ`L0ooK^1@0mFJ/4
0?ofkP<0000000<0RBdD0000000000000P2m>aX300000080?EV[00<000000>=57@0000000P0mFJ/0
0`000000hdDM000000020>=57@<000000P1<M>400`000000C7CQ000000020=@m6@030000001<M>40
00000080e3dI0`00000204Ybg0H00000103om^h50=@m6@L0ooK^0P3D?AT40?ofkP030=@m6@3om^h0
ooK^00P0ooK^0P3D?AT70?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h04@3om^h0
0`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h03@3om^h0
0`3D?AT0ooK^0?ofkP1>0?ofkP<000005`3om^h10?ooo`006P3om^h2000004h0ooK^00<0?EV[0?of
kP3om^h03P3om^h0100mFJ/0ooK^0?ofkP3om^h203eIZ``0ooK^00<0?EV[0?ofkP3om^h03P3om^h2
03eIZ`030?ofkP0mFJ/0ooK^01@0ooK^00<0?EV[0?ofkP3om^h00P3om^h203eIZ``0ooK^00<0?EV[
0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP030?ofkP@0?EV[203om^h6000000D0_C/J0`0mFJ/0
1@3SAAd0e3dI0000003SAAd000000080hdDM0`00000204adh@030000001<M>4000000080C7CQ0`3D
?AT504Ybg0H00000203om^h40=@m6@D0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?of
kP0:0?ofkP80e3dI103om^h00`3D?AT0ooK^0?ofkP0C0?ofkP040=@m6@3om^h0e3dI0=@m6A00ooK^
00<0e3dI0?ofkP3om^h02P3om^h20=@m6@<0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^
0?ofkP1<0?ofkP8000006P3om^h10?ooo`00703om^h2000004`0ooK^00<0?EV[0?ofkP3om^h03P3o
m^h0100mFJ/0ooK^03eIZ`0mFJ/?0?ofkP0303eIZ`3om^h0ooK^00/0ooK^0P0mFJ/40?ofkP0303eI
Z`3om^h0ooK^01<0ooK^00@0?EV[0?ofkP0mFJ/0?EV[3P3om^h00`0mFJ/0ooK^0?ofkP050?ofkP80
?EV[00D0ooK^03eIZ`0mFJ/0ooK^03eIZ`0;0?ofkP0403eIZ`000000000008T]508000000`2m>aX2
03eIZ`80_C/J0`0mFJ/020000000hdDM0>=57@000000hdDM0000001<M>4000000`1<M>430=@m6@80
BW;L0P3D?AT304Ybg080000000@0@fW8000000000000e3dI2`3om^h01@3D?AT0ooK^0=@m6@3D?AT0
ooK^0080e3dI1`3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP80e3dI00<0ooK^0=@m6@3om^h0503om^h0
0`3D?AT0ooK^0?ofkP020?ofkP80e3dI3@3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP80e3dI00<0ooK^
0=@m6@3om^h03P3om^h00`3D?AT0ooK^0?ofkP1;0?ofkP800000703om^h10?ooo`007P3om^h30000
04X0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0303eIZ`3om^h0ooK^
00P0ooK^0P0mFJ/70?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0m
FJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0?EV[0080?EV[2`3om^h00`0mFJ/0ooK^0?ofkP040000
0080?EV[0`2m>aX2000000030;dk6P000000?EV[0080?EV[00D000000>=57@000000C7CQ00000003
0=@m6@040000001:L]`00000000000<0BW;L0P3D?AT400000080ooK^00<0e3dI0?ofkP3om^h02@3o
m^h30=@m6@030?ofkP3D?AT0ooK^00L0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?of
kP0C0?ofkP030=@m6@3om^h0ooK^00D0ooK^0P3D?AT:0?ofkP030=@m6@3om^h0ooK^0100ooK^00<0
e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP180?ofkP<000007P3om^h10?ooo`008@3om^h2
000004P0ooK^00<0?EV[0?ofkP3om^h0303om^h203eIZ`030?ofkP0mFJ/0ooK^0100ooK^00<0?EV[
0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^0100ooK^0P0mFJ/0
0`3om^h0?EV[0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00@0ooK^1@0mFJ/00`3om^h0?EV[0?ofkP0:
0?ofkP0503eIZ`3om^h0ooK^03eIZ`0000000P0mFJ/208T]50<0000000@0e3dI0;dk6P2m>aX00000
0P2m>aX2000000030>=57@000000C7CQ008000000P1:L]`010000000BW;L04Ybg01:L]`300000080
@fW80P3D?AT00`000000e3dI0?ofkP020?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3D
?AT0103D?AT60?ofkP030=@m6@3om^h0ooK^00h0ooK^00@0e3dI0?ofkP3D?AT0e3dI4P3om^h00`3D
?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h03`3om^h0103D
?AT0ooK^0=@m6@3D?AT=0?ofkP030=@m6@3om^h0ooK^04L0ooK^0P00000Q0?ofkP40oooo000S0?of
kP800000A`3om^h00`0mFJ/0ooK^0?ofkP090?ofkP80?EV[0`3om^h00`0mFJ/0ooK^0?ofkP0@0?of
kP0303eIZ`3om^h0ooK^00@0ooK^0P0mFJ/<0?ofkP0303eIZ`3om^h0ooK^00d0ooK^0P0mFJ/40?of
kP80?EV[3P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP@0?EV[0`3om^h203eIZ`/0ooK^1@0mFJ/0103o
m^h0000000000000000208T]508000000P2m>aX01@000000_C/J0;dk6P000000_C/J00@000000`1:
L]`00`000000BW;L04Ybg00200000080@fW80`0000000`3om^h0e3dI0=@m6@020=@m6@030?ofkP3D
?AT0ooK^00T0ooK^0P3D?AT30?ofkP@0e3dI103om^h00`3D?AT0ooK^0?ofkP0<0?ofkP80e3dI103o
m^h20=@m6@l0ooK^00<0e3dI0?ofkP3om^h02P3om^h20=@m6@H0ooK^00<0e3dI0?ofkP3om^h0403o
m^h0103D?AT0ooK^0?ofkP3om^h20=@m6@/0ooK^00<0e3dI0?ofkP3om^h0A@3om^h2000002<0ooK^
0@3oool002D0ooK^0`0000140?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h0103o
m^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0403eIZ`3om^h0ooK^0?ofkP80?EV[3`3om^h00`0mFJ/0ooK^
0?ofkP0:0?ofkP80?EV[203om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0403eIZ`3om^h0ooK^0?ofkP<0
?EV[1@3om^h0100mFJ/0ooK^03eIZ`0mFJ/90?ofkP<0?EV[1P3om^h200000080RBdD0P0000030;dk
6P040000000mFJ/0?EV[00000080e3dI00@0000004Ybg01:L]`0BW;L0P00000204=Yb08000001P3o
m^h40=@m6@P0ooK^0P3D?AT00`3om^h0e3dI0?ofkP040?ofkP<0e3dI0`3om^h00`3D?AT0ooK^0?of
kP0;0?ofkP030=@m6@3om^h0ooK^00H0ooK^0P3D?AT<0?ofkP030=@m6@3om^h0ooK^00d0ooK^0P3D
?AT30?ofkP030=@m6@3om^h0ooK^0100ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?of
kP070?ofkP030=@m6@3om^h0ooK^04<0ooK^0`00000U0?ofkP40oooo000X0?ofkP800000@`3om^h0
0`0mFJ/0ooK^0?ofkP050?ofkP80?EV[203om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0403eIZ`3om^h0
?EV[03eIZa80ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3o
m^h0ooK^00X0ooK^00<0?EV[0?ofkP0mFJ/00P0mFJ/70?ofkP0403eIZ`3om^h0ooK^0?ofkP80?EV[
1@3om^h303eIZ`X0ooK^0`0000000`29;A@000000000000203eIZ`80_C/J00<0000004Ybg01:L]`0
0P3D?AT20000000404=Yb00000000000000000X0ooK^103D?AT40?ofkP80e3dI0`3om^h00`3D?AT0
ooK^0?ofkP050?ofkP<0e3dI00<0ooK^0=@m6@3om^h02`3om^h00`3D?AT0ooK^0?ofkP090?ofkP03
0=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h0403om^h20=@m6@030?ofkP3D?AT0ooK^0100
ooK^00<0e3dI0?ofkP3om^h01P3om^h20=@m6@L0ooK^00<0e3dI0?ofkP3om^h0@@3om^h2000002P0
ooK^0@3oool002X0ooK^0P0000110?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h0
203om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h0
1@3om^h203eIZ`d0ooK^0P0mFJ/:0?ofkP<0?EV[2@3om^h00`0mFJ/0ooK^0?ofkP030?ofkP80?EV[
00<0ooK^03eIZ`0mFJ/00P0mFJ/:0?ofkP<0?EV[00D000000=@m6@0mFJ/0?EV[000000030;dk6P05
0000001:L]`0BW;L04Ybg00000000P3D?AT2000000<0e3dI2`3om^h60=@m6@D0ooK^00<0e3dI0?of
kP3om^h01`3om^h30=@m6@X0ooK^0P3D?AT=0?ofkP80e3dI1`3om^h00`3D?AT0ooK^0?ofkP0C0?of
kP030=@m6@3om^h0ooK^0100ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP030?of
kP030=@m6@3om^h0ooK^0400ooK^0P00000Z0?ofkP40oooo000/0?ofkP<00000?`3om^h0100mFJ/0
ooK^0?ofkP3om^h203eIZ``0ooK^00<0?EV[0?ofkP3om^h03@3om^h203eIZ`030?ofkP0mFJ/0ooK^
01@0ooK^00<0?EV[0?ofkP3om^h00P3om^h203eIZa40ooK^00<0?EV[0?ofkP3om^h01P3om^h203eI
Z`/0ooK^00<0?EV[0?ofkP3om^h0103om^h403eIZ`030?ofkP0mFJ/0ooK^00T0ooK^00<0?EV[0?of
kP3om^h00P0mFJ/5000000030;dk6P000000BW;L00D000000P3D?AT20?ofkP030=@m6@3om^h0ooK^
00T0ooK^1P3D?AT50?ofkP030=@m6@3om^h0ooK^00T0ooK^0P3D?AT80?ofkP030=@m6@3om^h0ooK^
00l0ooK^0P3D?AT40?ofkP030=@m6@3om^h0ooK^01<0ooK^00@0e3dI0?ofkP3D?AT0e3dI3`3om^h0
0`3D?AT0ooK^0?ofkP0:0?ofkP80e3dI0`3om^h00`3D?AT0ooK^0?ofkP0m0?ofkP<00000;03om^h1
0?ooo`00;`3om^h2000003d0ooK^00@0?EV[0?ofkP0mFJ/0?EV[3`3om^h00`0mFJ/0ooK^0?ofkP0:
0?ofkP80?EV[103om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0403eIZ`3om^h0?EV[03eIZa@0ooK^00<0
?EV[0?ofkP3om^h00`3om^h203eIZ`030?ofkP0mFJ/0ooK^00X0ooK^00<0?EV[0?ofkP3om^h00P3o
m^h403eIZ`80ooK^100mFJ/60?ofkP80?EV[00<0ooK^03eIZ`0mFJ/0103om^h00`000000RBdD08T]
500300000080@fW800<000000?ofkP3om^h00P3om^h20=@m6@030?ofkP3D?AT0e3dI00H0ooK^103D
?AT20?ofkP80e3dI00<0ooK^0=@m6@3D?AT00`3om^h00`3D?AT0ooK^0?ofkP090?ofkP040=@m6@3o
m^h0e3dI0=@m6@D0ooK^00<0e3dI0?ofkP3om^h04P3om^h20=@m6@030?ofkP3D?AT0ooK^01@0ooK^
00<0e3dI0?ofkP3om^h00P3om^h20=@m6@`0ooK^00<0e3dI0?ofkP3om^h03@3om^h30=@m6Ch0ooK^
0P00000_0?ofkP40oooo000a0?ofkP<00000>`3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0303eIZ`3o
m^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3o
m^h0ooK^01D0ooK^0P0mFJ/00`3om^h0?EV[03eIZ`030?ofkP0303eIZ`3om^h0ooK^00P0ooK^00@0
?EV[0?ofkP3om^h0ooK^100mFJ/40?ofkP0403eIZ`3om^h0ooK^0?ofkPT0?EV[1@3om^h503eIZ`03
0000003D?AT0e3dI00<0e3dI1@3om^h20=@m6@030?ofkP3D?AT0e3dI00@0e3dI0`3om^h00`3D?AT0
ooK^0?ofkP020?ofkP80e3dI00<0ooK^0=@m6@3D?AT00P3om^h00`3D?AT0ooK^0?ofkP080?ofkP04
0=@m6@3om^h0ooK^0?ofkP80e3dI00<0ooK^0=@m6@3D?AT05`3om^h00`3D?AT0ooK^0?ofkP0C0?of
kP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP0@0?of
kP030=@m6@3om^h0ooK^03T0ooK^0`00000a0?ofkP40oooo000d0?ofkP800000>P3om^h00`0mFJ/0
ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00H0ooK^0P0mFJ/90?ofkP0303eIZ`3om^h0ooK^0100
ooK^0P0mFJ/00`3om^h0?EV[03eIZ`0F0?ofkP<0?EV[103om^h00`0mFJ/0ooK^0?ofkP080?ofkP03
03eIZ`3om^h0?EV[00<0?EV[1P3om^h00`0mFJ/0ooK^0?ofkP030?ofkQ00?EV[0`00000@0=@m6@H0
ooK^00<0e3dI0?ofkP3om^h00`3om^h20=@m6@040?ofkP3D?AT0e3dI0=@m6@X0ooK^00<0e3dI0?of
kP3om^h00P3om^h30=@m6AH0ooK^0P3D?AT00`3om^h0e3dI0=@m6@0B0?ofkP030=@m6@3om^h0ooK^
00L0ooK^0P3D?AT80?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h0>03om^h20000
03@0ooK^0@3oool003H0ooK^0P00000h0?ofkP0303eIZ`3om^h0ooK^0100ooK^00<0?EV[0?ofkP3o
m^h0103om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00d0ooK^0P0mFJ/50?ofkP03
03eIZ`3om^h0ooK^0140ooK^0P0mFJ/30?ofkP80?EV[0P3om^h00`0mFJ/0ooK^0?ofkP080?ofkP@0
?EV[1`3om^h00`0mFJ/0ooK^0?ofkP020?ofkP80?EV[00@0ooK^03eIZ`0mFJ/0?EV[103om^h703eI
Z`80ooK^00<000000?ofkP3om^h01`3D?AT40?ofkP<0e3dI00<0ooK^0=@m6@3D?AT0103om^h00`3D
?AT0ooK^0?ofkP050?ofkP80e3dI00<0ooK^0=@m6@3om^h02@3om^h00`3D?AT0ooK^0?ofkP020=@m
6@<0ooK^0P3D?ATC0?ofkP030=@m6@3om^h0ooK^00<0ooK^0P3D?AT?0?ofkP030=@m6@3om^h0ooK^
00X0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^
03L0ooK^0P00000f0?ofkP40oooo000h0?ofkP<00000=P3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP04
03eIZ`3om^h0ooK^0?ofkP80?EV[3P3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP80?EV[203om^h00`0m
FJ/0ooK^0?ofkP0>0?ofkP80?EV[1`3om^h303eIZ`P0ooK^100mFJ/90?ofkP0303eIZ`3om^h0ooK^
0080?EV[00D0ooK^03eIZ`0mFJ/0ooK^03eIZ`030?ofkP80?EV[00<0ooK^03eIZ`0mFJ/00P0mFJ/4
0?ofkP030000003om^h0ooK^0080ooK^103D?AT00`3om^h0e3dI0=@m6@030?ofkP050=@m6@3om^h0
e3dI0=@m6@3om^h00P3D?AT20?ofkP030=@m6@3om^h0ooK^00L0ooK^103D?AT80?ofkP<0e3dI1`3o
m^h20=@m6A00ooK^00<0e3dI0?ofkP3om^h01P3om^h20=@m6@`0ooK^00<0e3dI0?ofkP3om^h0303o
m^h20=@m6@<0ooK^00<0e3dI0?ofkP3om^h0403om^h00`3D?AT0ooK^0?ofkP0d0?ofkP<00000>03o
m^h10?ooo`00>`3om^h2000003D0ooK^00<0?EV[0?ofkP3om^h03`3om^h0100mFJ/0ooK^03eIZ`0m
FJ/A0?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h02@3om^h203eIZ``0ooK^0P0m
FJ/:0?ofkP@0?EV[103om^h403eIZ`X0ooK^00D0?EV[0?ofkP0mFJ/0?EV[0?ofkP0203eIZ`80ooK^
00<0?EV[0?ofkP3om^h00P0mFJ/00`3om^h0?EV[03eIZ`0203eIZ`H0ooK^00<000000?ofkP3om^h0
103om^h40=@m6@050?ofkP3D?AT0e3dI0?ofkP3D?AT00`3om^h20=@m6@050?ofkP3D?AT0e3dI0?of
kP3D?AT02P3om^h40=@m6@@0ooK^103D?AT:0?ofkP80e3dI303om^h20=@m6@/0ooK^00<0e3dI0?of
kP3om^h0203om^h00`3D?AT0ooK^0?ofkP0?0?ofkP80e3dI00<0ooK^0=@m6@3om^h0403om^h00`3D
?AT0ooK^0?ofkP0c0?ofkP800000>`3om^h10?ooo`00?@3om^h2000003@0ooK^00<0?EV[0?ofkP3o
m^h03`3om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^00D0ooK^0P0mFJ/>0?ofkP03
03eIZ`3om^h0ooK^00L0ooK^0P0mFJ/<0?ofkP0403eIZ`3om^h0ooK^0?ofkP80?EV[00H0ooK^03eI
Z`0mFJ/0?EV[0?ofkP0mFJ/:0?ofkP80?EV[00<0ooK^03eIZ`0mFJ/0103om^h303eIZ`030?ofkP0m
FJ/0?EV[0080?EV[203om^h00`000000ooK^0?ofkP060?ofkP@0e3dI00@0ooK^0=@m6@3D?AT0e3dI
103om^h20=@m6@030?ofkP3D?AT0e3dI00X0ooK^00<0e3dI0?ofkP3D?AT00P3D?AT00`3om^h0e3dI
0=@m6@030?ofkP030=@m6@3om^h0ooK^00X0ooK^0P3D?AT90?ofkP030=@m6@3om^h0ooK^00`0ooK^
0P3D?AT70?ofkP030=@m6@3om^h0ooK^0180ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^
0?ofkP0b0?ofkP800000?@3om^h10?ooo`00?`3om^h300000340ooK^00<0?EV[0?ofkP3om^h03@3o
m^h203eIZ`030?ofkP0mFJ/0ooK^01<0ooK^00<0?EV[0?ofkP3om^h00P3om^h203eIZa40ooK^00<0
?EV[0?ofkP3om^h0103om^h203eIZ`h0ooK^00<0?EV[0?ofkP3om^h00P3om^h403eIZ`80ooK^00<0
?EV[0?ofkP3om^h01P3om^h203eIZ`030?ofkP0mFJ/0?EV[00D0ooK^0P0mFJ/00`3om^h0?EV[03eI
Z`0203eIZ`X0ooK^00<000000?ofkP3om^h0203om^h40=@m6@030?ofkP3D?AT0e3dI00D0ooK^0P3D
?AT00`3om^h0e3dI0=@m6@080?ofkP030=@m6@3om^h0ooK^00@0e3dI103om^h00`3D?AT0ooK^0?of
kP0<0?ofkP80e3dI1P3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP80e3dI103om^h00`3D?AT0ooK^0?of
kP0B0?ofkP040=@m6@3om^h0e3dI0=@m6@h0ooK^00<0e3dI0?ofkP3om^h0<03om^h3000003l0ooK^
0@3oool00480ooK^0P00000`0?ofkP0303eIZ`3om^h0ooK^00X0ooK^0P0mFJ/40?ofkP0303eIZ`3o
m^h0ooK^0180ooK^00@0?EV[0?ofkP0mFJ/0?EV[503om^h203eIZ`80ooK^0P0mFJ/@0?ofkP0303eI
Z`3om^h0ooK^00@0?EV[0P3om^h403eIZ`D0ooK^0P0mFJ/00`3om^h0?EV[03eIZ`050?ofkP80?EV[
00<0ooK^03eIZ`0mFJ/00P0mFJ/<0?ofkP030000003om^h0ooK^00X0ooK^103D?AT00`3om^h0e3dI
0=@m6@050?ofkP80e3dI00<0ooK^0=@m6@3D?AT01@3om^h40=@m6@80ooK^103D?AT20?ofkP030=@m
6@3om^h0ooK^00h0ooK^0P3D?AT20?ofkP80e3dI503om^h20=@m6@030?ofkP3D?AT0ooK^01<0ooK^
00<0e3dI0?ofkP3om^h00P3om^h20=@m6@`0ooK^00<0e3dI0?ofkP3om^h0;P3om^h200000480ooK^
0@3oool004@0ooK^0P00000_0?ofkP0303eIZ`3om^h0ooK^00L0ooK^0P0mFJ/70?ofkP0303eIZ`3o
m^h0ooK^0180ooK^00<0?EV[0?ofkP3om^h05P3om^h203eIZa80ooK^1@0mFJ/50?ofkP0303eIZ`3o
m^h0ooK^00D0?EV[00<0ooK^03eIZ`0mFJ/01@3om^h703eIZ`h0ooK^00<000000?ofkP3om^h0303o
m^h70=@m6@D0ooK^0P3D?AT00`3om^h0e3dI0=@m6@030=@m6@80ooK^00<0e3dI0?ofkP3om^h00`3o
m^h50=@m6A80ooK^0P3D?ATH0?ofkP030=@m6@3om^h0ooK^0180ooK^00<0e3dI0?ofkP3om^h01@3o
m^h20=@m6@T0ooK^00<0e3dI0?ofkP3om^h0;@3om^h2000004@0ooK^0@3oool004H0ooK^0`00000]
0?ofkP0303eIZ`3om^h0ooK^00@0ooK^0P0mFJ/:0?ofkP0303eIZ`3om^h0ooK^00l0ooK^0P0mFJ/0
0`3om^h0?EV[03eIZ`0D0?ofkP80?EV[00<0ooK^03eIZ`0mFJ/04@3om^h303eIZ`L0ooK^00@0?EV[
0?ofkP3om^h0ooK^0P0mFJ/00`3om^h0?EV[03eIZ`0<03eIZa00ooK^00<000000?ofkP3om^h03P3o
m^h>0=@m6@030?ofkP3D?AT0e3dI00<0ooK^00<0e3dI0?ofkP3om^h01@3om^h30=@m6A40ooK^0P3D
?AT00`3om^h0e3dI0=@m6@0D0?ofkP80e3dI00<0ooK^0=@m6@3D?AT04@3om^h00`3D?AT0ooK^0?of
kP080?ofkP80e3dI1P3om^h00`3D?AT0ooK^0?ofkP0[0?ofkP<00000AP3om^h10?ooo`00B@3om^h2
000002/0ooK^00<0?EV[0?ofkP3om^h00P3om^h203eIZ`d0ooK^00<0?EV[0?ofkP3om^h0303om^h2
03eIZ`D0ooK^00<0?EV[0?ofkP3om^h03`3om^h203eIZ`D0ooK^0P0mFJ/>0?ofkP80?EV[2@3om^h0
100mFJ/0ooK^03eIZ`0mFJ/20?ofkP80?EV[00<0ooK^03eIZ`3om^h00P3om^h603eIZa80ooK^00<0
00000?ofkP3om^h0403om^h60=@m6@<0ooK^00@0e3dI0?ofkP3D?AT0e3dI0P3om^h20=@m6@030?of
kP3D?AT0ooK^00P0ooK^0P3D?AT>0?ofkP80e3dI1@3om^h20=@m6A40ooK^00<0e3dI0?ofkP3om^h0
0`3om^h20=@m6@h0ooK^00<0e3dI0?ofkP3om^h02`3om^h20=@m6@<0ooK^00<0e3dI0?ofkP3om^h0
:P3om^h2000004T0ooK^0@3oool004/0ooK^0P00000Z0?ofkP0403eIZ`3om^h0?EV[03eIZa00ooK^
00<0?EV[0?ofkP3om^h02@3om^h203eIZ`P0ooK^00<0?EV[0?ofkP3om^h0303om^h203eIZ`T0ooK^
0P0mFJ/:0?ofkP<0?EV[2@3om^h303eIZ`80ooK^0P0mFJ/30?ofkP0503eIZ`3om^h0ooK^03eIZ`3o
m^h00`0mFJ/D0?ofkP030000003om^h0ooK^0180ooK^0`3D?AT01@3om^h0e3dI0?ofkP3om^h0e3dI
00<0ooK^0P3D?AT20?ofkP<0e3dI2@3om^h30=@m6@X0ooK^0P3D?AT90?ofkP80e3dI3P3om^h00`3D
?AT0ooK^0?ofkP060?ofkP80e3dI2`3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP80e3dI00<0ooK^0=@m
6@3om^h0:@3om^h2000004/0ooK^0@3oool004d0ooK^0`00000X0?ofkP0303eIZ`3om^h0ooK^0140
ooK^00<0?EV[0?ofkP3om^h01P3om^h203eIZ`/0ooK^0P0mFJ/;0?ofkP0303eIZ`3om^h0ooK^00/0
ooK^0P0mFJ/60?ofkP80?EV[0P3om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^0080
?EV[103om^h00`0mFJ/0ooK^03eIZ`0403eIZaH0ooK^00<000000?ofkP3om^h0503om^h50=@m6@03
0?ofkP3D?AT0ooK^00<0ooK^0P3D?AT20?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3o
m^h00P3D?AT60?ofkP80e3dI3@3om^h00`3D?AT0ooK^0?ofkP090?ofkP80e3dI2`3om^h20=@m6@P0
ooK^00<0e3dI0?ofkP3om^h04@3om^h00`3D?AT0ooK^0?ofkP0V0?ofkP<00000C@3om^h10?ooo`00
D03om^h2000002L0ooK^00<0?EV[0?ofkP3om^h04@3om^h00`0mFJ/0ooK^0?ofkP030?ofkP80?EV[
3`3om^h00`0mFJ/0ooK^0?ofkP060?ofkP80?EV[403om^h203eIZ`80ooK^0P0mFJ/30?ofkP0303eI
Z`3om^h0ooK^00H0ooK^0P0mFJ/00`3om^h0?EV[03eIZ`060?ofkPD0?EV[603om^h00`000000ooK^
0?ofkP0F0?ofkPD0e3dI1P3om^h20=@m6@030?ofkP3D?AT0e3dI00P0ooK^00@0e3dI0?ofkP3om^h0
ooK^0P3D?AT20?ofkP80e3dI403om^h20=@m6@P0ooK^00<0e3dI0?ofkP3om^h03@3om^h20=@m6@D0
ooK^00<0e3dI0?ofkP3om^h04@3om^h00`3D?AT0ooK^0?ofkP0U0?ofkP800000D03om^h10?ooo`00
DP3om^h2000002H0ooK^00<0?EV[0?ofkP3om^h04@3om^h00`0mFJ/0ooK^0?ofkP0203eIZa80ooK^
00<0?EV[0?ofkP3om^h00`3om^h203eIZa@0ooK^100mFJ/30?ofkP0303eIZ`3om^h0ooK^00@0ooK^
1@0mFJ/60?ofkPD0?EV[6P3om^h00`000000ooK^0?ofkP0H0?ofkPD0e3dI1P3om^h20=@m6@030?of
kP3D?AT0e3dI00H0ooK^00@0e3dI0?ofkP3om^h0ooK^103D?ATD0?ofkP80e3dI1@3om^h00`3D?AT0
ooK^0?ofkP0@0?ofkP80e3dI0P3om^h00`3D?AT0ooK^0?ofkP0A0?ofkP030=@m6@3om^h0ooK^02@0
ooK^0P00001B0?ofkP40oooo001D0?ofkP<00000903om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP80?EV[
5@3om^h203eIZ`030?ofkP0mFJ/0?EV[01D0ooK^0P0mFJ/30?ofkPH0?EV[0P3om^h203eIZ`030?of
kP0mFJ/0?EV[00H0ooK^1@0mFJ/L0?ofkP030000003om^h0ooK^01X0ooK^1@3D?AT60?ofkP80e3dI
00<0ooK^0=@m6@3D?AT00P3om^h60=@m6@<0ooK^0P3D?ATE0?ofkP80e3dI00<0ooK^0=@m6@3D?AT0
5@3om^h20=@m6A<0ooK^00<0e3dI0?ofkP3om^h08P3om^h3000005@0ooK^0@3oool005L0ooK^0P00
000S0?ofkP0303eIZ`3om^h0ooK^00h0ooK^0P0mFJ/00`3om^h0?EV[03eIZ`0F0?ofkP80?EV[503o
m^h203eIZ`L0ooK^00@0?EV[0?ofkP3om^h0ooK^400mFJ/N0?ofkP030000003om^h0ooK^01`0ooK^
403D?AT30?ofkP030=@m6@3om^h0ooK^00D0ooK^0P3D?ATD0?ofkP80e3dI5P3om^h20=@m6@030?of
kP3D?AT0e3dI0100ooK^00<0e3dI0?ofkP3om^h08@3om^h2000005L0ooK^0@3oool005T0ooK^0P00
000R0?ofkP0303eIZ`3om^h0ooK^00/0ooK^0P0mFJ/50?ofkP0303eIZ`3om^h0ooK^0140ooK^0P0m
FJ/20?ofkP80?EV[403om^h203eIZ`T0ooK^00D0?EV[0?ofkP0mFJ/0?EV[0?ofkP0203eIZ`030?of
kP0mFJ/0ooK^0080ooK^1`0mFJ/O0?ofkP030000003om^h0ooK^01d0ooK^1`3D?AT30?ofkP050=@m
6@3om^h0e3dI0=@m6@3om^h00P3D?AT00`3om^h0e3dI0?ofkP080?ofkP80e3dI403om^h20=@m6@80
ooK^0P3D?ATC0?ofkP030=@m6@3om^h0ooK^00<0ooK^0P3D?AT=0?ofkP030=@m6@3om^h0ooK^0200
ooK^0P00001I0?ofkP40oooo001K0?ofkP<000007`3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eI
Z`3om^h0ooK^00H0ooK^0P0mFJ/?0?ofkP80?EV[1P3om^h203eIZ``0ooK^0P0mFJ/:0?ofkP<0?EV[
00<0ooK^03eIZ`0mFJ/00P3om^h00`0mFJ/0ooK^0?ofkP0203eIZ`030?ofkP0mFJ/0?EV[0080?EV[
8@3om^h00`000000ooK^0?ofkP0O0?ofkP@0e3dI00D0ooK^0=@m6@3D?AT0ooK^0=@m6@030?ofkP80
e3dI00@0ooK^0=@m6@3D?AT0e3dI2P3om^h20=@m6@`0ooK^0P3D?AT60?ofkP80e3dI3`3om^h20=@m
6@P0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP0M0?ofkP<00000F`3om^h10?oo
o`00GP3om^h2000001h0ooK^00<0?EV[0?ofkP3om^h01`3om^h203eIZ`/0ooK^00<0?EV[0?ofkP3o
m^h02P3om^h203eIZ`X0ooK^0`0mFJ/70?ofkP80?EV[303om^h0100mFJ/0ooK^03eIZ`0mFJ/40?of
kP<0?EV[00<0ooK^03eIZ`0mFJ/00P0mFJ/S0?ofkP030000003om^h0ooK^0240ooK^103D?AT0103o
m^h0e3dI0=@m6@3D?AT40?ofkP80e3dI00<0ooK^0=@m6@3om^h02`3om^h20=@m6@L0ooK^0`3D?AT:
0?ofkP80e3dI303om^h00`3D?AT0ooK^0?ofkP090?ofkP80e3dI2@3om^h00`3D?AT0ooK^0?ofkP0L
0?ofkP800000GP3om^h10?ooo`00H03om^h2000001d0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0m
FJ/0ooK^0?ofkP0<0?ofkP80?EV[203om^h203eIZ`l0ooK^0P0mFJ/30?ofkP80?EV[3@3om^h00`0m
FJ/0ooK^03eIZ`050?ofkP80?EV[00<0ooK^03eIZ`0mFJ/00P0mFJ/U0?ofkP030000003om^h0ooK^
02<0ooK^103D?AT00`3om^h0e3dI0=@m6@050?ofkP030=@m6@3om^h0e3dI00d0ooK^0P3D?AT30?of
kP80e3dI3`3om^h20=@m6@P0ooK^0P3D?AT>0?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?of
kP3om^h06`3om^h200000600ooK^0@3oool00680ooK^0`00000K0?ofkP0303eIZ`3om^h0ooK^0080
ooK^0P0mFJ/A0?ofkP0303eIZ`3om^h0ooK^00<0ooK^0P0mFJ/C0?ofkP<0?EV[3P3om^h303eIZ`@0
ooK^0P0mFJ/00`3om^h0?EV[03eIZ`0303eIZbH0ooK^00<000000?ofkP3om^h0903om^h50=@m6@03
0?ofkP3D?AT0e3dI00@0ooK^0P3D?AT?0?ofkP<0e3dI4`3om^h20=@m6@D0ooK^00<0e3dI0?ofkP3o
m^h03`3om^h20=@m6@@0ooK^00<0e3dI0?ofkP3om^h06@3om^h300000680ooK^0@3oool006D0ooK^
0P00000J0?ofkP0403eIZ`3om^h0?EV[03eIZa@0ooK^0P0mFJ/00`3om^h0?EV[03eIZ`0D0?ofkP80
?EV[0P3om^h403eIZ`T0ooK^0P0mFJ/40?ofkPP0?EV[:03om^h00`000000ooK^0?ofkP0V0?ofkPP0
e3dI103om^h20=@m6@T0ooK^103D?AT20?ofkP80e3dI503om^h20=@m6@030?ofkP3D?AT0e3dI01@0
ooK^0P3D?AT00`3om^h0e3dI0?ofkP0I0?ofkP800000I@3om^h10?ooo`00I`3om^h2000001T0ooK^
00<0?EV[0?ofkP3om^h05P3om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP80?EV[203om^h403eIZ`<0ooK^
0`0mFJ/20?ofkPH0?EV[00<0ooK^03eIZ`0mFJ/0:P3om^h00`000000ooK^0?ofkP0X0?ofkP80e3dI
00<0ooK^0=@m6@3D?AT0103D?AT20?ofkP<0e3dI0`3om^h40=@m6@P0ooK^0P3D?ATD0?ofkP030=@m
6@3om^h0ooK^01H0ooK^00<0e3dI0?ofkP3om^h05`3om^h2000006L0ooK^0@3oool006T0ooK^0`00
000G0?ofkP80?EV[503om^h203eIZ`030?ofkP0mFJ/0?EV[0100ooK^0P0mFJ/>0?ofkPT0?EV[00@0
ooK^03eIZ`0mFJ/0ooK^0P0mFJ//0?ofkP030000003om^h0ooK^02X0ooK^0P3D?AT0103om^h0e3dI
0=@m6@3om^h90=@m6@h0ooK^0P3D?AT@0?ofkP80e3dI00<0ooK^0=@m6@3D?AT0503om^h20=@m6AL0
ooK^0`00001Y0?ofkP40oooo001/0?ofkP8000005`3om^h203eIZa00ooK^0P0mFJ/50?ofkP80?EV[
3@3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP80?EV[00<0ooK^03eIZ`3om^h00P0mFJ/00`3om^h0?EV[
03eIZ`0303eIZbh0ooK^00<000000?ofkP3om^h0;03om^h50=@m6@040?ofkP3D?AT0e3dI0=@m6@80
ooK^0P3D?AT@0?ofkP030=@m6@3om^h0ooK^00/0ooK^0P3D?AT50?ofkP80e3dI403om^h20=@m6AL0
ooK^0P00001/0?ofkP40oooo001^0?ofkP8000005`3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP80?EV[
2@3om^h203eIZ`T0ooK^0P0mFJ/?0?ofkP80?EV[0`3om^h203eIZ`040?ofkP0mFJ/0?EV[0?ofkP80
?EV[<03om^h00`000000ooK^0?ofkP0^0?ofkP80e3dI00@0ooK^0=@m6@3D?AT0ooK^0P3D?AT30?of
kP80e3dI3`3om^h20=@m6@T0ooK^0P3D?AT90?ofkP80e3dI3@3om^h00`3D?AT0ooK^0?ofkP0E0?of
kP800000KP3om^h10?ooo`00L03om^h3000001D0ooK^0P0mFJ/90?ofkP80?EV[3@3om^h203eIZ`D0
ooK^0P0mFJ/?0?ofkP80?EV[103om^h01@0mFJ/0ooK^03eIZ`0mFJ/0ooK^0080?EV[<P3om^h00`00
0000ooK^0?ofkP0`0?ofkP80e3dI00D0ooK^0=@m6@3D?AT0ooK^0=@m6@040?ofkP80e3dI3`3om^h2
0=@m6@D0ooK^0P3D?AT=0?ofkP80e3dI2@3om^h20=@m6AD0ooK^0`00001`0?ofkP40oooo001c0?of
kP8000005@3om^h203eIZ`D0ooK^0P0mFJ/A0?ofkP80?EV[00<0ooK^03eIZ`0mFJ/03`3om^h203eI
Z`D0ooK^1P0mFJ/d0?ofkP030000003om^h0ooK^0380ooK^1P3D?AT50?ofkP80e3dI3`3om^h20=@m
6@030?ofkP3D?AT0e3dI0140ooK^0P3D?AT50?ofkP80e3dI5@3om^h2000007<0ooK^0@3oool007D0
ooK^0P00000E0?ofkP80?EV[00<0ooK^03eIZ`0mFJ/05@3om^h303eIZ`d0ooK^0P0mFJ/60?ofkPD0
?EV[=P3om^h00`000000ooK^0?ofkP0d0?ofkPD0e3dI1P3om^h20=@m6@d0ooK^0`3D?ATE0?ofkP80
e3dI00<0ooK^0=@m6@3D?AT05@3om^h2000007D0ooK^0@3oool007L0ooK^0`00000D0?ofkP0303eI
Z`3om^h0ooK^01<0ooK^0P0mFJ/30?ofkPH0?EV[1@3om^h203eIZ`80ooK^1P0mFJ/00`3om^h0?EV[
03eIZ`0h0?ofkP030000003om^h0ooK^03H0ooK^0P3D?AT00`3om^h0e3dI0=@m6@040=@m6@80ooK^
0P3D?AT50?ofkPH0e3dI0`3om^h20=@m6AD0ooK^00<0e3dI0?ofkP3om^h04P3om^h3000007L0ooK^
0@3oool007X0ooK^0P00000C0?ofkP80?EV[4@3om^h203eIZ`/0ooK^2@0mFJ/20?ofkP80?EV[00<0
ooK^03eIZ`0mFJ/0>P3om^h00`000000ooK^0?ofkP0h0?ofkP80e3dI00<0ooK^0=@m6@3D?AT00P3o
m^h90=@m6@/0ooK^0P3D?ATA0?ofkP80e3dI4`3om^h2000007X0ooK^0@3oool007`0ooK^0P00000C
0?ofkP80?EV[3@3om^h203eIZ`h0ooK^0P0mFJ/60?ofkPD0?EV[?03om^h00`000000ooK^0?ofkP0j
0?ofkPD0e3dI1P3om^h20=@m6@h0ooK^0P3D?AT=0?ofkP80e3dI4`3om^h2000007`0ooK^0@3oool0
07h0ooK^0`00000B0?ofkP80?EV[2@3om^h203eIZ`h0ooK^0P0mFJ/60?ofkPD0?EV[?P3om^h00`00
0000ooK^0?ofkP0l0?ofkPD0e3dI1P3om^h20=@m6@h0ooK^0P3D?AT90?ofkP80e3dI4P3om^h30000
07h0ooK^0@3oool00840ooK^0P00000B0?ofkP80?EV[1@3om^h203eIZ`h0ooK^0P0mFJ/60?ofkP@0
?EV[@@3om^h00`000000ooK^0?ofkP0o0?ofkP@0e3dI1P3om^h20=@m6@h0ooK^0P3D?AT50?ofkP80
e3dI4P3om^h200000840ooK^0@3oool008<0ooK^0`00000A0?ofkP80?EV[00<0ooK^03eIZ`0mFJ/0
3P3om^h203eIZ`H0ooK^100mFJ]30?ofkP030000003om^h0ooK^0440ooK^103D?AT60?ofkP80e3dI
3P3om^h20=@m6@030?ofkP3D?AT0e3dI0140ooK^0`0000230?ofkP40oooo00260?ofkP8000004@3o
m^h303eIZ``0ooK^0P0mFJ/60?ofkP<0?EV[AP3om^h00`000000ooK^0?ofkP140?ofkP<0e3dI1P3o
m^h20=@m6@`0ooK^0`3D?ATA0?ofkP800000QP3om^h10?ooo`00R03om^h200000180ooK^1P0mFJ/4
0?ofkP80?EV[0`3om^h603eIZdP0ooK^00<000000?ofkP3om^h0AP3om^h60=@m6@<0ooK^0P3D?AT4
0?ofkPH0e3dI4P3om^h2000008P0ooK^0@3oool008X0ooK^0`00000E0?ofkPT0?EV[CP3om^h00`00
0000ooK^0?ofkP1<0?ofkPT0e3dI5@3om^h3000008X0ooK^0@3oool008d0ooK^0P00001Z0?ofkP03
0000003om^h0ooK^06P0ooK^0P00002=0?ofkP40oooo002?0?ofkP800000J03om^h00`000000ooK^
0?ofkP1V0?ofkP800000S`3om^h10?ooo`00T@3om^h3000006D0ooK^00<000000?ofkP3om^h0H`3o
m^h300000940ooK^0@3oool009@0ooK^0P00001S0?ofkP030000003om^h0ooK^0640ooK^0P00002D
0?ofkP40oooo002F0?ofkP800000H@3om^h00`000000ooK^0?ofkP1O0?ofkP800000UP3om^h10?oo
o`00V03om^h3000005h0ooK^00<000000?ofkP3om^h0G03om^h3000009P0ooK^0@3oool009/0ooK^
0P00001L0?ofkP030000003om^h0ooK^05X0ooK^0P00002K0?ofkP40oooo002M0?ofkP800000FP3o
m^h00`000000ooK^0?ofkP1H0?ofkP800000W@3om^h10?ooo`00W`3om^h3000005L0ooK^00<00000
0?ofkP3om^h0E@3om^h3000009l0ooK^0@3oool00:80ooK^0P00001E0?ofkP030000003om^h0ooK^
05<0ooK^0P00002R0?ofkP40oooo002T0?ofkP800000D`3om^h00`000000ooK^0?ofkP1A0?ofkP80
0000Y03om^h10?ooo`00YP3om^h300000500ooK^00<000000?ofkP3om^h0CP3om^h300000:H0ooK^
0@3oool00:T0ooK^0P00001>0?ofkP030000003om^h0ooK^04`0ooK^0P00002Y0?ofkP40oooo002[
0?ofkP800000C03om^h00`000000ooK^0?ofkP1:0?ofkP800000Z`3om^h10?ooo`00[@3om^h30000
04T0ooK^00<000000?ofkP3om^h0A`3om^h300000:d0ooK^0@3oool00;00ooK^0P0000170?ofkP03
0000003om^h0ooK^04D0ooK^0P00002`0?ofkP40oooo002b0?ofkP800000A@3om^h00`000000ooK^
0?ofkP130?ofkP800000/P3om^h10?ooo`00]03om^h300000480ooK^00<000000?ofkP3om^h0@03o
m^h300000;@0ooK^0@3oool00;L0ooK^0P0000100?ofkP030000003om^h0ooK^03h0ooK^0P00002g
0?ofkP40oooo002i0?ofkP800000?P3om^h00`000000ooK^0?ofkP0l0?ofkP800000^@3om^h10?oo
o`00^`3om^h3000003/0ooK^00<000000?ofkP3om^h0>@3om^h300000;/0ooK^0@3oool00;h0ooK^
0P00000i0?ofkP030000003om^h0ooK^03L0ooK^0P00002n0?ofkP40oooo00300?ofkP800000=`3o
m^h00`000000ooK^0?ofkP0e0?ofkP800000`03om^h10?ooo`00`P3om^h3000003@0ooK^00<00000
0?ofkP3om^h0<P3om^h300000<80ooK^0@3oool00<D0ooK^0P00000b0?ofkP030000003om^h0ooK^
0300ooK^0P0000350?ofkP40oooo00370?ofkP800000<03om^h00`000000ooK^0?ofkP0^0?ofkP80
0000a`3om^h10?ooo`00b@3om^h3000002d0ooK^00<000000?ofkP3om^h0:`3om^h300000<T0ooK^
0@3oool00<`0ooK^0P00000[0?ofkP030000003om^h0ooK^02T0ooK^0P00003<0?ofkP40oooo003>
0?ofkP800000:@3om^h00`000000ooK^0?ofkP0W0?ofkP800000cP3om^h10?ooo`00d03om^h30000
02H0ooK^00<000000?ofkP3om^h0903om^h300000=00ooK^0@3oool00=<0ooK^0P00000T0?ofkP03
0000003om^h0ooK^0280ooK^0P00003C0?ofkP40oooo003E0?ofkP<000008@3om^h00`000000ooK^
0?ofkP0O0?ofkP<00000e@3om^h10?ooo`00f03om^h2000001l0ooK^00<000000?ofkP3om^h07@3o
m^h200000=P0ooK^0@3oool00=X0ooK^0P00000M0?ofkP030000003om^h0ooK^01/0ooK^0P00003J
0?ofkP40oooo003L0?ofkP<000006P3om^h00`000000ooK^0?ofkP0H0?ofkP<00000g03om^h10?oo
o`00g`3om^h2000001P0ooK^00<000000?ofkP3om^h05P3om^h200000=l0ooK^0@3oool00>40ooK^
0P00000F0?ofkP030000003om^h0ooK^01@0ooK^0P00003Q0?ofkP40oooo003S0?ofkP<000004`3o
m^h00`000000ooK^0?ofkP0A0?ofkP<00000h`3om^h10?ooo`00iP3om^h200000140ooK^00<00000
0?ofkP3om^h03`3om^h200000>H0ooK^0@3oool00>P0ooK^0P00000?0?ofkP030000003om^h0ooK^
00d0ooK^0P00003X0?ofkP40oooo003Z0?ofkP<00000303om^h00`000000ooK^0?ofkP0:0?ofkP<0
0000jP3om^h10?ooo`00k@3om^h2000000X0ooK^00<000000?ofkP3om^h0203om^h200000>d0ooK^
0@3oool00>l0ooK^0P0000080?ofkP030000003om^h0ooK^00H0ooK^0P00003_0?ofkP40oooo003a
0?ofkP<000001@3om^h00`000000ooK^0?ofkP030?ofkP<00000l@3om^h10?ooo`00m03om^h20000
00<0ooK^00@000000?ofkP3om^h0ooK^0P00003d0?ofkP40oooo003f0?ofkP80000000<0ooK^0000
003om^h00P00003f0?ofkP40oooo003h0?ofkP<00000n03om^h10?ooo`00o`3om^kd0?ofkP40oooo
003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0
ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool0
0?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03o
m^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00
o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?of
kP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o
0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^
0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0
ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h1
0?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3o
m^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40
oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?of
k_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3o
ool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^
m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?oo
o`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd
0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo
003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0
ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool0
0?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03o
m^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00
o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?of
kP40oooo0000\
\>"],
  ImageRangeCache->{{{0, 499}, {499, 0}} -> {-5.00005*^-06, -5.00005*^-06, \
0.00200403, 0.00200403}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
%%ImageSize: 500 500 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics3D
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Background color
1 .961 .933 r
MFill
% Scaling calculations
0 1 0 1 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 0 r
.25 Mabswid
[ ] 0 setdash
.06705 .30234 m
.00747 .5665 L
s
.00747 .5665 m
.39961 .8356 L
s
.39961 .8356 m
.40912 .60318 L
s
.40912 .60318 m
.06705 .30234 L
s
.63805 .03848 m
.88764 .44767 L
s
.88764 .44767 m
.93472 .69847 L
s
.93472 .69847 m
.66126 .3169 L
s
.66126 .3169 m
.63805 .03848 L
s
.06705 .30234 m
.00747 .5665 L
s
.00747 .5665 m
.66126 .3169 L
s
.66126 .3169 m
.63805 .03848 L
s
.63805 .03848 m
.06705 .30234 L
s
.40912 .60318 m
.88764 .44767 L
s
.88764 .44767 m
.93472 .69847 L
s
.93472 .69847 m
.39961 .8356 L
s
.39961 .8356 m
.40912 .60318 L
s
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
.83 .24 .1 r
.5 Mabswid
.57143 .56253 m
.59245 .54684 L
s
.55428 .54453 m
.57143 .56253 L
s
.553 .58135 m
.57143 .56253 L
s
.53555 .56364 m
.553 .58135 L
s
.53784 .60261 m
.553 .58135 L
s
.59245 .54684 m
.61531 .53486 L
s
.5756 .52855 m
.59245 .54684 L
s
.5201 .58518 m
.53784 .60261 L
s
.52654 .62555 m
.53784 .60261 L
s
.61531 .53486 m
.6392 .52709 L
s
.59876 .5163 m
.61531 .53486 L
s
.50852 .6084 m
.52654 .62555 L
s
.51958 .64934 m
.52654 .62555 L
s
.6392 .52709 m
.66322 .52391 L
s
.62292 .50827 m
.6392 .52709 L
s
.5756 .52855 m
.55428 .54453 L
s
.53658 .52595 m
.55428 .54453 L
s
.55428 .54453 m
.53555 .56364 L
s
.50131 .63245 m
.51958 .64934 L
s
.51732 .6731 m
.51958 .64934 L
s
.51754 .54535 m
.53555 .56364 L
s
.53555 .56364 m
.5201 .58518 L
s
.59876 .5163 m
.5756 .52855 L
s
.55821 .50967 m
.5756 .52855 L
s
.50178 .56719 m
.5201 .58518 L
s
.5201 .58518 m
.50852 .6084 L
s
.66322 .52391 m
.68644 .52555 L
s
.64718 .50487 m
.66322 .52391 L
s
.62292 .50827 m
.59876 .5163 L
s
.58167 .49713 m
.59876 .5163 L
s
.48991 .59069 m
.50852 .6084 L
s
.50852 .6084 m
.50131 .63245 L
s
.49883 .65643 m
.51732 .6731 L
s
.51998 .69588 m
.51732 .6731 L
s
.64718 .50487 m
.62292 .50827 L
s
.6061 .48884 m
.62292 .50827 L
s
.24 .35 .67 r
.3337 .59771 m
.3274 .57153 L
s
.3274 .57153 m
.35824 .56096 L
s
.3274 .57153 m
.31825 .54593 L
s
.31825 .54593 m
.34901 .53511 L
s
.31825 .54593 m
.30656 .5218 L
s
.83 .24 .1 r
.55821 .50967 m
.53658 .52595 L
s
.5183 .50675 m
.53658 .52595 L
s
.53658 .52595 m
.51754 .54535 L
s
.68644 .52555 m
.7079 .53211 L
s
.67062 .50634 m
.68644 .52555 L
s
.48243 .61499 m
.50131 .63245 L
s
.50131 .63245 m
.49883 .65643 L
s
.49893 .52646 m
.51754 .54535 L
s
.51754 .54535 m
.50178 .56719 L
s
.58167 .49713 m
.55821 .50967 L
s
.54025 .49016 m
.55821 .50967 L
s
.24 .35 .67 r
.33691 .62359 m
.3337 .59771 L
s
.3337 .59771 m
.36469 .58735 L
s
.30656 .5218 m
.33733 .51071 L
s
.30656 .5218 m
.29271 .49996 L
s
.83 .24 .1 r
.48286 .5486 m
.50178 .56719 L
s
.50178 .56719 m
.48991 .59069 L
s
.50133 .6794 m
.51998 .69588 L
s
.52762 .71672 m
.51998 .69588 L
s
.67062 .50634 m
.64718 .50487 L
s
.63062 .4852 m
.64718 .50487 L
s
.6061 .48884 m
.58167 .49713 L
s
.56401 .47732 m
.58167 .49713 L
s
.24 .35 .67 r
.33687 .64824 m
.33691 .62359 L
s
.33691 .62359 m
.36813 .61341 L
s
.83 .24 .1 r
.47068 .57239 m
.48991 .59069 L
s
.48991 .59069 m
.48243 .61499 L
s
.24 .35 .67 r
.36469 .58735 m
.35824 .56096 L
s
.35824 .56096 m
.38967 .55018 L
s
.35824 .56096 m
.34901 .53511 L
s
.34901 .53511 m
.38037 .52409 L
s
.34901 .53511 m
.33733 .51071 L
s
.83 .24 .1 r
.47973 .63921 m
.49883 .65643 L
s
.49883 .65643 m
.50133 .6794 L
s
.24 .35 .67 r
.29271 .49996 m
.32356 .48859 L
s
.29271 .49996 m
.27714 .48125 L
s
.83 .24 .1 r
.7079 .53211 m
.72665 .54349 L
s
.69225 .51278 m
.7079 .53211 L
s
.24 .35 .67 r
.36813 .61341 m
.36469 .58735 L
s
.36469 .58735 m
.39628 .5768 L
s
.33733 .51071 m
.36868 .49941 L
s
.33733 .51071 m
.32356 .48859 L
s
.83 .24 .1 r
.63062 .4852 m
.6061 .48884 L
s
.58873 .46875 m
.6061 .48884 L
s
.54025 .49016 m
.5183 .50675 L
s
.4994 .4869 m
.5183 .50675 L
s
.5183 .50675 m
.49893 .52646 L
s
.69225 .51278 m
.67062 .50634 L
s
.65427 .48648 m
.67062 .50634 L
s
.50887 .70039 m
.52762 .71672 L
s
.54009 .73466 m
.52762 .71672 L
s
.46293 .59696 m
.48243 .61499 L
s
.48243 .61499 m
.47973 .63921 L
s
.4797 .50694 m
.49893 .52646 L
s
.49893 .52646 m
.48286 .5486 L
s
.24 .35 .67 r
.36838 .63821 m
.33687 .64824 L
s
.33348 .67076 m
.33687 .64824 L
s
.36838 .63821 m
.36813 .61341 L
s
.36813 .61341 m
.39995 .60304 L
s
.83 .24 .1 r
.56401 .47732 m
.54025 .49016 L
s
.52168 .46999 m
.54025 .49016 L
s
.24 .35 .67 r
.39628 .5768 m
.38967 .55018 L
s
.38967 .55018 m
.42171 .5392 L
s
.38967 .55018 m
.38037 .52409 L
s
.38037 .52409 m
.41233 .51285 L
s
.38037 .52409 m
.36868 .49941 L
s
.32356 .48859 m
.35499 .477 L
s
.32356 .48859 m
.30814 .46959 L
s
.27714 .48125 m
.30814 .46959 L
s
.27714 .48125 m
.26038 .46644 L
s
.83 .24 .1 r
.4633 .52939 m
.48286 .5486 L
s
.48286 .5486 m
.47068 .57239 L
s
.48206 .66237 m
.50133 .6794 L
s
.50133 .6794 m
.50887 .70039 L
s
.24 .35 .67 r
.39995 .60304 m
.39628 .5768 L
s
.39628 .5768 m
.42848 .56604 L
s
.36868 .49941 m
.40065 .48789 L
s
.36868 .49941 m
.35499 .477 L
s
.83 .24 .1 r
.65427 .48648 m
.63062 .4852 L
s
.6135 .46487 m
.63062 .4852 L
s
.58873 .46875 m
.56401 .47732 L
s
.54575 .45684 m
.56401 .47732 L
s
.72665 .54349 m
.74177 .55936 L
s
.71112 .5241 m
.72665 .54349 L
s
.47068 .57239 m
.46293 .59696 L
s
.45999 .6214 m
.47973 .63921 L
s
.47973 .63921 m
.48206 .66237 L
s
.24 .35 .67 r
.4005 .62799 m
.36838 .63821 L
s
.36533 .66082 m
.36838 .63821 L
s
.4005 .62799 m
.39995 .60304 L
s
.39995 .60304 m
.43239 .59247 L
s
.42848 .56604 m
.42171 .5392 L
s
.42171 .5392 m
.41233 .51285 L
s
.41233 .51285 m
.44491 .50139 L
s
.41233 .51285 m
.40065 .48789 L
s
.83 .24 .1 r
.71112 .5241 m
.69225 .51278 L
s
.67607 .49279 m
.69225 .51278 L
s
.52132 .71843 m
.54009 .73466 L
s
.55704 .74882 m
.54009 .73466 L
s
.24 .35 .67 r
.35499 .477 m
.38705 .46519 L
s
.35499 .477 m
.33974 .4577 L
s
.30814 .46959 m
.33974 .4577 L
s
.30814 .46959 m
.29159 .45448 L
s
.32675 .6902 m
.33348 .67076 L
s
.33348 .67076 m
.36533 .66082 L
s
.83 .24 .1 r
.6135 .46487 m
.58873 .46875 L
s
.57076 .44798 m
.58873 .46875 L
s
.24 .35 .67 r
.43239 .59247 m
.42848 .56604 L
s
.26038 .46644 m
.29159 .45448 L
s
.26038 .46644 m
.243 .45621 L
s
.40065 .48789 m
.43323 .47615 L
s
.40065 .48789 m
.38705 .46519 L
s
.83 .24 .1 r
.52168 .46999 m
.4994 .4869 L
s
.4994 .4869 m
.4797 .50694 L
s
.67607 .49279 m
.65427 .48648 L
s
.63736 .46595 m
.65427 .48648 L
s
.48949 .6835 m
.50887 .70039 L
s
.50887 .70039 m
.52132 .71843 L
s
.46293 .59696 m
.45999 .6214 L
s
.4797 .50694 m
.4633 .52939 L
s
.54575 .45684 m
.52168 .46999 L
s
.50248 .44914 m
.52168 .46999 L
s
.74177 .55936 m
.75243 .57919 L
s
.72629 .53999 m
.74177 .55936 L
s
.24 .35 .67 r
.43325 .61756 m
.4005 .62799 L
s
.39781 .6507 m
.4005 .62799 L
s
.43325 .61756 m
.43239 .59247 L
s
1 .302 .124 r
.45135 .51826 m .45957 .52633 L .45551 .55007 L p F P
0 0 0 r
s
.24 .35 .67 r
.42171 .5392 m
.4527 .52857 L
s
1 .302 .124 r
.45551 .55007 m .44643 .54137 L .45135 .51826 L p F P
0 0 0 r
s
1 .296 .121 r
.44643 .54137 m .45551 .55007 L .45243 .57274 L p F P
0 0 0 r
s
.24 .35 .67 r
.42848 .56604 m
.44978 .55892 L
s
.211 .299 .6 r
.46836 .56749 m .45243 .57274 L .45551 .55007 L p F P
0 0 0 r
s
.83 .24 .1 r
.46626 .56818 m
.47068 .57239 L
s
.46153 .5328 m
.4633 .52939 L
s
.211 .299 .6 r
.45551 .55007 m .47042 .54506 L .46836 .56749 L p F P
0 0 0 r
s
.24 .35 .67 r
.45386 .55756 m
.46131 .55507 L
s
.224 .319 .638 r
.47042 .54506 m .45551 .55007 L .45957 .52633 L p F P
0 0 0 r
s
.83 .24 .1 r
.46213 .64475 m
.48206 .66237 L
s
.48206 .66237 m
.48949 .6835 L
s
.24 .35 .67 r
.44491 .50139 m
.45118 .51904 L
s
.44491 .50139 m
.43323 .47615 L
s
1 .306 .127 r
.45737 .49468 m .46455 .5019 L .45957 .52633 L p F P
0 0 0 r
s
1 .306 .127 r
.45957 .52633 m .45135 .51826 L .45737 .49468 L p F P
0 0 0 r
s
.24 .35 .67 r
.44491 .50139 m
.45671 .49724 L
s
.224 .319 .638 r
.45957 .52633 m .47313 .52168 L .47042 .54506 L p F P
0 0 0 r
s
.24 .35 .67 r
.45664 .53684 m
.46131 .55507 L
s
.235 .338 .673 r
.47313 .52168 m .45957 .52633 L .46455 .5019 L p F P
0 0 0 r
s
.24 .35 .67 r
.38705 .46519 m
.41973 .45314 L
s
.38705 .46519 m
.37196 .44558 L
s
.33974 .4577 m
.37196 .44558 L
s
.33974 .4577 m
.32342 .4423 L
s
.83 .24 .1 r
.63736 .46595 m
.6135 .46487 L
s
.59579 .44384 m
.6135 .46487 L
s
.24 .35 .67 r
.35899 .68032 m
.36533 .66082 L
s
.36533 .66082 m
.39781 .6507 L
s
1 .296 .121 r
.45243 .57274 m .44268 .56361 L .44643 .54137 L p F P
0 0 0 r
s
.83 .24 .1 r
.4508 .55347 m
.45922 .53724 L
s
.4508 .55347 m
.45534 .55778 L
s
1 .286 .116 r
.44268 .56361 m .45243 .57274 L .45038 .59394 L p F P
0 0 0 r
s
.24 .35 .67 r
.43239 .59247 m
.44866 .58717 L
s
.197 .277 .557 r
.46699 .58856 m .45038 .59394 L .45243 .57274 L p F P
0 0 0 r
s
.83 .24 .1 r
.45726 .59171 m
.46293 .59696 L
s
.197 .277 .557 r
.45243 .57274 m .46836 .56749 L .46699 .58856 L p F P
0 0 0 r
s
.24 .35 .67 r
.45051 .58656 m
.46547 .58169 L
s
.83 .24 .1 r
.57076 .44798 m
.54575 .45684 L
s
.52687 .43566 m
.54575 .45684 L
s
.24 .35 .67 r
.46131 .55507 m
.46547 .58169 L
s
.83 .24 .1 r
.72629 .53999 m
.71112 .5241 L
s
.69505 .50405 m
.71112 .5241 L
s
.24 .35 .67 r
.29159 .45448 m
.32342 .4423 L
s
.29159 .45448 m
.2745 .44399 L
s
1 .308 .128 r
.46439 .47104 m .47035 .4772 L .46455 .5019 L p F P
0 0 0 r
s
1 .308 .128 r
.46455 .5019 m .45737 .49468 L .46439 .47104 L p F P
0 0 0 r
s
.235 .338 .673 r
.46455 .5019 m .47645 .49774 L .47313 .52168 L p F P
0 0 0 r
s
.83 .24 .1 r
.47573 .50291 m
.4797 .50694 L
s
.245 .355 .705 r
.47645 .49774 m .46455 .5019 L .47035 .4772 L p F P
0 0 0 r
s
.24 .35 .67 r
.43323 .47615 m
.41973 .45314 L
s
.83 .24 .1 r
.53831 .73262 m
.55704 .74882 L
s
.57784 .75839 m
.55704 .74882 L
s
.211 .299 .6 r
.48444 .56218 m .46836 .56749 L .47042 .54506 L p F P
0 0 0 r
s
.211 .299 .6 r
.47042 .54506 m .48546 .54001 L .48444 .56218 L p F P
0 0 0 r
s
.224 .319 .638 r
.48546 .54001 m .47042 .54506 L .47313 .52168 L p F P
0 0 0 r
s
.224 .319 .638 r
.47313 .52168 m .4868 .517 L .48546 .54001 L p F P
0 0 0 r
s
.235 .338 .673 r
.4868 .517 m .47313 .52168 L .47645 .49774 L p F P
0 0 0 r
s
.24 .35 .67 r
.31682 .70568 m
.32675 .6902 L
s
.32675 .6902 m
.35899 .68032 L
s
1 .286 .116 r
.45038 .59394 m .44019 .58459 L .44268 .56361 L p F P
0 0 0 r
s
.979 .272 .109 r
.44019 .58459 m .45038 .59394 L .44941 .61329 L p F P
0 0 0 r
s
.83 .24 .1 r
.44276 .5783 m
.45192 .58677 L
s
.181 .25 .506 r
.46634 .60791 m .44941 .61329 L .45038 .59394 L p F P
0 0 0 r
s
.181 .25 .506 r
.45038 .59394 m .46699 .58856 L .46634 .60791 L p F P
0 0 0 r
s
.197 .277 .557 r
.48376 .58313 m .46699 .58856 L .46836 .56749 L p F P
0 0 0 r
s
.197 .277 .557 r
.46836 .56749 m .48444 .56218 L .48376 .58313 L p F P
0 0 0 r
s
1 .302 .124 r
.44301 .51007 m .45135 .51826 L .44643 .54137 L p F P
0 0 0 r
s
1 .302 .124 r
.44643 .54137 m .4372 .53252 L .44301 .51007 L p F P
0 0 0 r
s
1 .296 .121 r
.4372 .53252 m .44643 .54137 L .44268 .56361 L p F P
0 0 0 r
s
.83 .24 .1 r
.44276 .5783 m
.4508 .55347 L
s
1 .306 .127 r
.45011 .48737 m .45737 .49468 L .45135 .51826 L p F P
0 0 0 r
s
1 .306 .127 r
.45135 .51826 m .44301 .51007 L .45011 .48737 L p F P
0 0 0 r
s
.235 .338 .673 r
.47645 .49774 m .48843 .49355 L .4868 .517 L p F P
0 0 0 r
s
.245 .355 .705 r
.48843 .49355 m .47645 .49774 L .48032 .47365 L p F P
0 0 0 r
s
.245 .355 .705 r
.47035 .4772 m .48032 .47365 L .47645 .49774 L p F P
0 0 0 r
s
.24 .35 .67 r
.46538 .4942 m
.47813 .48971 L
s
.83 .24 .1 r
.69505 .50405 m
.67607 .49279 L
s
.65933 .47212 m
.67607 .49279 L
s
.50189 .70163 m
.52132 .71843 L
s
.52132 .71843 m
.53831 .73262 L
s
.24 .35 .67 r
.243 .45621 m
.2745 .44399 L
s
.243 .45621 m
.22568 .4512 L
s
.224 .319 .638 r
.50063 .53491 m .48546 .54001 L .4868 .517 L p F P
0 0 0 r
s
.224 .319 .638 r
.4868 .517 m .50057 .51227 L .50063 .53491 L p F P
0 0 0 r
s
.235 .338 .673 r
.50057 .51227 m .4868 .517 L .48843 .49355 L p F P
0 0 0 r
s
.24 .35 .67 r
.45857 .52656 m
.48767 .51658 L
s
.211 .299 .6 r
.50068 .55683 m .48444 .56218 L .48546 .54001 L p F P
0 0 0 r
s
.211 .299 .6 r
.48546 .54001 m .50063 .53491 L .50068 .55683 L p F P
0 0 0 r
s
.24 .35 .67 r
.46131 .55507 m
.49479 .54388 L
s
.43093 .64037 m
.43325 .61756 L
s
.83 .24 .1 r
.59579 .44384 m
.57076 .44798 L
s
.55217 .4265 m
.57076 .44798 L
s
1 .296 .121 r
.44268 .56361 m .43277 .55433 L .4372 .53252 L p F P
0 0 0 r
s
1 .286 .116 r
.43277 .55433 m .44268 .56361 L .44019 .58459 L p F P
0 0 0 r
s
.24 .35 .67 r
.48767 .51658 m
.49479 .54388 L
s
.47813 .48971 m
.48767 .51658 L
s
1 .308 .129 r
.47229 .44776 m .47691 .45265 L .47035 .4772 L p F P
0 0 0 r
s
1 .308 .129 r
.47035 .4772 m .46439 .47104 L .47229 .44776 L p F P
0 0 0 r
s
.255 .371 .736 r
.48032 .47365 m .47035 .4772 L .47691 .45265 L p F P
0 0 0 r
s
1 .308 .128 r
.45836 .46482 m .46439 .47104 L .45737 .49468 L p F P
0 0 0 r
s
.24 .35 .67 r
.45999 .46651 m
.46646 .46417 L
s
.83 .24 .1 r
.45982 .48675 m
.46748 .49453 L
s
1 .308 .128 r
.45737 .49468 m .45011 .48737 L .45836 .46482 L p F P
0 0 0 r
s
.24 .35 .67 r
.43323 .47615 m
.4574 .46744 L
s
.46981 .4715 m
.47813 .48971 L
s
.46646 .46417 m
.46661 .46449 L
s
.181 .25 .506 r
.48344 .60246 m .46634 .60791 L .46699 .58856 L p F P
0 0 0 r
s
.181 .25 .506 r
.46699 .58856 m .48376 .58313 L .48344 .60246 L p F P
0 0 0 r
s
.24 .35 .67 r
.41973 .45314 m
.40482 .43322 L
s
.235 .338 .673 r
.48843 .49355 m .5005 .48933 L .50057 .51227 L p F P
0 0 0 r
s
.245 .355 .705 r
.5005 .48933 m .48843 .49355 L .49034 .47008 L p F P
0 0 0 r
s
.83 .24 .1 r
.49899 .48647 m
.4994 .4869 L
s
.245 .355 .705 r
.48032 .47365 m .49034 .47008 L .48843 .49355 L p F P
0 0 0 r
s
.83 .24 .1 r
.47986 .46638 m
.48515 .47193 L
s
.197 .277 .557 r
.50071 .57765 m .48376 .58313 L .48444 .56218 L p F P
0 0 0 r
s
.197 .277 .557 r
.48444 .56218 m .50068 .55683 L .50071 .57765 L p F P
0 0 0 r
s
.24 .35 .67 r
.37196 .44558 m
.40482 .43322 L
s
.37196 .44558 m
.35589 .42987 L
s
.39187 .67024 m
.39781 .6507 L
s
.39781 .6507 m
.43093 .64037 L
s
.83 .24 .1 r
.75243 .57919 m
.75798 .6022 L
s
.73695 .55992 m
.75243 .57919 L
s
.47899 .46546 m
.47986 .46638 L
s
.45982 .48675 m
.47413 .47221 L
s
.47924 .46702 m
.47986 .46638 L
s
.65933 .47212 m
.63736 .46595 L
s
.61987 .44471 m
.63736 .46595 L
s
.46943 .66603 m
.48949 .6835 L
s
.48949 .6835 m
.50189 .70163 L
s
.224 .319 .638 r
.51594 .52976 m .50063 .53491 L .50057 .51227 L p F P
0 0 0 r
s
.224 .319 .638 r
.50057 .51227 m .51446 .50751 L .51594 .52976 L p F P
0 0 0 r
s
.235 .338 .673 r
.51446 .50751 m .50057 .51227 L .5005 .48933 L p F P
0 0 0 r
s
.24 .35 .67 r
.49479 .54388 m
.4992 .57069 L
s
.255 .371 .736 r
.49034 .47008 m .48032 .47365 L .48468 .44983 L p F P
0 0 0 r
s
.83 .24 .1 r
.47986 .46638 m
.48194 .4648 L
s
.48765 .46045 m
.50248 .44914 L
s
.255 .371 .736 r
.47691 .45265 m .48468 .44983 L .48032 .47365 L p F P
0 0 0 r
s
.211 .299 .6 r
.51707 .55142 m .50068 .55683 L .50063 .53491 L p F P
0 0 0 r
s
.211 .299 .6 r
.50063 .53491 m .51594 .52976 L .51707 .55142 L p F P
0 0 0 r
s
.979 .272 .109 r
.44941 .61329 m .43901 .60393 L .44019 .58459 L p F P
0 0 0 r
s
.913 .25 .099 r
.43901 .60393 m .44941 .61329 L .44956 .63042 L p F P
0 0 0 r
s
.24 .35 .67 r
.43325 .61756 m
.44318 .6144 L
s
.16 .218 .444 r
.46644 .62513 m .44956 .63042 L .44941 .61329 L p F P
0 0 0 r
s
.83 .24 .1 r
.4605 .62699 m
.46213 .64475 L
s
.16 .218 .444 r
.44941 .61329 m .46634 .60791 L .46644 .62513 L p F P
0 0 0 r
s
.24 .35 .67 r
.32342 .4423 m
.35589 .42987 L
s
.32342 .4423 m
.30662 .43152 L
s
.46646 .46417 m
.46675 .46407 L
s
1 .306 .127 r
.44275 .47997 m .45011 .48737 L .44301 .51007 L p F P
0 0 0 r
s
.83 .24 .1 r
.44307 .50952 m
.45982 .48675 L
s
.44307 .50952 m
.46076 .5269 L
s
1 .306 .127 r
.44301 .51007 m .43456 .50177 L .44275 .47997 L p F P
0 0 0 r
s
1 .302 .124 r
.43456 .50177 m .44301 .51007 L .4372 .53252 L p F P
0 0 0 r
s
.235 .338 .673 r
.5005 .48933 m .51266 .48509 L .51446 .50751 L p F P
0 0 0 r
s
.245 .355 .705 r
.51266 .48509 m .5005 .48933 L .50042 .46649 L p F P
0 0 0 r
s
.245 .355 .705 r
.49034 .47008 m .50042 .46649 L .5005 .48933 L p F P
0 0 0 r
s
1 .286 .116 r
.44019 .58459 m .42982 .57508 L .43277 .55433 L p F P
0 0 0 r
s
.979 .272 .109 r
.42982 .57508 m .44019 .58459 L .43901 .60393 L p F P
0 0 0 r
s
.83 .24 .1 r
.43956 .60298 m
.44276 .5783 L
s
1 .302 .124 r
.4372 .53252 m .42783 .52354 L .43456 .50177 L p F P
0 0 0 r
s
1 .296 .121 r
.42783 .52354 m .4372 .53252 L .43277 .55433 L p F P
0 0 0 r
s
1 .308 .129 r
.46764 .44283 m .47229 .44776 L .46439 .47104 L p F P
0 0 0 r
s
1 .308 .129 r
.46439 .47104 m .45836 .46482 L .46764 .44283 L p F P
0 0 0 r
s
.24 .35 .67 r
.34946 .6958 m
.35899 .68032 L
s
.35899 .68032 m
.39187 .67024 L
s
.197 .277 .557 r
.51782 .57211 m .50071 .57765 L .50068 .55683 L p F P
0 0 0 r
s
.197 .277 .557 r
.50068 .55683 m .51707 .55142 L .51782 .57211 L p F P
0 0 0 r
s
.255 .371 .736 r
.50042 .46649 m .49034 .47008 L .49248 .447 L p F P
0 0 0 r
s
.255 .371 .736 r
.48468 .44983 m .49248 .447 L .49034 .47008 L p F P
0 0 0 r
s
.181 .25 .506 r
.50072 .59697 m .48344 .60246 L .48376 .58313 L p F P
0 0 0 r
s
.181 .25 .506 r
.48376 .58313 m .50071 .57765 L .50072 .59697 L p F P
0 0 0 r
s
.24 .35 .67 r
.46547 .58169 m
.4992 .57069 L
s
1 .308 .128 r
.45227 .45853 m .45836 .46482 L .45011 .48737 L p F P
0 0 0 r
s
1 .308 .128 r
.45011 .48737 m .44275 .47997 L .45227 .45853 L p F P
0 0 0 r
s
.83 .24 .1 r
.73695 .55992 m
.72629 .53999 L
s
.71028 .51995 m
.72629 .53999 L
s
.55924 .74215 m
.57784 .75839 L
s
.60167 .76276 m
.57784 .75839 L
s
.224 .319 .638 r
.53138 .52457 m .51594 .52976 L .51446 .50751 L p F P
0 0 0 r
s
.224 .319 .638 r
.51446 .50751 m .52846 .50272 L .53138 .52457 L p F P
0 0 0 r
s
.235 .338 .673 r
.52846 .50272 m .51446 .50751 L .51266 .48509 L p F P
0 0 0 r
s
.24 .35 .67 r
.48767 .51658 m
.52164 .50494 L
s
.211 .299 .6 r
.53361 .54597 m .51707 .55142 L .51594 .52976 L p F P
0 0 0 r
s
.211 .299 .6 r
.51594 .52976 m .53138 .52457 L .53361 .54597 L p F P
0 0 0 r
s
.24 .35 .67 r
.49479 .54388 m
.52893 .53248 L
s
1 .296 .121 r
.43277 .55433 m .4227 .54489 L .42783 .52354 L p F P
0 0 0 r
s
1 .286 .116 r
.4227 .54489 m .43277 .55433 L .42982 .57508 L p F P
0 0 0 r
s
.83 .24 .1 r
.43024 .5339 m
.4508 .55347 L
s
.16 .218 .444 r
.48349 .61979 m .46644 .62513 L .46634 .60791 L p F P
0 0 0 r
s
.16 .218 .444 r
.46634 .60791 m .48344 .60246 L .48349 .61979 L p F P
0 0 0 r
s
.24 .35 .67 r
.44868 .61264 m
.46665 .60692 L
s
.46547 .58169 m
.46665 .60692 L
s
.235 .338 .673 r
.51266 .48509 m .5249 .48081 L .52846 .50272 L p F P
0 0 0 r
s
.245 .355 .705 r
.5249 .48081 m .51266 .48509 L .51056 .46288 L p F P
0 0 0 r
s
.245 .355 .705 r
.50042 .46649 m .51056 .46288 L .51266 .48509 L p F P
0 0 0 r
s
.24 .35 .67 r
.47813 .48971 m
.51201 .4778 L
s
.2745 .44399 m
.30662 .43152 L
s
.2745 .44399 m
.25751 .43872 L
s
1 .306 .129 r
.48096 .42527 m .48411 .42869 L .47691 .45265 L p F P
0 0 0 r
s
1 .306 .129 r
.47691 .45265 m .47229 .44776 L .48096 .42527 L p F P
0 0 0 r
s
.265 .388 .766 r
.48468 .44983 m .47691 .45265 L .48411 .42869 L p F P
0 0 0 r
s
.83 .24 .1 r
.61987 .44471 m
.59579 .44384 L
s
.57746 .42208 m
.59579 .44384 L
s
.255 .371 .736 r
.51056 .46288 m .50042 .46649 L .50033 .44416 L p F P
0 0 0 r
s
.83 .24 .1 r
.50292 .4489 m
.52687 .43566 L
s
.255 .371 .736 r
.49248 .447 m .50033 .44416 L .50042 .46649 L p F P
0 0 0 r
s
.83 .24 .1 r
.55217 .4265 m
.52687 .43566 L
s
.24 .35 .67 r
.51201 .4778 m
.52164 .50494 L
s
1 .308 .129 r
.46295 .43787 m .46764 .44283 L .45836 .46482 L p F P
0 0 0 r
s
1 .308 .129 r
.45836 .46482 m .45227 .45853 L .46295 .43787 L p F P
0 0 0 r
s
.24 .35 .67 r
.45306 .44085 m
.45745 .4485 L
s
.41973 .45314 m
.45306 .44085 L
s
.83 .24 .1 r
.71028 .51995 m
.69505 .50405 L
s
.67843 .4833 m
.69505 .50405 L
s
.197 .277 .557 r
.5351 .56651 m .51782 .57211 L .51707 .55142 L p F P
0 0 0 r
s
.197 .277 .557 r
.51707 .55142 m .53361 .54597 L .5351 .56651 L p F P
0 0 0 r
s
.224 .319 .638 r
.54697 .51933 m .53138 .52457 L .52846 .50272 L p F P
0 0 0 r
s
.224 .319 .638 r
.52846 .50272 m .54257 .49788 L .54697 .51933 L p F P
0 0 0 r
s
.24 .35 .67 r
.52164 .50494 m
.52893 .53248 L
s
.235 .338 .673 r
.54257 .49788 m .52846 .50272 L .5249 .48081 L p F P
0 0 0 r
s
.265 .388 .766 r
.49248 .447 m .48468 .44983 L .48946 .42672 L p F P
0 0 0 r
s
.265 .388 .766 r
.48411 .42869 m .48946 .42672 L .48468 .44983 L p F P
0 0 0 r
s
.181 .25 .506 r
.51817 .59142 m .50072 .59697 L .50071 .57765 L p F P
0 0 0 r
s
.181 .25 .506 r
.50071 .57765 m .51782 .57211 L .51817 .59142 L p F P
0 0 0 r
s
.24 .35 .67 r
.4992 .57069 m
.50071 .59608 L
s
.40482 .43322 m
.43834 .4206 L
s
.40482 .43322 m
.389 .41719 L
s
.42541 .65996 m
.43093 .64037 L
s
.83 .24 .1 r
.51892 .71585 m
.53831 .73262 L
s
.53831 .73262 m
.55924 .74215 L
s
.24 .35 .67 r
.30393 .71638 m
.31682 .70568 L
s
.31682 .70568 m
.34946 .6958 L
s
1 .306 .127 r
.43531 .47247 m .44275 .47997 L .43456 .50177 L p F P
0 0 0 r
s
1 .306 .127 r
.43456 .50177 m .42598 .49335 L .43531 .47247 L p F P
0 0 0 r
s
1 .302 .124 r
.42598 .49335 m .43456 .50177 L .42783 .52354 L p F P
0 0 0 r
s
.83 .24 .1 r
.43024 .5339 m
.44307 .50952 L
s
.235 .338 .673 r
.5249 .48081 m .53723 .4765 L .54257 .49788 L p F P
0 0 0 r
s
.245 .355 .705 r
.53723 .4765 m .5249 .48081 L .52076 .45925 L p F P
0 0 0 r
s
.245 .355 .705 r
.51056 .46288 m .52076 .45925 L .5249 .48081 L p F P
0 0 0 r
s
.979 .272 .109 r
.43901 .60393 m .42843 .5944 L .42982 .57508 L p F P
0 0 0 r
s
.913 .25 .099 r
.42843 .5944 m .43901 .60393 L .43919 .62123 L p F P
0 0 0 r
s
.913 .25 .099 r
.44956 .63042 m .43919 .62123 L .43901 .60393 L p F P
0 0 0 r
s
.83 .24 .1 r
.43956 .60298 m
.45059 .61292 L
s
.255 .371 .736 r
.52076 .45925 m .51056 .46288 L .5082 .4413 L p F P
0 0 0 r
s
.255 .371 .736 r
.50033 .44416 m .5082 .4413 L .51056 .46288 L p F P
0 0 0 r
s
.24 .35 .67 r
.50035 .45196 m
.51201 .4778 L
s
.47322 .46174 m
.50035 .45196 L
s
.211 .299 .6 r
.55032 .54046 m .53361 .54597 L .53138 .52457 L p F P
0 0 0 r
s
.211 .299 .6 r
.53138 .52457 m .54697 .51933 L .55032 .54046 L p F P
0 0 0 r
s
1 .308 .128 r
.44612 .45218 m .45227 .45853 L .44275 .47997 L p F P
0 0 0 r
s
1 .308 .128 r
.44275 .47997 m .43531 .47247 L .44612 .45218 L p F P
0 0 0 r
s
1 .306 .129 r
.47779 .42183 m .48096 .42527 L .47229 .44776 L p F P
0 0 0 r
s
1 .306 .129 r
.47229 .44776 m .46764 .44283 L .47779 .42183 L p F P
0 0 0 r
s
.134 .176 .364 r
.46731 .63986 m .45086 .64493 L .44956 .63042 L p F P
0 0 0 r
s
.83 .24 .1 r
.46213 .64475 m
.46943 .66603 L
s
.45936 .64231 m
.46213 .64475 L
s
.134 .176 .364 r
.44956 .63042 m .46644 .62513 L .46731 .63986 L p F P
0 0 0 r
s
.809 .217 .084 r
.43919 .62123 m .44956 .63042 L .45086 .64493 L p F P
0 0 0 r
s
.24 .35 .67 r
.43093 .64037 m
.44626 .63559 L
s
1 .302 .124 r
.42783 .52354 m .41831 .51442 L .42598 .49335 L p F P
0 0 0 r
s
1 .296 .121 r
.41831 .51442 m .42783 .52354 L .4227 .54489 L p F P
0 0 0 r
s
.24 .35 .67 r
.52893 .53248 m
.53361 .55948 L
s
.265 .388 .766 r
.50033 .44416 m .49248 .447 L .49484 .42474 L p F P
0 0 0 r
s
.265 .388 .766 r
.48946 .42672 m .49484 .42474 L .49248 .447 L p F P
0 0 0 r
s
.16 .218 .444 r
.50072 .6144 m .48349 .61979 L .48344 .60246 L p F P
0 0 0 r
s
.16 .218 .444 r
.48344 .60246 m .50072 .59697 L .50072 .6144 L p F P
0 0 0 r
s
.24 .35 .67 r
.46665 .60692 m
.50071 .59608 L
s
1 .286 .116 r
.42982 .57508 m .41928 .56541 L .4227 .54489 L p F P
0 0 0 r
s
.979 .272 .109 r
.41928 .56541 m .42982 .57508 L .42843 .5944 L p F P
0 0 0 r
s
.83 .24 .1 r
.75798 .6022 m
.74241 .58311 L
s
.75798 .6022 m
.75797 .62739 L
s
.24 .35 .67 r
.35589 .42987 m
.389 .41719 L
s
.35589 .42987 m
.3394 .4188 L
s
.22568 .4512 m
.25751 .43872 L
s
.22568 .4512 m
.20913 .45184 L
s
.83 .24 .1 r
.67843 .4833 m
.65933 .47212 L
s
.64201 .45071 m
.65933 .47212 L
s
.245 .355 .705 r
.52076 .45925 m .53102 .45559 L .53723 .4765 L p F P
0 0 0 r
s
.255 .371 .736 r
.53102 .45559 m .52076 .45925 L .51612 .43843 L p F P
0 0 0 r
s
.255 .371 .736 r
.5082 .4413 m .51612 .43843 L .52076 .45925 L p F P
0 0 0 r
s
.224 .319 .638 r
.56269 .51404 m .54697 .51933 L .54257 .49788 L p F P
0 0 0 r
s
.224 .319 .638 r
.54257 .49788 m .5568 .493 L .56269 .51404 L p F P
0 0 0 r
s
.235 .338 .673 r
.5568 .493 m .54257 .49788 L .53723 .4765 L p F P
0 0 0 r
s
.24 .35 .67 r
.52164 .50494 m
.55628 .49306 L
s
.235 .338 .673 r
.53723 .4765 m .54964 .47216 L .5568 .493 L p F P
0 0 0 r
s
.245 .355 .705 r
.54964 .47216 m .53723 .4765 L .53102 .45559 L p F P
0 0 0 r
s
1 .308 .129 r
.45822 .43286 m .46295 .43787 L .45227 .45853 L p F P
0 0 0 r
s
.24 .35 .67 r
.45306 .44085 m
.45668 .43952 L
s
.83 .24 .1 r
.45965 .44515 m
.47586 .46218 L
s
1 .308 .129 r
.45227 .45853 m .44612 .45218 L .45822 .43286 L p F P
0 0 0 r
s
.197 .277 .557 r
.55255 .56086 m .5351 .56651 L .53361 .54597 L p F P
0 0 0 r
s
.197 .277 .557 r
.53361 .54597 m .55032 .54046 L .55255 .56086 L p F P
0 0 0 r
s
.265 .388 .766 r
.5082 .4413 m .50033 .44416 L .50022 .42275 L p F P
0 0 0 r
s
.265 .388 .766 r
.49484 .42474 m .50022 .42275 L .50033 .44416 L p F P
0 0 0 r
s
.83 .24 .1 r
.48178 .68424 m
.50189 .70163 L
s
.50189 .70163 m
.51892 .71585 L
s
.24 .35 .67 r
.38277 .68572 m
.39187 .67024 L
s
.39187 .67024 m
.42541 .65996 L
s
.181 .25 .506 r
.5358 .58581 m .51817 .59142 L .51782 .57211 L p F P
0 0 0 r
s
.181 .25 .506 r
.51782 .57211 m .5351 .56651 L .5358 .58581 L p F P
0 0 0 r
s
.24 .35 .67 r
.4992 .57069 m
.53361 .55948 L
s
1 .296 .121 r
.4227 .54489 m .41246 .53529 L .41831 .51442 L p F P
0 0 0 r
s
1 .286 .116 r
.41246 .53529 m .4227 .54489 L .41928 .56541 L p F P
0 0 0 r
s
.83 .24 .1 r
.42188 .559 m
.43024 .5339 L
s
.42188 .559 m
.44276 .5783 L
s
.57746 .42208 m
.55217 .4265 L
s
1 .306 .129 r
.4746 .41836 m .47779 .42183 L .46764 .44283 L p F P
0 0 0 r
s
.24 .35 .67 r
.46249 .43738 m
.46998 .43462 L
s
1 .306 .129 r
.46764 .44283 m .46295 .43787 L .4746 .41836 L p F P
0 0 0 r
s
.211 .299 .6 r
.56718 .53489 m .55032 .54046 L .54697 .51933 L p F P
0 0 0 r
s
.211 .299 .6 r
.54697 .51933 m .56269 .51404 L .56718 .53489 L p F P
0 0 0 r
s
.83 .24 .1 r
.58328 .74641 m
.60167 .76276 L
s
.62746 .76154 m
.60167 .76276 L
s
.134 .176 .364 r
.48392 .63473 m .46731 .63986 L .46644 .62513 L p F P
0 0 0 r
s
.134 .176 .364 r
.46644 .62513 m .48349 .61979 L .48392 .63473 L p F P
0 0 0 r
s
.24 .35 .67 r
.46471 .62983 m
.46665 .60692 L
s
.265 .388 .766 r
.51612 .43843 m .5082 .4413 L .50563 .42076 L p F P
0 0 0 r
s
.265 .388 .766 r
.50022 .42275 m .50563 .42076 L .5082 .4413 L p F P
0 0 0 r
s
.245 .355 .705 r
.53102 .45559 m .54134 .45192 L .54964 .47216 L p F P
0 0 0 r
s
.255 .371 .736 r
.54134 .45192 m .53102 .45559 L .52407 .43555 L p F P
0 0 0 r
s
.255 .371 .736 r
.51612 .43843 m .52407 .43555 L .53102 .45559 L p F P
0 0 0 r
s
.16 .218 .444 r
.51812 .60895 m .50072 .6144 L .50072 .59697 L p F P
0 0 0 r
s
.16 .218 .444 r
.50072 .59697 m .51817 .59142 L .51812 .60895 L p F P
0 0 0 r
s
.24 .35 .67 r
.30662 .43152 m
.3394 .4188 L
s
.30662 .43152 m
.28999 .42599 L
s
1 .308 .128 r
.43991 .44577 m .44612 .45218 L .43531 .47247 L p F P
0 0 0 r
s
1 .308 .128 r
.43531 .47247 m .42777 .46489 L .43991 .44577 L p F P
0 0 0 r
s
.83 .24 .1 r
.43924 .46586 m
.45982 .48675 L
s
1 .306 .127 r
.42777 .46489 m .43531 .47247 L .42598 .49335 L p F P
0 0 0 r
s
1 .306 .127 r
.42598 .49335 m .41728 .48481 L .42777 .46489 L p F P
0 0 0 r
s
1 .302 .124 r
.41728 .48481 m .42598 .49335 L .41831 .51442 L p F P
0 0 0 r
s
.83 .24 .1 r
.42213 .48896 m
.44307 .50952 L
s
.235 .338 .673 r
.57115 .48808 m .5568 .493 L .54964 .47216 L p F P
0 0 0 r
s
.235 .338 .673 r
.54964 .47216 m .56215 .46779 L .57115 .48808 L p F P
0 0 0 r
s
.245 .355 .705 r
.56215 .46779 m .54964 .47216 L .54134 .45192 L p F P
0 0 0 r
s
.24 .35 .67 r
.51201 .4778 m
.54656 .46565 L
s
.224 .319 .638 r
.57856 .50871 m .56269 .51404 L .5568 .493 L p F P
0 0 0 r
s
.224 .319 .638 r
.5568 .493 m .57115 .48808 L .57856 .50871 L p F P
0 0 0 r
s
.83 .24 .1 r
.74241 .58311 m
.73695 .55992 L
s
.72091 .53997 m
.73695 .55992 L
s
.43924 .46586 m
.45965 .44515 L
s
1 .303 .128 r
.49025 .40402 m .49185 .4058 L .48411 .42869 L p F P
0 0 0 r
s
1 .303 .128 r
.48411 .42869 m .48096 .42527 L .49025 .40402 L p F P
0 0 0 r
s
.275 .404 .796 r
.48946 .42672 m .48411 .42869 L .49185 .4058 L p F P
0 0 0 r
s
.24 .35 .67 r
.48705 .42832 m
.50035 .45196 L
s
.4811 .43051 m
.48705 .42832 L
s
.83 .24 .1 r
.48261 .42756 m
.48611 .43136 L
s
.64201 .45071 m
.61987 .44471 L
s
.24 .35 .67 r
.54656 .46565 m
.55628 .49306 L
s
.83 .24 .1 r
.46943 .66603 m
.48178 .68424 L
s
.42213 .48896 m
.43924 .46586 L
s
.265 .388 .766 r
.52407 .43555 m .51612 .43843 L .51105 .41876 L p F P
0 0 0 r
s
.265 .388 .766 r
.50563 .42076 m .51105 .41876 L .51612 .43843 L p F P
0 0 0 r
s
.197 .277 .557 r
.57019 .55515 m .55255 .56086 L .55032 .54046 L p F P
0 0 0 r
s
.197 .277 .557 r
.55032 .54046 m .56718 .53489 L .57019 .55515 L p F P
0 0 0 r
s
1 .306 .129 r
.4714 .41488 m .4746 .41836 L .46295 .43787 L p F P
0 0 0 r
s
1 .306 .129 r
.46295 .43787 m .45822 .43286 L .4714 .41488 L p F P
0 0 0 r
s
.83 .24 .1 r
.45965 .44515 m
.48261 .42756 L
s
1 .308 .129 r
.45346 .42781 m .45822 .43286 L .44612 .45218 L p F P
0 0 0 r
s
1 .308 .129 r
.44612 .45218 m .43991 .44577 L .45346 .42781 L p F P
0 0 0 r
s
.24 .35 .67 r
.43834 .4206 m
.44842 .43448 L
s
.979 .272 .109 r
.42843 .5944 m .41766 .5847 L .41928 .56541 L p F P
0 0 0 r
s
.913 .25 .099 r
.41766 .5847 m .42843 .5944 L .42864 .61188 L p F P
0 0 0 r
s
.913 .25 .099 r
.43919 .62123 m .42864 .61188 L .42843 .5944 L p F P
0 0 0 r
s
1 .302 .124 r
.41831 .51442 m .40865 .50516 L .41728 .48481 L p F P
0 0 0 r
s
1 .296 .121 r
.40865 .50516 m .41831 .51442 L .41246 .53529 L p F P
0 0 0 r
s
.245 .355 .705 r
.54134 .45192 m .55173 .44822 L .56215 .46779 L p F P
0 0 0 r
s
.255 .371 .736 r
.55173 .44822 m .54134 .45192 L .53206 .43265 L p F P
0 0 0 r
s
.255 .371 .736 r
.52407 .43555 m .53206 .43265 L .54134 .45192 L p F P
0 0 0 r
s
.181 .25 .506 r
.55361 .58014 m .5358 .58581 L .5351 .56651 L p F P
0 0 0 r
s
.181 .25 .506 r
.5351 .56651 m .55255 .56086 L .55361 .58014 L p F P
0 0 0 r
s
.24 .35 .67 r
.53361 .55948 m
.53547 .58501 L
s
.275 .404 .796 r
.49484 .42474 m .48946 .42672 L .4946 .40477 L p F P
0 0 0 r
s
.275 .404 .796 r
.49185 .4058 m .4946 .40477 L .48946 .42672 L p F P
0 0 0 r
s
.211 .299 .6 r
.58422 .52928 m .56718 .53489 L .56269 .51404 L p F P
0 0 0 r
s
.211 .299 .6 r
.56269 .51404 m .57856 .50871 L .58422 .52928 L p F P
0 0 0 r
s
.24 .35 .67 r
.52893 .53248 m
.56375 .52084 L
s
.55628 .49306 m
.56375 .52084 L
s
.809 .217 .084 r
.42864 .61188 m .43919 .62123 L .44077 .63611 L p F P
0 0 0 r
s
.809 .217 .084 r
.45086 .64493 m .44077 .63611 L .43919 .62123 L p F P
0 0 0 r
s
.83 .24 .1 r
.43956 .60298 m
.4415 .62652 L
s
.24 .35 .67 r
.44943 .6346 m
.46471 .62983 L
s
.83 .24 .1 r
.4415 .62652 m
.45087 .6348 L
s
.24 .35 .67 r
.337 .70644 m
.34946 .6958 L
s
.34946 .6958 m
.38277 .68572 L
s
1 .286 .116 r
.41928 .56541 m .40855 .55556 L .41246 .53529 L p F P
0 0 0 r
s
.979 .272 .109 r
.40855 .55556 m .41928 .56541 L .41766 .5847 L p F P
0 0 0 r
s
.83 .24 .1 r
.41842 .58391 m
.42188 .559 L
s
1 .303 .128 r
.48864 .40223 m .49025 .40402 L .48096 .42527 L p F P
0 0 0 r
s
1 .303 .128 r
.48096 .42527 m .47779 .42183 L .48864 .40223 L p F P
0 0 0 r
s
.24 .35 .67 r
.48176 .42082 m
.48705 .42832 L
s
.83 .24 .1 r
.48261 .42756 m
.49165 .42251 L
s
.265 .388 .766 r
.53206 .43265 m .52407 .43555 L .51649 .41675 L p F P
0 0 0 r
s
.265 .388 .766 r
.51105 .41876 m .51649 .41675 L .52407 .43555 L p F P
0 0 0 r
s
.83 .24 .1 r
.50863 .4152 m
.51162 .41855 L
s
.235 .338 .673 r
.58561 .48312 m .57115 .48808 L .56215 .46779 L p F P
0 0 0 r
s
.235 .338 .673 r
.56215 .46779 m .57474 .46339 L .58561 .48312 L p F P
0 0 0 r
s
.245 .355 .705 r
.57474 .46339 m .56215 .46779 L .55173 .44822 L p F P
0 0 0 r
s
.275 .404 .796 r
.50022 .42275 m .49484 .42474 L .49736 .40374 L p F P
0 0 0 r
s
.275 .404 .796 r
.4946 .40477 m .49736 .40374 L .49484 .42474 L p F P
0 0 0 r
s
.134 .176 .364 r
.5007 .62955 m .48392 .63473 L .48349 .61979 L p F P
0 0 0 r
s
.134 .176 .364 r
.48349 .61979 m .50072 .6144 L .5007 .62955 L p F P
0 0 0 r
s
.24 .35 .67 r
.46471 .62983 m
.49918 .61908 L
s
.224 .319 .638 r
.59457 .50333 m .57856 .50871 L .57115 .48808 L p F P
0 0 0 r
s
.224 .319 .638 r
.57115 .48808 m .58561 .48312 L .59457 .50333 L p F P
0 0 0 r
s
.16 .218 .444 r
.53569 .60345 m .51812 .60895 L .51817 .59142 L p F P
0 0 0 r
s
.16 .218 .444 r
.51817 .59142 m .5358 .58581 L .53569 .60345 L p F P
0 0 0 r
s
.24 .35 .67 r
.50071 .59608 m
.53547 .58501 L
s
.83 .24 .1 r
.75797 .62739 m
.75223 .65357 L
s
.74224 .60854 m
.75797 .62739 L
s
.72091 .53997 m
.71028 .51995 L
s
.6937 .4992 m
.71028 .51995 L
s
.53999 .72534 m
.55924 .74215 L
s
.55924 .74215 m
.58328 .74641 L
s
.245 .355 .705 r
.55173 .44822 m .56217 .4445 L .57474 .46339 L p F P
0 0 0 r
s
.255 .371 .736 r
.56217 .4445 m .55173 .44822 L .54008 .42974 L p F P
0 0 0 r
s
.255 .371 .736 r
.53206 .43265 m .54008 .42974 L .55173 .44822 L p F P
0 0 0 r
s
.24 .35 .67 r
.53493 .4395 m
.54656 .46565 L
s
.50035 .45196 m
.53493 .4395 L
s
.389 .41719 m
.42279 .40425 L
s
.389 .41719 m
.37284 .40581 L
s
.275 .404 .796 r
.50563 .42076 m .50022 .42275 L .50011 .40271 L p F P
0 0 0 r
s
.275 .404 .796 r
.49736 .40374 m .50011 .40271 L .50022 .42275 L p F P
0 0 0 r
s
.65 .169 .063 r
.44077 .63611 m .45086 .64493 L .45333 .65648 L p F P
0 0 0 r
s
.099 .122 .259 r
.46896 .65171 m .45333 .65648 L .45086 .64493 L p F P
0 0 0 r
s
.83 .24 .1 r
.45714 .65532 m
.46943 .66603 L
s
.099 .122 .259 r
.45086 .64493 m .46731 .63986 L .46896 .65171 L p F P
0 0 0 r
s
.24 .35 .67 r
.45963 .64947 m
.46471 .62983 L
s
1 .306 .129 r
.46818 .41138 m .4714 .41488 L .45822 .43286 L p F P
0 0 0 r
s
1 .306 .129 r
.45822 .43286 m .45346 .42781 L .46818 .41138 L p F P
0 0 0 r
s
.24 .35 .67 r
.25751 .43872 m
.28999 .42599 L
s
.25751 .43872 m
.24134 .43916 L
s
.265 .388 .766 r
.54008 .42974 m .53206 .43265 L .52195 .41474 L p F P
0 0 0 r
s
.265 .388 .766 r
.51649 .41675 m .52195 .41474 L .53206 .43265 L p F P
0 0 0 r
s
1 .296 .121 r
.41246 .53529 m .40204 .52554 L .40865 .50516 L p F P
0 0 0 r
s
1 .286 .116 r
.40204 .52554 m .41246 .53529 L .40855 .55556 L p F P
0 0 0 r
s
.83 .24 .1 r
.40896 .51364 m
.43024 .5339 L
s
1 .303 .128 r
.48703 .40043 m .48864 .40223 L .47779 .42183 L p F P
0 0 0 r
s
1 .303 .128 r
.47779 .42183 m .4746 .41836 L .48703 .40043 L p F P
0 0 0 r
s
1 .308 .128 r
.43363 .43928 m .43991 .44577 L .42777 .46489 L p F P
0 0 0 r
s
1 .308 .128 r
.42777 .46489 m .42014 .45721 L .43363 .43928 L p F P
0 0 0 r
s
1 .306 .127 r
.42014 .45721 m .42777 .46489 L .41728 .48481 L p F P
0 0 0 r
s
.197 .277 .557 r
.588 .54939 m .57019 .55515 L .56718 .53489 L p F P
0 0 0 r
s
.197 .277 .557 r
.56718 .53489 m .58422 .52928 L .588 .54939 L p F P
0 0 0 r
s
.24 .35 .67 r
.56375 .52084 m
.56871 .54804 L
s
.211 .299 .6 r
.60141 .5236 m .58422 .52928 L .57856 .50871 L p F P
0 0 0 r
s
.211 .299 .6 r
.57856 .50871 m .59457 .50333 L .60141 .5236 L p F P
0 0 0 r
s
.275 .404 .796 r
.51105 .41876 m .50563 .42076 L .50288 .40167 L p F P
0 0 0 r
s
.275 .404 .796 r
.50011 .40271 m .50288 .40167 L .50563 .42076 L p F P
0 0 0 r
s
.24 .35 .67 r
.41677 .67543 m
.42541 .65996 L
s
1 .308 .129 r
.44865 .42272 m .45346 .42781 L .43991 .44577 L p F P
0 0 0 r
s
1 .308 .129 r
.43991 .44577 m .43363 .43928 L .44865 .42272 L p F P
0 0 0 r
s
1 .306 .127 r
.41728 .48481 m .40846 .47615 L .42014 .45721 L p F P
0 0 0 r
s
1 .302 .124 r
.40846 .47615 m .41728 .48481 L .40865 .50516 L p F P
0 0 0 r
s
.83 .24 .1 r
.40896 .51364 m
.42213 .48896 L
s
.181 .25 .506 r
.57161 .57442 m .55361 .58014 L .55255 .56086 L p F P
0 0 0 r
s
.181 .25 .506 r
.55255 .56086 m .57019 .55515 L .57161 .57442 L p F P
0 0 0 r
s
.24 .35 .67 r
.53361 .55948 m
.56871 .54804 L
s
.235 .338 .673 r
.6002 .47813 m .58561 .48312 L .57474 .46339 L p F P
0 0 0 r
s
.235 .338 .673 r
.57474 .46339 m .58743 .45896 L .6002 .47813 L p F P
0 0 0 r
s
.245 .355 .705 r
.58743 .45896 m .57474 .46339 L .56217 .4445 L p F P
0 0 0 r
s
.245 .355 .705 r
.56217 .4445 m .57268 .44076 L .58743 .45896 L p F P
0 0 0 r
s
.255 .371 .736 r
.57268 .44076 m .56217 .4445 L .54814 .42682 L p F P
0 0 0 r
s
.255 .371 .736 r
.54008 .42974 m .54814 .42682 L .56217 .4445 L p F P
0 0 0 r
s
.265 .388 .766 r
.54814 .42682 m .54008 .42974 L .52742 .41272 L p F P
0 0 0 r
s
.265 .388 .766 r
.52195 .41474 m .52742 .41272 L .54008 .42974 L p F P
0 0 0 r
s
.83 .24 .1 r
.60935 .74501 m
.62746 .76154 L
s
.65397 .75463 m
.62746 .76154 L
s
.224 .319 .638 r
.61072 .49789 m .59457 .50333 L .58561 .48312 L p F P
0 0 0 r
s
.224 .319 .638 r
.58561 .48312 m .6002 .47813 L .61072 .49789 L p F P
0 0 0 r
s
.24 .35 .67 r
.55628 .49306 m
.59162 .48095 L
s
.275 .404 .796 r
.51649 .41675 m .51105 .41876 L .50565 .40063 L p F P
0 0 0 r
s
.83 .24 .1 r
.50845 .41333 m
.50933 .413 L
s
.275 .404 .796 r
.50288 .40167 m .50565 .40063 L .51105 .41876 L p F P
0 0 0 r
s
1 .303 .128 r
.48541 .39863 m .48703 .40043 L .4746 .41836 L p F P
0 0 0 r
s
1 .303 .128 r
.4746 .41836 m .4714 .41488 L .48541 .39863 L p F P
0 0 0 r
s
.134 .176 .364 r
.51764 .62432 m .5007 .62955 L .50072 .6144 L p F P
0 0 0 r
s
.24 .35 .67 r
.49918 .61908 m
.50071 .59608 L
s
.134 .176 .364 r
.50072 .6144 m .51812 .60895 L .51764 .62432 L p F P
0 0 0 r
s
.83 .24 .1 r
.6937 .4992 m
.67843 .4833 L
s
.24 .35 .67 r
.28849 .72158 m
.30393 .71638 L
s
.30393 .71638 m
.337 .70644 L
s
.16 .218 .444 r
.55345 .59789 m .53569 .60345 L .5358 .58581 L p F P
0 0 0 r
s
.16 .218 .444 r
.5358 .58581 m .55361 .58014 L .55345 .59789 L p F P
0 0 0 r
s
1 .306 .129 r
.46494 .40786 m .46818 .41138 L .45346 .42781 L p F P
0 0 0 r
s
.24 .35 .67 r
.43834 .4206 m
.46293 .41135 L
s
1 .306 .129 r
.45346 .42781 m .44865 .42272 L .46494 .40786 L p F P
0 0 0 r
s
.24 .35 .67 r
.3394 .4188 m
.37284 .40581 L
s
.3394 .4188 m
.32313 .41301 L
s
1 .302 .124 r
.40865 .50516 m .39883 .49575 L .40846 .47615 L p F P
0 0 0 r
s
1 .296 .121 r
.39883 .49575 m .40865 .50516 L .40204 .52554 L p F P
0 0 0 r
s
.83 .24 .1 r
.49885 .69848 m
.51892 .71585 L
s
.51892 .71585 m
.53999 .72534 L
s
.275 .404 .796 r
.52195 .41474 m .51649 .41675 L .50842 .3996 L p F P
0 0 0 r
s
.83 .24 .1 r
.51304 .41163 m
.51392 .4113 L
s
.275 .404 .796 r
.50565 .40063 m .50842 .3996 L .51649 .41675 L p F P
0 0 0 r
s
.24 .35 .67 r
.48705 .42832 m
.52174 .41553 L
s
.099 .122 .259 r
.48474 .6469 m .46896 .65171 L .46731 .63986 L p F P
0 0 0 r
s
.099 .122 .259 r
.46731 .63986 m .48392 .63473 L .48474 .6469 L p F P
0 0 0 r
s
.255 .371 .736 r
.54814 .42682 m .55624 .42388 L .57268 .44076 L p F P
0 0 0 r
s
.265 .388 .766 r
.55624 .42388 m .54814 .42682 L .53291 .41069 L p F P
0 0 0 r
s
.265 .388 .766 r
.52742 .41272 m .53291 .41069 L .54814 .42682 L p F P
0 0 0 r
s
.24 .35 .67 r
.52174 .41553 m
.53493 .4395 L
s
.979 .272 .109 r
.41766 .5847 m .4067 .57483 L .40855 .55556 L p F P
0 0 0 r
s
.913 .25 .099 r
.4067 .57483 m .41766 .5847 L .41791 .60236 L p F P
0 0 0 r
s
.913 .25 .099 r
.42864 .61188 m .41791 .60236 L .41766 .5847 L p F P
0 0 0 r
s
.235 .338 .673 r
.6149 .47308 m .6002 .47813 L .58743 .45896 L p F P
0 0 0 r
s
.235 .338 .673 r
.58743 .45896 m .60021 .45449 L .6149 .47308 L p F P
0 0 0 r
s
.245 .355 .705 r
.60021 .45449 m .58743 .45896 L .57268 .44076 L p F P
0 0 0 r
s
.245 .355 .705 r
.57268 .44076 m .58326 .43699 L .60021 .45449 L p F P
0 0 0 r
s
.24 .35 .67 r
.54656 .46565 m
.58182 .45325 L
s
.255 .371 .736 r
.58326 .43699 m .57268 .44076 L .55624 .42388 L p F P
0 0 0 r
s
.24 .35 .67 r
.58182 .45325 m
.59162 .48095 L
s
.809 .217 .084 r
.41791 .60236 m .42864 .61188 L .43052 .62713 L p F P
0 0 0 r
s
.83 .24 .1 r
.41842 .58391 m
.43956 .60298 L
s
.809 .217 .084 r
.44077 .63611 m .43052 .62713 L .42864 .61188 L p F P
0 0 0 r
s
.197 .277 .557 r
.60599 .54356 m .588 .54939 L .58422 .52928 L p F P
0 0 0 r
s
.197 .277 .557 r
.58422 .52928 m .60141 .5236 L .60599 .54356 L p F P
0 0 0 r
s
.211 .299 .6 r
.61878 .51788 m .60141 .5236 L .59457 .50333 L p F P
0 0 0 r
s
.211 .299 .6 r
.59457 .50333 m .61072 .49789 L .61878 .51788 L p F P
0 0 0 r
s
.24 .35 .67 r
.56375 .52084 m
.59929 .50897 L
s
.59162 .48095 m
.59929 .50897 L
s
1 .303 .128 r
.48379 .39682 m .48541 .39863 L .4714 .41488 L p F P
0 0 0 r
s
1 .303 .128 r
.4714 .41488 m .46818 .41138 L .48379 .39682 L p F P
0 0 0 r
s
.24 .35 .67 r
.4668 .40989 m
.47178 .40802 L
s
.275 .404 .796 r
.52742 .41272 m .52195 .41474 L .51119 .39856 L p F P
0 0 0 r
s
.83 .24 .1 r
.51764 .40992 m
.51853 .40959 L
s
.275 .404 .796 r
.50842 .3996 m .51119 .39856 L .52195 .41474 L p F P
0 0 0 r
s
1 .286 .116 r
.40855 .55556 m .39763 .54555 L .40204 .52554 L p F P
0 0 0 r
s
.979 .272 .109 r
.39763 .54555 m .40855 .55556 L .4067 .57483 L p F P
0 0 0 r
s
.83 .24 .1 r
.74241 .58311 m
.72628 .56333 L
s
.74224 .60854 m
.74241 .58311 L
s
1 .308 .129 r
.44381 .4176 m .44865 .42272 L .43363 .43928 L p F P
0 0 0 r
s
1 .308 .129 r
.43363 .43928 m .42728 .43273 L .44381 .4176 L p F P
0 0 0 r
s
.24 .35 .67 r
.42279 .40425 m
.43834 .4206 L
s
1 .308 .128 r
.42728 .43273 m .43363 .43928 L .42014 .45721 L p F P
0 0 0 r
s
.181 .25 .506 r
.58979 .56863 m .57161 .57442 L .57019 .55515 L p F P
0 0 0 r
s
.181 .25 .506 r
.57019 .55515 m .588 .54939 L .58979 .56863 L p F P
0 0 0 r
s
.24 .35 .67 r
.56871 .54804 m
.57094 .57372 L
s
1 .308 .128 r
.42014 .45721 m .41241 .44943 L .42728 .43273 L p F P
0 0 0 r
s
1 .306 .127 r
.41241 .44943 m .42014 .45721 L .40846 .47615 L p F P
0 0 0 r
s
.224 .319 .638 r
.62703 .49241 m .61072 .49789 L .6002 .47813 L p F P
0 0 0 r
s
.224 .319 .638 r
.6002 .47813 m .6149 .47308 L .62703 .49241 L p F P
0 0 0 r
s
.24 .35 .67 r
.20913 .45184 m
.24134 .43916 L
s
.20913 .45184 m
.19413 .4584 L
s
.37075 .69629 m
.38277 .68572 L
s
.38277 .68572 m
.41677 .67543 L
s
.255 .371 .736 r
.55624 .42388 m .56438 .42093 L .58326 .43699 L p F P
0 0 0 r
s
.265 .388 .766 r
.56438 .42093 m .55624 .42388 L .53842 .40866 L p F P
0 0 0 r
s
.265 .388 .766 r
.53291 .41069 m .53842 .40866 L .55624 .42388 L p F P
0 0 0 r
s
.83 .24 .1 r
.53421 .40573 m
.53715 .40913 L
s
.75223 .65357 m
.74091 .67945 L
s
.73626 .63504 m
.75223 .65357 L
s
.275 .404 .796 r
.53291 .41069 m .52742 .41272 L .51397 .39751 L p F P
0 0 0 r
s
.83 .24 .1 r
.52225 .40821 m
.52314 .40788 L
s
.275 .404 .796 r
.51119 .39856 m .51397 .39751 L .52742 .41272 L p F P
0 0 0 r
s
1 .297 .127 r
.49185 .4058 m .49025 .40402 L .5 .38446 L closepath p F P
0 0 0 r
s
.284 .42 .826 r
.5 .38446 m .4946 .40477 L .49185 .4058 L closepath p F P
0 0 0 r
s
1 .306 .129 r
.46168 .40433 m .46494 .40786 L .44865 .42272 L p F P
0 0 0 r
s
1 .306 .129 r
.44865 .42272 m .44381 .4176 L .46168 .40433 L p F P
0 0 0 r
s
.65 .169 .063 r
.43052 .62713 m .44077 .63611 L .44377 .64819 L p F P
0 0 0 r
s
.65 .169 .063 r
.45333 .65648 m .44377 .64819 L .44077 .63611 L p F P
0 0 0 r
s
.83 .24 .1 r
.4415 .62652 m
.44866 .64794 L
s
.24 .35 .67 r
.42541 .65996 m
.449 .65273 L
s
.45186 .65185 m
.45963 .64947 L
s
.83 .24 .1 r
.44866 .64794 m
.4534 .65206 L
s
.134 .176 .364 r
.53475 .61904 m .51764 .62432 L .51812 .60895 L p F P
0 0 0 r
s
.134 .176 .364 r
.51812 .60895 m .53569 .60345 L .53475 .61904 L p F P
0 0 0 r
s
.24 .35 .67 r
.49918 .61908 m
.53436 .60811 L
s
.245 .355 .705 r
.61308 .44999 m .60021 .45449 L .58326 .43699 L p F P
0 0 0 r
s
.245 .355 .705 r
.58326 .43699 m .59389 .4332 L .61308 .44999 L p F P
0 0 0 r
s
.255 .371 .736 r
.59389 .4332 m .58326 .43699 L .56438 .42093 L p F P
0 0 0 r
s
1 .306 .127 r
.40846 .47615 m .39951 .46737 L .41241 .44943 L p F P
0 0 0 r
s
1 .302 .124 r
.39951 .46737 m .40846 .47615 L .39883 .49575 L p F P
0 0 0 r
s
.83 .24 .1 r
.40045 .46767 m
.42213 .48896 L
s
1 .303 .128 r
.48216 .39501 m .48379 .39682 L .46818 .41138 L p F P
0 0 0 r
s
1 .303 .128 r
.46818 .41138 m .46494 .40786 L .48216 .39501 L p F P
0 0 0 r
s
.83 .24 .1 r
.46096 .66623 m
.48178 .68424 L
s
.48178 .68424 m
.49885 .69848 L
s
.284 .42 .826 r
.5 .38446 m .49736 .40374 L .4946 .40477 L closepath p F P
0 0 0 r
s
1 .296 .121 r
.40204 .52554 m .39145 .51561 L .39883 .49575 L p F P
0 0 0 r
s
1 .286 .116 r
.39145 .51561 m .40204 .52554 L .39763 .54555 L p F P
0 0 0 r
s
.83 .24 .1 r
.40028 .53902 m
.40896 .51364 L
s
.40028 .53902 m
.42188 .559 L
s
.235 .338 .673 r
.62973 .468 m .6149 .47308 L .60021 .45449 L p F P
0 0 0 r
s
.235 .338 .673 r
.60021 .45449 m .61308 .44999 L .62973 .468 L p F P
0 0 0 r
s
.16 .218 .444 r
.57138 .59227 m .55345 .59789 L .55361 .58014 L p F P
0 0 0 r
s
.16 .218 .444 r
.55361 .58014 m .57161 .57442 L .57138 .59227 L p F P
0 0 0 r
s
.24 .35 .67 r
.53547 .58501 m
.57094 .57372 L
s
.275 .404 .796 r
.53842 .40866 m .53291 .41069 L .51676 .39647 L p F P
0 0 0 r
s
.83 .24 .1 r
.52688 .4065 m
.52777 .40617 L
s
.53293 .40425 m
.53421 .40573 L
s
.275 .404 .796 r
.51397 .39751 m .51676 .39647 L .53291 .41069 L p F P
0 0 0 r
s
.83 .24 .1 r
.53152 .40478 m
.53293 .40425 L
s
1 .297 .127 r
.49025 .40402 m .48864 .40223 L .5 .38446 L closepath p F P
0 0 0 r
s
.284 .42 .826 r
.5 .38446 m .50011 .40271 L .49736 .40374 L closepath p F P
0 0 0 r
s
.255 .371 .736 r
.56438 .42093 m .57255 .41797 L .59389 .4332 L p F P
0 0 0 r
s
.24 .35 .67 r
.5702 .42679 m
.58182 .45325 L
s
.53493 .4395 m
.5702 .42679 L
s
.265 .388 .766 r
.57255 .41797 m .56438 .42093 L .54394 .40662 L p F P
0 0 0 r
s
.265 .388 .766 r
.53842 .40866 m .54394 .40662 L .56438 .42093 L p F P
0 0 0 r
s
.099 .122 .259 r
.50066 .64204 m .48474 .6469 L .48392 .63473 L p F P
0 0 0 r
s
.099 .122 .259 r
.48392 .63473 m .5007 .62955 L .50066 .64204 L p F P
0 0 0 r
s
.24 .35 .67 r
.49456 .63876 m
.49918 .61908 L
s
.83 .24 .1 r
.63619 .73785 m
.65397 .75463 L
s
.67986 .74226 m
.65397 .75463 L
s
.24 .35 .67 r
.28999 .42599 m
.32313 .41301 L
s
.28999 .42599 m
.27421 .42621 L
s
.211 .299 .6 r
.63632 .51209 m .61878 .51788 L .61072 .49789 L p F P
0 0 0 r
s
.211 .299 .6 r
.61072 .49789 m .62703 .49241 L .63632 .51209 L p F P
0 0 0 r
s
.284 .42 .826 r
.5 .38446 m .50288 .40167 L .50011 .40271 L closepath p F P
0 0 0 r
s
.197 .277 .557 r
.62417 .53768 m .60599 .54356 L .60141 .5236 L p F P
0 0 0 r
s
.197 .277 .557 r
.60141 .5236 m .61878 .51788 L .62417 .53768 L p F P
0 0 0 r
s
.24 .35 .67 r
.59929 .50897 m
.60453 .53636 L
s
.83 .24 .1 r
.56423 .72948 m
.58328 .74641 L
s
.58328 .74641 m
.60935 .74501 L
s
1 .297 .127 r
.48864 .40223 m .48703 .40043 L .5 .38446 L closepath p F P
0 0 0 r
s
.275 .404 .796 r
.54394 .40662 m .53842 .40866 L .51955 .39542 L p F P
0 0 0 r
s
.275 .404 .796 r
.51676 .39647 m .51955 .39542 L .53842 .40866 L p F P
0 0 0 r
s
.224 .319 .638 r
.64348 .48688 m .62703 .49241 L .6149 .47308 L p F P
0 0 0 r
s
.224 .319 .638 r
.6149 .47308 m .62973 .468 L .64348 .48688 L p F P
0 0 0 r
s
.24 .35 .67 r
.59162 .48095 m
.62769 .46858 L
s
.284 .42 .826 r
.5 .38446 m .50565 .40063 L .50288 .40167 L closepath p F P
0 0 0 r
s
1 .303 .128 r
.48053 .3932 m .48216 .39501 L .46494 .40786 L p F P
0 0 0 r
s
1 .303 .128 r
.46494 .40786 m .46168 .40433 L .48053 .3932 L p F P
0 0 0 r
s
.83 .24 .1 r
.46204 .40522 m
.48261 .42756 L
s
.245 .355 .705 r
.62605 .44546 m .61308 .44999 L .59389 .4332 L p F P
0 0 0 r
s
.245 .355 .705 r
.59389 .4332 m .60459 .42939 L .62605 .44546 L p F P
0 0 0 r
s
.255 .371 .736 r
.60459 .42939 m .59389 .4332 L .57255 .41797 L p F P
0 0 0 r
s
.181 .25 .506 r
.60816 .56279 m .58979 .56863 L .588 .54939 L p F P
0 0 0 r
s
.181 .25 .506 r
.588 .54939 m .60599 .54356 L .60816 .56279 L p F P
0 0 0 r
s
.24 .35 .67 r
.56871 .54804 m
.60453 .53636 L
s
1 .308 .129 r
.43893 .41243 m .44381 .4176 L .42728 .43273 L p F P
0 0 0 r
s
1 .308 .129 r
.42728 .43273 m .42087 .42611 L .43893 .41243 L p F P
0 0 0 r
s
.83 .24 .1 r
.43871 .42317 m
.45965 .44515 L
s
1 .308 .128 r
.42087 .42611 m .42728 .43273 L .41241 .44943 L p F P
0 0 0 r
s
.255 .371 .736 r
.57255 .41797 m .58077 .41499 L .60459 .42939 L p F P
0 0 0 r
s
.83 .24 .1 r
.59317 .42249 m
.60176 .42271 L
s
.60176 .42271 m
.61156 .43461 L
s
.265 .388 .766 r
.58077 .41499 m .57255 .41797 L .54949 .40458 L p F P
0 0 0 r
s
.265 .388 .766 r
.54394 .40662 m .54949 .40458 L .57255 .41797 L p F P
0 0 0 r
s
.83 .24 .1 r
.5645 .40669 m
.56788 .4107 L
s
.284 .42 .826 r
.5 .38446 m .50842 .3996 L .50565 .40063 L closepath p F P
0 0 0 r
s
1 .297 .127 r
.48703 .40043 m .48541 .39863 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .302 .124 r
.39883 .49575 m .38885 .48619 L .39951 .46737 L p F P
0 0 0 r
s
1 .296 .121 r
.38885 .48619 m .39883 .49575 L .39145 .51561 L p F P
0 0 0 r
s
1 .306 .129 r
.4584 .40077 m .46168 .40433 L .44381 .4176 L p F P
0 0 0 r
s
1 .306 .129 r
.44381 .4176 m .43893 .41243 L .4584 .40077 L p F P
0 0 0 r
s
.83 .24 .1 r
.72628 .56333 m
.72091 .53997 L
s
.70431 .51931 m
.72091 .53997 L
s
.275 .404 .796 r
.54949 .40458 m .54394 .40662 L .52234 .39438 L p F P
0 0 0 r
s
.83 .24 .1 r
.5371 .40348 m
.53808 .4033 L
s
.275 .404 .796 r
.51955 .39542 m .52234 .39438 L .54394 .40662 L p F P
0 0 0 r
s
.83 .24 .1 r
.43871 .42317 m
.46204 .40522 L
s
.235 .338 .673 r
.64468 .46288 m .62973 .468 L .61308 .44999 L p F P
0 0 0 r
s
.235 .338 .673 r
.61308 .44999 m .62605 .44546 L .64468 .46288 L p F P
0 0 0 r
s
.284 .42 .826 r
.5 .38446 m .51119 .39856 L .50842 .3996 L closepath p F P
0 0 0 r
s
1 .308 .128 r
.41241 .44943 m .40459 .44156 L .42087 .42611 L p F P
0 0 0 r
s
.83 .24 .1 r
.41794 .44424 m
.43871 .42317 L
s
.41794 .44424 m
.43924 .46586 L
s
1 .306 .127 r
.40459 .44156 m .41241 .44943 L .39951 .46737 L p F P
0 0 0 r
s
.134 .176 .364 r
.55203 .61371 m .53475 .61904 L .53569 .60345 L p F P
0 0 0 r
s
.24 .35 .67 r
.53436 .60811 m
.53547 .58501 L
s
.134 .176 .364 r
.53569 .60345 m .55345 .59789 L .55203 .61371 L p F P
0 0 0 r
s
.83 .24 .1 r
.74091 .67945 m
.7245 .70368 L
s
.72464 .66127 m
.74091 .67945 L
s
1 .297 .127 r
.48541 .39863 m .48379 .39682 L .5 .38446 L closepath p F P
0 0 0 r
s
.066 .08 .157 r
.47139 .66034 m .45696 .6647 L .45333 .65648 L p F P
0 0 0 r
s
.83 .24 .1 r
.45943 .66396 m
.46096 .66623 L
s
.066 .08 .157 r
.45333 .65648 m .46896 .65171 L .47139 .66034 L p F P
0 0 0 r
s
.507 .125 .048 r
.44377 .64819 m .45333 .65648 L .45696 .6647 L p F P
0 0 0 r
s
.284 .42 .826 r
.5 .38446 m .51397 .39751 L .51119 .39856 L closepath p F P
0 0 0 r
s
.979 .272 .109 r
.4067 .57483 m .39554 .56478 L .39763 .54555 L p F P
0 0 0 r
s
.913 .25 .099 r
.39554 .56478 m .4067 .57483 L .40699 .59268 L p F P
0 0 0 r
s
.913 .25 .099 r
.41791 .60236 m .40699 .59268 L .4067 .57483 L p F P
0 0 0 r
s
.265 .388 .766 r
.54949 .40458 m .55505 .40253 L .58077 .41499 L p F P
0 0 0 r
s
.275 .404 .796 r
.55505 .40253 m .54949 .40458 L .52514 .39333 L p F P
0 0 0 r
s
.83 .24 .1 r
.54345 .40231 m
.54426 .40216 L
s
.275 .404 .796 r
.52234 .39438 m .52514 .39333 L .54949 .40458 L p F P
0 0 0 r
s
.24 .35 .67 r
.32198 .71152 m
.337 .70644 L
s
.337 .70644 m
.37075 .69629 L
s
1 .303 .128 r
.4789 .39138 m .48053 .3932 L .46168 .40433 L p F P
0 0 0 r
s
1 .303 .128 r
.46168 .40433 m .4584 .40077 L .4789 .39138 L p F P
0 0 0 r
s
.255 .371 .736 r
.61536 .42556 m .60459 .42939 L .58077 .41499 L p F P
0 0 0 r
s
.255 .371 .736 r
.58077 .41499 m .58902 .41199 L .61536 .42556 L p F P
0 0 0 r
s
.265 .388 .766 r
.58902 .41199 m .58077 .41499 L .55505 .40253 L p F P
0 0 0 r
s
.16 .218 .444 r
.58951 .5866 m .57138 .59227 L .57161 .57442 L p F P
0 0 0 r
s
.16 .218 .444 r
.57161 .57442 m .58979 .56863 L .58951 .5866 L p F P
0 0 0 r
s
.24 .35 .67 r
.37284 .40581 m
.40698 .39257 L
s
.37284 .40581 m
.35696 .39975 L
s
.809 .217 .084 r
.40699 .59268 m .41791 .60236 L .42008 .618 L p F P
0 0 0 r
s
.809 .217 .084 r
.43052 .62713 m .42008 .618 L .41791 .60236 L p F P
0 0 0 r
s
.83 .24 .1 r
.41842 .58391 m
.42014 .60765 L
s
.284 .42 .826 r
.5 .38446 m .51676 .39647 L .51397 .39751 L closepath p F P
0 0 0 r
s
.245 .355 .705 r
.63911 .4409 m .62605 .44546 L .60459 .42939 L p F P
0 0 0 r
s
.83 .24 .1 r
.63517 .44227 m
.64201 .45071 L
s
.245 .355 .705 r
.60459 .42939 m .61536 .42556 L .63911 .4409 L p F P
0 0 0 r
s
.24 .35 .67 r
.58182 .45325 m
.6178 .4406 L
s
.099 .122 .259 r
.51674 .63714 m .50066 .64204 L .5007 .62955 L p F P
0 0 0 r
s
.099 .122 .259 r
.5007 .62955 m .51764 .62432 L .51674 .63714 L p F P
0 0 0 r
s
1 .297 .127 r
.48379 .39682 m .48216 .39501 L .5 .38446 L closepath p F P
0 0 0 r
s
.211 .299 .6 r
.65403 .50625 m .63632 .51209 L .62703 .49241 L p F P
0 0 0 r
s
.211 .299 .6 r
.62703 .49241 m .64348 .48688 L .65403 .50625 L p F P
0 0 0 r
s
.24 .35 .67 r
.59929 .50897 m
.63555 .49685 L
s
.83 .24 .1 r
.66246 .72517 m
.67986 .74226 L
s
.70379 .72498 m
.67986 .74226 L
s
1 .286 .116 r
.39763 .54555 m .38652 .53535 L .39145 .51561 L p F P
0 0 0 r
s
.979 .272 .109 r
.38652 .53535 m .39763 .54555 L .39554 .56478 L p F P
0 0 0 r
s
.83 .24 .1 r
.39653 .56417 m
.40028 .53902 L
s
.284 .42 .826 r
.5 .38446 m .51955 .39542 L .51676 .39647 L closepath p F P
0 0 0 r
s
.224 .319 .638 r
.66009 .4813 m .64348 .48688 L .62973 .468 L p F P
0 0 0 r
s
.224 .319 .638 r
.62973 .468 m .64468 .46288 L .66009 .4813 L p F P
0 0 0 r
s
.197 .277 .557 r
.64253 .53173 m .62417 .53768 L .61878 .51788 L p F P
0 0 0 r
s
.197 .277 .557 r
.61878 .51788 m .63632 .51209 L .64253 .53173 L p F P
0 0 0 r
s
.265 .388 .766 r
.55505 .40253 m .56063 .40047 L .58902 .41199 L p F P
0 0 0 r
s
.275 .404 .796 r
.56063 .40047 m .55505 .40253 L .52795 .39228 L p F P
0 0 0 r
s
.275 .404 .796 r
.52514 .39333 m .52795 .39228 L .55505 .40253 L p F P
0 0 0 r
s
.24 .35 .67 r
.52174 .41553 m
.55714 .40248 L
s
.62769 .46858 m
.63555 .49685 L
s
.6178 .4406 m
.62769 .46858 L
s
1 .306 .127 r
.39951 .46737 m .39043 .45845 L .40459 .44156 L p F P
0 0 0 r
s
.83 .24 .1 r
.40045 .46767 m
.41794 .44424 L
s
1 .302 .124 r
.39043 .45845 m .39951 .46737 L .38885 .48619 L p F P
0 0 0 r
s
.284 .42 .826 r
.5 .38446 m .52234 .39438 L .51955 .39542 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.50743 .39461 m
.52174 .41553 L
s
.235 .338 .673 r
.65976 .45771 m .64468 .46288 L .62605 .44546 L p F P
0 0 0 r
s
.83 .24 .1 r
.64201 .45071 m
.64456 .45219 L
s
.235 .338 .673 r
.62605 .44546 m .63911 .4409 L .65976 .45771 L p F P
0 0 0 r
s
1 .306 .129 r
.45511 .39719 m .4584 .40077 L .43893 .41243 L p F P
0 0 0 r
s
1 .306 .129 r
.43893 .41243 m .43401 .40721 L .45511 .39719 L p F P
0 0 0 r
s
1 .308 .129 r
.43401 .40721 m .43893 .41243 L .42087 .42611 L p F P
0 0 0 r
s
1 .297 .127 r
.48216 .39501 m .48053 .3932 L .5 .38446 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.48645 .4025 m
.50743 .39461 L
s
.752 .23 .102 r
.58471 .40678 m .58902 .41199 L .61536 .42556 L p F P
0 0 0 r
s
.856 .258 .113 r
.58902 .41199 m .58471 .40678 L .55762 .39689 L p F P
0 0 0 r
s
.856 .258 .113 r
.55762 .39689 m .56063 .40047 L .58902 .41199 L p F P
0 0 0 r
s
.24 .35 .67 r
.55714 .40248 m
.5702 .42679 L
s
.65 .169 .063 r
.42008 .618 m .43052 .62713 L .43407 .63977 L p F P
0 0 0 r
s
.83 .24 .1 r
.42014 .60765 m
.4415 .62652 L
s
.65 .169 .063 r
.44377 .64819 m .43407 .63977 L .43052 .62713 L p F P
0 0 0 r
s
.83 .24 .1 r
.7245 .70368 m
.70379 .72498 L
s
.70788 .68587 m
.7245 .70368 L
s
.181 .25 .506 r
.62672 .55688 m .60816 .56279 L .60599 .54356 L p F P
0 0 0 r
s
.181 .25 .506 r
.60599 .54356 m .62417 .53768 L .62672 .55688 L p F P
0 0 0 r
s
.24 .35 .67 r
.60453 .53636 m
.60713 .56219 L
s
.284 .42 .826 r
.5 .38446 m .52514 .39333 L .52234 .39438 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.73626 .63504 m
.74224 .60854 L
s
.72594 .58902 m
.74224 .60854 L
s
.70431 .51931 m
.6937 .4992 L
s
1 .303 .128 r
.47726 .38955 m .4789 .39138 L .4584 .40077 L p F P
0 0 0 r
s
1 .303 .128 r
.4584 .40077 m .45511 .39719 L .47726 .38955 L p F P
0 0 0 r
s
.83 .24 .1 r
.52003 .70792 m
.53999 .72534 L
s
.53999 .72534 m
.56423 .72948 L
s
1 .308 .129 r
.42087 .42611 m .41439 .41942 L .43401 .40721 L p F P
0 0 0 r
s
1 .308 .128 r
.41439 .41942 m .42087 .42611 L .40459 .44156 L p F P
0 0 0 r
s
.24 .35 .67 r
.24134 .43916 m
.27421 .42621 L
s
.24134 .43916 m
.22674 .44557 L
s
.927 .276 .12 r
.56063 .40047 m .55762 .39689 L .52919 .3894 L p F P
0 0 0 r
s
.927 .276 .12 r
.52919 .3894 m .53075 .39123 L .56063 .40047 L p F P
0 0 0 r
s
.275 .404 .796 r
.52795 .39228 m .53075 .39123 L .56063 .40047 L p F P
0 0 0 r
s
.24 .35 .67 r
.55714 .40248 m
.56336 .40019 L
s
.83 .24 .1 r
.54905 .40128 m
.55848 .39954 L
s
.55848 .39954 m
.56183 .40351 L
s
1 .296 .121 r
.39145 .51561 m .38068 .50552 L .38885 .48619 L p F P
0 0 0 r
s
1 .286 .116 r
.38068 .50552 m .39145 .51561 L .38652 .53535 L p F P
0 0 0 r
s
.83 .24 .1 r
.68679 .70755 m
.70379 .72498 L
s
.24 .35 .67 r
.4052 .68593 m
.41677 .67543 L
s
.41677 .67543 m
.45146 .66493 L
s
.601 .189 .087 r
.6099 .41886 m .61536 .42556 L .63911 .4409 L p F P
0 0 0 r
s
.752 .23 .102 r
.61536 .42556 m .6099 .41886 L .58471 .40678 L p F P
0 0 0 r
s
.24 .35 .67 r
.60953 .42151 m
.6178 .4406 L
s
.60231 .41522 m
.6062 .41382 L
s
.5702 .42679 m
.59891 .41645 L
s
.6062 .41382 m
.60799 .41794 L
s
.284 .42 .826 r
.5 .38446 m .52795 .39228 L .52514 .39333 L closepath p F P
0 0 0 r
s
1 .297 .127 r
.48053 .3932 m .4789 .39138 L .5 .38446 L closepath p F P
0 0 0 r
s
.066 .08 .157 r
.48594 .65595 m .47139 .66034 L .46896 .65171 L p F P
0 0 0 r
s
.066 .08 .157 r
.46896 .65171 m .48474 .6469 L .48594 .65595 L p F P
0 0 0 r
s
.24 .35 .67 r
.45963 .64947 m
.49456 .63876 L
s
.284 .42 .826 r
.5 .38446 m .53075 .39123 L .52795 .39228 L closepath p F P
0 0 0 r
s
.134 .176 .364 r
.56948 .60832 m .55203 .61371 L .55345 .59789 L p F P
0 0 0 r
s
.134 .176 .364 r
.55345 .59789 m .57138 .59227 L .56948 .60832 L p F P
0 0 0 r
s
1 .297 .127 r
.4789 .39138 m .47726 .38955 L .5 .38446 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.48709 .39105 m
.4993 .40473 L
s
.978 .289 .124 r
.5 .38446 m .53075 .39123 L .52919 .3894 L closepath p F P
0 0 0 r
s
1 .308 .128 r
.40459 .44156 m .39666 .43358 L .41439 .41942 L p F P
0 0 0 r
s
1 .306 .127 r
.39666 .43358 m .40459 .44156 L .39043 .45845 L p F P
0 0 0 r
s
.099 .122 .259 r
.53296 .63219 m .51674 .63714 L .51764 .62432 L p F P
0 0 0 r
s
.099 .122 .259 r
.51764 .62432 m .53475 .61904 L .53296 .63219 L p F P
0 0 0 r
s
.224 .319 .638 r
.67686 .47566 m .66009 .4813 L .64468 .46288 L p F P
0 0 0 r
s
.83 .24 .1 r
.67327 .47686 m
.67843 .4833 L
s
.224 .319 .638 r
.64468 .46288 m .65976 .45771 L .67686 .47566 L p F P
0 0 0 r
s
.16 .218 .444 r
.60782 .58087 m .58951 .5866 L .58979 .56863 L p F P
0 0 0 r
s
.16 .218 .444 r
.58979 .56863 m .60816 .56279 L .60782 .58087 L p F P
0 0 0 r
s
.24 .35 .67 r
.57094 .57372 m
.60713 .56219 L
s
.211 .299 .6 r
.67191 .50035 m .65403 .50625 L .64348 .48688 L p F P
0 0 0 r
s
.211 .299 .6 r
.64348 .48688 m .66009 .4813 L .67191 .50035 L p F P
0 0 0 r
s
1 .303 .128 r
.47561 .38772 m .47726 .38955 L .45511 .39719 L p F P
0 0 0 r
s
1 .303 .128 r
.45511 .39719 m .4518 .39359 L .47561 .38772 L p F P
0 0 0 r
s
.24 .35 .67 r
.45727 .39105 m
.45816 .39202 L
s
.83 .24 .1 r
.46204 .40522 m
.48709 .39105 L
s
1 .306 .129 r
.4518 .39359 m .45511 .39719 L .43401 .40721 L p F P
0 0 0 r
s
.24 .35 .67 r
.42279 .40425 m
.45727 .39105 L
s
.453 .143 .069 r
.63267 .43291 m .63911 .4409 L .65976 .45771 L p F P
0 0 0 r
s
.601 .189 .087 r
.63911 .4409 m .63267 .43291 L .6099 .41886 L p F P
0 0 0 r
s
.24 .35 .67 r
.6178 .4406 m
.63172 .4357 L
s
.856 .258 .113 r
.55459 .39329 m .55762 .39689 L .58471 .40678 L p F P
0 0 0 r
s
.927 .276 .12 r
.55762 .39689 m .55459 .39329 L .52762 .38757 L p F P
0 0 0 r
s
.927 .276 .12 r
.52762 .38757 m .52919 .3894 L .55762 .39689 L p F P
0 0 0 r
s
1 .302 .124 r
.38885 .48619 m .37871 .47647 L .39043 .45845 L p F P
0 0 0 r
s
1 .296 .121 r
.37871 .47647 m .38885 .48619 L .38068 .50552 L p F P
0 0 0 r
s
.83 .24 .1 r
.38692 .49266 m
.40045 .46767 L
s
.38692 .49266 m
.40896 .51364 L
s
.197 .277 .557 r
.66109 .52572 m .64253 .53173 L .63632 .51209 L p F P
0 0 0 r
s
.197 .277 .557 r
.63632 .51209 m .65403 .50625 L .66109 .52572 L p F P
0 0 0 r
s
.24 .35 .67 r
.63555 .49685 m
.64109 .52445 L
s
.83 .24 .1 r
.59058 .72789 m
.60935 .74501 L
s
.60935 .74501 m
.63619 .73785 L
s
1 .306 .129 r
.43401 .40721 m .42905 .40196 L .4518 .39359 L p F P
0 0 0 r
s
1 .308 .129 r
.42905 .40196 m .43401 .40721 L .41439 .41942 L p F P
0 0 0 r
s
1 .297 .127 r
.47726 .38955 m .47561 .38772 L .5 .38446 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.32313 .41301 m
.35696 .39975 L
s
.32313 .41301 m
.30777 .413 L
s
.978 .289 .124 r
.5 .38446 m .52919 .3894 L .52762 .38757 L closepath p F P
0 0 0 r
s
.752 .23 .102 r
.58036 .40152 m .58471 .40678 L .6099 .41886 L p F P
0 0 0 r
s
.856 .258 .113 r
.58471 .40678 m .58036 .40152 L .55459 .39329 L p F P
0 0 0 r
s
.24 .35 .67 r
.552 .39473 m
.55714 .40248 L
s
.27109 .72076 m
.28849 .72158 L
s
.28849 .72158 m
.32198 .71152 L
s
.507 .125 .048 r
.43407 .63977 m .44377 .64819 L .44819 .65713 L p F P
0 0 0 r
s
.507 .125 .048 r
.45696 .6647 m .44819 .65713 L .44377 .64819 L p F P
0 0 0 r
s
.24 .35 .67 r
.45146 .66493 m
.45264 .6627 L
s
.45264 .6627 m
.45327 .66151 L
s
.45416 .65981 m
.45963 .64947 L
s
.83 .24 .1 r
.44866 .64794 m
.4569 .66019 L
s
.181 .25 .506 r
.64548 .55091 m .62672 .55688 L .62417 .53768 L p F P
0 0 0 r
s
.181 .25 .506 r
.62417 .53768 m .64253 .53173 L .64548 .55091 L p F P
0 0 0 r
s
.24 .35 .67 r
.60453 .53636 m
.64109 .52445 L
s
1 .297 .127 r
.47561 .38772 m .47396 .38588 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .303 .128 r
.47396 .38588 m .47561 .38772 L .4518 .39359 L p F P
0 0 0 r
s
.927 .276 .12 r
.52604 .38573 m .52762 .38757 L .55459 .39329 L p F P
0 0 0 r
s
.978 .289 .124 r
.5 .38446 m .52762 .38757 L .52604 .38573 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.47805 .68048 m
.49885 .69848 L
s
.49885 .69848 m
.52003 .70792 L
s
1 .308 .129 r
.41439 .41942 m .40784 .41266 L .42905 .40196 L p F P
0 0 0 r
s
1 .308 .128 r
.40784 .41266 m .41439 .41942 L .39666 .43358 L p F P
0 0 0 r
s
1 .303 .128 r
.4518 .39359 m .44847 .38997 L .47396 .38588 L p F P
0 0 0 r
s
1 .306 .129 r
.44847 .38997 m .4518 .39359 L .42905 .40196 L p F P
0 0 0 r
s
.978 .289 .124 r
.5 .38446 m .52287 .38204 L .52129 .38019 L closepath p F P
0 0 0 r
s
.978 .289 .124 r
.5 .38446 m .52604 .38573 L .52446 .38389 L closepath p F P
0 0 0 r
s
.978 .289 .124 r
.5 .38446 m .52446 .38389 L .52287 .38204 L closepath p F P
0 0 0 r
s
.978 .289 .124 r
.5 .38446 m .52129 .38019 L .51969 .37833 L closepath p F P
0 0 0 r
s
.978 .289 .124 r
.5 .38446 m .51969 .37833 L .51809 .37647 L closepath p F P
0 0 0 r
s
.978 .289 .124 r
.5 .38446 m .51809 .37647 L .51649 .3746 L closepath p F P
0 0 0 r
s
.978 .289 .124 r
.5 .38446 m .51649 .3746 L .51488 .37273 L closepath p F P
0 0 0 r
s
.978 .289 .124 r
.5 .38446 m .51488 .37273 L .51327 .37085 L closepath p F P
0 0 0 r
s
.978 .289 .124 r
.5 .38446 m .51327 .37085 L .51165 .36896 L closepath p F P
0 0 0 r
s
.978 .289 .124 r
.5 .38446 m .51165 .36896 L .51003 .36707 L closepath p F P
0 0 0 r
s
.978 .289 .124 r
.5 .38446 m .51003 .36707 L .50841 .36518 L closepath p F P
0 0 0 r
s
1 .297 .127 r
.47231 .38404 m .47065 .3822 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .297 .127 r
.47396 .38588 m .47231 .38404 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .297 .127 r
.47065 .3822 m .46899 .38034 L .5 .38446 L closepath p F P
0 0 0 r
s
.292 .436 .854 r
.47177 .37927 m .46899 .38034 L .5 .38446 L closepath p F P
0 0 0 r
s
.292 .436 .854 r
.47456 .3782 m .47177 .37927 L .5 .38446 L closepath p F P
0 0 0 r
s
.292 .436 .854 r
.47736 .37712 m .47456 .3782 L .5 .38446 L closepath p F P
0 0 0 r
s
.292 .436 .854 r
.48016 .37605 m .47736 .37712 L .5 .38446 L closepath p F P
0 0 0 r
s
.292 .436 .854 r
.48296 .37497 m .48016 .37605 L .5 .38446 L closepath p F P
0 0 0 r
s
.292 .436 .854 r
.48577 .37389 m .48296 .37497 L .5 .38446 L closepath p F P
0 0 0 r
s
.292 .436 .854 r
.48858 .37281 m .48577 .37389 L .5 .38446 L closepath p F P
0 0 0 r
s
.292 .436 .854 r
.4914 .37172 m .48858 .37281 L .5 .38446 L closepath p F P
0 0 0 r
s
.292 .436 .854 r
.49422 .37064 m .4914 .37172 L .5 .38446 L closepath p F P
0 0 0 r
s
.292 .436 .854 r
.49705 .36955 m .49422 .37064 L .5 .38446 L closepath p F P
0 0 0 r
s
.292 .436 .854 r
.49988 .36846 m .49705 .36955 L .5 .38446 L closepath p F P
0 0 0 r
s
.292 .436 .854 r
.50272 .36737 m .49988 .36846 L .5 .38446 L closepath p F P
0 0 0 r
s
.292 .436 .854 r
.50556 .36627 m .50272 .36737 L .5 .38446 L closepath p F P
0 0 0 r
s
.292 .436 .854 r
.50841 .36518 m .50556 .36627 L .5 .38446 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.49247 .37758 m
.50743 .39461 L
s
.83 .24 .1 r
.48709 .39105 m
.513 .38121 L
s
.856 .258 .113 r
.55154 .38967 m .55459 .39329 L .58036 .40152 L p F P
0 0 0 r
s
.927 .276 .12 r
.55459 .39329 m .55154 .38967 L .52604 .38573 L p F P
0 0 0 r
s
.24 .35 .67 r
.50743 .39461 m
.52867 .38662 L
s
.066 .08 .157 r
.50061 .65151 m .48594 .65595 L .48474 .6469 L p F P
0 0 0 r
s
.066 .08 .157 r
.48474 .6469 m .50066 .64204 L .50061 .65151 L p F P
0 0 0 r
s
.601 .189 .087 r
.60439 .4121 m .6099 .41886 L .63267 .43291 L p F P
0 0 0 r
s
.83 .24 .1 r
.62406 .42854 m
.63098 .43709 L
s
.60809 .42436 m
.62406 .42854 L
s
.752 .23 .102 r
.6099 .41886 m .60439 .4121 L .58036 .40152 L p F P
0 0 0 r
s
.979 .272 .109 r
.39554 .56478 m .38418 .55455 L .38652 .53535 L p F P
0 0 0 r
s
.913 .25 .099 r
.38418 .55455 m .39554 .56478 L .39587 .58282 L p F P
0 0 0 r
s
.913 .25 .099 r
.40699 .59268 m .39587 .58282 L .39554 .56478 L p F P
0 0 0 r
s
1 .306 .127 r
.39043 .45845 m .38122 .44941 L .39666 .43358 L p F P
0 0 0 r
s
1 .302 .124 r
.38122 .44941 m .39043 .45845 L .37871 .47647 L p F P
0 0 0 r
s
.809 .217 .084 r
.39587 .58282 m .40699 .59268 L .40947 .60871 L p F P
0 0 0 r
s
.83 .24 .1 r
.39653 .56417 m
.41842 .58391 L
s
.809 .217 .084 r
.42008 .618 m .40947 .60871 L .40699 .59268 L p F P
0 0 0 r
s
1 .303 .128 r
.47231 .38404 m .47396 .38588 L .44847 .38997 L p F P
0 0 0 r
s
.927 .276 .12 r
.52446 .38389 m .52604 .38573 L .55154 .38967 L p F P
0 0 0 r
s
.24 .35 .67 r
.53177 .38545 m
.53203 .38535 L
s
.134 .176 .364 r
.5871 .60288 m .56948 .60832 L .57138 .59227 L p F P
0 0 0 r
s
.24 .35 .67 r
.57026 .59692 m
.57094 .57372 L
s
.53436 .60811 m
.57026 .59692 L
s
.134 .176 .364 r
.57138 .59227 m .58951 .5866 L .5871 .60288 L p F P
0 0 0 r
s
.309 .092 .048 r
.65252 .44865 m .65976 .45771 L .67686 .47566 L p F P
0 0 0 r
s
.24 .35 .67 r
.66038 .45738 m
.6645 .45596 L
s
.453 .143 .069 r
.65976 .45771 m .65252 .44865 L .63267 .43291 L p F P
0 0 0 r
s
.24 .35 .67 r
.62769 .46858 m
.65978 .45758 L
s
1 .286 .116 r
.38652 .53535 m .37521 .52497 L .38068 .50552 L p F P
0 0 0 r
s
.979 .272 .109 r
.37521 .52497 m .38652 .53535 L .38418 .55455 L p F P
0 0 0 r
s
.24 .35 .67 r
.19413 .4584 m
.22674 .44557 L
s
.19413 .4584 m
.18145 .47088 L
s
.211 .299 .6 r
.68998 .49439 m .67191 .50035 L .66009 .4813 L p F P
0 0 0 r
s
.83 .24 .1 r
.68988 .49443 m
.6937 .4992 L
s
.211 .299 .6 r
.66009 .4813 m .67686 .47566 L .68998 .49439 L p F P
0 0 0 r
s
.83 .24 .1 r
.72628 .56333 m
.70957 .54284 L
s
.72594 .58902 m
.72628 .56333 L
s
.24 .35 .67 r
.35616 .70125 m
.37075 .69629 L
s
.37075 .69629 m
.4052 .68593 L
s
.099 .122 .259 r
.54934 .6272 m .53296 .63219 L .53475 .61904 L p F P
0 0 0 r
s
.24 .35 .67 r
.53021 .62783 m
.53436 .60811 L
s
.099 .122 .259 r
.53475 .61904 m .55203 .61371 L .54934 .6272 L p F P
0 0 0 r
s
1 .306 .129 r
.42905 .40196 m .42405 .39666 L .44847 .38997 L p F P
0 0 0 r
s
1 .308 .129 r
.42405 .39666 m .42905 .40196 L .40784 .41266 L p F P
0 0 0 r
s
.24 .35 .67 r
.40698 .39257 m
.41911 .40153 L
s
.16 .218 .444 r
.62632 .57508 m .60782 .58087 L .60816 .56279 L p F P
0 0 0 r
s
.16 .218 .444 r
.60816 .56279 m .62672 .55688 L .62632 .57508 L p F P
0 0 0 r
s
1 .303 .128 r
.47065 .3822 m .47231 .38404 L .44512 .38633 L p F P
0 0 0 r
s
1 .303 .128 r
.44847 .38997 m .44512 .38633 L .47231 .38404 L p F P
0 0 0 r
s
.752 .23 .102 r
.57598 .39622 m .58036 .40152 L .60439 .4121 L p F P
0 0 0 r
s
.856 .258 .113 r
.58036 .40152 m .57598 .39622 L .55154 .38967 L p F P
0 0 0 r
s
.927 .276 .12 r
.55154 .38967 m .54848 .38603 L .52446 .38389 L p F P
0 0 0 r
s
.927 .276 .12 r
.52287 .38204 m .52446 .38389 L .54848 .38603 L p F P
0 0 0 r
s
.197 .277 .557 r
.67983 .51965 m .66109 .52572 L .65403 .50625 L p F P
0 0 0 r
s
.197 .277 .557 r
.65403 .50625 m .67191 .50035 L .67983 .51965 L p F P
0 0 0 r
s
.83 .24 .1 r
.72464 .66127 m
.73626 .63504 L
s
.71971 .61583 m
.73626 .63504 L
s
1 .306 .129 r
.44512 .38633 m .44847 .38997 L .42405 .39666 L p F P
0 0 0 r
s
.65 .169 .063 r
.40947 .60871 m .42008 .618 L .4242 .63121 L p F P
0 0 0 r
s
.65 .169 .063 r
.43407 .63977 m .4242 .63121 L .42008 .618 L p F P
0 0 0 r
s
.83 .24 .1 r
.42014 .60765 m
.42715 .6292 L
s
.856 .258 .113 r
.54848 .38603 m .55154 .38967 L .57598 .39622 L p F P
0 0 0 r
s
.24 .35 .67 r
.57506 .39588 m
.59327 .38916 L
s
1 .308 .128 r
.39666 .43358 m .38863 .4255 L .40784 .41266 L p F P
0 0 0 r
s
1 .306 .127 r
.38863 .4255 m .39666 .43358 L .38122 .44941 L p F P
0 0 0 r
s
1 .296 .121 r
.38068 .50552 m .36972 .49525 L .37871 .47647 L p F P
0 0 0 r
s
1 .286 .116 r
.36972 .49525 m .38068 .50552 L .37521 .52497 L p F P
0 0 0 r
s
.83 .24 .1 r
.37789 .51832 m
.40028 .53902 L
s
.24 .35 .67 r
.6645 .45596 m
.66696 .46468 L
s
.65452 .42769 m
.6645 .45596 L
s
1 .303 .128 r
.46899 .38034 m .47065 .3822 L .44175 .38268 L p F P
0 0 0 r
s
1 .303 .128 r
.44512 .38633 m .44175 .38268 L .47065 .3822 L p F P
0 0 0 r
s
.453 .143 .069 r
.62616 .42483 m .63267 .43291 L .65252 .44865 L p F P
0 0 0 r
s
.24 .35 .67 r
.63638 .43406 m
.65452 .42769 L
s
.601 .189 .087 r
.63267 .43291 m .62616 .42483 L .60439 .4121 L p F P
0 0 0 r
s
.24 .35 .67 r
.59327 .38916 m
.6057 .41286 L
s
.927 .276 .12 r
.54848 .38603 m .5454 .38237 L .52287 .38204 L p F P
0 0 0 r
s
.927 .276 .12 r
.52129 .38019 m .52287 .38204 L .5454 .38237 L p F P
0 0 0 r
s
.24 .35 .67 r
.54305 .38121 m
.54372 .38222 L
s
.83 .24 .1 r
.513 .38121 m
.52502 .39511 L
s
.24 .35 .67 r
.54101 .38197 m
.54305 .38121 L
s
.65452 .42769 m
.69201 .4145 L
s
.64295 .40058 m
.65452 .42769 L
s
.83 .24 .1 r
.45861 .66421 m
.46096 .66623 L
s
.181 .25 .506 r
.66443 .54488 m .64548 .55091 L .64253 .53173 L p F P
0 0 0 r
s
.181 .25 .506 r
.64253 .53173 m .66109 .52572 L .66443 .54488 L p F P
0 0 0 r
s
.24 .35 .67 r
.64109 .52445 m
.64409 .55043 L
s
.59327 .38916 m
.63015 .37557 L
s
.066 .08 .157 r
.51541 .64704 m .50061 .65151 L .50066 .64204 L p F P
0 0 0 r
s
.066 .08 .157 r
.50066 .64204 m .51674 .63714 L .51541 .64704 L p F P
0 0 0 r
s
.24 .35 .67 r
.49456 .63876 m
.53021 .62783 L
s
.27421 .42621 m
.30777 .413 L
s
.27421 .42621 m
.26003 .43246 L
s
1 .303 .128 r
.44175 .38268 m .43836 .379 L .46899 .38034 L p F P
0 0 0 r
s
.299 .449 .877 r
.46899 .38034 m .47177 .37927 L .44385 .37686 L p F P
0 0 0 r
s
.299 .449 .877 r
.44385 .37686 m .43836 .379 L .46899 .38034 L p F P
0 0 0 r
s
1 .308 .129 r
.40784 .41266 m .40122 .40583 L .42405 .39666 L p F P
0 0 0 r
s
1 .308 .128 r
.40122 .40583 m .40784 .41266 L .38863 .4255 L p F P
0 0 0 r
s
.83 .24 .1 r
.39587 .42183 m
.41794 .44424 L
s
.927 .276 .12 r
.5454 .38237 m .54231 .37869 L .52129 .38019 L p F P
0 0 0 r
s
.927 .276 .12 r
.51969 .37833 m .52129 .38019 L .54231 .37869 L p F P
0 0 0 r
s
.83 .24 .1 r
.61777 .72047 m
.63619 .73785 L
s
.63619 .73785 m
.66246 .72517 L
s
1 .306 .129 r
.44175 .38268 m .44512 .38633 L .419 .39132 L p F P
0 0 0 r
s
1 .306 .129 r
.42405 .39666 m .419 .39132 L .44512 .38633 L p F P
0 0 0 r
s
.601 .189 .087 r
.59882 .40526 m .60439 .4121 L .62616 .42483 L p F P
0 0 0 r
s
.24 .35 .67 r
.60925 .41272 m
.64295 .40058 L
s
.752 .23 .102 r
.60439 .4121 m .59882 .40526 L .57598 .39622 L p F P
0 0 0 r
s
1 .302 .124 r
.37871 .47647 m .36841 .4666 L .38122 .44941 L p F P
0 0 0 r
s
1 .296 .121 r
.36841 .4666 m .37871 .47647 L .36972 .49525 L p F P
0 0 0 r
s
.83 .24 .1 r
.37789 .51832 m
.38692 .49266 L
s
.856 .258 .113 r
.57598 .39622 m .57156 .39087 L .54848 .38603 L p F P
0 0 0 r
s
.856 .258 .113 r
.5454 .38237 m .54848 .38603 L .57156 .39087 L p F P
0 0 0 r
s
.299 .449 .877 r
.47177 .37927 m .47456 .3782 L .44936 .37472 L p F P
0 0 0 r
s
.299 .449 .877 r
.44936 .37472 m .44385 .37686 L .47177 .37927 L p F P
0 0 0 r
s
.24 .35 .67 r
.44182 .37904 m
.44755 .38349 L
s
.83 .24 .1 r
.54449 .71193 m
.56423 .72948 L
s
.56423 .72948 m
.59058 .72789 L
s
1 .308 .129 r
.419 .39132 m .42405 .39666 L .40122 .40583 L p F P
0 0 0 r
s
.83 .24 .1 r
.41703 .4004 m
.43871 .42317 L
s
.134 .176 .364 r
.60491 .59738 m .5871 .60288 L .58951 .5866 L p F P
0 0 0 r
s
.134 .176 .364 r
.58951 .5866 m .60782 .58087 L .60491 .59738 L p F P
0 0 0 r
s
.309 .092 .048 r
.67686 .47566 m .66897 .46577 L .65252 .44865 L p F P
0 0 0 r
s
.471 .116 .045 r
.66897 .46577 m .67686 .47566 L .68998 .49439 L p F P
0 0 0 r
s
.24 .35 .67 r
.66713 .46528 m
.67256 .48448 L
s
.83 .24 .1 r
.66617 .46696 m
.67652 .4777 L
s
.24 .35 .67 r
.63555 .49685 m
.67256 .48448 L
s
.83 .24 .1 r
.67652 .4777 m
.68044 .48261 L
s
.752 .23 .102 r
.57156 .39087 m .57598 .39622 L .59882 .40526 L p F P
0 0 0 r
s
.83 .24 .1 r
.583 .39992 m
.59804 .4182 L
s
.55848 .39954 m
.583 .39992 L
s
.042 .053 .102 r
.47458 .66541 m .46175 .66927 L .45696 .6647 L p F P
0 0 0 r
s
.83 .24 .1 r
.46384 .66864 m
.47805 .68048 L
s
.042 .053 .102 r
.45696 .6647 m .47139 .66034 L .47458 .66541 L p F P
0 0 0 r
s
.325 .073 .03 r
.44819 .65713 m .45696 .6647 L .46175 .66927 L p F P
0 0 0 r
s
.24 .35 .67 r
.45146 .66493 m
.45552 .6637 L
s
.927 .276 .12 r
.54231 .37869 m .5392 .37499 L .51969 .37833 L p F P
0 0 0 r
s
.927 .276 .12 r
.51809 .37647 m .51969 .37833 L .5392 .37499 L p F P
0 0 0 r
s
.299 .449 .877 r
.47456 .3782 m .47736 .37712 L .45489 .37257 L p F P
0 0 0 r
s
.299 .449 .877 r
.45489 .37257 m .44936 .37472 L .47456 .3782 L p F P
0 0 0 r
s
.24 .35 .67 r
.47131 .38568 m
.49247 .37758 L
s
.681 .48166 m
.68236 .48121 L
s
.67256 .48448 m
.68071 .48176 L
s
.099 .122 .259 r
.56587 .62215 m .54934 .6272 L .55203 .61371 L p F P
0 0 0 r
s
.099 .122 .259 r
.55203 .61371 m .56948 .60832 L .56587 .62215 L p F P
0 0 0 r
s
.507 .125 .048 r
.4242 .63121 m .43407 .63977 L .43928 .64944 L p F P
0 0 0 r
s
.507 .125 .048 r
.44819 .65713 m .43928 .64944 L .43407 .63977 L p F P
0 0 0 r
s
.83 .24 .1 r
.42715 .6292 m
.44866 .64794 L
s
.16 .218 .444 r
.64502 .56922 m .62632 .57508 L .62672 .55688 L p F P
0 0 0 r
s
.16 .218 .444 r
.62672 .55688 m .64548 .55091 L .64502 .56922 L p F P
0 0 0 r
s
.24 .35 .67 r
.60713 .56219 m
.64409 .55043 L
s
.83 .24 .1 r
.70957 .54284 m
.70431 .51931 L
s
.299 .449 .877 r
.47736 .37712 m .48016 .37605 L .46044 .37042 L p F P
0 0 0 r
s
.299 .449 .877 r
.46044 .37042 m .45489 .37257 L .47736 .37712 L p F P
0 0 0 r
s
.83 .24 .1 r
.47463 .37706 m
.48709 .39105 L
s
.197 .277 .557 r
.69878 .51352 m .67983 .51965 L .67191 .50035 L p F P
0 0 0 r
s
.197 .277 .557 r
.67191 .50035 m .68998 .49439 L .69878 .51352 L p F P
0 0 0 r
s
.24 .35 .67 r
.64295 .40058 m
.68046 .38706 L
s
.64295 .40058 m
.63015 .37557 L
s
.83 .24 .1 r
.39587 .42183 m
.41703 .4004 L
s
1 .306 .127 r
.38122 .44941 m .37187 .44023 L .38863 .4255 L p F P
0 0 0 r
s
1 .302 .124 r
.37187 .44023 m .38122 .44941 L .36841 .4666 L p F P
0 0 0 r
s
.83 .24 .1 r
.378 .44562 m
.40045 .46767 L
s
.927 .276 .12 r
.5392 .37499 m .53606 .37127 L .51809 .37647 L p F P
0 0 0 r
s
.927 .276 .12 r
.51649 .3746 m .51809 .37647 L .53606 .37127 L p F P
0 0 0 r
s
.83 .24 .1 r
.513 .38121 m
.53882 .37619 L
s
.299 .449 .877 r
.48016 .37605 m .48296 .37497 L .466 .36826 L p F P
0 0 0 r
s
.299 .449 .877 r
.466 .36826 m .46044 .37042 L .48016 .37605 L p F P
0 0 0 r
s
.24 .35 .67 r
.35696 .39975 m
.34203 .39951 L
s
1 .306 .129 r
.43836 .379 m .44175 .38268 L .41392 .38593 L p F P
0 0 0 r
s
1 .306 .129 r
.419 .39132 m .41392 .38593 L .44175 .38268 L p F P
0 0 0 r
s
.83 .24 .1 r
.44073 .38208 m
.46204 .40522 L
s
.24 .35 .67 r
.40698 .39257 m
.41664 .38881 L
s
.309 .092 .048 r
.64517 .43946 m .65252 .44865 L .66897 .46577 L p F P
0 0 0 r
s
.24 .35 .67 r
.6645 .45596 m
.70208 .44308 L
s
.453 .143 .069 r
.65252 .44865 m .64517 .43946 L .62616 .42483 L p F P
0 0 0 r
s
.856 .258 .113 r
.57156 .39087 m .56711 .38548 L .5454 .38237 L p F P
0 0 0 r
s
.856 .258 .113 r
.54231 .37869 m .5454 .38237 L .56711 .38548 L p F P
0 0 0 r
s
.24 .35 .67 r
.30496 .71052 m
.32198 .71152 L
s
.32198 .71152 m
.35616 .70125 L
s
.83 .24 .1 r
.70788 .68587 m
.72464 .66127 L
s
.70778 .64242 m
.72464 .66127 L
s
.299 .449 .877 r
.48296 .37497 m .48577 .37389 L .47158 .36609 L p F P
0 0 0 r
s
.299 .449 .877 r
.47158 .36609 m .466 .36826 L .48296 .37497 L p F P
0 0 0 r
s
.83 .24 .1 r
.46613 .36753 m
.46658 .36803 L
s
.927 .276 .12 r
.53606 .37127 m .53292 .36752 L .51649 .3746 L p F P
0 0 0 r
s
.927 .276 .12 r
.51488 .37273 m .51649 .3746 L .53292 .36752 L p F P
0 0 0 r
s
.979 .272 .109 r
.38418 .55455 m .37261 .54413 L .37521 .52497 L p F P
0 0 0 r
s
.913 .25 .099 r
.37261 .54413 m .38418 .55455 L .38454 .57279 L p F P
0 0 0 r
s
.913 .25 .099 r
.39587 .58282 m .38454 .57279 L .38418 .55455 L p F P
0 0 0 r
s
.066 .08 .157 r
.53034 .64252 m .51541 .64704 L .51674 .63714 L p F P
0 0 0 r
s
.066 .08 .157 r
.51674 .63714 m .53296 .63219 L .53034 .64252 L p F P
0 0 0 r
s
1 .308 .128 r
.38863 .4255 m .3805 .41732 L .40122 .40583 L p F P
0 0 0 r
s
1 .306 .127 r
.3805 .41732 m .38863 .4255 L .37187 .44023 L p F P
0 0 0 r
s
.83 .24 .1 r
.378 .44562 m
.39587 .42183 L
s
.809 .217 .084 r
.38454 .57279 m .39587 .58282 L .39867 .59926 L p F P
0 0 0 r
s
.809 .217 .084 r
.40947 .60871 m .39867 .59926 L .39587 .58282 L p F P
0 0 0 r
s
.83 .24 .1 r
.39653 .56417 m
.39801 .58809 L
s
.181 .25 .506 r
.68359 .53879 m .66443 .54488 L .66109 .52572 L p F P
0 0 0 r
s
.181 .25 .506 r
.66109 .52572 m .67983 .51965 L .68359 .53879 L p F P
0 0 0 r
s
.24 .35 .67 r
.64109 .52445 m
.67841 .51228 L
s
.299 .449 .877 r
.48577 .37389 m .48858 .37281 L .47718 .36391 L p F P
0 0 0 r
s
.299 .449 .877 r
.47718 .36391 m .47158 .36609 L .48577 .37389 L p F P
0 0 0 r
s
1 .308 .129 r
.41392 .38593 m .419 .39132 L .39453 .39892 L p F P
0 0 0 r
s
1 .308 .129 r
.40122 .40583 m .39453 .39892 L .419 .39132 L p F P
0 0 0 r
s
.83 .24 .1 r
.41703 .4004 m
.44073 .38208 L
s
.453 .143 .069 r
.61956 .41663 m .62616 .42483 L .64517 .43946 L p F P
0 0 0 r
s
.601 .189 .087 r
.62616 .42483 m .61956 .41663 L .59882 .40526 L p F P
0 0 0 r
s
.83 .24 .1 r
.46243 .36965 m
.46613 .36753 L
s
1 .286 .116 r
.37521 .52497 m .36369 .5144 L .36972 .49525 L p F P
0 0 0 r
s
.979 .272 .109 r
.36369 .5144 m .37521 .52497 L .37261 .54413 L p F P
0 0 0 r
s
.83 .24 .1 r
.37384 .5437 m
.37789 .51832 L
s
.64443 .70747 m
.66246 .72517 L
s
.66246 .72517 m
.68679 .70755 L
s
1 .308 .128 r
.39453 .39892 m .40122 .40583 L .3805 .41732 L p F P
0 0 0 r
s
.752 .23 .102 r
.59882 .40526 m .59319 .39835 L .57156 .39087 L p F P
0 0 0 r
s
.752 .23 .102 r
.56711 .38548 m .57156 .39087 L .59319 .39835 L p F P
0 0 0 r
s
.042 .053 .102 r
.48751 .66153 m .47458 .66541 L .47139 .66034 L p F P
0 0 0 r
s
.042 .053 .102 r
.47139 .66034 m .48594 .65595 L .48751 .66153 L p F P
0 0 0 r
s
.299 .449 .877 r
.48858 .37281 m .4914 .37172 L .4828 .36173 L p F P
0 0 0 r
s
.299 .449 .877 r
.4828 .36173 m .47718 .36391 L .48858 .37281 L p F P
0 0 0 r
s
.927 .276 .12 r
.53292 .36752 m .52975 .36376 L .51488 .37273 L p F P
0 0 0 r
s
.927 .276 .12 r
.51327 .37085 m .51488 .37273 L .52975 .36376 L p F P
0 0 0 r
s
.601 .189 .087 r
.59319 .39835 m .59882 .40526 L .61956 .41663 L p F P
0 0 0 r
s
1 .306 .129 r
.41392 .38593 m .40879 .3805 L .43836 .379 L p F P
0 0 0 r
s
.3 .456 .884 r
.43836 .379 m .44385 .37686 L .41685 .37734 L p F P
0 0 0 r
s
.83 .24 .1 r
.44073 .38208 m
.45002 .37676 L
s
.3 .456 .884 r
.41685 .37734 m .40879 .3805 L .43836 .379 L p F P
0 0 0 r
s
.83 .24 .1 r
.43695 .37797 m
.44073 .38208 L
s
.24 .35 .67 r
.43572 .38141 m
.44182 .37904 L
s
.856 .258 .113 r
.56711 .38548 m .56262 .38005 L .54231 .37869 L p F P
0 0 0 r
s
.856 .258 .113 r
.5392 .37499 m .54231 .37869 L .56262 .38005 L p F P
0 0 0 r
s
.134 .176 .364 r
.62289 .59183 m .60491 .59738 L .60782 .58087 L p F P
0 0 0 r
s
.24 .35 .67 r
.60692 .58549 m
.60713 .56219 L
s
.57026 .59692 m
.60692 .58549 L
s
.134 .176 .364 r
.60782 .58087 m .62632 .57508 L .62289 .59183 L p F P
0 0 0 r
s
.65 .169 .063 r
.39867 .59926 m .40947 .60871 L .41417 .62252 L p F P
0 0 0 r
s
.83 .24 .1 r
.39801 .58809 m
.42014 .60765 L
s
.65 .169 .063 r
.4242 .63121 m .41417 .62252 L .40947 .60871 L p F P
0 0 0 r
s
.299 .449 .877 r
.4914 .37172 m .49422 .37064 L .48844 .35954 L p F P
0 0 0 r
s
.299 .449 .877 r
.48844 .35954 m .4828 .36173 L .4914 .37172 L p F P
0 0 0 r
s
.099 .122 .259 r
.58256 .61706 m .56587 .62215 L .56948 .60832 L p F P
0 0 0 r
s
.099 .122 .259 r
.56948 .60832 m .5871 .60288 L .58256 .61706 L p F P
0 0 0 r
s
.24 .35 .67 r
.56661 .61668 m
.57026 .59692 L
s
.22674 .44557 m
.26003 .43246 L
s
.22674 .44557 m
.21447 .45797 L
s
1 .296 .121 r
.36972 .49525 m .35856 .4848 L .36841 .4666 L p F P
0 0 0 r
s
1 .286 .116 r
.35856 .4848 m .36972 .49525 L .36369 .5144 L p F P
0 0 0 r
s
.24 .35 .67 r
.39107 .69076 m
.4052 .68593 L
s
.4052 .68593 m
.44038 .67536 L
s
.83 .24 .1 r
.68679 .70755 m
.70788 .68587 L
s
.69064 .66741 m
.70788 .68587 L
s
.71971 .61583 m
.72594 .58902 L
s
.70904 .56878 m
.72594 .58902 L
s
.927 .276 .12 r
.52975 .36376 m .52656 .35997 L .51327 .37085 L p F P
0 0 0 r
s
.927 .276 .12 r
.51165 .36896 m .51327 .37085 L .52656 .35997 L p F P
0 0 0 r
s
.83 .24 .1 r
.49935 .68986 m
.52003 .70792 L
s
.52003 .70792 m
.54449 .71193 L
s
.299 .449 .877 r
.49422 .37064 m .49705 .36955 L .49409 .35734 L p F P
0 0 0 r
s
.299 .449 .877 r
.49409 .35734 m .48844 .35954 L .49422 .37064 L p F P
0 0 0 r
s
.83 .24 .1 r
.49235 .35733 m
.49279 .35785 L
s
.24 .35 .67 r
.4774 .36523 m
.49247 .37758 L
s
.16 .218 .444 r
.66391 .56331 m .64502 .56922 L .64548 .55091 L p F P
0 0 0 r
s
.16 .218 .444 r
.64548 .55091 m .66443 .54488 L .66391 .56331 L p F P
0 0 0 r
s
.641 .167 .062 r
.68162 .48393 m .68998 .49439 L .69878 .51352 L p F P
0 0 0 r
s
.83 .24 .1 r
.69761 .51098 m
.70431 .51931 L
s
.471 .116 .045 r
.68998 .49439 m .68162 .48393 L .66897 .46577 L p F P
0 0 0 r
s
.24 .35 .67 r
.67256 .48448 m
.67841 .51228 L
s
.68236 .48121 m
.71035 .47185 L
s
.83 .24 .1 r
.66916 .68948 m
.68679 .70755 L
s
.3 .456 .884 r
.44385 .37686 m .44936 .37472 L .42495 .37417 L p F P
0 0 0 r
s
.3 .456 .884 r
.42495 .37417 m .41685 .37734 L .44385 .37686 L p F P
0 0 0 r
s
.299 .449 .877 r
.49705 .36955 m .49988 .36846 L .49976 .35514 L p F P
0 0 0 r
s
.299 .449 .877 r
.49976 .35514 m .49409 .35734 L .49705 .36955 L p F P
0 0 0 r
s
.24 .35 .67 r
.49247 .37758 m
.5139 .36937 L
s
.67841 .51228 m
.69494 .5069 L
s
.927 .276 .12 r
.52656 .35997 m .52336 .35616 L .51165 .36896 L p F P
0 0 0 r
s
.927 .276 .12 r
.51003 .36707 m .51165 .36896 L .52336 .35616 L p F P
0 0 0 r
s
1 .302 .124 r
.36841 .4666 m .35794 .45656 L .37187 .44023 L p F P
0 0 0 r
s
1 .296 .121 r
.35794 .45656 m .36841 .4666 L .35856 .4848 L p F P
0 0 0 r
s
.83 .24 .1 r
.36408 .47093 m
.38692 .49266 L
s
.24 .35 .67 r
.71035 .47185 m
.70208 .44308 L
s
.70208 .44308 m
.74045 .42993 L
s
.70208 .44308 m
.69201 .4145 L
s
.325 .073 .03 r
.43928 .64944 m .44819 .65713 L .45398 .66257 L p F P
0 0 0 r
s
.325 .073 .03 r
.46175 .66927 m .45398 .66257 L .44819 .65713 L p F P
0 0 0 r
s
.24 .35 .67 r
.44038 .67536 m
.45146 .66493 L
s
.299 .449 .877 r
.49988 .36846 m .50272 .36737 L .50546 .35293 L p F P
0 0 0 r
s
.299 .449 .877 r
.50546 .35293 m .49976 .35514 L .49988 .36846 L p F P
0 0 0 r
s
.24 .35 .67 r
.69201 .4145 m
.73028 .40104 L
s
.69201 .4145 m
.68046 .38706 L
s
.856 .258 .113 r
.56262 .38005 m .55809 .37457 L .5392 .37499 L p F P
0 0 0 r
s
.24 .35 .67 r
.55871 .37532 m
.57941 .36752 L
s
.83 .24 .1 r
.53882 .37619 m
.55848 .39954 L
s
.856 .258 .113 r
.53606 .37127 m .5392 .37499 L .55809 .37457 L p F P
0 0 0 r
s
.066 .08 .157 r
.54539 .63797 m .53034 .64252 L .53296 .63219 L p F P
0 0 0 r
s
.066 .08 .157 r
.53296 .63219 m .54934 .6272 L .54539 .63797 L p F P
0 0 0 r
s
1 .308 .129 r
.40879 .3805 m .41392 .38593 L .38777 .39194 L p F P
0 0 0 r
s
.24 .35 .67 r
.39911 .38933 m
.40514 .39181 L
s
1 .308 .129 r
.39453 .39892 m .38777 .39194 L .41392 .38593 L p F P
0 0 0 r
s
.309 .092 .048 r
.66897 .46577 m .66096 .45572 L .64517 .43946 L p F P
0 0 0 r
s
.471 .116 .045 r
.66096 .45572 m .66897 .46577 L .68162 .48393 L p F P
0 0 0 r
s
.3 .456 .884 r
.44936 .37472 m .45489 .37257 L .43309 .37098 L p F P
0 0 0 r
s
.3 .456 .884 r
.43309 .37098 m .42495 .37417 L .44936 .37472 L p F P
0 0 0 r
s
.752 .23 .102 r
.59319 .39835 m .5875 .39136 L .56711 .38548 L p F P
0 0 0 r
s
.752 .23 .102 r
.56262 .38005 m .56711 .38548 L .5875 .39136 L p F P
0 0 0 r
s
.24 .35 .67 r
.57941 .36752 m
.59327 .38916 L
s
.299 .449 .877 r
.50272 .36737 m .50556 .36627 L .51117 .35071 L p F P
0 0 0 r
s
.299 .449 .877 r
.51117 .35071 m .50546 .35293 L .50272 .36737 L p F P
0 0 0 r
s
.181 .25 .506 r
.70296 .53263 m .68359 .53879 L .67983 .51965 L p F P
0 0 0 r
s
.181 .25 .506 r
.67983 .51965 m .69878 .51352 L .70296 .53263 L p F P
0 0 0 r
s
.24 .35 .67 r
.25246 .71367 m
.27109 .72076 L
s
.27109 .72076 m
.30496 .71052 L
s
.042 .053 .102 r
.50054 .65761 m .48751 .66153 L .48594 .65595 L p F P
0 0 0 r
s
.042 .053 .102 r
.48594 .65595 m .50061 .65151 L .50054 .65761 L p F P
0 0 0 r
s
.24 .35 .67 r
.45592 .66358 m
.48688 .6542 L
s
.48688 .6542 m
.49456 .63876 L
s
.63015 .37557 m
.66781 .36168 L
s
.63015 .37557 m
.61654 .35355 L
s
.927 .276 .12 r
.52336 .35616 m .52014 .35233 L .51003 .36707 L p F P
0 0 0 r
s
.927 .276 .12 r
.50841 .36518 m .51003 .36707 L .52014 .35233 L p F P
0 0 0 r
s
.83 .24 .1 r
.50072 .36702 m
.513 .38121 L
s
.507 .125 .048 r
.41417 .62252 m .4242 .63121 L .43024 .64163 L p F P
0 0 0 r
s
.507 .125 .048 r
.43928 .64944 m .43024 .64163 L .4242 .63121 L p F P
0 0 0 r
s
.24 .35 .67 r
.57941 .36752 m
.61654 .35355 L
s
1 .306 .127 r
.37187 .44023 m .36238 .43091 L .3805 .41732 L p F P
0 0 0 r
s
1 .302 .124 r
.36238 .43091 m .37187 .44023 L .35794 .45656 L p F P
0 0 0 r
s
.83 .24 .1 r
.36408 .47093 m
.378 .44562 L
s
.24 .35 .67 r
.30777 .413 m
.34203 .39951 L
s
.30777 .413 m
.29404 .41908 L
s
.299 .449 .877 r
.50556 .36627 m .50841 .36518 L .5169 .34848 L p F P
0 0 0 r
s
.299 .449 .877 r
.5169 .34848 m .51117 .35071 L .50556 .36627 L p F P
0 0 0 r
s
.83 .24 .1 r
.57112 .71013 m
.59058 .72789 L
s
.59058 .72789 m
.61777 .72047 L
s
1 .308 .128 r
.38777 .39194 m .39453 .39892 L .37227 .40903 L p F P
0 0 0 r
s
1 .308 .128 r
.3805 .41732 m .37227 .40903 L .39453 .39892 L p F P
0 0 0 r
s
.309 .092 .048 r
.63771 .43014 m .64517 .43946 L .66096 .45572 L p F P
0 0 0 r
s
.83 .24 .1 r
.64336 .43953 m
.65897 .45902 L
s
.453 .143 .069 r
.64517 .43946 m .63771 .43014 L .61956 .41663 L p F P
0 0 0 r
s
.3 .456 .884 r
.45489 .37257 m .46044 .37042 L .44127 .36778 L p F P
0 0 0 r
s
.3 .456 .884 r
.44127 .36778 m .43309 .37098 L .45489 .37257 L p F P
0 0 0 r
s
1 .306 .127 r
.37227 .40903 m .3805 .41732 L .36238 .43091 L p F P
0 0 0 r
s
.601 .189 .087 r
.61956 .41663 m .61288 .40833 L .59319 .39835 L p F P
0 0 0 r
s
.601 .189 .087 r
.5875 .39136 m .59319 .39835 L .61288 .40833 L p F P
0 0 0 r
s
.83 .24 .1 r
.583 .39992 m
.60546 .40557 L
s
.927 .276 .12 r
.52014 .35233 m .5169 .34848 L .50841 .36518 L p F P
0 0 0 r
s
.453 .143 .069 r
.61288 .40833 m .61956 .41663 L .63771 .43014 L p F P
0 0 0 r
s
.83 .24 .1 r
.60546 .40557 m
.62406 .42854 L
s
.62406 .42854 m
.64336 .43953 L
s
.134 .176 .364 r
.64106 .58623 m .62289 .59183 L .62632 .57508 L p F P
0 0 0 r
s
.134 .176 .364 r
.62632 .57508 m .64502 .56922 L .64106 .58623 L p F P
0 0 0 r
s
.099 .122 .259 r
.59941 .61192 m .58256 .61706 L .5871 .60288 L p F P
0 0 0 r
s
.099 .122 .259 r
.5871 .60288 m .60491 .59738 L .59941 .61192 L p F P
0 0 0 r
s
.856 .258 .113 r
.55809 .37457 m .55352 .36904 L .53606 .37127 L p F P
0 0 0 r
s
.856 .258 .113 r
.53292 .36752 m .53606 .37127 L .55352 .36904 L p F P
0 0 0 r
s
.24 .35 .67 r
.71652 .49986 m
.71035 .47185 L
s
.71035 .47185 m
.74894 .45896 L
s
.83 .24 .1 r
.47805 .68048 m
.49935 .68986 L
s
.3 .456 .884 r
.46044 .37042 m .466 .36826 L .44949 .36456 L p F P
0 0 0 r
s
.3 .456 .884 r
.44949 .36456 m .44127 .36778 L .46044 .37042 L p F P
0 0 0 r
s
.16 .218 .444 r
.683 .55733 m .66391 .56331 L .66443 .54488 L p F P
0 0 0 r
s
.16 .218 .444 r
.66443 .54488 m .68359 .53879 L .683 .55733 L p F P
0 0 0 r
s
.24 .35 .67 r
.64409 .55043 m
.68182 .53841 L
s
.18145 .47088 m
.21447 .45797 L
s
.18145 .47088 m
.17182 .48898 L
s
.68046 .38706 m
.71877 .37326 L
s
.68046 .38706 m
.66781 .36168 L
s
1 .308 .129 r
.38777 .39194 m .38093 .38488 L .40879 .3805 L p F P
0 0 0 r
s
.24 .35 .67 r
.35696 .39975 m
.38478 .38885 L
s
.288 .444 .855 r
.40879 .3805 m .41685 .37734 L .39138 .38077 L p F P
0 0 0 r
s
.288 .444 .855 r
.39138 .38077 m .38093 .38488 L .40879 .3805 L p F P
0 0 0 r
s
.83 .24 .1 r
.39914 .38161 m
.41703 .4004 L
s
.979 .272 .109 r
.37261 .54413 m .36083 .53352 L .36369 .5144 L p F P
0 0 0 r
s
.913 .25 .099 r
.36083 .53352 m .37261 .54413 L .37302 .56257 L p F P
0 0 0 r
s
.913 .25 .099 r
.38454 .57279 m .37302 .56257 L .37261 .54413 L p F P
0 0 0 r
s
.809 .217 .084 r
.37302 .56257 m .38454 .57279 L .38768 .58964 L p F P
0 0 0 r
s
.83 .24 .1 r
.37384 .5437 m
.39653 .56417 L
s
.809 .217 .084 r
.39867 .59926 m .38768 .58964 L .38454 .57279 L p F P
0 0 0 r
s
.752 .23 .102 r
.5875 .39136 m .58175 .38429 L .56262 .38005 L p F P
0 0 0 r
s
.752 .23 .102 r
.55809 .37457 m .56262 .38005 L .58175 .38429 L p F P
0 0 0 r
s
.066 .08 .157 r
.56058 .63338 m .54539 .63797 L .54934 .6272 L p F P
0 0 0 r
s
.066 .08 .157 r
.54934 .6272 m .56587 .62215 L .56058 .63338 L p F P
0 0 0 r
s
.24 .35 .67 r
.53021 .62783 m
.56661 .61668 L
s
.33955 .70007 m
.35616 .70125 L
s
.35616 .70125 m
.39107 .69076 L
s
.042 .053 .102 r
.51367 .65367 m .50054 .65761 L .50061 .65151 L p F P
0 0 0 r
s
.042 .053 .102 r
.50061 .65151 m .51541 .64704 L .51367 .65367 L p F P
0 0 0 r
s
.3 .456 .884 r
.466 .36826 m .47158 .36609 L .45774 .36133 L p F P
0 0 0 r
s
.3 .456 .884 r
.45774 .36133 m .44949 .36456 L .466 .36826 L p F P
0 0 0 r
s
1 .286 .116 r
.36369 .5144 m .35196 .50364 L .35856 .4848 L p F P
0 0 0 r
s
.979 .272 .109 r
.35196 .50364 m .36369 .5144 L .36083 .53352 L p F P
0 0 0 r
s
.83 .24 .1 r
.70904 .56878 m
.70957 .54284 L
s
.856 .258 .113 r
.55352 .36904 m .54891 .36347 L .53292 .36752 L p F P
0 0 0 r
s
.856 .258 .113 r
.52975 .36376 m .53292 .36752 L .54891 .36347 L p F P
0 0 0 r
s
.65 .169 .063 r
.38768 .58964 m .39867 .59926 L .40398 .61367 L p F P
0 0 0 r
s
.65 .169 .063 r
.41417 .62252 m .40398 .61367 L .39867 .59926 L p F P
0 0 0 r
s
.83 .24 .1 r
.39801 .58809 m
.40485 .60977 L
s
.813 .22 .084 r
.69011 .50274 m .69878 .51352 L .70296 .53263 L p F P
0 0 0 r
s
.24 .35 .67 r
.69546 .50673 m
.69653 .50638 L
s
.641 .167 .062 r
.69878 .51352 m .69011 .50274 L .68162 .48393 L p F P
0 0 0 r
s
.24 .35 .67 r
.69653 .50638 m
.71652 .49986 L
s
.67841 .51228 m
.68182 .53841 L
s
1 .296 .121 r
.35856 .4848 m .34722 .47417 L .35794 .45656 L p F P
0 0 0 r
s
1 .286 .116 r
.34722 .47417 m .35856 .4848 L .35196 .50364 L p F P
0 0 0 r
s
.83 .24 .1 r
.35469 .49687 m
.37789 .51832 L
s
.70778 .64242 m
.71971 .61583 L
s
.70255 .5959 m
.71971 .61583 L
s
.288 .444 .855 r
.41685 .37734 m .42495 .37417 L .40189 .37664 L p F P
0 0 0 r
s
.288 .444 .855 r
.40189 .37664 m .39138 .38077 L .41685 .37734 L p F P
0 0 0 r
s
.83 .24 .1 r
.39456 .3768 m
.39644 .37878 L
s
.3 .456 .884 r
.47158 .36609 m .47718 .36391 L .46604 .35808 L p F P
0 0 0 r
s
.83 .24 .1 r
.47065 .36577 m
.47121 .36555 L
s
.3 .456 .884 r
.46604 .35808 m .45774 .36133 L .47158 .36609 L p F P
0 0 0 r
s
.24 .35 .67 r
.44182 .37904 m
.4774 .36523 L
s
1 .308 .128 r
.38093 .38488 m .38777 .39194 L .36392 .40063 L p F P
0 0 0 r
s
1 .308 .128 r
.37227 .40903 m .36392 .40063 L .38777 .39194 L p F P
0 0 0 r
s
.83 .24 .1 r
.373 .39861 m
.39587 .42183 L
s
.325 .073 .03 r
.43024 .64163 m .43928 .64944 L .44611 .65578 L p F P
0 0 0 r
s
.83 .24 .1 r
.42715 .6292 m
.43937 .64757 L
s
.325 .073 .03 r
.45398 .66257 m .44611 .65578 L .43928 .64944 L p F P
0 0 0 r
s
.83 .24 .1 r
.43937 .64757 m
.45826 .6639 L
s
.641 .167 .062 r
.67311 .47328 m .68162 .48393 L .69011 .50274 L p F P
0 0 0 r
s
.83 .24 .1 r
.68492 .49375 m
.68709 .49789 L
s
.68709 .49789 m
.68787 .49886 L
s
.471 .116 .045 r
.68162 .48393 m .67311 .47328 L .66096 .45572 L p F P
0 0 0 r
s
.601 .189 .087 r
.61288 .40833 m .6061 .39993 L .5875 .39136 L p F P
0 0 0 r
s
.601 .189 .087 r
.58175 .38429 m .5875 .39136 L .6061 .39993 L p F P
0 0 0 r
s
.099 .122 .259 r
.61642 .60673 m .59941 .61192 L .60491 .59738 L p F P
0 0 0 r
s
.099 .122 .259 r
.60491 .59738 m .62289 .59183 L .61642 .60673 L p F P
0 0 0 r
s
.24 .35 .67 r
.60378 .60528 m
.60692 .58549 L
s
.134 .176 .364 r
.65942 .58056 m .64106 .58623 L .64502 .56922 L p F P
0 0 0 r
s
.24 .35 .67 r
.64409 .55043 m
.64434 .57381 L
s
.60692 .58549 m
.64434 .57381 L
s
.134 .176 .364 r
.64502 .56922 m .66391 .56331 L .65942 .58056 L p F P
0 0 0 r
s
1 .302 .124 r
.35794 .45656 m .34729 .44636 L .36238 .43091 L p F P
0 0 0 r
s
1 .296 .121 r
.34729 .44636 m .35794 .45656 L .34722 .47417 L p F P
0 0 0 r
s
.83 .24 .1 r
.35469 .49687 m
.36408 .47093 L
s
.24 .35 .67 r
.26003 .43246 m
.29404 .41908 L
s
.26003 .43246 m
.2482 .44478 L
s
1 .306 .127 r
.36392 .40063 m .37227 .40903 L .35274 .42146 L p F P
0 0 0 r
s
1 .306 .127 r
.36238 .43091 m .35274 .42146 L .37227 .40903 L p F P
0 0 0 r
s
.24 .35 .67 r
.42673 .68005 m
.44038 .67536 L
s
.309 .092 .048 r
.66096 .45572 m .65281 .44551 L .63771 .43014 L p F P
0 0 0 r
s
.471 .116 .045 r
.65281 .44551 m .66096 .45572 L .67311 .47328 L p F P
0 0 0 r
s
.3 .456 .884 r
.47718 .36391 m .4828 .36173 L .47438 .35482 L p F P
0 0 0 r
s
.83 .24 .1 r
.47643 .36352 m
.47699 .3633 L
s
.48223 .36126 m
.49235 .35733 L
s
.3 .456 .884 r
.47438 .35482 m .46604 .35808 L .47718 .36391 L p F P
0 0 0 r
s
1 .302 .124 r
.35274 .42146 m .36238 .43091 L .34729 .44636 L p F P
0 0 0 r
s
.83 .24 .1 r
.35471 .42275 m
.378 .44562 L
s
.856 .258 .113 r
.54891 .36347 m .54427 .35785 L .52975 .36376 L p F P
0 0 0 r
s
.856 .258 .113 r
.52656 .35997 m .52975 .36376 L .54427 .35785 L p F P
0 0 0 r
s
.83 .24 .1 r
.49235 .35733 m
.4961 .35656 L
s
.752 .23 .102 r
.58175 .38429 m .57593 .37715 L .55809 .37457 L p F P
0 0 0 r
s
.752 .23 .102 r
.55352 .36904 m .55809 .37457 L .57593 .37715 L p F P
0 0 0 r
s
.83 .24 .1 r
.53882 .37619 m
.56355 .3763 L
s
.56355 .3763 m
.583 .39992 L
s
.453 .143 .069 r
.63771 .43014 m .63014 .42067 L .61288 .40833 L p F P
0 0 0 r
s
.453 .143 .069 r
.6061 .39993 m .61288 .40833 L .63014 .42067 L p F P
0 0 0 r
s
.16 .218 .444 r
.7023 .55129 m .683 .55733 L .68359 .53879 L p F P
0 0 0 r
s
.16 .218 .444 r
.68359 .53879 m .70296 .53263 L .7023 .55129 L p F P
0 0 0 r
s
.83 .24 .1 r
.70289 .53465 m
.70957 .54284 L
s
.288 .444 .855 r
.42495 .37417 m .43309 .37098 L .41246 .37248 L p F P
0 0 0 r
s
.288 .444 .855 r
.41246 .37248 m .40189 .37664 L .42495 .37417 L p F P
0 0 0 r
s
.309 .092 .048 r
.63014 .42067 m .63771 .43014 L .65281 .44551 L p F P
0 0 0 r
s
.507 .125 .048 r
.40398 .61367 m .41417 .62252 L .42106 .63371 L p F P
0 0 0 r
s
.507 .125 .048 r
.43024 .64163 m .42106 .63371 L .41417 .62252 L p F P
0 0 0 r
s
.83 .24 .1 r
.40485 .60977 m
.42715 .6292 L
s
.024 .035 .067 r
.4785 .66664 m .46762 .6699 L .46175 .66927 L p F P
0 0 0 r
s
.024 .035 .067 r
.46175 .66927 m .47458 .66541 L .4785 .66664 L p F P
0 0 0 r
s
.438 .139 .066 r
.45398 .66257 m .46175 .66927 L .46762 .6699 L p F P
0 0 0 r
s
.24 .35 .67 r
.46136 .66905 m
.46252 .6687 L
s
.83 .24 .1 r
.46556 .66968 m
.47805 .68048 L
s
.24 .35 .67 r
.44038 .67536 m
.46136 .66905 L
s
.83 .24 .1 r
.59867 .70243 m
.61777 .72047 L
s
.61777 .72047 m
.64443 .70747 L
s
.042 .053 .102 r
.5269 .64969 m .51367 .65367 L .51541 .64704 L p F P
0 0 0 r
s
.042 .053 .102 r
.51541 .64704 m .53034 .64252 L .5269 .64969 L p F P
0 0 0 r
s
.24 .35 .67 r
.48688 .6542 m
.52305 .64326 L
s
.52305 .64326 m
.53021 .62783 L
s
.066 .08 .157 r
.5759 .62875 m .56058 .63338 L .56587 .62215 L p F P
0 0 0 r
s
.066 .08 .157 r
.56587 .62215 m .58256 .61706 L .5759 .62875 L p F P
0 0 0 r
s
.24 .35 .67 r
.72035 .52614 m
.71652 .49986 L
s
.71652 .49986 m
.75544 .48718 L
s
.83 .24 .1 r
.52401 .69373 m
.54449 .71193 L
s
.54449 .71193 m
.57112 .71013 L
s
.3 .456 .884 r
.4828 .36173 m .48844 .35954 L .48276 .35153 L p F P
0 0 0 r
s
.3 .456 .884 r
.48276 .35153 m .47438 .35482 L .4828 .36173 L p F P
0 0 0 r
s
.24 .35 .67 r
.74894 .45896 m
.74045 .42993 L
s
.74045 .42993 m
.77964 .41649 L
s
.74045 .42993 m
.73028 .40104 L
s
.73028 .40104 m
.76938 .3873 L
s
.73028 .40104 m
.71877 .37326 L
s
.28666 .70319 m
.30496 .71052 L
s
.30496 .71052 m
.33955 .70007 L
s
.856 .258 .113 r
.54427 .35785 m .53959 .35218 L .52656 .35997 L p F P
0 0 0 r
s
.24 .35 .67 r
.54421 .35777 m
.5651 .34977 L
s
.856 .258 .113 r
.52336 .35616 m .52656 .35997 L .53959 .35218 L p F P
0 0 0 r
s
.24 .35 .67 r
.66781 .36168 m
.70628 .3475 L
s
.66781 .36168 m
.65447 .33929 L
s
.288 .444 .855 r
.43309 .37098 m .44127 .36778 L .4231 .36829 L p F P
0 0 0 r
s
.83 .24 .1 r
.42966 .37006 m
.43067 .37116 L
s
.288 .444 .855 r
.4231 .36829 m .41246 .37248 L .43309 .37098 L p F P
0 0 0 r
s
.24 .35 .67 r
.39853 .38346 m
.42678 .37239 L
s
.42678 .37239 m
.44182 .37904 L
s
.61654 .35355 m
.65447 .33929 L
s
.61654 .35355 m
.60258 .33542 L
s
.3 .456 .884 r
.48844 .35954 m .49409 .35734 L .49118 .34824 L p F P
0 0 0 r
s
.3 .456 .884 r
.49118 .34824 m .48276 .35153 L .48844 .35954 L p F P
0 0 0 r
s
.83 .24 .1 r
.39456 .3768 m
.41863 .35808 L
s
.373 .39861 m
.38839 .38304 L
s
.39016 .38125 m
.39456 .3768 L
s
1 .308 .128 r
.36392 .40063 m .35547 .39212 L .38093 .38488 L p F P
0 0 0 r
s
.25 .394 .75 r
.38093 .38488 m .39138 .38077 L .36805 .38715 L p F P
0 0 0 r
s
.25 .394 .75 r
.36805 .38715 m .35547 .39212 L .38093 .38488 L p F P
0 0 0 r
s
.83 .24 .1 r
.36405 .38953 m
.373 .39861 L
s
.099 .122 .259 r
.6336 .60149 m .61642 .60673 L .62289 .59183 L p F P
0 0 0 r
s
.099 .122 .259 r
.62289 .59183 m .64106 .58623 L .6336 .60149 L p F P
0 0 0 r
s
.83 .24 .1 r
.69064 .66741 m
.70778 .64242 L
s
.69028 .62287 m
.70778 .64242 L
s
.601 .189 .087 r
.6061 .39993 m .59924 .39141 L .58175 .38429 L p F P
0 0 0 r
s
.601 .189 .087 r
.57593 .37715 m .58175 .38429 L .59924 .39141 L p F P
0 0 0 r
s
.134 .176 .364 r
.67796 .57484 m .65942 .58056 L .66391 .56331 L p F P
0 0 0 r
s
.134 .176 .364 r
.66391 .56331 m .683 .55733 L .67796 .57484 L p F P
0 0 0 r
s
.752 .23 .102 r
.57593 .37715 m .57005 .36993 L .55352 .36904 L p F P
0 0 0 r
s
.752 .23 .102 r
.54891 .36347 m .55352 .36904 L .57005 .36993 L p F P
0 0 0 r
s
.24 .35 .67 r
.5651 .34977 m
.57941 .36752 L
s
.024 .035 .067 r
.48944 .66335 m .4785 .66664 L .47458 .66541 L p F P
0 0 0 r
s
.024 .035 .067 r
.47458 .66541 m .48751 .66153 L .48944 .66335 L p F P
0 0 0 r
s
.24 .35 .67 r
.47631 .66456 m
.48688 .6542 L
s
.3 .456 .884 r
.49409 .35734 m .49976 .35514 L .49965 .34492 L p F P
0 0 0 r
s
.3 .456 .884 r
.49965 .34492 m .49118 .34824 L .49409 .35734 L p F P
0 0 0 r
s
.24 .35 .67 r
.75544 .48718 m
.74894 .45896 L
s
.74894 .45896 m
.78835 .44579 L
s
.913 .25 .099 r
.37302 .56257 m .36127 .55216 L .36083 .53352 L p F P
0 0 0 r
s
.809 .217 .084 r
.36127 .55216 m .37302 .56257 L .3765 .57985 L p F P
0 0 0 r
s
.809 .217 .084 r
.38768 .58964 m .3765 .57985 L .37302 .56257 L p F P
0 0 0 r
s
.83 .24 .1 r
.37384 .5437 m
.37506 .56781 L
s
.979 .272 .109 r
.36083 .53352 m .34882 .52271 L .35196 .50364 L p F P
0 0 0 r
s
.913 .25 .099 r
.34882 .52271 m .36083 .53352 L .36127 .55216 L p F P
0 0 0 r
s
.042 .053 .102 r
.54023 .64568 m .5269 .64969 L .53034 .64252 L p F P
0 0 0 r
s
.042 .053 .102 r
.53034 .64252 m .54539 .63797 L .54023 .64568 L p F P
0 0 0 r
s
.288 .444 .855 r
.44127 .36778 m .44949 .36456 L .43381 .36407 L p F P
0 0 0 r
s
.288 .444 .855 r
.43381 .36407 m .4231 .36829 L .44127 .36778 L p F P
0 0 0 r
s
.83 .24 .1 r
.41863 .35808 m
.42672 .36687 L
s
.44439 .34314 m
.41863 .35808 L
s
.39571 .33319 m
.41863 .35808 L
s
.856 .258 .113 r
.53959 .35218 m .53486 .34646 L .52336 .35616 L p F P
0 0 0 r
s
.856 .258 .113 r
.52014 .35233 m .52336 .35616 L .53486 .34646 L p F P
0 0 0 r
s
.066 .08 .157 r
.59136 .62408 m .5759 .62875 L .58256 .61706 L p F P
0 0 0 r
s
.066 .08 .157 r
.58256 .61706 m .59941 .61192 L .59136 .62408 L p F P
0 0 0 r
s
.24 .35 .67 r
.56661 .61668 m
.60378 .60528 L
s
.21447 .45797 m
.2482 .44478 L
s
.21447 .45797 m
.20524 .47606 L
s
1 .286 .116 r
.35196 .50364 m .34002 .49268 L .34722 .47417 L p F P
0 0 0 r
s
.979 .272 .109 r
.34002 .49268 m .35196 .50364 L .34882 .52271 L p F P
0 0 0 r
s
.83 .24 .1 r
.35031 .52248 m
.35469 .49687 L
s
.813 .22 .084 r
.70296 .53263 m .69414 .5218 L .69011 .50274 L p F P
0 0 0 r
s
.939 .259 .102 r
.69414 .5218 m .70296 .53263 L .7023 .55129 L p F P
0 0 0 r
s
.24 .35 .67 r
.70234 .53188 m
.72035 .52614 L
s
.68182 .53841 m
.69737 .53346 L
s
.5651 .34977 m
.60258 .33542 L
s
.83 .24 .1 r
.62572 .6891 m
.64443 .70747 L
s
.64443 .70747 m
.66916 .68948 L
s
.24 .35 .67 r
.71877 .37326 m
.7579 .35916 L
s
.71877 .37326 m
.70628 .3475 L
s
.325 .073 .03 r
.42106 .63371 m .43024 .64163 L .43814 .64891 L p F P
0 0 0 r
s
.325 .073 .03 r
.44611 .65578 m .43814 .64891 L .43024 .64163 L p F P
0 0 0 r
s
.65 .169 .063 r
.3765 .57985 m .38768 .58964 L .39361 .60468 L p F P
0 0 0 r
s
.83 .24 .1 r
.37506 .56781 m
.39801 .58809 L
s
.65 .169 .063 r
.40398 .61367 m .39361 .60468 L .38768 .58964 L p F P
0 0 0 r
s
1 .306 .127 r
.35547 .39212 m .36392 .40063 L .34297 .41186 L p F P
0 0 0 r
s
.24 .35 .67 r
.34203 .39951 m
.35369 .39492 L
s
1 .306 .127 r
.35274 .42146 m .34297 .41186 L .36392 .40063 L p F P
0 0 0 r
s
.83 .24 .1 r
.35471 .42275 m
.373 .39861 L
s
.3 .456 .884 r
.49976 .35514 m .50546 .35293 L .50815 .34159 L p F P
0 0 0 r
s
.3 .456 .884 r
.50815 .34159 m .49965 .34492 L .49976 .35514 L p F P
0 0 0 r
s
.813 .22 .084 r
.68128 .49177 m .69011 .50274 L .69414 .5218 L p F P
0 0 0 r
s
.83 .24 .1 r
.68709 .49789 m
.68742 .4994 L
s
.641 .167 .062 r
.69011 .50274 m .68128 .49177 L .67311 .47328 L p F P
0 0 0 r
s
1 .296 .121 r
.34722 .47417 m .33567 .46335 L .34729 .44636 L p F P
0 0 0 r
s
1 .286 .116 r
.33567 .46335 m .34722 .47417 L .34002 .49268 L p F P
0 0 0 r
s
.453 .143 .069 r
.63014 .42067 m .62245 .41106 L .6061 .39993 L p F P
0 0 0 r
s
.453 .143 .069 r
.59924 .39141 m .6061 .39993 L .62245 .41106 L p F P
0 0 0 r
s
.24 .35 .67 r
.37488 .68938 m
.39107 .69076 L
s
.39107 .69076 m
.42673 .68005 L
s
.25 .394 .75 r
.39138 .38077 m .40189 .37664 L .38074 .38215 L p F P
0 0 0 r
s
.25 .394 .75 r
.38074 .38215 m .36805 .38715 L .39138 .38077 L p F P
0 0 0 r
s
.24 .35 .67 r
.37703 .38573 m
.38741 .38608 L
s
.438 .139 .066 r
.44611 .65578 m .45398 .66257 L .46109 .66424 L p F P
0 0 0 r
s
.83 .24 .1 r
.43937 .64757 m
.45578 .66124 L
s
.438 .139 .066 r
.46762 .6699 m .46109 .66424 L .45398 .66257 L p F P
0 0 0 r
s
.24 .35 .67 r
.46529 .66787 m
.47631 .66456 L
s
1 .302 .124 r
.34729 .44636 m .33647 .43599 L .35274 .42146 L p F P
0 0 0 r
s
1 .296 .121 r
.33647 .43599 m .34729 .44636 L .33567 .46335 L p F P
0 0 0 r
s
.83 .24 .1 r
.34039 .44838 m
.36408 .47093 L
s
1 .302 .124 r
.34297 .41186 m .35274 .42146 L .33647 .43599 L p F P
0 0 0 r
s
.83 .24 .1 r
.34039 .44838 m
.35471 .42275 L
s
.641 .167 .062 r
.66446 .46244 m .67311 .47328 L .68128 .49177 L p F P
0 0 0 r
s
.471 .116 .045 r
.67311 .47328 m .66446 .46244 L .65281 .44551 L p F P
0 0 0 r
s
.83 .24 .1 r
.65871 .45541 m
.66479 .46303 L
s
.64336 .43953 m
.65871 .45541 L
s
.66916 .68948 m
.69064 .66741 L
s
.67277 .64825 m
.69064 .66741 L
s
.70255 .5959 m
.70904 .56878 L
s
.24 .35 .67 r
.23348 .70035 m
.25246 .71367 L
s
.25246 .71367 m
.28666 .70319 L
s
.288 .444 .855 r
.44949 .36456 m .45774 .36133 L .44459 .35983 L p F P
0 0 0 r
s
.288 .444 .855 r
.44459 .35983 m .43381 .36407 L .44949 .36456 L p F P
0 0 0 r
s
.83 .24 .1 r
.47788 .67112 m
.49935 .68986 L
s
.49935 .68986 m
.52401 .69373 L
s
.309 .092 .048 r
.65281 .44551 m .64453 .43512 L .63014 .42067 L p F P
0 0 0 r
s
.309 .092 .048 r
.62245 .41106 m .63014 .42067 L .64453 .43512 L p F P
0 0 0 r
s
.83 .24 .1 r
.62486 .41644 m
.64336 .43953 L
s
.60546 .40557 m
.62486 .41644 L
s
.471 .116 .045 r
.64453 .43512 m .65281 .44551 L .66446 .46244 L p F P
0 0 0 r
s
.3 .456 .884 r
.50546 .35293 m .51117 .35071 L .5167 .33825 L p F P
0 0 0 r
s
.3 .456 .884 r
.5167 .33825 m .50815 .34159 L .50546 .35293 L p F P
0 0 0 r
s
.24 .35 .67 r
.4774 .36523 m
.51374 .35113 L
s
.024 .035 .067 r
.50046 .66005 m .48944 .66335 L .48751 .66153 L p F P
0 0 0 r
s
.024 .035 .067 r
.48751 .66153 m .50054 .65761 L .50046 .66005 L p F P
0 0 0 r
s
.83 .24 .1 r
.65087 .67073 m
.66916 .68948 L
s
.856 .258 .113 r
.53486 .34646 m .5301 .3407 L .52014 .35233 L p F P
0 0 0 r
s
.856 .258 .113 r
.5169 .34848 m .52014 .35233 L .5301 .3407 L p F P
0 0 0 r
s
.83 .24 .1 r
.51843 .35198 m
.53882 .37619 L
s
.5088 .35395 m
.51843 .35198 L
s
.24 .35 .67 r
.51374 .35113 m
.51917 .35583 L
s
.752 .23 .102 r
.57005 .36993 m .56411 .36264 L .54891 .36347 L p F P
0 0 0 r
s
.752 .23 .102 r
.54427 .35785 m .54891 .36347 L .56411 .36264 L p F P
0 0 0 r
s
.507 .125 .048 r
.39361 .60468 m .40398 .61367 L .41174 .62567 L p F P
0 0 0 r
s
.507 .125 .048 r
.42106 .63371 m .41174 .62567 L .40398 .61367 L p F P
0 0 0 r
s
.099 .122 .259 r
.65094 .5962 m .6336 .60149 L .64106 .58623 L p F P
0 0 0 r
s
.099 .122 .259 r
.64106 .58623 m .65942 .58056 L .65094 .5962 L p F P
0 0 0 r
s
.24 .35 .67 r
.64175 .59364 m
.64434 .57381 L
s
.042 .053 .102 r
.55367 .64165 m .54023 .64568 L .54539 .63797 L p F P
0 0 0 r
s
.042 .053 .102 r
.54539 .63797 m .56058 .63338 L .55367 .64165 L p F P
0 0 0 r
s
.134 .176 .364 r
.6967 .56905 m .67796 .57484 L .683 .55733 L p F P
0 0 0 r
s
.24 .35 .67 r
.68182 .53841 m
.68257 .56189 L
s
.64434 .57381 m
.68257 .56189 L
s
.134 .176 .364 r
.683 .55733 m .7023 .55129 L .6967 .56905 L p F P
0 0 0 r
s
.3 .456 .884 r
.51117 .35071 m .5169 .34848 L .52529 .33488 L p F P
0 0 0 r
s
.3 .456 .884 r
.52529 .33488 m .5167 .33825 L .51117 .35071 L p F P
0 0 0 r
s
.601 .189 .087 r
.59924 .39141 m .59229 .38278 L .57593 .37715 L p F P
0 0 0 r
s
.601 .189 .087 r
.57005 .36993 m .57593 .37715 L .59229 .38278 L p F P
0 0 0 r
s
.24 .35 .67 r
.29404 .41908 m
.28265 .4313 L
s
.25 .394 .75 r
.40189 .37664 m .41246 .37248 L .39352 .37711 L p F P
0 0 0 r
s
.25 .394 .75 r
.39352 .37711 m .38074 .38215 L .40189 .37664 L p F P
0 0 0 r
s
.288 .444 .855 r
.45774 .36133 m .46604 .35808 L .45544 .35556 L p F P
0 0 0 r
s
.24 .35 .67 r
.46281 .35827 m
.4774 .36523 L
s
.288 .444 .855 r
.45544 .35556 m .44459 .35983 L .45774 .36133 L p F P
0 0 0 r
s
.83 .24 .1 r
.44439 .34314 m
.45547 .35557 L
s
.24 .35 .67 r
.17182 .48898 m
.20524 .47606 L
s
.17182 .48898 m
.16585 .51203 L
s
.066 .08 .157 r
.60695 .61936 m .59136 .62408 L .59941 .61192 L p F P
0 0 0 r
s
.066 .08 .157 r
.59941 .61192 m .61642 .60673 L .60695 .61936 L p F P
0 0 0 r
s
.83 .24 .1 r
.47092 .33257 m
.44439 .34314 L
s
.42183 .31784 m
.44439 .34314 L
s
.24 .35 .67 r
.51374 .35113 m
.52013 .34865 L
s
.83 .24 .1 r
.55093 .69171 m
.57112 .71013 L
s
.57112 .71013 m
.59867 .70243 L
s
.24 .35 .67 r
.75971 .51361 m
.72035 .52614 L
s
.72162 .54971 m
.72035 .52614 L
s
.856 .258 .113 r
.5301 .3407 m .52529 .33488 L .5169 .34848 L p F P
0 0 0 r
s
.83 .24 .1 r
.51481 .34768 m
.51843 .35198 L
s
.24 .35 .67 r
.75971 .51361 m
.75544 .48718 L
s
.75544 .48718 m
.7952 .47422 L
s
.024 .035 .067 r
.51154 .65673 m .50046 .66005 L .50054 .65761 L p F P
0 0 0 r
s
.024 .035 .067 r
.50054 .65761 m .51367 .65367 L .51154 .65673 L p F P
0 0 0 r
s
.24 .35 .67 r
.78835 .44579 m
.77964 .41649 L
s
.77964 .41649 m
.81967 .40277 L
s
.77964 .41649 m
.76938 .3873 L
s
.76938 .3873 m
.80931 .37325 L
s
.76938 .3873 m
.7579 .35916 L
s
.288 .444 .855 r
.46604 .35808 m .47438 .35482 L .46636 .35127 L p F P
0 0 0 r
s
.288 .444 .855 r
.46636 .35127 m .45544 .35556 L .46604 .35808 L p F P
0 0 0 r
s
.752 .23 .102 r
.56411 .36264 m .5581 .35525 L .54427 .35785 L p F P
0 0 0 r
s
.752 .23 .102 r
.53959 .35218 m .54427 .35785 L .5581 .35525 L p F P
0 0 0 r
s
1 .306 .127 r
.34297 .41186 m .33304 .40212 L .35547 .39212 L p F P
0 0 0 r
s
.024 .035 .067 r
.35547 .39212 m .36805 .38715 L .34749 .39642 L p F P
0 0 0 r
s
.24 .35 .67 r
.36359 .39102 m
.37703 .38573 L
s
.83 .24 .1 r
.36329 .38876 m
.36349 .38896 L
s
.024 .035 .067 r
.34749 .39642 m .33304 .40212 L .35547 .39212 L p F P
0 0 0 r
s
.24 .35 .67 r
.3216 .69249 m
.33955 .70007 L
s
.33955 .70007 m
.37488 .68938 L
s
.25 .394 .75 r
.41246 .37248 m .4231 .36829 L .4064 .37203 L p F P
0 0 0 r
s
.25 .394 .75 r
.4064 .37203 m .39352 .37711 L .41246 .37248 L p F P
0 0 0 r
s
.83 .24 .1 r
.37124 .35232 m
.39449 .37673 L
s
.453 .143 .069 r
.62245 .41106 m .61465 .4013 L .59924 .39141 L p F P
0 0 0 r
s
.453 .143 .069 r
.59229 .38278 m .59924 .39141 L .61465 .4013 L p F P
0 0 0 r
s
.24 .35 .67 r
.70628 .3475 m
.74557 .33302 L
s
.70628 .3475 m
.69321 .32471 L
s
.325 .073 .03 r
.41174 .62567 m .42106 .63371 L .43006 .64194 L p F P
0 0 0 r
s
.325 .073 .03 r
.43814 .64891 m .43006 .64194 L .42106 .63371 L p F P
0 0 0 r
s
.83 .24 .1 r
.41698 .62821 m
.43937 .64757 L
s
.24 .35 .67 r
.65447 .33929 m
.69321 .32471 L
s
.65447 .33929 m
.64088 .32076 L
s
.438 .139 .066 r
.43814 .64891 m .44611 .65578 L .45449 .65851 L p F P
0 0 0 r
s
.438 .139 .066 r
.46109 .66424 m .45449 .65851 L .44611 .65578 L p F P
0 0 0 r
s
.042 .053 .102 r
.56721 .63758 m .55367 .64165 L .56058 .63338 L p F P
0 0 0 r
s
.24 .35 .67 r
.52305 .64326 m
.55999 .63207 L
s
.042 .053 .102 r
.56058 .63338 m .5759 .62875 L .56721 .63758 L p F P
0 0 0 r
s
.24 .35 .67 r
.55999 .63207 m
.56661 .61668 L
s
.913 .25 .099 r
.36127 .55216 m .34931 .54156 L .34882 .52271 L p F P
0 0 0 r
s
.809 .217 .084 r
.34931 .54156 m .36127 .55216 L .36511 .56989 L p F P
0 0 0 r
s
.83 .24 .1 r
.35031 .52248 m
.37384 .5437 L
s
.809 .217 .084 r
.3765 .57985 m .36511 .56989 L .36127 .55216 L p F P
0 0 0 r
s
.979 .272 .109 r
.34882 .52271 m .33659 .51169 L .34002 .49268 L p F P
0 0 0 r
s
.913 .25 .099 r
.33659 .51169 m .34882 .52271 L .34931 .54156 L p F P
0 0 0 r
s
.099 .122 .259 r
.66845 .59086 m .65094 .5962 L .65942 .58056 L p F P
0 0 0 r
s
.099 .122 .259 r
.65942 .58056 m .67796 .57484 L .66845 .59086 L p F P
0 0 0 r
s
1 .302 .124 r
.33304 .40212 m .34297 .41186 L .32547 .42545 L p F P
0 0 0 r
s
.24 .35 .67 r
.32877 .40542 m
.33251 .40375 L
s
1 .302 .124 r
.33647 .43599 m .32547 .42545 L .34297 .41186 L p F P
0 0 0 r
s
.24 .35 .67 r
.29404 .41908 m
.32877 .40542 L
s
1 .286 .116 r
.34002 .49268 m .32785 .48152 L .33567 .46335 L p F P
0 0 0 r
s
.979 .272 .109 r
.32785 .48152 m .34002 .49268 L .33659 .51169 L p F P
0 0 0 r
s
1 .284 .114 r
.69351 .54067 m .7023 .55129 L .6967 .56905 L p F P
0 0 0 r
s
.24 .35 .67 r
.70004 .55645 m
.70114 .5561 L
s
.68257 .56189 m
.69544 .55788 L
s
.83 .24 .1 r
.70014 .55813 m
.70904 .56878 L
s
.939 .259 .102 r
.7023 .55129 m .69351 .54067 L .69414 .5218 L p F P
0 0 0 r
s
.24 .35 .67 r
.70114 .5561 m
.72162 .54971 L
s
.65 .169 .063 r
.36511 .56989 m .3765 .57985 L .38307 .59554 L p F P
0 0 0 r
s
.65 .169 .063 r
.39361 .60468 m .38307 .59554 L .3765 .57985 L p F P
0 0 0 r
s
.83 .24 .1 r
.37506 .56781 m
.38172 .58962 L
s
.288 .444 .855 r
.47438 .35482 m .48276 .35153 L .47735 .34694 L p F P
0 0 0 r
s
.288 .444 .855 r
.47735 .34694 m .46636 .35127 L .47438 .35482 L p F P
0 0 0 r
s
.813 .22 .084 r
.69414 .5218 m .68516 .51077 L .68128 .49177 L p F P
0 0 0 r
s
.939 .259 .102 r
.68516 .51077 m .69414 .5218 L .69351 .54067 L p F P
0 0 0 r
s
.066 .08 .157 r
.62268 .61461 m .60695 .61936 L .61642 .60673 L p F P
0 0 0 r
s
.066 .08 .157 r
.61642 .60673 m .6336 .60149 L .62268 .61461 L p F P
0 0 0 r
s
.24 .35 .67 r
.60378 .60528 m
.64175 .59364 L
s
.601 .189 .087 r
.59229 .38278 m .58524 .37403 L .57005 .36993 L p F P
0 0 0 r
s
.83 .24 .1 r
.58617 .38174 m
.60546 .40557 L
s
.56355 .3763 m
.58617 .38174 L
s
.601 .189 .087 r
.56411 .36264 m .57005 .36993 L .58524 .37403 L p F P
0 0 0 r
s
.24 .35 .67 r
.7952 .47422 m
.78835 .44579 L
s
.78835 .44579 m
.82861 .43234 L
s
1 .296 .121 r
.33567 .46335 m .32391 .45233 L .33647 .43599 L p F P
0 0 0 r
s
1 .286 .116 r
.32391 .45233 m .33567 .46335 L .32785 .48152 L p F P
0 0 0 r
s
.83 .24 .1 r
.33062 .47461 m
.35469 .49687 L
s
.309 .092 .048 r
.64453 .43512 m .63611 .42456 L .62245 .41106 L p F P
0 0 0 r
s
.309 .092 .048 r
.61465 .4013 m .62245 .41106 L .63611 .42456 L p F P
0 0 0 r
s
1 .296 .121 r
.32547 .42545 m .33647 .43599 L .32391 .45233 L p F P
0 0 0 r
s
.83 .24 .1 r
.33062 .47461 m
.34039 .44838 L
s
.813 .22 .084 r
.67228 .48059 m .68128 .49177 L .68516 .51077 L p F P
0 0 0 r
s
.641 .167 .062 r
.68128 .49177 m .67228 .48059 L .66446 .46244 L p F P
0 0 0 r
s
.024 .035 .067 r
.5227 .65338 m .51154 .65673 L .51367 .65367 L p F P
0 0 0 r
s
.024 .035 .067 r
.51367 .65367 m .5269 .64969 L .5227 .65338 L p F P
0 0 0 r
s
.641 .167 .062 r
.65564 .45141 m .66446 .46244 L .67228 .48059 L p F P
0 0 0 r
s
.83 .24 .1 r
.66669 .47079 m
.66923 .47567 L
s
.66923 .47567 m
.67009 .47674 L
s
.471 .116 .045 r
.66446 .46244 m .65564 .45141 L .64453 .43512 L p F P
0 0 0 r
s
.24 .35 .67 r
.2482 .44478 m
.28265 .4313 L
s
.2482 .44478 m
.2394 .46286 L
s
.471 .116 .045 r
.63611 .42456 m .64453 .43512 L .65564 .45141 L p F P
0 0 0 r
s
.83 .24 .1 r
.69028 .62287 m
.70255 .5959 L
s
.24 .35 .67 r
.60258 .33542 m
.64088 .32076 L
s
.60258 .33542 m
.58878 .322 L
s
.25 .394 .75 r
.4231 .36829 m .43381 .36407 L .41938 .36691 L p F P
0 0 0 r
s
.24 .35 .67 r
.42678 .37239 m
.46281 .35827 L
s
.25 .394 .75 r
.41938 .36691 m .4064 .37203 L .4231 .36829 L p F P
0 0 0 r
s
.24 .35 .67 r
.41279 .37165 m
.42678 .37239 L
s
.7579 .35916 m
.79788 .34475 L
s
.7579 .35916 m
.74557 .33302 L
s
.024 .035 .067 r
.36805 .38715 m .38074 .38215 L .36207 .39068 L p F P
0 0 0 r
s
.024 .035 .067 r
.36207 .39068 m .34749 .39642 L .36805 .38715 L p F P
0 0 0 r
s
.752 .23 .102 r
.5581 .35525 m .55202 .34779 L .53959 .35218 L p F P
0 0 0 r
s
.752 .23 .102 r
.53486 .34646 m .53959 .35218 L .55202 .34779 L p F P
0 0 0 r
s
.83 .24 .1 r
.51843 .35198 m
.54338 .3518 L
s
.507 .125 .048 r
.38307 .59554 m .39361 .60468 L .40228 .6175 L p F P
0 0 0 r
s
.507 .125 .048 r
.41174 .62567 m .40228 .6175 L .39361 .60468 L p F P
0 0 0 r
s
.83 .24 .1 r
.38172 .58962 m
.40485 .60977 L
s
.40485 .60977 m
.41698 .62821 L
s
.288 .444 .855 r
.48276 .35153 m .49118 .34824 L .48841 .34259 L p F P
0 0 0 r
s
.288 .444 .855 r
.48841 .34259 m .47735 .34694 L .48276 .35153 L p F P
0 0 0 r
s
.83 .24 .1 r
.47092 .33257 m
.48183 .34518 L
s
.24 .35 .67 r
.41099 .67847 m
.42673 .68005 L
s
.042 .053 .102 r
.58085 .63348 m .56721 .63758 L .5759 .62875 L p F P
0 0 0 r
s
.042 .053 .102 r
.5759 .62875 m .59136 .62408 L .58085 .63348 L p F P
0 0 0 r
s
.24 .35 .67 r
.26794 .68959 m
.28666 .70319 L
s
.28666 .70319 m
.3216 .69249 L
s
.83 .24 .1 r
.49728 .32686 m
.47092 .33257 L
s
.44869 .30686 m
.47092 .33257 L
s
.221 .353 .675 r
.48309 .66377 m .47452 .66634 L .46762 .6699 L p F P
0 0 0 r
s
.221 .353 .675 r
.46762 .6699 m .4785 .66664 L .48309 .66377 L p F P
0 0 0 r
s
.24 .35 .67 r
.47631 .66456 m
.51301 .65352 L
s
.58 .187 .085 r
.46109 .66424 m .46762 .6699 L .47452 .66634 L p F P
0 0 0 r
s
.83 .24 .1 r
.4717 .66843 m
.47264 .66884 L
s
.46014 .66341 m
.46257 .66447 L
s
.47264 .66884 m
.47788 .67112 L
s
.24 .35 .67 r
.46639 .66798 m
.46697 .66778 L
s
.4722 .66598 m
.47631 .66456 L
s
.42673 .68005 m
.46316 .6691 L
s
.46316 .6691 m
.46639 .66798 L
s
.83 .24 .1 r
.57884 .68372 m
.59867 .70243 L
s
.59867 .70243 m
.62572 .6891 L
s
.099 .122 .259 r
.68613 .58547 m .66845 .59086 L .67796 .57484 L p F P
0 0 0 r
s
.099 .122 .259 r
.67796 .57484 m .6967 .56905 L .68613 .58547 L p F P
0 0 0 r
s
.24 .35 .67 r
.68055 .58175 m
.68257 .56189 L
s
.024 .035 .067 r
.53393 .65002 m .5227 .65338 L .5269 .64969 L p F P
0 0 0 r
s
.24 .35 .67 r
.51301 .65352 m
.52305 .64326 L
s
.024 .035 .067 r
.5269 .64969 m .54023 .64568 L .53393 .65002 L p F P
0 0 0 r
s
.25 .394 .75 r
.43381 .36407 m .44459 .35983 L .43246 .36175 L p F P
0 0 0 r
s
.25 .394 .75 r
.43246 .36175 m .41938 .36691 L .43381 .36407 L p F P
0 0 0 r
s
.83 .24 .1 r
.50275 .67484 m
.52401 .69373 L
s
.52401 .69373 m
.55093 .69171 L
s
.288 .444 .855 r
.49118 .34824 m .49965 .34492 L .49954 .33821 L p F P
0 0 0 r
s
.288 .444 .855 r
.49954 .33821 m .48841 .34259 L .49118 .34824 L p F P
0 0 0 r
s
.453 .143 .069 r
.61465 .4013 m .60673 .3914 L .59229 .38278 L p F P
0 0 0 r
s
.453 .143 .069 r
.58524 .37403 m .59229 .38278 L .60673 .3914 L p F P
0 0 0 r
s
.066 .08 .157 r
.63855 .60981 m .62268 .61461 L .6336 .60149 L p F P
0 0 0 r
s
.066 .08 .157 r
.6336 .60149 m .65094 .5962 L .63855 .60981 L p F P
0 0 0 r
s
.438 .139 .066 r
.43006 .64194 m .43814 .64891 L .44781 .65272 L p F P
0 0 0 r
s
.438 .139 .066 r
.45449 .65851 m .44781 .65272 L .43814 .64891 L p F P
0 0 0 r
s
.024 .035 .067 r
.38074 .38215 m .39352 .37711 L .37678 .38488 L p F P
0 0 0 r
s
.024 .035 .067 r
.37678 .38488 m .36207 .39068 L .38074 .38215 L p F P
0 0 0 r
s
.83 .24 .1 r
.34927 .37452 m
.36329 .38876 L
s
.601 .189 .087 r
.58524 .37403 m .5781 .36516 L .56411 .36264 L p F P
0 0 0 r
s
.601 .189 .087 r
.5581 .35525 m .56411 .36264 L .5781 .36516 L p F P
0 0 0 r
s
.83 .24 .1 r
.54338 .3518 m
.56355 .3763 L
s
.24 .35 .67 r
.32877 .40542 m
.33244 .40397 L
s
.20524 .47606 m
.2394 .46286 L
s
.20524 .47606 m
.19966 .49919 L
s
.325 .073 .03 r
.40228 .6175 m .41174 .62567 L .42187 .63487 L p F P
0 0 0 r
s
.325 .073 .03 r
.43006 .64194 m .42187 .63487 L .41174 .62567 L p F P
0 0 0 r
s
.24 .35 .67 r
.21511 .68126 m
.23348 .70035 L
s
.23348 .70035 m
.26794 .68959 L
s
.752 .23 .102 r
.55202 .34779 m .54587 .34025 L .53486 .34646 L p F P
0 0 0 r
s
.24 .35 .67 r
.55085 .33672 m
.5651 .34977 L
s
.752 .23 .102 r
.5301 .3407 m .53486 .34646 L .54587 .34025 L p F P
0 0 0 r
s
.24 .35 .67 r
.54144 .34037 m
.55085 .33672 L
s
.55085 .33672 m
.58878 .322 L
s
.83 .24 .1 r
.39571 .33319 m
.37124 .35232 L
s
.34705 .32691 m
.37124 .35232 L
s
.37124 .35232 m
.34927 .37452 L
s
.221 .353 .675 r
.4917 .66119 m .48309 .66377 L .4785 .66664 L p F P
0 0 0 r
s
.221 .353 .675 r
.4785 .66664 m .48944 .66335 L .4917 .66119 L p F P
0 0 0 r
s
.24 .35 .67 r
.79993 .50081 m
.75971 .51361 L
s
.76152 .53727 m
.75971 .51361 L
s
.83 .24 .1 r
.32464 .34952 m
.34927 .37452 L
s
.288 .444 .855 r
.49965 .34492 m .50815 .34159 L .51074 .3338 L p F P
0 0 0 r
s
.83 .24 .1 r
.50859 .34029 m
.50931 .34114 L
s
.288 .444 .855 r
.51074 .3338 m .49954 .33821 L .49965 .34492 L p F P
0 0 0 r
s
.24 .35 .67 r
.49961 .34385 m
.51374 .35113 L
s
.83 .24 .1 r
.49728 .32686 m
.50502 .33605 L
s
1 .302 .124 r
.32547 .42545 m .31428 .41472 L .33304 .40212 L p F P
0 0 0 r
s
.027 .038 .072 r
.33304 .40212 m .34749 .39642 L .33027 .40845 L p F P
0 0 0 r
s
.83 .24 .1 r
.33056 .39903 m
.34927 .37452 L
s
.33356 .40197 m
.33368 .40209 L
s
.33604 .40441 m
.35471 .42275 L
s
.33056 .39903 m
.33356 .40197 L
s
.027 .038 .072 r
.33027 .40845 m .31428 .41472 L .33304 .40212 L p F P
0 0 0 r
s
.24 .35 .67 r
.79993 .50081 m
.7952 .47422 L
s
.7952 .47422 m
.83583 .46098 L
s
.042 .053 .102 r
.59461 .62934 m .58085 .63348 L .59136 .62408 L p F P
0 0 0 r
s
.042 .053 .102 r
.59136 .62408 m .60695 .61936 L .59461 .62934 L p F P
0 0 0 r
s
.24 .35 .67 r
.55999 .63207 m
.59772 .62065 L
s
.59772 .62065 m
.60378 .60528 L
s
.83 .24 .1 r
.67277 .64825 m
.69028 .62287 L
s
.67212 .60257 m
.69028 .62287 L
s
.24 .35 .67 r
.81967 .40277 m
.82861 .43234 L
s
.80931 .37325 m
.81967 .40277 L
s
.25 .394 .75 r
.44459 .35983 m .45544 .35556 L .44565 .35655 L p F P
0 0 0 r
s
.24 .35 .67 r
.44932 .35727 m
.46281 .35827 L
s
.25 .394 .75 r
.44565 .35655 m .43246 .36175 L .44459 .35983 L p F P
0 0 0 r
s
.309 .092 .048 r
.63611 .42456 m .62755 .41382 L .61465 .4013 L p F P
0 0 0 r
s
.309 .092 .048 r
.60673 .3914 m .61465 .4013 L .62755 .41382 L p F P
0 0 0 r
s
.24 .35 .67 r
.79788 .34475 m
.80931 .37325 L
s
.16585 .51203 m
.19966 .49919 L
s
.16585 .51203 m
.16402 .53904 L
s
.024 .035 .067 r
.54523 .64663 m .53393 .65002 L .54023 .64568 L p F P
0 0 0 r
s
.024 .035 .067 r
.54023 .64568 m .55367 .64165 L .54523 .64663 L p F P
0 0 0 r
s
.913 .25 .099 r
.34931 .54156 m .33713 .53076 L .33659 .51169 L p F P
0 0 0 r
s
.809 .217 .084 r
.33713 .53076 m .34931 .54156 L .35352 .55974 L p F P
0 0 0 r
s
.809 .217 .084 r
.36511 .56989 m .35352 .55974 L .34931 .54156 L p F P
0 0 0 r
s
.83 .24 .1 r
.35031 .52248 m
.35126 .54677 L
s
.979 .272 .109 r
.33659 .51169 m .32413 .50047 L .32785 .48152 L p F P
0 0 0 r
s
.913 .25 .099 r
.32413 .50047 m .33659 .51169 L .33713 .53076 L p F P
0 0 0 r
s
.65 .169 .063 r
.35352 .55974 m .36511 .56989 L .37235 .58624 L p F P
0 0 0 r
s
.83 .24 .1 r
.35126 .54677 m
.37506 .56781 L
s
.65 .169 .063 r
.38307 .59554 m .37235 .58624 L .36511 .56989 L p F P
0 0 0 r
s
1 .296 .121 r
.31428 .41472 m .32547 .42545 L .31194 .44112 L p F P
0 0 0 r
s
1 .296 .121 r
.32391 .45233 m .31194 .44112 L .32547 .42545 L p F P
0 0 0 r
s
.24 .35 .67 r
.35731 .68155 m
.37488 .68938 L
s
.37488 .68938 m
.41099 .67847 L
s
.83 .24 .1 r
.42183 .31784 m
.39571 .33319 L
s
.37192 .30736 m
.39571 .33319 L
s
.58 .187 .085 r
.45449 .65851 m .46109 .66424 L .46942 .66188 L p F P
0 0 0 r
s
.58 .187 .085 r
.47452 .66634 m .46942 .66188 L .46109 .66424 L p F P
0 0 0 r
s
.24 .35 .67 r
.74557 .33302 m
.78572 .31822 L
s
.74557 .33302 m
.73279 .30982 L
s
1 .286 .116 r
.32785 .48152 m .31545 .47015 L .32391 .45233 L p F P
0 0 0 r
s
.979 .272 .109 r
.31545 .47015 m .32785 .48152 L .32413 .50047 L p F P
0 0 0 r
s
.83 .24 .1 r
.32589 .50047 m
.33062 .47461 L
s
1 .284 .114 r
.6967 .56905 m .6881 .55889 L .69351 .54067 L p F P
0 0 0 r
s
1 .284 .114 r
.68455 .52985 m .69351 .54067 L .6881 .55889 L p F P
0 0 0 r
s
.83 .24 .1 r
.69176 .53856 m
.69187 .53478 L
s
.939 .259 .102 r
.69351 .54067 m .68455 .52985 L .68516 .51077 L p F P
0 0 0 r
s
.24 .35 .67 r
.69321 .32471 m
.73279 .30982 L
s
.69321 .32471 m
.68 .30578 L
s
.83 .24 .1 r
.6063 .67003 m
.62572 .6891 L
s
.62572 .6891 m
.65087 .67073 L
s
.024 .035 .067 r
.39352 .37711 m .4064 .37203 L .39162 .37904 L p F P
0 0 0 r
s
.024 .035 .067 r
.39162 .37904 m .37678 .38488 L .39352 .37711 L p F P
0 0 0 r
s
.24 .35 .67 r
.37703 .38573 m
.41279 .37165 L
s
1 .286 .116 r
.31194 .44112 m .32391 .45233 L .31545 .47015 L p F P
0 0 0 r
s
.83 .24 .1 r
.31581 .42499 m
.34039 .44838 L
s
.813 .22 .084 r
.68516 .51077 m .67601 .49953 L .67228 .48059 L p F P
0 0 0 r
s
.939 .259 .102 r
.67601 .49953 m .68516 .51077 L .68455 .52985 L p F P
0 0 0 r
s
.24 .35 .67 r
.72019 .5696 m
.72162 .54971 L
s
.72162 .54971 m
.76152 .53727 L
s
1 .3 .122 r
.6881 .55889 m .6967 .56905 L .68613 .58547 L p F P
0 0 0 r
s
.83 .24 .1 r
.68931 .58054 m
.70255 .5959 L
s
.471 .116 .045 r
.65564 .45141 m .64667 .44018 L .63611 .42456 L p F P
0 0 0 r
s
.471 .116 .045 r
.62755 .41382 m .63611 .42456 L .64667 .44018 L p F P
0 0 0 r
s
.83 .24 .1 r
.62486 .41644 m
.64023 .43229 L
s
.288 .444 .855 r
.50815 .34159 m .5167 .33825 L .52202 .32936 L p F P
0 0 0 r
s
.288 .444 .855 r
.52202 .32936 m .51074 .3338 L .50815 .34159 L p F P
0 0 0 r
s
.066 .08 .157 r
.65456 .60497 m .63855 .60981 L .65094 .5962 L p F P
0 0 0 r
s
.24 .35 .67 r
.63628 .60898 m
.64175 .59364 L
s
.066 .08 .157 r
.65094 .5962 m .66845 .59086 L .65456 .60497 L p F P
0 0 0 r
s
.24 .35 .67 r
.64175 .59364 m
.68055 .58175 L
s
.813 .22 .084 r
.66312 .46919 m .67228 .48059 L .67601 .49953 L p F P
0 0 0 r
s
.83 .24 .1 r
.66923 .47567 m
.66955 .47719 L
s
.67252 .49132 m
.67425 .49953 L
s
.641 .167 .062 r
.67228 .48059 m .66312 .46919 L .65564 .45141 L p F P
0 0 0 r
s
.221 .353 .675 r
.50036 .65859 m .4917 .66119 L .48944 .66335 L p F P
0 0 0 r
s
.221 .353 .675 r
.48944 .66335 m .50046 .66005 L .50036 .65859 L p F P
0 0 0 r
s
.641 .167 .062 r
.64667 .44018 m .65564 .45141 L .66312 .46919 L p F P
0 0 0 r
s
.83 .24 .1 r
.64023 .43229 m
.64699 .44076 L
s
.507 .125 .048 r
.37235 .58624 m .38307 .59554 L .39267 .60921 L p F P
0 0 0 r
s
.507 .125 .048 r
.40228 .6175 m .39267 .60921 L .38307 .59554 L p F P
0 0 0 r
s
.752 .23 .102 r
.54587 .34025 m .53966 .33261 L .5301 .3407 L p F P
0 0 0 r
s
.752 .23 .102 r
.52529 .33488 m .5301 .3407 L .53966 .33261 L p F P
0 0 0 r
s
.83 .24 .1 r
.31581 .42499 m
.32376 .411 L
s
.25 .394 .75 r
.45544 .35556 m .46636 .35127 L .45894 .35131 L p F P
0 0 0 r
s
.24 .35 .67 r
.46281 .35827 m
.49961 .34385 L
s
.25 .394 .75 r
.45894 .35131 m .44565 .35655 L .45544 .35556 L p F P
0 0 0 r
s
.83 .24 .1 r
.65087 .67073 m
.67277 .64825 L
s
.65421 .62837 m
.67277 .64825 L
s
.24 .35 .67 r
.82861 .43234 m
.83583 .46098 L
s
.601 .189 .087 r
.5781 .36516 m .57087 .35618 L .5581 .35525 L p F P
0 0 0 r
s
.601 .189 .087 r
.55202 .34779 m .5581 .35525 L .57087 .35618 L p F P
0 0 0 r
s
.83 .24 .1 r
.47348 .66727 m
.47788 .67112 L
s
.47788 .67112 m
.50275 .67484 L
s
.63188 .65126 m
.65087 .67073 L
s
.453 .143 .069 r
.60673 .3914 m .59868 .38134 L .58524 .37403 L p F P
0 0 0 r
s
.453 .143 .069 r
.5781 .36516 m .58524 .37403 L .59868 .38134 L p F P
0 0 0 r
s
.027 .038 .072 r
.34749 .39642 m .36207 .39068 L .34641 .40211 L p F P
0 0 0 r
s
.24 .35 .67 r
.34215 .40015 m
.34716 .39818 L
s
.027 .038 .072 r
.34641 .40211 m .33027 .40845 L .34749 .39642 L p F P
0 0 0 r
s
.83 .24 .1 r
.32575 .40749 m
.33056 .39903 L
s
.30548 .3744 m
.33056 .39903 L
s
.042 .053 .102 r
.60846 .62518 m .59461 .62934 L .60695 .61936 L p F P
0 0 0 r
s
.042 .053 .102 r
.60695 .61936 m .62268 .61461 L .60846 .62518 L p F P
0 0 0 r
s
.438 .139 .066 r
.42187 .63487 m .43006 .64194 L .44105 .64687 L p F P
0 0 0 r
s
.438 .139 .066 r
.44781 .65272 m .44105 .64687 L .43006 .64194 L p F P
0 0 0 r
s
.83 .24 .1 r
.43409 .64245 m
.43436 .64269 L
s
.24 .35 .67 r
.28265 .4313 m
.2743 .44937 L
s
.64088 .32076 m
.68 .30578 L
s
.64088 .32076 m
.62754 .30695 L
s
.024 .035 .067 r
.55661 .64322 m .54523 .64663 L .55367 .64165 L p F P
0 0 0 r
s
.024 .035 .067 r
.55367 .64165 m .56721 .63758 L .55661 .64322 L p F P
0 0 0 r
s
.24 .35 .67 r
.78572 .31822 m
.79788 .34475 L
s
.288 .444 .855 r
.5167 .33825 m .52529 .33488 L .53337 .3249 L p F P
0 0 0 r
s
.288 .444 .855 r
.53337 .3249 m .52202 .32936 L .5167 .33825 L p F P
0 0 0 r
s
.83 .24 .1 r
.52244 .32637 m
.5242 .32851 L
s
.221 .353 .675 r
.50906 .65597 m .50036 .65859 L .50046 .66005 L p F P
0 0 0 r
s
.221 .353 .675 r
.50046 .66005 m .51154 .65673 L .50906 .65597 L p F P
0 0 0 r
s
.024 .035 .067 r
.4064 .37203 m .41938 .36691 L .40659 .37314 L p F P
0 0 0 r
s
.024 .035 .067 r
.40659 .37314 m .39162 .37904 L .4064 .37203 L p F P
0 0 0 r
s
.24 .35 .67 r
.44789 .66731 m
.46316 .6691 L
s
.46316 .6691 m
.47058 .66687 L
s
.325 .073 .03 r
.39267 .60921 m .40228 .6175 L .41358 .62771 L p F P
0 0 0 r
s
.325 .073 .03 r
.42187 .63487 m .41358 .62771 L .40228 .6175 L p F P
0 0 0 r
s
.83 .24 .1 r
.41698 .62821 m
.43409 .64245 L
s
.49728 .32686 m
.52244 .32637 L
s
.47531 .30077 m
.49728 .32686 L
s
.24 .35 .67 r
.30316 .67858 m
.3216 .69249 L
s
.3216 .69249 m
.35731 .68155 L
s
.6894 .57904 m
.72019 .5696 L
s
.68055 .58175 m
.68655 .57991 L
s
.25 .394 .75 r
.46636 .35127 m .47735 .34694 L .47233 .34603 L p F P
0 0 0 r
s
.25 .394 .75 r
.47233 .34603 m .45894 .35131 L .46636 .35127 L p F P
0 0 0 r
s
.83 .24 .1 r
.44869 .30686 m
.42183 .31784 L
s
.39841 .29157 m
.42183 .31784 L
s
.58 .187 .085 r
.44781 .65272 m .45449 .65851 L .46427 .65738 L p F P
0 0 0 r
s
.58 .187 .085 r
.46942 .66188 m .46427 .65738 L .45449 .65851 L p F P
0 0 0 r
s
.066 .08 .157 r
.67072 .60009 m .65456 .60497 L .66845 .59086 L p F P
0 0 0 r
s
.066 .08 .157 r
.66845 .59086 m .68613 .58547 L .67072 .60009 L p F P
0 0 0 r
s
.83 .24 .1 r
.52997 .67258 m
.55093 .69171 L
s
.55093 .69171 m
.57884 .68372 L
s
.752 .23 .102 r
.53966 .33261 m .53337 .3249 L .52529 .33488 L p F P
0 0 0 r
s
.24 .35 .67 r
.5369 .32923 m
.53723 .32911 L
s
.49961 .34385 m
.52961 .33209 L
s
.83 .24 .1 r
.52671 .33156 m
.54338 .3518 L
s
.309 .092 .048 r
.62755 .41382 m .61883 .4029 L .60673 .3914 L p F P
0 0 0 r
s
.309 .092 .048 r
.59868 .38134 m .60673 .3914 L .61883 .4029 L p F P
0 0 0 r
s
.83 .24 .1 r
.60566 .39248 m
.62486 .41644 L
s
.58617 .38174 m
.60566 .39248 L
s
.024 .035 .067 r
.56806 .63978 m .55661 .64322 L .56721 .63758 L p F P
0 0 0 r
s
.24 .35 .67 r
.55051 .64225 m
.55999 .63207 L
s
.024 .035 .067 r
.56721 .63758 m .58085 .63348 L .56806 .63978 L p F P
0 0 0 r
s
.027 .038 .072 r
.36207 .39068 m .37678 .38488 L .36272 .39571 L p F P
0 0 0 r
s
.24 .35 .67 r
.35722 .39422 m
.36227 .39223 L
s
.3738 .38718 m
.37703 .38573 L
s
.027 .038 .072 r
.36272 .39571 m .34641 .40211 L .36207 .39068 L p F P
0 0 0 r
s
.042 .053 .102 r
.62243 .62098 m .60846 .62518 L .62268 .61461 L p F P
0 0 0 r
s
.042 .053 .102 r
.62268 .61461 m .63855 .60981 L .62243 .62098 L p F P
0 0 0 r
s
.24 .35 .67 r
.59772 .62065 m
.63628 .60898 L
s
.221 .353 .675 r
.5178 .65335 m .50906 .65597 L .51154 .65673 L p F P
0 0 0 r
s
.221 .353 .675 r
.51154 .65673 m .5227 .65338 L .5178 .65335 L p F P
0 0 0 r
s
.24 .35 .67 r
.51301 .65352 m
.55051 .64225 L
s
.50039 .65792 m
.51301 .65352 L
s
.2394 .46286 m
.2743 .44937 L
s
.2394 .46286 m
.23421 .48607 L
s
.601 .189 .087 r
.57087 .35618 m .56353 .34707 L .55202 .34779 L p F P
0 0 0 r
s
.83 .24 .1 r
.54338 .3518 m
.56616 .35701 L
s
.601 .189 .087 r
.54587 .34025 m .55202 .34779 L .56353 .34707 L p F P
0 0 0 r
s
.24 .35 .67 r
.24975 .67016 m
.26794 .68959 L
s
.26794 .68959 m
.30316 .67858 L
s
.024 .035 .067 r
.41938 .36691 m .43246 .36175 L .4217 .36718 L p F P
0 0 0 r
s
.024 .035 .067 r
.4217 .36718 m .40659 .37314 L .41938 .36691 L p F P
0 0 0 r
s
.24 .35 .67 r
.41279 .37165 m
.44932 .35727 L
s
.19835 .65721 m
.21511 .68126 L
s
.21511 .68126 m
.24975 .67016 L
s
.58878 .322 m
.62754 .30695 L
s
.58878 .322 m
.57568 .31404 L
s
1 .296 .121 r
.31194 .44112 m .29975 .4297 L .31428 .41472 L p F P
0 0 0 r
s
.051 .063 .121 r
.31428 .41472 m .33027 .40845 L .31692 .42301 L p F P
0 0 0 r
s
.051 .063 .121 r
.31692 .42301 m .29975 .4297 L .31428 .41472 L p F P
0 0 0 r
s
.83 .24 .1 r
.31466 .42389 m
.31581 .42499 L
s
.30924 .41874 m
.31015 .4196 L
s
.29029 .40071 m
.30924 .41874 L
s
.25 .394 .75 r
.47735 .34694 m .48841 .34259 L .48583 .34071 L p F P
0 0 0 r
s
.25 .394 .75 r
.48583 .34071 m .47233 .34603 L .47735 .34694 L p F P
0 0 0 r
s
.913 .25 .099 r
.33713 .53076 m .32471 .51975 L .32413 .50047 L p F P
0 0 0 r
s
.809 .217 .084 r
.32471 .51975 m .33713 .53076 L .34172 .54941 L p F P
0 0 0 r
s
.83 .24 .1 r
.32589 .50047 m
.35031 .52248 L
s
.809 .217 .084 r
.35352 .55974 m .34172 .54941 L .33713 .53076 L p F P
0 0 0 r
s
.24 .35 .67 r
.84104 .48772 m
.79993 .50081 L
s
.80231 .52455 m
.79993 .50081 L
s
.65 .169 .063 r
.34172 .54941 m .35352 .55974 L .36145 .57679 L p F P
0 0 0 r
s
.65 .169 .063 r
.37235 .58624 m .36145 .57679 L .35352 .55974 L p F P
0 0 0 r
s
.83 .24 .1 r
.35126 .54677 m
.35771 .56871 L
s
.471 .116 .045 r
.64667 .44018 m .63753 .42874 L .62755 .41382 L p F P
0 0 0 r
s
.471 .116 .045 r
.61883 .4029 m .62755 .41382 L .63753 .42874 L p F P
0 0 0 r
s
.979 .272 .109 r
.32413 .50047 m .31143 .48903 L .31545 .47015 L p F P
0 0 0 r
s
.913 .25 .099 r
.31143 .48903 m .32413 .50047 L .32471 .51975 L p F P
0 0 0 r
s
.24 .35 .67 r
.83583 .46098 m
.84104 .48772 L
s
.453 .143 .069 r
.59868 .38134 m .59051 .37112 L .5781 .36516 L p F P
0 0 0 r
s
.453 .143 .069 r
.57087 .35618 m .5781 .36516 L .59051 .37112 L p F P
0 0 0 r
s
.83 .24 .1 r
.56616 .35701 m
.58617 .38174 L
s
1 .286 .116 r
.29975 .4297 m .31194 .44112 L .30282 .45856 L p F P
0 0 0 r
s
.24 .35 .67 r
.28265 .4313 m
.3077 .42151 L
s
1 .286 .116 r
.31545 .47015 m .30282 .45856 L .31194 .44112 L p F P
0 0 0 r
s
.83 .24 .1 r
.30564 .45151 m
.31581 .42499 L
s
.979 .272 .109 r
.30282 .45856 m .31545 .47015 L .31143 .48903 L p F P
0 0 0 r
s
.83 .24 .1 r
.30564 .45151 m
.33062 .47461 L
s
1 .284 .114 r
.6881 .55889 m .67935 .54855 L .68455 .52985 L p F P
0 0 0 r
s
1 .284 .114 r
.67543 .51883 m .68455 .52985 L .67935 .54855 L p F P
0 0 0 r
s
.939 .259 .102 r
.68455 .52985 m .67543 .51883 L .67601 .49953 L p F P
0 0 0 r
s
.83 .24 .1 r
.67425 .49953 m
.67595 .50162 L
s
1 .3 .122 r
.68613 .58547 m .67791 .576 L .6881 .55889 L p F P
0 0 0 r
s
1 .3 .122 r
.67935 .54855 m .6881 .55889 L .67791 .576 L p F P
0 0 0 r
s
.438 .139 .066 r
.41358 .62771 m .42187 .63487 L .43422 .64095 L p F P
0 0 0 r
s
.83 .24 .1 r
.39375 .60812 m
.41698 .62821 L
s
.438 .139 .066 r
.44105 .64687 m .43422 .64095 L .42187 .63487 L p F P
0 0 0 r
s
.24 .35 .67 r
.16402 .53904 m
.19816 .52636 L
s
.16402 .53904 m
.16654 .56866 L
s
.813 .22 .084 r
.67601 .49953 m .66668 .48807 L .66312 .46919 L p F P
0 0 0 r
s
.939 .259 .102 r
.66668 .48807 m .67601 .49953 L .67543 .51883 L p F P
0 0 0 r
s
.507 .125 .048 r
.36145 .57679 m .37235 .58624 L .38292 .60079 L p F P
0 0 0 r
s
.507 .125 .048 r
.39267 .60921 m .38292 .60079 L .37235 .58624 L p F P
0 0 0 r
s
.83 .24 .1 r
.38172 .58962 m
.39375 .60812 L
s
.35771 .56871 m
.38172 .58962 L
s
.641 .167 .062 r
.66312 .46919 m .65378 .45759 L .64667 .44018 L p F P
0 0 0 r
s
.641 .167 .062 r
.63753 .42874 m .64667 .44018 L .65378 .45759 L p F P
0 0 0 r
s
.83 .24 .1 r
.6507 .45261 m
.65164 .45378 L
s
.6477 .44679 m
.6507 .45261 L
s
.24 .35 .67 r
.19966 .49919 m
.23421 .48607 L
s
.19966 .49919 m
.19816 .52636 L
s
.813 .22 .084 r
.65378 .45759 m .66312 .46919 L .66668 .48807 L p F P
0 0 0 r
s
.221 .353 .675 r
.52659 .65071 m .5178 .65335 L .5227 .65338 L p F P
0 0 0 r
s
.221 .353 .675 r
.5227 .65338 m .53393 .65002 L .52659 .65071 L p F P
0 0 0 r
s
1 .31 .127 r
.67791 .576 m .68613 .58547 L .67072 .60009 L p F P
0 0 0 r
s
.24 .35 .67 r
.39381 .67037 m
.41099 .67847 L
s
.41099 .67847 m
.44789 .66731 L
s
.77325 .29459 m
.78572 .31822 L
s
.024 .035 .067 r
.57959 .63633 m .56806 .63978 L .58085 .63348 L p F P
0 0 0 r
s
.024 .035 .067 r
.58085 .63348 m .59461 .62934 L .57959 .63633 L p F P
0 0 0 r
s
.83 .24 .1 r
.67212 .60257 m
.67525 .59579 L
s
.24 .35 .67 r
.73279 .30982 m
.77325 .29459 L
s
.73279 .30982 m
.72 .29047 L
s
.58 .187 .085 r
.44105 .64687 m .44781 .65272 L .45907 .65283 L p F P
0 0 0 r
s
.58 .187 .085 r
.46427 .65738 m .45907 .65283 L .44781 .65272 L p F P
0 0 0 r
s
.24 .35 .67 r
.76071 .55718 m
.76152 .53727 L
s
.76152 .53727 m
.80231 .52455 L
s
.25 .394 .75 r
.48841 .34259 m .49954 .33821 L .49943 .33534 L p F P
0 0 0 r
s
.25 .394 .75 r
.49943 .33534 m .48583 .34071 L .48841 .34259 L p F P
0 0 0 r
s
.24 .35 .67 r
.48666 .34257 m
.49961 .34385 L
s
.027 .038 .072 r
.37678 .38488 m .39162 .37904 L .37919 .38925 L p F P
0 0 0 r
s
.24 .35 .67 r
.37243 .38824 m
.37752 .38623 L
s
.027 .038 .072 r
.37919 .38925 m .36272 .39571 L .37678 .38488 L p F P
0 0 0 r
s
.042 .053 .102 r
.63651 .61675 m .62243 .62098 L .63855 .60981 L p F P
0 0 0 r
s
.042 .053 .102 r
.63855 .60981 m .65456 .60497 L .63651 .61675 L p F P
0 0 0 r
s
.024 .035 .067 r
.43246 .36175 m .44565 .35655 L .43695 .36118 L p F P
0 0 0 r
s
.024 .035 .067 r
.43695 .36118 m .4217 .36718 L .43246 .36175 L p F P
0 0 0 r
s
.325 .073 .03 r
.38292 .60079 m .39267 .60921 L .40516 .62046 L p F P
0 0 0 r
s
.325 .073 .03 r
.41358 .62771 m .40516 .62046 L .39267 .60921 L p F P
0 0 0 r
s
.27 .42 .813 r
.48828 .65667 m .48233 .65847 L .47452 .66634 L p F P
0 0 0 r
s
.24 .35 .67 r
.47396 .66586 m
.47545 .66541 L
s
.27 .42 .813 r
.47452 .66634 m .48309 .66377 L .48828 .65667 L p F P
0 0 0 r
s
.24 .35 .67 r
.48371 .66293 m
.50039 .65792 L
s
.762 .236 .104 r
.46942 .66188 m .47452 .66634 L .48233 .65847 L p F P
0 0 0 r
s
.83 .24 .1 r
.47531 .30077 m
.44869 .30686 L
s
.42559 .28017 m
.44869 .30686 L
s
.051 .063 .121 r
.33027 .40845 m .34641 .40211 L .33427 .41625 L p F P
0 0 0 r
s
.051 .063 .121 r
.33427 .41625 m .31692 .42301 L .33027 .40845 L p F P
0 0 0 r
s
.601 .189 .087 r
.56353 .34707 m .55609 .33784 L .54587 .34025 L p F P
0 0 0 r
s
.601 .189 .087 r
.53966 .33261 m .54587 .34025 L .55609 .33784 L p F P
0 0 0 r
s
.24 .35 .67 r
.53723 .32911 m
.54859 .33545 L
s
.83 .24 .1 r
.55825 .66428 m
.57884 .68372 L
s
.57884 .68372 m
.6063 .67003 L
s
.221 .353 .675 r
.53543 .64806 m .52659 .65071 L .53393 .65002 L p F P
0 0 0 r
s
.221 .353 .675 r
.53393 .65002 m .54523 .64663 L .53543 .64806 L p F P
0 0 0 r
s
.24 .35 .67 r
.68 .30578 m
.72 .29047 L
s
.68 .30578 m
.66715 .29157 L
s
.83 .24 .1 r
.50275 .67484 m
.52997 .67258 L
s
.309 .092 .048 r
.61883 .4029 m .60997 .39179 L .59868 .38134 L p F P
0 0 0 r
s
.309 .092 .048 r
.59051 .37112 m .59868 .38134 L .60997 .39179 L p F P
0 0 0 r
s
.24 .35 .67 r
.53675 .32905 m
.53723 .32911 L
s
.024 .035 .067 r
.59119 .63285 m .57959 .63633 L .59461 .62934 L p F P
0 0 0 r
s
.24 .35 .67 r
.55051 .64225 m
.58883 .63073 L
s
.024 .035 .067 r
.59461 .62934 m .60846 .62518 L .59119 .63285 L p F P
0 0 0 r
s
.24 .35 .67 r
.58883 .63073 m
.59772 .62065 L
s
.25 .394 .75 r
.49954 .33821 m .51074 .3338 L .51315 .32993 L p F P
0 0 0 r
s
.25 .394 .75 r
.51315 .32993 m .49943 .33534 L .49954 .33821 L p F P
0 0 0 r
s
.27 .42 .813 r
.49425 .65487 m .48828 .65667 L .48309 .66377 L p F P
0 0 0 r
s
.27 .42 .813 r
.48309 .66377 m .4917 .66119 L .49425 .65487 L p F P
0 0 0 r
s
.83 .24 .1 r
.48768 .66145 m
.50275 .67484 L
s
.48457 .65868 m
.48768 .66145 L
s
.24 .35 .67 r
.18417 .62942 m
.19835 .65721 L
s
.19835 .65721 m
.23309 .64576 L
s
.024 .035 .067 r
.44565 .35655 m .45894 .35131 L .45233 .35511 L p F P
0 0 0 r
s
.024 .035 .067 r
.45233 .35511 m .43695 .36118 L .44565 .35655 L p F P
0 0 0 r
s
.24 .35 .67 r
.43759 .36259 m
.44932 .35727 L
s
.33917 .66734 m
.35731 .68155 L
s
.35731 .68155 m
.39381 .67037 L
s
.71598 .58485 m
.72019 .5696 L
s
.72019 .5696 m
.76071 .55718 L
s
.453 .143 .069 r
.59051 .37112 m .58222 .36074 L .57087 .35618 L p F P
0 0 0 r
s
.453 .143 .069 r
.56353 .34707 m .57087 .35618 L .58222 .36074 L p F P
0 0 0 r
s
.027 .038 .072 r
.39162 .37904 m .40659 .37314 L .39583 .38272 L p F P
0 0 0 r
s
.24 .35 .67 r
.38777 .3822 m
.39292 .38017 L
s
.40362 .37578 m
.41279 .37165 L
s
.027 .038 .072 r
.39583 .38272 m .37919 .38925 L .39162 .37904 L p F P
0 0 0 r
s
.042 .053 .102 r
.6507 .61249 m .63651 .61675 L .65456 .60497 L p F P
0 0 0 r
s
.042 .053 .102 r
.65456 .60497 m .67072 .60009 L .6507 .61249 L p F P
0 0 0 r
s
.438 .139 .066 r
.40516 .62046 m .41358 .62771 L .42731 .63496 L p F P
0 0 0 r
s
.438 .139 .066 r
.43422 .64095 m .42731 .63496 L .41358 .62771 L p F P
0 0 0 r
s
.83 .24 .1 r
.37192 .30736 m
.34705 .32691 L
s
.32191 .30052 m
.34705 .32691 L
s
.34705 .32691 m
.32464 .34952 L
s
.58 .187 .085 r
.43422 .64095 m .44105 .64687 L .45383 .64825 L p F P
0 0 0 r
s
.58 .187 .085 r
.45907 .65283 m .45383 .64825 L .44105 .64687 L p F P
0 0 0 r
s
.24 .35 .67 r
.16654 .56866 m
.20095 .55622 L
s
.16654 .56866 m
.17336 .59935 L
s
.83 .24 .1 r
.29906 .32355 m
.32464 .34952 L
s
.32464 .34952 m
.30548 .3744 L
s
.221 .353 .675 r
.5443 .64539 m .53543 .64806 L .54523 .64663 L p F P
0 0 0 r
s
.221 .353 .675 r
.54523 .64663 m .55661 .64322 L .5443 .64539 L p F P
0 0 0 r
s
.83 .24 .1 r
.67019 .60041 m
.67212 .60257 L
s
.762 .236 .104 r
.46427 .65738 m .46942 .66188 L .47881 .65535 L p F P
0 0 0 r
s
.762 .236 .104 r
.48233 .65847 m .47881 .65535 L .46942 .66188 L p F P
0 0 0 r
s
.471 .116 .045 r
.63753 .42874 m .62822 .4171 L .61883 .4029 L p F P
0 0 0 r
s
.471 .116 .045 r
.60997 .39179 m .61883 .4029 L .62822 .4171 L p F P
0 0 0 r
s
.83 .24 .1 r
.60566 .39248 m
.62105 .40828 L
s
.809 .217 .084 r
.34172 .54941 m .3297 .53889 L .32471 .51975 L p F P
0 0 0 r
s
.65 .169 .063 r
.3297 .53889 m .34172 .54941 L .35036 .56717 L p F P
0 0 0 r
s
.65 .169 .063 r
.36145 .57679 m .35036 .56717 L .34172 .54941 L p F P
0 0 0 r
s
.25 .394 .75 r
.51074 .3338 m .52202 .32936 L .52697 .32448 L p F P
0 0 0 r
s
.83 .24 .1 r
.52244 .32637 m
.52334 .32657 L
s
.25 .394 .75 r
.52697 .32448 m .51315 .32993 L .51074 .3338 L p F P
0 0 0 r
s
.83 .24 .1 r
.52458 .32684 m
.52707 .32737 L
s
.913 .25 .099 r
.32471 .51975 m .31206 .50854 L .31143 .48903 L p F P
0 0 0 r
s
.809 .217 .084 r
.31206 .50854 m .32471 .51975 L .3297 .53889 L p F P
0 0 0 r
s
.83 .24 .1 r
.32655 .52494 m
.35126 .54677 L
s
.32589 .50047 m
.32655 .52494 L
s
.051 .063 .121 r
.34641 .40211 m .36272 .39571 L .35181 .40942 L p F P
0 0 0 r
s
.051 .063 .121 r
.35181 .40942 m .33427 .41625 L .34641 .40211 L p F P
0 0 0 r
s
.27 .42 .813 r
.50025 .65306 m .49425 .65487 L .4917 .66119 L p F P
0 0 0 r
s
.27 .42 .813 r
.4917 .66119 m .50036 .65859 L .50025 .65306 L p F P
0 0 0 r
s
.24 .35 .67 r
.50035 .65791 m
.50039 .65792 L
s
.507 .125 .048 r
.35036 .56717 m .36145 .57679 L .37301 .59224 L p F P
0 0 0 r
s
.507 .125 .048 r
.38292 .60079 m .37301 .59224 L .36145 .57679 L p F P
0 0 0 r
s
1 .286 .116 r
.30282 .45856 m .28995 .44675 L .29975 .4297 L p F P
0 0 0 r
s
.09 .111 .237 r
.29975 .4297 m .31692 .42301 L .30791 .43982 L p F P
0 0 0 r
s
.09 .111 .237 r
.30791 .43982 m .28995 .44675 L .29975 .4297 L p F P
0 0 0 r
s
.83 .24 .1 r
.29244 .4393 m
.29409 .44083 L
s
.27969 .42751 m
.29244 .4393 L
s
.24 .35 .67 r
.2743 .44937 m
.26953 .47265 L
s
.979 .272 .109 r
.31143 .48903 m .29848 .47737 L .30282 .45856 L p F P
0 0 0 r
s
.913 .25 .099 r
.29848 .47737 m .31143 .48903 L .31206 .50854 L p F P
0 0 0 r
s
1 .3 .122 r
.67791 .576 m .66955 .56637 L .67935 .54855 L p F P
0 0 0 r
s
1 .3 .122 r
.67043 .53801 m .67935 .54855 L .66955 .56637 L p F P
0 0 0 r
s
1 .284 .114 r
.67935 .54855 m .67043 .53801 L .67543 .51883 L p F P
0 0 0 r
s
.024 .035 .067 r
.60287 .62935 m .59119 .63285 L .60846 .62518 L p F P
0 0 0 r
s
.024 .035 .067 r
.60846 .62518 m .62243 .62098 L .60287 .62935 L p F P
0 0 0 r
s
.83 .24 .1 r
.39841 .29157 m
.37192 .30736 L
s
.34721 .28052 m
.37192 .30736 L
s
.24 .35 .67 r
.28517 .65882 m
.30316 .67858 L
s
.30316 .67858 m
.33917 .66734 L
s
.979 .272 .109 r
.28995 .44675 m .30282 .45856 L .29848 .47737 L p F P
0 0 0 r
s
.24 .35 .67 r
.2743 .44937 m
.29248 .44234 L
s
.83 .24 .1 r
.29739 .44388 m
.30564 .45151 L
s
1 .284 .114 r
.66612 .5076 m .67543 .51883 L .67043 .53801 L p F P
0 0 0 r
s
.83 .24 .1 r
.67363 .51667 m
.67377 .51299 L
s
.939 .259 .102 r
.67543 .51883 m .66612 .5076 L .66668 .48807 L p F P
0 0 0 r
s
.24 .35 .67 r
.23309 .64576 m
.24975 .67016 L
s
.24975 .67016 m
.28517 .65882 L
s
.601 .189 .087 r
.55609 .33784 m .54855 .32848 L .53966 .33261 L p F P
0 0 0 r
s
.601 .189 .087 r
.53337 .3249 m .53966 .33261 L .54855 .32848 L p F P
0 0 0 r
s
.83 .24 .1 r
.58613 .65022 m
.6063 .67003 L
s
.6063 .67003 m
.63188 .65126 L
s
.24 .35 .67 r
.62754 .30695 m
.66715 .29157 L
s
.62754 .30695 m
.61498 .29864 L
s
1 .31 .127 r
.67072 .60009 m .66306 .59152 L .67791 .576 L p F P
0 0 0 r
s
.24 .35 .67 r
.67569 .59705 m
.67639 .59484 L
s
.67639 .59484 m
.6773 .59198 L
s
1 .31 .127 r
.66955 .56637 m .67791 .576 L .66306 .59152 L p F P
0 0 0 r
s
.641 .167 .062 r
.65378 .45759 m .64427 .44576 L .63753 .42874 L p F P
0 0 0 r
s
.641 .167 .062 r
.62822 .4171 m .63753 .42874 L .64427 .44576 L p F P
0 0 0 r
s
.83 .24 .1 r
.62105 .40828 m
.62854 .41766 L
s
.813 .22 .084 r
.66668 .48807 m .65717 .47639 L .65378 .45759 L p F P
0 0 0 r
s
.939 .259 .102 r
.65717 .47639 m .66668 .48807 L .66612 .5076 L p F P
0 0 0 r
s
.813 .22 .084 r
.64427 .44576 m .65378 .45759 L .65717 .47639 L p F P
0 0 0 r
s
.83 .24 .1 r
.65399 .46883 m
.65557 .47663 L
s
.024 .035 .067 r
.45894 .35131 m .47233 .34603 L .46786 .349 L p F P
0 0 0 r
s
.024 .035 .067 r
.46786 .349 m .45233 .35511 L .45894 .35131 L p F P
0 0 0 r
s
.24 .35 .67 r
.44932 .35727 m
.48666 .34257 L
s
.84104 .48772 m
.844 .51155 L
s
.17336 .59935 m
.18417 .62942 L
s
.18417 .62942 m
.21889 .61761 L
s
.325 .073 .03 r
.37301 .59224 m .38292 .60079 L .39664 .6131 L p F P
0 0 0 r
s
.325 .073 .03 r
.40516 .62046 m .39664 .6131 L .38292 .60079 L p F P
0 0 0 r
s
.221 .353 .675 r
.55323 .64271 m .5443 .64539 L .55661 .64322 L p F P
0 0 0 r
s
.24 .35 .67 r
.53844 .64648 m
.55051 .64225 L
s
.221 .353 .675 r
.55661 .64322 m .56806 .63978 L .55323 .64271 L p F P
0 0 0 r
s
.24 .35 .67 r
.17336 .59935 m
.20798 .5872 L
s
.83 .24 .1 r
.27944 .34882 m
.30548 .3744 L
s
.30548 .3744 m
.29029 .40071 L
s
.027 .038 .072 r
.40659 .37314 m .4217 .36718 L .41264 .37612 L p F P
0 0 0 r
s
.027 .038 .072 r
.41264 .37612 m .39583 .38272 L .40659 .37314 L p F P
0 0 0 r
s
.24 .35 .67 r
.19816 .52636 m
.23306 .5134 L
s
.19816 .52636 m
.20095 .55622 L
s
1 .316 .13 r
.66306 .59152 m .67072 .60009 L .6507 .61249 L p F P
0 0 0 r
s
.24 .35 .67 r
.67084 .59852 m
.67569 .59705 L
s
.67064 .59858 m
.67084 .59852 L
s
.63628 .60898 m
.65635 .6029 L
s
.83 .24 .1 r
.65421 .62837 m
.67212 .60257 L
s
.27 .42 .813 r
.50627 .65124 m .50025 .65306 L .50036 .65859 L p F P
0 0 0 r
s
.27 .42 .813 r
.50036 .65859 m .50906 .65597 L .50627 .65124 L p F P
0 0 0 r
s
.83 .24 .1 r
.63188 .65126 m
.65421 .62837 L
s
.24 .35 .67 r
.23421 .48607 m
.26953 .47265 L
s
.23421 .48607 m
.23306 .5134 L
s
.25 .394 .75 r
.52202 .32936 m .53337 .3249 L .54091 .31899 L p F P
0 0 0 r
s
.25 .394 .75 r
.54091 .31899 m .52697 .32448 L .52202 .32936 L p F P
0 0 0 r
s
.24 .35 .67 r
.43112 .65894 m
.44789 .66731 L
s
.44789 .66731 m
.4737 .65951 L
s
.4737 .65951 m
.479 .65791 L
s
.762 .236 .104 r
.45907 .65283 m .46427 .65738 L .47528 .65221 L p F P
0 0 0 r
s
.83 .24 .1 r
.45816 .65203 m
.46281 .65269 L
s
.762 .236 .104 r
.47881 .65535 m .47528 .65221 L .46427 .65738 L p F P
0 0 0 r
s
.24 .35 .67 r
.76089 .27481 m
.77325 .29459 L
s
.309 .092 .048 r
.60997 .39179 m .60096 .38049 L .59051 .37112 L p F P
0 0 0 r
s
.309 .092 .048 r
.58222 .36074 m .59051 .37112 L .60096 .38049 L p F P
0 0 0 r
s
.83 .24 .1 r
.58573 .3676 m
.60566 .39248 L
s
.24 .35 .67 r
.80214 .54448 m
.80231 .52455 L
s
.80231 .52455 m
.844 .51155 L
s
.66806 .60691 m
.67569 .59705 L
s
.67569 .59705 m
.71598 .58485 L
s
.58 .187 .085 r
.42731 .63496 m .43422 .64095 L .44854 .64362 L p F P
0 0 0 r
s
.58 .187 .085 r
.45383 .64825 m .44854 .64362 L .43422 .64095 L p F P
0 0 0 r
s
.024 .035 .067 r
.61463 .62582 m .60287 .62935 L .62243 .62098 L p F P
0 0 0 r
s
.024 .035 .067 r
.62243 .62098 m .63651 .61675 L .61463 .62582 L p F P
0 0 0 r
s
.453 .143 .069 r
.58222 .36074 m .57378 .3502 L .56353 .34707 L p F P
0 0 0 r
s
.83 .24 .1 r
.56616 .35701 m
.58573 .3676 L
s
.453 .143 .069 r
.55609 .33784 m .56353 .34707 L .57378 .3502 L p F P
0 0 0 r
s
.051 .063 .121 r
.36272 .39571 m .37919 .38925 L .36954 .40251 L p F P
0 0 0 r
s
.051 .063 .121 r
.36954 .40251 m .35181 .40942 L .36272 .39571 L p F P
0 0 0 r
s
.438 .139 .066 r
.39664 .6131 m .40516 .62046 L .42032 .62891 L p F P
0 0 0 r
s
.438 .139 .066 r
.42731 .63496 m .42032 .62891 L .40516 .62046 L p F P
0 0 0 r
s
.83 .24 .1 r
.41085 .62234 m
.41208 .62341 L
s
.39375 .60812 m
.41085 .62234 L
s
.27 .42 .813 r
.5123 .64942 m .50627 .65124 L .50906 .65597 L p F P
0 0 0 r
s
.27 .42 .813 r
.50906 .65597 m .5178 .65335 L .5123 .64942 L p F P
0 0 0 r
s
.83 .24 .1 r
.50069 .29996 m
.47531 .30077 L
s
.45249 .27368 m
.47531 .30077 L
s
.221 .353 .675 r
.5622 .64002 m .55323 .64271 L .56806 .63978 L p F P
0 0 0 r
s
.221 .353 .675 r
.56806 .63978 m .57959 .63633 L .5622 .64002 L p F P
0 0 0 r
s
.024 .035 .067 r
.47233 .34603 m .48583 .34071 L .48353 .34282 L p F P
0 0 0 r
s
.024 .035 .067 r
.48353 .34282 m .46786 .349 L .47233 .34603 L p F P
0 0 0 r
s
.09 .111 .237 r
.31692 .42301 m .33427 .41625 L .32607 .43282 L p F P
0 0 0 r
s
.09 .111 .237 r
.32607 .43282 m .30791 .43982 L .31692 .42301 L p F P
0 0 0 r
s
.83 .24 .1 r
.42559 .28017 m
.39841 .29157 L
s
.37408 .26427 m
.39841 .29157 L
s
.601 .189 .087 r
.54855 .32848 m .54091 .31899 L .53337 .3249 L p F P
0 0 0 r
s
.24 .35 .67 r
.52483 .32754 m
.53372 .32866 L
s
.83 .24 .1 r
.52894 .32778 m
.54537 .33133 L
s
.24 .35 .67 r
.54622 .32558 m
.57568 .31404 L
s
.83 .24 .1 r
.50964 .65403 m
.52997 .67258 L
s
.50819 .65271 m
.50964 .65403 L
s
.52997 .67258 m
.55825 .66428 L
s
.24 .35 .67 r
.72 .29047 m
.76089 .27481 L
s
.72 .29047 m
.70766 .27585 L
s
.027 .038 .072 r
.4217 .36718 m .43695 .36118 L .42961 .36946 L p F P
0 0 0 r
s
.24 .35 .67 r
.43468 .36374 m
.43759 .36259 L
s
.027 .038 .072 r
.42961 .36946 m .41264 .37612 L .4217 .36718 L p F P
0 0 0 r
s
.24 .35 .67 r
.57568 .31404 m
.61498 .29864 L
s
.57568 .31404 m
.56386 .31217 L
s
.27 .42 .813 r
.51836 .64759 m .5123 .64942 L .5178 .65335 L p F P
0 0 0 r
s
.27 .42 .813 r
.5178 .65335 m .52659 .65071 L .51836 .64759 L p F P
0 0 0 r
s
.24 .35 .67 r
.52561 .65034 m
.53844 .64648 L
s
.471 .116 .045 r
.62822 .4171 m .61874 .40523 L .60997 .39179 L p F P
0 0 0 r
s
.471 .116 .045 r
.60096 .38049 m .60997 .39179 L .61874 .40523 L p F P
0 0 0 r
s
.762 .236 .104 r
.45383 .64825 m .45907 .65283 L .47172 .64906 L p F P
0 0 0 r
s
.762 .236 .104 r
.47528 .65221 m .47172 .64906 L .45907 .65283 L p F P
0 0 0 r
s
.024 .035 .067 r
.62647 .62227 m .61463 .62582 L .63651 .61675 L p F P
0 0 0 r
s
.024 .035 .067 r
.63651 .61675 m .6507 .61249 L .62647 .62227 L p F P
0 0 0 r
s
.24 .35 .67 r
.58883 .63073 m
.62801 .61895 L
s
.62801 .61895 m
.63628 .60898 L
s
.21889 .61761 m
.23309 .64576 L
s
.23309 .64576 m
.2686 .63406 L
s
.221 .353 .675 r
.57121 .63731 m .5622 .64002 L .57959 .63633 L p F P
0 0 0 r
s
.221 .353 .675 r
.57959 .63633 m .59119 .63285 L .57121 .63731 L p F P
0 0 0 r
s
.24 .35 .67 r
.37598 .65584 m
.39381 .67037 L
s
.39381 .67037 m
.43112 .65894 L
s
.83 .24 .1 r
.26377 .37547 m
.29029 .40071 L
s
.29029 .40071 m
.27969 .42751 L
s
.65 .169 .063 r
.35036 .56717 m .33908 .55738 L .3297 .53889 L p F P
0 0 0 r
s
.507 .125 .048 r
.33908 .55738 m .35036 .56717 L .36294 .58355 L p F P
0 0 0 r
s
.507 .125 .048 r
.37301 .59224 m .36294 .58355 L .35036 .56717 L p F P
0 0 0 r
s
.24 .35 .67 r
.75718 .57238 m
.76071 .55718 L
s
.76071 .55718 m
.80214 .54448 L
s
.809 .217 .084 r
.3297 .53889 m .31745 .52817 L .31206 .50854 L p F P
0 0 0 r
s
.65 .169 .063 r
.31745 .52817 m .3297 .53889 L .33908 .55738 L p F P
0 0 0 r
s
.024 .035 .067 r
.48583 .34071 m .49943 .33534 L .49934 .33659 L p F P
0 0 0 r
s
.024 .035 .067 r
.49934 .33659 m .48353 .34282 L .48583 .34071 L p F P
0 0 0 r
s
.913 .25 .099 r
.31206 .50854 m .29916 .4971 L .29848 .47737 L p F P
0 0 0 r
s
.83 .24 .1 r
.30053 .4776 m
.30564 .45151 L
s
.809 .217 .084 r
.29916 .4971 m .31206 .50854 L .31745 .52817 L p F P
0 0 0 r
s
.83 .24 .1 r
.30053 .4776 m
.32589 .50047 L
s
1 .31 .127 r
.66306 .59152 m .65529 .58282 L .66955 .56637 L p F P
0 0 0 r
s
1 .31 .127 r
.66104 .55656 m .66955 .56637 L .65529 .58282 L p F P
0 0 0 r
s
1 .3 .122 r
.66955 .56637 m .66104 .55656 L .67043 .53801 L p F P
0 0 0 r
s
.83 .24 .1 r
.67005 .53876 m
.67036 .53753 L
s
.325 .073 .03 r
.36294 .58355 m .37301 .59224 L .38799 .60564 L p F P
0 0 0 r
s
.83 .24 .1 r
.35771 .56871 m
.36962 .58725 L
s
.325 .073 .03 r
.39664 .6131 m .38799 .60564 L .37301 .59224 L p F P
0 0 0 r
s
1 .3 .122 r
.66135 .52728 m .67043 .53801 L .66104 .55656 L p F P
0 0 0 r
s
1 .284 .114 r
.67043 .53801 m .66135 .52728 L .66612 .5076 L p F P
0 0 0 r
s
.24 .35 .67 r
.20095 .55622 m
.23614 .5435 L
s
.20095 .55622 m
.20798 .5872 L
s
.58 .187 .085 r
.42032 .62891 m .42731 .63496 L .44321 .63896 L p F P
0 0 0 r
s
.58 .187 .085 r
.44854 .64362 m .44321 .63896 L .42731 .63496 L p F P
0 0 0 r
s
.051 .063 .121 r
.37919 .38925 m .39583 .38272 L .38746 .39553 L p F P
0 0 0 r
s
.24 .35 .67 r
.39552 .3832 m
.39596 .38267 L
s
.051 .063 .121 r
.38746 .39553 m .36954 .40251 L .37919 .38925 L p F P
0 0 0 r
s
.979 .272 .109 r
.29848 .47737 m .28528 .46548 L .28995 .44675 L p F P
0 0 0 r
s
.913 .25 .099 r
.28528 .46548 m .29848 .47737 L .29916 .4971 L p F P
0 0 0 r
s
.27 .42 .813 r
.52444 .64575 m .51836 .64759 L .52659 .65071 L p F P
0 0 0 r
s
.27 .42 .813 r
.52659 .65071 m .53543 .64806 L .52444 .64575 L p F P
0 0 0 r
s
.641 .167 .062 r
.64427 .44576 m .63456 .4337 L .62822 .4171 L p F P
0 0 0 r
s
.641 .167 .062 r
.61874 .40523 m .62822 .4171 L .63456 .4337 L p F P
0 0 0 r
s
.83 .24 .1 r
.63144 .42866 m
.63247 .42994 L
s
.62787 .42165 m
.63144 .42866 L
s
.127 .167 .35 r
.28995 .44675 m .30791 .43982 L .30361 .45851 L p F P
0 0 0 r
s
.127 .167 .35 r
.30361 .45851 m .28528 .46548 L .28995 .44675 L p F P
0 0 0 r
s
1 .284 .114 r
.65664 .49614 m .66612 .5076 L .66135 .52728 L p F P
0 0 0 r
s
.939 .259 .102 r
.66612 .5076 m .65664 .49614 L .65717 .47639 L p F P
0 0 0 r
s
.83 .24 .1 r
.65557 .47663 m
.65711 .47853 L
s
1 .316 .13 r
.6507 .61249 m .64381 .60502 L .66306 .59152 L p F P
0 0 0 r
s
1 .316 .13 r
.65529 .58282 m .66306 .59152 L .64381 .60502 L p F P
0 0 0 r
s
.09 .111 .237 r
.33427 .41625 m .35181 .40942 L .34444 .42574 L p F P
0 0 0 r
s
.09 .111 .237 r
.34444 .42574 m .32607 .43282 L .33427 .41625 L p F P
0 0 0 r
s
.813 .22 .084 r
.65717 .47639 m .64748 .46448 L .64427 .44576 L p F P
0 0 0 r
s
.939 .259 .102 r
.64748 .46448 m .65717 .47639 L .65664 .49614 L p F P
0 0 0 r
s
.813 .22 .084 r
.63456 .4337 m .64427 .44576 L .64748 .46448 L p F P
0 0 0 r
s
.027 .038 .072 r
.43695 .36118 m .45233 .35511 L .44676 .36273 L p F P
0 0 0 r
s
.027 .038 .072 r
.44676 .36273 m .42961 .36946 L .43695 .36118 L p F P
0 0 0 r
s
.453 .143 .069 r
.57378 .3502 m .56522 .33949 L .55609 .33784 L p F P
0 0 0 r
s
.453 .143 .069 r
.54855 .32848 m .55609 .33784 L .56522 .33949 L p F P
0 0 0 r
s
.83 .24 .1 r
.54537 .33133 m
.56616 .35701 L
s
.24 .35 .67 r
.32138 .64722 m
.33917 .66734 L
s
.33917 .66734 m
.37598 .65584 L
s
.309 .092 .048 r
.60096 .38049 m .59179 .36898 L .58222 .36074 L p F P
0 0 0 r
s
.309 .092 .048 r
.57378 .3502 m .58222 .36074 L .59179 .36898 L p F P
0 0 0 r
s
.24 .35 .67 r
.2686 .63406 m
.28517 .65882 L
s
.28517 .65882 m
.32138 .64722 L
s
.438 .139 .066 r
.38799 .60564 m .39664 .6131 L .41325 .62278 L p F P
0 0 0 r
s
.83 .24 .1 r
.36962 .58725 m
.39375 .60812 L
s
.40745 .6194 m
.41085 .62234 L
s
.438 .139 .066 r
.42032 .62891 m .41325 .62278 L .39664 .6131 L p F P
0 0 0 r
s
.221 .353 .675 r
.58028 .63459 m .57121 .63731 L .59119 .63285 L p F P
0 0 0 r
s
.221 .353 .675 r
.59119 .63285 m .60287 .62935 L .58028 .63459 L p F P
0 0 0 r
s
.24 .35 .67 r
.66715 .29157 m
.70766 .27585 L
s
.66715 .29157 m
.65518 .28288 L
s
1 .318 .132 r
.64381 .60502 m .6507 .61249 L .62647 .62227 L p F P
0 0 0 r
s
.24 .35 .67 r
.64318 .61439 m
.64446 .61401 L
s
.62801 .61895 m
.63058 .61818 L
s
.64446 .61401 m
.66806 .60691 L
s
.83 .24 .1 r
.64248 .61581 m
.64299 .61635 L
s
.64299 .61635 m
.65421 .62837 L
s
.762 .236 .104 r
.44854 .64362 m .45383 .64825 L .46815 .64589 L p F P
0 0 0 r
s
.762 .236 .104 r
.47172 .64906 m .46815 .64589 L .45383 .64825 L p F P
0 0 0 r
s
.27 .42 .813 r
.53054 .64391 m .52444 .64575 L .53543 .64806 L p F P
0 0 0 r
s
.27 .42 .813 r
.53543 .64806 m .5443 .64539 L .53054 .64391 L p F P
0 0 0 r
s
.24 .35 .67 r
.20798 .5872 m
.21889 .61761 L
s
.21889 .61761 m
.2544 .60554 L
s
.20798 .5872 m
.24337 .57479 L
s
.024 .035 .067 r
.49943 .33534 m .51315 .32993 L .5153 .3303 L p F P
0 0 0 r
s
.024 .035 .067 r
.5153 .3303 m .49934 .33659 L .49943 .33534 L p F P
0 0 0 r
s
.24 .35 .67 r
.48666 .34257 m
.52483 .32754 L
s
.23306 .5134 m
.26875 .50014 L
s
.23306 .5134 m
.23614 .5435 L
s
.289 .443 .863 r
.49396 .64528 m .49088 .64622 L .48233 .65847 L p F P
0 0 0 r
s
.83 .24 .1 r
.48321 .65747 m
.48382 .65802 L
s
.289 .443 .863 r
.48233 .65847 m .48828 .65667 L .49396 .64528 L p F P
0 0 0 r
s
.24 .35 .67 r
.48847 .65629 m
.48919 .65639 L
s
.886 .269 .117 r
.47881 .65535 m .48233 .65847 L .49088 .64622 L p F P
0 0 0 r
s
.83 .24 .1 r
.47828 .65488 m
.47925 .65502 L
s
.24 .35 .67 r
.26953 .47265 m
.28573 .4665 L
s
.26953 .47265 m
.26875 .50014 L
s
.83 .24 .1 r
.45249 .27368 m
.42559 .28017 L
s
.40159 .25242 m
.42559 .28017 L
s
.53826 .64542 m
.55825 .66428 L
s
.55825 .66428 m
.58613 .65022 L
s
.051 .063 .121 r
.39583 .38272 m .41264 .37612 L .40558 .38847 L p F P
0 0 0 r
s
.051 .063 .121 r
.40558 .38847 m .38746 .39553 L .39583 .38272 L p F P
0 0 0 r
s
.24 .35 .67 r
.844 .51155 m
.84451 .53149 L
s
.27 .42 .813 r
.53666 .64206 m .53054 .64391 L .5443 .64539 L p F P
0 0 0 r
s
.27 .42 .813 r
.5443 .64539 m .55323 .64271 L .53666 .64206 L p F P
0 0 0 r
s
.83 .24 .1 r
.53684 .64408 m
.53826 .64542 L
s
.221 .353 .675 r
.58939 .63186 m .58028 .63459 L .60287 .62935 L p F P
0 0 0 r
s
.24 .35 .67 r
.57735 .6348 m
.58883 .63073 L
s
.221 .353 .675 r
.60287 .62935 m .61463 .62582 L .58939 .63186 L p F P
0 0 0 r
s
.24 .35 .67 r
.70903 .5946 m
.71598 .58485 L
s
.71598 .58485 m
.75718 .57238 L
s
.58 .187 .085 r
.41325 .62278 m .42032 .62891 L .43783 .63425 L p F P
0 0 0 r
s
.58 .187 .085 r
.44321 .63896 m .43783 .63425 L .42032 .62891 L p F P
0 0 0 r
s
.289 .443 .863 r
.49704 .64434 m .49396 .64528 L .48828 .65667 L p F P
0 0 0 r
s
.289 .443 .863 r
.48828 .65667 m .49425 .65487 L .49704 .64434 L p F P
0 0 0 r
s
.127 .167 .35 r
.30791 .43982 m .32607 .43282 L .32216 .45146 L p F P
0 0 0 r
s
.127 .167 .35 r
.32216 .45146 m .30361 .45851 L .30791 .43982 L p F P
0 0 0 r
s
.24 .35 .67 r
.30565 .45894 m
.30589 .45764 L
s
.027 .038 .072 r
.45233 .35511 m .46786 .349 L .46408 .35594 L p F P
0 0 0 r
s
.027 .038 .072 r
.46408 .35594 m .44676 .36273 L .45233 .35511 L p F P
0 0 0 r
s
.09 .111 .237 r
.35181 .40942 m .36954 .40251 L .36301 .41858 L p F P
0 0 0 r
s
.09 .111 .237 r
.36301 .41858 m .34444 .42574 L .35181 .40942 L p F P
0 0 0 r
s
.471 .116 .045 r
.61874 .40523 m .60909 .39314 L .60096 .38049 L p F P
0 0 0 r
s
.471 .116 .045 r
.59179 .36898 m .60096 .38049 L .60909 .39314 L p F P
0 0 0 r
s
.762 .236 .104 r
.44321 .63896 m .44854 .64362 L .46455 .64269 L p F P
0 0 0 r
s
.762 .236 .104 r
.46815 .64589 m .46455 .64269 L .44854 .64362 L p F P
0 0 0 r
s
.886 .269 .117 r
.47528 .65221 m .47881 .65535 L .48909 .6446 L p F P
0 0 0 r
s
.83 .24 .1 r
.47974 .65438 m
.4799 .65453 L
s
.886 .269 .117 r
.49088 .64622 m .48909 .6446 L .47881 .65535 L p F P
0 0 0 r
s
.83 .24 .1 r
.49071 .6543 m
.49361 .65404 L
s
.34721 .28052 m
.32191 .30052 L
s
.29578 .27308 m
.32191 .30052 L
s
.32191 .30052 m
.29906 .32355 L
s
.024 .035 .067 r
.51315 .32993 m .52697 .32448 L .53141 .32396 L p F P
0 0 0 r
s
.83 .24 .1 r
.52145 .32518 m
.52237 .32629 L
s
.024 .035 .067 r
.53141 .32396 m .5153 .3303 L .51315 .32993 L p F P
0 0 0 r
s
.83 .24 .1 r
.50069 .29996 m
.52145 .32518 L
s
.24 .35 .67 r
.52483 .32754 m
.53961 .32172 L
s
.289 .443 .863 r
.50013 .6434 m .49704 .64434 L .49425 .65487 L p F P
0 0 0 r
s
.289 .443 .863 r
.49425 .65487 m .50025 .65306 L .50013 .6434 L p F P
0 0 0 r
s
.65 .169 .063 r
.33908 .55738 m .3276 .54742 L .31745 .52817 L p F P
0 0 0 r
s
.83 .24 .1 r
.32655 .52494 m
.33277 .54698 L
s
.507 .125 .048 r
.3276 .54742 m .33908 .55738 L .35271 .57472 L p F P
0 0 0 r
s
.507 .125 .048 r
.36294 .58355 m .35271 .57472 L .33908 .55738 L p F P
0 0 0 r
s
.83 .24 .1 r
.33277 .54698 m
.35771 .56871 L
s
.325 .073 .03 r
.35271 .57472 m .36294 .58355 L .37923 .59808 L p F P
0 0 0 r
s
.325 .073 .03 r
.38799 .60564 m .37923 .59808 L .36294 .58355 L p F P
0 0 0 r
s
.83 .24 .1 r
.52376 .30464 m
.50069 .29996 L
s
.47808 .2725 m
.50069 .29996 L
s
.27 .42 .813 r
.54281 .64021 m .53666 .64206 L .55323 .64271 L p F P
0 0 0 r
s
.27 .42 .813 r
.55323 .64271 m .5622 .64002 L .54281 .64021 L p F P
0 0 0 r
s
.24 .35 .67 r
.55988 .64004 m
.57735 .6348 L
s
.74909 .25977 m
.76089 .27481 L
s
.83 .24 .1 r
.25271 .40257 m
.27969 .42751 L
s
.27969 .42751 m
.27419 .45384 L
s
.27246 .29655 m
.29906 .32355 L
s
.29906 .32355 m
.27944 .34882 L
s
.809 .217 .084 r
.31745 .52817 m .30498 .51726 L .29916 .4971 L p F P
0 0 0 r
s
.65 .169 .063 r
.30498 .51726 m .31745 .52817 L .3276 .54742 L p F P
0 0 0 r
s
1 .316 .13 r
.64381 .60502 m .63682 .59745 L .65529 .58282 L p F P
0 0 0 r
s
1 .316 .13 r
.64738 .57399 m .65529 .58282 L .63682 .59745 L p F P
0 0 0 r
s
1 .31 .127 r
.65529 .58282 m .64738 .57399 L .66104 .55656 L p F P
0 0 0 r
s
1 .31 .127 r
.65238 .54659 m .66104 .55656 L .64738 .57399 L p F P
0 0 0 r
s
1 .3 .122 r
.66104 .55656 m .65238 .54659 L .66135 .52728 L p F P
0 0 0 r
s
.453 .143 .069 r
.56522 .33949 m .55652 .32861 L .54855 .32848 L p F P
0 0 0 r
s
.83 .24 .1 r
.54537 .33133 m
.56502 .34175 L
s
.453 .143 .069 r
.54091 .31899 m .54855 .32848 L .55652 .32861 L p F P
0 0 0 r
s
.83 .24 .1 r
.53723 .32127 m
.54537 .33133 L
s
.221 .353 .675 r
.59854 .62911 m .58939 .63186 L .61463 .62582 L p F P
0 0 0 r
s
.83 .24 .1 r
.61215 .63104 m
.63188 .65126 L
s
.221 .353 .675 r
.61463 .62582 m .62647 .62227 L .59854 .62911 L p F P
0 0 0 r
s
.24 .35 .67 r
.61498 .29864 m
.65518 .28288 L
s
.61498 .29864 m
.60378 .29645 L
s
.438 .139 .066 r
.37923 .59808 m .38799 .60564 L .4061 .61659 L p F P
0 0 0 r
s
.83 .24 .1 r
.39978 .61277 m
.40447 .61682 L
s
.438 .139 .066 r
.41325 .62278 m .4061 .61659 L .38799 .60564 L p F P
0 0 0 r
s
1 .3 .122 r
.6521 .51634 m .66135 .52728 L .65238 .54659 L p F P
0 0 0 r
s
1 .284 .114 r
.66135 .52728 m .6521 .51634 L .65664 .49614 L p F P
0 0 0 r
s
.913 .25 .099 r
.29916 .4971 m .28601 .48545 L .28528 .46548 L p F P
0 0 0 r
s
.809 .217 .084 r
.28601 .48545 m .29916 .4971 L .30498 .51726 L p F P
0 0 0 r
s
.83 .24 .1 r
.30087 .50225 m
.32655 .52494 L
s
.289 .443 .863 r
.50322 .64246 m .50013 .6434 L .50025 .65306 L p F P
0 0 0 r
s
.289 .443 .863 r
.50025 .65306 m .50627 .65124 L .50322 .64246 L p F P
0 0 0 r
s
.83 .24 .1 r
.49361 .65404 m
.50819 .65271 L
s
1 .318 .132 r
.62647 .62227 m .62055 .61607 L .64381 .60502 L p F P
0 0 0 r
s
1 .318 .132 r
.63682 .59745 m .64381 .60502 L .62055 .61607 L p F P
0 0 0 r
s
.641 .167 .062 r
.63456 .4337 m .62467 .4214 L .61874 .40523 L p F P
0 0 0 r
s
.641 .167 .062 r
.60909 .39314 m .61874 .40523 L .62467 .4214 L p F P
0 0 0 r
s
.83 .24 .1 r
.60112 .38334 m
.60939 .3937 L
s
.309 .092 .048 r
.59179 .36898 m .58245 .35728 L .57378 .3502 L p F P
0 0 0 r
s
.83 .24 .1 r
.58573 .3676 m
.60112 .38334 L
s
.309 .092 .048 r
.56522 .33949 m .57378 .3502 L .58245 .35728 L p F P
0 0 0 r
s
.24 .35 .67 r
.2544 .60554 m
.2686 .63406 L
s
.2686 .63406 m
.30491 .62209 L
s
.83 .24 .1 r
.37408 .26427 m
.34721 .28052 L
s
.32151 .25262 m
.34721 .28052 L
s
.24 .35 .67 r
.41363 .64408 m
.43112 .65894 L
s
.158 .215 .442 r
.28528 .46548 m .30361 .45851 L .30429 .47861 L p F P
0 0 0 r
s
.83 .24 .1 r
.29304 .47084 m
.30053 .4776 L
s
.24 .35 .67 r
.28621 .46632 m
.28639 .46625 L
s
.30365 .45969 m
.30565 .45894 L
s
.83 .24 .1 r
.27419 .45384 m
.28656 .46499 L
s
.158 .215 .442 r
.30429 .47861 m .28601 .48545 L .28528 .46548 L p F P
0 0 0 r
s
.83 .24 .1 r
.30057 .48 m
.30087 .50225 L
s
1 .284 .114 r
.64697 .48447 m .65664 .49614 L .6521 .51634 L p F P
0 0 0 r
s
.83 .24 .1 r
.6548 .49393 m
.65496 .49035 L
s
.939 .259 .102 r
.65664 .49614 m .64697 .48447 L .64748 .46448 L p F P
0 0 0 r
s
.24 .35 .67 r
.79932 .55963 m
.80214 .54448 L
s
.80214 .54448 m
.84451 .53149 L
s
.051 .063 .121 r
.41264 .37612 m .42961 .36946 L .42389 .38134 L p F P
0 0 0 r
s
.051 .063 .121 r
.42389 .38134 m .40558 .38847 L .41264 .37612 L p F P
0 0 0 r
s
.886 .269 .117 r
.47172 .64906 m .47528 .65221 L .48729 .64297 L p F P
0 0 0 r
s
.83 .24 .1 r
.47636 .65138 m
.47652 .65153 L
s
.886 .269 .117 r
.48909 .6446 m .48729 .64297 L .47528 .65221 L p F P
0 0 0 r
s
.24 .35 .67 r
.47796 .65185 m
.47968 .65276 L
s
.83 .24 .1 r
.58613 .65022 m
.61215 .63104 L
s
.27 .42 .813 r
.54898 .63835 m .54281 .64021 L .5622 .64002 L p F P
0 0 0 r
s
.27 .42 .813 r
.5622 .64002 m .57121 .63731 L .54898 .63835 L p F P
0 0 0 r
s
.027 .038 .072 r
.46786 .349 m .48353 .34282 L .48158 .34907 L p F P
0 0 0 r
s
.24 .35 .67 r
.4831 .34419 m
.48666 .34257 L
s
.027 .038 .072 r
.48158 .34907 m .46408 .35594 L .46786 .349 L p F P
0 0 0 r
s
.813 .22 .084 r
.64748 .46448 m .63759 .45234 L .63456 .4337 L p F P
0 0 0 r
s
.939 .259 .102 r
.63759 .45234 m .64748 .46448 L .64697 .48447 L p F P
0 0 0 r
s
.813 .22 .084 r
.62467 .4214 m .63456 .4337 L .63759 .45234 L p F P
0 0 0 r
s
.83 .24 .1 r
.63472 .44548 m
.63616 .45283 L
s
.24 .35 .67 r
.23614 .5435 m
.27213 .53049 L
s
.23614 .5435 m
.24337 .57479 L
s
.289 .443 .863 r
.50632 .64152 m .50322 .64246 L .50627 .65124 L p F P
0 0 0 r
s
.289 .443 .863 r
.50627 .65124 m .5123 .64942 L .50632 .64152 L p F P
0 0 0 r
s
.453 .143 .069 r
.55652 .32861 m .54767 .31755 L .54091 .31899 L p F P
0 0 0 r
s
.024 .035 .067 r
.52697 .32448 m .54091 .31899 L .54767 .31755 L p F P
0 0 0 r
s
.24 .35 .67 r
.54828 .3183 m
.56386 .31217 L
s
.83 .24 .1 r
.53654 .32042 m
.53671 .32064 L
s
.024 .035 .067 r
.54767 .31755 m .53141 .32396 L .52697 .32448 L p F P
0 0 0 r
s
.83 .24 .1 r
.52376 .30464 m
.53654 .32042 L
s
.762 .236 .104 r
.43783 .63425 m .44321 .63896 L .46093 .63948 L p F P
0 0 0 r
s
.762 .236 .104 r
.46455 .64269 m .46093 .63948 L .44321 .63896 L p F P
0 0 0 r
s
.127 .167 .35 r
.32607 .43282 m .34444 .42574 L .34092 .44432 L p F P
0 0 0 r
s
.127 .167 .35 r
.34092 .44432 m .32216 .45146 L .32607 .43282 L p F P
0 0 0 r
s
.58 .187 .085 r
.4061 .61659 m .41325 .62278 L .4324 .6295 L p F P
0 0 0 r
s
.58 .187 .085 r
.43783 .63425 m .4324 .6295 L .41325 .62278 L p F P
0 0 0 r
s
.83 .24 .1 r
.25235 .32222 m
.27944 .34882 L
s
.27944 .34882 m
.26377 .37547 L
s
.09 .111 .237 r
.36954 .40251 m .38746 .39553 L .3818 .41134 L p F P
0 0 0 r
s
.09 .111 .237 r
.3818 .41134 m .36301 .41858 L .36954 .40251 L p F P
0 0 0 r
s
1 .319 .133 r
.62055 .61607 m .62647 .62227 L .59854 .62911 L p F P
0 0 0 r
s
.24 .35 .67 r
.61981 .62189 m
.62029 .62171 L
s
.83 .24 .1 r
.61215 .63104 m
.61867 .62436 L
s
.6081 .62688 m
.61215 .63104 L
s
.289 .443 .863 r
.50942 .64057 m .50632 .64152 L .5123 .64942 L p F P
0 0 0 r
s
.289 .443 .863 r
.5123 .64942 m .51836 .64759 L .50942 .64057 L p F P
0 0 0 r
s
.24 .35 .67 r
.65783 .61062 m
.66806 .60691 L
s
.66806 .60691 m
.70903 .5946 L
s
.35841 .63537 m
.37598 .65584 L
s
.37598 .65584 m
.41363 .64408 L
s
.27 .42 .813 r
.55516 .63648 m .54898 .63835 L .57121 .63731 L p F P
0 0 0 r
s
.27 .42 .813 r
.57121 .63731 m .58028 .63459 L .55516 .63648 L p F P
0 0 0 r
s
.24 .35 .67 r
.30491 .62209 m
.32138 .64722 L
s
.32138 .64722 m
.35841 .63537 L
s
.886 .269 .117 r
.46815 .64589 m .47172 .64906 L .48548 .64133 L p F P
0 0 0 r
s
.83 .24 .1 r
.47296 .64836 m
.47313 .64851 L
s
.24 .35 .67 r
.43112 .65894 m
.46928 .64725 L
s
.886 .269 .117 r
.48729 .64297 m .48548 .64133 L .47172 .64906 L p F P
0 0 0 r
s
.24 .35 .67 r
.46928 .64725 m
.47796 .65185 L
s
.70766 .27585 m
.74909 .25977 L
s
.70766 .27585 m
.69629 .26677 L
s
.24337 .57479 m
.2544 .60554 L
s
.2544 .60554 m
.29071 .59319 L
s
.24337 .57479 m
.27957 .56209 L
s
.289 .443 .863 r
.51253 .63962 m .50942 .64057 L .51836 .64759 L p F P
0 0 0 r
s
.289 .443 .863 r
.51836 .64759 m .52444 .64575 L .51253 .63962 L p F P
0 0 0 r
s
.24 .35 .67 r
.5225 .64476 m
.52419 .64425 L
s
.52419 .64425 m
.52764 .64479 L
s
.83 .24 .1 r
.47808 .2725 m
.45249 .27368 L
s
.42877 .2455 m
.45249 .27368 L
s
.24 .35 .67 r
.26875 .50014 m
.27213 .53049 L
s
.051 .063 .121 r
.42961 .36946 m .44676 .36273 L .44241 .37413 L p F P
0 0 0 r
s
.051 .063 .121 r
.44241 .37413 m .42389 .38134 L .42961 .36946 L p F P
0 0 0 r
s
.027 .038 .072 r
.48353 .34282 m .49934 .33659 L .49926 .34213 L p F P
0 0 0 r
s
.027 .038 .072 r
.49926 .34213 m .48158 .34907 L .48353 .34282 L p F P
0 0 0 r
s
.83 .24 .1 r
.40159 .25242 m
.37408 .26427 L
s
.34877 .23589 m
.37408 .26427 L
s
.471 .116 .045 r
.60909 .39314 m .59924 .38082 L .59179 .36898 L p F P
0 0 0 r
s
.471 .116 .045 r
.58245 .35728 m .59179 .36898 L .59924 .38082 L p F P
0 0 0 r
s
.83 .24 .1 r
.56502 .34175 m
.58573 .3676 L
s
.507 .125 .048 r
.35271 .57472 m .34232 .56575 L .3276 .54742 L p F P
0 0 0 r
s
.325 .073 .03 r
.34232 .56575 m .35271 .57472 L .37034 .59041 L p F P
0 0 0 r
s
.325 .073 .03 r
.37923 .59808 m .37034 .59041 L .35271 .57472 L p F P
0 0 0 r
s
.83 .24 .1 r
.34454 .56557 m
.36962 .58725 L
s
.27 .42 .813 r
.56137 .6346 m .55516 .63648 L .58028 .63459 L p F P
0 0 0 r
s
.83 .24 .1 r
.57182 .63616 m
.58613 .65022 L
s
.27 .42 .813 r
.58028 .63459 m .58939 .63186 L .56137 .6346 L p F P
0 0 0 r
s
.24 .35 .67 r
.58603 .63219 m
.60087 .62773 L
s
.158 .215 .442 r
.30361 .45851 m .32216 .45146 L .32277 .4717 L p F P
0 0 0 r
s
.158 .215 .442 r
.32277 .4717 m .30429 .47861 L .30361 .45851 L p F P
0 0 0 r
s
.438 .139 .066 r
.37034 .59041 m .37923 .59808 L .39887 .61032 L p F P
0 0 0 r
s
.83 .24 .1 r
.39202 .60605 m
.39676 .61016 L
s
.438 .139 .066 r
.4061 .61659 m .39887 .61032 L .37923 .59808 L p F P
0 0 0 r
s
.83 .24 .1 r
.3867 .60145 m
.38896 .60341 L
s
.36962 .58725 m
.3867 .60145 L
s
.762 .236 .104 r
.4324 .6295 m .43783 .63425 L .45728 .63625 L p F P
0 0 0 r
s
.762 .236 .104 r
.46093 .63948 m .45728 .63625 L .43783 .63425 L p F P
0 0 0 r
s
.886 .269 .117 r
.46455 .64269 m .46815 .64589 L .48367 .63969 L p F P
0 0 0 r
s
.83 .24 .1 r
.46955 .64533 m
.46971 .64547 L
s
.886 .269 .117 r
.48548 .64133 m .48367 .63969 L .46815 .64589 L p F P
0 0 0 r
s
1 .316 .13 r
.63682 .59745 m .62974 .58977 L .64738 .57399 L p F P
0 0 0 r
s
1 .316 .13 r
.63936 .565 m .64738 .57399 L .62974 .58977 L p F P
0 0 0 r
s
1 .31 .127 r
.64738 .57399 m .63936 .565 L .65238 .54659 L p F P
0 0 0 r
s
.289 .443 .863 r
.51565 .63867 m .51253 .63962 L .52444 .64575 L p F P
0 0 0 r
s
.289 .443 .863 r
.52444 .64575 m .53054 .64391 L .51565 .63867 L p F P
0 0 0 r
s
.83 .24 .1 r
.50819 .65271 m
.53684 .64408 L
s
.65 .169 .063 r
.3276 .54742 m .31591 .53729 L .30498 .51726 L p F P
0 0 0 r
s
.507 .125 .048 r
.31591 .53729 m .3276 .54742 L .34232 .56575 L p F P
0 0 0 r
s
.83 .24 .1 r
.33277 .54698 m
.34454 .56557 L
s
.24 .35 .67 r
.56386 .31217 m
.60378 .29645 L
s
.56386 .31217 m
.55391 .31682 L
s
1 .318 .132 r
.62055 .61607 m .61456 .60979 L .63682 .59745 L p F P
0 0 0 r
s
1 .318 .132 r
.62974 .58977 m .63682 .59745 L .61456 .60979 L p F P
0 0 0 r
s
.24 .35 .67 r
.75093 .582 m
.75718 .57238 L
s
.75718 .57238 m
.79932 .55963 L
s
1 .31 .127 r
.64357 .53644 m .65238 .54659 L .63936 .565 L p F P
0 0 0 r
s
1 .3 .122 r
.65238 .54659 m .64357 .53644 L .6521 .51634 L p F P
0 0 0 r
s
.127 .167 .35 r
.34444 .42574 m .36301 .41858 L .3599 .43711 L p F P
0 0 0 r
s
.127 .167 .35 r
.3599 .43711 m .34092 .44432 L .34444 .42574 L p F P
0 0 0 r
s
.24 .35 .67 r
.34258 .44491 m
.3428 .44361 L
s
.09 .111 .237 r
.38746 .39553 m .40558 .38847 L .4008 .40402 L p F P
0 0 0 r
s
.09 .111 .237 r
.4008 .40402 m .3818 .41134 L .38746 .39553 L p F P
0 0 0 r
s
.58 .187 .085 r
.39887 .61032 m .4061 .61659 L .42692 .62471 L p F P
0 0 0 r
s
.58 .187 .085 r
.4324 .6295 m .42692 .62471 L .4061 .61659 L p F P
0 0 0 r
s
.809 .217 .084 r
.30498 .51726 m .29227 .50613 L .28601 .48545 L p F P
0 0 0 r
s
.65 .169 .063 r
.29227 .50613 m .30498 .51726 L .31591 .53729 L p F P
0 0 0 r
s
.309 .092 .048 r
.58245 .35728 m .57295 .34536 L .56522 .33949 L p F P
0 0 0 r
s
.309 .092 .048 r
.55652 .32861 m .56522 .33949 L .57295 .34536 L p F P
0 0 0 r
s
1 .319 .133 r
.59854 .62911 m .59381 .62431 L .62055 .61607 L p F P
0 0 0 r
s
1 .319 .133 r
.61456 .60979 m .62055 .61607 L .59381 .62431 L p F P
0 0 0 r
s
.24 .35 .67 r
.60907 .62527 m
.61713 .62284 L
s
.61713 .62284 m
.61981 .62189 L
s
.289 .443 .863 r
.51877 .63772 m .51565 .63867 L .53054 .64391 L p F P
0 0 0 r
s
.289 .443 .863 r
.53054 .64391 m .53666 .64206 L .51877 .63772 L p F P
0 0 0 r
s
.27 .42 .813 r
.56761 .63272 m .56137 .6346 L .58939 .63186 L p F P
0 0 0 r
s
.83 .24 .1 r
.56886 .63326 m
.57182 .63616 L
s
.27 .42 .813 r
.58939 .63186 m .59854 .62911 L .56761 .63272 L p F P
0 0 0 r
s
.83 .24 .1 r
.2362 .34922 m
.26377 .37547 L
s
.26377 .37547 m
.25271 .40257 L
s
1 .3 .122 r
.64267 .5052 m .6521 .51634 L .64357 .53644 L p F P
0 0 0 r
s
.83 .24 .1 r
.65124 .51533 m
.65167 .51369 L
s
1 .284 .114 r
.6521 .51634 m .64267 .5052 L .64697 .48447 L p F P
0 0 0 r
s
.181 .252 .513 r
.28601 .48545 m .30429 .47861 L .31004 .49961 L p F P
0 0 0 r
s
.24 .35 .67 r
.30531 .48235 m
.30537 .47821 L
s
.181 .252 .513 r
.31004 .49961 m .29227 .50613 L .28601 .48545 L p F P
0 0 0 r
s
.24 .35 .67 r
.26875 .50014 m
.2877 .49311 L
s
.2877 .49311 m
.28827 .4929 L
s
.83 .24 .1 r
.28824 .49108 m
.28899 .49175 L
s
.27418 .47866 m
.28824 .49108 L
s
.641 .167 .062 r
.62467 .4214 m .61459 .40886 L .60909 .39314 L p F P
0 0 0 r
s
.641 .167 .062 r
.59924 .38082 m .60909 .39314 L .61459 .40886 L p F P
0 0 0 r
s
.83 .24 .1 r
.61143 .40376 m
.61256 .40516 L
s
.6071 .39517 m
.61143 .40376 L
s
.886 .269 .117 r
.46093 .63948 m .46455 .64269 L .48185 .63805 L p F P
0 0 0 r
s
.83 .24 .1 r
.46611 .64227 m
.46628 .64242 L
s
.886 .269 .117 r
.48367 .63969 m .48185 .63805 L .46455 .64269 L p F P
0 0 0 r
s
.83 .24 .1 r
.24679 .42913 m
.27419 .45384 L
s
.27419 .45384 m
.27418 .47866 L
s
1 .284 .114 r
.63711 .47256 m .64697 .48447 L .64267 .5052 L p F P
0 0 0 r
s
.939 .259 .102 r
.64697 .48447 m .63711 .47256 L .63759 .45234 L p F P
0 0 0 r
s
.83 .24 .1 r
.63616 .45283 m
.63754 .45452 L
s
.289 .443 .863 r
.52189 .63677 m .51877 .63772 L .53666 .64206 L p F P
0 0 0 r
s
.289 .443 .863 r
.53666 .64206 m .54281 .64021 L .52189 .63677 L p F P
0 0 0 r
s
.027 .038 .072 r
.49934 .33659 m .5153 .3303 L .51713 .33512 L p F P
0 0 0 r
s
.24 .35 .67 r
.51583 .3317 m
.52483 .32754 L
s
.027 .038 .072 r
.51713 .33512 m .49926 .34213 L .49934 .33659 L p F P
0 0 0 r
s
.24 .35 .67 r
.65518 .28288 m
.69629 .26677 L
s
.65518 .28288 m
.64462 .28037 L
s
.051 .063 .121 r
.44676 .36273 m .46408 .35594 L .46113 .36683 L p F P
0 0 0 r
s
.051 .063 .121 r
.46113 .36683 m .44241 .37413 L .44676 .36273 L p F P
0 0 0 r
s
.24 .35 .67 r
.61713 .62284 m
.65783 .61062 L
s
.762 .236 .104 r
.42692 .62471 m .4324 .6295 L .45362 .63299 L p F P
0 0 0 r
s
.762 .236 .104 r
.45728 .63625 m .45362 .63299 L .4324 .6295 L p F P
0 0 0 r
s
.83 .24 .1 r
.45532 .6345 m
.45773 .63482 L
s
.813 .22 .084 r
.63759 .45234 m .6275 .43995 L .62467 .4214 L p F P
0 0 0 r
s
.813 .22 .084 r
.61459 .40886 m .62467 .4214 L .6275 .43995 L p F P
0 0 0 r
s
.939 .259 .102 r
.6275 .43995 m .63759 .45234 L .63711 .47256 L p F P
0 0 0 r
s
1 .316 .133 r
.59381 .62431 m .59854 .62911 L .56761 .63272 L p F P
0 0 0 r
s
.24 .35 .67 r
.29071 .59319 m
.30491 .62209 L
s
.30491 .62209 m
.34206 .60985 L
s
.46928 .64725 m
.48484 .64249 L
s
.84451 .53149 m
.84243 .54658 L
s
.158 .215 .442 r
.32216 .45146 m .34092 .44432 L .34147 .46471 L p F P
0 0 0 r
s
.24 .35 .67 r
.3222 .45265 m
.32329 .45223 L
s
.34095 .44553 m
.34258 .44491 L
s
.158 .215 .442 r
.34147 .46471 m .32277 .4717 L .32216 .45146 L p F P
0 0 0 r
s
.289 .443 .863 r
.52503 .63582 m .52189 .63677 L .54281 .64021 L p F P
0 0 0 r
s
.289 .443 .863 r
.54281 .64021 m .54898 .63835 L .52503 .63582 L p F P
0 0 0 r
s
.83 .24 .1 r
.54348 .31487 m
.52376 .30464 L
s
.50129 .27689 m
.52376 .30464 L
s
.24 .35 .67 r
.27213 .53049 m
.27957 .56209 L
s
.886 .269 .117 r
.45728 .63625 m .46093 .63948 L .48002 .6364 L p F P
0 0 0 r
s
.83 .24 .1 r
.45773 .63482 m
.45934 .63626 L
s
.46265 .6392 m
.46282 .63935 L
s
.886 .269 .117 r
.48185 .63805 m .48002 .6364 L .46093 .63948 L p F P
0 0 0 r
s
.09 .111 .237 r
.40558 .38847 m .42389 .38134 L .42002 .39661 L p F P
0 0 0 r
s
.09 .111 .237 r
.42002 .39661 m .4008 .40402 L .40558 .38847 L p F P
0 0 0 r
s
.127 .167 .35 r
.36301 .41858 m .3818 .41134 L .37909 .42981 L p F P
0 0 0 r
s
.127 .167 .35 r
.37909 .42981 m .3599 .43711 L .36301 .41858 L p F P
0 0 0 r
s
.325 .073 .03 r
.37034 .59041 m .36132 .58263 L .34232 .56575 L p F P
0 0 0 r
s
.438 .139 .066 r
.36132 .58263 m .37034 .59041 L .39155 .60398 L p F P
0 0 0 r
s
.83 .24 .1 r
.38415 .59925 m
.3867 .60145 L
s
.3867 .60145 m
.38926 .60251 L
s
.438 .139 .066 r
.39887 .61032 m .39155 .60398 L .37034 .59041 L p F P
0 0 0 r
s
.291 .44 .861 r
.49088 .64622 m .49396 .64528 L .5 .62969 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.50133 .64645 m
.50819 .65271 L
s
.968 .29 .124 r
.5 .62969 m .48909 .6446 L .49088 .64622 L closepath p F P
0 0 0 r
s
.58 .187 .085 r
.39155 .60398 m .39887 .61032 L .42139 .61987 L p F P
0 0 0 r
s
.58 .187 .085 r
.42692 .62471 m .42139 .61987 L .39887 .61032 L p F P
0 0 0 r
s
1 .318 .132 r
.61456 .60979 m .60851 .60345 L .62974 .58977 L p F P
0 0 0 r
s
1 .318 .132 r
.62255 .58198 m .62974 .58977 L .60851 .60345 L p F P
0 0 0 r
s
1 .316 .13 r
.62974 .58977 m .62255 .58198 L .63936 .565 L p F P
0 0 0 r
s
.289 .443 .863 r
.52816 .63486 m .52503 .63582 L .54898 .63835 L p F P
0 0 0 r
s
.289 .443 .863 r
.54898 .63835 m .55516 .63648 L .52816 .63486 L p F P
0 0 0 r
s
.507 .125 .048 r
.34232 .56575 m .33176 .55664 L .31591 .53729 L p F P
0 0 0 r
s
.325 .073 .03 r
.33176 .55664 m .34232 .56575 L .36132 .58263 L p F P
0 0 0 r
s
1 .319 .133 r
.59381 .62431 m .58904 .61947 L .61456 .60979 L p F P
0 0 0 r
s
.24 .35 .67 r
.604 .62012 m
.61713 .62284 L
s
1 .319 .133 r
.60851 .60345 m .61456 .60979 L .58904 .61947 L p F P
0 0 0 r
s
.83 .24 .1 r
.42877 .2455 m
.40159 .25242 L
s
.37663 .22356 m
.40159 .25242 L
s
.291 .44 .861 r
.49396 .64528 m .49704 .64434 L .5 .62969 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.49922 .64452 m
.50133 .64645 L
s
.24 .35 .67 r
.69946 .59811 m
.70903 .5946 L
s
.70903 .5946 m
.75093 .582 L
s
1 .316 .13 r
.6312 .55588 m .63936 .565 L .62255 .58198 L p F P
0 0 0 r
s
1 .31 .127 r
.63936 .565 m .6312 .55588 L .64357 .53644 L p F P
0 0 0 r
s
.24 .35 .67 r
.3963 .62323 m
.41363 .64408 L
s
.471 .116 .045 r
.59924 .38082 m .58921 .36827 L .58245 .35728 L p F P
0 0 0 r
s
.471 .116 .045 r
.57295 .34536 m .58245 .35728 L .58921 .36827 L p F P
0 0 0 r
s
.968 .29 .124 r
.5 .62969 m .48729 .64297 L .48909 .6446 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.34206 .60985 m
.35841 .63537 L
s
.35841 .63537 m
.3963 .62323 L
s
.027 .038 .072 r
.5153 .3303 m .53141 .32396 L .53518 .32804 L p F P
0 0 0 r
s
.027 .038 .072 r
.53518 .32804 m .51713 .33512 L .5153 .3303 L p F P
0 0 0 r
s
.24 .35 .67 r
.73836 .25029 m
.74909 .25977 L
s
.181 .252 .513 r
.30429 .47861 m .32277 .4717 L .32801 .49302 L p F P
0 0 0 r
s
.181 .252 .513 r
.32801 .49302 m .31004 .49961 L .30429 .47861 L p F P
0 0 0 r
s
.291 .44 .861 r
.49704 .64434 m .50013 .6434 L .5 .62969 L closepath p F P
0 0 0 r
s
.762 .236 .104 r
.42139 .61987 m .42692 .62471 L .44993 .62972 L p F P
0 0 0 r
s
.762 .236 .104 r
.45362 .63299 m .44993 .62972 L .42692 .62471 L p F P
0 0 0 r
s
.289 .443 .863 r
.53131 .6339 m .52816 .63486 L .55516 .63648 L p F P
0 0 0 r
s
.289 .443 .863 r
.55516 .63648 m .56137 .6346 L .53131 .6339 L p F P
0 0 0 r
s
.83 .24 .1 r
.52802 .63575 m
.53684 .64408 L
s
.53684 .64408 m
.55173 .63648 L
s
.55173 .63648 m
.55473 .63495 L
s
.65 .169 .063 r
.31591 .53729 m .30402 .52697 L .29227 .50613 L p F P
0 0 0 r
s
.507 .125 .048 r
.30402 .52697 m .31591 .53729 L .33176 .55664 L p F P
0 0 0 r
s
1 .316 .133 r
.56761 .63272 m .56427 .62945 L .59381 .62431 L p F P
0 0 0 r
s
1 .316 .133 r
.58904 .61947 m .59381 .62431 L .56427 .62945 L p F P
0 0 0 r
s
.051 .063 .121 r
.46408 .35594 m .48158 .34907 L .48006 .35946 L p F P
0 0 0 r
s
.051 .063 .121 r
.48006 .35946 m .46113 .36683 L .46408 .35594 L p F P
0 0 0 r
s
.886 .269 .117 r
.45362 .63299 m .45728 .63625 L .47819 .63474 L p F P
0 0 0 r
s
.886 .269 .117 r
.48002 .6364 m .47819 .63474 L .45728 .63625 L p F P
0 0 0 r
s
.24 .35 .67 r
.27957 .56209 m
.29071 .59319 L
s
.29071 .59319 m
.32785 .58056 L
s
.291 .44 .861 r
.50013 .6434 m .50322 .64246 L .5 .62969 L closepath p F P
0 0 0 r
s
.309 .092 .048 r
.57295 .34536 m .56327 .33323 L .55652 .32861 L p F P
0 0 0 r
s
.83 .24 .1 r
.56502 .34175 m
.5804 .35742 L
s
.309 .092 .048 r
.54767 .31755 m .55652 .32861 L .56327 .33323 L p F P
0 0 0 r
s
1 .31 .127 r
.6346 .52611 m .64357 .53644 L .6312 .55588 L p F P
0 0 0 r
s
1 .3 .122 r
.64357 .53644 m .6346 .52611 L .64267 .5052 L p F P
0 0 0 r
s
.968 .29 .124 r
.5 .62969 m .48548 .64133 L .48729 .64297 L closepath p F P
0 0 0 r
s
.291 .44 .861 r
.50322 .64246 m .50632 .64152 L .5 .62969 L closepath p F P
0 0 0 r
s
.289 .443 .863 r
.53446 .63294 m .53131 .6339 L .56137 .6346 L p F P
0 0 0 r
s
.289 .443 .863 r
.56137 .6346 m .56761 .63272 L .53446 .63294 L p F P
0 0 0 r
s
.24 .35 .67 r
.56218 .63276 m
.56364 .63232 L
s
.56364 .63232 m
.56595 .63273 L
s
.83 .24 .1 r
.32151 .25262 m
.29578 .27308 L
s
.26861 .24454 m
.29578 .27308 L
s
.29578 .27308 m
.27246 .29655 L
s
.2 .282 .57 r
.29227 .50613 m .31004 .49961 L .32084 .52093 L p F P
0 0 0 r
s
.2 .282 .57 r
.32084 .52093 m .30402 .52697 L .29227 .50613 L p F P
0 0 0 r
s
.24 .35 .67 r
.27213 .53049 m
.30027 .52032 L
s
.83 .24 .1 r
.30811 .5255 m
.33277 .54698 L
s
.158 .215 .442 r
.34092 .44432 m .3599 .43711 L .36038 .45764 L p F P
0 0 0 r
s
.158 .215 .442 r
.36038 .45764 m .34147 .46471 L .34092 .44432 L p F P
0 0 0 r
s
.24 .35 .67 r
.56364 .63232 m
.56636 .6315 L
s
.291 .44 .861 r
.50632 .64152 m .50942 .64057 L .5 .62969 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.50129 .27689 m
.47808 .2725 L
s
.45456 .24394 m
.47808 .2725 L
s
.27988 .50091 m
.29933 .51785 L
s
.29933 .51785 m
.30087 .51919 L
s
.968 .29 .124 r
.5 .62969 m .48367 .63969 L .48548 .64133 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.22465 .37662 m
.25271 .40257 L
s
.25271 .40257 m
.24679 .42913 L
s
.2448 .26846 m
.27246 .29655 L
s
.27246 .29655 m
.25235 .32222 L
s
.24 .35 .67 r
.60378 .29645 m
.64462 .28037 L
s
.60378 .29645 m
.59449 .30085 L
s
1 .3 .122 r
.63306 .49384 m .64267 .5052 L .6346 .52611 L p F P
0 0 0 r
s
1 .284 .114 r
.64267 .5052 m .63306 .49384 L .63711 .47256 L p F P
0 0 0 r
s
.24 .35 .67 r
.79381 .56911 m
.79932 .55963 L
s
.79932 .55963 m
.84243 .54658 L
s
.09 .111 .237 r
.42389 .38134 m .44241 .37413 L .43946 .38912 L p F P
0 0 0 r
s
.09 .111 .237 r
.43946 .38912 m .42002 .39661 L .42389 .38134 L p F P
0 0 0 r
s
.291 .44 .861 r
.50942 .64057 m .51253 .63962 L .5 .62969 L closepath p F P
0 0 0 r
s
.641 .167 .062 r
.61459 .40886 m .6043 .39608 L .59924 .38082 L p F P
0 0 0 r
s
.641 .167 .062 r
.58921 .36827 m .59924 .38082 L .6043 .39608 L p F P
0 0 0 r
s
.83 .24 .1 r
.5804 .35742 m
.58951 .36882 L
s
.127 .167 .35 r
.3818 .41134 m .4008 .40402 L .39852 .42243 L p F P
0 0 0 r
s
.127 .167 .35 r
.39852 .42243 m .37909 .42981 L .3818 .41134 L p F P
0 0 0 r
s
.24 .35 .67 r
.38037 .43055 m
.38056 .42925 L
s
.886 .269 .117 r
.44993 .62972 m .45362 .63299 L .47636 .63308 L p F P
0 0 0 r
s
.83 .24 .1 r
.45568 .633 m
.45585 .63315 L
s
.886 .269 .117 r
.47819 .63474 m .47636 .63308 L .45362 .63299 L p F P
0 0 0 r
s
1 .312 .132 r
.56427 .62945 m .56761 .63272 L .53446 .63294 L p F P
0 0 0 r
s
.438 .139 .066 r
.39155 .60398 m .38414 .59756 L .36132 .58263 L p F P
0 0 0 r
s
.58 .187 .085 r
.38414 .59756 m .39155 .60398 L .41581 .61499 L p F P
0 0 0 r
s
.58 .187 .085 r
.42139 .61987 m .41581 .61499 L .39155 .60398 L p F P
0 0 0 r
s
.83 .24 .1 r
.40839 .61045 m
.40982 .61169 L
s
.40502 .60905 m
.40839 .61045 L
s
.968 .29 .124 r
.5 .62969 m .48185 .63805 L .48367 .63969 L closepath p F P
0 0 0 r
s
.291 .44 .861 r
.51253 .63962 m .51565 .63867 L .5 .62969 L closepath p F P
0 0 0 r
s
.309 .092 .048 r
.56327 .33323 m .55342 .32088 L .54767 .31755 L p F P
0 0 0 r
s
.027 .038 .072 r
.53141 .32396 m .54767 .31755 L .55342 .32088 L p F P
0 0 0 r
s
.24 .35 .67 r
.54945 .31857 m
.55391 .31682 L
s
.83 .24 .1 r
.54616 .31821 m
.54627 .31834 L
s
.54348 .31487 m
.54616 .31821 L
s
.027 .038 .072 r
.55342 .32088 m .53518 .32804 L .53141 .32396 L p F P
0 0 0 r
s
.83 .24 .1 r
.54952 .32241 m
.56502 .34175 L
s
.762 .236 .104 r
.41581 .61499 m .42139 .61987 L .44622 .62643 L p F P
0 0 0 r
s
.762 .236 .104 r
.44993 .62972 m .44622 .62643 L .42139 .61987 L p F P
0 0 0 r
s
1 .319 .133 r
.58904 .61947 m .58422 .61459 L .60851 .60345 L p F P
0 0 0 r
s
1 .319 .133 r
.60238 .59702 m .60851 .60345 L .58422 .61459 L p F P
0 0 0 r
s
1 .318 .132 r
.60851 .60345 m .60238 .59702 L .62255 .58198 L p F P
0 0 0 r
s
.83 .24 .1 r
.34877 .23589 m
.32151 .25262 L
s
.29478 .22359 m
.32151 .25262 L
s
1 .284 .114 r
.62706 .46042 m .63711 .47256 L .63306 .49384 L p F P
0 0 0 r
s
.83 .24 .1 r
.63523 .47029 m
.63542 .46681 L
s
.939 .259 .102 r
.63711 .47256 m .62706 .46042 L .6275 .43995 L p F P
0 0 0 r
s
.325 .073 .03 r
.36132 .58263 m .35218 .57475 L .33176 .55664 L p F P
0 0 0 r
s
.438 .139 .066 r
.35218 .57475 m .36132 .58263 L .38414 .59756 L p F P
0 0 0 r
s
1 .316 .133 r
.56427 .62945 m .56091 .62615 L .58904 .61947 L p F P
0 0 0 r
s
.24 .35 .67 r
.57058 .63022 m
.57619 .62852 L
s
1 .316 .133 r
.58422 .61459 m .58904 .61947 L .56091 .62615 L p F P
0 0 0 r
s
.291 .44 .861 r
.51565 .63867 m .51877 .63772 L .5 .62969 L closepath p F P
0 0 0 r
s
.181 .252 .513 r
.32277 .4717 m .34147 .46471 L .34619 .48636 L p F P
0 0 0 r
s
.181 .252 .513 r
.34619 .48636 m .32801 .49302 L .32277 .4717 L p F P
0 0 0 r
s
.813 .22 .084 r
.6275 .43995 m .61721 .42731 L .61459 .40886 L p F P
0 0 0 r
s
.813 .22 .084 r
.6043 .39608 m .61459 .40886 L .61721 .42731 L p F P
0 0 0 r
s
.83 .24 .1 r
.61469 .4212 m
.61597 .42808 L
s
1 .318 .132 r
.61527 .57409 m .62255 .58198 L .60238 .59702 L p F P
0 0 0 r
s
1 .316 .13 r
.62255 .58198 m .61527 .57409 L .6312 .55588 L p F P
0 0 0 r
s
.051 .063 .121 r
.48158 .34907 m .49926 .34213 L .4992 .352 L p F P
0 0 0 r
s
.051 .063 .121 r
.4992 .352 m .48006 .35946 L .48158 .34907 L p F P
0 0 0 r
s
.939 .259 .102 r
.61721 .42731 m .6275 .43995 L .62706 .46042 L p F P
0 0 0 r
s
.968 .29 .124 r
.5 .62969 m .48002 .6364 L .48185 .63805 L closepath p F P
0 0 0 r
s
.291 .44 .861 r
.51877 .63772 m .52189 .63677 L .5 .62969 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.22418 .29455 m
.25235 .32222 L
s
.25235 .32222 m
.2362 .34922 L
s
.24 .35 .67 r
.69629 .26677 m
.73836 .25029 L
s
.69629 .26677 m
.68641 .26392 L
s
.886 .269 .117 r
.44622 .62643 m .44993 .62972 L .47452 .63142 L p F P
0 0 0 r
s
.83 .24 .1 r
.45216 .62988 m
.45233 .63003 L
s
.886 .269 .117 r
.47636 .63308 m .47452 .63142 L .44993 .62972 L p F P
0 0 0 r
s
.24 .35 .67 r
.45215 .63205 m
.46928 .64725 L
s
.41363 .64408 m
.45215 .63205 L
s
.507 .125 .048 r
.33176 .55664 m .32103 .54738 L .30402 .52697 L p F P
0 0 0 r
s
.24 .35 .67 r
.27957 .56209 m
.3166 .54909 L
s
.325 .073 .03 r
.32103 .54738 m .33176 .55664 L .35218 .57475 L p F P
0 0 0 r
s
1 .312 .132 r
.53446 .63294 m .53271 .63128 L .56427 .62945 L p F P
0 0 0 r
s
1 .312 .132 r
.56091 .62615 m .56427 .62945 L .53271 .63128 L p F P
0 0 0 r
s
.24 .35 .67 r
.64531 .60763 m
.65783 .61062 L
s
.65783 .61062 m
.69946 .59811 L
s
.291 .44 .861 r
.52189 .63677 m .52503 .63582 L .5 .62969 L closepath p F P
0 0 0 r
s
.968 .29 .124 r
.5 .62969 m .47819 .63474 L .48002 .6364 L closepath p F P
0 0 0 r
s
1 .316 .13 r
.6229 .5466 m .6312 .55588 L .61527 .57409 L p F P
0 0 0 r
s
1 .31 .127 r
.6312 .55588 m .6229 .5466 L .6346 .52611 L p F P
0 0 0 r
s
.24 .35 .67 r
.32785 .58056 m
.34206 .60985 L
s
.2 .282 .57 r
.31004 .49961 m .32801 .49302 L .33784 .51483 L p F P
0 0 0 r
s
.2 .282 .57 r
.33784 .51483 m .32084 .52093 L .31004 .49961 L p F P
0 0 0 r
s
.291 .44 .861 r
.52503 .63582 m .52816 .63486 L .5 .62969 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.2464 .45411 m
.27418 .47866 L
s
.27418 .47866 m
.27988 .50091 L
s
.158 .215 .442 r
.3599 .43711 m .37909 .42981 L .37952 .45048 L p F P
0 0 0 r
s
.24 .35 .67 r
.35992 .43832 m
.36105 .43789 L
s
.37912 .43103 m
.38037 .43055 L
s
.158 .215 .442 r
.37952 .45048 m .36038 .45764 L .3599 .43711 L p F P
0 0 0 r
s
.471 .116 .045 r
.58921 .36827 m .57899 .35547 L .57295 .34536 L p F P
0 0 0 r
s
.471 .116 .045 r
.56327 .33323 m .57295 .34536 L .57899 .35547 L p F P
0 0 0 r
s
.09 .111 .237 r
.44241 .37413 m .46113 .36683 L .45913 .38154 L p F P
0 0 0 r
s
.09 .111 .237 r
.45913 .38154 m .43946 .38912 L .44241 .37413 L p F P
0 0 0 r
s
.291 .44 .861 r
.52816 .63486 m .53131 .6339 L .5 .62969 L closepath p F P
0 0 0 r
s
.968 .29 .124 r
.5 .62969 m .47636 .63308 L .47819 .63474 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.47624 .63297 m
.47913 .63268 L
s
.58 .187 .085 r
.41581 .61499 m .41018 .61007 L .38414 .59756 L p F P
0 0 0 r
s
.762 .236 .104 r
.41018 .61007 m .41581 .61499 L .44248 .62311 L p F P
0 0 0 r
s
.762 .236 .104 r
.44622 .62643 m .44248 .62311 L .41581 .61499 L p F P
0 0 0 r
s
.216 .308 .619 r
.30402 .52697 m .32084 .52093 L .33647 .54196 L p F P
0 0 0 r
s
.216 .308 .619 r
.33647 .54196 m .32103 .54738 L .30402 .52697 L p F P
0 0 0 r
s
.83 .24 .1 r
.31462 .53686 m
.31679 .54033 L
s
.31679 .54033 m
.31846 .54301 L
s
.24 .35 .67 r
.31424 .53923 m
.31551 .54455 L
s
.31551 .54455 m
.3166 .54909 L
s
.127 .167 .35 r
.4008 .40402 m .42002 .39661 L .41817 .41496 L p F P
0 0 0 r
s
.127 .167 .35 r
.41817 .41496 m .39852 .42243 L .4008 .40402 L p F P
0 0 0 r
s
1 .316 .133 r
.56091 .62615 m .55753 .62284 L .58422 .61459 L p F P
0 0 0 r
s
1 .316 .133 r
.57936 .60966 m .58422 .61459 L .55753 .62284 L p F P
0 0 0 r
s
1 .319 .133 r
.58422 .61459 m .57936 .60966 L .60238 .59702 L p F P
0 0 0 r
s
.83 .24 .1 r
.45456 .24394 m
.42877 .2455 L
s
.40408 .21618 m
.42877 .2455 L
s
.291 .44 .861 r
.53131 .6339 m .53446 .63294 L .5 .62969 L closepath p F P
0 0 0 r
s
.886 .269 .117 r
.44248 .62311 m .44622 .62643 L .47267 .62975 L p F P
0 0 0 r
s
.83 .24 .1 r
.44862 .62673 m
.44879 .62688 L
s
.886 .269 .117 r
.47452 .63142 m .47267 .62975 L .44622 .62643 L p F P
0 0 0 r
s
1 .31 .127 r
.62546 .51559 m .6346 .52611 L .6229 .5466 L p F P
0 0 0 r
s
1 .3 .122 r
.6346 .52611 m .62546 .51559 L .63306 .49384 L p F P
0 0 0 r
s
.438 .139 .066 r
.38414 .59756 m .37665 .59106 L .35218 .57475 L p F P
0 0 0 r
s
.58 .187 .085 r
.37665 .59106 m .38414 .59756 L .41018 .61007 L p F P
0 0 0 r
s
1 .312 .132 r
.53271 .63128 m .53095 .62961 L .56091 .62615 L p F P
0 0 0 r
s
1 .312 .132 r
.55753 .62284 m .56091 .62615 L .53095 .62961 L p F P
0 0 0 r
s
.24 .35 .67 r
.55643 .62798 m
.55806 .62896 L
s
.83 .24 .1 r
.37663 .22356 m
.34877 .23589 L
s
.32244 .20636 m
.34877 .23589 L
s
.24 .35 .67 r
.55391 .31682 m
.59449 .30085 L
s
.55183 .31996 m
.55391 .31682 L
s
.968 .29 .124 r
.5 .62969 m .47452 .63142 L .47636 .63308 L closepath p F P
0 0 0 r
s
1 .319 .133 r
.59618 .59052 m .60238 .59702 L .57936 .60966 L p F P
0 0 0 r
s
1 .318 .132 r
.60238 .59702 m .59618 .59052 L .61527 .57409 L p F P
0 0 0 r
s
1 .303 .129 r
.53271 .63128 m .53446 .63294 L .5 .62969 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.74208 .5853 m
.75093 .582 L
s
.75093 .582 m
.79381 .56911 L
s
.051 .063 .121 r
.49926 .34213 m .51713 .33512 L .51856 .34446 L p F P
0 0 0 r
s
.051 .063 .121 r
.51856 .34446 m .4992 .352 L .49926 .34213 L p F P
0 0 0 r
s
.181 .252 .513 r
.34147 .46471 m .36038 .45764 L .36456 .47962 L p F P
0 0 0 r
s
.181 .252 .513 r
.36456 .47962 m .34619 .48636 L .34147 .46471 L p F P
0 0 0 r
s
.83 .24 .1 r
.54348 .31487 m
.54846 .31991 L
s
.52107 .28689 m
.54348 .31487 L
s
.968 .29 .124 r
.5 .62969 m .47267 .62975 L .47452 .63142 L closepath p F P
0 0 0 r
s
.325 .073 .03 r
.35218 .57475 m .34291 .56675 L .32103 .54738 L p F P
0 0 0 r
s
.24 .35 .67 r
.3166 .54909 m
.32785 .58056 L
s
.83 .24 .1 r
.32279 .54676 m
.34454 .56557 L
s
.438 .139 .066 r
.34291 .56675 m .35218 .57475 L .37665 .59106 L p F P
0 0 0 r
s
.83 .24 .1 r
.34454 .56557 m
.36159 .57972 L
s
.36159 .57972 m
.36496 .58264 L
s
1 .303 .129 r
.53095 .62961 m .53271 .63128 L .5 .62969 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.3166 .54909 m
.32116 .54749 L
s
1 .3 .122 r
.62327 .48227 m .63306 .49384 L .62546 .51559 L p F P
0 0 0 r
s
.83 .24 .1 r
.63144 .49193 m
.63221 .48909 L
s
1 .284 .114 r
.63306 .49384 m .62327 .48227 L .62706 .46042 L p F P
0 0 0 r
s
1 .318 .132 r
.60787 .56608 m .61527 .57409 L .59618 .59052 L p F P
0 0 0 r
s
1 .316 .13 r
.61527 .57409 m .60787 .56608 L .6229 .5466 L p F P
0 0 0 r
s
.762 .236 .104 r
.44248 .62311 m .43872 .61978 L .41018 .61007 L p F P
0 0 0 r
s
.886 .269 .117 r
.43872 .61978 m .44248 .62311 L .47082 .62807 L p F P
0 0 0 r
s
.83 .24 .1 r
.44506 .62357 m
.44523 .62372 L
s
.886 .269 .117 r
.47267 .62975 m .47082 .62807 L .44248 .62311 L p F P
0 0 0 r
s
.24 .35 .67 r
.45215 .63205 m
.46416 .6283 L
s
.641 .167 .062 r
.6043 .39608 m .5938 .38303 L .58921 .36827 L p F P
0 0 0 r
s
.641 .167 .062 r
.57899 .35547 m .58921 .36827 L .5938 .38303 L p F P
0 0 0 r
s
.83 .24 .1 r
.59062 .37786 m
.59184 .37939 L
s
.58523 .36709 m
.59062 .37786 L
s
1 .312 .132 r
.53095 .62961 m .52919 .62793 L .55753 .62284 L p F P
0 0 0 r
s
1 .312 .132 r
.55413 .6195 m .55753 .62284 L .52919 .62793 L p F P
0 0 0 r
s
1 .316 .133 r
.55753 .62284 m .55413 .6195 L .57936 .60966 L p F P
0 0 0 r
s
.24 .35 .67 r
.57619 .62852 m
.604 .62012 L
s
.83 .24 .1 r
.2075 .32191 m
.2362 .34922 L
s
.2362 .34922 m
.22465 .37662 L
s
.2 .282 .57 r
.32801 .49302 m .34619 .48636 L .35502 .50866 L p F P
0 0 0 r
s
.2 .282 .57 r
.35502 .50866 m .33784 .51483 L .32801 .49302 L p F P
0 0 0 r
s
.968 .29 .124 r
.5 .62969 m .47082 .62807 L .47267 .62975 L closepath p F P
0 0 0 r
s
.58 .187 .085 r
.41018 .61007 m .4045 .6051 L .37665 .59106 L p F P
0 0 0 r
s
.762 .236 .104 r
.4045 .6051 m .41018 .61007 L .43872 .61978 L p F P
0 0 0 r
s
1 .303 .129 r
.52919 .62793 m .53095 .62961 L .5 .62969 L closepath p F P
0 0 0 r
s
.158 .215 .442 r
.37909 .42981 m .39852 .42243 L .39887 .44324 L p F P
0 0 0 r
s
.158 .215 .442 r
.39887 .44324 m .37952 .45048 L .37909 .42981 L p F P
0 0 0 r
s
.24 .35 .67 r
.58914 .61054 m
.604 .62012 L
s
.604 .62012 m
.64531 .60763 L
s
1 .316 .133 r
.57445 .60469 m .57936 .60966 L .55413 .6195 L p F P
0 0 0 r
s
1 .319 .133 r
.57936 .60966 m .57445 .60469 L .59618 .59052 L p F P
0 0 0 r
s
.09 .111 .237 r
.46113 .36683 m .48006 .35946 L .47903 .37387 L p F P
0 0 0 r
s
.09 .111 .237 r
.47903 .37387 m .45913 .38154 L .46113 .36683 L p F P
0 0 0 r
s
.24 .35 .67 r
.64462 .28037 m
.68641 .26392 L
s
.64462 .28037 m
.63602 .28451 L
s
.83 .24 .1 r
.21827 .40341 m
.24679 .42913 L
s
.24679 .42913 m
.2464 .45411 L
s
.216 .308 .619 r
.32084 .52093 m .33784 .51483 L .35205 .53649 L p F P
0 0 0 r
s
.216 .308 .619 r
.35205 .53649 m .33647 .54196 L .32084 .52093 L p F P
0 0 0 r
s
.24 .35 .67 r
.84243 .54658 m
.8377 .55592 L
s
1 .284 .114 r
.6168 .44803 m .62706 .46042 L .62327 .48227 L p F P
0 0 0 r
s
.939 .259 .102 r
.62706 .46042 m .6168 .44803 L .61721 .42731 L p F P
0 0 0 r
s
.83 .24 .1 r
.61597 .42808 m
.61717 .42955 L
s
.23 .33 .662 r
.32103 .54738 m .33647 .54196 L .35654 .56207 L p F P
0 0 0 r
s
.83 .24 .1 r
.31846 .54301 m
.3217 .54582 L
s
.3217 .54582 m
.32183 .54593 L
s
.23 .33 .662 r
.35654 .56207 m .34291 .56675 L .32103 .54738 L p F P
0 0 0 r
s
.127 .167 .35 r
.42002 .39661 m .43946 .38912 L .43805 .4074 L p F P
0 0 0 r
s
.127 .167 .35 r
.43805 .4074 m .41817 .41496 L .42002 .39661 L p F P
0 0 0 r
s
.24 .35 .67 r
.41904 .41587 m
.4192 .41456 L
s
.886 .269 .117 r
.47082 .62807 m .46896 .62639 L .43872 .61978 L p F P
0 0 0 r
s
.24 .35 .67 r
.46416 .6283 m
.46785 .62715 L
s
.968 .29 .124 r
.5 .62969 m .46896 .62639 L .47082 .62807 L closepath p F P
0 0 0 r
s
1 .303 .129 r
.52742 .62625 m .52919 .62793 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .312 .132 r
.52919 .62793 m .52742 .62625 L .55413 .6195 L p F P
0 0 0 r
s
.813 .22 .084 r
.61721 .42731 m .60671 .41442 L .6043 .39608 L p F P
0 0 0 r
s
.813 .22 .084 r
.5938 .38303 m .6043 .39608 L .60671 .41442 L p F P
0 0 0 r
s
1 .316 .13 r
.61448 .53717 m .6229 .5466 L .60787 .56608 L p F P
0 0 0 r
s
1 .31 .127 r
.6229 .5466 m .61448 .53717 L .62546 .51559 L p F P
0 0 0 r
s
.939 .259 .102 r
.60671 .41442 m .61721 .42731 L .6168 .44803 L p F P
0 0 0 r
s
.438 .139 .066 r
.37665 .59106 m .36906 .58449 L .34291 .56675 L p F P
0 0 0 r
s
.24 .35 .67 r
.32785 .58056 m
.35004 .57302 L
s
.35004 .57302 m
.35126 .5726 L
s
.58 .187 .085 r
.36906 .58449 m .37665 .59106 L .4045 .6051 L p F P
0 0 0 r
s
.051 .063 .121 r
.51713 .33512 m .53518 .32804 L .53814 .33684 L p F P
0 0 0 r
s
.051 .063 .121 r
.53814 .33684 m .51856 .34446 L .51713 .33512 L p F P
0 0 0 r
s
.762 .236 .104 r
.43872 .61978 m .43494 .61643 L .4045 .6051 L p F P
0 0 0 r
s
.886 .269 .117 r
.43494 .61643 m .43872 .61978 L .46896 .62639 L p F P
0 0 0 r
s
.285 .426 .838 r
.5 .62969 m .48719 .61612 L .49035 .61512 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.4949 .62915 m
.49845 .62805 L
s
.285 .426 .838 r
.5 .62969 m .49035 .61512 L .49352 .61413 L closepath p F P
0 0 0 r
s
.285 .426 .838 r
.5 .62969 m .49352 .61413 L .49669 .61313 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.49948 .62709 m
.50201 .62944 L
s
.285 .426 .838 r
.5 .62969 m .49669 .61313 L .49987 .61214 L closepath p F P
0 0 0 r
s
.285 .426 .838 r
.5 .62969 m .49987 .61214 L .50305 .61114 L closepath p F P
0 0 0 r
s
.285 .426 .838 r
.5 .62969 m .50305 .61114 L .50624 .61014 L closepath p F P
0 0 0 r
s
.285 .426 .838 r
.5 .62969 m .50624 .61014 L .50944 .60913 L closepath p F P
0 0 0 r
s
.968 .29 .124 r
.5 .62969 m .46522 .62301 L .46709 .6247 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.47958 .6266 m
.48072 .62764 L
s
.968 .29 .124 r
.5 .62969 m .46709 .6247 L .46896 .62639 L closepath p F P
0 0 0 r
s
1 .303 .129 r
.52565 .62456 m .52742 .62625 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .303 .129 r
.52387 .62287 m .52565 .62456 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .303 .129 r
.52209 .62117 m .52387 .62287 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .303 .129 r
.5203 .61947 m .52209 .62117 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .303 .129 r
.5185 .61776 m .5203 .61947 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .303 .129 r
.5167 .61604 m .5185 .61776 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .303 .129 r
.5149 .61433 m .5167 .61604 L .5 .62969 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.50113 .62722 m
.50294 .62666 L
s
.285 .426 .838 r
.5 .62969 m .46522 .62301 L .46834 .62203 L closepath p F P
0 0 0 r
s
.285 .426 .838 r
.5 .62969 m .46834 .62203 L .47147 .62105 L closepath p F P
0 0 0 r
s
.285 .426 .838 r
.5 .62969 m .47147 .62105 L .4746 .62007 L closepath p F P
0 0 0 r
s
.285 .426 .838 r
.5 .62969 m .4746 .62007 L .47774 .61908 L closepath p F P
0 0 0 r
s
.285 .426 .838 r
.5 .62969 m .47774 .61908 L .48088 .61809 L closepath p F P
0 0 0 r
s
.285 .426 .838 r
.5 .62969 m .48088 .61809 L .48403 .61711 L closepath p F P
0 0 0 r
s
.285 .426 .838 r
.5 .62969 m .48403 .61711 L .48719 .61612 L closepath p F P
0 0 0 r
s
1 .303 .129 r
.51308 .6126 m .5149 .61433 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .303 .129 r
.51126 .61087 m .51308 .6126 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .303 .129 r
.50944 .60913 m .51126 .61087 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .312 .132 r
.55071 .61615 m .55413 .6195 L .52742 .62625 L p F P
0 0 0 r
s
1 .316 .133 r
.55413 .6195 m .55071 .61615 L .57445 .60469 L p F P
0 0 0 r
s
1 .319 .133 r
.5899 .58394 m .59618 .59052 L .57445 .60469 L p F P
0 0 0 r
s
1 .318 .132 r
.59618 .59052 m .5899 .58394 L .60787 .56608 L p F P
0 0 0 r
s
.83 .24 .1 r
.52107 .28689 m
.50129 .27689 L
s
.47791 .248 m
.50129 .27689 L
s
.886 .269 .117 r
.46896 .62639 m .46709 .6247 L .43494 .61643 L p F P
0 0 0 r
s
.24 .35 .67 r
.44319 .62092 m
.45215 .63205 L
s
.44138 .61867 m
.44319 .62092 L
s
1 .312 .132 r
.52742 .62625 m .52565 .62456 L .55071 .61615 L p F P
0 0 0 r
s
.181 .252 .513 r
.36038 .45764 m .37952 .45048 L .38314 .4728 L p F P
0 0 0 r
s
.181 .252 .513 r
.38314 .4728 m .36456 .47962 L .36038 .45764 L p F P
0 0 0 r
s
.471 .116 .045 r
.57899 .35547 m .56857 .34243 L .56327 .33323 L p F P
0 0 0 r
s
.471 .116 .045 r
.55342 .32088 m .56327 .33323 L .56857 .34243 L p F P
0 0 0 r
s
.83 .24 .1 r
.29131 .51954 m
.31846 .54301 L
s
.31846 .54301 m
.33545 .55711 L
s
.24 .35 .67 r
.72919 .24707 m
.73836 .25029 L
s
.58 .187 .085 r
.4045 .6051 m .39876 .60008 L .36906 .58449 L p F P
0 0 0 r
s
.24 .35 .67 r
.38007 .59732 m
.3963 .62323 L
s
.34206 .60985 m
.38007 .59732 L
s
.762 .236 .104 r
.39876 .60008 m .4045 .6051 L .43494 .61643 L p F P
0 0 0 r
s
.24 .35 .67 r
.3963 .62323 m
.42282 .61474 L
s
.886 .269 .117 r
.43114 .61305 m .43494 .61643 L .46709 .6247 L p F P
0 0 0 r
s
.886 .269 .117 r
.46709 .6247 m .46522 .62301 L .43114 .61305 L p F P
0 0 0 r
s
.83 .24 .1 r
.42676 .61273 m
.43143 .61331 L
s
.24 .35 .67 r
.68758 .59485 m
.69946 .59811 L
s
.69946 .59811 m
.74208 .5853 L
s
1 .312 .132 r
.52565 .62456 m .52387 .62287 L .54727 .61277 L p F P
0 0 0 r
s
1 .312 .132 r
.54727 .61277 m .55071 .61615 L .52565 .62456 L p F P
0 0 0 r
s
.24 .35 .67 r
.53213 .628 m
.54826 .62306 L
s
.54826 .62306 m
.55643 .62798 L
s
1 .316 .133 r
.5695 .59967 m .57445 .60469 L .55071 .61615 L p F P
0 0 0 r
s
1 .319 .133 r
.57445 .60469 m .5695 .59967 L .5899 .58394 L p F P
0 0 0 r
s
.83 .24 .1 r
.40408 .21618 m
.37663 .22356 L
s
.35064 .19352 m
.37663 .22356 L
s
.2 .282 .57 r
.34619 .48636 m .36456 .47962 L .37238 .50243 L p F P
0 0 0 r
s
.2 .282 .57 r
.37238 .50243 m .35502 .50866 L .34619 .48636 L p F P
0 0 0 r
s
1 .31 .127 r
.61616 .50488 m .62546 .51559 L .61448 .53717 L p F P
0 0 0 r
s
.83 .24 .1 r
.61325 .53678 m
.61465 .53388 L
s
.62418 .51412 m
.62522 .51196 L
s
1 .3 .122 r
.62546 .51559 m .61616 .50488 L .62327 .48227 L p F P
0 0 0 r
s
.762 .236 .104 r
.43494 .61643 m .43114 .61305 L .39876 .60008 L p F P
0 0 0 r
s
.24 .35 .67 r
.42282 .61474 m
.42827 .613 L
s
.37664 .59015 m
.38007 .59732 L
s
.37602 .58885 m
.37664 .59015 L
s
.38007 .59732 m
.38781 .59477 L
s
.242 .351 .701 r
.34291 .56675 m .35654 .56207 L .38051 .58066 L p F P
0 0 0 r
s
.242 .351 .701 r
.38051 .58066 m .36906 .58449 L .34291 .56675 L p F P
0 0 0 r
s
.83 .24 .1 r
.35091 .57048 m
.35174 .5712 L
s
.24 .35 .67 r
.37326 .58309 m
.37557 .58791 L
s
1 .316 .133 r
.55071 .61615 m .54727 .61277 L .5695 .59967 L p F P
0 0 0 r
s
.216 .308 .619 r
.33784 .51483 m .35502 .50866 L .36779 .53097 L p F P
0 0 0 r
s
.216 .308 .619 r
.36779 .53097 m .35205 .53649 L .33784 .51483 L p F P
0 0 0 r
s
.158 .215 .442 r
.39852 .42243 m .41817 .41496 L .41846 .43592 L p F P
0 0 0 r
s
.24 .35 .67 r
.39854 .42366 m
.39969 .42322 L
s
.41818 .41619 m
.41904 .41587 L
s
.158 .215 .442 r
.41846 .43592 m .39887 .44324 L .39852 .42243 L p F P
0 0 0 r
s
.23 .33 .662 r
.33647 .54196 m .35205 .53649 L .37029 .55736 L p F P
0 0 0 r
s
.24 .35 .67 r
.33659 .54208 m
.33667 .54205 L
s
.35216 .53662 m
.3545 .5358 L
s
.23 .33 .662 r
.37029 .55736 m .35654 .56207 L .33647 .54196 L p F P
0 0 0 r
s
.83 .24 .1 r
.33545 .55711 m
.35091 .57048 L
s
.09 .111 .237 r
.48006 .35946 m .4992 .352 L .49916 .36611 L p F P
0 0 0 r
s
.09 .111 .237 r
.49916 .36611 m .47903 .37387 L .48006 .35946 L p F P
0 0 0 r
s
1 .318 .132 r
.60037 .55795 m .60787 .56608 L .5899 .58394 L p F P
0 0 0 r
s
1 .316 .13 r
.60787 .56608 m .60037 .55795 L .61448 .53717 L p F P
0 0 0 r
s
.83 .24 .1 r
.61325 .53678 m
.6141 .53773 L
s
.276 .409 .807 r
.46834 .62203 m .46522 .62301 L .43114 .61305 L p F P
0 0 0 r
s
.83 .24 .1 r
.43386 .61361 m
.43401 .61374 L
s
.43304 .61351 m
.43386 .61361 L
s
1 .312 .132 r
.52387 .62287 m .52209 .62117 L .54381 .60937 L p F P
0 0 0 r
s
1 .312 .132 r
.54381 .60937 m .54727 .61277 L .52387 .62287 L p F P
0 0 0 r
s
.24 .35 .67 r
.35446 .53565 m
.3545 .5358 L
s
.127 .167 .35 r
.43946 .38912 m .45913 .38154 L .45817 .39975 L p F P
0 0 0 r
s
.127 .167 .35 r
.45817 .39975 m .43805 .4074 L .43946 .38912 L p F P
0 0 0 r
s
.276 .409 .807 r
.43114 .61305 m .43726 .61109 L .46834 .62203 L p F P
0 0 0 r
s
.276 .409 .807 r
.47147 .62105 m .46834 .62203 L .43726 .61109 L p F P
0 0 0 r
s
.051 .063 .121 r
.53518 .32804 m .55342 .32088 L .55794 .32912 L p F P
0 0 0 r
s
.051 .063 .121 r
.55794 .32912 m .53814 .33684 L .53518 .32804 L p F P
0 0 0 r
s
1 .312 .132 r
.52209 .62117 m .5203 .61947 L .54032 .60595 L p F P
0 0 0 r
s
1 .312 .132 r
.54032 .60595 m .54381 .60937 L .52209 .62117 L p F P
0 0 0 r
s
.83 .24 .1 r
.54286 .60844 m
.54334 .6082 L
s
.276 .409 .807 r
.43726 .61109 m .44341 .60912 L .47147 .62105 L p F P
0 0 0 r
s
.276 .409 .807 r
.4746 .62007 m .47147 .62105 L .44341 .60912 L p F P
0 0 0 r
s
.254 .371 .738 r
.36906 .58449 m .38051 .58066 L .40769 .59717 L p F P
0 0 0 r
s
.254 .371 .738 r
.40769 .59717 m .39876 .60008 L .36906 .58449 L p F P
0 0 0 r
s
.83 .24 .1 r
.37706 .58603 m
.37802 .58642 L
s
.24 .35 .67 r
.59449 .30085 m
.63602 .28451 L
s
.59449 .30085 m
.58767 .312 L
s
.83 .24 .1 r
.29478 .22359 m
.26861 .24454 L
s
.26861 .24454 m
.2448 .26846 L
s
1 .3 .122 r
.61328 .47047 m .62327 .48227 L .61616 .50488 L p F P
0 0 0 r
s
1 .284 .114 r
.62327 .48227 m .61328 .47047 L .6168 .44803 L p F P
0 0 0 r
s
.265 .39 .773 r
.43726 .61109 m .43114 .61305 L .39876 .60008 L p F P
0 0 0 r
s
.24 .35 .67 r
.7857 .5722 m
.79381 .56911 L
s
.79381 .56911 m
.8377 .55592 L
s
1 .319 .133 r
.58355 .57729 m .5899 .58394 L .5695 .59967 L p F P
0 0 0 r
s
1 .318 .132 r
.5899 .58394 m .58355 .57729 L .60037 .55795 L p F P
0 0 0 r
s
.83 .24 .1 r
.59403 .56389 m
.59464 .56455 L
s
.47791 .248 m
.45456 .24394 L
s
.43008 .2142 m
.45456 .24394 L
s
1 .316 .133 r
.54727 .61277 m .54381 .60937 L .5645 .5946 L p F P
0 0 0 r
s
.83 .24 .1 r
.54334 .6082 m
.54423 .60907 L
s
.54762 .6124 m
.54772 .6125 L
s
1 .316 .133 r
.5645 .5946 m .5695 .59967 L .54727 .61277 L p F P
0 0 0 r
s
.24 .35 .67 r
.54826 .62306 m
.58914 .61054 L
s
.83 .24 .1 r
.2518 .47645 m
.27988 .50091 L
s
.27988 .50091 m
.29131 .51954 L
s
.19544 .3496 m
.22465 .37662 L
s
.22465 .37662 m
.21827 .40341 L
s
.276 .409 .807 r
.44341 .60912 m .44957 .60715 L .4746 .62007 L p F P
0 0 0 r
s
.276 .409 .807 r
.47774 .61908 m .4746 .62007 L .44957 .60715 L p F P
0 0 0 r
s
.181 .252 .513 r
.37952 .45048 m .39887 .44324 L .40193 .46591 L p F P
0 0 0 r
s
.181 .252 .513 r
.40193 .46591 m .38314 .4728 L .37952 .45048 L p F P
0 0 0 r
s
.83 .24 .1 r
.2448 .26846 m
.22418 .29455 L
s
.641 .167 .062 r
.5938 .38303 m .58309 .36972 L .57899 .35547 L p F P
0 0 0 r
s
.641 .167 .062 r
.56857 .34243 m .57899 .35547 L .58309 .36972 L p F P
0 0 0 r
s
.265 .39 .773 r
.39876 .60008 m .40769 .59717 L .43726 .61109 L p F P
0 0 0 r
s
1 .312 .132 r
.5203 .61947 m .5185 .61776 L .53681 .60251 L p F P
0 0 0 r
s
1 .312 .132 r
.53681 .60251 m .54032 .60595 L .5203 .61947 L p F P
0 0 0 r
s
1 .319 .133 r
.5695 .59967 m .5645 .5946 L .58355 .57729 L p F P
0 0 0 r
s
.83 .24 .1 r
.5703 .58813 m
.57092 .58877 L
s
.242 .351 .701 r
.35654 .56207 m .37029 .55736 L .39204 .57681 L p F P
0 0 0 r
s
.242 .351 .701 r
.39204 .57681 m .38051 .58066 L .35654 .56207 L p F P
0 0 0 r
s
.24 .35 .67 r
.3545 .5358 m
.35661 .5417 L
s
.276 .409 .807 r
.44957 .60715 m .45576 .60517 L .47774 .61908 L p F P
0 0 0 r
s
.276 .409 .807 r
.48088 .61809 m .47774 .61908 L .45576 .60517 L p F P
0 0 0 r
s
1 .316 .13 r
.60591 .52759 m .61448 .53717 L .60037 .55795 L p F P
0 0 0 r
s
.83 .24 .1 r
.59403 .56389 m
.60111 .5539 L
s
1 .31 .127 r
.61448 .53717 m .60591 .52759 L .61616 .50488 L p F P
0 0 0 r
s
.265 .39 .773 r
.44341 .60912 m .43726 .61109 L .40769 .59717 L p F P
0 0 0 r
s
.83 .24 .1 r
.42817 .60855 m
.42962 .60984 L
s
.2 .282 .57 r
.36456 .47962 m .38314 .4728 L .38992 .49613 L p F P
0 0 0 r
s
.2 .282 .57 r
.38992 .49613 m .37238 .50243 L .36456 .47962 L p F P
0 0 0 r
s
.23 .33 .662 r
.35205 .53649 m .36779 .53097 L .38415 .55261 L p F P
0 0 0 r
s
.23 .33 .662 r
.38415 .55261 m .37029 .55736 L .35205 .53649 L p F P
0 0 0 r
s
.276 .409 .807 r
.45576 .60517 m .46198 .60318 L .48088 .61809 L p F P
0 0 0 r
s
.276 .409 .807 r
.48403 .61711 m .48088 .61809 L .46198 .60318 L p F P
0 0 0 r
s
.83 .24 .1 r
.46932 .61724 m
.47155 .61927 L
s
1 .284 .114 r
.60633 .43539 m .6168 .44803 L .61328 .47047 L p F P
0 0 0 r
s
.83 .24 .1 r
.61487 .4457 m
.61508 .44231 L
s
.939 .259 .102 r
.6168 .44803 m .60633 .43539 L .60671 .41442 L p F P
0 0 0 r
s
.83 .24 .1 r
.32244 .20636 m
.29478 .22359 L
s
.216 .308 .619 r
.35502 .50866 m .37238 .50243 L .38367 .5254 L p F P
0 0 0 r
s
.216 .308 .619 r
.38367 .5254 m .36779 .53097 L .35502 .50866 L p F P
0 0 0 r
s
1 .312 .132 r
.5185 .61776 m .5167 .61604 L .53328 .59904 L p F P
0 0 0 r
s
1 .312 .132 r
.53328 .59904 m .53681 .60251 L .5185 .61776 L p F P
0 0 0 r
s
.09 .111 .237 r
.4992 .352 m .51856 .34446 L .51953 .35825 L p F P
0 0 0 r
s
.09 .111 .237 r
.51953 .35825 m .49916 .36611 L .4992 .352 L p F P
0 0 0 r
s
.254 .371 .738 r
.38051 .58066 m .39204 .57681 L .41666 .59423 L p F P
0 0 0 r
s
.254 .371 .738 r
.41666 .59423 m .40769 .59717 L .38051 .58066 L p F P
0 0 0 r
s
.83 .24 .1 r
.38336 .58859 m
.38847 .59306 L
s
.37802 .58642 m
.38336 .58859 L
s
.276 .409 .807 r
.46198 .60318 m .46821 .60119 L .48403 .61711 L p F P
0 0 0 r
s
.83 .24 .1 r
.44411 .61249 m
.46198 .61054 L
s
.276 .409 .807 r
.48719 .61612 m .48403 .61711 L .46821 .60119 L p F P
0 0 0 r
s
.813 .22 .084 r
.60671 .41442 m .596 .40125 L .5938 .38303 L p F P
0 0 0 r
s
.813 .22 .084 r
.58309 .36972 m .5938 .38303 L .596 .40125 L p F P
0 0 0 r
s
.83 .24 .1 r
.59383 .39595 m
.59496 .40232 L
s
.24 .35 .67 r
.63098 .59772 m
.64531 .60763 L
s
.64531 .60763 m
.68758 .59485 L
s
.158 .215 .442 r
.41817 .41496 m .43805 .4074 L .43827 .42851 L p F P
0 0 0 r
s
.24 .35 .67 r
.41904 .41587 m
.41935 .41575 L
s
.158 .215 .442 r
.43827 .42851 m .41846 .43592 L .41817 .41496 L p F P
0 0 0 r
s
.265 .39 .773 r
.40769 .59717 m .41666 .59423 L .44341 .60912 L p F P
0 0 0 r
s
1 .316 .133 r
.54381 .60937 m .54032 .60595 L .55946 .58949 L p F P
0 0 0 r
s
1 .316 .133 r
.55946 .58949 m .5645 .5946 L .54381 .60937 L p F P
0 0 0 r
s
.83 .24 .1 r
.56328 .59336 m
.5703 .58813 L
s
.24 .35 .67 r
.68641 .26392 m
.72919 .24707 L
s
.68641 .26392 m
.67854 .26777 L
s
.265 .39 .773 r
.44957 .60715 m .44341 .60912 L .41666 .59423 L p F P
0 0 0 r
s
.83 .24 .1 r
.42618 .60678 m
.42817 .60855 L
s
.939 .259 .102 r
.596 .40125 m .60671 .41442 L .60633 .43539 L p F P
0 0 0 r
s
.276 .409 .807 r
.46821 .60119 m .47447 .59919 L .48719 .61612 L p F P
0 0 0 r
s
.83 .24 .1 r
.46198 .61054 m
.46932 .61724 L
s
.276 .409 .807 r
.49035 .61512 m .48719 .61612 L .47447 .59919 L p F P
0 0 0 r
s
.471 .116 .045 r
.56857 .34243 m .55794 .32912 L .55342 .32088 L p F P
0 0 0 r
s
.83 .24 .1 r
.55884 .33044 m
.56885 .34297 L
s
.55765 .32923 m
.55884 .33044 L
s
1 .312 .132 r
.5167 .61604 m .5149 .61433 L .52973 .59555 L p F P
0 0 0 r
s
1 .312 .132 r
.52973 .59555 m .53328 .59904 L .5167 .61604 L p F P
0 0 0 r
s
.24 .35 .67 r
.5319 .60714 m
.54826 .62306 L
s
.83 .24 .1 r
.22418 .29455 m
.2075 .32191 L
s
.127 .167 .35 r
.45913 .38154 m .47903 .37387 L .47853 .392 L p F P
0 0 0 r
s
.127 .167 .35 r
.47853 .392 m .45817 .39975 L .45913 .38154 L p F P
0 0 0 r
s
.24 .35 .67 r
.45862 .40083 m
.45875 .39952 L
s
1 .318 .132 r
.59276 .54971 m .60037 .55795 L .58355 .57729 L p F P
0 0 0 r
s
.83 .24 .1 r
.5703 .58813 m
.58492 .5732 L
s
1 .316 .13 r
.60037 .55795 m .59276 .54971 L .60591 .52759 L p F P
0 0 0 r
s
.83 .24 .1 r
.53639 .30235 m
.55387 .32421 L
s
.55783 .32917 m
.55884 .33044 L
s
.276 .409 .807 r
.47447 .59919 m .48075 .59718 L .49035 .61512 L p F P
0 0 0 r
s
.24 .35 .67 r
.47475 .59811 m
.47536 .5989 L
s
.276 .409 .807 r
.49352 .61413 m .49035 .61512 L .48075 .59718 L p F P
0 0 0 r
s
.242 .351 .701 r
.37029 .55736 m .38415 .55261 L .40364 .57292 L p F P
0 0 0 r
s
.242 .351 .701 r
.40364 .57292 m .39204 .57681 L .37029 .55736 L p F P
0 0 0 r
s
.83 .24 .1 r
.35729 .56583 m
.38336 .58859 L
s
.265 .39 .773 r
.41666 .59423 m .42568 .59129 L .44957 .60715 L p F P
0 0 0 r
s
.265 .39 .773 r
.45576 .60517 m .44957 .60715 L .42568 .59129 L p F P
0 0 0 r
s
.83 .24 .1 r
.21748 .42855 m
.2464 .45411 L
s
.2464 .45411 m
.2518 .47645 L
s
1 .319 .133 r
.5645 .5946 m .55946 .58949 L .57712 .57055 L p F P
0 0 0 r
s
1 .319 .133 r
.57712 .57055 m .58355 .57729 L .5645 .5946 L p F P
0 0 0 r
s
1 .31 .127 r
.60669 .49397 m .61616 .50488 L .60591 .52759 L p F P
0 0 0 r
s
1 .3 .122 r
.61616 .50488 m .60669 .49397 L .61328 .47047 L p F P
0 0 0 r
s
1 .312 .132 r
.5149 .61433 m .51308 .6126 L .52615 .59205 L p F P
0 0 0 r
s
1 .312 .132 r
.52615 .59205 m .52973 .59555 L .5149 .61433 L p F P
0 0 0 r
s
.276 .409 .807 r
.48075 .59718 m .48706 .59516 L .49352 .61413 L p F P
0 0 0 r
s
.276 .409 .807 r
.49669 .61313 m .49352 .61413 L .48706 .59516 L p F P
0 0 0 r
s
.254 .371 .738 r
.42568 .59129 m .41666 .59423 L .39204 .57681 L p F P
0 0 0 r
s
1 .318 .132 r
.58355 .57729 m .57712 .57055 L .59276 .54971 L p F P
0 0 0 r
s
.181 .252 .513 r
.39887 .44324 m .41846 .43592 L .42094 .45894 L p F P
0 0 0 r
s
.181 .252 .513 r
.42094 .45894 m .40193 .46591 L .39887 .44324 L p F P
0 0 0 r
s
.24 .35 .67 r
.55562 .32454 m
.58767 .312 L
s
.254 .371 .738 r
.39204 .57681 m .40364 .57292 L .42568 .59129 L p F P
0 0 0 r
s
.24 .35 .67 r
.41794 .58484 m
.41897 .5845 L
s
.41897 .5845 m
.42047 .58695 L
s
1 .316 .133 r
.54032 .60595 m .53681 .60251 L .55437 .58433 L p F P
0 0 0 r
s
.83 .24 .1 r
.5406 .60551 m
.54071 .60562 L
s
1 .316 .133 r
.55437 .58433 m .55946 .58949 L .54032 .60595 L p F P
0 0 0 r
s
.276 .409 .807 r
.48706 .59516 m .49338 .59313 L .49669 .61313 L p F P
0 0 0 r
s
.276 .409 .807 r
.49987 .61214 m .49669 .61313 L .49338 .59313 L p F P
0 0 0 r
s
.23 .33 .662 r
.36779 .53097 m .38367 .5254 L .39813 .54782 L p F P
0 0 0 r
s
.24 .35 .67 r
.36789 .5311 m
.36797 .53107 L
s
.23 .33 .662 r
.39813 .54782 m .38415 .55261 L .36779 .53097 L p F P
0 0 0 r
s
.265 .39 .773 r
.42568 .59129 m .43474 .58832 L .45576 .60517 L p F P
0 0 0 r
s
.83 .24 .1 r
.40901 .59153 m
.42618 .60678 L
s
.265 .39 .773 r
.46198 .60318 m .45576 .60517 L .43474 .58832 L p F P
0 0 0 r
s
1 .312 .132 r
.51308 .6126 m .51126 .61087 L .52255 .58851 L p F P
0 0 0 r
s
1 .312 .132 r
.52255 .58851 m .52615 .59205 L .51308 .6126 L p F P
0 0 0 r
s
.24 .35 .67 r
.5156 .61223 m
.5194 .61104 L
s
.83 .24 .1 r
.43008 .2142 m
.40408 .21618 L
s
.37837 .18565 m
.40408 .21618 L
s
.2 .282 .57 r
.38314 .4728 m .40193 .46591 L .40765 .48976 L p F P
0 0 0 r
s
.2 .282 .57 r
.40765 .48976 m .38992 .49613 L .38314 .4728 L p F P
0 0 0 r
s
.276 .409 .807 r
.49338 .59313 m .49974 .5911 L .49987 .61214 L p F P
0 0 0 r
s
.83 .24 .1 r
.4914 .60119 m
.49862 .608 L
s
.276 .409 .807 r
.50305 .61114 m .49987 .61214 L .49974 .5911 L p F P
0 0 0 r
s
.216 .308 .619 r
.37238 .50243 m .38992 .49613 L .39971 .51977 L p F P
0 0 0 r
s
.216 .308 .619 r
.39971 .51977 m .38367 .5254 L .37238 .50243 L p F P
0 0 0 r
s
.24 .35 .67 r
.73087 .58176 m
.74208 .5853 L
s
.74208 .5853 m
.7857 .5722 L
s
.83 .24 .1 r
.35064 .19352 m
.32244 .20636 L
s
.09 .111 .237 r
.51856 .34446 m .53814 .33684 L .54015 .35031 L p F P
0 0 0 r
s
.09 .111 .237 r
.54015 .35031 m .51953 .35825 L .51856 .34446 L p F P
0 0 0 r
s
.24 .35 .67 r
.57319 .59424 m
.58914 .61054 L
s
.58914 .61054 m
.63098 .59772 L
s
.254 .371 .738 r
.43474 .58832 m .42568 .59129 L .40364 .57292 L p F P
0 0 0 r
s
.83 .24 .1 r
.38336 .58859 m
.40901 .59153 L
s
.276 .409 .807 r
.49974 .5911 m .50611 .58906 L .50305 .61114 L p F P
0 0 0 r
s
.83 .24 .1 r
.49862 .608 m
.50081 .61007 L
s
.276 .409 .807 r
.50624 .61014 m .50305 .61114 L .50611 .58906 L p F P
0 0 0 r
s
1 .312 .132 r
.51126 .61087 m .50944 .60913 L .51893 .58496 L p F P
0 0 0 r
s
1 .312 .132 r
.51893 .58496 m .52255 .58851 L .51126 .61087 L p F P
0 0 0 r
s
.24 .35 .67 r
.5194 .61104 m
.5319 .60714 L
s
.265 .39 .773 r
.43474 .58832 m .44386 .58534 L .46198 .60318 L p F P
0 0 0 r
s
.265 .39 .773 r
.46821 .60119 m .46198 .60318 L .44386 .58534 L p F P
0 0 0 r
s
.83 .24 .1 r
.46198 .61054 m
.4914 .60119 L
s
.158 .215 .442 r
.43805 .4074 m .45817 .39975 L .45832 .42102 L p F P
0 0 0 r
s
.24 .35 .67 r
.43806 .40864 m
.43924 .4082 L
s
.45818 .401 m
.45862 .40083 L
s
.158 .215 .442 r
.45832 .42102 m .43827 .42851 L .43805 .4074 L p F P
0 0 0 r
s
.242 .351 .701 r
.38415 .55261 m .39813 .54782 L .41533 .56901 L p F P
0 0 0 r
s
.242 .351 .701 r
.41533 .56901 m .40364 .57292 L .38415 .55261 L p F P
0 0 0 r
s
.24 .35 .67 r
.40376 .55476 m
.40477 .55441 L
s
.40477 .55441 m
.40657 .55822 L
s
1 .3 .122 r
.6031 .45843 m .61328 .47047 L .60669 .49397 L p F P
0 0 0 r
s
.83 .24 .1 r
.61083 .46757 m
.61193 .46365 L
s
1 .284 .114 r
.61328 .47047 m .6031 .45843 L .60633 .43539 L p F P
0 0 0 r
s
.276 .409 .807 r
.50611 .58906 m .51251 .58701 L .50624 .61014 L p F P
0 0 0 r
s
.276 .409 .807 r
.50944 .60913 m .50624 .61014 L .51251 .58701 L p F P
0 0 0 r
s
.83 .24 .1 r
.53639 .30235 m
.52107 .28689 L
s
.49773 .25776 m
.52107 .28689 L
s
1 .316 .133 r
.53681 .60251 m .53328 .59904 L .54923 .57912 L p F P
0 0 0 r
s
.83 .24 .1 r
.53706 .60204 m
.53717 .60214 L
s
1 .316 .133 r
.54923 .57912 m .55437 .58433 L .53681 .60251 L p F P
0 0 0 r
s
1 .316 .13 r
.59719 .51784 m .60591 .52759 L .59276 .54971 L p F P
0 0 0 r
s
1 .31 .127 r
.60591 .52759 m .59719 .51784 L .60669 .49397 L p F P
0 0 0 r
s
.254 .371 .738 r
.40364 .57292 m .41533 .56901 L .43474 .58832 L p F P
0 0 0 r
s
.127 .167 .35 r
.47903 .37387 m .49916 .36611 L .49914 .38417 L p F P
0 0 0 r
s
.127 .167 .35 r
.49914 .38417 m .47853 .392 L .47903 .37387 L p F P
0 0 0 r
s
.641 .167 .062 r
.58309 .36972 m .57217 .35613 L .56857 .34243 L p F P
0 0 0 r
s
.641 .167 .062 r
.55794 .32912 m .56857 .34243 L .57217 .35613 L p F P
0 0 0 r
s
.83 .24 .1 r
.56894 .35089 m
.57028 .35256 L
s
.56203 .3369 m
.56894 .35089 L
s
1 .319 .133 r
.55946 .58949 m .55437 .58433 L .57062 .56373 L p F P
0 0 0 r
s
1 .319 .133 r
.57062 .56373 m .57712 .57055 L .55946 .58949 L p F P
0 0 0 r
s
.276 .409 .807 r
.51251 .58701 m .51893 .58496 L .50944 .60913 L p F P
0 0 0 r
s
.83 .24 .1 r
.30823 .53356 m
.33545 .55711 L
s
.33545 .55711 m
.35729 .56583 L
s
.265 .39 .773 r
.44386 .58534 m .45302 .58234 L .46821 .60119 L p F P
0 0 0 r
s
.265 .39 .773 r
.47447 .59919 m .46821 .60119 L .45302 .58234 L p F P
0 0 0 r
s
.24 .35 .67 r
.47358 .59849 m
.47475 .59811 L
s
.83 .24 .1 r
.2075 .32191 m
.19544 .3496 L
s
.254 .371 .738 r
.44386 .58534 m .43474 .58832 L .41533 .56901 L p F P
0 0 0 r
s
.83 .24 .1 r
.46041 .60911 m
.46198 .61054 L
s
.24 .35 .67 r
.63602 .28451 m
.67854 .26777 L
s
.63602 .28451 m
.6299 .29548 L
s
.8377 .55592 m
.83037 .55878 L
s
.23 .33 .662 r
.38367 .5254 m .39971 .51977 L .41223 .54299 L p F P
0 0 0 r
s
.24 .35 .67 r
.38376 .52553 m
.38384 .5255 L
s
.23 .33 .662 r
.41223 .54299 m .39813 .54782 L .38367 .5254 L p F P
0 0 0 r
s
.24 .35 .67 r
.51537 .5851 m
.51597 .58591 L
s
.5319 .60714 m
.53456 .60631 L
s
1 .318 .132 r
.58504 .54134 m .59276 .54971 L .57712 .57055 L p F P
0 0 0 r
s
1 .316 .13 r
.59276 .54971 m .58504 .54134 L .59719 .51784 L p F P
0 0 0 r
s
.181 .252 .513 r
.41846 .43592 m .43827 .42851 L .44016 .45189 L p F P
0 0 0 r
s
.181 .252 .513 r
.44016 .45189 m .42094 .45894 L .41846 .43592 L p F P
0 0 0 r
s
1 .318 .132 r
.57712 .57055 m .57062 .56373 L .58504 .54134 L p F P
0 0 0 r
s
.83 .24 .1 r
.18856 .37662 m
.21827 .40341 L
s
.21827 .40341 m
.21748 .42855 L
s
1 .284 .114 r
.59565 .42249 m .60633 .43539 L .6031 .45843 L p F P
0 0 0 r
s
.939 .259 .102 r
.60633 .43539 m .59565 .42249 L .596 .40125 L p F P
0 0 0 r
s
.83 .24 .1 r
.59496 .40232 m
.59596 .40355 L
s
.265 .39 .773 r
.45302 .58234 m .46224 .57933 L .47447 .59919 L p F P
0 0 0 r
s
.83 .24 .1 r
.43744 .58814 m
.46041 .60911 L
s
.265 .39 .773 r
.48075 .59718 m .47447 .59919 L .46224 .57933 L p F P
0 0 0 r
s
1 .316 .133 r
.53328 .59904 m .52973 .59555 L .54404 .57386 L p F P
0 0 0 r
s
.24 .35 .67 r
.52323 .59559 m
.5319 .60714 L
s
.52148 .59325 m
.52323 .59559 L
s
.83 .24 .1 r
.5335 .59854 m
.5336 .59864 L
s
1 .316 .133 r
.54404 .57386 m .54923 .57912 L .53328 .59904 L p F P
0 0 0 r
s
.24 .35 .67 r
.40196 .54651 m
.40477 .55441 L
s
.216 .308 .619 r
.38992 .49613 m .40765 .48976 L .4159 .51409 L p F P
0 0 0 r
s
.216 .308 .619 r
.4159 .51409 m .39971 .51977 L .38992 .49613 L p F P
0 0 0 r
s
.2 .282 .57 r
.40193 .46591 m .42094 .45894 L .42558 .48333 L p F P
0 0 0 r
s
.2 .282 .57 r
.42558 .48333 m .40765 .48976 L .40193 .46591 L p F P
0 0 0 r
s
.813 .22 .084 r
.596 .40125 m .58506 .38782 L .58309 .36972 L p F P
0 0 0 r
s
.813 .22 .084 r
.57217 .35613 m .58309 .36972 L .58506 .38782 L p F P
0 0 0 r
s
.242 .351 .701 r
.4271 .56508 m .41533 .56901 L .39813 .54782 L p F P
0 0 0 r
s
.254 .371 .738 r
.41533 .56901 m .4271 .56508 L .44386 .58534 L p F P
0 0 0 r
s
.242 .351 .701 r
.39813 .54782 m .41223 .54299 L .4271 .56508 L p F P
0 0 0 r
s
.939 .259 .102 r
.58506 .38782 m .596 .40125 L .59565 .42249 L p F P
0 0 0 r
s
.254 .371 .738 r
.45302 .58234 m .44386 .58534 L .4271 .56508 L p F P
0 0 0 r
s
.09 .111 .237 r
.53814 .33684 m .55794 .32912 L .56101 .34227 L p F P
0 0 0 r
s
.09 .111 .237 r
.56101 .34227 m .54015 .35031 L .53814 .33684 L p F P
0 0 0 r
s
.265 .39 .773 r
.46224 .57933 m .47151 .5763 L .48075 .59718 L p F P
0 0 0 r
s
.265 .39 .773 r
.48706 .59516 m .48075 .59718 L .47151 .5763 L p F P
0 0 0 r
s
.83 .24 .1 r
.49773 .25776 m
.47791 .248 L
s
.45354 .2179 m
.47791 .248 L
s
1 .31 .127 r
.59705 .48287 m .60669 .49397 L .59719 .51784 L p F P
0 0 0 r
s
1 .3 .122 r
.60669 .49397 m .59705 .48287 L .6031 .45843 L p F P
0 0 0 r
s
.24 .35 .67 r
.67383 .58459 m
.68758 .59485 L
s
.68758 .59485 m
.73087 .58176 L
s
1 .319 .133 r
.55437 .58433 m .54923 .57912 L .56403 .55683 L p F P
0 0 0 r
s
1 .319 .133 r
.56403 .55683 m .57062 .56373 L .55437 .58433 L p F P
0 0 0 r
s
.158 .215 .442 r
.45817 .39975 m .47853 .392 L .47861 .41343 L p F P
0 0 0 r
s
.24 .35 .67 r
.45862 .40083 m
.45937 .40055 L
s
.158 .215 .442 r
.47861 .41343 m .45832 .42102 L .45817 .39975 L p F P
0 0 0 r
s
.24 .35 .67 r
.72208 .25064 m
.72919 .24707 L
s
.83 .24 .1 r
.26303 .49508 m
.29131 .51954 L
s
.29131 .51954 m
.30823 .53356 L
s
.127 .167 .35 r
.49916 .36611 m .51953 .35825 L .52 .37624 L p F P
0 0 0 r
s
.127 .167 .35 r
.52 .37624 m .49914 .38417 L .49916 .36611 L p F P
0 0 0 r
s
.24 .35 .67 r
.49915 .38544 m
.49925 .38413 L
s
1 .316 .133 r
.52973 .59555 m .52615 .59205 L .5388 .56855 L p F P
0 0 0 r
s
.83 .24 .1 r
.52991 .59501 m
.53002 .59512 L
s
1 .316 .133 r
.5388 .56855 m .54404 .57386 L .52973 .59555 L p F P
0 0 0 r
s
.24 .35 .67 r
.53456 .60631 m
.57319 .59424 L
s
.265 .39 .773 r
.47151 .5763 m .48082 .57326 L .48706 .59516 L p F P
0 0 0 r
s
.265 .39 .773 r
.49338 .59313 m .48706 .59516 L .48082 .57326 L p F P
0 0 0 r
s
.23 .33 .662 r
.39971 .51977 m .4159 .51409 L .42645 .53812 L p F P
0 0 0 r
s
.24 .35 .67 r
.39979 .51991 m
.39987 .51988 L
s
.23 .33 .662 r
.42645 .53812 m .41223 .54299 L .39971 .51977 L p F P
0 0 0 r
s
.83 .24 .1 r
.37837 .18565 m
.35064 .19352 L
s
.254 .371 .738 r
.4271 .56508 m .43895 .56111 L .45302 .58234 L p F P
0 0 0 r
s
.254 .371 .738 r
.46224 .57933 m .45302 .58234 L .43895 .56111 L p F P
0 0 0 r
s
.242 .351 .701 r
.43895 .56111 m .4271 .56508 L .41223 .54299 L p F P
0 0 0 r
s
.83 .24 .1 r
.4914 .60119 m
.50676 .59315 L
s
.50676 .59315 m
.50986 .59152 L
s
.242 .351 .701 r
.41223 .54299 m .42645 .53812 L .43895 .56111 L p F P
0 0 0 r
s
.83 .24 .1 r
.38313 .56852 m
.40901 .59153 L
s
.40901 .59153 m
.43744 .58814 L
s
.181 .252 .513 r
.43827 .42851 m .45832 .42102 L .4596 .44476 L p F P
0 0 0 r
s
.181 .252 .513 r
.4596 .44476 m .44016 .45189 L .43827 .42851 L p F P
0 0 0 r
s
1 .316 .13 r
.58833 .50793 m .59719 .51784 L .58504 .54134 L p F P
0 0 0 r
s
1 .31 .127 r
.59719 .51784 m .58833 .50793 L .59705 .48287 L p F P
0 0 0 r
s
1 .318 .132 r
.57062 .56373 m .56403 .55683 L .57721 .53285 L p F P
0 0 0 r
s
1 .318 .132 r
.57721 .53285 m .58504 .54134 L .57062 .56373 L p F P
0 0 0 r
s
.24 .35 .67 r
.58767 .312 m
.6299 .29548 L
s
.58767 .312 m
.58378 .32975 L
s
.265 .39 .773 r
.48082 .57326 m .49019 .57019 L .49338 .59313 L p F P
0 0 0 r
s
.265 .39 .773 r
.49974 .5911 m .49338 .59313 L .49019 .57019 L p F P
0 0 0 r
s
.216 .308 .619 r
.40765 .48976 m .42558 .48333 L .43226 .50835 L p F P
0 0 0 r
s
.216 .308 .619 r
.43226 .50835 m .4159 .51409 L .40765 .48976 L p F P
0 0 0 r
s
.2 .282 .57 r
.42094 .45894 m .44016 .45189 L .44369 .47683 L p F P
0 0 0 r
s
.2 .282 .57 r
.44369 .47683 m .42558 .48333 L .42094 .45894 L p F P
0 0 0 r
s
1 .316 .13 r
.58504 .54134 m .57721 .53285 L .58833 .50793 L p F P
0 0 0 r
s
1 .316 .133 r
.52615 .59205 m .52255 .58851 L .53352 .56319 L p F P
0 0 0 r
s
.83 .24 .1 r
.5263 .59147 m
.52641 .59157 L
s
1 .316 .133 r
.53352 .56319 m .5388 .56855 L .52615 .59205 L p F P
0 0 0 r
s
1 .3 .122 r
.59271 .44616 m .6031 .45843 L .59705 .48287 L p F P
0 0 0 r
s
1 .284 .114 r
.6031 .45843 m .59271 .44616 L .59565 .42249 L p F P
0 0 0 r
s
.254 .371 .738 r
.43895 .56111 m .45089 .55712 L .46224 .57933 L p F P
0 0 0 r
s
.254 .371 .738 r
.47151 .5763 m .46224 .57933 L .45089 .55712 L p F P
0 0 0 r
s
.83 .24 .1 r
.46726 .5784 m
.48986 .59973 L
s
.48986 .59973 m
.4914 .60119 L
s
.24 .35 .67 r
.7752 .56836 m
.7857 .5722 L
s
.7857 .5722 m
.83037 .55878 L
s
1 .319 .133 r
.54923 .57912 m .54404 .57386 L .55737 .54984 L p F P
0 0 0 r
s
1 .319 .133 r
.55737 .54984 m .56403 .55683 L .54923 .57912 L p F P
0 0 0 r
s
.83 .24 .1 r
.54636 .3228 m
.55747 .33662 L
s
.641 .167 .062 r
.57217 .35613 m .56101 .34227 L .55794 .32912 L p F P
0 0 0 r
s
.83 .24 .1 r
.55747 .33662 m
.5589 .3384 L
s
.265 .39 .773 r
.49019 .57019 m .49961 .56712 L .49974 .5911 L p F P
0 0 0 r
s
.265 .39 .773 r
.50611 .58906 m .49974 .5911 L .49961 .56712 L p F P
0 0 0 r
s
.24 .35 .67 r
.61549 .58103 m
.63098 .59772 L
s
.63098 .59772 m
.67383 .58459 L
s
.242 .351 .701 r
.45089 .55712 m .43895 .56111 L .42645 .53812 L p F P
0 0 0 r
s
.83 .24 .1 r
.45354 .2179 m
.43008 .2142 L
s
.40456 .18321 m
.43008 .2142 L
s
.22255 .45096 m
.2518 .47645 L
s
.2518 .47645 m
.26303 .49508 L
s
.19544 .3496 m
.18856 .37662 L
s
.158 .215 .442 r
.47853 .392 m .49914 .38417 L .49914 .40575 L p F P
0 0 0 r
s
.24 .35 .67 r
.47854 .39327 m
.47974 .39281 L
s
.49914 .38544 m
.49915 .38544 L
s
.158 .215 .442 r
.49914 .40575 m .47861 .41343 L .47853 .392 L p F P
0 0 0 r
s
.23 .33 .662 r
.4159 .51409 m .43226 .50835 L .44078 .53321 L p F P
0 0 0 r
s
.24 .35 .67 r
.41597 .51423 m
.41605 .5142 L
s
.23 .33 .662 r
.44078 .53321 m .42645 .53812 L .4159 .51409 L p F P
0 0 0 r
s
.127 .167 .35 r
.51953 .35825 m .54015 .35031 L .54111 .36821 L p F P
0 0 0 r
s
.127 .167 .35 r
.54111 .36821 m .52 .37624 L .51953 .35825 L p F P
0 0 0 r
s
.265 .39 .773 r
.49961 .56712 m .50908 .56402 L .50611 .58906 L p F P
0 0 0 r
s
.265 .39 .773 r
.51251 .58701 m .50611 .58906 L .50908 .56402 L p F P
0 0 0 r
s
.24 .35 .67 r
.51237 .58607 m
.51537 .5851 L
s
.242 .351 .701 r
.42645 .53812 m .44078 .53321 L .45089 .55712 L p F P
0 0 0 r
s
.254 .371 .738 r
.45089 .55712 m .46291 .55309 L .47151 .5763 L p F P
0 0 0 r
s
.254 .371 .738 r
.48082 .57326 m .47151 .5763 L .46291 .55309 L p F P
0 0 0 r
s
1 .316 .133 r
.52255 .58851 m .51893 .58496 L .52818 .55777 L p F P
0 0 0 r
s
.83 .24 .1 r
.52267 .5879 m
.52277 .58801 L
s
1 .316 .133 r
.52818 .55777 m .53352 .56319 L .52255 .58851 L p F P
0 0 0 r
s
1 .284 .114 r
.58475 .40933 m .59565 .42249 L .59271 .44616 L p F P
0 0 0 r
s
.83 .24 .1 r
.59367 .4201 m
.59391 .41679 L
s
.939 .259 .102 r
.59565 .42249 m .58475 .40933 L .58506 .38782 L p F P
0 0 0 r
s
.24 .35 .67 r
.67854 .26777 m
.72208 .25064 L
s
.67854 .26777 m
.67316 .27856 L
s
.5606 .33871 m
.58378 .32975 L
s
.813 .22 .084 r
.58506 .38782 m .57389 .3741 L .57217 .35613 L p F P
0 0 0 r
s
.813 .22 .084 r
.56101 .34227 m .57217 .35613 L .57389 .3741 L p F P
0 0 0 r
s
.83 .24 .1 r
.5721 .36966 m
.57307 .37549 L
s
.24 .35 .67 r
.57319 .59424 m
.61549 .58103 L
s
.216 .308 .619 r
.42558 .48333 m .44369 .47683 L .44877 .50255 L p F P
0 0 0 r
s
.216 .308 .619 r
.44877 .50255 m .43226 .50835 L .42558 .48333 L p F P
0 0 0 r
s
.24 .35 .67 r
.43296 .5081 m
.433 .50826 L
s
.43231 .5085 m
.433 .50826 L
s
.265 .39 .773 r
.50908 .56402 m .5186 .56091 L .51251 .58701 L p F P
0 0 0 r
s
.265 .39 .773 r
.51893 .58496 m .51251 .58701 L .5186 .56091 L p F P
0 0 0 r
s
.83 .24 .1 r
.51892 .58422 m
.51912 .58442 L
s
.5152 .58057 m
.51658 .58192 L
s
.24 .35 .67 r
.51892 .58397 m
.51931 .58384 L
s
.181 .252 .513 r
.45832 .42102 m .47861 .41343 L .47927 .43754 L p F P
0 0 0 r
s
.181 .252 .513 r
.47927 .43754 m .4596 .44476 L .45832 .42102 L p F P
0 0 0 r
s
.242 .351 .701 r
.46291 .55309 m .45089 .55712 L .44078 .53321 L p F P
0 0 0 r
s
1 .31 .127 r
.58722 .47155 m .59705 .48287 L .58833 .50793 L p F P
0 0 0 r
s
1 .3 .122 r
.59705 .48287 m .58722 .47155 L .59271 .44616 L p F P
0 0 0 r
s
.939 .259 .102 r
.57389 .3741 m .58506 .38782 L .58475 .40933 L p F P
0 0 0 r
s
1 .318 .132 r
.56403 .55683 m .55737 .54984 L .56926 .52424 L p F P
0 0 0 r
s
1 .318 .132 r
.56926 .52424 m .57721 .53285 L .56403 .55683 L p F P
0 0 0 r
s
1 .319 .133 r
.54404 .57386 m .5388 .56855 L .55062 .54277 L p F P
0 0 0 r
s
1 .319 .133 r
.55062 .54277 m .55737 .54984 L .54404 .57386 L p F P
0 0 0 r
s
.24 .35 .67 r
.5283 .58096 m
.55697 .57178 L
s
.55697 .57178 m
.57319 .59424 L
s
.2 .282 .57 r
.44016 .45189 m .4596 .44476 L .462 .47025 L p F P
0 0 0 r
s
.2 .282 .57 r
.462 .47025 m .44369 .47683 L .44016 .45189 L p F P
0 0 0 r
s
.24 .35 .67 r
.433 .50826 m
.44239 .53465 L
s
.254 .371 .738 r
.46291 .55309 m .47502 .54904 L .48082 .57326 L p F P
0 0 0 r
s
.254 .371 .738 r
.49019 .57019 m .48082 .57326 L .47502 .54904 L p F P
0 0 0 r
s
.83 .24 .1 r
.54636 .3228 m
.53639 .30235 L
s
.513 .27307 m
.53639 .30235 L
s
.33011 .54211 m
.35729 .56583 L
s
.35729 .56583 m
.38313 .56852 L
s
.265 .39 .773 r
.5186 .56091 m .52818 .55777 L .51893 .58496 L p F P
0 0 0 r
s
.24 .35 .67 r
.52252 .58281 m
.52495 .58204 L
s
.52495 .58204 m
.5283 .58096 L
s
.83 .24 .1 r
.18734 .40191 m
.21748 .42855 L
s
.21748 .42855 m
.22255 .45096 L
s
.23 .33 .662 r
.43226 .50835 m .44877 .50255 L .45525 .52825 L p F P
0 0 0 r
s
.23 .33 .662 r
.45525 .52825 m .44078 .53321 L .43226 .50835 L p F P
0 0 0 r
s
.242 .351 .701 r
.44078 .53321 m .45525 .52825 L .46291 .55309 L p F P
0 0 0 r
s
1 .316 .13 r
.57932 .49786 m .58833 .50793 L .57721 .53285 L p F P
0 0 0 r
s
1 .31 .127 r
.58833 .50793 m .57932 .49786 L .58722 .47155 L p F P
0 0 0 r
s
1 .316 .13 r
.57721 .53285 m .56926 .52424 L .57932 .49786 L p F P
0 0 0 r
s
.24 .35 .67 r
.71773 .57115 m
.73087 .58176 L
s
.73087 .58176 m
.7752 .56836 L
s
.158 .215 .442 r
.49914 .38417 m .52 .37624 L .51993 .39798 L p F P
0 0 0 r
s
.24 .35 .67 r
.49915 .38544 m
.50036 .38498 L
s
.158 .215 .442 r
.51993 .39798 m .49914 .40575 L .49914 .38417 L p F P
0 0 0 r
s
.242 .351 .701 r
.47502 .54904 m .46291 .55309 L .45525 .52825 L p F P
0 0 0 r
s
.254 .371 .738 r
.47502 .54904 m .48721 .54496 L .49019 .57019 L p F P
0 0 0 r
s
.254 .371 .738 r
.49961 .56712 m .49019 .57019 L .48721 .54496 L p F P
0 0 0 r
s
.83 .24 .1 r
.5133 .57871 m
.5152 .58057 L
s
.127 .167 .35 r
.54015 .35031 m .56101 .34227 L .56248 .36009 L p F P
0 0 0 r
s
.127 .167 .35 r
.56248 .36009 m .54111 .36821 L .54015 .35031 L p F P
0 0 0 r
s
.83 .24 .1 r
.40456 .18321 m
.37837 .18565 L
s
.216 .308 .619 r
.44369 .47683 m .462 .47025 L .46544 .4967 L p F P
0 0 0 r
s
.216 .308 .619 r
.46544 .4967 m .44877 .50255 L .44369 .47683 L p F P
0 0 0 r
s
1 .319 .133 r
.5388 .56855 m .53352 .56319 L .54378 .5356 L p F P
0 0 0 r
s
1 .319 .133 r
.54378 .5356 m .55062 .54277 L .5388 .56855 L p F P
0 0 0 r
s
.83 .24 .1 r
.41185 .5648 m
.43744 .58814 L
s
.43744 .58814 m
.46726 .5784 L
s
1 .3 .122 r
.58212 .43364 m .59271 .44616 L .58722 .47155 L p F P
0 0 0 r
s
1 .284 .114 r
.59271 .44616 m .58212 .43364 L .58475 .40933 L p F P
0 0 0 r
s
.181 .252 .513 r
.47861 .41343 m .49914 .40575 L .49917 .43024 L p F P
0 0 0 r
s
.181 .252 .513 r
.49917 .43024 m .47927 .43754 L .47861 .41343 L p F P
0 0 0 r
s
.24 .35 .67 r
.6299 .29548 m
.67316 .27856 L
s
.6299 .29548 m
.6267 .31316 L
s
.83 .24 .1 r
.513 .27307 m
.49773 .25776 L
s
.47339 .22739 m
.49773 .25776 L
s
.254 .371 .738 r
.48721 .54496 m .49949 .54086 L .49961 .56712 L p F P
0 0 0 r
s
.254 .371 .738 r
.50908 .56402 m .49961 .56712 L .49949 .54086 L p F P
0 0 0 r
s
.2 .282 .57 r
.4596 .44476 m .47927 .43754 L .48051 .46361 L p F P
0 0 0 r
s
.2 .282 .57 r
.48051 .46361 m .462 .47025 L .4596 .44476 L p F P
0 0 0 r
s
1 .318 .132 r
.55737 .54984 m .55062 .54277 L .56119 .51549 L p F P
0 0 0 r
s
1 .318 .132 r
.56119 .51549 m .56926 .52424 L .55737 .54984 L p F P
0 0 0 r
s
.23 .33 .662 r
.46983 .52325 m .45525 .52825 L .44877 .50255 L p F P
0 0 0 r
s
.242 .351 .701 r
.45525 .52825 m .46983 .52325 L .47502 .54904 L p F P
0 0 0 r
s
.23 .33 .662 r
.44877 .50255 m .46544 .4967 L .46983 .52325 L p F P
0 0 0 r
s
.242 .351 .701 r
.48721 .54496 m .47502 .54904 L .46983 .52325 L p F P
0 0 0 r
s
.83 .24 .1 r
.27985 .50901 m
.30823 .53356 L
s
.30823 .53356 m
.33011 .54211 L
s
.24 .35 .67 r
.83037 .55878 m
.82062 .55462 L
s
.65881 .5675 m
.67383 .58459 L
s
.67383 .58459 m
.71773 .57115 L
s
.83 .24 .1 r
.18856 .37662 m
.18734 .40191 L
s
1 .284 .114 r
.57362 .39588 m .58475 .40933 L .58212 .43364 L p F P
0 0 0 r
s
.939 .259 .102 r
.58475 .40933 m .57362 .39588 L .57389 .3741 L p F P
0 0 0 r
s
.83 .24 .1 r
.57307 .37549 m
.57386 .37645 L
s
.158 .215 .442 r
.52 .37624 m .54111 .36821 L .54096 .39012 L p F P
0 0 0 r
s
.24 .35 .67 r
.51999 .37752 m
.52123 .37705 L
s
.158 .215 .442 r
.54096 .39012 m .51993 .39798 L .52 .37624 L p F P
0 0 0 r
s
.254 .371 .738 r
.49949 .54086 m .51186 .53672 L .50908 .56402 L p F P
0 0 0 r
s
.254 .371 .738 r
.5186 .56091 m .50908 .56402 L .51186 .53672 L p F P
0 0 0 r
s
.83 .24 .1 r
.49695 .56264 m
.5133 .57871 L
s
1 .31 .127 r
.57721 .46002 m .58722 .47155 L .57932 .49786 L p F P
0 0 0 r
s
1 .3 .122 r
.58722 .47155 m .57721 .46002 L .58212 .43364 L p F P
0 0 0 r
s
.83 .24 .1 r
.55026 .34751 m
.55893 .35815 L
s
.813 .22 .084 r
.57389 .3741 m .56248 .36009 L .56101 .34227 L p F P
0 0 0 r
s
1 .319 .133 r
.53352 .56319 m .52818 .55777 L .53686 .52835 L p F P
0 0 0 r
s
1 .319 .133 r
.53686 .52835 m .54378 .5356 L .53352 .56319 L p F P
0 0 0 r
s
1 .316 .13 r
.56926 .52424 m .56119 .51549 L .57016 .4876 L p F P
0 0 0 r
s
1 .316 .13 r
.57016 .4876 m .57932 .49786 L .56926 .52424 L p F P
0 0 0 r
s
.216 .308 .619 r
.462 .47025 m .48051 .46361 L .48228 .49079 L p F P
0 0 0 r
s
.216 .308 .619 r
.48228 .49079 m .46544 .4967 L .462 .47025 L p F P
0 0 0 r
s
.242 .351 .701 r
.46983 .52325 m .48454 .51821 L .48721 .54496 L p F P
0 0 0 r
s
.242 .351 .701 r
.49949 .54086 m .48721 .54496 L .48454 .51821 L p F P
0 0 0 r
s
.939 .259 .102 r
.56248 .36009 m .57389 .3741 L .57362 .39588 L p F P
0 0 0 r
s
.23 .33 .662 r
.48454 .51821 m .46983 .52325 L .46544 .4967 L p F P
0 0 0 r
s
1 .31 .127 r
.57932 .49786 m .57016 .4876 L .57721 .46002 L p F P
0 0 0 r
s
.24 .35 .67 r
.71749 .26123 m
.72208 .25064 L
s
.83 .24 .1 r
.47339 .22739 m
.45354 .2179 L
s
.42814 .18652 m
.45354 .2179 L
s
.24 .35 .67 r
.58378 .32975 m
.6267 .31316 L
s
.58378 .32975 m
.58317 .35352 L
s
.59959 .55814 m
.61549 .58103 L
s
.61549 .58103 m
.65881 .5675 L
s
.54134 .54416 m
.55697 .57178 L
s
.55697 .57178 m
.59959 .55814 L
s
.181 .252 .513 r
.49914 .40575 m .51993 .39798 L .5193 .42286 L p F P
0 0 0 r
s
.181 .252 .513 r
.5193 .42286 m .49917 .43024 L .49914 .40575 L p F P
0 0 0 r
s
.254 .371 .738 r
.51186 .53672 m .52432 .53255 L .5186 .56091 L p F P
0 0 0 r
s
.254 .371 .738 r
.52818 .55777 m .5186 .56091 L .52432 .53255 L p F P
0 0 0 r
s
.23 .33 .662 r
.46544 .4967 m .48228 .49079 L .48454 .51821 L p F P
0 0 0 r
s
.2 .282 .57 r
.47927 .43754 m .49917 .43024 L .49922 .45689 L p F P
0 0 0 r
s
.2 .282 .57 r
.49922 .45689 m .48051 .46361 L .47927 .43754 L p F P
0 0 0 r
s
.83 .24 .1 r
.23354 .46958 m
.26303 .49508 L
s
.26303 .49508 m
.27985 .50901 L
s
1 .318 .132 r
.55062 .54277 m .54378 .5356 L .553 .50662 L p F P
0 0 0 r
s
1 .318 .132 r
.553 .50662 m .56119 .51549 L .55062 .54277 L p F P
0 0 0 r
s
.83 .24 .1 r
.44208 .55464 m
.46726 .5784 L
s
.46726 .5784 m
.49695 .56264 L
s
.242 .351 .701 r
.48454 .51821 m .49938 .51313 L .49949 .54086 L p F P
0 0 0 r
s
.242 .351 .701 r
.51186 .53672 m .49949 .54086 L .49938 .51313 L p F P
0 0 0 r
s
.83 .24 .1 r
.35614 .54453 m
.38313 .56852 L
s
.38313 .56852 m
.41185 .5648 L
s
.254 .371 .738 r
.52432 .53255 m .53686 .52835 L .52818 .55777 L p F P
0 0 0 r
s
.83 .24 .1 r
.52492 .54161 m
.52747 .54422 L
s
.52747 .54422 m
.52965 .54646 L
s
.24 .35 .67 r
.53287 .54696 m
.53679 .54566 L
s
.53679 .54566 m
.54134 .54416 L
s
.7627 .55737 m
.7752 .56836 L
s
.7752 .56836 m
.82062 .55462 L
s
.23 .33 .662 r
.49938 .51313 m .48454 .51821 L .48228 .49079 L p F P
0 0 0 r
s
.158 .215 .442 r
.54111 .36821 m .56248 .36009 L .56225 .38215 L p F P
0 0 0 r
s
.24 .35 .67 r
.5411 .36951 m
.54235 .36903 L
s
.83 .24 .1 r
.55893 .35815 m
.56098 .36066 L
s
.158 .215 .442 r
.56225 .38215 m .54096 .39012 L .54111 .36821 L p F P
0 0 0 r
s
1 .3 .122 r
.57131 .42087 m .58212 .43364 L .57721 .46002 L p F P
0 0 0 r
s
1 .284 .114 r
.58212 .43364 m .57131 .42087 L .57362 .39588 L p F P
0 0 0 r
s
.216 .308 .619 r
.48051 .46361 m .49922 .45689 L .49929 .48483 L p F P
0 0 0 r
s
.216 .308 .619 r
.49929 .48483 m .48228 .49079 L .48051 .46361 L p F P
0 0 0 r
s
.83 .24 .1 r
.54636 .3228 m
.55026 .34751 L
s
.52282 .2935 m
.54636 .3228 L
s
.23 .33 .662 r
.48228 .49079 m .49929 .48483 L .49938 .51313 L p F P
0 0 0 r
s
.83 .24 .1 r
.42814 .18652 m
.40456 .18321 L
s
.19204 .42439 m
.22255 .45096 L
s
.22255 .45096 m
.23354 .46958 L
s
1 .316 .13 r
.56119 .51549 m .553 .50662 L .56083 .47717 L p F P
0 0 0 r
s
1 .316 .13 r
.56083 .47717 m .57016 .4876 L .56119 .51549 L p F P
0 0 0 r
s
.181 .252 .513 r
.51993 .39798 m .54096 .39012 L .53967 .41539 L p F P
0 0 0 r
s
.181 .252 .513 r
.53967 .41539 m .5193 .42286 L .51993 .39798 L p F P
0 0 0 r
s
.242 .351 .701 r
.49938 .51313 m .51435 .508 L .51186 .53672 L p F P
0 0 0 r
s
.242 .351 .701 r
.52432 .53255 m .51186 .53672 L .51435 .508 L p F P
0 0 0 r
s
.2 .282 .57 r
.49917 .43024 m .5193 .42286 L .51814 .4501 L p F P
0 0 0 r
s
.2 .282 .57 r
.51814 .4501 m .49922 .45689 L .49917 .43024 L p F P
0 0 0 r
s
.24 .35 .67 r
.67316 .27856 m
.71749 .26123 L
s
.67316 .27856 m
.67069 .29616 L
s
1 .318 .132 r
.54378 .5356 m .53686 .52835 L .54468 .49761 L p F P
0 0 0 r
s
1 .318 .132 r
.54468 .49761 m .553 .50662 L .54378 .5356 L p F P
0 0 0 r
s
1 .31 .127 r
.56701 .44826 m .57721 .46002 L .57016 .4876 L p F P
0 0 0 r
s
1 .3 .122 r
.57721 .46002 m .56701 .44826 L .57131 .42087 L p F P
0 0 0 r
s
1 .284 .114 r
.56225 .38215 m .57362 .39588 L .57131 .42087 L p F P
0 0 0 r
s
.83 .24 .1 r
.57159 .39343 m
.57185 .39021 L
s
.939 .259 .102 r
.57362 .39588 m .56225 .38215 L .56248 .36009 L p F P
0 0 0 r
s
.24 .35 .67 r
.56329 .36108 m
.58317 .35352 L
s
.23 .33 .662 r
.51435 .508 m .49938 .51313 L .49929 .48483 L p F P
0 0 0 r
s
1 .31 .127 r
.57016 .4876 m .56083 .47717 L .56701 .44826 L p F P
0 0 0 r
s
.83 .24 .1 r
.47225 .5384 m
.49695 .56264 L
s
.49695 .56264 m
.52492 .54161 L
s
.24 .35 .67 r
.53792 .53658 m
.54134 .54416 L
s
.5373 .53521 m
.53792 .53658 L
s
.54134 .54416 m
.58414 .53006 L
s
.7032 .55363 m
.71773 .57115 L
s
.71773 .57115 m
.7627 .55737 L
s
.216 .308 .619 r
.49922 .45689 m .51814 .4501 L .51647 .4788 L p F P
0 0 0 r
s
.216 .308 .619 r
.51647 .4788 m .49929 .48483 L .49922 .45689 L p F P
0 0 0 r
s
.242 .351 .701 r
.51435 .508 m .52945 .50282 L .52432 .53255 L p F P
0 0 0 r
s
.242 .351 .701 r
.53686 .52835 m .52432 .53255 L .52945 .50282 L p F P
0 0 0 r
s
.23 .33 .662 r
.49929 .48483 m .51647 .4788 L .51435 .508 L p F P
0 0 0 r
s
.83 .24 .1 r
.52492 .54161 m
.53201 .53438 L
s
.52282 .2935 m
.513 .27307 L
s
.4886 .24253 m
.513 .27307 L
s
.30177 .51737 m
.33011 .54211 L
s
.33011 .54211 m
.35614 .54453 L
s
.50077 .51684 m
.52492 .54161 L
s
.18734 .40191 m
.19204 .42439 L
s
.24 .35 .67 r
.6267 .31316 m
.67069 .29616 L
s
.6267 .31316 m
.62675 .33698 L
s
.64326 .54415 m
.65881 .5675 L
s
.65881 .5675 m
.7032 .55363 L
s
.2 .282 .57 r
.5193 .42286 m .53967 .41539 L .53726 .44323 L p F P
0 0 0 r
s
.2 .282 .57 r
.53726 .44323 m .51814 .4501 L .5193 .42286 L p F P
0 0 0 r
s
.23 .33 .662 r
.52945 .50282 m .51435 .508 L .51647 .4788 L p F P
0 0 0 r
s
.24 .35 .67 r
.58414 .53006 m
.59959 .55814 L
s
.59959 .55814 m
.64326 .54415 L
s
.181 .252 .513 r
.54096 .39012 m .56225 .38215 L .56028 .40783 L p F P
0 0 0 r
s
.83 .24 .1 r
.54762 .37546 m
.55983 .39008 L
s
.181 .252 .513 r
.56028 .40783 m .53967 .41539 L .54096 .39012 L p F P
0 0 0 r
s
1 .316 .13 r
.553 .50662 m .54468 .49761 L .55134 .46656 L p F P
0 0 0 r
s
1 .316 .13 r
.55134 .46656 m .56083 .47717 L .553 .50662 L p F P
0 0 0 r
s
.24 .35 .67 r
.54477 .50681 m
.57001 .49823 L
s
.242 .351 .701 r
.52945 .50282 m .54468 .49761 L .53686 .52835 L p F P
0 0 0 r
s
.24 .35 .67 r
.5434 .50728 m
.54477 .50681 L
s
.83 .24 .1 r
.54004 .50605 m
.54079 .50686 L
s
1 .3 .122 r
.56028 .40783 m .57131 .42087 L .56701 .44826 L p F P
0 0 0 r
s
1 .284 .114 r
.57131 .42087 m .56028 .40783 L .56225 .38215 L p F P
0 0 0 r
s
.83 .24 .1 r
.55983 .39008 m
.56048 .39086 L
s
.24 .35 .67 r
.56222 .39117 m
.58604 .38232 L
s
.83 .24 .1 r
.38516 .54044 m
.41185 .5648 L
s
.41185 .5648 m
.44208 .55464 L
s
.24 .35 .67 r
.58317 .35352 m
.62675 .33698 L
s
.58317 .35352 m
.58604 .38232 L
s
.216 .308 .619 r
.51814 .4501 m .53726 .44323 L .53382 .47271 L p F P
0 0 0 r
s
.216 .308 .619 r
.53382 .47271 m .51647 .4788 L .51814 .4501 L p F P
0 0 0 r
s
.23 .33 .662 r
.51647 .4788 m .53382 .47271 L .52945 .50282 L p F P
0 0 0 r
s
.24 .35 .67 r
.82062 .55462 m
.80879 .54325 L
s
.83 .24 .1 r
.4886 .24253 m
.47339 .22739 L
s
.44801 .1957 m
.47339 .22739 L
s
.25025 .4834 m
.27985 .50901 L
s
.27985 .50901 m
.30177 .51737 L
s
.23 .33 .662 r
.54468 .49761 m .52945 .50282 L .53382 .47271 L p F P
0 0 0 r
s
1 .31 .127 r
.56083 .47717 m .55134 .46656 L .55661 .43629 L p F P
0 0 0 r
s
1 .31 .127 r
.55661 .43629 m .56701 .44826 L .56083 .47717 L p F P
0 0 0 r
s
1 .3 .122 r
.56701 .44826 m .55661 .43629 L .56028 .40783 L p F P
0 0 0 r
s
.2 .282 .57 r
.53967 .41539 m .56028 .40783 L .55661 .43629 L p F P
0 0 0 r
s
.2 .282 .57 r
.55661 .43629 m .53726 .44323 L .53967 .41539 L p F P
0 0 0 r
s
.24 .35 .67 r
.71578 .27873 m
.71749 .26123 L
s
.83 .24 .1 r
.55026 .34751 m
.52645 .31832 L
s
.54762 .37546 m
.55026 .34751 L
s
.216 .308 .619 r
.55134 .46656 m .53382 .47271 L .53726 .44323 L p F P
0 0 0 r
s
.23 .33 .662 r
.53382 .47271 m .55134 .46656 L .54468 .49761 L p F P
0 0 0 r
s
.83 .24 .1 r
.52607 .49109 m
.54004 .50605 L
s
.53835 .40532 m
.55671 .42663 L
s
.216 .308 .619 r
.53726 .44323 m .55661 .43629 L .55134 .46656 L p F P
0 0 0 r
s
.83 .24 .1 r
.54681 .46252 m
.55178 .45271 L
s
.54681 .46252 m
.54979 .46586 L
s
.24 .35 .67 r
.55276 .46624 m
.55803 .46439 L
s
.55254 .46632 m
.55276 .46624 L
s
.83 .24 .1 r
.44801 .1957 m
.42814 .18652 L
s
.24 .35 .67 r
.57001 .49823 m
.58414 .53006 L
s
.58414 .53006 m
.628 .5156 L
s
.74871 .53942 m
.7627 .55737 L
s
.7627 .55737 m
.80879 .54325 L
s
.83 .24 .1 r
.20276 .44297 m
.23354 .46958 L
s
.23354 .46958 m
.25025 .4834 L
s
.24 .35 .67 r
.55855 .42695 m
.59233 .41474 L
s
.55502 .45325 m
.55803 .46439 L
s
.83 .24 .1 r
.4158 .52984 m
.44208 .55464 L
s
.44208 .55464 m
.47225 .5384 L
s
.24 .35 .67 r
.67069 .29616 m
.71578 .27873 L
s
.67069 .29616 m
.67141 .32001 L
s
.83 .24 .1 r
.32796 .51949 m
.35614 .54453 L
s
.35614 .54453 m
.38516 .54044 L
s
.24 .35 .67 r
.68802 .52982 m
.7032 .55363 L
s
.7032 .55363 m
.74871 .53942 L
s
.628 .5156 m
.64326 .54415 L
s
.64326 .54415 m
.68802 .52982 L
s
.55803 .46439 m
.57001 .49823 L
s
.57001 .49823 m
.61391 .4833 L
s
.55803 .46439 m
.60179 .44904 L
s
.83 .24 .1 r
.52645 .31832 m
.52282 .2935 L
s
.49824 .26292 m
.52282 .2935 L
s
.24 .35 .67 r
.58604 .38232 m
.63017 .36593 L
s
.58604 .38232 m
.59233 .41474 L
s
.62675 .33698 m
.67141 .32001 L
s
.62675 .33698 m
.63017 .36593 L
s
.83 .24 .1 r
.19204 .42439 m
.20276 .44297 L
s
.52607 .49109 m
.54681 .46252 L
s
.52272 .4356 m
.54681 .46252 L
s
.44648 .51309 m
.47225 .5384 L
s
.47225 .5384 m
.50077 .51684 L
s
.50077 .51684 m
.52607 .49109 L
s
.50142 .46468 m
.52607 .49109 L
s
.53835 .40532 m
.54762 .37546 L
s
.52345 .3465 m
.54762 .37546 L
s
.49824 .26292 m
.4886 .24253 L
s
.46312 .21065 m
.4886 .24253 L
s
.27218 .49153 m
.30177 .51737 L
s
.30177 .51737 m
.32796 .51949 L
s
.47555 .49099 m
.50077 .51684 L
s
.24 .35 .67 r
.61391 .4833 m
.628 .5156 L
s
.628 .5156 m
.67297 .50078 L
s
.80879 .54325 m
.79536 .52485 L
s
.59233 .41474 m
.63691 .39862 L
s
.59233 .41474 m
.60179 .44904 L
s
.83 .24 .1 r
.35729 .51501 m
.38516 .54044 L
s
.38516 .54044 m
.4158 .52984 L
s
.24 .35 .67 r
.71721 .30262 m
.71578 .27873 L
s
.73391 .51512 m
.74871 .53942 L
s
.74871 .53942 m
.79536 .52485 L
s
.67297 .50078 m
.68802 .52982 L
s
.68802 .52982 m
.73391 .51512 L
s
.83 .24 .1 r
.46312 .21065 m
.44801 .1957 L
s
.21933 .45665 m
.25025 .4834 L
s
.25025 .4834 m
.27218 .49153 L
s
.24 .35 .67 r
.60179 .44904 m
.61391 .4833 L
s
.61391 .4833 m
.65892 .468 L
s
.60179 .44904 m
.64666 .43329 L
s
.63017 .36593 m
.67542 .34913 L
s
.63017 .36593 m
.63691 .39862 L
s
.67141 .32001 m
.71721 .30262 L
s
.67141 .32001 m
.67542 .34913 L
s
.83 .24 .1 r
.52645 .31832 m
.50158 .28784 L
s
.52345 .3465 m
.52645 .31832 L
s
.52272 .4356 m
.53835 .40532 L
s
.51371 .37673 m
.53835 .40532 L
s
.20276 .44297 m
.21933 .45665 L
s
.38835 .50393 m
.4158 .52984 L
s
.4158 .52984 m
.44648 .51309 L
s
.29854 .49333 m
.32796 .51949 L
s
.32796 .51949 m
.35729 .51501 L
s
.24 .35 .67 r
.65892 .468 m
.67297 .50078 L
s
.67297 .50078 m
.71909 .48558 L
s
.63691 .39862 m
.68262 .3821 L
s
.63691 .39862 m
.64666 .43329 L
s
.83 .24 .1 r
.50158 .28784 m
.49824 .26292 L
s
.47256 .23097 m
.49824 .26292 L
s
.50142 .46468 m
.52272 .4356 L
s
.49755 .40747 m
.52272 .4356 L
s
.24 .35 .67 r
.79536 .52485 m
.78098 .50005 L
s
.71909 .48558 m
.73391 .51512 L
s
.73391 .51512 m
.78098 .50005 L
s
.64666 .43329 m
.65892 .468 L
s
.65892 .468 m
.70508 .45231 L
s
.64666 .43329 m
.69269 .41715 L
s
.83 .24 .1 r
.41955 .48664 m
.44648 .51309 L
s
.44648 .51309 m
.47555 .49099 L
s
.24 .35 .67 r
.67542 .34913 m
.72183 .3319 L
s
.67542 .34913 m
.68262 .3821 L
s
.72183 .3319 m
.71721 .30262 L
s
.83 .24 .1 r
.47555 .49099 m
.50142 .46468 L
s
.47567 .43709 m
.50142 .46468 L
s
.51371 .37673 m
.52345 .3465 L
s
.49819 .31625 m
.52345 .3465 L
s
.47256 .23097 m
.46312 .21065 L
s
.24126 .46454 m
.27218 .49153 L
s
.27218 .49153 m
.29854 .49333 L
s
.44919 .46396 m
.47555 .49099 L
s
.32816 .48843 m
.35729 .51501 L
s
.35729 .51501 m
.38835 .50393 L
s
.24 .35 .67 r
.70508 .45231 m
.71909 .48558 L
s
.71909 .48558 m
.7664 .46998 L
s
.68262 .3821 m
.72952 .36514 L
s
.68262 .3821 m
.69269 .41715 L
s
.83 .24 .1 r
.21933 .45665 m
.24126 .46454 L
s
.24 .35 .67 r
.78098 .50005 m
.7664 .46998 L
s
.83 .24 .1 r
.50158 .28784 m
.47559 .25597 L
s
.49819 .31625 m
.50158 .28784 L
s
.24 .35 .67 r
.69269 .41715 m
.70508 .45231 L
s
.70508 .45231 m
.75244 .4362 L
s
.69269 .41715 m
.73991 .40058 L
s
.83 .24 .1 r
.49755 .40747 m
.51371 .37673 L
s
.48796 .34683 m
.51371 .37673 L
s
.24 .35 .67 r
.72952 .36514 m
.72183 .3319 L
s
.83 .24 .1 r
.35965 .47684 m
.38835 .50393 L
s
.38835 .50393 m
.41955 .48664 L
s
.26776 .46598 m
.29854 .49333 L
s
.29854 .49333 m
.32816 .48843 L
s
.47559 .25597 m
.47256 .23097 L
s
.47567 .43709 m
.49755 .40747 L
s
.47122 .37805 m
.49755 .40747 L
s
.24 .35 .67 r
.7664 .46998 m
.75244 .4362 L
s
.73991 .40058 m
.72952 .36514 L
s
.83 .24 .1 r
.39138 .45898 m
.41955 .48664 L
s
.41955 .48664 m
.44919 .46396 L
s
.44919 .46396 m
.47567 .43709 L
s
.44872 .40822 m
.47567 .43709 L
s
.48796 .34683 m
.49819 .31625 L
s
.47176 .2846 m
.49819 .31625 L
s
.24126 .46454 m
.26776 .46598 L
s
.42162 .4357 m
.44919 .46396 L
s
.24 .35 .67 r
.75244 .4362 m
.73991 .40058 L
s
.83 .24 .1 r
.29769 .46062 m
.32816 .48843 L
s
.32816 .48843 m
.35965 .47684 L
s
.47176 .2846 m
.47559 .25597 L
s
.47122 .37805 m
.48796 .34683 L
s
.46101 .31555 m
.48796 .34683 L
s
.32961 .44848 m
.35965 .47684 L
s
.35965 .47684 m
.39138 .45898 L
s
.26776 .46598 m
.29769 .46062 L
s
.44872 .40822 m
.47122 .37805 L
s
.44366 .34725 m
.47122 .37805 L
s
.36188 .43002 m
.39138 .45898 L
s
.39138 .45898 m
.42162 .4357 L
s
.42162 .4357 m
.44872 .40822 L
s
.42051 .378 m
.44872 .40822 L
s
.46101 .31555 m
.47176 .2846 L
s
.39275 .4061 m
.42162 .4357 L
s
.29769 .46062 m
.32961 .44848 L
s
.44366 .34725 m
.46101 .31555 L
s
.32961 .44848 m
.36188 .43002 L
s
.42051 .378 m
.44366 .34725 L
s
.36188 .43002 m
.39275 .4061 L
s
.39275 .4061 m
.42051 .378 L
s
0 0 0 r
.25 Mabswid
.63805 .03848 m
.88764 .44767 L
s
.88764 .44767 m
.93472 .69847 L
s
.93472 .69847 m
.66126 .3169 L
s
.66126 .3169 m
.63805 .03848 L
s
.06705 .30234 m
.00747 .5665 L
s
.00747 .5665 m
.66126 .3169 L
s
.66126 .3169 m
.63805 .03848 L
s
.63805 .03848 m
.06705 .30234 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{500, 500},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40007d0001m2000`400?l00000o`00003oo`3ooooe
0?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3o
m^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40
oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?of
k_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3o
ool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^
m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofkSh0ooK^0P00002d0?ofkP40oooo003o0?of
kS`0ooK^0P0000000`3om^h000000000002c0?ofkP40oooo003o0?ofkSX0ooK^0P0000030?ofkP80
0000/`3om^h10?ooo`00o`3om^hh0?ofkP8000001@3om^h00`000000ooK^0000002b0?ofkP40oooo
003o0?ofkSH0ooK^0P0000070?ofkP030000003om^h000000;80ooK^0@3oool00?l0ooK^=03om^h2
000000T0ooK^00@000000?ofkP3om^h00000/@3om^h10?ooo`00o`3om^ha0?ofkP<000002`3om^h0
1@000000ooK^0?ofkP3om^h000000;00ooK^0@3oool00?l0ooK^;`3om^h2000000l0ooK^00@00000
0?ofkP3om^h00000/03om^h10?ooo`00o`3om^h]0?ofkP8000004@3om^h01@000000ooK^0?ofkP3o
m^h000000:l0ooK^0@3oool00?l0ooK^:`3om^h2000001<0ooK^00D000000?ofkP3om^h0ooK^0000
002_0?ofkP40oooo003o0?ofkRT0ooK^0P00000E0?ofkP030000003om^h0ooK^0080ooK^00<00000
0?ofkP3om^h0[03om^h10?ooo`00o`3om^hV0?ofkP<000005`3om^h00`000000ooK^0?ofkP030?of
kP030000003om^h0ooK^0:/0ooK^0@3oool00?l0ooK^903om^h2000001X0ooK^00<000000?ofkP3o
m^h00`3om^h00`000000ooK^0?ofkP2[0?ofkP40oooo003o0?ofkR80ooK^0P00000L0?ofkP030000
003om^h0ooK^00@0ooK^00<000000?ofkP3om^h0ZP3om^h10?ooo`00o`3om^hP0?ofkP8000007P3o
m^h00`000000ooK^0?ofkP050?ofkP030000003om^h0ooK^0:T0ooK^0@3oool00?l0ooK^7P3om^h2
00000200ooK^00<000000?ofkP3om^h01@3om^h00`000000ooK^0?ofkP2Y0?ofkP40oooo003o0?of
kQ`0ooK^0P00000R0?ofkP030000003om^h0ooK^00H0ooK^00<000000?ofkP3om^h0Z03om^h10?oo
o`00o`3om^hI0?ofkP<00000903om^h00`000000ooK^0?ofkP060?ofkP030000003om^h0ooK^0:P0
ooK^0@3oool00?l0ooK^5`3om^h2000002L0ooK^00<000000?ofkP3om^h01`3om^h00`000000ooK^
0?ofkP2W0?ofkP40oooo003o0?ofkQD0ooK^0P00000Z0?ofkP030000003om^h0ooK^00L0ooK^00<0
00000?ofkP3om^h0YP3om^h10?ooo`00o`3om^hC0?ofkP800000;03om^h00`000000ooK^0?ofkP07
0?ofkP030000003om^h0ooK^0:H0ooK^0@3oool00?l0ooK^4@3om^h2000002h0ooK^00<000000?of
kP3om^h0203om^h00`000000ooK^0?ofkP2U0?ofkP40oooo003o0?ofkPl0ooK^0P00000`0?ofkP03
0000003om^h0ooK^00P0ooK^00<000000?ofkP3om^h0Y@3om^h10?ooo`00o`3om^h<0?ofkP<00000
<P3om^h00`000000ooK^0?ofkP090?ofkP030000003om^h0ooK^0:@0ooK^0@3oool00?l0ooK^2P3o
m^h2000003D0ooK^00<000000?ofkP3om^h02P3om^h00`000000ooK^0?ofkP2S0?ofkP40oooo003o
0?ofkPP0ooK^0P00000g0?ofkP030000003om^h0ooK^00X0ooK^00<000000?ofkP3om^h0X`3om^h1
0?ooo`00o`3om^h60?ofkP800000>@3om^h00`000000ooK^0?ofkP0;0?ofkP030000003om^h0ooK^
0:80ooK^0@3oool00?l0ooK^103om^h2000003/0ooK^00<000000?ofkP3om^h02`3om^h00`000000
ooK^0?ofkP2R0?ofkP40oooo003o0?ofkP40ooK^0`00000m0?ofkP030000003om^h0ooK^00`0ooK^
00<000000?ofkP3om^h0X@3om^h10?ooo`00oP3om^h200000400ooK^00<000000?ofkP3om^h03@3o
m^h00`000000ooK^0?ofkP2P0?ofkP40oooo003l0?ofkP800000@P3om^h00`000000ooK^0?ofkP0=
0?ofkP030000003om^h0ooK^0:00ooK^0@3oool00?X0ooK^0P0000140?ofkP030000003om^h0ooK^
00h0ooK^00<000000?ofkP3om^h0W`3om^h10?ooo`00n03om^h2000004L0ooK^00<000000?ofkP3o
m^h03@3om^h00`000000ooK^0?ofkP2O0?ofkP40oooo003f0?ofkP800000B@3om^h00`000000ooK^
0?ofkP0>0?ofkP030000003om^h0ooK^09h0ooK^0@3oool00?<0ooK^0`00001;0?ofkP030000003o
m^h0ooK^00l0ooK^00<000000?ofkP3om^h0W@3om^h10?ooo`00l@3om^h2000004h0ooK^00<00000
0?ofkP3om^h03`3om^h00`000000ooK^0?ofkP2M0?ofkP40oooo003_0?ofkP800000D03om^h00`00
0000ooK^0?ofkP0@0?ofkP030000003om^h0ooK^09`0ooK^0@3oool00>d0ooK^0P00001B0?ofkP03
0000003om^h0ooK^0100ooK^00<000000?ofkP3om^h0W03om^h10?ooo`00j`3om^h2000005@0ooK^
00<000000?ofkP3om^h04@3om^h00`000000ooK^0?ofkP2K0?ofkP40oooo003Y0?ofkP800000EP3o
m^h00`000000ooK^0?ofkP0B0?ofkP030000003om^h0ooK^09X0ooK^0@3oool00>H0ooK^0`00001H
0?ofkP030000003om^h0ooK^0180ooK^00<000000?ofkP3om^h0VP3om^h10?ooo`00i03om^h20000
05/0ooK^00<000000?ofkP3om^h04`3om^h00`000000ooK^0?ofkP2I0?ofkP40oooo003R0?ofkP80
0000G@3om^h00`000000ooK^0?ofkP0D0?ofkP030000003om^h0ooK^09P0ooK^0@3oool00>00ooK^
0P00001O0?ofkP030000003om^h0ooK^01@0ooK^00<000000?ofkP3om^h0V03om^h10?ooo`00gP3o
m^h200000640ooK^00<000000?ofkP3om^h05@3om^h00`000000ooK^0?ofkP2G0?ofkP40oooo003L
0?ofkP800000I03om^h00`000000ooK^0?ofkP0D0?ofkP030000003om^h0ooK^09L0ooK^0@3oool0
0=T0ooK^0`00001V0?ofkP030000003om^h0ooK^01D0ooK^00<000000?ofkP3om^h0UP3om^h10?oo
o`00e`3om^h2000006T0ooK^00<000000?ofkP3om^h05P3om^h00`000000ooK^0?ofkP2E0?ofkP40
oooo003E0?ofkP800000J`3om^h00`000000ooK^0?ofkP0F0?ofkP030000003om^h0ooK^09D0ooK^
0@3oool00=<0ooK^0P00001]0?ofkP030000003om^h0ooK^01L0ooK^00<000000?ofkP3om^h0U03o
m^h10?ooo`00d@3om^h2000006l0ooK^00<000000?ofkP3om^h05`3om^h00`000000ooK^0?ofkP2D
0?ofkP40oooo003>0?ofkP<00000L@3om^h00`000000ooK^0?ofkP0H0?ofkP030000003om^h0ooK^
09<0ooK^0@3oool00<`0ooK^0P00001d0?ofkP030000003om^h0ooK^01T0ooK^00<000000?ofkP3o
m^h0TP3om^h10?ooo`00bP3om^h2000007H0ooK^00<000000?ofkP3om^h06@3om^h00`000000ooK^
0?ofkP2B0?ofkP40oooo00380?ofkP800000N03om^h00`000000ooK^0?ofkP0J0?ofkP030000003o
m^h0ooK^0940ooK^0@3oool00<H0ooK^0P00001j0?ofkP030000003om^h0ooK^01X0ooK^00<00000
0?ofkP3om^h0T@3om^h10?ooo`00a03om^h2000007`0ooK^00<000000?ofkP3om^h06`3om^h00`00
0000ooK^0?ofkP2@0?ofkP40oooo00310?ofkP<00000O`3om^h00`000000ooK^0?ofkP0K0?ofkP03
0000003om^h0ooK^08l0ooK^0@3oool00;l0ooK^0P0000220?ofkP030000003om^h0ooK^01/0ooK^
00<000000?ofkP3om^h0S`3om^h10?ooo`00_@3om^h2000008@0ooK^00<000000?ofkP3om^h0703o
m^h00`000000ooK^0?ofkP2>0?ofkP40oooo002k0?ofkP800000QP3om^h00`000000ooK^0?ofkP0L
0?ofkP030000003om^h0ooK^08h0ooK^0@3oool00;T0ooK^0P0000280?ofkP030000003om^h0ooK^
01d0ooK^00<000000?ofkP3om^h0S@3om^h10?ooo`00]`3om^h2000008X0ooK^00<000000?ofkP3o
m^h07P3om^h00`000000ooK^0?ofkP2<0?ofkP40oooo002d0?ofkP<00000S03om^h00`000000ooK^
0?ofkP0N0?ofkP030000003om^h0ooK^08`0ooK^0@3oool00;80ooK^0P00002?0?ofkP030000003o
m^h0ooK^01l0ooK^00<000000?ofkP3om^h0R`3om^h10?ooo`00/03om^h200000940ooK^00<00000
0?ofkP3om^h0803om^h00`000000ooK^0?ofkP2:0?ofkP40oooo002^0?ofkP800000T`3om^h00`00
0000ooK^0?ofkP0P0?ofkP030000003om^h0ooK^08X0ooK^0@3oool00:`0ooK^0P00002E0?ofkP03
0000003om^h0ooK^0240ooK^00<000000?ofkP3om^h0R@3om^h10?ooo`00Z@3om^h3000009L0ooK^
00<000000?ofkP3om^h08@3om^h00`000000ooK^0?ofkP290?ofkP40oooo002W0?ofkP800000VP3o
m^h00`000000ooK^0?ofkP0R0?ofkP030000003om^h0ooK^08P0ooK^0@3oool00:D0ooK^0P00002M
0?ofkP030000003om^h0ooK^0280ooK^00<000000?ofkP3om^h0Q`3om^h10?ooo`00X`3om^h20000
09l0ooK^00<000000?ofkP3om^h08P3om^h00`000000ooK^0?ofkP270?ofkP40oooo002Q0?ofkP80
0000803om^h90=@m6GP0ooK^00<000000?ofkP3om^h08`3om^h00`000000ooK^0?ofkP260?ofkP40
oooo002O0?ofkP8000006P3om^h80=@m6@L0ooK^00<0e3dI0?ofkP3D?AT01@3D?AUb0?ofkP030000
003om^h0ooK^02<0ooK^00<000000?ofkP3om^h0QP3om^h10?ooo`00W03om^h3000001P0ooK^103D
?AT20?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h0103om^h50=@m6Fd0ooK^00<0
00000?ofkP3om^h0903om^h00`000000ooK^0?ofkP250?ofkP40oooo002J0?ofkP800000603om^h3
0=@m6@L0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP070?ofkP<0e3dIJ`3om^h0
0`000000ooK^0?ofkP0U0?ofkP030000003om^h0ooK^08@0ooK^0@3oool009P0ooK^0P00000F0?of
kP@0e3dI2`3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?of
kP3D?AT00P3D?AUX0?ofkP030000003om^h0ooK^02D0ooK^00<000000?ofkP3om^h0Q03om^h10?oo
o`00UP3om^h2000001D0ooK^0`3D?AT?0?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3o
m^h0203om^h0103D?AT0ooK^0?ofkP3om^h20=@m6FH0ooK^00<000000?ofkP3om^h09P3om^h00`00
0000ooK^0?ofkP230?ofkP40oooo002D0?ofkP8000005@3om^h20=@m6@80ooK^00<0e3dI0?ofkP3o
m^h03P3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3o
m^h00`3om^h20=@m6F@0ooK^00<000000?ofkP3om^h09P3om^h00`000000ooK^0?ofkP230?ofkP40
oooo002B0?ofkP8000005@3om^h20=@m6@D0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^
0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^
0?ofkP1Q0?ofkP030000003om^h0ooK^02L0ooK^00<000000?ofkP3om^h0PP3om^h10?ooo`00S`3o
m^h3000001@0ooK^0`3D?AT80?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h02`3o
m^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h0H03o
m^h00`000000ooK^0?ofkP0X0?ofkP030000003om^h0ooK^0840ooK^0@3oool008d0ooK^0P00000E
0?ofkP80e3dI2`3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI
0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP030?ofkP80e3dIH@3om^h00`000000ooK^0?ofkP0X
0?ofkP030000003om^h0ooK^0840ooK^0@3oool008/0ooK^0P00000E0?ofkP80e3dI3P3om^h00`3D
?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D
?AT0ooK^0?ofkP030?ofkP80e3dIH03om^h00`000000ooK^0?ofkP0Y0?ofkP030000003om^h0ooK^
0800ooK^0@3oool008T0ooK^0P00000E0?ofkP80e3dI4@3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP03
0=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP030?ofkP80
e3dIH03om^h00`000000ooK^0?ofkP0X0?ofkP030000003om^h0ooK^0800ooK^0@3oool008L0ooK^
0P00000E0?ofkP80e3dI00<0ooK^0=@m6@3om^h04@3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m
6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP030?ofkP80e3dI
G`3om^h00`000000ooK^0?ofkP0Y0?ofkP030000003om^h0ooK^07l0ooK^0@3oool008@0ooK^0`00
000F0?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h0403om^h00`3D?AT0ooK^0?of
kP0>0?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?of
kP030?ofkP80e3dIGP3om^h00`000000ooK^0?ofkP0Z0?ofkP030000003om^h0ooK^07h0ooK^0@3o
ool00880ooK^0P00000G0?ofkP80e3dI1P3om^h00`3D?AT0ooK^0?ofkP0@0?ofkP030=@m6@3om^h0
ooK^00h0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0
ooK^00<0ooK^00<0e3dI0?ofkP3D?AT0G@3om^h00`000000ooK^0?ofkP0Z0?ofkP030000003om^h0
ooK^07h0ooK^0@3oool00800ooK^0P00000H0?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?of
kP3om^h0403om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00D0ooK^2@3D?AT70?of
kP030=@m6@3om^h0ooK^00<0ooK^0`3D?AUL0?ofkP030000003om^h0ooK^02/0ooK^00<000000?of
kP3om^h0O@3om^h10?ooo`00OP3om^h2000001T0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0
ooK^0?ofkP0@0?ofkP030=@m6@3om^h0ooK^00d0ooK^203D?AT70?ofkP030=@m6@3om^h0e3dI00D0
e3dI0P3om^h00`3D?AT0ooK^0?ofkP030?ofkP80e3dIG03om^h00`000000ooK^0?ofkP0[0?ofkP03
0000003om^h0ooK^07d0ooK^0@3oool007`0ooK^0P00000I0?ofkP80e3dI3@3om^h00`3D?AT0ooK^
0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00T0ooK^103D?AT20?ofkP030=@m6@3om^h0ooK^00/0ooK^
00<0e3dI0?ofkP3om^h0103om^h40=@m6@D0ooK^0P3D?AUK0?ofkP030000003om^h0ooK^02`0ooK^
00<000000?ofkP3om^h0O03om^h10?ooo`00NP3om^h2000001X0ooK^00<0e3dI0?ofkP3om^h03P3o
m^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00D0ooK^0`3D?AT70?ofkP030=@m6@3o
m^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h0203om^h20=@m6@@0ooK^0P3D?AUJ0?ofkP030000003o
m^h0ooK^02d0ooK^00<000000?ofkP3om^h0N`3om^h10?ooo`00M`3om^h3000001X0ooK^0P3D?ATA
0?ofkP030=@m6@3om^h0ooK^0100ooK^00<0e3dI0?ofkP3om^h0103D?AT:0?ofkP030=@m6@3om^h0
ooK^00/0ooK^00<0e3dI0?ofkP3om^h0203om^h30=@m6@80ooK^0`3D?AUI0?ofkP030000003om^h0
ooK^02d0ooK^00<000000?ofkP3om^h0N`3om^h10?ooo`00M@3om^h2000001`0ooK^00<0e3dI0?of
kP3om^h04P3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP<0e3dI3`3om^h00`3D?AT0ooK^0?ofkP0;0?of
kP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h01@3D?AUI0?ofkP030000003om^h0ooK^
02h0ooK^00<000000?ofkP3om^h0NP3om^h10?ooo`00L`3om^h2000001d0ooK^00<0e3dI0?ofkP3D
?AT0503om^h00`3D?AT0ooK^0?ofkP0<0?ofkP80e3dI0P3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP03
0=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h01`3om^h0103D?AT0ooK^0?ofkP3om^h40=@m
6EP0ooK^00<000000?ofkP3om^h0;`3om^h00`000000ooK^0?ofkP1i0?ofkP40oooo001a0?ofkP80
00007P3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI01@0ooK^00<0e3dI0?ofkP3om^h02@3om^h20=@m
6@D0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^
00L0ooK^00@0e3dI0?ofkP3om^h0ooK^103D?AUG0?ofkP030000003om^h0ooK^02l0ooK^00<00000
0?ofkP3om^h0N@3om^h10?ooo`00K`3om^h2000001h0ooK^0P3D?AT50?ofkP030=@m6@3om^h0ooK^
0180ooK^00<0e3dI0?ofkP3om^h01P3om^h20=@m6@P0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D
?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00P0ooK^00H0e3dI0?ofkP3om^h0ooK^0=@m6@3o
m^h20=@m6EL0ooK^00<000000?ofkP3om^h0;`3om^h00`000000ooK^0?ofkP1h0?ofkP40oooo001]
0?ofkP8000007`3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI
0?ofkP3om^h00`3om^h20=@m6@/0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0;
0?ofkP030=@m6@3om^h0ooK^00P0ooK^00@0e3dI0?ofkP3om^h0e3dI0P3om^h00`3D?AT0ooK^0?of
kP1E0?ofkP030000003om^h0ooK^02l0ooK^00<000000?ofkP3om^h0N03om^h10?ooo`00JP3om^h3
00000200ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0
ooK^0080e3dI3P3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI
0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP020=@m6@030?ofkP3D?AT0e3dI05H0ooK^00<00000
0?ofkP3om^h0<03om^h00`000000ooK^0?ofkP1g0?ofkP40oooo001X0?ofkP8000008P3om^h00`3D
?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^01<0ooK^0P3D?ATA0?ofkP030=@m6@3om^h0ooK^
00d0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP070?ofkP060=@m6@3om^h0e3dI
0?ofkP3D?AT0ooK^0P3D?AUE0?ofkP030000003om^h0ooK^0340ooK^00<000000?ofkP3om^h0MP3o
m^h10?ooo`00IP3om^h2000002<0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP0@
0?ofkP80e3dI00<0ooK^0=@m6@3om^h0403om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0
ooK^00/0ooK^00<0e3dI0?ofkP3om^h01`3om^h20=@m6@040?ofkP3D?AT0ooK^0?ofkP80e3dIE03o
m^h00`000000ooK^0?ofkP0a0?ofkP030000003om^h0ooK^07H0ooK^0@3oool006@0ooK^0P00000S
0?ofkP80e3dI3`3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI
0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI
0?ofkP3om^h0203om^h20=@m6@050?ofkP3D?AT0ooK^0?ofkP3D?AT0E03om^h00`000000ooK^0?of
kP0b0?ofkP030000003om^h0ooK^07D0ooK^0@3oool00680ooK^0P00000T0?ofkP030=@m6@3om^h0
ooK^0100ooK^00<0e3dI0?ofkP3om^h02`3om^h20=@m6@H0ooK^00<0e3dI0?ofkP3om^h03`3om^h0
0`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h0203om^h0
103D?AT0ooK^0?ofkP3D?AT20?ofkP030=@m6@3om^h0ooK^0540ooK^00<000000?ofkP3om^h0<P3o
m^h00`000000ooK^0?ofkP1e0?ofkP40oooo001P0?ofkP8000009@3om^h00`3D?AT0ooK^0?ofkP0B
0?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP0@
0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h01@3om^h90=@m6@L0ooK^00H0e3dI
0?ofkP3om^h0ooK^0=@m6@3om^h20=@m6E80ooK^00<000000?ofkP3om^h0<`3om^h00`000000ooK^
0?ofkP1d0?ofkP40oooo001M0?ofkP<000009P3om^h00`3D?AT0ooK^0?ofkP0D0?ofkP030=@m6@3o
m^h0ooK^00H0ooK^0P3D?AT:0?ofkP030=@m6@3om^h0ooK^0100ooK^00<0e3dI0?ofkP3om^h02`3o
m^h90=@m6@L0ooK^00<0e3dI0?ofkP3D?AT01@3D?AT00`3om^h0e3dI0=@m6@030?ofkP040=@m6@3o
m^h0e3dI0=@m6E40ooK^00<000000?ofkP3om^h0=03om^h00`000000ooK^0?ofkP1c0?ofkP40oooo
001K0?ofkP800000:03om^h00`3D?AT0ooK^0=@m6@0E0?ofkP030=@m6@3om^h0ooK^00@0ooK^0P3D
?AT=0?ofkP030=@m6@3om^h0ooK^0100ooK^00<0e3dI0?ofkP3om^h01P3om^h40=@m6@<0ooK^00<0
e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP040?ofkP@0e3dI0P3om^h00`3D?AT0ooK^0?of
kP020=@m6E00ooK^00<000000?ofkP3om^h08@3om^h403eIZ`l0ooK^00<000000?ofkP3om^h0L`3o
m^h10?ooo`00F@3om^h2000002T0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0E0?ofkP030=@m6@3o
m^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0@0?ofkP040=@m6@3o
m^h0ooK^0?ofkP@0e3dI203om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00@0ooK^
00<0e3dI0?ofkP3om^h00P3D?AT00`3om^h0e3dI0?ofkP020=@m6E00ooK^00<000000?ofkP3om^h0
7`3om^h303eIZ`<0ooK^0`0mFJ/=0?ofkP030000003om^h0ooK^0780ooK^0@3oool005L0ooK^0P00
000Z0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h04`3om^h0103D?AT0ooK^0=@m
6@3D?ATB0?ofkP030=@m6@3om^h0ooK^00l0ooK^103D?AT=0?ofkP030=@m6@3om^h0ooK^00X0ooK^
00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP040=@m6@030?ofkP3D?AT0e3dI04l0ooK^
00<000000?ofkP3om^h0703om^h403eIZ`@0ooK^0P0mFJ/20?ofkP0303eIZ`3om^h0ooK^00X0ooK^
00<000000?ofkP3om^h0LP3om^h10?ooo`00E@3om^h2000002/0ooK^00<0e3dI0?ofkP3om^h01@3o
m^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h0303o
m^h20=@m6@80ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3o
m^h0ooK^00@0ooK^00@0e3dI0?ofkP3om^h0e3dI0P3om^h50=@m6Dh0ooK^00<000000?ofkP3om^h0
6@3om^h503eIZ`040?ofkP0mFJ/0ooK^0?ofkP80?EV[1@3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP03
0000003om^h0ooK^0740ooK^0@3oool00580ooK^0`00000/0?ofkP030=@m6@3om^h0ooK^00L0ooK^
00<0e3dI0?ofkP3om^h04@3om^h00`3D?AT0ooK^0=@m6@0E0?ofkP030=@m6@3om^h0ooK^00T0ooK^
0P3D?AT50?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^
0?ofkP030?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT00`3om^h40=@m6Dh0ooK^00<000000?ofkP3o
m^h05P3om^h403eIZ`<0ooK^100mFJ/80?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<000000?ofkP3o
m^h0L03om^h10?ooo`00D03om^h2000002d0ooK^0P3D?AT;0?ofkP030=@m6@3om^h0ooK^00h0ooK^
0P3D?AT30?ofkP030=@m6@3om^h0ooK^0180ooK^00<0e3dI0?ofkP3om^h01P3om^h30=@m6@P0ooK^
00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^0080ooK^
0P3D?AT30?ofkP040=@m6@3om^h0ooK^0?ofkP@0e3dIC@3om^h00`000000ooK^0?ofkP0C0?ofkPD0
?EV[103om^h203eIZ``0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`000000ooK^0?ofkP1`0?ofkP40
oooo001>0?ofkP800000;P3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00d0ooK^
00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP0B0?ofkP030=@m6@3om^h0ooK^00<0ooK^
0P3D?AT;0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h02`3om^h01`3D?AT0ooK^
0?ofkP3om^h0e3dI0?ofkP3D?AT00`3om^h00`3D?AT0ooK^0?ofkP020=@m6@030?ofkP3D?AT0ooK^
04`0ooK^00<000000?ofkP3om^h0403om^h503eIZ`D0ooK^0`0mFJ/=0?ofkP80?EV[2`3om^h00`00
0000ooK^0?ofkP1_0?ofkP40oooo001<0?ofkP800000;`3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP03
0=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP0B0?ofkP03
0=@m6@3om^h0ooK^0080e3dI3P3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00/0
ooK^00H0e3dI0?ofkP3om^h0e3dI0?ofkP3D?AT40?ofkP040=@m6@3om^h0ooK^0=@m6@80ooK^00<0
e3dI0?ofkP3om^h0BP3om^h00`000000ooK^0?ofkP0>0?ofkP@0?EV[1@3om^h303eIZ`030?ofkP0m
FJ/0?EV[00/0ooK^0P0mFJ/20?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<000000?ofkP3om^h0K`3o
m^h10?ooo`00BP3om^h200000300ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP08
0?ofkP80e3dI2P3om^h00`3D?AT0ooK^0?ofkP0B0?ofkP80e3dI4@3om^h00`3D?AT0ooK^0?ofkP0=
0?ofkP030=@m6@3om^h0ooK^00/0ooK^0P3D?AT30?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT00`3o
m^h0103D?AT0ooK^0=@m6@3D?AU;0?ofkP030000003om^h0ooK^00/0ooK^100mFJ/60?ofkP80?EV[
0P3om^h203eIZ`030?ofkP0mFJ/0ooK^00L0ooK^0`0mFJ/40?ofkP0303eIZ`3om^h0ooK^00T0ooK^
00<000000?ofkP3om^h0KP3om^h10?ooo`00B03om^h200000340ooK^00<0e3dI0?ofkP3om^h04@3o
m^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h03`3o
m^h20=@m6@030?ofkP3D?AT0ooK^0140ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?of
kP0:0?ofkP80e3dI103om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI0080ooK^0P3D?AT00`3om^h0e3dI
0=@m6@1:0?ofkP030000003om^h0ooK^00T0ooK^100mFJ/00`3om^h0?EV[03eIZ`030?ofkP80?EV[
00@0ooK^03eIZ`0mFJ/0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP040?ofkP80?EV[203om^h00`0mFJ/0
ooK^0?ofkP090?ofkP030000003om^h0ooK^06d0ooK^0@3oool004D0ooK^0`00000b0?ofkP030=@m
6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m
6@3om^h0ooK^00`0ooK^0P3D?AT40?ofkP030=@m6@3om^h0ooK^0100ooK^00<0e3dI0?ofkP3om^h0
303om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00<0ooK^00X0e3dI0?ofkP3om^h0
ooK^0=@m6@3om^h0e3dI0?ofkP3D?AT0ooK^0P3D?AU90?ofkP030000003om^h0ooK^00H0ooK^100m
FJ/60?ofkP<0?EV[00<0ooK^03eIZ`0mFJ/01P3om^h0100mFJ/0ooK^0?ofkP3om^h303eIZ`/0ooK^
00<0?EV[0?ofkP3om^h0203om^h00`000000ooK^0?ofkP1]0?ofkP40oooo00130?ofkP800000=03o
m^h00`3D?AT0ooK^0=@m6@0E0?ofkP040=@m6@3om^h0ooK^0?ofkP80e3dI4@3om^h00`3D?AT0ooK^
0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h0403om^h00`3D?AT0ooK^
0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00X0ooK^0P3D?AT50?ofkP040=@m6@3om^h0ooK^0?ofkP80
e3dI00D0ooK^0=@m6@3om^h0ooK^0=@m6@190?ofkP030000003om^h0ooK^00<0ooK^1@0mFJ/60?of
kP80?EV[00@0ooK^03eIZ`0mFJ/0?EV[203om^h0100mFJ/0ooK^03eIZ`0mFJ/?0?ofkP0303eIZ`3o
m^h0ooK^00P0ooK^00<000000?ofkP3om^h0K03om^h10?ooo`00@@3om^h2000003D0ooK^00D0e3dI
0?ofkP3om^h0ooK^0=@m6@0E0?ofkP030=@m6@3om^h0e3dI01@0ooK^00<0e3dI0?ofkP3om^h01`3o
m^h20=@m6@P0ooK^00<0e3dI0?ofkP3om^h04@3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3o
m^h0ooK^00D0ooK^203D?AT30?ofkP030=@m6@3om^h0ooK^0080ooK^0P3D?AT01@3om^h0e3dI0?of
kP3om^h0e3dI04P0ooK^00@000000?ofkP3om^h0ooK^100mFJ/20?ofkP0403eIZ`3om^h0ooK^0?of
kPH0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP040?ofkP<0?EV[4@3om^h00`0mFJ/0ooK^0?ofkP090?of
kP030000003om^h0ooK^06/0ooK^0@3oool003l0ooK^0P00000f0?ofkP030=@m6@3om^h0ooK^00<0
ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP0D0?ofkP030=@m6@3om^h0ooK^00D0
ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP0@0?ofkP030=@m6@3om^h0ooK^00/0
ooK^2@3D?AT40?ofkP030=@m6@3om^h0ooK^00H0e3dI0`3om^h20=@m6@80ooK^00@0e3dI0?ofkP3D
?AT0e3dIA`3om^h00`000000?EV[03eIZ`0203eIZ`@0ooK^00<0?EV[0?ofkP0mFJ/00P0mFJ/00`3o
m^h0?EV[03eIZ`070?ofkP80?EV[0P3om^h303eIZa@0ooK^00<0?EV[0?ofkP3om^h0203om^h00`00
0000ooK^0?ofkP1[0?ofkP40oooo000m0?ofkP800000>03om^h00`3D?AT0ooK^0?ofkP040?ofkP03
0=@m6@3om^h0ooK^0140ooK^00<0e3dI0?ofkP3D?AT05P3om^h00`3D?AT0ooK^0?ofkP020?ofkP80
e3dI3@3om^h00`3D?AT0ooK^0?ofkP0@0?ofkP030=@m6@3om^h0ooK^00H0ooK^103D?AT30?ofkP03
0=@m6@3om^h0ooK^00L0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@030?ofkP@0e3dI00<0ooK^0=@m
6@3om^h00P3om^h0103D?AT0ooK^0=@m6@3D?AU40?ofkP80?EV[00<0000003eIZ`3om^h01P3om^h2
03eIZ`040?ofkP0mFJ/0?EV[03eIZ`X0ooK^0`0mFJ/20?ofkP0303eIZ`3om^h0ooK^0180ooK^0P0m
FJ/:0?ofkP030000003om^h0ooK^06X0ooK^0@3oool003/0ooK^0P00000i0?ofkP030=@m6@3om^h0
ooK^00H0ooK^00<0e3dI0?ofkP3om^h03`3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI01H0ooK^00@0
e3dI0?ofkP3D?AT0e3dI403om^h00`3D?AT0ooK^0?ofkP0@0?ofkP040=@m6@3om^h0ooK^0?ofkP@0
e3dI203om^h00`3D?AT0ooK^0?ofkP060?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT01@3om^h00`3D
?AT0ooK^0=@m6@020=@m6@<0ooK^00@0e3dI0?ofkP3D?AT0e3dI@@3om^h403eIZ`030000003om^h0
ooK^00<0ooK^0`0mFJ/00`3om^h0?EV[03eIZ`0;0?ofkP80?EV[0P3om^h0100mFJ/0ooK^0?ofkP0m
FJ/A0?ofkP<0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP070?ofkP030000003om^h0ooK^06X0ooK^0@3o
ool003P0ooK^0`00000j0?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h03@3om^h0
0`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^01@0ooK^00<0e3dI0?ofkP3om^h04@3om^h0
0`3D?AT0ooK^0?ofkP0?0?ofkP@0e3dI3@3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0
ooK^00<0ooK^00<0e3dI0?ofkP3om^h00`3om^h0103D?AT0ooK^0=@m6@3om^h20=@m6@030?ofkP3D
?AT0ooK^00<0e3dI?@3om^h403eIZ`<0ooK^00<000000?ofkP3om^h00`0mFJ/0103om^h0?EV[03eI
Z`0mFJ/:0?ofkP<0?EV[1@3om^h303eIZ`h0ooK^0`0mFJ/50?ofkP0303eIZ`3om^h0ooK^00P0ooK^
00<000000?ofkP3om^h0J@3om^h10?ooo`00=P3om^h2000003`0ooK^00<0e3dI0?ofkP3om^h02@3o
m^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h04P3o
m^h00`3D?AT0ooK^0=@m6@0C0?ofkP030=@m6@3om^h0ooK^00`0ooK^0P3D?AT20?ofkP030=@m6@3o
m^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3o
m^h0ooK^00<0ooK^0P3D?AT20?ofkP@0e3dI00<0ooK^0=@m6@3D?AT0>`3om^h303eIZ`80ooK^0P0m
FJ/30?ofkP040000000mFJ/0ooK^0?ofkP80?EV[00<0ooK^03eIZ`3om^h01`3om^h303eIZ`H0ooK^
1@0mFJ/<0?ofkP80?EV[2@3om^h00`0mFJ/0ooK^0?ofkP080?ofkP030000003om^h0ooK^06P0ooK^
0@3oool003@0ooK^0P00000m0?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h02P3o
m^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00l0ooK^0P3D?AT30?ofkP030=@m6@3o
m^h0ooK^0140ooK^00<0e3dI0?ofkP3om^h02@3om^h20=@m6@D0ooK^00<0e3dI0?ofkP3om^h0303o
m^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h00P3o
m^h01@3D?AT0ooK^0=@m6@3om^h0e3dI0080ooK^1@3D?ATg0?ofkP@0?EV[1P3om^h303eIZ`040000
000mFJ/0?EV[03eIZ`<0ooK^00<0?EV[0?ofkP3om^h0103om^h203eIZ`H0ooK^0`0mFJ/30?ofkP80
?EV[2@3om^h303eIZ``0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`000000ooK^0?ofkP1X0?ofkP40
oooo000b0?ofkP800000?P3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00L0ooK^
0P3D?AT;0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^
0?ofkP0@0?ofkP030=@m6@3om^h0ooK^00H0ooK^0`3D?AT70?ofkP030=@m6@3om^h0ooK^00d0ooK^
00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00<0ooK^
0P3D?AT20?ofkP040=@m6@3om^h0ooK^0?ofkP@0e3dI=03om^h403eIZ`H0ooK^0P0mFJ/0103om^h0
?EV[03eIZ`0000060?ofkP0403eIZ`3om^h0ooK^0?ofkP<0?EV[1@3om^h303eIZ`L0ooK^00<0?EV[
0?ofkP3om^h0103om^h303eIZ`l0ooK^00<0?EV[0?ofkP3om^h0203om^h00`000000ooK^0?ofkP1W
0?ofkP40oooo000`0?ofkP800000@03om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^
00D0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^
00D0ooK^00<0e3dI0?ofkP3om^h04@3om^h00`3D?AT0ooK^0?ofkP030?ofkP80e3dI2`3om^h00`3D
?AT0ooK^0?ofkP0=0?ofkP040=@m6@3om^h0ooK^0?ofkP80e3dI1`3om^h00`3D?AT0ooK^0?ofkP03
0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT00`3om^h40=@m6C00ooK^100mFJ/20?ofkP0403eIZ`3o
m^h0ooK^0?ofkP<0?EV[00<0ooK^03eIZ`0mFJ/00P3om^h00`000000?EV[0?ofkP030?ofkP0303eI
Z`3om^h0?EV[0080?EV[1P3om^h203eIZ`X0ooK^0P0mFJ/20?ofkP<0?EV[4`3om^h00`0mFJ/0ooK^
0?ofkP070?ofkP030000003om^h0ooK^06L0ooK^0@3oool002d0ooK^0`0000110?ofkP030=@m6@3o
m^h0ooK^0100ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3o
m^h0ooK^00P0ooK^0P3D?AT90?ofkP030=@m6@3om^h0ooK^0140ooK^00<0e3dI0?ofkP3om^h00P3D
?AT>0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3D?AT00P3om^h00`3D?AT0ooK^0?of
kP050?ofkP030=@m6@3om^h0ooK^0080ooK^0P3D?AT30?ofkP030=@m6@3om^h0ooK^0080e3dI00<0
ooK^0=@m6@3D?AT0;@3om^h403eIZ`<0ooK^00<0?EV[0?ofkP3om^h00P0mFJ/0103om^h0?EV[03eI
Z`0mFJ/40?ofkP040000003om^h0?EV[03eIZ`80ooK^0P0mFJ/60?ofkP<0?EV[303om^h403eIZaL0
ooK^00<0?EV[0?ofkP3om^h01`3om^h00`000000ooK^0?ofkP1V0?ofkP40oooo000[0?ofkP800000
@`3om^h00`3D?AT0ooK^0?ofkP0B0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT04P3om^h00`3D?AT0
ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h04@3om^h20=@m6A40
ooK^00<0e3dI0?ofkP3om^h03@3om^h20=@m6@<0ooK^00<0e3dI0?ofkP3om^h01@3om^h01`3D?AT0
ooK^0?ofkP3om^h0e3dI0?ofkP3D?AT00P3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI0080ooK^0P3D
?ATY0?ofkP@0?EV[1P3om^h603eIZ`L0ooK^00<000000?ofkP3om^h0100mFJ/40?ofkP<0?EV[3P3o
m^h203eIZ`80ooK^00<0?EV[0?ofkP3om^h05@3om^h00`0mFJ/0ooK^0?ofkP080?ofkP030000003o
m^h0ooK^06D0ooK^0@3oool002T0ooK^0P0000140?ofkP030=@m6@3om^h0ooK^01@0ooK^00<0e3dI
0?ofkP3D?AT0503om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI
0?ofkP3om^h03P3om^h20=@m6@030?ofkP3D?AT0ooK^0100ooK^00<0e3dI0?ofkP3om^h03P3om^h0
1@3D?AT0ooK^0?ofkP3om^h0e3dI00P0ooK^00H0e3dI0?ofkP3om^h0e3dI0?ofkP3D?AT30?ofkP06
0=@m6@3om^h0ooK^0?ofkP3D?AT0ooK^0`3D?ATV0?ofkP@0?EV[1P3om^h203eIZ`030?ofkP0mFJ/0
?EV[00X0ooK^00<0000003eIZ`0mFJ/00P3om^h203eIZ`040?ofkP0mFJ/0?EV[03eIZ`h0ooK^0`0m
FJ/01@3om^h0?EV[0?ofkP3om^h0?EV[01L0ooK^0P0mFJ/90?ofkP030000003om^h0ooK^06D0ooK^
0@3oool002L0ooK^0P0000150?ofkP030=@m6@3om^h0e3dI01H0ooK^00<0e3dI0?ofkP3om^h0503o
m^h0103D?AT0ooK^0?ofkP3om^h20=@m6A00ooK^00<0e3dI0?ofkP3om^h02`3om^h20=@m6@@0ooK^
00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP80e3dI103om^h00`3D?AT0ooK^
0?ofkP050?ofkP030=@m6@3om^h0e3dI00<0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@020?ofkP80
e3dI00<0ooK^0=@m6@3D?AT08`3om^h503eIZ`D0ooK^1P0mFJ/;0?ofkP0303eIZ`000000ooK^00<0
ooK^0`0mFJ/?0?ofkP80?EV[103om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[01@0ooK^0P0mFJ/20?of
kP0303eIZ`3om^h0ooK^00L0ooK^00<000000?ofkP3om^h0I03om^h10?ooo`009@3om^h2000004L0
ooK^00@0e3dI0?ofkP3om^h0e3dI503om^h00`3D?AT0ooK^0=@m6@0F0?ofkP030=@m6@3om^h0e3dI
01<0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^
00l0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0=@m6@040?ofkP030=@m6@3om^h0ooK^
00D0ooK^0P3D?AT40?ofkP0:0=@m6@3om^h0ooK^0?ofkP3D?AT0ooK^0=@m6@3om^h0e3dI0?ofkP80
e3dI803om^h403eIZ`030?ofkP0mFJ/0?EV[00<0ooK^0P0mFJ/01@3om^h0?EV[03eIZ`3om^h0?EV[
00T0ooK^0`0mFJ/0103om^h000000?ofkP3om^h203eIZ`030?ofkP0mFJ/0?EV[00`0ooK^0`0mFJ/6
0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/04@3om^h303eIZ`@0ooK^00<0?EV[0?ofkP3om^h01`3o
m^h00`000000ooK^0?ofkP1T0?ofkP40oooo000S0?ofkP800000B03om^h00`3D?AT0ooK^0?ofkP02
0?ofkP030=@m6@3om^h0ooK^0100ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0F0?ofkP030=@m6@3o
m^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h01P3om^h20=@m6@T0ooK^00<0e3dI0?ofkP3om^h03`3o
m^h00`3D?AT0ooK^0?ofkP0:0?ofkP040=@m6@3om^h0ooK^0=@m6@@0ooK^00<0e3dI0?ofkP3om^h0
1`3D?AT40?ofkP040=@m6@3om^h0ooK^0?ofkP80e3dI00@0ooK^0=@m6@3om^h0ooK^0P3D?ATL0?of
kPD0?EV[1@3om^h603eIZ`<0ooK^00<0?EV[0?ofkP3om^h01@3om^h203eIZ`@0ooK^00<0000003eI
Z`0mFJ/00`3om^h00`0mFJ/0ooK^03eIZ`090?ofkP80?EV[2@3om^h00`0mFJ/0ooK^0?ofkP020?of
kP0303eIZ`3om^h0ooK^00`0ooK^0P0mFJ/80?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<000000?of
kP3om^h0H`3om^h10?ooo`008@3om^h2000004X0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0
ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h04P3om^h00`3D?AT0
ooK^0=@m6@0D0?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0
ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h02@3D?AT50?ofkPH0
e3dI00d0ooK^0=@m6@3om^h0ooK^0=@m6@3om^h0e3dI0?ofkP3D?AT0ooK^0=@m6@3om^h0e3dI01T0
ooK^1@0mFJ/40?ofkPL0?EV[103om^h00`0mFJ/0ooK^0?ofkP030?ofkP<0?EV[103om^h203eIZ`03
0000003om^h0ooK^00<0ooK^00@0?EV[0?ofkP3om^h0?EV[1@3om^h303eIZ`/0ooK^00<0?EV[0?of
kP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP080?ofkP<0?EV[2P3om^h00`0mFJ/0ooK^0?ofkP080?of
kP030000003om^h0ooK^0680ooK^0@3oool00240ooK^0P0000190?ofkP030=@m6@3om^h0ooK^00D0
ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^0100
ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0D0?ofkP030=@m6@3om^h0ooK^0080ooK^0P3D?AT>0?of
kP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h01`3om^h40=@m6@<0ooK^00<0e3dI0?of
kP3om^h00P3om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0e3dI00<0ooK^103D?AT00`3o
m^h0e3dI0=@m6@020?ofkP030=@m6@3om^h0e3dI0080e3dI5@3om^h603eIZ`@0ooK^0P0mFJ/00`3o
m^h0?EV[03eIZ`040?ofkP80?EV[0P3om^h0100mFJ/0ooK^0?ofkP3om^h203eIZ`D0ooK^0P0mFJ/2
0?ofkP030000003om^h0ooK^00<0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`020?ofkP80?EV[3@3o
m^h203eIZ`D0ooK^00<0?EV[0?ofkP3om^h01P3om^h203eIZ`h0ooK^00<0?EV[0?ofkP3om^h01`3o
m^h00`000000ooK^0?ofkP1R0?ofkP40oooo000Q0?ofkP030000003om^h0000004P0ooK^00<0e3dI
0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI
0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^0180ooK^00@0e3dI
0?ofkP3D?AT0e3dI403om^h00`3D?AT0ooK^0?ofkP0?0?ofkP040=@m6@3om^h0ooK^0?ofkPD0e3dI
00<0ooK^0=@m6@3om^h01@3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^0080ooK^
00@0e3dI0?ofkP3om^h0e3dI103om^h00`3D?AT0ooK^0=@m6@020=@m6@<0ooK^00<0e3dI0?ofkP3D
?AT00P3D?ATB0?ofkPD0?EV[0P3om^h00`0mFJ/0ooK^03eIZ`0503eIZ`P0ooK^0`0mFJ/00`3om^h0
?EV[03eIZ`040?ofkP<0?EV[1@3om^h00`000000ooK^0?ofkP020?ofkP0403eIZ`3om^h0ooK^0?of
kP<0?EV[303om^h303eIZ`030?ofkP0mFJ/0ooK^00D0ooK^00<0?EV[0?ofkP3om^h00P3om^h303eI
Za00ooK^00<0?EV[0?ofkP3om^h0203om^h00`000000ooK^0?ofkP1Q0?ofkP40oooo000P0?ofkP05
0000003om^h0ooK^0?ofkP000000AP3om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^
00T0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^
00D0ooK^00<0e3dI0?ofkP3om^h04P3om^h00`3D?AT0ooK^0?ofkP0A0?ofkP030=@m6@3om^h0ooK^
00h0ooK^103D?AT50?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h00P3om^h01@3D
?AT0ooK^0?ofkP3om^h0e3dI0080ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP03
0=@m6@80ooK^00@0e3dI0?ofkP3D?AT0e3dI3`3om^h503eIZ`@0ooK^1P0mFJ/<0?ofkP<0?EV[103o
m^h203eIZ`P0ooK^00<000000?ofkP3om^h00P3om^h0100mFJ/0ooK^03eIZ`0mFJ/20?ofkP0303eI
Z`3om^h0ooK^00P0ooK^0P0mFJ/40?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h0
0P0mFJ/D0?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<000000?ofkP3om^h0H@3om^h10?ooo`00803o
m^h00`000000ooK^0?ofkP020?ofkP800000@`3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3o
m^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3o
m^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h0403om^h00`3D?AT0ooK^0=@m6@0C0?ofkP030=@m6@3o
m^h0ooK^00/0ooK^0P3D?AT20?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h01P3o
m^h00`3D?AT0ooK^0?ofkP020?ofkP040=@m6@3om^h0ooK^0=@m6@@0ooK^00<0e3dI0?ofkP3om^h0
0`3om^h0103D?AT0ooK^0=@m6@3om^h40=@m6@80ooK^0P3D?AT<0?ofkPD0?EV[103om^h503eIZ``0
ooK^100mFJ/00`3om^h0?EV[0?ofkP0303eIZ`X0ooK^00@000000?ofkP3om^h0ooK^0`0mFJ/40?of
kP0303eIZ`3om^h0ooK^00D0ooK^0`0mFJ/70?ofkP0303eIZ`3om^h0ooK^00<0ooK^0`0mFJ/G0?of
kP0303eIZ`3om^h0ooK^00L0ooK^00<000000?ofkP3om^h0H03om^h10?ooo`00803om^h00`000000
ooK^0?ofkP040?ofkP030000003om^h0ooK^0400ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0
ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0
ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^00h0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0C0?of
kP030=@m6@3om^h0ooK^00L0ooK^0`3D?AT50?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?of
kP3om^h01`3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0e3dI00D0ooK^00<0e3dI0?of
kP3om^h00`3om^h20=@m6@80ooK^00P0e3dI0?ofkP3D?AT0e3dI0?ofkP3D?AT0ooK^0=@m6@P0ooK^
1@0mFJ/40?ofkPH0?EV[2`3om^h303eIZ`<0ooK^00@0?EV[0?ofkP0mFJ/0?EV[3@3om^h010000000
ooK^03eIZ`0mFJ/20?ofkP0303eIZ`3om^h0ooK^00<0ooK^00@0?EV[0?ofkP3om^h0ooK^0`0mFJ/:
0?ofkP0403eIZ`3om^h0ooK^0?ofkP80?EV[0P3om^h00`0mFJ/0ooK^0?ofkP0E0?ofkP0303eIZ`3o
m^h0ooK^00P0ooK^00<000000?ofkP3om^h0G`3om^h10?ooo`00803om^h00`000000ooK^0?ofkP05
0?ofkP030000003om^h0ooK^03h0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP04
0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP09
0?ofkP030=@m6@3om^h0ooK^00`0ooK^0P3D?AT50?ofkP030=@m6@3om^h0ooK^0140ooK^00<0e3dI
0?ofkP3om^h00`3om^h30=@m6@T0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0;0?ofkP030=@m6@3o
m^h0ooK^0080ooK^0P3D?AT60?ofkP030=@m6@3om^h0ooK^0080ooK^00D0e3dI0?ofkP3D?AT0ooK^
0=@m6@030?ofkP<0e3dI00<0ooK^0=@m6@3om^h0103om^h503eIZ`030?ofkP0mFJ/0?EV[00<0?EV[
00D0ooK^03eIZ`0mFJ/0ooK^03eIZ`0:0?ofkP80?EV[1@3om^h303eIZ`80ooK^00<0?EV[0?ofkP3o
m^h02@3om^h00`0mFJ/0000003eIZ`040?ofkP0303eIZ`3om^h0ooK^00<0ooK^100mFJ/=0?ofkP@0
?EV[103om^h00`0mFJ/0ooK^0?ofkP0F0?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<000000?ofkP3o
m^h0G`3om^h10?ooo`007`3om^h00`000000ooK^0?ofkP070?ofkP030000003om^h0ooK^03d0ooK^
00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00l0ooK^
00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00X0ooK^
00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP0A0?ofkP030=@m6@3om^h0ooK^0080e3dI
3@3om^h0103D?AT0ooK^0?ofkP3D?AT<0?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3o
m^h01@3om^h00`3D?AT0ooK^0?ofkP020?ofkP80e3dI0P3om^h0103D?AT0ooK^0?ofkP3om^h30=@m
6@030?ofkP3D?AT0ooK^00D0?EV[103om^h203eIZ`040?ofkP0mFJ/0?EV[03eIZ`<0ooK^00<0?EV[
0?ofkP3om^h01@3om^h303eIZ`D0ooK^0P0mFJ/00`3om^h0?EV[0?ofkP020?ofkP0303eIZ`3om^h0
ooK^00L0ooK^0P0mFJ/00`3om^h000000?ofkP040?ofkP0303eIZ`3om^h0ooK^0080ooK^0`0mFJ/>
0?ofkP80?EV[203om^h00`0mFJ/0ooK^0?ofkP0E0?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<00000
0?ofkP3om^h0GP3om^h10?ooo`007`3om^h00`000000ooK^0?ofkP080?ofkP030000003om^h0ooK^
03/0ooK^00<0e3dI0?ofkP3om^h0403om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI0180ooK^00<0e3dI
0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI
0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP0A0?ofkP80e3dI403om^h20=@m6@030?ofkP3D?AT0
ooK^00/0ooK^00@0e3dI0?ofkP3om^h0ooK^0P3D?AT70?ofkP030=@m6@3om^h0ooK^0080ooK^00D0
e3dI0?ofkP3om^h0ooK^0=@m6@030?ofkP<0e3dI00<000000=@m6@0mFJ/00P0mFJ/30?ofkPH0?EV[
0`3om^h00`0mFJ/0ooK^03eIZ`050?ofkP<0?EV[1@3om^h303eIZ`<0ooK^00<0?EV[0?ofkP3om^h0
0P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP<0?EV[0P3om^h2000000D0ooK^00<0?EV[0?ofkP0mFJ/0
0P0mFJ/30?ofkP0303eIZ`3om^h0ooK^00P0ooK^0`0mFJ/00`3om^h0?EV[0?ofkP070?ofkP0303eI
Z`3om^h0ooK^01D0ooK^0P0mFJ/90?ofkP030000003om^h0ooK^05h0ooK^0@3oool001l0ooK^00<0
00000?ofkP3om^h02@3om^h00`000000ooK^0?ofkP0j0?ofkP030=@m6@3om^h0ooK^0140ooK^00<0
e3dI0?ofkP3D?AT0503om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI0140ooK^00<0e3dI0?ofkP3om^h0
1P3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00h0ooK^0P3D?AT00`3om^h0e3dI
0?ofkP0?0?ofkP80e3dI0P3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0e3dI0080ooK^
00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP020?ofkP80e3dI0`3om^h00`3D?AT00000
000000020=@m6@0400H94P3D?AT0e3dI03eIZ`<0ooK^0P0mFJ/00`3om^h0?EV[03eIZ`070?ofkP80
?EV[0P3om^h303eIZ`D0ooK^0`0mFJ/60?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3o
m^h00P0mFJ/30?ofkP8000000P3om^h010000000ooK^0?ofkP3om^h303eIZ`H0ooK^00<0?EV[0?of
kP3om^h01P3om^h203eIZ`D0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP0B0?of
kP80?EV[00<0ooK^03eIZ`3om^h02@3om^h00`000000ooK^0?ofkP1M0?ofkP40oooo000O0?ofkP03
0000003om^h0ooK^00X0ooK^00<000000?ofkP3om^h0>03om^h00`3D?AT0ooK^0?ofkP0C0?ofkP03
0=@m6@3om^h0ooK^01@0ooK^00<0e3dI0?ofkP3D?AT04`3om^h00`3D?AT0ooK^0?ofkP040?ofkP03
0=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h0303om^h20=@m6@@0ooK^00<0e3dI0?ofkP3o
m^h03@3om^h20=@m6@80ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0=@m6@030?ofkP03
0=@m6@3om^h0ooK^00@0ooK^00T0e3dI0?ofkP3om^h0ooK^0=@m6@3om^h0e3dI0000000621400`00
000010062A80e3dI0=@m6@062A820=@m6@030000000mFJ/0?EV[00<0?EV[2P3om^h303eIZ`H0ooK^
0P0mFJ/90?ofkP0303eIZ`3om^h0ooK^00<0ooK^0`0mFJ/20?ofkP<00000103om^h01P000000ooK^
03eIZ`0mFJ/0ooK^03eIZ`P0ooK^00<0?EV[0?ofkP3om^h00P3om^h303eIZ`L0ooK^00<0?EV[0?of
kP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP<0?EV[103om^h00`0mFJ/0ooK^0?ofkP080?of
kP030000003om^h0ooK^05`0ooK^0@3oool001h0ooK^00<000000?ofkP3om^h0303om^h2000003P0
ooK^0P3D?ATC0?ofkP030=@m6@3om^h0e3dI01H0ooK^00<0e3dI0?ofkP3om^h04`3om^h0103D?AT0
ooK^0?ofkP3om^h20=@m6@l0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP050?of
kP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3D?AT00P3om^h00`3D?AT0ooK^0?ofkP0:0?of
kP80e3dI0`3om^h00`3D?AT0ooK^0?ofkP050?ofkP070=@m6@3om^h0ooK^0=@m6@000000e3dI0000
000600H94P050=@m6@000000000000d@7P3D?AT00P0mFJ/;0?ofkP<0?EV[00<0ooK^03eIZ`3om^h0
0P3om^h303eIZ`/0ooK^00<0?EV[0?ofkP3om^h00`0mFJ/20?ofkP<000001P3om^h203eIZ`050000
003om^h0ooK^0?ofkP0mFJ/0203om^h00`0mFJ/0ooK^0?ofkP0203eIZ`X0ooK^00<0?EV[0?ofkP3o
m^h01`3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP80?EV[1`3om^h00`0mFJ/0ooK^0?ofkP080?ofkP03
0000003om^h0ooK^05`0ooK^0@3oool001h0ooK^00<000000?ofkP3om^h03P3om^h00`000000ooK^
0?ofkP0d0?ofkP040=@m6@3om^h0ooK^0=@m6A80ooK^00@0e3dI0?ofkP3om^h0e3dI503om^h00`3D
?AT0ooK^0=@m6@0E0?ofkP030=@m6@3om^h0e3dI0180ooK^00<0e3dI0?ofkP3om^h01`3om^h20=@m
6@P0ooK^00<0e3dI0?ofkP3om^h02`3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI0080ooK^00<0e3dI
0?ofkP3om^h02@3om^h20=@m6@@0ooK^00<0e3dI0?ofkP3om^h01P3D?AT01P000000e3dI00000006
2A80e3dI000000801PTB0`0000020=@m6@<03A0N0P0000090?ofkP80?EV[00<0ooK^03eIZ`3om^h0
0P3om^h303eIZ`h0ooK^0`0mFJ/30?ofkP80000000<0ooK^03eIZ`3om^h0103om^h203eIZ`<0ooK^
00@000000?ofkP3om^h0?EV[203om^h303eIZ``0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0
ooK^0?ofkP080?ofkP<0?EV[2P3om^h00`0mFJ/0ooK^0?ofkP080?ofkP030000003om^h0ooK^05/0
ooK^0@3oool001h0ooK^00<000000?ofkP3om^h03`3om^h00`000000ooK^0?ofkP0c0?ofkP050=@m
6@3om^h0ooK^0?ofkP3D?AT0403om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^0100
ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0E0?ofkP030=@m6@3om^h0ooK^0180ooK^00<0e3dI0?of
kP3om^h01@3om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?of
kP3om^h00P3om^h0103D?AT0ooK^0?ofkP3D?AT90?ofkPX0e3dI0`3om^h4000000050=@m6@062A80
1PTB00H94P3D?AT00P00000300d@7P030=@m6@0=41h0e3dI00803A0N00<0000007PM2`3om^h01@3o
m^h303eIZ`<0ooK^00H0?EV[0?ofkP0mFJ/0?EV[0?ofkP0mFJ/=0?ofkP<0?EV[0P3om^h3000000<0
ooK^00<0?EV[0?ofkP3om^h00`0mFJ/60?ofkP040000003om^h0ooK^03eIZ`@0ooK^0`0mFJ/20?of
kP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP060?of
kP80?EV[3@3om^h00`0mFJ/0ooK^0?ofkP090?ofkP030000003om^h0ooK^05X0ooK^0@3oool001h0
ooK^00<000000?ofkP3om^h0403om^h00`000000ooK^0?ofkP0a0?ofkP030=@m6@3om^h0ooK^00<0
ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00l0
ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP0A0?ofkP030=@m6@3om^h0e3dI01@0
ooK^00<0e3dI0?ofkP3om^h00P3om^h20=@m6@d0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0
ooK^0?ofkP040?ofkP050=@m6@3om^h0ooK^0=@m6@3om^h01`3D?AT01@3om^h0e3dI0?ofkP3om^h0
e3dI00@0ooK^00@0e3dI000000000000000010062A801P3D?AT01PTB0000000000003A0N0=@m6@@0
3A0N00D0e3dI00d@7P0=41h0e3dI00d@7P03000000<0ooK^0P0mFJ/50?ofkP<0?EV[103om^h00`0m
FJ/0ooK^0?ofkP070?ofkP<0?EV[0P3om^h3000000H0ooK^0`0mFJ/90?ofkP040000003om^h0ooK^
03eIZ`80ooK^0P0mFJ/50?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h0203om^h0
0`0mFJ/0ooK^0?ofkP020?ofkP<0?EV[403om^h00`0mFJ/0ooK^0?ofkP080?ofkP030000003om^h0
ooK^05X0ooK^0@3oool001h0ooK^00<000000?ofkP3om^h04@3om^h00`000000ooK^0?ofkP0`0?of
kP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP050?of
kP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP0?0?of
kP050=@m6@3om^h0ooK^0?ofkP3D?AT0503om^h0103D?AT0ooK^0=@m6@3D?AT@0?ofkP030=@m6@3o
m^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h01@3om^h50=@m6@L0ooK^00<0e3dI0?ofkP3om^h00P3o
m^h00`3D?AT0ooK^0?ofkP02000000030=@m6@062A80000000<01PTB00<0e3dI0000000000000`0=
41h00`000000e3dI00d@7P0300d@7P050=@m6@0=41h000000=@m6@0G73`00`00000203eIZ`D0ooK^
0P0mFJ/00`3om^h0?EV[0?ofkP050?ofkP0303eIZ`3om^h0ooK^00@0ooK^0P0mFJ/30?ofkP800000
00<0?EV[0?ofkP3om^h0103om^h203eIZ`80ooK^00<0?EV[0?ofkP3om^h0203om^h00`000000ooK^
03eIZ`0203eIZ`P0ooK^00<0?EV[0?ofkP3om^h02@3om^h203eIZ`X0ooK^00<0?EV[0?ofkP3om^h0
0P0mFJ/C0?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<000000?ofkP3om^h0F@3om^h10?ooo`007@3o
m^h00`000000ooK^0?ofkP0C0?ofkP030000003om^h0ooK^02h0ooK^00<0e3dI0?ofkP3om^h01P3o
m^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h02`3o
m^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h00`3o
m^h00`3D?AT0ooK^0?ofkP0B0?ofkP030=@m6@3om^h0ooK^0140ooK^00<0e3dI0?ofkP3om^h01@3o
m^h00`3D?AT0ooK^0?ofkP030?ofkP80e3dI0P3om^h00`3D?AT0ooK^0=@m6@070?ofkP030=@m6@3o
m^h0ooK^00<0ooK^0`00000200H94P060=@m6@062A80000000H94P000000e3dI1P0=41h01`3D?AT0
3A0N00d@7P0=41h000000=@m6@0000000P0G73`00`3D?AT000000:@Z3`02000000@0ooK^0P0mFJ/3
0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h00`0mFJ/20?ofkP<000000P3om^h0
100mFJ/0ooK^0?ofkP3om^h303eIZ`D0ooK^00<0?EV[0?ofkP3om^h01P3om^h203eIZ`030000000m
FJ/0ooK^00X0ooK^00<0?EV[0?ofkP3om^h01P3om^h203eIZ`030?ofkP0mFJ/0ooK^00T0ooK^0`0m
FJ/E0?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<000000?ofkP3om^h0F@3om^h10?ooo`007@3om^h0
0`000000ooK^0?ofkP0D0?ofkP030000003om^h0ooK^02d0ooK^00<0e3dI0?ofkP3om^h01`3om^h0
0`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h02@3om^h0
0`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h01@3om^h0
0`3D?AT0ooK^0?ofkP0@0?ofkP030=@m6@3om^h0e3dI01<0ooK^00<0e3dI0?ofkP3om^h00`3om^h0
0`3D?AT0ooK^0?ofkP020?ofkP80e3dI1@3om^h00`3D?AT0ooK^0=@m6@060?ofkP030=@m6@3om^h0
ooK^00<000001P062A801@3D?AT000000000000=41h0e3dI00H03A0N00H000000=@m6@0000000000
01LL?03D?AT401LL?0030=@m6@2T:Pl00000008000000`0mFJ/50?ofkP0303eIZ`3om^h0ooK^00D0
ooK^0`0mFJ/30?ofkP8000001@3om^h0100mFJ/0ooK^03eIZ`0mFJ/80?ofkP0303eIZ`3om^h0ooK^
00@0ooK^0P0mFJ/20?ofkP030000000mFJ/0ooK^00X0ooK^00<0?EV[0?ofkP3om^h00`3om^h303eI
Z`<0ooK^00<0?EV[0?ofkP3om^h01@3om^h303eIZ`030?ofkP0mFJ/0ooK^01H0ooK^00<0?EV[0?of
kP3om^h02@3om^h00`000000ooK^0?ofkP1H0?ofkP40oooo000M0?ofkP030000003om^h0ooK^01D0
ooK^0P00000]0?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0
ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0
ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h03@3om^h20=@m6@<0
ooK^00<0e3dI0?ofkP3om^h0403om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^0080
e3dI203om^h00`3D?AT0ooK^0=@m6@050?ofkP030=@m6@00000000000080000010062A8300000005
00d@7P3D?AT03A0N00d@7P3D?AT01@0=41h3000000040=@m6@0G73`05a`l0=@m6@@05a`l00<0e3dI
0000002T:Pl00P0mFJ/80?ofkP0303eIZ`3om^h0ooK^0080ooK^0`0mFJ/20?ofkP0403eIZ`000000
0000000000H0ooK^0`0mFJ/;0?ofkP0303eIZ`3om^h0ooK^00<0?EV[1@3om^h00`000000ooK^0?of
kP0:0?ofkP0303eIZ`3om^h0ooK^0080?EV[1`3om^h0100mFJ/0ooK^0?ofkP3om^h303eIZ`D0ooK^
00<0?EV[0?ofkP3om^h0503om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP030000003om^h0ooK^05L0ooK^
0@3oool001d0ooK^00<000000?ofkP3om^h05`3om^h00`000000ooK^0?ofkP0Y0?ofkP030=@m6@3o
m^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3o
m^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP070?ofkP80e3dI2`3o
m^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h0403o
m^h01P3D?AT0ooK^0?ofkP3om^h0e3dI0?ofkP80e3dI2P3om^h0103D?AT0ooK^0?ofkP3D?AT30?of
kP030=@m6@000000000000801PTB00<0000000H94P0000000P00000400d@7P040=@m6@0=41h03A0N
0=@m6@803A0N0`0000001`0G73`0000001LL?00G73`0e3dI01LL?03D?AT01@0G73`203eIZ`030:@Z
3`000000000000L0ooK^00<0?EV[0?ofkP3om^h00P0mFJ/30?ofkP<0000000<0?EV[0?ofkP3om^h0
103om^h203eIZ`030?ofkP0mFJ/0ooK^00/0ooK^0`0mFJ/80?ofkP0303eIZ`000000ooK^00X0ooK^
0`0mFJ/90?ofkP0403eIZ`3om^h0?EV[03eIZ`P0ooK^00<0?EV[0?ofkP3om^h05@3om^h00`0mFJ/0
ooK^0?ofkP090?ofkP030000003om^h0ooK^05L0ooK^0@3oool001`0ooK^00<000000?ofkP3om^h0
6@3om^h00`000000ooK^0?ofkP0X0?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h0
0`3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h0
303om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h0
2@3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^0100ooK^00<0e3dI0?ofkP3om^h0
0P3D?AT=0?ofkP070=@m6@3om^h0ooK^0=@m6@0mFJ/000000=@m6@0300H94P<000001`0=41h01000
0000e3dI0000003D?AT2000000@05a`l00@0000001LL?00G73`05a`l0P3D?AT401LL?08000000`2T
:Pl2000000H0ooK^0`0mFJ/30?ofkP8000000`3om^h0100mFJ/0ooK^0?ofkP3om^h303eIZ`<0ooK^
00<0?EV[0?ofkP3om^h01`3om^h303eIZ`80ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^
000000070?ofkP<0?EV[00<0ooK^03eIZ`3om^h0203om^h303eIZ`/0ooK^00<0?EV[0?ofkP3om^h0
503om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP030000003om^h0ooK^05H0ooK^0@3oool001`0ooK^00<0
00000?ofkP3om^h06P3om^h00`000000ooK^0?ofkP0V0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0
e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^0080ooK^00<0
e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0
e3dI0?ofkP3om^h01P3om^h20=@m6@X0ooK^00<0e3dI0?ofkP3om^h0403om^h20=@m6@h0ooK^1000
00001@3D?AT01PTB00H94P3D?AT01PTB0080000000<03A0N0000000=41h01P0=41h300000080e3dI
1P0G73`0200000005a`l01LL?00G73`0e3dI01LL?03D?AT05a`l0P0000000`0P:UT0000000000002
0:@Z3`8000000`3om^h403eIZ`80ooK^0`0000060?ofkP<0?EV[1P3om^h00`0mFJ/0ooK^0?ofkP05
0?ofkP80?EV[1@3om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`000000ooK^00@0ooK^0P0mFJ/5
0?ofkP0303eIZ`3om^h0ooK^00<0ooK^0`0mFJ/00`3om^h0?EV[0?ofkP0;0?ofkP0303eIZ`3om^h0
ooK^01D0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`000000ooK^0?ofkP1F0?ofkP40oooo000L0?of
kP030000003om^h0ooK^01/0ooK^00<000000?ofkP3om^h09@3om^h00`3D?AT0ooK^0?ofkP0>0?of
kP040=@m6@3om^h0ooK^0=@m6A80ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0A0?ofkP050=@m6@3o
m^h0ooK^0?ofkP3D?AT04P3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00X0ooK^
00<0e3dI0?ofkP3om^h03P3om^h20=@m6@030?ofkP3D?AT0ooK^00/0ooK^00<0000000H84@062140
0P00000010062A8000000=@m6@3D?AT2000000<03A0N00<0000000d@7P0=41h00`0=41h200000005
01LL?00000005a`l01LL?03D?AT01`0G73`0100000005a`l01LL?00G73`20=@m6@070000000P:UT0
82YI020ZF@000000d3PE000000020:@Z3`8000000P0mFJ/30?ofkP<000001`3om^h203eIZ`030?of
kP0mFJ/0ooK^00L0ooK^00@0?EV[0?ofkP3om^h0ooK^0`0mFJ/80?ofkP0303eIZ`3om^h0ooK^00H0
ooK^00@0?EV[0?ofkP000000ooK^0`0mFJ/70?ofkP0303eIZ`3om^h0ooK^00<0?EV[1@3om^h00`0m
FJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^01<0ooK^0P0mFJ/<0?ofkP030000003om^h0ooK^
05D0ooK^0@3oool001`0ooK^00<000000?ofkP3om^h0703om^h00`000000ooK^0?ofkP0S0?ofkP03
0=@m6@3om^h0ooK^0100ooK^00<0e3dI0?ofkP3D?AT04`3om^h00`3D?AT0ooK^0=@m6@0C0?ofkP03
0=@m6@3om^h0e3dI01@0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP03
0=@m6@3om^h0ooK^00/0ooK^0P3D?AT20?ofkP030=@m6@3om^h0e3dI00T0ooK^1@00000200H94P04
000000062A8000000=@m6@D03A0N00@0000000d@7P0=41h03A0N0P00000301LL?0030000000G73`0
5a`l0080e3dI1P0G73`01P0000005a`l00000000000082YI0=@m6@@082YI00D000000=0h5@3@>1D0
00000:@Z3`0300000080ooK^0P0000000`0mFJ/0ooK^0?ofkP040?ofkP<0?EV[103om^h00`0mFJ/0
ooK^0?ofkP050?ofkP@0?EV[303om^h00`0mFJ/0ooK^0?ofkP050?ofkP0403eIZ`3om^h0?EV[0000
00X0ooK^0`0mFJ/80?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h0403om^h303eI
Z`030?ofkP0mFJ/0ooK^00`0ooK^00<000000?ofkP3om^h0E03om^h10?ooo`00703om^h00`000000
ooK^0?ofkP0M0?ofkP030000003om^h0ooK^0280ooK^00<0e3dI0?ofkP3om^h04@3om^h00`3D?AT0
ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h0503om^h0103D?AT0
ooK^0=@m6@3D?AT@0?ofkP030=@m6@3om^h0ooK^00P0ooK^0P3D?AT30?ofkP050=@m6@3om^h0e3dI
0?ofkP3D?AT01P3om^h4000000@01PTB0`0000000`3D?AT03A0N0=@m6@0400d@7P040000000=41h0
0000000000D05a`l00<0000001LL?03D?AT00P0G73`00`3D?AT05a`l01LL?00201LL?0<000000`0P
:UT20=@m6@<082YI00L000000=0h5@3@>1D000000:@Z3`000000Y2X?00<000000P3om^h0100mFJ/0
ooK^0?ofkP3om^h303eIZ`L0ooK^00<0?EV[0?ofkP3om^h0103om^h203eIZ`l0ooK^00<0?EV[0?of
kP3om^h0103om^h303eIZ`80ooK^00<000000?ofkP3om^h0103om^h303eIZ`030?ofkP0mFJ/0ooK^
00P0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP<0?EV[1@3om^h00`0m
FJ/0ooK^0?ofkP0:0?ofkP030000003om^h0ooK^05@0ooK^0@3oool001/0ooK^00<000000?ofkP3o
m^h07`3om^h200000280ooK^0P3D?ATB0?ofkP80e3dI4`3om^h00`3D?AT0ooK^0=@m6@0C0?ofkP03
0=@m6@3om^h0e3dI01H0ooK^00<0e3dI0?ofkP3om^h04@3om^h00`3D?AT0ooK^0?ofkP050?ofkP80
e3dI103om^h01`3D?AT0ooK^0?ofkP3om^h0e3dI0?ofkP3D?AT00P3om^h5000000<01PTB0`000000
100=41h0000000d@7P3D?AT200d@7P030=@m6@0=41h03A0N00<00000200G73`01@000000e3dI01LL
?00G73`0e3dI00805a`l0P0000000`0P:UT00000020ZF@03020ZF@030=@m6@0P:UT0e3dI00<082YI
00<000000=0h5@3@>1D00`0000000`2T:Pl000000?ofkP020?ofkP0403eIZ`3om^h0?EV[03eIZ`/0
ooK^00<0?EV[0?ofkP3om^h00`0mFJ/00`3om^h0?EV[0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00<0
?EV[00<0ooK^03eIZ`3om^h00P3om^h00`000000ooK^0?ofkP020?ofkP80?EV[1@3om^h00`0mFJ/0
ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h02P3om^h203eIZ`P0
ooK^00<0?EV[0?ofkP3om^h02`3om^h00`000000ooK^0?ofkP1C0?ofkP40oooo000K0?ofkP030000
003om^h0ooK^0240ooK^00<000000?ofkP3om^h07`3om^h00`3D?AT0ooK^0=@m6@0@0?ofkP040=@m
6@3om^h0ooK^0=@m6A80ooK^00@0e3dI0?ofkP3om^h0e3dI4@3om^h01@3D?AT0ooK^0?ofkP3om^h0
e3dI01@0ooK^00<0e3dI0?ofkP3D?AT04`3om^h00`3D?AT0ooK^0?ofkP020?ofkP80e3dI1P3om^h0
0`3D?AT0ooK^0?ofkP020?ofkP030=@m6@000000000000<000000P062A84000000@03A0N00<00000
0=@m6@0=41h00`0=41h0103D?AT0000001LL?000000901LL?0070000003D?AT05a`l01LL?0000000
e3dI00000003020ZF@030000000P:UT082YI008082YI00<0e3dI020ZF@3D?AT00`0P:UT300000007
0=0h5@00000000000:@Z3`000000N1d;0?ofkP0303eIZ`d0ooK^0`0mFJ/40?ofkP0303eIZ`3om^h0
ooK^00h0ooK^0`0mFJ/40?ofkP0303eIZ`3om^h0ooK^0080ooK^00@0000003eIZ`0mFJ/0?EV[1`3o
m^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h01P3o
m^h303eIZ`X0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`000000ooK^0?ofkP1C0?ofkP40oooo000K
0?ofkP030000003om^h0ooK^0280ooK^00<000000?ofkP3om^h07@3om^h0103D?AT0ooK^0?ofkP3o
m^h20=@m6@h0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0@0?ofkP030=@m6@3om^h0ooK^0080ooK^
00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^0100ooK^
00D0e3dI0?ofkP3om^h0ooK^0=@m6@0C0?ofkP040=@m6@3om^h0e3dI0=@m6@L0ooK^00<0e3dI0?of
kP3om^h0100000000`3D?AT0000000H94P0200H94P<000001P0=41h0100000003A0N0=@m6@0=41h3
0000000401LL?03D?AT05a`l000000T05a`l00@0e3dI01LL?000000000000P0P:UT01@3D?AT082YI
020ZF@0P:UT0000000@082YI00@0e3dI020ZF@0P:UT0e3dI0`0000040=0h5@030000002T:Pl0Y2X?
0080?EV[00<0ooK^03eIZ`3om^h02`3om^h203eIZ`80ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0m
FJ/0ooK^0?ofkP0;0?ofkP<0?EV[00<0ooK^03eIZ`3om^h01@3om^h00`0mFJ/0ooK^03eIZ`0203eI
Z`030000003om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP0;0?of
kP0303eIZ`3om^h0ooK^00<0ooK^0`0mFJ/>0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<000000?of
kP3om^h0DP3om^h10?ooo`006`3om^h00`000000ooK^0?ofkP0S0?ofkP030000003om^h0ooK^01`0
ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00<0
ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00`0
ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00<0
ooK^00<0e3dI0?ofkP3om^h04@3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0000000D0
000000<01PTB0=@m6@062A800P0000000`0=41h0000000d@7P0600d@7P040000003D?AT000000000
00D05a`l00<0e3dI0000000G73`01`0G73`00`000000e3dI00000005020ZF@040=@m6@0P:UT082YI
000000@082YI00L0e3dI020ZF@00000000000=@m6@0P:UT0000000@0d3PE0`0mFJ/30000000303eI
Z`3om^h0ooK^00L0ooK^0`0mFJ/40?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h0
2@3om^h203eIZ`D0ooK^00<0?EV[0?ofkP3om^h00`3om^h203eIZ`<0ooK^00<000000?ofkP3om^h0
203om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP0mFJ/0
0P0mFJ/A0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<000000?ofkP3om^h0D@3om^h10?ooo`006P3o
m^h00`000000ooK^0?ofkP0U0?ofkP030000003om^h0ooK^01/0ooK^00<0e3dI0?ofkP3om^h0103o
m^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h02`3o
m^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h01P3o
m^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h03`3o
m^h00`3D?AT0ooK^0=@m6@060?ofkP030=@m6@000000000000<0000000H01PTB000000062A801PTB
0000003D?AT300d@7P030000000=41h03A0N00@03A0N0P0000000`3D?AT05a`l01LL?00601LL?003
0=@m6@0G73`05a`l00@05a`l0P0000000`0P:UT0e3dI020ZF@06020ZF@040=@m6@0P:UT082YI0000
008082YI0`000003020ZF@040=@m6@000000d3PE0=0h5@80?EV[0P0000020:@Z3`80000000<0?EV[
0?ofkP3om^h01@3om^h203eIZ`P0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP05
0?ofkP<0?EV[1`3om^h00`0mFJ/0ooK^0?ofkP0403eIZ`D0ooK^00<000000?ofkP3om^h0203om^h0
0`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00/0ooK^0`0mFJ/D0?ofkP0303eIZ`3om^h0
ooK^00`0ooK^00<000000?ofkP3om^h0D@3om^h10?ooo`006P3om^h00`000000ooK^0?ofkP0V0?of
kP030000003om^h0ooK^01X0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP080?of
kP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP070?of
kP80e3dI2@3om^h00`3D?AT0ooK^0?ofkP080?ofkP80e3dI2`3om^h00`3D?AT0ooK^0?ofkP070?of
kP030=@m6@3om^h0ooK^00d0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@040?ofkP030=@m6@000000
0000008000000`062A83000000803A0N00<0e3dI00d@7P0000001@0=41h20000000301LL?03D?AT0
5a`l00P05a`l00@0e3dI01LL?00G73`05a`l0`000002020ZF@030=@m6@00000082YI00H082YI00<0
e3dI020ZF@0P:UT00`000000103D?AT082YI020ZF@0P:UT20000000402PgL@000000?EV[03eIZ`80
d3PE00P000000=0h5@000000Y2X?0000002T:Pl0?EV[000000<0ooK^0`0mFJ/;0?ofkP0503eIZ`3o
m^h0ooK^0?ofkP0mFJ/0103om^h303eIZ`X0ooK^0`0mFJ/30?ofkP0303eIZ`3om^h0ooK^00@0ooK^
00<000000?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00L0ooK^
0`0mFJ/00`3om^h0?EV[0?ofkP0E0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<000000?ofkP3om^h0
D03om^h10?ooo`006P3om^h00`000000ooK^0?ofkP0W0?ofkP030000003om^h0ooK^01P0ooK^00<0
e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00L0ooK^0P3D
?AT90?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?of
kP0:0?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?of
kP0;0?ofkP80e3dI103om^h00`3D?AT0ooK^0?ofkP02000000030=@m6@0mFJ/0000000<01PTB0`00
000400d@7P030=@m6@0=41h0000000<03A0N0P00000301LL?0030=@m6@0G73`05a`l00L05a`l00@0
00000=@m6@00000000001@0P:UT00`3D?AT00000020ZF@07020ZF@<000000P0P:UT0103D?AT00000
00000000000302PgL@030000003`@QX000000080d3PE00<000000=0h5@3@>1D00P0000000`2T:Pl0
?EV[0000000303eIZ`h0ooK^00H0?EV[0?ofkP3om^h0ooK^03eIZ`3om^h303eIZ`X0ooK^0`0mFJ/0
0`3om^h0?EV[0?ofkP030?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<000000?ofkP3om^h01`3om^h0
0`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00@0ooK^0`0mFJ/50?ofkP0303eIZ`3om^h0
ooK^01<0ooK^00<0?EV[0?ofkP3om^h0303om^h00`000000ooK^0?ofkP1@0?ofkP40oooo000J0?of
kP030000003om^h0ooK^02P0ooK^0P00000H0?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?of
kP3om^h01@3om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?of
kP3om^h02`3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?of
kP3om^h01@3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?of
kP3om^h01@3om^h3000000030=@m6@062A80000000801PTB0P0000000`0=41h0000000d@7P0500d@
7P030=@m6@0000003A0N00800000100G73`00`3D?AT0000001LL?00701LL?0<0000000<0e3dI020Z
F@0P:UT0100P:UT00`3D?AT00000020ZF@04020ZF@<0000000H082YI0=@m6@00000082YI0000003D
?AT602PgL@040000003`@QX0l48J00000080d3PE00P000000=0h5@3@>1D000000:@Z3`0mFJ/0Y2X?
00000140ooK^00<0?EV[0?ofkP0mFJ/00P0mFJ/;0?ofkP80?EV[1@3om^h01@0mFJ/0ooK^0?ofkP3o
m^h0?EV[00L0ooK^00<000000?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP040?ofkP80?EV[103o
m^h203eIZ`P0ooK^00<0?EV[0?ofkP3om^h0503om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP030000003o
m^h0ooK^04l0ooK^0@3oool001T0ooK^00<000000?ofkP3om^h0:`3om^h00`000000ooK^0?ofkP0E
0?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP0:
0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP02
0?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP0<
0?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h00`3om^h40000000300H94P3D?AT0
1PTB00@000000P0=41h00`0000003A0N00d@7P0500d@7P030000003D?AT0000000H05a`l00<0e3dI
0000000G73`01@0G73`200000005020ZF@00000082YI020ZF@3D?AT0100P:UT00`3D?AT082YI0000
0002020ZF@<00000100P:UT01@000000e3dI0000000X=g40e3dI00H0:3Ma00@000000?126P3`@QX0
00000P3@>1D00`000000d3PE0=0h5@020000000403eIZ`3D?AT0Y2X?000000l0ooK^0`0mFJ/00`3o
m^h0?EV[0?ofkP080?ofkP<0?EV[1`3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^
00D0ooK^00<000000?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP0303eIZ`030?ofkP0mFJ/0ooK^
00<0?EV[2P3om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<000000?of
kP3om^h0CP3om^h10?ooo`006@3om^h00`000000ooK^0?ofkP0/0?ofkP030000003om^h0ooK^01@0
ooK^00<0e3dI0?ofkP3om^h02P3om^h20=@m6@<0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0
ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00h0ooK^00@0e3dI0?ofkP3om^h0e3dI4P3om^h01@3D
?AT0ooK^0?ofkP3om^h0e3dI0100ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP06
000000801PTB00@0e3dI00000000000000001@0=41h00`0000003A0N00d@7P0200d@7P<0000000<0
5a`l0000003D?AT01@0G73`00`3D?AT05a`l0000000301LL?0<000000`0P:UT01@00000082YI020Z
F@0P:UT0e3dI00<082YI00<0e3dI020ZF@0000000P000004020ZF@<0000000D0:3Ma0000003D?AT0
:3Ma0=@m6@0602PgL@070000003`@QX0l48J0?126P000000d3PE000000030=0h5@040000002T:Pl0
?EV[0:@Z3`800000303om^h203eIZ`80ooK^00<0?EV[0?ofkP0mFJ/01P3om^h303eIZ`/0ooK^00D0
?EV[0?ofkP3om^h0ooK^03eIZ`080?ofkP030000003om^h0ooK^00H0ooK^0`0mFJ/30?ofkP<0?EV[
3P3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<000000?ofkP3om^h0
CP3om^h10?ooo`006@3om^h00`000000ooK^0?ofkP0]0?ofkP030000003om^h0ooK^0180ooK^00<0
e3dI0?ofkP3om^h03@3om^h0103D?AT0ooK^0?ofkP3D?AT?0?ofkP040=@m6@3om^h0ooK^0=@m6A80
ooK^00<0e3dI0?ofkP3D?AT04`3om^h00`3D?AT0ooK^0=@m6@0B0?ofkP030=@m6@3om^h0ooK^00<0
ooK^00<0e3dI0?ofkP0000001P0000000`062A8000000=@m6@02000000H03A0N00<0000000d@7P00
00000`00000401LL?0030000000G73`0e3dI00@05a`l00@0e3dI01LL?00000005a`l0P000006020Z
F@030000000P:UT082YI008082YI00<0e3dI020ZF@0P:UT00`000004020ZF@800000100X=g401000
0000e3dI02PgL@3D?AT602PgL@030000003`@QX0l48J0080l48J0P0000030=0h5@80000000<0?EV[
0=@m6@0000000P0000080?ofkP<0?EV[1@3om^h00`0mFJ/0ooK^03eIZ`030?ofkP80?EV[3P3om^h0
1@0mFJ/0ooK^0?ofkP3om^h0?EV[00P0ooK^00<000000?ofkP3om^h00`3om^h303eIZ`030?ofkP0m
FJ/0ooK^00<0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^01@0ooK^00<0
?EV[0?ofkP3om^h03@3om^h00`000000ooK^0?ofkP1=0?ofkP40oooo000I0?ofkP030000003om^h0
ooK^02h0ooK^00<000000?ofkP3om^h04@3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP80e3dI4@3om^h0
0`3D?AT0ooK^0=@m6@0C0?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h04P3om^h0
0`3D?AT0ooK^0?ofkP020=@m6@@000000P062A840000000400d@7P3D?AT03A0N000000D03A0N0`00
000801LL?0040000000G73`05a`l0=@m6@805a`l00<0e3dI01LL?00000000P000008020ZF@030000
000P:UT082YI00<082YI0P000002020ZF@030000000P:UT00000008000001P0X=g4010000000:3Ma
0=@m6@3D?AT602PgL@030000003`@QX0l48J00<0l48J00L000000=0h5@3@>1D0d3PE0000003@>1D0
?EV[0080Y2X?0`0000040?ofkP<0?EV[203om^h00`0mFJ/0ooK^03eIZ`0303eIZa40ooK^00@0?EV[
0?ofkP3om^h0?EV[2@3om^h00`000000ooK^03eIZ`0203eIZ`<0ooK^0`0mFJ/50?ofkP0303eIZ`3o
m^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h04`3om^h203eIZa00ooK^00<000000?ofkP3om^h0C03o
m^h10?ooo`006@3om^h00`000000ooK^0?ofkP0_0?ofkP030000003om^h0ooK^0100ooK^00<0e3dI
0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP0@0?ofkP030=@m6@3om^h0ooK^0140ooK^00<0e3dI
0?ofkP3D?AT04`3om^h00`3D?AT0ooK^0=@m6@0D0?ofkP80e3dI1000000200H94P<000000`0=41h0
0`3D?AT03A0N0000000400d@7P80000000<05a`l0000000G73`01`0G73`00`0000005a`l01LL?002
01LL?0060=@m6@0G73`0e3dI0000000P:UT000002@0P:UT00`00000082YI020ZF@0300000003020Z
F@3D?AT082YI00<000002@0X=g4010000000:3Ma02PgL@3D?AT602PgL@030000003`@QX0l48J00<0
l48J0P0000020=0h5@090000003@>1D0?EV[0000003D?AT000000:@Z3`000000ooK^00<0?EV[2`3o
m^h303eIZa@0ooK^00@0?EV[0?ofkP3om^h0?EV[203om^h203eIZ`040000003om^h0ooK^0?ofkP<0
?EV[00<0ooK^03eIZ`3om^h01@3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00l0
ooK^0`0mFJ/00`3om^h0?EV[0?ofkP0?0?ofkP030000003om^h0ooK^04`0ooK^0@3oool001P0ooK^
00<000000?ofkP3om^h0<@3om^h00`000000ooK^0?ofkP0?0?ofkP80e3dI403om^h20=@m6A40ooK^
0P3D?ATB0?ofkP040=@m6@3om^h0ooK^0=@m6A40ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0B0?of
kPH0000000@01PTB0000000000000000100=41h0103D?AT03A0N00d@7P00000200d@7P8000000`0G
73`00`0000005a`l01LL?00601LL?0040000000G73`05a`l01LL?080000000D0e3dI020ZF@0P:UT0
82YI00000009020ZF@<000000`0P:UT01@3D?AT000000=@m6@0X=g40000000X0:3Ma00<0000002Pg
L@0X=g400P3D?AT502PgL@030000003`@QX0l48J00<0l48J0P0000020=0h5@070000003@>1D0?EV[
0000002T:Pl000000:@Z3`0203eIZ``0ooK^0P0mFJ/00`3om^h0?EV[03eIZ`0E0?ofkP0403eIZ`3o
m^h0ooK^03eIZ`@0ooK^0`0mFJ/30?ofkP030000000mFJ/0?EV[00D0ooK^00<0?EV[0?ofkP3om^h0
103om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00`0ooK^0`0mFJ/50?ofkP0303eI
Z`3om^h0ooK^00h0ooK^00<000000?ofkP3om^h0B`3om^h10?ooo`00603om^h00`000000ooK^0?of
kP0b0?ofkP8000003`3om^h00`3D?AT0ooK^0=@m6@0>0?ofkP040=@m6@3om^h0ooK^0=@m6@l0ooK^
00@0e3dI0?ofkP3om^h0e3dI403om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00h0
ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP0;0?ofkPD0000000<0?EV[00H94P00
00000`00000200d@7P090000000=41h03A0N00d@7P3D?AT03A0N0=@m6@0000003A0N008000001@0G
73`00`0000005a`l01LL?00601LL?0080000000G73`000000000000P:UT0e3dI020ZF@3D?AT2020Z
F@030000000P:UT082YI00D082YI0`000003020ZF@80000000D0e3dI02PgL@0X=g40e3dI00000009
02PgL@040000000X=g40:3Ma0=@m6@80:3Ma00<0e3dI02PgL@0X=g400P0X=g400`000000l48J0?12
6P030?126P030000003`@QX000000080d3PE00<0000003eIZ`3@>1D00`0mFJ/00`2T:Pl000000000
00080?ofkP<0?EV[103om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0503eIZ`3om^h0ooK^03eIZ`3om^h0
0`0mFJ/40?ofkP80?EV[00<000000?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eI
Z`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h02@3om^h203eIZ`P0ooK^00<0?EV[0?ofkP3om^h0
3P3om^h00`000000ooK^0?ofkP1;0?ofkP40oooo000H0?ofkP030000003om^h0ooK^03@0ooK^00<0
00000?ofkP3om^h0303om^h0103D?AT0ooK^0?ofkP3D?AT=0?ofkP050=@m6@3om^h0ooK^0?ofkP3D
?AT03P3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00l0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D
?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h01`3om^h30000
000400H84@000000?EV[000000801PTB0P00000400d@7P050000000=41h03A0N00d@7P3D?AT00P0=
41h00`000000e3dI0000000601LL?0030000000G73`05a`l00H05a`l0`000002020ZF@070=@m6@0P
:UT082YI020ZF@3D?AT082YI00000004020ZF@<000000P0P:UT01P00000082YI000000000000:3Ma
0=@m6@<0:3Ma00<0e3dI0000000X=g40200X=g4010000000:3Ma02PgL@3D?AT302PgL@030=@m6@0X
=g40:3Ma008000001@3`@QX01@000000l48J0?126P000000d3PE00<0?EV[00<0d3PE000000000000
0P2T:Pl2000000D0ooK^0P0mFJ/70?ofkP0303eIZ`3om^h0ooK^01@0ooK^100mFJ/40?ofkP<0?EV[
0`3om^h00`000000ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h0
3@3om^h00`0mFJ/0ooK^0?ofkP060?ofkP<0?EV[2`3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP030000
003om^h0ooK^04X0ooK^0@3oool001P0ooK^00<000000?ofkP3om^h0=@3om^h00`000000ooK^0?of
kP0;0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT0303om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m
6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m
6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m
6@3om^h0ooK^00@0ooK^0P00000200H84@80000000<01PTB000000062A800P00000600d@7P040000
000=41h03A0N0=@m6@<0000000<05a`l0000003D?AT01P0G73`00`0000005a`l01LL?00401LL?080
000000<082YI0000000P:UT00P0P:UT00`3D?AT082YI020ZF@02020ZF@030=@m6@0P:UT082YI00<0
0000100P:UT3000000<0:3Ma00<0e3dI02PgL@0X=g400P0X=g400`3D?AT0:3Ma02PgL@0702PgL@04
0000000X=g40:3Ma0=@m6@<0:3Ma00@0e3dI000000000000;T230P0000040?126P030000003`@QX0
l48J0080?EV[00<0000003eIZ`3@>1D00P3@>1D00`000000Y2X?0:@Z3`03000000040?ofkP0mFJ/0
?EV[03eIZ`X0ooK^00<0?EV[0?ofkP3om^h04@3om^h303eIZ`030?ofkP0mFJ/0ooK^0080ooK^0P0m
FJ/70?ofkP030000003om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?of
kP0<0?ofkP0303eIZ`3om^h0ooK^00<0ooK^0`0mFJ/>0?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0
00000?ofkP3om^h0B@3om^h10?ooo`005`3om^h00`000000ooK^0?ofkP0g0?ofkP030000003om^h0
ooK^00X0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0
ooK^00<0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0
ooK^00T0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0
ooK^00P0ooK^00@0e3dI0?ofkP3om^h0ooK^0P0000001@062140?EV[0000000000001PTB00@00000
00<03A0N0000000=41h0100=41h01@0000003A0N0000003D?AT0000000<05a`l00@0000001LL?00G
73`0e3dI1@0G73`0100000005a`l01LL?00G73`3000000<082YI00@00000020ZF@0P:UT0e3dI1@0P
:UT00`3D?AT0000000000004020ZF@<0000000<0:3Ma0000000X=g400P0X=g400`3D?AT0:3Ma02Pg
L@0302PgL@030000003D?AT0:3Ma00L0:3Ma00<0000002PgL@3D?AT00P0X=g420000000702i0P`3D
?AT0;T2302i0P`000000odPM000000030?126P040000000mFJ/0?EV[0?126P80000000@0?EV[0=0h
5@3@>1D0d3PE0P0000020:@Z3`80000000<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP0>
0?ofkP<0?EV[0`3om^h00`0mFJ/0ooK^03eIZ`0203eIZ`X0ooK^00<000000?ofkP3om^h0103om^h0
0`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP0mFJ/00P0mFJ/B
0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<000000?ofkP3om^h0B@3om^h10?ooo`005`3om^h00`00
0000ooK^0?ofkP0h0?ofkP030000003om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D
?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D
?AT0ooK^0?ofkP050?ofkP80e3dI2@3om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^
00P0ooK^00<0e3dI0?ofkP3om^h02@3om^h01@3D?AT00000000000000000?EV[008000000P062A83
000000803A0N00<0000000d@7P0=41h00`0=41h3000000030=@m6@0G73`05a`l00<05a`l00D00000
01LL?00G73`05a`l0=@m6@0401LL?0040000000G73`00000000000H082YI00<00000020ZF@3D?AT0
100P:UT3000000040=@m6@0P:UT082YI020ZF@800000100X=g401@000000:3Ma02PgL@0X=g40e3dI
00D0:3Ma00<0000002PgL@3D?AT01`0X=g400`000000:3Ma0=@m6@02000000@0;T2300<0e3dI02i0
P`0000000P3oB1d010000000?EV[03eIZ`0mFJ/40?126P030000003@>1D0?EV[0080d3PE00@00000
0=0h5@000000Y2X?0`00000=0?ofkP80?EV[303om^h303eIZ`D0ooK^100mFJ/<0?ofkP030000003o
m^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP<0?EV[5@3o
m^h00`0mFJ/0ooK^0?ofkP0?0?ofkP030000003om^h0ooK^04P0ooK^0@3oool001L0ooK^00<00000
0?ofkP3om^h0>@3om^h00`000000ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI
0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP060?ofkP80e3dI1`3om^h00`3D?AT0ooK^0?ofkP08
0?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP06
0?ofkP030=@m6@3om^h0ooK^00P0ooK^1000000200H94P03000000062A801PTB00<00000100=41h0
100000003A0N00d@7P0=41h20000000301LL?0000000e3dI00H05a`l00<0000001LL?00G73`00P0G
73`00`3D?AT05a`l01LL?003000000P082YI00<000000=@m6@0P:UT00P0P:UT20000008082YI00<0
0000020ZF@3D?AT00P00000602PgL@040000000X=g40:3Ma0=@m6@H0:3Ma00@0000002PgL@0X=g40
e3dI1@0X=g43000000030=@m6@0^@8<0;T2300D0;T2300<0e3dI0000003oB1d00P0mFJ/00`3`@QX0
e3dI000000040?126P80000000T0?EV[0=0h5@3@>1D000000=0h5@000000Y2X?0000002T:Pl00P00
000<0?ofkP80?EV[2P3om^h203eIZ`D0ooK^0`0mFJ/0103om^h0?EV[0?ofkP0mFJ/=0?ofkP030000
003om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP080?ofkP<0?EV[
00<0ooK^03eIZ`3om^h05@3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP030000003om^h0ooK^04P0ooK^
0@3oool001L0ooK^00<000000?ofkP3om^h0>P3om^h00`000000ooK^0?ofkP060?ofkP030=@m6@3o
m^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3o
m^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3o
m^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP060?ofkP@0000000<0
?EV[00H94P062A801P00000500d@7P030000000=41h03A0N008000000P0G73`00`000000e3dI01LL
?00601LL?0030000000G73`05a`l00805a`l00D000000=@m6@00000082YI00000008020ZF@030000
003D?AT082YI00<000000`0P:UT30000000302PgL@3D?AT0:3Ma00H0:3Ma00@0000002PgL@0X=g40
e3dI1P0X=g4010000000:3Ma02PgL@3D?AT302PgL@80000000<0;T230000003D?AT0200^@8<00`3D
?AT0?EV[03eIZ`020?m87@030000003`@QX0000000@0l48J00<000000?126P0mFJ/00P3@>1D00`00
0000d3PE0=0h5@02000000040:@Z3`000000e3dI000000/0ooK^00<0?EV[0?ofkP0mFJ/01P3om^h3
03eIZ`@0ooK^0`0mFJ/50?ofkP80?EV[3P3om^h00`000000ooK^0?ofkP030?ofkP0303eIZ`3om^h0
ooK^00<0ooK^00<0?EV[0?ofkP3om^h01P3om^h203eIZ`D0ooK^00<0?EV[0?ofkP3om^h0503om^h0
0`0mFJ/0ooK^0?ofkP0?0?ofkP030000003om^h0ooK^04L0ooK^0@3oool001L0ooK^00<000000?of
kP3om^h0>`3om^h2000000H0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP030?of
kP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP0:0?of
kP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP020?of
kP030=@m6@3om^h0ooK^00D0ooK^1@00000200H94P@000000P0=41h00`0000003A0N00d@7P0400d@
7P<00000100G73`00`3D?AT05a`l01LL?00501LL?0030000000G73`0000000<0000000D082YI0=@m
6@0P:UT082YI00000008020ZF@<00000100P:UT20000000302PgL@000000:3Ma0080:3Ma00<0e3dI
02PgL@0X=g40100X=g400`000000:3Ma0=@m6@0702PgL@050000000X=g40:3Ma02PgL@3D?AT00P00
000302i0P`030000003D?AT0;T2300P0;T2300<000000?m87@3oB1d00P3oB1d2000000@0l48J00@0
00000?126P0mFJ/000000P3@>1D00`000000d3PE0=0h5@02000000040:@Z3`000000e3dI000000/0
ooK^0P0mFJ/30?ofkP<0?EV[0`3om^h403eIZ`P0ooK^00<0?EV[0?ofkP0mFJ/03@3om^h00`000000
ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h00`3om^h303eIZ`L0
ooK^00<0?EV[0?ofkP3om^h0503om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP030000003om^h0ooK^04H0
ooK^0@3oool001H0ooK^00<000000?ofkP3om^h0?P3om^h00`000000ooK^0?ofkP030?ofkP030=@m
6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP050=@m
6@3om^h0ooK^0?ofkP3D?AT03P3om^h0103D?AT0ooK^0?ofkP3D?AT@0?ofkP050=@m6@3om^h0ooK^
0?ofkP3D?AT01@3om^h30000000400H94P0000001PTB00H94P<00000100=41h00`0000003A0N00d@
7P0300d@7P<000001@0G73`00`3D?AT0000001LL?00501LL?0<000001P0P:UT00`3D?AT082YI0000
0006020ZF@80000000@0e3dI020ZF@0P:UT082YI0`00000302PgL@030000000X=g40:3Ma0080:3Ma
00<0e3dI02PgL@0X=g400`0X=g400`000000:3Ma0=@m6@0702PgL@060000000X=g4000000000000^
@8<0e3dI100^@8<00`000000e3dI02i0P`0702i0P`030000003oB1d0odPM00@0odPM00<000000?12
6P3`@QX00P3`@QX01`000000l48J03eIZ`000000d3PE0=@m6@0000000`3@>1D00`000000Y2X?0000
0002000000/0ooK^00<0?EV[0?ofkP0mFJ/00P0mFJ/30?ofkP<0?EV[3@3om^h203eIZ`h0ooK^00<0
00000?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00<0?EV[2`3o
m^h00`0mFJ/0ooK^0?ofkP0D0?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<000000?ofkP3om^h0AP3o
m^h10?ooo`005P3om^h00`000000ooK^0?ofkP0o0?ofkP030000003om^h0ooK^0080ooK^00<0e3dI
0?ofkP3om^h02@3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00h0ooK^00@0e3dI0?ofkP3om^h0e3dI
3`3om^h00`3D?AT0ooK^0=@m6@0A0?ofkP030=@m6@3om^h0e3dI00@0ooK^0`000000100mFJ/01PTB
000000062A83000000H03A0N00<0000000d@7P0=41h00`0000000`0G73`0000001LL?00401LL?003
0=@m6@0G73`0000000@05a`l0P0000000`0P:UT00000020ZF@07020ZF@030=@m6@00000082YI0080
82YI0`000000100P:UT0e3dI0000000P:UT2000000H0:3Ma00<0000002PgL@0X=g400`0X=g400`3D
?AT0:3Ma02PgL@0202PgL@030000003D?AT0:3Ma00H0:3Ma0`00000402i0P`050=@m6@0^@8<0;T23
02i0P`3D?AT02@0^@8<00`000000odPM0?m87@040?m87@8000000`3`@QX01`000000l48J03eIZ`3`
@QX000000=0h5@0000000`3@>1D2000000040=@m6@0000000000000000T0ooK^100mFJ/20?ofkP<0
?EV[403om^h203eIZ`l0ooK^00<000000?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP80
?EV[3P3om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP0303eIZ`3om^h0ooK^0100ooK^00<000000?ofkP3o
m^h0A@3om^h10?ooo`005P3om^h00`000000ooK^0?ofkP100?ofkP050000003om^h0ooK^0?ofkP3D
?AT0303om^h0103D?AT0ooK^0?ofkP3D?AT?0?ofkP80e3dI4@3om^h00`3D?AT0ooK^0?ofkP0A0?of
kP040=@m6@3om^h0ooK^0?ofkP<000000P062A84000000803A0N00<0000000d@7P0=41h00`0=41h4
000000<05a`l00<0000001LL?00G73`00`0G73`00`3D?AT05a`l0000000301LL?08000000`0P:UT0
0`00000082YI020ZF@06020ZF@030000003D?AT00000008000000`0P:UT0103D?AT000000000000m
FJ/802PgL@030000000X=g40:3Ma00@0:3Ma00H0e3dI02PgL@0X=g40:3Ma0000003D?AT502PgL@80
000000<0;T230000000^@8<01@0^@8<0103D?AT0;T2302i0P`3D?AT902i0P`030000003oB1d0odPM
00@0odPM0P0000030?126P050000003`@QX0l48J03eIZ`3`@QX00P0000030=0h5@80000000<0Y2X?
0000000000000P0000050?ofkP<0?EV[00<0ooK^03eIZ`3om^h00`0mFJ/D0?ofkP0303eIZ`3om^h0
ooK^00h0ooK^00<000000?ofkP3om^h00P3om^h00`0mFJ/0ooK^03eIZ`0303eIZa00ooK^00<0?EV[
0?ofkP3om^h0503om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP030000003om^h0ooK^04D0ooK^0@3oool0
01H0ooK^00<000000?ofkP3om^h0@@3om^h010000000ooK^0?ofkP3D?AT=0?ofkP80e3dI4@3om^h0
0`3D?AT0ooK^0?ofkP0?0?ofkP80e3dI4@3om^h00`3D?AT0ooK^0=@m6@040000000400H94P000000
0000000000@03A0N00<0000000d@7P0=41h00P0=41h3000000H05a`l00<0000001LL?00G73`00P0G
73`01@3D?AT05a`l01LL?00000005a`l008000001@0P:UT00`00000082YI020ZF@06020ZF@800000
00<0e3dI020ZF@0P:UT00P0P:UT0103D?AT0000002PgL@00000902PgL@030000000X=g40:3Ma00@0
:3Ma00D0e3dI02PgL@0X=g40:3Ma0=@m6@0302PgL@<000000`0^@8<00`000000;T2302i0P`0402i0
P`040=@m6@0^@8<0;T230=@m6@T0;T2300<000000?m87@3oB1d0103oB1d00`000000odPM00000002
0?126P040000003`@QX0l48J03eIZ`80l48J00T000000=0h5@3@>1D0d3PE0000003@>1D000000=@m
6@2T:Pl00P0000030?ofkP80?EV[103om^h203eIZ`030?ofkP0mFJ/0ooK^01@0ooK^0P0mFJ/?0?of
kP040000003om^h0ooK^0?ofkPD0?EV[00<0ooK^03eIZ`3om^h03`3om^h00`0mFJ/0ooK^0?ofkP0C
0?ofkP80?EV[4P3om^h00`000000ooK^0?ofkP140?ofkP40oooo000E0?ofkP030000003om^h0ooK^
04<0ooK^00@000000?ofkP3D?AT0e3dI3@3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP80e3dI3`3om^h0
103D?AT0ooK^0?ofkP3D?AT@0?ofkP060=@m6@000000000000H94P0000001PTB0`00000500d@7P04
0000000=41h03A0N00d@7P80000000<05a`l0000000G73`01@0G73`00`0000005a`l01LL?00201LL
?0030=@m6@0G73`05a`l00<000001`0P:UT00`00000082YI020ZF@03020ZF@@000000P0P:UT01@3D
?AT00000000000000000e3dI0080:3Ma00<0000002PgL@0X=g401`0X=g400`000000:3Ma02PgL@05
02PgL@050=@m6@0X=g40:3Ma0=@m6@0X=g400P00000602i0P`030000000^@8<0;T2300D0;T230P3D
?AT00`000000;T2302i0P`0702i0P`030000003oB1d0odPM00@0odPM00H000000?m87@3oB1d00000
0?126P0000020?126P0303eIZ`3`@QX0l48J008000000P3@>1D01`000000d3PE0=0h5@000000e3dI
0:@Z3`0000000`0mFJ/30?ofkP<0?EV[00D0ooK^03eIZ`3om^h0ooK^03eIZ`0E0?ofkP0303eIZ`3o
m^h0ooK^00h0ooK^00<0000003eIZ`0mFJ/00`0mFJ/40?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0
?EV[0?ofkP3om^h0403om^h303eIZ`030?ofkP0mFJ/0ooK^0180ooK^00<000000?ofkP3om^h0@`3o
m^h10?ooo`005@3om^h00`000000ooK^0?ofkP140?ofkP040000003D?AT0ooK^0=@m6@`0ooK^0P3D
?AT@0?ofkP030=@m6@3om^h0e3dI00h0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0>0?ofkP030=@m
6@0000001PTB00@0000000<03A0N0000000=41h0100=41h00`0000003A0N00d@7P02000000805a`l
00<0000001LL?00G73`01@0G73`01P0000005a`l01LL?00G73`0e3dI01LL?080000000<082YI0000
000P:UT01P0P:UT00`00000082YI020ZF@02020ZF@8000000`0P:UT01`00000082YI000000000000
e3dI02PgL@3D?AT00`0X=g400`000000:3Ma02PgL@0702PgL@030000000X=g40:3Ma00H0:3Ma0P3D
?AT2000000P0;T2300<0000002i0P`0^@8<01P0^@8<00`3D?AT0000002i0P`0802i0P`030000003o
B1d0odPM00@0odPM00@000000?m87@3oB1d0odPM0P0000020?126P0603eIZ`3`@QX0l48J0000003`
@QX000000P3@>1D00`000000d3PE0=0h5@0303eIZ`80000000@0ooK^03eIZ`0mFJ/0?EV[103om^h0
100mFJ/0ooK^0?ofkP0mFJ/E0?ofkP0303eIZ`3om^h0ooK^00/0ooK^100mFJ/01@000000?EV[0?of
kP3om^h0?EV[00@0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP<0?EV[
1@3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP030000003om^h0ooK^04<0ooK^0@3oool001D0ooK^00<0
00000?ofkP3om^h0A@3om^h00`000000e3dI0?ofkP020=@m6@X0ooK^00<0e3dI0?ofkP3D?AT03P3o
m^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00d0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^
0?ofkP090?ofkP0303eIZ`000000e3dI00<000000`0=41h00`0000003A0N00d@7P0400d@7P<00000
100G73`00`0000005a`l01LL?00501LL?0060000000G73`05a`l0=@m6@000000e3dI0`0P:UT00`00
000082YI020ZF@05020ZF@030000000P:UT0000000800000100P:UT20000000503eIZ`0X=g40:3Ma
02PgL@3D?AT0100X=g400`000000:3Ma02PgL@0702PgL@030000000X=g40:3Ma00@0:3Ma0`000000
0`3D?AT0000002i0P`0802i0P`030000000^@8<0;T2300D0;T2300<0e3dI02i0P`3D?AT0200^@8<2
000000H0odPM00@000000?m87@3oB1d0odPM0P0000020?126P0603eIZ`3`@QX0l48J0000003`@QX0
00000P3@>1D303eIZ`80000000@0Y2X?00000000000000001`3om^h01@0mFJ/0ooK^0?ofkP3om^h0
?EV[01D0ooK^00<0?EV[0?ofkP3om^h01P3om^h403eIZ`050?ofkP0mFJ/0?EV[0?ofkP0000000`3o
m^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h02P3o
m^h203eIZ`P0ooK^00<0?EV[0?ofkP3om^h04@3om^h00`000000ooK^0?ofkP120?ofkP40oooo000E
0?ofkP030000003om^h0ooK^04H0ooK^00D0e3dI0000003om^h0ooK^0=@m6@090?ofkP030=@m6@3o
m^h0ooK^0080e3dI303om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0
e3dI0?ofkP3om^h0103om^h20=@m6@H0ooK^0P0mFJ/5000000D03A0N00<0000000d@7P0=41h00P0=
41h3000000D05a`l00<0000001LL?00G73`01@0G73`0100000005a`l0=@m6@3D?AT3020ZF@030=@m
6@0P:UT0000000L082YI0`000005020ZF@80000000<0:3Ma0000000X=g400P0X=g400`3D?AT0:3Ma
0=@m6@0302PgL@030000000X=g40:3Ma00L0:3Ma00<0000002PgL@0X=g400P0X=g4200000080;T23
00<0e3dI02i0P`3D?AT02@0^@8<00`000000;T2302i0P`0502i0P`040=@m6@0^@8<000000=@m6@D0
;T230P0000000`0cB9400000000000040?m87@030000003oB1d0odPM00<0odPM00L000000?126P3`
@QX0l48J03eIZ`3`@QX000000080l48J0P0mFJ/01@000000d3PE0=0h5@3@>1D000000080Y2X?0`00
00070?ofkP0403eIZ`3om^h0ooK^03eIZaD0ooK^00<0?EV[0?ofkP3om^h00`3om^h303eIZ`80ooK^
0`0mFJ/40?ofkP040000003om^h0ooK^03eIZ`D0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0
ooK^0?ofkP060?ofkP<0?EV[2P3om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP030000003om^h0ooK^0480
ooK^0@3oool001@0ooK^00<000000?ofkP3om^h0A`3om^h00`3D?AT0ooK^000000020?ofkP030=@m
6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m
6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP060?ofkP040=@m
6@3om^h0ooK^0?ofkP80?EV[100000000`0=41h0000000d@7P0400d@7P030000000=41h03A0N00@0
00001`0G73`00`0000005a`l01LL?00401LL?080000000<0e3dI020ZF@0P:UT0100P:UT00`3D?AT0
0000020ZF@04020ZF@80000000<082YI0000000P:UT00P0P:UT3000000<0:3Ma00@0000002PgL@0X
=g40e3dI0`0X=g40103D?AT0:3Ma02PgL@00000902PgL@030000000X=g40000000800000100^@8<0
103D?AT0;T230000003D?AT802i0P`030000000^@8<0;T2300@0;T2300L0e3dI02i0P`0^@8<00000
02i0P`3D?AT0;T2300<000000`0cB9400`000000od`O000000030?m87@030000003oB1d0odPM00<0
odPM0P0000020?126P0303eIZ`3`@QX0?EV[0080?EV[00<0l48J0000000000000`3@>1D200000005
0:@Z3`00000000000=@m6@0000001P3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[01@0ooK^0P0mFJ/0
103om^h0?EV[03eIZ`0mFJ/20?ofkP<0?EV[203om^h010000000ooK^0?ofkP0mFJ/40?ofkP0303eI
Z`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h00`3om^h303eIZ`d0ooK^00<0?EV[0?ofkP3om^h0
4P3om^h00`000000ooK^0?ofkP110?ofkP40oooo000D0?ofkP030000003om^h0ooK^04L0ooK^00@0
e3dI0?ofkP3om^h000000P3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00<0ooK^
00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00H0ooK^
00<0e3dI0?ofkP3om^h0203om^h0103D?AT0?EV[03eIZ`0mFJ/2000000@03A0N00<0000000d@7P0=
41h00P0=41h4000000<05a`l00<0000001LL?00G73`01@0G73`0100000005a`l01LL?00G73`30000
0003020ZF@3D?AT082YI00L082YI00<0e3dI020ZF@0P:UT00`000003020ZF@040000000mFJ/00000
000000H0:3Ma00<0000002PgL@3D?AT01@0X=g400`3D?AT0:3Ma0000000802PgL@<000001P0^@8<0
1P3D?AT0;T2302i0P`000000;T230=@m6@L0;T2300<0000002i0P`0^@8<0100^@8<01`3D?AT0;T23
02i0P`000000;T230000003D?AT01P0cB94010000000od`O0?m<7`0000020?m87@030000003oB1d0
odPM00<0odPM00<000000?m87@0000000`0mFJ/00`000000l48J0?126P020?126P060000003@>1D0
d3PE0=0h5@000000d3PE0P000000102T:Pl000000000000000050?ofkP0503eIZ`3om^h0ooK^0?of
kP0mFJ/0503om^h303eIZ`<0ooK^0P0mFJ/<0?ofkP030000003om^h0?EV[00@0ooK^00<0?EV[0?of
kP3om^h03`3om^h00`0mFJ/0ooK^03eIZ`0203eIZa40ooK^00<0?EV[0?ofkP3om^h04P3om^h00`00
0000ooK^0?ofkP100?ofkP40oooo000D0?ofkP030000003om^h0ooK^04L0ooK^00D0e3dI0?ofkP3o
m^h0ooK^000000020?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D
?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D
?AT0ooK^0?ofkP050?ofkP@0?EV[00<0e3dI0?ofkP0000001@0=41h00`0000003A0N00d@7P0200d@
7P8000001@0G73`00`0000005a`l01LL?00501LL?0030000000G73`00000008000000`0P:UT00`3D
?AT00000020ZF@07020ZF@<000001@0P:UT20000000303eIZ`0X=g40:3Ma00H0:3Ma00<000000=@m
6@0X=g401P0X=g400`3D?AT0000002PgL@0502PgL@80000000<0;T230000000^@8<01@0^@8<01`3D
?AT0;T2302i0P`0^@8<0000002i0P`3D?AT01`0^@8<00`000000;T2302i0P`0302i0P`030=@m6@0^
@8<0;T2300<0000000<0<dRA0=@m6@0cB940100cB9401@000000od`O0?m<7`3oC1l000000080odPM
00<000000?m87@3oB1d00`3oB1d01`000000?EV[03eIZ`000000?EV[0=@m6@000000103`@QX20000
0080d3PE00T000000=0h5@000000Y2X?0000002T:Pl0000007PM2`000000103om^h01@0mFJ/0ooK^
0?ofkP3om^h0?EV[0140ooK^0`0mFJ/00`3om^h0?EV[0?ofkP0303eIZ`h0ooK^00<000000?ofkP0m
FJ/01@3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP<0?EV[503om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP03
0000003om^h0ooK^0400ooK^0@3oool001@0ooK^00<000000?ofkP3om^h0A`3om^h00`3D?AT0ooK^
0?ofkP020?ofkP040000003om^h0ooK^0=@m6@D0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0
ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0
ooK^0?ofkP020?ofkP@0?EV[103om^h00`3D?AT03A0N00d@7P0300d@7P040000000=41h03A0N00d@
7P8000001`0G73`00`0000005a`l01LL?00401LL?0<00000100P:UT20=@m6@03020ZF@00000082YI
00D082YI0P000002020ZF@030=@m6@0P:UT082YI00<0000000<0:3Ma0000000X=g40200X=g400`3D
?AT0:3Ma02PgL@0702PgL@040=@m6@0X=g40:3Ma02PgL@<000000`0^@8<00`000000;T2302i0P`03
02i0P`030=@m6@0^@8<0;T230080;T2300@0000002i0P`0^@8<0e3dI1P0^@8<00`000000;T2302i0
P`0302i0P`050=@m6@000000000003=8T@0000000`0cB9400`3D?AT0<dRA03=8T@0203=8T@030000
003oC1l0od`O0080od`O00<000000?m87@0000000`3oB1d303eIZ`<0odPM00<0000003eIZ`000000
103`@QX200000080d3PE00<000000=0h5@3@>1D00P0000020:@Z3`<00000103om^h01@0mFJ/0ooK^
0?ofkP3om^h0?EV[00h0ooK^0P0mFJ/30?ofkP<0?EV[4P3om^h00`000000ooK^03eIZ`040?ofkP03
03eIZ`3om^h0ooK^00X0ooK^0`0mFJ/00`3om^h0?EV[0?ofkP0D0?ofkP0303eIZ`3om^h0ooK^01<0
ooK^00<000000?ofkP3om^h0?`3om^h10?ooo`00503om^h00`000000ooK^0?ofkP180?ofkP030=@m
6@3om^h0ooK^0080ooK^00@000000?ofkP3om^h0e3dI103om^h00`3D?AT0ooK^0?ofkP060?ofkP03
0=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP020?ofkP04
0=@m6@3om^h0ooK^0?ofkP@0?EV[103om^h00`0mFJ/000000=@m6@0400d@7P030000000=41h03A0N
0080000000<05a`l0000000G73`01@0G73`00`0000005a`l01LL?00301LL?080000000<082YI0000
000P:UT00`0P:UT01@3D?AT082YI020ZF@0P:UT0000000<082YI0`0000000`0P:UT00000020ZF@02
000000030=@m6@000000:3Ma00<0:3Ma00<0000002PgL@0X=g401P0X=g400`3D?AT0000002PgL@08
02PgL@040000003D?AT00000000000H0;T2300<0000002i0P`0^@8<00`0^@8<00`3D?AT0;T2302i0
P`0202i0P`050000000^@8<0;T2302i0P`3D?AT01@0^@8<01`000000;T2302i0P`0^@8<000000=@m
6@0000000`0cB9400`000000<dRA03=8T@0203=8T@050=@m6@0cB940<dRA03=8T@0000001@3oC1l2
000000030?m87@0mFJ/0?EV[0080odPM00<000000?m87@3oB1d00P3oB1d00`0mFJ/000000?126P03
0?126P030000003`@QX000000080d3PE00<000000=0h5@3@>1D00P000000102T:Pl0000000000000
00040?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/02`3om^h303eIZ`80ooK^0`0mFJ/00`3om^h0?EV[
03eIZ`0C0?ofkP030000000mFJ/0ooK^00<0ooK^00<0?EV[0?ofkP3om^h01`3om^h303eIZ`D0ooK^
00<0?EV[0?ofkP3om^h04P3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP030000003om^h0ooK^03l0ooK^
0@3oool001<0ooK^00<000000?ofkP3om^h0B@3om^h00`3D?AT0ooK^0?ofkP030?ofkP030000003o
m^h0ooK^0080e3dI0P3om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0
e3dI0?ofkP3om^h02@3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00D0?EV[0`3om^h503eIZ`D03A0N
0`00000201LL?0030000000G73`05a`l00D05a`l00<0000001LL?00G73`00`000003020ZF@050000
000P:UT082YI020ZF@3D?AT00`0P:UT00`00000082YI00000002000000<082YI0`00000302PgL@03
0=@m6@0X=g40:3Ma0080:3Ma00<0000002PgL@0X=g401@0X=g400`3D?AT0:3Ma0000000802PgL@<0
000000<0e3dI02i0P`0^@8<01@0^@8<00`000000;T2302i0P`0202i0P`030=@m6@0^@8<0;T2300<0
;T2300<0000002i0P`0^@8<00P0^@8<00`3D?AT0;T2302i0P`0202i0P`060000000^@8<000000000
000cB940e3dI100cB9400`000000<dRA03=8T@0303=8T@040=@m6@0cB940<dRA000000H0od`O0P0m
FJ/30?m87@030000003oB1d0odPM00<0odPM00<0?EV[0000003`@QX00`3`@QX01P000000l48J0?12
6P000000e3dI000000<0d3PE00<000000:@Z3`3D?AT00`0000030?ofkP0303eIZ`3om^h0ooK^0080
ooK^00<0?EV[0?ofkP3om^h01@3om^h303eIZ`80ooK^0`0mFJ/50?ofkP0303eIZ`3om^h0ooK^0140
ooK^00<000000?ofkP0mFJ/0103om^h00`0mFJ/0ooK^0?ofkP040?ofkP80?EV[203om^h00`0mFJ/0
ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<000000?ofkP3om^h0?P3om^h10?ooo`00
4`3om^h00`000000ooK^0?ofkP190?ofkP030=@m6@3om^h0ooK^00@0ooK^0P0000020?ofkP030=@m
6@3om^h0e3dI00X0ooK^0P3D?AT30?ofkP030=@m6@3om^h0ooK^00X0ooK^00D0e3dI03eIZ`0mFJ/0
e3dI03eIZ`020?ofkP0303eIZ`3om^h0?EV[0080?EV[00@0ooK^03eIZ`0mFJ/00000100=41h30000
00@05a`l00<0000001LL?00G73`0100G73`0100000005a`l000000000005020ZF@050000000P:UT0
82YI020ZF@3D?AT0100P:UT2000000@082YI0P0000000`0X=g40000002PgL@0402PgL@050=@m6@0X
=g40:3Ma02PgL@0000001`0X=g400`3D?AT0:3Ma0000000502PgL@<0000000@0;T230000000^@8<0
e3dI1`0^@8<01@000000;T2302i0P`0^@8<0e3dI00H0;T2300<0000002i0P`0^@8<00`0^@8<00`3D
?AT0;T2302i0P`0300000080<dRA00<0e3dI03=8T@0cB9400`0cB9400`000000<dRA03=8T@0403=8
T@030=@m6@0cB940000000<0od`O0`0mFJ/2000000<0odPM00<000000?m87@3oB1d00`3oB1d00`0m
FJ/00000000000030?126P040000003`@QX0l48J0?126P8000000`3@>1D2000000030:@Z3`3D?AT0
Y2X?008000000`3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00D0ooK^0P0mFJ/20?ofkP<0?EV[203o
m^h203eIZa<0ooK^00<0000003eIZ`3om^h00`3om^h0100mFJ/0ooK^0?ofkP3om^h303eIZ`X0ooK^
00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP030000003om^h0ooK^03d0ooK^
0@3oool001<0ooK^00<000000?ofkP3om^h0BP3om^h00`3D?AT0ooK^0?ofkP050?ofkP030000003o
m^h0ooK^0080e3dI303om^h00`3D?AT0ooK^0=@m6@0;0?ofkP<0?EV[0P3D?AT603eIZ`80ooK^0P0m
FJ/0103om^h0000000d@7P0=41h4000000D05a`l00<0000001LL?00G73`0100G73`3000000L082YI
00@00000020ZF@3D?AT0e3dI0P0P:UT4000000<082YI0P00000302PgL@030000000X=g40:3Ma00@0
:3Ma00@0e3dI02PgL@0X=g4000001P0X=g401@3D?AT0:3Ma02PgL@000000:3Ma00@00000100^@8<0
10000000;T2302i0P`3D?AT602i0P`040000000^@8<0;T230=@m6@L0;T2300<0000002i0P`0^@8<0
0`0^@8<01@000000e3dI0000000cB940000000<0<dRA00<0e3dI03=8T@0cB9400`0cB9400`000000
<dRA03=8T@0503=8T@030=@m6@000000od`O0080?EV[0`3oC1l00`000000od`O000000020?m87@03
0000003oB1d0odPM00@0odPM00<0?EV[0000003`@QX00P3`@QX01P000000l48J0?126P3`@QX00000
0=@m6@<0d3PE00@000000=0h5@000000e3dI0P2T:Pl200000080ooK^00<0?EV[0?ofkP3om^h00P3o
m^h00`0mFJ/0ooK^03eIZ`0203eIZ`80ooK^0P0mFJ/;0?ofkP80?EV[503om^h00`000000ooK^0?of
kP020?ofkP@0?EV[3@3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^01@0ooK^00<0
00000?ofkP3om^h0?@3om^h10?ooo`004`3om^h00`000000ooK^0?ofkP1:0?ofkP80e3dI1`3om^h0
10000000ooK^0?ofkP3D?AT=0?ofkP80e3dI2@3om^h403eIZ`80ooK^00<0e3dI0?ofkP0mFJ/00P0m
FJ/00`3om^h0?EV[03eIZ`0203eIZ`030?ofkP0000000000008000000`0G73`00`0000005a`l01LL
?00301LL?0040000000G73`05a`l01LL?0<0000000<082YI0000000P:UT01`0P:UT010000000e3dI
020ZF@0P:UT2000000<082YI00@00000020ZF@00000000001@0X=g400`000000:3Ma02PgL@0502Pg
L@030=@m6@0X=g40000000D0:3Ma00<0e3dI02PgL@0X=g400`00000802i0P`050000000^@8<0;T23
02i0P`3D?AT01P0^@8<00`000000;T230=@m6@0702i0P`030000000^@8<0000000<000000P0cB940
0`3D?AT0<dRA0000000203=8T@030=@m6@0cB940<dRA00@0<dRA00<0000003=8T@0cB9401P0cB942
03eIZ`@0od`O00@000000?m<7`3oC1l000000P3oB1d00`000000odPM0?m87@030?m87@040000000m
FJ/0odPM00000080l48J00<000000?126P3`@QX00P3`@QX00`000000d3PE0=0h5@020=0h5@800000
00D0Y2X?0=@m6@2T:Pl0Y2X?000000020?ofkP0403eIZ`3om^h0ooK^0?ofkP<0?EV[0P3om^h303eI
Z`h0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`000000ooK^03eIZ`0303eIZa00ooK^00<0?EV[0?of
kP3om^h04P3om^h00`0mFJ/0ooK^0?ofkP0E0?ofkP030000003om^h0ooK^03`0ooK^0@3oool00180
ooK^00<000000?ofkP3om^h0C03om^h20=@m6@L0ooK^00@000000?ofkP3D?AT0e3dI3@3om^h00`3D
?AT0ooK^0?ofkP050?ofkP<0?EV[103om^h0100mFJ/0e3dI0=@m6@3om^h303eIZ`@0ooK^0P000005
01LL?0030000000G73`05a`l00<05a`l00<0000001LL?00000000P000004020ZF@030000000P:UT0
82YI00H082YI00@0e3dI0000000000000000100P:UT3000000L0:3Ma00<0000002PgL@0X=g401P0X
=g400`3D?AT0000002PgL@0302PgL@060=@m6@0X=g4000000000000^@8<000002@0^@8<00`000000
;T2302i0P`0202i0P`030=@m6@0^@8<0;T2300<0;T2300<000000=@m6@0^@8<01P0^@8<3000000H0
<dRA00<0e3dI03=8T@0000000P0cB9400`3D?AT0<dRA03=8T@0303=8T@030000000cB940<dRA00H0
<dRA00<000000?m<7`3oC1l0103oC1l01`000000od`O0?m<7`3oC1l000000?m87@0000001@3oB1d0
1`000000?EV[0?m87@3oB1d000000?126P000000103`@QX2000000<0d3PE00@000000=0h5@000000
e3dI0P2T:Pl2000000030?ofkP0mFJ/0?EV[0080?EV[00<0ooK^03eIZ`0mFJ/00P0mFJ/A0?ofkP80
?EV[4`3om^h00`0mFJ/0000003eIZ`030?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3o
m^h04`3om^h00`0mFJ/0ooK^0?ofkP0E0?ofkP030000003om^h0ooK^03/0ooK^0@3oool00180ooK^
00<000000?ofkP3om^h0C03om^h0103D?AT0ooK^0=@m6@3D?AT60?ofkP040000003D?AT0ooK^0=@m
6@`0ooK^0P3D?AT30?ofkP<0?EV[103om^h303eIZ`050?ofkP3D?AT0?EV[0=@m6@0mFJ/01@3om^h0
0`0000005a`l01LL?00401LL?0030000000G73`05a`l00<05a`l0`000007020ZF@030000000P:UT0
82YI00@082YI0`0000000`3D?AT082YI020ZF@02020ZF@80000000<0:3Ma0000000X=g401`0X=g40
0`000000:3Ma02PgL@0702PgL@050=@m6@0X=g40:3Ma02PgL@3D?AT00P00000302i0P`030000000^
@8<0;T2300L0;T2300<0000002i0P`0^@8<00`0^@8<00`3D?AT0;T2302i0P`0202i0P`030=@m6@0^
@8<0;T2300@0;T230P0000000`0cB940000003=8T@0703=8T@040=@m6@000000<dRA0=@m6@H0<dRA
00<0000003=8T@0cB9401P0cB9400`000000od`O0?m<7`040?m<7`030000003oC1l0od`O0080od`O
0P0000050?m87@030000000mFJ/0odPM0080odPM0P0000040?126P030000003`@QX000000080d3PE
00<000000=0h5@3@>1D00P0000020:@Z3`8000000P0mFJ/00`3om^h0?EV[03eIZ`0203eIZa<0ooK^
0P0mFJ/@0?ofkP<0?EV[00<0ooK^03eIZ`0000000`3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eI
Z`3om^h0ooK^0180ooK^0P0mFJ/G0?ofkP030000003om^h0ooK^03/0ooK^0@3oool00180ooK^00<0
00000?ofkP3om^h0C@3om^h0103D?AT0ooK^0?ofkP3D?AT60?ofkP040000003D?AT0ooK^0=@m6@/0
ooK^00<0e3dI0?ofkP3D?AT00`0mFJ/40?ofkP80?EV[0P3om^h01P0mFJ/0e3dI03eIZ`0mFJ/0ooK^
0=@m6@D0ooK^00<0000001LL?00G73`0100G73`0100000005a`l01LL?00G73`200000003020ZF@00
000082YI00L082YI00<00000020ZF@0P:UT00P0P:UT200000005020ZF@00000082YI020ZF@3D?AT0
0`00000302PgL@030000000X=g40:3Ma00L0:3Ma00<0000002PgL@0X=g401P0X=g4010000000e3dI
0000003D?AT602i0P`030000000^@8<0;T2300P0;T2300<0000002i0P`0^@8<00`0^@8<01@3D?AT0
;T2302i0P`3D?AT0000000<0;T230`00000303=8T@030000000cB940<dRA00L0<dRA00<0e3dI03=8
T@3D?AT01P0cB9400`000000<dRA03=8T@0603=8T@030000003oC1l0od`O00@0od`O00<000000?m<
7`3oC1l00`3oC1l00`000000odPM0?m87@030?m87@030000003oB1d0?EV[0080odPM0P0000040?12
6P060000003`@QX0l48J0000003@>1D000000`3@>1D00`000000Y2X?0:@Z3`02000000<0?EV[0`3o
m^h00`0mFJ/0ooK^0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^00`0ooK^0P0mFJ/50?ofkP0303eIZ`00
0000ooK^0080ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP<0?EV[00<0
ooK^03eIZ`3om^h05`3om^h00`000000ooK^0?ofkP0j0?ofkP40oooo000B0?ofkP030000003om^h0
ooK^04h0ooK^00@0e3dI0?ofkP3om^h0e3dI1P3om^h0103D?AT0ooK^0?ofkP3D?AT:0?ofkP050=@m
6@0mFJ/0?EV[0=@m6@0mFJ/00P3om^h303eIZ`080?ofkP0mFJ/0?EV[03eIZ`3om^h0e3dI0?ofkP0m
FJ/20?ofkP050=@m6@3om^h0ooK^03eIZ`0000001P0G73`00`0000005a`l01LL?002000000<082YI
00<00000020ZF@0P:UT01@0P:UT00`00000082YI020ZF@03000000<082YI00D00000020ZF@000000
00000=@m6@0502PgL@030000000X=g40:3Ma00L0:3Ma00<0000002PgL@0X=g401@0X=g4300000003
0=@m6@0^@8<0;T2300D0;T2300<0000002i0P`0^@8<0200^@8<00`000000;T2302i0P`0402i0P`05
0=@m6@0^@8<0e3dI0000000^@8<00P00000603=8T@030000000cB940<dRA00L0<dRA00<000000=@m
6@0cB9401P0cB9400`000000<dRA03=8T@0503=8T@8000001@3oC1l00`000000od`O0?m<7`040?m<
7`800000103oB1d00`000000odPM03eIZ`030?m87@030000003`@QX0l48J0080l48J00L000000?12
6P3`@QX0l48J0000003@>1D000000080d3PE0P00000303eIZ`030000000mFJ/0ooK^00<0ooK^00<0
?EV[0?ofkP3om^h04P3om^h203eIZ`X0ooK^0`0mFJ/70?ofkP0403eIZ`3om^h000000?ofkP80?EV[
403om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP<0?EV[1@3om^h00`0mFJ/0ooK^0?ofkP0E0?ofkP030000
003om^h0ooK^03X0ooK^0@3oool00180ooK^00<000000?ofkP3om^h0CP3om^h01@3D?AT0ooK^0?of
kP3om^h0e3dI00D0ooK^00D0e3dI000000000000ooK^0=@m6@080?ofkP0303eIZ`3D?AT0ooK^0080
?EV[00@0e3dI03eIZ`0mFJ/0ooK^0`0mFJ/40?ofkP030=@m6@0mFJ/0ooK^00<0ooK^00<0e3dI03eI
Z`0000001`0G73`3000000@082YI00<00000020ZF@0P:UT01P0P:UT3000000030=@m6@0P:UT082YI
008082YI0P0000001@0mFJ/0:3Ma02PgL@0X=g40e3dI00@0:3Ma00<0000002PgL@0X=g401`0X=g40
0`000000:3Ma02PgL@0302PgL@80000000D0;T230000003D?AT0;T230=@m6@0602i0P`030000000^
@8<0;T2300P0;T2300<0000002i0P`0^@8<01@0^@8<0103D?AT0000000000000000803=8T@030000
000cB940<dRA00H0<dRA00@000000=@m6@0cB940e3dI1P0cB9400`000000<dRA03=8T@0303=8T@80
000000<0=djN000000000000103oC1l00`000000od`O0?m<7`040?m<7`030000003oC1l0000000<0
odPM00<000000?m87@0mFJ/00`3oB1d2000000<0l48J00<000000?126P3`@QX00P3`@QX200000080
d3PE0P0mFJ/00`000000Y2X?000000020000000303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3o
m^h04P3om^h00`0mFJ/0ooK^0?ofkP050?ofkP<0?EV[2P3om^h203eIZ`040000000mFJ/0ooK^03eI
Za00ooK^00<0?EV[0?ofkP3om^h02@3om^h203eIZ`P0ooK^00<0?EV[0?ofkP3om^h05P3om^h00`00
0000ooK^0?ofkP0i0?ofkP40oooo000A0?ofkP030000003om^h0ooK^0500ooK^00D0e3dI0?ofkP3o
m^h0ooK^0=@m6@040?ofkP060=@m6@3om^h0ooK^0000003om^h0e3dI103om^h403eIZ`060=@m6@0m
FJ/0?EV[03eIZ`3om^h0e3dI0`0mFJ/60?ofkP030=@m6@0mFJ/0ooK^00<0?EV[00<0ooK^0=@m6@3D
?AT01@0G73`3000000H082YI00<00000020ZF@0P:UT0100P:UT300000080e3dI0P0P:UT300000003
02PgL@000000:3Ma00@0:3Ma00D0e3dI02PgL@0X=g40:3Ma0000000902PgL@040000000X=g40:3Ma
02PgL@8000000P0^@8<20=@m6@<0;T2300<0e3dI02i0P`0^@8<00`0^@8<00`000000;T2302i0P`08
02i0P`030000000^@8<0;T2300<0;T2300D000000=@m6@000000e3dI0000000903=8T@030000000c
B940<dRA00H0<dRA00D000000=@m6@0cB940<dRA0=@m6@0503=8T@040000000cB940<dRA03=8T@80
00000`0gCYh00`000000odlP000000030?m<7`030000003oC1l0od`O00@0od`O00<000000?m<7`00
00000P3oB1d01@000000odPM0?m87@3oB1d0?EV[0080odPM00<000000?m87@0000000P3`@QX00`00
0000l48J0?126P030?126P<0?EV[00P0d3PE000000000000Y2X?0000002T:Pl0000003eIZ`@0ooK^
00<0?EV[0?ofkP3om^h04P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP80?EV[2`3om^h303eIZ`80ooK^
00@000000?ofkP3om^h0?EV[3`3om^h00`0mFJ/0ooK^0?ofkP060?ofkP<0?EV[2P3om^h00`0mFJ/0
ooK^0?ofkP0G0?ofkP030000003om^h0ooK^03P0ooK^0@3oool00140ooK^00<000000?ofkP3om^h0
D03om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^0080ooK^00D0e3dI0?ofkP3om^h0
00000?ofkP020=@m6@80?EV[0`3om^h00`3D?AT0?EV[03eIZ`0303eIZ`040?ofkP3D?AT0e3dI0?of
kP<0?EV[0P3om^h0103D?AT0?EV[03eIZ`0mFJ/30?ofkP80?EV[0`0G73`300000003020ZF@000000
82YI00H082YI00@00000020ZF@0P:UT082YI0`000000100P:UT0e3dI0=@m6@0P:UT3000000@0:3Ma
00<0000002PgL@0X=g40100X=g40103D?AT0:3Ma02PgL@00000902PgL@040000000X=g4000000000
00<0;T2300<0e3dI02i0P`000000100^@8<00`3D?AT0;T2302i0P`0302i0P`030000000^@8<0;T23
00L0;T2300<0000002i0P`0000000`0000001@3D?AT0<dRA03=8T@0cB940e3dI00T0<dRA00<00000
03=8T@0cB9401P0cB9400`3D?AT0<dRA03=8T@0203=8T@030=@m6@0cB940<dRA0080<dRA00@00000
03=8T@00000000001@0gCYh00`000000odlP000000030?m<7`030000003oC1l0od`O00<0od`O00L0
00000?m<7`3oC1l0od`O0000003oB1d0000000<0odPM00<0?EV[0?m87@0000000P3oB1d010000000
l48J0?126P0000020?126P<0?EV[0P0000020=0h5@070000003@>1D000000000002T:Pl0000003eI
Z`040?ofkP0303eIZ`3om^h0ooK^0180ooK^0P0mFJ/0103om^h0?EV[03eIZ`0mFJ/:0?ofkP<0?EV[
0`3om^h01P0mFJ/0ooK^0?ofkP000000ooK^03eIZ`l0ooK^00<0?EV[0?ofkP3om^h00`3om^h303eI
Z`d0ooK^00<0?EV[0?ofkP3om^h05`3om^h00`000000ooK^0?ofkP0h0?ofkP40oooo000A0?ofkP03
0000003om^h0ooK^0540ooK^00<0e3dI0?ofkP3om^h00P3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI
00<0ooK^0`0mFJ/01P3D?AT0ooK^0?ofkP3om^h0?EV[0=@m6@80?EV[1P3om^h0103D?AT0ooK^0?of
kP3om^h203eIZ`030=@m6@0mFJ/0ooK^0080ooK^0P0mFJ/00`3om^h0000000000002000000@082YI
00<00000020ZF@0P:UT01@0P:UT01000000082YI000000000002020ZF@80e3dI0`00000702PgL@03
0000000X=g40:3Ma00D0:3Ma00<0e3dI02PgL@000000200X=g43000000@0;T2300D0e3dI02i0P`0^
@8<0;T230000000402i0P`030=@m6@0^@8<0;T230080;T2300<0000002i0P`0^@8<01P0^@8<30000
00<0<dRA00<0e3dI03=8T@0cB9400P0cB9400`000000e3dI03=8T@0703=8T@030000000cB940<dRA
00D0<dRA00<0e3dI0000000cB940100cB9400`3D?AT0<dRA03=8T@03000000H0=djN00L000000?m?
803oCb00odlP0000003oC1l0000000H0od`O00<000000?m<7`3oC1l00P3oC1l2000000<0odPM00<0
?EV[0?m87@0000000`3oB1d00`000000l48J03eIZ`0203eIZ`<0l48J00D000000?126P000000d3PE
000000020=0h5@80000000<0Y2X?0000000mFJ/0103om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP<0?EV[
2P3om^h303eIZ`H0ooK^00@0?EV[0?ofkP3om^h000000P3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP03
03eIZ`3om^h0?EV[0080?EV[4@3om^h00`0mFJ/0ooK^0?ofkP0G0?ofkP030000003om^h0ooK^03L0
ooK^0@3oool00140ooK^00<000000?ofkP3om^h0DP3om^h00`3D?AT0ooK^0?ofkP020?ofkP80e3dI
00<0ooK^0=@m6@0mFJ/00`0mFJ/010000000ooK^0?ofkP3D?AT303eIZ`030=@m6@0mFJ/0ooK^00L0
ooK^00<0e3dI03eIZ`0mFJ/00P3om^h00`3D?AT0?EV[0?ofkP0203eIZ`80ooK^0P000006020ZF@03
0000000P:UT082YI00D082YI0`000002020ZF@80e3dI0P0000000`0X=g40000002PgL@0702PgL@03
0000000X=g40:3Ma00H0:3Ma00<0e3dI0000000X=g40100X=g430000000302i0P`000000;T2300<0
;T2300<0e3dI02i0P`0^@8<00P0^@8<00`000000;T2302i0P`0302i0P`050=@m6@0^@8<0;T2302i0
P`0000001P0^@8<20000000303=8T@000000<dRA0080<dRA00<0e3dI03=8T@0cB9400`0cB9400`00
0000<dRA0=@m6@0703=8T@030000000cB940<dRA00@0<dRA00<0e3dI03=8T@0000001@0cB9401@00
0000e3dI0000000gCYh0000000L0=djN00<000000?m?803oCb000P3oCb02000000H0od`O00<00000
0?m<7`3oC1l00`3oC1l01`000000odPM0?m87@3oB1d0?EV[0?m87@0000000`3oB1d203eIZ`030000
003`@QX0l48J00<0l48J00D000000?126P000000d3PE000000030=0h5@050000002T:Pl0e3dI03eI
Z`0000000`3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP<0?EV[00<0ooK^03eIZ`3om^h01`3om^h303eI
Z`T0ooK^00L0?EV[0?ofkP3om^h0ooK^0000003om^h0?EV[00h0ooK^0`0mFJ/D0?ofkP0303eIZ`3o
m^h0ooK^01L0ooK^00<000000?ofkP3om^h0=`3om^h10?ooo`00403om^h00`000000ooK^0?ofkP1D
0?ofkP80e3dI103om^h20=@m6@80?EV[0`3om^h303eIZ`040=@m6@3om^h0ooK^0=@m6@L0ooK^0`0m
FJ/01@3D?AT0ooK^0?ofkP3om^h0e3dI00<0?EV[0`3om^h00`00000082YI020ZF@05020ZF@030000
000P:UT082YI008082YI10000002020ZF@80e3dI0P00000302PgL@030000000X=g40:3Ma00H0:3Ma
00<0000002PgL@0X=g401`0X=g400`3D?AT0:3Ma00000003000000@0;T2300<0000002i0P`0^@8<0
0P3D?AT502i0P`030000000^@8<0;T2300@0;T2300@0e3dI02i0P`0^@8<000000`0^@8<3000000<0
<dRA00@0000003=8T@0cB940e3dI1P0cB94010000000<dRA03=8T@3D?AT603=8T@030000000cB940
<dRA00@0<dRA00@0e3dI03=8T@000000<dRA1000000203M>WP030=@m6@0gCYh0000000L0=djN00<0
00000?m?803oCb000`3oCb000`000000od`O0?m<7`040?m<7`030000003oC1l0od`O00<0od`O0P00
00030?m87@0303eIZ`000000?EV[0080?EV[0P3oB1d00`000000l48J0?126P030?126P060000003`
@QX0l48J0000003@>1D000000P3@>1D2000000040:@Z3`0mFJ/00000000000<0ooK^00<0?EV[0?of
kP3om^h02P3om^h303eIZ`@0ooK^0P0mFJ/40?ofkP<0?EV[303om^h00`0mFJ/0ooK^0?ofkP020?of
kP030000000mFJ/0ooK^00X0ooK^0`0mFJ/00`3om^h0?EV[0?ofkP0D0?ofkP0303eIZ`3om^h0ooK^
01L0ooK^0P00000h0?ofkP40oooo000@0?ofkP030000003om^h0ooK^05D0ooK^0P3D?AT303eIZ`03
0?ofkP3D?AT0e3dI0080ooK^100mFJ/20?ofkP030=@m6@3om^h0e3dI00D0ooK^0P0mFJ/40?ofkP04
0=@m6@0mFJ/0e3dI03eIZ`<0ooK^0P0mFJ/00`3om^h00000020ZF@06020ZF@030000000P:UT082YI
008000000`0P:UT01P000000e3dI0=@m6@000000:3Ma0=@m6@@0:3Ma00<0000002PgL@0X=g401P0X
=g400`000000:3Ma02PgL@0602PgL@80000000<0e3dI02i0P`0^@8<01P0^@8<00`000000;T230=@m
6@0702i0P`030000000^@8<0;T2300D0;T2300@0e3dI02i0P`000000;T230P00000603=8T@030000
000cB940e3dI00L0<dRA00D0000003=8T@0cB940<dRA0=@m6@0503=8T@030000000cB940<dRA00<0
<dRA00<0e3dI03=8T@0000000P00000603M>WP030=@m6@0gCYh0000000L0=djN00<000000?m?803o
Cb000`3oCb02000000D0od`O00<000000?m<7`3oC1l00`3oC1l010000000od`O0000003oB1d303eI
Z`D0odPM0P0000030?126P030000003`@QX0l48J0080l48J0P0000020=0h5@050000003@>1D00000
0=@m6@0mFJ/00P0000020?ofkP0303eIZ`3om^h0ooK^00H0ooK^100mFJ/80?ofkP0303eIZ`3om^h0
?EV[0080?EV[403om^h00`0mFJ/0ooK^0?ofkP020?ofkP030000000mFJ/0ooK^00H0ooK^0`0mFJ/4
0?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h0503om^h3000000030?ofkP000000
ooK^03L0ooK^0@3oool00100ooK^00<000000?ofkP3om^h0E03om^h303eIZ`030=@m6@0mFJ/0?EV[
0080?EV[00<0e3dI03eIZ`0mFJ/00P0mFJ/20?ofkP80000000<0ooK^0=@m6@3D?AT00P3om^h303eI
Z`@0ooK^0`0mFJ/20=@m6@H0ooK^00<00000020ZF@0P:UT01P0P:UT3000000<082YI0`3D?AT00`0m
FJ/0:3Ma02PgL@0202PgL@050=@m6@0X=g40:3Ma02PgL@000000200X=g400`000000:3Ma02PgL@04
02PgL@80000000@0;T230000000^@8<0e3dI1`0^@8<00`000000e3dI02i0P`0702i0P`030000000^
@8<0;T2300H0;T2300<0e3dI000000000000200cB9400`000000e3dI03=8T@0703=8T@030000000c
B940<dRA0080<dRA00<0e3dI03=8T@0cB9400P0cB9400`000000<dRA03=8T@0203=8T@050=@m6@00
0000000003M>WP000000200gCYh00`3D?AT0=djN03M>WP0503M>WP030=@m6@000000odlP00@0odlP
00<000000?m?80000000103oC1l00`000000od`O0?m<7`030?m<7`070000000mFJ/0?EV[03eIZ`3o
B1d0?EV[000000050?m87@030000003oB1d000000080l48J00<000000?126P3`@QX00`3`@QX01000
0000d3PE0=0h5@3@>1D2000000040:@Z3`0mFJ/0Y2X?00000080ooK^00<0?EV[0?ofkP3om^h00`3o
m^h303eIZ`/0ooK^0`0mFJ/C0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0000003eIZ`3om^h0103o
m^h203eIZ`P0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP<00000103o
m^h00`000000ooK^0?ofkP0f0?ofkP40oooo000@0?ofkP030000003om^h0ooK^0580ooK^0`0mFJ/3
0?ofkP80e3dI00@0?EV[0?ofkP0mFJ/0e3dI0P3om^h403eIZ`040?ofkP000000?EV[0=@m6@80?EV[
103om^h303eIZ`@0ooK^00<0e3dI0?ofkP3om^h0103om^h00`00000082YI020ZF@03020ZF@<00000
0`0P:UT30=@m6@030000000X=g40000000H0:3Ma00@0e3dI02PgL@0X=g400000200X=g4010000000
:3Ma02PgL@0X=g43000000<0;T2300@0000002i0P`0^@8<0e3dI1P0^@8<00`3D?AT0;T2302i0P`07
02i0P`030000000^@8<0;T2300@0;T230P0000000`0cB940e3dI03=8T@0803=8T@030=@m6@0cB940
<dRA00L0<dRA00<0000003=8T@0cB9400`0cB9401P3D?AT0<dRA03=8T@0cB940000003=8T@<00000
00D0e3dI03M>WP0gCYh0=djN0000000803M>WP030000003D?AT0=djN00@0=djN00<0e3dI03M>WP0m
FJ/0103oCb001@000000odlP0?m?803oCb0000000080od`O00<000000?m<7`3oC1l00P3oC1l303eI
Z`80od`O00@000000?m87@000000?EV[1@3oB1d00`000000odPM000000020?126P030000003`@QX0
l48J00<0l48J0P0000020=0h5@050000003@>1D000000=@m6@0mFJ/00P0000020?ofkP0303eIZ`3o
m^h0?EV[0080?EV[2`3om^h303eIZ`030?ofkP0mFJ/0ooK^01<0ooK^00<0?EV[0?ofkP3om^h00`3o
m^h00`000000?EV[0?ofkP0303eIZ`X0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?of
kP0=0?ofkP<00000203om^h00`000000ooK^0?ofkP0e0?ofkP40oooo000?0?ofkP030000003om^h0
ooK^0500ooK^0`0mFJ/70?ofkP<0e3dI00<0ooK^0=@m6@3D?AT01@3om^h303eIZ`80e3dI0`3om^h2
03eIZ`H0ooK^00<0?EV[0=@m6@3D?AT0103om^h00`0mFJ/00000020ZF@02020ZF@8000000P0P:UT0
1@00000082YI0=@m6@3D?AT0000000@0:3Ma00<0000002PgL@0X=g401@0X=g400`3D?AT0:3Ma0000
000802PgL@040000000X=g400000000000L0;T2300@0000002i0P`0^@8<0e3dI0`0^@8<20=@m6@03
02i0P`000000;T2300P0;T2300@0000002i0P`0^@8<0;T230P00000303=8T@030000003D?AT0<dRA
00H0<dRA00<0e3dI0000000cB940200cB9400`000000<dRA03=8T@0403=8T@030=@m6@0cB9400000
008000000P0gCYh00`3D?AT0=djN03M>WP0203M>WP030000000gCYh0=djN00H0=djN00<0000003M>
WP3D?AT0100gCYh00`3D?AT0=djN03eIZ`040?m?80030000003oCb00odlP0080odlP00@000000?m<
7`000000od`O0`0mFJ/00`3oC1l000000?m<7`030?m<7`80000000<0?EV[0?m87@3oB1d00`3oB1d0
1P000000odPM0?m87@000000l48J000000D0l48J00D000000?126P000000d3PE000000020=0h5@03
0000000mFJ/0Y2X?0080000000<0ooK^03eIZ`0mFJ/02`3om^h303eIZ`D0ooK^00<0?EV[0?ofkP3o
m^h04@3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`000000?EV[00d0ooK^00<0?EV[0?ofkP3o
m^h04`3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP<000002`3om^h00`000000ooK^0?ofkP0e0?ofkP40
oooo000?0?ofkP030000003om^h0ooK^04h0ooK^0P0mFJ/80?ofkP<0?EV[1`3D?AT40?ofkP0303eI
Z`3om^h0?EV[0080e3dI0P0mFJ/80?ofkP0403eIZ`3D?AT0ooK^0=@m6@<0?EV[00<0ooK^00000000
00000P000003020ZF@<0e3dI1`0X=g400`000000:3Ma02PgL@0602PgL@030=@m6@000000:3Ma00H0
:3Ma0`00000902i0P`070000000^@8<0;T2302i0P`3D?AT0;T230=@m6@0302i0P`030000000^@8<0
;T2300L0;T2300@0000002i0P`00000000001@0cB9400`000000<dRA0=@m6@0503=8T@040=@m6@0c
B940<dRA000000P0<dRA00<0000003=8T@0cB940100cB94010000000e3dI03M>WP00000203M>WP03
0=@m6@0gCYh0=djN00<0=djN00<0000003M>WP0gCYh01P0gCYh010000000=djN03M>WP3D?AT203M>
WP050=@m6@0gCYh0=djN0000000mFJ/00`3oCb000`000000odlP0?m?80020?m?80@0?EV[103oC1l0
0`000000od`O0?m<7`030?m<7`030000000mFJ/0odPM00@0odPM00@000000?m87@3oB1d0odPM0P00
00050?126P050000003`@QX000000=0h5@0000000`3@>1D00`0mFJ/0Y2X?000000020000000303eI
Z`3om^h0ooK^00L0ooK^0`0mFJ/80?ofkP0303eIZ`3om^h0ooK^0180ooK^00<0?EV[0?ofkP0mFJ/0
0P0mFJ/00`3om^h0000003eIZ`0=0?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h0
1`3om^h3000000h0ooK^00<000000?ofkP3om^h0=@3om^h10?ooo`003`3om^h00`000000ooK^0?of
kP1=0?ofkP0303eIZ`3om^h0ooK^00D0ooK^100mFJ/30?ofkP80e3dI00<0ooK^0=@m6@3D?AT00P3D
?AT20?ofkP0603eIZ`3om^h0?EV[03eIZ`3D?AT0?EV[0P3D?AT80?ofkP0503eIZ`3D?AT0?EV[03eI
Z`3D?AT00P3om^h20000008082YI103D?AT00`0X=g40000002PgL@0702PgL@030000000X=g40:3Ma
00L0:3Ma00<0e3dI02PgL@0X=g400P0X=g430000000302i0P`000000;T2300T0;T2300<0000002i0
P`0^@8<00P0^@8<00`3D?AT0;T2302i0P`0202i0P`030000000^@8<0;T2300H0;T230`00000803=8
T@030000000cB940e3dI00<0<dRA00D0e3dI03=8T@0cB940<dRA0000000803=8T@040000000cB940
<dRA03=8T@<000000P0gCYh0103D?AT0000003M>WP3D?AT603M>WP030000000gCYh0=djN00H0=djN
00/0000003M>WP0gCYh0=djN0=@m6@0gCYh0e3dI03M>WP000000odlP03eIZ`030?m?80030000003o
Cb00?EV[0080?EV[0P3oCb000`000000od`O0?m<7`030?m<7`030000003oC1l0od`O00<0od`O0P00
00001@0mFJ/0odPM0?m87@3oB1d0000000D0odPM00<000000?126P3`@QX00`3`@QX01P000000l48J
0?126P000000d3PE00000080d3PE00@0000003eIZ`000000Y2X?0P0000070?ofkP80?EV[2`3om^h2
03eIZa80ooK^0`0mFJ/50?ofkP030000003om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h0503om^h0
0`0mFJ/0ooK^0?ofkP020?ofkP@000004@3om^h00`000000ooK^0?ofkP0e0?ofkP40oooo000?0?of
kP030000003om^h0ooK^04`0ooK^00<0?EV[0?ofkP3om^h00`3om^h303eIZ`<0ooK^00<0?EV[0?of
kP3om^h00P3om^h20=@m6@030?ofkP3D?AT0ooK^00<0e3dI0P0mFJ/20?ofkP050=@m6@000000?EV[
03eIZ`3D?AT01P3om^h203eIZ`030=@m6@3om^h0ooK^00<00000103D?AT20000000402PgL@3D?AT0
:3Ma000000P0:3Ma00<0000002PgL@0X=g401`0X=g400`000000e3dI0=@m6@02000000@0;T2300<0
000002i0P`0^@8<0200^@8<00`000000;T2302i0P`020=@m6@0302i0P`3D?AT0;T230080;T2300<0
000002i0P`0^@8<00`0^@8<30000000303=8T@000000<dRA00P0<dRA00H0000003=8T@0cB940e3dI
03=8T@3D?AT403=8T@030000000cB940<dRA00H0<dRA00@0000003=8T@00000000001P0gCYh00`3D
?AT0=djN0=@m6@0603M>WP030000000gCYh0=djN00H0=djN00<0000003M>WP0gCYh00P0gCYh0103D
?AT0=djN03M>WP0000020?m?800303eIZ`3oCb00?EV[0080?EV[1@3oCb02000000@0od`O00<00000
0?m<7`3oC1l00P3oC1l010000000od`O0?m<7`0mFJ/30?m87@030000003oB1d0odPM00<0odPM0P00
00030?126P030000003`@QX0l48J0080l48J0P0000020=0h5@070000000mFJ/0Y2X?0000002T:Pl0
000003eIZ`030?ofkP<0?EV[3P3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP<0?EV[00<0ooK^03eIZ`3o
m^h01@3om^h00`0mFJ/000000?ofkP0<0?ofkP0303eIZ`3om^h0ooK^0180ooK^0P0mFJ/0103om^h0
000000000000000E0?ofkP030000003om^h0ooK^03D0ooK^0@3oool000l0ooK^00<000000?ofkP3o
m^h0B`3om^h00`0mFJ/0ooK^0?ofkP020?ofkP80?EV[1@3om^h00`0mFJ/0ooK^0?ofkP040?ofkP<0
e3dI00<0ooK^03eIZ`0mFJ/02@3D?AT0100mFJ/0e3dI0?ofkP3om^h303eIZ`030?ofkP0mFJ/00000
008000000`3D?AT01000000082YI00000000000402PgL@030=@m6@000000:3Ma00P0:3Ma00<00000
02PgL@0X=g401@0X=g430000000302i0P`3D?AT0;T2300D0;T2300<0000002i0P`0^@8<01`0^@8<0
0`000000e3dI0=@m6@0402i0P`050=@m6@0^@8<0;T230000000^@8<01000000403=8T@030000000c
B940<dRA00L0<dRA00D0000003=8T@0cB940<dRA0=@m6@0503=8T@030000000cB940<dRA00D0<dRA
0`00000803M>WP030000003D?AT0=djN00D0=djN00<0000003M>WP0gCYh01`0gCYh02P000000=djN
03M>WP0gCYh0e3dI03M>WP3D?AT0=djN0000003oCb0303eIZ`030000003oCb00odlP00@0odlP00@0
00000?m?803oCb0000000`3oC1l00`000000od`O0?m<7`020?m<7`050000003oC1l0od`O03eIZ`00
00000P3oB1d00`000000odPM0?m87@030?m87@030000003oB1d000000080l48J00<000000?126P3`
@QX00`3`@QX01@000000d3PE0=0h5@000000?EV[0080000000<0Y2X?0000000000000`0mFJ/A0?of
kP0303eIZ`3om^h0ooK^00X0ooK^0`0mFJ/40?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0000
003om^h02`3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP@0?EV[00<0000003eIZ`0000006@3om^h00`00
0000ooK^0?ofkP0d0?ofkP40oooo000>0?ofkP030000003om^h0ooK^04/0ooK^00<0?EV[0?ofkP3o
m^h00`0mFJ/70?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0=@m6@3D?AT00P3om^h0100mFJ/0
e3dI0?ofkP3D?AT20?ofkP030=@m6@3om^h0000000L0e3dI0P0000000`3D?AT0ooK^0?ofkP020?of
kP0303eIZ`000000000000L0:3Ma00<0e3dI02PgL@0X=g401`0X=g400`000000:3Ma02PgL@0302Pg
L@80000000<0;T230000000^@8<00P0^@8<00`3D?AT0;T2302i0P`0302i0P`030000000^@8<0;T23
00H0;T230P3D?AT702i0P`040=@m6@0000000000000000P0<dRA00<0000003=8T@0cB9401`0cB940
1P000000<dRA0=@m6@3D?AT0<dRA0=@m6@@0<dRA00<0000003=8T@0cB9400P0cB9430000000303M>
WP000000=djN00P0=djN00<0e3dI03M>WP3D?AT01@0gCYh00`000000=djN03M>WP0603M>WP030000
000gCYh0=djN0080=djN00@0e3dI03M>WP0gCYh0e3dI0P0mFJ/0103oCb00?EV[0?m?800000060?m?
80040000003oCb00odlP00000080od`O00<000000?m<7`3oC1l00`3oC1l020000000od`O0?m<7`3o
C1l0?EV[0000003oB1d000001@3oB1d00`000000odPM000000020?126P030=@m6@3`@QX0l48J00<0
l48J0P0000001@3@>1D000000=0h5@0mFJ/0000000<0?EV[00<000000?ofkP3om^h04@3om^h203eI
Z`L0ooK^100mFJ/80?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0000003om^h02`3om^h00`0m
FJ/0ooK^0?ofkP0;0?ofkP<0?EV[00H0ooK^00000000000000000?ofkP0mFJ/J0?ofkP030000003o
m^h0ooK^03@0ooK^0@3oool000h0ooK^00<000000?ofkP3om^h0BP3om^h403eIZ`T0ooK^00<0?EV[
0?ofkP3om^h0103om^h203eIZ`80ooK^00X0e3dI0?ofkP3om^h0?EV[0?ofkP3D?AT0ooK^0=@m6@3o
m^h0e3dI0`3om^h00`000000ooK^0=@m6@03000000030=@m6@3om^h0e3dI0080ooK^0P0mFJ/00`3o
m^h0000002PgL@0702PgL@030000003D?AT0:3Ma00L0:3Ma00@0000002PgL@0X=g40:3Ma0P000003
02i0P`030000000^@8<0;T230080;T2300<0e3dI02i0P`0^@8<00P0^@8<00`000000;T2302i0P`04
02i0P`80e3dI0P0^@8<00`000000;T2302i0P`0202i0P`<0000000<0e3dI0000000cB9402@0cB940
0`000000<dRA03=8T@0603=8T@030000003D?AT0<dRA00<0<dRA00H0e3dI03=8T@0cB940<dRA0000
000cB943000000@0=djN00<0000003M>WP0gCYh01P0gCYh01@3D?AT0000003M>WP0gCYh0e3dI00@0
=djN00<0000003M>WP0gCYh01P0gCYh01@000000=djN03M>WP0gCYh0e3dI00<0000000<0>UBY0000
000000000P3oCb000`0mFJ/000000?m?80050?m?80070000003oCb00odlP0?m?80000000od`O0000
00050?m<7`060000003oC1l0od`O0?m<7`0mFJ/0e3dI0P0000050?m87@060000003oB1d0odPM0000
003`@QX000001@3`@QX2000000030=0h5@3D?AT0?EV[0080?EV[00<000000:@Z3`0000000P00000B
0?ofkP80?EV[103om^h303eIZ``0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/000000?ofkP0:
0?ofkP0303eIZ`3om^h0ooK^00L0ooK^100mFJ/0103om^h000000000000000040?ofkP0303eIZ`3o
m^h0ooK^01P0ooK^00<000000?ofkP3om^h0=03om^h10?ooo`003P3om^h00`000000ooK^0?ofkP19
0?ofkP80?EV[303om^h00`0mFJ/0ooK^0?ofkP020?ofkP80?EV[1@3om^h20=@m6@0303eIZ`3om^h0
ooK^00@0e3dI0`3om^h3000000040=@m6@3om^h0ooK^03eIZ`80e3dI0P0mFJ/30?ofkP050000000X
=g40:3Ma02PgL@3D?AT0100X=g400`000000:3Ma0=@m6@0702PgL@040000000X=g400000000000H0
;T2300<0000002i0P`0^@8<00P0^@8<01@3D?AT0;T2302i0P`0^@8<0000000@0;T230P3D?AT402i0
P`030000000^@8<0000000800000100cB9400`3D?AT0<dRA03=8T@0803=8T@030000000cB940<dRA
00H0<dRA00<0e3dI03=8T@0cB940100cB9400`3D?AT0<dRA00000002000000L0=djN00<0000003M>
WP0gCYh01@0gCYh00`3D?AT0=djN0000000303M>WP050=@m6@0gCYh0=djN03M>WP000000200gCYh0
1@000000=djN0000003D?AT0000000<0>UBY00<000000?m@8@0000000P3oCb000`0mFJ/000000?m?
80050?m?80030000003oCb00odlP0080odlP0P0000040?m<7`030000003oC1l0od`O00<0od`O00<0
?EV[0?m<7`0000001@3oB1d010000000odPM0?m87@3oB1d2000000D0l48J00P0000003eIZ`0mFJ/0
?EV[0000000mFJ/0d3PE00000080Y2X?0`00000B0?ofkPD0?EV[3`3om^h00`0mFJ/0ooK^0?ofkP04
0?ofkP80?EV[00<0ooK^0000003om^h02P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP<0?EV[0P3om^h3
000000P0ooK^00<0?EV[0?ofkP3om^h05`3om^h00`000000ooK^0?ofkP0d0?ofkP40oooo000>0?of
kP030000003om^h0ooK^04P0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP0303eI
Z`P0ooK^0P3D?AT40?ofkP80e3dI00<0ooK^0000000000000P3om^h010000000ooK^0=@m6@3D?AT2
03eIZ`030=@m6@3om^h0ooK^00<0ooK^00<0000002PgL@0X=g400P0X=g401@3D?AT0:3Ma02PgL@0X
=g4000000080:3Ma00<0e3dI02PgL@0X=g400`0X=g43000000P0;T2300<0000002i0P`0^@8<00`0^
@8<0103D?AT0;T2302i0P`00000202i0P`80e3dI1@0^@8<3000000P0<dRA00<0e3dI03=8T@0cB940
1`0cB9400`000000<dRA03=8T@0403=8T@80e3dI00<0<dRA0000000cB9400`0cB942000000030=@m
6@0gCYh0000000P0=djN00<0000003M>WP0gCYh0100gCYh0103D?AT0=djN03M>WP00000303M>WP05
0=@m6@0gCYh0=djN03M>WP0000001`0gCYh30000000303YDZ@3D?AT0>UBY00<0>UBY00L000000?m@
8@3oD24000000?m?800mFJ/0000000D0odlP00<000000?m?803oCb00103oCb000`000000od`O0?m<
7`020?m<7`030000003oC1l0od`O00<0od`O00@0?EV[0?m<7`00000000000`3oB1d00`000000odPM
0?m87@030?m87@030000003`@QX0l48J0080l48J0P0mFJ/20?126P80000000D0d3PE03eIZ`000000
00000:@Z3`020000000307PM2`3om^h0ooK^00l0ooK^0`0mFJ/B0?ofkP0403eIZ`3om^h0ooK^0?of
kP<0?EV[00D0ooK^03eIZ`3om^h0ooK^0000000:0?ofkP0303eIZ`3om^h0?EV[00<0?EV[0P3om^h3
000000/0ooK^00<0?EV[0?ofkP3om^h05`3om^h00`000000ooK^0?ofkP0d0?ofkP40oooo000=0?of
kP030000003om^h0ooK^04T0ooK^00<0?EV[0?ofkP3om^h02`3om^h303eIZ`/0ooK^00<0?EV[0=@m
6@3D?AT00`3om^h3000000D0ooK^0`0mFJ/0103D?AT0ooK^0=@m6@3D?AT40?ofkP030000000X=g40
:3Ma00H0:3Ma00@0000002PgL@0X=g40:3Ma0P3D?AT30000000302i0P`000000;T2300P0;T2300<0
000002i0P`0^@8<0100^@8<00`3D?AT0;T23000000020=@m6@D0;T230P0000000`0cB940000003=8
T@0803=8T@030000003D?AT0e3dI00L0<dRA00<0000003=8T@0cB9400`0cB9401P3D?AT0<dRA03=8
T@0cB940000003=8T@<000000`0gCYh00`3D?AT0000003M>WP0703M>WP030000000gCYh0=djN00<0
=djN00D0e3dI03M>WP0gCYh0=djN0000000403M>WP040=@m6@0gCYh0=djN000000@0=djN0`000000
100jE:T0000003YDZ@3D?AT503YDZ@040000003oD240oe0Q0?m@8@80000000<0?EV[0?m?803oCb00
0`3oCb000`000000odlP0?m?80040?m?808000000`3oC1l00`000000od`O0?m<7`030?m<7`0503eI
Z`000000od`O0?m<7`0000000P3oB1d00`000000odPM0?m87@030?m87@8000000`0mFJ/030000000
l48J0?126P3`@QX000000=@m6@3@>1D0?EV[0000003@>1D000000:@Z3`80000000<0N1d;0?ofkP3o
m^h02`3om^h303eIZ`040?ofkP0mFJ/0ooK^03eIZa40ooK^100mFJ/50?ofkP0303eIZ`3om^h00000
00T0ooK^0`0mFJ/30?ofkP<000003P3om^h00`0mFJ/0ooK^0?ofkP0G0?ofkP030000003om^h0ooK^
03@0ooK^0@3oool000d0ooK^00<000000?ofkP3om^h0B03om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP<0
?EV[3@3om^h00`0mFJ/0ooK^0=@m6@0300000080ooK^0P3D?AT0203om^h0?EV[03eIZ`0mFJ/0ooK^
0000003om^h0?EV[0P3D?AT00`3om^h0e3dI0?ofkP020?ofkP030000000X=g40:3Ma00H0:3Ma00<0
000002PgL@0000000`0000001@3D?AT0;T2302i0P`0^@8<0000000T0;T2300<0000002i0P`0^@8<0
100^@8<30=@m6@040000000^@8<0;T2302i0P`<000000`0cB9400`000000<dRA03=8T@0703=8T@04
0000000cB940<dRA0=@m6@H0<dRA00<0000003=8T@0cB9400P0cB940103D?AT0<dRA03=8T@0cB943
000000L0=djN00<0e3dI03M>WP0gCYh01P0gCYh00`000000=djN03M>WP0203M>WP030=@m6@0gCYh0
=djN0080=djN00<0000003M>WP0gCYh00`0gCYh0103D?AT0=djN0000000gCYh3000000@0>UBY00<0
00000=@m6@0jE:T01@0jE:T010000000oe0Q0?m@8@3oD2420000000303eIZ`3oCb00odlP00<0odlP
00<000000?m?803oCb000`3oCb0010000000odlP0?m?800000020?m<7`030000003oC1l0od`O00@0
od`O00@0?EV[0?m<7`3oC1l000000P3oB1d00`000000odPM0?m87@020?m87@<0?EV[00@000000?12
6P3`@QX00000103`@QX020000000d3PE0=0h5@0mFJ/000000=0h5@000000e3dI0`00000:0?ofkP80
?EV[103om^h00`0mFJ/0ooK^03eIZ`0?0?ofkP@0?EV[1`3om^h0100mFJ/0ooK^0?ofkP0000050?of
kP<0?EV[00<0ooK^03eIZ`3om^h00`00000A0?ofkP0303eIZ`3om^h0ooK^01P0ooK^00<000000?of
kP3om^h0<`3om^h10?ooo`003@3om^h00`000000ooK^0?ofkP180?ofkP0303eIZ`3om^h0ooK^00L0
ooK^0`0mFJ/00`3om^h0?EV[0?ofkP0=0?ofkP0303eIZ`00000000000080e3dI103om^h30=@m6@@0
ooK^00@0000003eIZ`3om^h0e3dI0P3om^h0103D?AT0ooK^0?ofkP00000702PgL@<000001@0^@8<0
1@3D?AT0;T2302i0P`0^@8<0000000P0;T2300<0000002i0P`0^@8<00P0^@8<20=@m6@80;T2300<0
e3dI0000000^@8<00P00000703=8T@030000000cB940<dRA00H0<dRA00D0000003=8T@0cB940<dRA
0=@m6@0503=8T@030000000cB940<dRA0080e3dI0P0cB9420000000303M>WP000000=djN00L0=djN
00<0e3dI0000000gCYh01`0gCYh010000000=djN03M>WP3D?AT503M>WP030000000gCYh0=djN00@0
=djN00<0e3dI0000000000001`0jE:T00`000000e3dI03YDZ@0403YDZ@030000003oD240oe0Q00<0
oe0Q00<0000003eIZ`3oCb000`3oCb000`000000odlP0?m?80040?m?80060000003oCb00odlP0000
003oC1l000001`3oC1l0200mFJ/0od`O0?m<7`3oC1l000000?m87@000000odPM0`0mFJ/010000000
odPM0?m87@0000020?126P030000003`@QX0l48J0080l48J0P0000000`3@>1D0?EV[000000020=0h
5@D000001P3om^h303eIZ`L0ooK^0P0mFJ/<0?ofkP<0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP060?of
kP0503eIZ`3om^h0ooK^0000003om^h00`0mFJ/30?ofkP030000000mFJ/0000001@0ooK^00<0?EV[
0?ofkP3om^h0603om^h00`000000ooK^0?ofkP0c0?ofkP40oooo000=0?ofkP030000003om^h0ooK^
04L0ooK^00<0?EV[0?ofkP3om^h01@3om^h303eIZ`<0ooK^00<0?EV[0?ofkP3om^h02`3om^h30000
00@0ooK^00@0e3dI03eIZ`0mFJ/0?EV[0P3D?AT00`3om^h0e3dI0?ofkP030?ofkP0403eIZ`000000
e3dI0=@m6@80ooK^0P3D?AT00`000000:3Ma02PgL@0302PgL@80000000<0;T230000000^@8<01P0^
@8<0103D?AT0;T2302i0P`00000802i0P`030000000^@8<0e3dI0080e3dI100^@8<00`000000e3dI
0000000903=8T@030000000cB940<dRA00L0<dRA00D0000003=8T@0cB940<dRA0=@m6@0503=8T@04
0000003D?AT0<dRA03=8T@8000000`0gCYh00`000000=djN03M>WP0703M>WP030=@m6@0gCYh0=djN
00H0=djN00@0000003M>WP0gCYh0e3dI1@0gCYh00`000000=djN03M>WP0203M>WP80000000<0>UBY
0=@m6@0jE:T01P0jE:T00`000000e3dI03YDZ@0503YDZ@030000003oD240oe0Q00<0oe0Q0P000000
1@0mFJ/0odlP0?m?803oCb00000000H0odlP00@000000?m?803oCb00odlP0P0000060?m<7`030000
000mFJ/0od`O00<0od`O00<0000003eIZ`0mFJ/00`3oB1d01`000000odPM0?m87@3oB1d000000?12
6P000000103`@QX01@000000l48J0000003@>1D0?EV[00<0d3PE0P0000000`2T:Pl0000000000002
0?ofkP<0?EV[2P3om^h00`0mFJ/0ooK^03eIZ`080?ofkP<0?EV[1P3om^h00`0mFJ/0ooK^0?ofkP06
0?ofkP0503eIZ`3om^h0ooK^0000000mFJ/00`3om^h300000080ooK^00<0?EV[0?ofkP3om^h04P3o
m^h00`0mFJ/0ooK^0?ofkP0H0?ofkP030000003om^h0ooK^03<0ooK^0@3oool000d0ooK^00<00000
0?ofkP3om^h0A`3om^h00`0mFJ/0ooK^0?ofkP030?ofkP80?EV[1P3om^h00`0mFJ/0ooK^0?ofkP09
0?ofkP80000000<0ooK^03eIZ`3om^h00P3om^h303eIZ`040=@m6@3om^h0ooK^0?ofkP@0e3dI0`3o
m^h00`0mFJ/0ooK^000000020=@m6@0403eIZ`3om^h0ooK^0=@m6@<0:3Ma0P00000402i0P`030000
000^@8<0;T2300D0;T2300<0e3dI02i0P`0000001`0^@8<30=@m6@@0;T230`0000000`0cB9400000
0=@m6@0903=8T@030000000cB940<dRA00L0<dRA00<0000003=8T@0cB9400P0cB9400`3D?AT0<dRA
03=8T@0203=8T@040=@m6@0cB9400000000000D0=djN00<0000003M>WP0gCYh01`0gCYh00`000000
e3dI03M>WP0603M>WP030000000gCYh0e3dI00H0=djN00<0000003M>WP0000000P00000303YDZ@03
0000003D?AT0>UBY00D0>UBY00<0e3dI03YDZ@0jE:T01@0jE:T00`000000oe0Q0?m@8@020?m@8@04
0000003oD240oe0Q03eIZ`<0odlP00<000000?m?803oCb000`3oCb000`000000odlP0?m?80030?m?
80030000003oC1l0od`O00@0od`O00@000000?m<7`0mFJ/0od`O0`0mFJ/00`000000odPM0?m87@02
0?m87@030000003oB1d0odPM0080odPM0P0000040?126P050000003`@QX000000=0h5@0mFJ/00`3@
>1D3000000040:@Z3`000000?EV[03eIZ`d0ooK^00<0?EV[0?ofkP0mFJ/01@3om^h303eIZ`T0ooK^
00<0?EV[0?ofkP3om^h01P3om^h303eIZ`030?ofkP0000000000008000001@3om^h00`0mFJ/0ooK^
0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^01L0ooK^00<000000?ofkP3om^h0<`3om^h10?ooo`00303o
m^h00`000000ooK^0?ofkP170?ofkP0403eIZ`3om^h0ooK^0?ofkP<0?EV[203om^h00`0mFJ/0ooK^
0?ofkP060?ofkP<000000`3om^h0100mFJ/0ooK^03eIZ`0mFJ/40?ofkP80e3dI00@0ooK^0=@m6@3o
m^h0ooK^0P3D?AT20?ofkP0603eIZ`3om^h0ooK^0=@m6@3om^h0e3dI0P3om^h010000000e3dI0000
0000000602i0P`030000000^@8<0;T2300H0;T2300<0e3dI0000000^@8<0100^@8<20=@m6@80;T23
00<0000002i0P`0000000P00000503=8T@030000003D?AT0<dRA00L0<dRA00<0000003=8T@0cB940
1`0cB9400`000000<dRA03=8T@0303=8T@040=@m6@0cB940e3dI0=@m6@800000200gCYh00`000000
=djN03M>WP0603M>WP030000000gCYh0e3dI00H0=djN00<000000=@m6@0gCYh01@0gCYh3000000H0
>UBY00<0000003YDZ@3D?AT01@0jE:T00`3D?AT0>UBY03YDZ@0503YDZ@030000003oD240oe0Q0080
oe0Q00D000000?m@8@3oD240oe0Q03eIZ`020?m?80030000003oCb00odlP00<0odlP00<000000?m?
803oCb000`3oCb02000000D0od`O00@0000003eIZ`0mFJ/0?EV[0`3oC1l2000000<0odPM00<00000
0?m87@3oB1d00`3oB1d00`000000l48J0?126P020?126P060000003`@QX0l48J0000000mFJ/00000
0P3@>1D300000080Y2X?00<000000?ofkP3om^h0303om^h01@0mFJ/0ooK^0?ofkP0mFJ/0ooK^00<0
?EV[3@3om^h00`0mFJ/0ooK^0?ofkP020?ofkP<0?EV[00H0ooK^03eIZ`00000000000?ofkP000007
0?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h05`3om^h00`000000ooK^0?ofkP0c
0?ofkP40oooo000<0?ofkP030000003om^h0ooK^04L0ooK^100mFJ/;0?ofkP0303eIZ`3om^h0ooK^
00<0ooK^0`0000050?ofkP<0?EV[1`3om^h40=@m6@80ooK^0P3D?AT02@3om^h0?EV[0?ofkP3om^h0
e3dI0000003om^h0e3dI0?ofkP02000000030=@m6@0^@8<0;T2300D0;T2300<0000002i0P`0^@8<0
1`0^@8<00`3D?AT0;T2302i0P`030=@m6@<0;T230`00000803=8T@030000000cB940e3dI00P0<dRA
00<0000003=8T@0cB9401P0cB9400`000000<dRA03=8T@0303=8T@050000003D?AT0000003M>WP00
00002@0gCYh00`000000=djN03M>WP0603M>WP040000000gCYh0=djN0=@m6@D0=djN00<0e3dI03M>
WP0gCYh00P0gCYh30000000303YDZ@000000>UBY00H0>UBY00<0000003YDZ@3D?AT0100jE:T00`3D
?AT0000003YDZ@0503YDZ@030000003oD240oe0Q00<0oe0Q00D000000?m@8@3oD240oe0Q03eIZ`02
000000H0odlP00<000000?m?803oCb000P3oCb0010000000odlP0?m?800000020?m<7`<0?EV[00<0
od`O03eIZ`3oC1l00P3oC1l00`000000od`O000000030?m87@030000003oB1d0odPM00<0odPM0P00
00030?126P060000003`@QX0l48J0?126P000000?EV[0`3@>1D3000000030:@Z3`000000000000d0
ooK^00<0?EV[0?ofkP0mFJ/00P0mFJ/@0?ofkP0303eIZ`3om^h0?EV[0080?EV[00H0ooK^00000000
000000000?ofkP0mFJ/30?ofkP030000003om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h04`3om^h0
0`0mFJ/0ooK^0?ofkP0H0?ofkP030000003om^h0ooK^0380ooK^0@3oool000`0ooK^00<000000?of
kP3om^h0AP3om^h203eIZ`d0ooK^00<0?EV[0?ofkP3om^h00P3om^h2000000H0ooK^0P0mFJ/00`3o
m^h0?EV[0?ofkP080?ofkP80e3dI00@0ooK^0=@m6@3D?AT0ooK^0P3D?AT02@0mFJ/0ooK^0?ofkP3D
?AT0ooK^0000003om^h0e3dI0000000202i0P`030=@m6@0^@8<0;T2300@0;T2300<0000002i0P`0^
@8<01P0^@8<40=@m6@@0;T230P0000000`0cB940000003=8T@0803=8T@040000000cB940<dRA0=@m
6@L0<dRA00<0000003=8T@0cB9401`0cB94010000000<dRA0000000000020=@m6@0403M>WP3D?AT0
=djN000000T0=djN00<0000003M>WP0gCYh01P0gCYh01@000000=djN03M>WP0gCYh0e3dI00<0=djN
00<0e3dI0000000gCYh00`00000403YDZ@030000000jE:T0>UBY00D0>UBY00@0000003YDZ@0jE:T0
e3dI0P0jE:T00`3D?AT0>UBY0000000603YDZ@030000003oD240oe0Q00<0oe0Q00L000000?m@8@3o
D240oe0Q03eIZ`3oD240000000H0odlP00<000000?m?803oCb000P3oCb000`000000odlP0?m?8003
03eIZ`030?m<7`000000od`O0080od`O00@0?EV[0?m<7`3oC1l000000P3oC1l010000000odPM0?m8
7@0000050?m87@030000003oB1d000000080l48J00<000000?126P3`@QX00P3`@QX01`0mFJ/0d3PE
0=0h5@3@>1D000000=0h5@0000000P2T:Pl2000000/0ooK^0`0mFJ/20?ofkP0303eIZ`3om^h0ooK^
00d0ooK^0`0mFJ/0103om^h000000000000000040?ofkP0503eIZ`3om^h0ooK^0?ofkP0000001`3o
m^h00`0mFJ/0ooK^0?ofkP0A0?ofkP80?EV[6P3om^h00`000000ooK^0?ofkP0b0?ofkP40oooo000<
0?ofkP030000003om^h0ooK^04H0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^00000002
000000D0ooK^0`0mFJ/30?ofkP0303eIZ`3om^h0ooK^00P0ooK^0`3D?AT00`3om^h0e3dI0=@m6@02
0=@m6@<0ooK^00H0e3dI0?ofkP000000ooK^0=@m6@00000202i0P`030=@m6@0^@8<0;T2300@0;T23
00<0000002i0P`0^@8<01@3D?AT202i0P`040000003D?AT0;T2302i0P`800000100cB9400`000000
<dRA03=8T@0703=8T@040000000cB940<dRA0=@m6@H0<dRA00<0000003=8T@0cB9401P0cB9430000
0080e3dI100gCYh00`3D?AT0=djN0000000803M>WP030000000gCYh0=djN00L0=djN00L0000003M>
WP0gCYh0=djN0=@m6@0gCYh0e3dI00<000001`0jE:T00`000000>UBY03YDZ@0503YDZ@090000000j
E:T0>UBY03YDZ@3D?AT0>UBY0=@m6@0jE:T0000000H0>UBY00<000000?m@8@3oD2400P3oD2400`00
0000oe0Q0?m@8@030?m@8@0303eIZ`000000000000@0odlP00<000000?m?803oCb000`3oCb0303eI
Z`050?m?80000000od`O0?m<7`0000000`3oC1l0100mFJ/0od`O0?m<7`0000030?m<7`030000003D
?AT0odPM00@0odPM00@000000?m87@3oB1d000000P3`@QX00`000000l48J0?126P020?126P060000
000mFJ/0d3PE0=0h5@000000d3PE0P0000000`2T:Pl00000000000070?ofkP@0?EV[0P3om^h0100m
FJ/0ooK^0?ofkP0mFJ/<0?ofkP<0?EV[00@0ooK^03eIZ`0000000000203om^h01@0mFJ/0ooK^0?of
kP3om^h0000000H0ooK^00<0?EV[0?ofkP3om^h03P3om^h303eIZ`030?ofkP0mFJ/0ooK^01T0ooK^
00<000000?ofkP3om^h0<P3om^h10?ooo`002`3om^h00`000000ooK^0?ofkP160?ofkP0303eIZ`3o
m^h0ooK^00`0ooK^0`0000060?ofkP80?EV[1P3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP80e3dI0`3o
m^h80=@m6@0303eIZ`3D?AT0e3dI0080;T2300@0e3dI02i0P`0^@8<0;T231@3D?AT702i0P`040000
000^@8<0e3dI000000H0<dRA00<0000003=8T@0cB9401`0cB9401@000000<dRA03=8T@0cB940e3dI
00D0<dRA00<0000003=8T@0cB9400`0cB9430000000303M>WP3D?AT0e3dI00L0=djN00<0e3dI0000
000gCYh01`0gCYh00`000000=djN03M>WP0703M>WP030000000gCYh0=djN0080=djN00@0e3dI0000
000jE:T00000200jE:T00`000000>UBY03YDZ@0503YDZ@030000000jE:T0>UBY0080>UBY00@0e3dI
03YDZ@0jE:T000001P0jE:T00`000000oe0Q0?m@8@020?m@8@030000003oD240oe0Q00<0oe0Q00@0
?EV[0?m@8@3oD24000000`3oCb000`000000odlP03eIZ`0303eIZ`D0odlP0P0000050?m<7`0303eI
Z`000000od`O00<0od`O00<000000=@m6@3oB1d0103oB1d01`000000odPM0?m87@3oB1d000000?12
6P000000103`@QX01@000000?EV[0000003@>1D000000080d3PE00<000000:@Z3`2T:Pl00P000003
0?ofkP<0?EV[1P3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00P0ooK^0`0mFJ/01@3om^h000000000
00000000?EV[00X0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`000000ooK^0?ofkP030?ofkP0303eI
Z`3om^h0ooK^00X0ooK^100mFJ/40?ofkP0303eIZ`3om^h0ooK^01P0ooK^00<000000?ofkP3om^h0
<P3om^h10?ooo`002`3om^h00`000000ooK^0?ofkP160?ofkP0303eIZ`3om^h0ooK^00X0ooK^0P00
00000`3om^h0?EV[0?ofkP040?ofkP80?EV[203om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP050=@m6@3o
m^h0ooK^0?ofkP0mFJ/00P3D?AT00`3om^h0e3dI0?ofkP020?ofkPT0e3dI0P0^@8<00`000000;T23
02i0P`0602i0P`<0000000<0<dRA0=@m6@3D?AT01P0cB9400`000000<dRA03=8T@0703=8T@050000
000cB940<dRA03=8T@3D?AT01@0cB9400`000000<dRA00000002000000<0=djN00<0e3dI03M>WP00
0000200gCYh00`3D?AT0=djN03M>WP0603M>WP030000000gCYh0=djN00L0=djN00<0000003M>WP00
00000P3D?AT0100jE:T0e3dI03YDZ@00000803YDZ@030000000jE:T0>UBY00@0>UBY00<0000003YD
Z@0jE:T00P0jE:T01@3D?AT0>UBY0=@m6@0jE:T0000000D0>UBY00<000000?m@8@3oD2400`3oD240
0`000000oe0Q0?m@8@030?m@8@0603eIZ`3oD240oe0Q0?m@8@000000odlP0`0mFJ/30?m?80030000
003oCb00odlP00@0odlP00<000000?m<7`3oC1l00`3oC1l00`0mFJ/000000?m<7`040?m<7`030000
003oB1d0odPM00<0odPM00<000000?m87@3oB1d00P3oB1d2000000@0l48J00D000000?126P0mFJ/0
d3PE000000020=0h5@80000000<0Y2X?0000002T:Pl00`0mFJ/90?ofkP0503eIZ`3om^h0ooK^0?of
kP0mFJ/0103om^h403eIZ`040?ofkP0000000000000000@0ooK^00<0?EV[0?ofkP3om^h0203om^h0
1@0mFJ/0ooK^0?ofkP3om^h0000000D0ooK^00<0?EV[0?ofkP3om^h01`3om^h303eIZ`P0ooK^00<0
?EV[0?ofkP3om^h0603om^h00`000000ooK^0?ofkP0b0?ofkP40oooo000;0?ofkP030000003om^h0
ooK^04H0ooK^00<0?EV[0?ofkP3om^h01`3om^h300000080ooK^00@0?EV[0?ofkP3om^h0ooK^0`0m
FJ/:0?ofkP0303eIZ`3om^h0ooK^00`0ooK^0P3D?AT0103om^h0?EV[0?ofkP3om^h20=@m6@<0?EV[
00<0ooK^0000000^@8<0100^@8<01@3D?AT0;T2302i0P`0^@8<0000000D0;T230`0000000`0cB940
000003=8T@0303=8T@030=@m6@0cB940<dRA00<0<dRA00<0000003=8T@0cB9401`0cB9400`000000
<dRA03=8T@0203=8T@040=@m6@0cB940<dRA03=8T@<00000100gCYh20=@m6@80=djN00<0000003M>
WP0gCYh01P0gCYh00`000000e3dI03M>WP0703M>WP030000000gCYh0=djN00D0=djN0`0000000`3D
?AT0>UBY03YDZ@0203YDZ@030=@m6@000000>UBY00L0>UBY00<0000003YDZ@0jE:T0100jE:T01@00
0000>UBY03YDZ@0jE:T0e3dI00<0>UBY00<0e3dI03YDZ@0jE:T0100jE:T00`000000oe0Q0?m@8@02
0?m@8@030000003oD240oe0Q00@0oe0Q00<0000003eIZ`3oD2400`0mFJ/00`000000odlP0?m?8003
0?m?80030000003oCb00odlP00@0odlP0P0000040?m<7`030000000mFJ/0od`O00@0od`O0P000004
0?m87@030000003oB1d0odPM00<0odPM00<000000?126P3`@QX00P3`@QX020000000l48J03eIZ`00
0000d3PE0000003@>1D00000100mFJ/00`000000e3dI0?ofkP0:0?ofkP0403eIZ`3om^h0ooK^0?of
kP@0?EV[0P3om^h3000000L0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP020?of
kP030000003om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h00`3om^h303eIZ``0ooK^00<0?EV[0?of
kP3om^h0603om^h00`000000ooK^0?ofkP0a0?ofkP40oooo000;0?ofkP030000003om^h0ooK^04H0
ooK^00<0?EV[0?ofkP3om^h01@3om^h2000000D0ooK^00@0?EV[0?ofkP0mFJ/0?EV[3@3om^h00`0m
FJ/0ooK^0?ofkP0=0?ofkP80e3dI00@0?EV[0?ofkP0mFJ/0?EV[0P3D?AT40?ofkP030000000^@8<0
;T2300<0;T2300H0e3dI02i0P`0^@8<0;T230000000^@8<3000000D0<dRA00<0000003=8T@0cB940
0P0cB9400`3D?AT0<dRA03=8T@0303=8T@030000000cB940<dRA00H0<dRA00<0000003=8T@0cB940
0`0cB9401@3D?AT000000000000gCYh0000000<0=djN0P3D?AT403M>WP030000000gCYh0=djN00L0
=djN00<000000=@m6@0gCYh01P0gCYh00`000000=djN03M>WP0203M>WP<0000000<0>UBY0000003D
?AT01P0jE:T00`3D?AT0>UBY03YDZ@0603YDZ@030000000jE:T0>UBY00@0>UBY00@0000003YDZ@0j
E:T0e3dI100jE:T00`000000e3dI03YDZ@0303YDZ@800000103oD2400`000000oe0Q0?m@8@040?m@
8@<0?EV[0`3oD2400`000000odlP0?m?80030?m?80030000003oCb00odlP00<0odlP00@000000?m?
803oCb0000000`3oC1l00`000000?EV[0?m<7`030?m<7`040000003oC1l0od`O000000<0odPM00<0
00000?m87@3oB1d00`3oB1d2000000<0l48J00D000000?126P3`@QX0?EV[0000000303eIZ`060000
003@>1D000000=@m6@2T:Pl000002`3om^h00`0mFJ/0ooK^03eIZ`0203eIZ`80ooK^0`00000:0?of
kP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`000000ooK^0?ofkP020?of
kP0303eIZ`3om^h0?EV[00<0?EV[3`3om^h00`0mFJ/0ooK^0?ofkP0H0?ofkP030000003om^h0ooK^
0340ooK^0@3oool000X0ooK^00<000000?ofkP3om^h0AP3om^h00`0mFJ/0ooK^0?ofkP030?ofkP<0
00001P3om^h303eIZ`l0ooK^00<0?EV[0?ofkP3om^h03P3om^h20=@m6@0403eIZ`3om^h0ooK^0?of
kP80e3dI0`3om^h00`000000;T2302i0P`0402i0P`80e3dI0`00000803=8T@030000000cB940<dRA
00<0<dRA00<0e3dI03=8T@0cB9400P0cB9400`000000<dRA03=8T@0703=8T@030000000cB9400000
0080000000<0=djN0=@m6@0gCYh00P0gCYh00`000000e3dI0=@m6@0703M>WP030000000gCYh0=djN
00H0=djN00<000000=@m6@0gCYh01P0gCYh00`000000=djN00000002000000<0>UBY0P3D?AT703YD
Z@030000003D?AT0>UBY00H0>UBY00<0000003YDZ@0jE:T0100jE:T00`000000>UBY0=@m6@0503YD
Z@030000000jE:T0e3dI00<0000000<0?EVc0000000000000`3oD24010000000oe0Q0?m@8@3oD243
03eIZ`030?m@8@0mFJ/0oe0Q00<0oe0Q0P0000030?m?80030000003oCb00odlP00@0odlP00D00000
0?m?803oCb00odlP000000020?m<7`030000000mFJ/0od`O00<0od`O00@000000?m<7`3oC1l00000
0`3oB1d00`000000odPM0?m87@030?m87@030000003oB1d000000080l48J00<000000?126P0mFJ/0
0P0mFJ/010000000d3PE0=0h5@0000020=0h5@<0000000<0e3dI0?ofkP3om^h01`3om^h303eIZ`80
ooK^00<0000003eIZ`0000003@3om^h00`0mFJ/0ooK^0?ofkP080?ofkP80?EV[1@3om^h00`000000
ooK^0?ofkP0303eIZa<0ooK^00<0?EV[0?ofkP3om^h0603om^h00`000000ooK^0?ofkP0a0?ofkP40
oooo000:0?ofkP030000003om^h0ooK^04H0ooK^00<0?EV[0?ofkP3om^h00`0000060?ofkP<0?EV[
00<0ooK^03eIZ`3om^h03`3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP80?EV[00<0ooK^0=@m6@3D?AT0
103om^h20=@m6@80ooK^00<0000002i0P`0^@8<00`0^@8<3000000030=@m6@0cB940000000T0<dRA
00<0000003=8T@0cB9400`0cB9400`3D?AT0<dRA03=8T@0203=8T@030000000cB940<dRA00D0<dRA
0`00000503M>WP040=@m6@0gCYh0e3dI0=@m6@T0=djN00<0000003M>WP0gCYh01P0gCYh00`000000
=djN0=@m6@0503M>WP<000001@0jE:T00`3D?AT0>UBY0000000703YDZ@030000000jE:T0e3dI00H0
>UBY00<0000003YDZ@0jE:T0100jE:T00`000000e3dI03YDZ@0403YDZ@<0000000D0?EVc0=@m6@0m
FK<0?EVc000000020?mA8@030000003oD240oe0Q00@0?EV[0P3oD24010000000oe0Q0?m@8@0mFJ/2
0?m@8@040000003oD240oe0Q00000080odlP00<000000?m?803oCb000`3oCb000`000000odlP0?m?
80030?m?808000000P3oC1l01@0mFJ/0od`O0?m<7`3oC1l0000000<0od`O00<000000?m87@000000
1@3oB1d01@000000odPM0?m87@000000l48J00<0?EV[0P3`@QX01@0mFJ/000000000003@>1D00000
00<0d3PE00@000000:@Z3`000000e3dI1@3om^h303eIZ`030?ofkP0mFJ/000000080000000<0ooK^
03eIZ`3om^h03P3om^h00`0mFJ/0ooK^0?ofkP040?ofkP<0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP02
0?ofkP050000000mFJ/0?EV[0?ofkP0mFJ/0503om^h00`0mFJ/0ooK^0?ofkP0H0?ofkP030000003o
m^h0ooK^0340ooK^0@3oool000X0ooK^00<000000?ofkP3om^h0AP3om^h00`0mFJ/0000000000006
0?ofkP<0?EV[103om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00T0ooK^0`0mFJ/3
0?ofkP0403eIZ`3om^h0e3dI0=@m6@80ooK^0`3D?AT20?ofkP030000000^@8<0000000800000100c
B9400`3D?AT0000003=8T@0803=8T@030000000cB940<dRA00@0<dRA00D0e3dI03=8T@0cB940<dRA
0000000503=8T@80000000<0=djN0000000gCYh01@0gCYh20=@m6@80=djN00<0000003M>WP0gCYh0
1P0gCYh00`000000=djN03M>WP0603M>WP040000000gCYh0=djN0=@m6@80=djN0P0000000`0jE:T0
000003YDZ@0403YDZ@050=@m6@0jE:T0>UBY03YDZ@0000001P0jE:T010000000>UBY03YDZ@3D?AT5
03YDZ@030000000jE:T0>UBY00<0>UBY0P3D?AT403YDZ@80000000<0?EVc0000000mFK<00P0mFK<0
0`3D?AT0?EVc000000020?mA8@<0?EV[1P3oD24010000000oe0Q0?m@8@0mFJ/20?m@8@040000003o
D240oe0Q00000080odlP00<000000?m?803oCb000`3oCb000`000000odlP0?m?80040?m?80040000
003oC1l0od`O03eIZ`<0od`O00<000000?m<7`3oC1l00P3oC1l2000000D0odPM00<000000?m87@3o
B1d00P0mFJ/00`3`@QX000000?126P020?126P0303eIZ`000000l48J008000000`3@>1D300000080
e3dI100mFJ/01@3om^h00000000000000000?EV[00D0ooK^00<0?EV[0?ofkP3om^h0303om^h0100m
FJ/0ooK^0?ofkP3om^h303eIZ`D0ooK^00<0?EV[0?ofkP0mFJ/00P0mFJ/01@3om^h000000?ofkP3o
m^h0?EV[01@0ooK^00<0?EV[0?ofkP3om^h0603om^h00`000000ooK^0?ofkP0a0?ofkP40oooo000:
0?ofkP030000003om^h0ooK^04@0ooK^0`0000060?ofkP80?EV[1`3om^h00`0mFJ/0ooK^0?ofkP0>
0?ofkP0303eIZ`3om^h0ooK^00L0ooK^0P0mFJ/60?ofkP0303eIZ`3om^h0ooK^0080e3dI0P3om^h3
0=@m6@030?ofkP000000000000P0<dRA00<0e3dI0000000cB940200cB9400`000000<dRA03=8T@04
03=8T@060=@m6@0cB940<dRA03=8T@000000<dRA0`00000403M>WP030000000gCYh0=djN00<0e3dI
0P0gCYh00`3D?AT0=djN0000000903M>WP030000000gCYh0=djN00H0=djN00D0000003M>WP000000
e3dI0000000403YDZ@030000000jE:T0>UBY0080e3dI100jE:T00`000000>UBY03YDZ@0503YDZ@04
0000000jE:T0>UBY0=@m6@@0>UBY00<0000003YDZ@0jE:T00P0jE:T0103D?AT0>UBY0000000jE:T3
000000<0?EVc00<0000003eI/`0mFK<00P0mFK<0103D?AT0000003eIZ`0mFJ/20?mA8@030000003o
D240oe0Q00<0oe0Q00<000000?m@8@3oD2400P3oD2400`0mFJ/000000?m@8@030?m@8@8000001@3o
Cb000`000000odlP0?m?80050?m?808000000P3oC1l00`0mFJ/0od`O000000060?m<7`030000003o
B1d0odPM00<0odPM0`0mFJ/20?m87@800000103`@QX01@0mFJ/0l48J0000003@>1D000000080d3PE
0P00000303eIZ`80ooK^0`0000030?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h0
303om^h403eIZ`P0ooK^0P0mFJ/50?ofkP030000003om^h0?EV[01@0ooK^00<0?EV[0?ofkP3om^h0
6@3om^h00`000000ooK^0?ofkP0`0?ofkP40oooo000:0?ofkP030000003om^h0ooK^0440ooK^0`00
00000`3om^h0?EV[0?ofkP030?ofkP<0?EV[2@3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3o
m^h0ooK^00@0ooK^0`0mFJ/80?ofkP0403eIZ`3om^h0ooK^0?ofkP@0e3dI00D0ooK^0=@m6@3D?AT0
ooK^0000000903=8T@030=@m6@0cB940<dRA00L0<dRA00<0000003=8T@0cB9401@0cB9420=@m6@<0
00001`0gCYh30=@m6@H0=djN00<0e3dI0000000gCYh0200gCYh00`000000=djN03M>WP0503M>WP<0
00000P0jE:T00`3D?AT0>UBY03YDZ@0203YDZ@030000000jE:T0e3dI00H0>UBY00<0000003YDZ@0j
E:T01@0jE:T01@000000>UBY03YDZ@0jE:T0e3dI00<0>UBY00H0000003YDZ@0jE:T0>UBY0=@m6@0j
E:T3000000D0?EVc00<0000003eI/`0mFK<0100mFK<00`000000?EV[0?mA8@020?mA8@800000103o
D2400`000000oe0Q0?m@8@020?m@8@0303eIZ`000000oe0Q00@0oe0Q00<000000?m?803oCb000`3o
Cb000`000000odlP0?m?80040?m?80080000003oCb00odlP0000003oC1l0?EV[0?m<7`0000060?m<
7`80000000D0odPM03eIZ`0mFJ/0?EV[000000050?m87@030000003`@QX0l48J0080l48J00<0?EV[
0?126P3`@QX00P0000030=0h5@<000000P3D?AT00`000000ooK^0?ofkP050?ofkP0303eIZ`3om^h0
ooK^00<0ooK^00<0?EV[0?ofkP3om^h02P3om^h203eIZ`P0ooK^0`0mFJ/00`3om^h0?EV[0?ofkP04
0?ofkP030000003om^h0?EV[01D0ooK^00<0?EV[0?ofkP3om^h0603om^h00`000000ooK^0?ofkP0`
0?ofkP40oooo00090?ofkP030000003om^h0ooK^0400ooK^0P0000040?ofkP0303eIZ`3om^h0?EV[
0080?EV[303om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0403eIZ`3om^h0ooK^0?ofkP<0?EV[2`3om^h0
0`0mFJ/0ooK^0?ofkP020?ofkP@0e3dI00@0ooK^0=@m6@3D?AT000002P0cB9400`3D?AT0<dRA03=8
T@0703=8T@030000000cB940<dRA00<0<dRA0`0000000`3D?AT0=djN0000000403M>WP<0e3dI00<0
=djN0000000gCYh01`0gCYh00`3D?AT0000003M>WP0703M>WP030000000gCYh0=djN00<0=djN0P00
00000`0jE:T0000003YDZ@0303YDZ@060=@m6@0jE:T0>UBY03YDZ@000000e3dI1`0jE:T00`000000
>UBY03YDZ@0503YDZ@030000000jE:T0>UBY0080>UBY00@0e3dI03YDZ@0jE:T000000P0jE:T01@3D
?AT000000000000mFK<0000000H0?EVc00<0000003eI/`0mFK<00`0mFK<00`000000oe4Q0?mA8@02
0?mA8@040000003oDB40oe4Q000000<0oe0Q00<000000?m@8@3oD2400`3oD2400`0mFJ/0oe0Q0?m@
8@030?m@8@800000103oCb000`000000odlP0?m?80040?m?80040000003oCb00odlP00000080od`O
00<0?EV[0000003oC1l0103oC1l010000000?EV[03eIZ`0mFJ/30?m87@030000003oB1d0odPM00<0
odPM0P0000030?126P050000000mFJ/0l48J0?126P0000000`3@>1D00`000000d3PE000000030=@m
6@L0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP070?ofkP<0?EV[0P3om^h00`0m
FJ/0ooK^0?ofkP020?ofkP<0?EV[1@3om^h00`0mFJ/0ooK^0?ofkP030?ofkP030000000mFJ/0ooK^
01@0ooK^00<0?EV[0?ofkP3om^h0603om^h00`000000ooK^0?ofkP0`0?ofkP40oooo00090?ofkP03
0000003om^h0ooK^03d0ooK^0`0000060?ofkP80?EV[3`3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP04
03eIZ`3om^h0?EV[03eIZ`h0ooK^00<0?EV[0?ofkP3om^h00`3om^h20=@m6@040?ofkP3D?AT0e3dI
0?ofkP80e3dI2P0cB9400`3D?AT0<dRA03=8T@0603=8T@030000000cB940<dRA00<00000100gCYh0
0`3D?AT0000003M>WP030=@m6@@0=djN00<0000003M>WP0gCYh01`0gCYh00`3D?AT0=djN03M>WP07
03M>WP030000000gCYh0000000800000100jE:T00`000000>UBY03YDZ@0203YDZ@050=@m6@0jE:T0
e3dI0=@m6@0000001`0jE:T00`000000>UBY03YDZ@0503YDZ@030000000jE:T0>UBY00<0>UBY00H0
e3dI03YDZ@000000>UBY0=@m6@00000303eI/`030000000mFK<0?EVc00@0?EVc00<0000003eI/`0m
FK<00`0mFK<00`000000oe4Q0?mA8@020?mA8@050000003oDB40oe4Q0?mA8@0000000P3oD2400`00
0000oe0Q0?m@8@020?m@8@030000000mFJ/0oe0Q00<0oe0Q00@000000?m@8@3oD24000000P3oCb00
0`000000odlP0?m?80040?m?80030000003oCb00odlP0080odlP00@000000?m<7`0mFJ/00000103o
C1l203eIZ`<0od`O00<000000?m87@0000001P3oB1d01`000000odPM0000003`@QX0e3dI0000000m
FJ/00P3`@QX200000080d3PE00@000000=0h5@00000000000`3D?AT60?ofkP0303eIZ`3om^h0ooK^
00@0ooK^00<0?EV[0?ofkP3om^h00`3om^h303eIZ`D0ooK^00<0?EV[0?ofkP0mFJ/00P0mFJ/80?of
kP0303eIZ`3om^h0ooK^00@0ooK^00<000000?ofkP3om^h04P3om^h203eIZaX0ooK^00<000000?of
kP3om^h0<03om^h10?ooo`002@3om^h00`000000ooK^0?ofkP0k0?ofkP8000002@3om^h00`0mFJ/0
ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00h0ooK^0`0mFJ/@0?ofkP0303eIZ`3om^h0ooK^00@0
ooK^0`3D?AT00`3om^h0e3dI0=@m6@020=@m6@T0<dRA00<000000=@m6@3D?AT01P0cB943000000H0
=djN103D?AT803M>WP030000000gCYh0=djN00L0=djN00<0e3dI03M>WP0gCYh01@0gCYh3000000L0
>UBY00<0000003YDZ@0jE:T00`0jE:T0103D?AT0>UBY03YDZ@00000703YDZ@030000000jE:T0>UBY
00D0>UBY00<0000003YDZ@0jE:T0100jE:T00`3D?AT000000=@m6@0503eI/`030000000mFK<0?EVc
00@0?EVc00<0000003eI/`0mFK<00`0mFK<00`000000oe4Q0?mA8@020?mA8@030000003oDB40oe4Q
0080oe4Q0P0000050?m@8@030000000mFJ/0oe0Q00<0oe0Q00@000000?m@8@3oD24000000P3oCb00
0`000000odlP0?m?80040?m?80030000003oCb00odlP00<0odlP0P0000000`0mFJ/0od`O03eIZ`02
03eIZ`030000003oC1l0od`O00<0od`O00<000000=@m6@3oB1d0103oB1d03`000000odPM0?m87@3o
B1d000000?126P000000l48J03eIZ`3`@QX000000?126P000000d3PE000000020=0h5@030000003D
?AT0e3dI0080e3dI1@3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00<0?EV[1`3o
m^h303eIZ``0ooK^00<0?EV[0?ofkP3om^h0103om^h00`000000ooK^0?ofkP0=0?ofkP@0?EV[00<0
ooK^03eIZ`3om^h06@3om^h00`000000ooK^0?ofkP0`0?ofkP40oooo00090?ofkP030000003om^h0
ooK^03P0ooK^0`00000;0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h02`3om^h3
03eIZ`030?ofkP0mFJ/0ooK^0140ooK^00<0?EV[0?ofkP3om^h01@3om^h20=@m6@80ooK^0`3D?AT9
03=8T@030000000cB940e3dI00<0<dRA0P00000203M>WP030000000gCYh0e3dI00@0e3dI0`0gCYh0
0`3D?AT0=djN03M>WP0603M>WP030000000gCYh0=djN00L0=djN00<000000=@m6@0gCYh00`0gCYh2
0000000303YDZ@000000>UBY00L0>UBY00@0000003YDZ@0jE:T0>UBY0P3D?AT0100jE:T0e3dI03YD
Z@00000703YDZ@030000000jE:T0>UBY00D0>UBY00<0000003YDZ@0jE:T0100000000`0mFK<0e3dI
03eI/`0503eI/`030000000mFK<0?EVc00@0?EVc00<0000003eI/`0mFK<00`0mFK<00`000000oe4Q
0?mA8@020?mA8@030000003oDB40oe4Q00<0oe4Q00<000000?m@8@3oD2400`3oD2400`000000oe0Q
03eIZ`020?m@8@030000003oD240oe0Q0080oe0Q0P0000060?m?80030000003oCb00odlP00D0odlP
0`0mFJ/30?m<7`030000003oC1l0od`O00<0od`O00<0e3dI0000003oB1d0103oB1d00`000000odPM
0?m87@020?m87@80000000P0l48J03eIZ`3`@QX000000?126P000000d3PE00000080d3PE00<00000
0?ofkP3D?AT00P3D?AT50?ofkP0303eIZ`3om^h0ooK^00@0ooK^0`0mFJ/70?ofkP<0?EV[00<0ooK^
03eIZ`3om^h03@3om^h00`0mFJ/0ooK^0?ofkP030?ofkP030000003om^h0ooK^00X0ooK^0`0mFJ/5
0?ofkP0303eIZ`3om^h0ooK^01T0ooK^00<000000?ofkP3om^h0;`3om^h10?ooo`00203om^h00`00
0000ooK^0?ofkP0f0?ofkP<000003P3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^
00P0ooK^0`0mFJ/40?ofkP0303eIZ`3om^h0ooK^0100ooK^00<0?EV[0?ofkP3om^h01P3om^h00`3D
?AT0ooK^0?ofkP020?ofkPP0e3dI0P0cB94010000000<dRA03=8T@3D?AT20000000303M>WP3D?AT0
e3dI00<0e3dI2@0gCYh00`3D?AT0=djN03M>WP0603M>WP030000000gCYh0=djN00L0=djN00<00000
0=@m6@3D?AT00P00000403YDZ@030000000jE:T0>UBY00H0>UBY00<000000=@m6@3D?AT0100jE:T0
0`3D?AT0000003YDZ@0703YDZ@030000000jE:T0>UBY00<0>UBY1000000403eI/`030=@m6@000000
e3dI00D0?EVc00<0000003eI/`0mFK<00`0mFK<00`000000?EVc03eI/`0303eI/`030000003oDB40
oe4Q0080oe4Q00<000000?mA8@3oDB40103oDB42000000<0oe0Q00@000000?m@8@3oD240?EV[0P3o
D2400`000000oe0Q0?m@8@030?m@8@030000003oCb00odlP00@0odlP00<000000?m?803oCb000P3o
Cb0303eIZ`030?m?800mFJ/0od`O00<0od`O00<000000?m<7`3oC1l0103oC1l2000000@0odPM00<0
00000?m87@3oB1d00`3oB1d01@000000l48J0?126P0mFJ/000000080l48J00D000000=0h5@000000
d3PE000000020=@m6@030?ofkP3D?AT0e3dI00@0ooK^00@0?EV[0?ofkP3om^h0ooK^0`0mFJ/20?of
kP0403eIZ`3om^h0ooK^0?ofkP@0?EV[103om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0
ooK^00<0ooK^00<0?EV[0000003om^h01P3om^h403eIZ`P0ooK^00<0?EV[0?ofkP3om^h06@3om^h0
0`000000ooK^0?ofkP0_0?ofkP40oooo00080?ofkP030000003om^h0ooK^03@0ooK^0P00000A0?of
kP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h01@3om^h303eIZ`L0ooK^00<0?EV[0?of
kP3om^h0403om^h00`0mFJ/0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^0080?EV[0P3D?AT503=8
T@T0e3dI100gCYh00`000000=djN03M>WP0703M>WP030000003D?AT0=djN00H0=djN00<0000003M>
WP0gCYh01P0gCYh30000000303YDZ@3D?AT0>UBY00@0>UBY00<0000003YDZ@0jE:T01@0jE:T20=@m
6@L0>UBY00<0e3dI0000000jE:T01P0jE:T010000000>UBY03YDZ@0jE:T20000000303eI/`000000
?EVc00<0?EVc0P3D?AT0100mFK<0000003eI/`3D?AT403eI/`030000000mFK<0?EVc00<0?EVc00<0
000003eI/`0mFK<00`0mFK<00`000000oe4Q0?mA8@020?mA8@030000003oDB40oe4Q00<0oe4Q00@0
00000?mA8@3oDB4000000P3oD2401P000000oe0Q0?m@8@3oD240?EV[000000D0oe0Q00<000000?m@
8@0000001@3oCb000`000000odlP03eIZ`0203eIZ`80odlP00@000000?m?803oCb00?EV[0P3oC1l0
0`000000od`O0?m<7`040?m<7`040000003oC1l0od`O000000<0odPM00<000000?m87@3oB1d00`3o
B1d2000000030?126P0mFJ/0000000<0l48J0P0000020=0h5@060000003om^h0e3dI0=@m6@3om^h0
e3dI0`3om^h403eIZ`D0ooK^100mFJ/80?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3o
m^h00P3om^h00`0mFJ/0ooK^000000030?ofkP<0?EV[303om^h00`0mFJ/0ooK^0?ofkP0I0?ofkP03
0000003om^h0ooK^02l0ooK^0@3oool000P0ooK^00<000000?ofkP3om^h0<@3om^h3000001<0ooK^
00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP020?ofkP<0?EV[2P3om^h00`0mFJ/0ooK^
0?ofkP0@0?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0=@m6@3D?AT00P3om^h00`000000<dRA
0=@m6@0303=8T@<000000P0gCYh010000000=djN03M>WP3D?AT603M>WP030000000gCYh0=djN00L0
=djN00<000000=@m6@0gCYh01P0gCYh00`000000=djN03M>WP0303M>WP8000000P0jE:T010000000
>UBY03YDZ@3D?AT503YDZ@030000000jE:T0>UBY0080>UBY0P3D?AT00`0jE:T0000003YDZ@0703YD
Z@030=@m6@0jE:T0>UBY00D0>UBY00@0000003YDZ@00000000000`0mFK<01@000000?EVc03eI/`0m
FK<0e3dI00<0?EVc00@0000003eI/`0mFK<0e3dI0P0mFK<00`000000?EVc03eI/`0403eI/`030000
000mFK<0?EVc00<0?EVc00<000000?mA8@3oDB400P3oDB400`000000oe4Q0?mA8@030?mA8@040000
003oDB40oe4Q0?mA8@800000103oD2400`0mFJ/000000?m@8@040?m@8@040000003oD240oe0Q0000
00<0odlP0`0mFJ/40?m?80050000003oCb00odlP0?m?800mFJ/00P3oC1l00`000000od`O0?m<7`04
0?m<7`040000003oC1l0od`O000000<0odPM00<000000?m87@3oB1d00P3oB1d00`000000odPM0000
00020?126P0303eIZ`3`@QX0l48J0080l48J00D000000=0h5@3@>1D000000?ofkP040=@m6@<0?EV[
00<0ooK^03eIZ`3om^h0103om^h403eIZ`X0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^
0?ofkP020?ofkP0403eIZ`3om^h0?EV[00000080?EV[3`3om^h00`0mFJ/0ooK^0?ofkP0I0?ofkP03
0000003om^h0ooK^02l0ooK^0@3oool000P0ooK^00<000000?ofkP3om^h0;P3om^h3000001H0ooK^
00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^03eIZ`0203eIZ`d0ooK^00<0?EV[0?ofkP3om^h0
403om^h00`0mFJ/0ooK^0?ofkP050?ofkP80?EV[0P3om^h20=@m6@040?ofkP000000<dRA03=8T@80
e3dI00<0000003M>WP0gCYh00`0gCYh01@000000=djN03M>WP0gCYh0e3dI00D0=djN00<0000003M>
WP0gCYh01`0gCYh00`000000=djN0=@m6@0603M>WP030000000gCYh0=djN00<00000100jE:T01@00
0000>UBY03YDZ@0jE:T0e3dI00@0>UBY00<0000003YDZ@0jE:T00P3D?AT303YDZ@030000000jE:T0
>UBY00H0>UBY00<000000=@m6@0jE:T0100jE:T3000000D0?EVc00@0000003eI/`0mFK<0e3dI100m
FK<01`000000?EVc03eI/`0mFK<0e3dI03eI/`0000001P0mFK<00`000000?EVc03eI/`0303eI/`03
0000003oDB40oe4Q0080oe4Q00<000000?mA8@3oDB400P3oDB400`000000oe4Q0?mA8@030?mA8@03
0000003oD240oe0Q00<0oe0Q00<0?EV[0?m@8@3oD2400P3oD24010000000oe0Q0?m@8@3oD24403eI
Z`030000003oCb00odlP00@0odlP00<000000?m?803oCb000P3oCb000`0mFJ/000000?m<7`050?m<
7`030000003oC1l0od`O0080od`O00<000000?m87@0000001@3oB1d01P000000odPM0?m87@000000
l48J03eIZ`@0l48J0P000000103@>1D000000=@m6@3om^h303eIZ`80e3dI0P3om^h00`0mFJ/0ooK^
03eIZ`0303eIZ`<0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP80?EV[
0P3om^h303eIZ`030?ofkP000000ooK^0100ooK^00<0?EV[0?ofkP3om^h06@3om^h00`000000ooK^
0?ofkP0_0?ofkP40oooo00080?ofkP030000003om^h0ooK^02`0ooK^0P00000H0?ofkP0303eIZ`3o
m^h0ooK^00d0ooK^0`0mFJ/@0?ofkP0303eIZ`3om^h0ooK^0100ooK^00<0?EV[0?ofkP3om^h00P3o
m^h303eIZ`D0ooK^0P3D?AT00`3om^h000000000000203M>WP030=@m6@0gCYh0=djN00@0=djN00@0
000003M>WP0gCYh0=djN0P3D?AT403M>WP030000000gCYh0=djN00L0=djN00<0000003M>WP3D?AT0
1@0gCYh3000000P0>UBY00D0000003YDZ@0jE:T0>UBY0=@m6@0303YDZ@030000003D?AT0e3dI00H0
>UBY00<0000003YDZ@0jE:T01P0jE:T00`000000e3dI0=@m6@030000000303eI/`000000?EVc00H0
?EVc00<000000=@m6@0mFK<0100mFK<00`000000?EVc03eI/`0203eI/`030=@m6@000000?EVc00D0
?EVc00<0000003eI/`0mFK<00P0mFK<00`000000oe4Q0?mA8@020?mA8@030000003oDB40oe4Q00<0
oe4Q00<000000?mA8@3oDB400`3oDB42000000<0oe0Q00<0000003eIZ`3oD2400`3oD24010000000
?EV[03eIZ`0mFJ/20?m@8@8000001P3oCb000`000000odlP0?m?80030?m?800303eIZ`000000od`O
00D0od`O00<000000?m<7`3oC1l00`3oC1l2000000D0odPM00@000000?m87@3oB1d0odPM0P000000
1P0mFJ/0l48J0?126P3`@QX000000?126P@0?EV[0P3D?AT0103om^h0e3dI0=@m6@3om^h303eIZ`P0
ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP<0?EV[00H0ooK^03eIZ`0m
FJ/0?EV[0?ofkP0mFJ/30?ofkP030000003om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h06@3om^h0
0`000000ooK^0?ofkP0_0?ofkP40oooo00070?ofkP030000003om^h0ooK^02X0ooK^0`00000J0?of
kP0303eIZ`3om^h0ooK^00X0ooK^0`0mFJ/00`3om^h0?EV[0?ofkP0@0?ofkP0303eIZ`3om^h0ooK^
0100ooK^00<0?EV[0?ofkP0mFJ/00P0mFJ/90?ofkP80e3dI00<0ooK^0000000gCYh00P0gCYh00`3D
?AT0=djN03M>WP0403M>WP030000000gCYh0=djN0080=djN00D0e3dI03M>WP0gCYh0=djN00000009
03M>WP030000000gCYh0=djN0080e3dI0`00000203YDZ@030000000jE:T0>UBY00H0>UBY00<00000
03YDZ@0jE:T00P0jE:T01@3D?AT0>UBY0=@m6@3D?AT0000000L0>UBY00<0000003YDZ@0jE:T01@0j
E:T30000000303eI/`3D?AT0?EVc0080?EVc00<0000003eI/`0mFK<0100mFK<20=@m6@H0?EVc00<0
000003eI/`0mFK<00`0mFK<00`3D?AT0?EVc03eI/`0303eI/`030000000mFK<0?EVc0080?EVc0P00
00040?mA8@030000003oDB40oe4Q0080oe4Q00<000000?mA8@3oDB400`3oDB4010000000oe4Q0?mA
8@0000020?m@8@040000003oD240?EV[0?m@8@<0?EV[1P3oD2400`000000odlP0?m?80040?m?8003
0000003oCb00odlP00<0odlP00<0000003eIZ`0000001@3oC1l00`000000od`O0?m<7`040?m<7`03
0000003oB1d0odPM0080odPM00<000000?m87@3oB1d00P3oB1d20000000303eIZ`3`@QX0l48J00<0
?EV[00<000000=0h5@0000000P3D?AT00`3om^h0e3dI03eIZ`0203eIZ`030?ofkP0mFJ/0ooK^00P0
ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP070?ofkP<0?EV[00H0ooK^03eIZ`0m
FJ/0?EV[0?ofkP0mFJ/20?ofkP0303eIZ`3om^h0ooK^0080ooK^00<000000?ofkP3om^h03@3om^h0
0`0mFJ/0ooK^0?ofkP0J0?ofkP030000003om^h0ooK^02h0ooK^0@3oool000L0ooK^00<000000?of
kP3om^h0:03om^h2000001d0ooK^00<0?EV[0?ofkP3om^h01`3om^h303eIZ`@0ooK^00<0?EV[0?of
kP3om^h0403om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP<0?EV[3P3om^h00`3D?AT0ooK^0000000303M>
WP030=@m6@0gCYh0=djN00<0=djN00<0000003M>WP0gCYh00`0gCYh01@3D?AT0=djN03M>WP0gCYh0
000000P0=djN100000000`0jE:T0e3dI03YDZ@0303YDZ@030000000jE:T0>UBY00L0>UBY00@00000
03YDZ@0jE:T0>UBY0P3D?AT203YDZ@030000000jE:T0>UBY00D0>UBY00<0000003YDZ@0jE:T00`0j
E:T20000000303eI/`000000?EVc0080?EVc00D0e3dI03eI/`0mFK<0?EVc0000000403eI/`030=@m
6@0mFK<0000000H0?EVc00<0000003eI/`0mFK<00`0mFK<00`3D?AT0?EVc03eI/`0303eI/`030000
000mFK<000000080000000<0@Ejl0000000000000`3oDB400`000000oe4Q0?mA8@020?mA8@030000
003oDB40oe4Q00<0oe4Q00D000000?mA8@3oDB40oe4Q000000020?m@8@<0?EV[00<0oe0Q0000003o
D2401@3oD2400`000000oe0Q000000040?m?80030000003oCb00odlP00@0odlP00@0000003eIZ`3o
Cb0000000`3oC1l00`000000od`O0?m<7`040?m<7`030000003oC1l0000000<0odPM00<000000?m8
7@3oB1d00`3oB1d01P000000?EV[03eIZ`0mFJ/0l48J00000080l48J0P000000103D?AT0?EV[03eI
Z`0mFJ/40=@m6@0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^
0?ofkP040?ofkP<0?EV[00@0ooK^03eIZ`0mFJ/0?EV[1@3om^h00`0mFJ/0ooK^03eIZ`040?ofkP03
0000003om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h06P3om^h00`000000ooK^0?ofkP0^0?ofkP40
oooo00070?ofkP030000003om^h0ooK^02D0ooK^0`00000O0?ofkP0303eIZ`3om^h0ooK^00D0ooK^
0P0mFJ/70?ofkP0303eIZ`3om^h0ooK^0100ooK^00<0?EV[0?ofkP3om^h0303om^h203eIZ`030?of
kP0mFJ/0ooK^00l0ooK^00<0e3dI0000000gCYh00`0gCYh00`3D?AT0=djN03M>WP0303M>WP030000
000gCYh0=djN00<0=djN00D0e3dI03M>WP0gCYh0=djN0000000503M>WP8000000P0jE:T01@000000
>UBY03YDZ@0jE:T0e3dI00@0>UBY00<0000003YDZ@0jE:T01P0jE:T010000000e3dI0=@m6@3D?AT2
03YDZ@040=@m6@0jE:T0>UBY000000L0>UBY00<0000003YDZ@0000000P00000303eI/`030000000m
FK<0?EVc0080?EVc00@0e3dI03eI/`0mFK<000000`0mFK<0103D?AT0?EVc03eI/`00000603eI/`03
0000000mFK<0?EVc00<0?EVc00<000000=@m6@0mFK<00P0mFK<3000000<0@Ejl00@000000?mA8P3o
DB8000000P3oDB401@000000oe4Q0?mA8@3oDB40000000D0oe4Q00<000000?mA8@3oDB400P3oDB43
03eIZ`80oe0Q00<0?EV[0000003oD2401P3oD24010000000oe0Q0?m@8@0000030?m?80030000003o
Cb00odlP00<0odlP00H000000?m?803oCb00?EV[0?m?800000020?m<7`030000003oC1l0od`O00@0
od`O00@000000?m<7`3oC1l000000P3oB1d010000000odPM0?m87@3oB1d303eIZ`050000003`@QX0
?EV[0?126P0000000`3`@QX203eIZ`80e3dI0P3om^h30=@m6@0303eIZ`3om^h0ooK^00T0ooK^00<0
?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP020?ofkP80?EV[00@0ooK^03eIZ`0mFJ/0?EV[
2@3om^h203eIZ`D0ooK^00<000000?ofkP3om^h02`3om^h203eIZa`0ooK^00<000000?ofkP3om^h0
;P3om^h10?ooo`001`3om^h00`000000ooK^0?ofkP0R0?ofkP<000008P3om^h00`0mFJ/0ooK^0?of
kP020?ofkP<0?EV[2P3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00T0ooK^0`0m
FJ/30?ofkP0303eIZ`3om^h0ooK^00l0ooK^0P3D?AT403M>WP030=@m6@0gCYh0=djN0080=djN00<0
000003M>WP0gCYh0100gCYh0103D?AT0=djN03M>WP00000203M>WP<00000100jE:T00`000000>UBY
03YDZ@0203YDZ@030=@m6@0jE:T0>UBY0080>UBY00<0000003YDZ@0jE:T00`0jE:T30=@m6@030000
000jE:T0>UBY00<0>UBY00<0e3dI03YDZ@0000001P0jE:T3000000L0?EVc00<0000003eI/`0mFK<0
0P0mFK<0103D?AT0?EVc0000000mFK<20=@m6@<0?EVc00<0000003eI/`0mFK<0100mFK<00`000000
?EVc03eI/`0303eI/`030000000mFK<0e3dI0080000000<0@Ejl00000011G[`00P11G[`00`3D?AT0
00000?mA8P020?mA8P800000103oDB400`000000oe4Q0?mA8@030?mA8@030000003oDB40?EV[0080
?EV[00<000000?mA8@0000000P3oD2400`0mFJ/000000?m@8@050?m@8@050000003oD240oe0Q0?m@
8@0000000P3oCb000`000000odlP0?m?80040?m?80040000003oCb00odlP03eIZ`80odlP0P000006
0?m<7`050000003oC1l0od`O0?m<7`0000000P3oB1d403eIZ`080?m87@000000odPM0?m87@000000
?EV[0=@m6@0000030?126P030000003om^h0ooK^00<0e3dI00D0ooK^0=@m6@3D?AT0?EV[0=@m6@0:
0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP0mFJ/01@0mFJ/<0?ofkP80?EV[1P3om^h0
0`000000ooK^0?ofkP060?ofkP@0?EV[00<0ooK^03eIZ`3om^h06`3om^h00`000000ooK^0?ofkP0^
0?ofkP40oooo00060?ofkP030000003om^h0ooK^0240ooK^0P00000U0?ofkP0303eIZ`3om^h0?EV[
0080?EV[3@3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00L0ooK^0P0mFJ/70?of
kP0303eIZ`3om^h0ooK^00l0ooK^103D?AT203M>WP80e3dI0`0gCYh00`000000=djN03M>WP0403M>
WP030=@m6@0gCYh0000000800000200jE:T00`000000>UBY03YDZ@0203YDZ@050=@m6@0jE:T0>UBY
03YDZ@0000000P0jE:T30=@m6@<0>UBY00<0000003YDZ@0jE:T0100jE:T0103D?AT0>UBY0000000j
E:T40000000303eI/`000000?EVc00L0?EVc00<0000003eI/`0mFK<00`0mFK<00`3D?AT000000=@m
6@0503eI/`030000000mFK<0?EVc00@0?EVc00<0000003eI/`0mFK<00P0mFK<300000005045N_03D
?AT0@Ejl045N_00000000P11G[`01@3D?AT0@Ejl0000003oDB80?EV[0080oe4R00D000000?mA8@3o
DB40oe4Q000000050?mA8@<0?EV[0`3oDB400`000000oe4Q000000020?m@8@030000000mFJ/0oe0Q
00@0oe0Q00<000000?m@8@3oD2400`3oD2400`000000odlP000000050?m?80030000003oCb00odlP
0080odlP00@0?EV[0?m?803oCb0000001P3oC1l010000000od`O0?m<7`3oC1l303eIZ`D0odPM00L0
00000?m87@3oB1d0odPM0000000mFJ/0000000<0l48J00@000000=@m6@3om^h0e3dI0P3om^h30=@m
6@0303eIZ`3D?AT0ooK^00X0ooK^00<0?EV[0?ofkP3om^h00`3om^h603eIZa00ooK^00<0?EV[0?of
kP3om^h01@3om^h00`000000ooK^0?ofkP020?ofkP<0?EV[1@3om^h00`0mFJ/0ooK^0?ofkP0J0?of
kP030000003om^h0ooK^02h0ooK^0@3oool000H0ooK^00<000000?ofkP3om^h07P3om^h3000002L0
ooK^0P0mFJ/@0?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h0103om^h303eIZ`T0
ooK^00<0?EV[0?ofkP3om^h0403om^h50=@m6@80=djN00D0e3dI03M>WP0gCYh0=djN0000000503M>
WP050000003D?AT0e3dI03YDZ@0000002@0jE:T00`000000>UBY03YDZ@0203YDZ@030=@m6@0jE:T0
>UBY00<0e3dI1`0jE:T00`000000>UBY03YDZ@0403YDZ@030=@m6@000000000000H0?EVc00<00000
03eI/`0mFK<01@0mFK<00`000000?EVc03eI/`0403eI/`030=@m6@000000?EVc00D0?EVc00<00000
03eI/`0mFK<00`0mFK<00`000000?EVc0000000200000003045N_0000000@Ejl0080@Ejl00D0e3dI
00000011G[`0@Ejl0=@m6@02045N_0030000003oDB80?EV[0080oe4R0P0000020?mA8@030000003o
DB40oe4Q00<0?EV[00<000000?mA8@3oDB400P3oDB4020000000oe4Q0?mA8@3oDB4000000?m@8@00
0000?EV[1@3oD2400`000000oe0Q0?m@8@040?m@8@030000003oCb00odlP00<0odlP00<000000?m?
803oCb000`3oCb001@0mFJ/0odlP0000003oCb00000000@0od`O00<000000?m<7`0mFJ/00P0mFJ/2
0?m<7`030000003oB1d0odPM00<0odPM00<000000?m87@3oB1d00P3oB1d00`0mFJ/000000?126P02
0?126P040000003om^h0e3dI0=@m6@<0ooK^0P3D?AT00`0mFJ/0e3dI0=@m6@0:0?ofkP0303eIZ`3o
m^h0ooK^00H0?EV[4`3om^h203eIZ`H0ooK^00<0000003eIZ`0mFJ/00P0mFJ/80?ofkP0303eIZ`3o
m^h0ooK^01/0ooK^00<000000?ofkP3om^h0;@3om^h10?ooo`001P3om^h00`000000ooK^0?ofkP0K
0?ofkP<00000:P3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00l0ooK^00@0?EV[
0?ofkP3om^h0ooK^0`0mFJ/<0?ofkP0303eIZ`3om^h0ooK^0140ooK^00@0?EV[0=@m6@3D?AT0=djN
103D?AT203M>WP030000000gCYh0=djN00<000000`0jE:T00`3D?AT0>UBY0000000903YDZ@030000
000jE:T0e3dI00@0e3dI00<0>UBY0000000jE:T01`0jE:T00`000000>UBY03YDZ@040000000303eI
/`3D?AT0000000H0?EVc00<0000003eI/`0mFK<01@0mFK<00`000000?EVc03eI/`0203eI/`80e3dI
00<0?EVc0=@m6@0mFK<01@0mFK<00`000000?EVc03eI/`0203eI/`<000001011G[`00`000000@Ejl
045N_002045N_0030=@m6@11G[`0e3dI0080@Ejl00H000000?mA8P3oDB80oe4R03eIZ`0000020?mA
8P8000000`0mFJ/20?mA8@030000003oDB40oe4Q00<0oe4Q00D000000?mA8@3oDB40oe4Q00000003
0?m@8@0503eIZ`3oD240oe0Q0?m@8@0000001P3oD2400`000000oe0Q000000040?m?80030000003o
Cb00odlP00@0odlP00H0?EV[0000003oCb00odlP0000003oC1l403eIZ`@0od`O00<000000?m<7`00
00000`3oB1d00`000000odPM0?m87@040?m87@0503eIZ`3`@QX0l48J0?126P0000000P3om^h20=@m
6@@0ooK^00@0e3dI03eIZ`3om^h0e3dI2@3om^h603eIZ`030?ofkP0mFJ/0ooK^01<0ooK^00<0?EV[
0?ofkP0mFJ/00`3om^h303eIZ`030000003om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h0703om^h0
0`000000ooK^0?ofkP0]0?ofkP40oooo00060?ofkP030000003om^h0ooK^01T0ooK^0P00000]0?of
kP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h03`3om^h0100mFJ/0ooK^03eIZ`0mFJ/?
0?ofkP0303eIZ`3om^h0ooK^0140ooK^0P0mFJ/00`3D?AT0=djN03M>WP0203M>WPP0e3dI1@0jE:T0
0`3D?AT0000003YDZ@0203YDZ@P0e3dI100jE:T0103D?AT0>UBY03YDZ@00000703YDZ@<000001P0m
FK<20=@m6@H0?EVc00<0000003eI/`0mFK<01@0mFK<010000000?EVc0=@m6@3D?AT303eI/`030000
003D?AT0?EVc00@0?EVc00<0000003eI/`0000000P0000000`11G[`00000045N_004045N_0030000
0011G[`0@Ejl0080@Ejl00<000000=@m6@11G[`00P11G[`01`000000oe4R0?mA8P3oDB80?EV[0000
003oDB800`0mFJ/50?mA8@030000003oDB40oe4Q0080oe4Q00<000000?mA8@3oDB400`3oDB401000
0000oe0Q0?m@8@0mFJ/30?m@8@030000003oD240oe0Q00@0oe0Q00@000000?m@8@3oD24000000P3o
Cb000`000000odlP0?m?80050?m?800303eIZ`3oCb00odlP00<0?EV[00<0od`O0000003oC1l01@3o
C1l010000000od`O0?m<7`0000020?m87@030000003oB1d0odPM00@0odPM00D0?EV[0000003`@QX0
l48J000000030?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI03eIZ`3D?AT00P3D?AT50?ofkPH0
?EV[103om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP0303eIZ`3om^h0?EV[00<0?EV[103om^h00`000000
ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^01`0ooK^00<000000?ofkP3om^h0;@3om^h10?ooo`00
1@3om^h00`000000ooK^0?ofkP0G0?ofkP<00000;`3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eI
Z`3om^h0ooK^00h0ooK^0`0mFJ/B0?ofkP0303eIZ`3om^h0ooK^0140ooK^00<0?EV[0000003D?AT0
100gCYh01@000000e3dI03YDZ@0jE:T000000080>UBY2P3D?AT703YDZ@030000000jE:T0>UBY00<0
>UBY00@0e3dI03YDZ@0jE:T00000100jE:T200000080?EVc00<0000003eI/`0mFK<01@0mFK<00`00
0000e3dI03eI/`0403eI/`030000000mFK<0?EVc00D0?EVc0P3D?AT503eI/`030000000mFK<0e3dI
00<0?EVc0`000004045N_00300000011G[`0@Ejl00<0@Ejl00@00000045N_011G[`0@Ejl0P3D?AT0
1@11G[`0e3dI0=@m6@11G[`0000000<0oe4R0`0mFJ/20?mA8P8000000`3oDB400`000000oe4Q0?mA
8@020?mA8@030000003oDB40oe4Q00<0oe4Q00<000000?mA8@0000000P3oD2400`0mFJ/0oe0Q0000
00060?m@8@030000003oD240oe0Q0080oe0Q00<000000?m?800000001P3oCb0010000000?EV[03eI
Z`0mFJ/20?m?80030000003oC1l0000000D0od`O00D000000?m<7`3oC1l0od`O000000020?m87@03
0000003oB1d0odPM00<0odPM00<000000?m87@0mFJ/00P3`@QX010000000ooK^0?ofkP3om^h20=@m
6@<0ooK^00<0e3dI03eIZ`3D?AT00`3D?AT703eIZ`<0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0C
0?ofkPD0?EV[1P3om^h00`000000ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^01`0ooK^00<00000
0?ofkP3om^h0;@3om^h10?ooo`001@3om^h00`000000ooK^0?ofkP0D0?ofkP<00000<`3om^h00`0m
FJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00/0ooK^0`0mFJ/00`3om^h0?EV[0?ofkP0B0?of
kP0303eIZ`3om^h0ooK^0140ooK^0P0mFJ/00`000000e3dI0=@m6@0200000080>UBY00@0e3dI03YD
Z@0jE:T00000200jE:T00`3D?AT0000003YDZ@0803YDZ@030000000jE:T0>UBY00<0>UBY00<0e3dI
03YDZ@0000000P0jE:T2000000@0?EVc00<0000003eI/`0mFK<01P0mFK<00`000000e3dI03eI/`03
03eI/`030000000mFK<0?EVc00<0?EVc0P3D?AT00`000000?EVc03eI/`0503eI/`030000000mFK<0
e3dI0080000000<0@Ejl00000011G[`01011G[`00`000000@Ejl045N_003045N_00500000011G[`0
@Ejl0=@m6@0000001011G[`00`3D?AT0?EV[03eIZ`0203eIZ`050000000mFJ/0oe4R0?mA8P000000
0P3oDB8010000000oe4Q0?mA8@0000040?mA8@030000003oDB40oe4Q00<0oe4Q00@000000?mA8@3o
DB4000000P3oD2400`0mFJ/0oe0Q0?m@8@040?m@8@030000003oD240oe0Q00@0oe0Q00<000000?m?
803oCb000`3oCb0303eIZ`80odlP00D0?EV[0?m?803oCb00odlP000000060?m<7`030000003oC1l0
od`O0080od`O0P0000060?m87@060000003oB1d0odPM03eIZ`3`@QX000000`3om^h20=@m6@@0ooK^
00<0?EV[0=@m6@0mFJ/01@0mFJ/70?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/0403om^h603eIZ`80
ooK^00<0?EV[0?ofkP3om^h0103om^h00`000000ooK^0?ofkP050?ofkP80?EV[7P3om^h00`000000
ooK^0?ofkP0]0?ofkP40oooo00050?ofkP030000003om^h0ooK^0180ooK^0P00000f0?ofkP0303eI
Z`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h0203om^h303eIZ`D0ooK^00<0?EV[0?ofkP3om^h0
403om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP@0?EV[0P0000000`3D?AT0>UBY03YDZ@0203YDZ@80e3dI
00<0>UBY0000000jE:T01`0jE:T00`3D?AT0000003YDZ@0803YDZ@030000000jE:T0>UBY00<0>UBY
00@0e3dI00000000000000001`0mFK<00`000000?EVc03eI/`0503eI/`030000000mFK<0e3dI00@0
?EVc00<0000003eI/`0mFK<00P3D?AT203eI/`030000000mFK<0?EVc00@0?EVc0`0000001@11G[`0
e3dI045N_011G[`0000000D0@Ejl00<00000045N_011G[`00`11G[`01@000000@Ejl0=@m6@11G[`0
000000@0@Ejl00<000000?mA8P3oDB800P3oDB801@000000oe4R03eIZ`3oDB80000000<0oe4R0P00
00040?mA8@030000003oDB40oe4Q00<0oe4Q00<000000?mA8@3oDB400P3oDB400`000000oe0Q03eI
Z`050?m@8@030000003oD240oe0Q00@0oe0Q00@000000?m@8@000000odlP0`0mFJ/00`3oCb000000
0?m?80020?m?800603eIZ`3oCb00odlP0000003oCb000000103oC1l00`000000od`O0?m<7`040?m<
7`030000003oB1d0odPM00@0odPM00@000000?m87@3oB1d0?EV[0P0000030?ofkP030=@m6@3om^h0
e3dI0080ooK^1P0mFJ/00`3D?AT0ooK^0?ofkP080?ofkP0403eIZ`3om^h0ooK^03eIZ`d0ooK^1`0m
FJ/50?ofkP0303eIZ`3om^h0ooK^00@0ooK^00@000000?ofkP3om^h0ooK^0`0mFJ/00`3om^h0?EV[
0?ofkP0N0?ofkP030000003om^h0ooK^02`0ooK^0@3oool000D0ooK^00<000000?ofkP3om^h03`3o
m^h3000003P0ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP050?ofkP80?EV[203o
m^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0303eIZ`3om^h0ooK^00h0ooK^0P0mFJ/0203om^h0?EV[0?of
kP0mFJ/0ooK^0000000jE:T0e3dI1@0jE:T00`3D?AT0>UBY0000000803YDZ@80e3dI200jE:T00`00
0000>UBY03YDZ@04000000030=@m6@0mFK<0000000P0?EVc00<0000003eI/`0mFK<01@0mFK<00`00
0000?EVc0=@m6@0303eI/`030000003D?AT0e3dI00D0?EVc00<0000003eI/`0000000`0000000`11
G[`00000045N_002045N_0030=@m6@11G[`0000000D0@Ejl00<00000045N_011G[`00P11G[`00`00
0000e3dI0=@m6@02045N_00300000011G[`0@Ejl0080@Ejl00D000000?mA8P3oDB80oe4R00000002
0?mA8P0303eIZ`000000oe4R00@0oe4R00<000000?mA8@3oDB400P3oDB400`000000oe4Q0?mA8@02
0?mA8@030000003oDB40oe4Q00@0oe4Q00<000000?m@8@0mFJ/0103oD2400`000000oe0Q0?m@8@04
0?m@8@040000000mFJ/0?EV[03eIZ`<0odlP00<000000?m?803oCb000`3oCb000`0mFJ/0odlP0000
00020?m?80050000003oC1l0od`O0?m<7`0000001P3oC1l2000000@0odPM00<000000?m87@3oB1d0
0P3oB1d00`0mFJ/000000?ofkP020?ofkP030=@m6@0mFJ/0?EV[00D0?EV[00<0ooK^0=@m6@3D?AT0
0P3D?AT:0?ofkP0303eIZ`3om^h0?EV[00X0ooK^1@0mFJ/40?ofkP0303eIZ`3om^h0ooK^00@0ooK^
0P0mFJ/50?ofkP030000000mFJ/0?EV[00<0ooK^00<0?EV[0?ofkP3om^h07P3om^h00`000000ooK^
0?ofkP0/0?ofkP40oooo00050?ofkP030000003om^h0ooK^00d0ooK^0P00000k0?ofkP0303eIZ`3o
m^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h00P3om^h303eIZ`X0ooK^00<0?EV[0?ofkP3om^h04@3o
m^h00`0mFJ/0ooK^0?ofkP0:0?ofkP<0?EV[103om^h203eIZ`80ooK^0P0000020=@m6@@0>UBY00<0
e3dI03YDZ@0000002@0jE:T00`3D?AT0>UBY03YDZ@0503YDZ@<000001@0mFK<20=@m6@030000000m
FK<0?EVc00H0?EVc00<0000003eI/`0mFK<0100mFK<01@000000?EVc03eI/`3D?AT0?EVc0080e3dI
00<0000003eI/`0mFK<0100mFK<2000000D0@Ejl00<00000045N_011G[`00P11G[`00`3D?AT00000
045N_004045N_00300000011G[`0@Ejl0080@Ejl00<0e3dI045N_011G[`00P11G[`00`000000@Ejl
045N_002045N_0050000003oDB80oe4R0?mA8P0000000`3oDB800`0mFJ/0oe4R0?mA8P020?mA8P03
0000003oDB8000000080oe4Q00<000000?mA8@3oDB400`3oDB400`000000oe4Q0?mA8@030?mA8@04
0000003oDB40000003eIZ`<0oe0Q00<000000?m@8@3oD2400`3oD24303eIZ`80oe0Q00@000000?m?
803oCb0000001`3oCb001@0mFJ/0odlP0?m?803oCb0000000080od`O00<000000?m<7`3oC1l0103o
C1l010000000od`O0?m<7`0000030?m87@030000003oB1d0odPM0080odPM00<0?EV[0000003om^h0
1`0mFJ/00`3om^h0?EV[0?ofkP020?ofkP@0e3dI2P3om^h203eIZ`L0ooK^1@0mFJ/70?ofkP0303eI
Z`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP0mFJ/00P0mFJ/00`000000ooK^0?ofkP030?ofkP0303eI
Z`3om^h0ooK^01h0ooK^00<000000?ofkP3om^h0;03om^h10?ooo`00103om^h00`000000ooK^0?of
kP0;0?ofkP<00000?@3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0?EV[0080?EV[3@3o
m^h00`0mFJ/0ooK^0?ofkP0A0?ofkP0303eIZ`3om^h0ooK^00P0ooK^0P0mFJ/70?ofkP0303eIZ`3o
m^h0?EV[00<0ooK^00<0000003YDZ@3D?AT0100jE:T00`3D?AT0>UBY0000000803YDZ@030000003D
?AT0>UBY00<0>UBY0P00000203eI/`030000000mFK<0?EVc00D0?EVc00<0e3dI0000000mFK<01P0m
FK<00`000000?EVc03eI/`0503eI/`040000000mFK<0e3dI0=@m6@80?EVc00<0000003eI/`0mFK<0
0P0mFK<3000000H0@Ejl00<00000045N_011G[`00`11G[`00`3D?AT0@Ejl045N_003045N_0030000
0011G[`0@Ejl0080e3dI00<00000045N_011G[`00P11G[`00`000000@Ejl045N_002045N_0050000
003oDB80oe4R0?mA8P0000000P3oDB800`000000?EV[0?mA8P030?mA8P060000003oDB80oe4R0000
003oDB400000103oDB400`000000oe4Q0?mA8@030?mA8@080000003oDB40oe4Q0?mA8@000000?EV[
0?m@8@0000030?m@8@<0?EV[00<000000?m@8@3oD2400`3oD2400`000000odlP000000060?m?8003
0000000mFJ/0odlP00<0odlP00<000000?m<7`0000001P3oC1l01@000000od`O0?m<7`3oC1l00000
0080odPM00<000000?m87@3oB1d00P3oB1d603eIZ`<0ooK^00@0e3dI0?ofkP0mFJ/0e3dI0`3om^h0
103D?AT0ooK^0=@m6@3D?AT90?ofkP80?EV[103om^h503eIZ`X0ooK^00<0?EV[0?ofkP3om^h0103o
m^h503eIZ`<0ooK^00D000000?ofkP3om^h0ooK^03eIZ`0Q0?ofkP030000003om^h0ooK^02`0ooK^
0@3oool000@0ooK^00<000000?ofkP3om^h0203om^h300000400ooK^00<0?EV[0?ofkP3om^h03P3o
m^h303eIZa40ooK^00<0?EV[0?ofkP3om^h0403om^h00`0mFJ/0ooK^0?ofkP050?ofkP<0?EV[2@3o
m^h00`0mFJ/0ooK^03eIZ`040?ofkP040000000jE:T0e3dI0=@m6@<0>UBY00<0e3dI03YDZ@000000
200jE:T00`000000e3dI03YDZ@02000000D0?EVc00<0000003eI/`0mFK<01@0mFK<00`3D?AT00000
03eI/`0603eI/`030000000mFK<0?EVc00<0?EVc0`3D?AT203eI/`050=@m6@0mFK<0?EVc0000000m
FK<00P000003045N_00300000011G[`0@Ejl00@0@Ejl00<00000045N_011G[`00P11G[`00`000000
e3dI045N_003045N_00300000011G[`0e3dI0080@Ejl00D00000045N_011G[`0@Ejl00000004045N
_0050000003oDB80oe4R0?mA8P0000000`3oDB800`000000oe4R03eIZ`020?mA8P030000003oDB80
oe4R0080oe4R00<000000?mA8@3oDB400`3oDB400`000000oe4Q0?mA8@030?mA8@030000003oDB40
oe4Q0080oe4Q00<0?EV[0?m@8@0000000`0mFJ/20?m@8@030000003oD240oe0Q00D0oe0Q00<00000
0?m?803oCb001@3oCb000`000000odlP03eIZ`040?m?80030000003oC1l0od`O00@0od`O00<00000
0?m<7`3oC1l00`3oC1l200000080odPM1P0mFJ/00`3om^h0e3dI0?ofkP040?ofkP030=@m6@0mFJ/0
e3dI00<0ooK^0P3D?AT00`3om^h0e3dI0?ofkP090?ofkP0303eIZ`3om^h0?EV[00<0?EV[3@3om^h0
0`0mFJ/0ooK^0?ofkP020?ofkPD0?EV[0`3om^h203eIZ`80ooK^00@000000?ofkP0mFJ/0?EV[8@3o
m^h00`000000ooK^0?ofkP0/0?ofkP40oooo00040?ofkP030000003om^h0ooK^00H0ooK^0P000013
0?ofkP0303eIZ`3om^h0ooK^00/0ooK^0`0mFJ/00`3om^h0?EV[0?ofkP0A0?ofkP0303eIZ`3om^h0
ooK^0100ooK^00<0?EV[0?ofkP3om^h00P3om^h303eIZ`d0ooK^0P0mFJ/50?ofkP030000000jE:T0
e3dI0080e3dI0P0jE:T00`3D?AT0>UBY0000000703YDZ@80000000<0e3dI03eI/`0mFK<01P0mFK<0
0`000000?EVc03eI/`0503eI/`030=@m6@0mFK<0?EVc00H0?EVc00<0000003eI/`3D?AT00P3D?AT2
03eI/`050000000mFK<0?EVc03eI/`3D?AT00`000005045N_00300000011G[`0@Ejl00@0@Ejl00<0
0000045N_011G[`00`11G[`00`000000e3dI045N_002045N_0030000003D?AT0@Ejl0080@Ejl00D0
0000045N_011G[`0@Ejl00000002045N_0<000000`3oDB8010000000oe4R0?mA8P0000020?mA8P04
03eIZ`3oDB80oe4R000000<0oe4R00<000000?mA8P0000000`3oDB400`000000oe4Q0?mA8@030?mA
8@030000003oDB40oe4Q00<0oe4Q0`0mFJ/50?m@8@030000003oD240oe0Q00@0oe0Q00<000000?m@
8@0000001@3oCb001@000000odlP0?m?803oCb00?EV[0080odlP00<000000?m?800000001@3oC1l0
0`000000od`O0?m<7`040?m<7`<0?EV[00@0odPM03eIZ`3oB1d0e3dI0P3om^h00`0mFJ/0e3dI0?of
kP050?ofkP0303eIZ`3D?AT0ooK^00<0ooK^00@0e3dI0?ofkP3om^h0e3dI203om^h403eIZa00ooK^
00<0?EV[0?ofkP0mFJ/0100mFJ/80?ofkP<0?EV[00<000000?ofkP3om^h08P3om^h00`000000ooK^
0?ofkP0[0?ofkP40oooo00040?ofkP030000003om^h0ooK^00<0ooK^0`0000150?ofkP0303eIZ`3o
m^h0ooK^00P0ooK^0`0mFJ/40?ofkP0303eIZ`3om^h0ooK^0100ooK^00<0?EV[0?ofkP3om^h04@3o
m^h0100mFJ/0ooK^03eIZ`0mFJ/@0?ofkP0303eIZ`3om^h0?EV[00D0ooK^00@0000003YDZ@3D?AT0
>UBY0P3D?AT0100jE:T0e3dI0=@m6@00000203YDZ@@000000P0mFK<00`000000e3dI03eI/`0703eI
/`030000000mFK<0?EVc00D0?EVc00<0e3dI03eI/`0mFK<0100mFK<30=@m6@D0?EVc100000001011
G[`0e3dI045N_0000006045N_00300000011G[`0@Ejl00<0@Ejl00<00000045N_011G[`00`11G[`0
10000000@Ejl0=@m6@11G[`20=@m6@@0@Ejl00@00000045N_011G[`0@Ejl0`00000204=Sa@800000
0P3oDB8010000000oe4R0?mA8P0000030?mA8P0303eIZ`000000oe4R00<0oe4R00<000000?mA8P00
00000P3oDB400`000000oe4Q0?mA8@030?mA8@040000003oDB40oe4Q0?mA8@<0?EV[00<000000?mA
8@0mFJ/0103oD2400`000000oe0Q0?m@8@040?m@8@040000003oD240oe0Q0?m@8@8000000P3oCb00
0`000000odlP0?m?80020?m?800403eIZ`3oCb00odlP00000080odlP00D000000?m<7`3oC1l0od`O
000000040?m<7`<0?EV[00<0od`O0000003oB1d00P3oB1d00`000000ooK^0=@m6@020?ofkP0303eI
Z`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3D?AT01@3om^h0103D?AT0ooK^0?ofkP3D?AT40?ofkPD0
?EV[00<0ooK^03eIZ`3om^h03P3om^h403eIZ`P0ooK^100mFJ/30?ofkP030000003om^h0ooK^0280
ooK^00<000000?ofkP3om^h0:`3om^h10?ooo`000`3om^h010000000ooK^0?ofkP3om^h3000004T0
ooK^00<0?EV[0?ofkP3om^h01@3om^h203eIZ`P0ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0
ooK^0?ofkP0@0?ofkP<0?EV[4`3om^h203eIZ`H0ooK^0P0000000`3D?AT0>UBY03YDZ@020=@m6@04
03YDZ@3D?AT00000000000L0?EVc00<000000=@m6@3D?AT01`0mFK<00`000000?EVc03eI/`0503eI
/`030=@m6@0mFK<0?EVc00<0e3dI0P0mFK<00`000000?EVc03eI/`0300000080@Ejl00H00000045N
_011G[`0@Ejl0=@m6@000006045N_00300000011G[`0@Ejl00<0@Ejl00<00000045N_011G[`00`11
G[`01P000000@Ejl045N_03D?AT0@Ejl000000@0@Ejl00@00000045N_000000000001013HlD00`00
0000oe0R0?m@8P0200000080oe4R00<000000?mA8P3oDB800P3oDB800`0mFJ/0oe4R0?mA8P020?mA
8P070000003oDB80oe4R0?mA8P000000oe4Q000000040?mA8@030000003oDB40?EV[0080?EV[0P3o
DB401@000000oe4Q0?mA8@0mFJ/000000080oe0Q00<000000?m@8@3oD2401@3oD2400`000000oe0Q
0?m@8@030?m@8@030000003oCb00000000D0odlP00<0?EV[0000003oCb000`3oCb0010000000od`O
0?m<7`00000403eIZ`80od`O00@000000?m<7`3oC1l000000P3oB1d01`000000ooK^0?ofkP3D?AT0
ooK^0=@m6@0mFJ/0103om^h0100mFJ/0ooK^0=@m6@3D?AT40?ofkP80e3dI00<0ooK^0=@m6@0mFJ/0
100mFJ/20?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/02P3om^h503eIZ`P0ooK^100mFJ/70?ofkP03
0000003om^h0ooK^0240ooK^00<000000?ofkP3om^h0:`3om^h10?ooo`000`3om^h010000000ooK^
00000000001<0?ofkP0303eIZ`3om^h0ooK^0080ooK^0`0mFJ/:0?ofkP0303eIZ`3om^h0ooK^0100
ooK^00<0?EV[0?ofkP3om^h0303om^h303eIZ`030?ofkP0mFJ/0ooK^01<0ooK^0P0mFJ/70?ofkP80
00000P3D?AT2000000<0e3dI00<0000003eI/`0mFK<01`0mFK<00`000000e3dI03eI/`0603eI/`03
0000000mFK<0?EVc0080?EVc1@3D?AT503eI/`<000001@11G[`00`000000@Ejl045N_002045N_003
0=@m6@000000@Ejl00@0@Ejl00<00000045N_011G[`00`11G[`00`000000@Ejl045N_003045N_006
0000003D?AT0e3dI045N_03D?AT000000P11G[`4000000H0@f?500D000000?m@8P3oD280oe0R0000
00020?mA8P030000003oDB80oe4R0080oe4R00D0000003eIZ`3oDB80oe4R000000050?mA8P030000
003oDB40oe4Q0080oe4Q0`0mFJ/50?mA8@080000003oDB40oe4Q0?mA8@0mFJ/000000?m@8@000006
0?m@8@030000003oD240oe0Q00D0oe0Q00<000000?m?803oCb00103oCb000`000000?EV[0?m?8004
0?m?80<0?EV[1@3oC1l01@000000od`O0?m<7`3oC1l000000080odPM00L000000?ofkP3om^h0e3dI
0?ofkP3D?AT0?EV[00@0ooK^00@0?EV[0?ofkP3om^h0e3dI1@3om^h503eIZ`D0ooK^00<0?EV[0?of
kP3om^h00P3om^h203eIZ`D0ooK^1@0mFJ/20?ofkP0303eIZ`3om^h0ooK^0080ooK^1@0mFJ/;0?of
kP030000003om^h0ooK^0200ooK^00<000000?ofkP3om^h0:`3om^h10?ooo`000`3om^h2000004h0
ooK^00<0?EV[0?ofkP0mFJ/00P0mFJ/=0?ofkP0303eIZ`3om^h0ooK^0100ooK^00<0?EV[0?ofkP3o
m^h02@3om^h303eIZ`D0ooK^00<0?EV[0?ofkP3om^h04@3om^h00`0mFJ/0ooK^03eIZ`070?ofkP<0
000000@0e3dI03eI/`0mFK<0?EVc203D?AT403eI/`030000003D?AT0?EVc00<0?EVc1`3D?AT403eI
/`030=@m6@0mFK<0?EVc00<000000P11G[`00`000000@Ejl045N_004045N_00300000011G[`0@Ejl
0080@Ejl0P3D?AT5045N_00300000011G[`0@Ejl0080@Ejl00<00000045N_011G[`00P11G[`20=@m
6@<0@Ejl00@000000=@m6@00000000000P13HlD010000000@f?504=Sa@00000304=Sa@060000003o
D280oe0R0?m@8P000000oe0R0P0000040?mA8P030000003oDB80?EV[0080oe4R00<000000?mA8P3o
DB800P3oDB800`000000oe4R03eIZ`0303eIZ`030000003oDB40oe4Q00@0oe4Q00<000000?mA8@3o
DB400`3oDB400`0mFJ/000000?m@8@050?m@8@030000003oD240oe0Q00D0oe0Q00<000000?m@8@00
00001@3oCb0010000000?EV[0?m?803oCb0303eIZ`030?m?80000000od`O00D0od`O00<000000?m<
7`3oC1l00P3oC1l2000000@0ooK^0P3D?AT00`3om^h0?EV[0?ofkP020?ofkP0303eIZ`3om^h0ooK^
0080e3dI00<0ooK^03eIZ`0mFJ/00`0mFJ/00`3om^h0e3dI0?ofkP050?ofkP0303eIZ`3om^h0ooK^
00@0ooK^1P0mFJ/50?ofkP0303eIZ`3om^h0?EV[00D0?EV[3P3om^h00`000000ooK^0?ofkP0P0?of
kP030000003om^h0ooK^02/0ooK^0@3oool000@0ooK^0P00001=0?ofkP80?EV[403om^h00`0mFJ/0
ooK^0?ofkP0@0?ofkP0303eIZ`3om^h0ooK^00H0ooK^0`0mFJ/80?ofkP0303eIZ`3om^h0ooK^0180
ooK^0P0mFJ/40?ofkP<0?EV[00D0ooK^00000000000000000=@m6@0403eI/`030=@m6@0mFK<00000
00<0?EVc2P3D?AT403eI/`030000000mFK<0?EVc00@0?EVc00<000000=@m6@0000001@11G[`00`00
0000@Ejl045N_005045N_00300000011G[`0@Ejl0080@Ejl00<000000=@m6@11G[`00`11G[`00`00
0000@Ejl045N_003045N_00700000011G[`0e3dI0=@m6@11G[`00000045N_0020000000304=Sa@00
0000e3dI00<0@f?500@0000004=Sa@13HlD000000`13HlD01@000000oe0R0?m@8P3oD28000000080
oe0R00<000000?mA8P3oDB800P3oDB801@000000oe4R0?mA8P0mFJ/0000000@0oe4R0`0mFJ/0103o
DB8000000?mA8@0000060?mA8@030000003oDB40oe4Q00@0oe4Q00<0000003eIZ`000000103oD240
0`000000oe0Q0?m@8@050?m@8@050000003oD240oe0Q0?m@8@0000000`3oCb000`000000odlP03eI
Z`0203eIZ`<0odlP00<000000?m?80000000103oC1l00`000000od`O0?m<7`040?m<7`030000003o
m^h0ooK^00<0ooK^00@0e3dI0?ofkP3om^h0?EV[0P3om^h00`0mFJ/0ooK^03eIZ`0403eIZ`80ooK^
00D0e3dI0?ofkP3D?AT0ooK^0=@m6@050?ofkP0303eIZ`3om^h0ooK^0080ooK^1@0mFJ/70?ofkPD0
?EV[4`3om^h00`000000ooK^0?ofkP0P0?ofkP030000003om^h0ooK^02X0ooK^0@3oool000H0ooK^
00<000000?ofkP3om^h0BP3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^0100ooK^
00<0?EV[0?ofkP3om^h00`3om^h303eIZ``0ooK^00<0?EV[0?ofkP3om^h04@3om^h0100mFJ/0ooK^
03eIZ`3om^h203eIZ`D0ooK^00@000000=@m6@000000e3dI100mFK<00`3D?AT0?EVc0000000803eI
/`030000003D?AT0?EVc00H0?EVc00<0000003eI/`0mFK<00`000002045N_0030=@m6@11G[`0@Ejl
00@0@Ejl00<00000045N_011G[`01011G[`00`000000@Ejl045N_002045N_00300000011G[`0e3dI
00@0@Ejl00<00000045N_011G[`00P11G[`010000000e3dI045N_011G[`3000000<0@f?500D00000
04=Sa@3D?AT0e3dI0000000304=Sa@0500000013HlD0@f?504=Sa@0000000P3oD2801P000000oe0R
0?m@8P000000oe0R00000080oe4R00L000000?mA8P3oDB80oe4R03eIZ`000000oe4R00<0?EV[00<0
00000?mA8P3oDB800P3oDB800`000000oe4Q0?mA8@040?mA8@030000003oDB40oe4Q00@0oe4Q00D0
00000?mA8@0mFJ/0oe4Q000000030?m@8@030000003oD240oe0Q00@0oe0Q00<000000?m@8@3oD240
0P3oD2400`000000odlP03eIZ`0303eIZ`80odlP00@0?EV[0?m?803oCb0000000`3oCb001@000000
od`O0?m<7`3oC1l0000000D0od`O00<000000?ofkP3om^h0103om^h20=@m6@80ooK^1P0mFJ/20?of
kP040=@m6@3om^h0ooK^0=@m6@80ooK^0P3D?AT40?ofkP0303eIZ`3om^h0?EV[00D0?EV[0`3om^h3
03eIZ`030?ofkP0mFJ/0?EV[00<0?EV[5`3om^h00`000000ooK^0?ofkP0O0?ofkP030000003om^h0
ooK^02X0ooK^0@3oool000L0ooK^0P00001:0?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?of
kP3om^h04@3om^h00`0mFJ/0ooK^03eIZ`0203eIZ`l0ooK^00<0?EV[0?ofkP3om^h04@3om^h0100m
FJ/0ooK^03eIZ`0mFJ/80?ofkP80?EV[00<0e3dI0000000mFK<00`0mFK<20=@m6@8000001`0mFK<0
0`000000e3dI03eI/`0503eI/`<000001P11G[`00`3D?AT0@Ejl045N_004045N_00300000011G[`0
@Ejl00@0@Ejl00<00000045N_011G[`00P11G[`00`000000@Ejl0=@m6@03045N_00400000011G[`0
@Ejl045N_080e3dI00D0@Ejl000000000000@f?50000000404=Sa@0500000013HlD0@f?504=Sa@3D
?AT00`13HlD010000000@f?504=Sa@0000030?m@8P040000003oD280oe0R00000080oe0R00<00000
0?mA8P0000000`3oDB8303eIZ`80oe4R00<000000?mA8P3oDB800P3oDB800`000000oe4R00000004
0?mA8@030000003oDB40oe4Q00@0oe4Q00T000000?mA8@3oDB40oe4Q03eIZ`3oDB4000000?m@8@00
00001P3oD2400`000000oe0Q0?m@8@020?m@8@<0?EV[00<0odlP0000003oCb00103oCb000`0mFJ/0
00000?m?80030?m?80040000003oC1l0od`O000000H0od`O00<000000?ofkP3om^h0103om^h00`3D
?AT0?EV[03eIZ`0403eIZ`80ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@020?ofkP030=@m6@3om^h0
ooK^0080e3dI0P3om^h603eIZ`L0ooK^1@0mFJ/K0?ofkP030000003om^h0ooK^01h0ooK^00<00000
0?ofkP3om^h0:P3om^h10?ooo`002@3om^h00`000000ooK^0?ofkP180?ofkP0303eIZ`3om^h0ooK^
00l0ooK^00<0?EV[0?ofkP3om^h03`3om^h303eIZa80ooK^00<0?EV[0?ofkP3om^h04P3om^h203eI
Z`H0ooK^0`0mFJ/20?ofkP030000003D?AT0000000D0?EVc00<0e3dI03eI/`000000200mFK<00`3D
?AT0?EVc03eI/`0300000080@Ejl00<00000045N_011G[`01@11G[`00`3D?AT0@Ejl045N_004045N
_00300000011G[`0@Ejl00<0@Ejl00<00000045N_011G[`00P11G[`010000000@Ejl045N_03D?AT3
045N_0030000003D?AT0e3dI00<000000`13HlD00`000000@f?504=Sa@0204=Sa@0800000013HlD0
@f?504=Sa@000000e3dI04=Sa@00000304=Sa@040000003oD280oe0R00000080oe0R00<000000?m@
8P3oD2800P3oD2800`000000?EV[03eIZ`0203eIZ`80oe4R00<0?EV[0?mA8P000000103oDB801@00
0000oe4R0?mA8P3oDB80000000<0oe4Q00<000000?mA8@3oDB400`3oDB400`000000oe4Q0?mA8@03
0?mA8@0303eIZ`3oDB40000000H0oe0Q00<000000?m@8@0mFJ/00`0mFJ/30?m@8@030000003oCb00
odlP00@0odlP00<0000003eIZ`3oCb00103oCb000`000000od`O000000050?m<7`030000003om^h0
ooK^0080ooK^1`0mFJ/00`3om^h0?EV[03eIZ`020?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT00P3o
m^h0103D?AT0ooK^0?ofkP3om^h603eIZ`L0ooK^1@0mFJ/N0?ofkP030000003om^h0ooK^01h0ooK^
00<000000?ofkP3om^h0:P3om^h10?ooo`002P3om^h2000004P0ooK^00<0?EV[0?ofkP3om^h03`3o
m^h00`0mFJ/0ooK^0?ofkP0=0?ofkP80?EV[00<0ooK^03eIZ`3om^h04`3om^h00`0mFJ/0ooK^0?of
kP0A0?ofkP80?EV[103om^h203eIZ`H0ooK^00<000000=@m6@0000001@0mFK<00`3D?AT0?EVc0000
000703eI/`030000003D?AT0000000H0@Ejl00<00000045N_011G[`01@11G[`20=@m6@@0@Ejl00<0
0000045N_011G[`01011G[`00`000000@Ejl045N_002045N_00500000011G[`0@Ejl0=@m6@11G[`0
0P3D?AT20000000304=Sa@000000@f?500@0@f?500D0000004=Sa@13HlD0@f?50000000304=Sa@04
00000013HlD0e3dI000000<0@f?500@000000?m@8P3oD28000000P3oD2800`000000oe0R0?m@8P03
03eIZ`80000000<0oe4R0000003oDB800P3oDB800`0mFJ/0oe4R0?mA8P030?mA8P030000003oDB80
oe4R0080oe4R00<000000?mA8@0000001@3oDB400`000000oe4Q0?mA8@050?mA8@0303eIZ`3oDB40
000000@0oe0Q0`0mFJ/60?m@8@030000003oD240000000@0odlP00@000000?m?803oCb00?EV[1@3o
Cb000`000000od`O0?m<7`040?m<7`030000000mFJ/0?EV[00D0?EV[103om^h01P3D?AT0?EV[0?of
kP0mFJ/0ooK^0=@m6@@0ooK^00<0e3dI0?ofkP0mFJ/01`0mFJ/50?ofkPH0?EV[8P3om^h00`000000
ooK^0?ofkP0M0?ofkP030000003om^h0ooK^02X0ooK^0@3oool000`0ooK^00<000000?ofkP3om^h0
A@3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00X0ooK^0`0mFJ/40?ofkP0303eI
Z`3om^h0ooK^0140ooK^00<0?EV[0?ofkP3om^h04P3om^h503eIZ`T0ooK^1000000403eI/`040=@m
6@0mFK<0000000000080?EVc0`000002045N_0030=@m6@11G[`0@Ejl00D0@Ejl00<00000045N_011
G[`01011G[`00`000000@Ejl0=@m6@04045N_00300000011G[`0@Ejl00@0@Ejl00D00000045N_011
G[`0@Ejl00000002045N_080e3dI00<0@f?500000013HlD00`13HlD00`000000@f?504=Sa@0204=S
a@0500000013HlD0@f?504=Sa@0000000`13HlD010000000@f?504=Sa@3D?AT204=Sa@040000003o
D280oe0R00000080oe0R100mFJ/00`3oD28000000?m@8P020?m@8P060000003oDB80oe4R0?mA8P00
0000?EV[103oDB800`000000oe4R0?mA8P040?mA8P030000003oDB40oe4Q00<0oe4Q00<000000?mA
8@3oDB40103oDB420000000303eIZ`3oDB40000000@0?EV[203oD24010000000oe0Q0?m@8@000003
0?m?80030000003oCb00odlP0080odlP00L0?EV[0?m?803oCb00odlP0000003oCb00000000@0od`O
1@0mFJ/30?ofkP030=@m6@3om^h0ooK^0080ooK^00@0e3dI03eIZ`3om^h0ooK^0P0mFJ/30?ofkPH0
?EV[0P3om^h00`3D?AT0?EV[0?ofkP020?ofkPH0?EV[9P3om^h00`000000ooK^0?ofkP0L0?ofkP03
0000003om^h0ooK^02X0ooK^0@3oool000d0ooK^00<000000?ofkP3om^h0A03om^h00`0mFJ/0ooK^
0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00P0ooK^0P0mFJ/70?ofkP0303eIZ`3om^h0ooK^0180ooK^
00<0?EV[0?ofkP3om^h0403om^h303eIZ`h0ooK^00<000000=@m6@000000100mFK<00`3D?AT0?EVc
00000002000000H0@Ejl0P3D?AT6045N_00300000011G[`0@Ejl00@0@Ejl00<00000045N_03D?AT0
1011G[`00`000000@Ejl045N_003045N_00400000011G[`0@Ejl045N_0<0e3dI0P13HlD00`3D?AT0
@f?50000000304=Sa@0300000013HlD0@f?50080@f?500D0000004=Sa@13HlD0@f?50000000304=S
a@0700000013HlD0@f?50000003D?AT0@f?5000000020?m@8P040000000mFJ/0?EV[000000<0oe0R
00L000000?m@8P3oD280oe0R0000003oD28000000080oe4R00<000000?mA8P0mFJ/00P3oDB800`00
0000oe4R0?mA8P040?mA8P030000003oDB80000000<0oe4Q00<000000?mA8@3oDB40103oDB400`00
0000oe4Q0?mA8@0303eIZ`030000003oD240000000P0oe0Q00<000000?m@8@3oD2400P3oD2400`00
0000odlP000000060?m?800303eIZ`3oCb00000000<0odlP00<000000?m<7`0mFJ/00`0mFJ/60?of
kP030=@m6@3om^h0ooK^00<0ooK^00D0?EV[0?ofkP3om^h0ooK^0=@m6@0603eIZ`80e3dI103om^h7
03eIZbT0ooK^00<000000?ofkP3om^h07@3om^h00`000000ooK^0?ofkP0Y0?ofkP40oooo000>0?of
kP800000A03om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00D0ooK^0`0mFJ/90?of
kP0303eIZ`3om^h0ooK^0180ooK^00<0?EV[0?ofkP3om^h03@3om^h303eIZ`030?ofkP0mFJ/0?EV[
00l0ooK^00@000000=@m6@00000000000P0mFK<010000000e3dI0=@m6@11G[`2000000L0@Ejl00<0
e3dI045N_011G[`01011G[`2000000D0@Ejl00<00000045N_03D?AT01011G[`00`000000@Ejl045N
_002045N_0040000003D?AT0e3dI0=@m6@80@f?500H0000004=Sa@13HlD0@f?50=@m6@00000404=S
a@0500000013HlD0@f?504=Sa@0000000`13HlD010000000@f?504=Sa@00000204=Sa@0500000013
HlD0e3dI0000003oD2800`0mFJ/00`3oD28000000?m@8P020?m@8P050000003oD280oe0R0?m@8P00
00000P3oD2800`000000oe4R000000030?mA8P0303eIZ`000000oe4R00@0oe4R0P0000030?mA8P03
0000003oDB40000000H0oe4Q00@0000003eIZ`0mFJ/0?EV[0P3oDB400`0mFJ/0oe4Q000000070?m@
8@8000001P3oD2400`000000odlP0?m?80060?m?800303eIZ`3oCb00odlP00@0?EV[00<0od`O0000
003D?AT01P3om^h00`3D?AT0ooK^0?ofkP030?ofkP0303eIZ`3om^h0?EV[00H0?EV[103om^h00`3D
?AT0ooK^0?ofkP0503eIZbh0ooK^00<000000?ofkP3om^h0703om^h00`000000ooK^0?ofkP0Y0?of
kP40oooo000@0?ofkP030000003om^h0ooK^0440ooK^00<0?EV[0?ofkP3om^h0403om^h0100mFJ/0
ooK^0?ofkP3om^h303eIZ`d0ooK^00<0?EV[0?ofkP3om^h04@3om^h00`0mFJ/0ooK^0?ofkP0:0?of
kP<0?EV[1@3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP80000000<0L2<@0000000000000`11G[`00`3D
?AT0@Ejl045N_002000000H0@Ejl00<0e3dI045N_011G[`01@11G[`00`000000@Ejl045N_003045N
_00300000011G[`0e3dI00<0@Ejl00<00000045N_011G[`00`3D?AT00`13HlD0000004=Sa@0204=S
a@0300000013HlD0@f?50080@f?500<0e3dI00000013HlD00P13HlD01@000000@f?504=Sa@13HlD0
000000<0@f?500@0000004=Sa@13HlD000000P13HlD01`000000@f?5000000000000?EV[0?m@8P00
00000P3oD2801@000000oe0R0?m@8P3oD280000000<0oe0R00D000000?m@8P3oD280oe0R00000004
0?mA8P030000000mFJ/0oe4R00<0oe4R00<000000?mA8P3oDB80103oDB800`000000oe4Q0?mA8@03
0?mA8@<0?EV[1@3oDB4010000000?EV[0?mA8@0000050?m@8@030000003oD240oe0Q00D0oe0Q00<0
00000?m@8@0000001P3oCb0010000000?EV[03eIZ`0mFJ/30?m?80050000003oC1l000000?ofkP3D
?AT01@3om^h00`3D?AT0ooK^0?ofkP020?ofkPL0?EV[0`3om^h903eIZ`030?ofkP3D?AT0ooK^02l0
ooK^00<000000?ofkP3om^h06`3om^h00`000000ooK^0?ofkP0Y0?ofkP40oooo000A0?ofkP800000
@P3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0403eIZ`3om^h0?EV[03eIZa00ooK^00<0?EV[0?ofkP3o
m^h04P3om^h00`0mFJ/0ooK^0?ofkP060?ofkP<0?EV[203om^h203eIZ`l0ooK^00<0?EV[0000001`
8a000`0000001011G[`0e3dI0=@m6@3D?AT3045N_08000001@11G[`00`3D?AT00000045N_005045N
_00300000011G[`0@Ejl00<0@Ejl00D00000045N_03D?AT0@Ejl000000030=@m6@D0@f?500D00000
04=Sa@13HlD0@f?50000000404=Sa@050=@m6@13HlD0@f?504=Sa@0000000`13HlD01@000000@f?5
04=Sa@13HlD000000080@f?500<0000004=Sa@0000000P000000100mFJ/000000000000000020?m@
8P050000003oD280oe0R0?m@8P0000000`3oD2801`000000oe0R0?m@8P3oD28000000?m@8P000000
0`3oDB800`000000oe4R03eIZ`020?mA8P030000003oDB80oe4R00@0oe4R00@000000?mA8P000000
oe4Q0`0mFJ/00`000000oe4Q0?mA8@040?mA8@030000003oDB40?EV[0080oe4Q00D000000?m@8@3o
D240oe0Q000000070?m@8@050000003oD240oe0Q0?m@8@0000000`3oCb0303eIZ`80odlP0P0mFJ/3
0?m?80050000003om^h0ooK^0?ofkP3D?AT0103om^h00`3D?AT0ooK^03eIZ`0503eIZ`80ooK^0P3D
?AT30?ofkPH0?EV[00D0e3dI0?ofkP3om^h0ooK^0=@m6@0a0?ofkP030000003om^h0ooK^01X0ooK^
00<000000?ofkP3om^h0:@3om^h10?ooo`004`3om^h00`000000ooK^0?ofkP0o0?ofkP0303eIZ`3o
m^h0ooK^00h0ooK^0`0mFJ/B0?ofkP0303eIZ`3om^h0ooK^0180ooK^00<0?EV[0?ofkP3om^h00`3o
m^h303eIZ``0ooK^00<0?EV[0?ofkP3om^h0303om^h303eIZ`H0000000<0@Ejl0=@m6@3D?AT00`3D
?AT00`11G[`00000045N_004045N_0030=@m6@000000@Ejl00D0@Ejl00<00000045N_011G[`00P11
G[`50=@m6@80@f?500<0000004=Sa@13HlD00`13HlD00`000000@f?504=Sa@0204=Sa@0600000013
HlD0@f?504=Sa@000000e3dI0`13HlD01@000000@f?504=Sa@13HlD000000080@f?500<0000004=S
a@0000000P00000304IXcP040000003oCb40odlQ00000080oe0R00D000000?m@8P3oD280oe0R0000
00020?m@8P050000003oD280oe0R0?m@8P0000000`3oD2800`000000oe4R000000030?mA8P0303eI
Z`000000oe4R00@0oe4R0P0000001P3oDB80?EV[03eIZ`0mFJ/0oe4Q000000L0oe4Q00D000000?mA
8@3oDB40oe4Q03eIZ`020?mA8@030000003oD240000000L0oe0Q00<000000?m@8@3oD2400P3oD240
1@000000?EV[03eIZ`0mFJ/0000000H0odlP00<0?EV[0?m?80000000103om^h00`3D?AT0ooK^0?of
kP0703eIZ`H0ooK^1`0mFJ/0103om^h0e3dI0?ofkP3D?AT30?ofkP030=@m6@3om^h0ooK^02l0ooK^
00<000000?ofkP3om^h06P3om^h00`000000ooK^0?ofkP0Y0?ofkP40oooo000D0?ofkP800000?`3o
m^h00`0mFJ/0ooK^0?ofkP0;0?ofkP<0?EV[00<0ooK^03eIZ`3om^h04P3om^h00`0mFJ/0ooK^0?of
kP0C0?ofkP0303eIZ`3om^h0?EV[0080?EV[3`3om^h00`0mFJ/0ooK^0?ofkP090?ofkP<0?EV[00@0
ooK^03eIZ`3om^h0ooK^0P0000000`1`8a00?EV[09@_5@0200000004045N_03D?AT0@Ejl045N_0H0
e3dI0P11G[`00`3D?AT00000045N_002045N_0L0e3dI00D0000004=Sa@000000@f?50=@m6@0304=S
a@0300000013HlD0@f?500<0@f?500D0000004=Sa@13HlD0@f?50000000404=Sa@050000003D?AT0
@f?504=Sa@0000000`13HlD00`000000@f?500000002000000<0AVS>00@0000004IXcP16J<h00000
0P3oCb43000000<0oe0R00@000000?m@8P3oD28000000`3oD2800`000000oe0R0?m@8P030?m@8P06
0000003oDB80oe4R0?mA8P000000?EV[1@3oDB8010000000?EV[03eIZ`0mFJ/30?mA8P030000003o
DB40oe4Q00@0oe4Q0P0000050?mA8@0403eIZ`3oDB40oe4Q000000H0oe0Q0P0000030?m@8@<0?EV[
00<000000?m?80000000203oCb000`0mFJ/0ooK^0?ofkP030?ofkPH0?EV[0`3om^h0100mFJ/0ooK^
0?ofkP3om^h603eIZ`D0ooK^00@0e3dI0?ofkP3om^h0e3dI0P3om^h00`3D?AT0ooK^0?ofkP0`0?of
kP030000003om^h0ooK^01X0ooK^00<000000?ofkP3om^h0:03om^h10?ooo`005P3om^h00`000000
ooK^0?ofkP0l0?ofkP0303eIZ`3om^h0ooK^00P0ooK^0`0mFJ/50?ofkP0303eIZ`3om^h0ooK^0140
ooK^00<0?EV[0?ofkP3om^h04@3om^h303eIZa80ooK^0P0mFJ/70?ofkP<0?EV[103om^h0100mFJ/0
ooK^0?ofkP3om^h20000000703eIZ`000000000009@_5@000000@Ejl0=@m6@05045N_08000001`3D
?AT2045N_0@000001@13HlD00`000000e3dI04=Sa@0204=Sa@0300000013HlD0@f?500<0@f?500D0
000004=Sa@13HlD0@f?50000000304=Sa@0300000013HlD0e3dI0080@f?500<0000004=Sa@000000
0P0000001016J<h0000004IXcP16J<h30=@m6@80AVS>00<000000?m?8@0000000P3oCb4010000000
oe0R0?m@8P0000020?m@8P050000003oD280oe0R0?m@8P0000001@3oD2801@000000oe0R0000003o
DB8000000080oe4R00<0?EV[0?mA8P3oDB800`0mFJ/40?mA8P80000000<0oe4R0000003oDB400`3o
DB400`000000oe4Q0?mA8@060?mA8@0403eIZ`000000oe4Q000000@0oe0Q00<000000?m@8@0mFJ/0
0`0mFJ/40?m@8@030000003oCb00odlP00@0odlP00@0?EV[0?m?80000000ooK^200mFJ/00`3om^h0
e3dI0?ofkP020?ofkPP0?EV[00<0e3dI0?ofkP3D?AT01@3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI
0080ooK^00<0e3dI0?ofkP3om^h0<03om^h00`000000ooK^0?ofkP0I0?ofkP030000003om^h0ooK^
02P0ooK^0@3oool001L0ooK^0P00000l0?ofkP0303eIZ`3om^h0ooK^00H0ooK^0P0mFJ/80?ofkP03
03eIZ`3om^h0ooK^0140ooK^00<0?EV[0?ofkP3om^h03P3om^h303eIZ`030?ofkP0mFJ/0ooK^01<0
ooK^00<0?EV[0?ofkP3om^h00P3om^h303eIZ`L0ooK^00<0?EV[0?ofkP3om^h00P3om^h200000003
03eIZ`000000000000<000001`11G[`200000080@Ejl00<0e3dI0000000000000P00000304=Sa@80
00001@13HlD00`000000e3dI04=Sa@0204=Sa@8000001013HlD01@000000@f?504=Sa@13HlD00000
00<0@f?500<0000004=Sa@3D?AT00`0000001@16J<h0000004IXcP16J<h000000080e3dI0P16J<h0
0`000000AVS>000000020?m?8@070000000mFJ/000000?m?8@000000e3dI000000020?m@8P040000
003oD280oe0R000000@0oe0R0P0000030?m@8P040000003oDB80oe4R0?mA8P<0?EV[00<000000?mA
8P3oDB800`3oDB800`000000oe4R0?mA8P020?mA8P040000003oDB400000000000P0oe4Q00D00000
03eIZ`3oDB40oe4Q000000030?m@8@<0?EV[1P3oD242000000030?m@8@000000odlP00@0odlP00<0
?EV[0000000mFJ/01@0mFJ/40?ofkP80e3dI00<0ooK^03eIZ`0mFJ/0100mFJ/30?ofkP040=@m6@3o
m^h0ooK^0=@m6@D0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0=@m6@0c0?ofkP030000
003om^h0ooK^01P0ooK^00<000000?ofkP3om^h0:03om^h10?ooo`006@3om^h00`000000ooK^0?of
kP0j0?ofkP0303eIZ`3om^h0ooK^0080ooK^0`0mFJ/;0?ofkP0303eIZ`3om^h0ooK^0100ooK^00<0
?EV[0?ofkP3om^h0303om^h203eIZ`D0ooK^00<0?EV[0?ofkP3om^h04@3om^h503eIZ`/0ooK^00<0
?EV[0?ofkP3om^h00`3om^h00`0mFJ/000000000000203eIZ`<000001P11G[`4000000040=@m6@13
HlD00000000000D0@f?50P00000404=Sa@030000003D?AT0@f?500<0@f?500D0000004=Sa@13HlD0
@f?50000000304=Sa@0300000013HlD0@f?500@0000000H0e3dI00000016J<h0AVS>00000016J<h2
0=@m6@@0AVS>00D0000004IXcP000000odlQ000000020?m?8@0403eIZ`3oCb40odlQ00000080oe0R
00@000000?m@8P3oD2800000103oD2800`000000oe0R0?m@8P020?m@8P030000003oD280?EV[0080
?EV[00<0oe4R0000000mFJ/0103oDB82000000H0oe4R00<000000?mA8@3oDB401P3oDB4200000080
oe4Q00<0?EV[0?mA8@3oDB400`0mFJ/80?m@8@030000003oD240oe0Q0080oe0Q00@000000?m?803o
Cb00odlP1P0mFJ/30?ofkP<0?EV[00<0ooK^03eIZ`0mFJ/0100mFJ/60?ofkP050=@m6@3om^h0ooK^
0?ofkP3D?AT0103om^h00`3D?AT0ooK^0?ofkP030?ofkP80e3dI<`3om^h00`000000ooK^0?ofkP0H
0?ofkP030000003om^h0ooK^02P0ooK^0@3oool001X0ooK^0P00000j0?ofkP0303eIZ`3om^h0?EV[
0080?EV[3P3om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP0303eIZ`3om^h0ooK^00P0ooK^0`0mFJ/70?of
kP0303eIZ`3om^h0ooK^0140ooK^0P0mFJ/>0?ofkP0303eIZ`3om^h0ooK^00<0ooK^0`0mFJ/20000
000309@_5@0000000000008000000P11G[`2000000<0@f?500<0000004=Sa@3D?AT00P13HlD20000
00D0@f?500<0000004=Sa@13HlD00`13HlD20=@m6@<0@f?500D0000004=Sa@13HlD0@f?500000002
04=Sa@<000001@16J<h00`3D?AT0AVS>04IXcP020=@m6@0304IXcP000000AVS>0080AVS>00`00000
04IXcP16J<h000000?m?8@000000odlQ0000003oCb40?EV[0000003oCb4200000080oe0R00<00000
0?m@8P3oD2800P3oD28010000000oe0R0?m@8P3oD28403eIZ`040?m@8P000000oe4R00000080oe4R
00@0?EV[0?mA8P00000000001P3oDB82000000030?mA8P000000oe4Q00@0oe4Q0P0000040?mA8@<0
?EV[00<0oe4Q0000003oD2401P3oD242000000H0oe0Q00<0000003eIZ`0mFJ/00`0mFJ/60?ofkPH0
?EV[00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP020?ofkP050=@m6@3om^h0ooK^0?of
kP3D?AT01@3om^h20=@m6C@0ooK^00<000000?ofkP3om^h05`3om^h00`000000ooK^0?ofkP0X0?of
kP40oooo000L0?ofkP030000003om^h0ooK^03L0ooK^0P0mFJ/A0?ofkP0303eIZ`3om^h0ooK^0140
ooK^00<0?EV[0?ofkP3om^h01@3om^h303eIZ`/0ooK^00<0?EV[0?ofkP3om^h0403om^h00`0mFJ/0
ooK^03eIZ`0=0?ofkP0303eIZ`3om^h0ooK^00<0?EV[0P3om^h00`0mFJ/0e3dI0000000200000003
09@_5@0000000000008000001`13HlD00`000000e3dI0=@m6@0204=Sa@8000001013HlD2000000@0
@f?500<000000=@m6@13HlD00P13HlD00`000000@f?504=Sa@03000000D0AVS>00@0000004IXcP16
J<h0AVS>0P3D?AT030000000AVS>04IXcP000000AVS>00000016J<h0000004IXcP000000odlQ0000
0080odlQ00D000000?m?8@000000?EV[0?m?8@02000000030?m@8P000000oe0R00<0oe0R00<00000
0?m@8P0mFJ/00P0mFJ/60?m@8P030000003oDB80oe4R0080oe4R00<0?EV[0?mA8P3oDB801@3oDB80
1@000000oe4R0?mA8P3oDB80000000@0oe4Q00<000000?mA8@3oDB40100mFJ/20?mA8@80?EV[00<0
oe4Q0000003oD240103oD2400`000000oe0Q0?m@8@060?m@8@<0?EV[1P3om^h603eIZ`050?ofkP3D
?AT0ooK^0?ofkP3D?AT0203om^h00`3D?AT0ooK^0?ofkP030?ofkP040=@m6@3om^h0ooK^0=@m6@H0
ooK^0P3D?ATd0?ofkP030000003om^h0ooK^01L0ooK^00<000000?ofkP3om^h09`3om^h10?ooo`00
7@3om^h2000003L0ooK^00<0?EV[0?ofkP3om^h04@3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0303eI
Z`3om^h0ooK^00<0ooK^0P0mFJ/>0?ofkP0303eIZ`3om^h0ooK^0100ooK^00<0?EV[0?ofkP0mFJ/0
3@3om^h303eIZ`D0ooK^00<0?EV[0000003D?AT0100000000`2D;aD0000000000002000000L0@f?5
00<000000=@m6@13HlD00P13HlD2000000@0@f?50P00000304=Sa@040000003D?AT0@f?504=Sa@<0
00000P16J<h00`000000AVS>04IXcP0404IXcP<0e3dI00<0000004IXcP3D?AT00P16J<h040000000
AVS>00000016J<h0000004IXcP000000odlQ0000003oCb4000000?m?8@000000odlQ03eIZ`000002
0?m?8@050000003D?AT0oe0R0?m@8P0000000`0mFJ/00`3oD28000000?m@8P040?m@8P80000000<0
oe0R0000003oDB800P0000000`0mFJ/0oe4R0?mA8P030?mA8P8000001@3oDB8010000000oe4Q0000
0000000303eIZ`@0oe4Q0P0000020?mA8@0503eIZ`3oDB4000000000003oD2400P0000030?m@8@03
03eIZ`3oD240oe0Q00<0?EV[00<000000?ofkP0mFJ/00`3om^h503eIZ`D0ooK^00D0e3dI0?ofkP3o
m^h0ooK^0=@m6@060?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3D?AT01`3om^h00`3D
?AT0ooK^0?ofkP0b0?ofkP030000003om^h0ooK^01L0ooK^00<000000?ofkP3om^h09`3om^h10?oo
o`007`3om^h00`000000ooK^0?ofkP0e0?ofkP0303eIZ`3om^h0ooK^0100ooK^00<0?EV[0?ofkP3o
m^h04@3om^h00`0mFJ/0ooK^03eIZ`0203eIZa40ooK^00<0?EV[0?ofkP3om^h03`3om^h0100mFJ/0
ooK^0?ofkP0mFJ/80?ofkPD0?EV[203om^h0100mFJ/000000=@m6@3D?AT40000000309@_5@000000
000000@000001@13HlD00`3D?AT0000004=Sa@0204=Sa@8000001013HlD200000080@f?500<00000
0=@m6@0000000P16J<h01@000000AVS>04IXcP16J<h000000080AVS>0`3D?AT03P000000AVS>04IX
cP000000AVS>0=@m6@000000AVS>00000016J<h0000004IXcP000000AVS>0P000000103oCb400000
0?m?8@0000020?m?8@050000000mFJ/0odlQ0000003oCb40100mFJ/30?m@8P030000003oD280oe0R
0080oe0R0P0000040?m@8P050000003oDB80oe4R0?mA8P0mFJ/00P3oDB82000000L0oe4R100mFJ/5
0?mA8@8000001@3oDB4203eIZ`030?mA8@000000oe0Q00@0oe0Q0`0mFJ/200000080ooK^1`0mFJ/7
0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP05
0?ofkP030=@m6@3om^h0e3dI00L0ooK^00<0e3dI0?ofkP3om^h0<`3om^h00`000000ooK^0?ofkP0F
0?ofkP030000003om^h0ooK^02L0ooK^0@3oool00200ooK^00<000000?ofkP3om^h0=03om^h00`0m
FJ/0ooK^0?ofkP0A0?ofkP0303eIZ`3om^h0ooK^00l0ooK^0`0mFJ/D0?ofkP0303eIZ`3om^h0ooK^
0100ooK^00<0?EV[0?ofkP0mFJ/01@3om^h303eIZ`@0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0m
FJ/00000070S40060000000509@_5@000000000000000033?1X00P00000404=Sa@030=@m6@000000
000000<0@f?50P00000304=Sa@<000000P16J<h01@3D?AT0AVS>04IXcP16J<h000000080AVS>0`3D
?AT01@16J<h0000004IXcP16J<h000000080AVS>00H0000004IXcP3D?AT0AVS>00000016J<h20000
000;04IXcP000000odlQ0000003oCb4000000?m?8@000000odlQ0000003oCb40100mFJ/00`3oCb40
00000?m@8P020?m@8P8000000`3oD282000000@0oe0R0P0000000`3oD28000000?mA8P020?mA8P03
03eIZ`000000oe4R00D0oe4R0`0mFJ/20?mA8P030000003oDB40oe4Q0080oe4Q0P0000080?mA8@05
0000000mFJ/0?EV[0000003oD2400`0mFJ/20?m@8@030000003om^h0ooK^00D0?EV[00<0e3dI0?of
kP3om^h0203om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?of
kP3om^h01P3om^h20=@m6@L0ooK^00<0e3dI0?ofkP3om^h0=03om^h00`000000ooK^0?ofkP0E0?of
kP030000003om^h0ooK^02L0ooK^0@3oool00240ooK^0P00000d0?ofkP0303eIZ`3om^h0ooK^0140
ooK^00<0?EV[0?ofkP3om^h0303om^h303eIZ`80ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0
ooK^0?ofkP0?0?ofkP0503eIZ`3om^h0ooK^03eIZ`3om^h00`0mFJ/80?ofkP0303eIZ`3om^h0ooK^
00@0ooK^0`0mFJ/0103om^h000000000003D?AT7000000030<<l6P000000000000@000000P13HlD0
103D?AT0@f?500000000000304=Sa@<000000P16J<h200000080AVS>00<0e3dI00000016J<h00`3D
?AT204IXcP0600000016J<h0AVS>00000016J<h000000P16J<h01P000000AVS>0000003D?AT00000
04IXcP80000000P0AVS>000000000000odlQ0000003oCb4000000?m?8@<0?EV[00<000000?m?8@0m
FJ/00P000000103oCb4000000?m@8P0000030?m@8P800000103oD282000000@0oe0R00D000000?mA
8P000000000003eIZ`020?mA8P@0?EV[00<000000?mA8P3oDB800`3oDB8010000000oe4Q00000000
00080?mA8@8000000P3oDB4403eIZ`80oe0Q0P00000503eIZ`@0ooK^00<0e3dI0?ofkP3om^h01P3o
m^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h01`3o
m^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^03D0ooK^00<000000?ofkP3om^h0503o
m^h00`000000ooK^0?ofkP0W0?ofkP40oooo000S0?ofkP030000003om^h0ooK^0380ooK^00<0?EV[
0?ofkP3om^h0403om^h00`0mFJ/0ooK^0?ofkP090?ofkP<0?EV[1@3om^h00`0mFJ/0ooK^0?ofkP0C
0?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP0mFJ/00P0mFJ/;0?ofkP0303eIZ`3om^h0
ooK^0080ooK^0P0mFJ/30?ofkP0603eIZ`3om^h000000000003D?AT0L2<@1`0000020<<l6P800000
00D0`c`J00000000000000000=@m6@0204=Sa@<000000`16J<h00`000000AVS>04IXcP060=@m6@04
00000016J<h0000000000080AVS>00d0000004IXcP16J<h0000004IXcP000000AVS>00000016J<h0
000004IXcP3D?AT0AVS>00D0000000<0odlQ0000000000000P0mFJ/00`3oCb400000000000020?m?
8@040000000mFJ/0odlQ0?m?8@8000000P3oD282000000@0oe0R0P0000060?m@8P8000000P3oDB83
03eIZ`<000001`3oDB82000000P0oe4Q0P00000403eIZ`80oe4Q00<000000?m@8@0mFJ/0100mFJ/2
0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP06
0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT02@3om^h20=@m6@H0ooK^00<0e3dI0?ofkP3om^h0=@3o
m^h00`000000ooK^0?ofkP0E0?ofkP030000003om^h0ooK^02H0ooK^0@3oool002@0ooK^0P00000b
0?ofkP0303eIZ`3om^h0ooK^0140ooK^00<0?EV[0?ofkP3om^h01P3om^h203eIZ`T0ooK^00<0?EV[
0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP<0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP09
0?ofkP0303eIZ`3om^h0?EV[0080?EV[1P3om^h00`0mFJ/0ooK^0?ofkP060000000309@_5@3D?AT0
000000<000000P33?1X00`000000?EV[03eIZ`03000000<0AVS>00<000000=@m6@3D?AT00`3D?AT3
04IXcP0500000016J<h0e3dI04IXcP0000000P16J<h020000000AVS>04IXcP000000AVS>00000016
J<h000000P16J<h9000000070?m=8@000000?EV[03eIZ`000000odlQ000000030?m?8@050000003o
Cb40odlQ03eIZ`0000000P3oCb42000000@0oe0R0P0000060?m@8P80000000H0oe0R03eIZ`0mFJ/0
?EV[0?mA8P00000203eIZ`L0oe4R0P0000020?mA8P030000003oDB40oe4Q00<0oe4Q00@0000003eI
Z`0mFJ/0?EV[1P3oDB4403eIZ`D0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP04
0?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3D?AT02P3om^h00`3D?AT0ooK^0=@m6@05
0?ofkP030=@m6@3om^h0ooK^03H0ooK^00<000000?ofkP3om^h0503om^h00`000000ooK^0?ofkP0V
0?ofkP40oooo000V0?ofkP030000003om^h0ooK^02l0ooK^00<0?EV[0?ofkP3om^h04@3om^h00`0m
FJ/0ooK^0?ofkP030?ofkP<0?EV[2`3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^
00X0ooK^0`0mFJ/00`3om^h0?EV[0?ofkP020?ofkP0303eIZ`3om^h0ooK^00P0ooK^0`0mFJ/90?of
kP0403eIZ`3om^h0ooK^0?ofkP@0000000@0U2lE000000000000U2lE0`00000303eIZ`050<<l6P00
0000e3dI0<<l6P3D?AT00P00000304IXcP<000000P16J<h20000000404IXcP00000000000=@m6@80
AVS>00<0000004IXcP0000000P16J<h010000000AVS>00000016J<h40000000504Q]eP000000B6gF
00000018KMH010000000103oCb4000000?m?8@0000020?m?8@80000000D0odlQ000000000000odlQ
03eIZ`02000000040?m?8@000000oe0R0?m@8P8000001@3oD282000000@0?EV[00@0oe0R00000000
000000000`3oDB80100mFJ/0oe4R0?mA8P3oDB83000000D0oe4R00<000000?mA8@0mFJ/00`0mFJ/6
0?mA8@<0?EV[203om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI
0?ofkP3om^h02@3om^h20=@m6@T0ooK^00@0e3dI0?ofkP3om^h0e3dI1@3om^h00`3D?AT0ooK^0?of
kP0g0?ofkP030000003om^h0ooK^01<0ooK^00<000000?ofkP3om^h09P3om^h10?ooo`009`3om^h2
00000300ooK^00<0?EV[0?ofkP3om^h04@3om^h00`0mFJ/0ooK^03eIZ`0203eIZ`l0ooK^00<0?EV[
0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP060?ofkP<0?EV[103om^h00`0mFJ/0ooK^0?ofkP02
0?ofkP0303eIZ`3om^h0ooK^00@0ooK^0`0mFJ/00`3om^h0?EV[0?ofkP0:0?ofkP0403eIZ`3om^h0
ooK^0?ofkP80000000D0e3dI000000000000U2lE0000000303eIZ`D000000P33?1X300000080hT@M
0P00000204IXcP8000000`16J<h010000000AVS>0000003D?AT204IXcP<000000P16J<h300000005
04Q]eP000000000000000018KMH01`000000103oCB4000000?m?8@0000020?m?8@040000003oCb40
000000000080odlQ0P0000000`0mFJ/0odlQ0?m?8@03000000@0oe0R0P00000303eIZ`80oe0R0`00
00020?m@8P030000003oDB80oe4R0080oe4R0P0mFJ/00`000000oe4R0?mA8P050?mA8P<0?EV[00<0
00000?mA8@3oDB400`3oDB4403eIZ`030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h0203o
m^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00d0ooK^00<0e3dI0?ofkP3om^h01`3om^h01@3D?AT0ooK^
0?ofkP3om^h0e3dI00@0ooK^00<0e3dI0?ofkP3om^h0=`3om^h00`000000ooK^0?ofkP0C0?ofkP03
0000003om^h0ooK^02H0ooK^0@3oool002T0ooK^00<000000?ofkP3om^h0;@3om^h00`0mFJ/0ooK^
0?ofkP0@0?ofkP<0?EV[4P3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^00<0ooK^
0`0mFJ/80?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/00`3om^h303eIZ`@0ooK^00<0?EV[0?ofkP3o
m^h02P3om^h0100mFJ/0ooK^0?ofkP0mFJ/2000000@0?EV[100000020<<l6P@0000000<0`c`J0000
003RA1d010000000103RA1d0000000000016J<h300000080AVS>0P000000103D?AT0000004IXcP16
J<h30000000304Q]eP000000B6gF0080000000<0B6gF0000000000001P0000001@3oCB4000000?m=
8@000000odlQ00@0000000@0odlQ00000000000000000P3oCb400`000000?EV[000000020?m?8@04
0000003oD280oe0R000000<0?EV[00<0oe0R0000000000000P0000050?m@8P030000003oDB80oe4R
008000000P3oDB8203eIZ`80oe4R100mFJ/010000000oe4R0?mA8P0000020?mA8@<0?EV[0`000002
0?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h02P3om^h0103D?AT0ooK^0?ofkP3D
?AT=0?ofkP80e3dI203om^h00`3D?AT0ooK^0?ofkP020?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT0
>P3om^h00`000000ooK^0?ofkP0B0?ofkP030000003om^h0ooK^02H0ooK^0@3oool002X0ooK^0P00
000]0?ofkP0303eIZ`3om^h0ooK^00d0ooK^0`0mFJ/00`3om^h0?EV[0?ofkP0C0?ofkP0303eIZ`3o
m^h0ooK^01<0ooK^00<0?EV[0?ofkP0mFJ/00P0mFJ/;0?ofkP0303eIZ`3om^h0ooK^0080ooK^0`0m
FJ/70?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h00`0mFJ/01@000000L2<@0000
00000000U2lE00D000001033?1X50000000303eIZ`3RA1d0000000P000000P16J<h01@000000e3dI
000000000000B6gF00<0000000<0B6gF00000018KMH02@0000001@3oCB400000000000000000oddQ
00<0000000<0odlQ0000000000000P3oCb4300000080odlQ00<0?EV[0?m?8@000000100mFJ/0103o
D28000000000000000080?m@8P@000001@3oDB8403eIZ`030000003oDB80oe4R0080oe4R100mFJ/0
0`3oDB400000000000060?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h02`3om^h2
0=@m6@d0ooK^00@0e3dI0?ofkP3om^h0e3dI1`3om^h00`3D?AT0ooK^0?ofkP030?ofkP040=@m6@3o
m^h0ooK^0=@m6C/0ooK^00<000000?ofkP3om^h04P3om^h00`000000ooK^0?ofkP0U0?ofkP40oooo
000/0?ofkP030000003om^h0ooK^02/0ooK^00<0?EV[0?ofkP3om^h02@3om^h303eIZ`D0ooK^00<0
?EV[0?ofkP3om^h04P3om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP<0?EV[3P3om^h00`0mFJ/0ooK^03eI
Z`0203eIZ`030?ofkP0mFJ/0ooK^00L0ooK^00<0?EV[0?ofkP3om^h02P3om^h403eIZ`80ooK^0P00
00001@3D?AT0L2<@000000000000U2lE00L000000`33?1X30000000503eIZ`00000000000000003R
A1d00`0000000`3RA1d000000000000200000080B6gF0`0000000`18KMH000000000000200000003
04Q]eP000000000000D0000000@0oddQ000000000000oddQ0P0000001@3oCB400000000000000000
odlQ00<000000`3oCb42000000<0?EV[00<0odlQ0000000000000P0000070?m@8P@000000`3oD282
000000@0?EV[00@000000?mA8P3oDB80oe4R1P0mFJ/4000000T0ooK^00<0e3dI0?ofkP3om^h00P3o
m^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00/0ooK^00D0e3dI0?ofkP3om^h0ooK^
0=@m6@050?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3D?AT0?03om^h00`000000ooK^
0?ofkP0A0?ofkP030000003om^h0ooK^02D0ooK^0@3oool002d0ooK^0P00000[0?ofkP0303eIZ`3o
m^h0ooK^00H0ooK^0`0mFJ/80?ofkP0303eIZ`3om^h0ooK^0180ooK^00<0?EV[0?ofkP3om^h03P3o
m^h303eIZ`80ooK^00<0?EV[0?ofkP3om^h0303om^h203eIZ`@0ooK^00<0?EV[0?ofkP3om^h01P3o
m^h00`0mFJ/0ooK^0?ofkP070?ofkP<0?EV[0P3om^h203eIZ`<0ooK^0P0000000`3D?AT0L2<@0000
000200000080U2lE0`0000000`33?1X0000000000002000000030<<l6P000000?EV[0100000000<0
B6gF0000000000005P0000020?m?8@@000000P0mFJ/20000000503eIZ`000000odlQ0?m?8@000000
0`3oD285000000H0oe0R0`0mFJ/2000000L0oe4R0P0mFJ/010000000e3dI00000000000=0?ofkP04
0=@m6@3om^h0ooK^0=@m6@l0ooK^00<0e3dI0?ofkP3D?AT02`3om^h00`3D?AT0ooK^0?ofkP030?of
kP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0=@m6@0l0?of
kP030000003om^h0ooK^0140ooK^00<000000?ofkP3om^h09@3om^h10?ooo`00;`3om^h00`000000
ooK^0?ofkP0X0?ofkP0303eIZ`3om^h0ooK^00<0ooK^0`0mFJ/<0?ofkP0303eIZ`3om^h0ooK^0180
ooK^00<0?EV[0?ofkP3om^h02P3om^h303eIZ`D0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0
ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h01@3om^h203eIZ`H0
ooK^00<0?EV[0?ofkP0mFJ/00`0mFJ/01@000000L2<@000000000000U2lE008000000P2D;aD50000
00050<<l6P00000000000000000mFJ/00P000000103RA1d000000000000000020>947B80000000@0
odlQ03eIZ`0mFJ/0?EV[0P0000030?m?8@80?EV[1@0000070?m@8P@0?EV[00D000000?m@8P3oD280
oe0R000000030?mA8P8000000P0mFJ/2000000030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3D
?AT03`3om^h0103D?AT0ooK^0?ofkP3D?AT:0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?of
kP3om^h00P3om^h00`3D?AT0ooK^0?ofkP060?ofkP80e3dI?@3om^h00`000000ooK^0?ofkP0@0?of
kP030000003om^h0ooK^02D0ooK^0@3oool00300ooK^0P00000Y0?ofkP0303eIZ`3om^h0?EV[0080
?EV[3`3om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^00L0ooK^0`0mFJ/90?ofkP03
03eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP040?ofkP03
03eIZ`3om^h0ooK^0080ooK^0`0mFJ/70?ofkP<0?EV[0P3om^h00`000000ooK^0?ofkP0200000004
070S40000000000009@_5@<000001033?1X3000000040<<l6P000000?EV[0>947@@000000`0mFJ/P
00000080?EV[00<0odlQ0000000000001P0000001@3oCb40?EV[03eIZ`3oCb40000000<0oe0R0P00
000303eIZ`H0oe0R100000000`0mFJ/0000000000002000000030=@m6@3om^h0e3dI01<0ooK^00<0
e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0
e3dI0?ofkP3om^h01@3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00T0ooK^00<0e3dI0?ofkP3om^h0
?03om^h00`000000ooK^0?ofkP0?0?ofkP030000003om^h0ooK^02D0ooK^0@3oool00380ooK^00<0
00000?ofkP3om^h09P3om^h203eIZa<0ooK^00<0?EV[0?ofkP3om^h04P3om^h00`0mFJ/0ooK^0?of
kP030?ofkP<0?EV[3@3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0
?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^03eIZ`0203eIZ`L0ooK^0`0mFJ/00`3om^h0?EV[03eI
Z`020?ofkP040000003om^h0ooK^0?ofkPh000000P33?1X010000000?EV[00000000000303eIZ`80
hT@M900000060?m?8@X000000P0mFJ/00`3oD2800000000000060000000304E[d0000000000000@0
00000`3om^h00`3D?AT0ooK^0?ofkP0A0?ofkP030=@m6@3om^h0e3dI00d0ooK^00<0e3dI0?ofkP3o
m^h0103om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3D
?AT02P3om^h00`3D?AT0ooK^0?ofkP0l0?ofkP030000003om^h0ooK^00l0ooK^00<000000?ofkP3o
m^h09@3om^h10?ooo`00<`3om^h00`000000ooK^0?ofkP0V0?ofkP0303eIZ`3om^h0ooK^0140ooK^
00<0?EV[0?ofkP3om^h04P3om^h00`0mFJ/0ooK^0?ofkP0303eIZa00ooK^00<0?EV[0?ofkP3om^h0
2P3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00<0ooK^0P0mFJ/70?ofkP<0?EV[
103om^h01@0mFJ/0ooK^03eIZ`3om^h0000000@0ooK^1@0000000`2D;aD0000000000002000000<0
`c`J0`00000303eIZc`000001`15Jm04000000H0ooK^00<0e3dI0?ofkP3D?AT04@3om^h01@3D?AT0
ooK^0?ofkP3om^h0e3dI00`0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP040?of
kP030=@m6@3om^h0ooK^00P0ooK^0P3D?AT:0?ofkP030=@m6@3om^h0ooK^03d0ooK^00<000000?of
kP3om^h03`3om^h00`000000ooK^0?ofkP0T0?ofkP40oooo000d0?ofkP8000009P3om^h00`0mFJ/0
ooK^0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^0140ooK^0`0mFJ/D0?ofkP0303eIZ`3om^h0ooK^00T0
ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP0403eIZ`@0ooK^100mFJ/70?ofkP05
03eIZ`3om^h0ooK^03eIZ`0000001P3om^h00`000000L2<@0000000200000080U2lE1000000303eI
Z`80`c`J00<0?EV[0000003RA1d01@3RA1dI0000000304Y`g0000000000001H0000000D0e3dI0000
00000000000004E[d005000000P0ooK^0P3D?AT30?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI
0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI
0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI
0?ofkP3om^h0?`3om^h00`000000ooK^0?ofkP0>0?ofkP030000003om^h0ooK^02@0ooK^0@3oool0
03H0ooK^00<000000?ofkP3om^h0903om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP0303eIZ`3om^h0ooK^
00h0ooK^0`0mFJ/20?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0m
FJ/0ooK^0?ofkP060?ofkP<0?EV[0`3om^h00`0mFJ/0ooK^03eIZ`0203eIZ`/0ooK^00D0?EV[0?of
kP3om^h0ooK^03eIZ`070?ofkP80000000<0L2<@0000000000000P00000303eIZ`80`c`J10000002
03eIZ`D000001@3RA1d2000000030?M:7`000000000000L0000000<0BW3L0000000000000`000002
04Y`g0@0000000@0e3dI00000000000000000`19LM`5000000030=@m6@000000000000H0000000<0
AF_@0=@m6@15Jm001000000:0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h02`3o
m^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h0203o
m^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00`0ooK^0P3D?AT80?ofkP030=@m6@3om^h0ooK^0400ooK^
00<000000?ofkP3om^h03@3om^h00`000000ooK^0?ofkP0T0?ofkP40oooo000g0?ofkP800000903o
m^h00`0mFJ/0ooK^0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^00X0ooK^0`0mFJ/50?ofkP0303eIZ`3o
m^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP020?ofkP@0?EV[0P3o
m^h00`0mFJ/0ooK^0?ofkP0303eIZ`h0ooK^00H0?EV[0?ofkP3om^h0ooK^0000000mFJ/70?ofkP80
0000100mFJ/00`2D;aD0000000000005000000<0`c`J00@0?EV[0=@m6@3RA1d0hT@M100000030>94
7@`0000000@0BW3L000000000000BW3L1@00000204Uag0040000003D?AT0000004Uag0H000000P3D
?AT;000000030=@m6@000000ooK^00/0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?of
kP090?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?of
kP0:0?ofkP040=@m6@3om^h0ooK^0=@m6@/0ooK^00@0e3dI0?ofkP3om^h0e3dI1`3om^h00`3D?AT0
ooK^0?ofkP100?ofkP030000003om^h0ooK^00d0ooK^00<000000?ofkP3om^h0903om^h10?ooo`00
>@3om^h00`000000ooK^0?ofkP0R0?ofkP0303eIZ`3om^h0ooK^0140ooK^00<0?EV[0?ofkP3om^h0
1`3om^h303eIZ`T0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eI
Z`3om^h0?EV[0080?EV[1P3om^h303eIZ`030?ofkP0mFJ/0ooK^00d0ooK^00<0?EV[0?ofkP3om^h0
0P3om^h00`000000?EV[0?ofkP050?ofkP<0?EV[00@0L2<@0000000000000000102D;aD010000000
`c`J0<<l6P33?1X40000000403eIZ`00000000000>947@@000000`3RA1d00`000000mdXO00000006
0000000404Y`g0000000BW3L04Y`g0<000000P19LM`00`000000BG7L00000003000000030=@m6@19
LM`0BG7L00<000000P3D?AT<00000080ooK^00<0e3dI0?ofkP3om^h0203om^h20=@m6@X0ooK^00<0
e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0
e3dI0?ofkP3om^h02`3om^h20=@m6@`0ooK^00@0e3dI0?ofkP3om^h0e3dI1`3om^h00`3D?AT0ooK^
0?ofkP110?ofkP030000003om^h0ooK^00`0ooK^00<000000?ofkP3om^h0903om^h10?ooo`00>P3o
m^h200000280ooK^00<0?EV[0?ofkP3om^h04P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP<0?EV[3@3o
m^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^00@0ooK^100mFJ/60?ofkP<0?EV[0P3o
m^h00`0mFJ/0ooK^03eIZ`0>0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<000000?ofkP0mFJ/00P3o
m^h603eIZ`80000000<0e3dI0000000000000P0000000`2D;aD000000<<l6P040<<l6P<000000P0m
FJ/00`000000hT@M0>947@020>947@8000000P0mFJ/2000000040?M:7`000000000004Y`g0800000
00D0BW3L000000000000000004Uag003000000<0BG7L00H0000004Uag019LM`0BG7L0000003D?AT2
00000080e3dI2P0000070?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h02`3om^h0
0`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h00P3om^h0
0`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h00P3om^h0
0`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^04<0ooK^00<000000?ofkP3om^h0303om^h0
0`000000ooK^0?ofkP0S0?ofkP40oooo000l0?ofkP030000003om^h0ooK^0200ooK^00<0?EV[0?of
kP3om^h04@3om^h00`0mFJ/0ooK^0?ofkP0303eIZa00ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0m
FJ/0ooK^0?ofkP0403eIZ`80ooK^00<0?EV[0?ofkP3om^h00P3om^h303eIZ`H0ooK^0P0mFJ/>0?of
kP0303eIZ`3om^h0ooK^0080ooK^00<000000?ofkP0mFJ/0100mFJ/40?ofkP0303eIZ`0000000000
00<000000P2D;aD6000000@0`c`J00@0000003eIZ`3RA1d00000100mFJ/010000000hT@M0000003R
A1d80000000604Uag0000000BG7L04Uag0000000BG7L0P00000304Uag0<000000`3D?AT404E[d0<0
00003@3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3o
m^h00`3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP040=@m6@3om^h0ooK^0=@m6@l0ooK^00<0e3dI0?of
kP3D?AT02P3om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?of
kP3om^h0A03om^h00`000000ooK^0?ofkP0;0?ofkP030000003om^h0ooK^02<0ooK^0@3oool003d0
ooK^0P00000P0?ofkP0303eIZ`3om^h0ooK^0140ooK^0`0mFJ/D0?ofkP0303eIZ`3om^h0ooK^0180
ooK^0`0mFJ/60?ofkP0303eIZ`3om^h0?EV[0080?EV[2@3om^h203eIZ`h0ooK^00@0?EV[0?ofkP3o
m^h0ooK^1P0mFJ/60?ofkP0503eIZ`3om^h000000000001`8a00100000000`2D;aD0000000000004
0<<l6P@000000P0mFJ/00`3RA1d00000000000020>947@030000003RA1d00000008000000P19LM`2
000000040=@m6@000000BG7L000000<0BG7L00<0000004Uag019LM`00P0000040=@m6@80AF_@00<0
e3dI0000000000000`00000@0?ofkP040=@m6@3om^h0ooK^0?ofkP80e3dI4@3om^h01@3D?AT0ooK^
0?ofkP3om^h0e3dI0100ooK^00<0e3dI0?ofkP3D?AT03`3om^h0103D?AT0ooK^0?ofkP3D?AT80?of
kP030=@m6@3om^h0ooK^00D0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@160?ofkP030000003om^h0
ooK^00/0ooK^00<000000?ofkP3om^h08`3om^h10?ooo`00?`3om^h00`000000ooK^0?ofkP0N0?of
kP0303eIZ`3om^h0ooK^00`0ooK^100mFJ/20?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?of
kP3om^h03P3om^h303eIZ`80ooK^00<0?EV[0?ofkP3om^h0103om^h203eIZ`d0ooK^00<0?EV[0?of
kP3om^h0303om^h603eIZ`@0ooK^0P0mFJ/40?ofkP0403eIZ`3om^h0ooK^0?ofkP80000000<0L2<@
0000002D;aD01`00000303eIZ`040<<l6P000000?EV[00000080hT@M0P0000002`3RA1d000000000
0019LM`0000004Uag0000000BG7L00000019LM`0e3dI0080BG7L00<0000004Uag019LM`00P000003
0=@m6@80AF_@1@0000000`3D?AT000000?ofkP0C0?ofkP030=@m6@3om^h0e3dI01@0ooK^00<0e3dI
0?ofkP3D?AT04P3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI
0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP060?ofkP040=@m6@3om^h0ooK^0=@m6DL0ooK^00<0
00000?ofkP3om^h02P3om^h00`000000ooK^0?ofkP0S0?ofkP40oooo00100?ofkP8000007P3om^h0
0`0mFJ/0ooK^0?ofkP090?ofkP<0?EV[1P3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0
ooK^00/0ooK^0`0mFJ/60?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h02`3om^h0
0`0mFJ/0ooK^03eIZ`0:0?ofkPD0?EV[0`3om^h00`000000ooK^0?ofkP040?ofkP0403eIZ`3om^h0
ooK^03eIZ`D0ooK^1000000409@_5@<0?EV[00@0`c`J00000000000000000P33?1X203eIZ`050000
003RA1d0hT@M0000003RA1d00P00000204Uag00600000019LM`0000004Uag0000000e3dI0P000004
0=@m6@0304E[d0000000000000H000000P3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0
ooK^01@0ooK^00<0e3dI0?ofkP3om^h0403om^h00`3D?AT0ooK^0=@m6@0=0?ofkP030=@m6@3om^h0
ooK^00@0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0
e3dI04T0ooK^00<000000?ofkP3om^h02@3om^h00`000000ooK^0?ofkP0S0?ofkP40oooo00120?of
kP030000003om^h0ooK^01`0ooK^00<0?EV[0?ofkP3om^h0103om^h403eIZ`X0ooK^00<0?EV[0?of
kP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP070?ofkP<0?EV[2P3om^h00`0mFJ/0ooK^0?ofkP020?of
kP0303eIZ`3om^h0ooK^00/0ooK^00@0?EV[0?ofkP3om^h0?EV[1P3om^h503eIZ`030?ofkP0mFJ/0
ooK^00<0ooK^00<000000?ofkP3om^h01@3om^h00`0mFJ/0ooK^03eIZ`060?ofkP030000001`8a00
000000@0?EV[00@000000=@m6@00000000001P33?1X02`000000?EV[03eIZ`000000hT@M00000019
LM`0000004Uag0000000BG7L008000001@3D?AT00`15Jm0000000000000204E[d0D000001P3om^h0
0`3D?AT0ooK^0?ofkP0@0?ofkP80e3dI00<0ooK^0=@m6@3om^h04`3om^h00`3D?AT0ooK^0=@m6@0@
0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT0303om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3o
m^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h0203om^h20=@m6DT0ooK^00<000000?ofkP3om^h02P3o
m^h00`000000ooK^0?ofkP0R0?ofkP40oooo00130?ofkP800000703om^h00`0mFJ/0ooK^0?ofkP04
03eIZ`l0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP030?ofkP<0?EV[3P3om^h0
100mFJ/0ooK^0?ofkP0mFJ/>0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/00P3om^h503eIZ`<0ooK^
00<0?EV[0?ofkP3om^h00`3om^h00`000000ooK^0?ofkP060?ofkP80?EV[1P3om^h303eIZ`03070S
40000000U2lE00@0U2lE00<000000<<l6P33?1X00P33?1X3000000060>947@000000hT@M00000019
LM`000001P3D?AT304E[d0040000003D?AT0AF_@04E[d0D000002P3om^h00`3D?AT0ooK^0?ofkP0=
0?ofkP80e3dI103om^h00`3D?AT0ooK^0?ofkP0?0?ofkP80e3dI0`3om^h00`3D?AT0ooK^0?ofkP0<
0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP06
0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT0303om^h00`3D?AT0ooK^0?ofkP180?ofkP030000003o
m^h0ooK^00T0ooK^00<000000?ofkP3om^h08P3om^h10?ooo`00A@3om^h00`000000ooK^0?ofkP0J
0?ofkP80?EV[4`3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^00<0?EV[4@3om^h0
100mFJ/0ooK^0?ofkP0mFJ/>0?ofkP0403eIZ`3om^h0ooK^0?ofkPD0?EV[1P3om^h00`0mFJ/0ooK^
0?ofkP030?ofkP030000003om^h0ooK^00L0ooK^0P0mFJ/20?ofkP<0?EV[0P3om^h200000003070S
40000000U2lE00<0U2lE00<000000<<l6P33?1X00P0000030<<l6P030000003RA1d0hT@M00@00000
00D0AF_@00000015Jm00AF_@0000000204E[d0<0000000D0e3dI000000000000ooK^0=@m6@0=0?of
kP80e3dI2`3om^h20=@m6@L0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP040?of
kP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP060?of
kP030=@m6@3om^h0ooK^00P0ooK^00@0e3dI0?ofkP3om^h0e3dI303om^h00`3D?AT0ooK^0?ofkP19
0?ofkP030000003om^h0ooK^00P0ooK^00<000000?ofkP3om^h08P3om^h10?ooo`00AP3om^h20000
01/0ooK^00<0?EV[0?ofkP3om^h04P3om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP<0?EV[5@3om^h00`0m
FJ/0ooK^03eIZ`0>0?ofkPD0?EV[00<0ooK^03eIZ`3om^h01`3om^h00`0mFJ/0ooK^0?ofkP030?of
kP030000003om^h0ooK^00H0ooK^00<0?EV[0?ofkP0mFJ/00P0mFJ/60?ofkPX000001033?1X00`00
0000?EV[0000000300000080AF_@00<0000004E[d015Jm001P0000020?ofkP040=@m6@3om^h0ooK^
0=@m6@l0ooK^00<0e3dI0?ofkP3om^h01P3om^h20=@m6@X0ooK^00<0e3dI0?ofkP3om^h02`3om^h0
0`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h01P3om^h0
0`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00X0ooK^0P3D?AT<0?ofkP030=@m6@3om^h0
ooK^04/0ooK^00<000000?ofkP3om^h01`3om^h00`000000ooK^0?ofkP0R0?ofkP40oooo00180?of
kP030000003om^h0ooK^01P0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP0>0?of
kP<0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP80?EV[2`3om^h503eIZ`D0ooK^0P0mFJ/50?of
kP0303eIZ`3om^h0ooK^00@0ooK^00<000000?ofkP3om^h01@3om^h303eIZ`80ooK^0P0mFJ/60?of
kP80000000<0L2<@0000002D;aD00`2D;aD2000000@0?EV[00D0`c`J00000015Jm00AF_@0=@m6@02
04E[d0H0000000<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0=@m6@0@0?ofkP030=@m6@3om^h0
ooK^00<0ooK^0P3D?AT=0?ofkP030=@m6@3om^h0ooK^00P0ooK^0P3D?AT90?ofkP030=@m6@3om^h0
ooK^00L0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0
ooK^00/0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP1;0?ofkP030000003om^h0
ooK^00L0ooK^00<000000?ofkP3om^h08P3om^h10?ooo`00B@3om^h00`000000ooK^0?ofkP0H0?of
kP0303eIZ`3om^h0ooK^0180ooK^00<0?EV[0?ofkP3om^h02`3om^h303eIZ`H0ooK^00<0?EV[0?of
kP3om^h0503om^h00`0mFJ/0ooK^0?ofkP050?ofkPH0?EV[00<0ooK^03eIZ`3om^h01`3om^h00`0m
FJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00@0ooK^00@000000?ofkP3om^h0ooK^1@0mFJ/6
0?ofkP80?EV[1@3om^h00`0mFJ/0000000000002000000@0?EV[00D000000<<l6P33?1X0`c`J0000
000204E[d00500000015Jm00e3dI0000000hFZ`00P0000001@3D?AT0ooK^0?ofkP3om^h0e3dI00D0
ooK^00<0e3dI0?ofkP3om^h0403om^h00`3D?AT0ooK^0?ofkP020=@m6A00ooK^00<0e3dI0?ofkP3o
m^h01P3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3o
m^h02P3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3D
?AT02P3om^h00`3D?AT0ooK^0?ofkP1=0?ofkP030000003om^h0ooK^00L0ooK^00<000000?ofkP3o
m^h08@3om^h10?ooo`00BP3om^h2000001T0ooK^00<0?EV[0?ofkP3om^h04P3om^h00`0mFJ/0ooK^
0?ofkP070?ofkP<0?EV[2P3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP80?EV[0P3om^h703eIZ`<0ooK^
00<0?EV[0?ofkP3om^h0203om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00H0ooK^00<0000003eIZ`0m
FJ/00P0mFJ/30?ofkP0303eIZ`3om^h0ooK^00H0ooK^0P0mFJ/20?ofkPH0?EV[0`00000209@_5@04
00000033?1X0000004E[d0D0000000<0e3dI0000003om^h00P3om^h01@3D?AT0ooK^0?ofkP3om^h0
e3dI00@0ooK^0`3D?AT@0?ofkP<0e3dI4`3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0
ooK^00`0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP040=@m6@3om^h0
ooK^0=@m6@h0ooK^00@0e3dI0?ofkP3om^h0e3dI2@3om^h00`3D?AT0ooK^0?ofkP1>0?ofkP030000
003om^h0ooK^00H0ooK^00<000000?ofkP3om^h08@3om^h10?ooo`00C03om^h00`000000ooK^0?of
kP0G0?ofkP0303eIZ`3om^h0ooK^0180ooK^00<0?EV[0?ofkP3om^h00`3om^h303eIZ`h0ooK^00<0
?EV[0?ofkP3om^h04@3om^h00`0mFJ/0ooK^03eIZ`0603eIZ`H0ooK^00<0?EV[0?ofkP3om^h02@3o
m^h203eIZ`030?ofkP0mFJ/0ooK^00<0ooK^0`0mFJ/60?ofkP0303eIZ`3om^h0ooK^00P0ooK^1P0m
FJ/01P3om^h000000000001`8a00000009@_5@<0?EV[1P000000103D?AT0ooK^0?ofkP3D?AT30?of
kP030=@m6@3om^h0ooK^0080ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@020?ofkP030=@m6@3om^h0
ooK^00T0ooK^103D?AT20?ofkP030=@m6@3om^h0ooK^0180ooK^00@0e3dI0?ofkP3om^h0ooK^0P3D
?AT@0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT0403om^h00`3D?AT0ooK^0=@m6@0=0?ofkP050=@m
6@3om^h0ooK^0?ofkP3D?AT0203om^h00`3D?AT0ooK^0?ofkP1?0?ofkP030000003om^h0ooK^00H0
ooK^00<000000?ofkP3om^h08@3om^h10?ooo`00C@3om^h2000001L0ooK^00<0?EV[0?ofkP3om^h0
4P3om^h00`0mFJ/0ooK^0?ofkP0303eIZa40ooK^00<0?EV[0?ofkP3om^h0403om^h603eIZ`X0ooK^
00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^03eIZ`0303eIZ`80ooK^00<000000?ofkP3om^h0
0`3om^h00`0mFJ/0ooK^0?ofkP060?ofkP@0?EV[00<0ooK^03eIZ`3om^h00P3om^h703eIZ`040000
003D?AT0e3dI0=@m6@<0ooK^00<0e3dI0?ofkP3D?AT00P3om^h20=@m6@030?ofkP3D?AT0ooK^00@0
ooK^0P3D?AT00`3om^h0e3dI0?ofkP020?ofkP030=@m6@3om^h0ooK^00D0ooK^0`3D?AT70?ofkP03
0=@m6@3om^h0ooK^0180ooK^00<0e3dI0?ofkP3D?AT04`3om^h00`3D?AT0ooK^0=@m6@0B0?ofkP03
0=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP050?ofkP03
0=@m6@3om^h0ooK^0500ooK^00<000000?ofkP3om^h01@3om^h00`000000ooK^0?ofkP0Q0?ofkP40
oooo001?0?ofkP030000003om^h0ooK^01D0ooK^00<0?EV[0?ofkP3om^h04@3om^h303eIZaD0ooK^
00<0?EV[0?ofkP3om^h0303om^h303eIZ`030?ofkP0mFJ/0?EV[00<0ooK^00<0?EV[0?ofkP3om^h0
1P3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP@0?EV[1@3om^h00`000000ooK^0?ofkP030?ofkP0303eI
Z`3om^h0ooK^00<0ooK^100mFJ/30?ofkP0403eIZ`3om^h0ooK^0?ofkP@0?EV[0P3om^h00`3D?AT0
0000000000070=@m6@80ooK^00@0e3dI0?ofkP3om^h0ooK^0P3D?AT70?ofkP80e3dI103om^h00`3D
?AT0ooK^0?ofkP040=@m6@/0ooK^00<0e3dI0?ofkP3om^h04P3om^h00`3D?AT0ooK^0?ofkP0C0?of
kP030=@m6@3om^h0ooK^0100ooK^00<0e3dI0?ofkP3D?AT0303om^h00`3D?AT0ooK^0?ofkP040?of
kP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h0DP3om^h00`000000ooK^0?ofkP040?of
kP030000003om^h0ooK^0240ooK^0@3oool00500ooK^0P00000F0?ofkP0303eIZ`3om^h0ooK^00`0
ooK^100mFJ/20?ofkP0303eIZ`3om^h0ooK^01@0ooK^00<0?EV[0?ofkP3om^h0203om^h303eIZ`@0
ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00P0
ooK^100mFJ/30?ofkP80?EV[0P3om^h00`000000ooK^0?ofkP030?ofkP0403eIZ`3om^h0ooK^0?of
kP@0?EV[1@3om^h00`0mFJ/0ooK^0?ofkP0303eIZ`H0ooK^00<0e3dI0?ofkP3om^h00P3D?AT00`3o
m^h0e3dI0?ofkP060=@m6@80ooK^00<0e3dI0?ofkP3om^h01P3om^h80=@m6A00ooK^00<0e3dI0?of
kP3om^h03`3om^h20=@m6@030?ofkP3D?AT0ooK^0180ooK^00<0e3dI0?ofkP3D?AT0403om^h01@3D
?AT0ooK^0?ofkP3om^h0e3dI00X0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP02
0?ofkP030=@m6@3om^h0ooK^05<0ooK^00<000000?ofkP3om^h0103om^h00`000000ooK^0?ofkP0P
0?ofkP40oooo001B0?ofkP030000003om^h0ooK^01@0ooK^00<0?EV[0?ofkP3om^h0203om^h303eI
Z`L0ooK^00<0?EV[0?ofkP3om^h0503om^h00`0mFJ/0ooK^0?ofkP040?ofkP<0?EV[1P3om^h00`0m
FJ/0ooK^0?ofkP050?ofkP80?EV[1@3om^h00`0mFJ/0ooK^0?ofkP050?ofkP@0?EV[0P3om^h00`0m
FJ/0ooK^0?ofkP030?ofkP80?EV[00<000000?ofkP3om^h00`3om^h503eIZ`L0ooK^100mFJ/:0?of
kP80e3dI00L0ooK^0=@m6@3D?AT0ooK^0=@m6@3om^h0e3dI00@0ooK^303D?AT60?ofkP030=@m6@3o
m^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h0303om^h20=@m6@@0ooK^00<0e3dI0?ofkP3om^h03P3o
m^h20=@m6@<0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3o
m^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h01`3om^h0103D?AT0ooK^0?ofkP3D?AUF0?ofkP030000
003om^h0ooK^00@0ooK^00<000000?ofkP3om^h0803om^h10?ooo`00D`3om^h2000001@0ooK^00<0
?EV[0?ofkP3om^h01@3om^h303eIZ`/0ooK^00<0?EV[0?ofkP3om^h0503om^h00`0mFJ/0ooK^0?of
kP0303eIZ`T0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0403eIZ`3o
m^h0ooK^0?ofkPD0?EV[103om^h00`0mFJ/0ooK^0?ofkP060?ofkP80?EV[0P3om^h403eIZ`L0ooK^
100mFJ/>0?ofkP<0e3dI00H0ooK^0=@m6@3D?AT0e3dI0?ofkP3D?AT40?ofkP040=@m6@3om^h0e3dI
0=@m6@H0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0
ooK^00T0ooK^0P3D?AT70?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h0103om^h0
0`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h01@3om^h0
0`3D?AT0ooK^0?ofkP080?ofkP040=@m6@3om^h0ooK^0=@m6EL0ooK^00<000000?ofkP3om^h00`3o
m^h00`000000ooK^0?ofkP0P0?ofkP40oooo001E0?ofkP030000003om^h0ooK^0180ooK^00<0?EV[
0?ofkP3om^h0100mFJ/?0?ofkP0303eIZ`3om^h0ooK^01<0ooK^0`0mFJ/<0?ofkP0303eIZ`3om^h0
ooK^00P0ooK^00D0?EV[0?ofkP3om^h0?EV[0?ofkP0503eIZ`L0ooK^00<0?EV[0?ofkP3om^h01P3o
m^h00`000000?EV[03eIZ`0403eIZ`D0ooK^100mFJ/C0?ofkP80e3dI0P3om^h30=@m6@D0ooK^0P3D
?AT00`3om^h0e3dI0?ofkP040?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h03`3o
m^h00`3D?AT0ooK^0?ofkP060?ofkP80e3dI2P3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3o
m^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3o
m^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h02P3om^h20=@m6ET0ooK^00<000000?ofkP3om^h00P3o
m^h00`000000ooK^0?ofkP0P0?ofkP40oooo001F0?ofkP8000004`3om^h203eIZa<0ooK^00<0?EV[
0?ofkP3om^h0403om^h303eIZ`80ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP0:
0?ofkPH0?EV[2@3om^h00`0mFJ/0ooK^0?ofkP050?ofkP@0?EV[00<0ooK^03eIZ`3om^h00P3om^h5
03eIZaP0ooK^0P3D?AT20?ofkP<0e3dI1@3om^h0103D?AT0ooK^0?ofkP3D?AT40?ofkP030=@m6@3o
m^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP030?ofkP80e3dI3@3o
m^h20=@m6@P0ooK^0P3D?AT90?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h02@3o
m^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h0F03o
m^h01@000000ooK^0?ofkP3om^h000000280ooK^0@3oool005P0ooK^00<000000?ofkP3om^h04@3o
m^h00`0mFJ/0ooK^0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^00`0ooK^0`0mFJ/60?ofkP80?EV[2@3o
m^h00`0mFJ/0ooK^0?ofkP080?ofkPD0?EV[303om^h0100mFJ/0ooK^0?ofkP3om^h403eIZ`80ooK^
00<000000?ofkP0mFJ/00P3om^h403eIZa`0ooK^0`3D?AT0103om^h0e3dI0=@m6@3D?AT40?ofkP80
e3dI0P3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00X0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D
?AT0ooK^0?ofkP020=@m6A40ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP0:0?of
kP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h02`3om^h0103D?AT0ooK^0?ofkP3D?AT=
0?ofkP030=@m6@3om^h0ooK^05T0ooK^00D000000?ofkP3om^h0ooK^0000000R0?ofkP40oooo001I
0?ofkP8000004P3om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^00P0ooK^0`0mFJ/;
0?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h01@3om^h503eIZ`030?ofkP0mFJ/0
ooK^00<0?EV[203om^h00`0mFJ/0ooK^03eIZ`0303eIZ`D0ooK^00<0000003eIZ`0mFJ/00`0mFJ/P
0?ofkP030=@m6@3om^h0e3dI0080e3dI00<0ooK^0=@m6@3om^h00`3om^h20=@m6@80ooK^0P3D?AT0
0`3om^h0e3dI0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00h0ooK^0`3D?ATD0?ofkP030=@m6@3om^h0
ooK^0080ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0
ooK^00d0ooK^00<0e3dI0?ofkP3D?AT03@3om^h00`3D?AT0ooK^0?ofkP1J0?ofkP050000003om^h0
ooK^0?ofkP0000008@3om^h10?ooo`00F`3om^h00`000000ooK^0?ofkP0@0?ofkP0303eIZ`3om^h0
ooK^0180ooK^00<0?EV[0?ofkP3om^h0103om^h303eIZ`l0ooK^00<0?EV[0?ofkP3om^h01@3om^h0
100mFJ/0ooK^0?ofkP3om^h503eIZ`@0ooK^00<0?EV[0?ofkP3om^h00`3om^h303eIZ`<0ooK^100m
FJ/80?ofkP<0?EV[9@3om^h00`3D?AT0ooK^0?ofkP020=@m6@030?ofkP3D?AT0ooK^0080ooK^00<0
e3dI0?ofkP3D?AT00`3om^h00`3D?AT0ooK^0=@m6@0;0?ofkP030=@m6@3om^h0ooK^00T0ooK^103D
?AT20?ofkP030=@m6@3om^h0ooK^01<0ooK^00@0e3dI0?ofkP3D?AT0e3dI403om^h01@3D?AT0ooK^
0?ofkP3om^h0e3dI0140ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP1L0?ofkP04
0000003om^h0ooK^00000240ooK^0@3oool005`0ooK^00<000000?ofkP3om^h0403om^h00`0mFJ/0
ooK^0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^00<0?EV[4`3om^h203eIZ`@0ooK^00<0?EV[0?ofkP0m
FJ/0100mFJ/60?ofkP0303eIZ`3om^h0ooK^00L0ooK^1@0mFJ/60?ofkP@0?EV[00<0ooK^0000003o
m^h09P3om^h00`3D?AT0ooK^0?ofkP040=@m6@80ooK^00<0e3dI0?ofkP3om^h00P3D?AT20?ofkP80
e3dI303om^h00`3D?AT0ooK^0?ofkP050?ofkP<0e3dI1`3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP03
0=@m6@3om^h0ooK^0140ooK^00<0e3dI0?ofkP3D?AT04@3om^h00`3D?AT0ooK^0=@m6@0;0?ofkP03
0=@m6@3om^h0ooK^05d0ooK^00@000000?ofkP3om^h000008@3om^h10?ooo`00G@3om^h200000100
ooK^00<0?EV[0?ofkP3om^h04P3om^h303eIZaP0ooK^00<0?EV[0?ofkP3om^h0100mFJ/:0?ofkP03
03eIZ`3om^h0ooK^00@0ooK^0`0mFJ/30?ofkP0303eIZ`3om^h0?EV[00D0?EV[1@3om^h00`000000
ooK^0?ofkP0V0?ofkP80e3dI00<0ooK^0=@m6@3D?AT0103D?AT40?ofkP040=@m6@3om^h0ooK^0=@m
6@d0ooK^00<0e3dI0?ofkP3om^h0103D?AT;0?ofkP030=@m6@3om^h0ooK^0100ooK^0P3D?AT00`3o
m^h0e3dI0?ofkP0B0?ofkP030=@m6@3om^h0ooK^00l0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0:
0?ofkP030=@m6@3om^h0ooK^05h0ooK^00<000000?ofkP0000008@3om^h10?ooo`00G`3om^h00`00
0000ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00d0ooK^100mFJ/20?ofkP80?EV[5`3om^h403eI
Z``0ooK^00<0?EV[0?ofkP3om^h00P3om^h303eIZ`@0ooK^0P0mFJ/00`3om^h0?EV[03eIZ`0203eI
Z`P0ooK^00<000000?ofkP3om^h09`3om^h20=@m6@030?ofkP3D?AT0e3dI0080e3dI00<0ooK^0=@m
6@3D?AT0103D?AT00`3om^h0e3dI0=@m6@070?ofkPP0e3dI403om^h00`3D?AT0ooK^0?ofkP0=0?of
kP80e3dI103om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0e3dI00l0ooK^00<0e3dI0?of
kP3om^h00`3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^0600ooK^0P00000Q0?of
kP40oooo001P0?ofkP8000003`3om^h00`0mFJ/0ooK^0?ofkP090?ofkP<0?EV[203om^h203eIZa40
ooK^100mFJ/30?ofkP80?EV[2`3om^h503eIZ`H0ooK^1@0mFJ/;0?ofkP030000003om^h0ooK^02P0
ooK^0`3D?AT20?ofkP<0e3dI1@3om^h:0=@m6@L0ooK^00<0e3dI0?ofkP3om^h03`3om^h20=@m6@/0
ooK^0P3D?AT70?ofkP030=@m6@3om^h0ooK^00`0ooK^0P3D?AT30?ofkP030=@m6@3om^h0ooK^00/0
ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^0680
ooK^0P00000P0?ofkP40oooo001R0?ofkP030000003om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h0
1@3om^h303eIZ`d0ooK^00<0?EV[0?ofkP3om^h02`3om^h303eIZ`H0ooK^00<0?EV[0?ofkP3om^h0
0P0mFJ/70?ofkP@0?EV[1P3om^h403eIZ`l0ooK^00<000000?ofkP3om^h0:P3om^h20=@m6@80ooK^
0P3D?AT60?ofkP040=@m6@3om^h0ooK^0=@m6@d0ooK^00<0e3dI0?ofkP3om^h0403om^h00`3D?AT0
ooK^0?ofkP060?ofkP80e3dI2P3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00@0
ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00@0
ooK^00<0e3dI0?ofkP3om^h0HP3om^h200000200ooK^0@3oool006<0ooK^0P00000>0?ofkP0303eI
Z`3om^h0ooK^00@0?EV[4@3om^h203eIZ`P0ooK^0`0mFJ/80?ofkP0303eIZ`3om^h0ooK^00<0ooK^
0P0mFJ/20?ofkP@0?EV[1@3om^h503eIZa80ooK^00<000000?ofkP3om^h0:`3om^h20=@m6@80ooK^
0P3D?AT50?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT03@3om^h00`3D?AT0ooK^0?ofkP0@0?ofkP03
0=@m6@3om^h0ooK^00<0ooK^0P3D?AT<0?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3o
m^h01P3om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3o
m^h00P3om^h00`3D?AT0ooK^0?ofkP1S0?ofkP800000803om^h10?ooo`00I@3om^h00`000000ooK^
0?ofkP0<0?ofkP80?EV[5`3om^h203eIZ`80ooK^100mFJ/;0?ofkP0303eIZ`3om^h0ooK^00@0ooK^
3@0mFJ/F0?ofkP030000003om^h0ooK^02`0ooK^0`3D?AT0103om^h0e3dI0=@m6@3D?AT40?ofkP05
0=@m6@3om^h0ooK^0?ofkP3D?AT03@3om^h00`3D?AT0ooK^0?ofkP0@0?ofkP030=@m6@3om^h0ooK^
0080e3dI3`3om^h00`3D?AT0ooK^0?ofkP060?ofkP80e3dI2P3om^h00`3D?AT0ooK^0?ofkP050?of
kP030=@m6@3om^h0ooK^00X0ooK^00@0e3dI0?ofkP3om^h0e3dIHP3om^h400000280ooK^0@3oool0
06H0ooK^0P00000=0?ofkP0303eIZ`3om^h0ooK^01H0ooK^0`0mFJ/>0?ofkP0403eIZ`3om^h0ooK^
0?ofkPD0?EV[0P3om^h203eIZ`030?ofkP0mFJ/0?EV[0080?EV[6@3om^h00`000000ooK^0?ofkP0]
0?ofkP030=@m6@3om^h0e3dI0080e3dI00<0ooK^0=@m6@3om^h00P3om^h00`3D?AT0ooK^0?ofkP02
0?ofkP030=@m6@3om^h0ooK^00/0ooK^0P3D?AT@0?ofkP<0e3dI4P3om^h00`3D?AT0ooK^0?ofkP04
0?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP0<
0?ofkP030=@m6@3om^h0e3dI05h0ooK^1000000V0?ofkP40oooo001X0?ofkP030000003om^h0ooK^
00/0ooK^0P0mFJ/C0?ofkP<0?EV[0`3om^h203eIZ``0ooK^1@0mFJ/50?ofkPD0?EV[703om^h00`00
0000ooK^0?ofkP0^0?ofkP030=@m6@3om^h0ooK^00@0e3dI0`3om^h00`3D?AT0ooK^0?ofkP020?of
kP80e3dI3@3om^h00`3D?AT0ooK^0?ofkP090?ofkP@0e3dI0P3om^h00`3D?AT0ooK^0?ofkP0A0?of
kP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h03@3om^h01@3D?AT0ooK^0?ofkP3om^h0
e3dI0100ooK^00<0e3dI0?ofkP3om^h0F@3om^h4000002X0ooK^0@3oool006T0ooK^0P00000=0?of
kP0303eIZ`3om^h0ooK^00d0ooK^0`0mFJ/80?ofkP80?EV[2@3om^h303eIZ`H0ooK^0`0mFJ/P0?of
kP030000003om^h0ooK^02l0ooK^0P3D?AT00`3om^h0e3dI0=@m6@020=@m6@80ooK^00<0e3dI0?of
kP3om^h0103om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00D0ooK^0`3D?AT70?of
kP030=@m6@3om^h0ooK^0140ooK^00@0e3dI0?ofkP3D?AT0e3dI4@3om^h00`3D?AT0ooK^0=@m6@0@
0?ofkP030=@m6@3om^h0ooK^05H0ooK^1000000^0?ofkP40oooo001[0?ofkP030000003om^h0ooK^
00/0ooK^00<0?EV[0?ofkP3om^h02@3om^h303eIZ`d0ooK^0P0mFJ/30?ofkP@0?EV[1@3om^h503eI
Zb80ooK^00<000000?ofkP3om^h0<03om^h20=@m6@030?ofkP3D?AT0ooK^00@0e3dI1`3om^h00`3D
?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00@0e3dI2`3om^h00`3D?AT0ooK^0?ofkP0@0?of
kP80e3dI503om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^05<0ooK^1000000b0?of
kP40oooo001/0?ofkP800000303om^h203eIZ`H0ooK^0`0mFJ/B0?ofkPD0?EV[103om^h503eIZbD0
ooK^00<000000?ofkP3om^h0<@3om^h20=@m6@030?ofkP3D?AT0ooK^0080e3dI00<0ooK^0=@m6@3D
?AT0103D?AT20?ofkP030=@m6@3om^h0ooK^00D0ooK^203D?AT@0?ofkP030=@m6@3om^h0ooK^00d0
ooK^0P3D?AT20?ofkP030=@m6@3om^h0ooK^00l0ooK^0P3D?AT00`3om^h0e3dI0?ofkP0=0?ofkP03
0=@m6@3om^h0ooK^0500ooK^1000000f0?ofkP40oooo001^0?ofkP030000003om^h0ooK^00/0ooK^
00<0?EV[0?ofkP3om^h00`0mFJ/A0?ofkP@0?EV[0`3om^h00`0mFJ/0ooK^03eIZ`0503eIZbP0ooK^
00<000000?ofkP3om^h0<`3om^h0103D?AT0ooK^0=@m6@3om^h30=@m6@D0ooK^2P3D?AT70?ofkP03
0=@m6@3om^h0ooK^00l0ooK^0P3D?AT;0?ofkP80e3dI1@3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP03
0=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP1=0?ofkP@0
0000>P3om^h10?ooo`00K`3om^h00`000000ooK^0?ofkP0;0?ofkP80?EV[4@3om^h303eIZ`D0ooK^
1`0mFJ/[0?ofkP030000003om^h0ooK^03@0ooK^0P3D?AT30?ofkP80e3dI203om^h00`3D?AT0ooK^
0?ofkP0;0?ofkP030=@m6@3om^h0ooK^0100ooK^00<0e3dI0?ofkP3om^h01P3om^h20=@m6@P0ooK^
00<0e3dI0?ofkP3om^h02P3om^h20=@m6@H0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^
0?ofkP1:0?ofkP@00000?P3om^h10?ooo`00L03om^h2000000d0ooK^0`0mFJ/;0?ofkP<0?EV[1P3o
m^h503eIZbl0ooK^00<000000?ofkP3om^h0=@3om^h20=@m6@<0ooK^0P3D?AT80?ofkP030=@m6@3o
m^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h0403om^h00`3D?AT0ooK^0?ofkP030?ofkP80e3dI2`3o
m^h20=@m6@T0ooK^00<0e3dI0?ofkP3om^h01`3om^h20=@m6@L0ooK^00<0e3dI0?ofkP3om^h0A`3o
m^h400000480ooK^0@3oool00780ooK^00<000000?ofkP3om^h03@3om^h403eIZ`<0ooK^100mFJ/7
0?ofkP@0?EV[<@3om^h00`000000ooK^0?ofkP0g0?ofkP@0e3dI00<0ooK^0=@m6@3D?AT0203om^h0
0`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^0100ooK^00<0e3dI0?ofkP3om^h00P3D?AT?
0?ofkP030=@m6@3om^h0ooK^00@0ooK^0P3D?AT<0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI
0?ofkP3om^h0A03om^h4000004H0ooK^0@3oool007<0ooK^0P00000A0?ofkPD0?EV[1P3om^h403eI
Zc@0ooK^00<000000?ofkP3om^h0>03om^h20=@m6@040?ofkP3D?AT0e3dI0?ofkP80e3dI1`3om^h0
0`3D?AT0ooK^0?ofkP0;0?ofkP80e3dI403om^h30=@m6A80ooK^00<0e3dI0?ofkP3om^h00P3om^h0
0`3D?AT0ooK^0?ofkP0=0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT0@`3om^h4000004X0ooK^0@3o
ool007D0ooK^00<000000?ofkP3om^h04`3om^h603eIZcP0ooK^00<000000?ofkP3om^h0>P3om^h0
0`3D?AT0ooK^0?ofkP040=@m6@L0ooK^0P3D?AT=0?ofkP030=@m6@3om^h0ooK^00T0ooK^103D?AT2
0?ofkP030=@m6@3om^h0ooK^0140ooK^00@0e3dI0?ofkP3D?AT0e3dI4@3om^h00`3D?AT0ooK^0=@m
6@100?ofkP@00000CP3om^h10?ooo`00MP3om^h200000540ooK^00<000000?ofkP3om^h0>`3om^h0
1@3D?AT0ooK^0?ofkP3D?AT0ooK^00<0e3dI1`3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3o
m^h0ooK^00D0ooK^0`3D?AT70?ofkP030=@m6@3om^h0ooK^0140ooK^00<0e3dI0?ofkP3om^h04P3o
m^h00`3D?AT0ooK^0?ofkP0k0?ofkP@00000DP3om^h10?ooo`00N03om^h00`000000ooK^0?ofkP1>
0?ofkP030000003om^h0ooK^03`0ooK^0`3D?AT30?ofkPD0e3dI103om^h00`3D?AT0ooK^0?ofkP0;
0?ofkP030=@m6@3om^h0ooK^00@0e3dI2`3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP80e3dI00<0ooK^
0=@m6@3om^h04@3om^h00`3D?AT0ooK^0?ofkP0i0?ofkP<00000EP3om^h10?ooo`00N@3om^h20000
04h0ooK^00<000000?ofkP3om^h0?@3om^h30=@m6@<0ooK^00@0e3dI0?ofkP3om^h0ooK^103D?AT0
0`3om^h0e3dI0?ofkP060?ofkPP0e3dI403om^h00`3D?AT0ooK^0?ofkP0;0?ofkP80e3dI103om^h0
0`3D?AT0ooK^0?ofkP0=0?ofkP80e3dI>03om^h4000005T0ooK^0@3oool007/0ooK^00<000000?of
kP3om^h0B`3om^h00`000000ooK^0?ofkP0o0?ofkP80e3dI0`3om^h00`3D?AT0ooK^0?ofkP040?of
kPT0e3dI1`3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00P0ooK^0P3D?AT70?of
kP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h0=03om^h4000005d0ooK^0@3oool007`0
ooK^0P00001;0?ofkP030000003om^h0ooK^0400ooK^0P3D?AT30?ofkP030=@m6@3om^h0ooK^00H0
ooK^00<0e3dI0?ofkP3om^h02`3om^h20=@m6A00ooK^00<0e3dI0?ofkP3om^h01@3om^h20=@m6@X0
ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP0a0?ofkP@00000H@3om^h10?ooo`00
OP3om^h00`000000ooK^0?ofkP180?ofkP030000003om^h0ooK^0440ooK^0`3D?AT20?ofkP80e3dI
1`3om^h20=@m6@d0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP020?ofkP80e3dI
3@3om^h00`3D?AT0ooK^0?ofkP060?ofkP80e3dI<03om^h4000006D0ooK^0@3oool007l0ooK^0P00
00180?ofkP030000003om^h0ooK^0480ooK^00@0e3dI0?ofkP3D?AT0e3dI0P3om^h00`3D?AT0ooK^
0?ofkP060?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h03P3om^h0103D?AT0ooK^
0=@m6@3D?AT@0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h0;03om^h4000006T0
ooK^0@3oool00840ooK^00<000000?ofkP3om^h0A@3om^h00`000000ooK^0?ofkP130?ofkP030=@m
6@3om^h0ooK^0080e3dI00<0ooK^0=@m6@3om^h01`3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m
6@3om^h0ooK^00`0ooK^0`3D?ATC0?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h0
:@3om^h4000006d0ooK^0@3oool00880ooK^00<000000?ofkP3om^h0A03om^h00`000000ooK^0?of
kP140?ofkP80e3dI0P3om^h30=@m6@P0ooK^00<0e3dI0?ofkP3om^h02`3om^h20=@m6@P0ooK^103D
?AT30?ofkP030=@m6@3om^h0ooK^0140ooK^00@0e3dI0?ofkP3D?AT0e3dI:03om^h400000740ooK^
0@3oool008<0ooK^0P0000140?ofkP030000003om^h0ooK^04D0ooK^0P3D?AT30?ofkP@0e3dI1P3o
m^h20=@m6@d0ooK^00@0e3dI0?ofkP3om^h0ooK^103D?AT80?ofkP030=@m6@3om^h0ooK^0100ooK^
0P3D?ATV0?ofkP@00000M@3om^h10?ooo`00Q@3om^h00`000000ooK^0?ofkP110?ofkP030000003o
m^h0ooK^04L0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0=@m6@050=@m6@80ooK^00<0
e3dI0?ofkP3om^h01@3om^h90=@m6@d0ooK^00<0e3dI0?ofkP3om^h03@3om^h20=@m6B@0ooK^1000
001i0?ofkP40oooo00260?ofkP800000@@3om^h00`000000ooK^0?ofkP180?ofkP030=@m6@3om^h0
ooK^0080ooK^00<0e3dI0?ofkP3om^h0103om^h:0=@m6@L0ooK^00<0e3dI0?ofkP3om^h03@3om^h2
0=@m6@/0ooK^0P3D?ATR0?ofkP@00000O@3om^h10?ooo`00R03om^h00`000000ooK^0?ofkP0n0?of
kP030000003om^h0ooK^04T0ooK^0P3D?AT30?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?of
kP3om^h02`3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00H0ooK^0P3D?ATP0?of
kP@00000P@3om^h10?ooo`00R@3om^h2000003h0ooK^00<000000?ofkP3om^h0B`3om^h20=@m6@80
ooK^0P3D?AT80?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0
ooK^0?ofkP030?ofkP80e3dI7P3om^h4000008D0ooK^0@3oool008/0ooK^00<000000?ofkP3om^h0
>`3om^h00`000000ooK^0?ofkP1=0?ofkP80e3dI0P3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m
6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP020=@m6Ad0ooK^
0`0000290?ofkP40oooo002<0?ofkP800000>`3om^h00`000000ooK^0?ofkP1?0?ofkP80e3dI00<0
ooK^0=@m6@3om^h01`3om^h20=@m6@`0ooK^00<0e3dI0?ofkP3om^h03@3om^h30=@m6A/0ooK^1000
002<0?ofkP40oooo002>0?ofkP030000003om^h0ooK^03P0ooK^00<000000?ofkP3om^h0D@3om^h3
0=@m6@T0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP090?ofkP<0e3dI6P3om^h4
00000900ooK^0@3oool008l0ooK^0P00000h0?ofkP030000003om^h0ooK^05<0ooK^103D?AT70?of
kP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h0103om^h40=@m6AT0ooK^1000002D0?of
kP40oooo002A0?ofkP030000003om^h0ooK^03D0ooK^00<000000?ofkP3om^h0E`3om^h60=@m6@80
ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP030=@m6AT0ooK^1000002H0?ofkP40
oooo002B0?ofkP800000=@3om^h00`000000ooK^0?ofkP1M0?ofkQ80e3dI603om^h4000009`0ooK^
0@3oool009@0ooK^00<000000?ofkP3om^h0<P3om^h00`000000ooK^0?ofkP230?ofkP@00000X03o
m^h10?ooo`00U@3om^h00`000000ooK^0?ofkP0`0?ofkP030000003om^h0ooK^0800ooK^1000002T
0?ofkP40oooo002F0?ofkP800000<03om^h00`000000ooK^0?ofkP1l0?ofkP@00000Z03om^h10?oo
o`00V03om^h00`000000ooK^0?ofkP0]0?ofkP030000003om^h0ooK^07P0ooK^1000002/0?ofkP40
oooo002I0?ofkP800000;@3om^h00`000000ooK^0?ofkP1d0?ofkP@00000/03om^h10?ooo`00V`3o
m^h00`000000ooK^0?ofkP0Z0?ofkP030000003om^h0ooK^0700ooK^1000002d0?ofkP40oooo002L
0?ofkP800000:P3om^h00`000000ooK^0?ofkP1/0?ofkP@00000^03om^h10?ooo`00WP3om^h00`00
0000ooK^0?ofkP0W0?ofkP030000003om^h0ooK^06P0ooK^1000002l0?ofkP40oooo002O0?ofkP80
00009`3om^h00`000000ooK^0?ofkP1U0?ofkP<00000`03om^h10?ooo`00X@3om^h00`000000ooK^
0?ofkP0T0?ofkP030000003om^h0ooK^0640ooK^100000330?ofkP40oooo002R0?ofkP800000903o
m^h00`000000ooK^0?ofkP1M0?ofkP@00000a`3om^h10?ooo`00Y03om^h00`000000ooK^0?ofkP0Q
0?ofkP030000003om^h0ooK^05T0ooK^1000003;0?ofkP40oooo002U0?ofkP8000008@3om^h00`00
0000ooK^0?ofkP1E0?ofkP@00000c`3om^h10?ooo`00Y`3om^h00`000000ooK^0?ofkP0N0?ofkP03
0000003om^h0ooK^0540ooK^1000003C0?ofkP40oooo002X0?ofkP8000007P3om^h00`000000ooK^
0?ofkP1=0?ofkP@00000e`3om^h10?ooo`00ZP3om^h00`000000ooK^0?ofkP0K0?ofkP030000003o
m^h0ooK^04T0ooK^1000003K0?ofkP40oooo002[0?ofkP030000003om^h0ooK^01X0ooK^00<00000
0?ofkP3om^h0A@3om^h400000=l0ooK^0@3oool00:`0ooK^0P00000J0?ofkP030000003om^h0ooK^
0440ooK^1000003S0?ofkP40oooo002^0?ofkP030000003om^h0ooK^01L0ooK^00<000000?ofkP3o
m^h0?@3om^h400000>L0ooK^0@3oool00:l0ooK^0P00000G0?ofkP030000003om^h0ooK^03T0ooK^
1000003[0?ofkP40oooo002a0?ofkP030000003om^h0ooK^01@0ooK^00<000000?ofkP3om^h0=@3o
m^h400000>l0ooK^0@3oool00;80ooK^0P00000D0?ofkP030000003om^h0ooK^0380ooK^0`00003c
0?ofkP40oooo002d0?ofkP030000003om^h0ooK^0140ooK^00<000000?ofkP3om^h0;P3om^h40000
0?H0ooK^0@3oool00;D0ooK^0P00000A0?ofkP030000003om^h0ooK^02X0ooK^1000003j0?ofkP40
oooo002g0?ofkP030000003om^h0ooK^00d0ooK^00<000000?ofkP3om^h09`3om^h400000?h0ooK^
0@3oool00;P0ooK^0P00000=0?ofkP030000003om^h0ooK^02<0ooK^1000003o0?ofkP<0ooK^0@3o
ool00;X0ooK^00<000000?ofkP3om^h02P3om^h00`000000ooK^0?ofkP0O0?ofkP@00000o`3om^h7
0?ofkP40oooo002k0?ofkP8000002P3om^h00`000000ooK^0?ofkP0K0?ofkP@00000o`3om^h;0?of
kP40oooo002m0?ofkP030000003om^h0ooK^00L0ooK^00<000000?ofkP3om^h05`3om^h400000?l0
ooK^3`3om^h10?ooo`00_P3om^h00`000000ooK^0?ofkP060?ofkP030000003om^h0ooK^01<0ooK^
1000003o0?ofkQ<0ooK^0@3oool00;l0ooK^0P0000060?ofkP030000003om^h0ooK^00l0ooK^1000
003o0?ofkQL0ooK^0@3oool00<40ooK^00<000000?ofkP3om^h00`3om^h00`000000ooK^0?ofkP0;
0?ofkP@00000o`3om^hK0?ofkP40oooo00320?ofkP8000000`3om^h00`000000ooK^0?ofkP070?of
kP@00000o`3om^hO0?ofkP40oooo00340?ofkP040000003om^h0ooK^000000D0ooK^1000003o0?of
kR<0ooK^0@3oool00<D0ooK^0`0000000`3om^h000000000000200000?l0ooK^9`3om^h10?ooo`00
a`3om^h200000?l0ooK^:`3om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool0
0?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03o
m^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00
o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?of
kP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o
0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^
0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0
ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h1
0?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3o
m^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40
oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?of
k_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3o
ool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^
m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?oo
o`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd
0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo
003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0
ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool0
0?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03o
m^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00
o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?of
kP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o
0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^
0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo0000\
\>"],
  ImageRangeCache->{{{0, 499}, {499, 0}} -> {-5.00005*^-06, -5.00005*^-06, \
0.00200403, 0.00200403}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
%%ImageSize: 500 500 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics3D
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Background color
1 .961 .933 r
MFill
% Scaling calculations
0 1 0 1 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 0 r
.25 Mabswid
[ ] 0 setdash
.08947 .22236 m
.02925 .49223 L
s
.02925 .49223 m
.3022 .81857 L
s
.3022 .81857 m
.32128 .58361 L
s
.32128 .58361 m
.08947 .22236 L
s
.75972 .08168 m
.83139 .50547 L
s
.83139 .50547 m
.86955 .74993 L
s
.86955 .74993 m
.80207 .35868 L
s
.80207 .35868 m
.75972 .08168 L
s
.08947 .22236 m
.02925 .49223 L
s
.02925 .49223 m
.80207 .35868 L
s
.80207 .35868 m
.75972 .08168 L
s
.75972 .08168 m
.08947 .22236 L
s
.32128 .58361 m
.83139 .50547 L
s
.83139 .50547 m
.86955 .74993 L
s
.86955 .74993 m
.3022 .81857 L
s
.3022 .81857 m
.32128 .58361 L
s
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
.83 .24 .1 r
.5 Mabswid
.52744 .55588 m
.55225 .54761 L
s
.51851 .53577 m
.52744 .55588 L
s
.50435 .56818 m
.52744 .55588 L
s
.49499 .54826 m
.50435 .56818 L
s
.48382 .58405 m
.50435 .56818 L
s
.55225 .54761 m
.57783 .54369 L
s
.54374 .52733 m
.55225 .54761 L
s
.47407 .56436 m
.48382 .58405 L
s
.46666 .60293 m
.48382 .58405 L
s
.57783 .54369 m
.60325 .54431 L
s
.56975 .52327 m
.57783 .54369 L
s
.45655 .58347 m
.46666 .60293 L
s
.45358 .62415 m
.46666 .60293 L
s
.60325 .54431 m
.6275 .54952 L
s
.59557 .52378 m
.60325 .54431 L
s
.44317 .60493 m
.45358 .62415 L
s
.44518 .64691 m
.45358 .62415 L
s
.6275 .54952 m
.64963 .55922 L
s
.62021 .52894 m
.6275 .54952 L
s
.54374 .52733 m
.51851 .53577 L
s
.50925 .51493 m
.51851 .53577 L
s
.51851 .53577 m
.49499 .54826 L
s
.4853 .52763 m
.49499 .54826 L
s
.49499 .54826 m
.47407 .56436 L
s
.56975 .52327 m
.54374 .52733 L
s
.53492 .50631 m
.54374 .52733 L
s
.46397 .54395 m
.47407 .56436 L
s
.47407 .56436 m
.45655 .58347 L
s
.59557 .52378 m
.56975 .52327 L
s
.56137 .5021 m
.56975 .52327 L
s
.43452 .62794 m
.44518 .64691 L
s
.4419 .67035 m
.44518 .64691 L
s
.64963 .55922 m
.66866 .57313 L
s
.64267 .53862 m
.64963 .55922 L
s
.44608 .5633 m
.45655 .58347 L
s
.45655 .58347 m
.44317 .60493 L
s
.62021 .52894 m
.59557 .52378 L
s
.58762 .5025 m
.59557 .52378 L
s
.43237 .58501 m
.44317 .60493 L
s
.44317 .60493 m
.43452 .62794 L
s
.43108 .65162 m
.4419 .67035 L
s
.44405 .6935 m
.4419 .67035 L
s
.64267 .53862 m
.62021 .52894 L
s
.61265 .50759 m
.62021 .52894 L
s
.53492 .50631 m
.50925 .51493 L
s
.49964 .49333 m
.50925 .51493 L
s
.50925 .51493 m
.4853 .52763 L
s
.66866 .57313 m
.68373 .59079 L
s
.66199 .55258 m
.66866 .57313 L
s
.47525 .50624 m
.4853 .52763 L
s
.4853 .52763 m
.46397 .54395 L
s
.56137 .5021 m
.53492 .50631 L
s
.52578 .48451 m
.53492 .50631 L
s
.45349 .52279 m
.46397 .54395 L
s
.46397 .54395 m
.44608 .5633 L
s
.58762 .5025 m
.56137 .5021 L
s
.55269 .48015 m
.56137 .5021 L
s
.42346 .60827 m
.43452 .62794 L
s
.43452 .62794 m
.43108 .65162 L
s
.66199 .55258 m
.64267 .53862 L
s
.63546 .51727 m
.64267 .53862 L
s
.43521 .54239 m
.44608 .5633 L
s
.44608 .5633 m
.43237 .58501 L
s
.43314 .675 m
.44405 .6935 L
s
.45169 .71538 m
.44405 .6935 L
s
.61265 .50759 m
.58762 .5025 L
s
.57937 .48044 m
.58762 .5025 L
s
.68373 .59079 m
.69405 .61157 L
s
.67726 .57035 m
.68373 .59079 L
s
.42117 .56435 m
.43237 .58501 L
s
.43237 .58501 m
.42346 .60827 L
s
.41985 .63219 m
.43108 .65162 L
s
.43108 .65162 m
.43314 .675 L
s
.63546 .51727 m
.61265 .50759 L
s
.6048 .48545 m
.61265 .50759 L
s
.52578 .48451 m
.49964 .49333 L
s
.48968 .47091 m
.49964 .49333 L
s
.49964 .49333 m
.47525 .50624 L
s
.67726 .57035 m
.66199 .55258 L
s
.65506 .53126 m
.66199 .55258 L
s
.46482 .48405 m
.47525 .50624 L
s
.47525 .50624 m
.45349 .52279 L
s
.55269 .48015 m
.52578 .48451 L
s
.51629 .4619 m
.52578 .48451 L
s
.44081 .69708 m
.45169 .71538 L
s
.46468 .73497 m
.45169 .71538 L
s
.69405 .61157 m
.699 .63465 L
s
.6877 .59129 m
.69405 .61157 L
s
.44262 .50083 m
.45349 .52279 L
s
.45349 .52279 m
.43521 .54239 L
s
.57937 .48044 m
.55269 .48015 L
s
.54367 .45737 m
.55269 .48015 L
s
.41199 .58786 m
.42346 .60827 L
s
.42346 .60827 m
.41985 .63219 L
s
.65506 .53126 m
.63546 .51727 L
s
.62797 .4951 m
.63546 .51727 L
s
.42394 .52068 m
.43521 .54239 L
s
.43521 .54239 m
.42117 .56435 L
s
.42183 .6558 m
.43314 .675 L
s
.43314 .675 m
.44081 .69708 L
s
.24 .35 .67 r
.27308 .56888 m
.27 .54129 L
s
.27 .54129 m
.30589 .53554 L
s
.27 .54129 m
.26487 .51389 L
s
.83 .24 .1 r
.6048 .48545 m
.57937 .48044 L
s
.57081 .45753 m
.57937 .48044 L
s
.6877 .59129 m
.67726 .57035 L
s
.67054 .54912 m
.67726 .57035 L
s
.24 .35 .67 r
.26487 .51389 m
.30078 .50799 L
s
.26487 .51389 m
.25786 .48758 L
s
.274 .59574 m
.27308 .56888 L
s
.27308 .56888 m
.30907 .56326 L
s
.83 .24 .1 r
.45392 .71683 m
.46468 .73497 L
s
.48259 .75129 m
.46468 .73497 L
s
.699 .63465 m
.69267 .61457 L
s
.699 .63465 m
.69818 .65903 L
s
.24 .35 .67 r
.30907 .56326 m
.30589 .53554 L
s
.30589 .53554 m
.34213 .52974 L
s
.30589 .53554 m
.30078 .50799 L
s
.25786 .48758 m
.2939 .48153 L
s
.25786 .48758 m
.24917 .46327 L
s
.30078 .50799 m
.33704 .50204 L
s
.30078 .50799 m
.2939 .48153 L
s
.83 .24 .1 r
.42117 .56435 m
.41199 .58786 L
s
.40819 .61202 m
.41985 .63219 L
s
.41985 .63219 m
.42183 .6558 L
s
.24 .35 .67 r
.3102 .59022 m
.30907 .56326 L
s
.30907 .56326 m
.34541 .55758 L
s
.83 .24 .1 r
.62797 .4951 m
.6048 .48545 L
s
.59666 .46246 m
.6048 .48545 L
s
.51629 .4619 m
.48968 .47091 L
s
.47934 .44764 m
.48968 .47091 L
s
.48968 .47091 m
.46482 .48405 L
s
.24 .35 .67 r
.27268 .62095 m
.274 .59574 L
s
.274 .59574 m
.3102 .59022 L
s
.83 .24 .1 r
.67054 .54912 m
.65506 .53126 L
s
.64787 .50913 m
.65506 .53126 L
s
.46482 .48405 m
.44262 .50083 L
s
.54367 .45737 m
.51629 .4619 L
s
.50645 .43843 m
.51629 .4619 L
s
.24 .35 .67 r
.34541 .55758 m
.34213 .52974 L
s
.34213 .52974 m
.37874 .52387 L
s
.34213 .52974 m
.33704 .50204 L
s
.83 .24 .1 r
.42951 .67808 m
.44081 .69708 L
s
.44081 .69708 m
.45392 .71683 L
s
.24 .35 .67 r
.2939 .48153 m
.33031 .47541 L
s
.2939 .48153 m
.28547 .45704 L
s
.33704 .50204 m
.37368 .49603 L
s
.33704 .50204 m
.33031 .47541 L
s
.83 .24 .1 r
.69267 .61457 m
.6877 .59129 L
s
.6811 .57022 m
.6877 .59129 L
s
.44262 .50083 m
.42394 .52068 L
s
.24 .35 .67 r
.34677 .58464 m
.34541 .55758 L
s
.34541 .55758 m
.38213 .55184 L
s
.83 .24 .1 r
.47206 .73327 m
.48259 .75129 L
s
.50473 .76347 m
.48259 .75129 L
s
.57081 .45753 m
.54367 .45737 L
s
.53431 .43372 m
.54367 .45737 L
s
.24 .35 .67 r
.30921 .6155 m
.3102 .59022 L
s
.3102 .59022 m
.34677 .58464 L
s
.24917 .46327 m
.28547 .45704 L
s
.24917 .46327 m
.23906 .44185 L
s
.83 .24 .1 r
.69818 .65903 m
.69145 .6836 L
s
.69177 .63921 m
.69818 .65903 L
s
.24 .35 .67 r
.38213 .55184 m
.37874 .52387 L
s
.37874 .52387 m
.37368 .49603 L
s
.83 .24 .1 r
.41199 .58786 m
.40819 .61202 L
s
.24 .35 .67 r
.33031 .47541 m
.36709 .46924 L
s
.33031 .47541 m
.32213 .45075 L
s
.37368 .49603 m
.41068 .48996 L
s
.37368 .49603 m
.36709 .46924 L
s
.83 .24 .1 r
.64787 .50913 m
.62797 .4951 L
s
.6202 .47208 m
.62797 .4951 L
s
.24 .35 .67 r
.30921 .6155 m
.27268 .62095 L
s
.26911 .64356 m
.27268 .62095 L
s
.38371 .57901 m
.38213 .55184 L
s
.83 .24 .1 r
.41008 .63586 m
.42183 .6558 L
s
.42183 .6558 m
.42951 .67808 L
s
.24 .35 .67 r
.34612 .61 m
.34677 .58464 L
s
.34677 .58464 m
.38371 .57901 L
s
.83 .24 .1 r
.59666 .46246 m
.57081 .45753 L
s
.56192 .43375 m
.57081 .45753 L
s
.24 .35 .67 r
.28547 .45704 m
.32213 .45075 L
s
.28547 .45704 m
.27572 .43545 L
s
.83 .24 .1 r
.6811 .57022 m
.67054 .54912 L
s
.66357 .52708 m
.67054 .54912 L
s
1 .318 .13 r
.41652 .50795 m .42129 .5171 L .41331 .54012 L p F P
0 0 0 r
s
1 .318 .13 r
.41331 .54012 m .40799 .53023 L .41652 .50795 L p F P
0 0 0 r
s
.24 .35 .67 r
.37874 .52387 m
.41249 .51847 L
s
1 .312 .126 r
.40799 .53023 m .41331 .54012 L .40724 .5623 L p F P
0 0 0 r
s
.227 .321 .635 r
.42516 .55954 m .40724 .5623 L .41331 .54012 L p F P
0 0 0 r
s
.83 .24 .1 r
.40954 .5429 m
.4122 .5478 L
s
.41907 .56048 m
.42117 .56435 L
s
.24 .35 .67 r
.38213 .55184 m
.40758 .54787 L
s
.83 .24 .1 r
.4219 .52382 m
.42394 .52068 L
s
.227 .321 .635 r
.41331 .54012 m .43007 .53748 L .42516 .55954 L p F P
0 0 0 r
s
.24 .35 .67 r
.41084 .54736 m
.41922 .54605 L
s
.238 .338 .668 r
.43007 .53748 m .41331 .54012 L .42129 .5171 L p F P
0 0 0 r
s
.83 .24 .1 r
.40954 .5429 m
.41925 .52792 L
s
1 .321 .132 r
.42693 .48547 m .43103 .49365 L .42129 .5171 L p F P
0 0 0 r
s
1 .321 .132 r
.42129 .5171 m .41652 .50795 L .42693 .48547 L p F P
0 0 0 r
s
.238 .338 .668 r
.42129 .5171 m .43651 .51466 L .43007 .53748 L p F P
0 0 0 r
s
.247 .353 .697 r
.43651 .51466 m .42129 .5171 L .43103 .49365 L p F P
0 0 0 r
s
.24 .35 .67 r
.41687 .52713 m
.41922 .54605 L
s
.41068 .48996 m
.41476 .51256 L
s
.36709 .46924 m
.40424 .463 L
s
.36709 .46924 m
.35918 .4444 L
s
.41068 .48996 m
.42602 .48744 L
s
.41068 .48996 m
.40424 .463 L
s
.83 .24 .1 r
.44275 .698 m
.45392 .71683 L
s
.45392 .71683 m
.47206 .73327 L
s
.238 .338 .668 r
.4469 .53484 m .43007 .53748 L .43651 .51466 L p F P
0 0 0 r
s
.238 .338 .668 r
.43651 .51466 m .45181 .51221 L .4469 .53484 L p F P
0 0 0 r
s
.247 .353 .697 r
.45181 .51221 m .43651 .51466 L .44439 .49147 L p F P
0 0 0 r
s
.247 .353 .697 r
.43103 .49365 m .44439 .49147 L .43651 .51466 L p F P
0 0 0 r
s
.227 .321 .635 r
.44317 .55676 m .42516 .55954 L .43007 .53748 L p F P
0 0 0 r
s
.227 .321 .635 r
.43007 .53748 m .4469 .53484 L .44317 .55676 L p F P
0 0 0 r
s
.83 .24 .1 r
.49453 .74552 m
.50473 .76347 L
s
.53016 .77082 m
.50473 .76347 L
s
1 .312 .126 r
.40724 .5623 m .40149 .55191 L .40799 .53023 L p F P
0 0 0 r
s
1 .3 .12 r
.40149 .55191 m .40724 .5623 L .4032 .58325 L p F P
0 0 0 r
s
.216 .302 .599 r
.42189 .58042 m .4032 .58325 L .40724 .5623 L p F P
0 0 0 r
s
.83 .24 .1 r
.40892 .58239 m
.41199 .58786 L
s
.216 .302 .599 r
.40724 .5623 m .42516 .55954 L .42189 .58042 L p F P
0 0 0 r
s
1 .321 .133 r
.43903 .46321 m .44239 .47016 L .43103 .49365 L p F P
0 0 0 r
s
1 .321 .133 r
.43103 .49365 m .42693 .48547 L .43903 .46321 L p F P
0 0 0 r
s
.255 .368 .725 r
.44439 .49147 m .43103 .49365 L .44239 .47016 L p F P
0 0 0 r
s
.24 .35 .67 r
.34612 .61 m
.30921 .6155 L
s
.30608 .63817 m
.30921 .6155 L
s
.41922 .54605 m
.42103 .57332 L
s
.83 .24 .1 r
.69267 .61457 m
.6861 .59372 L
s
.69177 .63921 m
.69267 .61457 L
s
.24 .35 .67 r
.3834 .60445 m
.38371 .57901 L
s
.4042 .57589 m
.42103 .57332 L
s
.38371 .57901 m
.40281 .5761 L
s
.83 .24 .1 r
.69145 .6836 m
.67899 .70718 L
s
.68485 .66408 m
.69145 .6836 L
s
.238 .338 .668 r
.46381 .53218 m .4469 .53484 L .45181 .51221 L p F P
0 0 0 r
s
.238 .338 .668 r
.45181 .51221 m .46716 .50975 L .46381 .53218 L p F P
0 0 0 r
s
.247 .353 .697 r
.46716 .50975 m .45181 .51221 L .4578 .48928 L p F P
0 0 0 r
s
.247 .353 .697 r
.44439 .49147 m .4578 .48928 L .45181 .51221 L p F P
0 0 0 r
s
.24 .35 .67 r
.42046 .51719 m
.45309 .51197 L
s
.255 .368 .725 r
.4578 .48928 m .44439 .49147 L .45356 .4683 L p F P
0 0 0 r
s
.255 .368 .725 r
.44239 .47016 m .45356 .4683 L .44439 .49147 L p F P
0 0 0 r
s
.24 .35 .67 r
.43376 .48617 m
.44807 .48382 L
s
.32213 .45075 m
.35918 .4444 L
s
.32213 .45075 m
.31276 .42897 L
s
.227 .321 .635 r
.46126 .55397 m .44317 .55676 L .4469 .53484 L p F P
0 0 0 r
s
.227 .321 .635 r
.4469 .53484 m .46381 .53218 L .46126 .55397 L p F P
0 0 0 r
s
.24 .35 .67 r
.41922 .54605 m
.45669 .54019 L
s
.216 .302 .599 r
.44068 .57757 m .42189 .58042 L .42516 .55954 L p F P
0 0 0 r
s
.216 .302 .599 r
.42516 .55954 m .44317 .55676 L .44068 .57757 L p F P
0 0 0 r
s
.24 .35 .67 r
.45309 .51197 m
.45669 .54019 L
s
.44807 .48382 m
.45309 .51197 L
s
.23906 .44185 m
.27572 .43545 L
s
.23906 .44185 m
.22786 .4242 L
s
.247 .353 .697 r
.4578 .48928 m .47125 .48708 L .46716 .50975 L p F P
0 0 0 r
s
.255 .368 .725 r
.47125 .48708 m .4578 .48928 L .46477 .46644 L p F P
0 0 0 r
s
.255 .368 .725 r
.45356 .4683 m .46477 .46644 L .4578 .48928 L p F P
0 0 0 r
s
.238 .338 .668 r
.4808 .52951 m .46381 .53218 L .46716 .50975 L p F P
0 0 0 r
s
.238 .338 .668 r
.46716 .50975 m .48258 .50728 L .4808 .52951 L p F P
0 0 0 r
s
.247 .353 .697 r
.48258 .50728 m .46716 .50975 L .47125 .48708 L p F P
0 0 0 r
s
.24 .35 .67 r
.40424 .463 m
.3966 .43798 L
s
.83 .24 .1 r
.6202 .47208 m
.59666 .46246 L
s
.227 .321 .635 r
.47945 .55116 m .46126 .55397 L .46381 .53218 L p F P
0 0 0 r
s
.227 .321 .635 r
.46381 .53218 m .4808 .52951 L .47945 .55116 L p F P
0 0 0 r
s
.83 .24 .1 r
.50645 .43843 m
.47934 .44764 L
s
.202 .28 .556 r
.42034 .59975 m .40129 .60259 L .4032 .58325 L p F P
0 0 0 r
s
.202 .28 .556 r
.4032 .58325 m .42189 .58042 L .42034 .59975 L p F P
0 0 0 r
s
1 .3 .12 r
.4032 .58325 m .39716 .57261 L .40149 .55191 L p F P
0 0 0 r
s
.996 .278 .11 r
.39716 .57261 m .4032 .58325 L .40129 .60259 L p F P
0 0 0 r
s
1 .318 .133 r
.45263 .44156 m .45518 .44706 L .44239 .47016 L p F P
0 0 0 r
s
1 .318 .133 r
.44239 .47016 m .43903 .46321 L .45263 .44156 L p F P
0 0 0 r
s
.24 .35 .67 r
.44178 .45669 m
.44214 .45826 L
s
.263 .382 .752 r
.45356 .4683 m .44239 .47016 L .45518 .44706 L p F P
0 0 0 r
s
.24 .35 .67 r
.44358 .46449 m
.44807 .48382 L
s
.83 .24 .1 r
.4541 .46124 m
.45714 .46771 L
s
.45413 .46093 m
.47934 .44764 L
s
.216 .302 .599 r
.45956 .57471 m .44068 .57757 L .44317 .55676 L p F P
0 0 0 r
s
.216 .302 .599 r
.44317 .55676 m .46126 .55397 L .45956 .57471 L p F P
0 0 0 r
s
.24 .35 .67 r
.3834 .60445 m
.34612 .61 L
s
.34342 .63272 m
.34612 .61 L
s
.45669 .54019 m
.45874 .56757 L
s
.83 .24 .1 r
.66357 .52708 m
.64787 .50913 L
s
.6404 .48613 m
.64787 .50913 L
s
1 .321 .132 r
.42277 .47719 m .42693 .48547 L .41652 .50795 L p F P
0 0 0 r
s
1 .321 .132 r
.41652 .50795 m .41169 .49865 L .42277 .47719 L p F P
0 0 0 r
s
1 .318 .13 r
.41169 .49865 m .41652 .50795 L .40799 .53023 L p F P
0 0 0 r
s
.247 .353 .697 r
.47125 .48708 m .48476 .48488 L .48258 .50728 L p F P
0 0 0 r
s
.255 .368 .725 r
.48476 .48488 m .47125 .48708 L .47601 .46458 L p F P
0 0 0 r
s
.255 .368 .725 r
.46477 .46644 m .47601 .46458 L .47125 .48708 L p F P
0 0 0 r
s
.238 .338 .668 r
.49787 .52683 m .4808 .52951 L .48258 .50728 L p F P
0 0 0 r
s
.238 .338 .668 r
.48258 .50728 m .49807 .5048 L .49787 .52683 L p F P
0 0 0 r
s
.247 .353 .697 r
.49807 .5048 m .48258 .50728 L .48476 .48488 L p F P
0 0 0 r
s
.24 .35 .67 r
.45309 .51197 m
.49083 .50592 L
s
.83 .24 .1 r
.53431 .43372 m
.50645 .43843 L
s
.24 .35 .67 r
.42103 .57332 m
.45874 .56757 L
s
1 .318 .13 r
.40799 .53023 m .40258 .52016 L .41169 .49865 L p F P
0 0 0 r
s
1 .312 .126 r
.40258 .52016 m .40799 .53023 L .40149 .55191 L p F P
0 0 0 r
s
.263 .382 .752 r
.46477 .46644 m .45356 .4683 L .46389 .44559 L p F P
0 0 0 r
s
.263 .382 .752 r
.45518 .44706 m .46389 .44559 L .45356 .4683 L p F P
0 0 0 r
s
.227 .321 .635 r
.49772 .54834 m .47945 .55116 L .4808 .52951 L p F P
0 0 0 r
s
.227 .321 .635 r
.4808 .52951 m .49787 .52683 L .49772 .54834 L p F P
0 0 0 r
s
.24 .35 .67 r
.45669 .54019 m
.49455 .53428 L
s
1 .321 .133 r
.43564 .45617 m .43903 .46321 L .42693 .48547 L p F P
0 0 0 r
s
.24 .35 .67 r
.43633 .45761 m
.44178 .45669 L
s
1 .321 .133 r
.42693 .48547 m .42277 .47719 L .43564 .45617 L p F P
0 0 0 r
s
.83 .24 .1 r
.43133 .47804 m
.43569 .48683 L
s
.24 .35 .67 r
.40424 .463 m
.43458 .4579 L
s
.83 .24 .1 r
.43133 .47804 m
.44752 .46587 L
s
.41777 .65834 m
.42951 .67808 L
s
.42951 .67808 m
.44275 .698 L
s
.24 .35 .67 r
.35918 .4444 m
.3966 .43798 L
s
.35918 .4444 m
.35019 .42243 L
s
.26334 .66268 m
.26911 .64356 L
s
.26911 .64356 m
.30608 .63817 L
s
.247 .353 .697 r
.48476 .48488 m .49831 .48267 L .49807 .5048 L p F P
0 0 0 r
s
.255 .368 .725 r
.49831 .48267 m .48476 .48488 L .48728 .4627 L p F P
0 0 0 r
s
.255 .368 .725 r
.47601 .46458 m .48728 .4627 L .48476 .48488 L p F P
0 0 0 r
s
.24 .35 .67 r
.44807 .48382 m
.48583 .47763 L
s
.216 .302 .599 r
.47854 .57184 m .45956 .57471 L .46126 .55397 L p F P
0 0 0 r
s
.216 .302 .599 r
.46126 .55397 m .47945 .55116 L .47854 .57184 L p F P
0 0 0 r
s
.202 .28 .556 r
.4395 .5969 m .42034 .59975 L .42189 .58042 L p F P
0 0 0 r
s
.202 .28 .556 r
.42189 .58042 m .44068 .57757 L .4395 .5969 L p F P
0 0 0 r
s
.83 .24 .1 r
.52037 .75287 m
.53016 .77082 L
s
.55768 .77285 m
.53016 .77082 L
s
.24 .35 .67 r
.49083 .50592 m
.49455 .53428 L
s
.263 .382 .752 r
.47601 .46458 m .46477 .46644 L .47261 .44412 L p F P
0 0 0 r
s
.263 .382 .752 r
.46389 .44559 m .47261 .44412 L .46477 .46644 L p F P
0 0 0 r
s
.238 .338 .668 r
.51502 .52413 m .49787 .52683 L .49807 .5048 L p F P
0 0 0 r
s
.238 .338 .668 r
.49807 .5048 m .51362 .50231 L .51502 .52413 L p F P
0 0 0 r
s
.247 .353 .697 r
.51362 .50231 m .49807 .5048 L .49831 .48267 L p F P
0 0 0 r
s
.24 .35 .67 r
.27572 .43545 m
.31276 .42897 L
s
.27572 .43545 m
.26498 .41761 L
s
.83 .24 .1 r
.6861 .59372 m
.6811 .57022 L
s
.67425 .54833 m
.6811 .57022 L
s
.67899 .70718 m
.66127 .72857 L
s
.67209 .68796 m
.67899 .70718 L
s
.24 .35 .67 r
.44178 .45669 m
.44328 .45644 L
s
.227 .321 .635 r
.51609 .54551 m .49772 .54834 L .49787 .52683 L p F P
0 0 0 r
s
.227 .321 .635 r
.49787 .52683 m .51502 .52413 L .51609 .54551 L p F P
0 0 0 r
s
.247 .353 .697 r
.49831 .48267 m .51192 .48045 L .51362 .50231 L p F P
0 0 0 r
s
.255 .368 .725 r
.51192 .48045 m .49831 .48267 L .49859 .46083 L p F P
0 0 0 r
s
.255 .368 .725 r
.48728 .4627 m .49859 .46083 L .49831 .48267 L p F P
0 0 0 r
s
.24 .35 .67 r
.48583 .47763 m
.49083 .50592 L
s
1 .312 .126 r
.40149 .55191 m .39564 .54133 L .40258 .52016 L p F P
0 0 0 r
s
1 .3 .12 r
.39564 .54133 m .40149 .55191 L .39716 .57261 L p F P
0 0 0 r
s
.83 .24 .1 r
.40008 .56666 m
.40954 .5429 L
s
.263 .382 .752 r
.48728 .4627 m .47601 .46458 L .48135 .44264 L p F P
0 0 0 r
s
.263 .382 .752 r
.47261 .44412 m .48135 .44264 L .47601 .46458 L p F P
0 0 0 r
s
.83 .24 .1 r
.46112 .71456 m
.47206 .73327 L
s
.47206 .73327 m
.49453 .74552 L
s
.56192 .43375 m
.53431 .43372 L
s
.216 .302 .599 r
.49762 .56895 m .47854 .57184 L .47945 .55116 L p F P
0 0 0 r
s
.216 .302 .599 r
.47945 .55116 m .49772 .54834 L .49762 .56895 L p F P
0 0 0 r
s
.202 .28 .556 r
.45876 .59403 m .4395 .5969 L .44068 .57757 L p F P
0 0 0 r
s
.202 .28 .556 r
.44068 .57757 m .45956 .57471 L .45876 .59403 L p F P
0 0 0 r
s
.238 .338 .668 r
.53225 .52142 m .51502 .52413 L .51362 .50231 L p F P
0 0 0 r
s
.238 .338 .668 r
.51362 .50231 m .52924 .49981 L .53225 .52142 L p F P
0 0 0 r
s
.247 .353 .697 r
.52924 .49981 m .51362 .50231 L .51192 .48045 L p F P
0 0 0 r
s
.24 .35 .67 r
.49083 .50592 m
.52897 .49981 L
s
.38116 .62721 m
.3834 .60445 L
s
.49455 .53428 m
.49683 .56176 L
s
1 .318 .133 r
.45006 .436 m .45263 .44156 L .43903 .46321 L p F P
0 0 0 r
s
1 .318 .133 r
.43903 .46321 m .43564 .45617 L .45006 .436 L p F P
0 0 0 r
s
.24 .35 .67 r
.44936 .45542 m
.4797 .45032 L
s
.263 .382 .752 r
.49859 .46083 m .48728 .4627 L .49012 .44116 L p F P
0 0 0 r
s
.263 .382 .752 r
.48135 .44264 m .49012 .44116 L .48728 .4627 L p F P
0 0 0 r
s
.24 .35 .67 r
.4797 .45032 m
.48583 .47763 L
s
.247 .353 .697 r
.51192 .48045 m .52557 .47822 L .52924 .49981 L p F P
0 0 0 r
s
.255 .368 .725 r
.52557 .47822 m .51192 .48045 L .50993 .45894 L p F P
0 0 0 r
s
.255 .368 .725 r
.49859 .46083 m .50993 .45894 L .51192 .48045 L p F P
0 0 0 r
s
.24 .35 .67 r
.45874 .56757 m
.49683 .56176 L
s
.83 .24 .1 r
.68485 .66408 m
.69177 .63921 L
s
.68511 .61862 m
.69177 .63921 L
s
.227 .321 .635 r
.53454 .54266 m .51609 .54551 L .51502 .52413 L p F P
0 0 0 r
s
.227 .321 .635 r
.51502 .52413 m .53225 .52142 L .53454 .54266 L p F P
0 0 0 r
s
.996 .278 .11 r
.40129 .60259 m .39511 .59192 L .39716 .57261 L p F P
0 0 0 r
s
.83 .24 .1 r
.40008 .56666 m
.4055 .5763 L
s
.888 .244 .094 r
.39511 .59192 m .40129 .60259 L .40159 .61991 L p F P
0 0 0 r
s
.24 .35 .67 r
.3834 .60445 m
.39752 .60234 L
s
.186 .253 .503 r
.42059 .61713 m .40159 .61991 L .40129 .60259 L p F P
0 0 0 r
s
.83 .24 .1 r
.40873 .61886 m
.41008 .63586 L
s
.186 .253 .503 r
.40129 .60259 m .42034 .59975 L .42059 .61713 L p F P
0 0 0 r
s
1 .314 .132 r
.4675 .42094 m .46921 .42478 L .45518 .44706 L p F P
0 0 0 r
s
1 .314 .132 r
.45518 .44706 m .45263 .44156 L .4675 .42094 L p F P
0 0 0 r
s
.271 .395 .778 r
.46389 .44559 m .45518 .44706 L .46921 .42478 L p F P
0 0 0 r
s
.238 .338 .668 r
.54955 .5187 m .53225 .52142 L .52924 .49981 L p F P
0 0 0 r
s
.238 .338 .668 r
.52924 .49981 m .54492 .4973 L .54955 .5187 L p F P
0 0 0 r
s
.247 .353 .697 r
.54492 .4973 m .52924 .49981 L .52557 .47822 L p F P
0 0 0 r
s
.24 .35 .67 r
.3966 .43798 m
.388 .41582 L
s
.216 .302 .599 r
.5168 .56604 m .49762 .56895 L .49772 .54834 L p F P
0 0 0 r
s
.216 .302 .599 r
.49772 .54834 m .51609 .54551 L .5168 .56604 L p F P
0 0 0 r
s
.24 .35 .67 r
.30083 .6573 m
.30608 .63817 L
s
.30608 .63817 m
.34342 .63272 L
s
.263 .382 .752 r
.50993 .45894 m .49859 .46083 L .49891 .43968 L p F P
0 0 0 r
s
.263 .382 .752 r
.49012 .44116 m .49891 .43968 L .49859 .46083 L p F P
0 0 0 r
s
.202 .28 .556 r
.47811 .59115 m .45876 .59403 L .45956 .57471 L p F P
0 0 0 r
s
.202 .28 .556 r
.45956 .57471 m .47854 .57184 L .47811 .59115 L p F P
0 0 0 r
s
.247 .353 .697 r
.52557 .47822 m .53927 .47599 L .54492 .4973 L p F P
0 0 0 r
s
.255 .368 .725 r
.53927 .47599 m .52557 .47822 L .52131 .45705 L p F P
0 0 0 r
s
.255 .368 .725 r
.50993 .45894 m .52131 .45705 L .52557 .47822 L p F P
0 0 0 r
s
.24 .35 .67 r
.48583 .47763 m
.52399 .47136 L
s
.52399 .47136 m
.52897 .49981 L
s
1 .321 .132 r
.41856 .46878 m .42277 .47719 L .41169 .49865 L p F P
0 0 0 r
s
1 .321 .132 r
.41169 .49865 m .40677 .4892 L .41856 .46878 L p F P
0 0 0 r
s
.83 .24 .1 r
.41223 .49814 m
.42247 .51787 L
s
.41223 .49814 m
.43133 .47804 L
s
1 .318 .13 r
.40677 .4892 m .41169 .49865 L .40258 .52016 L p F P
0 0 0 r
s
.271 .395 .778 r
.47261 .44412 m .46389 .44559 L .4752 .42375 L p F P
0 0 0 r
s
.271 .395 .778 r
.46921 .42478 m .4752 .42375 L .46389 .44559 L p F P
0 0 0 r
s
.24 .35 .67 r
.31276 .42897 m
.35019 .42243 L
s
.31276 .42897 m
.30249 .41095 L
s
1 .321 .133 r
.4322 .44906 m .43564 .45617 L .42277 .47719 L p F P
0 0 0 r
s
1 .321 .133 r
.42277 .47719 m .41856 .46878 L .4322 .44906 L p F P
0 0 0 r
s
.227 .321 .635 r
.55309 .5398 m .53454 .54266 L .53225 .52142 L p F P
0 0 0 r
s
.227 .321 .635 r
.53225 .52142 m .54955 .5187 L .55309 .5398 L p F P
0 0 0 r
s
.24 .35 .67 r
.49455 .53428 m
.53279 .5283 L
s
.52897 .49981 m
.53279 .5283 L
s
.83 .24 .1 r
.54838 .75484 m
.55768 .77285 L
s
.58596 .76938 m
.55768 .77285 L
s
.263 .382 .752 r
.52131 .45705 m .50993 .45894 L .50771 .43819 L p F P
0 0 0 r
s
.263 .382 .752 r
.49891 .43968 m .50771 .43819 L .50993 .45894 L p F P
0 0 0 r
s
.238 .338 .668 r
.56694 .51597 m .54955 .5187 L .54492 .4973 L p F P
0 0 0 r
s
.238 .338 .668 r
.54492 .4973 m .56067 .49478 L .56694 .51597 L p F P
0 0 0 r
s
.247 .353 .697 r
.56067 .49478 m .54492 .4973 L .53927 .47599 L p F P
0 0 0 r
s
.271 .395 .778 r
.48135 .44264 m .47261 .44412 L .4812 .42272 L p F P
0 0 0 r
s
.271 .395 .778 r
.4752 .42375 m .4812 .42272 L .47261 .44412 L p F P
0 0 0 r
s
.24 .35 .67 r
.47262 .42494 m
.4797 .45032 L
s
1 .3 .12 r
.39716 .57261 m .391 .56176 L .39564 .54133 L p F P
0 0 0 r
s
.996 .278 .11 r
.391 .56176 m .39716 .57261 L .39511 .59192 L p F P
0 0 0 r
s
.83 .24 .1 r
.39608 .59107 m
.40008 .56666 L
s
.66127 .72857 m
.6391 .74666 L
s
.65399 .70967 m
.66127 .72857 L
s
.41008 .63586 m
.41777 .65834 L
s
.186 .253 .503 r
.43968 .61433 m .42059 .61713 L .42034 .59975 L p F P
0 0 0 r
s
.186 .253 .503 r
.42034 .59975 m .4395 .5969 L .43968 .61433 L p F P
0 0 0 r
s
.24 .35 .67 r
.40086 .60185 m
.42107 .59883 L
s
.42103 .57332 m
.42107 .59883 L
s
.247 .353 .697 r
.53927 .47599 m .55303 .47374 L .56067 .49478 L p F P
0 0 0 r
s
.255 .368 .725 r
.55303 .47374 m .53927 .47599 L .53273 .45516 L p F P
0 0 0 r
s
.255 .368 .725 r
.52131 .45705 m .53273 .45516 L .53927 .47599 L p F P
0 0 0 r
s
1 .318 .13 r
.40258 .52016 m .39708 .50992 L .40677 .4892 L p F P
0 0 0 r
s
1 .312 .126 r
.39708 .50992 m .40258 .52016 L .39564 .54133 L p F P
0 0 0 r
s
.83 .24 .1 r
.39746 .52061 m
.40954 .5429 L
s
.216 .302 .599 r
.53608 .56312 m .5168 .56604 L .51609 .54551 L p F P
0 0 0 r
s
.216 .302 .599 r
.51609 .54551 m .53454 .54266 L .53608 .56312 L p F P
0 0 0 r
s
.202 .28 .556 r
.49757 .58825 m .47811 .59115 L .47854 .57184 L p F P
0 0 0 r
s
.202 .28 .556 r
.47854 .57184 m .49762 .56895 L .49757 .58825 L p F P
0 0 0 r
s
.263 .382 .752 r
.53273 .45516 m .52131 .45705 L .51654 .4367 L p F P
0 0 0 r
s
.263 .382 .752 r
.50771 .43819 m .51654 .4367 L .52131 .45705 L p F P
0 0 0 r
s
.271 .395 .778 r
.49012 .44116 m .48135 .44264 L .4872 .42169 L p F P
0 0 0 r
s
.271 .395 .778 r
.4812 .42272 m .4872 .42169 L .48135 .44264 L p F P
0 0 0 r
s
.227 .321 .635 r
.57173 .53692 m .55309 .5398 L .54955 .5187 L p F P
0 0 0 r
s
.227 .321 .635 r
.54955 .5187 m .56694 .51597 L .57173 .53692 L p F P
0 0 0 r
s
1 .318 .133 r
.44746 .4304 m .45006 .436 L .43564 .45617 L p F P
0 0 0 r
s
1 .318 .133 r
.43564 .45617 m .4322 .44906 L .44746 .4304 L p F P
0 0 0 r
s
.24 .35 .67 r
.43442 .43149 m
.43761 .44244 L
s
.3966 .43798 m
.43442 .43149 L
s
.238 .338 .668 r
.58441 .51322 m .56694 .51597 L .56067 .49478 L p F P
0 0 0 r
s
.238 .338 .668 r
.56067 .49478 m .57648 .49224 L .58441 .51322 L p F P
0 0 0 r
s
.247 .353 .697 r
.57648 .49224 m .56067 .49478 L .55303 .47374 L p F P
0 0 0 r
s
.24 .35 .67 r
.52897 .49981 m
.5675 .49364 L
s
1 .314 .132 r
.46578 .41707 m .4675 .42094 L .45263 .44156 L p F P
0 0 0 r
s
1 .314 .132 r
.45263 .44156 m .45006 .436 L .46578 .41707 L p F P
0 0 0 r
s
.247 .353 .697 r
.55303 .47374 m .56683 .47149 L .57648 .49224 L p F P
0 0 0 r
s
.255 .368 .725 r
.56683 .47149 m .55303 .47374 L .54417 .45326 L p F P
0 0 0 r
s
.255 .368 .725 r
.53273 .45516 m .54417 .45326 L .55303 .47374 L p F P
0 0 0 r
s
.83 .24 .1 r
.67425 .54833 m
.66357 .52708 L
s
.271 .395 .778 r
.49891 .43968 m .49012 .44116 L .49322 .42066 L p F P
0 0 0 r
s
.271 .395 .778 r
.4872 .42169 m .49322 .42066 L .49012 .44116 L p F P
0 0 0 r
s
.263 .382 .752 r
.54417 .45326 m .53273 .45516 L .52539 .4352 L p F P
0 0 0 r
s
.263 .382 .752 r
.51654 .4367 m .52539 .4352 L .53273 .45516 L p F P
0 0 0 r
s
.24 .35 .67 r
.51802 .44389 m
.52399 .47136 L
s
.4797 .45032 m
.51802 .44389 L
s
.22786 .4242 m
.26498 .41761 L
s
.22786 .4242 m
.21593 .41113 L
s
.186 .253 .503 r
.45888 .61151 m .43968 .61433 L .4395 .5969 L p F P
0 0 0 r
s
.186 .253 .503 r
.4395 .5969 m .45876 .59403 L .45888 .61151 L p F P
0 0 0 r
s
.216 .302 .599 r
.55545 .56018 m .53608 .56312 L .53454 .54266 L p F P
0 0 0 r
s
.216 .302 .599 r
.53454 .54266 m .55309 .5398 L .55545 .56018 L p F P
0 0 0 r
s
.24 .35 .67 r
.53279 .5283 m
.53532 .55589 L
s
.49683 .56176 m
.53532 .55589 L
s
.46596 .42608 m
.47262 .42494 L
s
.43442 .43149 m
.45702 .42762 L
s
.83 .24 .1 r
.57718 .75122 m
.58596 .76938 L
s
.61357 .7605 m
.58596 .76938 L
s
.24 .35 .67 r
.33871 .65187 m
.34342 .63272 L
s
.34342 .63272 m
.38116 .62721 L
s
.202 .28 .556 r
.51714 .58533 m .49757 .58825 L .49762 .56895 L p F P
0 0 0 r
s
.202 .28 .556 r
.49762 .56895 m .5168 .56604 L .51714 .58533 L p F P
0 0 0 r
s
.83 .24 .1 r
.6391 .74666 m
.61357 .7605 L
s
.63136 .72805 m
.6391 .74666 L
s
.271 .395 .778 r
.50771 .43819 m .49891 .43968 L .49925 .41963 L p F P
0 0 0 r
s
.271 .395 .778 r
.49322 .42066 m .49925 .41963 L .49891 .43968 L p F P
0 0 0 r
s
.83 .24 .1 r
.4969 .41566 m
.4986 .41974 L
s
.43113 .67842 m
.44275 .698 L
s
.44275 .698 m
.46112 .71456 L
s
.227 .321 .635 r
.59047 .53403 m .57173 .53692 L .56694 .51597 L p F P
0 0 0 r
s
.227 .321 .635 r
.56694 .51597 m .58441 .51322 L .59047 .53403 L p F P
0 0 0 r
s
.24 .35 .67 r
.53279 .5283 m
.57143 .52226 L
s
.5675 .49364 m
.57143 .52226 L
s
.247 .353 .697 r
.59236 .4897 m .57648 .49224 L .56683 .47149 L p F P
0 0 0 r
s
.247 .353 .697 r
.56683 .47149 m .58069 .46923 L .59236 .4897 L p F P
0 0 0 r
s
.255 .368 .725 r
.58069 .46923 m .56683 .47149 L .55566 .45135 L p F P
0 0 0 r
s
.255 .368 .725 r
.54417 .45326 m .55566 .45135 L .56683 .47149 L p F P
0 0 0 r
s
.24 .35 .67 r
.52399 .47136 m
.56254 .46504 L
s
.56254 .46504 m
.5675 .49364 L
s
1 .312 .126 r
.39564 .54133 m .38967 .53055 L .39708 .50992 L p F P
0 0 0 r
s
1 .3 .12 r
.38967 .53055 m .39564 .54133 L .391 .56176 L p F P
0 0 0 r
s
.238 .338 .668 r
.60196 .51046 m .58441 .51322 L .57648 .49224 L p F P
0 0 0 r
s
.238 .338 .668 r
.57648 .49224 m .59236 .4897 L .60196 .51046 L p F P
0 0 0 r
s
.24 .35 .67 r
.35019 .42243 m
.388 .41582 L
s
.35019 .42243 m
.3404 .40422 L
s
.263 .382 .752 r
.55566 .45135 m .54417 .45326 L .53426 .4337 L p F P
0 0 0 r
s
.263 .382 .752 r
.52539 .4352 m .53426 .4337 L .54417 .45326 L p F P
0 0 0 r
s
.83 .24 .1 r
.60532 .74214 m
.61357 .7605 L
s
.48393 .72687 m
.49453 .74552 L
s
.49453 .74552 m
.52037 .75287 L
s
.271 .395 .778 r
.51654 .4367 m .50771 .43819 L .50529 .41859 L p F P
0 0 0 r
s
.271 .395 .778 r
.49925 .41963 m .50529 .41859 L .50771 .43819 L p F P
0 0 0 r
s
.216 .302 .599 r
.57493 .55723 m .55545 .56018 L .55309 .5398 L p F P
0 0 0 r
s
.216 .302 .599 r
.55309 .5398 m .57173 .53692 L .57493 .55723 L p F P
0 0 0 r
s
.186 .253 .503 r
.47818 .60869 m .45888 .61151 L .45876 .59403 L p F P
0 0 0 r
s
.186 .253 .503 r
.45876 .59403 m .47811 .59115 L .47818 .60869 L p F P
0 0 0 r
s
.24 .35 .67 r
.42107 .59883 m
.45914 .59316 L
s
.45874 .56757 m
.45914 .59316 L
s
.83 .24 .1 r
.6861 .59372 m
.67927 .57204 L
s
.68511 .61862 m
.6861 .59372 L
s
.255 .368 .725 r
.55566 .45135 m .56718 .44943 L .58069 .46923 L p F P
0 0 0 r
s
.263 .382 .752 r
.56718 .44943 m .55566 .45135 L .54315 .4322 L p F P
0 0 0 r
s
.263 .382 .752 r
.53426 .4337 m .54315 .4322 L .55566 .45135 L p F P
0 0 0 r
s
.247 .353 .697 r
.60831 .48715 m .59236 .4897 L .58069 .46923 L p F P
0 0 0 r
s
.247 .353 .697 r
.58069 .46923 m .5946 .46696 L .60831 .48715 L p F P
0 0 0 r
s
.255 .368 .725 r
.5946 .46696 m .58069 .46923 L .56718 .44943 L p F P
0 0 0 r
s
.202 .28 .556 r
.5368 .58241 m .51714 .58533 L .5168 .56604 L p F P
0 0 0 r
s
.202 .28 .556 r
.5168 .56604 m .53608 .56312 L .5368 .58241 L p F P
0 0 0 r
s
.271 .395 .778 r
.52539 .4352 m .51654 .4367 L .51133 .41755 L p F P
0 0 0 r
s
.271 .395 .778 r
.50529 .41859 m .51133 .41755 L .51654 .4367 L p F P
0 0 0 r
s
1 .321 .133 r
.42873 .44186 m .4322 .44906 L .41856 .46878 L p F P
0 0 0 r
s
1 .321 .133 r
.41856 .46878 m .41428 .46027 L .42873 .44186 L p F P
0 0 0 r
s
1 .321 .132 r
.41428 .46027 m .41856 .46878 L .40677 .4892 L p F P
0 0 0 r
s
.83 .24 .1 r
.67209 .68796 m
.68485 .66408 L
s
.678 .64378 m
.68485 .66408 L
s
.238 .338 .668 r
.6196 .50769 m .60196 .51046 L .59236 .4897 L p F P
0 0 0 r
s
.238 .338 .668 r
.59236 .4897 m .60831 .48715 L .6196 .50769 L p F P
0 0 0 r
s
.24 .35 .67 r
.5675 .49364 m
.60643 .48741 L
s
.227 .321 .635 r
.6093 .53112 m .59047 .53403 L .58441 .51322 L p F P
0 0 0 r
s
.227 .321 .635 r
.58441 .51322 m .60196 .51046 L .6093 .53112 L p F P
0 0 0 r
s
1 .314 .132 r
.46405 .41318 m .46578 .41707 L .45006 .436 L p F P
0 0 0 r
s
1 .314 .132 r
.45006 .436 m .44746 .4304 L .46405 .41318 L p F P
0 0 0 r
s
1 .321 .132 r
.40677 .4892 m .40178 .4796 L .41428 .46027 L p F P
0 0 0 r
s
1 .318 .13 r
.40178 .4796 m .40677 .4892 L .39708 .50992 L p F P
0 0 0 r
s
.83 .24 .1 r
.39746 .52061 m
.41223 .49814 L
s
.164 .219 .436 r
.42266 .63217 m .40415 .63484 L .40159 .61991 L p F P
0 0 0 r
s
.83 .24 .1 r
.40906 .63413 m
.41008 .63586 L
s
.164 .219 .436 r
.40159 .61991 m .42059 .61713 L .42266 .63217 L p F P
0 0 0 r
s
.888 .244 .094 r
.40159 .61991 m .39543 .60945 L .39511 .59192 L p F P
0 0 0 r
s
.83 .24 .1 r
.39608 .59107 m
.40262 .60239 L
s
.72 .193 .072 r
.39543 .60945 m .40159 .61991 L .40415 .63484 L p F P
0 0 0 r
s
1 .307 .13 r
.48338 .40176 m .48423 .40376 L .46921 .42478 L p F P
0 0 0 r
s
1 .307 .13 r
.46921 .42478 m .4675 .42094 L .48338 .40176 L p F P
0 0 0 r
s
.278 .409 .804 r
.4752 .42375 m .46921 .42478 L .48423 .40376 L p F P
0 0 0 r
s
.83 .24 .1 r
.4686 .42347 m
.4705 .42774 L
s
.271 .395 .778 r
.53426 .4337 m .52539 .4352 L .51739 .41651 L p F P
0 0 0 r
s
.271 .395 .778 r
.51133 .41755 m .51739 .41651 L .52539 .4352 L p F P
0 0 0 r
s
.255 .368 .725 r
.56718 .44943 m .57873 .44752 L .5946 .46696 L p F P
0 0 0 r
s
.263 .382 .752 r
.57873 .44752 m .56718 .44943 L .55206 .4307 L p F P
0 0 0 r
s
.263 .382 .752 r
.54315 .4322 m .55206 .4307 L .56718 .44943 L p F P
0 0 0 r
s
.996 .278 .11 r
.39511 .59192 m .38881 .58104 L .391 .56176 L p F P
0 0 0 r
s
.888 .244 .094 r
.38881 .58104 m .39511 .59192 L .39543 .60945 L p F P
0 0 0 r
s
.24 .35 .67 r
.2555 .67739 m
.26334 .66268 L
s
.26334 .66268 m
.30083 .6573 L
s
1 .318 .133 r
.44484 .42475 m .44746 .4304 L .4322 .44906 L p F P
0 0 0 r
s
1 .318 .133 r
.4322 .44906 m .42873 .44186 L .44484 .42475 L p F P
0 0 0 r
s
.83 .24 .1 r
.44275 .43707 m
.45177 .45627 L
s
.247 .353 .697 r
.62433 .48458 m .60831 .48715 L .5946 .46696 L p F P
0 0 0 r
s
.247 .353 .697 r
.5946 .46696 m .60856 .46468 L .62433 .48458 L p F P
0 0 0 r
s
.255 .368 .725 r
.60856 .46468 m .5946 .46696 L .57873 .44752 L p F P
0 0 0 r
s
.278 .409 .804 r
.4812 .42272 m .4752 .42375 L .48731 .40323 L p F P
0 0 0 r
s
.278 .409 .804 r
.48423 .40376 m .48731 .40323 L .4752 .42375 L p F P
0 0 0 r
s
.216 .302 .599 r
.59451 .55427 m .57493 .55723 L .57173 .53692 L p F P
0 0 0 r
s
.216 .302 .599 r
.57173 .53692 m .59047 .53403 L .59451 .55427 L p F P
0 0 0 r
s
.24 .35 .67 r
.57143 .52226 m
.57422 .54996 L
s
.53532 .55589 m
.57422 .54996 L
s
.26498 .41761 m
.30249 .41095 L
s
.26498 .41761 m
.2536 .40437 L
s
.186 .253 .503 r
.49758 .60584 m .47818 .60869 L .47811 .59115 L p F P
0 0 0 r
s
.186 .253 .503 r
.47811 .59115 m .49757 .58825 L .49758 .60584 L p F P
0 0 0 r
s
.24 .35 .67 r
.37699 .64638 m
.38116 .62721 L
s
.40209 .62416 m
.41929 .62165 L
s
.38116 .62721 m
.40056 .62438 L
s
.271 .395 .778 r
.54315 .4322 m .53426 .4337 L .52346 .41547 L p F P
0 0 0 r
s
.271 .395 .778 r
.51739 .41651 m .52346 .41547 L .53426 .4337 L p F P
0 0 0 r
s
.238 .338 .668 r
.63731 .50491 m .6196 .50769 L .60831 .48715 L p F P
0 0 0 r
s
.238 .338 .668 r
.60831 .48715 m .62433 .48458 L .63731 .50491 L p F P
0 0 0 r
s
.202 .28 .556 r
.55657 .57946 m .5368 .58241 L .53608 .56312 L p F P
0 0 0 r
s
.202 .28 .556 r
.53608 .56312 m .55545 .56018 L .55657 .57946 L p F P
0 0 0 r
s
.24 .35 .67 r
.53532 .55589 m
.53646 .58164 L
s
.227 .321 .635 r
.62822 .5282 m .6093 .53112 L .60196 .51046 L p F P
0 0 0 r
s
.227 .321 .635 r
.60196 .51046 m .6196 .50769 L .62822 .5282 L p F P
0 0 0 r
s
.24 .35 .67 r
.57143 .52226 m
.61048 .51616 L
s
.278 .409 .804 r
.4872 .42169 m .4812 .42272 L .49038 .40269 L p F P
0 0 0 r
s
.278 .409 .804 r
.48731 .40323 m .49038 .40269 L .4812 .42272 L p F P
0 0 0 r
s
.255 .368 .725 r
.57873 .44752 m .59032 .44559 L .60856 .46468 L p F P
0 0 0 r
s
.263 .382 .752 r
.59032 .44559 m .57873 .44752 L .561 .42919 L p F P
0 0 0 r
s
.83 .24 .1 r
.5882 .43858 m
.5909 .44619 L
s
.56192 .43375 m
.56616 .43453 L
s
.263 .382 .752 r
.55206 .4307 m .561 .42919 L .57873 .44752 L p F P
0 0 0 r
s
.24 .35 .67 r
.55673 .43739 m
.56254 .46504 L
s
.83 .24 .1 r
.57269 .43573 m
.5882 .43858 L
s
.24 .35 .67 r
.51802 .44389 m
.55673 .43739 L
s
.60643 .48741 m
.61048 .51616 L
s
1 .318 .13 r
.39708 .50992 m .39148 .4995 L .40178 .4796 L p F P
0 0 0 r
s
1 .312 .126 r
.39148 .4995 m .39708 .50992 L .38967 .53055 L p F P
0 0 0 r
s
.83 .24 .1 r
.4686 .42347 m
.47873 .42001 L
s
.44275 .43707 m
.4686 .42347 L
s
.24 .35 .67 r
.388 .41582 m
.42621 .40915 L
s
.388 .41582 m
.37871 .39742 L
s
.278 .409 .804 r
.49322 .42066 m .4872 .42169 L .49346 .40216 L p F P
0 0 0 r
s
.278 .409 .804 r
.49038 .40269 m .49346 .40216 L .4872 .42169 L p F P
0 0 0 r
s
.247 .353 .697 r
.64041 .482 m .62433 .48458 L .60856 .46468 L p F P
0 0 0 r
s
.83 .24 .1 r
.63558 .48278 m
.6404 .48613 L
s
.247 .353 .697 r
.60856 .46468 m .62257 .4624 L .64041 .482 L p F P
0 0 0 r
s
.255 .368 .725 r
.62257 .4624 m .60856 .46468 L .59032 .44559 L p F P
0 0 0 r
s
.24 .35 .67 r
.6015 .45864 m
.60643 .48741 L
s
.56254 .46504 m
.6015 .45864 L
s
.271 .395 .778 r
.55206 .4307 m .54315 .4322 L .52954 .41443 L p F P
0 0 0 r
s
.271 .395 .778 r
.52346 .41547 m .52954 .41443 L .54315 .4322 L p F P
0 0 0 r
s
.83 .24 .1 r
.52523 .41078 m
.52686 .41489 L
s
.164 .219 .436 r
.44126 .62948 m .42266 .63217 L .42059 .61713 L p F P
0 0 0 r
s
.164 .219 .436 r
.42059 .61713 m .43968 .61433 L .44126 .62948 L p F P
0 0 0 r
s
.24 .35 .67 r
.41929 .62165 m
.42107 .59883 L
s
1 .3 .12 r
.391 .56176 m .38472 .5507 L .38967 .53055 L p F P
0 0 0 r
s
.996 .278 .11 r
.38472 .5507 m .391 .56176 L .38881 .58104 L p F P
0 0 0 r
s
1 .307 .13 r
.48253 .39976 m .48338 .40176 L .4675 .42094 L p F P
0 0 0 r
s
1 .307 .13 r
.4675 .42094 m .46578 .41707 L .48253 .39976 L p F P
0 0 0 r
s
.24 .35 .67 r
.46978 .41673 m
.47262 .42494 L
s
.278 .409 .804 r
.49925 .41963 m .49322 .42066 L .49653 .40162 L p F P
0 0 0 r
s
.278 .409 .804 r
.49346 .40216 m .49653 .40162 L .49322 .42066 L p F P
0 0 0 r
s
.216 .302 .599 r
.6142 .55128 m .59451 .55427 L .59047 .53403 L p F P
0 0 0 r
s
.216 .302 .599 r
.59047 .53403 m .6093 .53112 L .6142 .55128 L p F P
0 0 0 r
s
.255 .368 .725 r
.59032 .44559 m .60195 .44366 L .62257 .4624 L p F P
0 0 0 r
s
.263 .382 .752 r
.60195 .44366 m .59032 .44559 L .56995 .42767 L p F P
0 0 0 r
s
.263 .382 .752 r
.561 .42919 m .56995 .42767 L .59032 .44559 L p F P
0 0 0 r
s
.238 .338 .668 r
.65511 .50211 m .63731 .50491 L .62433 .48458 L p F P
0 0 0 r
s
.238 .338 .668 r
.62433 .48458 m .64041 .482 L .65511 .50211 L p F P
0 0 0 r
s
.186 .253 .503 r
.51708 .60299 m .49758 .60584 L .49757 .58825 L p F P
0 0 0 r
s
.186 .253 .503 r
.49757 .58825 m .51714 .58533 L .51708 .60299 L p F P
0 0 0 r
s
.24 .35 .67 r
.45914 .59316 m
.4976 .58743 L
s
.49683 .56176 m
.4976 .58743 L
s
.271 .395 .778 r
.561 .42919 m .55206 .4307 L .53562 .41338 L p F P
0 0 0 r
s
.271 .395 .778 r
.52954 .41443 m .53562 .41338 L .55206 .4307 L p F P
0 0 0 r
s
.227 .321 .635 r
.64724 .52527 m .62822 .5282 L .6196 .50769 L p F P
0 0 0 r
s
.227 .321 .635 r
.6196 .50769 m .63731 .50491 L .64724 .52527 L p F P
0 0 0 r
s
1 .314 .132 r
.46231 .40926 m .46405 .41318 L .44746 .4304 L p F P
0 0 0 r
s
1 .314 .132 r
.44746 .4304 m .44484 .42475 L .46231 .40926 L p F P
0 0 0 r
s
.202 .28 .556 r
.57645 .5765 m .55657 .57946 L .55545 .56018 L p F P
0 0 0 r
s
.202 .28 .556 r
.55545 .56018 m .57493 .55723 L .57645 .5765 L p F P
0 0 0 r
s
.278 .409 .804 r
.50529 .41859 m .49925 .41963 L .49962 .40108 L p F P
0 0 0 r
s
.278 .409 .804 r
.49653 .40162 m .49962 .40108 L .49925 .41963 L p F P
0 0 0 r
s
.504 .158 .074 r
.61971 .45379 m .62257 .4624 L .64041 .482 L p F P
0 0 0 r
s
.655 .2 .091 r
.62257 .4624 m .61971 .45379 L .59945 .4364 L p F P
0 0 0 r
s
.655 .2 .091 r
.59945 .4364 m .60195 .44366 L .62257 .4624 L p F P
0 0 0 r
s
.24 .35 .67 r
.6015 .45864 m
.61647 .45619 L
s
.83 .24 .1 r
.41777 .65834 m
.43113 .67842 L
s
.278 .409 .804 r
.51133 .41755 m .50529 .41859 L .5027 .40055 L p F P
0 0 0 r
s
.24 .35 .67 r
.51123 .41832 m
.51802 .44389 L
s
.278 .409 .804 r
.49962 .40108 m .5027 .40055 L .50529 .41859 L p F P
0 0 0 r
s
.24 .35 .67 r
.47262 .42494 m
.51123 .41832 L
s
.271 .395 .778 r
.56995 .42767 m .561 .42919 L .54172 .41234 L p F P
0 0 0 r
s
.83 .24 .1 r
.55983 .42817 m
.55997 .42855 L
s
.271 .395 .778 r
.53562 .41338 m .54172 .41234 L .561 .42919 L p F P
0 0 0 r
s
.263 .382 .752 r
.56995 .42767 m .57893 .42616 L .60195 .44366 L p F P
0 0 0 r
s
.768 .232 .103 r
.60195 .44366 m .59945 .4364 L .57689 .42047 L p F P
0 0 0 r
s
.768 .232 .103 r
.57689 .42047 m .57893 .42616 L .60195 .44366 L p F P
0 0 0 r
s
.24 .35 .67 r
.59748 .43881 m
.6015 .45864 L
s
.59585 .43082 m
.59657 .43437 L
s
.59237 .4314 m
.59585 .43082 L
s
.55673 .43739 m
.58796 .43214 L
s
.164 .219 .436 r
.45996 .62678 m .44126 .62948 L .43968 .61433 L p F P
0 0 0 r
s
.164 .219 .436 r
.43968 .61433 m .45888 .61151 L .45996 .62678 L p F P
0 0 0 r
s
.38 .117 .058 r
.63727 .47229 m .64041 .482 L .65511 .50211 L p F P
0 0 0 r
s
.24 .35 .67 r
.64283 .48158 m
.64577 .4811 L
s
.504 .158 .074 r
.64041 .482 m .63727 .47229 L .61971 .45379 L p F P
0 0 0 r
s
.24 .35 .67 r
.60643 .48741 m
.64074 .48191 L
s
.62124 .4554 m
.64086 .45218 L
s
.83 .24 .1 r
.5102 .73421 m
.52037 .75287 L
s
.52037 .75287 m
.54838 .75484 L
s
.278 .409 .804 r
.51739 .41651 m .51133 .41755 L .50579 .40001 L p F P
0 0 0 r
s
.83 .24 .1 r
.50848 .41193 m
.5095 .41175 L
s
.278 .409 .804 r
.5027 .40055 m .50579 .40001 L .51133 .41755 L p F P
0 0 0 r
s
.24 .35 .67 r
.29358 .672 m
.30083 .6573 L
s
.30083 .6573 m
.33871 .65187 L
s
.216 .302 .599 r
.63398 .54829 m .6142 .55128 L .6093 .53112 L p F P
0 0 0 r
s
.216 .302 .599 r
.6093 .53112 m .62822 .5282 L .63398 .54829 L p F P
0 0 0 r
s
.24 .35 .67 r
.61048 .51616 m
.61352 .54397 L
s
.57422 .54996 m
.61352 .54397 L
s
1 .307 .13 r
.48168 .39775 m .48253 .39976 L .46578 .41707 L p F P
0 0 0 r
s
1 .307 .13 r
.46578 .41707 m .46405 .41318 L .48168 .39775 L p F P
0 0 0 r
s
1 .321 .133 r
.42521 .43458 m .42873 .44186 L .41428 .46027 L p F P
0 0 0 r
s
1 .321 .133 r
.41428 .46027 m .40995 .45163 L .42521 .43458 L p F P
0 0 0 r
s
.83 .24 .1 r
.4196 .45435 m
.43133 .47804 L
s
1 .321 .132 r
.40995 .45163 m .41428 .46027 L .40178 .4796 L p F P
0 0 0 r
s
.271 .395 .778 r
.57893 .42616 m .56995 .42767 L .54783 .41129 L p F P
0 0 0 r
s
.271 .395 .778 r
.54172 .41234 m .54783 .41129 L .56995 .42767 L p F P
0 0 0 r
s
.24 .35 .67 r
.30249 .41095 m
.3404 .40422 L
s
.30249 .41095 m
.29167 .39753 L
s
.227 .321 .635 r
.66636 .52232 m .64724 .52527 L .63731 .50491 L p F P
0 0 0 r
s
.83 .24 .1 r
.66226 .52295 m
.66357 .52708 L
s
.227 .321 .635 r
.63731 .50491 m .65511 .50211 L .66636 .52232 L p F P
0 0 0 r
s
.24 .35 .67 r
.61048 .51616 m
.64994 .51 L
s
.186 .253 .503 r
.53669 .60011 m .51708 .60299 L .51714 .58533 L p F P
0 0 0 r
s
.186 .253 .503 r
.51714 .58533 m .5368 .58241 L .53669 .60011 L p F P
0 0 0 r
s
.24 .35 .67 r
.4976 .58743 m
.53646 .58164 L
s
1 .312 .126 r
.38967 .53055 m .38359 .51957 L .39148 .4995 L p F P
0 0 0 r
s
1 .3 .12 r
.38359 .51957 m .38967 .53055 L .38472 .5507 L p F P
0 0 0 r
s
.83 .24 .1 r
.3877 .54463 m
.39746 .52061 L
s
.3877 .54463 m
.40008 .56666 L
s
1 .318 .133 r
.44219 .41904 m .44484 .42475 L .42873 .44186 L p F P
0 0 0 r
s
1 .318 .133 r
.42873 .44186 m .42521 .43458 L .44219 .41904 L p F P
0 0 0 r
s
.24 .35 .67 r
.42621 .40915 m
.43295 .4275 L
s
.83 .24 .1 r
.4196 .45435 m
.44275 .43707 L
s
.24 .35 .67 r
.41929 .62165 m
.45782 .61602 L
s
.278 .409 .804 r
.52346 .41547 m .51739 .41651 L .50888 .39947 L p F P
0 0 0 r
s
.83 .24 .1 r
.51355 .41105 m
.51458 .41088 L
s
.278 .409 .804 r
.50579 .40001 m .50888 .39947 L .51739 .41651 L p F P
0 0 0 r
s
.202 .28 .556 r
.59643 .57353 m .57645 .5765 L .57493 .55723 L p F P
0 0 0 r
s
.202 .28 .556 r
.57493 .55723 m .59451 .55427 L .59643 .57353 L p F P
0 0 0 r
s
.24 .35 .67 r
.57422 .54996 m
.57573 .57579 L
s
.83 .24 .1 r
.65399 .70967 m
.67209 .68796 L
s
.66493 .66798 m
.67209 .68796 L
s
.24 .35 .67 r
.64577 .4811 m
.64679 .4882 L
s
.64086 .45218 m
.64577 .4811 L
s
.271 .395 .778 r
.54783 .41129 m .55395 .41024 L .57893 .42616 L p F P
0 0 0 r
s
.855 .256 .112 r
.57893 .42616 m .57689 .42047 L .55248 .4063 L p F P
0 0 0 r
s
.855 .256 .112 r
.55248 .4063 m .55395 .41024 L .57893 .42616 L p F P
0 0 0 r
s
.24 .35 .67 r
.55024 .41163 m
.55673 .43739 L
s
.278 .409 .804 r
.52954 .41443 m .52346 .41547 L .51197 .39893 L p F P
0 0 0 r
s
.83 .24 .1 r
.51863 .41018 m
.51966 .41 L
s
.52372 .4093 m
.52459 .40915 L
s
.52459 .40915 m
.52514 .41055 L
s
.278 .409 .804 r
.50888 .39947 m .51197 .39893 L .52346 .41547 L p F P
0 0 0 r
s
.83 .24 .1 r
.44974 .69509 m
.46112 .71456 L
s
.46112 .71456 m
.48393 .72687 L
s
1 .321 .132 r
.40178 .4796 m .39671 .46985 L .40995 .45163 L p F P
0 0 0 r
s
1 .318 .13 r
.39671 .46985 m .40178 .4796 L .39148 .4995 L p F P
0 0 0 r
s
.83 .24 .1 r
.40006 .47471 m
.41223 .49814 L
s
.40006 .47471 m
.4196 .45435 L
s
.164 .219 .436 r
.47876 .62407 m .45996 .62678 L .45888 .61151 L p F P
0 0 0 r
s
.164 .219 .436 r
.45888 .61151 m .47818 .60869 L .47876 .62407 L p F P
0 0 0 r
s
.24 .35 .67 r
.45782 .61602 m
.45914 .59316 L
s
.278 .409 .804 r
.53562 .41338 m .52954 .41443 L .51506 .39839 L p F P
0 0 0 r
s
.83 .24 .1 r
.52445 .40879 m
.52459 .40915 L
s
.52459 .40915 m
.52477 .40915 L
s
.278 .409 .804 r
.51197 .39893 m .51506 .39839 L .52954 .41443 L p F P
0 0 0 r
s
.216 .302 .599 r
.65388 .54527 m .63398 .54829 L .62822 .5282 L p F P
0 0 0 r
s
.216 .302 .599 r
.62822 .5282 m .64724 .52527 L .65388 .54527 L p F P
0 0 0 r
s
1 .314 .132 r
.46056 .40532 m .46231 .40926 L .44484 .42475 L p F P
0 0 0 r
s
1 .314 .132 r
.44484 .42475 m .44219 .41904 L .46056 .40532 L p F P
0 0 0 r
s
.24 .35 .67 r
.64086 .45218 m
.68064 .44566 L
s
.267 .077 .042 r
.65177 .49155 m .65511 .50211 L .66636 .52232 L p F P
0 0 0 r
s
.38 .117 .058 r
.65511 .50211 m .65177 .49155 L .63727 .47229 L p F P
0 0 0 r
s
.24 .35 .67 r
.64577 .4811 m
.68552 .47474 L
s
.64713 .49055 m
.64994 .51 L
s
.278 .409 .804 r
.54172 .41234 m .53562 .41338 L .51816 .39786 L p F P
0 0 0 r
s
.278 .409 .804 r
.51506 .39839 m .51816 .39786 L .53562 .41338 L p F P
0 0 0 r
s
.186 .253 .503 r
.5564 .59723 m .53669 .60011 L .5368 .58241 L p F P
0 0 0 r
s
.186 .253 .503 r
.5368 .58241 m .55657 .57946 L .5564 .59723 L p F P
0 0 0 r
s
1 .307 .13 r
.48082 .39573 m .48168 .39775 L .46405 .41318 L p F P
0 0 0 r
s
1 .307 .13 r
.46405 .41318 m .46231 .40926 L .48082 .39573 L p F P
0 0 0 r
s
.202 .28 .556 r
.61652 .57054 m .59643 .57353 L .59451 .55427 L p F P
0 0 0 r
s
.202 .28 .556 r
.59451 .55427 m .6142 .55128 L .61652 .57054 L p F P
0 0 0 r
s
.83 .24 .1 r
.678 .64378 m
.68511 .61862 L
s
.67819 .5972 m
.68511 .61862 L
s
.888 .244 .094 r
.39543 .60945 m .38915 .59877 L .38881 .58104 L p F P
0 0 0 r
s
.72 .193 .072 r
.38915 .59877 m .39543 .60945 L .39818 .6248 L p F P
0 0 0 r
s
.72 .193 .072 r
.40415 .63484 m .39818 .6248 L .39543 .60945 L p F P
0 0 0 r
s
.83 .24 .1 r
.39786 .61514 m
.40342 .62456 L
s
.39608 .59107 m
.39786 .61514 L
s
.24 .35 .67 r
.64994 .51 m
.65888 .5086 L
s
.278 .409 .804 r
.54783 .41129 m .54172 .41234 L .52126 .39732 L p F P
0 0 0 r
s
.278 .409 .804 r
.51816 .39786 m .52126 .39732 L .54172 .41234 L p F P
0 0 0 r
s
.24 .35 .67 r
.51123 .41832 m
.55024 .41163 L
s
.996 .278 .11 r
.38881 .58104 m .38238 .56995 L .38472 .5507 L p F P
0 0 0 r
s
.888 .244 .094 r
.38238 .56995 m .38881 .58104 L .38915 .59877 L p F P
0 0 0 r
s
.164 .219 .436 r
.49764 .62134 m .47876 .62407 L .47818 .60869 L p F P
0 0 0 r
s
.164 .219 .436 r
.47818 .60869 m .49758 .60584 L .49764 .62134 L p F P
0 0 0 r
s
.278 .409 .804 r
.55395 .41024 m .54783 .41129 L .52436 .39678 L p F P
0 0 0 r
s
.278 .409 .804 r
.52126 .39732 m .52436 .39678 L .54783 .41129 L p F P
0 0 0 r
s
.655 .2 .091 r
.59691 .42906 m .59945 .4364 L .61971 .45379 L p F P
0 0 0 r
s
.24 .35 .67 r
.59585 .43082 m
.59743 .43055 L
s
.768 .232 .103 r
.59945 .4364 m .59691 .42906 L .57483 .41472 L p F P
0 0 0 r
s
.768 .232 .103 r
.57483 .41472 m .57689 .42047 L .59945 .4364 L p F P
0 0 0 r
s
1 .318 .13 r
.39148 .4995 m .38578 .48889 L .39671 .46985 L p F P
0 0 0 r
s
1 .312 .126 r
.38578 .48889 m .39148 .4995 L .38359 .51957 L p F P
0 0 0 r
s
.216 .302 .599 r
.67387 .54224 m .65388 .54527 L .64724 .52527 L p F P
0 0 0 r
s
.83 .24 .1 r
.67242 .54246 m
.67425 .54833 L
s
.216 .302 .599 r
.64724 .52527 m .66636 .52232 L .67387 .54224 L p F P
0 0 0 r
s
.24 .35 .67 r
.61352 .54397 m
.65324 .53791 L
s
.33207 .66656 m
.33871 .65187 L
s
.33871 .65187 m
.37699 .64638 L
s
.135 .173 .347 r
.42659 .6445 m .40901 .64701 L .40415 .63484 L p F P
0 0 0 r
s
.83 .24 .1 r
.41087 .64674 m
.41777 .65834 L
s
.135 .173 .347 r
.40415 .63484 m .42266 .63217 L .42659 .6445 L p F P
0 0 0 r
s
.24 .35 .67 r
.41568 .64083 m
.41929 .62165 L
s
.561 .145 .055 r
.39818 .6248 m .40415 .63484 L .40901 .64701 L p F P
0 0 0 r
s
.504 .158 .074 r
.6168 .44506 m .61971 .45379 L .63727 .47229 L p F P
0 0 0 r
s
.24 .35 .67 r
.63539 .42418 m
.64086 .45218 L
s
.655 .2 .091 r
.61971 .45379 m .6168 .44506 L .59691 .42906 L p F P
0 0 0 r
s
.24 .35 .67 r
.59854 .43037 m
.63539 .42418 L
s
.83 .24 .1 r
.61212 .44816 m
.61523 .45739 L
s
.595 .4413 m
.61212 .44816 L
s
1 .299 .127 r
.48423 .40376 m .48338 .40176 L .5 .38446 L closepath p F P
0 0 0 r
s
.285 .422 .829 r
.5 .38446 m .48731 .40323 L .48423 .40376 L closepath p F P
0 0 0 r
s
.922 .274 .118 r
.55395 .41024 m .55248 .4063 L .52668 .39421 L p F P
0 0 0 r
s
.922 .274 .118 r
.52668 .39421 m .52747 .39623 L .55395 .41024 L p F P
0 0 0 r
s
.278 .409 .804 r
.52436 .39678 m .52747 .39623 L .55395 .41024 L p F P
0 0 0 r
s
.24 .35 .67 r
.3404 .40422 m
.37871 .39742 L
s
.3404 .40422 m
.33015 .39061 L
s
.186 .253 .503 r
.57621 .59432 m .5564 .59723 L .55657 .57946 L p F P
0 0 0 r
s
.186 .253 .503 r
.55657 .57946 m .57645 .5765 L .57621 .59432 L p F P
0 0 0 r
s
.24 .35 .67 r
.53646 .58164 m
.57573 .57579 L
s
.83 .24 .1 r
.5387 .7361 m
.54838 .75484 L
s
.54838 .75484 m
.57718 .75122 L
s
.24 .35 .67 r
.45782 .61602 m
.49676 .61034 L
s
.855 .256 .112 r
.57689 .42047 m .57483 .41472 L .551 .40235 L p F P
0 0 0 r
s
.855 .256 .112 r
.551 .40235 m .55248 .4063 L .57689 .42047 L p F P
0 0 0 r
s
.83 .24 .1 r
.54233 .40907 m
.55267 .40902 L
s
.55267 .40902 m
.55431 .41339 L
s
.24 .35 .67 r
.55024 .41163 m
.55706 .41046 L
s
.285 .422 .829 r
.5 .38446 m .49038 .40269 L .48731 .40323 L closepath p F P
0 0 0 r
s
.202 .28 .556 r
.63671 .56753 m .61652 .57054 L .6142 .55128 L p F P
0 0 0 r
s
.202 .28 .556 r
.6142 .55128 m .63398 .54829 L .63671 .56753 L p F P
0 0 0 r
s
.24 .35 .67 r
.61352 .54397 m
.61542 .56987 L
s
.21593 .41113 m
.2536 .40437 L
s
.21593 .41113 m
.20372 .40341 L
s
1 .307 .13 r
.47996 .39371 m .48082 .39573 L .46231 .40926 L p F P
0 0 0 r
s
1 .307 .13 r
.46231 .40926 m .46056 .40532 L .47996 .39371 L p F P
0 0 0 r
s
.24 .35 .67 r
.46482 .4024 m
.46493 .40271 L
s
.42621 .40915 m
.46482 .4024 L
s
1 .318 .133 r
.43952 .41329 m .44219 .41904 L .42521 .43458 L p F P
0 0 0 r
s
1 .318 .133 r
.42521 .43458 m .42165 .42722 L .43952 .41329 L p F P
0 0 0 r
s
1 .321 .133 r
.42165 .42722 m .42521 .43458 L .40995 .45163 L p F P
0 0 0 r
s
.285 .422 .829 r
.5 .38446 m .49346 .40216 L .49038 .40269 L closepath p F P
0 0 0 r
s
1 .3 .12 r
.38472 .5507 m .37832 .53942 L .38359 .51957 L p F P
0 0 0 r
s
.996 .278 .11 r
.37832 .53942 m .38472 .5507 L .38238 .56995 L p F P
0 0 0 r
s
.83 .24 .1 r
.38349 .56929 m
.3877 .54463 L
s
.24 .35 .67 r
.68981 .50376 m
.68552 .47474 L
s
.68552 .47474 m
.72569 .4683 L
s
.68552 .47474 m
.68064 .44566 L
s
.83 .24 .1 r
.63136 .72805 m
.65399 .70967 L
s
.64642 .69 m
.65399 .70967 L
s
.285 .422 .829 r
.5 .38446 m .49653 .40162 L .49346 .40216 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.46482 .4024 m
.4657 .40224 L
s
1 .314 .132 r
.4588 .40136 m .46056 .40532 L .44219 .41904 L p F P
0 0 0 r
s
1 .314 .132 r
.44219 .41904 m .43952 .41329 L .4588 .40136 L p F P
0 0 0 r
s
1 .299 .127 r
.48338 .40176 m .48253 .39976 L .5 .38446 L closepath p F P
0 0 0 r
s
.164 .219 .436 r
.51663 .6186 m .49764 .62134 L .49758 .60584 L p F P
0 0 0 r
s
.164 .219 .436 r
.49758 .60584 m .51708 .60299 L .51663 .6186 L p F P
0 0 0 r
s
.24 .35 .67 r
.49676 .61034 m
.4976 .58743 L
s
.285 .422 .829 r
.5 .38446 m .49962 .40108 L .49653 .40162 L closepath p F P
0 0 0 r
s
1 .321 .133 r
.40995 .45163 m .40555 .44287 L .42165 .42722 L p F P
0 0 0 r
s
1 .321 .132 r
.40555 .44287 m .40995 .45163 L .39671 .46985 L p F P
0 0 0 r
s
.187 .054 .028 r
.66287 .51118 m .66636 .52232 L .67387 .54224 L p F P
0 0 0 r
s
.267 .077 .042 r
.66636 .52232 m .66287 .51118 L .65177 .49155 L p F P
0 0 0 r
s
.24 .35 .67 r
.64994 .51 m
.65324 .53791 L
s
.66121 .50823 m
.68981 .50376 L
s
.83 .24 .1 r
.64557 .49199 m
.65632 .50418 L
s
.65632 .50418 m
.65798 .50941 L
s
.285 .422 .829 r
.5 .38446 m .5027 .40055 L .49962 .40108 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.63539 .42418 m
.67534 .41747 L
s
.63539 .42418 m
.62951 .39803 L
s
.38 .117 .058 r
.63407 .46242 m .63727 .47229 L .65177 .49155 L p F P
0 0 0 r
s
.504 .158 .074 r
.63727 .47229 m .63407 .46242 L .6168 .44506 L p F P
0 0 0 r
s
.24 .35 .67 r
.68064 .44566 m
.72084 .43906 L
s
.68064 .44566 m
.67534 .41747 L
s
.135 .173 .347 r
.44426 .64198 m .42659 .6445 L .42266 .63217 L p F P
0 0 0 r
s
.135 .173 .347 r
.42266 .63217 m .44126 .62948 L .44426 .64198 L p F P
0 0 0 r
s
.285 .422 .829 r
.5 .38446 m .50579 .40001 L .5027 .40055 L closepath p F P
0 0 0 r
s
.186 .253 .503 r
.59613 .5914 m .57621 .59432 L .57645 .5765 L p F P
0 0 0 r
s
.186 .253 .503 r
.57645 .5765 m .59643 .57353 L .59613 .5914 L p F P
0 0 0 r
s
.285 .422 .829 r
.5 .38446 m .50888 .39947 L .50579 .40001 L closepath p F P
0 0 0 r
s
1 .299 .127 r
.48253 .39976 m .48168 .39775 L .5 .38446 L closepath p F P
0 0 0 r
s
.922 .274 .118 r
.55248 .4063 m .551 .40235 L .52589 .39218 L p F P
0 0 0 r
s
.922 .274 .118 r
.52589 .39218 m .52668 .39421 L .55248 .4063 L p F P
0 0 0 r
s
.24 .35 .67 r
.54771 .40327 m
.55024 .41163 L
s
.202 .28 .556 r
.65702 .56451 m .63671 .56753 L .63398 .54829 L p F P
0 0 0 r
s
.202 .28 .556 r
.63398 .54829 m .65388 .54527 L .65702 .56451 L p F P
0 0 0 r
s
.285 .422 .829 r
.5 .38446 m .51197 .39893 L .50888 .39947 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.69337 .53179 m
.68981 .50376 L
s
.68981 .50376 m
.7301 .49747 L
s
.285 .422 .829 r
.5 .38446 m .51506 .39839 L .51197 .39893 L closepath p F P
0 0 0 r
s
1 .307 .13 r
.47909 .39168 m .47996 .39371 L .46056 .40532 L p F P
0 0 0 r
s
1 .307 .13 r
.46056 .40532 m .4588 .40136 L .47909 .39168 L p F P
0 0 0 r
s
.285 .422 .829 r
.5 .38446 m .51816 .39786 L .51506 .39839 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.56804 .73233 m
.57718 .75122 L
s
.57718 .75122 m
.60532 .74214 L
s
1 .321 .132 r
.39671 .46985 m .39155 .45994 L .40555 .44287 L p F P
0 0 0 r
s
1 .318 .13 r
.39155 .45994 m .39671 .46985 L .38578 .48889 L p F P
0 0 0 r
s
.164 .219 .436 r
.53571 .61584 m .51663 .6186 L .51708 .60299 L p F P
0 0 0 r
s
.164 .219 .436 r
.51708 .60299 m .53669 .60011 L .53571 .61584 L p F P
0 0 0 r
s
1 .312 .126 r
.38359 .51957 m .3774 .50838 L .38578 .48889 L p F P
0 0 0 r
s
1 .3 .12 r
.3774 .50838 m .38359 .51957 L .37832 .53942 L p F P
0 0 0 r
s
.24 .35 .67 r
.65324 .53791 m
.67124 .53516 L
s
.285 .422 .829 r
.5 .38446 m .52126 .39732 L .51816 .39786 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.60532 .74214 m
.63136 .72805 L
s
.62331 .70869 m
.63136 .72805 L
s
1 .299 .127 r
.48168 .39775 m .48082 .39573 L .5 .38446 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.37098 .66105 m
.37699 .64638 L
s
.37699 .64638 m
.40664 .64213 L
s
.768 .232 .103 r
.57276 .40893 m .57483 .41472 L .59691 .42906 L p F P
0 0 0 r
s
.855 .256 .112 r
.57483 .41472 m .57276 .40893 L .54951 .39836 L p F P
0 0 0 r
s
.24 .35 .67 r
.56424 .40922 m
.56589 .40894 L
s
.855 .256 .112 r
.54951 .39836 m .551 .40235 L .57483 .41472 L p F P
0 0 0 r
s
.24 .35 .67 r
.5709 .40808 m
.58967 .40486 L
s
.83 .24 .1 r
.41905 .65806 m
.43113 .67842 L
s
.43113 .67842 m
.44974 .69509 L
s
.285 .422 .829 r
.5 .38446 m .52436 .39678 L .52126 .39732 L closepath p F P
0 0 0 r
s
.135 .173 .347 r
.46201 .63945 m .44426 .64198 L .44126 .62948 L p F P
0 0 0 r
s
.135 .173 .347 r
.44126 .62948 m .45996 .62678 L .46201 .63945 L p F P
0 0 0 r
s
.24 .35 .67 r
.45478 .63523 m
.45782 .61602 L
s
.655 .2 .091 r
.59435 .42162 m .59691 .42906 L .6168 .44506 L p F P
0 0 0 r
s
.768 .232 .103 r
.59691 .42906 m .59435 .42162 L .57276 .40893 L p F P
0 0 0 r
s
.24 .35 .67 r
.58967 .40486 m
.59355 .42115 L
s
.37871 .39742 m
.41742 .39055 L
s
.37871 .39742 m
.36905 .38363 L
s
.285 .422 .829 r
.5 .38446 m .52747 .39623 L .52436 .39678 L closepath p F P
0 0 0 r
s
.186 .253 .503 r
.61615 .58847 m .59613 .5914 L .59643 .57353 L p F P
0 0 0 r
s
.186 .253 .503 r
.59643 .57353 m .61652 .57054 L .61615 .58847 L p F P
0 0 0 r
s
.24 .35 .67 r
.57573 .57579 m
.61542 .56987 L
s
.83 .24 .1 r
.59673 .72305 m
.60532 .74214 L
s
.202 .28 .556 r
.67744 .56147 m .65702 .56451 L .65388 .54527 L p F P
0 0 0 r
s
.83 .24 .1 r
.67425 .54833 m
.67696 .56114 L
s
.67704 .56152 m
.67927 .57204 L
s
.202 .28 .556 r
.65388 .54527 m .67387 .54224 L .67744 .56147 L p F P
0 0 0 r
s
.24 .35 .67 r
.65324 .53791 m
.65553 .56389 L
s
.975 .288 .123 r
.5 .38446 m .52747 .39623 L .52668 .39421 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.50384 .39558 m
.51123 .41832 L
s
.83 .24 .1 r
.4729 .70746 m
.48393 .72687 L
s
.48393 .72687 m
.5102 .73421 L
s
.24 .35 .67 r
.2536 .40437 m
.29167 .39753 L
s
.2536 .40437 m
.242 .39647 L
s
.24578 .68689 m
.2555 .67739 L
s
.2555 .67739 m
.29358 .672 L
s
1 .314 .132 r
.45703 .39737 m .4588 .40136 L .43952 .41329 L p F P
0 0 0 r
s
1 .314 .132 r
.43952 .41329 m .43683 .40748 L .45703 .39737 L p F P
0 0 0 r
s
1 .318 .133 r
.43683 .40748 m .43952 .41329 L .42165 .42722 L p F P
0 0 0 r
s
.267 .077 .042 r
.64836 .4808 m .65177 .49155 L .66287 .51118 L p F P
0 0 0 r
s
.38 .117 .058 r
.65177 .49155 m .64836 .4808 L .63407 .46242 L p F P
0 0 0 r
s
.922 .274 .118 r
.551 .40235 m .54951 .39836 L .5251 .39015 L p F P
0 0 0 r
s
.24 .35 .67 r
.54683 .40038 m
.54693 .4007 L
s
.922 .274 .118 r
.5251 .39015 m .52589 .39218 L .551 .40235 L p F P
0 0 0 r
s
1 .299 .127 r
.48082 .39573 m .47996 .39371 L .5 .38446 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.48043 .39967 m
.50384 .39558 L
s
.7301 .49747 m
.72569 .4683 L
s
.72569 .4683 m
.76629 .4618 L
s
.72569 .4683 m
.72084 .43906 L
s
1 .318 .133 r
.42165 .42722 m .41806 .41976 L .43683 .40748 L p F P
0 0 0 r
s
1 .321 .133 r
.41806 .41976 m .42165 .42722 L .40555 .44287 L p F P
0 0 0 r
s
.164 .219 .436 r
.5549 .61307 m .53571 .61584 L .53669 .60011 L p F P
0 0 0 r
s
.24 .35 .67 r
.49676 .61034 m
.53612 .6046 L
s
.53612 .6046 m
.53646 .58164 L
s
.164 .219 .436 r
.53669 .60011 m .5564 .59723 L .5549 .61307 L p F P
0 0 0 r
s
.83 .24 .1 r
.67819 .5972 m
.67927 .57204 L
s
1 .307 .13 r
.47823 .38964 m .47909 .39168 L .4588 .40136 L p F P
0 0 0 r
s
1 .307 .13 r
.4588 .40136 m .45703 .39737 L .47823 .38964 L p F P
0 0 0 r
s
.83 .24 .1 r
.45743 .39834 m
.4686 .42347 L
s
.504 .158 .074 r
.61385 .43621 m .6168 .44506 L .63407 .46242 L p F P
0 0 0 r
s
.655 .2 .091 r
.6168 .44506 m .61385 .43621 L .59435 .42162 L p F P
0 0 0 r
s
.83 .24 .1 r
.66493 .66798 m
.678 .64378 L
s
.67086 .62267 m
.678 .64378 L
s
.975 .288 .123 r
.5 .38446 m .52668 .39421 L .52589 .39218 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.67534 .41747 m
.71572 .41069 L
s
.67534 .41747 m
.66978 .39112 L
s
.135 .173 .347 r
.47984 .6369 m .46201 .63945 L .45996 .62678 L p F P
0 0 0 r
s
.135 .173 .347 r
.45996 .62678 m .47876 .62407 L .47984 .6369 L p F P
0 0 0 r
s
.24 .35 .67 r
.72084 .43906 m
.76147 .43239 L
s
.72084 .43906 m
.71572 .41069 L
s
1 .299 .127 r
.47996 .39371 m .47909 .39168 L .5 .38446 L closepath p F P
0 0 0 r
s
.888 .244 .094 r
.38915 .59877 m .38274 .58789 L .38238 .56995 L p F P
0 0 0 r
s
.72 .193 .072 r
.38274 .58789 m .38915 .59877 L .39209 .61456 L p F P
0 0 0 r
s
.83 .24 .1 r
.38349 .56929 m
.39608 .59107 L
s
.72 .193 .072 r
.39818 .6248 m .39209 .61456 L .38915 .59877 L p F P
0 0 0 r
s
.186 .253 .503 r
.63629 .58552 m .61615 .58847 L .61652 .57054 L p F P
0 0 0 r
s
.186 .253 .503 r
.61652 .57054 m .63671 .56753 L .63629 .58552 L p F P
0 0 0 r
s
1 .318 .13 r
.38578 .48889 m .37997 .47809 L .39155 .45994 L p F P
0 0 0 r
s
1 .312 .126 r
.37997 .47809 m .38578 .48889 L .3774 .50838 L p F P
0 0 0 r
s
.83 .24 .1 r
.3849 .49745 m
.40006 .47471 L
s
.3849 .49745 m
.39746 .52061 L
s
.187 .054 .028 r
.67387 .54224 m .6703 .53079 L .66287 .51118 L p F P
0 0 0 r
s
.66 .179 .065 r
.6703 .53079 m .67387 .54224 L .67744 .56147 L p F P
0 0 0 r
s
.24 .35 .67 r
.67237 .53499 m
.69337 .53179 L
s
.67165 .5351 m
.67237 .53499 L
s
1 .321 .133 r
.40555 .44287 m .40109 .43398 L .41806 .41976 L p F P
0 0 0 r
s
1 .321 .132 r
.40109 .43398 m .40555 .44287 L .39155 .45994 L p F P
0 0 0 r
s
.996 .278 .11 r
.38238 .56995 m .37582 .55863 L .37832 .53942 L p F P
0 0 0 r
s
.888 .244 .094 r
.37582 .55863 m .38238 .56995 L .38274 .58789 L p F P
0 0 0 r
s
.24 .35 .67 r
.73394 .5256 m
.7301 .49747 L
s
.7301 .49747 m
.77083 .4911 L
s
.975 .288 .123 r
.5 .38446 m .52589 .39218 L .5251 .39015 L closepath p F P
0 0 0 r
s
.855 .256 .112 r
.54802 .39436 m .54951 .39836 L .57276 .40893 L p F P
0 0 0 r
s
.922 .274 .118 r
.54951 .39836 m .54802 .39436 L .5243 .38811 L p F P
0 0 0 r
s
.24 .35 .67 r
.54575 .39683 m
.54584 .39713 L
s
.922 .274 .118 r
.5243 .38811 m .5251 .39015 L .54951 .39836 L p F P
0 0 0 r
s
.24 .35 .67 r
.54328 .38868 m
.54474 .39349 L
s
.53318 .39045 m
.54328 .38868 L
s
.50384 .39558 m
.52741 .39146 L
s
1 .299 .127 r
.47909 .39168 m .47823 .38964 L .5 .38446 L closepath p F P
0 0 0 r
s
.561 .145 .055 r
.39209 .61456 m .39818 .6248 L .40339 .63758 L p F P
0 0 0 r
s
.561 .145 .055 r
.40901 .64701 m .40339 .63758 L .39818 .6248 L p F P
0 0 0 r
s
.83 .24 .1 r
.39786 .61514 m
.40556 .63782 L
s
.24 .35 .67 r
.40693 .64209 m
.41568 .64083 L
s
.83 .24 .1 r
.40556 .63782 m
.40835 .64251 L
s
.768 .232 .103 r
.57066 .40308 m .57276 .40893 L .59435 .42162 L p F P
0 0 0 r
s
.24 .35 .67 r
.58967 .40486 m
.62951 .39803 L
s
.83 .24 .1 r
.57941 .41375 m
.58646 .43367 L
s
.55267 .40902 m
.57941 .41375 L
s
.855 .256 .112 r
.57276 .40893 m .57066 .40308 L .54802 .39436 L p F P
0 0 0 r
s
.164 .219 .436 r
.57418 .61028 m .5549 .61307 L .5564 .59723 L p F P
0 0 0 r
s
.164 .219 .436 r
.5564 .59723 m .57621 .59432 L .57418 .61028 L p F P
0 0 0 r
s
.24 .35 .67 r
.69608 .55785 m
.69337 .53179 L
s
.69337 .53179 m
.73394 .5256 L
s
1 .307 .13 r
.47736 .3876 m .47823 .38964 L .45703 .39737 L p F P
0 0 0 r
s
1 .307 .13 r
.45703 .39737 m .45524 .39336 L .47736 .3876 L p F P
0 0 0 r
s
1 .314 .132 r
.45524 .39336 m .45703 .39737 L .43683 .40748 L p F P
0 0 0 r
s
.135 .173 .347 r
.49777 .63434 m .47984 .6369 L .47876 .62407 L p F P
0 0 0 r
s
.135 .173 .347 r
.47876 .62407 m .49764 .62134 L .49777 .63434 L p F P
0 0 0 r
s
.24 .35 .67 r
.4943 .62956 m
.49676 .61034 L
s
.38 .117 .058 r
.63083 .45239 m .63407 .46242 L .64836 .4808 L p F P
0 0 0 r
s
.504 .158 .074 r
.63407 .46242 m .63083 .45239 L .61385 .43621 L p F P
0 0 0 r
s
.83 .24 .1 r
.63263 .46223 m
.63943 .48315 L
s
.61212 .44816 m
.63263 .46223 L
s
.975 .288 .123 r
.5 .38446 m .5251 .39015 L .5243 .38811 L closepath p F P
0 0 0 r
s
1 .314 .132 r
.43683 .40748 m .43411 .40162 L .45524 .39336 L p F P
0 0 0 r
s
1 .318 .133 r
.43411 .40162 m .43683 .40748 L .41806 .41976 L p F P
0 0 0 r
s
.83 .24 .1 r
.43105 .41218 m
.44275 .43707 L
s
.24 .35 .67 r
.41742 .39055 m
.42621 .40915 L
s
.83 .24 .1 r
.43105 .41218 m
.45743 .39834 L
s
.24 .35 .67 r
.62951 .39803 m
.66978 .39112 L
s
.62951 .39803 m
.62342 .37468 L
s
1 .3 .12 r
.37832 .53942 m .37179 .52791 L .3774 .50838 L p F P
0 0 0 r
s
.996 .278 .11 r
.37179 .52791 m .37832 .53942 L .37582 .55863 L p F P
0 0 0 r
s
1 .299 .127 r
.47823 .38964 m .47736 .3876 L .5 .38446 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.45743 .39834 m
.48558 .38869 L
s
.48558 .38869 m
.492 .40399 L
s
.186 .253 .503 r
.65653 .58255 m .63629 .58552 L .63671 .56753 L p F P
0 0 0 r
s
.186 .253 .503 r
.63671 .56753 m .65702 .56451 L .65653 .58255 L p F P
0 0 0 r
s
.24 .35 .67 r
.61542 .56987 m
.65553 .56389 L
s
.655 .2 .091 r
.59176 .4141 m .59435 .42162 L .61385 .43621 L p F P
0 0 0 r
s
.768 .232 .103 r
.59435 .42162 m .59176 .4141 L .57066 .40308 L p F P
0 0 0 r
s
.24 .35 .67 r
.29167 .39753 m
.33015 .39061 L
s
.29167 .39753 m
.28071 .38947 L
s
.28452 .68145 m
.29358 .672 L
s
.29358 .672 m
.33207 .66656 L
s
.187 .054 .028 r
.65932 .49983 m .66287 .51118 L .6703 .53079 L p F P
0 0 0 r
s
.83 .24 .1 r
.66713 .52558 m
.67037 .53593 L
s
.267 .077 .042 r
.66287 .51118 m .65932 .49983 L .64836 .4808 L p F P
0 0 0 r
s
.83 .24 .1 r
.65632 .50418 m
.66713 .52558 L
s
.24 .35 .67 r
.77083 .4911 m
.76629 .4618 L
s
.76629 .4618 m
.80732 .45523 L
s
.76629 .4618 m
.76147 .43239 L
s
.922 .274 .118 r
.5235 .38606 m .5243 .38811 L .54802 .39436 L p F P
0 0 0 r
s
.975 .288 .123 r
.5 .38446 m .5243 .38811 L .5235 .38606 L closepath p F P
0 0 0 r
s
.164 .219 .436 r
.59356 .60749 m .57418 .61028 L .57621 .59432 L p F P
0 0 0 r
s
.24 .35 .67 r
.53612 .6046 m
.57589 .59879 L
s
.57573 .57579 m
.57589 .59879 L
s
.164 .219 .436 r
.57621 .59432 m .59613 .5914 L .59356 .60749 L p F P
0 0 0 r
s
1 .321 .132 r
.39155 .45994 m .38632 .44987 L .40109 .43398 L p F P
0 0 0 r
s
1 .318 .13 r
.38632 .44987 m .39155 .45994 L .37997 .47809 L p F P
0 0 0 r
s
.83 .24 .1 r
.3874 .45035 m
.40006 .47471 L
s
.855 .256 .112 r
.54652 .39033 m .54802 .39436 L .57066 .40308 L p F P
0 0 0 r
s
.922 .274 .118 r
.54802 .39436 m .54652 .39033 L .5235 .38606 L p F P
0 0 0 r
s
1 .299 .127 r
.47736 .3876 m .47649 .38555 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .307 .13 r
.47649 .38555 m .47736 .3876 L .45524 .39336 L p F P
0 0 0 r
s
1 .318 .133 r
.41806 .41976 m .41441 .41222 L .43411 .40162 L p F P
0 0 0 r
s
1 .321 .133 r
.41441 .41222 m .41806 .41976 L .40109 .43398 L p F P
0 0 0 r
s
.83 .24 .1 r
.40741 .42972 m
.43105 .41218 L
s
.40741 .42972 m
.4196 .45435 L
s
.135 .173 .347 r
.51577 .63177 m .49777 .63434 L .49764 .62134 L p F P
0 0 0 r
s
.135 .173 .347 r
.49764 .62134 m .51663 .6186 L .51577 .63177 L p F P
0 0 0 r
s
.24 .35 .67 r
.71572 .41069 m
.75653 .40383 L
s
.71572 .41069 m
.71048 .38414 L
s
.76147 .43239 m
.80253 .42565 L
s
.76147 .43239 m
.75653 .40383 L
s
.095 .112 .226 r
.43237 .65375 m .41616 .65604 L .40901 .64701 L p F P
0 0 0 r
s
.83 .24 .1 r
.41757 .65584 m
.41905 .65806 L
s
.095 .112 .226 r
.40901 .64701 m .42659 .6445 L .43237 .65375 L p F P
0 0 0 r
s
.245 .071 .038 r
.40339 .63758 m .40901 .64701 L .41616 .65604 L p F P
0 0 0 r
s
.83 .24 .1 r
.40556 .63782 m
.4146 .65138 L
s
.24 .35 .67 r
.4122 .65032 m
.41568 .64083 L
s
.41568 .64083 m
.45478 .63523 L
s
1 .307 .13 r
.45524 .39336 m .45345 .38932 L .47649 .38555 L p F P
0 0 0 r
s
1 .314 .132 r
.45345 .38932 m .45524 .39336 L .43411 .40162 L p F P
0 0 0 r
s
.975 .288 .123 r
.5 .38446 m .51867 .37364 L .51785 .37155 L closepath p F P
0 0 0 r
s
.975 .288 .123 r
.5 .38446 m .51785 .37155 L .51703 .36945 L closepath p F P
0 0 0 r
s
.975 .288 .123 r
.5 .38446 m .5235 .38606 L .5227 .38401 L closepath p F P
0 0 0 r
s
.975 .288 .123 r
.5 .38446 m .5227 .38401 L .5219 .38195 L closepath p F P
0 0 0 r
s
.975 .288 .123 r
.5 .38446 m .5219 .38195 L .5211 .37988 L closepath p F P
0 0 0 r
s
.975 .288 .123 r
.5 .38446 m .5211 .37988 L .52029 .37781 L closepath p F P
0 0 0 r
s
.975 .288 .123 r
.5 .38446 m .52029 .37781 L .51948 .37573 L closepath p F P
0 0 0 r
s
.975 .288 .123 r
.5 .38446 m .51948 .37573 L .51867 .37364 L closepath p F P
0 0 0 r
s
.975 .288 .123 r
.5 .38446 m .51703 .36945 L .51621 .36734 L closepath p F P
0 0 0 r
s
1 .299 .127 r
.47561 .3835 m .47473 .38144 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .299 .127 r
.47649 .38555 m .47561 .3835 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .299 .127 r
.47297 .37729 m .47209 .37521 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .299 .127 r
.47385 .37937 m .47297 .37729 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .299 .127 r
.47473 .38144 m .47385 .37937 L .5 .38446 L closepath p F P
0 0 0 r
s
.291 .434 .851 r
.47522 .37465 m .47209 .37521 L .5 .38446 L closepath p F P
0 0 0 r
s
.291 .434 .851 r
.47836 .37409 m .47522 .37465 L .5 .38446 L closepath p F P
0 0 0 r
s
.291 .434 .851 r
.4815 .37353 m .47836 .37409 L .5 .38446 L closepath p F P
0 0 0 r
s
.291 .434 .851 r
.48464 .37297 m .4815 .37353 L .5 .38446 L closepath p F P
0 0 0 r
s
.291 .434 .851 r
.48779 .37241 m .48464 .37297 L .5 .38446 L closepath p F P
0 0 0 r
s
.291 .434 .851 r
.49093 .37185 m .48779 .37241 L .5 .38446 L closepath p F P
0 0 0 r
s
.291 .434 .851 r
.49408 .37129 m .49093 .37185 L .5 .38446 L closepath p F P
0 0 0 r
s
.291 .434 .851 r
.49724 .37073 m .49408 .37129 L .5 .38446 L closepath p F P
0 0 0 r
s
.291 .434 .851 r
.50039 .37016 m .49724 .37073 L .5 .38446 L closepath p F P
0 0 0 r
s
.291 .434 .851 r
.50355 .3696 m .50039 .37016 L .5 .38446 L closepath p F P
0 0 0 r
s
.291 .434 .851 r
.50671 .36904 m .50355 .3696 L .5 .38446 L closepath p F P
0 0 0 r
s
.291 .434 .851 r
.50988 .36847 m .50671 .36904 L .5 .38446 L closepath p F P
0 0 0 r
s
.291 .434 .851 r
.51304 .36791 m .50988 .36847 L .5 .38446 L closepath p F P
0 0 0 r
s
.291 .434 .851 r
.51621 .36734 m .51304 .36791 L .5 .38446 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.4961 .37658 m
.50384 .39558 L
s
.83 .24 .1 r
.48558 .38869 m
.51448 .3836 L
s
.51448 .3836 m
.52058 .39902 L
s
.186 .253 .503 r
.67688 .57957 m .65653 .58255 L .65702 .56451 L p F P
0 0 0 r
s
.186 .253 .503 r
.65702 .56451 m .67744 .56147 L .67688 .57957 L p F P
0 0 0 r
s
.83 .24 .1 r
.6773 .5658 m
.67927 .57204 L
s
.922 .274 .118 r
.5227 .38401 m .5235 .38606 L .54652 .39033 L p F P
0 0 0 r
s
1 .312 .126 r
.3774 .50838 m .37108 .49697 L .37997 .47809 L p F P
0 0 0 r
s
1 .3 .12 r
.37108 .49697 m .3774 .50838 L .37179 .52791 L p F P
0 0 0 r
s
.83 .24 .1 r
.37483 .52173 m
.3849 .49745 L
s
.37483 .52173 m
.3877 .54463 L
s
.49961 .71479 m
.5102 .73421 L
s
.5102 .73421 m
.5387 .7361 L
s
.768 .232 .103 r
.56855 .39718 m .57066 .40308 L .59176 .4141 L p F P
0 0 0 r
s
.855 .256 .112 r
.57066 .40308 m .56855 .39718 L .54652 .39033 L p F P
0 0 0 r
s
1 .307 .13 r
.47561 .3835 m .47649 .38555 L .45345 .38932 L p F P
0 0 0 r
s
.504 .158 .074 r
.61086 .42723 m .61385 .43621 L .63083 .45239 L p F P
0 0 0 r
s
.655 .2 .091 r
.61385 .43621 m .61086 .42723 L .59176 .4141 L p F P
0 0 0 r
s
.24 .35 .67 r
.77494 .51935 m
.77083 .4911 L
s
.77083 .4911 m
.81199 .48467 L
s
.164 .219 .436 r
.61304 .60467 m .59356 .60749 L .59613 .5914 L p F P
0 0 0 r
s
.164 .219 .436 r
.59613 .5914 m .61615 .58847 L .61304 .60467 L p F P
0 0 0 r
s
.267 .077 .042 r
.64489 .46985 m .64836 .4808 L .65932 .49983 L p F P
0 0 0 r
s
.38 .117 .058 r
.64836 .4808 m .64489 .46985 L .63083 .45239 L p F P
0 0 0 r
s
.24 .35 .67 r
.73706 .55175 m
.73394 .5256 L
s
.73394 .5256 m
.77494 .51935 L
s
1 .314 .132 r
.43411 .40162 m .43137 .3957 L .45345 .38932 L p F P
0 0 0 r
s
1 .318 .133 r
.43137 .3957 m .43411 .40162 L .41441 .41222 L p F P
0 0 0 r
s
.83 .24 .1 r
.64642 .69 m
.66493 .66798 L
s
.65747 .64719 m
.66493 .66798 L
s
.135 .173 .347 r
.53387 .62919 m .51577 .63177 L .51663 .6186 L p F P
0 0 0 r
s
.135 .173 .347 r
.51663 .6186 m .53571 .61584 L .53387 .62919 L p F P
0 0 0 r
s
.922 .274 .118 r
.54652 .39033 m .545 .38627 L .5227 .38401 L p F P
0 0 0 r
s
.922 .274 .118 r
.5219 .38195 m .5227 .38401 L .545 .38627 L p F P
0 0 0 r
s
.855 .256 .112 r
.545 .38627 m .54652 .39033 L .56855 .39718 L p F P
0 0 0 r
s
.24 .35 .67 r
.54832 .3878 m
.58314 .38172 L
s
.45478 .63523 m
.4943 .62956 L
s
.095 .112 .226 r
.44866 .65145 m .43237 .65375 L .42659 .6445 L p F P
0 0 0 r
s
.095 .112 .226 r
.42659 .6445 m .44426 .64198 L .44866 .65145 L p F P
0 0 0 r
s
1 .307 .13 r
.47473 .38144 m .47561 .3835 L .45164 .38526 L p F P
0 0 0 r
s
.24 .35 .67 r
.4571 .38485 m
.45849 .388 L
s
1 .307 .13 r
.45345 .38932 m .45164 .38526 L .47561 .3835 L p F P
0 0 0 r
s
.24 .35 .67 r
.45655 .3836 m
.4569 .38439 L
s
.41742 .39055 m
.45655 .3836 L
s
1 .321 .133 r
.40109 .43398 m .39657 .42497 L .41441 .41222 L p F P
0 0 0 r
s
1 .321 .132 r
.39657 .42497 m .40109 .43398 L .38632 .44987 L p F P
0 0 0 r
s
.83 .24 .1 r
.4379 .67484 m
.44974 .69509 L
s
.44974 .69509 m
.4729 .70746 L
s
.24 .35 .67 r
.66978 .39112 m
.71048 .38414 L
s
.66978 .39112 m
.66415 .36756 L
s
1 .314 .132 r
.45164 .38526 m .45345 .38932 L .43137 .3957 L p F P
0 0 0 r
s
.66 .179 .065 r
.67744 .56147 m .67383 .54997 L .6703 .53079 L p F P
0 0 0 r
s
.855 .238 .09 r
.67383 .54997 m .67744 .56147 L .67688 .57957 L p F P
0 0 0 r
s
.24 .35 .67 r
.67719 .56067 m
.69608 .55785 L
s
.65553 .56389 m
.67496 .561 L
s
.33015 .39061 m
.36905 .38363 L
s
.33015 .39061 m
.31983 .38238 L
s
.32367 .67596 m
.33207 .66656 L
s
.33207 .66656 m
.37098 .66105 L
s
.922 .274 .118 r
.545 .38627 m .54348 .38219 L .5219 .38195 L p F P
0 0 0 r
s
.922 .274 .118 r
.5211 .37988 m .5219 .38195 L .54348 .38219 L p F P
0 0 0 r
s
.655 .2 .091 r
.58914 .4065 m .59176 .4141 L .61086 .42723 L p F P
0 0 0 r
s
.768 .232 .103 r
.59176 .4141 m .58914 .4065 L .56855 .39718 L p F P
0 0 0 r
s
.83 .24 .1 r
.57941 .41375 m
.60371 .42328 L
s
.24 .35 .67 r
.58314 .38172 m
.58967 .40486 L
s
.80732 .45523 m
.81199 .48467 L
s
.80253 .42565 m
.80732 .45523 L
s
1 .307 .13 r
.47385 .37937 m .47473 .38144 L .44983 .38117 L p F P
0 0 0 r
s
1 .307 .13 r
.45164 .38526 m .44983 .38117 L .47473 .38144 L p F P
0 0 0 r
s
1 .318 .13 r
.37997 .47809 m .37406 .4671 L .38632 .44987 L p F P
0 0 0 r
s
1 .312 .126 r
.37406 .4671 m .37997 .47809 L .37108 .49697 L p F P
0 0 0 r
s
.24 .35 .67 r
.58314 .38172 m
.62342 .37468 L
s
.164 .219 .436 r
.63262 .60184 m .61304 .60467 L .61615 .58847 L p F P
0 0 0 r
s
.24 .35 .67 r
.57589 .59879 m
.61609 .59293 L
s
.61542 .56987 m
.61609 .59293 L
s
.164 .219 .436 r
.61615 .58847 m .63629 .58552 L .63262 .60184 L p F P
0 0 0 r
s
.135 .173 .347 r
.55206 .6266 m .53387 .62919 L .53571 .61584 L p F P
0 0 0 r
s
.135 .173 .347 r
.53571 .61584 m .5549 .61307 L .55206 .6266 L p F P
0 0 0 r
s
.24 .35 .67 r
.53425 .62383 m
.53612 .6046 L
s
.095 .112 .226 r
.46501 .64914 m .44866 .65145 L .44426 .64198 L p F P
0 0 0 r
s
.095 .112 .226 r
.44426 .64198 m .46201 .63945 L .46501 .64914 L p F P
0 0 0 r
s
.888 .244 .094 r
.38274 .58789 m .37621 .57679 L .37582 .55863 L p F P
0 0 0 r
s
.72 .193 .072 r
.37621 .57679 m .38274 .58789 L .38589 .60412 L p F P
0 0 0 r
s
.72 .193 .072 r
.39209 .61456 m .38589 .60412 L .38274 .58789 L p F P
0 0 0 r
s
.83 .24 .1 r
.38349 .56929 m
.38516 .59358 L
s
.24 .35 .67 r
.75653 .40383 m
.79778 .39691 L
s
.75653 .40383 m
.75162 .37708 L
s
.187 .054 .028 r
.6703 .53079 m .66666 .51911 L .65932 .49983 L p F P
0 0 0 r
s
.66 .179 .065 r
.66666 .51911 m .6703 .53079 L .67383 .54997 L p F P
0 0 0 r
s
.24 .35 .67 r
.79778 .39691 m
.80253 .42565 L
s
.922 .274 .118 r
.54348 .38219 m .54194 .37808 L .5211 .37988 L p F P
0 0 0 r
s
.922 .274 .118 r
.52029 .37781 m .5211 .37988 L .54194 .37808 L p F P
0 0 0 r
s
.38 .117 .058 r
.62752 .44219 m .63083 .45239 L .64489 .46985 L p F P
0 0 0 r
s
.504 .158 .074 r
.63083 .45239 m .62752 .44219 L .61086 .42723 L p F P
0 0 0 r
s
.83 .24 .1 r
.60371 .42328 m
.61212 .44816 L
s
1 .318 .133 r
.41441 .41222 m .41073 .40459 L .43137 .3957 L p F P
0 0 0 r
s
1 .321 .133 r
.41073 .40459 m .41441 .41222 L .39657 .42497 L p F P
0 0 0 r
s
.24 .35 .67 r
.20372 .40341 m
.242 .39647 L
s
.20372 .40341 m
.19172 .40163 L
s
.768 .232 .103 r
.56642 .39122 m .56855 .39718 L .58914 .4065 L p F P
0 0 0 r
s
.855 .256 .112 r
.56855 .39718 m .56642 .39122 L .545 .38627 L p F P
0 0 0 r
s
.855 .256 .112 r
.54348 .38219 m .545 .38627 L .56642 .39122 L p F P
0 0 0 r
s
1 .307 .13 r
.47297 .37729 m .47385 .37937 L .448 .37705 L p F P
0 0 0 r
s
1 .307 .13 r
.44983 .38117 m .448 .37705 L .47385 .37937 L p F P
0 0 0 r
s
.996 .278 .11 r
.37582 .55863 m .36913 .54708 L .37179 .52791 L p F P
0 0 0 r
s
.888 .244 .094 r
.36913 .54708 m .37582 .55863 L .37621 .57679 L p F P
0 0 0 r
s
.561 .145 .055 r
.38589 .60412 m .39209 .61456 L .39767 .62799 L p F P
0 0 0 r
s
.561 .145 .055 r
.40339 .63758 m .39767 .62799 L .39209 .61456 L p F P
0 0 0 r
s
.83 .24 .1 r
.38516 .59358 m
.39786 .61514 L
s
1 .314 .132 r
.44983 .38117 m .45164 .38526 L .4286 .38973 L p F P
0 0 0 r
s
1 .314 .132 r
.43137 .3957 m .4286 .38973 L .45164 .38526 L p F P
0 0 0 r
s
.24 .35 .67 r
.73706 .55175 m
.69608 .55785 L
s
.6978 .581 m
.69608 .55785 L
s
.81199 .48467 m
.81639 .51303 L
s
1 .318 .133 r
.4286 .38973 m .43137 .3957 L .41073 .40459 L p F P
0 0 0 r
s
.922 .274 .118 r
.54194 .37808 m .5404 .37394 L .52029 .37781 L p F P
0 0 0 r
s
.922 .274 .118 r
.51948 .37573 m .52029 .37781 L .5404 .37394 L p F P
0 0 0 r
s
.83 .24 .1 r
.52862 .71659 m
.5387 .7361 L
s
.5387 .7361 m
.56804 .73233 L
s
.164 .219 .436 r
.65231 .599 m .63262 .60184 L .63629 .58552 L p F P
0 0 0 r
s
.164 .219 .436 r
.63629 .58552 m .65653 .58255 L .65231 .599 L p F P
0 0 0 r
s
.095 .112 .226 r
.48144 .64682 m .46501 .64914 L .46201 .63945 L p F P
0 0 0 r
s
.095 .112 .226 r
.46201 .63945 m .47984 .6369 L .48144 .64682 L p F P
0 0 0 r
s
1 .307 .13 r
.47209 .37521 m .47297 .37729 L .44616 .37291 L p F P
0 0 0 r
s
1 .307 .13 r
.448 .37705 m .44616 .37291 L .47297 .37729 L p F P
0 0 0 r
s
.24 .35 .67 r
.47236 .38079 m
.4961 .37658 L
s
.135 .173 .347 r
.57033 .62399 m .55206 .6266 L .5549 .61307 L p F P
0 0 0 r
s
.135 .173 .347 r
.5549 .61307 m .57418 .61028 L .57033 .62399 L p F P
0 0 0 r
s
.24 .35 .67 r
.77848 .54557 m
.77494 .51935 L
s
.77494 .51935 m
.81639 .51303 L
s
1 .321 .132 r
.38632 .44987 m .38099 .43963 L .39657 .42497 L p F P
0 0 0 r
s
.83 .24 .1 r
.3874 .45035 m
.40741 .42972 L
s
1 .318 .13 r
.38099 .43963 m .38632 .44987 L .37406 .4671 L p F P
0 0 0 r
s
1 .3 .12 r
.37179 .52791 m .36513 .51617 L .37108 .49697 L p F P
0 0 0 r
s
.996 .278 .11 r
.36513 .51617 m .37179 .52791 L .36913 .54708 L p F P
0 0 0 r
s
.83 .24 .1 r
.37039 .54663 m
.37483 .52173 L
s
.24 .35 .67 r
.4943 .62956 m
.53425 .62383 L
s
.83 .24 .1 r
.62331 .70869 m
.64642 .69 L
s
.63854 .66954 m
.64642 .69 L
s
.187 .054 .028 r
.6557 .48825 m .65932 .49983 L .66666 .51911 L p F P
0 0 0 r
s
.267 .077 .042 r
.65932 .49983 m .6557 .48825 L .64489 .46985 L p F P
0 0 0 r
s
.83 .24 .1 r
.64878 .48035 m
.65632 .50418 L
s
.63263 .46223 m
.64878 .48035 L
s
.504 .158 .074 r
.60782 .41812 m .61086 .42723 L .62752 .44219 L p F P
0 0 0 r
s
.655 .2 .091 r
.61086 .42723 m .60782 .41812 L .58914 .4065 L p F P
0 0 0 r
s
.24 .35 .67 r
.71048 .38414 m
.75162 .37708 L
s
.71048 .38414 m
.70531 .36037 L
s
.922 .274 .118 r
.5404 .37394 m .53885 .36978 L .51948 .37573 L p F P
0 0 0 r
s
.922 .274 .118 r
.51867 .37364 m .51948 .37573 L .53885 .36978 L p F P
0 0 0 r
s
.855 .256 .112 r
.56642 .39122 m .56426 .38521 L .54348 .38219 L p F P
0 0 0 r
s
.855 .256 .112 r
.54194 .37808 m .54348 .38219 L .56426 .38521 L p F P
0 0 0 r
s
.83 .24 .1 r
.54306 .38331 m
.55267 .40902 L
s
.51448 .3836 m
.54306 .38331 L
s
.24 .35 .67 r
.36905 .38363 m
.40836 .37656 L
s
.36905 .38363 m
.35938 .37522 L
s
1 .307 .13 r
.44616 .37291 m .44431 .36874 L .47209 .37521 L p F P
0 0 0 r
s
.293 .442 .865 r
.47209 .37521 m .47522 .37465 L .45054 .36762 L p F P
0 0 0 r
s
.293 .442 .865 r
.45054 .36762 m .44431 .36874 L .47209 .37521 L p F P
0 0 0 r
s
.24 .35 .67 r
.36325 .6704 m
.37098 .66105 L
s
.245 .071 .038 r
.39767 .62799 m .40339 .63758 L .41104 .64744 L p F P
0 0 0 r
s
.245 .071 .038 r
.41616 .65604 m .41104 .64744 L .40339 .63758 L p F P
0 0 0 r
s
.24 .35 .67 r
.37098 .66105 m
.4103 .65549 L
s
.4103 .65549 m
.41208 .65064 L
s
.293 .442 .865 r
.47522 .37465 m .47836 .37409 L .45678 .3665 L p F P
0 0 0 r
s
.293 .442 .865 r
.45678 .3665 m .45054 .36762 L .47522 .37465 L p F P
0 0 0 r
s
.24 .35 .67 r
.4481 .36942 m
.45123 .37468 L
s
1 .314 .132 r
.448 .37705 m .44983 .38117 L .42581 .3837 L p F P
0 0 0 r
s
1 .314 .132 r
.4286 .38973 m .42581 .3837 L .44983 .38117 L p F P
0 0 0 r
s
.095 .112 .226 r
.49794 .64449 m .48144 .64682 L .47984 .6369 L p F P
0 0 0 r
s
.095 .112 .226 r
.47984 .6369 m .49777 .63434 L .49794 .64449 L p F P
0 0 0 r
s
.24 .35 .67 r
.49024 .64418 m
.4943 .62956 L
s
.62342 .37468 m
.66415 .36756 L
s
.62342 .37468 m
.61734 .35506 L
s
.293 .442 .865 r
.47836 .37409 m .4815 .37353 L .46304 .36538 L p F P
0 0 0 r
s
.293 .442 .865 r
.46304 .36538 m .45678 .3665 L .47836 .37409 L p F P
0 0 0 r
s
.164 .219 .436 r
.6721 .59614 m .65231 .599 L .65653 .58255 L p F P
0 0 0 r
s
.83 .24 .1 r
.67086 .62267 m
.67819 .5972 L
s
.164 .219 .436 r
.65653 .58255 m .67688 .57957 L .6721 .59614 L p F P
0 0 0 r
s
.24 .35 .67 r
.65553 .56389 m
.65673 .587 L
s
.61609 .59293 m
.65673 .587 L
s
.655 .2 .091 r
.58648 .3988 m .58914 .4065 L .60782 .41812 L p F P
0 0 0 r
s
.768 .232 .103 r
.58914 .4065 m .58648 .3988 L .56642 .39122 L p F P
0 0 0 r
s
.135 .173 .347 r
.5887 .62137 m .57033 .62399 L .57418 .61028 L p F P
0 0 0 r
s
.135 .173 .347 r
.57418 .61028 m .59356 .60749 L .5887 .62137 L p F P
0 0 0 r
s
.24 .35 .67 r
.57463 .61804 m
.57589 .59879 L
s
1 .321 .133 r
.39657 .42497 m .39198 .41583 L .41073 .40459 L p F P
0 0 0 r
s
1 .321 .132 r
.39198 .41583 m .39657 .42497 L .38099 .43963 L p F P
0 0 0 r
s
.922 .274 .118 r
.53885 .36978 m .53729 .3656 L .51867 .37364 L p F P
0 0 0 r
s
.922 .274 .118 r
.51785 .37155 m .51867 .37364 L .53729 .3656 L p F P
0 0 0 r
s
.24 .35 .67 r
.4961 .37658 m
.51999 .37234 L
s
.768 .232 .103 r
.56426 .38521 m .56642 .39122 L .58648 .3988 L p F P
0 0 0 r
s
.293 .442 .865 r
.4815 .37353 m .48464 .37297 L .4693 .36425 L p F P
0 0 0 r
s
.293 .442 .865 r
.4693 .36425 m .46304 .36538 L .4815 .37353 L p F P
0 0 0 r
s
.83 .24 .1 r
.47901 .37301 m
.48558 .38869 L
s
1 .312 .126 r
.37108 .49697 m .36465 .48534 L .37406 .4671 L p F P
0 0 0 r
s
1 .3 .12 r
.36465 .48534 m .37108 .49697 L .36513 .51617 L p F P
0 0 0 r
s
.24 .35 .67 r
.79321 .36995 m
.79778 .39691 L
s
.293 .442 .865 r
.48464 .37297 m .48779 .37241 L .47558 .36312 L p F P
0 0 0 r
s
.293 .442 .865 r
.47558 .36312 m .4693 .36425 L .48464 .37297 L p F P
0 0 0 r
s
.83 .24 .1 r
.47451 .3623 m
.47491 .36324 L
s
.24 .35 .67 r
.242 .39647 m
.28071 .38947 L
s
.242 .39647 m
.23067 .39455 L
s
.267 .077 .042 r
.64136 .45871 m .64489 .46985 L .6557 .48825 L p F P
0 0 0 r
s
.38 .117 .058 r
.64489 .46985 m .64136 .45871 L .62752 .44219 L p F P
0 0 0 r
s
.293 .442 .865 r
.48779 .37241 m .49093 .37185 L .48186 .36199 L p F P
0 0 0 r
s
.293 .442 .865 r
.48186 .36199 m .47558 .36312 L .48779 .37241 L p F P
0 0 0 r
s
.83 .24 .1 r
.55853 .71267 m
.56804 .73233 L
s
.56804 .73233 m
.59673 .72305 L
s
.24 .35 .67 r
.23452 .69047 m
.24578 .68689 L
s
.24578 .68689 m
.28452 .68145 L
s
1 .318 .133 r
.42581 .3837 m .4286 .38973 L .407 .39687 L p F P
0 0 0 r
s
1 .318 .133 r
.41073 .40459 m .407 .39687 L .4286 .38973 L p F P
0 0 0 r
s
.24 .35 .67 r
.40836 .37656 m
.41699 .38988 L
s
1 .321 .133 r
.407 .39687 m .41073 .40459 L .39198 .41583 L p F P
0 0 0 r
s
.293 .442 .865 r
.49093 .37185 m .49408 .37129 L .48816 .36086 L p F P
0 0 0 r
s
.293 .442 .865 r
.48816 .36086 m .48186 .36199 L .49093 .37185 L p F P
0 0 0 r
s
.83 .24 .1 r
.59673 .72305 m
.62331 .70869 L
s
.61493 .68853 m
.62331 .70869 L
s
.922 .274 .118 r
.53729 .3656 m .53572 .36138 L .51785 .37155 L p F P
0 0 0 r
s
.922 .274 .118 r
.51703 .36945 m .51785 .37155 L .53572 .36138 L p F P
0 0 0 r
s
.855 .256 .112 r
.56426 .38521 m .56209 .37914 L .54194 .37808 L p F P
0 0 0 r
s
.855 .256 .112 r
.5404 .37394 m .54194 .37808 L .56209 .37914 L p F P
0 0 0 r
s
.83 .24 .1 r
.41772 .65582 m
.41905 .65806 L
s
.24 .35 .67 r
.77848 .54557 m
.73706 .55175 L
s
.73933 .57494 m
.73706 .55175 L
s
.293 .442 .865 r
.49408 .37129 m .49724 .37073 L .49447 .35972 L p F P
0 0 0 r
s
.293 .442 .865 r
.49447 .35972 m .48816 .36086 L .49408 .37129 L p F P
0 0 0 r
s
.095 .112 .226 r
.51452 .64214 m .49794 .64449 L .49777 .63434 L p F P
0 0 0 r
s
.095 .112 .226 r
.49777 .63434 m .51577 .63177 L .51452 .64214 L p F P
0 0 0 r
s
.293 .442 .865 r
.49724 .37073 m .50039 .37016 L .50079 .35859 L p F P
0 0 0 r
s
.293 .442 .865 r
.50079 .35859 m .49447 .35972 L .49724 .37073 L p F P
0 0 0 r
s
.24 .35 .67 r
.48828 .36221 m
.4961 .37658 L
s
.135 .173 .347 r
.60715 .61874 m .5887 .62137 L .59356 .60749 L p F P
0 0 0 r
s
.135 .173 .347 r
.59356 .60749 m .61304 .60467 L .60715 .61874 L p F P
0 0 0 r
s
.998 .282 .11 r
.67328 .5683 m .67688 .57957 L .6721 .59614 L p F P
0 0 0 r
s
.83 .24 .1 r
.67481 .58675 m
.67819 .5972 L
s
.855 .238 .09 r
.67688 .57957 m .67328 .5683 L .67383 .54997 L p F P
0 0 0 r
s
.83 .24 .1 r
.5878 .70317 m
.59673 .72305 L
s
1 .314 .132 r
.44616 .37291 m .448 .37705 L .42299 .37762 L p F P
0 0 0 r
s
1 .314 .132 r
.42581 .3837 m .42299 .37762 L .448 .37705 L p F P
0 0 0 r
s
.293 .442 .865 r
.50039 .37016 m .50355 .3696 L .50712 .35745 L p F P
0 0 0 r
s
.293 .442 .865 r
.50712 .35745 m .50079 .35859 L .50039 .37016 L p F P
0 0 0 r
s
.83 .24 .1 r
.46142 .68725 m
.4729 .70746 L
s
.4729 .70746 m
.49961 .71479 L
s
.24 .35 .67 r
.81639 .51303 m
.82036 .53933 L
s
.293 .442 .865 r
.50355 .3696 m .50671 .36904 L .51346 .35631 L p F P
0 0 0 r
s
.293 .442 .865 r
.51346 .35631 m .50712 .35745 L .50355 .3696 L p F P
0 0 0 r
s
.83 .24 .1 r
.50395 .35701 m
.50433 .35795 L
s
.24 .35 .67 r
.53425 .62383 m
.57463 .61804 L
s
1 .318 .13 r
.37406 .4671 m .36805 .45591 L .38099 .43963 L p F P
0 0 0 r
s
1 .312 .126 r
.36805 .45591 m .37406 .4671 L .36465 .48534 L p F P
0 0 0 r
s
.83 .24 .1 r
.37184 .47335 m
.3849 .49745 L
s
.922 .274 .118 r
.53572 .36138 m .53413 .35714 L .51703 .36945 L p F P
0 0 0 r
s
.922 .274 .118 r
.51621 .36734 m .51703 .36945 L .53413 .35714 L p F P
0 0 0 r
s
.66 .179 .065 r
.67383 .54997 m .67015 .53825 L .66666 .51911 L p F P
0 0 0 r
s
.855 .238 .09 r
.67015 .53825 m .67383 .54997 L .67328 .5683 L p F P
0 0 0 r
s
.83 .24 .1 r
.66713 .52558 m
.67049 .54156 L
s
.293 .442 .865 r
.50671 .36904 m .50988 .36847 L .51981 .35517 L p F P
0 0 0 r
s
.293 .442 .865 r
.51981 .35517 m .51346 .35631 L .50671 .36904 L p F P
0 0 0 r
s
.38 .117 .058 r
.62417 .43183 m .62752 .44219 L .64136 .45871 L p F P
0 0 0 r
s
.504 .158 .074 r
.62752 .44219 m .62417 .43183 L .60782 .41812 L p F P
0 0 0 r
s
.83 .24 .1 r
.62455 .43735 m
.63263 .46223 L
s
.24 .35 .67 r
.75162 .37708 m
.79321 .36995 L
s
.75162 .37708 m
.74693 .35309 L
s
.67515 .58431 m
.6978 .581 L
s
.65673 .587 m
.67258 .58468 L
s
.293 .442 .865 r
.50988 .36847 m .51304 .36791 L .52617 .35402 L p F P
0 0 0 r
s
.293 .442 .865 r
.52617 .35402 m .51981 .35517 L .50988 .36847 L p F P
0 0 0 r
s
.24 .35 .67 r
.40327 .66478 m
.4103 .65549 L
s
.83 .24 .1 r
.65747 .64719 m
.67086 .62267 L
s
.293 .442 .865 r
.51304 .36791 m .51621 .36734 L .53254 .35288 L p F P
0 0 0 r
s
.293 .442 .865 r
.53254 .35288 m .52617 .35402 L .51304 .36791 L p F P
0 0 0 r
s
.83 .24 .1 r
.50823 .3678 m
.51448 .3836 L
s
.095 .112 .226 r
.53117 .63979 m .51452 .64214 L .51577 .63177 L p F P
0 0 0 r
s
.095 .112 .226 r
.51577 .63177 m .53387 .62919 L .53117 .63979 L p F P
0 0 0 r
s
.768 .232 .103 r
.58648 .3988 m .5838 .391 L .56426 .38521 L p F P
0 0 0 r
s
.768 .232 .103 r
.56209 .37914 m .56426 .38521 L .5838 .391 L p F P
0 0 0 r
s
.83 .24 .1 r
.57026 .38792 m
.57941 .41375 L
s
.54306 .38331 m
.57026 .38792 L
s
.24 .35 .67 r
.57649 .36231 m
.58314 .38172 L
s
.069 .081 .154 r
.43996 .65959 m .42554 .66161 L .41616 .65604 L p F P
0 0 0 r
s
.069 .081 .154 r
.41616 .65604 m .43237 .65375 L .43996 .65959 L p F P
0 0 0 r
s
.365 .111 .056 r
.41104 .64744 m .41616 .65604 L .42554 .66161 L p F P
0 0 0 r
s
.24 .35 .67 r
.4103 .65549 m
.41513 .6548 L
s
.41513 .6548 m
.41533 .65478 L
s
.922 .274 .118 r
.53413 .35714 m .53254 .35288 L .51621 .36734 L p F P
0 0 0 r
s
.855 .256 .112 r
.56209 .37914 m .5599 .37302 L .5404 .37394 L p F P
0 0 0 r
s
.855 .256 .112 r
.53885 .36978 m .5404 .37394 L .5599 .37302 L p F P
0 0 0 r
s
.888 .244 .094 r
.37621 .57679 m .36955 .56546 L .36913 .54708 L p F P
0 0 0 r
s
.72 .193 .072 r
.36955 .56546 m .37621 .57679 L .37957 .59347 L p F P
0 0 0 r
s
.83 .24 .1 r
.37039 .54663 m
.38349 .56929 L
s
.72 .193 .072 r
.38589 .60412 m .37957 .59347 L .37621 .57679 L p F P
0 0 0 r
s
.135 .173 .347 r
.6257 .61609 m .60715 .61874 L .61304 .60467 L p F P
0 0 0 r
s
.135 .173 .347 r
.61304 .60467 m .63262 .60184 L .6257 .61609 L p F P
0 0 0 r
s
.24 .35 .67 r
.61545 .61219 m
.61609 .59293 L
s
.66415 .36756 m
.70531 .36037 L
s
.66415 .36756 m
.65864 .34773 L
s
.187 .054 .028 r
.66666 .51911 m .66295 .50719 L .6557 .48825 L p F P
0 0 0 r
s
.66 .179 .065 r
.66295 .50719 m .66666 .51911 L .67015 .53825 L p F P
0 0 0 r
s
.504 .158 .074 r
.60474 .40888 m .60782 .41812 L .62417 .43183 L p F P
0 0 0 r
s
.83 .24 .1 r
.60371 .42328 m
.62455 .43735 L
s
.655 .2 .091 r
.60782 .41812 m .60474 .40888 L .58648 .3988 L p F P
0 0 0 r
s
.561 .145 .055 r
.37957 .59347 m .38589 .60412 L .39184 .61822 L p F P
0 0 0 r
s
.561 .145 .055 r
.39767 .62799 m .39184 .61822 L .38589 .60412 L p F P
0 0 0 r
s
.83 .24 .1 r
.38516 .59358 m
.39286 .61646 L
s
1 .321 .132 r
.38099 .43963 m .37558 .42922 L .39198 .41583 L p F P
0 0 0 r
s
1 .318 .13 r
.37558 .42922 m .38099 .43963 L .36805 .45591 L p F P
0 0 0 r
s
.83 .24 .1 r
.37184 .47335 m
.3874 .45035 L
s
1 .314 .132 r
.44431 .36874 m .44616 .37291 L .42015 .37149 L p F P
0 0 0 r
s
1 .314 .132 r
.42299 .37762 m .42015 .37149 L .44616 .37291 L p F P
0 0 0 r
s
.83 .24 .1 r
.44581 .37219 m
.45743 .39834 L
s
.24 .35 .67 r
.40836 .37656 m
.42141 .37422 L
s
.655 .2 .091 r
.5838 .391 m .58648 .3988 L .60474 .40888 L p F P
0 0 0 r
s
1 .318 .133 r
.42299 .37762 m .42581 .3837 L .40323 .38905 L p F P
0 0 0 r
s
1 .318 .133 r
.407 .39687 m .40323 .38905 L .42581 .3837 L p F P
0 0 0 r
s
.83 .24 .1 r
.41889 .38628 m
.43105 .41218 L
s
.996 .278 .11 r
.36913 .54708 m .3623 .53529 L .36513 .51617 L p F P
0 0 0 r
s
.888 .244 .094 r
.3623 .53529 m .36913 .54708 L .36955 .56546 L p F P
0 0 0 r
s
.24 .35 .67 r
.28071 .38947 m
.31983 .38238 L
s
.28071 .38947 m
.27004 .3874 L
s
.27392 .68495 m
.28452 .68145 L
s
.28452 .68145 m
.32367 .67596 L
s
.095 .112 .226 r
.54789 .63743 m .53117 .63979 L .53387 .62919 L p F P
0 0 0 r
s
.095 .112 .226 r
.53387 .62919 m .55206 .6266 L .54789 .63743 L p F P
0 0 0 r
s
.069 .081 .154 r
.45442 .65756 m .43996 .65959 L .43237 .65375 L p F P
0 0 0 r
s
.83 .24 .1 r
.41905 .65806 m
.4379 .67484 L
s
.069 .081 .154 r
.43237 .65375 m .44866 .65145 L .45442 .65756 L p F P
0 0 0 r
s
1 .321 .133 r
.39198 .41583 m .38733 .40656 L .407 .39687 L p F P
0 0 0 r
s
1 .321 .132 r
.38733 .40656 m .39198 .41583 L .37558 .42922 L p F P
0 0 0 r
s
.24 .35 .67 r
.82036 .53933 m
.77848 .54557 L
s
.78131 .56882 m
.77848 .54557 L
s
1 .321 .133 r
.40323 .38905 m .407 .39687 L .38733 .40656 L p F P
0 0 0 r
s
.83 .24 .1 r
.39472 .40408 m
.40741 .42972 L
s
.44581 .37219 m
.45633 .36856 L
s
.46839 .36441 m
.47451 .3623 L
s
.41889 .38628 m
.44581 .37219 L
s
.135 .173 .347 r
.64434 .61343 m .6257 .61609 L .63262 .60184 L p F P
0 0 0 r
s
.135 .173 .347 r
.63262 .60184 m .65231 .599 L .64434 .61343 L p F P
0 0 0 r
s
.187 .054 .028 r
.65201 .47645 m .6557 .48825 L .66295 .50719 L p F P
0 0 0 r
s
.83 .24 .1 r
.65972 .50189 m
.66713 .52558 L
s
.267 .077 .042 r
.6557 .48825 m .65201 .47645 L .64136 .45871 L p F P
0 0 0 r
s
.83 .24 .1 r
.64878 .48035 m
.65972 .50189 L
s
1 .3 .12 r
.36513 .51617 m .35833 .50419 L .36465 .48534 L p F P
0 0 0 r
s
.996 .278 .11 r
.35833 .50419 m .36513 .51617 L .3623 .53529 L p F P
0 0 0 r
s
.855 .256 .112 r
.5599 .37302 m .55768 .36684 L .53885 .36978 L p F P
0 0 0 r
s
.855 .256 .112 r
.53729 .3656 m .53885 .36978 L .55768 .36684 L p F P
0 0 0 r
s
.24 .35 .67 r
.5527 .36653 m
.57649 .36231 L
s
.245 .071 .038 r
.39184 .61822 m .39767 .62799 L .40584 .6387 L p F P
0 0 0 r
s
.245 .071 .038 r
.41104 .64744 m .40584 .6387 L .39767 .62799 L p F P
0 0 0 r
s
.83 .24 .1 r
.39286 .61646 m
.40556 .63782 L
s
.24 .35 .67 r
.57463 .61804 m
.61545 .61219 L
s
1 .314 .132 r
.42015 .37149 m .41727 .36529 L .44431 .36874 L p F P
0 0 0 r
s
.24 .35 .67 r
.44117 .37067 m
.4481 .36942 L
s
.287 .44 .858 r
.44431 .36874 m .45054 .36762 L .4265 .36362 L p F P
0 0 0 r
s
.287 .44 .858 r
.4265 .36362 m .41727 .36529 L .44431 .36874 L p F P
0 0 0 r
s
.24 .35 .67 r
.57649 .36231 m
.61734 .35506 L
s
.069 .081 .154 r
.46895 .65552 m .45442 .65756 L .44866 .65145 L p F P
0 0 0 r
s
.069 .081 .154 r
.44866 .65145 m .46501 .64914 L .46895 .65552 L p F P
0 0 0 r
s
.24 .35 .67 r
.41814 .65438 m
.45005 .64986 L
s
.45005 .64986 m
.45478 .63523 L
s
.789 .34574 m
.79321 .36995 L
s
.69845 .60029 m
.6978 .581 L
s
.6978 .581 m
.73933 .57494 L
s
.768 .232 .103 r
.5838 .391 m .58108 .38311 L .56209 .37914 L p F P
0 0 0 r
s
.768 .232 .103 r
.5599 .37302 m .56209 .37914 L .58108 .38311 L p F P
0 0 0 r
s
.095 .112 .226 r
.56469 .63505 m .54789 .63743 L .55206 .6266 L p F P
0 0 0 r
s
.095 .112 .226 r
.55206 .6266 m .57033 .62399 L .56469 .63505 L p F P
0 0 0 r
s
.287 .44 .858 r
.45054 .36762 m .45678 .3665 L .43575 .36194 L p F P
0 0 0 r
s
.287 .44 .858 r
.43575 .36194 m .4265 .36362 L .45054 .36762 L p F P
0 0 0 r
s
.83 .24 .1 r
.44375 .36754 m
.44581 .37219 L
s
.267 .077 .042 r
.63776 .44736 m .64136 .45871 L .65201 .47645 L p F P
0 0 0 r
s
.38 .117 .058 r
.64136 .45871 m .63776 .44736 L .62417 .43183 L p F P
0 0 0 r
s
1 .312 .126 r
.36465 .48534 m .35808 .47348 L .36805 .45591 L p F P
0 0 0 r
s
1 .3 .12 r
.35808 .47348 m .36465 .48534 L .35833 .50419 L p F P
0 0 0 r
s
.83 .24 .1 r
.36143 .49788 m
.37483 .52173 L
s
.135 .173 .347 r
.66307 .61076 m .64434 .61343 L .65231 .599 L p F P
0 0 0 r
s
.135 .173 .347 r
.65231 .599 m .6721 .59614 L .66307 .61076 L p F P
0 0 0 r
s
.24 .35 .67 r
.65672 .60627 m
.65673 .587 L
s
1 .318 .133 r
.42015 .37149 m .42299 .37762 L .39941 .38114 L p F P
0 0 0 r
s
1 .318 .133 r
.40323 .38905 m .39941 .38114 L .42299 .37762 L p F P
0 0 0 r
s
.83 .24 .1 r
.39472 .40408 m
.41889 .38628 L
s
.24 .35 .67 r
.70531 .36037 m
.74693 .35309 L
s
.70531 .36037 m
.70039 .34031 L
s
.287 .44 .858 r
.45678 .3665 m .46304 .36538 L .44503 .36027 L p F P
0 0 0 r
s
.287 .44 .858 r
.44503 .36027 m .43575 .36194 L .45678 .3665 L p F P
0 0 0 r
s
.83 .24 .1 r
.48858 .69456 m
.49961 .71479 L
s
.49961 .71479 m
.52862 .71659 L
s
.855 .256 .112 r
.55768 .36684 m .55545 .3606 L .53729 .3656 L p F P
0 0 0 r
s
.855 .256 .112 r
.53572 .36138 m .53729 .3656 L .55545 .3606 L p F P
0 0 0 r
s
.287 .44 .858 r
.46304 .36538 m .4693 .36425 L .45433 .35858 L p F P
0 0 0 r
s
.287 .44 .858 r
.45433 .35858 m .44503 .36027 L .46304 .36538 L p F P
0 0 0 r
s
.069 .081 .154 r
.48353 .65347 m .46895 .65552 L .46501 .64914 L p F P
0 0 0 r
s
.069 .081 .154 r
.46501 .64914 m .48144 .64682 L .48353 .65347 L p F P
0 0 0 r
s
.24 .35 .67 r
.31983 .38238 m
.35938 .37522 L
s
.31983 .38238 m
.30986 .38017 L
s
.38 .117 .058 r
.62075 .42129 m .62417 .43183 L .63776 .44736 L p F P
0 0 0 r
s
.504 .158 .074 r
.62417 .43183 m .62075 .42129 L .60474 .40888 L p F P
0 0 0 r
s
.655 .2 .091 r
.60474 .40888 m .60162 .3995 L .5838 .391 L p F P
0 0 0 r
s
.655 .2 .091 r
.58108 .38311 m .5838 .391 L .60162 .3995 L p F P
0 0 0 r
s
.83 .24 .1 r
.57026 .38792 m
.59497 .39738 L
s
.095 .112 .226 r
.58157 .63267 m .56469 .63505 L .57033 .62399 L p F P
0 0 0 r
s
.095 .112 .226 r
.57033 .62399 m .5887 .62137 L .58157 .63267 L p F P
0 0 0 r
s
.24 .35 .67 r
.57194 .63262 m
.57463 .61804 L
s
.31377 .67937 m
.32367 .67596 L
s
.32367 .67596 m
.36325 .6704 L
s
.83 .24 .1 r
.63854 .66954 m
.65747 .64719 L
s
.6497 .62554 m
.65747 .64719 L
s
.287 .44 .858 r
.4693 .36425 m .47558 .36312 L .46365 .3569 L p F P
0 0 0 r
s
.83 .24 .1 r
.47451 .3623 m
.50395 .35701 L
s
.287 .44 .858 r
.46365 .3569 m .45433 .35858 L .4693 .36425 L p F P
0 0 0 r
s
1 .318 .13 r
.36805 .45591 m .36192 .44451 L .37558 .42922 L p F P
0 0 0 r
s
1 .312 .126 r
.36192 .44451 m .36805 .45591 L .35808 .47348 L p F P
0 0 0 r
s
.83 .24 .1 r
.36143 .49788 m
.37184 .47335 L
s
.504 .158 .074 r
.60162 .3995 m .60474 .40888 L .62075 .42129 L p F P
0 0 0 r
s
.83 .24 .1 r
.59497 .39738 m
.60371 .42328 L
s
.998 .282 .11 r
.6721 .59614 m .66855 .58534 L .67328 .5683 L p F P
0 0 0 r
s
.998 .282 .11 r
.6696 .5568 m .67328 .5683 L .66855 .58534 L p F P
0 0 0 r
s
.83 .24 .1 r
.67154 .56286 m
.6719 .55509 L
s
.855 .238 .09 r
.67328 .5683 m .6696 .5568 L .67015 .53825 L p F P
0 0 0 r
s
.24 .35 .67 r
.82036 .53933 m
.82375 .56262 L
s
1 .308 .123 r
.66855 .58534 m .6721 .59614 L .66307 .61076 L p F P
0 0 0 r
s
.83 .24 .1 r
.6655 .60681 m
.67086 .62267 L
s
.4379 .67484 m
.46142 .68725 L
s
.50395 .35701 m
.51013 .35691 L
s
.365 .111 .056 r
.40584 .6387 m .41104 .64744 L .42107 .65402 L p F P
0 0 0 r
s
.83 .24 .1 r
.41384 .64928 m
.41511 .65141 L
s
.365 .111 .056 r
.42554 .66161 m .42107 .65402 L .41104 .64744 L p F P
0 0 0 r
s
.287 .44 .858 r
.47558 .36312 m .48186 .36199 L .47299 .35521 L p F P
0 0 0 r
s
.287 .44 .858 r
.47299 .35521 m .46365 .3569 L .47558 .36312 L p F P
0 0 0 r
s
.24 .35 .67 r
.4481 .36942 m
.48828 .36221 L
s
1 .321 .133 r
.39941 .38114 m .40323 .38905 L .38261 .39715 L p F P
0 0 0 r
s
1 .321 .133 r
.38733 .40656 m .38261 .39715 L .40323 .38905 L p F P
0 0 0 r
s
.66 .179 .065 r
.67015 .53825 m .66639 .52627 L .66295 .50719 L p F P
0 0 0 r
s
.855 .238 .09 r
.66639 .52627 m .67015 .53825 L .6696 .5568 L p F P
0 0 0 r
s
.069 .081 .154 r
.49818 .65142 m .48353 .65347 L .48144 .64682 L p F P
0 0 0 r
s
.069 .081 .154 r
.48144 .64682 m .49794 .64449 L .49818 .65142 L p F P
0 0 0 r
s
.24 .35 .67 r
.45005 .64986 m
.49024 .64418 L
s
1 .321 .132 r
.37558 .42922 m .37007 .41864 L .38733 .40656 L p F P
0 0 0 r
s
1 .318 .13 r
.37007 .41864 m .37558 .42922 L .36192 .44451 L p F P
0 0 0 r
s
.83 .24 .1 r
.37422 .42498 m
.3874 .45035 L
s
.287 .44 .858 r
.48186 .36199 m .48816 .36086 L .48236 .35351 L p F P
0 0 0 r
s
.287 .44 .858 r
.48236 .35351 m .47299 .35521 L .48186 .36199 L p F P
0 0 0 r
s
.768 .232 .103 r
.58108 .38311 m .57833 .37513 L .5599 .37302 L p F P
0 0 0 r
s
.768 .232 .103 r
.55768 .36684 m .5599 .37302 L .57833 .37513 L p F P
0 0 0 r
s
.24 .35 .67 r
.61545 .61219 m
.65672 .60627 L
s
.19172 .40163 m
.23067 .39455 L
s
.19172 .40163 m
.18049 .40621 L
s
.095 .112 .226 r
.59852 .63027 m .58157 .63267 L .5887 .62137 L p F P
0 0 0 r
s
.095 .112 .226 r
.5887 .62137 m .60715 .61874 L .59852 .63027 L p F P
0 0 0 r
s
1 .321 .132 r
.38261 .39715 m .38733 .40656 L .37007 .41864 L p F P
0 0 0 r
s
.83 .24 .1 r
.37422 .42498 m
.39472 .40408 L
s
.855 .256 .112 r
.55545 .3606 m .55319 .3543 L .53572 .36138 L p F P
0 0 0 r
s
.855 .256 .112 r
.53413 .35714 m .53572 .36138 L .55319 .3543 L p F P
0 0 0 r
s
.24 .35 .67 r
.61734 .35506 m
.65864 .34773 L
s
.61734 .35506 m
.61148 .34007 L
s
.74063 .59424 m
.73933 .57494 L
s
.73933 .57494 m
.78131 .56882 L
s
.287 .44 .858 r
.48816 .36086 m .49447 .35972 L .49176 .35181 L p F P
0 0 0 r
s
.287 .44 .858 r
.49176 .35181 m .48236 .35351 L .48816 .36086 L p F P
0 0 0 r
s
.888 .244 .094 r
.36955 .56546 m .36274 .5539 L .3623 .53529 L p F P
0 0 0 r
s
.72 .193 .072 r
.36274 .5539 m .36955 .56546 L .37311 .58262 L p F P
0 0 0 r
s
.72 .193 .072 r
.37957 .59347 m .37311 .58262 L .36955 .56546 L p F P
0 0 0 r
s
.83 .24 .1 r
.37039 .54663 m
.37194 .57115 L
s
1 .318 .133 r
.41727 .36529 m .42015 .37149 L .39554 .37313 L p F P
0 0 0 r
s
.24 .35 .67 r
.40416 .37255 m
.40836 .37656 L
s
1 .318 .133 r
.39941 .38114 m .39554 .37313 L .42015 .37149 L p F P
0 0 0 r
s
.561 .145 .055 r
.37311 .58262 m .37957 .59347 L .3859 .60827 L p F P
0 0 0 r
s
.561 .145 .055 r
.39184 .61822 m .3859 .60827 L .37957 .59347 L p F P
0 0 0 r
s
.83 .24 .1 r
.37194 .57115 m
.38516 .59358 L
s
.187 .054 .028 r
.66295 .50719 m .65916 .49503 L .65201 .47645 L p F P
0 0 0 r
s
.66 .179 .065 r
.65916 .49503 m .66295 .50719 L .66639 .52627 L p F P
0 0 0 r
s
.287 .44 .858 r
.49447 .35972 m .50079 .35859 L .50117 .35011 L p F P
0 0 0 r
s
.287 .44 .858 r
.50117 .35011 m .49176 .35181 L .49447 .35972 L p F P
0 0 0 r
s
.069 .081 .154 r
.51287 .64936 m .49818 .65142 L .49794 .64449 L p F P
0 0 0 r
s
.069 .081 .154 r
.49794 .64449 m .51452 .64214 L .51287 .64936 L p F P
0 0 0 r
s
.24 .35 .67 r
.74693 .35309 m
.789 .34574 L
s
.74693 .35309 m
.74261 .33282 L
s
.996 .278 .11 r
.3623 .53529 m .35533 .52326 L .35833 .50419 L p F P
0 0 0 r
s
.888 .244 .094 r
.35533 .52326 m .3623 .53529 L .36274 .5539 L p F P
0 0 0 r
s
.287 .44 .858 r
.50079 .35859 m .50712 .35745 L .51061 .3484 L p F P
0 0 0 r
s
.287 .44 .858 r
.51061 .3484 m .50117 .35011 L .50079 .35859 L p F P
0 0 0 r
s
.095 .112 .226 r
.61555 .62787 m .59852 .63027 L .60715 .61874 L p F P
0 0 0 r
s
.095 .112 .226 r
.60715 .61874 m .6257 .61609 L .61555 .62787 L p F P
0 0 0 r
s
.24 .35 .67 r
.61347 .62674 m
.61545 .61219 L
s
.35938 .37522 m
.35012 .37286 L
s
.245 .071 .038 r
.3859 .60827 m .39184 .61822 L .40055 .6298 L p F P
0 0 0 r
s
.245 .071 .038 r
.40584 .6387 m .40055 .6298 L .39184 .61822 L p F P
0 0 0 r
s
.83 .24 .1 r
.51813 .69627 m
.52862 .71659 L
s
.52862 .71659 m
.55853 .71267 L
s
.24 .35 .67 r
.35406 .67373 m
.36325 .6704 L
s
.36325 .6704 m
.40327 .66478 L
s
.287 .44 .858 r
.50712 .35745 m .51346 .35631 L .52008 .34668 L p F P
0 0 0 r
s
.287 .44 .858 r
.52008 .34668 m .51061 .3484 L .50712 .35745 L p F P
0 0 0 r
s
.187 .054 .028 r
.64825 .46441 m .65201 .47645 L .65916 .49503 L p F P
0 0 0 r
s
.267 .077 .042 r
.65201 .47645 m .64825 .46441 L .63776 .44736 L p F P
0 0 0 r
s
.855 .256 .112 r
.55319 .3543 m .55092 .34794 L .53413 .35714 L p F P
0 0 0 r
s
.855 .256 .112 r
.53254 .35288 m .53413 .35714 L .55092 .34794 L p F P
0 0 0 r
s
.83 .24 .1 r
.53306 .35654 m
.54306 .38331 L
s
.52233 .35671 m
.53306 .35654 L
s
.655 .2 .091 r
.60162 .3995 m .59845 .38998 L .58108 .38311 L p F P
0 0 0 r
s
.655 .2 .091 r
.57833 .37513 m .58108 .38311 L .59845 .38998 L p F P
0 0 0 r
s
1 .3 .12 r
.35833 .50419 m .35139 .49197 L .35808 .47348 L p F P
0 0 0 r
s
.996 .278 .11 r
.35139 .49197 m .35833 .50419 L .35533 .52326 L p F P
0 0 0 r
s
.83 .24 .1 r
.35675 .52303 m
.36143 .49788 L
s
.069 .081 .154 r
.52763 .64728 m .51287 .64936 L .51452 .64214 L p F P
0 0 0 r
s
.069 .081 .154 r
.51452 .64214 m .53117 .63979 L .52763 .64728 L p F P
0 0 0 r
s
.83 .24 .1 r
.61493 .68853 m
.63854 .66954 L
s
.63033 .64822 m
.63854 .66954 L
s
.287 .44 .858 r
.51346 .35631 m .51981 .35517 L .52957 .34497 L p F P
0 0 0 r
s
.287 .44 .858 r
.52957 .34497 m .52008 .34668 L .51346 .35631 L p F P
0 0 0 r
s
.768 .232 .103 r
.57833 .37513 m .57554 .36705 L .55768 .36684 L p F P
0 0 0 r
s
.768 .232 .103 r
.55545 .3606 m .55768 .36684 L .57554 .36705 L p F P
0 0 0 r
s
.287 .44 .858 r
.51981 .35517 m .52617 .35402 L .53908 .34324 L p F P
0 0 0 r
s
.287 .44 .858 r
.53908 .34324 m .52957 .34497 L .51981 .35517 L p F P
0 0 0 r
s
.24 .35 .67 r
.52889 .35491 m
.53156 .36032 L
s
.48828 .36221 m
.52889 .35491 L
s
.267 .077 .042 r
.6341 .4358 m .63776 .44736 L .64825 .46441 L p F P
0 0 0 r
s
.83 .24 .1 r
.64093 .45555 m
.64878 .48035 L
s
.38 .117 .058 r
.63776 .44736 m .6341 .4358 L .62075 .42129 L p F P
0 0 0 r
s
.83 .24 .1 r
.62455 .43735 m
.64093 .45555 L
s
.095 .112 .226 r
.63266 .62545 m .61555 .62787 L .6257 .61609 L p F P
0 0 0 r
s
.095 .112 .226 r
.6257 .61609 m .64434 .61343 L .63266 .62545 L p F P
0 0 0 r
s
1 .321 .133 r
.39554 .37313 m .39941 .38114 L .37781 .3876 L p F P
0 0 0 r
s
1 .321 .133 r
.38261 .39715 m .37781 .3876 L .39941 .38114 L p F P
0 0 0 r
s
.24 .35 .67 r
.65672 .60627 m
.66427 .60519 L
s
.23067 .39455 m
.27004 .3874 L
s
.23067 .39455 m
.22011 .39903 L
s
.22212 .68765 m
.23452 .69047 L
s
.23452 .69047 m
.27392 .68495 L
s
.504 .158 .074 r
.62075 .42129 m .61728 .41057 L .60162 .3995 L p F P
0 0 0 r
s
.504 .158 .074 r
.59845 .38998 m .60162 .3995 L .61728 .41057 L p F P
0 0 0 r
s
1 .318 .133 r
.39554 .37313 m .39162 .36502 L .41727 .36529 L p F P
0 0 0 r
s
.24 .35 .67 r
.35938 .37522 m
.39356 .36903 L
s
.263 .411 .799 r
.41727 .36529 m .4265 .36362 L .40368 .36283 L p F P
0 0 0 r
s
.263 .411 .799 r
.40368 .36283 m .39162 .36502 L .41727 .36529 L p F P
0 0 0 r
s
.83 .24 .1 r
.4088 .36482 m
.41889 .38628 L
s
1 .312 .126 r
.35808 .47348 m .35139 .46138 L .36192 .44451 L p F P
0 0 0 r
s
1 .3 .12 r
.35139 .46138 m .35808 .47348 L .35139 .49197 L p F P
0 0 0 r
s
.287 .44 .858 r
.52617 .35402 m .53254 .35288 L .54862 .34152 L p F P
0 0 0 r
s
.287 .44 .858 r
.54862 .34152 m .53908 .34324 L .52617 .35402 L p F P
0 0 0 r
s
.24 .35 .67 r
.65864 .34773 m
.70039 .34031 L
s
.65864 .34773 m
.65346 .33253 L
s
.38 .117 .058 r
.61728 .41057 m .62075 .42129 L .6341 .4358 L p F P
0 0 0 r
s
.24 .35 .67 r
.78329 .58812 m
.78131 .56882 L
s
.78131 .56882 m
.82375 .56262 L
s
.069 .081 .154 r
.54245 .64521 m .52763 .64728 L .53117 .63979 L p F P
0 0 0 r
s
.24 .35 .67 r
.49024 .64418 m
.53087 .63843 L
s
.069 .081 .154 r
.53117 .63979 m .54789 .63743 L .54245 .64521 L p F P
0 0 0 r
s
.24 .35 .67 r
.53087 .63843 m
.53425 .62383 L
s
.52889 .35491 m
.53599 .35363 L
s
.55193 .35077 m
.56996 .34753 L
s
.042 .053 .102 r
.44926 .66172 m .43706 .66343 L .42554 .66161 L p F P
0 0 0 r
s
.042 .053 .102 r
.42554 .66161 m .43996 .65959 L .44926 .66172 L p F P
0 0 0 r
s
.486 .155 .073 r
.42107 .65402 m .42554 .66161 L .43706 .66343 L p F P
0 0 0 r
s
.83 .24 .1 r
.43064 .66242 m
.43073 .66257 L
s
.43073 .66257 m
.4379 .67484 L
s
.855 .256 .112 r
.55092 .34794 m .54862 .34152 L .53254 .35288 L p F P
0 0 0 r
s
.83 .24 .1 r
.53128 .35178 m
.53306 .35654 L
s
.263 .411 .799 r
.4265 .36362 m .43575 .36194 L .41577 .36064 L p F P
0 0 0 r
s
.263 .411 .799 r
.41577 .36064 m .40368 .36283 L .4265 .36362 L p F P
0 0 0 r
s
.83 .24 .1 r
.40622 .35932 m
.40754 .36213 L
s
.54862 .69219 m
.55853 .71267 L
s
.55853 .71267 m
.5878 .70317 L
s
.365 .111 .056 r
.40055 .6298 m .40584 .6387 L .41654 .64632 L p F P
0 0 0 r
s
.83 .24 .1 r
.39286 .61646 m
.40446 .63385 L
s
.40882 .64082 m
.41011 .643 L
s
.365 .111 .056 r
.42107 .65402 m .41654 .64632 L .40584 .6387 L p F P
0 0 0 r
s
.24 .35 .67 r
.7853 .32524 m
.789 .34574 L
s
1 .318 .13 r
.36192 .44451 m .35568 .43289 L .37007 .41864 L p F P
0 0 0 r
s
1 .312 .126 r
.35568 .43289 m .36192 .44451 L .35139 .46138 L p F P
0 0 0 r
s
.83 .24 .1 r
.35824 .44825 m
.37184 .47335 L
s
1 .321 .132 r
.37781 .3876 m .38261 .39715 L .36447 .40788 L p F P
0 0 0 r
s
1 .321 .132 r
.37007 .41864 m .36447 .40788 L .38261 .39715 L p F P
0 0 0 r
s
.095 .112 .226 r
.64985 .62302 m .63266 .62545 L .64434 .61343 L p F P
0 0 0 r
s
.095 .112 .226 r
.64434 .61343 m .66307 .61076 L .64985 .62302 L p F P
0 0 0 r
s
.83 .24 .1 r
.5878 .70317 m
.61493 .68853 L
s
.60619 .66753 m
.61493 .68853 L
s
1 .318 .13 r
.36447 .40788 m .37007 .41864 L .35568 .43289 L p F P
0 0 0 r
s
.83 .24 .1 r
.35824 .44825 m
.37422 .42498 L
s
.263 .411 .799 r
.43575 .36194 m .44503 .36027 L .4279 .35843 L p F P
0 0 0 r
s
.24 .35 .67 r
.4398 .36066 m
.4481 .36942 L
s
.263 .411 .799 r
.4279 .35843 m .41577 .36064 L .43575 .36194 L p F P
0 0 0 r
s
.24 .35 .67 r
.40745 .36652 m
.4398 .36066 L
s
.069 .081 .154 r
.55732 .64312 m .54245 .64521 L .54789 .63743 L p F P
0 0 0 r
s
.069 .081 .154 r
.54789 .63743 m .56469 .63505 L .55732 .64312 L p F P
0 0 0 r
s
.042 .053 .102 r
.4615 .66001 m .44926 .66172 L .43996 .65959 L p F P
0 0 0 r
s
.042 .053 .102 r
.43996 .65959 m .45442 .65756 L .4615 .66001 L p F P
0 0 0 r
s
.24 .35 .67 r
.44373 .65911 m
.45005 .64986 L
s
1 .308 .123 r
.66307 .61076 m .65962 .60067 L .66855 .58534 L p F P
0 0 0 r
s
.83 .24 .1 r
.6673 .58749 m
.66864 .58291 L
s
1 .308 .123 r
.66493 .57433 m .66855 .58534 L .65962 .60067 L p F P
0 0 0 r
s
.24 .35 .67 r
.66608 .60493 m
.69845 .60029 L
s
.998 .282 .11 r
.66855 .58534 m .66493 .57433 L .6696 .5568 L p F P
0 0 0 r
s
.998 .282 .11 r
.66585 .54506 m .6696 .5568 L .66493 .57433 L p F P
0 0 0 r
s
.855 .238 .09 r
.6696 .5568 m .66585 .54506 L .66639 .52627 L p F P
0 0 0 r
s
.24 .35 .67 r
.3948 .66802 m
.40327 .66478 L
s
.40327 .66478 m
.42695 .66146 L
s
.42695 .66146 m
.42825 .66128 L
s
.83 .24 .1 r
.57848 .68245 m
.5878 .70317 L
s
.44945 .6662 m
.46142 .68725 L
s
.46142 .68725 m
.48858 .69456 L
s
.768 .232 .103 r
.57554 .36705 m .57272 .35887 L .55545 .3606 L p F P
0 0 0 r
s
.83 .24 .1 r
.56073 .36102 m
.57026 .38792 L
s
.768 .232 .103 r
.55319 .3543 m .55545 .3606 L .57272 .35887 L p F P
0 0 0 r
s
.24 .35 .67 r
.56996 .34753 m
.57649 .36231 L
s
.83 .24 .1 r
.53306 .35654 m
.56073 .36102 L
s
.263 .411 .799 r
.44503 .36027 m .45433 .35858 L .44007 .35622 L p F P
0 0 0 r
s
.263 .411 .799 r
.44007 .35622 m .4279 .35843 L .44503 .36027 L p F P
0 0 0 r
s
.83 .24 .1 r
.43371 .34496 m
.43882 .35645 L
s
.66 .179 .065 r
.66639 .52627 m .66256 .51405 L .65916 .49503 L p F P
0 0 0 r
s
.855 .238 .09 r
.66256 .51405 m .66639 .52627 L .66585 .54506 L p F P
0 0 0 r
s
.83 .24 .1 r
.65972 .50189 m
.66286 .51692 L
s
.655 .2 .091 r
.59845 .38998 m .59523 .38033 L .57833 .37513 L p F P
0 0 0 r
s
.655 .2 .091 r
.57554 .36705 m .57833 .37513 L .59523 .38033 L p F P
0 0 0 r
s
1 .323 .13 r
.65962 .60067 m .66307 .61076 L .64985 .62302 L p F P
0 0 0 r
s
.24 .35 .67 r
.65661 .60755 m
.65672 .60627 L
s
.83 .24 .1 r
.6497 .62554 m
.6524 .62065 L
s
.042 .053 .102 r
.47378 .65829 m .4615 .66001 L .45442 .65756 L p F P
0 0 0 r
s
.042 .053 .102 r
.45442 .65756 m .46895 .65552 L .47378 .65829 L p F P
0 0 0 r
s
.069 .081 .154 r
.57226 .64102 m .55732 .64312 L .56469 .63505 L p F P
0 0 0 r
s
.069 .081 .154 r
.56469 .63505 m .58157 .63267 L .57226 .64102 L p F P
0 0 0 r
s
.24 .35 .67 r
.53087 .63843 m
.57194 .63262 L
s
.263 .411 .799 r
.45433 .35858 m .46365 .3569 L .45228 .354 L p F P
0 0 0 r
s
.263 .411 .799 r
.45228 .354 m .44007 .35622 L .45433 .35858 L p F P
0 0 0 r
s
.24 .35 .67 r
.69794 .61479 m
.69845 .60029 L
s
.69845 .60029 m
.74063 .59424 L
s
.27004 .3874 m
.30986 .38017 L
s
.27004 .3874 m
.26018 .39177 L
s
.72 .193 .072 r
.37311 .58262 m .36654 .57155 L .36274 .5539 L p F P
0 0 0 r
s
.561 .145 .055 r
.36654 .57155 m .37311 .58262 L .37985 .59813 L p F P
0 0 0 r
s
.561 .145 .055 r
.3859 .60827 m .37985 .59813 L .37311 .58262 L p F P
0 0 0 r
s
.83 .24 .1 r
.37194 .57115 m
.37964 .59422 L
s
.888 .244 .094 r
.36274 .5539 m .3558 .5421 L .35533 .52326 L p F P
0 0 0 r
s
.72 .193 .072 r
.3558 .5421 m .36274 .5539 L .36654 .57155 L p F P
0 0 0 r
s
.83 .24 .1 r
.35675 .52303 m
.37039 .54663 L
s
.24 .35 .67 r
.2622 .68201 m
.27392 .68495 L
s
.27392 .68495 m
.31377 .67937 L
s
.70039 .34031 m
.74261 .33282 L
s
.70039 .34031 m
.69592 .3249 L
s
1 .321 .133 r
.39162 .36502 m .39554 .37313 L .37295 .3779 L p F P
0 0 0 r
s
1 .321 .133 r
.37781 .3876 m .37295 .3779 L .39554 .37313 L p F P
0 0 0 r
s
.187 .054 .028 r
.65916 .49503 m .65529 .48262 L .64825 .46441 L p F P
0 0 0 r
s
.66 .179 .065 r
.65529 .48262 m .65916 .49503 L .66256 .51405 L p F P
0 0 0 r
s
.24 .35 .67 r
.82375 .56262 m
.82643 .58194 L
s
.56996 .34753 m
.61148 .34007 L
s
.263 .411 .799 r
.46365 .3569 m .47299 .35521 L .46454 .35178 L p F P
0 0 0 r
s
.263 .411 .799 r
.46454 .35178 m .45228 .354 L .46365 .3569 L p F P
0 0 0 r
s
.245 .071 .038 r
.37985 .59813 m .3859 .60827 L .39517 .62076 L p F P
0 0 0 r
s
.245 .071 .038 r
.40055 .6298 m .39517 .62076 L .3859 .60827 L p F P
0 0 0 r
s
.83 .24 .1 r
.37964 .59422 m
.39286 .61646 L
s
.996 .278 .11 r
.35533 .52326 m .34821 .51097 L .35139 .49197 L p F P
0 0 0 r
s
.888 .244 .094 r
.34821 .51097 m .35533 .52326 L .3558 .5421 L p F P
0 0 0 r
s
.042 .053 .102 r
.4861 .65657 m .47378 .65829 L .46895 .65552 L p F P
0 0 0 r
s
.042 .053 .102 r
.46895 .65552 m .48353 .65347 L .4861 .65657 L p F P
0 0 0 r
s
.069 .081 .154 r
.58725 .63892 m .57226 .64102 L .58157 .63267 L p F P
0 0 0 r
s
.069 .081 .154 r
.58157 .63267 m .59852 .63027 L .58725 .63892 L p F P
0 0 0 r
s
.504 .158 .074 r
.61728 .41057 m .61376 .39967 L .59845 .38998 L p F P
0 0 0 r
s
.504 .158 .074 r
.59523 .38033 m .59845 .38998 L .61376 .39967 L p F P
0 0 0 r
s
.187 .054 .028 r
.64441 .45213 m .64825 .46441 L .65529 .48262 L p F P
0 0 0 r
s
.83 .24 .1 r
.652 .47723 m
.65972 .50189 L
s
.267 .077 .042 r
.64825 .46441 m .64441 .45213 L .6341 .4358 L p F P
0 0 0 r
s
.83 .24 .1 r
.64093 .45555 m
.652 .47723 L
s
.263 .411 .799 r
.47299 .35521 m .48236 .35351 L .47683 .34955 L p F P
0 0 0 r
s
.263 .411 .799 r
.47683 .34955 m .46454 .35178 L .47299 .35521 L p F P
0 0 0 r
s
.83 .24 .1 r
.46299 .33483 m
.4697 .35084 L
s
.46299 .33483 m
.43371 .34496 L
s
.4211 .31658 m
.43371 .34496 L
s
.40622 .35932 m
.43371 .34496 L
s
.486 .155 .073 r
.41654 .64632 m .42107 .65402 L .43335 .65703 L p F P
0 0 0 r
s
.83 .24 .1 r
.41273 .64239 m
.41883 .64778 L
s
.486 .155 .073 r
.43706 .66343 m .43335 .65703 L .42107 .65402 L p F P
0 0 0 r
s
.24 .35 .67 r
.43525 .6603 m
.44373 .65911 L
s
.768 .232 .103 r
.57272 .35887 m .56987 .35058 L .55319 .3543 L p F P
0 0 0 r
s
.768 .232 .103 r
.55092 .34794 m .55319 .3543 L .56987 .35058 L p F P
0 0 0 r
s
1 .3 .12 r
.35139 .49197 m .34431 .47949 L .35139 .46138 L p F P
0 0 0 r
s
.996 .278 .11 r
.34431 .47949 m .35139 .49197 L .34821 .51097 L p F P
0 0 0 r
s
.267 .077 .042 r
.63037 .42402 m .6341 .4358 L .64441 .45213 L p F P
0 0 0 r
s
.38 .117 .058 r
.6341 .4358 m .63037 .42402 L .61728 .41057 L p F P
0 0 0 r
s
.38 .117 .058 r
.61376 .39967 m .61728 .41057 L .63037 .42402 L p F P
0 0 0 r
s
.83 .24 .1 r
.61613 .41145 m
.62455 .43735 L
s
.59497 .39738 m
.61613 .41145 L
s
.042 .053 .102 r
.49846 .65484 m .4861 .65657 L .48353 .65347 L p F P
0 0 0 r
s
.042 .053 .102 r
.48353 .65347 m .49818 .65142 L .49846 .65484 L p F P
0 0 0 r
s
.24 .35 .67 r
.44373 .65911 m
.48464 .65336 L
s
.48464 .65336 m
.49024 .64418 L
s
.263 .411 .799 r
.48236 .35351 m .49176 .35181 L .48917 .34731 L p F P
0 0 0 r
s
.263 .411 .799 r
.48917 .34731 m .47683 .34955 L .48236 .35351 L p F P
0 0 0 r
s
.24 .35 .67 r
.48067 .35326 m
.48828 .36221 L
s
.4398 .36066 m
.48067 .35326 L
s
1 .321 .132 r
.37295 .3779 m .37781 .3876 L .35878 .39693 L p F P
0 0 0 r
s
1 .321 .132 r
.36447 .40788 m .35878 .39693 L .37781 .3876 L p F P
0 0 0 r
s
.83 .24 .1 r
.39301 .33121 m
.40622 .35932 L
s
.40065 .36338 m
.40622 .35932 L
s
.069 .081 .154 r
.60231 .6368 m .58725 .63892 L .59852 .63027 L p F P
0 0 0 r
s
.069 .081 .154 r
.59852 .63027 m .61555 .62787 L .60231 .6368 L p F P
0 0 0 r
s
.83 .24 .1 r
.49299 .32931 m
.46299 .33483 L
s
.45098 .30619 m
.46299 .33483 L
s
1 .312 .126 r
.35139 .46138 m .34456 .44904 L .35568 .43289 L p F P
0 0 0 r
s
1 .3 .12 r
.34456 .44904 m .35139 .46138 L .34431 .47949 L p F P
0 0 0 r
s
.83 .24 .1 r
.34748 .47305 m
.36143 .49788 L
s
.365 .111 .056 r
.39517 .62076 m .40055 .6298 L .41193 .6385 L p F P
0 0 0 r
s
.83 .24 .1 r
.40373 .63223 m
.40504 .63444 L
s
.365 .111 .056 r
.41654 .64632 m .41193 .6385 L .40055 .6298 L p F P
0 0 0 r
s
.263 .411 .799 r
.49176 .35181 m .50117 .35011 L .50154 .34506 L p F P
0 0 0 r
s
.83 .24 .1 r
.50118 .35 m
.50122 .3501 L
s
.263 .411 .799 r
.50154 .34506 m .48917 .34731 L .49176 .35181 L p F P
0 0 0 r
s
.83 .24 .1 r
.49299 .32931 m
.49938 .34545 L
s
.655 .2 .091 r
.59523 .38033 m .59197 .37053 L .57554 .36705 L p F P
0 0 0 r
s
.655 .2 .091 r
.57272 .35887 m .57554 .36705 L .59197 .37053 L p F P
0 0 0 r
s
.24 .35 .67 r
.74088 .60871 m
.74063 .59424 L
s
.74063 .59424 m
.78329 .58812 L
s
.042 .053 .102 r
.51086 .6531 m .49846 .65484 L .49818 .65142 L p F P
0 0 0 r
s
.042 .053 .102 r
.49818 .65142 m .51287 .64936 L .51086 .6531 L p F P
0 0 0 r
s
.24 .35 .67 r
.30986 .38017 m
.35012 .37286 L
s
.30986 .38017 m
.30071 .38442 L
s
1 .318 .13 r
.35878 .39693 m .36447 .40788 L .34932 .42106 L p F P
0 0 0 r
s
1 .318 .13 r
.35568 .43289 m .34932 .42106 L .36447 .40788 L p F P
0 0 0 r
s
.83 .24 .1 r
.3605 .39856 m
.37422 .42498 L
s
1 .312 .126 r
.34932 .42106 m .35568 .43289 L .34456 .44904 L p F P
0 0 0 r
s
.83 .24 .1 r
.34748 .47305 m
.35824 .44825 L
s
.24 .35 .67 r
.30273 .6763 m
.31377 .67937 L
s
.31377 .67937 m
.35406 .67373 L
s
.74261 .33282 m
.7853 .32524 L
s
.74261 .33282 m
.73885 .31719 L
s
.263 .411 .799 r
.50117 .35011 m .51061 .3484 L .51396 .3428 L p F P
0 0 0 r
s
.263 .411 .799 r
.51396 .3428 m .50154 .34506 L .50117 .35011 L p F P
0 0 0 r
s
.83 .24 .1 r
.47708 .67348 m
.48858 .69456 L
s
.48858 .69456 m
.51813 .69627 L
s
1 .321 .133 r
.37295 .3779 m .36801 .36807 L .39162 .36502 L p F P
0 0 0 r
s
.83 .24 .1 r
.3815 .37739 m
.39472 .40408 L
s
.206 .334 .645 r
.39162 .36502 m .40368 .36283 L .38265 .36541 L p F P
0 0 0 r
s
.206 .334 .645 r
.38265 .36541 m .36801 .36807 L .39162 .36502 L p F P
0 0 0 r
s
.83 .24 .1 r
.3815 .37739 m
.39916 .36448 L
s
.24 .35 .67 r
.39083 .36547 m
.39696 .36727 L
s
.069 .081 .154 r
.61743 .63468 m .60231 .6368 L .61555 .62787 L p F P
0 0 0 r
s
.24 .35 .67 r
.57194 .63262 m
.61347 .62674 L
s
.069 .081 .154 r
.61555 .62787 m .63266 .62545 L .61743 .63468 L p F P
0 0 0 r
s
.24 .35 .67 r
.61148 .34007 m
.65346 .33253 L
s
.61148 .34007 m
.60609 .33056 L
s
.263 .411 .799 r
.51061 .3484 m .52008 .34668 L .52642 .34054 L p F P
0 0 0 r
s
.263 .411 .799 r
.52642 .34054 m .51396 .3428 L .51061 .3484 L p F P
0 0 0 r
s
.042 .053 .102 r
.52331 .65136 m .51086 .6531 L .51287 .64936 L p F P
0 0 0 r
s
.042 .053 .102 r
.51287 .64936 m .52763 .64728 L .52331 .65136 L p F P
0 0 0 r
s
1 .308 .123 r
.65962 .60067 m .65611 .59039 L .66493 .57433 L p F P
0 0 0 r
s
1 .308 .123 r
.66124 .56309 m .66493 .57433 L .65611 .59039 L p F P
0 0 0 r
s
.998 .282 .11 r
.66493 .57433 m .66124 .56309 L .66585 .54506 L p F P
0 0 0 r
s
.83 .24 .1 r
.37631 .36691 m
.3815 .37739 L
s
.24 .35 .67 r
.18049 .40621 m
.22011 .39903 L
s
.18049 .40621 m
.17059 .41731 L
s
.768 .232 .103 r
.56987 .35058 m .56698 .3422 L .55092 .34794 L p F P
0 0 0 r
s
.24 .35 .67 r
.56756 .3439 m
.56996 .34753 L
s
.768 .232 .103 r
.54862 .34152 m .55092 .34794 L .56698 .3422 L p F P
0 0 0 r
s
.998 .282 .11 r
.66203 .53307 m .66585 .54506 L .66124 .56309 L p F P
0 0 0 r
s
.83 .24 .1 r
.66409 .53952 m
.66446 .53199 L
s
.855 .238 .09 r
.66585 .54506 m .66203 .53307 L .66256 .51405 L p F P
0 0 0 r
s
.206 .334 .645 r
.40368 .36283 m .41577 .36064 L .39734 .36273 L p F P
0 0 0 r
s
.206 .334 .645 r
.39734 .36273 m .38265 .36541 L .40368 .36283 L p F P
0 0 0 r
s
1 .323 .13 r
.64985 .62302 m .64657 .61386 L .65962 .60067 L p F P
0 0 0 r
s
.24 .35 .67 r
.65011 .62156 m
.65547 .6208 L
s
.65547 .6208 m
.65588 .61599 L
s
1 .323 .13 r
.65611 .59039 m .65962 .60067 L .64657 .61386 L p F P
0 0 0 r
s
.83 .24 .1 r
.52263 .32866 m
.49299 .32931 L
s
.48157 .30044 m
.49299 .32931 L
s
.263 .411 .799 r
.52008 .34668 m .52957 .34497 L .53892 .33827 L p F P
0 0 0 r
s
.263 .411 .799 r
.53892 .33827 m .52642 .34054 L .52008 .34668 L p F P
0 0 0 r
s
.83 .24 .1 r
.52263 .32866 m
.52703 .34043 L
s
.24 .35 .67 r
.52201 .34578 m
.52889 .35491 L
s
.48067 .35326 m
.52201 .34578 L
s
.069 .081 .154 r
.6326 .63255 m .61743 .63468 L .63266 .62545 L p F P
0 0 0 r
s
.069 .081 .154 r
.63266 .62545 m .64985 .62302 L .6326 .63255 L p F P
0 0 0 r
s
.83 .24 .1 r
.64897 .6235 m
.6497 .62554 L
s
.66 .179 .065 r
.66256 .51405 m .65864 .50157 L .65529 .48262 L p F P
0 0 0 r
s
.855 .238 .09 r
.65864 .50157 m .66256 .51405 L .66203 .53307 L p F P
0 0 0 r
s
.042 .053 .102 r
.5358 .64961 m .52331 .65136 L .52763 .64728 L p F P
0 0 0 r
s
.24 .35 .67 r
.48464 .65336 m
.52601 .64756 L
s
.042 .053 .102 r
.52763 .64728 m .54245 .64521 L .5358 .64961 L p F P
0 0 0 r
s
.24 .35 .67 r
.52601 .64756 m
.53087 .63843 L
s
.504 .158 .074 r
.61376 .39967 m .61017 .38858 L .59523 .38033 L p F P
0 0 0 r
s
.504 .158 .074 r
.59197 .37053 m .59523 .38033 L .61017 .38858 L p F P
0 0 0 r
s
.206 .334 .645 r
.41577 .36064 m .4279 .35843 L .4121 .36005 L p F P
0 0 0 r
s
.206 .334 .645 r
.4121 .36005 m .39734 .36273 L .41577 .36064 L p F P
0 0 0 r
s
.263 .411 .799 r
.52957 .34497 m .53908 .34324 L .55146 .33599 L p F P
0 0 0 r
s
.263 .411 .799 r
.55146 .33599 m .53892 .33827 L .52957 .34497 L p F P
0 0 0 r
s
.72 .193 .072 r
.36654 .57155 m .35982 .56026 L .3558 .5421 L p F P
0 0 0 r
s
.561 .145 .055 r
.35982 .56026 m .36654 .57155 L .37369 .5878 L p F P
0 0 0 r
s
.561 .145 .055 r
.37985 .59813 m .37369 .5878 L .36654 .57155 L p F P
0 0 0 r
s
.486 .155 .073 r
.41193 .6385 m .41654 .64632 L .4296 .65055 L p F P
0 0 0 r
s
.486 .155 .073 r
.43335 .65703 m .4296 .65055 L .41654 .64632 L p F P
0 0 0 r
s
.888 .244 .094 r
.3558 .5421 m .34871 .53005 L .34821 .51097 L p F P
0 0 0 r
s
.72 .193 .072 r
.34871 .53005 m .3558 .5421 L .35982 .56026 L p F P
0 0 0 r
s
.83 .24 .1 r
.35816 .54777 m
.37194 .57115 L
s
.35675 .52303 m
.35816 .54777 L
s
.245 .071 .038 r
.37369 .5878 m .37985 .59813 L .3897 .61156 L p F P
0 0 0 r
s
.245 .071 .038 r
.39517 .62076 m .3897 .61156 L .37985 .59813 L p F P
0 0 0 r
s
.187 .054 .028 r
.65529 .48262 m .65134 .46994 L .64441 .45213 L p F P
0 0 0 r
s
.66 .179 .065 r
.65134 .46994 m .65529 .48262 L .65864 .50157 L p F P
0 0 0 r
s
.24 .35 .67 r
.78432 .60257 m
.78329 .58812 L
s
.78329 .58812 m
.82643 .58194 L
s
.37524 .3683 m
.39083 .36547 L
s
1 .33 .135 r
.64657 .61386 m .64985 .62302 L .6326 .63255 L p F P
0 0 0 r
s
.24 .35 .67 r
.61347 .62674 m
.63972 .62303 L
s
.83 .24 .1 r
.63033 .64822 m
.6497 .62554 L
s
.655 .2 .091 r
.59197 .37053 m .58865 .36058 L .57272 .35887 L p F P
0 0 0 r
s
.83 .24 .1 r
.58585 .3704 m
.59497 .39738 L
s
.56073 .36102 m
.58585 .3704 L
s
.655 .2 .091 r
.56987 .35058 m .57272 .35887 L .58865 .36058 L p F P
0 0 0 r
s
.263 .411 .799 r
.53908 .34324 m .54862 .34152 L .56405 .3337 L p F P
0 0 0 r
s
.263 .411 .799 r
.56405 .3337 m .55146 .33599 L .53908 .34324 L p F P
0 0 0 r
s
.24 .35 .67 r
.34373 .67053 m
.35406 .67373 L
s
.35406 .67373 m
.3948 .66802 L
s
1 .321 .132 r
.36801 .36807 m .37295 .3779 L .35299 .3858 L p F P
0 0 0 r
s
.24 .35 .67 r
.35012 .37286 m
.36647 .36989 L
s
1 .321 .132 r
.35878 .39693 m .35299 .3858 L .37295 .3779 L p F P
0 0 0 r
s
.83 .24 .1 r
.3605 .39856 m
.3815 .37739 L
s
.042 .053 .102 r
.54833 .64786 m .5358 .64961 L .54245 .64521 L p F P
0 0 0 r
s
.042 .053 .102 r
.54245 .64521 m .55732 .64312 L .54833 .64786 L p F P
0 0 0 r
s
.24 .35 .67 r
.78227 .30939 m
.7853 .32524 L
s
.206 .334 .645 r
.4279 .35843 m .44007 .35622 L .42691 .35736 L p F P
0 0 0 r
s
.24 .35 .67 r
.43199 .35799 m
.4398 .36066 L
s
.206 .334 .645 r
.42691 .35736 m .4121 .36005 L .4279 .35843 L p F P
0 0 0 r
s
.996 .278 .11 r
.34821 .51097 m .34094 .49843 L .34431 .47949 L p F P
0 0 0 r
s
.888 .244 .094 r
.34094 .49843 m .34821 .51097 L .34871 .53005 L p F P
0 0 0 r
s
.38 .117 .058 r
.63037 .42402 m .62657 .41202 L .61376 .39967 L p F P
0 0 0 r
s
.38 .117 .058 r
.61017 .38858 m .61376 .39967 L .62657 .41202 L p F P
0 0 0 r
s
.24 .35 .67 r
.65346 .33253 m
.69592 .3249 L
s
.65346 .33253 m
.64884 .32282 L
s
.65295 .62974 m
.65547 .6208 L
s
.65547 .6208 m
.69794 .61479 L
s
.187 .054 .028 r
.64049 .43961 m .64441 .45213 L .65134 .46994 L p F P
0 0 0 r
s
.267 .077 .042 r
.64441 .45213 m .64049 .43961 L .63037 .42402 L p F P
0 0 0 r
s
.181 .298 .578 r
.46014 .6599 m .45053 .66124 L .43706 .66343 L p F P
0 0 0 r
s
.181 .298 .578 r
.43706 .66343 m .44926 .66172 L .46014 .6599 L p F P
0 0 0 r
s
.65 .203 .092 r
.43335 .65703 m .43706 .66343 L .45053 .66124 L p F P
0 0 0 r
s
.83 .24 .1 r
.44362 .66316 m
.44945 .6662 L
s
.44256 .66261 m
.44362 .66316 L
s
.24 .35 .67 r
.43791 .66148 m
.43825 .66134 L
s
.44301 .6594 m
.44373 .65911 L
s
.43601 .66225 m
.43791 .66148 L
s
.768 .232 .103 r
.56698 .3422 m .56405 .3337 L .54862 .34152 L p F P
0 0 0 r
s
.83 .24 .1 r
.5508 .33299 m
.55183 .33592 L
s
.55282 .33872 m
.56073 .36102 L
s
.267 .077 .042 r
.62657 .41202 m .63037 .42402 L .64049 .43961 L p F P
0 0 0 r
s
.83 .24 .1 r
.61613 .41145 m
.63276 .4297 L
s
.63276 .4297 m
.64093 .45555 L
s
.50719 .67509 m
.51813 .69627 L
s
.51813 .69627 m
.54862 .69219 L
s
.206 .334 .645 r
.44007 .35622 m .45228 .354 L .44178 .35465 L p F P
0 0 0 r
s
.206 .334 .645 r
.44178 .35465 m .42691 .35736 L .44007 .35622 L p F P
0 0 0 r
s
.365 .111 .056 r
.3897 .61156 m .39517 .62076 L .40726 .63057 L p F P
0 0 0 r
s
.83 .24 .1 r
.39337 .61477 m
.39463 .6169 L
s
.39855 .6235 m
.39988 .62574 L
s
.37964 .59422 m
.39337 .61477 L
s
.365 .111 .056 r
.41193 .6385 m .40726 .63057 L .39517 .62076 L p F P
0 0 0 r
s
.24 .35 .67 r
.22011 .39903 m
.26018 .39177 L
s
.22011 .39903 m
.21088 .41007 L
s
.20911 .67818 m
.22212 .68765 L
s
.22212 .68765 m
.2622 .68201 L
s
.042 .053 .102 r
.5609 .6461 m .54833 .64786 L .55732 .64312 L p F P
0 0 0 r
s
.042 .053 .102 r
.55732 .64312 m .57226 .64102 L .5609 .6461 L p F P
0 0 0 r
s
1 .3 .12 r
.34431 .47949 m .33708 .46675 L .34456 .44904 L p F P
0 0 0 r
s
.996 .278 .11 r
.33708 .46675 m .34431 .47949 L .34094 .49843 L p F P
0 0 0 r
s
.83 .24 .1 r
.60619 .66753 m
.63033 .64822 L
s
1 .318 .13 r
.35299 .3858 m .35878 .39693 L .34284 .40901 L p F P
0 0 0 r
s
1 .318 .13 r
.34932 .42106 m .34284 .40901 L .35878 .39693 L p F P
0 0 0 r
s
.24 .35 .67 r
.52201 .34578 m
.55538 .33974 L
s
.181 .298 .578 r
.46976 .65855 m .46014 .6599 L .44926 .66172 L p F P
0 0 0 r
s
.181 .298 .578 r
.44926 .66172 m .4615 .66001 L .46976 .65855 L p F P
0 0 0 r
s
1 .312 .126 r
.34456 .44904 m .33759 .43645 L .34932 .42106 L p F P
0 0 0 r
s
1 .3 .12 r
.33759 .43645 m .34456 .44904 L .33708 .46675 L p F P
0 0 0 r
s
.206 .334 .645 r
.45228 .354 m .46454 .35178 L .45672 .35194 L p F P
0 0 0 r
s
.206 .334 .645 r
.45672 .35194 m .44178 .35465 L .45228 .354 L p F P
0 0 0 r
s
.83 .24 .1 r
.5508 .33299 m
.52263 .32866 L
s
.51177 .29958 m
.52263 .32866 L
s
1 .312 .126 r
.34284 .40901 m .34932 .42106 L .33759 .43645 L p F P
0 0 0 r
s
.83 .24 .1 r
.34406 .4221 m
.35824 .44825 L
s
.34406 .4221 m
.3605 .39856 L
s
.042 .053 .102 r
.57351 .64434 m .5609 .6461 L .57226 .64102 L p F P
0 0 0 r
s
.24 .35 .67 r
.52601 .64756 m
.56785 .64168 L
s
.56785 .64168 m
.57194 .63262 L
s
.042 .053 .102 r
.57226 .64102 m .58725 .63892 L .57351 .64434 L p F P
0 0 0 r
s
.181 .298 .578 r
.47941 .6572 m .46976 .65855 L .4615 .66001 L p F P
0 0 0 r
s
.181 .298 .578 r
.4615 .66001 m .47378 .65829 L .47941 .6572 L p F P
0 0 0 r
s
.206 .334 .645 r
.46454 .35178 m .47683 .34955 L .47171 .34921 L p F P
0 0 0 r
s
.24 .35 .67 r
.47363 .35043 m
.48067 .35326 L
s
.206 .334 .645 r
.47171 .34921 m .45672 .35194 L .46454 .35178 L p F P
0 0 0 r
s
.24 .35 .67 r
.82643 .58194 m
.82825 .59635 L
s
.3852 .6647 m
.3948 .66802 L
s
.3948 .66802 m
.43601 .66225 L
s
.504 .158 .074 r
.61017 .38858 m .60651 .3773 L .59197 .37053 L p F P
0 0 0 r
s
.504 .158 .074 r
.58865 .36058 m .59197 .37053 L .60651 .3773 L p F P
0 0 0 r
s
.83 .24 .1 r
.53828 .67083 m
.54862 .69219 L
s
.54862 .69219 m
.57848 .68245 L
s
.655 .2 .091 r
.58865 .36058 m .58529 .35048 L .56987 .35058 L p F P
0 0 0 r
s
.655 .2 .091 r
.56698 .3422 m .56987 .35058 L .58529 .35048 L p F P
0 0 0 r
s
.83 .24 .1 r
.57848 .68245 m
.60619 .66753 L
s
.59708 .64564 m
.60619 .66753 L
s
.042 .053 .102 r
.58617 .64257 m .57351 .64434 L .58725 .63892 L p F P
0 0 0 r
s
.042 .053 .102 r
.58725 .63892 m .60231 .6368 L .58617 .64257 L p F P
0 0 0 r
s
.181 .298 .578 r
.48909 .65585 m .47941 .6572 L .47378 .65829 L p F P
0 0 0 r
s
.181 .298 .578 r
.47378 .65829 m .4861 .65657 L .48909 .65585 L p F P
0 0 0 r
s
.24 .35 .67 r
.47768 .65641 m
.48464 .65336 L
s
1 .308 .123 r
.65611 .59039 m .65253 .57991 L .66124 .56309 L p F P
0 0 0 r
s
.83 .24 .1 r
.65849 .56839 m
.66135 .55883 L
s
1 .308 .123 r
.65747 .55162 m .66124 .56309 L .65253 .57991 L p F P
0 0 0 r
s
.998 .282 .11 r
.66124 .56309 m .65747 .55162 L .66203 .53307 L p F P
0 0 0 r
s
.24 .35 .67 r
.69592 .3249 m
.73885 .31719 L
s
.69592 .3249 m
.69209 .31499 L
s
.69623 .62367 m
.69794 .61479 L
s
.69794 .61479 m
.74088 .60871 L
s
1 .323 .13 r
.64657 .61386 m .64324 .60454 L .65611 .59039 L p F P
0 0 0 r
s
1 .323 .13 r
.65253 .57991 m .65611 .59039 L .64324 .60454 L p F P
0 0 0 r
s
.486 .155 .073 r
.40726 .63057 m .41193 .6385 L .42581 .64399 L p F P
0 0 0 r
s
.486 .155 .073 r
.4296 .65055 m .42581 .64399 L .41193 .6385 L p F P
0 0 0 r
s
.206 .334 .645 r
.47683 .34955 m .48917 .34731 L .48677 .34648 L p F P
0 0 0 r
s
.206 .334 .645 r
.48677 .34648 m .47171 .34921 L .47683 .34955 L p F P
0 0 0 r
s
.998 .282 .11 r
.65812 .52083 m .66203 .53307 L .65747 .55162 L p F P
0 0 0 r
s
.855 .238 .09 r
.66203 .53307 m .65812 .52083 L .65864 .50157 L p F P
0 0 0 r
s
.83 .24 .1 r
.56877 .66085 m
.57848 .68245 L
s
.65 .203 .092 r
.4296 .65055 m .43335 .65703 L .44769 .65621 L p F P
0 0 0 r
s
.65 .203 .092 r
.45053 .66124 m .44769 .65621 L .43335 .65703 L p F P
0 0 0 r
s
.83 .24 .1 r
.44699 .66186 m
.44945 .6662 L
s
.44945 .6662 m
.47708 .67348 L
s
1 .321 .132 r
.35299 .3858 m .3471 .37447 L .36801 .36807 L p F P
0 0 0 r
s
.03 .041 .078 r
.36801 .36807 m .38265 .36541 L .36401 .3714 L p F P
0 0 0 r
s
.83 .24 .1 r
.37587 .36602 m
.37615 .36659 L
s
.03 .041 .078 r
.36401 .3714 m .3471 .37447 L .36801 .36807 L p F P
0 0 0 r
s
.24 .35 .67 r
.26018 .39177 m
.30071 .38442 L
s
.26018 .39177 m
.25163 .40273 L
s
.24984 .67239 m
.2622 .68201 L
s
.2622 .68201 m
.30273 .6763 L
s
.181 .298 .578 r
.49879 .65449 m .48909 .65585 L .4861 .65657 L p F P
0 0 0 r
s
.181 .298 .578 r
.4861 .65657 m .49846 .65484 L .49879 .65449 L p F P
0 0 0 r
s
.042 .053 .102 r
.59887 .64079 m .58617 .64257 L .60231 .6368 L p F P
0 0 0 r
s
.042 .053 .102 r
.60231 .6368 m .61743 .63468 L .59887 .64079 L p F P
0 0 0 r
s
1 .33 .135 r
.6326 .63255 m .62957 .62452 L .64657 .61386 L p F P
0 0 0 r
s
1 .33 .135 r
.64324 .60454 m .64657 .61386 L .62957 .62452 L p F P
0 0 0 r
s
.206 .334 .645 r
.48917 .34731 m .50154 .34506 L .50188 .34373 L p F P
0 0 0 r
s
.206 .334 .645 r
.50188 .34373 m .48677 .34648 L .48917 .34731 L p F P
0 0 0 r
s
.66 .179 .065 r
.65864 .50157 m .65464 .48882 L .65134 .46994 L p F P
0 0 0 r
s
.855 .238 .09 r
.65464 .48882 m .65864 .50157 L .65812 .52083 L p F P
0 0 0 r
s
.83 .24 .1 r
.652 .47723 m
.65489 .49114 L
s
.72 .193 .072 r
.35982 .56026 m .35297 .54874 L .34871 .53005 L p F P
0 0 0 r
s
.561 .145 .055 r
.35297 .54874 m .35982 .56026 L .36741 .57727 L p F P
0 0 0 r
s
.561 .145 .055 r
.37369 .5878 m .36741 .57727 L .35982 .56026 L p F P
0 0 0 r
s
.83 .24 .1 r
.35816 .54777 m
.36585 .57104 L
s
.245 .071 .038 r
.36741 .57727 m .37369 .5878 L .38413 .6022 L p F P
0 0 0 r
s
.245 .071 .038 r
.3897 .61156 m .38413 .6022 L .37369 .5878 L p F P
0 0 0 r
s
.83 .24 .1 r
.36585 .57104 m
.37964 .59422 L
s
.38 .117 .058 r
.62657 .41202 m .62269 .3998 L .61017 .38858 L p F P
0 0 0 r
s
.38 .117 .058 r
.60651 .3773 m .61017 .38858 L .62269 .3998 L p F P
0 0 0 r
s
.83 .24 .1 r
.60736 .38445 m
.61613 .41145 L
s
.181 .298 .578 r
.50852 .65313 m .49879 .65449 L .49846 .65484 L p F P
0 0 0 r
s
.181 .298 .578 r
.49846 .65484 m .51086 .6531 L .50852 .65313 L p F P
0 0 0 r
s
.03 .041 .078 r
.38265 .36541 m .39734 .36273 L .381 .36832 L p F P
0 0 0 r
s
.24 .35 .67 r
.39083 .36547 m
.43199 .35799 L
s
.03 .041 .078 r
.381 .36832 m .36401 .3714 L .38265 .36541 L p F P
0 0 0 r
s
.83 .24 .1 r
.36772 .34956 m
.37587 .36602 L
s
.888 .244 .094 r
.34871 .53005 m .34147 .51775 L .34094 .49843 L p F P
0 0 0 r
s
.83 .24 .1 r
.34253 .49844 m
.34748 .47305 L
s
.72 .193 .072 r
.34147 .51775 m .34871 .53005 L .35297 .54874 L p F P
0 0 0 r
s
.83 .24 .1 r
.34253 .49844 m
.35675 .52303 L
s
.187 .054 .028 r
.65134 .46994 m .64731 .45699 L .64049 .43961 L p F P
0 0 0 r
s
.66 .179 .065 r
.64731 .45699 m .65134 .46994 L .65464 .48882 L p F P
0 0 0 r
s
.042 .053 .102 r
.61161 .63901 m .59887 .64079 L .61743 .63468 L p F P
0 0 0 r
s
.24 .35 .67 r
.56785 .64168 m
.61016 .63575 L
s
.042 .053 .102 r
.61743 .63468 m .6326 .63255 L .61161 .63901 L p F P
0 0 0 r
s
.206 .334 .645 r
.50154 .34506 m .51396 .3428 L .51706 .34097 L p F P
0 0 0 r
s
.206 .334 .645 r
.51706 .34097 m .50188 .34373 L .50154 .34506 L p F P
0 0 0 r
s
.365 .111 .056 r
.38413 .6022 m .3897 .61156 L .40251 .62251 L p F P
0 0 0 r
s
.83 .24 .1 r
.39328 .61462 m
.39337 .61477 L
s
.365 .111 .056 r
.40726 .63057 m .40251 .62251 L .3897 .61156 L p F P
0 0 0 r
s
.267 .077 .042 r
.64049 .43961 m .63649 .42683 L .62657 .41202 L p F P
0 0 0 r
s
.267 .077 .042 r
.62269 .3998 m .62657 .41202 L .63649 .42683 L p F P
0 0 0 r
s
.187 .054 .028 r
.63649 .42683 m .64049 .43961 L .64731 .45699 L p F P
0 0 0 r
s
.83 .24 .1 r
.63276 .4297 m
.64395 .45151 L
s
.64395 .45151 m
.65188 .47684 L
s
.996 .278 .11 r
.34094 .49843 m .33351 .48561 L .33708 .46675 L p F P
0 0 0 r
s
.888 .244 .094 r
.33351 .48561 m .34094 .49843 L .34147 .51775 L p F P
0 0 0 r
s
.181 .298 .578 r
.51827 .65176 m .50852 .65313 L .51086 .6531 L p F P
0 0 0 r
s
.181 .298 .578 r
.51086 .6531 m .52331 .65136 L .51827 .65176 L p F P
0 0 0 r
s
.24 .35 .67 r
.42714 .6588 m
.43601 .66225 L
s
.43601 .66225 m
.44434 .66108 L
s
.45 .66029 m
.47768 .65641 L
s
1 .318 .13 r
.3471 .37447 m .35299 .3858 L .33623 .39672 L p F P
0 0 0 r
s
.24 .35 .67 r
.34169 .377 m
.35012 .37286 L
s
1 .318 .13 r
.34284 .40901 m .33623 .39672 L .35299 .3858 L p F P
0 0 0 r
s
.03 .041 .078 r
.39734 .36273 m .4121 .36005 L .39807 .36522 L p F P
0 0 0 r
s
.03 .041 .078 r
.39807 .36522 m .381 .36832 L .39734 .36273 L p F P
0 0 0 r
s
.24 .35 .67 r
.38314 .36948 m
.3877 .3671 L
s
.206 .334 .645 r
.51396 .3428 m .52642 .34054 L .5323 .3382 L p F P
0 0 0 r
s
.206 .334 .645 r
.5323 .3382 m .51706 .34097 L .51396 .3428 L p F P
0 0 0 r
s
.24 .35 .67 r
.51574 .34278 m
.52201 .34578 L
s
.73885 .31719 m
.78227 .30939 L
s
.73885 .31719 m
.73583 .30707 L
s
.74001 .61752 m
.74088 .60871 L
s
.74088 .60871 m
.78432 .60257 L
s
1 .332 .137 r
.62957 .62452 m .6326 .63255 L .61161 .63901 L p F P
0 0 0 r
s
.83 .24 .1 r
.62517 .63484 m
.62535 .6353 L
s
.62535 .6353 m
.63033 .64822 L
s
.24 .35 .67 r
.61016 .63575 m
.61347 .62674 L
s
.83 .24 .1 r
.5508 .33299 m
.55652 .33507 L
s
.655 .2 .091 r
.58529 .35048 m .58187 .34023 L .56698 .3422 L p F P
0 0 0 r
s
.655 .2 .091 r
.56405 .3337 m .56698 .3422 L .58187 .34023 L p F P
0 0 0 r
s
.24 .35 .67 r
.57221 .33669 m
.60609 .33056 L
s
.83 .24 .1 r
.45098 .30619 m
.4211 .31658 L
s
.40795 .28698 m
.4211 .31658 L
s
.4211 .31658 m
.39301 .33121 L
s
1 .3 .12 r
.33708 .46675 m .32969 .45373 L .33759 .43645 L p F P
0 0 0 r
s
.996 .278 .11 r
.32969 .45373 m .33708 .46675 L .33351 .48561 L p F P
0 0 0 r
s
.181 .298 .578 r
.52805 .6504 m .51827 .65176 L .52331 .65136 L p F P
0 0 0 r
s
.181 .298 .578 r
.52331 .65136 m .5358 .64961 L .52805 .6504 L p F P
0 0 0 r
s
.24 .35 .67 r
.51982 .65051 m
.52601 .64756 L
s
.504 .158 .074 r
.60651 .3773 m .6028 .36583 L .58865 .36058 L p F P
0 0 0 r
s
.83 .24 .1 r
.58585 .3704 m
.60736 .38445 L
s
.504 .158 .074 r
.58529 .35048 m .58865 .36058 L .6028 .36583 L p F P
0 0 0 r
s
1 .312 .126 r
.33623 .39672 m .34284 .40901 L .33048 .42361 L p F P
0 0 0 r
s
1 .312 .126 r
.33759 .43645 m .33048 .42361 L .34284 .40901 L p F P
0 0 0 r
s
.24 .35 .67 r
.30071 .38442 m
.34169 .377 L
s
.30071 .38442 m
.29285 .39532 L
s
.29103 .66653 m
.30273 .6763 L
s
.30273 .6763 m
.34373 .67053 L
s
1 .3 .12 r
.33048 .42361 m .33759 .43645 L .32969 .45373 L p F P
0 0 0 r
s
.83 .24 .1 r
.33293 .44716 m
.34406 .4221 L
s
.33293 .44716 m
.34748 .47305 L
s
.206 .334 .645 r
.52642 .34054 m .53892 .33827 L .54761 .33541 L p F P
0 0 0 r
s
.206 .334 .645 r
.54761 .33541 m .5323 .3382 L .52642 .34054 L p F P
0 0 0 r
s
.03 .041 .078 r
.4121 .36005 m .42691 .35736 L .41522 .36211 L p F P
0 0 0 r
s
.03 .041 .078 r
.41522 .36211 m .39807 .36522 L .4121 .36005 L p F P
0 0 0 r
s
.83 .24 .1 r
.37924 .30189 m
.39301 .33121 L
s
.39301 .33121 m
.36772 .34956 L
s
.65 .203 .092 r
.42581 .64399 m .4296 .65055 L .44482 .65113 L p F P
0 0 0 r
s
.65 .203 .092 r
.44769 .65621 m .44482 .65113 L .4296 .65055 L p F P
0 0 0 r
s
.83 .24 .1 r
.48157 .30044 m
.45098 .30619 L
s
.43845 .27632 m
.45098 .30619 L
s
.486 .155 .073 r
.40251 .62251 m .40726 .63057 L .42196 .63735 L p F P
0 0 0 r
s
.486 .155 .073 r
.42581 .64399 m .42196 .63735 L .40726 .63057 L p F P
0 0 0 r
s
.24 .35 .67 r
.60609 .33056 m
.64884 .32282 L
s
.60609 .33056 m
.60142 .32722 L
s
.62642 .63346 m
.62779 .63327 L
s
.61016 .63575 m
.61681 .63481 L
s
.17059 .41731 m
.21088 .41007 L
s
.17059 .41731 m
.16258 .43474 L
s
.181 .298 .578 r
.53786 .64902 m .52805 .6504 L .5358 .64961 L p F P
0 0 0 r
s
.181 .298 .578 r
.5358 .64961 m .54833 .64786 L .53786 .64902 L p F P
0 0 0 r
s
.206 .334 .645 r
.53892 .33827 m .55146 .33599 L .56297 .33262 L p F P
0 0 0 r
s
.206 .334 .645 r
.56297 .33262 m .54761 .33541 L .53892 .33827 L p F P
0 0 0 r
s
.03 .041 .078 r
.42691 .35736 m .44178 .35465 L .43245 .35898 L p F P
0 0 0 r
s
.24 .35 .67 r
.43625 .35722 m
.47363 .35043 L
s
.03 .041 .078 r
.43245 .35898 m .41522 .36211 L .42691 .35736 L p F P
0 0 0 r
s
1 .323 .13 r
.64324 .60454 m .63984 .59506 L .65253 .57991 L p F P
0 0 0 r
s
1 .323 .13 r
.64889 .56923 m .65253 .57991 L .63984 .59506 L p F P
0 0 0 r
s
1 .308 .123 r
.65253 .57991 m .64889 .56923 L .65747 .55162 L p F P
0 0 0 r
s
.83 .24 .1 r
.47708 .67348 m
.50719 .67509 L
s
.181 .298 .578 r
.54769 .64765 m .53786 .64902 L .54833 .64786 L p F P
0 0 0 r
s
.181 .298 .578 r
.54833 .64786 m .5609 .6461 L .54769 .64765 L p F P
0 0 0 r
s
1 .308 .123 r
.65362 .53992 m .65747 .55162 L .64889 .56923 L p F P
0 0 0 r
s
.998 .282 .11 r
.65747 .55162 m .65362 .53992 L .65812 .52083 L p F P
0 0 0 r
s
.206 .334 .645 r
.55146 .33599 m .56405 .3337 L .57841 .32981 L p F P
0 0 0 r
s
.206 .334 .645 r
.57841 .32981 m .56297 .33262 L .55146 .33599 L p F P
0 0 0 r
s
.24 .35 .67 r
.55834 .33505 m
.56227 .33732 L
s
1 .33 .135 r
.62957 .62452 m .6265 .61637 L .64324 .60454 L p F P
0 0 0 r
s
1 .33 .135 r
.63984 .59506 m .64324 .60454 L .6265 .61637 L p F P
0 0 0 r
s
.83 .24 .1 r
.35335 .32053 m
.36772 .34956 L
s
.998 .282 .11 r
.65412 .50833 m .65812 .52083 L .65362 .53992 L p F P
0 0 0 r
s
.83 .24 .1 r
.65632 .5152 m
.65671 .5079 L
s
.855 .238 .09 r
.65812 .52083 m .65412 .50833 L .65464 .48882 L p F P
0 0 0 r
s
.03 .041 .078 r
.44178 .35465 m .45672 .35194 L .44976 .35584 L p F P
0 0 0 r
s
.03 .041 .078 r
.44976 .35584 m .43245 .35898 L .44178 .35465 L p F P
0 0 0 r
s
.24 .35 .67 r
.78008 .29906 m
.78227 .30939 L
s
.78429 .61131 m
.78432 .60257 L
s
.78432 .60257 m
.82825 .59635 L
s
.38 .117 .058 r
.62269 .3998 m .61874 .38733 L .60651 .3773 L p F P
0 0 0 r
s
.38 .117 .058 r
.6028 .36583 m .60651 .3773 L .61874 .38733 L p F P
0 0 0 r
s
.181 .298 .578 r
.55754 .64627 m .54769 .64765 L .5609 .6461 L p F P
0 0 0 r
s
.181 .298 .578 r
.5609 .6461 m .57351 .64434 L .55754 .64627 L p F P
0 0 0 r
s
.83 .24 .1 r
.51177 .29958 m
.48157 .30044 L
s
.46965 .27032 m
.48157 .30044 L
s
.561 .145 .055 r
.36741 .57727 m .36101 .56654 L .35297 .54874 L p F P
0 0 0 r
s
.245 .071 .038 r
.36101 .56654 m .36741 .57727 L .37846 .59267 L p F P
0 0 0 r
s
.245 .071 .038 r
.38413 .6022 m .37846 .59267 L .36741 .57727 L p F P
0 0 0 r
s
.83 .24 .1 r
.36585 .57104 m
.3797 .59173 L
s
.248 .39 .761 r
.4724 .65397 m .46574 .65491 L .45053 .66124 L p F P
0 0 0 r
s
.248 .39 .761 r
.45053 .66124 m .46014 .6599 L .4724 .65397 L p F P
0 0 0 r
s
.788 .241 .106 r
.44769 .65621 m .45053 .66124 L .46574 .65491 L p F P
0 0 0 r
s
.655 .2 .091 r
.58187 .34023 m .57841 .32981 L .56405 .3337 L p F P
0 0 0 r
s
.83 .24 .1 r
.55806 .33563 m
.57636 .34228 L
s
.72 .193 .072 r
.35297 .54874 m .34598 .53697 L .34147 .51775 L p F P
0 0 0 r
s
.561 .145 .055 r
.34598 .53697 m .35297 .54874 L .36101 .56654 L p F P
0 0 0 r
s
.24 .35 .67 r
.34169 .377 m
.34627 .37617 L
s
.33269 .6606 m
.34373 .67053 L
s
.34373 .67053 m
.3852 .6647 L
s
.365 .111 .056 r
.37846 .59267 m .38413 .6022 L .39769 .61433 L p F P
0 0 0 r
s
.83 .24 .1 r
.3797 .59173 m
.38388 .59877 L
s
.38792 .60559 m
.3893 .60791 L
s
.365 .111 .056 r
.40251 .62251 m .39769 .61433 L .38413 .6022 L p F P
0 0 0 r
s
.66 .179 .065 r
.65464 .48882 m .65055 .4758 L .64731 .45699 L p F P
0 0 0 r
s
.855 .238 .09 r
.65055 .4758 m .65464 .48882 L .65412 .50833 L p F P
0 0 0 r
s
.181 .298 .578 r
.56743 .64489 m .55754 .64627 L .57351 .64434 L p F P
0 0 0 r
s
.181 .298 .578 r
.57351 .64434 m .58617 .64257 L .56743 .64489 L p F P
0 0 0 r
s
.24 .35 .67 r
.19613 .6622 m
.20911 .67818 L
s
.20911 .67818 m
.24984 .67239 L
s
.03 .041 .078 r
.45672 .35194 m .47171 .34921 L .46715 .35268 L p F P
0 0 0 r
s
.03 .041 .078 r
.46715 .35268 m .44976 .35584 L .45672 .35194 L p F P
0 0 0 r
s
1 .332 .137 r
.61161 .63901 m .60893 .6323 L .62957 .62452 L p F P
0 0 0 r
s
1 .332 .137 r
.6265 .61637 m .62957 .62452 L .60893 .6323 L p F P
0 0 0 r
s
.24 .35 .67 r
.62779 .63327 m
.65295 .62974 L
s
.64884 .32282 m
.69209 .31499 L
s
.64884 .32282 m
.64501 .31931 L
s
.248 .39 .761 r
.47907 .65303 m .4724 .65397 L .46014 .6599 L p F P
0 0 0 r
s
.248 .39 .761 r
.46014 .6599 m .46976 .65855 L .47907 .65303 L p F P
0 0 0 r
s
.83 .24 .1 r
.46721 .65537 m
.46891 .65848 L
s
.65 .203 .092 r
.42196 .63735 m .42581 .64399 L .44193 .646 L p F P
0 0 0 r
s
.65 .203 .092 r
.44482 .65113 m .44193 .646 L .42581 .64399 L p F P
0 0 0 r
s
1 .318 .13 r
.33623 .39672 m .3295 .38419 L .3471 .37447 L p F P
0 0 0 r
s
.06 .072 .138 r
.3471 .37447 m .36401 .3714 L .34832 .38079 L p F P
0 0 0 r
s
.24 .35 .67 r
.34693 .37605 m
.34738 .37596 L
s
.83 .24 .1 r
.35057 .37945 m
.3605 .39856 L
s
.34619 .37101 m
.34797 .37444 L
s
.06 .072 .138 r
.34832 .38079 m .3295 .38419 L .3471 .37447 L p F P
0 0 0 r
s
.83 .24 .1 r
.34797 .37444 m
.34804 .37458 L
s
.24 .35 .67 r
.34121 .37772 m
.34169 .377 L
s
.6492 .63239 m
.65295 .62974 L
s
.65295 .62974 m
.69623 .62367 L
s
.21088 .41007 m
.25163 .40273 L
s
.21088 .41007 m
.2035 .42747 L
s
.888 .244 .094 r
.34147 .51775 m .33407 .50518 L .33351 .48561 L p F P
0 0 0 r
s
.72 .193 .072 r
.33407 .50518 m .34147 .51775 L .34598 .53697 L p F P
0 0 0 r
s
.83 .24 .1 r
.3438 .5234 m
.35816 .54777 L
s
.34253 .49844 m
.3438 .5234 L
s
.267 .077 .042 r
.63649 .42683 m .63241 .41378 L .62269 .3998 L p F P
0 0 0 r
s
.267 .077 .042 r
.61874 .38733 m .62269 .3998 L .63241 .41378 L p F P
0 0 0 r
s
.83 .24 .1 r
.60736 .38445 m
.62423 .40276 L
s
.187 .054 .028 r
.64731 .45699 m .64318 .44377 L .63649 .42683 L p F P
0 0 0 r
s
.66 .179 .065 r
.64318 .44377 m .64731 .45699 L .65055 .4758 L p F P
0 0 0 r
s
.83 .24 .1 r
.64395 .45151 m
.64902 .47604 L
s
.504 .158 .074 r
.6028 .36583 m .59902 .35415 L .58529 .35048 L p F P
0 0 0 r
s
.504 .158 .074 r
.58187 .34023 m .58529 .35048 L .59902 .35415 L p F P
0 0 0 r
s
.83 .24 .1 r
.57636 .34228 m
.58585 .3704 L
s
.187 .054 .028 r
.63241 .41378 m .63649 .42683 L .64318 .44377 L p F P
0 0 0 r
s
.83 .24 .1 r
.62423 .40276 m
.63276 .4297 L
s
.248 .39 .761 r
.48576 .65209 m .47907 .65303 L .46976 .65855 L p F P
0 0 0 r
s
.24 .35 .67 r
.47643 .65586 m
.47768 .65641 L
s
.248 .39 .761 r
.46976 .65855 m .47941 .6572 L .48576 .65209 L p F P
0 0 0 r
s
.83 .24 .1 r
.46891 .65848 m
.47708 .67348 L
s
.181 .298 .578 r
.57733 .6435 m .56743 .64489 L .58617 .64257 L p F P
0 0 0 r
s
.24 .35 .67 r
.56245 .64454 m
.56785 .64168 L
s
.181 .298 .578 r
.58617 .64257 m .59887 .64079 L .57733 .6435 L p F P
0 0 0 r
s
.486 .155 .073 r
.39769 .61433 m .40251 .62251 L .41807 .63062 L p F P
0 0 0 r
s
.486 .155 .073 r
.42196 .63735 m .41807 .63062 L .40251 .62251 L p F P
0 0 0 r
s
.03 .041 .078 r
.47171 .34921 m .48677 .34648 L .48463 .34951 L p F P
0 0 0 r
s
.24 .35 .67 r
.47363 .35043 m
.47936 .34939 L
s
.4855 .34827 m
.51574 .34278 L
s
.03 .041 .078 r
.48463 .34951 m .46715 .35268 L .47171 .34921 L p F P
0 0 0 r
s
.24 .35 .67 r
.46749 .35419 m
.47113 .35196 L
s
.996 .278 .11 r
.33351 .48561 m .32593 .47251 L .32969 .45373 L p F P
0 0 0 r
s
.888 .244 .094 r
.32593 .47251 m .33351 .48561 L .33407 .50518 L p F P
0 0 0 r
s
.06 .072 .138 r
.36401 .3714 m .381 .36832 L .36723 .37738 L p F P
0 0 0 r
s
.24 .35 .67 r
.36029 .37362 m
.36477 .37281 L
s
.37774 .37046 m
.38314 .36948 L
s
.83 .24 .1 r
.34619 .37101 m
.36772 .34956 L
s
.06 .072 .138 r
.36723 .37738 m .34832 .38079 L .36401 .3714 L p F P
0 0 0 r
s
.248 .39 .761 r
.49246 .65115 m .48576 .65209 L .47941 .6572 L p F P
0 0 0 r
s
.248 .39 .761 r
.47941 .6572 m .48909 .65585 L .49246 .65115 L p F P
0 0 0 r
s
.24 .35 .67 r
.48991 .6547 m
.51982 .65051 L
s
.83 .24 .1 r
.50719 .67509 m
.53828 .67083 L
s
.57262 .33123 m
.57636 .34228 L
s
1 .312 .126 r
.3295 .38419 m .33623 .39672 L .32323 .41049 L p F P
0 0 0 r
s
1 .312 .126 r
.33048 .42361 m .32323 .41049 L .33623 .39672 L p F P
0 0 0 r
s
.181 .298 .578 r
.58727 .64211 m .57733 .6435 L .59887 .64079 L p F P
0 0 0 r
s
.181 .298 .578 r
.59887 .64079 m .61161 .63901 L .58727 .64211 L p F P
0 0 0 r
s
1 .3 .12 r
.32969 .45373 m .32215 .44044 L .33048 .42361 L p F P
0 0 0 r
s
.996 .278 .11 r
.32215 .44044 m .32969 .45373 L .32593 .47251 L p F P
0 0 0 r
s
.788 .241 .106 r
.44482 .65113 m .44769 .65621 L .46382 .6514 L p F P
0 0 0 r
s
.788 .241 .106 r
.46574 .65491 m .46382 .6514 L .44769 .65621 L p F P
0 0 0 r
s
.24 .35 .67 r
.82825 .59635 m
.8291 .60502 L
s
.83 .24 .1 r
.33125 .34227 m
.34619 .37101 L
s
.34068 .37876 m
.34619 .37101 L
s
.32927 .39482 m
.3379 .38267 L
s
1 .3 .12 r
.32323 .41049 m .33048 .42361 L .32215 .44044 L p F P
0 0 0 r
s
.83 .24 .1 r
.32927 .39482 m
.34406 .4221 L
s
.03 .041 .078 r
.48677 .34648 m .50188 .34373 L .50219 .34632 L p F P
0 0 0 r
s
.03 .041 .078 r
.50219 .34632 m .48463 .34951 L .48677 .34648 L p F P
0 0 0 r
s
.248 .39 .761 r
.49916 .65021 m .49246 .65115 L .48909 .65585 L p F P
0 0 0 r
s
.248 .39 .761 r
.48909 .65585 m .49879 .65449 L .49916 .65021 L p F P
0 0 0 r
s
.83 .24 .1 r
.49577 .65298 m
.49653 .65445 L
s
.24 .35 .67 r
.37485 .6546 m
.3852 .6647 L
s
.3852 .6647 m
.42714 .6588 L
s
.06 .072 .138 r
.381 .36832 m .39807 .36522 L .38625 .37395 L p F P
0 0 0 r
s
.06 .072 .138 r
.38625 .37395 m .36723 .37738 L .381 .36832 L p F P
0 0 0 r
s
1 .329 .137 r
.60893 .6323 m .61161 .63901 L .58727 .64211 L p F P
0 0 0 r
s
.83 .24 .1 r
.59708 .64564 m
.60309 .64086 L
s
.60309 .64086 m
.60417 .64 L
s
.24 .35 .67 r
.6067 .63782 m
.6069 .6377 L
s
.83 .24 .1 r
.54044 .30375 m
.51177 .29958 L
s
.50042 .26924 m
.51177 .29958 L
s
.248 .39 .761 r
.50589 .64927 m .49916 .65021 L .49879 .65449 L p F P
0 0 0 r
s
.248 .39 .761 r
.49879 .65449 m .50852 .65313 L .50589 .64927 L p F P
0 0 0 r
s
.83 .24 .1 r
.49653 .65445 m
.50719 .67509 L
s
.24 .35 .67 r
.23742 .65622 m
.24984 .67239 L
s
.24984 .67239 m
.29103 .66653 L
s
.69209 .31499 m
.73583 .30707 L
s
.69209 .31499 m
.6891 .3113 L
s
1 .323 .13 r
.63984 .59506 m .63639 .58541 L .64889 .56923 L p F P
0 0 0 r
s
1 .323 .13 r
.64517 .55834 m .64889 .56923 L .63639 .58541 L p F P
0 0 0 r
s
1 .308 .123 r
.64889 .56923 m .64517 .55834 L .65362 .53992 L p F P
0 0 0 r
s
1 .33 .135 r
.6265 .61637 m .62338 .6081 L .63984 .59506 L p F P
0 0 0 r
s
1 .33 .135 r
.63639 .58541 m .63984 .59506 L .62338 .6081 L p F P
0 0 0 r
s
.24 .35 .67 r
.69333 .62621 m
.69623 .62367 L
s
.69623 .62367 m
.74001 .61752 L
s
.03 .041 .078 r
.50188 .34373 m .51706 .34097 L .51983 .34312 L p F P
0 0 0 r
s
.03 .041 .078 r
.51983 .34312 m .50219 .34632 L .50188 .34373 L p F P
0 0 0 r
s
.24 .35 .67 r
.25163 .40273 m
.29285 .39532 L
s
.25163 .40273 m
.24488 .42011 L
s
.65 .203 .092 r
.41807 .63062 m .42196 .63735 L .439 .64081 L p F P
0 0 0 r
s
.65 .203 .092 r
.44193 .646 m .439 .64081 L .42196 .63735 L p F P
0 0 0 r
s
.248 .39 .761 r
.51262 .64832 m .50589 .64927 L .50852 .65313 L p F P
0 0 0 r
s
.248 .39 .761 r
.50852 .65313 m .51827 .65176 L .51262 .64832 L p F P
0 0 0 r
s
.38 .117 .058 r
.61874 .38733 m .61471 .37462 L .6028 .36583 L p F P
0 0 0 r
s
.38 .117 .058 r
.59902 .35415 m .6028 .36583 L .61471 .37462 L p F P
0 0 0 r
s
.83 .24 .1 r
.59821 .35629 m
.60736 .38445 L
s
1 .308 .123 r
.6497 .52798 m .65362 .53992 L .64517 .55834 L p F P
0 0 0 r
s
.83 .24 .1 r
.65271 .53715 m
.65372 .53384 L
s
.998 .282 .11 r
.65362 .53992 m .6497 .52798 L .65412 .50833 L p F P
0 0 0 r
s
.83 .24 .1 r
.53828 .67083 m
.56877 .66085 L
s
.06 .072 .138 r
.39807 .36522 m .41522 .36211 L .40536 .3705 L p F P
0 0 0 r
s
.24 .35 .67 r
.39527 .36728 m
.39979 .36647 L
s
.06 .072 .138 r
.40536 .3705 m .38625 .37395 L .39807 .36522 L p F P
0 0 0 r
s
.83 .24 .1 r
.56877 .66085 m
.59708 .64564 L
s
1 .332 .137 r
.60893 .6323 m .60622 .62551 L .6265 .61637 L p F P
0 0 0 r
s
1 .332 .137 r
.62338 .6081 m .6265 .61637 L .60622 .62551 L p F P
0 0 0 r
s
.248 .39 .761 r
.51937 .64737 m .51262 .64832 L .51827 .65176 L p F P
0 0 0 r
s
.24 .35 .67 r
.51872 .64995 m
.51982 .65051 L
s
.248 .39 .761 r
.51827 .65176 m .52805 .6504 L .51937 .64737 L p F P
0 0 0 r
s
.24 .35 .67 r
.52593 .64965 m
.56245 .64454 L
s
.03 .041 .078 r
.51706 .34097 m .5323 .3382 L .53756 .33991 L p F P
0 0 0 r
s
.24 .35 .67 r
.5187 .34224 m
.52919 .34034 L
s
.53541 .33921 m
.55834 .33505 L
s
.03 .041 .078 r
.53756 .33991 m .51983 .34312 L .51706 .34097 L p F P
0 0 0 r
s
.245 .071 .038 r
.37846 .59267 m .3727 .58298 L .36101 .56654 L p F P
0 0 0 r
s
.365 .111 .056 r
.3727 .58298 m .37846 .59267 L .3928 .60602 L p F P
0 0 0 r
s
.365 .111 .056 r
.39769 .61433 m .3928 .60602 L .37846 .59267 L p F P
0 0 0 r
s
.561 .145 .055 r
.36101 .56654 m .35448 .5556 L .34598 .53697 L p F P
0 0 0 r
s
.245 .071 .038 r
.35448 .5556 m .36101 .56654 L .3727 .58298 L p F P
0 0 0 r
s
.24 .35 .67 r
.55834 .33505 m
.57471 .33207 L
s
.998 .282 .11 r
.65004 .49556 m .65412 .50833 L .6497 .52798 L p F P
0 0 0 r
s
.855 .238 .09 r
.65412 .50833 m .65004 .49556 L .65055 .4758 L p F P
0 0 0 r
s
.83 .24 .1 r
.64902 .47604 m
.65043 .48053 L
s
.788 .241 .106 r
.44193 .646 m .44482 .65113 L .4619 .64788 L p F P
0 0 0 r
s
.788 .241 .106 r
.46382 .6514 m .4619 .64788 L .44482 .65113 L p F P
0 0 0 r
s
.504 .158 .074 r
.59902 .35415 m .59517 .34226 L .58187 .34023 L p F P
0 0 0 r
s
.83 .24 .1 r
.57636 .34228 m
.59821 .35629 L
s
.504 .158 .074 r
.57841 .32981 m .58187 .34023 L .59517 .34226 L p F P
0 0 0 r
s
.24 .35 .67 r
.58012 .33109 m
.60142 .32722 L
s
.83 .24 .1 r
.44161 .64544 m
.44485 .64627 L
s
.248 .39 .761 r
.52613 .64642 m .51937 .64737 L .52805 .6504 L p F P
0 0 0 r
s
.248 .39 .761 r
.52805 .6504 m .53786 .64902 L .52613 .64642 L p F P
0 0 0 r
s
.83 .24 .1 r
.52821 .65002 m
.53828 .67083 L
s
.72 .193 .072 r
.34598 .53697 m .33885 .52497 L .33407 .50518 L p F P
0 0 0 r
s
.561 .145 .055 r
.33885 .52497 m .34598 .53697 L .35448 .5556 L p F P
0 0 0 r
s
.83 .24 .1 r
.3438 .5234 m
.35147 .54685 L
s
.35147 .54685 m
.36585 .57104 L
s
.486 .155 .073 r
.3928 .60602 m .39769 .61433 L .41412 .6238 L p F P
0 0 0 r
s
.486 .155 .073 r
.41807 .63062 m .41412 .6238 L .39769 .61433 L p F P
0 0 0 r
s
.06 .072 .138 r
.41522 .36211 m .43245 .35898 L .42457 .36703 L p F P
0 0 0 r
s
.24 .35 .67 r
.41288 .36409 m
.41743 .36327 L
s
.06 .072 .138 r
.42457 .36703 m .40536 .3705 L .41522 .36211 L p F P
0 0 0 r
s
.03 .041 .078 r
.5323 .3382 m .54761 .33541 L .55537 .33667 L p F P
0 0 0 r
s
.03 .041 .078 r
.55537 .33667 m .53756 .33991 L .5323 .3382 L p F P
0 0 0 r
s
.66 .179 .065 r
.65055 .4758 m .64638 .46248 L .64318 .44377 L p F P
0 0 0 r
s
.855 .238 .09 r
.64638 .46248 m .65055 .4758 L .65004 .49556 L p F P
0 0 0 r
s
.267 .077 .042 r
.63241 .41378 m .62824 .40046 L .61874 .38733 L p F P
0 0 0 r
s
.267 .077 .042 r
.61471 .37462 m .61874 .38733 L .62824 .40046 L p F P
0 0 0 r
s
.248 .39 .761 r
.5329 .64547 m .52613 .64642 L .53786 .64902 L p F P
0 0 0 r
s
.83 .24 .1 r
.52749 .64853 m
.52821 .65002 L
s
.248 .39 .761 r
.53786 .64902 m .54769 .64765 L .5329 .64547 L p F P
0 0 0 r
s
.24 .35 .67 r
.41749 .64853 m
.42714 .6588 L
s
.42714 .6588 m
.46217 .65387 L
s
.16258 .43474 m
.2035 .42747 L
s
.16258 .43474 m
.15699 .45788 L
s
.888 .244 .094 r
.33407 .50518 m .32652 .49234 L .32593 .47251 L p F P
0 0 0 r
s
.83 .24 .1 r
.32771 .47279 m
.33293 .44716 L
s
.72 .193 .072 r
.32652 .49234 m .33407 .50518 L .33885 .52497 L p F P
0 0 0 r
s
.83 .24 .1 r
.32771 .47279 m
.34253 .49844 L
s
1 .329 .137 r
.58727 .64211 m .58506 .63689 L .60893 .6323 L p F P
0 0 0 r
s
.24 .35 .67 r
.56245 .64454 m
.58685 .64112 L
s
.59687 .63972 m
.60557 .6385 L
s
.83 .24 .1 r
.59521 .64112 m
.59708 .64564 L
s
.24 .35 .67 r
.60557 .6385 m
.6067 .63782 L
s
1 .329 .137 r
.60622 .62551 m .60893 .6323 L .58506 .63689 L p F P
0 0 0 r
s
.24 .35 .67 r
.2792 .65017 m
.29103 .66653 L
s
.29103 .66653 m
.33269 .6606 L
s
.73583 .30707 m
.78008 .29906 L
s
.73583 .30707 m
.73371 .3032 L
s
.187 .054 .028 r
.64318 .44377 m .63897 .43026 L .63241 .41378 L p F P
0 0 0 r
s
.66 .179 .065 r
.63897 .43026 m .64318 .44377 L .64638 .46248 L p F P
0 0 0 r
s
.187 .054 .028 r
.62824 .40046 m .63241 .41378 L .63897 .43026 L p F P
0 0 0 r
s
.83 .24 .1 r
.62423 .40276 m
.63556 .42469 L
s
.63556 .42469 m
.64359 .45036 L
s
.24 .35 .67 r
.73798 .61995 m
.74001 .61752 L
s
.74001 .61752 m
.78429 .61131 L
s
.29285 .39532 m
.28676 .41267 L
s
.248 .39 .761 r
.53968 .64452 m .5329 .64547 L .54769 .64765 L p F P
0 0 0 r
s
.248 .39 .761 r
.54769 .64765 m .55754 .64627 L .53968 .64452 L p F P
0 0 0 r
s
.06 .072 .138 r
.43245 .35898 m .44976 .35584 L .44389 .36354 L p F P
0 0 0 r
s
.06 .072 .138 r
.44389 .36354 m .42457 .36703 L .43245 .35898 L p F P
0 0 0 r
s
.03 .041 .078 r
.54761 .33541 m .56297 .33262 L .57327 .33343 L p F P
0 0 0 r
s
.83 .24 .1 r
.54044 .30375 m
.55033 .33167 L
s
.55033 .33167 m
.5508 .33299 L
s
.03 .041 .078 r
.57327 .33343 m .55537 .33667 L .54761 .33541 L p F P
0 0 0 r
s
1 .312 .126 r
.32323 .41049 m .31582 .39711 L .3295 .38419 L p F P
0 0 0 r
s
.088 .103 .207 r
.3295 .38419 m .34832 .38079 L .33611 .39347 L p F P
0 0 0 r
s
.088 .103 .207 r
.33611 .39347 m .31582 .39711 L .3295 .38419 L p F P
0 0 0 r
s
.24 .35 .67 r
.29285 .39532 m
.32357 .38979 L
s
.83 .24 .1 r
.31384 .36635 m
.32586 .38852 L
s
.32921 .39471 m
.32927 .39482 L
s
.65 .203 .092 r
.41412 .6238 m .41807 .63062 L .43605 .63558 L p F P
0 0 0 r
s
.65 .203 .092 r
.439 .64081 m .43605 .63558 L .41807 .63062 L p F P
0 0 0 r
s
.996 .278 .11 r
.32593 .47251 m .31817 .45913 L .32215 .44044 L p F P
0 0 0 r
s
.888 .244 .094 r
.31817 .45913 m .32593 .47251 L .32652 .49234 L p F P
0 0 0 r
s
.248 .39 .761 r
.54647 .64356 m .53968 .64452 L .55754 .64627 L p F P
0 0 0 r
s
.248 .39 .761 r
.55754 .64627 m .56743 .64489 L .54647 .64356 L p F P
0 0 0 r
s
.83 .24 .1 r
.56186 .64547 m
.56877 .66085 L
s
.788 .241 .106 r
.439 .64081 m .44193 .646 L .45996 .64433 L p F P
0 0 0 r
s
.788 .241 .106 r
.4619 .64788 m .45996 .64433 L .44193 .646 L p F P
0 0 0 r
s
.83 .24 .1 r
.56644 .31292 m
.54044 .30375 L
s
.52962 .27323 m
.54044 .30375 L
s
.43845 .27632 m
.40795 .28698 L
s
.39421 .25608 m
.40795 .28698 L
s
.40795 .28698 m
.37924 .30189 L
s
.24 .35 .67 r
.60142 .32722 m
.64501 .31931 L
s
1 .3 .12 r
.32215 .44044 m .31444 .42686 L .32323 .41049 L p F P
0 0 0 r
s
.996 .278 .11 r
.31444 .42686 m .32215 .44044 L .31817 .45913 L p F P
0 0 0 r
s
1 .3 .12 r
.31582 .39711 m .32323 .41049 L .31444 .42686 L p F P
0 0 0 r
s
.83 .24 .1 r
.31775 .42014 m
.33293 .44716 L
s
.31775 .42014 m
.32927 .39482 L
s
.504 .158 .074 r
.59517 .34226 m .59125 .33016 L .57841 .32981 L p F P
0 0 0 r
s
.03 .041 .078 r
.56297 .33262 m .57841 .32981 L .59125 .33016 L p F P
0 0 0 r
s
.83 .24 .1 r
.57231 .33029 m
.57251 .33089 L
s
.03 .041 .078 r
.59125 .33016 m .57327 .33343 L .56297 .33262 L p F P
0 0 0 r
s
.83 .24 .1 r
.56644 .31292 m
.57231 .33029 L
s
.06 .072 .138 r
.44976 .35584 m .46715 .35268 L .4633 .36003 L p F P
0 0 0 r
s
.24 .35 .67 r
.46624 .35442 m
.46749 .35419 L
s
.06 .072 .138 r
.4633 .36003 m .44389 .36354 L .44976 .35584 L p F P
0 0 0 r
s
.248 .39 .761 r
.55328 .64261 m .54647 .64356 L .56743 .64489 L p F P
0 0 0 r
s
.248 .39 .761 r
.56743 .64489 m .57733 .6435 L .55328 .64261 L p F P
0 0 0 r
s
1 .33 .135 r
.62338 .6081 m .62021 .5997 L .63639 .58541 L p F P
0 0 0 r
s
1 .33 .135 r
.63288 .57559 m .63639 .58541 L .62021 .5997 L p F P
0 0 0 r
s
1 .323 .13 r
.63639 .58541 m .63288 .57559 L .64517 .55834 L p F P
0 0 0 r
s
.83 .24 .1 r
.64481 .55885 m
.6452 .55816 L
s
.36486 .27128 m
.37924 .30189 L
s
.37924 .30189 m
.35335 .32053 L
s
.088 .103 .207 r
.34832 .38079 m .36723 .37738 L .35652 .38982 L p F P
0 0 0 r
s
.088 .103 .207 r
.35652 .38982 m .33611 .39347 L .34832 .38079 L p F P
0 0 0 r
s
1 .332 .137 r
.60622 .62551 m .60347 .61863 L .62338 .6081 L p F P
0 0 0 r
s
1 .332 .137 r
.62021 .5997 m .62338 .6081 L .60347 .61863 L p F P
0 0 0 r
s
1 .323 .13 r
.64138 .54724 m .64517 .55834 L .63288 .57559 L p F P
0 0 0 r
s
1 .308 .123 r
.64517 .55834 m .64138 .54724 L .6497 .52798 L p F P
0 0 0 r
s
.24 .35 .67 r
.18384 .64023 m
.19613 .6622 L
s
.19613 .6622 m
.23742 .65622 L
s
.38 .117 .058 r
.61471 .37462 m .61061 .36166 L .59902 .35415 L p F P
0 0 0 r
s
.38 .117 .058 r
.59517 .34226 m .59902 .35415 L .61061 .36166 L p F P
0 0 0 r
s
.83 .24 .1 r
.46965 .27032 m
.43845 .27632 L
s
.42536 .24514 m
.43845 .27632 L
s
.248 .39 .761 r
.5601 .64165 m .55328 .64261 L .57733 .6435 L p F P
0 0 0 r
s
.248 .39 .761 r
.57733 .6435 m .58727 .64211 L .5601 .64165 L p F P
0 0 0 r
s
.83 .24 .1 r
.56043 .64229 m
.56186 .64547 L
s
.28 .43 .842 r
.48579 .64388 m .48236 .64436 L .46574 .65491 L p F P
0 0 0 r
s
.83 .24 .1 r
.46668 .65439 m
.46687 .65475 L
s
.28 .43 .842 r
.46574 .65491 m .4724 .65397 L .48579 .64388 L p F P
0 0 0 r
s
.89 .268 .117 r
.46382 .6514 m .46574 .65491 L .48236 .64436 L p F P
0 0 0 r
s
.83 .24 .1 r
.46367 .65112 m
.46421 .65126 L
s
.06 .072 .138 r
.46715 .35268 m .48463 .34951 L .48282 .35651 L p F P
0 0 0 r
s
.06 .072 .138 r
.48282 .35651 m .4633 .36003 L .46715 .35268 L p F P
0 0 0 r
s
.24 .35 .67 r
.2035 .42747 m
.24488 .42011 L
s
.2035 .42747 m
.19844 .45065 L
s
.245 .071 .038 r
.3727 .58298 m .36683 .57312 L .35448 .5556 L p F P
0 0 0 r
s
.365 .111 .056 r
.36683 .57312 m .3727 .58298 L .38783 .59759 L p F P
0 0 0 r
s
.83 .24 .1 r
.37694 .58707 m
.37836 .58947 L
s
.365 .111 .056 r
.3928 .60602 m .38783 .59759 L .3727 .58298 L p F P
0 0 0 r
s
.24 .35 .67 r
.32147 .64405 m
.33269 .6606 L
s
.33269 .6606 m
.37485 .6546 L
s
.28 .43 .842 r
.48923 .64339 m .48579 .64388 L .4724 .65397 L p F P
0 0 0 r
s
.28 .43 .842 r
.4724 .65397 m .47907 .65303 L .48923 .64339 L p F P
0 0 0 r
s
1 .308 .123 r
.64569 .51578 m .6497 .52798 L .64138 .54724 L p F P
0 0 0 r
s
.998 .282 .11 r
.6497 .52798 m .64569 .51578 L .65004 .49556 L p F P
0 0 0 r
s
1 .324 .136 r
.58506 .63689 m .58727 .64211 L .5601 .64165 L p F P
0 0 0 r
s
.486 .155 .073 r
.38783 .59759 m .3928 .60602 L .41013 .6169 L p F P
0 0 0 r
s
.486 .155 .073 r
.41412 .6238 m .41013 .6169 L .3928 .60602 L p F P
0 0 0 r
s
.24 .35 .67 r
.77885 .295 m
.78008 .29906 L
s
.78316 .61362 m
.78429 .61131 L
s
.78429 .61131 m
.8291 .60502 L
s
1 .329 .137 r
.58506 .63689 m .58282 .63161 L .60622 .62551 L p F P
0 0 0 r
s
.24 .35 .67 r
.60557 .6385 m
.6492 .63239 L
s
.59985 .63449 m
.60557 .6385 L
s
1 .329 .137 r
.60347 .61863 m .60622 .62551 L .58282 .63161 L p F P
0 0 0 r
s
.088 .103 .207 r
.36723 .37738 m .38625 .37395 L .37704 .38614 L p F P
0 0 0 r
s
.088 .103 .207 r
.37704 .38614 m .35652 .38982 L .36723 .37738 L p F P
0 0 0 r
s
.561 .145 .055 r
.35448 .5556 m .34782 .54445 L .33885 .52497 L p F P
0 0 0 r
s
.245 .071 .038 r
.34782 .54445 m .35448 .5556 L .36683 .57312 L p F P
0 0 0 r
s
.28 .43 .842 r
.49268 .6429 m .48923 .64339 L .47907 .65303 L p F P
0 0 0 r
s
.28 .43 .842 r
.47907 .65303 m .48576 .65209 L .49268 .6429 L p F P
0 0 0 r
s
.83 .24 .1 r
.47955 .65219 m
.49577 .65298 L
s
.4763 .65203 m
.47955 .65219 L
s
.788 .241 .106 r
.43605 .63558 m .439 .64081 L .45801 .64076 L p F P
0 0 0 r
s
.788 .241 .106 r
.45996 .64433 m .45801 .64076 L .439 .64081 L p F P
0 0 0 r
s
.28 .43 .842 r
.49612 .64242 m .49268 .6429 L .48576 .65209 L p F P
0 0 0 r
s
.28 .43 .842 r
.48576 .65209 m .49246 .65115 L .49612 .64242 L p F P
0 0 0 r
s
.83 .24 .1 r
.33834 .29022 m
.35335 .32053 L
s
.35335 .32053 m
.33125 .34227 L
s
.06 .072 .138 r
.48463 .34951 m .50219 .34632 L .50245 .35297 L p F P
0 0 0 r
s
.06 .072 .138 r
.50245 .35297 m .48282 .35651 L .48463 .34951 L p F P
0 0 0 r
s
.998 .282 .11 r
.64588 .48251 m .65004 .49556 L .64569 .51578 L p F P
0 0 0 r
s
.83 .24 .1 r
.64821 .48982 m
.64862 .48276 L
s
.855 .238 .09 r
.65004 .49556 m .64588 .48251 L .64638 .46248 L p F P
0 0 0 r
s
.65 .203 .092 r
.41013 .6169 m .41412 .6238 L .43306 .63029 L p F P
0 0 0 r
s
.65 .203 .092 r
.43605 .63558 m .43306 .63029 L .41412 .6238 L p F P
0 0 0 r
s
.89 .268 .117 r
.4619 .64788 m .46382 .6514 L .4814 .64255 L p F P
0 0 0 r
s
.83 .24 .1 r
.46478 .65092 m
.46484 .65102 L
s
.89 .268 .117 r
.48236 .64436 m .4814 .64255 L .46382 .6514 L p F P
0 0 0 r
s
.24 .35 .67 r
.46539 .64794 m
.46633 .64904 L
s
.72 .193 .072 r
.33885 .52497 m .33156 .51271 L .32652 .49234 L p F P
0 0 0 r
s
.561 .145 .055 r
.33156 .51271 m .33885 .52497 L .34782 .54445 L p F P
0 0 0 r
s
.28 .43 .842 r
.49957 .64193 m .49612 .64242 L .49246 .65115 L p F P
0 0 0 r
s
.28 .43 .842 r
.49246 .65115 m .49916 .65021 L .49957 .64193 L p F P
0 0 0 r
s
.24 .35 .67 r
.64501 .31931 m
.6891 .3113 L
s
.64501 .31931 m
.64217 .32253 L
s
.83 .24 .1 r
.50042 .26924 m
.46965 .27032 L
s
.4572 .23886 m
.46965 .27032 L
s
.267 .077 .042 r
.62824 .40046 m .62399 .38686 L .61471 .37462 L p F P
0 0 0 r
s
.267 .077 .042 r
.61061 .36166 m .61471 .37462 L .62399 .38686 L p F P
0 0 0 r
s
.24 .35 .67 r
.64431 .62824 m
.6492 .63239 L
s
.6492 .63239 m
.69333 .62621 L
s
.088 .103 .207 r
.38625 .37395 m .40536 .3705 L .39768 .38245 L p F P
0 0 0 r
s
.088 .103 .207 r
.39768 .38245 m .37704 .38614 L .38625 .37395 L p F P
0 0 0 r
s
.28 .43 .842 r
.50302 .64144 m .49957 .64193 L .49916 .65021 L p F P
0 0 0 r
s
.28 .43 .842 r
.49916 .65021 m .50589 .64927 L .50302 .64144 L p F P
0 0 0 r
s
.66 .179 .065 r
.64638 .46248 m .64211 .44888 L .63897 .43026 L p F P
0 0 0 r
s
.855 .238 .09 r
.64211 .44888 m .64638 .46248 L .64588 .48251 L p F P
0 0 0 r
s
.24 .35 .67 r
.22561 .63404 m
.23742 .65622 L
s
.23742 .65622 m
.2792 .65017 L
s
.06 .072 .138 r
.50219 .34632 m .51983 .34312 L .52217 .3494 L p F P
0 0 0 r
s
.06 .072 .138 r
.52217 .3494 m .50245 .35297 L .50219 .34632 L p F P
0 0 0 r
s
.28 .43 .842 r
.50648 .64095 m .50302 .64144 L .50589 .64927 L p F P
0 0 0 r
s
.28 .43 .842 r
.50589 .64927 m .51262 .64832 L .50648 .64095 L p F P
0 0 0 r
s
.24 .35 .67 r
.51146 .64693 m
.51249 .64679 L
s
.51249 .64679 m
.51488 .648 L
s
.888 .244 .094 r
.32652 .49234 m .3188 .47922 L .31817 .45913 L p F P
0 0 0 r
s
.72 .193 .072 r
.3188 .47922 m .32652 .49234 L .33156 .51271 L p F P
0 0 0 r
s
.83 .24 .1 r
.32882 .49797 m
.3438 .5234 L
s
.32771 .47279 m
.32882 .49797 L
s
.187 .054 .028 r
.63897 .43026 m .63467 .41646 L .62824 .40046 L p F P
0 0 0 r
s
.187 .054 .028 r
.62399 .38686 m .62824 .40046 L .63467 .41646 L p F P
0 0 0 r
s
.83 .24 .1 r
.61533 .37464 m
.62423 .40276 L
s
1 .324 .136 r
.5601 .64165 m .55849 .63806 L .58506 .63689 L p F P
0 0 0 r
s
1 .324 .136 r
.58282 .63161 m .58506 .63689 L .55849 .63806 L p F P
0 0 0 r
s
.66 .179 .065 r
.63467 .41646 m .63897 .43026 L .64211 .44888 L p F P
0 0 0 r
s
.83 .24 .1 r
.63556 .42469 m
.64063 .44941 L
s
.28 .43 .842 r
.50994 .64046 m .50648 .64095 L .51262 .64832 L p F P
0 0 0 r
s
.28 .43 .842 r
.51262 .64832 m .51937 .64737 L .50994 .64046 L p F P
0 0 0 r
s
.24 .35 .67 r
.24488 .42011 m
.28676 .41267 L
s
.24488 .42011 m
.24038 .44333 L
s
.36423 .63786 m
.37485 .6546 L
s
.37485 .6546 m
.41749 .64853 L
s
.89 .268 .117 r
.45996 .64433 m .4619 .64788 L .48044 .64072 L p F P
0 0 0 r
s
.83 .24 .1 r
.46291 .64749 m
.46297 .64759 L
s
.89 .268 .117 r
.4814 .64255 m .48044 .64072 L .4619 .64788 L p F P
0 0 0 r
s
1 .332 .137 r
.60347 .61863 m .60068 .61166 L .62021 .5997 L p F P
0 0 0 r
s
1 .332 .137 r
.61699 .59116 m .62021 .5997 L .60068 .61166 L p F P
0 0 0 r
s
1 .33 .135 r
.62021 .5997 m .61699 .59116 L .63288 .57559 L p F P
0 0 0 r
s
.088 .103 .207 r
.40536 .3705 m .42457 .36703 L .41843 .37873 L p F P
0 0 0 r
s
.088 .103 .207 r
.41843 .37873 m .39768 .38245 L .40536 .3705 L p F P
0 0 0 r
s
.24 .35 .67 r
.8291 .60502 m
.82887 .60722 L
s
.788 .241 .106 r
.43306 .63029 m .43605 .63558 L .45604 .63716 L p F P
0 0 0 r
s
.788 .241 .106 r
.45801 .64076 m .45604 .63716 L .43605 .63558 L p F P
0 0 0 r
s
.28 .43 .842 r
.5134 .63997 m .50994 .64046 L .51937 .64737 L p F P
0 0 0 r
s
.28 .43 .842 r
.51937 .64737 m .52613 .64642 L .5134 .63997 L p F P
0 0 0 r
s
1 .33 .135 r
.6293 .56559 m .63288 .57559 L .61699 .59116 L p F P
0 0 0 r
s
1 .323 .13 r
.63288 .57559 m .6293 .56559 L .64138 .54724 L p F P
0 0 0 r
s
.06 .072 .138 r
.51983 .34312 m .53756 .33991 L .54201 .34582 L p F P
0 0 0 r
s
.06 .072 .138 r
.54201 .34582 m .52217 .3494 L .51983 .34312 L p F P
0 0 0 r
s
.996 .278 .11 r
.31817 .45913 m .31025 .44545 L .31444 .42686 L p F P
0 0 0 r
s
.888 .244 .094 r
.31025 .44545 m .31817 .45913 L .3188 .47922 L p F P
0 0 0 r
s
1 .329 .137 r
.58282 .63161 m .58056 .62629 L .60347 .61863 L p F P
0 0 0 r
s
1 .329 .137 r
.60068 .61166 m .60347 .61863 L .58056 .62629 L p F P
0 0 0 r
s
.28 .43 .842 r
.51687 .63948 m .5134 .63997 L .52613 .64642 L p F P
0 0 0 r
s
.28 .43 .842 r
.52613 .64642 m .5329 .64547 L .51687 .63948 L p F P
0 0 0 r
s
.38 .117 .058 r
.61061 .36166 m .60642 .34845 L .59517 .34226 L p F P
0 0 0 r
s
.83 .24 .1 r
.59821 .35629 m
.61533 .37464 L
s
.38 .117 .058 r
.59125 .33016 m .59517 .34226 L .60642 .34845 L p F P
0 0 0 r
s
.83 .24 .1 r
.49105 .64384 m
.49577 .65298 L
s
.49577 .65298 m
.52749 .64853 L
s
.58866 .32689 m
.56644 .31292 L
s
.55609 .28227 m
.56644 .31292 L
s
1 .3 .12 r
.31444 .42686 m .30656 .41298 L .31582 .39711 L p F P
0 0 0 r
s
.13 .166 .335 r
.31582 .39711 m .33611 .39347 L .32785 .40921 L p F P
0 0 0 r
s
.13 .166 .335 r
.32785 .40921 m .30656 .41298 L .31582 .39711 L p F P
0 0 0 r
s
.83 .24 .1 r
.30969 .40581 m
.3107 .4076 L
s
.30189 .39193 m
.30969 .40581 L
s
.24 .35 .67 r
.15699 .45788 m
.19844 .45065 L
s
.15699 .45788 m
.15419 .48576 L
s
.996 .278 .11 r
.30656 .41298 m .31444 .42686 L .31025 .44545 L p F P
0 0 0 r
s
.83 .24 .1 r
.31307 .41183 m
.31775 .42014 L
s
.365 .111 .056 r
.38783 .59759 m .38278 .58902 L .36683 .57312 L p F P
0 0 0 r
s
.486 .155 .073 r
.38278 .58902 m .38783 .59759 L .40608 .60991 L p F P
0 0 0 r
s
.486 .155 .073 r
.41013 .6169 m .40608 .60991 L .38783 .59759 L p F P
0 0 0 r
s
1 .323 .13 r
.63752 .53592 m .64138 .54724 L .6293 .56559 L p F P
0 0 0 r
s
1 .308 .123 r
.64138 .54724 m .63752 .53592 L .64569 .51578 L p F P
0 0 0 r
s
.28 .43 .842 r
.52033 .63899 m .51687 .63948 L .5329 .64547 L p F P
0 0 0 r
s
.28 .43 .842 r
.5329 .64547 m .53968 .64452 L .52033 .63899 L p F P
0 0 0 r
s
.83 .24 .1 r
.31566 .31224 m
.33125 .34227 L
s
.33125 .34227 m
.31384 .36635 L
s
.24 .35 .67 r
.6891 .3113 m
.73371 .3032 L
s
.6891 .3113 m
.68715 .31438 L
s
.088 .103 .207 r
.42457 .36703 m .44389 .36354 L .43931 .37499 L p F P
0 0 0 r
s
.088 .103 .207 r
.43931 .37499 m .41843 .37873 L .42457 .36703 L p F P
0 0 0 r
s
.65 .203 .092 r
.40608 .60991 m .41013 .6169 L .43005 .62495 L p F P
0 0 0 r
s
.65 .203 .092 r
.43306 .63029 m .43005 .62495 L .41013 .6169 L p F P
0 0 0 r
s
.245 .071 .038 r
.36683 .57312 m .36085 .56308 L .34782 .54445 L p F P
0 0 0 r
s
.365 .111 .056 r
.36085 .56308 m .36683 .57312 L .38278 .58902 L p F P
0 0 0 r
s
.83 .24 .1 r
.36543 .56769 m
.36704 .5704 L
s
.24 .35 .67 r
.68929 .62191 m
.69333 .62621 L
s
.69333 .62621 m
.73798 .61995 L
s
.06 .072 .138 r
.53756 .33991 m .55537 .33667 L .56195 .34222 L p F P
0 0 0 r
s
.24 .35 .67 r
.55578 .33702 m
.5565 .33647 L
s
.06 .072 .138 r
.56195 .34222 m .54201 .34582 L .53756 .33991 L p F P
0 0 0 r
s
.28 .43 .842 r
.52381 .63849 m .52033 .63899 L .53968 .64452 L p F P
0 0 0 r
s
.28 .43 .842 r
.53968 .64452 m .54647 .64356 L .52381 .63849 L p F P
0 0 0 r
s
.89 .268 .117 r
.45801 .64076 m .45996 .64433 L .47948 .63889 L p F P
0 0 0 r
s
.83 .24 .1 r
.46103 .64403 m
.46108 .64413 L
s
.89 .268 .117 r
.48044 .64072 m .47948 .63889 L .45996 .64433 L p F P
0 0 0 r
s
.24 .35 .67 r
.46064 .64239 m
.46539 .64794 L
s
.83 .24 .1 r
.52962 .27323 m
.50042 .26924 L
s
.48857 .23754 m
.50042 .26924 L
s
.28 .43 .842 r
.52728 .638 m .52381 .63849 L .54647 .64356 L p F P
0 0 0 r
s
.28 .43 .842 r
.54647 .64356 m .55328 .64261 L .52728 .638 L p F P
0 0 0 r
s
.24 .35 .67 r
.26787 .62778 m
.2792 .65017 L
s
.2792 .65017 m
.32147 .64405 L
s
1 .324 .136 r
.55849 .63806 m .55686 .63444 L .58282 .63161 L p F P
0 0 0 r
s
1 .324 .136 r
.58056 .62629 m .58282 .63161 L .55686 .63444 L p F P
0 0 0 r
s
.13 .166 .335 r
.33611 .39347 m .35652 .38982 L .34926 .40541 L p F P
0 0 0 r
s
.13 .166 .335 r
.34926 .40541 m .32785 .40921 L .33611 .39347 L p F P
0 0 0 r
s
1 .308 .123 r
.6416 .50333 m .64569 .51578 L .63752 .53592 L p F P
0 0 0 r
s
.83 .24 .1 r
.64445 .51201 m
.64573 .50788 L
s
.998 .282 .11 r
.64569 .51578 m .6416 .50333 L .64588 .48251 L p F P
0 0 0 r
s
.561 .145 .055 r
.34782 .54445 m .34104 .53307 L .33156 .51271 L p F P
0 0 0 r
s
.245 .071 .038 r
.34104 .53307 m .34782 .54445 L .36085 .56308 L p F P
0 0 0 r
s
.83 .24 .1 r
.35147 .54685 m
.36543 .56769 L
s
.28 .43 .842 r
.53076 .63751 m .52728 .638 L .55328 .64261 L p F P
0 0 0 r
s
.28 .43 .842 r
.55328 .64261 m .5601 .64165 L .53076 .63751 L p F P
0 0 0 r
s
.24 .35 .67 r
.55457 .64087 m
.55591 .64068 L
s
.55591 .64068 m
.55676 .64118 L
s
.56351 .63961 m
.59985 .63449 L
s
.55591 .64068 m
.55944 .64018 L
s
.088 .103 .207 r
.44389 .36354 m .4633 .36003 L .4603 .37123 L p F P
0 0 0 r
s
.088 .103 .207 r
.4603 .37123 m .43931 .37499 L .44389 .36354 L p F P
0 0 0 r
s
.788 .241 .106 r
.43005 .62495 m .43306 .63029 L .45406 .63354 L p F P
0 0 0 r
s
.788 .241 .106 r
.45604 .63716 m .45406 .63354 L .43306 .63029 L p F P
0 0 0 r
s
.24 .35 .67 r
.28676 .41267 m
.30905 .40871 L
s
.28676 .41267 m
.28282 .43592 L
s
.17295 .61323 m
.18384 .64023 L
s
.18384 .64023 m
.22561 .63404 L
s
.06 .072 .138 r
.55537 .33667 m .57327 .33343 L .58199 .3386 L p F P
0 0 0 r
s
.06 .072 .138 r
.58199 .3386 m .56195 .34222 L .55537 .33667 L p F P
0 0 0 r
s
.83 .24 .1 r
.52303 .63931 m
.52749 .64853 L
s
.52749 .64853 m
.5439 .64314 L
s
.5439 .64314 m
.5472 .64206 L
s
.24 .35 .67 r
.40751 .63159 m
.41749 .64853 L
s
.41749 .64853 m
.46064 .64239 L
s
1 .316 .133 r
.55849 .63806 m .5601 .64165 L .53076 .63751 L p F P
0 0 0 r
s
.267 .077 .042 r
.62399 .38686 m .61965 .37298 L .61061 .36166 L p F P
0 0 0 r
s
.267 .077 .042 r
.60642 .34845 m .61061 .36166 L .61965 .37298 L p F P
0 0 0 r
s
.89 .268 .117 r
.45604 .63716 m .45801 .64076 L .47852 .63705 L p F P
0 0 0 r
s
.83 .24 .1 r
.45913 .64055 m
.45919 .64065 L
s
.89 .268 .117 r
.47948 .63889 m .47852 .63705 L .45801 .64076 L p F P
0 0 0 r
s
.998 .282 .11 r
.64162 .46917 m .64588 .48251 L .6416 .50333 L p F P
0 0 0 r
s
.855 .238 .09 r
.64588 .48251 m .64162 .46917 L .64211 .44888 L p F P
0 0 0 r
s
.83 .24 .1 r
.64063 .44941 m
.64199 .45374 L
s
.72 .193 .072 r
.33156 .51271 m .32412 .50019 L .3188 .47922 L p F P
0 0 0 r
s
.561 .145 .055 r
.32412 .50019 m .33156 .51271 L .34104 .53307 L p F P
0 0 0 r
s
.13 .166 .335 r
.35652 .38982 m .37704 .38614 L .3708 .4016 L p F P
0 0 0 r
s
.13 .166 .335 r
.3708 .4016 m .34926 .40541 L .35652 .38982 L p F P
0 0 0 r
s
1 .329 .137 r
.58056 .62629 m .57828 .62091 L .60068 .61166 L p F P
0 0 0 r
s
1 .329 .137 r
.59786 .6046 m .60068 .61166 L .57828 .62091 L p F P
0 0 0 r
s
1 .332 .137 r
.60068 .61166 m .59786 .6046 L .61699 .59116 L p F P
0 0 0 r
s
.24 .35 .67 r
.19844 .45065 m
.24038 .44333 L
s
.19844 .45065 m
.19608 .47861 L
s
1 .332 .137 r
.61372 .58249 m .61699 .59116 L .59786 .6046 L p F P
0 0 0 r
s
1 .33 .135 r
.61699 .59116 m .61372 .58249 L .6293 .56559 L p F P
0 0 0 r
s
.38 .117 .058 r
.60642 .34845 m .60215 .33496 L .59125 .33016 L p F P
0 0 0 r
s
.06 .072 .138 r
.57327 .33343 m .59125 .33016 L .60215 .33496 L p F P
0 0 0 r
s
.24 .35 .67 r
.59382 .3313 m
.59773 .33059 L
s
.59773 .33059 m
.60142 .32722 L
s
.83 .24 .1 r
.58985 .33055 m
.5899 .3307 L
s
.58866 .32689 m
.58985 .33055 L
s
.06 .072 .138 r
.60215 .33496 m .58199 .3386 L .57327 .33343 L p F P
0 0 0 r
s
.83 .24 .1 r
.59188 .33682 m
.59821 .35629 L
s
.088 .103 .207 r
.4633 .36003 m .48282 .35651 L .48141 .36745 L p F P
0 0 0 r
s
.088 .103 .207 r
.48141 .36745 m .4603 .37123 L .4633 .36003 L p F P
0 0 0 r
s
.24 .35 .67 r
.73371 .3032 m
.77885 .295 L
s
.73371 .3032 m
.73266 .30613 L
s
.73481 .6155 m
.73798 .61995 L
s
.73798 .61995 m
.78316 .61362 L
s
.66 .179 .065 r
.64211 .44888 m .63774 .43497 L .63467 .41646 L p F P
0 0 0 r
s
.855 .238 .09 r
.63774 .43497 m .64211 .44888 L .64162 .46917 L p F P
0 0 0 r
s
1 .324 .136 r
.55686 .63444 m .55522 .6308 L .58056 .62629 L p F P
0 0 0 r
s
1 .324 .136 r
.57828 .62091 m .58056 .62629 L .55522 .6308 L p F P
0 0 0 r
s
.486 .155 .073 r
.40608 .60991 m .40198 .60282 L .38278 .58902 L p F P
0 0 0 r
s
.65 .203 .092 r
.40198 .60282 m .40608 .60991 L .427 .61956 L p F P
0 0 0 r
s
.65 .203 .092 r
.43005 .62495 m .427 .61956 L .40608 .60991 L p F P
0 0 0 r
s
1 .316 .133 r
.53076 .63751 m .52988 .63567 L .55849 .63806 L p F P
0 0 0 r
s
1 .316 .133 r
.55686 .63444 m .55849 .63806 L .52988 .63567 L p F P
0 0 0 r
s
1 .33 .135 r
.62566 .55541 m .6293 .56559 L .61372 .58249 L p F P
0 0 0 r
s
1 .323 .13 r
.6293 .56559 m .62566 .55541 L .63752 .53592 L p F P
0 0 0 r
s
.187 .054 .028 r
.63467 .41646 m .63028 .40235 L .62399 .38686 L p F P
0 0 0 r
s
.187 .054 .028 r
.61965 .37298 m .62399 .38686 L .63028 .40235 L p F P
0 0 0 r
s
.83 .24 .1 r
.61533 .37464 m
.62679 .39668 L
s
.365 .111 .056 r
.38278 .58902 m .37766 .58031 L .36085 .56308 L p F P
0 0 0 r
s
.486 .155 .073 r
.37766 .58031 m .38278 .58902 L .40198 .60282 L p F P
0 0 0 r
s
.888 .244 .094 r
.3188 .47922 m .3109 .46581 L .31025 .44545 L p F P
0 0 0 r
s
.83 .24 .1 r
.31223 .44602 m
.31775 .42014 L
s
.72 .193 .072 r
.3109 .46581 m .3188 .47922 L .32412 .50019 L p F P
0 0 0 r
s
.83 .24 .1 r
.31223 .44602 m
.32771 .47279 L
s
.24 .35 .67 r
.31063 .62144 m
.32147 .64405 L
s
.32147 .64405 m
.36423 .63786 L
s
.13 .166 .335 r
.37704 .38614 m .39768 .38245 L .39247 .39776 L p F P
0 0 0 r
s
.13 .166 .335 r
.39247 .39776 m .3708 .4016 L .37704 .38614 L p F P
0 0 0 r
s
.66 .179 .065 r
.63028 .40235 m .63467 .41646 L .63774 .43497 L p F P
0 0 0 r
s
.83 .24 .1 r
.62679 .39668 m
.63493 .42269 L
s
.89 .268 .117 r
.45406 .63354 m .45604 .63716 L .47755 .63521 L p F P
0 0 0 r
s
.83 .24 .1 r
.45722 .63705 m
.45728 .63715 L
s
.89 .268 .117 r
.47852 .63705 m .47755 .63521 L .45604 .63716 L p F P
0 0 0 r
s
.289 .437 .857 r
.48236 .64436 m .48579 .64388 L .5 .62969 L closepath p F P
0 0 0 r
s
.967 .289 .124 r
.5 .62969 m .4814 .64255 L .48236 .64436 L closepath p F P
0 0 0 r
s
.788 .241 .106 r
.427 .61956 m .43005 .62495 L .45207 .62989 L p F P
0 0 0 r
s
.788 .241 .106 r
.45406 .63354 m .45207 .62989 L .43005 .62495 L p F P
0 0 0 r
s
.088 .103 .207 r
.48282 .35651 m .50245 .35297 L .50265 .36364 L p F P
0 0 0 r
s
.088 .103 .207 r
.50265 .36364 m .48141 .36745 L .48282 .35651 L p F P
0 0 0 r
s
.289 .437 .857 r
.48579 .64388 m .48923 .64339 L .5 .62969 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.29771 .3366 m
.31384 .36635 L
s
.31384 .36635 m
.30189 .39193 L
s
.24 .35 .67 r
.59773 .33059 m
.64217 .32253 L
s
.5972 .33279 m
.59773 .33059 L
s
.59319 .62353 m
.59985 .63449 L
s
.59985 .63449 m
.64431 .62824 L
s
.289 .437 .857 r
.48923 .64339 m .49268 .6429 L .5 .62969 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.21506 .60682 m
.22561 .63404 L
s
.22561 .63404 m
.26787 .62778 L
s
.46064 .64239 m
.47809 .6399 L
s
.245 .071 .038 r
.36085 .56308 m .35477 .55285 L .34104 .53307 L p F P
0 0 0 r
s
.365 .111 .056 r
.35477 .55285 m .36085 .56308 L .37766 .58031 L p F P
0 0 0 r
s
.289 .437 .857 r
.49268 .6429 m .49612 .64242 L .5 .62969 L closepath p F P
0 0 0 r
s
.996 .278 .11 r
.31025 .44545 m .30214 .43146 L .30656 .41298 L p F P
0 0 0 r
s
.888 .244 .094 r
.30214 .43146 m .31025 .44545 L .3109 .46581 L p F P
0 0 0 r
s
.967 .289 .124 r
.5 .62969 m .48044 .64072 L .4814 .64255 L closepath p F P
0 0 0 r
s
1 .323 .13 r
.63357 .52438 m .63752 .53592 L .62566 .55541 L p F P
0 0 0 r
s
.83 .24 .1 r
.62434 .55483 m
.62699 .55022 L
s
.63665 .53338 m
.63817 .53074 L
s
1 .308 .123 r
.63752 .53592 m .63357 .52438 L .6416 .50333 L p F P
0 0 0 r
s
.289 .437 .857 r
.49612 .64242 m .49957 .64193 L .5 .62969 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.15419 .48576 m
.19608 .47861 L
s
.15419 .48576 m
.15445 .51698 L
s
.83 .24 .1 r
.55609 .28227 m
.52962 .27323 L
s
.51832 .24133 m
.52962 .27323 L
s
.289 .437 .857 r
.49957 .64193 m .50302 .64144 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .316 .133 r
.52988 .63567 m .529 .63382 L .55686 .63444 L p F P
0 0 0 r
s
1 .316 .133 r
.55522 .6308 m .55686 .63444 L .529 .63382 L p F P
0 0 0 r
s
.83 .24 .1 r
.42536 .24514 m
.39421 .25608 L
s
.37986 .22379 m
.39421 .25608 L
s
.39421 .25608 m
.36486 .27128 L
s
.163 .218 .437 r
.30656 .41298 m .32785 .40921 L .3239 .42766 L p F P
0 0 0 r
s
.163 .218 .437 r
.3239 .42766 m .30214 .43146 L .30656 .41298 L p F P
0 0 0 r
s
.13 .166 .335 r
.39768 .38245 m .41843 .37873 L .41427 .3939 L p F P
0 0 0 r
s
.13 .166 .335 r
.41427 .3939 m .39247 .39776 L .39768 .38245 L p F P
0 0 0 r
s
.289 .437 .857 r
.50302 .64144 m .50648 .64095 L .5 .62969 L closepath p F P
0 0 0 r
s
.088 .103 .207 r
.50245 .35297 m .52217 .3494 L .524 .35982 L p F P
0 0 0 r
s
.088 .103 .207 r
.524 .35982 m .50265 .36364 L .50245 .35297 L p F P
0 0 0 r
s
.289 .437 .857 r
.50648 .64095 m .50994 .64046 L .5 .62969 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.24038 .44333 m
.28282 .43592 L
s
.24038 .44333 m
.23846 .47138 L
s
.83 .24 .1 r
.58866 .32689 m
.5943 .33285 L
s
.57868 .29617 m
.58866 .32689 L
s
.89 .268 .117 r
.45207 .62989 m .45406 .63354 L .47658 .63336 L p F P
0 0 0 r
s
.83 .24 .1 r
.45257 .62852 m
.45342 .63008 L
s
.4553 .63353 m
.45535 .63363 L
s
.89 .268 .117 r
.47755 .63521 m .47658 .63336 L .45406 .63354 L p F P
0 0 0 r
s
.967 .289 .124 r
.5 .62969 m .47948 .63889 L .48044 .64072 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.34983 .2393 m
.36486 .27128 L
s
.36486 .27128 m
.33834 .29022 L
s
.289 .437 .857 r
.50994 .64046 m .5134 .63997 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .329 .137 r
.57828 .62091 m .57598 .61547 L .59786 .6046 L p F P
0 0 0 r
s
1 .329 .137 r
.59501 .59744 m .59786 .6046 L .57598 .61547 L p F P
0 0 0 r
s
1 .332 .137 r
.59786 .6046 m .59501 .59744 L .61372 .58249 L p F P
0 0 0 r
s
1 .324 .136 r
.55522 .6308 m .55358 .62713 L .57828 .62091 L p F P
0 0 0 r
s
1 .324 .136 r
.57598 .61547 m .57828 .62091 L .55358 .62713 L p F P
0 0 0 r
s
.24 .35 .67 r
.77872 .29779 m
.77885 .295 L
s
.83 .24 .1 r
.4572 .23886 m
.42536 .24514 L
s
.41169 .21254 m
.42536 .24514 L
s
.289 .437 .857 r
.5134 .63997 m .51687 .63948 L .5 .62969 L closepath p F P
0 0 0 r
s
.561 .145 .055 r
.34104 .53307 m .33411 .52147 L .32412 .50019 L p F P
0 0 0 r
s
.245 .071 .038 r
.33411 .52147 m .34104 .53307 L .35477 .55285 L p F P
0 0 0 r
s
.83 .24 .1 r
.32882 .49797 m
.33645 .5216 L
s
.33645 .5216 m
.35147 .54685 L
s
.24 .35 .67 r
.78089 .60902 m
.78316 .61362 L
s
.78316 .61362 m
.82887 .60722 L
s
.289 .437 .857 r
.51687 .63948 m .52033 .63899 L .5 .62969 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.16409 .58255 m
.17295 .61323 L
s
.17295 .61323 m
.21506 .60682 L
s
1 .308 .123 r
.63742 .49061 m .6416 .50333 L .63357 .52438 L p F P
0 0 0 r
s
.998 .282 .11 r
.6416 .50333 m .63742 .49061 L .64162 .46917 L p F P
0 0 0 r
s
.289 .437 .857 r
.52033 .63899 m .52381 .63849 L .5 .62969 L closepath p F P
0 0 0 r
s
.65 .203 .092 r
.427 .61956 m .42393 .61411 L .40198 .60282 L p F P
0 0 0 r
s
.788 .241 .106 r
.42393 .61411 m .427 .61956 L .45006 .62621 L p F P
0 0 0 r
s
.788 .241 .106 r
.45207 .62989 m .45006 .62621 L .427 .61956 L p F P
0 0 0 r
s
.83 .24 .1 r
.45112 .62816 m
.45257 .62852 L
s
.967 .289 .124 r
.5 .62969 m .47852 .63705 L .47948 .63889 L closepath p F P
0 0 0 r
s
1 .332 .137 r
.6104 .57368 m .61372 .58249 L .59501 .59744 L p F P
0 0 0 r
s
1 .33 .135 r
.61372 .58249 m .6104 .57368 L .62566 .55541 L p F P
0 0 0 r
s
.83 .24 .1 r
.62434 .55483 m
.62488 .55635 L
s
.13 .166 .335 r
.41843 .37873 m .43931 .37499 L .4362 .39001 L p F P
0 0 0 r
s
.13 .166 .335 r
.4362 .39001 m .41427 .3939 L .41843 .37873 L p F P
0 0 0 r
s
.486 .155 .073 r
.40198 .60282 m .39782 .59565 L .37766 .58031 L p F P
0 0 0 r
s
.65 .203 .092 r
.39782 .59565 m .40198 .60282 L .42393 .61411 L p F P
0 0 0 r
s
.163 .218 .437 r
.32785 .40921 m .34926 .40541 L .3458 .42383 L p F P
0 0 0 r
s
.163 .218 .437 r
.3458 .42383 m .3239 .42766 L .32785 .40921 L p F P
0 0 0 r
s
.24 .35 .67 r
.32577 .42843 m
.32593 .4273 L
s
.289 .437 .857 r
.52381 .63849 m .52728 .638 L .5 .62969 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.3539 .61503 m
.36423 .63786 L
s
.36423 .63786 m
.40751 .63159 L
s
.088 .103 .207 r
.52217 .3494 m .54201 .34582 L .54548 .35597 L p F P
0 0 0 r
s
.088 .103 .207 r
.54548 .35597 m .524 .35982 L .52217 .3494 L p F P
0 0 0 r
s
1 .316 .133 r
.529 .63382 m .52812 .63196 L .55522 .6308 L p F P
0 0 0 r
s
1 .316 .133 r
.55358 .62713 m .55522 .6308 L .52812 .63196 L p F P
0 0 0 r
s
.289 .437 .857 r
.52728 .638 m .53076 .63751 L .5 .62969 L closepath p F P
0 0 0 r
s
.267 .077 .042 r
.61965 .37298 m .61521 .35879 L .60642 .34845 L p F P
0 0 0 r
s
.267 .077 .042 r
.60215 .33496 m .60642 .34845 L .61521 .35879 L p F P
0 0 0 r
s
.24 .35 .67 r
.64217 .32253 m
.68715 .31438 L
s
.64217 .32253 m
.64054 .33276 L
s
1 .304 .13 r
.52988 .63567 m .53076 .63751 L .5 .62969 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.63844 .61709 m
.64431 .62824 L
s
.64431 .62824 m
.68929 .62191 L
s
.89 .268 .117 r
.45006 .62621 m .45207 .62989 L .4756 .6315 L p F P
0 0 0 r
s
.89 .268 .117 r
.47658 .63336 m .4756 .6315 L .45207 .62989 L p F P
0 0 0 r
s
.967 .289 .124 r
.5 .62969 m .47755 .63521 L .47852 .63705 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.25766 .60033 m
.26787 .62778 L
s
.26787 .62778 m
.31063 .62144 L
s
.365 .111 .056 r
.37766 .58031 m .37245 .57147 L .35477 .55285 L p F P
0 0 0 r
s
.486 .155 .073 r
.37245 .57147 m .37766 .58031 L .39782 .59565 L p F P
0 0 0 r
s
.72 .193 .072 r
.32412 .50019 m .31652 .48741 L .3109 .46581 L p F P
0 0 0 r
s
.561 .145 .055 r
.31652 .48741 m .32412 .50019 L .33411 .52147 L p F P
0 0 0 r
s
.83 .24 .1 r
.32265 .25853 m
.33834 .29022 L
s
.33834 .29022 m
.31566 .31224 L
s
.998 .282 .11 r
.63726 .45554 m .64162 .46917 L .63742 .49061 L p F P
0 0 0 r
s
.83 .24 .1 r
.63975 .46332 m
.64018 .45649 L
s
.855 .238 .09 r
.64162 .46917 m .63726 .45554 L .63774 .43497 L p F P
0 0 0 r
s
1 .33 .135 r
.62195 .54505 m .62566 .55541 L .6104 .57368 L p F P
0 0 0 r
s
1 .323 .13 r
.62566 .55541 m .62195 .54505 L .63357 .52438 L p F P
0 0 0 r
s
.24 .35 .67 r
.19608 .47861 m
.23846 .47138 L
s
.19608 .47861 m
.19663 .50996 L
s
.13 .166 .335 r
.43931 .37499 m .4603 .37123 L .45826 .38611 L p F P
0 0 0 r
s
.13 .166 .335 r
.45826 .38611 m .4362 .39001 L .43931 .37499 L p F P
0 0 0 r
s
1 .304 .13 r
.529 .63382 m .52988 .63567 L .5 .62969 L closepath p F P
0 0 0 r
s
.088 .103 .207 r
.54201 .34582 m .56195 .34222 L .56709 .3521 L p F P
0 0 0 r
s
.088 .103 .207 r
.56709 .3521 m .54548 .35597 L .54201 .34582 L p F P
0 0 0 r
s
.163 .218 .437 r
.34926 .40541 m .3708 .4016 L .36783 .41999 L p F P
0 0 0 r
s
.163 .218 .437 r
.36783 .41999 m .3458 .42383 L .34926 .40541 L p F P
0 0 0 r
s
.83 .24 .1 r
.48857 .23754 m
.4572 .23886 L
s
.44418 .20598 m
.4572 .23886 L
s
.967 .289 .124 r
.5 .62969 m .47658 .63336 L .47755 .63521 L closepath p F P
0 0 0 r
s
1 .324 .136 r
.55358 .62713 m .55192 .62344 L .57598 .61547 L p F P
0 0 0 r
s
1 .324 .136 r
.57365 .60998 m .57598 .61547 L .55192 .62344 L p F P
0 0 0 r
s
1 .329 .137 r
.57598 .61547 m .57365 .60998 L .59501 .59744 L p F P
0 0 0 r
s
.24 .35 .67 r
.15445 .51698 m
.19663 .50996 L
s
.15445 .51698 m
.15781 .54985 L
s
.28282 .43592 m
.28136 .46406 L
s
1 .316 .133 r
.52812 .63196 m .52723 .6301 L .55358 .62713 L p F P
0 0 0 r
s
.24 .35 .67 r
.5307 .63242 m
.53486 .63183 L
s
1 .316 .133 r
.55192 .62344 m .55358 .62713 L .52723 .6301 L p F P
0 0 0 r
s
.187 .054 .028 r
.63028 .40235 m .62578 .38792 L .61965 .37298 L p F P
0 0 0 r
s
.187 .054 .028 r
.61521 .35879 m .61965 .37298 L .62578 .38792 L p F P
0 0 0 r
s
.66 .179 .065 r
.63774 .43497 m .63328 .42074 L .63028 .40235 L p F P
0 0 0 r
s
.855 .238 .09 r
.63328 .42074 m .63774 .43497 L .63726 .45554 L p F P
0 0 0 r
s
1 .304 .13 r
.52812 .63196 m .529 .63382 L .5 .62969 L closepath p F P
0 0 0 r
s
.788 .241 .106 r
.45006 .62621 m .44804 .62252 L .42393 .61411 L p F P
0 0 0 r
s
.89 .268 .117 r
.44804 .62252 m .45006 .62621 L .47462 .62964 L p F P
0 0 0 r
s
.83 .24 .1 r
.45142 .6264 m
.45147 .62651 L
s
.89 .268 .117 r
.4756 .6315 m .47462 .62964 L .45006 .62621 L p F P
0 0 0 r
s
.65 .203 .092 r
.42393 .61411 m .42082 .60861 L .39782 .59565 L p F P
0 0 0 r
s
.788 .241 .106 r
.42082 .60861 m .42393 .61411 L .44804 .62252 L p F P
0 0 0 r
s
.24 .35 .67 r
.82887 .60722 m
.82752 .60246 L
s
1 .329 .137 r
.59211 .59019 m .59501 .59744 L .57365 .60998 L p F P
0 0 0 r
s
1 .332 .137 r
.59501 .59744 m .59211 .59019 L .6104 .57368 L p F P
0 0 0 r
s
.245 .071 .038 r
.35477 .55285 m .34858 .54244 L .33411 .52147 L p F P
0 0 0 r
s
.365 .111 .056 r
.34858 .54244 m .35477 .55285 L .37245 .57147 L p F P
0 0 0 r
s
.967 .289 .124 r
.5 .62969 m .4756 .6315 L .47658 .63336 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.15781 .54985 m
.16409 .58255 L
s
.16409 .58255 m
.20639 .57592 L
s
.888 .244 .094 r
.3109 .46581 m .30283 .4521 L .30214 .43146 L p F P
0 0 0 r
s
.24 .35 .67 r
.28282 .43592 m
.30218 .43254 L
s
.72 .193 .072 r
.30283 .4521 m .3109 .46581 L .31652 .48741 L p F P
0 0 0 r
s
.83 .24 .1 r
.31316 .47141 m
.32882 .49797 L
s
.24 .35 .67 r
.20639 .57592 m
.21506 .60682 L
s
.21506 .60682 m
.25766 .60033 L
s
.66 .179 .065 r
.62578 .38792 m .63028 .40235 L .63328 .42074 L p F P
0 0 0 r
s
.83 .24 .1 r
.62679 .39668 m
.63186 .42159 L
s
.088 .103 .207 r
.56195 .34222 m .58199 .3386 L .58882 .34821 L p F P
0 0 0 r
s
.088 .103 .207 r
.58882 .34821 m .56709 .3521 L .56195 .34222 L p F P
0 0 0 r
s
.13 .166 .335 r
.4603 .37123 m .48141 .36745 L .48046 .38217 L p F P
0 0 0 r
s
.13 .166 .335 r
.48046 .38217 m .45826 .38611 L .4603 .37123 L p F P
0 0 0 r
s
.83 .24 .1 r
.28532 .36243 m
.30189 .39193 L
s
.30189 .39193 m
.29606 .41804 L
s
.163 .218 .437 r
.3708 .4016 m .39247 .39776 L .38999 .41611 L p F P
0 0 0 r
s
.163 .218 .437 r
.38999 .41611 m .36783 .41999 L .3708 .4016 L p F P
0 0 0 r
s
.24 .35 .67 r
.36923 .42084 m
.36937 .41972 L
s
1 .323 .13 r
.62955 .5126 m .63357 .52438 L .62195 .54505 L p F P
0 0 0 r
s
1 .308 .123 r
.63357 .52438 m .62955 .5126 L .63742 .49061 L p F P
0 0 0 r
s
1 .304 .13 r
.52723 .6301 m .52812 .63196 L .5 .62969 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.15781 .54985 m
.20012 .54302 L
s
.486 .155 .073 r
.39782 .59565 m .39361 .58837 L .37245 .57147 L p F P
0 0 0 r
s
.65 .203 .092 r
.39361 .58837 m .39782 .59565 L .42082 .60861 L p F P
0 0 0 r
s
.967 .289 .124 r
.5 .62969 m .47462 .62964 L .4756 .6315 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.47396 .62946 m
.47822 .62965 L
s
.24 .35 .67 r
.68715 .31438 m
.73266 .30613 L
s
.68715 .31438 m
.68637 .32451 L
s
.68424 .61057 m
.68929 .62191 L
s
.68929 .62191 m
.73481 .6155 L
s
.187 .257 .511 r
.30214 .43146 m .3239 .42766 L .32452 .44837 L p F P
0 0 0 r
s
.83 .24 .1 r
.30511 .4337 m
.31223 .44602 L
s
.24 .35 .67 r
.30272 .43245 m
.30331 .43234 L
s
.32394 .42875 m
.32577 .42843 L
s
.83 .24 .1 r
.29606 .41804 m
.30366 .43119 L
s
.187 .257 .511 r
.32452 .44837 m .30283 .4521 L .30214 .43146 L p F P
0 0 0 r
s
.83 .24 .1 r
.31239 .45046 m
.31316 .47141 L
s
1 .316 .133 r
.52723 .6301 m .52635 .62823 L .55192 .62344 L p F P
0 0 0 r
s
.24 .35 .67 r
.53486 .63183 m
.54848 .62989 L
s
.54848 .62989 m
.55322 .63676 L
s
1 .316 .133 r
.55024 .61972 m .55192 .62344 L .52635 .62823 L p F P
0 0 0 r
s
1 .324 .136 r
.55192 .62344 m .55024 .61972 L .57365 .60998 L p F P
0 0 0 r
s
.24 .35 .67 r
.30078 .59377 m
.31063 .62144 L
s
.31063 .62144 m
.3539 .61503 L
s
.83 .24 .1 r
.57868 .29617 m
.55609 .28227 L
s
.54526 .25022 m
.55609 .28227 L
s
1 .332 .137 r
.60702 .56474 m .6104 .57368 L .59211 .59019 L p F P
0 0 0 r
s
.83 .24 .1 r
.60961 .57161 m
.61261 .56819 L
s
1 .33 .135 r
.6104 .57368 m .60702 .56474 L .62195 .54505 L p F P
0 0 0 r
s
1 .304 .13 r
.52635 .62823 m .52723 .6301 L .5 .62969 L closepath p F P
0 0 0 r
s
.267 .077 .042 r
.61521 .35879 m .61068 .34429 L .60215 .33496 L p F P
0 0 0 r
s
.088 .103 .207 r
.58199 .3386 m .60215 .33496 L .61068 .34429 L p F P
0 0 0 r
s
.088 .103 .207 r
.61068 .34429 m .58882 .34821 L .58199 .3386 L p F P
0 0 0 r
s
.83 .24 .1 r
.60593 .34515 m
.60603 .34526 L
s
.60603 .34526 m
.61533 .37464 L
s
.788 .241 .106 r
.44804 .62252 m .446 .61879 L .42082 .60861 L p F P
0 0 0 r
s
.89 .268 .117 r
.446 .61879 m .44804 .62252 L .47364 .62777 L p F P
0 0 0 r
s
.83 .24 .1 r
.44945 .62281 m
.44951 .62291 L
s
.89 .268 .117 r
.47462 .62964 m .47364 .62777 L .44804 .62252 L p F P
0 0 0 r
s
.967 .289 .124 r
.5 .62969 m .47364 .62777 L .47462 .62964 L closepath p F P
0 0 0 r
s
.13 .166 .335 r
.48141 .36745 m .50265 .36364 L .50278 .37822 L p F P
0 0 0 r
s
.13 .166 .335 r
.50278 .37822 m .48046 .38217 L .48141 .36745 L p F P
0 0 0 r
s
.83 .24 .1 r
.29935 .28084 m
.31566 .31224 L
s
.31566 .31224 m
.29771 .3366 L
s
1 .324 .136 r
.5713 .60443 m .57365 .60998 L .55024 .61972 L p F P
0 0 0 r
s
1 .329 .137 r
.57365 .60998 m .5713 .60443 L .59211 .59019 L p F P
0 0 0 r
s
.24 .35 .67 r
.23846 .47138 m
.28136 .46406 L
s
.23846 .47138 m
.23932 .50287 L
s
.561 .145 .055 r
.33411 .52147 m .32705 .50963 L .31652 .48741 L p F P
0 0 0 r
s
.245 .071 .038 r
.32705 .50963 m .33411 .52147 L .34858 .54244 L p F P
0 0 0 r
s
.163 .218 .437 r
.39247 .39776 m .41427 .3939 L .41228 .41222 L p F P
0 0 0 r
s
.163 .218 .437 r
.41228 .41222 m .38999 .41611 L .39247 .39776 L p F P
0 0 0 r
s
.24 .35 .67 r
.19663 .50996 m
.23932 .50287 L
s
.19663 .50996 m
.20012 .54302 L
s
.365 .111 .056 r
.37245 .57147 m .36716 .56249 L .34858 .54244 L p F P
0 0 0 r
s
.83 .24 .1 r
.33645 .5216 m
.35053 .54257 L
s
.35053 .54257 m
.3538 .54808 L
s
.486 .155 .073 r
.36716 .56249 m .37245 .57147 L .39361 .58837 L p F P
0 0 0 r
s
1 .304 .13 r
.52545 .62636 m .52635 .62823 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .316 .133 r
.52635 .62823 m .52545 .62636 L .55024 .61972 L p F P
0 0 0 r
s
.65 .203 .092 r
.42082 .60861 m .41768 .60304 L .39361 .58837 L p F P
0 0 0 r
s
.24 .35 .67 r
.3977 .60854 m
.40751 .63159 L
s
.788 .241 .106 r
.41768 .60304 m .42082 .60861 L .446 .61879 L p F P
0 0 0 r
s
.83 .24 .1 r
.51832 .24133 m
.48857 .23754 L
s
.47619 .2044 m
.48857 .23754 L
s
1 .308 .123 r
.63315 .47762 m .63742 .49061 L .62955 .5126 L p F P
0 0 0 r
s
.83 .24 .1 r
.63039 .50289 m
.63063 .50213 L
s
.63582 .48576 m
.63737 .48087 L
s
.63039 .50289 m
.63051 .50326 L
s
.998 .282 .11 r
.63742 .49061 m .63315 .47762 L .63726 .45554 L p F P
0 0 0 r
s
.89 .268 .117 r
.47364 .62777 m .47266 .62589 L .446 .61879 L p F P
0 0 0 r
s
.967 .289 .124 r
.5 .62969 m .47266 .62589 L .47364 .62777 L closepath p F P
0 0 0 r
s
.187 .257 .511 r
.3239 .42766 m .3458 .42383 L .34634 .44462 L p F P
0 0 0 r
s
.187 .257 .511 r
.34634 .44462 m .32452 .44837 L .3239 .42766 L p F P
0 0 0 r
s
.287 .429 .842 r
.5 .62969 m .48629 .61576 L .48982 .61524 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.4925 .62865 m
.49817 .62783 L
s
.287 .429 .842 r
.5 .62969 m .48982 .61524 L .49336 .61473 L closepath p F P
0 0 0 r
s
.287 .429 .842 r
.5 .62969 m .49336 .61473 L .4969 .61421 L closepath p F P
0 0 0 r
s
.287 .429 .842 r
.5 .62969 m .4969 .61421 L .50044 .6137 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.50006 .62768 m
.501 .62956 L
s
.287 .429 .842 r
.5 .62969 m .50044 .6137 L .50399 .61318 L closepath p F P
0 0 0 r
s
.287 .429 .842 r
.5 .62969 m .50399 .61318 L .50754 .61267 L closepath p F P
0 0 0 r
s
.287 .429 .842 r
.5 .62969 m .50754 .61267 L .51109 .61215 L closepath p F P
0 0 0 r
s
.287 .429 .842 r
.5 .62969 m .51109 .61215 L .51464 .61163 L closepath p F P
0 0 0 r
s
.287 .429 .842 r
.5 .62969 m .51464 .61163 L .5182 .61112 L closepath p F P
0 0 0 r
s
.967 .289 .124 r
.5 .62969 m .46868 .61832 L .46968 .62022 L closepath p F P
0 0 0 r
s
.967 .289 .124 r
.5 .62969 m .46968 .62022 L .47068 .62212 L closepath p F P
0 0 0 r
s
.967 .289 .124 r
.5 .62969 m .47068 .62212 L .47167 .62401 L closepath p F P
0 0 0 r
s
.967 .289 .124 r
.5 .62969 m .47167 .62401 L .47266 .62589 L closepath p F P
0 0 0 r
s
1 .304 .13 r
.52456 .62448 m .52545 .62636 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .304 .13 r
.52366 .62259 m .52456 .62448 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .304 .13 r
.52276 .62069 m .52366 .62259 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .304 .13 r
.52185 .61879 m .52276 .62069 L .5 .62969 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.50242 .62723 m
.50597 .62672 L
s
1 .304 .13 r
.52095 .61688 m .52185 .61879 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .304 .13 r
.52004 .61497 m .52095 .61688 L .5 .62969 L closepath p F P
0 0 0 r
s
.287 .429 .842 r
.5 .62969 m .46868 .61832 L .4722 .61781 L closepath p F P
0 0 0 r
s
.287 .429 .842 r
.5 .62969 m .4722 .61781 L .47571 .61729 L closepath p F P
0 0 0 r
s
.287 .429 .842 r
.5 .62969 m .47571 .61729 L .47924 .61678 L closepath p F P
0 0 0 r
s
.287 .429 .842 r
.5 .62969 m .47924 .61678 L .48276 .61627 L closepath p F P
0 0 0 r
s
.287 .429 .842 r
.5 .62969 m .48276 .61627 L .48629 .61576 L closepath p F P
0 0 0 r
s
1 .304 .13 r
.51912 .61304 m .52004 .61497 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .304 .13 r
.5182 .61112 m .51912 .61304 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .316 .133 r
.54856 .61598 m .55024 .61972 L .52545 .62636 L p F P
0 0 0 r
s
1 .324 .136 r
.55024 .61972 m .54856 .61598 L .5713 .60443 L p F P
0 0 0 r
s
.83 .24 .1 r
.59631 .31454 m
.60388 .33846 L
s
.60599 .34513 m
.60603 .34526 L
s
.24 .35 .67 r
.20012 .54302 m
.20639 .57592 L
s
.20639 .57592 m
.24919 .56921 L
s
.24919 .56921 m
.25766 .60033 L
s
.25766 .60033 m
.30078 .59377 L
s
.13 .166 .335 r
.50265 .36364 m .524 .35982 L .52525 .37424 L p F P
0 0 0 r
s
.13 .166 .335 r
.52525 .37424 m .50278 .37822 L .50265 .36364 L p F P
0 0 0 r
s
1 .329 .137 r
.58918 .58285 m .59211 .59019 L .5713 .60443 L p F P
0 0 0 r
s
.83 .24 .1 r
.5913 .58817 m
.595 .58526 L
s
1 .332 .137 r
.59211 .59019 m .58918 .58285 L .60702 .56474 L p F P
0 0 0 r
s
1 .316 .133 r
.52545 .62636 m .52456 .62448 L .54856 .61598 L p F P
0 0 0 r
s
.788 .241 .106 r
.446 .61879 m .44395 .61504 L .41768 .60304 L p F P
0 0 0 r
s
.89 .268 .117 r
.44395 .61504 m .446 .61879 L .47266 .62589 L p F P
0 0 0 r
s
1 .33 .135 r
.61818 .53449 m .62195 .54505 L .60702 .56474 L p F P
0 0 0 r
s
1 .323 .13 r
.62195 .54505 m .61818 .53449 L .62955 .5126 L p F P
0 0 0 r
s
.163 .218 .437 r
.41427 .3939 m .4362 .39001 L .43472 .4083 L p F P
0 0 0 r
s
.163 .218 .437 r
.43472 .4083 m .41228 .41222 L .41427 .3939 L p F P
0 0 0 r
s
.24 .35 .67 r
.41322 .41316 m
.41333 .41204 L
s
.89 .268 .117 r
.47266 .62589 m .47167 .62401 L .44395 .61504 L p F P
0 0 0 r
s
.24 .35 .67 r
.40751 .63159 m
.4513 .62525 L
s
.4513 .62525 m
.46064 .64239 L
s
.20012 .54302 m
.24295 .5361 L
s
.72 .193 .072 r
.31652 .48741 m .30876 .47434 L .30283 .4521 L p F P
0 0 0 r
s
.561 .145 .055 r
.30876 .47434 m .31652 .48741 L .32705 .50963 L p F P
0 0 0 r
s
.24 .35 .67 r
.73266 .30613 m
.77872 .29779 L
s
.73266 .30613 m
.73277 .31616 L
s
.7306 .60397 m
.73481 .6155 L
s
.73481 .6155 m
.78089 .60902 L
s
.486 .155 .073 r
.39361 .58837 m .38935 .581 L .36716 .56249 L p F P
0 0 0 r
s
.65 .203 .092 r
.38935 .581 m .39361 .58837 L .41768 .60304 L p F P
0 0 0 r
s
.187 .257 .511 r
.3458 .42383 m .36783 .41999 L .36829 .44085 L p F P
0 0 0 r
s
.24 .35 .67 r
.34583 .42492 m
.34698 .42472 L
s
.36785 .42108 m
.36923 .42084 L
s
.187 .257 .511 r
.36829 .44085 m .34634 .44462 L .3458 .42383 L p F P
0 0 0 r
s
1 .316 .133 r
.52456 .62448 m .52366 .62259 L .54687 .61221 L p F P
0 0 0 r
s
1 .316 .133 r
.54687 .61221 m .54856 .61598 L .52456 .62448 L p F P
0 0 0 r
s
.83 .24 .1 r
.54801 .61475 m
.54804 .61474 L
s
.54804 .61474 m
.57447 .6006 L
s
.24 .35 .67 r
.54848 .62989 m
.59319 .62353 L
s
.83 .24 .1 r
.54804 .61474 m
.54859 .61596 L
s
.998 .282 .11 r
.63281 .44159 m .63726 .45554 L .63315 .47762 L p F P
0 0 0 r
s
.855 .238 .09 r
.63726 .45554 m .63281 .44159 L .63328 .42074 L p F P
0 0 0 r
s
.83 .24 .1 r
.63186 .42159 m
.63316 .42574 L
s
.24 .35 .67 r
.34443 .58713 m
.3539 .61503 L
s
.3539 .61503 m
.3977 .60854 L
s
.58589 .60576 m
.59319 .62353 L
s
.59319 .62353 m
.63844 .61709 L
s
1 .324 .136 r
.56892 .59883 m .5713 .60443 L .54856 .61598 L p F P
0 0 0 r
s
1 .329 .137 r
.5713 .60443 m .56892 .59883 L .58918 .58285 L p F P
0 0 0 r
s
.89 .268 .117 r
.44189 .61126 m .44395 .61504 L .47167 .62401 L p F P
0 0 0 r
s
.89 .268 .117 r
.47167 .62401 m .47068 .62212 L .44189 .61126 L p F P
0 0 0 r
s
.24 .35 .67 r
.4513 .62525 m
.46486 .62328 L
s
.46486 .62328 m
.46902 .62268 L
s
.245 .071 .038 r
.34858 .54244 m .34227 .53184 L .32705 .50963 L p F P
0 0 0 r
s
.365 .111 .056 r
.34227 .53184 m .34858 .54244 L .36716 .56249 L p F P
0 0 0 r
s
.24 .35 .67 r
.60584 .339 m
.64054 .33276 L
s
.13 .166 .335 r
.524 .35982 m .54548 .35597 L .54785 .37024 L p F P
0 0 0 r
s
.13 .166 .335 r
.54785 .37024 m .52525 .37424 L .524 .35982 L p F P
0 0 0 r
s
1 .324 .136 r
.54856 .61598 m .54687 .61221 L .56892 .59883 L p F P
0 0 0 r
s
.24 .35 .67 r
.28136 .46406 m
.28252 .49569 L
s
.163 .218 .437 r
.4362 .39001 m .45826 .38611 L .45729 .40436 L p F P
0 0 0 r
s
.163 .218 .437 r
.45729 .40436 m .43472 .4083 L .4362 .39001 L p F P
0 0 0 r
s
.65 .203 .092 r
.41768 .60304 m .41451 .59743 L .38935 .581 L p F P
0 0 0 r
s
.788 .241 .106 r
.41451 .59743 m .41768 .60304 L .44395 .61504 L p F P
0 0 0 r
s
.187 .054 .028 r
.62578 .38792 m .62118 .37317 L .61521 .35879 L p F P
0 0 0 r
s
.187 .054 .028 r
.61068 .34429 m .61521 .35879 L .62118 .37317 L p F P
0 0 0 r
s
1 .316 .133 r
.52366 .62259 m .52276 .62069 L .54516 .60841 L p F P
0 0 0 r
s
1 .316 .133 r
.54516 .60841 m .54687 .61221 L .52366 .62259 L p F P
0 0 0 r
s
.788 .241 .106 r
.44395 .61504 m .44189 .61126 L .41451 .59743 L p F P
0 0 0 r
s
.89 .268 .117 r
.43981 .60746 m .44189 .61126 L .47068 .62212 L p F P
0 0 0 r
s
.89 .268 .117 r
.47068 .62212 m .46968 .62022 L .43981 .60746 L p F P
0 0 0 r
s
.24 .35 .67 r
.23932 .50287 m
.28252 .49569 L
s
.23932 .50287 m
.24295 .5361 L
s
.66 .179 .065 r
.63328 .42074 m .62871 .40619 L .62578 .38792 L p F P
0 0 0 r
s
.855 .238 .09 r
.62871 .40619 m .63328 .42074 L .63281 .44159 L p F P
0 0 0 r
s
1 .332 .137 r
.60359 .55564 m .60702 .56474 L .58918 .58285 L p F P
0 0 0 r
s
1 .33 .135 r
.60702 .56474 m .60359 .55564 L .61818 .53449 L p F P
0 0 0 r
s
.206 .287 .569 r
.30283 .4521 m .32452 .44837 L .32981 .47079 L p F P
0 0 0 r
s
.24 .35 .67 r
.32499 .45036 m
.32507 .44828 L
s
.206 .287 .569 r
.32981 .47079 m .30876 .47434 L .30283 .4521 L p F P
0 0 0 r
s
.83 .24 .1 r
.30543 .45829 m
.30589 .45907 L
s
.29679 .44363 m
.30543 .45829 L
s
.24 .35 .67 r
.30395 .4602 m
.30495 .46003 L
s
.28136 .46406 m
.30395 .4602 L
s
1 .323 .13 r
.62545 .50058 m .62955 .5126 L .61818 .53449 L p F P
0 0 0 r
s
1 .308 .123 r
.62955 .5126 m .62545 .50058 L .63315 .47762 L p F P
0 0 0 r
s
.187 .257 .511 r
.36783 .41999 m .38999 .41611 L .39038 .43706 L p F P
0 0 0 r
s
.187 .257 .511 r
.39038 .43706 m .36829 .44085 L .36783 .41999 L p F P
0 0 0 r
s
.66 .179 .065 r
.62118 .37317 m .62578 .38792 L .62871 .40619 L p F P
0 0 0 r
s
.83 .24 .1 r
.61763 .3674 m
.62588 .39376 L
s
1 .316 .133 r
.52276 .62069 m .52185 .61879 L .54344 .60459 L p F P
0 0 0 r
s
1 .316 .133 r
.54344 .60459 m .54516 .60841 L .52276 .62069 L p F P
0 0 0 r
s
.24 .35 .67 r
.24295 .5361 m
.24919 .56921 L
s
.24919 .56921 m
.29251 .56242 L
s
.13 .166 .335 r
.54548 .35597 m .56709 .3521 L .57058 .36621 L p F P
0 0 0 r
s
.13 .166 .335 r
.57058 .36621 m .54785 .37024 L .54548 .35597 L p F P
0 0 0 r
s
.24 .35 .67 r
.29251 .56242 m
.30078 .59377 L
s
.30078 .59377 m
.34443 .58713 L
s
.89 .268 .117 r
.43772 .60363 m .43981 .60746 L .46968 .62022 L p F P
0 0 0 r
s
.89 .268 .117 r
.46968 .62022 m .46868 .61832 L .43772 .60363 L p F P
0 0 0 r
s
.24 .35 .67 r
.44644 .61306 m
.4513 .62525 L
s
.83 .24 .1 r
.28084 .30548 m
.29771 .3366 L
s
.29771 .3366 m
.28532 .36243 L
s
.365 .111 .056 r
.36716 .56249 m .36178 .55336 L .34227 .53184 L p F P
0 0 0 r
s
.486 .155 .073 r
.36178 .55336 m .36716 .56249 L .38935 .581 L p F P
0 0 0 r
s
1 .324 .136 r
.54687 .61221 m .54516 .60841 L .56652 .59317 L p F P
0 0 0 r
s
.83 .24 .1 r
.54689 .61218 m
.5469 .61219 L
s
1 .324 .136 r
.56652 .59317 m .56892 .59883 L .54687 .61221 L p F P
0 0 0 r
s
.83 .24 .1 r
.27914 .38877 m
.29606 .41804 L
s
.29606 .41804 m
.29679 .44363 L
s
.163 .218 .437 r
.45826 .38611 m .48046 .38217 L .48 .40039 L p F P
0 0 0 r
s
.163 .218 .437 r
.48 .40039 m .45729 .40436 L .45826 .38611 L p F P
0 0 0 r
s
.24 .35 .67 r
.45775 .40539 m
.45782 .40426 L
s
1 .329 .137 r
.5862 .5754 m .58918 .58285 L .56892 .59883 L p F P
0 0 0 r
s
1 .332 .137 r
.58918 .58285 m .5862 .5754 L .60359 .55564 L p F P
0 0 0 r
s
.24 .35 .67 r
.24295 .5361 m
.2863 .5291 L
s
1 .316 .133 r
.52185 .61879 m .52095 .61688 L .54171 .60073 L p F P
0 0 0 r
s
1 .316 .133 r
.54171 .60073 m .54344 .60459 L .52185 .61879 L p F P
0 0 0 r
s
.788 .241 .106 r
.4113 .59175 m .41451 .59743 L .44189 .61126 L p F P
0 0 0 r
s
.788 .241 .106 r
.44189 .61126 m .43981 .60746 L .4113 .59175 L p F P
0 0 0 r
s
.561 .145 .055 r
.32705 .50963 m .31984 .49755 L .30876 .47434 L p F P
0 0 0 r
s
.83 .24 .1 r
.31382 .47349 m
.32076 .49521 L
s
.245 .071 .038 r
.31984 .49755 m .32705 .50963 L .34227 .53184 L p F P
0 0 0 r
s
.83 .24 .1 r
.32076 .49521 m
.33645 .5216 L
s
1 .329 .137 r
.56892 .59883 m .56652 .59317 L .5862 .5754 L p F P
0 0 0 r
s
.24 .35 .67 r
.77974 .30771 m
.77872 .29779 L
s
.77753 .59729 m
.78089 .60902 L
s
.78089 .60902 m
.82752 .60246 L
s
.83 .24 .1 r
.54526 .25022 m
.51832 .24133 L
s
.5065 .20796 m
.51832 .24133 L
s
.281 .415 .817 r
.4722 .61781 m .46868 .61832 L .43772 .60363 L p F P
0 0 0 r
s
.206 .287 .569 r
.32452 .44837 m .34634 .44462 L .35098 .46722 L p F P
0 0 0 r
s
.206 .287 .569 r
.35098 .46722 m .32981 .47079 L .32452 .44837 L p F P
0 0 0 r
s
.83 .24 .1 r
.41169 .21254 m
.37986 .22379 L
s
.36485 .19001 m
.37986 .22379 L
s
.37986 .22379 m
.34983 .2393 L
s
.187 .257 .511 r
.38999 .41611 m .41228 .41222 L .4126 .43324 L p F P
0 0 0 r
s
.24 .35 .67 r
.39001 .41721 m
.39117 .41701 L
s
.4123 .41332 m
.41322 .41316 L
s
.187 .257 .511 r
.4126 .43324 m .39038 .43706 L .38999 .41611 L p F P
0 0 0 r
s
.281 .415 .817 r
.43772 .60363 m .44468 .6026 L .4722 .61781 L p F P
0 0 0 r
s
.24 .35 .67 r
.44203 .60198 m
.44241 .60294 L
s
.281 .415 .817 r
.47571 .61729 m .4722 .61781 L .44468 .6026 L p F P
0 0 0 r
s
.24 .35 .67 r
.63185 .5991 m
.63844 .61709 L
s
.63844 .61709 m
.68424 .61057 L
s
.486 .155 .073 r
.38935 .581 m .38502 .57353 L .36178 .55336 L p F P
0 0 0 r
s
.83 .24 .1 r
.37066 .55981 m
.37216 .56237 L
s
.65 .203 .092 r
.38502 .57353 m .38935 .581 L .41451 .59743 L p F P
0 0 0 r
s
.13 .166 .335 r
.56709 .3521 m .58882 .34821 L .59346 .36216 L p F P
0 0 0 r
s
.13 .166 .335 r
.59346 .36216 m .57058 .36621 L .56709 .3521 L p F P
0 0 0 r
s
.281 .415 .817 r
.44468 .6026 m .45166 .60157 L .47571 .61729 L p F P
0 0 0 r
s
.24 .35 .67 r
.44546 .61059 m
.44644 .61306 L
s
.281 .415 .817 r
.47924 .61678 m .47571 .61729 L .45166 .60157 L p F P
0 0 0 r
s
.83 .24 .1 r
.59631 .31454 m
.57868 .29617 L
s
.56823 .26403 m
.57868 .29617 L
s
.65 .203 .092 r
.41451 .59743 m .4113 .59175 L .38502 .57353 L p F P
0 0 0 r
s
.24 .35 .67 r
.64054 .33276 m
.68637 .32451 L
s
.64054 .33276 m
.64025 .34987 L
s
1 .316 .133 r
.52095 .61688 m .52004 .61497 L .53997 .59686 L p F P
0 0 0 r
s
1 .316 .133 r
.53997 .59686 m .54171 .60073 L .52095 .61688 L p F P
0 0 0 r
s
.24 .35 .67 r
.52243 .61495 m
.52665 .61434 L
s
.54049 .61233 m
.54848 .62989 L
s
.83 .24 .1 r
.33411 .20583 m
.34983 .2393 L
s
.34983 .2393 m
.32265 .25853 L
s
.281 .415 .817 r
.45166 .60157 m .45865 .60053 L .47924 .61678 L p F P
0 0 0 r
s
.281 .415 .817 r
.48276 .61627 m .47924 .61678 L .45865 .60053 L p F P
0 0 0 r
s
1 .308 .123 r
.62879 .46434 m .63315 .47762 L .62545 .50058 L p F P
0 0 0 r
s
.998 .282 .11 r
.63315 .47762 m .62879 .46434 L .63281 .44159 L p F P
0 0 0 r
s
.163 .218 .437 r
.48046 .38217 m .50278 .37822 L .50285 .3964 L p F P
0 0 0 r
s
.163 .218 .437 r
.50285 .3964 m .48 .40039 L .48046 .38217 L p F P
0 0 0 r
s
1 .33 .135 r
.61433 .52374 m .61818 .53449 L .60359 .55564 L p F P
0 0 0 r
s
1 .323 .13 r
.61818 .53449 m .61433 .52374 L .62545 .50058 L p F P
0 0 0 r
s
.83 .24 .1 r
.44418 .20598 m
.41169 .21254 L
s
.39739 .17845 m
.41169 .21254 L
s
.281 .415 .817 r
.45865 .60053 m .46566 .59949 L .48276 .61627 L p F P
0 0 0 r
s
.281 .415 .817 r
.48629 .61576 m .48276 .61627 L .46566 .59949 L p F P
0 0 0 r
s
1 .324 .136 r
.54516 .60841 m .54344 .60459 L .5641 .58745 L p F P
0 0 0 r
s
.83 .24 .1 r
.54518 .60838 m
.54519 .60839 L
s
1 .324 .136 r
.5641 .58745 m .56652 .59317 L .54516 .60841 L p F P
0 0 0 r
s
.281 .415 .817 r
.46566 .59949 m .47268 .59846 L .48629 .61576 L p F P
0 0 0 r
s
.281 .415 .817 r
.48982 .61524 m .48629 .61576 L .47268 .59846 L p F P
0 0 0 r
s
.24 .35 .67 r
.28252 .49569 m
.2863 .5291 L
s
.281 .415 .817 r
.47268 .59846 m .47971 .59741 L .48982 .61524 L p F P
0 0 0 r
s
.83 .24 .1 r
.47527 .61328 m
.47645 .61556 L
s
.47138 .60575 m
.47527 .61328 L
s
.281 .415 .817 r
.49336 .61473 m .48982 .61524 L .47971 .59741 L p F P
0 0 0 r
s
.206 .287 .569 r
.34634 .44462 m .36829 .44085 L .37228 .46363 L p F P
0 0 0 r
s
.24 .35 .67 r
.36881 .4438 m
.36886 .44075 L
s
.206 .287 .569 r
.37228 .46363 m .35098 .46722 L .34634 .44462 L p F P
0 0 0 r
s
.788 .241 .106 r
.40806 .58601 m .4113 .59175 L .43981 .60746 L p F P
0 0 0 r
s
.788 .241 .106 r
.43981 .60746 m .43772 .60363 L .40806 .58601 L p F P
0 0 0 r
s
.24 .35 .67 r
.3977 .60854 m
.42807 .60404 L
s
.42807 .60404 m
.43167 .60351 L
s
.43167 .60351 m
.43429 .60312 L
s
.43635 .60282 m
.44203 .60198 L
s
1 .316 .133 r
.52004 .61497 m .51912 .61304 L .53821 .59295 L p F P
0 0 0 r
s
1 .316 .133 r
.53821 .59295 m .53997 .59686 L .52004 .61497 L p F P
0 0 0 r
s
.281 .415 .817 r
.47971 .59741 m .48675 .59637 L .49336 .61473 L p F P
0 0 0 r
s
.281 .415 .817 r
.4969 .61421 m .49336 .61473 L .48675 .59637 L p F P
0 0 0 r
s
.187 .257 .511 r
.41228 .41222 m .43472 .4083 L .43495 .4294 L p F P
0 0 0 r
s
.24 .35 .67 r
.41322 .41316 m
.41347 .41312 L
s
.187 .257 .511 r
.43495 .4294 m .4126 .43324 L .41228 .41222 L p F P
0 0 0 r
s
.281 .415 .817 r
.48675 .59637 m .49381 .59533 L .4969 .61421 L p F P
0 0 0 r
s
.24 .35 .67 r
.48689 .59533 m
.48725 .5963 L
s
.281 .415 .817 r
.50044 .6137 m .4969 .61421 L .49381 .59533 L p F P
0 0 0 r
s
.187 .054 .028 r
.62118 .37317 m .61648 .35808 L .61068 .34429 L p F P
0 0 0 r
s
.13 .166 .335 r
.58882 .34821 m .61068 .34429 L .61648 .35808 L p F P
0 0 0 r
s
.13 .166 .335 r
.61648 .35808 m .59346 .36216 L .58882 .34821 L p F P
0 0 0 r
s
.83 .24 .1 r
.61306 .35868 m
.61763 .3674 L
s
.24 .35 .67 r
.2863 .5291 m
.29251 .56242 L
s
.29251 .56242 m
.33636 .55555 L
s
.83 .24 .1 r
.45114 .60497 m
.47138 .60575 L
s
.245 .071 .038 r
.34227 .53184 m .33584 .52104 L .31984 .49755 L p F P
0 0 0 r
s
.365 .111 .056 r
.33584 .52104 m .34227 .53184 L .36178 .55336 L p F P
0 0 0 r
s
.83 .24 .1 r
.3588 .54965 m
.37066 .55981 L
s
.24 .35 .67 r
.33636 .55555 m
.34443 .58713 L
s
.281 .415 .817 r
.49381 .59533 m .50088 .59428 L .50044 .6137 L p F P
0 0 0 r
s
.281 .415 .817 r
.50399 .61318 m .50044 .6137 L .50088 .59428 L p F P
0 0 0 r
s
.221 .311 .617 r
.30876 .47434 m .32981 .47079 L .3397 .49427 L p F P
0 0 0 r
s
.221 .311 .617 r
.3397 .49427 m .31984 .49755 L .30876 .47434 L p F P
0 0 0 r
s
.24 .35 .67 r
.28252 .49569 m
.31627 .49008 L
s
.83 .24 .1 r
.30434 .4676 m
.31619 .48753 L
s
.31619 .48753 m
.31712 .4891 L
s
1 .332 .137 r
.60011 .5464 m .60359 .55564 L .5862 .5754 L p F P
0 0 0 r
s
1 .33 .135 r
.60359 .55564 m .60011 .5464 L .61433 .52374 L p F P
0 0 0 r
s
.281 .415 .817 r
.50088 .59428 m .50797 .59323 L .50399 .61318 L p F P
0 0 0 r
s
.281 .415 .817 r
.50754 .61267 m .50399 .61318 L .50797 .59323 L p F P
0 0 0 r
s
.163 .218 .437 r
.50278 .37822 m .52525 .37424 L .52584 .39238 L p F P
0 0 0 r
s
.163 .218 .437 r
.52584 .39238 m .50285 .3964 L .50278 .37822 L p F P
0 0 0 r
s
1 .316 .133 r
.51912 .61304 m .5182 .61112 L .53644 .58902 L p F P
0 0 0 r
s
1 .316 .133 r
.53644 .58902 m .53821 .59295 L .51912 .61304 L p F P
0 0 0 r
s
.24 .35 .67 r
.52665 .61434 m
.54049 .61233 L
s
1 .329 .137 r
.56652 .59317 m .5641 .58745 L .58319 .56786 L p F P
0 0 0 r
s
1 .329 .137 r
.58319 .56786 m .5862 .5754 L .56652 .59317 L p F P
0 0 0 r
s
.24 .35 .67 r
.54049 .61233 m
.58589 .60576 L
s
.281 .415 .817 r
.50797 .59323 m .51506 .59218 L .50754 .61267 L p F P
0 0 0 r
s
.281 .415 .817 r
.51109 .61215 m .50754 .61267 L .51506 .59218 L p F P
0 0 0 r
s
.83 .24 .1 r
.50812 .60849 m
.50923 .61079 L
s
.50444 .60089 m
.50812 .60849 L
s
.60804 .33677 m
.61276 .35185 L
s
.61276 .35185 m
.61337 .35379 L
s
.30624 .22537 m
.32265 .25853 L
s
.32265 .25853 m
.29935 .28084 L
s
.24 .35 .67 r
.2863 .5291 m
.33018 .52201 L
s
.998 .282 .11 r
.62825 .42733 m .63281 .44159 L .62879 .46434 L p F P
0 0 0 r
s
.83 .24 .1 r
.6309 .43563 m
.63135 .42902 L
s
.855 .238 .09 r
.63281 .44159 m .62825 .42733 L .62871 .40619 L p F P
0 0 0 r
s
.281 .415 .817 r
.51506 .59218 m .52218 .59113 L .51109 .61215 L p F P
0 0 0 r
s
.281 .415 .817 r
.51464 .61163 m .51109 .61215 L .52218 .59113 L p F P
0 0 0 r
s
1 .332 .137 r
.5862 .5754 m .58319 .56786 L .60011 .5464 L p F P
0 0 0 r
s
.83 .24 .1 r
.59375 .55324 m
.59407 .55406 L
s
1 .324 .136 r
.54344 .60459 m .54171 .60073 L .56165 .58166 L p F P
0 0 0 r
s
.83 .24 .1 r
.54346 .60455 m
.54347 .60456 L
s
1 .324 .136 r
.56165 .58166 m .5641 .58745 L .54344 .60459 L p F P
0 0 0 r
s
.24 .35 .67 r
.82752 .60246 m
.82504 .59053 L
s
.206 .287 .569 r
.36829 .44085 m .39038 .43706 L .39371 .46002 L p F P
0 0 0 r
s
.206 .287 .569 r
.39371 .46002 m .37228 .46363 L .36829 .44085 L p F P
0 0 0 r
s
.281 .415 .817 r
.52218 .59113 m .5293 .59007 L .51464 .61163 L p F P
0 0 0 r
s
.281 .415 .817 r
.5182 .61112 m .51464 .61163 L .5293 .59007 L p F P
0 0 0 r
s
.65 .203 .092 r
.38064 .56596 m .38502 .57353 L .4113 .59175 L p F P
0 0 0 r
s
.65 .203 .092 r
.4113 .59175 m .40806 .58601 L .38064 .56596 L p F P
0 0 0 r
s
.24 .35 .67 r
.3886 .5804 m
.3977 .60854 L
s
.34443 .58713 m
.3886 .5804 L
s
.83 .24 .1 r
.47619 .2044 m
.44418 .20598 L
s
.43057 .17158 m
.44418 .20598 L
s
.187 .257 .511 r
.43472 .4083 m .45729 .40436 L .45744 .42554 L p F P
0 0 0 r
s
.24 .35 .67 r
.43473 .40941 m
.43591 .4092 L
s
.4573 .40547 m
.45775 .40539 L
s
.187 .257 .511 r
.45744 .42554 m .43495 .4294 L .43472 .4083 L p F P
0 0 0 r
s
.24 .35 .67 r
.67839 .59236 m
.68424 .61057 L
s
.68424 .61057 m
.7306 .60397 L
s
.273 .4 .789 r
.44468 .6026 m .43772 .60363 L .40806 .58601 L p F P
0 0 0 r
s
.281 .415 .817 r
.5293 .59007 m .53644 .58902 L .5182 .61112 L p F P
0 0 0 r
s
.365 .111 .056 r
.36178 .55336 m .35631 .54408 L .33584 .52104 L p F P
0 0 0 r
s
.486 .155 .073 r
.35631 .54408 m .36178 .55336 L .38502 .57353 L p F P
0 0 0 r
s
.24 .35 .67 r
.68637 .32451 m
.73277 .31616 L
s
.68637 .32451 m
.6869 .34158 L
s
.221 .311 .617 r
.32981 .47079 m .35098 .46722 L .35967 .49098 L p F P
0 0 0 r
s
.221 .311 .617 r
.35967 .49098 m .3397 .49427 L .32981 .47079 L p F P
0 0 0 r
s
1 .323 .13 r
.62126 .48831 m .62545 .50058 L .61433 .52374 L p F P
0 0 0 r
s
1 .308 .123 r
.62545 .50058 m .62126 .48831 L .62879 .46434 L p F P
0 0 0 r
s
.486 .155 .073 r
.38502 .57353 m .38064 .56596 L .35631 .54408 L p F P
0 0 0 r
s
.273 .4 .789 r
.40806 .58601 m .41831 .58447 L .44468 .6026 L p F P
0 0 0 r
s
.273 .4 .789 r
.45166 .60157 m .44468 .6026 L .41831 .58447 L p F P
0 0 0 r
s
.163 .218 .437 r
.52525 .37424 m .54785 .37024 L .54898 .38834 L p F P
0 0 0 r
s
.163 .218 .437 r
.54898 .38834 m .52584 .39238 L .52525 .37424 L p F P
0 0 0 r
s
.66 .179 .065 r
.62871 .40619 m .62404 .3913 L .62118 .37317 L p F P
0 0 0 r
s
.855 .238 .09 r
.62404 .3913 m .62871 .40619 L .62825 .42733 L p F P
0 0 0 r
s
.273 .4 .789 r
.41831 .58447 m .42858 .58291 L .45166 .60157 L p F P
0 0 0 r
s
.273 .4 .789 r
.45865 .60053 m .45166 .60157 L .42858 .58291 L p F P
0 0 0 r
s
.83 .24 .1 r
.43635 .59878 m
.43715 .60024 L
s
.66 .179 .065 r
.61648 .35808 m .62118 .37317 L .62404 .3913 L p F P
0 0 0 r
s
.83 .24 .1 r
.6148 .35838 m
.61763 .3674 L
s
.26797 .33157 m
.28532 .36243 L
s
.28532 .36243 m
.27914 .38877 L
s
.206 .287 .569 r
.39038 .43706 m .4126 .43324 L .41526 .45639 L p F P
0 0 0 r
s
.206 .287 .569 r
.41526 .45639 m .39371 .46002 L .39038 .43706 L p F P
0 0 0 r
s
1 .324 .136 r
.54171 .60073 m .53997 .59686 L .55917 .57582 L p F P
0 0 0 r
s
.24 .35 .67 r
.53621 .5999 m
.54049 .61233 L
s
.53534 .59738 m
.53621 .5999 L
s
.83 .24 .1 r
.54173 .6007 m
.54174 .60071 L
s
1 .324 .136 r
.55917 .57582 m .56165 .58166 L .54171 .60073 L p F P
0 0 0 r
s
.187 .257 .511 r
.45729 .40436 m .48 .40039 L .48007 .42165 L p F P
0 0 0 r
s
.24 .35 .67 r
.45775 .40539 m
.45848 .40526 L
s
.187 .257 .511 r
.48007 .42165 m .45744 .42554 L .45729 .40436 L p F P
0 0 0 r
s
.273 .4 .789 r
.42858 .58291 m .43888 .58136 L .45865 .60053 L p F P
0 0 0 r
s
.273 .4 .789 r
.46566 .59949 m .45865 .60053 L .43888 .58136 L p F P
0 0 0 r
s
.233 .332 .657 r
.31984 .49755 m .3397 .49427 L .35397 .51811 L p F P
0 0 0 r
s
.233 .332 .657 r
.35397 .51811 m .33584 .52104 L .31984 .49755 L p F P
0 0 0 r
s
.83 .24 .1 r
.33291 .51327 m
.33495 .5163 L
s
.33026 .50934 m
.33291 .51327 L
s
.33759 .52076 m
.34161 .52753 L
s
.24 .35 .67 r
.32889 .511 m
.32962 .51723 L
s
.32962 .51723 m
.33018 .52201 L
s
.33018 .52201 m
.33636 .55555 L
s
.33636 .55555 m
.36232 .55148 L
s
.36232 .55148 m
.36375 .55125 L
s
1 .329 .137 r
.5641 .58745 m .56165 .58166 L .58013 .56021 L p F P
0 0 0 r
s
1 .329 .137 r
.58013 .56021 m .58319 .56786 L .5641 .58745 L p F P
0 0 0 r
s
.221 .311 .617 r
.35098 .46722 m .37228 .46363 L .37975 .48766 L p F P
0 0 0 r
s
.221 .311 .617 r
.37975 .48766 m .35967 .49098 L .35098 .46722 L p F P
0 0 0 r
s
.273 .4 .789 r
.43888 .58136 m .44921 .5798 L .46566 .59949 L p F P
0 0 0 r
s
.273 .4 .789 r
.47268 .59846 m .46566 .59949 L .44921 .5798 L p F P
0 0 0 r
s
.163 .218 .437 r
.54785 .37024 m .57058 .36621 L .57226 .38427 L p F P
0 0 0 r
s
.163 .218 .437 r
.57226 .38427 m .54898 .38834 L .54785 .37024 L p F P
0 0 0 r
s
.24 .35 .67 r
.5783 .58179 m
.58589 .60576 L
s
.58589 .60576 m
.63185 .5991 L
s
.83 .24 .1 r
.47138 .60575 m
.50444 .60089 L
s
1 .33 .135 r
.61042 .51279 m .61433 .52374 L .60011 .5464 L p F P
0 0 0 r
s
.83 .24 .1 r
.59375 .55324 m
.60026 .54589 L
s
1 .323 .13 r
.61433 .52374 m .61042 .51279 L .62126 .48831 L p F P
0 0 0 r
s
.83 .24 .1 r
.56823 .26403 m
.54526 .25022 L
s
.53393 .21667 m
.54526 .25022 L
s
.273 .4 .789 r
.44921 .5798 m .45957 .57823 L .47268 .59846 L p F P
0 0 0 r
s
.273 .4 .789 r
.47971 .59741 m .47268 .59846 L .45957 .57823 L p F P
0 0 0 r
s
.264 .384 .758 r
.41831 .58447 m .40806 .58601 L .38064 .56596 L p F P
0 0 0 r
s
.24 .35 .67 r
.3886 .5804 m
.39754 .57904 L
s
.38636 .57134 m
.3886 .5804 L
s
.33018 .52201 m
.33579 .52111 L
s
.83 .24 .1 r
.28228 .24798 m
.29935 .28084 L
s
.29935 .28084 m
.28084 .30548 L
s
.27966 .41457 m
.29679 .44363 L
s
.29679 .44363 m
.30434 .4676 L
s
.206 .287 .569 r
.4126 .43324 m .43495 .4294 L .43694 .45273 L p F P
0 0 0 r
s
.206 .287 .569 r
.43694 .45273 m .41526 .45639 L .4126 .43324 L p F P
0 0 0 r
s
.273 .4 .789 r
.45957 .57823 m .46996 .57666 L .47971 .59741 L p F P
0 0 0 r
s
.273 .4 .789 r
.48675 .59637 m .47971 .59741 L .46996 .57666 L p F P
0 0 0 r
s
.24 .35 .67 r
.48598 .59546 m
.48689 .59533 L
s
.61492 .35437 m
.64025 .34987 L
s
1 .332 .137 r
.58319 .56786 m .58013 .56021 L .59656 .53701 L p F P
0 0 0 r
s
1 .332 .137 r
.59656 .53701 m .60011 .5464 L .58319 .56786 L p F P
0 0 0 r
s
1 .308 .123 r
.62432 .45076 m .62879 .46434 L .62126 .48831 L p F P
0 0 0 r
s
.83 .24 .1 r
.6268 .4583 m
.62862 .45271 L
s
.998 .282 .11 r
.62879 .46434 m .62432 .45076 L .62825 .42733 L p F P
0 0 0 r
s
.187 .257 .511 r
.48 .40039 m .50285 .3964 L .50284 .41774 L p F P
0 0 0 r
s
.24 .35 .67 r
.48 .40151 m
.48119 .4013 L
s
.50285 .3967 m
.50286 .3964 L
s
.187 .257 .511 r
.50284 .41774 m .48007 .42165 L .48 .40039 L p F P
0 0 0 r
s
.233 .332 .657 r
.3397 .49427 m .35967 .49098 L .3722 .51517 L p F P
0 0 0 r
s
.233 .332 .657 r
.3722 .51517 m .35397 .51811 L .3397 .49427 L p F P
0 0 0 r
s
.24 .35 .67 r
.72549 .58554 m
.7306 .60397 L
s
.7306 .60397 m
.77753 .59729 L
s
.264 .384 .758 r
.38064 .56596 m .39389 .56392 L .41831 .58447 L p F P
0 0 0 r
s
.83 .24 .1 r
.37759 .56322 m
.38256 .56567 L
s
.264 .384 .758 r
.42858 .58291 m .41831 .58447 L .39389 .56392 L p F P
0 0 0 r
s
.83 .24 .1 r
.43526 .59677 m
.43635 .59878 L
s
1 .33 .135 r
.60011 .5464 m .59656 .53701 L .61042 .51279 L p F P
0 0 0 r
s
1 .324 .136 r
.53997 .59686 m .53821 .59295 L .55667 .56992 L p F P
0 0 0 r
s
.83 .24 .1 r
.53999 .59682 m
.53999 .59683 L
s
1 .324 .136 r
.55667 .56992 m .55917 .57582 L .53997 .59686 L p F P
0 0 0 r
s
.221 .311 .617 r
.37228 .46363 m .39371 .46002 L .39994 .48433 L p F P
0 0 0 r
s
.221 .311 .617 r
.39994 .48433 m .37975 .48766 L .37228 .46363 L p F P
0 0 0 r
s
.24 .35 .67 r
.73277 .31616 m
.77974 .30771 L
s
.73277 .31616 m
.73412 .33319 L
s
.273 .4 .789 r
.46996 .57666 m .48038 .57509 L .48675 .59637 L p F P
0 0 0 r
s
.83 .24 .1 r
.45833 .58049 m
.47138 .60575 L
s
.273 .4 .789 r
.49381 .59533 m .48675 .59637 L .48038 .57509 L p F P
0 0 0 r
s
.83 .24 .1 r
.5065 .20796 m
.47619 .2044 L
s
.46322 .16971 m
.47619 .2044 L
s
.245 .351 .694 r
.33584 .52104 m .35397 .51811 L .37222 .54157 L p F P
0 0 0 r
s
.24 .35 .67 r
.33589 .52109 m
.33593 .52109 L
s
.83 .24 .1 r
.33495 .5163 m
.33689 .51957 L
s
.33689 .51957 m
.33697 .51971 L
s
.245 .351 .694 r
.37222 .54157 m .35631 .54408 L .33584 .52104 L p F P
0 0 0 r
s
.163 .218 .437 r
.57058 .36621 m .59346 .36216 L .59568 .38018 L p F P
0 0 0 r
s
.163 .218 .437 r
.59568 .38018 m .57226 .38427 L .57058 .36621 L p F P
0 0 0 r
s
.255 .368 .727 r
.39389 .56392 m .38064 .56596 L .35631 .54408 L p F P
0 0 0 r
s
.264 .384 .758 r
.39389 .56392 m .4072 .56186 L .42858 .58291 L p F P
0 0 0 r
s
.83 .24 .1 r
.39611 .57234 m
.39902 .57747 L
s
.38877 .56873 m
.39611 .57234 L
s
.264 .384 .758 r
.43888 .58136 m .42858 .58291 L .4072 .56186 L p F P
0 0 0 r
s
.273 .4 .789 r
.48038 .57509 m .49083 .57351 L .49381 .59533 L p F P
0 0 0 r
s
.273 .4 .789 r
.50088 .59428 m .49381 .59533 L .49083 .57351 L p F P
0 0 0 r
s
.83 .24 .1 r
.60804 .33677 m
.59631 .31454 L
s
.58614 .28238 m
.59631 .31454 L
s
.255 .368 .727 r
.35631 .54408 m .37222 .54157 L .39389 .56392 L p F P
0 0 0 r
s
.83 .24 .1 r
.36441 .54912 m
.3649 .54995 L
s
.273 .4 .789 r
.49083 .57351 m .5013 .57193 L .50088 .59428 L p F P
0 0 0 r
s
.273 .4 .789 r
.50797 .59323 m .50088 .59428 L .5013 .57193 L p F P
0 0 0 r
s
.206 .287 .569 r
.43495 .4294 m .45744 .42554 L .45875 .44905 L p F P
0 0 0 r
s
.206 .287 .569 r
.45875 .44905 m .43694 .45273 L .43495 .4294 L p F P
0 0 0 r
s
1 .329 .137 r
.56165 .58166 m .55917 .57582 L .57703 .55245 L p F P
0 0 0 r
s
1 .329 .137 r
.57703 .55245 m .58013 .56021 L .56165 .58166 L p F P
0 0 0 r
s
.233 .332 .657 r
.35967 .49098 m .37975 .48766 L .39051 .51221 L p F P
0 0 0 r
s
.233 .332 .657 r
.39051 .51221 m .3722 .51517 L .35967 .49098 L p F P
0 0 0 r
s
.24 .35 .67 r
.37459 .51478 m
.37459 .51484 L
s
.83 .24 .1 r
.50444 .60089 m
.52158 .59521 L
s
.52158 .59521 m
.52502 .59407 L
s
.264 .384 .758 r
.4072 .56186 m .42055 .5598 L .43888 .58136 L p F P
0 0 0 r
s
.264 .384 .758 r
.44921 .5798 m .43888 .58136 L .42055 .5598 L p F P
0 0 0 r
s
.187 .257 .511 r
.50285 .3964 m .52584 .39238 L .52575 .4138 L p F P
0 0 0 r
s
.24 .35 .67 r
.50285 .39752 m
.50405 .39731 L
s
.187 .257 .511 r
.52575 .4138 m .50284 .41774 L .50285 .3964 L p F P
0 0 0 r
s
.245 .351 .694 r
.35397 .51811 m .3722 .51517 L .3882 .53905 L p F P
0 0 0 r
s
.24 .35 .67 r
.35402 .51816 m
.35405 .51816 L
s
.37223 .51522 m
.37459 .51484 L
s
.245 .351 .694 r
.3882 .53905 m .37222 .54157 L .35397 .51811 L p F P
0 0 0 r
s
.83 .24 .1 r
.35535 .5336 m
.36441 .54912 L
s
.255 .368 .727 r
.4072 .56186 m .39389 .56392 L .37222 .54157 L p F P
0 0 0 r
s
.221 .311 .617 r
.39371 .46002 m .41526 .45639 L .42024 .48097 L p F P
0 0 0 r
s
.221 .311 .617 r
.42024 .48097 m .39994 .48433 L .39371 .46002 L p F P
0 0 0 r
s
.24 .35 .67 r
.37459 .51484 m
.37557 .5202 L
s
.37926 .54046 m
.38032 .54627 L
s
.273 .4 .789 r
.5013 .57193 m .51181 .57034 L .50797 .59323 L p F P
0 0 0 r
s
.83 .24 .1 r
.49211 .57539 m
.50444 .60089 L
s
.273 .4 .789 r
.51506 .59218 m .50797 .59323 L .51181 .57034 L p F P
0 0 0 r
s
.83 .24 .1 r
.31863 .48881 m
.33495 .5163 L
s
.33495 .5163 m
.35535 .5336 L
s
1 .324 .136 r
.53821 .59295 m .53644 .58902 L .55414 .56395 L p F P
0 0 0 r
s
.83 .24 .1 r
.53823 .59291 m
.53823 .59292 L
s
1 .324 .136 r
.55414 .56395 m .55667 .56992 L .53821 .59295 L p F P
0 0 0 r
s
.998 .282 .11 r
.62359 .41274 m .62825 .42733 L .62432 .45076 L p F P
0 0 0 r
s
.855 .238 .09 r
.62825 .42733 m .62359 .41274 L .62404 .3913 L p F P
0 0 0 r
s
.83 .24 .1 r
.62269 .39249 m
.62393 .39644 L
s
.163 .218 .437 r
.59346 .36216 m .61648 .35808 L .61926 .37606 L p F P
0 0 0 r
s
.163 .218 .437 r
.61926 .37606 m .59568 .38018 L .59346 .36216 L p F P
0 0 0 r
s
.83 .24 .1 r
.61887 .37358 m
.62269 .39249 L
s
.264 .384 .758 r
.42055 .5598 m .43395 .55773 L .44921 .5798 L p F P
0 0 0 r
s
.264 .384 .758 r
.45957 .57823 m .44921 .5798 L .43395 .55773 L p F P
0 0 0 r
s
.83 .24 .1 r
.42579 .57941 m
.43526 .59677 L
s
.255 .368 .727 r
.37222 .54157 m .3882 .53905 L .4072 .56186 L p F P
0 0 0 r
s
.273 .4 .789 r
.51181 .57034 m .52235 .56875 L .51506 .59218 L p F P
0 0 0 r
s
.273 .4 .789 r
.52218 .59113 m .51506 .59218 L .52235 .56875 L p F P
0 0 0 r
s
.24 .35 .67 r
.62485 .57489 m
.63185 .5991 L
s
.63185 .5991 m
.67839 .59236 L
s
.83 .24 .1 r
.39611 .57234 m
.42579 .57941 L
s
1 .323 .13 r
.61699 .47579 m .62126 .48831 L .61042 .51279 L p F P
0 0 0 r
s
1 .308 .123 r
.62126 .48831 m .61699 .47579 L .62432 .45076 L p F P
0 0 0 r
s
.255 .368 .727 r
.42055 .5598 m .4072 .56186 L .3882 .53905 L p F P
0 0 0 r
s
.273 .4 .789 r
.52235 .56875 m .53292 .56716 L .52218 .59113 L p F P
0 0 0 r
s
.273 .4 .789 r
.5293 .59007 m .52218 .59113 L .53292 .56716 L p F P
0 0 0 r
s
.24 .35 .67 r
.53231 .5886 m
.53265 .58958 L
s
.52947 .58902 m
.53231 .5886 L
s
.233 .332 .657 r
.37975 .48766 m .39994 .48433 L .40891 .50924 L p F P
0 0 0 r
s
.233 .332 .657 r
.40891 .50924 m .39051 .51221 L .37975 .48766 L p F P
0 0 0 r
s
.206 .287 .569 r
.45744 .42554 m .48007 .42165 L .48068 .44536 L p F P
0 0 0 r
s
.206 .287 .569 r
.48068 .44536 m .45875 .44905 L .45744 .42554 L p F P
0 0 0 r
s
.245 .351 .694 r
.3722 .51517 m .39051 .51221 L .40425 .53651 L p F P
0 0 0 r
s
.245 .351 .694 r
.40425 .53651 m .3882 .53905 L .3722 .51517 L p F P
0 0 0 r
s
.264 .384 .758 r
.43395 .55773 m .4474 .55566 L .45957 .57823 L p F P
0 0 0 r
s
.264 .384 .758 r
.46996 .57666 m .45957 .57823 L .4474 .55566 L p F P
0 0 0 r
s
.24 .35 .67 r
.64025 .34987 m
.6869 .34158 L
s
.64025 .34987 m
.6414 .37334 L
s
.187 .257 .511 r
.52584 .39238 m .54898 .38834 L .5488 .40984 L p F P
0 0 0 r
s
.24 .35 .67 r
.52584 .39351 m
.52704 .3933 L
s
.187 .257 .511 r
.5488 .40984 m .52575 .4138 L .52584 .39238 L p F P
0 0 0 r
s
.24 .35 .67 r
.77319 .57863 m
.77753 .59729 L
s
.77753 .59729 m
.82504 .59053 L
s
.221 .311 .617 r
.41526 .45639 m .43694 .45273 L .44066 .4776 L p F P
0 0 0 r
s
.221 .311 .617 r
.44066 .4776 m .42024 .48097 L .41526 .45639 L p F P
0 0 0 r
s
.273 .4 .789 r
.53292 .56716 m .54351 .56556 L .5293 .59007 L p F P
0 0 0 r
s
.273 .4 .789 r
.53644 .58902 m .5293 .59007 L .54351 .56556 L p F P
0 0 0 r
s
.83 .24 .1 r
.53646 .58896 m
.53646 .58898 L
s
.53432 .58421 m
.53499 .58571 L
s
.24 .35 .67 r
.53677 .58794 m
.53725 .58787 L
s
.255 .368 .727 r
.3882 .53905 m .40425 .53651 L .42055 .5598 L p F P
0 0 0 r
s
.83 .24 .1 r
.38121 .54613 m
.39611 .57234 L
s
1 .332 .137 r
.58013 .56021 m .57703 .55245 L .59296 .52746 L p F P
0 0 0 r
s
1 .332 .137 r
.59296 .52746 m .59656 .53701 L .58013 .56021 L p F P
0 0 0 r
s
.24 .35 .67 r
.78194 .32469 m
.77974 .30771 L
s
.66 .179 .065 r
.62404 .3913 m .61926 .37606 L .61648 .35808 L p F P
0 0 0 r
s
.83 .24 .1 r
.61309 .36202 m
.61674 .37362 L
s
.855 .238 .09 r
.61926 .37606 m .62404 .3913 L .62359 .41274 L p F P
0 0 0 r
s
.255 .368 .727 r
.43395 .55773 m .42055 .5598 L .40425 .53651 L p F P
0 0 0 r
s
.264 .384 .758 r
.4474 .55566 m .4609 .55357 L .46996 .57666 L p F P
0 0 0 r
s
.264 .384 .758 r
.48038 .57509 m .46996 .57666 L .4609 .55357 L p F P
0 0 0 r
s
.273 .4 .789 r
.54351 .56556 m .55414 .56395 L .53644 .58902 L p F P
0 0 0 r
s
.24 .35 .67 r
.54026 .58742 m
.5783 .58179 L
s
1 .33 .135 r
.60642 .50163 m .61042 .51279 L .59656 .53701 L p F P
0 0 0 r
s
1 .323 .13 r
.61042 .51279 m .60642 .50163 L .61699 .47579 L p F P
0 0 0 r
s
1 .329 .137 r
.55917 .57582 m .55667 .56992 L .57389 .54459 L p F P
0 0 0 r
s
1 .329 .137 r
.57389 .54459 m .57703 .55245 L .55917 .57582 L p F P
0 0 0 r
s
.233 .332 .657 r
.39994 .48433 m .42024 .48097 L .42741 .50625 L p F P
0 0 0 r
s
.233 .332 .657 r
.42741 .50625 m .40891 .50924 L .39994 .48433 L p F P
0 0 0 r
s
.245 .351 .694 r
.39051 .51221 m .40891 .50924 L .42037 .53397 L p F P
0 0 0 r
s
.24 .35 .67 r
.39054 .51226 m
.39058 .51226 L
s
.245 .351 .694 r
.42037 .53397 m .40425 .53651 L .39051 .51221 L p F P
0 0 0 r
s
.83 .24 .1 r
.26318 .27289 m
.28084 .30548 L
s
.28084 .30548 m
.26797 .33157 L
s
1 .33 .135 r
.59656 .53701 m .59296 .52746 L .60642 .50163 L p F P
0 0 0 r
s
.83 .24 .1 r
.60547 .50223 m
.60573 .50296 L
s
.264 .384 .758 r
.4609 .55357 m .47445 .55148 L .48038 .57509 L p F P
0 0 0 r
s
.264 .384 .758 r
.49083 .57351 m .48038 .57509 L .47445 .55148 L p F P
0 0 0 r
s
.206 .287 .569 r
.48007 .42165 m .50284 .41774 L .50275 .44164 L p F P
0 0 0 r
s
.206 .287 .569 r
.50275 .44164 m .48068 .44536 L .48007 .42165 L p F P
0 0 0 r
s
.255 .368 .727 r
.40425 .53651 m .42037 .53397 L .43395 .55773 L p F P
0 0 0 r
s
.255 .368 .727 r
.4474 .55566 m .43395 .55773 L .42037 .53397 L p F P
0 0 0 r
s
.83 .24 .1 r
.26143 .35813 m
.27914 .38877 L
s
.27914 .38877 m
.27966 .41457 L
s
.187 .257 .511 r
.54898 .38834 m .57226 .38427 L .572 .40585 L p F P
0 0 0 r
s
.24 .35 .67 r
.54897 .38947 m
.55018 .38926 L
s
.187 .257 .511 r
.572 .40585 m .5488 .40984 L .54898 .38834 L p F P
0 0 0 r
s
.221 .311 .617 r
.43694 .45273 m .45875 .44905 L .46118 .47421 L p F P
0 0 0 r
s
.221 .311 .617 r
.46118 .47421 m .44066 .4776 L .43694 .45273 L p F P
0 0 0 r
s
.264 .384 .758 r
.47445 .55148 m .48805 .54938 L .49083 .57351 L p F P
0 0 0 r
s
.264 .384 .758 r
.5013 .57193 m .49083 .57351 L .48805 .54938 L p F P
0 0 0 r
s
.83 .24 .1 r
.53393 .21667 m
.5065 .20796 L
s
.49412 .17302 m
.5065 .20796 L
s
.39739 .17845 m
.36485 .19001 L
s
.36485 .19001 m
.33411 .20583 L
s
.255 .368 .727 r
.42037 .53397 m .43656 .53141 L .4474 .55566 L p F P
0 0 0 r
s
.255 .368 .727 r
.4609 .55357 m .4474 .55566 L .43656 .53141 L p F P
0 0 0 r
s
.24 .35 .67 r
.67199 .5679 m
.67839 .59236 L
s
.67839 .59236 m
.72549 .58554 L
s
.245 .351 .694 r
.40891 .50924 m .42741 .50625 L .43656 .53141 L p F P
0 0 0 r
s
.24 .35 .67 r
.4217 .51949 m
.4242 .53336 L
s
.40894 .50929 m
.40898 .50929 L
s
.245 .351 .694 r
.43656 .53141 m .42037 .53397 L .40891 .50924 L p F P
0 0 0 r
s
1 .308 .123 r
.61976 .43689 m .62432 .45076 L .61699 .47579 L p F P
0 0 0 r
s
.998 .282 .11 r
.62432 .45076 m .61976 .43689 L .62359 .41274 L p F P
0 0 0 r
s
.233 .332 .657 r
.42024 .48097 m .44066 .4776 L .44601 .50325 L p F P
0 0 0 r
s
.233 .332 .657 r
.44601 .50325 m .42741 .50625 L .42024 .48097 L p F P
0 0 0 r
s
.83 .24 .1 r
.58614 .28238 m
.56823 .26403 L
s
.5573 .23037 m
.56823 .26403 L
s
.264 .384 .758 r
.48805 .54938 m .5017 .54728 L .5013 .57193 L p F P
0 0 0 r
s
.264 .384 .758 r
.51181 .57034 m .5013 .57193 L .5017 .54728 L p F P
0 0 0 r
s
.83 .24 .1 r
.33411 .20583 m
.30624 .22537 L
s
.206 .287 .569 r
.50284 .41774 m .52575 .4138 L .52495 .43789 L p F P
0 0 0 r
s
.206 .287 .569 r
.52495 .43789 m .50275 .44164 L .50284 .41774 L p F P
0 0 0 r
s
.24 .35 .67 r
.6869 .34158 m
.73412 .33319 L
s
.6869 .34158 m
.68875 .36507 L
s
.83 .24 .1 r
.43057 .17158 m
.39739 .17845 L
s
.24 .35 .67 r
.5783 .58179 m
.62485 .57489 L
s
.221 .311 .617 r
.45875 .44905 m .48068 .44536 L .48183 .47081 L p F P
0 0 0 r
s
.221 .311 .617 r
.48183 .47081 m .46118 .47421 L .45875 .44905 L p F P
0 0 0 r
s
.187 .257 .511 r
.57226 .38427 m .59568 .38018 L .59534 .40184 L p F P
0 0 0 r
s
.24 .35 .67 r
.57224 .38541 m
.57347 .38519 L
s
.187 .257 .511 r
.59534 .40184 m .572 .40585 L .57226 .38427 L p F P
0 0 0 r
s
.24 .35 .67 r
.82504 .59053 m
.82149 .57164 L
s
.255 .368 .727 r
.43656 .53141 m .45283 .52884 L .4609 .55357 L p F P
0 0 0 r
s
.255 .368 .727 r
.47445 .55148 m .4609 .55357 L .45283 .52884 L p F P
0 0 0 r
s
.264 .384 .758 r
.5017 .54728 m .5154 .54516 L .51181 .57034 L p F P
0 0 0 r
s
.264 .384 .758 r
.52235 .56875 m .51181 .57034 L .5154 .54516 L p F P
0 0 0 r
s
.83 .24 .1 r
.28714 .43869 m
.30434 .4676 L
s
.30434 .4676 m
.31863 .48881 L
s
.245 .351 .694 r
.45283 .52884 m .43656 .53141 L .42741 .50625 L p F P
0 0 0 r
s
1 .329 .137 r
.55667 .56992 m .55414 .56395 L .57071 .53663 L p F P
0 0 0 r
s
1 .329 .137 r
.57071 .53663 m .57389 .54459 L .55667 .56992 L p F P
0 0 0 r
s
.24 .35 .67 r
.57081 .55267 m
.5783 .58179 L
s
.245 .351 .694 r
.42741 .50625 m .44601 .50325 L .45283 .52884 L p F P
0 0 0 r
s
1 .332 .137 r
.57703 .55245 m .57389 .54459 L .5893 .51776 L p F P
0 0 0 r
s
1 .332 .137 r
.5893 .51776 m .59296 .52746 L .57703 .55245 L p F P
0 0 0 r
s
.233 .332 .657 r
.44066 .4776 m .46118 .47421 L .46469 .50023 L p F P
0 0 0 r
s
.233 .332 .657 r
.46469 .50023 m .44601 .50325 L .44066 .4776 L p F P
0 0 0 r
s
.83 .24 .1 r
.41145 .55311 m
.42579 .57941 L
s
.42579 .57941 m
.45833 .58049 L
s
.264 .384 .758 r
.5154 .54516 m .52915 .54304 L .52235 .56875 L p F P
0 0 0 r
s
.83 .24 .1 r
.53339 .58215 m
.53432 .58421 L
s
.264 .384 .758 r
.53292 .56716 m .52235 .56875 L .52915 .54304 L p F P
0 0 0 r
s
.255 .368 .727 r
.45283 .52884 m .46916 .52626 L .47445 .55148 L p F P
0 0 0 r
s
.255 .368 .727 r
.48805 .54938 m .47445 .55148 L .46916 .52626 L p F P
0 0 0 r
s
.206 .287 .569 r
.52575 .4138 m .5488 .40984 L .54729 .43413 L p F P
0 0 0 r
s
.206 .287 .569 r
.54729 .43413 m .52495 .43789 L .52575 .4138 L p F P
0 0 0 r
s
.221 .311 .617 r
.48068 .44536 m .50275 .44164 L .50259 .46738 L p F P
0 0 0 r
s
.221 .311 .617 r
.50259 .46738 m .48183 .47081 L .48068 .44536 L p F P
0 0 0 r
s
1 .323 .13 r
.61262 .463 m .61699 .47579 L .60642 .50163 L p F P
0 0 0 r
s
.83 .24 .1 r
.60547 .50223 m
.60665 .50025 L
s
1 .308 .123 r
.61699 .47579 m .61262 .463 L .61976 .43689 L p F P
0 0 0 r
s
.245 .351 .694 r
.46916 .52626 m .45283 .52884 L .44601 .50325 L p F P
0 0 0 r
s
.187 .257 .511 r
.59568 .38018 m .61926 .37606 L .61882 .39781 L p F P
0 0 0 r
s
.24 .35 .67 r
.59567 .38132 m
.5969 .3811 L
s
.83 .24 .1 r
.61915 .38127 m
.62031 .38493 L
s
.61674 .37362 m
.6176 .37635 L
s
.187 .257 .511 r
.61882 .39781 m .59534 .40184 L .59568 .38018 L p F P
0 0 0 r
s
.83 .24 .1 r
.60804 .33677 m
.61309 .36202 L
s
.598 .30468 m
.60804 .33677 L
s
.30624 .22537 m
.28228 .24798 L
s
.998 .282 .11 r
.61882 .39781 m .62359 .41274 L .61976 .43689 L p F P
0 0 0 r
s
.83 .24 .1 r
.62165 .40666 m
.62212 .40027 L
s
.855 .238 .09 r
.62359 .41274 m .61882 .39781 L .61926 .37606 L p F P
0 0 0 r
s
.24 .35 .67 r
.6196 .37714 m
.6414 .37334 L
s
.264 .384 .758 r
.52915 .54304 m .54295 .54091 L .53292 .56716 L p F P
0 0 0 r
s
.264 .384 .758 r
.54351 .56556 m .53292 .56716 L .54295 .54091 L p F P
0 0 0 r
s
.83 .24 .1 r
.52537 .56431 m
.53339 .58215 L
s
.245 .351 .694 r
.44601 .50325 m .46469 .50023 L .46916 .52626 L p F P
0 0 0 r
s
.255 .368 .727 r
.46916 .52626 m .48557 .52367 L .48805 .54938 L p F P
0 0 0 r
s
.255 .368 .727 r
.5017 .54728 m .48805 .54938 L .48557 .52367 L p F P
0 0 0 r
s
.83 .24 .1 r
.3393 .50615 m
.35535 .5336 L
s
.35535 .5336 m
.38121 .54613 L
s
.46322 .16971 m
.43057 .17158 L
s
.233 .332 .657 r
.46118 .47421 m .48183 .47081 L .48347 .4972 L p F P
0 0 0 r
s
.233 .332 .657 r
.48347 .4972 m .46469 .50023 L .46118 .47421 L p F P
0 0 0 r
s
.24 .35 .67 r
.46507 .50017 m
.46508 .50023 L
s
.46508 .50023 m
.4697 .52618 L
s
.4647 .50029 m
.46508 .50023 L
s
1 .33 .135 r
.59296 .52746 m .5893 .51776 L .60236 .49026 L p F P
0 0 0 r
s
1 .33 .135 r
.60236 .49026 m .60642 .50163 L .59296 .52746 L p F P
0 0 0 r
s
.24 .35 .67 r
.71972 .56083 m
.72549 .58554 L
s
.72549 .58554 m
.77319 .57863 L
s
.264 .384 .758 r
.54295 .54091 m .55681 .53877 L .54351 .56556 L p F P
0 0 0 r
s
.264 .384 .758 r
.55414 .56395 m .54351 .56556 L .55681 .53877 L p F P
0 0 0 r
s
1 .323 .13 r
.60642 .50163 m .60236 .49026 L .61262 .463 L p F P
0 0 0 r
s
.245 .351 .694 r
.48557 .52367 m .46916 .52626 L .46469 .50023 L p F P
0 0 0 r
s
.206 .287 .569 r
.5488 .40984 m .572 .40585 L .56976 .43034 L p F P
0 0 0 r
s
.206 .287 .569 r
.56976 .43034 m .54729 .43413 L .5488 .40984 L p F P
0 0 0 r
s
.255 .368 .727 r
.48557 .52367 m .50205 .52107 L .5017 .54728 L p F P
0 0 0 r
s
.255 .368 .727 r
.5154 .54516 m .5017 .54728 L .50205 .52107 L p F P
0 0 0 r
s
.24 .35 .67 r
.73412 .33319 m
.78194 .32469 L
s
.73412 .33319 m
.7367 .3567 L
s
.221 .311 .617 r
.50275 .44164 m .52495 .43789 L .52346 .46393 L p F P
0 0 0 r
s
.221 .311 .617 r
.52346 .46393 m .50259 .46738 L .50275 .44164 L p F P
0 0 0 r
s
.24 .35 .67 r
.61779 .54552 m
.62485 .57489 L
s
.62485 .57489 m
.67199 .5679 L
s
.245 .351 .694 r
.46469 .50023 m .48347 .4972 L .48557 .52367 L p F P
0 0 0 r
s
.264 .384 .758 r
.55681 .53877 m .57071 .53663 L .55414 .56395 L p F P
0 0 0 r
s
.83 .24 .1 r
.55639 .5478 m
.55862 .55315 L
s
.24 .35 .67 r
.56144 .5541 m
.57081 .55267 L
s
.233 .332 .657 r
.48183 .47081 m .50259 .46738 L .50235 .49415 L p F P
0 0 0 r
s
.233 .332 .657 r
.50235 .49415 m .48347 .4972 L .48183 .47081 L p F P
0 0 0 r
s
.83 .24 .1 r
.2498 .29923 m
.26797 .33157 L
s
.26797 .33157 m
.26143 .35813 L
s
.245 .351 .694 r
.50205 .52107 m .48557 .52367 L .48347 .4972 L p F P
0 0 0 r
s
.255 .368 .727 r
.50205 .52107 m .51861 .51846 L .5154 .54516 L p F P
0 0 0 r
s
.255 .368 .727 r
.52915 .54304 m .5154 .54516 L .51861 .51846 L p F P
0 0 0 r
s
1 .332 .137 r
.57389 .54459 m .57071 .53663 L .58558 .50788 L p F P
0 0 0 r
s
1 .332 .137 r
.58558 .50788 m .5893 .51776 L .57389 .54459 L p F P
0 0 0 r
s
.24 .35 .67 r
.6414 .37334 m
.68875 .36507 L
s
.6414 .37334 m
.64398 .40217 L
s
.245 .351 .694 r
.48347 .4972 m .50235 .49415 L .50205 .52107 L p F P
0 0 0 r
s
.206 .287 .569 r
.572 .40585 m .59534 .40184 L .59236 .42653 L p F P
0 0 0 r
s
.206 .287 .569 r
.59236 .42653 m .56976 .43034 L .572 .40585 L p F P
0 0 0 r
s
.221 .311 .617 r
.52495 .43789 m .54729 .43413 L .54446 .46046 L p F P
0 0 0 r
s
.221 .311 .617 r
.54446 .46046 m .52346 .46393 L .52495 .43789 L p F P
0 0 0 r
s
.83 .24 .1 r
.44466 .55402 m
.45833 .58049 L
s
.45833 .58049 m
.49211 .57539 L
s
.5573 .23037 m
.53393 .21667 L
s
.52206 .18153 m
.53393 .21667 L
s
.255 .368 .727 r
.51861 .51846 m .53524 .51583 L .52915 .54304 L p F P
0 0 0 r
s
.255 .368 .727 r
.54295 .54091 m .52915 .54304 L .53524 .51583 L p F P
0 0 0 r
s
1 .308 .123 r
.6151 .42269 m .61976 .43689 L .61262 .463 L p F P
0 0 0 r
s
.998 .282 .11 r
.61976 .43689 m .6151 .42269 L .61882 .39781 L p F P
0 0 0 r
s
.245 .351 .694 r
.51861 .51846 m .50205 .52107 L .50235 .49415 L p F P
0 0 0 r
s
.233 .332 .657 r
.50259 .46738 m .52346 .46393 L .52133 .49108 L p F P
0 0 0 r
s
.233 .332 .657 r
.52133 .49108 m .50235 .49415 L .50259 .46738 L p F P
0 0 0 r
s
.24 .35 .67 r
.56913 .54476 m
.57081 .55267 L
s
.56883 .54333 m
.56913 .54476 L
s
.57081 .55267 m
.61779 .54552 L
s
.83 .24 .1 r
.28228 .24798 m
.26318 .27289 L
s
.55639 .5478 m
.56419 .54175 L
s
.26172 .38411 m
.27966 .41457 L
s
.27966 .41457 m
.28714 .43869 L
s
.24 .35 .67 r
.76805 .55367 m
.77319 .57863 L
s
.77319 .57863 m
.82149 .57164 L
s
.245 .351 .694 r
.50235 .49415 m .52133 .49108 L .51861 .51846 L p F P
0 0 0 r
s
.255 .368 .727 r
.53524 .51583 m .55194 .5132 L .54295 .54091 L p F P
0 0 0 r
s
.255 .368 .727 r
.55681 .53877 m .54295 .54091 L .55194 .5132 L p F P
0 0 0 r
s
.83 .24 .1 r
.49412 .17302 m
.46322 .16971 L
s
.206 .287 .569 r
.59534 .40184 m .61882 .39781 L .6151 .42269 L p F P
0 0 0 r
s
.83 .24 .1 r
.6161 .4052 m
.61637 .40605 L
s
.206 .287 .569 r
.6151 .42269 m .59236 .42653 L .59534 .40184 L p F P
0 0 0 r
s
.83 .24 .1 r
.61094 .38925 m
.6161 .4052 L
s
.221 .311 .617 r
.54729 .43413 m .56976 .43034 L .56557 .45698 L p F P
0 0 0 r
s
.221 .311 .617 r
.56557 .45698 m .54446 .46046 L .54729 .43413 L p F P
0 0 0 r
s
.245 .351 .694 r
.53524 .51583 m .51861 .51846 L .52133 .49108 L p F P
0 0 0 r
s
.24 .35 .67 r
.78526 .34823 m
.78194 .32469 L
s
.66537 .53828 m
.67199 .5679 L
s
.67199 .5679 m
.71972 .56083 L
s
.83 .24 .1 r
.598 .30468 m
.58614 .28238 L
s
.57548 .24869 m
.58614 .28238 L
s
1 .33 .135 r
.5893 .51776 m .58558 .50788 L .59821 .47867 L p F P
0 0 0 r
s
1 .33 .135 r
.59821 .47867 m .60236 .49026 L .5893 .51776 L p F P
0 0 0 r
s
.233 .332 .657 r
.52346 .46393 m .54446 .46046 L .5404 .488 L p F P
0 0 0 r
s
.233 .332 .657 r
.5404 .488 m .52133 .49108 L .52346 .46393 L p F P
0 0 0 r
s
.255 .368 .727 r
.55194 .5132 m .56872 .51055 L .55681 .53877 L p F P
0 0 0 r
s
.255 .368 .727 r
.57071 .53663 m .55681 .53877 L .56872 .51055 L p F P
0 0 0 r
s
1 .323 .13 r
.60816 .44995 m .61262 .463 L .60236 .49026 L p F P
0 0 0 r
s
1 .308 .123 r
.61262 .463 m .60816 .44995 L .6151 .42269 L p F P
0 0 0 r
s
.24 .35 .67 r
.61788 .40663 m
.64398 .40217 L
s
.83 .24 .1 r
.47918 .54868 m
.49211 .57539 L
s
.49211 .57539 m
.52537 .56431 L
s
.245 .351 .694 r
.52133 .49108 m .5404 .488 L .53524 .51583 L p F P
0 0 0 r
s
.83 .24 .1 r
.52537 .56431 m
.55639 .5478 L
s
.545 .52041 m
.55639 .5478 L
s
.245 .351 .694 r
.55194 .5132 m .53524 .51583 L .5404 .488 L p F P
0 0 0 r
s
1 .323 .13 r
.60236 .49026 m .59821 .47867 L .60816 .44995 L p F P
0 0 0 r
s
.83 .24 .1 r
.30154 .45999 m
.31863 .48881 L
s
.31863 .48881 m
.3393 .50615 L
s
.24 .35 .67 r
.68875 .36507 m
.7367 .3567 L
s
.68875 .36507 m
.6919 .394 L
s
.221 .311 .617 r
.56976 .43034 m .59236 .42653 L .58681 .45347 L p F P
0 0 0 r
s
.221 .311 .617 r
.58681 .45347 m .56557 .45698 L .56976 .43034 L p F P
0 0 0 r
s
.255 .368 .727 r
.56872 .51055 m .58558 .50788 L .57071 .53663 L p F P
0 0 0 r
s
.83 .24 .1 r
.51322 .53729 m
.52537 .56431 L
s
.233 .332 .657 r
.54446 .46046 m .56557 .45698 L .55957 .48491 L p F P
0 0 0 r
s
.233 .332 .657 r
.55957 .48491 m .5404 .488 L .54446 .46046 L p F P
0 0 0 r
s
.83 .24 .1 r
.3656 .51866 m
.38121 .54613 L
s
.38121 .54613 m
.41145 .55311 L
s
.24 .35 .67 r
.58331 .51684 m
.61108 .51249 L
s
.5818 .51708 m
.58331 .51684 L
s
.61108 .51249 m
.61779 .54552 L
s
.61779 .54552 m
.66537 .53828 L
s
.245 .351 .694 r
.5404 .488 m .55957 .48491 L .55194 .5132 L p F P
0 0 0 r
s
.245 .351 .694 r
.56872 .51055 m .55194 .5132 L .55957 .48491 L p F P
0 0 0 r
s
.83 .24 .1 r
.61309 .36202 m
.60302 .33009 L
s
.61094 .38925 m
.61309 .36202 L
s
.24 .35 .67 r
.82149 .57164 m
.817 .54642 L
s
.221 .311 .617 r
.59236 .42653 m .6151 .42269 L .60816 .44995 L p F P
0 0 0 r
s
.83 .24 .1 r
.60873 .4388 m
.6093 .4405 L
s
.221 .311 .617 r
.60816 .44995 m .58681 .45347 L .59236 .42653 L p F P
0 0 0 r
s
.83 .24 .1 r
.60143 .41721 m
.60873 .4388 L
s
.233 .332 .657 r
.56557 .45698 m .58681 .45347 L .57884 .48179 L p F P
0 0 0 r
s
.233 .332 .657 r
.57884 .48179 m .55957 .48491 L .56557 .45698 L p F P
0 0 0 r
s
.24 .35 .67 r
.71356 .53094 m
.71972 .56083 L
s
.71972 .56083 m
.76805 .55367 L
s
.245 .351 .694 r
.55957 .48491 m .57884 .48179 L .56872 .51055 L p F P
0 0 0 r
s
.83 .24 .1 r
.57918 .51539 m
.57952 .51628 L
s
.245 .351 .694 r
.58558 .50788 m .56872 .51055 L .57884 .48179 L p F P
0 0 0 r
s
.83 .24 .1 r
.26318 .27289 m
.2498 .29923 L
s
.24 .35 .67 r
.64398 .40217 m
.6919 .394 L
s
.64398 .40217 m
.6479 .43495 L
s
.83 .24 .1 r
.24286 .32601 m
.26143 .35813 L
s
.26143 .35813 m
.26172 .38411 L
s
.24 .35 .67 r
.6109 .4411 m
.6479 .43495 L
s
.7367 .3567 m
.78526 .34823 L
s
.7367 .3567 m
.74043 .38571 L
s
.245 .351 .694 r
.57884 .48179 m .59821 .47867 L .58558 .50788 L p F P
0 0 0 r
s
.83 .24 .1 r
.57285 .49894 m
.57918 .51539 L
s
.52206 .18153 m
.49412 .17302 L
s
.233 .332 .657 r
.58681 .45347 m .60816 .44995 L .59821 .47867 L p F P
0 0 0 r
s
.24 .35 .67 r
.6035 .46622 m
.60511 .47761 L
s
.59907 .47859 m
.59931 .47855 L
s
.59931 .47855 m
.60511 .47761 L
s
.233 .332 .657 r
.59821 .47867 m .57884 .48179 L .58681 .45347 L p F P
0 0 0 r
s
.83 .24 .1 r
.59537 .47407 m
.6007 .46519 L
s
.59537 .47407 m
.59663 .47758 L
s
.59663 .47758 m
.59668 .47772 L
s
.57548 .24869 m
.5573 .23037 L
s
.54583 .19509 m
.5573 .23037 L
s
.24 .35 .67 r
.60511 .47761 m
.61108 .51249 L
s
.61108 .51249 m
.65891 .50499 L
s
.65891 .50499 m
.66537 .53828 L
s
.66537 .53828 m
.71356 .53094 L
s
.60511 .47761 m
.65297 .46988 L
s
.83 .24 .1 r
.26912 .40837 m
.28714 .43869 L
s
.28714 .43869 m
.30154 .45999 L
s
.24 .35 .67 r
.76236 .52352 m
.76805 .55367 L
s
.76805 .55367 m
.817 .54642 L
s
.83 .24 .1 r
.39642 .52553 m
.41145 .55311 L
s
.41145 .55311 m
.44466 .55402 L
s
.24 .35 .67 r
.6919 .394 m
.74043 .38571 L
s
.6919 .394 m
.6962 .42692 L
s
.83 .24 .1 r
.60302 .33009 m
.598 .30468 L
s
.58747 .27104 m
.598 .30468 L
s
.57285 .49894 m
.59537 .47407 L
s
.58478 .44453 m
.59537 .47407 L
s
.24 .35 .67 r
.6479 .43495 m
.6962 .42692 L
s
.6479 .43495 m
.65297 .46988 L
s
.78958 .37733 m
.78526 .34823 L
s
.83 .24 .1 r
.32248 .47737 m
.3393 .50615 L
s
.3393 .50615 m
.3656 .51866 L
s
.24 .35 .67 r
.65297 .46988 m
.65891 .50499 L
s
.65891 .50499 m
.70735 .4974 L
s
.70735 .4974 m
.71356 .53094 L
s
.71356 .53094 m
.76236 .52352 L
s
.83 .24 .1 r
.60143 .41721 m
.61094 .38925 L
s
.60069 .35756 m
.61094 .38925 L
s
.24 .35 .67 r
.65297 .46988 m
.70145 .46205 L
s
.83 .24 .1 r
.2498 .29923 m
.24286 .32601 L
s
.24 .35 .67 r
.817 .54642 m
.81178 .51599 L
s
.74043 .38571 m
.78958 .37733 L
s
.74043 .38571 m
.74513 .41879 L
s
.83 .24 .1 r
.43032 .52626 m
.44466 .55402 L
s
.44466 .55402 m
.47918 .54868 L
s
.54583 .19509 m
.52206 .18153 L
s
.24 .35 .67 r
.6962 .42692 m
.74513 .41879 L
s
.6962 .42692 m
.70145 .46205 L
s
.83 .24 .1 r
.545 .52041 m
.57285 .49894 L
s
.56163 .46981 m
.57285 .49894 L
s
.24289 .35217 m
.26172 .38411 L
s
.26172 .38411 m
.26912 .40837 L
s
.24 .35 .67 r
.70145 .46205 m
.70735 .4974 L
s
.70735 .4974 m
.75641 .48971 L
s
.75641 .48971 m
.76236 .52352 L
s
.76236 .52352 m
.81178 .51599 L
s
.83 .24 .1 r
.58747 .27104 m
.57548 .24869 L
s
.56429 .21335 m
.57548 .24869 L
s
.24 .35 .67 r
.70145 .46205 m
.75056 .45412 L
s
.83 .24 .1 r
.46562 .52065 m
.47918 .54868 L
s
.47918 .54868 m
.51322 .53729 L
s
.51322 .53729 m
.545 .52041 L
s
.53305 .49167 m
.545 .52041 L
s
.2836 .42976 m
.30154 .45999 L
s
.30154 .45999 m
.32248 .47737 L
s
.24 .35 .67 r
.79468 .41055 m
.78958 .37733 L
s
.83 .24 .1 r
.50048 .50893 m
.51322 .53729 L
s
.34922 .48984 m
.3656 .51866 L
s
.3656 .51866 m
.39642 .52553 L
s
.24 .35 .67 r
.74513 .41879 m
.79468 .41055 L
s
.74513 .41879 m
.75056 .45412 L
s
.83 .24 .1 r
.60302 .33009 m
.59247 .29659 L
s
.60069 .35756 m
.60302 .33009 L
s
.58478 .44453 m
.60143 .41721 L
s
.59083 .38583 m
.60143 .41721 L
s
.24 .35 .67 r
.75056 .45412 m
.75641 .48971 L
s
.75641 .48971 m
.80611 .48192 L
s
.81178 .51599 m
.80611 .48192 L
s
.75056 .45412 m
.8003 .44609 L
s
.83 .24 .1 r
.24286 .32601 m
.24289 .35217 L
s
.56429 .21335 m
.54583 .19509 L
s
.24 .35 .67 r
.8003 .44609 m
.79468 .41055 L
s
.80611 .48192 m
.8003 .44609 L
s
.83 .24 .1 r
.25019 .37655 m
.26912 .40837 L
s
.26912 .40837 m
.2836 .42976 L
s
.38063 .49659 m
.39642 .52553 L
s
.39642 .52553 m
.43032 .52626 L
s
.59247 .29659 m
.58747 .27104 L
s
.57642 .23572 m
.58747 .27104 L
s
.56163 .46981 m
.58478 .44453 L
s
.57366 .41353 m
.58478 .44453 L
s
.30482 .44716 m
.32248 .47737 L
s
.32248 .47737 m
.34922 .48984 L
s
.59083 .38583 m
.60069 .35756 L
s
.58994 .32428 m
.60069 .35756 L
s
.41526 .4971 m
.43032 .52626 L
s
.43032 .52626 m
.46562 .52065 L
s
.53305 .49167 m
.56163 .46981 L
s
.54984 .43921 m
.56163 .46981 L
s
.24289 .35217 m
.25019 .37655 L
s
.57642 .23572 m
.56429 .21335 L
s
.45138 .49122 m
.46562 .52065 L
s
.46562 .52065 m
.50048 .50893 L
s
.50048 .50893 m
.53305 .49167 L
s
.52049 .46149 m
.53305 .49167 L
s
.26476 .39801 m
.2836 .42976 L
s
.2836 .42976 m
.30482 .44716 L
s
.48709 .47914 m
.50048 .50893 L
s
.33201 .45956 m
.34922 .48984 L
s
.34922 .48984 m
.38063 .49659 L
s
.59247 .29659 m
.58138 .2614 L
s
.58994 .32428 m
.59247 .29659 L
s
.57366 .41353 m
.59083 .38583 L
s
.57969 .35287 m
.59083 .38583 L
s
.25019 .37655 m
.26476 .39801 L
s
.36405 .46617 m
.38063 .49659 L
s
.38063 .49659 m
.41526 .4971 L
s
.58138 .2614 m
.57642 .23572 L
s
.54984 .43921 m
.57366 .41353 L
s
.56197 .38094 m
.57366 .41353 L
s
.28625 .4154 m
.30482 .44716 L
s
.30482 .44716 m
.33201 .45956 L
s
.57969 .35287 m
.58994 .32428 L
s
.57863 .28931 m
.58994 .32428 L
s
.39944 .46646 m
.41526 .4971 L
s
.41526 .4971 m
.45138 .49122 L
s
.52049 .46149 m
.54984 .43921 L
s
.53746 .40704 m
.54984 .43921 L
s
.4364 .46026 m
.45138 .49122 L
s
.45138 .49122 m
.48709 .47914 L
s
.48709 .47914 m
.52049 .46149 L
s
.50729 .42975 m
.52049 .46149 L
s
.26476 .39801 m
.28625 .4154 L
s
.473 .44782 m
.48709 .47914 L
s
.31391 .42772 m
.33201 .45956 L
s
.33201 .45956 m
.36405 .46617 L
s
.57863 .28931 m
.58138 .2614 L
s
.56197 .38094 m
.57969 .35287 L
s
.56798 .3182 m
.57969 .35287 L
s
.34659 .43416 m
.36405 .46617 L
s
.36405 .46617 m
.39944 .46646 L
s
.53746 .40704 m
.56197 .38094 L
s
.54967 .34665 m
.56197 .38094 L
s
.28625 .4154 m
.31391 .42772 L
s
.56798 .3182 m
.57863 .28931 L
s
.38277 .43419 m
.39944 .46646 L
s
.39944 .46646 m
.4364 .46026 L
s
.50729 .42975 m
.53746 .40704 L
s
.52441 .37317 m
.53746 .40704 L
s
.42063 .42767 m
.4364 .46026 L
s
.4364 .46026 m
.473 .44782 L
s
.473 .44782 m
.50729 .42975 L
s
.49339 .39633 m
.50729 .42975 L
s
.45817 .41483 m
.473 .44782 L
s
.31391 .42772 m
.34659 .43416 L
s
.54967 .34665 m
.56798 .3182 L
s
.34659 .43416 m
.38277 .43419 L
s
.52441 .37317 m
.54967 .34665 L
s
.38277 .43419 m
.42063 .42767 L
s
.49339 .39633 m
.52441 .37317 L
s
.42063 .42767 m
.45817 .41483 L
s
.45817 .41483 m
.49339 .39633 L
s
0 0 0 r
.25 Mabswid
.75972 .08168 m
.83139 .50547 L
s
.83139 .50547 m
.86955 .74993 L
s
.86955 .74993 m
.80207 .35868 L
s
.80207 .35868 m
.75972 .08168 L
s
.08947 .22236 m
.02925 .49223 L
s
.02925 .49223 m
.80207 .35868 L
s
.80207 .35868 m
.75972 .08168 L
s
.75972 .08168 m
.08947 .22236 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{500, 500},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40007d0001m2000`400?l00000o`00003oo`3ooooe
0?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3o
m^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40
oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?of
k_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3o
ool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^
m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?oo
o`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd
0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo
003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0
ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool0
0?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03o
m^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofkWX0ooK^0`00001g0?ofkP40oooo003o0?ofkWD0
ooK^1@0000020?ofkP030000003om^h0ooK^07D0ooK^0@3oool00?l0ooK^L@3om^h4000000L0ooK^
00<000000?ofkP3om^h0M@3om^h10?ooo`00o`3om^i/0?ofkPD000002`3om^h00`000000ooK^0?of
kP1e0?ofkP40oooo003o0?ofkVL0ooK^1@00000A0?ofkP030000003om^h0ooK^07@0ooK^0@3oool0
0?l0ooK^HP3om^h5000001H0ooK^00<000000?ofkP3om^h0M03om^h10?ooo`00o`3om^iM0?ofkPD0
00006`3om^h00`000000ooK^0?ofkP1d0?ofkP40oooo003o0?ofkUT0ooK^1000000P0?ofkP030000
003om^h0ooK^07@0ooK^0@3oool00?l0ooK^E03om^h5000002@0ooK^00<000000?ofkP3om^h0M03o
m^h10?ooo`00o`3om^i?0?ofkPD00000:@3om^h00`000000ooK^0?ofkP1d0?ofkP40oooo003o0?of
kTX0ooK^1@00000_0?ofkP030000003om^h0ooK^07<0ooK^0@3oool00?l0ooK^A@3om^h5000003@0
ooK^00<000000?ofkP3om^h0L`3om^h10?ooo`00o`3om^i10?ofkP@00000>@3om^h00`000000ooK^
0?ofkP1c0?ofkP40oooo003o0?ofkS`0ooK^1@00000m0?ofkP030000003om^h0ooK^07<0ooK^0@3o
ool00?l0ooK^=`3om^h500000480ooK^00<000000?ofkP3om^h0L`3om^h10?ooo`00o`3om^hb0?of
kPD00000A`3om^h00`000000ooK^0?ofkP1c0?ofkP40oooo003o0?ofkRh0ooK^1000001<0?ofkP80
0000M03om^h10?ooo`00o`3om^hY0?ofkPD00000D@3om^h00`000000ooK^0?ofkP1b0?ofkP40oooo
003o0?ofkR@0ooK^1@00001F0?ofkP030000003om^h0ooK^0780ooK^0@3oool00?l0ooK^7`3om^h5
000005/0ooK^00<000000?ofkP3om^h0LP3om^h10?ooo`00o`3om^hJ0?ofkPD00000H03om^h00`00
0000ooK^0?ofkP1b0?ofkP40oooo003o0?ofkQH0ooK^1000001U0?ofkP030000003om^h0ooK^0780
ooK^0@3oool00?l0ooK^4@3om^h5000006T0ooK^0P00001c0?ofkP40oooo003o0?ofkP`0ooK^1@00
001^0?ofkP800000L`3om^h10?ooo`00o`3om^h70?ofkPD00000M03om^h00`000000ooK^0?ofkP1a
0?ofkP40oooo003o0?ofkP80ooK^1@00001i0?ofkP030000003om^h0ooK^0740ooK^0@3oool00?d0
ooK^1000001n0?ofkP030000003om^h0ooK^0740ooK^0@3oool00?P0ooK^1@0000220?ofkP030000
003om^h0ooK^0740ooK^0@3oool00?<0ooK^1@0000270?ofkP800000LP3om^h10?ooo`00kP3om^h5
000008`0ooK^0P00001b0?ofkP40oooo003Z0?ofkP@00000TP3om^h00`000000ooK^0?ofkP1`0?of
kP40oooo003U0?ofkPD00000UP3om^h00`000000ooK^0?ofkP1`0?ofkP40oooo003P0?ofkPD00000
V`3om^h00`000000ooK^0?ofkP1`0?ofkP40oooo003K0?ofkPD00000X03om^h00`000000ooK^0?of
kP1`0?ofkP40oooo003F0?ofkPD00000Y@3om^h200000740ooK^0@3oool00=80ooK^1000002Z0?of
kP800000L@3om^h10?ooo`00c@3om^h500000:h0ooK^0P00001a0?ofkP40oooo00380?ofkPD00000
]03om^h00`000000ooK^0?ofkP1_0?ofkP40oooo00330?ofkPD00000^@3om^h00`000000ooK^0?of
kP1_0?ofkP40oooo002n0?ofkPD00000_P3om^h00`000000ooK^0?ofkP1_0?ofkP40oooo002j0?of
kP@00000``3om^h200000700ooK^0@3oool00;D0ooK^1@0000370?ofkP800000L03om^h10?ooo`00
/03om^h500000<`0ooK^0P00001`0?ofkP40oooo002[0?ofkPD00000dP3om^h00`000000ooK^0?of
kP1^0?ofkP40oooo002W0?ofkP@00000=03om^h<0=@m6IL0ooK^00<000000?ofkP3om^h0KP3om^h1
0?ooo`00XP3om^h5000002h0ooK^2P3D?AT80?ofkP040=@m6@3om^h0ooK^0?ofkPP0e3dIS`3om^h0
0`000000ooK^0?ofkP1^0?ofkP40oooo002M0?ofkPD00000;`3om^h40=@m6@030?ofkP3D?AT0ooK^
0100ooK^00<0e3dI0?ofkP3om^h0203om^h50=@m6HX0ooK^0P00001_0?ofkP40oooo002H0?ofkPD0
0000<03om^h40=@m6@H0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP03
0=@m6@3om^h0e3dI00<0e3dIQP3om^h2000006l0ooK^0@3oool009<0ooK^1@00000a0?ofkP@0e3dI
2P3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h0
0P3om^h30=@m6H<0ooK^0P00001_0?ofkP40oooo002?0?ofkP@00000<P3om^h40=@m6@l0ooK^00<0
e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00D0ooK^103D
?AUo0?ofkP800000K`3om^h10?ooo`00RP3om^h5000003<0ooK^0`3D?AT00`3om^h0e3dI0?ofkP0@
0?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP09
0?ofkP80e3dIOP3om^h00`000000ooK^0?ofkP1]0?ofkP40oooo00250?ofkPD00000=@3om^h30=@m
6@D0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^
00`0ooK^00<0e3dI0?ofkP3om^h02@3om^h30=@m6G`0ooK^00<000000?ofkP3om^h0K@3om^h10?oo
o`00P03om^h5000003H0ooK^103D?AT80?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3o
m^h03P3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00X0ooK^00@0e3dI0?ofkP3D
?AT0e3dINP3om^h2000006h0ooK^0@3oool007/0ooK^1@00000h0?ofkP<0e3dI3@3om^h00`3D?AT0
ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0
ooK^0?ofkP0:0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT0N@3om^h2000006h0ooK^0@3oool007L0
ooK^1000000k0?ofkP80e3dI403om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00h0
ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^0080
ooK^0P3D?AUg0?ofkP800000KP3om^h10?ooo`00LP3om^h5000003d0ooK^0`3D?ATA0?ofkP030=@m
6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m
6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h00`3om^h20=@m6GD0ooK^0P00001^0?ofkP40oooo
001]0?ofkPD00000@03om^h20=@m6@<0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?of
kP0?0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?of
kP090?ofkP030=@m6@3om^h0ooK^00D0ooK^0P3D?AUd0?ofkP030000003om^h0ooK^06`0ooK^0@3o
ool006P0ooK^1@0000130?ofkP80e3dI1@3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0
ooK^00l0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0
ooK^00T0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP1a0?ofkP030000003om^h0
ooK^06`0ooK^0@3oool006@0ooK^100000160?ofkP80e3dI203om^h00`3D?AT0ooK^0?ofkP0?0?of
kP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0;0?of
kP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h01P3om^h20=@m6G80ooK^0P00001]0?of
kP40oooo001O0?ofkPD00000B03om^h20=@m6@X0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0
ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0
ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^00L0ooK^0P3D?AUa0?ofkP800000K@3om^h10?ooo`00
FP3om^h5000004/0ooK^0P3D?AT<0?ofkP030=@m6@3om^h0ooK^0100ooK^00<0e3dI0?ofkP3om^h0
3P3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h0
2@3om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0e3dI0700ooK^0P00001]0?ofkP40oooo
001E0?ofkPD00000CP3om^h20=@m6@l0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?of
kP0?0?ofkP030=@m6@3om^h0ooK^00H0ooK^2`3D?AT:0?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0
e3dI0?ofkP3om^h01P3om^h0103D?AT0ooK^0?ofkP3D?AU_0?ofkP800000K@3om^h10?ooo`00D03o
m^h500000540ooK^0P3D?ATA0?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h03P3o
m^h:0=@m6@L0ooK^00@0e3dI0?ofkP3om^h0ooK^203D?AT30?ofkP030=@m6@3om^h0ooK^00T0ooK^
00<0e3dI0?ofkP3om^h01`3om^h0103D?AT0ooK^0?ofkP3D?AU^0?ofkP800000K@3om^h10?ooo`00
C03om^h4000005@0ooK^0`3D?ATC0?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h0
2@3om^h40=@m6@030?ofkP3D?AT0ooK^00l0ooK^00<0e3dI0?ofkP3om^h0203om^h50=@m6@X0ooK^
00<0e3dI0?ofkP3om^h01`3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI06h0ooK^00<000000?ofkP3o
m^h0J`3om^h10?ooo`00A`3om^h5000005L0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0B0?ofkP03
0=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h01@3om^h40=@m6@H0ooK^00<0e3dI0?ofkP3o
m^h03@3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0e3dI0080e3dI203om^h00`3D?AT0
ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h0J`3om^h2000006`0
ooK^0@3oool00480ooK^1@00001K0?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h0
4@3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00@0e3dI2P3om^h00`3D?AT0ooK^
0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00`0ooK^00@0e3dI0?ofkP3om^h0ooK^0P3D?AT60?ofkP03
0=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP1Z0?ofkP80
0000K03om^h10?ooo`00?@3om^h5000005h0ooK^0P3D?AT60?ofkP030=@m6@3om^h0ooK^0100ooK^
00<0e3dI0?ofkP3om^h03P3om^h40=@m6@l0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^
0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00<0ooK^0`3D?AT30?ofkP030=@m6@3om^h0ooK^00L0ooK^
00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP1Y0?ofkP800000K03om^h10?ooo`00>03o
m^h500000680ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP0@0?ofkP030=@m6@3o
m^h0ooK^00/0ooK^0`3D?AT00`3om^h0e3dI0?ofkP0@0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0
e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP060?ofkP<0e3dI00<0ooK^0=@m6@3om^h0203o
m^h00`3D?AT0ooK^0?ofkP020?ofkP80e3dIJP3om^h2000006`0ooK^0@3oool003@0ooK^1000001U
0?ofkP80e3dI2P3om^h00`3D?AT0ooK^0?ofkP0@0?ofkP030=@m6@3om^h0ooK^00L0ooK^0`3D?AT5
0?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0<
0?ofkP030=@m6@3om^h0ooK^00P0ooK^0P3D?AT90?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI
0?ofkP3om^h0J03om^h2000006`0ooK^0@3oool002l0ooK^1@00001X0?ofkP030=@m6@3om^h0ooK^
00X0ooK^00<0e3dI0?ofkP3om^h0403om^h00`3D?AT0ooK^0?ofkP030?ofkP@0e3dI203om^h00`3D
?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D
?AT0ooK^0?ofkP090?ofkP<0e3dI1`3om^h00`3D?AT0ooK^0?ofkP030?ofkP80e3dIJ@3om^h20000
06`0ooK^0@3oool002`0ooK^0`00001/0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3o
m^h0403om^h00`3D?AT0ooK^0=@m6@020=@m6@d0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0
ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h02P3om^h0103D?AT0
ooK^0=@m6@3D?AT60?ofkP030=@m6@3om^h0ooK^0080ooK^0P3D?AUZ0?ofkP800000J`3om^h10?oo
o`00;03om^h2000006/0ooK^0P3D?AT?0?ofkP030=@m6@3om^h0ooK^0100ooK^0P3D?AT@0?ofkP03
0=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP03
0=@m6@3om^h0ooK^00T0ooK^00@0e3dI0?ofkP3om^h0ooK^0P3D?AT40?ofkP030=@m6@3om^h0ooK^
00<0ooK^0P3D?AUY0?ofkP800000J`3om^h10?ooo`00;03om^h2000006X0ooK^00<0e3dI0?ofkP3o
m^h0403om^h00`3D?AT0ooK^0?ofkP0=0?ofkP<0e3dI4P3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP03
0=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP090?ofkP03
0=@m6@3om^h0ooK^00<0ooK^0P3D?AT20?ofkP030=@m6@3om^h0ooK^00<0ooK^0P3D?AUY0?ofkP80
0000J`3om^h10?ooo`00:`3om^h010000000ooK^0?ofkP00001X0?ofkP030=@m6@3om^h0e3dI0140
ooK^00<0e3dI0?ofkP3om^h02`3om^h20=@m6@<0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0
ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0
ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^00@0ooK^0P3D?AT00`3om^h0e3dI0?ofkP030?ofkP03
0=@m6@3om^h0e3dI06P0ooK^0P00001[0?ofkP40oooo000[0?ofkP050000003om^h0ooK^0?ofkP00
0000IP3om^h0103D?AT0ooK^0?ofkP3D?ATB0?ofkP030=@m6@3om^h0ooK^00P0ooK^0P3D?AT50?of
kP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP0=0?of
kP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP060?of
kP80e3dI1@3om^h20=@m6FP0ooK^0P00001[0?ofkP40oooo000[0?ofkP050000003om^h0ooK^0?of
kP000000I@3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?of
kP3om^h01P3om^h20=@m6@P0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP0>0?of
kP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP0:0?of
kP030=@m6@3om^h0ooK^00H0ooK^0P3D?AT40?ofkP030=@m6@3om^h0e3dI06L0ooK^0P00001[0?of
kP40oooo000[0?ofkP030000003om^h0ooK^0080ooK^00<000000?ofkP3om^h0H@3om^h00`3D?AT0
ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^0100ooK^00<0e3dI0?ofkP3om^h00`3om^h20=@m6@X0
ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00`0
ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^00L0
ooK^0P3D?AT30?ofkP030=@m6@3om^h0e3dI06P0ooK^0P00001Z0?ofkP40oooo000Z0?ofkP030000
003om^h0ooK^00<0ooK^00<000000?ofkP3om^h0H03om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m
6@3om^h0ooK^00l0ooK^00@0e3dI0?ofkP3om^h0ooK^0P3D?AT=0?ofkP030=@m6@3om^h0ooK^00l0
ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00/0
ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0e3dI00<0
ooK^00<0e3dI0?ofkP3D?AT0I`3om^h2000006X0ooK^0@3oool002X0ooK^00<000000?ofkP3om^h0
103om^h00`000000ooK^0?ofkP1M0?ofkP80e3dI203om^h00`3D?AT0ooK^0?ofkP0@0?ofkP<0e3dI
3`3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h0
1@3om^h;0=@m6@X0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP060?ofkP040=@m
6@3om^h0ooK^0=@m6@80ooK^00<0e3dI0?ofkP3D?AT0I`3om^h2000006X0ooK^0@3oool002X0ooK^
00<000000?ofkP3om^h01@3om^h00`000000ooK^0?ofkP1K0?ofkP030=@m6@3om^h0ooK^00T0ooK^
00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^0100ooK^
00<0e3dI0?ofkP3om^h0303om^h:0=@m6@L0ooK^00@0e3dI0?ofkP3om^h0ooK^203D?AT30?ofkP03
0=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h01P3om^h0103D?AT0ooK^0?ofkP3D?AT20?of
kP040=@m6@3om^h0e3dI0=@m6FH0ooK^0P00001Z0?ofkP40oooo000Z0?ofkP030000003om^h0ooK^
00D0ooK^00<000000?ofkP3om^h0FP3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^
00h0ooK^0P3D?ATB0?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h01`3om^h50=@m
6@80ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP080?ofkPD0e3dI2P3om^h00`3D
?AT0ooK^0?ofkP070?ofkP040=@m6@3om^h0ooK^0=@m6@80ooK^00<0e3dI0?ofkP3D?AT0IP3om^h2
000006X0ooK^0@3oool002X0ooK^00<000000?ofkP3om^h01P3om^h00`000000ooK^0?ofkP1H0?of
kP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h02`3om^h20=@m6@80ooK^00<0e3dI0?of
kP3om^h03`3om^h00`3D?AT0ooK^0?ofkP0@0?ofkP030=@m6@3om^h0ooK^00H0e3dI203om^h00`3D
?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3D?AT00`3D?AT70?of
kP030=@m6@3om^h0ooK^00H0ooK^00T0e3dI0?ofkP3om^h0ooK^0=@m6@3om^h0e3dI0?ofkP3D?AT0
IP3om^h2000006X0ooK^0@3oool002T0ooK^00<000000?ofkP3om^h0203om^h00`000000ooK^0?of
kP1F0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?of
kP020?ofkP030=@m6@3om^h0ooK^0100ooK^00<0e3dI0?ofkP3om^h03P3om^h40=@m6@h0ooK^00<0
e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^0080ooK^0`3D
?AT40?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h00P3om^h20=@m6@030?ofkP3D
?AT0e3dI06D0ooK^00<000000?ofkP000000J@3om^h10?ooo`00:@3om^h00`000000ooK^0?ofkP08
0?ofkP030000003om^h0ooK^05D0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP08
0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP0;
0?ofkP<0e3dI00<0ooK^0=@m6@3om^h0403om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0
ooK^00/0ooK^00<0e3dI0?ofkP3om^h01@3om^h40=@m6@030?ofkP3D?AT0ooK^00L0ooK^00<0e3dI
0?ofkP3om^h00P3om^h40=@m6FH0ooK^0P00001Y0?ofkP40oooo000Y0?ofkP030000003om^h0ooK^
00T0ooK^00<000000?ofkP3om^h0D`3om^h00`3D?AT0ooK^0=@m6@0@0?ofkP030=@m6@3om^h0ooK^
00H0ooK^0P3D?AT70?ofkP030=@m6@3om^h0ooK^0100ooK^00<0e3dI0?ofkP3om^h01`3om^h30=@m
6@D0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^
00/0ooK^00<0e3dI0?ofkP3om^h02@3om^h20=@m6@P0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D
?AT0ooK^0=@m6@1V0?ofkP800000J@3om^h10?ooo`00:@3om^h00`000000ooK^0?ofkP0:0?ofkP03
0000003om^h0ooK^0580ooK^00<0e3dI0?ofkP3D?AT04@3om^h00`3D?AT0ooK^0?ofkP040?ofkP03
0=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP030?ofkP@0
e3dI203om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3o
m^h02`3om^h00`3D?AT0ooK^0?ofkP090?ofkP<0e3dI1P3om^h00`3D?AT0ooK^0?ofkP030?ofkP@0
e3dII@3om^h2000006T0ooK^0@3oool002P0ooK^00<000000?ofkP3om^h02`3om^h00`000000ooK^
0?ofkP1A0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT0403om^h00`3D?AT0ooK^0?ofkP030?ofkP03
0=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h0403om^h00`3D?AT0ooK^0=@m6@020=@m6@d0
ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00/0
ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0=@m6@060?ofkP030=@m6@3om^h0ooK^00<0
ooK^0`3D?AUU0?ofkP800000J@3om^h10?ooo`00:03om^h00`000000ooK^0?ofkP0<0?ofkP030000
003om^h0ooK^04l0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m
6@3om^h0ooK^0080e3dI3@3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP80e3dI403om^h00`3D?AT0ooK^
0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^
0?ofkP090?ofkP030=@m6@3om^h0ooK^0080e3dI103om^h00`3D?AT0ooK^0?ofkP030?ofkP<0e3dI
I@3om^h2000006T0ooK^0@3oool002P0ooK^00<000000?ofkP3om^h03@3om^h00`000000ooK^0?of
kP1>0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0=@m
6@0?0?ofkP030=@m6@3om^h0ooK^00d0ooK^0`3D?ATA0?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0
e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0
e3dI0?ofkP3om^h00P3om^h20=@m6@80ooK^00<0e3dI0?ofkP3om^h00`3om^h40=@m6F@0ooK^00<0
00000?ofkP000000J03om^h10?ooo`00:03om^h00`000000ooK^0?ofkP0=0?ofkP030000003om^h0
ooK^04d0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0
ooK^00l0ooK^00<0e3dI0?ofkP3om^h02P3om^h20=@m6@<0ooK^00<0e3dI0?ofkP3om^h03`3om^h0
0`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h02`3om^h0
0`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3D?AT01P3om^h3
0=@m6FD0ooK^0P00001X0?ofkP40oooo000X0?ofkP030000003om^h0ooK^00h0ooK^00<000000?of
kP3om^h0B`3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00d0ooK^0P3D?ATA0?of
kP030=@m6@3om^h0ooK^00P0ooK^0P3D?AT50?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?of
kP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?of
kP3om^h02@3om^h00`3D?AT0ooK^0?ofkP040?ofkP<0e3dI1@3om^h30=@m6FD0ooK^0P00001X0?of
kP40oooo000W0?ofkP030000003om^h0ooK^00l0ooK^00<000000?ofkP3om^h0BP3om^h00`3D?AT0
ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00`0ooK^00@0e3dI0?ofkP3om^h0e3dI4@3om^h00`3D
?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D
?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D
?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h00`3om^h40=@m
6F@0ooK^0P00001X0?ofkP40oooo000W0?ofkP030000003om^h0ooK^0100ooK^00<000000?ofkP3o
m^h0B@3om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00X0ooK^00D0e3dI0?ofkP3o
m^h0ooK^0=@m6@0A0?ofkP030=@m6@3om^h0ooK^00@0ooK^0P3D?AT90?ofkP030=@m6@3om^h0ooK^
00l0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^
00/0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP060?ofkP80e3dI103om^h40=@m
6F@0ooK^0P00001X0?ofkP40oooo000W0?ofkP030000003om^h0ooK^0140ooK^00<000000?ofkP3o
m^h0A`3om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3o
m^h00`3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP040=@m6@3om^h0ooK^0?ofkP80e3dI303om^h00`3D
?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D
?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h01P3om^h20=@m
6@@0ooK^0`3D?AUT0?ofkP800000J03om^h10?ooo`009`3om^h00`000000ooK^0?ofkP0A0?ofkP03
0000003om^h0ooK^04H0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP070?ofkP03
0=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h03`3om^h0103D?AT0ooK^0=@m6@3D?AT>0?of
kP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h0303om^hE0=@m6@X0ooK^00<0e3dI0?of
kP3om^h02@3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0e3dI0080ooK^1@3D?AUS0?of
kP030000003om^h0000006L0ooK^0@3oool002H0ooK^00<000000?ofkP3om^h04`3om^h00`000000
ooK^0?ofkP150?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h01@3om^h20=@m6@P0
ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00l0
ooK^00<0e3dI0?ofkP3om^h01`3om^h50=@m6@80ooK^00<0e3dI0?ofkP3om^h0303om^h0103D?AT0
ooK^0?ofkP3om^h80=@m6@<0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP060?of
kP050=@m6@3om^h0ooK^0=@m6@3om^h00`3D?AT00`3om^h0e3dI0?ofkP1R0?ofkP030000003om^h0
000006L0ooK^0@3oool002H0ooK^00<000000?ofkP3om^h0503om^h00`000000ooK^0?ofkP130?of
kP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP080?of
kP030=@m6@3om^h0ooK^00d0ooK^0`3D?ATA0?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?of
kP3om^h01P3D?AT80?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h0203om^h50=@m
6@X0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP020=@m6@040?ofkP3D?AT0e3dI
0=@m6F@0ooK^0P00001W0?ofkP40oooo000V0?ofkP030000003om^h0ooK^01@0ooK^00<000000?of
kP3om^h0@P3om^h00`3D?AT0ooK^0=@m6@0>0?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?of
kP3om^h02P3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT0403om^h0
0`3D?AT0ooK^0?ofkP0>0?ofkP@0e3dI3P3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0
ooK^00/0ooK^00<0e3dI0?ofkP3D?AT00P3D?AT70?ofkP030=@m6@3om^h0ooK^00H0ooK^00H0e3dI
0?ofkP3om^h0ooK^0=@m6@3om^h40=@m6F<0ooK^0P00001W0?ofkP40oooo000V0?ofkP030000003o
m^h0ooK^01D0ooK^00<000000?ofkP3om^h0@@3om^h00`3D?AT0ooK^0=@m6@0?0?ofkP040=@m6@3o
m^h0ooK^0=@m6@d0ooK^00<0e3dI0?ofkP3om^h02@3om^h20=@m6@@0ooK^00<0e3dI0?ofkP3om^h0
3`3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP80e3dI00<0ooK^0=@m6@3om^h0403om^h00`3D?AT0ooK^
0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00/0ooK^00@0e3dI0?ofkP3om^h0ooK^103D?AT30?ofkP03
0=@m6@3om^h0ooK^00H0ooK^00@0e3dI0?ofkP3om^h0ooK^1P3D?AUS0?ofkP800000I`3om^h10?oo
o`009P3om^h00`000000ooK^0?ofkP0F0?ofkP030000003om^h0ooK^03l0ooK^00D0e3dI0?ofkP3o
m^h0ooK^0=@m6@0>0?ofkP030=@m6@3om^h0e3dI00l0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D
?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h0203om^h30=@m
6@@0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^
00/0ooK^00<0e3dI0?ofkP3om^h01@3om^h30=@m6@030?ofkP3D?AT0ooK^00H0ooK^00H0e3dI0?of
kP3om^h0ooK^0=@m6@3om^h40=@m6F<0ooK^0P00001W0?ofkP40oooo000U0?ofkP030000003om^h0
ooK^01L0ooK^00<000000?ofkP3om^h0?`3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00l0ooK^00<0
e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP050?ofkP80e3dI203om^h00`3D?AT0ooK^0?of
kP0?0?ofkP030=@m6@3om^h0ooK^00D0ooK^0P3D?AT70?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0
e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00P0ooK^0P3D
?AT80?ofkP040=@m6@3om^h0ooK^0=@m6@80ooK^0`3D?AUS0?ofkP030000003om^h0000006H0ooK^
0@3oool002D0ooK^00<000000?ofkP3om^h0603om^h00`000000ooK^0?ofkP0m0?ofkP030=@m6@3o
m^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0=@m6@0@0?ofkP030=@m6@3o
m^h0ooK^0080ooK^0P3D?AT;0?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h00P3o
m^h30=@m6@X0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3o
m^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h0203om^h30=@m6@H0ooK^00<0e3dI0?ofkP3D?AT00`3o
m^h40=@m6F80ooK^00<000000?ofkP000000IP3om^h10?ooo`009@3om^h00`000000ooK^0?ofkP0I
0?ofkP030000003om^h0ooK^03`0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP0:
0?ofkP040=@m6@3om^h0ooK^0=@m6A00ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0=0?ofkP030=@m
6@3om^h0ooK^00l0ooK^00@0e3dI0?ofkP3D?AT0e3dI3@3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP03
0=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP090?ofkP03
0=@m6@3om^h0e3dI00D0ooK^00<0e3dI0?ofkP3D?AT0103om^h30=@m6F<0ooK^0P00001V0?ofkP40
oooo000U0?ofkP030000003om^h0ooK^01T0ooK^00<000000?ofkP3om^h0>`3om^h00`3D?AT0ooK^
0?ofkP050?ofkP030=@m6@3om^h0ooK^00T0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0@0?ofkP<0
e3dI3`3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP80e3dI403om^h00`3D?AT0ooK^0?ofkP0>0?ofkP03
0=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP090?ofkP03
0=@m6@3om^h0ooK^0080e3dI103om^h20=@m6@@0ooK^0`3D?AUS0?ofkP800000IP3om^h10?ooo`00
903om^h00`000000ooK^0?ofkP0K0?ofkP030000003om^h0ooK^03X0ooK^00<0e3dI0?ofkP3om^h0
1@3om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h0
3P3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00`0ooK^0`3D?ATA0?ofkP030=@m
6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m
6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h00P3om^h20=@m6@80ooK^0P3D?AT40?ofkP80e3dI
00<0ooK^0=@m6@3om^h0H@3om^h2000006H0ooK^0@3oool002@0ooK^00<000000?ofkP3om^h06`3o
m^h00`000000ooK^0?ofkP0i0?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h01P3o
m^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3D?AT04@3o
m^h00`3D?AT0ooK^0?ofkP090?ofkP80e3dI0`3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3o
m^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3o
m^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h00`3om^h0103D?AT0ooK^0=@m6@3D?AT50?ofkP<0e3dI
HP3om^h2000006H0ooK^0@3oool002@0ooK^00<000000?ofkP3om^h0703om^h00`000000ooK^0?of
kP0h0?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?of
kP050?ofkP030=@m6@3om^h0ooK^00/0ooK^00@0e3dI0?ofkP3om^h0e3dI4@3om^h00`3D?AT0ooK^
0?ofkP070?ofkP80e3dI1@3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00h0ooK^
00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00T0ooK^
00<0e3dI0?ofkP3om^h0103om^h40=@m6@@0ooK^0`3D?AUR0?ofkP800000IP3om^h10?ooo`00903o
m^h00`000000ooK^0?ofkP0M0?ofkP030000003om^h0ooK^03H0ooK^00<0e3dI0?ofkP3om^h02@3o
m^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h02@3o
m^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h0103o
m^h20=@m6@P0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3o
m^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3o
m^h0ooK^00D0ooK^0`3D?AT40?ofkP80e3dI00<0ooK^0=@m6@3om^h0E`3om^h303eIZ`H0ooK^00<0
00000?ofkP000000I@3om^h10?ooo`00903om^h00`000000ooK^0?ofkP0M0?ofkP030000003om^h0
ooK^03H0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0
ooK^00L0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0
ooK^00l0ooK^00<0e3dI0?ofkP3om^h00P3om^h20=@m6@X0ooK^00<0e3dI0?ofkP3om^h03`3om^h0
0`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h02P3om^h0
0`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00D0ooK^0`3D?AT40?ofkP@0e3dIDP3om^h9
03eIZ`H0ooK^00<000000?ofkP000000I@3om^h10?ooo`008`3om^h00`000000ooK^0?ofkP0O0?of
kP030000003om^h0ooK^03@0ooK^00<0e3dI0?ofkP3om^h02`3om^h01@3D?AT0ooK^0?ofkP3om^h0
e3dI00/0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0
ooK^00l0ooK^00@0e3dI0?ofkP3D?AT0e3dI3@3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3o
m^h0ooK^00/0ooK^5@3D?AT90?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h00`3o
m^h00`3D?AT0ooK^0?ofkP020=@m6@@0ooK^0`3D?AU=0?ofkP/0?EV[00@0ooK^03eIZ`0mFJ/0?EV[
1P3om^h2000006D0ooK^0@3oool002<0ooK^00<000000?ofkP3om^h0803om^h00`000000ooK^0?of
kP0c0?ofkP80e3dI3@3om^h00`3D?AT0ooK^0=@m6@0<0?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0
e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP80e3dI3`3om^h00`3D?AT0ooK^0?of
kP0?0?ofkP030=@m6@3om^h0ooK^00H0ooK^1@3D?AT20?ofkP030=@m6@3om^h0ooK^00`0ooK^00@0
e3dI0?ofkP3om^h0ooK^1`3D?AT30?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h0
0`3om^h00`3D?AT0ooK^0?ofkP030=@m6@<0ooK^0`3D?AU70?ofkP/0?EV[00<0ooK^03eIZ`0mFJ/0
100mFJ/00`3om^h0?EV[03eIZ`060?ofkP800000I@3om^h10?ooo`008`3om^h00`000000ooK^0?of
kP0P0?ofkP030000003om^h0ooK^03<0ooK^0P3D?AT=0?ofkP030=@m6@3om^h0e3dI00d0ooK^00<0
e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00`0ooK^0`3D
?ATA0?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h01@3D?AT80?ofkP030=@m6@3o
m^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h01`3om^h50=@m6@T0ooK^00<0e3dI0?ofkP3om^h00P3o
m^h0103D?AT0ooK^0?ofkP3om^h20=@m6@040?ofkP3D?AT0ooK^0?ofkP@0e3dI@@3om^h:03eIZ`80
ooK^1@0mFJ/80?ofkP0303eIZ`3om^h0ooK^00@0ooK^0P00001U0?ofkP40oooo000S0?ofkP030000
003om^h0ooK^0240ooK^00<000000?ofkP3om^h0<@3om^h0103D?AT0ooK^0?ofkP3D?AT=0?ofkP03
0=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP090?ofkP03
0=@m6@3om^h0ooK^00/0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0@0?ofkP030=@m6@3om^h0ooK^
00h0ooK^103D?AT=0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h02P3om^h0103D
?AT0ooK^0=@m6@3D?AT80?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT0103om^h20=@m6@030?ofkP3D
?AT0ooK^0080e3dI00<0ooK^0=@m6@3om^h0>P3om^h:03eIZ`80ooK^1P0mFJ/=0?ofkP80?EV[1@3o
m^h2000006D0ooK^0@3oool00280ooK^00<000000?ofkP3om^h08`3om^h00`000000ooK^0?ofkP0`
0?ofkP040=@m6@3om^h0ooK^0=@m6@`0ooK^00<0e3dI0?ofkP3D?AT03P3om^h0103D?AT0ooK^0?of
kP3D?AT=0?ofkP030=@m6@3om^h0ooK^00P0ooK^0P3D?AT40?ofkP030=@m6@3om^h0ooK^00l0ooK^
00<0e3dI0?ofkP3om^h02P3om^h30=@m6@030?ofkP3D?AT0ooK^00l0ooK^00<0e3dI0?ofkP3om^h0
2`3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00<0e3dI1@3om^h01@3D?AT0ooK^
0?ofkP3om^h0e3dI00@0ooK^0P3D?AT20?ofkPD0e3dI=@3om^h;03eIZ`80ooK^1@0mFJ/A0?ofkP@0
?EV[1@3om^h00`000000ooK^0000001T0?ofkP40oooo000R0?ofkP030000003om^h0ooK^02<0ooK^
00<000000?ofkP3om^h0<03om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00/0ooK^00<0e3dI0?ofkP3D
?AT03P3om^h00`3D?AT0ooK^0=@m6@0>0?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3o
m^h01@3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00L0ooK^0`3D?AT50?ofkP03
0=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP0:0?ofkP03
0=@m6@3om^h0ooK^00<0ooK^0`3D?AT20?ofkP040=@m6@3om^h0ooK^0=@m6@D0ooK^00@0e3dI0?of
kP3D?AT0ooK^1P3D?AT^0?ofkP/0?EV[0P3om^h703eIZ`030?ofkP0mFJ/0ooK^00`0ooK^1P0mFJ/0
103om^h0?EV[03eIZ`0mFJ/50?ofkP030000003om^h0000006@0ooK^0@3oool00280ooK^00<00000
0?ofkP3om^h0903om^h00`000000ooK^0?ofkP0_0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT02P3o
m^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00h0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^
0?ofkP050?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^
0?ofkP030?ofkP<0e3dI203om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00`0ooK^
00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP060?ofkP80e3dI00@0ooK^0=@m6@3om^h0
e3dI1@3om^h01P3D?AT0ooK^0=@m6@3om^h0e3dI0?ofkP@0e3dI:@3om^h:03eIZ`<0ooK^1@0mFJ/6
0?ofkP0303eIZ`3om^h0?EV[00L0ooK^1P0mFJ/00`3om^h0?EV[03eIZ`0403eIZ`030?ofkP0mFJ/0
?EV[00D0ooK^00<000000?ofkP000000I03om^h10?ooo`008P3om^h00`000000ooK^0?ofkP0T0?of
kP030000003om^h0ooK^02h0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP070?of
kP050=@m6@3om^h0ooK^0?ofkP3D?AT03@3om^h00`3D?AT0ooK^0=@m6@0?0?ofkP030=@m6@3om^h0
ooK^00<0ooK^0P3D?AT:0?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h00`3D?AT<
0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP0;
0?ofkP030=@m6@3om^h0ooK^00L0ooK^0P3D?AT00`3om^h0e3dI0?ofkP050?ofkP80e3dI00@0ooK^
0=@m6@3om^h0ooK^0`3D?ATS0?ofkPX0?EV[0`3om^h603eIZ`/0ooK^00<0?EV[0?ofkP3om^h01`0m
FJ/20?ofkPD0?EV[1`3om^h203eIZ`H0ooK^0P00001T0?ofkP40oooo000R0?ofkP030000003om^h0
ooK^02D0ooK^00<000000?ofkP3om^h0;@3om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0
ooK^00H0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP090?ofkP040=@m6@3om^h0
ooK^0=@m6A00ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0<0?ofkP030=@m6@3om^h0ooK^00l0ooK^
0P3D?AT?0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^
0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00P0ooK^0`3D?AT60?ofkP040=@m6@3om^h0e3dI0=@m6@80
ooK^103D?ATM0?ofkPX0?EV[0P3om^h603eIZ`l0ooK^1P0mFJ/20?ofkPH0?EV[303om^h203eIZ`H0
ooK^0P00001T0?ofkP40oooo000Q0?ofkP030000003om^h0ooK^02L0ooK^00<000000?ofkP3om^h0
;03om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h0
0`3om^h00`3D?AT0ooK^0?ofkP090?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT03`3om^h0103D?AT0
ooK^0=@m6@3D?AT>0?ofkP030=@m6@3om^h0ooK^00`0ooK^0`3D?AT@0?ofkP030=@m6@3om^h0ooK^
00h0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^
00T0ooK^00<0e3dI0?ofkP3D?AT01@3om^h0103D?AT0ooK^0=@m6@3D?AT30?ofkP<0e3dI5`3om^h:
03eIZ`<0ooK^1P0mFJ/20?ofkP0303eIZ`3om^h0ooK^00T0ooK^1P0mFJ/20?ofkPH0?EV[4`3om^h0
0`0mFJ/0ooK^0?ofkP040?ofkP800000I03om^h10?ooo`008@3om^h00`000000ooK^0?ofkP0W0?of
kP030000003om^h0ooK^02`0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP030?of
kP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP020?of
kP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0:0?of
kP80e3dI0`3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?of
kP3om^h02`3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00L0ooK^0P3D?AT20?of
kP80e3dI103om^h30=@m6@<0ooK^0`3D?ATB0?ofkPX0?EV[0`3om^h503eIZ`D0ooK^00D0?EV[0?of
kP3om^h0ooK^03eIZ`040?ofkPH0?EV[103om^h503eIZ`80ooK^00<0?EV[0?ofkP3om^h04`3om^h2
03eIZ`D0ooK^00<000000?ofkP000000H`3om^h10?ooo`008@3om^h00`000000ooK^0?ofkP0X0?of
kP030000003om^h0ooK^02X0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP030?of
kP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP040?of
kP030=@m6@3om^h0ooK^00`0ooK^0P3D?ATA0?ofkP030=@m6@3om^h0ooK^00L0ooK^0P3D?AT50?of
kP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0<0?of
kP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h01`3om^h30=@m6@<0ooK^0P3D?AT20?of
kP030=@m6@3om^h0e3dI00<0ooK^0`3D?AT=0?ofkPT0?EV[0`3om^h603eIZ`X0ooK^00<0?EV[0?of
kP3om^h01P0mFJ/40?ofkPH0?EV[103om^h0100mFJ/0ooK^0?ofkP0mFJ/E0?ofkP80?EV[1@3om^h0
0`000000ooK^0000001S0?ofkP40oooo000Q0?ofkP030000003om^h0ooK^02T0ooK^00<000000?of
kP3om^h0:@3om^h00`3D?AT0ooK^0?ofkP070?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT02@3om^h0
0`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h02`3om^h0
103D?AT0ooK^0?ofkP3D?AT@0?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h01P3o
m^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h02`3o
m^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00D0ooK^00@0e3dI0?ofkP3om^h0e3dI
1@3om^h01@3D?AT0ooK^0=@m6@3om^h0e3dI00@0ooK^00<0e3dI0?ofkP3D?AT01P3om^h:03eIZ`80
ooK^1P0mFJ/>0?ofkPD0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP0503eIZ`X0ooK^00D0?EV[0?ofkP3o
m^h0ooK^03eIZ`0D0?ofkP80?EV[1@3om^h00`000000ooK^0000001S0?ofkP40oooo000P0?ofkP03
0000003om^h0ooK^02X0ooK^00<000000?ofkP3om^h0:@3om^h00`3D?AT0ooK^0?ofkP070?ofkP05
0=@m6@3om^h0ooK^0?ofkP3D?AT02@3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^
00H0ooK^00<0e3dI0?ofkP3om^h02@3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI0140ooK^00<0e3dI
0?ofkP3om^h00`3om^h20=@m6@T0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0=
0?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP04
0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT01P3om^h40=@m6@@0ooK^0`3D?AT00`3om^h0?EV[03eI
Z`0703eIZ`030?ofkP0mFJ/0?EV[00H0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP090?ofkP@0?EV[0P3o
m^h00`0mFJ/0ooK^03eIZ`0503eIZa00ooK^00@0?EV[0?ofkP3om^h0?EV[4P3om^h403eIZ`H0ooK^
0P00001S0?ofkP40oooo000P0?ofkP030000003om^h0ooK^02/0ooK^00<000000?ofkP3om^h0:03o
m^h20=@m6@T0ooK^00<0e3dI0?ofkP3D?AT02`3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3o
m^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3o
m^h0ooK^00h0ooK^00@0e3dI0?ofkP3om^h0ooK^0P3D?AT;0?ofkP030=@m6@3om^h0ooK^00h0ooK^
00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00X0ooK^
00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00D0ooK^
00<0e3dI0?ofkP3D?AT00P3om^h0100mFJ/0e3dI0=@m6@3D?AT;03eIZ`H0ooK^00<0?EV[0?ofkP3o
m^h00P3om^h00`0mFJ/0ooK^0?ofkP040?ofkPD0?EV[00<0ooK^03eIZ`0mFJ/01@0mFJ/30?ofkP03
03eIZ`3om^h0ooK^0100ooK^00@0?EV[0?ofkP3om^h0?EV[303om^h703eIZ`030?ofkP0mFJ/0?EV[
00H0ooK^0P00001S0?ofkP40oooo000P0?ofkP030000003om^h0ooK^02`0ooK^00<000000?ofkP3o
m^h09`3om^h20=@m6@T0ooK^00<0e3dI0?ofkP3D?AT02`3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI
00/0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^
00l0ooK^0`3D?AT>0?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h02`3om^hD0=@m
6@X0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@0000000000
00D000000`3D?AT403eIZ`<0e3dI0`0mFJ/=0?ofkP0303eIZ`3om^h0ooK^00<0ooK^300mFJ/50?of
kP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h03`3om^h0100mFJ/0ooK^0?ofkP0mFJ/6
0?ofkPP0?EV[1P3om^h203eIZ`H0ooK^0P00001S0?ofkP40oooo000P0?ofkP030000003om^h0ooK^
02`0ooK^00<000000?ofkP3om^h09`3om^h00`3D?AT0ooK^0=@m6@090?ofkP030=@m6@3om^h0ooK^
00/0ooK^00<0e3dI0?ofkP3D?AT0303om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^
00H0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^
00h0ooK^00<0e3dI0?ofkP3om^h01P3om^h50=@m6@80ooK^00<0e3dI0?ofkP3om^h02`3om^h0103D
?AT0ooK^0?ofkP3om^h70=@m6@<0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@04000000801`XC00@0
e3dI00L:4`072Q<01`XC100000030=@m6@@0?EV[0`3D?AT00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eI
Z`3om^h0ooK^00P0?EV[303om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00l0ooK^
00@0?EV[0?ofkP3om^h0ooK^200mFJ/<0?ofkP0303eIZ`3om^h0?EV[00D0ooK^00<000000?ofkP00
0000HP3om^h10?ooo`00803om^h00`000000ooK^0?ofkP0]0?ofkP030000003om^h0ooK^02H0ooK^
00<0e3dI0?ofkP3D?AT02@3om^h20=@m6@`0ooK^00<0e3dI0?ofkP3D?AT03@3om^h00`3D?AT0ooK^
0?ofkP030?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h0303om^h30=@m6A40ooK^
00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP050=@m6@P0ooK^00<0e3dI0?ofkP3om^h0
2`3om^h00`3D?AT0ooK^0?ofkP070?ofkP@0e3dI0`000000103D?AT01`XC00L:4`072Q<400000003
0=@m6@000000000000<03a8S00<0e3dI00lB8`0?4R<00P3D?AT00`0?4R<0?EV[000000030=@m6@03
03eIZ`3om^h0ooK^00/0ooK^1`0mFJ/20?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3o
m^h00`3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkPT0?EV[4@3om^h00`0mFJ/0ooK^03eIZ`050?ofkP03
0000003om^h000000680ooK^0@3oool001l0ooK^00<000000?ofkP3om^h0;`3om^h00`000000ooK^
0?ofkP0U0?ofkP040=@m6@3om^h0ooK^0=@m6@P0ooK^0P3D?AT=0?ofkP030=@m6@3om^h0ooK^00`0
ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^00X0
ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0@0?ofkP030=@m6@3om^h0ooK^00d0ooK^103D?AT=0?of
kP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h01P3om^h7000000030=@m6@0000000000
00800000100?4R<00`3D?AT000000000000300lB8`050=@m6@0?4R<03a8S00lB8`3D?AT00`000004
0=@m6@0303eIZ`3om^h0ooK^00@0ooK^2@0mFJ/60?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[
0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP070?ofkPT0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP0A
0?ofkP0303eIZ`3om^h0?EV[00D0ooK^00<000000?ofkP000000HP3om^h10?ooo`007`3om^h00`00
0000ooK^0?ofkP0_0?ofkP030000003om^h0ooK^02D0ooK^00@0e3dI0?ofkP3om^h0e3dI1`3om^h0
103D?AT0ooK^0?ofkP3D?AT<0?ofkP80e3dI3P3om^h0103D?AT0ooK^0?ofkP3D?AT<0?ofkP030=@m
6@3om^h0ooK^00P0ooK^0P3D?AT40?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h0
2P3om^h30=@m6@030?ofkP3D?AT0ooK^00h0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^
00000002000000@01`XC1000000200lB8`030=@m6@0000003a8S00H03a8S00<0e3dI00lB8`000000
0`0000001@3D?AT00000000000000000e3dI00<05QXd0P3D?AT00`3om^h0e3dI03eIZ`0803eIZ`H0
ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00@0
ooK^00<0?EV[0?ofkP3om^h0200mFJ/60?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/0503om^h203eI
Z`D0ooK^00<000000?ofkP000000HP3om^h10?ooo`007`3om^h00`000000ooK^0?ofkP0`0?ofkP03
0000003om^h0ooK^02@0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@060?ofkP040=@m6@3om^h0ooK^
0=@m6@/0ooK^00<0e3dI0?ofkP3D?AT03P3om^h00`3D?AT0ooK^0=@m6@0>0?ofkP030=@m6@3om^h0
ooK^00H0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0
ooK^00H0ooK^0`3D?AT50?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h02@3om^h2
000000<0?EV[00<01`XC0000000000000`00000500lB8`040=@m6@0?4R<03a8S000000<03a8S1000
00001@3D?AT05QXd01HJ=00F6S@0e3dI00@05QXd00H0e3dI01HJ=00F6S@05QXd0=@m6@0F6S@20=@m
6@@0?EV[2`3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00`0ooK^00@0?EV[0?of
kP3om^h0ooK^1`0mFJ/=0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h04@3om^h2
03eIZ`H0ooK^0P00001R0?ofkP40oooo000O0?ofkP030000003om^h0ooK^0300ooK^00<000000?of
kP3om^h0903om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00H0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m
6@0:0?ofkP040=@m6@3om^h0ooK^0=@m6@h0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^
0?ofkP050?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^
0?ofkP030?ofkP<0e3dI203om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00@0ooK^
1000000300L:4`@000000`0?4R<00`0000003a8S00lB8`0300lB8`030=@m6@0?4R<03a8S00D00000
100F6S@01@3D?AT05QXd01HJ=00F6S@0e3dI00D05QXd00D0e3dI01HJ=00F6S@0e3dI01HJ=0030=@m
6@0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP0:0?of
kPL0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?of
kP3om^h04@3om^h00`0mFJ/0ooK^03eIZ`050?ofkP800000HP3om^h10?ooo`007P3om^h00`000000
ooK^0?ofkP0b0?ofkP030000003om^h0ooK^02<0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0
ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h01P3om^h01@3D?AT0
ooK^0?ofkP3om^h0e3dI00d0ooK^0P3D?AT@0?ofkP030=@m6@3om^h0ooK^0080ooK^0P3D?AT:0?of
kP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3D?AT00P3D?AT;0?ofkP030=@m6@3om^h0ooK^
00`0ooK^3`00000700lB8`040000000?4R<03a8S00lB8`80000000<0e3dI0000000000000P0F6S@0
0`0000005QXd01HJ=00401HJ=0060=@m6@0F6S@05QXd01HJ=03D?AT00000100F6S@00`3D?AT05QXd
0=@m6@0201HJ=0<0e3dI00<0ooK^03eIZ`3om^h02`3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eI
Z`3om^h0ooK^00@0ooK^2@0mFJ/60?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h0
0P3om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP0303eIZ`3om^h0?EV[00D0ooK^00<000000?ofkP000000
H@3om^h10?ooo`007P3om^h00`000000ooK^0?ofkP0c0?ofkP030000003om^h0ooK^0280ooK^00<0
e3dI0?ofkP3om^h00`3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00D0ooK^00<0e3dI0?ofkP3om^h0
1P3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00T0ooK^00@0e3dI0?ofkP3om^h0
e3dI3`3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00`0ooK^00<0e3dI0?ofkP3om^h03P3om^h20=@m
6@l0ooK^00<0e3dI0?ofkP3om^h01@3om^h60000000300L:4`000000000000D00000100?4R<00`00
00003a8S00lB8`0600lB8`D0000000<05QXd0=@m6@0F6S@01@0F6S@00`0000005QXd01HJ=00401HJ
=0050=@m6@0F6S@0e3dI01HJ=00000000`0F6S@010000000e3dI0000003D?AT2000000050=@m6@0Q
:UD0e3dI0?ofkP0mFJ/0303om^h00`0mFJ/0ooK^0?ofkP060?ofkPP0?EV[1P3om^h00`0mFJ/0ooK^
0?ofkP050?ofkP0303eIZ`3om^h0ooK^00h0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0C0?ofkP<0
?EV[1@3om^h00`000000ooK^0000001Q0?ofkP40oooo000N0?ofkP030000003om^h0ooK^03<0ooK^
00<000000?ofkP3om^h08P3om^h00`3D?AT0ooK^0?ofkP030?ofkP050=@m6@3om^h0ooK^0?ofkP3D
?AT01P3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3o
m^h02@3om^h0103D?AT0ooK^0?ofkP3D?AT@0?ofkP<0e3dI3@3om^h00`3D?AT0ooK^0?ofkP0<0?of
kP<0e3dI403om^h0103D?AT0ooK^0?ofkP3om^h5000000801`XC1000000200lB8`030000000?4R<0
3a8S00L03a8S00<0000000lB8`0?4R<01@00000201HJ=0030000000F6S@05QXd0080e3dI1P0F6S@0
0`0000005QXd01HJ=00401HJ=0030=@m6@0F6S@0e3dI00D000000P0Q:UD20=@m6@<08BYE0P3D?AT0
0`000000?EV[0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00T0?EV[2`3om^h00`0mFJ/0ooK^0?ofkP05
0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0>0?ofkPH0?EV[00<0
ooK^03eIZ`3om^h0103om^h00`000000ooK^0000001Q0?ofkP40oooo000N0?ofkP030000003om^h0
ooK^03@0ooK^00<000000?ofkP3om^h08@3om^h00`3D?AT0ooK^0?ofkP040?ofkP040=@m6@3om^h0
ooK^0=@m6@H0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3o
m^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3o
m^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h02@3om^h20=@m6@<0ooK^00<0e3dI0?ofkP3om^h0303o
m^h400000080?EV[1P00000600lB8`030000000?4R<03a8S00D03a8S1@00000801HJ=0050000003D
?AT05QXd01HJ=03D?AT01P0F6S@00`0000005QXd01HJ=003000000030=@m6@000000e3dI00808BYE
00<00000024ZE@0Q:UD00P0Q:UD20=@m6@<08BYE0`3D?AT00`3om^h0?EV[0?ofkP070?ofkPX0?EV[
0P3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h0
3P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00D0ooK^2@0mFJ/20?ofkP0303eI
Z`3om^h0?EV[00D0ooK^00<000000?ofkP000000H@3om^h10?ooo`007P3om^h00`000000ooK^0?of
kP0e0?ofkP030000003om^h0ooK^0200ooK^00<0e3dI0?ofkP3om^h0103om^h0103D?AT0ooK^0?of
kP3D?AT70?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^
0?ofkP060?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h0303om^h20=@m6A00ooK^
00<0e3dI0?ofkP3om^h01`3om^h20=@m6@D0ooK^00<0e3dI0?ofkP3om^h0103om^h>000000<03a8S
00<0000000lB8`0?4R<01P0?4R<00`0000003a8S00lB8`05000000805QXd00<0000001HJ=00F6S@0
200F6S@01@3D?AT05QXd01HJ=00F6S@0e3dI00@05QXd1@000004024ZE@030=@m6@0Q:UD08BYE0080
8BYE00@00000024ZE@0Q:UD08BYE0P3D?AT3024ZE@<0e3dI00@0000003eIZ`3om^h0ooK^2`0mFJ/8
0?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP0>
0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h0200mFJ/80?ofkP0303eIZ`3om^h0
?EV[00H0ooK^0P00001Q0?ofkP40oooo000M0?ofkP030000003om^h0ooK^03H0ooK^00<000000?of
kP3om^h0803om^h20=@m6@H0ooK^0P3D?AT90?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT0203om^h0
0`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h02P3om^h0
103D?AT0ooK^0?ofkP3D?AT@0?ofkP030=@m6@3om^h0ooK^00@0ooK^0P3D?AT80?ofkP030=@m6@00
0000000000<0000000<01`XC000000000000100000000`0?4R<0000000lB8`0600lB8`030000000?
4R<03a8S00<03a8S1`00000701HJ=0030000000F6S@05QXd00L05QXd00<0e3dI01HJ=00000000P0F
6S@00`3D?AT0000000000002000000808BYE00<00000024ZE@0Q:UD0100Q:UD00`3D?AT08BYE024Z
E@02024ZE@040000000Q:UD08BYE024ZE@80e3dI100Q:UD00`3D?AT08BYE03eIZ`0303eIZ`030?of
kP0mFJ/0?EV[00<0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00X0ooK^
00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0?EV[00L0?EV[
3`3om^h00`0mFJ/0ooK^03eIZ`050?ofkP800000H@3om^h10?ooo`007@3om^h00`000000ooK^0?of
kP0g0?ofkP030000003om^h0ooK^01l0ooK^0P3D?AT60?ofkP80e3dI2@3om^h0103D?AT0ooK^0?of
kP3D?AT90?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^
0?ofkP090?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT0403om^h00`3D?AT0ooK^0?ofkP020?ofkP80
e3dI1`3om^h5000000801`XC1@00000500lB8`030000000?4R<03a8S00<03a8S2000000401HJ=003
0000000F6S@05QXd00P05QXd00<0000001HJ=00F6S@01@0F6S@00`3D?AT000000000000300000003
024ZE@3D?AT08BYE00D08BYE00<00000024ZE@0Q:UD00P0Q:UD20=@m6@D08BYE00D00000024ZE@0Q
:UD08BYE0=@m6@04024ZE@040=@m6@0Q:UD08BYE000000<0?EV[203om^h00`0mFJ/0ooK^0?ofkP07
0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP08
0?ofkPT0?EV[00<0ooK^03eIZ`3om^h04P3om^h00`0mFJ/0ooK^03eIZ`050?ofkP030000003om^h0
00000600ooK^0@3oool001d0ooK^00<000000?ofkP3om^h0>03om^h00`000000ooK^0?ofkP0O0?of
kP80e3dI1P3om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0e3dI00X0ooK^00<0e3dI0?of
kP3om^h00P3om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?of
kP3om^h00`3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP040=@m6@3om^h0e3dI0=@m6@@0ooK^1@000000
0`072Q<00000000000040000000300lB8`0000003a8S00H03a8S00<0000000lB8`0?4R<010000002
01HJ=0030000000F6S@05QXd00L05QXd00<0000001HJ=00F6S@0200F6S@00`0000005QXd01HJ=004
000000050=@m6@0000008BYE024ZE@0000000`0Q:UD00`3D?AT08BYE024ZE@04024ZE@030000000Q
:UD08BYE00808BYE00<0e3dI024ZE@3D?AT0100Q:UD01@0000008BYE024ZE@0Q:UD0e3dI00@08BYE
0P3D?AT20000000303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^
0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00@0?EV[0?ofkP3om^h0ooK^2P0mFJ/20?ofkP03
03eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h04@3om^h00`0mFJ/0ooK^03eIZ`030?ofkP<0
000000<0ooK^0000003om^h0G`3om^h10?ooo`007@3om^h00`000000ooK^0?ofkP0h0?ofkP030000
003om^h0ooK^01l0ooK^0P3D?AT60?ofkP80e3dI2@3om^h20=@m6@/0ooK^00D0e3dI0?ofkP3om^h0
ooK^0=@m6@0:0?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0
ooK^0?ofkP0>0?ofkP80e3dI3P00000400lB8`030000000?4R<03a8S00@03a8S1@00000601HJ=003
0000000F6S@05QXd00L05QXd00<0000001HJ=00F6S@01P0F6S@5000000<08BYE00<0e3dI024ZE@0Q
:UD00P0Q:UD01@0000008BYE024ZE@0Q:UD0e3dI00H08BYE00D00000024ZE@0Q:UD08BYE0=@m6@02
024ZE@030=@m6@0Q:UD08BYE00<08BYE00@00000024ZE@0Q:UD0e3dI1@0000001@3D?AT0:CM_0000
003om^h0?EV[00T0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eI
Z`3om^h0ooK^00<0ooK^1P0mFJ/00`3om^h0?EV[03eIZ`0203eIZ`L0ooK^00<0?EV[0?ofkP3om^h0
0`3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkPH000000P3om^h00`000000ooK^0000001P0?ofkP40oooo
000L0?ofkP030000003om^h0ooK^03X0ooK^00<000000?ofkP3om^h07P3om^h00`3D?AT0ooK^0=@m
6@050?ofkP80e3dI2P3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0e3dI00`0ooK^00<0
e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00/0ooK^1000
00000`072Q<0000000000005000000803a8S00<0000000lB8`0?4R<01@0?4R<00`0000003a8S0000
0004000000805QXd00<0000001HJ=00F6S@01P0F6S@00`0000005QXd01HJ=00701HJ=0030000000F
6S@05QXd00H000000P0Q:UD00`0000008BYE024ZE@03024ZE@030=@m6@0Q:UD08BYE00808BYE00<0
0000024ZE@0Q:UD00P0Q:UD00`3D?AT08BYE024ZE@03024ZE@040000000Q:UD08BYE0=@m6@<08BYE
00@0e3dI024ZE@0Q:UD08BYE100000000`3D?AT0:CM_0=@m6@0402TgK`050=@m6@0Y=fl000000?of
kP0mFJ/02@3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00X0ooK^1P0mFJ/20?of
kPD0?EV[2`3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00X0ooK^1P0000000`0m
FJ/0ooK^03eIZ`050?ofkP030000003om^h000000600ooK^0@3oool001`0ooK^00<000000?ofkP3o
m^h0>`3om^h00`000000ooK^0?ofkP0M0?ofkP030=@m6@3om^h0e3dI00D0ooK^00<0e3dI0?ofkP3D
?AT02@3om^h20=@m6@/0ooK^00<0e3dI0?ofkP3D?AT0303om^h00`3D?AT0ooK^0?ofkP030?ofkP03
0=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h01P3om^h:0000000300lB8`0000003a8S00D0
3a8S00<0000000lB8`0?4R<00`0?4R<5000000H05QXd00<0000001HJ=00F6S@01`0F6S@00`000000
5QXd01HJ=00501HJ=0D00000200Q:UD00`0000008BYE024ZE@02024ZE@030=@m6@0Q:UD08BYE00@0
8BYE00D00000024ZE@0Q:UD08BYE0=@m6@06024ZE@040000000Q:UD0e3dI024ZE@<0000000<0e3dI
0000000000000P0Y=fl01@000000:CM_0=@m6@0Y=fl0e3dI00@0:CM_00D0e3dI02TgK`0Y=fl00000
03eIZ`0:0?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h01P3om^h503eIZ`80ooK^
1P0mFJ/@0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h0103om^h6000000L0ooK^
0P0mFJ/60?ofkP800000H03om^h10?ooo`00703om^h00`000000ooK^0?ofkP0k0?ofkP030000003o
m^h0ooK^01h0ooK^00<0e3dI0?ofkP3D?AT0103om^h00`3D?AT0ooK^0=@m6@090?ofkP80e3dI303o
m^h00`3D?AT0ooK^0?ofkP0<0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT02`3om^h00`3D?AT00000
000000090000000303eIZ`0000003a8S00803a8S0P00000600lB8`030000000?4R<0000000@00000
0P0F6S@00`0000005QXd01HJ=00601HJ=0030000000F6S@05QXd00L05QXd00<0000001HJ=00F6S@0
1@000002024ZE@030000000Q:UD08BYE00P08BYE00D00000024ZE@0Q:UD08BYE0=@m6@07024ZE@05
0000000Q:UD08BYE024ZE@3D?AT0100Q:UD3000000030=@m6@000000000000<0:CM_00<0e3dI02Tg
K`0Y=fl00P0Y=fl01@000000:CM_0=@m6@0Y=fl0e3dI00@0:CM_0P3D?AT0100Y=fl000000?ofkP0m
FJ/90?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h01@0mFJ/20?ofkPD0?EV[1P3o
m^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP0000001000
000=0?ofkP0303eIZ`3om^h0?EV[00D0ooK^0P00001P0?ofkP40oooo000L0?ofkP030000003om^h0
ooK^03`0ooK^00<000000?ofkP3om^h07@3om^h00`3D?AT0ooK^0=@m6@040?ofkP040=@m6@3om^h0
ooK^0=@m6@L0ooK^00@0e3dI0?ofkP3om^h0e3dI2`3om^h20=@m6@d0ooK^00@0e3dI0?ofkP3om^h0
e3dI1`3om^h=0000000300lB8`000000000000D03a8S00@0000000lB8`0?4R<03a8S1`00000601HJ
=0030000000F6S@05QXd00L05QXd00<0000001HJ=00F6S@01@0F6S@5000000L08BYE00<00000024Z
E@0Q:UD02@0Q:UD00`0000008BYE0=@m6@08024ZE@030000000Q:UD08BYE0080000000@0e3dI0000
0000000000000P0Y=fl00`3D?AT0:CM_02TgK`0402TgK`030=@m6@0Y=fl0:CM_0080:CM_00<00000
0=@m6@0Y=fl00P0Y=fl0103D?AT0:CM_02TgK`0Y=fl20=@m6@0402TgK`000000ooK^03eIZ`T0ooK^
00<0?EV[0?ofkP3om^h01@3om^h603eIZ`030?ofkP0mFJ/0?EV[00@0?EV[0P3om^h00`0mFJ/0ooK^
0?ofkP060?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0000000000001000000B0?ofkP0303eI
Z`3om^h0?EV[00D0ooK^00<000000?ofkP000000G`3om^h10?ooo`00703om^h00`000000ooK^0?of
kP0l0?ofkP030000003om^h0ooK^01d0ooK^00@0e3dI0?ofkP3om^h0e3dI0`3om^h01@3D?AT0ooK^
0?ofkP3om^h0e3dI00H0ooK^00@0e3dI0?ofkP3om^h0e3dI2P3om^h00`3D?AT0ooK^0=@m6@0>0?of
kP80e3dI1@3om^h30000000300L:4`000000000000D000001@0?4R<00`0000003a8S00lB8`0200lB
8`L000000`0F6S@00`0000005QXd01HJ=00701HJ=0030000000F6S@05QXd00H05QXd00<0000001HJ
=00F6S@01P000002024ZE@030000000Q:UD08BYE00L08BYE00<00000024ZE@0Q:UD02@0Q:UD00`00
0000e3dI024ZE@06024ZE@D000000P0Y=fl00`3D?AT0:CM_02TgK`0302TgK`030=@m6@0Y=fl0:CM_
00@0:CM_00<0e3dI02TgK`0Y=fl00P0Y=fl00`000000e3dI02TgK`0202TgK`040=@m6@0Y=fl0:CM_
02TgK`80e3dI00@0:CM_0000003om^h0?EV[2@3om^h00`0mFJ/0ooK^03eIZ`0503eIZ`030?ofkP0m
FJ/0?EV[00@0?EV[203om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00P0ooK^1P00
00050?ofkP0303eIZ`3om^h0ooK^0100ooK^0`0mFJ/50?ofkP030000003om^h0000005l0ooK^0@3o
ool001/0ooK^00<000000?ofkP3om^h0?P3om^h00`000000ooK^0?ofkP0L0?ofkP050=@m6@3om^h0
ooK^0?ofkP3D?AT00P3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00H0ooK^00D0e3dI0?ofkP3om^h0
ooK^0=@m6@090?ofkP040=@m6@3om^h0ooK^0=@m6@d0ooK^00<0e3dI0?ofkP3om^h02@00000300lB
8`030000000?4R<03a8S00<03a8S1`0000000`0F6S@0000001HJ=00701HJ=0030000000F6S@05QXd
00L05QXd00<0000001HJ=00F6S@0100F6S@5000000P08BYE00<00000024ZE@0Q:UD01`0Q:UD00`00
00008BYE024ZE@09024ZE@030=@m6@0Q:UD08BYE00H000000P0Y=fl00`000000:CM_02TgK`0202Tg
K`030=@m6@0Y=fl0:CM_0080:CM_00<0e3dI0000000Y=fl01P0Y=fl01P3D?AT0:CM_02TgK`0Y=fl0
e3dI000000<0:CM_00/0e3dI02TgK`0Y=fl0:CM_0=@m6@0Y=fl0e3dI02TgK`000000ooK^03eIZ`03
0?ofkPL0?EV[00<0ooK^03eIZ`0mFJ/0100mFJ/20?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[
0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP020?ofkPH000001@3om^h00`0mFJ/0ooK^0?ofkP03
0?ofkP0303eIZ`3om^h0ooK^00/0ooK^1P0mFJ/00`3om^h0?EV[0?ofkP040?ofkP030000003om^h0
000005l0ooK^0@3oool001/0ooK^00<000000?ofkP3om^h0?`3om^h00`000000ooK^0?ofkP0L0?of
kP040=@m6@3om^h0ooK^0=@m6@80ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP03
0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT0203om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00`0ooK^
00<0e3dI03eIZ`3D?AT0100000001@0?4R<000000000000?4R<0?EV[00<03a8S00@0000000lB8`0?
4R<03a8S1@00000601HJ=0030000000F6S@05QXd00D05QXd00<0000001HJ=00F6S@01`0F6S@00`00
00005QXd01HJ=005000000808BYE00<00000024ZE@0Q:UD0200Q:UD00`0000008BYE024ZE@07024Z
E@030000000Q:UD08BYE00L08BYE00<000000=@m6@0000000P00000802TgK`030000000Y=fl0:CM_
00<0:CM_00H0e3dI02TgK`0Y=fl0:CM_0=@m6@00000702TgK`060=@m6@0Y=fl0:CM_02TgK`3D?AT0
00000`0Y=fl01P3D?AT0:CM_02TgK`0Y=fl0e3dI02TgK`80e3dI00<0000003eIZ`0mFJ/00`0mFJ/3
0?ofkPD0?EV[2@3om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^00D0ooK^1@00000;
0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h01P3om^h503eIZ`H0ooK^0P0mFJ/5
0?ofkP030000003om^h0000005l0ooK^0@3oool001/0ooK^00<000000?ofkP3om^h0?`3om^h00`00
0000ooK^0?ofkP0L0?ofkP070=@m6@3om^h0ooK^0?ofkP3D?AT0ooK^0=@m6@040?ofkP030=@m6@3o
m^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3o
m^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h00`3om^h603eIZ`030=@m6@000000?EV[00@03a8S00<0
000000lB8`0?4R<00`0?4R<60000000301HJ=00000005QXd00L05QXd00<0000001HJ=00F6S@01P0F
6S@00`0000005QXd01HJ=00201HJ=0P000001`0Q:UD00`0000008BYE024ZE@07024ZE@030000000Q
:UD08BYE00P08BYE00@00000024ZE@0Q:UD08BYE1@0000030=@m6@030000000Y=fl0:CM_00P0:CM_
00<0000002TgK`0Y=fl00`0Y=fl0103D?AT0:CM_02TgK`3D?AT202TgK`030000000Y=fl0:CM_00@0
:CM_00H0e3dI02TgK`0Y=fl0:CM_0=@m6@00000402TgK`030=@m6@0Y=fl0e3dI0080:CM_00@00000
0=@m6@000000ooK^1`0mFJ/20?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h02@3o
m^h00`0mFJ/0ooK^00000005000000030?ofkP0mFJ/0ooK^00d0ooK^00<0?EV[0?ofkP3om^h0103o
m^h00`0mFJ/0ooK^0?ofkP0503eIZ`/0ooK^00<0?EV[0?ofkP0mFJ/01@3om^h2000005l0ooK^0@3o
ool001/0ooK^00<000000?ofkP3om^h0@03om^h00`000000ooK^0?ofkP0L0?ofkP060=@m6@3om^h0
ooK^0=@m6@3om^h0e3dI1@3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00D0ooK^00<0e3dI0?ofkP3o
m^h0103om^h00`3D?AT0ooK^0?ofkP020?ofkP0303eIZ`3D?AT0?EV[00@0?EV[0P3om^h203eIZ`03
0000003D?AT03a8S00@03a8S0P00000300lB8`D000001@0F6S@00`0000005QXd01HJ=00501HJ=003
0000000F6S@05QXd00@05QXd20000005024ZE@030000000Q:UD08BYE00L08BYE00<00000024ZE@0Q
:UD01`0Q:UD00`0000008BYE024ZE@06024ZE@H00000100Y=fl01@3D?AT0:CM_02TgK`0Y=fl0e3dI
00X0:CM_00<0000002TgK`0Y=fl00`0Y=fl00`3D?AT0:CM_0=@m6@0302TgK`030000000Y=fl0:CM_
00D0:CM_00D0e3dI02TgK`3D?AT0:CM_0000000302TgK`040000003D?AT000000=@m6@8000000P0_
@H8303eIZ`P0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP050?ofkPH000001`3o
m^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0403eIZ`3om^h0ooK^0?ofkPH0?EV[3@3om^h403eIZ`030?of
kP0mFJ/0ooK^00@0ooK^0P00001O0?ofkP40oooo000J0?ofkP030000003om^h0ooK^0480ooK^00<0
00000?ofkP3om^h06`3om^h0103D?AT0ooK^0?ofkP3om^h20=@m6@H0ooK^00@0e3dI0?ofkP3om^h0
e3dI1P3om^h00`3D?AT0ooK^0?ofkP020?ofkP0303eIZ`3D?AT0?EV[00<0?EV[0P3om^h00`3D?AT0
?EV[03eIZ`0403eIZ`8000001@0?4R<70000000301HJ=00000005QXd00H05QXd00<0000001HJ=00F
6S@01P0F6S@00`0000005QXd00000004000000808BYE00<00000024ZE@0Q:UD01`0Q:UD00`000000
8BYE024ZE@07024ZE@030000000Q:UD08BYE00P08BYE00<00000024ZE@0Q:UD01P00000202TgK`03
0000000Y=fl0:CM_00@0:CM_00<0e3dI02TgK`0Y=fl00P0Y=fl00`3D?AT0:CM_02TgK`0802TgK`03
0000000Y=fl0:CM_00@0:CM_0P3D?AT302TgK`030000000Y=fl0:CM_00D0:CM_00<0e3dI02TgK`3D
?AT01@000000100_@H80e3dI02m1PP3D?AT402m1PP80000000<0ooK^03eIZ`3om^h01P3om^h00`0m
FJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0000000D00000103om^h00`0mFJ/0ooK^0?ofkP060?of
kP0303eIZ`3om^h0ooK^00T0ooK^1`0mFJ/30?ofkP0303eIZ`3om^h0ooK^00L0ooK^1P0mFJ/30?of
kP0303eIZ`3om^h0?EV[00D0ooK^00<000000?ofkP000000GP3om^h10?ooo`006P3om^h00`000000
ooK^0?ofkP120?ofkP030000003om^h0ooK^01`0ooK^00<0e3dI0?ofkP3om^h00P3D?AT60?ofkP04
0=@m6@3om^h0ooK^0=@m6@H0ooK^00<0e3dI03eIZ`0mFJ/00P0mFJ/00`3D?AT0?EV[03eIZ`0503eI
Z`030=@m6@0mFJ/0?EV[0080ooK^0P0000000`0?4R<0e3dI00000006000000D05QXd00<0000001HJ
=00F6S@01@0F6S@00`0000005QXd01HJ=00401HJ=0D000001P0Q:UD00`0000008BYE024ZE@08024Z
E@030000000Q:UD08BYE00L08BYE00<00000024ZE@0Q:UD01P0Q:UD5000000P0:CM_00<0000002Tg
K`0Y=fl00P0Y=fl20=@m6@D0:CM_00<000000=@m6@0Y=fl0200Y=fl00`000000:CM_02TgK`0402Tg
K`030=@m6@0Y=fl0:CM_0080:CM_00@0000002TgK`0Y=fl0:CM_100000001@3D?AT000000=@m6@0_
@H80000000D0;d620P3D?AT302m1PP050=@m6@00000000000000000mFJ/01`3om^h00`0mFJ/0ooK^
0?ofkP050?ofkPH000002P3om^h00`0mFJ/0ooK^0?ofkP070?ofkP0403eIZ`3om^h0ooK^0?ofkPL0
?EV[103om^h00`0mFJ/0ooK^0?ofkP030?ofkP0403eIZ`3om^h0ooK^0?ofkPH0?EV[2@3om^h00`0m
FJ/0ooK^03eIZ`050?ofkP030000003om^h0000005h0ooK^0@3oool001X0ooK^00<000000?ofkP3o
m^h0@`3om^h00`000000ooK^0?ofkP0K0?ofkP80e3dI0P3om^h00`3D?AT0ooK^0?ofkP050?ofkP80
e3dI0P3om^h503eIZ`030?ofkP3D?AT0?EV[0080?EV[00<0e3dI03eIZ`0mFJ/00P0mFJ/30?ofkP04
03eIZ`3D?AT0ooK^0?ofkPD000000`0F6S@00`0000005QXd01HJ=00501HJ=0030000000F6S@05QXd
00H05QXd00<0000001HJ=000000010000002024ZE@030000000Q:UD08BYE00H08BYE00<00000024Z
E@0Q:UD0200Q:UD00`0000008BYE024ZE@07024ZE@030000000Q:UD08BYE00H000000P0Y=fl00`00
0000:CM_02TgK`0802TgK`050000000Y=fl0:CM_02TgK`3D?AT01`0Y=fl00`000000e3dI02TgK`08
02TgK`030000000Y=fl0:CM_00<0:CM_0P3D?AT202TgK`H000001@0_@H80103D?AT0;d6202m1PP00
000502m1PP80e3dI0`0_@H801@3D?AT00000000000000000?EV[00L0ooK^00<0?EV[0?ofkP3om^h0
1@0000050?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h01@3om^h603eIZ`/0ooK^
00@0?EV[0?ofkP3om^h0ooK^1P0mFJ/?0?ofkP0303eIZ`3om^h0?EV[00D0ooK^00<000000?ofkP00
0000GP3om^h10?ooo`006P3om^h00`000000ooK^0?ofkP140?ofkP030000003om^h0ooK^01/0ooK^
0P3D?AT00`3om^h0e3dI0=@m6@050?ofkP0303eIZ`3D?AT0e3dI0080?EV[00<0ooK^03eIZ`0mFJ/0
0`0mFJ/0103D?AT0?EV[03eIZ`3D?AT90?ofkP030=@m6@0mFJ/0000000L05QXd00<0000001HJ=00F
6S@01@0F6S@00`0000005QXd01HJ=00401HJ=0D000001P0Q:UD00`0000008BYE024ZE@07024ZE@03
0000000Q:UD08BYE00P08BYE00<00000024ZE@0Q:UD01@0Q:UD5000000P0:CM_00<0000002TgK`0Y
=fl0200Y=fl010000000:CM_02TgK`3D?AT802TgK`030000003D?AT0:CM_00P0:CM_00H0000002Tg
K`0Y=fl0:CM_0000003D?AT2000000050=@m6@000000;d6202m1PP000000200_@H80103D?AT0;d62
02m1PP00000502m1PP80e3dI100_@H82000000030=@m6@000000ooK^00<0ooK^1P00000:0?ofkP03
03eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h01@0mFJ/20?ofkP0303eIZ`3om^h0ooK^00X0
ooK^1P0mFJ/30?ofkP0303eIZ`3om^h0ooK^00l0ooK^00@0?EV[0?ofkP3om^h0?EV[103om^h00`00
0000ooK^0000001N0?ofkP40oooo000J0?ofkP030000003om^h0ooK^04@0ooK^00<000000?ofkP3o
m^h0703om^h0103D?AT0ooK^0?ofkP3D?AT703eIZ`030=@m6@0mFJ/0?EV[00H0?EV[00@0ooK^0=@m
6@3om^h0e3dI2P3om^h00`3D?AT05QXd01HJ=00501HJ=0030000000F6S@05QXd00D05QXd00<00000
01HJ=00000001@000002024ZE@030000000Q:UD08BYE00H08BYE00<00000024ZE@0Q:UD01`0Q:UD0
0`0000008BYE024ZE@07024ZE@030000000Q:UD08BYE00H000000P0Y=fl00`000000:CM_02TgK`08
02TgK`030000000Y=fl0:CM_00P0:CM_00<000000=@m6@3D?AT02@0Y=fl00`000000:CM_0=@m6@06
02TgK`H0000000D0e3dI02m1PP0_@H80;d620=@m6@0302m1PP030000000_@H80;d6200D0;d620P3D
?AT202m1PP030000000_@H80;d6200@0;d6200H0e3dI02m1PP0_@H80;d620000003J?1L7000000<0
ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP060?ofkPD0?EV[1`3om^h00`0mFJ/0
ooK^0?ofkP040?ofkPH0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^0100
ooK^00<0?EV[0?ofkP0mFJ/01@3om^h2000005h0ooK^0@3oool001T0ooK^00<000000?ofkP3om^h0
AP3om^h00`000000ooK^0?ofkP0H0?ofkP<0?EV[0P3D?AT00`0mFJ/0e3dI0=@m6@0603eIZ`80e3dI
0P0mFJ/50?ofkP0303eIZ`3D?AT0e3dI00P0ooK^0`0mFJ/701HJ=0030000000F6S@05QXd00<05QXd
1@000007024ZE@030000000Q:UD08BYE00H08BYE00<00000024ZE@0Q:UD01`0Q:UD00`0000008BYE
024ZE@06024ZE@D00000200Y=fl00`000000:CM_02TgK`0802TgK`030000000Y=fl0:CM_00P0:CM_
00<0e3dI02TgK`0Y=fl02@0Y=fl00`000000:CM_0=@m6@0600000080;d6200@0000002m1PP0_@H80
e3dI100_@H801@3D?AT0;d6202m1PP0_@H80000000L0;d6200D0e3dI02m1PP3D?AT0;d6200000006
02m1PP030=@m6@000000000000H0000000<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP0:
0?ofkP0303eIZ`3om^h0ooK^00D0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP070?ofkPH0?EV[203om^h0
0`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^0100ooK^00<0?EV[0?ofkP0mFJ/01@3om^h2
000005h0ooK^0@3oool001T0ooK^00<000000?ofkP3om^h0AP3om^h00`000000ooK^0?ofkP0B0?of
kPH0?EV[0P3om^h203eIZ`@0e3dI100mFJ/20?ofkP80e3dI00<0?EV[0?ofkP3om^h00`3om^h0100m
FJ/0ooK^0?ofkP3D?AT30?ofkPH0?EV[00<0000001HJ=00F6S@01@0F6S@00`0000005QXd00000004
000000808BYE00<00000024ZE@0Q:UD01`0Q:UD00`0000008BYE024ZE@06024ZE@030000000Q:UD0
8BYE00L08BYE00<00000024ZE@0Q:UD01P00000202TgK`030000000Y=fl0:CM_00P0:CM_00<00000
02TgK`0Y=fl0200Y=fl00`000000:CM_02TgK`0702TgK`030=@m6@000000:CM_00P0:CM_1@000000
0`3D?AT0;d6202m1PP0502m1PP030000000_@H80e3dI00H0;d6200@0e3dI02m1PP0_@H8000001P0_
@H801P3D?AT0;d6202m1PP3D?AT0;d6200000080;d621@00000302m1PP060000003J?1L0fS`G0000
003D?AT000001`3om^h00`0mFJ/0ooK^0?ofkP070?ofkPH0?EV[203om^h0100mFJ/0ooK^0?ofkP3o
m^h703eIZ`d0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0303eIZ`3o
m^h0?EV[00D0ooK^00<000000?ofkP000000G@3om^h10?ooo`006@3om^h00`000000ooK^0?ofkP17
0?ofkP030000003om^h0ooK^00/0ooK^1P0mFJ/30?ofkPP0?EV[103D?AT50?ofkP030=@m6@3om^h0
e3dI0080?EV[0`3om^h00`0mFJ/0ooK^03eIZ`020=@m6@D0?EV[0P3om^h00`0000005QXd01HJ=002
01HJ=0030=@m6@000000000000<000001P0Q:UD00`0000008BYE024ZE@07024ZE@030000000Q:UD0
8BYE00L08BYE00<00000024ZE@0Q:UD01@0Q:UD5000000P0:CM_00<0000002TgK`0Y=fl0200Y=fl0
0`000000:CM_02TgK`0802TgK`030000000Y=fl0:CM_00D0:CM_0P3D?AT00`0Y=fl0000002TgK`02
02TgK`H000000P0_@H8010000000;d6202m1PP3D?AT702m1PP030000003D?AT0;d6200H0;d6200@0
e3dI02m1PP0_@H8000001P0_@H800`3D?AT0;d6200000005000000<0;d6200<0e3dI02m1PP3D?AT0
0P0_@H801P000000fS`G0=Xl5`000000e3dI000000L0ooK^00@0?EV[0?ofkP3om^h0ooK^1P0mFJ/3
0?ofkP0303eIZ`3om^h0ooK^00H0ooK^1P0mFJ/60?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[
0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0403eIZ`3om^h0ooK^03eIZ`@0ooK^00<0
00000?ofkP000000G@3om^h10?ooo`006@3om^h00`000000ooK^0?ofkP180?ofkP030000003om^h0
ooK^00D0ooK^1`0mFJ/20?ofkPL0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP030=@m6@030?ofkP3D?AT0
ooK^00<0ooK^00@0e3dI0?ofkP3D?AT0ooK^1`0mFJ/20=@m6@0303eIZ`3om^h0ooK^00<0ooK^00<0
000001HJ=0000000100000000`0Q:UD00000024ZE@08024ZE@030000000Q:UD08BYE00L08BYE00<0
0000024ZE@0Q:UD01P0Q:UD00`0000008BYE024ZE@0600000080:CM_00<0000002TgK`0Y=fl0200Y
=fl00`000000:CM_02TgK`0802TgK`030000000Y=fl0:CM_00P0:CM_00<0000002TgK`0Y=fl0100Y
=fl00`3D?AT0:CM_00000005000000P0;d6200D0000002m1PP0_@H80;d620=@m6@0602m1PP030000
003D?AT0;d6200L0;d6200<0e3dI02m1PP0000000P0_@H8600000080;d6200<0e3dI0000000_@H80
100_@H800`3D?AT0;d620=@m6@0202m1PP030000003J?1L0fS`G00<0000000@0?EV[0?ofkP3om^h0
ooK^1`0mFJ/90?ofkP0303eIZ`3om^h0ooK^00H0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP070?ofkP03
03eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP04
03eIZ`3om^h0ooK^03eIZ`@0ooK^00<000000?ofkP000000G@3om^h10?ooo`00603om^h00`000000
ooK^0?ofkP190?ofkP030000003om^h0ooK^00D0?EV[0`3om^h703eIZ`<0ooK^0P0mFJ/40?ofkP04
03eIZ`3om^h0ooK^0?ofkP80e3dI00<0ooK^0=@m6@3om^h00`0mFJ/0103D?AT0?EV[03eIZ`3D?AT5
03eIZ`050?ofkP3D?AT0ooK^0?ofkP3D?AT0103om^h3000000H08BYE00<00000024ZE@0Q:UD01P0Q
:UD00`0000008BYE024ZE@08024ZE@030000000Q:UD08BYE00@08BYE1@00000802TgK`030000000Y
=fl0:CM_00P0:CM_00<0000002TgK`0Y=fl0200Y=fl00`000000:CM_02TgK`0802TgK`030000000Y
=fl0:CM_008000000`3D?AT010000000;d6202m1PP00000;02m1PP050000000_@H80;d6202m1PP3D
?AT01P0_@H800`3D?AT0;d6202m1PP0602m1PPH000000`0_@H800`3D?AT0;d6202m1PP0202m1PP03
0=@m6@000000;d6200@0;d6200<0e3dI02m1PP3D?AT00`0000020=Xl5`<00000100mFJ/30?ofkP03
03eIZ`3om^h0ooK^00L0ooK^1P0mFJ/80?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3o
m^h02`3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00l0ooK^100mFJ/40?ofkP03
0000003om^h0000005d0ooK^0@3oool001P0ooK^00<000000?ofkP3om^h0A`3om^h503eIZ`<0ooK^
1`0mFJ/:0?ofkP0403eIZ`3om^h0ooK^03eIZ`80ooK^0P0mFJ/01@3D?AT0?EV[0=@m6@0mFJ/0e3dI
00<0?EV[00@0e3dI03eIZ`0mFJ/0e3dI0P3om^h203eIZ`80ooK^00@0e3dI0?ofkP3om^h0e3dI0`3o
m^h00`0000008BYE024ZE@06024ZE@030000000Q:UD08BYE00L08BYE00<00000024ZE@0Q:UD01`0Q
:UD00`0000008BYE024ZE@0500000080:CM_00<0000002TgK`0Y=fl0200Y=fl00`000000:CM_02Tg
K`0702TgK`030000000Y=fl0:CM_00T0:CM_00<0000002TgK`0Y=fl01P0Y=fl500000080e3dI0`0_
@H80103D?AT0;d6202m1PP00000;02m1PP050000000_@H80;d6202m1PP3D?AT01@0_@H800`3D?AT0
000002m1PP0202m1PPD0000000@0;d620=@m6@0_@H800000100_@H800`3D?AT0;d6202m1PP0402m1
PP030=@m6@0_@H80;d6200<0000000H0e3dI000000000000e3dI03A9T@0000020=Xl5`@000001P3o
m^h0100mFJ/0ooK^0?ofkP3om^h603eIZ`@0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^
0?ofkP080?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^
0?ofkP080?ofkPP0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP800000G@3om^h10?ooo`00603o
m^h00`000000ooK^0?ofkP130?ofkP@0?EV[0P3om^h903eIZ`h0ooK^1P0mFJ/00`3om^h0?EV[03eI
Z`040=@m6@<0ooK^00H0e3dI0?ofkP3om^h0ooK^0=@m6@3om^h203eIZ`80ooK^00D0e3dI0?ofkP3o
m^h0ooK^0=@m6@020?ofkP030000000Q:UD08BYE00H08BYE00<00000024ZE@0Q:UD01`0Q:UD00`00
00008BYE024ZE@05024ZE@D000001`0Y=fl00`000000:CM_02TgK`0802TgK`030000000Y=fl0:CM_
00L0:CM_00<0000002TgK`0Y=fl02@0Y=fl00`000000:CM_02TgK`0600000080;d6200<000000=@m
6@3D?AT01@0_@H80103D?AT0;d6202m1PP00000;02m1PP030000000_@H80;d620080;d6200@0e3dI
02m1PP0_@H80;d621P00000702m1PP030=@m6@000000;d620080;d6200<0e3dI02m1PP0_@H800`0_
@H82000000030=@m6@00000000000080=4VA00H0e3dI03A9T@0dBI40=4VA0=@m6@0dBI4200000003
0=Xl5`0000000000008000000`3om^h703eIZ`X0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0
ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h0103om^h0100mFJ/0
ooK^0?ofkP3om^h703eIZ`L0ooK^00@0?EV[0?ofkP3om^h0?EV[1@3om^h2000005d0ooK^0@3oool0
01P0ooK^00<000000?ofkP3om^h0@@3om^h<03eIZ`<0ooK^00<0?EV[0?ofkP3om^h0203om^h503eI
Z`030?ofkP0mFJ/0?EV[00@0?EV[0`3om^h40=@m6@80ooK^00H0e3dI0?ofkP3om^h0ooK^0=@m6@0m
FJ/20?ofkP0303eIZ`3om^h0e3dI00<0ooK^00<0e3dI0?ofkP000000200Q:UD00`0000008BYE024Z
E@07024ZE@030000000Q:UD08BYE00H000000P0Y=fl00`000000:CM_02TgK`0702TgK`030000000Y
=fl0:CM_00L0:CM_00<0000002TgK`0Y=fl0200Y=fl00`000000:CM_02TgK`0702TgK`D000001`0_
@H820=@m6@P0;d6200<0e3dI02m1PP0000002`0_@H800`000000;d6202m1PP0600000080;d6200<0
000002m1PP0_@H80200_@H800`3D?AT0000002m1PP0202m1PP030=@m6@000000000000<000000P0d
BI400`3D?AT0=4VA03A9T@0203A9T@030=@m6@0dBI40=4VA0080=4VA00D0e3dI0?m870000000fS`G
0000000603eIZ`<0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eI
Z`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h02`3om^h0100mFJ/0ooK^0?ofkP3om^h703eIZ`l0
ooK^00<0?EV[0?ofkP0mFJ/01@3om^h00`000000ooK^0000001L0?ofkP40oooo000H0?ofkP030000
003om^h0ooK^03l0ooK^100mFJ/80?ofkP80?EV[0`3om^h00`0mFJ/0ooK^0?ofkP030?ofkPD0?EV[
00<0ooK^03eIZ`0mFJ/0100mFJ/20?ofkP0303eIZ`3om^h0ooK^00<0ooK^0P3D?AT01@3om^h0e3dI
0=@m6@3om^h0e3dI00@0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@050?ofkP030=@m6@0Q:UD08BYE
00L08BYE00<00000024ZE@0Q:UD01@0Q:UD5000000P0:CM_00<0000002TgK`0Y=fl01`0Y=fl00`00
0000:CM_02TgK`0702TgK`030000000Y=fl0:CM_00P0:CM_00@0000002TgK`0Y=fl0:CM_1P000002
02m1PP030000000_@H80;d6200D0;d620P3D?AT00`0_@H80000002m1PP0702m1PP030=@m6@0_@H80
000000P0;d621P00000302m1PP80e3dI0`0_@H800`000000;d6202m1PP0702m1PP030000003D?AT0
00000080000000<0e3dI03A9T@0dBI401P0dBI400`000000e3dI03A9T@0203A9T@030=@m6@0dBI40
=4VA0080=4VA00<0e3dI03eIZ`0mFJ/00P0mFJ/0103J?1L000000:P]400000050?ofkP0303eIZ`3o
m^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3o
m^h0ooK^00P0ooK^1P0mFJ/30?ofkP0303eIZ`3om^h0ooK^0100ooK^00@0?EV[0?ofkP3om^h0?EV[
103om^h00`000000ooK^0000001L0?ofkP40oooo000G0?ofkP030000003om^h0ooK^03l0ooK^00<0
?EV[0?ofkP3om^h0303om^h0100mFJ/0ooK^03eIZ`3om^h503eIZ`80ooK^100mFJ/50?ofkP0503eI
Z`3om^h0ooK^0?ofkP0mFJ/01@3om^h20=@m6@040?ofkP3D?AT0e3dI0=@m6@@0ooK^00H0e3dI0?of
kP3om^h0ooK^0=@m6@0mFJ/20?ofkP<0?EV[00<0e3dI024ZE@0Q:UD01@0Q:UD00`0000008BYE024Z
E@0600000080:CM_00<0000002TgK`0Y=fl01`0Y=fl00`000000:CM_02TgK`0702TgK`030000000Y
=fl0:CM_00P0:CM_00<0000002TgK`0Y=fl01P0Y=fl6000000P0;d6200<0000002m1PP0_@H800`0_
@H820=@m6@<0;d6200<0000002m1PP0_@H801P0_@H800`3D?AT0;d620000000302m1PPD000000`0_
@H800`000000;d6202m1PP0302m1PP030=@m6@0_@H80;d620080;d6200@0000002m1PP0_@H80;d62
1P00000203A9T@040=@m6@0dBI40=4VA0=@m6@L0=4VA00<0000003A9T@3D?AT00P0dBI400`3D?AT0
=4VA03A9T@0303A9T@030000003oB1`0odPL0080000000@0fS`G0000002X;A0000001@3om^h00`0m
FJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h0203om^h0100m
FJ/0ooK^0?ofkP3om^h703eIZ`80ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0@
0?ofkP0403eIZ`3om^h0ooK^03eIZ`@0ooK^00<000000?ofkP000000G03om^h10?ooo`005`3om^h0
0`000000ooK^0?ofkP0n0?ofkP0303eIZ`3om^h0ooK^00`0ooK^1@0mFJ/20?ofkPD0?EV[2@3om^h0
0`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h00P3D?AT3
0?ofkP0303eIZ`3om^h0e3dI0080?EV[00H0e3dI03eIZ`0mFJ/0?EV[0?ofkP000007024ZE@D00000
200Y=fl00`000000:CM_02TgK`0702TgK`030000000Y=fl0:CM_00L0:CM_00<0000002TgK`0Y=fl0
200Y=fl00`000000:CM_02TgK`0600000080;d6200<0000002m1PP0_@H802@0_@H8010000000;d62
02m1PP0_@H820=@m6@D0;d6200<0000002m1PP0_@H801P0_@H86000000P0;d6200@0000002m1PP0_
@H80;d620`3D?AT202m1PPH00000200dBI400`3D?AT0=4VA0=@m6@0803A9T@030000000dBI40e3dI
0080=4VA00<0e3dI03A9T@0dBI400`0dBI401P000000odPL0?m8703oB1`000000=Xl5`<000001@3o
m^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h01P3o
m^h603eIZ`T0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP@0?EV[0P3o
m^h00`0mFJ/0ooK^0?ofkP020?ofkP030000003om^h0000005`0ooK^0@3oool001L0ooK^00<00000
0?ofkP3om^h0?@3om^h00`0mFJ/0ooK^0?ofkP080?ofkPD0?EV[0P3om^h00`0mFJ/0ooK^03eIZ`02
03eIZ`d0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP030?ofkP80e3dI00@0ooK^
0=@m6@3D?AT0e3dI100mFJ/0103D?AT0ooK^0?ofkP3D?AT403eIZ`030000000Q:UD0000000D00000
0P0Y=fl00`000000:CM_02TgK`0702TgK`030000000Y=fl0:CM_00P0:CM_00<0000002TgK`0Y=fl0
1`0Y=fl00`000000:CM_02TgK`0602TgK`D00000200_@H800`000000;d6202m1PP0902m1PP040000
000_@H80e3dI0=@m6@L0;d6200<0000002m1PP0_@H801P0000000`0_@H80e3dI0000000;02m1PP04
0000000_@H80;d620=@m6@<0000000D0e3dI0000000dBI40=4VA0000000;03A9T@030000003D?AT0
e3dI00P0=4VA00H0000003A9T@0dBI40e3dI03A9T@3D?AT503A9T@060000003oB1`0odPL0?m87000
0000fS`G0`0000000`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?of
kP3om^h01`3om^h0100mFJ/0ooK^0?ofkP3om^h503eIZ`80ooK^00<0?EV[0?ofkP3om^h02`3om^h0
0`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00H0ooK^1P0mFJ/30?ofkP0403eIZ`3om^h0
ooK^03eIZ`D0ooK^0P00001L0?ofkP40oooo000G0?ofkP030000003om^h0ooK^03d0ooK^00<0?EV[
0?ofkP3om^h00`3om^h503eIZ`H0ooK^00D0?EV[0?ofkP000000ooK^03eIZ`0>0?ofkP0303eIZ`3o
m^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h00`3om^h01P3D?AT0?EV[03eIZ`3D?AT0?EV[0=@m6@@0
?EV[0P3D?AT30?ofkP0403eIZ`0000000000000000P0:CM_00<0000002TgK`0Y=fl01`0Y=fl00`00
0000:CM_02TgK`0802TgK`030000000Y=fl0:CM_00L0:CM_00<0000002TgK`0Y=fl01P00000202m1
PP030000000_@H80;d6200P0;d6200<0000002m1PP0_@H80200_@H830=@m6@H0;d621P00000802m1
PP030=@m6@0_@H80;d6200L0;d62100000000`3D?AT0=4VA03A9T@0203A9T@050=@m6@0dBI40=4VA
03A9T@0000002`0dBI400`000000e3dI03A9T@0803A9T@060000000dBI40=4VA0=@m6@0dBI40e3dI
1@0dBI4020000000odPL0?m8703oB1`000000=Xl5`000000fS`G0P0000050?ofkP0303eIZ`3om^h0
ooK^00/0ooK^00<0?EV[0?ofkP3om^h01@3om^h603eIZ`L0ooK^00<0?EV[0?ofkP3om^h02`3om^h0
0`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00H0?EV[2@3om^h0100mFJ/0ooK^0?ofkP0m
FJ/50?ofkP800000G03om^h10?ooo`005P3om^h00`000000ooK^0?ofkP0m0?ofkP0303eIZ`3om^h0
?EV[00@0?EV[2`3om^h00`0mFJ/0ooK^000000020?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[
0?ofkP3om^h0103om^h603eIZ`80e3dI00@0?EV[0=@m6@3D?AT0?EV[0P3D?AT20?ofkP80e3dI0`3o
m^h00`0mFJ/0000002TgK`0802TgK`030000000Y=fl0:CM_00P0:CM_00<0000002TgK`0Y=fl01`0Y
=fl00`000000:CM_02TgK`0602TgK`D00000200_@H800`000000;d6202m1PP0802m1PP030000000_
@H80;d6200D0;d620`3D?AT0100_@H80e3dI02m1PP0_@H85000000<0;d6200<0000002m1PP0_@H80
200_@H80103D?AT0;d6202m1PP0_@H8600000080=4VA0P3D?AT503A9T@050=@m6@0dBI40=4VA03A9
T@0000002`0dBI420=@m6@T0=4VA00D0000003A9T@0dBI40=4VA0=@m6@0503A9T@030000003oB1`0
odPL0080odPL00@000000=Xl5`000000fS`G0P0000050?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0
?EV[0?ofkP3om^h01@0mFJ/20?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h02`3o
m^h0100mFJ/0ooK^0?ofkP3om^h603eIZ`l0ooK^00@0?EV[0?ofkP3om^h0?EV[1@3om^h00`000000
ooK^0000001K0?ofkP40oooo000F0?ofkP030000003om^h0ooK^03`0ooK^0`0mFJ/?0?ofkP0503eI
Z`3om^h0ooK^0?ofkP0000000P3om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^00/0
?EV[00L0ooK^0=@m6@3D?AT0ooK^0=@m6@3om^h0?EV[00<0e3dI00<0ooK^0=@m6@3om^h00`3om^h0
0`000000:CM_02TgK`0702TgK`030000000Y=fl0:CM_00P0:CM_00<0000002TgK`0Y=fl01`0Y=fl0
0`000000:CM_02TgK`0600000080;d6200<0000002m1PP0_@H80200_@H800`000000;d6202m1PP08
02m1PP030000000_@H80;d6200<0;d620P3D?AT00`0_@H80000000000004000000P0;d6200<00000
02m1PP0_@H801P0_@H83000000030=@m6@000000000000L0=4VA00<0e3dI0000000dBI401P0dBI40
103D?AT0=4VA03A9T@00000:03A9T@040=@m6@0dBI40=4VA0=@m6@P0=4VA00D0000003A9T@0dBI40
=4VA0=@m6@0503A9T@030000003oB1`0odPL0080odPL0`0000020=Xl5`030000003om^h0ooK^00<0
ooK^00<0?EV[0?ofkP3om^h0203om^h603eIZ`L0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0
ooK^0?ofkP080?ofkPH0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0303eIZ`3om^h0?EV[00D0
ooK^00<000000?ofkP000000F`3om^h10?ooo`005P3om^h00`000000ooK^0?ofkP0k0?ofkP0303eI
Z`3om^h0ooK^0100ooK^00D0?EV[0?ofkP3om^h0ooK^000000030?ofkP0303eIZ`3om^h0ooK^00H0
ooK^2@0mFJ/40?ofkP0303eIZ`3om^h0ooK^0080ooK^00H0e3dI0?ofkP3D?AT0e3dI03eIZ`3D?AT2
0?ofkP<0e3dI0P3om^h00`000000:CM_02TgK`0802TgK`030000000Y=fl0:CM_00L0:CM_00<00000
02TgK`0Y=fl01P0Y=fl5000000P0;d6200<0000002m1PP0_@H80200_@H800`000000;d6202m1PP09
02m1PP030000000_@H80000000D000000`0_@H800`000000e3dI02m1PP0802m1PP030000000_@H80
;d6200H000000P0dBI400`000000e3dI03A9T@0703A9T@030=@m6@0dBI40000000L0=4VA00@0e3dI
03A9T@0dBI4000002@0dBI401@3D?AT0000003A9T@0dBI40e3dI00L0=4VA00@0000003A9T@0dBI40
=4VA0P3D?AT503A9T@060000003oB1`0odPL0?m870000000odPL0P0000020=Xl5`800000103om^h0
0`0mFJ/0ooK^0?ofkP020?ofkPH0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0
ooK^00P0ooK^00<0?EV[0?ofkP3om^h00`3om^h503eIZ`80ooK^00<0?EV[0?ofkP3om^h0103om^h0
0`0mFJ/0ooK^0?ofkP0@0?ofkP0403eIZ`3om^h0ooK^03eIZ`@0ooK^00<000000?ofkP000000F`3o
m^h10?ooo`005P3om^h00`000000ooK^0?ofkP0k0?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[
0?ofkP3om^h00`3om^h01@000000ooK^0?ofkP3om^h0?EV[0080ooK^200mFJ/:0?ofkP0303eIZ`3o
m^h0ooK^0080ooK^103D?AT00`0mFJ/0ooK^0=@m6@020?ofkP@0e3dI00<0000002TgK`0Y=fl0200Y
=fl00`000000:CM_02TgK`0702TgK`030000000Y=fl0:CM_00H000000P0_@H800`000000;d6202m1
PP0802m1PP030000000_@H80;d6200P0;d6200<0000002m1PP0_@H801@0_@H86000000T0;d6200<0
000002m1PP3D?AT01P0_@H85000000P0=4VA00<000000=@m6@0dBI401@0dBI420=@m6@80=4VA00<0
000003A9T@0dBI401P0dBI400`3D?AT0=4VA0000000803A9T@030=@m6@0dBI4000000080=4VA00<0
e3dI03A9T@0dBI401@0dBI401`000000=4VA03A9T@0dBI40e3dI03A9T@3D?AT00P0dBI43000000<0
odPL00@000000?m87000000000000P3J?1L2000000<0ooK^1P0mFJ/90?ofkP0303eIZ`3om^h0ooK^
00P0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^03eIZ`0303eIZ`L0ooK^00<0?EV[0?of
kP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0403eIZ`3om^h0ooK^03eIZ`@0ooK^00<00000
0?ofkP000000F`3om^h10?ooo`005P3om^h00`000000ooK^0?ofkP0j0?ofkP0303eIZ`3om^h0ooK^
0100ooK^00<0?EV[0?ofkP3om^h0103om^h803eIZ`@0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0m
FJ/0ooK^0?ofkP020?ofkP060=@m6@3om^h0e3dI0=@m6@3om^h0e3dI0P3om^h0103D?AT0ooK^0=@m
6@3om^h20=@m6@P0:CM_00<0000002TgK`0Y=fl01P0Y=fl30000000303eIZ`000000;d6200L0;d62
00<0000002m1PP0_@H80200_@H800`000000;d6202m1PP0802m1PP030000000_@H80;d6200D00000
00D0;d620=@m6@3D?AT0;d620000000:02m1PP030000000_@H80e3dI00H000000P0dBI400`000000
=4VA03A9T@0803A9T@030000000dBI40e3dI00@0=4VA00<0e3dI03A9T@0dBI400P0dBI400`000000
=4VA03A9T@0603A9T@030=@m6@0dBI40000000L0=4VA00@0e3dI03A9T@0dBI4000000`0dBI400`3D
?AT0=4VA03A9T@0403A9T@040000000dBI40=4VA0=@m6@80000000<0e3dI0000000000000P0hCid0
1P000000odPL0?m8703oB1`000000?m8708000000P3J?1L2000000<0?EV[00<0ooK^03eIZ`3om^h0
3@3om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00D0ooK^1@0mFJ/;0?ofkP0303eI
Z`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h0403om^h0100mFJ/0ooK^0?ofkP0mFJ/50?ofkP80
0000F`3om^h10?ooo`005@3om^h00`000000ooK^0?ofkP0k0?ofkP0303eIZ`3om^h0ooK^00l0ooK^
00<0?EV[0?ofkP3om^h01@0mFJ/00`000000ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00@0ooK^
00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP<0e3dI00/0?EV[0=@m6@3om^h0
e3dI0?ofkP3D?AT0ooK^0=@m6@3om^h0000002TgK`020=@m6@H0:CM_00<0000002TgK`0Y=fl01P00
000202m1PP030000000_@H80;d6200P0;d6200<0000002m1PP0_@H80200_@H800`000000;d6202m1
PP0502m1PPH000000`0_@H830=@m6@<0;d6200<0000002m1PP0_@H801P0_@H85000000030=@m6@0d
BI40=4VA00D0=4VA00<0000003A9T@0dBI40200dBI400`000000=4VA0=@m6@0303A9T@030=@m6@0d
BI40=4VA0080=4VA00<0000003A9T@0dBI401`0dBI400`3D?AT0=4VA0000000603A9T@050=@m6@0d
BI40=4VA03A9T@0000000`0dBI400`3D?AT0=4VA03A9T@0203A9T@@0000000D0e3dI03Q?W@0hCid0
>4nM0=@m6@0403Q?W@8000000P3oB1`010000000odPL0?m8700000020=Xl5`800000103om^h00`0m
FJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h01@0mFJ/30?of
kP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0?0?of
kP@0?EV[1@3om^h2000005/0ooK^0@3oool001D0ooK^00<000000?ofkP3om^h0>P3om^h00`0mFJ/0
ooK^0?ofkP0=0?ofkPH0?EV[1P3om^h01@000000ooK^0?ofkP3om^h0?EV[00H0ooK^00<0?EV[0?of
kP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP020?ofkP80e3dI00@0?EV[0=@m6@3om^h0ooK^0P3D?AT2
0?ofkP030=@m6@0Y=fl0:CM_0080:CM_103D?AT5000000P0;d6200<0000002m1PP0_@H80200_@H80
0`000000;d6202m1PP0802m1PP030000000_@H80000000D000000`0_@H800`000000;d620=@m6@03
0=@m6@H0;d6200<0000002m1PP0_@H801P00000203A9T@040000000dBI40=4VA0=@m6@L0=4VA00<0
000003A9T@0dBI40200dBI400`000000=4VA03A9T@030=@m6@D0=4VA00<0000003A9T@0dBI40200d
BI400`3D?AT0000003A9T@0503A9T@050=@m6@0dBI40=4VA03A9T@0000000P0dBI400`000000e3dI
0000000300000080>4nM00<0000003Q?W@3D?AT00`0hCid01`3D?AT0>4nM03Q?W@0hCid000000?m>
7`0000000P3oB1`010000000odPL0?m8700000020=Xl5`<00000103om^h00`0mFJ/0ooK^0?ofkP0;
0?ofkP0303eIZ`3om^h0ooK^00D0ooK^1@0mFJ/80?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[
0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP080?ofkPP0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP03
0?ofkP030000003om^h0000005X0ooK^0@3oool001D0ooK^00<000000?ofkP3om^h0>P3om^h00`0m
FJ/0ooK^0?ofkP070?ofkPH0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP070?ofkP050000003om^h0ooK^
0?ofkP0mFJ/01@3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00<0ooK^0P3D?AT0
0`3om^h0e3dI0?ofkP020=@m6@80ooK^00<0e3dI02TgK`0Y=fl0100000000`3D?AT000000=@m6@04
0=@m6@P0;d6200<0000002m1PP0_@H80200_@H800`000000;d6202m1PP0402m1PPH000001@0_@H86
0=@m6@80;d6200<0e3dI02m1PP0_@H800`0_@H85000000P0=4VA00D0000003A9T@0dBI40=4VA0=@m
6@0603A9T@030000000dBI40=4VA00P0=4VA00@0000003A9T@0dBI40e3dI1`0dBI400`000000=4VA
03A9T@0803A9T@030=@m6@000000=4VA00@0=4VA00<0e3dI03A9T@0dBI401@00000203Q?W@030=@m
6@0hCid0>4nM00<0>4nM00<000000=@m6@0hCid0100hCid01P3D?AT0>4nM03Q?W@000000odhO0000
0080odPL00H000000?m8703oB1`000000=Xl5`3D?AT3000000@0ooK^00<0?EV[0?ofkP3om^h02`3o
m^h00`0mFJ/0ooK^03eIZ`0503eIZ`80ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?of
kP0;0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00@0?EV[0?ofkP3om^h0ooK^1`0mFJ/80?ofkP0303eI
Z`3om^h0?EV[00D0ooK^00<000000?ofkP000000FP3om^h10?ooo`005@3om^h00`000000ooK^0?of
kP0i0?ofkP0403eIZ`3om^h0ooK^0?ofkPL0?EV[2@3om^h00`0mFJ/0ooK^0?ofkP070?ofkP030000
003om^h0ooK^0080ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0?0?ofkP0303eIZ`3om^h0ooK^0080
ooK^0P3D?AT0103om^h0e3dI0?ofkP3om^h20=@m6@0403eIZ`000000e3dI000000@0;d6200D0e3dI
02m1PP0_@H80;d620000000202m1PPH0e3dI0P0_@H800`000000;d6202m1PP0802m1PPL00000100_
@H800`000000e3dI0=@m6@040=@m6@@0;d6200H0000002m1PP0_@H80;d620000003D?AT400000080
=4VA00<0000003A9T@0dBI40200dBI401@000000=4VA03A9T@0dBI40e3dI00H0=4VA00<0000003A9
T@0dBI40200dBI4010000000e3dI0=@m6@3D?AT703A9T@030000000dBI40=4VA00P0=4VA00@0e3dI
0000000dBI40=4VA0P000000103D?AT0000000000000000203Q?W@030000000hCid0>4nM0080>4nM
00<0e3dI03Q?W@0hCid00P0hCid00`000000e3dI03Q?W@0503Q?W@040=@m6@0hCid0>4nM00000080
odhO0P0000030?m87080000000@0e3dI0=Xl5`0000000000103om^h00`0mFJ/0ooK^0?ofkP070?of
kPH0?EV[203om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?of
kP3om^h00P3om^h603eIZ`l0ooK^00<0?EV[0?ofkP0mFJ/01@3om^h00`000000ooK^0000001J0?of
kP40oooo000D0?ofkP030000003om^h0ooK^03X0ooK^100mFJ/?0?ofkP0303eIZ`3om^h0ooK^00T0
ooK^00D000000?ofkP3om^h0ooK^03eIZ`030?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?of
kP3om^h00P3om^h00`0mFJ/0e3dI0=@m6@020=@m6@80?EV[00D0e3dI0?ofkP000000;d620=@m6@05
02m1PP040=@m6@0_@H80;d62000000P0;d622@3D?AT5000000/0e3dI200_@H860000000303A9T@3D
?AT0=4VA00D0=4VA00<0000003A9T@0dBI40200dBI400`000000=4VA03A9T@0203A9T@030=@m6@0d
BI40=4VA00<0=4VA00<0000003A9T@0dBI401`0dBI420=@m6@<0=4VA00<0e3dI03A9T@0dBI40100d
BI400`000000=4VA03A9T@0703A9T@80000000D0e3dI000000000000>4nM0=@m6@0603Q?W@030000
000hCid0>4nM0080>4nM00<0e3dI03Q?W@0hCid00P0hCid00`3D?AT0>4nM03Q?W@0503Q?W@040=@m
6@0hCid0>4nM00000080odhO0P0000020?m870040000003oB1`0000000000080fS`G00<000000=@m
6@3om^h00P3om^h0100mFJ/0ooK^0?ofkP3om^h603eIZ`D0ooK^00<0?EV[0?ofkP3om^h01`3om^h0
0`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00X0ooK^1@0mFJ/20?ofkP0303eIZ`3om^h0
ooK^0100ooK^00@0?EV[0?ofkP3om^h0?EV[103om^h00`000000ooK^0000001J0?ofkP40oooo000D
0?ofkP030000003om^h0ooK^03X0ooK^00<0?EV[0?ofkP3om^h0403om^h00`0mFJ/0ooK^0?ofkP0:
0?ofkP050000003om^h0ooK^0?ofkP0mFJ/00P3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkPL0?EV[0P3D
?AT01`3om^h0e3dI0=@m6@3om^h0e3dI0?ofkP0000001`0_@H80103D?AT0;d6202m1PP00000:02m1
PPL00000100_@H800`000000;d6202m1PP0502m1PP040=@m6@0_@H80;d6200000080;d621P000002
03A9T@030000000dBI40=4VA00<0=4VA00<0e3dI03A9T@0dBI400`0dBI400`000000=4VA03A9T@08
03A9T@030000000dBI40=4VA0080=4VA00<0e3dI03A9T@0dBI400`0dBI400`000000=4VA03A9T@05
03A9T@80e3dI00<0=4VA0000000dBI400P0dBI400`3D?AT0=4VA03A9T@0403A9T@040000000dBI40
=4VA03A9T@H000000P0hCid0103D?AT0>4nM03Q?W@3D?AT703Q?W@030000000hCid0>4nM00<0>4nM
00D0e3dI03Q?W@0hCid0>4nM0=@m6@0803Q?W@030=@m6@000000odhO00<0odhO00D000000?m8703o
B1`000000?m8700200000080fS`G0P00000703eIZ`/0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0m
FJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00D0ooK^1P0mFJ/60?ofkP0303eIZ`3om^h0ooK^
0100ooK^00@0?EV[0?ofkP3om^h0?EV[1@3om^h2000005X0ooK^0@3oool001@0ooK^00<000000?of
kP3om^h0>@3om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<000000?of
kP3om^h00P3om^h00`0mFJ/0ooK^03eIZ`080?ofkPX0?EV[0P3om^h00`0mFJ/0ooK^0=@m6@020?of
kP050=@m6@3om^h0e3dI0=@m6@000000200_@H800`3D?AT0;d620000000502m1PPH0000000<0e3dI
02m1PP0_@H801`0_@H800`000000;d6202m1PP0302m1PP<0000000<0e3dI0000000000000P000008
03A9T@030000000dBI40=4VA00<0=4VA00<0e3dI03A9T@0dBI400`0dBI400`000000=4VA03A9T@08
03A9T@030000000dBI40=4VA00<0=4VA00<0e3dI03A9T@0dBI400P0dBI400`000000=4VA03A9T@03
03A9T@80e3dI0`0dBI401@000000=4VA03A9T@0dBI40e3dI00@0=4VA1P00000803Q?W@030000003D
?AT0e3dI00L0>4nM00<0000003Q?W@0hCid0100hCid01@3D?AT0>4nM03Q?W@3D?AT0000000P0>4nM
00<0e3dI0000003oCQl00`3oCQl01@000000odPL0?m870000000odPL00H0?EV[0`3om^h00`0mFJ/0
ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0
ooK^0?ofkP0503eIZ`H0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP04
03eIZ`3om^h0ooK^03eIZ`D0ooK^0P00001J0?ofkP40oooo000D0?ofkP030000003om^h0ooK^03T0
ooK^00<0?EV[0?ofkP3om^h04@3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP040000003om^h0ooK^0?of
kP80?EV[0`3om^h:03eIZ`D0ooK^00@0?EV[0?ofkP3om^h0?EV[0P3om^h00`3D?AT0ooK^0?ofkP03
0=@m6@030000000_@H80;d6200H0;d6200<0e3dI02m1PP0000001@00000502m1PP030000000_@H80
e3dI00H0;d622000000303A9T@030=@m6@0dBI40000000/0=4VA00<0000003A9T@0dBI400`0dBI40
0`3D?AT0=4VA03A9T@0203A9T@030000000dBI40=4VA00P0=4VA00<0000003A9T@0dBI400`0dBI40
0`3D?AT0=4VA03A9T@0203A9T@040000000dBI40=4VA03A9T@80e3dI1@0dBI400`000000=4VA03A9
T@02000000040=@m6@000000000000000080>4nM00<0000003Q?W@0hCid02@0hCid00`000000e3dI
03Q?W@0703Q?W@030000000hCid0>4nM00@0>4nM00@0e3dI03Q?W@3D?AT000002P0hCid0103D?AT0
odhO0?m>7`3oCQl603eIZ`040?m870000000fS`G0=Xl5`8000000`3om^h00`0mFJ/0ooK^0?ofkP0<
0?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h01@3om^h603eIZ`/0ooK^00<0?EV[
0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0403eIZ`3om^h0ooK^03eIZ`D0ooK^00<0
00000?ofkP000000F@3om^h10?ooo`00503om^h00`000000ooK^0?ofkP0i0?ofkP0303eIZ`3om^h0
ooK^0140ooK^00<0?EV[0?ofkP3om^h02`3om^h00`000000ooK^0?ofkP020?ofkPT0?EV[2P3om^h0
100mFJ/0ooK^0?ofkP0mFJ/20?ofkP80e3dI00D0ooK^0=@m6@3D?AT0ooK^0=@m6@0502m1PPH00000
2P0_@H800`000000;d620=@m6@0600000080=4VA00<0000003A9T@0dBI401`0dBI400`3D?AT00000
03A9T@0:03A9T@030000000dBI40=4VA00<0=4VA00<0e3dI03A9T@0dBI400`0dBI400`000000=4VA
03A9T@0703A9T@030000000dBI40=4VA00@0=4VA00H0e3dI03A9T@0dBI40=4VA0000000dBI420=@m
6@D0=4VA1@00000203Q?W@030=@m6@0hCid0>4nM00<0>4nM00<0000003Q?W@0hCid0200hCid30=@m
6@P0>4nM00<0000003Q?W@0hCid01@0hCid20=@m6@030000000hCid0>4nM00P0>4nM100mFJ/01@00
0000odhO0000003oB1`000000080odPL00<000000=Xl5`3J?1L00P000000103D?AT0ooK^0?ofkP0m
FJ/?0?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP0mFJ/01@0mFJ/30?ofkP0303eIZ`3o
m^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0303eIZ`3o
m^h0?EV[00D0ooK^00<000000?ofkP000000F@3om^h10?ooo`004`3om^h00`000000ooK^0?ofkP0j
0?ofkP0303eIZ`3om^h0ooK^0140ooK^00<0?EV[0?ofkP3om^h0303om^h00`000000?EV[03eIZ`04
03eIZa40ooK^00<0?EV[0?ofkP0mFJ/00`3om^h00`3D?AT0ooK^0?ofkP020=@m6@H00000100_@H80
0`3D?AT0000002m1PP0702m1PPD0000000<0e3dI03A9T@0dBI401@0dBI400`000000=4VA03A9T@07
03A9T@030=@m6@0dBI40000000X0=4VA00<0000003A9T@0dBI40100dBI400`3D?AT0=4VA03A9T@02
03A9T@030000000dBI40=4VA00L0=4VA00<0000003A9T@0dBI40100dBI40103D?AT0=4VA03A9T@0d
BI420=@m6@0303A9T@000000000000@000000P0hCid00`000000>4nM03Q?W@0303Q?W@030=@m6@0h
Cid0>4nM0080>4nM00<0000003Q?W@0hCid01`0hCid01@3D?AT0000003Q?W@0hCid0e3dI00L0>4nM
00<0000003Q?W@0hCid01@0hCid00`3D?AT0>4nM0000000:03Q?W@090000003oCQl0odhO0?m>7`00
0000odhO0000003oB1`000000080odPL00<000000=Xl5`3J?1L00`0000020?ofkP0303eIZ`3om^h0
ooK^00d0ooK^00@0?EV[0?ofkP3om^h0ooK^1`0mFJ/90?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0
?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0303eIZ`3om^h0?EV[00D0ooK^00<0
00000?ofkP000000F@3om^h10?ooo`004`3om^h00`000000ooK^0?ofkP0i0?ofkP0303eIZ`3om^h0
ooK^0140ooK^00<0?EV[0?ofkP3om^h0203om^h603eIZ`030000003om^h0ooK^0080?EV[4P3om^h0
0`0mFJ/0ooK^03eIZ`020?ofkPH0000000<0ooK^0=@m6@0_@H80200_@H800`3D?AT0;d6202m1PP06
00000080=4VA00@0000003A9T@0dBI40e3dI1`0dBI400`000000=4VA03A9T@0803A9T@030=@m6@00
0000=4VA00T0=4VA00<0000003A9T@0dBI40100dBI400`3D?AT0=4VA03A9T@0203A9T@030000000d
BI40=4VA00L0=4VA00<0000003A9T@0dBI401@0dBI430=@m6@<00000200hCid00`000000>4nM03Q?
W@0303Q?W@030=@m6@0hCid0>4nM0080>4nM00<0000003Q?W@0hCid01P0hCid00`3D?AT0>4nM0000
000203Q?W@030=@m6@0hCid0>4nM00D0>4nM00<0000003Q?W@0hCid0100hCid20=@m6@0303Q?W@00
0000>4nM00P0>4nM00<000000?m>7`3oCQl00P3oCQl010000000odhO0000000000030?m870<00000
0P3J?1L01@000000ooK^0?ofkP3om^h0?EV[00/0ooK^1`0mFJ/60?ofkP0303eIZ`3om^h0ooK^00P0
ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00d0
ooK^100mFJ/00`3om^h0?EV[0?ofkP040?ofkP030000003om^h0000005T0ooK^0@3oool001<0ooK^
00<000000?ofkP3om^h0>@3om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP0403eIZ`3om^h0ooK^0?ofkPL0
?EV[1P3om^h00`000000ooK^0?ofkP0203eIZa40ooK^1P0000020?ofkP060=@m6@3om^h0e3dI0=@m
6@3om^h000000P3D?AT502m1PP<0000000<0e3dI0000000dBI401`0dBI401@000000=4VA03A9T@0d
BI40e3dI00L0=4VA00<0000003A9T@0dBI401`0dBI400`3D?AT0000003A9T@0903A9T@030000000d
BI40=4VA00D0=4VA00D0e3dI03A9T@0dBI40=4VA0000000903A9T@030000000dBI40=4VA00@00000
0P3D?AT203Q?W@030000000hCid0>4nM00P0>4nM00<0000003Q?W@0hCid00`0hCid00`3D?AT0>4nM
03Q?W@0203Q?W@030000000hCid0>4nM00@0>4nM0P3D?AT203Q?W@050000000hCid0>4nM03Q?W@3D
?AT01P0hCid00`000000>4nM03Q?W@0303Q?W@050=@m6@0hCid0>4nM0=@m6@0000002@0hCid01@00
0000odhO0?m>7`3oCQl0000000<0odhO00D000000?m8703oB1`000000?m8700200000080fS`G00D0
00000=@m6@3om^h0ooK^03eIZ`050?ofkPH0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eI
Z`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eI
Z`3om^h0ooK^00H0ooK^1P0mFJ/30?ofkP0303eIZ`3om^h0?EV[00H0ooK^0P00001I0?ofkP40oooo
000C0?ofkP030000003om^h0ooK^03T0ooK^00<0?EV[0?ofkP3om^h03`3om^h603eIZ`h0ooK^00D0
00000?ofkP0mFJ/0ooK^03eIZ`0;0?ofkPD000000P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP80e3dI
00D0ooK^0=@m6@3D?AT0000002m1PP030=@m6@<000000P0dBI400`000000e3dI03A9T@0903A9T@04
0000000dBI40=4VA0=@m6@L0=4VA00<0000003A9T@0dBI40200dBI400`3D?AT0=4VA03A9T@0803A9
T@030000000dBI40=4VA00D0=4VA00D0e3dI03A9T@0dBI40=4VA0000000503A9T@L0000000H0>4nM
0=@m6@3D?AT0e3dI03Q?W@3D?AT203Q?W@030000000hCid0>4nM00P0>4nM00<0000003Q?W@0hCid0
100hCid01@3D?AT0>4nM03Q?W@0hCid0000000D0>4nM00<0e3dI03Q?W@0hCid00P0hCid01@000000
>4nM03Q?W@0hCid0e3dI00H0>4nM00<0000003Q?W@0hCid00P0hCid01@3D?AT0>4nM03Q?W@0hCid0
e3dI00P0>4nM0`0000030?m>7`050000003oCQl0odhO0?m>7`0000000P3oB1`010000000odPL0000
000000020=Xl5`030000003D?AT0ooK^00L0?EV[2@3om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eI
Z`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eI
Z`3om^h0ooK^00H0?EV[2@3om^h0100mFJ/0ooK^0?ofkP0mFJ/50?ofkP800000F@3om^h10?ooo`00
4P3om^h00`000000ooK^0?ofkP0j0?ofkP0303eIZ`3om^h0ooK^00X0ooK^1@0mFJ/20?ofkP0303eI
Z`3om^h0ooK^0100ooK^00@0000003eIZ`3om^h0?EV[1@3om^h6000000L0ooK^0P0mFJ/50?ofkP@0
e3dI0P0000000`3D?AT0=4VA03A9T@020=@m6@@0=4VA00<000000=@m6@0dBI40200dBI401@000000
=4VA03A9T@0dBI40e3dI00H0=4VA00<0000003A9T@0dBI40200dBI400`3D?AT0=4VA03A9T@0903A9
T@030000000dBI40=4VA00D0=4VA00<0e3dI0000000000001P00000403Q?W@040000003D?AT0e3dI
0=@m6@D0>4nM00<0e3dI03Q?W@0000002P0hCid00`000000>4nM03Q?W@0403Q?W@050=@m6@0hCid0
>4nM03Q?W@000000100hCid00`3D?AT0>4nM03Q?W@0303Q?W@050000000hCid0>4nM03Q?W@3D?AT0
1@0hCid00`000000>4nM03Q?W@0303Q?W@070=@m6@0hCid0>4nM03Q?W@000000e3dI03Q?W@060000
0080>eBX00D000000?m>7`3oCQl0odhO000000030?m>7`050000003oB1`0e3dI0000003oB1`00P00
00020=Xl5`<0000000<0ooK^03eIZ`3om^h03P3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3o
m^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h02`3om^h0100mFJ/0ooK^0?ofkP3om^h603eIZ`l0ooK^
00@0?EV[0?ofkP3om^h0?EV[1@3om^h00`000000ooK^0000001H0?ofkP40oooo000B0?ofkP030000
003om^h0ooK^03T0ooK^00<0?EV[0?ofkP3om^h01@3om^h603eIZ`L0ooK^00<0?EV[0?ofkP3om^h0
403om^h00`000000?EV[0?ofkP06000000d0ooK^0P0mFJ/50?ofkP<0e3dI00D0?EV[0=@m6@0dBI40
=4VA0=@m6@0303A9T@80e3dI0P0dBI400`000000e3dI03A9T@0803A9T@030000000dBI40=4VA0080
=4VA00<0e3dI03A9T@0dBI400`0dBI400`000000=4VA03A9T@0803A9T@030000003D?AT0=4VA00T0
=4VA00<0000003A9T@0dBI401@000000103D?AT0>4nM03Q?W@00000603Q?W@@0e3dI200hCid00`3D
?AT0>4nM0000000:03Q?W@030000000hCid0>4nM00@0>4nM00D0e3dI03Q?W@0hCid0>4nM00000002
03Q?W@80e3dI1@0hCid00`000000>4nM03Q?W@0303Q?W@030=@m6@0hCid0>4nM0080>4nM00<00000
03Q?W@0hCid00P0hCid00`3D?AT0>4nM03Q?W@03000000030=@m6@000000>eBX00H0>eBX00<00000
0?mB8@0000000P3oCQl020000000odhO0?m>7`000000odhO0000003D?AT000000P3oB1`00`000000
fS`G0=Xl5`03000000030?ofkP0mFJ/0ooK^00h0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0
ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00T0ooK^1P0mFJ/30?ofkP0303eIZ`3om^h0ooK^0100
ooK^00<0?EV[0?ofkP0mFJ/01@3om^h00`000000ooK^0000001H0?ofkP40oooo000B0?ofkP030000
003om^h0ooK^03T0ooK^00<0?EV[0?ofkP3om^h01@0mFJ/=0?ofkP0303eIZ`3om^h0ooK^00d0ooK^
1P0000000`3om^h0?EV[0?ofkP0@0?ofkP0303eIZ`3om^h0?EV[0080ooK^0`0mFJ/20=@m6@050?of
kP3D?AT0000003A9T@3D?AT01@0dBI420=@m6@030000000dBI40e3dI00P0=4VA00<0000003A9T@0d
BI400P0dBI400`3D?AT0=4VA03A9T@0303A9T@030000000dBI40=4VA00T0=4VA00<0e3dI03A9T@0d
BI401P0dBI45000000H0>4nM00<0e3dI03Q?W@0000000`0hCid30=@m6@<0>4nM00<0000003Q?W@0h
Cid01`0hCid00`3D?AT0000003Q?W@0903Q?W@030000000hCid0>4nM00D0>4nM00H0e3dI03Q?W@0h
Cid0000003Q?W@3D?AT703Q?W@030000000hCid0>4nM00<0>4nM00<0e3dI03Q?W@0hCid00P0hCid0
1@000000>4nM03Q?W@000000e3dI00<000000P0kE:P00`000000e3dI03]DZ00703]DZ0050000003o
DR4000000?m>7`0000000`3oCQl01@000000odhO0000003oB1`000000080odPL00<000000=Xl5`3J
?1L00P0000000`2X;A00000003eIZ`0?0?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3o
m^h02@3om^h00`0mFJ/0ooK^0?ofkP020?ofkPH0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP040?ofkP03
03eIZ`3om^h0ooK^00l0ooK^100mFJ/50?ofkP030000003om^h0000005P0ooK^0@3oool00180ooK^
00<000000?ofkP3om^h0>@3om^h303eIZa40ooK^00<0?EV[0?ofkP3om^h02@3om^h5000000<0ooK^
00<0?EV[0?ofkP0000000P3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkPD0?EV[0`3om^h30=@m6@050?of
kP3D?AT0=4VA03A9T@3D?AT01P0dBI430=@m6@T0=4VA00<0000003A9T@0dBI400P0dBI400`3D?AT0
=4VA03A9T@0203A9T@030000000dBI40=4VA00T0=4VA00<000000=@m6@0dBI401P00000203Q?W@03
0000000hCid0>4nM00H0>4nM00<0e3dI03Q?W@0000000`3D?AT703Q?W@030000000hCid0>4nM00H0
>4nM00<0e3dI0000000hCid02@0hCid00`000000>4nM03Q?W@0503Q?W@050=@m6@0hCid0>4nM0000
003D?AT0200hCid00`000000>4nM03Q?W@0303Q?W@030000003D?AT0000000D0000000<0e3dI03]D
Z00kE:P00`0kE:P010000000>eBX03]DZ03D?AT703]DZ0050000003oDR4000000?m>7`0000000`3o
CQl01@000000odhO0000003oB1`000000080odPL00<000000=Xl5`3J?1L0100000000`0mFJ/0ooK^
0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h01`3om^h603eIZ`P0ooK^
00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP080?ofkPH0?EV[00@0ooK^03eIZ`3om^h0
?EV[1@3om^h00`000000ooK^0000001H0?ofkP40oooo000B0?ofkP030000003om^h0ooK^03T0ooK^
00<0?EV[0?ofkP3om^h04@3om^h00`0mFJ/0ooK^0?ofkP030?ofkPH00000203om^h00`0mFJ/0ooK^
000000020?ofkP0303eIZ`3om^h0ooK^00P0ooK^1`0mFJ/00`3om^h0?EV[0?ofkP050?ofkP80e3dI
0P0mFJ/203A9T@030=@m6@0dBI40=4VA00D0=4VA00<000000=@m6@3D?AT00P3D?AT603A9T@030000
000dBI40=4VA0080=4VA00<0e3dI03A9T@0dBI400`0dBI400`000000=4VA03A9T@0603A9T@<00000
00<0e3dI0000000hCid01`0hCid00`000000>4nM03Q?W@0503Q?W@@0e3dI2P0hCid00`000000>4nM
03Q?W@0703Q?W@030=@m6@000000>4nM00P0>4nM00<0000003Q?W@0hCid01P0hCid30=@m6@L0>4nM
200000000`0kE:P0e3dI03]DZ00203]DZ0030000000kE:P0e3dI00H0>eBX00@0000003]DZ00kE:P0
e3dI1P0kE:P01P000000oe8Q0?mB8@000000odhO00000080odhO00<000000?m>7`3oCQl00P000003
0?m87080000000<0fS`G0000003J?1L00P0000000`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0
ooK^00L0ooK^00@0?EV[0?ofkP3om^h0ooK^1P0mFJ/00`3om^h0?EV[0?ofkP0;0?ofkP0303eIZ`3o
m^h0ooK^00D0ooK^00@0?EV[0?ofkP3om^h0ooK^1`0mFJ/70?ofkP0303eIZ`3om^h0?EV[00H0ooK^
0P00001H0?ofkP40oooo000A0?ofkP030000003om^h0ooK^03X0ooK^00<0?EV[0?ofkP3om^h04@3o
m^h6000000h0ooK^00@0?EV[0?ofkP3om^h000000P3om^h0100mFJ/0ooK^0?ofkP3om^h603eIZ`H0
ooK^00<0?EV[0?ofkP3om^h01P0mFJ/30=@m6@050000000dBI40=4VA03A9T@3D?AT01P0dBI401@00
0000=4VA03A9T@3D?AT0=4VA00D0e3dI00<0=4VA0000000dBI40100dBI400`3D?AT0=4VA03A9T@02
03A9T@030000000dBI40=4VA00H000000P0hCid00`000000>4nM0=@m6@0803Q?W@030000000hCid0
e3dI00D0e3dI0P0hCid00`3D?AT0000003Q?W@0903Q?W@030000000hCid0>4nM00L0>4nM00<0e3dI
0000000hCid0200hCid00`000000>4nM03Q?W@0603Q?W@030=@m6@0hCid000000080>4nM1@000002
03]DZ0030000000kE:P0>eBX00@0>eBX00H0e3dI03]DZ00kE:P0>eBX0000003D?AT703]DZ0050000
000kE:P0>eBX03]DZ03D?AT01@0kE:P01@000000oe8Q0?mB8@3oDR40000000<0odhO00D000000?m>
7`3oCQl0odhO000000020?m870060000003oB1`000000=Xl5`000000fS`G0`0000000`0mFJ/0ooK^
0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00<0ooK^1`0mFJ/70?ofkP0303eIZ`3om^h0ooK^00/0ooK^
00@0?EV[0?ofkP3om^h0ooK^1`0mFJ/>0?ofkP0403eIZ`3om^h0ooK^03eIZ`D0ooK^0P00001H0?of
kP40oooo000A0?ofkP030000003om^h0ooK^03X0ooK^00<0?EV[0?ofkP3om^h02`3om^h600000003
03eIZ`3om^h0ooK^0140ooK^00H0?EV[0?ofkP3om^h0ooK^0000003om^h403eIZ`X0ooK^1P0mFJ/6
0?ofkP<0e3dI00@0000003A9T@0dBI40e3dI1P0dBI4010000000=4VA03A9T@3D?AT603A9T@H0e3dI
00@0=4VA0=@m6@0dBI40=4VA1@00000803Q?W@030000000hCid0e3dI00@0>4nM1P3D?AT903Q?W@03
0=@m6@0hCid0>4nM00P0>4nM00<0000003Q?W@0hCid01`0hCid00`3D?AT0000003Q?W@0803Q?W@03
0000000hCid0>4nM00@0>4nM0`3D?AT4000000L0>eBX00<0000003]DZ00kE:P01@0kE:P01@3D?AT0
>eBX0000000kE:P0e3dI00L0>eBX00D0000003]DZ00kE:P0>eBX0=@m6@0403]DZ0030000003oDR40
oe8Q0080oe8Q00D000000?m>7`3oCQl0odhO000000030?m>7`040000003oB1`0odPL00000080odPL
0P0000001@3J?1L00000000000000000?EV[00l0ooK^1P0mFJ/30?ofkP0303eIZ`3om^h0ooK^00T0
ooK^00<0?EV[0?ofkP3om^h0203om^h603eIZ`<0ooK^00<0?EV[0?ofkP3om^h03`3om^h0100mFJ/0
ooK^0?ofkP0mFJ/50?ofkP030000003om^h0000005L0ooK^0@3oool00140ooK^00<000000?ofkP3o
m^h0>@3om^h00`0mFJ/0ooK^0?ofkP070?ofkPD000001P3om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP07
03eIZ`3om^h0ooK^0?ofkP000000ooK^03eIZ`070?ofkPH0?EV[0P3om^h0100mFJ/0ooK^0?ofkP0m
FJ/60?ofkP@0e3dI0`0dBI400`3D?AT0=4VA03A9T@0303A9T@050000000dBI40=4VA03A9T@3D?AT0
1`0dBI4010000000=4VA03A9T@00000H0=@m6@D0>4nM00<0000003Q?W@0hCid01`0hCid00`3D?AT0
000003Q?W@0803Q?W@030000000hCid0>4nM00P0>4nM00<0e3dI03Q?W@0hCid01`0hCid00`000000
>4nM03Q?W@0200000080e3dI0P0000000`0kE:P0e3dI0000000903]DZ0030000000kE:P0>eBX00D0
>eBX00@0e3dI03]DZ0000000e3dI1`0kE:P00`000000>eBX03]DZ00203]DZ0070=@m6@0kE:P0>eBX
03]DZ03D?AT0000003eIZ`030?mB8@050000003oCQl0odhO0?m>7`0000000`3oCQl010000000odPL
0?m8700000020?m87080000000D0fS`G000000000000000003eIZ`090?ofkPL0?EV[203om^h00`0m
FJ/0ooK^0?ofkP090?ofkP0403eIZ`3om^h0ooK^0?ofkPL0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP04
0?ofkP0303eIZ`3om^h0ooK^0100ooK^00<0?EV[0?ofkP0mFJ/01@3om^h00`000000ooK^0000001G
0?ofkP40oooo000A0?ofkP030000003om^h0ooK^03T0ooK^00@0?EV[0?ofkP3om^h0ooK^1P00000;
0?ofkP0303eIZ`3om^h0ooK^0140ooK^00<0?EV[0?ofkP3om^h00P3om^h010000000ooK^03eIZ`3o
m^h503eIZ`P0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`060?ofkP80e3dI00D000000=@m6@0dBI40
=4VA0=@m6@0603A9T@040000000dBI40=4VA0=@m6@80=4VA2000000403Q?W@050=@m6@0hCid0>4nM
03Q?W@0000002P0hCid00`000000>4nM0=@m6@0803Q?W@030000000hCid0>4nM00P0>4nM00<0e3dI
03Q?W@0hCid01`0hCid00`000000>4nM03Q?W@0803Q?W@030=@m6@0hCid0>4nM00<0>4nM1`000002
0=@m6@D0>eBX00<0e3dI0000000kE:P01`0kE:P00`000000>eBX03]DZ00703]DZ080e3dI200kE:P0
0`000000>eBX03]DZ00303]DZ0060=@m6@0kE:P0e3dI03]DZ0000000?EV[0P3oDR401@000000oe8Q
0000003oCQl0000000<0odhO00D000000?m>7`000000odPL000000030?m870030000003J?1L00000
0080000000@0?EV[0?ofkP3om^h0ooK^1P0mFJ/60?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[
0?ofkP3om^h01P3om^h703eIZ`T0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0@
0?ofkP0303eIZ`3om^h0?EV[00D0ooK^00<000000?ofkP000000E`3om^h10?ooo`00403om^h00`00
0000ooK^0?ofkP0h0?ofkPH000004@3om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP0303eIZ`3om^h0ooK^
00H0?EV[3@3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00L0ooK^0P3D?AT01@0dBI40e3dI0=@m6@0d
BI40e3dI00<0=4VA1P0000000`3D?AT0000003Q?W@0403Q?W@030000000hCid0>4nM00@0>4nM00D0
e3dI03Q?W@0hCid0>4nM0000000:03Q?W@040000000hCid0>4nM0=@m6@L0>4nM00<0000003Q?W@0h
Cid0200hCid00`3D?AT0>4nM03Q?W@0803Q?W@030000000hCid0>4nM00D0>4nM0`0000000`3D?AT0
000000000002000000@0>eBX00<0000003]DZ03D?AT0200kE:P00`3D?AT0>eBX03]DZ00603]DZ003
0000000kE:P0>eBX00L0>eBX00<0e3dI0000000kE:P01`0kE:P00`000000>eBX03]DZ00303]DZ006
0=@m6@0kE:P0e3dI0000003oDR40?EV[0P3oDR401@000000oe8Q0000003oCQl0000000<0odhO00D0
00000?m>7`000000odPL000000030?m870030000003J?1L0000000H0?EV[3@3om^h00`0mFJ/0ooK^
0?ofkP050?ofkP0303eIZ`3om^h0ooK^00H0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eI
Z`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^03eIZ`050?ofkP030000
003om^h0000005L0ooK^0@3oool00100ooK^00<000000?ofkP3om^h0<P3om^h600000080ooK^00<0
?EV[0?ofkP3om^h04@3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkPH0?EV[0`3om^h00`000000?EV[0?of
kP0=0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/01`3om^h20=@m6@030000000dBI40=4VA0080e3dI
0`00000203Q?W@030000000hCid0>4nM0080>4nM00<0e3dI03Q?W@0hCid0100hCid00`000000>4nM
03Q?W@0403Q?W@040=@m6@0hCid0>4nM000000X0>4nM00@0000003Q?W@0hCid0e3dI1`0hCid00`00
0000>4nM03Q?W@0803Q?W@030000003D?AT0>4nM00P0>4nM00<0000003Q?W@0hCid01@00000203]D
Z0030000003D?AT0>eBX00L0>eBX0P3D?AT903]DZ0030=@m6@0kE:P0>eBX00H0>eBX00<0000003]D
Z00kE:P01@0kE:P30=@m6@P0>eBX00<0000003]DZ00kE:P01@0kE:P01`3D?AT0>eBX0000003oDR40
?EV[0?mB8@0000000P3oDR400`000000odhO000000030?m>7`050000003oCQl000000?m870000000
1P0mFJ/20000000303eIZ`3om^h0ooK^00h0ooK^00@0?EV[0?ofkP3om^h0ooK^1`0mFJ/90?ofkP03
03eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP04
03eIZ`3om^h0ooK^03eIZ`D0ooK^0P00001G0?ofkP40oooo000@0?ofkP030000003om^h0ooK^02`0
ooK^1P0000080?ofkP0303eIZ`3om^h0ooK^0140ooK^00<0?EV[0?ofkP3om^h0203om^h703eIZ`<0
ooK^00<0?EV[0?ofkP3om^h0103om^h00`000000?EV[0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^0080
ooK^00<0?EV[0?ofkP3om^h01@3om^h20=@m6@80000000<0>4nM0=@m6@3D?AT01@0hCid01@000000
>4nM03Q?W@0hCid0e3dI00H0>4nM00<0000003Q?W@0hCid0100hCid01@3D?AT0>4nM03Q?W@0hCid0
000000X0>4nM00@0000003Q?W@0hCid0e3dI1P0hCid00`000000>4nM03Q?W@0803Q?W@030000003D
?AT0>4nM00H0>4nM1@00000703]DZ0030000000kE:P0e3dI00D0>eBX0P3D?AT00`000000>eBX03]D
Z00803]DZ0030=@m6@0kE:P0>eBX00H0>eBX00<0000003]DZ00kE:P0100kE:P01@3D?AT0>eBX03]D
Z0000000e3dI00L0>eBX00<0000003]DZ00kE:P01@0kE:P01`3D?AT0>eBX0000003oDR40?EV[0?mB
8@0000000`3oDR4010000000odhO0?m>7`3oCQl603eIZ`<0odPL0`0000000`3J?1L0000003eIZ`0>
0?ofkPH0?EV[1@3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[
0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0403eIZ`3om^h0ooK^03eIZ`D0ooK^0P00
001G0?ofkP40oooo000@0?ofkP030000003om^h0ooK^02L0ooK^1@00000>0?ofkP0303eIZ`3om^h0
ooK^0140ooK^00@0?EV[0?ofkP3om^h0ooK^1`0mFJ/:0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0
000003eIZ`3om^h0303om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00D0ooK^0`3D
?AT303Q?W@030=@m6@0hCid0>4nM00<0>4nM00<0000003Q?W@0hCid00P0hCid00`3D?AT0>4nM03Q?
W@0303Q?W@030000000hCid0>4nM00D0>4nM00@0e3dI03Q?W@0hCid000002P0hCid010000000>4nM
03Q?W@3D?AT703Q?W@030000000hCid0>4nM00L0>4nM00<0000003Q?W@3D?AT01P00000203]DZ003
0000000kE:P0>eBX00L0>eBX00<0000003]DZ03D?AT00`0kE:P20=@m6@80>eBX00<0000003]DZ00k
E:P0200kE:P00`000000e3dI03]DZ00603]DZ0030000000kE:P0>eBX00<0>eBX00H0e3dI03]DZ00k
E:P0>eBX0000003D?AT703]DZ0030000000kE:P0>eBX00@0>eBX0P3D?AT01`000000oe8Q0?mB8@0m
FJ/0oe8Q0000003oDR401P0mFJ/01@000000odhO0?m>7`3oCQl0000000<0odPL00P000000?m87000
000000000=Xl5`000000e3dI03eIZ`P0ooK^1@0mFJ/20?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0
?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0
?EV[0?ofkP3om^h03`3om^h0100mFJ/0ooK^0?ofkP0mFJ/50?ofkP030000003om^h0000005H0ooK^
0@3oool00100ooK^00<000000?ofkP3om^h08@3om^h6000001<0ooK^00<0?EV[0?ofkP3om^h03`3o
m^h603eIZa40ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3o
m^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h01P3om^h20=@m6@@0>4nM0P3D?AT403Q?W@050000000h
Cid0>4nM03Q?W@3D?AT01P0hCid00`000000>4nM03Q?W@0403Q?W@040=@m6@0hCid0>4nM000000X0
>4nM00D0000003Q?W@0hCid0>4nM0=@m6@0603Q?W@030000000hCid0>4nM00D0>4nM100000000`3D
?AT0>eBX03]DZ00603]DZ0030000000kE:P0>eBX00L0>eBX00<0000003]DZ00kE:P00`3D?AT403]D
Z0030000000kE:P0>eBX00L0>eBX00<0000003]DZ03D?AT01`0kE:P010000000>eBX03]DZ00kE:P2
0=@m6@@0>eBX00<000000=@m6@0kE:P01P0kE:P00`000000>eBX03]DZ00303]DZ0040=@m6@000000
e3dI000000H0?EV[0P3oDR401@000000odhO0?m>7`3oCQl0000000<0odhO00H000000?m8703oB1`0
odPL0000003oB1`2000000040=Xl5`000000000003eIZ`<0ooK^1@0mFJ/70?ofkP0303eIZ`3om^h0
ooK^00H0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0
ooK^00@0ooK^00<0?EV[0?ofkP3om^h0403om^h00`0mFJ/0ooK^03eIZ`050?ofkP030000003om^h0
000005H0ooK^0@3oool000l0ooK^00<000000?ofkP3om^h0703om^h6000001P0ooK^00<0?EV[0?of
kP3om^h02`3om^h503eIZ`80ooK^00<0?EV[0?ofkP3om^h04P3om^h00`0mFJ/0ooK^0?ofkP060?of
kP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h00`3om^h0100mFJ/0ooK^0?ofkP3om^h5
03eIZ`80e3dI100hCid30=@m6@80>4nM00<0000003Q?W@0hCid00P0hCid00`3D?AT0>4nM03Q?W@03
03Q?W@030000000hCid0>4nM00D0>4nM00@0e3dI03Q?W@0hCid000002@0hCid01@000000>4nM03Q?
W@0hCid0e3dI00H0>4nM00<0000003Q?W@0hCid01@00000203]DZ0040000000kE:P0>eBX0=@m6@L0
>eBX00<0000003]DZ00kE:P01`0kE:P010000000>eBX0=@m6@3D?AT603]DZ0030000000kE:P0>eBX
00L0>eBX00@0000003]DZ00kE:P0e3dI1P0kE:P010000000>eBX03]DZ03D?AT503]DZ0040000000k
E:P0>eBX0=@m6@D0>eBX00<0000003]DZ00kE:P00`0000001@3D?AT0000003iI/@0nFK4000000080
oe8Q00<0?EV[0000003oDR400P3oDR400`000000oe8Q000000020?m>7`050000003oCQl0odhO0?m>
7`0000000P3oB1`01P3D?AT000000?m8703oB1`000000=Xl5`800000100mFJ/<0?ofkP0303eIZ`3o
m^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3o
m^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h0403om^h0100mFJ/0ooK^0?ofkP0mFJ/40?ofkP030000
003om^h0000005H0ooK^0@3oool000l0ooK^00<000000?ofkP3om^h05P3om^h6000001h0ooK^00<0
?EV[0?ofkP3om^h01@3om^h603eIZ`L0ooK^00<0?EV[0?ofkP3om^h04P3om^h00`0mFJ/0ooK^0?of
kP060?ofkP0303eIZ`3om^h0ooK^00X0ooK^00@0?EV[0?ofkP3om^h0ooK^1P0mFJ/50?ofkP80e3dI
100hCid00`3D?AT0>4nM03Q?W@020=@m6@030000000hCid0>4nM00<0>4nM00<0e3dI03Q?W@0hCid0
0`0hCid00`000000>4nM03Q?W@0403Q?W@040=@m6@0hCid0>4nM000000X0>4nM00H0000003Q?W@0h
Cid0>4nM0=@m6@0hCid7000000L0>eBX00@0000003]DZ00kE:P0e3dI1`0kE:P00`000000>eBX03]D
Z00603]DZ0<0e3dI00<0>eBX0=@m6@0kE:P01@0kE:P00`000000>eBX03]DZ00703]DZ0040000000k
E:P0>eBX0=@m6@D0>eBX00@0000003]DZ00kE:P0e3dI1P0kE:P01@000000>eBX03]DZ03D?AT0>eBX
00L000000P0nFK402P3D?AT0?UVa03iI/@0nFK4000000?mD8P000000oe8Q03eIZ`0000030?mB8@03
0000003oDR4000000080odhO00T000000?m>7`3oCQl000000?m>7`000000odPL0=@m6@0000000P3o
B1`01@000000fS`G000000000000?EV[0100ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^
0?ofkP090?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^
0?ofkP0=0?ofkP@0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP030000003om^h0000005H0ooK^
0@3oool000l0ooK^00<000000?ofkP3om^h04@3om^h5000002@0ooK^00<0?EV[0?ofkP3om^h01@0m
FJ/=0?ofkP0303eIZ`3om^h0ooK^0180ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/000000?of
kP080?ofkPH0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP070?ofkP80e3dI100hCid0103D?AT0>4nM03Q?
W@0hCid30=@m6@<0>4nM00<0e3dI03Q?W@0hCid00`0hCid00`000000>4nM03Q?W@0503Q?W@030=@m
6@0hCid0000000P0>4nM1P0000000`3D?AT0000003]DZ00303]DZ0030000000kE:P0>eBX00P0>eBX
00@0000003]DZ00kE:P0e3dI1P0kE:P00`000000>eBX03]DZ00303]DZ0<0e3dI00<0>eBX0000000k
E:P00P0kE:P00`3D?AT0>eBX03]DZ00303]DZ0030000000kE:P0>eBX00L0>eBX00@0000003]DZ00k
E:P0e3dI1@0kE:P00`000000e3dI0=@m6@0503]DZ0D0000000<0e3dI0000000nFK400`0nFK401@00
0000?UVa03iI/@0nFK40e3dI00@0?UVa00H000000?mD8P000000oe8Q0000000mFJ/20?mB8@050000
003oDR40oe8Q0?mB8@000000103oCQl00`000000odhO000000020?m870050000003oB1`0odPL0000
003J?1L00P0000000`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?of
kP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?of
kP3om^h01`3om^h603eIZ`<0ooK^100mFJ/50?ofkP800000EP3om^h10?ooo`003`3om^h00`000000
ooK^0?ofkP0;0?ofkPH00000:@3om^h303eIZa80ooK^00<0?EV[0?ofkP3om^h04P3om^h00`0mFJ/0
ooK^0?ofkP070?ofkP0403eIZ`000000ooK^0?ofkPH0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP040?of
kP0303eIZ`3om^h0ooK^00H0ooK^0P3D?AT503Q?W@060=@m6@0hCid0>4nM03Q?W@000000>4nM0P3D
?AT203Q?W@030=@m6@0hCid0>4nM0080>4nM00<0000003Q?W@0hCid01@0hCid0103D?AT0>4nM03Q?
W@00000203Q?W@D000000P0kE:P00`000000>eBX03]DZ00203]DZ0030=@m6@0kE:P0>eBX00<0>eBX
00<0000003]DZ00kE:P01`0kE:P010000000>eBX03]DZ03D?AT603]DZ0030000000kE:P0>eBX00<0
e3dI1@0kE:P010000000>eBX03]DZ03D?AT503]DZ0030000000kE:P0>eBX00L0>eBX00D0000003]D
Z00kE:P0>eBX0=@m6@0403]DZ0030=@m6@0kE:P0>eBX00D000000P0nFK401@000000?UVa03iI/@0n
FK40e3dI00<0?UVa00D0000003iI/@0nFK40?UVa0=@m6@0403iI/@070000003oE280oe@R0000003o
DR40000003eIZ`020?mB8@050000003oDR40oe8Q0?mB8@000000103oCQl00`000000odhO0?m>7`02
000000<0odPL0`0000000`3J?1L0?EV[0000000?0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[
0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[
0?ofkP3om^h01P0mFJ/50?ofkPD0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP800000EP3om^h1
0?ooo`003P3om^h00`000000ooK^0?ofkP060?ofkPH00000;`3om^h00`0mFJ/0ooK^0?ofkP0B0?of
kP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h01P3om^h403eIZ`P0ooK^00<0?EV[0?of
kP3om^h0103om^h00`0mFJ/0ooK^0?ofkP070?ofkP80e3dI100hCid00`3D?AT0>4nM03Q?W@0203Q?
W@030000000hCid0>4nM00<0e3dI1@0hCid00`000000>4nM03Q?W@0303Q?W@80000000<0e3dI0000
000000000P00000803]DZ0050000000kE:P0>eBX03]DZ03D?AT01@0kE:P00`000000>eBX03]DZ007
03]DZ0050000000kE:P0>eBX03]DZ03D?AT01@0kE:P30=@m6@P0>eBX00D0000003]DZ00kE:P0>eBX
0=@m6@0403]DZ0030000000kE:P0>eBX00L0>eBX00D0000003]DZ00kE:P0>eBX0=@m6@0203]DZ003
0000003D?AT00000008000001P0nFK400`000000?UVa03iI/@0203iI/@050=@m6@0nFK40?UVa03iI
/@0000000P0nFK400`3D?AT0?UVa03iI/@0303iI/@070000003oE280oe@R0?mD8P000000oe8Q03eI
Z`020?mB8@030000003oDR40oe8Q0080oe8Q00D000000?m>7`3oCQl0odhO000000020?m>7`800000
0P3oB1`01`000000odPL000000000000fS`G0000000mFJ/03`3om^h00`0mFJ/0ooK^0?ofkP050?of
kP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h02`3om^h0100mFJ/0ooK^0?ofkP3om^h6
03eIZ`D0ooK^1P0mFJ/50?ofkP0303eIZ`3om^h0?EV[00D0ooK^00<000000?ofkP000000E@3om^h1
0?ooo`003P3om^h00`000000ooK^0?ofkP06000003D0ooK^00<0?EV[0?ofkP3om^h04P3om^h00`0m
FJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP0000002@3om^h00`0m
FJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00D0ooK^0`0mFJ/20=@m6@@0>4nM00D0e3dI03Q?
W@0hCid0>4nM0000000403Q?W@@0e3dI2000000203]DZ0030=@m6@0kE:P0000000X0>eBX00<00000
03]DZ00kE:P00P0kE:P00`3D?AT0>eBX03]DZ00203]DZ0030000000kE:P0>eBX00L0>eBX00D00000
03]DZ00kE:P0>eBX0=@m6@0203]DZ0<0e3dI00<0>eBX0000000kE:P0200kE:P01@000000>eBX03]D
Z00kE:P0e3dI00@0>eBX00<0000003]DZ00kE:P01`0kE:P00`000000>eBX03]DZ002000000<0e3dI
00<0?UVa0000000nFK401`0nFK400`000000?UVa03iI/@0303iI/@060=@m6@0nFK40?UVa0000000n
FK40e3dI1P0nFK402@000000oe@R0?mD8P3oE28000000?mB8@0mFJ/0oe8Q000000040?mB8@800000
0P3oCQl00`000000odhO0?m>7`020?m>7`050000003oB1`0odPL0000003oB1`00P0000000`3J?1L0
000003eIZ`0?0?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0
ooK^0?ofkP080?ofkPL0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP0503eIZ`/0ooK^00<0?EV[0?ofkP0m
FJ/01@3om^h00`000000ooK^0000001E0?ofkP40oooo000>0?ofkP<00000>`3om^h00`0mFJ/0ooK^
0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^
000000080?ofkP0303eIZ`3om^h0ooK^00D0ooK^1`0mFJ/30?ofkP040000003D?AT0e3dI0=@m6@80
>4nM00<0e3dI03Q?W@0hCid00P0hCid00`000000>4nM03Q?W@03000000030=@m6@000000e3dI00@0
e3dI1P0kE:P00`3D?AT0>eBX0000000:03]DZ0050000000kE:P0>eBX03]DZ03D?AT01@0kE:P00`00
0000>eBX03]DZ00703]DZ0030000000kE:P0e3dI00<0e3dI100kE:P00`000000>eBX03]DZ00703]D
Z0030000000kE:P0>eBX0080>eBX00D0e3dI03]DZ00kE:P0>eBX0000000503]DZ0L000000P0nFK40
1@3D?AT0?UVa03iI/@0nFK40000000P0?UVa00<0000003iI/@0nFK400`0nFK401@3D?AT0?UVa0000
000nFK40e3dI00H0?UVa00<000000?mD8P3oE2800P3oE2801@000000oe8Q03eIZ`3oDR40000000@0
oe8Q00D000000?mB8@000000odhO000000040?m>7`050000003oB1`0odPL0000003oB1`00P000000
103J?1L0000003eIZ`00000>0?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h02@3o
m^h0100mFJ/0ooK^0?ofkP3om^h603eIZ`<0ooK^00@0?EV[0?ofkP3om^h0ooK^1P0mFJ/@0?ofkP04
03eIZ`3om^h0ooK^03eIZ`@0ooK^00<000000?ofkP000000E@3om^h10?ooo`003`3om^h00`000000
ooK^0?ofkP0j0?ofkP0303eIZ`3om^h0ooK^0180ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0
ooK^0?ofkP070?ofkP0303eIZ`3om^h0000000P0ooK^00<0?EV[0?ofkP3om^h01P0mFJ/90?ofkP05
0000000hCid0e3dI03Q?W@3D?AT00P0hCid00`3D?AT0>4nM00000004000000<0>eBX00<0e3dI03]D
Z00kE:P00P0kE:P00`000000>eBX0=@m6@040=@m6@0403]DZ03D?AT0>eBX000000X0>eBX00<00000
03]DZ00kE:P00P0kE:P00`3D?AT0>eBX03]DZ00203]DZ0030000000kE:P0>eBX00<0>eBX1P3D?AT2
03]DZ0030=@m6@0kE:P0>eBX00<0>eBX00<0000003]DZ00kE:P01`0kE:P00`000000>eBX03]DZ002
03]DZ0030=@m6@0kE:P0000000L00000100nFK400`000000?UVa03iI/@030=@m6@<0?UVa00<00000
03iI/@0nFK401P0nFK400`000000?UVa03iI/@0303iI/@040=@m6@0nFK4000000=@m6@L0?UVa00X0
00000?mD8P3oE280oe@R0000003oE280000003eIZ`3oDR4000000`3oDR401P000000oe8Q0?mB8@00
0000odhO000000<0odhO00D000000?m>7`000000odPL000000020?m870050000003J?1L0000003eI
Z`3D?AT03P3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00L0ooK^1P0mFJ/70?of
kPH0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0403eIZ`3om^h0ooK^03eIZ`@0ooK^00<00000
0?ofkP000000E@3om^h10?ooo`00403om^h00`000000ooK^0?ofkP0i0?ofkP0303eIZ`3om^h0ooK^
01<0ooK^00<0?EV[0?ofkP3om^h04P3om^h00`0mFJ/0ooK^0?ofkP070?ofkP0403eIZ`3om^h0ooK^
000000@0ooK^1P0mFJ/50?ofkP0303eIZ`3om^h0ooK^00P0ooK^00D0000003Q?W@3D?AT000000=@m
6@02000000050=@m6@0kE:P0>eBX03]DZ00000001@0kE:P01@3D?AT0>eBX03]DZ00kE:P0000000H0
>eBX2`3D?AT303]DZ0030000000kE:P0>eBX0080>eBX00<0e3dI03]DZ00kE:P00P0kE:P60=@m6@@0
>eBX00<0000003]DZ00kE:P00P0kE:P00`3D?AT0>eBX03]DZ00203]DZ0030000000kE:P0>eBX00L0
>eBX00<0000003]DZ00kE:P00P0000001@3D?AT0000003iI/@0nFK40000000T0?UVa00<000000=@m
6@3D?AT00`0nFK400`3D?AT0?UVa0000000803iI/@030000000nFK40?UVa00D0?UVa0P3D?AT703iI
/@030000003oE280oe@R0080oe@R00D000000?mD8P000000oe8Q03eIZ`040?mB8@060000003oDR40
oe8Q0000003oCQl000000`3oCQl01@000000odhO0000003oB1`000000080odPL00D000000=Xl5`00
0000?EV[0=@m6@0>0?ofkP0303eIZ`3om^h0ooK^00H0ooK^00@0?EV[0?ofkP3om^h0ooK^1P0mFJ/2
0?ofkP0403eIZ`3om^h0ooK^0?ofkPL0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3o
m^h0ooK^0100ooK^00@0?EV[0?ofkP3om^h0?EV[1@3om^h2000005D0ooK^0@3oool00140ooK^00<0
00000?ofkP3om^h0>03om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^0180ooK^00<0
?EV[0?ofkP3om^h0203om^h703eIZ`<0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?of
kP080?ofkP80000000H0e3dI03]DZ00kE:P0e3dI03]DZ03D?AT303]DZ0030000000kE:P0>eBX00<0
>eBX00<0e3dI03]DZ00kE:P00P0kE:P00`000000>eBX03]DZ00603]DZ0030=@m6@000000>eBX00D0
>eBX3@3D?AT00`0kE:P0000003]DZ00703]DZ0030000000kE:P0>eBX0080>eBX00<0e3dI03]DZ00k
E:P00P0kE:P00`000000>eBX03]DZ00303]DZ0L000000`0nFK40103D?AT0?UVa03iI/@00000803iI
/@80e3dI1@0nFK400`3D?AT0?UVa0000000803iI/@030000000nFK40?UVa00D0?UVa00<0e3dI03iI
/@0nFK401P0nFK401@000000oe@R0?mD8P3oE28000000080oe@R00<000000?mB8@0mFJ/00`3oDR40
0`000000oe8Q0?mB8@020?mB8@030000003oCQl0odhO0080odhO00D000000?m>7`000000odPL0000
00020?m870040000003J?1L0000003eIZ`8000003P3om^h00`0mFJ/0ooK^0?ofkP020?ofkPL0?EV[
1@3om^h703eIZ`X0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0403eI
Z`3om^h0ooK^03eIZ`D0ooK^0P00001E0?ofkP40oooo000A0?ofkP030000003om^h0ooK^03P0ooK^
00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP0403eIZ`3om^h0ooK^0?ofkPP0
?EV[0P3om^h00`000000ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3o
m^h0203om^h00`000000>eBX0=@m6@0203]DZ0030=@m6@0kE:P0e3dI00<0>eBX00<0000003]DZ00k
E:P00`0kE:P01@3D?AT0>eBX03]DZ00kE:P0000000P0>eBX00<0e3dI0000000kE:P02@0kE:P00`00
0000>eBX03]DZ00203]DZ0030=@m6@0kE:P0>eBX0080>eBX00<0000003]DZ00kE:P01`0kE:P00`00
0000>eBX03]DZ00203]DZ0030=@m6@0kE:P0000000L00000100nFK400`000000?UVa03iI/@0303iI
/@040=@m6@0nFK40?UVa000000H0?UVa0P3D?AT00`000000?UVa03iI/@0503iI/@030=@m6@000000
?UVa00L0?UVa00<0000003iI/@0nFK40100nFK420=@m6@P0?UVa00D000000?mD8P3oE280oe@R0000
00030?mD8P030000000mFJ/0oe8Q0080oe8Q00<000000?mB8@3oDR400P3oDR401@000000odhO0?m>
7`3oCQl000000080odhO0P0000030?m870<0000000<0fS`G03eIZ`3D?AT02`3om^h803eIZ`<0ooK^
00<0?EV[0?ofkP3om^h01P0mFJ/30?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h0
103om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0303eIZ`3om^h0?EV[00D0ooK^00<000000?ofkP000000
E03om^h10?ooo`004P3om^h00`000000ooK^0?ofkP0h0?ofkP0303eIZ`3om^h0ooK^0180ooK^00<0
?EV[0?ofkP3om^h0403om^h603eIZ`L0ooK^00D0?EV[0?ofkP3om^h0ooK^000000050?ofkP0303eI
Z`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h0203om^h00`000000>eBX0=@m6@0303]DZ0<0e3dI
0P0kE:P00`000000>eBX03]DZ00303]DZ0030=@m6@0kE:P0>eBX0080>eBX00<0000003]DZ00kE:P0
1P0kE:P00`3D?AT0000003]DZ00803]DZ0030000000kE:P0>eBX00<0>eBX00D0e3dI03]DZ00kE:P0
>eBX0000000903]DZ0030000000kE:P0>eBX0080000000D0e3dI0000000nFK40?UVa0000000903iI
/@030000000nFK40?UVa00@0?UVa00<0e3dI03iI/@000000100nFK420=@m6@80?UVa00<0000003iI
/@0nFK401@0nFK400`3D?AT0000003iI/@0703iI/@030000000nFK40?UVa0080?UVa0P3D?AT00`00
0000?UVa0=@m6@0603iI/@050000003oE280oe@R0?mD8P000000103oE2801@000000?EV[0?mB8@3o
DR40000000@0oe8Q0P0000030?m>7`050000003oCQl0odhO0?m>7`0000000P3oB1`01`000000odPL
000000000000fS`G03eIZ`3D?AT00`3om^h803eIZ`<0ooK^00@0?EV[0?ofkP3om^h0ooK^1`0mFJ/9
0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0@
0?ofkP0303eIZ`3om^h0?EV[00D0ooK^00<000000?ofkP000000E03om^h10?ooo`004`3om^h00`00
0000ooK^0?ofkP0g0?ofkP0303eIZ`3om^h0ooK^0180ooK^00<0?EV[0?ofkP3om^h02`3om^h503eI
Z`80ooK^00<0?EV[0?ofkP3om^h0203om^h01@0mFJ/0ooK^0?ofkP3om^h0000000D0ooK^00<0?EV[
0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0403eIZ`000000>eBX0=@m6@@0>eBX00D0
e3dI03]DZ00kE:P0>eBX0000000503]DZ0050=@m6@0kE:P0>eBX03]DZ0000000200kE:P00`3D?AT0
000003]DZ00903]DZ0030000000kE:P0>eBX0080>eBX00<0e3dI03]DZ00kE:P00P0kE:P00`000000
>eBX03]DZ00203]DZ0L000000`0nFK40103D?AT0?UVa03iI/@00000903iI/@030000000nFK40?UVa
00@0?UVa00<0e3dI03iI/@0000000P0nFK420=@m6@@0?UVa00<0000003iI/@0nFK401P0nFK400`3D
?AT0?UVa03iI/@0503iI/@030000000nFK40?UVa0080?UVa00H0e3dI03iI/@0nFK40000003iI/@3D
?AT603iI/@050000003oE280oe@R0?mD8P0000000`3oE2820000000403eIZ`3oDR40oe8Q000000@0
oe8Q00D000000?mB8@000000odhO000000040?m>7`060000003oB1`0odPL0000003oB1`000001`0m
FJ/80?ofkPL0?EV[1@3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0
?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0303eIZ`3om^h0?EV[00D0ooK^00<0
00000?ofkP000000E03om^h10?ooo`00503om^h00`000000ooK^0?ofkP0f0?ofkP0303eIZ`3om^h0
ooK^0180ooK^00<0?EV[0?ofkP3om^h01@3om^h603eIZ`L0ooK^00<0?EV[0?ofkP3om^h02@3om^h0
1@0mFJ/0ooK^0?ofkP3om^h0000000D0ooK^00<0?EV[0?ofkP3om^h01P3om^h0100mFJ/0ooK^0?of
kP3om^h603eIZ`80ooK^00<0000003]DZ03D?AT0100kE:P20=@m6@0303]DZ0000000>eBX00D0>eBX
00D0e3dI03]DZ00kE:P0>eBX0000000803]DZ0030=@m6@000000>eBX00P0>eBX00<0000003]DZ00k
E:P00`0kE:P00`3D?AT0>eBX00000006000000@0?UVa00<0000003iI/@0nFK400`0nFK401@3D?AT0
?UVa03iI/@0nFK40000000P0?UVa00<0000003iI/@0nFK401@0nFK40103D?AT000000=@m6@3D?AT6
03iI/@030000000nFK40?UVa00H0?UVa00<0e3dI03iI/@0nFK401@0nFK401@000000?UVa03iI/@0n
FK40e3dI00<0?UVa00@0000003iI/@0nFK40e3dI100nFK400`000000oe@R0?mD8P020?mD8P090000
003oE280oe@R0?mD8P000000oe@R03eIZ`3oDR40000000@0oe8Q00H000000?mB8@3oDR4000000?m>
7`0000040?m>7`H0?EV[00<000000=Xl5`0mFJ/00P0000020?ofkPP0?EV[0`3om^h00`0mFJ/0ooK^
0?ofkP060?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^
0?ofkP040?ofkP0303eIZ`3om^h0ooK^0100ooK^00@0?EV[0?ofkP3om^h0?EV[0`3om^h4000005@0
ooK^0@3oool001D0ooK^00<000000?ofkP3om^h0=@3om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP0303eI
Z`3om^h0ooK^00D0?EV[3@3om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^0080ooK^
00<000000?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP040?ofkPH0?EV[203om^h2000000030=@m
6@0kE:P0>eBX00<0>eBX0`3D?AT00`000000>eBX03]DZ00303]DZ0050=@m6@0kE:P0>eBX03]DZ000
0000200kE:P00`3D?AT0000003]DZ00903]DZ00303eIZ`0kE:P0>eBX0080000000D0e3dI0000000n
FK40?UVa0000000803iI/@030000000nFK40?UVa00@0?UVa00@0e3dI03iI/@0nFK400000200nFK40
0`000000?UVa03iI/@0403iI/@<0e3dI200nFK400`000000?UVa03iI/@0603iI/@030=@m6@0nFK40
?UVa00D0?UVa00@0000003iI/@0nFK40e3dI0`0nFK401@000000?UVa03iI/@0nFK40e3dI00D00000
0`3oE2801@000000oe@R0?mD8P3oE28000000080oe@R00<0000003eIZ`000000103oDR4010000000
oe8Q0?mB8@00000603eIZ`040?m>7`000000e3dI00000080odPL00<000000=Xl5`0mFJ/00P000002
03eIZ`/0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0
ooK^00/0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0403eIZ`000000
000003eIZ`<000000P3om^h2000005@0ooK^0@3oool001H0ooK^00<000000?ofkP3om^h0=03om^h0
0`0mFJ/0ooK^0?ofkP0?0?ofkPH0?EV[4P3om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0
ooK^0080ooK^00<000000?ofkP3om^h00P3om^h703eIZ`80ooK^00<0?EV[0?ofkP3om^h02P3om^h0
0`000000?EV[0=@m6@0403]DZ0030=@m6@0kE:P0>eBX0080e3dI1@0kE:P01@3D?AT0>eBX03]DZ00k
E:P0000000P0>eBX00<0e3dI0000000kE:P0100kE:P7000000<0?UVa00D0e3dI03iI/@0nFK40?UVa
0000000803iI/@030000000nFK40?UVa00<0?UVa00@0e3dI03iI/@0nFK400000200nFK4010000000
?UVa03iI/@0nFK430=@m6@0303iI/@3D?AT0000000P0?UVa00<0000003iI/@0nFK401@0nFK400`00
0000?UVa0=@m6@0603iI/@030000003D?AT0e3dI00<0?UVa1P0000000`3D?AT0@Ejj045N^P020000
00<0oe@R00D000000?mD8P3oE280oe@R000000030?mD8P0403eIZ`3oDR40oe8Q0?mB8@H0?EV[00<0
00000?m>7`3oCQl00P3oCQl01@000000odhO0000003oB1`000000080odPL00D000000=Xl5`000000
?EV[0000000=0?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0
ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h02P3om^h600000004
03eIZ`3om^h0ooK^03eIZ`D0ooK^0P00001D0?ofkP40oooo000F0?ofkP030000003om^h0ooK^03@0
ooK^00<0?EV[0?ofkP3om^h0203om^h703eIZ`<0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0
ooK^0?ofkP090?ofkP0403eIZ`3om^h0ooK^0?ofkPH0?EV[203om^h00`0mFJ/0ooK^0?ofkP0:0?of
kP040000000mFJ/0e3dI0=@m6@@0>eBX00@0e3dI03]DZ00kE:P000000P3D?AT303]DZ0050=@m6@0k
E:P0>eBX03]DZ00000001`0kE:P010000000e3dI0000000mFJ/4000000@0?UVa00<0000003iI/@0n
FK400`0nFK401@3D?AT0?UVa03iI/@0nFK40000000P0?UVa00<0000003iI/@0nFK40100nFK400`3D
?AT0?UVa0000000903iI/@<0e3dI1@0nFK400`3D?AT0?UVa03iI/@0503iI/@030000000nFK40?UVa
00H0?UVa00<0000003iI/@3D?AT01@0nFK400`000000e3dI03iI/@0400000003045N^P000000@Ejj
00<0@Ejj00P0e3dI045N^P11G[X000000?mD8`000000oe@R000000<0oe@R00<000000?mD8P0mFJ/0
1P0mFJ/00`3oDR4000000?mB8@030?mB8@050000003oCQl0odhO0?m>7`0000000P3oCQl2000000<0
odPL0`0000000`0mFJ/000000000000<0?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3o
m^h0203om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3o
m^h0103om^h6000000L0ooK^0`0mFJ/50?ofkP800000E03om^h10?ooo`005`3om^h00`000000ooK^
0?ofkP0c0?ofkP0403eIZ`3om^h0ooK^0?ofkPL0?EV[2P3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP03
03eIZ`3om^h0ooK^00T0ooK^100mFJ/20?ofkP040000003om^h0ooK^03eIZ`P0ooK^00<0?EV[0?of
kP3om^h02`3om^h00`0mFJ/000000=@m6@0403]DZ0060=@m6@0kE:P0>eBX03]DZ0000000>eBX0P3D
?AT203]DZ0070=@m6@0kE:P0>eBX03]DZ0000000?EV[03]DZ00400000080?UVa00<0e3dI0000000n
FK40200nFK400`000000?UVa03iI/@0303iI/@040=@m6@0nFK40?UVa000000P0?UVa00<0000003iI
/@0nFK40100nFK40103D?AT0?UVa03iI/@00000603iI/@80e3dI00<0000003iI/@0nFK401@0nFK40
0`3D?AT0?UVa03iI/@0503iI/@030000000nFK40?UVa00H0?UVa00D0000003iI/@0nFK40e3dI03iI
/@03000000030=@m6@000000000000@0@Ejj00<00000045N^P11G[X01011G[X01P3D?AT000000?mD
8`3oE2<000000?mD8PH0?EV[0P3oE2800`000000?EV[0?mB8@020?mB8@030000003oDR40oe8Q0080
oe8Q0P0000030?m>7`050000003oCQl0odhO0?m>7`0000000P3oB1`01@000000odPL000000000000
?EV[00800000303om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[
0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP030?ofkP030000000mFJ/0000000@00000203om^h6
03eIZ`030?ofkP0mFJ/0ooK^00@0ooK^00<000000?ofkP000000D`3om^h10?ooo`00603om^h00`00
0000ooK^0?ofkP0b0?ofkP@0?EV[4@3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^
00T0ooK^00<0?EV[0?ofkP3om^h00`3om^h010000000ooK^0?ofkP0mFJ/90?ofkP0303eIZ`3om^h0
ooK^00X0ooK^00@0?EV[03hB2@000000e3dI100kE:P0103D?AT0>eBX03]DZ000000303]DZ0<0e3dI
1P00000603iI/@030=@m6@000000?UVa00P0?UVa00<0000003iI/@0nFK400`0nFK401@3D?AT0?UVa
03iI/@0nFK40000000L0?UVa00<0000003iI/@0nFK401@0nFK400`3D?AT0?UVa0000000303iI/@<0
e3dI0P0nFK400`000000?UVa03iI/@0503iI/@030000003D?AT0?UVa00D0?UVa00<0000003iI/@0n
FK400P0nFK47000000030=@m6@000000@Ejj0080e3dI00<00000045N^P11G[X01011G[X00`000000
@Ejj045N^P04045N^P030=@m6@000000?EV[00<0?EV[0`3oE2800`000000oe@R0?mD8P020?mD8P03
0000000mFJ/000000080oe8Q00<000000?mB8@3oDR400P3oDR400`000000oe8Q000000020?m>7`05
0000003oCQl0odhO0?m>7`0000000P3oB1`01@000000odPL000000000000?EV[00800000303om^h0
0`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h02`3om^h0
0`0mFJ/0000000000003000000030?ofkP0mFJ/0ooK^00H0ooK^1P0mFJ/20?ofkP@0?EV[00<0ooK^
03eIZ`3om^h0103om^h00`000000ooK^0000001C0?ofkP40oooo000I0?ofkP030000003om^h0ooK^
0340ooK^00<0?EV[0?ofkP3om^h04P3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^
00T0ooK^00<0?EV[0?ofkP3om^h0103om^h00`000000ooK^03eIZ`090?ofkP0303eIZ`3om^h0ooK^
00X0ooK^00<0?EV[0000000000000P3D?AT303]DZ0030=@m6@000000000000H000000`3D?AT203iI
/@030000000nFK40?UVa00H0?UVa00<0e3dI0000000nFK40200nFK400`000000?UVa03iI/@0303iI
/@040=@m6@0nFK40?UVa000000P0?UVa00<0000003iI/@0nFK40100nFK400`3D?AT0?UVa00000003
0=@m6@D0?UVa00<0000003iI/@0nFK401@0nFK400`000000e3dI03iI/@0403iI/@H000001011G[X0
10000000@Ejj045N^P11G[X20=@m6@03045N^P000000@Ejj00D0@Ejj00<00000045N^P11G[X01@11
G[X00`000000?EV[0?mD8`020?mD8`050000003oE280oe@R0?mD8P0000000`3oE2801P000000oe@R
0?mD8P0mFJ/0oe8Q000000@0oe8Q00H000000?mB8@3oDR4000000?m>7`0000040?m>7`040000003o
B1`0odPL00000080odPL00<000000=Xl5`0mFJ/00P00000;0?ofkP0303eIZ`3om^h0ooK^00L0ooK^
00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP040?ofkPL0000000<0?EV[0?ofkP3om^h0
103om^h00`0mFJ/0ooK^0?ofkP0503eIZ`80ooK^1P0mFJ/30?ofkP0303eIZ`3om^h0?EV[00D0ooK^
00<000000?ofkP000000D`3om^h10?ooo`006P3om^h00`000000ooK^0?ofkP0`0?ofkP0303eIZ`3o
m^h0ooK^0180ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3o
m^h0ooK^00@0ooK^00<000000?ofkP0mFJ/02@3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0403eIZ`00
0000e3dI00000080e3dI0P0000000`0nFK40e3dI03iI/@0203iI/@030000000nFK40?UVa00<0?UVa
1@3D?AT703iI/@030=@m6@000000?UVa00P0?UVa00L0000003iI/@0nFK40?UVa03eIZ`0nFK40e3dI
0080?UVa00<0000003iI/@0nFK401P0nFK400`000000?UVa03iI/@0303iI/@@0e3dI200nFK400`00
0000?UVa03iI/@0503iI/@030000000nFK40e3dI00@0000000<0@Ejj00000011G[X01`11G[X01@00
0000@Ejj045N^P11G[X0e3dI0080@Ejj00<00000045N^P11G[X01011G[X00`000000@Ejj045N^P05
045N^P040000003oE2<0oe@S0?mD8`8000000P3oE2800`000000oe@R0?mD8P020?mD8P060000003o
E280oe@R03eIZ`3oDR400000103oDR401P000000oe8Q0?mB8@000000odhO000000<0odhO00D00000
0?m>7`000000odPL000000020?m870030000003J?1L0?EV[00800000303om^h00`0mFJ/0ooK^0?of
kP070?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0000000000000`0000080?ofkP0303eIZ`3o
m^h0ooK^00H0?EV[00<0ooK^03eIZ`0mFJ/0100mFJ/90?ofkP0403eIZ`3om^h0ooK^03eIZ`D0ooK^
0P00001C0?ofkP40oooo000K0?ofkP030000003om^h0ooK^02l0ooK^00<0?EV[0?ofkP3om^h04P3o
m^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h0103o
m^h00`000000ooK^03eIZ`080?ofkP0303eIZ`3om^h0ooK^00P0ooK^1P0mFJ/00`000000?UVa0=@m
6@0303iI/@040=@m6@0nFK40?UVa000000D0?UVa00D0e3dI03iI/@0nFK40?UVa000000040=@m6@@0
?UVa00<0e3dI0000000nFK401`0nFK400`000000?UVa03iI/@0403iI/@030=@m6@0nFK40000000P0
?UVa1P3D?AT203iI/@030=@m6@0nFK40000000L0?UVa00<0000003iI/@0nFK400P0nFK4500000003
0=@m6@11G[X0@Ejj00<0@Ejj00<00000045N^P11G[X01@11G[X00`000000@Ejj045N^P030=@m6@03
045N^P000000@Ejj00D0@Ejj00<00000045N^P11G[X01@11G[X00`000000oe@S0?mD8`020?mD8`80
00000P3oE2801@000000oe@R0?mD8P3oE280000000<0oe@R00<0?EV[0000003oDR400`3oDR400`00
0000oe8Q0?mB8@020?mB8@030000003oCQl0odhO0080odhO00D000000?m>7`000000odPL00000002
0?m870030000003J?1L0?EV[00800000303om^h00`0mFJ/0ooK^0?ofkP070?ofkP0403eIZ`3om^h0
ooK^0?ofkPL0000000<0?EV[0?ofkP3om^h0203om^h603eIZ`030?ofkP0mFJ/0?EV[00@0?EV[3`3o
m^h0100mFJ/0ooK^0?ofkP0mFJ/50?ofkP800000D`3om^h10?ooo`006`3om^h00`000000ooK^0?of
kP0_0?ofkP0303eIZ`3om^h0ooK^0180ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?of
kP0:0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0000003eIZ`3om^h01`3om^h00`0mFJ/0ooK^0?of
kP020?ofkPH0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP030000000503iI/@3D?AT0?UVa03iI/@3D?AT0
0`0nFK400`000000?UVa03iI/@0303iI/@050=@m6@0nFK40?UVa03iI/@0000000`0nFK450=@m6@03
0000000nFK40?UVa00L0?UVa00<0000003iI/@0nFK400`0nFK401@3D?AT0?UVa03iI/@000000?UVa
00H0e3dI00<0000003iI/@0nFK401P0nFK400`3D?AT0000003iI/@0303iI/@P000000`11G[X01000
0000@Ejj045N^P3D?AT4045N^P0300000011G[X0@Ejj00D0@Ejj00<000000=@m6@3D?AT00`11G[X0
0`3D?AT00000045N^P05045N^P0300000011G[X0@Ejj00@0@Ejj00<000000?mD8`3oE2<00P3oE2<0
0`000000oe@S0?mD8`02000000<0oe@R00<000000?mD8P3oE2800P3oE2800`0mFJ/000000?mB8@03
0?mB8@030000003oDR40oe8Q0080oe8Q00D000000?m>7`3oCQl0odhO000000020?m>7`8000000`3o
B1`20000000403eIZ`3J?1L00000000000/0ooK^00<0?EV[0?ofkP3om^h01@3om^h20000000403eI
Z`0000000000000000L0ooK^00@0?EV[0?ofkP3om^h0ooK^3P0mFJ/20?ofkP0303eIZ`3om^h0ooK^
0140ooK^00<0?EV[0?ofkP0mFJ/01@3om^h2000005<0ooK^0@3oool001`0ooK^00<000000?ofkP3o
m^h0;P3om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3o
m^h02P3om^h00`0mFJ/0ooK^0?ofkP050?ofkP030000000mFJ/0ooK^00L0ooK^1@0mFJ/80?ofkP03
03eIZ`3om^h0ooK^00<000000P0nFK420=@m6@0303iI/@3D?AT0?UVa0080?UVa00<0000003iI/@0n
FK400P0nFK400`3D?AT0?UVa03iI/@0203iI/@030000000nFK40?UVa00@0?UVa5P3D?AT703iI/@03
0000000nFK40?UVa0080?UVa0`0000000`3D?AT0000000000003000000<0@Ejj00<00000045N^P11
G[X01@11G[X010000000@Ejj045N^P3D?AT4045N^P0300000011G[X0@Ejj00D0@Ejj00<0e3dI045N
^P11G[X00`11G[X00`3D?AT00000045N^P05045N^P0300000011G[X0@Ejj00@0@Ejj00<000000?mD
8`3oE2<00P3oE2<00`000000oe@S0?mD8`02000000<0oe@R00<000000?mD8P3oE2800P3oE2800`00
0000?EV[0?mB8@020?mB8@030000003oDR40oe8Q0080oe8Q0P0000030?m>7`050000003oCQl0odhO
0?m>7`0000000P3oB1`01@000000odPL000000000000?EV[008000002`3om^h00`0mFJ/000000000
000500000080ooK^00<0?EV[0?ofkP3om^h01@3om^h>03eIZ`<0ooK^00<0?EV[0?ofkP3om^h00`3o
m^h00`0mFJ/0ooK^0?ofkP0A0?ofkP0303eIZ`3om^h0?EV[00D0ooK^00<000000?ofkP000000DP3o
m^h10?ooo`007@3om^h00`000000ooK^0?ofkP0]0?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[
0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[
0?ofkP3om^h01`0mFJ/=0?ofkP0303eIZ`3om^h0ooK^00<000000`0nFK420=@m6@@0?UVa00<00000
03iI/@0nFK400P0nFK401@3D?AT0?UVa03iI/@0nFK40000000P0?UVa00<0e3dI0000000nFK401`0n
FK400`000000?UVa03iI/@0303iI/@030=@m6@0nFK40000000L0?UVa1P000004045N^P030=@m6@11
G[X0@Ejj00D0@Ejj00<00000045N^P11G[X01@11G[X01@000000@Ejj045N^P11G[X0e3dI00<0@Ejj
00<00000045N^P11G[X00`11G[X20=@m6@0300000011G[X0@Ejj00<0@Ejj00<000000=@m6@11G[X0
1011G[X00`000000@Ejj045N^P04045N^P030000003oE2<0oe@S0080oe@S00D000000?mD8`3oE2<0
oe@S000000030?mD8P030000003oE280oe@R00<0oe@R00<0000003eIZ`0000000P3oDR400`000000
oe8Q0?mB8@020?mB8@030000003oDR4000000080odhO00D000000?m>7`3oCQl0odhO000000020?m8
70050000003oB1`000000000000mFJ/00`0000050?ofkPD0000000<0?EV[0?ofkP3om^h0203om^h=
03eIZ`/0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0303eIZ`3om^h0
?EV[00D0ooK^00<000000?ofkP000000DP3om^h10?ooo`007P3om^h00`000000ooK^0?ofkP0/0?of
kP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP090?of
kP0303eIZ`3om^h0ooK^00<0ooK^1P0mFJ/70?ofkP0303eIZ`3om^h0ooK^00X0ooK^00L0?EV[0?of
kP3om^h0?EV[0000001M70h0000000<0?UVa0P3D?AT303iI/@030000000nFK40?UVa0080?UVa00<0
e3dI03iI/@0nFK400P0nFK400`000000?UVa03iI/@0503iI/@030=@m6@000000?UVa00L0?UVa00<0
000003iI/@0nFK40100nFK400`3D?AT0?UVa0000000203iI/@@0000000<0@Ejj00000011G[X01`11
G[X00`3D?AT0@Ejj045N^P05045N^P0300000011G[X0@Ejj00D0@Ejj00D00000045N^P11G[X0@Ejj
0=@m6@03045N^P0400000011G[X0@Ejj045N^P80e3dI00<0@Ejj00000011G[X01@11G[X00`000000
e3dI045N^P04045N^P0300000011G[X0@Ejj00@0@Ejj00D000000?mD8`3oE2<0oe@S000000030?mD
8`8000000`3oE2800`000000oe@R0?mD8P020?mD8P060000003oE280?EV[0000003oDR400000103o
DR401P000000oe8Q0?mB8@000000odhO000000@0odhO00@000000?m8703oB1`000000P3oB1`00`00
0000?EV[00000007000000D0ooK^00@0?EV[0?ofkP3om^h0ooK^300mFJ/50?ofkP0303eIZ`3om^h0
ooK^00`0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0303eIZ`3om^h0
?EV[00D0ooK^00<000000?ofkP000000DP3om^h10?ooo`007`3om^h00`000000ooK^0?ofkP0[0?of
kP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP080?of
kPL0?EV[0`3om^h00`0mFJ/000000?ofkP070?ofkP0303eIZ`3om^h0ooK^00L0ooK^1P0mFJ/01@3o
m^h000000000001M70h0000000<0?UVa00<0e3dI03iI/@0nFK400P0nFK400`000000?UVa03iI/@02
03iI/@030=@m6@0nFK40?UVa0080?UVa00<0000003iI/@0nFK401@0nFK400`3D?AT0000003iI/@07
03iI/@030000000nFK40?UVa0080?UVa00<000000=@m6@0000000`000006045N^P0300000011G[X0
@Ejj00D0@Ejj00<000000=@m6@11G[X01@11G[X00`000000@Ejj045N^P05045N^P0300000011G[X0
@Ejj0080@Ejj00<0e3dI045N^P0000000`11G[X01@3D?AT0@Ejj045N^P11G[X0000000H0@Ejj00<0
0000045N^P3D?AT00`11G[X00`000000@Ejj045N^P04045N^P030000003oE2<0oe@S0080oe@S00T0
00000?mD8`3oE2<0oe@S0000003oE2<000000?mD8P000000103oE2801@000000oe@R0?mD8P0mFJ/0
oe@R00800000103oDR401P000000oe8Q0?mB8@000000odhO000000<0odhO00D000000?m>7`000000
odPL000000020?m870030000000mFJ/00000008000001P3om^h=03eIZ`80ooK^00<0?EV[0?ofkP3o
m^h01`3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3o
m^h0403om^h00`0mFJ/0ooK^03eIZ`060?ofkP800000DP3om^h10?ooo`00803om^h00`000000ooK^
0?ofkP0[0?ofkP0303eIZ`3om^h0ooK^0180ooK^00<0?EV[0?ofkP3om^h04`3om^h0100mFJ/0ooK^
0?ofkP3om^h703eIZ`030?ofkP0mFJ/0ooK^00L0ooK^00<0?EV[0?ofkP0000001`3om^h0100mFJ/0
ooK^0?ofkP3om^h603eIZ`<0ooK^00<0?EV[0?ofkP3om^h00P3om^h20000000305dL3P000000?UVa
0080?UVa0P3D?AT303iI/@030000000nFK40?UVa0080?UVa00<0e3dI03iI/@0nFK400P0nFK400`00
0000?UVa03iI/@0403iI/@030=@m6@000000?UVa00@0?UVa20000002045N^P030=@m6@000000@Ejj
00L0@Ejj00<00000045N^P11G[X01P11G[X00`3D?AT0@Ejj045N^P04045N^P0300000011G[X0@Ejj
00D0@Ejj00<00000045N^P11G[X00P11G[X0103D?AT0@Ejj00000011G[X20=@m6@@0@Ejj00<00000
045N^P11G[X00`11G[X010000000@Ejj045N^P3D?AT3045N^P0300000011G[X0@Ejj00@0@Ejj00D0
00000?mD8`3oE2<0oe@S000000030?mD8`060000003oE2<0oe@S0000003oE2800000103oE2801P00
0000oe@R0?mD8P3oE280?EV[000000@0oe8Q00H000000?mB8@3oDR40oe8Q0=@m6@0000040?m>7`05
0000003oCQl000000=@m6@0000000P3oB1`00`000000fS`G03eIZ`02000000H0?EV[00<0ooK^03eI
Z`0mFJ/0100mFJ/80?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0m
FJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^0100ooK^00@0?EV[0?ofkP3om^h0?EV[1@3om^h2
00000580ooK^0@3oool00200ooK^00<000000?ofkP3om^h0:`3om^h00`0mFJ/0ooK^0?ofkP0B0?of
kP0303eIZ`3om^h0ooK^0100ooK^1`0mFJ/90?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?of
kP000000103om^h603eIZ`T0ooK^00<0?EV[0?ofkP3om^h00P3om^h01@0mFJ/000000000001M70h0
00000080?UVa00@0e3dI03iI/@3D?AT0e3dI0P0nFK401@000000?UVa03iI/@0nFK40e3dI00@0?UVa
00<0000003iI/@0nFK400`0nFK42000000030=@m6@000000000000<000001011G[X00`000000@Ejj
045N^P03045N^P030=@m6@11G[X0000000L0@Ejj00<00000045N^P11G[X01P11G[X00`000000e3dI
045N^P04045N^P0300000011G[X0@Ejj00D0@Ejj00<00000045N^P11G[X00`11G[X30=@m6@H0@Ejj
00<00000045N^P11G[X00`11G[X010000000@Ejj045N^P3D?AT2045N^P0400000011G[X0@Ejj045N
^P@000000`3oE2<01@000000oe@S0?mD8`3oE2<0000000@0oe@S00<000000?mD8P3oE2800P3oE280
0`000000oe@R0?mD8P020?mD8P0303eIZ`000000oe8Q0080oe8Q00<000000?mB8@3oDR400`3oDR40
1@000000odhO0?m>7`3oCQl000000080odhO0P0000030?m87080000000@0?EV[0=Xl5`0000000000
1P0mFJ/30?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^
0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h0403om^h0100mFJ/0ooK^
0?ofkP0mFJ/50?ofkP800000DP3om^h10?ooo`008@3om^h00`000000ooK^0?ofkP0Z0?ofkP0303eI
Z`3om^h0ooK^0180ooK^00<0?EV[0?ofkP3om^h02@3om^h703eIZ`<0ooK^00<0?EV[0?ofkP3om^h0
2P3om^h00`0mFJ/0ooK^0?ofkP060?ofkPL0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eI
Z`3om^h0ooK^00<0ooK^1000000303iI/@030=@m6@0nFK40?UVa0080e3dI00<0000003iI/@0nFK40
0P0nFK40103D?AT0?UVa03iI/@0nFK46000000<0@Ejj00<0e3dI00000011G[X01P11G[X00`000000
@Ejj045N^P04045N^P030=@m6@000000@Ejj00L0@Ejj00<00000045N^P11G[X01@11G[X00`000000
e3dI045N^P05045N^P0300000011G[X0@Ejj00@0@Ejj00<00000045N^P11G[X00P11G[X20=@m6@03
00000011G[X0@Ejj00@0@Ejj00<00000045N^P11G[X00`11G[X01P000000@Ejj045N^P11G[X00000
0=@m6@D000000P13H/82000000<0oe@S00D000000?mD8`3oE2<0oe@S000000030?mD8`800000103o
E2800`000000oe@R0?mD8P020?mD8P0303eIZ`3oE28000000080oe8Q00<000000?mB8@3oDR400P3o
DR42000000<0odhO00D000000?m>7`3oCQl0e3dI000000020?m870030000000mFJ/0?EV[00@0?EV[
2@3om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h0
303om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^0100ooK^00@0?EV[0?ofkP3om^h0
?EV[1@3om^h200000580ooK^0@3oool00280ooK^00<000000?ofkP3om^h0:@3om^h00`0mFJ/0ooK^
0?ofkP0B0?ofkP0403eIZ`3om^h0ooK^0?ofkPP0?EV[2P3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP04
03eIZ`3om^h0ooK^0?ofkPH0?EV[0P3om^h00`000000ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^
00/0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0000005dL3P0200000080?UVa00<0e3dI03iI
/@0nFK400P0nFK420=@m6@<0?UVa00@0e3dI00000000000000000P11G[X00`000000@Ejj045N^P04
045N^P030=@m6@000000@Ejj00L0@Ejj00<00000045N^P11G[X00`11G[X00`3D?AT0@Ejj00000007
045N^P0300000011G[X0@Ejj00D0@Ejj00<00000045N^P3D?AT01@11G[X00`000000@Ejj045N^P04
045N^P030000003D?AT0e3dI0080e3dI00<0@Ejj0=@m6@0000001P11G[X010000000@Ejj045N^P11
G[X60000000304=R`P3D?AT0@f;200H0@f;200D000000?mD8`000000oe@S000000030?mD8`030000
003oE2<0oe@S0080oe@S00<000000?mD8`0000000P3oE2800`000000oe@R0?mD8P020?mD8P060000
000mFJ/0oe@R0000003oDR4000001@3oDR400`000000oe8Q000000020?m>7`030000003oCQl0?EV[
00D0?EV[00@0odPL0000000mFJ/0fS`G0`0000090?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[
0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[
0?ofkP3om^h03`3om^h403eIZ`D0ooK^00<000000?ofkP000000D@3om^h10?ooo`008`3om^h00`00
0000ooK^0?ofkP0X0?ofkP0303eIZ`3om^h0ooK^0100ooK^1P0mFJ/C0?ofkP0303eIZ`3om^h0ooK^
00T0ooK^100mFJ/50?ofkP0503eIZ`3om^h0ooK^0?ofkP000000103om^h00`0mFJ/0ooK^0?ofkP0;
0?ofkP0303eIZ`3om^h0ooK^0080ooK^00@0?EV[000000000000GA`>0P00000203iI/@030=@m6@0n
FK40?UVa00<000000P3D?AT00`000000@Ejj0=@m6@05045N^P0300000011G[X0@Ejj00@0@Ejj00<0
e3dI00000011G[X01P11G[X00`000000@Ejj045N^P04045N^P030=@m6@000000@Ejj00H0@Ejj00<0
0000045N^P11G[X01@11G[X00`000000@Ejj0=@m6@05045N^P0300000011G[X0@Ejj0080@Ejj0`3D
?AT6045N^P030=@m6@11G[X0@Ejj00<0@Ejj1@00000204=R`P0300000013H/80@f;200<0@f;200<0
e3dI04=R`P13H/800P13H/801`3D?AT000000?mD8`3oE2<000000?mD8`0000000P3oE2<00`000000
oe@S0?mD8`020?mD8`060000003oE2<0oe@S0000003oE2800000103oE2801@000000oe@R0?mD8P0m
FJ/0oe@R00800000103oDR400`000000oe8Q03eIZ`0503eIZ`030?m>7`00000000000080odPL00D0
00000?m8703oB1`0?EV[0=Xl5`03000000T0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^
0?ofkP070?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^
0?ofkP080?ofkPL0?EV[00@0ooK^03eIZ`3om^h0?EV[1@3om^h00`000000ooK^0000001A0?ofkP40
oooo000T0?ofkP030000003om^h0ooK^02L0ooK^00<0?EV[0?ofkP3om^h02`3om^h503eIZ`80ooK^
00<0?EV[0?ofkP3om^h0503om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^00H0ooK^
00D0?EV[0?ofkP3om^h0ooK^000000050?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3o
m^h00P3om^h00`0mFJ/0ooK^000000020000000405dL3P00000000000=@m6@8000001011G[X01000
0000e3dI0=@m6@3D?AT5045N^P0300000011G[X0@Ejj00D0@Ejj00<0e3dI00000011G[X01P11G[X0
0`000000@Ejj045N^P03045N^P030=@m6@11G[X0000000H0@Ejj00<00000045N^P11G[X01@11G[X0
10000000@Ejj045N^P3D?AT4045N^P0300000011G[X0e3dI0080e3dI0P11G[X00`000000@Ejj045N
^P04045N^P030=@m6@11G[X0000000<0000000<0@f;200000013H/800`13H/800`000000@f;204=R
`P0404=R`P080=@m6@13H/80@f;204=R`P3D?AT0@f;20000000mFJ/20?mD8`050000003oE2<0oe@S
0?mD8`0000000`3oE2<00`000000oe@S0?mD8`020?mD8`800000103oE2801`000000oe@R0?mD8P0m
FJ/0oe@R0000003oDR401P0mFJ/0103oDR4000000?m>7`0000030?m>7`050000003oCQl000000?m8
700000000P3oB1`00`000000?EV[00000002000000T0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0m
FJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h00`3om^h0100m
FJ/0ooK^0?ofkP3om^h703eIZ`P0ooK^00<0?EV[0?ofkP0mFJ/01P3om^h200000540ooK^0@3oool0
02D0ooK^00<000000?ofkP3om^h09P3om^h00`0mFJ/0ooK^0?ofkP050?ofkPH0?EV[1`3om^h00`0m
FJ/0ooK^0?ofkP0D0?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0m
FJ/0ooK^0?ofkP020?ofkP030000003om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0m
FJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0000000<0000000@0GA`>00000011G[X0e3dI1P11G[X0
0`000000@Ejj0=@m6@030=@m6@<0@Ejj00<00000045N^P11G[X01011G[X00`3D?AT00000045N^P06
045N^P0300000011G[X0@Ejj00@0@Ejj00<0e3dI00000011G[X01P11G[X00`000000@Ejj045N^P05
045N^P0300000011G[X0e3dI0080@Ejj103D?AT5045N^P0400000011G[X0@Ejj045N^P@0000000<0
e3dI04=R`P13H/800P13H/800`000000@f;204=R`P0304=R`P0300000013H/80@f;200<0@f;200<0
000004=R`P3D?AT00P3D?AT01@13H/8000000?mD8`0mFJ/0oe@S008000000P3oE2<00`000000oe@S
0?mD8`020?mD8`030000003oE2<0oe@S0080oe@S00<000000?mD8P3oE2800P3oE2800`000000?EV[
03eIZ`0503eIZ`<0oe8Q00<000000?mB8@3oDR400P3oDR401@000000odhO0?m>7`3oCQl000000080
odhO00<000000?m8700000000P3oB1`00`000000?EV[00000002000000T0ooK^00<0?EV[0?ofkP3o
m^h02@3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3o
m^h01`0mFJ/=0?ofkP<0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP800000D@3om^h10?ooo`00
9@3om^h00`000000ooK^0?ofkP0V0?ofkP0303eIZ`3om^h0ooK^00D0?EV[3P3om^h00`0mFJ/0ooK^
0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h01`3om^h01@0mFJ/0ooK^
0?ofkP3om^h0000000@0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP03
03eIZ`3om^h0ooK^00H0000000<0e3dI045N^P11G[X01@11G[X01@000000@Ejj045N^P3D?AT0@Ejj
00D0e3dI1P11G[X00`3D?AT00000045N^P06045N^P0300000011G[X0@Ejj00<0@Ejj00<0e3dI045N
^P0000001P11G[X00`000000@Ejj045N^P05045N^P030000003D?AT0e3dI0080e3dI0P11G[X01000
0000@Ejj045N^P11G[X7000000<0@f;200<000000=@m6@13H/800`13H/800`000000@f;204=R`P03
04=R`P0300000013H/80@f;200<0@f;200<0000004=R`P3D?AT00`13H/8010000000oe@S03eIZ`3o
E2<2000000030?mD8`000000oe@S00<0oe@S00@000000?mD8`3oE2<0oe@S200mFJ/30?mD8P0403eI
Z`3oE280oe@R00000080oe8Q00<000000?mB8@3oDR400`3oDR401@000000odhO0?m>7`3oCQl00000
0080odhO0P0000020?m870050000003oB1`0?EV[0000003J?1L00P0000080?ofkP0303eIZ`3om^h0
ooK^00T0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP080?ofkPL0?EV[0`3om^h0
0`0mFJ/0ooK^0?ofkP080?ofkPH0?EV[0P3om^h0100mFJ/0ooK^0?ofkP0mFJ/50?ofkP800000D@3o
m^h10?ooo`009P3om^h00`000000ooK^0?ofkP0U0?ofkP<0?EV[4`3om^h00`0mFJ/0ooK^0?ofkP0C
0?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP02
0?ofkP050000003om^h0ooK^0?ofkP0mFJ/0303om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3o
m^h0ooK^00L000000P3D?AT6045N^P0300000011G[X0e3dI00H0@Ejj1@3D?AT01011G[X0e3dI045N
^P000007045N^P0300000011G[X0@Ejj00<0@Ejj00<0e3dI00000011G[X01@11G[X00`000000@Ejj
045N^P060=@m6@80@Ejj00<0e3dI0000000000001@00000304=R`P0300000013H/80@f;200@0@f;2
00<0000004=R`P3D?AT00`13H/800`000000@f;204=R`P0204=R`P0300000013H/80@f;200<0@f;2
00@000000=@m6@3D?AT0e3dI0P13H/801@000000oe@S0?mD8`3oE2<0?EV[0080oe@S0P00000803eI
Z`040?mD8`000000oe@S00000080oe@R00<000000?mD8P3oE2800P3oE280100mFJ/0oe@R0?mD8P00
00020?mB8@030000003oDR40oe8Q0080oe8Q0P0000020?m>7`030000003oCQl0odhO0080odhO00P0
00000?m8703oB1`000000?m8700mFJ/000000=Xl5`800000203om^h00`0mFJ/0ooK^0?ofkP090?of
kP0303eIZ`3om^h0ooK^00H0ooK^00@0?EV[0?ofkP3om^h0ooK^1`0mFJ/50?ofkP0303eIZ`3om^h0
ooK^0080ooK^00<0?EV[0?ofkP3om^h00P3om^h603eIZ`P0ooK^00@0?EV[0?ofkP3om^h0?EV[1@3o
m^h200000540ooK^0@3oool002L0ooK^00<000000?ofkP3om^h0903om^h00`0mFJ/0ooK^0?ofkP0C
0?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP06
0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00@000000?ofkP3om^h0?EV[3@3om^h00`0mFJ/0ooK^0?of
kP020?ofkP0303eIZ`3om^h0ooK^00800000100mFJ/00`000000@Ejj045N^P06045N^P0300000011
G[X0e3dI00H0@Ejj00@00000045N^P11G[X0@Ejj2P3D?AT00`11G[X00000045N^P04045N^P030=@m
6@11G[X000000080@Ejj1P3D?AT2045N^PL0000000@0e3dI04=R`P13H/8000001P13H/800`000000
@f;204=R`P0304=R`P0400000013H/80@f;20=@m6@80@f;200<0000004=R`P13H/800`13H/800`00
0000@f;204=R`P0204=R`P80e3dI0`13H/800`3D?AT000000?mD8`020?mD8`H0?EV[0`3oE2<00`00
0000oe@S0?mD8`020?mD8`060000003oE2<0oe@S0000003oE2800000103oE2801`000000oe@R03eI
Z`3oE28000000?mB8@0000001@3oDR4200000080odhO00<000000?m>7`3oCQl00P3oCQl020000000
odPL0?m870000000odPL03eIZ`000000fS`G0P0000090?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0
?EV[0?ofkP3om^h00`3om^h703eIZ``0ooK^00@0?EV[0?ofkP3om^h0ooK^1P0mFJ/>0?ofkP0403eI
Z`3om^h0ooK^03eIZ`D0ooK^00<000000?ofkP000000D03om^h10?ooo`00:03om^h00`000000ooK^
0?ofkP0S0?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h0503om^h00`0mFJ/0ooK^
0?ofkP090?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h00`3om^h010000000ooK^
0?ofkP0mFJ/=0?ofkP0403eIZ`3om^h0ooK^0?ofkPH0?EV[00H0000005dL3P000000000007`W4P00
0008045N^P030000003D?AT0@Ejj00H0@Ejj00<00000045N^P11G[X00P11G[X00`3D?AT0@Ejj0000
0005045N^P`0e3dI0P11G[X6000000<0@f;200D0000004=R`P13H/80@f;20=@m6@0204=R`P030000
0013H/80@f;200@0@f;200<0000004=R`P13H/800`13H/801`000000@f;204=R`P13H/80e3dI04=R
`P0000001013H/8010000000@f;204=R`P13H/820=@m6@0304=R`P000000@f;20080@f;200<0e3dI
0000000mFJ/00P0mFJ/00`000000?EV[0?mD8`02000000<0oe@S00<000000?mD8`3oE2<00P3oE2<0
0`000000oe@S0?mD8`020?mD8`8000000`3oE28010000000oe@R0?mD8P0mFJ/20?mD8P800000103o
DR400`000000oe8Q0?mB8@02000000@0odhO0P0000000`3oB1`000000?m870020?m8700403eIZ`3D
?AT00000000000T0ooK^00<0?EV[0?ofkP3om^h0203om^h603eIZ`<0ooK^00<0?EV[0?ofkP3om^h0
2P3om^h703eIZ`030?ofkP0mFJ/0ooK^0180ooK^00<0?EV[0?ofkP0mFJ/01@3om^h00`000000ooK^
0000001@0?ofkP40oooo000Y0?ofkP030000003om^h0ooK^02<0ooK^00<0?EV[0?ofkP3om^h04P3o
m^h00`0mFJ/0ooK^0?ofkP0D0?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h01P3o
m^h00`0mFJ/0ooK^0?ofkP040?ofkP030000003om^h0?EV[00X0ooK^1`0mFJ/00`3om^h0?EV[0?of
kP020?ofkP040000000n4PT0000005dL3P80000000<0O2LB0000000000001`11G[X00`000000e3dI
045N^P05045N^P0300000011G[X0@Ejj00<0@Ejj00<0e3dI045N^P0000001P11G[X00`000000@Ejj
045N^P02045N^P80000000<0e3dI0000000000000P00000204=R`P0300000013H/80@f;200D0@f;2
00L0000004=R`P13H/80@f;20=@m6@13H/80000000H0@f;200<0000004=R`P13H/800`13H/801`00
0000@f;204=R`P13H/80e3dI04=R`P0000001013H/8010000000@f;20=@m6@3D?AT204=R`P030000
0013H/80@f;20080@f;200D000000?mD8`3oE2<0oe@S000000020?mD8`0603eIZ`000000oe@S0000
003oE2<00000103oE2<00`000000oe@S0?mD8`030?mD8`050000003oE280oe@R0?mD8P0000000`3o
E280100mFJ/0oe@R0?mD8P0000040?mB8@040000003oDR40oe8Q0?mB8@800000103oCQl200000003
0?m870000000odPL0080odPL00@0?EV[0=@m6@00000000002@3om^h0100mFJ/0ooK^0?ofkP3om^h7
03eIZ`030?ofkP0mFJ/0ooK^00H0ooK^00<0?EV[0?ofkP3om^h00P3om^h803eIZ`<0ooK^00<0?EV[
0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP0303eIZ`3om^h0?EV[00H0ooK^0P00001@
0?ofkP40oooo000Z0?ofkP030000003om^h0ooK^0280ooK^00<0?EV[0?ofkP3om^h04P3om^h00`0m
FJ/0ooK^0?ofkP0D0?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0m
FJ/0ooK^0?ofkP040?ofkP030000003om^h0?EV[0080ooK^1`0mFJ/30?ofkP0303eIZ`3om^h0ooK^
00H0?EV[00D0ooK^000000000000000005dL3P0200000080O2LB00<00000045N^P11G[X01@11G[X0
0`3D?AT0@Ejj045N^P05045N^P0300000011G[X0@Ejj0080@Ejj00<0e3dI045N^P0000001011G[X7
00000080@f;200<0e3dI04=R`P0000001@13H/800`000000@f;204=R`P0404=R`P0700000013H/80
@f;204=R`P3D?AT0@f;20000000604=R`P0300000013H/80@f;200<0@f;200<0000004=R`P13H/80
0P13H/800`3D?AT0000004=R`P0304=R`P80e3dI1013H/800`000000@f;204=R`P0204=R`P040000
003oE2<0oe@S000000<0oe@S00H0?EV[0?mD8`3oE2<000000?mD8`0000040?mD8`030000003oE2<0
oe@S0080oe@S0P0000020?mD8P030000003oE280oe@R0080oe@R00@0?EV[0?mD8P0000000000103o
DR401@000000oe8Q0?mB8@3oDR40000000@0odhO00D000000?m>7`3oCQl000000=@m6@030?m87003
03eIZ`3D?AT0000000800000103om^h803eIZ`P0ooK^00<0?EV[0?ofkP3om^h00P3om^h803eIZ`/0
ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0403eIZ`3om^h0ooK^03eI
Z`D0ooK^0P00001@0?ofkP40oooo000Z0?ofkP030000003om^h0ooK^0280ooK^00<0?EV[0?ofkP3o
m^h04`3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3o
m^h01`3om^h0100mFJ/0ooK^0?ofkP3om^h803eIZ`L0ooK^1P0mFJ/20?ofkP0303eIZ`3om^h0ooK^
00<0ooK^0`0000001P1M70h00000000000000000O2LB000000L0@Ejj00<0e3dI045N^P11G[X01@11
G[X00`000000@Ejj045N^P02045N^P030=@m6@000000000000<000001013H/800`000000@f;204=R
`P0304=R`P030=@m6@000000@f;200@0@f;200<0000004=R`P13H/801013H/800`000000@f;204=R
`P0204=R`P030=@m6@000000@f;200D0@f;200<0000004=R`P13H/800`13H/800`000000@f;204=R
`P0204=R`P040=@m6@13H/80@f;204=R`P80e3dI1@13H/800`000000@f;204=R`P0204=R`P040000
003oE2<0oe@S000000<0oe@S00<0000003eIZ`3oE2<00P3oE2<00`000000oe@S0?mD8`020?mD8`03
0000003oE2<0oe@S0080oe@S00<000000?mD8`0000000P3oE2800`000000oe@R0?mD8P020?mD8P05
03eIZ`000000oe@R0?mD8P0000000P3oDR4010000000oe8Q0?mB8@3oDR42000000@0odhO00D00000
0?m>7`3oCQl000000=@m6@020?m870040000000mFJ/0e3dI0=Xl5`H0?EV[103om^h00`0mFJ/0ooK^
0?ofkP070?ofkPL0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00<0ooK^
00<0?EV[0?ofkP3om^h0403om^h0100mFJ/0ooK^0?ofkP0mFJ/50?ofkP800000D03om^h10?ooo`00
:`3om^h00`000000ooK^0?ofkP0Q0?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h0
4`3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00@0ooK^1P0mFJ/40?ofkP030000
000mFJ/0ooK^0080ooK^1P0mFJ/40?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/01@3om^h300000080
GA`>00D0000007`W4P000000O2LB00000006045N^P030=@m6@000000@Ejj00<0@Ejj1`000000103D
?AT0@f;204=R`P00000604=R`P0300000013H/80@f;200<0@f;200<0e3dI04=R`P0000001@13H/80
0`000000@f;204=R`P0304=R`P0300000013H/80@f;20080@f;200<0e3dI00000013H/801@13H/80
0`000000@f;204=R`P0304=R`P0300000013H/80@f;20080@f;200H000000=@m6@3D?AT0e3dI04=R
`P00000504=R`P0300000013H/80@f;20080@f;200@000000?mD8`3oE2<000000`3oE2<010000000
?EV[0?mD8`3oE2<2000000<0oe@S00<000000?mD8`3oE2<00P3oE2<010000000oe@S0?mD8`3oE2<2
000000D0oe@R00L0000003eIZ`3oE280oe@R0000003oDR40000000@0oe8Q00<000000?mB8@000000
0P3oCQl01@000000odhO0?m>7`3oCQl0000000<0odPL00<0000003eIZ`3D?AT00P3J?1L00`000000
ooK^0?ofkP060?ofkP0403eIZ`3om^h0ooK^0?ofkPH0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP050?of
kP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP0@0?of
kP@0?EV[1@3om^h200000500ooK^0@3oool002`0ooK^00<000000?ofkP3om^h0803om^h00`0mFJ/0
ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0
ooK^03eIZ`0403eIZ`80ooK^00<0?EV[0?ofkP3om^h00P3om^h803eIZ`X0ooK^00D0?EV[0?ofkP3o
m^h0ooK^03eIZ`060?ofkP040000000n4PT0000005dL3P80000000@0O2LB0000001l9a8000001011
G[X2000000030=@m6@0000000000008000001013H/801@000000@f;204=R`P13H/80e3dI0080@f;2
00<0000004=R`P13H/801013H/800`000000@f;204=R`P0304=R`P030=@m6@000000@f;200@0@f;2
00<0000004=R`P13H/801013H/801`000000@f;204=R`P13H/80e3dI04=R`P0000001@13H/800`00
0000@f;204=R`P0204=R`P0300000013H/80@f;200<0@f;20P3D?AT304=R`P0300000013H/80@f;2
0080@f;200<0000004=R`P13H/800`0000020?mD8`050000003oE2<0oe@S0?mD8`0000000P3oE2<0
1`0mFJ/000000?mD8`3oE2<000000?mD8`000000103oE2<00`000000oe@S0?mD8`020?mD8`030000
003oE280oe@R00<0oe@R00<000000?mD8P0mFJ/00`3oE282000000<0oe8Q00@000000?mB8@3oDR40
00000P3oCQl01@000000odhO0?m>7`3oCQl0000000<0odPL00<000000?m8700mFJ/00P3J?1L00`00
0000ooK^0?ofkP040?ofkPH0?EV[203om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^
00d0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP090?ofkPP0?EV[0P3om^h00`0m
FJ/0ooK^0?ofkP030?ofkP030000003om^h0000004l0ooK^0@3oool002d0ooK^00<000000?ofkP3o
m^h07`3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^01@0ooK^00<0?EV[0?ofkP3o
m^h01@3om^h603eIZ`<0ooK^2@0mFJ/40?ofkP0303eIZ`3om^h0ooK^00/0ooK^00D0?EV[0?ofkP3o
m^h0ooK^03eIZ`070?ofkP040000003D?AT0000005dL3P@0000000<0O2LB0000000000000P000002
04=R`P030=@m6@13H/80000000L0@f;200@0000004=R`P13H/80e3dI0`13H/800`000000@f;204=R
`P0404=R`P0300000013H/80@f;20080@f;200<0e3dI04=R`P0000001@13H/800`000000@f;204=R
`P0304=R`P0300000013H/80@f;20080@f;200<0e3dI00000013H/801013H/800`000000@f;204=R
`P0204=R`P0300000013H/80@f;200<0e3dI00D0@f;20=@m6@13H/80@f;20000000304=R`PD00000
00D0AFK9000000000000oe@S000000030?mD8`060000003oE2<0oe@S0?mD8`0mFJ/000000P3oE2<0
0`000000oe@S000000030?mD8`030000003oE2<0oe@S0080oe@S0P0000050?mD8P030000003oE280
?EV[00<0oe@R00D000000?mB8@3oDR40oe8Q000000030?mB8@030000003oCQl0000000<0odhO00D0
00000?m>7`000000odPL000000020?m8700403eIZ`3J?1L0fS`G000000H0?EV[0P3om^h00`0mFJ/0
ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0
ooK^0?ofkP020?ofkP0403eIZ`3om^h0ooK^0?ofkPP0?EV[203om^h00`0mFJ/0ooK^03eIZ`060?of
kP800000C`3om^h10?ooo`00;P3om^h00`000000ooK^0?ofkP0O0?ofkP0303eIZ`3om^h0ooK^0180
ooK^00<0?EV[0?ofkP3om^h0503om^h00`0mFJ/0ooK^0?ofkP0503eIZ`@0ooK^1@0mFJ/50?ofkP03
03eIZ`3om^h0ooK^00D0ooK^00<0?EV[0000003om^h0303om^h0100mFJ/0ooK^0?ofkP0mFJ/70?of
kP80000000<0e3dI0000000000000P1l9a820000000507`W4P000000000004=R`P3D?AT00P13H/80
0`3D?AT0@f;20000000704=R`P0400000013H/80@f;20=@m6@<0@f;200<0000004=R`P13H/801013
H/800`000000@f;204=R`P0204=R`P030=@m6@000000@f;200@0@f;200<0000004=R`P13H/800`13
H/800`000000@f;204=R`P0204=R`P030=@m6@000000@f;200@0@f;200<0000004=R`P13H/800P13
H/830=@m6@D0000000<0e3dI0000000000000`0000000`15I/T0000004EVb@0204EVb@030000003o
DR80oe8R008000000`3oE2<01@000000oe@S0?mD8`3oE2<0?EV[00@0oe@S00<000000?mD8`3oE2<0
0P3oE2<01@000000oe@S0?mD8`3oE2<000000080oe@S00D000000?mD8P3oE280oe@R000000020?mD
8P0303eIZ`3oE280oe@R008000000`3oDR400`000000oe8Q0?mB8@020?mB8@8000000`3oCQl01000
0000odhO0000003oB1`703eIZ`030=@m6@3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h02P3om^h0
0`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP0mFJ/01P0mFJ/@
0?ofkP0303eIZ`3om^h0?EV[00H0ooK^0P00001?0?ofkP40oooo000_0?ofkP030000003om^h0ooK^
01h0ooK^00<0?EV[0?ofkP3om^h04P3om^h00`0mFJ/0ooK^0?ofkP0A0?ofkPH0?EV[2@3om^h00`0m
FJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP000000303om^h0100m
FJ/0ooK^0?ofkP0mFJ/80?ofkP0303hB2@000000e3dI008000000P1l9a83000000030:Hc5`000000
@f;200<0e3dI0P13H/82000000H0@f;200<0000004=R`P3D?AT01013H/800`000000@f;204=R`P03
04=R`P0300000013H/80@f;20080@f;200<0e3dI04=R`P0000001@13H/800`000000@f;204=R`P02
04=R`P0300000013H/80@f;200<0@f;200<0e3dI04=R`P13H/800`13H/800`000000@f;204=R`P02
0=@m6@<000001@15I/T00`3D?AT0AFK904EVb@0404EVb@0500000015I/T0AFK904EVb@0000000P3o
DR801@000000oe@S0?mD8`3oE2<0000000<0oe@S00<0000003eIZ`3oE2<00P3oE2<2000000<0oe@S
00D000000?mD8`3oE2<0oe@S000000030?mD8`040000003oE280oe@R000000@0oe@R00@0?EV[0000
003oE28000000P3oDR400`000000oe8Q0?mB8@030?mB8@030000000mFJ/0?EV[00H0?EV[00@00000
0?m8703oB1`0?EV[0P3J?1L00`000000e3dI0?ofkP070?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0
?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP080?ofkPL0?EV[0`3om^h00`0mFJ/0ooK^0?of
kP0A0?ofkP0303eIZ`3om^h0?EV[00H0ooK^0P00001?0?ofkP40oooo000_0?ofkP030000003om^h0
ooK^01h0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP090?ofkPL0?EV[0`3om^h0
0`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h0103om^h0
0`0mFJ/0ooK^0000000<0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/01`3om^h00`000000?Q890000
0002000000<0O2LB00D0000007`W4P000000?EV[0000000204=R`P<0e3dI0P13H/800`000000@f;2
04=R`P0404=R`P0300000013H/80e3dI00<0@f;200<0000004=R`P13H/801013H/800`000000@f;2
04=R`P0204=R`P030=@m6@000000@f;200@0@f;200<0000004=R`P13H/800`13H/800`000000@f;2
04=R`P0204=R`P040=@m6@13H/80@f;204=R`P8000000`3D?AT204EVb@0500000015I/T0AFK904EV
b@0000001015I/T00`3D?AT0AFK904EVb@0204EVb@0500000015I/T0AFK904EVb@0000000P3oDR80
1@000000oe8R0000003oE2<0000000<0oe@S00P000000?mD8`3oE2<0?EV[0?mD8`000000oe@S0000
0080oe@S00D000000?mD8`3oE2<0oe@S000000050?mD8`8000001@3oE2801@0mFJ/0oe@R0?mD8P3o
E280000000P0?EV[0`3oCQl01@000000odhO0?m>7`3oCQl0000000<0odPL00<0?EV[000000000000
0P3D?AT80?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h01@3om^h0100mFJ/0ooK^
0?ofkP3om^h703eIZ`D0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP@0
?EV[00<0ooK^03eIZ`3om^h01@3om^h2000004l0ooK^0@3oool00300ooK^00<000000?ofkP3om^h0
7@3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0403eIZ`3om^h0ooK^0?ofkPP0?EV[2`3om^h00`0mFJ/0
ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h0103om^h0100mFJ/0
ooK^0?ofkP00000;0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/0203om^h600000080O2LB00@00000
07`W4P0mFJ/0YS<G0P00000204=R`PD0e3dI1P13H/800`000000e3dI04=R`P0304=R`P0300000013
H/80@f;200@0@f;200L0000004=R`P13H/80@f;20=@m6@13H/80000000D0@f;200<0000004=R`P13
H/80200000000`3D?AT000000=@m6@020=@m6@0300000015I/T0AFK90080AFK900D0000004EVb@15
I/T0AFK90000000404EVb@030=@m6@15I/T0AFK90080AFK900@0000004EVb@15I/T000000P3oDR80
1P000000oe8R0?mB8P000000oe@S00000080oe@S00H000000?mD8`3oE2<0oe@S03eIZ`0000030?mD
8`800000103oE2<00`000000oe@S0?mD8`030?mD8`030000003oE280oe@R0080oe@R1`0mFJ/00`00
0000oe8Q0?mB8@020?mB8@060000003oDR40oe8Q0000003oCQl00000103oCQl01`000000odPL0?m8
70000000odPL03eIZ`0000000`3D?AT70?ofkP0303eIZ`3om^h0ooK^00X0ooK^00@0?EV[0?ofkP3o
m^h0ooK^1`0mFJ/=0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/0203om^h803eIZ`<0ooK^00@0?EV[
0?ofkP3om^h0?EV[1@3om^h2000004l0ooK^0@3oool00340ooK^00<000000?ofkP3om^h0703om^h0
0`0mFJ/0ooK^0?ofkP0@0?ofkPL0?EV[4`3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0
ooK^00P0ooK^00<0?EV[0?ofkP3om^h0103om^h0100mFJ/0ooK^0?ofkP00000<0?ofkP0403eIZ`3o
m^h0ooK^03eIZ`P0ooK^00<0000003hB2@0000000P0000001P1l9a80000007`W4P1l9a80000003eI
Z`80000000@0YS<G00000013H/80e3dI1013H/840=@m6@<0@f;200<000000=@m6@13H/800`13H/80
0`000000@f;204=R`P0404=R`P0600000013H/80@f;204=R`P3D?AT000000`13H/8500000080AFK9
00<0000004EVb@3D?AT01@3D?AT304EVb@0500000015I/T0AFK904EVb@0000001015I/T01`000000
AFK904EVb@15I/T0000004EVb@3D?AT00P15I/T010000000AFK904EVb@0000030?mB8P050000003o
DR80oe8R0?mB8P0000000P3oE2<00`000000oe@S0?mD8`020?mD8`0303eIZ`3oE2<0oe@S0080oe@S
00<000000?mD8`3oE2<00P3oE2<00`000000oe@S0?mD8`030?mD8`H0?EV[00<000000?mD8P0mFJ/0
0`3oE2800`000000oe8Q0?mB8@030?mB8@060000003oDR40oe8Q0000003oCQl000000`3oCQl20000
0080odPL00@000000?m8700mFJ/000000`3D?AT70?ofkP0303eIZ`3om^h0ooK^00P0ooK^1P0mFJ/3
0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00@0?EV[0?ofkP3om^h0ooK^2@0mFJ/;0?ofkP0403eIZ`3o
m^h0ooK^03eIZ`D0ooK^0P00001?0?ofkP40oooo000b0?ofkP030000003om^h0ooK^01`0ooK^00<0
?EV[0?ofkP3om^h0203om^h703eIZ`<0ooK^00<0?EV[0?ofkP3om^h0503om^h00`0mFJ/0ooK^0?of
kP080?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h0103om^h01@0mFJ/0ooK^0?of
kP3om^h0000000/0ooK^00@0?EV[0?ofkP3om^h0?EV[0`3om^h80000000505dL3P000000000007`W
4P0000000`1l9a800`0mFJ/0YS<G0000000303eIZ`030=@m6@13H/80@f;20080@f;200<0000004=R
`P13H/801@3D?AT504=R`P0300000013H/80@f;200<0@f;200D0000004=R`P13H/80@f;20=@m6@04
0000000304EVb@3D?AT0e3dI00H0e3dI0`15I/T00`000000e3dI04EVb@0304EVb@0500000015I/T0
AFK904EVb@0000001015I/T02@000000AFK904EVb@15I/T0000004EVb@3D?AT0AFK90000000304EV
b@040000003oDR80oe8R000000<0oe8R0P0000020?mD8`060000003oE2<0oe@S0?mD8`000000?EV[
0`3oE2<00`000000oe@S000000020?mD8`030000000mFJ/0?EV[00@0?EV[0P3oE2<010000000oe@R
0?mD8P0000030?mD8P0403eIZ`3oE2800000000000@0oe8Q00<000000?mB8@3oDR400P3oDR400`00
0000odhO0?m>7`020?m>7`080000003oCQl000000?m870000000odPL03eIZ`0000030=@m6@L0ooK^
00@0?EV[0?ofkP3om^h0ooK^1`0mFJ/20?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3o
m^h0303om^h703eIZa@0ooK^00<0?EV[0?ofkP0mFJ/01P3om^h2000004h0ooK^0@3oool003<0ooK^
00<000000?ofkP3om^h06`3om^h0100mFJ/0ooK^0?ofkP3om^h703eIZ`/0ooK^00<0?EV[0?ofkP3o
m^h04`3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3o
m^h00`3om^h00`0mFJ/0ooK^0?ofkP020?ofkP030000003om^h0ooK^00P0ooK^00@0?EV[00000000
0000?EV[0`0000060?ofkP0403eIZ`000000000005dL3P80000000<0O2LB03eIZ`0mFJ/0100mFJ/2
000000030:Hc5`000000@f;200@0@f;20P00000404=R`QH0e3dI0P15I/T00`000000AFK904EVb@02
04EVb@0300000015I/T0AFK90080AFK900<000000=@m6@15I/T00P15I/T01@000000AFK904EVb@15
I/T0000000<0AFK900D0000004EVb@15I/T0AFK90000000304EVb@050=@m6@000000AFK904EVb@00
00000P3oDR801@000000oe8R0?mB8P3oDR8000000080oe8R0P0000030?mD8`040000003oE2<0oe@S
03eIZ`8000001P0mFJ/40?mD8`070000003oE2<0oe@S0?mD8`000000oe@R000000040?mD8P0503eI
Z`000000oe@R0?mD8P0000000P3oDR400`000000oe8Q0?mB8@030?mB8@050000003oCQl0odhO0?m>
7`0000000P3oCQl01P000000odPL0000003oB1`0?EV[000000@0e3dI103om^h603eIZ`T0ooK^00<0
?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP060?ofkPH0?EV[0P3om^h00`0mFJ/0ooK^0?of
kP020?ofkP0303eIZ`3om^h0ooK^0140ooK^00<0?EV[0?ofkP0mFJ/01P3om^h2000004h0ooK^0@3o
ool003@0ooK^00<000000?ofkP3om^h06P3om^h403eIZa80ooK^00<0?EV[0?ofkP3om^h0503om^h0
0`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h00`3om^h0
0`0mFJ/0ooK^0?ofkP020?ofkP030000003om^h0ooK^0080ooK^1P000000100mFJ/0ooK^0?ofkP0m
FJ/30?ofkPd0?EV[0P1l9a8010000000?EV[0000000000020:Hc5`030000002V<aL0000000H0@f;2
00@0000004=R`P13H/80@f;20P0000000`3D?AT0000000000006000000<0AFK900H0000004EVb@15
I/T0AFK90=@m6@00000404EVb@0300000015I/T0AFK90080AFK900<0000004EVb@15I/T00P15I/T0
0`000000e3dI04EVb@0204EVb@0500000015I/T0AFK904EVb@0000000`15I/T01@000000AFK904EV
b@15I/T0000000<0AFK900@0e3dI04EVb@15I/T000000P3oDR801@000000oe8R0?mB8P3oDR800000
00<0oe8R00D000000?mD8`3oE2<0oe@S0000000603eIZ`<0oe@S00<000000?mD8`3oE2<00P3oE2<2
000000D0oe@S00<000000?mD8P3oE2800`3oE2801`0mFJ/0oe@R0?mD8P3oE28000000?mB8@000000
1@3oDR42000000<0odhO00@000000?m>7`3oCQl00000103oB1`00`0mFJ/0e3dI0=@m6@0603eIZ`80
ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00H0
?EV[203om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^0100ooK^100mFJ/60?ofkP80
0000CP3om^h10?ooo`00=03om^h00`000000ooK^0?ofkP0J0?ofkP0303eIZ`3om^h0ooK^01<0ooK^
00<0?EV[0?ofkP3om^h0503om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00T0ooK^
00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP030?ofkP@000001P3om^h=03eIZ`80ooK^
0P00000205dL3P<0000000<0O2LB0000000mFJ/00`0000000`2V<aL000000:Hc5`02000000<0@f;2
1@00000204EVb@030=@m6@000000AFK900@0AFK900<0000004EVb@15I/T00`15I/T01P000000AFK9
04EVb@3D?AT0AFK9000000@0AFK900D0000004EVb@15I/T0AFK90000000404EVb@0500000015I/T0
e3dI04EVb@0000001015I/T01@000000AFK904EVb@15I/T000000080AFK900<0000004EVb@15I/T0
0P15I/T00`3D?AT0AFK9000000020?mB8P050000003oDR80oe8R0?mB8P0000000`3oDR8603eIZ`80
oe@S00<0000003eIZ`3oE2<00P3oE2<3000000<0oe@S00<000000?mD8`3oE2<0103oE2<2000000<0
oe@R0P0000000`3oE280?EV[0?mD8P020?mD8P800000103oDR401P000000oe8Q0?mB8@000000odhO
000000@0odhO00<000000?m8700mFJ/0100mFJ/30=@m6@D0ooK^00<0?EV[0?ofkP3om^h02`3om^h0
0`0mFJ/0ooK^0?ofkP0603eIZ`l0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0;0?ofkPL0?EV[00@0
ooK^03eIZ`3om^h0?EV[1P3om^h2000004h0ooK^0@3oool003D0ooK^00<000000?ofkP3om^h06P3o
m^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h01`3o
m^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h00`3o
m^h010000000ooK^0?ofkP3om^h;03eIZ`X0ooK^0`000000203D?AT0GA`>0000001l9a80000007`W
4P0mFJ/000000P2V<aL01@000000YS<G000000000000YS<G00<000000`15I/T00`000000AFK904EV
b@0204EVb@030=@m6@000000AFK900@0AFK900<0000004EVb@15I/T00P15I/T01P000000AFK904EV
b@15I/T0e3dI000000@0AFK900<0000004EVb@15I/T00P15I/T02@000000AFK904EVb@15I/T00000
04EVb@3D?AT0AFK90000000404EVb@0500000015I/T0AFK904EVb@0000000P15I/T02P000000AFK9
04EVb@15I/T000000=@m6@15I/T000000?mB8P0000020?mB8PH0?EV[0P3oDR82000000<0oe@S00H0
00000?mD8`3oE2<0?EV[0?mD8`0000020?mD8`040000003oE2<0oe@S000000D0oe@S0P0000001@3o
E2<000000?mD8P3oE280000000<0oe@R00D0?EV[0?mD8P3oE280oe@R000000040?mB8@070000003o
DR40oe8Q0?mB8@000000odhO000000040?m>7`050000003oB1`0odPL0=@m6@0mFJ/01@3D?AT50?of
kP0303eIZ`3om^h0ooK^00P0ooK^1P0mFJ/40?ofkP0303eIZ`3om^h0ooK^00h0ooK^00D0?EV[0?of
kP3om^h0ooK^03eIZ`030?ofkPP0?EV[2@3om^h203eIZ`H0ooK^0P00001>0?ofkP40oooo000f0?of
kP030000003om^h0ooK^01T0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP0C0?of
kP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP020?of
kP0403eIZ`3om^h0ooK^0?ofkP/0?EV[0P3om^h00`0mFJ/0ooK^03eIZ`0<0?ofkP<000000P1M70h0
1P000000O2LB0000000mFJ/0O2LB00000080YS<G00D000000:Hc5`2V<aL000000:Hc5`02000000D0
AFK900D0000004EVb@15I/T0e3dI04EVb@02000000@0AFK900<0000004EVb@15I/T00P15I/T01P00
0000AFK904EVb@3D?AT0AFK9000000@0AFK900D0000004EVb@15I/T0AFK90000000304EVb@050000
0015I/T0AFK90=@m6@0000000`15I/T01@000000AFK904EVb@15I/T000000080AFK900D0000004EV
b@15I/T0AFK903eIZ`03000000D0?EV[00D000000?mB8P3oDR80oe8R000000030?mB8P030000003o
E2<0oe@S008000000`3oE2<00`0mFJ/000000?mD8`030?mD8`8000001@3oE2<00`000000oe@S0?mD
8`020?mD8`800000103oE2800`0mFJ/0oe@R0?mD8P02000000@0oe8Q00<000000?mB8@3oDR400P3o
DR400`000000odhO0?m>7`020?m>7`8000000P3oB1`0103D?AT0?EV[0=@m6@3om^h30=@m6@D0ooK^
00<0?EV[0?ofkP3om^h0200mFJ/30?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h0
3P3om^h803eIZa40ooK^0P0mFJ/60?ofkP800000CP3om^h10?ooo`00=`3om^h00`000000ooK^0?of
kP0H0?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h0503om^h00`0mFJ/0ooK^0?of
kP060?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h0300mFJ/80?ofkP80?EV[3@3o
m^h010000000e3dI0000001M70h20000000307`W4P000000?EV[00<0000000@0YS<G000000000000
YS<G0P0000000`39?A/000000000000404EVb@80000000D0AFK90=@m6@15I/T0AFK90000000404EV
b@0300000015I/T0AFK90080AFK900H0000004EVb@15I/T0e3dI04EVb@00000304EVb@0500000015
I/T0AFK904EVb@0000000`15I/T01@000000AFK904EVb@3D?AT0000000<0AFK900H0000004EVb@15
I/T0AFK900000015I/T9000000050?mB8P000000oe8R0?mB8P0000000`3oDR8010000000oe8R0?mB
8P3oDR82000000030?mD8`000000oe@S00<0oe@S00<0000003eIZ`3oE2<0103oE2<00`000000oe@S
0?mD8`030?mD8`030000003oE2<0oe@S00<0oe@S00<000000?mD8P3oE280103oE2801@0mFJ/00000
0?mD8P3oE28000000080oe8Q00<000000?mB8@3oDR400`3oDR400`000000odhO0?m>7`020?m>7`07
0000003oCQl000000?m870000000e3dI03eIZ`020?ofkP80e3dI200mFJ/;0?ofkP0303eIZ`3om^h0
ooK^00@0ooK^00<0?EV[0?ofkP3om^h0203om^h703eIZ`<0ooK^00<0?EV[0?ofkP3om^h0403om^h3
03eIZ`030?ofkP0mFJ/0ooK^00D0ooK^0P00001=0?ofkP40oooo000h0?ofkP030000003om^h0ooK^
01P0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^
00H0ooK^00<0?EV[0?ofkP3om^h01`3om^h603eIZ`030?ofkP0mFJ/0?EV[00<0?EV[0P3om^h00`00
0000ooK^0?ofkP090?ofkP80?EV[3@3om^h20000000305dL3P000000GA`>00<0000000@0?EV[07`W
4P000000YS<G0P0000001@2V<aL000000:Hc5`2V<aL000000080bCdK00<0000004EVb@15I/T00`15
I/T00`000000AFK90=@m6@0204EVb@0300000015I/T0AFK90080AFK900<0000004EVb@15I/T00P15
I/T01@000000AFK90=@m6@15I/T0000000@0AFK900@0000004EVb@15I/T000001015I/T010000000
AFK904EVb@3D?AT304EVb@0300000015I/T0AFK900<000001017J]400`000000Af[A000000020?m@
8P040000003oDR80oe8R00000080oe8R0P0000020?mB8P8000000P3oDR800`000000oe@S0?mD8`02
0?mD8`040000003oE2<0oe@S03eIZ`80oe@S0`0000040?mD8`030000003oE2<0oe@S00<0oe@S0P00
00060?mD8P0703eIZ`3oE280oe@R0?mD8P000000oe8Q000000050?mB8@8000000`3oCQl010000000
odhO0?m>7`00000803eIZ`030=@m6@3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h0303om^h00`0m
FJ/0ooK^0?ofkP030?ofkP0403eIZ`3om^h0ooK^0?ofkPL0?EV[1P3om^h01@0mFJ/0ooK^0?ofkP3o
m^h0?EV[00`0ooK^1P0mFJ/20?ofkP0303eIZ`3om^h0?EV[00H0ooK^0P00001=0?ofkP40oooo000i
0?ofkP030000003om^h0ooK^01L0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP0C
0?ofkP0303eIZ`3om^h0ooK^00H0ooK^00@0?EV[0?ofkP3om^h0ooK^1P0mFJ/00`3om^h0?EV[03eI
Z`0403eIZ`030?ofkP0mFJ/0ooK^00@0ooK^00<000000?ofkP3om^h02@3om^h203eIZ`h0ooK^0P00
00000`1M70h000000000000207`W4P0303eIZ`1l9a80000000<0YS<G00@000000:Hc5`000000YS<G
0`0000000`39?A/000000000000404EVb@030000003D?AT0AFK90080AFK900<0000004EVb@15I/T0
0P15I/T00`000000AFK904EVb@0204EVb@0500000015I/T0e3dI04EVb@0000000`15I/T01@000000
AFK904EVb@15I/T0000000<0AFK900@0000004EVb@000000e3dI1P00000304MZd@0300000017J]40
e3dI00<0Af[A00H000000?m@8P00000000000?mB8P0000020?mB8P050000003oDR80oe8R0?mB8P00
00000`3oDR82000000<0oe@S00L000000?mD8`3oE2<0oe@S03eIZ`3oE2<000000080oe@S00<00000
0?mD8`3oE2<00P0000040?mD8`8000000P3oE2<010000000oe@R0?mD8P3oE2820000000303eIZ`3o
E280oe@R0080oe@R00<000000?mB8@3oDR400`3oDR400`000000oe8Q03eIZ`0703eIZ`040000003o
m^h0e3dI03eIZ`<0ooK^0P3D?AT40?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h0
1`0mFJ/>0?ofkP0403eIZ`3om^h0ooK^03eIZ`H0ooK^1P0mFJ/80?ofkP0303eIZ`3om^h0?EV[00H0
ooK^0P00001=0?ofkP40oooo000i0?ofkP030000003om^h0ooK^01L0ooK^00<0?EV[0?ofkP3om^h0
4`3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^00H0ooK^2`0mFJ/30?ofkP0503eI
Z`3om^h0ooK^0?ofkP0mFJ/0103om^h00`000000ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00`0
ooK^0`0000000`1M70h000000000000207`W4P0303eIZ`1l9a80000000<0YS<G0`0000000`2V<aL0
00000<Tm6`02000000030<Tm6`000000000000<0AFK900<000000=@m6@15I/T00P15I/T00`000000
AFK904EVb@0204EVb@0900000015I/T0AFK904EVb@000000AFK90=@m6@15I/T0000000@0AFK900<0
000004EVb@0000001P0000000`17J]4000000=@m6@0504MZd@0300000017J]40e3dI0080e3dI00H0
Af[A00000017J]4000000?m@8P0000020?m@8P040000003oDR80oe8R000000<0oe8R00<000000?mB
8P3oDR800P0000020?mB8P<00000103oE2<00`0mFJ/000000?mD8`030?mD8`8000001@3oE2<00`00
0000oe@S0?mD8`020?mD8`040000003oE280oe@R000000<0oe@R00@0?EV[0?mD8P3oE2800000200m
FJ/0103oDR4000000?m>7`0000040?m>7`050000003om^h0ooK^0=@m6@0mFJ/00P3om^h30=@m6@<0
ooK^00<0?EV[0?ofkP3om^h0203om^h703eIZ`<0ooK^00<0?EV[0?ofkP3om^h03`3om^h0100mFJ/0
ooK^0?ofkP3om^h603eIZ`d0ooK^100mFJ/60?ofkP800000C@3om^h10?ooo`00>P3om^h00`000000
ooK^0?ofkP0G0?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h04`3om^h0100mFJ/0
ooK^0?ofkP3om^h803eIZ`/0ooK^00@0?EV[0?ofkP3om^h0?EV[103om^h00`000000ooK^0?ofkP0:
0?ofkP80?EV[3`3om^h30000000705dL3P000000O2LB07`W4P0mFJ/0000007`W4P02000000<0YS<G
0`0000030<Tm6`80000000<0bCdK00000015I/T00P15I/T00`3D?AT0000004EVb@0204EVb@800000
0`15I/T01`000000AFK904EVb@15I/T0000004EVb@3D?AT01`0000000`17J]40000004MZd@0204MZ
d@0500000017J]40Af[A0000003D?AT00`17J]440=@m6@0:00000017J]40Af[A00000017J]400000
0?m@8P000000oe0R03eIZ`80000000<0oe8R0000003oDR800P3oDR8010000000oe8R0?mB8P000004
0?mB8P030000003oE2<0oe@S00<0oe@S0P0000000`0mFJ/0oe@S0?mD8`020?mD8`030000003oE2<0
oe@S00<0oe@S00<000000?mD8`3oE2<0103oE2<200000080oe@R1P0mFJ/01@000000oe8Q0?mB8@3o
DR40000000D0oe8Q0P0000030?m>7`060000003om^h0ooK^0?ofkP3D?AT0?EV[0P3om^h30=@m6@<0
ooK^00@0?EV[0?ofkP3om^h0ooK^1`0mFJ/40?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?of
kP3om^h0303om^h803eIZ`/0ooK^1`0mFJ/20?ofkP80?EV[1P3om^h2000004d0ooK^0@3oool003/0
ooK^00<000000?ofkP3om^h05P3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^0100
ooK^1`0mFJ/40?ofkP0303eIZ`3om^h0ooK^00`0ooK^00@0?EV[0?ofkP3om^h0?EV[103om^h00`00
0000ooK^0?ofkP0:0?ofkP80?EV[403om^h00`000000GA`>000000030000000507`W4P0mFJ/0O2LB
0000002V<aL00P0000030:Hc5`<000000`39?A/010000000bCdK00000000000204EVb@030=@m6@00
0000000000<0AFK900<0000004EVb@15I/T01P0000000`3D?AT0Af[A04MZd@0704MZd@0400000017
J]40Af[A00000080Af[A1@3D?AT02`17J]40000004MZd@17J]40000004MZd@000000Af[A0000003o
D28000000080oe0R00@0?EV[0?m@8P3oD28000000P3oDR8200000080oe8R00@000000?mB8P3oDR80
oe8R0P0000000`3oDR8000000?mD8`020?mD8`040000003oE2<0oe@S03eIZ`80oe@S0P000000103o
E2<000000?mD8`3oE2<2000000D0oe@S1P0mFJ/20?mD8P0303eIZ`000000oe@R0080oe@R00<00000
0?mB8@0000001P3oDR400`000000odhO0?m>7`020?m>7`060000003om^h0ooK^0?ofkP3D?AT0?EV[
0P3om^h30=@m6@L0?EV[303om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00@0ooK^
200mFJ/30?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/00`3om^h803eIZ`T0ooK^0P0mFJ/60?ofkP80
0000C@3om^h10?ooo`00?03om^h00`000000ooK^0?ofkP0E0?ofkP0303eIZ`3om^h0ooK^01<0ooK^
00<0?EV[0?ofkP3om^h02@3om^h703eIZ`<0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^
0?ofkP0<0?ofkP0403eIZ`3om^h0ooK^03eIZ`@0ooK^00<000000?ofkP3om^h02P3om^h00`0mFJ/0
ooK^03eIZ`0?0?ofkP8000000P1M70h010000000O2LB0000000mFJ/207`W4P030000002V<aL0YS<G
008000000`2V<aL300000080bCdK0P0000000`39?A/000000000000204EVb@L000000P17J]401P00
0000Af[A04MZd@17J]4000000=@m6@D0Af[A00@0000004MZd@17J]4000001@3D?AT010000000Af[A
0=@m6@00000204MZd@0300000017J]4000000080Af[A0P0000001P3oD28000000?m@8P3oD2800000
03eIZ`<0000000<0oe8R0000003oDR800P3oDR801@000000oe8R0?mB8P3oDR80000000<0oe8R00@0
00000?mD8`00000000000`3oE2<00`0mFJ/00000000000030?mD8`040000003oE2<000000?mD8`H0
?EV[0`0000040?mD8P80000000@0?EV[0?mD8P3oE280oe@R0P0000060?mB8@8000000`3oCQl01000
0000ooK^0?ofkP3om^h803eIZ`<0ooK^00<0?EV[0?ofkP3om^h03@3om^h0100mFJ/0ooK^0?ofkP3o
m^h803eIZ``0ooK^1`0mFJ/>0?ofkPD0?EV[1`3om^h00`000000ooK^0?ofkP1;0?ofkP40oooo000m
0?ofkP030000003om^h0ooK^01D0ooK^00<0?EV[0?ofkP3om^h04`3om^h0100mFJ/0ooK^0?ofkP3o
m^h703eIZ`/0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3o
m^h0?EV[00@0ooK^00<000000?ofkP3om^h02P3om^h00`0mFJ/0ooK^03eIZ`0=0?ofkP<0?EV[0P00
000205dL3P050000001l9a80?EV[0000001l9a800`0000020:Hc5`80000000<0YS<G00000039?A/0
1P0mFJ/010000000bCdK00000000000204MZd@0300000017J]40Af[A00D0e3dI1017J]40103D?AT0
Af[A04MZd@0000060=@m6@0300000017J]4000000080Af[A00@0000004MZd@17J]40e3dI0P17J]40
10000000Af[A00000017J]4200000080oe0R00H000000?m@8P000000oe0R0000000mFJ/20?m@8P03
0000003oDR80oe8R008000000P3oDR82000000D0oe8R00<000000?mD8`3oE2<00`3oE2<010000000
?EV[0?mD8`3oE2<603eIZ`@0oe@S0P0000030?mD8`040000003oE280oe@R00000080oe@R00D0?EV[
0?mD8P3oE280oe@R000000060?mB8@040000003oDR4000000?m>7`H0?EV[00D0e3dI0?ofkP3D?AT0
?EV[0?ofkP040=@m6@80ooK^00<0?EV[0?ofkP3om^h02P3om^h703eIZ`030?ofkP0mFJ/0ooK^00X0
ooK^200mFJ/20?ofkP0303eIZ`3om^h0ooK^00L0ooK^200mFJ/20?ofkP<0?EV[1`3om^h2000004`0
ooK^0@3oool003h0ooK^00<000000?ofkP3om^h0503om^h00`0mFJ/0ooK^0?ofkP0@0?ofkPL0?EV[
4P3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP0mFJ/0
103om^h00`000000ooK^0?ofkP0:0?ofkP0403eIZ`3om^h0ooK^03eIZ`H0ooK^1P0mFJ/30?ofkP<0
00000P1M70h01P000000O2LB03eIZ`000000O2LB000000P0?EV[0P39?A/300000080bCdK0P000000
0`3SA1d0000004MZd@0204MZd@0600000017J]40Af[A04MZd@000000Af[A203D?AT010000000Af[A
04MZd@00000204MZd@0600000017J]40Af[A00000017J]4000000P17J]402P3D?AT0Af[A00000017
J]40000004MZd@000000Af[A0000003oD283000000040?m@8P000000oe0R03eIZ`<0000000@0oe8R
0000003oDR80oe8R0P0000050?mB8P<000000`3oE2<603eIZ`040?mD8`0000000000000000D0oe@S
00<000000?mD8`3oE2<00`3oE2<00`000000oe@R000000030?mD8P0303eIZ`3oE280oe@R00800000
1@3oDR4010000000oe8Q0?mB8@3oDR42000000030=@m6@3om^h0ooK^0080ooK^00D0e3dI0?ofkP3D
?AT0?EV[0=@m6@020?ofkP80e3dI0P3om^h00`0mFJ/0ooK^0?ofkP020?ofkPP0?EV[0`3om^h00`0m
FJ/0ooK^0?ofkP020?ofkP0403eIZ`3om^h0ooK^0?ofkPP0?EV[203om^h0100mFJ/0ooK^03eIZ`3o
m^h803eIZ`@0ooK^1P0mFJ/20?ofkP0303eIZ`3om^h0ooK^00D0ooK^0P00001<0?ofkP40oooo000n
0?ofkP030000003om^h0ooK^01@0ooK^00<0?EV[0?ofkP3om^h02@3om^h703eIZ`<0ooK^00<0?EV[
0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[
0?ofkP0mFJ/0103om^h00`000000ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00L0?EV[2@3om^h0
100mFJ/0000000000000000703eIZ`<0YS<G0P0000020:Hc5`8000000`39?A/300000080bCdK0P00
00000`3SA1d0000004MZd@0204MZd@0300000017J]40Af[A008000000P17J]4010000000Af[A0=@m
6@00000204MZd@0400000017J]40Af[A00000080Af[A00/0000004MZd@000000Af[A00000017J]40
000004MZd@3D?AT0000004MZd@020000000304MZd@000000oe0R0080000000<0oe0R000000000000
0P3oD2801@0mFJ/0oe0R0?m@8P3oD28000000080oe8R00<000000?mB8P3oDR800`3oDR8803eIZ`<0
oe@S00@0?EV[0?mD8`00000000000P3oE2<010000000oe@S0?mD8`3oE2<2000000L0oe@S00<00000
0?mD8P3oE2800`3oE2801@0mFJ/000000?mD8P3oE280000000<0oe8Q00<000000?mB8@3oDR400P3o
DR42000000050=@m6@3om^h0ooK^0?ofkP3D?AT00P3om^h00`3D?AT0ooK^03eIZ`020?ofkP030=@m
6@0mFJ/0?EV[00H0?EV[303om^h803eIZ`h0ooK^1P0mFJ/70?ofkPD0?EV[1@3om^h403eIZ`L0ooK^
0P00001<0?ofkP40oooo000o0?ofkP030000003om^h0ooK^01@0ooK^00@0?EV[0?ofkP3om^h0ooK^
1`0mFJ/;0?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^
0?ofkP0>0?ofkP80?EV[103om^h00`000000ooK^0?ofkP080?ofkPH0?EV[303om^h703eIZ`0505dL
3P000000000003eIZ`0000000P1l9a82000000<0YS<G0P000000102V<aL000000000000000030<Tm
6`@0000000@0hd@M0000000mFJ/0hd@M0P00000204MZd@0400000017J]40Af[A000000<0Af[A00<0
00000=@m6@0000000P17J]400`000000Af[A0000000204MZd@0<00000017J]40000004MZd@000000
Af[A00000017J]4000000=@m6@000000Af[A0P0000001@3oD28000000000003oD28000000080oe0R
0P0000000`3oD280?EV[00000002000000P0?EV[103oDR82000000D0oe@S00<0000003eIZ`3oE2<0
103oE2<3000000L0oe@S0`0000040?mD8P030000000mFJ/0oe@R0080oe@R00@000000?mB8@3oDR40
00001@3oDR400`000000ooK^0=@m6@030?ofkP030=@m6@3om^h0?EV[00H0?EV[0P3D?AT00`3om^h0
?EV[0?ofkP090?ofkPL0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP090?ofkPH0?EV[0P3om^h00`0mFJ/0
ooK^03eIZ`020?ofkPH0?EV[0P3om^h803eIZ`/0ooK^0P00001<0?ofkP40oooo00100?ofkP030000
003om^h0ooK^01<0ooK^100mFJ/B0?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h0
0`3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP80?EV[103om^h00`000000ooK^0?ofkP020?ofkPH0?EV[
0P3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00<0ooK^200mFJ/30?ofkP0403eIZ`3om^h000000000
0080GA`>00<0000007`W4P0mFJ/00P000000101l9a8000000000000000030:Hc5`8000000P39?A/3
00000080bCdK100000000`0mFJ/00000000000030000000404MZd@000000000004MZd@8000000P17
J]401@3D?AT0Af[A00000017J]4000000080Af[A00<0000004MZd@17J]400P0000000`17J]400000
04MZd@07000000060?m=8@00000000000?m@8P000000oe0R0P00000703eIZ`040=@m6@3oDR80oe8R
0?mB8P800000103oDR82000000030?mB8P000000oe@S0080oe@S0P0000000`3oE2<0?EV[0?mD8`03
0?mD8`8000001`3oE2<200000080oe@S00L000000?mD8P3oE280oe@R0000003oE280?EV[00@0oe@R
0P0000050?mB8@030000000mFJ/0?EV[00H0?EV[0P3om^h00`3D?AT0?EV[0?ofkP020?ofkP80e3dI
00<0ooK^03eIZ`3om^h00P3om^h703eIZ`H0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`050?ofkPH0
?EV[1`3om^h>03eIZa<0ooK^0P00001<0?ofkP40oooo00110?ofkP030000003om^h0ooK^0180ooK^
00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^00<0ooK^
00<0?EV[0?ofkP3om^h03`3om^h0100mFJ/0ooK^0?ofkP3om^h603eIZ`P0ooK^00<0?EV[0?ofkP0m
FJ/01@0mFJ/;0?ofkP0303eIZ`3om^h0ooK^0080000000@0e3dI05dL3P000000?EV[0P1l9a820000
0080YS<G0P0000030:Hc5`8000000`39?A/3000000040<Tm6`000000000003eIZ`80000000<0hd@M
0000000000000P0000001@17J]40000000000017J]4000000080Af[A00L0e3dI000000000000Af[A
00000017J]4000000080Af[A1P0000000`19KML0000000000002000000030?m=8@000000000000H0
?EV[0P0000001@3oD280?EV[0000003oD28000000080oe8R0P0000040?mB8P800000103oDR830000
00@0oe@S00@0?EV[00000000000000000P3oE2<00`000000oe@S0?mD8`020?mD8`8000001@3oE2<3
000000<0oe@R00@0?EV[0?mD8P3oE280oe@R200mFJ/30?ofkP030=@m6@3om^h0e3dI00@0ooK^0P3D
?AT00`0mFJ/0ooK^0?ofkP0703eIZ`h0ooK^00<0?EV[0?ofkP3om^h01P0mFJ/60?ofkPd0?EV[703o
m^h00`000000ooK^0?ofkP1:0?ofkP40oooo00120?ofkP030000003om^h0ooK^0180ooK^00<0?EV[
0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[
0?ofkP3om^h02`3om^h803eIZ`030?ofkP000000ooK^00P0ooK^1@0mFJ/20?ofkP0303eIZ`3om^h0
ooK^00/0ooK^00@0?EV[0?ofkP3om^h0ooK^0`000000101M70h000000000000mFJ/307`W4P800000
0P2V<aL200000080YS<G100000030<Tm6`<0000000<0hd@M03eIZ`0000000P0000000`3SA1d00000
000000020000000304MZd@00000000000080000000<0e3dI04MZd@000000200000000`19KML00000
04U]e`020000000404U]e`00000000000?m=8@<0000000@0oe0R000000000000oe0R0P0000001P3o
D28000000000003oD280?EV[0?m@8P<000000`3oDR83000000D0oe8R0P0000050?mD8`030000000m
FJ/0oe@S00@0oe@S00<000000?mD8`3oE2<00P0000070?mD8`040000003oE280oe@R0?mD8PH0?EV[
00<000000?mB8@3oDR400P3oDR400`0mFJ/0ooK^0?ofkP030?ofkP030=@m6@3om^h0e3dI0080ooK^
1`0mFJ/20=@m6@030?ofkP0mFJ/0ooK^00d0ooK^1`0mFJ/30?ofkPh0?EV[8`3om^h2000004/0ooK^
0@3oool004<0ooK^00<000000?ofkP3om^h04@3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3o
m^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP020?ofkPT0?EV[103o
m^h00`0mFJ/0ooK^0?ofkP020?ofkP040000003om^h0ooK^0?ofkPH0?EV[0`3om^h00`0mFJ/0ooK^
0?ofkP020?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h00P3om^h50000000603eI
Z`000000O2LB07`W4P000000YS<G0P0000020:Hc5`<000000`39?A/300000080bCdK0P0000000`0m
FJ/0hd@M0>=47@04000000030>=47@000000000000H0000000X0BFgG000000000000BFgG00000019
KML0000004U]e`000000BFgG0P0000001@19KML00000000000000000oddQ00<0000000<0oddQ0000
003oD2800P0000000`3oD2800000000000020?m@8P050000000mFJ/000000?m@8P0000000P3oDR82
000000D0oe8R0`000000103oDR8000000?mD8`3oE2<300000080oe@S00<0?EV[0?mD8`3oE2<00P3o
E2<3000000L0oe@S1P0mFJ/20?mD8P0303eIZ`000000oe@R0080oe@R00D000000?mB8@3oDR400000
03eIZ`030?ofkPL0?EV[0`3om^h0103D?AT0?EV[0?ofkP3om^h30=@m6@0303eIZ`3om^h0ooK^00@0
ooK^200mFJ/30?ofkPh0?EV[:P3om^h2000004/0ooK^0@3oool004<0ooK^00<000000?ofkP3om^h0
4@3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^01@0ooK^00@0?EV[0?ofkP3om^h0
ooK^1@0mFJ/=0?ofkP80?EV[0P3om^h503eIZ`T0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0
ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00H0?Q890000001M70h0000003eIZ`1l9a82
0000000407`W4P000000YS<G0:Hc5`<0000000@0YS<G00000000000000001039?A/2000000040<Tm
6`000000hd@M03eIZ`80000000<0hd@M0000000000000P0000000`3SA1d000000000000500000080
BFgG100000000`19KML0000000000005000000040?m=8@00000000000?m=8@@0000000@0oe0R0000
00000000oe0R0`0000020?m@8P0303eIZ`3oD280000000800000103oDR83000000@0oe8R0`000005
0?mD8`0303eIZ`3oE2<000000080000000<0oe@S0000003oE2<00P3oE2<503eIZ`<0oe@S00@00000
0?mD8P3oE280oe@R0P0000001`0mFJ/0oe@R0?mD8P3oE28000000?mB8@3D?AT01@0mFJ/30?ofkP03
0=@m6@3om^h0ooK^00@0ooK^00@0e3dI0?ofkP0mFJ/0ooK^0P3D?AT803eIZ`@0ooK^3@0mFJ/b0?of
kP800000B`3om^h10?ooo`00A03om^h00`000000ooK^0?ofkP0A0?ofkP0303eIZ`3om^h0ooK^01<0
ooK^00<0?EV[0?ofkP3om^h04`3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00l0ooK^1P0mFJ/00`00
0000ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0m
FJ/0ooK^0?ofkP030?ofkP<0000000<0GA`>0000000mFJ/00P1l9a82000000D0YS<G0`0000000`39
?A/0000000000002000000<0bCdK0P0000000`0mFJ/000000>=47@0?0000000304U]e`0000000000
00h0000000<0oddQ000000000000100000030?m@8P80000000@0?EV[0000003oD28000000P3oDR83
000000<0oe8R100000000`3oDR8000000?mD8`040?mD8`80000000<0?EV[0?mD8`3oE2<01P0mFJ/0
0`3oE2<00000000000050?mD8`040000003oE280000000000080oe@R00<0?EV[0?mD8P3oE2800P3o
E28010000000?EV[0?ofkP0mFJ/60?ofkP030=@m6@3om^h0ooK^00<0ooK^200mFJ/30?ofkPh0?EV[
>@3om^h2000004/0ooK^0@3oool004D0ooK^00<000000?ofkP3om^h0403om^h00`0mFJ/0ooK^0?of
kP0C0?ofkP0303eIZ`3om^h0ooK^01<0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`080?ofkPL0?EV[
00@0ooK^03eIZ`3om^h0?EV[0P3om^h00`000000ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00@0
ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP020?ofkP80?EV[00H000000=@m6@00
0000GA`>03eIZ`00000307`W4P8000001@2V<aL3000000<0bCdK0`0000000`39?A/0?EV[03eIZ`08
03eIZ`030>=47@000000000001/000000P3oD284000000<0oe0R00<0?EV[0000000000000P000002
0?mB8P@000001P3oDR8010000000oe@S00000000000603eIZ`<0oe@S00@000000?mD8`0000000000
1`3oE2<2000000D0oe@R00L0?EV[0?mD8P00000000000=@m6@3om^h0?EV[00H0ooK^1`0mFJ/0103D
?AT0ooK^0=@m6@3om^h=03eIZd40ooK^0P00001;0?ofkP40oooo00160?ofkP030000003om^h0ooK^
00l0ooK^00<0?EV[0?ofkP3om^h0503om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0403eIZ`3om^h0?EV[
0?ofkPP0?EV[203om^h01P0mFJ/0ooK^0?ofkP0mFJ/0ooK^000000`0ooK^00<0?EV[0?ofkP3om^h0
103om^h00`0mFJ/0ooK^0?ofkP060?ofkPP0?EV[0P3om^h2000000040=@m6@000000000003eIZ`80
00000P1l9a84000000@0YS<G0P00000603eIZ`80000000<0?EV[0000003SA1d00P3SA1dD00000003
0=@m6@000000000000`0000000<0oe0R000000000000100000000`0mFJ/0000000000004000000H0
oe8R200mFJ/40?mD8`0403eIZ`3oE2<0oe@S0?mD8`<000001P3oE2<3000000030?mD8`000000oe@R
00@0oe@R00D0?EV[0000003om^h0ooK^0=@m6@0803eIZ`040=@m6@3om^h0e3dI0?ofkP`0?EV[BP3o
m^h00`000000ooK^0?ofkP190?ofkP40oooo00170?ofkP030000003om^h0ooK^00l0ooK^00<0?EV[
0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkPL0?EV[403om^h01P0mFJ/0ooK^0?ofkP0m
FJ/0ooK^000000`0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^03eIZ`0503eIZ`<0ooK^
00<0?EV[0?ofkP3om^h01@3om^h200000080GA`>00<0?EV[07`W4P1l9a800`0000030:Hc5`030000
000mFJ/0?EV[00<0?EV[0`39?A/3000000040<Tm6`000000hd@M03eIZ`H0000000<0hd@M00000000
00007P0000000`3oD2800000000000040000000403eIZ`3oD280oe0R000000P0?EV[0P0000020?mB
8P030000003oE2<0oe@S00D0oe@S00H0?EV[00000000000000000?mD8`0000050?mD8`800000103o
E2<010000000oe@R0?mD8P3oE28803eIZ`<0ooK^3@0mFJ/01P3om^h0e3dI0?ofkP3D?AT0ooK^0=@m
6D/0ooK^00<000000?ofkP3om^h0B@3om^h10?ooo`00B03om^h00`000000ooK^0?ofkP0>0?ofkP03
03eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h02@3om^h703eIZ`@0ooK^0P0mFJ/A0?ofkP06
03eIZ`3om^h0ooK^0?ofkP0mFJ/00000303om^h0100mFJ/0ooK^0?ofkP3om^h603eIZ`T0ooK^00<0
?EV[0?ofkP3om^h01P3om^h01@000000GA`>05dL3P1M70h0?EV[0080O2LB1P0mFJ/30:Hc5`@00000
1@39?A/20000000303eIZ`0000000000008000000P3SA1dR000000<0oe0R1`0mFJ/4000000T0oe8R
00<000000?mD8`3oE2<0100000000`3oE2<0?EV[0?mD8`030?mD8`030000003oE2<0000000800000
0`3oE2<703eIZ`80ooK^3`0mFJ/00`3D?AT0ooK^0?ofkP020?ofkP070=@m6@3om^h0ooK^0=@m6@3o
m^h0e3dI0?ofkP020=@m6DX0ooK^0P00001:0?ofkP40oooo00180?ofkP030000003om^h0ooK^00l0
ooK^00<0?EV[0?ofkP3om^h04`3om^h0100mFJ/0ooK^0?ofkP3om^h703eIZ`/0ooK^0P0mFJ/A0?of
kP0603eIZ`3om^h0ooK^0?ofkP0mFJ/000002@3om^h703eIZ`D0ooK^00<0?EV[0?ofkP3om^h01P3o
m^h00`0mFJ/0ooK^0?ofkP070?ofkP030000000mFJ/0?EV[00@0?EV[0P1l9a800`000000YS<G0000
0002000000<0YS<G00<000000<Tm6`39?A/01@0000001039?A/000000>=47@0mFJ/30>=47B400000
1P0mFJ/01@000000oe0R0?m@8P3oD280?EV[0080oe0R00<000000?mB8P3oDR80103oDR89000000D0
oe@S00<0?EV[0?mD8`3oE2<00P00000803eIZ`80oe@S3P0mFJ/40?ofkP030=@m6@3om^h0ooK^0080
ooK^00@0e3dI0?ofkP3om^h0e3dI103om^h20=@m6@80ooK^00<0e3dI0?ofkP3om^h0B03om^h20000
04X0ooK^0@3oool004T0ooK^00<000000?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkPL0
?EV[4`3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00@0?EV[0?ofkP3o
m^h0ooK^1P0mFJ/30?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h01P3om^h0100m
FJ/0ooK^0?ofkP3om^h703eIZ`060000001M70h0000005dL3P0mFJ/0O2LB0P0000000`1l9a800000
0:Hc5`020:Hc5`<0000000<0YS<G00000039?A/01@39?A/30000000303eIZ`000000000002d00000
00<0?EV[0000000000001P0000060?mB8P030000003oE2<0oe@S0080oe@S0P00000603eIZ`030?mD
8`000000oe@S00D0oe@S00<0e3dI03eIZ`0mFJ/01P0mFJ/00`3D?AT0ooK^0?ofkP030?ofkP030=@m
6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h00P3om^h0103D?AT0ooK^0?ofkP3D?AT40?ofkP80
e3dI0P3om^h00`3D?AT0ooK^0?ofkP180?ofkP800000BP3om^h10?ooo`00BP3om^h00`000000ooK^
0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00T0ooK^1`0mFJ/40?ofkP0303eIZ`3om^h0ooK^01<0ooK^
00<0?EV[0?ofkP3om^h03P3om^h0100mFJ/0ooK^0?ofkP3om^h603eIZ`T0ooK^00<0?EV[0?ofkP3o
m^h01`3om^h0100mFJ/0ooK^0?ofkP3om^h803eIZ`L0ooK^0P0000000`1M70h0000003eIZ`0307`W
4P8000001P2V<aL<0000000303eIZ`0000000000008000001@3SA1d2000000030?M97`0000000000
00`0000000<0BFoK0000000000003@0000050?m@8P0303eIZ`000000oe8R00H0oe8R1P00000603eI
Z`<0oe@S0P0mFJ/20?mD8`030000003oE2<0?EV[00H0?EV[1P3om^h00`3D?AT0ooK^0?ofkP040?of
kP050=@m6@3om^h0ooK^0?ofkP3D?AT01P3om^h00`3D?AT0ooK^0=@m6@050?ofkP040=@m6@3om^h0
ooK^0=@m6DX0ooK^0P00001:0?ofkP40oooo001;0?ofkP030000003om^h0ooK^00d0ooK^00@0?EV[
0?ofkP3om^h0ooK^1`0mFJ/;0?ofkP0303eIZ`3om^h0ooK^0180ooK^00<0?EV[0?ofkP0mFJ/03@3o
m^h603eIZ`80ooK^00<0000003eIZ`3om^h02@3om^h00`0mFJ/0ooK^0?ofkP050?ofkPL0?EV[103o
m^h00`0mFJ/0ooK^0?ofkP090?ofkP8000000P1M70h00`0mFJ/0000007`W4P0207`W4PD000000`2V
<aL00`000000bCdK0<Tm6`060<Tm6`040000000mFJ/0hd@M0>=47@D000000`3SA1d80000000304U_
f`00000000000080000000<0BFoK0000000000000P0000000`19Km/0000000000005000000H0oe0R
3P00000603eIZ`030?mB8P000000oe@S00H0oe@S1P0mFJ/00`000000ooK^0?ofkP030?ofkP030=@m
6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h0103om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00H0
ooK^00<0e3dI0?ofkP3D?AT01@3om^h0103D?AT0ooK^0?ofkP3D?AU;0?ofkP030000003om^h0ooK^
04P0ooK^0@3oool004`0ooK^00<000000?ofkP3om^h0303om^h403eIZa<0ooK^00<0?EV[0?ofkP3o
m^h04@3om^h00`0mFJ/0ooK^03eIZ`070?ofkPH0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP03
0000000mFJ/0ooK^00T0ooK^200mFJ/40?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3o
m^h02P3om^h20000000305dL3P0mFJ/0O2LB008000000P1l9a8010000000YS<G0:Hc5`2V<aL>0000
000303eIZ`000000hd@M0080hd@M1@0mFJ/90000000304U_f`000000BFoK00P0000000<0AfkG0=@m
6@000000100000000`17K]L000000000000700000080oe0R00<0000003eIZ`3oDR80100mFJ/70?mB
8P030000003oE2<0oe@S0080oe@S00<0e3dI03eIZ`0mFJ/00P3D?AT00`000000ooK^0?ofkP080?of
kP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0=@m6@070?of
kP80e3dI1P3om^h0103D?AT0ooK^0?ofkP3D?AU;0?ofkP030000003om^h0ooK^04P0ooK^0@3oool0
04d0ooK^00<000000?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^
0140ooK^00<0?EV[0?ofkP3om^h01`0mFJ/80?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<000000?of
kP0mFJ/00`3om^h703eIZ`/0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP080?of
kP<0?EV[0`000000101M70h0?EV[07`W4P1l9a83000000L0YS<G00<000000<Tm6`39?A/01039?A/8
03eIZ`040000003SA1d0000000000080hd@M0P0000000`19Km/0000004U_f`070000000504M^e`00
0000AfkG00000017K]L0100000000`3D?AT0AfkG04M^e`050000000304M^e`3D?AT0e3dI0080e3dI
5`0000000`3D?AT0ooK^0=@m6@0=0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT02@3om^h00`3D?AT0
ooK^0=@m6@080?ofkP030=@m6@3om^h0ooK^00<0ooK^00D0e3dI0?ofkP3D?AT0ooK^0=@m6@1;0?of
kP800000B@3om^h10?ooo`00C@3om^h00`000000ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^01@0
ooK^00<0?EV[0?ofkP3om^h0403om^h403eIZ`d0ooK^00<0?EV[0?ofkP3om^h00`3om^h703eIZ`H0
ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0403eIZ`3om^h0ooK^0?of
kPL0?EV[103om^h20000000305dL3P000000?EV[00<0O2LB1@0000030:Hc5`L0?EV[10000000100m
FJ/0hd@M0>=47@3SA1d200000080hd@M1`0000002@3D?AT0000004M^e`17K]L0000004M^e`000000
AfkG0000000204M^e`80000000@0AfkG000000000000e3dI0P00000404M^e`80e3dI2@0000000`3D
?AT0000000000009000000H0ooK^0P3D?AT>0?ofkP040=@m6@3om^h0ooK^0=@m6@/0ooK^00<0e3dI
0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP030?ofkP050=@m6@3om^h0e3dI0?ofkP3D?AT0B`3o
m^h2000004T0ooK^0@3oool004h0ooK^00<000000?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0C
0?ofkP0303eIZ`3om^h0ooK^0100ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0;0?ofkPL0?EV[00D0
00000?ofkP3om^h0ooK^03eIZ`080?ofkP0303eIZ`3om^h0ooK^00/0ooK^200mFJ/<0?ofkP050000
001M70h0GA`>03eIZ`0000000`1l9a8703eIZ`H000001039?A/00`000000hd@M03eIZ`0200000080
hd@M1P00000204M^e`030000003D?AT000000080AfkG00<0000004M^e`17K]L00P17K]L01@000000
AfkG04M^e`17K]L000000080AfkG00@000000=@m6@00000000000`3D?AT00`000000?f?203mS`P03
03mS`PH0000000<0e3dI0000000000003P3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP80e3dI303om^h0
0`3D?AT0ooK^0?ofkP060?ofkP80e3dI1@3om^h01@3D?AT0ooK^0=@m6@3om^h0e3dI04/0ooK^0P00
00190?ofkP40oooo001?0?ofkP030000003om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h0503om^h0
0`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h00P3om^h7
03eIZ`030?ofkP0mFJ/0ooK^00@0ooK^00D000000?ofkP3om^h0ooK^03eIZ`070?ofkP0303eIZ`3o
m^h0ooK^00L0ooK^1`0mFJ/20?ofkP0303eIZ`3om^h0ooK^00h0ooK^1`0mFJ/2000000H0YS<G00<0
00000<Tm6`39?A/00`39?A/60000000?03eIZ`3SA1d000000000003SA1d0000004M^e`000000AfkG
00000017K]L0000004M^e`000000e3dI0080AfkG00<0000004M^e`000000200000050=@m6@`00000
0`3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP<0e3dI403om^h00`3D?AT0ooK^0?ofkP0:0?ofkP80e3dI
203om^h00`3D?AT0ooK^0=@m6@030?ofkP060=@m6@3om^h0ooK^0=@m6@3om^h0e3dIB`3om^h20000
04T0ooK^0@3oool00500ooK^00<000000?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP03
03eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h01`0mFJ/80?ofkP0303eIZ`3om^h0ooK^00<0
ooK^00<000000?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0403eIZ`3om^h0ooK^0?of
kPH0?EV[1P3om^h00`0mFJ/0ooK^03eIZ`0:0?ofkPL0?EV[10000000100mFJ/0O2LB07`W4P1l9a8=
000000@0bCdK00D000000=@m6@00000000000>=47@020000000404M^e`000000AfkG000000<0AfkG
0P0000000`3D?AT00000000000020000000303mS`P3D?AT0e3dI00H0e3dI00@0?f?2000000000000
e3dI1`00000:0?ofkP030=@m6@3om^h0ooK^00T0ooK^0P3D?AT30?ofkP030=@m6@3om^h0ooK^00`0
ooK^0P3D?AT;0?ofkP040=@m6@3om^h0ooK^0=@m6@H0ooK^00@0e3dI0?ofkP3om^h0e3dI0`3om^h0
103D?AT0ooK^0?ofkP3om^h20=@m6D`0ooK^00<000000?ofkP3om^h0A`3om^h10?ooo`00D@3om^h0
0`000000ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^01@0ooK^00<0?EV[0?ofkP3om^h02@3om^h7
03eIZ`@0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP040?ofkP030000003om^h0
ooK^00<0ooK^00<0?EV[0?ofkP0mFJ/01`0mFJ/=0?ofkP80?EV[0`3om^h703eIZ`L0ooK^00<0?EV[
0000001M70h00P0000000`0mFJ/0O2LB07`W4P0207`W4P030000002V<aL0YS<G00@0YS<G00<00000
0<Tm6`39?A/01@39?A/2000000050>=47@000000000004M^e`0000001@3D?AT2000000P0e3dI2`00
00000`3D?AT000000?ofkP0?0?ofkP030=@m6@3om^h0ooK^00L0ooK^0P3D?AT50?ofkP030=@m6@3o
m^h0ooK^00/0ooK^00@0e3dI0?ofkP3om^h0e3dI2@3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00H0
ooK^00@0e3dI0?ofkP3om^h0e3dI0`3om^h0103D?AT0ooK^0?ofkP3om^h20=@m6D`0ooK^00<00000
0?ofkP3om^h0A`3om^h10?ooo`00DP3om^h00`000000ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^
01<0ooK^00<0?EV[0?ofkP3om^h00P3om^h703eIZ`<0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0m
FJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^0080ooK^2P0mFJ/30?ofkP0303eIZ`3om^h0ooK^
00d0ooK^1`0mFJ/=0?ofkP0403eIZ`3om^h0?EV[03eIZ`80GA`>00<0000003eIZ`0000000P1l9a80
0`000000YS<G0:Hc5`040:Hc5`0400000039?A/0bCdK0<Tm6`D0?EV[00<0bCdK0000000000001@00
00000`0oHl80000003mS`P0203mS`P040000000oHl80?f?20=@m6@@00000303om^h00`3D?AT0ooK^
0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00@0ooK^0P3D?AT80?ofkP030=@m6@3om^h0ooK^00P0ooK^
0P3D?AT30?ofkP030=@m6@3om^h0ooK^00L0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@050?ofkP05
0=@m6@3om^h0ooK^0?ofkP3D?AT00`3om^h0103D?AT0ooK^0?ofkP3om^h20=@m6D`0ooK^0P000018
0?ofkP40oooo001B0?ofkP030000003om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h04@3om^h703eI
Z`X0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP030?ofkPP0?EV[0P3om^h00`00
0000ooK^0?ofkP040?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/0203om^h703eIZ`80ooK^00<0?EV[
0?ofkP0mFJ/02`3om^h603eIZ`070?ofkP000000GA`>05dL3P000000O2LB03eIZ`05000000P0?EV[
0`39?A/200000080?f?200<0e3dI03mS`P0000002`0000000`3om^h0e3dI0?ofkP0>0?ofkP030=@m
6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h00P3om^h20=@m6@X0ooK^00<0e3dI0?ofkP3om^h0
1`3om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h0
0P3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3D?AT0
1@3om^h00`3D?AT0ooK^0?ofkP1:0?ofkP800000B03om^h10?ooo`00D`3om^h00`000000ooK^0?of
kP0:0?ofkP0303eIZ`3om^h0ooK^00T0ooK^1`0mFJ/40?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0
?EV[0?ofkP3om^h01P3om^h603eIZ`80ooK^00<0?EV[0?ofkP3om^h01@3om^h00`000000ooK^0?of
kP050?ofkP0303eIZ`3om^h0?EV[0080ooK^1`0mFJ/80?ofkP0403eIZ`3om^h0ooK^0?ofkP/0?EV[
0`3om^h00`0mFJ/0ooK^0?ofkP020?ofkP030000003D?AT0?EV[00L0?EV[1@2V<aL00`000000bCdK
0<Tm6`0300000080?f?20P0000000`3D?AT0000000000004000000P0ooK^00<0e3dI0?ofkP3om^h0
3P3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP040=@m6@3om^h0e3dI0=@m6@d0ooK^00<0e3dI0?ofkP3o
m^h01@3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3o
m^h0103om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00D0ooK^00<0e3dI0?ofkP3D?AT01@3om^h00`3D
?AT0ooK^0?ofkP1:0?ofkP800000B03om^h10?ooo`00E03om^h00`000000ooK^0?ofkP090?ofkP03
03eIZ`3om^h0ooK^0080ooK^1`0mFJ/;0?ofkP0303eIZ`3om^h0ooK^00T0ooK^00@0?EV[0?ofkP3o
m^h0ooK^1P0mFJ/20?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`00
0000ooK^0?ofkP030?ofkPL0?EV[303om^h903eIZ`/0ooK^200mFJ/00`3D?AT0000007`W4P0303eI
Z`0407`W4P000000YS<G0:Hc5`80?EV[00<0YS<G0000000000002@0000000`3D?AT0ooK^0?ofkP0<
0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h03P3om^h30=@m6@l0ooK^00<0e3dI
0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI
0?ofkP3om^h01@3om^h0103D?AT0ooK^0?ofkP3D?AT60?ofkP030=@m6@3om^h0e3dI00D0ooK^00<0
e3dI0?ofkP3om^h0BP3om^h2000004P0ooK^0@3oool005D0ooK^00<000000?ofkP3om^h02@3om^h4
03eIZa<0ooK^00<0?EV[0?ofkP3om^h0203om^h403eIZ`P0ooK^00<0?EV[0?ofkP3om^h00P3om^h0
0`0mFJ/0ooK^0?ofkP050?ofkPL0?EV[0`3om^h203eIZ`P0ooK^1P0mFJ/20?ofkP0303eIZ`3om^h0
ooK^00@0ooK^00<0?EV[0?ofkP3om^h00P3om^h703eIZ`D0ooK^300mFJ/20=@m6@030000003D?AT0
000000<000001P3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI
0?ofkP3om^h02P3om^h30=@m6@030?ofkP3D?AT0ooK^0100ooK^00<0e3dI0?ofkP3om^h00P3om^h0
0`3D?AT0ooK^0?ofkP080?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT0203om^h0103D?AT0ooK^0?of
kP3D?AT70?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h0B`3om^h00`000000ooK^
0?ofkP160?ofkP40oooo001F0?ofkP030000003om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h0503o
m^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00/0ooK^00@0?EV[0?ofkP3om^h0ooK^
200mFJ/00`3om^h000000?ofkP070?ofkP0303eIZ`3om^h0?EV[00L0?EV[1`3om^h00`0mFJ/0ooK^
0?ofkP030?ofkPL0?EV[0P3om^h@03eIZ`030?ofkP3D?AT0000000D000000P3D?AT;0?ofkP030=@m
6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP070?ofkP<0e3dI
1@3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^0080e3dI2`3om^h0103D?AT0ooK^
0?ofkP3D?AT90?ofkP030=@m6@3om^h0e3dI00P0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0
ooK^0?ofkP1<0?ofkP030000003om^h0ooK^04H0ooK^0@3oool005L0ooK^00<000000?ofkP3om^h0
2@3om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h0
2@3om^h703eIZ`L0ooK^00<000000?ofkP3om^h00`3om^h803eIZ``0ooK^1`0mFJ/30?ofkPH0?EV[
00<0ooK^03eIZ`0mFJ/01`0mFJ/20?ofkPL0e3dI0P3om^h20=@m6@<0ooK^0P3D?AT90?ofkP030=@m
6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP030?ofkP<0e3dI
203om^h00`3D?AT0ooK^0?ofkP0?0?ofkP80e3dI3@3om^h0103D?AT0ooK^0?ofkP3D?AT:0?ofkP80
e3dI1`3om^h20=@m6@D0ooK^00<0e3dI0?ofkP3om^h0C03om^h00`000000ooK^0?ofkP160?ofkP40
oooo001G0?ofkP030000003om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^
0?ofkP040?ofkP0303eIZ`3om^h0ooK^00<0ooK^1`0mFJ/40?ofkP80?EV[203om^h603eIZ`80ooK^
00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP020?ofkPP0?EV[0P3om^h703eIZ`80ooK^
1`0mFJ/:0?ofkP80e3dI00@0ooK^0=@m6@3D?AT0e3dI0P3om^h20=@m6@@0ooK^1@3D?AT60?ofkP03
0=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP030=@m6@`0
ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP80e3dI2`3om^h00`3D?AT0
ooK^0?ofkP060?ofkP030=@m6@3om^h0e3dI00@0ooK^00<0e3dI0?ofkP3om^h0C03om^h2000004L0
ooK^0@3oool005P0ooK^00<000000?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP0303eI
Z`3om^h0ooK^0080ooK^1`0mFJ/;0?ofkP80?EV[0P3om^h603eIZ`030000003om^h0ooK^00@0ooK^
00<0?EV[0?ofkP3om^h00P3om^h703eIZ`<0ooK^1`0mFJ/20?ofkPL0?EV[4P3om^h20=@m6@040?of
kP3D?AT0e3dI0=@m6@80ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP020?ofkP<0
e3dI103om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00X0ooK^1@3D?AT?0?ofkP03
0=@m6@3om^h0ooK^00`0ooK^0`3D?AT?0?ofkP030=@m6@3om^h0ooK^00T0ooK^0P3D?AT70?ofkP04
0=@m6@3om^h0ooK^0=@m6@@0ooK^00<0e3dI0?ofkP3om^h0C03om^h2000004L0ooK^0@3oool005T0
ooK^00<000000?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP0A0?ofkPP0?EV[3P3om^h703eIZ`H0
ooK^00<000000?ofkP3om^h00`3om^h603eIZ`@0ooK^3`0mFJ/I0?ofkP80e3dI00@0ooK^0=@m6@3D
?AT0e3dI0P3om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00@0ooK^1@3D?AT>0?of
kP030=@m6@3om^h0ooK^0080ooK^203D?AT30?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?of
kP3om^h02@3om^h20=@m6@<0ooK^00<0e3dI0?ofkP3om^h02`3om^h20=@m6@X0ooK^00@0e3dI0?of
kP3om^h0e3dI1P3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI0080ooK^00<0e3dI0?ofkP3om^h0C@3o
m^h2000004L0ooK^0@3oool005X0ooK^00<000000?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP0:
0?ofkPH0?EV[103om^h0100mFJ/0ooK^0?ofkP0mFJ/80?ofkPH0?EV[0P3om^h00`0mFJ/0ooK^0?of
kP020?ofkP0303eIZ`3om^h0ooK^0080ooK^200mFJ/20?ofkPL0?EV[00<0ooK^03eIZ`0mFJ/01@0m
FJ/Q0?ofkP80e3dI00H0ooK^0=@m6@3om^h0e3dI0?ofkP3D?AT50?ofkP030=@m6@3om^h0ooK^00P0
ooK^503D?AT<0?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h01`3om^h20=@m6@D0
ooK^00<0e3dI0?ofkP3om^h02@3om^h20=@m6@80ooK^00<0e3dI0?ofkP3om^h01`3om^h0103D?AT0
ooK^0?ofkP3D?AT50?ofkP030=@m6@3om^h0ooK^0080ooK^00@0e3dI0?ofkP3om^h0e3dID03om^h0
0`000000ooK^0?ofkP150?ofkP40oooo001K0?ofkP030000003om^h0ooK^00T0ooK^00<0?EV[0?of
kP3om^h00P3om^h703eIZ`/0ooK^0P0mFJ/30?ofkPH0?EV[1`3om^h0100mFJ/0ooK^0?ofkP3om^h7
03eIZ`030?ofkP000000ooK^00L0?EV[0P3om^h603eIZbP0ooK^0P3D?AT0103om^h0e3dI0?ofkP3o
m^h20=@m6@H0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3o
m^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP040?ofkP80e3dI203o
m^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h01P3o
m^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h00P3o
m^h0103D?AT0ooK^0?ofkP3D?AU@0?ofkP030000003om^h0ooK^04D0ooK^0@3oool005`0ooK^00<0
00000?ofkP3om^h02@3om^h403eIZa<0ooK^100mFJ/:0?ofkPL0?EV[103om^h?03eIZbl0ooK^0P3D
?AT00`3om^h0e3dI0?ofkP040=@m6@D0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?of
kP0<0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?of
kP020?ofkP80e3dI2P3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0
e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP030?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT0
1P3om^h00`3D?AT0ooK^0=@m6@1@0?ofkP030000003om^h0ooK^04D0ooK^0@3oool005`0ooK^00<0
00000?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP0403eIZ`3om^h0ooK^03eIZ`@0ooK^
1`0mFJ/0103om^h0?EV[0?ofkP3om^h?03eIZcL0ooK^0`3D?AT20?ofkP030=@m6@3om^h0ooK^0080
e3dI0`3om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3o
m^h03@3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP040=@m6@3om^h0e3dI0=@m6@`0ooK^00<0e3dI0?of
kP3om^h0103om^h20=@m6@L0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP040?of
kP050=@m6@3om^h0ooK^0?ofkP3D?AT01P3om^h20=@m6E40ooK^0P0000160?ofkP40oooo001M0?of
kP030000003om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h03`3om^h203eIZ`030?ofkP0mFJ/0?EV[
00D0?EV[0`3om^h?03eIZ`@0ooK^00<000000?ofkP3om^h0>03om^h40=@m6@030?ofkP3D?AT0ooK^
00<0ooK^0P3D?AT20?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D
?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00d0ooK^0`3D?AT?0?ofkP030=@m6@3om^h0ooK^
0080ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^
00H0ooK^00<0e3dI0?ofkP3D?AT0203om^h00`3D?AT0ooK^0?ofkP1?0?ofkP800000AP3om^h10?oo
o`00GP3om^h00`000000ooK^0?ofkP0:0?ofkP80?EV[303om^hE03eIZ`h0ooK^00<000000?ofkP3o
m^h0>@3om^h30=@m6@80ooK^00<0e3dI0?ofkP3om^h00`3om^h30=@m6@X0ooK^00<0e3dI0?ofkP3o
m^h0303om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00X0ooK^0`3D?AT00`3om^h0
e3dI0?ofkP0?0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT02`3om^h0103D?AT0ooK^0?ofkP3D?AT9
0?ofkP030=@m6@3om^h0e3dI00P0ooK^00<0e3dI0?ofkP3om^h0C`3om^h2000004H0ooK^0@3oool0
05l0ooK^00<000000?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP020?ofkQ<0?EV[5`3om^h00`00
0000ooK^0?ofkP0i0?ofkPL0e3dI1P3om^h30=@m6@T0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D
?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00H0ooK^0`3D?AT50?ofkP030=@m6@3om^h0ooK^
00h0ooK^0`3D?AT<0?ofkP040=@m6@3om^h0ooK^0=@m6@X0ooK^00<0e3dI0?ofkP3om^h01P3om^h0
0`3D?AT0ooK^0?ofkP1A0?ofkP030000003om^h0ooK^04@0ooK^0@3oool00600ooK^00<000000?of
kP3om^h02`3om^h403eIZ`D0ooK^200mFJ/M0?ofkP030000003om^h0ooK^03X0ooK^0`3D?AT00`3o
m^h0e3dI0=@m6@070?ofkP030=@m6@3om^h0e3dI0080e3dI1P3om^h00`3D?AT0ooK^0?ofkP0<0?of
kP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h00`3om^h30=@m6@P0ooK^00<0e3dI0?of
kP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP80e3dI2`3om^h00`3D?AT0ooK^0?ofkP060?of
kP030=@m6@3om^h0ooK^0540ooK^00<000000?ofkP3om^h0A03om^h10?ooo`00H@3om^h00`000000
ooK^0?ofkP0>0?ofkPL0?EV[8P3om^h00`000000ooK^0?ofkP0k0?ofkP80e3dI00<0ooK^0=@m6@3D
?AT00P3D?AT70?ofkP040=@m6@3om^h0ooK^0?ofkP@0e3dI0`3om^h00`3D?AT0ooK^0?ofkP0<0?of
kP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3D?AT00P3D?AT<0?ofkP030=@m6@3om^h0ooK^
00/0ooK^0`3D?AT?0?ofkP030=@m6@3om^h0ooK^00T0ooK^0P3D?AT70?ofkP030=@m6@3om^h0ooK^
0580ooK^00<000000?ofkP3om^h0A03om^h10?ooo`00H@3om^h00`000000ooK^0?ofkP0g0?ofkP03
0000003om^h0ooK^03`0ooK^00H0e3dI0?ofkP3D?AT0e3dI0?ofkP3D?AT70?ofkP030=@m6@3om^h0
ooK^00D0ooK^103D?AT>0?ofkP030=@m6@3om^h0ooK^00X0ooK^1@3D?AT?0?ofkP030=@m6@3om^h0
ooK^00T0ooK^0P3D?AT30?ofkP030=@m6@3om^h0ooK^00/0ooK^0P3D?AT:0?ofkP040=@m6@3om^h0
ooK^0=@m6@D0ooK^00<0e3dI0?ofkP3om^h0D`3om^h00`000000ooK^0?ofkP140?ofkP40oooo001R
0?ofkP030000003om^h0ooK^03H0ooK^00<000000?ofkP3om^h0?03om^h20=@m6@050?ofkP3D?AT0
ooK^0?ofkP3D?AT01`3om^h00`3D?AT0ooK^0?ofkP070?ofkPT0e3dI1`3om^h0103D?AT0ooK^0?of
kP3om^h80=@m6@<0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP060?ofkP80e3dI
1@3om^h00`3D?AT0ooK^0?ofkP090?ofkP80e3dI0P3om^h00`3D?AT0ooK^0?ofkP070?ofkP040=@m
6@3om^h0ooK^0=@m6@D0ooK^00<0e3dI0?ofkP3om^h0D`3om^h2000004D0ooK^0@3oool006<0ooK^
00<000000?ofkP3om^h0=@3om^h00`000000ooK^0?ofkP0m0?ofkP030=@m6@3om^h0e3dI00<0ooK^
0P3D?AT50?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h0103om^h;0=@m6@`0ooK^
00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP040?ofkP80e3dI203om^h00`3D?AT0ooK^
0?ofkP070?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h01P3om^h01@3D?AT0ooK^
0?ofkP3om^h0e3dI00@0ooK^00<0e3dI0?ofkP3om^h0E03om^h2000004D0ooK^0@3oool006@0ooK^
00<000000?ofkP3om^h0=03om^h00`000000ooK^0?ofkP0n0?ofkP030=@m6@3om^h0e3dI0080ooK^
00<0e3dI0?ofkP3D?AT01@3om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00/0ooK^
00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP040=@m6@3om^h0ooK^0?ofkP80
e3dI2P3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3o
m^h0103om^h00`3D?AT0ooK^0?ofkP030?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT0E`3om^h00`00
0000ooK^0?ofkP130?ofkP40oooo001U0?ofkP030000003om^h0ooK^03<0ooK^00<000000?ofkP3o
m^h0?P3om^h30=@m6@<0ooK^00@0e3dI0?ofkP3D?AT0e3dI0`3om^h00`3D?AT0ooK^0?ofkP090?of
kP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0>0?of
kP040=@m6@3om^h0e3dI0=@m6@d0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP05
0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h0103om^h0103D?AT0ooK^0?ofkP3D
?AUH0?ofkP030000003om^h0ooK^04<0ooK^0@3oool006H0ooK^00<000000?ofkP3om^h0<P3om^h0
0`000000ooK^0?ofkP0o0?ofkP<0e3dI0P3om^h0103D?AT0ooK^0?ofkP3om^h20=@m6@80ooK^00<0
e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0
e3dI0?ofkP3om^h03P3om^h20=@m6@l0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?of
kP060?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0=@m
6@1I0?ofkP030000003om^h0ooK^04<0ooK^0@3oool006H0ooK^00<000000?ofkP3om^h0<P3om^h0
0`000000ooK^0?ofkP100?ofkP<0e3dI0P3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0
e3dI00/0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0
ooK^00X0ooK^0`3D?AT00`3om^h0e3dI0?ofkP0?0?ofkP030=@m6@3om^h0ooK^0080e3dI2P3om^h0
103D?AT0ooK^0?ofkP3D?AT90?ofkP80e3dIF@3om^h00`000000ooK^0?ofkP130?ofkP40oooo001W
0?ofkP030000003om^h0ooK^0340ooK^00<000000?ofkP3om^h0@03om^h20=@m6@050?ofkP3D?AT0
ooK^0?ofkP3D?AT0103om^h30=@m6@/0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?of
kP0=0?ofkP030=@m6@3om^h0ooK^00L0ooK^0`3D?AT50?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0
e3dI0?ofkP3D?AT0303om^h0103D?AT0ooK^0?ofkP3D?AT90?ofkP030=@m6@3om^h0ooK^05P0ooK^
0P0000140?ofkP40oooo001X0?ofkP030000003om^h0ooK^0300ooK^00<000000?ofkP3om^h0@@3o
m^h20=@m6@040?ofkP3D?AT0ooK^0=@m6@H0ooK^0`3D?AT90?ofkP030=@m6@3om^h0ooK^00/0ooK^
00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP030?ofkP<0e3dI203om^h00`3D?AT0ooK^
0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00`0ooK^0P3D?AT90?ofkP030=@m6@3om^h0ooK^05T0ooK^
0P0000140?ofkP40oooo001Y0?ofkP030000003om^h0ooK^02l0ooK^00<000000?ofkP3om^h0@P3o
m^h00`3D?AT0ooK^0?ofkP030=@m6@H0ooK^00<0e3dI0?ofkP3D?AT00`3D?AT60?ofkP030=@m6@3o
m^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP030=@m6@`0ooK^00<0
e3dI0?ofkP3om^h02`3om^h30=@m6@h0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?of
kP1K0?ofkP030000003om^h0ooK^0480ooK^0@3oool006X0ooK^00<000000?ofkP3om^h0;P3om^h0
0`000000ooK^0?ofkP120?ofkP80e3dI0`3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0
ooK^00<0ooK^1@3D?AT00`3om^h0e3dI0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00X0ooK^1@3D?AT?
0?ofkP030=@m6@3om^h0ooK^00T0ooK^0P3D?AT30?ofkP030=@m6@3om^h0ooK^00X0ooK^0P3D?AT9
0?ofkP030=@m6@3om^h0ooK^05/0ooK^00<000000?ofkP3om^h0@P3om^h10?ooo`00J`3om^h00`00
0000ooK^0?ofkP0/0?ofkP030000003om^h0ooK^04@0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D
?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00L0ooK^2@3D?AT60?ofkP030=@m6@3om^h0ooK^
0080ooK^203D?AT30?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h01`3om^h20=@m
6@D0ooK^00<0e3dI0?ofkP3om^h0203om^h20=@m6@80ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D
?AT0ooK^0?ofkP1L0?ofkP030000003om^h0ooK^0480ooK^0@3oool006/0ooK^00<000000?ofkP3o
m^h0;03om^h00`000000ooK^0?ofkP150?ofkP030=@m6@3om^h0ooK^0080ooK^0P3D?AT50?ofkP03
0=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h0103om^h;0=@m6@`0ooK^00<0e3dI0?ofkP3o
m^h03P3om^h00`3D?AT0ooK^0?ofkP040?ofkP80e3dI203om^h00`3D?AT0ooK^0?ofkP060?ofkP03
0=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP1M0?ofkP03
0000003om^h0ooK^0480ooK^0@3oool006`0ooK^00<000000?ofkP3om^h0:`3om^h00`000000ooK^
0?ofkP150?ofkP80e3dI0`3om^h0103D?AT0ooK^0=@m6@3D?AT30?ofkP030=@m6@3om^h0ooK^00T0
ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00h0
ooK^00<0e3dI0?ofkP3om^h00P3om^h20=@m6@X0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0
ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h0GP3om^h2000004<0
ooK^0@3oool006d0ooK^00<000000?ofkP3om^h0:P3om^h00`000000ooK^0?ofkP160?ofkP80e3dI
0`3om^h00`3D?AT0ooK^0?ofkP020=@m6@80ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^
0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h03P3om^h0103D?AT0ooK^
0=@m6@3D?AT<0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h01@3om^h01@3D?AT0
ooK^0?ofkP3om^h0e3dI0640ooK^0P0000130?ofkP40oooo001^0?ofkP030000003om^h0ooK^02T0
ooK^00<000000?ofkP3om^h0AP3om^h30=@m6@80ooK^00<0e3dI0?ofkP3om^h00P3om^h20=@m6@03
0?ofkP3D?AT0ooK^00T0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP03
0=@m6@3om^h0ooK^00d0ooK^0`3D?AT?0?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3o
m^h01P3om^h0103D?AT0ooK^0?ofkP3D?AUS0?ofkP030000003om^h0ooK^0440ooK^0@3oool006l0
ooK^00<000000?ofkP3om^h0:03om^h00`000000ooK^0?ofkP170?ofkP060=@m6@3om^h0e3dI0=@m
6@3om^h0e3dI1@3om^h20=@m6@X0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP0=
0?ofkP030=@m6@3om^h0ooK^00T0ooK^0`3D?AT00`3om^h0e3dI0?ofkP0?0?ofkP030=@m6@3om^h0
ooK^0080e3dI2@3om^h0103D?AT0ooK^0?ofkP3D?AUS0?ofkP030000003om^h0ooK^0440ooK^0@3o
ool00700ooK^00<000000?ofkP3om^h09`3om^h00`000000ooK^0?ofkP180?ofkP030=@m6@3om^h0
ooK^0080e3dI1`3om^h20=@m6@T0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP0=
0?ofkP030=@m6@3om^h0ooK^00L0ooK^0P3D?AT50?ofkP030=@m6@3om^h0ooK^00h0ooK^0P3D?AT<
0?ofkP80e3dII03om^h00`000000ooK^0?ofkP110?ofkP40oooo001`0?ofkP030000003om^h0ooK^
02L0ooK^00<000000?ofkP3om^h0B03om^h0103D?AT0ooK^0?ofkP3om^h20=@m6@H0ooK^00<0e3dI
0?ofkP3D?AT00P3D?AT60?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h03@3om^h0
0`3D?AT0ooK^0?ofkP030?ofkP<0e3dI1`3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0
ooK^00/0ooK^00<0e3dI0?ofkP3om^h0H`3om^h00`000000ooK^0?ofkP110?ofkP40oooo001a0?of
kP030000003om^h0ooK^02H0ooK^00<000000?ofkP3om^h0B@3om^h01@3D?AT0ooK^0?ofkP3om^h0
e3dI00L0ooK^00@0e3dI0?ofkP3om^h0ooK^103D?AT30?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0
e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP030=@m6@/0ooK^00<0e3dI0?ofkP3om^h02`3o
m^h30=@m6@`0ooK^00<0e3dI0?ofkP3om^h0I03om^h00`000000ooK^0?ofkP110?ofkP40oooo001b
0?ofkP030000003om^h0ooK^02D0ooK^00<000000?ofkP3om^h0B@3om^h00`3D?AT0ooK^0?ofkP02
0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h01@3om^h40=@m6@d0ooK^00<0e3dI
0?ofkP3om^h02P3om^h50=@m6@h0ooK^00<0e3dI0?ofkP3om^h02@3om^h20=@m6@<0ooK^00<0e3dI
0?ofkP3om^h01`3om^h20=@m6FL0ooK^0P0000120?ofkP40oooo001c0?ofkP030000003om^h0ooK^
02@0ooK^00<000000?ofkP3om^h0BP3om^h00`3D?AT0ooK^0?ofkP020?ofkP80e3dI1@3om^h00`3D
?AT0ooK^0?ofkP070?ofkPP0e3dI1P3om^h00`3D?AT0ooK^0?ofkP020?ofkPP0e3dI103om^h00`3D
?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00H0ooK^0P3D?AT50?ofkP030=@m6@3om^h0ooK^
00H0ooK^00<0e3dI0?ofkP3om^h0J03om^h00`000000ooK^0?ofkP100?ofkP40oooo001d0?ofkP03
0000003om^h0ooK^02<0ooK^00<000000?ofkP3om^h0B`3om^h01`3D?AT0ooK^0?ofkP3om^h0e3dI
0?ofkP3D?AT0103om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^00<0ooK^2`3D?AT<
0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h0103om^h20=@m6@L0ooK^00<0e3dI
0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP1Y0?ofkP030000003om^h0ooK^0400ooK^0@3oool0
07D0ooK^00<000000?ofkP3om^h08@3om^h00`000000ooK^0?ofkP1=0?ofkP060=@m6@3om^h0ooK^
0?ofkP3D?AT0ooK^0P3D?AT30?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h02`3o
m^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00d0ooK^00@0e3dI0?ofkP3om^h0ooK^
0P3D?AT:0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h0JP3om^h00`000000ooK^
0?ofkP100?ofkP40oooo001e0?ofkP030000003om^h0ooK^0240ooK^00<000000?ofkP3om^h0CP3o
m^h0103D?AT0ooK^0?ofkP3D?AT30?ofkP80e3dI00<0ooK^0=@m6@3om^h02P3om^h00`3D?AT0ooK^
0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h03@3om^h0103D?AT0ooK^
0=@m6@3D?AT<0?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h0J`3om^h00`000000
ooK^0?ofkP100?ofkP40oooo001f0?ofkP030000003om^h0ooK^0200ooK^00<000000?ofkP3om^h0
C`3om^h20=@m6@030?ofkP3D?AT0ooK^00<0ooK^00<0e3dI0?ofkP3D?AT02P3om^h00`3D?AT0ooK^
0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h0303om^h20=@m6@h0ooK^
00<0e3dI0?ofkP3om^h00P3D?AU^0?ofkP030000003om^h0ooK^0400ooK^0@3oool007L0ooK^00<0
00000?ofkP3om^h07`3om^h00`000000ooK^0?ofkP1A0?ofkP80e3dI1@3om^h20=@m6@/0ooK^00<0
e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00P0ooK^103D
?AT00`3om^h0e3dI0?ofkP0>0?ofkP80e3dIL03om^h200000440ooK^0@3oool007P0ooK^00<00000
0?ofkP3om^h07P3om^h00`000000ooK^0?ofkP1B0?ofkP80e3dI1P3om^h30=@m6@P0ooK^00<0e3dI
0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00@0ooK^0`3D?AT6
0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h0L03om^h00`000000ooK^0?ofkP0o
0?ofkP40oooo001i0?ofkP030000003om^h0ooK^01d0ooK^00<000000?ofkP3om^h0D`3om^h00`3D
?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0e3dI00<0e3dI1@3om^h00`3D?AT0ooK^0?ofkP0:0?of
kP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h0103D?AT90?ofkP030=@m6@3om^h0ooK^
00X0ooK^0P3D?AUc0?ofkP030000003om^h0ooK^03l0ooK^0@3oool007X0ooK^00<000000?ofkP3o
m^h0703om^h00`000000ooK^0?ofkP1D0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3o
m^h00`3om^h40=@m6@030?ofkP3D?AT0ooK^00`0ooK^00<0e3dI0?ofkP3om^h02P3om^h50=@m6@h0
ooK^00<0e3dI0?ofkP3om^h01`3om^h20=@m6G40ooK^1@0000110?ofkP40oooo001j0?ofkP030000
003om^h0ooK^01`0ooK^00<000000?ofkP3om^h0E@3om^h20=@m6@D0ooK^00<0e3dI0?ofkP3om^h0
1P3om^h90=@m6@H0ooK^00<0e3dI0?ofkP3om^h00P3om^h80=@m6@<0ooK^00<0e3dI0?ofkP3om^h0
3@3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^06T0ooK^200000160?ofkP40oooo
001k0?ofkP030000003om^h0ooK^01/0ooK^00<000000?ofkP3om^h0E`3om^h20=@m6@<0ooK^00<0
e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP030?ofkP/0e3dI303om^h00`3D?AT0ooK^0?of
kP0=0?ofkP030=@m6@3om^h0ooK^00<0ooK^0P3D?AUT0?ofkPP00000CP3om^h10?ooo`00O03om^h0
0`000000ooK^0?ofkP0J0?ofkP030000003om^h0ooK^05T0ooK^0P3D?AT20?ofkP030=@m6@3om^h0
ooK^00P0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0
ooK^00d0ooK^00@0e3dI0?ofkP3om^h0ooK^0P3D?AUM0?ofkPT00000EP3om^h10?ooo`00O@3om^h0
0`000000ooK^0?ofkP0I0?ofkP030000003om^h0ooK^05/0ooK^0P3D?AT00`3om^h0e3dI0?ofkP09
0?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0=
0?ofkP<0e3dIE`3om^h8000005l0ooK^0@3oool007h0ooK^00<000000?ofkP3om^h05`3om^h00`00
0000ooK^0?ofkP1N0?ofkP80e3dI2P3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^
00`0ooK^00<0e3dI0?ofkP3om^h0303om^h20=@m6E40ooK^2000001W0?ofkP40oooo001o0?ofkP03
0000003om^h0ooK^01H0ooK^00<000000?ofkP3om^h0H03om^h20=@m6@T0ooK^00<0e3dI0?ofkP3o
m^h02P3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00L0ooK^103D?AU:0?ofkPT0
0000K`3om^h10?ooo`00O`3om^h00`000000ooK^0?ofkP0F0?ofkP030000003om^h0ooK^0680ooK^
0`3D?AT60?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^
0?ofkP040?ofkP<0e3dIAP3om^h8000007P0ooK^0@3oool00800ooK^00<000000?ofkP3om^h05@3o
m^h00`000000ooK^0?ofkP1U0?ofkP@0e3dI0`3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3o
m^h0ooK^00d0ooK^00<0e3dI0?ofkP3D?AT00`3D?AU10?ofkPP00000P03om^h10?ooo`00P@3om^h0
0`000000ooK^0?ofkP0D0?ofkP030000003om^h0ooK^06T0ooK^103D?AT=0?ofkP030=@m6@3om^h0
ooK^00T0ooK^1@3D?ATl0?ofkPT00000R03om^h10?ooo`00PP3om^h00`000000ooK^0?ofkP0C0?of
kP030000003om^h0ooK^06`0ooK^203D?AT60?ofkP030=@m6@3om^h0ooK^0080ooK^1`3D?ATi0?of
kPP00000T@3om^h10?ooo`00P`3om^h00`000000ooK^0?ofkP0B0?ofkP030000003om^h0ooK^07@0
ooK^2`3D?ATh0?ofkPP00000V@3om^h10?ooo`00Q03om^h00`000000ooK^0?ofkP0A0?ofkP030000
003om^h0ooK^0:h0ooK^2@00002Q0?ofkP40oooo00240?ofkP030000003om^h0ooK^0140ooK^00<0
00000?ofkP3om^h0YP3om^h800000:X0ooK^0@3oool008D0ooK^00<000000?ofkP3om^h0403om^h0
0`000000ooK^0?ofkP2N0?ofkPP00000/P3om^h10?ooo`00QP3om^h00`000000ooK^0?ofkP0?0?of
kP030000003om^h0ooK^09D0ooK^2@00002j0?ofkP40oooo00270?ofkP030000003om^h0ooK^00h0
ooK^00<000000?ofkP3om^h0S@3om^h800000<<0ooK^0@3oool008P0ooK^00<000000?ofkP3om^h0
303om^h00`000000ooK^0?ofkP260?ofkPP00000b`3om^h10?ooo`00R@3om^h00`000000ooK^0?of
kP0;0?ofkP030000003om^h0ooK^07h0ooK^2000003C0?ofkP40oooo00290?ofkP030000003om^h0
ooK^00/0ooK^00<000000?ofkP3om^h0M@3om^h900000=/0ooK^0@3oool008X0ooK^00<000000?of
kP3om^h02P3om^h00`000000ooK^0?ofkP1]0?ofkPP00000i03om^h10?ooo`00R`3om^h00`000000
ooK^0?ofkP090?ofkP030000003om^h0ooK^06D0ooK^2000003/0?ofkP40oooo002<0?ofkP030000
003om^h0ooK^00P0ooK^00<000000?ofkP3om^h0G03om^h900000?@0ooK^0@3oool008d0ooK^00<0
00000?ofkP3om^h01`3om^h00`000000ooK^0?ofkP1D0?ofkPP00000o@3om^h10?ooo`00SP3om^h0
0`000000ooK^0?ofkP060?ofkP030000003om^h0ooK^04`0ooK^2000003o0?ofkPH0ooK^0@3oool0
08h0ooK^00<000000?ofkP3om^h01P3om^h00`000000ooK^0?ofkP130?ofkPT00000o`3om^h>0?of
kP40oooo002?0?ofkP030000003om^h0ooK^00D0ooK^00<000000?ofkP3om^h0>`3om^h800000?l0
ooK^5`3om^h10?ooo`00T03om^h00`000000ooK^0?ofkP040?ofkP030000003om^h0ooK^03<0ooK^
2000003o0?ofkQl0ooK^0@3oool00940ooK^00<000000?ofkP3om^h00`3om^h00`000000ooK^0?of
kP0Z0?ofkPT00000o`3om^hW0?ofkP40oooo002B0?ofkP050000003om^h0ooK^0?ofkP0000009@3o
m^h800000?l0ooK^<03om^h10?ooo`00T`3om^h010000000ooK^0?ofkP00000M0?ofkPP00000o`3o
m^hh0?ofkP40oooo002C0?ofkP040000003om^h0ooK^000001@0ooK^2@00003o0?ofkT00ooK^0@3o
ool009@0ooK^00<000000?ofkP000000303om^h800000?l0ooK^B@3om^h10?ooo`00U@3om^h20000
00@0ooK^2000003o0?ofkU40ooK^0@3oool009H0ooK^1@00003o0?ofkUT0ooK^0@3oool00?l0ooK^
m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?oo
o`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd
0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo
003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0
ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool0
0?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03o
m^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00
o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?of
kP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o
0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^
0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0
ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h1
0?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3o
m^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40
oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?of
k_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3o
ool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^
m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?oo
o`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd
0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo
003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0
ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool0
0?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03o
m^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00
o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?of
kP40oooo003o0?ofk_@0ooK^0@3oool00001\
\>"],
  ImageRangeCache->{{{0, 499}, {499, 0}} -> {-5.00005*^-06, -5.00005*^-06, \
0.00200403, 0.00200403}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
%%ImageSize: 500 500 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics3D
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Background color
1 .961 .933 r
MFill
% Scaling calculations
0 1 0 1 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 0 r
.25 Mabswid
[ ] 0 setdash
.14736 .14594 m
.09252 .42015 L
s
.09252 .42015 m
.21113 .79004 L
s
.21113 .79004 m
.23981 .55099 L
s
.23981 .55099 m
.14736 .14594 L
s
.85264 .14594 m
.76019 .55099 L
s
.76019 .55099 m
.78887 .79004 L
s
.78887 .79004 m
.90748 .42015 L
s
.90748 .42015 m
.85264 .14594 L
s
.14736 .14594 m
.09252 .42015 L
s
.09252 .42015 m
.90748 .42015 L
s
.90748 .42015 m
.85264 .14594 L
s
.85264 .14594 m
.14736 .14594 L
s
.23981 .55099 m
.76019 .55099 L
s
.76019 .55099 m
.78887 .79004 L
s
.78887 .79004 m
.21113 .79004 L
s
.21113 .79004 m
.23981 .55099 L
s
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
.83 .24 .1 r
.5 Mabswid
.51307 .55057 m
.53873 .55504 L
s
.51331 .52967 m
.51307 .55057 L
s
.48693 .55057 m
.51307 .55057 L
s
.48669 .52967 m
.48693 .55057 L
s
.46127 .55504 m
.48693 .55057 L
s
.53873 .55504 m
.56292 .56382 L
s
.53944 .53417 m
.53873 .55504 L
s
.46056 .53417 m
.46127 .55504 L
s
.43708 .56382 m
.46127 .55504 L
s
.56292 .56382 m
.58469 .57664 L
s
.56408 .54303 m
.56292 .56382 L
s
.43592 .54303 m
.43708 .56382 L
s
.41531 .57664 m
.43708 .56382 L
s
.58469 .57664 m
.60316 .59306 L
s
.58626 .55596 m
.58469 .57664 L
s
.41374 .55596 m
.41531 .57664 L
s
.39684 .59306 m
.41531 .57664 L
s
.53944 .53417 m
.51331 .52967 L
s
.51356 .50798 m
.51331 .52967 L
s
.51331 .52967 m
.48669 .52967 L
s
.48644 .50798 m
.48669 .52967 L
s
.48669 .52967 m
.46056 .53417 L
s
.60316 .59306 m
.61752 .61251 L
s
.60509 .57253 m
.60316 .59306 L
s
.39491 .57253 m
.39684 .59306 L
s
.38248 .61251 m
.39684 .59306 L
s
.56408 .54303 m
.53944 .53417 L
s
.54018 .51252 m
.53944 .53417 L
s
.45982 .51252 m
.46056 .53417 L
s
.46056 .53417 m
.43592 .54303 L
s
.58626 .55596 m
.56408 .54303 L
s
.56528 .52145 m
.56408 .54303 L
s
.43472 .52145 m
.43592 .54303 L
s
.43592 .54303 m
.41374 .55596 L
s
.61752 .61251 m
.62706 .63427 L
s
.61974 .59216 m
.61752 .61251 L
s
.38026 .59216 m
.38248 .61251 L
s
.37294 .63427 m
.38248 .61251 L
s
.60509 .57253 m
.58626 .55596 L
s
.58789 .5345 m
.58626 .55596 L
s
.41211 .5345 m
.41374 .55596 L
s
.41374 .55596 m
.39491 .57253 L
s
.54018 .51252 m
.51356 .50798 L
s
.51382 .48547 m
.51356 .50798 L
s
.51356 .50798 m
.48644 .50798 L
s
.48618 .48547 m
.48644 .50798 L
s
.48644 .50798 m
.45982 .51252 L
s
.37052 .61413 m
.37294 .63427 L
s
.36877 .65748 m
.37294 .63427 L
s
.62706 .63427 m
.63123 .65748 L
s
.62948 .61413 m
.62706 .63427 L
s
.61974 .59216 m
.60509 .57253 L
s
.6071 .55122 m
.60509 .57253 L
s
.3929 .55122 m
.39491 .57253 L
s
.39491 .57253 m
.38026 .59216 L
s
.56528 .52145 m
.54018 .51252 L
s
.54094 .49005 m
.54018 .51252 L
s
.45906 .49005 m
.45982 .51252 L
s
.45982 .51252 m
.43472 .52145 L
s
.58789 .5345 m
.56528 .52145 L
s
.56653 .49905 m
.56528 .52145 L
s
.43347 .49905 m
.43472 .52145 L
s
.43472 .52145 m
.41211 .5345 L
s
.62948 .61413 m
.61974 .59216 L
s
.62204 .57104 m
.61974 .59216 L
s
.37796 .57104 m
.38026 .59216 L
s
.38026 .59216 m
.37052 .61413 L
s
.63123 .65748 m
.63376 .63758 L
s
.63123 .65748 m
.6297 .68118 L
s
.36624 .63758 m
.36877 .65748 L
s
.3703 .68118 m
.36877 .65748 L
s
.6071 .55122 m
.58789 .5345 L
s
.58959 .51221 m
.58789 .5345 L
s
.41041 .51221 m
.41211 .5345 L
s
.41211 .5345 m
.3929 .55122 L
s
.54094 .49005 m
.51382 .48547 L
s
.51409 .46208 m
.51382 .48547 L
s
.51382 .48547 m
.48618 .48547 L
s
.48591 .46208 m
.48618 .48547 L
s
.48618 .48547 m
.45906 .49005 L
s
.36801 .59322 m
.37052 .61413 L
s
.37052 .61413 m
.36624 .63758 L
s
.63376 .63758 m
.62948 .61413 L
s
.63199 .59322 m
.62948 .61413 L
s
.62204 .57104 m
.6071 .55122 L
s
.60918 .52908 m
.6071 .55122 L
s
.39082 .52908 m
.3929 .55122 L
s
.3929 .55122 m
.37796 .57104 L
s
.56653 .49905 m
.54094 .49005 L
s
.54174 .4667 m
.54094 .49005 L
s
.45826 .4667 m
.45906 .49005 L
s
.45906 .49005 m
.43347 .49905 L
s
.6297 .68118 m
.62236 .7043 L
s
.63223 .66153 m
.6297 .68118 L
s
.36777 .66153 m
.3703 .68118 L
s
.37764 .7043 m
.3703 .68118 L
s
.58959 .51221 m
.56653 .49905 L
s
.56783 .47578 m
.56653 .49905 L
s
.43217 .47578 m
.43347 .49905 L
s
.43347 .49905 m
.41041 .51221 L
s
.63199 .59322 m
.62204 .57104 L
s
.62443 .54908 m
.62204 .57104 L
s
.37557 .54908 m
.37796 .57104 L
s
.37796 .57104 m
.36801 .59322 L
s
.63376 .63758 m
.63639 .6169 L
s
.63223 .66153 m
.63376 .63758 L
s
.36361 .6169 m
.36624 .63758 L
s
.36624 .63758 m
.36777 .66153 L
s
.60918 .52908 m
.58959 .51221 L
s
.59135 .48905 m
.58959 .51221 L
s
.40865 .48905 m
.41041 .51221 L
s
.41041 .51221 m
.39082 .52908 L
s
.62236 .7043 m
.60936 .72577 L
s
.62476 .68491 m
.62236 .7043 L
s
.37524 .68491 m
.37764 .7043 L
s
.39064 .72577 m
.37764 .7043 L
s
.54174 .4667 m
.51409 .46208 L
s
.51437 .43777 m
.51409 .46208 L
s
.51409 .46208 m
.48591 .46208 L
s
.48563 .43777 m
.48591 .46208 L
s
.48591 .46208 m
.45826 .4667 L
s
.36539 .57147 m
.36801 .59322 L
s
.36801 .59322 m
.36361 .6169 L
s
.63639 .6169 m
.63199 .59322 L
s
.63461 .57147 m
.63199 .59322 L
s
.62443 .54908 m
.60918 .52908 L
s
.61134 .50606 m
.60918 .52908 L
s
.38866 .50606 m
.39082 .52908 L
s
.39082 .52908 m
.37557 .54908 L
s
.56783 .47578 m
.54174 .4667 L
s
.54257 .44242 m
.54174 .4667 L
s
.45743 .44242 m
.45826 .4667 L
s
.45826 .4667 m
.43217 .47578 L
s
.60936 .72577 m
.59117 .74451 L
s
.61153 .70662 m
.60936 .72577 L
s
.38847 .70662 m
.39064 .72577 L
s
.40883 .74451 m
.39064 .72577 L
s
.36515 .6411 m
.36777 .66153 L
s
.36777 .66153 m
.37524 .68491 L
s
.62476 .68491 m
.63223 .66153 L
s
.63485 .6411 m
.63223 .66153 L
s
.59135 .48905 m
.56783 .47578 L
s
.43217 .47578 m
.40865 .48905 L
s
.63461 .57147 m
.62443 .54908 L
s
.37557 .54908 m
.36539 .57147 L
s
.407 .72558 m
.40883 .74451 L
s
.43144 .75955 m
.40883 .74451 L
s
.59117 .74451 m
.56856 .75955 L
s
.593 .72558 m
.59117 .74451 L
s
.63639 .6169 m
.63912 .5954 L
s
.63485 .6411 m
.63639 .6169 L
s
.36088 .5954 m
.36361 .6169 L
s
.36361 .6169 m
.36515 .6411 L
s
.61134 .50606 m
.59135 .48905 L
s
.40865 .48905 m
.38866 .50606 L
s
.61153 .70662 m
.62476 .68491 L
s
.62726 .66473 m
.62476 .68491 L
s
.37274 .66473 m
.37524 .68491 L
s
.37524 .68491 m
.38847 .70662 L
s
.43006 .74079 m
.43144 .75955 L
s
.45744 .77007 m
.43144 .75955 L
s
.56856 .75955 m
.54256 .77007 L
s
.56994 .74079 m
.56856 .75955 L
s
.54257 .44242 m
.51437 .43777 L
s
.51437 .43777 m
.48563 .43777 L
s
.48563 .43777 m
.45743 .44242 L
s
.36539 .57147 m
.36088 .5954 L
s
.63912 .5954 m
.63461 .57147 L
s
.45658 .75144 m
.45744 .77007 L
s
.48557 .77548 m
.45744 .77007 L
s
.54256 .77007 m
.51443 .77548 L
s
.54342 .75144 m
.54256 .77007 L
s
.56918 .45158 m
.54257 .44242 L
s
.45743 .44242 m
.43082 .45158 L
s
.593 .72558 m
.61153 .70662 L
s
.61379 .68669 m
.61153 .70662 L
s
.38621 .68669 m
.38847 .70662 L
s
.38847 .70662 m
.407 .72558 L
s
.62726 .66473 m
.63485 .6411 L
s
.63758 .61984 m
.63485 .6411 L
s
.36242 .61984 m
.36515 .6411 L
s
.36515 .6411 m
.37274 .66473 L
s
1 .334 .136 r
.40067 .47162 m .40138 .48028 L .38726 .50212 L p F P
0 0 0 r
s
1 .334 .136 r
.38726 .50212 m .38634 .49239 L .40067 .47162 L p F P
0 0 0 r
s
1 .33 .134 r
.38634 .49239 m .38726 .50212 L .37567 .52392 L p F P
0 0 0 r
s
.251 .356 .697 r
.62433 .52392 m .60657 .52392 L .59663 .50212 L p F P
0 0 0 r
s
.251 .356 .697 r
.59663 .50212 m .61274 .50212 L .62433 .52392 L p F P
0 0 0 r
s
.251 .356 .697 r
.60657 .52392 m .5888 .52392 L .58053 .50212 L p F P
0 0 0 r
s
.251 .356 .697 r
.58053 .50212 m .59663 .50212 L .60657 .52392 L p F P
0 0 0 r
s
.251 .356 .697 r
.5888 .52392 m .57104 .52392 L .56442 .50212 L p F P
0 0 0 r
s
.251 .356 .697 r
.56442 .50212 m .58053 .50212 L .5888 .52392 L p F P
0 0 0 r
s
.251 .356 .697 r
.57104 .52392 m .55328 .52392 L .54832 .50212 L p F P
0 0 0 r
s
.251 .356 .697 r
.54832 .50212 m .56442 .50212 L .57104 .52392 L p F P
0 0 0 r
s
.251 .356 .697 r
.55328 .52392 m .53552 .52392 L .53221 .50212 L p F P
0 0 0 r
s
.251 .356 .697 r
.53221 .50212 m .54832 .50212 L .55328 .52392 L p F P
0 0 0 r
s
.251 .356 .697 r
.53552 .52392 m .51776 .52392 L .51611 .50212 L p F P
0 0 0 r
s
.251 .356 .697 r
.51611 .50212 m .53221 .50212 L .53552 .52392 L p F P
0 0 0 r
s
.251 .356 .697 r
.51776 .52392 m .5 .52392 L .5 .50212 L p F P
0 0 0 r
s
.251 .356 .697 r
.5 .50212 m .51611 .50212 L .51776 .52392 L p F P
0 0 0 r
s
.251 .356 .697 r
.5 .52392 m .48224 .52392 L .48389 .50212 L p F P
0 0 0 r
s
.251 .356 .697 r
.48389 .50212 m .5 .50212 L .5 .52392 L p F P
0 0 0 r
s
.251 .356 .697 r
.48224 .52392 m .46448 .52392 L .46779 .50212 L p F P
0 0 0 r
s
.251 .356 .697 r
.46779 .50212 m .48389 .50212 L .48224 .52392 L p F P
0 0 0 r
s
.251 .356 .697 r
.46448 .52392 m .44672 .52392 L .45168 .50212 L p F P
0 0 0 r
s
.251 .356 .697 r
.45168 .50212 m .46779 .50212 L .46448 .52392 L p F P
0 0 0 r
s
.251 .356 .697 r
.44672 .52392 m .42896 .52392 L .43558 .50212 L p F P
0 0 0 r
s
.251 .356 .697 r
.43558 .50212 m .45168 .50212 L .44672 .52392 L p F P
0 0 0 r
s
.251 .356 .697 r
.42896 .52392 m .4112 .52392 L .41947 .50212 L p F P
0 0 0 r
s
.251 .356 .697 r
.41947 .50212 m .43558 .50212 L .42896 .52392 L p F P
0 0 0 r
s
.251 .356 .697 r
.4112 .52392 m .39343 .52392 L .40337 .50212 L p F P
0 0 0 r
s
.251 .356 .697 r
.40337 .50212 m .41947 .50212 L .4112 .52392 L p F P
0 0 0 r
s
.251 .356 .697 r
.39343 .52392 m .37567 .52392 L .38726 .50212 L p F P
0 0 0 r
s
.83 .24 .1 r
.38845 .50633 m
.38866 .50606 L
s
.251 .356 .697 r
.38726 .50212 m .40337 .50212 L .39343 .52392 L p F P
0 0 0 r
s
.258 .369 .723 r
.61274 .50212 m .59663 .50212 L .58454 .48028 L p F P
0 0 0 r
s
.258 .369 .723 r
.58454 .48028 m .59862 .48028 L .61274 .50212 L p F P
0 0 0 r
s
.258 .369 .723 r
.59663 .50212 m .58053 .50212 L .57045 .48028 L p F P
0 0 0 r
s
.258 .369 .723 r
.57045 .48028 m .58454 .48028 L .59663 .50212 L p F P
0 0 0 r
s
.258 .369 .723 r
.58053 .50212 m .56442 .50212 L .55636 .48028 L p F P
0 0 0 r
s
.258 .369 .723 r
.55636 .48028 m .57045 .48028 L .58053 .50212 L p F P
0 0 0 r
s
.258 .369 .723 r
.56442 .50212 m .54832 .50212 L .54227 .48028 L p F P
0 0 0 r
s
.258 .369 .723 r
.54227 .48028 m .55636 .48028 L .56442 .50212 L p F P
0 0 0 r
s
.258 .369 .723 r
.54832 .50212 m .53221 .50212 L .52818 .48028 L p F P
0 0 0 r
s
.258 .369 .723 r
.52818 .48028 m .54227 .48028 L .54832 .50212 L p F P
0 0 0 r
s
.258 .369 .723 r
.53221 .50212 m .51611 .50212 L .51409 .48028 L p F P
0 0 0 r
s
.258 .369 .723 r
.51409 .48028 m .52818 .48028 L .53221 .50212 L p F P
0 0 0 r
s
.258 .369 .723 r
.51611 .50212 m .5 .50212 L .5 .48028 L p F P
0 0 0 r
s
.258 .369 .723 r
.5 .48028 m .51409 .48028 L .51611 .50212 L p F P
0 0 0 r
s
.258 .369 .723 r
.5 .50212 m .48389 .50212 L .48591 .48028 L p F P
0 0 0 r
s
.258 .369 .723 r
.48591 .48028 m .5 .48028 L .5 .50212 L p F P
0 0 0 r
s
.258 .369 .723 r
.48389 .50212 m .46779 .50212 L .47182 .48028 L p F P
0 0 0 r
s
.258 .369 .723 r
.47182 .48028 m .48591 .48028 L .48389 .50212 L p F P
0 0 0 r
s
.258 .369 .723 r
.46779 .50212 m .45168 .50212 L .45773 .48028 L p F P
0 0 0 r
s
.258 .369 .723 r
.45773 .48028 m .47182 .48028 L .46779 .50212 L p F P
0 0 0 r
s
.258 .369 .723 r
.45168 .50212 m .43558 .50212 L .44364 .48028 L p F P
0 0 0 r
s
.258 .369 .723 r
.44364 .48028 m .45773 .48028 L .45168 .50212 L p F P
0 0 0 r
s
.258 .369 .723 r
.43558 .50212 m .41947 .50212 L .42955 .48028 L p F P
0 0 0 r
s
.258 .369 .723 r
.42955 .48028 m .44364 .48028 L .43558 .50212 L p F P
0 0 0 r
s
.258 .369 .723 r
.41947 .50212 m .40337 .50212 L .41546 .48028 L p F P
0 0 0 r
s
.258 .369 .723 r
.41546 .48028 m .42955 .48028 L .41947 .50212 L p F P
0 0 0 r
s
.258 .369 .723 r
.40337 .50212 m .38726 .50212 L .40138 .48028 L p F P
0 0 0 r
s
.258 .369 .723 r
.40138 .48028 m .41546 .48028 L .40337 .50212 L p F P
0 0 0 r
s
.465 .141 .068 r
.61366 .49239 m .61274 .50212 L .62433 .52392 L p F P
0 0 0 r
s
.597 .179 .083 r
.61274 .50212 m .61366 .49239 L .59933 .47162 L p F P
0 0 0 r
s
.597 .179 .083 r
.59933 .47162 m .59862 .48028 L .61274 .50212 L p F P
0 0 0 r
s
.83 .24 .1 r
.48528 .75692 m
.48557 .77548 L
s
.51443 .77548 m
.48557 .77548 L
s
.51472 .75692 m
.51443 .77548 L
s
1 .332 .137 r
.41728 .45146 m .41777 .45879 L .40138 .48028 L p F P
0 0 0 r
s
1 .332 .137 r
.40138 .48028 m .40067 .47162 L .41728 .45146 L p F P
0 0 0 r
s
.702 .21 .094 r
.59862 .48028 m .59933 .47162 L .58272 .45146 L p F P
0 0 0 r
s
.702 .21 .094 r
.58272 .45146 m .58223 .45879 L .59862 .48028 L p F P
0 0 0 r
s
.265 .381 .747 r
.59862 .48028 m .58454 .48028 L .57048 .45879 L p F P
0 0 0 r
s
.265 .381 .747 r
.57048 .45879 m .58223 .45879 L .59862 .48028 L p F P
0 0 0 r
s
.265 .381 .747 r
.58454 .48028 m .57045 .48028 L .55874 .45879 L p F P
0 0 0 r
s
.83 .24 .1 r
.56783 .47578 m
.56784 .4755 L
s
.265 .381 .747 r
.55874 .45879 m .57048 .45879 L .58454 .48028 L p F P
0 0 0 r
s
.265 .381 .747 r
.57045 .48028 m .55636 .48028 L .54699 .45879 L p F P
0 0 0 r
s
.265 .381 .747 r
.54699 .45879 m .55874 .45879 L .57045 .48028 L p F P
0 0 0 r
s
.83 .24 .1 r
.56878 .45879 m
.56918 .45158 L
s
.265 .381 .747 r
.55636 .48028 m .54227 .48028 L .53524 .45879 L p F P
0 0 0 r
s
.265 .381 .747 r
.53524 .45879 m .54699 .45879 L .55636 .48028 L p F P
0 0 0 r
s
.265 .381 .747 r
.54227 .48028 m .52818 .48028 L .52349 .45879 L p F P
0 0 0 r
s
.265 .381 .747 r
.52349 .45879 m .53524 .45879 L .54227 .48028 L p F P
0 0 0 r
s
.265 .381 .747 r
.52818 .48028 m .51409 .48028 L .51175 .45879 L p F P
0 0 0 r
s
.265 .381 .747 r
.51175 .45879 m .52349 .45879 L .52818 .48028 L p F P
0 0 0 r
s
.265 .381 .747 r
.51409 .48028 m .5 .48028 L .5 .45879 L p F P
0 0 0 r
s
.265 .381 .747 r
.5 .45879 m .51175 .45879 L .51409 .48028 L p F P
0 0 0 r
s
.265 .381 .747 r
.5 .48028 m .48591 .48028 L .48825 .45879 L p F P
0 0 0 r
s
.265 .381 .747 r
.48825 .45879 m .5 .45879 L .5 .48028 L p F P
0 0 0 r
s
.265 .381 .747 r
.48591 .48028 m .47182 .48028 L .47651 .45879 L p F P
0 0 0 r
s
.265 .381 .747 r
.47651 .45879 m .48825 .45879 L .48591 .48028 L p F P
0 0 0 r
s
.265 .381 .747 r
.47182 .48028 m .45773 .48028 L .46476 .45879 L p F P
0 0 0 r
s
.265 .381 .747 r
.46476 .45879 m .47651 .45879 L .47182 .48028 L p F P
0 0 0 r
s
.265 .381 .747 r
.45773 .48028 m .44364 .48028 L .45301 .45879 L p F P
0 0 0 r
s
.265 .381 .747 r
.45301 .45879 m .46476 .45879 L .45773 .48028 L p F P
0 0 0 r
s
.265 .381 .747 r
.44364 .48028 m .42955 .48028 L .44126 .45879 L p F P
0 0 0 r
s
.265 .381 .747 r
.44126 .45879 m .45301 .45879 L .44364 .48028 L p F P
0 0 0 r
s
.265 .381 .747 r
.42955 .48028 m .41546 .48028 L .42952 .45879 L p F P
0 0 0 r
s
.265 .381 .747 r
.42952 .45879 m .44126 .45879 L .42955 .48028 L p F P
0 0 0 r
s
.83 .24 .1 r
.43082 .45158 m
.43122 .45879 L
s
.265 .381 .747 r
.41546 .48028 m .40138 .48028 L .41777 .45879 L p F P
0 0 0 r
s
.265 .381 .747 r
.41777 .45879 m .42952 .45879 L .41546 .48028 L p F P
0 0 0 r
s
.24 .35 .67 r
.73723 .53082 m
.73671 .5021 L
s
.77616 .5021 m
.77677 .53082 L
s
.73671 .5021 m
.77616 .5021 L
s
.69769 .53082 m
.69726 .5021 L
s
.69726 .5021 m
.73671 .5021 L
s
.65815 .53082 m
.65781 .5021 L
s
.65781 .5021 m
.69726 .5021 L
s
.61836 .5021 m
.61839 .50638 L
s
.61836 .5021 m
.65781 .5021 L
s
.5789 .5021 m
.61334 .5021 L
s
.61695 .5021 m
.61836 .5021 L
s
.53945 .5021 m
.5789 .5021 L
s
.5 .5021 m
.53945 .5021 L
s
.46055 .5021 m
.5 .5021 L
s
.4211 .5021 m
.46055 .5021 L
s
.38161 .50638 m
.38164 .5021 L
s
.38666 .5021 m
.4211 .5021 L
s
.38164 .5021 m
.38305 .5021 L
s
.34185 .53082 m
.34219 .5021 L
s
.34219 .5021 m
.38164 .5021 L
s
.30231 .53082 m
.30274 .5021 L
s
.30274 .5021 m
.34219 .5021 L
s
.26277 .53082 m
.26329 .5021 L
s
.26329 .5021 m
.30274 .5021 L
s
.22323 .53082 m
.22384 .5021 L
s
.22384 .5021 m
.26329 .5021 L
s
.73671 .5021 m
.7371 .4733 L
s
.77661 .4733 m
.77616 .5021 L
s
.69726 .5021 m
.69758 .4733 L
s
.65781 .5021 m
.65807 .4733 L
s
.5789 .5021 m
.57903 .4733 L
s
.53945 .5021 m
.53952 .4733 L
s
.5 .4733 m
.5 .5021 L
s
.46048 .4733 m
.46055 .5021 L
s
.42097 .4733 m
.4211 .5021 L
s
.34219 .5021 m
.34193 .4733 L
s
.30274 .5021 m
.30242 .4733 L
s
.26329 .5021 m
.2629 .4733 L
s
.22384 .5021 m
.22339 .4733 L
s
1 .33 .134 r
.37567 .52392 m .37455 .51338 L .38634 .49239 L p F P
0 0 0 r
s
.24 .35 .67 r
.38145 .4733 m
.38163 .50077 L
s
1 .318 .127 r
.37455 .51338 m .37567 .52392 L .36684 .54528 L p F P
0 0 0 r
s
.242 .342 .668 r
.63316 .54528 m .61414 .54528 L .60657 .52392 L p F P
0 0 0 r
s
.83 .24 .1 r
.62443 .54908 m
.62484 .54528 L
s
.242 .342 .668 r
.60657 .52392 m .62433 .52392 L .63316 .54528 L p F P
0 0 0 r
s
.242 .342 .668 r
.61414 .54528 m .59511 .54528 L .5888 .52392 L p F P
0 0 0 r
s
.242 .342 .668 r
.5888 .52392 m .60657 .52392 L .61414 .54528 L p F P
0 0 0 r
s
.242 .342 .668 r
.59511 .54528 m .57609 .54528 L .57104 .52392 L p F P
0 0 0 r
s
.242 .342 .668 r
.57104 .52392 m .5888 .52392 L .59511 .54528 L p F P
0 0 0 r
s
.24 .35 .67 r
.5789 .5021 m
.57908 .53082 L
s
.242 .342 .668 r
.57609 .54528 m .55707 .54528 L .55328 .52392 L p F P
0 0 0 r
s
.242 .342 .668 r
.55328 .52392 m .57104 .52392 L .57609 .54528 L p F P
0 0 0 r
s
.242 .342 .668 r
.55707 .54528 m .53805 .54528 L .53552 .52392 L p F P
0 0 0 r
s
.242 .342 .668 r
.53552 .52392 m .55328 .52392 L .55707 .54528 L p F P
0 0 0 r
s
.24 .35 .67 r
.53945 .5021 m
.53954 .53082 L
s
.242 .342 .668 r
.53805 .54528 m .51902 .54528 L .51776 .52392 L p F P
0 0 0 r
s
.242 .342 .668 r
.51776 .52392 m .53552 .52392 L .53805 .54528 L p F P
0 0 0 r
s
.242 .342 .668 r
.51902 .54528 m .5 .54528 L .5 .52392 L p F P
0 0 0 r
s
.242 .342 .668 r
.5 .52392 m .51776 .52392 L .51902 .54528 L p F P
0 0 0 r
s
.242 .342 .668 r
.5 .54528 m .48098 .54528 L .48224 .52392 L p F P
0 0 0 r
s
.242 .342 .668 r
.48224 .52392 m .5 .52392 L .5 .54528 L p F P
0 0 0 r
s
.24 .35 .67 r
.5 .5021 m
.5 .53082 L
s
.242 .342 .668 r
.48098 .54528 m .46195 .54528 L .46448 .52392 L p F P
0 0 0 r
s
.242 .342 .668 r
.46448 .52392 m .48224 .52392 L .48098 .54528 L p F P
0 0 0 r
s
.242 .342 .668 r
.46195 .54528 m .44293 .54528 L .44672 .52392 L p F P
0 0 0 r
s
.242 .342 .668 r
.44672 .52392 m .46448 .52392 L .46195 .54528 L p F P
0 0 0 r
s
.24 .35 .67 r
.46046 .53082 m
.46055 .5021 L
s
.242 .342 .668 r
.44293 .54528 m .42391 .54528 L .42896 .52392 L p F P
0 0 0 r
s
.242 .342 .668 r
.42896 .52392 m .44672 .52392 L .44293 .54528 L p F P
0 0 0 r
s
.242 .342 .668 r
.42391 .54528 m .40489 .54528 L .4112 .52392 L p F P
0 0 0 r
s
.242 .342 .668 r
.4112 .52392 m .42896 .52392 L .42391 .54528 L p F P
0 0 0 r
s
.24 .35 .67 r
.42092 .53082 m
.4211 .5021 L
s
.242 .342 .668 r
.40489 .54528 m .38586 .54528 L .39343 .52392 L p F P
0 0 0 r
s
.242 .342 .668 r
.39343 .52392 m .4112 .52392 L .40489 .54528 L p F P
0 0 0 r
s
.242 .342 .668 r
.38586 .54528 m .36684 .54528 L .37567 .52392 L p F P
0 0 0 r
s
.83 .24 .1 r
.37516 .54528 m
.37557 .54908 L
s
.242 .342 .668 r
.37567 .52392 m .39343 .52392 L .38586 .54528 L p F P
0 0 0 r
s
.24 .35 .67 r
.38139 .53082 m
.38156 .51149 L
s
.332 .1 .051 r
.62545 .51338 m .62433 .52392 L .63316 .54528 L p F P
0 0 0 r
s
.465 .141 .068 r
.62433 .52392 m .62545 .51338 L .61366 .49239 L p F P
0 0 0 r
s
.24 .35 .67 r
.61844 .51149 m
.61861 .53082 L
s
.61837 .50077 m
.61855 .4733 L
s
.7371 .4733 m
.77661 .4733 L
s
.69758 .4733 m
.7371 .4733 L
s
.65807 .4733 m
.69758 .4733 L
s
.61855 .4733 m
.65807 .4733 L
s
.57903 .4733 m
.59411 .4733 L
s
.60049 .4733 m
.61855 .4733 L
s
.53952 .4733 m
.57903 .4733 L
s
.5 .4733 m
.53952 .4733 L
s
.46048 .4733 m
.5 .4733 L
s
.42097 .4733 m
.46048 .4733 L
s
.40589 .4733 m
.42097 .4733 L
s
.38145 .4733 m
.39951 .4733 L
s
.34193 .4733 m
.38145 .4733 L
s
.30242 .4733 m
.34193 .4733 L
s
.2629 .4733 m
.30242 .4733 L
s
.22339 .4733 m
.2629 .4733 L
s
.7371 .4733 m
.73838 .44538 L
s
.77811 .44538 m
.77661 .4733 L
s
.69758 .4733 m
.69865 .44538 L
s
.65807 .4733 m
.65892 .44538 L
s
.61855 .4733 m
.61919 .44538 L
s
.38145 .4733 m
.38081 .44538 L
s
.34193 .4733 m
.34108 .44538 L
s
.30242 .4733 m
.30135 .44538 L
s
.2629 .4733 m
.26162 .44538 L
s
.22339 .4733 m
.22189 .44538 L
s
.73863 .55854 m
.73723 .53082 L
s
.77677 .53082 m
.77841 .55854 L
s
.73723 .53082 m
.77677 .53082 L
s
.69886 .55854 m
.69769 .53082 L
s
.69769 .53082 m
.73723 .53082 L
s
.65909 .55854 m
.65815 .53082 L
s
.65815 .53082 m
.69769 .53082 L
s
.61861 .53082 m
.62752 .53082 L
s
.62967 .53082 m
.65815 .53082 L
s
.57908 .53082 m
.61861 .53082 L
s
.53954 .53082 m
.57908 .53082 L
s
.5 .53082 m
.53954 .53082 L
s
.46046 .53082 m
.5 .53082 L
s
.42092 .53082 m
.46046 .53082 L
s
.38139 .53082 m
.42092 .53082 L
s
.34091 .55854 m
.34185 .53082 L
s
.37248 .53082 m
.38139 .53082 L
s
.34185 .53082 m
.37033 .53082 L
s
.30114 .55854 m
.30231 .53082 L
s
.30231 .53082 m
.34185 .53082 L
s
.26137 .55854 m
.26277 .53082 L
s
.26277 .53082 m
.30231 .53082 L
s
.22159 .55854 m
.22323 .53082 L
s
.22323 .53082 m
.26277 .53082 L
s
1 .327 .136 r
.43587 .43229 m .43616 .43807 L .41777 .45879 L p F P
0 0 0 r
s
1 .327 .136 r
.41777 .45879 m .41728 .45146 L .43587 .43229 L p F P
0 0 0 r
s
.271 .393 .77 r
.58223 .45879 m .57048 .45879 L .55472 .43807 L p F P
0 0 0 r
s
.271 .393 .77 r
.55472 .43807 m .56384 .43807 L .58223 .45879 L p F P
0 0 0 r
s
.271 .393 .77 r
.57048 .45879 m .55874 .45879 L .5456 .43807 L p F P
0 0 0 r
s
.271 .393 .77 r
.5456 .43807 m .55472 .43807 L .57048 .45879 L p F P
0 0 0 r
s
.271 .393 .77 r
.55874 .45879 m .54699 .45879 L .53648 .43807 L p F P
0 0 0 r
s
.271 .393 .77 r
.53648 .43807 m .5456 .43807 L .55874 .45879 L p F P
0 0 0 r
s
.271 .393 .77 r
.54699 .45879 m .53524 .45879 L .52736 .43807 L p F P
0 0 0 r
s
.271 .393 .77 r
.52736 .43807 m .53648 .43807 L .54699 .45879 L p F P
0 0 0 r
s
.24 .35 .67 r
.53952 .4733 m
.53973 .44538 L
s
.271 .393 .77 r
.53524 .45879 m .52349 .45879 L .51824 .43807 L p F P
0 0 0 r
s
.271 .393 .77 r
.51824 .43807 m .52736 .43807 L .53524 .45879 L p F P
0 0 0 r
s
.271 .393 .77 r
.52349 .45879 m .51175 .45879 L .50912 .43807 L p F P
0 0 0 r
s
.271 .393 .77 r
.50912 .43807 m .51824 .43807 L .52349 .45879 L p F P
0 0 0 r
s
.271 .393 .77 r
.51175 .45879 m .5 .45879 L .5 .43807 L p F P
0 0 0 r
s
.271 .393 .77 r
.5 .43807 m .50912 .43807 L .51175 .45879 L p F P
0 0 0 r
s
.271 .393 .77 r
.5 .45879 m .48825 .45879 L .49088 .43807 L p F P
0 0 0 r
s
.271 .393 .77 r
.49088 .43807 m .5 .43807 L .5 .45879 L p F P
0 0 0 r
s
.24 .35 .67 r
.5 .44538 m
.5 .4733 L
s
.271 .393 .77 r
.48825 .45879 m .47651 .45879 L .48176 .43807 L p F P
0 0 0 r
s
.271 .393 .77 r
.48176 .43807 m .49088 .43807 L .48825 .45879 L p F P
0 0 0 r
s
.271 .393 .77 r
.47651 .45879 m .46476 .45879 L .47264 .43807 L p F P
0 0 0 r
s
.271 .393 .77 r
.47264 .43807 m .48176 .43807 L .47651 .45879 L p F P
0 0 0 r
s
.271 .393 .77 r
.46476 .45879 m .45301 .45879 L .46352 .43807 L p F P
0 0 0 r
s
.271 .393 .77 r
.46352 .43807 m .47264 .43807 L .46476 .45879 L p F P
0 0 0 r
s
.271 .393 .77 r
.45301 .45879 m .44126 .45879 L .4544 .43807 L p F P
0 0 0 r
s
.271 .393 .77 r
.4544 .43807 m .46352 .43807 L .45301 .45879 L p F P
0 0 0 r
s
.24 .35 .67 r
.46027 .44538 m
.46048 .4733 L
s
.271 .393 .77 r
.44126 .45879 m .42952 .45879 L .44528 .43807 L p F P
0 0 0 r
s
.271 .393 .77 r
.44528 .43807 m .4544 .43807 L .44126 .45879 L p F P
0 0 0 r
s
.271 .393 .77 r
.42952 .45879 m .41777 .45879 L .43616 .43807 L p F P
0 0 0 r
s
.24 .35 .67 r
.42066 .4534 m
.42097 .4733 L
s
.42054 .44538 m
.42058 .44805 L
s
.271 .393 .77 r
.43616 .43807 m .44528 .43807 L .42952 .45879 L p F P
0 0 0 r
s
.789 .235 .104 r
.58223 .45879 m .58272 .45146 L .56413 .43229 L p F P
0 0 0 r
s
.789 .235 .104 r
.56413 .43229 m .56384 .43807 L .58223 .45879 L p F P
0 0 0 r
s
.24 .35 .67 r
.57942 .44805 m
.57946 .44538 L
s
.57903 .4733 m
.57934 .4534 L
s
1 .318 .127 r
.36684 .54528 m .36555 .5342 L .37455 .51338 L p F P
0 0 0 r
s
.83 .24 .1 r
.37308 .52624 m
.38359 .51263 L
s
.37308 .52624 m
.37365 .53146 L
s
1 .295 .116 r
.36555 .5342 m .36684 .54528 L .36095 .56581 L p F P
0 0 0 r
s
.232 .325 .636 r
.63905 .56581 m .61919 .56581 L .61414 .54528 L p F P
0 0 0 r
s
.83 .24 .1 r
.63461 .57147 m
.63529 .56581 L
s
.232 .325 .636 r
.61414 .54528 m .63316 .54528 L .63905 .56581 L p F P
0 0 0 r
s
.232 .325 .636 r
.61919 .56581 m .59932 .56581 L .59511 .54528 L p F P
0 0 0 r
s
.232 .325 .636 r
.59511 .54528 m .61414 .54528 L .61919 .56581 L p F P
0 0 0 r
s
.24 .35 .67 r
.61861 .53082 m
.61932 .55854 L
s
.232 .325 .636 r
.59932 .56581 m .57946 .56581 L .57609 .54528 L p F P
0 0 0 r
s
.232 .325 .636 r
.57609 .54528 m .59511 .54528 L .59932 .56581 L p F P
0 0 0 r
s
.232 .325 .636 r
.57946 .56581 m .55959 .56581 L .55707 .54528 L p F P
0 0 0 r
s
.232 .325 .636 r
.55707 .54528 m .57609 .54528 L .57946 .56581 L p F P
0 0 0 r
s
.24 .35 .67 r
.57908 .53082 m
.57954 .55854 L
s
.232 .325 .636 r
.55959 .56581 m .53973 .56581 L .53805 .54528 L p F P
0 0 0 r
s
.232 .325 .636 r
.53805 .54528 m .55707 .54528 L .55959 .56581 L p F P
0 0 0 r
s
.232 .325 .636 r
.53973 .56581 m .51986 .56581 L .51902 .54528 L p F P
0 0 0 r
s
.232 .325 .636 r
.51902 .54528 m .53805 .54528 L .53973 .56581 L p F P
0 0 0 r
s
.24 .35 .67 r
.53954 .53082 m
.53977 .55854 L
s
.232 .325 .636 r
.51986 .56581 m .5 .56581 L .5 .54528 L p F P
0 0 0 r
s
.232 .325 .636 r
.5 .54528 m .51902 .54528 L .51986 .56581 L p F P
0 0 0 r
s
.232 .325 .636 r
.5 .56581 m .48014 .56581 L .48098 .54528 L p F P
0 0 0 r
s
.232 .325 .636 r
.48098 .54528 m .5 .54528 L .5 .56581 L p F P
0 0 0 r
s
.24 .35 .67 r
.5 .53082 m
.5 .55854 L
s
.232 .325 .636 r
.48014 .56581 m .46027 .56581 L .46195 .54528 L p F P
0 0 0 r
s
.232 .325 .636 r
.46195 .54528 m .48098 .54528 L .48014 .56581 L p F P
0 0 0 r
s
.232 .325 .636 r
.46027 .56581 m .44041 .56581 L .44293 .54528 L p F P
0 0 0 r
s
.232 .325 .636 r
.44293 .54528 m .46195 .54528 L .46027 .56581 L p F P
0 0 0 r
s
.24 .35 .67 r
.46023 .55854 m
.46046 .53082 L
s
.232 .325 .636 r
.44041 .56581 m .42054 .56581 L .42391 .54528 L p F P
0 0 0 r
s
.232 .325 .636 r
.42391 .54528 m .44293 .54528 L .44041 .56581 L p F P
0 0 0 r
s
.232 .325 .636 r
.42054 .56581 m .40068 .56581 L .40489 .54528 L p F P
0 0 0 r
s
.232 .325 .636 r
.40489 .54528 m .42391 .54528 L .42054 .56581 L p F P
0 0 0 r
s
.24 .35 .67 r
.42046 .55854 m
.42092 .53082 L
s
.232 .325 .636 r
.40068 .56581 m .38081 .56581 L .38586 .54528 L p F P
0 0 0 r
s
.232 .325 .636 r
.38586 .54528 m .40489 .54528 L .40068 .56581 L p F P
0 0 0 r
s
.232 .325 .636 r
.38081 .56581 m .36095 .56581 L .36684 .54528 L p F P
0 0 0 r
s
.83 .24 .1 r
.36471 .56581 m
.36539 .57147 L
s
.232 .325 .636 r
.36684 .54528 m .38586 .54528 L .38081 .56581 L p F P
0 0 0 r
s
.24 .35 .67 r
.38068 .55854 m
.38139 .53082 L
s
.249 .072 .039 r
.63445 .5342 m .63316 .54528 L .63905 .56581 L p F P
0 0 0 r
s
.332 .1 .051 r
.63316 .54528 m .63445 .5342 L .62545 .51338 L p F P
0 0 0 r
s
.83 .24 .1 r
.61641 .51263 m
.62692 .52624 L
s
.62635 .53146 m
.62692 .52624 L
s
.40511 .70587 m
.407 .72558 L
s
.407 .72558 m
.43006 .74079 L
s
.56994 .74079 m
.593 .72558 L
s
.59489 .70587 m
.593 .72558 L
s
.24 .35 .67 r
.73838 .44538 m
.77811 .44538 L
s
.69865 .44538 m
.73838 .44538 L
s
.65892 .44538 m
.69865 .44538 L
s
.61919 .44538 m
.65892 .44538 L
s
.57946 .44538 m
.61919 .44538 L
s
.53973 .44538 m
.57148 .44538 L
s
.57682 .44538 m
.57946 .44538 L
s
.5 .44538 m
.53973 .44538 L
s
.46027 .44538 m
.5 .44538 L
s
.42852 .44538 m
.46027 .44538 L
s
.42054 .44538 m
.42318 .44538 L
s
.38081 .44538 m
.42054 .44538 L
s
.34108 .44538 m
.38081 .44538 L
s
.30135 .44538 m
.34108 .44538 L
s
.26162 .44538 m
.30135 .44538 L
s
.22189 .44538 m
.26162 .44538 L
s
.73838 .44538 m
.74052 .41926 L
s
.78061 .41926 m
.77811 .44538 L
s
.69865 .44538 m
.70043 .41926 L
s
.65892 .44538 m
.66035 .41926 L
s
.61919 .44538 m
.62026 .41926 L
s
.38081 .44538 m
.37974 .41926 L
s
.34108 .44538 m
.33965 .41926 L
s
.30135 .44538 m
.29957 .41926 L
s
.26162 .44538 m
.25948 .41926 L
s
.22189 .44538 m
.21939 .41926 L
s
1 .332 .137 r
.41679 .44404 m .41728 .45146 L .40067 .47162 L p F P
0 0 0 r
s
1 .332 .137 r
.40067 .47162 m .39996 .46284 L .41679 .44404 L p F P
0 0 0 r
s
.83 .24 .1 r
.40682 .46496 m
.40753 .47426 L
s
.40682 .46496 m
.42398 .45539 L
s
1 .334 .136 r
.39996 .46284 m .40067 .47162 L .38634 .49239 L p F P
0 0 0 r
s
.597 .179 .083 r
.60004 .46284 m .59933 .47162 L .61366 .49239 L p F P
0 0 0 r
s
.702 .21 .094 r
.59933 .47162 m .60004 .46284 L .58321 .44404 L p F P
0 0 0 r
s
.702 .21 .094 r
.58321 .44404 m .58272 .45146 L .59933 .47162 L p F P
0 0 0 r
s
.83 .24 .1 r
.59247 .47426 m
.59318 .46496 L
s
.57602 .45539 m
.59318 .46496 L
s
1 .334 .136 r
.38634 .49239 m .3854 .4825 L .39996 .46284 L p F P
0 0 0 r
s
1 .33 .134 r
.3854 .4825 m .38634 .49239 L .37455 .51338 L p F P
0 0 0 r
s
.465 .141 .068 r
.6146 .4825 m .61366 .49239 L .62545 .51338 L p F P
0 0 0 r
s
.597 .179 .083 r
.61366 .49239 m .6146 .4825 L .60004 .46284 L p F P
0 0 0 r
s
.24 .35 .67 r
.7409 .58431 m
.73863 .55854 L
s
.77841 .55854 m
.78105 .58431 L
s
.73863 .55854 m
.77841 .55854 L
s
.70075 .58431 m
.69886 .55854 L
s
.69886 .55854 m
.73863 .55854 L
s
.6606 .58431 m
.65909 .55854 L
s
.65909 .55854 m
.69886 .55854 L
s
.61932 .55854 m
.63721 .55854 L
s
.63799 .55854 m
.65909 .55854 L
s
.57954 .55854 m
.61932 .55854 L
s
.53977 .55854 m
.57954 .55854 L
s
.5 .55854 m
.53977 .55854 L
s
.46023 .55854 m
.5 .55854 L
s
.42046 .55854 m
.46023 .55854 L
s
.38068 .55854 m
.42046 .55854 L
s
.3394 .58431 m
.34091 .55854 L
s
.36279 .55854 m
.38068 .55854 L
s
.34091 .55854 m
.36201 .55854 L
s
.29925 .58431 m
.30114 .55854 L
s
.30114 .55854 m
.34091 .55854 L
s
.2591 .58431 m
.26137 .55854 L
s
.26137 .55854 m
.30114 .55854 L
s
.21895 .58431 m
.22159 .55854 L
s
.22159 .55854 m
.26137 .55854 L
s
1 .32 .134 r
.4561 .41449 m .45624 .41851 L .43616 .43807 L p F P
0 0 0 r
s
1 .32 .134 r
.43616 .43807 m .43587 .43229 L .4561 .41449 L p F P
0 0 0 r
s
.277 .404 .792 r
.56384 .43807 m .55472 .43807 L .53751 .41851 L p F P
0 0 0 r
s
.277 .404 .792 r
.53751 .41851 m .54376 .41851 L .56384 .43807 L p F P
0 0 0 r
s
.277 .404 .792 r
.55472 .43807 m .5456 .43807 L .53126 .41851 L p F P
0 0 0 r
s
.83 .24 .1 r
.54271 .43807 m
.54284 .43431 L
s
.277 .404 .792 r
.53126 .41851 m .53751 .41851 L .55472 .43807 L p F P
0 0 0 r
s
.277 .404 .792 r
.5456 .43807 m .53648 .43807 L .52501 .41851 L p F P
0 0 0 r
s
.277 .404 .792 r
.52501 .41851 m .53126 .41851 L .5456 .43807 L p F P
0 0 0 r
s
.24 .35 .67 r
.53973 .44538 m
.54009 .41926 L
s
.277 .404 .792 r
.53648 .43807 m .52736 .43807 L .51876 .41851 L p F P
0 0 0 r
s
.277 .404 .792 r
.51876 .41851 m .52501 .41851 L .53648 .43807 L p F P
0 0 0 r
s
.277 .404 .792 r
.52736 .43807 m .51824 .43807 L .5125 .41851 L p F P
0 0 0 r
s
.83 .24 .1 r
.51437 .43777 m
.51451 .42535 L
s
.277 .404 .792 r
.5125 .41851 m .51876 .41851 L .52736 .43807 L p F P
0 0 0 r
s
.277 .404 .792 r
.51824 .43807 m .50912 .43807 L .50625 .41851 L p F P
0 0 0 r
s
.277 .404 .792 r
.50625 .41851 m .5125 .41851 L .51824 .43807 L p F P
0 0 0 r
s
.277 .404 .792 r
.50912 .43807 m .5 .43807 L .5 .41851 L p F P
0 0 0 r
s
.277 .404 .792 r
.5 .41851 m .50625 .41851 L .50912 .43807 L p F P
0 0 0 r
s
.277 .404 .792 r
.5 .43807 m .49088 .43807 L .49375 .41851 L p F P
0 0 0 r
s
.277 .404 .792 r
.49375 .41851 m .5 .41851 L .5 .43807 L p F P
0 0 0 r
s
.24 .35 .67 r
.5 .41926 m
.5 .44538 L
s
.277 .404 .792 r
.49088 .43807 m .48176 .43807 L .4875 .41851 L p F P
0 0 0 r
s
.277 .404 .792 r
.4875 .41851 m .49375 .41851 L .49088 .43807 L p F P
0 0 0 r
s
.277 .404 .792 r
.48176 .43807 m .47264 .43807 L .48124 .41851 L p F P
0 0 0 r
s
.277 .404 .792 r
.48124 .41851 m .4875 .41851 L .48176 .43807 L p F P
0 0 0 r
s
.277 .404 .792 r
.47264 .43807 m .46352 .43807 L .47499 .41851 L p F P
0 0 0 r
s
.277 .404 .792 r
.47499 .41851 m .48124 .41851 L .47264 .43807 L p F P
0 0 0 r
s
.277 .404 .792 r
.46352 .43807 m .4544 .43807 L .46874 .41851 L p F P
0 0 0 r
s
.277 .404 .792 r
.46874 .41851 m .47499 .41851 L .46352 .43807 L p F P
0 0 0 r
s
.277 .404 .792 r
.4544 .43807 m .44528 .43807 L .46249 .41851 L p F P
0 0 0 r
s
.83 .24 .1 r
.45707 .43163 m
.45716 .43431 L
s
.277 .404 .792 r
.46249 .41851 m .46874 .41851 L .4544 .43807 L p F P
0 0 0 r
s
.277 .404 .792 r
.44528 .43807 m .43616 .43807 L .45624 .41851 L p F P
0 0 0 r
s
.277 .404 .792 r
.45624 .41851 m .46249 .41851 L .44528 .43807 L p F P
0 0 0 r
s
.24 .35 .67 r
.45991 .41926 m
.46027 .44538 L
s
.86 .255 .111 r
.56384 .43807 m .56413 .43229 L .5439 .41449 L p F P
0 0 0 r
s
.86 .255 .111 r
.5439 .41449 m .54376 .41851 L .56384 .43807 L p F P
0 0 0 r
s
.83 .24 .1 r
.61379 .68669 m
.62726 .66473 L
s
.62987 .64374 m
.62726 .66473 L
s
.37013 .64374 m
.37274 .66473 L
s
.37274 .66473 m
.38621 .68669 L
s
1 .327 .136 r
.43557 .42645 m .43587 .43229 L .41728 .45146 L p F P
0 0 0 r
s
1 .327 .136 r
.41728 .45146 m .41679 .44404 L .43557 .42645 L p F P
0 0 0 r
s
.789 .235 .104 r
.58272 .45146 m .58321 .44404 L .56443 .42645 L p F P
0 0 0 r
s
.789 .235 .104 r
.56443 .42645 m .56413 .43229 L .58272 .45146 L p F P
0 0 0 r
s
1 .295 .116 r
.36095 .56581 m .35954 .55444 L .36555 .5342 L p F P
0 0 0 r
s
.899 .254 .097 r
.35954 .55444 m .36095 .56581 L .35816 .58511 L p F P
0 0 0 r
s
.221 .306 .597 r
.64184 .58511 m .62158 .58511 L .61919 .56581 L p F P
0 0 0 r
s
.221 .306 .597 r
.61919 .56581 m .63905 .56581 L .64184 .58511 L p F P
0 0 0 r
s
.221 .306 .597 r
.62158 .58511 m .60132 .58511 L .59932 .56581 L p F P
0 0 0 r
s
.221 .306 .597 r
.59932 .56581 m .61919 .56581 L .62158 .58511 L p F P
0 0 0 r
s
.24 .35 .67 r
.61932 .55854 m
.62045 .58431 L
s
.221 .306 .597 r
.60132 .58511 m .58105 .58511 L .57946 .56581 L p F P
0 0 0 r
s
.221 .306 .597 r
.57946 .56581 m .59932 .56581 L .60132 .58511 L p F P
0 0 0 r
s
.221 .306 .597 r
.58105 .58511 m .56079 .58511 L .55959 .56581 L p F P
0 0 0 r
s
.221 .306 .597 r
.55959 .56581 m .57946 .56581 L .58105 .58511 L p F P
0 0 0 r
s
.24 .35 .67 r
.57954 .55854 m
.5803 .58431 L
s
.221 .306 .597 r
.56079 .58511 m .54053 .58511 L .53973 .56581 L p F P
0 0 0 r
s
.221 .306 .597 r
.53973 .56581 m .55959 .56581 L .56079 .58511 L p F P
0 0 0 r
s
.221 .306 .597 r
.54053 .58511 m .52026 .58511 L .51986 .56581 L p F P
0 0 0 r
s
.221 .306 .597 r
.51986 .56581 m .53973 .56581 L .54053 .58511 L p F P
0 0 0 r
s
.24 .35 .67 r
.53977 .55854 m
.54015 .58431 L
s
.221 .306 .597 r
.52026 .58511 m .5 .58511 L .5 .56581 L p F P
0 0 0 r
s
.221 .306 .597 r
.5 .56581 m .51986 .56581 L .52026 .58511 L p F P
0 0 0 r
s
.221 .306 .597 r
.5 .58511 m .47974 .58511 L .48014 .56581 L p F P
0 0 0 r
s
.221 .306 .597 r
.48014 .56581 m .5 .56581 L .5 .58511 L p F P
0 0 0 r
s
.24 .35 .67 r
.5 .55854 m
.5 .58431 L
s
.221 .306 .597 r
.47974 .58511 m .45947 .58511 L .46027 .56581 L p F P
0 0 0 r
s
.221 .306 .597 r
.46027 .56581 m .48014 .56581 L .47974 .58511 L p F P
0 0 0 r
s
.221 .306 .597 r
.45947 .58511 m .43921 .58511 L .44041 .56581 L p F P
0 0 0 r
s
.221 .306 .597 r
.44041 .56581 m .46027 .56581 L .45947 .58511 L p F P
0 0 0 r
s
.24 .35 .67 r
.45985 .58431 m
.46023 .55854 L
s
.221 .306 .597 r
.43921 .58511 m .41895 .58511 L .42054 .56581 L p F P
0 0 0 r
s
.221 .306 .597 r
.42054 .56581 m .44041 .56581 L .43921 .58511 L p F P
0 0 0 r
s
.221 .306 .597 r
.41895 .58511 m .39868 .58511 L .40068 .56581 L p F P
0 0 0 r
s
.221 .306 .597 r
.40068 .56581 m .42054 .56581 L .41895 .58511 L p F P
0 0 0 r
s
.24 .35 .67 r
.4197 .58431 m
.42046 .55854 L
s
.221 .306 .597 r
.39868 .58511 m .37842 .58511 L .38081 .56581 L p F P
0 0 0 r
s
.221 .306 .597 r
.38081 .56581 m .40068 .56581 L .39868 .58511 L p F P
0 0 0 r
s
.221 .306 .597 r
.37842 .58511 m .35816 .58511 L .36095 .56581 L p F P
0 0 0 r
s
.221 .306 .597 r
.36095 .56581 m .38081 .56581 L .37842 .58511 L p F P
0 0 0 r
s
.24 .35 .67 r
.37955 .58431 m
.38068 .55854 L
s
.181 .052 .027 r
.64046 .55444 m .63905 .56581 L .64184 .58511 L p F P
0 0 0 r
s
.249 .072 .039 r
.63905 .56581 m .64046 .55444 L .63445 .5342 L p F P
0 0 0 r
s
1 .33 .134 r
.37455 .51338 m .37341 .50265 L .3854 .4825 L p F P
0 0 0 r
s
1 .318 .127 r
.37341 .50265 m .37455 .51338 L .36555 .5342 L p F P
0 0 0 r
s
.332 .1 .051 r
.62659 .50265 m .62545 .51338 L .63445 .5342 L p F P
0 0 0 r
s
.465 .141 .068 r
.62545 .51338 m .62659 .50265 L .6146 .4825 L p F P
0 0 0 r
s
1 .32 .134 r
.45596 .41044 m .4561 .41449 L .43587 .43229 L p F P
0 0 0 r
s
1 .32 .134 r
.43587 .43229 m .43557 .42645 L .45596 .41044 L p F P
0 0 0 r
s
.86 .255 .111 r
.56413 .43229 m .56443 .42645 L .54404 .41044 L p F P
0 0 0 r
s
.86 .255 .111 r
.54404 .41044 m .5439 .41449 L .56413 .43229 L p F P
0 0 0 r
s
.83 .24 .1 r
.42862 .72127 m
.43006 .74079 L
s
.43006 .74079 m
.45658 .75144 L
s
.54342 .75144 m
.56994 .74079 L
s
.57138 .72127 m
.56994 .74079 L
s
1 .318 .127 r
.36555 .5342 m .36424 .52289 L .37341 .50265 L p F P
0 0 0 r
s
1 .295 .116 r
.36424 .52289 m .36555 .5342 L .35954 .55444 L p F P
0 0 0 r
s
.83 .24 .1 r
.36267 .54885 m
.37308 .52624 L
s
.36267 .54885 m
.36391 .55914 L
s
.249 .072 .039 r
.63576 .52289 m .63445 .5342 L .64046 .55444 L p F P
0 0 0 r
s
.83 .24 .1 r
.63609 .55914 m
.63733 .54885 L
s
.332 .1 .051 r
.63445 .5342 m .63576 .52289 L .62659 .50265 L p F P
0 0 0 r
s
.83 .24 .1 r
.62692 .52624 m
.63733 .54885 L
s
1 .332 .137 r
.41628 .43652 m .41679 .44404 L .39996 .46284 L p F P
0 0 0 r
s
1 .332 .137 r
.39996 .46284 m .39923 .45393 L .41628 .43652 L p F P
0 0 0 r
s
1 .334 .136 r
.39923 .45393 m .39996 .46284 L .3854 .4825 L p F P
0 0 0 r
s
.597 .179 .083 r
.60077 .45393 m .60004 .46284 L .6146 .4825 L p F P
0 0 0 r
s
.702 .21 .094 r
.60004 .46284 m .60077 .45393 L .58372 .43652 L p F P
0 0 0 r
s
.702 .21 .094 r
.58372 .43652 m .58321 .44404 L .60004 .46284 L p F P
0 0 0 r
s
1 .327 .136 r
.43527 .42056 m .43557 .42645 L .41679 .44404 L p F P
0 0 0 r
s
1 .327 .136 r
.41679 .44404 m .41628 .43652 L .43527 .42056 L p F P
0 0 0 r
s
.24 .35 .67 r
.41983 .41926 m
.42021 .43322 L
s
.789 .235 .104 r
.58321 .44404 m .58372 .43652 L .56473 .42056 L p F P
0 0 0 r
s
.24 .35 .67 r
.57959 .44064 m
.57962 .43947 L
s
.789 .235 .104 r
.56473 .42056 m .56443 .42645 L .58321 .44404 L p F P
0 0 0 r
s
.24 .35 .67 r
.57979 .43322 m
.58017 .41926 L
s
1 .311 .131 r
.47761 .39843 m .47765 .40051 L .45624 .41851 L p F P
0 0 0 r
s
1 .311 .131 r
.45624 .41851 m .4561 .41449 L .47761 .39843 L p F P
0 0 0 r
s
.282 .414 .813 r
.54376 .41851 m .53751 .41851 L .51916 .40051 L p F P
0 0 0 r
s
.282 .414 .813 r
.51916 .40051 m .52235 .40051 L .54376 .41851 L p F P
0 0 0 r
s
.282 .414 .813 r
.53751 .41851 m .53126 .41851 L .51597 .40051 L p F P
0 0 0 r
s
.282 .414 .813 r
.51597 .40051 m .51916 .40051 L .53751 .41851 L p F P
0 0 0 r
s
.282 .414 .813 r
.53126 .41851 m .52501 .41851 L .51277 .40051 L p F P
0 0 0 r
s
.282 .414 .813 r
.51277 .40051 m .51597 .40051 L .53126 .41851 L p F P
0 0 0 r
s
.282 .414 .813 r
.52501 .41851 m .51876 .41851 L .50958 .40051 L p F P
0 0 0 r
s
.282 .414 .813 r
.50958 .40051 m .51277 .40051 L .52501 .41851 L p F P
0 0 0 r
s
.282 .414 .813 r
.51876 .41851 m .5125 .41851 L .50639 .40051 L p F P
0 0 0 r
s
.282 .414 .813 r
.50639 .40051 m .50958 .40051 L .51876 .41851 L p F P
0 0 0 r
s
.282 .414 .813 r
.5125 .41851 m .50625 .41851 L .50319 .40051 L p F P
0 0 0 r
s
.282 .414 .813 r
.50319 .40051 m .50639 .40051 L .5125 .41851 L p F P
0 0 0 r
s
.282 .414 .813 r
.50625 .41851 m .5 .41851 L .5 .40051 L p F P
0 0 0 r
s
.282 .414 .813 r
.5 .40051 m .50319 .40051 L .50625 .41851 L p F P
0 0 0 r
s
.282 .414 .813 r
.5 .41851 m .49375 .41851 L .49681 .40051 L p F P
0 0 0 r
s
.282 .414 .813 r
.49681 .40051 m .5 .40051 L .5 .41851 L p F P
0 0 0 r
s
.282 .414 .813 r
.49375 .41851 m .4875 .41851 L .49361 .40051 L p F P
0 0 0 r
s
.282 .414 .813 r
.49361 .40051 m .49681 .40051 L .49375 .41851 L p F P
0 0 0 r
s
.282 .414 .813 r
.4875 .41851 m .48124 .41851 L .49042 .40051 L p F P
0 0 0 r
s
.282 .414 .813 r
.49042 .40051 m .49361 .40051 L .4875 .41851 L p F P
0 0 0 r
s
.282 .414 .813 r
.48124 .41851 m .47499 .41851 L .48723 .40051 L p F P
0 0 0 r
s
.282 .414 .813 r
.48723 .40051 m .49042 .40051 L .48124 .41851 L p F P
0 0 0 r
s
.282 .414 .813 r
.47499 .41851 m .46874 .41851 L .48403 .40051 L p F P
0 0 0 r
s
.282 .414 .813 r
.48403 .40051 m .48723 .40051 L .47499 .41851 L p F P
0 0 0 r
s
.282 .414 .813 r
.46874 .41851 m .46249 .41851 L .48084 .40051 L p F P
0 0 0 r
s
.282 .414 .813 r
.48084 .40051 m .48403 .40051 L .46874 .41851 L p F P
0 0 0 r
s
.282 .414 .813 r
.46249 .41851 m .45624 .41851 L .47765 .40051 L p F P
0 0 0 r
s
.83 .24 .1 r
.45657 .41717 m
.45672 .42163 L
s
.282 .414 .813 r
.47765 .40051 m .48084 .40051 L .46249 .41851 L p F P
0 0 0 r
s
.921 .272 .118 r
.54376 .41851 m .5439 .41449 L .52239 .39843 L p F P
0 0 0 r
s
.921 .272 .118 r
.52239 .39843 m .52235 .40051 L .54376 .41851 L p F P
0 0 0 r
s
.83 .24 .1 r
.54328 .42163 m
.54343 .41717 L
s
.53285 .41544 m
.54343 .41717 L
s
.45657 .41717 m
.46715 .41544 L
s
1 .334 .136 r
.3854 .4825 m .38445 .47245 L .39923 .45393 L p F P
0 0 0 r
s
.83 .24 .1 r
.38641 .48212 m
.38838 .50307 L
s
.38641 .48212 m
.40682 .46496 L
s
1 .33 .134 r
.38445 .47245 m .3854 .4825 L .37341 .50265 L p F P
0 0 0 r
s
.465 .141 .068 r
.61555 .47245 m .6146 .4825 L .62659 .50265 L p F P
0 0 0 r
s
.597 .179 .083 r
.6146 .4825 m .61555 .47245 L .60077 .45393 L p F P
0 0 0 r
s
.83 .24 .1 r
.61162 .50307 m
.61359 .48212 L
s
.59318 .46496 m
.61359 .48212 L
s
.24 .35 .67 r
.74052 .41926 m
.78061 .41926 L
s
.70043 .41926 m
.74052 .41926 L
s
.66035 .41926 m
.70043 .41926 L
s
.62026 .41926 m
.66035 .41926 L
s
.58017 .41926 m
.62026 .41926 L
s
.54009 .41926 m
.54705 .41926 L
s
.55528 .41926 m
.58017 .41926 L
s
.5 .41926 m
.54009 .41926 L
s
.45991 .41926 m
.5 .41926 L
s
.45295 .41926 m
.45991 .41926 L
s
.41983 .41926 m
.44472 .41926 L
s
.37974 .41926 m
.41983 .41926 L
s
.33965 .41926 m
.37974 .41926 L
s
.29957 .41926 m
.33965 .41926 L
s
.25948 .41926 m
.29957 .41926 L
s
.21939 .41926 m
.25948 .41926 L
s
.74052 .41926 m
.74348 .39591 L
s
.78406 .39591 m
.78061 .41926 L
s
.70043 .41926 m
.7029 .39591 L
s
.66035 .41926 m
.66232 .39591 L
s
.62026 .41926 m
.62174 .39591 L
s
.37974 .41926 m
.37826 .39591 L
s
.33965 .41926 m
.33768 .39591 L
s
.29957 .41926 m
.2971 .39591 L
s
.25948 .41926 m
.25652 .39591 L
s
.21939 .41926 m
.21594 .39591 L
s
.206 .282 .55 r
.64141 .60276 m .62121 .60276 L .62158 .58511 L p F P
0 0 0 r
s
.83 .24 .1 r
.6388 .60044 m
.63912 .5954 L
s
.206 .282 .55 r
.62158 .58511 m .64184 .58511 L .64141 .60276 L p F P
0 0 0 r
s
.83 .24 .1 r
.63758 .61984 m
.63865 .60276 L
s
.206 .282 .55 r
.62121 .60276 m .601 .60276 L .60132 .58511 L p F P
0 0 0 r
s
.206 .282 .55 r
.60132 .58511 m .62158 .58511 L .62121 .60276 L p F P
0 0 0 r
s
.206 .282 .55 r
.601 .60276 m .5808 .60276 L .58105 .58511 L p F P
0 0 0 r
s
.206 .282 .55 r
.58105 .58511 m .60132 .58511 L .601 .60276 L p F P
0 0 0 r
s
.206 .282 .55 r
.5808 .60276 m .5606 .60276 L .56079 .58511 L p F P
0 0 0 r
s
.206 .282 .55 r
.56079 .58511 m .58105 .58511 L .5808 .60276 L p F P
0 0 0 r
s
.206 .282 .55 r
.5606 .60276 m .5404 .60276 L .54053 .58511 L p F P
0 0 0 r
s
.206 .282 .55 r
.54053 .58511 m .56079 .58511 L .5606 .60276 L p F P
0 0 0 r
s
.206 .282 .55 r
.5404 .60276 m .5202 .60276 L .52026 .58511 L p F P
0 0 0 r
s
.206 .282 .55 r
.52026 .58511 m .54053 .58511 L .5404 .60276 L p F P
0 0 0 r
s
.206 .282 .55 r
.5202 .60276 m .5 .60276 L .5 .58511 L p F P
0 0 0 r
s
.206 .282 .55 r
.5 .58511 m .52026 .58511 L .5202 .60276 L p F P
0 0 0 r
s
.206 .282 .55 r
.5 .60276 m .4798 .60276 L .47974 .58511 L p F P
0 0 0 r
s
.206 .282 .55 r
.47974 .58511 m .5 .58511 L .5 .60276 L p F P
0 0 0 r
s
.206 .282 .55 r
.4798 .60276 m .4596 .60276 L .45947 .58511 L p F P
0 0 0 r
s
.206 .282 .55 r
.45947 .58511 m .47974 .58511 L .4798 .60276 L p F P
0 0 0 r
s
.206 .282 .55 r
.4596 .60276 m .4394 .60276 L .43921 .58511 L p F P
0 0 0 r
s
.206 .282 .55 r
.43921 .58511 m .45947 .58511 L .4596 .60276 L p F P
0 0 0 r
s
.206 .282 .55 r
.4394 .60276 m .4192 .60276 L .41895 .58511 L p F P
0 0 0 r
s
.206 .282 .55 r
.41895 .58511 m .43921 .58511 L .4394 .60276 L p F P
0 0 0 r
s
.206 .282 .55 r
.4192 .60276 m .399 .60276 L .39868 .58511 L p F P
0 0 0 r
s
.206 .282 .55 r
.39868 .58511 m .41895 .58511 L .4192 .60276 L p F P
0 0 0 r
s
.206 .282 .55 r
.399 .60276 m .37879 .60276 L .37842 .58511 L p F P
0 0 0 r
s
.206 .282 .55 r
.37842 .58511 m .39868 .58511 L .399 .60276 L p F P
0 0 0 r
s
.206 .282 .55 r
.37879 .60276 m .35859 .60276 L .35816 .58511 L p F P
0 0 0 r
s
.206 .282 .55 r
.35816 .58511 m .37842 .58511 L .37879 .60276 L p F P
0 0 0 r
s
.83 .24 .1 r
.36135 .60276 m
.36242 .61984 L
s
.181 .052 .027 r
.64184 .58511 m .64331 .5737 L .64046 .55444 L p F P
0 0 0 r
s
.899 .254 .097 r
.35816 .58511 m .35669 .5737 L .35954 .55444 L p F P
0 0 0 r
s
.7 .195 .071 r
.35669 .5737 m .35816 .58511 L .35859 .60276 L p F P
0 0 0 r
s
.098 .028 .012 r
.64331 .5737 m .64184 .58511 L .64141 .60276 L p F P
0 0 0 r
s
1 .32 .134 r
.45582 .40637 m .45596 .41044 L .43557 .42645 L p F P
0 0 0 r
s
1 .32 .134 r
.43557 .42645 m .43527 .42056 L .45582 .40637 L p F P
0 0 0 r
s
.86 .255 .111 r
.56443 .42645 m .56473 .42056 L .54418 .40637 L p F P
0 0 0 r
s
.86 .255 .111 r
.54418 .40637 m .54404 .41044 L .56443 .42645 L p F P
0 0 0 r
s
.83 .24 .1 r
.45568 .73204 m
.45658 .75144 L
s
.45658 .75144 m
.48528 .75692 L
s
.51472 .75692 m
.54342 .75144 L
s
.54432 .73204 m
.54342 .75144 L
s
.24 .35 .67 r
.78105 .58431 m
.7409 .58431 L
s
.7409 .58431 m
.70075 .58431 L
s
.70075 .58431 m
.6606 .58431 L
s
.62045 .58431 m
.64194 .58431 L
s
.64261 .58431 m
.6606 .58431 L
s
.62045 .58431 m
.5803 .58431 L
s
.5803 .58431 m
.54015 .58431 L
s
.54015 .58431 m
.5 .58431 L
s
.5 .58431 m
.45985 .58431 L
s
.45985 .58431 m
.4197 .58431 L
s
.4197 .58431 m
.37955 .58431 L
s
.35806 .58431 m
.37955 .58431 L
s
.3394 .58431 m
.35739 .58431 L
s
.3394 .58431 m
.29925 .58431 L
s
.29925 .58431 m
.2591 .58431 L
s
.2591 .58431 m
.21895 .58431 L
s
.74397 .6072 m
.7409 .58431 L
s
.78105 .58431 m
.78463 .6072 L
s
.70331 .6072 m
.70075 .58431 L
s
.66265 .6072 m
.6606 .58431 L
s
.33735 .6072 m
.3394 .58431 L
s
.29669 .6072 m
.29925 .58431 L
s
.25603 .6072 m
.2591 .58431 L
s
.21537 .6072 m
.21895 .58431 L
s
1 .311 .131 r
.47757 .39634 m .47761 .39843 L .4561 .41449 L p F P
0 0 0 r
s
1 .311 .131 r
.4561 .41449 m .45596 .41044 L .47757 .39634 L p F P
0 0 0 r
s
.24 .35 .67 r
.45973 .41076 m
.45991 .41926 L
s
.921 .272 .118 r
.5439 .41449 m .54404 .41044 L .52243 .39634 L p F P
0 0 0 r
s
.921 .272 .118 r
.52243 .39634 m .52239 .39843 L .5439 .41449 L p F P
0 0 0 r
s
.24 .35 .67 r
.54009 .41926 m
.54027 .41076 L
s
.83 .24 .1 r
.38386 .66594 m
.38621 .68669 L
s
.38621 .68669 m
.40511 .70587 L
s
.59489 .70587 m
.61379 .68669 L
s
.61614 .66594 m
.61379 .68669 L
s
.62987 .64374 m
.63758 .61984 L
s
.36242 .61984 m
.37013 .64374 L
s
1 .33 .134 r
.37341 .50265 m .37224 .49173 L .38445 .47245 L p F P
0 0 0 r
s
1 .318 .127 r
.37224 .49173 m .37341 .50265 L .36424 .52289 L p F P
0 0 0 r
s
.332 .1 .051 r
.62776 .49173 m .62659 .50265 L .63576 .52289 L p F P
0 0 0 r
s
.465 .141 .068 r
.62659 .50265 m .62776 .49173 L .61555 .47245 L p F P
0 0 0 r
s
1 .295 .116 r
.35954 .55444 m .35811 .54283 L .36424 .52289 L p F P
0 0 0 r
s
.899 .254 .097 r
.35811 .54283 m .35954 .55444 L .35669 .5737 L p F P
0 0 0 r
s
.181 .052 .027 r
.64189 .54283 m .64046 .55444 L .64331 .5737 L p F P
0 0 0 r
s
.249 .072 .039 r
.64046 .55444 m .64189 .54283 L .63576 .52289 L p F P
0 0 0 r
s
.83 .24 .1 r
.48497 .73759 m
.48528 .75692 L
s
.48528 .75692 m
.51472 .75692 L
s
.51503 .73759 m
.51472 .75692 L
s
1 .327 .136 r
.43497 .41462 m .43527 .42056 L .41628 .43652 L p F P
0 0 0 r
s
1 .327 .136 r
.41628 .43652 m .41578 .42892 L .43497 .41462 L p F P
0 0 0 r
s
.83 .24 .1 r
.42941 .42639 m
.43054 .4466 L
s
1 .332 .137 r
.41578 .42892 m .41628 .43652 L .39923 .45393 L p F P
0 0 0 r
s
.702 .21 .094 r
.58422 .42892 m .58372 .43652 L .60077 .45393 L p F P
0 0 0 r
s
.789 .235 .104 r
.58372 .43652 m .58422 .42892 L .56503 .41462 L p F P
0 0 0 r
s
.789 .235 .104 r
.56503 .41462 m .56473 .42056 L .58372 .43652 L p F P
0 0 0 r
s
.83 .24 .1 r
.56946 .4466 m
.57059 .42639 L
s
1 .332 .137 r
.39923 .45393 m .39849 .4449 L .41578 .42892 L p F P
0 0 0 r
s
1 .334 .136 r
.39849 .4449 m .39923 .45393 L .38445 .47245 L p F P
0 0 0 r
s
.597 .179 .083 r
.60151 .4449 m .60077 .45393 L .61555 .47245 L p F P
0 0 0 r
s
.702 .21 .094 r
.60077 .45393 m .60151 .4449 L .58422 .42892 L p F P
0 0 0 r
s
.921 .272 .118 r
.54404 .41044 m .54418 .40637 L .52246 .39425 L p F P
0 0 0 r
s
.921 .272 .118 r
.52246 .39425 m .52243 .39634 L .54404 .41044 L p F P
0 0 0 r
s
1 .311 .131 r
.47754 .39425 m .47757 .39634 L .45596 .41044 L p F P
0 0 0 r
s
1 .311 .131 r
.45596 .41044 m .45582 .40637 L .47754 .39425 L p F P
0 0 0 r
s
1 .32 .134 r
.45568 .40227 m .45582 .40637 L .43527 .42056 L p F P
0 0 0 r
s
1 .32 .134 r
.43527 .42056 m .43497 .41462 L .45568 .40227 L p F P
0 0 0 r
s
.83 .24 .1 r
.42941 .42639 m
.45657 .41717 L
s
.86 .255 .111 r
.56473 .42056 m .56503 .41462 L .54432 .40227 L p F P
0 0 0 r
s
.86 .255 .111 r
.54432 .40227 m .54418 .40637 L .56473 .42056 L p F P
0 0 0 r
s
.83 .24 .1 r
.54343 .41717 m
.57059 .42639 L
s
1 .318 .127 r
.36424 .52289 m .3629 .51137 L .37224 .49173 L p F P
0 0 0 r
s
.83 .24 .1 r
.37049 .50248 m
.37308 .52624 L
s
1 .295 .116 r
.3629 .51137 m .36424 .52289 L .35811 .54283 L p F P
0 0 0 r
s
.249 .072 .039 r
.6371 .51137 m .63576 .52289 L .64189 .54283 L p F P
0 0 0 r
s
.332 .1 .051 r
.63576 .52289 m .6371 .51137 L .62776 .49173 L p F P
0 0 0 r
s
.83 .24 .1 r
.62692 .52624 m
.62951 .50248 L
s
1 .334 .136 r
.38445 .47245 m .38348 .46224 L .39849 .4449 L p F P
0 0 0 r
s
1 .33 .134 r
.38348 .46224 m .38445 .47245 L .37224 .49173 L p F P
0 0 0 r
s
.83 .24 .1 r
.37049 .50248 m
.38641 .48212 L
s
.465 .141 .068 r
.61652 .46224 m .61555 .47245 L .62776 .49173 L p F P
0 0 0 r
s
.83 .24 .1 r
.61359 .48212 m
.62951 .50248 L
s
.597 .179 .083 r
.61555 .47245 m .61652 .46224 L .60151 .4449 L p F P
0 0 0 r
s
1 .3 .128 r
.47765 .40051 m .47761 .39843 L .5 .38446 L closepath p F P
0 0 0 r
s
.287 .424 .832 r
.5 .38446 m .52235 .40051 L .51916 .40051 L closepath p F P
0 0 0 r
s
.287 .424 .832 r
.5 .38446 m .51916 .40051 L .51597 .40051 L closepath p F P
0 0 0 r
s
.287 .424 .832 r
.5 .38446 m .51597 .40051 L .51277 .40051 L closepath p F P
0 0 0 r
s
.287 .424 .832 r
.5 .38446 m .51277 .40051 L .50958 .40051 L closepath p F P
0 0 0 r
s
.287 .424 .832 r
.5 .38446 m .50958 .40051 L .50639 .40051 L closepath p F P
0 0 0 r
s
.287 .424 .832 r
.5 .38446 m .50639 .40051 L .50319 .40051 L closepath p F P
0 0 0 r
s
.287 .424 .832 r
.5 .38446 m .50319 .40051 L .5 .40051 L closepath p F P
0 0 0 r
s
.287 .424 .832 r
.5 .38446 m .5 .40051 L .49681 .40051 L closepath p F P
0 0 0 r
s
.287 .424 .832 r
.5 .38446 m .49681 .40051 L .49361 .40051 L closepath p F P
0 0 0 r
s
.287 .424 .832 r
.5 .38446 m .49361 .40051 L .49042 .40051 L closepath p F P
0 0 0 r
s
.287 .424 .832 r
.5 .38446 m .49042 .40051 L .48723 .40051 L closepath p F P
0 0 0 r
s
.287 .424 .832 r
.5 .38446 m .48723 .40051 L .48403 .40051 L closepath p F P
0 0 0 r
s
.287 .424 .832 r
.5 .38446 m .48403 .40051 L .48084 .40051 L closepath p F P
0 0 0 r
s
.287 .424 .832 r
.5 .38446 m .48084 .40051 L .47765 .40051 L closepath p F P
0 0 0 r
s
.973 .287 .123 r
.5 .38446 m .52235 .40051 L .52239 .39843 L closepath p F P
0 0 0 r
s
1 .311 .131 r
.4775 .39215 m .47754 .39425 L .45582 .40637 L p F P
0 0 0 r
s
1 .311 .131 r
.45582 .40637 m .45568 .40227 L .4775 .39215 L p F P
0 0 0 r
s
.921 .272 .118 r
.54418 .40637 m .54432 .40227 L .5225 .39215 L p F P
0 0 0 r
s
.24 .35 .67 r
.5404 .40426 m
.54041 .4039 L
s
.921 .272 .118 r
.5225 .39215 m .52246 .39425 L .54418 .40637 L p F P
0 0 0 r
s
1 .3 .128 r
.47761 .39843 m .47757 .39634 L .5 .38446 L closepath p F P
0 0 0 r
s
.973 .287 .123 r
.5 .38446 m .52239 .39843 L .52243 .39634 L closepath p F P
0 0 0 r
s
.187 .251 .489 r
.63766 .61838 m .618 .61838 L .62121 .60276 L p F P
0 0 0 r
s
.187 .251 .489 r
.62121 .60276 m .64141 .60276 L .63766 .61838 L p F P
0 0 0 r
s
.83 .24 .1 r
.63758 .61984 m
.63789 .61742 L
s
.187 .251 .489 r
.618 .61838 m .59833 .61838 L .601 .60276 L p F P
0 0 0 r
s
.187 .251 .489 r
.601 .60276 m .62121 .60276 L .618 .61838 L p F P
0 0 0 r
s
.24 .35 .67 r
.62045 .58431 m
.62199 .6072 L
s
.187 .251 .489 r
.59833 .61838 m .57866 .61838 L .5808 .60276 L p F P
0 0 0 r
s
.187 .251 .489 r
.5808 .60276 m .601 .60276 L .59833 .61838 L p F P
0 0 0 r
s
.187 .251 .489 r
.57866 .61838 m .559 .61838 L .5606 .60276 L p F P
0 0 0 r
s
.187 .251 .489 r
.5606 .60276 m .5808 .60276 L .57866 .61838 L p F P
0 0 0 r
s
.24 .35 .67 r
.5803 .58431 m
.58132 .6072 L
s
.187 .251 .489 r
.559 .61838 m .53933 .61838 L .5404 .60276 L p F P
0 0 0 r
s
.187 .251 .489 r
.5404 .60276 m .5606 .60276 L .559 .61838 L p F P
0 0 0 r
s
.187 .251 .489 r
.53933 .61838 m .51967 .61838 L .5202 .60276 L p F P
0 0 0 r
s
.187 .251 .489 r
.5202 .60276 m .5404 .60276 L .53933 .61838 L p F P
0 0 0 r
s
.24 .35 .67 r
.54015 .58431 m
.54066 .6072 L
s
.187 .251 .489 r
.51967 .61838 m .5 .61838 L .5 .60276 L p F P
0 0 0 r
s
.187 .251 .489 r
.5 .60276 m .5202 .60276 L .51967 .61838 L p F P
0 0 0 r
s
.187 .251 .489 r
.5 .61838 m .48033 .61838 L .4798 .60276 L p F P
0 0 0 r
s
.187 .251 .489 r
.4798 .60276 m .5 .60276 L .5 .61838 L p F P
0 0 0 r
s
.24 .35 .67 r
.5 .58431 m
.5 .6072 L
s
.187 .251 .489 r
.48033 .61838 m .46067 .61838 L .4596 .60276 L p F P
0 0 0 r
s
.187 .251 .489 r
.4596 .60276 m .4798 .60276 L .48033 .61838 L p F P
0 0 0 r
s
.187 .251 .489 r
.46067 .61838 m .441 .61838 L .4394 .60276 L p F P
0 0 0 r
s
.187 .251 .489 r
.4394 .60276 m .4596 .60276 L .46067 .61838 L p F P
0 0 0 r
s
.24 .35 .67 r
.45934 .6072 m
.45985 .58431 L
s
.187 .251 .489 r
.441 .61838 m .42134 .61838 L .4192 .60276 L p F P
0 0 0 r
s
.187 .251 .489 r
.4192 .60276 m .4394 .60276 L .441 .61838 L p F P
0 0 0 r
s
.187 .251 .489 r
.42134 .61838 m .40167 .61838 L .399 .60276 L p F P
0 0 0 r
s
.187 .251 .489 r
.399 .60276 m .4192 .60276 L .42134 .61838 L p F P
0 0 0 r
s
.24 .35 .67 r
.41868 .6072 m
.4197 .58431 L
s
.187 .251 .489 r
.40167 .61838 m .382 .61838 L .37879 .60276 L p F P
0 0 0 r
s
.187 .251 .489 r
.37879 .60276 m .399 .60276 L .40167 .61838 L p F P
0 0 0 r
s
.187 .251 .489 r
.382 .61838 m .36234 .61838 L .35859 .60276 L p F P
0 0 0 r
s
.83 .24 .1 r
.36211 .61742 m
.36242 .61984 L
s
.187 .251 .489 r
.35859 .60276 m .37879 .60276 L .382 .61838 L p F P
0 0 0 r
s
.24 .35 .67 r
.37801 .6072 m
.37955 .58431 L
s
.7 .195 .071 r
.35859 .60276 m .35714 .59157 L .35669 .5737 L p F P
0 0 0 r
s
.157 .045 .023 r
.35714 .59157 m .35859 .60276 L .36234 .61838 L p F P
0 0 0 r
s
.098 .028 .012 r
.64141 .60276 m .64286 .59157 L .64331 .5737 L p F P
0 0 0 r
s
.796 .229 .086 r
.64286 .59157 m .64141 .60276 L .63766 .61838 L p F P
0 0 0 r
s
1 .32 .134 r
.45554 .39815 m .45568 .40227 L .43497 .41462 L p F P
0 0 0 r
s
1 .32 .134 r
.43497 .41462 m .43466 .40861 L .45554 .39815 L p F P
0 0 0 r
s
1 .327 .136 r
.43466 .40861 m .43497 .41462 L .41578 .42892 L p F P
0 0 0 r
s
.789 .235 .104 r
.56534 .40861 m .56503 .41462 L .58422 .42892 L p F P
0 0 0 r
s
.86 .255 .111 r
.56503 .41462 m .56534 .40861 L .54446 .39815 L p F P
0 0 0 r
s
.86 .255 .111 r
.54446 .39815 m .54432 .40227 L .56503 .41462 L p F P
0 0 0 r
s
.83 .24 .1 r
.57138 .72127 m
.59489 .70587 L
s
.59687 .68534 m
.59489 .70587 L
s
.40313 .68534 m
.40511 .70587 L
s
.40511 .70587 m
.42862 .72127 L
s
.702 .21 .094 r
.58474 .42122 m .58422 .42892 L .60151 .4449 L p F P
0 0 0 r
s
.83 .24 .1 r
.59318 .46496 m
.59509 .43988 L
s
.789 .235 .104 r
.58422 .42892 m .58474 .42122 L .56534 .40861 L p F P
0 0 0 r
s
.83 .24 .1 r
.57059 .42639 m
.59509 .43988 L
s
.24 .35 .67 r
.58021 .41828 m
.58116 .39591 L
s
1 .327 .136 r
.41578 .42892 m .41526 .42122 L .43466 .40861 L p F P
0 0 0 r
s
.24 .35 .67 r
.41884 .39591 m
.41979 .41828 L
s
1 .332 .137 r
.41526 .42122 m .41578 .42892 L .39849 .4449 L p F P
0 0 0 r
s
.83 .24 .1 r
.40491 .43988 m
.42941 .42639 L
s
.40491 .43988 m
.40682 .46496 L
s
.899 .254 .097 r
.35669 .5737 m .3552 .56206 L .35811 .54283 L p F P
0 0 0 r
s
.83 .24 .1 r
.35804 .57301 m
.35958 .58511 L
s
.35804 .57301 m
.36267 .54885 L
s
.7 .195 .071 r
.3552 .56206 m .35669 .5737 L .35714 .59157 L p F P
0 0 0 r
s
.181 .052 .027 r
.64331 .5737 m .6448 .56206 L .64189 .54283 L p F P
0 0 0 r
s
.83 .24 .1 r
.64042 .58511 m
.64196 .57301 L
s
.63733 .54885 m
.64196 .57301 L
s
.098 .028 .012 r
.6448 .56206 m .64331 .5737 L .64286 .59157 L p F P
0 0 0 r
s
1 .3 .128 r
.47757 .39634 m .47754 .39425 L .5 .38446 L closepath p F P
0 0 0 r
s
.973 .287 .123 r
.5 .38446 m .52243 .39634 L .52246 .39425 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.5 .39591 m
.5 .41926 L
s
1 .33 .134 r
.37224 .49173 m .37106 .4806 L .38348 .46224 L p F P
0 0 0 r
s
1 .318 .127 r
.37106 .4806 m .37224 .49173 L .3629 .51137 L p F P
0 0 0 r
s
.332 .1 .051 r
.62894 .4806 m .62776 .49173 L .6371 .51137 L p F P
0 0 0 r
s
.465 .141 .068 r
.62776 .49173 m .62894 .4806 L .61652 .46224 L p F P
0 0 0 r
s
1 .311 .131 r
.47747 .39004 m .4775 .39215 L .45568 .40227 L p F P
0 0 0 r
s
1 .311 .131 r
.45568 .40227 m .45554 .39815 L .47747 .39004 L p F P
0 0 0 r
s
.24 .35 .67 r
.45942 .39591 m
.45944 .39671 L
s
.921 .272 .118 r
.54432 .40227 m .54446 .39815 L .52253 .39004 L p F P
0 0 0 r
s
.24 .35 .67 r
.54048 .40049 m
.54049 .40012 L
s
.921 .272 .118 r
.52253 .39004 m .5225 .39215 L .54432 .40227 L p F P
0 0 0 r
s
.24 .35 .67 r
.54056 .39671 m
.54058 .39591 L
s
.74348 .39591 m
.78406 .39591 L
s
.7029 .39591 m
.74348 .39591 L
s
.66232 .39591 m
.7029 .39591 L
s
.62174 .39591 m
.66232 .39591 L
s
.58116 .39591 m
.62174 .39591 L
s
.54058 .39591 m
.58116 .39591 L
s
.5 .39591 m
.5243 .39591 L
s
.5384 .39591 m
.54058 .39591 L
s
.4757 .39591 m
.5 .39591 L
s
.45942 .39591 m
.4616 .39591 L
s
.41884 .39591 m
.45942 .39591 L
s
.37826 .39591 m
.41884 .39591 L
s
.33768 .39591 m
.37826 .39591 L
s
.2971 .39591 m
.33768 .39591 L
s
.25652 .39591 m
.2971 .39591 L
s
.21594 .39591 m
.25652 .39591 L
s
.74348 .39591 m
.74718 .37624 L
s
.78837 .37624 m
.78406 .39591 L
s
.7029 .39591 m
.70598 .37624 L
s
.66232 .39591 m
.66478 .37624 L
s
.62174 .39591 m
.62359 .37624 L
s
.37826 .39591 m
.37641 .37624 L
s
.33768 .39591 m
.33522 .37624 L
s
.2971 .39591 m
.29402 .37624 L
s
.25652 .39591 m
.25282 .37624 L
s
.21594 .39591 m
.21163 .37624 L
s
1 .332 .137 r
.39849 .4449 m .39775 .43573 L .41526 .42122 L p F P
0 0 0 r
s
1 .334 .136 r
.39775 .43573 m .39849 .4449 L .38348 .46224 L p F P
0 0 0 r
s
.597 .179 .083 r
.60225 .43573 m .60151 .4449 L .61652 .46224 L p F P
0 0 0 r
s
.702 .21 .094 r
.60151 .4449 m .60225 .43573 L .58474 .42122 L p F P
0 0 0 r
s
1 .3 .128 r
.47754 .39425 m .4775 .39215 L .5 .38446 L closepath p F P
0 0 0 r
s
.973 .287 .123 r
.5 .38446 m .52246 .39425 L .5225 .39215 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.61614 .66594 m
.62987 .64374 L
s
.37013 .64374 m
.38386 .66594 L
s
1 .295 .116 r
.35811 .54283 m .35664 .53099 L .3629 .51137 L p F P
0 0 0 r
s
.899 .254 .097 r
.35664 .53099 m .35811 .54283 L .3552 .56206 L p F P
0 0 0 r
s
.181 .052 .027 r
.64336 .53099 m .64189 .54283 L .6448 .56206 L p F P
0 0 0 r
s
.249 .072 .039 r
.64189 .54283 m .64336 .53099 L .6371 .51137 L p F P
0 0 0 r
s
.24 .35 .67 r
.74777 .62625 m
.74397 .6072 L
s
.78463 .6072 m
.78906 .62625 L
s
.74397 .6072 m
.78463 .6072 L
s
.70647 .62625 m
.70331 .6072 L
s
.70331 .6072 m
.74397 .6072 L
s
.66518 .62625 m
.66265 .6072 L
s
.66265 .6072 m
.70331 .6072 L
s
.64028 .6072 m
.66265 .6072 L
s
.62199 .6072 m
.63983 .6072 L
s
.58132 .6072 m
.62199 .6072 L
s
.54066 .6072 m
.58132 .6072 L
s
.5 .6072 m
.54066 .6072 L
s
.45934 .6072 m
.5 .6072 L
s
.41868 .6072 m
.45934 .6072 L
s
.37801 .6072 m
.41868 .6072 L
s
.33482 .62625 m
.33735 .6072 L
s
.33735 .6072 m
.35972 .6072 L
s
.36017 .6072 m
.37801 .6072 L
s
.29353 .62625 m
.29669 .6072 L
s
.29669 .6072 m
.33735 .6072 L
s
.25223 .62625 m
.25603 .6072 L
s
.25603 .6072 m
.29669 .6072 L
s
.21094 .62625 m
.21537 .6072 L
s
.21537 .6072 m
.25603 .6072 L
s
.973 .287 .123 r
.5 .38446 m .5225 .39215 L .52253 .39004 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.4775 .39215 m .47747 .39004 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .311 .131 r
.47743 .38793 m .47747 .39004 L .45554 .39815 L p F P
0 0 0 r
s
1 .311 .131 r
.45554 .39815 m .45539 .394 L .47743 .38793 L p F P
0 0 0 r
s
1 .32 .134 r
.45539 .394 m .45554 .39815 L .43466 .40861 L p F P
0 0 0 r
s
.86 .255 .111 r
.54461 .394 m .54446 .39815 L .56534 .40861 L p F P
0 0 0 r
s
.921 .272 .118 r
.54446 .39815 m .54461 .394 L .52257 .38793 L p F P
0 0 0 r
s
.921 .272 .118 r
.52257 .38793 m .52253 .39004 L .54446 .39815 L p F P
0 0 0 r
s
1 .32 .134 r
.43466 .40861 m .43435 .40255 L .45539 .394 L p F P
0 0 0 r
s
1 .327 .136 r
.43435 .40255 m .43466 .40861 L .41526 .42122 L p F P
0 0 0 r
s
.789 .235 .104 r
.56565 .40255 m .56534 .40861 L .58474 .42122 L p F P
0 0 0 r
s
.86 .255 .111 r
.56534 .40861 m .56565 .40255 L .54461 .394 L p F P
0 0 0 r
s
1 .334 .136 r
.38348 .46224 m .38249 .45184 L .39775 .43573 L p F P
0 0 0 r
s
.83 .24 .1 r
.38407 .45718 m
.38641 .48212 L
s
1 .33 .134 r
.38249 .45184 m .38348 .46224 L .37106 .4806 L p F P
0 0 0 r
s
.465 .141 .068 r
.61751 .45184 m .61652 .46224 L .62894 .4806 L p F P
0 0 0 r
s
.597 .179 .083 r
.61652 .46224 m .61751 .45184 L .60225 .43573 L p F P
0 0 0 r
s
.83 .24 .1 r
.61359 .48212 m
.61593 .45718 L
s
1 .3 .128 r
.47747 .39004 m .47743 .38793 L .5 .38446 L closepath p F P
0 0 0 r
s
.973 .287 .123 r
.5 .38446 m .52253 .39004 L .52257 .38793 L closepath p F P
0 0 0 r
s
.249 .072 .039 r
.63847 .49961 m .6371 .51137 L .64336 .53099 L p F P
0 0 0 r
s
.83 .24 .1 r
.63733 .54885 m
.64016 .52529 L
s
.332 .1 .051 r
.6371 .51137 m .63847 .49961 L .62894 .4806 L p F P
0 0 0 r
s
.83 .24 .1 r
.62951 .50248 m
.64016 .52529 L
s
1 .318 .127 r
.3629 .51137 m .36153 .49961 L .37106 .4806 L p F P
0 0 0 r
s
1 .295 .116 r
.36153 .49961 m .3629 .51137 L .35664 .53099 L p F P
0 0 0 r
s
.83 .24 .1 r
.35984 .52529 m
.37049 .50248 L
s
.35984 .52529 m
.36267 .54885 L
s
1 .327 .136 r
.41526 .42122 m .41474 .41343 L .43435 .40255 L p F P
0 0 0 r
s
1 .332 .137 r
.41474 .41343 m .41526 .42122 L .39775 .43573 L p F P
0 0 0 r
s
.702 .21 .094 r
.58526 .41343 m .58474 .42122 L .60225 .43573 L p F P
0 0 0 r
s
.789 .235 .104 r
.58474 .42122 m .58526 .41343 L .56565 .40255 L p F P
0 0 0 r
s
.83 .24 .1 r
.42712 .70093 m
.42862 .72127 L
s
.42862 .72127 m
.45568 .73204 L
s
.54432 .73204 m
.57138 .72127 L
s
.57288 .70093 m
.57138 .72127 L
s
.921 .272 .118 r
.52261 .38581 m .52257 .38793 L .54461 .394 L p F P
0 0 0 r
s
.973 .287 .123 r
.5 .38446 m .52257 .38793 L .52261 .38581 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.51478 .40205 m
.51496 .38615 L
s
1 .3 .128 r
.47743 .38793 m .47739 .38581 L .5 .38446 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.48504 .38615 m
.48522 .40205 L
s
1 .311 .131 r
.47739 .38581 m .47743 .38793 L .45539 .394 L p F P
0 0 0 r
s
.86 .255 .111 r
.54475 .38982 m .54461 .394 L .56565 .40255 L p F P
0 0 0 r
s
.921 .272 .118 r
.54461 .394 m .54475 .38982 L .52261 .38581 L p F P
0 0 0 r
s
.83 .24 .1 r
.54343 .41717 m
.54432 .39087 L
s
1 .311 .131 r
.45539 .394 m .45525 .38982 L .47739 .38581 L p F P
0 0 0 r
s
.83 .24 .1 r
.45568 .39087 m
.45657 .41717 L
s
1 .32 .134 r
.45525 .38982 m .45539 .394 L .43435 .40255 L p F P
0 0 0 r
s
.973 .287 .123 r
.5 .38446 m .52283 .37294 L .52287 .37077 L closepath p F P
0 0 0 r
s
.973 .287 .123 r
.5 .38446 m .52261 .38581 L .52264 .38368 L closepath p F P
0 0 0 r
s
.973 .287 .123 r
.5 .38446 m .52264 .38368 L .52268 .38155 L closepath p F P
0 0 0 r
s
.973 .287 .123 r
.5 .38446 m .52268 .38155 L .52272 .37941 L closepath p F P
0 0 0 r
s
.973 .287 .123 r
.5 .38446 m .52272 .37941 L .52276 .37726 L closepath p F P
0 0 0 r
s
.973 .287 .123 r
.5 .38446 m .52276 .37726 L .52279 .3751 L closepath p F P
0 0 0 r
s
.973 .287 .123 r
.5 .38446 m .52279 .3751 L .52283 .37294 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.47736 .38368 m .47732 .38155 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.47739 .38581 m .47736 .38368 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.47721 .3751 m .47717 .37294 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.47724 .37726 m .47721 .3751 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.47728 .37941 m .47724 .37726 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.47732 .38155 m .47728 .37941 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.47717 .37294 m .47713 .37077 L .5 .38446 L closepath p F P
0 0 0 r
s
.289 .431 .847 r
.4804 .37077 m .47713 .37077 L .5 .38446 L closepath p F P
0 0 0 r
s
.289 .431 .847 r
.48367 .37077 m .4804 .37077 L .5 .38446 L closepath p F P
0 0 0 r
s
.289 .431 .847 r
.48693 .37077 m .48367 .37077 L .5 .38446 L closepath p F P
0 0 0 r
s
.289 .431 .847 r
.4902 .37077 m .48693 .37077 L .5 .38446 L closepath p F P
0 0 0 r
s
.289 .431 .847 r
.49347 .37077 m .4902 .37077 L .5 .38446 L closepath p F P
0 0 0 r
s
.289 .431 .847 r
.49673 .37077 m .49347 .37077 L .5 .38446 L closepath p F P
0 0 0 r
s
.289 .431 .847 r
.5 .37077 m .49673 .37077 L .5 .38446 L closepath p F P
0 0 0 r
s
.289 .431 .847 r
.50327 .37077 m .5 .37077 L .5 .38446 L closepath p F P
0 0 0 r
s
.289 .431 .847 r
.50653 .37077 m .50327 .37077 L .5 .38446 L closepath p F P
0 0 0 r
s
.289 .431 .847 r
.5098 .37077 m .50653 .37077 L .5 .38446 L closepath p F P
0 0 0 r
s
.289 .431 .847 r
.51307 .37077 m .5098 .37077 L .5 .38446 L closepath p F P
0 0 0 r
s
.289 .431 .847 r
.51633 .37077 m .51307 .37077 L .5 .38446 L closepath p F P
0 0 0 r
s
.289 .431 .847 r
.5196 .37077 m .51633 .37077 L .5 .38446 L closepath p F P
0 0 0 r
s
.289 .431 .847 r
.52287 .37077 m .5196 .37077 L .5 .38446 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.5 .37624 m
.5 .39591 L
s
.921 .272 .118 r
.52264 .38368 m .52261 .38581 L .54475 .38982 L p F P
0 0 0 r
s
1 .311 .131 r
.47736 .38368 m .47739 .38581 L .45525 .38982 L p F P
0 0 0 r
s
.83 .24 .1 r
.51496 .38615 m
.48504 .38615 L
s
1 .32 .134 r
.43435 .40255 m .43404 .39644 L .45525 .38982 L p F P
0 0 0 r
s
1 .327 .136 r
.43404 .39644 m .43435 .40255 L .41474 .41343 L p F P
0 0 0 r
s
.789 .235 .104 r
.56596 .39644 m .56565 .40255 L .58526 .41343 L p F P
0 0 0 r
s
.86 .255 .111 r
.56565 .40255 m .56596 .39644 L .54475 .38982 L p F P
0 0 0 r
s
1 .332 .137 r
.39775 .43573 m .39699 .42642 L .41474 .41343 L p F P
0 0 0 r
s
1 .334 .136 r
.39699 .42642 m .39775 .43573 L .38249 .45184 L p F P
0 0 0 r
s
.83 .24 .1 r
.38407 .45718 m
.40491 .43988 L
s
.597 .179 .083 r
.60301 .42642 m .60225 .43573 L .61751 .45184 L p F P
0 0 0 r
s
.83 .24 .1 r
.59509 .43988 m
.61593 .45718 L
s
.702 .21 .094 r
.60225 .43573 m .60301 .42642 L .58526 .41343 L p F P
0 0 0 r
s
.7 .195 .071 r
.35714 .59157 m .35566 .58015 L .3552 .56206 L p F P
0 0 0 r
s
.157 .045 .023 r
.35566 .58015 m .35714 .59157 L .36096 .60765 L p F P
0 0 0 r
s
.83 .24 .1 r
.36072 .60665 m
.36087 .60778 L
s
.157 .045 .023 r
.36234 .61838 m .36096 .60765 L .35714 .59157 L p F P
0 0 0 r
s
.83 .24 .1 r
.35958 .59771 m
.36064 .60596 L
s
.35804 .57301 m
.35958 .59771 L
s
.796 .229 .086 r
.63766 .61838 m .63904 .60765 L .64286 .59157 L p F P
0 0 0 r
s
.098 .028 .012 r
.64286 .59157 m .64434 .58015 L .6448 .56206 L p F P
0 0 0 r
s
.796 .229 .086 r
.64434 .58015 m .64286 .59157 L .63904 .60765 L p F P
0 0 0 r
s
.83 .24 .1 r
.63936 .60596 m
.64042 .59771 L
s
.64042 .59771 m
.64196 .57301 L
s
1 .33 .134 r
.37106 .4806 m .36985 .46926 L .38249 .45184 L p F P
0 0 0 r
s
1 .318 .127 r
.36985 .46926 m .37106 .4806 L .36153 .49961 L p F P
0 0 0 r
s
.332 .1 .051 r
.63015 .46926 m .62894 .4806 L .63847 .49961 L p F P
0 0 0 r
s
.465 .141 .068 r
.62894 .4806 m .63015 .46926 L .61751 .45184 L p F P
0 0 0 r
s
.161 .21 .408 r
.38808 .63157 m .36942 .63157 L .36234 .61838 L p F P
0 0 0 r
s
.161 .21 .408 r
.36234 .61838 m .382 .61838 L .38808 .63157 L p F P
0 0 0 r
s
.236 .068 .036 r
.36096 .60765 m .36234 .61838 L .36942 .63157 L p F P
0 0 0 r
s
.83 .24 .1 r
.36838 .62964 m
.37013 .64374 L
s
.161 .21 .408 r
.63058 .63157 m .61192 .63157 L .618 .61838 L p F P
0 0 0 r
s
.161 .21 .408 r
.618 .61838 m .63766 .61838 L .63058 .63157 L p F P
0 0 0 r
s
.24 .35 .67 r
.62199 .6072 m
.62388 .62625 L
s
.161 .21 .408 r
.61192 .63157 m .59327 .63157 L .59833 .61838 L p F P
0 0 0 r
s
.161 .21 .408 r
.59833 .61838 m .618 .61838 L .61192 .63157 L p F P
0 0 0 r
s
.161 .21 .408 r
.59327 .63157 m .57462 .63157 L .57866 .61838 L p F P
0 0 0 r
s
.161 .21 .408 r
.57866 .61838 m .59833 .61838 L .59327 .63157 L p F P
0 0 0 r
s
.24 .35 .67 r
.58132 .6072 m
.58259 .62625 L
s
.161 .21 .408 r
.57462 .63157 m .55596 .63157 L .559 .61838 L p F P
0 0 0 r
s
.161 .21 .408 r
.559 .61838 m .57866 .61838 L .57462 .63157 L p F P
0 0 0 r
s
.161 .21 .408 r
.55596 .63157 m .53731 .63157 L .53933 .61838 L p F P
0 0 0 r
s
.161 .21 .408 r
.53933 .61838 m .559 .61838 L .55596 .63157 L p F P
0 0 0 r
s
.24 .35 .67 r
.54066 .6072 m
.54129 .62625 L
s
.161 .21 .408 r
.53731 .63157 m .51865 .63157 L .51967 .61838 L p F P
0 0 0 r
s
.161 .21 .408 r
.51967 .61838 m .53933 .61838 L .53731 .63157 L p F P
0 0 0 r
s
.161 .21 .408 r
.51865 .63157 m .5 .63157 L .5 .61838 L p F P
0 0 0 r
s
.161 .21 .408 r
.5 .61838 m .51967 .61838 L .51865 .63157 L p F P
0 0 0 r
s
.161 .21 .408 r
.5 .63157 m .48135 .63157 L .48033 .61838 L p F P
0 0 0 r
s
.161 .21 .408 r
.48033 .61838 m .5 .61838 L .5 .63157 L p F P
0 0 0 r
s
.24 .35 .67 r
.5 .6072 m
.5 .62625 L
s
.161 .21 .408 r
.48135 .63157 m .46269 .63157 L .46067 .61838 L p F P
0 0 0 r
s
.161 .21 .408 r
.46067 .61838 m .48033 .61838 L .48135 .63157 L p F P
0 0 0 r
s
.161 .21 .408 r
.46269 .63157 m .44404 .63157 L .441 .61838 L p F P
0 0 0 r
s
.161 .21 .408 r
.441 .61838 m .46067 .61838 L .46269 .63157 L p F P
0 0 0 r
s
.24 .35 .67 r
.45871 .62625 m
.45934 .6072 L
s
.161 .21 .408 r
.44404 .63157 m .42538 .63157 L .42134 .61838 L p F P
0 0 0 r
s
.161 .21 .408 r
.42134 .61838 m .441 .61838 L .44404 .63157 L p F P
0 0 0 r
s
.161 .21 .408 r
.42538 .63157 m .40673 .63157 L .40167 .61838 L p F P
0 0 0 r
s
.161 .21 .408 r
.40167 .61838 m .42134 .61838 L .42538 .63157 L p F P
0 0 0 r
s
.24 .35 .67 r
.41741 .62625 m
.41868 .6072 L
s
.161 .21 .408 r
.40673 .63157 m .38808 .63157 L .382 .61838 L p F P
0 0 0 r
s
.161 .21 .408 r
.382 .61838 m .40167 .61838 L .40673 .63157 L p F P
0 0 0 r
s
.24 .35 .67 r
.37612 .62625 m
.37801 .6072 L
s
.973 .282 .11 r
.63904 .60765 m .63766 .61838 L .63058 .63157 L p F P
0 0 0 r
s
.83 .24 .1 r
.62987 .64374 m
.63162 .62964 L
s
.921 .272 .118 r
.54475 .38982 m .54489 .38562 L .52264 .38368 L p F P
0 0 0 r
s
.83 .24 .1 r
.51496 .38615 m
.54432 .39087 L
s
.921 .272 .118 r
.52268 .38155 m .52264 .38368 L .54489 .38562 L p F P
0 0 0 r
s
1 .311 .131 r
.47732 .38155 m .47736 .38368 L .45511 .38562 L p F P
0 0 0 r
s
.24 .35 .67 r
.45909 .38527 m
.4592 .38873 L
s
1 .311 .131 r
.45525 .38982 m .45511 .38562 L .47736 .38368 L p F P
0 0 0 r
s
.83 .24 .1 r
.45568 .39087 m
.48504 .38615 L
s
.899 .254 .097 r
.3552 .56206 m .35368 .55017 L .35664 .53099 L p F P
0 0 0 r
s
.7 .195 .071 r
.35368 .55017 m .3552 .56206 L .35566 .58015 L p F P
0 0 0 r
s
.181 .052 .027 r
.6448 .56206 m .64632 .55017 L .64336 .53099 L p F P
0 0 0 r
s
.098 .028 .012 r
.64632 .55017 m .6448 .56206 L .64434 .58015 L p F P
0 0 0 r
s
.86 .255 .111 r
.54489 .38562 m .54475 .38982 L .56596 .39644 L p F P
0 0 0 r
s
1 .32 .134 r
.45511 .38562 m .45525 .38982 L .43404 .39644 L p F P
0 0 0 r
s
.83 .24 .1 r
.45475 .71183 m
.45568 .73204 L
s
.45568 .73204 m
.48497 .73759 L
s
.51503 .73759 m
.54432 .73204 L
s
.54525 .71183 m
.54432 .73204 L
s
.921 .272 .118 r
.54489 .38562 m .54504 .38139 L .52268 .38155 L p F P
0 0 0 r
s
.921 .272 .118 r
.52272 .37941 m .52268 .38155 L .54504 .38139 L p F P
0 0 0 r
s
1 .311 .131 r
.47728 .37941 m .47732 .38155 L .45496 .38139 L p F P
0 0 0 r
s
1 .311 .131 r
.45511 .38562 m .45496 .38139 L .47732 .38155 L p F P
0 0 0 r
s
.83 .24 .1 r
.59687 .68534 m
.61614 .66594 L
s
.61859 .64431 m
.61614 .66594 L
s
.38141 .64431 m
.38386 .66594 L
s
.38386 .66594 m
.40313 .68534 L
s
1 .327 .136 r
.41474 .41343 m .41422 .40554 L .43404 .39644 L p F P
0 0 0 r
s
1 .332 .137 r
.41422 .40554 m .41474 .41343 L .39699 .42642 L p F P
0 0 0 r
s
.702 .21 .094 r
.58578 .40554 m .58526 .41343 L .60301 .42642 L p F P
0 0 0 r
s
.789 .235 .104 r
.58526 .41343 m .58578 .40554 L .56596 .39644 L p F P
0 0 0 r
s
1 .295 .116 r
.35664 .53099 m .35515 .51889 L .36153 .49961 L p F P
0 0 0 r
s
.899 .254 .097 r
.35515 .51889 m .35664 .53099 L .35368 .55017 L p F P
0 0 0 r
s
.181 .052 .027 r
.64485 .51889 m .64336 .53099 L .64632 .55017 L p F P
0 0 0 r
s
.249 .072 .039 r
.64336 .53099 m .64485 .51889 L .63847 .49961 L p F P
0 0 0 r
s
.83 .24 .1 r
.48466 .71745 m
.48497 .73759 L
s
.48497 .73759 m
.51503 .73759 L
s
.51534 .71745 m
.51503 .73759 L
s
.921 .272 .118 r
.54504 .38139 m .54519 .37713 L .52272 .37941 L p F P
0 0 0 r
s
.921 .272 .118 r
.52276 .37726 m .52272 .37941 L .54519 .37713 L p F P
0 0 0 r
s
1 .311 .131 r
.47724 .37726 m .47728 .37941 L .45481 .37713 L p F P
0 0 0 r
s
1 .311 .131 r
.45496 .38139 m .45481 .37713 L .47728 .37941 L p F P
0 0 0 r
s
1 .334 .136 r
.38249 .45184 m .38149 .44128 L .39699 .42642 L p F P
0 0 0 r
s
1 .33 .134 r
.38149 .44128 m .38249 .45184 L .36985 .46926 L p F P
0 0 0 r
s
.465 .141 .068 r
.61851 .44128 m .61751 .45184 L .63015 .46926 L p F P
0 0 0 r
s
.597 .179 .083 r
.61751 .45184 m .61851 .44128 L .60301 .42642 L p F P
0 0 0 r
s
.86 .255 .111 r
.56596 .39644 m .56627 .39026 L .54489 .38562 L p F P
0 0 0 r
s
.86 .255 .111 r
.54504 .38139 m .54489 .38562 L .56627 .39026 L p F P
0 0 0 r
s
1 .32 .134 r
.45496 .38139 m .45511 .38562 L .43373 .39026 L p F P
0 0 0 r
s
1 .32 .134 r
.43404 .39644 m .43373 .39026 L .45511 .38562 L p F P
0 0 0 r
s
1 .327 .136 r
.43373 .39026 m .43404 .39644 L .41422 .40554 L p F P
0 0 0 r
s
.83 .24 .1 r
.42795 .40016 m
.45568 .39087 L
s
.42795 .40016 m
.42941 .42639 L
s
.24 .35 .67 r
.41761 .37624 m
.41884 .39591 L
s
.789 .235 .104 r
.56627 .39026 m .56596 .39644 L .58578 .40554 L p F P
0 0 0 r
s
.83 .24 .1 r
.54432 .39087 m
.57205 .40016 L
s
.57059 .42639 m
.57205 .40016 L
s
.24 .35 .67 r
.58116 .39591 m
.58239 .37624 L
s
.921 .272 .118 r
.54519 .37713 m .54533 .37284 L .52276 .37726 L p F P
0 0 0 r
s
.921 .272 .118 r
.52279 .3751 m .52276 .37726 L .54533 .37284 L p F P
0 0 0 r
s
1 .311 .131 r
.47721 .3751 m .47724 .37726 L .45467 .37284 L p F P
0 0 0 r
s
1 .311 .131 r
.45481 .37713 m .45467 .37284 L .47724 .37726 L p F P
0 0 0 r
s
1 .318 .127 r
.36153 .49961 m .36014 .48762 L .36985 .46926 L p F P
0 0 0 r
s
1 .295 .116 r
.36014 .48762 m .36153 .49961 L .35515 .51889 L p F P
0 0 0 r
s
.249 .072 .039 r
.63986 .48762 m .63847 .49961 L .64485 .51889 L p F P
0 0 0 r
s
.332 .1 .051 r
.63847 .49961 m .63986 .48762 L .63015 .46926 L p F P
0 0 0 r
s
.24 .35 .67 r
.74718 .37624 m
.78837 .37624 L
s
.70598 .37624 m
.74718 .37624 L
s
.66478 .37624 m
.70598 .37624 L
s
.62359 .37624 m
.66478 .37624 L
s
.58239 .37624 m
.62359 .37624 L
s
.54522 .37624 m
.58239 .37624 L
s
.5 .37624 m
.52467 .37624 L
s
.47533 .37624 m
.5 .37624 L
s
.41761 .37624 m
.45478 .37624 L
s
.37641 .37624 m
.41761 .37624 L
s
.33522 .37624 m
.37641 .37624 L
s
.29402 .37624 m
.33522 .37624 L
s
.25282 .37624 m
.29402 .37624 L
s
.21163 .37624 m
.25282 .37624 L
s
.74718 .37624 m
.75151 .36117 L
s
.79343 .36117 m
.78837 .37624 L
s
.70598 .37624 m
.70959 .36117 L
s
.66478 .37624 m
.66767 .36117 L
s
.62359 .37624 m
.62575 .36117 L
s
.37641 .37624 m
.37425 .36117 L
s
.33522 .37624 m
.33233 .36117 L
s
.29402 .37624 m
.29041 .36117 L
s
.25282 .37624 m
.24849 .36117 L
s
.21163 .37624 m
.20657 .36117 L
s
1 .332 .137 r
.39699 .42642 m .39622 .41697 L .41422 .40554 L p F P
0 0 0 r
s
1 .334 .136 r
.39622 .41697 m .39699 .42642 L .38149 .44128 L p F P
0 0 0 r
s
.597 .179 .083 r
.60378 .41697 m .60301 .42642 L .61851 .44128 L p F P
0 0 0 r
s
.702 .21 .094 r
.60301 .42642 m .60378 .41697 L .58578 .40554 L p F P
0 0 0 r
s
.921 .272 .118 r
.54533 .37284 m .54548 .36853 L .52279 .3751 L p F P
0 0 0 r
s
.921 .272 .118 r
.52283 .37294 m .52279 .3751 L .54548 .36853 L p F P
0 0 0 r
s
1 .311 .131 r
.47717 .37294 m .47721 .3751 L .45452 .36853 L p F P
0 0 0 r
s
1 .311 .131 r
.45467 .37284 m .45452 .36853 L .47721 .3751 L p F P
0 0 0 r
s
.86 .255 .111 r
.56627 .39026 m .56659 .38403 L .54504 .38139 L p F P
0 0 0 r
s
.86 .255 .111 r
.54519 .37713 m .54504 .38139 L .56659 .38403 L p F P
0 0 0 r
s
1 .32 .134 r
.45481 .37713 m .45496 .38139 L .43341 .38403 L p F P
0 0 0 r
s
1 .32 .134 r
.43373 .39026 m .43341 .38403 L .45496 .38139 L p F P
0 0 0 r
s
1 .327 .136 r
.41422 .40554 m .41368 .39756 L .43373 .39026 L p F P
0 0 0 r
s
1 .332 .137 r
.41368 .39756 m .41422 .40554 L .39622 .41697 L p F P
0 0 0 r
s
.83 .24 .1 r
.40293 .41375 m
.42795 .40016 L
s
.40293 .41375 m
.40491 .43988 L
s
.702 .21 .094 r
.58632 .39756 m .58578 .40554 L .60378 .41697 L p F P
0 0 0 r
s
.83 .24 .1 r
.59509 .43988 m
.59707 .41375 L
s
.789 .235 .104 r
.58578 .40554 m .58632 .39756 L .56627 .39026 L p F P
0 0 0 r
s
.83 .24 .1 r
.57205 .40016 m
.59707 .41375 L
s
.921 .272 .118 r
.54548 .36853 m .54563 .36418 L .52283 .37294 L p F P
0 0 0 r
s
.921 .272 .118 r
.52287 .37077 m .52283 .37294 L .54563 .36418 L p F P
0 0 0 r
s
1 .311 .131 r
.47713 .37077 m .47717 .37294 L .45437 .36418 L p F P
0 0 0 r
s
1 .311 .131 r
.45452 .36853 m .45437 .36418 L .47717 .37294 L p F P
0 0 0 r
s
1 .327 .136 r
.43341 .38403 m .43373 .39026 L .41368 .39756 L p F P
0 0 0 r
s
.789 .235 .104 r
.56659 .38403 m .56627 .39026 L .58632 .39756 L p F P
0 0 0 r
s
.24 .35 .67 r
.75218 .64058 m
.74777 .62625 L
s
.78906 .62625 m
.79421 .64058 L
s
.74777 .62625 m
.78906 .62625 L
s
.71015 .64058 m
.70647 .62625 L
s
.70647 .62625 m
.74777 .62625 L
s
.66812 .64058 m
.66518 .62625 L
s
.66518 .62625 m
.70647 .62625 L
s
.63318 .62625 m
.66518 .62625 L
s
.62388 .62625 m
.63246 .62625 L
s
.58259 .62625 m
.62388 .62625 L
s
.54129 .62625 m
.58259 .62625 L
s
.5 .62625 m
.54129 .62625 L
s
.45871 .62625 m
.5 .62625 L
s
.41741 .62625 m
.45871 .62625 L
s
.37612 .62625 m
.41741 .62625 L
s
.33188 .64058 m
.33482 .62625 L
s
.33482 .62625 m
.36682 .62625 L
s
.36754 .62625 m
.37612 .62625 L
s
.28985 .64058 m
.29353 .62625 L
s
.29353 .62625 m
.33482 .62625 L
s
.24782 .64058 m
.25223 .62625 L
s
.25223 .62625 m
.29353 .62625 L
s
.20579 .64058 m
.21094 .62625 L
s
.21094 .62625 m
.25223 .62625 L
s
1 .33 .134 r
.36985 .46926 m .36862 .45771 L .38149 .44128 L p F P
0 0 0 r
s
1 .318 .127 r
.36862 .45771 m .36985 .46926 L .36014 .48762 L p F P
0 0 0 r
s
.83 .24 .1 r
.36779 .47772 m
.38407 .45718 L
s
.36779 .47772 m
.37049 .50248 L
s
.332 .1 .051 r
.63138 .45771 m .63015 .46926 L .63986 .48762 L p F P
0 0 0 r
s
.83 .24 .1 r
.62951 .50248 m
.63221 .47772 L
s
.465 .141 .068 r
.63015 .46926 m .63138 .45771 L .61851 .44128 L p F P
0 0 0 r
s
.83 .24 .1 r
.61593 .45718 m
.63221 .47772 L
s
.7 .195 .071 r
.35566 .58015 m .35414 .56849 L .35368 .55017 L p F P
0 0 0 r
s
.157 .045 .023 r
.35414 .56849 m .35566 .58015 L .35955 .5967 L p F P
0 0 0 r
s
.83 .24 .1 r
.35931 .59568 m
.35958 .59771 L
s
.157 .045 .023 r
.36096 .60765 m .35955 .5967 L .35566 .58015 L p F P
0 0 0 r
s
.796 .229 .086 r
.63904 .60765 m .64045 .5967 L .64434 .58015 L p F P
0 0 0 r
s
.098 .028 .012 r
.64434 .58015 m .64586 .56849 L .64632 .55017 L p F P
0 0 0 r
s
.796 .229 .086 r
.64586 .56849 m .64434 .58015 L .64045 .5967 L p F P
0 0 0 r
s
.921 .272 .118 r
.54563 .36418 m .54578 .35981 L .52287 .37077 L p F P
0 0 0 r
s
1 .311 .131 r
.45437 .36418 m .45422 .35981 L .47713 .37077 L p F P
0 0 0 r
s
.287 .433 .852 r
.47713 .37077 m .4804 .37077 L .46076 .35981 L p F P
0 0 0 r
s
.287 .433 .852 r
.46076 .35981 m .45422 .35981 L .47713 .37077 L p F P
0 0 0 r
s
.24 .35 .67 r
.45808 .36117 m
.45835 .36676 L
s
.287 .433 .852 r
.4804 .37077 m .48367 .37077 L .4673 .35981 L p F P
0 0 0 r
s
.287 .433 .852 r
.4673 .35981 m .46076 .35981 L .4804 .37077 L p F P
0 0 0 r
s
.287 .433 .852 r
.48367 .37077 m .48693 .37077 L .47384 .35981 L p F P
0 0 0 r
s
.287 .433 .852 r
.47384 .35981 m .4673 .35981 L .48367 .37077 L p F P
0 0 0 r
s
.287 .433 .852 r
.48693 .37077 m .4902 .37077 L .48038 .35981 L p F P
0 0 0 r
s
.287 .433 .852 r
.48038 .35981 m .47384 .35981 L .48693 .37077 L p F P
0 0 0 r
s
.287 .433 .852 r
.4902 .37077 m .49347 .37077 L .48692 .35981 L p F P
0 0 0 r
s
.287 .433 .852 r
.48692 .35981 m .48038 .35981 L .4902 .37077 L p F P
0 0 0 r
s
.83 .24 .1 r
.48486 .36985 m
.48504 .38615 L
s
.48473 .35871 m
.48474 .35981 L
s
.287 .433 .852 r
.49347 .37077 m .49673 .37077 L .49346 .35981 L p F P
0 0 0 r
s
.287 .433 .852 r
.49346 .35981 m .48692 .35981 L .49347 .37077 L p F P
0 0 0 r
s
.287 .433 .852 r
.49673 .37077 m .5 .37077 L .5 .35981 L p F P
0 0 0 r
s
.287 .433 .852 r
.5 .35981 m .49346 .35981 L .49673 .37077 L p F P
0 0 0 r
s
.287 .433 .852 r
.5 .37077 m .50327 .37077 L .50654 .35981 L p F P
0 0 0 r
s
.287 .433 .852 r
.50654 .35981 m .5 .35981 L .5 .37077 L p F P
0 0 0 r
s
.24 .35 .67 r
.5 .36117 m
.5 .37624 L
s
.287 .433 .852 r
.50327 .37077 m .50653 .37077 L .51308 .35981 L p F P
0 0 0 r
s
.287 .433 .852 r
.51308 .35981 m .50654 .35981 L .50327 .37077 L p F P
0 0 0 r
s
.287 .433 .852 r
.50653 .37077 m .5098 .37077 L .51962 .35981 L p F P
0 0 0 r
s
.287 .433 .852 r
.51962 .35981 m .51308 .35981 L .50653 .37077 L p F P
0 0 0 r
s
.287 .433 .852 r
.5098 .37077 m .51307 .37077 L .52616 .35981 L p F P
0 0 0 r
s
.287 .433 .852 r
.52616 .35981 m .51962 .35981 L .5098 .37077 L p F P
0 0 0 r
s
.287 .433 .852 r
.51307 .37077 m .51633 .37077 L .5327 .35981 L p F P
0 0 0 r
s
.287 .433 .852 r
.5327 .35981 m .52616 .35981 L .51307 .37077 L p F P
0 0 0 r
s
.83 .24 .1 r
.51496 .38615 m
.51514 .36985 L
s
.51526 .35981 m
.51527 .35871 L
s
.287 .433 .852 r
.51633 .37077 m .5196 .37077 L .53924 .35981 L p F P
0 0 0 r
s
.287 .433 .852 r
.53924 .35981 m .5327 .35981 L .51633 .37077 L p F P
0 0 0 r
s
.287 .433 .852 r
.5196 .37077 m .52287 .37077 L .54578 .35981 L p F P
0 0 0 r
s
.287 .433 .852 r
.54578 .35981 m .53924 .35981 L .5196 .37077 L p F P
0 0 0 r
s
.24 .35 .67 r
.54165 .36676 m
.54192 .36117 L
s
.236 .068 .036 r
.35955 .5967 m .36096 .60765 L .36818 .62152 L p F P
0 0 0 r
s
.236 .068 .036 r
.36942 .63157 m .36818 .62152 L .36096 .60765 L p F P
0 0 0 r
s
.973 .282 .11 r
.63058 .63157 m .63182 .62152 L .63904 .60765 L p F P
0 0 0 r
s
.973 .282 .11 r
.64045 .5967 m .63904 .60765 L .63182 .62152 L p F P
0 0 0 r
s
.86 .255 .111 r
.56659 .38403 m .56691 .37774 L .54519 .37713 L p F P
0 0 0 r
s
.86 .255 .111 r
.54533 .37284 m .54519 .37713 L .56691 .37774 L p F P
0 0 0 r
s
.83 .24 .1 r
.54432 .39087 m
.54526 .36346 L
s
1 .32 .134 r
.45467 .37284 m .45481 .37713 L .43309 .37774 L p F P
0 0 0 r
s
1 .32 .134 r
.43341 .38403 m .43309 .37774 L .45481 .37713 L p F P
0 0 0 r
s
.83 .24 .1 r
.45474 .36346 m
.45568 .39087 L
s
.57288 .70093 m
.59687 .68534 L
s
.59893 .66394 m
.59687 .68534 L
s
.40107 .66394 m
.40313 .68534 L
s
.40313 .68534 m
.42712 .70093 L
s
.899 .254 .097 r
.35368 .55017 m .35212 .53803 L .35515 .51889 L p F P
0 0 0 r
s
.83 .24 .1 r
.35508 .54969 m
.35804 .57301 L
s
.35508 .54969 m
.35984 .52529 L
s
.7 .195 .071 r
.35212 .53803 m .35368 .55017 L .35414 .56849 L p F P
0 0 0 r
s
.181 .052 .027 r
.64632 .55017 m .64788 .53803 L .64485 .51889 L p F P
0 0 0 r
s
.83 .24 .1 r
.64196 .57301 m
.64492 .54969 L
s
.64016 .52529 m
.64492 .54969 L
s
.098 .028 .012 r
.64788 .53803 m .64632 .55017 L .64586 .56849 L p F P
0 0 0 r
s
1 .334 .136 r
.38149 .44128 m .38047 .43053 L .39622 .41697 L p F P
0 0 0 r
s
.83 .24 .1 r
.38163 .4312 m
.38407 .45718 L
s
1 .33 .134 r
.38047 .43053 m .38149 .44128 L .36862 .45771 L p F P
0 0 0 r
s
.465 .141 .068 r
.61953 .43053 m .61851 .44128 L .63138 .45771 L p F P
0 0 0 r
s
.597 .179 .083 r
.61851 .44128 m .61953 .43053 L .60378 .41697 L p F P
0 0 0 r
s
.83 .24 .1 r
.61593 .45718 m
.61837 .4312 L
s
.124 .151 .292 r
.62018 .64196 m .60301 .64196 L .61192 .63157 L p F P
0 0 0 r
s
.124 .151 .292 r
.61192 .63157 m .63058 .63157 L .62018 .64196 L p F P
0 0 0 r
s
.124 .151 .292 r
.60301 .64196 m .58584 .64196 L .59327 .63157 L p F P
0 0 0 r
s
.124 .151 .292 r
.59327 .63157 m .61192 .63157 L .60301 .64196 L p F P
0 0 0 r
s
.124 .151 .292 r
.58584 .64196 m .56867 .64196 L .57462 .63157 L p F P
0 0 0 r
s
.124 .151 .292 r
.57462 .63157 m .59327 .63157 L .58584 .64196 L p F P
0 0 0 r
s
.24 .35 .67 r
.58259 .62625 m
.58406 .64058 L
s
.124 .151 .292 r
.56867 .64196 m .55151 .64196 L .55596 .63157 L p F P
0 0 0 r
s
.124 .151 .292 r
.55596 .63157 m .57462 .63157 L .56867 .64196 L p F P
0 0 0 r
s
.124 .151 .292 r
.55151 .64196 m .53434 .64196 L .53731 .63157 L p F P
0 0 0 r
s
.124 .151 .292 r
.53731 .63157 m .55596 .63157 L .55151 .64196 L p F P
0 0 0 r
s
.24 .35 .67 r
.54129 .62625 m
.54203 .64058 L
s
.124 .151 .292 r
.53434 .64196 m .51717 .64196 L .51865 .63157 L p F P
0 0 0 r
s
.124 .151 .292 r
.51865 .63157 m .53731 .63157 L .53434 .64196 L p F P
0 0 0 r
s
.124 .151 .292 r
.51717 .64196 m .5 .64196 L .5 .63157 L p F P
0 0 0 r
s
.124 .151 .292 r
.5 .63157 m .51865 .63157 L .51717 .64196 L p F P
0 0 0 r
s
.124 .151 .292 r
.5 .64196 m .48283 .64196 L .48135 .63157 L p F P
0 0 0 r
s
.124 .151 .292 r
.48135 .63157 m .5 .63157 L .5 .64196 L p F P
0 0 0 r
s
.24 .35 .67 r
.5 .62625 m
.5 .64058 L
s
.124 .151 .292 r
.48283 .64196 m .46566 .64196 L .46269 .63157 L p F P
0 0 0 r
s
.124 .151 .292 r
.46269 .63157 m .48135 .63157 L .48283 .64196 L p F P
0 0 0 r
s
.124 .151 .292 r
.46566 .64196 m .44849 .64196 L .44404 .63157 L p F P
0 0 0 r
s
.124 .151 .292 r
.44404 .63157 m .46269 .63157 L .46566 .64196 L p F P
0 0 0 r
s
.24 .35 .67 r
.45797 .64058 m
.45871 .62625 L
s
.124 .151 .292 r
.44849 .64196 m .43133 .64196 L .42538 .63157 L p F P
0 0 0 r
s
.124 .151 .292 r
.42538 .63157 m .44404 .63157 L .44849 .64196 L p F P
0 0 0 r
s
.124 .151 .292 r
.43133 .64196 m .41416 .64196 L .40673 .63157 L p F P
0 0 0 r
s
.124 .151 .292 r
.40673 .63157 m .42538 .63157 L .43133 .64196 L p F P
0 0 0 r
s
.24 .35 .67 r
.41594 .64058 m
.41741 .62625 L
s
.124 .151 .292 r
.41416 .64196 m .39699 .64196 L .38808 .63157 L p F P
0 0 0 r
s
.124 .151 .292 r
.38808 .63157 m .40673 .63157 L .41416 .64196 L p F P
0 0 0 r
s
.124 .151 .292 r
.39699 .64196 m .37982 .64196 L .36942 .63157 L p F P
0 0 0 r
s
.124 .151 .292 r
.36942 .63157 m .38808 .63157 L .39699 .64196 L p F P
0 0 0 r
s
.32 .095 .05 r
.36818 .62152 m .36942 .63157 L .37982 .64196 L p F P
0 0 0 r
s
.24 .35 .67 r
.375 .63349 m
.37612 .62625 L
s
1 .315 .125 r
.63182 .62152 m .63058 .63157 L .62018 .64196 L p F P
0 0 0 r
s
.24 .35 .67 r
.62388 .62625 m
.625 .63349 L
s
.83 .24 .1 r
.61859 .64431 m
.62005 .64196 L
s
.37995 .64196 m
.38141 .64431 L
s
1 .295 .116 r
.35515 .51889 m .35362 .50655 L .36014 .48762 L p F P
0 0 0 r
s
.899 .254 .097 r
.35362 .50655 m .35515 .51889 L .35212 .53803 L p F P
0 0 0 r
s
.181 .052 .027 r
.64638 .50655 m .64485 .51889 L .64788 .53803 L p F P
0 0 0 r
s
.249 .072 .039 r
.64485 .51889 m .64638 .50655 L .63986 .48762 L p F P
0 0 0 r
s
.789 .235 .104 r
.58632 .39756 m .58686 .38947 L .56659 .38403 L p F P
0 0 0 r
s
.789 .235 .104 r
.56691 .37774 m .56659 .38403 L .58686 .38947 L p F P
0 0 0 r
s
1 .327 .136 r
.43309 .37774 m .43341 .38403 L .41314 .38947 L p F P
0 0 0 r
s
1 .327 .136 r
.41368 .39756 m .41314 .38947 L .43341 .38403 L p F P
0 0 0 r
s
.86 .255 .111 r
.56691 .37774 m .56724 .37138 L .54533 .37284 L p F P
0 0 0 r
s
.86 .255 .111 r
.54548 .36853 m .54533 .37284 L .56724 .37138 L p F P
0 0 0 r
s
1 .32 .134 r
.45452 .36853 m .45467 .37284 L .43276 .37138 L p F P
0 0 0 r
s
1 .32 .134 r
.43309 .37774 m .43276 .37138 L .45467 .37284 L p F P
0 0 0 r
s
1 .332 .137 r
.39622 .41697 m .39544 .40739 L .41368 .39756 L p F P
0 0 0 r
s
1 .334 .136 r
.39544 .40739 m .39622 .41697 L .38047 .43053 L p F P
0 0 0 r
s
.597 .179 .083 r
.60456 .40739 m .60378 .41697 L .61953 .43053 L p F P
0 0 0 r
s
.702 .21 .094 r
.60378 .41697 m .60456 .40739 L .58632 .39756 L p F P
0 0 0 r
s
.702 .21 .094 r
.58686 .38947 m .58632 .39756 L .60456 .40739 L p F P
0 0 0 r
s
1 .332 .137 r
.41314 .38947 m .41368 .39756 L .39544 .40739 L p F P
0 0 0 r
s
1 .318 .127 r
.36014 .48762 m .35871 .47539 L .36862 .45771 L p F P
0 0 0 r
s
1 .295 .116 r
.35871 .47539 m .36014 .48762 L .35362 .50655 L p F P
0 0 0 r
s
.83 .24 .1 r
.35689 .50075 m
.36779 .47772 L
s
.35689 .50075 m
.35984 .52529 L
s
.249 .072 .039 r
.64129 .47539 m .63986 .48762 L .64638 .50655 L p F P
0 0 0 r
s
.83 .24 .1 r
.64016 .52529 m
.64311 .50075 L
s
.332 .1 .051 r
.63986 .48762 m .64129 .47539 L .63138 .45771 L p F P
0 0 0 r
s
.83 .24 .1 r
.63221 .47772 m
.64311 .50075 L
s
.86 .255 .111 r
.56724 .37138 m .56756 .36497 L .54548 .36853 L p F P
0 0 0 r
s
.86 .255 .111 r
.54563 .36418 m .54548 .36853 L .56756 .36497 L p F P
0 0 0 r
s
1 .32 .134 r
.45437 .36418 m .45452 .36853 L .43244 .36497 L p F P
0 0 0 r
s
1 .32 .134 r
.43276 .37138 m .43244 .36497 L .45452 .36853 L p F P
0 0 0 r
s
.83 .24 .1 r
.42556 .67971 m
.42712 .70093 L
s
.42712 .70093 m
.45475 .71183 L
s
.54525 .71183 m
.57288 .70093 L
s
.57444 .67971 m
.57288 .70093 L
s
.789 .235 .104 r
.58686 .38947 m .5874 .38129 L .56691 .37774 L p F P
0 0 0 r
s
.789 .235 .104 r
.56724 .37138 m .56691 .37774 L .5874 .38129 L p F P
0 0 0 r
s
1 .327 .136 r
.43276 .37138 m .43309 .37774 L .4126 .38129 L p F P
0 0 0 r
s
1 .327 .136 r
.41314 .38947 m .4126 .38129 L .43309 .37774 L p F P
0 0 0 r
s
1 .33 .134 r
.36862 .45771 m .36737 .44594 L .38047 .43053 L p F P
0 0 0 r
s
1 .318 .127 r
.36737 .44594 m .36862 .45771 L .35871 .47539 L p F P
0 0 0 r
s
.332 .1 .051 r
.63263 .44594 m .63138 .45771 L .64129 .47539 L p F P
0 0 0 r
s
.465 .141 .068 r
.63138 .45771 m .63263 .44594 L .61953 .43053 L p F P
0 0 0 r
s
.83 .24 .1 r
.53424 .36171 m
.54526 .36346 L
s
.51527 .35871 m
.52225 .35981 L
s
.51527 .35871 m
.48473 .35871 L
s
.45474 .36346 m
.46576 .36171 L
s
.47775 .35981 m
.48473 .35871 L
s
.86 .255 .111 r
.56756 .36497 m .56789 .35849 L .54563 .36418 L p F P
0 0 0 r
s
.86 .255 .111 r
.54578 .35981 m .54563 .36418 L .56789 .35849 L p F P
0 0 0 r
s
1 .32 .134 r
.45422 .35981 m .45437 .36418 L .43211 .35849 L p F P
0 0 0 r
s
1 .32 .134 r
.43244 .36497 m .43211 .35849 L .45437 .36418 L p F P
0 0 0 r
s
.157 .045 .023 r
.35955 .5967 m .35812 .58552 L .35414 .56849 L p F P
0 0 0 r
s
.236 .068 .036 r
.35812 .58552 m .35955 .5967 L .36692 .61128 L p F P
0 0 0 r
s
.236 .068 .036 r
.36818 .62152 m .36692 .61128 L .35955 .5967 L p F P
0 0 0 r
s
.973 .282 .11 r
.63182 .62152 m .63308 .61128 L .64045 .5967 L p F P
0 0 0 r
s
.973 .282 .11 r
.64188 .58552 m .64045 .5967 L .63308 .61128 L p F P
0 0 0 r
s
.796 .229 .086 r
.64045 .5967 m .64188 .58552 L .64586 .56849 L p F P
0 0 0 r
s
.7 .195 .071 r
.35414 .56849 m .35259 .55658 L .35212 .53803 L p F P
0 0 0 r
s
.157 .045 .023 r
.35259 .55658 m .35414 .56849 L .35812 .58552 L p F P
0 0 0 r
s
.83 .24 .1 r
.35661 .57464 m
.35778 .58375 L
s
.35508 .54969 m
.35661 .57464 L
s
.098 .028 .012 r
.64586 .56849 m .64741 .55658 L .64788 .53803 L p F P
0 0 0 r
s
.796 .229 .086 r
.64741 .55658 m .64586 .56849 L .64188 .58552 L p F P
0 0 0 r
s
.83 .24 .1 r
.64339 .57464 m
.64492 .54969 L
s
.64222 .58375 m
.64339 .57464 L
s
1 .334 .136 r
.38047 .43053 m .37943 .41959 L .39544 .40739 L p F P
0 0 0 r
s
.83 .24 .1 r
.38163 .4312 m
.40293 .41375 L
s
1 .33 .134 r
.37943 .41959 m .38047 .43053 L .36737 .44594 L p F P
0 0 0 r
s
.465 .141 .068 r
.62057 .41959 m .61953 .43053 L .63263 .44594 L p F P
0 0 0 r
s
.597 .179 .083 r
.61953 .43053 m .62057 .41959 L .60456 .40739 L p F P
0 0 0 r
s
.83 .24 .1 r
.59707 .41375 m
.61837 .4312 L
s
.702 .21 .094 r
.60456 .40739 m .60536 .39766 L .58686 .38947 L p F P
0 0 0 r
s
.702 .21 .094 r
.5874 .38129 m .58686 .38947 L .60536 .39766 L p F P
0 0 0 r
s
1 .332 .137 r
.4126 .38129 m .41314 .38947 L .39464 .39766 L p F P
0 0 0 r
s
1 .332 .137 r
.39544 .40739 m .39464 .39766 L .41314 .38947 L p F P
0 0 0 r
s
1 .334 .136 r
.39464 .39766 m .39544 .40739 L .37943 .41959 L p F P
0 0 0 r
s
.597 .179 .083 r
.60536 .39766 m .60456 .40739 L .62057 .41959 L p F P
0 0 0 r
s
.899 .254 .097 r
.35212 .53803 m .35053 .52562 L .35362 .50655 L p F P
0 0 0 r
s
.7 .195 .071 r
.35053 .52562 m .35212 .53803 L .35259 .55658 L p F P
0 0 0 r
s
.181 .052 .027 r
.64788 .53803 m .64947 .52562 L .64638 .50655 L p F P
0 0 0 r
s
.098 .028 .012 r
.64947 .52562 m .64788 .53803 L .64741 .55658 L p F P
0 0 0 r
s
.83 .24 .1 r
.45377 .69075 m
.45475 .71183 L
s
.45475 .71183 m
.48466 .71745 L
s
.51534 .71745 m
.54525 .71183 L
s
.54623 .69075 m
.54525 .71183 L
s
.32 .095 .05 r
.36692 .61128 m .36818 .62152 L .37877 .63281 L p F P
0 0 0 r
s
.32 .095 .05 r
.37982 .64196 m .37877 .63281 L .36818 .62152 L p F P
0 0 0 r
s
.24 .35 .67 r
.37391 .64058 m
.37464 .63583 L
s
1 .315 .125 r
.62018 .64196 m .62123 .63281 L .63182 .62152 L p F P
0 0 0 r
s
.24 .35 .67 r
.62536 .63583 m
.62609 .64058 L
s
1 .315 .125 r
.63308 .61128 m .63182 .62152 L .62123 .63281 L p F P
0 0 0 r
s
.83 .24 .1 r
.61859 .64431 m
.61885 .64196 L
s
.38115 .64196 m
.38141 .64431 L
s
.789 .235 .104 r
.5874 .38129 m .58796 .37299 L .56724 .37138 L p F P
0 0 0 r
s
.789 .235 .104 r
.56756 .36497 m .56724 .37138 L .58796 .37299 L p F P
0 0 0 r
s
.83 .24 .1 r
.57205 .40016 m
.57358 .37282 L
s
.24 .35 .67 r
.58289 .371 m
.58384 .36117 L
s
.83 .24 .1 r
.54526 .36346 m
.57358 .37282 L
s
1 .327 .136 r
.43244 .36497 m .43276 .37138 L .41204 .37299 L p F P
0 0 0 r
s
.24 .35 .67 r
.41616 .36117 m
.41711 .371 L
s
.41726 .37259 m
.41761 .37624 L
s
1 .327 .136 r
.4126 .38129 m .41204 .37299 L .43276 .37138 L p F P
0 0 0 r
s
.83 .24 .1 r
.42642 .37282 m
.42795 .40016 L
s
.42642 .37282 m
.45474 .36346 L
s
.86 .255 .111 r
.56789 .35849 m .56823 .35194 L .54578 .35981 L p F P
0 0 0 r
s
1 .32 .134 r
.43211 .35849 m .43177 .35194 L .45422 .35981 L p F P
0 0 0 r
s
.274 .422 .83 r
.45422 .35981 m .46076 .35981 L .44152 .35194 L p F P
0 0 0 r
s
.274 .422 .83 r
.44152 .35194 m .43177 .35194 L .45422 .35981 L p F P
0 0 0 r
s
.274 .422 .83 r
.46076 .35981 m .4673 .35981 L .45127 .35194 L p F P
0 0 0 r
s
.274 .422 .83 r
.45127 .35194 m .44152 .35194 L .46076 .35981 L p F P
0 0 0 r
s
.274 .422 .83 r
.4673 .35981 m .47384 .35981 L .46101 .35194 L p F P
0 0 0 r
s
.274 .422 .83 r
.46101 .35194 m .45127 .35194 L .4673 .35981 L p F P
0 0 0 r
s
.83 .24 .1 r
.45457 .35858 m
.45474 .36346 L
s
.274 .422 .83 r
.47384 .35981 m .48038 .35981 L .47076 .35194 L p F P
0 0 0 r
s
.274 .422 .83 r
.47076 .35194 m .46101 .35194 L .47384 .35981 L p F P
0 0 0 r
s
.274 .422 .83 r
.48038 .35981 m .48692 .35981 L .48051 .35194 L p F P
0 0 0 r
s
.274 .422 .83 r
.48051 .35194 m .47076 .35194 L .48038 .35981 L p F P
0 0 0 r
s
.274 .422 .83 r
.48692 .35981 m .49346 .35981 L .49025 .35194 L p F P
0 0 0 r
s
.274 .422 .83 r
.49025 .35194 m .48051 .35194 L .48692 .35981 L p F P
0 0 0 r
s
.274 .422 .83 r
.49346 .35981 m .5 .35981 L .5 .35194 L p F P
0 0 0 r
s
.274 .422 .83 r
.5 .35194 m .49025 .35194 L .49346 .35981 L p F P
0 0 0 r
s
.274 .422 .83 r
.5 .35981 m .50654 .35981 L .50975 .35194 L p F P
0 0 0 r
s
.274 .422 .83 r
.50975 .35194 m .5 .35194 L .5 .35981 L p F P
0 0 0 r
s
.274 .422 .83 r
.50654 .35981 m .51308 .35981 L .51949 .35194 L p F P
0 0 0 r
s
.83 .24 .1 r
.51527 .35871 m
.51529 .3571 L
s
.274 .422 .83 r
.51949 .35194 m .50975 .35194 L .50654 .35981 L p F P
0 0 0 r
s
.274 .422 .83 r
.51308 .35981 m .51962 .35981 L .52924 .35194 L p F P
0 0 0 r
s
.274 .422 .83 r
.52924 .35194 m .51949 .35194 L .51308 .35981 L p F P
0 0 0 r
s
.274 .422 .83 r
.51962 .35981 m .52616 .35981 L .53899 .35194 L p F P
0 0 0 r
s
.274 .422 .83 r
.53899 .35194 m .52924 .35194 L .51962 .35981 L p F P
0 0 0 r
s
.274 .422 .83 r
.52616 .35981 m .5327 .35981 L .54873 .35194 L p F P
0 0 0 r
s
.274 .422 .83 r
.54873 .35194 m .53899 .35194 L .52616 .35981 L p F P
0 0 0 r
s
.274 .422 .83 r
.5327 .35981 m .53924 .35981 L .55848 .35194 L p F P
0 0 0 r
s
.274 .422 .83 r
.55848 .35194 m .54873 .35194 L .5327 .35981 L p F P
0 0 0 r
s
.274 .422 .83 r
.53924 .35981 m .54578 .35981 L .56823 .35194 L p F P
0 0 0 r
s
.274 .422 .83 r
.56823 .35194 m .55848 .35194 L .53924 .35981 L p F P
0 0 0 r
s
.83 .24 .1 r
.54526 .36346 m
.54543 .35858 L
s
.24 .35 .67 r
.75151 .36117 m
.79343 .36117 L
s
.70959 .36117 m
.75151 .36117 L
s
.66767 .36117 m
.70959 .36117 L
s
.62575 .36117 m
.66767 .36117 L
s
.58384 .36117 m
.62575 .36117 L
s
.54192 .36117 m
.5492 .36117 L
s
.56776 .36117 m
.58384 .36117 L
s
.5 .36117 m
.54192 .36117 L
s
.45808 .36117 m
.5 .36117 L
s
.4508 .36117 m
.45808 .36117 L
s
.41616 .36117 m
.43224 .36117 L
s
.37425 .36117 m
.41616 .36117 L
s
.33233 .36117 m
.37425 .36117 L
s
.29041 .36117 m
.33233 .36117 L
s
.24849 .36117 m
.29041 .36117 L
s
.20657 .36117 m
.24849 .36117 L
s
.75151 .36117 m
.75633 .35155 L
s
.79906 .35155 m
.79343 .36117 L
s
.70959 .36117 m
.71361 .35155 L
s
.66767 .36117 m
.67089 .35155 L
s
.62575 .36117 m
.62817 .35155 L
s
.37425 .36117 m
.37183 .35155 L
s
.33233 .36117 m
.32911 .35155 L
s
.29041 .36117 m
.28639 .35155 L
s
.24849 .36117 m
.24367 .35155 L
s
.20657 .36117 m
.20094 .35155 L
s
1 .295 .116 r
.35362 .50655 m .35206 .49394 L .35871 .47539 L p F P
0 0 0 r
s
.899 .254 .097 r
.35206 .49394 m .35362 .50655 L .35053 .52562 L p F P
0 0 0 r
s
.181 .052 .027 r
.64794 .49394 m .64638 .50655 L .64947 .52562 L p F P
0 0 0 r
s
.249 .072 .039 r
.64638 .50655 m .64794 .49394 L .64129 .47539 L p F P
0 0 0 r
s
.83 .24 .1 r
.48432 .69643 m
.48466 .71745 L
s
.48466 .71745 m
.51534 .71745 L
s
.51568 .69643 m
.51534 .71745 L
s
.088 .1 .192 r
.60657 .64919 m .59134 .64919 L .60301 .64196 L p F P
0 0 0 r
s
.088 .1 .192 r
.60301 .64196 m .62018 .64196 L .60657 .64919 L p F P
0 0 0 r
s
.088 .1 .192 r
.59134 .64919 m .57612 .64919 L .58584 .64196 L p F P
0 0 0 r
s
.088 .1 .192 r
.58584 .64196 m .60301 .64196 L .59134 .64919 L p F P
0 0 0 r
s
.088 .1 .192 r
.57612 .64919 m .5609 .64919 L .56867 .64196 L p F P
0 0 0 r
s
.088 .1 .192 r
.56867 .64196 m .58584 .64196 L .57612 .64919 L p F P
0 0 0 r
s
.088 .1 .192 r
.5609 .64919 m .54567 .64919 L .55151 .64196 L p F P
0 0 0 r
s
.088 .1 .192 r
.55151 .64196 m .56867 .64196 L .5609 .64919 L p F P
0 0 0 r
s
.088 .1 .192 r
.54567 .64919 m .53045 .64919 L .53434 .64196 L p F P
0 0 0 r
s
.088 .1 .192 r
.53434 .64196 m .55151 .64196 L .54567 .64919 L p F P
0 0 0 r
s
.088 .1 .192 r
.53045 .64919 m .51522 .64919 L .51717 .64196 L p F P
0 0 0 r
s
.088 .1 .192 r
.51717 .64196 m .53434 .64196 L .53045 .64919 L p F P
0 0 0 r
s
.088 .1 .192 r
.51522 .64919 m .5 .64919 L .5 .64196 L p F P
0 0 0 r
s
.088 .1 .192 r
.5 .64196 m .51717 .64196 L .51522 .64919 L p F P
0 0 0 r
s
.088 .1 .192 r
.5 .64919 m .48478 .64919 L .48283 .64196 L p F P
0 0 0 r
s
.088 .1 .192 r
.48283 .64196 m .5 .64196 L .5 .64919 L p F P
0 0 0 r
s
.088 .1 .192 r
.48478 .64919 m .46955 .64919 L .46566 .64196 L p F P
0 0 0 r
s
.088 .1 .192 r
.46566 .64196 m .48283 .64196 L .48478 .64919 L p F P
0 0 0 r
s
.088 .1 .192 r
.46955 .64919 m .45433 .64919 L .44849 .64196 L p F P
0 0 0 r
s
.088 .1 .192 r
.44849 .64196 m .46566 .64196 L .46955 .64919 L p F P
0 0 0 r
s
.088 .1 .192 r
.45433 .64919 m .4391 .64919 L .43133 .64196 L p F P
0 0 0 r
s
.088 .1 .192 r
.43133 .64196 m .44849 .64196 L .45433 .64919 L p F P
0 0 0 r
s
.088 .1 .192 r
.4391 .64919 m .42388 .64919 L .41416 .64196 L p F P
0 0 0 r
s
.088 .1 .192 r
.41416 .64196 m .43133 .64196 L .4391 .64919 L p F P
0 0 0 r
s
.088 .1 .192 r
.42388 .64919 m .40866 .64919 L .39699 .64196 L p F P
0 0 0 r
s
.088 .1 .192 r
.39699 .64196 m .41416 .64196 L .42388 .64919 L p F P
0 0 0 r
s
.088 .1 .192 r
.40866 .64919 m .39343 .64919 L .37982 .64196 L p F P
0 0 0 r
s
.088 .1 .192 r
.37982 .64196 m .39699 .64196 L .40866 .64919 L p F P
0 0 0 r
s
.43 .135 .065 r
.37877 .63281 m .37982 .64196 L .39343 .64919 L p F P
0 0 0 r
s
.83 .24 .1 r
.38141 .64431 m
.40107 .66394 L
s
1 .333 .134 r
.62123 .63281 m .62018 .64196 L .60657 .64919 L p F P
0 0 0 r
s
.83 .24 .1 r
.59893 .66394 m
.61859 .64431 L
s
1 .318 .127 r
.35871 .47539 m .35726 .4629 L .36737 .44594 L p F P
0 0 0 r
s
1 .295 .116 r
.35726 .4629 m .35871 .47539 L .35206 .49394 L p F P
0 0 0 r
s
.249 .072 .039 r
.64274 .4629 m .64129 .47539 L .64794 .49394 L p F P
0 0 0 r
s
.332 .1 .051 r
.64129 .47539 m .64274 .4629 L .63263 .44594 L p F P
0 0 0 r
s
.24 .35 .67 r
.75706 .64935 m
.75218 .64058 L
s
.79421 .64058 m
.79991 .64935 L
s
.75218 .64058 m
.79421 .64058 L
s
.71422 .64935 m
.71015 .64058 L
s
.71015 .64058 m
.75218 .64058 L
s
.67138 .64935 m
.66812 .64058 L
s
.66812 .64058 m
.71015 .64058 L
s
.62609 .64058 m
.62853 .64935 L
s
.62609 .64058 m
.66812 .64058 L
s
.62096 .64058 m
.62609 .64058 L
s
.62075 .64058 m
.62096 .64058 L
s
.58406 .64058 m
.61427 .64058 L
s
.54203 .64058 m
.58406 .64058 L
s
.5 .64058 m
.54203 .64058 L
s
.45797 .64058 m
.5 .64058 L
s
.41594 .64058 m
.45797 .64058 L
s
.37147 .64935 m
.37391 .64058 L
s
.37391 .64058 m
.37904 .64058 L
s
.37904 .64058 m
.37925 .64058 L
s
.38573 .64058 m
.41594 .64058 L
s
.32862 .64935 m
.33188 .64058 L
s
.33188 .64058 m
.37391 .64058 L
s
.28578 .64935 m
.28985 .64058 L
s
.28985 .64058 m
.33188 .64058 L
s
.24294 .64935 m
.24782 .64058 L
s
.24782 .64058 m
.28985 .64058 L
s
.20009 .64935 m
.20579 .64058 L
s
.20579 .64058 m
.24782 .64058 L
s
.702 .21 .094 r
.60536 .39766 m .60616 .38777 L .5874 .38129 L p F P
0 0 0 r
s
.702 .21 .094 r
.58796 .37299 m .5874 .38129 L .60616 .38777 L p F P
0 0 0 r
s
1 .332 .137 r
.41204 .37299 m .4126 .38129 L .39384 .38777 L p F P
0 0 0 r
s
1 .332 .137 r
.39464 .39766 m .39384 .38777 L .4126 .38129 L p F P
0 0 0 r
s
.789 .235 .104 r
.58796 .37299 m .58852 .3646 L .56756 .36497 L p F P
0 0 0 r
s
.789 .235 .104 r
.56789 .35849 m .56756 .36497 L .58852 .3646 L p F P
0 0 0 r
s
1 .327 .136 r
.43211 .35849 m .43244 .36497 L .41148 .3646 L p F P
0 0 0 r
s
1 .327 .136 r
.41204 .37299 m .41148 .3646 L .43244 .36497 L p F P
0 0 0 r
s
1 .33 .134 r
.36737 .44594 m .36609 .43394 L .37943 .41959 L p F P
0 0 0 r
s
1 .318 .127 r
.36609 .43394 m .36737 .44594 L .35726 .4629 L p F P
0 0 0 r
s
.83 .24 .1 r
.36498 .45191 m
.36779 .47772 L
s
.332 .1 .051 r
.63391 .43394 m .63263 .44594 L .64274 .4629 L p F P
0 0 0 r
s
.83 .24 .1 r
.63221 .47772 m
.63502 .45191 L
s
.465 .141 .068 r
.63263 .44594 m .63391 .43394 L .62057 .41959 L p F P
0 0 0 r
s
.597 .179 .083 r
.62057 .41959 m .62162 .40846 L .60536 .39766 L p F P
0 0 0 r
s
.597 .179 .083 r
.60616 .38777 m .60536 .39766 L .62162 .40846 L p F P
0 0 0 r
s
1 .334 .136 r
.39384 .38777 m .39464 .39766 L .37838 .40846 L p F P
0 0 0 r
s
1 .334 .136 r
.37943 .41959 m .37838 .40846 L .39464 .39766 L p F P
0 0 0 r
s
1 .33 .134 r
.37838 .40846 m .37943 .41959 L .36609 .43394 L p F P
0 0 0 r
s
.83 .24 .1 r
.36498 .45191 m
.38163 .4312 L
s
.465 .141 .068 r
.62162 .40846 m .62057 .41959 L .63391 .43394 L p F P
0 0 0 r
s
.83 .24 .1 r
.61837 .4312 m
.63502 .45191 L
s
.157 .045 .023 r
.35812 .58552 m .35666 .57412 L .35259 .55658 L p F P
0 0 0 r
s
.236 .068 .036 r
.35666 .57412 m .35812 .58552 L .36563 .60084 L p F P
0 0 0 r
s
.236 .068 .036 r
.36692 .61128 m .36563 .60084 L .35812 .58552 L p F P
0 0 0 r
s
.973 .282 .11 r
.63308 .61128 m .63437 .60084 L .64188 .58552 L p F P
0 0 0 r
s
.973 .282 .11 r
.64334 .57412 m .64188 .58552 L .63437 .60084 L p F P
0 0 0 r
s
.83 .24 .1 r
.6432 .57521 m
.64339 .57464 L
s
.796 .229 .086 r
.64188 .58552 m .64334 .57412 L .64741 .55658 L p F P
0 0 0 r
s
.7 .195 .071 r
.35259 .55658 m .35101 .54442 L .35053 .52562 L p F P
0 0 0 r
s
.157 .045 .023 r
.35101 .54442 m .35259 .55658 L .35666 .57412 L p F P
0 0 0 r
s
.098 .028 .012 r
.64741 .55658 m .64899 .54442 L .64947 .52562 L p F P
0 0 0 r
s
.796 .229 .086 r
.64899 .54442 m .64741 .55658 L .64334 .57412 L p F P
0 0 0 r
s
.83 .24 .1 r
.57444 .67971 m
.59893 .66394 L
s
.40107 .66394 m
.42556 .67971 L
s
.32 .095 .05 r
.36563 .60084 m .36692 .61128 L .3777 .62349 L p F P
0 0 0 r
s
.32 .095 .05 r
.37877 .63281 m .3777 .62349 L .36692 .61128 L p F P
0 0 0 r
s
1 .315 .125 r
.62123 .63281 m .6223 .62349 L .63308 .61128 L p F P
0 0 0 r
s
1 .315 .125 r
.63437 .60084 m .63308 .61128 L .6223 .62349 L p F P
0 0 0 r
s
.899 .254 .097 r
.35053 .52562 m .3489 .51295 L .35206 .49394 L p F P
0 0 0 r
s
.83 .24 .1 r
.35199 .52537 m
.35508 .54969 L
s
.35199 .52537 m
.35689 .50075 L
s
.7 .195 .071 r
.3489 .51295 m .35053 .52562 L .35101 .54442 L p F P
0 0 0 r
s
.181 .052 .027 r
.64947 .52562 m .6511 .51295 L .64794 .49394 L p F P
0 0 0 r
s
.83 .24 .1 r
.64492 .54969 m
.64801 .52537 L
s
.64311 .50075 m
.64801 .52537 L
s
.098 .028 .012 r
.6511 .51295 m .64947 .52562 L .64899 .54442 L p F P
0 0 0 r
s
.789 .235 .104 r
.58852 .3646 m .58908 .35609 L .56789 .35849 L p F P
0 0 0 r
s
.789 .235 .104 r
.56823 .35194 m .56789 .35849 L .58908 .35609 L p F P
0 0 0 r
s
1 .327 .136 r
.43177 .35194 m .43211 .35849 L .41092 .35609 L p F P
0 0 0 r
s
.24 .35 .67 r
.4154 .3566 m
.41616 .36117 L
s
1 .327 .136 r
.41148 .3646 m .41092 .35609 L .43211 .35849 L p F P
0 0 0 r
s
.702 .21 .094 r
.60616 .38777 m .60698 .37774 L .58796 .37299 L p F P
0 0 0 r
s
.83 .24 .1 r
.59707 .41375 m
.59914 .38651 L
s
.702 .21 .094 r
.58852 .3646 m .58796 .37299 L .60698 .37774 L p F P
0 0 0 r
s
.83 .24 .1 r
.57358 .37282 m
.59914 .38651 L
s
1 .332 .137 r
.41148 .3646 m .41204 .37299 L .39302 .37774 L p F P
0 0 0 r
s
1 .332 .137 r
.39384 .38777 m .39302 .37774 L .41204 .37299 L p F P
0 0 0 r
s
.83 .24 .1 r
.40086 .38651 m
.42642 .37282 L
s
.40086 .38651 m
.40293 .41375 L
s
1 .295 .116 r
.35206 .49394 m .35047 .48105 L .35726 .4629 L p F P
0 0 0 r
s
.899 .254 .097 r
.35047 .48105 m .35206 .49394 L .3489 .51295 L p F P
0 0 0 r
s
.181 .052 .027 r
.64953 .48105 m .64794 .49394 L .6511 .51295 L p F P
0 0 0 r
s
.249 .072 .039 r
.64794 .49394 m .64953 .48105 L .64274 .4629 L p F P
0 0 0 r
s
.43 .135 .065 r
.3777 .62349 m .37877 .63281 L .39261 .64114 L p F P
0 0 0 r
s
.83 .24 .1 r
.38021 .63367 m
.3803 .63452 L
s
.43 .135 .065 r
.39343 .64919 m .39261 .64114 L .37877 .63281 L p F P
0 0 0 r
s
1 .333 .134 r
.60657 .64919 m .60739 .64114 L .62123 .63281 L p F P
0 0 0 r
s
1 .333 .134 r
.6223 .62349 m .62123 .63281 L .60739 .64114 L p F P
0 0 0 r
s
1 .318 .127 r
.35726 .4629 m .35578 .45015 L .36609 .43394 L p F P
0 0 0 r
s
1 .295 .116 r
.35578 .45015 m .35726 .4629 L .35047 .48105 L p F P
0 0 0 r
s
.83 .24 .1 r
.35381 .47514 m
.36498 .45191 L
s
.35381 .47514 m
.35689 .50075 L
s
.249 .072 .039 r
.64422 .45015 m .64274 .4629 L .64953 .48105 L p F P
0 0 0 r
s
.83 .24 .1 r
.64311 .50075 m
.64619 .47514 L
s
.332 .1 .051 r
.64274 .4629 m .64422 .45015 L .63391 .43394 L p F P
0 0 0 r
s
.83 .24 .1 r
.63502 .45191 m
.64619 .47514 L
s
.597 .179 .083 r
.62162 .40846 m .6227 .39713 L .60616 .38777 L p F P
0 0 0 r
s
.83 .24 .1 r
.61837 .4312 m
.62092 .40409 L
s
.597 .179 .083 r
.60698 .37774 m .60616 .38777 L .6227 .39713 L p F P
0 0 0 r
s
.83 .24 .1 r
.59914 .38651 m
.62092 .40409 L
s
1 .334 .136 r
.39302 .37774 m .39384 .38777 L .3773 .39713 L p F P
0 0 0 r
s
1 .334 .136 r
.37838 .40846 m .3773 .39713 L .39384 .38777 L p F P
0 0 0 r
s
.83 .24 .1 r
.37908 .40409 m
.40086 .38651 L
s
.37908 .40409 m
.38163 .4312 L
s
.789 .235 .104 r
.58908 .35609 m .58966 .34748 L .56823 .35194 L p F P
0 0 0 r
s
1 .327 .136 r
.41092 .35609 m .41034 .34748 L .43177 .35194 L p F P
0 0 0 r
s
.24 .38 .748 r
.43177 .35194 m .44152 .35194 L .42315 .34748 L p F P
0 0 0 r
s
.24 .38 .748 r
.42315 .34748 m .41034 .34748 L .43177 .35194 L p F P
0 0 0 r
s
.24 .38 .748 r
.44152 .35194 m .45127 .35194 L .43596 .34748 L p F P
0 0 0 r
s
.24 .38 .748 r
.43596 .34748 m .42315 .34748 L .44152 .35194 L p F P
0 0 0 r
s
.83 .24 .1 r
.42516 .35013 m
.42642 .37282 L
s
.42483 .3443 m
.42501 .34748 L
s
.24 .38 .748 r
.45127 .35194 m .46101 .35194 L .44877 .34748 L p F P
0 0 0 r
s
.24 .38 .748 r
.44877 .34748 m .43596 .34748 L .45127 .35194 L p F P
0 0 0 r
s
.24 .38 .748 r
.46101 .35194 m .47076 .35194 L .46157 .34748 L p F P
0 0 0 r
s
.24 .38 .748 r
.46157 .34748 m .44877 .34748 L .46101 .35194 L p F P
0 0 0 r
s
.83 .24 .1 r
.45377 .33487 m
.4542 .34748 L
s
.24 .35 .67 r
.45728 .35155 m
.45808 .36117 L
s
.24 .38 .748 r
.47076 .35194 m .48051 .35194 L .47438 .34748 L p F P
0 0 0 r
s
.24 .38 .748 r
.47438 .34748 m .46157 .34748 L .47076 .35194 L p F P
0 0 0 r
s
.24 .38 .748 r
.48051 .35194 m .49025 .35194 L .48719 .34748 L p F P
0 0 0 r
s
.24 .38 .748 r
.48719 .34748 m .47438 .34748 L .48051 .35194 L p F P
0 0 0 r
s
.83 .24 .1 r
.4844 .33009 m
.4846 .34748 L
s
.24 .38 .748 r
.49025 .35194 m .5 .35194 L .5 .34748 L p F P
0 0 0 r
s
.24 .38 .748 r
.5 .34748 m .48719 .34748 L .49025 .35194 L p F P
0 0 0 r
s
.24 .38 .748 r
.5 .35194 m .50975 .35194 L .51281 .34748 L p F P
0 0 0 r
s
.24 .38 .748 r
.51281 .34748 m .5 .34748 L .5 .35194 L p F P
0 0 0 r
s
.24 .35 .67 r
.5 .35155 m
.5 .36117 L
s
.24 .38 .748 r
.50975 .35194 m .51949 .35194 L .52562 .34748 L p F P
0 0 0 r
s
.24 .38 .748 r
.52562 .34748 m .51281 .34748 L .50975 .35194 L p F P
0 0 0 r
s
.83 .24 .1 r
.5154 .34748 m
.5156 .33009 L
s
.24 .38 .748 r
.51949 .35194 m .52924 .35194 L .53843 .34748 L p F P
0 0 0 r
s
.24 .38 .748 r
.53843 .34748 m .52562 .34748 L .51949 .35194 L p F P
0 0 0 r
s
.24 .38 .748 r
.52924 .35194 m .53899 .35194 L .55123 .34748 L p F P
0 0 0 r
s
.83 .24 .1 r
.54565 .35194 m
.54574 .34948 L
s
.24 .38 .748 r
.55123 .34748 m .53843 .34748 L .52924 .35194 L p F P
0 0 0 r
s
.24 .38 .748 r
.53899 .35194 m .54873 .35194 L .56404 .34748 L p F P
0 0 0 r
s
.24 .38 .748 r
.56404 .34748 m .55123 .34748 L .53899 .35194 L p F P
0 0 0 r
s
.83 .24 .1 r
.5458 .34748 m
.54623 .33487 L
s
.24 .35 .67 r
.54192 .36117 m
.54272 .35155 L
s
.24 .38 .748 r
.54873 .35194 m .55848 .35194 L .57685 .34748 L p F P
0 0 0 r
s
.24 .38 .748 r
.57685 .34748 m .56404 .34748 L .54873 .35194 L p F P
0 0 0 r
s
.24 .38 .748 r
.55848 .35194 m .56823 .35194 L .58966 .34748 L p F P
0 0 0 r
s
.24 .38 .748 r
.58966 .34748 m .57685 .34748 L .55848 .35194 L p F P
0 0 0 r
s
.83 .24 .1 r
.57499 .34748 m
.57517 .3443 L
s
.57358 .37282 m
.57484 .35013 L
s
1 .33 .134 r
.36609 .43394 m .36478 .4217 L .37838 .40846 L p F P
0 0 0 r
s
1 .318 .127 r
.36478 .4217 m .36609 .43394 L .35578 .45015 L p F P
0 0 0 r
s
.332 .1 .051 r
.63522 .4217 m .63391 .43394 L .64422 .45015 L p F P
0 0 0 r
s
.465 .141 .068 r
.63391 .43394 m .63522 .4217 L .62162 .40846 L p F P
0 0 0 r
s
1 .33 .134 r
.3773 .39713 m .37838 .40846 L .36478 .4217 L p F P
0 0 0 r
s
.465 .141 .068 r
.6227 .39713 m .62162 .40846 L .63522 .4217 L p F P
0 0 0 r
s
.83 .24 .1 r
.42393 .65756 m
.42556 .67971 L
s
.42556 .67971 m
.45377 .69075 L
s
.54623 .69075 m
.57444 .67971 L
s
.57607 .65756 m
.57444 .67971 L
s
.702 .21 .094 r
.60698 .37774 m .60781 .36755 L .58852 .3646 L p F P
0 0 0 r
s
.702 .21 .094 r
.58908 .35609 m .58852 .3646 L .60781 .36755 L p F P
0 0 0 r
s
1 .332 .137 r
.41092 .35609 m .41148 .3646 L .39219 .36755 L p F P
0 0 0 r
s
1 .332 .137 r
.39302 .37774 m .39219 .36755 L .41148 .3646 L p F P
0 0 0 r
s
.062 .074 .141 r
.58992 .65296 m .57708 .65296 L .59134 .64919 L p F P
0 0 0 r
s
.062 .074 .141 r
.59134 .64919 m .60657 .64919 L .58992 .65296 L p F P
0 0 0 r
s
.062 .074 .141 r
.57708 .65296 m .56423 .65296 L .57612 .64919 L p F P
0 0 0 r
s
.062 .074 .141 r
.57612 .64919 m .59134 .64919 L .57708 .65296 L p F P
0 0 0 r
s
.24 .35 .67 r
.58406 .64058 m
.58569 .64935 L
s
.062 .074 .141 r
.56423 .65296 m .55138 .65296 L .5609 .64919 L p F P
0 0 0 r
s
.062 .074 .141 r
.5609 .64919 m .57612 .64919 L .56423 .65296 L p F P
0 0 0 r
s
.062 .074 .141 r
.55138 .65296 m .53854 .65296 L .54567 .64919 L p F P
0 0 0 r
s
.062 .074 .141 r
.54567 .64919 m .5609 .64919 L .55138 .65296 L p F P
0 0 0 r
s
.062 .074 .141 r
.53854 .65296 m .52569 .65296 L .53045 .64919 L p F P
0 0 0 r
s
.062 .074 .141 r
.53045 .64919 m .54567 .64919 L .53854 .65296 L p F P
0 0 0 r
s
.24 .35 .67 r
.54203 .64058 m
.54284 .64935 L
s
.062 .074 .141 r
.52569 .65296 m .51285 .65296 L .51522 .64919 L p F P
0 0 0 r
s
.062 .074 .141 r
.51522 .64919 m .53045 .64919 L .52569 .65296 L p F P
0 0 0 r
s
.062 .074 .141 r
.51285 .65296 m .5 .65296 L .5 .64919 L p F P
0 0 0 r
s
.062 .074 .141 r
.5 .64919 m .51522 .64919 L .51285 .65296 L p F P
0 0 0 r
s
.062 .074 .141 r
.5 .65296 m .48715 .65296 L .48478 .64919 L p F P
0 0 0 r
s
.062 .074 .141 r
.48478 .64919 m .5 .64919 L .5 .65296 L p F P
0 0 0 r
s
.24 .35 .67 r
.5 .64058 m
.5 .64935 L
s
.062 .074 .141 r
.48715 .65296 m .47431 .65296 L .46955 .64919 L p F P
0 0 0 r
s
.062 .074 .141 r
.46955 .64919 m .48478 .64919 L .48715 .65296 L p F P
0 0 0 r
s
.062 .074 .141 r
.47431 .65296 m .46146 .65296 L .45433 .64919 L p F P
0 0 0 r
s
.062 .074 .141 r
.45433 .64919 m .46955 .64919 L .47431 .65296 L p F P
0 0 0 r
s
.062 .074 .141 r
.46146 .65296 m .44862 .65296 L .4391 .64919 L p F P
0 0 0 r
s
.062 .074 .141 r
.4391 .64919 m .45433 .64919 L .46146 .65296 L p F P
0 0 0 r
s
.24 .35 .67 r
.45716 .64935 m
.45797 .64058 L
s
.062 .074 .141 r
.44862 .65296 m .43577 .65296 L .42388 .64919 L p F P
0 0 0 r
s
.062 .074 .141 r
.42388 .64919 m .4391 .64919 L .44862 .65296 L p F P
0 0 0 r
s
.062 .074 .141 r
.43577 .65296 m .42292 .65296 L .40866 .64919 L p F P
0 0 0 r
s
.062 .074 .141 r
.40866 .64919 m .42388 .64919 L .43577 .65296 L p F P
0 0 0 r
s
.062 .074 .141 r
.42292 .65296 m .41008 .65296 L .39343 .64919 L p F P
0 0 0 r
s
.062 .074 .141 r
.39343 .64919 m .40866 .64919 L .42292 .65296 L p F P
0 0 0 r
s
.24 .35 .67 r
.41431 .64935 m
.41594 .64058 L
s
.583 .18 .083 r
.39261 .64114 m .39343 .64919 L .41008 .65296 L p F P
0 0 0 r
s
.83 .24 .1 r
.39982 .65096 m
.40107 .66394 L
s
.39978 .65063 m
.39982 .65096 L
s
1 .338 .138 r
.60739 .64114 m .60657 .64919 L .58992 .65296 L p F P
0 0 0 r
s
.83 .24 .1 r
.60018 .65096 m
.60022 .65063 L
s
.59893 .66394 m
.60018 .65096 L
s
.157 .045 .023 r
.35666 .57412 m .35516 .56248 L .35101 .54442 L p F P
0 0 0 r
s
.236 .068 .036 r
.35516 .56248 m .35666 .57412 L .36432 .59019 L p F P
0 0 0 r
s
.236 .068 .036 r
.36563 .60084 m .36432 .59019 L .35666 .57412 L p F P
0 0 0 r
s
.973 .282 .11 r
.63437 .60084 m .63568 .59019 L .64334 .57412 L p F P
0 0 0 r
s
.973 .282 .11 r
.64484 .56248 m .64334 .57412 L .63568 .59019 L p F P
0 0 0 r
s
.796 .229 .086 r
.64334 .57412 m .64484 .56248 L .64899 .54442 L p F P
0 0 0 r
s
.83 .24 .1 r
.54623 .33487 m
.5156 .33009 L
s
.51594 .30021 m
.5156 .33009 L
s
.5156 .33009 m
.4844 .33009 L
s
.48406 .30021 m
.4844 .33009 L
s
.4844 .33009 m
.45377 .33487 L
s
.32 .095 .05 r
.36432 .59019 m .36563 .60084 L .37662 .61402 L p F P
0 0 0 r
s
.32 .095 .05 r
.3777 .62349 m .37662 .61402 L .36563 .60084 L p F P
0 0 0 r
s
1 .315 .125 r
.6223 .62349 m .62338 .61402 L .63437 .60084 L p F P
0 0 0 r
s
.83 .24 .1 r
.63404 .60123 m
.63438 .60068 L
s
1 .315 .125 r
.63568 .59019 m .63437 .60084 L .62338 .61402 L p F P
0 0 0 r
s
.7 .195 .071 r
.35101 .54442 m .3494 .53199 L .3489 .51295 L p F P
0 0 0 r
s
.157 .045 .023 r
.3494 .53199 m .35101 .54442 L .35516 .56248 L p F P
0 0 0 r
s
.83 .24 .1 r
.35352 .55058 m
.35481 .56061 L
s
.35199 .52537 m
.35352 .55058 L
s
.098 .028 .012 r
.64899 .54442 m .6506 .53199 L .6511 .51295 L p F P
0 0 0 r
s
.796 .229 .086 r
.6506 .53199 m .64899 .54442 L .64484 .56248 L p F P
0 0 0 r
s
.83 .24 .1 r
.64648 .55058 m
.64801 .52537 L
s
.64519 .56061 m
.64648 .55058 L
s
.24 .35 .67 r
.75633 .35155 m
.79906 .35155 L
s
.71361 .35155 m
.75633 .35155 L
s
.67089 .35155 m
.71361 .35155 L
s
.62817 .35155 m
.67089 .35155 L
s
.58939 .35155 m
.62817 .35155 L
s
.54272 .35155 m
.57686 .35155 L
s
.5 .35155 m
.54272 .35155 L
s
.45728 .35155 m
.5 .35155 L
s
.42314 .35155 m
.45728 .35155 L
s
.37183 .35155 m
.41061 .35155 L
s
.32911 .35155 m
.37183 .35155 L
s
.28639 .35155 m
.32911 .35155 L
s
.24367 .35155 m
.28639 .35155 L
s
.20094 .35155 m
.24367 .35155 L
s
.75633 .35155 m
.76148 .34808 L
s
.80506 .34808 m
.79906 .35155 L
s
.71361 .35155 m
.7179 .34808 L
s
.67089 .35155 m
.67432 .34808 L
s
.62817 .35155 m
.63074 .34808 L
s
.58593 .35057 m
.58716 .34808 L
s
.54272 .35155 m
.54358 .34808 L
s
.5 .34808 m
.5 .35155 L
s
.45642 .34808 m
.45728 .35155 L
s
.41284 .34808 m
.41407 .35057 L
s
.37183 .35155 m
.36926 .34808 L
s
.32911 .35155 m
.32568 .34808 L
s
.28639 .35155 m
.2821 .34808 L
s
.24367 .35155 m
.23852 .34808 L
s
.20094 .35155 m
.19494 .34808 L
s
.899 .254 .097 r
.3489 .51295 m .34724 .5 L .35047 .48105 L p F P
0 0 0 r
s
.7 .195 .071 r
.34724 .5 m .3489 .51295 L .3494 .53199 L p F P
0 0 0 r
s
.181 .052 .027 r
.6511 .51295 m .65276 .5 L .64953 .48105 L p F P
0 0 0 r
s
.098 .028 .012 r
.65276 .5 m .6511 .51295 L .6506 .53199 L p F P
0 0 0 r
s
.83 .24 .1 r
.45276 .66874 m
.45377 .69075 L
s
.45377 .69075 m
.48432 .69643 L
s
.51568 .69643 m
.54623 .69075 L
s
.54724 .66874 m
.54623 .69075 L
s
.57517 .3443 m
.54623 .33487 L
s
.54725 .30502 m
.54623 .33487 L
s
.45275 .30502 m
.45377 .33487 L
s
.45377 .33487 m
.42483 .3443 L
s
.43 .135 .065 r
.37662 .61402 m .3777 .62349 L .39177 .63297 L p F P
0 0 0 r
s
.83 .24 .1 r
.37917 .62448 m
.37926 .62534 L
s
.43 .135 .065 r
.39261 .64114 m .39177 .63297 L .3777 .62349 L p F P
0 0 0 r
s
1 .333 .134 r
.60739 .64114 m .60823 .63297 L .6223 .62349 L p F P
0 0 0 r
s
1 .333 .134 r
.62338 .61402 m .6223 .62349 L .60823 .63297 L p F P
0 0 0 r
s
.597 .179 .083 r
.6227 .39713 m .62379 .38561 L .60698 .37774 L p F P
0 0 0 r
s
.597 .179 .083 r
.60781 .36755 m .60698 .37774 L .62379 .38561 L p F P
0 0 0 r
s
1 .334 .136 r
.39219 .36755 m .39302 .37774 L .37621 .38561 L p F P
0 0 0 r
s
1 .334 .136 r
.3773 .39713 m .37621 .38561 L .39302 .37774 L p F P
0 0 0 r
s
1 .295 .116 r
.35047 .48105 m .34885 .46789 L .35578 .45015 L p F P
0 0 0 r
s
.899 .254 .097 r
.34885 .46789 m .35047 .48105 L .34724 .5 L p F P
0 0 0 r
s
.181 .052 .027 r
.65115 .46789 m .64953 .48105 L .65276 .5 L p F P
0 0 0 r
s
.249 .072 .039 r
.64953 .48105 m .65115 .46789 L .64422 .45015 L p F P
0 0 0 r
s
.24 .35 .67 r
.76224 .65188 m
.75706 .64935 L
s
.79991 .64935 m
.80595 .65188 L
s
.75706 .64935 m
.79991 .64935 L
s
.71853 .65188 m
.71422 .64935 L
s
.71422 .64935 m
.75706 .64935 L
s
.67483 .65188 m
.67138 .64935 L
s
.67138 .64935 m
.71422 .64935 L
s
.63112 .65188 m
.62853 .64935 L
s
.62853 .64935 m
.67138 .64935 L
s
.60203 .64935 m
.62853 .64935 L
s
.58569 .64935 m
.59526 .64935 L
s
.54284 .64935 m
.54371 .65188 L
s
.54284 .64935 m
.58569 .64935 L
s
.5 .64935 m
.5 .65188 L
s
.5 .64935 m
.54284 .64935 L
s
.45629 .65188 m
.45716 .64935 L
s
.45716 .64935 m
.5 .64935 L
s
.41431 .64935 m
.45716 .64935 L
s
.36888 .65188 m
.37147 .64935 L
s
.37147 .64935 m
.39797 .64935 L
s
.40474 .64935 m
.41431 .64935 L
s
.32517 .65188 m
.32862 .64935 L
s
.32862 .64935 m
.37147 .64935 L
s
.28147 .65188 m
.28578 .64935 L
s
.28578 .64935 m
.32862 .64935 L
s
.23776 .65188 m
.24294 .64935 L
s
.24294 .64935 m
.28578 .64935 L
s
.19405 .65188 m
.20009 .64935 L
s
.20009 .64935 m
.24294 .64935 L
s
.83 .24 .1 r
.48398 .67449 m
.48432 .69643 L
s
.48432 .69643 m
.51568 .69643 L
s
.51602 .67449 m
.51568 .69643 L
s
.702 .21 .094 r
.60781 .36755 m .60865 .3572 L .58908 .35609 L p F P
0 0 0 r
s
.83 .24 .1 r
.59914 .38651 m
.6013 .35809 L
s
.702 .21 .094 r
.58966 .34748 m .58908 .35609 L .60865 .3572 L p F P
0 0 0 r
s
1 .332 .137 r
.41034 .34748 m .41092 .35609 L .39135 .3572 L p F P
0 0 0 r
s
1 .332 .137 r
.39219 .36755 m .39135 .3572 L .41092 .35609 L p F P
0 0 0 r
s
.83 .24 .1 r
.3987 .35809 m
.40086 .38651 L
s
1 .318 .127 r
.35578 .45015 m .35427 .43714 L .36478 .4217 L p F P
0 0 0 r
s
1 .295 .116 r
.35427 .43714 m .35578 .45015 L .34885 .46789 L p F P
0 0 0 r
s
.249 .072 .039 r
.64573 .43714 m .64422 .45015 L .65115 .46789 L p F P
0 0 0 r
s
.332 .1 .051 r
.64422 .45015 m .64573 .43714 L .63522 .4217 L p F P
0 0 0 r
s
1 .33 .134 r
.37621 .38561 m .3773 .39713 L .36346 .40923 L p F P
0 0 0 r
s
1 .33 .134 r
.36478 .4217 m .36346 .40923 L .3773 .39713 L p F P
0 0 0 r
s
.465 .141 .068 r
.63522 .4217 m .63654 .40923 L .6227 .39713 L p F P
0 0 0 r
s
.465 .141 .068 r
.62379 .38561 m .6227 .39713 L .63654 .40923 L p F P
0 0 0 r
s
1 .318 .127 r
.36346 .40923 m .36478 .4217 L .35427 .43714 L p F P
0 0 0 r
s
.83 .24 .1 r
.36205 .42498 m
.37908 .40409 L
s
.36205 .42498 m
.36498 .45191 L
s
.332 .1 .051 r
.63654 .40923 m .63522 .4217 L .64573 .43714 L p F P
0 0 0 r
s
.83 .24 .1 r
.62092 .40409 m
.63795 .42498 L
s
.63502 .45191 m
.63795 .42498 L
s
.57517 .3443 m
.5812 .34748 L
s
.57683 .31451 m
.57517 .3443 L
s
.42317 .31451 m
.42483 .3443 L
s
.4188 .34748 m
.42483 .3443 L
s
.583 .18 .083 r
.39177 .63297 m .39261 .64114 L .40949 .6462 L p F P
0 0 0 r
s
.583 .18 .083 r
.41008 .65296 m .40949 .6462 L .39261 .64114 L p F P
0 0 0 r
s
1 .338 .138 r
.58992 .65296 m .59051 .6462 L .60739 .64114 L p F P
0 0 0 r
s
1 .338 .138 r
.60823 .63297 m .60739 .64114 L .59051 .6462 L p F P
0 0 0 r
s
.236 .068 .036 r
.36432 .59019 m .36298 .57934 L .35516 .56248 L p F P
0 0 0 r
s
.32 .095 .05 r
.36298 .57934 m .36432 .59019 L .37551 .60437 L p F P
0 0 0 r
s
.32 .095 .05 r
.37662 .61402 m .37551 .60437 L .36432 .59019 L p F P
0 0 0 r
s
1 .315 .125 r
.62338 .61402 m .62449 .60437 L .63568 .59019 L p F P
0 0 0 r
s
1 .315 .125 r
.63702 .57934 m .63568 .59019 L .62449 .60437 L p F P
0 0 0 r
s
.973 .282 .11 r
.63568 .59019 m .63702 .57934 L .64484 .56248 L p F P
0 0 0 r
s
.157 .045 .023 r
.35516 .56248 m .35364 .55059 L .3494 .53199 L p F P
0 0 0 r
s
.236 .068 .036 r
.35364 .55059 m .35516 .56248 L .36298 .57934 L p F P
0 0 0 r
s
.973 .282 .11 r
.64636 .55059 m .64484 .56248 L .63702 .57934 L p F P
0 0 0 r
s
.83 .24 .1 r
.64629 .55115 m
.64648 .55058 L
s
.796 .229 .086 r
.64484 .56248 m .64636 .55059 L .6506 .53199 L p F P
0 0 0 r
s
.597 .179 .083 r
.62379 .38561 m .6249 .37387 L .60781 .36755 L p F P
0 0 0 r
s
.83 .24 .1 r
.62092 .40409 m
.62358 .3758 L
s
.597 .179 .083 r
.60865 .3572 m .60781 .36755 L .6249 .37387 L p F P
0 0 0 r
s
1 .334 .136 r
.39135 .3572 m .39219 .36755 L .3751 .37387 L p F P
0 0 0 r
s
1 .334 .136 r
.37621 .38561 m .3751 .37387 L .39219 .36755 L p F P
0 0 0 r
s
.83 .24 .1 r
.37642 .3758 m
.37908 .40409 L
s
.7 .195 .071 r
.3494 .53199 m .34775 .51929 L .34724 .5 L p F P
0 0 0 r
s
.157 .045 .023 r
.34775 .51929 m .3494 .53199 L .35364 .55059 L p F P
0 0 0 r
s
.098 .028 .012 r
.6506 .53199 m .65225 .51929 L .65276 .5 L p F P
0 0 0 r
s
.796 .229 .086 r
.65225 .51929 m .6506 .53199 L .64636 .55059 L p F P
0 0 0 r
s
.43 .135 .065 r
.37551 .60437 m .37662 .61402 L .39092 .62466 L p F P
0 0 0 r
s
.83 .24 .1 r
.37811 .61512 m
.3782 .616 L
s
.43 .135 .065 r
.39177 .63297 m .39092 .62466 L .37662 .61402 L p F P
0 0 0 r
s
1 .333 .134 r
.60823 .63297 m .60908 .62466 L .62338 .61402 L p F P
0 0 0 r
s
1 .333 .134 r
.62449 .60437 m .62338 .61402 L .60908 .62466 L p F P
0 0 0 r
s
.702 .21 .094 r
.60865 .3572 m .60951 .34669 L .58966 .34748 L p F P
0 0 0 r
s
.83 .24 .1 r
.58261 .34823 m
.6013 .35809 L
s
1 .332 .137 r
.39135 .3572 m .39049 .34669 L .41034 .34748 L p F P
0 0 0 r
s
.83 .24 .1 r
.3987 .35809 m
.41739 .34823 L
s
.172 .286 .565 r
.41034 .34748 m .42315 .34748 L .40614 .34669 L p F P
0 0 0 r
s
.172 .286 .565 r
.40614 .34669 m .39049 .34669 L .41034 .34748 L p F P
0 0 0 r
s
.172 .286 .565 r
.42315 .34748 m .43596 .34748 L .42178 .34669 L p F P
0 0 0 r
s
.172 .286 .565 r
.42178 .34669 m .40614 .34669 L .42315 .34748 L p F P
0 0 0 r
s
.172 .286 .565 r
.43596 .34748 m .44877 .34748 L .43742 .34669 L p F P
0 0 0 r
s
.172 .286 .565 r
.43742 .34669 m .42178 .34669 L .43596 .34748 L p F P
0 0 0 r
s
.172 .286 .565 r
.44877 .34748 m .46157 .34748 L .45307 .34669 L p F P
0 0 0 r
s
.172 .286 .565 r
.45307 .34669 m .43742 .34669 L .44877 .34748 L p F P
0 0 0 r
s
.172 .286 .565 r
.46157 .34748 m .47438 .34748 L .46871 .34669 L p F P
0 0 0 r
s
.172 .286 .565 r
.46871 .34669 m .45307 .34669 L .46157 .34748 L p F P
0 0 0 r
s
.172 .286 .565 r
.47438 .34748 m .48719 .34748 L .48436 .34669 L p F P
0 0 0 r
s
.172 .286 .565 r
.48436 .34669 m .46871 .34669 L .47438 .34748 L p F P
0 0 0 r
s
.172 .286 .565 r
.48719 .34748 m .5 .34748 L .5 .34669 L p F P
0 0 0 r
s
.172 .286 .565 r
.5 .34669 m .48436 .34669 L .48719 .34748 L p F P
0 0 0 r
s
.172 .286 .565 r
.5 .34748 m .51281 .34748 L .51564 .34669 L p F P
0 0 0 r
s
.172 .286 .565 r
.51564 .34669 m .5 .34669 L .5 .34748 L p F P
0 0 0 r
s
.172 .286 .565 r
.51281 .34748 m .52562 .34748 L .53129 .34669 L p F P
0 0 0 r
s
.172 .286 .565 r
.53129 .34669 m .51564 .34669 L .51281 .34748 L p F P
0 0 0 r
s
.172 .286 .565 r
.52562 .34748 m .53843 .34748 L .54693 .34669 L p F P
0 0 0 r
s
.172 .286 .565 r
.54693 .34669 m .53129 .34669 L .52562 .34748 L p F P
0 0 0 r
s
.172 .286 .565 r
.53843 .34748 m .55123 .34748 L .56258 .34669 L p F P
0 0 0 r
s
.172 .286 .565 r
.56258 .34669 m .54693 .34669 L .53843 .34748 L p F P
0 0 0 r
s
.172 .286 .565 r
.55123 .34748 m .56404 .34748 L .57822 .34669 L p F P
0 0 0 r
s
.172 .286 .565 r
.57822 .34669 m .56258 .34669 L .55123 .34748 L p F P
0 0 0 r
s
.172 .286 .565 r
.56404 .34748 m .57685 .34748 L .59386 .34669 L p F P
0 0 0 r
s
.172 .286 .565 r
.59386 .34669 m .57822 .34669 L .56404 .34748 L p F P
0 0 0 r
s
.172 .286 .565 r
.57685 .34748 m .58966 .34748 L .60951 .34669 L p F P
0 0 0 r
s
.172 .286 .565 r
.60951 .34669 m .59386 .34669 L .57685 .34748 L p F P
0 0 0 r
s
.83 .24 .1 r
.57607 .65756 m
.58217 .65367 L
s
.41783 .65367 m
.42393 .65756 L
s
.899 .254 .097 r
.34724 .5 m .34554 .48676 L .34885 .46789 L p F P
0 0 0 r
s
.83 .24 .1 r
.34877 .5 m
.35199 .52537 L
s
.34877 .5 m
.35381 .47514 L
s
.7 .195 .071 r
.34554 .48676 m .34724 .5 L .34775 .51929 L p F P
0 0 0 r
s
.181 .052 .027 r
.65276 .5 m .65446 .48676 L .65115 .46789 L p F P
0 0 0 r
s
.83 .24 .1 r
.64619 .47514 m
.65123 .5 L
s
.64801 .52537 m
.65123 .5 L
s
.098 .028 .012 r
.65446 .48676 m .65276 .5 L .65225 .51929 L p F P
0 0 0 r
s
.83 .24 .1 r
.6013 .35809 m
.60215 .34691 L
s
.39785 .34691 m
.3987 .35809 L
s
.025 .036 .068 r
.57051 .65302 m .56044 .65302 L .57708 .65296 L p F P
0 0 0 r
s
.025 .036 .068 r
.57708 .65296 m .58992 .65296 L .57051 .65302 L p F P
0 0 0 r
s
.025 .036 .068 r
.56044 .65302 m .55037 .65302 L .56423 .65296 L p F P
0 0 0 r
s
.025 .036 .068 r
.56423 .65296 m .57708 .65296 L .56044 .65302 L p F P
0 0 0 r
s
.025 .036 .068 r
.55037 .65302 m .54029 .65302 L .55138 .65296 L p F P
0 0 0 r
s
.025 .036 .068 r
.55138 .65296 m .56423 .65296 L .55037 .65302 L p F P
0 0 0 r
s
.025 .036 .068 r
.54029 .65302 m .53022 .65302 L .53854 .65296 L p F P
0 0 0 r
s
.025 .036 .068 r
.53854 .65296 m .55138 .65296 L .54029 .65302 L p F P
0 0 0 r
s
.025 .036 .068 r
.53022 .65302 m .52015 .65302 L .52569 .65296 L p F P
0 0 0 r
s
.025 .036 .068 r
.52569 .65296 m .53854 .65296 L .53022 .65302 L p F P
0 0 0 r
s
.025 .036 .068 r
.52015 .65302 m .51007 .65302 L .51285 .65296 L p F P
0 0 0 r
s
.025 .036 .068 r
.51285 .65296 m .52569 .65296 L .52015 .65302 L p F P
0 0 0 r
s
.025 .036 .068 r
.51007 .65302 m .5 .65302 L .5 .65296 L p F P
0 0 0 r
s
.025 .036 .068 r
.5 .65296 m .51285 .65296 L .51007 .65302 L p F P
0 0 0 r
s
.025 .036 .068 r
.5 .65302 m .48993 .65302 L .48715 .65296 L p F P
0 0 0 r
s
.025 .036 .068 r
.48715 .65296 m .5 .65296 L .5 .65302 L p F P
0 0 0 r
s
.025 .036 .068 r
.48993 .65302 m .47985 .65302 L .47431 .65296 L p F P
0 0 0 r
s
.025 .036 .068 r
.47431 .65296 m .48715 .65296 L .48993 .65302 L p F P
0 0 0 r
s
.025 .036 .068 r
.47985 .65302 m .46978 .65302 L .46146 .65296 L p F P
0 0 0 r
s
.025 .036 .068 r
.46146 .65296 m .47431 .65296 L .47985 .65302 L p F P
0 0 0 r
s
.025 .036 .068 r
.46978 .65302 m .45971 .65302 L .44862 .65296 L p F P
0 0 0 r
s
.025 .036 .068 r
.44862 .65296 m .46146 .65296 L .46978 .65302 L p F P
0 0 0 r
s
.025 .036 .068 r
.45971 .65302 m .44963 .65302 L .43577 .65296 L p F P
0 0 0 r
s
.025 .036 .068 r
.43577 .65296 m .44862 .65296 L .45971 .65302 L p F P
0 0 0 r
s
.025 .036 .068 r
.44963 .65302 m .43956 .65302 L .42292 .65296 L p F P
0 0 0 r
s
.025 .036 .068 r
.42292 .65296 m .43577 .65296 L .44963 .65302 L p F P
0 0 0 r
s
.025 .036 .068 r
.43956 .65302 m .42949 .65302 L .41008 .65296 L p F P
0 0 0 r
s
.025 .036 .068 r
.41008 .65296 m .42292 .65296 L .43956 .65302 L p F P
0 0 0 r
s
.712 .216 .097 r
.40949 .6462 m .41008 .65296 L .42949 .65302 L p F P
0 0 0 r
s
.83 .24 .1 r
.41675 .65298 m
.41783 .65367 L
s
1 .336 .139 r
.59051 .6462 m .58992 .65296 L .57051 .65302 L p F P
0 0 0 r
s
.83 .24 .1 r
.58217 .65367 m
.58325 .65298 L
s
.465 .141 .068 r
.63654 .40923 m .6379 .39651 L .62379 .38561 L p F P
0 0 0 r
s
.465 .141 .068 r
.6249 .37387 m .62379 .38561 L .6379 .39651 L p F P
0 0 0 r
s
1 .33 .134 r
.3751 .37387 m .37621 .38561 L .3621 .39651 L p F P
0 0 0 r
s
1 .33 .134 r
.36346 .40923 m .3621 .39651 L .37621 .38561 L p F P
0 0 0 r
s
1 .295 .116 r
.34885 .46789 m .34718 .45444 L .35427 .43714 L p F P
0 0 0 r
s
.899 .254 .097 r
.34718 .45444 m .34885 .46789 L .34554 .48676 L p F P
0 0 0 r
s
.181 .052 .027 r
.65282 .45444 m .65115 .46789 L .65446 .48676 L p F P
0 0 0 r
s
.249 .072 .039 r
.65115 .46789 m .65282 .45444 L .64573 .43714 L p F P
0 0 0 r
s
.583 .18 .083 r
.39092 .62466 m .39177 .63297 L .4089 .63935 L p F P
0 0 0 r
s
.583 .18 .083 r
.40949 .6462 m .4089 .63935 L .39177 .63297 L p F P
0 0 0 r
s
1 .338 .138 r
.59051 .6462 m .5911 .63935 L .60823 .63297 L p F P
0 0 0 r
s
1 .338 .138 r
.60908 .62466 m .60823 .63297 L .5911 .63935 L p F P
0 0 0 r
s
1 .318 .127 r
.35427 .43714 m .35272 .42385 L .36346 .40923 L p F P
0 0 0 r
s
1 .295 .116 r
.35272 .42385 m .35427 .43714 L .34718 .45444 L p F P
0 0 0 r
s
.83 .24 .1 r
.3506 .44841 m
.36205 .42498 L
s
.3506 .44841 m
.35381 .47514 L
s
.249 .072 .039 r
.64728 .42385 m .64573 .43714 L .65282 .45444 L p F P
0 0 0 r
s
.83 .24 .1 r
.64619 .47514 m
.6494 .44841 L
s
.332 .1 .051 r
.64573 .43714 m .64728 .42385 L .63654 .40923 L p F P
0 0 0 r
s
.83 .24 .1 r
.63795 .42498 m
.6494 .44841 L
s
1 .318 .127 r
.3621 .39651 m .36346 .40923 L .35272 .42385 L p F P
0 0 0 r
s
.332 .1 .051 r
.6379 .39651 m .63654 .40923 L .64728 .42385 L p F P
0 0 0 r
s
.597 .179 .083 r
.6249 .37387 m .62603 .36193 L .60865 .3572 L p F P
0 0 0 r
s
.597 .179 .083 r
.60951 .34669 m .60865 .3572 L .62603 .36193 L p F P
0 0 0 r
s
.83 .24 .1 r
.6013 .35809 m
.62358 .3758 L
s
1 .334 .136 r
.39049 .34669 m .39135 .3572 L .37397 .36193 L p F P
0 0 0 r
s
1 .334 .136 r
.3751 .37387 m .37397 .36193 L .39135 .3572 L p F P
0 0 0 r
s
.83 .24 .1 r
.37642 .3758 m
.3987 .35809 L
s
.42393 .65756 m
.45276 .66874 L
s
.54724 .66874 m
.57607 .65756 L
s
.236 .068 .036 r
.36298 .57934 m .36162 .56827 L .35364 .55059 L p F P
0 0 0 r
s
.32 .095 .05 r
.36162 .56827 m .36298 .57934 L .37439 .59454 L p F P
0 0 0 r
s
.32 .095 .05 r
.37551 .60437 m .37439 .59454 L .36298 .57934 L p F P
0 0 0 r
s
1 .315 .125 r
.62449 .60437 m .62561 .59454 L .63702 .57934 L p F P
0 0 0 r
s
1 .315 .125 r
.63838 .56827 m .63702 .57934 L .62561 .59454 L p F P
0 0 0 r
s
.83 .24 .1 r
.63732 .57689 m
.63833 .57529 L
s
.973 .282 .11 r
.63702 .57934 m .63838 .56827 L .64636 .55059 L p F P
0 0 0 r
s
.43 .135 .065 r
.37439 .59454 m .37551 .60437 L .39006 .61622 L p F P
0 0 0 r
s
.83 .24 .1 r
.37703 .6056 m
.37713 .60649 L
s
.43 .135 .065 r
.39092 .62466 m .39006 .61622 L .37551 .60437 L p F P
0 0 0 r
s
1 .333 .134 r
.60908 .62466 m .60994 .61622 L .62449 .60437 L p F P
0 0 0 r
s
1 .333 .134 r
.62561 .59454 m .62449 .60437 L .60994 .61622 L p F P
0 0 0 r
s
.157 .045 .023 r
.35364 .55059 m .35208 .53845 L .34775 .51929 L p F P
0 0 0 r
s
.236 .068 .036 r
.35208 .53845 m .35364 .55059 L .36162 .56827 L p F P
0 0 0 r
s
.973 .282 .11 r
.64792 .53845 m .64636 .55059 L .63838 .56827 L p F P
0 0 0 r
s
.796 .229 .086 r
.64636 .55059 m .64792 .53845 L .65225 .51929 L p F P
0 0 0 r
s
.712 .216 .097 r
.4089 .63935 m .40949 .6462 L .42913 .64773 L p F P
0 0 0 r
s
.712 .216 .097 r
.42949 .65302 m .42913 .64773 L .40949 .6462 L p F P
0 0 0 r
s
.83 .24 .1 r
.4236 .653 m
.42393 .65756 L
s
.24 .35 .67 r
.41259 .65188 m
.41309 .65114 L
s
1 .336 .139 r
.57051 .65302 m .57087 .64773 L .59051 .6462 L p F P
0 0 0 r
s
.83 .24 .1 r
.57607 .65756 m
.5764 .653 L
s
.24 .35 .67 r
.58691 .65114 m
.58741 .65188 L
s
1 .336 .139 r
.5911 .63935 m .59051 .6462 L .57087 .64773 L p F P
0 0 0 r
s
.83 .24 .1 r
.54725 .30502 m
.51594 .30021 L
s
.5163 .26899 m
.51594 .30021 L
s
.51594 .30021 m
.48406 .30021 L
s
.4837 .26899 m
.48406 .30021 L
s
.48406 .30021 m
.45275 .30502 L
s
.24 .35 .67 r
.76148 .34808 m
.80506 .34808 L
s
.7179 .34808 m
.76148 .34808 L
s
.67432 .34808 m
.7179 .34808 L
s
.63074 .34808 m
.67432 .34808 L
s
.58716 .34808 m
.60378 .34808 L
s
.61101 .34808 m
.63074 .34808 L
s
.54358 .34808 m
.58716 .34808 L
s
.5 .34808 m
.54358 .34808 L
s
.45642 .34808 m
.5 .34808 L
s
.41284 .34808 m
.45642 .34808 L
s
.39622 .34808 m
.41284 .34808 L
s
.36926 .34808 m
.38899 .34808 L
s
.32568 .34808 m
.36926 .34808 L
s
.2821 .34808 m
.32568 .34808 L
s
.23852 .34808 m
.2821 .34808 L
s
.19494 .34808 m
.23852 .34808 L
s
.76148 .34808 m
.76674 .35131 L
s
.81119 .35131 m
.80506 .34808 L
s
.7179 .34808 m
.72228 .35131 L
s
.67432 .34808 m
.67782 .35131 L
s
.32568 .34808 m
.32218 .35131 L
s
.2821 .34808 m
.27772 .35131 L
s
.23852 .34808 m
.23326 .35131 L
s
.19494 .34808 m
.18881 .35131 L
s
.7 .195 .071 r
.34775 .51929 m .34606 .50631 L .34554 .48676 L p F P
0 0 0 r
s
.157 .045 .023 r
.34606 .50631 m .34775 .51929 L .35208 .53845 L p F P
0 0 0 r
s
.83 .24 .1 r
.35029 .52546 m
.35171 .53649 L
s
.34877 .5 m
.35029 .52546 L
s
.098 .028 .012 r
.65225 .51929 m .65394 .50631 L .65446 .48676 L p F P
0 0 0 r
s
.796 .229 .086 r
.65394 .50631 m .65225 .51929 L .64792 .53845 L p F P
0 0 0 r
s
.83 .24 .1 r
.64971 .52546 m
.65123 .5 L
s
.64829 .53649 m
.64971 .52546 L
s
.583 .18 .083 r
.39006 .61622 m .39092 .62466 L .4083 .63241 L p F P
0 0 0 r
s
.583 .18 .083 r
.4089 .63935 m .4083 .63241 L .39092 .62466 L p F P
0 0 0 r
s
1 .338 .138 r
.5911 .63935 m .5917 .63241 L .60908 .62466 L p F P
0 0 0 r
s
1 .338 .138 r
.60994 .61622 m .60908 .62466 L .5917 .63241 L p F P
0 0 0 r
s
.465 .141 .068 r
.6379 .39651 m .63928 .38353 L .6249 .37387 L p F P
0 0 0 r
s
.465 .141 .068 r
.62603 .36193 m .6249 .37387 L .63928 .38353 L p F P
0 0 0 r
s
1 .33 .134 r
.37397 .36193 m .3751 .37387 L .36072 .38353 L p F P
0 0 0 r
s
1 .33 .134 r
.3621 .39651 m .36072 .38353 L .3751 .37387 L p F P
0 0 0 r
s
.83 .24 .1 r
.45203 .65306 m
.45276 .66874 L
s
.45276 .66874 m
.48398 .67449 L
s
.51602 .67449 m
.54724 .66874 L
s
.54724 .66874 m
.54797 .65306 L
s
.57683 .31451 m
.54725 .30502 L
s
.54831 .27383 m
.54725 .30502 L
s
.45169 .27383 m
.45275 .30502 L
s
.45275 .30502 m
.42317 .31451 L
s
.899 .254 .097 r
.34554 .48676 m .34381 .47322 L .34718 .45444 L p F P
0 0 0 r
s
.7 .195 .071 r
.34381 .47322 m .34554 .48676 L .34606 .50631 L p F P
0 0 0 r
s
.181 .052 .027 r
.65446 .48676 m .65619 .47322 L .65282 .45444 L p F P
0 0 0 r
s
.098 .028 .012 r
.65619 .47322 m .65446 .48676 L .65394 .50631 L p F P
0 0 0 r
s
.24 .35 .67 r
.76749 .64765 m
.76224 .65188 L
s
.80595 .65188 m
.81208 .64765 L
s
.76224 .65188 m
.80595 .65188 L
s
.72291 .64765 m
.71853 .65188 L
s
.71853 .65188 m
.76224 .65188 L
s
.67833 .64765 m
.67483 .65188 L
s
.67483 .65188 m
.71853 .65188 L
s
.63375 .64765 m
.63112 .65188 L
s
.63112 .65188 m
.67483 .65188 L
s
.58741 .65188 m
.63112 .65188 L
s
.57863 .65188 m
.58741 .65188 L
s
.54371 .65188 m
.57059 .65188 L
s
.5 .65188 m
.54371 .65188 L
s
.45629 .65188 m
.5 .65188 L
s
.41259 .65188 m
.42137 .65188 L
s
.42941 .65188 m
.45629 .65188 L
s
.36625 .64765 m
.36888 .65188 L
s
.36888 .65188 m
.41259 .65188 L
s
.32167 .64765 m
.32517 .65188 L
s
.32517 .65188 m
.36888 .65188 L
s
.27709 .64765 m
.28147 .65188 L
s
.28147 .65188 m
.32517 .65188 L
s
.23251 .64765 m
.23776 .65188 L
s
.23776 .65188 m
.28147 .65188 L
s
.18792 .64765 m
.19405 .65188 L
s
.19405 .65188 m
.23776 .65188 L
s
1 .295 .116 r
.34718 .45444 m .34548 .44069 L .35272 .42385 L p F P
0 0 0 r
s
.899 .254 .097 r
.34548 .44069 m .34718 .45444 L .34381 .47322 L p F P
0 0 0 r
s
.181 .052 .027 r
.65452 .44069 m .65282 .45444 L .65619 .47322 L p F P
0 0 0 r
s
.249 .072 .039 r
.65282 .45444 m .65452 .44069 L .64728 .42385 L p F P
0 0 0 r
s
1 .318 .127 r
.36072 .38353 m .3621 .39651 L .35115 .41027 L p F P
0 0 0 r
s
1 .318 .127 r
.35272 .42385 m .35115 .41027 L .3621 .39651 L p F P
0 0 0 r
s
.83 .24 .1 r
.35898 .39685 m
.36205 .42498 L
s
.332 .1 .051 r
.64728 .42385 m .64885 .41027 L .6379 .39651 L p F P
0 0 0 r
s
.332 .1 .051 r
.63928 .38353 m .6379 .39651 L .64885 .41027 L p F P
0 0 0 r
s
.83 .24 .1 r
.63795 .42498 m
.64102 .39685 L
s
.48364 .65309 m
.48398 .67449 L
s
.48398 .67449 m
.51602 .67449 L
s
.51602 .67449 m
.51636 .65309 L
s
1 .295 .116 r
.35115 .41027 m .35272 .42385 L .34548 .44069 L p F P
0 0 0 r
s
.249 .072 .039 r
.64885 .41027 m .64728 .42385 L .65452 .44069 L p F P
0 0 0 r
s
.597 .179 .083 r
.62603 .36193 m .62719 .34976 L .60951 .34669 L p F P
0 0 0 r
s
1 .334 .136 r
.37397 .36193 m .37281 .34976 L .39049 .34669 L p F P
0 0 0 r
s
.055 .066 .127 r
.39049 .34669 m .40614 .34669 L .39098 .34976 L p F P
0 0 0 r
s
.83 .24 .1 r
.39644 .32839 m
.39778 .34597 L
s
.39778 .34597 m
.39783 .34669 L
s
.055 .066 .127 r
.39098 .34976 m .37281 .34976 L .39049 .34669 L p F P
0 0 0 r
s
.055 .066 .127 r
.40614 .34669 m .42178 .34669 L .40915 .34976 L p F P
0 0 0 r
s
.055 .066 .127 r
.40915 .34976 m .39098 .34976 L .40614 .34669 L p F P
0 0 0 r
s
.055 .066 .127 r
.42178 .34669 m .43742 .34669 L .42732 .34976 L p F P
0 0 0 r
s
.055 .066 .127 r
.42732 .34976 m .40915 .34976 L .42178 .34669 L p F P
0 0 0 r
s
.24 .35 .67 r
.41109 .35131 m
.41193 .34976 L
s
.055 .066 .127 r
.43742 .34669 m .45307 .34669 L .44549 .34976 L p F P
0 0 0 r
s
.055 .066 .127 r
.44549 .34976 m .42732 .34976 L .43742 .34669 L p F P
0 0 0 r
s
.055 .066 .127 r
.45307 .34669 m .46871 .34669 L .46366 .34976 L p F P
0 0 0 r
s
.055 .066 .127 r
.46366 .34976 m .44549 .34976 L .45307 .34669 L p F P
0 0 0 r
s
.24 .35 .67 r
.45554 .35131 m
.45596 .34976 L
s
.055 .066 .127 r
.46871 .34669 m .48436 .34669 L .48183 .34976 L p F P
0 0 0 r
s
.055 .066 .127 r
.48183 .34976 m .46366 .34976 L .46871 .34669 L p F P
0 0 0 r
s
.055 .066 .127 r
.48436 .34669 m .5 .34669 L .5 .34976 L p F P
0 0 0 r
s
.055 .066 .127 r
.5 .34976 m .48183 .34976 L .48436 .34669 L p F P
0 0 0 r
s
.055 .066 .127 r
.5 .34669 m .51564 .34669 L .51817 .34976 L p F P
0 0 0 r
s
.055 .066 .127 r
.51817 .34976 m .5 .34976 L .5 .34669 L p F P
0 0 0 r
s
.24 .35 .67 r
.5 .34976 m
.5 .35131 L
s
.055 .066 .127 r
.51564 .34669 m .53129 .34669 L .53634 .34976 L p F P
0 0 0 r
s
.055 .066 .127 r
.53634 .34976 m .51817 .34976 L .51564 .34669 L p F P
0 0 0 r
s
.055 .066 .127 r
.53129 .34669 m .54693 .34669 L .55451 .34976 L p F P
0 0 0 r
s
.055 .066 .127 r
.55451 .34976 m .53634 .34976 L .53129 .34669 L p F P
0 0 0 r
s
.24 .35 .67 r
.54404 .34976 m
.54446 .35131 L
s
.055 .066 .127 r
.54693 .34669 m .56258 .34669 L .57268 .34976 L p F P
0 0 0 r
s
.055 .066 .127 r
.57268 .34976 m .55451 .34976 L .54693 .34669 L p F P
0 0 0 r
s
.055 .066 .127 r
.56258 .34669 m .57822 .34669 L .59085 .34976 L p F P
0 0 0 r
s
.055 .066 .127 r
.59085 .34976 m .57268 .34976 L .56258 .34669 L p F P
0 0 0 r
s
.055 .066 .127 r
.57822 .34669 m .59386 .34669 L .60902 .34976 L p F P
0 0 0 r
s
.83 .24 .1 r
.60222 .34597 m
.60356 .32839 L
s
.60217 .34669 m
.60222 .34597 L
s
.055 .066 .127 r
.60902 .34976 m .59085 .34976 L .57822 .34669 L p F P
0 0 0 r
s
.24 .35 .67 r
.58807 .34976 m
.58891 .35131 L
s
.055 .066 .127 r
.59386 .34669 m .60951 .34669 L .62719 .34976 L p F P
0 0 0 r
s
.055 .066 .127 r
.62719 .34976 m .60902 .34976 L .59386 .34669 L p F P
0 0 0 r
s
.712 .216 .097 r
.4083 .63241 m .4089 .63935 L .42876 .64238 L p F P
0 0 0 r
s
.712 .216 .097 r
.42913 .64773 m .42876 .64238 L .4089 .63935 L p F P
0 0 0 r
s
.24 .35 .67 r
.41084 .64765 m
.41259 .65188 L
s
1 .336 .139 r
.57087 .64773 m .57124 .64238 L .5911 .63935 L p F P
0 0 0 r
s
.24 .35 .67 r
.58741 .65188 m
.58916 .64765 L
s
1 .336 .139 r
.5917 .63241 m .5911 .63935 L .57124 .64238 L p F P
0 0 0 r
s
.83 .24 .1 r
.60356 .32839 m
.57683 .31451 L
s
.57857 .28338 m
.57683 .31451 L
s
.42143 .28338 m
.42317 .31451 L
s
.42317 .31451 m
.39644 .32839 L
s
.32 .095 .05 r
.37439 .59454 m .37324 .58454 L .36162 .56827 L p F P
0 0 0 r
s
.43 .135 .065 r
.37324 .58454 m .37439 .59454 L .38918 .60765 L p F P
0 0 0 r
s
.83 .24 .1 r
.37593 .59591 m
.37603 .59682 L
s
.43 .135 .065 r
.39006 .61622 m .38918 .60765 L .37439 .59454 L p F P
0 0 0 r
s
1 .333 .134 r
.60994 .61622 m .61082 .60765 L .62561 .59454 L p F P
0 0 0 r
s
1 .333 .134 r
.62676 .58454 m .62561 .59454 L .61082 .60765 L p F P
0 0 0 r
s
1 .315 .125 r
.62561 .59454 m .62676 .58454 L .63838 .56827 L p F P
0 0 0 r
s
.236 .068 .036 r
.36162 .56827 m .36023 .55697 L .35208 .53845 L p F P
0 0 0 r
s
.32 .095 .05 r
.36023 .55697 m .36162 .56827 L .37324 .58454 L p F P
0 0 0 r
s
1 .315 .125 r
.63977 .55697 m .63838 .56827 L .62676 .58454 L p F P
0 0 0 r
s
.973 .282 .11 r
.63838 .56827 m .63977 .55697 L .64792 .53845 L p F P
0 0 0 r
s
.229 .365 .719 r
.54872 .64919 m .54176 .64919 L .56044 .65302 L p F P
0 0 0 r
s
.229 .365 .719 r
.56044 .65302 m .57051 .65302 L .54872 .64919 L p F P
0 0 0 r
s
.229 .365 .719 r
.54176 .64919 m .5348 .64919 L .55037 .65302 L p F P
0 0 0 r
s
.24 .35 .67 r
.54371 .65188 m
.5438 .65141 L
s
.229 .365 .719 r
.55037 .65302 m .56044 .65302 L .54176 .64919 L p F P
0 0 0 r
s
.229 .365 .719 r
.5348 .64919 m .52784 .64919 L .54029 .65302 L p F P
0 0 0 r
s
.229 .365 .719 r
.54029 .65302 m .55037 .65302 L .5348 .64919 L p F P
0 0 0 r
s
.83 .24 .1 r
.54797 .65306 m
.54812 .64981 L
s
.24 .35 .67 r
.54426 .64919 m
.54458 .64765 L
s
.229 .365 .719 r
.52784 .64919 m .52088 .64919 L .53022 .65302 L p F P
0 0 0 r
s
.229 .365 .719 r
.53022 .65302 m .54029 .65302 L .52784 .64919 L p F P
0 0 0 r
s
.229 .365 .719 r
.52088 .64919 m .51392 .64919 L .52015 .65302 L p F P
0 0 0 r
s
.229 .365 .719 r
.52015 .65302 m .53022 .65302 L .52088 .64919 L p F P
0 0 0 r
s
.229 .365 .719 r
.51392 .64919 m .50696 .64919 L .51007 .65302 L p F P
0 0 0 r
s
.229 .365 .719 r
.51007 .65302 m .52015 .65302 L .51392 .64919 L p F P
0 0 0 r
s
.83 .24 .1 r
.51636 .65309 m
.51638 .65156 L
s
.229 .365 .719 r
.50696 .64919 m .5 .64919 L .5 .65302 L p F P
0 0 0 r
s
.229 .365 .719 r
.5 .65302 m .51007 .65302 L .50696 .64919 L p F P
0 0 0 r
s
.229 .365 .719 r
.5 .64919 m .49304 .64919 L .48993 .65302 L p F P
0 0 0 r
s
.229 .365 .719 r
.48993 .65302 m .5 .65302 L .5 .64919 L p F P
0 0 0 r
s
.24 .35 .67 r
.5 .64765 m
.5 .64919 L
s
.229 .365 .719 r
.49304 .64919 m .48608 .64919 L .47985 .65302 L p F P
0 0 0 r
s
.229 .365 .719 r
.47985 .65302 m .48993 .65302 L .49304 .64919 L p F P
0 0 0 r
s
.229 .365 .719 r
.48608 .64919 m .47912 .64919 L .46978 .65302 L p F P
0 0 0 r
s
.229 .365 .719 r
.46978 .65302 m .47985 .65302 L .48608 .64919 L p F P
0 0 0 r
s
.83 .24 .1 r
.48362 .65156 m
.48364 .65309 L
s
.229 .365 .719 r
.47912 .64919 m .47216 .64919 L .45971 .65302 L p F P
0 0 0 r
s
.229 .365 .719 r
.45971 .65302 m .46978 .65302 L .47912 .64919 L p F P
0 0 0 r
s
.229 .365 .719 r
.47216 .64919 m .4652 .64919 L .44963 .65302 L p F P
0 0 0 r
s
.229 .365 .719 r
.44963 .65302 m .45971 .65302 L .47216 .64919 L p F P
0 0 0 r
s
.229 .365 .719 r
.4652 .64919 m .45824 .64919 L .43956 .65302 L p F P
0 0 0 r
s
.229 .365 .719 r
.43956 .65302 m .44963 .65302 L .4652 .64919 L p F P
0 0 0 r
s
.229 .365 .719 r
.45824 .64919 m .45128 .64919 L .42949 .65302 L p F P
0 0 0 r
s
.229 .365 .719 r
.42949 .65302 m .43956 .65302 L .45824 .64919 L p F P
0 0 0 r
s
.83 .24 .1 r
.45188 .64981 m
.45203 .65306 L
s
.24 .35 .67 r
.45542 .64765 m
.45574 .64919 L
s
.814 .245 .108 r
.42913 .64773 m .42949 .65302 L .45128 .64919 L p F P
0 0 0 r
s
1 .329 .137 r
.57087 .64773 m .57051 .65302 L .54872 .64919 L p F P
0 0 0 r
s
.583 .18 .083 r
.38918 .60765 m .39006 .61622 L .40769 .62538 L p F P
0 0 0 r
s
.583 .18 .083 r
.4083 .63241 m .40769 .62538 L .39006 .61622 L p F P
0 0 0 r
s
1 .338 .138 r
.5917 .63241 m .59231 .62538 L .60994 .61622 L p F P
0 0 0 r
s
1 .338 .138 r
.61082 .60765 m .60994 .61622 L .59231 .62538 L p F P
0 0 0 r
s
.157 .045 .023 r
.35208 .53845 m .35049 .52605 L .34606 .50631 L p F P
0 0 0 r
s
.236 .068 .036 r
.35049 .52605 m .35208 .53845 L .36023 .55697 L p F P
0 0 0 r
s
.83 .24 .1 r
.35856 .55038 m
.35882 .5525 L
s
.973 .282 .11 r
.64951 .52605 m .64792 .53845 L .63977 .55697 L p F P
0 0 0 r
s
.83 .24 .1 r
.64118 .5525 m
.64144 .55038 L
s
.796 .229 .086 r
.64792 .53845 m .64951 .52605 L .65394 .50631 L p F P
0 0 0 r
s
.465 .141 .068 r
.63928 .38353 m .64069 .3703 L .62603 .36193 L p F P
0 0 0 r
s
.83 .24 .1 r
.62358 .3758 m
.64102 .39685 L
s
.465 .141 .068 r
.62719 .34976 m .62603 .36193 L .64069 .3703 L p F P
0 0 0 r
s
.24 .35 .67 r
.63074 .34808 m
.63337 .35131 L
s
1 .33 .134 r
.37281 .34976 m .37397 .36193 L .35931 .3703 L p F P
0 0 0 r
s
.24 .35 .67 r
.36663 .35131 m
.36926 .34808 L
s
1 .33 .134 r
.36072 .38353 m .35931 .3703 L .37397 .36193 L p F P
0 0 0 r
s
.83 .24 .1 r
.35898 .39685 m
.37642 .3758 L
s
.7 .195 .071 r
.34606 .50631 m .34434 .49304 L .34381 .47322 L p F P
0 0 0 r
s
.83 .24 .1 r
.3454 .4735 m
.3506 .44841 L
s
.157 .045 .023 r
.34434 .49304 m .34606 .50631 L .35049 .52605 L p F P
0 0 0 r
s
.83 .24 .1 r
.3454 .4735 m
.34877 .5 L
s
.35048 .52602 m
.35856 .55038 L
s
.098 .028 .012 r
.65394 .50631 m .65566 .49304 L .65619 .47322 L p F P
0 0 0 r
s
.796 .229 .086 r
.65566 .49304 m .65394 .50631 L .64951 .52605 L p F P
0 0 0 r
s
.83 .24 .1 r
.64144 .55038 m
.64952 .52602 L
s
.65123 .5 m
.6546 .4735 L
s
.6494 .44841 m
.6546 .4735 L
s
.712 .216 .097 r
.40769 .62538 m .4083 .63241 L .4284 .63697 L p F P
0 0 0 r
s
.83 .24 .1 r
.40727 .62498 m
.40959 .62644 L
s
.712 .216 .097 r
.42876 .64238 m .4284 .63697 L .4083 .63241 L p F P
0 0 0 r
s
1 .336 .139 r
.57124 .64238 m .5716 .63697 L .5917 .63241 L p F P
0 0 0 r
s
1 .336 .139 r
.59231 .62538 m .5917 .63241 L .5716 .63697 L p F P
0 0 0 r
s
.83 .24 .1 r
.59041 .62644 m
.59273 .62498 L
s
.814 .245 .108 r
.42876 .64238 m .42913 .64773 L .45111 .64553 L p F P
0 0 0 r
s
.814 .245 .108 r
.45128 .64919 m .45111 .64553 L .42913 .64773 L p F P
0 0 0 r
s
1 .329 .137 r
.54872 .64919 m .54889 .64553 L .57087 .64773 L p F P
0 0 0 r
s
1 .329 .137 r
.57124 .64238 m .57087 .64773 L .54889 .64553 L p F P
0 0 0 r
s
.899 .254 .097 r
.34381 .47322 m .34203 .45938 L .34548 .44069 L p F P
0 0 0 r
s
.7 .195 .071 r
.34203 .45938 m .34381 .47322 L .34434 .49304 L p F P
0 0 0 r
s
.181 .052 .027 r
.65619 .47322 m .65797 .45938 L .65452 .44069 L p F P
0 0 0 r
s
.098 .028 .012 r
.65797 .45938 m .65619 .47322 L .65566 .49304 L p F P
0 0 0 r
s
1 .318 .127 r
.35931 .3703 m .36072 .38353 L .34953 .3964 L p F P
0 0 0 r
s
1 .318 .127 r
.35115 .41027 m .34953 .3964 L .36072 .38353 L p F P
0 0 0 r
s
.332 .1 .051 r
.64885 .41027 m .65047 .3964 L .63928 .38353 L p F P
0 0 0 r
s
.332 .1 .051 r
.64069 .3703 m .63928 .38353 L .65047 .3964 L p F P
0 0 0 r
s
.83 .24 .1 r
.62636 .34623 m
.60356 .32839 L
s
.60592 .29735 m
.60356 .32839 L
s
.39408 .29735 m
.39644 .32839 L
s
.39644 .32839 m
.37364 .34623 L
s
1 .295 .116 r
.34548 .44069 m .34375 .42663 L .35115 .41027 L p F P
0 0 0 r
s
.899 .254 .097 r
.34375 .42663 m .34548 .44069 L .34203 .45938 L p F P
0 0 0 r
s
.181 .052 .027 r
.65625 .42663 m .65452 .44069 L .65797 .45938 L p F P
0 0 0 r
s
.249 .072 .039 r
.65452 .44069 m .65625 .42663 L .64885 .41027 L p F P
0 0 0 r
s
1 .295 .116 r
.34953 .3964 m .35115 .41027 L .34375 .42663 L p F P
0 0 0 r
s
.83 .24 .1 r
.34724 .42048 m
.3506 .44841 L
s
.34724 .42048 m
.35898 .39685 L
s
.249 .072 .039 r
.65047 .3964 m .64885 .41027 L .65625 .42663 L p F P
0 0 0 r
s
.83 .24 .1 r
.6494 .44841 m
.65276 .42048 L
s
.64102 .39685 m
.65276 .42048 L
s
.32 .095 .05 r
.37324 .58454 m .37208 .57435 L .36023 .55697 L p F P
0 0 0 r
s
.43 .135 .065 r
.37208 .57435 m .37324 .58454 L .38829 .59894 L p F P
0 0 0 r
s
.83 .24 .1 r
.37481 .58604 m
.37491 .58697 L
s
.43 .135 .065 r
.38918 .60765 m .38829 .59894 L .37324 .58454 L p F P
0 0 0 r
s
1 .333 .134 r
.61082 .60765 m .61171 .59894 L .62676 .58454 L p F P
0 0 0 r
s
1 .333 .134 r
.62792 .57435 m .62676 .58454 L .61171 .59894 L p F P
0 0 0 r
s
1 .315 .125 r
.62676 .58454 m .62792 .57435 L .63977 .55697 L p F P
0 0 0 r
s
.583 .18 .083 r
.38829 .59894 m .38918 .60765 L .40707 .61825 L p F P
0 0 0 r
s
.583 .18 .083 r
.40769 .62538 m .40707 .61825 L .38918 .60765 L p F P
0 0 0 r
s
1 .338 .138 r
.59231 .62538 m .59293 .61825 L .61082 .60765 L p F P
0 0 0 r
s
1 .338 .138 r
.61171 .59894 m .61082 .60765 L .59293 .61825 L p F P
0 0 0 r
s
.236 .068 .036 r
.36023 .55697 m .35881 .54545 L .35049 .52605 L p F P
0 0 0 r
s
.32 .095 .05 r
.35881 .54545 m .36023 .55697 L .37208 .57435 L p F P
0 0 0 r
s
.83 .24 .1 r
.36746 .5643 m
.3734 .57358 L
s
1 .315 .125 r
.64119 .54545 m .63977 .55697 L .62792 .57435 L p F P
0 0 0 r
s
.83 .24 .1 r
.6266 .57358 m
.63254 .5643 L
s
.64038 .55204 m
.64144 .55038 L
s
.973 .282 .11 r
.63977 .55697 m .64119 .54545 L .64951 .52605 L p F P
0 0 0 r
s
.814 .245 .108 r
.4284 .63697 m .42876 .64238 L .45093 .64183 L p F P
0 0 0 r
s
.814 .245 .108 r
.45111 .64553 m .45093 .64183 L .42876 .64238 L p F P
0 0 0 r
s
1 .329 .137 r
.54889 .64553 m .54907 .64183 L .57124 .64238 L p F P
0 0 0 r
s
1 .329 .137 r
.5716 .63697 m .57124 .64238 L .54907 .64183 L p F P
0 0 0 r
s
.712 .216 .097 r
.40707 .61825 m .40769 .62538 L .42802 .63152 L p F P
0 0 0 r
s
.712 .216 .097 r
.4284 .63697 m .42802 .63152 L .40769 .62538 L p F P
0 0 0 r
s
1 .336 .139 r
.5716 .63697 m .57198 .63152 L .59231 .62538 L p F P
0 0 0 r
s
1 .336 .139 r
.59293 .61825 m .59231 .62538 L .57198 .63152 L p F P
0 0 0 r
s
.83 .24 .1 r
.42838 .63679 m
.42946 .63721 L
s
.57054 .63721 m
.57162 .63679 L
s
.24 .35 .67 r
.76674 .35131 m
.81119 .35131 L
s
.72228 .35131 m
.76674 .35131 L
s
.67782 .35131 m
.72228 .35131 L
s
.63337 .35131 m
.67782 .35131 L
s
.58891 .35131 m
.62772 .35131 L
s
.62821 .35131 m
.63337 .35131 L
s
.54446 .35131 m
.58891 .35131 L
s
.5 .35131 m
.54446 .35131 L
s
.45554 .35131 m
.5 .35131 L
s
.41109 .35131 m
.45554 .35131 L
s
.37228 .35131 m
.41109 .35131 L
s
.36663 .35131 m
.37179 .35131 L
s
.32218 .35131 m
.36663 .35131 L
s
.27772 .35131 m
.32218 .35131 L
s
.23326 .35131 m
.27772 .35131 L
s
.18881 .35131 m
.23326 .35131 L
s
.76674 .35131 m
.77186 .36147 L
s
.81717 .36147 m
.81119 .35131 L
s
.72228 .35131 m
.72655 .36147 L
s
.67782 .35131 m
.68124 .36147 L
s
.32218 .35131 m
.31876 .36147 L
s
.27772 .35131 m
.27345 .36147 L
s
.23326 .35131 m
.22814 .36147 L
s
.18881 .35131 m
.18283 .36147 L
s
.157 .045 .023 r
.35049 .52605 m .34886 .51338 L .34434 .49304 L p F P
0 0 0 r
s
.236 .068 .036 r
.34886 .51338 m .35049 .52605 L .35881 .54545 L p F P
0 0 0 r
s
.973 .282 .11 r
.65114 .51338 m .64951 .52605 L .64119 .54545 L p F P
0 0 0 r
s
.796 .229 .086 r
.64951 .52605 m .65114 .51338 L .65566 .49304 L p F P
0 0 0 r
s
.465 .141 .068 r
.64069 .3703 m .64213 .35679 L .62719 .34976 L p F P
0 0 0 r
s
1 .33 .134 r
.35931 .3703 m .35787 .35679 L .37281 .34976 L p F P
0 0 0 r
s
.084 .096 .185 r
.37281 .34976 m .39098 .34976 L .37817 .35679 L p F P
0 0 0 r
s
.83 .24 .1 r
.37414 .3515 m
.37642 .3758 L
s
.084 .096 .185 r
.37817 .35679 m .35787 .35679 L .37281 .34976 L p F P
0 0 0 r
s
.83 .24 .1 r
.37399 .34991 m
.374 .35006 L
s
.37364 .34623 m
.37399 .34991 L
s
.24 .35 .67 r
.36624 .35285 m
.36663 .35131 L
s
.084 .096 .185 r
.39098 .34976 m .40915 .34976 L .39848 .35679 L p F P
0 0 0 r
s
.084 .096 .185 r
.39848 .35679 m .37817 .35679 L .39098 .34976 L p F P
0 0 0 r
s
.084 .096 .185 r
.40915 .34976 m .42732 .34976 L .41878 .35679 L p F P
0 0 0 r
s
.084 .096 .185 r
.41878 .35679 m .39848 .35679 L .40915 .34976 L p F P
0 0 0 r
s
.084 .096 .185 r
.42732 .34976 m .44549 .34976 L .43909 .35679 L p F P
0 0 0 r
s
.084 .096 .185 r
.43909 .35679 m .41878 .35679 L .42732 .34976 L p F P
0 0 0 r
s
.084 .096 .185 r
.44549 .34976 m .46366 .34976 L .45939 .35679 L p F P
0 0 0 r
s
.084 .096 .185 r
.45939 .35679 m .43909 .35679 L .44549 .34976 L p F P
0 0 0 r
s
.084 .096 .185 r
.46366 .34976 m .48183 .34976 L .4797 .35679 L p F P
0 0 0 r
s
.084 .096 .185 r
.4797 .35679 m .45939 .35679 L .46366 .34976 L p F P
0 0 0 r
s
.084 .096 .185 r
.48183 .34976 m .5 .34976 L .5 .35679 L p F P
0 0 0 r
s
.084 .096 .185 r
.5 .35679 m .4797 .35679 L .48183 .34976 L p F P
0 0 0 r
s
.084 .096 .185 r
.5 .34976 m .51817 .34976 L .5203 .35679 L p F P
0 0 0 r
s
.084 .096 .185 r
.5203 .35679 m .5 .35679 L .5 .34976 L p F P
0 0 0 r
s
.084 .096 .185 r
.51817 .34976 m .53634 .34976 L .54061 .35679 L p F P
0 0 0 r
s
.084 .096 .185 r
.54061 .35679 m .5203 .35679 L .51817 .34976 L p F P
0 0 0 r
s
.084 .096 .185 r
.53634 .34976 m .55451 .34976 L .56091 .35679 L p F P
0 0 0 r
s
.084 .096 .185 r
.56091 .35679 m .54061 .35679 L .53634 .34976 L p F P
0 0 0 r
s
.084 .096 .185 r
.55451 .34976 m .57268 .34976 L .58122 .35679 L p F P
0 0 0 r
s
.084 .096 .185 r
.58122 .35679 m .56091 .35679 L .55451 .34976 L p F P
0 0 0 r
s
.084 .096 .185 r
.57268 .34976 m .59085 .34976 L .60152 .35679 L p F P
0 0 0 r
s
.084 .096 .185 r
.60152 .35679 m .58122 .35679 L .57268 .34976 L p F P
0 0 0 r
s
.084 .096 .185 r
.59085 .34976 m .60902 .34976 L .62183 .35679 L p F P
0 0 0 r
s
.084 .096 .185 r
.62183 .35679 m .60152 .35679 L .59085 .34976 L p F P
0 0 0 r
s
.084 .096 .185 r
.60902 .34976 m .62719 .34976 L .64213 .35679 L p F P
0 0 0 r
s
.83 .24 .1 r
.62358 .3758 m
.62569 .3533 L
s
.084 .096 .185 r
.64213 .35679 m .62183 .35679 L .60902 .34976 L p F P
0 0 0 r
s
.83 .24 .1 r
.626 .35006 m
.62601 .34991 L
s
.62601 .34991 m
.62636 .34623 L
s
.24 .35 .67 r
.63337 .35131 m
.63376 .35285 L
s
.83 .24 .1 r
.54831 .27383 m
.5163 .26899 L
s
.51668 .23634 m
.5163 .26899 L
s
.5163 .26899 m
.4837 .26899 L
s
.48332 .23634 m
.4837 .26899 L
s
.4837 .26899 m
.45169 .27383 L
s
.7 .195 .071 r
.34434 .49304 m .34257 .47947 L .34203 .45938 L p F P
0 0 0 r
s
.157 .045 .023 r
.34257 .47947 m .34434 .49304 L .34886 .51338 L p F P
0 0 0 r
s
.83 .24 .1 r
.34692 .4992 m
.34848 .51131 L
s
.3454 .4735 m
.34692 .4992 L
s
.098 .028 .012 r
.65566 .49304 m .65743 .47947 L .65797 .45938 L p F P
0 0 0 r
s
.796 .229 .086 r
.65743 .47947 m .65566 .49304 L .65114 .51338 L p F P
0 0 0 r
s
.83 .24 .1 r
.65308 .4992 m
.6546 .4735 L
s
.65152 .51131 m
.65308 .4992 L
s
.24 .35 .67 r
.77257 .63648 m
.76749 .64765 L
s
.81208 .64765 m
.818 .63648 L
s
.76749 .64765 m
.81208 .64765 L
s
.72714 .63648 m
.72291 .64765 L
s
.72291 .64765 m
.76749 .64765 L
s
.68172 .63648 m
.67833 .64765 L
s
.67833 .64765 m
.72291 .64765 L
s
.63629 .63648 m
.63375 .64765 L
s
.63375 .64765 m
.67833 .64765 L
s
.58916 .64765 m
.59086 .63648 L
s
.58916 .64765 m
.63375 .64765 L
s
.55232 .64765 m
.58916 .64765 L
s
.54458 .64765 m
.54879 .64765 L
s
.5 .64765 m
.54458 .64765 L
s
.45542 .64765 m
.5 .64765 L
s
.40914 .63648 m
.41084 .64765 L
s
.41084 .64765 m
.44768 .64765 L
s
.45121 .64765 m
.45542 .64765 L
s
.36371 .63648 m
.36625 .64765 L
s
.36625 .64765 m
.41084 .64765 L
s
.31828 .63648 m
.32167 .64765 L
s
.32167 .64765 m
.36625 .64765 L
s
.27286 .63648 m
.27709 .64765 L
s
.27709 .64765 m
.32167 .64765 L
s
.22743 .63648 m
.23251 .64765 L
s
.23251 .64765 m
.27709 .64765 L
s
.182 .63648 m
.18792 .64765 L
s
.18792 .64765 m
.23251 .64765 L
s
.271 .418 .822 r
.52502 .6414 m .52145 .6414 L .54176 .64919 L p F P
0 0 0 r
s
.271 .418 .822 r
.54176 .64919 m .54872 .64919 L .52502 .6414 L p F P
0 0 0 r
s
.271 .418 .822 r
.52145 .6414 m .51787 .6414 L .5348 .64919 L p F P
0 0 0 r
s
.271 .418 .822 r
.5348 .64919 m .54176 .64919 L .52145 .6414 L p F P
0 0 0 r
s
.271 .418 .822 r
.51787 .6414 m .5143 .6414 L .52784 .64919 L p F P
0 0 0 r
s
.271 .418 .822 r
.52784 .64919 m .5348 .64919 L .51787 .6414 L p F P
0 0 0 r
s
.271 .418 .822 r
.5143 .6414 m .51072 .6414 L .52088 .64919 L p F P
0 0 0 r
s
.271 .418 .822 r
.52088 .64919 m .52784 .64919 L .5143 .6414 L p F P
0 0 0 r
s
.271 .418 .822 r
.51072 .6414 m .50715 .6414 L .51392 .64919 L p F P
0 0 0 r
s
.271 .418 .822 r
.51392 .64919 m .52088 .64919 L .51072 .6414 L p F P
0 0 0 r
s
.271 .418 .822 r
.50715 .6414 m .50357 .6414 L .50696 .64919 L p F P
0 0 0 r
s
.271 .418 .822 r
.50696 .64919 m .51392 .64919 L .50715 .6414 L p F P
0 0 0 r
s
.271 .418 .822 r
.50357 .6414 m .5 .6414 L .5 .64919 L p F P
0 0 0 r
s
.271 .418 .822 r
.5 .64919 m .50696 .64919 L .50357 .6414 L p F P
0 0 0 r
s
.271 .418 .822 r
.5 .6414 m .49643 .6414 L .49304 .64919 L p F P
0 0 0 r
s
.271 .418 .822 r
.49304 .64919 m .5 .64919 L .5 .6414 L p F P
0 0 0 r
s
.271 .418 .822 r
.49643 .6414 m .49285 .6414 L .48608 .64919 L p F P
0 0 0 r
s
.271 .418 .822 r
.48608 .64919 m .49304 .64919 L .49643 .6414 L p F P
0 0 0 r
s
.271 .418 .822 r
.49285 .6414 m .48928 .6414 L .47912 .64919 L p F P
0 0 0 r
s
.271 .418 .822 r
.47912 .64919 m .48608 .64919 L .49285 .6414 L p F P
0 0 0 r
s
.271 .418 .822 r
.48928 .6414 m .4857 .6414 L .47216 .64919 L p F P
0 0 0 r
s
.271 .418 .822 r
.47216 .64919 m .47912 .64919 L .48928 .6414 L p F P
0 0 0 r
s
.271 .418 .822 r
.4857 .6414 m .48213 .6414 L .4652 .64919 L p F P
0 0 0 r
s
.271 .418 .822 r
.4652 .64919 m .47216 .64919 L .4857 .6414 L p F P
0 0 0 r
s
.271 .418 .822 r
.48213 .6414 m .47855 .6414 L .45824 .64919 L p F P
0 0 0 r
s
.271 .418 .822 r
.45824 .64919 m .4652 .64919 L .48213 .6414 L p F P
0 0 0 r
s
.271 .418 .822 r
.47855 .6414 m .47498 .6414 L .45128 .64919 L p F P
0 0 0 r
s
.83 .24 .1 r
.45185 .64903 m
.45185 .64919 L
s
.271 .418 .822 r
.45128 .64919 m .45824 .64919 L .47855 .6414 L p F P
0 0 0 r
s
.898 .269 .117 r
.45111 .64553 m .45128 .64919 L .47498 .6414 L p F P
0 0 0 r
s
.83 .24 .1 r
.45111 .64551 m
.45113 .64552 L
s
1 .318 .134 r
.54889 .64553 m .54872 .64919 L .52502 .6414 L p F P
0 0 0 r
s
.83 .24 .1 r
.54887 .64552 m
.54889 .64551 L
s
.814 .245 .108 r
.42802 .63152 m .4284 .63697 L .45076 .63812 L p F P
0 0 0 r
s
.814 .245 .108 r
.45093 .64183 m .45076 .63812 L .4284 .63697 L p F P
0 0 0 r
s
1 .329 .137 r
.54907 .64183 m .54924 .63812 L .5716 .63697 L p F P
0 0 0 r
s
1 .329 .137 r
.57198 .63152 m .5716 .63697 L .54924 .63812 L p F P
0 0 0 r
s
.83 .24 .1 r
.62636 .34623 m
.63216 .35312 L
s
.62926 .31531 m
.62636 .34623 L
s
.37074 .31531 m
.37364 .34623 L
s
.36784 .35312 m
.37364 .34623 L
s
1 .318 .127 r
.35787 .35679 m .35931 .3703 L .34789 .38223 L p F P
0 0 0 r
s
.83 .24 .1 r
.35578 .36744 m
.36475 .35679 L
s
1 .318 .127 r
.34953 .3964 m .34789 .38223 L .35931 .3703 L p F P
0 0 0 r
s
.83 .24 .1 r
.35578 .36744 m
.35898 .39685 L
s
.332 .1 .051 r
.65047 .3964 m .65211 .38223 L .64069 .3703 L p F P
0 0 0 r
s
.332 .1 .051 r
.64213 .35679 m .64069 .3703 L .65211 .38223 L p F P
0 0 0 r
s
.83 .24 .1 r
.64102 .39685 m
.64422 .36744 L
s
.63525 .35679 m
.64422 .36744 L
s
.46339 .64787 m
.48362 .65156 L
s
.51638 .65156 m
.53661 .64787 L
s
.57857 .28338 m
.54831 .27383 L
s
.54943 .24121 m
.54831 .27383 L
s
.45057 .24121 m
.45169 .27383 L
s
.45169 .27383 m
.42143 .28338 L
s
.899 .254 .097 r
.34203 .45938 m .34021 .44522 L .34375 .42663 L p F P
0 0 0 r
s
.7 .195 .071 r
.34021 .44522 m .34203 .45938 L .34257 .47947 L p F P
0 0 0 r
s
.181 .052 .027 r
.65797 .45938 m .65979 .44522 L .65625 .42663 L p F P
0 0 0 r
s
.098 .028 .012 r
.65979 .44522 m .65797 .45938 L .65743 .47947 L p F P
0 0 0 r
s
.43 .135 .065 r
.38829 .59894 m .38739 .59009 L .37208 .57435 L p F P
0 0 0 r
s
.83 .24 .1 r
.3734 .57358 m
.37367 .576 L
s
.583 .18 .083 r
.38739 .59009 m .38829 .59894 L .40645 .61103 L p F P
0 0 0 r
s
.583 .18 .083 r
.40707 .61825 m .40645 .61103 L .38829 .59894 L p F P
0 0 0 r
s
1 .338 .138 r
.59293 .61825 m .59355 .61103 L .61171 .59894 L p F P
0 0 0 r
s
1 .338 .138 r
.61261 .59009 m .61171 .59894 L .59355 .61103 L p F P
0 0 0 r
s
1 .333 .134 r
.61171 .59894 m .61261 .59009 L .62792 .57435 L p F P
0 0 0 r
s
.83 .24 .1 r
.62633 .576 m
.6266 .57358 L
s
.712 .216 .097 r
.40645 .61103 m .40707 .61825 L .42765 .626 L p F P
0 0 0 r
s
.712 .216 .097 r
.42802 .63152 m .42765 .626 L .40707 .61825 L p F P
0 0 0 r
s
1 .336 .139 r
.57198 .63152 m .57235 .626 L .59293 .61825 L p F P
0 0 0 r
s
1 .336 .139 r
.59355 .61103 m .59293 .61825 L .57235 .626 L p F P
0 0 0 r
s
.32 .095 .05 r
.37208 .57435 m .37089 .56398 L .35881 .54545 L p F P
0 0 0 r
s
.43 .135 .065 r
.37089 .56398 m .37208 .57435 L .38739 .59009 L p F P
0 0 0 r
s
1 .333 .134 r
.62911 .56398 m .62792 .57435 L .61261 .59009 L p F P
0 0 0 r
s
1 .315 .125 r
.62792 .57435 m .62911 .56398 L .64119 .54545 L p F P
0 0 0 r
s
1 .295 .116 r
.34375 .42663 m .34197 .41225 L .34953 .3964 L p F P
0 0 0 r
s
.899 .254 .097 r
.34197 .41225 m .34375 .42663 L .34021 .44522 L p F P
0 0 0 r
s
.181 .052 .027 r
.65803 .41225 m .65625 .42663 L .65979 .44522 L p F P
0 0 0 r
s
.249 .072 .039 r
.65625 .42663 m .65803 .41225 L .65047 .3964 L p F P
0 0 0 r
s
1 .295 .116 r
.34789 .38223 m .34953 .3964 L .34197 .41225 L p F P
0 0 0 r
s
.249 .072 .039 r
.65211 .38223 m .65047 .3964 L .65803 .41225 L p F P
0 0 0 r
s
.898 .269 .117 r
.45093 .64183 m .45111 .64553 L .47493 .63951 L p F P
0 0 0 r
s
.83 .24 .1 r
.45168 .64538 m
.45168 .64543 L
s
.898 .269 .117 r
.47498 .6414 m .47493 .63951 L .45111 .64553 L p F P
0 0 0 r
s
1 .318 .134 r
.52502 .6414 m .52507 .63951 L .54889 .64553 L p F P
0 0 0 r
s
1 .318 .134 r
.54907 .64183 m .54889 .64553 L .52507 .63951 L p F P
0 0 0 r
s
.83 .24 .1 r
.48347 .64207 m
.48362 .65156 L
s
.48362 .65156 m
.51638 .65156 L
s
.51638 .65156 m
.51653 .64207 L
s
.236 .068 .036 r
.35881 .54545 m .35736 .53369 L .34886 .51338 L p F P
0 0 0 r
s
.32 .095 .05 r
.35736 .53369 m .35881 .54545 L .37089 .56398 L p F P
0 0 0 r
s
1 .315 .125 r
.64264 .53369 m .64119 .54545 L .62911 .56398 L p F P
0 0 0 r
s
.973 .282 .11 r
.64119 .54545 m .64264 .53369 L .65114 .51338 L p F P
0 0 0 r
s
.814 .245 .108 r
.42765 .626 m .42802 .63152 L .45059 .63437 L p F P
0 0 0 r
s
.814 .245 .108 r
.45076 .63812 m .45059 .63437 L .42802 .63152 L p F P
0 0 0 r
s
1 .329 .137 r
.54924 .63812 m .54941 .63437 L .57198 .63152 L p F P
0 0 0 r
s
1 .329 .137 r
.57235 .626 m .57198 .63152 L .54941 .63437 L p F P
0 0 0 r
s
.83 .24 .1 r
.60592 .29735 m
.57857 .28338 L
s
.58039 .25081 m
.57857 .28338 L
s
.41961 .25081 m
.42143 .28338 L
s
.42143 .28338 m
.39408 .29735 L
s
.898 .269 .117 r
.45076 .63812 m .45093 .64183 L .47489 .63761 L p F P
0 0 0 r
s
.83 .24 .1 r
.45151 .64173 m
.45151 .64178 L
s
.898 .269 .117 r
.47493 .63951 m .47489 .63761 L .45093 .64183 L p F P
0 0 0 r
s
1 .318 .134 r
.52507 .63951 m .52511 .63761 L .54907 .64183 L p F P
0 0 0 r
s
1 .318 .134 r
.54924 .63812 m .54907 .64183 L .52511 .63761 L p F P
0 0 0 r
s
.157 .045 .023 r
.34886 .51338 m .3472 .50043 L .34257 .47947 L p F P
0 0 0 r
s
.236 .068 .036 r
.3472 .50043 m .34886 .51338 L .35736 .53369 L p F P
0 0 0 r
s
.83 .24 .1 r
.35533 .52438 m
.35589 .52888 L
s
.973 .282 .11 r
.6528 .50043 m .65114 .51338 L .64264 .53369 L p F P
0 0 0 r
s
.83 .24 .1 r
.64411 .52888 m
.64467 .52438 L
s
.796 .229 .086 r
.65114 .51338 m .6528 .50043 L .65743 .47947 L p F P
0 0 0 r
s
.583 .18 .083 r
.40645 .61103 m .40581 .60371 L .38739 .59009 L p F P
0 0 0 r
s
.712 .216 .097 r
.40581 .60371 m .40645 .61103 L .42727 .62042 L p F P
0 0 0 r
s
.712 .216 .097 r
.42765 .626 m .42727 .62042 L .40645 .61103 L p F P
0 0 0 r
s
1 .336 .139 r
.57235 .626 m .57273 .62042 L .59355 .61103 L p F P
0 0 0 r
s
1 .336 .139 r
.59419 .60371 m .59355 .61103 L .57273 .62042 L p F P
0 0 0 r
s
1 .338 .138 r
.59355 .61103 m .59419 .60371 L .61261 .59009 L p F P
0 0 0 r
s
.43 .135 .065 r
.38739 .59009 m .38647 .5811 L .37089 .56398 L p F P
0 0 0 r
s
.583 .18 .083 r
.38647 .5811 m .38739 .59009 L .40581 .60371 L p F P
0 0 0 r
s
1 .338 .138 r
.61353 .5811 m .61261 .59009 L .59419 .60371 L p F P
0 0 0 r
s
.83 .24 .1 r
.61295 .58684 m
.61739 .58252 L
s
1 .333 .134 r
.61261 .59009 m .61353 .5811 L .62911 .56398 L p F P
0 0 0 r
s
.898 .269 .117 r
.45059 .63437 m .45076 .63812 L .47484 .6357 L p F P
0 0 0 r
s
.83 .24 .1 r
.45134 .63806 m
.45134 .6381 L
s
.898 .269 .117 r
.47489 .63761 m .47484 .6357 L .45076 .63812 L p F P
0 0 0 r
s
.24 .35 .67 r
.45457 .63648 m
.45511 .6436 L
s
1 .318 .134 r
.52511 .63761 m .52516 .6357 L .54924 .63812 L p F P
0 0 0 r
s
1 .318 .134 r
.54941 .63437 m .54924 .63812 L .52516 .6357 L p F P
0 0 0 r
s
.24 .35 .67 r
.54489 .6436 m
.54543 .63648 L
s
.814 .245 .108 r
.42727 .62042 m .42765 .626 L .45041 .6306 L p F P
0 0 0 r
s
.814 .245 .108 r
.45059 .63437 m .45041 .6306 L .42765 .626 L p F P
0 0 0 r
s
1 .329 .137 r
.54941 .63437 m .54959 .6306 L .57235 .626 L p F P
0 0 0 r
s
1 .329 .137 r
.57273 .62042 m .57235 .626 L .54959 .6306 L p F P
0 0 0 r
s
.7 .195 .071 r
.34257 .47947 m .34077 .46558 L .34021 .44522 L p F P
0 0 0 r
s
.83 .24 .1 r
.34188 .44579 m
.34724 .42048 L
s
.157 .045 .023 r
.34077 .46558 m .34257 .47947 L .3472 .50043 L p F P
0 0 0 r
s
.83 .24 .1 r
.34188 .44579 m
.3454 .4735 L
s
.34704 .49954 m
.35533 .52438 L
s
.098 .028 .012 r
.65743 .47947 m .65923 .46558 L .65979 .44522 L p F P
0 0 0 r
s
.796 .229 .086 r
.65923 .46558 m .65743 .47947 L .6528 .50043 L p F P
0 0 0 r
s
.83 .24 .1 r
.64467 .52438 m
.65296 .49954 L
s
.6546 .4735 m
.65812 .44579 L
s
.65276 .42048 m
.65812 .44579 L
s
1 .318 .127 r
.34789 .38223 m .3462 .36775 L .35787 .35679 L p F P
0 0 0 r
s
.332 .1 .051 r
.65211 .38223 m .6538 .36775 L .64213 .35679 L p F P
0 0 0 r
s
.119 .144 .278 r
.35787 .35679 m .37817 .35679 L .36817 .36775 L p F P
0 0 0 r
s
.119 .144 .278 r
.36817 .36775 m .3462 .36775 L .35787 .35679 L p F P
0 0 0 r
s
.83 .24 .1 r
.35242 .33666 m
.35503 .36063 L
s
.119 .144 .278 r
.37817 .35679 m .39848 .35679 L .39015 .36775 L p F P
0 0 0 r
s
.119 .144 .278 r
.39015 .36775 m .36817 .36775 L .37817 .35679 L p F P
0 0 0 r
s
.119 .144 .278 r
.39848 .35679 m .41878 .35679 L .41212 .36775 L p F P
0 0 0 r
s
.119 .144 .278 r
.41212 .36775 m .39015 .36775 L .39848 .35679 L p F P
0 0 0 r
s
.119 .144 .278 r
.41878 .35679 m .43909 .35679 L .43409 .36775 L p F P
0 0 0 r
s
.119 .144 .278 r
.43409 .36775 m .41212 .36775 L .41878 .35679 L p F P
0 0 0 r
s
.119 .144 .278 r
.43909 .35679 m .45939 .35679 L .45606 .36775 L p F P
0 0 0 r
s
.119 .144 .278 r
.45606 .36775 m .43409 .36775 L .43909 .35679 L p F P
0 0 0 r
s
.119 .144 .278 r
.45939 .35679 m .4797 .35679 L .47803 .36775 L p F P
0 0 0 r
s
.119 .144 .278 r
.47803 .36775 m .45606 .36775 L .45939 .35679 L p F P
0 0 0 r
s
.119 .144 .278 r
.4797 .35679 m .5 .35679 L .5 .36775 L p F P
0 0 0 r
s
.119 .144 .278 r
.5 .36775 m .47803 .36775 L .4797 .35679 L p F P
0 0 0 r
s
.119 .144 .278 r
.5 .35679 m .5203 .35679 L .52197 .36775 L p F P
0 0 0 r
s
.119 .144 .278 r
.52197 .36775 m .5 .36775 L .5 .35679 L p F P
0 0 0 r
s
.119 .144 .278 r
.5203 .35679 m .54061 .35679 L .54394 .36775 L p F P
0 0 0 r
s
.119 .144 .278 r
.54394 .36775 m .52197 .36775 L .5203 .35679 L p F P
0 0 0 r
s
.119 .144 .278 r
.54061 .35679 m .56091 .35679 L .56591 .36775 L p F P
0 0 0 r
s
.119 .144 .278 r
.56591 .36775 m .54394 .36775 L .54061 .35679 L p F P
0 0 0 r
s
.119 .144 .278 r
.56091 .35679 m .58122 .35679 L .58788 .36775 L p F P
0 0 0 r
s
.119 .144 .278 r
.58788 .36775 m .56591 .36775 L .56091 .35679 L p F P
0 0 0 r
s
.119 .144 .278 r
.58122 .35679 m .60152 .35679 L .60985 .36775 L p F P
0 0 0 r
s
.119 .144 .278 r
.60985 .36775 m .58788 .36775 L .58122 .35679 L p F P
0 0 0 r
s
.119 .144 .278 r
.60152 .35679 m .62183 .35679 L .63183 .36775 L p F P
0 0 0 r
s
.119 .144 .278 r
.63183 .36775 m .60985 .36775 L .60152 .35679 L p F P
0 0 0 r
s
.119 .144 .278 r
.62183 .35679 m .64213 .35679 L .6538 .36775 L p F P
0 0 0 r
s
.119 .144 .278 r
.6538 .36775 m .63183 .36775 L .62183 .35679 L p F P
0 0 0 r
s
.83 .24 .1 r
.64497 .36063 m
.64758 .33666 L
s
.32 .095 .05 r
.37089 .56398 m .36968 .55341 L .35736 .53369 L p F P
0 0 0 r
s
.43 .135 .065 r
.36968 .55341 m .37089 .56398 L .38647 .5811 L p F P
0 0 0 r
s
1 .333 .134 r
.63032 .55341 m .62911 .56398 L .61353 .5811 L p F P
0 0 0 r
s
1 .315 .125 r
.62911 .56398 m .63032 .55341 L .64264 .53369 L p F P
0 0 0 r
s
.899 .254 .097 r
.34021 .44522 m .33836 .43072 L .34197 .41225 L p F P
0 0 0 r
s
.7 .195 .071 r
.33836 .43072 m .34021 .44522 L .34077 .46558 L p F P
0 0 0 r
s
.181 .052 .027 r
.65979 .44522 m .66164 .43072 L .65803 .41225 L p F P
0 0 0 r
s
.098 .028 .012 r
.66164 .43072 m .65979 .44522 L .65923 .46558 L p F P
0 0 0 r
s
.83 .24 .1 r
.62926 .31531 m
.60592 .29735 L
s
.60839 .26485 m
.60592 .29735 L
s
.39161 .26485 m
.39408 .29735 L
s
.39408 .29735 m
.37074 .31531 L
s
.898 .269 .117 r
.45041 .6306 m .45059 .63437 L .4748 .63378 L p F P
0 0 0 r
s
.83 .24 .1 r
.45117 .63436 m
.45117 .6344 L
s
.898 .269 .117 r
.47484 .6357 m .4748 .63378 L .45059 .63437 L p F P
0 0 0 r
s
1 .318 .134 r
.52516 .6357 m .5252 .63378 L .54941 .63437 L p F P
0 0 0 r
s
1 .318 .134 r
.54959 .6306 m .54941 .63437 L .5252 .63378 L p F P
0 0 0 r
s
.249 .072 .039 r
.65803 .41225 m .65985 .39754 L .65211 .38223 L p F P
0 0 0 r
s
.249 .072 .039 r
.6538 .36775 m .65211 .38223 L .65985 .39754 L p F P
0 0 0 r
s
.83 .24 .1 r
.65276 .42048 m
.65628 .39126 L
s
.64438 .36775 m
.65628 .39126 L
s
1 .295 .116 r
.3462 .36775 m .34789 .38223 L .34015 .39754 L p F P
0 0 0 r
s
1 .295 .116 r
.34197 .41225 m .34015 .39754 L .34789 .38223 L p F P
0 0 0 r
s
.83 .24 .1 r
.34372 .39126 m
.34724 .42048 L
s
.34372 .39126 m
.35562 .36775 L
s
.286 .433 .851 r
.52145 .6414 m .52502 .6414 L .5 .62969 L closepath p F P
0 0 0 r
s
.286 .433 .851 r
.51787 .6414 m .52145 .6414 L .5 .62969 L closepath p F P
0 0 0 r
s
.286 .433 .851 r
.5143 .6414 m .51787 .6414 L .5 .62969 L closepath p F P
0 0 0 r
s
.286 .433 .851 r
.51072 .6414 m .5143 .6414 L .5 .62969 L closepath p F P
0 0 0 r
s
.286 .433 .851 r
.50715 .6414 m .51072 .6414 L .5 .62969 L closepath p F P
0 0 0 r
s
.286 .433 .851 r
.50357 .6414 m .50715 .6414 L .5 .62969 L closepath p F P
0 0 0 r
s
.286 .433 .851 r
.5 .6414 m .50357 .6414 L .5 .62969 L closepath p F P
0 0 0 r
s
.286 .433 .851 r
.49643 .6414 m .5 .6414 L .5 .62969 L closepath p F P
0 0 0 r
s
.286 .433 .851 r
.49285 .6414 m .49643 .6414 L .5 .62969 L closepath p F P
0 0 0 r
s
.286 .433 .851 r
.48928 .6414 m .49285 .6414 L .5 .62969 L closepath p F P
0 0 0 r
s
.286 .433 .851 r
.4857 .6414 m .48928 .6414 L .5 .62969 L closepath p F P
0 0 0 r
s
.286 .433 .851 r
.48213 .6414 m .4857 .6414 L .5 .62969 L closepath p F P
0 0 0 r
s
.286 .433 .851 r
.47855 .6414 m .48213 .6414 L .5 .62969 L closepath p F P
0 0 0 r
s
.286 .433 .851 r
.47498 .6414 m .47855 .6414 L .5 .62969 L closepath p F P
0 0 0 r
s
.968 .289 .124 r
.5 .62969 m .47493 .63951 L .47498 .6414 L closepath p F P
0 0 0 r
s
1 .305 .13 r
.52507 .63951 m .52502 .6414 L .5 .62969 L closepath p F P
0 0 0 r
s
.899 .254 .097 r
.34015 .39754 m .34197 .41225 L .33836 .43072 L p F P
0 0 0 r
s
.181 .052 .027 r
.65985 .39754 m .65803 .41225 L .66164 .43072 L p F P
0 0 0 r
s
.236 .068 .036 r
.35736 .53369 m .35588 .52169 L .3472 .50043 L p F P
0 0 0 r
s
.32 .095 .05 r
.35588 .52169 m .35736 .53369 L .36968 .55341 L p F P
0 0 0 r
s
1 .315 .125 r
.64412 .52169 m .64264 .53369 L .63032 .55341 L p F P
0 0 0 r
s
.83 .24 .1 r
.64358 .52606 m
.64467 .52438 L
s
.973 .282 .11 r
.64264 .53369 m .64412 .52169 L .6528 .50043 L p F P
0 0 0 r
s
.24 .35 .67 r
.77186 .36147 m
.81717 .36147 L
s
.72655 .36147 m
.77186 .36147 L
s
.68124 .36147 m
.72655 .36147 L
s
.64712 .36147 m
.68124 .36147 L
s
.31876 .36147 m
.35288 .36147 L
s
.27345 .36147 m
.31876 .36147 L
s
.22814 .36147 m
.27345 .36147 L
s
.18283 .36147 m
.22814 .36147 L
s
.77186 .36147 m
.77658 .37848 L
s
.82268 .37848 m
.81717 .36147 L
s
.72655 .36147 m
.73048 .37848 L
s
.68124 .36147 m
.68439 .37848 L
s
.31876 .36147 m
.31561 .37848 L
s
.27345 .36147 m
.26952 .37848 L
s
.22814 .36147 m
.22342 .37848 L
s
.18283 .36147 m
.17732 .37848 L
s
.712 .216 .097 r
.42727 .62042 m .42689 .61479 L .40581 .60371 L p F P
0 0 0 r
s
.814 .245 .108 r
.42689 .61479 m .42727 .62042 L .45023 .6268 L p F P
0 0 0 r
s
.814 .245 .108 r
.45041 .6306 m .45023 .6268 L .42727 .62042 L p F P
0 0 0 r
s
1 .329 .137 r
.54959 .6306 m .54977 .6268 L .57273 .62042 L p F P
0 0 0 r
s
1 .329 .137 r
.57311 .61479 m .57273 .62042 L .54977 .6268 L p F P
0 0 0 r
s
1 .336 .139 r
.57273 .62042 m .57311 .61479 L .59419 .60371 L p F P
0 0 0 r
s
.968 .289 .124 r
.5 .62969 m .47489 .63761 L .47493 .63951 L closepath p F P
0 0 0 r
s
1 .305 .13 r
.52511 .63761 m .52507 .63951 L .5 .62969 L closepath p F P
0 0 0 r
s
.583 .18 .083 r
.40581 .60371 m .40517 .59629 L .38647 .5811 L p F P
0 0 0 r
s
.712 .216 .097 r
.40517 .59629 m .40581 .60371 L .42689 .61479 L p F P
0 0 0 r
s
1 .336 .139 r
.59483 .59629 m .59419 .60371 L .57311 .61479 L p F P
0 0 0 r
s
.83 .24 .1 r
.59443 .60093 m
.59902 .59806 L
s
1 .338 .138 r
.59419 .60371 m .59483 .59629 L .61353 .5811 L p F P
0 0 0 r
s
.898 .269 .117 r
.45023 .6268 m .45041 .6306 L .47475 .63186 L p F P
0 0 0 r
s
.83 .24 .1 r
.451 .63063 m
.451 .63068 L
s
.898 .269 .117 r
.4748 .63378 m .47475 .63186 L .45041 .6306 L p F P
0 0 0 r
s
1 .318 .134 r
.5252 .63378 m .52525 .63186 L .54959 .6306 L p F P
0 0 0 r
s
1 .318 .134 r
.54977 .6268 m .54959 .6306 L .52525 .63186 L p F P
0 0 0 r
s
.968 .289 .124 r
.5 .62969 m .47484 .6357 L .47489 .63761 L closepath p F P
0 0 0 r
s
1 .305 .13 r
.52516 .6357 m .52511 .63761 L .5 .62969 L closepath p F P
0 0 0 r
s
.43 .135 .065 r
.38647 .5811 m .38553 .57195 L .36968 .55341 L p F P
0 0 0 r
s
.583 .18 .083 r
.38553 .57195 m .38647 .5811 L .40517 .59629 L p F P
0 0 0 r
s
1 .338 .138 r
.61447 .57195 m .61353 .5811 L .59483 .59629 L p F P
0 0 0 r
s
1 .333 .134 r
.61353 .5811 m .61447 .57195 L .63032 .55341 L p F P
0 0 0 r
s
.24 .35 .67 r
.77722 .61852 m
.77257 .63648 L
s
.818 .63648 m
.82342 .61852 L
s
.77257 .63648 m
.818 .63648 L
s
.73101 .61852 m
.72714 .63648 L
s
.72714 .63648 m
.77257 .63648 L
s
.68481 .61852 m
.68172 .63648 L
s
.68172 .63648 m
.72714 .63648 L
s
.63861 .61852 m
.63629 .63648 L
s
.63629 .63648 m
.68172 .63648 L
s
.59086 .63648 m
.59241 .61852 L
s
.59086 .63648 m
.63629 .63648 L
s
.54543 .63648 m
.59086 .63648 L
s
.52721 .63648 m
.54543 .63648 L
s
.45457 .63648 m
.47279 .63648 L
s
.40759 .61852 m
.40914 .63648 L
s
.40914 .63648 m
.45457 .63648 L
s
.36139 .61852 m
.36371 .63648 L
s
.36371 .63648 m
.40914 .63648 L
s
.31519 .61852 m
.31828 .63648 L
s
.31828 .63648 m
.36371 .63648 L
s
.26899 .61852 m
.27286 .63648 L
s
.27286 .63648 m
.31828 .63648 L
s
.22278 .61852 m
.22743 .63648 L
s
.22743 .63648 m
.27286 .63648 L
s
.17658 .61852 m
.182 .63648 L
s
.182 .63648 m
.22743 .63648 L
s
.157 .045 .023 r
.3472 .50043 m .3455 .48719 L .34077 .46558 L p F P
0 0 0 r
s
.236 .068 .036 r
.3455 .48719 m .3472 .50043 L .35588 .52169 L p F P
0 0 0 r
s
.973 .282 .11 r
.6545 .48719 m .6528 .50043 L .64412 .52169 L p F P
0 0 0 r
s
.796 .229 .086 r
.6528 .50043 m .6545 .48719 L .65923 .46558 L p F P
0 0 0 r
s
.968 .289 .124 r
.5 .62969 m .4748 .63378 L .47484 .6357 L closepath p F P
0 0 0 r
s
1 .305 .13 r
.5252 .63378 m .52516 .6357 L .5 .62969 L closepath p F P
0 0 0 r
s
.712 .216 .097 r
.42689 .61479 m .4265 .6091 L .40517 .59629 L p F P
0 0 0 r
s
.814 .245 .108 r
.4265 .6091 m .42689 .61479 L .45005 .62298 L p F P
0 0 0 r
s
.814 .245 .108 r
.45023 .6268 m .45005 .62298 L .42689 .61479 L p F P
0 0 0 r
s
.83 .24 .1 r
.44289 .61875 m
.45058 .62168 L
s
1 .329 .137 r
.54977 .6268 m .54995 .62298 L .57311 .61479 L p F P
0 0 0 r
s
1 .329 .137 r
.5735 .6091 m .57311 .61479 L .54995 .62298 L p F P
0 0 0 r
s
.83 .24 .1 r
.54942 .62168 m
.55711 .61875 L
s
.57326 .61262 m
.57759 .61098 L
s
1 .336 .139 r
.57311 .61479 m .5735 .6091 L .59483 .59629 L p F P
0 0 0 r
s
.898 .269 .117 r
.45005 .62298 m .45023 .6268 L .4747 .62994 L p F P
0 0 0 r
s
.83 .24 .1 r
.45058 .62168 m
.45065 .62315 L
s
.45082 .62688 m
.45082 .62692 L
s
.898 .269 .117 r
.47475 .63186 m .4747 .62994 L .45023 .6268 L p F P
0 0 0 r
s
1 .318 .134 r
.52525 .63186 m .5253 .62994 L .54977 .6268 L p F P
0 0 0 r
s
1 .318 .134 r
.54995 .62298 m .54977 .6268 L .5253 .62994 L p F P
0 0 0 r
s
.83 .24 .1 r
.54935 .62315 m
.54942 .62168 L
s
.32 .095 .05 r
.36968 .55341 m .36844 .54264 L .35588 .52169 L p F P
0 0 0 r
s
.43 .135 .065 r
.36844 .54264 m .36968 .55341 L .38553 .57195 L p F P
0 0 0 r
s
1 .333 .134 r
.63156 .54264 m .63032 .55341 L .61447 .57195 L p F P
0 0 0 r
s
1 .315 .125 r
.63032 .55341 m .63156 .54264 L .64412 .52169 L p F P
0 0 0 r
s
.968 .289 .124 r
.5 .62969 m .47475 .63186 L .4748 .63378 L closepath p F P
0 0 0 r
s
1 .305 .13 r
.52525 .63186 m .5252 .63378 L .5 .62969 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.54943 .24121 m
.51668 .23634 L
s
.51707 .20215 m
.51668 .23634 L
s
.51668 .23634 m
.48332 .23634 L
s
.48293 .20215 m
.48332 .23634 L
s
.48332 .23634 m
.45057 .24121 L
s
.7 .195 .071 r
.34077 .46558 m .33892 .45138 L .33836 .43072 L p F P
0 0 0 r
s
.157 .045 .023 r
.33892 .45138 m .34077 .46558 L .3455 .48719 L p F P
0 0 0 r
s
.83 .24 .1 r
.34339 .47174 m
.3451 .48501 L
s
.34188 .44579 m
.34339 .47174 L
s
.098 .028 .012 r
.65923 .46558 m .66108 .45138 L .66164 .43072 L p F P
0 0 0 r
s
.796 .229 .086 r
.66108 .45138 m .65923 .46558 L .6545 .48719 L p F P
0 0 0 r
s
.83 .24 .1 r
.65661 .47174 m
.65812 .44579 L
s
.6549 .48501 m
.65661 .47174 L
s
.583 .18 .083 r
.40517 .59629 m .40452 .58877 L .38553 .57195 L p F P
0 0 0 r
s
.712 .216 .097 r
.40452 .58877 m .40517 .59629 L .4265 .6091 L p F P
0 0 0 r
s
1 .336 .139 r
.59548 .58877 m .59483 .59629 L .5735 .6091 L p F P
0 0 0 r
s
1 .338 .138 r
.59483 .59629 m .59548 .58877 L .61447 .57195 L p F P
0 0 0 r
s
.83 .24 .1 r
.64758 .33666 m
.62926 .31531 L
s
.63231 .28292 m
.62926 .31531 L
s
.36769 .28292 m
.37074 .31531 L
s
.37074 .31531 m
.35242 .33666 L
s
.968 .289 .124 r
.5 .62969 m .4747 .62994 L .47475 .63186 L closepath p F P
0 0 0 r
s
1 .305 .13 r
.5253 .62994 m .52525 .63186 L .5 .62969 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.58039 .25081 m
.54943 .24121 L
s
.55059 .20704 m
.54943 .24121 L
s
.44941 .20704 m
.45057 .24121 L
s
.45057 .24121 m
.41961 .25081 L
s
.814 .245 .108 r
.45005 .62298 m .44987 .61912 L .4265 .6091 L p F P
0 0 0 r
s
.898 .269 .117 r
.44987 .61912 m .45005 .62298 L .47466 .628 L p F P
0 0 0 r
s
.898 .269 .117 r
.4747 .62994 m .47466 .628 L .45005 .62298 L p F P
0 0 0 r
s
.83 .24 .1 r
.46353 .62401 m
.48324 .62757 L
s
1 .318 .134 r
.5253 .62994 m .52534 .628 L .54995 .62298 L p F P
0 0 0 r
s
1 .318 .134 r
.55013 .61912 m .54995 .62298 L .52534 .628 L p F P
0 0 0 r
s
.83 .24 .1 r
.51676 .62757 m
.53647 .62401 L
s
1 .329 .137 r
.54995 .62298 m .55013 .61912 L .5735 .6091 L p F P
0 0 0 r
s
.899 .254 .097 r
.33836 .43072 m .33645 .41589 L .34015 .39754 L p F P
0 0 0 r
s
.7 .195 .071 r
.33645 .41589 m .33836 .43072 L .33892 .45138 L p F P
0 0 0 r
s
.181 .052 .027 r
.66164 .43072 m .66355 .41589 L .65985 .39754 L p F P
0 0 0 r
s
.098 .028 .012 r
.66355 .41589 m .66164 .43072 L .66108 .45138 L p F P
0 0 0 r
s
.968 .289 .124 r
.5 .62969 m .47466 .628 L .4747 .62994 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.48324 .62757 m
.48326 .62857 L
s
1 .305 .13 r
.52534 .628 m .5253 .62994 L .5 .62969 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.51674 .62857 m
.51676 .62757 L
s
1 .295 .116 r
.34015 .39754 m .33829 .38248 L .3462 .36775 L p F P
0 0 0 r
s
.249 .072 .039 r
.65985 .39754 m .66171 .38248 L .6538 .36775 L p F P
0 0 0 r
s
.161 .21 .408 r
.3462 .36775 m .36817 .36775 L .36139 .38248 L p F P
0 0 0 r
s
.161 .21 .408 r
.36139 .38248 m .33829 .38248 L .3462 .36775 L p F P
0 0 0 r
s
.83 .24 .1 r
.34005 .36067 m
.34209 .37767 L
s
.34267 .38248 m
.34372 .39126 L
s
.161 .21 .408 r
.36817 .36775 m .39015 .36775 L .38449 .38248 L p F P
0 0 0 r
s
.161 .21 .408 r
.38449 .38248 m .36139 .38248 L .36817 .36775 L p F P
0 0 0 r
s
.161 .21 .408 r
.39015 .36775 m .41212 .36775 L .40759 .38248 L p F P
0 0 0 r
s
.161 .21 .408 r
.40759 .38248 m .38449 .38248 L .39015 .36775 L p F P
0 0 0 r
s
.161 .21 .408 r
.41212 .36775 m .43409 .36775 L .4307 .38248 L p F P
0 0 0 r
s
.161 .21 .408 r
.4307 .38248 m .40759 .38248 L .41212 .36775 L p F P
0 0 0 r
s
.161 .21 .408 r
.43409 .36775 m .45606 .36775 L .4538 .38248 L p F P
0 0 0 r
s
.161 .21 .408 r
.4538 .38248 m .4307 .38248 L .43409 .36775 L p F P
0 0 0 r
s
.161 .21 .408 r
.45606 .36775 m .47803 .36775 L .4769 .38248 L p F P
0 0 0 r
s
.161 .21 .408 r
.4769 .38248 m .4538 .38248 L .45606 .36775 L p F P
0 0 0 r
s
.161 .21 .408 r
.47803 .36775 m .5 .36775 L .5 .38248 L p F P
0 0 0 r
s
.161 .21 .408 r
.5 .38248 m .4769 .38248 L .47803 .36775 L p F P
0 0 0 r
s
.161 .21 .408 r
.5 .36775 m .52197 .36775 L .5231 .38248 L p F P
0 0 0 r
s
.161 .21 .408 r
.5231 .38248 m .5 .38248 L .5 .36775 L p F P
0 0 0 r
s
.161 .21 .408 r
.52197 .36775 m .54394 .36775 L .5462 .38248 L p F P
0 0 0 r
s
.161 .21 .408 r
.5462 .38248 m .5231 .38248 L .52197 .36775 L p F P
0 0 0 r
s
.161 .21 .408 r
.54394 .36775 m .56591 .36775 L .5693 .38248 L p F P
0 0 0 r
s
.161 .21 .408 r
.5693 .38248 m .5462 .38248 L .54394 .36775 L p F P
0 0 0 r
s
.161 .21 .408 r
.56591 .36775 m .58788 .36775 L .59241 .38248 L p F P
0 0 0 r
s
.161 .21 .408 r
.59241 .38248 m .5693 .38248 L .56591 .36775 L p F P
0 0 0 r
s
.161 .21 .408 r
.58788 .36775 m .60985 .36775 L .61551 .38248 L p F P
0 0 0 r
s
.161 .21 .408 r
.61551 .38248 m .59241 .38248 L .58788 .36775 L p F P
0 0 0 r
s
.161 .21 .408 r
.60985 .36775 m .63183 .36775 L .63861 .38248 L p F P
0 0 0 r
s
.161 .21 .408 r
.63861 .38248 m .61551 .38248 L .60985 .36775 L p F P
0 0 0 r
s
.161 .21 .408 r
.63183 .36775 m .6538 .36775 L .66171 .38248 L p F P
0 0 0 r
s
.161 .21 .408 r
.66171 .38248 m .63861 .38248 L .63183 .36775 L p F P
0 0 0 r
s
.83 .24 .1 r
.65628 .39126 m
.65733 .38248 L
s
.65791 .37767 m
.65995 .36067 L
s
.236 .068 .036 r
.35588 .52169 m .35437 .50943 L .3455 .48719 L p F P
0 0 0 r
s
.32 .095 .05 r
.35437 .50943 m .35588 .52169 L .36844 .54264 L p F P
0 0 0 r
s
1 .315 .125 r
.64563 .50943 m .64412 .52169 L .63156 .54264 L p F P
0 0 0 r
s
.973 .282 .11 r
.64412 .52169 m .64563 .50943 L .6545 .48719 L p F P
0 0 0 r
s
.899 .254 .097 r
.33829 .38248 m .34015 .39754 L .33645 .41589 L p F P
0 0 0 r
s
.181 .052 .027 r
.66171 .38248 m .65985 .39754 L .66355 .41589 L p F P
0 0 0 r
s
.43 .135 .065 r
.38553 .57195 m .38458 .56266 L .36844 .54264 L p F P
0 0 0 r
s
.583 .18 .083 r
.38458 .56266 m .38553 .57195 L .40452 .58877 L p F P
0 0 0 r
s
1 .338 .138 r
.61542 .56266 m .61447 .57195 L .59548 .58877 L p F P
0 0 0 r
s
1 .333 .134 r
.61447 .57195 m .61542 .56266 L .63156 .54264 L p F P
0 0 0 r
s
.712 .216 .097 r
.4265 .6091 m .42611 .60335 L .40452 .58877 L p F P
0 0 0 r
s
.814 .245 .108 r
.42611 .60335 m .4265 .6091 L .44987 .61912 L p F P
0 0 0 r
s
1 .329 .137 r
.57389 .60335 m .5735 .6091 L .55013 .61912 L p F P
0 0 0 r
s
1 .336 .139 r
.5735 .6091 m .57389 .60335 L .59548 .58877 L p F P
0 0 0 r
s
.83 .24 .1 r
.48324 .62757 m
.51676 .62757 L
s
.898 .269 .117 r
.47466 .628 m .47461 .62606 L .44987 .61912 L p F P
0 0 0 r
s
.968 .289 .124 r
.5 .62969 m .47461 .62606 L .47466 .628 L closepath p F P
0 0 0 r
s
1 .305 .13 r
.52539 .62606 m .52534 .628 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .318 .134 r
.52534 .628 m .52539 .62606 L .55013 .61912 L p F P
0 0 0 r
s
.289 .431 .847 r
.5 .62969 m .47433 .61425 L .478 .61425 L closepath p F P
0 0 0 r
s
.289 .431 .847 r
.5 .62969 m .478 .61425 L .48166 .61425 L closepath p F P
0 0 0 r
s
.289 .431 .847 r
.5 .62969 m .48166 .61425 L .48533 .61425 L closepath p F P
0 0 0 r
s
.289 .431 .847 r
.5 .62969 m .48533 .61425 L .489 .61425 L closepath p F P
0 0 0 r
s
.289 .431 .847 r
.5 .62969 m .489 .61425 L .49267 .61425 L closepath p F P
0 0 0 r
s
.289 .431 .847 r
.5 .62969 m .49267 .61425 L .49633 .61425 L closepath p F P
0 0 0 r
s
.289 .431 .847 r
.5 .62969 m .49633 .61425 L .5 .61425 L closepath p F P
0 0 0 r
s
.289 .431 .847 r
.5 .62969 m .5 .61425 L .50367 .61425 L closepath p F P
0 0 0 r
s
.289 .431 .847 r
.5 .62969 m .50367 .61425 L .50733 .61425 L closepath p F P
0 0 0 r
s
.289 .431 .847 r
.5 .62969 m .50733 .61425 L .511 .61425 L closepath p F P
0 0 0 r
s
.289 .431 .847 r
.5 .62969 m .511 .61425 L .51467 .61425 L closepath p F P
0 0 0 r
s
.289 .431 .847 r
.5 .62969 m .51467 .61425 L .51834 .61425 L closepath p F P
0 0 0 r
s
.289 .431 .847 r
.5 .62969 m .51834 .61425 L .522 .61425 L closepath p F P
0 0 0 r
s
.289 .431 .847 r
.5 .62969 m .522 .61425 L .52567 .61425 L closepath p F P
0 0 0 r
s
.968 .289 .124 r
.5 .62969 m .47433 .61425 L .47438 .61624 L closepath p F P
0 0 0 r
s
.968 .289 .124 r
.5 .62969 m .47438 .61624 L .47443 .61822 L closepath p F P
0 0 0 r
s
.968 .289 .124 r
.5 .62969 m .47443 .61822 L .47447 .62019 L closepath p F P
0 0 0 r
s
.968 .289 .124 r
.5 .62969 m .47447 .62019 L .47452 .62215 L closepath p F P
0 0 0 r
s
.968 .289 .124 r
.5 .62969 m .47452 .62215 L .47457 .62411 L closepath p F P
0 0 0 r
s
.968 .289 .124 r
.5 .62969 m .47457 .62411 L .47461 .62606 L closepath p F P
0 0 0 r
s
1 .305 .13 r
.52543 .62411 m .52539 .62606 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .305 .13 r
.52548 .62215 m .52543 .62411 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .305 .13 r
.52553 .62019 m .52548 .62215 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .305 .13 r
.52557 .61822 m .52553 .62019 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .305 .13 r
.52562 .61624 m .52557 .61822 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .305 .13 r
.52567 .61425 m .52562 .61624 L .5 .62969 L closepath p F P
0 0 0 r
s
.814 .245 .108 r
.44987 .61912 m .44969 .61524 L .42611 .60335 L p F P
0 0 0 r
s
.898 .269 .117 r
.44969 .61524 m .44987 .61912 L .47461 .62606 L p F P
0 0 0 r
s
1 .318 .134 r
.55031 .61524 m .55013 .61912 L .52539 .62606 L p F P
0 0 0 r
s
1 .329 .137 r
.55013 .61912 m .55031 .61524 L .57389 .60335 L p F P
0 0 0 r
s
.898 .269 .117 r
.47461 .62606 m .47457 .62411 L .44969 .61524 L p F P
0 0 0 r
s
1 .318 .134 r
.52539 .62606 m .52543 .62411 L .55031 .61524 L p F P
0 0 0 r
s
.83 .24 .1 r
.60839 .26485 m
.58039 .25081 L
s
.58229 .21669 m
.58039 .25081 L
s
.41771 .21669 m
.41961 .25081 L
s
.41961 .25081 m
.39161 .26485 L
s
.583 .18 .083 r
.40452 .58877 m .40386 .58114 L .38458 .56266 L p F P
0 0 0 r
s
.712 .216 .097 r
.40386 .58114 m .40452 .58877 L .42611 .60335 L p F P
0 0 0 r
s
1 .336 .139 r
.59614 .58114 m .59548 .58877 L .57389 .60335 L p F P
0 0 0 r
s
1 .338 .138 r
.59548 .58877 m .59614 .58114 L .61542 .56266 L p F P
0 0 0 r
s
.157 .045 .023 r
.3455 .48719 m .34376 .47365 L .33892 .45138 L p F P
0 0 0 r
s
.236 .068 .036 r
.34376 .47365 m .3455 .48719 L .35437 .50943 L p F P
0 0 0 r
s
.973 .282 .11 r
.65624 .47365 m .6545 .48719 L .64563 .50943 L p F P
0 0 0 r
s
.796 .229 .086 r
.6545 .48719 m .65624 .47365 L .66108 .45138 L p F P
0 0 0 r
s
.898 .269 .117 r
.44951 .61133 m .44969 .61524 L .47457 .62411 L p F P
0 0 0 r
s
.898 .269 .117 r
.47457 .62411 m .47452 .62215 L .44951 .61133 L p F P
0 0 0 r
s
1 .318 .134 r
.52543 .62411 m .52548 .62215 L .55049 .61133 L p F P
0 0 0 r
s
1 .318 .134 r
.55049 .61133 m .55031 .61524 L .52543 .62411 L p F P
0 0 0 r
s
.32 .095 .05 r
.36844 .54264 m .36718 .53166 L .35437 .50943 L p F P
0 0 0 r
s
.43 .135 .065 r
.36718 .53166 m .36844 .54264 L .38458 .56266 L p F P
0 0 0 r
s
1 .333 .134 r
.63282 .53166 m .63156 .54264 L .61542 .56266 L p F P
0 0 0 r
s
1 .315 .125 r
.63156 .54264 m .63282 .53166 L .64563 .50943 L p F P
0 0 0 r
s
.712 .216 .097 r
.42611 .60335 m .42572 .59753 L .40386 .58114 L p F P
0 0 0 r
s
.814 .245 .108 r
.42572 .59753 m .42611 .60335 L .44969 .61524 L p F P
0 0 0 r
s
1 .329 .137 r
.57428 .59753 m .57389 .60335 L .55031 .61524 L p F P
0 0 0 r
s
1 .336 .139 r
.57389 .60335 m .57428 .59753 L .59614 .58114 L p F P
0 0 0 r
s
.814 .245 .108 r
.44969 .61524 m .44951 .61133 L .42572 .59753 L p F P
0 0 0 r
s
1 .329 .137 r
.55031 .61524 m .55049 .61133 L .57428 .59753 L p F P
0 0 0 r
s
.898 .269 .117 r
.44932 .6074 m .44951 .61133 L .47452 .62215 L p F P
0 0 0 r
s
.898 .269 .117 r
.47452 .62215 m .47447 .62019 L .44932 .6074 L p F P
0 0 0 r
s
1 .318 .134 r
.52548 .62215 m .52553 .62019 L .55068 .6074 L p F P
0 0 0 r
s
1 .318 .134 r
.55068 .6074 m .55049 .61133 L .52548 .62215 L p F P
0 0 0 r
s
.24 .35 .67 r
.77658 .37848 m
.82268 .37848 L
s
.73048 .37848 m
.77658 .37848 L
s
.68439 .37848 m
.73048 .37848 L
s
.65956 .37848 m
.68439 .37848 L
s
.31561 .37848 m
.34044 .37848 L
s
.26952 .37848 m
.31561 .37848 L
s
.22342 .37848 m
.26952 .37848 L
s
.17732 .37848 m
.22342 .37848 L
s
.77658 .37848 m
.78064 .40178 L
s
.82741 .40178 m
.82268 .37848 L
s
.73048 .37848 m
.73386 .40178 L
s
.68439 .37848 m
.68709 .40178 L
s
.31561 .37848 m
.31291 .40178 L
s
.26952 .37848 m
.26614 .40178 L
s
.22342 .37848 m
.21936 .40178 L
s
.17732 .37848 m
.17259 .40178 L
s
.7 .195 .071 r
.33892 .45138 m .33703 .43684 L .33645 .41589 L p F P
0 0 0 r
s
.83 .24 .1 r
.3382 .41679 m
.34372 .39126 L
s
.157 .045 .023 r
.33703 .43684 m .33892 .45138 L .34376 .47365 L p F P
0 0 0 r
s
.83 .24 .1 r
.3382 .41679 m
.34188 .44579 L
s
.098 .028 .012 r
.66108 .45138 m .66297 .43684 L .66355 .41589 L p F P
0 0 0 r
s
.796 .229 .086 r
.66297 .43684 m .66108 .45138 L .65624 .47365 L p F P
0 0 0 r
s
.83 .24 .1 r
.65812 .44579 m
.6618 .41679 L
s
.65628 .39126 m
.6618 .41679 L
s
.34891 .30442 m
.35242 .33666 L
s
.35242 .33666 m
.34005 .36067 L
s
.65995 .36067 m
.64758 .33666 L
s
.65109 .30442 m
.64758 .33666 L
s
.898 .269 .117 r
.44914 .60343 m .44932 .6074 L .47447 .62019 L p F P
0 0 0 r
s
.898 .269 .117 r
.47447 .62019 m .47443 .61822 L .44914 .60343 L p F P
0 0 0 r
s
.24 .35 .67 r
.4538 .61852 m
.45457 .63648 L
s
1 .318 .134 r
.52553 .62019 m .52557 .61822 L .55086 .60343 L p F P
0 0 0 r
s
1 .318 .134 r
.55086 .60343 m .55068 .6074 L .52553 .62019 L p F P
0 0 0 r
s
.24 .35 .67 r
.54543 .63648 m
.5462 .61852 L
s
.43 .135 .065 r
.38458 .56266 m .38361 .55321 L .36718 .53166 L p F P
0 0 0 r
s
.583 .18 .083 r
.38361 .55321 m .38458 .56266 L .40386 .58114 L p F P
0 0 0 r
s
1 .338 .138 r
.61639 .55321 m .61542 .56266 L .59614 .58114 L p F P
0 0 0 r
s
.83 .24 .1 r
.61556 .56124 m
.61697 .55989 L
s
1 .333 .134 r
.61542 .56266 m .61639 .55321 L .63282 .53166 L p F P
0 0 0 r
s
.24 .35 .67 r
.78115 .59437 m
.77722 .61852 L
s
.82342 .61852 m
.82801 .59437 L
s
.77722 .61852 m
.82342 .61852 L
s
.73429 .59437 m
.73101 .61852 L
s
.73101 .61852 m
.77722 .61852 L
s
.68744 .59437 m
.68481 .61852 L
s
.68481 .61852 m
.73101 .61852 L
s
.64058 .59437 m
.63861 .61852 L
s
.63861 .61852 m
.68481 .61852 L
s
.59241 .61852 m
.63861 .61852 L
s
.5462 .61852 m
.59241 .61852 L
s
.53201 .61852 m
.5462 .61852 L
s
.52767 .61852 m
.53201 .61852 L
s
.4538 .61852 m
.46799 .61852 L
s
.46799 .61852 m
.47233 .61852 L
s
.40759 .61852 m
.4538 .61852 L
s
.35942 .59437 m
.36139 .61852 L
s
.36139 .61852 m
.40759 .61852 L
s
.31256 .59437 m
.31519 .61852 L
s
.31519 .61852 m
.36139 .61852 L
s
.26571 .59437 m
.26899 .61852 L
s
.26899 .61852 m
.31519 .61852 L
s
.21885 .59437 m
.22278 .61852 L
s
.22278 .61852 m
.26899 .61852 L
s
.17199 .59437 m
.17658 .61852 L
s
.17658 .61852 m
.22278 .61852 L
s
.814 .245 .108 r
.42532 .59165 m .42572 .59753 L .44951 .61133 L p F P
0 0 0 r
s
.814 .245 .108 r
.44951 .61133 m .44932 .6074 L .42532 .59165 L p F P
0 0 0 r
s
1 .329 .137 r
.55049 .61133 m .55068 .6074 L .57468 .59165 L p F P
0 0 0 r
s
1 .329 .137 r
.57468 .59165 m .57428 .59753 L .55049 .61133 L p F P
0 0 0 r
s
.236 .068 .036 r
.35437 .50943 m .35283 .49692 L .34376 .47365 L p F P
0 0 0 r
s
.83 .24 .1 r
.34343 .47185 m
.3458 .47889 L
s
.32 .095 .05 r
.35283 .49692 m .35437 .50943 L .36718 .53166 L p F P
0 0 0 r
s
1 .315 .125 r
.64717 .49692 m .64563 .50943 L .63282 .53166 L p F P
0 0 0 r
s
.973 .282 .11 r
.64563 .50943 m .64717 .49692 L .65624 .47365 L p F P
0 0 0 r
s
.83 .24 .1 r
.6542 .47889 m
.65657 .47185 L
s
.898 .269 .117 r
.44895 .59943 m .44914 .60343 L .47443 .61822 L p F P
0 0 0 r
s
.898 .269 .117 r
.47443 .61822 m .47438 .61624 L .44895 .59943 L p F P
0 0 0 r
s
1 .318 .134 r
.52557 .61822 m .52562 .61624 L .55105 .59943 L p F P
0 0 0 r
s
1 .318 .134 r
.55105 .59943 m .55086 .60343 L .52557 .61822 L p F P
0 0 0 r
s
.899 .254 .097 r
.33645 .41589 m .3345 .4007 L .33829 .38248 L p F P
0 0 0 r
s
.7 .195 .071 r
.3345 .4007 m .33645 .41589 L .33703 .43684 L p F P
0 0 0 r
s
.181 .052 .027 r
.66355 .41589 m .6655 .4007 L .66171 .38248 L p F P
0 0 0 r
s
.098 .028 .012 r
.6655 .4007 m .66355 .41589 L .66297 .43684 L p F P
0 0 0 r
s
.583 .18 .083 r
.40386 .58114 m .40319 .57341 L .38361 .55321 L p F P
0 0 0 r
s
.712 .216 .097 r
.40319 .57341 m .40386 .58114 L .42572 .59753 L p F P
0 0 0 r
s
1 .336 .139 r
.59681 .57341 m .59614 .58114 L .57428 .59753 L p F P
0 0 0 r
s
1 .338 .138 r
.59614 .58114 m .59681 .57341 L .61639 .55321 L p F P
0 0 0 r
s
.83 .24 .1 r
.63231 .28292 m
.60839 .26485 L
s
.61098 .23081 m
.60839 .26485 L
s
.38902 .23081 m
.39161 .26485 L
s
.39161 .26485 m
.36769 .28292 L
s
.712 .216 .097 r
.42572 .59753 m .42532 .59165 L .40319 .57341 L p F P
0 0 0 r
s
.83 .24 .1 r
.41858 .5849 m
.41868 .58618 L
s
.24 .35 .67 r
.40628 .59437 m
.40759 .61852 L
s
.83 .24 .1 r
.41276 .5813 m
.41858 .5849 L
s
1 .336 .139 r
.57428 .59753 m .57468 .59165 L .59681 .57341 L p F P
0 0 0 r
s
.83 .24 .1 r
.58132 .58618 m
.58142 .5849 L
s
.58142 .5849 m
.58724 .5813 L
s
.24 .35 .67 r
.59241 .61852 m
.59372 .59437 L
s
.19 .256 .498 r
.33829 .38248 m .36139 .38248 L .35815 .4007 L p F P
0 0 0 r
s
.19 .256 .498 r
.35815 .4007 m .3345 .4007 L .33829 .38248 L p F P
0 0 0 r
s
.19 .256 .498 r
.36139 .38248 m .38449 .38248 L .38179 .4007 L p F P
0 0 0 r
s
.19 .256 .498 r
.38179 .4007 m .35815 .4007 L .36139 .38248 L p F P
0 0 0 r
s
.24 .35 .67 r
.35968 .40178 m
.35978 .4007 L
s
.19 .256 .498 r
.38449 .38248 m .40759 .38248 L .40543 .4007 L p F P
0 0 0 r
s
.19 .256 .498 r
.40543 .4007 m .38179 .4007 L .38449 .38248 L p F P
0 0 0 r
s
.19 .256 .498 r
.40759 .38248 m .4307 .38248 L .42907 .4007 L p F P
0 0 0 r
s
.19 .256 .498 r
.42907 .4007 m .40543 .4007 L .40759 .38248 L p F P
0 0 0 r
s
.24 .35 .67 r
.40645 .40178 m
.40652 .4007 L
s
.19 .256 .498 r
.4307 .38248 m .4538 .38248 L .45272 .4007 L p F P
0 0 0 r
s
.19 .256 .498 r
.45272 .4007 m .42907 .4007 L .4307 .38248 L p F P
0 0 0 r
s
.19 .256 .498 r
.4538 .38248 m .4769 .38248 L .47636 .4007 L p F P
0 0 0 r
s
.19 .256 .498 r
.47636 .4007 m .45272 .4007 L .4538 .38248 L p F P
0 0 0 r
s
.24 .35 .67 r
.45323 .40178 m
.45326 .4007 L
s
.19 .256 .498 r
.4769 .38248 m .5 .38248 L .5 .4007 L p F P
0 0 0 r
s
.19 .256 .498 r
.5 .4007 m .47636 .4007 L .4769 .38248 L p F P
0 0 0 r
s
.19 .256 .498 r
.5 .38248 m .5231 .38248 L .52364 .4007 L p F P
0 0 0 r
s
.19 .256 .498 r
.52364 .4007 m .5 .4007 L .5 .38248 L p F P
0 0 0 r
s
.24 .35 .67 r
.5 .4007 m
.5 .40178 L
s
.19 .256 .498 r
.5231 .38248 m .5462 .38248 L .54728 .4007 L p F P
0 0 0 r
s
.24 .35 .67 r
.54621 .38248 m
.54622 .38281 L
s
.19 .256 .498 r
.54728 .4007 m .52364 .4007 L .5231 .38248 L p F P
0 0 0 r
s
.19 .256 .498 r
.5462 .38248 m .5693 .38248 L .57093 .4007 L p F P
0 0 0 r
s
.19 .256 .498 r
.57093 .4007 m .54728 .4007 L .5462 .38248 L p F P
0 0 0 r
s
.24 .35 .67 r
.54674 .4007 m
.54677 .40178 L
s
.19 .256 .498 r
.5693 .38248 m .59241 .38248 L .59457 .4007 L p F P
0 0 0 r
s
.24 .35 .67 r
.59243 .38248 m
.59245 .38281 L
s
.19 .256 .498 r
.59457 .4007 m .57093 .4007 L .5693 .38248 L p F P
0 0 0 r
s
.19 .256 .498 r
.59241 .38248 m .61551 .38248 L .61821 .4007 L p F P
0 0 0 r
s
.19 .256 .498 r
.61821 .4007 m .59457 .4007 L .59241 .38248 L p F P
0 0 0 r
s
.24 .35 .67 r
.59348 .4007 m
.59355 .40178 L
s
.19 .256 .498 r
.61551 .38248 m .63861 .38248 L .64185 .4007 L p F P
0 0 0 r
s
.24 .35 .67 r
.63864 .38248 m
.63867 .38281 L
s
.19 .256 .498 r
.64185 .4007 m .61821 .4007 L .61551 .38248 L p F P
0 0 0 r
s
.19 .256 .498 r
.63861 .38248 m .66171 .38248 L .6655 .4007 L p F P
0 0 0 r
s
.19 .256 .498 r
.6655 .4007 m .64185 .4007 L .63861 .38248 L p F P
0 0 0 r
s
.24 .35 .67 r
.64022 .4007 m
.64032 .40178 L
s
.898 .269 .117 r
.44876 .59541 m .44895 .59943 L .47438 .61624 L p F P
0 0 0 r
s
.898 .269 .117 r
.47438 .61624 m .47433 .61425 L .44876 .59541 L p F P
0 0 0 r
s
1 .318 .134 r
.52562 .61624 m .52567 .61425 L .55124 .59541 L p F P
0 0 0 r
s
1 .318 .134 r
.55124 .59541 m .55105 .59943 L .52562 .61624 L p F P
0 0 0 r
s
.814 .245 .108 r
.42491 .58571 m .42532 .59165 L .44932 .6074 L p F P
0 0 0 r
s
.814 .245 .108 r
.44932 .6074 m .44914 .60343 L .42491 .58571 L p F P
0 0 0 r
s
1 .329 .137 r
.55068 .6074 m .55086 .60343 L .57509 .58571 L p F P
0 0 0 r
s
1 .329 .137 r
.57509 .58571 m .57468 .59165 L .55068 .6074 L p F P
0 0 0 r
s
.286 .423 .829 r
.44876 .59541 m .45608 .59541 L .478 .61425 L p F P
0 0 0 r
s
.286 .423 .829 r
.478 .61425 m .47433 .61425 L .44876 .59541 L p F P
0 0 0 r
s
.24 .35 .67 r
.45338 .60331 m
.4538 .61852 L
s
.45314 .59437 m
.45317 .59541 L
s
.286 .423 .829 r
.45608 .59541 m .4634 .59541 L .48166 .61425 L p F P
0 0 0 r
s
.286 .423 .829 r
.48166 .61425 m .478 .61425 L .45608 .59541 L p F P
0 0 0 r
s
.286 .423 .829 r
.4634 .59541 m .47072 .59541 L .48533 .61425 L p F P
0 0 0 r
s
.286 .423 .829 r
.48533 .61425 m .48166 .61425 L .4634 .59541 L p F P
0 0 0 r
s
.286 .423 .829 r
.47072 .59541 m .47804 .59541 L .489 .61425 L p F P
0 0 0 r
s
.286 .423 .829 r
.489 .61425 m .48533 .61425 L .47072 .59541 L p F P
0 0 0 r
s
.286 .423 .829 r
.47804 .59541 m .48536 .59541 L .49267 .61425 L p F P
0 0 0 r
s
.286 .423 .829 r
.49267 .61425 m .489 .61425 L .47804 .59541 L p F P
0 0 0 r
s
.83 .24 .1 r
.48284 .60245 m
.48297 .61029 L
s
.48297 .61029 m
.483 .61267 L
s
.286 .423 .829 r
.48536 .59541 m .49268 .59541 L .49633 .61425 L p F P
0 0 0 r
s
.286 .423 .829 r
.49633 .61425 m .49267 .61425 L .48536 .59541 L p F P
0 0 0 r
s
.286 .423 .829 r
.49268 .59541 m .5 .59541 L .5 .61425 L p F P
0 0 0 r
s
.286 .423 .829 r
.5 .61425 m .49633 .61425 L .49268 .59541 L p F P
0 0 0 r
s
.286 .423 .829 r
.5 .59541 m .50732 .59541 L .50367 .61425 L p F P
0 0 0 r
s
.286 .423 .829 r
.50367 .61425 m .5 .61425 L .5 .59541 L p F P
0 0 0 r
s
.24 .35 .67 r
.5 .59437 m
.5 .59541 L
s
.286 .423 .829 r
.50732 .59541 m .51464 .59541 L .50733 .61425 L p F P
0 0 0 r
s
.286 .423 .829 r
.50733 .61425 m .50367 .61425 L .50732 .59541 L p F P
0 0 0 r
s
.286 .423 .829 r
.51464 .59541 m .52196 .59541 L .511 .61425 L p F P
0 0 0 r
s
.286 .423 .829 r
.511 .61425 m .50733 .61425 L .51464 .59541 L p F P
0 0 0 r
s
.286 .423 .829 r
.52196 .59541 m .52928 .59541 L .51467 .61425 L p F P
0 0 0 r
s
.286 .423 .829 r
.51467 .61425 m .511 .61425 L .52196 .59541 L p F P
0 0 0 r
s
.286 .423 .829 r
.52928 .59541 m .5366 .59541 L .51834 .61425 L p F P
0 0 0 r
s
.286 .423 .829 r
.51834 .61425 m .51467 .61425 L .52928 .59541 L p F P
0 0 0 r
s
.83 .24 .1 r
.51703 .61029 m
.51716 .60245 L
s
.517 .61267 m
.51703 .61029 L
s
.286 .423 .829 r
.5366 .59541 m .54392 .59541 L .522 .61425 L p F P
0 0 0 r
s
.286 .423 .829 r
.522 .61425 m .51834 .61425 L .5366 .59541 L p F P
0 0 0 r
s
.286 .423 .829 r
.54392 .59541 m .55124 .59541 L .52567 .61425 L p F P
0 0 0 r
s
.24 .35 .67 r
.54683 .59541 m
.54686 .59437 L
s
.5462 .61852 m
.54662 .60331 L
s
.286 .423 .829 r
.52567 .61425 m .522 .61425 L .54392 .59541 L p F P
0 0 0 r
s
.32 .095 .05 r
.36718 .53166 m .3659 .52047 L .35283 .49692 L p F P
0 0 0 r
s
.43 .135 .065 r
.3659 .52047 m .36718 .53166 L .38361 .55321 L p F P
0 0 0 r
s
1 .333 .134 r
.6341 .52047 m .63282 .53166 L .61639 .55321 L p F P
0 0 0 r
s
1 .315 .125 r
.63282 .53166 m .6341 .52047 L .64717 .49692 L p F P
0 0 0 r
s
.157 .045 .023 r
.34376 .47365 m .34199 .45981 L .33703 .43684 L p F P
0 0 0 r
s
.236 .068 .036 r
.34199 .45981 m .34376 .47365 L .35283 .49692 L p F P
0 0 0 r
s
.973 .282 .11 r
.65801 .45981 m .65624 .47365 L .64717 .49692 L p F P
0 0 0 r
s
.796 .229 .086 r
.65624 .47365 m .65801 .45981 L .66297 .43684 L p F P
0 0 0 r
s
.712 .216 .097 r
.40251 .56557 m .40319 .57341 L .42532 .59165 L p F P
0 0 0 r
s
.712 .216 .097 r
.42532 .59165 m .42491 .58571 L .40251 .56557 L p F P
0 0 0 r
s
1 .336 .139 r
.57468 .59165 m .57509 .58571 L .59749 .56557 L p F P
0 0 0 r
s
1 .336 .139 r
.59749 .56557 m .59681 .57341 L .57468 .59165 L p F P
0 0 0 r
s
.814 .245 .108 r
.42451 .57971 m .42491 .58571 L .44914 .60343 L p F P
0 0 0 r
s
.814 .245 .108 r
.44914 .60343 m .44895 .59943 L .42451 .57971 L p F P
0 0 0 r
s
1 .329 .137 r
.55086 .60343 m .55105 .59943 L .57549 .57971 L p F P
0 0 0 r
s
1 .329 .137 r
.57549 .57971 m .57509 .58571 L .55086 .60343 L p F P
0 0 0 r
s
.43 .135 .065 r
.38361 .55321 m .38263 .54359 L .3659 .52047 L p F P
0 0 0 r
s
.83 .24 .1 r
.36743 .52087 m
.36766 .5229 L
s
.583 .18 .083 r
.38263 .54359 m .38361 .55321 L .40319 .57341 L p F P
0 0 0 r
s
1 .338 .138 r
.61737 .54359 m .61639 .55321 L .59681 .57341 L p F P
0 0 0 r
s
1 .333 .134 r
.61639 .55321 m .61737 .54359 L .6341 .52047 L p F P
0 0 0 r
s
.83 .24 .1 r
.63234 .5229 m
.63257 .52087 L
s
.583 .18 .083 r
.40319 .57341 m .40251 .56557 L .38263 .54359 L p F P
0 0 0 r
s
1 .338 .138 r
.59681 .57341 m .59749 .56557 L .61737 .54359 L p F P
0 0 0 r
s
.83 .24 .1 r
.55059 .20704 m
.51707 .20215 L
s
.51748 .16632 m
.51707 .20215 L
s
.51707 .20215 m
.48293 .20215 L
s
.48252 .16632 m
.48293 .20215 L
s
.48293 .20215 m
.44941 .20704 L
s
.7 .195 .071 r
.33703 .43684 m .3351 .42195 L .3345 .4007 L p F P
0 0 0 r
s
.157 .045 .023 r
.3351 .42195 m .33703 .43684 L .34199 .45981 L p F P
0 0 0 r
s
.83 .24 .1 r
.3397 .44298 m
.34157 .4575 L
s
.098 .028 .012 r
.66297 .43684 m .6649 .42195 L .6655 .4007 L p F P
0 0 0 r
s
.796 .229 .086 r
.6649 .42195 m .66297 .43684 L .65801 .45981 L p F P
0 0 0 r
s
.83 .24 .1 r
.65843 .4575 m
.6603 .44298 L
s
.236 .068 .036 r
.35283 .49692 m .35125 .48413 L .34199 .45981 L p F P
0 0 0 r
s
.32 .095 .05 r
.35125 .48413 m .35283 .49692 L .3659 .52047 L p F P
0 0 0 r
s
.83 .24 .1 r
.36386 .51541 m
.36743 .52087 L
s
1 .315 .125 r
.64875 .48413 m .64717 .49692 L .6341 .52047 L p F P
0 0 0 r
s
.83 .24 .1 r
.63257 .52087 m
.63614 .51541 L
s
.973 .282 .11 r
.64717 .49692 m .64875 .48413 L .65801 .45981 L p F P
0 0 0 r
s
.83 .24 .1 r
.33619 .3286 m
.34005 .36067 L
s
.33434 .38641 m
.34005 .36067 L
s
.65995 .36067 m
.66566 .38641 L
s
.66381 .3286 m
.65995 .36067 L
s
.65109 .30442 m
.63231 .28292 L
s
.6355 .24898 m
.63231 .28292 L
s
.3645 .24898 m
.36769 .28292 L
s
.36769 .28292 m
.34891 .30442 L
s
.814 .245 .108 r
.42409 .57364 m .42451 .57971 L .44895 .59943 L p F P
0 0 0 r
s
.814 .245 .108 r
.44895 .59943 m .44876 .59541 L .42409 .57364 L p F P
0 0 0 r
s
1 .329 .137 r
.55105 .59943 m .55124 .59541 L .57591 .57364 L p F P
0 0 0 r
s
1 .329 .137 r
.57591 .57364 m .57549 .57971 L .55105 .59943 L p F P
0 0 0 r
s
.83 .24 .1 r
.46166 .59867 m
.48284 .60245 L
s
.51716 .60245 m
.53834 .59867 L
s
.24 .35 .67 r
.78064 .40178 m
.82741 .40178 L
s
.73386 .40178 m
.78064 .40178 L
s
.68709 .40178 m
.73386 .40178 L
s
.64032 .40178 m
.66536 .40178 L
s
.66547 .40178 m
.68709 .40178 L
s
.59355 .40178 m
.64032 .40178 L
s
.54677 .40178 m
.59355 .40178 L
s
.5 .40178 m
.54677 .40178 L
s
.45323 .40178 m
.5 .40178 L
s
.40645 .40178 m
.45323 .40178 L
s
.35968 .40178 m
.40645 .40178 L
s
.33464 .40178 m
.35968 .40178 L
s
.31291 .40178 m
.33453 .40178 L
s
.26614 .40178 m
.31291 .40178 L
s
.21936 .40178 m
.26614 .40178 L
s
.17259 .40178 m
.21936 .40178 L
s
.78064 .40178 m
.78377 .43038 L
s
.83107 .43038 m
.82741 .40178 L
s
.73386 .40178 m
.73648 .43038 L
s
.68709 .40178 m
.68918 .43038 L
s
.31291 .40178 m
.31082 .43038 L
s
.26614 .40178 m
.26352 .43038 L
s
.21936 .40178 m
.21623 .43038 L
s
.17259 .40178 m
.16893 .43038 L
s
.83 .24 .1 r
.58229 .21669 m
.55059 .20704 L
s
.55181 .17123 m
.55059 .20704 L
s
.44819 .17123 m
.44941 .20704 L
s
.44941 .20704 m
.41771 .21669 L
s
.712 .216 .097 r
.40182 .55761 m .40251 .56557 L .42491 .58571 L p F P
0 0 0 r
s
.712 .216 .097 r
.42491 .58571 m .42451 .57971 L .40182 .55761 L p F P
0 0 0 r
s
1 .336 .139 r
.57509 .58571 m .57549 .57971 L .59818 .55761 L p F P
0 0 0 r
s
1 .336 .139 r
.59818 .55761 m .59749 .56557 L .57509 .58571 L p F P
0 0 0 r
s
.211 .29 .565 r
.3345 .4007 m .35815 .4007 L .35866 .42195 L p F P
0 0 0 r
s
.83 .24 .1 r
.33637 .40234 m
.3382 .41679 L
s
.211 .29 .565 r
.35866 .42195 m .3351 .42195 L .3345 .4007 L p F P
0 0 0 r
s
.83 .24 .1 r
.33434 .38641 m
.33616 .4007 L
s
.3385 .42195 m
.3397 .44298 L
s
.211 .29 .565 r
.35815 .4007 m .38179 .4007 L .38221 .42195 L p F P
0 0 0 r
s
.211 .29 .565 r
.38221 .42195 m .35866 .42195 L .35815 .4007 L p F P
0 0 0 r
s
.211 .29 .565 r
.38179 .4007 m .40543 .4007 L .40577 .42195 L p F P
0 0 0 r
s
.211 .29 .565 r
.40577 .42195 m .38221 .42195 L .38179 .4007 L p F P
0 0 0 r
s
.211 .29 .565 r
.40543 .4007 m .42907 .4007 L .42933 .42195 L p F P
0 0 0 r
s
.211 .29 .565 r
.42933 .42195 m .40577 .42195 L .40543 .4007 L p F P
0 0 0 r
s
.211 .29 .565 r
.42907 .4007 m .45272 .4007 L .45289 .42195 L p F P
0 0 0 r
s
.211 .29 .565 r
.45289 .42195 m .42933 .42195 L .42907 .4007 L p F P
0 0 0 r
s
.211 .29 .565 r
.45272 .4007 m .47636 .4007 L .47644 .42195 L p F P
0 0 0 r
s
.211 .29 .565 r
.47644 .42195 m .45289 .42195 L .45272 .4007 L p F P
0 0 0 r
s
.211 .29 .565 r
.47636 .4007 m .5 .4007 L .5 .42195 L p F P
0 0 0 r
s
.211 .29 .565 r
.5 .42195 m .47644 .42195 L .47636 .4007 L p F P
0 0 0 r
s
.211 .29 .565 r
.5 .4007 m .52364 .4007 L .52356 .42195 L p F P
0 0 0 r
s
.211 .29 .565 r
.52356 .42195 m .5 .42195 L .5 .4007 L p F P
0 0 0 r
s
.211 .29 .565 r
.52364 .4007 m .54728 .4007 L .54711 .42195 L p F P
0 0 0 r
s
.211 .29 .565 r
.54711 .42195 m .52356 .42195 L .52364 .4007 L p F P
0 0 0 r
s
.211 .29 .565 r
.54728 .4007 m .57093 .4007 L .57067 .42195 L p F P
0 0 0 r
s
.211 .29 .565 r
.57067 .42195 m .54711 .42195 L .54728 .4007 L p F P
0 0 0 r
s
.211 .29 .565 r
.57093 .4007 m .59457 .4007 L .59423 .42195 L p F P
0 0 0 r
s
.211 .29 .565 r
.59423 .42195 m .57067 .42195 L .57093 .4007 L p F P
0 0 0 r
s
.211 .29 .565 r
.59457 .4007 m .61821 .4007 L .61779 .42195 L p F P
0 0 0 r
s
.211 .29 .565 r
.61779 .42195 m .59423 .42195 L .59457 .4007 L p F P
0 0 0 r
s
.211 .29 .565 r
.61821 .4007 m .64185 .4007 L .64134 .42195 L p F P
0 0 0 r
s
.211 .29 .565 r
.64134 .42195 m .61779 .42195 L .61821 .4007 L p F P
0 0 0 r
s
.211 .29 .565 r
.64185 .4007 m .6655 .4007 L .6649 .42195 L p F P
0 0 0 r
s
.211 .29 .565 r
.6649 .42195 m .64134 .42195 L .64185 .4007 L p F P
0 0 0 r
s
.83 .24 .1 r
.6603 .44298 m
.6615 .42195 L
s
.66384 .4007 m
.66566 .38641 L
s
.24 .35 .67 r
.78414 .56511 m
.78115 .59437 L
s
.82801 .59437 m
.8315 .56511 L
s
.78115 .59437 m
.82801 .59437 L
s
.73678 .56511 m
.73429 .59437 L
s
.73429 .59437 m
.78115 .59437 L
s
.68943 .56511 m
.68744 .59437 L
s
.68744 .59437 m
.73429 .59437 L
s
.64207 .56511 m
.64058 .59437 L
s
.64058 .59437 m
.68744 .59437 L
s
.59372 .59437 m
.64058 .59437 L
s
.555 .59437 m
.59372 .59437 L
s
.54686 .59437 m
.55241 .59437 L
s
.5 .59437 m
.54686 .59437 L
s
.45314 .59437 m
.5 .59437 L
s
.40628 .59437 m
.445 .59437 L
s
.44759 .59437 m
.45314 .59437 L
s
.35793 .56511 m
.35942 .59437 L
s
.35942 .59437 m
.40628 .59437 L
s
.31057 .56511 m
.31256 .59437 L
s
.31256 .59437 m
.35942 .59437 L
s
.26322 .56511 m
.26571 .59437 L
s
.26571 .59437 m
.31256 .59437 L
s
.21586 .56511 m
.21885 .59437 L
s
.21885 .59437 m
.26571 .59437 L
s
.1685 .56511 m
.17199 .59437 L
s
.17199 .59437 m
.21885 .59437 L
s
.32 .095 .05 r
.3659 .52047 m .3646 .50907 L .35125 .48413 L p F P
0 0 0 r
s
.43 .135 .065 r
.3646 .50907 m .3659 .52047 L .38263 .54359 L p F P
0 0 0 r
s
1 .333 .134 r
.6354 .50907 m .6341 .52047 L .61737 .54359 L p F P
0 0 0 r
s
1 .315 .125 r
.6341 .52047 m .6354 .50907 L .64875 .48413 L p F P
0 0 0 r
s
.83 .24 .1 r
.48284 .60245 m
.51716 .60245 L
s
.281 .411 .806 r
.42409 .57364 m .43494 .57364 L .45608 .59541 L p F P
0 0 0 r
s
.24 .35 .67 r
.45312 .5934 m
.45314 .59437 L
s
.281 .411 .806 r
.45608 .59541 m .44876 .59541 L .42409 .57364 L p F P
0 0 0 r
s
.281 .411 .806 r
.43494 .57364 m .44578 .57364 L .4634 .59541 L p F P
0 0 0 r
s
.281 .411 .806 r
.4634 .59541 m .45608 .59541 L .43494 .57364 L p F P
0 0 0 r
s
.281 .411 .806 r
.44578 .57364 m .45662 .57364 L .47072 .59541 L p F P
0 0 0 r
s
.281 .411 .806 r
.47072 .59541 m .4634 .59541 L .44578 .57364 L p F P
0 0 0 r
s
.83 .24 .1 r
.44914 .59045 m
.44921 .59199 L
s
.281 .411 .806 r
.45662 .57364 m .46747 .57364 L .47804 .59541 L p F P
0 0 0 r
s
.281 .411 .806 r
.47804 .59541 m .47072 .59541 L .45662 .57364 L p F P
0 0 0 r
s
.281 .411 .806 r
.46747 .57364 m .47831 .57364 L .48536 .59541 L p F P
0 0 0 r
s
.281 .411 .806 r
.48536 .59541 m .47804 .59541 L .46747 .57364 L p F P
0 0 0 r
s
.281 .411 .806 r
.47831 .57364 m .48916 .57364 L .49268 .59541 L p F P
0 0 0 r
s
.281 .411 .806 r
.49268 .59541 m .48536 .59541 L .47831 .57364 L p F P
0 0 0 r
s
.83 .24 .1 r
.48243 .57611 m
.48284 .60245 L
s
.281 .411 .806 r
.48916 .57364 m .5 .57364 L .5 .59541 L p F P
0 0 0 r
s
.281 .411 .806 r
.5 .59541 m .49268 .59541 L .48916 .57364 L p F P
0 0 0 r
s
.281 .411 .806 r
.5 .57364 m .51084 .57364 L .50732 .59541 L p F P
0 0 0 r
s
.281 .411 .806 r
.50732 .59541 m .5 .59541 L .5 .57364 L p F P
0 0 0 r
s
.281 .411 .806 r
.51084 .57364 m .52169 .57364 L .51464 .59541 L p F P
0 0 0 r
s
.281 .411 .806 r
.51464 .59541 m .50732 .59541 L .51084 .57364 L p F P
0 0 0 r
s
.281 .411 .806 r
.52169 .57364 m .53253 .57364 L .52196 .59541 L p F P
0 0 0 r
s
.281 .411 .806 r
.52196 .59541 m .51464 .59541 L .52169 .57364 L p F P
0 0 0 r
s
.83 .24 .1 r
.51716 .60245 m
.51757 .57611 L
s
.281 .411 .806 r
.53253 .57364 m .54338 .57364 L .52928 .59541 L p F P
0 0 0 r
s
.281 .411 .806 r
.52928 .59541 m .52196 .59541 L .53253 .57364 L p F P
0 0 0 r
s
.281 .411 .806 r
.54338 .57364 m .55422 .57364 L .5366 .59541 L p F P
0 0 0 r
s
.281 .411 .806 r
.5366 .59541 m .52928 .59541 L .54338 .57364 L p F P
0 0 0 r
s
.281 .411 .806 r
.55422 .57364 m .56506 .57364 L .54392 .59541 L p F P
0 0 0 r
s
.24 .35 .67 r
.54686 .59437 m
.54689 .59234 L
s
.281 .411 .806 r
.54392 .59541 m .5366 .59541 L .55422 .57364 L p F P
0 0 0 r
s
.281 .411 .806 r
.56506 .57364 m .57591 .57364 L .55124 .59541 L p F P
0 0 0 r
s
.281 .411 .806 r
.55124 .59541 m .54392 .59541 L .56506 .57364 L p F P
0 0 0 r
s
.83 .24 .1 r
.55079 .59199 m
.55086 .59045 L
s
.583 .18 .083 r
.38163 .53382 m .38263 .54359 L .40251 .56557 L p F P
0 0 0 r
s
.583 .18 .083 r
.40251 .56557 m .40182 .55761 L .38163 .53382 L p F P
0 0 0 r
s
1 .338 .138 r
.59749 .56557 m .59818 .55761 L .61837 .53382 L p F P
0 0 0 r
s
1 .338 .138 r
.61837 .53382 m .61737 .54359 L .59749 .56557 L p F P
0 0 0 r
s
.43 .135 .065 r
.38263 .54359 m .38163 .53382 L .3646 .50907 L p F P
0 0 0 r
s
1 .333 .134 r
.61737 .54359 m .61837 .53382 L .6354 .50907 L p F P
0 0 0 r
s
.157 .045 .023 r
.34199 .45981 m .34017 .44565 L .3351 .42195 L p F P
0 0 0 r
s
.236 .068 .036 r
.34017 .44565 m .34199 .45981 L .35125 .48413 L p F P
0 0 0 r
s
.973 .282 .11 r
.65983 .44565 m .65801 .45981 L .64875 .48413 L p F P
0 0 0 r
s
.796 .229 .086 r
.65801 .45981 m .65983 .44565 L .6649 .42195 L p F P
0 0 0 r
s
.83 .24 .1 r
.61098 .23081 m
.58229 .21669 L
s
.58429 .18091 m
.58229 .21669 L
s
.41571 .18091 m
.41771 .21669 L
s
.41771 .21669 m
.38902 .23081 L
s
.712 .216 .097 r
.40112 .54955 m .40182 .55761 L .42451 .57971 L p F P
0 0 0 r
s
.712 .216 .097 r
.42451 .57971 m .42409 .57364 L .40112 .54955 L p F P
0 0 0 r
s
1 .336 .139 r
.57549 .57971 m .57591 .57364 L .59888 .54955 L p F P
0 0 0 r
s
1 .336 .139 r
.59888 .54955 m .59818 .55761 L .57549 .57971 L p F P
0 0 0 r
s
.236 .068 .036 r
.35125 .48413 m .34964 .47107 L .34017 .44565 L p F P
0 0 0 r
s
.83 .24 .1 r
.3397 .44298 m
.34513 .45898 L
s
.32 .095 .05 r
.34964 .47107 m .35125 .48413 L .3646 .50907 L p F P
0 0 0 r
s
1 .315 .125 r
.65036 .47107 m .64875 .48413 L .6354 .50907 L p F P
0 0 0 r
s
.973 .282 .11 r
.64875 .48413 m .65036 .47107 L .65983 .44565 L p F P
0 0 0 r
s
.83 .24 .1 r
.65487 .45898 m
.6603 .44298 L
s
.227 .315 .616 r
.3351 .42195 m .35866 .42195 L .363 .44565 L p F P
0 0 0 r
s
.227 .315 .616 r
.363 .44565 m .34017 .44565 L .3351 .42195 L p F P
0 0 0 r
s
.83 .24 .1 r
.33787 .42874 m
.33798 .42959 L
s
.33583 .41283 m
.33787 .42874 L
s
.227 .315 .616 r
.35866 .42195 m .38221 .42195 L .38583 .44565 L p F P
0 0 0 r
s
.227 .315 .616 r
.38583 .44565 m .363 .44565 L .35866 .42195 L p F P
0 0 0 r
s
.227 .315 .616 r
.38221 .42195 m .40577 .42195 L .40867 .44565 L p F P
0 0 0 r
s
.227 .315 .616 r
.40867 .44565 m .38583 .44565 L .38221 .42195 L p F P
0 0 0 r
s
.227 .315 .616 r
.40577 .42195 m .42933 .42195 L .4315 .44565 L p F P
0 0 0 r
s
.227 .315 .616 r
.4315 .44565 m .40867 .44565 L .40577 .42195 L p F P
0 0 0 r
s
.227 .315 .616 r
.42933 .42195 m .45289 .42195 L .45433 .44565 L p F P
0 0 0 r
s
.227 .315 .616 r
.45433 .44565 m .4315 .44565 L .42933 .42195 L p F P
0 0 0 r
s
.227 .315 .616 r
.45289 .42195 m .47644 .42195 L .47717 .44565 L p F P
0 0 0 r
s
.227 .315 .616 r
.47717 .44565 m .45433 .44565 L .45289 .42195 L p F P
0 0 0 r
s
.227 .315 .616 r
.47644 .42195 m .5 .42195 L .5 .44565 L p F P
0 0 0 r
s
.227 .315 .616 r
.5 .44565 m .47717 .44565 L .47644 .42195 L p F P
0 0 0 r
s
.227 .315 .616 r
.5 .42195 m .52356 .42195 L .52283 .44565 L p F P
0 0 0 r
s
.227 .315 .616 r
.52283 .44565 m .5 .44565 L .5 .42195 L p F P
0 0 0 r
s
.227 .315 .616 r
.52356 .42195 m .54711 .42195 L .54567 .44565 L p F P
0 0 0 r
s
.227 .315 .616 r
.54567 .44565 m .52283 .44565 L .52356 .42195 L p F P
0 0 0 r
s
.227 .315 .616 r
.54711 .42195 m .57067 .42195 L .5685 .44565 L p F P
0 0 0 r
s
.227 .315 .616 r
.5685 .44565 m .54567 .44565 L .54711 .42195 L p F P
0 0 0 r
s
.227 .315 .616 r
.57067 .42195 m .59423 .42195 L .59133 .44565 L p F P
0 0 0 r
s
.227 .315 .616 r
.59133 .44565 m .5685 .44565 L .57067 .42195 L p F P
0 0 0 r
s
.227 .315 .616 r
.59423 .42195 m .61779 .42195 L .61417 .44565 L p F P
0 0 0 r
s
.227 .315 .616 r
.61417 .44565 m .59133 .44565 L .59423 .42195 L p F P
0 0 0 r
s
.227 .315 .616 r
.61779 .42195 m .64134 .42195 L .637 .44565 L p F P
0 0 0 r
s
.227 .315 .616 r
.637 .44565 m .61417 .44565 L .61779 .42195 L p F P
0 0 0 r
s
.227 .315 .616 r
.64134 .42195 m .6649 .42195 L .65983 .44565 L p F P
0 0 0 r
s
.83 .24 .1 r
.66213 .42874 m
.66417 .41283 L
s
.66202 .42959 m
.66213 .42874 L
s
.227 .315 .616 r
.65983 .44565 m .637 .44565 L .64134 .42195 L p F P
0 0 0 r
s
.583 .18 .083 r
.38061 .52388 m .38163 .53382 L .40182 .55761 L p F P
0 0 0 r
s
.583 .18 .083 r
.40182 .55761 m .40112 .54955 L .38061 .52388 L p F P
0 0 0 r
s
1 .338 .138 r
.59818 .55761 m .59888 .54955 L .61939 .52388 L p F P
0 0 0 r
s
1 .338 .138 r
.61939 .52388 m .61837 .53382 L .59818 .55761 L p F P
0 0 0 r
s
.83 .24 .1 r
.66381 .3286 m
.65109 .30442 L
s
.65478 .27061 m
.65109 .30442 L
s
.34522 .27061 m
.34891 .30442 L
s
.34891 .30442 m
.33619 .3286 L
s
.274 .398 .781 r
.40112 .54955 m .41525 .54955 L .43494 .57364 L p F P
0 0 0 r
s
.274 .398 .781 r
.43494 .57364 m .42409 .57364 L .40112 .54955 L p F P
0 0 0 r
s
.24 .35 .67 r
.40529 .56511 m
.40628 .59437 L
s
.83 .24 .1 r
.40007 .54823 m
.40222 .54955 L
s
.274 .398 .781 r
.41525 .54955 m .42937 .54955 L .44578 .57364 L p F P
0 0 0 r
s
.274 .398 .781 r
.44578 .57364 m .43494 .57364 L .41525 .54955 L p F P
0 0 0 r
s
.83 .24 .1 r
.41663 .55835 m
.41703 .56379 L
s
.40876 .55354 m
.41663 .55835 L
s
.274 .398 .781 r
.42937 .54955 m .4435 .54955 L .45662 .57364 L p F P
0 0 0 r
s
.24 .35 .67 r
.45273 .57019 m
.45279 .57364 L
s
.83 .24 .1 r
.44904 .58834 m
.44914 .59045 L
s
.274 .398 .781 r
.45662 .57364 m .44578 .57364 L .42937 .54955 L p F P
0 0 0 r
s
.274 .398 .781 r
.4435 .54955 m .45762 .54955 L .46747 .57364 L p F P
0 0 0 r
s
.274 .398 .781 r
.46747 .57364 m .45662 .57364 L .4435 .54955 L p F P
0 0 0 r
s
.83 .24 .1 r
.4482 .57007 m
.44904 .58834 L
s
.274 .398 .781 r
.45762 .54955 m .47175 .54955 L .47831 .57364 L p F P
0 0 0 r
s
.274 .398 .781 r
.47831 .57364 m .46747 .57364 L .45762 .54955 L p F P
0 0 0 r
s
.274 .398 .781 r
.47175 .54955 m .48587 .54955 L .48916 .57364 L p F P
0 0 0 r
s
.274 .398 .781 r
.48916 .57364 m .47831 .57364 L .47175 .54955 L p F P
0 0 0 r
s
.274 .398 .781 r
.48587 .54955 m .5 .54955 L .5 .57364 L p F P
0 0 0 r
s
.274 .398 .781 r
.5 .57364 m .48916 .57364 L .48587 .54955 L p F P
0 0 0 r
s
.274 .398 .781 r
.5 .54955 m .51413 .54955 L .51084 .57364 L p F P
0 0 0 r
s
.274 .398 .781 r
.51084 .57364 m .5 .57364 L .5 .54955 L p F P
0 0 0 r
s
.274 .398 .781 r
.51413 .54955 m .52825 .54955 L .52169 .57364 L p F P
0 0 0 r
s
.274 .398 .781 r
.52169 .57364 m .51084 .57364 L .51413 .54955 L p F P
0 0 0 r
s
.274 .398 .781 r
.52825 .54955 m .54238 .54955 L .53253 .57364 L p F P
0 0 0 r
s
.274 .398 .781 r
.53253 .57364 m .52169 .57364 L .52825 .54955 L p F P
0 0 0 r
s
.274 .398 .781 r
.54238 .54955 m .5565 .54955 L .54338 .57364 L p F P
0 0 0 r
s
.83 .24 .1 r
.55086 .59045 m
.55096 .58834 L
s
.274 .398 .781 r
.54338 .57364 m .53253 .57364 L .54238 .54955 L p F P
0 0 0 r
s
.274 .398 .781 r
.5565 .54955 m .57063 .54955 L .55422 .57364 L p F P
0 0 0 r
s
.274 .398 .781 r
.55422 .57364 m .54338 .57364 L .5565 .54955 L p F P
0 0 0 r
s
.83 .24 .1 r
.55096 .58834 m
.5518 .57007 L
s
.274 .398 .781 r
.57063 .54955 m .58475 .54955 L .56506 .57364 L p F P
0 0 0 r
s
.274 .398 .781 r
.56506 .57364 m .55422 .57364 L .57063 .54955 L p F P
0 0 0 r
s
.274 .398 .781 r
.58475 .54955 m .59888 .54955 L .57591 .57364 L p F P
0 0 0 r
s
.83 .24 .1 r
.59778 .54955 m
.59993 .54823 L
s
.24 .35 .67 r
.59372 .59437 m
.59471 .56511 L
s
.274 .398 .781 r
.57591 .57364 m .56506 .57364 L .58475 .54955 L p F P
0 0 0 r
s
.83 .24 .1 r
.58337 .55835 m
.59124 .55354 L
s
.58297 .56379 m
.58337 .55835 L
s
.24 .35 .67 r
.78377 .43038 m
.83107 .43038 L
s
.73648 .43038 m
.78377 .43038 L
s
.68918 .43038 m
.73648 .43038 L
s
.66317 .43038 m
.68918 .43038 L
s
.31082 .43038 m
.33683 .43038 L
s
.26352 .43038 m
.31082 .43038 L
s
.21623 .43038 m
.26352 .43038 L
s
.16893 .43038 m
.21623 .43038 L
s
.78377 .43038 m
.78579 .46287 L
s
.83342 .46287 m
.83107 .43038 L
s
.73648 .43038 m
.73816 .46287 L
s
.68918 .43038 m
.69053 .46287 L
s
.31082 .43038 m
.30947 .46287 L
s
.26352 .43038 m
.26184 .46287 L
s
.21623 .43038 m
.21421 .46287 L
s
.16893 .43038 m
.16658 .46287 L
s
.83 .24 .1 r
.66566 .38641 m
.6697 .35454 L
s
.66417 .41283 m
.66566 .38641 L
s
.3303 .35454 m
.33434 .38641 L
s
.33434 .38641 m
.33583 .41283 L
s
.32 .095 .05 r
.3646 .50907 m .36326 .49743 L .34964 .47107 L p F P
0 0 0 r
s
.43 .135 .065 r
.36326 .49743 m .3646 .50907 L .38163 .53382 L p F P
0 0 0 r
s
1 .333 .134 r
.63674 .49743 m .6354 .50907 L .61837 .53382 L p F P
0 0 0 r
s
1 .315 .125 r
.6354 .50907 m .63674 .49743 L .65036 .47107 L p F P
0 0 0 r
s
.43 .135 .065 r
.38163 .53382 m .38061 .52388 L .36326 .49743 L p F P
0 0 0 r
s
1 .333 .134 r
.61837 .53382 m .61939 .52388 L .63674 .49743 L p F P
0 0 0 r
s
.24 .35 .67 r
.78598 .5322 m
.78414 .56511 L
s
.8315 .56511 m
.83364 .5322 L
s
.78414 .56511 m
.8315 .56511 L
s
.73831 .5322 m
.73678 .56511 L
s
.73678 .56511 m
.78414 .56511 L
s
.69065 .5322 m
.68943 .56511 L
s
.68943 .56511 m
.73678 .56511 L
s
.64299 .5322 m
.64207 .56511 L
s
.64207 .56511 m
.68943 .56511 L
s
.59471 .56511 m
.59489 .55573 L
s
.59471 .56511 m
.64207 .56511 L
s
.5852 .56511 m
.59471 .56511 L
s
.40511 .55573 m
.40529 .56511 L
s
.40529 .56511 m
.4148 .56511 L
s
.35701 .5322 m
.35793 .56511 L
s
.35793 .56511 m
.40529 .56511 L
s
.30935 .5322 m
.31057 .56511 L
s
.31057 .56511 m
.35793 .56511 L
s
.26169 .5322 m
.26322 .56511 L
s
.26322 .56511 m
.31057 .56511 L
s
.21402 .5322 m
.21586 .56511 L
s
.21586 .56511 m
.26322 .56511 L
s
.16636 .5322 m
.1685 .56511 L
s
.1685 .56511 m
.21586 .56511 L
s
.83 .24 .1 r
.6355 .24898 m
.61098 .23081 L
s
.61369 .1951 m
.61098 .23081 L
s
.38631 .1951 m
.38902 .23081 L
s
.38902 .23081 m
.3645 .24898 L
s
.239 .337 .658 r
.34017 .44565 m .363 .44565 L .37112 .47107 L p F P
0 0 0 r
s
.239 .337 .658 r
.37112 .47107 m .34964 .47107 L .34017 .44565 L p F P
0 0 0 r
s
.83 .24 .1 r
.34471 .43875 m
.34739 .46034 L
s
.34739 .46034 m
.3476 .46205 L
s
.239 .337 .658 r
.363 .44565 m .38583 .44565 L .3926 .47107 L p F P
0 0 0 r
s
.239 .337 .658 r
.3926 .47107 m .37112 .47107 L .363 .44565 L p F P
0 0 0 r
s
.239 .337 .658 r
.38583 .44565 m .40867 .44565 L .41408 .47107 L p F P
0 0 0 r
s
.239 .337 .658 r
.41408 .47107 m .3926 .47107 L .38583 .44565 L p F P
0 0 0 r
s
.239 .337 .658 r
.40867 .44565 m .4315 .44565 L .43556 .47107 L p F P
0 0 0 r
s
.239 .337 .658 r
.43556 .47107 m .41408 .47107 L .40867 .44565 L p F P
0 0 0 r
s
.239 .337 .658 r
.4315 .44565 m .45433 .44565 L .45704 .47107 L p F P
0 0 0 r
s
.239 .337 .658 r
.45704 .47107 m .43556 .47107 L .4315 .44565 L p F P
0 0 0 r
s
.239 .337 .658 r
.45433 .44565 m .47717 .44565 L .47852 .47107 L p F P
0 0 0 r
s
.239 .337 .658 r
.47852 .47107 m .45704 .47107 L .45433 .44565 L p F P
0 0 0 r
s
.239 .337 .658 r
.47717 .44565 m .5 .44565 L .5 .47107 L p F P
0 0 0 r
s
.239 .337 .658 r
.5 .47107 m .47852 .47107 L .47717 .44565 L p F P
0 0 0 r
s
.239 .337 .658 r
.5 .44565 m .52283 .44565 L .52148 .47107 L p F P
0 0 0 r
s
.239 .337 .658 r
.52148 .47107 m .5 .47107 L .5 .44565 L p F P
0 0 0 r
s
.239 .337 .658 r
.52283 .44565 m .54567 .44565 L .54296 .47107 L p F P
0 0 0 r
s
.239 .337 .658 r
.54296 .47107 m .52148 .47107 L .52283 .44565 L p F P
0 0 0 r
s
.239 .337 .658 r
.54567 .44565 m .5685 .44565 L .56444 .47107 L p F P
0 0 0 r
s
.239 .337 .658 r
.56444 .47107 m .54296 .47107 L .54567 .44565 L p F P
0 0 0 r
s
.239 .337 .658 r
.5685 .44565 m .59133 .44565 L .58592 .47107 L p F P
0 0 0 r
s
.239 .337 .658 r
.58592 .47107 m .56444 .47107 L .5685 .44565 L p F P
0 0 0 r
s
.239 .337 .658 r
.59133 .44565 m .61417 .44565 L .6074 .47107 L p F P
0 0 0 r
s
.239 .337 .658 r
.6074 .47107 m .58592 .47107 L .59133 .44565 L p F P
0 0 0 r
s
.239 .337 .658 r
.61417 .44565 m .637 .44565 L .62888 .47107 L p F P
0 0 0 r
s
.239 .337 .658 r
.62888 .47107 m .6074 .47107 L .61417 .44565 L p F P
0 0 0 r
s
.239 .337 .658 r
.637 .44565 m .65983 .44565 L .65036 .47107 L p F P
0 0 0 r
s
.83 .24 .1 r
.6524 .46205 m
.65261 .46034 L
s
.65261 .46034 m
.65529 .43875 L
s
.239 .337 .658 r
.65036 .47107 m .62888 .47107 L .637 .44565 L p F P
0 0 0 r
s
.267 .385 .754 r
.38061 .52388 m .39767 .52388 L .41525 .54955 L p F P
0 0 0 r
s
.24 .35 .67 r
.40485 .54185 m
.405 .54955 L
s
.267 .385 .754 r
.41525 .54955 m .40112 .54955 L .38061 .52388 L p F P
0 0 0 r
s
.267 .385 .754 r
.39767 .52388 m .41472 .52388 L .42937 .54955 L p F P
0 0 0 r
s
.267 .385 .754 r
.42937 .54955 m .41525 .54955 L .39767 .52388 L p F P
0 0 0 r
s
.267 .385 .754 r
.41472 .52388 m .43178 .52388 L .4435 .54955 L p F P
0 0 0 r
s
.267 .385 .754 r
.4435 .54955 m .42937 .54955 L .41472 .52388 L p F P
0 0 0 r
s
.267 .385 .754 r
.43178 .52388 m .44883 .52388 L .45762 .54955 L p F P
0 0 0 r
s
.24 .35 .67 r
.45245 .54441 m
.4525 .54955 L
s
.267 .385 .754 r
.45762 .54955 m .4435 .54955 L .43178 .52388 L p F P
0 0 0 r
s
.267 .385 .754 r
.44883 .52388 m .46589 .52388 L .47175 .54955 L p F P
0 0 0 r
s
.267 .385 .754 r
.47175 .54955 m .45762 .54955 L .44883 .52388 L p F P
0 0 0 r
s
.267 .385 .754 r
.46589 .52388 m .48294 .52388 L .48587 .54955 L p F P
0 0 0 r
s
.267 .385 .754 r
.48587 .54955 m .47175 .54955 L .46589 .52388 L p F P
0 0 0 r
s
.267 .385 .754 r
.48294 .52388 m .5 .52388 L .5 .54955 L p F P
0 0 0 r
s
.267 .385 .754 r
.5 .54955 m .48587 .54955 L .48294 .52388 L p F P
0 0 0 r
s
.267 .385 .754 r
.5 .52388 m .51706 .52388 L .51413 .54955 L p F P
0 0 0 r
s
.267 .385 .754 r
.51413 .54955 m .5 .54955 L .5 .52388 L p F P
0 0 0 r
s
.267 .385 .754 r
.51706 .52388 m .53411 .52388 L .52825 .54955 L p F P
0 0 0 r
s
.267 .385 .754 r
.52825 .54955 m .51413 .54955 L .51706 .52388 L p F P
0 0 0 r
s
.267 .385 .754 r
.53411 .52388 m .55117 .52388 L .54238 .54955 L p F P
0 0 0 r
s
.267 .385 .754 r
.54238 .54955 m .52825 .54955 L .53411 .52388 L p F P
0 0 0 r
s
.267 .385 .754 r
.55117 .52388 m .56822 .52388 L .5565 .54955 L p F P
0 0 0 r
s
.267 .385 .754 r
.5565 .54955 m .54238 .54955 L .55117 .52388 L p F P
0 0 0 r
s
.267 .385 .754 r
.56822 .52388 m .58528 .52388 L .57063 .54955 L p F P
0 0 0 r
s
.267 .385 .754 r
.57063 .54955 m .5565 .54955 L .56822 .52388 L p F P
0 0 0 r
s
.267 .385 .754 r
.58528 .52388 m .60233 .52388 L .58475 .54955 L p F P
0 0 0 r
s
.267 .385 .754 r
.58475 .54955 m .57063 .54955 L .58528 .52388 L p F P
0 0 0 r
s
.267 .385 .754 r
.60233 .52388 m .61939 .52388 L .59888 .54955 L p F P
0 0 0 r
s
.267 .385 .754 r
.59888 .54955 m .58475 .54955 L .60233 .52388 L p F P
0 0 0 r
s
.24 .35 .67 r
.78579 .46287 m
.83342 .46287 L
s
.73816 .46287 m
.78579 .46287 L
s
.69053 .46287 m
.73816 .46287 L
s
.65362 .46287 m
.69053 .46287 L
s
.30947 .46287 m
.34638 .46287 L
s
.26184 .46287 m
.30947 .46287 L
s
.21421 .46287 m
.26184 .46287 L
s
.16658 .46287 m
.21421 .46287 L
s
.78579 .46287 m
.78654 .49746 L
s
.8343 .49746 m
.83342 .46287 L
s
.73816 .46287 m
.73878 .49746 L
s
.69053 .46287 m
.69103 .49746 L
s
.64298 .47107 m
.64314 .48505 L
s
.35686 .48505 m
.35702 .47107 L
s
.30947 .46287 m
.30897 .49746 L
s
.26184 .46287 m
.26122 .49746 L
s
.21421 .46287 m
.21346 .49746 L
s
.16658 .46287 m
.1657 .49746 L
s
.83 .24 .1 r
.41458 .5305 m
.41663 .55835 L
s
.41663 .55835 m
.4482 .57007 L
s
.5518 .57007 m
.58337 .55835 L
s
.58337 .55835 m
.58542 .5305 L
s
.24 .35 .67 r
.78654 .49746 m
.78598 .5322 L
s
.83364 .5322 m
.8343 .49746 L
s
.78598 .5322 m
.83364 .5322 L
s
.73878 .49746 m
.73831 .5322 L
s
.73831 .5322 m
.78598 .5322 L
s
.69103 .49746 m
.69065 .5322 L
s
.69065 .5322 m
.73831 .5322 L
s
.64299 .5322 m
.64327 .49746 L
s
.64299 .5322 m
.69065 .5322 L
s
.59537 .52388 m
.59551 .49746 L
s
.61503 .5322 m
.64299 .5322 L
s
.61351 .5322 m
.61503 .5322 L
s
.54769 .52388 m
.54776 .49746 L
s
.5 .49746 m
.5 .52388 L
s
.45224 .49746 m
.45231 .52388 L
s
.40449 .49746 m
.40463 .52388 L
s
.35673 .49746 m
.35701 .5322 L
s
.35701 .5322 m
.38497 .5322 L
s
.38497 .5322 m
.38649 .5322 L
s
.30897 .49746 m
.30935 .5322 L
s
.30935 .5322 m
.35701 .5322 L
s
.26122 .49746 m
.26169 .5322 L
s
.26169 .5322 m
.30935 .5322 L
s
.21346 .49746 m
.21402 .5322 L
s
.21402 .5322 m
.26169 .5322 L
s
.1657 .49746 m
.16636 .5322 L
s
.16636 .5322 m
.21402 .5322 L
s
.25 .354 .694 r
.34964 .47107 m .37112 .47107 L .3828 .49743 L p F P
0 0 0 r
s
.25 .354 .694 r
.3828 .49743 m .36326 .49743 L .34964 .47107 L p F P
0 0 0 r
s
.83 .24 .1 r
.36422 .49261 m
.36464 .49627 L
s
.36196 .48917 m
.36422 .49261 L
s
.35901 .48471 m
.36196 .48917 L
s
.24 .35 .67 r
.35673 .49746 m
.35685 .48612 L
s
.25 .354 .694 r
.37112 .47107 m .3926 .47107 L .40233 .49743 L p F P
0 0 0 r
s
.25 .354 .694 r
.40233 .49743 m .3828 .49743 L .37112 .47107 L p F P
0 0 0 r
s
.25 .354 .694 r
.3926 .47107 m .41408 .47107 L .42186 .49743 L p F P
0 0 0 r
s
.25 .354 .694 r
.42186 .49743 m .40233 .49743 L .3926 .47107 L p F P
0 0 0 r
s
.24 .35 .67 r
.40449 .49746 m
.40449 .49743 L
s
.25 .354 .694 r
.41408 .47107 m .43556 .47107 L .4414 .49743 L p F P
0 0 0 r
s
.25 .354 .694 r
.4414 .49743 m .42186 .49743 L .41408 .47107 L p F P
0 0 0 r
s
.25 .354 .694 r
.43556 .47107 m .45704 .47107 L .46093 .49743 L p F P
0 0 0 r
s
.25 .354 .694 r
.46093 .49743 m .4414 .49743 L .43556 .47107 L p F P
0 0 0 r
s
.24 .35 .67 r
.45224 .49746 m
.45224 .49743 L
s
.25 .354 .694 r
.45704 .47107 m .47852 .47107 L .48047 .49743 L p F P
0 0 0 r
s
.25 .354 .694 r
.48047 .49743 m .46093 .49743 L .45704 .47107 L p F P
0 0 0 r
s
.25 .354 .694 r
.47852 .47107 m .5 .47107 L .5 .49743 L p F P
0 0 0 r
s
.25 .354 .694 r
.5 .49743 m .48047 .49743 L .47852 .47107 L p F P
0 0 0 r
s
.25 .354 .694 r
.5 .47107 m .52148 .47107 L .51953 .49743 L p F P
0 0 0 r
s
.25 .354 .694 r
.51953 .49743 m .5 .49743 L .5 .47107 L p F P
0 0 0 r
s
.24 .35 .67 r
.5 .49743 m
.5 .49746 L
s
.25 .354 .694 r
.52148 .47107 m .54296 .47107 L .53907 .49743 L p F P
0 0 0 r
s
.25 .354 .694 r
.53907 .49743 m .51953 .49743 L .52148 .47107 L p F P
0 0 0 r
s
.25 .354 .694 r
.54296 .47107 m .56444 .47107 L .5586 .49743 L p F P
0 0 0 r
s
.25 .354 .694 r
.5586 .49743 m .53907 .49743 L .54296 .47107 L p F P
0 0 0 r
s
.24 .35 .67 r
.54776 .49743 m
.54776 .49746 L
s
.25 .354 .694 r
.56444 .47107 m .58592 .47107 L .57814 .49743 L p F P
0 0 0 r
s
.25 .354 .694 r
.57814 .49743 m .5586 .49743 L .56444 .47107 L p F P
0 0 0 r
s
.25 .354 .694 r
.58592 .47107 m .6074 .47107 L .59767 .49743 L p F P
0 0 0 r
s
.25 .354 .694 r
.59767 .49743 m .57814 .49743 L .58592 .47107 L p F P
0 0 0 r
s
.24 .35 .67 r
.59551 .49743 m
.59551 .49746 L
s
.25 .354 .694 r
.6074 .47107 m .62888 .47107 L .6172 .49743 L p F P
0 0 0 r
s
.25 .354 .694 r
.6172 .49743 m .59767 .49743 L .6074 .47107 L p F P
0 0 0 r
s
.25 .354 .694 r
.62888 .47107 m .65036 .47107 L .63674 .49743 L p F P
0 0 0 r
s
.24 .35 .67 r
.64315 .48612 m
.64327 .49746 L
s
.83 .24 .1 r
.63804 .48917 m
.64099 .48471 L
s
.25 .354 .694 r
.63674 .49743 m .6172 .49743 L .62888 .47107 L p F P
0 0 0 r
s
.83 .24 .1 r
.63536 .49627 m
.63578 .49261 L
s
.63578 .49261 m
.63804 .48917 L
s
.24 .35 .67 r
.78654 .49746 m
.8343 .49746 L
s
.73878 .49746 m
.78654 .49746 L
s
.69103 .49746 m
.73878 .49746 L
s
.64327 .49746 m
.69103 .49746 L
s
.63744 .49746 m
.64327 .49746 L
s
.59551 .49746 m
.63672 .49746 L
s
.6372 .49746 m
.63744 .49746 L
s
.54776 .49746 m
.59551 .49746 L
s
.5 .49746 m
.54776 .49746 L
s
.45224 .49746 m
.5 .49746 L
s
.40449 .49746 m
.45224 .49746 L
s
.35673 .49746 m
.3628 .49746 L
s
.36328 .49746 m
.40449 .49746 L
s
.30897 .49746 m
.35673 .49746 L
s
.26122 .49746 m
.30897 .49746 L
s
.21346 .49746 m
.26122 .49746 L
s
.1657 .49746 m
.21346 .49746 L
s
.259 .37 .725 r
.36326 .49743 m .3828 .49743 L .39767 .52388 L p F P
0 0 0 r
s
.83 .24 .1 r
.36491 .4987 m
.36509 .50021 L
s
.38818 .53021 m
.38827 .5311 L
s
.259 .37 .725 r
.39767 .52388 m .38061 .52388 L .36326 .49743 L p F P
0 0 0 r
s
.259 .37 .725 r
.3828 .49743 m .40233 .49743 L .41472 .52388 L p F P
0 0 0 r
s
.259 .37 .725 r
.41472 .52388 m .39767 .52388 L .3828 .49743 L p F P
0 0 0 r
s
.83 .24 .1 r
.38658 .5136 m
.38818 .53021 L
s
.259 .37 .725 r
.40233 .49743 m .42186 .49743 L .43178 .52388 L p F P
0 0 0 r
s
.259 .37 .725 r
.43178 .52388 m .41472 .52388 L .40233 .49743 L p F P
0 0 0 r
s
.259 .37 .725 r
.42186 .49743 m .4414 .49743 L .44883 .52388 L p F P
0 0 0 r
s
.259 .37 .725 r
.44883 .52388 m .43178 .52388 L .42186 .49743 L p F P
0 0 0 r
s
.259 .37 .725 r
.4414 .49743 m .46093 .49743 L .46589 .52388 L p F P
0 0 0 r
s
.259 .37 .725 r
.46589 .52388 m .44883 .52388 L .4414 .49743 L p F P
0 0 0 r
s
.259 .37 .725 r
.46093 .49743 m .48047 .49743 L .48294 .52388 L p F P
0 0 0 r
s
.259 .37 .725 r
.48294 .52388 m .46589 .52388 L .46093 .49743 L p F P
0 0 0 r
s
.259 .37 .725 r
.48047 .49743 m .5 .49743 L .5 .52388 L p F P
0 0 0 r
s
.259 .37 .725 r
.5 .52388 m .48294 .52388 L .48047 .49743 L p F P
0 0 0 r
s
.259 .37 .725 r
.5 .49743 m .51953 .49743 L .51706 .52388 L p F P
0 0 0 r
s
.259 .37 .725 r
.51706 .52388 m .5 .52388 L .5 .49743 L p F P
0 0 0 r
s
.259 .37 .725 r
.51953 .49743 m .53907 .49743 L .53411 .52388 L p F P
0 0 0 r
s
.259 .37 .725 r
.53411 .52388 m .51706 .52388 L .51953 .49743 L p F P
0 0 0 r
s
.259 .37 .725 r
.53907 .49743 m .5586 .49743 L .55117 .52388 L p F P
0 0 0 r
s
.259 .37 .725 r
.55117 .52388 m .53411 .52388 L .53907 .49743 L p F P
0 0 0 r
s
.259 .37 .725 r
.5586 .49743 m .57814 .49743 L .56822 .52388 L p F P
0 0 0 r
s
.259 .37 .725 r
.56822 .52388 m .55117 .52388 L .5586 .49743 L p F P
0 0 0 r
s
.259 .37 .725 r
.57814 .49743 m .59767 .49743 L .58528 .52388 L p F P
0 0 0 r
s
.259 .37 .725 r
.58528 .52388 m .56822 .52388 L .57814 .49743 L p F P
0 0 0 r
s
.259 .37 .725 r
.59767 .49743 m .6172 .49743 L .60233 .52388 L p F P
0 0 0 r
s
.83 .24 .1 r
.61173 .5311 m
.61182 .53021 L
s
.259 .37 .725 r
.60233 .52388 m .58528 .52388 L .59767 .49743 L p F P
0 0 0 r
s
.259 .37 .725 r
.6172 .49743 m .63674 .49743 L .61939 .52388 L p F P
0 0 0 r
s
.259 .37 .725 r
.61939 .52388 m .60233 .52388 L .6172 .49743 L p F P
0 0 0 r
s
.83 .24 .1 r
.61182 .53021 m
.61342 .5136 L
s
.55181 .17123 m
.51748 .16632 L
s
.51748 .16632 m
.48252 .16632 L
s
.48252 .16632 m
.44819 .17123 L
s
.33214 .29495 m
.33619 .3286 L
s
.33619 .3286 m
.3303 .35454 L
s
.6697 .35454 m
.66381 .3286 L
s
.66786 .29495 m
.66381 .3286 L
s
.65478 .27061 m
.6355 .24898 L
s
.63884 .21336 m
.6355 .24898 L
s
.36116 .21336 m
.3645 .24898 L
s
.3645 .24898 m
.34522 .27061 L
s
.44692 .54236 m
.4482 .57007 L
s
.4482 .57007 m
.48243 .57611 L
s
.51757 .57611 m
.5518 .57007 L
s
.55308 .54236 m
.5518 .57007 L
s
.58429 .18091 m
.55181 .17123 L
s
.44819 .17123 m
.41571 .18091 L
s
.36086 .46294 m
.36422 .49261 L
s
.36422 .49261 m
.38658 .5136 L
s
.61342 .5136 m
.63578 .49261 L
s
.63914 .46294 m
.63578 .49261 L
s
.65529 .43875 m
.66417 .41283 L
s
.66824 .38118 m
.66417 .41283 L
s
.33176 .38118 m
.33583 .41283 L
s
.33583 .41283 m
.34471 .43875 L
s
.48199 .54847 m
.48243 .57611 L
s
.48243 .57611 m
.51757 .57611 L
s
.51801 .54847 m
.51757 .57611 L
s
.61369 .1951 m
.58429 .18091 L
s
.41571 .18091 m
.38631 .1951 L
s
.66786 .29495 m
.65478 .27061 L
s
.65864 .2351 m
.65478 .27061 L
s
.34136 .2351 m
.34522 .27061 L
s
.34522 .27061 m
.33214 .29495 L
s
.38375 .48416 m
.38658 .5136 L
s
.38658 .5136 m
.41458 .5305 L
s
.58542 .5305 m
.61342 .5136 L
s
.61625 .48416 m
.61342 .5136 L
s
.6697 .35454 m
.67395 .32108 L
s
.66824 .38118 m
.6697 .35454 L
s
.32605 .32108 m
.3303 .35454 L
s
.3303 .35454 m
.33176 .38118 L
s
.63884 .21336 m
.61369 .1951 L
s
.38631 .1951 m
.36116 .21336 L
s
.34082 .40734 m
.34471 .43875 L
s
.34471 .43875 m
.36086 .46294 L
s
.63914 .46294 m
.65529 .43875 L
s
.65918 .40734 m
.65529 .43875 L
s
.41242 .50124 m
.41458 .5305 L
s
.41458 .5305 m
.44692 .54236 L
s
.55308 .54236 m
.58542 .5305 L
s
.58758 .50124 m
.58542 .5305 L
s
.32789 .25959 m
.33214 .29495 L
s
.33214 .29495 m
.32605 .32108 L
s
.67395 .32108 m
.66786 .29495 L
s
.67211 .25959 m
.66786 .29495 L
s
.65864 .2351 m
.63884 .21336 L
s
.36116 .21336 m
.34136 .2351 L
s
.44557 .51323 m
.44692 .54236 L
s
.44692 .54236 m
.48199 .54847 L
s
.51801 .54847 m
.55308 .54236 L
s
.55443 .51323 m
.55308 .54236 L
s
.61625 .48416 m
.63914 .46294 L
s
.64267 .43177 m
.63914 .46294 L
s
.35733 .43177 m
.36086 .46294 L
s
.36086 .46294 m
.38375 .48416 L
s
.65918 .40734 m
.66824 .38118 L
s
.67251 .34793 m
.66824 .38118 L
s
.32749 .34793 m
.33176 .38118 L
s
.33176 .38118 m
.34082 .40734 L
s
.48153 .51941 m
.48199 .54847 L
s
.48199 .54847 m
.51801 .54847 L
s
.51847 .51941 m
.51801 .54847 L
s
.34136 .2351 m
.32789 .25959 L
s
.67211 .25959 m
.65864 .2351 L
s
.38077 .4532 m
.38375 .48416 L
s
.38375 .48416 m
.41242 .50124 L
s
.58758 .50124 m
.61625 .48416 L
s
.61923 .4532 m
.61625 .48416 L
s
.67395 .32108 m
.67842 .2859 L
s
.67251 .34793 m
.67395 .32108 L
s
.32158 .2859 m
.32605 .32108 L
s
.32605 .32108 m
.32749 .34793 L
s
.64267 .43177 m
.65918 .40734 L
s
.66328 .37432 m
.65918 .40734 L
s
.33672 .37432 m
.34082 .40734 L
s
.34082 .40734 m
.35733 .43177 L
s
.41016 .47047 m
.41242 .50124 L
s
.41242 .50124 m
.44557 .51323 L
s
.55443 .51323 m
.58758 .50124 L
s
.58984 .47047 m
.58758 .50124 L
s
.32789 .25959 m
.32158 .2859 L
s
.67842 .2859 m
.67211 .25959 L
s
.44415 .4826 m
.44557 .51323 L
s
.44557 .51323 m
.48153 .51941 L
s
.51847 .51941 m
.55443 .51323 L
s
.55585 .4826 m
.55443 .51323 L
s
.35361 .39897 m
.35733 .43177 L
s
.35733 .43177 m
.38077 .4532 L
s
.61923 .4532 m
.64267 .43177 L
s
.64639 .39897 m
.64267 .43177 L
s
.66328 .37432 m
.67251 .34793 L
s
.677 .31295 m
.67251 .34793 L
s
.323 .31295 m
.32749 .34793 L
s
.32749 .34793 m
.33672 .37432 L
s
.48105 .48885 m
.48153 .51941 L
s
.48153 .51941 m
.51847 .51941 L
s
.51895 .48885 m
.51847 .51941 L
s
.58984 .47047 m
.61923 .4532 L
s
.62237 .42062 m
.61923 .4532 L
s
.37763 .42062 m
.38077 .4532 L
s
.38077 .4532 m
.41016 .47047 L
s
.677 .31295 m
.67842 .2859 L
s
.32158 .2859 m
.323 .31295 L
s
.64639 .39897 m
.66328 .37432 L
s
.66759 .33955 m
.66328 .37432 L
s
.33241 .33955 m
.33672 .37432 L
s
.33672 .37432 m
.35361 .39897 L
s
.40777 .43807 m
.41016 .47047 L
s
.41016 .47047 m
.44415 .4826 L
s
.55585 .4826 m
.58984 .47047 L
s
.59223 .43807 m
.58984 .47047 L
s
.44266 .45032 m
.44415 .4826 L
s
.44415 .4826 m
.48105 .48885 L
s
.51895 .48885 m
.55585 .4826 L
s
.55734 .45032 m
.55585 .4826 L
s
.62237 .42062 m
.64639 .39897 L
s
.6503 .36442 m
.64639 .39897 L
s
.3497 .36442 m
.35361 .39897 L
s
.35361 .39897 m
.37763 .42062 L
s
.66759 .33955 m
.677 .31295 L
s
.323 .31295 m
.33241 .33955 L
s
.48055 .45664 m
.48105 .48885 L
s
.48105 .48885 m
.51895 .48885 L
s
.51945 .45664 m
.51895 .48885 L
s
.37432 .38627 m
.37763 .42062 L
s
.37763 .42062 m
.40777 .43807 L
s
.59223 .43807 m
.62237 .42062 L
s
.62568 .38627 m
.62237 .42062 L
s
.33241 .33955 m
.3497 .36442 L
s
.6503 .36442 m
.66759 .33955 L
s
.40526 .4039 m
.40777 .43807 L
s
.40777 .43807 m
.44266 .45032 L
s
.55734 .45032 m
.59223 .43807 L
s
.59474 .4039 m
.59223 .43807 L
s
.44109 .41628 m
.44266 .45032 L
s
.44266 .45032 m
.48055 .45664 L
s
.51945 .45664 m
.55734 .45032 L
s
.55891 .41628 m
.55734 .45032 L
s
.3497 .36442 m
.37432 .38627 L
s
.62568 .38627 m
.6503 .36442 L
s
.48001 .42267 m
.48055 .45664 L
s
.48055 .45664 m
.51945 .45664 L
s
.51999 .42267 m
.51945 .45664 L
s
.37432 .38627 m
.40526 .4039 L
s
.59474 .4039 m
.62568 .38627 L
s
.40526 .4039 m
.44109 .41628 L
s
.55891 .41628 m
.59474 .4039 L
s
.44109 .41628 m
.48001 .42267 L
s
.51999 .42267 m
.55891 .41628 L
s
.48001 .42267 m
.51999 .42267 L
s
0 0 0 r
.25 Mabswid
.14736 .14594 m
.09252 .42015 L
s
.09252 .42015 m
.90748 .42015 L
s
.90748 .42015 m
.85264 .14594 L
s
.85264 .14594 m
.14736 .14594 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{500, 500},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40007d0001m2000`400?l00000o`00003oo`3ooooe
0?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3o
m^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40
oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?of
k_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3o
ool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^
m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?oo
o`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd
0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo
003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0
ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool0
0?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03o
m^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00
o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?of
kP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o
0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^
0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0
ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h1
0?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3o
m^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40
oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?of
k_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00B@3om^ko000006800000B@3om^h10?ooo`00B@3o
m^h00`000000ooK^0?ofkP3o0?ofkUh0ooK^00<000000?ofkP3om^h0A`3om^h10?ooo`00B@3om^h0
0`000000ooK^0?ofkP3o0?ofkUh0ooK^00<000000?ofkP3om^h0A`3om^h10?ooo`00B03om^h00`00
0000ooK^0000003o0?ofkUh0ooK^00<000000?ofkP000000B03om^h10?ooo`00B03om^h00`000000
ooK^0000003o0?ofkUh0ooK^00<000000?ofkP000000B03om^h10?ooo`00B03om^h00`000000ooK^
0000003o0?ofkUh0ooK^00<000000?ofkP000000B03om^h10?ooo`00B03om^h00`000000ooK^0000
003o0?ofkUh0ooK^00<000000?ofkP000000B03om^h10?ooo`00B03om^h010000000ooK^0?ofkP00
003o0?ofkU`0ooK^00@000000?ofkP3om^h00000B03om^h10?ooo`00A`3om^h01@000000ooK^0?of
kP3om^h000000?l0ooK^G03om^h01@000000ooK^0?ofkP3om^h0000004L0ooK^0@3oool004L0ooK^
00D000000?ofkP3om^h0ooK^0000003o0?ofkU`0ooK^00D000000?ofkP3om^h0ooK^000000170?of
kP40oooo00170?ofkP050000003om^h0ooK^0?ofkP000000XP3om^hG0=@m6J80ooK^00D000000?of
kP3om^h0ooK^000000170?ofkP40oooo00170?ofkP030000003om^h0ooK^0080ooK^00<000000?of
kP3om^h0V@3om^h60=@m6@80ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP060=@m
6I/0ooK^00<000000?ofkP3om^h00P3om^h00`000000ooK^0?ofkP150?ofkP40oooo00170?ofkP03
0000003om^h0ooK^0080ooK^00<000000?ofkP3om^h0T`3om^h60=@m6@P0ooK^00<0e3dI0?ofkP3o
m^h03`3om^h00`3D?AT0ooK^0?ofkP060?ofkPH0e3dIU@3om^h00`000000ooK^0?ofkP020?ofkP03
0000003om^h0ooK^04D0ooK^0@3oool004H0ooK^00<000000?ofkP3om^h00`3om^h00`000000ooK^
0?ofkP2?0?ofkP@0e3dI3P3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00`0ooK^
103D?AVA0?ofkP030000003om^h0ooK^00<0ooK^00<000000?ofkP3om^h0A03om^h10?ooo`00AP3o
m^h00`000000ooK^0?ofkP030?ofkP030000003om^h0ooK^08`0ooK^0`3D?AT00`3om^h0e3dI0?of
kP0?0?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0=@m
6@020=@m6Hh0ooK^00<000000?ofkP3om^h00`3om^h00`000000ooK^0?ofkP140?ofkP40oooo0016
0?ofkP030000003om^h0ooK^00<0ooK^00<000000?ofkP3om^h0R@3om^h30=@m6@@0ooK^00<0e3dI
0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI
0?ofkP3om^h00P3om^h30=@m6H/0ooK^00<000000?ofkP3om^h00`3om^h00`000000ooK^0?ofkP14
0?ofkP40oooo00160?ofkP030000003om^h0ooK^00@0ooK^00<000000?ofkP3om^h0Q03om^h40=@m
6@L0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^
00h0ooK^00<0e3dI0?ofkP3om^h01@3om^h40=@m6HH0ooK^00<000000?ofkP3om^h0103om^h00`00
0000ooK^0?ofkP140?ofkP40oooo00160?ofkP030000003om^h0ooK^00@0ooK^00<000000?ofkP3o
m^h0P@3om^h30=@m6@/0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP03
0=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h02@3om^h30=@m6H<0ooK^00<000000?ofkP3o
m^h0103om^h00`000000ooK^0?ofkP140?ofkP40oooo00150?ofkP030000003om^h0ooK^00D0ooK^
00<000000?ofkP3om^h0OP3om^h30=@m6@h0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^
0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h0303om^h30=@m6H00ooK^
00<000000?ofkP3om^h01@3om^h00`000000ooK^0?ofkP130?ofkP40oooo00150?ofkP030000003o
m^h0ooK^00D0ooK^00<000000?ofkP3om^h0O03om^h20=@m6@030?ofkP3D?AT0ooK^00h0ooK^00<0
e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0
e3dI0?ofkP3om^h03@3om^h0103D?AT0ooK^0=@m6@3D?AUn0?ofkP030000003om^h0ooK^00D0ooK^
00<000000?ofkP3om^h0@`3om^h10?ooo`00A@3om^h00`000000ooK^0?ofkP060?ofkP030000003o
m^h0ooK^07T0ooK^0P3D?AT30?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h03P3o
m^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h03@3o
m^h0103D?AT0ooK^0?ofkP3om^h20=@m6G/0ooK^00<000000?ofkP3om^h01P3om^h00`000000ooK^
0?ofkP130?ofkP40oooo00150?ofkP030000003om^h0ooK^00H0ooK^00<000000?ofkP3om^h0M`3o
m^h20=@m6@D0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3o
m^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3o
m^h0ooK^00<0ooK^0P3D?AUi0?ofkP030000003om^h0ooK^00H0ooK^00<000000?ofkP3om^h0@`3o
m^h10?ooo`00A@3om^h00`000000ooK^0?ofkP060?ofkP030000003om^h0ooK^07D0ooK^0P3D?AT7
0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0?
0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP05
0?ofkP80e3dIM`3om^h00`000000ooK^0?ofkP060?ofkP030000003om^h0ooK^04<0ooK^0@3oool0
04@0ooK^00<000000?ofkP3om^h01`3om^h00`000000ooK^0?ofkP1c0?ofkP80e3dI2@3om^h00`3D
?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D
?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h01`3om^h20=@m
6GD0ooK^00<000000?ofkP3om^h01`3om^h00`000000ooK^0?ofkP120?ofkP40oooo00140?ofkP03
0000003om^h0ooK^00L0ooK^00<000000?ofkP3om^h0L@3om^h20=@m6@/0ooK^00<0e3dI0?ofkP3o
m^h03P3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3o
m^h03@3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00T0ooK^0P3D?AUc0?ofkP03
0000003om^h0ooK^00L0ooK^00<000000?ofkP3om^h0@P3om^h10?ooo`00A03om^h00`000000ooK^
0?ofkP080?ofkP030000003om^h0ooK^06h0ooK^0P3D?AT=0?ofkP030=@m6@3om^h0ooK^00h0ooK^
00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00d0ooK^
00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP80e3dIL03om^h00`000000ooK^
0?ofkP080?ofkP030000003om^h0ooK^0480ooK^0@3oool004@0ooK^00<000000?ofkP3om^h0203o
m^h00`000000ooK^0?ofkP1]0?ofkP80e3dI3P3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3o
m^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3o
m^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h0303om^h20=@m6Fl0ooK^00<000000?ofkP3om^h0203o
m^h00`000000ooK^0?ofkP120?ofkP40oooo00140?ofkP030000003om^h0ooK^00P0ooK^00<00000
0?ofkP3om^h0J`3om^h20=@m6@030?ofkP3D?AT0ooK^00d0ooK^00<0e3dI0?ofkP3om^h03P3om^h0
0`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h03@3om^h0
0`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00d0ooK^00@0e3dI0?ofkP3D?AT0e3dIK@3o
m^h00`000000ooK^0?ofkP080?ofkP030000003om^h0ooK^0480ooK^0@3oool004<0ooK^00<00000
0?ofkP3om^h02@3om^h00`000000ooK^0?ofkP1Z0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT03`3o
m^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00/0ooK^5`3D?AT=0?ofkP030=@m6@3o
m^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h03@3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI06`0ooK^
00<000000?ofkP3om^h02@3om^h00`000000ooK^0?ofkP110?ofkP40oooo00130?ofkP030000003o
m^h0ooK^00X0ooK^00<000000?ofkP3om^h0J03om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3o
m^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP060?ofkPD0e3dI0P3o
m^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00D0e3dI203om^h00`3D?AT0ooK^0?of
kP0=0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?of
kP1X0?ofkP030000003om^h0ooK^00X0ooK^00<000000?ofkP3om^h0@@3om^h10?ooo`00@`3om^h0
0`000000ooK^0?ofkP0:0?ofkP030000003om^h0ooK^06H0ooK^0P3D?AT60?ofkP030=@m6@3om^h0
ooK^00`0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP060=@m6@L0ooK^00<0e3dI
0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP050?ofkPH0e3dI0P3om^h00`3D?AT0ooK^0?ofkP0=
0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h0103om^h20=@m6FP0ooK^00<00000
0?ofkP3om^h02P3om^h00`000000ooK^0?ofkP110?ofkP40oooo00130?ofkP030000003om^h0ooK^
00X0ooK^00<000000?ofkP3om^h0I@3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^
00`0ooK^00<0e3dI0?ofkP3om^h0303om^h40=@m6@d0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D
?AT0ooK^0?ofkP0;0?ofkP@0e3dI3P3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^
00H0ooK^00<0e3dI0?ofkP3om^h0I@3om^h00`000000ooK^0?ofkP0:0?ofkP030000003om^h0ooK^
0440ooK^0@3oool004<0ooK^00<000000?ofkP3om^h02P3om^h00`000000ooK^0?ofkP1T0?ofkP03
0=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP090?ofkP<0
e3dI00<0ooK^0=@m6@3om^h03P3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00d0
ooK^00<0e3dI0?ofkP3D?AT00P3D?AT;0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3o
m^h01`3om^h00`3D?AT0ooK^0?ofkP1T0?ofkP030000003om^h0ooK^00X0ooK^00<000000?ofkP3o
m^h0@@3om^h10?ooo`00@P3om^h00`000000ooK^0?ofkP0<0?ofkP030000003om^h0ooK^0640ooK^
0P3D?AT:0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h01P3om^h30=@m6@@0ooK^
00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00d0ooK^
00<0e3dI0?ofkP3om^h00P3om^h30=@m6@P0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^
0?ofkP080?ofkP80e3dIH`3om^h00`000000ooK^0?ofkP0<0?ofkP030000003om^h0ooK^0400ooK^
0@3oool00480ooK^00<000000?ofkP3om^h0303om^h00`000000ooK^0?ofkP1P0?ofkP030=@m6@3o
m^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP020?ofkP@0e3dI1`3o
m^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h03@3o
m^h00`3D?AT0ooK^0?ofkP050?ofkP@0e3dI103om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3o
m^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h0H03om^h00`000000ooK^0?ofkP0<0?ofkP030000003o
m^h0ooK^0400ooK^0@3oool00480ooK^00<000000?ofkP3om^h0303om^h00`000000ooK^0?ofkP1O
0?ofkP80e3dI303om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0e3dI0080e3dI2`3om^h0
0`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h03@3om^h0
0`3D?AT0ooK^0?ofkP090?ofkP<0e3dI00<0ooK^0=@m6@3om^h03@3om^h00`3D?AT0ooK^0?ofkP0:
0?ofkP80e3dIH@3om^h00`000000ooK^0?ofkP0<0?ofkP030000003om^h0ooK^0400ooK^0@3oool0
0480ooK^00<000000?ofkP3om^h0303om^h00`000000ooK^0?ofkP1N0?ofkP030=@m6@3om^h0e3dI
00`0ooK^00<0e3dI0?ofkP3om^h0303om^h20=@m6@h0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D
?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h0303om^h20=@m
6@h0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0=@m6@1P0?ofkP030000003om^h0ooK^
00`0ooK^00<000000?ofkP3om^h0@03om^h10?ooo`00@P3om^h00`000000ooK^0?ofkP0<0?ofkP03
0000003om^h0ooK^05d0ooK^00@0e3dI0?ofkP3om^h0e3dI303om^h00`3D?AT0ooK^0?ofkP0:0?of
kP<0e3dI3`3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?of
kP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP<0e3dI303om^h00`3D?AT0ooK^0?ofkP0:0?of
kP040=@m6@3om^h0ooK^0=@m6El0ooK^00<000000?ofkP3om^h0303om^h00`000000ooK^0?ofkP10
0?ofkP40oooo00120?ofkP030000003om^h0ooK^00d0ooK^00<000000?ofkP3om^h0F`3om^h01@3D
?AT0ooK^0?ofkP3om^h0e3dI00`0ooK^00<0e3dI0?ofkP3om^h0203om^h20=@m6@80ooK^00<0e3dI
0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI
0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^0080e3dI2P3om^h0
0`3D?AT0ooK^0?ofkP0:0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT0G@3om^h00`000000ooK^0?of
kP0=0?ofkP030000003om^h0ooK^0400ooK^0@3oool00440ooK^00<000000?ofkP3om^h03P3om^h0
0`000000ooK^0?ofkP1J0?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h02`3om^h0
0`3D?AT0ooK^0?ofkP050?ofkP80e3dI103om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0
ooK^00h0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0
ooK^00d0ooK^00<0e3dI0?ofkP3om^h00P3om^h20=@m6@L0ooK^00<0e3dI0?ofkP3om^h02`3om^h0
0`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^05X0ooK^00<000000?ofkP3om^h03P3om^h0
0`000000ooK^0?ofkP0o0?ofkP40oooo00110?ofkP030000003om^h0ooK^00h0ooK^00<000000?of
kP3om^h0FP3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?of
kP3om^h00`3om^h20=@m6@H0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0>0?of
kP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0=0?of
kP030=@m6@3om^h0ooK^00@0ooK^0P3D?AT50?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?of
kP3om^h00P3om^h00`3D?AT0ooK^0?ofkP1J0?ofkP030000003om^h0ooK^00h0ooK^00<000000?of
kP3om^h0?`3om^h10?ooo`00@@3om^h00`000000ooK^0?ofkP0>0?ofkP030000003om^h0ooK^05T0
ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP040=@m6@3om^h0ooK^0?of
kP80e3dI203om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?of
kP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?of
kP3om^h01P3om^h20=@m6@<0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP030?of
kP030=@m6@3om^h0ooK^05T0ooK^00<000000?ofkP3om^h03P3om^h00`000000ooK^0?ofkP0o0?of
kP40oooo00110?ofkP030000003om^h0ooK^00l0ooK^00<000000?ofkP3om^h0E`3om^h00`3D?AT0
ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00/0ooK^00@0e3dI0?ofkP3D?AT0e3dI2P3om^h00`3D
?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D
?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h0203om^h20=@m
6@030?ofkP3D?AT0ooK^00`0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP1G0?of
kP030000003om^h0ooK^00l0ooK^00<000000?ofkP3om^h0?`3om^h10?ooo`00@@3om^h00`000000
ooK^0?ofkP0?0?ofkP030000003om^h0ooK^05H0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0
ooK^0?ofkP0;0?ofkP80e3dI303om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00h0
ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00d0
ooK^00<0e3dI0?ofkP3om^h02P3om^h20=@m6@`0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0
ooK^0?ofkP1F0?ofkP030000003om^h0ooK^00l0ooK^00<000000?ofkP3om^h0?`3om^h10?ooo`00
@03om^h00`000000ooK^0?ofkP0@0?ofkP030000003om^h0ooK^05D0ooK^00<0e3dI0?ofkP3om^h0
1`3om^h00`3D?AT0ooK^0?ofkP080?ofkP<0e3dI3@3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m
6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m
6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h02`3om^h30=@m6@X0ooK^00<0e3dI0?ofkP3om^h0
1`3om^h00`3D?AT0ooK^0?ofkP1E0?ofkP030000003om^h0ooK^0100ooK^00<000000?ofkP3om^h0
?P3om^h10?ooo`00@03om^h00`000000ooK^0?ofkP0@0?ofkP030000003om^h0ooK^05@0ooK^00<0
e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP070?ofkP040=@m6@3om^h0ooK^0=@m6@h0ooK^
00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP0<0?ofkQD0e3dI3P3om^h00`3D?AT0ooK^
0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00`0ooK^00@0e3dI0?ofkP3om^h0e3dI2@3om^h00`3D?AT0
ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^05@0ooK^00<000000?ofkP3om^h0403om^h00`000000
ooK^0?ofkP0n0?ofkP40oooo00100?ofkP030000003om^h0ooK^0100ooK^00<000000?ofkP3om^h0
D`3om^h20=@m6@X0ooK^00<0e3dI0?ofkP3om^h01@3om^h20=@m6@<0ooK^00<0e3dI0?ofkP3om^h0
303om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00H0ooK^1P3D?AT20?ofkP030=@m
6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h01P3D?AT80?ofkP030=@m6@3om^h0ooK^00`0ooK^
00<0e3dI0?ofkP3om^h0303om^h0103D?AT0ooK^0?ofkP3om^h20=@m6@L0ooK^00<0e3dI0?ofkP3o
m^h0203om^h20=@m6ED0ooK^00<000000?ofkP3om^h0403om^h00`000000ooK^0?ofkP0n0?ofkP40
oooo00100?ofkP030000003om^h0ooK^0140ooK^00<000000?ofkP3om^h0DP3om^h20=@m6@X0ooK^
00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00`0ooK^
00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP060=@m6@P0ooK^00<0e3dI0?ofkP3om^h0
3@3om^h00`3D?AT0ooK^0?ofkP060?ofkPH0e3dI0P3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m
6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m
6@3om^h0ooK^00P0ooK^0P3D?AUD0?ofkP030000003om^h0ooK^0140ooK^00<000000?ofkP3om^h0
?P3om^h10?ooo`00@03om^h00`000000ooK^0?ofkP0A0?ofkP030000003om^h0ooK^0540ooK^00<0
e3dI0?ofkP3D?AT02P3om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0
e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP0;0?ofkP@0e3dI3P3om^h00`3D?AT0ooK^0?of
kP0=0?ofkP030=@m6@3om^h0ooK^00`0ooK^103D?AT=0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0
e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0
e3dI0?ofkP3D?AT0D`3om^h00`000000ooK^0?ofkP0A0?ofkP030000003om^h0ooK^03h0ooK^0@3o
ool003l0ooK^00<000000?ofkP3om^h04P3om^h00`000000ooK^0?ofkP1A0?ofkP030=@m6@3om^h0
e3dI00X0ooK^00@0e3dI0?ofkP3om^h0ooK^0P3D?AT70?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0
e3dI0?ofkP3om^h0203om^h30=@m6@030?ofkP3D?AT0ooK^00l0ooK^00<0e3dI0?ofkP3om^h03@3o
m^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0e3dI0080e3dI2P3om^h00`3D?AT0ooK^0?of
kP0<0?ofkP030=@m6@3om^h0ooK^00D0ooK^0P3D?AT30?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0
e3dI0?ofkP3D?AT0D`3om^h00`000000ooK^0?ofkP0B0?ofkP030000003om^h0ooK^03d0ooK^0@3o
ool003l0ooK^00<000000?ofkP3om^h04P3om^h00`000000ooK^0?ofkP1@0?ofkP050=@m6@3om^h0
ooK^0?ofkP3D?AT02@3om^h0103D?AT0ooK^0?ofkP3D?AT90?ofkP030=@m6@3om^h0ooK^00`0ooK^
00<0e3dI0?ofkP3om^h01@3om^h30=@m6@@0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^
0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h00P3om^h30=@m6@L0ooK^
00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP070?ofkP040=@m6@3om^h0ooK^0=@m6@T0
ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@1B0?ofkP030000003om^h0ooK^0180ooK^00<000000?of
kP3om^h0?@3om^h10?ooo`00?`3om^h00`000000ooK^0?ofkP0C0?ofkP030000003om^h0ooK^04h0
ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP070?ofkP<0e3dI2P3om^h00`3D?AT0
ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^0080ooK^0`3D?AT70?ofkP030=@m6@3om^h0ooK^00h0
ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00D0
ooK^0`3D?AT40?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h0203om^h30=@m6@T0
ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@1A0?ofkP030000003om^h0ooK^01<0ooK^00<000000?of
kP3om^h0?@3om^h10?ooo`00?`3om^h00`000000ooK^0?ofkP0C0?ofkP030000003om^h0ooK^04h0
ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00/0
ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0=@m6@020=@m6@X0ooK^00<0e3dI0?ofkP3o
m^h03P3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3o
m^h0203om^h30=@m6@030?ofkP3D?AT0ooK^00`0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0
ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h0CP3om^h00`000000
ooK^0?ofkP0C0?ofkP030000003om^h0ooK^03d0ooK^0@3oool003l0ooK^00<000000?ofkP3om^h0
4`3om^h00`000000ooK^0?ofkP1=0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h0
1P3om^h20=@m6@d0ooK^00<0e3dI0?ofkP3om^h02`3om^h20=@m6@d0ooK^00<0e3dI0?ofkP3om^h0
3P3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h0
2`3om^h20=@m6@d0ooK^00<0e3dI0?ofkP3om^h02`3om^h20=@m6@P0ooK^00<0e3dI0?ofkP3om^h0
0`3om^h00`3D?AT0ooK^0?ofkP1=0?ofkP030000003om^h0ooK^01<0ooK^00<000000?ofkP3om^h0
?@3om^h10?ooo`00?P3om^h00`000000ooK^0?ofkP0D0?ofkP030000003om^h0ooK^04d0ooK^00<0
e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0e3dI00d0ooK^00<0
e3dI0?ofkP3om^h02@3om^h30=@m6@h0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?of
kP0=0?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h0303om^h30=@m6@/0ooK^00<0
e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0=@m6@070?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0
e3dI0?ofkP3om^h0C@3om^h00`000000ooK^0?ofkP0D0?ofkP030000003om^h0ooK^03`0ooK^0@3o
ool003h0ooK^00<000000?ofkP3om^h05@3om^h00`000000ooK^0?ofkP1;0?ofkP030=@m6@3om^h0
ooK^00@0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0=@m6@0=0?ofkP030=@m6@3om^h0
ooK^00L0ooK^0P3D?AT20?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h03P3om^h0
0`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h0303om^h0
0`3D?AT0ooK^0?ofkP020=@m6@T0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0=@m6@07
0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h0B`3om^h00`000000ooK^0?ofkP0E
0?ofkP030000003om^h0ooK^03`0ooK^0@3oool003h0ooK^00<000000?ofkP3om^h05@3om^h00`00
0000ooK^0?ofkP1;0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h0103om^h0103D
?AT0ooK^0?ofkP3D?AT=0?ofkP030=@m6@3om^h0ooK^00D0ooK^0P3D?AT40?ofkP030=@m6@3om^h0
ooK^00`0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0
ooK^00d0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP020?ofkP80e3dI1`3om^h0
0`3D?AT0ooK^0?ofkP0;0?ofkP040=@m6@3om^h0ooK^0=@m6@H0ooK^00<0e3dI0?ofkP3om^h0103o
m^h00`3D?AT0ooK^0?ofkP1;0?ofkP030000003om^h0ooK^01D0ooK^00<000000?ofkP3om^h0?03o
m^h10?ooo`00?P3om^h00`000000ooK^0?ofkP0E0?ofkP030000003om^h0ooK^04X0ooK^00<0e3dI
0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI
0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP030?ofkP80e3dI1P3om^h00`3D?AT0ooK^0?ofkP0=
0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0=
0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h0103om^h20=@m6@D0ooK^00<0e3dI
0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI
0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP1:0?ofkP030000003om^h0ooK^01D0ooK^00<00000
0?ofkP3om^h0?03om^h10?ooo`00?P3om^h00`000000ooK^0?ofkP0E0?ofkP030000003om^h0ooK^
04X0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^
00<0ooK^00<0e3dI0?ofkP3om^h02P3om^h0103D?AT0ooK^0?ofkP3om^h20=@m6@P0ooK^00<0e3dI
0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI
0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00H0ooK^0P3D?AT3
0?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP02
0?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h0BP3om^h00`000000ooK^0?ofkP0E
0?ofkP030000003om^h0ooK^03`0ooK^0@3oool003d0ooK^00<000000?ofkP3om^h05P3om^h00`00
0000ooK^0?ofkP1:0?ofkP030=@m6@3om^h0ooK^00H0ooK^00@0e3dI0?ofkP3om^h0e3dI1P3om^h0
0`3D?AT0ooK^0?ofkP0:0?ofkP040=@m6@3om^h0e3dI0=@m6@X0ooK^00<0e3dI0?ofkP3om^h03@3o
m^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h03@3o
m^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00P0ooK^0P3D?AT00`3om^h0e3dI0?of
kP0;0?ofkP030=@m6@3om^h0ooK^00@0ooK^00@0e3dI0?ofkP3om^h0e3dI203om^h00`3D?AT0ooK^
0?ofkP1:0?ofkP030000003om^h0ooK^01H0ooK^00<000000?ofkP3om^h0>`3om^h10?ooo`00?@3o
m^h00`000000ooK^0?ofkP0G0?ofkP030000003om^h0ooK^04P0ooK^0P3D?AT80?ofkP030=@m6@3o
m^h0e3dI00L0ooK^00<0e3dI0?ofkP3om^h02P3om^h20=@m6@`0ooK^00<0e3dI0?ofkP3om^h03@3o
m^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h03@3o
m^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00X0ooK^0P3D?AT<0?ofkP030=@m6@3o
m^h0ooK^00D0ooK^00<0e3dI0?ofkP3D?AT0203om^h20=@m6DX0ooK^00<000000?ofkP3om^h05`3o
m^h00`000000ooK^0?ofkP0k0?ofkP40oooo000m0?ofkP030000003om^h0ooK^01L0ooK^00<00000
0?ofkP3om^h0B03om^h20=@m6@P0ooK^00<0e3dI0?ofkP3D?AT01`3om^h00`3D?AT0ooK^0?ofkP09
0?ofkP80e3dI3@3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI
0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI
0?ofkP3om^h0303om^h20=@m6@/0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0=@m6@08
0?ofkP80e3dIBP3om^h00`000000ooK^0?ofkP0G0?ofkP030000003om^h0ooK^03/0ooK^0@3oool0
03d0ooK^00<000000?ofkP3om^h05`3om^h00`000000ooK^0?ofkP180?ofkP030=@m6@3om^h0e3dI
00L0ooK^0P3D?AT80?ofkP030=@m6@3om^h0ooK^00L0ooK^0P3D?AT00`3om^h0e3dI0?ofkP0=0?of
kP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h02P3om^hG0=@m6@`0ooK^00<0e3dI0?of
kP3om^h0303om^h00`3D?AT0ooK^0?ofkP0<0?ofkP040=@m6@3om^h0e3dI0=@m6@T0ooK^00<0e3dI
0?ofkP3om^h01P3om^h20=@m6@L0ooK^00<0e3dI0?ofkP3D?AT0BP3om^h00`000000ooK^0?ofkP0G
0?ofkP030000003om^h0ooK^03/0ooK^0@3oool003d0ooK^00<000000?ofkP3om^h05`3om^h00`00
0000ooK^0?ofkP180?ofkP030=@m6@3om^h0e3dI00L0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D
?AT0ooK^0?ofkP060?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT03P3om^h00`3D?AT0ooK^0?ofkP0<
0?ofkP030=@m6@3om^h0ooK^0080ooK^203D?AT30?ofkP030=@m6@3om^h0ooK^00d0ooK^00@0e3dI
0?ofkP3om^h0ooK^203D?AT40?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h0303o
m^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00P0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^
0?ofkP050?ofkP030=@m6@3om^h0e3dI04X0ooK^00<000000?ofkP3om^h05`3om^h00`000000ooK^
0?ofkP0k0?ofkP40oooo000l0?ofkP030000003om^h0ooK^01T0ooK^00<000000?ofkP3om^h0AP3o
m^h0103D?AT0ooK^0?ofkP3D?AT60?ofkP80e3dI2@3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m
6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP0;0?ofkPH0e3dI
2`3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00T0ooK^1P3D?AT=0?ofkP030=@m
6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m
6@3om^h0ooK^00L0ooK^0P3D?AT60?ofkP040=@m6@3om^h0ooK^0=@m6DP0ooK^00<000000?ofkP3o
m^h06@3om^h00`000000ooK^0?ofkP0j0?ofkP40oooo000l0?ofkP030000003om^h0ooK^01T0ooK^
00<000000?ofkP3om^h0AP3om^h0103D?AT0ooK^0?ofkP3D?AT60?ofkP80e3dI2P3om^h00`3D?AT0
ooK^0?ofkP020?ofkP80e3dI1@3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00P0
ooK^0`3D?AT00`3om^h0e3dI0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3o
m^h03@3om^h00`3D?AT0ooK^0=@m6@020=@m6@X0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0
ooK^0?ofkP030?ofkP80e3dI103om^h00`3D?AT0ooK^0?ofkP080?ofkP80e3dI1P3om^h0103D?AT0
ooK^0?ofkP3D?AU80?ofkP030000003om^h0ooK^01T0ooK^00<000000?ofkP3om^h0>P3om^h10?oo
o`00?03om^h00`000000ooK^0?ofkP0I0?ofkP030000003om^h0ooK^04H0ooK^00@0e3dI0?ofkP3o
m^h0e3dI1@3om^h00`3D?AT0ooK^0=@m6@0:0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT01`3om^h0
0`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00D0ooK^0`3D?AT40?ofkP030=@m6@3om^h0
ooK^00d0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0
ooK^0080ooK^0`3D?AT70?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h01@3om^h0
1@3D?AT0ooK^0?ofkP3om^h0e3dI00X0ooK^00<0e3dI0?ofkP3D?AT01@3om^h0103D?AT0ooK^0?of
kP3D?AU80?ofkP030000003om^h0ooK^01T0ooK^00<000000?ofkP3om^h0>P3om^h10?ooo`00?03o
m^h00`000000ooK^0?ofkP0I0?ofkP030000003om^h0ooK^04H0ooK^00@0e3dI0?ofkP3om^h0e3dI
1@3om^h00`3D?AT0ooK^0=@m6@0:0?ofkP040=@m6@3om^h0ooK^0=@m6@P0ooK^00<0e3dI0?ofkP3o
m^h0303om^h00`3D?AT0ooK^0?ofkP020?ofkP<0e3dI1`3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP03
0=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP050?ofkP<0
e3dI103om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00H0ooK^00@0e3dI0?ofkP3o
m^h0e3dI2@3om^h0103D?AT0ooK^0?ofkP3D?AT50?ofkP040=@m6@3om^h0ooK^0=@m6DP0ooK^00<0
00000?ofkP3om^h06@3om^h00`000000ooK^0?ofkP0j0?ofkP40oooo000l0?ofkP030000003om^h0
ooK^01T0ooK^00<000000?ofkP3om^h0A@3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00@0ooK^00D0
e3dI0?ofkP3om^h0ooK^0=@m6@090?ofkP<0e3dI2@3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m
6@3om^h0e3dI0080e3dI2P3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00d0ooK^
00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP080?ofkP<0e3dI00<0ooK^0=@m6@3om^h0
303om^h00`3D?AT0ooK^0?ofkP080?ofkP<0e3dI2@3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00@0
ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@170?ofkP030000003om^h0ooK^01T0ooK^00<000000?of
kP3om^h0>P3om^h10?ooo`00>`3om^h00`000000ooK^0?ofkP0K0?ofkP030000003om^h0ooK^04@0
ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@030?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?of
kP3om^h01`3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00/0ooK^0P3D?AT=0?of
kP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0=0?of
kP030=@m6@3om^h0ooK^00/0ooK^0P3D?AT=0?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?of
kP3om^h01`3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00@0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m
6@160?ofkP030000003om^h0ooK^01/0ooK^00<000000?ofkP3om^h0>@3om^h10?ooo`00>`3om^h0
0`000000ooK^0?ofkP0K0?ofkP030000003om^h0ooK^04@0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m
6@030?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h01P3om^h20=@m6@`0ooK^00<0
e3dI0?ofkP3om^h02@3om^h30=@m6@h0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?of
kP0=0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h0303om^h30=@m6@/0ooK^00<0
e3dI0?ofkP3om^h02P3om^h20=@m6@P0ooK^00<0e3dI0?ofkP3om^h00P3om^h01@3D?AT0ooK^0?of
kP3om^h0e3dI00<0ooK^00<0e3dI0?ofkP3om^h0A03om^h00`000000ooK^0?ofkP0K0?ofkP030000
003om^h0ooK^03T0ooK^0@3oool003/0ooK^00<000000?ofkP3om^h06`3om^h00`000000ooK^0?of
kP140?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3D?AT01@3om^h00`3D?AT0ooK^0?of
kP050?ofkP030=@m6@3om^h0e3dI00`0ooK^00<0e3dI0?ofkP3om^h01`3om^h20=@m6@80ooK^00<0
e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0
e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^0080e3dI2@3o
m^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0e3dI00L0ooK^00<0e3dI0?ofkP3om^h00`3o
m^h00`3D?AT0ooK^0=@m6@040?ofkP030=@m6@3om^h0ooK^04@0ooK^00<000000?ofkP3om^h06`3o
m^h00`000000ooK^0?ofkP0i0?ofkP40oooo000k0?ofkP030000003om^h0ooK^01/0ooK^00<00000
0?ofkP3om^h0A03om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0e3dI00D0ooK^00<0e3dI
0?ofkP3om^h0103om^h0103D?AT0ooK^0?ofkP3D?AT<0?ofkP030=@m6@3om^h0ooK^00D0ooK^0P3D
?AT40?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?of
kP0=0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?of
kP020?ofkP80e3dI1`3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP040=@m6@3om^h0ooK^0=@m6@H0ooK^
00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0=@m6@040?ofkP030=@m6@3om^h0ooK^04@0ooK^
00<000000?ofkP3om^h06`3om^h00`000000ooK^0?ofkP0i0?ofkP40oooo000k0?ofkP030000003o
m^h0ooK^01`0ooK^00<000000?ofkP3om^h0@`3om^h00`3D?AT0ooK^0?ofkP020?ofkP80e3dI1P3o
m^h00`3D?AT0ooK^0?ofkP030?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT0303om^h00`3D?AT0ooK^
0?ofkP030?ofkP80e3dI1P3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00d0ooK^
00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00`0ooK^
00<0e3dI0?ofkP3om^h0103om^h20=@m6@D0ooK^00<0e3dI0?ofkP3om^h02P3om^h01@3D?AT0ooK^
0?ofkP3om^h0e3dI00D0ooK^00<0e3dI0?ofkP3om^h0103om^h20=@m6@@0ooK^00<0e3dI0?ofkP3o
m^h0@`3om^h00`000000ooK^0?ofkP0L0?ofkP030000003om^h0ooK^03T0ooK^0@3oool003X0ooK^
00<000000?ofkP3om^h07@3om^h00`000000ooK^0?ofkP130?ofkP030=@m6@3om^h0ooK^0080ooK^
0P3D?AT60?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^
0?ofkP090?ofkP040=@m6@3om^h0ooK^0?ofkP80e3dI203om^h00`3D?AT0ooK^0?ofkP0<0?ofkP03
0=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP03
0=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h01P3om^h20=@m6@<0ooK^00<0e3dI0?ofkP3o
m^h02P3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00D0ooK^00<0e3dI0?ofkP3om^h0103om^h20=@m
6@@0ooK^00<0e3dI0?ofkP3om^h0@`3om^h00`000000ooK^0?ofkP0M0?ofkP030000003om^h0ooK^
03P0ooK^0@3oool003X0ooK^00<000000?ofkP3om^h07@3om^h00`000000ooK^0?ofkP130?ofkP80
e3dI0`3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3o
m^h00`3om^h00`3D?AT0ooK^0?ofkP090?ofkP040=@m6@3om^h0e3dI0=@m6@X0ooK^00<0e3dI0?of
kP3om^h0303om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?of
kP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00P0ooK^0P3D?AT00`3o
m^h0e3dI0?ofkP0;0?ofkP030=@m6@3om^h0ooK^0080ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@08
0?ofkP040=@m6@3om^h0ooK^0?ofkP80e3dIA@3om^h00`000000ooK^0?ofkP0M0?ofkP030000003o
m^h0ooK^03P0ooK^0@3oool003X0ooK^00<000000?ofkP3om^h07@3om^h00`000000ooK^0?ofkP13
0?ofkP80e3dI0`3om^h00`3D?AT0ooK^0?ofkP060?ofkP040=@m6@3om^h0ooK^0=@m6@H0ooK^00<0
e3dI0?ofkP3om^h02@3om^h20=@m6@`0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?of
kP0=0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?of
kP0<0?ofkP030=@m6@3om^h0ooK^00X0ooK^0P3D?AT<0?ofkP030=@m6@3om^h0ooK^00<0ooK^00@0
e3dI0?ofkP3om^h0e3dI203om^h0103D?AT0ooK^0?ofkP3om^h20=@m6DD0ooK^00<000000?ofkP3o
m^h07@3om^h00`000000ooK^0?ofkP0h0?ofkP40oooo000j0?ofkP030000003om^h0ooK^01h0ooK^
00<000000?ofkP3om^h0@P3om^h20=@m6@<0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^
0=@m6@070?ofkP030=@m6@3om^h0ooK^00P0ooK^0P3D?AT>0?ofkP030=@m6@3om^h0ooK^00/0ooK^
00<0e3dI0?ofkP3om^h02`3om^hE0=@m6@d0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^
0?ofkP0<0?ofkP80e3dI2P3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0e3dI00P0ooK^
00D0e3dI0?ofkP3om^h0ooK^0=@m6@150?ofkP030000003om^h0ooK^01h0ooK^00<000000?ofkP3o
m^h0>03om^h10?ooo`00>P3om^h00`000000ooK^0?ofkP0N0?ofkP030000003om^h0ooK^04<0ooK^
00<0e3dI0?ofkP3om^h00P3D?AT80?ofkP80e3dI203om^h00`3D?AT0ooK^0?ofkP060?ofkP80e3dI
00<0ooK^0=@m6@3om^h03@3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00H0ooK^
1@3D?AT20?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h01@3D?AT80?ofkP030=@m
6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h0303om^h0103D?AT0ooK^0=@m6@3D?AT80?ofkP03
0=@m6@3om^h0ooK^00H0ooK^0P3D?AT80?ofkP80e3dI0P3om^h00`3D?AT0ooK^0?ofkP130?ofkP03
0000003om^h0ooK^01h0ooK^00<000000?ofkP3om^h0>03om^h10?ooo`00>@3om^h00`000000ooK^
0?ofkP0O0?ofkP030000003om^h0ooK^04<0ooK^00<0e3dI0?ofkP3om^h00P3D?AT80?ofkP030=@m
6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h01@3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00h0
ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP060=@m6@L0ooK^00<0e3dI0?ofkP3o
m^h03@3om^h00`3D?AT0ooK^0?ofkP050?ofkPH0e3dI0P3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP03
0=@m6@3om^h0ooK^00`0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@070?ofkP030=@m6@3om^h0ooK^
00L0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0=@m6@020?ofkP030=@m6@3om^h0ooK^
04<0ooK^00<000000?ofkP3om^h07`3om^h00`000000ooK^0?ofkP0g0?ofkP40oooo000i0?ofkP03
0000003om^h0ooK^01l0ooK^00<000000?ofkP3om^h0@`3om^h01P3D?AT0ooK^0?ofkP3D?AT0ooK^
0=@m6@H0ooK^0P3D?AT90?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h00P3om^h0
0`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00X0ooK^103D?AT=0?ofkP030=@m6@3om^h0
ooK^00d0ooK^00<0e3dI0?ofkP3om^h02`3om^h40=@m6@`0ooK^00<0e3dI0?ofkP3om^h0303om^h0
0`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h01`3om^h2
0=@m6@H0ooK^00<0e3dI0?ofkP3D?AT00P3om^h00`3D?AT0ooK^0?ofkP130?ofkP030000003om^h0
ooK^01l0ooK^00<000000?ofkP3om^h0=`3om^h10?ooo`00>@3om^h00`000000ooK^0?ofkP0O0?of
kP030000003om^h0ooK^04<0ooK^00H0e3dI0?ofkP3om^h0e3dI0?ofkP3D?AT60?ofkP80e3dI2@3o
m^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h0303o
m^h00`3D?AT0ooK^0?ofkP060?ofkP@0e3dI00<0ooK^0=@m6@3om^h03P3om^h00`3D?AT0ooK^0?of
kP0=0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3D?AT00`3D?AT80?ofkP030=@m6@3o
m^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h00`3om^h20=@m6@@0ooK^00<0e3dI0?ofkP3om^h01`3o
m^h20=@m6@H0ooK^00<0e3dI0?ofkP3D?AT00P3om^h00`3D?AT0ooK^0?ofkP130?ofkP030000003o
m^h0ooK^01l0ooK^00<000000?ofkP3om^h0=`3om^h10?ooo`00>@3om^h00`000000ooK^0?ofkP0P
0?ofkP030000003om^h0ooK^0480ooK^00<0e3dI0?ofkP3D?AT00P3om^h00`3D?AT0ooK^0?ofkP03
0?ofkP030=@m6@3om^h0e3dI00X0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@060?ofkP030=@m6@3o
m^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h00`3om^h30=@m6@D0ooK^00<0e3dI0?ofkP3om^h03@3o
m^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h00`3o
m^h30=@m6@D0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP050?ofkP050=@m6@3o
m^h0ooK^0?ofkP3D?AT02@3om^h00`3D?AT0ooK^0=@m6@050?ofkP060=@m6@3om^h0ooK^0=@m6@3o
m^h0e3dIA03om^h00`000000ooK^0?ofkP0P0?ofkP030000003om^h0ooK^03L0ooK^0@3oool003T0
ooK^00<000000?ofkP3om^h0803om^h00`000000ooK^0?ofkP120?ofkP030=@m6@3om^h0e3dI0080
ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0=@m6@0:0?ofkP040=@m6@3om^h0e3dI0=@m
6@L0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0=@m6@030=@m6@P0ooK^00<0e3dI0?of
kP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?of
kP3om^h01P3om^h40=@m6@030?ofkP3D?AT0ooK^00d0ooK^00<0e3dI0?ofkP3om^h01P3om^h0103D
?AT0ooK^0?ofkP3D?AT90?ofkP030=@m6@3om^h0e3dI00D0ooK^00H0e3dI0?ofkP3om^h0e3dI0?of
kP3D?AU40?ofkP030000003om^h0ooK^0200ooK^00<000000?ofkP3om^h0=`3om^h10?ooo`00>03o
m^h00`000000ooK^0?ofkP0Q0?ofkP030000003om^h0ooK^0480ooK^0`3D?AT20?ofkP030=@m6@3o
m^h0ooK^0080ooK^00@0e3dI0?ofkP3om^h0e3dI2P3om^h20=@m6@X0ooK^00<0e3dI0?ofkP3om^h0
2`3om^h20=@m6@`0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m
6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h02P3om^h20=@m6@d0ooK^00<0e3dI0?ofkP3om^h0
203om^h30=@m6@T0ooK^00@0e3dI0?ofkP3om^h0e3dI103om^h00`3D?AT0ooK^0?ofkP030=@m6D@0
ooK^00<000000?ofkP3om^h08@3om^h00`000000ooK^0?ofkP0f0?ofkP40oooo000h0?ofkP030000
003om^h0ooK^0240ooK^00<000000?ofkP3om^h0@P3om^h30=@m6@80ooK^00D0e3dI0?ofkP3om^h0
ooK^0=@m6@030?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0
ooK^0?ofkP090?ofkP<0e3dI3@3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00d0
ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP<0e3dI2`3om^h00`3D?AT0
ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00L0ooK^00@0e3dI0?ofkP3om^h0e3dI103om^h00`3D
?AT0ooK^0?ofkP030=@m6D@0ooK^00<000000?ofkP3om^h08@3om^h00`000000ooK^0?ofkP0f0?of
kP40oooo000h0?ofkP030000003om^h0ooK^0280ooK^00<000000?ofkP3om^h0@@3om^h20=@m6@<0
ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@030?ofkP030=@m6@3om^h0ooK^00L0ooK^0P3D?AT;0?of
kP030=@m6@3om^h0ooK^00L0ooK^0P3D?AT20?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?of
kP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?of
kP3om^h02`3om^h00`3D?AT0ooK^0?ofkP020=@m6@T0ooK^00<0e3dI0?ofkP3om^h02P3om^h20=@m
6@P0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@030?ofkP040=@m6@3om^h0ooK^0?ofkP80e3dI@`3o
m^h00`000000ooK^0?ofkP0R0?ofkP030000003om^h0ooK^03H0ooK^0@3oool003P0ooK^00<00000
0?ofkP3om^h08P3om^h00`000000ooK^0?ofkP110?ofkP80e3dI0`3om^h0103D?AT0ooK^0?ofkP3D
?AT40?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3D?AT02`3om^h00`3D?AT0ooK^0?of
kP050?ofkP80e3dI103om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0
e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0
e3dI0?ofkP3om^h00P3om^h20=@m6@L0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0=@m
6@060?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3D?AT0103om^h20=@m6D<0ooK^00<0
00000?ofkP3om^h08P3om^h00`000000ooK^0?ofkP0f0?ofkP40oooo000h0?ofkP030000003om^h0
ooK^0280ooK^00<000000?ofkP3om^h0@@3om^h20=@m6@@0ooK^00<0e3dI0?ofkP3D?AT01@3om^h0
0`3D?AT0ooK^0?ofkP040?ofkP040=@m6@3om^h0ooK^0=@m6@/0ooK^00<0e3dI0?ofkP3om^h00`3o
m^h20=@m6@H0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3o
m^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3o
m^h0ooK^00@0ooK^0P3D?AT50?ofkP030=@m6@3om^h0ooK^00X0ooK^00@0e3dI0?ofkP3om^h0e3dI
1@3om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0e3dI00@0ooK^0P3D?AU30?ofkP030000
003om^h0ooK^0280ooK^00<000000?ofkP3om^h0=P3om^h10?ooo`00=`3om^h00`000000ooK^0?of
kP0S0?ofkP030000003om^h0ooK^0480ooK^0P3D?AT30?ofkP80e3dI1P3om^h00`3D?AT0ooK^0?of
kP030?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT02`3om^h0103D?AT0ooK^0?ofkP3om^h20=@m6@P0
ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00d0
ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00H0
ooK^0P3D?AT30?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0
ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00@0ooK^0P3D?AT30?ofkP80e3dIA03om^h00`000000
ooK^0?ofkP0S0?ofkP030000003om^h0ooK^03D0ooK^0@3oool003L0ooK^00<000000?ofkP3om^h0
8`3om^h00`000000ooK^0?ofkP120?ofkP80e3dI0`3om^h20=@m6@H0ooK^00<0e3dI0?ofkP3om^h0
0P3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00T0ooK^00@0e3dI0?ofkP3D?AT0
e3dI2P3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3o
m^h03@3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3o
m^h0203om^h20=@m6@030?ofkP3D?AT0ooK^00X0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0
ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00@0ooK^0P3D?AT30?ofkP80e3dIA03om^h00`000000
ooK^0?ofkP0S0?ofkP030000003om^h0ooK^03D0ooK^0@3oool003L0ooK^00<000000?ofkP3om^h0
903om^h00`000000ooK^0?ofkP110?ofkP80e3dI0`3om^h00`3D?AT0ooK^0?ofkP050?ofkP050=@m
6@3om^h0ooK^0?ofkP3D?AT01@3om^h00`3D?AT0ooK^0?ofkP090?ofkP80e3dI303om^h00`3D?AT0
ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0
ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h02P3om^h20=@m6@/0
ooK^00<0e3dI0?ofkP3om^h00`3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00L0ooK^00@0e3dI0?of
kP3om^h0ooK^0P3D?AU30?ofkP030000003om^h0ooK^02@0ooK^00<000000?ofkP3om^h0=@3om^h1
0?ooo`00=`3om^h00`000000ooK^0?ofkP0T0?ofkP030000003om^h0ooK^0440ooK^0P3D?AT30?of
kP030=@m6@3om^h0ooK^00D0ooK^00@0e3dI0?ofkP3om^h0e3dI1P3om^h00`3D?AT0ooK^0?ofkP08
0?ofkP80e3dI3@3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00X0ooK^5@3D?AT<
0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h02`3om^h20=@m6@X0ooK^00<0e3dI
0?ofkP3om^h0103om^h0103D?AT0ooK^0?ofkP3D?AT70?ofkP040=@m6@3om^h0ooK^0?ofkP80e3dI
@`3om^h00`000000ooK^0?ofkP0T0?ofkP030000003om^h0ooK^03D0ooK^0@3oool003L0ooK^00<0
00000?ofkP3om^h0903om^h00`000000ooK^0?ofkP110?ofkP<0e3dI0P3om^h00`3D?AT0ooK^0?of
kP050?ofkP030=@m6@3om^h0e3dI00P0ooK^00<0e3dI0?ofkP3om^h01@3om^h20=@m6@030?ofkP3D
?AT0ooK^00`0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP050?ofkPD0e3dI0P3o
m^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00D0e3dI1`3om^h00`3D?AT0ooK^0?of
kP0<0?ofkP030=@m6@3om^h0ooK^00/0ooK^00@0e3dI0?ofkP3D?AT0e3dI203om^h00`3D?AT0ooK^
0?ofkP050?ofkP030=@m6@3om^h0e3dI00L0ooK^00<0e3dI0?ofkP3om^h00`3D?AU30?ofkP030000
003om^h0ooK^02@0ooK^00<000000?ofkP3om^h0=@3om^h10?ooo`00=P3om^h00`000000ooK^0?of
kP0U0?ofkP030000003om^h0ooK^0440ooK^0`3D?AT00`3om^h0e3dI0=@m6@070?ofkP80e3dI2@3o
m^h00`3D?AT0ooK^0?ofkP040?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT03@3om^h00`3D?AT0ooK^
0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00D0e3dI1`3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m
6@3om^h0ooK^00D0ooK^1@3D?AT20?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h0
2`3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00L0ooK^00<0e3dI0?ofkP3om^h01P3om^h20=@m6@L0
ooK^0P3D?AT0103om^h0e3dI0=@m6@3D?AU30?ofkP030000003om^h0ooK^02D0ooK^00<000000?of
kP3om^h0=03om^h10?ooo`00=P3om^h00`000000ooK^0?ofkP0V0?ofkP030000003om^h0ooK^0400
ooK^0`3D?AT00`3om^h0e3dI0=@m6@070?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3o
m^h00`3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3o
m^h02`3om^h40=@m6@`0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP@0
e3dI3@3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3o
m^h0103om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00@0ooK^00@0e3dI0?ofkP3D
?AT0ooK^0`3D?AU20?ofkP030000003om^h0ooK^02H0ooK^00<000000?ofkP3om^h0=03om^h10?oo
o`00=P3om^h00`000000ooK^0?ofkP0V0?ofkP030000003om^h0ooK^0400ooK^0P3D?AT01@3om^h0
e3dI0=@m6@3om^h0e3dI00D0ooK^0P3D?AT:0?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?of
kP3om^h0103om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00L0ooK^103D?AT00`3o
m^h0e3dI0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D
?AT0ooK^0=@m6@030=@m6@T0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP040?of
kP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP040?of
kP050=@m6@3om^h0e3dI0=@m6@3om^h00P3D?AU20?ofkP030000003om^h0ooK^02H0ooK^00<00000
0?ofkP3om^h0=03om^h10?ooo`00=P3om^h00`000000ooK^0?ofkP0V0?ofkP030000003om^h0ooK^
0440ooK^00H0e3dI0?ofkP3D?AT0e3dI0?ofkP3D?AT50?ofkP80e3dI2P3om^h01@3D?AT0ooK^0?of
kP3om^h0e3dI00L0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP030?ofkP@0e3dI
1@3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h0
303om^h00`3D?AT0ooK^0?ofkP030?ofkP@0e3dI1@3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m
6@3om^h0ooK^00D0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0:0?ofkP80e3dI1@3om^h01P3D?AT0
ooK^0=@m6@3D?AT0ooK^0=@m6D<0ooK^00<000000?ofkP3om^h09P3om^h00`000000ooK^0?ofkP0d
0?ofkP40oooo000f0?ofkP030000003om^h0ooK^02H0ooK^00<000000?ofkP3om^h0@@3om^h01P3D
?AT0ooK^0=@m6@3D?AT0ooK^0=@m6@@0ooK^00<0e3dI0?ofkP3D?AT02P3om^h0103D?AT0ooK^0=@m
6@3D?AT80?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3D?AT00`3D?AT90?ofkP030=@m
6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m
6@3om^h0ooK^00L0ooK^103D?AT00`3om^h0e3dI0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00H0ooK^
0P3D?AT00`3om^h0e3dI0?ofkP080?ofkP030=@m6@3om^h0e3dI00D0ooK^00H0e3dI0?ofkP3D?AT0
e3dI0?ofkP3D?AU30?ofkP030000003om^h0ooK^02H0ooK^00<000000?ofkP3om^h0=03om^h10?oo
o`00=@3om^h00`000000ooK^0?ofkP0X0?ofkP030000003om^h0ooK^0400ooK^00H0e3dI0?ofkP3D
?AT0e3dI0?ofkP3D?AT40?ofkP040=@m6@3om^h0ooK^0=@m6@T0ooK^0P3D?AT:0?ofkP030=@m6@3o
m^h0ooK^00X0ooK^0P3D?AT=0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h03@3o
m^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00/0ooK^0P3D?AT<0?ofkP030=@m6@3o
m^h0ooK^00P0ooK^0P3D?AT90?ofkP040=@m6@3om^h0ooK^0=@m6@@0ooK^0P3D?AT0103om^h0e3dI
0?ofkP3D?AU20?ofkP030000003om^h0ooK^02P0ooK^00<000000?ofkP3om^h0<`3om^h10?ooo`00
=@3om^h00`000000ooK^0?ofkP0X0?ofkP030000003om^h0ooK^0400ooK^00<0e3dI0?ofkP3D?AT0
0`3D?AT30?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT02@3om^h00`3D?AT0ooK^0?ofkP040?ofkPD0
000000<0e3dI000000000000J@0000060?ofkP030=@m6@3om^h0ooK^00L0ooK^00@0e3dI0?ofkP3o
m^h0e3dI103om^h60=@m6D80ooK^00<000000?ofkP3om^h0:03om^h00`000000ooK^0?ofkP0c0?of
kP40oooo000e0?ofkP030000003om^h0ooK^02P0ooK^00<0000003eIZ`0mFJ/0@00mFJ/40=@m6@03
03eIZ`3D?AT0?EV[0080?EV[00D0e3dI03eIZ`0mFJ/0?EV[0=@m6@0803eIZ`80e3dI0P0mFJ/40000
00@03Q0P1000000500h@80<000001P0>4202000000L03Q0P0P00000600h@80030000000>42003Q0P
00D03Q0P00<0000000h@800>42001P0>42000`0000003Q0P00h@800500h@80030000000>42003Q0P
00H03Q0P00<0000000h@800>4200100>4202000000L03Q0P0P00000600h@80<000001@0>42040000
00@03Q0P1000000203eIZ`80e3dI200mFJ/01@3D?AT0?EV[03eIZ`0mFJ/0e3dI00<0?EV[00<0e3dI
03eIZ`3D?AT00`3D?AU203eIZ`030000003om^h0ooK^02P0ooK^00<000000?ofkP3om^h0<`3om^h1
0?ooo`00=@3om^h00`000000ooK^0?ofkP0W0?ofkP80?EV[00<0ooK^03eIZ`0mFJ/04@3om^h203eI
Z`030?ofkP0mFJ/0ooK^0140ooK^00<0?EV[0?ofkP0mFJ/04`3om^h01`0mFJ/0ooK^0=@m6@3D?AT0
ooK^0=@m6@3om^h00P3D?AT00`3om^h0e3dI0?ofkP030?ofkP030=@m6@3om^h0ooK^00@0ooK^00@0
?EV[0=@m6@3om^h0e3dIO@0000020=@m6@030?ofkP0mFJ/0ooK^00D0ooK^00D0e3dI0?ofkP3om^h0
ooK^0=@m6@020?ofkP80e3dI00<0ooK^0=@m6@3om^h00P3D?AT00`3om^h0?EV[0?ofkP0B0?ofkP03
03eIZ`3om^h0?EV[0180ooK^00@0?EV[0?ofkP0mFJ/0?EV[4@3om^h203eIZ`030?ofkP0mFJ/0?EV[
02T0ooK^00<000000?ofkP3om^h0<`3om^h10?ooo`00=@3om^h00`000000ooK^0?ofkP0V0?ofkTD0
?EV[0P3D?AT00`0mFJ/0e3dI03eIZ`020=@m6@0303eIZ`3D?AT0?EV[00<0?EV[00<0e3dI03eIZ`0m
FJ/01@0mFJ/00`3D?AT0000001DH;`0601DH;`8000001`0E62l2000000P05AP_00<0000001DH;`0E
62l01P0E62l00`0000005AP_01DH;`0601DH;`030000000E62l05AP_00L05AP_00<0000001DH;`0E
62l01P0E62l00`0000005AP_01DH;`0601DH;`030000000E62l05AP_00H05AP_00<0000001DH;`0E
62l01`0E62l00`0000005AP_01DH;`0601DH;`030000000E62l05AP_00H05AP_0P00000701DH;`80
00001`0E62l00`000000e3dI03eIZ`0603eIZ`030=@m6@0mFJ/0?EV[0080?EV[0`3D?AT203eIZ`04
0=@m6@0mFJ/0e3dI0=@m6DD0?EV[:03om^h00`000000ooK^0?ofkP0c0?ofkP40oooo000e0?ofkP03
0000003om^h0ooK^02D0ooK^00D0?EV[0?ofkP3om^h0ooK^000000030?ofkP0303eIZ`3om^h0ooK^
00/0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0503eIZ`3om^h0ooK^
0?ofkP0mFJ/04@3om^h00`0mFJ/0ooK^0?ofkP020=@m6@040?ofkP3D?AT0ooK^0?ofkP80e3dI1@3o
m^h00`3D?AT0ooK^0?ofkP030?ofkP0303eIZ`3D?AT05AP_00H05AP_0P00000801DH;`030000000E
62l05AP_00H05AP_0P00000801DH;`030000000E62l05AP_00L05AP_00<0000001DH;`0E62l01P0E
62l00`0000005AP_01DH;`0701DH;`030000000E62l05AP_00H05AP_00<0000001DH;`0E62l01`0E
62l00`0000005AP_01DH;`0601DH;`030000000E62l05AP_00L05AP_0P00000801DH;`030000000E
62l05AP_00H05AP_0P00000401DH;`050=@m6@0E62l05AP_0=@m6@0mFJ/0103om^h00`3D?AT0ooK^
0?ofkP030?ofkP<0e3dI0P3om^h0103D?AT0ooK^0=@m6@3D?AT20?ofkP0303eIZ`3om^h0ooK^00l0
ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0@0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?of
kP3om^h02`3om^h01@0mFJ/0ooK^0?ofkP3om^h0000000<0ooK^00<0?EV[0?ofkP3om^h09@3om^h0
0`000000ooK^0?ofkP0c0?ofkP40oooo000d0?ofkP030000003om^h0ooK^02H0ooK^00D0?EV[0?of
kP3om^h0ooK^000000030?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h0103om^h0
0`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h03P3om^h0
0`0mFJ/0ooK^0?ofkP040=@m6@80ooK^0`3D?AT50?ofkP030=@m6@3om^h0ooK^008000001`0E62l2
000000P05AP_0P00000801DH;`030000000E62l05AP_00P05AP_00<0000001DH;`0E62l01P0E62l0
0`0000005AP_01DH;`0701DH;`030000000E62l05AP_00L05AP_00<0000001DH;`0E62l01`0E62l0
0`0000005AP_01DH;`0601DH;`030000000E62l05AP_00L05AP_00<0000001DH;`0E62l0200E62l0
0`0000005AP_01DH;`0601DH;`800000200E62l2000000L05AP_0P0000020?ofkP030=@m6@3om^h0
ooK^00<0ooK^0`3D?AT20?ofkP@0e3dI0P3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0
ooK^00<0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0
ooK^00/0ooK^00D0?EV[0?ofkP3om^h0ooK^000000030?ofkP0303eIZ`3om^h0ooK^02H0ooK^00<0
00000?ofkP3om^h0<P3om^h10?ooo`00=03om^h00`000000ooK^0?ofkP0U0?ofkP0303eIZ`3om^h0
ooK^0080ooK^00<000000?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0
ooK^00D0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0
ooK^00d0ooK^00<0?EV[0?ofkP3om^h00P3om^h20=@m6@040?ofkP3D?AT0ooK^0=@m6@80ooK^00<0
e3dI0?ofkP3om^h00P3om^h00`3D?AT000000000002=000000030=@m6@3om^h0ooK^0080ooK^00L0
e3dI0?ofkP3D?AT0e3dI0?ofkP3D?AT0ooK^0080e3dI103om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP03
03eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP050?ofkP03
03eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`000000ooK^0?ofkP020?ofkP03
03eIZ`3om^h0ooK^02D0ooK^00<000000?ofkP3om^h0<P3om^h10?ooo`00=03om^h00`000000ooK^
0?ofkP0U0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<000000?ofkP3om^h00P3om^h00`0mFJ/0ooK^
0?ofkP090?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^
0?ofkP050?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h00P3om^h20=@m6@040?of
kP3D?AT0ooK^0=@m6@80ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT07RA701hTA`0701hTA`03
0000000N94L07RA700L07RA700<0000001hTA`0N94L01`0N94L00`0000007RA701hTA`0801hTA`03
0000000N94L07RA700P07RA700<0000001hTA`0N94L01`0N94L00`0000007RA701hTA`0701hTA`03
0000000N94L07RA700L07RA700<0000001hTA`0N94L01`0N94L00`0000007RA701hTA`0801hTA`03
0000000N94L07RA700P07RA700<0000001hTA`0N94L01`0N94L00`0000007RA701hTA`0701hTA`03
0000000N94L07RA700L07RA700D0e3dI0?ofkP3om^h0ooK^0=@m6@030?ofkP040=@m6@3om^h0e3dI
0?ofkP80e3dI103om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[
0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[
0?ofkP3om^h00P3om^h00`000000ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^02D0ooK^00<00000
0?ofkP3om^h0<P3om^h10?ooo`00=03om^h00`000000ooK^0?ofkP0T0?ofkTT0?EV[00H0e3dI03eI
Z`3D?AT0e3dI03eIZ`3D?AT303eIZ`040=@m6@0mFJ/0?EV[03eIZ`T07RA700<0000001hTA`0N94L0
1`0N94L00`0000007RA701hTA`0801hTA`030000000N94L07RA700P07RA700<0000001hTA`0N94L0
1`0N94L00`0000007RA701hTA`0801hTA`030000000N94L07RA700L07RA700<0000001hTA`0N94L0
1`0N94L00`0000007RA701hTA`0801hTA`030000000N94L07RA700L07RA700<0000001hTA`0N94L0
200N94L00`0000007RA701hTA`0801hTA`030000000N94L07RA700L07RA700<0000001hTA`0N94L0
1`0N94L303eIZ`060=@m6@0mFJ/0?EV[03eIZ`3D?AT0?EV[103D?AU903eIZbH0ooK^00<000000?of
kP3om^h0<P3om^h10?ooo`00=03om^h00`000000ooK^0?ofkP0T0?ofkP0303eIZ`3om^h0ooK^00@0
ooK^00<000000?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00L0
ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00`0
ooK^00<0?EV[0?ofkP3om^h00P3om^h40=@m6@030?ofkP3D?AT0ooK^00<0ooK^00<0e3dI0000000N
94L0200N94L00`0000007RA701hTA`0801hTA`030000000N94L07RA700L07RA700<0000001hTA`0N
94L0200N94L00`0000007RA701hTA`0801hTA`030000000N94L07RA700L07RA700<0000001hTA`0N
94L0200N94L00`0000007RA701hTA`0801hTA`030000000N94L07RA700L07RA700<0000001hTA`0N
94L0200N94L00`0000007RA701hTA`0801hTA`030000000N94L07RA700L07RA700<0000001hTA`0N
94L0200N94L00`0000007RA701hTA`0701hTA`030000003D?AT0ooK^00<0ooK^00<0e3dI0?ofkP3D
?AT00`3D?AT40?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0
ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0
ooK^0?ofkP020?ofkP030000003om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h0903om^h00`000000
ooK^0?ofkP0b0?ofkP40oooo000c0?ofkP030000003om^h0ooK^02@0ooK^00<0?EV[0?ofkP3om^h0
1@3om^h00`000000ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h0
2@3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h0
2P3om^h00`0mFJ/0ooK^0?ofkP030?ofkPH0e3dI0`3om^h00`000000e3dI0=@m6@0801hTA`030000
000N94L07RA700P07RA700<0000001hTA`0N94L0200N94L00`0000007RA701hTA`0801hTA`030000
000N94L07RA700L07RA700<0000001hTA`0N94L0200N94L00`0000007RA701hTA`0801hTA`030000
000N94L07RA700P07RA700<0000001hTA`0N94L0200N94L00`0000007RA701hTA`0701hTA`030000
000N94L07RA700P07RA700<0000001hTA`0N94L0200N94L00`0000007RA701hTA`0801hTA`030000
000N94L07RA700H07RA70P3D?AT010000000ooK^0?ofkP3om^h60=@m6@@0ooK^00<0?EV[0?ofkP3o
m^h02`3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3o
m^h0203om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<000000?ofkP3o
m^h01@3om^h00`0mFJ/0ooK^0?ofkP0T0?ofkP030000003om^h0ooK^0340ooK^0@3oool003<0ooK^
00<000000?ofkP3om^h0903om^h00`0mFJ/0ooK^0?ofkP050?ofkP030000003om^h0ooK^00<0ooK^
00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^00P0ooK^
00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00<0ooK^
0P3D?AT0100mFJ/0e3dI0=@m6@3D?AT20?ofkP80000000<0e3dI0000003D?AT0T@0000000`3D?AT0
00000=@m6@0200000080ooK^0`3D?AT00`0mFJ/0e3dI0=@m6@050?ofkP0303eIZ`3om^h0ooK^00X0
ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00T0
ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP030?ofkP030000003om^h0ooK^00D0
ooK^00<0?EV[0?ofkP3om^h0903om^h00`000000ooK^0?ofkP0a0?ofkP40oooo000c0?ofkP030000
003om^h0ooK^02<0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`000000ooK^0?ofkP020?ofkP0303eI
Z`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eI
Z`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP80e3dI
00H0?EV[0=@m6@3D?AT0ooK^0=@m6@00000202TeJ0040=@m6@0Y=FP0:CEX0=@m6@D0:CEX00<00000
02TeJ00Y=FP0200Y=FP00`000000:CEX02TeJ00802TeJ0030000000Y=FP0:CEX00P0:CEX00<00000
02TeJ00Y=FP0200Y=FP00`000000:CEX02TeJ00802TeJ0030000000Y=FP0:CEX00P0:CEX00<00000
02TeJ00Y=FP0200Y=FP00`000000:CEX02TeJ00802TeJ0030000000Y=FP0:CEX00P0:CEX00<00000
02TeJ00Y=FP0200Y=FP00`000000:CEX02TeJ00802TeJ0030000000Y=FP0:CEX00P0:CEX00<00000
02TeJ00Y=FP00`0Y=FP0103D?AT0:CEX02TeJ03D?AT202TeJ0030000003D?AT0ooK^0080e3dI00<0
?EV[0=@m6@3D?AT01@3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0
?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0
?EV[0?ofkP3om^h00P3om^h00`000000ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^02@0ooK^00<0
00000?ofkP3om^h0<@3om^h10?ooo`00<`3om^h00`000000ooK^0?ofkP0S0?ofkP0303eIZ`3om^h0
ooK^00L0ooK^00<000000?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0
ooK^00X0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0
ooK^00X0ooK^00<0?EV[0?ofkP3om^h00`3om^h20=@m6@0603eIZ`3om^h0e3dI0?ofkP3D?AT00000
0P0Y=FP01@3D?AT0:CEX02TeJ00Y=FP0e3dI00<0:CEX00<0000002TeJ00Y=FP0200Y=FP00`000000
:CEX02TeJ00802TeJ0030000000Y=FP0:CEX00P0:CEX00<0000002TeJ00Y=FP02@0Y=FP00`000000
:CEX02TeJ00802TeJ0030000000Y=FP0:CEX00P0:CEX00<0000002TeJ00Y=FP0200Y=FP00`000000
:CEX02TeJ00802TeJ0030000000Y=FP0:CEX00T0:CEX00<0000002TeJ00Y=FP0200Y=FP00`000000
:CEX02TeJ00802TeJ0030000000Y=FP0:CEX00P0:CEX00D0000002TeJ00Y=FP0:CEX0=@m6@0302Te
J0090=@m6@0Y=FP0:CEX0000003D?AT0ooK^0=@m6@3om^h0?EV[0080e3dI1@3om^h00`0mFJ/0ooK^
0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^
0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`000000ooK^
0?ofkP070?ofkP0303eIZ`3om^h0ooK^02<0ooK^00<000000?ofkP3om^h0<@3om^h10?ooo`00<`3o
m^h00`000000ooK^0?ofkP0S0?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<000000?ofkP3om^h00`3o
m^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h01@3o
m^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h01@3o
m^h01P3D?AT0ooK^0=@m6@3D?AT0ooK^0=@m6@@0:CEX00D0e3dI02TeJ00Y=FP0:CEX0=@m6@0202Te
J0030000000Y=FP0:CEX00P0:CEX00<0000002TeJ00Y=FP0200Y=FP00`000000:CEX02TeJ00802Te
J0030000000Y=FP0:CEX00T0:CEX00<0000002TeJ00Y=FP0200Y=FP00`000000:CEX02TeJ00802Te
J0030000000Y=FP0:CEX00P0:CEX00<0000002TeJ00Y=FP0200Y=FP00`000000:CEX02TeJ00902Te
J0030000000Y=FP0:CEX00P0:CEX00<0000002TeJ00Y=FP0200Y=FP00`000000:CEX02TeJ00802Te
J0040000000Y=FP0:CEX0=@m6@<0:CEX00<0e3dI02TeJ00Y=FP00P0Y=FP01P3D?AT0ooK^0=@m6@3D
?AT0ooK^0=@m6@H0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eI
Z`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eI
Z`3om^h0ooK^00<0ooK^00<000000?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP0S0?ofkP030000
003om^h0ooK^0340ooK^0@3oool00380ooK^00<000000?ofkP3om^h08`3om^h00`0mFJ/0ooK^0?of
kP080?ofkP030000003om^h0ooK^00<0ooK^?00mFJ/00`3D?AT0?EV[0=@m6@030=@m6@@0:CEX00<0
e3dI02TeJ00Y=FP00P0Y=FP20=@m6@X0:CEX00<0000002TeJ00Y=FP02@0Y=FP00`000000:CEX02Te
J00802TeJ0030000000Y=FP0:CEX00P0:CEX00<0000002TeJ00Y=FP0200Y=FP00`000000:CEX02Te
J00902TeJ0030000000Y=FP0:CEX00T0:CEX00<0000002TeJ00Y=FP0200Y=FP00`000000:CEX02Te
J00802TeJ0030000000Y=FP0:CEX00P0:CEX00<0000002TeJ00Y=FP02@0Y=FP00`000000:CEX02Te
J00802TeJ080e3dI100Y=FP00`3D?AT0:CEX02TeJ00202TeJ0@0e3dI00<0?EV[0=@m6@0mFJ/0>`0m
FJ/50?ofkP030000003om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h08`3om^h00`000000ooK^0?of
kP0`0?ofkP40oooo000b0?ofkP030000003om^h0ooK^02<0ooK^C@0mFJ/00`3D?AT0?EV[0=@m6@03
0=@m6@@0:CEX00<0e3dI02TeJ00Y=FP00`0Y=FP00`000000e3dI02TeJ00802TeJ0030000000Y=FP0
:CEX00T0:CEX00<0000002TeJ00Y=FP0200Y=FP00`000000:CEX02TeJ00802TeJ0030000000Y=FP0
:CEX00P0:CEX00<0000002TeJ00Y=FP02@0Y=FP00`000000:CEX02TeJ00902TeJ0030000000Y=FP0
:CEX00P0:CEX00<0000002TeJ00Y=FP0200Y=FP00`000000:CEX02TeJ00802TeJ0030000000Y=FP0
:CEX00T0:CEX00<0000002TeJ00Y=FP01`0Y=FP00`3D?AT0000002TeJ00402TeJ0030=@m6@0Y=FP0
:CEX0080:CEX1P3D?AU=03eIZbD0ooK^00<000000?ofkP3om^h0<03om^h10?ooo`00<P3om^h00`00
0000ooK^0?ofkP0S0?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<000000?ofkP3om^h00P3om^h00`0m
FJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0m
FJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h01@3om^h40=@m
6@030000003D?AT0:CEX00<0:CEX00<0e3dI02TeJ00Y=FP00P0Y=FP010000000:CEX02TeJ03D?AT7
02TeJ0030000000Y=FP0:CEX00T0:CEX00<0000002TeJ00Y=FP0200Y=FP00`000000:CEX02TeJ009
02TeJ0030000000Y=FP0:CEX00P0:CEX00<0000002TeJ00Y=FP02@0Y=FP00`000000:CEX02TeJ009
02TeJ0030000000Y=FP0:CEX00P0:CEX00<0000002TeJ00Y=FP02@0Y=FP00`000000:CEX02TeJ008
02TeJ0030000000Y=FP0:CEX00T0:CEX00<0000002TeJ00Y=FP01@0Y=FP0103D?AT0:CEX02TeJ000
000402TeJ0030=@m6@0Y=FP0:CEX0080:CEX00<0e3dI0000003D?AT00`3D?AT70?ofkP0303eIZ`3o
m^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3o
m^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP020?ofkP030000003o
m^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h08`3om^h00`000000ooK^0?ofkP0`0?ofkP40oooo000b
0?ofkP030000003om^h0ooK^02<0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`000000ooK^0?ofkP03
0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP04
0?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP05
0?ofkP80e3dI00@0?EV[0=@m6@000000e3dI100000000`3D?AT0000000000006000000030=@m6@00
0000000007l0000000<0e3dI0000000000001P0000000`3D?AT0000000000002000000040=@m6@00
0000e3dI03eIZ`80e3dI1`3om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00X0ooK^
00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^0080ooK^
00<0?EV[0?ofkP3om^h00`3om^h00`000000ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^02<0ooK^
00<000000?ofkP3om^h0<03om^h10?ooo`00<P3om^h00`000000ooK^0?ofkP0R0?ofkP0303eIZ`3o
m^h0ooK^00X0ooK^00<000000?ofkP3om^h00`3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[0100ooK^
00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00L0ooK^
00<0?EV[0?ofkP3om^h01@3om^h20=@m6@0503eIZ`000000e3dI0311O`3D?AT00`0`@Gl00`3D?AT0
<45o0311O`020311O`030000000`@Gl0<45o0080<45o00<0e3dI0311O`0`@Gl00`0`@Gl00`000000
<45o0311O`090311O`030000000`@Gl0<45o00P0<45o00<000000311O`0`@Gl02@0`@Gl00`000000
<45o0311O`080311O`030000000`@Gl0<45o00T0<45o00<000000311O`0`@Gl02@0`@Gl00`000000
<45o0311O`080311O`030000000`@Gl0<45o00T0<45o00<000000311O`0`@Gl0200`@Gl00`000000
<45o0311O`090311O`030000000`@Gl0<45o00<0<45o00<0e3dI0311O`0`@Gl00P0`@Gl00`000000
<45o0311O`020311O`090=@m6@0`@Gl0<45o0311O`3D?AT0<45o0=@m6@000000?EV[0080e3dI1`3o
m^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h0103o
m^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h00`3o
m^h00`000000ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^02<0ooK^00<000000?ofkP3om^h0<03o
m^h10?ooo`00<@3om^h00`000000ooK^0?ofkP0S0?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<00000
0?ofkP3om^h00`3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[0100ooK^00<0?EV[0?ofkP3om^h00`3o
m^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h01@3o
m^h20=@m6@0303eIZ`000000e3dI0080<45o00@0e3dI0311O`0`@Gl0e3dI100`@Gl00`000000<45o
0311O`030311O`030=@m6@0`@Gl0<45o0080<45o00<000000311O`0`@Gl02@0`@Gl00`000000<45o
0311O`080311O`030000000`@Gl0<45o00T0<45o00<000000311O`0`@Gl0200`@Gl00`000000<45o
0311O`090311O`030000000`@Gl0<45o00T0<45o00<000000311O`0`@Gl0200`@Gl00`000000<45o
0311O`090311O`030000000`@Gl0<45o00P0<45o00<000000311O`0`@Gl02@0`@Gl00`000000<45o
0311O`020311O`030=@m6@0`@Gl0<45o00<0<45o00<000000311O`0`@Gl00P0`@Gl0103D?AT0<45o
0311O`3D?AT20311O`030=@m6@000000ooK^0080e3dI1`3om^h00`0mFJ/0ooK^0?ofkP070?ofkP03
03eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP05
03eIZ`3om^h0ooK^0?ofkP0mFJ/01@3om^h00`000000ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^
02<0ooK^00<000000?ofkP3om^h0;`3om^h10?ooo`00<@3om^h00`000000ooK^0?ofkP0S0?ofkP03
03eIZ`3om^h0ooK^00/0ooK^00<000000?ofkP3om^h00P3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[
0100ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^
00L0ooK^00<0?EV[0?ofkP3om^h01@3om^h20=@m6@030000000`@Gl0e3dI0080<45o00@0e3dI0311
O`0`@Gl0e3dI0`0`@Gl00`000000<45o0311O`040311O`<0e3dI0P0`@Gl00`000000<45o0311O`09
0311O`030000000`@Gl0<45o00P0<45o00<000000311O`0`@Gl02@0`@Gl00`000000<45o0311O`08
0311O`030000000`@Gl0<45o00T0<45o00<000000311O`0`@Gl02@0`@Gl00`000000<45o0311O`08
0311O`030000000`@Gl0<45o00T0<45o00<000000311O`0`@Gl0200`@Gl00`000000<45o0311O`09
0311O`030000000`@Gl0<45o00<0e3dI1P0`@Gl01@000000<45o0311O`0`@Gl0e3dI0080<45o00H0
e3dI0311O`0`@Gl0e3dI0311O`0000020=@m6@L0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0
ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h03P3om^h01@0mFJ/0
ooK^0?ofkP3om^h0?EV[00@0ooK^00<000000?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP0S0?of
kP030000003om^h0ooK^02l0ooK^0@3oool00340ooK^00<000000?ofkP3om^h08`3om^h00`0mFJ/0
ooK^0?ofkP0;0?ofkP030000003om^h0ooK^0080ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0@0?of
kP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP060?of
kP0303eIZ`3om^h0ooK^00H0ooK^0`3D?AT00`0`@Gl0e3dI0311O`020311O`030=@m6@0`@Gl0e3dI
00<0<45o00<000000311O`0`@Gl0100`@Gl00`3D?AT0<45o0311O`020=@m6@030000000`@Gl0<45o
00T0<45o00<000000311O`0`@Gl0200`@Gl00`000000<45o0311O`090311O`030000000`@Gl0<45o
00P0<45o00<000000311O`0`@Gl02@0`@Gl00`000000<45o0311O`090311O`030000000`@Gl0<45o
00P0<45o00<000000311O`0`@Gl02@0`@Gl00`000000<45o0311O`080311O`030000000`@Gl0<45o
00T0<45o00<000000=@m6@3D?AT00P0`@Gl00`3D?AT0<45o0311O`040311O`070000000`@Gl0<45o
0311O`3D?AT0<45o0=@m6@030311O`040=@m6@0`@Gl0e3dI0=@m6@P0ooK^00<0?EV[0?ofkP3om^h0
1`3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h0
3P3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00@0ooK^00<000000?ofkP3om^h02`3om^h00`0mFJ/0
ooK^0?ofkP0S0?ofkP030000003om^h0ooK^02l0ooK^0@3oool00340ooK^00<000000?ofkP3om^h0
8`3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP030000003om^h0ooK^00<0ooK^00@0?EV[0?ofkP3om^h0
?EV[4@3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3o
m^h01@3om^h00`0mFJ/0ooK^0?ofkP070?ofkP80e3dI00<0<45o0=@m6@0`@Gl00`0`@Gl00`3D?AT0
<45o0=@m6@020311O`030000000`@Gl0<45o00@0<45o00D0e3dI0311O`0`@Gl0<45o000000020=@m
6@T0<45o00<000000311O`0`@Gl02@0`@Gl00`000000<45o0311O`080311O`030000000`@Gl0<45o
00T0<45o00<000000311O`0`@Gl02@0`@Gl00`000000<45o0311O`090311O`030000000`@Gl0<45o
00T0<45o00<000000311O`0`@Gl0200`@Gl00`000000<45o0311O`090311O`030000000`@Gl0<45o
00L0<45o0P3D?AT01@000000<45o0311O`0`@Gl0e3dI00H0<45o00H000000311O`0`@Gl0e3dI0311
O`3D?AT40311O`040=@m6@0`@Gl0e3dI0=@m6@T0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0
ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h03`3om^h0100mFJ/0
ooK^0?ofkP0mFJ/50?ofkP030000003om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h08`3om^h00`00
0000ooK^0?ofkP0_0?ofkP40oooo000a0?ofkP030000003om^h0ooK^02<0ooK^00<0?EV[0?ofkP3o
m^h02`3om^h00`000000ooK^0?ofkP030?ofkP0403eIZ`3om^h0ooK^03eIZa40ooK^00<0?EV[0?of
kP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?of
kP3om^h01`3om^h20=@m6@030311O`3D?AT0<45o00<0<45o00<0e3dI0311O`3D?AT00P0`@Gl00`00
0000<45o0311O`040311O`050=@m6@0`@Gl0<45o0311O`0000000P0`@Gl00`3D?AT0<45o0311O`06
0311O`030000000`@Gl0<45o00T0<45o00<000000311O`0`@Gl0200`@Gl00`000000<45o0311O`09
0311O`030000000`@Gl0<45o00T0<45o00<000000311O`0`@Gl02@0`@Gl00`000000<45o0311O`09
0311O`030000000`@Gl0<45o00P0<45o00<000000311O`0`@Gl02@0`@Gl00`000000<45o0311O`06
0311O`040=@m6@0`@Gl0<45o000000<0<45o00<0e3dI0311O`0`@Gl0100`@Gl01P000000<45o0311
O`3D?AT0<45o0=@m6@@0<45o00@0e3dI0311O`3D?AT0e3dI2@3om^h00`0mFJ/0ooK^0?ofkP050?of
kP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP0?0?of
kP0403eIZ`3om^h0ooK^03eIZ`D0ooK^00<000000?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP0S
0?ofkP030000003om^h0ooK^02l0ooK^0@3oool00300ooK^00<000000?ofkP3om^h08`3om^h00`0m
FJ/0ooK^0?ofkP0<0?ofkP030000003om^h0ooK^00<0ooK^>`0mFJ/40=@m6@D0<45o0P3D?AT00`0`
@Gl000000311O`070311O`040=@m6@0`@Gl0<45o000000<0<45o0P3D?AT60311O`030000000`@Gl0
<45o00T0<45o00<000000311O`0`@Gl0200`@Gl00`000000<45o0311O`090311O`030000000`@Gl0
<45o00T0<45o00<000000311O`0`@Gl02@0`@Gl00`000000<45o0311O`090311O`030000000`@Gl0
<45o00P0<45o00<000000311O`0`@Gl02@0`@Gl00`000000<45o0311O`040311O`80e3dI0`0`@Gl0
10000000<45o0311O`3D?AT80311O`040000000`@Gl0e3dI0=@m6@D0<45o103D?ATk03eIZ`D0ooK^
00<000000?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP0T0?ofkP030000003om^h0ooK^02h0ooK^
0@3oool00300ooK^00<000000?ofkP3om^h08`3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP030000003o
m^h0ooK^0080ooK^00<0?EV[0?ofkP0mFJ/04P3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00l0ooK^
00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP070?ofkP@0e3dI1@0`@Gl20=@m6@030311
O`000000<45o00L0<45o00@0e3dI0311O`0`@Gl000001@0`@Gl20=@m6@@0<45o00<000000311O`0`
@Gl02@0`@Gl00`000000<45o0311O`080311O`030000000`@Gl0<45o00T0<45o00<000000311O`0`
@Gl02@0`@Gl00`000000<45o0311O`090311O`030000000`@Gl0<45o00T0<45o00<000000311O`0`
@Gl0200`@Gl00`000000<45o0311O`090311O`030000000`@Gl0<45o0080<45o0P3D?AT50311O`04
0000000`@Gl0<45o0=@m6@P0<45o00@000000311O`3D?AT0e3dI1@0`@Gl40=@m6@T0ooK^00<0?EV[
0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/04P3o
m^h00`0mFJ/0ooK^03eIZ`040?ofkP030000003om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h08`3o
m^h00`000000ooK^0?ofkP0^0?ofkP40oooo000`0?ofkP030000003om^h0ooK^02<0ooK^00<0?EV[
0?ofkP3om^h03@3om^h00`000000ooK^0?ofkP020?ofkP0303eIZ`3om^h0?EV[0180ooK^00D0?EV[
0?ofkP3om^h0ooK^03eIZ`0?0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h01`3o
m^h30=@m6@030000003D?AT0000000@0000000<0e3dI000000000000200000000`3D?AT000000000
000800000080e3dIH`0000020=@m6@X0000000<0e3dI000000000000200000000`3D?AT000000000
0003000000030=@m6@000000e3dI0080e3dI2@3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3o
m^h0ooK^00d0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0B0?ofkP0303eIZ`3om^h0?EV[00@0ooK^
00<000000?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0S0?ofkP030000003om^h0ooK^02h0ooK^
0@3oool00300ooK^00<000000?ofkP3om^h08`3om^i@03eIZ`80e3dI00<0=TZ@0=@m6@3D?AT01@0f
BY020=@m6@030000000fBY00=TZ@00H0=TZ@00@0e3dI03I:T00fBY0000002@0fBY020=@m6@030000
000fBY00=TZ@00T0=TZ@00<0000003I:T00fBY00200fBY000`000000=TZ@03I:T00903I:T0030000
000fBY00=TZ@00T0=TZ@00<0000003I:T00fBY002@0fBY000`000000=TZ@03I:T00903I:T0030000
000fBY00=TZ@00P0=TZ@00<0000003I:T00fBY002@0fBY000`000000e3dI0=@m6@0903I:T0040000
000fBY00=TZ@0=@m6@P0=TZ@00<000000=@m6@3D?AT01@0fBY020=@m6@0303I:T03D?AT0e3dI0500
?EV[9@3om^h00`000000ooK^0?ofkP0^0?ofkP40oooo000`0?ofkP030000003om^h0ooK^02<0ooK^
00<0?EV[0?ofkP3om^h03@3om^h00`000000ooK^0?ofkP030?ofkP80?EV[4P3om^h01@0mFJ/0ooK^
0?ofkP3om^h0?EV[00l0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP070?ofkP80
e3dI00<0=TZ@0=@m6@3D?AT01@0fBY000`3D?AT0=TZ@0=@m6@0803I:T0040=@m6@0fBY00=TZ@0000
00/0=TZ@0P3D?AT:03I:T0030000000fBY00=TZ@00P0=TZ@00<0000003I:T00fBY002@0fBY000`00
0000=TZ@03I:T00903I:T0030000000fBY00=TZ@00T0=TZ@00<0000003I:T00fBY002@0fBY000`00
0000=TZ@03I:T00803I:T0030000000fBY00=TZ@00P0=TZ@0P3D?AT;03I:T0040000000fBY00=TZ@
0=@m6@P0=TZ@00<0e3dI03I:T03D?AT01@0fBY020=@m6@0303I:T03D?AT0e3dI00T0ooK^00<0?EV[
0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/04P3o
m^h203eIZ`D0ooK^00<000000?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0S0?ofkP030000003o
m^h0ooK^02h0ooK^0@3oool002l0ooK^00<000000?ofkP3om^h0903om^h00`0mFJ/0ooK^0?ofkP0>
0?ofkP030000003om^h0ooK^0080ooK^0P0mFJ/B0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/03`3o
m^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00L0ooK^0P3D?AT203I:T0030=@m6@0f
BY00=TZ@00<0=TZ@00<0e3dI03I:T00000000P3D?AT603I:T0040=@m6@0fBY00=TZ@000000/0=TZ@
00<0e3dI03I:T03D?AT00P3D?AT703I:T0030000000fBY00=TZ@00P0=TZ@00<0000003I:T00fBY00
2@0fBY000`000000=TZ@03I:T00903I:T0030000000fBY00=TZ@00T0=TZ@00<0000003I:T00fBY00
2@0fBY000`000000=TZ@03I:T00803I:T0030000000fBY00=TZ@00D0=TZ@0`3D?AT00`0fBY00e3dI
03I:T00:03I:T0040000000fBY00=TZ@0=@m6@H0=TZ@0P3D?AT00`000000=TZ@0=@m6@0503I:T005
0=@m6@0fBY00=TZ@0=@m6@0000002@3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^
00d0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0B0?ofkP80?EV[103om^h00`000000ooK^0?ofkP0>
0?ofkP0303eIZ`3om^h0ooK^02@0ooK^00<000000?ofkP3om^h0;@3om^h10?ooo`00;`3om^h00`00
0000ooK^0?ofkP0T0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<000000?ofkP3om^h00P3om^h203eI
Za80ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0?0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[
0?ofkP3om^h01`3om^h01@000000e3dI03I:T00fBY00e3dI00D0=TZ@00<0e3dI03I:T00000000P0f
BY000`3D?AT0=TZ@03I:T00303I:T0040=@m6@0fBY00=TZ@000000/0=TZ@00<0e3dI03I:T00fBY00
0P0fBY030=@m6@@0=TZ@00<0000003I:T00fBY00200fBY000`000000=TZ@03I:T00903I:T0030000
000fBY00=TZ@00T0=TZ@00<0000003I:T00fBY002@0fBY000`000000=TZ@03I:T00903I:T0030000
000fBY00=TZ@00P0=TZ@00<0000003I:T00fBY000P0fBY030=@m6@@0=TZ@00<0e3dI03I:T00fBY00
2@0fBY0010000000=TZ@03I:T03D?AT503I:T0050=@m6@0fBY00=TZ@0000003D?AT01P0fBY001@3D
?AT0=TZ@03I:T03D?AT0000000T0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0>
0?ofkP0403eIZ`3om^h0ooK^03eIZa<0ooK^0P0mFJ/40?ofkP030000003om^h0ooK^00h0ooK^00<0
?EV[0?ofkP3om^h0903om^h00`000000ooK^0?ofkP0]0?ofkP40oooo000_0?ofkP030000003om^h0
ooK^02<0ooK^00<0?EV[0?ofkP3om^h03`3om^h00`000000ooK^0?ofkP020?ofkP0303eIZ`3om^h0
ooK^0180ooK^00@0?EV[0?ofkP3om^h0?EV[403om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3o
m^h0ooK^00L0ooK^00@000000=@m6@0fBY00=TZ@0P3D?AT503I:T0030=@m6@000000=TZ@0080=TZ@
00<0e3dI03I:T00fBY000P0fBY00103D?AT0=TZ@03I:T000000;03I:T0030=@m6@0fBY00=TZ@00D0
=TZ@0`3D?AT00`0fBY00000003I:T00903I:T0030000000fBY00=TZ@00T0=TZ@00<0000003I:T00f
BY002@0fBY000`000000=TZ@03I:T00903I:T0030000000fBY00=TZ@00T0=TZ@00<0000003I:T00f
BY00200fBY000`000000=TZ@0=@m6@020=@m6@L0=TZ@00<0e3dI03I:T00fBY002@0fBY0010000000
=TZ@03I:T03D?AT403I:T0060=@m6@0fBY00=TZ@03I:T0000000e3dI1@0fBY020=@m6@80=TZ@00<0
e3dI0000003om^h0203om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00h0ooK^00@0
?EV[0?ofkP3om^h0?EV[503om^h00`0mFJ/0ooK^0?ofkP020?ofkP030000003om^h0ooK^00l0ooK^
00<0?EV[0?ofkP3om^h08`3om^h00`000000ooK^0?ofkP0]0?ofkP40oooo000_0?ofkP030000003o
m^h0ooK^02<0ooK^00<0?EV[0?ofkP3om^h03`3om^h00`000000ooK^0?ofkP020?ofkP0303eIZ`3o
m^h0ooK^0180ooK^00@0?EV[0?ofkP3om^h0?EV[403om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eI
Z`3om^h0ooK^00P0ooK^00<0e3dI03I:T00fBY000P3D?AT503I:T0030=@m6@000000=TZ@00<0=TZ@
00<0e3dI03I:T00fBY000P0fBY000`3D?AT0=TZ@0000000;03I:T0030=@m6@0fBY00=TZ@00P0=TZ@
0`3D?AT903I:T0030000000fBY00=TZ@00T0=TZ@00<0000003I:T00fBY002@0fBY000`000000=TZ@
03I:T00903I:T0030000000fBY00=TZ@00T0=TZ@00<0000003I:T00fBY001`0fBY030=@m6@X0=TZ@
00<0e3dI03I:T00fBY002@0fBY000`000000=TZ@0=@m6@0403I:T0030=@m6@0fBY00=TZ@0080=TZ@
00<000000=@m6@0fBY00100fBY020=@m6@80=TZ@00<0e3dI0?ofkP3om^h0203om^h00`0mFJ/0ooK^
0?ofkP040?ofkP0303eIZ`3om^h0ooK^00h0ooK^00@0?EV[0?ofkP3om^h0?EV[503om^h00`0mFJ/0
ooK^0?ofkP020?ofkP030000003om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h08`3om^h00`000000
ooK^0?ofkP0]0?ofkP40oooo000_0?ofkP030000003om^h0ooK^02<0ooK^00<0?EV[0?ofkP3om^h0
403om^h01@000000ooK^0?ofkP3om^h0?EV[01@0ooK^00@0?EV[0?ofkP3om^h0?EV[403om^h00`0m
FJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00P0ooK^00H0e3dI03I:T00fBY00e3dI03I:T03D
?AT403I:T0030=@m6@000000=TZ@00@0=TZ@00L0e3dI03I:T00fBY00=TZ@0=@m6@0fBY00000000/0
=TZ@00<0e3dI03I:T00fBY002@0fBY000`000000=TZ@0=@m6@020=@m6@H0=TZ@00<0000003I:T00f
BY002@0fBY000`000000=TZ@03I:T00903I:T0030000000fBY00=TZ@00T0=TZ@00<0000003I:T00f
BY002@0fBY000`000000=TZ@03I:T00403I:T0<0e3dI00<0=TZ@0000000fBY002P0fBY000`3D?AT0
=TZ@03I:T00903I:T0030000000fBY00e3dI00<0=TZ@00<0e3dI03I:T00fBY000`0fBY000`000000
e3dI03I:T00303I:T0030=@m6@0fBY00e3dI0080=TZ@00<0e3dI0?ofkP3om^h0203om^h00`0mFJ/0
ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00h0ooK^00@0?EV[0?ofkP3om^h0?EV[4`3om^h203eI
Z`<0ooK^00<000000?ofkP3om^h0403om^h00`0mFJ/0ooK^0?ofkP0S0?ofkP030000003om^h0ooK^
02d0ooK^0@3oool002h0ooK^00<000000?ofkP3om^h0903om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP04
0000003om^h0ooK^0?ofkP80?EV[4`3om^h00`0mFJ/0ooK^03eIZ`0A0?ofkP0303eIZ`3om^h0ooK^
00<0ooK^00<0?EV[0?ofkP3om^h02@3om^h01`3D?AT0=TZ@03I:T00fBY00e3dI03I:T03D?AT00`0f
BY000`3D?AT0000003I:T00503I:T080e3dI00@0=TZ@0=@m6@0fBY0000002`0fBY000`3D?AT0=TZ@
03I:T00903I:T0030000000fBY00=TZ@0080=TZ@1@3D?AT00`0fBY00000003I:T00:03I:T0030000
000fBY00=TZ@00T0=TZ@00<0000003I:T00fBY002@0fBY000`000000=TZ@03I:T00903I:T0030000
000fBY00e3dI00@0e3dI100fBY000`000000=TZ@03I:T00903I:T0030=@m6@0fBY00=TZ@00T0=TZ@
00@0000003I:T03D?AT0=TZ@0P3D?AT603I:T0030000003D?AT0=TZ@0080=TZ@00<0e3dI03I:T03D
?AT00`0fBY000`3D?AT0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3o
m^h03P3om^h0100mFJ/0ooK^0?ofkP0mFJ/C0?ofkP80?EV[0`3om^h00`000000ooK^0?ofkP0@0?of
kP0303eIZ`3om^h0ooK^02@0ooK^00<000000?ofkP3om^h0;03om^h10?ooo`00;P3om^h00`000000
ooK^0?ofkP0T0?ofkP0303eIZ`3om^h0ooK^0100ooK^00@000000?ofkP3om^h0ooK^0P0mFJ/C0?of
kP0303eIZ`3om^h0?EV[0140ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP090?of
kP80e3dI0P0fBY000`3D?AT0=TZ@0=@m6@0303I:T0030=@m6@000000=TZ@00L0=TZ@0P3D?AT00`0f
BY00000003I:T00:03I:T0030=@m6@0fBY00=TZ@00T0=TZ@00<0000003I:T00fBY000`0fBY00103D
?AT0=TZ@03I:T00fBY060=@m6@L0=TZ@00<0000003I:T00fBY002@0fBY000`000000=TZ@03I:T009
03I:T0030000000fBY00=TZ@00D0=TZ@1P3D?AT303I:T0030=@m6@0fBY00=TZ@00<0=TZ@00<00000
03I:T00fBY002@0fBY000`3D?AT0=TZ@03I:T00903I:T0040000000fBY00e3dI0=@m6@P0=TZ@00<0
00000=@m6@0fBY000P0fBY000`3D?AT0=TZ@0=@m6@0203I:T080e3dI2`3om^h00`0mFJ/0ooK^0?of
kP030?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP0mFJ/04`3om^h203eIZ`<0ooK^00<0
00000?ofkP3om^h0403om^h00`0mFJ/0ooK^0?ofkP0T0?ofkP030000003om^h0ooK^02`0ooK^0@3o
ool002h0ooK^o`00002H000002h0ooK^0@3oool002h0ooK^00<000000?ofkP3om^h0903om^h00`0m
FJ/0ooK^0?ofkP0@0?ofkP040000003om^h0ooK^0?ofkP80?EV[4`3om^h00`0mFJ/0ooK^03eIZ`0A
0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h02@3om^h01@000000e3dI0=@m6@00
0000e3dI00<0000000<0e3dI0000003D?AT02P0000030=@m6@`0000000<0e3dI0000000000003P00
00000`3D?AT000000000000=000001/0e3dI3`0000000`3D?AT000000000000>000000030=@m6@00
0000000000X000000`3D?AT:000000030=@m6@000000e3dI00<0000000D0e3dI0000003D?AT0e3dI
0000000;0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^
03eIZ`0C0?ofkP80?EV[0`3om^h00`000000ooK^0?ofkP0@0?ofkP0303eIZ`3om^h0ooK^02@0ooK^
00<000000?ofkP3om^h0;03om^h10?ooo`00;`3om^h00`000000ooK^0?ofkP0R0?ofkP0303eIZ`3o
m^h0ooK^0180ooK^00D000000?ofkP0mFJ/0ooK^03eIZ`0C0?ofkP0303eIZ`3om^h0?EV[0140ooK^
00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP090?ofkP050000003D?AT0e3dI03Y@W@3D
?AT00`0jD9d0103D?AT0>U2M0=@m6@00000903Y@W@030=@m6@0jD9d000000080e3dI2@0jD9d00`00
0000e3dI03Y@W@0903Y@W@030000000jD9d0>U2M00<0>U2M00<0e3dI03Y@W@0jD9d00P0jD9d00`00
0000>U2M03Y@W@0903Y@W@030000000jD9d0e3dI00T0>U2M00<0000003Y@W@0jD9d01`0jD9d00`3D
?AT0>U2M0000000;03Y@W@030000000jD9d0>U2M0080>U2M00<0e3dI03Y@W@0jD9d00`0jD9d00`00
0000>U2M03Y@W@0803Y@W@030=@m6@000000>U2M00P0>U2M0P3D?AT00`000000>U2M0=@m6@0903Y@
W@040=@m6@0jD9d0>U2M0=@m6@<0>U2M00D0e3dI03Y@W@3D?AT0e3dI0000000;0?ofkP0303eIZ`3o
m^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^03eIZ`0C0?ofkP0503eIZ`3o
m^h0?EV[0?ofkP000000503om^h00`0mFJ/0ooK^0?ofkP0R0?ofkP030000003om^h0ooK^02d0ooK^
0@3oool002l0ooK^00<000000?ofkP3om^h08P3om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP050000003o
m^h0?EV[0?ofkP0mFJ/04`3om^h00`0mFJ/0ooK^03eIZ`0A0?ofkP0303eIZ`3om^h0ooK^00<0ooK^
00<0?EV[0?ofkP3om^h02@3om^h01@000000e3dI0=@m6@0jD9d0e3dI00@0>U2M00<0e3dI03Y@W@3D
?AT02@0jD9d00`3D?AT0>U2M0000000203Y@W@030=@m6@0jD9d0>U2M00H0>U2M00<000000=@m6@0j
D9d02@0jD9d00`000000>U2M03Y@W@0303Y@W@030=@m6@0jD9d0>U2M0080>U2M00<0000003Y@W@0j
D9d02@0jD9d00`000000>U2M0=@m6@0903Y@W@030000000jD9d0>U2M00L0>U2M00<0e3dI03Y@W@00
00002`0jD9d00`000000>U2M03Y@W@0203Y@W@030=@m6@0jD9d0>U2M00<0>U2M00<0000003Y@W@0j
D9d0200jD9d00`3D?AT0000003Y@W@0703Y@W@060=@m6@0jD9d0>U2M0000000jD9d0e3dI200jD9d0
10000000e3dI03Y@W@3D?AT403Y@W@80e3dI00<0>U2M0=@m6@0000002`3om^h00`0mFJ/0ooK^0?of
kP030?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP0mFJ/04`3om^h01@0mFJ/0ooK^03eI
Z`3om^h0000001@0ooK^00<0?EV[0?ofkP3om^h08P3om^h00`000000ooK^0?ofkP0]0?ofkP40oooo
000_0?ofkP030000003om^h0ooK^0280ooK^00<0?EV[0?ofkP3om^h04P3om^h01@000000ooK^03eI
Z`3om^h0?EV[01<0ooK^00<0?EV[0?ofkP0mFJ/04@3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eI
Z`3om^h0ooK^00T0ooK^00<000000=@m6@0jD9d00P3D?AT503Y@W@80e3dI00<0000003Y@W@0jD9d0
1P0jD9d00`3D?AT0>U2M0000000303Y@W@80e3dI1P0jD9d00`000000e3dI03Y@W@0903Y@W@030000
000jD9d0>U2M00<0>U2M00<0e3dI03Y@W@0jD9d00P0jD9d00`000000>U2M03Y@W@0903Y@W@030000
000jD9d0e3dI00T0>U2M00<0000003Y@W@0jD9d01`0jD9d00`3D?AT0>U2M0000000;03Y@W@030000
000jD9d0>U2M0080>U2M00<0e3dI03Y@W@0jD9d00`0jD9d00`000000>U2M03Y@W@0803Y@W@030=@m
6@000000>U2M00D0>U2M0P3D?AT203Y@W@040000000jD9d0>U2M0=@m6@P0>U2M00<000000=@m6@3D
?AT01@0jD9d20=@m6@0303Y@W@3D?AT0000000/0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0
ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0?EV[01<0ooK^00D0?EV[0?ofkP0mFJ/0ooK^0000000D0?of
kP0303eIZ`3om^h0ooK^0280ooK^00<000000?ofkP3om^h0;@3om^h10?ooo`00<03om^h00`000000
ooK^0?ofkP0Q0?ofkUD0?EV[00<0>U2M0=@m6@3D?AT01@0jD9d20=@m6@030000000jD9d0>U2M00L0
>U2M00<0e3dI03Y@W@000000100jD9d20=@m6@@0>U2M00<000000=@m6@0jD9d02@0jD9d00`000000
>U2M03Y@W@0303Y@W@030=@m6@0jD9d0>U2M0080>U2M00<0000003Y@W@0jD9d02@0jD9d00`000000
>U2M0=@m6@0903Y@W@030000000jD9d0>U2M00L0>U2M00<0e3dI03Y@W@0000002`0jD9d00`000000
>U2M03Y@W@0203Y@W@030=@m6@0jD9d0>U2M00<0>U2M00<0000003Y@W@0jD9d0200jD9d00`3D?AT0
000003Y@W@0303Y@W@80e3dI100jD9d00`000000>U2M0=@m6@0903Y@W@030000003D?AT0e3dI00D0
>U2M0P3D?AT00`0jD9d0?EV[03eIZ`1C03eIZb<0ooK^00<000000?ofkP3om^h0;P3om^h10?ooo`00
<03om^h00`000000ooK^0?ofkP0Q0?ofkP0303eIZ`3om^h0ooK^01<0ooK^00@0000003eIZ`3om^h0
?EV[4`3om^h00`0mFJ/0ooK^03eIZ`0A0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3o
m^h02P3om^h00`000000>U2M03Y@W@020=@m6@D0>U2M00<0e3dI0000000jD9d0200jD9d00`3D?AT0
>U2M0000000603Y@W@060=@m6@0jD9d0>U2M03Y@W@000000e3dI2P0jD9d00`000000>U2M03Y@W@03
03Y@W@030=@m6@0jD9d0>U2M0080>U2M00<0000003Y@W@0jD9d02@0jD9d00`000000>U2M0=@m6@09
03Y@W@030000000jD9d0>U2M00L0>U2M00<0e3dI03Y@W@0000002`0jD9d00`000000>U2M03Y@W@02
03Y@W@030=@m6@0jD9d0>U2M00<0>U2M00<0000003Y@W@0jD9d0200jD9d00`3D?AT0000003Y@W@02
03Y@W@030=@m6@0jD9d0>U2M00@0>U2M00<0000003Y@W@3D?AT02@0jD9d00`000000e3dI03Y@W@04
03Y@W@80e3dI0P0jD9d00`000000ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[
0?ofkP3om^h03`3om^h00`0mFJ/0ooK^03eIZ`0C0?ofkP0403eIZ`3om^h0?EV[000001D0ooK^00<0
?EV[0?ofkP3om^h08@3om^h00`000000ooK^0?ofkP0^0?ofkP40oooo000`0?ofkP030000003om^h0
ooK^0240ooK^00<0?EV[0?ofkP3om^h04`3om^h01@000000?EV[0?ofkP3om^h0?EV[01<0ooK^0P0m
FJ/B0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h02P3om^h00`000000>U2M03Y@
W@020=@m6@D0>U2M0P3D?AT903Y@W@030=@m6@0jD9d0000000L0>U2M0P3D?AT00`0jD9d000000=@m
6@0:03Y@W@030000000jD9d0>U2M00<0>U2M00<0e3dI03Y@W@0jD9d00P0jD9d00`000000>U2M03Y@
W@0903Y@W@030000000jD9d0e3dI00T0>U2M00<0000003Y@W@0jD9d01`0jD9d00`3D?AT0000003Y@
W@0:03Y@W@030000000jD9d0>U2M00<0>U2M00<0e3dI03Y@W@0jD9d00P0jD9d00`000000>U2M03Y@
W@0903Y@W@030=@m6@0jD9d0>U2M0080e3dI1`0jD9d00`000000>U2M0=@m6@0803Y@W@030000003D
?AT0e3dI00D0>U2M0P3D?AT203Y@W@030000003om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h00P3o
m^h00`0mFJ/0ooK^0?ofkP0@0?ofkP80?EV[4`3om^h01@0mFJ/0ooK^0?ofkP0mFJ/0000001D0ooK^
00<0?EV[0?ofkP3om^h08@3om^h00`000000ooK^0?ofkP0^0?ofkP40oooo000a0?ofkP030000003o
m^h0ooK^0200ooK^00<0?EV[0?ofkP3om^h04`3om^h01@000000?EV[0?ofkP3om^h0?EV[01<0ooK^
0P0mFJ/B0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h02P3om^h01@000000>U2M
03Y@W@0jD9d0e3dI00D0>U2M00<0e3dI03Y@W@3D?AT0200jD9d00`3D?AT0>U2M0000000903Y@W@<0
e3dI2`0jD9d00`000000>U2M03Y@W@0203Y@W@030=@m6@0jD9d0>U2M00<0>U2M00<0000003Y@W@0j
D9d02@0jD9d00`000000e3dI03Y@W@0803Y@W@030000000jD9d0>U2M00L0>U2M00<0e3dI0000000j
D9d02P0jD9d00`000000>U2M03Y@W@0303Y@W@030=@m6@0jD9d0>U2M0080>U2M00<0000003Y@W@0j
D9d02@0jD9d30=@m6@T0>U2M00<0000003Y@W@3D?AT0200jD9d00`3D?AT0>U2M0=@m6@0503Y@W@05
0=@m6@0jD9d0>U2M03Y@W@000000303om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^
0100ooK^0P0mFJ/C0?ofkP0503eIZ`3om^h0ooK^03eIZ`0000005@3om^h00`0mFJ/0ooK^0?ofkP0P
0?ofkP030000003om^h0ooK^02l0ooK^0@3oool00340ooK^00<000000?ofkP3om^h0803om^h00`0m
FJ/0ooK^0?ofkP0C0?ofkP050000000mFJ/0ooK^0?ofkP0mFJ/04`3om^h203eIZa80ooK^00<0?EV[
0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP050000000jD9d0>U2M03Y@W@3D?AT01@0j
D9d0103D?AT0>U2M0000003D?AT703Y@W@030=@m6@0jD9d0000000/0>U2M0P3D?AT:03Y@W@030000
000jD9d0>U2M0080>U2M00<0e3dI03Y@W@0jD9d00`0jD9d00`000000>U2M03Y@W@0903Y@W@030000
003D?AT0>U2M00P0>U2M00<0000003Y@W@0jD9d01`0jD9d00`3D?AT0000003Y@W@0:03Y@W@030000
000jD9d0>U2M00<0>U2M00<0e3dI03Y@W@0jD9d00P0jD9d00`000000>U2M03Y@W@0803Y@W@80e3dI
2`0jD9d00`000000>U2M0=@m6@0703Y@W@040=@m6@000000>U2M0=@m6@D0>U2M00D0e3dI03Y@W@0j
D9d0>U2M0000000<0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h0403om^h203eI
Za<0ooK^00D0?EV[0?ofkP3om^h0?EV[0000000E0?ofkP0303eIZ`3om^h0ooK^0200ooK^00<00000
0?ofkP3om^h0;`3om^h10?ooo`00<@3om^h00`000000ooK^0?ofkP0P0?ofkP0303eIZ`3om^h0ooK^
01<0ooK^00D0000003eIZ`3om^h0ooK^03eIZ`0C0?ofkP80?EV[4P3om^h00`0mFJ/0ooK^0?ofkP02
0?ofkP0303eIZ`3om^h0ooK^00X0ooK^00@0000003Y@W@0jD9d0>U2M0P3D?AT403Y@W@050=@m6@0j
D9d0000003Y@W@3D?AT01P0jD9d00`3D?AT0>U2M0000000;03Y@W@030=@m6@0jD9d0e3dI0080e3dI
1`0jD9d00`000000>U2M03Y@W@0203Y@W@030=@m6@0jD9d0>U2M00<0>U2M00<0000003Y@W@0jD9d0
2@0jD9d00`000000e3dI03Y@W@0803Y@W@030000000jD9d0>U2M00L0>U2M00<0e3dI0000000jD9d0
2P0jD9d00`000000>U2M03Y@W@0303Y@W@030=@m6@0jD9d0>U2M0080>U2M00<0000003Y@W@0jD9d0
1@0jD9d30=@m6@0303Y@W@3D?AT0>U2M00T0>U2M00@0000003Y@W@0jD9d0e3dI1P0jD9d0103D?AT0
>U2M0000003D?AT503Y@W@80e3dI0P0jD9d2000000`0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0m
FJ/0ooK^0?ofkP0@0?ofkP80?EV[4`3om^h01@0mFJ/0ooK^0?ofkP0mFJ/0000001D0ooK^00<0?EV[
0?ofkP3om^h0803om^h00`000000ooK^0?ofkP0_0?ofkP40oooo000b0?ofkP030000003om^h0ooK^
01l0ooK^00<0?EV[0?ofkP3om^h0503om^h0100mFJ/0ooK^0?ofkP0mFJ/C0?ofkP80?EV[4P3om^h0
0`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00X0ooK^0P00000203Y@W@80e3dI1@0jD9d0
1@3D?AT0000003Y@W@0jD9d0e3dI00D0>U2M00@0e3dI03Y@W@0jD9d000002P0jD9d00`3D?AT0>U2M
03Y@W@0203Y@W@<0e3dI100jD9d00`000000>U2M03Y@W@0203Y@W@030=@m6@0jD9d0>U2M00<0>U2M
00<0000003Y@W@0jD9d02@0jD9d00`000000e3dI03Y@W@0803Y@W@030000000jD9d0>U2M00L0>U2M
00<0e3dI0000000jD9d02P0jD9d00`000000>U2M03Y@W@0303Y@W@030=@m6@0jD9d0>U2M0080>U2M
00<0000003Y@W@0jD9d00P0jD9d30=@m6@@0>U2M00<0e3dI03Y@W@0jD9d0200jD9d010000000>U2M
03Y@W@3D?AT503Y@W@050=@m6@0jD9d0000003Y@W@3D?AT01@0jD9d20=@m6@80>U2M0P00000<0?of
kP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h0403om^h203eIZa<0ooK^00@0?EV[0?of
kP3om^h0?EV[5P3om^h00`0mFJ/0ooK^0?ofkP0O0?ofkP030000003om^h0ooK^0300ooK^0@3oool0
0380ooK^00<000000?ofkP3om^h07`3om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP0403eIZ`3om^h0ooK^
03eIZa<0ooK^0P0mFJ/B0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h02P3om^h2
00000080>U2M00<0e3dI03Y@W@3D?AT0100jD9d00`3D?AT0>U2M0000000203Y@W@80e3dI0`0jD9d0
103D?AT0>U2M03Y@W@00000:03Y@W@030=@m6@0jD9d0>U2M00D0>U2M0P3D?AT203Y@W@030000000j
D9d0>U2M0080>U2M00<0e3dI03Y@W@0jD9d00`0jD9d00`000000>U2M03Y@W@0903Y@W@030000003D
?AT0>U2M00P0>U2M00<0000003Y@W@0jD9d01`0jD9d00`3D?AT0000003Y@W@0:03Y@W@030000000j
D9d0>U2M00<0>U2M00<0e3dI03Y@W@0jD9d00P0jD9d00`000000>U2M03Y@W@020=@m6@L0>U2M00<0
e3dI03Y@W@0jD9d0200jD9d010000000>U2M03Y@W@3D?AT303Y@W@80e3dI0P0jD9d00`000000>U2M
0=@m6@0403Y@W@030=@m6@0jD9d0e3dI0080>U2M00<000000?ofkP3om^h02`3om^h00`0mFJ/0ooK^
0?ofkP020?ofkP0303eIZ`3om^h0ooK^0100ooK^0P0mFJ/C0?ofkP0403eIZ`3om^h0ooK^03eIZaH0
ooK^00<0?EV[0?ofkP3om^h07`3om^h00`000000ooK^0?ofkP0`0?ofkP40oooo000b0?ofkP030000
003om^h0ooK^01h0ooK^00<0?EV[0?ofkP3om^h0503om^h0100mFJ/000000?ofkP3om^hk03eIZ`<0
000000<0e3dI0000003D?AT0100000000`3D?AT0000000000004000000050=@m6@00000000000000
003D?AT0300000000`3D?AT0000000000007000000<0e3dI100000000`3D?AT000000000000@0000
00030=@m6@00000000000140000000<0e3dI000000000000400000000`3D?AT00000000000020000
00<0e3dI2@0000000`3D?AT000000000000:000000050=@m6@00000000000000003D?AT01P000000
0`3D?AT0000000000002000000030=@m6@000000e3dI00<00000>`0mFJ/20?ofkP0303eIZ`3om^h0
ooK^01@0ooK^00<0?EV[0?ofkP3om^h07`3om^h00`000000ooK^0?ofkP0`0?ofkP40oooo000b0?of
kP030000003om^h0ooK^01h0ooK^00<0?EV[0?ofkP3om^h0503om^h01@0mFJ/000000?ofkP3om^h0
?EV[01<0ooK^00<0?EV[0?ofkP3om^h04@3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00h0ooK^00@0
000003eFZ00mEZP0e3dI0P0mEZP01`3D?AT0?EJX03eFZ00mEZP0e3dI03eFZ00000001@0mEZP01P3D
?AT0?EJX03eFZ03D?AT0?EJX000000X0?EJX00<0e3dI03eFZ00mEZP02@0mEZP01P000000e3dI0=@m
6@3D?AT0?EJX0=@m6@D0?EJX00<0000003eFZ00mEZP02@0mEZP00`000000e3dI03eFZ00803eFZ003
0000000mEZP0?EJX00L0?EJX00<0e3dI0000000mEZP02P0mEZP00`000000?EJX03eFZ00303eFZ003
0=@m6@0mEZP0e3dI0080e3dI00<0000003eFZ00mEZP02@0mEZP00`3D?AT0?EJX03eFZ00803eFZ003
0000000mEZP0e3dI0080?EJX00<0e3dI03eFZ00mEZP00`0mEZP00`000000?EJX0=@m6@0303eFZ004
0=@m6@0mEZP0?EJX0=@m6@80?EJX00<000000?ofkP3om^h0303om^h01@0mFJ/0ooK^0?ofkP3om^h0
?EV[01<0ooK^00<0?EV[0?ofkP3om^h04@3om^h01@0mFJ/0ooK^0?ofkP000000?EV[01H0ooK^00<0
?EV[0?ofkP3om^h07P3om^h00`000000ooK^0?ofkP0`0?ofkP40oooo000c0?ofkP030000003om^h0
ooK^01d0ooK^00<0?EV[0?ofkP3om^h0503om^h01@0mFJ/0ooK^0000003om^h0?EV[01<0ooK^00<0
?EV[0?ofkP3om^h04@3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00h0ooK^0P00000203eFZ0040=@m
6@0mEZP0?EJX0=@m6@80?EJX00@0e3dI03eFZ00mEZP000001@0mEZP01@3D?AT0?EJX0=@m6@0mEZP0
000000X0?EJX00<0e3dI03eFZ00mEZP02@0mEZP010000000?EJX03eFZ00mEZP50=@m6@80?EJX00<0
000003eFZ00mEZP02@0mEZP00`000000e3dI03eFZ00803eFZ0030000000mEZP0?EJX00L0?EJX00<0
e3dI0000000mEZP02P0mEZP00`000000?EJX03eFZ0050=@m6@<0?EJX00<0000003eFZ00mEZP02@0m
EZP00`3D?AT0?EJX03eFZ00803eFZ0050000000mEZP0e3dI03eFZ03D?AT01@0mEZP010000000?EJX
03eFZ03D?AT203eFZ0040=@m6@0mEZP0?EJX0=@m6@80?EJX0P00000>0?ofkP0503eIZ`3om^h0ooK^
0?ofkP0mFJ/04`3om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP0503eIZ`3om^h000000?ofkP0mFJ/05P3o
m^h00`0mFJ/0ooK^0?ofkP0M0?ofkP030000003om^h0ooK^0340ooK^0@3oool003<0ooK^00<00000
0?ofkP3om^h07@3om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP0503eIZ`3om^h000000?ofkP0mFJ/04`3o
m^h00`0mFJ/0ooK^0?ofkP0A0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/03P3om^h200000080?EJX
00@0e3dI03eFZ00mEZP0e3dI0P0mEZP0103D?AT0?EJX03eFZ000000603eFZ080e3dI0P0mEZP00`00
0000?EJX03eFZ00703eFZ0030=@m6@000000?EJX00T0?EJX00<0000003eFZ00mEZP00P0mEZP0103D
?AT0?EJX03eFZ00mEZP60=@m6@P0?EJX00<000000=@m6@0mEZP0200mEZP00`000000?EJX03eFZ007
03eFZ0030=@m6@000000?EJX00L0?EJX1P3D?AT303eFZ0030=@m6@0mEZP0?EJX0080?EJX00<00000
03eFZ00mEZP0200mEZP00`000000e3dI03eFZ00803eFZ0030000000mEZP0?EJX0080e3dI1P0mEZP0
10000000?EJX03eFZ03D?AT203eFZ0040=@m6@0mEZP0?EJX0=@m6@80?EJX0P00000>0?ofkP0503eI
Z`3om^h0ooK^0?ofkP0mFJ/04`3om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP0503eIZ`3om^h000000?of
kP0mFJ/05P3om^h00`0mFJ/0ooK^0?ofkP0M0?ofkP030000003om^h0ooK^0340ooK^0@3oool003<0
ooK^00<000000?ofkP3om^h07@3om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP0503eIZ`3om^h000000?of
kP0mFJ/04`3om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/03P3om^h3
0000000303eFZ03D?AT0?EJX0080?EJX00<0e3dI03eFZ03D?AT00P0mEZP00`000000?EJX03eFZ005
03eFZ0040=@m6@0mEZP0?EJX000000T0?EJX00<0e3dI0000000mEZP02P0mEZP01@000000?EJX03eF
Z00mEZP0e3dI00H0?EJX00<0000003eFZ00mEZP01P3D?AT203eFZ0030000003D?AT0?EJX00P0?EJX
00<0000003eFZ00mEZP01`0mEZP0103D?AT0000003eFZ00mEZP60=@m6@80?EJX00<0000003eFZ00m
EZP0100mEZP01@3D?AT0?EJX03eFZ00mEZP0000000/0?EJX00<0e3dI03eFZ00mEZP0200mEZP01000
0000?EJX03eFZ03D?AT703eFZ0060000000mEZP0?EJX0=@m6@0mEZP0e3dI0`0mEZP00`3D?AT0?EJX
00000002000000h0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0C0?ofkP0303eIZ`3om^h0ooK^0140
ooK^00D0?EV[0?ofkP000000ooK^03eIZ`0F0?ofkP0303eIZ`3om^h0ooK^01d0ooK^00<000000?of
kP3om^h0<@3om^h10?ooo`00=03om^h00`000000ooK^0?ofkP0L0?ofkP0303eIZ`3om^h0ooK^01@0
ooK^00D0?EV[0?ofkP000000ooK^03eIZ`0C0?ofkP0303eIZ`3om^h0ooK^0140ooK^00D0?EV[0?of
kP3om^h0ooK^03eIZ`0>0?ofkP<0000000<0?EJX0=@m6@0mEZP00`0mEZP20=@m6@<0?EJX00<00000
03eFZ00mEZP0100mEZP30=@m6@030000000mEZP0?EJX00P0?EJX00<0e3dI03eFZ00mEZP02@0mEZP0
1@000000?EJX03eFZ00mEZP0e3dI00H0?EJX00<0000003eFZ00mEZP01P0mEZPK0=@m6@P0?EJX00<0
000003eFZ00mEZP0100mEZP01@3D?AT0?EJX03eFZ00mEZP0000000/0?EJX00<0e3dI03eFZ00mEZP0
200mEZP010000000e3dI0=@m6@3D?AT603eFZ0060000000mEZP0?EJX0=@m6@0mEZP0e3dI100mEZP0
0`3D?AT0?EJX00000002000000h0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0C0?ofkP0303eIZ`3o
m^h0ooK^0140ooK^00D0?EV[0?ofkP000000ooK^03eIZ`0F0?ofkP0303eIZ`3om^h0ooK^01`0ooK^
00<000000?ofkP3om^h0<P3om^h10?ooo`00=03om^h00`000000ooK^0?ofkP0L0?ofkP0303eIZ`3o
m^h0ooK^01@0ooK^00D0?EV[0?ofkP3om^h0000003eIZ`0C0?ofkP0303eIZ`3om^h0ooK^0140ooK^
00D0?EV[0?ofkP3om^h0ooK^03eIZ`0>0?ofkP<0000000<0?EJX0=@m6@0mEZP00`0mEZP00`3D?AT0
?EJX0=@m6@0203eFZ0030000000mEZP0?EJX00@0?EJX00<0e3dI03eFZ00mEZP00P3D?AT903eFZ003
0=@m6@0mEZP0?EJX00T0?EJX00D0000003eFZ00mEZP0?EJX0=@m6@0603eFZ0030000000mEZP0?EJX
00P0?EJX00<000000=@m6@0mEZP0200mEZP00`000000?EJX03eFZ00703eFZ0030=@m6@000000?EJX
00T0?EJX00<0000003eFZ00mEZP0100mEZP01@3D?AT0?EJX03eFZ00mEZP0000000/0?EJX00<0e3dI
03eFZ00mEZP01`0mEZP20=@m6@80?EJX00<0e3dI03eFZ00mEZP0100mEZP01P000000?EJX03eFZ03D
?AT0?EJX0=@m6@@0?EJX00<0e3dI03eFZ00000000P00000>0?ofkP0503eIZ`3om^h0ooK^0?ofkP0m
FJ/04`3om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP0503eIZ`000000ooK^0?ofkP0mFJ/05P3om^h00`0m
FJ/0ooK^0?ofkP0L0?ofkP030000003om^h0ooK^0380ooK^0@3oool003@0ooK^00<000000?ofkP3o
m^h0703om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP0503eIZ`3om^h0ooK^0000000mFJ/04`3om^h00`0m
FJ/0ooK^0?ofkP0A0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/03`3om^h010000000?1490000003D
?AT503eFZ080e3dI0P0mEZP00`000000?EJX03eFZ00403eFZ0050=@m6@0mEZP0?EJX03eFZ0000000
0P3D?AT703eFZ0030=@m6@000000?EJX00T0?EJX00D0000003eFZ00mEZP0?EJX0=@m6@0603eFZ003
0000000mEZP0?EJX00P0?EJX00<000000=@m6@0mEZP0200mEZP00`000000?EJX03eFZ00703eFZ003
0=@m6@000000?EJX00T0?EJX00<0000003eFZ00mEZP0100mEZP01@3D?AT0?EJX03eFZ00mEZP00000
00X0?EJX00<000000=@m6@0mEZP01P0mEZP20=@m6@050000000mEZP0?EJX03eFZ03D?AT01P0mEZP0
0`000000?EJX03eFZ0020=@m6@D0?EJX00@0e3dI0000003iB1`000003`3om^h01@0mFJ/0ooK^0?of
kP3om^h0?EV[0180ooK^0P0mFJ/B0?ofkP0303eIZ`3om^h000000080ooK^00<0?EV[0?ofkP3om^h0
503om^h00`0mFJ/0ooK^0?ofkP0L0?ofkP030000003om^h0ooK^0380ooK^0@3oool003D0ooK^00<0
00000?ofkP3om^h06`3om^iJ03eIZ`030=@m6@0mEZP0?EJX00<0?EJX0P3D?AT203eFZ0030000000m
EZP0?EJX00@0?EJX00D0e3dI03eFZ00mEZP0?EJX0000000203eFZ0030=@m6@0mEZP0?EJX00@0?EJX
00<0e3dI0000000mEZP02@0mEZP01@000000?EJX03eFZ00mEZP0e3dI00H0?EJX00<0000003eFZ00m
EZP0200mEZP00`000000e3dI03eFZ00803eFZ0030000000mEZP0?EJX00L0?EJX00<0e3dI0000000m
EZP02@0mEZP00`000000?EJX03eFZ00403eFZ0050=@m6@0mEZP0?EJX03eFZ00000002P0mEZP00`00
0000e3dI03eFZ00503eFZ0040=@m6@0mEZP0?EJX000000<0?EJX00<0e3dI03eFZ00mEZP0100mEZP0
0`000000?EJX03eFZ0020=@m6@D0?EJX00<0e3dI03eIZ`0mFJ/0F00mFJ/M0?ofkP030000003om^h0
ooK^03<0ooK^0@3oool003D0ooK^00<000000?ofkP3om^h06`3om^h00`0mFJ/0ooK^0?ofkP0D0?of
kP0603eIZ`3om^h0ooK^0000003om^h0?EV[4P3om^h203eIZa80ooK^00D0?EV[0?ofkP3om^h0ooK^
03eIZ`0?0?ofkP<000001`0mEZP01@3D?AT0?EJX03eFZ00mEZP0000000D0?EJX00D0e3dI03eFZ00m
EZP0?EJX0000000303eFZ080e3dI100mEZP00`3D?AT0000003eFZ00903eFZ0050000000mEZP0?EJX
03eFZ03D?AT01P0mEZP00`000000?EJX03eFZ00803eFZ0030000003D?AT0?EJX00P0?EJX00<00000
03eFZ00mEZP01`0mEZP00`3D?AT0000003eFZ00903eFZ0030000000mEZP0?EJX00@0?EJX00D0e3dI
03eFZ00mEZP0?EJX0000000:03eFZ0030000003D?AT0?EJX00<0?EJX0P3D?AT303eFZ0050000000m
EZP0?EJX03eFZ03D?AT01@0mEZP01@000000?EJX03eFZ00mEZP0e3dI00L0?EJX0`00000?0?ofkP05
03eIZ`3om^h0ooK^0?ofkP0mFJ/04P3om^h203eIZa80ooK^00<0?EV[0?ofkP0000000P3om^h00`0m
FJ/0ooK^0?ofkP0D0?ofkP0303eIZ`3om^h0ooK^01/0ooK^00<000000?ofkP3om^h0<`3om^h10?oo
o`00=@3om^h00`000000ooK^0?ofkP0K0?ofkP0303eIZ`3om^h0ooK^01@0ooK^00H0?EV[0?ofkP3o
m^h000000?ofkP0mFJ/B0?ofkP80?EV[4P3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00l0ooK^0P00
00000`0l4@T0000003eFZ00503eFZ080e3dI0P0mEZP00`000000?EJX03eFZ00303eFZ0050=@m6@0m
EZP0?EJX03eFZ00000001@0mEZP20=@m6@80?EJX00<0e3dI0000000mEZP02P0mEZP010000000?EJX
03eFZ03D?AT703eFZ0030000000mEZP0?EJX00L0?EJX00<000000=@m6@0mEZP0200mEZP00`000000
?EJX03eFZ00703eFZ0030=@m6@000000?EJX00P0?EJX00<0000003eFZ00mEZP0100mEZP01@3D?AT0
?EJX03eFZ00mEZP0000000/0?EJX00@000000=@m6@0mEZP0?EJX0P3D?AT503eFZ0050000000mEZP0
?EJX03eFZ03D?AT01@0mEZP00`000000?EJX03eFZ0020=@m6@H0?EJX00@000000?U8700000000000
3`3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[0180ooK^0P0mFJ/B0?ofkP0303eIZ`3om^h000000080
ooK^00<0?EV[0?ofkP3om^h0503om^h00`0mFJ/0ooK^0?ofkP0K0?ofkP030000003om^h0ooK^03<0
ooK^0@3oool003H0ooK^00<000000?ofkP3om^h06P3om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP0603eI
Z`3om^h0ooK^0?ofkP000000?EV[4P3om^h203eIZa80ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0?
0?ofkP@000001P0mEZP01@3D?AT0?EJX0=@m6@0mEZP0000000D0?EJX00<0e3dI03eFZ00mEZP00P0m
EZP00`000000?EJX03eFZ00403eFZ0<0e3dI00<0?EJX0000000mEZP02@0mEZP01@000000?EJX03eF
Z00mEZP0e3dI00H0?EJX00<0000003eFZ00mEZP01`0mEZP00`000000e3dI03eFZ00803eFZ0030000
000mEZP0?EJX00L0?EJX00<0e3dI0000000mEZP0200mEZP00`000000?EJX03eFZ00403eFZ0050=@m
6@0mEZP0?EJX03eFZ00000002P0mEZP00`000000?EJX0=@m6@020=@m6@H0?EJX00<0000003eFZ00m
EZP00P0mEZP00`3D?AT0?EJX03eFZ00303eFZ0050000000mEZP0e3dI03eFZ03D?AT01P0mEZP40000
00l0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0B0?ofkP80?EV[4P3om^h00`0mFJ/000000?ofkP02
0?ofkP0303eIZ`3om^h0ooK^01@0ooK^00<0?EV[0?ofkP3om^h06P3om^h00`000000ooK^0?ofkP0d
0?ofkP40oooo000f0?ofkP030000003om^h0ooK^01X0ooK^00<0?EV[0?ofkP3om^h0503om^h01P0m
FJ/0ooK^0?ofkP3om^h0000003eIZa80ooK^0P0mFJ/B0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/0
3`3om^h30000000303`A2@000000?EJX00@0?EJX00H0e3dI03eFZ00mEZP0e3dI03eFZ000000503eF
Z0050=@m6@0mEZP0?EJX03eFZ0000000200mEZP20=@m6@030000000mEZP0?EJX00P0?EJX00D00000
03eFZ00mEZP0?EJX0=@m6@0603eFZ0030000000mEZP0?EJX00L0?EJX00<000000=@m6@0mEZP0200m
EZP00`000000?EJX03eFZ00703eFZ0030=@m6@000000?EJX00P0?EJX00<0000003eFZ00mEZP0100m
EZP01@3D?AT0?EJX03eFZ00mEZP0000000X0?EJX00<000000=@m6@3D?AT0200mEZP01@000000?EJX
03eFZ00mEZP0e3dI00D0?EJX00<0000003eFZ03D?AT00P0mEZP00`3D?AT0?EJX03eFZ00303eFZ003
0000003iB1`00000008000003`3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[0180ooK^0P0mFJ/B0?of
kP0303eIZ`000000ooK^0080ooK^00<0?EV[0?ofkP3om^h0503om^h00`0mFJ/0ooK^0?ofkP0J0?of
kP030000003om^h0ooK^03@0ooK^0@3oool003H0ooK^00<000000?ofkP3om^h06P3om^h00`0mFJ/0
ooK^0?ofkP0D0?ofkP0603eIZ`3om^h0ooK^0?ofkP000000?EV[4P3om^h203eIZa80ooK^00D0?EV[
0?ofkP3om^h0ooK^03eIZ`0?0?ofkP<0000000<0?149000000000000100000001@3D?AT000000000
00000000e3dI00H0000000<0e3dI0000000000002P0000000`3D?AT000000=@m6@020=@m6@`00000
00<0e3dI0000000000003`0000000`3D?AT000000000000@000000030=@m6@000000000001000000
00<0e3dI0000000000002P0000030=@m6@030000003D?AT0000000/0000000<0e3dI000000000000
100000001@3D?AT00000000000000000e3dI00L0000000<0nDPL0000000000003`3om^h01@0mFJ/0
ooK^0?ofkP3om^h0?EV[0180ooK^0P0mFJ/B0?ofkP0303eIZ`000000ooK^0080ooK^00<0?EV[0?of
kP3om^h0503om^h00`0mFJ/0ooK^0?ofkP0J0?ofkP030000003om^h0ooK^03@0ooK^0@3oool003L0
ooK^00<000000?ofkP3om^h06@3om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP0503eIZ`3om^h0ooK^0?of
kP000000>`0mFJ/20000000403`A2@0000000000000000@0?eZa00<0e3dI03mJ/@0oF[400P0oF[42
0=@m6@@0?eZa00D0e3dI03mJ/@0oF[40?eZa0000000803mJ/@030=@m6@0oF[4000000080?eZa0`3D
?AT503mJ/@050000000oF[40?eZa03mJ/@3D?AT01P0oF[400`000000?eZa03mJ/@0703mJ/@030000
000oF[40e3dI00P0?eZa00<0000003mJ/@0oF[401P0oF[400`3D?AT0?eZa0000000903mJ/@030000
000oF[40?eZa00@0?eZa00D0e3dI03mJ/@0oF[40?eZa0000000503mJ/@<0e3dI0P0oF[400`000000
?eZa0=@m6@0803mJ/@050000000oF[40?eZa03mJ/@3D?AT0100oF[420=@m6@@0?eZa00<0e3dI03mJ
/@0oF[400P0oF[43000000030?U870000000000003/0?EV[00D000000?ofkP3om^h0ooK^03eIZ`0F
0?ofkP0303eIZ`3om^h0ooK^01T0ooK^00<000000?ofkP3om^h0=@3om^h10?ooo`00=`3om^h00`00
0000ooK^0?ofkP0I0?ofkP0303eIZ`3om^h0ooK^01@0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0m
FJ/0ooK^0?ofkP0@0?ofkP80?EV[4P3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00l0ooK^0P000000
100l4@T0000000000000000403mJ/@030=@m6@0oF[40?eZa00<0?eZa00<000000=@m6@0oF[400P0o
F[400`3D?AT0?eZa03mJ/@0203mJ/@030000000oF[40?eZa00D0?eZa00@0e3dI03mJ/@0oF[400000
100oF[420=@m6@<0?eZa00D0000003mJ/@0oF[40?eZa0=@m6@0603mJ/@030000000oF[40?eZa00L0
?eZa00<0000003mJ/@3D?AT0200oF[400`000000?eZa03mJ/@0603mJ/@030=@m6@0oF[40000000T0
?eZa00<0000003mJ/@0oF[40100oF[401@3D?AT0?eZa03mJ/@0oF[40000000<0?eZa0P3D?AT403mJ
/@040000000oF[40?eZa0=@m6@L0?eZa00<0000003mJ/@0oF[400P0oF[401P3D?AT0?eZa03mJ/@0o
F[40e3dI000000D0?eZa00<0e3dI03mJ/@0oF[400P0oF[43000000030?U870000000000000l0ooK^
00D0?EV[0?ofkP3om^h0ooK^03eIZ`0B0?ofkP80?EV[4P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP03
03eIZ`3om^h0ooK^01@0ooK^00<0?EV[0?ofkP3om^h06@3om^h00`000000ooK^0?ofkP0e0?ofkP40
oooo000g0?ofkP030000003om^h0ooK^01T0ooK^00<0?EV[0?ofkP3om^h0503om^h00`0mFJ/0ooK^
0?ofkP020?ofkP0303eIZ`3om^h0ooK^0100ooK^0P0mFJ/B0?ofkP0503eIZ`3om^h0ooK^0?ofkP0m
FJ/03`3om^h30000000403`A2@000000DAP<000000<0?eZa00<0e3dI03mJ/@0oF[400`0oF[400`00
0000?eZa0=@m6@0203mJ/@030=@m6@0oF[40?eZa0080?eZa00<0000003mJ/@0oF[401@0oF[40103D
?AT0?eZa03mJ/@00000603mJ/@<0e3dI00D0?eZa0000000oF[40?eZa0=@m6@0603mJ/@030000000o
F[40?eZa00L0?eZa00<0000003mJ/@3D?AT0200oF[400`000000?eZa03mJ/@0603mJ/@030=@m6@0o
F[40000000T0?eZa00<0000003mJ/@0oF[40100oF[401@3D?AT0?eZa03mJ/@000000?eZa00<0e3dI
1P0oF[4010000000?eZa03mJ/@3D?AT703mJ/@030000000oF[40?eZa0080?eZa00H0e3dI03mJ/@0o
F[40e3dI03mJ/@00000403mJ/@030=@m6@0oF[40?eZa0080?eZa0`000000103iB1`0000000000000
000?0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/04P3om^h203eIZa80ooK^00<0?EV[0?ofkP3om^h0
0P3om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP0303eIZ`3om^h0ooK^01T0ooK^00<000000?ofkP3om^h0
=@3om^h10?ooo`00>03om^h00`000000ooK^0?ofkP0G0?ofkP0303eIZ`3om^h0ooK^01D0ooK^00<0
?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP80?EV[4P3om^h01@0mFJ/0ooK^0?of
kP3om^h0?EV[00l0ooK^0`000000100l4@T0000000000000000403mJ/@030=@m6@0oF[40?eZa00<0
?eZa00D0000003mJ/@3D?AT0?eZa0=@m6@0503mJ/@030000000oF[40?eZa00@0?eZa00@0e3dI03mJ
/@0oF[4000002@0oF[430=@m6@0303mJ/@3D?AT0?eZa00H0?eZa00<0000003mJ/@0oF[401P0oF[40
0`000000?eZa0=@m6@0803mJ/@030000000oF[40?eZa00H0?eZa00<0e3dI03mJ/@000000200oF[40
0`000000?eZa03mJ/@0503mJ/@030=@m6@0oF[40e3dI0080e3dI2@0oF[4010000000?eZa03mJ/@3D
?AT603mJ/@030000000oF[40?eZa00<0?eZa00D0e3dI03mJ/@3D?AT0?eZa0000000503mJ/@030=@m
6@0oF[40?eZa0080?eZa0`000000103iB1`0000000000000000?0?ofkP0503eIZ`3om^h0ooK^0?of
kP0mFJ/04P3om^h203eIZa80ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP0D0?of
kP0303eIZ`3om^h0ooK^01P0ooK^00<000000?ofkP3om^h0=P3om^h10?ooo`00>03om^h00`000000
ooK^0?ofkP0G0?ofkP0303eIZ`3om^h0ooK^01D0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0
ooK^0?ofkP0@0?ofkP80?EV[4P3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00l0ooK^10000000100l
4@T00000054H3000000303mJ/@030=@m6@0oF[40?eZa00<0?eZa00<0000003mJ/@0oF[400P3D?AT5
03mJ/@030000000oF[40?eZa00@0?eZa00D0e3dI03mJ/@0oF[40?eZa0000000903mJ/@030000000o
F[40e3dI00@0e3dI100oF[400`000000?eZa03mJ/@0603mJ/@030000000oF[40e3dI00P0?eZa00<0
000003mJ/@0oF[401P0oF[400`3D?AT0?eZa0000000803mJ/@030000000oF[40?eZa0080?eZa1@3D
?AT00`0oF[40000003mJ/@0803mJ/@050000000oF[40?eZa03mJ/@3D?AT01P0oF[400`000000?eZa
03mJ/@0303mJ/@80e3dI0P0oF[400`000000?eZa03mJ/@0303mJ/@080=@m6@0oF[40?eZa03mJ/@00
0000oe0O0000003iB1`4000000l0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0B0?ofkP80?EV[4P3o
m^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^01D0ooK^00<0?EV[0?ofkP3om^h05`3o
m^h00`000000ooK^0?ofkP0f0?ofkP40oooo000h0?ofkP030000003om^h0ooK^01L0ooK^00<0?EV[
0?ofkP3om^h05@3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^0100ooK^0P0mFJ/B
0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/03`3om^h40000000803`A2@000000DAP<0000000oF[40
e3dI03mJ/@3D?AT603mJ/@040000000oF[40?eZa0=@m6@D0?eZa00<0000003mJ/@0oF[40100oF[40
1@3D?AT0?eZa03mJ/@0oF[40000000T0?eZa00@0000003mJ/@0oF[40e3dI0`0oF[460=@m6@L0?eZa
00<0000003mJ/@3D?AT0200oF[400`000000?eZa03mJ/@0603mJ/@030=@m6@0oF[40000000L0?eZa
1P3D?AT303mJ/@040=@m6@0oF[40?eZa000000T0?eZa00D0000003mJ/@0oF[40?eZa0=@m6@0603mJ
/@030000000oF[40?eZa00<0?eZa00@0e3dI03mJ/@0oF[4000001P0oF[40203D?AT0?eZa0=@m6@0o
F[4000000?m@7`000000nDPL1000000?0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/04P3om^h203eI
Za80ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP0E0?ofkP0303eIZ`3om^h0ooK^
01L0ooK^00<000000?ofkP3om^h0=P3om^h10?ooo`00>@3om^h00`000000ooK^0?ofkP0F0?ofkP03
03eIZ`3om^h0ooK^01D0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/000000?ofkP0@0?ofkP80
?EV[4P3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00l0ooK^0`0000000`0l4@T0000000000002054H
300403eIZ`3D?AT0?eZa0=@m6@H0?eZa00<0000003mJ/@0oF[400`3D?AT403mJ/@030000000oF[40
?eZa00<0?eZa00D0e3dI03mJ/@0oF[40?eZa0000000:03mJ/@030000000oF[40e3dI00L0?eZa00<0
000003mJ/@3D?AT01@3D?AT203mJ/@030000003D?AT0?eZa00L0?eZa00<0000003mJ/@0oF[401P0o
F[40103D?AT0000003mJ/@0oF[460=@m6@0303mJ/@000000?eZa00H0?eZa00<0e3dI03mJ/@000000
2P0oF[4010000000?eZa03mJ/@3D?AT603mJ/@030000000oF[40?eZa0080?eZa0`3D?AT203mJ/@03
0000000oF[40?eZa00@0?eZa00@0e3dI03mJ/@3D?AT0?EV[0P3oD1l2000000040?U8700000000000
000000l0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0B0?ofkP80?EV[4@3om^h00`000000?EV[0?of
kP030?ofkP0303eIZ`3om^h0ooK^01D0ooK^00<0?EV[0?ofkP3om^h05P3om^h00`000000ooK^0?of
kP0g0?ofkP40oooo000i0?ofkP030000003om^h0ooK^01H0ooK^00<0?EV[0?ofkP3om^h05@3om^h0
0`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`000000ooK^0100ooK^0P0mFJ/B0?ofkP0503eIZ`3om^h0
ooK^0?ofkP0mFJ/03`3om^h0100mFJ/000000000000l4@T300000003054H300mFJ/0?eZa0080e3dI
1`0oF[400`000000?eZa0=@m6@0203mJ/@050=@m6@0oF[40?eZa03mJ/@0000001P0oF[40103D?AT0
?eZa03mJ/@00000:03mJ/@030000000oF[40e3dI00L0?eZa00<0000003mJ/@0oF[401@0oF[4I0=@m
6@L0?eZa00<0000003mJ/@0oF[401@0oF[400`3D?AT0?eZa0000000:03mJ/@040000000oF[40?eZa
0=@m6@H0?eZa00D0000003mJ/@0oF[40?eZa0=@m6@0203mJ/@030=@m6@0oF[40000000L0?eZa0P3D
?AT00`0oF[40?EV[0?m@7`03000000040?U870000000000003eIZ`l0ooK^00@0?EV[0?ofkP3om^h0
?EV[4`3om^h203eIZa40ooK^00<0000003eIZ`3om^h00`3om^h00`0mFJ/0ooK^0?ofkP0E0?ofkP03
03eIZ`3om^h0ooK^01H0ooK^00<000000?ofkP3om^h0=`3om^h10?ooo`00>@3om^h00`000000ooK^
0?ofkP0F0?ofkP0303eIZ`3om^h0ooK^01D0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/00000
0?ofkP0@0?ofkP80?EV[4`3om^h0100mFJ/0ooK^0?ofkP0mFJ/?0?ofkP0303eIZ`00000000000080
?1490P0000000`1A60`0?EV[000000020=@m6@L0?eZa00<0000003mJ/@3D?AT00`0oF[420=@m6@03
03mJ/@000000?eZa00D0?eZa00D0e3dI03mJ/@0oF[40?eZa0000000903mJ/@030000000oF[40e3dI
00L0?eZa00<0000003mJ/@0oF[401`0oF[400`000000e3dI03mJ/@0703mJ/@030000000oF[40?eZa
00H0?eZa00<0e3dI0000000oF[40200oF[400`000000?eZa03mJ/@0503mJ/@030=@m6@0oF[400000
00T0?eZa00D0000003mJ/@0oF[40?eZa0=@m6@0603mJ/@040000000oF[40e3dI0=@m6@<0?eZa00<0
e3dI03mJ/@0000001`0oF[420=@m6@030000000mFJ/0oe0O008000000P3iB1`20000000303eIZ`3o
m^h0ooK^00d0ooK^00@0?EV[0?ofkP3om^h0?EV[4`3om^h203eIZa40ooK^00<0000003eIZ`3om^h0
0`3om^h00`0mFJ/0ooK^0?ofkP0E0?ofkP0303eIZ`3om^h0ooK^01H0ooK^00<000000?ofkP3om^h0
=`3om^h10?ooo`00>@3om^h00`000000ooK^0?ofkP0F0?ofkP0303eIZ`3om^h0ooK^01D0ooK^00<0
?EV[0?ofkP3om^h00P3om^h00`0mFJ/000000?ofkP0@0?ofkP80?EV[4`3om^h0100mFJ/0ooK^0?of
kP0mFJ/?0?ofkP0503eIZ`00000000000000000l4@T00`000000100mFJ/0000003mJ/@3D?AT803mJ
/@030000003D?AT0?eZa00@0?eZa00<0e3dI03mJ/@0000001@0oF[401@3D?AT0?eZa03mJ/@0oF[40
000000T0?eZa00<0000003mJ/@3D?AT0200oF[400`000000?eZa03mJ/@0603mJ/@030000003D?AT0
?eZa00L0?eZa00<0000003mJ/@0oF[401P0oF[400`3D?AT0000003mJ/@0703mJ/@030000000oF[40
?eZa00H0?eZa00<0e3dI03mJ/@0000002@0oF[401@000000?eZa03mJ/@0oF[40e3dI00D0?eZa00<0
000003mJ/@3D?AT01@0oF[400`3D?AT0000003mJ/@0703mJ/@040=@m6@0oF[40000003eIZ`<00000
00D0nDPL000000000000000003eIZ`0?0?ofkP0403eIZ`3om^h0ooK^03eIZa<0ooK^0P0mFJ/A0?of
kP030000000mFJ/0ooK^00<0ooK^00<0?EV[0?ofkP3om^h05@3om^h00`0mFJ/0ooK^0?ofkP0F0?of
kP030000003om^h0ooK^03L0ooK^0@3oool003X0ooK^00<000000?ofkP3om^h05@3om^h00`0mFJ/0
ooK^0?ofkP0E0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP000000403om^h203eIZa<0
ooK^00@0?EV[0?ofkP3om^h0?EV[3`3om^h0100mFJ/0000000000000000203`A2@80000000<0?EV[
054H300000000P3D?AT703mJ/@030000003D?AT0?eZa00D0?eZa0P3D?AT503mJ/@050=@m6@0oF[40
?eZa03mJ/@0000002P0oF[400`000000e3dI03mJ/@0703mJ/@030000000oF[40?eZa00H0?eZa00<0
00000=@m6@0oF[401`0oF[400`000000?eZa03mJ/@0603mJ/@030=@m6@000000?eZa00L0?eZa00<0
000003mJ/@0oF[401P0oF[400`3D?AT0000003mJ/@0903mJ/@050000000oF[40?eZa03mJ/@3D?AT0
1@0oF[420=@m6@H0?eZa00<0e3dI0000000oF[401P0oF[420=@m6@030000003oD1l0?EV[00800000
0P3iB1`30000000303eIZ`3om^h0ooK^00d0ooK^00@0?EV[0?ofkP3om^h0?EV[4`3om^h203eIZa00
ooK^00<000000?ofkP0mFJ/0103om^h00`0mFJ/0ooK^0?ofkP0E0?ofkP0303eIZ`3om^h0ooK^01D0
ooK^00<000000?ofkP3om^h0>03om^h10?ooo`00>P3om^h00`000000ooK^0?ofkP0E0?ofkP0303eI
Z`3om^h0ooK^01D0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0000000@0?ofkP80?EV[
4`3om^h0100mFJ/0ooK^0?ofkP0mFJ/?0?ofkP0403eIZ`000000000000000080?14900P00000054H
300mFJ/0DAP<0000003D?AT0?eZa0=@m6@L0?eZa00<0e3dI03mJ/@0oF[401P0oF[420=@m6@0403eI
Z`0oF[40?eZa0=@m6@@0?eZa00<0000003mJ/@0oF[401`0oF[400`000000e3dI03mJ/@0203mJ/@03
03eIZ`0oF[40?eZa0080?eZa00<0000003mJ/@0oF[401P0oF[400`000000e3dI03mJ/@0703mJ/@03
03eIZ`0oF[40?eZa00H0?eZa00<0e3dI0000000oF[401`0oF[400`000000?eZa03mJ/@0203mJ/@06
03eIZ`0oF[40?eZa03mJ/@3D?AT000002@0oF[400`000000?eZa03mJ/@0203mJ/@040=@m6@0oF[40
?eZa03mJ/@80e3dI200oF[400`3D?AT0?eZa03mJ/@0503mJ/@080=@m6@0oF[40e3dI0000003oD1l0
?EV[0?m@7`0000020?U870<0000000<0?EV[0?ofkP3om^h03@3om^h0100mFJ/0ooK^0?ofkP0mFJ/C
0?ofkP80?EV[403om^h00`000000ooK^03eIZ`040?ofkP0303eIZ`3om^h0ooK^01D0ooK^00<0?EV[
0?ofkP3om^h05@3om^h00`000000ooK^0?ofkP0h0?ofkP40oooo000j0?ofkP030000003om^h0ooK^
01D0ooK^H`0mFJ/010000000e3dI0000003D?AT6000000030=@m6@000000000000P0000000@0e3dI
000000000000e3dI3`0000000`3D?AT000000000000@000000030=@m6@000000000000l0000000<0
e3dI0000000000003`0000000`3D?AT000000000000>000000040=@m6@00000000000=@m6@X00000
00<0e3dI00000000000010000000103D?AT0000000000000001S03eIZaL0ooK^00<000000?ofkP3o
m^h0>03om^h10?ooo`00>`3om^h00`000000ooK^0?ofkP0D0?ofkP0303eIZ`3om^h0ooK^01D0ooK^
00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0000000@0?ofkP80?EV[4`3om^h0100mFJ/0ooK^
0?ofkP0mFJ/?0?ofkP0303eIZ`00000000000080000000H0?149000000000000?EV[0000001A60`2
00000080@Uji00<0e3dI049N^@12G[T01012G[T00`3D?AT0@Uji049N^@05049N^@0300000012G[T0
@Uji00<0e3dI1012G[T00`000000@Uji049N^@07049N^@0300000012G[T0e3dI00L0@Uji00<00000
049N^@12G[T01P12G[T00`000000e3dI049N^@07049N^@0300000012G[T0@Uji00H0@Uji00<0e3dI
00000012G[T01`12G[T00`000000@Uji049N^@05049N^@030=@m6@12G[T0000000T0@Uji00<00000
049N^@12G[T00P12G[T30=@m6@80@Uji00<00000049N^@12G[T01@12G[T00`3D?AT0@Uji049N^@04
049N^@030=@m6@12G[T0@Uji0080000000<0oe0O0000000mFJ/00P0000001P3iB1`0000000000000
0000ooK^03eIZ`l0ooK^00@0?EV[0?ofkP3om^h0?EV[4`3om^h203eIZa00ooK^00<000000?ofkP0m
FJ/0103om^h00`0mFJ/0ooK^0?ofkP0E0?ofkP0303eIZ`3om^h0ooK^01@0ooK^00<000000?ofkP3o
m^h0>@3om^h10?ooo`00>`3om^h00`000000ooK^0?ofkP0D0?ofkP0303eIZ`3om^h0ooK^01D0ooK^
00<0?EV[0?ofkP3om^h00P3om^hm03eIZ`8000000P0l4@T20000000303eIZ`000000DAP<00800000
0`12G[T00`3D?AT0@Uji049N^@03049N^@030=@m6@12G[T0@Uji00H0@Uji00@00000049N^@12G[T0
@Uji0P3D?AT4049N^@0300000012G[T0@Uji00H0@Uji00<00000049N^@3D?AT01`12G[T00`000000
@Uji049N^@06049N^@030000003D?AT0@Uji00L0@Uji00<00000049N^@12G[T01P12G[T00`3D?AT0
0000049N^@07049N^@0300000012G[T0@Uji00D0@Uji00<0e3dI049N^@0000002012G[T00`000000
@Uji049N^@02049N^@80e3dI0`12G[T00`000000@Uji049N^@06049N^@030=@m6@12G[T0@Uji00<0
@Uji00@0e3dI049N^@12G[T0@Uji0P0000001@3oD1l0000003eIZ`3oD1l000000080nDPL0P00000m
03eIZ`@0ooK^00<0?EV[0?ofkP3om^h05@3om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP030000003om^h0
ooK^03T0ooK^0@3oool003/0ooK^00<000000?ofkP3om^h0503om^h00`0mFJ/0ooK^0?ofkP0E0?of
kP0303eIZ`3om^h0ooK^0080ooK^00@0?EV[0?ofkP3om^h000003`3om^h203eIZa<0ooK^00@0?EV[
0?ofkP3om^h0?EV[3`3om^h00`0mFJ/0ooK^0000000400000007054H300mFJ/0DAP<054H30000000
KR8@00000003049N^@030=@m6@12G[T0@Uji0080@Uji00<0e3dI00000012G[T01P12G[T01P000000
@Uji049N^@12G[T0e3dI049N^@<0e3dI00<0@Uji00000012G[T02012G[T00`000000e3dI049N^@06
049N^@0300000012G[T0@Uji00H0@Uji00<000000=@m6@12G[T01`12G[T00`000000@Uji049N^@06
049N^@030=@m6@000000@Uji00L0@Uji00<00000049N^@12G[T01@12G[T00`3D?AT00000049N^@08
049N^@0300000012G[T0e3dI0080e3dI00<0@Uji0=@m6@12G[T00P12G[T00`000000@Uji049N^@05
049N^@030000003D?AT0@Uji00<0@Uji00L0e3dI049N^@12G[T0@Uji0000003oEB8000000080oe0O
00<0?EV[0?m@7`0000000`0000000`3;>QH0ooK^03eIZ`0?0?ofkP0403eIZ`3om^h0ooK^03eIZa<0
ooK^0P0mFJ/?0?ofkP040000003om^h0ooK^03eIZ`@0ooK^00<0?EV[0?ofkP3om^h05@3om^h00`0m
FJ/0ooK^0?ofkP0D0?ofkP030000003om^h0ooK^03T0ooK^0@3oool003`0ooK^00<000000?ofkP3o
m^h04`3om^h00`0mFJ/0ooK^0?ofkP0E0?ofkP0303eIZ`3om^h0ooK^0080ooK^00@0?EV[0?ofkP3o
m^h000003`3om^h203eIZa<0ooK^00@0?EV[0?ofkP3om^h0?EV[3`3om^h00`0mFJ/0ooK^00000004
00000003054H300mFJ/0DAP<0080000000<0KR8@00000012G[T00`12G[T01P3D?AT0@Uji049N^@12
G[T0e3dI000000P0@Uji00@00000049N^@12G[T0e3dI1012G[T30=@m6@P0@Uji00<000000=@m6@12
G[T01`12G[T00`000000@Uji049N^@05049N^@030000003D?AT0@Uji00L0@Uji00<00000049N^@12
G[T01P12G[T00`3D?AT00000049N^@06049N^@0300000012G[T0@Uji00H0@Uji00<0e3dI00000012
G[T01`12G[T30=@m6@@0@Uji00@0e3dI049N^@12G[T000002012G[T00`000000e3dI049N^@02049N
^@030=@m6@12G[T0@Uji0080@Uji00<000000?mE8P0000000P0000000`0mFJ/0oe0O000000040000
00030?ofkP0mFJ/0ooK^00h0ooK^00@0?EV[0?ofkP3om^h0?EV[4`3om^h203eIZ`l0ooK^00@00000
0?ofkP3om^h0?EV[103om^h00`0mFJ/0ooK^0?ofkP0E0?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0
00000?ofkP3om^h0>P3om^h10?ooo`00?03om^h00`000000ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0
ooK^01D0ooK^00<0?EV[0?ofkP3om^h00P3om^h0100mFJ/0ooK^0?ofkP00000?0?ofkP80?EV[4`3o
m^h0100mFJ/0ooK^0?ofkP0mFJ/?0?ofkP0<03eIZ`3om^h000000=@m6@000000?1490000001A60`0
?EV[0000001A60`000000P1^8Q000`000000@Uji049N^@02049N^@060=@m6@12G[T0@Uji0=@m6@12
G[T000001`12G[T010000000@Uji049N^@3D?AT6049N^@030000003D?AT0e3dI00H0@Uji00<00000
0=@m6@12G[T01`12G[T00`000000@Uji049N^@05049N^@030000003D?AT0@Uji00L0@Uji00<00000
049N^@12G[T01P12G[T00`3D?AT00000049N^@06049N^@0300000012G[T0@Uji00H0@Uji00<0e3dI
00000012G[T01@12G[T20=@m6@0300000012G[T0@Uji00@0@Uji00@0e3dI049N^@12G[T000001`12
G[T00`000000@Uji0=@m6@02049N^@030=@m6@12G[T0@Uji0080@Uji00l000000?mE8P3oEB800000
0?m@7`000000?EV[0?m@7`000000nDPL0000003D?AT000000?ofkP0mFJ/03`3om^h0100mFJ/0ooK^
0?ofkP0mFJ/C0?ofkP80?EV[3`3om^h010000000ooK^0?ofkP0mFJ/40?ofkP0303eIZ`3om^h0ooK^
01D0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`000000ooK^0?ofkP0j0?ofkP40oooo000l0?ofkP03
0000003om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h05@3om^h00`0mFJ/0ooK^0?ofkP020?ofkP04
03eIZ`3om^h0ooK^000000l0ooK^0P0mFJ/C0?ofkP0403eIZ`3om^h0ooK^03eIZ`l0ooK^00@0?EV[
0?ofkP000000e3dI0`0000001@1A60`0?EV[0000001A60`0000000<0KR8@00<00000049N^@12G[T0
0P12G[T01@3D?AT0@Uji0=@m6@12G[T0000000P0@Uji00<00000049N^@3D?AT01P12G[T00`000000
@Uji049N^@030=@m6@<0@Uji00<000000=@m6@12G[T01`12G[T00`000000@Uji049N^@05049N^@03
0000003D?AT0@Uji00L0@Uji00<00000049N^@12G[T01P12G[T00`3D?AT00000049N^@06049N^@03
00000012G[T0@Uji00H0@Uji00<0e3dI00000012G[T00P12G[T30=@m6@80@Uji00<00000049N^@12
G[T01012G[T00`3D?AT0@Uji00000008049N^@0500000012G[T0e3dI049N^@3D?AT01012G[T01000
0000oeDR0?mE8P3oEB82000000030?m@7`0mFJ/0oe0O00<0000000@0e3dI0000003om^h0?EV[3`3o
m^h0100mFJ/0ooK^0?ofkP0mFJ/C0?ofkP80?EV[3`3om^h010000000ooK^0?ofkP0mFJ/40?ofkP03
03eIZ`3om^h0ooK^01D0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`000000ooK^0?ofkP0j0?ofkP40
oooo000m0?ofkP030000003om^h0ooK^0180ooK^00<0?EV[0?ofkP3om^h05@3om^h00`0mFJ/0ooK^
0?ofkP020?ofkP0503eIZ`3om^h0ooK^0?ofkP0000003P3om^h203eIZa<0ooK^00@0?EV[0?ofkP3o
m^h0?EV[3`3om^h0100mFJ/0ooK^0000003D?AT40000000303eIZ`1A60`00000008000000P1^8Q00
0`000000@Uji049N^@03049N^@80e3dI0P12G[T00`000000@Uji049N^@05049N^@0300000012G[T0
e3dI00L0@Uji00<00000049N^@12G[T00P12G[T30=@m6@03049N^@3D?AT0@Uji00L0@Uji00<00000
049N^@12G[T01P12G[T00`3D?AT0@Uji049N^@06049N^@0300000012G[T0@Uji00H0@Uji00<0e3dI
049N^@12G[T01P12G[T00`000000@Uji049N^@06049N^@030=@m6@12G[T0e3dI0080e3dI1012G[T0
0`000000@Uji049N^@05049N^@030=@m6@12G[T0000000L0@Uji00<00000049N^@12G[T00P3D?AT5
049N^@030000003oEB80oeDR00<0000000<0oe0O03eIZ`0000000`000000103D?AT000000?ofkP0m
FJ/?0?ofkP0403eIZ`3om^h0ooK^03eIZa<0ooK^0P0mFJ/>0?ofkP050000003om^h0ooK^0?ofkP0m
FJ/0103om^h00`0mFJ/0ooK^0?ofkP0E0?ofkP0303eIZ`3om^h0ooK^0180ooK^00<000000?ofkP3o
m^h0>`3om^h10?ooo`00?@3om^h00`000000ooK^0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^01D0ooK^
00<0?EV[0?ofkP3om^h00P3om^h01@0mFJ/0ooK^0?ofkP3om^h0000000h0ooK^0P0mFJ/C0?ofkP04
03eIZ`3om^h0ooK^03eIZ`l0ooK^00H0?EV[0?ofkP3om^h0:0/50000003D?AT20000000303eIZ`1A
60`00000008000000`1^8Q000`000000@Uji049N^@03049N^@040=@m6@12G[T0@Uji000000P0@Uji
00<000000=@m6@12G[T01P12G[T00`000000@Uji049N^@05049N^@@0e3dI1P12G[T00`000000@Uji
049N^@06049N^@030=@m6@12G[T0@Uji00H0@Uji00<00000049N^@12G[T01P12G[T00`3D?AT0@Uji
049N^@06049N^@0300000012G[T0@Uji00@0@Uji103D?AT7049N^@0300000012G[T0@Uji00D0@Uji
00<0e3dI00000012G[T01`12G[T010000000@Uji049N^@3D?AT5049N^@060000003oEB80oeDR0000
003oEB8000000P3oD1l01P0mFJ/000000000003D?AT000000</j5P80ooK^00<0?EV[0?ofkP3om^h0
3@3om^h0100mFJ/0ooK^0?ofkP0mFJ/C0?ofkP80?EV[3P3om^h01@000000ooK^0?ofkP3om^h0?EV[
00@0ooK^00<0?EV[0?ofkP3om^h05@3om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP030000003om^h0ooK^
03/0ooK^0@3oool003d0ooK^00<000000?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP03
03eIZ`3om^h0ooK^0080ooK^00D0?EV[0?ofkP3om^h0ooK^0000000>0?ofkP80?EV[4P3om^h01@0m
FJ/0ooK^0?ofkP3om^h0?EV[00l0ooK^00<0?EV[0?ofkP3om^h00P000000100l4@T00000054H300m
FJ/2054H30030=@m6@000000000000<0KR8@00<00000049N^@12G[T00P12G[T30=@m6@03049N^@00
0000@Uji00H0@Uji00<000000=@m6@12G[T01P12G[T00`000000@Uji049N^@06049N^@030=@m6@12
G[T0@Uji00H0e3dI00<00000049N^@12G[T01P12G[T00`3D?AT0@Uji049N^@06049N^@0300000012
G[T0@Uji00H0@Uji00<0e3dI049N^@12G[T01P12G[T00`000000e3dI0=@m6@040=@m6@80@Uji00<0
e3dI049N^@12G[T01P12G[T00`000000@Uji049N^@04049N^@030=@m6@12G[T0000000L0@Uji00<0
0000049N^@3D?AT00P3D?AT4049N^@040000003oEB80oeDR0?mE8P80000000@0e3dI0?m@7`3oD1l0
?EV[0P0000000`3iB1`00000000000020?ofkP0303eIZ`3om^h0ooK^00d0ooK^00@0?EV[0?ofkP3o
m^h0?EV[4`3om^h203eIZ`h0ooK^00D000000?ofkP3om^h0ooK^03eIZ`040?ofkP0303eIZ`3om^h0
ooK^01@0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`000000ooK^0?ofkP0k0?ofkP40oooo000n0?of
kP030000003om^h0ooK^0180ooK^00<0?EV[0?ofkP3om^h0503om^h00`0mFJ/0ooK^0?ofkP020?of
kP0503eIZ`3om^h0ooK^0?ofkP0000003P3om^h203eIZa80ooK^00D0?EV[0?ofkP3om^h0ooK^03eI
Z`0?0?ofkP0303eIZ`3om^h0ooK^00D0000000<0?EV[0000001A60`00P0000001@1^8Q00000006hR
401^8Q00000000@0@Uji00<0e3dI049N^@12G[T00P3D?AT8049N^@030000003D?AT0@Uji00H0@Uji
00<00000049N^@12G[T01@12G[T00`3D?AT0@Uji049N^@06049N^@H0e3dI0`12G[T00`3D?AT0@Uji
049N^@06049N^@0300000012G[T0@Uji00H0@Uji00@0e3dI049N^@12G[T0@Uji1P3D?AT8049N^@03
0=@m6@12G[T0@Uji00D0@Uji00<00000049N^@12G[T01@12G[T00`3D?AT00000049N^@07049N^@80
e3dI0P12G[T00`3D?AT0@Uji049N^@02049N^@060000003oEB80oeDR0000003oEB8000000P3oD1l0
0`000000?EV[0000000400000080ooK^00<0?EV[0?ofkP3om^h03@3om^h01@0mFJ/0ooK^0?ofkP3o
m^h0?EV[0180ooK^0P0mFJ/>0?ofkP050000003om^h0ooK^0?ofkP0mFJ/0103om^h00`0mFJ/0ooK^
0?ofkP0D0?ofkP0303eIZ`3om^h0ooK^0180ooK^00<000000?ofkP3om^h0?03om^h10?ooo`00?P3o
m^h00`000000ooK^0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^01@0ooK^00<0?EV[0?ofkP3om^h00P3o
m^h00`0mFJ/0ooK^0?ofkP020?ofkP030000003om^h0ooK^00/0ooK^0P0mFJ/B0?ofkP0503eIZ`3o
m^h0ooK^0?ofkP0mFJ/03`3om^h00`0mFJ/0ooK^0?ofkP030000000403`A2@000000?EV[00000080
DAP<00@0000006hR401^8Q0000000P1^8Q001@000000@Uji049N^@12G[T0e3dI00@0@Uji0P3D?AT6
049N^@030000003D?AT0@Uji00H0@Uji00<00000049N^@12G[T01@12G[T00`3D?AT00000049N^@07
049N^@0300000012G[T0@Uji0080@Uji6@3D?AT4049N^@0300000012G[T0@Uji00H0@Uji00<00000
0=@m6@12G[T01P12G[T00`000000@Uji049N^@05049N^@030=@m6@000000@Uji00D0@Uji0P3D?AT4
049N^@050=@m6@12G[T0@Uji049N^@0000000P3oEB8010000000oeDR0?mE8P0000020?m@7`040000
000mFJ/000000?U870<000000P3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0503eIZ`3om^h0ooK^0?of
kP0mFJ/04P3om^h203eIZ`d0ooK^00<000000?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP020?of
kP0303eIZ`3om^h0ooK^01@0ooK^00<0?EV[0?ofkP3om^h04P3om^h00`000000ooK^0?ofkP0l0?of
kP40oooo000n0?ofkP030000003om^h0ooK^0180ooK^00<0?EV[0?ofkP3om^h0503om^h00`0mFJ/0
ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^0080ooK^00<000000?ofkP3om^h02`3om^h203eIZa80
ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0?0?ofkP0303eIZ`3om^h0ooK^0080000000L0?1490000
00000000?EV[054H30000000DAP<0080000000D0KR8@0000001^8Q00KR8@00000003049N^@030=@m
6@12G[T0@Uji0080@Uji00<00000049N^@3D?AT01P12G[T00`3D?AT0@Uji049N^@06049N^@030000
0012G[T0@Uji00@0@Uji00<0e3dI00000012G[T01`12G[T00`000000@Uji049N^@05049N^@030=@m
6@12G[T0@Uji00H0@Uji00<00000049N^@12G[T01P12G[T00`3D?AT0@Uji049N^@05049N^@030000
0012G[T0@Uji00H0@Uji00<000000=@m6@12G[T01@12G[T00`000000@Uji049N^@06049N^@030=@m
6@12G[T0@Uji00@0@Uji00<0e3dI049N^@0000000`12G[T00`3D?AT0@Uji049N^@02049N^@030000
003oEB8000000080oeDR0P000000103oD1l000000?m@7`0mFJ/2000000030?U87000000000000080
ooK^00<0?EV[0?ofkP3om^h03@3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[0180ooK^0P0mFJ/=0?of
kP030000003om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP0D0?of
kP0303eIZ`3om^h0ooK^0180ooK^00<000000?ofkP3om^h0?03om^h10?ooo`00?`3om^h00`000000
ooK^0?ofkP0A0?ofkP0303eIZ`3om^h0ooK^01@0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0
ooK^0?ofkP020?ofkP030000003om^h0ooK^00/0ooK^0P0mFJ/B0?ofkP0503eIZ`3om^h0ooK^0?of
kP0mFJ/03`3om^h00`0mFJ/0ooK^0?ofkP020000000703`A2@000000000003eIZ`1A60`00000054H
300200000080KR8@00<0000006hR401^8Q00100000000`3D?AT000000000000400000080e3dI1000
00000`3D?AT000000000000=000000030=@m6@000000000000l0000000<0e3dI0000000000003`00
00000`3D?AT000000000000?000000030=@m6@000000000000d0000000<0e3dI0000000000000P00
00020=@m6@H0000000<0e3dI0000000000000P0000020?mE8P030000003oEB80oeDR0080000000@0
oe0O0000003oD1l0?EV[0P0000000`3iB1`00000000000020?ofkP0303eIZ`3om^h0ooK^00d0ooK^
00D0?EV[0?ofkP3om^h0ooK^03eIZ`0B0?ofkP80?EV[3@3om^h00`000000ooK^0?ofkP020?ofkP03
03eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h0503om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP03
0000003om^h0ooK^03d0ooK^0@3oool003l0ooK^00<000000?ofkP3om^h04@3om^h00`0mFJ/0ooK^
0?ofkP0D0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h00P3om^h00`000000ooK^
0?ofkP0;0?ofkP80?EV[4P3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00l0ooK^00<0?EV[0?ofkP3o
m^h00P000000100l4@T000000000000mFJ/2054H3080000000H0KR8@0000001^8Q00KR8@0000001^
8Q0200000080A6;100<0e3dI04AR`@14H/400`14H/400`000000A6;104AR`@020=@m6@80A6;100<0
e3dI00000014H/401P14H/400`000000A6;104AR`@0404AR`@030=@m6@000000A6;100L0A6;100<0
000004AR`@14H/401@14H/400`3D?AT0A6;104AR`@0604AR`@0300000014H/40A6;100H0A6;100<0
e3dI04AR`@14H/401@14H/400`000000A6;104AR`@0604AR`@030000003D?AT0A6;100D0A6;100<0
000004AR`@14H/401@14H/4010000000e3dI04AR`@14H/420=@m6@80A6;100<0000004AR`@14H/40
0`14H/400`3D?AT0A6;104AR`@02000000040?mE8P000000oeDR0?mE8P80000000D0oe0O0000003o
D1l0oe0O03eIZ`02000000030?U870000000ooK^0080ooK^00<0?EV[0?ofkP3om^h03@3om^h01@0m
FJ/0ooK^0?ofkP3om^h0?EV[0180ooK^0P0mFJ/=0?ofkP030000003om^h0ooK^0080ooK^00<0?EV[
0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP0303eIZ`3om^h0ooK^0140ooK^00<00000
0?ofkP3om^h0?@3om^h10?ooo`00?`3om^h00`000000ooK^0?ofkP0A0?ofkP0303eIZ`3om^h0ooK^
01@0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP030000003om^h0ooK^
00/0ooK^0P0mFJ/B0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/03`3om^h01@0mFJ/0ooK^0?ofkP3o
m^h000000080?14900<0000003eIZ`0000000P1A60`20000000406hR40000000KR8@06hR40800000
00@0UBhE00000014H/40e3dI1@14H/400`000000A6;104AR`@0204AR`@<0e3dI00<0000004AR`@14
H/401P14H/400`000000A6;104AR`@0304AR`@030=@m6@14H/40000000L0A6;100<0000004AR`@14
H/401@14H/400`3D?AT0A6;104AR`@0604AR`@0300000014H/40A6;100H0A6;100<0e3dI04AR`@14
H/401@14H/400`000000A6;104AR`@0504AR`@030000003D?AT0A6;100D0A6;100<0000004AR`@14
H/401P14H/4010000000e3dI0=@m6@3D?AT404AR`@0300000014H/40A6;100<0A6;100@0e3dI04AR
`@000000oeHS0P0000020?mE8P040000003oEB80000000000080oe0O00H0000003eIZ`3D?AT0nDPL
0000003D?AT30?ofkP0303eIZ`3om^h0ooK^00d0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0B0?of
kP80?EV[3@3om^h00`000000ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?of
kP3om^h0503om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP030000003om^h0ooK^03d0ooK^0@3oool00400
ooK^00<000000?ofkP3om^h0403om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP0303eIZ`3om^h0ooK^0080
ooK^?`0mFJ/20000000403`A2@000000?EV[00000080DAP<0P0000002P1^8Q00000006hR401^8Q00
000006hR40000000UBhE0000003D?AT604AR`@0300000014H/40A6;100<0A6;10P3D?AT00`000000
A6;104AR`@0504AR`@0300000014H/40A6;100@0A6;100<0e3dI00000014H/401`14H/400`000000
A6;104AR`@0404AR`@030=@m6@14H/40A6;100H0A6;100<0000004AR`@14H/401P14H/400`3D?AT0
A6;104AR`@0404AR`@0300000014H/40A6;100H0A6;100<000000=@m6@14H/401@14H/400`000000
A6;104AR`@0504AR`@030000003D?AT0e3dI00D0A6;100<0000004AR`@14H/401014H/400`3D?AT0
00000?mF8`02000000<0oeDR00@000000?mE8P00000000000P3oD1l010000000?EV[0000003iB1`2
000003l0?EV[103om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP0303eIZ`3om^h0ooK^0100ooK^00<00000
0?ofkP3om^h0?P3om^h10?ooo`00@03om^h00`000000ooK^0?ofkP0@0?ofkVh0?EV[00<0e3dI04AR
`@14H/401@14H/400`000000A6;104AR`@0204AR`@030=@m6@14H/40e3dI0080e3dI1P14H/400`00
0000A6;104AR`@0304AR`@030=@m6@14H/40000000L0A6;100<0000004AR`@14H/401014H/400`3D
?AT0000004AR`@0604AR`@0300000014H/40A6;100D0A6;100<000000=@m6@14H/401@14H/400`00
0000A6;104AR`@0504AR`@0300000014H/40e3dI00D0A6;100<0000004AR`@14H/401014H/430=@m
6@0304AR`@3D?AT0A6;100<0A6;100<0000004AR`@14H/401@14H/400`3D?AT0?EV[03eIZ`1/03eI
Za80ooK^00<000000?ofkP3om^h0?P3om^h10?ooo`00@03om^h00`000000ooK^0?ofkP0@0?ofkP03
03eIZ`3om^h0ooK^01@0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP03
0000003om^h0ooK^00X0ooK^0P0mFJ/B0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/03`3om^h02@0m
FJ/0ooK^0?ofkP3om^h000000=@m6@000000?14903eIZ`02054H30040000001A60`0000000000080
KR8@00@0000006hR401^8Q0000000P2E;QD00`000000A6;104AR`@0504AR`@0300000014H/40A6;1
0080A6;100D0e3dI04AR`@14H/40000004AR`@030=@m6@<0A6;100<0000004AR`@14H/400`14H/40
0`3D?AT0A6;10000000704AR`@0300000014H/40A6;100@0A6;100<0e3dI00000014H/401P14H/40
0`000000A6;104AR`@0504AR`@030000003D?AT0A6;100D0A6;100<0000004AR`@14H/401@14H/40
0`000000A6;10=@m6@0504AR`@0400000014H/40A6;104AR`@<0e3dI00D0A6;100000014H/40A6;1
0=@m6@0404AR`@0300000014H/40A6;100D0A6;100@000000?mF8`3oER<000000P3oEB800`000000
oeDR0?mE8P02000000090?m@7`000000oe0O0?m@7`0mFJ/0nDPL0000003D?AT0000000<0ooK^00<0
?EV[0?ofkP3om^h03@3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[0180ooK^0P0mFJ/<0?ofkP030000
003om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP0303eI
Z`3om^h0ooK^0100ooK^00<000000?ofkP3om^h0?P3om^h10?ooo`00@03om^h00`000000ooK^0?of
kP0@0?ofkP0303eIZ`3om^h0ooK^01@0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?of
kP030?ofkP030000003om^h0ooK^00X0ooK^0P0mFJ/B0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/0
3`3om^h0100mFJ/0ooK^0?ofkP3om^h30000000603`A2@0mFJ/00000054H30000000DAP<0P000002
06hR40030000001^8Q00KR8@008000000P2E;QD00`000000A6;104AR`@0504AR`@0500000014H/40
A6;104AR`@3D?AT00`14H/4010000000A6;104AR`@14H/420=@m6@80A6;100<0000004AR`@14H/40
0P14H/400`3D?AT0A6;10000000704AR`@0300000014H/40A6;100@0A6;100<0e3dI00000014H/40
1P14H/400`000000A6;104AR`@0504AR`@030000003D?AT0A6;100D0A6;100<0000004AR`@14H/40
1@14H/400`000000A6;10=@m6@0404AR`@0300000014H/40A6;10080e3dI0`14H/401@000000A6;1
04AR`@14H/40e3dI00<0A6;100<0000004AR`@14H/401@14H/400`000000oeHS0?mF8`0200000080
oeDR00<000000?mE8P3oEB800P0000001`3oD1l000000?m@7`000000?EV[0000003iB1`00P000003
0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0B0?ofkP80?EV[303o
m^h00`000000ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h0503o
m^h00`0mFJ/0ooK^0?ofkP0@0?ofkP030000003om^h0ooK^03h0ooK^0@3oool00440ooK^00<00000
0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[
0?ofkP3om^h0103om^h00`000000ooK^0?ofkP090?ofkP80?EV[4P3om^h01@0mFJ/0ooK^0?ofkP3o
m^h0?EV[00l0ooK^00@0?EV[0?ofkP3om^h0ooK^0P000000100l4@T0000003eIZ`000002054H3080
000000T0KR8@0000001^8Q00KR8@0000001^8Q00000009D^5@0000000P2E;QD00`000000A6;104AR
`@0504AR`@0400000014H/40A6;10=@m6@<0A6;100<0000004AR`@14H/400`14H/430=@m6@@0A6;1
00@0e3dI04AR`@14H/4000001`14H/400`000000A6;104AR`@0304AR`@030=@m6@000000A6;100H0
A6;100<0000004AR`@14H/401@14H/400`000000e3dI04AR`@0404AR`@0300000014H/40A6;100D0
A6;100@0000004AR`@14H/40e3dI1014H/430=@m6@D0A6;100D0000004AR`@14H/40A6;10=@m6@02
04AR`@0300000014H/40A6;100D0A6;100P000000?mF8`3oER<000000?mF8`000000oeDR00000080
oeDR00@000000?mE8P00000000000P3oD1l01@000000?EV[0000003D?AT0000000@0ooK^00<0?EV[
0?ofkP3om^h03@3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[0180ooK^0P0mFJ/;0?ofkP030000003o
m^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP0303eIZ`3o
m^h0ooK^00l0ooK^00<000000?ofkP3om^h0?`3om^h10?ooo`00@@3om^h00`000000ooK^0?ofkP0?
0?ofkP0303eIZ`3om^h0ooK^01@0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP04
0?ofkP030000003om^h0ooK^00T0ooK^0P0mFJ/B0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/03`3o
m^h00`0mFJ/0ooK^0?ofkP020?ofkP070000003D?AT0000003eIZ`1A60`00000054H300200000080
KR8@00L0000006hR401^8Q00KR8@0000002E;QD0000000<0UBhE00<0000004AR`@14H/401@14H/40
0`000000A6;10=@m6@0404AR`@0300000014H/40A6;100D0A6;10`3D?AT01@14H/40e3dI04AR`@14
H/40000000L0A6;100<0000004AR`@14H/400`14H/400`3D?AT0000004AR`@0604AR`@0300000014
H/40A6;100D0A6;100<000000=@m6@14H/401014H/400`000000A6;104AR`@0504AR`@0500000014
H/40A6;10=@m6@14H/400`3D?AT704AR`@0300000014H/40A6;10080A6;100<0e3dI04AR`@000000
1`14H/4010000000oeHS0?mF8`0000020?mF8`050000003oEB80oeDR0?mE8P0000000P3oEB820000
00070?m@7`000000000003eIZ`3iB1`0e3dI000000040?ofkP0303eIZ`3om^h0ooK^00d0ooK^00D0
?EV[0?ofkP3om^h0ooK^03eIZ`0B0?ofkP80?EV[2`3om^h00`000000ooK^0?ofkP040?ofkP0303eI
Z`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h0503om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP030000
003om^h0ooK^03l0ooK^0@3oool00440ooK^00<000000?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?of
kP0D0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h0103om^h00`000000ooK^0?of
kP090?ofkP80?EV[4P3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00l0ooK^00<0?EV[0?ofkP3om^h0
0P3om^h20000000403`A2@0mFJ/0000000000080DAP<00H0000006hR401^8Q00KR8@0000001^8Q02
00000080UBhE00D0000009D^5@2E;QD0UBhE0000000404AR`@0503eIZ`14H/40000004AR`@3D?AT0
1@14H/400`000000A6;104AR`@0404AR`@0300000014H/40A6;100@0e3dI00<0000004AR`@14H/40
1@14H/400`000000A6;104AR`@0304AR`@030=@m6@000000A6;100H0A6;100<0000004AR`@14H/40
1@14H/400`000000e3dI04AR`@0404AR`@0300000014H/40A6;100D0A6;100<000000=@m6@3D?AT0
0P3D?AT204AR`@0300000014H/40A6;100@0A6;100<0000004AR`@14H/400`14H/400`3D?AT0A6;1
0000000604AR`@050000003oER<0oeHS0?mF8`0000000P3oER<2000000030?mE8P000000oeDR0080
oeDR00<000000?m@7`3oD1l00P000000100mFJ/0nDPL0000000000040?ofkP0303eIZ`3om^h0ooK^
00d0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0B0?ofkP80?EV[2`3om^h00`000000ooK^0?ofkP04
0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h0503om^h00`0mFJ/0ooK^0?ofkP0?
0?ofkP030000003om^h0ooK^03l0ooK^0@3oool00480ooK^00<000000?ofkP3om^h03P3om^h00`0m
FJ/0ooK^0?ofkP0D0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/01`3om^h00`000000ooK^0?ofkP09
0?ofkP0303eIZ`3om^h0ooK^0140ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0?0?ofkP0303eIZ`3o
m^h0ooK^0080ooK^0P0000001P0l4@T0?EV[0000001A60`00000054H308000000P1^8Q0010000000
KR8@06hR4000000309D^5@040000002E;QD0UBhE000000L0A6;100<000000=@m6@14H/401014H/40
0`000000A6;104AR`@0504AR`@0600000014H/40A6;10=@m6@14H/40?EV[1P3D?AT204AR`@030000
0014H/40A6;100<0A6;100<0e3dI04AR`@0000001P14H/400`000000A6;104AR`@0404AR`@030000
0014H/40e3dI00D0A6;100<0000004AR`@14H/401P3D?AT204AR`@040=@m6@14H/40A6;1000000L0
A6;100<0000004AR`@14H/400P14H/400`3D?AT0A6;10000000704AR`@040000003oER<0oeHS0000
00<0oeHS00@000000?mE8P3oEB8000000P3oEB82000000060?m@7`000000oe0O0000000mFJ/0e3dI
0P0000040?ofkP0303eIZ`3om^h0ooK^00d0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0B0?ofkP80
?EV[2`3om^h00`000000ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3o
m^h0503om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP030000003om^h0ooK^0400ooK^0@3oool00480ooK^
00<000000?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP0503eIZ`3om^h0ooK^0?ofkP0m
FJ/0203om^h00`000000ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^0140ooK^00D0?EV[0?ofkP3o
m^h0ooK^03eIZ`0?0?ofkP0303eIZ`3om^h0ooK^0080ooK^0P0000000`3D?AT0?EV[00000002054H
3080000000H0KR8@0000001^8Q00KR8@0000001^8Q02000000<0UBhE00@0000009D^5@2E;QD00000
1`14H/400`000000e3dI04AR`@0404AR`@0300000014H/40A6;100@0A6;100@0000004AR`@14H/40
e3dI0`14H/400`000000A6;104AR`@0204AR`@H0e3dI0P14H/400`3D?AT0A6;10000000604AR`@03
00000014H/40A6;100@0A6;100<0000004AR`@3D?AT00P14H/460=@m6@@0A6;100D0000004AR`@14
H/40A6;10=@m6@0204AR`@0300000014H/40A6;100@0A6;100<0000004AR`@14H/400`14H/400`3D
?AT0000004AR`@0604AR`@040000003oER<0oeHS000000<0oeHS0P0000001P3oEB8000000?mE8P3o
EB8000000?mE8P8000000P3oD1l00`000000?EV[0=@m6@02000000@0ooK^00<0?EV[0?ofkP3om^h0
3@3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[01<0ooK^00<0?EV[0?ofkP3om^h0203om^h00`000000
ooK^0?ofkP060?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/05P3om^h00`0mFJ/0ooK^0?ofkP0>0?of
kP030000003om^h0ooK^0400ooK^0@3oool00480ooK^00<000000?ofkP3om^h03P3om^h00`0mFJ/0
ooK^0?ofkP0D0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/0203om^h00`000000ooK^0?ofkP080?of
kP0303eIZ`3om^h0ooK^0140ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0?0?ofkP0303eIZ`3om^h0
ooK^0080ooK^0`000000100mFJ/000000000001A60`20000000306hR40000000KR8@0080KR8@0P00
00000`2E;QD0000009D^5@0209D^5@040000002E;QD0UBhE000000H0A6;100<000000=@m6@14H/40
1014H/400`000000A6;104AR`@0504AR`@0300000014H/40e3dI00@0A6;100<0000004AR`@14H/40
1014H/400`000000A6;104AR`@0G0=@m6@80A6;100<0000004AR`@14H/401014H/400`000000A6;1
04AR`@0204AR`@030=@m6@14H/40000000L0A6;100<0000004AR`@14H/400`14H/400`3D?AT00000
04AR`@0504AR`@040000003oER<0oeHS000000<0oeHS00@000000?mF8`00000000000`3oEB820000
00030?m@7`000000oe0O0080000000@0?EV[0000000000000000103om^h00`0mFJ/0ooK^0?ofkP0=
0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/04P3om^h203eIZ`X0ooK^00<000000?ofkP3om^h01P3o
m^h0100mFJ/0ooK^0?ofkP0mFJ/F0?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<000000?ofkP3om^h0
@03om^h10?ooo`00@`3om^h00`000000ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^01@0ooK^00@0
?EV[0?ofkP3om^h0?EV[203om^h;00000080?EV[4P0000001@0mFJ/00000000000000000?EV[00l0
000000<0?EV[00000000000010000000100l4@T0?EV[000000000002054H3080000000<0KR8@0000
001^8Q000`1^8Q000`000000UBhE0000000309D^5@030000002E;QD0UBhE00L0000000<0e3dI0000
000000003@0000000`3D?AT000000000000>000000030=@m6@000000000000l0000000<0e3dI0000
000000003P0000000`3D?AT000000000000=000000030=@m6@000000000000D000000P3oER<01`00
0000oeHS0?mF8`3oER<000000?mF8`000000103oEB8010000000oeDR0000000000020?m@7`800000
00<0?EV[0?U8700000001@0000000`0mFJ/000000000000=0000000503eIZ`00000000000000000m
FJ/04P00000203eIZ`/00000203om^h0100mFJ/0ooK^0?ofkP0mFJ/F0?ofkP0303eIZ`3om^h0ooK^
00h0ooK^00<000000?ofkP3om^h0@@3om^h10?ooo`00@`3om^h00`000000ooK^0?ofkP0>0?ofkP03
03eIZ`3om^h0ooK^01@0ooK^00@0?EV[0?ofkP3om^h0?EV[203om^h00`000000ooK^0?ofkP080?of
kP80?EV[4P3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00l0ooK^00<0?EV[0?ofkP3om^h00P3om^h2
0000000603`A2@0mFJ/00000054H30000000DAP<0P00000206hR40030000001^8Q00KR8@00800000
0P2E;QD010000000UBhE09D^5@00000209D^5@8000001@16ILL00`3D?AT0000004IUa`0504IUa`03
00000016ILL0AVG700<0AVG700<0000004IUa`3D?AT01016ILL00`000000AVG704IUa`0404IUa`03
00000016ILL0AVG70080AVG700<0e3dI04IUa`0000001P16ILL00`000000AVG704IUa`0404IUa`03
00000016ILL0e3dI00@0AVG700<0000004IUa`16ILL01016ILL00`000000AVG704IUa`0204IUa`03
0=@m6@000000AVG700D0AVG700<0000004IUa`16ILL01016ILL00`000000e3dI04IUa`0404IUa`80
000000<0oeHS0000003oER<00P3oER<00`000000oeHS0?mF8`0200000080oeDR00<000000?mE8P3o
EB800P0000001P3oD1l000000?m@7`000000?EV[0?U870800000103om^h00`0mFJ/0ooK^0?ofkP0=
0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/04P3om^h203eIZ`X0ooK^00<000000?ofkP3om^h01P3o
m^h0100mFJ/0ooK^0?ofkP0mFJ/F0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<000000?ofkP3om^h0
@@3om^h10?ooo`00@`3om^h00`000000ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^01@0ooK^00@0
?EV[0?ofkP3om^h0?EV[203om^h00`000000ooK^0?ofkP080?ofkP80?EV[4P3om^h01@0mFJ/0ooK^
0?ofkP3om^h0?EV[00l0ooK^00<0?EV[0?ofkP3om^h00P3om^h30000000703eIZ`000000DAP<054H
30000000DAP<0000000306hR40040000001^8Q00KR8@000000<0UBhE00T0000009D^5@2E;QD00000
09D^5@000000]SLH0000003D?AT00`16ILL00`3D?AT0AVG70000000504IUa`0300000016ILL0AVG7
00@0AVG700<000000=@m6@16ILL01016ILL00`000000AVG704IUa`0304IUa`0300000016ILL0AVG7
0080AVG700<0e3dI04IUa`0000001P16ILL00`000000AVG704IUa`0404IUa`0300000016ILL0e3dI
00<0AVG700<0000004IUa`16ILL01016ILL00`000000AVG704IUa`0304IUa`030=@m6@000000AVG7
00D0AVG700<0000004IUa`16ILL00`16ILL00`000000AVG70=@m6@0304IUa`060=@m6@000000oeHS
0000003oER<000000P3oER<01@000000oeHS0?mF8`3oER<000000080oeDR00L000000?mE8P3oEB80
oeDR0000003oD1l000000080oe0O00<0000003eIZ`0000000P0000040?ofkP0303eIZ`3om^h0ooK^
00d0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0B0?ofkP80?EV[2P3om^h00`000000ooK^0?ofkP06
0?ofkP0403eIZ`3om^h0ooK^03eIZaH0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`000000ooK^0?of
kP110?ofkP40oooo00140?ofkP030000003om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h0503om^h0
100mFJ/0ooK^0?ofkP0mFJ/80?ofkP030000003om^h0ooK^00P0ooK^0P0mFJ/B0?ofkP0503eIZ`3o
m^h0ooK^0?ofkP0mFJ/03`3om^h00`0mFJ/0ooK^0?ofkP020?ofkP<0000000H0?EV[0000001A60`0
DAP<0000001A60`2000000<0KR8@00@0000006hR4000000000000P2E;QD010000000UBhE09D^5@2E
;QD2000000030;Hg600mFJ/000000080e3dI00@0AVG70=@m6@16ILL000001P16ILL00`000000AVG7
04IUa`0304IUa`030000003D?AT0AVG700@0AVG700<0000004IUa`16ILL01016ILL01`000000AVG7
04IUa`16ILL0e3dI04IUa`0000001P16ILL00`000000AVG704IUa`0304IUa`0400000016ILL0AVG7
0=@m6@<0AVG700<0000004IUa`16ILL01016ILL00`000000AVG704IUa`0304IUa`030=@m6@16ILL0
AVG700@0AVG700<0000004IUa`16ILL00`16ILL01@000000AVG704IUa`3D?AT0AVG70080e3dI00<0
000003eIZ`3oER<00P0000030?mF8`030000003oER<0oeHS0080000000<0oeDR0000003oEB800P3o
EB82000000060?m@7`000000oe0O0?m@7`000000?EV[0`0000040?ofkP0303eIZ`3om^h0ooK^00d0
ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0B0?ofkP80?EV[2P3om^h00`000000ooK^0?ofkP060?of
kP0403eIZ`3om^h0ooK^03eIZaH0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`000000ooK^0?ofkP12
0?ofkP40oooo00140?ofkP030000003om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h0503om^h00`0m
FJ/0ooK^0?ofkP1103eIZ`040000000X2`D0000003eIZ`8000000P1A60`20000000906hR40000000
KR8@06hR40000000KR8@0000002E;QD000000080UBhE00X0000009D^5@2E;QD0UBhE0000002f=aP0
?EV[0;Hg60000000AVG70`3D?AT00`16ILL0000004IUa`0504IUa`0300000016ILL0AVG700<0AVG7
00<0e3dI04IUa`16ILL01016ILL00`000000AVG704IUa`0304IUa`0500000016ILL0AVG704IUa`3D
?AT00P16ILL00`000000AVG704IUa`0304IUa`0300000016ILL0AVG700<0AVG700@0000004IUa`16
ILL0e3dI0`16ILL00`000000AVG704IUa`0304IUa`0300000016ILL0AVG700@0AVG700<0e3dI04IU
a`16ILL00`16ILL00`000000AVG704IUa`0404IUa`0300000016ILL0e3dI0080e3dI00H0AVG70000
003oER<0?EV[0?mF8`0000030?mF8`080000003oER<0oeHS0000003oER<000000?mE8P0000020?mE
8P040000003oEB80000000000080oe0O0P000000100mFJ/000000</j5P00001103eIZ`80ooK^00<0
?EV[0?ofkP3om^h0503om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP030000003om^h0ooK^0480ooK^0@3o
ool004@0ooK^00<000000?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP0403eIZ`3om^h0
ooK^03eIZ`L0ooK^00<000000?ofkP3om^h02@3om^h203eIZa80ooK^00D0?EV[0?ofkP3om^h0ooK^
03eIZ`0?0?ofkP0303eIZ`3om^h0ooK^0080ooK^00@0000002P;1@000000?EV[0P000003054H3080
000000@0KR8@0000001^8Q00KR8@0P00000209D^5@040000002E;QD0UBhE00000080UBhE0P000000
1`0mFJ/0]SLH0;Hg60000000AVG70=@m6@16ILL00P3D?AT00`000000AVG704IUa`0304IUa`030000
0016ILL0AVG700<0AVG700<0e3dI04IUa`16ILL01016ILL00`000000AVG704IUa`0304IUa`050000
0016ILL0AVG704IUa`3D?AT00P16ILL00`000000AVG704IUa`0304IUa`0300000016ILL0AVG700<0
AVG700@0000004IUa`16ILL0e3dI0`16ILL00`000000AVG704IUa`0304IUa`0300000016ILL0AVG7
00<0AVG700<000000=@m6@16ILL01016ILL00`000000AVG704IUa`0304IUa`070000003D?AT0e3dI
04IUa`3D?AT0AVG7000000020?mF8`0303eIZ`00000000000080oeHS00@000000?mF8`3oER<00000
0P3oER<200000080oeDR00@000000?mE8P00000000000`3oD1l20000000403eIZ`000000bcXF0000
00@0ooK^00<0?EV[0?ofkP3om^h03@3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[0180ooK^0P0mFJ/;
0?ofkP030000003om^h0ooK^00D0ooK^00@0?EV[0?ofkP3om^h0?EV[5P3om^h00`0mFJ/0ooK^0?of
kP0=0?ofkP030000003om^h0ooK^0480ooK^0@3oool004D0ooK^00<000000?ofkP3om^h0303om^h0
0`0mFJ/0ooK^0?ofkP0D0?ofkP0403eIZ`3om^h0ooK^03eIZ`L0ooK^00<000000?ofkP3om^h02@3o
m^h203eIZa80ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0?0?ofkP0303eIZ`3om^h0ooK^0080ooK^
0`000000100mFJ/00000054H30000002054H308000000P1^8Q0010000000KR8@06hR4000000309D^
5@080000002E;QD0UBhE0000002E;QD000000;Hg600mFJ/20;Hg600400000016ILL0AVG70=@m6@80
AVG70`3D?AT404IUa`0300000016ILL0AVG70080AVG700<0e3dI00000016ILL01016ILL00`000000
AVG704IUa`0304IUa`0500000016ILL0AVG704IUa`3D?AT00P16ILL00`000000AVG704IUa`0304IU
a`0300000016ILL0AVG700<0AVG700@0000004IUa`16ILL0e3dI0P16ILL00`000000AVG704IUa`03
04IUa`0300000016ILL0AVG700@0AVG700<000000=@m6@16ILL00`16ILL00`000000AVG704IUa`02
04IUa`<0e3dI0P16ILL00`3D?AT0AVG7000000030?mF8`0503eIZ`3oER<000000?mF8`0000000P3o
ER<01@000000oeHS0?mF8`3oER<000000080oeDR00<000000?mE8P3oEB800P0000020?m@7`<00000
00<0?EV[0000000000001@3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0503eIZ`3om^h0ooK^0?ofkP0m
FJ/04P3om^h203eIZ`/0ooK^00<000000?ofkP3om^h01@3om^h0100mFJ/0ooK^0?ofkP0mFJ/F0?of
kP0303eIZ`3om^h0ooK^00`0ooK^00<000000?ofkP3om^h0@`3om^h10?ooo`00A@3om^h00`000000
ooK^0?ofkP0<0?ofkW/0?EV[00<0AVG70=@m6@16ILL00`16ILL010000000e3dI0=@m6@3D?AT204IU
a`0600000016ILL0AVG704IUa`3D?AT000001P16ILL00`000000AVG704IUa`0304IUa`0400000016
ILL0AVG70=@m6@80AVG700<0000004IUa`16ILL00`16ILL00`000000AVG704IUa`0304IUa`040000
0016ILL0AVG70=@m6@80AVG700<0000004IUa`16ILL00`16ILL00`000000AVG704IUa`0304IUa`03
00000016ILL0e3dI00<0AVG700<0000004IUa`16ILL00`3D?AT00`000000AVG704IUa`0204IUa`03
0=@m6@16ILL0?EV[07X0?EV[3P3om^h00`000000ooK^0?ofkP130?ofkP40oooo00150?ofkP030000
003om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h0503om^h0100mFJ/0ooK^0?ofkP0mFJ/70?ofkP03
0000003om^h0ooK^00T0ooK^0P0mFJ/B0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/03`3om^h00`0m
FJ/0ooK^0?ofkP030?ofkP80000000D0?EV[03`A2@000000DAP<00000002054H308000000P1^8Q00
1@000000KR8@0000002E;QD0000000<0UBhE00P0000009D^5@2E;QD000000;Hg600mFJ/0]SLH0000
0080]SLH00<0000004IUa`16ILL01016ILL00`000000AVG704IUa`020=@m6@0700000016ILL0AVG7
04IUa`3D?AT0AVG70000000504IUa`0300000016ILL0AVG700<0AVG700@0000004IUa`16ILL0e3dI
0P16ILL00`000000AVG704IUa`0304IUa`0300000016ILL0AVG700<0AVG700@0000004IUa`16ILL0
e3dI0P16ILL00`000000AVG704IUa`0304IUa`0300000016ILL0AVG700<0AVG700<0000004IUa`3D
?AT00`16ILL00`000000e3dI0=@m6@0204IUa`0300000016ILL0AVG700@0AVG700P000000?mF8`3o
ER<000000?mF8`0mFJ/0oeHS00000080oeHS00T000000?mF8`3oER<0oeHS0000003oER<000000?mE
8P0000000P3oEB8200000080oe0O00D000000?m@7`000000nDPL03eIZ`02000000D0ooK^00<0?EV[
0?ofkP3om^h03@3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[0180ooK^0P0mFJ/;0?ofkP030000003o
m^h0ooK^00D0ooK^00@0?EV[0?ofkP3om^h0?EV[5P3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP030000
003om^h0ooK^04<0ooK^0@3oool004H0ooK^00<000000?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?of
kP0D0?ofkP0403eIZ`3om^h0ooK^03eIZ`L0ooK^00<000000?ofkP3om^h02@3om^h203eIZa80ooK^
00D0?EV[0?ofkP3om^h0ooK^03eIZ`0?0?ofkP0303eIZ`3om^h0ooK^00<0ooK^0P0000000`0mFJ/0
?14900000002054H30050000001A60`0000006hR400000000P1^8Q001@000000KR8@0000002E;QD0
000000<0UBhE00D0000009D^5@000000000003eIZ`020;Hg60040000002f=aP0]SLH000000D0AVG7
00<0000004IUa`16ILL00P16ILL30=@m6@0404IUa`3D?AT0AVG7000000H0AVG700<0000004IUa`16
ILL00P16ILL010000000AVG704IUa`3D?AT204IUa`0300000016ILL0AVG700<0AVG700<0000004IU
a`16ILL00P16ILL01@000000AVG704IUa`16ILL0e3dI0080AVG700<0000004IUa`16ILL00P16ILL0
0`000000AVG704IUa`0304IUa`0500000016ILL0AVG70=@m6@16ILL00`3D?AT304IUa`0300000016
ILL0AVG700@0AVG700@000000?mF8`3oER<000000P3oER<01@0mFJ/000000000003oER<0000000<0
oeHS00D000000?mF8`000000oeDR000000020?mE8P050000003oEB8000000?m@7`0000000P3oD1l0
0`000000nDPL03eIZ`02000000D0ooK^00<0?EV[0?ofkP3om^h03@3om^h01@0mFJ/0ooK^0?ofkP3o
m^h0?EV[0180ooK^0P0mFJ/;0?ofkP030000003om^h0ooK^00D0ooK^00@0?EV[0?ofkP3om^h0?EV[
5P3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP030000003om^h0ooK^04@0ooK^0@3oool004H0ooK^00<0
00000?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP0403eIZ`3om^h0ooK^03eIZ`L0ooK^
00<000000?ofkP3om^h02@3om^h203eIZa80ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0?0?ofkP03
03eIZ`3om^h0ooK^00<0ooK^0P000000100mFJ/00000000000000002054H308000000P1^8Q000`00
0000KR8@06hR400200000080UBhE00@0000009D^5@2E;QD0UBhE0P0000000`2f=aP0?EV[0;Hg6002
0;Hg60040000002f=aP0]SLH000000D0AVG700<0000004IUa`16ILL00`16ILL00`000000e3dI0=@m
6@020=@m6@0300000016ILL0AVG700<0AVG700<0000004IUa`16ILL00P16ILL010000000AVG704IU
a`3D?AT304IUa`0300000016ILL0AVG70080AVG700<0000004IUa`16ILL00P16ILL01`000000AVG7
04IUa`16ILL0e3dI04IUa`0000001@16ILL00`000000AVG704IUa`0304IUa`030000003D?AT0e3dI
0080e3dI00<0000004IUa`16ILL00`16ILL00`000000AVG704IUa`0304IUa`040000003oER<0oeHS
000000<0oeHS00@0?EV[0000003oER<000000`3oER<00`000000oeHS0?mF8`0200000080oeDR00<0
00000?mE8P3oEB800P0000020?m@7`<0000000<0?EV[0000000000001@3om^h00`0mFJ/0ooK^0?of
kP0=0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/04P3om^h203eIZ`/0ooK^00<000000?ofkP3om^h0
1@3om^h0100mFJ/0ooK^0?ofkP0mFJ/F0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<000000?ofkP3o
m^h0A03om^h10?ooo`00AP3om^h00`000000ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^01D0ooK^
0P0mFJ/80?ofkP030000003om^h0ooK^00P0ooK^00<0?EV[0?ofkP0mFJ/04@3om^h00`0mFJ/0ooK^
0?ofkP020?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h0103om^h20000000403eI
Z`000000000000000080DAP<0P00000206hR40050000001^8Q00KR8@06hR400000000`2E;QD20000
0080UBhE0P0000000`0mFJ/00000000000020;Hg60040000002f=aP0]SLH000000D0AVG700<00000
04IUa`16ILL00P16ILL00`000000AVG70=@m6@0204IUa`H0e3dI00<0AVG700000016ILL00`16ILL0
0`000000AVG70=@m6@0304IUa`0300000016ILL0AVG70080AVG700<0000004IUa`16ILL00P16ILL0
1`000000AVG704IUa`16ILL0e3dI04IUa`0000001016ILL00`000000AVG70=@m6@050=@m6@80AVG7
00<0e3dI04IUa`0000001016ILL00`000000AVG704IUa`0304IUa`040000003oER<0oeHS00000080
oeHS0P0000000`0mFJ/00000000000020?mF8`8000000`3oER<010000000oeDR0?mE8P0000030?mE
8P80000000<0oe0O0000003oD1l00P0000000`0mFJ/00000000000060?ofkP0303eIZ`3om^h0ooK^
00`0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0?EV[
00X0ooK^00<000000?ofkP3om^h01P3om^h203eIZaL0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`00
0000ooK^0?ofkP140?ofkP40oooo00170?ofkP030000003om^h0ooK^00X0ooK^00<0?EV[0?ofkP3o
m^h05@3om^h203eIZ`P0ooK^00<000000?ofkP3om^h0203om^h00`0mFJ/0ooK^03eIZ`0A0?ofkP03
03eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP040?ofkP80
000000D0?EV[03`A2@000000DAP<00000002054H30050000001^8Q00KR8@06hR400000000P1^8Q02
000000@0UBhE00D0000009D^5@2E;QD0000003eIZ`020;Hg60040000002f=aP0]SLH00000080]SLH
300000000`3D?AT0000000000006000000H0e3dI0P0000000`3D?AT000000000000?000000030=@m
6@000000000000H0e3dI200000000`3D?AT000000000000:00000080oeHS00@000000?mF8`3oER<0
00000P3oER<01@0mFJ/000000?mF8`3oER<0000000@0oeHS0P0000020?mE8P050000003oEB80oeDR
0?mE8P0000000P3oD1l3000000030?U8700mFJ/0000000L0ooK^00<0?EV[0?ofkP3om^h0303om^h0
0`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP0mFJ/02P3om^h0
0`000000ooK^0?ofkP060?ofkP80?EV[5`3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP030000003om^h0
ooK^04D0ooK^0@3oool004L0ooK^00<000000?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP0E0?of
kP80?EV[1`3om^h00`000000ooK^0?ofkP090?ofkP0303eIZ`3om^h0?EV[0140ooK^00<0?EV[0?of
kP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0000003eI
Z`0l4@T00P0000000`1A60`00000054H3002000000<0KR8@00D0000006hR40000000UBhE00000004
09D^5@040000002E;QD0000003eIZ`<0]SLH00D000000;Hg602f=aP000000;Hg6002000000D0AfW>
00<0000004MYcP17JLh00P17JLh00`3D?AT0AfW>04MYcP0204MYcP0300000017JLh0AfW>0080AfW>
00<0000004MYcP17JLh00P17JLhG0=@m6@@0AfW>00<0000004MYcP17JLh00P17JLh00`000000AfW>
04MYcP0204MYcP030=@m6@17JLh0AfW>0080AfW>00<0000004MYcP17JLh00`17JLh2000000050?mF
8`000000oeHS0?mF8`0000000`3oER<0100mFJ/000000?mF8`0000040?mF8`050000003oER<00000
0?mE8P0000000`3oEB82000000080?m@7`000000oe0O0000003D?AT0nDPL03eIZ`0000070?ofkP03
03eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP03
03eIZ`3om^h0?EV[00/0ooK^00<000000?ofkP3om^h01@3om^h203eIZaL0ooK^00<0?EV[0?ofkP3o
m^h02P3om^h00`000000ooK^0?ofkP150?ofkP40oooo00170?ofkP030000003om^h0ooK^00X0ooK^
00<0?EV[0?ofkP3om^h05@3om^h203eIZ`L0ooK^00<000000?ofkP3om^h02@3om^h00`0mFJ/0ooK^
03eIZ`0A0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^
0?ofkP050?ofkP050000000mFJ/0?14903`A2@0000000P1A60`20000000306hR40000000KR8@0080
KR8@0P00000209D^5@030000002E;QD0UBhE0080UBhE0P0000000`0mFJ/00000000000020;Hg6003
0000002f=aP0]SLH0080000000<0d3hK00000017JLh01017JLh01P000000AfW>04MYcP17JLh0e3dI
000000<0AfW>00<0000004MYcP17JLh00`17JLh00`000000AfW>04MYcP0204MYcP030000003D?AT0
AfW>0080AfW>00<0000004MYcP17JLh00P17JLh00`000000AfW>04MYcP0204MYcP0600000017JLh0
AfW>04MYcP3D?AT000001017JLh00`000000AfW>04MYcP0304MYcP0600000017JLh0AfW>04MYcP00
0000e3dI0`17JLh00`000000AfW>04MYcP0304MYcP040000003oE2<0000000000080oeHS00<00000
0?mF8`3oER<00P0000000`0mFJ/00000000000040?mF8`030000003oER<0oeHS008000000`3oEB80
10000000oeDR0000000000020?m@7`050000003iB1`0nDPL03eIZ`0000001`3om^h00`0mFJ/0ooK^
0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^
03eIZ`0;0?ofkP030000003om^h0ooK^00D0ooK^0P0mFJ/G0?ofkP0303eIZ`3om^h0ooK^00X0ooK^
00<000000?ofkP3om^h0A@3om^h10?ooo`00B03om^h00`000000ooK^0?ofkP0:0?ofkP0303eIZ`3o
m^h0ooK^01@0ooK^0P0mFJ/70?ofkP030000003om^h0ooK^00T0ooK^00@0?EV[0?ofkP3om^h0?EV[
403om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h0
1@3om^h20000000303eIZ`0l4@T000000080DAP<00D00000054H30000000KR8@0000000306hR4004
0000002E;QD0UBhE09D^5@8000000`2E;QD01@000000?EV[0;Hg602f=aP000000080]SLH00@00000
0;Hg602f=aP000000P3@?Q/00`000000AfW>04MYcP0304MYcP0500000017JLh0AfW>04MYcP3D?AT0
1017JLh00`000000AfW>04MYcP0204MYcP0300000017JLh0AfW>0080AfW>00<000000=@m6@17JLh0
0P17JLh00`000000AfW>04MYcP0204MYcP0300000017JLh0AfW>0080AfW>00H0000004MYcP17JLh0
AfW>0=@m6@00000404MYcP0300000017JLh0AfW>0080AfW>00<0000004MYcP17JLh00P17JLh01@3D
?AT0AfW>04MYcP17JLh0000000D0AfW>00@000000?mD8`3oE2<000000P3oER<010000000oeHS0?mF
8`0000020?mF8`0303eIZ`000000oeHS0080oeHS0P0000030?mF8`060000003oEB80oeDR0?mE8P00
0000oeDR0P0000030?m@7`030000003iB1`0?EV[008000001`3om^h00`0mFJ/0ooK^0?ofkP0;0?of
kP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h03P3om^h0100mFJ/0ooK^0?ofkP0mFJ/;
0?ofkP030000003om^h0ooK^00D0ooK^0P0mFJ/F0?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<00000
0?ofkP3om^h0AP3om^h10?ooo`00B03om^h00`000000ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^
01@0ooK^0P0mFJ/70?ofkP030000003om^h0ooK^00T0ooK^00@0?EV[0?ofkP3om^h0?EV[403om^h0
0`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h01@3om^h2
0000000403eIZ`0l4@T0000000000080DAP<0P00000206hR40030000001^8Q00KR8@00800000102E
;QD01@000000UBhE09D^5@000000?EV[0080]SLH00@0e3dI0000002f=aP0]SLH100000020=0n6`03
00000017JLh0AfW>00<0AfW>00D0000004MYcP17JLh0e3dI0000000404MYcP0300000017JLh0AfW>
0080AfW>00H0000004MYcP17JLh0AfW>0000003D?AT304MYcP0300000017JLh0AfW>0080AfW>00<0
000004MYcP17JLh00P17JLh01P000000AfW>04MYcP17JLh0e3dI000000<0AfW>00<0000004MYcP17
JLh00P17JLh00`000000AfW>04MYcP0204MYcP050000003D?AT0AfW>04MYcP0000001@17JLh00`00
0000oe@S0?mD8`0400000080oeHS00H000000=@m6@3oER<0oeHS03eIZ`0000020?mF8`030000003o
ER<0oeHS0080oeHS0P0000000`3oEB80e3dI000000020?mE8P8000000P3oD1l2000000040?U8700m
FJ/00000000000L0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eI
Z`3om^h0ooK^00h0ooK^00@0?EV[0?ofkP3om^h0?EV[2`3om^h00`000000ooK^0?ofkP050?ofkP80
?EV[5P3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP030000003om^h0ooK^04H0ooK^0@3oool004P0ooK^
00<000000?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP0D0?ofkTD0?EV[0P000000100mFJ/0?149
000000000003054H30080000001^8Q00KR8@06hR40000000KR8@0000002E;QD2000000<0UBhE00@0
000009D^5@000000?EV[0P0000020;Hg60040000002f=aP0]SLH0;Hg60@0000000<0d3hK00000017
JLh01017JLh01@000000AfW>0=@m6@17JLh0000000<0AfW>00<0000004MYcP17JLh00P17JLh00`00
0000AfW>04MYcP0204MYcP050=@m6@17JLh0AfW>04MYcP0000001017JLh00`000000AfW>04MYcP02
04MYcP0500000017JLh0AfW>04MYcP3D?AT01017JLh00`000000AfW>04MYcP0204MYcP0900000017
JLh0AfW>04MYcP000000AfW>0=@m6@17JLh0000000D0AfW>00<000000?mD8`0000000`0000030?mF
8`030000003oER<0oeHS0080000000@0?EV[0000003oER<000000`3oER<2000000040?mF8`000000
e3dI000000<0oeDR00@000000?m@7`3oD1l0oe0O0`0000000`0mFJ/000000000001503eIZaH0ooK^
00<0?EV[0?ofkP3om^h02P3om^h00`000000ooK^0?ofkP160?ofkP40oooo00180?ofkP030000003o
m^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h0503om^h203eIZ`L0ooK^00<000000?ofkP3om^h02@3o
m^h0100mFJ/0ooK^0?ofkP0mFJ/@0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h0
2`3om^h00`0mFJ/0ooK^0?ofkP050?ofkP80000000D0?EV[000000000000DAP<00000002054H3080
00000`1^8Q000`000000KR8@0000000209D^5@040000002E;QD0UBhE09D^5@80000000@0?EV[0;Hg
602f=aP000000P2f=aP01@000000]SLH0;Hg602f=aP000000080d3hK00@000000=0n6`0000000000
0`17JLh00`000000AfW>0=@m6@0204MYcP0500000017JLh0AfW>04MYcP0000001017JLh01@000000
AfW>04MYcP17JLh0e3dI00@0AfW>00D0000004MYcP17JLh0AfW>0000000304MYcP0300000017JLh0
AfW>0080AfW>00D0e3dI04MYcP17JLh0AfW>0000000404MYcP0500000017JLh0AfW>04MYcP000000
0P17JLh00`3D?AT0AfW>0000000304MYcP80000000D0oe@S0000003oE2<0oe@S000000030?mF8`04
0000003oER<0oeHS00000080oeHS00<0?EV[0000000000000`3oER<01P000000oeHS0?mF8`000000
oeDR000000<0oeDR0P0000020?m@7`060000003oD1l000000000000mFJ/00000203om^h00`0mFJ/0
ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h03P3om^h0100mFJ/0
ooK^0?ofkP0mFJ/;0?ofkP030000003om^h0ooK^00D0ooK^0P0mFJ/F0?ofkP0303eIZ`3om^h0ooK^
00X0ooK^00<000000?ofkP3om^h0AP3om^h10?ooo`00B@3om^h00`000000ooK^0?ofkP090?ofkP03
03eIZ`3om^h0ooK^01D0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`000000ooK^0?ofkP090?ofkP04
03eIZ`3om^h0ooK^03eIZa00ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP0;0?of
kP0303eIZ`3om^h0ooK^00H0ooK^00@0000003eIZ`00000000000P1A60`01@000000DAP<0000001^
8Q00000000<0KR8@0P00000309D^5@060000002E;QD0UBhE09D^5@000000?EV[0`2f=aP00`000000
]SLH0;Hg6002000000030;Hg6000000000000080d3hK00@000000=0n6`3@?Q/000000`17JLh00`00
0000e3dI04MYcP0204MYcP0400000017JLh0AfW>000000@0AfW>00H0000004MYcP17JLh0AfW>0=@m
6@00000304MYcP0500000017JLh0AfW>04MYcP0000000`17JLh01P000000AfW>04MYcP17JLh00000
0=@m6@<0AfW>00<0000004MYcP17JLh00P17JLh010000000AfW>04MYcP00000304MYcP030=@m6@00
0000AfW>0080AfW>00@000000?mD8`3oE2<000000P3oE2<2000000030?mF8`00000000000080oeHS
00H000000?mF8`3oER<0oeHS03eIZ`0000030?mF8`040000003oER<0oeHS0?mF8`8000000`3oEB80
1@000000oeDR0000003oD1l000000080oe0O00@000000?U8700mFJ/00000203om^h00`0mFJ/0ooK^
0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h03P3om^h0100mFJ/0ooK^
0?ofkP0mFJ/;0?ofkP030000003om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h05@3om^h00`0mFJ/0
ooK^0?ofkP090?ofkP030000003om^h0ooK^04L0ooK^0@3oool004T0ooK^00<000000?ofkP3om^h0
2@3om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP80?EV[1`3om^h00`000000ooK^0?ofkP080?ofkP0503eI
Z`3om^h0ooK^0?ofkP0mFJ/0403om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00/0
ooK^00<0?EV[0?ofkP3om^h01P3om^h010000000?EV[03`A2@000003054H308000000P1^8Q001@00
0000KR8@06hR401^8Q00000000@0UBhE00H0000009D^5@2E;QD0000003eIZ`0000030;Hg60040000
002f=aP0]SLH0;Hg6080000000@0d3hK000000000000d3hK0P0000000`3@?Q/0000004MYcP0204MY
cP030=@m6@17JLh0AfW>0080AfW>00@0000004MYcP17JLh000001017JLh01@000000AfW>04MYcP3D
?AT0000000<0AfW>00D0000004MYcP17JLh0AfW>0000000304MYcP0600000017JLh0AfW>04MYcP00
0000e3dI0P17JLh00`000000AfW>04MYcP0204MYcP0400000017JLh0AfW>000000@0AfW>00H0e3dI
04MYcP17JLh0AfW>0000003oE2<2000000040?mD8`00000000000?mD8`8000000`3oER<01`000000
oeHS0?mF8`3oER<0000003eIZ`0000000P3oER<00`000000oeHS0?mF8`020?mF8`050000003oEB80
oeDR0?mE8P0000000P3oEB82000000<0oe0O00@000000?U8700mFJ/00000203om^h00`0mFJ/0ooK^
0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h03P3om^h01@0mFJ/0ooK^
0?ofkP3om^h0?EV[00X0ooK^00<000000?ofkP3om^h01@3om^h203eIZaH0ooK^00<0?EV[0?ofkP3o
m^h02@3om^h00`000000ooK^0?ofkP170?ofkP40oooo00190?ofkP030000003om^h0ooK^00T0ooK^
00<0?EV[0?ofkP3om^h0503om^h203eIZ`L0ooK^00<000000?ofkP3om^h0203om^h01@0mFJ/0ooK^
0?ofkP3om^h0?EV[0100ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP03
03eIZ`3om^h0ooK^00H0ooK^00<0000003eIZ`0000000P000002054H308000000`1^8Q000`000000
KR8@06hR4002000000@0UBhE0`0000000`0mFJ/0]SLH000000030;Hg60050000002f=aP0]SLH0;Hg
600000000`3@?Q/01P000000d3hK0=0n6`000000d3hK00000080AfW>00<0e3dI00000017JLh00P17
JLh01@000000AfW>04MYcP17JLh0000000<0AfW>00D0000004MYcP17JLh0e3dI0000000304MYcP05
00000017JLh0AfW>04MYcP0000000`17JLh01P000000AfW>04MYcP17JLh000000=@m6@80AfW>00D0
000004MYcP17JLh0AfW>0000000304MYcP0600000017JLh0AfW>03eIZ`000000e3dI0P17JLh00`00
0000oe@S000000020?mD8`050000003oE2<0oe@S0?mD8`0000000`3oER<020000000oeHS0?mF8`3o
ER<000000?mF8`0mFJ/0oeHS0P0000040?mF8`8000000P3oEB8010000000oeDR0?mE8P3oEB820000
0080oe0O0`0000000`0mFJ/000000?ofkP070?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?of
kP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/02P3om^h0
0`000000ooK^0?ofkP050?ofkP80?EV[5P3om^h00`0mFJ/0ooK^0?ofkP090?ofkP030000003om^h0
ooK^04L0ooK^0@3oool004X0ooK^00<000000?ofkP3om^h0203om^j903eIZ`0500000017JLh0AfW>
04MYcP0000000`17JLh010000000AfW>04MYcP00000404MYcP0500000017JLh0e3dI04MYcP000000
0P17JLh01@000000AfW>04MYcP17JLh0000000<0AfW>00P0000004MYcP17JLh0000004MYcP3D?AT0
AfW>000000@0AfW>00@0000004MYcP17JLh000000`17JLh01@000000AfW>04MYcP17JLh0000008T0
?EV[2P3om^h00`000000ooK^0?ofkP180?ofkP40oooo001:0?ofkP030000003om^h0ooK^00P0ooK^
00<0?EV[0?ofkP3om^h0503om^h203eIZ`H0ooK^00<000000?ofkP3om^h02@3om^h01@0mFJ/0ooK^
0?ofkP3om^h0?EV[00l0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP03
03eIZ`3om^h0ooK^00L0ooK^00<0000003eIZ`0l4@T00P0000000`1A60`00000054H3002000000@0
KR8@0P00000309D^5@030000002E;QD0UBhE0080UBhE00@0?EV[0;Hg602f=aP0]SLH0P0000030;Hg
608000000P3@?Q/00`000000d3hK0=0n6`02000000030=0n6`000000d3hK0140000000<0e3dI0000
000000003`0000000`3D?AT000000000000A000000030?mD8`00000000000080oe@S00<000000?mD
8`3oE2<00P0000030?mF8`8000000`3oER<00`0mFJ/0oeHS0?mF8`020?mF8`040000003oER<0oeHS
0?mF8`800000103oEB82000000030?m@7`000000oe0O0080000000<0nDPL03eIZ`0000002@3om^h0
0`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h03@3om^h0
1@0mFJ/0ooK^0?ofkP3om^h0?EV[00/0ooK^00<000000?ofkP3om^h0103om^h203eIZaH0ooK^00<0
?EV[0?ofkP3om^h0203om^h00`000000ooK^0?ofkP180?ofkP40oooo001:0?ofkP030000003om^h0
ooK^00P0ooK^00<0?EV[0?ofkP3om^h0503om^h203eIZ`H0ooK^00<000000?ofkP3om^h02@3om^h0
1@0mFJ/0ooK^0?ofkP3om^h0?EV[00l0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?of
kP0:0?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0000003eIZ`0l4@T00P0000001P1A60`00000054H
30000000KR8@000000@0KR8@00<0000009D^5@2E;QD00P2E;QD01@000000UBhE09D^5@2E;QD0?EV[
008000000`2f=aP01@000000]SLH0;Hg602f=aP0000000<0d3hK0P0000020=0n6`030000003@?Q/0
d3hK00<000000P19K=@00`000000BFcD0=@m6@020=@m6@80BFcD00P0000004U/e019K=@0BFcD0000
003D?AT0BFcD00000080BFcD00D0000004U/e019K=@0BFcD0000000304U/e00700000019K=@0BFcD
00000019K=@0e3dI0000000304U/e00300000019K=@0BFcD00<0e3dI00@0BFcD00000019K=@0BFcD
0`0000020?mD8`030000003oE2<0oe@S008000000`3oE2<01@000000oeHS0?mF8`3oER<0000000<0
oeHS0P0000001@0mFJ/0oeHS0?mF8`3oER<0000000@0oeHS00<000000?mE8P3oEB800P3oEB801P00
0000oeDR0000003oD1l000000?m@7`<0000000<0?EV[0000003om^h0203om^h00`0mFJ/0ooK^0?of
kP0:0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h03@3om^h01@0mFJ/0ooK^0?of
kP3om^h0?EV[00/0ooK^00<000000?ofkP3om^h0103om^h203eIZaD0ooK^00<0?EV[0?ofkP3om^h0
2@3om^h00`000000ooK^0?ofkP180?ofkP40oooo001;0?ofkP030000003om^h0ooK^00P0ooK^00<0
?EV[0?ofkP3om^h04`3om^h203eIZ`H0ooK^00<000000?ofkP3om^h02@3om^h01@0mFJ/0ooK^0?of
kP3om^h0?EV[00l0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eI
Z`3om^h0ooK^00L0ooK^00D0000003eIZ`000000?14900000002054H30050000001A60`0000006hR
400000000`1^8Q03000000<0UBhE0P000000102E;QD0?EV[0;Hg602f=aP200000080]SLH00<00000
0;Hg602f=aP00`0000030=0n6`040000003@?Q/0d3hK00000080d3hK00<000000>E47@0000000P19
K=@200000080BFcD1@3D?AT00`19K=@000000=@m6@0204U/e00300000019K=@0000000<0BFcD00L0
000004U/e019K=@0BFcD00000019K=@000000080BFcD00<0e3dI00000019K=@01@3D?AT204U/e080
00000P19K=@00`000000oe4R000000020?mD8`040000003oE2<0oe@S000000<0oe@S0`0000020?mF
8`030000003oER<0oeHS008000000P3oER<0100mFJ/0oeHS0000000000030?mF8`<000000`3oEB80
1@000000oeDR0000003oD1l000000080oe0O00D000000?U870000000?EV[000000090?ofkP0303eI
Z`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eI
Z`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h02@3om^h00`000000ooK^0?ofkP030?ofkP0303eI
Z`3om^h0?EV[01D0ooK^00<0?EV[0?ofkP3om^h0203om^h00`000000ooK^0?ofkP190?ofkP40oooo
001;0?ofkP030000003om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h04P3om^h0100mFJ/0ooK^0?of
kP0mFJ/50?ofkP030000003om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^
0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^
0?ofkP070?ofkP040000000mFJ/0000003`A2@8000000P1A60`200000080KR8@0P0000001@1^8Q00
000009D^5@2E;QD0000000@0UBhE00<0000003eIZ`2f=aP00`2f=aP00`000000]SLH0;Hg60030000
0080d3hK0P0000020=0n6`80000000<0d3hK0000003@?Q/01@00000204U/e00400000019K=@0BFcD
00000080BFcD00<000000=@m6@3D?AT05@3D?AT010000000BFcD04U/e000000204U/e00300000019
K=@0BFcD00L0000000<0oe@S0000000000000P3oE2<200000080oe@S0`0000020?mF8`030000003o
ER<0oeHS0080oeHS00<0?EV[0000003oER<00`3oER<01@000000oeHS0?mF8`000000oeDR00800000
0P3oEB8200000080oe0O00H000000=@m6@000000nDPL03eIZ`0000090?ofkP0303eIZ`3om^h0ooK^
00T0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^
00<0ooK^00<0?EV[0?ofkP3om^h0203om^h00`000000ooK^0?ofkP030?ofkP0403eIZ`3om^h0ooK^
03eIZa@0ooK^00<0?EV[0?ofkP3om^h0203om^h00`000000ooK^0?ofkP190?ofkP40oooo001;0?of
kP030000003om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h04P3om^h0100mFJ/0ooK^0?ofkP0mFJ/5
0?ofkP030000003om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP0<
0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP07
0?ofkP030000000mFJ/0000000<000000`1A60`00`000000KR8@06hR400206hR40030000001^8Q00
00000080UBhE0P00000309D^5@0303eIZ`000000]SLH00<0]SLH0P0000020;Hg60030000003@?Q/0
d3hK0080d3hK00D000000=0n6`3@?Q/0d3hK000000020=0n6`060000003UA1d0?EV[0000003UA1d0
00000P19K=@010000000BFcD04U/e000000204U/e00600000019K=@0e3dI00000019K=@000000P19
K=@010000000BFcD04U/e000000204U/e00900000019K=@0BFcD00000019K=@000000=@m6@19K=@0
00000080BFcD00@0000004U/e019K=@000000P19K=@01P000000oe4R0000000mFJ/0oe4R00000080
oe@S00D000000?mD8`3oE2<0oe@S000000040?mD8`030000003oER<0oeHS00800000103oER<00`00
0000?EV[0?mF8`020?mF8`8000000P3oER<00`000000oeDR000000040?mE8P040000003oD1l0oe0O
0?m@7`@0000000<0?EV[0000003om^h0203om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0
ooK^00D0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0
ooK^00P0ooK^00<000000?ofkP3om^h00`3om^h0100mFJ/0ooK^0?ofkP0mFJ/D0?ofkP0303eIZ`3o
m^h0ooK^00P0ooK^00<000000?ofkP3om^h0B@3om^h10?ooo`00C03om^h00`000000ooK^0?ofkP07
0?ofkP0303eIZ`3om^h0ooK^0180ooK^B@0mFJ/300000004054H30000000DAP<054H30800000101^
8Q02000000@0UBhE00D0000009D^5@2E;QD0?EV[0;Hg6002000000@0]SLH00<000000;Hg60000000
0P0000030=0n6`8000000P3@?Q/01P000000d3hK000000000000?EV[0>E47@<000000P19K=@02@00
0000BFcD04U/e0000000BFcD00000019K=@0e3dI0000000204U/e00300000019K=@000000080BFcD
00H0000004U/e019K=@0000004U/e000000204U/e0060=@m6@19K=@0BFcD00000019K=@000000P19
K=@00`000000BFcD04U/e003000000030?mA8P0mFJ/0000000<000000P3oE2<2000000<0oe@S0`00
00000`3oER<000000?mF8`030?mF8`80000000D0?EV[0000003oER<0oeHS000000040?mF8`800000
103oEB8200000080oe0O0P0000020?U8700303eIZ`3D?AT0?EV[04L0?EV[4`3om^h00`0mFJ/0ooK^
0?ofkP080?ofkP030000003om^h0ooK^04X0ooK^0@3oool004`0ooK^00<000000?ofkP3om^h0203o
m^h00`0mFJ/0ooK^0?ofkP0A0?ofkP0403eIZ`3om^h0ooK^03eIZ`D0ooK^00<000000?ofkP3om^h0
203om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h0
1@3om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0000003eIZ`0l4@T0
0P0000001P1A60`00000054H30000000KR8@000000@0KR8@00<0000009D^5@2E;QD00`2E;QD30000
000303eIZ`2f=aP0]SLH00800000102f=aP2000000030=0n6`000000000000<0d3hK0P0000020=0n
6`030000003UA1d0?EV[0080000000H0iD@M000000000000000004U/e000000204U/e00:00000019
K=@0000004U/e03D?AT0000004U/e0000000BFcD00000080BFcD00d0000004U/e019K=@0000004U/
e0000000BFcD0000003D?AT0BFcD00000019K=@000000080BFcD00<0000004U/e00000000P000000
1P3oDB8000000000000mFJ/0oe4R00000080oe@S0P0000030?mD8`80000000<0oe@S000000000000
103oER<200000080oeHS00@0?EV[00000000000000001@3oER<00`000000oeDR0?mE8P020?mE8P06
0000003oEB8000000?m@7`000000oe0O0P0000000`3iB1`0?EV[0000000:0?ofkP0303eIZ`3om^h0
ooK^00T0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0
ooK^00<0ooK^00<0?EV[0?ofkP3om^h0203om^h00`000000ooK^0?ofkP030?ofkP0403eIZ`3om^h0
ooK^03eIZa<0ooK^00<0?EV[0?ofkP3om^h0203om^h00`000000ooK^0?ofkP1:0?ofkP40oooo001<
0?ofkP030000003om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h04@3om^h0100mFJ/0ooK^0?ofkP0m
FJ/40?ofkP030000003om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?of
kP0<0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?of
kP080?ofkP030000000mFJ/0?149008000000`1A60`00`000000KR8@06hR400200000080KR8@0`00
000509D^5@030000000mFJ/0]SLH00<0]SLH0P0000020;Hg60050000003@?Q/000000000003@?Q/0
0P0000030=0n6`050000003@?Q/000000000000mFJ/00P3UA1d00`000000iD@M0000000200000009
04U/e0000000000004U/e0000000BFcD0000003D?AT0BFcD008000000P19K=@01@000000BFcD0000
0019K=@000000080BFcD0P0000001P19K=@0e3dI00000019K=@0000004U/e080000000H0BFcD0000
0000000000000?mA8P0000020?mA8P0303eIZ`0000000000008000000`3oE2<2000000070?mD8`00
000000000?mD8`000000oeHS0=@m6@02000000@0oeHS00<0?EV[0000003oER<0103oER<300000080
oeDR0P0000020?mE8P8000000P3oD1l01@000000nDPL0?U8700mFJ/0000000X0ooK^00<0?EV[0?of
kP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?of
kP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP080?ofkP030000003om^h0ooK^00<0ooK^00@0?EV[0?of
kP3om^h0?EV[4`3om^h00`0mFJ/0ooK^0?ofkP080?ofkP030000003om^h0ooK^04X0ooK^0@3oool0
04d0ooK^00<000000?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0503eIZ`3om^h0ooK^
0?ofkP0mFJ/0103om^h00`000000ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[
0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[
0?ofkP3om^h0203om^h01@000000?EV[0000000l4@T000000080DAP<0P00000406hR40030000001^
8Q0000000080UBhE0P00000309D^5@040000000mFJ/00000000000@0]SLH0P000000102f=aP00000
0=0n6`3@?Q/2000000030=0n6`000000000000<0d3hK0P000000100mFJ/000000000003UA1d20000
000O0>E47@000000000000000019K=@0000004U/e0000000BFcD0=@m6@19K=@0000004U/e0000000
BFcD00000019K=@0000004U/e0000000BFcD00000019K=@0000004U/e03D?AT0BFcD00000019K=@0
000004U/e003000000040?mA8P00000000000?mA8P80000000<0?EV[0000000000000`3oE2<20000
00030?mD8`00000000000080oe@S00@000000?mF8`3D?AT00000103oER<20000000303eIZ`000000
oeHS0080oeHS0P0000020?mF8`030000003oEB80000000@0oeDR0P0000020?m@7`050000003iB1`0
000003eIZ`0000002P3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0
?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00P0ooK^00D0
00000?ofkP3om^h0ooK^03eIZ`040?ofkP0303eIZ`3om^h0ooK^0100ooK^00<0?EV[0?ofkP3om^h0
1`3om^h00`000000ooK^0?ofkP1;0?ofkP40oooo001=0?ofkP030000003om^h0ooK^00L0ooK^00<0
?EV[0?ofkP3om^h0403om^h00`0mFJ/0ooK^0?ofkP020?ofkP0503eIZ`3om^h0ooK^0?ofkP000000
2P3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h0
1`3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00P0ooK^00@0000003eIZ`000000
?1490P000002054H30030000003D?AT0KR8@00<0KR8@0P00000409D^5@80000000<0UBhE0000000m
FJ/00P2f=aP2000000@0]SLH0`0000030=0n6`D0000000H0d3hK0000003UA1d0?EV[0000003UA1d2
000000050>E47@00000000000000003UA1d07`0000002@3oDB8000000000003oDB80000003eIZ`3o
DB8000000?mD8`05000000<0oe@S0`0000040?mF8`8000000P3oER<00`0mFJ/0oeHS0?mF8`020000
00@0oeHS0P0000050?mE8P030000003oD1l0oe0O0080000000<0nDPL0000000mFJ/02`3om^h00`0m
FJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0m
FJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00P0ooK^00D000000?ofkP3om^h0ooK^03eIZ`04
0?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h0203om^h00`000000ooK^0?ofkP1;
0?ofkP40oooo001=0?ofkP030000003om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0m
FJ/0ooK^0?ofkP020?ofkP0503eIZ`3om^h0ooK^0?ofkP0000002P3om^h00`0mFJ/0ooK^0?ofkP05
0?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP07
0?ofkP0303eIZ`3om^h0ooK^00X0ooK^00L0?EV[03`A2@0000000000054H30000000DAP<00<00000
101^8Q000`000000UBhE09D^5@0409D^5@030000002E;QD0?EV[00@0]SLH0P0000030;Hg60030000
003@?Q/00000008000000`3@?Q/50000000503eIZ`3UA1d000000000003UA1d00P0000000`3UA1d0
00000>E47@060000000904U^f0000000BFkH00000019K]P0000004U^f0000000BFkH00<0000000<0
BFkH00000019K]P020000000103oDB8000000000003oDB82000000030?mA8P0mFJ/0000000@00000
0`3oE2<3000000030?mD8`000000oeHS0080oeHS0P0000040?mF8`0303eIZ`000000000000H0oeHS
00<000000?mE8P3oEB800P3oEB83000000030?m@7`000000oe0O0080000000<0nDPL03eIZ`3om^h0
2P3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h0
2P3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00P0ooK^00D000000?ofkP3om^h0
ooK^03eIZ`040?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h0203om^h00`000000
ooK^0?ofkP1;0?ofkP40oooo001>0?ofkP030000003om^h0ooK^00L0ooK^U00mFJ/70000000304U^
f000000000000080000000@0BFkH000000000000BFkH0`0000000`19K]P0000000000005000009@0
?EV[2@3om^h00`000000ooK^0?ofkP1<0?ofkP40oooo001>0?ofkP030000003om^h0ooK^00L0ooK^
00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0503eIZ`3om^h0ooK^0?ofkP00
00002P3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3o
m^h01`3om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00X0ooK^00@0?EV[0000000l
4@T000000P1A60`00`000000DAP<0000000206hR4080000000@0KR8@0000002E;QD0UBhE0P000004
09D^5@0403eIZ`2f=aP00000000000D0]SLH0`0000050=0n6`80000000D0e3dI0=0n6`000000iD@M
03eIZ`05000000030>E47@000000000000T0000000@0BFkH000000000000BFkH1P0000000`19K]P0
000000000009000000030?mA8P000000000000<0000000D0?EV[0?mA8P000000oe@S0=@m6@020000
00D0oe@S0`0000050?mF8`80000000<0oeHS03eIZ`3oER<00`3oER<2000000040?mF8`000000oeDR
0?mE8P8000000P3oEB800`000000oe0O000000020?m@7`040000003iB1`0000003eIZ``0ooK^00<0
?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0
?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP080?ofkP050000003om^h0ooK^0?ofkP0mFJ/0
103om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<000000?ofkP3om^h0
C03om^h10?ooo`00CP3om^h00`000000ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0
?EV[0?ofkP3om^h00`3om^h01@0mFJ/0ooK^0?ofkP3om^h0000000T0ooK^00<0?EV[0?ofkP3om^h0
1P3om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h0
1`3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0403eIZ`000000?149000000<0DAP<0P00000406hR40<0
00000`2E;QD200000080UBhE00@0?EV[0;Hg602f=aP0]SLH0`0000030;Hg60030000003@?Q/00000
00<00000103@?Q/30000000303eIZ`3UA1d0iD@M00D0000000<0iD@M0000000000008@0000020?mA
8P0403eIZ`0000000000000000@0oe@S100000000`3oE2<000000?mF8`020?mF8`<000000`3oER<0
0`0mFJ/0oeHS0?mF8`02000000<0oeHS0`0000040?mE8P8000000`3oD1l010000000nDPL0000000m
FJ/<0?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?of
kP090?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h01`3om^h01@000000ooK^0?of
kP3om^h0?EV[00D0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP070?ofkP030000
003om^h0ooK^04`0ooK^0@3oool004l0ooK^00<000000?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?of
kP0=0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00@0?EV[0?ofkP3om^h000002@3om^h00`0mFJ/0ooK^
0?ofkP070?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^
0?ofkP070?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0=@m6@0000000P000003054H30030000
003D?AT0KR8@00@0KR8@00<0000009D^5@2E;QD00`2E;QD00`000000UBhE03eIZ`060;Hg60800000
00<0]SLH0000003@?Q/0103@?Q/4000000040=0n6`000000iD@M03eIZ`<0000000D0iD@M0=@m6@00
000000000>E47@0M000000050?mA8P00000000000=@m6@3oDB800`000000100mFJ/0oe4R0000003o
E2<4000000D0oe@S00@000000?mF8`00000000001P3oER<00`0mFJ/00000000000050?mF8`030000
003oEB80oeDR00@0oeDR00@000000?m@7`3oD1l0oe0O0`0000000`3D?AT0?EV[0?ofkP0;0?ofkP03
03eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP080?ofkP03
03eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h01`3om^h010000000ooK^0?ofkP0mFJ/60?of
kP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`000000ooK^0?ofkP1=0?of
kP40oooo001?0?ofkP030000003om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h03@3om^i>03eIZ`03
0000001A60`000000080DAP<0`00000406hR40<000001@2E;QD00`0mFJ/000000;Hg60060;Hg60@0
00001`3@?Q/30000000403eIZ`3UA1d0iD@M0>E47@@0000000<0iD@M0000000000006`0000000`3o
DB80000000000002000000<0oe4R00@0?EV[00000000000000001`3oE2<4000000L0oeHS00<00000
03eIZ`3oER<0103oER<3000000@0oeDR0`0000020?m@7`030000003oD1l0000004h0?EV[3`3om^h0
0`0mFJ/0ooK^0?ofkP070?ofkP030000003om^h0ooK^04d0ooK^0@3oool004l0ooK^00<000000?of
kP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?of
kP0000002P3om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?of
kP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00/0ooK^00D0?EV[0=@m
6@0000000000054H300300000080KR8@0P00000206hR40030000002E;QD0UBhE008000000`2E;QD0
0`000000?EV[00000002000000D0]SLH00<000000=0n6`3@?Q/01P0000020=0n6`030000003UA1d0
?EV[00H0000000<0iD@M0000000000007@0000000`3oDB800000000000040000000303eIZ`3oDB80
00000080oe@S1P0000020?mD8`030000003oER<0oeHS00<0oeHS0`0000000`0mFJ/000000?mF8`02
0?mF8`8000000P3oER<00`000000oeDR0?mE8P02000000030?mE8P000000oe0O0080000000D0oe0O
000000000000e3dI03eIZ`0=0?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h02@3o
m^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h0203o
m^h00`000000ooK^03eIZ`060?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h01`3o
m^h00`000000ooK^0?ofkP1=0?ofkP40oooo001?0?ofkP030000003om^h0ooK^00L0ooK^00<0?EV[
0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0000000T0ooK^00<0?EV[
0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[
0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0403eIZ`3D?AT0e3dI000000<0DAP<0P00
000306hR40<00000102E;QD20000000309D^5@000000?EV[00<0]SLH100000000`2f=aP000000=0n
6`070=0n6`@0000000@0?EV[00000000000000000`3UA1dQ000000<0oe4R0`0000000`0mFJ/00000
00000002000000P0oe@S00<000000?mF8`0000000`0000030?mF8`0303eIZ`000000oeHS00800000
103oER<3000000<0oeDR0P0000030?m@7`040000003D?AT0e3dI03eIZ`h0ooK^00<0?EV[0?ofkP3o
m^h01@3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3o
m^h0203om^h00`0mFJ/0ooK^0?ofkP070?ofkP030000003om^h0?EV[00L0ooK^00<0?EV[0?ofkP3o
m^h0303om^h00`0mFJ/0ooK^0?ofkP070?ofkP030000003om^h0ooK^04d0ooK^0@3oool00500ooK^
00<000000?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00H0ooK^
00<0?EV[0000003om^h0203om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^00H0ooK^
00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00`0ooK^
00@0?EV[0=@m6@3D?AT00000101A60`00`000000KR8@06hR400306hR408000001@2E;QD200000003
03eIZ`000000]SLH00D0]SLH1`0000050=0n6`030000003UA1d0?EV[00<0iD@M9`0000030?mA8P03
03eIZ`3oDB80000000D0oe@S1`0000060?mF8`040000000mFJ/00000000000D0oeHS0P0000050?mE
8P030000003oD1l0oe0O0080oe0O00@000000=@m6@3D?AT0?EV[3P3om^h00`0mFJ/0ooK^0?ofkP05
0?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP09
0?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0000003eIZ`3om^h01`3om^h00`0mFJ/0ooK^0?ofkP0;
0?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<000000?ofkP3om^h0CP3om^h10?ooo`00D03om^h00`00
0000ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0m
FJ/000000?ofkP080?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0m
FJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h0303om^h01@0m
FJ/0e3dI0=@m6@3om^h0000000<0DAP<00<0e3dI0000000000000`1^8Q0010000000UBhE00000000
000409D^5@030000000mFJ/0]SLH00D000000P2f=aP00`000000d3hK0=0n6`030=0n6`L0000000<0
?EV[000000000000:`0000000`0mFJ/0000000000005000000D0oe@S00<000000?mF8`3oER<01@00
00000`3oER<0?EV[000000040?mF8`80000000<0oeHS0000003oEB800P3oEB83000000<0oe0O00D0
00000?ofkP3D?AT0e3dI03eIZ`0>0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h0
2P3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h0
1`3om^h00`000000?EV[0?ofkP080?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h0
1`3om^h00`000000ooK^0?ofkP1>0?ofkP40oooo001@0?ofkP030000003om^h0ooK^00L0ooK^TP0m
FJ/K00000980?EV[2@3om^h00`000000ooK^0?ofkP1>0?ofkP40oooo001A0?ofkP030000003om^h0
ooK^00H0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`000000
ooK^00L0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0
ooK^00/0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0903eIZ`3D?AT0
e3dI0=@m6@3om^h0?EV[0000001A60`0000000<0KR8@0`00000509D^5@80000000<0UBhE03eIZ`2f
=aP01`2f=aP00`000000d3hK0=0n6`030=0n6`L0000000<0?EV[0000000000000P0000050>E47@@0
000000<0mdTO0000000000000P0000000`19K]T0000004U^f@030000000304U^f@000000BFkI00@0
000000<0odhQ0000000000000P0000050?mA8P@0000000<0?EV[0000000000001@0000050?mD8`03
0000003oER<0oeHS00H0oeHS00@0?EV[0?mF8`00000000001@3oER<3000000<0oeDR00D000000?m@
7`000000?EV[0?ofkP030=@m6@0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h0103om^h0
0`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h02P3om^h0
0`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h0203om^h0
0`0mFJ/0ooK^0?ofkP070?ofkP030000003om^h0ooK^04l0ooK^0@3oool00540ooK^00<000000?of
kP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP080?ofkUP0?EV[0P1^8Q000`0mFJ/0KR8@06hR40020000
00H0UBhE00<0000003eIZ`0000000`0000040;Hg60030000003@?Q/0d3hK00P0d3hK00@000000=@m
6@0mFJ/0iD@M1P0000020>E47@80000000<0mdTO0000000000000`0000001`19K]T0000000000000
0000BFkI00000019K]T00`0000000`19K]T0000000000003000000030?m>8@00000000000080oe4R
1P0000000`0mFJ/0oe4R0000000;0?mD8`030000003oER<0oeHS0080oeHS100000000`0mFJ/00000
0?mF8`050?mF8`8000000P3oEB800`0mFJ/0oeDR0?mE8P1H03eIZ`X0ooK^00<0?EV[0?ofkP3om^h0
1`3om^h00`000000ooK^0?ofkP1?0?ofkP40oooo001A0?ofkP030000003om^h0ooK^00L0ooK^00<0
?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0
?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0
?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3D?AT0ooK^0080e3dI00<0
?EV[0?ofkP3om^h00P00000406hR40030000002E;QD0000000800000102E;QD00`0mFJ/0]SLH0;Hg
60020;Hg6180000000@0?EV[0>E47@3UA1d0iD@M100000020>E47AT000000P3oDB84000000<0oe4R
00<0?EV[000000000000400000030?mF8`0303eIZ`000000oeHS00<0oeHS0`0000000`3oER<00000
0?mE8P030?mE8P8000000P3om^h01@0mFJ/0e3dI0=@m6@3om^h0?EV[0100ooK^00<0?EV[0?ofkP3o
m^h00`3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3o
m^h02`3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`000000ooK^00/0ooK^00<0?EV[0?ofkP3o
m^h01P3om^h00`0mFJ/0ooK^0?ofkP080?ofkP030000003om^h0ooK^04l0ooK^0@3oool00580ooK^
00<000000?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00X0ooK^
00<0000003eIZ`3om^h01@3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00<0ooK^
00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00l0ooK^
00D0?EV[0=@m6@3D?AT0e3dI03eIZ`030?ofkP030=@m6@00000000000080KR8@00<0000009D^5@2E
;QD00P2E;QD30000000309D^5@000000?EV[00L0]SLH00<000000=0n6`3@?Q/02@3@?Q/00`000000
iD@M03eIZ`03000000030>E47@000000000000L0000000@0e3dI00000000000000000P15Jm801@00
0000AF_B00000015Jm8000000080AF_B0`0000000`3D?AT0000000000007000000080?mA8P000000
00000000000mFJ/0oe4R0000003D?AT:0?mD8`030000003oER<0oeHS00D0oeHS00<0?EV[0000003o
ER<00`0000030?mF8`040000003oEB80oeDR0?mE8P80000000D0e3dI0?ofkP3om^h0ooK^03eIZ`03
0=@m6@0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP0=
0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP04
0?ofkP0303eIZ`000000ooK^00/0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP07
0?ofkP030000003om^h0ooK^0500ooK^0@3oool00580ooK^00<000000?ofkP3om^h01`3om^h00`0m
FJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<000000?ofkP0mFJ/01P3om^h00`0m
FJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h03P3om^h01@0m
FJ/0ooK^0?ofkP3om^h0?EV[0140ooK^00@0?EV[0=@m6@3D?AT0?EV[103om^h20=@m6@050?ofkP00
0000000006hR400000001P2E;QD20000000403eIZ`0000000000000000D0]SLH00<000000=0n6`3@
?Q/00`3@?Q/7000000030>E47@000000000000T0000000D0AF_B0000003D?AT0AF_B0000000204E[
dP0400000015Jm80AF_B00000080AF_B00P0000004E[dP15Jm80000004E[dP3D?AT0000004E[dP/0
000000<0oe4R0000000000001@0000050?mD8`030000003oER<0oeHS00<0oeHS0`0000000`0mFJ/0
0000000000060?mF8`050000003oEB8000000000003om^h00P3D?AT40?ofkP0403eIZ`3D?AT0e3dI
03eIZa40ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0@0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0
?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0403eIZ`3om^h0ooK^000000`0ooK^
00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP080?ofkP030000003om^h0ooK^0500ooK^
0@3oool00580ooK^00<000000?ofkP3om^h0203om^j303eIZ`030=0n6`000000000000@000000`3D
?AT7000000030=@m6@000000000000d0000000<0e3dI0000000000001@0000030=@m6@H0000000<0
oe@S03eIZ`0mFJ/0P@0mFJ/:0?ofkP030000003om^h0ooK^0500ooK^0@3oool005<0ooK^00<00000
0?ofkP3om^h0203om^h203eIZ`80ooK^I@0mFJ/01P3D?AT0000003eIZ`0mFJ/0UBhE00000080?EV[
1`2f=aP00`000000d3hK0=0n6`08000000030=@m6@0jGKP0000000H000001@3D?AT00`0jGKP00000
0=@m6@0303YM^0050000000jGKP0>Ufh03YM^00000000`0jGKP01`000000>Ufh03YM^00jGKP0e3dI
0000000jGKP01@3D?AT70000000303YM^03D?AT0000000L000000P3oE2<00`000000oeHS0?mF8`05
0?mF8`80?EV[00H000000?mF8`0mFJ/0?EV[0000003D?AUU03eIZ`80ooK^0P0mFJ/:0?ofkP030000
003om^h0ooK^0540ooK^0@3oool005<0ooK^00<000000?ofkP3om^h02P3om^ic03eIZ`030=@m6@00
0000000000/0000000<0e3dI0000000000002`00000E0=@m6@d0000000<0e3dI0000000000002`00
00000`3D?AT0?EV[03eIZ`1a03eIZ``0ooK^00<000000?ofkP3om^h0D@3om^h10?ooo`00D`3om^h0
0`000000ooK^0?ofkP0K0?ofkP030000003om^h0ooK^04<0ooK^0P3D?AT20?ofkP040=@m6@3om^h0
ooK^0=@m6@@0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@080?ofkP040=@m6@3om^h0ooK^0=@m6@d0
ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00d0
ooK^00<0e3dI0?ofkP3om^h02`3om^h0103D?AT0ooK^0?ofkP3D?AT80?ofkP050=@m6@3om^h0ooK^
0?ofkP3D?AT0103om^h01@3D?AT0ooK^0?ofkP3D?AT0ooK^00<0e3dIA@3om^h00`000000ooK^0?of
kP0K0?ofkP030000003om^h0ooK^0540ooK^0@3oool005@0ooK^00<000000?ofkP3om^h06P3om^h0
0`000000ooK^0?ofkP130?ofkP<0e3dI0P3om^h0103D?AT0ooK^0?ofkP3D?AT40?ofkP040=@m6@3o
m^h0ooK^0=@m6@T0ooK^0`3D?AT=0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h0
3@3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00/0ooK^0`3D?AT90?ofkP040=@m
6@3om^h0ooK^0=@m6@@0ooK^00@0e3dI0?ofkP3om^h0e3dI0P3om^h30=@m6DD0ooK^00<000000?of
kP3om^h06P3om^h00`000000ooK^0?ofkP1B0?ofkP40oooo001D0?ofkP030000003om^h0ooK^01X0
ooK^00<000000?ofkP3om^h0@`3om^h30=@m6@80ooK^00@0e3dI0?ofkP3om^h0e3dI1@3om^h0103D
?AT0ooK^0?ofkP3D?AT:0?ofkP80e3dI303om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0
ooK^00d0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP80e3dI2P3om^h0
103D?AT0ooK^0?ofkP3D?AT50?ofkP040=@m6@3om^h0ooK^0=@m6@80ooK^0`3D?AU50?ofkP030000
003om^h0ooK^01X0ooK^00<000000?ofkP3om^h0DP3om^h10?ooo`00E03om^h00`000000ooK^0?of
kP0J0?ofkP030000003om^h0ooK^04<0ooK^0`3D?AT30?ofkP030=@m6@3om^h0e3dI00H0ooK^00<0
e3dI0?ofkP3D?AT02P3om^h00`3D?AT0ooK^0=@m6@020=@m6@T0ooK^00<0e3dI0?ofkP3om^h03@3o
m^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h01`3o
m^h30=@m6@030?ofkP3D?AT0ooK^00T0ooK^00<0e3dI0?ofkP3D?AT01P3om^h00`3D?AT0ooK^0=@m
6@030?ofkP<0e3dIA@3om^h00`000000ooK^0?ofkP0J0?ofkP030000003om^h0ooK^0580ooK^0@3o
ool005D0ooK^00<000000?ofkP3om^h0603om^h00`000000ooK^0?ofkP140?ofkP<0e3dI103om^h2
0=@m6@L0ooK^0P3D?AT:0?ofkP030=@m6@3om^h0ooK^0080ooK^0P3D?AT70?ofkP030=@m6@3om^h0
ooK^00d0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0
ooK^00D0ooK^0P3D?AT40?ofkP030=@m6@3om^h0ooK^00P0ooK^0P3D?AT70?ofkP80e3dI103om^h3
0=@m6DH0ooK^00<000000?ofkP3om^h0603om^h00`000000ooK^0?ofkP1C0?ofkP40oooo001E0?of
kP030000003om^h0ooK^01P0ooK^00<000000?ofkP3om^h0A03om^h30=@m6@@0ooK^0P3D?AT80?of
kP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h0103om^h30=@m6@@0ooK^00<0e3dI0?of
kP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?of
kP3om^h00P3om^h30=@m6@H0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP060?of
kP80e3dI103om^h30=@m6DH0ooK^00<000000?ofkP3om^h0603om^h00`000000ooK^0?ofkP1C0?of
kP40oooo001E0?ofkP030000003om^h0ooK^01P0ooK^00<000000?ofkP3om^h0A03om^h40=@m6@@0
ooK^00<0e3dI0?ofkP3om^h01P3om^h30=@m6@P0ooK^00<0e3dI0?ofkP3om^h01`3om^h30=@m6@03
0?ofkP3D?AT0ooK^00h0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP03
0=@m6@3om^h0e3dI0080e3dI2@3om^h00`3D?AT0ooK^0?ofkP060?ofkP<0e3dI203om^h00`3D?AT0
ooK^0?ofkP020?ofkP@0e3dIAP3om^h00`000000ooK^0?ofkP0H0?ofkP030000003om^h0ooK^05<0
ooK^0@3oool005H0ooK^00<000000?ofkP3om^h05`3om^h00`000000ooK^0?ofkP140?ofkP@0e3dI
103om^h20=@m6@L0ooK^00@0e3dI0?ofkP3om^h0e3dI1`3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP@0
e3dI3@3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00/0ooK^103D?AT<0?ofkP03
0=@m6@3om^h0ooK^00D0ooK^00@0e3dI0?ofkP3om^h0e3dI1`3om^h20=@m6@@0ooK^103D?AU60?of
kP030000003om^h0ooK^01L0ooK^00<000000?ofkP3om^h0E03om^h10?ooo`00EP3om^h00`000000
ooK^0?ofkP0G0?ofkP030000003om^h0ooK^04@0ooK^0P3D?AT00`3om^h0e3dI0=@m6@030?ofkP03
0=@m6@3om^h0e3dI00H0ooK^00@0e3dI0?ofkP3om^h0ooK^0P3D?AT60?ofkP030=@m6@3om^h0ooK^
00X0ooK^00<0e3dI0?ofkP3om^h01@3D?AT80?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?of
kP3om^h01P3om^h50=@m6@80ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP040?of
kP80e3dI0`3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0e3dI00<0ooK^0P3D?AT00`3o
m^h0e3dI0=@m6@160?ofkP030000003om^h0ooK^01L0ooK^00<000000?ofkP3om^h0E03om^h10?oo
o`00EP3om^h00`000000ooK^0?ofkP0G0?ofkP030000003om^h0ooK^04D0ooK^0`3D?AT01@3om^h0
e3dI0?ofkP3om^h0e3dI0080ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP030?of
kP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP050?of
kPH0e3dI0P3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00H0e3dI1`3om^h00`3D
?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D
?AT0ooK^0?ofkP030?ofkP040=@m6@3om^h0ooK^0=@m6@80ooK^00<0e3dI0?ofkP3D?AT00P3D?AU7
0?ofkP030000003om^h0ooK^01L0ooK^00<000000?ofkP3om^h0E03om^h10?ooo`00E`3om^h00`00
0000ooK^0?ofkP0F0?ofkP030000003om^h0ooK^04D0ooK^0`3D?AT01@3om^h0e3dI0?ofkP3om^h0
e3dI00<0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP040?ofkP80e3dI0`3om^h0
0`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00/0ooK^5@3D?AT=0?ofkP030=@m6@3om^h0
ooK^00X0ooK^00@0e3dI0?ofkP3om^h0ooK^0P3D?AT50?ofkP030=@m6@3om^h0ooK^00<0ooK^00D0
e3dI0?ofkP3om^h0ooK^0=@m6@020?ofkP030=@m6@3om^h0e3dI0080e3dIA`3om^h00`000000ooK^
0?ofkP0F0?ofkP030000003om^h0ooK^05D0ooK^0@3oool005L0ooK^00<000000?ofkP3om^h05P3o
m^h00`000000ooK^0?ofkP150?ofkP030=@m6@3om^h0e3dI0080ooK^00<0e3dI0?ofkP3D?AT0103o
m^h20=@m6@<0ooK^00<0e3dI0?ofkP3om^h01@3om^h0103D?AT0ooK^0?ofkP3D?AT<0?ofkP030=@m
6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m
6@3om^h0ooK^00X0ooK^00@0e3dI0?ofkP3om^h0e3dI1`3om^h0103D?AT0ooK^0?ofkP3om^h20=@m
6@<0ooK^00@0e3dI0?ofkP3om^h0e3dI0P3om^h00`3D?AT0ooK^0=@m6@170?ofkP030000003om^h0
ooK^01H0ooK^00<000000?ofkP3om^h0E@3om^h10?ooo`00E`3om^h00`000000ooK^0?ofkP0F0?of
kP030000003om^h0ooK^04D0ooK^00<0e3dI0?ofkP3D?AT00P3om^h0103D?AT0ooK^0?ofkP3D?AT5
0?ofkP040=@m6@3om^h0ooK^0=@m6@P0ooK^0`3D?AT<0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0
e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00X0ooK^0`3D
?AT80?ofkP040=@m6@3om^h0ooK^0=@m6@D0ooK^00@0e3dI0?ofkP3om^h0e3dI0P3om^h00`3D?AT0
ooK^0=@m6@170?ofkP030000003om^h0ooK^01H0ooK^00<000000?ofkP3om^h0E@3om^h10?ooo`00
E`3om^h00`000000ooK^0?ofkP0E0?ofkP030000003om^h0ooK^04H0ooK^00@0e3dI0?ofkP3D?AT0
e3dI0P3om^h00`3D?AT0ooK^0=@m6@060?ofkP030=@m6@3om^h0e3dI00X0ooK^0P3D?AT<0?ofkP03
0=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP03
0=@m6@3om^h0ooK^00X0ooK^0P3D?AT:0?ofkP030=@m6@3om^h0e3dI00H0ooK^00<0e3dI0?ofkP3D
?AT00P3om^h20=@m6@030?ofkP3D?AT0ooK^04L0ooK^00<000000?ofkP3om^h05@3om^h00`000000
ooK^0?ofkP1E0?ofkP40oooo001H0?ofkP030000003om^h0ooK^01@0ooK^00<000000?ofkP3om^h0
AP3om^h0103D?AT0ooK^0?ofkP3D?AT30?ofkP80e3dI1`3om^h20=@m6@X0ooK^00<0e3dI0?ofkP3D
?AT00P3D?AT90?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0
ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00L0ooK^0`3D?AT00`3om^h0e3dI0?ofkP090?ofkP80
e3dI1`3om^h20=@m6@<0ooK^00@0e3dI0?ofkP3om^h0e3dIB03om^h00`000000ooK^0?ofkP0D0?of
kP030000003om^h0ooK^05H0ooK^0@3oool005P0ooK^00<000000?ofkP3om^h0503om^h00`000000
ooK^0?ofkP170?ofkP030=@m6@3om^h0e3dI00<0ooK^0P3D?AT80?ofkP030=@m6@3om^h0ooK^00P0
ooK^00<0e3dI0?ofkP3om^h00P3om^h20=@m6@L0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0
ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h01@3om^h20=@m6@@0
ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP060?ofkP80e3dI0`3om^h00`3D?AT0
ooK^0=@m6@190?ofkP030000003om^h0ooK^01@0ooK^00<000000?ofkP3om^h0EP3om^h10?ooo`00
F03om^h00`000000ooK^0?ofkP0D0?ofkP030000003om^h0ooK^04L0ooK^00@0e3dI0?ofkP3D?AT0
e3dI0`3om^h00`3D?AT0ooK^0?ofkP060?ofkP<0e3dI203om^h00`3D?AT0ooK^0?ofkP040?ofkP<0
e3dI103om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3o
m^h0303om^h00`3D?AT0ooK^0?ofkP020?ofkP<0e3dI1P3om^h00`3D?AT0ooK^0?ofkP060?ofkP<0
e3dI203om^h0103D?AT0ooK^0?ofkP3om^h20=@m6@030?ofkP3D?AT0ooK^04P0ooK^00<000000?of
kP3om^h0503om^h00`000000ooK^0?ofkP1F0?ofkP40oooo001I0?ofkP030000003om^h0ooK^01<0
ooK^00<000000?ofkP3om^h0A`3om^h0103D?AT0ooK^0=@m6@3D?AT30?ofkP80e3dI1`3om^h0103D
?AT0ooK^0?ofkP3D?AT70?ofkP030=@m6@3om^h0ooK^00L0ooK^0`3D?AT00`3om^h0e3dI0?ofkP0=
0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0=@m6@02
0=@m6@T0ooK^00<0e3dI0?ofkP3om^h01@3om^h0103D?AT0ooK^0?ofkP3D?AT70?ofkP80e3dI0`3o
m^h20=@m6@030?ofkP3D?AT0ooK^04P0ooK^00<000000?ofkP3om^h04`3om^h00`000000ooK^0?of
kP1G0?ofkP40oooo001I0?ofkP030000003om^h0ooK^01<0ooK^00<000000?ofkP3om^h0B03om^h2
0=@m6@070?ofkP3D?AT0ooK^0?ofkP3D?AT0ooK^0=@m6@060?ofkP040=@m6@3om^h0ooK^0?ofkP80
e3dI1@3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP@0e3dI303om^h00`3D?AT0ooK^0?ofkP0=0?ofkP03
0=@m6@3om^h0ooK^00X0ooK^103D?AT;0?ofkP030=@m6@3om^h0ooK^00@0ooK^0P3D?AT30?ofkP03
0=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3D?AT00P3om^h0103D?AT0ooK^0=@m6@3D?AU:0?of
kP030000003om^h0ooK^01<0ooK^00<000000?ofkP3om^h0E`3om^h10?ooo`00F@3om^h00`000000
ooK^0?ofkP0C0?ofkP030000003om^h0ooK^04P0ooK^0P3D?AT01@3om^h0e3dI0?ofkP3om^h0e3dI
0080ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^
00<0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP050=@m6@L0ooK^00<0e3dI0?of
kP3om^h03@3om^h00`3D?AT0ooK^0?ofkP050?ofkPD0e3dI0P3om^h00`3D?AT0ooK^0?ofkP0:0?of
kP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP030?of
kP040=@m6@3om^h0ooK^0=@m6@80ooK^00@0e3dI0?ofkP3D?AT0e3dIBP3om^h00`000000ooK^0?of
kP0C0?ofkP030000003om^h0ooK^05L0ooK^0@3oool005X0ooK^00<000000?ofkP3om^h04P3om^h0
0`000000ooK^0?ofkP180?ofkP80e3dI0P3om^h00`3D?AT0ooK^0=@m6@030?ofkP030=@m6@3om^h0
ooK^0080ooK^00<0e3dI0?ofkP3om^h0103om^h20=@m6@<0ooK^00<0e3dI0?ofkP3om^h02P3om^h0
0`3D?AT0ooK^0?ofkP050?ofkPD0e3dI0P3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0
ooK^00D0e3dI1`3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP040=@m6@3om^h0ooK^0?ofkP80e3dI1P3o
m^h00`3D?AT0ooK^0?ofkP020?ofkP0;0=@m6@3om^h0ooK^0?ofkP3D?AT0ooK^0=@m6@3om^h0e3dI
0?ofkP3D?AT0BP3om^h00`000000ooK^0?ofkP0B0?ofkP030000003om^h0ooK^05P0ooK^0@3oool0
05X0ooK^00<000000?ofkP3om^h04@3om^h00`000000ooK^0?ofkP1:0?ofkP80e3dI00@0ooK^0=@m
6@3om^h0e3dI103om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00D0ooK^00@0e3dI
0?ofkP3om^h0e3dI303om^h00`3D?AT0ooK^0?ofkP0:0?ofkQD0e3dI303om^h00`3D?AT0ooK^0?of
kP0:0?ofkP040=@m6@3om^h0ooK^0=@m6@L0ooK^00<0e3dI0?ofkP3om^h00P3om^h01@3D?AT0ooK^
0?ofkP3om^h0e3dI0080ooK^00@0e3dI0?ofkP3D?AT0e3dIC03om^h00`000000ooK^0?ofkP0A0?of
kP030000003om^h0ooK^05P0ooK^0@3oool005X0ooK^00<000000?ofkP3om^h04@3om^h00`000000
ooK^0?ofkP1:0?ofkP80e3dI0P3om^h00`3D?AT0ooK^0=@m6@040?ofkP050=@m6@3om^h0ooK^0?of
kP3D?AT0203om^h30=@m6@`0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP0=0?of
kP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h02P3om^h30=@m6@P0ooK^00D0e3dI0?of
kP3om^h0ooK^0=@m6@040?ofkP030=@m6@3om^h0e3dI0080ooK^0P3D?AU<0?ofkP030000003om^h0
ooK^0140ooK^00<000000?ofkP3om^h0F03om^h10?ooo`00F`3om^h00`000000ooK^0?ofkP0@0?of
kP030000003om^h0ooK^04X0ooK^0P3D?AT20?ofkP030=@m6@3om^h0e3dI00D0ooK^00@0e3dI0?of
kP3om^h0e3dI2P3om^h20=@m6@/0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP0=
0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h02@3om^h20=@m6@X0ooK^00@0e3dI
0?ofkP3om^h0e3dI1@3om^h00`3D?AT0ooK^0=@m6@020?ofkP80e3dIC03om^h00`000000ooK^0?of
kP0@0?ofkP030000003om^h0ooK^05T0ooK^0@3oool005/0ooK^00<000000?ofkP3om^h0403om^h0
0`000000ooK^0?ofkP1;0?ofkP040=@m6@3om^h0ooK^0?ofkP80e3dI1P3om^h00`3D?AT0ooK^0=@m
6@0:0?ofkP040=@m6@3om^h0e3dI0=@m6@T0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^
0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h01`3om^h20=@m6@030?of
kP3D?AT0ooK^00T0ooK^00<0e3dI0?ofkP3D?AT01P3om^h20=@m6@<0ooK^00<0e3dI0?ofkP3om^h0
B`3om^h00`000000ooK^0?ofkP0@0?ofkP030000003om^h0ooK^05T0ooK^0@3oool005/0ooK^00<0
00000?ofkP3om^h0403om^h00`000000ooK^0?ofkP1;0?ofkP040=@m6@3om^h0ooK^0?ofkP80e3dI
1`3om^h20=@m6@X0ooK^00@0e3dI0?ofkP3om^h0ooK^0P3D?AT70?ofkP030=@m6@3om^h0ooK^00`0
ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00D0
ooK^0P3D?AT30?ofkP030=@m6@3om^h0ooK^00P0ooK^0P3D?AT70?ofkP80e3dI0`3om^h00`3D?AT0
ooK^0?ofkP1;0?ofkP030000003om^h0ooK^0100ooK^00<000000?ofkP3om^h0F@3om^h10?ooo`00
G03om^h00`000000ooK^0?ofkP0?0?ofkP030000003om^h0ooK^04`0ooK^00D0e3dI0?ofkP3om^h0
ooK^0=@m6@080?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h00`3om^h20=@m6@D0
ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00`0
ooK^00<0e3dI0?ofkP3om^h00`3om^h20=@m6@D0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0
ooK^0?ofkP060?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT0CP3om^h00`000000ooK^0?ofkP0?0?of
kP030000003om^h0ooK^05X0ooK^0@3oool005`0ooK^00<000000?ofkP3om^h03`3om^h00`000000
ooK^0?ofkP1<0?ofkP040=@m6@3om^h0ooK^0?ofkP80e3dI1`3om^h30=@m6@P0ooK^00<0e3dI0?of
kP3om^h01@3om^h20=@m6@<0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP0=0?of
kP030=@m6@3om^h0ooK^00`0ooK^00@0e3dI0?ofkP3om^h0ooK^0P3D?AT70?ofkP030=@m6@3om^h0
ooK^00H0ooK^0`3D?AT70?ofkP80e3dI0`3om^h00`3D?AT0ooK^0?ofkP1<0?ofkP030000003om^h0
ooK^00l0ooK^00<000000?ofkP3om^h0FP3om^h10?ooo`00G03om^h00`000000ooK^0?ofkP0?0?of
kP030000003om^h0ooK^04d0ooK^00H0e3dI0?ofkP3om^h0e3dI0?ofkP3D?AT60?ofkP040=@m6@3o
m^h0ooK^0=@m6@L0ooK^00<0e3dI0?ofkP3om^h01`3om^h20=@m6@030?ofkP3D?AT0ooK^00d0ooK^
00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP040=@m6@3om^h0e3dI0=@m6@T0
ooK^00<0e3dI0?ofkP3om^h01@3om^h0103D?AT0ooK^0?ofkP3D?AT60?ofkP030=@m6@3om^h0e3dI
0080ooK^00<0e3dI0?ofkP3om^h0C@3om^h00`000000ooK^0?ofkP0?0?ofkP030000003om^h0ooK^
05X0ooK^0@3oool005d0ooK^00<000000?ofkP3om^h03P3om^h00`000000ooK^0?ofkP1=0?ofkP04
0=@m6@3om^h0ooK^0=@m6@80ooK^00<0e3dI0?ofkP3om^h00`3om^h0103D?AT0ooK^0?ofkP3om^h2
0=@m6@D0ooK^00<0e3dI0?ofkP3om^h02@3om^h40=@m6@`0ooK^00<0e3dI0?ofkP3om^h03@3om^h0
0`3D?AT0ooK^0?ofkP0:0?ofkP@0e3dI2`3om^h00`3D?AT0ooK^0?ofkP030?ofkP80e3dI0`3om^h0
0`3D?AT0ooK^0?ofkP030?ofkP040=@m6@3om^h0ooK^0=@m6@80ooK^00<0e3dI0?ofkP3om^h0C@3o
m^h00`000000ooK^0?ofkP0>0?ofkP030000003om^h0ooK^05/0ooK^0@3oool005d0ooK^00<00000
0?ofkP3om^h03@3om^h00`000000ooK^0?ofkP1?0?ofkP030=@m6@3om^h0e3dI00<0ooK^00<0e3dI
0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP030?ofkP80e3dI0`3om^h00`3D?AT0ooK^0?ofkP0:
0?ofkP030=@m6@3om^h0ooK^00D0e3dI1`3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0
ooK^00D0ooK^1@3D?AT20?ofkP030=@m6@3om^h0ooK^00X0ooK^00@0e3dI0?ofkP3om^h0ooK^0P3D
?AT50?ofkP030=@m6@3om^h0ooK^0080ooK^00L0e3dI0?ofkP3om^h0ooK^0=@m6@3om^h0e3dI0540
ooK^00<000000?ofkP3om^h03@3om^h00`000000ooK^0?ofkP1K0?ofkP40oooo001M0?ofkP030000
003om^h0ooK^00d0ooK^00<000000?ofkP3om^h0C`3om^h00`3D?AT0ooK^0=@m6@040?ofkP050=@m
6@3om^h0ooK^0?ofkP3D?AT01`3om^h0103D?AT0ooK^0?ofkP3D?AT<0?ofkP030=@m6@3om^h0ooK^
00D0ooK^1@3D?AT20?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h01@3D?AT70?of
kP030=@m6@3om^h0ooK^00X0ooK^00@0e3dI0?ofkP3om^h0e3dI1P3om^h00`3D?AT0ooK^0?ofkP02
0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT00P3om^h00`3D?AT0ooK^0?ofkP1?0?ofkP030000003o
m^h0ooK^00d0ooK^00<000000?ofkP3om^h0F`3om^h10?ooo`00GP3om^h00`000000ooK^0?ofkP0<
0?ofkP030000003om^h0ooK^0500ooK^00<0e3dI0?ofkP3D?AT0103om^h01@3D?AT0ooK^0?ofkP3o
m^h0e3dI00L0ooK^0`3D?AT<0?ofkP030=@m6@3om^h0ooK^00X0ooK^5@3D?AT<0?ofkP030=@m6@3o
m^h0ooK^00X0ooK^0`3D?AT70?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT0103om^h00`3D?AT0ooK^
0=@m6@1B0?ofkP030000003om^h0ooK^00`0ooK^00<000000?ofkP3om^h0G03om^h10?ooo`00GP3o
m^h00`000000ooK^0?ofkP0<0?ofkP030000003om^h0ooK^0500ooK^00<0e3dI0?ofkP3D?AT01@3o
m^h0103D?AT0ooK^0?ofkP3D?AT90?ofkP80e3dI2`3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m
6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP090?ofkP80e3dI
2@3om^h0103D?AT0ooK^0?ofkP3D?AT50?ofkP030=@m6@3om^h0e3dI0580ooK^00<000000?ofkP3o
m^h0303om^h00`000000ooK^0?ofkP1L0?ofkP40oooo001N0?ofkP030000003om^h0ooK^00`0ooK^
00<000000?ofkP3om^h0D@3om^h20=@m6@H0ooK^00<0e3dI0?ofkP3D?AT02@3om^h0103D?AT0ooK^
0=@m6@3D?AT90?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0
ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00P0ooK^0P3D?AT00`3om^h0e3dI0?ofkP080?ofkP03
0=@m6@3om^h0e3dI00H0ooK^0P3D?AUC0?ofkP030000003om^h0ooK^00`0ooK^00<000000?ofkP3o
m^h0G03om^h10?ooo`00GP3om^h00`000000ooK^0?ofkP0<0?ofkP030000003om^h0ooK^0540ooK^
0P3D?AT70?ofkP80e3dI2@3om^h0103D?AT0ooK^0?ofkP3om^h20=@m6@P0ooK^00<0e3dI0?ofkP3o
m^h02`3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3o
m^h01P3om^h20=@m6@<0ooK^00<0e3dI0?ofkP3om^h01`3om^h20=@m6@L0ooK^0P3D?AUC0?ofkP03
0000003om^h0ooK^00`0ooK^00<000000?ofkP3om^h0G03om^h10?ooo`00G`3om^h00`000000ooK^
0?ofkP0;0?ofkP030000003om^h0ooK^0580ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^
0?ofkP070?ofkP030=@m6@3om^h0ooK^00<0ooK^0`3D?AT50?ofkP030=@m6@3om^h0ooK^00/0ooK^
00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00<0ooK^
0`3D?AT50?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^
0?ofkP1B0?ofkP030000003om^h0ooK^00/0ooK^00<000000?ofkP3om^h0G@3om^h10?ooo`00G`3o
m^h00`000000ooK^0?ofkP0;0?ofkP030000003om^h0ooK^05<0ooK^00<0e3dI0?ofkP3om^h01@3o
m^h30=@m6@L0ooK^00<0e3dI0?ofkP3om^h01P3om^h20=@m6@<0ooK^00<0e3dI0?ofkP3om^h02`3o
m^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00/0ooK^00@0e3dI0?ofkP3om^h0ooK^
0P3D?AT80?ofkP030=@m6@3om^h0ooK^00D0ooK^0`3D?AT70?ofkP030=@m6@3om^h0ooK^05<0ooK^
00<000000?ofkP3om^h02`3om^h00`000000ooK^0?ofkP1M0?ofkP40oooo001O0?ofkP030000003o
m^h0ooK^00X0ooK^00<000000?ofkP3om^h0E@3om^h00`3D?AT0ooK^0?ofkP040?ofkP040=@m6@3o
m^h0ooK^0=@m6@H0ooK^00<0e3dI0?ofkP3om^h0203om^h20=@m6@030?ofkP3D?AT0ooK^00d0ooK^
00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP0;0?ofkP040=@m6@3om^h0e3dI0=@m6@T0
ooK^00<0e3dI0?ofkP3om^h01@3om^h0103D?AT0ooK^0?ofkP3D?AT60?ofkP030=@m6@3om^h0ooK^
05@0ooK^00<000000?ofkP3om^h02`3om^h00`000000ooK^0?ofkP1M0?ofkP40oooo001P0?ofkP03
0000003om^h0ooK^00T0ooK^00<000000?ofkP3om^h0EP3om^h00`3D?AT0ooK^0?ofkP030?ofkP04
0=@m6@3om^h0ooK^0?ofkP80e3dI1@3om^h00`3D?AT0ooK^0?ofkP090?ofkP@0e3dI303om^h00`3D
?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00T0ooK^103D?AT;0?ofkP030=@m6@3om^h0ooK^
00<0ooK^0P3D?AT30?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h0EP3om^h00`00
0000ooK^0?ofkP090?ofkP030000003om^h0ooK^05h0ooK^0@3oool00600ooK^00<000000?ofkP3o
m^h02@3om^h00`000000ooK^0?ofkP1G0?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3o
m^h00`3om^h20=@m6@<0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP050=@m6@L0
ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP050?ofkP@0e3dI0P3om^h00`3D?AT0
ooK^0?ofkP0:0?ofkP040=@m6@3om^h0ooK^0?ofkP80e3dI1@3om^h00`3D?AT0ooK^0?ofkP020?of
kP030=@m6@3om^h0ooK^05L0ooK^00<000000?ofkP3om^h02@3om^h00`000000ooK^0?ofkP1N0?of
kP40oooo001P0?ofkP030000003om^h0ooK^00T0ooK^00<000000?ofkP3om^h0F03om^h20=@m6@<0
ooK^00<0e3dI0?ofkP3om^h0103om^h0103D?AT0ooK^0?ofkP3D?AT<0?ofkP030=@m6@3om^h0ooK^
00D0ooK^1@3D?AT20?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h01@3D?AT60?of
kP030=@m6@3om^h0ooK^00X0ooK^00@0e3dI0?ofkP3om^h0e3dI1P3om^h0103D?AT0ooK^0?ofkP3o
m^h20=@m6EX0ooK^00<000000?ofkP3om^h02@3om^h00`000000ooK^0?ofkP1N0?ofkP40oooo001Q
0?ofkP030000003om^h0ooK^00P0ooK^00<000000?ofkP3om^h0FP3om^h0103D?AT0ooK^0?ofkP3D
?AT70?ofkP<0e3dI303om^h00`3D?AT0ooK^0?ofkP0:0?ofkQ@0e3dI2`3om^h00`3D?AT0ooK^0?of
kP0:0?ofkP<0e3dI1`3om^h0103D?AT0ooK^0?ofkP3D?AUL0?ofkP030000003om^h0ooK^00P0ooK^
00<000000?ofkP3om^h0G`3om^h10?ooo`00H@3om^h00`000000ooK^0?ofkP080?ofkP030000003o
m^h0ooK^05/0ooK^00<0e3dI0?ofkP3D?AT02@3om^h20=@m6@/0ooK^00<0e3dI0?ofkP3om^h0303o
m^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h02@3o
m^h20=@m6@T0ooK^00<0e3dI0?ofkP3D?AT0G@3om^h00`000000ooK^0?ofkP080?ofkP030000003o
m^h0ooK^05l0ooK^0@3oool00640ooK^00<000000?ofkP3om^h0203om^h00`000000ooK^0?ofkP1L
0?ofkP80e3dI2@3om^h0103D?AT0ooK^0=@m6@3D?AT90?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0
e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00L0ooK^0P3D
?AT00`3om^h0e3dI0?ofkP080?ofkP80e3dIGP3om^h00`000000ooK^0?ofkP080?ofkP030000003o
m^h0ooK^05l0ooK^0@3oool00680ooK^00<000000?ofkP3om^h01`3om^h00`000000ooK^0?ofkP1M
0?ofkP030=@m6@3om^h0ooK^00L0ooK^00@0e3dI0?ofkP3om^h0ooK^0`3D?AT60?ofkP030=@m6@3o
m^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3o
m^h0ooK^00@0ooK^0`3D?AT30?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h0G@3o
m^h00`000000ooK^0?ofkP070?ofkP030000003om^h0ooK^0600ooK^0@3oool00680ooK^00<00000
0?ofkP3om^h01`3om^h00`000000ooK^0?ofkP1N0?ofkP80e3dI1`3om^h00`3D?AT0ooK^0?ofkP04
0?ofkP<0e3dI0`3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI
0?ofkP3om^h02`3om^h0103D?AT0ooK^0?ofkP3om^h30=@m6@H0ooK^00<0e3dI0?ofkP3om^h01@3o
m^h20=@m6F00ooK^00<000000?ofkP3om^h01`3om^h00`000000ooK^0?ofkP1P0?ofkP40oooo001R
0?ofkP030000003om^h0ooK^00H0ooK^00<000000?ofkP3om^h0H@3om^h00`3D?AT0ooK^0?ofkP04
0?ofkP030=@m6@3om^h0ooK^00L0ooK^0P3D?AT00`3om^h0e3dI0?ofkP0=0?ofkP030=@m6@3om^h0
ooK^00/0ooK^00<0e3dI0?ofkP3om^h0303om^h0103D?AT0ooK^0=@m6@3D?AT90?ofkP030=@m6@3o
m^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h0H@3om^h00`000000ooK^0?ofkP060?ofkP030000003o
m^h0ooK^0600ooK^0@3oool006<0ooK^00<000000?ofkP3om^h01@3om^h00`000000ooK^0?ofkP1R
0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h02@3om^h40=@m6@`0ooK^00<0e3dI
0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP@0e3dI2P3om^h00`3D?AT0ooK^0?ofkP04
0?ofkP030=@m6@3om^h0ooK^0680ooK^00<000000?ofkP3om^h01@3om^h00`000000ooK^0?ofkP1Q
0?ofkP40oooo001S0?ofkP030000003om^h0ooK^00D0ooK^00<000000?ofkP3om^h0H`3om^h20=@m
6@@0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP050=@m6@L0ooK^00<0e3dI0?of
kP3om^h02`3om^h00`3D?AT0ooK^0?ofkP050?ofkPD0e3dI0P3om^h00`3D?AT0ooK^0?ofkP090?of
kP030=@m6@3om^h0ooK^0080ooK^0P3D?AUU0?ofkP030000003om^h0ooK^00D0ooK^00<000000?of
kP3om^h0H@3om^h10?ooo`00H`3om^h00`000000ooK^0?ofkP050?ofkP030000003om^h0ooK^06D0
ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0;0?ofkP030=@m6@3om^h0ooK^00D0ooK^1@3D?AT20?of
kP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h01@3D?AT70?ofkP030=@m6@3om^h0ooK^
00T0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@1W0?ofkP030000003om^h0ooK^00D0ooK^00<00000
0?ofkP3om^h0H@3om^h10?ooo`00I03om^h00`000000ooK^0?ofkP040?ofkP030000003om^h0ooK^
06H0ooK^00@0e3dI0?ofkP3om^h0e3dI2`3om^h00`3D?AT0ooK^0?ofkP0:0?ofkQ<0e3dI303om^h0
0`3D?AT0ooK^0?ofkP090?ofkP040=@m6@3om^h0ooK^0=@m6FP0ooK^00<000000?ofkP3om^h0103o
m^h00`000000ooK^0?ofkP1R0?ofkP40oooo001T0?ofkP030000003om^h0ooK^00@0ooK^00<00000
0?ofkP3om^h0I`3om^h30=@m6@/0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP0;
0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h02@3om^h30=@m6FT0ooK^00<00000
0?ofkP3om^h0103om^h00`000000ooK^0?ofkP1R0?ofkP40oooo001T0?ofkP030000003om^h0ooK^
00@0ooK^00<000000?ofkP3om^h0J@3om^h20=@m6@X0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D
?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h02@3om^h20=@m
6F/0ooK^00<000000?ofkP3om^h0103om^h00`000000ooK^0?ofkP1R0?ofkP40oooo001U0?ofkP03
0000003om^h0ooK^00<0ooK^00<000000?ofkP3om^h0J`3om^h20=@m6@T0ooK^00<0e3dI0?ofkP3o
m^h02`3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3o
m^h01`3om^h20=@m6Fd0ooK^00<000000?ofkP3om^h00`3om^h00`000000ooK^0?ofkP1S0?ofkP40
oooo001U0?ofkP030000003om^h0ooK^00<0ooK^00<000000?ofkP3om^h0K@3om^h30=@m6@H0ooK^
00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00/0ooK^
00<0e3dI0?ofkP3om^h0103om^h30=@m6Fl0ooK^00<000000?ofkP3om^h00`3om^h00`000000ooK^
0?ofkP1S0?ofkP40oooo001U0?ofkP030000003om^h0ooK^0080ooK^00<000000?ofkP3om^h0L@3o
m^h30=@m6@<0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3o
m^h0ooK^00/0ooK^00@0e3dI0?ofkP3om^h0ooK^0`3D?AUc0?ofkP030000003om^h0ooK^0080ooK^
00<000000?ofkP3om^h0H`3om^h10?ooo`00I@3om^h00`000000ooK^0?ofkP020?ofkP030000003o
m^h0ooK^07@0ooK^0P3D?AT00`3om^h0e3dI0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0
e3dI0?ofkP3om^h02`3om^h0103D?AT0ooK^0=@m6@3D?AUf0?ofkP030000003om^h0ooK^0080ooK^
00<000000?ofkP3om^h0H`3om^h10?ooo`00IP3om^h01@000000ooK^0?ofkP3om^h0000007P0ooK^
1@3D?AT:0?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h0203om^h50=@m6GP0ooK^
00D000000?ofkP3om^h0ooK^0000001V0?ofkP40oooo001V0?ofkP050000003om^h0ooK^0?ofkP00
0000O@3om^h70=@m6@<0ooK^00<0e3dI0?ofkP3om^h02`3om^h0103D?AT0ooK^0?ofkP3om^h70=@m
6Gd0ooK^00D000000?ofkP3om^h0ooK^0000001V0?ofkP40oooo001V0?ofkP050000003om^h0ooK^
0?ofkP000000Q03om^hE0=@m6H@0ooK^00D000000?ofkP3om^h0ooK^0000001V0?ofkP40oooo001W
0?ofkP040000003om^h0ooK^00000?l0ooK^7P3om^h010000000ooK^0?ofkP00001W0?ofkP40oooo
001W0?ofkP040000003om^h0ooK^00000?l0ooK^7P3om^h010000000ooK^0?ofkP00001W0?ofkP40
oooo001W0?ofkP040000003om^h0ooK^00000?l0ooK^7P3om^h010000000ooK^0?ofkP00001W0?of
kP40oooo001X0?ofkP800000o`3om^hP0?ofkP800000J03om^h10?ooo`00J03om^h200000?l0ooK^
803om^h2000006P0ooK^0@3oool006P0ooK^0P00003o0?ofkR00ooK^0P00001X0?ofkP40oooo001Y
0?ofkP030000003om^h0ooK^0?l0ooK^7P3om^h00`000000ooK^0?ofkP1W0?ofkP40oooo001Y0?of
k_l000008P00001Y0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3o
m^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40
oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?of
k_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3o
ool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^
m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?oo
o`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd
0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo
003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0
ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool0
0?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03o
m^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00
o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?of
kP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o
0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^
0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0
ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h1
0?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3o
m^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40
oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?of
k_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3o
ool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^
m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?oo
o`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd
0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo
003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0
ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool0
0?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03o
m^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00
o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00\
\>"],
  ImageRangeCache->{{{0, 499}, {499, 0}} -> {-5.00005*^-06, -5.00005*^-06, \
0.00200403, 0.00200403}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
%%ImageSize: 500 500 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics3D
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Background color
1 .961 .933 r
MFill
% Scaling calculations
0 1 0 1 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 0 r
.25 Mabswid
[ ] 0 setdash
.24028 .08168 m
.19793 .35868 L
s
.19793 .35868 m
.13045 .74993 L
s
.13045 .74993 m
.16861 .50547 L
s
.16861 .50547 m
.24028 .08168 L
s
.91053 .22236 m
.67872 .58361 L
s
.67872 .58361 m
.6978 .81857 L
s
.6978 .81857 m
.97075 .49223 L
s
.97075 .49223 m
.91053 .22236 L
s
.24028 .08168 m
.19793 .35868 L
s
.19793 .35868 m
.97075 .49223 L
s
.97075 .49223 m
.91053 .22236 L
s
.91053 .22236 m
.24028 .08168 L
s
.16861 .50547 m
.67872 .58361 L
s
.67872 .58361 m
.6978 .81857 L
s
.6978 .81857 m
.13045 .74993 L
s
.13045 .74993 m
.16861 .50547 L
s
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
.83 .24 .1 r
.5 Mabswid
.47256 .55588 m
.49565 .56818 L
s
.48149 .53577 m
.47256 .55588 L
s
.44775 .54761 m
.47256 .55588 L
s
.49565 .56818 m
.51618 .58405 L
s
.50501 .54826 m
.49565 .56818 L
s
.45626 .52733 m
.44775 .54761 L
s
.42217 .54369 m
.44775 .54761 L
s
.51618 .58405 m
.53334 .60293 L
s
.52593 .56436 m
.51618 .58405 L
s
.43025 .52327 m
.42217 .54369 L
s
.39675 .54431 m
.42217 .54369 L
s
.53334 .60293 m
.54642 .62415 L
s
.54345 .58347 m
.53334 .60293 L
s
.40443 .52378 m
.39675 .54431 L
s
.3725 .54952 m
.39675 .54431 L
s
.54642 .62415 m
.55482 .64691 L
s
.55683 .60493 m
.54642 .62415 L
s
.37979 .52894 m
.3725 .54952 L
s
.35037 .55922 m
.3725 .54952 L
s
.50501 .54826 m
.48149 .53577 L
s
.49075 .51493 m
.48149 .53577 L
s
.48149 .53577 m
.45626 .52733 L
s
.52593 .56436 m
.50501 .54826 L
s
.5147 .52763 m
.50501 .54826 L
s
.46508 .50631 m
.45626 .52733 L
s
.45626 .52733 m
.43025 .52327 L
s
.54345 .58347 m
.52593 .56436 L
s
.53603 .54395 m
.52593 .56436 L
s
.43863 .5021 m
.43025 .52327 L
s
.43025 .52327 m
.40443 .52378 L
s
.55482 .64691 m
.5581 .67035 L
s
.56548 .62794 m
.55482 .64691 L
s
.35733 .53862 m
.35037 .55922 L
s
.33134 .57313 m
.35037 .55922 L
s
.55683 .60493 m
.54345 .58347 L
s
.55392 .5633 m
.54345 .58347 L
s
.41238 .5025 m
.40443 .52378 L
s
.40443 .52378 m
.37979 .52894 L
s
.56548 .62794 m
.55683 .60493 L
s
.56763 .58501 m
.55683 .60493 L
s
.5581 .67035 m
.56892 .65162 L
s
.5581 .67035 m
.55595 .6935 L
s
.38735 .50759 m
.37979 .52894 L
s
.37979 .52894 m
.35733 .53862 L
s
.5147 .52763 m
.49075 .51493 L
s
.50036 .49333 m
.49075 .51493 L
s
.49075 .51493 m
.46508 .50631 L
s
.33801 .55258 m
.33134 .57313 L
s
.31627 .59079 m
.33134 .57313 L
s
.53603 .54395 m
.5147 .52763 L
s
.52475 .50624 m
.5147 .52763 L
s
.47422 .48451 m
.46508 .50631 L
s
.46508 .50631 m
.43863 .5021 L
s
.55392 .5633 m
.53603 .54395 L
s
.54651 .52279 m
.53603 .54395 L
s
.44731 .48015 m
.43863 .5021 L
s
.43863 .5021 m
.41238 .5025 L
s
.56892 .65162 m
.56548 .62794 L
s
.57654 .60827 m
.56548 .62794 L
s
.36454 .51727 m
.35733 .53862 L
s
.35733 .53862 m
.33801 .55258 L
s
.56763 .58501 m
.55392 .5633 L
s
.56479 .54239 m
.55392 .5633 L
s
.55595 .6935 m
.54831 .71538 L
s
.56686 .675 m
.55595 .6935 L
s
.42063 .48044 m
.41238 .5025 L
s
.41238 .5025 m
.38735 .50759 L
s
.32274 .57035 m
.31627 .59079 L
s
.30595 .61157 m
.31627 .59079 L
s
.57654 .60827 m
.56763 .58501 L
s
.57883 .56435 m
.56763 .58501 L
s
.56892 .65162 m
.58015 .63219 L
s
.56686 .675 m
.56892 .65162 L
s
.3952 .48545 m
.38735 .50759 L
s
.38735 .50759 m
.36454 .51727 L
s
.52475 .50624 m
.50036 .49333 L
s
.51032 .47091 m
.50036 .49333 L
s
.50036 .49333 m
.47422 .48451 L
s
.34494 .53126 m
.33801 .55258 L
s
.33801 .55258 m
.32274 .57035 L
s
.54651 .52279 m
.52475 .50624 L
s
.53518 .48405 m
.52475 .50624 L
s
.48371 .4619 m
.47422 .48451 L
s
.47422 .48451 m
.44731 .48015 L
s
.54831 .71538 m
.53532 .73497 L
s
.55919 .69708 m
.54831 .71538 L
s
.3123 .59129 m
.30595 .61157 L
s
.301 .63465 m
.30595 .61157 L
s
.56479 .54239 m
.54651 .52279 L
s
.55738 .50083 m
.54651 .52279 L
s
.45633 .45737 m
.44731 .48015 L
s
.44731 .48015 m
.42063 .48044 L
s
.58015 .63219 m
.57654 .60827 L
s
.58801 .58786 m
.57654 .60827 L
s
.37203 .4951 m
.36454 .51727 L
s
.36454 .51727 m
.34494 .53126 L
s
.57883 .56435 m
.56479 .54239 L
s
.57606 .52068 m
.56479 .54239 L
s
.55919 .69708 m
.56686 .675 L
s
.57817 .6558 m
.56686 .675 L
s
.24 .35 .67 r
.73 .54129 m
.72692 .56888 L
s
.69411 .53554 m
.73 .54129 L
s
.73513 .51389 m
.73 .54129 L
s
.83 .24 .1 r
.42919 .45753 m
.42063 .48044 L
s
.42063 .48044 m
.3952 .48545 L
s
.32946 .54912 m
.32274 .57035 L
s
.32274 .57035 m
.3123 .59129 L
s
.24 .35 .67 r
.69922 .50799 m
.73513 .51389 L
s
.74214 .48758 m
.73513 .51389 L
s
.72692 .56888 m
.726 .59574 L
s
.69093 .56326 m
.72692 .56888 L
s
.83 .24 .1 r
.53532 .73497 m
.51741 .75129 L
s
.54608 .71683 m
.53532 .73497 L
s
.30733 .61457 m
.301 .63465 L
s
.30182 .65903 m
.301 .63465 L
s
.24 .35 .67 r
.69093 .56326 m
.69411 .53554 L
s
.65787 .52974 m
.69411 .53554 L
s
.69411 .53554 m
.69922 .50799 L
s
.7061 .48153 m
.74214 .48758 L
s
.75083 .46327 m
.74214 .48758 L
s
.66296 .50204 m
.69922 .50799 L
s
.69922 .50799 m
.7061 .48153 L
s
.83 .24 .1 r
.58801 .58786 m
.57883 .56435 L
s
.58015 .63219 m
.59181 .61202 L
s
.57817 .6558 m
.58015 .63219 L
s
.24 .35 .67 r
.6898 .59022 m
.69093 .56326 L
s
.65459 .55758 m
.69093 .56326 L
s
.83 .24 .1 r
.40334 .46246 m
.3952 .48545 L
s
.3952 .48545 m
.37203 .4951 L
s
.53518 .48405 m
.51032 .47091 L
s
.52066 .44764 m
.51032 .47091 L
s
.51032 .47091 m
.48371 .4619 L
s
.24 .35 .67 r
.726 .59574 m
.72732 .62095 L
s
.6898 .59022 m
.726 .59574 L
s
.83 .24 .1 r
.35213 .50913 m
.34494 .53126 L
s
.34494 .53126 m
.32946 .54912 L
s
.55738 .50083 m
.53518 .48405 L
s
.49355 .43843 m
.48371 .4619 L
s
.48371 .4619 m
.45633 .45737 L
s
.24 .35 .67 r
.65459 .55758 m
.65787 .52974 L
s
.62126 .52387 m
.65787 .52974 L
s
.65787 .52974 m
.66296 .50204 L
s
.83 .24 .1 r
.54608 .71683 m
.55919 .69708 L
s
.57049 .67808 m
.55919 .69708 L
s
.24 .35 .67 r
.66969 .47541 m
.7061 .48153 L
s
.7061 .48153 m
.71453 .45704 L
s
.62632 .49603 m
.66296 .50204 L
s
.66296 .50204 m
.66969 .47541 L
s
.83 .24 .1 r
.3189 .57022 m
.3123 .59129 L
s
.3123 .59129 m
.30733 .61457 L
s
.57606 .52068 m
.55738 .50083 L
s
.24 .35 .67 r
.65323 .58464 m
.65459 .55758 L
s
.61787 .55184 m
.65459 .55758 L
s
.83 .24 .1 r
.51741 .75129 m
.49527 .76347 L
s
.52794 .73327 m
.51741 .75129 L
s
.46569 .43372 m
.45633 .45737 L
s
.45633 .45737 m
.42919 .45753 L
s
.24 .35 .67 r
.69079 .6155 m
.6898 .59022 L
s
.65323 .58464 m
.6898 .59022 L
s
.71453 .45704 m
.75083 .46327 L
s
.76094 .44185 m
.75083 .46327 L
s
.83 .24 .1 r
.30823 .63921 m
.30182 .65903 L
s
.30855 .6836 m
.30182 .65903 L
s
.24 .35 .67 r
.61787 .55184 m
.62126 .52387 L
s
.62126 .52387 m
.62632 .49603 L
s
.83 .24 .1 r
.59181 .61202 m
.58801 .58786 L
s
.24 .35 .67 r
.63291 .46924 m
.66969 .47541 L
s
.66969 .47541 m
.67787 .45075 L
s
.58932 .48996 m
.62632 .49603 L
s
.62632 .49603 m
.63291 .46924 L
s
.83 .24 .1 r
.3798 .47208 m
.37203 .4951 L
s
.37203 .4951 m
.35213 .50913 L
s
.24 .35 .67 r
.72732 .62095 m
.69079 .6155 L
s
.72732 .62095 m
.73089 .64356 L
s
.61629 .57901 m
.61787 .55184 L
s
.83 .24 .1 r
.57049 .67808 m
.57817 .6558 L
s
.58992 .63586 m
.57817 .6558 L
s
.24 .35 .67 r
.65388 .61 m
.65323 .58464 L
s
.61629 .57901 m
.65323 .58464 L
s
.83 .24 .1 r
.43808 .43375 m
.42919 .45753 L
s
.42919 .45753 m
.40334 .46246 L
s
.24 .35 .67 r
.67787 .45075 m
.71453 .45704 L
s
.71453 .45704 m
.72428 .43545 L
s
.83 .24 .1 r
.33643 .52708 m
.32946 .54912 L
s
.32946 .54912 m
.3189 .57022 L
s
.257 .362 .701 r
.56993 .53748 m .58669 .54012 L .59276 .5623 L p F P
0 0 0 r
s
.83 .24 .1 r
.57606 .52068 m
.5781 .52382 L
s
.57883 .56435 m
.5847 .55353 L
s
.264 .375 .727 r
.58669 .54012 m .56993 .53748 L .56349 .51466 L p F P
0 0 0 r
s
.264 .375 .727 r
.56349 .51466 m .57871 .5171 L .58669 .54012 L p F P
0 0 0 r
s
.471 .137 .065 r
.59201 .53023 m .58669 .54012 L .59276 .5623 L p F P
0 0 0 r
s
.24 .35 .67 r
.59242 .54787 m
.61787 .55184 L
s
.578 .169 .078 r
.58669 .54012 m .59201 .53023 L .58348 .50795 L p F P
0 0 0 r
s
.24 .35 .67 r
.58751 .51847 m
.62126 .52387 L
s
.578 .169 .078 r
.58348 .50795 m .57871 .5171 L .58669 .54012 L p F P
0 0 0 r
s
.667 .196 .088 r
.57871 .5171 m .58348 .50795 L .57307 .48547 L p F P
0 0 0 r
s
.667 .196 .088 r
.57307 .48547 m .56897 .49365 L .57871 .5171 L p F P
0 0 0 r
s
.27 .386 .75 r
.57871 .5171 m .56349 .51466 L .55561 .49147 L p F P
0 0 0 r
s
.83 .24 .1 r
.55738 .50083 m
.55822 .49914 L
s
.27 .386 .75 r
.55561 .49147 m .56897 .49365 L .57871 .5171 L p F P
0 0 0 r
s
.24 .35 .67 r
.58524 .51256 m
.58932 .48996 L
s
.59576 .463 m
.63291 .46924 L
s
.63291 .46924 m
.64082 .4444 L
s
.57398 .48744 m
.58932 .48996 L
s
.58932 .48996 m
.59576 .463 L
s
.83 .24 .1 r
.52794 .73327 m
.54608 .71683 L
s
.55725 .698 m
.54608 .71683 L
s
.264 .375 .727 r
.54819 .51221 m .56349 .51466 L .56993 .53748 L p F P
0 0 0 r
s
.27 .386 .75 r
.56349 .51466 m .54819 .51221 L .5422 .48928 L p F P
0 0 0 r
s
.27 .386 .75 r
.5422 .48928 m .55561 .49147 L .56349 .51466 L p F P
0 0 0 r
s
.257 .362 .701 r
.59276 .5623 m .57484 .55954 L .56993 .53748 L p F P
0 0 0 r
s
.24 .35 .67 r
.58078 .54605 m
.58313 .52713 L
s
.83 .24 .1 r
.58075 .52792 m
.59046 .5429 L
s
.24 .35 .67 r
.58078 .54605 m
.58916 .54736 L
s
.83 .24 .1 r
.5878 .5478 m
.59046 .5429 L
s
.257 .362 .701 r
.5531 .53484 m .56993 .53748 L .57484 .55954 L p F P
0 0 0 r
s
.264 .375 .727 r
.56993 .53748 m .5531 .53484 L .54819 .51221 L p F P
0 0 0 r
s
.83 .24 .1 r
.49527 .76347 m
.46984 .77082 L
s
.50547 .74552 m
.49527 .76347 L
s
.34 .098 .05 r
.59851 .55191 m .59276 .5623 L .5968 .58325 L p F P
0 0 0 r
s
.471 .137 .065 r
.59276 .5623 m .59851 .55191 L .59201 .53023 L p F P
0 0 0 r
s
.248 .347 .671 r
.57484 .55954 m .59276 .5623 L .5968 .58325 L p F P
0 0 0 r
s
.83 .24 .1 r
.58801 .58786 m
.59294 .57908 L
s
.275 .396 .771 r
.56897 .49365 m .55561 .49147 L .54644 .4683 L p F P
0 0 0 r
s
.275 .396 .771 r
.54644 .4683 m .55761 .47016 L .56897 .49365 L p F P
0 0 0 r
s
.744 .218 .097 r
.56897 .49365 m .57307 .48547 L .56097 .46321 L p F P
0 0 0 r
s
.744 .218 .097 r
.56097 .46321 m .55761 .47016 L .56897 .49365 L p F P
0 0 0 r
s
.24 .35 .67 r
.69079 .6155 m
.65388 .61 L
s
.69392 .63817 m
.69079 .6155 L
s
.83 .24 .1 r
.3139 .59372 m
.30733 .61457 L
s
.30733 .61457 m
.30823 .63921 L
s
.24 .35 .67 r
.6166 .60445 m
.61629 .57901 L
s
.59719 .5761 m
.61629 .57901 L
s
.83 .24 .1 r
.31515 .66408 m
.30855 .6836 L
s
.32101 .70718 m
.30855 .6836 L
s
.264 .375 .727 r
.53284 .50975 m .54819 .51221 L .5531 .53484 L p F P
0 0 0 r
s
.27 .386 .75 r
.54819 .51221 m .53284 .50975 L .52875 .48708 L p F P
0 0 0 r
s
.27 .386 .75 r
.52875 .48708 m .5422 .48928 L .54819 .51221 L p F P
0 0 0 r
s
.275 .396 .771 r
.55561 .49147 m .5422 .48928 L .53523 .46644 L p F P
0 0 0 r
s
.83 .24 .1 r
.53518 .48405 m
.53847 .47705 L
s
.275 .396 .771 r
.53523 .46644 m .54644 .4683 L .55561 .49147 L p F P
0 0 0 r
s
.24 .35 .67 r
.55193 .48382 m
.56624 .48617 L
s
.64082 .4444 m
.67787 .45075 L
s
.67787 .45075 m
.68724 .42897 L
s
.257 .362 .701 r
.57484 .55954 m .55683 .55676 L .5531 .53484 L p F P
0 0 0 r
s
.257 .362 .701 r
.53619 .53218 m .5531 .53484 L .55683 .55676 L p F P
0 0 0 r
s
.264 .375 .727 r
.5531 .53484 m .53619 .53218 L .53284 .50975 L p F P
0 0 0 r
s
.24 .35 .67 r
.54691 .51197 m
.57954 .51719 L
s
.248 .347 .671 r
.5968 .58325 m .57811 .58042 L .57484 .55954 L p F P
0 0 0 r
s
.24 .35 .67 r
.57897 .57332 m
.5958 .57589 L
s
.57897 .57332 m
.58078 .54605 L
s
.248 .347 .671 r
.55683 .55676 m .57484 .55954 L .57811 .58042 L p F P
0 0 0 r
s
.24 .35 .67 r
.54691 .51197 m
.55193 .48382 L
s
.72428 .43545 m
.76094 .44185 L
s
.77214 .4242 m
.76094 .44185 L
s
.275 .396 .771 r
.5422 .48928 m .52875 .48708 L .52399 .46458 L p F P
0 0 0 r
s
.275 .396 .771 r
.52399 .46458 m .53523 .46644 L .5422 .48928 L p F P
0 0 0 r
s
.264 .375 .727 r
.51742 .50728 m .53284 .50975 L .53619 .53218 L p F P
0 0 0 r
s
.27 .386 .75 r
.53284 .50975 m .51742 .50728 L .51524 .48488 L p F P
0 0 0 r
s
.27 .386 .75 r
.51524 .48488 m .52875 .48708 L .53284 .50975 L p F P
0 0 0 r
s
.24 .35 .67 r
.59576 .463 m
.6034 .43798 L
s
.83 .24 .1 r
.40334 .46246 m
.3798 .47208 L
s
.257 .362 .701 r
.55683 .55676 m .53874 .55397 L .53619 .53218 L p F P
0 0 0 r
s
.24 .35 .67 r
.54331 .54019 m
.54691 .51197 L
s
.54331 .54019 m
.58078 .54605 L
s
.257 .362 .701 r
.5192 .52951 m .53619 .53218 L .53874 .55397 L p F P
0 0 0 r
s
.264 .375 .727 r
.53619 .53218 m .5192 .52951 L .51742 .50728 L p F P
0 0 0 r
s
.83 .24 .1 r
.52066 .44764 m
.49355 .43843 L
s
.237 .33 .635 r
.57811 .58042 m .5968 .58325 L .59871 .60259 L p F P
0 0 0 r
s
.231 .067 .035 r
.60284 .57261 m .5968 .58325 L .59871 .60259 L p F P
0 0 0 r
s
.34 .098 .05 r
.5968 .58325 m .60284 .57261 L .59851 .55191 L p F P
0 0 0 r
s
.81 .238 .105 r
.55761 .47016 m .56097 .46321 L .54737 .44156 L p F P
0 0 0 r
s
.24 .35 .67 r
.55786 .45826 m
.55822 .45669 L
s
.81 .238 .105 r
.54737 .44156 m .54482 .44706 L .55761 .47016 L p F P
0 0 0 r
s
.28 .405 .79 r
.55761 .47016 m .54644 .4683 L .53611 .44559 L p F P
0 0 0 r
s
.83 .24 .1 r
.54286 .46771 m
.54454 .46413 L
s
.28 .405 .79 r
.53611 .44559 m .54482 .44706 L .55761 .47016 L p F P
0 0 0 r
s
.24 .35 .67 r
.55193 .48382 m
.55642 .46449 L
s
.83 .24 .1 r
.52066 .44764 m
.54221 .459 L
s
.248 .347 .671 r
.57811 .58042 m .55932 .57757 L .55683 .55676 L p F P
0 0 0 r
s
.248 .347 .671 r
.53874 .55397 m .55683 .55676 L .55932 .57757 L p F P
0 0 0 r
s
.24 .35 .67 r
.65388 .61 m
.6166 .60445 L
s
.65658 .63272 m
.65388 .61 L
s
.83 .24 .1 r
.3596 .48613 m
.35213 .50913 L
s
.35213 .50913 m
.33643 .52708 L
s
.578 .169 .078 r
.58831 .49865 m .58348 .50795 L .59201 .53023 L p F P
0 0 0 r
s
.667 .196 .088 r
.58348 .50795 m .58831 .49865 L .57723 .47719 L p F P
0 0 0 r
s
.667 .196 .088 r
.57723 .47719 m .57307 .48547 L .58348 .50795 L p F P
0 0 0 r
s
.275 .396 .771 r
.52875 .48708 m .51524 .48488 L .51272 .4627 L p F P
0 0 0 r
s
.275 .396 .771 r
.51272 .4627 m .52399 .46458 L .52875 .48708 L p F P
0 0 0 r
s
.264 .375 .727 r
.50193 .5048 m .51742 .50728 L .5192 .52951 L p F P
0 0 0 r
s
.27 .386 .75 r
.51742 .50728 m .50193 .5048 L .50169 .48267 L p F P
0 0 0 r
s
.27 .386 .75 r
.50169 .48267 m .51524 .48488 L .51742 .50728 L p F P
0 0 0 r
s
.83 .24 .1 r
.49355 .43843 m
.46569 .43372 L
s
.471 .137 .065 r
.59742 .52016 m .59201 .53023 L .59851 .55191 L p F P
0 0 0 r
s
.578 .169 .078 r
.59201 .53023 m .59742 .52016 L .58831 .49865 L p F P
0 0 0 r
s
.28 .405 .79 r
.54644 .4683 m .53523 .46644 L .52739 .44412 L p F P
0 0 0 r
s
.28 .405 .79 r
.52739 .44412 m .53611 .44559 L .54644 .4683 L p F P
0 0 0 r
s
.257 .362 .701 r
.53874 .55397 m .52055 .55116 L .5192 .52951 L p F P
0 0 0 r
s
.257 .362 .701 r
.50213 .52683 m .5192 .52951 L .52055 .55116 L p F P
0 0 0 r
s
.264 .375 .727 r
.5192 .52951 m .50213 .52683 L .50193 .5048 L p F P
0 0 0 r
s
.24 .35 .67 r
.50917 .50592 m
.54691 .51197 L
s
.744 .218 .097 r
.57307 .48547 m .57723 .47719 L .56436 .45617 L p F P
0 0 0 r
s
.744 .218 .097 r
.56436 .45617 m .56097 .46321 L .57307 .48547 L p F P
0 0 0 r
s
.83 .24 .1 r
.56431 .48683 m
.56867 .47804 L
s
.24 .35 .67 r
.56542 .4579 m
.59576 .463 L
s
.55822 .45669 m
.56367 .45761 L
s
.83 .24 .1 r
.55248 .46587 m
.56867 .47804 L
s
.55725 .698 m
.57049 .67808 L
s
.58223 .65834 m
.57049 .67808 L
s
.24 .35 .67 r
.6034 .43798 m
.64082 .4444 L
s
.64082 .4444 m
.64981 .42243 L
s
.73089 .64356 m
.73666 .66268 L
s
.69392 .63817 m
.73089 .64356 L
s
.275 .396 .771 r
.51524 .48488 m .50169 .48267 L .50141 .46083 L p F P
0 0 0 r
s
.275 .396 .771 r
.50141 .46083 m .51272 .4627 L .51524 .48488 L p F P
0 0 0 r
s
.24 .35 .67 r
.51417 .47763 m
.55193 .48382 L
s
.248 .347 .671 r
.55932 .57757 m .54044 .57471 L .53874 .55397 L p F P
0 0 0 r
s
.24 .35 .67 r
.54126 .56757 m
.57897 .57332 L
s
.54126 .56757 m
.54331 .54019 L
s
.248 .347 .671 r
.52055 .55116 m .53874 .55397 L .54044 .57471 L p F P
0 0 0 r
s
.237 .33 .635 r
.59871 .60259 m .57966 .59975 L .57811 .58042 L p F P
0 0 0 r
s
.237 .33 .635 r
.55932 .57757 m .57811 .58042 L .57966 .59975 L p F P
0 0 0 r
s
.83 .24 .1 r
.46984 .77082 m
.44232 .77285 L
s
.47963 .75287 m
.46984 .77082 L
s
.24 .35 .67 r
.50917 .50592 m
.51417 .47763 L
s
.28 .405 .79 r
.53523 .46644 m .52399 .46458 L .51865 .44264 L p F P
0 0 0 r
s
.28 .405 .79 r
.51865 .44264 m .52739 .44412 L .53523 .46644 L p F P
0 0 0 r
s
.264 .375 .727 r
.48638 .50231 m .50193 .5048 L .50213 .52683 L p F P
0 0 0 r
s
.27 .386 .75 r
.50193 .5048 m .48638 .50231 L .48808 .48045 L p F P
0 0 0 r
s
.27 .386 .75 r
.48808 .48045 m .50169 .48267 L .50193 .5048 L p F P
0 0 0 r
s
.24 .35 .67 r
.68724 .42897 m
.72428 .43545 L
s
.72428 .43545 m
.73502 .41761 L
s
.83 .24 .1 r
.32575 .54833 m
.3189 .57022 L
s
.3189 .57022 m
.3139 .59372 L
s
.32791 .68796 m
.32101 .70718 L
s
.33873 .72857 m
.32101 .70718 L
s
.24 .35 .67 r
.55672 .45644 m
.55822 .45669 L
s
.257 .362 .701 r
.52055 .55116 m .50228 .54834 L .50213 .52683 L p F P
0 0 0 r
s
.24 .35 .67 r
.50545 .53428 m
.50917 .50592 L
s
.50545 .53428 m
.54331 .54019 L
s
.257 .362 .701 r
.48498 .52413 m .50213 .52683 L .50228 .54834 L p F P
0 0 0 r
s
.264 .375 .727 r
.50213 .52683 m .48498 .52413 L .48638 .50231 L p F P
0 0 0 r
s
.275 .396 .771 r
.50169 .48267 m .48808 .48045 L .49007 .45894 L p F P
0 0 0 r
s
.275 .396 .771 r
.49007 .45894 m .50141 .46083 L .50169 .48267 L p F P
0 0 0 r
s
.34 .098 .05 r
.60436 .54133 m .59851 .55191 L .60284 .57261 L p F P
0 0 0 r
s
.471 .137 .065 r
.59851 .55191 m .60436 .54133 L .59742 .52016 L p F P
0 0 0 r
s
.83 .24 .1 r
.59046 .5429 m
.59992 .56666 L
s
.28 .405 .79 r
.52399 .46458 m .51272 .4627 L .50988 .44116 L p F P
0 0 0 r
s
.28 .405 .79 r
.50988 .44116 m .51865 .44264 L .52399 .46458 L p F P
0 0 0 r
s
.24 .35 .67 r
.51417 .47763 m
.5203 .45032 L
s
.83 .24 .1 r
.50547 .74552 m
.52794 .73327 L
s
.53888 .71456 m
.52794 .73327 L
s
.46569 .43372 m
.43808 .43375 L
s
.248 .347 .671 r
.54044 .57471 m .52146 .57184 L .52055 .55116 L p F P
0 0 0 r
s
.248 .347 .671 r
.50228 .54834 m .52055 .55116 L .52146 .57184 L p F P
0 0 0 r
s
.237 .33 .635 r
.57966 .59975 m .5605 .5969 L .55932 .57757 L p F P
0 0 0 r
s
.237 .33 .635 r
.54044 .57471 m .55932 .57757 L .5605 .5969 L p F P
0 0 0 r
s
.264 .375 .727 r
.47076 .49981 m .48638 .50231 L .48498 .52413 L p F P
0 0 0 r
s
.27 .386 .75 r
.48638 .50231 m .47076 .49981 L .47443 .47822 L p F P
0 0 0 r
s
.27 .386 .75 r
.47443 .47822 m .48808 .48045 L .48638 .50231 L p F P
0 0 0 r
s
.24 .35 .67 r
.61884 .62721 m
.6166 .60445 L
s
.81 .238 .105 r
.56097 .46321 m .56436 .45617 L .54994 .436 L p F P
0 0 0 r
s
.24 .35 .67 r
.55822 .45669 m
.55827 .45654 L
s
.81 .238 .105 r
.54994 .436 m .54737 .44156 L .56097 .46321 L p F P
0 0 0 r
s
.24 .35 .67 r
.5203 .45032 m
.55064 .45542 L
s
.28 .405 .79 r
.51272 .4627 m .50141 .46083 L .50109 .43968 L p F P
0 0 0 r
s
.28 .405 .79 r
.50109 .43968 m .50988 .44116 L .51272 .4627 L p F P
0 0 0 r
s
.275 .396 .771 r
.48808 .48045 m .47443 .47822 L .47869 .45705 L p F P
0 0 0 r
s
.275 .396 .771 r
.47869 .45705 m .49007 .45894 L .48808 .48045 L p F P
0 0 0 r
s
.83 .24 .1 r
.31489 .61862 m
.30823 .63921 L
s
.30823 .63921 m
.31515 .66408 L
s
.257 .362 .701 r
.50228 .54834 m .48391 .54551 L .48498 .52413 L p F P
0 0 0 r
s
.257 .362 .701 r
.46775 .52142 m .48498 .52413 L .48391 .54551 L p F P
0 0 0 r
s
.264 .375 .727 r
.48498 .52413 m .46775 .52142 L .47076 .49981 L p F P
0 0 0 r
s
.24 .35 .67 r
.47103 .49981 m
.50917 .50592 L
s
.224 .307 .59 r
.57966 .59975 m .59871 .60259 L .59841 .61991 L p F P
0 0 0 r
s
.83 .24 .1 r
.58992 .63586 m
.59175 .61275 L
s
.231 .067 .035 r
.59871 .60259 m .60489 .59192 L .60284 .57261 L p F P
0 0 0 r
s
.83 .24 .1 r
.5945 .5763 m
.59992 .56666 L
s
.171 .049 .025 r
.60489 .59192 m .59871 .60259 L .59841 .61991 L p F P
0 0 0 r
s
.24 .35 .67 r
.60248 .60234 m
.6166 .60445 L
s
.284 .414 .807 r
.54482 .44706 m .53611 .44559 L .5248 .42375 L p F P
0 0 0 r
s
.284 .414 .807 r
.5248 .42375 m .53079 .42478 L .54482 .44706 L p F P
0 0 0 r
s
.87 .256 .112 r
.54482 .44706 m .54737 .44156 L .5325 .42094 L p F P
0 0 0 r
s
.87 .256 .112 r
.5325 .42094 m .53079 .42478 L .54482 .44706 L p F P
0 0 0 r
s
.264 .375 .727 r
.45508 .4973 m .47076 .49981 L .46775 .52142 L p F P
0 0 0 r
s
.27 .386 .75 r
.47076 .49981 m .45508 .4973 L .46073 .47599 L p F P
0 0 0 r
s
.27 .386 .75 r
.46073 .47599 m .47443 .47822 L .47076 .49981 L p F P
0 0 0 r
s
.24 .35 .67 r
.6034 .43798 m
.612 .41582 L
s
.248 .347 .671 r
.52146 .57184 m .50238 .56895 L .50228 .54834 L p F P
0 0 0 r
s
.24 .35 .67 r
.50317 .56176 m
.54126 .56757 L
s
.50317 .56176 m
.50545 .53428 L
s
.248 .347 .671 r
.48391 .54551 m .50228 .54834 L .50238 .56895 L p F P
0 0 0 r
s
.24 .35 .67 r
.69917 .6573 m
.69392 .63817 L
s
.65658 .63272 m
.69392 .63817 L
s
.28 .405 .79 r
.50141 .46083 m .49007 .45894 L .49229 .43819 L p F P
0 0 0 r
s
.28 .405 .79 r
.49229 .43819 m .50109 .43968 L .50141 .46083 L p F P
0 0 0 r
s
.237 .33 .635 r
.5605 .5969 m .54124 .59403 L .54044 .57471 L p F P
0 0 0 r
s
.237 .33 .635 r
.52146 .57184 m .54044 .57471 L .54124 .59403 L p F P
0 0 0 r
s
.275 .396 .771 r
.47443 .47822 m .46073 .47599 L .46727 .45516 L p F P
0 0 0 r
s
.275 .396 .771 r
.46727 .45516 m .47869 .45705 L .47443 .47822 L p F P
0 0 0 r
s
.24 .35 .67 r
.47601 .47136 m
.51417 .47763 L
s
.47103 .49981 m
.47601 .47136 L
s
.578 .169 .078 r
.59323 .4892 m .58831 .49865 L .59742 .52016 L p F P
0 0 0 r
s
.667 .196 .088 r
.58831 .49865 m .59323 .4892 L .58144 .46878 L p F P
0 0 0 r
s
.667 .196 .088 r
.58144 .46878 m .57723 .47719 L .58831 .49865 L p F P
0 0 0 r
s
.83 .24 .1 r
.57753 .51787 m
.58777 .49814 L
s
.56867 .47804 m
.58777 .49814 L
s
.284 .414 .807 r
.53611 .44559 m .52739 .44412 L .5188 .42272 L p F P
0 0 0 r
s
.83 .24 .1 r
.52258 .44331 m
.52494 .43801 L
s
.284 .414 .807 r
.5188 .42272 m .5248 .42375 L .53611 .44559 L p F P
0 0 0 r
s
.24 .35 .67 r
.64981 .42243 m
.68724 .42897 L
s
.68724 .42897 m
.69751 .41095 L
s
.744 .218 .097 r
.57723 .47719 m .58144 .46878 L .5678 .44906 L p F P
0 0 0 r
s
.744 .218 .097 r
.5678 .44906 m .56436 .45617 L .57723 .47719 L p F P
0 0 0 r
s
.257 .362 .701 r
.48391 .54551 m .46546 .54266 L .46775 .52142 L p F P
0 0 0 r
s
.257 .362 .701 r
.45045 .5187 m .46775 .52142 L .46546 .54266 L p F P
0 0 0 r
s
.24 .35 .67 r
.46721 .5283 m
.50545 .53428 L
s
.264 .375 .727 r
.46775 .52142 m .45045 .5187 L .45508 .4973 L p F P
0 0 0 r
s
.24 .35 .67 r
.46721 .5283 m
.47103 .49981 L
s
.83 .24 .1 r
.44232 .77285 m
.41404 .76938 L
s
.45162 .75484 m
.44232 .77285 L
s
.28 .405 .79 r
.49007 .45894 m .47869 .45705 L .48346 .4367 L p F P
0 0 0 r
s
.28 .405 .79 r
.48346 .4367 m .49229 .43819 L .49007 .45894 L p F P
0 0 0 r
s
.264 .375 .727 r
.43933 .49478 m .45508 .4973 L .45045 .5187 L p F P
0 0 0 r
s
.27 .386 .75 r
.45508 .4973 m .43933 .49478 L .44697 .47374 L p F P
0 0 0 r
s
.27 .386 .75 r
.44697 .47374 m .46073 .47599 L .45508 .4973 L p F P
0 0 0 r
s
.284 .414 .807 r
.52739 .44412 m .51865 .44264 L .5128 .42169 L p F P
0 0 0 r
s
.284 .414 .807 r
.5128 .42169 m .5188 .42272 L .52739 .44412 L p F P
0 0 0 r
s
.24 .35 .67 r
.5203 .45032 m
.52738 .42494 L
s
.231 .067 .035 r
.609 .56176 m .60284 .57261 L .60489 .59192 L p F P
0 0 0 r
s
.34 .098 .05 r
.60284 .57261 m .609 .56176 L .60436 .54133 L p F P
0 0 0 r
s
.83 .24 .1 r
.59992 .56666 m
.60392 .59107 L
s
.34601 .70967 m
.33873 .72857 L
s
.3609 .74666 m
.33873 .72857 L
s
.58223 .65834 m
.58992 .63586 L
s
.224 .307 .59 r
.59841 .61991 m .57941 .61713 L .57966 .59975 L p F P
0 0 0 r
s
.224 .307 .59 r
.5605 .5969 m .57966 .59975 L .57941 .61713 L p F P
0 0 0 r
s
.24 .35 .67 r
.57893 .59883 m
.59914 .60185 L
s
.57893 .59883 m
.57897 .57332 L
s
.275 .396 .771 r
.46073 .47599 m .44697 .47374 L .45583 .45326 L p F P
0 0 0 r
s
.275 .396 .771 r
.45583 .45326 m .46727 .45516 L .46073 .47599 L p F P
0 0 0 r
s
.471 .137 .065 r
.60292 .50992 m .59742 .52016 L .60436 .54133 L p F P
0 0 0 r
s
.83 .24 .1 r
.59046 .5429 m
.60254 .52061 L
s
.578 .169 .078 r
.59742 .52016 m .60292 .50992 L .59323 .4892 L p F P
0 0 0 r
s
.248 .347 .671 r
.50238 .56895 m .4832 .56604 L .48391 .54551 L p F P
0 0 0 r
s
.248 .347 .671 r
.46546 .54266 m .48391 .54551 L .4832 .56604 L p F P
0 0 0 r
s
.237 .33 .635 r
.54124 .59403 m .52189 .59115 L .52146 .57184 L p F P
0 0 0 r
s
.237 .33 .635 r
.50238 .56895 m .52146 .57184 L .52189 .59115 L p F P
0 0 0 r
s
.28 .405 .79 r
.47869 .45705 m .46727 .45516 L .47461 .4352 L p F P
0 0 0 r
s
.28 .405 .79 r
.47461 .4352 m .48346 .4367 L .47869 .45705 L p F P
0 0 0 r
s
.24 .35 .67 r
.47601 .47136 m
.48198 .44389 L
s
.48198 .44389 m
.5203 .45032 L
s
.284 .414 .807 r
.51865 .44264 m .50988 .44116 L .50678 .42066 L p F P
0 0 0 r
s
.284 .414 .807 r
.50678 .42066 m .5128 .42169 L .51865 .44264 L p F P
0 0 0 r
s
.257 .362 .701 r
.46546 .54266 m .44691 .5398 L .45045 .5187 L p F P
0 0 0 r
s
.257 .362 .701 r
.43306 .51597 m .45045 .5187 L .44691 .5398 L p F P
0 0 0 r
s
.264 .375 .727 r
.45045 .5187 m .43306 .51597 L .43933 .49478 L p F P
0 0 0 r
s
.81 .238 .105 r
.56436 .45617 m .5678 .44906 L .55254 .4304 L p F P
0 0 0 r
s
.24 .35 .67 r
.56011 .45023 m
.5607 .4482 L
s
.56558 .43149 m
.6034 .43798 L
s
.81 .238 .105 r
.55254 .4304 m .54994 .436 L .56436 .45617 L p F P
0 0 0 r
s
.24 .35 .67 r
.56239 .44244 m
.56558 .43149 L
s
.264 .375 .727 r
.42352 .49224 m .43933 .49478 L .43306 .51597 L p F P
0 0 0 r
s
.27 .386 .75 r
.43933 .49478 m .42352 .49224 L .43317 .47149 L p F P
0 0 0 r
s
.27 .386 .75 r
.43317 .47149 m .44697 .47374 L .43933 .49478 L p F P
0 0 0 r
s
.24 .35 .67 r
.4325 .49364 m
.47103 .49981 L
s
.87 .256 .112 r
.54737 .44156 m .54994 .436 L .53422 .41707 L p F P
0 0 0 r
s
.87 .256 .112 r
.53422 .41707 m .5325 .42094 L .54737 .44156 L p F P
0 0 0 r
s
.275 .396 .771 r
.44697 .47374 m .43317 .47149 L .44434 .45135 L p F P
0 0 0 r
s
.275 .396 .771 r
.44434 .45135 m .45583 .45326 L .44697 .47374 L p F P
0 0 0 r
s
.83 .24 .1 r
.33643 .52708 m
.32575 .54833 L
s
.284 .414 .807 r
.50988 .44116 m .50109 .43968 L .50075 .41963 L p F P
0 0 0 r
s
.284 .414 .807 r
.50075 .41963 m .50678 .42066 L .50988 .44116 L p F P
0 0 0 r
s
.83 .24 .1 r
.5014 .41974 m
.5031 .41566 L
s
.28 .405 .79 r
.46727 .45516 m .45583 .45326 L .46574 .4337 L p F P
0 0 0 r
s
.28 .405 .79 r
.46574 .4337 m .47461 .4352 L .46727 .45516 L p F P
0 0 0 r
s
.24 .35 .67 r
.73502 .41761 m
.77214 .4242 L
s
.78407 .41113 m
.77214 .4242 L
s
.224 .307 .59 r
.57941 .61713 m .56032 .61433 L .5605 .5969 L p F P
0 0 0 r
s
.224 .307 .59 r
.54124 .59403 m .5605 .5969 L .56032 .61433 L p F P
0 0 0 r
s
.248 .347 .671 r
.4832 .56604 m .46392 .56312 L .46546 .54266 L p F P
0 0 0 r
s
.248 .347 .671 r
.44691 .5398 m .46546 .54266 L .46392 .56312 L p F P
0 0 0 r
s
.24 .35 .67 r
.46468 .55589 m
.46721 .5283 L
s
.46468 .55589 m
.50317 .56176 L
s
.52738 .42494 m
.53404 .42608 L
s
.54298 .42762 m
.56558 .43149 L
s
.83 .24 .1 r
.41404 .76938 m
.38643 .7605 L
s
.42282 .75122 m
.41404 .76938 L
s
.24 .35 .67 r
.66129 .65187 m
.65658 .63272 L
s
.61884 .62721 m
.65658 .63272 L
s
.237 .33 .635 r
.52189 .59115 m .50243 .58825 L .50238 .56895 L p F P
0 0 0 r
s
.237 .33 .635 r
.4832 .56604 m .50238 .56895 L .50243 .58825 L p F P
0 0 0 r
s
.83 .24 .1 r
.36864 .72805 m
.3609 .74666 L
s
.38643 .7605 m
.3609 .74666 L
s
.284 .414 .807 r
.50109 .43968 m .49229 .43819 L .49471 .41859 L p F P
0 0 0 r
s
.284 .414 .807 r
.49471 .41859 m .50075 .41963 L .50109 .43968 L p F P
0 0 0 r
s
.83 .24 .1 r
.53888 .71456 m
.55725 .698 L
s
.56887 .67842 m
.55725 .698 L
s
.257 .362 .701 r
.44691 .5398 m .42827 .53692 L .43306 .51597 L p F P
0 0 0 r
s
.257 .362 .701 r
.41559 .51322 m .43306 .51597 L .42827 .53692 L p F P
0 0 0 r
s
.24 .35 .67 r
.42857 .52226 m
.46721 .5283 L
s
.264 .375 .727 r
.43306 .51597 m .41559 .51322 L .42352 .49224 L p F P
0 0 0 r
s
.24 .35 .67 r
.42857 .52226 m
.4325 .49364 L
s
.27 .386 .75 r
.41931 .46923 m .43317 .47149 L .42352 .49224 L p F P
0 0 0 r
s
.275 .396 .771 r
.43317 .47149 m .41931 .46923 L .43282 .44943 L p F P
0 0 0 r
s
.275 .396 .771 r
.43282 .44943 m .44434 .45135 L .43317 .47149 L p F P
0 0 0 r
s
.24 .35 .67 r
.4325 .49364 m
.43746 .46504 L
s
.43746 .46504 m
.47601 .47136 L
s
.34 .098 .05 r
.61033 .53055 m .60436 .54133 L .609 .56176 L p F P
0 0 0 r
s
.471 .137 .065 r
.60436 .54133 m .61033 .53055 L .60292 .50992 L p F P
0 0 0 r
s
.264 .375 .727 r
.40764 .4897 m .42352 .49224 L .41559 .51322 L p F P
0 0 0 r
s
.27 .386 .75 r
.42352 .49224 m .40764 .4897 L .41931 .46923 L p F P
0 0 0 r
s
.24 .35 .67 r
.612 .41582 m
.64981 .42243 L
s
.64981 .42243 m
.6596 .40422 L
s
.28 .405 .79 r
.45583 .45326 m .44434 .45135 L .45685 .4322 L p F P
0 0 0 r
s
.28 .405 .79 r
.45685 .4322 m .46574 .4337 L .45583 .45326 L p F P
0 0 0 r
s
.83 .24 .1 r
.39468 .74214 m
.38643 .7605 L
s
.47963 .75287 m
.50547 .74552 L
s
.51607 .72687 m
.50547 .74552 L
s
.284 .414 .807 r
.49229 .43819 m .48346 .4367 L .48867 .41755 L p F P
0 0 0 r
s
.284 .414 .807 r
.48867 .41755 m .49471 .41859 L .49229 .43819 L p F P
0 0 0 r
s
.248 .347 .671 r
.46392 .56312 m .44455 .56018 L .44691 .5398 L p F P
0 0 0 r
s
.248 .347 .671 r
.42827 .53692 m .44691 .5398 L .44455 .56018 L p F P
0 0 0 r
s
.224 .307 .59 r
.56032 .61433 m .54112 .61151 L .54124 .59403 L p F P
0 0 0 r
s
.224 .307 .59 r
.52189 .59115 m .54124 .59403 L .54112 .61151 L p F P
0 0 0 r
s
.24 .35 .67 r
.54086 .59316 m
.57893 .59883 L
s
.54086 .59316 m
.54126 .56757 L
s
.83 .24 .1 r
.32073 .57204 m
.3139 .59372 L
s
.3139 .59372 m
.31489 .61862 L
s
.28 .405 .79 r
.44434 .45135 m .43282 .44943 L .44794 .4307 L p F P
0 0 0 r
s
.28 .405 .79 r
.44794 .4307 m .45685 .4322 L .44434 .45135 L p F P
0 0 0 r
s
.27 .386 .75 r
.4054 .46696 m .41931 .46923 L .40764 .4897 L p F P
0 0 0 r
s
.275 .396 .771 r
.41931 .46923 m .4054 .46696 L .42127 .44752 L p F P
0 0 0 r
s
.275 .396 .771 r
.42127 .44752 m .43282 .44943 L .41931 .46923 L p F P
0 0 0 r
s
.237 .33 .635 r
.50243 .58825 m .48286 .58533 L .4832 .56604 L p F P
0 0 0 r
s
.237 .33 .635 r
.46392 .56312 m .4832 .56604 L .48286 .58533 L p F P
0 0 0 r
s
.284 .414 .807 r
.48346 .4367 m .47461 .4352 L .48261 .41651 L p F P
0 0 0 r
s
.284 .414 .807 r
.48261 .41651 m .48867 .41755 L .48346 .4367 L p F P
0 0 0 r
s
.667 .196 .088 r
.58572 .46027 m .58144 .46878 L .59323 .4892 L p F P
0 0 0 r
s
.744 .218 .097 r
.58144 .46878 m .58572 .46027 L .57127 .44186 L p F P
0 0 0 r
s
.744 .218 .097 r
.57127 .44186 m .5678 .44906 L .58144 .46878 L p F P
0 0 0 r
s
.83 .24 .1 r
.322 .64378 m
.31515 .66408 L
s
.31515 .66408 m
.32791 .68796 L
s
.264 .375 .727 r
.41559 .51322 m .39804 .51046 L .40764 .4897 L p F P
0 0 0 r
s
.264 .375 .727 r
.39169 .48715 m .40764 .4897 L .39804 .51046 L p F P
0 0 0 r
s
.27 .386 .75 r
.40764 .4897 m .39169 .48715 L .4054 .46696 L p F P
0 0 0 r
s
.257 .362 .701 r
.42827 .53692 m .40953 .53403 L .41559 .51322 L p F P
0 0 0 r
s
.257 .362 .701 r
.39804 .51046 m .41559 .51322 L .40953 .53403 L p F P
0 0 0 r
s
.87 .256 .112 r
.54994 .436 m .55254 .4304 L .53595 .41318 L p F P
0 0 0 r
s
.87 .256 .112 r
.53595 .41318 m .53422 .41707 L .54994 .436 L p F P
0 0 0 r
s
.578 .169 .078 r
.59822 .4796 m .59323 .4892 L .60292 .50992 L p F P
0 0 0 r
s
.83 .24 .1 r
.58777 .49814 m
.60254 .52061 L
s
.667 .196 .088 r
.59323 .4892 m .59822 .4796 L .58572 .46027 L p F P
0 0 0 r
s
.206 .277 .53 r
.57941 .61713 m .59841 .61991 L .59585 .63484 L p F P
0 0 0 r
s
.83 .24 .1 r
.58992 .63586 m
.59259 .63133 L
s
.096 .028 .012 r
.60457 .60945 m .59841 .61991 L .59585 .63484 L p F P
0 0 0 r
s
.171 .049 .025 r
.59841 .61991 m .60457 .60945 L .60489 .59192 L p F P
0 0 0 r
s
.83 .24 .1 r
.59738 .60239 m
.60392 .59107 L
s
.924 .272 .118 r
.53079 .42478 m .5325 .42094 L .51662 .40176 L p F P
0 0 0 r
s
.924 .272 .118 r
.51662 .40176 m .51577 .40376 L .53079 .42478 L p F P
0 0 0 r
s
.287 .421 .823 r
.53079 .42478 m .5248 .42375 L .51269 .40323 L p F P
0 0 0 r
s
.287 .421 .823 r
.51269 .40323 m .51577 .40376 L .53079 .42478 L p F P
0 0 0 r
s
.83 .24 .1 r
.5295 .42774 m
.5314 .42347 L
s
.284 .414 .807 r
.47461 .4352 m .46574 .4337 L .47654 .41547 L p F P
0 0 0 r
s
.284 .414 .807 r
.47654 .41547 m .48261 .41651 L .47461 .4352 L p F P
0 0 0 r
s
.28 .405 .79 r
.43282 .44943 m .42127 .44752 L .439 .42919 L p F P
0 0 0 r
s
.83 .24 .1 r
.43758 .43384 m
.43808 .43375 L
s
.28 .405 .79 r
.439 .42919 m .44794 .4307 L .43282 .44943 L p F P
0 0 0 r
s
.24 .35 .67 r
.44327 .43739 m
.48198 .44389 L
s
.231 .067 .035 r
.60489 .59192 m .61119 .58104 L .609 .56176 L p F P
0 0 0 r
s
.171 .049 .025 r
.61119 .58104 m .60489 .59192 L .60457 .60945 L p F P
0 0 0 r
s
.24 .35 .67 r
.73666 .66268 m
.7445 .67739 L
s
.69917 .6573 m
.73666 .66268 L
s
.81 .238 .105 r
.5678 .44906 m .57127 .44186 L .55516 .42475 L p F P
0 0 0 r
s
.81 .238 .105 r
.55516 .42475 m .55254 .4304 L .5678 .44906 L p F P
0 0 0 r
s
.83 .24 .1 r
.54823 .45627 m
.55725 .43707 L
s
.27 .386 .75 r
.39144 .46468 m .4054 .46696 L .39169 .48715 L p F P
0 0 0 r
s
.275 .396 .771 r
.4054 .46696 m .39144 .46468 L .40968 .44559 L p F P
0 0 0 r
s
.275 .396 .771 r
.40968 .44559 m .42127 .44752 L .4054 .46696 L p F P
0 0 0 r
s
.287 .421 .823 r
.5248 .42375 m .5188 .42272 L .50962 .40269 L p F P
0 0 0 r
s
.287 .421 .823 r
.50962 .40269 m .51269 .40323 L .5248 .42375 L p F P
0 0 0 r
s
.248 .347 .671 r
.44455 .56018 m .42507 .55723 L .42827 .53692 L p F P
0 0 0 r
s
.248 .347 .671 r
.40953 .53403 m .42827 .53692 L .42507 .55723 L p F P
0 0 0 r
s
.24 .35 .67 r
.42578 .54996 m
.42857 .52226 L
s
.42578 .54996 m
.46468 .55589 L
s
.69751 .41095 m
.73502 .41761 L
s
.73502 .41761 m
.7464 .40437 L
s
.224 .307 .59 r
.54112 .61151 m .52182 .60869 L .52189 .59115 L p F P
0 0 0 r
s
.224 .307 .59 r
.50243 .58825 m .52189 .59115 L .52182 .60869 L p F P
0 0 0 r
s
.24 .35 .67 r
.62301 .64638 m
.61884 .62721 L
s
.59944 .62438 m
.61884 .62721 L
s
.284 .414 .807 r
.46574 .4337 m .45685 .4322 L .47046 .41443 L p F P
0 0 0 r
s
.284 .414 .807 r
.47046 .41443 m .47654 .41547 L .46574 .4337 L p F P
0 0 0 r
s
.83 .24 .1 r
.47314 .41489 m
.47477 .41078 L
s
.264 .375 .727 r
.39804 .51046 m .3804 .50769 L .39169 .48715 L p F P
0 0 0 r
s
.24 .35 .67 r
.39357 .48741 m
.4325 .49364 L
s
.264 .375 .727 r
.37567 .48458 m .39169 .48715 L .3804 .50769 L p F P
0 0 0 r
s
.27 .386 .75 r
.39169 .48715 m .37567 .48458 L .39144 .46468 L p F P
0 0 0 r
s
.237 .33 .635 r
.48286 .58533 m .4632 .58241 L .46392 .56312 L p F P
0 0 0 r
s
.237 .33 .635 r
.44455 .56018 m .46392 .56312 L .4632 .58241 L p F P
0 0 0 r
s
.24 .35 .67 r
.46354 .58164 m
.46468 .55589 L
s
.257 .362 .701 r
.40953 .53403 m .3907 .53112 L .39804 .51046 L p F P
0 0 0 r
s
.257 .362 .701 r
.3804 .50769 m .39804 .51046 L .3907 .53112 L p F P
0 0 0 r
s
.287 .421 .823 r
.5188 .42272 m .5128 .42169 L .50654 .40216 L p F P
0 0 0 r
s
.287 .421 .823 r
.50654 .40216 m .50962 .40269 L .5188 .42272 L p F P
0 0 0 r
s
.28 .405 .79 r
.42127 .44752 m .40968 .44559 L .43005 .42767 L p F P
0 0 0 r
s
.83 .24 .1 r
.4091 .44619 m
.4118 .43858 L
s
.4118 .43858 m
.41919 .43722 L
s
.42641 .43589 m
.43384 .43453 L
s
.28 .405 .79 r
.43005 .42767 m .439 .42919 L .42127 .44752 L p F P
0 0 0 r
s
.24 .35 .67 r
.43746 .46504 m
.44327 .43739 L
s
.471 .137 .065 r
.60852 .4995 m .60292 .50992 L .61033 .53055 L p F P
0 0 0 r
s
.578 .169 .078 r
.60292 .50992 m .60852 .4995 L .59822 .4796 L p F P
0 0 0 r
s
.83 .24 .1 r
.5314 .42347 m
.55725 .43707 L
s
.52127 .42001 m
.5314 .42347 L
s
.24 .35 .67 r
.57379 .40915 m
.612 .41582 L
s
.612 .41582 m
.62129 .39742 L
s
.287 .421 .823 r
.5128 .42169 m .50678 .42066 L .50347 .40162 L p F P
0 0 0 r
s
.287 .421 .823 r
.50347 .40162 m .50654 .40216 L .5128 .42169 L p F P
0 0 0 r
s
.27 .386 .75 r
.37743 .4624 m .39144 .46468 L .37567 .48458 L p F P
0 0 0 r
s
.83 .24 .1 r
.3596 .48613 m
.37648 .47439 L
s
.275 .396 .771 r
.39144 .46468 m .37743 .4624 L .39805 .44366 L p F P
0 0 0 r
s
.275 .396 .771 r
.39805 .44366 m .40968 .44559 L .39144 .46468 L p F P
0 0 0 r
s
.24 .35 .67 r
.39357 .48741 m
.3985 .45864 L
s
.3985 .45864 m
.43746 .46504 L
s
.284 .414 .807 r
.45685 .4322 m .44794 .4307 L .46438 .41338 L p F P
0 0 0 r
s
.284 .414 .807 r
.46438 .41338 m .47046 .41443 L .45685 .4322 L p F P
0 0 0 r
s
.206 .277 .53 r
.59585 .63484 m .57734 .63217 L .57941 .61713 L p F P
0 0 0 r
s
.24 .35 .67 r
.58071 .62165 m
.59791 .62416 L
s
.206 .277 .53 r
.56032 .61433 m .57941 .61713 L .57734 .63217 L p F P
0 0 0 r
s
.24 .35 .67 r
.57893 .59883 m
.58071 .62165 L
s
.231 .067 .035 r
.61528 .5507 m .609 .56176 L .61119 .58104 L p F P
0 0 0 r
s
.34 .098 .05 r
.609 .56176 m .61528 .5507 L .61033 .53055 L p F P
0 0 0 r
s
.924 .272 .118 r
.5325 .42094 m .53422 .41707 L .51747 .39976 L p F P
0 0 0 r
s
.924 .272 .118 r
.51747 .39976 m .51662 .40176 L .5325 .42094 L p F P
0 0 0 r
s
.24 .35 .67 r
.52738 .42494 m
.53022 .41673 L
s
.287 .421 .823 r
.50678 .42066 m .50075 .41963 L .50038 .40108 L p F P
0 0 0 r
s
.287 .421 .823 r
.50038 .40108 m .50347 .40162 L .50678 .42066 L p F P
0 0 0 r
s
.248 .347 .671 r
.42507 .55723 m .40549 .55427 L .40953 .53403 L p F P
0 0 0 r
s
.248 .347 .671 r
.3907 .53112 m .40953 .53403 L .40549 .55427 L p F P
0 0 0 r
s
.28 .405 .79 r
.40968 .44559 m .39805 .44366 L .42107 .42616 L p F P
0 0 0 r
s
.28 .405 .79 r
.42107 .42616 m .43005 .42767 L .40968 .44559 L p F P
0 0 0 r
s
.264 .375 .727 r
.3804 .50769 m .36269 .50491 L .37567 .48458 L p F P
0 0 0 r
s
.264 .375 .727 r
.35959 .482 m .37567 .48458 L .36269 .50491 L p F P
0 0 0 r
s
.83 .24 .1 r
.3596 .48613 m
.35999 .48495 L
s
.27 .386 .75 r
.37567 .48458 m .35959 .482 L .37743 .4624 L p F P
0 0 0 r
s
.224 .307 .59 r
.52182 .60869 m .50242 .60584 L .50243 .58825 L p F P
0 0 0 r
s
.224 .307 .59 r
.48286 .58533 m .50243 .58825 L .50242 .60584 L p F P
0 0 0 r
s
.24 .35 .67 r
.5024 .58743 m
.54086 .59316 L
s
.5024 .58743 m
.50317 .56176 L
s
.284 .414 .807 r
.44794 .4307 m .439 .42919 L .45828 .41234 L p F P
0 0 0 r
s
.284 .414 .807 r
.45828 .41234 m .46438 .41338 L .44794 .4307 L p F P
0 0 0 r
s
.257 .362 .701 r
.3907 .53112 m .37178 .5282 L .3804 .50769 L p F P
0 0 0 r
s
.24 .35 .67 r
.38952 .51616 m
.39357 .48741 L
s
.38952 .51616 m
.42857 .52226 L
s
.257 .362 .701 r
.36269 .50491 m .3804 .50769 L .37178 .5282 L p F P
0 0 0 r
s
.87 .256 .112 r
.55254 .4304 m .55516 .42475 L .53769 .40926 L p F P
0 0 0 r
s
.87 .256 .112 r
.53769 .40926 m .53595 .41318 L .55254 .4304 L p F P
0 0 0 r
s
.237 .33 .635 r
.4632 .58241 m .44343 .57946 L .44455 .56018 L p F P
0 0 0 r
s
.237 .33 .635 r
.42507 .55723 m .44455 .56018 L .44343 .57946 L p F P
0 0 0 r
s
.287 .421 .823 r
.50075 .41963 m .49471 .41859 L .4973 .40055 L p F P
0 0 0 r
s
.287 .421 .823 r
.4973 .40055 m .50038 .40108 L .50075 .41963 L p F P
0 0 0 r
s
1 .338 .139 r
.40055 .4364 m .39805 .44366 L .37743 .4624 L p F P
0 0 0 r
s
1 .338 .139 r
.37743 .4624 m .38029 .45379 L .40055 .4364 L p F P
0 0 0 r
s
.24 .35 .67 r
.38353 .45619 m
.3985 .45864 L
s
1 .336 .137 r
.38029 .45379 m .37743 .4624 L .35959 .482 L p F P
0 0 0 r
s
.83 .24 .1 r
.56887 .67842 m
.58223 .65834 L
s
.287 .421 .823 r
.49471 .41859 m .48867 .41755 L .49421 .40001 L p F P
0 0 0 r
s
.24 .35 .67 r
.48198 .44389 m
.48877 .41832 L
s
.287 .421 .823 r
.49421 .40001 m .4973 .40055 L .49471 .41859 L p F P
0 0 0 r
s
.24 .35 .67 r
.48877 .41832 m
.52738 .42494 L
s
.284 .414 .807 r
.439 .42919 m .43005 .42767 L .45217 .41129 L p F P
0 0 0 r
s
.83 .24 .1 r
.44017 .42817 m
.4406 .42702 L
s
.284 .414 .807 r
.45217 .41129 m .45828 .41234 L .439 .42919 L p F P
0 0 0 r
s
1 .333 .138 r
.42311 .42047 m .42107 .42616 L .39805 .44366 L p F P
0 0 0 r
s
1 .333 .138 r
.39805 .44366 m .40055 .4364 L .42311 .42047 L p F P
0 0 0 r
s
.24 .35 .67 r
.40415 .43082 m
.40763 .4314 L
s
.41204 .43214 m
.44327 .43739 L
s
.40343 .43437 m
.40415 .43082 L
s
.3985 .45864 m
.40252 .43881 L
s
.206 .277 .53 r
.57734 .63217 m .55874 .62948 L .56032 .61433 L p F P
0 0 0 r
s
.206 .277 .53 r
.54112 .61151 m .56032 .61433 L .55874 .62948 L p F P
0 0 0 r
s
.264 .375 .727 r
.36269 .50491 m .34489 .50211 L .35959 .482 L p F P
0 0 0 r
s
1 .336 .137 r
.35959 .482 m .36273 .47229 L .38029 .45379 L p F P
0 0 0 r
s
.24 .35 .67 r
.35914 .45218 m
.37876 .4554 L
s
1 .323 .129 r
.36273 .47229 m .35959 .482 L .34489 .50211 L p F P
0 0 0 r
s
.24 .35 .67 r
.35926 .48191 m
.39357 .48741 L
s
.35423 .4811 m
.35717 .48158 L
s
.83 .24 .1 r
.45162 .75484 m
.47963 .75287 L
s
.4898 .73421 m
.47963 .75287 L
s
.287 .421 .823 r
.48867 .41755 m .48261 .41651 L .49112 .39947 L p F P
0 0 0 r
s
.287 .421 .823 r
.49112 .39947 m .49421 .40001 L .48867 .41755 L p F P
0 0 0 r
s
.24 .35 .67 r
.70642 .672 m
.69917 .6573 L
s
.66129 .65187 m
.69917 .6573 L
s
.248 .347 .671 r
.40549 .55427 m .3858 .55128 L .3907 .53112 L p F P
0 0 0 r
s
.248 .347 .671 r
.37178 .5282 m .3907 .53112 L .3858 .55128 L p F P
0 0 0 r
s
.24 .35 .67 r
.38648 .54397 m
.38952 .51616 L
s
.38648 .54397 m
.42578 .54996 L
s
.924 .272 .118 r
.53422 .41707 m .53595 .41318 L .51832 .39775 L p F P
0 0 0 r
s
.924 .272 .118 r
.51832 .39775 m .51747 .39976 L .53422 .41707 L p F P
0 0 0 r
s
.667 .196 .088 r
.59005 .45163 m .58572 .46027 L .59822 .4796 L p F P
0 0 0 r
s
.744 .218 .097 r
.58572 .46027 m .59005 .45163 L .57479 .43458 L p F P
0 0 0 r
s
.744 .218 .097 r
.57479 .43458 m .57127 .44186 L .58572 .46027 L p F P
0 0 0 r
s
.83 .24 .1 r
.56867 .47804 m
.5804 .45435 L
s
.284 .414 .807 r
.43005 .42767 m .42107 .42616 L .44605 .41024 L p F P
0 0 0 r
s
.284 .414 .807 r
.44605 .41024 m .45217 .41129 L .43005 .42767 L p F P
0 0 0 r
s
.24 .35 .67 r
.6596 .40422 m
.69751 .41095 L
s
.69751 .41095 m
.70833 .39753 L
s
.257 .362 .701 r
.37178 .5282 m .35276 .52527 L .36269 .50491 L p F P
0 0 0 r
s
.257 .362 .701 r
.34489 .50211 m .36269 .50491 L .35276 .52527 L p F P
0 0 0 r
s
.224 .307 .59 r
.50242 .60584 m .48292 .60299 L .48286 .58533 L p F P
0 0 0 r
s
.224 .307 .59 r
.4632 .58241 m .48286 .58533 L .48292 .60299 L p F P
0 0 0 r
s
.34 .098 .05 r
.61641 .51957 m .61033 .53055 L .61528 .5507 L p F P
0 0 0 r
s
.83 .24 .1 r
.59992 .56666 m
.6123 .54463 L
s
.471 .137 .065 r
.61033 .53055 m .61641 .51957 L .60852 .4995 L p F P
0 0 0 r
s
.83 .24 .1 r
.60254 .52061 m
.6123 .54463 L
s
.81 .238 .105 r
.57127 .44186 m .57479 .43458 L .55781 .41904 L p F P
0 0 0 r
s
.81 .238 .105 r
.55781 .41904 m .55516 .42475 L .57127 .44186 L p F P
0 0 0 r
s
.24 .35 .67 r
.56705 .4275 m
.57379 .40915 L
s
.83 .24 .1 r
.55725 .43707 m
.5804 .45435 L
s
.287 .421 .823 r
.48261 .41651 m .47654 .41547 L .48803 .39893 L p F P
0 0 0 r
s
.83 .24 .1 r
.4844 .4107 m
.48542 .41088 L
s
.287 .421 .823 r
.48803 .39893 m .49112 .39947 L .48261 .41651 L p F P
0 0 0 r
s
.237 .33 .635 r
.44343 .57946 m .42355 .5765 L .42507 .55723 L p F P
0 0 0 r
s
.237 .33 .635 r
.40549 .55427 m .42507 .55723 L .42355 .5765 L p F P
0 0 0 r
s
.24 .35 .67 r
.42427 .57579 m
.42578 .54996 L
s
.83 .24 .1 r
.32575 .54833 m
.32073 .57204 L
s
.33507 .66798 m
.32791 .68796 L
s
.32791 .68796 m
.34601 .70967 L
s
.24 .35 .67 r
.35321 .4882 m
.35423 .4811 L
s
.35423 .4811 m
.35914 .45218 L
s
1 .324 .136 r
.44752 .4063 m .44605 .41024 L .42107 .42616 L p F P
0 0 0 r
s
1 .324 .136 r
.42107 .42616 m .42311 .42047 L .44752 .4063 L p F P
0 0 0 r
s
.24 .35 .67 r
.44327 .43739 m
.44976 .41163 L
s
.287 .421 .823 r
.47654 .41547 m .47046 .41443 L .48494 .39839 L p F P
0 0 0 r
s
.83 .24 .1 r
.47932 .40982 m
.48034 .41 L
s
.287 .421 .823 r
.48494 .39839 m .48803 .39893 L .47654 .41547 L p F P
0 0 0 r
s
.83 .24 .1 r
.51607 .72687 m
.53888 .71456 L
s
.55026 .69509 m
.53888 .71456 L
s
.578 .169 .078 r
.60329 .46985 m .59822 .4796 L .60852 .4995 L p F P
0 0 0 r
s
.667 .196 .088 r
.59822 .4796 m .60329 .46985 L .59005 .45163 L p F P
0 0 0 r
s
.83 .24 .1 r
.58777 .49814 m
.59994 .47471 L
s
.5804 .45435 m
.59994 .47471 L
s
.206 .277 .53 r
.55874 .62948 m .54004 .62678 L .54112 .61151 L p F P
0 0 0 r
s
.24 .35 .67 r
.54218 .61602 m
.58071 .62165 L
s
.206 .277 .53 r
.52182 .60869 m .54112 .61151 L .54004 .62678 L p F P
0 0 0 r
s
.24 .35 .67 r
.54086 .59316 m
.54218 .61602 L
s
.287 .421 .823 r
.47046 .41443 m .46438 .41338 L .48184 .39786 L p F P
0 0 0 r
s
.83 .24 .1 r
.47409 .40914 m
.47523 .40915 L
s
.287 .421 .823 r
.48184 .39786 m .48494 .39839 L .47046 .41443 L p F P
0 0 0 r
s
.248 .347 .671 r
.3858 .55128 m .36602 .54829 L .37178 .5282 L p F P
0 0 0 r
s
.248 .347 .671 r
.35276 .52527 m .37178 .5282 L .36602 .54829 L p F P
0 0 0 r
s
.87 .256 .112 r
.55516 .42475 m .55781 .41904 L .53944 .40532 L p F P
0 0 0 r
s
.87 .256 .112 r
.53944 .40532 m .53769 .40926 L .55516 .42475 L p F P
0 0 0 r
s
.24 .35 .67 r
.31936 .44566 m
.35914 .45218 L
s
1 .323 .129 r
.34489 .50211 m .34823 .49155 L .36273 .47229 L p F P
0 0 0 r
s
.24 .35 .67 r
.31448 .47474 m
.35423 .4811 L
s
.997 .292 .115 r
.34823 .49155 m .34489 .50211 L .33364 .52232 L p F P
0 0 0 r
s
.257 .362 .701 r
.35276 .52527 m .33364 .52232 L .34489 .50211 L p F P
0 0 0 r
s
.83 .24 .1 r
.33643 .52708 m
.33774 .52295 L
s
.24 .35 .67 r
.35006 .51 m
.35287 .49055 L
s
.35006 .51 m
.38952 .51616 L
s
.287 .421 .823 r
.46438 .41338 m .45828 .41234 L .47874 .39732 L p F P
0 0 0 r
s
.287 .421 .823 r
.47874 .39732 m .48184 .39786 L .46438 .41338 L p F P
0 0 0 r
s
.224 .307 .59 r
.48292 .60299 m .46331 .60011 L .4632 .58241 L p F P
0 0 0 r
s
.24 .35 .67 r
.46354 .58164 m
.5024 .58743 L
s
.224 .307 .59 r
.44343 .57946 m .4632 .58241 L .46331 .60011 L p F P
0 0 0 r
s
.924 .272 .118 r
.53595 .41318 m .53769 .40926 L .51918 .39573 L p F P
0 0 0 r
s
.24 .35 .67 r
.53249 .41015 m
.53264 .40973 L
s
.924 .272 .118 r
.51918 .39573 m .51832 .39775 L .53595 .41318 L p F P
0 0 0 r
s
.237 .33 .635 r
.42355 .5765 m .40357 .57353 L .40549 .55427 L p F P
0 0 0 r
s
.237 .33 .635 r
.3858 .55128 m .40549 .55427 L .40357 .57353 L p F P
0 0 0 r
s
.83 .24 .1 r
.32181 .5972 m
.31489 .61862 L
s
.31489 .61862 m
.322 .64378 L
s
.096 .028 .012 r
.59585 .63484 m .60182 .6248 L .60457 .60945 L p F P
0 0 0 r
s
.096 .028 .012 r
.61085 .59877 m .60457 .60945 L .60182 .6248 L p F P
0 0 0 r
s
.83 .24 .1 r
.59658 .62456 m
.60214 .61514 L
s
.60214 .61514 m
.60392 .59107 L
s
.171 .049 .025 r
.60457 .60945 m .61085 .59877 L .61119 .58104 L p F P
0 0 0 r
s
.24 .35 .67 r
.34112 .5086 m
.35006 .51 L
s
.287 .421 .823 r
.45828 .41234 m .45217 .41129 L .47564 .39678 L p F P
0 0 0 r
s
.287 .421 .823 r
.47564 .39678 m .47874 .39732 L .45828 .41234 L p F P
0 0 0 r
s
.24 .35 .67 r
.44976 .41163 m
.48877 .41832 L
s
.231 .067 .035 r
.61119 .58104 m .61762 .56995 L .61528 .5507 L p F P
0 0 0 r
s
.171 .049 .025 r
.61762 .56995 m .61119 .58104 L .61085 .59877 L p F P
0 0 0 r
s
.206 .277 .53 r
.54004 .62678 m .52124 .62407 L .52182 .60869 L p F P
0 0 0 r
s
.206 .277 .53 r
.50242 .60584 m .52182 .60869 L .52124 .62407 L p F P
0 0 0 r
s
.287 .421 .823 r
.45217 .41129 m .44605 .41024 L .47253 .39623 L p F P
0 0 0 r
s
.287 .421 .823 r
.47253 .39623 m .47564 .39678 L .45217 .41129 L p F P
0 0 0 r
s
1 .333 .138 r
.42517 .41472 m .42311 .42047 L .40055 .4364 L p F P
0 0 0 r
s
1 .333 .138 r
.40055 .4364 m .40309 .42906 L .42517 .41472 L p F P
0 0 0 r
s
1 .338 .139 r
.40309 .42906 m .40055 .4364 L .38029 .45379 L p F P
0 0 0 r
s
.471 .137 .065 r
.61422 .48889 m .60852 .4995 L .61641 .51957 L p F P
0 0 0 r
s
.578 .169 .078 r
.60852 .4995 m .61422 .48889 L .60329 .46985 L p F P
0 0 0 r
s
.248 .347 .671 r
.36602 .54829 m .34612 .54527 L .35276 .52527 L p F P
0 0 0 r
s
.248 .347 .671 r
.33364 .52232 m .35276 .52527 L .34612 .54527 L p F P
0 0 0 r
s
.24 .35 .67 r
.34676 .53791 m
.38648 .54397 L
s
.66793 .66656 m
.66129 .65187 L
s
.62301 .64638 m
.66129 .65187 L
s
.18 .237 .449 r
.57734 .63217 m .59585 .63484 L .59099 .64701 L p F P
0 0 0 r
s
.083 .024 .01 r
.60182 .6248 m .59585 .63484 L .59099 .64701 L p F P
0 0 0 r
s
1 .338 .139 r
.38029 .45379 m .3832 .44506 L .40309 .42906 L p F P
0 0 0 r
s
.83 .24 .1 r
.38477 .45739 m
.38788 .44816 L
s
.38788 .44816 m
.405 .4413 L
s
.24 .35 .67 r
.36461 .42418 m
.40146 .43037 L
s
1 .336 .137 r
.3832 .44506 m .38029 .45379 L .36273 .47229 L p F P
0 0 0 r
s
.24 .35 .67 r
.35914 .45218 m
.36461 .42418 L
s
.288 .426 .836 r
.5 .38446 m .51577 .40376 L .51269 .40323 L closepath p F P
0 0 0 r
s
.973 .287 .123 r
.5 .38446 m .51577 .40376 L .51662 .40176 L closepath p F P
0 0 0 r
s
1 .313 .132 r
.47332 .39421 m .47253 .39623 L .44605 .41024 L p F P
0 0 0 r
s
1 .313 .132 r
.44605 .41024 m .44752 .4063 L .47332 .39421 L p F P
0 0 0 r
s
.24 .35 .67 r
.62129 .39742 m
.6596 .40422 L
s
.6596 .40422 m
.66985 .39061 L
s
.224 .307 .59 r
.46331 .60011 m .4436 .59723 L .44343 .57946 L p F P
0 0 0 r
s
.224 .307 .59 r
.42355 .5765 m .44343 .57946 L .4436 .59723 L p F P
0 0 0 r
s
.83 .24 .1 r
.42282 .75122 m
.45162 .75484 L
s
.4613 .7361 m
.45162 .75484 L
s
1 .324 .136 r
.449 .40235 m .44752 .4063 L .42311 .42047 L p F P
0 0 0 r
s
1 .324 .136 r
.42311 .42047 m .42517 .41472 L .449 .40235 L p F P
0 0 0 r
s
.83 .24 .1 r
.44569 .41339 m
.44733 .40902 L
s
.44733 .40902 m
.45767 .40907 L
s
.24 .35 .67 r
.44294 .41046 m
.44976 .41163 L
s
.288 .426 .836 r
.5 .38446 m .51269 .40323 L .50962 .40269 L closepath p F P
0 0 0 r
s
.237 .33 .635 r
.40357 .57353 m .38348 .57054 L .3858 .55128 L p F P
0 0 0 r
s
.237 .33 .635 r
.36602 .54829 m .3858 .55128 L .38348 .57054 L p F P
0 0 0 r
s
.24 .35 .67 r
.38458 .56987 m
.38648 .54397 L
s
.7464 .40437 m
.78407 .41113 L
s
.79628 .40341 m
.78407 .41113 L
s
.924 .272 .118 r
.53769 .40926 m .53944 .40532 L .52004 .39371 L p F P
0 0 0 r
s
.24 .35 .67 r
.53379 .40641 m
.53394 .40596 L
s
.924 .272 .118 r
.52004 .39371 m .51918 .39573 L .53769 .40926 L p F P
0 0 0 r
s
.24 .35 .67 r
.53507 .40271 m
.53518 .4024 L
s
.53518 .4024 m
.57379 .40915 L
s
.744 .218 .097 r
.57835 .42722 m .57479 .43458 L .59005 .45163 L p F P
0 0 0 r
s
.81 .238 .105 r
.57479 .43458 m .57835 .42722 L .56048 .41329 L p F P
0 0 0 r
s
.81 .238 .105 r
.56048 .41329 m .55781 .41904 L .57479 .43458 L p F P
0 0 0 r
s
.288 .426 .836 r
.5 .38446 m .50962 .40269 L .50654 .40216 L closepath p F P
0 0 0 r
s
.231 .067 .035 r
.62168 .53942 m .61528 .5507 L .61762 .56995 L p F P
0 0 0 r
s
.34 .098 .05 r
.61528 .5507 m .62168 .53942 L .61641 .51957 L p F P
0 0 0 r
s
.83 .24 .1 r
.6123 .54463 m
.61651 .56929 L
s
.24 .35 .67 r
.31019 .50376 m
.31448 .47474 L
s
.27431 .4683 m
.31448 .47474 L
s
.31448 .47474 m
.31936 .44566 L
s
.83 .24 .1 r
.35358 .69 m
.34601 .70967 L
s
.34601 .70967 m
.36864 .72805 L
s
.288 .426 .836 r
.5 .38446 m .50654 .40216 L .50347 .40162 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.5343 .40224 m
.53518 .4024 L
s
.87 .256 .112 r
.55781 .41904 m .56048 .41329 L .5412 .40136 L p F P
0 0 0 r
s
.87 .256 .112 r
.5412 .40136 m .53944 .40532 L .55781 .41904 L p F P
0 0 0 r
s
.973 .287 .123 r
.5 .38446 m .51662 .40176 L .51747 .39976 L closepath p F P
0 0 0 r
s
.206 .277 .53 r
.52124 .62407 m .50236 .62134 L .50242 .60584 L p F P
0 0 0 r
s
.24 .35 .67 r
.50324 .61034 m
.54218 .61602 L
s
.206 .277 .53 r
.48292 .60299 m .50242 .60584 L .50236 .62134 L p F P
0 0 0 r
s
.24 .35 .67 r
.5024 .58743 m
.50324 .61034 L
s
.288 .426 .836 r
.5 .38446 m .50347 .40162 L .50038 .40108 L closepath p F P
0 0 0 r
s
.667 .196 .088 r
.59445 .44287 m .59005 .45163 L .60329 .46985 L p F P
0 0 0 r
s
.744 .218 .097 r
.59005 .45163 m .59445 .44287 L .57835 .42722 L p F P
0 0 0 r
s
.248 .347 .671 r
.34612 .54527 m .32613 .54224 L .33364 .52232 L p F P
0 0 0 r
s
.83 .24 .1 r
.32575 .54833 m
.32758 .54246 L
s
.997 .292 .115 r
.33364 .52232 m .33713 .51118 L .34823 .49155 L p F P
0 0 0 r
s
.24 .35 .67 r
.34676 .53791 m
.35006 .51 L
s
.31019 .50376 m
.33879 .50823 L
s
.83 .24 .1 r
.34368 .50418 m
.35443 .49199 L
s
.34202 .50941 m
.34368 .50418 L
s
.822 .24 .091 r
.33713 .51118 m .33364 .52232 L .32613 .54224 L p F P
0 0 0 r
s
.288 .426 .836 r
.5 .38446 m .50038 .40108 L .4973 .40055 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.32466 .41747 m
.36461 .42418 L
s
.36461 .42418 m
.37049 .39803 L
s
1 .336 .137 r
.36273 .47229 m .36593 .46242 L .3832 .44506 L p F P
0 0 0 r
s
1 .323 .129 r
.36593 .46242 m .36273 .47229 L .34823 .49155 L p F P
0 0 0 r
s
.24 .35 .67 r
.27916 .43906 m
.31936 .44566 L
s
.31936 .44566 m
.32466 .41747 L
s
.18 .237 .449 r
.59099 .64701 m .57341 .6445 L .57734 .63217 L p F P
0 0 0 r
s
.83 .24 .1 r
.58223 .65834 m
.58913 .64674 L
s
.24 .35 .67 r
.58071 .62165 m
.58432 .64083 L
s
.18 .237 .449 r
.55874 .62948 m .57734 .63217 L .57341 .6445 L p F P
0 0 0 r
s
.288 .426 .836 r
.5 .38446 m .4973 .40055 L .49421 .40001 L closepath p F P
0 0 0 r
s
.224 .307 .59 r
.4436 .59723 m .42379 .59432 L .42355 .5765 L p F P
0 0 0 r
s
.24 .35 .67 r
.42427 .57579 m
.46354 .58164 L
s
.224 .307 .59 r
.40357 .57353 m .42355 .5765 L .42379 .59432 L p F P
0 0 0 r
s
.288 .426 .836 r
.5 .38446 m .49421 .40001 L .49112 .39947 L closepath p F P
0 0 0 r
s
.973 .287 .123 r
.5 .38446 m .51747 .39976 L .51832 .39775 L closepath p F P
0 0 0 r
s
1 .313 .132 r
.47411 .39218 m .47332 .39421 L .44752 .4063 L p F P
0 0 0 r
s
1 .313 .132 r
.44752 .4063 m .449 .40235 L .47411 .39218 L p F P
0 0 0 r
s
.24 .35 .67 r
.44976 .41163 m
.45229 .40327 L
s
.237 .33 .635 r
.38348 .57054 m .36329 .56753 L .36602 .54829 L p F P
0 0 0 r
s
.237 .33 .635 r
.34612 .54527 m .36602 .54829 L .36329 .56753 L p F P
0 0 0 r
s
.288 .426 .836 r
.5 .38446 m .49112 .39947 L .48803 .39893 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.30663 .53179 m
.31019 .50376 L
s
.2699 .49747 m
.31019 .50376 L
s
.288 .426 .836 r
.5 .38446 m .48803 .39893 L .48494 .39839 L closepath p F P
0 0 0 r
s
.924 .272 .118 r
.53944 .40532 m .5412 .40136 L .52091 .39168 L p F P
0 0 0 r
s
.24 .35 .67 r
.53518 .4024 m
.53525 .40224 L
s
.924 .272 .118 r
.52091 .39168 m .52004 .39371 L .53944 .40532 L p F P
0 0 0 r
s
.288 .426 .836 r
.5 .38446 m .48494 .39839 L .48184 .39786 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.39468 .74214 m
.42282 .75122 L
s
.43196 .73233 m
.42282 .75122 L
s
.578 .169 .078 r
.60845 .45994 m .60329 .46985 L .61422 .48889 L p F P
0 0 0 r
s
.667 .196 .088 r
.60329 .46985 m .60845 .45994 L .59445 .44287 L p F P
0 0 0 r
s
.206 .277 .53 r
.50236 .62134 m .48337 .6186 L .48292 .60299 L p F P
0 0 0 r
s
.206 .277 .53 r
.46331 .60011 m .48292 .60299 L .48337 .6186 L p F P
0 0 0 r
s
.34 .098 .05 r
.6226 .50838 m .61641 .51957 L .62168 .53942 L p F P
0 0 0 r
s
.471 .137 .065 r
.61641 .51957 m .6226 .50838 L .61422 .48889 L p F P
0 0 0 r
s
.24 .35 .67 r
.32876 .53516 m
.34676 .53791 L
s
.288 .426 .836 r
.5 .38446 m .48184 .39786 L .47874 .39732 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.37669 .70869 m
.36864 .72805 L
s
.36864 .72805 m
.39468 .74214 L
s
.973 .287 .123 r
.5 .38446 m .51832 .39775 L .51918 .39573 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.62902 .66105 m
.62301 .64638 L
s
.59336 .64213 m
.62301 .64638 L
s
1 .324 .136 r
.45049 .39836 m .449 .40235 L .42517 .41472 L p F P
0 0 0 r
s
1 .324 .136 r
.42517 .41472 m .42724 .40893 L .45049 .39836 L p F P
0 0 0 r
s
.24 .35 .67 r
.41033 .40486 m
.4291 .40808 L
s
1 .333 .138 r
.42724 .40893 m .42517 .41472 L .40309 .42906 L p F P
0 0 0 r
s
.83 .24 .1 r
.55026 .69509 m
.56887 .67842 L
s
.58095 .65806 m
.56887 .67842 L
s
.288 .426 .836 r
.5 .38446 m .47874 .39732 L .47564 .39678 L closepath p F P
0 0 0 r
s
.18 .237 .449 r
.57341 .6445 m .55574 .64198 L .55874 .62948 L p F P
0 0 0 r
s
.18 .237 .449 r
.54004 .62678 m .55874 .62948 L .55574 .64198 L p F P
0 0 0 r
s
1 .333 .138 r
.40309 .42906 m .40565 .42162 L .42724 .40893 L p F P
0 0 0 r
s
.24 .35 .67 r
.40645 .42115 m
.41033 .40486 L
s
1 .338 .139 r
.40565 .42162 m .40309 .42906 L .3832 .44506 L p F P
0 0 0 r
s
.24 .35 .67 r
.58258 .39055 m
.62129 .39742 L
s
.62129 .39742 m
.63095 .38363 L
s
.288 .426 .836 r
.5 .38446 m .47564 .39678 L .47253 .39623 L closepath p F P
0 0 0 r
s
.224 .307 .59 r
.42379 .59432 m .40387 .5914 L .40357 .57353 L p F P
0 0 0 r
s
.224 .307 .59 r
.38348 .57054 m .40357 .57353 L .40387 .5914 L p F P
0 0 0 r
s
.83 .24 .1 r
.40327 .72305 m
.39468 .74214 L
s
.237 .33 .635 r
.36329 .56753 m .34298 .56451 L .34612 .54527 L p F P
0 0 0 r
s
.237 .33 .635 r
.32613 .54224 m .34612 .54527 L .34298 .56451 L p F P
0 0 0 r
s
.24 .35 .67 r
.34447 .56389 m
.34676 .53791 L
s
1 .3 .128 r
.47253 .39623 m .47332 .39421 L .5 .38446 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.48877 .41832 m
.49616 .39558 L
s
.83 .24 .1 r
.4898 .73421 m
.51607 .72687 L
s
.5271 .70746 m
.51607 .72687 L
s
.24 .35 .67 r
.70833 .39753 m
.7464 .40437 L
s
.7464 .40437 m
.758 .39647 L
s
.7445 .67739 m
.75422 .68689 L
s
.70642 .672 m
.7445 .67739 L
s
.81 .238 .105 r
.56317 .40748 m .56048 .41329 L .57835 .42722 L p F P
0 0 0 r
s
.87 .256 .112 r
.56048 .41329 m .56317 .40748 L .54297 .39737 L p F P
0 0 0 r
s
.87 .256 .112 r
.54297 .39737 m .5412 .40136 L .56048 .41329 L p F P
0 0 0 r
s
1 .323 .129 r
.34823 .49155 m .35164 .4808 L .36593 .46242 L p F P
0 0 0 r
s
.997 .292 .115 r
.35164 .4808 m .34823 .49155 L .33713 .51118 L p F P
0 0 0 r
s
1 .313 .132 r
.4749 .39015 m .47411 .39218 L .449 .40235 L p F P
0 0 0 r
s
1 .313 .132 r
.449 .40235 m .45049 .39836 L .4749 .39015 L p F P
0 0 0 r
s
.973 .287 .123 r
.5 .38446 m .51918 .39573 L .52004 .39371 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.49616 .39558 m
.51957 .39967 L
s
.2699 .49747 m
.27431 .4683 L
s
.23371 .4618 m
.27431 .4683 L
s
.27431 .4683 m
.27916 .43906 L
s
.744 .218 .097 r
.58194 .41976 m .57835 .42722 L .59445 .44287 L p F P
0 0 0 r
s
.81 .238 .105 r
.57835 .42722 m .58194 .41976 L .56317 .40748 L p F P
0 0 0 r
s
.206 .277 .53 r
.48337 .6186 m .46429 .61584 L .46331 .60011 L p F P
0 0 0 r
s
.206 .277 .53 r
.4436 .59723 m .46331 .60011 L .46429 .61584 L p F P
0 0 0 r
s
.83 .24 .1 r
.32073 .57204 m
.32181 .5972 L
s
.924 .272 .118 r
.5412 .40136 m .54297 .39737 L .52177 .38964 L p F P
0 0 0 r
s
.24 .35 .67 r
.5366 .39916 m
.5368 .39871 L
s
.924 .272 .118 r
.52177 .38964 m .52091 .39168 L .5412 .40136 L p F P
0 0 0 r
s
.83 .24 .1 r
.5314 .42347 m
.54257 .39834 L
s
1 .338 .139 r
.3832 .44506 m .38615 .43621 L .40565 .42162 L p F P
0 0 0 r
s
1 .336 .137 r
.38615 .43621 m .3832 .44506 L .36593 .46242 L p F P
0 0 0 r
s
.83 .24 .1 r
.32914 .62267 m
.322 .64378 L
s
.322 .64378 m
.33507 .66798 L
s
1 .3 .128 r
.47332 .39421 m .47411 .39218 L .5 .38446 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.28428 .41069 m
.32466 .41747 L
s
.32466 .41747 m
.33022 .39112 L
s
.18 .237 .449 r
.55574 .64198 m .53799 .63945 L .54004 .62678 L p F P
0 0 0 r
s
.24 .35 .67 r
.54218 .61602 m
.54522 .63523 L
s
.18 .237 .449 r
.52124 .62407 m .54004 .62678 L .53799 .63945 L p F P
0 0 0 r
s
.24 .35 .67 r
.23853 .43239 m
.27916 .43906 L
s
.27916 .43906 m
.28428 .41069 L
s
.973 .287 .123 r
.5 .38446 m .52004 .39371 L .52091 .39168 L closepath p F P
0 0 0 r
s
.096 .028 .012 r
.60182 .6248 m .60791 .61456 L .61085 .59877 L p F P
0 0 0 r
s
.096 .028 .012 r
.61726 .58789 m .61085 .59877 L .60791 .61456 L p F P
0 0 0 r
s
.171 .049 .025 r
.61085 .59877 m .61726 .58789 L .61762 .56995 L p F P
0 0 0 r
s
.83 .24 .1 r
.60392 .59107 m
.61651 .56929 L
s
.224 .307 .59 r
.40387 .5914 m .38385 .58847 L .38348 .57054 L p F P
0 0 0 r
s
.24 .35 .67 r
.38458 .56987 m
.42427 .57579 L
s
.224 .307 .59 r
.36329 .56753 m .38348 .57054 L .38385 .58847 L p F P
0 0 0 r
s
.471 .137 .065 r
.62003 .47809 m .61422 .48889 L .6226 .50838 L p F P
0 0 0 r
s
.83 .24 .1 r
.60254 .52061 m
.6151 .49745 L
s
.578 .169 .078 r
.61422 .48889 m .62003 .47809 L .60845 .45994 L p F P
0 0 0 r
s
.83 .24 .1 r
.59994 .47471 m
.6151 .49745 L
s
.237 .33 .635 r
.34298 .56451 m .32256 .56147 L .32613 .54224 L p F P
0 0 0 r
s
.822 .24 .091 r
.32613 .54224 m .3297 .53079 L .33713 .51118 L p F P
0 0 0 r
s
.083 .024 .01 r
.3297 .53079 m .32613 .54224 L .32256 .56147 L p F P
0 0 0 r
s
.24 .35 .67 r
.30663 .53179 m
.32763 .53499 L
s
.32763 .53499 m
.32835 .5351 L
s
.667 .196 .088 r
.59891 .43398 m .59445 .44287 L .60845 .45994 L p F P
0 0 0 r
s
.744 .218 .097 r
.59445 .44287 m .59891 .43398 L .58194 .41976 L p F P
0 0 0 r
s
.231 .067 .035 r
.61762 .56995 m .62418 .55863 L .62168 .53942 L p F P
0 0 0 r
s
.171 .049 .025 r
.62418 .55863 m .61762 .56995 L .61726 .58789 L p F P
0 0 0 r
s
.24 .35 .67 r
.26606 .5256 m
.2699 .49747 L
s
.22917 .4911 m
.2699 .49747 L
s
1 .3 .128 r
.47411 .39218 m .4749 .39015 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .313 .132 r
.4757 .38811 m .4749 .39015 L .45049 .39836 L p F P
0 0 0 r
s
1 .313 .132 r
.45049 .39836 m .45198 .39436 L .4757 .38811 L p F P
0 0 0 r
s
.24 .35 .67 r
.45526 .39349 m
.45672 .38868 L
s
.45672 .38868 m
.46682 .39045 L
s
.47259 .39146 m
.49616 .39558 L
s
1 .324 .136 r
.45198 .39436 m .45049 .39836 L .42724 .40893 L p F P
0 0 0 r
s
.973 .287 .123 r
.5 .38446 m .52091 .39168 L .52177 .38964 L closepath p F P
0 0 0 r
s
.083 .024 .01 r
.59099 .64701 m .59661 .63758 L .60182 .6248 L p F P
0 0 0 r
s
.24 .35 .67 r
.58432 .64083 m
.59307 .64209 L
s
.83 .24 .1 r
.59165 .64251 m
.59444 .63782 L
s
.083 .024 .01 r
.60791 .61456 m .60182 .6248 L .59661 .63758 L p F P
0 0 0 r
s
.83 .24 .1 r
.59444 .63782 m
.60214 .61514 L
s
1 .324 .136 r
.42724 .40893 m .42934 .40308 L .45198 .39436 L p F P
0 0 0 r
s
1 .333 .138 r
.42934 .40308 m .42724 .40893 L .40565 .42162 L p F P
0 0 0 r
s
.24 .35 .67 r
.37049 .39803 m
.41033 .40486 L
s
.83 .24 .1 r
.42059 .41375 m
.44733 .40902 L
s
.41354 .43367 m
.42059 .41375 L
s
.206 .277 .53 r
.46429 .61584 m .4451 .61307 L .4436 .59723 L p F P
0 0 0 r
s
.24 .35 .67 r
.46388 .6046 m
.50324 .61034 L
s
.46354 .58164 m
.46388 .6046 L
s
.206 .277 .53 r
.42379 .59432 m .4436 .59723 L .4451 .61307 L p F P
0 0 0 r
s
.24 .35 .67 r
.30392 .55785 m
.30663 .53179 L
s
.26606 .5256 m
.30663 .53179 L
s
.87 .256 .112 r
.54476 .39336 m .54297 .39737 L .56317 .40748 L p F P
0 0 0 r
s
.924 .272 .118 r
.54297 .39737 m .54476 .39336 L .52264 .3876 L p F P
0 0 0 r
s
.24 .35 .67 r
.53816 .39562 m
.53836 .39516 L
s
.924 .272 .118 r
.52264 .3876 m .52177 .38964 L .54297 .39737 L p F P
0 0 0 r
s
.18 .237 .449 r
.53799 .63945 m .52016 .6369 L .52124 .62407 L p F P
0 0 0 r
s
.18 .237 .449 r
.50236 .62134 m .52124 .62407 L .52016 .6369 L p F P
0 0 0 r
s
1 .336 .137 r
.36593 .46242 m .36917 .45239 L .38615 .43621 L p F P
0 0 0 r
s
1 .323 .129 r
.36917 .45239 m .36593 .46242 L .35164 .4808 L p F P
0 0 0 r
s
.83 .24 .1 r
.36057 .48315 m
.36737 .46223 L
s
.36737 .46223 m
.38788 .44816 L
s
1 .3 .128 r
.4749 .39015 m .4757 .38811 L .5 .38446 L closepath p F P
0 0 0 r
s
.81 .238 .105 r
.56589 .40162 m .56317 .40748 L .58194 .41976 L p F P
0 0 0 r
s
.24 .35 .67 r
.57379 .40915 m
.58258 .39055 L
s
.83 .24 .1 r
.55725 .43707 m
.56895 .41218 L
s
.87 .256 .112 r
.56317 .40748 m .56589 .40162 L .54476 .39336 L p F P
0 0 0 r
s
.83 .24 .1 r
.54257 .39834 m
.56895 .41218 L
s
.24 .35 .67 r
.33022 .39112 m
.37049 .39803 L
s
.37049 .39803 m
.37658 .37468 L
s
.231 .067 .035 r
.62821 .52791 m .62168 .53942 L .62418 .55863 L p F P
0 0 0 r
s
.34 .098 .05 r
.62168 .53942 m .62821 .52791 L .6226 .50838 L p F P
0 0 0 r
s
.973 .287 .123 r
.5 .38446 m .52177 .38964 L .52264 .3876 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.51442 .38869 m
.54257 .39834 L
s
.508 .40399 m
.51442 .38869 L
s
.224 .307 .59 r
.38385 .58847 m .36371 .58552 L .36329 .56753 L p F P
0 0 0 r
s
.224 .307 .59 r
.34298 .56451 m .36329 .56753 L .36371 .58552 L p F P
0 0 0 r
s
1 .333 .138 r
.40565 .42162 m .40824 .4141 L .42934 .40308 L p F P
0 0 0 r
s
1 .338 .139 r
.40824 .4141 m .40565 .42162 L .38615 .43621 L p F P
0 0 0 r
s
.24 .35 .67 r
.66985 .39061 m
.70833 .39753 L
s
.70833 .39753 m
.71929 .38947 L
s
.71548 .68145 m
.70642 .672 L
s
.66793 .66656 m
.70642 .672 L
s
.997 .292 .115 r
.33713 .51118 m .34068 .49983 L .35164 .4808 L p F P
0 0 0 r
s
.822 .24 .091 r
.34068 .49983 m .33713 .51118 L .3297 .53079 L p F P
0 0 0 r
s
.83 .24 .1 r
.33287 .52558 m
.34368 .50418 L
s
.32963 .53593 m
.33287 .52558 L
s
.24 .35 .67 r
.22917 .4911 m
.23371 .4618 L
s
.19268 .45523 m
.23371 .4618 L
s
.23371 .4618 m
.23853 .43239 L
s
1 .3 .128 r
.4757 .38811 m .4765 .38606 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .313 .132 r
.4765 .38606 m .4757 .38811 L .45198 .39436 L p F P
0 0 0 r
s
.206 .277 .53 r
.4451 .61307 m .42582 .61028 L .42379 .59432 L p F P
0 0 0 r
s
.206 .277 .53 r
.40387 .5914 m .42379 .59432 L .42582 .61028 L p F P
0 0 0 r
s
.578 .169 .078 r
.61368 .44987 m .60845 .45994 L .62003 .47809 L p F P
0 0 0 r
s
.667 .196 .088 r
.60845 .45994 m .61368 .44987 L .59891 .43398 L p F P
0 0 0 r
s
.83 .24 .1 r
.59994 .47471 m
.6126 .45035 L
s
1 .313 .132 r
.45198 .39436 m .45348 .39033 L .4765 .38606 L p F P
0 0 0 r
s
1 .324 .136 r
.45348 .39033 m .45198 .39436 L .42934 .40308 L p F P
0 0 0 r
s
.924 .272 .118 r
.52351 .38555 m .52264 .3876 L .54476 .39336 L p F P
0 0 0 r
s
.973 .287 .123 r
.5 .38446 m .52264 .3876 L .52351 .38555 L closepath p F P
0 0 0 r
s
.744 .218 .097 r
.58559 .41222 m .58194 .41976 L .59891 .43398 L p F P
0 0 0 r
s
.83 .24 .1 r
.5804 .45435 m
.59259 .42972 L
s
.81 .238 .105 r
.58194 .41976 m .58559 .41222 L .56589 .40162 L p F P
0 0 0 r
s
.83 .24 .1 r
.56895 .41218 m
.59259 .42972 L
s
.18 .237 .449 r
.52016 .6369 m .50223 .63434 L .50236 .62134 L p F P
0 0 0 r
s
.24 .35 .67 r
.50324 .61034 m
.5057 .62956 L
s
.18 .237 .449 r
.48337 .6186 m .50236 .62134 L .50223 .63434 L p F P
0 0 0 r
s
.24 .35 .67 r
.24347 .40383 m
.28428 .41069 L
s
.28428 .41069 m
.28952 .38414 L
s
.19747 .42565 m
.23853 .43239 L
s
.23853 .43239 m
.24347 .40383 L
s
.143 .178 .333 r
.57341 .6445 m .59099 .64701 L .58384 .65604 L p F P
0 0 0 r
s
.871 .26 .101 r
.59661 .63758 m .59099 .64701 L .58384 .65604 L p F P
0 0 0 r
s
.24 .35 .67 r
.58432 .64083 m
.5878 .65032 L
s
.83 .24 .1 r
.5854 .65138 m
.59444 .63782 L
s
.24 .35 .67 r
.54522 .63523 m
.58432 .64083 L
s
.87 .256 .112 r
.54655 .38932 m .54476 .39336 L .56589 .40162 L p F P
0 0 0 r
s
.924 .272 .118 r
.54476 .39336 m .54655 .38932 L .52351 .38555 L p F P
0 0 0 r
s
.973 .287 .123 r
.5 .38446 m .52527 .38144 L .52615 .37937 L closepath p F P
0 0 0 r
s
.973 .287 .123 r
.5 .38446 m .52615 .37937 L .52703 .37729 L closepath p F P
0 0 0 r
s
.973 .287 .123 r
.5 .38446 m .52703 .37729 L .52791 .37521 L closepath p F P
0 0 0 r
s
.973 .287 .123 r
.5 .38446 m .52351 .38555 L .52439 .3835 L closepath p F P
0 0 0 r
s
.973 .287 .123 r
.5 .38446 m .52439 .3835 L .52527 .38144 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.48052 .37573 m .48133 .37364 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.47971 .37781 m .48052 .37573 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.4789 .37988 m .47971 .37781 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.4781 .38195 m .4789 .37988 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.4773 .38401 m .4781 .38195 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.4765 .38606 m .4773 .38401 L .5 .38446 L closepath p F P
0 0 0 r
s
.287 .429 .843 r
.51536 .37297 m .51221 .37241 L .5 .38446 L closepath p F P
0 0 0 r
s
.287 .429 .843 r
.5185 .37353 m .51536 .37297 L .5 .38446 L closepath p F P
0 0 0 r
s
.287 .429 .843 r
.52164 .37409 m .5185 .37353 L .5 .38446 L closepath p F P
0 0 0 r
s
.287 .429 .843 r
.52478 .37465 m .52164 .37409 L .5 .38446 L closepath p F P
0 0 0 r
s
.287 .429 .843 r
.52791 .37521 m .52478 .37465 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.48297 .36945 m .48379 .36734 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.48215 .37155 m .48297 .36945 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.48133 .37364 m .48215 .37155 L .5 .38446 L closepath p F P
0 0 0 r
s
.287 .429 .843 r
.48696 .36791 m .48379 .36734 L .5 .38446 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.47942 .39902 m
.48552 .3836 L
s
.287 .429 .843 r
.49012 .36847 m .48696 .36791 L .5 .38446 L closepath p F P
0 0 0 r
s
.287 .429 .843 r
.49329 .36904 m .49012 .36847 L .5 .38446 L closepath p F P
0 0 0 r
s
.287 .429 .843 r
.49645 .3696 m .49329 .36904 L .5 .38446 L closepath p F P
0 0 0 r
s
.287 .429 .843 r
.49961 .37016 m .49645 .3696 L .5 .38446 L closepath p F P
0 0 0 r
s
.287 .429 .843 r
.50276 .37073 m .49961 .37016 L .5 .38446 L closepath p F P
0 0 0 r
s
.287 .429 .843 r
.50592 .37129 m .50276 .37073 L .5 .38446 L closepath p F P
0 0 0 r
s
.287 .429 .843 r
.50907 .37185 m .50592 .37129 L .5 .38446 L closepath p F P
0 0 0 r
s
.287 .429 .843 r
.51221 .37241 m .50907 .37185 L .5 .38446 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.49616 .39558 m
.5039 .37658 L
s
.83 .24 .1 r
.48552 .3836 m
.51442 .38869 L
s
.224 .307 .59 r
.36371 .58552 m .34347 .58255 L .34298 .56451 L p F P
0 0 0 r
s
.24 .35 .67 r
.34447 .56389 m
.38458 .56987 L
s
.224 .307 .59 r
.32256 .56147 m .34298 .56451 L .34347 .58255 L p F P
0 0 0 r
s
.83 .24 .1 r
.32073 .57204 m
.3237 .56261 L
s
1 .313 .132 r
.4773 .38401 m .4765 .38606 L .45348 .39033 L p F P
0 0 0 r
s
.34 .098 .05 r
.62892 .49697 m .6226 .50838 L .62821 .52791 L p F P
0 0 0 r
s
.83 .24 .1 r
.6123 .54463 m
.62517 .52173 L
s
.471 .137 .065 r
.6226 .50838 m .62892 .49697 L .62003 .47809 L p F P
0 0 0 r
s
.83 .24 .1 r
.6151 .49745 m
.62517 .52173 L
s
.4613 .7361 m
.4898 .73421 L
s
.50039 .71479 m
.4898 .73421 L
s
1 .324 .136 r
.42934 .40308 m .43145 .39718 L .45348 .39033 L p F P
0 0 0 r
s
1 .333 .138 r
.43145 .39718 m .42934 .40308 L .40824 .4141 L p F P
0 0 0 r
s
.924 .272 .118 r
.52439 .3835 m .52351 .38555 L .54655 .38932 L p F P
0 0 0 r
s
1 .338 .139 r
.38615 .43621 m .38914 .42723 L .40824 .4141 L p F P
0 0 0 r
s
1 .336 .137 r
.38914 .42723 m .38615 .43621 L .36917 .45239 L p F P
0 0 0 r
s
.24 .35 .67 r
.22506 .51935 m
.22917 .4911 L
s
.18801 .48467 m
.22917 .4911 L
s
.206 .277 .53 r
.42582 .61028 m .40644 .60749 L .40387 .5914 L p F P
0 0 0 r
s
.24 .35 .67 r
.42411 .59879 m
.46388 .6046 L
s
.42411 .59879 m
.42427 .57579 L
s
.206 .277 .53 r
.38385 .58847 m .40387 .5914 L .40644 .60749 L p F P
0 0 0 r
s
1 .323 .129 r
.35164 .4808 m .35511 .46985 L .36917 .45239 L p F P
0 0 0 r
s
.997 .292 .115 r
.35511 .46985 m .35164 .4808 L .34068 .49983 L p F P
0 0 0 r
s
.24 .35 .67 r
.26294 .55175 m
.26606 .5256 L
s
.22506 .51935 m
.26606 .5256 L
s
.81 .238 .105 r
.56863 .3957 m .56589 .40162 L .58559 .41222 L p F P
0 0 0 r
s
.87 .256 .112 r
.56589 .40162 m .56863 .3957 L .54655 .38932 L p F P
0 0 0 r
s
.83 .24 .1 r
.34253 .64719 m
.33507 .66798 L
s
.33507 .66798 m
.35358 .69 L
s
.18 .237 .449 r
.50223 .63434 m .48423 .63177 L .48337 .6186 L p F P
0 0 0 r
s
.18 .237 .449 r
.46429 .61584 m .48337 .6186 L .48423 .63177 L p F P
0 0 0 r
s
1 .313 .132 r
.4781 .38195 m .4773 .38401 L .455 .38627 L p F P
0 0 0 r
s
.24 .35 .67 r
.45672 .38868 m
.45773 .38599 L
s
1 .313 .132 r
.45348 .39033 m .455 .38627 L .4773 .38401 L p F P
0 0 0 r
s
1 .324 .136 r
.455 .38627 m .45348 .39033 L .43145 .39718 L p F P
0 0 0 r
s
.24 .35 .67 r
.41686 .38172 m
.45168 .3878 L
s
.5057 .62956 m
.54522 .63523 L
s
.143 .178 .333 r
.58384 .65604 m .56763 .65375 L .57341 .6445 L p F P
0 0 0 r
s
.83 .24 .1 r
.58095 .65806 m
.58243 .65584 L
s
.143 .178 .333 r
.55574 .64198 m .57341 .6445 L .56763 .65375 L p F P
0 0 0 r
s
.924 .272 .118 r
.54655 .38932 m .54836 .38526 L .52439 .3835 L p F P
0 0 0 r
s
.924 .272 .118 r
.52527 .38144 m .52439 .3835 L .54836 .38526 L p F P
0 0 0 r
s
.24 .35 .67 r
.5431 .38439 m
.54345 .3836 L
s
.54345 .3836 m
.58258 .39055 L
s
.667 .196 .088 r
.60343 .42497 m .59891 .43398 L .61368 .44987 L p F P
0 0 0 r
s
.744 .218 .097 r
.59891 .43398 m .60343 .42497 L .58559 .41222 L p F P
0 0 0 r
s
.83 .24 .1 r
.5271 .70746 m
.55026 .69509 L
s
.5621 .67484 m
.55026 .69509 L
s
.24 .35 .67 r
.28952 .38414 m
.33022 .39112 L
s
.33022 .39112 m
.33585 .36756 L
s
.87 .256 .112 r
.54836 .38526 m .54655 .38932 L .56863 .3957 L p F P
0 0 0 r
s
.083 .024 .01 r
.32256 .56147 m .32617 .54997 L .3297 .53079 L p F P
0 0 0 r
s
.224 .307 .59 r
.34347 .58255 m .32312 .57957 L .32256 .56147 L p F P
0 0 0 r
s
.154 .045 .022 r
.32617 .54997 m .32256 .56147 L .32312 .57957 L p F P
0 0 0 r
s
.24 .35 .67 r
.30392 .55785 m
.32281 .56067 L
s
.32504 .561 m
.34447 .56389 L
s
.63095 .38363 m
.66985 .39061 L
s
.66985 .39061 m
.68017 .38238 L
s
.67633 .67596 m
.66793 .66656 L
s
.62902 .66105 m
.66793 .66656 L
s
1 .313 .132 r
.4789 .37988 m .4781 .38195 L .45652 .38219 L p F P
0 0 0 r
s
1 .313 .132 r
.455 .38627 m .45652 .38219 L .4781 .38195 L p F P
0 0 0 r
s
1 .333 .138 r
.40824 .4141 m .41086 .4065 L .43145 .39718 L p F P
0 0 0 r
s
.24 .35 .67 r
.41033 .40486 m
.41686 .38172 L
s
1 .338 .139 r
.41086 .4065 m .40824 .4141 L .38914 .42723 L p F P
0 0 0 r
s
.83 .24 .1 r
.39629 .42328 m
.42059 .41375 L
s
.24 .35 .67 r
.18801 .48467 m
.19268 .45523 L
s
.19268 .45523 m
.19747 .42565 L
s
.924 .272 .118 r
.54836 .38526 m .55017 .38117 L .52527 .38144 L p F P
0 0 0 r
s
.924 .272 .118 r
.52615 .37937 m .52527 .38144 L .55017 .38117 L p F P
0 0 0 r
s
.471 .137 .065 r
.62594 .4671 m .62003 .47809 L .62892 .49697 L p F P
0 0 0 r
s
.578 .169 .078 r
.62003 .47809 m .62594 .4671 L .61368 .44987 L p F P
0 0 0 r
s
.24 .35 .67 r
.37658 .37468 m
.41686 .38172 L
s
.206 .277 .53 r
.40644 .60749 m .38696 .60467 L .38385 .58847 L p F P
0 0 0 r
s
.206 .277 .53 r
.36371 .58552 m .38385 .58847 L .38696 .60467 L p F P
0 0 0 r
s
.18 .237 .449 r
.48423 .63177 m .46613 .62919 L .46429 .61584 L p F P
0 0 0 r
s
.18 .237 .449 r
.4451 .61307 m .46429 .61584 L .46613 .62919 L p F P
0 0 0 r
s
.143 .178 .333 r
.56763 .65375 m .55134 .65145 L .55574 .64198 L p F P
0 0 0 r
s
.143 .178 .333 r
.53799 .63945 m .55574 .64198 L .55134 .65145 L p F P
0 0 0 r
s
.096 .028 .012 r
.60791 .61456 m .61411 .60412 L .61726 .58789 L p F P
0 0 0 r
s
.096 .028 .012 r
.62379 .57679 m .61726 .58789 L .61411 .60412 L p F P
0 0 0 r
s
.83 .24 .1 r
.61484 .59358 m
.61651 .56929 L
s
.171 .049 .025 r
.61726 .58789 m .62379 .57679 L .62418 .55863 L p F P
0 0 0 r
s
.24 .35 .67 r
.20222 .39691 m
.24347 .40383 L
s
.24347 .40383 m
.24838 .37708 L
s
.822 .24 .091 r
.3297 .53079 m .33334 .51911 L .34068 .49983 L p F P
0 0 0 r
s
.083 .024 .01 r
.33334 .51911 m .3297 .53079 L .32617 .54997 L p F P
0 0 0 r
s
.24 .35 .67 r
.19747 .42565 m
.20222 .39691 L
s
1 .313 .132 r
.47971 .37781 m .4789 .37988 L .45806 .37808 L p F P
0 0 0 r
s
1 .313 .132 r
.45652 .38219 m .45806 .37808 L .4789 .37988 L p F P
0 0 0 r
s
1 .336 .137 r
.36917 .45239 m .37248 .44219 L .38914 .42723 L p F P
0 0 0 r
s
.83 .24 .1 r
.38788 .44816 m
.39629 .42328 L
s
1 .323 .129 r
.37248 .44219 m .36917 .45239 L .35511 .46985 L p F P
0 0 0 r
s
.744 .218 .097 r
.58927 .40459 m .58559 .41222 L .60343 .42497 L p F P
0 0 0 r
s
.81 .238 .105 r
.58559 .41222 m .58927 .40459 L .56863 .3957 L p F P
0 0 0 r
s
.24 .35 .67 r
.758 .39647 m
.79628 .40341 L
s
.80828 .40163 m
.79628 .40341 L
s
1 .324 .136 r
.43145 .39718 m .43358 .39122 L .455 .38627 L p F P
0 0 0 r
s
1 .333 .138 r
.43358 .39122 m .43145 .39718 L .41086 .4065 L p F P
0 0 0 r
s
1 .324 .136 r
.45652 .38219 m .455 .38627 L .43358 .39122 L p F P
0 0 0 r
s
.924 .272 .118 r
.55017 .38117 m .552 .37705 L .52615 .37937 L p F P
0 0 0 r
s
.924 .272 .118 r
.52703 .37729 m .52615 .37937 L .552 .37705 L p F P
0 0 0 r
s
.231 .067 .035 r
.62418 .55863 m .63087 .54708 L .62821 .52791 L p F P
0 0 0 r
s
.171 .049 .025 r
.63087 .54708 m .62418 .55863 L .62379 .57679 L p F P
0 0 0 r
s
.083 .024 .01 r
.59661 .63758 m .60233 .62799 L .60791 .61456 L p F P
0 0 0 r
s
.083 .024 .01 r
.61411 .60412 m .60791 .61456 L .60233 .62799 L p F P
0 0 0 r
s
.83 .24 .1 r
.60214 .61514 m
.61484 .59358 L
s
.87 .256 .112 r
.56863 .3957 m .5714 .38973 L .54836 .38526 L p F P
0 0 0 r
s
.87 .256 .112 r
.55017 .38117 m .54836 .38526 L .5714 .38973 L p F P
0 0 0 r
s
.24 .35 .67 r
.30392 .55785 m
.26294 .55175 L
s
.3022 .581 m
.30392 .55785 L
s
.18361 .51303 m
.18801 .48467 L
s
.81 .238 .105 r
.5714 .38973 m .56863 .3957 L .58927 .40459 L p F P
0 0 0 r
s
1 .313 .132 r
.48052 .37573 m .47971 .37781 L .4596 .37394 L p F P
0 0 0 r
s
1 .313 .132 r
.45806 .37808 m .4596 .37394 L .47971 .37781 L p F P
0 0 0 r
s
.83 .24 .1 r
.43196 .73233 m
.4613 .7361 L
s
.47138 .71659 m
.4613 .7361 L
s
.206 .277 .53 r
.38696 .60467 m .36738 .60184 L .36371 .58552 L p F P
0 0 0 r
s
.24 .35 .67 r
.38391 .59293 m
.42411 .59879 L
s
.38391 .59293 m
.38458 .56987 L
s
.206 .277 .53 r
.34347 .58255 m .36371 .58552 L .36738 .60184 L p F P
0 0 0 r
s
.143 .178 .333 r
.55134 .65145 m .53499 .64914 L .53799 .63945 L p F P
0 0 0 r
s
.143 .178 .333 r
.52016 .6369 m .53799 .63945 L .53499 .64914 L p F P
0 0 0 r
s
.924 .272 .118 r
.552 .37705 m .55384 .37291 L .52703 .37729 L p F P
0 0 0 r
s
.924 .272 .118 r
.52791 .37521 m .52703 .37729 L .55384 .37291 L p F P
0 0 0 r
s
.24 .35 .67 r
.5039 .37658 m
.52764 .38079 L
s
.18 .237 .449 r
.46613 .62919 m .44794 .6266 L .4451 .61307 L p F P
0 0 0 r
s
.24 .35 .67 r
.46388 .6046 m
.46575 .62383 L
s
.18 .237 .449 r
.42582 .61028 m .4451 .61307 L .44794 .6266 L p F P
0 0 0 r
s
.24 .35 .67 r
.22152 .54557 m
.22506 .51935 L
s
.18361 .51303 m
.22506 .51935 L
s
.578 .169 .078 r
.61901 .43963 m .61368 .44987 L .62594 .4671 L p F P
0 0 0 r
s
.667 .196 .088 r
.61368 .44987 m .61901 .43963 L .60343 .42497 L p F P
0 0 0 r
s
.83 .24 .1 r
.59259 .42972 m
.6126 .45035 L
s
.231 .067 .035 r
.63487 .51617 m .62821 .52791 L .63087 .54708 L p F P
0 0 0 r
s
.34 .098 .05 r
.62821 .52791 m .63487 .51617 L .62892 .49697 L p F P
0 0 0 r
s
.83 .24 .1 r
.62517 .52173 m
.62961 .54663 L
s
.24 .35 .67 r
.46575 .62383 m
.5057 .62956 L
s
.83 .24 .1 r
.36146 .66954 m
.35358 .69 L
s
.35358 .69 m
.37669 .70869 L
s
.997 .292 .115 r
.34068 .49983 m .3443 .48825 L .35511 .46985 L p F P
0 0 0 r
s
.83 .24 .1 r
.35122 .48035 m
.36737 .46223 L
s
.822 .24 .091 r
.3443 .48825 m .34068 .49983 L .33334 .51911 L p F P
0 0 0 r
s
.83 .24 .1 r
.34368 .50418 m
.35122 .48035 L
s
1 .338 .139 r
.38914 .42723 m .39218 .41812 L .41086 .4065 L p F P
0 0 0 r
s
1 .336 .137 r
.39218 .41812 m .38914 .42723 L .37248 .44219 L p F P
0 0 0 r
s
.24 .35 .67 r
.24838 .37708 m
.28952 .38414 L
s
.28952 .38414 m
.29469 .36037 L
s
1 .313 .132 r
.48133 .37364 m .48052 .37573 L .46115 .36978 L p F P
0 0 0 r
s
1 .313 .132 r
.4596 .37394 m .46115 .36978 L .48052 .37573 L p F P
0 0 0 r
s
1 .324 .136 r
.45806 .37808 m .45652 .38219 L .43574 .38521 L p F P
0 0 0 r
s
.83 .24 .1 r
.45694 .38331 m
.48552 .3836 L
s
1 .324 .136 r
.43358 .39122 m .43574 .38521 L .45652 .38219 L p F P
0 0 0 r
s
.83 .24 .1 r
.44733 .40902 m
.45694 .38331 L
s
.24 .35 .67 r
.59164 .37656 m
.63095 .38363 L
s
.63095 .38363 m
.64062 .37522 L
s
.924 .272 .118 r
.55384 .37291 m .55569 .36874 L .52791 .37521 L p F P
0 0 0 r
s
.281 .424 .837 r
.52478 .37465 m .52791 .37521 L .55569 .36874 L p F P
0 0 0 r
s
.24 .35 .67 r
.63675 .6704 m
.62902 .66105 L
s
.871 .26 .101 r
.58384 .65604 m .58896 .64744 L .59661 .63758 L p F P
0 0 0 r
s
.24 .35 .67 r
.5897 .65549 m
.62902 .66105 L
s
.58792 .65064 m
.5897 .65549 L
s
.871 .26 .101 r
.60233 .62799 m .59661 .63758 L .58896 .64744 L p F P
0 0 0 r
s
.281 .424 .837 r
.52164 .37409 m .52478 .37465 L .54946 .36762 L p F P
0 0 0 r
s
.281 .424 .837 r
.55569 .36874 m .54946 .36762 L .52478 .37465 L p F P
0 0 0 r
s
.87 .256 .112 r
.5714 .38973 m .57419 .3837 L .55017 .38117 L p F P
0 0 0 r
s
.87 .256 .112 r
.552 .37705 m .55017 .38117 L .57419 .3837 L p F P
0 0 0 r
s
.143 .178 .333 r
.53499 .64914 m .51856 .64682 L .52016 .6369 L p F P
0 0 0 r
s
.143 .178 .333 r
.50223 .63434 m .52016 .6369 L .51856 .64682 L p F P
0 0 0 r
s
.24 .35 .67 r
.33585 .36756 m
.37658 .37468 L
s
.37658 .37468 m
.38266 .35506 L
s
.281 .424 .837 r
.5185 .37353 m .52164 .37409 L .54322 .3665 L p F P
0 0 0 r
s
.281 .424 .837 r
.54946 .36762 m .54322 .3665 L .52164 .37409 L p F P
0 0 0 r
s
.24 .35 .67 r
.54877 .37468 m
.5519 .36942 L
s
.206 .277 .53 r
.36738 .60184 m .34769 .599 L .34347 .58255 L p F P
0 0 0 r
s
.206 .277 .53 r
.32312 .57957 m .34347 .58255 L .34769 .599 L p F P
0 0 0 r
s
1 .333 .138 r
.41086 .4065 m .41352 .3988 L .43358 .39122 L p F P
0 0 0 r
s
1 .338 .139 r
.41352 .3988 m .41086 .4065 L .39218 .41812 L p F P
0 0 0 r
s
.18 .237 .449 r
.44794 .6266 m .42967 .62399 L .42582 .61028 L p F P
0 0 0 r
s
.18 .237 .449 r
.40644 .60749 m .42582 .61028 L .42967 .62399 L p F P
0 0 0 r
s
.667 .196 .088 r
.60802 .41583 m .60343 .42497 L .61901 .43963 L p F P
0 0 0 r
s
.744 .218 .097 r
.60343 .42497 m .60802 .41583 L .58927 .40459 L p F P
0 0 0 r
s
1 .313 .132 r
.48215 .37155 m .48133 .37364 L .46271 .3656 L p F P
0 0 0 r
s
1 .313 .132 r
.46115 .36978 m .46271 .3656 L .48133 .37364 L p F P
0 0 0 r
s
.24 .35 .67 r
.48001 .37234 m
.5039 .37658 L
s
1 .333 .138 r
.43574 .38521 m .43358 .39122 L .41352 .3988 L p F P
0 0 0 r
s
.281 .424 .837 r
.51536 .37297 m .5185 .37353 L .53696 .36538 L p F P
0 0 0 r
s
.281 .424 .837 r
.54322 .3665 m .53696 .36538 L .5185 .37353 L p F P
0 0 0 r
s
.83 .24 .1 r
.51442 .38869 m
.52099 .37301 L
s
.34 .098 .05 r
.63535 .48534 m .62892 .49697 L .63487 .51617 L p F P
0 0 0 r
s
.471 .137 .065 r
.62892 .49697 m .63535 .48534 L .62594 .4671 L p F P
0 0 0 r
s
.24 .35 .67 r
.20222 .39691 m
.20679 .36995 L
s
.281 .424 .837 r
.51221 .37241 m .51536 .37297 L .5307 .36425 L p F P
0 0 0 r
s
.281 .424 .837 r
.53696 .36538 m .5307 .36425 L .51536 .37297 L p F P
0 0 0 r
s
.24 .35 .67 r
.71929 .38947 m
.758 .39647 L
s
.758 .39647 m
.76933 .39455 L
s
1 .323 .129 r
.35511 .46985 m .35864 .45871 L .37248 .44219 L p F P
0 0 0 r
s
.997 .292 .115 r
.35864 .45871 m .35511 .46985 L .3443 .48825 L p F P
0 0 0 r
s
.281 .424 .837 r
.50907 .37185 m .51221 .37241 L .52442 .36312 L p F P
0 0 0 r
s
.281 .424 .837 r
.5307 .36425 m .52442 .36312 L .51221 .37241 L p F P
0 0 0 r
s
.83 .24 .1 r
.52509 .36324 m
.52549 .3623 L
s
.40327 .72305 m
.43196 .73233 L
s
.44147 .71267 m
.43196 .73233 L
s
.24 .35 .67 r
.75422 .68689 m
.76548 .69047 L
s
.71548 .68145 m
.75422 .68689 L
s
.81 .238 .105 r
.58927 .40459 m .593 .39687 L .5714 .38973 L p F P
0 0 0 r
s
.81 .238 .105 r
.57419 .3837 m .5714 .38973 L .593 .39687 L p F P
0 0 0 r
s
.24 .35 .67 r
.58301 .38988 m
.59164 .37656 L
s
.744 .218 .097 r
.593 .39687 m .58927 .40459 L .60802 .41583 L p F P
0 0 0 r
s
.281 .424 .837 r
.50592 .37129 m .50907 .37185 L .51814 .36199 L p F P
0 0 0 r
s
.281 .424 .837 r
.52442 .36312 m .51814 .36199 L .50907 .37185 L p F P
0 0 0 r
s
.83 .24 .1 r
.38507 .68853 m
.37669 .70869 L
s
.37669 .70869 m
.40327 .72305 L
s
1 .313 .132 r
.48297 .36945 m .48215 .37155 L .46428 .36138 L p F P
0 0 0 r
s
1 .313 .132 r
.46271 .3656 m .46428 .36138 L .48215 .37155 L p F P
0 0 0 r
s
1 .324 .136 r
.4596 .37394 m .45806 .37808 L .43791 .37914 L p F P
0 0 0 r
s
1 .324 .136 r
.43574 .38521 m .43791 .37914 L .45806 .37808 L p F P
0 0 0 r
s
.83 .24 .1 r
.58095 .65806 m
.58228 .65582 L
s
.24 .35 .67 r
.26294 .55175 m
.22152 .54557 L
s
.26067 .57494 m
.26294 .55175 L
s
.281 .424 .837 r
.50276 .37073 m .50592 .37129 L .51184 .36086 L p F P
0 0 0 r
s
.281 .424 .837 r
.51814 .36199 m .51184 .36086 L .50592 .37129 L p F P
0 0 0 r
s
.143 .178 .333 r
.51856 .64682 m .50206 .64449 L .50223 .63434 L p F P
0 0 0 r
s
.24 .35 .67 r
.5057 .62956 m
.50976 .64418 L
s
.143 .178 .333 r
.48423 .63177 m .50223 .63434 L .50206 .64449 L p F P
0 0 0 r
s
.281 .424 .837 r
.49961 .37016 m .50276 .37073 L .50553 .35972 L p F P
0 0 0 r
s
.281 .424 .837 r
.51184 .36086 m .50553 .35972 L .50276 .37073 L p F P
0 0 0 r
s
.18 .237 .449 r
.42967 .62399 m .4113 .62137 L .40644 .60749 L p F P
0 0 0 r
s
.24 .35 .67 r
.42411 .59879 m
.42537 .61804 L
s
.18 .237 .449 r
.38696 .60467 m .40644 .60749 L .4113 .62137 L p F P
0 0 0 r
s
.206 .277 .53 r
.34769 .599 m .3279 .59614 L .32312 .57957 L p F P
0 0 0 r
s
.83 .24 .1 r
.32181 .5972 m
.32914 .62267 L
s
.24 .35 .67 r
.34327 .587 m
.38391 .59293 L
s
.34327 .587 m
.34447 .56389 L
s
.154 .045 .022 r
.32312 .57957 m .32672 .5683 L .32617 .54997 L p F P
0 0 0 r
s
.226 .065 .035 r
.32672 .5683 m .32312 .57957 L .3279 .59614 L p F P
0 0 0 r
s
.83 .24 .1 r
.32181 .5972 m
.32519 .58675 L
s
.4122 .70317 m
.40327 .72305 L
s
.87 .256 .112 r
.57419 .3837 m .57701 .37762 L .552 .37705 L p F P
0 0 0 r
s
.87 .256 .112 r
.55384 .37291 m .552 .37705 L .57701 .37762 L p F P
0 0 0 r
s
.281 .424 .837 r
.49645 .3696 m .49961 .37016 L .49921 .35859 L p F P
0 0 0 r
s
.281 .424 .837 r
.50553 .35972 m .49921 .35859 L .49961 .37016 L p F P
0 0 0 r
s
.24 .35 .67 r
.5039 .37658 m
.51172 .36221 L
s
.83 .24 .1 r
.50039 .71479 m
.5271 .70746 L
s
.53858 .68725 m
.5271 .70746 L
s
.24 .35 .67 r
.17964 .53933 m
.18361 .51303 L
s
.281 .424 .837 r
.49329 .36904 m .49645 .3696 L .49288 .35745 L p F P
0 0 0 r
s
.281 .424 .837 r
.49921 .35859 m .49288 .35745 L .49645 .3696 L p F P
0 0 0 r
s
.83 .24 .1 r
.49567 .35795 m
.49605 .35701 L
s
.24 .35 .67 r
.42537 .61804 m
.46575 .62383 L
s
.471 .137 .065 r
.63195 .45591 m .62594 .4671 L .63535 .48534 L p F P
0 0 0 r
s
.83 .24 .1 r
.6151 .49745 m
.62816 .47335 L
s
.578 .169 .078 r
.62594 .4671 m .63195 .45591 L .61901 .43963 L p F P
0 0 0 r
s
1 .313 .132 r
.48379 .36734 m .48297 .36945 L .46587 .35714 L p F P
0 0 0 r
s
1 .313 .132 r
.46428 .36138 m .46587 .35714 L .48297 .36945 L p F P
0 0 0 r
s
.083 .024 .01 r
.32617 .54997 m .32985 .53825 L .33334 .51911 L p F P
0 0 0 r
s
.154 .045 .022 r
.32985 .53825 m .32617 .54997 L .32672 .5683 L p F P
0 0 0 r
s
.83 .24 .1 r
.32951 .54156 m
.33287 .52558 L
s
.281 .424 .837 r
.49012 .36847 m .49329 .36904 L .48654 .35631 L p F P
0 0 0 r
s
.281 .424 .837 r
.49288 .35745 m .48654 .35631 L .49329 .36904 L p F P
0 0 0 r
s
1 .336 .137 r
.37248 .44219 m .37583 .43183 L .39218 .41812 L p F P
0 0 0 r
s
1 .323 .129 r
.37583 .43183 m .37248 .44219 L .35864 .45871 L p F P
0 0 0 r
s
.83 .24 .1 r
.36737 .46223 m
.37545 .43735 L
s
.24 .35 .67 r
.20679 .36995 m
.24838 .37708 L
s
.24838 .37708 m
.25307 .35309 L
s
.3022 .581 m
.32485 .58431 L
s
.32742 .58468 m
.34327 .587 L
s
.281 .424 .837 r
.48696 .36791 m .49012 .36847 L .48019 .35517 L p F P
0 0 0 r
s
.281 .424 .837 r
.48654 .35631 m .48019 .35517 L .49012 .36847 L p F P
0 0 0 r
s
.24 .35 .67 r
.5897 .65549 m
.59673 .66478 L
s
.83 .24 .1 r
.32914 .62267 m
.34253 .64719 L
s
.281 .424 .837 r
.48379 .36734 m .48696 .36791 L .47383 .35402 L p F P
0 0 0 r
s
.281 .424 .837 r
.48019 .35517 m .47383 .35402 L .48696 .36791 L p F P
0 0 0 r
s
.83 .24 .1 r
.48552 .3836 m
.49177 .3678 L
s
.143 .178 .333 r
.50206 .64449 m .48548 .64214 L .48423 .63177 L p F P
0 0 0 r
s
.143 .178 .333 r
.46613 .62919 m .48423 .63177 L .48548 .64214 L p F P
0 0 0 r
s
1 .333 .138 r
.43791 .37914 m .43574 .38521 L .4162 .391 L p F P
0 0 0 r
s
.24 .35 .67 r
.41686 .38172 m
.42351 .36231 L
s
1 .333 .138 r
.41352 .3988 m .4162 .391 L .43574 .38521 L p F P
0 0 0 r
s
.83 .24 .1 r
.42059 .41375 m
.42974 .38792 L
s
.42974 .38792 m
.45694 .38331 L
s
.101 .114 .218 r
.56763 .65375 m .58384 .65604 L .57446 .66161 L p F P
0 0 0 r
s
1 .304 .122 r
.58896 .64744 m .58384 .65604 L .57446 .66161 L p F P
0 0 0 r
s
.24 .35 .67 r
.58487 .6548 m
.5897 .65549 L
s
.58467 .65478 m
.58487 .6548 L
s
1 .313 .132 r
.46587 .35714 m .46746 .35288 L .48379 .36734 L p F P
0 0 0 r
s
.281 .424 .837 r
.47383 .35402 m .46746 .35288 L .48379 .36734 L p F P
0 0 0 r
s
1 .324 .136 r
.46115 .36978 m .4596 .37394 L .4401 .37302 L p F P
0 0 0 r
s
1 .324 .136 r
.43791 .37914 m .4401 .37302 L .4596 .37394 L p F P
0 0 0 r
s
.096 .028 .012 r
.61411 .60412 m .62043 .59347 L .62379 .57679 L p F P
0 0 0 r
s
.096 .028 .012 r
.63045 .56546 m .62379 .57679 L .62043 .59347 L p F P
0 0 0 r
s
.171 .049 .025 r
.62379 .57679 m .63045 .56546 L .63087 .54708 L p F P
0 0 0 r
s
.83 .24 .1 r
.61651 .56929 m
.62961 .54663 L
s
.18 .237 .449 r
.4113 .62137 m .39285 .61874 L .38696 .60467 L p F P
0 0 0 r
s
.18 .237 .449 r
.36738 .60184 m .38696 .60467 L .39285 .61874 L p F P
0 0 0 r
s
.24 .35 .67 r
.29469 .36037 m
.33585 .36756 L
s
.33585 .36756 m
.34136 .34773 L
s
.822 .24 .091 r
.33334 .51911 m .33705 .50719 L .3443 .48825 L p F P
0 0 0 r
s
.083 .024 .01 r
.33705 .50719 m .33334 .51911 L .32985 .53825 L p F P
0 0 0 r
s
1 .338 .139 r
.39218 .41812 m .39526 .40888 L .41352 .3988 L p F P
0 0 0 r
s
1 .336 .137 r
.39526 .40888 m .39218 .41812 L .37583 .43183 L p F P
0 0 0 r
s
.83 .24 .1 r
.37545 .43735 m
.39629 .42328 L
s
.083 .024 .01 r
.60233 .62799 m .60816 .61822 L .61411 .60412 L p F P
0 0 0 r
s
.083 .024 .01 r
.62043 .59347 m .61411 .60412 L .60816 .61822 L p F P
0 0 0 r
s
.83 .24 .1 r
.60714 .61646 m
.61484 .59358 L
s
.578 .169 .078 r
.62442 .42922 m .61901 .43963 L .63195 .45591 L p F P
0 0 0 r
s
.83 .24 .1 r
.6126 .45035 m
.62816 .47335 L
s
.667 .196 .088 r
.61901 .43963 m .62442 .42922 L .60802 .41583 L p F P
0 0 0 r
s
.87 .256 .112 r
.57701 .37762 m .57985 .37149 L .55384 .37291 L p F P
0 0 0 r
s
.24 .35 .67 r
.57859 .37422 m
.59164 .37656 L
s
.87 .256 .112 r
.55569 .36874 m .55384 .37291 L .57985 .37149 L p F P
0 0 0 r
s
.83 .24 .1 r
.54257 .39834 m
.55419 .37219 L
s
1 .338 .139 r
.4162 .391 m .41352 .3988 L .39526 .40888 L p F P
0 0 0 r
s
.81 .238 .105 r
.593 .39687 m .59677 .38905 L .57419 .3837 L p F P
0 0 0 r
s
.81 .238 .105 r
.57701 .37762 m .57419 .3837 L .59677 .38905 L p F P
0 0 0 r
s
.83 .24 .1 r
.56895 .41218 m
.58111 .38628 L
s
.231 .067 .035 r
.63087 .54708 m .6377 .53529 L .63487 .51617 L p F P
0 0 0 r
s
.171 .049 .025 r
.6377 .53529 m .63087 .54708 L .63045 .56546 L p F P
0 0 0 r
s
.24 .35 .67 r
.68017 .38238 m
.71929 .38947 L
s
.71929 .38947 m
.72996 .3874 L
s
.72608 .68495 m
.71548 .68145 L
s
.67633 .67596 m
.71548 .68145 L
s
.143 .178 .333 r
.48548 .64214 m .46883 .63979 L .46613 .62919 L p F P
0 0 0 r
s
.143 .178 .333 r
.44794 .6266 m .46613 .62919 L .46883 .63979 L p F P
0 0 0 r
s
.101 .114 .218 r
.57446 .66161 m .56004 .65959 L .56763 .65375 L p F P
0 0 0 r
s
.101 .114 .218 r
.55134 .65145 m .56763 .65375 L .56004 .65959 L p F P
0 0 0 r
s
.83 .24 .1 r
.5621 .67484 m
.58095 .65806 L
s
.667 .196 .088 r
.61267 .40656 m .60802 .41583 L .62442 .42922 L p F P
0 0 0 r
s
.744 .218 .097 r
.60802 .41583 m .61267 .40656 L .593 .39687 L p F P
0 0 0 r
s
.24 .35 .67 r
.22152 .54557 m
.17964 .53933 L
s
.21869 .56882 m
.22152 .54557 L
s
.744 .218 .097 r
.59677 .38905 m .593 .39687 L .61267 .40656 L p F P
0 0 0 r
s
.83 .24 .1 r
.59259 .42972 m
.60528 .40408 L
s
.55419 .37219 m
.58111 .38628 L
s
.54367 .36856 m
.55419 .37219 L
s
.52549 .3623 m
.53161 .36441 L
s
.18 .237 .449 r
.39285 .61874 m .3743 .61609 L .36738 .60184 L p F P
0 0 0 r
s
.24 .35 .67 r
.38391 .59293 m
.38455 .61219 L
s
.18 .237 .449 r
.34769 .599 m .36738 .60184 L .3743 .61609 L p F P
0 0 0 r
s
.997 .292 .115 r
.3443 .48825 m .34799 .47645 L .35864 .45871 L p F P
0 0 0 r
s
.822 .24 .091 r
.34799 .47645 m .3443 .48825 L .33705 .50719 L p F P
0 0 0 r
s
.83 .24 .1 r
.34028 .50189 m
.35122 .48035 L
s
.33287 .52558 m
.34028 .50189 L
s
.231 .067 .035 r
.64167 .50419 m .63487 .51617 L .6377 .53529 L p F P
0 0 0 r
s
.34 .098 .05 r
.63487 .51617 m .64167 .50419 L .63535 .48534 L p F P
0 0 0 r
s
1 .324 .136 r
.46271 .3656 m .46115 .36978 L .44232 .36684 L p F P
0 0 0 r
s
.24 .35 .67 r
.42351 .36231 m
.4473 .36653 L
s
1 .324 .136 r
.4401 .37302 m .44232 .36684 L .46115 .36978 L p F P
0 0 0 r
s
.871 .26 .101 r
.58896 .64744 m .59416 .6387 L .60233 .62799 L p F P
0 0 0 r
s
.871 .26 .101 r
.60816 .61822 m .60233 .62799 L .59416 .6387 L p F P
0 0 0 r
s
.83 .24 .1 r
.59444 .63782 m
.60714 .61646 L
s
.24 .35 .67 r
.38455 .61219 m
.42537 .61804 L
s
.87 .256 .112 r
.57985 .37149 m .58273 .36529 L .55569 .36874 L p F P
0 0 0 r
s
.24 .35 .67 r
.5519 .36942 m
.55883 .37067 L
s
.263 .406 .804 r
.54946 .36762 m .55569 .36874 L .58273 .36529 L p F P
0 0 0 r
s
.24 .35 .67 r
.38266 .35506 m
.42351 .36231 L
s
.101 .114 .218 r
.56004 .65959 m .54558 .65756 L .55134 .65145 L p F P
0 0 0 r
s
.101 .114 .218 r
.53499 .64914 m .55134 .65145 L .54558 .65756 L p F P
0 0 0 r
s
.24 .35 .67 r
.54995 .64986 m
.58186 .65438 L
s
.54522 .63523 m
.54995 .64986 L
s
.20679 .36995 m
.211 .34574 L
s
.30155 .60029 m
.3022 .581 L
s
.26067 .57494 m
.3022 .581 L
s
1 .333 .138 r
.4401 .37302 m .43791 .37914 L .41892 .38311 L p F P
0 0 0 r
s
1 .333 .138 r
.4162 .391 m .41892 .38311 L .43791 .37914 L p F P
0 0 0 r
s
.143 .178 .333 r
.46883 .63979 m .45211 .63743 L .44794 .6266 L p F P
0 0 0 r
s
.143 .178 .333 r
.42967 .62399 m .44794 .6266 L .45211 .63743 L p F P
0 0 0 r
s
.263 .406 .804 r
.54322 .3665 m .54946 .36762 L .5735 .36362 L p F P
0 0 0 r
s
.263 .406 .804 r
.58273 .36529 m .5735 .36362 L .54946 .36762 L p F P
0 0 0 r
s
.83 .24 .1 r
.55419 .37219 m
.55625 .36754 L
s
1 .323 .129 r
.35864 .45871 m .36224 .44736 L .37583 .43183 L p F P
0 0 0 r
s
.997 .292 .115 r
.36224 .44736 m .35864 .45871 L .34799 .47645 L p F P
0 0 0 r
s
.34 .098 .05 r
.64192 .47348 m .63535 .48534 L .64167 .50419 L p F P
0 0 0 r
s
.83 .24 .1 r
.62517 .52173 m
.63857 .49788 L
s
.471 .137 .065 r
.63535 .48534 m .64192 .47348 L .63195 .45591 L p F P
0 0 0 r
s
.18 .237 .449 r
.3743 .61609 m .35566 .61343 L .34769 .599 L p F P
0 0 0 r
s
.18 .237 .449 r
.3279 .59614 m .34769 .599 L .35566 .61343 L p F P
0 0 0 r
s
.81 .238 .105 r
.59677 .38905 m .60059 .38114 L .57701 .37762 L p F P
0 0 0 r
s
.83 .24 .1 r
.58111 .38628 m
.60528 .40408 L
s
.81 .238 .105 r
.57985 .37149 m .57701 .37762 L .60059 .38114 L p F P
0 0 0 r
s
.24 .35 .67 r
.25307 .35309 m
.29469 .36037 L
s
.29469 .36037 m
.29961 .34031 L
s
.263 .406 .804 r
.53696 .36538 m .54322 .3665 L .56425 .36194 L p F P
0 0 0 r
s
.263 .406 .804 r
.5735 .36362 m .56425 .36194 L .54322 .3665 L p F P
0 0 0 r
s
.83 .24 .1 r
.47138 .71659 m
.50039 .71479 L
s
.51142 .69456 m
.50039 .71479 L
s
1 .324 .136 r
.46428 .36138 m .46271 .3656 L .44455 .3606 L p F P
0 0 0 r
s
1 .324 .136 r
.44232 .36684 m .44455 .3606 L .46271 .3656 L p F P
0 0 0 r
s
.263 .406 .804 r
.5307 .36425 m .53696 .36538 L .55497 .36027 L p F P
0 0 0 r
s
.263 .406 .804 r
.56425 .36194 m .55497 .36027 L .53696 .36538 L p F P
0 0 0 r
s
.101 .114 .218 r
.54558 .65756 m .53105 .65552 L .53499 .64914 L p F P
0 0 0 r
s
.101 .114 .218 r
.51856 .64682 m .53499 .64914 L .53105 .65552 L p F P
0 0 0 r
s
.24 .35 .67 r
.64062 .37522 m
.68017 .38238 L
s
.68017 .38238 m
.69014 .38017 L
s
1 .336 .137 r
.37583 .43183 m .37925 .42129 L .39526 .40888 L p F P
0 0 0 r
s
1 .323 .129 r
.37925 .42129 m .37583 .43183 L .36224 .44736 L p F P
0 0 0 r
s
1 .338 .139 r
.41892 .38311 m .4162 .391 L .39838 .3995 L p F P
0 0 0 r
s
1 .338 .139 r
.39526 .40888 m .39838 .3995 L .4162 .391 L p F P
0 0 0 r
s
.83 .24 .1 r
.40503 .39738 m
.42974 .38792 L
s
.143 .178 .333 r
.45211 .63743 m .43531 .63505 L .42967 .62399 L p F P
0 0 0 r
s
.143 .178 .333 r
.4113 .62137 m .42967 .62399 L .43531 .63505 L p F P
0 0 0 r
s
.24 .35 .67 r
.68623 .67937 m
.67633 .67596 L
s
.63675 .6704 m
.67633 .67596 L
s
.83 .24 .1 r
.3503 .62554 m
.34253 .64719 L
s
.34253 .64719 m
.36146 .66954 L
s
.263 .406 .804 r
.52442 .36312 m .5307 .36425 L .54567 .35858 L p F P
0 0 0 r
s
.83 .24 .1 r
.49605 .35701 m
.52549 .3623 L
s
.263 .406 .804 r
.55497 .36027 m .54567 .35858 L .5307 .36425 L p F P
0 0 0 r
s
.471 .137 .065 r
.63808 .44451 m .63195 .45591 L .64192 .47348 L p F P
0 0 0 r
s
.83 .24 .1 r
.62816 .47335 m
.63857 .49788 L
s
.578 .169 .078 r
.63195 .45591 m .63808 .44451 L .62442 .42922 L p F P
0 0 0 r
s
1 .336 .137 r
.39838 .3995 m .39526 .40888 L .37925 .42129 L p F P
0 0 0 r
s
.83 .24 .1 r
.39629 .42328 m
.40503 .39738 L
s
.154 .045 .022 r
.32672 .5683 m .3304 .5568 L .32985 .53825 L p F P
0 0 0 r
s
.226 .065 .035 r
.3304 .5568 m .32672 .5683 L .33145 .58534 L p F P
0 0 0 r
s
.226 .065 .035 r
.3279 .59614 m .33145 .58534 L .32672 .5683 L p F P
0 0 0 r
s
.24 .35 .67 r
.17625 .56262 m
.17964 .53933 L
s
.18 .237 .449 r
.35566 .61343 m .33693 .61076 L .3279 .59614 L p F P
0 0 0 r
s
.24 .35 .67 r
.34327 .587 m
.34328 .60627 L
s
.294 .087 .046 r
.33145 .58534 m .3279 .59614 L .33693 .61076 L p F P
0 0 0 r
s
.83 .24 .1 r
.32914 .62267 m
.3345 .60681 L
s
.53858 .68725 m
.5621 .67484 L
s
.48987 .35691 m
.49605 .35701 L
s
1 .304 .122 r
.57446 .66161 m .57893 .65402 L .58896 .64744 L p F P
0 0 0 r
s
1 .304 .122 r
.59416 .6387 m .58896 .64744 L .57893 .65402 L p F P
0 0 0 r
s
.263 .406 .804 r
.51814 .36199 m .52442 .36312 L .53635 .3569 L p F P
0 0 0 r
s
.263 .406 .804 r
.54567 .35858 m .53635 .3569 L .52442 .36312 L p F P
0 0 0 r
s
.24 .35 .67 r
.51172 .36221 m
.5519 .36942 L
s
.744 .218 .097 r
.61267 .40656 m .61739 .39715 L .59677 .38905 L p F P
0 0 0 r
s
.744 .218 .097 r
.60059 .38114 m .59677 .38905 L .61739 .39715 L p F P
0 0 0 r
s
.083 .024 .01 r
.32985 .53825 m .33361 .52627 L .33705 .50719 L p F P
0 0 0 r
s
.154 .045 .022 r
.33361 .52627 m .32985 .53825 L .3304 .5568 L p F P
0 0 0 r
s
.101 .114 .218 r
.53105 .65552 m .51647 .65347 L .51856 .64682 L p F P
0 0 0 r
s
.101 .114 .218 r
.50206 .64449 m .51856 .64682 L .51647 .65347 L p F P
0 0 0 r
s
.24 .35 .67 r
.50976 .64418 m
.54995 .64986 L
s
.578 .169 .078 r
.62993 .41864 m .62442 .42922 L .63808 .44451 L p F P
0 0 0 r
s
.667 .196 .088 r
.62442 .42922 m .62993 .41864 L .61267 .40656 L p F P
0 0 0 r
s
.83 .24 .1 r
.6126 .45035 m
.62578 .42498 L
s
.263 .406 .804 r
.51184 .36086 m .51814 .36199 L .52701 .35521 L p F P
0 0 0 r
s
.263 .406 .804 r
.53635 .3569 m .52701 .35521 L .51814 .36199 L p F P
0 0 0 r
s
1 .333 .138 r
.44232 .36684 m .4401 .37302 L .42167 .37513 L p F P
0 0 0 r
s
1 .333 .138 r
.41892 .38311 m .42167 .37513 L .4401 .37302 L p F P
0 0 0 r
s
.24 .35 .67 r
.34328 .60627 m
.38455 .61219 L
s
.76933 .39455 m
.80828 .40163 L
s
.81951 .40621 m
.80828 .40163 L
s
.143 .178 .333 r
.43531 .63505 m .41843 .63267 L .4113 .62137 L p F P
0 0 0 r
s
.24 .35 .67 r
.42537 .61804 m
.42806 .63262 L
s
.143 .178 .333 r
.39285 .61874 m .4113 .62137 L .41843 .63267 L p F P
0 0 0 r
s
.667 .196 .088 r
.61739 .39715 m .61267 .40656 L .62993 .41864 L p F P
0 0 0 r
s
.83 .24 .1 r
.60528 .40408 m
.62578 .42498 L
s
1 .324 .136 r
.46587 .35714 m .46428 .36138 L .44681 .3543 L p F P
0 0 0 r
s
1 .324 .136 r
.44455 .3606 m .44681 .3543 L .46428 .36138 L p F P
0 0 0 r
s
.24 .35 .67 r
.34136 .34773 m
.38266 .35506 L
s
.38266 .35506 m
.38852 .34007 L
s
.25937 .59424 m
.26067 .57494 L
s
.21869 .56882 m
.26067 .57494 L
s
.263 .406 .804 r
.50553 .35972 m .51184 .36086 L .51764 .35351 L p F P
0 0 0 r
s
.263 .406 .804 r
.52701 .35521 m .51764 .35351 L .51184 .36086 L p F P
0 0 0 r
s
.096 .028 .012 r
.62043 .59347 m .62689 .58262 L .63045 .56546 L p F P
0 0 0 r
s
.096 .028 .012 r
.63726 .5539 m .63045 .56546 L .62689 .58262 L p F P
0 0 0 r
s
.83 .24 .1 r
.62806 .57115 m
.62961 .54663 L
s
.171 .049 .025 r
.63045 .56546 m .63726 .5539 L .6377 .53529 L p F P
0 0 0 r
s
.81 .238 .105 r
.60059 .38114 m .60446 .37313 L .57985 .37149 L p F P
0 0 0 r
s
.81 .238 .105 r
.58273 .36529 m .57985 .37149 L .60446 .37313 L p F P
0 0 0 r
s
.083 .024 .01 r
.60816 .61822 m .6141 .60827 L .62043 .59347 L p F P
0 0 0 r
s
.083 .024 .01 r
.62689 .58262 m .62043 .59347 L .6141 .60827 L p F P
0 0 0 r
s
.83 .24 .1 r
.61484 .59358 m
.62806 .57115 L
s
.822 .24 .091 r
.33705 .50719 m .34084 .49503 L .34799 .47645 L p F P
0 0 0 r
s
.083 .024 .01 r
.34084 .49503 m .33705 .50719 L .33361 .52627 L p F P
0 0 0 r
s
.263 .406 .804 r
.49921 .35859 m .50553 .35972 L .50824 .35181 L p F P
0 0 0 r
s
.263 .406 .804 r
.51764 .35351 m .50824 .35181 L .50553 .35972 L p F P
0 0 0 r
s
.101 .114 .218 r
.51647 .65347 m .50182 .65142 L .50206 .64449 L p F P
0 0 0 r
s
.101 .114 .218 r
.48548 .64214 m .50206 .64449 L .50182 .65142 L p F P
0 0 0 r
s
.24 .35 .67 r
.211 .34574 m
.25307 .35309 L
s
.25307 .35309 m
.25739 .33282 L
s
.231 .067 .035 r
.6377 .53529 m .64467 .52326 L .64167 .50419 L p F P
0 0 0 r
s
.171 .049 .025 r
.64467 .52326 m .6377 .53529 L .63726 .5539 L p F P
0 0 0 r
s
.263 .406 .804 r
.49288 .35745 m .49921 .35859 L .49883 .35011 L p F P
0 0 0 r
s
.263 .406 .804 r
.50824 .35181 m .49883 .35011 L .49921 .35859 L p F P
0 0 0 r
s
.143 .178 .333 r
.41843 .63267 m .40148 .63027 L .39285 .61874 L p F P
0 0 0 r
s
.143 .178 .333 r
.3743 .61609 m .39285 .61874 L .40148 .63027 L p F P
0 0 0 r
s
.24 .35 .67 r
.64062 .37522 m
.64988 .37286 L
s
.871 .26 .101 r
.59416 .6387 m .59945 .6298 L .60816 .61822 L p F P
0 0 0 r
s
.871 .26 .101 r
.6141 .60827 m .60816 .61822 L .59945 .6298 L p F P
0 0 0 r
s
.83 .24 .1 r
.44147 .71267 m
.47138 .71659 L
s
.48187 .69627 m
.47138 .71659 L
s
.24 .35 .67 r
.64594 .67373 m
.63675 .6704 L
s
.59673 .66478 m
.63675 .6704 L
s
.263 .406 .804 r
.48654 .35631 m .49288 .35745 L .48939 .3484 L p F P
0 0 0 r
s
.263 .406 .804 r
.49883 .35011 m .48939 .3484 L .49288 .35745 L p F P
0 0 0 r
s
.997 .292 .115 r
.34799 .47645 m .35175 .46441 L .36224 .44736 L p F P
0 0 0 r
s
.822 .24 .091 r
.35175 .46441 m .34799 .47645 L .34084 .49503 L p F P
0 0 0 r
s
1 .324 .136 r
.46746 .35288 m .46587 .35714 L .44908 .34794 L p F P
0 0 0 r
s
.83 .24 .1 r
.46694 .35654 m
.47767 .35671 L
s
1 .324 .136 r
.44681 .3543 m .44908 .34794 L .46587 .35714 L p F P
0 0 0 r
s
.83 .24 .1 r
.45694 .38331 m
.46694 .35654 L
s
1 .338 .139 r
.42167 .37513 m .41892 .38311 L .40155 .38998 L p F P
0 0 0 r
s
1 .338 .139 r
.39838 .3995 m .40155 .38998 L .41892 .38311 L p F P
0 0 0 r
s
.231 .067 .035 r
.64861 .49197 m .64167 .50419 L .64467 .52326 L p F P
0 0 0 r
s
.34 .098 .05 r
.64167 .50419 m .64861 .49197 L .64192 .47348 L p F P
0 0 0 r
s
.83 .24 .1 r
.63857 .49788 m
.64325 .52303 L
s
.101 .114 .218 r
.50182 .65142 m .48713 .64936 L .48548 .64214 L p F P
0 0 0 r
s
.101 .114 .218 r
.46883 .63979 m .48548 .64214 L .48713 .64936 L p F P
0 0 0 r
s
.83 .24 .1 r
.36967 .64822 m
.36146 .66954 L
s
.36146 .66954 m
.38507 .68853 L
s
.263 .406 .804 r
.48019 .35517 m .48654 .35631 L .47992 .34668 L p F P
0 0 0 r
s
.263 .406 .804 r
.48939 .3484 m .47992 .34668 L .48654 .35631 L p F P
0 0 0 r
s
1 .333 .138 r
.44455 .3606 m .44232 .36684 L .42446 .36705 L p F P
0 0 0 r
s
1 .333 .138 r
.42167 .37513 m .42446 .36705 L .44232 .36684 L p F P
0 0 0 r
s
.263 .406 .804 r
.47383 .35402 m .48019 .35517 L .47043 .34497 L p F P
0 0 0 r
s
.263 .406 .804 r
.47992 .34668 m .47043 .34497 L .48019 .35517 L p F P
0 0 0 r
s
.24 .35 .67 r
.46844 .36032 m
.47111 .35491 L
s
.47111 .35491 m
.51172 .36221 L
s
1 .323 .129 r
.36224 .44736 m .3659 .4358 L .37925 .42129 L p F P
0 0 0 r
s
.997 .292 .115 r
.3659 .4358 m .36224 .44736 L .35175 .46441 L p F P
0 0 0 r
s
.83 .24 .1 r
.35907 .45555 m
.37545 .43735 L
s
.35122 .48035 m
.35907 .45555 L
s
.143 .178 .333 r
.40148 .63027 m .38445 .62787 L .3743 .61609 L p F P
0 0 0 r
s
.143 .178 .333 r
.35566 .61343 m .3743 .61609 L .38445 .62787 L p F P
0 0 0 r
s
.744 .218 .097 r
.61739 .39715 m .62219 .3876 L .60059 .38114 L p F P
0 0 0 r
s
.744 .218 .097 r
.60446 .37313 m .60059 .38114 L .62219 .3876 L p F P
0 0 0 r
s
.24 .35 .67 r
.33573 .60519 m
.34328 .60627 L
s
.72996 .3874 m
.76933 .39455 L
s
.76933 .39455 m
.77989 .39903 L
s
.76548 .69047 m
.77788 .68765 L
s
.72608 .68495 m
.76548 .69047 L
s
1 .336 .137 r
.40155 .38998 m .39838 .3995 L .38272 .41057 L p F P
0 0 0 r
s
1 .336 .137 r
.37925 .42129 m .38272 .41057 L .39838 .3995 L p F P
0 0 0 r
s
.81 .238 .105 r
.60446 .37313 m .60838 .36502 L .58273 .36529 L p F P
0 0 0 r
s
.24 .35 .67 r
.60644 .36903 m
.64062 .37522 L
s
.224 .356 .712 r
.5735 .36362 m .58273 .36529 L .60838 .36502 L p F P
0 0 0 r
s
.34 .098 .05 r
.64861 .46138 m .64192 .47348 L .64861 .49197 L p F P
0 0 0 r
s
.471 .137 .065 r
.64192 .47348 m .64861 .46138 L .63808 .44451 L p F P
0 0 0 r
s
.263 .406 .804 r
.46746 .35288 m .47383 .35402 L .46092 .34324 L p F P
0 0 0 r
s
.263 .406 .804 r
.47043 .34497 m .46092 .34324 L .47383 .35402 L p F P
0 0 0 r
s
.24 .35 .67 r
.29961 .34031 m
.34136 .34773 L
s
.34136 .34773 m
.34654 .33253 L
s
1 .323 .129 r
.38272 .41057 m .37925 .42129 L .3659 .4358 L p F P
0 0 0 r
s
.24 .35 .67 r
.21671 .58812 m
.21869 .56882 L
s
.17625 .56262 m
.21869 .56882 L
s
.101 .114 .218 r
.48713 .64936 m .47237 .64728 L .46883 .63979 L p F P
0 0 0 r
s
.101 .114 .218 r
.45211 .63743 m .46883 .63979 L .47237 .64728 L p F P
0 0 0 r
s
.24 .35 .67 r
.46913 .63843 m
.50976 .64418 L
s
.46575 .62383 m
.46913 .63843 L
s
.46401 .35363 m
.47111 .35491 L
s
.43004 .34753 m
.44807 .35077 L
s
.074 .086 .165 r
.56004 .65959 m .57446 .66161 L .56294 .66343 L p F P
0 0 0 r
s
1 .327 .133 r
.57893 .65402 m .57446 .66161 L .56294 .66343 L p F P
0 0 0 r
s
.83 .24 .1 r
.56927 .66257 m
.56936 .66242 L
s
1 .324 .136 r
.44908 .34794 m .45138 .34152 L .46746 .35288 L p F P
0 0 0 r
s
.263 .406 .804 r
.46092 .34324 m .45138 .34152 L .46746 .35288 L p F P
0 0 0 r
s
.83 .24 .1 r
.46694 .35654 m
.46872 .35178 L
s
.224 .356 .712 r
.56425 .36194 m .5735 .36362 L .59632 .36283 L p F P
0 0 0 r
s
.224 .356 .712 r
.60838 .36502 m .59632 .36283 L .5735 .36362 L p F P
0 0 0 r
s
.83 .24 .1 r
.58111 .38628 m
.5912 .36482 L
s
.4122 .70317 m
.44147 .71267 L
s
.45138 .69219 m
.44147 .71267 L
s
1 .304 .122 r
.57893 .65402 m .58346 .64632 L .59416 .6387 L p F P
0 0 0 r
s
1 .304 .122 r
.59945 .6298 m .59416 .6387 L .58346 .64632 L p F P
0 0 0 r
s
.83 .24 .1 r
.59554 .63385 m
.60714 .61646 L
s
.24 .35 .67 r
.211 .34574 m
.2147 .32524 L
s
.471 .137 .065 r
.64432 .43289 m .63808 .44451 L .64861 .46138 L p F P
0 0 0 r
s
.83 .24 .1 r
.62816 .47335 m
.64176 .44825 L
s
.578 .169 .078 r
.63808 .44451 m .64432 .43289 L .62993 .41864 L p F P
0 0 0 r
s
.667 .196 .088 r
.62993 .41864 m .63553 .40788 L .61739 .39715 L p F P
0 0 0 r
s
.667 .196 .088 r
.62219 .3876 m .61739 .39715 L .63553 .40788 L p F P
0 0 0 r
s
.143 .178 .333 r
.38445 .62787 m .36734 .62545 L .35566 .61343 L p F P
0 0 0 r
s
.143 .178 .333 r
.33693 .61076 m .35566 .61343 L .36734 .62545 L p F P
0 0 0 r
s
.83 .24 .1 r
.39381 .66753 m
.38507 .68853 L
s
.38507 .68853 m
.4122 .70317 L
s
.578 .169 .078 r
.63553 .40788 m .62993 .41864 L .64432 .43289 L p F P
0 0 0 r
s
.83 .24 .1 r
.62578 .42498 m
.64176 .44825 L
s
.224 .356 .712 r
.55497 .36027 m .56425 .36194 L .58423 .36064 L p F P
0 0 0 r
s
.24 .35 .67 r
.5519 .36942 m
.5602 .36066 L
s
.224 .356 .712 r
.59632 .36283 m .58423 .36064 L .56425 .36194 L p F P
0 0 0 r
s
.83 .24 .1 r
.59246 .36213 m
.59378 .35932 L
s
.24 .35 .67 r
.5602 .36066 m
.59255 .36652 L
s
.101 .114 .218 r
.47237 .64728 m .45755 .64521 L .45211 .63743 L p F P
0 0 0 r
s
.101 .114 .218 r
.43531 .63505 m .45211 .63743 L .45755 .64521 L p F P
0 0 0 r
s
.074 .086 .165 r
.56294 .66343 m .55074 .66172 L .56004 .65959 L p F P
0 0 0 r
s
.83 .24 .1 r
.5621 .67484 m
.56927 .66257 L
s
.074 .086 .165 r
.54558 .65756 m .56004 .65959 L .55074 .66172 L p F P
0 0 0 r
s
.226 .065 .035 r
.33145 .58534 m .33507 .57433 L .3304 .5568 L p F P
0 0 0 r
s
.294 .087 .046 r
.33507 .57433 m .33145 .58534 L .34038 .60067 L p F P
0 0 0 r
s
.294 .087 .046 r
.33693 .61076 m .34038 .60067 L .33145 .58534 L p F P
0 0 0 r
s
.24 .35 .67 r
.30155 .60029 m
.33392 .60493 L
s
.154 .045 .022 r
.3304 .5568 m .33415 .54506 L .33361 .52627 L p F P
0 0 0 r
s
.226 .065 .035 r
.33415 .54506 m .3304 .5568 L .33507 .57433 L p F P
0 0 0 r
s
.24 .35 .67 r
.6052 .66802 m
.59673 .66478 L
s
.57305 .66146 m
.59673 .66478 L
s
.57175 .66128 m
.57305 .66146 L
s
.83 .24 .1 r
.42152 .68245 m
.4122 .70317 L
s
.51142 .69456 m
.53858 .68725 L
s
.55055 .6662 m
.53858 .68725 L
s
1 .333 .138 r
.44681 .3543 m .44455 .3606 L .42728 .35887 L p F P
0 0 0 r
s
1 .333 .138 r
.42446 .36705 m .42728 .35887 L .44455 .3606 L p F P
0 0 0 r
s
.24 .35 .67 r
.42351 .36231 m
.43004 .34753 L
s
.83 .24 .1 r
.43927 .36102 m
.46694 .35654 L
s
.42974 .38792 m
.43927 .36102 L
s
.224 .356 .712 r
.54567 .35858 m .55497 .36027 L .5721 .35843 L p F P
0 0 0 r
s
.83 .24 .1 r
.55946 .36032 m
.55971 .35976 L
s
.224 .356 .712 r
.58423 .36064 m .5721 .35843 L .55497 .36027 L p F P
0 0 0 r
s
.083 .024 .01 r
.33361 .52627 m .33744 .51405 L .34084 .49503 L p F P
0 0 0 r
s
.154 .045 .022 r
.33744 .51405 m .33361 .52627 L .33415 .54506 L p F P
0 0 0 r
s
.83 .24 .1 r
.33714 .51692 m
.34028 .50189 L
s
1 .338 .139 r
.42446 .36705 m .42167 .37513 L .40477 .38033 L p F P
0 0 0 r
s
1 .338 .139 r
.40155 .38998 m .40477 .38033 L .42167 .37513 L p F P
0 0 0 r
s
.143 .178 .333 r
.36734 .62545 m .35015 .62302 L .33693 .61076 L p F P
0 0 0 r
s
.433 .13 .063 r
.34038 .60067 m .33693 .61076 L .35015 .62302 L p F P
0 0 0 r
s
.24 .35 .67 r
.34328 .60627 m
.34339 .60755 L
s
.83 .24 .1 r
.3476 .62065 m
.3503 .62554 L
s
.074 .086 .165 r
.55074 .66172 m .5385 .66001 L .54558 .65756 L p F P
0 0 0 r
s
.24 .35 .67 r
.54995 .64986 m
.55627 .65911 L
s
.074 .086 .165 r
.53105 .65552 m .54558 .65756 L .5385 .66001 L p F P
0 0 0 r
s
.101 .114 .218 r
.45755 .64521 m .44268 .64312 L .43531 .63505 L p F P
0 0 0 r
s
.101 .114 .218 r
.41843 .63267 m .43531 .63505 L .44268 .64312 L p F P
0 0 0 r
s
.24 .35 .67 r
.42806 .63262 m
.46913 .63843 L
s
.224 .356 .712 r
.53635 .3569 m .54567 .35858 L .55993 .35622 L p F P
0 0 0 r
s
.224 .356 .712 r
.5721 .35843 m .55993 .35622 L .54567 .35858 L p F P
0 0 0 r
s
.83 .24 .1 r
.56118 .35645 m
.56629 .34496 L
s
.24 .35 .67 r
.30206 .61479 m
.30155 .60029 L
s
.25937 .59424 m
.30155 .60029 L
s
.69014 .38017 m
.72996 .3874 L
s
.72996 .3874 m
.73982 .39177 L
s
.083 .024 .01 r
.6141 .60827 m .62015 .59813 L .62689 .58262 L p F P
0 0 0 r
s
.083 .024 .01 r
.63346 .57155 m .62689 .58262 L .62015 .59813 L p F P
0 0 0 r
s
.096 .028 .012 r
.62689 .58262 m .63346 .57155 L .63726 .5539 L p F P
0 0 0 r
s
.83 .24 .1 r
.62036 .59422 m
.62806 .57115 L
s
.096 .028 .012 r
.6442 .5421 m .63726 .5539 L .63346 .57155 L p F P
0 0 0 r
s
.171 .049 .025 r
.63726 .5539 m .6442 .5421 L .64467 .52326 L p F P
0 0 0 r
s
.83 .24 .1 r
.62961 .54663 m
.64325 .52303 L
s
.24 .35 .67 r
.7378 .68201 m
.72608 .68495 L
s
.68623 .67937 m
.72608 .68495 L
s
.25739 .33282 m
.29961 .34031 L
s
.29961 .34031 m
.30408 .3249 L
s
.744 .218 .097 r
.62219 .3876 m .62705 .3779 L .60446 .37313 L p F P
0 0 0 r
s
.744 .218 .097 r
.60838 .36502 m .60446 .37313 L .62705 .3779 L p F P
0 0 0 r
s
.822 .24 .091 r
.34084 .49503 m .34471 .48262 L .35175 .46441 L p F P
0 0 0 r
s
.083 .024 .01 r
.34471 .48262 m .34084 .49503 L .33744 .51405 L p F P
0 0 0 r
s
.24 .35 .67 r
.17357 .58194 m
.17625 .56262 L
s
.38852 .34007 m
.43004 .34753 L
s
.224 .356 .712 r
.52701 .35521 m .53635 .3569 L .54772 .354 L p F P
0 0 0 r
s
.224 .356 .712 r
.55993 .35622 m .54772 .354 L .53635 .3569 L p F P
0 0 0 r
s
.871 .26 .101 r
.59945 .6298 m .60483 .62076 L .6141 .60827 L p F P
0 0 0 r
s
.871 .26 .101 r
.62015 .59813 m .6141 .60827 L .60483 .62076 L p F P
0 0 0 r
s
.83 .24 .1 r
.60714 .61646 m
.62036 .59422 L
s
.231 .067 .035 r
.64467 .52326 m .65179 .51097 L .64861 .49197 L p F P
0 0 0 r
s
.171 .049 .025 r
.65179 .51097 m .64467 .52326 L .6442 .5421 L p F P
0 0 0 r
s
.074 .086 .165 r
.5385 .66001 m .52622 .65829 L .53105 .65552 L p F P
0 0 0 r
s
.074 .086 .165 r
.51647 .65347 m .53105 .65552 L .52622 .65829 L p F P
0 0 0 r
s
.101 .114 .218 r
.44268 .64312 m .42774 .64102 L .41843 .63267 L p F P
0 0 0 r
s
.101 .114 .218 r
.40148 .63027 m .41843 .63267 L .42774 .64102 L p F P
0 0 0 r
s
1 .336 .137 r
.40477 .38033 m .40155 .38998 L .38624 .39967 L p F P
0 0 0 r
s
1 .336 .137 r
.38272 .41057 m .38624 .39967 L .40155 .38998 L p F P
0 0 0 r
s
.997 .292 .115 r
.35175 .46441 m .35559 .45213 L .3659 .4358 L p F P
0 0 0 r
s
.822 .24 .091 r
.35559 .45213 m .35175 .46441 L .34471 .48262 L p F P
0 0 0 r
s
.83 .24 .1 r
.348 .47723 m
.35907 .45555 L
s
.34028 .50189 m
.348 .47723 L
s
.224 .356 .712 r
.51764 .35351 m .52701 .35521 L .53546 .35178 L p F P
0 0 0 r
s
.83 .24 .1 r
.5285 .35512 m
.52876 .35449 L
s
.224 .356 .712 r
.54772 .354 m .53546 .35178 L .52701 .35521 L p F P
0 0 0 r
s
.83 .24 .1 r
.56629 .34496 m
.59378 .35932 L
s
.5789 .31658 m
.56629 .34496 L
s
.56629 .34496 m
.53701 .33483 L
s
1 .327 .133 r
.56294 .66343 m .56665 .65703 L .57893 .65402 L p F P
0 0 0 r
s
.24 .35 .67 r
.55627 .65911 m
.56475 .6603 L
s
1 .327 .133 r
.58346 .64632 m .57893 .65402 L .56665 .65703 L p F P
0 0 0 r
s
.83 .24 .1 r
.58117 .64778 m
.58727 .64239 L
s
1 .333 .138 r
.44908 .34794 m .44681 .3543 L .43013 .35058 L p F P
0 0 0 r
s
1 .333 .138 r
.42728 .35887 m .43013 .35058 L .44681 .3543 L p F P
0 0 0 r
s
.231 .067 .035 r
.65569 .47949 m .64861 .49197 L .65179 .51097 L p F P
0 0 0 r
s
.34 .098 .05 r
.64861 .49197 m .65569 .47949 L .64861 .46138 L p F P
0 0 0 r
s
1 .323 .129 r
.3659 .4358 m .36963 .42402 L .38272 .41057 L p F P
0 0 0 r
s
.997 .292 .115 r
.36963 .42402 m .3659 .4358 L .35559 .45213 L p F P
0 0 0 r
s
1 .323 .129 r
.38624 .39967 m .38272 .41057 L .36963 .42402 L p F P
0 0 0 r
s
.83 .24 .1 r
.37545 .43735 m
.38387 .41145 L
s
.38387 .41145 m
.40503 .39738 L
s
.074 .086 .165 r
.52622 .65829 m .5139 .65657 L .51647 .65347 L p F P
0 0 0 r
s
.074 .086 .165 r
.50182 .65142 m .51647 .65347 L .5139 .65657 L p F P
0 0 0 r
s
.24 .35 .67 r
.51536 .65336 m
.55627 .65911 L
s
.224 .356 .712 r
.50824 .35181 m .51764 .35351 L .52317 .34955 L p F P
0 0 0 r
s
.224 .356 .712 r
.53546 .35178 m .52317 .34955 L .51764 .35351 L p F P
0 0 0 r
s
.24 .35 .67 r
.51172 .36221 m
.51933 .35326 L
s
.51933 .35326 m
.5602 .36066 L
s
.83 .24 .1 r
.5303 .35084 m
.53701 .33483 L
s
.667 .196 .088 r
.63553 .40788 m .64122 .39693 L .62219 .3876 L p F P
0 0 0 r
s
.667 .196 .088 r
.62705 .3779 m .62219 .3876 L .64122 .39693 L p F P
0 0 0 r
s
.83 .24 .1 r
.59378 .35932 m
.59935 .36338 L
s
.101 .114 .218 r
.42774 .64102 m .41275 .63892 L .40148 .63027 L p F P
0 0 0 r
s
.101 .114 .218 r
.38445 .62787 m .40148 .63027 L .41275 .63892 L p F P
0 0 0 r
s
.83 .24 .1 r
.54902 .30619 m
.53701 .33483 L
s
.53701 .33483 m
.50701 .32931 L
s
.34 .098 .05 r
.65544 .44904 m .64861 .46138 L .65569 .47949 L p F P
0 0 0 r
s
.83 .24 .1 r
.63857 .49788 m
.65252 .47305 L
s
.471 .137 .065 r
.64861 .46138 m .65544 .44904 L .64432 .43289 L p F P
0 0 0 r
s
1 .304 .122 r
.58346 .64632 m .58807 .6385 L .59945 .6298 L p F P
0 0 0 r
s
1 .304 .122 r
.60483 .62076 m .59945 .6298 L .58807 .6385 L p F P
0 0 0 r
s
.224 .356 .712 r
.49883 .35011 m .50824 .35181 L .51083 .34731 L p F P
0 0 0 r
s
.224 .356 .712 r
.52317 .34955 m .51083 .34731 L .50824 .35181 L p F P
0 0 0 r
s
1 .338 .139 r
.42728 .35887 m .42446 .36705 L .40803 .37053 L p F P
0 0 0 r
s
1 .338 .139 r
.40477 .38033 m .40803 .37053 L .42446 .36705 L p F P
0 0 0 r
s
.24 .35 .67 r
.25912 .60871 m
.25937 .59424 L
s
.21671 .58812 m
.25937 .59424 L
s
.074 .086 .165 r
.5139 .65657 m .50154 .65484 L .50182 .65142 L p F P
0 0 0 r
s
.24 .35 .67 r
.50976 .64418 m
.51536 .65336 L
s
.074 .086 .165 r
.48713 .64936 m .50182 .65142 L .50154 .65484 L p F P
0 0 0 r
s
.24 .35 .67 r
.64988 .37286 m
.69014 .38017 L
s
.69014 .38017 m
.69929 .38442 L
s
.578 .169 .078 r
.64432 .43289 m .65068 .42106 L .63553 .40788 L p F P
0 0 0 r
s
.578 .169 .078 r
.64122 .39693 m .63553 .40788 L .65068 .42106 L p F P
0 0 0 r
s
.83 .24 .1 r
.62578 .42498 m
.6395 .39856 L
s
.471 .137 .065 r
.65068 .42106 m .64432 .43289 L .65544 .44904 L p F P
0 0 0 r
s
.83 .24 .1 r
.64176 .44825 m
.65252 .47305 L
s
.24 .35 .67 r
.69727 .6763 m
.68623 .67937 L
s
.64594 .67373 m
.68623 .67937 L
s
.2147 .32524 m
.25739 .33282 L
s
.25739 .33282 m
.26115 .31719 L
s
.224 .356 .712 r
.48939 .3484 m .49883 .35011 L .49846 .34506 L p F P
0 0 0 r
s
.224 .356 .712 r
.51083 .34731 m .49846 .34506 L .49883 .35011 L p F P
0 0 0 r
s
.83 .24 .1 r
.50062 .34545 m
.50701 .32931 L
s
.48187 .69627 m
.51142 .69456 L
s
.52292 .67348 m
.51142 .69456 L
s
.744 .218 .097 r
.62705 .3779 m .63199 .36807 L .60838 .36502 L p F P
0 0 0 r
s
.83 .24 .1 r
.60528 .40408 m
.6185 .37739 L
s
.157 .263 .533 r
.59632 .36283 m .60838 .36502 L .63199 .36807 L p F P
0 0 0 r
s
.83 .24 .1 r
.60084 .36448 m
.6185 .37739 L
s
.101 .114 .218 r
.41275 .63892 m .39769 .6368 L .38445 .62787 L p F P
0 0 0 r
s
.101 .114 .218 r
.36734 .62545 m .38445 .62787 L .39769 .6368 L p F P
0 0 0 r
s
.24 .35 .67 r
.38653 .62674 m
.42806 .63262 L
s
.38455 .61219 m
.38653 .62674 L
s
.34654 .33253 m
.38852 .34007 L
s
.38852 .34007 m
.39391 .33056 L
s
.224 .356 .712 r
.47992 .34668 m .48939 .3484 L .48604 .3428 L p F P
0 0 0 r
s
.224 .356 .712 r
.49846 .34506 m .48604 .3428 L .48939 .3484 L p F P
0 0 0 r
s
.074 .086 .165 r
.50154 .65484 m .48914 .6531 L .48713 .64936 L p F P
0 0 0 r
s
.074 .086 .165 r
.47237 .64728 m .48713 .64936 L .48914 .6531 L p F P
0 0 0 r
s
.226 .065 .035 r
.33507 .57433 m .33876 .56309 L .33415 .54506 L p F P
0 0 0 r
s
.294 .087 .046 r
.33876 .56309 m .33507 .57433 L .34389 .59039 L p F P
0 0 0 r
s
.294 .087 .046 r
.34038 .60067 m .34389 .59039 L .33507 .57433 L p F P
0 0 0 r
s
.24 .35 .67 r
.77989 .39903 m
.81951 .40621 L
s
.82941 .41731 m
.81951 .40621 L
s
1 .333 .138 r
.45138 .34152 m .44908 .34794 L .43302 .3422 L p F P
0 0 0 r
s
1 .333 .138 r
.43013 .35058 m .43302 .3422 L .44908 .34794 L p F P
0 0 0 r
s
.24 .35 .67 r
.43004 .34753 m
.43244 .3439 L
s
.154 .045 .022 r
.33415 .54506 m .33797 .53307 L .33744 .51405 L p F P
0 0 0 r
s
.226 .065 .035 r
.33797 .53307 m .33415 .54506 L .33876 .56309 L p F P
0 0 0 r
s
.157 .263 .533 r
.58423 .36064 m .59632 .36283 L .61735 .36541 L p F P
0 0 0 r
s
.157 .263 .533 r
.63199 .36807 m .61735 .36541 L .59632 .36283 L p F P
0 0 0 r
s
.83 .24 .1 r
.6185 .37739 m
.62369 .36691 L
s
.24 .35 .67 r
.60304 .36727 m
.60917 .36547 L
s
.433 .13 .063 r
.34389 .59039 m .34038 .60067 L .35343 .61386 L p F P
0 0 0 r
s
.433 .13 .063 r
.35015 .62302 m .35343 .61386 L .34038 .60067 L p F P
0 0 0 r
s
.24 .35 .67 r
.34453 .6208 m
.34989 .62156 L
s
.34412 .61599 m
.34453 .6208 L
s
.83 .24 .1 r
.51843 .30044 m
.50701 .32931 L
s
.50701 .32931 m
.47737 .32866 L
s
.224 .356 .712 r
.47043 .34497 m .47992 .34668 L .47358 .34054 L p F P
0 0 0 r
s
.224 .356 .712 r
.48604 .3428 m .47358 .34054 L .47992 .34668 L p F P
0 0 0 r
s
.24 .35 .67 r
.47111 .35491 m
.47799 .34578 L
s
.47799 .34578 m
.51933 .35326 L
s
.101 .114 .218 r
.39769 .6368 m .38257 .63468 L .36734 .62545 L p F P
0 0 0 r
s
.101 .114 .218 r
.35015 .62302 m .36734 .62545 L .38257 .63468 L p F P
0 0 0 r
s
.83 .24 .1 r
.3503 .62554 m
.35108 .62336 L
s
.083 .024 .01 r
.33744 .51405 m .34136 .50157 L .34471 .48262 L p F P
0 0 0 r
s
.154 .045 .022 r
.34136 .50157 m .33744 .51405 L .33797 .53307 L p F P
0 0 0 r
s
.074 .086 .165 r
.48914 .6531 m .47669 .65136 L .47237 .64728 L p F P
0 0 0 r
s
.074 .086 .165 r
.45755 .64521 m .47237 .64728 L .47669 .65136 L p F P
0 0 0 r
s
1 .336 .137 r
.40803 .37053 m .40477 .38033 L .38983 .38858 L p F P
0 0 0 r
s
1 .336 .137 r
.38624 .39967 m .38983 .38858 L .40477 .38033 L p F P
0 0 0 r
s
.157 .263 .533 r
.5721 .35843 m .58423 .36064 L .60266 .36273 L p F P
0 0 0 r
s
.157 .263 .533 r
.61735 .36541 m .60266 .36273 L .58423 .36064 L p F P
0 0 0 r
s
.224 .356 .712 r
.46092 .34324 m .47043 .34497 L .46108 .33827 L p F P
0 0 0 r
s
.224 .356 .712 r
.47358 .34054 m .46108 .33827 L .47043 .34497 L p F P
0 0 0 r
s
.83 .24 .1 r
.47297 .34043 m
.47737 .32866 L
s
.083 .024 .01 r
.62015 .59813 m .62631 .5878 L .63346 .57155 L p F P
0 0 0 r
s
.083 .024 .01 r
.64018 .56026 m .63346 .57155 L .62631 .5878 L p F P
0 0 0 r
s
.096 .028 .012 r
.63346 .57155 m .64018 .56026 L .6442 .5421 L p F P
0 0 0 r
s
1 .327 .133 r
.56665 .65703 m .5704 .65055 L .58346 .64632 L p F P
0 0 0 r
s
1 .327 .133 r
.58807 .6385 m .58346 .64632 L .5704 .65055 L p F P
0 0 0 r
s
.096 .028 .012 r
.65129 .53005 m .6442 .5421 L .64018 .56026 L p F P
0 0 0 r
s
.83 .24 .1 r
.64184 .54777 m
.64325 .52303 L
s
.62806 .57115 m
.64184 .54777 L
s
.171 .049 .025 r
.6442 .5421 m .65129 .53005 L .65179 .51097 L p F P
0 0 0 r
s
.871 .26 .101 r
.60483 .62076 m .6103 .61156 L .62015 .59813 L p F P
0 0 0 r
s
.871 .26 .101 r
.62631 .5878 m .62015 .59813 L .6103 .61156 L p F P
0 0 0 r
s
.822 .24 .091 r
.34471 .48262 m .34866 .46994 L .35559 .45213 L p F P
0 0 0 r
s
.083 .024 .01 r
.34866 .46994 m .34471 .48262 L .34136 .50157 L p F P
0 0 0 r
s
.24 .35 .67 r
.21568 .60257 m
.21671 .58812 L
s
.17357 .58194 m
.21671 .58812 L
s
.60917 .36547 m
.62476 .3683 L
s
.101 .114 .218 r
.38257 .63468 m .3674 .63255 L .35015 .62302 L p F P
0 0 0 r
s
.564 .169 .078 r
.35343 .61386 m .35015 .62302 L .3674 .63255 L p F P
0 0 0 r
s
.83 .24 .1 r
.3503 .62554 m
.36967 .64822 L
s
.24 .35 .67 r
.36028 .62303 m
.38653 .62674 L
s
1 .338 .139 r
.43013 .35058 m .42728 .35887 L .41135 .36058 L p F P
0 0 0 r
s
1 .338 .139 r
.40803 .37053 m .41135 .36058 L .42728 .35887 L p F P
0 0 0 r
s
.83 .24 .1 r
.40503 .39738 m
.41415 .3704 L
s
.41415 .3704 m
.43927 .36102 L
s
.224 .356 .712 r
.45138 .34152 m .46092 .34324 L .44854 .33599 L p F P
0 0 0 r
s
.224 .356 .712 r
.46108 .33827 m .44854 .33599 L .46092 .34324 L p F P
0 0 0 r
s
.24 .35 .67 r
.65627 .67053 m
.64594 .67373 L
s
.6052 .66802 m
.64594 .67373 L
s
.667 .196 .088 r
.64122 .39693 m .64701 .3858 L .62705 .3779 L p F P
0 0 0 r
s
.667 .196 .088 r
.63199 .36807 m .62705 .3779 L .64701 .3858 L p F P
0 0 0 r
s
.83 .24 .1 r
.6185 .37739 m
.6395 .39856 L
s
.24 .35 .67 r
.63353 .36989 m
.64988 .37286 L
s
.074 .086 .165 r
.47669 .65136 m .4642 .64961 L .45755 .64521 L p F P
0 0 0 r
s
.24 .35 .67 r
.47399 .64756 m
.51536 .65336 L
s
.46913 .63843 m
.47399 .64756 L
s
.074 .086 .165 r
.44268 .64312 m .45755 .64521 L .4642 .64961 L p F P
0 0 0 r
s
.24 .35 .67 r
.2147 .32524 m
.21773 .30939 L
s
.157 .263 .533 r
.55993 .35622 m .5721 .35843 L .5879 .36005 L p F P
0 0 0 r
s
.157 .263 .533 r
.60266 .36273 m .5879 .36005 L .5721 .35843 L p F P
0 0 0 r
s
.231 .067 .035 r
.65179 .51097 m .65906 .49843 L .65569 .47949 L p F P
0 0 0 r
s
.171 .049 .025 r
.65906 .49843 m .65179 .51097 L .65129 .53005 L p F P
0 0 0 r
s
1 .323 .129 r
.38983 .38858 m .38624 .39967 L .37343 .41202 L p F P
0 0 0 r
s
1 .323 .129 r
.36963 .42402 m .37343 .41202 L .38624 .39967 L p F P
0 0 0 r
s
.24 .35 .67 r
.30408 .3249 m
.34654 .33253 L
s
.34654 .33253 m
.35116 .32282 L
s
.34453 .6208 m
.34705 .62974 L
s
.30206 .61479 m
.34453 .6208 L
s
.997 .292 .115 r
.35559 .45213 m .35951 .43961 L .36963 .42402 L p F P
0 0 0 r
s
.822 .24 .091 r
.35951 .43961 m .35559 .45213 L .34866 .46994 L p F P
0 0 0 r
s
.148 .248 .501 r
.55074 .66172 m .56294 .66343 L .54947 .66124 L p F P
0 0 0 r
s
1 .333 .137 r
.56665 .65703 m .56294 .66343 L .54947 .66124 L p F P
0 0 0 r
s
.24 .35 .67 r
.56209 .66148 m
.56399 .66225 L
s
.56175 .66134 m
.56209 .66148 L
s
.55627 .65911 m
.55699 .6594 L
s
.83 .24 .1 r
.55638 .66316 m
.55744 .66261 L
s
.55055 .6662 m
.55638 .66316 L
s
1 .333 .138 r
.43302 .3422 m .43595 .3337 L .45138 .34152 L p F P
0 0 0 r
s
.224 .356 .712 r
.44854 .33599 m .43595 .3337 L .45138 .34152 L p F P
0 0 0 r
s
.83 .24 .1 r
.43927 .36102 m
.44718 .33872 L
s
.44817 .33592 m
.4492 .33299 L
s
.997 .292 .115 r
.37343 .41202 m .36963 .42402 L .35951 .43961 L p F P
0 0 0 r
s
.83 .24 .1 r
.35907 .45555 m
.36724 .4297 L
s
.36724 .4297 m
.38387 .41145 L
s
.45138 .69219 m
.48187 .69627 L
s
.49281 .67509 m
.48187 .69627 L
s
.157 .263 .533 r
.54772 .354 m .55993 .35622 L .57309 .35736 L p F P
0 0 0 r
s
.157 .263 .533 r
.5879 .36005 m .57309 .35736 L .55993 .35622 L p F P
0 0 0 r
s
.24 .35 .67 r
.5602 .36066 m
.56801 .35799 L
s
1 .304 .122 r
.58807 .6385 m .59274 .63057 L .60483 .62076 L p F P
0 0 0 r
s
1 .304 .122 r
.6103 .61156 m .60483 .62076 L .59274 .63057 L p F P
0 0 0 r
s
.83 .24 .1 r
.60537 .6169 m
.60663 .61477 L
s
.60663 .61477 m
.62036 .59422 L
s
.24 .35 .67 r
.73982 .39177 m
.77989 .39903 L
s
.77989 .39903 m
.78912 .41007 L
s
.77788 .68765 m
.79089 .67818 L
s
.7378 .68201 m
.77788 .68765 L
s
.074 .086 .165 r
.4642 .64961 m .45167 .64786 L .44268 .64312 L p F P
0 0 0 r
s
.074 .086 .165 r
.42774 .64102 m .44268 .64312 L .45167 .64786 L p F P
0 0 0 r
s
.231 .067 .035 r
.66292 .46675 m .65569 .47949 L .65906 .49843 L p F P
0 0 0 r
s
.34 .098 .05 r
.65569 .47949 m .66292 .46675 L .65544 .44904 L p F P
0 0 0 r
s
.83 .24 .1 r
.36967 .64822 m
.39381 .66753 L
s
.578 .169 .078 r
.65068 .42106 m .65716 .40901 L .64122 .39693 L p F P
0 0 0 r
s
.578 .169 .078 r
.64701 .3858 m .64122 .39693 L .65716 .40901 L p F P
0 0 0 r
s
.24 .35 .67 r
.44462 .33974 m
.47799 .34578 L
s
.148 .248 .501 r
.54947 .66124 m .53986 .6599 L .55074 .66172 L p F P
0 0 0 r
s
.148 .248 .501 r
.5385 .66001 m .55074 .66172 L .53986 .6599 L p F P
0 0 0 r
s
.34 .098 .05 r
.66241 .43645 m .65544 .44904 L .66292 .46675 L p F P
0 0 0 r
s
.471 .137 .065 r
.65544 .44904 m .66241 .43645 L .65068 .42106 L p F P
0 0 0 r
s
.157 .263 .533 r
.53546 .35178 m .54772 .354 L .55822 .35465 L p F P
0 0 0 r
s
.157 .263 .533 r
.57309 .35736 m .55822 .35465 L .54772 .354 L p F P
0 0 0 r
s
.83 .24 .1 r
.48823 .29958 m
.47737 .32866 L
s
.47737 .32866 m
.4492 .33299 L
s
.471 .137 .065 r
.65716 .40901 m .65068 .42106 L .66241 .43645 L p F P
0 0 0 r
s
.83 .24 .1 r
.6395 .39856 m
.65594 .4221 L
s
.64176 .44825 m
.65594 .4221 L
s
.074 .086 .165 r
.45167 .64786 m .4391 .6461 L .42774 .64102 L p F P
0 0 0 r
s
.074 .086 .165 r
.41275 .63892 m .42774 .64102 L .4391 .6461 L p F P
0 0 0 r
s
.148 .248 .501 r
.53986 .6599 m .53024 .65855 L .5385 .66001 L p F P
0 0 0 r
s
.148 .248 .501 r
.52622 .65829 m .5385 .66001 L .53024 .65855 L p F P
0 0 0 r
s
.157 .263 .533 r
.52317 .34955 m .53546 .35178 L .54328 .35194 L p F P
0 0 0 r
s
.157 .263 .533 r
.55822 .35465 m .54328 .35194 L .53546 .35178 L p F P
0 0 0 r
s
.24 .35 .67 r
.17175 .59635 m
.17357 .58194 L
s
.6148 .6647 m
.6052 .66802 L
s
.56399 .66225 m
.6052 .66802 L
s
1 .336 .137 r
.41135 .36058 m .40803 .37053 L .39349 .3773 L p F P
0 0 0 r
s
1 .336 .137 r
.38983 .38858 m .39349 .3773 L .40803 .37053 L p F P
0 0 0 r
s
.83 .24 .1 r
.42152 .68245 m
.45138 .69219 L
s
.46172 .67083 m
.45138 .69219 L
s
1 .338 .139 r
.43302 .3422 m .43013 .35058 L .41471 .35048 L p F P
0 0 0 r
s
1 .338 .139 r
.41135 .36058 m .41471 .35048 L .43013 .35058 L p F P
0 0 0 r
s
.83 .24 .1 r
.40292 .64564 m
.39381 .66753 L
s
.39381 .66753 m
.42152 .68245 L
s
.074 .086 .165 r
.4391 .6461 m .42649 .64434 L .41275 .63892 L p F P
0 0 0 r
s
.24 .35 .67 r
.43215 .64168 m
.47399 .64756 L
s
.42806 .63262 m
.43215 .64168 L
s
.074 .086 .165 r
.39769 .6368 m .41275 .63892 L .42649 .64434 L p F P
0 0 0 r
s
.148 .248 .501 r
.53024 .65855 m .52059 .6572 L .52622 .65829 L p F P
0 0 0 r
s
.148 .248 .501 r
.5139 .65657 m .52622 .65829 L .52059 .6572 L p F P
0 0 0 r
s
.226 .065 .035 r
.33876 .56309 m .34253 .55162 L .33797 .53307 L p F P
0 0 0 r
s
.294 .087 .046 r
.34253 .55162 m .33876 .56309 L .34747 .57991 L p F P
0 0 0 r
s
.294 .087 .046 r
.34389 .59039 m .34747 .57991 L .33876 .56309 L p F P
0 0 0 r
s
.24 .35 .67 r
.26115 .31719 m
.30408 .3249 L
s
.30408 .3249 m
.30791 .31499 L
s
.30377 .62367 m
.30206 .61479 L
s
.25912 .60871 m
.30206 .61479 L
s
.433 .13 .063 r
.34747 .57991 m .34389 .59039 L .35676 .60454 L p F P
0 0 0 r
s
.433 .13 .063 r
.35343 .61386 m .35676 .60454 L .34389 .59039 L p F P
0 0 0 r
s
1 .327 .133 r
.5704 .65055 m .57419 .64399 L .58807 .6385 L p F P
0 0 0 r
s
1 .327 .133 r
.59274 .63057 m .58807 .6385 L .57419 .64399 L p F P
0 0 0 r
s
.157 .263 .533 r
.51083 .34731 m .52317 .34955 L .52829 .34921 L p F P
0 0 0 r
s
.157 .263 .533 r
.54328 .35194 m .52829 .34921 L .52317 .34955 L p F P
0 0 0 r
s
.24 .35 .67 r
.51933 .35326 m
.52637 .35043 L
s
.154 .045 .022 r
.33797 .53307 m .34188 .52083 L .34136 .50157 L p F P
0 0 0 r
s
.226 .065 .035 r
.34188 .52083 m .33797 .53307 L .34253 .55162 L p F P
0 0 0 r
s
.83 .24 .1 r
.43123 .66085 m
.42152 .68245 L
s
1 .333 .137 r
.54947 .66124 m .55231 .65621 L .56665 .65703 L p F P
0 0 0 r
s
1 .333 .137 r
.5704 .65055 m .56665 .65703 L .55231 .65621 L p F P
0 0 0 r
s
.83 .24 .1 r
.52292 .67348 m
.55055 .6662 L
s
.55055 .6662 m
.55301 .66186 L
s
.667 .196 .088 r
.64701 .3858 m .6529 .37447 L .63199 .36807 L p F P
0 0 0 r
s
.069 .081 .156 r
.61735 .36541 m .63199 .36807 L .6529 .37447 L p F P
0 0 0 r
s
.83 .24 .1 r
.62385 .36659 m
.62413 .36602 L
s
.24 .35 .67 r
.69929 .38442 m
.73982 .39177 L
s
.73982 .39177 m
.74837 .40273 L
s
.75016 .67239 m
.7378 .68201 L
s
.69727 .6763 m
.7378 .68201 L
s
.148 .248 .501 r
.52059 .6572 m .51091 .65585 L .5139 .65657 L p F P
0 0 0 r
s
.24 .35 .67 r
.51536 .65336 m
.52232 .65641 L
s
.148 .248 .501 r
.50154 .65484 m .5139 .65657 L .51091 .65585 L p F P
0 0 0 r
s
.074 .086 .165 r
.42649 .64434 m .41383 .64257 L .39769 .6368 L p F P
0 0 0 r
s
.074 .086 .165 r
.38257 .63468 m .39769 .6368 L .41383 .64257 L p F P
0 0 0 r
s
.564 .169 .078 r
.35676 .60454 m .35343 .61386 L .37043 .62452 L p F P
0 0 0 r
s
.83 .24 .1 r
.35414 .61482 m
.35429 .6144 L
s
.564 .169 .078 r
.3674 .63255 m .37043 .62452 L .35343 .61386 L p F P
0 0 0 r
s
.157 .263 .533 r
.49846 .34506 m .51083 .34731 L .51323 .34648 L p F P
0 0 0 r
s
.157 .263 .533 r
.52829 .34921 m .51323 .34648 L .51083 .34731 L p F P
0 0 0 r
s
.083 .024 .01 r
.34136 .50157 m .34536 .48882 L .34866 .46994 L p F P
0 0 0 r
s
.154 .045 .022 r
.34536 .48882 m .34136 .50157 L .34188 .52083 L p F P
0 0 0 r
s
.83 .24 .1 r
.34511 .49114 m
.348 .47723 L
s
.083 .024 .01 r
.62631 .5878 m .63259 .57727 L .64018 .56026 L p F P
0 0 0 r
s
.083 .024 .01 r
.64703 .54874 m .64018 .56026 L .63259 .57727 L p F P
0 0 0 r
s
.096 .028 .012 r
.64018 .56026 m .64703 .54874 L .65129 .53005 L p F P
0 0 0 r
s
.83 .24 .1 r
.63415 .57104 m
.64184 .54777 L
s
.871 .26 .101 r
.6103 .61156 m .61587 .6022 L .62631 .5878 L p F P
0 0 0 r
s
.871 .26 .101 r
.63259 .57727 m .62631 .5878 L .61587 .6022 L p F P
0 0 0 r
s
.83 .24 .1 r
.62036 .59422 m
.63415 .57104 L
s
1 .323 .129 r
.39349 .3773 m .38983 .38858 L .37731 .3998 L p F P
0 0 0 r
s
1 .323 .129 r
.37343 .41202 m .37731 .3998 L .38983 .38858 L p F P
0 0 0 r
s
.83 .24 .1 r
.38387 .41145 m
.39264 .38445 L
s
.148 .248 .501 r
.51091 .65585 m .50121 .65449 L .50154 .65484 L p F P
0 0 0 r
s
.148 .248 .501 r
.48914 .6531 m .50154 .65484 L .50121 .65449 L p F P
0 0 0 r
s
.069 .081 .156 r
.60266 .36273 m .61735 .36541 L .63599 .3714 L p F P
0 0 0 r
s
.24 .35 .67 r
.56801 .35799 m
.60917 .36547 L
s
.069 .081 .156 r
.6529 .37447 m .63599 .3714 L .61735 .36541 L p F P
0 0 0 r
s
.096 .028 .012 r
.65853 .51775 m .65129 .53005 L .64703 .54874 L p F P
0 0 0 r
s
.171 .049 .025 r
.65129 .53005 m .65853 .51775 L .65906 .49843 L p F P
0 0 0 r
s
.83 .24 .1 r
.64325 .52303 m
.65747 .49844 L
s
.65252 .47305 m
.65747 .49844 L
s
.822 .24 .091 r
.34866 .46994 m .35269 .45699 L .35951 .43961 L p F P
0 0 0 r
s
.083 .024 .01 r
.35269 .45699 m .34866 .46994 L .34536 .48882 L p F P
0 0 0 r
s
.074 .086 .165 r
.41383 .64257 m .40113 .64079 L .38257 .63468 L p F P
0 0 0 r
s
.074 .086 .165 r
.3674 .63255 m .38257 .63468 L .40113 .64079 L p F P
0 0 0 r
s
.157 .263 .533 r
.48604 .3428 m .49846 .34506 L .49812 .34373 L p F P
0 0 0 r
s
.157 .263 .533 r
.51323 .34648 m .49812 .34373 L .49846 .34506 L p F P
0 0 0 r
s
1 .304 .122 r
.59274 .63057 m .59749 .62251 L .6103 .61156 L p F P
0 0 0 r
s
1 .304 .122 r
.61587 .6022 m .6103 .61156 L .59749 .62251 L p F P
0 0 0 r
s
.997 .292 .115 r
.37731 .3998 m .37343 .41202 L .36351 .42683 L p F P
0 0 0 r
s
.997 .292 .115 r
.35951 .43961 m .36351 .42683 L .37343 .41202 L p F P
0 0 0 r
s
.822 .24 .091 r
.36351 .42683 m .35951 .43961 L .35269 .45699 L p F P
0 0 0 r
s
.83 .24 .1 r
.35605 .45151 m
.36724 .4297 L
s
.34812 .47684 m
.35605 .45151 L
s
.231 .067 .035 r
.65906 .49843 m .66649 .48561 L .66292 .46675 L p F P
0 0 0 r
s
.171 .049 .025 r
.66649 .48561 m .65906 .49843 L .65853 .51775 L p F P
0 0 0 r
s
.148 .248 .501 r
.50121 .65449 m .49148 .65313 L .48914 .6531 L p F P
0 0 0 r
s
.148 .248 .501 r
.47669 .65136 m .48914 .6531 L .49148 .65313 L p F P
0 0 0 r
s
.24 .35 .67 r
.56399 .66225 m
.57286 .6588 L
s
.55566 .66108 m
.56399 .66225 L
s
.52232 .65641 m
.55 .66029 L
s
.578 .169 .078 r
.65716 .40901 m .66377 .39672 L .64701 .3858 L p F P
0 0 0 r
s
.578 .169 .078 r
.6529 .37447 m .64701 .3858 L .66377 .39672 L p F P
0 0 0 r
s
.24 .35 .67 r
.64988 .37286 m
.65831 .377 L
s
.069 .081 .156 r
.5879 .36005 m .60266 .36273 L .619 .36832 L p F P
0 0 0 r
s
.069 .081 .156 r
.63599 .3714 m .619 .36832 L .60266 .36273 L p F P
0 0 0 r
s
.83 .24 .1 r
.62413 .36602 m
.63228 .34956 L
s
.157 .263 .533 r
.47358 .34054 m .48604 .3428 L .48294 .34097 L p F P
0 0 0 r
s
.157 .263 .533 r
.49812 .34373 m .48294 .34097 L .48604 .3428 L p F P
0 0 0 r
s
.24 .35 .67 r
.47799 .34578 m
.48426 .34278 L
s
.21773 .30939 m
.26115 .31719 L
s
.26115 .31719 m
.26417 .30707 L
s
.25999 .61752 m
.25912 .60871 L
s
.21568 .60257 m
.25912 .60871 L
s
.074 .086 .165 r
.40113 .64079 m .38839 .63901 L .3674 .63255 L p F P
0 0 0 r
s
.24 .35 .67 r
.38984 .63575 m
.43215 .64168 L
s
.672 .201 .091 r
.37043 .62452 m .3674 .63255 L .38839 .63901 L p F P
0 0 0 r
s
.24 .35 .67 r
.38653 .62674 m
.38984 .63575 L
s
.83 .24 .1 r
.36967 .64822 m
.37465 .6353 L
s
.37465 .6353 m
.37483 .63484 L
s
.44348 .33507 m
.4492 .33299 L
s
1 .338 .139 r
.43595 .3337 m .43302 .3422 L .41813 .34023 L p F P
0 0 0 r
s
.24 .35 .67 r
.39391 .33056 m
.42779 .33669 L
s
1 .338 .139 r
.41471 .35048 m .41813 .34023 L .43302 .3422 L p F P
0 0 0 r
s
.83 .24 .1 r
.60699 .33121 m
.5789 .31658 L
s
.59205 .28698 m
.5789 .31658 L
s
.5789 .31658 m
.54902 .30619 L
s
.231 .067 .035 r
.67031 .45373 m .66292 .46675 L .66649 .48561 L p F P
0 0 0 r
s
.34 .098 .05 r
.66292 .46675 m .67031 .45373 L .66241 .43645 L p F P
0 0 0 r
s
.148 .248 .501 r
.49148 .65313 m .48173 .65176 L .47669 .65136 L p F P
0 0 0 r
s
.148 .248 .501 r
.4642 .64961 m .47669 .65136 L .48173 .65176 L p F P
0 0 0 r
s
1 .336 .137 r
.41471 .35048 m .41135 .36058 L .3972 .36583 L p F P
0 0 0 r
s
1 .336 .137 r
.39349 .3773 m .3972 .36583 L .41135 .36058 L p F P
0 0 0 r
s
.83 .24 .1 r
.39264 .38445 m
.41415 .3704 L
s
.471 .137 .065 r
.66241 .43645 m .66952 .42361 L .65716 .40901 L p F P
0 0 0 r
s
.471 .137 .065 r
.66377 .39672 m .65716 .40901 L .66952 .42361 L p F P
0 0 0 r
s
.24 .35 .67 r
.65831 .377 m
.69929 .38442 L
s
.69929 .38442 m
.70715 .39532 L
s
.70897 .66653 m
.69727 .6763 L
s
.65627 .67053 m
.69727 .6763 L
s
.34 .098 .05 r
.66952 .42361 m .66241 .43645 L .67031 .45373 L p F P
0 0 0 r
s
.83 .24 .1 r
.65594 .4221 m
.66707 .44716 L
s
.65252 .47305 m
.66707 .44716 L
s
.157 .263 .533 r
.46108 .33827 m .47358 .34054 L .4677 .3382 L p F P
0 0 0 r
s
.157 .263 .533 r
.48294 .34097 m .4677 .3382 L .47358 .34054 L p F P
0 0 0 r
s
.069 .081 .156 r
.57309 .35736 m .5879 .36005 L .60193 .36522 L p F P
0 0 0 r
s
.83 .24 .1 r
.59438 .35804 m
.60699 .33121 L
s
.59378 .35932 m
.59438 .35804 L
s
.069 .081 .156 r
.619 .36832 m .60193 .36522 L .5879 .36005 L p F P
0 0 0 r
s
.24 .35 .67 r
.6123 .3671 m
.61686 .36948 L
s
.83 .24 .1 r
.63228 .34956 m
.60699 .33121 L
s
.62076 .30189 m
.60699 .33121 L
s
1 .333 .137 r
.55231 .65621 m .55518 .65113 L .5704 .65055 L p F P
0 0 0 r
s
1 .333 .137 r
.57419 .64399 m .5704 .65055 L .55518 .65113 L p F P
0 0 0 r
s
.83 .24 .1 r
.56155 .27632 m
.54902 .30619 L
s
.54902 .30619 m
.51843 .30044 L
s
1 .327 .133 r
.57419 .64399 m .57804 .63735 L .59274 .63057 L p F P
0 0 0 r
s
1 .327 .133 r
.59749 .62251 m .59274 .63057 L .57804 .63735 L p F P
0 0 0 r
s
.24 .35 .67 r
.35116 .32282 m
.39391 .33056 L
s
.39391 .33056 m
.39858 .32722 L
s
.37221 .63327 m
.37358 .63346 L
s
.38319 .63481 m
.38984 .63575 L
s
.78912 .41007 m
.82941 .41731 L
s
.83742 .43474 m
.82941 .41731 L
s
.148 .248 .501 r
.48173 .65176 m .47195 .6504 L .4642 .64961 L p F P
0 0 0 r
s
.24 .35 .67 r
.47399 .64756 m
.48018 .65051 L
s
.148 .248 .501 r
.45167 .64786 m .4642 .64961 L .47195 .6504 L p F P
0 0 0 r
s
.157 .263 .533 r
.44854 .33599 m .46108 .33827 L .45239 .33541 L p F P
0 0 0 r
s
.157 .263 .533 r
.4677 .3382 m .45239 .33541 L .46108 .33827 L p F P
0 0 0 r
s
.069 .081 .156 r
.55822 .35465 m .57309 .35736 L .58478 .36211 L p F P
0 0 0 r
s
.24 .35 .67 r
.52637 .35043 m
.56801 .35799 L
s
.069 .081 .156 r
.60193 .36522 m .58478 .36211 L .57309 .35736 L p F P
0 0 0 r
s
.294 .087 .046 r
.34747 .57991 m .35111 .56923 L .34253 .55162 L p F P
0 0 0 r
s
.433 .13 .063 r
.35111 .56923 m .34747 .57991 L .36016 .59506 L p F P
0 0 0 r
s
.433 .13 .063 r
.35676 .60454 m .36016 .59506 L .34747 .57991 L p F P
0 0 0 r
s
.83 .24 .1 r
.49281 .67509 m
.52292 .67348 L
s
.148 .248 .501 r
.47195 .6504 m .46214 .64902 L .45167 .64786 L p F P
0 0 0 r
s
.148 .248 .501 r
.4391 .6461 m .45167 .64786 L .46214 .64902 L p F P
0 0 0 r
s
.226 .065 .035 r
.34253 .55162 m .34638 .53992 L .34188 .52083 L p F P
0 0 0 r
s
.294 .087 .046 r
.34638 .53992 m .34253 .55162 L .35111 .56923 L p F P
0 0 0 r
s
.157 .263 .533 r
.43595 .3337 m .44854 .33599 L .43703 .33262 L p F P
0 0 0 r
s
.157 .263 .533 r
.45239 .33541 m .43703 .33262 L .44854 .33599 L p F P
0 0 0 r
s
.24 .35 .67 r
.43773 .33732 m
.44166 .33505 L
s
.564 .169 .078 r
.36016 .59506 m .35676 .60454 L .3735 .61637 L p F P
0 0 0 r
s
.83 .24 .1 r
.35746 .60556 m
.35761 .60514 L
s
.564 .169 .078 r
.37043 .62452 m .3735 .61637 L .35676 .60454 L p F P
0 0 0 r
s
.83 .24 .1 r
.64665 .32053 m
.63228 .34956 L
s
.154 .045 .022 r
.34188 .52083 m .34588 .50833 L .34536 .48882 L p F P
0 0 0 r
s
.226 .065 .035 r
.34588 .50833 m .34188 .52083 L .34638 .53992 L p F P
0 0 0 r
s
.069 .081 .156 r
.54328 .35194 m .55822 .35465 L .56755 .35898 L p F P
0 0 0 r
s
.069 .081 .156 r
.58478 .36211 m .56755 .35898 L .55822 .35465 L p F P
0 0 0 r
s
.24 .35 .67 r
.21773 .30939 m
.21992 .29906 L
s
.21571 .61131 m
.21568 .60257 L
s
.17175 .59635 m
.21568 .60257 L
s
1 .323 .129 r
.3972 .36583 m .39349 .3773 L .38126 .38733 L p F P
0 0 0 r
s
1 .323 .129 r
.37731 .3998 m .38126 .38733 L .39349 .3773 L p F P
0 0 0 r
s
.148 .248 .501 r
.46214 .64902 m .45231 .64765 L .4391 .6461 L p F P
0 0 0 r
s
.148 .248 .501 r
.42649 .64434 m .4391 .6461 L .45231 .64765 L p F P
0 0 0 r
s
.83 .24 .1 r
.53035 .27032 m
.51843 .30044 L
s
.51843 .30044 m
.48823 .29958 L
s
.871 .26 .101 r
.61587 .6022 m .62154 .59267 L .63259 .57727 L p F P
0 0 0 r
s
.083 .024 .01 r
.63259 .57727 m .63899 .56654 L .64703 .54874 L p F P
0 0 0 r
s
.871 .26 .101 r
.63899 .56654 m .63259 .57727 L .62154 .59267 L p F P
0 0 0 r
s
.83 .24 .1 r
.6203 .59173 m
.63415 .57104 L
s
.217 .348 .693 r
.53986 .6599 m .54947 .66124 L .53426 .65491 L p F P
0 0 0 r
s
1 .329 .137 r
.55231 .65621 m .54947 .66124 L .53426 .65491 L p F P
0 0 0 r
s
1 .338 .139 r
.41813 .34023 m .42159 .32981 L .43595 .3337 L p F P
0 0 0 r
s
.83 .24 .1 r
.42364 .34228 m
.44194 .33563 L
s
.157 .263 .533 r
.43703 .33262 m .42159 .32981 L .43595 .3337 L p F P
0 0 0 r
s
.083 .024 .01 r
.65402 .53697 m .64703 .54874 L .63899 .56654 L p F P
0 0 0 r
s
.096 .028 .012 r
.64703 .54874 m .65402 .53697 L .65853 .51775 L p F P
0 0 0 r
s
.24 .35 .67 r
.65373 .37617 m
.65831 .377 L
s
.66731 .6606 m
.65627 .67053 L
s
.6148 .6647 m
.65627 .67053 L
s
1 .304 .122 r
.59749 .62251 m .60231 .61433 L .61587 .6022 L p F P
0 0 0 r
s
1 .304 .122 r
.62154 .59267 m .61587 .6022 L .60231 .61433 L p F P
0 0 0 r
s
.83 .24 .1 r
.61612 .59877 m
.6203 .59173 L
s
.083 .024 .01 r
.34536 .48882 m .34945 .4758 L .35269 .45699 L p F P
0 0 0 r
s
.154 .045 .022 r
.34945 .4758 m .34536 .48882 L .34588 .50833 L p F P
0 0 0 r
s
.148 .248 .501 r
.45231 .64765 m .44246 .64627 L .42649 .64434 L p F P
0 0 0 r
s
.148 .248 .501 r
.41383 .64257 m .42649 .64434 L .44246 .64627 L p F P
0 0 0 r
s
.24 .35 .67 r
.79089 .67818 m
.80387 .6622 L
s
.75016 .67239 m
.79089 .67818 L
s
.069 .081 .156 r
.52829 .34921 m .54328 .35194 L .55024 .35584 L p F P
0 0 0 r
s
.069 .081 .156 r
.56755 .35898 m .55024 .35584 L .54328 .35194 L p F P
0 0 0 r
s
.672 .201 .091 r
.3735 .61637 m .37043 .62452 L .39107 .6323 L p F P
0 0 0 r
s
.672 .201 .091 r
.38839 .63901 m .39107 .6323 L .37043 .62452 L p F P
0 0 0 r
s
.24 .35 .67 r
.34705 .62974 m
.37221 .63327 L
s
.30791 .31499 m
.35116 .32282 L
s
.35116 .32282 m
.35499 .31931 L
s
.217 .348 .693 r
.53426 .65491 m .5276 .65397 L .53986 .6599 L p F P
0 0 0 r
s
.217 .348 .693 r
.53024 .65855 m .53986 .6599 L .5276 .65397 L p F P
0 0 0 r
s
.83 .24 .1 r
.53109 .65848 m
.53279 .65537 L
s
1 .333 .137 r
.55518 .65113 m .55807 .646 L .57419 .64399 L p F P
0 0 0 r
s
1 .333 .137 r
.57804 .63735 m .57419 .64399 L .55807 .646 L p F P
0 0 0 r
s
.578 .169 .078 r
.66377 .39672 m .6705 .38419 L .6529 .37447 L p F P
0 0 0 r
s
.1 .113 .216 r
.63599 .3714 m .6529 .37447 L .6705 .38419 L p F P
0 0 0 r
s
.24 .35 .67 r
.65831 .377 m
.65879 .37772 L
s
.83 .24 .1 r
.65196 .37458 m
.65203 .37444 L
s
.6395 .39856 m
.65077 .37688 L
s
.24 .35 .67 r
.3508 .63239 m
.34705 .62974 L
s
.30377 .62367 m
.34705 .62974 L
s
.74837 .40273 m
.78912 .41007 L
s
.78912 .41007 m
.7965 .42747 L
s
.096 .028 .012 r
.66593 .50518 m .65853 .51775 L .65402 .53697 L p F P
0 0 0 r
s
.83 .24 .1 r
.6562 .5234 m
.65747 .49844 L
s
.64184 .54777 m
.6562 .5234 L
s
.171 .049 .025 r
.65853 .51775 m .66593 .50518 L .66649 .48561 L p F P
0 0 0 r
s
.997 .292 .115 r
.38126 .38733 m .37731 .3998 L .36759 .41378 L p F P
0 0 0 r
s
.997 .292 .115 r
.36351 .42683 m .36759 .41378 L .37731 .3998 L p F P
0 0 0 r
s
.83 .24 .1 r
.37577 .40276 m
.39264 .38445 L
s
.822 .24 .091 r
.35269 .45699 m .35682 .44377 L .36351 .42683 L p F P
0 0 0 r
s
.083 .024 .01 r
.35682 .44377 m .35269 .45699 L .34945 .4758 L p F P
0 0 0 r
s
.83 .24 .1 r
.35098 .47604 m
.35605 .45151 L
s
1 .336 .137 r
.41813 .34023 m .41471 .35048 L .40098 .35415 L p F P
0 0 0 r
s
1 .336 .137 r
.3972 .36583 m .40098 .35415 L .41471 .35048 L p F P
0 0 0 r
s
.83 .24 .1 r
.41415 .3704 m
.42364 .34228 L
s
.822 .24 .091 r
.36759 .41378 m .36351 .42683 L .35682 .44377 L p F P
0 0 0 r
s
.83 .24 .1 r
.36724 .4297 m
.37577 .40276 L
s
.217 .348 .693 r
.5276 .65397 m .52093 .65303 L .53024 .65855 L p F P
0 0 0 r
s
.217 .348 .693 r
.52059 .6572 m .53024 .65855 L .52093 .65303 L p F P
0 0 0 r
s
.83 .24 .1 r
.52292 .67348 m
.53109 .65848 L
s
.148 .248 .501 r
.44246 .64627 m .43257 .64489 L .41383 .64257 L p F P
0 0 0 r
s
.148 .248 .501 r
.40113 .64079 m .41383 .64257 L .43257 .64489 L p F P
0 0 0 r
s
1 .327 .133 r
.57804 .63735 m .58193 .63062 L .59749 .62251 L p F P
0 0 0 r
s
1 .327 .133 r
.60231 .61433 m .59749 .62251 L .58193 .63062 L p F P
0 0 0 r
s
.069 .081 .156 r
.51323 .34648 m .52829 .34921 L .53285 .35268 L p F P
0 0 0 r
s
.24 .35 .67 r
.48426 .34278 m
.52486 .35016 L
s
.069 .081 .156 r
.55024 .35584 m .53285 .35268 L .52829 .34921 L p F P
0 0 0 r
s
.231 .067 .035 r
.66649 .48561 m .67407 .47251 L .67031 .45373 L p F P
0 0 0 r
s
.171 .049 .025 r
.67407 .47251 m .66649 .48561 L .66593 .50518 L p F P
0 0 0 r
s
.1 .113 .216 r
.619 .36832 m .63599 .3714 L .65168 .38079 L p F P
0 0 0 r
s
.24 .35 .67 r
.61686 .36948 m
.62676 .37128 L
s
.63971 .37362 m
.64418 .37443 L
s
.83 .24 .1 r
.63228 .34956 m
.65381 .37101 L
s
.1 .113 .216 r
.6705 .38419 m .65168 .38079 L .63599 .3714 L p F P
0 0 0 r
s
.83 .24 .1 r
.65203 .37444 m
.65381 .37101 L
s
.217 .348 .693 r
.52093 .65303 m .51424 .65209 L .52059 .6572 L p F P
0 0 0 r
s
.217 .348 .693 r
.51091 .65585 m .52059 .6572 L .51424 .65209 L p F P
0 0 0 r
s
.24 .35 .67 r
.48018 .65051 m
.51173 .65493 L
s
.83 .24 .1 r
.46172 .67083 m
.49281 .67509 L
s
.42364 .34228 m
.42738 .33123 L
s
.471 .137 .065 r
.66952 .42361 m .67677 .41049 L .66377 .39672 L p F P
0 0 0 r
s
.471 .137 .065 r
.6705 .38419 m .66377 .39672 L .67677 .41049 L p F P
0 0 0 r
s
.148 .248 .501 r
.43257 .64489 m .42267 .6435 L .40113 .64079 L p F P
0 0 0 r
s
.24 .35 .67 r
.43215 .64168 m
.43755 .64454 L
s
.148 .248 .501 r
.38839 .63901 m .40113 .64079 L .42267 .6435 L p F P
0 0 0 r
s
.231 .067 .035 r
.67785 .44044 m .67031 .45373 L .67407 .47251 L p F P
0 0 0 r
s
.34 .098 .05 r
.67031 .45373 m .67785 .44044 L .66952 .42361 L p F P
0 0 0 r
s
1 .329 .137 r
.53426 .65491 m .53618 .6514 L .55231 .65621 L p F P
0 0 0 r
s
1 .329 .137 r
.55518 .65113 m .55231 .65621 L .53618 .6514 L p F P
0 0 0 r
s
.24 .35 .67 r
.1709 .60502 m
.17175 .59635 L
s
.83 .24 .1 r
.65381 .37101 m
.65932 .37876 L
s
.6621 .38267 m
.67073 .39482 L
s
.66875 .34227 m
.65381 .37101 L
s
.34 .098 .05 r
.67677 .41049 m .66952 .42361 L .67785 .44044 L p F P
0 0 0 r
s
.83 .24 .1 r
.65594 .4221 m
.67073 .39482 L
s
.069 .081 .156 r
.49812 .34373 m .51323 .34648 L .51537 .34951 L p F P
0 0 0 r
s
.069 .081 .156 r
.53285 .35268 m .51537 .34951 L .51323 .34648 L p F P
0 0 0 r
s
.24 .35 .67 r
.52887 .35196 m
.53251 .35419 L
s
.217 .348 .693 r
.51424 .65209 m .50754 .65115 L .51091 .65585 L p F P
0 0 0 r
s
.217 .348 .693 r
.50121 .65449 m .51091 .65585 L .50754 .65115 L p F P
0 0 0 r
s
.24 .35 .67 r
.62515 .6546 m
.6148 .6647 L
s
.57286 .6588 m
.6148 .6647 L
s
.1 .113 .216 r
.60193 .36522 m .619 .36832 L .63277 .37738 L p F P
0 0 0 r
s
.1 .113 .216 r
.65168 .38079 m .63277 .37738 L .619 .36832 L p F P
0 0 0 r
s
.148 .248 .501 r
.42267 .6435 m .41273 .64211 L .38839 .63901 L p F P
0 0 0 r
s
.762 .227 .101 r
.39107 .6323 m .38839 .63901 L .41273 .64211 L p F P
0 0 0 r
s
.83 .24 .1 r
.39583 .64 m
.39691 .64086 L
s
.39691 .64086 m
.40292 .64564 L
s
.24 .35 .67 r
.3931 .6377 m
.3933 .63782 L
s
.83 .24 .1 r
.49958 .26924 m
.48823 .29958 L
s
.48823 .29958 m
.45956 .30375 L
s
.217 .348 .693 r
.50754 .65115 m .50084 .65021 L .50121 .65449 L p F P
0 0 0 r
s
.83 .24 .1 r
.50347 .65445 m
.50423 .65298 L
s
.217 .348 .693 r
.49148 .65313 m .50121 .65449 L .50084 .65021 L p F P
0 0 0 r
s
.83 .24 .1 r
.49281 .67509 m
.50347 .65445 L
s
.24 .35 .67 r
.76258 .65622 m
.75016 .67239 L
s
.70897 .66653 m
.75016 .67239 L
s
.26417 .30707 m
.30791 .31499 L
s
.30791 .31499 m
.3109 .3113 L
s
.294 .087 .046 r
.35111 .56923 m .35483 .55834 L .34638 .53992 L p F P
0 0 0 r
s
.433 .13 .063 r
.35483 .55834 m .35111 .56923 L .36361 .58541 L p F P
0 0 0 r
s
.433 .13 .063 r
.36016 .59506 m .36361 .58541 L .35111 .56923 L p F P
0 0 0 r
s
.564 .169 .078 r
.36361 .58541 m .36016 .59506 L .37662 .6081 L p F P
0 0 0 r
s
.83 .24 .1 r
.36084 .59615 m
.36099 .59572 L
s
.564 .169 .078 r
.3735 .61637 m .37662 .6081 L .36016 .59506 L p F P
0 0 0 r
s
.24 .35 .67 r
.30667 .62621 m
.30377 .62367 L
s
.25999 .61752 m
.30377 .62367 L
s
.069 .081 .156 r
.48294 .34097 m .49812 .34373 L .49781 .34632 L p F P
0 0 0 r
s
.069 .081 .156 r
.51537 .34951 m .49781 .34632 L .49812 .34373 L p F P
0 0 0 r
s
.24 .35 .67 r
.70715 .39532 m
.74837 .40273 L
s
.74837 .40273 m
.75512 .42011 L
s
1 .333 .137 r
.55807 .646 m .561 .64081 L .57804 .63735 L p F P
0 0 0 r
s
.83 .24 .1 r
.57536 .63789 m
.57873 .63616 L
s
1 .333 .137 r
.58193 .63062 m .57804 .63735 L .561 .64081 L p F P
0 0 0 r
s
.217 .348 .693 r
.50084 .65021 m .49411 .64927 L .49148 .65313 L p F P
0 0 0 r
s
.217 .348 .693 r
.48173 .65176 m .49148 .65313 L .49411 .64927 L p F P
0 0 0 r
s
1 .323 .129 r
.40098 .35415 m .3972 .36583 L .38529 .37462 L p F P
0 0 0 r
s
1 .323 .129 r
.38126 .38733 m .38529 .37462 L .3972 .36583 L p F P
0 0 0 r
s
.83 .24 .1 r
.39264 .38445 m
.40179 .35629 L
s
.226 .065 .035 r
.34638 .53992 m .3503 .52798 L .34588 .50833 L p F P
0 0 0 r
s
.294 .087 .046 r
.3503 .52798 m .34638 .53992 L .35483 .55834 L p F P
0 0 0 r
s
.83 .24 .1 r
.43123 .66085 m
.46172 .67083 L
s
.1 .113 .216 r
.58478 .36211 m .60193 .36522 L .61375 .37395 L p F P
0 0 0 r
s
.24 .35 .67 r
.60473 .36728 m
.60925 .3681 L
s
.1 .113 .216 r
.63277 .37738 m .61375 .37395 L .60193 .36522 L p F P
0 0 0 r
s
.83 .24 .1 r
.40292 .64564 m
.43123 .66085 L
s
.672 .201 .091 r
.37662 .6081 m .3735 .61637 L .39378 .62551 L p F P
0 0 0 r
s
.672 .201 .091 r
.39107 .6323 m .39378 .62551 L .3735 .61637 L p F P
0 0 0 r
s
.217 .348 .693 r
.49411 .64927 m .48738 .64832 L .48173 .65176 L p F P
0 0 0 r
s
.217 .348 .693 r
.47195 .6504 m .48173 .65176 L .48738 .64832 L p F P
0 0 0 r
s
.24 .35 .67 r
.43755 .64454 m
.47573 .64989 L
s
.069 .081 .156 r
.4677 .3382 m .48294 .34097 L .48017 .34312 L p F P
0 0 0 r
s
.24 .35 .67 r
.44166 .33505 m
.47509 .34112 L
s
.4813 .34224 m
.48426 .34278 L
s
.069 .081 .156 r
.49781 .34632 m .48017 .34312 L .48294 .34097 L p F P
0 0 0 r
s
1 .304 .122 r
.60231 .61433 m .6072 .60602 L .62154 .59267 L p F P
0 0 0 r
s
1 .304 .122 r
.6273 .58298 m .62154 .59267 L .6072 .60602 L p F P
0 0 0 r
s
.871 .26 .101 r
.62154 .59267 m .6273 .58298 L .63899 .56654 L p F P
0 0 0 r
s
.083 .024 .01 r
.63899 .56654 m .64552 .5556 L .65402 .53697 L p F P
0 0 0 r
s
.871 .26 .101 r
.64552 .5556 m .63899 .56654 L .6273 .58298 L p F P
0 0 0 r
s
.24 .35 .67 r
.42529 .33207 m
.44166 .33505 L
s
.154 .045 .022 r
.34588 .50833 m .34996 .49556 L .34945 .4758 L p F P
0 0 0 r
s
.83 .24 .1 r
.34957 .48053 m
.35098 .47604 L
s
.226 .065 .035 r
.34996 .49556 m .34588 .50833 L .3503 .52798 L p F P
0 0 0 r
s
1 .329 .137 r
.53618 .6514 m .5381 .64788 L .55518 .65113 L p F P
0 0 0 r
s
1 .329 .137 r
.55807 .646 m .55518 .65113 L .5381 .64788 L p F P
0 0 0 r
s
1 .336 .137 r
.42159 .32981 m .41813 .34023 L .40483 .34226 L p F P
0 0 0 r
s
.24 .35 .67 r
.39858 .32722 m
.41988 .33109 L
s
1 .336 .137 r
.40098 .35415 m .40483 .34226 L .41813 .34023 L p F P
0 0 0 r
s
.83 .24 .1 r
.40179 .35629 m
.42364 .34228 L
s
.55515 .64627 m
.55839 .64544 L
s
.217 .348 .693 r
.48738 .64832 m .48063 .64737 L .47195 .6504 L p F P
0 0 0 r
s
.217 .348 .693 r
.46214 .64902 m .47195 .6504 L .48063 .64737 L p F P
0 0 0 r
s
.83 .24 .1 r
.46172 .67083 m
.47179 .65002 L
s
.083 .024 .01 r
.66115 .52497 m .65402 .53697 L .64552 .5556 L p F P
0 0 0 r
s
.83 .24 .1 r
.63415 .57104 m
.64853 .54685 L
s
.096 .028 .012 r
.65402 .53697 m .66115 .52497 L .66593 .50518 L p F P
0 0 0 r
s
.83 .24 .1 r
.64853 .54685 m
.6562 .5234 L
s
1 .327 .133 r
.58193 .63062 m .58588 .6238 L .60231 .61433 L p F P
0 0 0 r
s
1 .327 .133 r
.6072 .60602 m .60231 .61433 L .58588 .6238 L p F P
0 0 0 r
s
.1 .113 .216 r
.56755 .35898 m .58478 .36211 L .59464 .3705 L p F P
0 0 0 r
s
.24 .35 .67 r
.58712 .36409 m
.59165 .36491 L
s
.1 .113 .216 r
.61375 .37395 m .59464 .3705 L .58478 .36211 L p F P
0 0 0 r
s
.069 .081 .156 r
.45239 .33541 m .4677 .3382 L .46244 .33991 L p F P
0 0 0 r
s
.069 .081 .156 r
.48017 .34312 m .46244 .33991 L .4677 .3382 L p F P
0 0 0 r
s
.083 .024 .01 r
.34945 .4758 m .35362 .46248 L .35682 .44377 L p F P
0 0 0 r
s
.154 .045 .022 r
.35362 .46248 m .34945 .4758 L .34996 .49556 L p F P
0 0 0 r
s
.997 .292 .115 r
.38529 .37462 m .38126 .38733 L .37176 .40046 L p F P
0 0 0 r
s
.997 .292 .115 r
.36759 .41378 m .37176 .40046 L .38126 .38733 L p F P
0 0 0 r
s
.217 .348 .693 r
.48063 .64737 m .47387 .64642 L .46214 .64902 L p F P
0 0 0 r
s
.217 .348 .693 r
.45231 .64765 m .46214 .64902 L .47387 .64642 L p F P
0 0 0 r
s
.83 .24 .1 r
.47179 .65002 m
.47251 .64853 L
s
.24 .35 .67 r
.57286 .6588 m
.58251 .64853 L
s
.53783 .65387 m
.57286 .6588 L
s
.7965 .42747 m
.83742 .43474 L
s
.84301 .45788 m
.83742 .43474 L
s
.096 .028 .012 r
.67348 .49234 m .66593 .50518 L .66115 .52497 L p F P
0 0 0 r
s
.171 .049 .025 r
.66593 .50518 m .67348 .49234 L .67407 .47251 L p F P
0 0 0 r
s
.83 .24 .1 r
.65747 .49844 m
.67229 .47279 L
s
.66707 .44716 m
.67229 .47279 L
s
.762 .227 .101 r
.39378 .62551 m .39107 .6323 L .41494 .63689 L p F P
0 0 0 r
s
.762 .227 .101 r
.41273 .64211 m .41494 .63689 L .39107 .6323 L p F P
0 0 0 r
s
.24 .35 .67 r
.41315 .64112 m
.43755 .64454 L
s
.39443 .6385 m
.40313 .63972 L
s
.83 .24 .1 r
.40292 .64564 m
.40479 .64112 L
s
.24 .35 .67 r
.3933 .63782 m
.39443 .6385 L
s
.7208 .65017 m
.70897 .66653 L
s
.66731 .6606 m
.70897 .66653 L
s
.21992 .29906 m
.26417 .30707 L
s
.26417 .30707 m
.26629 .3032 L
s
.822 .24 .091 r
.35682 .44377 m .36103 .43026 L .36759 .41378 L p F P
0 0 0 r
s
.083 .024 .01 r
.36103 .43026 m .35682 .44377 L .35362 .46248 L p F P
0 0 0 r
s
.822 .24 .091 r
.37176 .40046 m .36759 .41378 L .36103 .43026 L p F P
0 0 0 r
s
.83 .24 .1 r
.35641 .45036 m
.36444 .42469 L
s
.36444 .42469 m
.37577 .40276 L
s
.24 .35 .67 r
.26202 .61995 m
.25999 .61752 L
s
.21571 .61131 m
.25999 .61752 L
s
.70715 .39532 m
.71324 .41267 L
s
.217 .348 .693 r
.47387 .64642 m .4671 .64547 L .45231 .64765 L p F P
0 0 0 r
s
.217 .348 .693 r
.44246 .64627 m .45231 .64765 L .4671 .64547 L p F P
0 0 0 r
s
.1 .113 .216 r
.55024 .35584 m .56755 .35898 L .57543 .36703 L p F P
0 0 0 r
s
.24 .35 .67 r
.56942 .36088 m
.57398 .36171 L
s
.1 .113 .216 r
.59464 .3705 m .57543 .36703 L .56755 .35898 L p F P
0 0 0 r
s
.069 .081 .156 r
.43703 .33262 m .45239 .33541 L .44463 .33667 L p F P
0 0 0 r
s
.83 .24 .1 r
.44967 .33167 m
.45956 .30375 L
s
.4492 .33299 m
.44967 .33167 L
s
.069 .081 .156 r
.46244 .33991 m .44463 .33667 L .45239 .33541 L p F P
0 0 0 r
s
.471 .137 .065 r
.67677 .41049 m .68418 .39711 L .6705 .38419 L p F P
0 0 0 r
s
.142 .176 .325 r
.65168 .38079 m .6705 .38419 L .68418 .39711 L p F P
0 0 0 r
s
.83 .24 .1 r
.67073 .39482 m
.67263 .39131 L
s
1 .333 .137 r
.561 .64081 m .56395 .63558 L .58193 .63062 L p F P
0 0 0 r
s
1 .333 .137 r
.58588 .6238 m .58193 .63062 L .56395 .63558 L p F P
0 0 0 r
s
.231 .067 .035 r
.67407 .47251 m .68183 .45913 L .67785 .44044 L p F P
0 0 0 r
s
.171 .049 .025 r
.68183 .45913 m .67407 .47251 L .67348 .49234 L p F P
0 0 0 r
s
.217 .348 .693 r
.4671 .64547 m .46032 .64452 L .44246 .64627 L p F P
0 0 0 r
s
.217 .348 .693 r
.43257 .64489 m .44246 .64627 L .46032 .64452 L p F P
0 0 0 r
s
.83 .24 .1 r
.43123 .66085 m
.43814 .64547 L
s
1 .329 .137 r
.5381 .64788 m .54004 .64433 L .55807 .646 L p F P
0 0 0 r
s
1 .329 .137 r
.561 .64081 m .55807 .646 L .54004 .64433 L p F P
0 0 0 r
s
.83 .24 .1 r
.47038 .27323 m
.45956 .30375 L
s
.45956 .30375 m
.43356 .31292 L
s
.62076 .30189 m
.59205 .28698 L
s
.60579 .25608 m
.59205 .28698 L
s
.59205 .28698 m
.56155 .27632 L
s
.24 .35 .67 r
.35499 .31931 m
.39858 .32722 L
s
.231 .067 .035 r
.68556 .42686 m .67785 .44044 L .68183 .45913 L p F P
0 0 0 r
s
.34 .098 .05 r
.67785 .44044 m .68556 .42686 L .67677 .41049 L p F P
0 0 0 r
s
.34 .098 .05 r
.68418 .39711 m .67677 .41049 L .68556 .42686 L p F P
0 0 0 r
s
.83 .24 .1 r
.66707 .44716 m
.68225 .42014 L
s
.069 .081 .156 r
.42159 .32981 m .43703 .33262 L .42673 .33343 L p F P
0 0 0 r
s
.83 .24 .1 r
.42769 .33029 m
.43356 .31292 L
s
.42749 .33089 m
.42769 .33029 L
s
.069 .081 .156 r
.44463 .33667 m .42673 .33343 L .43703 .33262 L p F P
0 0 0 r
s
.1 .113 .216 r
.53285 .35268 m .55024 .35584 L .55611 .36354 L p F P
0 0 0 r
s
.24 .35 .67 r
.53251 .35419 m
.53836 .35526 L
s
.55163 .35766 m
.55621 .35849 L
s
.1 .113 .216 r
.57543 .36703 m .55611 .36354 L .55024 .35584 L p F P
0 0 0 r
s
.217 .348 .693 r
.46032 .64452 m .45353 .64356 L .43257 .64489 L p F P
0 0 0 r
s
.217 .348 .693 r
.42267 .6435 m .43257 .64489 L .45353 .64356 L p F P
0 0 0 r
s
.433 .13 .063 r
.36361 .58541 m .36712 .57559 L .35483 .55834 L p F P
0 0 0 r
s
.83 .24 .1 r
.3548 .55816 m
.35519 .55885 L
s
.564 .169 .078 r
.36712 .57559 m .36361 .58541 L .37979 .5997 L p F P
0 0 0 r
s
.83 .24 .1 r
.36427 .58657 m
.36443 .58614 L
s
.564 .169 .078 r
.37662 .6081 m .37979 .5997 L .36361 .58541 L p F P
0 0 0 r
s
.83 .24 .1 r
.64665 .32053 m
.62076 .30189 L
s
.63514 .27128 m
.62076 .30189 L
s
.142 .176 .325 r
.63277 .37738 m .65168 .38079 L .66389 .39347 L p F P
0 0 0 r
s
.142 .176 .325 r
.68418 .39711 m .66389 .39347 L .65168 .38079 L p F P
0 0 0 r
s
.83 .24 .1 r
.67073 .39482 m
.68225 .42014 L
s
.67414 .38852 m
.68616 .36635 L
s
.24 .35 .67 r
.67643 .38979 m
.70715 .39532 L
s
.672 .201 .091 r
.37979 .5997 m .37662 .6081 L .39653 .61863 L p F P
0 0 0 r
s
.672 .201 .091 r
.39378 .62551 m .39653 .61863 L .37662 .6081 L p F P
0 0 0 r
s
.294 .087 .046 r
.35483 .55834 m .35862 .54724 L .3503 .52798 L p F P
0 0 0 r
s
.433 .13 .063 r
.35862 .54724 m .35483 .55834 L .36712 .57559 L p F P
0 0 0 r
s
.24 .35 .67 r
.80387 .6622 m
.81616 .64023 L
s
.76258 .65622 m
.80387 .6622 L
s
1 .323 .129 r
.40483 .34226 m .40098 .35415 L .38939 .36166 L p F P
0 0 0 r
s
1 .323 .129 r
.38529 .37462 m .38939 .36166 L .40098 .35415 L p F P
0 0 0 r
s
.83 .24 .1 r
.57464 .24514 m
.56155 .27632 L
s
.56155 .27632 m
.53035 .27032 L
s
.217 .348 .693 r
.45353 .64356 m .44672 .64261 L .42267 .6435 L p F P
0 0 0 r
s
.217 .348 .693 r
.41273 .64211 m .42267 .6435 L .44672 .64261 L p F P
0 0 0 r
s
.264 .407 .805 r
.5276 .65397 m .53426 .65491 L .51764 .64436 L p F P
0 0 0 r
s
1 .319 .134 r
.53618 .6514 m .53426 .65491 L .51764 .64436 L p F P
0 0 0 r
s
.83 .24 .1 r
.53579 .65126 m
.53633 .65112 L
s
1 .336 .137 r
.40483 .34226 m .40875 .33016 L .42159 .32981 L p F P
0 0 0 r
s
.069 .081 .156 r
.42673 .33343 m .40875 .33016 L .42159 .32981 L p F P
0 0 0 r
s
.1 .113 .216 r
.51537 .34951 m .53285 .35268 L .5367 .36003 L p F P
0 0 0 r
s
.1 .113 .216 r
.55611 .36354 m .5367 .36003 L .53285 .35268 L p F P
0 0 0 r
s
.24 .35 .67 r
.75512 .42011 m
.7965 .42747 L
s
.7965 .42747 m
.80156 .45065 L
s
1 .304 .122 r
.6072 .60602 m .61217 .59759 L .6273 .58298 L p F P
0 0 0 r
s
1 .304 .122 r
.63317 .57312 m .6273 .58298 L .61217 .59759 L p F P
0 0 0 r
s
.871 .26 .101 r
.6273 .58298 m .63317 .57312 L .64552 .5556 L p F P
0 0 0 r
s
.24 .35 .67 r
.67853 .64405 m
.66731 .6606 L
s
.62515 .6546 m
.66731 .6606 L
s
.264 .407 .805 r
.51764 .64436 m .51421 .64388 L .5276 .65397 L p F P
0 0 0 r
s
.264 .407 .805 r
.52093 .65303 m .5276 .65397 L .51421 .64388 L p F P
0 0 0 r
s
.226 .065 .035 r
.3503 .52798 m .35431 .51578 L .34996 .49556 L p F P
0 0 0 r
s
.294 .087 .046 r
.35431 .51578 m .3503 .52798 L .35862 .54724 L p F P
0 0 0 r
s
.217 .348 .693 r
.44672 .64261 m .4399 .64165 L .41273 .64211 L p F P
0 0 0 r
s
.83 .24 .1 r
.43814 .64547 m
.43957 .64229 L
s
.841 .25 .11 r
.41494 .63689 m .41273 .64211 L .4399 .64165 L p F P
0 0 0 r
s
1 .327 .133 r
.58588 .6238 m .58987 .6169 L .6072 .60602 L p F P
0 0 0 r
s
1 .327 .133 r
.61217 .59759 m .6072 .60602 L .58987 .6169 L p F P
0 0 0 r
s
.24 .35 .67 r
.21992 .29906 m
.22115 .295 L
s
.21684 .61362 m
.21571 .61131 L
s
.1709 .60502 m
.21571 .61131 L
s
.762 .227 .101 r
.39653 .61863 m .39378 .62551 L .41718 .63161 L p F P
0 0 0 r
s
.762 .227 .101 r
.41494 .63689 m .41718 .63161 L .39378 .62551 L p F P
0 0 0 r
s
.24 .35 .67 r
.3508 .63239 m
.39443 .6385 L
s
.39443 .6385 m
.40015 .63449 L
s
.142 .176 .325 r
.61375 .37395 m .63277 .37738 L .64348 .38982 L p F P
0 0 0 r
s
.142 .176 .325 r
.66389 .39347 m .64348 .38982 L .63277 .37738 L p F P
0 0 0 r
s
.083 .024 .01 r
.64552 .5556 m .65218 .54445 L .66115 .52497 L p F P
0 0 0 r
s
.871 .26 .101 r
.65218 .54445 m .64552 .5556 L .63317 .57312 L p F P
0 0 0 r
s
.264 .407 .805 r
.51421 .64388 m .51077 .64339 L .52093 .65303 L p F P
0 0 0 r
s
.264 .407 .805 r
.51424 .65209 m .52093 .65303 L .51077 .64339 L p F P
0 0 0 r
s
.83 .24 .1 r
.50423 .65298 m
.52045 .65219 L
s
.52045 .65219 m
.5237 .65203 L
s
1 .329 .137 r
.54004 .64433 m .54199 .64076 L .561 .64081 L p F P
0 0 0 r
s
1 .329 .137 r
.56395 .63558 m .561 .64081 L .54199 .64076 L p F P
0 0 0 r
s
.264 .407 .805 r
.51077 .64339 m .50732 .6429 L .51424 .65209 L p F P
0 0 0 r
s
.264 .407 .805 r
.50754 .65115 m .51424 .65209 L .50732 .6429 L p F P
0 0 0 r
s
.83 .24 .1 r
.66875 .34227 m
.64665 .32053 L
s
.66166 .29022 m
.64665 .32053 L
s
.1 .113 .216 r
.49781 .34632 m .51537 .34951 L .51718 .35651 L p F P
0 0 0 r
s
.24 .35 .67 r
.5158 .35117 m
.52042 .352 L
s
.1 .113 .216 r
.5367 .36003 m .51718 .35651 L .51537 .34951 L p F P
0 0 0 r
s
.154 .045 .022 r
.34996 .49556 m .35412 .48251 L .35362 .46248 L p F P
0 0 0 r
s
.226 .065 .035 r
.35412 .48251 m .34996 .49556 L .35431 .51578 L p F P
0 0 0 r
s
1 .333 .137 r
.56395 .63558 m .56694 .63029 L .58588 .6238 L p F P
0 0 0 r
s
1 .333 .137 r
.58987 .6169 m .58588 .6238 L .56694 .63029 L p F P
0 0 0 r
s
1 .319 .134 r
.51764 .64436 m .5186 .64255 L .53618 .6514 L p F P
0 0 0 r
s
1 .319 .134 r
.5381 .64788 m .53618 .6514 L .5186 .64255 L p F P
0 0 0 r
s
.24 .35 .67 r
.53367 .64904 m
.53461 .64794 L
s
.083 .024 .01 r
.66844 .51271 m .66115 .52497 L .65218 .54445 L p F P
0 0 0 r
s
.096 .028 .012 r
.66115 .52497 m .66844 .51271 L .67348 .49234 L p F P
0 0 0 r
s
.264 .407 .805 r
.50732 .6429 m .50388 .64242 L .50754 .65115 L p F P
0 0 0 r
s
.264 .407 .805 r
.50084 .65021 m .50754 .65115 L .50388 .64242 L p F P
0 0 0 r
s
.24 .35 .67 r
.3109 .3113 m
.35499 .31931 L
s
.35499 .31931 m
.35783 .32253 L
s
.83 .24 .1 r
.5428 .23886 m
.53035 .27032 L
s
.53035 .27032 m
.49958 .26924 L
s
.997 .292 .115 r
.38939 .36166 m .38529 .37462 L .37601 .38686 L p F P
0 0 0 r
s
.997 .292 .115 r
.37176 .40046 m .37601 .38686 L .38529 .37462 L p F P
0 0 0 r
s
.24 .35 .67 r
.35569 .62824 m
.3508 .63239 L
s
.30667 .62621 m
.3508 .63239 L
s
.142 .176 .325 r
.59464 .3705 m .61375 .37395 L .62296 .38614 L p F P
0 0 0 r
s
.142 .176 .325 r
.64348 .38982 m .62296 .38614 L .61375 .37395 L p F P
0 0 0 r
s
.264 .407 .805 r
.50388 .64242 m .50043 .64193 L .50084 .65021 L p F P
0 0 0 r
s
.264 .407 .805 r
.49411 .64927 m .50084 .65021 L .50043 .64193 L p F P
0 0 0 r
s
.083 .024 .01 r
.35362 .46248 m .35789 .44888 L .36103 .43026 L p F P
0 0 0 r
s
.154 .045 .022 r
.35789 .44888 m .35362 .46248 L .35412 .48251 L p F P
0 0 0 r
s
.24 .35 .67 r
.77439 .63404 m
.76258 .65622 L
s
.7208 .65017 m
.76258 .65622 L
s
.1 .113 .216 r
.48017 .34312 m .49781 .34632 L .49755 .35297 L p F P
0 0 0 r
s
.24 .35 .67 r
.49775 .34789 m
.5024 .34874 L
s
.1 .113 .216 r
.51718 .35651 m .49755 .35297 L .49781 .34632 L p F P
0 0 0 r
s
.264 .407 .805 r
.50043 .64193 m .49698 .64144 L .49411 .64927 L p F P
0 0 0 r
s
.264 .407 .805 r
.48738 .64832 m .49411 .64927 L .49698 .64144 L p F P
0 0 0 r
s
.24 .35 .67 r
.48751 .64679 m
.48919 .64702 L
s
.48512 .648 m
.48751 .64679 L
s
.096 .028 .012 r
.6812 .47922 m .67348 .49234 L .66844 .51271 L p F P
0 0 0 r
s
.83 .24 .1 r
.67118 .49797 m
.67229 .47279 L
s
.6562 .5234 m
.67118 .49797 L
s
.171 .049 .025 r
.67348 .49234 m .6812 .47922 L .68183 .45913 L p F P
0 0 0 r
s
.822 .24 .091 r
.37601 .38686 m .37176 .40046 L .36533 .41646 L p F P
0 0 0 r
s
.83 .24 .1 r
.37577 .40276 m
.38467 .37464 L
s
.822 .24 .091 r
.36103 .43026 m .36533 .41646 L .37176 .40046 L p F P
0 0 0 r
s
.841 .25 .11 r
.41718 .63161 m .41494 .63689 L .44151 .63806 L p F P
0 0 0 r
s
.841 .25 .11 r
.4399 .64165 m .44151 .63806 L .41494 .63689 L p F P
0 0 0 r
s
.083 .024 .01 r
.36533 .41646 m .36103 .43026 L .35789 .44888 L p F P
0 0 0 r
s
.83 .24 .1 r
.35937 .44941 m
.36444 .42469 L
s
.264 .407 .805 r
.49698 .64144 m .49352 .64095 L .48738 .64832 L p F P
0 0 0 r
s
.264 .407 .805 r
.48063 .64737 m .48738 .64832 L .49352 .64095 L p F P
0 0 0 r
s
.24 .35 .67 r
.71324 .41267 m
.75512 .42011 L
s
.75512 .42011 m
.75962 .44333 L
s
.63577 .63786 m
.62515 .6546 L
s
.58251 .64853 m
.62515 .6546 L
s
1 .319 .134 r
.5186 .64255 m .51956 .64072 L .5381 .64788 L p F P
0 0 0 r
s
1 .319 .134 r
.54004 .64433 m .5381 .64788 L .51956 .64072 L p F P
0 0 0 r
s
.564 .169 .078 r
.37979 .5997 m .38301 .59116 L .36712 .57559 L p F P
0 0 0 r
s
.672 .201 .091 r
.38301 .59116 m .37979 .5997 L .39932 .61166 L p F P
0 0 0 r
s
.672 .201 .091 r
.39653 .61863 m .39932 .61166 L .37979 .5997 L p F P
0 0 0 r
s
.142 .176 .325 r
.57543 .36703 m .59464 .3705 L .60232 .38245 L p F P
0 0 0 r
s
.142 .176 .325 r
.62296 .38614 m .60232 .38245 L .59464 .3705 L p F P
0 0 0 r
s
.24 .35 .67 r
.17113 .60722 m
.1709 .60502 L
s
1 .329 .137 r
.54199 .64076 m .54396 .63716 L .56395 .63558 L p F P
0 0 0 r
s
1 .329 .137 r
.56694 .63029 m .56395 .63558 L .54396 .63716 L p F P
0 0 0 r
s
.264 .407 .805 r
.49352 .64095 m .49006 .64046 L .48063 .64737 L p F P
0 0 0 r
s
.264 .407 .805 r
.47387 .64642 m .48063 .64737 L .49006 .64046 L p F P
0 0 0 r
s
.433 .13 .063 r
.36712 .57559 m .3707 .56559 L .35862 .54724 L p F P
0 0 0 r
s
.564 .169 .078 r
.3707 .56559 m .36712 .57559 L .38301 .59116 L p F P
0 0 0 r
s
.1 .113 .216 r
.46244 .33991 m .48017 .34312 L .47783 .3494 L p F P
0 0 0 r
s
.24 .35 .67 r
.47962 .34461 m
.48429 .34545 L
s
.1 .113 .216 r
.49755 .35297 m .47783 .3494 L .48017 .34312 L p F P
0 0 0 r
s
.231 .067 .035 r
.68183 .45913 m .68975 .44545 L .68556 .42686 L p F P
0 0 0 r
s
.171 .049 .025 r
.68975 .44545 m .68183 .45913 L .6812 .47922 L p F P
0 0 0 r
s
.762 .227 .101 r
.39932 .61166 m .39653 .61863 L .41944 .62629 L p F P
0 0 0 r
s
.762 .227 .101 r
.41718 .63161 m .41944 .62629 L .39653 .61863 L p F P
0 0 0 r
s
.264 .407 .805 r
.49006 .64046 m .4866 .63997 L .47387 .64642 L p F P
0 0 0 r
s
.264 .407 .805 r
.4671 .64547 m .47387 .64642 L .4866 .63997 L p F P
0 0 0 r
s
1 .323 .129 r
.40875 .33016 m .40483 .34226 L .39358 .34845 L p F P
0 0 0 r
s
1 .323 .129 r
.38939 .36166 m .39358 .34845 L .40483 .34226 L p F P
0 0 0 r
s
.83 .24 .1 r
.38467 .37464 m
.40179 .35629 L
s
.47251 .64853 m
.50423 .65298 L
s
.50423 .65298 m
.50895 .64384 L
s
.44391 .28227 m
.43356 .31292 L
s
.43356 .31292 m
.41134 .32689 L
s
.34 .098 .05 r
.68556 .42686 m .69344 .41298 L .68418 .39711 L p F P
0 0 0 r
s
.183 .241 .456 r
.66389 .39347 m .68418 .39711 L .69344 .41298 L p F P
0 0 0 r
s
.24 .35 .67 r
.80156 .45065 m
.84301 .45788 L
s
.84581 .48576 m
.84301 .45788 L
s
.231 .067 .035 r
.69344 .41298 m .68556 .42686 L .68975 .44545 L p F P
0 0 0 r
s
1 .327 .133 r
.58987 .6169 m .59392 .60991 L .61217 .59759 L p F P
0 0 0 r
s
1 .327 .133 r
.61722 .58902 m .61217 .59759 L .59392 .60991 L p F P
0 0 0 r
s
1 .304 .122 r
.61217 .59759 m .61722 .58902 L .63317 .57312 L p F P
0 0 0 r
s
.294 .087 .046 r
.35862 .54724 m .36248 .53592 L .35431 .51578 L p F P
0 0 0 r
s
.433 .13 .063 r
.36248 .53592 m .35862 .54724 L .3707 .56559 L p F P
0 0 0 r
s
.264 .407 .805 r
.4866 .63997 m .48313 .63948 L .4671 .64547 L p F P
0 0 0 r
s
.264 .407 .805 r
.46032 .64452 m .4671 .64547 L .48313 .63948 L p F P
0 0 0 r
s
.83 .24 .1 r
.68616 .36635 m
.66875 .34227 L
s
.68434 .31224 m
.66875 .34227 L
s
.24 .35 .67 r
.26629 .3032 m
.3109 .3113 L
s
.3109 .3113 m
.31285 .31438 L
s
.142 .176 .325 r
.55611 .36354 m .57543 .36703 L .58157 .37873 L p F P
0 0 0 r
s
.142 .176 .325 r
.60232 .38245 m .58157 .37873 L .57543 .36703 L p F P
0 0 0 r
s
1 .333 .137 r
.56694 .63029 m .56995 .62495 L .58987 .6169 L p F P
0 0 0 r
s
1 .333 .137 r
.59392 .60991 m .58987 .6169 L .56995 .62495 L p F P
0 0 0 r
s
1 .304 .122 r
.63915 .56308 m .63317 .57312 L .61722 .58902 L p F P
0 0 0 r
s
.871 .26 .101 r
.63317 .57312 m .63915 .56308 L .65218 .54445 L p F P
0 0 0 r
s
.83 .24 .1 r
.63296 .5704 m
.63457 .56769 L
s
.24 .35 .67 r
.31071 .62191 m
.30667 .62621 L
s
.26202 .61995 m
.30667 .62621 L
s
.1 .113 .216 r
.44463 .33667 m .46244 .33991 L .45799 .34582 L p F P
0 0 0 r
s
.24 .35 .67 r
.44619 .33855 m
.44779 .33884 L
s
.46139 .3413 m
.46609 .34216 L
s
.4435 .33647 m
.44619 .33855 L
s
.1 .113 .216 r
.47783 .3494 m .45799 .34582 L .46244 .33991 L p F P
0 0 0 r
s
.264 .407 .805 r
.48313 .63948 m .47967 .63899 L .46032 .64452 L p F P
0 0 0 r
s
.264 .407 .805 r
.45353 .64356 m .46032 .64452 L .47967 .63899 L p F P
0 0 0 r
s
1 .319 .134 r
.51956 .64072 m .52052 .63889 L .54004 .64433 L p F P
0 0 0 r
s
1 .319 .134 r
.54199 .64076 m .54004 .64433 L .52052 .63889 L p F P
0 0 0 r
s
.24 .35 .67 r
.53461 .64794 m
.53936 .64239 L
s
.83 .24 .1 r
.51143 .23754 m
.49958 .26924 L
s
.49958 .26924 m
.47038 .27323 L
s
.264 .407 .805 r
.47967 .63899 m .47619 .63849 L .45353 .64356 L p F P
0 0 0 r
s
.264 .407 .805 r
.44672 .64261 m .45353 .64356 L .47619 .63849 L p F P
0 0 0 r
s
.24 .35 .67 r
.73213 .62778 m
.7208 .65017 L
s
.67853 .64405 m
.7208 .65017 L
s
.841 .25 .11 r
.41944 .62629 m .41718 .63161 L .44314 .63444 L p F P
0 0 0 r
s
.841 .25 .11 r
.44151 .63806 m .44314 .63444 L .41718 .63161 L p F P
0 0 0 r
s
.183 .241 .456 r
.64348 .38982 m .66389 .39347 L .67215 .40921 L p F P
0 0 0 r
s
.183 .241 .456 r
.69344 .41298 m .67215 .40921 L .66389 .39347 L p F P
0 0 0 r
s
.83 .24 .1 r
.68225 .42014 m
.68693 .41183 L
s
.6893 .4076 m
.69031 .40581 L
s
.69031 .40581 m
.69811 .39193 L
s
.226 .065 .035 r
.35431 .51578 m .3584 .50333 L .35412 .48251 L p F P
0 0 0 r
s
.294 .087 .046 r
.3584 .50333 m .35431 .51578 L .36248 .53592 L p F P
0 0 0 r
s
.083 .024 .01 r
.65218 .54445 m .65896 .53307 L .66844 .51271 L p F P
0 0 0 r
s
.871 .26 .101 r
.65896 .53307 m .65218 .54445 L .63915 .56308 L p F P
0 0 0 r
s
.83 .24 .1 r
.63457 .56769 m
.64853 .54685 L
s
.264 .407 .805 r
.47619 .63849 m .47272 .638 L .44672 .64261 L p F P
0 0 0 r
s
.264 .407 .805 r
.4399 .64165 m .44672 .64261 L .47272 .638 L p F P
0 0 0 r
s
.24 .35 .67 r
.44409 .64068 m
.44609 .64096 L
s
.44303 .6413 m
.44409 .64068 L
s
.40015 .63449 m
.43649 .63961 L
s
.44056 .64018 m
.44409 .64068 L
s
.142 .176 .325 r
.5367 .36003 m .55611 .36354 L .56069 .37499 L p F P
0 0 0 r
s
.142 .176 .325 r
.58157 .37873 m .56069 .37499 L .55611 .36354 L p F P
0 0 0 r
s
1 .329 .137 r
.54396 .63716 m .54594 .63354 L .56694 .63029 L p F P
0 0 0 r
s
1 .329 .137 r
.56995 .62495 m .56694 .63029 L .54594 .63354 L p F P
0 0 0 r
s
.24 .35 .67 r
.69095 .40871 m
.71324 .41267 L
s
.71324 .41267 m
.71718 .43592 L
s
.81616 .64023 m
.82705 .61323 L
s
.77439 .63404 m
.81616 .64023 L
s
.1 .113 .216 r
.42673 .33343 m .44463 .33667 L .43805 .34222 L p F P
0 0 0 r
s
.24 .35 .67 r
.44308 .33799 m
.44619 .33855 L
s
.1 .113 .216 r
.45799 .34582 m .43805 .34222 L .44463 .33667 L p F P
0 0 0 r
s
.83 .24 .1 r
.4561 .64314 m
.47251 .64853 L
s
.4528 .64206 m
.4561 .64314 L
s
.24 .35 .67 r
.59249 .63159 m
.58251 .64853 L
s
.53936 .64239 m
.58251 .64853 L
s
.264 .407 .805 r
.47272 .638 m .46924 .63751 L .4399 .64165 L p F P
0 0 0 r
s
.83 .24 .1 r
.47251 .64853 m
.47697 .63931 L
s
.909 .271 .117 r
.44151 .63806 m .4399 .64165 L .46924 .63751 L p F P
0 0 0 r
s
.997 .292 .115 r
.39358 .34845 m .38939 .36166 L .38035 .37298 L p F P
0 0 0 r
s
.997 .292 .115 r
.37601 .38686 m .38035 .37298 L .38939 .36166 L p F P
0 0 0 r
s
1 .319 .134 r
.52052 .63889 m .52148 .63705 L .54199 .64076 L p F P
0 0 0 r
s
1 .319 .134 r
.54396 .63716 m .54199 .64076 L .52148 .63705 L p F P
0 0 0 r
s
.154 .045 .022 r
.35412 .48251 m .35838 .46917 L .35789 .44888 L p F P
0 0 0 r
s
.83 .24 .1 r
.35801 .45374 m
.35937 .44941 L
s
.226 .065 .035 r
.35838 .46917 m .35412 .48251 L .3584 .50333 L p F P
0 0 0 r
s
.083 .024 .01 r
.67588 .50019 m .66844 .51271 L .65896 .53307 L p F P
0 0 0 r
s
.096 .028 .012 r
.66844 .51271 m .67588 .50019 L .6812 .47922 L p F P
0 0 0 r
s
.183 .241 .456 r
.62296 .38614 m .64348 .38982 L .65074 .40541 L p F P
0 0 0 r
s
.183 .241 .456 r
.67215 .40921 m .65074 .40541 L .64348 .38982 L p F P
0 0 0 r
s
.672 .201 .091 r
.39932 .61166 m .40214 .6046 L .38301 .59116 L p F P
0 0 0 r
s
.762 .227 .101 r
.40214 .6046 m .39932 .61166 L .42172 .62091 L p F P
0 0 0 r
s
.762 .227 .101 r
.41944 .62629 m .42172 .62091 L .39932 .61166 L p F P
0 0 0 r
s
.24 .35 .67 r
.75962 .44333 m
.80156 .45065 L
s
.80156 .45065 m
.80392 .47861 L
s
.564 .169 .078 r
.38301 .59116 m .38628 .58249 L .3707 .56559 L p F P
0 0 0 r
s
.672 .201 .091 r
.38628 .58249 m .38301 .59116 L .40214 .6046 L p F P
0 0 0 r
s
.1 .113 .216 r
.40875 .33016 m .42673 .33343 L .41801 .3386 L p F P
0 0 0 r
s
.24 .35 .67 r
.40788 .33161 m
.41094 .33216 L
s
.42467 .33465 m
.42941 .33551 L
s
.1 .113 .216 r
.43805 .34222 m .41801 .3386 L .42673 .33343 L p F P
0 0 0 r
s
.142 .176 .325 r
.51718 .35651 m .5367 .36003 L .5397 .37123 L p F P
0 0 0 r
s
.142 .176 .325 r
.56069 .37499 m .5397 .37123 L .5367 .36003 L p F P
0 0 0 r
s
.24 .35 .67 r
.22115 .295 m
.26629 .3032 L
s
.26629 .3032 m
.26734 .30613 L
s
.26519 .6155 m
.26202 .61995 L
s
.21684 .61362 m
.26202 .61995 L
s
.083 .024 .01 r
.35789 .44888 m .36226 .43497 L .36533 .41646 L p F P
0 0 0 r
s
.154 .045 .022 r
.36226 .43497 m .35789 .44888 L .35838 .46917 L p F P
0 0 0 r
s
.841 .25 .11 r
.42172 .62091 m .41944 .62629 L .44478 .6308 L p F P
0 0 0 r
s
.841 .25 .11 r
.44314 .63444 m .44478 .6308 L .41944 .62629 L p F P
0 0 0 r
s
1 .333 .137 r
.56995 .62495 m .573 .61956 L .59392 .60991 L p F P
0 0 0 r
s
1 .333 .137 r
.59802 .60282 m .59392 .60991 L .573 .61956 L p F P
0 0 0 r
s
1 .327 .133 r
.59392 .60991 m .59802 .60282 L .61722 .58902 L p F P
0 0 0 r
s
.909 .271 .117 r
.44314 .63444 m .44151 .63806 L .47012 .63567 L p F P
0 0 0 r
s
.909 .271 .117 r
.46924 .63751 m .47012 .63567 L .44151 .63806 L p F P
0 0 0 r
s
.433 .13 .063 r
.3707 .56559 m .37434 .55541 L .36248 .53592 L p F P
0 0 0 r
s
.564 .169 .078 r
.37434 .55541 m .3707 .56559 L .38628 .58249 L p F P
0 0 0 r
s
.822 .24 .091 r
.38035 .37298 m .37601 .38686 L .36972 .40235 L p F P
0 0 0 r
s
.822 .24 .091 r
.36533 .41646 m .36972 .40235 L .37601 .38686 L p F P
0 0 0 r
s
.83 .24 .1 r
.37321 .39668 m
.38467 .37464 L
s
1 .327 .133 r
.62234 .58031 m .61722 .58902 L .59802 .60282 L p F P
0 0 0 r
s
1 .304 .122 r
.61722 .58902 m .62234 .58031 L .63915 .56308 L p F P
0 0 0 r
s
.096 .028 .012 r
.6891 .46581 m .6812 .47922 L .67588 .50019 L p F P
0 0 0 r
s
.171 .049 .025 r
.6812 .47922 m .6891 .46581 L .68975 .44545 L p F P
0 0 0 r
s
.83 .24 .1 r
.67229 .47279 m
.68777 .44602 L
s
.68225 .42014 m
.68777 .44602 L
s
.24 .35 .67 r
.68937 .62144 m
.67853 .64405 L
s
.63577 .63786 m
.67853 .64405 L
s
.183 .241 .456 r
.60232 .38245 m .62296 .38614 L .6292 .4016 L p F P
0 0 0 r
s
.183 .241 .456 r
.65074 .40541 m .6292 .4016 L .62296 .38614 L p F P
0 0 0 r
s
.083 .024 .01 r
.36972 .40235 m .36533 .41646 L .36226 .43497 L p F P
0 0 0 r
s
.83 .24 .1 r
.36507 .42269 m
.37321 .39668 L
s
1 .319 .134 r
.52148 .63705 m .52245 .63521 L .54396 .63716 L p F P
0 0 0 r
s
1 .319 .134 r
.54594 .63354 m .54396 .63716 L .52245 .63521 L p F P
0 0 0 r
s
1 .305 .13 r
.5186 .64255 m .51764 .64436 L .5 .62969 L closepath p F P
0 0 0 r
s
.284 .43 .846 r
.51421 .64388 m .51764 .64436 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .323 .129 r
.39358 .34845 m .39785 .33496 L .40875 .33016 L p F P
0 0 0 r
s
.1 .113 .216 r
.41801 .3386 m .39785 .33496 L .40875 .33016 L p F P
0 0 0 r
s
.24 .35 .67 r
.39858 .32722 m
.40227 .33059 L
s
.40227 .33059 m
.40618 .3313 L
s
.83 .24 .1 r
.40179 .35629 m
.40812 .33682 L
s
.41015 .33055 m
.41134 .32689 L
s
.4101 .3307 m
.41015 .33055 L
s
1 .329 .137 r
.54594 .63354 m .54793 .62989 L .56995 .62495 L p F P
0 0 0 r
s
1 .329 .137 r
.573 .61956 m .56995 .62495 L .54793 .62989 L p F P
0 0 0 r
s
.142 .176 .325 r
.49755 .35297 m .51718 .35651 L .51859 .36745 L p F P
0 0 0 r
s
.142 .176 .325 r
.5397 .37123 m .51859 .36745 L .51718 .35651 L p F P
0 0 0 r
s
.284 .43 .846 r
.51077 .64339 m .51421 .64388 L .5 .62969 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.69811 .39193 m
.68616 .36635 L
s
.70229 .3366 m
.68616 .36635 L
s
.24 .35 .67 r
.35783 .32253 m
.40227 .33059 L
s
.40227 .33059 m
.4028 .33279 L
s
.40015 .63449 m
.40681 .62353 L
s
.35569 .62824 m
.40015 .63449 L
s
.284 .43 .846 r
.50732 .6429 m .51077 .64339 L .5 .62969 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.78494 .60682 m
.77439 .63404 L
s
.73213 .62778 m
.77439 .63404 L
s
.52191 .6399 m
.53936 .64239 L
s
1 .304 .122 r
.64523 .55285 m .63915 .56308 L .62234 .58031 L p F P
0 0 0 r
s
.871 .26 .101 r
.63915 .56308 m .64523 .55285 L .65896 .53307 L p F P
0 0 0 r
s
.284 .43 .846 r
.50388 .64242 m .50732 .6429 L .5 .62969 L closepath p F P
0 0 0 r
s
.231 .067 .035 r
.68975 .44545 m .69786 .43146 L .69344 .41298 L p F P
0 0 0 r
s
.171 .049 .025 r
.69786 .43146 m .68975 .44545 L .6891 .46581 L p F P
0 0 0 r
s
1 .305 .13 r
.51956 .64072 m .5186 .64255 L .5 .62969 L closepath p F P
0 0 0 r
s
.294 .087 .046 r
.36248 .53592 m .36643 .52438 L .3584 .50333 L p F P
0 0 0 r
s
.433 .13 .063 r
.36643 .52438 m .36248 .53592 L .37434 .55541 L p F P
0 0 0 r
s
.83 .24 .1 r
.37301 .55022 m
.37566 .55483 L
s
.284 .43 .846 r
.50043 .64193 m .50388 .64242 L .5 .62969 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.80392 .47861 m
.84581 .48576 L
s
.84555 .51698 m
.84581 .48576 L
s
.83 .24 .1 r
.48168 .24133 m
.47038 .27323 L
s
.47038 .27323 m
.44391 .28227 L
s
.284 .43 .846 r
.49698 .64144 m .50043 .64193 L .5 .62969 L closepath p F P
0 0 0 r
s
.909 .271 .117 r
.44478 .6308 m .44314 .63444 L .471 .63382 L p F P
0 0 0 r
s
.909 .271 .117 r
.47012 .63567 m .471 .63382 L .44314 .63444 L p F P
0 0 0 r
s
.83 .24 .1 r
.63514 .27128 m
.60579 .25608 L
s
.62014 .22379 m
.60579 .25608 L
s
.60579 .25608 m
.57464 .24514 L
s
.211 .286 .545 r
.67215 .40921 m .69344 .41298 L .69786 .43146 L p F P
0 0 0 r
s
.183 .241 .456 r
.58157 .37873 m .60232 .38245 L .60753 .39776 L p F P
0 0 0 r
s
.183 .241 .456 r
.6292 .4016 m .60753 .39776 L .60232 .38245 L p F P
0 0 0 r
s
.284 .43 .846 r
.49352 .64095 m .49698 .64144 L .5 .62969 L closepath p F P
0 0 0 r
s
.142 .176 .325 r
.47783 .3494 m .49755 .35297 L .49735 .36364 L p F P
0 0 0 r
s
.142 .176 .325 r
.51859 .36745 m .49735 .36364 L .49755 .35297 L p F P
0 0 0 r
s
.284 .43 .846 r
.49006 .64046 m .49352 .64095 L .5 .62969 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.71718 .43592 m
.75962 .44333 L
s
.75962 .44333 m
.76154 .47138 L
s
.83 .24 .1 r
.42132 .29617 m
.41134 .32689 L
s
.4057 .33285 m
.41134 .32689 L
s
1 .319 .134 r
.52245 .63521 m .52342 .63336 L .54594 .63354 L p F P
0 0 0 r
s
1 .319 .134 r
.54793 .62989 m .54594 .63354 L .52342 .63336 L p F P
0 0 0 r
s
.83 .24 .1 r
.54658 .63008 m
.54743 .62852 L
s
1 .305 .13 r
.52052 .63889 m .51956 .64072 L .5 .62969 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.66166 .29022 m
.63514 .27128 L
s
.65017 .2393 m
.63514 .27128 L
s
.284 .43 .846 r
.4866 .63997 m .49006 .64046 L .5 .62969 L closepath p F P
0 0 0 r
s
.672 .201 .091 r
.40214 .6046 m .40499 .59744 L .38628 .58249 L p F P
0 0 0 r
s
.762 .227 .101 r
.40499 .59744 m .40214 .6046 L .42402 .61547 L p F P
0 0 0 r
s
.762 .227 .101 r
.42172 .62091 m .42402 .61547 L .40214 .6046 L p F P
0 0 0 r
s
.841 .25 .11 r
.42402 .61547 m .42172 .62091 L .44642 .62713 L p F P
0 0 0 r
s
.841 .25 .11 r
.44478 .6308 m .44642 .62713 L .42172 .62091 L p F P
0 0 0 r
s
.24 .35 .67 r
.22115 .295 m
.22128 .29779 L
s
.83 .24 .1 r
.58831 .21254 m
.57464 .24514 L
s
.57464 .24514 m
.5428 .23886 L
s
.284 .43 .846 r
.48313 .63948 m .4866 .63997 L .5 .62969 L closepath p F P
0 0 0 r
s
.083 .024 .01 r
.65896 .53307 m .66589 .52147 L .67588 .50019 L p F P
0 0 0 r
s
.871 .26 .101 r
.66589 .52147 m .65896 .53307 L .64523 .55285 L p F P
0 0 0 r
s
.83 .24 .1 r
.64853 .54685 m
.66355 .5216 L
s
.66355 .5216 m
.67118 .49797 L
s
.24 .35 .67 r
.21911 .60902 m
.21684 .61362 L
s
.17113 .60722 m
.21684 .61362 L
s
.284 .43 .846 r
.47967 .63899 m .48313 .63948 L .5 .62969 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.82705 .61323 m
.83591 .58255 L
s
.78494 .60682 m
.82705 .61323 L
s
.226 .065 .035 r
.3584 .50333 m .36258 .49061 L .35838 .46917 L p F P
0 0 0 r
s
.294 .087 .046 r
.36258 .49061 m .3584 .50333 L .36643 .52438 L p F P
0 0 0 r
s
.284 .43 .846 r
.47619 .63849 m .47967 .63899 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .329 .137 r
.54793 .62989 m .54994 .62621 L .573 .61956 L p F P
0 0 0 r
s
.83 .24 .1 r
.54743 .62852 m
.54888 .62816 L
s
1 .329 .137 r
.57607 .61411 m .573 .61956 L .54994 .62621 L p F P
0 0 0 r
s
1 .333 .137 r
.573 .61956 m .57607 .61411 L .59802 .60282 L p F P
0 0 0 r
s
1 .305 .13 r
.52148 .63705 m .52052 .63889 L .5 .62969 L closepath p F P
0 0 0 r
s
.564 .169 .078 r
.38628 .58249 m .3896 .57368 L .37434 .55541 L p F P
0 0 0 r
s
.83 .24 .1 r
.37512 .55635 m
.37566 .55483 L
s
.672 .201 .091 r
.3896 .57368 m .38628 .58249 L .40499 .59744 L p F P
0 0 0 r
s
.183 .241 .456 r
.56069 .37499 m .58157 .37873 L .58573 .3939 L p F P
0 0 0 r
s
.183 .241 .456 r
.60753 .39776 m .58573 .3939 L .58157 .37873 L p F P
0 0 0 r
s
1 .333 .137 r
.60218 .59565 m .59802 .60282 L .57607 .61411 L p F P
0 0 0 r
s
1 .327 .133 r
.59802 .60282 m .60218 .59565 L .62234 .58031 L p F P
0 0 0 r
s
.211 .286 .545 r
.65074 .40541 m .67215 .40921 L .6761 .42766 L p F P
0 0 0 r
s
.211 .286 .545 r
.69786 .43146 m .6761 .42766 L .67215 .40921 L p F P
0 0 0 r
s
.284 .43 .846 r
.47272 .638 m .47619 .63849 L .5 .62969 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.6461 .61503 m
.63577 .63786 L
s
.59249 .63159 m
.63577 .63786 L
s
.142 .176 .325 r
.45799 .34582 m .47783 .3494 L .476 .35982 L p F P
0 0 0 r
s
.142 .176 .325 r
.49735 .36364 m .476 .35982 L .47783 .3494 L p F P
0 0 0 r
s
.909 .271 .117 r
.44642 .62713 m .44478 .6308 L .47188 .63196 L p F P
0 0 0 r
s
.909 .271 .117 r
.471 .63382 m .47188 .63196 L .44478 .6308 L p F P
0 0 0 r
s
.284 .43 .846 r
.46924 .63751 m .47272 .638 L .5 .62969 L closepath p F P
0 0 0 r
s
.997 .292 .115 r
.39785 .33496 m .39358 .34845 L .38479 .35879 L p F P
0 0 0 r
s
.997 .292 .115 r
.38035 .37298 m .38479 .35879 L .39358 .34845 L p F P
0 0 0 r
s
.24 .35 .67 r
.31285 .31438 m
.35783 .32253 L
s
.35783 .32253 m
.35946 .33276 L
s
.97 .289 .124 r
.5 .62969 m .47012 .63567 L .46924 .63751 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.36156 .61709 m
.35569 .62824 L
s
.31071 .62191 m
.35569 .62824 L
s
1 .319 .134 r
.52342 .63336 m .5244 .6315 L .54793 .62989 L p F P
0 0 0 r
s
1 .319 .134 r
.54994 .62621 m .54793 .62989 L .5244 .6315 L p F P
0 0 0 r
s
1 .305 .13 r
.52245 .63521 m .52148 .63705 L .5 .62969 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.74234 .60033 m
.73213 .62778 L
s
.68937 .62144 m
.73213 .62778 L
s
1 .327 .133 r
.62755 .57147 m .62234 .58031 L .60218 .59565 L p F P
0 0 0 r
s
.83 .24 .1 r
.62483 .5761 m
.6285 .57293 L
s
1 .304 .122 r
.62234 .58031 m .62755 .57147 L .64523 .55285 L p F P
0 0 0 r
s
.083 .024 .01 r
.68348 .48741 m .67588 .50019 L .66589 .52147 L p F P
0 0 0 r
s
.096 .028 .012 r
.67588 .50019 m .68348 .48741 L .6891 .46581 L p F P
0 0 0 r
s
.83 .24 .1 r
.68434 .31224 m
.66166 .29022 L
s
.67735 .25853 m
.66166 .29022 L
s
.154 .045 .022 r
.35838 .46917 m .36274 .45554 L .36226 .43497 L p F P
0 0 0 r
s
.226 .065 .035 r
.36274 .45554 m .35838 .46917 L .36258 .49061 L p F P
0 0 0 r
s
.433 .13 .063 r
.37434 .55541 m .37805 .54505 L .36643 .52438 L p F P
0 0 0 r
s
.564 .169 .078 r
.37805 .54505 m .37434 .55541 L .3896 .57368 L p F P
0 0 0 r
s
.24 .35 .67 r
.76154 .47138 m
.80392 .47861 L
s
.80392 .47861 m
.80337 .50996 L
s
.183 .241 .456 r
.5397 .37123 m .56069 .37499 L .5638 .39001 L p F P
0 0 0 r
s
.183 .241 .456 r
.58573 .3939 m .5638 .39001 L .56069 .37499 L p F P
0 0 0 r
s
.97 .289 .124 r
.5 .62969 m .471 .63382 L .47012 .63567 L closepath p F P
0 0 0 r
s
.142 .176 .325 r
.43805 .34222 m .45799 .34582 L .45452 .35597 L p F P
0 0 0 r
s
.142 .176 .325 r
.476 .35982 m .45452 .35597 L .45799 .34582 L p F P
0 0 0 r
s
.211 .286 .545 r
.6292 .4016 m .65074 .40541 L .6542 .42383 L p F P
0 0 0 r
s
.211 .286 .545 r
.6761 .42766 m .6542 .42383 L .65074 .40541 L p F P
0 0 0 r
s
.24 .35 .67 r
.67407 .4273 m
.67423 .42843 L
s
.83 .24 .1 r
.55582 .20598 m
.5428 .23886 L
s
.5428 .23886 m
.51143 .23754 L
s
1 .305 .13 r
.52342 .63336 m .52245 .63521 L .5 .62969 L closepath p F P
0 0 0 r
s
.762 .227 .101 r
.42402 .61547 m .42635 .60998 L .40499 .59744 L p F P
0 0 0 r
s
.841 .25 .11 r
.42635 .60998 m .42402 .61547 L .44808 .62344 L p F P
0 0 0 r
s
.841 .25 .11 r
.44642 .62713 m .44808 .62344 L .42402 .61547 L p F P
0 0 0 r
s
.24 .35 .67 r
.80337 .50996 m
.84555 .51698 L
s
.84219 .54985 m
.84555 .51698 L
s
.71718 .43592 m
.71864 .46406 L
s
.909 .271 .117 r
.44808 .62344 m .44642 .62713 L .47277 .6301 L p F P
0 0 0 r
s
.909 .271 .117 r
.47188 .63196 m .47277 .6301 L .44642 .62713 L p F P
0 0 0 r
s
.24 .35 .67 r
.46514 .63183 m
.4693 .63242 L
s
.822 .24 .091 r
.38479 .35879 m .38035 .37298 L .37422 .38792 L p F P
0 0 0 r
s
.822 .24 .091 r
.36972 .40235 m .37422 .38792 L .38035 .37298 L p F P
0 0 0 r
s
.083 .024 .01 r
.36226 .43497 m .36672 .42074 L .36972 .40235 L p F P
0 0 0 r
s
.154 .045 .022 r
.36672 .42074 m .36226 .43497 L .36274 .45554 L p F P
0 0 0 r
s
.97 .289 .124 r
.5 .62969 m .47188 .63196 L .471 .63382 L closepath p F P
0 0 0 r
s
1 .319 .134 r
.5244 .6315 m .52538 .62964 L .54994 .62621 L p F P
0 0 0 r
s
1 .319 .134 r
.55196 .62252 m .54994 .62621 L .52538 .62964 L p F P
0 0 0 r
s
1 .329 .137 r
.54994 .62621 m .55196 .62252 L .57607 .61411 L p F P
0 0 0 r
s
1 .329 .137 r
.57918 .60861 m .57607 .61411 L .55196 .62252 L p F P
0 0 0 r
s
1 .333 .137 r
.57607 .61411 m .57918 .60861 L .60218 .59565 L p F P
0 0 0 r
s
.24 .35 .67 r
.17248 .60246 m
.17113 .60722 L
s
.672 .201 .091 r
.40499 .59744 m .40789 .59019 L .3896 .57368 L p F P
0 0 0 r
s
.762 .227 .101 r
.40789 .59019 m .40499 .59744 L .42635 .60998 L p F P
0 0 0 r
s
1 .304 .122 r
.65142 .54244 m .64523 .55285 L .62755 .57147 L p F P
0 0 0 r
s
.871 .26 .101 r
.64523 .55285 m .65142 .54244 L .66589 .52147 L p F P
0 0 0 r
s
1 .305 .13 r
.5244 .6315 m .52342 .63336 L .5 .62969 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.83591 .58255 m
.84219 .54985 L
s
.79361 .57592 m
.83591 .58255 L
s
.096 .028 .012 r
.69717 .4521 m .6891 .46581 L .68348 .48741 L p F P
0 0 0 r
s
.83 .24 .1 r
.67118 .49797 m
.68684 .47141 L
s
.171 .049 .025 r
.6891 .46581 m .69717 .4521 L .69786 .43146 L p F P
0 0 0 r
s
.24 .35 .67 r
.69782 .43254 m
.71718 .43592 L
s
.79361 .57592 m
.78494 .60682 L
s
.74234 .60033 m
.78494 .60682 L
s
.083 .024 .01 r
.37422 .38792 m .36972 .40235 L .36672 .42074 L p F P
0 0 0 r
s
.83 .24 .1 r
.36814 .42159 m
.37321 .39668 L
s
.142 .176 .325 r
.41801 .3386 m .43805 .34222 L .43291 .3521 L p F P
0 0 0 r
s
.142 .176 .325 r
.45452 .35597 m .43291 .3521 L .43805 .34222 L p F P
0 0 0 r
s
.183 .241 .456 r
.51859 .36745 m .5397 .37123 L .54174 .38611 L p F P
0 0 0 r
s
.183 .241 .456 r
.5638 .39001 m .54174 .38611 L .5397 .37123 L p F P
0 0 0 r
s
.83 .24 .1 r
.70394 .41804 m
.69811 .39193 L
s
.71468 .36243 m
.69811 .39193 L
s
.211 .286 .545 r
.60753 .39776 m .6292 .4016 L .63217 .41999 L p F P
0 0 0 r
s
.211 .286 .545 r
.6542 .42383 m .63217 .41999 L .6292 .4016 L p F P
0 0 0 r
s
.294 .087 .046 r
.36643 .52438 m .37045 .5126 L .36258 .49061 L p F P
0 0 0 r
s
.433 .13 .063 r
.37045 .5126 m .36643 .52438 L .37805 .54505 L p F P
0 0 0 r
s
.97 .289 .124 r
.5 .62969 m .47277 .6301 L .47188 .63196 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.79988 .54302 m
.84219 .54985 L
s
1 .333 .137 r
.60639 .58837 m .60218 .59565 L .57918 .60861 L p F P
0 0 0 r
s
1 .327 .133 r
.60218 .59565 m .60639 .58837 L .62755 .57147 L p F P
0 0 0 r
s
1 .305 .13 r
.52538 .62964 m .5244 .6315 L .5 .62969 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.52178 .62965 m
.52604 .62946 L
s
.24 .35 .67 r
.26734 .30613 m
.31285 .31438 L
s
.31285 .31438 m
.31363 .32451 L
s
.31576 .61057 m
.31071 .62191 L
s
.26519 .6155 m
.31071 .62191 L
s
.231 .318 .61 r
.6761 .42766 m .69786 .43146 L .69717 .4521 L p F P
0 0 0 r
s
.83 .24 .1 r
.68777 .44602 m
.68944 .44313 L
s
.24 .35 .67 r
.67423 .42843 m
.6772 .42894 L
s
.83 .24 .1 r
.68684 .47141 m
.68777 .44602 L
s
.841 .25 .11 r
.44808 .62344 m .44976 .61972 L .42635 .60998 L p F P
0 0 0 r
s
.909 .271 .117 r
.44976 .61972 m .44808 .62344 L .47365 .62823 L p F P
0 0 0 r
s
.909 .271 .117 r
.47277 .6301 m .47365 .62823 L .44808 .62344 L p F P
0 0 0 r
s
.24 .35 .67 r
.45152 .62989 m
.46514 .63183 L
s
.44678 .63676 m
.45152 .62989 L
s
.69922 .59377 m
.68937 .62144 L
s
.6461 .61503 m
.68937 .62144 L
s
.83 .24 .1 r
.45474 .25022 m
.44391 .28227 L
s
.44391 .28227 m
.42132 .29617 L
s
.564 .169 .078 r
.3896 .57368 m .39298 .56474 L .37805 .54505 L p F P
0 0 0 r
s
.672 .201 .091 r
.39298 .56474 m .3896 .57368 L .40789 .59019 L p F P
0 0 0 r
s
.97 .289 .124 r
.5 .62969 m .47365 .62823 L .47277 .6301 L closepath p F P
0 0 0 r
s
.142 .176 .325 r
.39785 .33496 m .41801 .3386 L .41118 .34821 L p F P
0 0 0 r
s
.142 .176 .325 r
.43291 .3521 m .41118 .34821 L .41801 .3386 L p F P
0 0 0 r
s
1 .319 .134 r
.52538 .62964 m .52636 .62777 L .55196 .62252 L p F P
0 0 0 r
s
1 .319 .134 r
.554 .61879 m .55196 .62252 L .52636 .62777 L p F P
0 0 0 r
s
1 .329 .137 r
.55196 .62252 m .554 .61879 L .57918 .60861 L p F P
0 0 0 r
s
1 .305 .13 r
.52636 .62777 m .52538 .62964 L .5 .62969 L closepath p F P
0 0 0 r
s
.183 .241 .456 r
.49735 .36364 m .51859 .36745 L .51954 .38217 L p F P
0 0 0 r
s
.183 .241 .456 r
.54174 .38611 m .51954 .38217 L .51859 .36745 L p F P
0 0 0 r
s
.83 .24 .1 r
.70229 .3366 m
.68434 .31224 L
s
.70065 .28084 m
.68434 .31224 L
s
.762 .227 .101 r
.42635 .60998 m .4287 .60443 L .40789 .59019 L p F P
0 0 0 r
s
.841 .25 .11 r
.4287 .60443 m .42635 .60998 L .44976 .61972 L p F P
0 0 0 r
s
.24 .35 .67 r
.71864 .46406 m
.76154 .47138 L
s
.76154 .47138 m
.76068 .50287 L
s
.083 .024 .01 r
.66589 .52147 m .67295 .50963 L .68348 .48741 L p F P
0 0 0 r
s
.871 .26 .101 r
.67295 .50963 m .66589 .52147 L .65142 .54244 L p F P
0 0 0 r
s
.211 .286 .545 r
.58573 .3939 m .60753 .39776 L .61001 .41611 L p F P
0 0 0 r
s
.211 .286 .545 r
.63217 .41999 m .61001 .41611 L .60753 .39776 L p F P
0 0 0 r
s
.24 .35 .67 r
.63063 .41972 m
.63077 .42084 L
s
.76068 .50287 m
.80337 .50996 L
s
.80337 .50996 m
.79988 .54302 L
s
1 .327 .133 r
.63284 .56249 m .62755 .57147 L .60639 .58837 L p F P
0 0 0 r
s
1 .304 .122 r
.62755 .57147 m .63284 .56249 L .65142 .54244 L p F P
0 0 0 r
s
.83 .24 .1 r
.64947 .54257 m
.66355 .5216 L
s
.6462 .54808 m
.64947 .54257 L
s
.909 .271 .117 r
.47365 .62823 m .47455 .62636 L .44976 .61972 L p F P
0 0 0 r
s
.97 .289 .124 r
.5 .62969 m .47455 .62636 L .47365 .62823 L closepath p F P
0 0 0 r
s
1 .329 .137 r
.58232 .60304 m .57918 .60861 L .554 .61879 L p F P
0 0 0 r
s
1 .333 .137 r
.57918 .60861 m .58232 .60304 L .60639 .58837 L p F P
0 0 0 r
s
.24 .35 .67 r
.59249 .63159 m
.6023 .60854 L
s
.83 .24 .1 r
.52381 .2044 m
.51143 .23754 L
s
.51143 .23754 m
.48168 .24133 L
s
.226 .065 .035 r
.36258 .49061 m .36685 .47762 L .36274 .45554 L p F P
0 0 0 r
s
.294 .087 .046 r
.36685 .47762 m .36258 .49061 L .37045 .5126 L p F P
0 0 0 r
s
.83 .24 .1 r
.36937 .50213 m
.36961 .50289 L
s
.36949 .50326 m
.36961 .50289 L
s
1 .305 .13 r
.52734 .62589 m .52636 .62777 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .319 .134 r
.52636 .62777 m .52734 .62589 L .554 .61879 L p F P
0 0 0 r
s
.231 .318 .61 r
.6542 .42383 m .6761 .42766 L .67548 .44837 L p F P
0 0 0 r
s
.231 .318 .61 r
.69717 .4521 m .67548 .44837 L .6761 .42766 L p F P
0 0 0 r
s
.83 .24 .1 r
.69634 .43119 m
.70394 .41804 L
s
.97 .289 .124 r
.5 .62969 m .4818 .61112 L .48088 .61304 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.49758 .62723 m
.5075 .62865 L
s
.24 .35 .67 r
.499 .62956 m
.49926 .62905 L
s
.97 .289 .124 r
.5 .62969 m .48088 .61304 L .47996 .61497 L closepath p F P
0 0 0 r
s
.291 .434 .852 r
.5 .62969 m .4818 .61112 L .48536 .61163 L closepath p F P
0 0 0 r
s
.291 .434 .852 r
.5 .62969 m .48536 .61163 L .48891 .61215 L closepath p F P
0 0 0 r
s
.291 .434 .852 r
.5 .62969 m .48891 .61215 L .49246 .61267 L closepath p F P
0 0 0 r
s
.291 .434 .852 r
.5 .62969 m .49246 .61267 L .49601 .61318 L closepath p F P
0 0 0 r
s
.291 .434 .852 r
.5 .62969 m .49601 .61318 L .49956 .6137 L closepath p F P
0 0 0 r
s
.291 .434 .852 r
.5 .62969 m .49956 .6137 L .5031 .61421 L closepath p F P
0 0 0 r
s
.291 .434 .852 r
.5 .62969 m .5031 .61421 L .50664 .61473 L closepath p F P
0 0 0 r
s
.291 .434 .852 r
.5 .62969 m .50664 .61473 L .51018 .61524 L closepath p F P
0 0 0 r
s
.97 .289 .124 r
.5 .62969 m .47996 .61497 L .47905 .61688 L closepath p F P
0 0 0 r
s
.97 .289 .124 r
.5 .62969 m .47905 .61688 L .47815 .61879 L closepath p F P
0 0 0 r
s
.97 .289 .124 r
.5 .62969 m .47815 .61879 L .47724 .62069 L closepath p F P
0 0 0 r
s
.97 .289 .124 r
.5 .62969 m .47724 .62069 L .47634 .62259 L closepath p F P
0 0 0 r
s
.97 .289 .124 r
.5 .62969 m .47634 .62259 L .47544 .62448 L closepath p F P
0 0 0 r
s
.97 .289 .124 r
.5 .62969 m .47544 .62448 L .47455 .62636 L closepath p F P
0 0 0 r
s
1 .305 .13 r
.52833 .62401 m .52734 .62589 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .305 .13 r
.52932 .62212 m .52833 .62401 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .305 .13 r
.53032 .62022 m .52932 .62212 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .305 .13 r
.53132 .61832 m .53032 .62022 L .5 .62969 L closepath p F P
0 0 0 r
s
.291 .434 .852 r
.5 .62969 m .51018 .61524 L .51371 .61576 L closepath p F P
0 0 0 r
s
.291 .434 .852 r
.5 .62969 m .51371 .61576 L .51724 .61627 L closepath p F P
0 0 0 r
s
.291 .434 .852 r
.5 .62969 m .51724 .61627 L .52076 .61678 L closepath p F P
0 0 0 r
s
.291 .434 .852 r
.5 .62969 m .52076 .61678 L .52429 .61729 L closepath p F P
0 0 0 r
s
.291 .434 .852 r
.5 .62969 m .52429 .61729 L .5278 .61781 L closepath p F P
0 0 0 r
s
.291 .434 .852 r
.5 .62969 m .5278 .61781 L .53132 .61832 L closepath p F P
0 0 0 r
s
.841 .25 .11 r
.44976 .61972 m .45144 .61598 L .4287 .60443 L p F P
0 0 0 r
s
.909 .271 .117 r
.45144 .61598 m .44976 .61972 L .47455 .62636 L p F P
0 0 0 r
s
.997 .292 .115 r
.38479 .35879 m .38932 .34429 L .39785 .33496 L p F P
0 0 0 r
s
.142 .176 .325 r
.41118 .34821 m .38932 .34429 L .39785 .33496 L p F P
0 0 0 r
s
.83 .24 .1 r
.38467 .37464 m
.39397 .34526 L
s
.39397 .34526 m
.39407 .34515 L
s
.39612 .33846 m
.40369 .31454 L
s
.39397 .34526 m
.39401 .34513 L
s
.24 .35 .67 r
.79988 .54302 m
.79361 .57592 L
s
.75081 .56921 m
.79361 .57592 L
s
.75081 .56921 m
.74234 .60033 L
s
.69922 .59377 m
.74234 .60033 L
s
.183 .241 .456 r
.476 .35982 m .49735 .36364 L .49722 .37822 L p F P
0 0 0 r
s
.183 .241 .456 r
.51954 .38217 m .49722 .37822 L .49735 .36364 L p F P
0 0 0 r
s
.672 .201 .091 r
.40789 .59019 m .41082 .58285 L .39298 .56474 L p F P
0 0 0 r
s
.762 .227 .101 r
.41082 .58285 m .40789 .59019 L .4287 .60443 L p F P
0 0 0 r
s
.909 .271 .117 r
.47455 .62636 m .47544 .62448 L .45144 .61598 L p F P
0 0 0 r
s
1 .319 .134 r
.55605 .61504 m .554 .61879 L .52734 .62589 L p F P
0 0 0 r
s
1 .329 .137 r
.554 .61879 m .55605 .61504 L .58232 .60304 L p F P
0 0 0 r
s
.433 .13 .063 r
.37805 .54505 m .38182 .53449 L .37045 .5126 L p F P
0 0 0 r
s
.564 .169 .078 r
.38182 .53449 m .37805 .54505 L .39298 .56474 L p F P
0 0 0 r
s
.211 .286 .545 r
.5638 .39001 m .58573 .3939 L .58772 .41222 L p F P
0 0 0 r
s
.211 .286 .545 r
.61001 .41611 m .58772 .41222 L .58573 .3939 L p F P
0 0 0 r
s
1 .319 .134 r
.52734 .62589 m .52833 .62401 L .55605 .61504 L p F P
0 0 0 r
s
.24 .35 .67 r
.5487 .62525 m
.59249 .63159 L
s
.53936 .64239 m
.5487 .62525 L
s
.75705 .5361 m
.79988 .54302 L
s
.083 .024 .01 r
.69124 .47434 m .68348 .48741 L .67295 .50963 L p F P
0 0 0 r
s
.096 .028 .012 r
.68348 .48741 m .69124 .47434 L .69717 .4521 L p F P
0 0 0 r
s
.24 .35 .67 r
.22128 .29779 m
.26734 .30613 L
s
.26734 .30613 m
.26723 .31616 L
s
.2694 .60397 m
.26519 .6155 L
s
.21911 .60902 m
.26519 .6155 L
s
1 .333 .137 r
.61065 .581 m .60639 .58837 L .58232 .60304 L p F P
0 0 0 r
s
1 .327 .133 r
.60639 .58837 m .61065 .581 L .63284 .56249 L p F P
0 0 0 r
s
.231 .318 .61 r
.63217 .41999 m .6542 .42383 L .65366 .44462 L p F P
0 0 0 r
s
.24 .35 .67 r
.63077 .42084 m
.63331 .42128 L
s
.65417 .42492 m
.65532 .42513 L
s
.231 .318 .61 r
.67548 .44837 m .65366 .44462 L .6542 .42383 L p F P
0 0 0 r
s
.909 .271 .117 r
.45313 .61221 m .45144 .61598 L .47544 .62448 L p F P
0 0 0 r
s
.83 .24 .1 r
.42553 .6006 m
.45196 .61474 L
s
.45196 .61474 m
.45199 .61475 L
s
.46643 .61952 m
.47626 .62276 L
s
.24 .35 .67 r
.40681 .62353 m
.45152 .62989 L
s
.83 .24 .1 r
.45141 .61596 m
.45196 .61474 L
s
.909 .271 .117 r
.47544 .62448 m .47634 .62259 L .45313 .61221 L p F P
0 0 0 r
s
.154 .045 .022 r
.36274 .45554 m .36719 .44159 L .36672 .42074 L p F P
0 0 0 r
s
.83 .24 .1 r
.36684 .42574 m
.36814 .42159 L
s
.226 .065 .035 r
.36719 .44159 m .36274 .45554 L .36685 .47762 L p F P
0 0 0 r
s
.24 .35 .67 r
.65557 .58713 m
.6461 .61503 L
s
.6023 .60854 m
.6461 .61503 L
s
.40681 .62353 m
.41411 .60576 L
s
.36156 .61709 m
.40681 .62353 L
s
.762 .227 .101 r
.4287 .60443 m .43108 .59883 L .41082 .58285 L p F P
0 0 0 r
s
.841 .25 .11 r
.43108 .59883 m .4287 .60443 L .45144 .61598 L p F P
0 0 0 r
s
1 .319 .134 r
.52833 .62401 m .52932 .62212 L .55811 .61126 L p F P
0 0 0 r
s
1 .319 .134 r
.55811 .61126 m .55605 .61504 L .52833 .62401 L p F P
0 0 0 r
s
.24 .35 .67 r
.53514 .62328 m
.5487 .62525 L
s
.53098 .62268 m
.53514 .62328 L
s
1 .304 .122 r
.65773 .53184 m .65142 .54244 L .63284 .56249 L p F P
0 0 0 r
s
.871 .26 .101 r
.65142 .54244 m .65773 .53184 L .67295 .50963 L p F P
0 0 0 r
s
.24 .35 .67 r
.35946 .33276 m
.39416 .339 L
s
.183 .241 .456 r
.45452 .35597 m .476 .35982 L .47475 .37424 L p F P
0 0 0 r
s
.183 .241 .456 r
.49722 .37822 m .47475 .37424 L .476 .35982 L p F P
0 0 0 r
s
.841 .25 .11 r
.45144 .61598 m .45313 .61221 L .43108 .59883 L p F P
0 0 0 r
s
.24 .35 .67 r
.71864 .46406 m
.71748 .49569 L
s
.211 .286 .545 r
.54174 .38611 m .5638 .39001 L .56528 .4083 L p F P
0 0 0 r
s
.211 .286 .545 r
.58772 .41222 m .56528 .4083 L .5638 .39001 L p F P
0 0 0 r
s
.24 .35 .67 r
.58667 .41204 m
.58678 .41316 L
s
1 .329 .137 r
.58549 .59743 m .58232 .60304 L .55605 .61504 L p F P
0 0 0 r
s
1 .333 .137 r
.58232 .60304 m .58549 .59743 L .61065 .581 L p F P
0 0 0 r
s
.822 .24 .091 r
.38932 .34429 m .38479 .35879 L .37882 .37317 L p F P
0 0 0 r
s
.822 .24 .091 r
.37422 .38792 m .37882 .37317 L .38479 .35879 L p F P
0 0 0 r
s
.909 .271 .117 r
.45484 .60841 m .45313 .61221 L .47634 .62259 L p F P
0 0 0 r
s
.909 .271 .117 r
.47634 .62259 m .47724 .62069 L .45484 .60841 L p F P
0 0 0 r
s
1 .329 .137 r
.55605 .61504 m .55811 .61126 L .58549 .59743 L p F P
0 0 0 r
s
1 .319 .134 r
.52932 .62212 m .53032 .62022 L .56019 .60746 L p F P
0 0 0 r
s
1 .319 .134 r
.56019 .60746 m .55811 .61126 L .52932 .62212 L p F P
0 0 0 r
s
.24 .35 .67 r
.71748 .49569 m
.76068 .50287 L
s
.76068 .50287 m
.75705 .5361 L
s
.083 .024 .01 r
.36672 .42074 m .37129 .40619 L .37422 .38792 L p F P
0 0 0 r
s
.154 .045 .022 r
.37129 .40619 m .36672 .42074 L .36719 .44159 L p F P
0 0 0 r
s
.564 .169 .078 r
.39298 .56474 m .39641 .55564 L .38182 .53449 L p F P
0 0 0 r
s
.672 .201 .091 r
.39641 .55564 m .39298 .56474 L .41082 .58285 L p F P
0 0 0 r
s
.245 .342 .659 r
.67548 .44837 m .69717 .4521 L .69124 .47434 L p F P
0 0 0 r
s
.24 .35 .67 r
.69605 .4602 m
.71864 .46406 L
s
.69505 .46003 m
.69605 .4602 L
s
.83 .24 .1 r
.69411 .45907 m
.69457 .45829 L
s
.68684 .47141 m
.68813 .46921 L
s
.69457 .45829 m
.70321 .44363 L
s
.294 .087 .046 r
.37045 .5126 m .37455 .50058 L .36685 .47762 L p F P
0 0 0 r
s
.433 .13 .063 r
.37455 .50058 m .37045 .5126 L .38182 .53449 L p F P
0 0 0 r
s
.231 .318 .61 r
.61001 .41611 m .63217 .41999 L .63171 .44085 L p F P
0 0 0 r
s
.231 .318 .61 r
.65366 .44462 m .63171 .44085 L .63217 .41999 L p F P
0 0 0 r
s
.083 .024 .01 r
.37882 .37317 m .37422 .38792 L .37129 .40619 L p F P
0 0 0 r
s
.83 .24 .1 r
.37412 .39376 m
.38237 .3674 L
s
.909 .271 .117 r
.45656 .60459 m .45484 .60841 L .47724 .62069 L p F P
0 0 0 r
s
.909 .271 .117 r
.47724 .62069 m .47815 .61879 L .45656 .60459 L p F P
0 0 0 r
s
.24 .35 .67 r
.75705 .5361 m
.75081 .56921 L
s
.70749 .56242 m
.75081 .56921 L
s
.183 .241 .456 r
.43291 .3521 m .45452 .35597 L .45215 .37024 L p F P
0 0 0 r
s
.183 .241 .456 r
.47475 .37424 m .45215 .37024 L .45452 .35597 L p F P
0 0 0 r
s
.24 .35 .67 r
.70749 .56242 m
.69922 .59377 L
s
.65557 .58713 m
.69922 .59377 L
s
1 .319 .134 r
.53032 .62022 m .53132 .61832 L .56228 .60363 L p F P
0 0 0 r
s
1 .319 .134 r
.56228 .60363 m .56019 .60746 L .53032 .62022 L p F P
0 0 0 r
s
.24 .35 .67 r
.5487 .62525 m
.55356 .61306 L
s
.83 .24 .1 r
.71468 .36243 m
.70229 .3366 L
s
.71916 .30548 m
.70229 .3366 L
s
1 .327 .133 r
.63822 .55336 m .63284 .56249 L .61065 .581 L p F P
0 0 0 r
s
1 .304 .122 r
.63284 .56249 m .63822 .55336 L .65773 .53184 L p F P
0 0 0 r
s
.841 .25 .11 r
.43348 .59317 m .43108 .59883 L .45313 .61221 L p F P
0 0 0 r
s
.841 .25 .11 r
.45313 .61221 m .45484 .60841 L .43348 .59317 L p F P
0 0 0 r
s
.83 .24 .1 r
.70394 .41804 m
.72086 .38877 L
s
.70321 .44363 m
.70394 .41804 L
s
.211 .286 .545 r
.51954 .38217 m .54174 .38611 L .54271 .40436 L p F P
0 0 0 r
s
.211 .286 .545 r
.56528 .4083 m .54271 .40436 L .54174 .38611 L p F P
0 0 0 r
s
.672 .201 .091 r
.41082 .58285 m .4138 .5754 L .39641 .55564 L p F P
0 0 0 r
s
.762 .227 .101 r
.4138 .5754 m .41082 .58285 L .43108 .59883 L p F P
0 0 0 r
s
.24 .35 .67 r
.7137 .5291 m
.75705 .5361 L
s
.909 .271 .117 r
.45829 .60073 m .45656 .60459 L .47815 .61879 L p F P
0 0 0 r
s
.909 .271 .117 r
.47815 .61879 m .47905 .61688 L .45829 .60073 L p F P
0 0 0 r
s
1 .329 .137 r
.55811 .61126 m .56019 .60746 L .5887 .59175 L p F P
0 0 0 r
s
1 .329 .137 r
.5887 .59175 m .58549 .59743 L .55811 .61126 L p F P
0 0 0 r
s
.083 .024 .01 r
.67295 .50963 m .68016 .49755 L .69124 .47434 L p F P
0 0 0 r
s
.871 .26 .101 r
.68016 .49755 m .67295 .50963 L .65773 .53184 L p F P
0 0 0 r
s
.83 .24 .1 r
.66355 .5216 m
.67924 .49521 L
s
.762 .227 .101 r
.43108 .59883 m .43348 .59317 L .4138 .5754 L p F P
0 0 0 r
s
.24 .35 .67 r
.22128 .29779 m
.22026 .30771 L
s
.22247 .59729 m
.21911 .60902 L
s
.17248 .60246 m
.21911 .60902 L
s
.83 .24 .1 r
.4935 .20796 m
.48168 .24133 L
s
.48168 .24133 m
.45474 .25022 L
s
.292 .43 .842 r
.55532 .6026 m .56228 .60363 L .53132 .61832 L p F P
0 0 0 r
s
.24 .35 .67 r
.55759 .60294 m
.55797 .60198 L
s
.292 .43 .842 r
.53132 .61832 m .5278 .61781 L .55532 .6026 L p F P
0 0 0 r
s
.245 .342 .659 r
.65366 .44462 m .67548 .44837 L .67019 .47079 L p F P
0 0 0 r
s
.245 .342 .659 r
.69124 .47434 m .67019 .47079 L .67548 .44837 L p F P
0 0 0 r
s
.83 .24 .1 r
.67924 .49521 m
.68618 .47349 L
s
.65017 .2393 m
.62014 .22379 L
s
.63515 .19001 m
.62014 .22379 L
s
.62014 .22379 m
.58831 .21254 L
s
.231 .318 .61 r
.58772 .41222 m .61001 .41611 L .60962 .43706 L p F P
0 0 0 r
s
.24 .35 .67 r
.58678 .41316 m
.58887 .41353 L
s
.60999 .41721 m
.61116 .41742 L
s
.231 .318 .61 r
.63171 .44085 m .60962 .43706 L .61001 .41611 L p F P
0 0 0 r
s
.292 .43 .842 r
.54834 .60157 m .55532 .6026 L .5278 .61781 L p F P
0 0 0 r
s
.24 .35 .67 r
.55356 .61306 m
.55454 .61059 L
s
.292 .43 .842 r
.5278 .61781 m .52429 .61729 L .54834 .60157 L p F P
0 0 0 r
s
.24 .35 .67 r
.36815 .5991 m
.36156 .61709 L
s
.31576 .61057 m
.36156 .61709 L
s
1 .333 .137 r
.61498 .57353 m .61065 .581 L .58549 .59743 L p F P
0 0 0 r
s
1 .327 .133 r
.61065 .581 m .61498 .57353 L .63822 .55336 L p F P
0 0 0 r
s
.83 .24 .1 r
.62784 .56237 m
.62934 .55981 L
s
.183 .241 .456 r
.41118 .34821 m .43291 .3521 L .42942 .36621 L p F P
0 0 0 r
s
.183 .241 .456 r
.45215 .37024 m .42942 .36621 L .43291 .3521 L p F P
0 0 0 r
s
.292 .43 .842 r
.54135 .60053 m .54834 .60157 L .52429 .61729 L p F P
0 0 0 r
s
.292 .43 .842 r
.52429 .61729 m .52076 .61678 L .54135 .60053 L p F P
0 0 0 r
s
.83 .24 .1 r
.43177 .26403 m
.42132 .29617 L
s
.42132 .29617 m
.40369 .31454 L
s
1 .333 .137 r
.58549 .59743 m .5887 .59175 L .61498 .57353 L p F P
0 0 0 r
s
.24 .35 .67 r
.31363 .32451 m
.35946 .33276 L
s
.35946 .33276 m
.35975 .34987 L
s
.909 .271 .117 r
.46003 .59686 m .45829 .60073 L .47905 .61688 L p F P
0 0 0 r
s
.24 .35 .67 r
.45152 .62989 m
.45951 .61233 L
s
.909 .271 .117 r
.47905 .61688 m .47996 .61497 L .46003 .59686 L p F P
0 0 0 r
s
.24 .35 .67 r
.47335 .61434 m
.47757 .61495 L
s
.83 .24 .1 r
.67735 .25853 m
.65017 .2393 L
s
.66589 .20583 m
.65017 .2393 L
s
.292 .43 .842 r
.53434 .59949 m .54135 .60053 L .52076 .61678 L p F P
0 0 0 r
s
.292 .43 .842 r
.52076 .61678 m .51724 .61627 L .53434 .59949 L p F P
0 0 0 r
s
.226 .065 .035 r
.36685 .47762 m .37121 .46434 L .36719 .44159 L p F P
0 0 0 r
s
.294 .087 .046 r
.37121 .46434 m .36685 .47762 L .37455 .50058 L p F P
0 0 0 r
s
.211 .286 .545 r
.49722 .37822 m .51954 .38217 L .52 .40039 L p F P
0 0 0 r
s
.211 .286 .545 r
.54271 .40436 m .52 .40039 L .51954 .38217 L p F P
0 0 0 r
s
.24 .35 .67 r
.54218 .40426 m
.54225 .40539 L
s
.433 .13 .063 r
.38182 .53449 m .38567 .52374 L .37455 .50058 L p F P
0 0 0 r
s
.564 .169 .078 r
.38567 .52374 m .38182 .53449 L .39641 .55564 L p F P
0 0 0 r
s
.83 .24 .1 r
.60261 .17845 m
.58831 .21254 L
s
.58831 .21254 m
.55582 .20598 L
s
.292 .43 .842 r
.52732 .59846 m .53434 .59949 L .51724 .61627 L p F P
0 0 0 r
s
.292 .43 .842 r
.51724 .61627 m .51371 .61576 L .52732 .59846 L p F P
0 0 0 r
s
.841 .25 .11 r
.4359 .58745 m .43348 .59317 L .45484 .60841 L p F P
0 0 0 r
s
.841 .25 .11 r
.45484 .60841 m .45656 .60459 L .4359 .58745 L p F P
0 0 0 r
s
.292 .43 .842 r
.52029 .59741 m .52732 .59846 L .51371 .61576 L p F P
0 0 0 r
s
.83 .24 .1 r
.52355 .61556 m
.52473 .61328 L
s
.52473 .61328 m
.52862 .60575 L
s
.292 .43 .842 r
.51371 .61576 m .51018 .61524 L .52029 .59741 L p F P
0 0 0 r
s
.24 .35 .67 r
.71748 .49569 m
.7137 .5291 L
s
.292 .43 .842 r
.51325 .59637 m .52029 .59741 L .51018 .61524 L p F P
0 0 0 r
s
.292 .43 .842 r
.51018 .61524 m .50664 .61473 L .51325 .59637 L p F P
0 0 0 r
s
.245 .342 .659 r
.63171 .44085 m .65366 .44462 L .64902 .46722 L p F P
0 0 0 r
s
.245 .342 .659 r
.67019 .47079 m .64902 .46722 L .65366 .44462 L p F P
0 0 0 r
s
1 .329 .137 r
.56019 .60746 m .56228 .60363 L .59194 .58601 L p F P
0 0 0 r
s
.83 .24 .1 r
.56683 .60297 m
.56953 .60231 L
s
1 .329 .137 r
.59194 .58601 m .5887 .59175 L .56019 .60746 L p F P
0 0 0 r
s
.24 .35 .67 r
.57193 .60404 m
.6023 .60854 L
s
.56833 .60351 m
.57193 .60404 L
s
.56571 .60312 m
.56833 .60351 L
s
.55797 .60198 m
.56365 .60282 L
s
.909 .271 .117 r
.46179 .59295 m .46003 .59686 L .47996 .61497 L p F P
0 0 0 r
s
.909 .271 .117 r
.47996 .61497 m .48088 .61304 L .46179 .59295 L p F P
0 0 0 r
s
.292 .43 .842 r
.50619 .59533 m .51325 .59637 L .50664 .61473 L p F P
0 0 0 r
s
.24 .35 .67 r
.50594 .61463 m
.5066 .61284 L
s
.51275 .5963 m
.51311 .59533 L
s
.292 .43 .842 r
.50664 .61473 m .5031 .61421 L .50619 .59533 L p F P
0 0 0 r
s
.231 .318 .61 r
.56528 .4083 m .58772 .41222 L .5874 .43324 L p F P
0 0 0 r
s
.231 .318 .61 r
.60962 .43706 m .5874 .43324 L .58772 .41222 L p F P
0 0 0 r
s
.292 .43 .842 r
.49912 .59428 m .50619 .59533 L .5031 .61421 L p F P
0 0 0 r
s
.292 .43 .842 r
.5031 .61421 m .49956 .6137 L .49912 .59428 L p F P
0 0 0 r
s
.183 .241 .456 r
.38932 .34429 m .41118 .34821 L .40654 .36216 L p F P
0 0 0 r
s
.83 .24 .1 r
.38237 .3674 m
.39266 .34776 L
s
.183 .241 .456 r
.42942 .36621 m .40654 .36216 L .41118 .34821 L p F P
0 0 0 r
s
.24 .35 .67 r
.7137 .5291 m
.70749 .56242 L
s
.66364 .55555 m
.70749 .56242 L
s
.83 .24 .1 r
.52862 .60575 m
.54886 .60497 L
s
1 .304 .122 r
.66416 .52104 m .65773 .53184 L .63822 .55336 L p F P
0 0 0 r
s
.83 .24 .1 r
.62934 .55981 m
.6412 .54965 L
s
.871 .26 .101 r
.65773 .53184 m .66416 .52104 L .68016 .49755 L p F P
0 0 0 r
s
.24 .35 .67 r
.65557 .58713 m
.66364 .55555 L
s
.292 .43 .842 r
.49203 .59323 m .49912 .59428 L .49956 .6137 L p F P
0 0 0 r
s
.292 .43 .842 r
.49956 .6137 m .49601 .61318 L .49203 .59323 L p F P
0 0 0 r
s
.257 .361 .697 r
.67019 .47079 m .69124 .47434 L .68016 .49755 L p F P
0 0 0 r
s
.83 .24 .1 r
.68288 .4891 m
.68381 .48753 L
s
.67924 .49521 m
.67927 .49517 L
s
.68381 .48753 m
.69566 .4676 L
s
.24 .35 .67 r
.68373 .49008 m
.71748 .49569 L
s
.564 .169 .078 r
.39641 .55564 m .39989 .5464 L .38567 .52374 L p F P
0 0 0 r
s
.672 .201 .091 r
.39989 .5464 m .39641 .55564 L .4138 .5754 L p F P
0 0 0 r
s
.292 .43 .842 r
.48494 .59218 m .49203 .59323 L .49601 .61318 L p F P
0 0 0 r
s
.292 .43 .842 r
.49601 .61318 m .49246 .61267 L .48494 .59218 L p F P
0 0 0 r
s
.211 .286 .545 r
.47475 .37424 m .49722 .37822 L .49715 .3964 L p F P
0 0 0 r
s
.211 .286 .545 r
.52 .40039 m .49715 .3964 L .49722 .37822 L p F P
0 0 0 r
s
.909 .271 .117 r
.46356 .58902 m .46179 .59295 L .48088 .61304 L p F P
0 0 0 r
s
.909 .271 .117 r
.48088 .61304 m .4818 .61112 L .46356 .58902 L p F P
0 0 0 r
s
.24 .35 .67 r
.45951 .61233 m
.47335 .61434 L
s
.762 .227 .101 r
.41681 .56786 m .4138 .5754 L .43348 .59317 L p F P
0 0 0 r
s
.762 .227 .101 r
.43348 .59317 m .4359 .58745 L .41681 .56786 L p F P
0 0 0 r
s
.24 .35 .67 r
.41411 .60576 m
.45951 .61233 L
s
.292 .43 .842 r
.47782 .59113 m .48494 .59218 L .49246 .61267 L p F P
0 0 0 r
s
.292 .43 .842 r
.49246 .61267 m .48891 .61215 L .47782 .59113 L p F P
0 0 0 r
s
.83 .24 .1 r
.49077 .61079 m
.49188 .60849 L
s
.49188 .60849 m
.49556 .60089 L
s
.70065 .28084 m
.67735 .25853 L
s
.69376 .22537 m
.67735 .25853 L
s
.24 .35 .67 r
.66982 .52201 m
.7137 .5291 L
s
.154 .045 .022 r
.36719 .44159 m .37175 .42733 L .37129 .40619 L p F P
0 0 0 r
s
.226 .065 .035 r
.37175 .42733 m .36719 .44159 L .37121 .46434 L p F P
0 0 0 r
s
.292 .43 .842 r
.4707 .59007 m .47782 .59113 L .48891 .61215 L p F P
0 0 0 r
s
.292 .43 .842 r
.48891 .61215 m .48536 .61163 L .4707 .59007 L p F P
0 0 0 r
s
.672 .201 .091 r
.4138 .5754 m .41681 .56786 L .39989 .5464 L p F P
0 0 0 r
s
.83 .24 .1 r
.40593 .55406 m
.40625 .55324 L
s
.841 .25 .11 r
.43835 .58166 m .4359 .58745 L .45656 .60459 L p F P
0 0 0 r
s
.841 .25 .11 r
.45656 .60459 m .45829 .60073 L .43835 .58166 L p F P
0 0 0 r
s
.24 .35 .67 r
.17496 .59053 m
.17248 .60246 L
s
.245 .342 .659 r
.60962 .43706 m .63171 .44085 L .62772 .46363 L p F P
0 0 0 r
s
.245 .342 .659 r
.64902 .46722 m .62772 .46363 L .63171 .44085 L p F P
0 0 0 r
s
.292 .43 .842 r
.46356 .58902 m .4707 .59007 L .48536 .61163 L p F P
0 0 0 r
s
.292 .43 .842 r
.48536 .61163 m .4818 .61112 L .46356 .58902 L p F P
0 0 0 r
s
1 .333 .137 r
.5887 .59175 m .59194 .58601 L .61936 .56596 L p F P
0 0 0 r
s
.83 .24 .1 r
.59557 .58699 m
.59668 .58504 L
s
1 .333 .137 r
.61936 .56596 m .61498 .57353 L .5887 .59175 L p F P
0 0 0 r
s
.24 .35 .67 r
.6023 .60854 m
.6114 .5804 L
s
.6114 .5804 m
.65557 .58713 L
s
.83 .24 .1 r
.56943 .17158 m
.55582 .20598 L
s
.55582 .20598 m
.52381 .2044 L
s
.231 .318 .61 r
.54271 .40436 m .56528 .4083 L .56505 .4294 L p F P
0 0 0 r
s
.24 .35 .67 r
.54225 .40539 m
.54389 .40568 L
s
.56527 .40941 m
.56645 .40961 L
s
.231 .318 .61 r
.5874 .43324 m .56505 .4294 L .56528 .4083 L p F P
0 0 0 r
s
.24 .35 .67 r
.32161 .59236 m
.31576 .61057 L
s
.2694 .60397 m
.31576 .61057 L
s
.289 .423 .825 r
.58169 .58447 m .59194 .58601 L .56228 .60363 L p F P
0 0 0 r
s
.289 .423 .825 r
.56228 .60363 m .55532 .6026 L .58169 .58447 L p F P
0 0 0 r
s
1 .327 .133 r
.64369 .54408 m .63822 .55336 L .61498 .57353 L p F P
0 0 0 r
s
1 .304 .122 r
.63822 .55336 m .64369 .54408 L .66416 .52104 L p F P
0 0 0 r
s
.822 .24 .091 r
.37882 .37317 m .38352 .35808 L .38932 .34429 L p F P
0 0 0 r
s
.183 .241 .456 r
.40654 .36216 m .38352 .35808 L .38932 .34429 L p F P
0 0 0 r
s
.83 .24 .1 r
.38724 .35185 m
.39196 .33677 L
s
.38663 .35379 m
.38724 .35185 L
s
.24 .35 .67 r
.26723 .31616 m
.31363 .32451 L
s
.31363 .32451 m
.3131 .34158 L
s
.257 .361 .697 r
.64902 .46722 m .67019 .47079 L .6603 .49427 L p F P
0 0 0 r
s
.257 .361 .697 r
.68016 .49755 m .6603 .49427 L .67019 .47079 L p F P
0 0 0 r
s
.294 .087 .046 r
.37455 .50058 m .37874 .48831 L .37121 .46434 L p F P
0 0 0 r
s
.433 .13 .063 r
.37874 .48831 m .37455 .50058 L .38567 .52374 L p F P
0 0 0 r
s
1 .327 .133 r
.61498 .57353 m .61936 .56596 L .64369 .54408 L p F P
0 0 0 r
s
.289 .423 .825 r
.57142 .58291 m .58169 .58447 L .55532 .6026 L p F P
0 0 0 r
s
.289 .423 .825 r
.55532 .6026 m .54834 .60157 L .57142 .58291 L p F P
0 0 0 r
s
.211 .286 .545 r
.45215 .37024 m .47475 .37424 L .47416 .39238 L p F P
0 0 0 r
s
.211 .286 .545 r
.49715 .3964 m .47416 .39238 L .47475 .37424 L p F P
0 0 0 r
s
.083 .024 .01 r
.37129 .40619 m .37596 .3913 L .37882 .37317 L p F P
0 0 0 r
s
.154 .045 .022 r
.37596 .3913 m .37129 .40619 L .37175 .42733 L p F P
0 0 0 r
s
.289 .423 .825 r
.56112 .58136 m .57142 .58291 L .54834 .60157 L p F P
0 0 0 r
s
.83 .24 .1 r
.56285 .60024 m
.56365 .59878 L
s
.289 .423 .825 r
.54834 .60157 m .54135 .60053 L .56112 .58136 L p F P
0 0 0 r
s
.083 .024 .01 r
.38352 .35808 m .37882 .37317 L .37596 .3913 L p F P
0 0 0 r
s
.83 .24 .1 r
.37731 .39249 m
.38237 .3674 L
s
.38237 .3674 m
.3852 .35838 L
s
.72086 .38877 m
.71468 .36243 L
s
.73203 .33157 m
.71468 .36243 L
s
.245 .342 .659 r
.5874 .43324 m .60962 .43706 L .60629 .46002 L p F P
0 0 0 r
s
.245 .342 .659 r
.62772 .46363 m .60629 .46002 L .60962 .43706 L p F P
0 0 0 r
s
.841 .25 .11 r
.44083 .57582 m .43835 .58166 L .45829 .60073 L p F P
0 0 0 r
s
.841 .25 .11 r
.45829 .60073 m .46003 .59686 L .44083 .57582 L p F P
0 0 0 r
s
.24 .35 .67 r
.45951 .61233 m
.46379 .5999 L
s
.46379 .5999 m
.46466 .59738 L
s
.231 .318 .61 r
.52 .40039 m .54271 .40436 L .54256 .42554 L p F P
0 0 0 r
s
.231 .318 .61 r
.56505 .4294 m .54256 .42554 L .54271 .40436 L p F P
0 0 0 r
s
.289 .423 .825 r
.55079 .5798 m .56112 .58136 L .54135 .60053 L p F P
0 0 0 r
s
.289 .423 .825 r
.54135 .60053 m .53434 .59949 L .55079 .5798 L p F P
0 0 0 r
s
.266 .377 .73 r
.6603 .49427 m .68016 .49755 L .66416 .52104 L p F P
0 0 0 r
s
.24 .35 .67 r
.66982 .52201 m
.67038 .51723 L
s
.67038 .51723 m
.67111 .511 L
s
.83 .24 .1 r
.66709 .51327 m
.66974 .50934 L
s
.66505 .5163 m
.66709 .51327 L
s
.24 .35 .67 r
.66364 .55555 m
.66982 .52201 L
s
.63768 .55148 m
.66364 .55555 L
s
.63625 .55125 m
.63768 .55148 L
s
.762 .227 .101 r
.41987 .56021 m .41681 .56786 L .4359 .58745 L p F P
0 0 0 r
s
.762 .227 .101 r
.4359 .58745 m .43835 .58166 L .41987 .56021 L p F P
0 0 0 r
s
.257 .361 .697 r
.62772 .46363 m .64902 .46722 L .64033 .49098 L p F P
0 0 0 r
s
.257 .361 .697 r
.6603 .49427 m .64033 .49098 L .64902 .46722 L p F P
0 0 0 r
s
.289 .423 .825 r
.54043 .57823 m .55079 .5798 L .53434 .59949 L p F P
0 0 0 r
s
.289 .423 .825 r
.53434 .59949 m .52732 .59846 L .54043 .57823 L p F P
0 0 0 r
s
.211 .286 .545 r
.42942 .36621 m .45215 .37024 L .45102 .38834 L p F P
0 0 0 r
s
.211 .286 .545 r
.47416 .39238 m .45102 .38834 L .45215 .37024 L p F P
0 0 0 r
s
.24 .35 .67 r
.41411 .60576 m
.4217 .58179 L
s
.36815 .5991 m
.41411 .60576 L
s
.83 .24 .1 r
.49556 .60089 m
.52862 .60575 L
s
.433 .13 .063 r
.38567 .52374 m .38958 .51279 L .37874 .48831 L p F P
0 0 0 r
s
.564 .169 .078 r
.38958 .51279 m .38567 .52374 L .39989 .5464 L p F P
0 0 0 r
s
.83 .24 .1 r
.39974 .54589 m
.40625 .55324 L
s
.46607 .21667 m
.45474 .25022 L
s
.45474 .25022 m
.43177 .26403 L
s
.289 .423 .825 r
.53004 .57666 m .54043 .57823 L .52732 .59846 L p F P
0 0 0 r
s
.289 .423 .825 r
.52732 .59846 m .52029 .59741 L .53004 .57666 L p F P
0 0 0 r
s
.285 .413 .805 r
.60611 .56392 m .61936 .56596 L .59194 .58601 L p F P
0 0 0 r
s
.24 .35 .67 r
.6114 .5804 m
.61364 .57134 L
s
.83 .24 .1 r
.61744 .56567 m
.62241 .56322 L
s
.285 .413 .805 r
.59194 .58601 m .58169 .58447 L .60611 .56392 L p F P
0 0 0 r
s
.24 .35 .67 r
.60246 .57904 m
.6114 .5804 L
s
.66443 .52114 m
.66982 .52201 L
s
.66421 .52111 m
.66443 .52114 L
s
.83 .24 .1 r
.71916 .30548 m
.70065 .28084 L
s
.71772 .24798 m
.70065 .28084 L
s
.69566 .4676 m
.70321 .44363 L
s
.72034 .41457 m
.70321 .44363 L
s
.245 .342 .659 r
.56505 .4294 m .5874 .43324 L .58474 .45639 L p F P
0 0 0 r
s
.245 .342 .659 r
.60629 .46002 m .58474 .45639 L .5874 .43324 L p F P
0 0 0 r
s
.289 .423 .825 r
.51962 .57509 m .53004 .57666 L .52029 .59741 L p F P
0 0 0 r
s
.83 .24 .1 r
.52862 .60575 m
.54167 .58049 L
s
.289 .423 .825 r
.52029 .59741 m .51325 .59637 L .51962 .57509 L p F P
0 0 0 r
s
.24 .35 .67 r
.51311 .59533 m
.51354 .59539 L
s
.35975 .34987 m
.38508 .35437 L
s
.672 .201 .091 r
.40344 .53701 m .39989 .5464 L .41681 .56786 L p F P
0 0 0 r
s
.672 .201 .091 r
.41681 .56786 m .41987 .56021 L .40344 .53701 L p F P
0 0 0 r
s
.226 .065 .035 r
.37121 .46434 m .37568 .45076 L .37175 .42733 L p F P
0 0 0 r
s
.294 .087 .046 r
.37568 .45076 m .37121 .46434 L .37874 .48831 L p F P
0 0 0 r
s
.231 .318 .61 r
.49715 .3964 m .52 .40039 L .51993 .42165 L p F P
0 0 0 r
s
.24 .35 .67 r
.49718 .39752 m
.49835 .39773 L
s
.52 .40151 m
.52119 .40171 L
s
.49714 .3964 m
.49718 .39752 L
s
.231 .318 .61 r
.54256 .42554 m .51993 .42165 L .52 .40039 L p F P
0 0 0 r
s
.266 .377 .73 r
.64033 .49098 m .6603 .49427 L .64603 .51811 L p F P
0 0 0 r
s
.266 .377 .73 r
.66416 .52104 m .64603 .51811 L .6603 .49427 L p F P
0 0 0 r
s
.83 .24 .1 r
.65839 .52753 m
.66241 .52076 L
s
.24 .35 .67 r
.27451 .58554 m
.2694 .60397 L
s
.22247 .59729 m
.2694 .60397 L
s
.285 .413 .805 r
.5928 .56186 m .60611 .56392 L .58169 .58447 L p F P
0 0 0 r
s
.83 .24 .1 r
.60389 .57234 m
.61123 .56873 L
s
.60098 .57747 m
.60389 .57234 L
s
.285 .413 .805 r
.58169 .58447 m .57142 .58291 L .5928 .56186 L p F P
0 0 0 r
s
.83 .24 .1 r
.56365 .59878 m
.56474 .59677 L
s
.564 .169 .078 r
.39989 .5464 m .40344 .53701 L .38958 .51279 L p F P
0 0 0 r
s
.841 .25 .11 r
.44333 .56992 m .44083 .57582 L .46003 .59686 L p F P
0 0 0 r
s
.841 .25 .11 r
.46003 .59686 m .46179 .59295 L .44333 .56992 L p F P
0 0 0 r
s
.257 .361 .697 r
.60629 .46002 m .62772 .46363 L .62025 .48766 L p F P
0 0 0 r
s
.257 .361 .697 r
.64033 .49098 m .62025 .48766 L .62772 .46363 L p F P
0 0 0 r
s
.24 .35 .67 r
.22026 .30771 m
.26723 .31616 L
s
.26723 .31616 m
.26588 .33319 L
s
.289 .423 .825 r
.50917 .57351 m .51962 .57509 L .51325 .59637 L p F P
0 0 0 r
s
.289 .423 .825 r
.51325 .59637 m .50619 .59533 L .50917 .57351 L p F P
0 0 0 r
s
.83 .24 .1 r
.53678 .16971 m
.52381 .2044 L
s
.52381 .2044 m
.4935 .20796 L
s
.273 .391 .758 r
.64603 .51811 m .66416 .52104 L .64369 .54408 L p F P
0 0 0 r
s
.83 .24 .1 r
.66311 .51957 m
.66505 .5163 L
s
.66303 .51971 m
.66311 .51957 L
s
.211 .286 .545 r
.40654 .36216 m .42942 .36621 L .42774 .38427 L p F P
0 0 0 r
s
.211 .286 .545 r
.45102 .38834 m .42774 .38427 L .42942 .36621 L p F P
0 0 0 r
s
.279 .403 .783 r
.62778 .54157 m .64369 .54408 L .61936 .56596 L p F P
0 0 0 r
s
.83 .24 .1 r
.6351 .54995 m
.63559 .54912 L
s
.279 .403 .783 r
.61936 .56596 m .60611 .56392 L .62778 .54157 L p F P
0 0 0 r
s
.285 .413 .805 r
.57945 .5598 m .5928 .56186 L .57142 .58291 L p F P
0 0 0 r
s
.285 .413 .805 r
.57142 .58291 m .56112 .58136 L .57945 .5598 L p F P
0 0 0 r
s
.289 .423 .825 r
.4987 .57193 m .50917 .57351 L .50619 .59533 L p F P
0 0 0 r
s
.289 .423 .825 r
.50619 .59533 m .49912 .59428 L .4987 .57193 L p F P
0 0 0 r
s
.83 .24 .1 r
.41386 .28238 m
.40369 .31454 L
s
.40369 .31454 m
.39196 .33677 L
s
.273 .391 .758 r
.64369 .54408 m .62778 .54157 L .64603 .51811 L p F P
0 0 0 r
s
.289 .423 .825 r
.48819 .57034 m .4987 .57193 L .49912 .59428 L p F P
0 0 0 r
s
.289 .423 .825 r
.49912 .59428 m .49203 .59323 L .48819 .57034 L p F P
0 0 0 r
s
.245 .342 .659 r
.54256 .42554 m .56505 .4294 L .56306 .45273 L p F P
0 0 0 r
s
.245 .342 .659 r
.58474 .45639 m .56306 .45273 L .56505 .4294 L p F P
0 0 0 r
s
.762 .227 .101 r
.42297 .55245 m .41987 .56021 L .43835 .58166 L p F P
0 0 0 r
s
.762 .227 .101 r
.43835 .58166 m .44083 .57582 L .42297 .55245 L p F P
0 0 0 r
s
.266 .377 .73 r
.62025 .48766 m .64033 .49098 L .6278 .51517 L p F P
0 0 0 r
s
.24 .35 .67 r
.62541 .51484 m
.62611 .509 L
s
.266 .377 .73 r
.64603 .51811 m .6278 .51517 L .64033 .49098 L p F P
0 0 0 r
s
.83 .24 .1 r
.47842 .59521 m
.49556 .60089 L
s
.47498 .59407 m
.47842 .59521 L
s
.49556 .60089 m
.50789 .57539 L
s
.285 .413 .805 r
.56605 .55773 m .57945 .5598 L .56112 .58136 L p F P
0 0 0 r
s
.285 .413 .805 r
.56112 .58136 m .55079 .5798 L .56605 .55773 L p F P
0 0 0 r
s
.231 .318 .61 r
.47416 .39238 m .49715 .3964 L .49716 .41774 L p F P
0 0 0 r
s
.24 .35 .67 r
.49715 .39841 m
.49718 .39752 L
s
.49715 .39752 m
.49718 .39752 L
s
.231 .318 .61 r
.51993 .42165 m .49716 .41774 L .49715 .3964 L p F P
0 0 0 r
s
.273 .391 .758 r
.6278 .51517 m .64603 .51811 L .62778 .54157 L p F P
0 0 0 r
s
.83 .24 .1 r
.63559 .54912 m
.64465 .5336 L
s
.279 .403 .783 r
.6118 .53905 m .62778 .54157 L .60611 .56392 L p F P
0 0 0 r
s
.279 .403 .783 r
.60611 .56392 m .5928 .56186 L .6118 .53905 L p F P
0 0 0 r
s
.257 .361 .697 r
.58474 .45639 m .60629 .46002 L .60006 .48433 L p F P
0 0 0 r
s
.257 .361 .697 r
.62025 .48766 m .60006 .48433 L .60629 .46002 L p F P
0 0 0 r
s
.289 .423 .825 r
.47765 .56875 m .48819 .57034 L .49203 .59323 L p F P
0 0 0 r
s
.289 .423 .825 r
.49203 .59323 m .48494 .59218 L .47765 .56875 L p F P
0 0 0 r
s
.83 .24 .1 r
.64465 .5336 m
.66505 .5163 L
s
.68137 .48881 m
.66505 .5163 L
s
.841 .25 .11 r
.44586 .56395 m .44333 .56992 L .46179 .59295 L p F P
0 0 0 r
s
.841 .25 .11 r
.46179 .59295 m .46356 .58902 L .44586 .56395 L p F P
0 0 0 r
s
.154 .045 .022 r
.37175 .42733 m .37641 .41274 L .37596 .3913 L p F P
0 0 0 r
s
.83 .24 .1 r
.37607 .39644 m
.37731 .39249 L
s
.226 .065 .035 r
.37641 .41274 m .37175 .42733 L .37568 .45076 L p F P
0 0 0 r
s
.211 .286 .545 r
.38352 .35808 m .40654 .36216 L .40432 .38018 L p F P
0 0 0 r
s
.211 .286 .545 r
.42774 .38427 m .40432 .38018 L .40654 .36216 L p F P
0 0 0 r
s
.285 .413 .805 r
.5526 .55566 m .56605 .55773 L .55079 .5798 L p F P
0 0 0 r
s
.83 .24 .1 r
.56474 .59677 m
.57421 .57941 L
s
.285 .413 .805 r
.55079 .5798 m .54043 .57823 L .5526 .55566 L p F P
0 0 0 r
s
.273 .391 .758 r
.62778 .54157 m .6118 .53905 L .6278 .51517 L p F P
0 0 0 r
s
.24 .35 .67 r
.62443 .5202 m
.62541 .51484 L
s
.62541 .51484 m
.62777 .51522 L
s
.289 .423 .825 r
.46708 .56716 m .47765 .56875 L .48494 .59218 L p F P
0 0 0 r
s
.289 .423 .825 r
.48494 .59218 m .47782 .59113 L .46708 .56716 L p F P
0 0 0 r
s
.24 .35 .67 r
.37515 .57489 m
.36815 .5991 L
s
.32161 .59236 m
.36815 .5991 L
s
.83 .24 .1 r
.57421 .57941 m
.60389 .57234 L
s
.294 .087 .046 r
.37874 .48831 m .38301 .47579 L .37568 .45076 L p F P
0 0 0 r
s
.433 .13 .063 r
.38301 .47579 m .37874 .48831 L .38958 .51279 L p F P
0 0 0 r
s
.279 .403 .783 r
.59575 .53651 m .6118 .53905 L .5928 .56186 L p F P
0 0 0 r
s
.83 .24 .1 r
.60389 .57234 m
.61879 .54613 L
s
.279 .403 .783 r
.5928 .56186 m .57945 .5598 L .59575 .53651 L p F P
0 0 0 r
s
.289 .423 .825 r
.45649 .56556 m .46708 .56716 L .47782 .59113 L p F P
0 0 0 r
s
.289 .423 .825 r
.47782 .59113 m .4707 .59007 L .45649 .56556 L p F P
0 0 0 r
s
.24 .35 .67 r
.46735 .58958 m
.46769 .5886 L
s
.46769 .5886 m
.47005 .58895 L
s
.266 .377 .73 r
.60006 .48433 m .62025 .48766 L .60949 .51221 L p F P
0 0 0 r
s
.266 .377 .73 r
.6278 .51517 m .60949 .51221 L .62025 .48766 L p F P
0 0 0 r
s
.245 .342 .659 r
.51993 .42165 m .54256 .42554 L .54125 .44905 L p F P
0 0 0 r
s
.245 .342 .659 r
.56306 .45273 m .54125 .44905 L .54256 .42554 L p F P
0 0 0 r
s
.273 .391 .758 r
.60949 .51221 m .6278 .51517 L .6118 .53905 L p F P
0 0 0 r
s
.285 .413 .805 r
.5391 .55357 m .5526 .55566 L .54043 .57823 L p F P
0 0 0 r
s
.285 .413 .805 r
.54043 .57823 m .53004 .57666 L .5391 .55357 L p F P
0 0 0 r
s
.24 .35 .67 r
.3131 .34158 m
.35975 .34987 L
s
.35975 .34987 m
.3586 .37334 L
s
.231 .318 .61 r
.45102 .38834 m .47416 .39238 L .47425 .4138 L p F P
0 0 0 r
s
.24 .35 .67 r
.45156 .38956 m
.45224 .38968 L
s
.47416 .39351 m
.47537 .39372 L
s
.45155 .38892 m
.45156 .38956 L
s
.231 .318 .61 r
.49716 .41774 m .47425 .4138 L .47416 .39238 L p F P
0 0 0 r
s
.24 .35 .67 r
.22681 .57863 m
.22247 .59729 L
s
.17496 .59053 m
.22247 .59729 L
s
.257 .361 .697 r
.56306 .45273 m .58474 .45639 L .57976 .48097 L p F P
0 0 0 r
s
.257 .361 .697 r
.60006 .48433 m .57976 .48097 L .58474 .45639 L p F P
0 0 0 r
s
.289 .423 .825 r
.44586 .56395 m .45649 .56556 L .4707 .59007 L p F P
0 0 0 r
s
.289 .423 .825 r
.4707 .59007 m .46356 .58902 L .44586 .56395 L p F P
0 0 0 r
s
.83 .24 .1 r
.46501 .58571 m
.46568 .58421 L
s
.24 .35 .67 r
.4217 .58179 m
.45974 .58742 L
s
.273 .391 .758 r
.6118 .53905 m .59575 .53651 L .60949 .51221 L p F P
0 0 0 r
s
.672 .201 .091 r
.40704 .52746 m .40344 .53701 L .41987 .56021 L p F P
0 0 0 r
s
.672 .201 .091 r
.41987 .56021 m .42297 .55245 L .40704 .52746 L p F P
0 0 0 r
s
.24 .35 .67 r
.22026 .30771 m
.21806 .32469 L
s
.083 .024 .01 r
.37596 .3913 m .38074 .37606 L .38352 .35808 L p F P
0 0 0 r
s
.154 .045 .022 r
.38074 .37606 m .37596 .3913 L .37641 .41274 L p F P
0 0 0 r
s
.279 .403 .783 r
.57963 .53397 m .59575 .53651 L .57945 .5598 L p F P
0 0 0 r
s
.279 .403 .783 r
.57945 .5598 m .56605 .55773 L .57963 .53397 L p F P
0 0 0 r
s
.285 .413 .805 r
.52555 .55148 m .5391 .55357 L .53004 .57666 L p F P
0 0 0 r
s
.285 .413 .805 r
.53004 .57666 m .51962 .57509 L .52555 .55148 L p F P
0 0 0 r
s
.211 .286 .545 r
.40432 .38018 m .38074 .37606 L .38352 .35808 L p F P
0 0 0 r
s
.83 .24 .1 r
.38326 .37362 m
.38691 .36202 L
s
.433 .13 .063 r
.38958 .51279 m .39358 .50163 L .38301 .47579 L p F P
0 0 0 r
s
.564 .169 .078 r
.39358 .50163 m .38958 .51279 L .40344 .53701 L p F P
0 0 0 r
s
.762 .227 .101 r
.42611 .54459 m .42297 .55245 L .44083 .57582 L p F P
0 0 0 r
s
.762 .227 .101 r
.44083 .57582 m .44333 .56992 L .42611 .54459 L p F P
0 0 0 r
s
.266 .377 .73 r
.57976 .48097 m .60006 .48433 L .59109 .50924 L p F P
0 0 0 r
s
.266 .377 .73 r
.60949 .51221 m .59109 .50924 L .60006 .48433 L p F P
0 0 0 r
s
.273 .391 .758 r
.59109 .50924 m .60949 .51221 L .59575 .53651 L p F P
0 0 0 r
s
.83 .24 .1 r
.73203 .33157 m
.71916 .30548 L
s
.73682 .27289 m
.71916 .30548 L
s
.564 .169 .078 r
.40344 .53701 m .40704 .52746 L .39358 .50163 L p F P
0 0 0 r
s
.83 .24 .1 r
.39427 .50296 m
.39453 .50223 L
s
.285 .413 .805 r
.51195 .54938 m .52555 .55148 L .51962 .57509 L p F P
0 0 0 r
s
.24 .35 .67 r
.51901 .575 m
.5193 .57401 L
s
.285 .413 .805 r
.51962 .57509 m .50917 .57351 L .51195 .54938 L p F P
0 0 0 r
s
.245 .342 .659 r
.49716 .41774 m .51993 .42165 L .51932 .44536 L p F P
0 0 0 r
s
.245 .342 .659 r
.54125 .44905 m .51932 .44536 L .51993 .42165 L p F P
0 0 0 r
s
.273 .391 .758 r
.59575 .53651 m .57963 .53397 L .59109 .50924 L p F P
0 0 0 r
s
.279 .403 .783 r
.56344 .53141 m .57963 .53397 L .56605 .55773 L p F P
0 0 0 r
s
.279 .403 .783 r
.56605 .55773 m .5526 .55566 L .56344 .53141 L p F P
0 0 0 r
s
.83 .24 .1 r
.72086 .38877 m
.73857 .35813 L
s
.72034 .41457 m
.72086 .38877 L
s
.231 .318 .61 r
.42774 .38427 m .45102 .38834 L .4512 .40984 L p F P
0 0 0 r
s
.24 .35 .67 r
.45103 .38947 m
.45156 .38956 L
s
.231 .318 .61 r
.47425 .4138 m .4512 .40984 L .45102 .38834 L p F P
0 0 0 r
s
.257 .361 .697 r
.54125 .44905 m .56306 .45273 L .55934 .4776 L p F P
0 0 0 r
s
.257 .361 .697 r
.57976 .48097 m .55934 .4776 L .56306 .45273 L p F P
0 0 0 r
s
.285 .413 .805 r
.4983 .54728 m .51195 .54938 L .50917 .57351 L p F P
0 0 0 r
s
.285 .413 .805 r
.50917 .57351 m .4987 .57193 L .4983 .54728 L p F P
0 0 0 r
s
.83 .24 .1 r
.50588 .17302 m
.4935 .20796 L
s
.4935 .20796 m
.46607 .21667 L
s
.66589 .20583 m
.63515 .19001 L
s
.63515 .19001 m
.60261 .17845 L
s
.279 .403 .783 r
.54717 .52884 m .56344 .53141 L .5526 .55566 L p F P
0 0 0 r
s
.279 .403 .783 r
.5526 .55566 m .5391 .55357 L .54717 .52884 L p F P
0 0 0 r
s
.24 .35 .67 r
.32801 .5679 m
.32161 .59236 L
s
.27451 .58554 m
.32161 .59236 L
s
.266 .377 .73 r
.59109 .50924 m .57259 .50625 L .57976 .48097 L p F P
0 0 0 r
s
.273 .391 .758 r
.57259 .50625 m .59109 .50924 L .57963 .53397 L p F P
0 0 0 r
s
.24 .35 .67 r
.5758 .53336 m
.57732 .5249 L
s
.226 .065 .035 r
.37568 .45076 m .38024 .43689 L .37641 .41274 L p F P
0 0 0 r
s
.294 .087 .046 r
.38024 .43689 m .37568 .45076 L .38301 .47579 L p F P
0 0 0 r
s
.273 .391 .758 r
.57963 .53397 m .56344 .53141 L .57259 .50625 L p F P
0 0 0 r
s
.266 .377 .73 r
.55934 .4776 m .57976 .48097 L .57259 .50625 L p F P
0 0 0 r
s
.83 .24 .1 r
.4427 .23037 m
.43177 .26403 L
s
.43177 .26403 m
.41386 .28238 L
s
.285 .413 .805 r
.4846 .54516 m .4983 .54728 L .4987 .57193 L p F P
0 0 0 r
s
.285 .413 .805 r
.4987 .57193 m .48819 .57034 L .4846 .54516 L p F P
0 0 0 r
s
.83 .24 .1 r
.69376 .22537 m
.66589 .20583 L
s
.245 .342 .659 r
.47425 .4138 m .49716 .41774 L .49725 .44164 L p F P
0 0 0 r
s
.245 .342 .659 r
.51932 .44536 m .49725 .44164 L .49716 .41774 L p F P
0 0 0 r
s
.24 .35 .67 r
.26588 .33319 m
.3131 .34158 L
s
.3131 .34158 m
.31125 .36507 L
s
.83 .24 .1 r
.60261 .17845 m
.56943 .17158 L
s
.24 .35 .67 r
.37515 .57489 m
.4217 .58179 L
s
.257 .361 .697 r
.51932 .44536 m .54125 .44905 L .53882 .47421 L p F P
0 0 0 r
s
.257 .361 .697 r
.55934 .4776 m .53882 .47421 L .54125 .44905 L p F P
0 0 0 r
s
.231 .318 .61 r
.40432 .38018 m .42774 .38427 L .428 .40585 L p F P
0 0 0 r
s
.24 .35 .67 r
.40537 .3815 m
.40556 .38153 L
s
.42776 .38541 m
.42898 .38562 L
s
.40537 .3815 m
.40537 .38133 L
s
.231 .318 .61 r
.4512 .40984 m .428 .40585 L .42774 .38427 L p F P
0 0 0 r
s
.24 .35 .67 r
.17851 .57164 m
.17496 .59053 L
s
.279 .403 .783 r
.53084 .52626 m .54717 .52884 L .5391 .55357 L p F P
0 0 0 r
s
.279 .403 .783 r
.5391 .55357 m .52555 .55148 L .53084 .52626 L p F P
0 0 0 r
s
.285 .413 .805 r
.47085 .54304 m .4846 .54516 L .48819 .57034 L p F P
0 0 0 r
s
.83 .24 .1 r
.46568 .58421 m
.46661 .58215 L
s
.285 .413 .805 r
.48819 .57034 m .47765 .56875 L .47085 .54304 L p F P
0 0 0 r
s
.83 .24 .1 r
.68137 .48881 m
.69566 .4676 L
s
.71286 .43869 m
.69566 .4676 L
s
.273 .391 .758 r
.55399 .50325 m .57259 .50625 L .56344 .53141 L p F P
0 0 0 r
s
.273 .391 .758 r
.56344 .53141 m .54717 .52884 L .55399 .50325 L p F P
0 0 0 r
s
.762 .227 .101 r
.42929 .53663 m .42611 .54459 L .44333 .56992 L p F P
0 0 0 r
s
.24 .35 .67 r
.4217 .58179 m
.42919 .55267 L
s
.762 .227 .101 r
.44333 .56992 m .44586 .56395 L .42929 .53663 L p F P
0 0 0 r
s
.266 .377 .73 r
.57259 .50625 m .55399 .50325 L .55934 .4776 L p F P
0 0 0 r
s
.672 .201 .091 r
.4107 .51776 m .40704 .52746 L .42297 .55245 L p F P
0 0 0 r
s
.672 .201 .091 r
.42297 .55245 m .42611 .54459 L .4107 .51776 L p F P
0 0 0 r
s
.266 .377 .73 r
.53882 .47421 m .55934 .4776 L .55399 .50325 L p F P
0 0 0 r
s
.83 .24 .1 r
.54167 .58049 m
.57421 .57941 L
s
.58855 .55311 m
.57421 .57941 L
s
.285 .413 .805 r
.45705 .54091 m .47085 .54304 L .47765 .56875 L p F P
0 0 0 r
s
.285 .413 .805 r
.47765 .56875 m .46708 .56716 L .45705 .54091 L p F P
0 0 0 r
s
.279 .403 .783 r
.51443 .52367 m .53084 .52626 L .52555 .55148 L p F P
0 0 0 r
s
.24 .35 .67 r
.52494 .55139 m
.52515 .55048 L
s
.279 .403 .783 r
.52555 .55148 m .51195 .54938 L .51443 .52367 L p F P
0 0 0 r
s
.245 .342 .659 r
.4512 .40984 m .47425 .4138 L .47505 .43789 L p F P
0 0 0 r
s
.245 .342 .659 r
.49725 .44164 m .47505 .43789 L .47425 .4138 L p F P
0 0 0 r
s
.257 .361 .697 r
.49725 .44164 m .51932 .44536 L .51817 .47081 L p F P
0 0 0 r
s
.257 .361 .697 r
.53882 .47421 m .51817 .47081 L .51932 .44536 L p F P
0 0 0 r
s
.294 .087 .046 r
.38301 .47579 m .38738 .463 L .38024 .43689 L p F P
0 0 0 r
s
.433 .13 .063 r
.38738 .463 m .38301 .47579 L .39358 .50163 L p F P
0 0 0 r
s
.83 .24 .1 r
.39335 .50025 m
.39453 .50223 L
s
.273 .391 .758 r
.53531 .50023 m .55399 .50325 L .54717 .52884 L p F P
0 0 0 r
s
.273 .391 .758 r
.54717 .52884 m .53084 .52626 L .53531 .50023 L p F P
0 0 0 r
s
.231 .318 .61 r
.38074 .37606 m .40432 .38018 L .40466 .40184 L p F P
0 0 0 r
s
.24 .35 .67 r
.40433 .38132 m
.40537 .3815 L
s
.231 .318 .61 r
.428 .40585 m .40466 .40184 L .40432 .38018 L p F P
0 0 0 r
s
.83 .24 .1 r
.402 .30468 m
.39196 .33677 L
s
.38691 .36202 m
.39196 .33677 L
s
.71772 .24798 m
.69376 .22537 L
s
.154 .045 .022 r
.37641 .41274 m .38118 .39781 L .38074 .37606 L p F P
0 0 0 r
s
.83 .24 .1 r
.38085 .38127 m
.38205 .37747 L
s
.24 .35 .67 r
.38077 .3772 m
.382 .37742 L
s
.3586 .37334 m
.3804 .37714 L
s
.226 .065 .035 r
.38118 .39781 m .37641 .41274 L .38024 .43689 L p F P
0 0 0 r
s
.285 .413 .805 r
.44319 .53877 m .45705 .54091 L .46708 .56716 L p F P
0 0 0 r
s
.285 .413 .805 r
.46708 .56716 m .45649 .56556 L .44319 .53877 L p F P
0 0 0 r
s
.83 .24 .1 r
.46661 .58215 m
.47463 .56431 L
s
.266 .377 .73 r
.55399 .50325 m .53531 .50023 L .53882 .47421 L p F P
0 0 0 r
s
.279 .403 .783 r
.49795 .52107 m .51443 .52367 L .51195 .54938 L p F P
0 0 0 r
s
.279 .403 .783 r
.51195 .54938 m .4983 .54728 L .49795 .52107 L p F P
0 0 0 r
s
.83 .24 .1 r
.61879 .54613 m
.64465 .5336 L
s
.6607 .50615 m
.64465 .5336 L
s
.56943 .17158 m
.53678 .16971 L
s
.266 .377 .73 r
.51817 .47081 m .53882 .47421 L .53531 .50023 L p F P
0 0 0 r
s
.24 .35 .67 r
.53492 .50023 m
.53499 .49968 L
s
.5303 .52618 m
.53492 .50023 L
s
.53492 .50023 m
.5353 .50029 L
s
.564 .169 .078 r
.39764 .49026 m .39358 .50163 L .40704 .52746 L p F P
0 0 0 r
s
.564 .169 .078 r
.40704 .52746 m .4107 .51776 L .39764 .49026 L p F P
0 0 0 r
s
.24 .35 .67 r
.28028 .56083 m
.27451 .58554 L
s
.22681 .57863 m
.27451 .58554 L
s
.285 .413 .805 r
.42929 .53663 m .44319 .53877 L .45649 .56556 L p F P
0 0 0 r
s
.285 .413 .805 r
.45649 .56556 m .44586 .56395 L .42929 .53663 L p F P
0 0 0 r
s
.83 .24 .1 r
.44138 .55315 m
.44361 .5478 L
s
.24 .35 .67 r
.42919 .55267 m
.43856 .5541 L
s
.433 .13 .063 r
.39358 .50163 m .39764 .49026 L .38738 .463 L p F P
0 0 0 r
s
.273 .391 .758 r
.51653 .4972 m .53531 .50023 L .53084 .52626 L p F P
0 0 0 r
s
.273 .391 .758 r
.53084 .52626 m .51443 .52367 L .51653 .4972 L p F P
0 0 0 r
s
.245 .342 .659 r
.428 .40585 m .4512 .40984 L .45271 .43413 L p F P
0 0 0 r
s
.245 .342 .659 r
.47505 .43789 m .45271 .43413 L .4512 .40984 L p F P
0 0 0 r
s
.279 .403 .783 r
.48139 .51846 m .49795 .52107 L .4983 .54728 L p F P
0 0 0 r
s
.279 .403 .783 r
.4983 .54728 m .4846 .54516 L .48139 .51846 L p F P
0 0 0 r
s
.24 .35 .67 r
.21806 .32469 m
.26588 .33319 L
s
.26588 .33319 m
.2633 .3567 L
s
.257 .361 .697 r
.47505 .43789 m .49725 .44164 L .49741 .46738 L p F P
0 0 0 r
s
.257 .361 .697 r
.51817 .47081 m .49741 .46738 L .49725 .44164 L p F P
0 0 0 r
s
.24 .35 .67 r
.38221 .54552 m
.37515 .57489 L
s
.32801 .5679 m
.37515 .57489 L
s
.266 .377 .73 r
.53531 .50023 m .51653 .4972 L .51817 .47081 L p F P
0 0 0 r
s
.231 .318 .61 r
.40466 .40184 m .38118 .39781 L .38074 .37606 L p F P
0 0 0 r
s
.83 .24 .1 r
.3824 .37635 m
.38326 .37362 L
s
.266 .377 .73 r
.49741 .46738 m .51817 .47081 L .51653 .4972 L p F P
0 0 0 r
s
.83 .24 .1 r
.73857 .35813 m
.73203 .33157 L
s
.7502 .29923 m
.73203 .33157 L
s
.273 .391 .758 r
.49765 .49415 m .51653 .4972 L .51443 .52367 L p F P
0 0 0 r
s
.273 .391 .758 r
.51443 .52367 m .49795 .52107 L .49765 .49415 L p F P
0 0 0 r
s
.279 .403 .783 r
.46476 .51583 m .48139 .51846 L .4846 .54516 L p F P
0 0 0 r
s
.279 .403 .783 r
.4846 .54516 m .47085 .54304 L .46476 .51583 L p F P
0 0 0 r
s
.672 .201 .091 r
.41442 .50788 m .4107 .51776 L .42611 .54459 L p F P
0 0 0 r
s
.672 .201 .091 r
.42611 .54459 m .42929 .53663 L .41442 .50788 L p F P
0 0 0 r
s
.24 .35 .67 r
.31125 .36507 m
.3586 .37334 L
s
.3586 .37334 m
.35602 .40217 L
s
.266 .377 .73 r
.51653 .4972 m .49765 .49415 L .49741 .46738 L p F P
0 0 0 r
s
.245 .342 .659 r
.40466 .40184 m .428 .40585 L .43024 .43034 L p F P
0 0 0 r
s
.245 .342 .659 r
.45271 .43413 m .43024 .43034 L .428 .40585 L p F P
0 0 0 r
s
.257 .361 .697 r
.45271 .43413 m .47505 .43789 L .47654 .46393 L p F P
0 0 0 r
s
.257 .361 .697 r
.49741 .46738 m .47654 .46393 L .47505 .43789 L p F P
0 0 0 r
s
.83 .24 .1 r
.50789 .57539 m
.54167 .58049 L
s
.55534 .55402 m
.54167 .58049 L
s
.47794 .18153 m
.46607 .21667 L
s
.46607 .21667 m
.4427 .23037 L
s
.279 .403 .783 r
.44806 .5132 m .46476 .51583 L .47085 .54304 L p F P
0 0 0 r
s
.279 .403 .783 r
.47085 .54304 m .45705 .54091 L .44806 .5132 L p F P
0 0 0 r
s
.226 .065 .035 r
.38024 .43689 m .3849 .42269 L .38118 .39781 L p F P
0 0 0 r
s
.294 .087 .046 r
.3849 .42269 m .38024 .43689 L .38738 .463 L p F P
0 0 0 r
s
.273 .391 .758 r
.47867 .49108 m .49765 .49415 L .49795 .52107 L p F P
0 0 0 r
s
.273 .391 .758 r
.49795 .52107 m .48139 .51846 L .47867 .49108 L p F P
0 0 0 r
s
.266 .377 .73 r
.47654 .46393 m .49741 .46738 L .49765 .49415 L p F P
0 0 0 r
s
.24 .35 .67 r
.42919 .55267 m
.43087 .54476 L
s
.43087 .54476 m
.43117 .54333 L
s
.38221 .54552 m
.42919 .55267 L
s
.83 .24 .1 r
.73682 .27289 m
.71772 .24798 L
s
.43581 .54175 m
.44361 .5478 L
s
.71286 .43869 m
.72034 .41457 L
s
.73828 .38411 m
.72034 .41457 L
s
.24 .35 .67 r
.23195 .55367 m
.22681 .57863 L
s
.17851 .57164 m
.22681 .57863 L
s
.266 .377 .73 r
.49765 .49415 m .47867 .49108 L .47654 .46393 L p F P
0 0 0 r
s
.279 .403 .783 r
.43128 .51055 m .44806 .5132 L .45705 .54091 L p F P
0 0 0 r
s
.279 .403 .783 r
.45705 .54091 m .44319 .53877 L .43128 .51055 L p F P
0 0 0 r
s
.83 .24 .1 r
.53678 .16971 m
.50588 .17302 L
s
.245 .342 .659 r
.38118 .39781 m .40466 .40184 L .40764 .42653 L p F P
0 0 0 r
s
.245 .342 .659 r
.43024 .43034 m .40764 .42653 L .40466 .40184 L p F P
0 0 0 r
s
.257 .361 .697 r
.43024 .43034 m .45271 .43413 L .45554 .46046 L p F P
0 0 0 r
s
.24 .35 .67 r
.44688 .4507 m
.44742 .45079 L
s
.44688 .4507 m
.44693 .45021 L
s
.257 .361 .697 r
.47654 .46393 m .45554 .46046 L .45271 .43413 L p F P
0 0 0 r
s
.273 .391 .758 r
.4596 .488 m .47867 .49108 L .48139 .51846 L p F P
0 0 0 r
s
.273 .391 .758 r
.48139 .51846 m .46476 .51583 L .4596 .488 L p F P
0 0 0 r
s
.24 .35 .67 r
.21806 .32469 m
.21474 .34823 L
s
.33463 .53828 m
.32801 .5679 L
s
.28028 .56083 m
.32801 .5679 L
s
.83 .24 .1 r
.42452 .24869 m
.41386 .28238 L
s
.41386 .28238 m
.402 .30468 L
s
.564 .169 .078 r
.40179 .47867 m .39764 .49026 L .4107 .51776 L p F P
0 0 0 r
s
.564 .169 .078 r
.4107 .51776 m .41442 .50788 L .40179 .47867 L p F P
0 0 0 r
s
.266 .377 .73 r
.45554 .46046 m .47654 .46393 L .47867 .49108 L p F P
0 0 0 r
s
.279 .403 .783 r
.41442 .50788 m .43128 .51055 L .44319 .53877 L p F P
0 0 0 r
s
.279 .403 .783 r
.44319 .53877 m .42929 .53663 L .41442 .50788 L p F P
0 0 0 r
s
.294 .087 .046 r
.38738 .463 m .39184 .44995 L .3849 .42269 L p F P
0 0 0 r
s
.433 .13 .063 r
.39184 .44995 m .38738 .463 L .39764 .49026 L p F P
0 0 0 r
s
.24 .35 .67 r
.35602 .40217 m
.38079 .4064 L
s
.83 .24 .1 r
.47463 .56431 m
.50789 .57539 L
s
.52082 .54868 m
.50789 .57539 L
s
.266 .377 .73 r
.47867 .49108 m .4596 .488 L .45554 .46046 L p F P
0 0 0 r
s
.83 .24 .1 r
.44361 .5478 m
.455 .52041 L
s
.44361 .5478 m
.47463 .56431 L
s
.273 .391 .758 r
.44043 .48491 m .4596 .488 L .46476 .51583 L p F P
0 0 0 r
s
.273 .391 .758 r
.46476 .51583 m .44806 .5132 L .44043 .48491 L p F P
0 0 0 r
s
.433 .13 .063 r
.39764 .49026 m .40179 .47867 L .39184 .44995 L p F P
0 0 0 r
s
.83 .24 .1 r
.6607 .50615 m
.68137 .48881 L
s
.69846 .45999 m
.68137 .48881 L
s
.24 .35 .67 r
.2633 .3567 m
.31125 .36507 L
s
.31125 .36507 m
.3081 .394 L
s
.257 .361 .697 r
.40764 .42653 m .43024 .43034 L .43443 .45698 L p F P
0 0 0 r
s
.257 .361 .697 r
.45554 .46046 m .43443 .45698 L .43024 .43034 L p F P
0 0 0 r
s
.245 .342 .659 r
.40764 .42653 m .3849 .42269 L .38118 .39781 L p F P
0 0 0 r
s
.24 .35 .67 r
.38079 .4064 m
.38212 .40663 L
s
.83 .24 .1 r
.3839 .4052 m
.38906 .38925 L
s
.38363 .40605 m
.3839 .4052 L
s
.48678 .53729 m
.47463 .56431 L
s
.266 .377 .73 r
.43443 .45698 m .45554 .46046 L .4596 .488 L p F P
0 0 0 r
s
.83 .24 .1 r
.58855 .55311 m
.61879 .54613 L
s
.6344 .51866 m
.61879 .54613 L
s
.24 .35 .67 r
.38892 .51249 m
.41669 .51684 L
s
.41669 .51684 m
.4182 .51708 L
s
.38892 .51249 m
.38221 .54552 L
s
.33463 .53828 m
.38221 .54552 L
s
.266 .377 .73 r
.4596 .488 m .44043 .48491 L .43443 .45698 L p F P
0 0 0 r
s
.273 .391 .758 r
.42116 .48179 m .44043 .48491 L .44806 .5132 L p F P
0 0 0 r
s
.83 .24 .1 r
.42048 .51628 m
.42082 .51539 L
s
.273 .391 .758 r
.44806 .5132 m .43128 .51055 L .42116 .48179 L p F P
0 0 0 r
s
.83 .24 .1 r
.39698 .33009 m
.38691 .36202 L
s
.38691 .36202 m
.38906 .38925 L
s
.24 .35 .67 r
.183 .54642 m
.17851 .57164 L
s
.257 .361 .697 r
.3849 .42269 m .40764 .42653 L .41319 .45347 L p F P
0 0 0 r
s
.24 .35 .67 r
.39979 .44288 m
.40017 .43931 L
s
.39979 .44288 m
.40411 .44359 L
s
.257 .361 .697 r
.43443 .45698 m .41319 .45347 L .40764 .42653 L p F P
0 0 0 r
s
.266 .377 .73 r
.41319 .45347 m .43443 .45698 L .44043 .48491 L p F P
0 0 0 r
s
.24 .35 .67 r
.28644 .53094 m
.28028 .56083 L
s
.23195 .55367 m
.28028 .56083 L
s
.273 .391 .758 r
.40179 .47867 m .42116 .48179 L .43128 .51055 L p F P
0 0 0 r
s
.273 .391 .758 r
.43128 .51055 m .41442 .50788 L .40179 .47867 L p F P
0 0 0 r
s
.83 .24 .1 r
.42082 .51539 m
.42715 .49894 L
s
.266 .377 .73 r
.44043 .48491 m .42116 .48179 L .41319 .45347 L p F P
0 0 0 r
s
.83 .24 .1 r
.7502 .29923 m
.73682 .27289 L
s
.24 .35 .67 r
.3081 .394 m
.35602 .40217 L
s
.35602 .40217 m
.3521 .43495 L
s
.83 .24 .1 r
.73857 .35813 m
.75714 .32601 L
s
.73828 .38411 m
.73857 .35813 L
s
.24 .35 .67 r
.21474 .34823 m
.2633 .3567 L
s
.2633 .3567 m
.25957 .38571 L
s
.257 .361 .697 r
.41319 .45347 m .39184 .44995 L .3849 .42269 L p F P
0 0 0 r
s
.24 .35 .67 r
.38636 .44064 m
.3891 .4411 L
s
.3521 .43495 m
.38636 .44064 L
s
.83 .24 .1 r
.39127 .4388 m
.39857 .41721 L
s
.3907 .4405 m
.39127 .4388 L
s
.50588 .17302 m
.47794 .18153 L
s
.266 .377 .73 r
.39184 .44995 m .41319 .45347 L .42116 .48179 L p F P
0 0 0 r
s
.266 .377 .73 r
.42116 .48179 m .40179 .47867 L .39184 .44995 L p F P
0 0 0 r
s
.83 .24 .1 r
.3993 .46519 m
.40463 .47407 L
s
.24 .35 .67 r
.39489 .47761 m
.40069 .47855 L
s
.40069 .47855 m
.40093 .47859 L
s
.83 .24 .1 r
.40337 .47758 m
.40463 .47407 L
s
.40332 .47772 m
.40337 .47758 L
s
.24 .35 .67 r
.39489 .47761 m
.3965 .46622 L
s
.83 .24 .1 r
.45417 .19509 m
.4427 .23037 L
s
.4427 .23037 m
.42452 .24869 L
s
.24 .35 .67 r
.38892 .51249 m
.39489 .47761 L
s
.34109 .50499 m
.38892 .51249 L
s
.34109 .50499 m
.33463 .53828 L
s
.28644 .53094 m
.33463 .53828 L
s
.34703 .46988 m
.39489 .47761 L
s
.83 .24 .1 r
.69846 .45999 m
.71286 .43869 L
s
.73088 .40837 m
.71286 .43869 L
s
.24 .35 .67 r
.23764 .52352 m
.23195 .55367 L
s
.183 .54642 m
.23195 .55367 L
s
.83 .24 .1 r
.55534 .55402 m
.58855 .55311 L
s
.60358 .52553 m
.58855 .55311 L
s
.24 .35 .67 r
.25957 .38571 m
.3081 .394 L
s
.3081 .394 m
.3038 .42692 L
s
.83 .24 .1 r
.41253 .27104 m
.402 .30468 L
s
.402 .30468 m
.39698 .33009 L
s
.41522 .44453 m
.40463 .47407 L
s
.40463 .47407 m
.42715 .49894 L
s
.24 .35 .67 r
.3038 .42692 m
.3521 .43495 L
s
.3521 .43495 m
.34703 .46988 L
s
.21474 .34823 m
.21042 .37733 L
s
.83 .24 .1 r
.6344 .51866 m
.6607 .50615 L
s
.67752 .47737 m
.6607 .50615 L
s
.24 .35 .67 r
.34703 .46988 m
.34109 .50499 L
s
.29265 .4974 m
.34109 .50499 L
s
.29265 .4974 m
.28644 .53094 L
s
.23764 .52352 m
.28644 .53094 L
s
.83 .24 .1 r
.39931 .35756 m
.38906 .38925 L
s
.38906 .38925 m
.39857 .41721 L
s
.24 .35 .67 r
.29855 .46205 m
.34703 .46988 L
s
.83 .24 .1 r
.75714 .32601 m
.7502 .29923 L
s
.24 .35 .67 r
.18822 .51599 m
.183 .54642 L
s
.21042 .37733 m
.25957 .38571 L
s
.25957 .38571 m
.25487 .41879 L
s
.83 .24 .1 r
.52082 .54868 m
.55534 .55402 L
s
.56968 .52626 m
.55534 .55402 L
s
.47794 .18153 m
.45417 .19509 L
s
.24 .35 .67 r
.25487 .41879 m
.3038 .42692 L
s
.3038 .42692 m
.29855 .46205 L
s
.83 .24 .1 r
.43837 .46981 m
.42715 .49894 L
s
.42715 .49894 m
.455 .52041 L
s
.73088 .40837 m
.73828 .38411 L
s
.75711 .35217 m
.73828 .38411 L
s
.24 .35 .67 r
.29855 .46205 m
.29265 .4974 L
s
.24359 .48971 m
.29265 .4974 L
s
.24359 .48971 m
.23764 .52352 L
s
.18822 .51599 m
.23764 .52352 L
s
.83 .24 .1 r
.43571 .21335 m
.42452 .24869 L
s
.42452 .24869 m
.41253 .27104 L
s
.24 .35 .67 r
.24944 .45412 m
.29855 .46205 L
s
.83 .24 .1 r
.48678 .53729 m
.52082 .54868 L
s
.53438 .52065 m
.52082 .54868 L
s
.46695 .49167 m
.455 .52041 L
s
.455 .52041 m
.48678 .53729 L
s
.67752 .47737 m
.69846 .45999 L
s
.7164 .42976 m
.69846 .45999 L
s
.24 .35 .67 r
.21042 .37733 m
.20532 .41055 L
s
.83 .24 .1 r
.49952 .50893 m
.48678 .53729 L
s
.60358 .52553 m
.6344 .51866 L
s
.65078 .48984 m
.6344 .51866 L
s
.24 .35 .67 r
.20532 .41055 m
.25487 .41879 L
s
.25487 .41879 m
.24944 .45412 L
s
.83 .24 .1 r
.40753 .29659 m
.39698 .33009 L
s
.39698 .33009 m
.39931 .35756 L
s
.40917 .38583 m
.39857 .41721 L
s
.39857 .41721 m
.41522 .44453 L
s
.24 .35 .67 r
.24944 .45412 m
.24359 .48971 L
s
.19389 .48192 m
.24359 .48971 L
s
.19389 .48192 m
.18822 .51599 L
s
.1997 .44609 m
.24944 .45412 L
s
.83 .24 .1 r
.75711 .35217 m
.75714 .32601 L
s
.45417 .19509 m
.43571 .21335 L
s
.24 .35 .67 r
.20532 .41055 m
.1997 .44609 L
s
.1997 .44609 m
.19389 .48192 L
s
.83 .24 .1 r
.7164 .42976 m
.73088 .40837 L
s
.74981 .37655 m
.73088 .40837 L
s
.56968 .52626 m
.60358 .52553 L
s
.61937 .49659 m
.60358 .52553 L
s
.42358 .23572 m
.41253 .27104 L
s
.41253 .27104 m
.40753 .29659 L
s
.42634 .41353 m
.41522 .44453 L
s
.41522 .44453 m
.43837 .46981 L
s
.65078 .48984 m
.67752 .47737 L
s
.69518 .44716 m
.67752 .47737 L
s
.41006 .32428 m
.39931 .35756 L
s
.39931 .35756 m
.40917 .38583 L
s
.53438 .52065 m
.56968 .52626 L
s
.58474 .4971 m
.56968 .52626 L
s
.45016 .43921 m
.43837 .46981 L
s
.43837 .46981 m
.46695 .49167 L
s
.74981 .37655 m
.75711 .35217 L
s
.43571 .21335 m
.42358 .23572 L
s
.49952 .50893 m
.53438 .52065 L
s
.54862 .49122 m
.53438 .52065 L
s
.47951 .46149 m
.46695 .49167 L
s
.46695 .49167 m
.49952 .50893 L
s
.69518 .44716 m
.7164 .42976 L
s
.73524 .39801 m
.7164 .42976 L
s
.51291 .47914 m
.49952 .50893 L
s
.61937 .49659 m
.65078 .48984 L
s
.66799 .45956 m
.65078 .48984 L
s
.41862 .2614 m
.40753 .29659 L
s
.40753 .29659 m
.41006 .32428 L
s
.42031 .35287 m
.40917 .38583 L
s
.40917 .38583 m
.42634 .41353 L
s
.73524 .39801 m
.74981 .37655 L
s
.58474 .4971 m
.61937 .49659 L
s
.63595 .46617 m
.61937 .49659 L
s
.42358 .23572 m
.41862 .2614 L
s
.43803 .38094 m
.42634 .41353 L
s
.42634 .41353 m
.45016 .43921 L
s
.66799 .45956 m
.69518 .44716 L
s
.71375 .4154 m
.69518 .44716 L
s
.42137 .28931 m
.41006 .32428 L
s
.41006 .32428 m
.42031 .35287 L
s
.54862 .49122 m
.58474 .4971 L
s
.60056 .46646 m
.58474 .4971 L
s
.46254 .40704 m
.45016 .43921 L
s
.45016 .43921 m
.47951 .46149 L
s
.51291 .47914 m
.54862 .49122 L
s
.5636 .46026 m
.54862 .49122 L
s
.49271 .42975 m
.47951 .46149 L
s
.47951 .46149 m
.51291 .47914 L
s
.71375 .4154 m
.73524 .39801 L
s
.527 .44782 m
.51291 .47914 L
s
.63595 .46617 m
.66799 .45956 L
s
.68609 .42772 m
.66799 .45956 L
s
.41862 .2614 m
.42137 .28931 L
s
.43202 .3182 m
.42031 .35287 L
s
.42031 .35287 m
.43803 .38094 L
s
.60056 .46646 m
.63595 .46617 L
s
.65341 .43416 m
.63595 .46617 L
s
.45033 .34665 m
.43803 .38094 L
s
.43803 .38094 m
.46254 .40704 L
s
.68609 .42772 m
.71375 .4154 L
s
.42137 .28931 m
.43202 .3182 L
s
.5636 .46026 m
.60056 .46646 L
s
.61723 .43419 m
.60056 .46646 L
s
.47559 .37317 m
.46254 .40704 L
s
.46254 .40704 m
.49271 .42975 L
s
.527 .44782 m
.5636 .46026 L
s
.57937 .42767 m
.5636 .46026 L
s
.50661 .39633 m
.49271 .42975 L
s
.49271 .42975 m
.527 .44782 L
s
.54183 .41483 m
.527 .44782 L
s
.65341 .43416 m
.68609 .42772 L
s
.43202 .3182 m
.45033 .34665 L
s
.61723 .43419 m
.65341 .43416 L
s
.45033 .34665 m
.47559 .37317 L
s
.57937 .42767 m
.61723 .43419 L
s
.47559 .37317 m
.50661 .39633 L
s
.54183 .41483 m
.57937 .42767 L
s
.50661 .39633 m
.54183 .41483 L
s
0 0 0 r
.25 Mabswid
.24028 .08168 m
.19793 .35868 L
s
.19793 .35868 m
.13045 .74993 L
s
.13045 .74993 m
.16861 .50547 L
s
.16861 .50547 m
.24028 .08168 L
s
.24028 .08168 m
.19793 .35868 L
s
.19793 .35868 m
.97075 .49223 L
s
.97075 .49223 m
.91053 .22236 L
s
.91053 .22236 m
.24028 .08168 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{500, 500},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40007d0001m2000`400?l00000o`00003oo`3ooooe
0?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3o
m^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40
oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?of
k_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3o
ool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^
m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?oo
o`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd
0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo
003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0
ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool0
0?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03o
m^h10?ooo`00o`3om^kd0?ofkP40oooo001g0?ofkP<00000o`3om^ij0?ofkP40oooo001g0?ofkP03
0000003om^h0ooK^00D00000o`3om^ie0?ofkP40oooo001g0?ofkP030000003om^h0ooK^00D0ooK^
1000003o0?ofkW40ooK^0@3oool007L0ooK^00<000000?ofkP3om^h02@3om^h500000?l0ooK^K03o
m^h10?ooo`00MP3om^h00`000000ooK^0?ofkP0?0?ofkPD00000o`3om^iW0?ofkP40oooo001f0?of
kP030000003om^h0ooK^01@0ooK^1@00003o0?ofkV80ooK^0@3oool007H0ooK^00<000000?ofkP3o
m^h06@3om^h500000?l0ooK^G@3om^h10?ooo`00MP3om^h00`000000ooK^0?ofkP0N0?ofkP@00000
o`3om^iI0?ofkP40oooo001f0?ofkP030000003om^h0ooK^0280ooK^1@00003o0?ofkU@0ooK^0@3o
ool007H0ooK^00<000000?ofkP3om^h09`3om^h500000?l0ooK^C`3om^h10?ooo`00M@3om^h00`00
0000ooK^0?ofkP0]0?ofkPD00000o`3om^i:0?ofkP40oooo001e0?ofkP030000003om^h0ooK^0380
ooK^1@00003o0?ofkTD0ooK^0@3oool007D0ooK^00<000000?ofkP3om^h0=`3om^h400000?l0ooK^
@@3om^h10?ooo`00M@3om^h00`000000ooK^0?ofkP0k0?ofkPD00000o`3om^hl0?ofkP40oooo001e
0?ofkP030000003om^h0ooK^0400ooK^1@00003o0?ofkSL0ooK^0@3oool007D0ooK^00<000000?of
kP3om^h0A@3om^h500000?l0ooK^<P3om^h10?ooo`00M03om^h2000004`0ooK^1000003o0?ofkRh0
ooK^0@3oool007@0ooK^00<000000?ofkP3om^h0C`3om^h500000?l0ooK^:@3om^h10?ooo`00M03o
m^h00`000000ooK^0?ofkP1D0?ofkPD00000o`3om^hT0?ofkP40oooo001d0?ofkP030000003om^h0
ooK^05T0ooK^1@00003o0?ofkQl0ooK^0@3oool007@0ooK^00<000000?ofkP3om^h0GP3om^h50000
0?l0ooK^6P3om^h10?ooo`00M03om^h00`000000ooK^0?ofkP1S0?ofkP@00000o`3om^hF0?ofkP40
oooo001c0?ofkP800000J@3om^h500000?l0ooK^4@3om^h10?ooo`00L`3om^h00`000000ooK^0?of
kP1]0?ofkPD00000o`3om^h<0?ofkP40oooo001c0?ofkP030000003om^h0ooK^0780ooK^1@00003o
0?ofkPL0ooK^0@3oool007<0ooK^00<000000?ofkP3om^h0M`3om^h500000?l0ooK^0P3om^h10?oo
o`00L`3om^h00`000000ooK^0?ofkP1l0?ofkP@00000o@3om^h10?ooo`00L`3om^h00`000000ooK^
0?ofkP200?ofkPD00000n03om^h10?ooo`00LP3om^h2000008L0ooK^1@00003c0?ofkP40oooo001b
0?ofkP800000S03om^h500000>h0ooK^0@3oool00780ooK^00<000000?ofkP3om^h0T03om^h40000
0>X0ooK^0@3oool00780ooK^00<000000?ofkP3om^h0U03om^h500000>D0ooK^0@3oool00780ooK^
00<000000?ofkP3om^h0V@3om^h500000>00ooK^0@3oool00780ooK^00<000000?ofkP3om^h0WP3o
m^h500000=/0ooK^0@3oool00740ooK^0P00002U0?ofkPD00000eP3om^h10?ooo`00L@3om^h20000
0:X0ooK^1000003B0?ofkP40oooo001a0?ofkP800000[P3om^h500000<d0ooK^0@3oool00740ooK^
00<000000?ofkP3om^h0/P3om^h500000<P0ooK^0@3oool00740ooK^00<000000?ofkP3om^h0]`3o
m^h500000<<0ooK^0@3oool00740ooK^00<000000?ofkP3om^h0_03om^h500000;h0ooK^0@3oool0
0700ooK^0P0000330?ofkP@00000^P3om^h10?ooo`00L03om^h200000<L0ooK^1@00002e0?ofkP40
oooo001`0?ofkP800000c03om^h500000;00ooK^0@3oool00700ooK^00<000000?ofkP3om^h0d03o
m^h500000:/0ooK^0@3oool00700ooK^00<000000?ofkP3om^h0U@3om^h<0=@m6C@0ooK^1000002W
0?ofkP40oooo001`0?ofkP030000003om^h0ooK^08d0ooK^203D?AT30?ofkP030=@m6@3om^h0ooK^
00H0ooK^2P3D?AT^0?ofkPD00000XP3om^h10?ooo`00K`3om^h2000008X0ooK^1@3D?AT:0?ofkP03
0=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3D?AT00`3D?AT_0?ofkPD00000W@3om^h10?ooo`00
K`3om^h2000008H0ooK^103D?AT00`3om^h0e3dI0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00h0ooK^
00<0e3dI0?ofkP3om^h0103om^h40=@m6C00ooK^1@00002H0?ofkP40oooo001_0?ofkP800000P`3o
m^h30=@m6@@0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3o
m^h0ooK^00P0ooK^103D?ATa0?ofkPD00000T`3om^h10?ooo`00K`3om^h2000007l0ooK^103D?AT7
0?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0=
0?ofkP@0e3dI<P3om^h4000008l0ooK^0@3oool006l0ooK^00<000000?ofkP3om^h0O03om^h20=@m
6@/0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^
00l0ooK^00<0e3dI0?ofkP3D?AT00P3D?ATc0?ofkPD00000RP3om^h10?ooo`00K`3om^h00`000000
ooK^0?ofkP1j0?ofkP<0e3dI2`3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00h0
ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP030?ofkP<0e3dI=@3om^h5000008D0
ooK^0@3oool006h0ooK^0P00001j0?ofkP80e3dI00<0ooK^0=@m6@3om^h02`3om^h00`3D?AT0ooK^
0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^
0?ofkP060?ofkP@0e3dI=P3om^h500000800ooK^0@3oool006h0ooK^0P00001i0?ofkP050=@m6@3o
m^h0ooK^0?ofkP3D?AT0303om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00h0ooK^
00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP<0e3dI>03om^h5000007/0ooK^
0@3oool006h0ooK^0P00001g0?ofkP80e3dI103om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3o
m^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3o
m^h0ooK^00h0ooK^0P3D?ATk0?ofkP@00000M`3om^h10?ooo`00KP3om^h2000007D0ooK^0P3D?AT5
0?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP0>
0?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h03`3om^h30=@m6Cd0ooK^1@00001b
0?ofkP40oooo001^0?ofkP030000003om^h0ooK^0780ooK^0P3D?AT70?ofkP030=@m6@3om^h0ooK^
00T0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^
00l0ooK^00<0e3dI0?ofkP3om^h03`3om^h0103D?AT0ooK^0?ofkP3om^h20=@m6D00ooK^1@00001]
0?ofkP40oooo001^0?ofkP030000003om^h0ooK^0740ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D
?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D
?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h00`3om^h20=@m
6D<0ooK^1@00001X0?ofkP40oooo001]0?ofkP800000LP3om^h20=@m6@P0ooK^00<0e3dI0?ofkP3o
m^h02P3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3o
m^h03P3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00H0ooK^0P3D?AU60?ofkP@0
0000I03om^h10?ooo`00K@3om^h200000740ooK^0P3D?AT90?ofkP030=@m6@3om^h0ooK^00T0ooK^
00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00l0ooK^
00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP080?ofkP80e3dIB03om^h5000005l0ooK^
0@3oool006d0ooK^0P00001`0?ofkP030=@m6@3om^h0e3dI00T0ooK^00<0e3dI0?ofkP3om^h02@3o
m^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h03P3o
m^h00`3D?AT0ooK^0?ofkP0@0?ofkP030=@m6@3om^h0ooK^00X0ooK^0P3D?AU;0?ofkPD00000FP3o
m^h10?ooo`00K@3om^h2000006l0ooK^00@0e3dI0?ofkP3om^h0e3dI203om^h00`3D?AT0ooK^0?of
kP0:0?ofkP030=@m6@3om^h0ooK^00P0ooK^2`3D?AT80?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0
e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP80e3dICP3om^h5000005D0ooK^0@3o
ool006d0ooK^0P00001^0?ofkP040=@m6@3om^h0ooK^0=@m6@T0ooK^00<0e3dI0?ofkP3om^h02@3o
m^h0103D?AT0ooK^0?ofkP3om^h80=@m6@<0ooK^00<0e3dI0?ofkP3om^h01@3om^h:0=@m6A00ooK^
00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP80e3dID@3om^h500000500ooK^
0@3oool006d0ooK^00<000000?ofkP3om^h0K03om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00T0ooK^
00<0e3dI0?ofkP3om^h0203om^h50=@m6@X0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^
0=@m6@030=@m6@/0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP0A0?ofkP<0e3dI
E03om^h4000004`0ooK^0@3oool006`0ooK^0P00001]0?ofkP030=@m6@3om^h0ooK^0080ooK^00<0
e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP060?ofkP<0e3dI00<0ooK^0=@m6@3om^h0303o
m^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00@0ooK^103D?AT70?ofkP030=@m6@3o
m^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h0403om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI05L0ooK^
1@0000170?ofkP40oooo001/0?ofkP800000K03om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3o
m^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h0103om^h20=@m6@<0ooK^00<0e3dI0?ofkP3om^h0303o
m^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00P0ooK^103D?AT20?ofkP030=@m6@3o
m^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h04@3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3o
m^h0ooK^05T0ooK^1@0000120?ofkP40oooo001/0?ofkP800000J`3om^h00`3D?AT0ooK^0?ofkP03
0?ofkP030=@m6@3om^h0ooK^00L0ooK^00@0e3dI0?ofkP3om^h0ooK^0`3D?AT50?ofkP030=@m6@3o
m^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP@0e3dI403o
m^h00`3D?AT0ooK^0?ofkP0@0?ofkP030=@m6@3om^h0ooK^00@0ooK^0P3D?AUN0?ofkPD00000?@3o
m^h10?ooo`00K03om^h2000006X0ooK^0P3D?AT40?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI
0?ofkP3D?AT00P3D?AT80?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h03@3om^h0
0`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0e3dI0080e3dI3@3om^h00`3D?AT0ooK^0?ofkP0@
0?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h0H03om^h5000003P0ooK^0@3oool0
06`0ooK^0P00001Z0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h01`3om^h20=@m
6@X0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^
00h0ooK^00<0e3dI0?ofkP3om^h00`3om^h30=@m6@T0ooK^00<0e3dI0?ofkP3om^h0403om^h00`3D
?AT0ooK^0?ofkP080?ofkP80e3dII@3om^h4000003@0ooK^0@3oool006`0ooK^00<000000?ofkP3o
m^h0J03om^h20=@m6@D0ooK^00<0e3dI0?ofkP3om^h01@3om^h30=@m6@/0ooK^00<0e3dI0?ofkP3o
m^h02`3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3o
m^h01P3om^h40=@m6@D0ooK^00<0e3dI0?ofkP3om^h0403om^h00`3D?AT0ooK^0?ofkP0:0?ofkP03
0=@m6@3om^h0ooK^06H0ooK^1@00000_0?ofkP40oooo001[0?ofkP800000JP3om^h20=@m6@@0ooK^
00<0e3dI0?ofkP3om^h0103om^h20=@m6@030?ofkP3D?AT0ooK^00/0ooK^00<0e3dI0?ofkP3om^h0
2`3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h0
2`3om^h30=@m6@030?ofkP3D?AT0ooK^0140ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^
0?ofkP1Z0?ofkP<00000;03om^h10?ooo`00J`3om^h2000006T0ooK^0P3D?AT50?ofkP030=@m6@3o
m^h0ooK^0080ooK^0P3D?AT30?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h02`3o
m^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h03P3o
m^h20=@m6A80ooK^00<0e3dI0?ofkP3om^h03@3om^h20=@m6F/0ooK^0P00000/0?ofkP40oooo001[
0?ofkP800000J@3om^h20=@m6@D0ooK^00<0e3dI0?ofkP3om^h00P3D?AT40?ofkP030=@m6@3om^h0
ooK^00X0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0
ooK^00h0ooK^00<0e3dI0?ofkP3om^h0403om^h30=@m6@l0ooK^00<0e3dI0?ofkP3om^h0403om^h0
0`3D?AT0ooK^0?ofkP1X0?ofkP800000;03om^h10?ooo`00J`3om^h2000006P0ooK^00<0e3dI0?of
kP3D?AT0103om^h0103D?AT0ooK^0=@m6@3D?AT60?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI
0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI
0?ofkP3om^h03`3om^h0103D?AT0ooK^0?ofkP3om^h20=@m6@d0ooK^00<0e3dI0?ofkP3om^h03`3o
m^h00`3D?AT0ooK^0=@m6@1X0?ofkP040000003om^h0ooK^000002/0ooK^0@3oool006/0ooK^0P00
001X0?ofkP80e3dI1@3om^h20=@m6@P0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?of
kP0;0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?of
kP0@0?ofkP030=@m6@3om^h0ooK^00<0ooK^0P3D?AT:0?ofkP030=@m6@3om^h0ooK^0100ooK^00@0
e3dI0?ofkP3om^h0e3dIIP3om^h01@000000ooK^0?ofkP3om^h0000002/0ooK^0@3oool006/0ooK^
0P00001W0?ofkP030=@m6@3om^h0e3dI00@0ooK^0P3D?AT80?ofkP030=@m6@3om^h0ooK^00X0ooK^
00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00h0ooK^
00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP060?ofkP80e3dI203om^h00`3D?AT0ooK^
0?ofkP0?0?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h0H`3om^h01@000000ooK^
0?ofkP3om^h0000002/0ooK^0@3oool006X0ooK^0P00001X0?ofkP030=@m6@3om^h0e3dI00<0ooK^
0P3D?AT90?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^
0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^
0?ofkP080?ofkP80e3dI1@3om^h00`3D?AT0ooK^0?ofkP0@0?ofkP030=@m6@3om^h0ooK^00<0ooK^
00<0e3dI0?ofkP3om^h0H@3om^h00`000000ooK^0?ofkP020?ofkP030000003om^h0ooK^02T0ooK^
0@3oool006X0ooK^0P00001W0?ofkP030=@m6@3om^h0e3dI00<0ooK^00<0e3dI0?ofkP3D?AT02@3o
m^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h03@3o
m^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h02`3o
m^h20=@m6@<0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3o
m^h0ooK^0600ooK^00<000000?ofkP3om^h00`3om^h00`000000ooK^0?ofkP0X0?ofkP40oooo001Z
0?ofkP800000I`3om^h00`3D?AT0ooK^0=@m6@020?ofkP040=@m6@3om^h0ooK^0=@m6@P0ooK^00<0
e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP080?ofkP/0e3dI1`3om^h00`3D?AT0ooK^0?of
kP0?0?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h03@3om^h30=@m6A80ooK^00<0
e3dI0?ofkP3om^h01P3om^h20=@m6El0ooK^00<000000?ofkP3om^h0103om^h00`000000ooK^0?of
kP0X0?ofkP40oooo001Z0?ofkP800000IP3om^h20=@m6@040?ofkP3D?AT0ooK^0=@m6@<0ooK^00<0
e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP090?ofkP040=@m6@3om^h0ooK^0?ofkPP0e3dI
0`3om^h00`3D?AT0ooK^0?ofkP050?ofkPX0e3dI3P3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m
6@3om^h0ooK^0100ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m
6@3om^h0ooK^05/0ooK^00<000000?ofkP3om^h01@3om^h00`000000ooK^0?ofkP0X0?ofkP40oooo
001Z0?ofkP800000IP3om^h00`3D?AT0ooK^0=@m6@020?ofkP040=@m6@3om^h0ooK^0=@m6@P0ooK^
00<0e3dI0?ofkP3om^h02@3om^h50=@m6@X0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^
0?ofkP050=@m6@T0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m
6@3om^h0e3dI0100ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP1J0?ofkP030000
003om^h0ooK^00D0ooK^00<000000?ofkP3om^h0:03om^h10?ooo`00JP3om^h2000006H0ooK^00D0
e3dI0?ofkP3D?AT0ooK^0=@m6@030?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h0
1@3om^h40=@m6@030?ofkP3D?AT0ooK^00`0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^
0?ofkP060?ofkPH0e3dI0P3om^h00`3D?AT0ooK^0?ofkP0@0?ofkP030=@m6@3om^h0ooK^00l0ooK^
00<0e3dI0?ofkP3om^h00P3D?AT=0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h0
F03om^h00`000000ooK^0?ofkP060?ofkP030000003om^h0ooK^02P0ooK^0@3oool006T0ooK^00<0
00000?ofkP000000I@3om^h20=@m6@030?ofkP3D?AT0e3dI00@0ooK^00<0e3dI0?ofkP3om^h01P3o
m^h00`3D?AT0ooK^0?ofkP020?ofkP<0e3dI103om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3o
m^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h0303om^h40=@m6A00ooK^00<0e3dI0?ofkP3om^h03`3o
m^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h03@3o
m^h00`3D?AT0ooK^0?ofkP1F0?ofkP030000003om^h0ooK^00P0ooK^00<000000?ofkP3om^h09`3o
m^h10?ooo`00J@3om^h2000006H0ooK^103D?AT40?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI
0?ofkP3D?AT00`3D?AT70?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h0303om^h0
0`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0e3dI0080e3dI3@3om^h00`3D?AT0ooK^0?ofkP0?
0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP0?
0?ofkP030=@m6@3om^h0ooK^05D0ooK^00<000000?ofkP3om^h0203om^h00`000000ooK^0?ofkP0W
0?ofkP40oooo001Y0?ofkP800000IP3om^h00`3D?AT0ooK^0=@m6@050?ofkP030=@m6@3om^h0ooK^
00H0ooK^0P3D?AT:0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D
?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00<0ooK^0`3D?AT90?ofkP030=@m6@3om^h0ooK^
00l0ooK^00<0e3dI0?ofkP3om^h01P3om^h20=@m6@P0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D
?AT0ooK^0=@m6@1E0?ofkP030000003om^h0ooK^00T0ooK^00<000000?ofkP3om^h09`3om^h10?oo
o`00J@3om^h2000006D0ooK^103D?AT50?ofkP030=@m6@3om^h0ooK^00@0ooK^0`3D?AT;0?ofkP03
0=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP03
0=@m6@3om^h0ooK^00H0ooK^103D?AT50?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3o
m^h0203om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3D
?AT0E03om^h00`000000ooK^0?ofkP0:0?ofkP030000003om^h0ooK^02L0ooK^0@3oool006T0ooK^
0P00001U0?ofkP<0e3dI1@3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0e3dI00`0ooK^
00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00h0ooK^
00<0e3dI0?ofkP3om^h02`3om^h30=@m6@030?ofkP3D?AT0ooK^0100ooK^00<0e3dI0?ofkP3om^h0
2P3om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00h0ooK^00D0e3dI0?ofkP3om^h0
ooK^0=@m6@1C0?ofkP030000003om^h0ooK^00/0ooK^00<000000?ofkP3om^h09P3om^h10?ooo`00
J@3om^h2000006D0ooK^0`3D?AT50?ofkP030=@m6@3om^h0ooK^0080ooK^0P3D?AT20?ofkP030=@m
6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m
6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h03P3om^h20=@m6A40ooK^00<0e3dI0?ofkP3om^h0
2`3om^h20=@m6@80ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m
6@3om^h0ooK^04l0ooK^00<000000?ofkP3om^h0303om^h00`000000ooK^0?ofkP0V0?ofkP40oooo
001X0?ofkP030000003om^h0000006@0ooK^103D?AT50?ofkP030=@m6@3om^h0ooK^0080e3dI103o
m^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h0303o
m^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00l0ooK^0`3D?AT>0?ofkP030=@m6@3o
m^h0ooK^00h0ooK^00<0e3dI0?ofkP3D?AT0403om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3o
m^h0ooK^04h0ooK^00<000000?ofkP3om^h03@3om^h00`000000ooK^0?ofkP0V0?ofkP40oooo001X
0?ofkP800000I@3om^h30=@m6@H0ooK^00<0e3dI0?ofkP3D?AT01@3om^h00`3D?AT0ooK^0?ofkP0:
0?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP0>
0?ofkP030=@m6@3om^h0ooK^00l0ooK^00@0e3dI0?ofkP3om^h0ooK^0P3D?AT<0?ofkP030=@m6@3o
m^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3o
m^h0ooK^04d0ooK^00<000000?ofkP3om^h03@3om^h00`000000ooK^0?ofkP0V0?ofkP40oooo001X
0?ofkP800000I@3om^h30=@m6@D0ooK^0`3D?AT60?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI
0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI
0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP030?ofkP80e3dI2@3om^h00`3D?AT0ooK^0?ofkP0@
0?ofkP80e3dI3`3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^04/0ooK^00<00000
0?ofkP3om^h03P3om^h00`000000ooK^0?ofkP0V0?ofkP40oooo001X0?ofkP800000I03om^h40=@m
6@D0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^
00/0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^
00l0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^
00l0ooK^00@0e3dI0?ofkP3om^h0e3dI3P3om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0
ooK^04X0ooK^00<000000?ofkP3om^h03`3om^h00`000000ooK^0?ofkP0U0?ofkP40oooo001X0?of
kP800000I03om^h30=@m6@D0ooK^0P3D?AT70?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?of
kP3om^h0303om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?of
kP3om^h03`3om^h00`3D?AT0ooK^0?ofkP070?ofkP80e3dI1@3om^h00`3D?AT0ooK^0?ofkP0@0?of
kP050=@m6@3om^h0ooK^0?ofkP3D?AT0303om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0
ooK^04T0ooK^00<000000?ofkP3om^h0403om^h00`000000ooK^0?ofkP0U0?ofkP40oooo001X0?of
kP800000I03om^h30=@m6@@0ooK^0P3D?AT80?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?of
kP3om^h02`3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?of
kP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP80e3dI0`3om^h00`3D?AT0ooK^0?ofkP0?0?of
kP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP090?of
kP030=@m6@3om^h0ooK^04L0ooK^00<000000?ofkP3om^h04@3om^h00`000000ooK^0?ofkP0U0?of
kP40oooo001W0?ofkP030000003om^h0000006<0ooK^1@3D?AT20?ofkP030=@m6@3om^h0e3dI00P0
ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP080?ofkQD0e3dI3P3om^h00`3D?AT0
ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00`0ooK^0`3D?ATB0?ofkP030=@m6@3om^h0ooK^00@0
ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^04H0
ooK^00<000000?ofkP3om^h04@3om^h00`000000ooK^0?ofkP0U0?ofkP40oooo001W0?ofkP030000
003om^h0000006<0ooK^00<0e3dI0?ofkP3D?AT00P3D?AT01@3om^h0e3dI0?ofkP3om^h0e3dI00P0
ooK^00<0e3dI0?ofkP3om^h0203om^h0103D?AT0ooK^0?ofkP3om^h80=@m6@<0ooK^00<0e3dI0?of
kP3om^h0303om^h00`3D?AT0ooK^0?ofkP050=@m6@T0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D
?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h01P3om^h20=@m
6@L0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP150?ofkP030000003om^h0ooK^
01<0ooK^00<000000?ofkP3om^h0903om^h10?ooo`00I`3om^h2000006@0ooK^0`3D?AT00`3om^h0
e3dI0=@m6@020?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h0203om^h50=@m6@X0
ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP060?ofkPH0e3dI0P3om^h00`3D?AT0
ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00l0ooK^0`3D?AT?0?ofkP030=@m6@3om^h0ooK^00P0
ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^04<0
ooK^00<000000?ofkP3om^h0503om^h00`000000ooK^0?ofkP0T0?ofkP40oooo001W0?ofkP800000
H`3om^h40=@m6@030?ofkP3D?AT0ooK^0080ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^
0?ofkP050?ofkP<0e3dI00<0ooK^0=@m6@3om^h0303om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m
6@3om^h0ooK^00`0ooK^103D?AT@0?ofkP030=@m6@3om^h0ooK^00h0ooK^00D0e3dI0?ofkP3om^h0
ooK^0=@m6@0=0?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0
ooK^0?ofkP0<0?ofkP030=@m6@3om^h0e3dI04@0ooK^00<000000?ofkP3om^h0503om^h00`000000
ooK^0?ofkP0T0?ofkP40oooo001W0?ofkP800000H`3om^h00`3D?AT0ooK^0=@m6@030=@m6@<0ooK^
00<0e3dI0?ofkP3om^h01P3om^h0103D?AT0ooK^0?ofkP3om^h40=@m6@<0ooK^00<0e3dI0?ofkP3o
m^h02`3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00l0ooK^00@0e3dI0?ofkP3D
?AT0e3dI3@3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^0080ooK^0P3D?AT;0?of
kP030=@m6@3om^h0ooK^00/0ooK^00@0e3dI0?ofkP3om^h0e3dI3`3om^h00`3D?AT0ooK^0=@m6@13
0?ofkP030000003om^h0ooK^01D0ooK^00<000000?ofkP3om^h0903om^h10?ooo`00I`3om^h20000
06<0ooK^103D?AT01@3om^h0e3dI0?ofkP3om^h0e3dI00P0ooK^00<0e3dI0?ofkP3D?AT00P3D?AT7
0?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP0>
0?ofkP030=@m6@3om^h0ooK^0080ooK^0`3D?AT:0?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI
0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI
0?ofkP3D?AT03P3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI0440ooK^00<000000?ofkP3om^h05P3o
m^h00`000000ooK^0?ofkP0T0?ofkP40oooo001V0?ofkP030000003om^h0000006<0ooK^0`3D?AT2
0?ofkP040=@m6@3om^h0ooK^0=@m6@P0ooK^0P3D?AT:0?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0
e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00D0ooK^0P3D
?AT70?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h01P3om^h20=@m6@L0ooK^00<0
e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT0
@@3om^h00`000000ooK^0?ofkP0G0?ofkP030000003om^h0ooK^02<0ooK^0@3oool006H0ooK^00<0
00000?ofkP000000HP3om^h40=@m6@<0ooK^00<0e3dI0?ofkP3D?AT01P3om^h30=@m6@X0ooK^00<0
e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0
e3dI0?ofkP3om^h0203om^h30=@m6@@0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?of
kP090?ofkP80e3dI103om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0e3dI00d0ooK^00<0
e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP0m0?ofkP030000003om^h0ooK^01P0ooK^00<0
00000?ofkP3om^h08`3om^h10?ooo`00IP3om^h2000006<0ooK^0`3D?AT40?ofkP030=@m6@3om^h0
e3dI00D0ooK^00<0e3dI0?ofkP3D?AT02`3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0
ooK^00`0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP80e3dI00<0ooK^
0=@m6@3om^h0403om^h00`3D?AT0ooK^0?ofkP0;0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT0403o
m^h00`3D?AT0ooK^0=@m6@0=0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h0?03o
m^h00`000000ooK^0?ofkP0I0?ofkP030000003om^h0ooK^02<0ooK^0@3oool006H0ooK^0P00001S
0?ofkP<0e3dI103om^h20=@m6@@0ooK^0P3D?AT20?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI
0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI
0?ofkP3om^h03P3om^h20=@m6A00ooK^00<0e3dI0?ofkP3om^h03@3om^h30=@m6A00ooK^00D0e3dI
0?ofkP3om^h0ooK^0=@m6@0;0?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h0>`3o
m^h00`000000ooK^0?ofkP0I0?ofkP030000003om^h0ooK^02<0ooK^0@3oool006H0ooK^0P00001R
0?ofkP@0e3dI103om^h20=@m6@80ooK^0P3D?AT40?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI
0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI
0?ofkP3om^h03P3om^h0103D?AT0ooK^0=@m6@3D?AT>0?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0
e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0
e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP0j0?ofkP030000003om^h0ooK^01/0ooK^00<0
00000?ofkP3om^h08P3om^h10?ooo`00IP3om^h200000680ooK^0`3D?AT50?ofkP80e3dI00<0ooK^
0=@m6@3om^h0103om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI
0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00l0ooK^00@0e3dI
0?ofkP3om^h0ooK^0P3D?AT;0?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3D?AT03P3o
m^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h01`3o
m^h00`3D?AT0ooK^0?ofkP0i0?ofkP030000003om^h0ooK^01/0ooK^00<000000?ofkP3om^h08P3o
m^h10?ooo`00I@3om^h00`000000ooK^0000001R0?ofkP<0e3dI103om^h40=@m6@H0ooK^00<0e3dI
0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI
0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00@0ooK^0P3D?AT9
0?ofkP030=@m6@3om^h0ooK^00l0ooK^00@0e3dI0?ofkP3om^h0e3dI3@3om^h00`3D?AT0ooK^0?of
kP040?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?of
kP0h0?ofkP030000003om^h0ooK^01`0ooK^00<000000?ofkP3om^h08P3om^h10?ooo`00I@3om^h0
0`000000ooK^000000060?ofkP<0?EV[F03om^h40=@m6@@0ooK^0`3D?AT70?ofkP030=@m6@3om^h0
ooK^00P0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0
ooK^00d0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP060?ofkP80e3dI1P3om^h0
0`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h02@3om^h0
0`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h02@3om^h0
0`3D?AT0ooK^0?ofkP0f0?ofkP030000003om^h0ooK^01d0ooK^00<000000?ofkP3om^h08P3om^h1
0?ooo`00I@3om^h00`000000ooK^000000050?ofkPX0?EV[DP3om^h30=@m6@D0ooK^0`3D?AT60?of
kP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP0<0?of
kP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP090?of
kP80e3dI103om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?of
kP3om^h0203om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?of
kP3om^h02P3om^h00`3D?AT0ooK^0?ofkP0f0?ofkP030000003om^h0ooK^01d0ooK^00<000000?of
kP3om^h08P3om^h10?ooo`00I@3om^h2000000H0ooK^0`0mFJ/00`3om^h0?EV[03eIZ`0903eIZdd0
ooK^0`3D?AT40?ofkP80e3dI0P3om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00T0
ooK^00<0e3dI0?ofkP3om^h01`3om^hE0=@m6@d0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0
ooK^0?ofkP0;0?ofkP80e3dI00<0ooK^0=@m6@3om^h0403om^h00`3D?AT0ooK^0?ofkP050?ofkP03
0=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h02@3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI
00d0ooK^00<0e3dI0?ofkP3om^h0=03om^h00`000000ooK^0?ofkP0O0?ofkP030000003om^h0ooK^
0240ooK^0@3oool006D0ooK^0P0000060?ofkP80?EV[00<0ooK^03eIZ`0mFJ/0100mFJ/00`3om^h0
?EV[03eIZ`0903eIZdL0ooK^0`3D?AT30?ofkP<0e3dI0P3om^h00`3D?AT0ooK^0?ofkP030?ofkP03
0=@m6@3om^h0ooK^00P0ooK^00@0e3dI0?ofkP3om^h0ooK^1`3D?AT30?ofkP030=@m6@3om^h0ooK^
00`0ooK^00<0e3dI0?ofkP3om^h01@3D?AT80?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?of
kP3om^h03P3om^h20=@m6A40ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP050?of
kP030=@m6@3om^h0ooK^00T0ooK^00@0e3dI0?ofkP3om^h0e3dI3@3om^h20=@m6CD0ooK^00<00000
0?ofkP3om^h0803om^h00`000000ooK^0?ofkP0Q0?ofkP40oooo001U0?ofkP8000001P3om^h00`0m
FJ/0ooK^0?ofkP060?ofkPD0?EV[0P3om^h:03eIZd40ooK^00@0e3dI0?ofkP3D?AT0e3dI0P3om^h0
103D?AT0ooK^0=@m6@3D?AT20?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h01`3o
m^h50=@m6@T0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP060?ofkPD0e3dI0P3o
m^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00l0ooK^0`3D?AT>0?ofkP030=@m6@3o
m^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3o
m^h0e3dI00d0ooK^0P3D?ATe0?ofkP030000003om^h0ooK^0200ooK^00<000000?ofkP3om^h08@3o
m^h10?ooo`00I@3om^h2000000D0ooK^0P0mFJ/=0?ofkPH0?EV[0P3om^h:03eIZc/0ooK^00L0e3dI
0?ofkP3D?AT0e3dI0?ofkP3D?AT0ooK^0080e3dI103om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00P0
ooK^0P3D?AT00`3om^h0e3dI0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3o
m^h02`3om^h40=@m6@l0ooK^00<0e3dI0?ofkP3om^h03`3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI
00d0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^
00`0ooK^00<0e3dI0?ofkP3om^h02`3om^h0103D?AT0ooK^0?ofkP3D?ATc0?ofkP030000003om^h0
ooK^0240ooK^00<000000?ofkP3om^h08@3om^h10?ooo`00I03om^h00`000000ooK^000000050?of
kP@0?EV[4@3om^h503eIZ`80ooK^2`0mFJ/e0?ofkPD0e3dI0P3om^h20=@m6@@0ooK^00D0e3dI0?of
kP3om^h0ooK^0=@m6@050?ofkP<0e3dI0P3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0
ooK^00/0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0=@m6@020=@m6@`0ooK^00<0e3dI
0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP020?ofkP80e3dI2P3om^h00`3D?AT0ooK^0?ofkP0;
0?ofkP040=@m6@3om^h0ooK^0=@m6@h0ooK^00<0e3dI0?ofkP3D?AT0303om^h0103D?AT0ooK^0?of
kP3D?ATb0?ofkP030000003om^h0ooK^02<0ooK^00<000000?ofkP3om^h0803om^h10?ooo`00I03o
m^h00`000000ooK^000000050?ofkP<0?EV[00<0ooK^03eIZ`0mFJ/0100mFJ/=0?ofkP0303eIZ`3o
m^h0?EV[00H0?EV[0P3om^h;03eIZbh0ooK^1@3D?AT20?ofkP030=@m6@3om^h0e3dI00D0ooK^00@0
e3dI0?ofkP3om^h0e3dI0P3om^h30=@m6@D0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^
0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h00`3om^h30=@m6@P0ooK^
00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00L0ooK^
00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0=@m6@0>0?ofkP030=@m6@3om^h0e3dI00/0ooK^
00D0e3dI0?ofkP3om^h0ooK^0=@m6@0b0?ofkP030000003om^h0ooK^02<0ooK^00<000000?ofkP3o
m^h0803om^h10?ooo`00I03om^h2000000H0ooK^0P0mFJ/00`3om^h0?EV[03eIZ`0403eIZ`030?of
kP0mFJ/0?EV[00@0?EV[1`3om^h00`0mFJ/0ooK^03eIZ`060?ofkPD0?EV[0`3om^h:03eIZbT0ooK^
00L0e3dI0?ofkP3D?AT0e3dI0?ofkP3D?AT0ooK^0080e3dI1P3om^h0103D?AT0ooK^0=@m6@3om^h2
0=@m6@P0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0
ooK^00d0ooK^00<0e3dI0?ofkP3om^h01P3om^h30=@m6@D0ooK^00<0e3dI0?ofkP3om^h03`3om^h0
0`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h03P3om^h0
0`3D?AT0ooK^0?ofkP0<0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT02P3om^h01@3D?AT0ooK^0?of
kP3om^h0e3dI0340ooK^00<000000?ofkP3om^h0903om^h00`000000ooK^0?ofkP0P0?ofkP40oooo
001T0?ofkP8000001P3om^h203eIZ`L0ooK^1@0mFJ/20?ofkPL0?EV[0P3om^h00`0mFJ/0ooK^0?of
kP090?ofkPH0?EV[0`3om^h:03eIZb<0ooK^0`3D?AT20?ofkP040=@m6@3om^h0e3dI0=@m6@H0ooK^
00@0e3dI0?ofkP3D?AT0e3dI2@3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00/0
ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP<0e3dI00<0ooK^0=@m6@3o
m^h0403om^h00`3D?AT0ooK^0?ofkP080?ofkP80e3dI1@3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP03
0=@m6@3om^h0e3dI00d0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@090?ofkP030=@m6@3om^h0ooK^
00<0ooK^00<0e3dI0?ofkP3om^h0;P3om^h00`000000ooK^0?ofkP0T0?ofkP030000003om^h0ooK^
0200ooK^0@3oool006@0ooK^0P0000060?ofkP80?EV[303om^h603eIZ`80ooK^1P0mFJ/?0?ofkPH0
?EV[0P3om^h:03eIZad0ooK^103D?AT20?ofkP80e3dI00<0ooK^0=@m6@3om^h01@3om^h30=@m6@X0
ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00d0
ooK^00<0e3dI0?ofkP3om^h03@3om^h20=@m6A40ooK^00<0e3dI0?ofkP3om^h02P3om^h01@3D?AT0
ooK^0?ofkP3om^h0e3dI0100ooK^00<0e3dI0?ofkP3D?AT0303om^h00`3D?AT0ooK^0?ofkP030?of
kP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP0]0?of
kP030000003om^h0ooK^02D0ooK^00<000000?ofkP3om^h0803om^h10?ooo`00I03om^h2000000D0
ooK^0P0mFJ/C0?ofkPH0?EV[0P3om^h603eIZ`/0ooK^00<0?EV[0?ofkP3om^h01P0mFJ/30?ofkPX0
?EV[5`3om^h30=@m6@<0ooK^0P3D?AT00`3om^h0e3dI0?ofkP040?ofkP030=@m6@3om^h0e3dI00X0
ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00h0
ooK^00<0e3dI0?ofkP3om^h03P3om^h30=@m6@h0ooK^00<0e3dI0?ofkP3om^h0303om^h20=@m6@03
0?ofkP3D?AT0ooK^00h0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0;0?ofkP030=@m6@3om^h0ooK^
00<0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^
02`0ooK^00<000000?ofkP3om^h09`3om^h00`000000ooK^0?ofkP0O0?ofkP40oooo001S0?ofkP03
0000003om^h0000000D0ooK^0P0mFJ/E0?ofkP0303eIZ`3om^h0ooK^00D0?EV[103om^h603eIZ`@0
ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`050?ofkPD0?EV[0`3om^h:03eIZa80ooK^0`3D?AT30?of
kP<0e3dI103om^h20=@m6@80ooK^0P3D?AT90?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?of
kP3om^h02`3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00h0ooK^00@0e3dI0?of
kP3om^h0ooK^0P3D?AT<0?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h03P3om^h0
0`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h01@3om^h0
0`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h0;03om^h0
0`000000ooK^0?ofkP0W0?ofkP030000003om^h0ooK^01l0ooK^0@3oool006<0ooK^00<000000?of
kP0000001@3om^h203eIZa@0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`040?ofkPH0?EV[103om^h6
03eIZ`80ooK^00<0?EV[0?ofkP3om^h0203om^h603eIZ`<0ooK^2@0mFJ/<0?ofkP040=@m6@3om^h0
e3dI0=@m6@<0ooK^00<0e3dI0?ofkP3D?AT00P3om^h20=@m6@<0ooK^00<0e3dI0?ofkP3D?AT02@3o
m^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h03@3o
m^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00<0ooK^0P3D?AT90?ofkP030=@m6@3o
m^h0ooK^00l0ooK^0P3D?AT>0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h01P3o
m^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h01P3o
m^h00`3D?AT0ooK^0?ofkP0Z0?ofkP030000003om^h0ooK^02P0ooK^00<000000?ofkP3om^h07`3o
m^h10?ooo`00H`3om^h00`000000ooK^000000050?ofkP80?EV[503om^h01@0mFJ/0ooK^0?ofkP3o
m^h0?EV[00X0ooK^1@0mFJ/20?ofkP0303eIZ`3om^h0ooK^00D0?EV[3P3om^h603eIZ`80ooK^2P0m
FJ/60?ofkP<0e3dI103om^h01@3D?AT0ooK^0=@m6@3om^h0e3dI00D0ooK^00@0e3dI0?ofkP3om^h0
e3dI1`3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3o
m^h03@3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3o
m^h01P3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP040=@m6@3om^h0ooK^0=@m6@d0ooK^00<0e3dI0?of
kP3om^h0103om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00L0ooK^00D0e3dI0?of
kP3om^h0ooK^0=@m6@090?ofkP030=@m6@3om^h0ooK^02T0ooK^00<000000?ofkP3om^h0:@3om^h0
0`000000ooK^0?ofkP0O0?ofkP40oooo001S0?ofkP8000001P3om^h403eIZa80ooK^00@0?EV[0?of
kP3om^h0?EV[403om^h603eIZ`040?ofkP0mFJ/0ooK^0?ofkP@0?EV[2`3om^h0100mFJ/0ooK^0?of
kP3om^h803eIZ`030?ofkP0mFJ/0?EV[00L0?EV[00@0ooK^0=@m6@3D?AT0e3dI103om^h40=@m6@H0
ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@060?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?of
kP3om^h02`3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?of
kP3om^h01`3om^h20=@m6@D0ooK^00<0e3dI0?ofkP3om^h03`3om^h01@3D?AT0ooK^0?ofkP3om^h0
e3dI00/0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0
ooK^00L0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@090?ofkP030=@m6@3om^h0ooK^02T0ooK^00<0
00000?ofkP3om^h0:P3om^h00`000000ooK^0?ofkP0N0?ofkP40oooo001S0?ofkP8000001P3om^h2
03eIZ`030?ofkP0mFJ/0?EV[00D0?EV[303om^h0100mFJ/0ooK^0?ofkP0mFJ/B0?ofkP0403eIZ`3o
m^h0ooK^0?ofkPL0?EV[00<0ooK^03eIZ`0mFJ/00`0mFJ/50?ofkP0303eIZ`3om^h0ooK^0080ooK^
00<0?EV[0?ofkP3om^h01@3om^h;03eIZ`<0e3dI00H0?EV[0?ofkP3om^h0e3dI0?ofkP3D?AT70?of
kP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP0:0?of
kP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0>0?of
kP030=@m6@3om^h0ooK^00T0ooK^0P3D?AT30?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?of
kP3om^h00`3om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?of
kP3om^h00P3om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0e3dI00T0ooK^0P3D?ATZ0?of
kP030000003om^h0ooK^02/0ooK^00<000000?ofkP3om^h07P3om^h10?ooo`00H`3om^h2000000H0
ooK^0P0mFJ/60?ofkPP0?EV[1@3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[0140ooK^00<0?EV[0?of
kP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP030?ofkP`0?EV[1@3om^h00`0mFJ/0ooK^0?ofkP0;0?of
kP<0?EV[0`3D?AT403eIZ`<0e3dI1`0000000`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^
0080ooK^00<0e3dI0?ofkP3om^h0203om^hD0=@m6@d0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D
?AT0ooK^0?ofkP0<0?ofkP<0e3dI4@3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^
00H0ooK^00<0e3dI0?ofkP3om^h02@3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00/0ooK^00<0e3dI
0?ofkP3D?AT02@3om^h20=@m6BT0ooK^00<000000?ofkP3om^h0;03om^h00`000000ooK^0?ofkP0N
0?ofkP40oooo001R0?ofkP030000003om^h0000000D0ooK^00<0?EV[0?ofkP0mFJ/0303om^h803eI
Z`<0ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^
00X0ooK^200mFJ/20?ofkP0303eIZ`3om^h0ooK^00d0ooK^00@0?EV[0=@m6@3om^h0e3dI100mFJ/3
0=@m6@@000000`0A52L00`3D?AT0000000000003000000030=@m6@3om^h0ooK^0080ooK^00@0e3dI
0?ofkP3om^h0ooK^1`3D?AT30?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h01@3D
?AT80?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?of
kP0>0?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?of
kP090?ofkP040=@m6@3om^h0ooK^0=@m6@d0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^
0=@m6@0Y0?ofkP030000003om^h0ooK^02`0ooK^00<000000?ofkP3om^h07P3om^h10?ooo`00HP3o
m^h00`000000ooK^000000050?ofkP0303eIZ`3om^h0?EV[0140ooK^2@0mFJ/?0?ofkP0303eIZ`3o
m^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0703eIZ`d0ooK^00L0
?EV[0=@m6@3D?AT0e3dI0000000mFJ/06A`g0080e3dI0P0I73L01`3D?AT06A`g01TL=`0I73L00000
03eIZ`3D?AT010000003014D9`040=@m6@0000000000000000@0e3dI2@3om^h00`3D?AT0ooK^0?of
kP0;0?ofkP030=@m6@3om^h0ooK^00H0ooK^1@3D?AT20?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0
e3dI0?ofkP3om^h03`3om^h30=@m6@h0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?of
kP030?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3D?AT0303om^h20=@m6@T0ooK^00<0
e3dI0?ofkP3D?AT0:03om^h00`000000ooK^0?ofkP0]0?ofkP030000003om^h0ooK^01h0ooK^0@3o
ool00680ooK^00<000000?ofkP0000001@3om^h00`0mFJ/0ooK^03eIZ`0C0?ofkP0403eIZ`3om^h0
ooK^0?ofkPT0?EV[2@3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0
?EV[0?ofkP3om^h01@3om^h903eIZ`H0ooK^00<0?EV[0=@m6@3om^h00P3D?AT3000000050=@m6@0I
73L06A`g01TL=`3D?AT00`0I73L2000000030=@m6@0I73L0?EV[00806A`g100000000`3D?AT00000
00000005000000P0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP@0e3dI
3`3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT0303om^h00`3D?AT0
ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0
ooK^0?ofkP0;0?ofkP80e3dI203om^h0103D?AT0ooK^0?ofkP3D?ATW0?ofkP030000003om^h0ooK^
02l0ooK^00<000000?ofkP3om^h07@3om^h10?ooo`00HP3om^h00`000000ooK^000000050?ofkP80
?EV[503om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00H0ooK^200mFJ/20?ofkP0303eIZ`3om^h0ooK^
00@0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^
00@0ooK^2@0mFJ/0103D?AT0ooK^0=@m6@3D?AT302@]D`050=@m6@00000000000000003D?AT01000
00000`0I73L0e3dI01TL=`0601TL=`040000003D?AT06A`g01TL=`@0000000<04A@W000000000000
100000000`3om^h0e3dI0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3D?AT0
0P3D?AT<0?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h00P3om^h20=@m6@X0ooK^
00<0e3dI0?ofkP3om^h02P3om^h0103D?AT0ooK^0?ofkP3D?AT>0?ofkP80e3dI303om^h0103D?AT0
ooK^0?ofkP3D?AT70?ofkP040=@m6@3om^h0ooK^0=@m6BL0ooK^00<000000?ofkP3om^h0;`3om^h0
0`000000ooK^0?ofkP0M0?ofkP40oooo001R0?ofkP8000001P3om^h203eIZa<0ooK^00<0?EV[0?of
kP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkPL0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP0<0?of
kP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h02@3om^h403eIZ`80e3dI00<092eC0=@m
6@0T;E<00P0T;E<00`3D?AT092eC02@]D`0202@]D`050=@m6@0T;E<092eC02@]D`3D?AT010000003
01TL=`040000000I73L06A`g0=@m6@D06A`g1@000002014D9`@000002`3om^h00`3D?AT0ooK^0?of
kP0=0?ofkP030=@m6@3om^h0ooK^00<0ooK^0`3D?AT80?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0
e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0
e3dI0?ofkP3D?AT03P3om^h00`3D?AT0ooK^0=@m6@0;0?ofkP040=@m6@3om^h0ooK^0=@m6@H0ooK^
00D0e3dI0?ofkP3om^h0ooK^0=@m6@0V0?ofkP030000003om^h0ooK^0300ooK^00<000000?ofkP3o
m^h07@3om^h10?ooo`00HP3om^h2000000D0ooK^00<0?EV[0?ofkP0mFJ/04`3om^h00`0mFJ/0ooK^
0?ofkP020?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h01`0mFJ/<0?ofkP0303eI
Z`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h02`3om^h01P0mFJ/0e3dI0=@m6@3D?AT092eC0=@m
6@8092eC00<0e3dI02@]D`0T;E<00`0T;E<01@3D?AT092eC02@]D`0T;E<0e3dI00@092eC1@000002
01TL=`030=@m6@0I73L06A`g00<06A`g00@0000001TL=`0I73L0?EV[100000000`0mFJ/04A@W0000
0004000000H0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP060?ofkP<0e3dI1@3o
m^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h01@3o
m^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00`0ooK^00@0e3dI0?ofkP3om^h0e3dI
2P3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00D0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0
ooK^0?ofkP0T0?ofkP030000003om^h0ooK^0300ooK^00<000000?ofkP3om^h07@3om^h10?ooo`00
H@3om^h00`000000ooK^000000050?ofkP0303eIZ`3om^h0?EV[01<0ooK^00<0?EV[0?ofkP3om^h0
0P3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00@0ooK^2@0mFJ/50?ofkP0303eI
Z`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h02P3om^h01`0mFJ/0ooK^0=@m6@000000e3dI02@]
D`3D?AT00P0T;E<00`3D?AT092eC02@]D`0202@]D`030000003D?AT092eC008092eC00<0e3dI02@]
D`0T;E<0100T;E<00`00000092eC02@]D`02000000030=@m6@000000000000<06A`g00<0000001TL
=`0I73L01@0I73L?000000d0ooK^00<0e3dI0?ofkP3om^h02P3om^h30=@m6@030?ofkP3D?AT0ooK^
00l0ooK^00<0e3dI0?ofkP3om^h0203om^h20=@m6@@0ooK^00<0e3dI0?ofkP3om^h03P3om^h20=@m
6@d0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@080?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI
0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^02<0ooK^00<00000
0?ofkP3om^h0<P3om^h00`000000ooK^0?ofkP0L0?ofkP40oooo001Q0?ofkP030000003om^h00000
00D0ooK^0`0mFJ/C0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/0403om^h00`0mFJ/0ooK^0?ofkP05
0?ofkP0303eIZ`3om^h0ooK^00@0ooK^200mFJ/80?ofkP0303eIZ`3om^h0ooK^00X0ooK^00D0?EV[
0?ofkP3D?AT0e3dI02hmM002000000040=@m6@000000e3dI000000<092eC00D0000002@]D`3D?AT0
92eC0=@m6@0602@]D`030000000T;E<092eC00@092eC00<0e3dI02@]D`0000001000000801TL=`03
0000000I73L0?EV[00806A`g1`0000000`0A52L0000000000004000000L0ooK^00<0e3dI0?ofkP3o
m^h03@3om^h20=@m6A00ooK^00<0e3dI0?ofkP3om^h02P3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI
00l0ooK^00<0e3dI0?ofkP3D?AT0303om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^
00H0ooK^00<0e3dI0?ofkP3om^h00`3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00D0ooK^00<0e3dI
0?ofkP3om^h08P3om^h00`000000ooK^0?ofkP0c0?ofkP030000003om^h0ooK^01`0ooK^0@3oool0
0640ooK^00<000000?ofkP0000001@3om^h00`0mFJ/0ooK^03eIZ`0503eIZ`h0ooK^00D0?EV[0?of
kP3om^h0ooK^03eIZ`0@0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h02@3om^h9
03eIZ`80ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^000000020=@m6@<0;Sed0P3D?AT2
02hmM0D0000000<0e3dI02@]D`3D?AT01P0T;E<00`00000092eC02@]D`0402@]D`80e3dI0P0T;E<0
0`00000092eC02@]D`05000000806A`g00<0000001TL=`0I73L01`0I73L00`0000006A`g01TL=`04
00000004014D9`0000004A@W014D9`<000000`3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP<0e3dI3@3o
m^h00`3D?AT0ooK^0?ofkP0<0?ofkP<0e3dI403om^h0103D?AT0ooK^0?ofkP3D?AT;0?ofkP030=@m
6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP040?ofkP050=@m
6@3om^h0ooK^0?ofkP3D?AT01@3om^h00`3D?AT0ooK^0?ofkP0R0?ofkP030000003om^h0ooK^03<0
ooK^00<000000?ofkP3om^h0703om^h10?ooo`00H@3om^h00`000000ooK^000000050?ofkP0303eI
Z`3om^h0?EV[0080ooK^2@0mFJ/70?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h0
3P3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h0
2P0mFJ/80?ofkP0303eIZ`3om^h0e3dI0080e3dI0`0^?G@20=@m6@@0;Sed00H0000002hmM00^?G@0
e3dI0000003D?AT30000008092eC00<0000002@]D`0T;E<0100T;E<01@3D?AT092eC02@]D`3D?AT0
000000P092eC1@00000701TL=`030000000I73L06A`g00@06A`g1P0000000`0A52L0000000000003
000000h0ooK^00@0e3dI0?ofkP3om^h0ooK^0P3D?AT;0?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0
e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0
e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00@0ooK^00@0
e3dI0?ofkP3om^h0e3dI1P3om^h00`3D?AT0ooK^0?ofkP0Q0?ofkP030000003om^h0ooK^03@0ooK^
00<000000?ofkP3om^h0703om^h10?ooo`00H@3om^h2000000D0ooK^00@0?EV[0?ofkP3om^h0?EV[
203om^h803eIZ`80ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eI
Z`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP060?ofkP/0?EV[
0P3om^h00`0mFJ/000000=@m6@020=@m6@<0;Sed0P3D?AT302hmM0030000000^?G@0;Sed0080;Sed
00<0e3dI02hmM00^?G@00P0^?G@5000000@092eC00D0e3dI02@]D`0T;E<092eC0=@m6@0:02@]D`03
0000000T;E<092eC00D000000P0I73L00`0000006A`g01TL=`0601TL=`040000000I73L0?EV[01TL
=`h000001P3om^h00`3D?AT0ooK^0?ofkP030?ofkP80e3dI203om^h00`3D?AT0ooK^0?ofkP0>0?of
kP030=@m6@3om^h0e3dI00h0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP060?of
kP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP050?of
kP040=@m6@3om^h0ooK^0=@m6@H0ooK^00<0e3dI0?ofkP3om^h0803om^h00`000000ooK^0?ofkP0e
0?ofkP030000003om^h0ooK^01`0ooK^0@3oool00640ooK^0P0000050?ofkP0403eIZ`3om^h0ooK^
03eIZ`h0ooK^200mFJ/00`3om^h0?EV[0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[
0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP070?ofkP0403eIZ`3om^h0ooK^0?ofkPD0?EV[00<0
ooK^03eIZ`0mFJ/00P0mFJ/00`0^?G@0e3dI02hmM00302hmM080e3dI0`0^?G@00`000000;Sed02hm
M00202hmM0030=@m6@0^?G@0;Sed00@0;Sed00<0000002hmM00^?G@0100000001P3D?AT092eC02@]
D`00000092eC0=@m6@T092eC00<0000002@]D`0T;E<01@0T;E<7000000D06A`g00<0000001TL=`0I
73L0100I73L00`0000006A`g01TL=`0600000003014D9`000000000000<0000000<0e3dI0?ofkP3o
m^h01P3om^h20=@m6@H0ooK^00<0e3dI0?ofkP3om^h03P3om^h0103D?AT0ooK^0?ofkP3D?AT<0?of
kP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP060?of
kP050=@m6@3om^h0ooK^0?ofkP3D?AT02@3om^h20=@m6@H0ooK^0P3D?ATR0?ofkP030000003om^h0
ooK^03H0ooK^00<000000?ofkP3om^h06`3om^h10?ooo`00H03om^h00`000000ooK^000000050?of
kP0303eIZ`3om^h0?EV[01<0ooK^00<0?EV[0?ofkP0mFJ/0200mFJ/:0?ofkP0303eIZ`3om^h0ooK^
00D0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^
00H0ooK^0`0mFJ/010000000;Sed0=@m6@3D?AT402hmM0050=@m6@0^?G@0;Sed02hmM00000001@0^
?G@20=@m6@@0;Sed00<0000002hmM00^?G@0100^?G@00`3D?AT0;Sed00000004000000030=@m6@0T
;E<092eC00D092eC00<0000002@]D`0T;E<0200T;E<00`00000092eC02@]D`0202@]D`P000001@0I
73L00`0000006A`g01TL=`0301TL=`D000000P0A52L200000003014D9`000000000000L0ooK^0P3D
?AT30?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?of
kP090?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?of
kP070?ofkP040=@m6@3om^h0ooK^0=@m6@T0ooK^0P3D?AT60?ofkP030=@m6@3om^h0ooK^0200ooK^
00<000000?ofkP3om^h0=`3om^h00`000000ooK^0?ofkP0K0?ofkP40oooo001P0?ofkP030000003o
m^h00000008000000`3om^h00`0mFJ/0ooK^03eIZ`0B0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0
?EV[0?ofkP3om^h02P0mFJ/30?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h02P3o
m^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0000000000000P3D
?AT402hmM0050=@m6@0^?G@0;Sed02hmM0000000100^?G@00`3D?AT0;Sed0=@m6@0402hmM0030000
000^?G@0;Sed00@0;Sed00D0e3dI02hmM00^?G@0;Sed0000000202hmM0030000003D?AT0000000<0
00000P0T;E<00`00000092eC02@]D`0802@]D`030000000T;E<092eC00L092eC00<0000002@]D`0T
;E<0100000000`0I73L0000001TL=`0701TL=`030000000I73L0?EV[00D000000P0A52L4000000@0
ooK^0P3D?AT00`3om^h0e3dI0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3o
m^h01`3om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3o
m^h0203om^h00`3D?AT0ooK^0=@m6@0:0?ofkP030=@m6@3om^h0ooK^00@0ooK^0P3D?ATQ0?ofkP03
0000003om^h0ooK^03P0ooK^00<000000?ofkP3om^h06`3om^h10?ooo`00H03om^h00`000000ooK^
000000020?ofkPH000004P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00D0ooK^
100mFJ/00`3om^h0?EV[03eIZ`0403eIZ`D0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^
0?ofkP080?ofkP0303eIZ`3om^h0ooK^00L0ooK^00D0?EV[0?ofkP000000=TV;0=@m6@0500000004
0=@m6@0^?G@0;Sed000000D0;Sed00@0e3dI02hmM00^?G@0e3dI0`0^?G@00`000000;Sed02hmM004
02hmM0050=@m6@0^?G@0;Sed02hmM00000000`0^?G@00`3D?AT0;Sed02hmM00202hmM0D00000200T
;E<00`00000092eC02@]D`0702@]D`030000000T;E<092eC00@092eC1@00000501TL=`030000000I
73L06A`g00<06A`g1P0000000`0A52L000000000000500000080e3dI3`3om^h00`3D?AT0ooK^0?of
kP050?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h0203om^h01@3D?AT0ooK^0?of
kP3om^h0e3dI00/0ooK^0P3D?AT90?ofkP80e3dI1P3om^h20=@m6B40ooK^00<000000?ofkP3om^h0
>03om^h00`000000ooK^0?ofkP0K0?ofkP40oooo001P0?ofkP030000003om^h0000000D0ooK^00<0
?EV[0?ofkP0mFJ/01P00000<0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h02@3o
m^h503eIZ`80ooK^1P0mFJ/<0?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h0203o
m^h01@0mFJ/000000000000fBH/0e3dI00@0=TV;00<0e3dI03I9R`3D?AT01000000302hmM0050=@m
6@0^?G@0;Sed02hmM03D?AT00P0^?G@00`000000;Sed02hmM00302hmM0030=@m6@0^?G@0;Sed0080
;Sed00<0000002hmM00^?G@00P0^?G@00`3D?AT0;Sed02hmM00302hmM0030000000^?G@0;Sed00H0
00000P0T;E<00`00000092eC02@]D`0702@]D`030000000T;E<092eC00H092eC00<0000002@]D`0T
;E<01@0000000`0I73L0000001TL=`0601TL=`030000000I73L0?EV[00L0000000<04A@W00000000
00000P00000=0?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0
ooK^0?ofkP090?ofkP040=@m6@3om^h0ooK^0=@m6@`0ooK^00<0e3dI0?ofkP3om^h0203om^h20=@m
6@D0ooK^00<0e3dI0?ofkP3D?AT0803om^h00`000000ooK^0?ofkP0j0?ofkP030000003om^h0ooK^
01X0ooK^0@3oool00600ooK^0P0000050?ofkP0403eIZ`3om^h0ooK^03eIZ`H0ooK^1P0000060?of
kP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^03eIZ`0403eI
Z`80ooK^1@0mFJ/80?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h0203om^h01@0m
FJ/0000003I9R`0fBH/0e3dI00@0=TV;00D0e3dI03I9R`3D?AT0=TV;0000000203I9R`80000000P0
e3dI000000000000000002hmM03D?AT0;Sed000000H0;Sed00D0e3dI02hmM00^?G@0;Sed00000006
02hmM0030=@m6@0^?G@0;Sed0080;Sed00<0000002hmM00^?G@01P0^?G@5000000L092eC00<00000
02@]D`0T;E<01`0T;E<00`00000092eC02@]D`0402@]D`D000001@0I73L00`0000006A`g01TL=`04
01TL=`030000000I73L0000000@000000P0A52L3000000L0ooK^00<0e3dI0?ofkP3om^h0203om^h0
0`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3D?AT02`3om^h2
0=@m6@T0ooK^00<0e3dI0?ofkP3D?AT01@3om^h20=@m6B00ooK^00<000000?ofkP3om^h0>`3om^h0
0`000000ooK^0?ofkP0J0?ofkP40oooo001P0?ofkP8000001@3om^h0100mFJ/0ooK^0?ofkP0mFJ/<
0?ofkPD0000000<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0
ooK^00@0ooK^1@0mFJ/20?ofkPD0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0
ooK^00L0ooK^00@0?EV[0?ofkP000000=TV;0P3D?AT403I9R`050=@m6@0fBH/0e3dI03I9R`000000
100fBH/0103D?AT0=TV;03I9R`0fBH/2000000040=@m6@0000000000000000@0;Sed00D0e3dI02hm
M00^?G@0;Sed0000000702hmM0050=@m6@0^?G@0;Sed02hmM00000002P0^?G@00`000000;Sed02hm
M0050000008092eC00<0000002@]D`0T;E<01`0T;E<00`00000092eC02@]D`0602@]D`030000000T
;E<092eC00D0000000<06A`g0000000I73L01@0I73L2000000<06A`g1P0000000`0A52L000000000
0004000000030=@m6@3om^h0ooK^00T0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0>0?ofkP030=@m
6@3om^h0ooK^00X0ooK^0P3D?AT90?ofkP030=@m6@3om^h0e3dI00@0ooK^00<0e3dI0?ofkP3D?AT0
803om^h00`000000ooK^0?ofkP0k0?ofkP030000003om^h0ooK^01X0ooK^0@3oool005l0ooK^00<0
00000?ofkP0000001@3om^h0100mFJ/0ooK^0?ofkP0mFJ/A0?ofkPH0000000<0?EV[0?ofkP3om^h0
3@3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00H0?EV[00<0ooK^03eIZ`0mFJ/0
100mFJ/70?ofkP0303eIZ`3om^h0ooK^00L0ooK^00@0?EV[0?ofkP000000=TV;0P3D?AT303I9R`06
0=@m6@0fBH/0=TV;03I9R`3D?AT00000100fBH/00`3D?AT0=TV;03I9R`0303I9R`040=@m6@000000
=TV;03I9R`<0000000<0e3dI0000000000000P0^?G@00`000000;Sed02hmM00602hmM0030=@m6@0^
?G@0000000/0;Sed00<0000002hmM00^?G@01@0^?G@5000000L092eC00<0000002@]D`0T;E<01`0T
;E<00`00000092eC02@]D`0402@]D`L000000`0I73L00`0000006A`g01TL=`0301TL=`8000000P0m
FJ/<000000L0ooK^00@0e3dI0?ofkP3om^h0e3dI3@3om^h20=@m6@/0ooK^00@0e3dI0?ofkP3om^h0
e3dI1`3om^h0103D?AT0ooK^0?ofkP3D?AT30?ofkP040=@m6@3om^h0ooK^0=@m6Al0ooK^00<00000
0?ofkP3om^h0?03om^h00`000000ooK^0?ofkP0J0?ofkP40oooo001O0?ofkP030000003om^h00000
00D0ooK^100mFJ/A0?ofkP0303eIZ`3om^h0ooK^00<0ooK^1P00000:0?ofkP0303eIZ`3om^h0ooK^
00H0ooK^00<0?EV[0?ofkP3om^h01P3om^h603eIZ`030?ofkP0mFJ/0?EV[00@0?EV[00<0ooK^03eI
Z`3om^h0203om^h0100mFJ/000000000000fBH/20=@m6@<0=TV;00H0e3dI03I9R`0fBH/0=TV;0=@m
6@00000303I9R`030=@m6@0fBH/0=TV;00D0=TV;00<0e3dI03I9R`0fBH/00`0fBH/00`3D?AT0=TV;
03I9R`05000000L0;Sed00<0e3dI0000000^?G@02P0^?G@00`000000;Sed02hmM00702hmM0030000
000^?G@0;Sed00H000000P0T;E<00`00000092eC02@]D`0602@]D`030000000T;E<092eC00L092eC
00@0000002@]D`0T;E<092eC1`00000401TL=`030000000I73L06A`g00<06A`g1`000000100A52L0
00000000000000050?ofkP80e3dI3P3om^h00`3D?AT0ooK^0=@m6@0:0?ofkP040=@m6@3om^h0ooK^
0=@m6@H0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@030?ofkP040=@m6@3om^h0ooK^0=@m6Al0ooK^
00<000000?ofkP3om^h0?03om^h00`000000ooK^0?ofkP0J0?ofkP40oooo001O0?ofkP030000003o
m^h0000000D0ooK^00<0?EV[0?ofkP0mFJ/01@0mFJ/=0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0
?EV[0?ofkP3om^h00`3om^h6000000<0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?of
kP080?ofkP0403eIZ`3om^h0ooK^0?ofkPH0?EV[00<0ooK^03eIZ`0mFJ/01@0mFJ/30?ofkP0703eI
Z`3om^h0000003I9R`3D?AT0=TV;0=@m6@0303I9R`050=@m6@0fBH/0=TV;03I9R`3D?AT0100fBH/0
0`3D?AT0=TV;03I9R`0503I9R`030000003D?AT0=TV;00<0=TV;00<0e3dI03I9R`0fBH/00P0fBH/0
0`000000=TV;03I9R`0600000080;Sed00<0e3dI02hmM00^?G@02@0^?G@00`000000;Sed02hmM007
02hmM0030000000^?G@0;Sed00H0;Sed1@00000602@]D`030000000T;E<092eC00L092eC00<00000
02@]D`0T;E<01P0T;E<00`00000092eC00000006000000D06A`g00@0000001TL=`0I73L06A`g2@00
00020?ofkP030=@m6@3om^h0ooK^00/0ooK^00@0e3dI0?ofkP3om^h0e3dI2@3om^h01@3D?AT0ooK^
0?ofkP3om^h0e3dI00H0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@020?ofkP040=@m6@3om^h0ooK^
0=@m6Al0ooK^00<000000?ofkP3om^h0?P3om^h00`000000ooK^0?ofkP0I0?ofkP40oooo001O0?of
kP030000003om^h0000000D0ooK^00<0?EV[0?ofkP0mFJ/01@3om^h503eIZ`L0ooK^00<0?EV[0?of
kP3om^h0103om^h00`0mFJ/0ooK^0?ofkP090?ofkPD000001`3om^h00`0mFJ/0ooK^0?ofkP090?of
kP0303eIZ`3om^h0ooK^00L0ooK^1@0mFJ/30?ofkPD0?EV[00D0000003I9R`3D?AT0=TV;0=@m6@02
03I9R`030=@m6@0fBH/0=TV;0080=TV;00<000000=@m6@0fBH/00P0fBH/00`3D?AT0=TV;03I9R`05
03I9R`030000003D?AT0=TV;0080=TV;00<0e3dI03I9R`0fBH/00`0fBH/00`000000=TV;03I9R`06
03I9R`<0000000<0e3dI0000000^?G@0200^?G@00`000000;Sed02hmM00702hmM0030000000^?G@0
;Sed00P0;Sed00<0000002hmM00^?G@01@00000202@]D`030000000T;E<092eC00L092eC00<00000
02@]D`0T;E<01@0T;E<00`00000092eC02@]D`0402@]D`D000000`0I73L00`0000006A`g01TL=`03
01TL=`8000000P0mFJ/3000000030=@m6@0mFJ/0e3dI00`0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m
6@080?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT01@3om^h00`3D?AT0ooK^0?ofkP020?ofkP040=@m
6@3om^h0ooK^0=@m6@80ooK^00<0e3dI0?ofkP3om^h0703om^h00`000000ooK^0?ofkP0o0?ofkP03
0000003om^h0ooK^01T0ooK^0@3oool005l0ooK^0P0000050?ofkP0403eIZ`3om^h0ooK^03eIZ`X0
ooK^1@0mFJ/20?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0
ooK^00000005000000030?ofkP0mFJ/0ooK^00X0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0
ooK^0?ofkP0703eIZ`060?ofkP000000e3dI0000000fBH/0e3dI0P0fBH/00`3D?AT0=TV;03I9R`02
03I9R`030000003D?AT0=TV;0080=TV;00<0e3dI03I9R`0fBH/0100fBH/010000000=TV;03I9R`3D
?AT203I9R`030=@m6@0fBH/0=TV;00<0=TV;00<0000003I9R`0fBH/0200fBH/010000000e3dI0=@m
6@3D?AT5000000<0;Sed00<0000002hmM00^?G@0200^?G@00`000000;Sed02hmM00702hmM0030000
000^?G@0;Sed00D0;Sed2000000402@]D`030000000T;E<092eC00H092eC00<0000002@]D`0T;E<0
1P0T;E<00`00000092eC00000005000000D06A`g00<0000001TL=`0I73L00`0I73L2000000030=@m
6@0mFJ/0?EV[00<0?EV[1@3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00D0ooK^
00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^0080ooK^
00<0e3dI0?ofkP3D?AT00`3om^h00`3D?AT0ooK^0?ofkP0L0?ofkP030000003om^h0ooK^03l0ooK^
00<000000?ofkP3om^h06@3om^h10?ooo`00G`3om^h2000000D0ooK^00<0?EV[0?ofkP3om^h00`0m
FJ/=0?ofkPH0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00D0ooK^1P00
00070?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h01@3om^h303eIZ`030000000m
FJ/0>e6L0080000000@0e3dI0000003D?AT000000`0fBH/01@000000=TV;0=@m6@0fBH/0e3dI00L0
=TV;00L0000003I9R`0fBH/0=TV;0=@m6@0fBH/0e3dI00D0=TV;00<0000003I9R`0fBH/0200fBH/0
1@3D?AT0=TV;03I9R`0fBH/0e3dI00@0=TV;1P00000802hmM0030000000^?G@0;Sed00L0;Sed00<0
000002hmM00^?G@01`0^?G@00`000000;Sed02hmM00302hmM0P000001P0T;E<00`00000092eC02@]
D`0502@]D`030000000T;E<092eC00<092eC1@00000301TL=`8000001@0I73L0100mFJ/0e3dI03eI
Z`0mFJ/20?ofkPD0?EV[00<0e3dI03eIZ`3om^h00`3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m
6@3om^h0ooK^00<0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@050?ofkP030=@m6@3om^h0e3dI0080
ooK^00<0e3dI0?ofkP3om^h0703om^h00`000000ooK^0?ofkP100?ofkP030000003om^h0ooK^01T0
ooK^0@3oool005h0ooK^00<000000?ofkP0000001@3om^h0100mFJ/0ooK^0?ofkP0mFJ/20?ofkPH0
?EV[2@3om^h0100mFJ/0ooK^0?ofkP3om^h703eIZ`X0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0m
FJ/0ooK^0?ofkP020?ofkPH0000000<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP050?of
kP0403eIZ`3om^h00000000000@0>e6L00@0e3dI03]AW03D?AT0>e6L1@0000000`3D?AT0=TV;0=@m
6@0703I9R`040000000fBH/0=TV;03I9R`80e3dI1P0fBH/00`000000=TV;03I9R`0803I9R`030=@m
6@0fBH/0=TV;0080=TV;00<0e3dI03I9R`0fBH/0100fBH/00`000000=TV;03I9R`0600000080;Sed
00<0000002hmM00^?G@0200^?G@00`000000;Sed02hmM00702hmM0030000000^?G@0;Sed00L0;Sed
00<0000002hmM00^?G@01@0000000`0T;E<0000002@]D`0702@]D`030000000T;E<092eC00D092eC
00<0000002@]D`0000001P00000501TL=`8000001P0mFJ/00`3D?AT0ooK^0?ofkP0403eIZ`030=@m
6@0mFJ/0ooK^00<0ooK^00<0e3dI0?ofkP3om^h0103om^h0103D?AT0ooK^0?ofkP3D?AT60?ofkP80
e3dI0`3om^h00`3D?AT0ooK^0?ofkP0K0?ofkP030000003om^h0ooK^0480ooK^00<000000?ofkP3o
m^h0603om^h10?ooo`00GP3om^h00`000000ooK^000000050?ofkP0403eIZ`3om^h0ooK^03eIZ`P0
ooK^1P0mFJ/30?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h00P3om^h703eIZ`<0
ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP080?ofkPH000001`3om^h00`0mFJ/0
ooK^0?ofkP050?ofkP0403eIZ`0000000000000000@0>e6L0P3D?AT503]AW0050000000mFJ/0e3dI
0000003D?AT01000000303I9R`030000000fBH/0=TV;0080=TV;00<0e3dI03I9R`0fBH/0100fBH/0
0`000000=TV;03I9R`0703I9R`030=@m6@000000=TV;00@0=TV;0P3D?AT403I9R`030000000fBH/0
=TV;00H0=TV;1@00000802hmM0030000000^?G@0;Sed00L0;Sed00<0000002hmM00^?G@01`0^?G@0
0`000000;Sed02hmM00502hmM0D000001P0T;E<00`00000092eC02@]D`0502@]D`030000000T;E<0
92eC00<092eC1`000000103D?AT06A`g0000000000020?ofkP80?EV[00<0e3dI03eIZ`0mFJ/01@0m
FJ/00`3D?AT0?EV[03eIZ`0203eIZ`030=@m6@3om^h0ooK^00@0ooK^00@0e3dI0?ofkP3om^h0e3dI
1P3om^h20=@m6@80ooK^00<0e3dI0?ofkP3om^h0703om^h00`000000ooK^0?ofkP120?ofkP030000
003om^h0ooK^01P0ooK^0@3oool005h0ooK^00<000000?ofkP000000103om^h0100mFJ/0ooK^0?of
kP0mFJ/?0?ofkPH0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP090?ofkPH0?EV[1`3om^h00`0mFJ/0ooK^
0?ofkP080?ofkP0303eIZ`3om^h0ooK^00<0ooK^1@0000020?ofkP0303eIZ`3om^h0ooK^00D0ooK^
00@0?EV[0000000000000000100kDI`20=@m6@D0>e6L00@0000003]AW00kDI`0e3dI1@0kDI`60000
0080=TV;0P3D?AT503I9R`030000000fBH/0=TV;00L0=TV;00<0e3dI0000000fBH/01P0fBH/01@3D
?AT0=TV;03I9R`0fBH/0000000X0=TV;00<0000003I9R`0fBH/01P00000202hmM0030000000^?G@0
;Sed00L0;Sed00<0000002hmM00^?G@0200^?G@00`000000;Sed02hmM00602hmM0030000000^?G@0
;Sed00D0000000<092eC0000000T;E<01`0T;E<00`00000092eC02@]D`0502@]D`040000000T;E<0
92eC02@]D`D000000P3om^h00`3D?AT0?EV[0?ofkP020?ofkP@0?EV[00H0e3dI03eIZ`0mFJ/0?EV[
0=@m6@3om^h503eIZ`80ooK^0P3D?AT70?ofkP040=@m6@3om^h0ooK^0=@m6Ah0ooK^00<000000?of
kP3om^h0@`3om^h00`000000ooK^0?ofkP0H0?ofkP40oooo001N0?ofkP030000003om^h0000000@0
ooK^00@0?EV[0?ofkP3om^h0?EV[4@3om^h0100mFJ/0ooK^0?ofkP3om^h603eIZ``0ooK^00<0?EV[
0?ofkP3om^h01@0mFJ/20?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h0203om^h6
000000<0ooK^00<0?EV[0000003D?AT00P00000403]AW080e3dI1@0kDI`010000000>e6L03]AW03D
?AT803]AW0050000000mFJ/0>e6L0000003D?AT00P0000000`3D?AT0000003I9R`0203I9R`030000
000fBH/0=TV;00L0=TV;00<0e3dI0000000fBH/01`0fBH/0103D?AT0=TV;03I9R`00000:03I9R`03
0000000fBH/0=TV;00H0=TV;1@00000702hmM0030000000^?G@0;Sed00P0;Sed00<0000002hmM00^
?G@01`0^?G@00`000000;Sed02hmM00402hmM0D000001P0T;E<00`00000092eC02@]D`0502@]D`03
0000000T;E<092eC00D092eC00<0000003eIZ`3D?AT02@3om^h0103D?AT0?EV[03eIZ`3D?AT503eI
Z`030?ofkP0mFJ/0?EV[0080e3dI00<0?EV[0?ofkP3om^h00`3om^h20=@m6@030?ofkP3D?AT0e3dI
01d0ooK^00<000000?ofkP3om^h0A03om^h00`000000ooK^0?ofkP0H0?ofkP40oooo001N0?ofkP80
00001@3om^h0100mFJ/0ooK^0?ofkP0mFJ/A0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?of
kP3om^h01P0mFJ/60?ofkP0303eIZ`3om^h0ooK^00D0ooK^1@0mFJ/70?ofkP0303eIZ`3om^h0ooK^
00X0ooK^00<0?EV[0?ofkP3om^h00P3om^h6000000809`/500D0000003]AW00kDI`0>e6L0=@m6@06
03]AW0030000000kDI`0>e6L0080e3dI1`0kDI`01@000000>e6L03]AW00kDI`0e3dI00<0>e6L00<0
e3dI0000000000001000000603I9R`030=@m6@0fBH/0000000T0=TV;0P3D?AT00`000000=TV;03I9
R`0803I9R`030000000fBH/0=TV;00P0=TV;00<0000003I9R`0fBH/01P00000202hmM0030000000^
?G@0;Sed00L0;Sed00<0000002hmM00^?G@01`0^?G@00`000000;Sed02hmM00602hmM0030000000^
?G@0;Sed00H0000000<092eC0000000T;E<01P0T;E<00`00000092eC02@]D`0502@]D`030=@m6@3o
m^h0ooK^00P0ooK^00@0e3dI0?ofkP3D?AT0ooK^200mFJ/00`3D?AT0?EV[03eIZ`0503eIZ`040=@m
6@3om^h0ooK^0=@m6Ah0ooK^00<000000?ofkP3om^h0A03om^h00`000000ooK^0?ofkP0H0?ofkP40
oooo001N0?ofkP8000001@3om^h0100mFJ/0ooK^0?ofkP0mFJ/A0?ofkP0303eIZ`3om^h0ooK^00@0
ooK^00<0?EV[0?ofkP3om^h01P3om^h603eIZ`T0ooK^00@0?EV[0?ofkP3om^h0ooK^1@0mFJ/20?of
kP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/00000000000060000
00030=@m6@0kDI`0>e6L00@0>e6L00D0000003]AW03D?AT0>e6L0=@m6@0703]AW0040000000kDI`0
>e6L0=@m6@D0>e6L00@0e3dI03]AW00kDI`000000P0kDI`6000000030=@m6@0fBH/0000000/0=TV;
00<0e3dI03I9R`0fBH/0200fBH/00`000000=TV;03I9R`0803I9R`030000000fBH/0=TV;00H0=TV;
1@00000702hmM0030000000^?G@0;Sed00L0;Sed00<0000002hmM00^?G@01`0^?G@00`000000;Sed
02hmM00502hmM0D000001@0T;E<00`00000092eC02@]D`0502@]D`<0?EV[203om^h20=@m6@0303eI
Z`3om^h0ooK^00<0ooK^0P0mFJ/20=@m6@H0?EV[0P3D?AT00`0mFJ/0e3dI0=@m6@0303eIZaX0ooK^
00<000000?ofkP3om^h0AP3om^h00`000000ooK^0?ofkP0G0?ofkP40oooo001M0?ofkP030000003o
m^h0000000D0ooK^00@0?EV[0?ofkP3om^h0?EV[4@3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eI
Z`3om^h0ooK^00/0ooK^1`0mFJ/30?ofkP0303eIZ`3om^h0ooK^00H0ooK^1P0mFJ/90?ofkP0303eI
Z`3om^h0ooK^00D0ooK^00<000000=@m6@0000000P0W2`D010000000>e6L03]AW00kDI`500000080
>e6L00<0000003]AW03D?AT00P0kDI`00`3D?AT0>e6L03]AW00403]AW0040000000kDI`0>e6L0=@m
6@H0>e6L00<0e3dI03]AW00000001`0kDI`00`3D?AT0000000000003000000T0=TV;00<000000=@m
6@0fBH/0200fBH/00`000000=TV;03I9R`0803I9R`030000000fBH/0=TV;00P0=TV;00<0000003I9
R`0fBH/01P00000202hmM0030000000^?G@0;Sed00L0;Sed00<0000002hmM00^?G@01P0^?G@00`00
0000;Sed02hmM00702hmM0030000000^?G@0;Sed00D0000000<092eC0000000T;E<00`0T;E<0103D
?AT092eC02@]D`00000603eIZ`<0ooK^00@0e3dI0?ofkP3om^h0?EV[1@3om^h00`0mFJ/0e3dI0=@m
6@020?ofkP@0?EV[103D?AT203eIZ`80ooK^1P0mFJ/D0?ofkP030000003om^h0ooK^04H0ooK^00<0
00000?ofkP3om^h05`3om^h10?ooo`00G@3om^h00`000000ooK^000000040?ofkP0403eIZ`3om^h0
ooK^03eIZa80ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3o
m^h0ooK^00@0ooK^1P0mFJ/80?ofkP0403eIZ`3om^h0ooK^0?ofkPH0?EV[0`3om^h00`0mFJ/0ooK^
0?ofkP040?ofkP0403eIZ`000000e3dI000000809`/500H0000003]AW00kDI`0e3dI03]AW03D?AT3
03]AW0H0000000<0>e6L0=@m6@0kDI`01@0kDI`010000000>e6L03]AW03D?AT703]AW0030=@m6@00
0000>e6L00H0>e6L00H0e3dI03]AW00kDI`0000003eIZ`0kDI`6000000<0=TV;00@0000003I9R`3D
?AT0e3dI1`0fBH/00`000000=TV;03I9R`0803I9R`030000000fBH/0=TV;00P0=TV;00<0000003I9
R`0fBH/01P0fBH/5000000L0;Sed00<0000002hmM00^?G@01P0^?G@00`000000;Sed02hmM00802hm
M0030000000^?G@0;Sed00@0;Sed1@00000502@]D`030000003om^h0ooK^00D0?EV[0P3D?AT00`0m
FJ/0ooK^03eIZ`030?ofkP80?EV[00<0e3dI0?ofkP3D?AT01@3om^h40=@m6@P0?EV[0`3om^h603eI
Z`d0ooK^00<000000?ofkP3om^h0A`3om^h00`000000ooK^0?ofkP0G0?ofkP40oooo001M0?ofkP03
0000003om^h0000000@0ooK^00@0?EV[0?ofkP3om^h0?EV[4P3om^h00`0mFJ/0ooK^0?ofkP030?of
kP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP0603eI
Z`80ooK^00<0?EV[0?ofkP3om^h01`3om^h703eIZ`<0ooK^00@0?EV[01D60P00000000000P0W2`D0
1P000000>e6L03]AW03D?AT0>e6L0=@m6@D0>e6L00@000000=@m6@0kDI`0>e6L1P00000203]AW003
0000000kDI`0e3dI00P0>e6L00<0e3dI0000000kDI`01@0kDI`01@3D?AT0>e6L03]AW00kDI`00000
00P0>e6L1P0000000`0fBH/0e3dI03I9R`0503I9R`030000000fBH/0=TV;00P0=TV;00<0000003I9
R`0fBH/0200fBH/00`000000=TV;03I9R`0803I9R`030000000fBH/0=TV;00H000000P0^?G@00`00
0000;Sed02hmM00602hmM0030000000^?G@0;Sed00L0;Sed00<0000002hmM00^?G@01P0^?G@00`00
0000;Sed02hmM0050000000302@]D`000000ooK^00@0ooK^00<0?EV[0=@m6@3D?AT01`0mFJ/0103o
m^h0e3dI0?ofkP3D?AT40?ofkP030=@m6@3om^h0e3dI0080e3dI0P3om^h0100mFJ/0ooK^0?ofkP3o
m^h703eIZ`80ooK^1`0mFJ/70?ofkP030000003om^h0ooK^04P0ooK^00<000000?ofkP3om^h05`3o
m^h10?ooo`00G@3om^h00`000000ooK^000000040?ofkP@0?EV[4@3om^h00`0mFJ/0ooK^0?ofkP04
0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP06
0?ofkPH0?EV[2@3om^h0100mFJ/0ooK^0?ofkP3om^h403eIZ`<000000P0W2`D2000000040=@m6@0k
DI`0>e6L0=@m6@D0>e6L00<000000=@m6@0kDI`00`0kDI`0103D?AT0>e6L03]AW00kDI`6000000P0
>e6L00<0e3dI03]AW00kDI`0100kDI`01@3D?AT0>e6L03]AW00kDI`0000000/0>e6L00@0000003]A
W00kDI`000000`3D?AT200000080=TV;00<0000003I9R`0fBH/0200fBH/00`000000=TV;03I9R`08
03I9R`030000000fBH/0=TV;00P0=TV;00<0000003I9R`0fBH/01P0fBH/5000000H0;Sed00<00000
02hmM00^?G@01`0^?G@00`000000;Sed02hmM00702hmM0030000000^?G@0;Sed00@0;Sed0`000004
0?ofkP050=@m6@3om^h0ooK^0=@m6@3om^h01@0mFJ/0103D?AT0?EV[03eIZ`3D?AT303eIZ`030?of
kP3D?AT0ooK^0080e3dI0`3om^h00`0mFJ/0ooK^0?ofkP020?ofkP80?EV[0`3om^h703eIZ`<0ooK^
1@0mFJ/20?ofkP030000003om^h0ooK^04T0ooK^00<000000?ofkP3om^h05P3om^h10?ooo`00G@3o
m^h2000000D0ooK^00<0?EV[0?ofkP3om^h0200mFJ/:0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0
?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0
?EV[0?ofkP3om^h00P3om^h603eIZ`<0ooK^00<0?EV[0?ofkP3om^h0103om^h4000000809`/500<0
000003iGZ03D?AT00P000000103D?AT0000000000000000203]AW0030=@m6@0kDI`0>e6L00@0>e6L
00<0e3dI03]AW00kDI`00P0kDI`010000000>e6L0=@m6@0kDI`5000000<0>e6L00<000000=@m6@0k
DI`0100kDI`01@3D?AT0>e6L03]AW00kDI`0000000/0>e6L00@0000003]AW00kDI`0e3dI0`0kDI`2
0=@m6@D00000200fBH/00`000000=TV;03I9R`0903I9R`030000000fBH/0=TV;00L0=TV;00<00000
03I9R`0fBH/0200fBH/00`000000=TV;03I9R`0500000080;Sed00<0000002hmM00^?G@01`0^?G@0
0`000000;Sed02hmM00602hmM0030000000^?G@0;Sed00L0;Sed00D000000?ofkP3om^h0ooK^0=@m
6@020?ofkP030=@m6@3om^h0ooK^0080?EV[0P3om^h0103D?AT0?EV[03eIZ`3D?AT303eIZ`040=@m
6@0mFJ/0e3dI0=@m6@<0?EV[0P3om^h0100mFJ/0ooK^0?ofkP0mFJ/:0?ofkPL0?EV[0`3om^h503eI
ZdT0ooK^00<000000?ofkP3om^h05P3om^h10?ooo`00G@3om^h2000000D0ooK^00@0?EV[0?ofkP3o
m^h0?EV[1`3om^h703eIZ`<0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0;0?of
kP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP080?of
kPL0?EV[0`3om^h40000000502L;1@000000000003iGZ03D?AT00`0nEjP00`3D?AT0?UNX03iGZ002
000000030=@m6@000000000000D0>e6L00H0e3dI03]AW00kDI`0>e6L0000003D?AT703]AW0H00000
0`0kDI`00`3D?AT0>e6L03]AW00203]AW0030000000kDI`0>e6L00T0>e6L00@0000003]AW00kDI`0
e3dI1@0kDI`20=@m6@030000000mFJ/0>e6L00H000000P0fBH/00`000000=TV;03I9R`0903I9R`03
0000000fBH/0=TV;00L0=TV;00<0000003I9R`0fBH/0200fBH/00`000000=TV;03I9R`0503I9R`D0
00001`0^?G@00`000000;Sed02hmM00702hmM0030000000^?G@0;Sed00H0;Sed00@000000?ofkP3o
m^h0e3dI0`3om^h00`3D?AT0ooK^0?ofkP0203eIZ`030?ofkP3D?AT0ooK^0080ooK^00@0e3dI0?of
kP3om^h0ooK^103D?AT203eIZ`030?ofkP0mFJ/0?EV[00@0?EV[3P3om^h903eIZ`80ooK^100mFJ]5
0?ofkP030000003om^h0ooK^01H0ooK^0@3oool005`0ooK^00<000000?ofkP0000001@3om^h0100m
FJ/0ooK^0?ofkP0mFJ/>0?ofkPL0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0
ooK^00L0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0403eIZ`3om^h0
ooK^0?ofkPH0?EV[00D0000002L;1@00000000000=@m6@0403iGZ0030=@m6@0nEjP0?UNX0080?UNX
00<0e3dI03iGZ00nEjP01@0000001P3D?AT0>e6L03]AW00kDI`000000=@m6@X0>e6L00<0000003]A
W00kDI`01P00000203]AW0030000000kDI`0>e6L00T0>e6L00<0000003]AW03D?AT0200kDI`20=@m
6@L0>e6L1@00000903I9R`030000000fBH/0=TV;00P0=TV;00<0000003I9R`0fBH/01`0fBH/00`00
0000=TV;03I9R`0703I9R`030000000fBH/0=TV;00H000000P0^?G@00`000000;Sed02hmM00602hm
M0030000000^?G@0;Sed00L0;Sed00<000000?ofkP3D?AT00`3om^h01`3D?AT0ooK^03eIZ`3om^h0
?EV[0?ofkP3D?AT00`3om^h00`3D?AT0ooK^0?ofkP040=@m6@<0ooK^1P0mFJ/00`3om^h0?EV[03eI
Z`0303eIZ`X0ooK^00@0?EV[0?ofkP3om^h0ooK^300mFJ]30?ofkP030000003om^h0ooK^01H0ooK^
0@3oool005`0ooK^00<000000?ofkP000000103om^h0100mFJ/0ooK^0?ofkP0mFJ/B0?ofkP0403eI
Z`3om^h0ooK^0?ofkPH0?EV[2P3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00P0
ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP030?ofkP040000000E1P80000002L;
1@@0?EV[00<0e3dI03iGZ00nEjP00P0nEjP01P3D?AT0?UNX03iGZ00nEjP0e3dI000000P0?UNX00@0
e3dI000000000000e3dI0P00000903]AW0040000000kDI`0>e6L03]AW080e3dI0`0kDI`6000000P0
>e6L00<0000003]AW03D?AT0200kDI`010000000>e6L0=@m6@3D?AT703]AW0030000000mFJ/0>e6L
00H000000`0fBH/00`000000=TV;03I9R`0803I9R`030000000fBH/0=TV;00L0=TV;00<0000003I9
R`0fBH/01`0fBH/00`000000=TV;03I9R`0603I9R`D000001`0^?G@00`000000;Sed02hmM00602hm
M0030000003D?AT0ooK^00@0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@040?ofkP050=@m6@3om^h0
e3dI0=@m6@3om^h00P3D?AT50?ofkP0303eIZ`3om^h0ooK^00H0?EV[00<0ooK^03eIZ`0mFJ/00`0m
FJ/50?ofkP0403eIZ`3om^h0ooK^0?ofkP80?EV[203om^h403eIZd40ooK^00<000000?ofkP3om^h0
5P3om^h10?ooo`00G03om^h00`000000ooK^000000040?ofkP0403eIZ`3om^h0ooK^03eIZa80ooK^
00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0703eIZ`<0ooK^00<0?EV[0?ofkP3om^h0
203om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h0
0`3om^h0100000005@H20000000W2`D200000080>A0800<0000003iGZ00nEjP00`0nEjP01@3D?AT0
?UNX03iGZ03D?AT0000000P0?UNX00@0e3dI03iGZ00nEjP0e3dI0P0nEjP6000000<0>e6L00<00000
03]AW00kDI`00P0kDI`00`3D?AT0>e6L03]AW00303]AW0040000000kDI`0>e6L03]AW0D000000`0k
DI`00`000000>e6L0=@m6@0803]AW0040000000kDI`0>e6L03]AW080e3dI1@0kDI`00`000000>e6L
03]AW00603]AW0H00000200fBH/00`000000=TV;03I9R`0803I9R`030000000fBH/0=TV;00L0=TV;
00<0000003I9R`0fBH/01`0fBH/00`000000=TV;03I9R`060000000302hmM0000000;Sed00L0;Sed
00@0e3dI03eIZ`0mFJ/0?EV[0P3om^h00`0mFJ/0e3dI0?ofkP020?ofkP030=@m6@3om^h0ooK^0080
ooK^0`3D?AT00`3om^h0e3dI0=@m6@050?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/01@3om^h403eI
Z`80ooK^1@0mFJ/0103om^h0?EV[0?ofkP0mFJ/>0?ofkP0303eIZ`3om^h0ooK^03l0ooK^00<00000
0?ofkP3om^h05@3om^h10?ooo`00G03om^h00`000000ooK^000000040?ofkP0303eIZ`3om^h0ooK^
00@0?EV[3`3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00P0ooK^1P0mFJ/80?of
kP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP030?of
kP<0000000<09`/50000000i40P00P0i40P00`000000?UNX03iGZ00303iGZ0030=@m6@0nEjP0e3dI
0080?UNX00<0000003iGZ00nEjP01P0nEjP00`3D?AT0?UNX0=@m6@0803iGZ0H000000P0kDI`30=@m
6@<0>e6L00<0000003]AW00kDI`01P0kDI`6000000P0>e6L00<0000003]AW00kDI`00`0kDI`20=@m
6@<0>e6L00<0000003]AW00kDI`02@0kDI`00`000000>e6L03]AW00600000080=TV;00<0000003I9
R`0fBH/0200fBH/00`000000=TV;03I9R`0703I9R`030000000fBH/0=TV;00L0=TV;00<0000003I9
R`0fBH/01P0fBH/5000000L0;Sed00<000000?ofkP0mFJ/00P0mFJ/01P3D?AT0?EV[03eIZ`3D?AT0
ooK^03eIZ`<0ooK^0P3D?AT20?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h00P3o
m^h00`0mFJ/0ooK^0?ofkP070?ofkPD0?EV[0P3om^h503eIZ`h0ooK^00<0?EV[0?ofkP3om^h0?P3o
m^h00`000000ooK^0?ofkP0E0?ofkP40oooo001L0?ofkP8000001@3om^h0100mFJ/0ooK^0?ofkP0m
FJ/30?ofkPH0?EV[203om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0
?EV[0?ofkP3om^h01@0mFJ/30?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h02`3o
m^h00`0mFJ/0ooK^0?ofkP030?ofkP0603eIZ`0E1P8000000000000W2`D000000`0i40P00`000000
?UNX03iGZ00303iGZ0030=@m6@0nEjP0e3dI0080?UNX00<0000003iGZ00nEjP01P0nEjP20=@m6@03
0000000nEjP0?UNX00T0?UNX00D0000003iGZ00nEjP000000=@m6@03000000040=@m6@0kDI`0>e6L
000000/0>e6L00<000000=@m6@0kDI`01P00000203]AW0030000000kDI`0>e6L00D0>e6L0P3D?AT0
0`0kDI`0000003]AW00:03]AW0030000000kDI`0>e6L00H0>e6L1@00000803I9R`030000000fBH/0
=TV;00L0=TV;00<0000003I9R`0fBH/0200fBH/00`000000=TV;03I9R`0703I9R`030000000fBH/0
=TV;00H0000000<0;Sed0000000mFJ/00`0mFJ/0103D?AT0ooK^0?ofkP3D?AT403eIZ`<0e3dI00<0
ooK^0=@m6@3D?AT01@3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00/0ooK^0`0m
FJ/0103om^h0?EV[0?ofkP3om^h503eIZ`T0ooK^00<0?EV[0?ofkP3om^h0?P3om^h00`000000ooK^
0?ofkP0E0?ofkP40oooo001L0?ofkP8000001@3om^h0100mFJ/0ooK^0?ofkP0mFJ/90?ofkPH0?EV[
0P3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h0
1@3om^h603eIZ`L0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP030?ofkP800000
00@09`/50000000W2`D000000`0i40P00`000000?UNX03iGZ00303iGZ0030=@m6@0nEjP0e3dI0080
?UNX00<0000003iGZ00nEjP01`0nEjP00`3D?AT0000003iGZ00:03iGZ0050000000nEjP0?UNX03iG
Z03D?AT0100nEjP00`3D?AT0000000000002000000T0>e6L00<0e3dI03]AW00kDI`01P0kDI`60000
00H0>e6L0`3D?AT:03]AW0030000000kDI`0>e6L00P0>e6L00<0000003]AW00kDI`01P00000203I9
R`030000000fBH/0=TV;00L0=TV;00<0000003I9R`0fBH/0200fBH/00`000000=TV;03I9R`0703I9
R`030000000fBH/0=TV;00H0=TV;0`000000100mFJ/0ooK^0?ofkP3om^h20=@m6@@0?EV[00@0e3dI
03eIZ`3D?AT0?EV[0P3D?AT50?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h0303o
m^h01@0mFJ/0ooK^0000003om^h0?EV[00H0ooK^1@0mFJ/50?ofkP0303eIZ`3om^h0ooK^03d0ooK^
00<000000?ofkP3om^h05@3om^h10?ooo`00F`3om^h00`000000ooK^000000050?ofkP0303eIZ`3o
m^h0?EV[0100ooK^1P0mFJ/30?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h0203o
m^h00`0mFJ/0ooK^0?ofkP0503eIZ`80ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?of
kP030?ofkP80000000@09`/500000000000000000`0i40P00`000000?UNX03iGZ00403iGZ0050=@m
6@0nEjP0?UNX03iGZ00000002@0nEjP20=@m6@/0?UNX00@0000003iGZ00nEjP0e3dI1P0nEjP20=@m
6@80?UNX1P00000303]AW0030=@m6@0kDI`0>e6L00P0>e6L00@0000003]AW00kDI`0>e6L1@000002
03]AW0030=@m6@0kDI`0e3dI0080e3dI1`0kDI`00`000000>e6L03]AW00803]AW0030000000kDI`0
>e6L00H0>e6L1@00000803I9R`030000000fBH/0=TV;00L0=TV;00<0000003I9R`0fBH/0200fBH/0
0`000000=TV;03I9R`0703I9R`030000000mFJ/0ooK^0080ooK^0P3D?AT20?ofkP80e3dI00@0?EV[
0=@m6@3D?AT0?EV[0P3D?AT603eIZ`H0ooK^00<0?EV[0?ofkP3om^h02`3om^h01P0mFJ/0ooK^0?of
kP000000ooK^03eIZ`/0ooK^1@0mFJ/00`3om^h0?EV[0?ofkP0n0?ofkP030000003om^h0ooK^01@0
ooK^0@3oool005/0ooK^00<000000?ofkP0000001@3om^h00`0mFJ/0ooK^03eIZ`0B0?ofkP0403eI
Z`3om^h0ooK^0?ofkPH0?EV[2P3om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^00D0
ooK^1P0mFJ/:0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0000002L;1@0W2`D00`00000403T@2003
0000000nEjP0?UNX00<0?UNX00D0e3dI03iGZ00nEjP0?UNX0000000803iGZ0040=@m6@0nEjP00000
0=@m6@X0?UNX00@0000003iGZ00nEjP0e3dI1`0nEjP00`000000e3dI03iGZ00603iGZ080000000@0
e3dI0000000000000000200kDI`00`000000>e6L03]AW00603]AW0H0000000<0>e6L0=@m6@3D?AT0
1@0kDI`00`000000>e6L03]AW00803]AW0030000000kDI`0>e6L00P0>e6L00<0000003]AW00kDI`0
1P00000203I9R`030000000fBH/0=TV;00L0=TV;00<0000003I9R`0fBH/0200fBH/00`000000=TV;
03I9R`0703I9R`030000003om^h0ooK^0080ooK^00<0e3dI0?ofkP3D?AT00P3D?AT20?ofkP050=@m
6@3om^h0e3dI0=@m6@3om^h02`0mFJ/20?ofkP0303eIZ`3om^h0ooK^00T0ooK^00@0?EV[0?ofkP3o
m^h000000`3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP<0?EV[?P3om^h00`000000ooK^0?ofkP0D0?of
kP40oooo001K0?ofkP030000003om^h0000000@0ooK^00@0?EV[0?ofkP3om^h0?EV[4P3om^h00`0m
FJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00D0?EV[1@3om^h00`0mFJ/0ooK^0?ofkP080?of
kP0303eIZ`3om^h0ooK^00P0ooK^00@0?EV[0?ofkP3om^h0ooK^1P0mFJ/40?ofkP0303eIZ`3om^h0
ooK^0080ooK^0P00000202L;1@80000000<0>A080000000i40P00P0i40P00`000000?UNX03iGZ003
03iGZ080e3dI0P0nEjP00`000000?UNX03iGZ00603iGZ0050=@m6@0nEjP0?UNX0000003D?AT02@0n
EjP010000000?UNX03iGZ03D?AT703iGZ0030000000nEjP0e3dI00P0?UNX00@0e3dI0000000nEjP0
?UNX1P00000203]AW0030000000kDI`0>e6L00L0>e6L00<0e3dI0000000kDI`00P0kDI`600000003
03]AW0000000>e6L00X0>e6L00<0000003]AW00kDI`0200kDI`00`000000>e6L03]AW00603]AW0D0
0000200fBH/00`000000=TV;03I9R`0703I9R`030000000fBH/0=TV;00P0=TV;00<000000?ofkP3o
m^h00`3D?AT20?ofkP060=@m6@0mFJ/0e3dI0=@m6@3om^h0e3dI103om^h00`0mFJ/0ooK^0?ofkP02
0?ofkPT0?EV[203om^h01@0mFJ/0ooK^0?ofkP3om^h0000000<0ooK^00<0?EV[0?ofkP3om^h03`3o
m^h00`0mFJ/0ooK^0?ofkP0l0?ofkP030000003om^h0ooK^01@0ooK^0@3oool005/0ooK^00<00000
0?ofkP000000103om^h0100mFJ/0ooK^0?ofkP0mFJ/B0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0
?EV[0?ofkP3om^h01@3om^h403eIZ`030?ofkP0mFJ/0ooK^00T0ooK^00<0?EV[0?ofkP3om^h0203o
m^h00`0mFJ/0ooK^0?ofkP070?ofkPH0?EV[0`3om^h2000000809`/50P0000000`0i40P0000003T@
200203T@20<000000P0nEjP00`3D?AT0?UNX0=@m6@0303iGZ0030000000nEjP0?UNX00D0?UNX00H0
e3dI03iGZ00nEjP0000003iGZ03D?AT803iGZ0030000000nEjP0e3dI00P0?UNX00<0000003iGZ00n
EjP00P3D?AT603iGZ0030=@m6@000000?UNX00L0?UNX1@00000603]AW0030=@m6@0kDI`0000000T0
>e6L1P00000703]AW0030000000kDI`0>e6L00P0>e6L00<0000003]AW00kDI`0200kDI`00`000000
?EV[03]AW00600000080=TV;00<0000003I9R`0fBH/01`0fBH/00`000000=TV;03I9R`0803I9R`03
0000003D?AT0e3dI0080e3dI0P3om^h00`3D?AT0ooK^03eIZ`040=@m6@@0ooK^00<0?EV[0?ofkP3o
m^h0203om^h803eIZ`80ooK^00D0?EV[0?ofkP3om^h0ooK^000000050?ofkP0303eIZ`3om^h0ooK^
00l0ooK^00<0?EV[0?ofkP3om^h0>`3om^h00`000000ooK^0?ofkP0D0?ofkP40oooo001K0?ofkP80
00001@3om^h0100mFJ/0ooK^0?ofkP0mFJ/B0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?of
kP3om^h02P3om^h503eIZ`L0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP0<0?of
kP0303eIZ`3om^h0?EV[0080?EV[0P00000202L;1@040000000i40P0>A08000000<0>A0800<00000
045L/P11G;800P000000103D?AT000000000003D?AT203iGZ0030000000nEjP0?UNX00@0?UNX00D0
e3dI03iGZ00nEjP0?UNX0000000203iGZ0030=@m6@0nEjP0?UNX00D0?UNX00<0000003iGZ03D?AT0
200nEjP00`000000?UNX03iGZ00203iGZ0030=@m6@0nEjP0?UNX0080?UNX00<0e3dI03iGZ0000000
2P0nEjP00`000000?UNX03iGZ006000000030=@m6@0kDI`0000000X0>e6L00D0000003]AW03D?AT0
e3dI03]AW00500000080>e6L00<0000003]AW00kDI`0200kDI`00`000000>e6L03]AW00803]AW003
0000000kDI`0>e6L00H0>e6L1@00000803I9R`030000000fBH/0=TV;00H0=TV;0P3D?AT01P3om^h0
e3dI0?ofkP3D?AT0ooK^0=@m6@80ooK^0P3D?AT00`3om^h0e3dI0?ofkP030?ofkP0303eIZ`3om^h0
ooK^00T0ooK^00<0?EV[0?ofkP3om^h00`3om^h803eIZ`H0ooK^00<0?EV[0?ofkP3om^h03`3om^h0
0`0mFJ/0ooK^0?ofkP0k0?ofkP030000003om^h0ooK^01@0ooK^0@3oool005/0ooK^0P0000050?of
kP@0?EV[4@3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00/0ooK^00@0?EV[0?of
kP3om^h0ooK^1@0mFJ/20?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h0303om^h0
0`0mFJ/0ooK^0?ofkP020?ofkP8000000P0W2`D010000000>A0803T@2000000203T@208000001011
G;801@3D?AT0@Ebb045L/P11G;80e3dI00@00000100nEjP01@3D?AT0?UNX03iGZ00nEjP0000000<0
?UNX00<0e3dI03iGZ00nEjP0100nEjP00`000000?UNX0=@m6@0803iGZ0030000000nEjP0?UNX00<0
?UNX00L0e3dI03iGZ00nEjP0?UNX0=@m6@0nEjP0000000X0?UNX00<0000003iGZ00nEjP01@0nEjP0
0`3D?AT0000000000003000000P0>e6L00@0000003]AW00kDI`0>e6L0`3D?AT303]AW0H000001`0k
DI`00`000000>e6L03]AW00803]AW0030000000kDI`0>e6L00P0>e6L00<0000003eIZ`0kDI`01P00
000203I9R`030000000fBH/0=TV;00@0=TV;0P3D?AT02`0fBH/000000?ofkP3D?AT0ooK^0=@m6@3o
m^h0e3dI0?ofkP3D?AT0?EV[00<0e3dI103om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0
ooK^00@0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`000000?EV[03eIZ`0303eIZ`80ooK^00<0?EV[
0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP0k0?ofkP030000003om^h0ooK^01<0ooK^0@3oool0
05X0ooK^00<000000?ofkP0000001@3om^h0100mFJ/0ooK^03eIZ`3om^h703eIZ`X0ooK^00<0?EV[
0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00H0ooK^1@0mFJ/7
0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h00P3om^h3000000809`/500@00000
03T@200i40P000000P0i40P00`000000BaH;00000002045L/P030=@m6@11G;80@Ebb0080@Ebb00<0
e3dI045L/P0000000P11G;84000000050=@m6@000000?UNX03iGZ00000000`0nEjP00`3D?AT0?UNX
03iGZ00403iGZ0030000003D?AT0?UNX00T0?UNX00<0000003iGZ00nEjP00`0nEjP30=@m6@80?UNX
00<0000003iGZ00nEjP0200nEjP00`000000?UNX03iGZ00503iGZ0040=@m6@0nEjP0?UNX00000080
?UNX1P00000203]AW0030000000kDI`0>e6L00@0>e6L103D?AT00`0kDI`0000003]AW00203]AW0H0
000000<0>e6L0000000kDI`02@0kDI`00`000000>e6L03]AW00803]AW0030000000kDI`0>e6L00H0
>e6L1@0000040=@m6@@0=TV;00<0e3dI0?ofkP3om^h00P3D?AT20?ofkP040=@m6@0mFJ/0e3dI0=@m
6@@0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0503eIZ`3om^h0ooK^
0?ofkP0000001P3om^h603eIZ`h0ooK^00<0?EV[0?ofkP3om^h0>`3om^h00`000000ooK^0?ofkP0C
0?ofkP40oooo001J0?ofkP030000003om^h0000000D0ooK^00<0?EV[0?ofkP0mFJ/0203om^h703eI
Z`<0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^
00P0ooK^00<0?EV[0?ofkP3om^h01P0mFJ/00`3om^h0?EV[0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^
0080ooK^0`00000202L;1@060000000i40P0>A080000000i40P000000P1;5P/010000000@Ebb045L
/P3D?AT5045L/P030=@m6@000000@Ebb00@0@Ebb00<0e3dI045L/P11G;801@00000203iGZ0030=@m
6@0nEjP0?UNX00<0?UNX00<000000=@m6@0nEjP02@0nEjP00`000000?UNX03iGZ00503iGZ0040=@m
6@0nEjP0?UNX000000X0?UNX00<0000003iGZ00nEjP0100nEjP01@3D?AT0?UNX03iGZ00nEjP00000
00P0?UNX1@00000403]AW0040=@m6@0kDI`0>e6L03]AW0H0e3dI1@0kDI`6000000H0>e6L00<00000
03]AW00kDI`0200kDI`00`000000>e6L03]AW00603]AW0D0e3dI00<000000=@m6@0000000`000002
03I9R`030=@m6@3om^h0ooK^0080e3dI00<0ooK^0=@m6@3om^h00P3D?AT50?ofkP0303eIZ`3om^h0
ooK^00/0ooK^00<0?EV[0?ofkP3om^h00`3om^h01@0mFJ/0ooK^0?ofkP3om^h0000000T0ooK^00@0
?EV[0?ofkP3om^h0ooK^1P0mFJ/90?ofkP0303eIZ`3om^h0ooK^03X0ooK^00<000000?ofkP3om^h0
4`3om^h10?ooo`00FP3om^h00`000000ooK^000000050?ofkP0303eIZ`3om^h0?EV[00l0ooK^1P0m
FJ/40?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?of
kP060?ofkPH0?EV[2@3om^h00`0mFJ/0ooK^0?ofkP020?ofkP030000000W2`D09`/500<000000`0i
40P200000080BaH;00@00000045L/P11G;80e3dI1P11G;800`3D?AT00000045L/P03045L/P030=@m
6@11G;80@Ebb0080@Ebb00<00000045L/P11G;800`0000000`3D?AT000000000000203iGZ0030=@m
6@0nEjP0?UNX00T0?UNX00<0000003iGZ00nEjP01@0nEjP30=@m6@030000000nEjP0?UNX00P0?UNX
00<0000003iGZ00nEjP0100nEjP01@3D?AT0?UNX03iGZ00nEjP0000000X0?UNX00<0000003iGZ00n
EjP0100000000`3D?AT0000003]AW00203]AW0030000000kDI`0>e6L0080>e6L1P3D?AT00`000000
>e6L03]AW00203]AW0L000002P0kDI`00`000000>e6L03]AW0060=@m6@80>e6L00D0000003]AW00k
DI`0>e6L0=@m6@0403]AW0040000003D?AT0000003eIZ`80e3dI0P3om^h0103D?AT0ooK^0=@m6@3D
?AT40?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?of
kP020?ofkP030000003om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h01`3om^h703eIZ`80ooK^00<0
?EV[0?ofkP3om^h0>P3om^h00`000000ooK^0?ofkP0C0?ofkP40oooo001J0?ofkP030000003om^h0
000000@0ooK^00@0?EV[0?ofkP3om^h0?EV[4P3om^h00`0mFJ/0ooK^0?ofkP0503eIZ``0ooK^00<0
?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00<0ooK^1P0m
FJ/30?ofkP0603eIZ`3om^h0ooK^0?ofkP3D?AT000000P0W2`D20000000403T@20000000>A0803T@
208000000P1;5P/010000000@Ebb045L/P3D?AT7045L/P030=@m6@11G;80@Ebb0080@Ebb00<0e3dI
045L/P11G;800P11G;800`000000@Ebb045L/P04045L/P050=@m6@11G;8000000000003D?AT00P00
000903iGZ0030000000nEjP0?UNX00@0?UNX00@0e3dI03iGZ00nEjP0?UNX0P3D?AT903iGZ0030000
000nEjP0?UNX00<0?UNX00<0e3dI03iGZ00nEjP00P0nEjP00`000000?UNX03iGZ00803iGZ0030000
000nEjP0?UNX00<0?UNX00<0e3dI03iGZ00nEjP01P00000803]AW0/0e3dI1@0000090=@m6@P0>e6L
00@0000003]AW00kDI`0e3dI1`0kDI`00`000000ooK^0=@m6@0203eIZ`@0e3dI00<0?EV[0?ofkP3o
m^h00P3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/00`3om^h00`00
0000ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^00d0ooK^100mFJ/l0?ofkP030000003om^h0ooK^
0180ooK^0@3oool005X0ooK^0P0000050?ofkP0403eIZ`3om^h0ooK^03eIZa80ooK^00<0?EV[0?of
kP3om^h00`3om^h00`0mFJ/0ooK^03eIZ`0403eIZ`L0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0m
FJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00T0ooK^200mFJ/00`0000009`/502L;1@020000
000503T@20000000>A0803T@200000000`1;5P/00`000000@Ebb0=@m6@08045L/P050=@m6@11G;80
@Ebb045L/P3D?AT01@11G;800`000000@Ebb045L/P05045L/P040=@m6@11G;80@Ebb0=@m6@80@Ebb
1P00000303iGZ0030000000nEjP0?UNX00@0?UNX00H0e3dI03iGZ00nEjP0?UNX0000000nEjP20=@m
6@L0?UNX00<0000003iGZ00nEjP00`0nEjP00`3D?AT0?UNX03iGZ00203iGZ0030000000nEjP0?UNX
00P0?UNX00<0000003iGZ00nEjP00`0nEjP00`3D?AT0?UNX03iGZ00303iGZ0030000000nEjP0?UNX
00H000000P0kDI`00`000000>e6L0=@m6@0803]AW0030000000kDI`0>e6L0080>e6L1`00000:03]A
W0040000000kDI`0>e6L0=@m6@L0>e6L00@000000?ofkP3D?AT0ooK^0P3D?AT00`3om^h0e3dI0=@m
6@0703eIZ`h0ooK^00@0?EV[0?ofkP3om^h0?EV[0`3om^h00`000000ooK^0?ofkP0:0?ofkP0303eI
Z`3om^h0ooK^0100ooK^00<0?EV[0?ofkP3om^h0>P3om^h00`000000ooK^0?ofkP0B0?ofkP40oooo
001J0?ofkP8000001@3om^h0100mFJ/0ooK^0?ofkP0mFJ/A0?ofkP0303eIZ`3om^h0ooK^00@0ooK^
00<0?EV[0?ofkP3om^h0103om^h503eIZ`80ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^
0?ofkP070?ofkP0303eIZ`3om^h0ooK^00`0ooK^00D0?EV[0?ofkP3om^h0ooK^0000000803eIZ`03
03T@20000000BaH;00<0BaH;00<000000=@m6@11G;801`11G;801@000000e3dI045L/P11G;80e3dI
00H0@Ebb00<00000045L/P11G;801@11G;820=@m6@0300000011G;80@Ebb00H0@Ebb1P00000303iG
Z0030=@m6@0nEjP0?UNX0080?UNX00@0000003iGZ00nEjP0?UNX0P3D?AT503iGZ0030000000nEjP0
?UNX0080?UNX00<0e3dI03iGZ00nEjP00`0nEjP00`000000?UNX03iGZ00803iGZ0030000000nEjP0
?UNX0080?UNX00<0e3dI03iGZ00nEjP0100nEjP00`000000?UNX03iGZ00603iGZ0@0000000@0e3dI
00000000000000001@0kDI`00`000000>e6L03]AW00703]AW0030=@m6@000000000000@000001@0k
DI`00`000000>e6L0=@m6@0803]AW0050000003D?AT0e3dI0?ofkP3D?AT00P3om^h00`3D?AT0ooK^
03eIZ`020?ofkPX0?EV[203om^h00`0mFJ/0ooK^03eIZ`040?ofkP030000003om^h0ooK^00X0ooK^
00<0?EV[0?ofkP3om^h0403om^h00`0mFJ/0ooK^0?ofkP0j0?ofkP030000003om^h0ooK^0180ooK^
0@3oool005T0ooK^00<000000?ofkP0000001@3om^h00`0mFJ/0ooK^03eIZ`0B0?ofkP0303eIZ`3o
m^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h02@3om^h603eIZ`L0ooK^00<0?EV[0?ofkP3om^h01`3o
m^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0403eIZ`3om^h0ooK^0?ofkP8000000P0W2`D01@000000>A08
03T@20000000>A0800D0?EV[00<0BaH;0=@m6@11G;802011G;801@000000@Ebb0=@m6@11G;80e3dI
00H0@Ebb00<00000045L/P11G;801P11G;800`3D?AT00000045L/P0:045L/P0300000011G;80@Ebb
00<0000000<0e3dI0000000000000P0nEjP00`000000?UNX03iGZ00303iGZ080e3dI0`0nEjP00`00
0000?UNX03iGZ00203iGZ0030=@m6@0nEjP0?UNX00<0?UNX00<0000003iGZ00nEjP0200nEjP00`00
0000?UNX03iGZ00203iGZ0030=@m6@0nEjP0?UNX00<0?UNX00<0000003iGZ00nEjP02@0nEjP00`00
0000e3dI03iGZ00303iGZ0P000001P0kDI`00`3D?AT0>e6L0000000503]AW0H0000000<0>e6L0=@m
6@0kDI`01`0kDI`0103D?AT0ooK^0=@m6@3D?AT20?ofkP040=@m6@3om^h0ooK^03eIZ`80ooK^00<0
?EV[0?ofkP3om^h00`3om^h:03eIZ`80ooK^00<0?EV[0?ofkP0mFJ/00`3om^h00`000000ooK^0?of
kP0;0?ofkP0303eIZ`3om^h0ooK^0140ooK^00<0?EV[0?ofkP3om^h0>@3om^h00`000000ooK^0?of
kP0B0?ofkP40oooo001I0?ofkP030000003om^h0000000D0ooK^00<0?EV[0?ofkP0mFJ/04P3om^h0
0`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00/0ooK^00@0?EV[0?ofkP3om^h0ooK^1P0m
FJ/00`3om^h0?EV[0?ofkP070?ofkP0303eIZ`3om^h0ooK^00d0ooK^00@0?EV[0?ofkP3om^h0e3dI
0P00000202L;1@080000000i40P0>A080000000i40P0000004/F2`00000204/F2`80?EV[2P11G;80
0`000000e3dI0=@m6@07045L/P0300000011G;80@Ebb00H0@Ebb0`3D?AT:045L/P0300000011G;80
@Ebb00<0@Ebb00<0e3dI045L/P11G;801@00000503iGZ080e3dI00<0?UNX0000000nEjP00P0nEjP0
0`3D?AT0?UNX03iGZ00403iGZ0030000000nEjP0?UNX00L0?UNX00<0000003iGZ00nEjP00P0nEjP0
0`3D?AT0?UNX03iGZ00403iGZ0030000000nEjP0?UNX00T0?UNX00<000000=@m6@0nEjP0200nEjP0
0`000000?UNX03iGZ006000000030=@m6@0kDI`0000000X0>e6L1P00000403]AW0030000003D?AT0
ooK^0080e3dI00<0ooK^0=@m6@3D?AT00P3om^h0100mFJ/0ooK^0?ofkP0mFJ/:0?ofkPT0?EV[103o
m^h00`000000ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^0140ooK^00<0?EV[0?ofkP3om^h0>@3o
m^h00`000000ooK^0?ofkP0B0?ofkP40oooo001I0?ofkP030000003om^h0000000D0ooK^00<0?EV[
0?ofkP0mFJ/04P3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[
0?ofkP3om^h01`3om^h703eIZ`<0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP03
000000809`/500P0000003T@200i40P0000003T@20000000BaH;000000<0BaH;00<00000045L/P11
G;802011G;800`000000@Ebb0=@m6@07045L/P0300000011G;80@Ebb00D0@Ebb00D0e3dI045L/P11
G;8000000=@m6@09045L/P0300000011G;80@Ebb0080@Ebb00<0e3dI045L/P11G;800`11G;800`00
0000@Ebb045L/P060000000303iGZ03D?AT0e3dI00<0?UNX00<0e3dI03iGZ00nEjP0100nEjP00`00
0000?UNX03iGZ00703iGZ0030000000nEjP0?UNX0080?UNX00<0e3dI03iGZ00nEjP0100nEjP00`00
0000?UNX03iGZ00803iGZ0030000003D?AT0?UNX00T0?UNX00<0000003iGZ00nEjP01@0nEjP00`3D
?AT0000000000003000000P0>e6L00<0e3dI03]AW00kDI`00`0kDI`600000080e3dI0P3om^h01`3D
?AT0ooK^0?ofkP3om^h0?EV[0?ofkP0mFJ/04@3om^h603eIZ`030000003om^h0ooK^00`0ooK^00<0
?EV[0?ofkP3om^h04@3om^h00`0mFJ/0ooK^0?ofkP0j0?ofkP030000003om^h0ooK^0140ooK^0@3o
ool005T0ooK^00<000000?ofkP0000001@3om^h00`0mFJ/0ooK^03eIZ`0303eIZ`l0ooK^00<0?EV[
0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[
0?ofkP3om^h0103om^h703eIZ`/0ooK^00P0?EV[0?ofkP3om^h0ooK^0000000W2`D0000002L;1@80
0000100i40P00`000000BaH;0000000404/F2`0300000011G;80@Ebb00L0@Ebb00@00000045L/P3D
?AT0e3dI1P11G;800`000000@Ebb045L/P05045L/P060=@m6@11G;80@Ebb00000011G;80e3dI2011
G;800`000000@Ebb045L/P02045L/P030=@m6@11G;80@Ebb00<0@Ebb00<00000045L/P11G;801P11
G;83000000<0e3dI1`0nEjP00`000000?UNX03iGZ00703iGZ0050000000nEjP0?UNX03iGZ03D?AT0
1`0nEjP00`000000?UNX03iGZ00803iGZ0030000003D?AT0?UNX00P0?UNX00<0000003iGZ00nEjP0
1P0nEjP0103D?AT0?UNX03iGZ000000203iGZ0H000000P0kDI`00`3D?AT0>e6L03]AW00703]AW003
0=@m6@3om^h0000000D000000P3om^h00`0mFJ/0ooK^03eIZ`0B0?ofkP80?EV[0P3om^h00`000000
?EV[03eIZ`0403eIZ`X0ooK^00<0?EV[0?ofkP3om^h0403om^h00`0mFJ/0ooK^0?ofkP0j0?ofkP03
0000003om^h0ooK^0140ooK^0@3oool005T0ooK^0P0000060?ofkP0303eIZ`3om^h0?EV[00<0ooK^
1P0mFJ/80?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^
0?ofkP080?ofkP0303eIZ`3om^h0ooK^00L0ooK^00@0?EV[0?ofkP3om^h0ooK^1P0mFJ/50?ofkP05
03eIZ`3om^h0ooK^0=@m6@0000000P0W2`D20000000503T@20000000>A0803T@200000000`1;5P/0
1@000000BaH;04/F2`1;5P/0000000T0@Ebb00D000000=@m6@11G;80@Ebb0=@m6@05045L/P030000
0011G;80@Ebb00@0@Ebb00D0e3dI045L/P11G;80@Ebb00000002045L/P80e3dI1P11G;800`000000
@Ebb045L/P02045L/P030=@m6@11G;80@Ebb00<0@Ebb00<00000045L/P11G;802011G;800`000000
@Ebb045L/P020=@m6@@000000P0nEjP00`000000?UNX03iGZ00703iGZ0050000000nEjP0?UNX03iG
Z03D?AT01`0nEjP00`000000?UNX03iGZ00803iGZ0030=@m6@0nEjP0?UNX00P0?UNX00<0000003iG
Z00nEjP01@0nEjP0103D?AT0?UNX03iGZ000000903iGZ0030000003D?AT00000008000001@0kDI`2
0=@m6@030000003om^h0e3dI0080ooK^00<0e3dI0?ofkP3om^h01P00000A0?ofkP80?EV[0P3om^h0
0`000000ooK^0?ofkP040?ofkPL0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP0303eIZ`3om^h0
ooK^03T0ooK^00<000000?ofkP3om^h04@3om^h10?ooo`00F@3om^h2000000D0ooK^00@0?EV[0?of
kP3om^h0?EV[2@3om^h603eIZ`80ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0;
0?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP07
0?ofkPL0?EV[00<0ooK^0=@m6@0000000P0W2`D20000000503T@20000000>A0803T@200000000`1;
5P/010000000BaH;04/F2`1;5P/3000000P0@Ebb00D0e3dI045L/P11G;80@Ebb0=@m6@04045L/P03
00000011G;80@Ebb00@0@Ebb00D0e3dI03eIZ`11G;80@Ebb00000004045L/P030=@m6@11G;80@Ebb
00<0@Ebb00D00000045L/P11G;80@Ebb0=@m6@06045L/P0300000011G;80@Ebb00P0@Ebb00D00000
045L/P11G;80e3dI045L/P030=@m6@03045L/P000000000000D000001@0nEjP010000000?UNX03iG
Z03D?AT803iGZ0030000000nEjP0?UNX00P0?UNX00<0e3dI03iGZ00nEjP0200nEjP00`000000?UNX
03iGZ00403iGZ0050=@m6@0nEjP0?UNX03iGZ00000002P0nEjP0103D?AT0000003iGZ00nEjP30000
00<0e3dI00D0>e6L0000003D?AT0e3dI0?ofkP020=@m6@@0ooK^0P0mFJ/20?ofkPD000002`3om^h0
1@0mFJ/0ooK^03eIZ`3om^h0000000h0ooK^1P0mFJ/A0?ofkP0303eIZ`3om^h0ooK^03T0ooK^00<0
00000?ofkP3om^h04@3om^h10?ooo`00F03om^h00`000000ooK^000000050?ofkP0303eIZ`3om^h0
?EV[0100ooK^1P0mFJ/30?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h0203om^h0
0`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP0000000P000002
02L;1@80000000D0>A080000000i40P0>A080000000304/F2`050000001;5P/0BaH;04/F2`000000
0P14H;X600000003045L/P3D?AT0000000<0@Ebb00<0e3dI045L/P11G;800`11G;800`000000@Ebb
045L/P03045L/P050=@m6@11G;80@Ebb045L/P0000001@11G;800`3D?AT0@Ebb045L/P02045L/P05
00000011G;80@Ebb045L/P3D?AT01P11G;800`000000@Ebb045L/P08045L/P0300000011G;80e3dI
00D0@Ebb0`3D?AT00`000000@Ebb045L/P02045L/PP0000000<0e3dI03iGZ00nEjP01@0nEjP00`00
0000?UNX03iGZ00803iGZ0030=@m6@000000?UNX00T0?UNX00<0000003iGZ00nEjP0100nEjP01@3D
?AT0?UNX03iGZ00nEjP0000000T0?UNX00<0e3dI0000000nEjP00`0nEjP20=@m6@80?UNX00<0e3dI
000000000000103D?AT50?ofkP80?EV[1`3om^h6000000D0ooK^00@0?EV[0?ofkP0mFJ/000004P3o
m^h00`0mFJ/0ooK^0?ofkP0503eIZ``0ooK^00<0?EV[0?ofkP3om^h0>P3om^h00`000000ooK^0?of
kP0@0?ofkP40oooo001H0?ofkP030000003om^h0000000D0ooK^00<0?EV[0?ofkP0mFJ/04P3om^h0
100mFJ/0ooK^0?ofkP3om^h603eIZ`X0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?of
kP060?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP0000000P00000202L;1@080000000i
40P0>A080000000i40P0000004/F2`00000204/F2`060000001;5P/0BaH;0000001^8A0000001`14
H;X00`000000e3dI0000000200000080@Ebb00<0e3dI045L/P11G;800P11G;800`000000@Ebb045L
/P02045L/P030=@m6@11G;80@Ebb00<0@Ebb00<00000045L/P11G;800`11G;820=@m6@80@Ebb00@0
0000045L/P11G;80e3dI1`11G;800`000000@Ebb045L/P08045L/P0300000011G;80e3dI00P0@Ebb
103D?AT6045L/P0300000011G;80e3dI00H000000P0nEjP00`000000?UNX03iGZ00803iGZ0030=@m
6@000000?UNX00T0?UNX00<0000003iGZ00nEjP00`0nEjP00`3D?AT0?UNX03iGZ00203iGZ0030000
000nEjP0?UNX00L0?UNX00@0e3dI0000000nEjP0?UNX0P3D?AT303iGZ0050=@m6@0nEjP0?UNX0=@m
6@0mFJ/00`3D?AT50?ofkP80?EV[3@3om^h6000000030?ofkP0mFJ/000000180ooK^00<0?EV[0?of
kP3om^h01@3om^h603eIZ`H0ooK^00<0?EV[0?ofkP3om^h0>P3om^h00`000000ooK^0?ofkP0@0?of
kP40oooo001H0?ofkP030000003om^h0000000D0ooK^100mFJ/A0?ofkP0303eIZ`3om^h0ooK^00@0
ooK^00<0?EV[0?ofkP3om^h01P0mFJ/40?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3o
m^h01P3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`0000005@H2008000000P0W2`D020000000
>A0803T@20000000>A080000001;5P/000000`1;5P/01@000000BaH;0000001^8A00000000P0A62j
00@0e3dI00000014H;X0A62j0`0000001@3D?AT00000045L/P11G;80000000@0@Ebb00<0e3dI045L
/P11G;800`11G;800`000000@Ebb045L/P05045L/P030=@m6@11G;8000000080@Ebb00<0e3dI045L
/P11G;801@11G;800`000000@Ebb045L/P08045L/P030000003D?AT0@Ebb00L0@Ebb00<00000045L
/P11G;800P11G;830=@m6@<0@Ebb00<00000045L/P3D?AT01P11G;85000000L0?UNX00<0e3dI0000
000nEjP02P0nEjP00`000000?UNX03iGZ00303iGZ0050=@m6@0nEjP0?UNX03iGZ00000002@0nEjP0
0`3D?AT0?UNX000000020=@m6@D0?UNX00<0e3dI03iGZ0000000103D?AT303eIZ`80ooK^00<0?EV[
0?ofkP0mFJ/04@3om^h00`0mFJ/0ooK^00000005000000l0ooK^00<0?EV[0?ofkP3om^h02`3om^h5
03eIZ`80ooK^00<0?EV[0?ofkP3om^h0>@3om^h00`000000ooK^0?ofkP0@0?ofkP40oooo001H0?of
kP030000003om^h0000000D0ooK^00@0?EV[0?ofkP0mFJ/0ooK^1P0mFJ/:0?ofkP0303eIZ`3om^h0
ooK^00D0ooK^00<0?EV[0?ofkP3om^h01P3om^h603eIZ`T0ooK^00<0?EV[0?ofkP3om^h01`3om^h0
0`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`0000000000008000000P0W2`D020000000>A0803T@2000
0000>A080000001;5P/000000`1;5P/01@000000BaH;0000001^8A00000000L0A62j00@0e3dI04AP
^P14H;X000001@14H;X00`3D?AT0000000000004000000030=@m6@000000@Ebb00@0@Ebb00<00000
045L/P11G;801P11G;801@3D?AT00000045L/P11G;80e3dI00L0@Ebb00<00000045L/P11G;801`11
G;800`000000@Ebb0=@m6@08045L/P0300000011G;80@Ebb00D0@Ebb0`3D?AT00`000000e3dI045L
/P08045L/P0300000011G;80@Ebb00H0000000<0?UNX0=@m6@0000002P0nEjP00`000000?UNX03iG
Z00303iGZ0030=@m6@0nEjP0?UNX0080?UNX00<0000003iGZ00nEjP01`0nEjP30=@m6@H0?UNX00D0
e3dI03iGZ00nEjP0e3dI0?ofkP030=@m6@<0ooK^1@0mFJ/@0?ofkP0503eIZ`3om^h0ooK^0000000m
FJ/0103om^h5000000/0ooK^00<0?EV[0?ofkP3om^h03`3om^h303eIZc/0ooK^00<000000?ofkP3o
m^h0403om^h10?ooo`00F03om^h2000000H0ooK^00<0?EV[0?ofkP0mFJ/01`3om^h703eIZ`<0ooK^
00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0?EV[00D0?EV[
0`3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00h0ooK^00H0?EV[000000000000
9`/50000000W2`D2000000@0>A0800@0000004/F2`1;5P/000000P1;5P/00`000000BaH;00000002
06hQ400300000014H;X0A62j00@0A62j00@0e3dI04AP^P14H;X000001P14H;X00`3D?AT0A62j0000
000304AP^P030=@m6@14H;X0000000L000001`11G;830=@m6@P0@Ebb00<00000045L/P11G;801`11
G;800`000000e3dI045L/P08045L/P0300000011G;80@Ebb00P0@Ebb103D?AT7045L/P0300000011
G;80@Ebb00H0@Ebb00<0e3dI0000000000000P00000803iGZ0030000000nEjP0?UNX00<0?UNX00<0
e3dI03iGZ00nEjP00P0nEjP00`000000?UNX03iGZ00403iGZ0@0e3dI00<0000003iGZ00nEjP01@0n
EjP01@3D?AT0?UNX03iGZ03D?AT0?EV[0080e3dI1P3om^h00`0mFJ/0ooK^03eIZ`0603eIZ`X0ooK^
00H0?EV[0?ofkP3om^h000000?ofkP0mFJ/80?ofkPH000001@3om^h00`0mFJ/0ooK^0?ofkP0A0?of
kP0303eIZ`3om^h0ooK^03T0ooK^00<000000?ofkP3om^h0403om^h10?ooo`00F03om^h2000000D0
ooK^00@0?EV[0?ofkP3om^h0?EV[3P3om^h703eIZ`<0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0m
FJ/0ooK^0?ofkP050?ofkPL0?EV[1@3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0:03eIZ`0000000000
0000000W2`D0000002L;1@000000>A0800000080>A0800D0000004/F2`1;5P/0BaH;0000000304/F
2`050000001^8A00KR4@06hQ400000001@14H;X01@3D?AT0A62j04AP^P14H;X0000000L0A62j00<0
e3dI00000014H;X00P14H;X00`3D?AT0A62j04AP^P0404AP^P0300000014H;X0A62j00D000000P11
G;800`000000@Ebb0=@m6@08045L/P0300000011G;80@Ebb00L0@Ebb00<000000=@m6@11G;802011
G;800`000000@Ebb045L/P08045L/P040=@m6@11G;80@Ebb045L/PH0e3dI00<0@Ebb00000011G;80
1`11G;800`3D?AT0@Ebb00000002045L/PH000000P0nEjP00`000000?UNX03iGZ00203iGZ0030=@m
6@0nEjP0?UNX00<0?UNX00<0000003iGZ03D?AT0103D?AT01@0nEjP0e3dI03iGZ00nEjP0000000H0
?UNX00D0e3dI03iGZ00nEjP0?UNX000000030=@m6@H0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP040?of
kPH0?EV[0`3om^h0100mFJ/0ooK^0?ofkP0000020?ofkP0303eIZ`3om^h0ooK^00`0ooK^1P00000C
0?ofkP0303eIZ`3om^h0ooK^03X0ooK^00<000000?ofkP3om^h03`3om^h10?ooo`00E`3om^h00`00
0000ooK^000000050?ofkP0303eIZ`3om^h0?EV[0180ooK^00@0?EV[0?ofkP3om^h0ooK^1P0mFJ/:
0?ofkP0303eIZ`3om^h0ooK^00T0ooK^00@0?EV[0?ofkP3om^h0ooK^1P0mFJ/?0?ofkP0503eIZ`00
000000000000000W2`D00P00000203T@20040000000i40P0>A08000000<0BaH;00D0000004/F2`1;
5P/0BaH;0000000306hQ400300000014H;X0A62j00<0A62j00D0e3dI04AP^P14H;X0A62j00000007
04AP^P050=@m6@14H;X0000004AP^P3D?AT01`14H;X00`000000A62j04AP^P0504AP^P@000000`3D
?AT6045L/P0300000011G;80@Ebb00L0@Ebb00<0e3dI045L/P11G;802011G;800`000000@Ebb045L
/P08045L/P030=@m6@11G;80@Ebb00L0@Ebb1P3D?AT3045L/P030=@m6@11G;80000000T0@Ebb1@00
000203iGZ0030=@m6@0nEjP0e3dI00D0e3dI1P0nEjP0103D?AT0?UNX03iGZ000000603iGZ0040=@m
6@0nEjP0?UNX000000<0e3dI1P3om^h603eIZ`X0ooK^100mFJ/00`3om^h000000?ofkP020?ofkP03
03eIZ`3om^h0ooK^0140ooK^00<0?EV[0000000000001000000=0?ofkP0303eIZ`3om^h0ooK^03X0
ooK^00<000000?ofkP3om^h03`3om^h10?ooo`00E`3om^h00`000000ooK^000000050?ofkP0303eI
Z`3om^h0?EV[0180ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0703eIZ`<0ooK^
00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP060?ofkPL0?EV[2@3om^h01@0mFJ/00000
0000000000009`/5008000000P0i40P010000000>A0803T@2000000304/F2`050000001;5P/0BaH;
04/F2`0000000`1^8A000`0mFJ/000000=@m6@0304AP^P030=@m6@14H;X0A62j0080A62j00<00000
04AP^P14H;X01@14H;X0103D?AT0000004AP^P3D?AT704AP^P0300000014H;X0A62j00L0A62j00<0
00000=@m6@14H;X00P0000020=@m6@8000000P11G;800`000000@Ebb045L/P07045L/P030=@m6@11
G;80@Ebb00P0@Ebb00<00000045L/P11G;801`11G;800`3D?AT0@Ebb045L/P08045L/P0300000011
G;80@Ebb00<0@Ebb603D?AT010000000?UNX03iGZ000000703iGZ0050=@m6@0nEjP0?UNX03iGZ000
00001@0nEjP0103D?AT0?UNX03iGZ00nEjP40=@m6@H0ooK^00@0?EV[0?ofkP3om^h0?EV[0P3om^h6
03eIZ`L0ooK^00<0?EV[0?ofkP0000000`3om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP0303eIZ`3om^h0
ooK^00@0ooK^1@0000090?ofkP0303eIZ`3om^h0ooK^03T0ooK^00<000000?ofkP3om^h03`3om^h1
0?ooo`00E`3om^h00`000000ooK^000000050?ofkP0303eIZ`3om^h0?EV[0180ooK^00<0?EV[0?of
kP3om^h0103om^h00`0mFJ/0ooK^0?ofkP070?ofkPL0?EV[203om^h00`0mFJ/0ooK^0?ofkP060?of
kP0303eIZ`3om^h0ooK^00@0ooK^1P0mFJ/30?ofkP0603eIZ`00000000000000000W2`D000000`0i
40P010000000>A0800000000000404/F2`050000001;5P/0000006hQ400000000P1^8A000`0mFJ/0
00000=@m6@0204AP^P030=@m6@14H;X0A62j00<0A62j00<0000004AP^P14H;X01P14H;X20=@m6@T0
A62j00<0000004AP^P14H;X01P14H;X00`000000e3dI04AP^P0404AP^P80e3dI1`000005045L/P03
0=@m6@11G;80@Ebb00L0@Ebb00<00000045L/P11G;802011G;800`3D?AT0@Ebb045L/P08045L/P03
00000011G;80@Ebb00D0@Ebb00@0e3dI045L/P11G;8000002P11G;801@000000@Ebb045L/P11G;80
e3dI00@0@Ebb2000000203iGZ0040=@m6@0nEjP0?UNX000000H0?UNX00D0e3dI03iGZ00nEjP0e3dI
000000020=@m6@H0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`080?ofkPD0?EV[00@0ooK^03eIZ`3o
m^h00000103om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP0303eIZ`3om^h0ooK^00T0ooK^1P0000030?of
kP0303eIZ`3om^h0ooK^03T0ooK^00<000000?ofkP3om^h03`3om^h10?ooo`00E`3om^h00`000000
ooK^000000040?ofkP0403eIZ`3om^h0ooK^03eIZa40ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0m
FJ/0ooK^0?ofkP0:0?ofkP0403eIZ`3om^h0ooK^0?ofkPH0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP05
0?ofkP0303eIZ`3om^h0ooK^00/0ooK^1P0mFJ/00`0000009`/50000000303T@20050000000i40P0
000004/F2`0000000`1;5P/01@000000BaH;0000001^8A0000000080KR4@00H0?EV[06hQ40000000
e3dI04AP^P3D?AT504AP^P0300000014H;X0A62j00H0A62j00<000000=@m6@14H;X02014H;X00`00
0000A62j04AP^P0604AP^P030=@m6@14H;X0A62j00H0A62j00<0e3dI04AP^P0000001014H;X40000
00040=@m6@0000000000000000L0@Ebb00<00000045L/P11G;801`11G;800`3D?AT00000045L/P09
045L/P0300000011G;80@Ebb00D0@Ebb00@0e3dI045L/P11G;8000002P11G;801@000000@Ebb045L
/P11G;80e3dI00H0@Ebb00<00000045L/P11G;800`11G;800`000000e3dI00000005000000<0?UNX
00D0e3dI03iGZ03D?AT0e3dI03iGZ0020=@m6@L0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0=0?of
kPH0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP0303eIZ`3om^h0ooK^00l0ooK^1P00000j0?of
kP030000003om^h0ooK^00h0ooK^0@3oool005L0ooK^0P0000050?ofkP0403eIZ`3om^h0ooK^03eI
Za40ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^
00L0ooK^1`0mFJ/30?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0000000000001P0mFJ/01@00
0000>A080000001;5P/0000000<0BaH;00<0000004/F2`0000000P1^8A001@000000KR4@03eIZ`1^
8A0000000080e3dI1`14H;X00`000000A62j04AP^P0604AP^P<0e3dI1`14H;X00`000000A62j04AP
^P0604AP^P030=@m6@14H;X0A62j00L0A62j0P3D?AT804AP^P040=@m6@000000A62j04AP^PD00000
0P11G;800`000000@Ebb045L/P07045L/P030=@m6@000000@Ebb00T0@Ebb00<00000045L/P11G;80
1011G;80103D?AT0@Ebb045L/P00000;045L/P0400000011G;80@Ebb0=@m6@H0@Ebb00<00000045L
/P11G;801011G;800`3D?AT0@Ebb045L/P02045L/P0300000011G;80@Ebb00<000000P3D?AT203iG
Z0030000003D?AT0e3dI00L0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0>0?ofkP0303eIZ`000000
ooK^0080ooK^1P0mFJ/A0?ofkP0303eIZ`3om^h0ooK^0140ooK^00<0?EV[0?ofkP3om^h01P00000d
0?ofkP030000003om^h0ooK^00h0ooK^0@3oool005L0ooK^0P0000050?ofkP0403eIZ`3om^h0ooK^
03eIZa40ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0
ooK^00P0ooK^00<0?EV[0?ofkP3om^h00`3om^h603eIZ`h0ooK^00<0?EV[0000000W2`D00`000003
03T@20H0?EV[0`1;5P/02`000000KR4@06hQ401^8A00000006hQ400mFJ/0KR4@00000014H;X0e3dI
00L0A62j00<0000004AP^P14H;X01@14H;X01@3D?AT0000004AP^P14H;X0e3dI00H0A62j00<00000
04AP^P14H;X01P14H;X00`3D?AT0A62j04AP^P0804AP^P030000003D?AT0e3dI00D0A62j00<0e3dI
04AP^P0000001`14H;X5000000H0@Ebb00<0e3dI045L/P0000002P11G;800`000000@Ebb045L/P04
045L/P040=@m6@11G;80@Ebb000000X0@Ebb00D00000045L/P11G;80@Ebb0=@m6@06045L/P030000
0011G;80@Ebb00@0@Ebb00D0e3dI045L/P11G;80@Ebb00000005045L/P80e3dI00<0@Ebb00000000
00000P3D?AT70?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0
00000?ofkP050?ofkP0403eIZ`3om^h0ooK^0?ofkPL0?EV[2P3om^h00`0mFJ/0ooK^0?ofkP0A0?of
kP0303eIZ`3om^h0ooK^00H0ooK^1P00000^0?ofkP030000003om^h0ooK^00h0ooK^0@3oool005H0
ooK^00<000000?ofkP0000001@3om^h00`0mFJ/0ooK^03eIZ`0B0?ofkP0303eIZ`3om^h0ooK^00@0
ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^00H0
ooK^00<0?EV[0?ofkP3om^h01@0mFJ/80?ofkP0403eIZ`3D?AT0000002L;1@80000000<0>A080000
000i40P00P0i40P01@000000BaH;04/F2`000000BaH;00H0?EV[00@0KR4@0000001^8A00?EV[0P1^
8A000`000000e3dI0=@m6@0604AP^P0300000014H;X0A62j00D0A62j00<0e3dI00000014H;X00P14
H;X00`3D?AT0A62j04AP^P0304AP^P0300000014H;X0A62j00D0A62j00<0e3dI00000014H;X02@14
H;X00`000000A62j04AP^P020=@m6@<0A62j00<0e3dI04AP^P0000002@14H;X00`000000A62j04AP
^P06000000030=@m6@11G;80000000T0@Ebb00<00000045L/P11G;801011G;801@3D?AT0@Ebb045L
/P11G;80000000X0@Ebb00@00000045L/P11G;80e3dI1`11G;800`000000@Ebb045L/P03045L/P03
0=@m6@11G;80@Ebb0080@Ebb00<00000045L/P11G;800`11G;80103D?AT0@Ebb045L/P11G;830=@m
6@L0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`000000ooK^
00D0ooK^00<0?EV[0?ofkP3om^h0203om^h703eIZ`<0ooK^00<0?EV[0?ofkP3om^h04@3om^h00`0m
FJ/0ooK^0?ofkP0<0?ofkPD00000:@3om^h00`000000ooK^0?ofkP0>0?ofkP40oooo001F0?ofkP03
0000003om^h0000000D0ooK^00<0?EV[0?ofkP0mFJ/04P3om^h00`0mFJ/0ooK^0?ofkP040?ofkP03
03eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP060?ofkP03
03eIZ`3om^h0ooK^00D0ooK^1@0mFJ/30?ofkP0403eIZ`0E1P80000002L;1@80000000<0>A080000
000i40P00P0i40P01@000000BaH;04/F2`1;5P/000000080BaH;0P00000206hQ40L0?EV[00<0e3dI
0000003D?AT01@14H;X00`000000A62j04AP^P0504AP^P030=@m6@000000A62j00<0A62j0P3D?AT3
04AP^P0300000014H;X0A62j00D0A62j00<0e3dI00000014H;X02@14H;X00`000000A62j04AP^P02
04AP^P<0e3dI0P14H;X00`000000A62j04AP^P0704AP^P0300000014H;X0A62j00D0A62j00<0e3dI
0000000000000`000007045L/P0300000011G;80@Ebb00@0@Ebb00D0e3dI045L/P11G;80@Ebb0000
000:045L/P0400000011G;80@Ebb0=@m6@H0@Ebb00<00000045L/P11G;801011G;801@3D?AT0@Ebb
045L/P11G;80000000@0@Ebb0P3D?AT4045L/P80e3dI203om^h00`0mFJ/0ooK^0?ofkP020?ofkP03
03eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkPH0
?EV[4@3om^h00`0mFJ/0ooK^0?ofkP0A0?ofkPH000008`3om^h00`000000ooK^0?ofkP0>0?ofkP40
oooo001F0?ofkP030000003om^h0000000@0ooK^00@0?EV[0?ofkP3om^h0?EV[4P3om^h00`0mFJ/0
ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0
ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00X0ooK^100mFJ/20000000502L;1@000000>A0803T@
200000000P0i40P2000000<0BaH;00H0000004/F2`1;5P/0000006hQ4000000306hQ40050000000m
FJ/0KR4@06hQ400000000P15I<800`000000e3dI0000000200000080A62j00<0000004AP^P14H;X0
0`14H;X0103D?AT0A62j04AP^P00000504AP^P040=@m6@14H;X0A62j000000H0A62j00@0e3dI04AP
^P14H;X000002@14H;X00`000000A62j04AP^P0404AP^P80e3dI00<0A62j00000014H;X02014H;X0
0`000000A62j04AP^P0504AP^P040=@m6@14H;X0A62j00000080A62j1@000002045L/P0300000011
G;80@Ebb00<0@Ebb00D0e3dI045L/P11G;80@Ebb0000000:045L/P0400000011G;80@Ebb0=@m6@L0
@Ebb00<00000045L/P11G;800`11G;800`3D?AT0@Ebb045L/P02045L/P0300000011G;80@Ebb00<0
e3dI1011G;820=@m6@D0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00X0
ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^00D0
?EV[3@3om^h00`0mFJ/0ooK^0?ofkP0F0?ofkPH000007P3om^h00`000000ooK^0?ofkP0=0?ofkP40
oooo001F0?ofkP030000003om^h0000000@0ooK^00<0?EV[0?ofkP3om^h0100mFJ/?0?ofkP0303eI
Z`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eI
Z`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h03P3om^h01@0mFJ/000000000000W2`D000000080
>A0800H0000003T@200i40P0000004/F2`00000204/F2`030000001;5P/000000080KR4@00X00000
06hQ401^8A00KR4@0000000mFJ/0KR4@0000002@:a<000000`15I<800`3D?AT0AFC204ET`P070000
000504AP^P3D?AT0A62j04AP^P0000001P14H;X0103D?AT0A62j04AP^P00000504AP^P040=@m6@14
H;X0A62j000000T0A62j00<0000004AP^P14H;X01014H;X00`3D?AT0A62j0=@m6@020=@m6@P0A62j
00<0000004AP^P14H;X01014H;X01@3D?AT0A62j04AP^P14H;X0000000L0A62j1`0000000`11G;80
e3dI045L/P02045L/P0300000011G;80@Ebb00P0@Ebb00@00000045L/P11G;80e3dI1P11G;800`00
0000@Ebb045L/P03045L/P030=@m6@11G;80@Ebb0080@Ebb00@00000045L/P3D?AT0e3dI0P11G;80
0`3D?AT0@Ebb045L/P02045L/P80e3dI1@3om^h603eIZ`<0ooK^00<0?EV[0?ofkP3om^h02P3om^h0
0`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^0180ooK^00<0?EV[0?ofkP3om^h01@3om^h6
03eIZ`L0ooK^00<0?EV[0?ofkP3om^h0703om^h6000001P0ooK^00<000000?ofkP3om^h03@3om^h1
0?ooo`00EP3om^h2000000D0ooK^100mFJ/30?ofkPH0?EV[2@3om^h00`0mFJ/0ooK^0?ofkP030?of
kP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP050?of
kP0303eIZ`3om^h0ooK^00h0ooK^00D0?EV[0000000000009`/50000000203T@20030000000i40P0
00000080BaH;00H0000004/F2`1;5P/0000004/F2`00000306hQ40090000001^8A00KR4@03eIZ`00
0000KR4@0000002@:a<0000000@0AFC200D0e3dI04ET`P15I<80AFC20000000404ET`P030=@m6@00
0000000000@000001@14H;X20=@m6@0300000014H;X0A62j00<0A62j00@0e3dI04AP^P14H;X00000
2@14H;X00`000000A62j04AP^P0304AP^P040=@m6@14H;X0A62j00000080A62j0`3D?AT504AP^P03
00000014H;X0A62j00@0A62j00@0e3dI04AP^P14H;X000002P14H;X00`000000A62j04AP^P0204AP
^P030=@m6@000000000000D000002011G;800`000000@Ebb0=@m6@07045L/P0300000011G;80@Ebb
00<0@Ebb00@0e3dI045L/P11G;80@Ebb0`3D?AT3045L/P030=@m6@11G;80@Ebb0080@Ebb0P3D?AT9
0?ofkP0303eIZ`3om^h0ooK^00H0?EV[2@3om^h00`000000?EV[0?ofkP070?ofkP0303eIZ`3om^h0
ooK^0180ooK^00<0?EV[0?ofkP3om^h02`3om^h503eIZ`80ooK^00<0?EV[0?ofkP3om^h08P3om^h5
000001<0ooK^00<000000?ofkP3om^h03@3om^h10?ooo`00EP3om^h2000000D0ooK^00<0?EV[0?of
kP3om^h01@0mFJ/50?ofkPH0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^
00/0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^
00d0ooK^00<0000003eIZ`0W2`D00`00000303T@208000000P1;5P/01@000000BaH;04/F2`1;5P/0
000000@0KR4@00L0000006hQ401^8A00?EV[0000001^8A0000000080T2/C00<0000004ET`P15I<80
0P15I<801@3D?AT0AFC204ET`P15I<80000000<0AFC200D0e3dI04ET`P15I<80AFC20000000204ET
`PD000000P14H;X00`3D?AT0A62j04AP^P0204AP^P050=@m6@14H;X0A62j04AP^P0000002@14H;X0
0`000000A62j04AP^P0304AP^P040=@m6@14H;X0A62j000000D0A62j0`3D?AT204AP^P0300000014
H;X0A62j00<0A62j00D0e3dI04AP^P14H;X0A62j0000000904AP^P0300000014H;X0A62j00<0A62j
00<0e3dI04AP^P14H;X00P14H;X00`000000A62j04AP^P0500000080@Ebb00@00000045L/P11G;80
e3dI1`11G;800`000000@Ebb045L/P02045L/P030=@m6@11G;80@Ebb0080e3dI00<0@Ebb00000011
G;800P11G;800`3D?AT0@Ebb045L/P03045L/P80e3dI203om^h00`0mFJ/0ooK^0?ofkP040?ofkP03
03eIZ`3om^h0ooK^00H0?EV[0P3om^h00`000000?EV[0?ofkP080?ofkP0303eIZ`3om^h0ooK^0180
ooK^00<0?EV[0?ofkP3om^h0403om^h303eIZbT0ooK^1P00000=0?ofkP030000003om^h0ooK^00d0
ooK^0@3oool005D0ooK^00<000000?ofkP0000001@3om^h00`0mFJ/0ooK^03eIZ`050?ofkPH0?EV[
1@3om^h603eIZ`<0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eI
Z`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0000002L;1@020000000503T@
20000000>A0803T@200000000`1;5P/01@000000BaH;04/F2`1;5P/0000000@0KR4@00H0000006hQ
401^8A00?EV[06hQ40000003090[4`0300000015I<80AFC200<0AFC200@0e3dI04ET`P15I<800000
0`15I<800`3D?AT0AFC204ET`P0204ET`P0300000015I<80AFC200@0AFC20`0000001@3D?AT00000
04AP^P14H;X0e3dI00<0A62j00<0000004AP^P14H;X01`14H;X00`000000A62j04AP^P0204AP^P05
0=@m6@14H;X0A62j04AP^P0000002014H;X30=@m6@D0A62j00D0e3dI04AP^P14H;X0A62j00000009
04AP^P0300000014H;X0A62j0080A62j00<0e3dI04AP^P14H;X00P14H;X00`000000A62j04AP^P06
04AP^P@0000000<0e3dI0000000000001@11G;800`000000@Ebb045L/P03045L/P<0e3dI0P11G;80
0`000000@Ebb045L/P02045L/P030=@m6@11G;80@Ebb0080@Ebb0P3D?AT90?ofkP0303eIZ`3om^h0
ooK^00@0ooK^00<0?EV[0?ofkP3om^h01P3om^h403eIZ`P0ooK^00<0?EV[0?ofkP3om^h04`3om^h0
0`0mFJ/0ooK^0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^02d0ooK^1P0000080?ofkP030000003om^h0
ooK^00`0ooK^0@3oool005D0ooK^00<000000?ofkP0000001@3om^h00`0mFJ/0ooK^03eIZ`0;0?of
kPD0?EV[0P3om^h0100mFJ/0ooK^0?ofkP3om^h703eIZ`X0ooK^00<0?EV[0?ofkP3om^h0203om^h0
0`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0000000W2`D00P000000
1@0i40P0000003T@200i40P0000000@0BaH;00@0000004/F2`1;5P/000001@1^8A001@000000KR4@
03eIZ`1^8A00000000<0T2/C00<0000004ET`P15I<801015I<800`3D?AT0AFC20000000204ET`P03
0=@m6@15I<80AFC200<0AFC200<0000004ET`P15I<801P15I<800`000000AFC20=@m6@020=@m6@80
00000P14H;X00`000000A62j04AP^P0704AP^P0300000014H;X0A62j0080A62j00D0e3dI04AP^P14
H;X0A62j0000000904AP^P0300000014H;X0e3dI0080e3dI00<0A62j0=@m6@14H;X00`14H;X00`00
0000A62j04AP^P0704AP^P0300000014H;X0A62j0080A62j00<0e3dI04AP^P14H;X00P14H;X00`00
0000A62j04AP^P0804AP^P0300000014H;X0e3dI0080A62j200000040=@m6@@0@Ebb00D00000045L
/P11G;80@Ebb0=@m6@04045L/P80e3dI0`0mFJ/70?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[
0?ofkP3om^h01`3om^h00`000000ooK^03eIZ`080?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[
0?ofkP3om^h04P3om^h00`0mFJ/0ooK^0?ofkP0c0?ofkPH000000P3om^h00`000000ooK^0?ofkP0<
0?ofkP40oooo001E0?ofkP030000003om^h0000000@0ooK^00@0?EV[0?ofkP3om^h0?EV[403om^h6
03eIZ`<0ooK^00@0?EV[0?ofkP3om^h0ooK^1P0mFJ/30?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0
?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP040000000mFJ/0000002L;1@800000
00D0>A080000000i40P0>A080000000404/F2`050000001;5P/0000006hQ40000000101^8A001@00
0000KR4@03eIZ`1^8A00000000@0T2/C00<0000004ET`P15I<801015I<801@3D?AT0AFC200000015
I<80e3dI00D0AFC200<0000004ET`P15I<801P15I<801@000000AFC204ET`P15I<80e3dI0080AFC2
1`00000504AP^P0500000014H;X0A62j04AP^P3D?AT01014H;X00`000000A62j04AP^P0704AP^P03
00000014H;X0A62j0080A62j103D?AT00`14H;X0000004AP^P0804AP^P0300000014H;X0A62j0080
A62j00<0e3dI04AP^P14H;X00P14H;X00`000000A62j04AP^P0804AP^P0300000014H;X0e3dI00H0
A62j1@3D?AT00`000000e3dI0000000200000080@Ebb00D00000045L/P11G;80@Ebb0=@m6@03045L
/P<0e3dI00@000000?ofkP3om^h0ooK^1`0mFJ/70?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<00000
0?ofkP0mFJ/02@3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^0180ooK^00<0?EV[
0?ofkP3om^h0>@3om^h3000000h0ooK^0@3oool005D0ooK^00<000000?ofkP000000103om^h0100m
FJ/0ooK^0?ofkP0mFJ/B0?ofkP0403eIZ`3om^h0ooK^0?ofkPH0?EV[1`3om^h603eIZ`T0ooK^00<0
?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP050=@m6@0mFJ/0000002L;1@000000
0P0i40P01@000000>A080000001;5P/0000000<0BaH;00D0000004/F2`000000KR4@0000000406hQ
40060000001^8A00?EV[0000002@:a<000000`2@:a<00`000000AFC204ET`P0504ET`P040=@m6@00
0000AFC20=@m6@D0AFC200<0000004ET`P15I<801P15I<8010000000AFC204ET`P15I<830=@m6@80
AFC200<0000004ET`P15I<800P15I<880000000304AP^P3D?AT0A62j00<0A62j00<0000004AP^P14
H;X01`14H;X00`000000A62j04AP^P0204AP^P040=@m6@14H;X0A62j04AP^PH0e3dI1@14H;X00`00
0000A62j04AP^P0204AP^P030=@m6@14H;X0A62j0080A62j00<0000004AP^P14H;X02014H;X01000
0000A62j0=@m6@14H;X50=@m6@0304AP^P000000A62j00<0A62j00@0e3dI04AP^P14H;X0A62j1@00
00001P11G;80e3dI045L/P11G;80e3dI045L/P80e3dI00<000000?ofkP3om^h01`3om^h603eIZ`80
ooK^00<0?EV[0?ofkP3om^h01P3om^h00`000000ooK^03eIZ`090?ofkP0303eIZ`3om^h0ooK^0180
ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP0j0?ofkP030000003om^h0ooK^00d0
ooK^0@3oool005D0ooK^0P0000050?ofkP0403eIZ`3om^h0ooK^03eIZa80ooK^00<0?EV[0?ofkP3o
m^h00`3om^h0100mFJ/0ooK^0?ofkP3om^h703eIZ`<0ooK^00<0?EV[0?ofkP3om^h01P0mFJ/30?of
kP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h0303om^h01@3D?AT0?EV[0000000W2`D0
00000080>A0800D0000003T@20000000BaH;0000000304/F2`030000001;5P/000000080KR4@00<0
000006hQ401^8A000P1^8A001@0mFJ/0KR4@0000002@:a<0000000@0T2/C00<0000004ET`P15I<80
1@15I<820=@m6@L0AFC200<0000004ET`P15I<801P15I<800`000000AFC20=@m6@0304ET`P80e3dI
00<0000004ET`P15I<801`15I<801@000000AFC204ET`P000000e3dI008000000P14H;X00`000000
A62j04AP^P0704AP^P0300000014H;X0A62j0080A62j00<0e3dI04AP^P14H;X00P14H;X00`000000
A62j04AP^P0204AP^PH0e3dI0`14H;X00`3D?AT0A62j04AP^P0304AP^P0400000014H;X0A62j04AP
^P/0e3dI1P14H;X01@000000A62j04AP^P14H;X0e3dI00D0A62j00D0000004AP^P14H;X0A62j0=@m
6@02000000050=@m6@000000e3dI045L/P0000002P3om^h00`0mFJ/0ooK^0?ofkP030?ofkPH0?EV[
103om^h010000000ooK^0?ofkP0mFJ/90?ofkP0303eIZ`3om^h0ooK^0180ooK^00<0?EV[0?ofkP3o
m^h04`3om^h00`0mFJ/0ooK^0?ofkP0i0?ofkP030000003om^h0ooK^00h0ooK^0@3oool005D0ooK^
0P0000050?ofkP0403eIZ`3om^h0ooK^03eIZa80ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0
ooK^0?ofkP080?ofkPL0?EV[1@3om^h703eIZ`@0ooK^00<0?EV[0?ofkP3om^h0303om^h200000004
03eIZ`0000009`/500000080>A0800D0000003T@20000000BaH;0000000404/F2`050000001^8A00
KR4@06hQ40000000101^8A000`0mFJ/0KR4@00000002090[4`050000002@:a<0T2/C090[4`000000
2015I<800`3D?AT0AFC204ET`P0504ET`P0300000015I<80AFC200H0AFC200<0000004ET`P3D?AT0
1@15I<820=@m6@P0AFC200@0000004ET`P15I<80e3dI0`15I<87000000D0A62j00D0000004AP^P14
H;X0A62j0=@m6@0504AP^P0300000014H;X0A62j00H0A62j00<0000004AP^P3D?AT0303D?AT604AP
^P030000003D?AT0A62j00L0A62j00<0000004AP^P14H;X00P14H;X00`3D?AT0A62j04AP^P0304AP
^P0700000014H;X0A62j04AP^P3D?AT0A62j0=@m6@0204AP^P030=@m6@000000000000X0ooK^00<0
?EV[0?ofkP3om^h01@3om^h0100mFJ/0ooK^0?ofkP3om^h703eIZ`X0ooK^00<0?EV[0?ofkP3om^h0
4P3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^03P0ooK^00<000000?ofkP3om^h0
3`3om^h10?ooo`00E03om^h00`000000ooK^000000050?ofkP0303eIZ`3om^h0?EV[0180ooK^00<0
?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0403eIZ`3om^h0ooK^0?ofkPH0?EV[
0P3om^h0100mFJ/0ooK^0?ofkP3om^h803eIZ`/0ooK^00<0e3dI03eIZ`0W2`D00`00000403T@2004
0000001;5P/0BaH;000000<0BaH;00<0000006hQ401^8A000P1^8A001P000000KR4@06hQ401^8A00
?EV[000000<0T2/C00D00000090[4`2@:a<0T2/C0000000804ET`P80e3dI1P15I<800`000000AFC2
04ET`P0604ET`P030000003D?AT0AFC200H0AFC200<000000=@m6@3D?AT01P15I<8010000000AFC2
04ET`P3D?AT504ET`P0300000015I<80AFC20080AFC2200000000`14H;X0e3dI04AP^P0304AP^P03
00000014H;X0A62j00L0A62j00D0000004AP^P14H;X0A62j0=@m6@0504AP^P0300000014H;X0A62j
00L0A62j00<0000004AP^P3D?AT02014H;X01@000000A62j04AP^P14H;X0e3dI00D0A62j00L00000
04AP^P14H;X0A62j0=@m6@14H;X0e3dI0080A62j00<0e3dI04AP^P0000002P3om^h00`0mFJ/0ooK^
0?ofkP060?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<000000?ofkP3om^h0200mFJ/30?ofkP0303eI
Z`3om^h0ooK^0180ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP0h0?ofkP030000
003om^h0ooK^00l0ooK^0@3oool005@0ooK^00<000000?ofkP0000001@3om^h00`0mFJ/0ooK^03eI
Z`0B0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?of
kP070?ofkPL0?EV[0`3om^h0100mFJ/0ooK^0?ofkP3om^h803eIZ`<0ooK^00<0e3dI03eIZ`0W2`D0
0P0000001@0i40P0000003T@200i40P0000000<0BaH;00D0000004/F2`1;5P/0BaH;0000000406hQ
40060000001^8A00KR4@06hQ400mFJ/00000102@:a<01@000000T2/C090[4`2@:a<0000000H0AFC2
00<0e3dI04ET`P0000000P3D?AT404ET`P0300000015I<80AFC200H0AFC200<000000=@m6@15I<80
1P15I<800`000000AFC204ET`P020=@m6@@0AFC200<0000004ET`P3D?AT01P15I<800`000000AFC2
04ET`P0704ET`P0400000015I<80AFC20=@m6@<000000P14H;X00`000000A62j04AP^P0704AP^P05
00000014H;X0A62j04AP^P3D?AT01@14H;X00`000000A62j04AP^P0704AP^P030000003D?AT0A62j
00L0A62j00<0000004AP^P14H;X00P14H;X00`3D?AT0A62j04AP^P0304AP^P0300000014H;X0A62j
00<0e3dI0P14H;X0103D?AT0A62j04AP^P00000:0?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[
0?ofkP3om^h00`3om^h01@000000ooK^0?ofkP3om^h0?EV[00L0ooK^1P0mFJ/B0?ofkP0303eIZ`3o
m^h0ooK^0180ooK^00<0?EV[0?ofkP3om^h0>03om^h00`000000ooK^0?ofkP0@0?ofkP40oooo001D
0?ofkP030000003om^h0000000D0ooK^00<0?EV[0?ofkP0mFJ/04P3om^h00`0mFJ/0ooK^0?ofkP04
0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP03
0?ofkPL0?EV[203om^h703eIZ`030000000i40P000000080>A0800<0000004/F2`1;5P/00P1;5P/0
1@000000BaH;0000001^8A00000000@0KR4@00@0000006hQ401^8A00?EV[0P000003090[4`050000
002@:a<0T2/C090[4`0000001P15I<800`3D?AT0AFC20000000204ET`P030=@m6@15I<80AFC20080
AFC200<0000004ET`P15I<801@15I<800`3D?AT0AFC204ET`P0604ET`P0300000015I<80AFC20080
AFC20P3D?AT204ET`P0300000015I<80e3dI00H0AFC200<0000004ET`P15I<801`15I<8010000000
AFC204ET`P3D?AT304ET`PL000001014H;X01@000000A62j04AP^P14H;X0e3dI00D0A62j00<00000
04AP^P14H;X02014H;X00`000000e3dI04AP^P0704AP^P0500000014H;X0A62j04AP^P3D?AT01@14
H;X01@000000A62j04AP^P14H;X0e3dI00@0A62j00@0e3dI04AP^P000000?EV[2P3om^h00`0mFJ/0
ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00<0ooK^00D000000?ofkP3om^h0ooK^03eIZ`0:0?of
kP0303eIZ`3om^h0ooK^00D0?EV[3@3om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^
03L0ooK^00<000000?ofkP3om^h04@3om^h10?ooo`00E03om^h4000000<0ooK^00@0?EV[0?ofkP3o
m^h0?EV[4P3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?of
kP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0403eIZ`3om^h0ooK^0?ofkPP0?EV[0P3om^h2
0000000303eIZ`0W2`D0000000H0?EV[101;5P/01@000000BaH;0000001^8A00000000@0KR4@00H0
000006hQ401^8A00?EV[090[4`000003090[4`030000002@:a<0T2/C0080T2/C00<0000004ET`P15
I<800P15I<80103D?AT0AFC204ET`P00000304ET`P050=@m6@15I<80AFC204ET`P0000001`15I<80
0`3D?AT0AFC204ET`P0604ET`P0300000015I<80AFC200@0AFC20P3D?AT00`000000e3dI04ET`P06
04ET`P0300000015I<80AFC200H0AFC200@0000004ET`P15I<80e3dI1P15I<800`000000AFC204ET
`P0204ET`PL0000000<0A62j0=@m6@14H;X01014H;X00`000000A62j04AP^P0704AP^P030000003D
?AT0A62j00L0A62j00D0000004AP^P14H;X0A62j0=@m6@0504AP^P0300000014H;X0A62j0080e3dI
1014H;X00`3D?AT0A62j000000020?ofkPH0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eI
Z`3om^h0ooK^00<0ooK^00D000000?ofkP3om^h0ooK^03eIZ`0;0?ofkP0303eIZ`3om^h0ooK^00D0
ooK^1P0mFJ/70?ofkP0303eIZ`3om^h0ooK^0180ooK^00<0?EV[0?ofkP3om^h0=P3om^h00`000000
ooK^0?ofkP0B0?ofkP40oooo001D0?ofkP8000000P3om^h30000000403eIZ`000000000003eIZa80
ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00T0
ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP090?ofkP80?EV[0P0000000`0mFJ/0
9`/50000000203T@20040000000i40P0000004/F2`H0?EV[00@0000006hQ401^8A000000101^8A00
0`000000?EV[00000002090[4`050000002@:a<0T2/C090[4`0000000`2@:a<5000000050=@m6@15
I<80AFC204ET`P0000000`15I<80103D?AT0AFC204ET`P00000704ET`P030=@m6@15I<80AFC200H0
AFC200<0000004ET`P15I<801P15I<830=@m6@H0AFC200<0000004ET`P15I<801P15I<8010000000
AFC204ET`P3D?AT504ET`P0300000015I<80AFC200L0AFC200@0000004ET`P15I<80e3dI0`000002
04AP^P0300000014H;X0A62j00P0A62j00<000000=@m6@14H;X01014H;X0100mFJ/0A62j04AP^P00
000304AP^P030=@m6@14H;X0A62j00<0A62j00@000000=@m6@3D?AT0e3dI1@14H;X00`3D?AT00000
000000080?ofkPH0?EV[1P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP030000003om^h0ooK^0080ooK^
00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkPD0?EV[0P3om^h00`0mFJ/0ooK^
0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^03D0ooK^00<000000?ofkP3om^h04`3om^h10?ooo`00E03o
m^h2000000D0ooK^00@0?EV[0?ofkP3om^h0?EV[1P00000<0?ofkP0303eIZ`3om^h0ooK^00<0ooK^
00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00L0ooK^
00<0?EV[0?ofkP3om^h02`3om^h01@000000?EV[0000000W2`D000000080>A0800D0000003T@2000
0000BaH;0000000404/F2`030000000mFJ/0?EV[00@0?EV[0P1^8A000`000000?EV[090[4`02090[
4`050000002@:a<0T2/C090[4`0000000`2@:a<200000080AfO800<0e3dI00000000000010000003
04ET`P80e3dI00<0000004ET`P15I<801015I<800`3D?AT0AFC20000000704ET`P0300000015I<80
AFC200H0AFC200<000000=@m6@15I<800`3D?AT304ET`P0300000015I<80AFC200H0AFC200<00000
04ET`P3D?AT01P15I<800`000000AFC204ET`P0604ET`P0500000015I<80AFC204ET`P3D?AT00`15
I<87000000D0A62j00<000000=@m6@14H;X01`14H;X01@000000A62j04AP^P14H;X0e3dI00D0A62j
0P3D?AT204AP^P030=@m6@14H;X0A62j0080A62j0P3D?AT00`000000ooK^0?ofkP0:0?ofkP0303eI
Z`3om^h0ooK^00L0?EV[103om^h00`000000ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00T0ooK^
00<0?EV[0?ofkP3om^h0403om^h603eIZa40ooK^00<0?EV[0?ofkP3om^h0=03om^h00`000000ooK^
0?ofkP0D0?ofkP40oooo001D0?ofkP8000001@3om^h303eIZ`L0ooK^1P0000060?ofkP0303eIZ`3o
m^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3o
m^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h02P3om^h20000000403eIZ`0000000000000000@0>A08
00@0000004/F2`1;5P/000000`1;5P/00`000000KR4@06hQ400206hQ40030000001^8A00?EV[00H0
?EV[00<0T2/C0000002@:a<00P2@:a<01@000000T2/C0000002/<aL000000080AfO800<0e3dI04MW
b017IlP00P17IlP00`000000AfO8000000030000000304ET`P3D?AT0000000D0AFC200<0e3dI04ET
`P0000002015I<800`000000AFC204ET`P0504ET`P030=@m6@15I<80AFC200<0AFC20`3D?AT904ET
`P0300000015I<80e3dI00H0AFC200<0000004ET`P15I<801P15I<8010000000AFC204ET`P3D?AT6
04ET`P0300000015I<80AFC20080AFC21P0000000`3D?AT0000004AP^P0604AP^P0500000014H;X0
A62j04AP^P3D?AT00`14H;X20=@m6@0400000014H;X0A62j0=@m6@@0A62j0P3D?AT00`0mFJ/0ooK^
0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00H0ooK^1P0mFJ/30?ofkP0303eIZ`3om^h0ooK^00T0ooK^
00<0?EV[0?ofkP3om^h04`3om^h0100mFJ/0ooK^0?ofkP3om^h703eIZ`X0ooK^00<0?EV[0?ofkP3o
m^h0=03om^h00`000000ooK^0?ofkP0D0?ofkP40oooo001C0?ofkP030000003om^h0000000D0ooK^
00<0?EV[0?ofkP0mFJ/01@0mFJ/80?ofkPD0000000<0?EV[0000003om^h0103om^h00`0mFJ/0ooK^
0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^
0?ofkP0:0?ofkP80000000D0?EV[000000000000>A080000000203T@20050000001;5P/0BaH;04/F
2`0000000`1;5P/2000000<0KR4@00<0000006hQ401^8A000P1^8A00100mFJ/00000090[4`2@:a<6
03eIZ`06090[4`000000[3<G0:`c5`000000e3dI1P17IlP00`000000AfO804MWb00204MWb0800000
00H0e3dI000000000000000004ET`P3D?AT204ET`P0300000015I<80AFC200H0AFC200<0000004ET
`P15I<801@15I<800`3D?AT0AFC204ET`P0504ET`P030000003D?AT0e3dI00H0AFC200<0000004ET
`P3D?AT01`15I<800`000000AFC204ET`P0604ET`P0400000015I<80AFC20=@m6@D0AFC200<00000
04ET`P15I<801`15I<8010000000e3dI04ET`P15I<8400000080A62j00D0000004AP^P14H;X0A62j
0=@m6@0204AP^P80e3dI00<0A62j00000014H;X00P14H;X00`3D?AT0A62j04AP^P0204AP^P030=@m
6@000000?EV[00d0ooK^00<0?EV[0?ofkP3om^h01P3om^h0100mFJ/0ooK^0?ofkP0000020?ofkP@0
?EV[2`3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^00P0ooK^1`0mFJ/30?ofkP03
03eIZ`3om^h0ooK^03<0ooK^00<000000?ofkP3om^h05@3om^h10?ooo`00D`3om^h00`000000ooK^
000000050?ofkP0303eIZ`3om^h0?EV[00<0?EV[0P3om^h603eIZ`L0ooK^00<0?EV[0?ofkP000000
100000000`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h0
1`3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP80000000D0?EV[000000000000>A080000000203T@2005
0000001;5P/0BaH;04/F2`0000000P1;5P/00`000000KR4@0000000406hQ40060000001^8A00KR4@
0000000mFJ/00000102@:a<010000000T2/C090[4`2@:a<403eIZ`030000003D?AT0AfO800D0AfO8
00<0000004MWb017IlP01017IlP01P000000e3dI0=@m6@17IlP000000=@m6@L000001015I<800`00
0000AFC204ET`P0404ET`P030=@m6@000000AFC200H0AFC200<0000004ET`P15I<800`3D?AT304ET
`P0300000015I<80e3dI00H0AFC200<0000004ET`P15I<801P15I<8010000000AFC204ET`P3D?AT6
04ET`P0300000015I<80AFC200L0AFC200<000000=@m6@15I<801@15I<86000000<0e3dI0`14H;X0
10000000A62j04AP^P3D?AT404AP^P040=@m6@000000gT8I03eIZ``0ooK^00<0?EV[0?ofkP3om^h0
1`3om^h0100mFJ/0ooK^0?ofkP0000050?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3o
m^h04`3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP@0?EV[=03om^h00`000000ooK^0?ofkP0F0?ofkP40
oooo001C0?ofkP030000003om^h0000000D0ooK^00<0?EV[0?ofkP0mFJ/00`3om^h603eIZ`80ooK^
1@0mFJ/20?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0000000000001@0000060?ofkP0303eI
Z`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP800000
00<0?EV[02L;1@0000000P0i40P010000000>A0803T@2000000404/F2`030000001;5P/000000080
KR4@00D0000006hQ401^8A00KR4@0000000206hQ400403eIZ`2@:a<0T2/C000000<0T2/C00D00000
090[4`2@:a<0T2/C000000030:`c5`0303eIZ`000000AfO800H0AfO800<0000004MWb017IlP01017
IlP010000000AfO80=@m6@3D?AT304MWb00300000017IlP0AfO80080AfO81P00000504ET`P030=@m
6@000000AFC200H0AFC200<0000004ET`P15I<800`15I<830=@m6@030000003D?AT0AFC200H0AFC2
00<0000004ET`P15I<801P15I<8010000000AFC204ET`P3D?AT504ET`P0300000015I<80AFC200L0
AFC200<000000=@m6@15I<801`15I<800`000000AFC204ET`P030=@m6@P0000000H0e3dI04AP^P14
H;X0A62j0=@m6@14H;X20000000303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h01`3om^h0
0`0mFJ/0ooK^000000060?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h04`3om^h0
0`0mFJ/0ooK^0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^0340ooK^00<000000?ofkP3om^h05`3om^h1
0?ooo`00D`3om^h2000000D0ooK^00@0?EV[0?ofkP3om^h0?EV[2@3om^h603eIZ`030?ofkP0mFJ/0
?EV[00@0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP060?ofkPD0000000<0?EV[0?ofkP3om^h0203om^h0
0`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00X0ooK^0P0000000`0mFJ/09`/500000002
03T@20050000000i40P0000004/F2`0000000`1;5P/00`000000BaH;0000000206hQ40030000001^
8A00KR4@0080KR4@00<0000006hQ400mFJ/00P2@:a<00`000000T2/C090[4`02090[4`030000002@
:a<0T2/C008000000`2/<aL00`000000AfO804MWb00504MWb00300000017IlP0AfO800@0AfO800@0
000004MWb017IlP0e3dI0`17IlP00`000000AfO804MWb00604MWb00300000017IlP0000000<00000
00<0e3dI04ET`P0000001`15I<800`000000AFC204ET`P0604ET`P@0e3dI1@15I<800`000000AFC2
04ET`P0604ET`P0300000015I<80e3dI00H0AFC200<0000004ET`P15I<801`15I<800`000000e3dI
04ET`P0604ET`PD0e3dI1@15I<801P000000AFC204ET`P15I<80e3dI04ET`P8000000P3D?AT01000
0000e3dI0?ofkP0mFJ/<0?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP0000001P3om^h0
0`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h04P3om^h0
0`0mFJ/0ooK^0?ofkP0`0?ofkP030000003om^h0ooK^01P0ooK^0@3oool005<0ooK^0P0000050?of
kP0403eIZ`3om^h0ooK^03eIZ`l0ooK^1P0mFJ/00`3om^h0?EV[03eIZ`0403eIZ`X0ooK^00<0?EV[
0000000000001@0000030?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h02P3om^h2
0000000303eIZ`0W2`D000000080>A0800D0000003T@20000000BaH;0000000404/F2`030000001^
8A00KR4@0080KR4@00@0000006hQ401^8A00KR4@0P0000001@0mFJ/0T2/C090[4`2@:a<0000000<0
T2/C00<00000090[4`2@:a<00P0000040:`c5`0300000017IlP0AfO800D0AfO800<0000004MWb017
IlP01017IlP00`000000AfO80=@m6@020=@m6@80AfO800<0000004MWb017IlP01@17IlP00`000000
AfO804MWb00304MWb0030=@m6@000000000000<000001015I<800`000000AFC204ET`P0504ET`P03
0000003D?AT0AFC20080AFC21P3D?AT804ET`P0300000015I<80e3dI00D0AFC200<0000004ET`P15
I<801`15I<800`000000e3dI04ET`P0304ET`P@0e3dI00D0000004ET`P15I<80AFC20=@m6@0404ET
`P0500000015I<80AFC204ET`P3D?AT00`15I<800`3D?AT0AFC20000000603eIZ`X0ooK^00<0?EV[
0?ofkP3om^h01P3om^h00`0mFJ/0ooK^000000060?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[
0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^02l0ooK^00<00000
0?ofkP3om^h06@3om^h10?ooo`00D`3om^h2000000D0ooK^00<0?EV[0?ofkP0mFJ/04`3om^h00`0m
FJ/0ooK^0?ofkP0>03eIZ`<0ooK^00<0?EV[0?ofkP3om^h01@3om^h30000000303eIZ`0000000000
00L0ooK^00<0?EV[0?ofkP3om^h02@3om^h20000000402L;1@0mFJ/00000000000@0>A0800@00000
04/F2`1;5P/000000`1;5P/00`000000KR4@06hQ400206hQ40030000001^8A00KR4@0080KR4@00<0
000003eIZ`2@:a<00P2@:a<00`000000T2/C090[4`02090[4`8000000P2/<aL00`000000[3<G0:`c
5`020:`c5`0300000017IlP0AfO800@0AfO800<0000004MWb017IlP01017IlP00`000000e3dI04MW
b00204MWb080e3dI00<0000004MWb017IlP01@17IlP00`000000AfO804MWb00204MWb0040=@m6@17
IlP0AfO8000000<0AfO82000000404ET`P030000003D?AT0AFC200H0AFC200<0000004ET`P3D?AT0
1@3D?AT01015I<80000004ET`P3D?AT304ET`P0403eIZ`15I<80AFC2000000P0AFC200<0000004ET
`P3D?AT0103D?AT304ET`P0500000015I<80AFC204ET`P3D?AT01@15I<801@000000AFC204ET`P15
I<80e3dI0080AFC200<0e3dI04ET`P0000000P0000020?ofkP0303eIZ`3om^h0ooK^00H0?EV[103o
m^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`000000ooK^00H0ooK^00<0?EV[0?ofkP3om^h02P3o
m^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^0180ooK^00<0?EV[0?ofkP3om^h0;`3o
m^h00`000000ooK^0?ofkP0I0?ofkP40oooo001B0?ofkP030000003om^h0000000D0ooK^00<0?EV[
0?ofkP0mFJ/04`3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0403eIZ`3om^h0ooK^0?ofkPh0?EV[1P3o
m^h0100mFJ/0ooK^0?ofkP3om^h70000000303eIZ`3om^h0ooK^00T0ooK^0P0000001@0mFJ/00000
0000000i40P000000080>A0800D0000004/F2`1;5P/0BaH;0000000304/F2`800000101^8A001P00
0000KR4@06hQ401^8A00?EV[000000@0T2/C00@00000090[4`2@:a<0T2/C0P0000020:`c5`030000
002/<aL0[3<G0080[3<G00<0000004MWb017IlP01017IlP00`000000AfO804MWb00404MWb0030000
003D?AT0AfO800@0AfO800<0e3dI04MWb017IlP01@17IlP00`000000AfO804MWb00204MWb0040=@m
6@17IlP0AfO8000000L0AfO800@0000004MWb017IlP0AfO8100000000`3D?AT00000000000020000
00@0AFC200<0000004ET`P15I<801@15I<8F0=@m6@H0AFC200<0000004ET`P15I<800P15I<800`3D
?AT0AFC204ET`P0204ET`P0600000015I<80AFC204ET`P3D?AT0AFC20P3D?AT00`15I<8000000000
000200000080ooK^00<0?EV[0?ofkP3om^h01P3om^h503eIZ`P0ooK^00<0?EV[0000003om^h01P3o
m^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^0180ooK^00<0?EV[0?ofkP3om^h04`3o
m^h00`0mFJ/0ooK^0?ofkP0^0?ofkP030000003om^h0ooK^01X0ooK^0@3oool00580ooK^00<00000
0?ofkP0000001@3om^h00`0mFJ/0ooK^03eIZ`0B0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[
0?ofkP3om^h02@3om^h=03eIZ`X0ooK^00<0?EV[0000000000000`0000050?ofkP<0000000D0?EV[
000000000000>A080000000203T@20050000001;5P/0BaH;04/F2`0000000P1;5P/00`000000KR4@
0000000406hQ40060000001^8A00KR4@0000000mFJ/000001@2@:a<01@000000T2/C090[4`2@:a<0
000000<0[3<G00<000000:`c5`2/<aL00P2/<aL00`000000AfO804MWb00404MWb00300000017IlP0
AfO800<0AfO800<0e3dI00000017IlP01017IlP00`000000e3dI0=@m6@0504MWb00500000017IlP0
AfO804MWb03D?AT00`17IlP00`000000AfO804MWb00504MWb00300000017IlP0AfO800D0AfO800<0
e3dI04MWb017IlP00P17IlP6000000L0AFC200<000000=@m6@15I<801@15I<800`000000AFC204ET
`P0604ET`P030000003D?AT0AFC200L0AFC200D0000004ET`P15I<80AFC20=@m6@0404ET`P030000
0015I<80AFC20080AFC20P3D?AT304ET`P<000000P3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkPL0?EV[
0P3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h0
4`3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^02d0ooK^00<000000?ofkP3om^h0
6`3om^h10?ooo`00DP3om^h00`000000ooK^000000050?ofkP0303eIZ`3om^h0?EV[0180ooK^00<0
?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00<0ooK^300m
FJ/30?ofkP0303eIZ`3om^h0ooK^00<0ooK^200000001@0mFJ/0000003T@200i40P000000080>A08
00<0000004/F2`1;5P/00P1;5P/00`000000BaH;0000000206hQ40030000001^8A00KR4@0080KR4@
00H0000006hQ40000000?EV[090[4`000004090[4`060000002@:a<0T2/C0000002/<aL000000`2/
<aL01@000000[3<G0:`c5`2/<aL0000000H0AfO800<0000004MWb017IlP00`17IlP00`3D?AT00000
04MWb00504MWb00400000017IlP0e3dI0=@m6@<0AfO800D0000004MWb017IlP0AfO80=@m6@0304MW
b00300000017IlP0AfO800D0AfO800<0000004MWb017IlP01017IlP00`3D?AT0000004MWb00704MW
b00300000017IlP0000000<000000P15I<800`000000AFC20=@m6@0604ET`P0300000015I<80AFC2
00H0AFC200<000000=@m6@15I<801P15I<800`000000AFC204ET`P0204ET`P050=@m6@15I<80AFC2
04ET`P0000001015I<820=@m6@<0AFC20`000000100mFJ/0ooK^0?ofkP0mFJ/<0?ofkP0303eIZ`3o
m^h0ooK^00D0ooK^1P0mFJ/50?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h04`3o
m^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^02`0ooK^00<000000?ofkP3om^h0703o
m^h10?ooo`00DP3om^h2000000H0ooK^00<0?EV[0?ofkP0mFJ/04P3om^h00`0mFJ/0ooK^0?ofkP03
0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP0=
03eIZ`H0ooK^0`0000002@0mFJ/0000003T@200i40P0000003T@20000000BaH;0000000304/F2`03
0000001;5P/000000080KR4@00<0000006hQ401^8A000P1^8A0200000005090[4`0mFJ/0T2/C090[
4`000000102@:a<01@000000T2/C0000002/<aL0000000<0[3<G00<000000:`c5`2/<aL00P2/<aL0
0`000000AfO804MWb00404MWb00700000017IlP0AfO804MWb03D?AT0AfO80000000604MWb0050000
0017IlP0AfO804MWb03D?AT00P17IlP010000000AfO804MWb03D?AT404MWb00300000017IlP0AfO8
00D0AfO800<0000004MWb017IlP01017IlP00`3D?AT0000004MWb00604MWb00300000017IlP0AfO8
00@0AfO80`0000000`3D?AT000000000000404ET`P0300000015I<80AFC200H0AFC200<000000=@m
6@15I<801P15I<800`000000AFC204ET`P0204ET`P030=@m6@15I<80AFC20080AFC200<0000004ET
`P15I<800P15I<801`3D?AT0AFC204ET`P15I<8000000?m=7`0000000P3om^h603eIZ`T0ooK^00<0
?EV[0?ofkP3om^h01P3om^h00`000000?EV[0?ofkP020?ofkPL0?EV[2P3om^h00`0mFJ/0ooK^0?of
kP0C0?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h0:`3om^h00`000000ooK^0?of
kP0M0?ofkP40oooo001B0?ofkP8000001@3om^h0100mFJ/0ooK^0?ofkP0mFJ/B0?ofkP0303eIZ`3o
m^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3o
m^h0ooK^00H0ooK^1P0mFJ/00`3om^h0?EV[03eIZ`0403eIZ`80000000<0?EV[02L;1@0000000P0i
40P01@000000>A080000001;5P/0000000@0BaH;00<0000006hQ401^8A000P1^8A000`000000KR4@
06hQ400206hQ40030000000mFJ/0T2/C0080T2/C00<00000090[4`2@:a<00P2@:a<2000000<0[3<G
00D000000:`c5`2/<aL0[3<G000000030:`c5`0300000017IlP0AfO800@0AfO800D0000004MWb017
IlP0AfO80=@m6@0204MWb00300000017IlP0AfO800<0AfO800<0000004MWb017IlP00P17IlP20=@m
6@0404MWb0000000AfO80=@m6@@0AfO800<0000004MWb017IlP01@17IlP00`000000AfO804MWb003
04MWb0030=@m6@000000AfO800L0AfO800<0000004MWb017IlP01@17IlP00`000000AfO80=@m6@02
04MWb0P000001@15I<800`000000e3dI04ET`P0504ET`P0300000015I<80AFC20080AFC200<0e3dI
04ET`P15I<800P15I<8010000000AFC204ET`P15I<820=@m6@<0AFC200@000000?m=7`0000000000
103om^h0100mFJ/0ooK^0?ofkP3om^h603eIZ`<0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`000000
ooK^03eIZ`080?ofkP0303eIZ`3om^h0?EV[00H0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP03
03eIZ`3om^h0ooK^0180ooK^00<0?EV[0?ofkP3om^h0:`3om^h00`000000ooK^0?ofkP0N0?ofkP40
oooo001B0?ofkP8000001@3om^h0100mFJ/0ooK^0?ofkP0mFJ/B0?ofkP0303eIZ`3om^h0ooK^00<0
ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00T0
ooK^00@0?EV[0?ofkP3om^h0ooK^1P0mFJ/20000000402L;1@0mFJ/00000000000@0>A0800@00000
04/F2`1;5P/000000`1;5P/00`000000KR4@06hQ400306hQ40060000001^8A00KR4@06hQ40000000
?EV[102@:a<00`000000T2/C090[4`02090[4`030000002/<aL0[3<G0080[3<G00D000000:`c5`2/
<aL0[3<G000000030:`c5`@000000`17IlP010000000AfO804MWb03D?AT204MWb00300000017IlP0
AfO800<0AfO800<0000004MWb017IlP01017IlP30=@m6@D0AfO800<0000004MWb017IlP01@17IlP0
0`000000AfO804MWb00304MWb0030=@m6@000000AfO800L0AfO800<0000004MWb017IlP01@17IlP0
0`000000e3dI04MWb00504MWb00300000017IlP0AfO80080AfO81@0000000`3D?AT0000000000005
04ET`P0300000015I<80AFC20080AFC200D0e3dI04ET`P15I<80AFC20000000204ET`P<0e3dI0`15
I<801@000000oddO000000000000?EV[00@0ooK^00<0?EV[0?ofkP3om^h01`3om^h603eIZ`@0ooK^
00<000000?ofkP0mFJ/0203om^h00`0mFJ/0ooK^0?ofkP070?ofkPL0?EV[4P3om^h00`0mFJ/0ooK^
0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^02/0ooK^00<000000?ofkP3om^h07P3om^h10?ooo`00DP3o
m^h2000000D0ooK^00@0?EV[0?ofkP3om^h0?EV[4P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eI
Z`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eI
Z`3om^h0ooK^00L0ooK^1P0mFJ/010000000>A0803T@2000000304/F2`040000001;5P/0BaH;04/F
2`800000101^8A001P000000KR4@06hQ40000000T2/C03eIZ`@0T2/C00<00000090[4`2@:a<00P2@
:a<2000000<0[3<G00D000000:`c5`2/<aL0[3<G000000020:`c5`0300000033>QT000000080B6W>
1@0000000`3D?AT0000004MWb00204MWb00300000017IlP0AfO800<0AfO800<0000004MWb017IlP0
1017IlP00`000000e3dI0=@m6@0404MWb00300000017IlP0AfO800@0AfO800<0000004MWb017IlP0
0`17IlP00`3D?AT0AfO80000000704MWb00300000017IlP0AfO800D0AfO800<0000004MWb03D?AT0
1P17IlP00`000000AfO804MWb00504MWb0030000003D?AT0AfO80080AfO81P00000304ET`P060=@m
6@15I<80AFC204ET`P000000AFC20P3D?AT204ET`P050=@m6@15I<80AFC20000003oCAl00P000000
0`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h01`0mFJ/8
0?ofkP0303eIZ`3om^h0ooK^00X0ooK^00@0?EV[0?ofkP3om^h0ooK^1`0mFJ/;0?ofkP0303eIZ`3o
m^h0ooK^0180ooK^00<0?EV[0?ofkP3om^h0:P3om^h00`000000ooK^0?ofkP0O0?ofkP40oooo001A
0?ofkP030000003om^h0000000D0ooK^100mFJ/A0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[
0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[
0?ofkP3om^h01`3om^h30000000402L;1@0mFJ/0000003T@20H0?EV[00L0BaH;0000001;5P/0BaH;
0000001^8A00000000D0KR4@00H0000006hQ40000000T2/C03eIZ`000004090[4`060000002@:a<0
T2/C0000002/<aL00000102/<aL02@000000[3<G0:`c5`2/<aL000000:`c5`000000`cXI00000005
04QYcP0400000018JLh0e3dI04QYcPH000000`17IlP00`000000AfO804MWb00404MWb0030000003D
?AT0AfO800@0e3dI00<0000004MWb017IlP01017IlP00`000000AfO804MWb00304MWb0030=@m6@17
IlP0000000L0AfO800<0000004MWb017IlP01@17IlP00`000000e3dI04MWb00504MWb00300000017
IlP0AfO800H0AfO800<000000=@m6@17IlP01@17IlP00`000000AfO804MWb003000000040=@m6@15
I<80AFC204ET`P80e3dI0`15I<80103D?AT0AFC204ET`P15I<82000000030?m=7`000000?EV[00@0
ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP030?ofkP030000003om^h0ooK^00H0
?EV[0`3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00P0ooK^200mFJ/30?ofkP03
03eIZ`3om^h0ooK^0180ooK^00<0?EV[0?ofkP3om^h0:@3om^h00`000000ooK^0?ofkP0P0?ofkP40
oooo001A0?ofkP030000003om^h0000000D0ooK^00@0?EV[0?ofkP0mFJ/0ooK^1`0mFJ/:0?ofkP03
03eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP070?ofkP03
03eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h01`3om^h30000000502L;1@0mFJ/0>A0803T@
200000000P0i40P20000000304/F2`0mFJ/0?EV[00@0?EV[00<0KR4@0000001^8A000`1^8A020000
0005090[4`0mFJ/0T2/C090[4`000000102@:a<00`000000T2/C000000020:`c5`030000002/<aL0
[3<G0080[3<G00<000000:`c5`2/<aL00P0000030<<j6@030000003D?AT0B6W>00<0B6W>00<0e3dI
04QYcP18JLh00`18JLh00`000000B6W>04QYcP05000000D0AfO800<0e3dI04MWb017IlP01017IlP3
0=@m6@@0AfO800<0000004MWb017IlP00P17IlP0103D?AT0AfO804MWb000000704MWb00300000017
IlP0AfO800@0AfO800<0000004MWb03D?AT01P17IlP00`000000AfO804MWb00504MWb0030000003D
?AT0AfO800D0AfO800<0000004MWb017IlP00`17IlP00`3D?AT0AfO8000000020=@m6@<000000P15
I<800`3D?AT0AFC204ET`P02000000040?m=7`000000ooK^03eIZ`@0ooK^00<0?EV[0?ofkP3om^h0
2`3om^h00`0mFJ/0ooK^0?ofkP020?ofkP050000003om^h0ooK^0?ofkP0mFJ/01@3om^h403eIZ`/0
ooK^00<0?EV[0?ofkP3om^h04@3om^h603eIZa80ooK^00<0?EV[0?ofkP3om^h0:03om^h00`000000
ooK^0?ofkP0Q0?ofkP40oooo001A0?ofkP8000001P3om^h00`0mFJ/0ooK^03eIZ`080?ofkPL0?EV[
0`3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h0
1`3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00L0ooK^0`0000002@0mFJ/00000
03T@200i40P0000003T@20000000BaH;0000000304/F2`040000001;5P/0000006hQ40H0?EV[00@0
KR4@0000002@:a<0?EV[0P2@:a<00`000000T2/C090[4`02090[4`800000102/<aL01@000000[3<G
0:`c5`2/<aL0000000<0[3<G00L000000<<j6@33>QT0?EV[00000018JLh0e3dI00<0B6W>00<0e3dI
04QYcP18JLh01018JLh00`000000B6W>04QYcP0204QYcP0300000018JLh0000000<0000000<0AfO8
0=@m6@17IlP01@17IlP00`000000AfO804MWb0030=@m6@0304MWb0000000AfO800<0AfO800@0e3dI
04MWb017IlP000001`17IlP00`000000AfO804MWb00404MWb0030000003D?AT0AfO800D0AfO800<0
000004MWb017IlP01@17IlP00`000000e3dI04MWb00504MWb00300000017IlP0AfO800@0AfO80`3D
?AT00`000000AfO804MWb00204MWb0030000003D?AT000000080000000H0oddO0000000000000000
0?ofkP0mFJ/40?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h00`3om^h01@000000
ooK^0?ofkP3om^h0?EV[00P0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP0D0?of
kP0303eIZ`3om^h0ooK^00D0?EV[3@3om^h00`0mFJ/0ooK^0?ofkP0W0?ofkP030000003om^h0ooK^
0280ooK^0@3oool00540ooK^0P0000050?ofkP0303eIZ`3om^h0ooK^00<0?EV[3@3om^h703eIZ`80
ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00T0
ooK^00<0?EV[0?ofkP3om^h01`3om^h30000000703eIZ`000000>A0803T@20000000>A0800000002
04/F2`050000001;5P/0BaH;04/F2`000000101^8A0010000000KR4@06hQ401^8A0703eIZ`030000
002@:a<0T2/C0080T2/C00<000000:`c5`2/<aL00P2/<aL00`000000[3<G0:`c5`020:`c5`030000
002/<aL0[3<G0080000000D0`cXI03eIZ`33>QT0000004QYcP030=@m6@0304QYcP000000B6W>00@0
B6W>00<0000004QYcP18JLh00`18JLh00`000000B6W>04QYcP0204QYcP030=@m6@00000000000080
00000`17IlP00`000000AfO804MWb00304MWb0@0e3dI00D0AfO80=@m6@17IlP0AfO80000000704MW
b00300000017IlP0AfO800@0AfO800<0000004MWb03D?AT01@17IlP00`000000AfO804MWb00604MW
b0030000003D?AT0AfO800D0AfO800@0000004MWb017IlP0AfO8103D?AT00`17IlP0000004MWb005
04MWb0040=@m6@17IlP000000?m=7`<000000P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3o
m^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h00P3om^h01@000000ooK^0?ofkP3om^h0?EV[00T0ooK^
00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP0303eIZ`3om^h0ooK^00D0ooK^
1P0mFJ/70?ofkP0303eIZ`3om^h0ooK^02H0ooK^00<000000?ofkP3om^h08`3om^h10?ooo`00D@3o
m^h2000000D0ooK^00@0?EV[0?ofkP3om^h0?EV[0P3om^h603eIZ`X0ooK^00@0?EV[0?ofkP3om^h0
ooK^1`0mFJ/:0?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0
ooK^0?ofkP060?ofkP80000000D09`/50000000mFJ/0>A080000000303T@20040000001;5P/0BaH;
000000<0BaH;00<0000006hQ401^8A000`1^8A0010000000KR4@06hQ40000002090[4`0403eIZ`2@
:a<0T2/C090[4`P0?EV[0`2/<aL00`000000[3<G0:`c5`020:`c5`80000000<0`cXI0000000mFJ/0
0P33>QT01`000000B6W>04QYcP18JLh0e3dI04QYcP0000001@18JLh00`000000B6W>04QYcP0304QY
cP0300000018JLh0B6W>0080B6W>00<0e3dI00000018JLh00P18JLh7000000<0AfO800<0000004MW
b017IlP0103D?AT00`000000AfO804MWb00504MWb00300000017IlP0AfO800@0AfO800<000000=@m
6@17IlP01@17IlP00`000000AfO804MWb00504MWb0030000003D?AT0AfO800D0AfO81@3D?AT01@17
IlP0e3dI04MWb017IlP0000000H0AfO800<0e3dI04MWb00000001@0000020?ofkP0303eIZ`3om^h0
ooK^0080ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP050000003om^h0
ooK^0?ofkP0mFJ/02@3om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0
?EV[0?ofkP3om^h0303om^h503eIZ`80ooK^00<0?EV[0?ofkP3om^h09P3om^h00`000000ooK^0?of
kP0S0?ofkP40oooo001A0?ofkP8000001@3om^h0100mFJ/0ooK^0?ofkP0mFJ/80?ofkPH0?EV[103o
m^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00<0ooK^1`0mFJ/30?ofkP0303eIZ`3o
m^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP060?ofkP80000000D0
9`/50000000mFJ/0>A080000000203T@20030000001;5P/0BaH;0080BaH;00<0000004/F2`1;5P/0
0P00000406hQ40040000001^8A00KR4@00000080T2/C00<0?EV[090[4`2@:a<00P2@:a<01`000000
T2/C090[4`000000[3<G0000002/<aL0200mFJ/200000080`cXI00D0?EV[0<<j6@33>QT0`cXI0000
000204QYcP<0e3dI00<0000004QYcP18JLh00`18JLh00`000000B6W>04QYcP0204QYcP0700000018
JLh0B6W>04QYcP3D?AT0B6W>0000000604QYcP0400000018JLh0B6W>04QYcPL0000000<0e3dI04MW
b017IlP01P3D?AT204MWb00300000017IlP0AfO800<0AfO800<0000004MWb03D?AT01@17IlP00`00
0000AfO804MWb00504MWb00400000017IlP0e3dI04MWb0D0e3dI1P17IlP00`3D?AT0AfO800000006
04MWb080e3dI1P0000030?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h02P3om^h0
1@0mFJ/0ooK^0?ofkP3om^h0000000@0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?of
kP0:0?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h04@3om^h303eIZbL0ooK^00<0
00000?ofkP3om^h0903om^h10?ooo`00D03om^h00`000000ooK^000000050?ofkP0403eIZ`3om^h0
ooK^03eIZ`h0ooK^1P0mFJ/30?ofkP0303eIZ`3om^h0ooK^00X0ooK^1`0mFJ/50?ofkP0303eIZ`3o
m^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h01`3om^h20000000502L;1@000000?EV[03T@20000000
0P0i40P00`000000BaH;04/F2`0204/F2`030000001;5P/0BaH;008000001@1^8A001`000000KR4@
0000002@:a<0?EV[090[4`000000102@:a<00`000000T2/C000000020:`c5`030000002/<aL0[3<G
0080[3<G00@000000:`c5`2/<aL0[3<G1P0mFJ/30<<j6@030000003D?AT0B6W>0080B6W>0P3D?AT4
04QYcP0300000018JLh0B6W>00<0B6W>00H0000004QYcP18JLh0e3dI04QYcP00000604QYcP030000
0018JLh0B6W>00@0B6W>00@0000004QYcP18JLh0e3dI1`00000204MWb0H0e3dI0P17IlP00`000000
e3dI04MWb00504MWb00300000017IlP0e3dI00T0e3dI0`17IlP00`000000AfO804MWb00404MWb003
0=@m6@17IlP0000000P0AfO800<0000003eIZ`0mFJ/00P0mFJ/200000080ooK^00<0?EV[0?ofkP3o
m^h00P3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0403eIZ`3om^h0ooK^000000D0ooK^00<0?EV[0?of
kP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?of
kP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP0T0?ofkP030000003om^h0ooK^02D0ooK^0@3oool00500
ooK^0P0000060?ofkP0303eIZ`3om^h0?EV[01<0ooK^00<0?EV[0?ofkP0mFJ/01P0mFJ/<0?ofkP04
03eIZ`3om^h0ooK^0?ofkPH0?EV[2P3om^h00`0mFJ/0ooK^0?ofkP070?ofkP80000000<09`/503eI
Z`0i40P00P0i40P010000000>A0800000000000404/F2`8000000P1^8A000`000000KR4@06hQ4002
06hQ408000000P2@:a<0100mFJ/0T2/C090[4`000003090[4`800000102/<aL00`000000[3<G0:`c
5`020:`c5`090000002/<aL0[3<G00000033>QT000000<<j6@0mFJ/0000000<0?EV[00<000000=@m
6@18JLh00P18JLh010000000B6W>0=@m6@3D?AT204QYcP0300000018JLh0B6W>00<0B6W>00<00000
04QYcP3D?AT00`18JLh00`000000B6W>04QYcP0304QYcP0300000018JLh0B6W>00@0B6W>00@00000
04QYcP18JLh0e3dI0`18JLh010000000B6W>04QYcP18JLh600000080AfO8303D?AT504MWb0030000
003D?AT0AfO800@0AfO800<0000004MWb017IlP01@17IlP00`3D?AT0000004MWb00704MWb0060000
003oDb8000000000003oCAl000001P0mFJ/30?ofkP0303eIZ`3om^h0ooK^00/0ooK^00@0?EV[0?of
kP3om^h000001@3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[
0?ofkP3om^h0503om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^02<0ooK^00<00000
0?ofkP3om^h09P3om^h10?ooo`00D03om^h2000000H0ooK^00<0?EV[0?ofkP0mFJ/04`3om^h00`0m
FJ/0ooK^0?ofkP020?ofkP0403eIZ`3om^h0ooK^0?ofkPP0?EV[103om^h00`0mFJ/0ooK^0?ofkP05
0?ofkP0303eIZ`3om^h0?EV[00H0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP070?ofkP80000000<09`/5
03eIZ`0i40P00P0i40P010000000>A0800000000000404/F2`8000000`1^8A000`000000KR4@06hQ
400206hQ40040000002@:a<0T2/C03eIZ`<0T2/C00D00000090[4`2@:a<0T2/C000000050:`c5`03
0000002/<aL0[3<G0080[3<G00H000000:`c5`000000`cXI0000000mFJ/20<<j6@0500000033>QT0
`cXI0<<j6@0000001018JLh00`000000B6W>04QYcP020=@m6@0304QYcP000000B6W>00<0B6W>00<0
000004QYcP3D?AT00`18JLh00`000000B6W>04QYcP0304QYcP0300000018JLh0B6W>00@0B6W>00<0
000004QYcP3D?AT00`18JLh00`000000B6W>04QYcP0504QYcP0300000018JLh0B6W>00@0000000<0
e3dI0000000000001017IlP00`000000AfO804MWb00404MWb00300000017IlP0e3dI00@0AfO800<0
000004MWb017IlP01@17IlP00`3D?AT0000004MWb00604MWb080000000L0oe<R000000000000oddO
0000003N@QT0000000<0ooK^00<0?EV[0?ofkP0mFJ/01P0mFJ/:0?ofkP0303eIZ`3om^h0000000H0
ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^01@0
ooK^00<0?EV[0?ofkP3om^h04P3om^h00`0mFJ/0ooK^0?ofkP0S0?ofkP030000003om^h0ooK^02L0
ooK^0@3oool00500ooK^0P0000050?ofkP0403eIZ`3om^h0ooK^03eIZa80ooK^00<0?EV[0?ofkP3o
m^h00`3om^h00`0mFJ/0ooK^0?ofkP090?ofkPP0?EV[103om^h00`0mFJ/0ooK^0?ofkP060?ofkPP0
?EV[103om^h30000000302L;1@0mFJ/0>A080080>A080P00000204/F2`030000001;5P/0BaH;0080
BaH;00D0000006hQ401^8A00KR4@0000000406hQ4080000000<0T2/C03eIZ`2@:a<00`2@:a<00`00
0000T2/C090[4`02000000@0[3<G00<000000:`c5`2/<aL00P2/<aL2000000<0`cXI00D0?EV[0<<j
6@33>QT0`cXI000000020<<j6@0300000018JLh0B6W>0080B6W>00<0000004QYcP18JLh00P18JLh2
0=@m6@@0B6W>00<000000=@m6@18JLh00`18JLh00`000000B6W>04QYcP0304QYcP0300000018JLh0
B6W>00@0B6W>00<0000004QYcP3D?AT00`18JLh00`000000B6W>04QYcP0404QYcP0300000018JLh0
B6W>00<0B6W>00<0000004QYcP3D?AT00P18JLh7000000@0AfO800<000000=@m6@17IlP01017IlP0
0`000000AfO804MWb00504MWb0030=@m6@17IlP0AfO800D0AfO800<000000?mC8P3oDb800P000000
1@3oCAl00000000000000000ooK^00H0?EV[0P3om^h0100mFJ/0ooK^0?ofkP3om^h703eIZ`80ooK^
00<0?EV[0?ofkP0000001P3om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00T0ooK^
00<0?EV[0?ofkP3om^h0503om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^0280ooK^
00<000000?ofkP3om^h0:03om^h10?ooo`00D03om^h2000000D0ooK^00@0?EV[0?ofkP3om^h0?EV[
4P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00h0ooK^00@0?EV[0?ofkP3om^h0
ooK^1`0mFJ/90?ofkP0303eIZ`3om^h0ooK^0080ooK^1P0mFJ/0100W2`D0000003eIZ`00000303T@
20040000001;5P/0BaH;000000@0BaH;0P00000306hQ40040000001^8A00KR4@00000080T2/C00<0
?EV[090[4`2@:a<00`2@:a<00`000000T2/C000000020:`c5`030000002/<aL0[3<G0080[3<G00<0
00000:`c5`2/<aL00P2/<aL01P000000`cXI0<<j6@33>QT0?EV[000000<0`cXI00@000000<<j6@33
>QT000001018JLh00`000000B6W>04QYcP0304QYcP80e3dI0`18JLh00`3D?AT0B6W>04QYcP0204QY
cP0300000018JLh0B6W>00<0B6W>00<0000004QYcP18JLh01018JLh00`000000e3dI04QYcP0304QY
cP0300000018JLh0B6W>00@0B6W>00<0000004QYcP18JLh00`18JLh00`000000e3dI04QYcP0404QY
cP0300000018JLh0B6W>0080B6W>1@0000000`3D?AT0AfO804MWb00204MWb00300000017IlP0AfO8
00D0AfO800<0e3dI04MWb017IlP01@17IlP00`000000oe<R00000002000000040?m=7`0000000000
000000D0ooK^00<0?EV[0?ofkP3om^h01P0mFJ/70?ofkPP0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP07
0?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP0C
0?ofkP0303eIZ`3om^h0ooK^0280ooK^00<000000?ofkP3om^h0:03om^h10?ooo`00D03om^h20000
00D0ooK^100mFJ/B0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0m
FJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00H0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP060?of
kP060000000W2`D09`/50000000mFJ/000000`0i40P01@000000BaH;04/F2`1;5P/000000080BaH;
00<0000006hQ40000000101^8A000`000000KR4@00000002090[4`0303eIZ`000000T2/C00@0T2/C
0P0000030:`c5`030000002/<aL0[3<G0080[3<G00H000000:`c5`2/<aL000000<<j6@0000020<<j
6@0303eIZ`000000`cXI0080`cXI00@000000<<j6@33>QT000001018JLh00`000000B6W>04QYcP03
04QYcP0300000018JLh0e3dI0080e3dI00<0000004QYcP18JLh00P18JLh00`000000B6W>04QYcP03
04QYcP0300000018JLh0B6W>00<0B6W>00<0000004QYcP3D?AT01018JLh00`000000B6W>04QYcP03
04QYcP0300000018JLh0B6W>00<0B6W>00<0000004QYcP3D?AT01@18JLh00`000000B6W>04QYcP04
04QYcP0400000018JLh0e3dI04QYcPL000001017IlP00`000000e3dI04MWb00504MWb0060000003o
Db8000000?mC8P000000oddO100000050?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/0103om^h603eI
Z`<0ooK^00<0?EV[0000003om^h00`3om^h603eIZ`H0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0m
FJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h08@3om^h00`00
0000ooK^0?ofkP0Y0?ofkP40oooo001?0?ofkP030000003om^h0000000D0ooK^00<0?EV[0?ofkP3o
m^h0200mFJ/;0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0
ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00H0ooK^1P0mFJ/60?ofkP060000000W2`D09`/503eI
Z`0i40P000000`0i40P01@000000BaH;04/F2`1;5P/000000080BaH;00@0000006hQ401^8A000000
0`1^8A02000000<0T2/C00<0?EV[090[4`0000001@2@:a<00`000000[3<G0:`c5`020:`c5`030000
002/<aL0[3<G0080[3<G00<000000:`c5`0000000P33>QT01@000000?EV[0<<j6@33>QT0000000<0
`cXI00<000000<<j6@33>QT00`00000204QYcP0300000018JLh0B6W>0080B6W>00@0000004QYcP18
JLh0B6W>0P3D?AT404QYcP0300000018JLh0B6W>00<0B6W>00<0000004QYcP18JLh00`18JLh00`00
0000B6W>0=@m6@0304QYcP0300000018JLh0B6W>00@0B6W>00<0000004QYcP18JLh00`18JLh00`00
0000e3dI04QYcP0404QYcP0300000018JLh0B6W>00@0B6W>00@0000004QYcP18JLh0e3dI0`18JLh0
0`000000B6W>04QYcP0204QYcP@0000000<0e3dI0000000000001017IlP010000000oe<R0000003o
Db82000000040?m=7`00000000000=i26@H0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0:0?ofkPP0
?EV[103om^h00`0mFJ/0ooK^0?ofkP0503eIZ`030?ofkP0mFJ/0ooK^00/0ooK^00<0?EV[0?ofkP3o
m^h04`3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^0200ooK^00<000000?ofkP3o
m^h0:P3om^h10?ooo`00C`3om^h2000000H0ooK^00<0?EV[0?ofkP0mFJ/0203om^h803eIZ`<0ooK^
00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00D0ooK^
00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP0603eIZ`040000000W2`D09`/503eIZ`80
>A0800D0000003T@20000000BaH;0000000304/F2`030000001;5P/0000000<0KR4@00D0000006hQ
401^8A00KR4@00000003090[4`0303eIZ`2@:a<0000000D0T2/C0P0000030:`c5`030000002/<aL0
[3<G0080[3<G0P0000030<<j6@030000000mFJ/0`cXI0080`cXI00H000000<<j6@33>QT0`cXI0000
0033>QT20000000304U/d`000000000000<000000`18JLh01@000000B6W>04QYcP3D?AT0B6W>00<0
e3dI0P18JLh00`000000B6W>04QYcP0204QYcP0300000018JLh0B6W>00<0B6W>00<000000=@m6@18
JLh00`18JLh00`000000B6W>04QYcP0304QYcP0300000018JLh0B6W>00<0B6W>00<0000004QYcP3D
?AT01018JLh00`000000B6W>04QYcP0504QYcP0300000018JLh0e3dI00<0B6W>00<0000004QYcP18
JLh01@18JLh00`000000B6W>0=@m6@0204QYcP@0000000<0oe<R0000000000000P000000103oCAl0
00000=@m6@0000070?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/03@3om^h00`0mFJ/0ooK^0?ofkP02
0?ofkPT0?EV[0`3om^h603eIZ`L0ooK^00<0?EV[0?ofkP3om^h0503om^h00`0mFJ/0ooK^0?ofkP0B
0?ofkP0303eIZ`3om^h0ooK^0200ooK^00<000000?ofkP3om^h0:`3om^h10?ooo`00C`3om^h20000
00H0ooK^00<0?EV[0?ofkP0mFJ/0403om^h703eIZ`030?ofkP0mFJ/0ooK^00h0ooK^00<0?EV[0?of
kP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0e3dI03eI
Z`0mFJ/01@0mFJ/0100i40P0000004/F2`00000304/F2`800000101^8A0010000000KR4@06hQ401^
8A0200000080T2/C00@0?EV[090[4`2@:a<000000`2@:a<010000000[3<G0:`c5`0000030:`c5`03
0000002/<aL0[3<G0080[3<G00<000000<<j6@33>QT00P33>QT01@0mFJ/0`cXI0<<j6@33>QT00000
00<0`cXI0P0000000`3G?a`0000004U/d`0304U/d`0300000019K=<0000000@0000000<0e3dI0000
000000000`0000030=@m6@@0B6W>00<0000004QYcP18JLh00`18JLh00`000000e3dI04QYcP0304QY
cP0300000018JLh0B6W>00<0B6W>00<0000004QYcP18JLh00`18JLh00`000000e3dI04QYcP0304QY
cP0300000018JLh0B6W>00D0B6W>00@0000004QYcP18JLh0e3dI0P18JLh00`000000B6W>04QYcP05
04QYcP0300000018JLh0e3dI0080B6W>00D0e3dI04QYcP00000000000?mC8P0200000080oe<R0P00
00000`3D?AT000000?ofkP070?ofkP0403eIZ`3om^h0ooK^03eIZ`d0ooK^00<0000003eIZ`3om^h0
1P3om^h00`0mFJ/0ooK^0?ofkP030?ofkPD0?EV[103om^h503eIZ`80ooK^00<0?EV[0?ofkP3om^h0
503om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^01l0ooK^00<000000?ofkP3om^h0
;03om^h10?ooo`00C`3om^h2000000H0ooK^00<0?EV[0?ofkP0mFJ/04`3om^h0100mFJ/0ooK^0?of
kP3om^h703eIZ`X0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eI
Z`3om^h0ooK^00H0ooK^00D0e3dI0000000W2`D09`/503eIZ`0203T@20030000000mFJ/0?EV[00H0
?EV[00<0000006hQ401^8A000`1^8A001`000000KR4@06hQ40000000T2/C0000000mFJ/0102@:a<0
10000000T2/C090[4`0000030:`c5`050000002/<aL0[3<G0:`c5`0000000`2/<aL2000000<0`cXI
00<0?EV[00000033>QT00P33>QT01@000000`cXI0<<j6@33>QT000000080eclL00D0000004U/d`19
K=<0BFcC0000000404U/d`0300000019K=<0e3dI0080BFcC00<0000004U/d`19K=<00`0000020=@m
6@80B6W>00<0000004QYcP18JLh00`18JLh00`3D?AT0B6W>04QYcP0304QYcP0300000018JLh0B6W>
0080B6W>00<0000004QYcP18JLh00`18JLh00`000000B6W>0=@m6@0404QYcP0300000018JLh0B6W>
00@0B6W>00@0000004QYcP18JLh0e3dI0P18JLh00`000000B6W>04QYcP0404QYcP8000000P18JLh3
0=@m6@0304QYcP000000000000<000000P3oDb82000000030=@m6@000000gT8I00P0ooK^00@0?EV[
0?ofkP3om^h0?EV[303om^h00`000000ooK^03eIZ`070?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0
?EV[0?ofkP3om^h01`3om^h603eIZa<0ooK^00<0?EV[0?ofkP3om^h04P3om^h00`0mFJ/0ooK^0?of
kP0N0?ofkP030000003om^h0ooK^02d0ooK^0@3oool004l0ooK^0P0000050?ofkP0303eIZ`3om^h0
ooK^00@0?EV[403om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00H0ooK^1`0mFJ/30?ofkP0303eIZ`3o
m^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP060?ofkP80e3dI00<0
000003eIZ`0000000`0i40P01@000000BaH;04/F2`1;5P/0000000<0BaH;200mFJ/01@000000T2/C
090[4`2@:a<0?EV[00D0T2/C0P0000050:`c5`070000002/<aL0[3<G0:`c5`000000[3<G00000002
0<<j6@0300000033>QT0?EV[0080`cXI00T000000<<j6@33>QT0`cXI00000033>QT000000=Lo7000
00000P3G?a`01@000000BFcC04U/d`19K=<0000000@0BFcC00D0e3dI04U/d`19K=<0BFcC00000004
04U/d`0300000019K=<0BFcC00<0e3dI0P00000304QYcP030=@m6@18JLh0B6W>0080B6W>00<00000
04QYcP18JLh00`18JLh00`000000B6W>04QYcP0304QYcP030000003D?AT0B6W>00<0B6W>00<00000
04QYcP18JLh01018JLh01`000000B6W>04QYcP18JLh0e3dI04QYcP0000001P18JLh00`000000B6W>
04QYcP030=@m6@80B6W>00D0000003eIZ`000000oe<R000000030?mC8P<0000000<0gT8I0?ofkP3o
m^h01P3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00`0ooK^00<000000?ofkP0mFJ/01P3om^h00`0m
FJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00T0ooK^00@0?EV[0?ofkP3om^h0ooK^1`0mFJ/;
0?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h07P3om^h00`000000ooK^0?ofkP0]
0?ofkP40oooo001?0?ofkP8000001@3om^h0100mFJ/0ooK^0?ofkP0mFJ/30?ofkPP0?EV[203om^h0
1@0mFJ/0ooK^0?ofkP3om^h0?EV[00d0ooK^1`0mFJ/30?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0
?EV[0?ofkP3om^h01@3om^h01`3D?AT0ooK^0=@m6@000000?EV[03T@200000000P0i40P00`000000
BaH;04/F2`0204/F2`050000001;5P/0000006hQ400000001@1^8A000`000000?EV[03eIZ`0503eI
Z`@0T2/C00<000000:`c5`2/<aL0102/<aL010000000[3<G0:`c5`2/<aL2000000<0`cXI00<00000
03eIZ`33>QT00P33>QT01P000000`cXI0<<j6@000000`cXI00000080eclL00@000000=Lo703G?a`0
00000P19K=<00`000000BFcC04U/d`0204U/d`030=@m6@19K=<0BFcC0080BFcC00D0000004U/d`19
K=<0BFcC0000000404U/d`060000003D?AT0e3dI0=@m6@000000e3dI2000000204QYcP0300000018
JLh0B6W>00<0B6W>00<0000004QYcP3D?AT00`18JLh00`000000B6W>04QYcP0404QYcP0700000018
JLh0B6W>04QYcP3D?AT0B6W>0000000604QYcPD0e3dI0P18JLh2000000040?mE8`0mFJ/0oe<R0000
0080oe<R1P0000080?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/02`3om^h010000000ooK^0?ofkP0m
FJ/60?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?of
kP090?ofkPP0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^01d0ooK^00<0
00000?ofkP3om^h0;P3om^h10?ooo`00C`3om^h2000000D0ooK^00@0?EV[0?ofkP3om^h0?EV[2`3o
m^h903eIZ`<0ooK^00<0?EV[0?ofkP3om^h03P3om^h0100mFJ/0ooK^0?ofkP3om^h603eIZ`X0ooK^
00<0?EV[0?ofkP3om^h01@3om^h30=@m6@040000000mFJ/0>A0800000080>A0800<0000004/F2`1;
5P/00P1;5P/00`000000BaH;0000000206hQ40030000001^8A00KR4@00<0KR4@00L00000090[4`2@
:a<0T2/C03eIZ`2@:a<0000000H0?EV[1P2/<aL01@000000[3<G0:`c5`2/<aL0000000@0`cXI00<0
?EV[0<<j6@33>QT00P33>QT010000000`cXI0<<j6@0000030=Lo70040000003G?a`0eclL000000<0
BFcC00H0000004U/d`19K=<0e3dI04U/d`00000304U/d`0500000019K=<0BFcC04U/d`0000001019
K=<010000000BFcC04U/d`19K=<60=@m6@0404U/d`000000BFcC04U/d`D000000`18JLh00`000000
e3dI04QYcP0204QYcP0300000018JLh0B6W>00@0B6W>00<0000004QYcP18JLh00P18JLh00`3D?AT0
000004QYcP0204QYcP@0e3dI1018JLh0203D?AT0B6W>0000003oEB<0000003eIZ`3oDb8000000P3o
Db85000000030=i26@3om^h0ooK^00L0ooK^00@0?EV[0?ofkP3om^h0?EV[303om^h010000000ooK^
0?ofkP0mFJ/60?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0
ooK^0?ofkP0A0?ofkPL0?EV[4P3om^h00`0mFJ/0ooK^0?ofkP0L0?ofkP030000003om^h0ooK^02l0
ooK^0@3oool004h0ooK^0P0000060?ofkP0303eIZ`3om^h0?EV[01<0ooK^200mFJ/>0?ofkP0303eI
Z`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h01`0mFJ/30?ofkP0303eIZ`3om^h0ooK^00D0ooK^
0`3D?AT020000000?EV[03T@20000000>A080000001;5P/00000101;5P/00`000000KR4@06hQ4002
06hQ40030000001^8A00KR4@0080KR4@0P0000000`2@:a<0?EV[090[4`02090[4`040000002@:a<0
T2/C00000080[3<G1P0mFJ/0102/<aL000000:`c5`2/<aL2000000<0`cXI00<0?EV[00000033>QT0
0P33>QT00`000000`cXI0<<j6@02000000<0eclL00@000000=Lo703G?a`000000P19K=<01P000000
BFcC04U/d`3D?AT0BFcC000000<0BFcC00<0000004U/d`19K=<00P19K=<01@000000BFcC04U/d`19
K=<0000000<0BFcC00<0e3dI04U/d`0000000`19K=<80=@m6@0304U/d`00000000000080000000D0
e3dI04QYcP18JLh0B6W>0000000604QYcP0600000018JLh0B6W>04QYcP3D?AT00000103D?AT204QY
cP0300000018JLh0B6W>0080B6W>00L0e3dI03eIZ`0mFJ/0?EV[0000003oEB<0?EV[00<0oe<R00D0
00000?mC8P00000000000?m=7`08000000<0ooK^00@0?EV[0?ofkP3om^h0?EV[2`3om^h01@000000
ooK^0?ofkP3om^h0?EV[00D0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP080?of
kP0303eIZ`3om^h0ooK^01@0ooK^00@0?EV[0?ofkP3om^h0ooK^1`0mFJ/:0?ofkP0303eIZ`3om^h0
ooK^01`0ooK^00<000000?ofkP3om^h0<03om^h10?ooo`00CP3om^h2000000H0ooK^00<0?EV[0?of
kP0mFJ/04`3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00H0?EV[203om^h00`0m
FJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00L0ooK^1P0mFJ/40?ofkP@0e3dI00P0?EV[03T@
200i40P0000003T@20000000BaH;000000@0BaH;00<0000006hQ401^8A000`1^8A0010000000KR4@
06hQ40000002090[4`030000000mFJ/0T2/C00<0T2/C0P0000040:`c5`030000002/<aL0[3<G0080
[3<G1P0mFJ/20000000403eIZ`33>QT0`cXI000000<0`cXI0P0000020=Lo70050000003G?a`0eclL
0=Lo700000000P3G?a`01@000000BFcC04U/d`000000e3dI00<0BFcC00@0000004U/d`19K=<00000
1019K=<01@000000BFcC04U/d`19K=<0000000<0BFcC00<0e3dI00000019K=<00`19K=<00`000000
BFcC04U/d`0204U/d`0300000019K=<0BFcC01H0e3dI1018JLh2000000D0B6W>00@000000?mE8`00
000000001P0mFJ/0103oDb8000000000003oCAl20000000303eIZ`3om^h0ooK^00@0ooK^0`000000
100mFJ/000000000000mFJ/:0?ofkP030000003om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h00`3o
m^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h04`3o
m^h00`0mFJ/0ooK^0?ofkP090?ofkPL0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP0K0?ofkP030000003o
m^h0ooK^0340ooK^0@3oool004h0ooK^0P0000060?ofkP@0?EV[4P3om^h00`0mFJ/0ooK^0?ofkP02
0?ofkP0303eIZ`3om^h0ooK^00H0ooK^1P0mFJ/20?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[
0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP0603eIZ`80e3dI00<0?EV[03T@200i40P00P0i40P0
10000000BaH;04/F2`00000304/F2`800000101^8A0010000000KR4@06hQ40000003090[4`0303eI
Z`2@:a<0T2/C00<0T2/C00<000000:`c5`2/<aL00`2/<aL2000000D0[3<G00<000000<<j6@33>QT0
1P0mFJ/01@000000`cXI0<<j6@33>QT0000000<0eclL00D000000=Lo703G?a`0eclL000000020=Lo
700400000019K=<0BFcC0=@m6@<0BFcC00D0000004U/d`19K=<0BFcC0000000304U/d`0500000019
K=<0BFcC04U/d`0000000P19K=<00`3D?AT0BFcC0000000404U/d`0300000019K=<0BFcC0080BFcC
00<0000004U/d`19K=<00P19K=<00`000000e3dI04U/d`0204U/d`0400000019K=<0BFcC04U/d`P0
000000<0e3dI0000000000000`18JLh00`000000B6W>04QYcP0404QYcP030000003oEB<000000080
oeDS00@000000?mC8P0mFJ/000000P3oDb8=03eIZ`<0ooK^00@0?EV[0?ofkP3om^h0?EV[1P000004
0?ofkP030000003om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP09
0?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h0503om^h00`0mFJ/0ooK^0?ofkP0@
0?ofkP@0?EV[703om^h00`000000ooK^0?ofkP0b0?ofkP40oooo001>0?ofkP8000001P3om^h0100m
FJ/0ooK^03eIZ`3om^h703eIZ`/0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0?0?ofkPH0?EV[0P3o
m^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00<0ooK^0`3D?AT403eIZ`80>A0800D0
000004/F2`1;5P/0BaH;0000000204/F2`040000001^8A00KR4@000000@0KR4@0P000003090[4`04
03eIZ`2@:a<00000000000<0T2/C0P0000060:`c5`070000002/<aL0[3<G0:`c5`000000`cXI0000
00030<<j6@0403eIZ`000000`cXI0<<j6@H0?EV[0`3G?a`01`000000eclL0=Lo703G?a`000000=Lo
700000000P19K=<00`3D?AT0BFcC04U/d`0204U/d`0400000019K=<0BFcC000000<0BFcC00<00000
04U/d`19K=<00P19K=<01@000000BFcC0=@m6@19K=<0000000@0BFcC00D0000004U/d`19K=<0BFcC
0000000404U/d`0300000019K=<0e3dI0080BFcC00<0000004U/d`19K=<01019K=<00`000000BFcC
04U/d`0204U/d`040000003D?AT0BFcC04U/d`D000000`18JLh2000000030?mE8`000000oeDS00<0
000000<0?EV[0000003oDb800`0000020?m=7`8000000P3om^h=03eIZ`H0ooK^100000050?ofkP03
03eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP070?ofkP03
03eIZ`3om^h0ooK^01@0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP0J0?ofkP03
0000003om^h0ooK^0380ooK^0@3oool004h0ooK^0P0000060?ofkP80?EV[2@3om^h803eIZ`<0ooK^
00D0?EV[0?ofkP3om^h0ooK^03eIZ`0@0?ofkP0303eIZ`3om^h0ooK^0080ooK^1P0mFJ/:0?ofkP03
03eIZ`3om^h0ooK^00<0ooK^1@3D?AT01@0mFJ/0e3dI03T@200i40P0000000@0BaH;00<0000004/F
2`0000000`1^8A000`000000KR4@06hQ400206hQ40050000002@:a<0T2/C090[4`0mFJ/00`2@:a<0
0`000000T2/C000000020:`c5`8000001@2/<aL010000000[3<G0:`c5`0000020<<j6@80000000@0
?EV[0<<j6@33>QT000000`33>QT200000080eclL1P0mFJ/20=Lo70060000003G?a`0000004U/d`3D
?AT000000`19K=<010000000BFcC04U/d`00000304U/d`0300000019K=<0BFcC0080BFcC00D00000
0=@m6@19K=<0BFcC0000000304U/d`0300000019K=<0BFcC0080BFcC00<0000004U/d`19K=<00P19
K=<00`000000e3dI04U/d`0204U/d`0300000019K=<0BFcC00<0BFcC00<0000004U/d`19K=<00P19
K=<00`000000e3dI04U/d`0204U/d`8000000`19K=<3000000060?mE8`00000000000?mE8`000000
oeDS0P0000001@0mFJ/0oe<R0000003oDb8000000080oddO0`00000:0?ofkP/0?EV[0`3om^h00`00
0000ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0m
FJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0m
FJ/0ooK^0?ofkP0J0?ofkP030000003om^h0ooK^03<0ooK^0@3oool004h0ooK^0P0000060?ofkP80
?EV[4@3om^h803eIZa00ooK^00<0?EV[0?ofkP3om^h0103om^h0100mFJ/0ooK^0?ofkP3om^h803eI
Z`80ooK^00<0?EV[0?ofkP3om^h00`3om^h30=@m6@040?ofkP0mFJ/0ooK^0=@m6@80>A080P000003
04/F2`800000101^8A001`000000KR4@06hQ401^8A000000090[4`0000000P2@:a<00`0mFJ/0T2/C
090[4`02090[4`800000102/<aL00`000000[3<G0:`c5`030:`c5`8000001@33>QT0100mFJ/0`cXI
0<<j6@33>QT200000080`cXI00D000000=Lo703G?a`0eclL000000030=Lo70030000000mFJ/0?EV[
0080?EV[00D0eclL000000000000BFcC03eIZ`0304U/d`0300000019K=<0000000<0BFcC00<00000
04U/d`19K=<00P19K=<01@000000e3dI04U/d`19K=<0000000<0BFcC00D0000004U/d`19K=<0BFcC
0000000404U/d`0300000019K=<0e3dI0080BFcC00<0000004U/d`19K=<00`19K=<010000000BFcC
04U/d`19K=<2000000050=@m6@19K=<0BFcC04U/d`0000001@19K=<2000000050?mE8`000000oeDS
0?mE8`0000000P3oEB<01P000000oe<R03eIZ`000000oe<R00000080oddO0`00000<0?ofkP0303eI
Z`3om^h0?EV[0080ooK^2`0mFJ/30?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h0
2P3om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h0
4`3om^h00`0mFJ/0ooK^0?ofkP0I0?ofkP030000003om^h0ooK^03@0ooK^0@3oool004d0ooK^0P00
00060?ofkP0303eIZ`3om^h0?EV[0080?EV[4P3om^h0100mFJ/0ooK^0?ofkP3om^h703eIZ`X0ooK^
00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP090?ofkPP0?EV[0P3D?AT20?ofkP0703eI
Z`3D?AT0000003T@20000000BaH;0000000404/F2`030000001^8A00KR4@00<0KR4@00@0000006hQ
401^8A0000000P2@:a<00`000000?EV[090[4`05090[4`030000002/<aL0[3<G00<0[3<G00<00000
0:`c5`2/<aL00`2/<aL00`000000`cXI0<<j6@030<<j6@0303eIZ`000000`cXI00<0`cXI0P000000
0`3G?a`000000=Lo70020=Lo70050000003G?a`0eclL0=Lo700000000P3G?a`2000000030>Q57@00
0000000000H0000000<0BFcC00000019K=<00P19K=<01@000000BFcC04U/d`19K=<0e3dI00<0BFcC
00D0000004U/d`19K=<0BFcC0000000304U/d`0700000019K=<0BFcC04U/d`000000BFcC0=@m6@02
04U/d`0300000019K=<0BFcC00<0BFcC00D0000004U/d`19K=<0BFcC0000000204U/d`040=@m6@19
K=<00000000000@0BFcC0P000000103oE2<000000000003oEB<2000000070?mE8`00000000000?mC
8P0mFJ/000000?mC8P02000000040?m=7`000000oddO000000d0ooK^0P0mFJ/80?ofkP`0?EV[0P3o
m^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h0503o
m^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^01P0ooK^00<000000?ofkP3om^h0=@3o
m^h10?ooo`00C@3om^h2000000H0ooK^00<0?EV[0?ofkP0mFJ/00P3om^h603eIZ``0ooK^00D0?EV[
0?ofkP3om^h0ooK^03eIZ`060?ofkPL0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3o
m^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`3D?AT0?EV[03eIZ`0603eIZ`040000001;
5P/0BaH;000000<0BaH;0P00000506hQ40800000102@:a<00`0mFJ/0T2/C090[4`04090[4`800000
1@2/<aL00`000000[3<G0:`c5`020:`c5`<000000P33>QT0100mFJ/0`cXI0<<j6@0000040<<j6@03
0000003G?a`0eclL008000000P3G?a`200000080eclL00@000000=Lo703G?a`000000P3XAAd00`00
0000BVkG0000000204Y^e`030000001:K]L00000008000000P19K=<01@000000BFcC04U/d`19K=<0
e3dI0080BFcC00<0000004U/d`19K=<00P19K=<010000000BFcC04U/d`00000404U/d`0500000019
K=<0e3dI04U/d`0000001019K=<2000000<0BFcC00H0000004U/d`19K=<0e3dI04U/d`00000504U/
d`040000003oE2<0oe@S00000080oeDS00P000000?mE8`00000000000?mE8`000000oe<R03eIZ`<0
000000<0oddO0000003oCAl00P00000=0?ofkP80?EV[2`3om^h00`000000ooK^0?ofkP0503eIZ`03
0?ofkP0mFJ/0?EV[00@0?EV[2@3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^01<0
ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP0H0?ofkP030000003om^h0ooK^03H0
ooK^0@3oool004d0ooK^0P0000060?ofkP0303eIZ`3om^h0?EV[00P0ooK^1P0mFJ/60?ofkP0403eI
Z`3om^h0ooK^03eIZ`h0ooK^1`0mFJ/20?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3o
m^h00P3om^h20=@m6@<0ooK^00@0?EV[0=@m6@3om^h00000200mFJ/00`1^8A00000006hQ400406hQ
40030000002@:a<0T2/C0080T2/C00<0?EV[0000000000000`2@:a<00`000000[3<G0:`c5`020000
00@0[3<G0P0000000`2/<aL000000<<j6@020<<j6@0300000033>QT0?EV[00<0`cXI0P0000020<<j
6@8000000`3G?a`01@000000eclL0=Lo703G?a`000000080eclL0P0000003@3XAAd000000>Q57@00
0000BVkG0000001:K]L0e3dI04Y^e`000000BVkG0000001:K]L01@0000001@3D?AT0000000000019
K=<0000000<0BFcC00D0000004U/d`19K=<0BFcC0000000304U/d`0500000019K=<0e3dI04U/d`00
00001019K=<00`000000BFcC04U/d`0204U/d`0600000019K=<0BFcC04U/d`3D?AT000001019K=<2
000000080?mD8`00000000000000003oEB<000000?mE8`0000020?mE8`040000003oDb80?EV[0000
0080oe<R0P0000000`3oCAl000000000000>0?ofkP80?EV[2`3om^h00`000000ooK^0?ofkP030?of
kP0303eIZ`3om^h0?EV[00D0?EV[00<0ooK^03eIZ`0mFJ/0100mFJ/30?ofkP0303eIZ`3om^h0ooK^
00H0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^
01L0ooK^00<000000?ofkP3om^h0=`3om^h10?ooo`00C@3om^h2000000H0ooK^100mFJ/=0?ofkPH0
?EV[0`3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0403eIZ`3om^h0ooK^0?ofkPL0?EV[2P3om^h0100m
FJ/0ooK^0?ofkP3om^h30=@m6@80ooK^00D0?EV[0=@m6@3om^h0ooK^0000000404/F2`040000001;
5P/0000006hQ40P0?EV[00@00000090[4`2@:a<0?EV[0`2@:a<010000000T2/C090[4`0000040:`c
5`030000002/<aL0[3<G00<0[3<G0P0000040<<j6@030000000mFJ/0`cXI00@0`cXI0P0000020=Lo
708000000P3G?a`01@000000eclL0=Lo703G?a`000000080eclL00T000000>Q57@3XAAd000000>Q5
7@000000BVkG0000001:K]L00`3D?AT01@1:K]L0000004Y^e`1:K]L000000080BVkG00<0e3dI0000
001:K]L01`0000000`19K=<0000004U/d`0304U/d`0500000019K=<0e3dI04U/d`0000000`19K=<0
0`000000BFcC04U/d`0204U/d`0600000019K=<0BFcC04U/d`3D?AT000000`19K=<2000000060?mD
8`00000000000?mD8`000000oeDS0`0000030?mE8`030000003oDb80?EV[0080oe<R0P000000103o
CAl0000000000000000>0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<000000?ofkP3om^h00P3om^h0
1@0mFJ/0ooK^0?ofkP3om^h0?EV[00<0ooK^2`0mFJ/80?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0
?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP0G0?ofkP030000003om^h0ooK^03L0ooK^0@3o
ool004d0ooK^0P0000060?ofkP80?EV[0P3om^h703eIZ`/0ooK^200mFJ/>0?ofkP0303eIZ`3om^h0
ooK^00<0ooK^00<0?EV[0?ofkP3om^h00P3om^h703eIZ`<0ooK^00@0?EV[0?ofkP3om^h0ooK^0`3D
?AT20?ofkP0303eIZ`3D?AT0ooK^0080ooK^00@0000004/F2`1;5P/0BaH;0P00000506hQ40050000
001^8A00KR4@06hQ400000001P0mFJ/2090[4`8000001P2/<aL00`000000[3<G0:`c5`030:`c5`03
00000033>QT0`cXI0080`cXI00<0?EV[0000000000001@33>QT00`000000eclL0=Lo70020=Lo7004
0000003G?a`0eclL000000<0eclL0P0000002@3XAAd0000003eIZ`3XAAd000000>Q57@000000BVkG
0000000204Y^e`030000003D?AT0e3dI0080e3dI00D0000004Y^e`3D?AT0BVkG0000000204Y^e`06
0000001:K]L0BVkG04Y^e`000000BVkG1`0000000`3D?AT0BFcC0000000304U/d`0400000019K=<0
BFcC04U/d`8000000`19K=<00`000000e3dI04U/d`0204U/d`040000003oE2<00000000000<0oe@S
0`0000030?mE8`80000000<0oe<R0000000mFJ/00P3oDb800`000000oddO00000002000000l0ooK^
0P0mFJ/<0?ofkP030000003om^h0ooK^0080ooK^00@0?EV[0?ofkP3om^h0?EV[2`3om^h803eIZ`<0
ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^01L0
ooK^00<000000?ofkP3om^h0>03om^h10?ooo`00C@3om^h2000000H0ooK^0P0mFJ/90?ofkPP0?EV[
0`3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00<0ooK^200mFJ/60?ofkP0303eIZ`3om^h0ooK^0080
ooK^00<0?EV[0?ofkP3om^h02P3om^h703eIZ`<0e3dI0P3om^h00`0mFJ/0e3dI0?ofkP020?ofkP03
0000001;5P/0BaH;0080BaH;00<0000006hQ401^8A00101^8A000`000000KR4@00000003090[4`04
0000000mFJ/0T2/C090[4`H0?EV[1@2/<aL200000080[3<G00@000000<<j6@00000000000P33>QT0
100mFJ/0`cXI0<<j6@0000030<<j6@040000003G?a`00000000000<0eclL00<000000=Lo703G?a`0
0P0000020=Lo70040000003XAAd0j4DM03eIZ`80j4DM00L000000>Q57@000000BVkG0000001:K]L0
00000080BVkG00<0000004Y^e`3D?AT0103D?AT204Y^e`040000001:K]L0BVkG00000080BVkG00D0
000004Y^e`1:K]L0BVkG0000000204Y^e`030=@m6@000000000000@000000P19K=<010000000BFcC
04U/d`19K=<2000000030=@m6@19K=<0BFcC0080000000<0oe@S0000003oE2<00P3oE2<3000000<0
oeDS0P0000001@3oEB<000000?mC8P0mFJ/0oe<R00@0000000<0oddO0000003om^h03P3om^h00`0m
FJ/0ooK^03eIZ`0<0?ofkP030000003om^h0ooK^0080ooK^00@0?EV[0?ofkP3om^h0?EV[3P3om^h0
0`0mFJ/0ooK^0?ofkP020?ofkPL0?EV[4P3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0
ooK^01H0ooK^00<000000?ofkP3om^h0>@3om^h10?ooo`00C@3om^h00`000000ooK^0?ofkP050?of
kPD0?EV[3P3om^h703eIZ``0ooK^200mFJ/30?ofkP0303eIZ`3om^h0ooK^00d0ooK^00@0?EV[0?of
kP3om^h0e3dI200mFJ/30?ofkP040000001;5P/0BaH;04/F2`8000001P1^8A02000000<0T2/C00<0
?EV[0000000000000`2@:a<010000000[3<G00000000000603eIZ`040:`c5`000000[3<G000000<0
`cXI0P000000100mFJ/0`cXI0<<j6@33>QT2000000030<<j6@000000eclL0080eclL00D000000=Lo
703G?a`0eclL000000030=Lo7080000000L0j4DM000000000000?EV[0000003XAAd000000080j4DM
0P00000204Y^e`030000001:K]L000000080BVkG00@0e3dI04Y^e`1:K]L000001@3D?AT010000000
BVkG04Y^e`00000204Y^e`050000001:K]L0BVkG0=@m6@0000000P1:K]L200000080BVkG1`000002
04U/d`80000000<0e3dI0000000000000P3oE2<3000000<0oeDS0P0000020?mE8`040000003oDb80
oe<R03eIZ`<000000P3oCAl2000000l0ooK^00<0?EV[0?ofkP0mFJ/0303om^h00`000000ooK^0?of
kP020?ofkP0403eIZ`3om^h0ooK^03eIZ`h0ooK^00<0?EV[0?ofkP3om^h01@3om^h0100mFJ/0ooK^
0?ofkP3om^h703eIZ`/0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP0E0?ofkP03
0000003om^h0ooK^03X0ooK^0@3oool004`0ooK^0P0000070?ofkP<0?EV[0P3om^h803eIZ`T0ooK^
00<0?EV[0?ofkP3om^h0200mFJ/;0?ofkP0303eIZ`3om^h0?EV[00H0?EV[303om^h00`0mFJ/0ooK^
0?ofkP020=@m6@070?ofkP3D?AT0ooK^03eIZ`3D?AT0ooK^0=@m6@0603eIZ`0404/F2`000000KR4@
000000H0KR4@00D00000090[4`2@:a<0T2/C03eIZ`02090[4`040000002@:a<0T2/C000000<0[3<G
0P0000040:`c5`H0?EV[0P33>QT00`0mFJ/000000<<j6@040<<j6@030000003G?a`0eclL00<0eclL
0P0000020=Lo708000000P3G?a`02@000000j4DM0>Q57@0mFJ/000000>Q57@000000j4DM00000002
0>Q57@80000000@0BVkG0000001:K]L000000P1:K]L0103D?AT0BVkG04Y^e`00000204Y^e`030000
001:K]L0000000H0e3dI00@0000004Y^e`1:K]L0e3dI0P1:K]L00`000000BVkG0=@m6@040=@m6@03
04Y^e`00000000000080BVkG0P0000000`3oE2<0000003eIZ`0503eIZ`030?mD8`000000oeDS0080
00000P3oEB<200000080oe<R00@0000003eIZ`3oDb8000000P3oCAl2000000<0?EV[3@3om^h00`0m
FJ/0ooK^03eIZ`0<0?ofkP030000003om^h0ooK^0080ooK^00<0?EV[0?ofkP0mFJ/03`3om^h00`0m
FJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00T0ooK^1`0mFJ/30?ofkP0303eIZ`3om^h0ooK^
01<0ooK^00<0?EV[0?ofkP3om^h05@3om^h00`000000ooK^0?ofkP0k0?ofkP40oooo001<0?ofkP80
00001`3om^h00`0mFJ/0ooK^0?ofkP0603eIZ`@0ooK^200mFJ/0103om^h0?EV[0?ofkP0mFJ/80?of
kPP0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0403eIZ`3om^h0ooK^0?ofkPP0?EV[103om^h0
0`0mFJ/0ooK^0?ofkP020=@m6@070?ofkP3D?AT0ooK^03eIZ`3D?AT0ooK^0=@m6@040?ofkP030=@m
6@000000000000<0KR4@00<0000006hQ401^8A000`1^8A001@3D?AT00000090[4`2@:a<0?EV[00<0
T2/C0P0000060:`c5`030000002/<aL0[3<G00<0[3<G0`0000000`33>QT0?EV[03eIZ`0403eIZ`<0
`cXI0`0000050=Lo708000000P3G?a`2000000070>Q57@000000000003eIZ`3XAAd000000>Q57@03
0000000:0>Q57@000000BVkG0000001:K]L0000004Y^e`000000e3dI00000080BVkG00<0000004Y^
e`0000000P1:K]L010000000BVkG04Y^e`00000204Y^e`030000003D?AT0e3dI00H0e3dI00@0BVkG
0000001:K]L0BVkG0P00000204Y^e`D000000P3oE2<300000080oe@S200mFJ/01P000000oe<R0000
000mFJ/0oe<R00000080oddO0`0000030?ofkPH0?EV[1P3om^h0100mFJ/0ooK^0?ofkP0mFJ/<0?of
kP030000003om^h0ooK^0080ooK^00<0?EV[0?ofkP0mFJ/03`3om^h00`0mFJ/0ooK^0?ofkP040?of
kP0303eIZ`3om^h0ooK^0100ooK^1`0mFJ/B0?ofkP0303eIZ`3om^h0ooK^01@0ooK^00<000000?of
kP3om^h0?03om^h10?ooo`00C03om^h2000000L0ooK^100mFJ/50?ofkPD0?EV[1`3om^h603eIZ`h0
ooK^200mFJ/<0?ofkPP0?EV[00D0e3dI0?ofkP3om^h0?EV[0=@m6@030?ofkP050=@m6@3om^h0ooK^
0?ofkP3D?AT00P00000406hQ40050000001^8A00KR4@06hQ400000000P2@:a<00`000000?EV[090[
4`04090[4`030000002/<aL0[3<G00D0[3<G0P0000020:`c5`0400000033>QT0`cXI0<<j6@800000
00<0`cXI03eIZ`33>QT00P33>QT803eIZ`D0eclL00@000000=Lo703G?a`000000`3XAAd00`0mFJ/0
j4DM0>Q57@02000000060>Q57@00000000000>Q57@000000BVkG0P0000002`1:K]L000000=@m6@1:
K]L0000004Y^e`000000BVkG0000001:K]L000000080BVkG00@0000004Y^e`1:K]L000000P1:K]L0
103D?AT0BVkG00000000000204Y^e`80000000<0BVkG0000000000000P1:K]L2000000030?mA8P00
000000000080oe@S0`0000030?mD8`8000000P3oEB<200000080oeDS00<0000003eIZ`0mFJ/01@0m
FJ/30000000303eIZ`3om^h0ooK^00L0ooK^1`0mFJ/20?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0
00000?ofkP3om^h00P3om^h203eIZa00ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?of
kP0C0?ofkP0403eIZ`3om^h0ooK^0?ofkPL0?EV[2`3om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP030000
003om^h0ooK^03`0ooK^0@3oool004`0ooK^0P00000;0?ofkPP0?EV[0P3om^h603eIZ`80ooK^00<0
?EV[0?ofkP0mFJ/00P3om^h603eIZ`/0ooK^00@0?EV[0?ofkP3om^h0ooK^1`0mFJ/:0?ofkP0403eI
Z`3om^h0e3dI0=@m6@L0?EV[00D0ooK^0=@m6@3om^h0ooK^0=@m6@020?ofkP030000001^8A00KR4@
00<0KR4@00@0000006hQ401^8A0000000`2@:a<00`0mFJ/00000090[4`03090[4`<000001`2/<aL3
000000D0`cXI00<0?EV[00000033>QT01033>QT2000000@0eclL200mFJ/30000000403eIZ`3XAAd0
000000000080j4DM00H000000>Q57@00000000000>Q57@00000204Y^e`0;0000003D?AT0000004Y^
e`000000BVkG0000001:K]L0000004Y^e`0000000P1:K]L00`000000BVkG0000000204Y^e`030000
003D?AT0000000<0BVkG00@0000004Y^e`1:K]L000000P1:K]L2000000050?mA8P0mFJ/000000000
003oE2<00`0000030?mD8`<0000000<0oeDS0000000000000`3oEB<200000080oe<R00D0000003eI
Z`00000000000?m=7`0703eIZ``0ooK^1P0mFJ/:0?ofkP030000003om^h0ooK^0080ooK^0P0mFJ/@
0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP09
0?ofkPL0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP030000003om^h0ooK^03d0ooK^0@3oool0
04`0ooK^0P00000C0?ofkPh0?EV[1`3om^h603eIZ`D0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`06
0?ofkPL0?EV[0`3om^h0100mFJ/0ooK^0=@m6@3D?AT30?ofkP0403eIZ`3D?AT0ooK^0?ofkPP0?EV[
00<0000006hQ401^8A000`1^8A02000000@0T2/C00<0?EV[090[4`0000000P2@:a<010000000[3<G
0:`c5`2/<aL2000000L0[3<G0P0000040<<j6@0403eIZ`33>QT00000000000<0`cXI00@000000=Lo
700000000000103G?a`2000000@0eclL1`0mFJ/2000000030>Q57@000000j4DM0080000000<0n4TO
0000000000001@0000001@1:K]L0000004Y^e`000000?EV[0080BVkG00P0000004Y^e`1:K]L00000
04Y^e`000000e3dI00000080BVkG0P000000101:K]L000000000001:K]L50000000303eIZ`000000
0000008000000P3oE2<300000080oe@S0P0000030?mE8`<0000000@0oe<R000000000000?EV[0P00
00020?m=7`80000000<0ooK^03eIZ`3om^h00P3om^h803eIZ`<0ooK^00D0?EV[0?ofkP3om^h0ooK^
03eIZ`020?ofkPH0?EV[103om^h00`000000ooK^0?ofkP020?ofkP80?EV[403om^h00`0mFJ/0ooK^
0?ofkP030?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h0403om^h403eIZaD0ooK^
00<000000?ofkP3om^h0?P3om^h10?ooo`00C03om^h00`000000ooK^0?ofkP0J0?ofkPd0?EV[1P3o
m^h603eIZ`80ooK^00<0?EV[0?ofkP3om^h0303om^h703eIZ`80ooK^00<0?EV[0=@m6@3D?AT0103o
m^h00`3D?AT0ooK^0=@m6@030?ofkPP0?EV[0`2@:a<0100mFJ/0T2/C090[4`2@:a<3000000D0[3<G
0P0000040:`c5`0300000033>QT0`cXI00<0000000<0`cXI03eIZ`33>QT00P33>QT00`000000`cXI
000000040=Lo70800000103G?a`2000000070=Lo70000000j4DM0>Q57@000000?EV[0>Q57@020000
00H0?EV[0P0000000`3hBAl00000000000020000000304Y_fP000000000000@000000P1:K]L01000
0000BVkG0000001:K]L2000000050=@m6@1:K]L0BVkG0000001:K]L00P0000000`1:K]L000000000
0002000000030?mA8P000000?EV[00<0000000@0oe@S00000000000000000`3oE2<2000000<0oeDS
0P0000020?mE8`8000000P3oDb801P0mFJ/000000?m=7`3oCAl000000=i26@80ooK^00<0?EV[0?of
kP3om^h02@3om^h603eIZ`030?ofkP0mFJ/0ooK^00L0ooK^1P0mFJ/30?ofkP0303eIZ`3om^h0ooK^
00l0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP0303eIZ`3om^h0ooK^
01<0ooK^00<0?EV[0?ofkP3om^h04P3om^h00`000000ooK^0?ofkP0o0?ofkP40oooo001;0?ofkP80
00008`3om^h>03eIZ`<0ooK^1`0mFJ/>0?ofkP0403eIZ`3om^h0e3dI0=@m6@L0?EV[0P3om^h00`3D
?AT0ooK^0=@m6@050?ofkP0603eIZ`1^8A00KR4@06hQ40000000T2/C1P0mFJ/3090[4`030000002/
<aL0[3<G00D0[3<G0P0000020:`c5`0300000033>QT0`cXI00<0`cXI00<0?EV[00000033>QT01033
>QT2000000D0eclL0`0000030=Lo70<0000000<0j4DM03eIZ`3XAAd00P0000001@3XAAd000000000
003XAAd000000080j4DM0`000000103hBAl000000000001:KmX20000000304Y_fP000000BVoJ00T0
000000L0BVkG0=@m6@000000000004Y^e`000000BVkG00@0000000L0oe4R000000000000000003eI
Z`000000oe@S008000000`3oE2<400000080oeDS0P0000020?mE8`8000000`3oDb80100mFJ/00000
0?m=7`3oCAl3000000<0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP0503eIZ`T0
ooK^00<000000?ofkP0mFJ/01`0mFJ/=0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3o
m^h04`3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^0180ooK^00<000000?ofkP3o
m^h0@03om^h10?ooo`00B`3om^h2000002X0ooK^3P0mFJ/30?ofkPP0?EV[1P3om^h0100mFJ/0e3dI
0=@m6@3D?AT20?ofkP0303eIZ`3D?AT0ooK^0080ooK^1`0mFJ/30?ofkP0503eIZ`000000KR4@06hQ
400000000`2@:a<0100mFJ/0T2/C090[4`2@:a<603eIZ`L0[3<G0`0000050<<j6@0303eIZ`33>QT0
00000080000000@0`cXI0000003G?a`0eclL0`0000050=Lo7080000000L0eclL0000003XAAd0j4DM
0000000mFJ/000000080j4DM0P0000001P3XAAd000000000003XAAd000000?Q97`<0000000D0n4TO
000000000000000004Y_fP040000000504Y_fP000000BVoJ0000001:KmX00P0000000`1:KmX00000
00000006000000030?mA8P00000000000080000000<0oe4R03eIZ`0000000P0000020?mD8`<00000
0`3oE2<300000080oeDS0`0000030?mC8P030000000mFJ/0000000@00000103om^h00`0mFJ/0ooK^
0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^0080ooK^00@0?EV[0?ofkP3om^h0ooK^1P0mFJ/30?ofkP03
0000003om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h00P3om^h903eIZ`@0ooK^00<0?EV[0?ofkP3o
m^h00P3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3o
m^h04@3om^h00`000000ooK^0?ofkP110?ofkP40oooo001;0?ofkP800000<P3om^h=03eIZ`@0ooK^
200mFJ/20=@m6@040?ofkP0mFJ/0ooK^0=@m6@H0ooK^00@0e3dI0?ofkP3om^h0ooK^1@0mFJ/00`3D
?AT00000090[4`03090[4`0303eIZ`000000000000<0T2/C00@000000:`c5`2/<aL0[3<G1P0mFJ/2
0:`c5`0300000033>QT00000008000000P33>QT00`0mFJ/0`cXI0<<j6@020<<j6@<00000103G?a`3
000000@0eclL0`000000103XAAd0?EV[0>Q57@3XAAd200000080e3dI0P0000000`3XAAd000000000
0002000000030?Q97`000000000000P0000000<0BVoJ0000000000000P00000204Y_fP`0000000H0
oe4R000000000000?EV[0000003oE2<3000000@0oe@S0`000000103oEB<000000000000000020?mE
8`050000003oDb8000000000000mFJ/00P0000000`3oCAl000000=i26@050?ofkP0303eIZ`3om^h0
ooK^00X0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP070?ofkPD0?EV[0P3om^h2
03eIZ`d0ooK^1@0mFJ/30?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h0503om^h0
0`0mFJ/0ooK^0?ofkP0A0?ofkP030000003om^h0ooK^0440ooK^0@3oool004/0ooK^0P00000i0?of
kPh0?EV[0`3om^h803eIZ`D0ooK^00<0e3dI0?ofkP3om^h0103om^h0100mFJ/0ooK^03eIZ`000003
090[4`80?EV[0P2@:a<3000000H0[3<G0P0000020:`c5`H0?EV[00@0`cXI0000000mFJ/000001@33
>QT00`000000eclL00000003000000<0eclL0`0000001P3G?a`000000>Q57@3XAAd0000003eIZ`80
00000`3XAAd2000000050=@m6@00000000000000003hBAl02`0000000`1:KmX00000000000020000
000304Y_fP000000000000d0000000<0oe4R03eIZ`0000000P0000030?mD8`D0000000<0oeDS0000
00000000103oEB<00`000000oe<R000000020?mC8P0303eIZ`000000oddO00<000001@3om^h00`0m
FJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`00
0000?EV[03eIZ`0403eIZ`l0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0E0?ofkP0303eIZ`3om^h0
ooK^01<0ooK^00<0?EV[0?ofkP3om^h04@3om^h00`000000ooK^0?ofkP120?ofkP40oooo001;0?of
kP800000@@3om^h=03eIZ`040?ofkP3D?AT0ooK^0=@m6@L0?EV[1P3om^h00`0mFJ/0ooK^0=@m6@02
00000003090[4`0mFJ/0T2/C00@0T2/C0P0000070:`c5`80000000<0[3<G00000033>QT00`33>QT6
03eIZ`0300000033>QT0000000H0eclL100000020=Lo70@0000000@0?EV[0>Q57@3XAAd0j4DM1000
00020>Q57Ad0000000<0oe4R03eIZ`0mFJ/0200mFJ/0103oE2<000000000000000030?mD8`<00000
1@3oEB<2000000<0oe<R00<0000003eIZ`3oCAl00`00000203eIZ`@0ooK^00<0?EV[0?ofkP3om^h0
2@3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00X0ooK^00L000000?ofkP3om^h0
?EV[0?ofkP0mFJ/0ooK^00L0?EV[203om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[01D0ooK^00<0?EV[
0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP030000003om^h0ooK^04<0ooK^0@3oool0
04/0ooK^00<000000?ofkP3om^h0B03om^h<03eIZ`040?ofkP3D?AT0ooK^0=@m6@P0?EV[00D0e3dI
0?ofkP3om^h0?EV[00000005090[4`030000002/<aL00000008000001P2/<aL3000000@0`cXI00<0
?EV[0<<j6@33>QT00P33>QT703eIZ`H0eclL1P0000000`0mFJ/0000000000004000000030>Q57@00
00000000024000000`3oDB8010000000?EV[00000000000603eIZ`800000103oEB<400000080oe<R
0P000000100mFJ/000000000003oCAl200000080ooK^200mFJ/70?ofkP0303eIZ`3om^h0ooK^00D0
ooK^00<0?EV[0?ofkP3om^h02P3om^h00`000000ooK^03eIZ`020?ofkP0303eIZ`3om^h0ooK^00H0
ooK^2@0mFJ/20?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0
ooK^0?ofkP0@0?ofkP030000003om^h0ooK^04@0ooK^0@3oool004X0ooK^0P00001;0?ofkP060=@m
6@3om^h0e3dI0?ofkP3D?AT0ooK^3@0mFJ/30?ofkPP0?EV[0P2@:a<00`000000[3<G0:`c5`030:`c
5`8000001@2/<aL00`000000`cXI000000020000000303eIZ`33>QT0`cXI00D0`cXI00<000000=Lo
703G?a`00P00000803eIZ`<0j4DM00<0?EV[0000000000000`0000020>Q57B00000000<0oe4R0000
0000000010000000100mFJ/000000?mD8`3oE2<3000000<0oe@S1@0mFJ/010000000oeDS0?mE8`3o
EB<300000080oe<R00<0?EV[0?m=7`3oCAl00P0000070?ofkP0403eIZ`3om^h0ooK^0?ofkPH0?EV[
00<0ooK^03eIZ`3om^h01P3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP030000003om^h0?EV[0080ooK^
00<0?EV[0?ofkP3om^h03P3om^h703eIZa80ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^
0?ofkP0?0?ofkP030000003om^h0ooK^04D0ooK^0@3oool004X0ooK^0P00001:0?ofkP80e3dI00@0
ooK^0=@m6@3om^h0e3dI0P3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@0mFJ/0?EV[00d0?EV[
0P3om^h703eIZ`<0[3<G0`0000000`2/<aL000000<<j6@040<<j6@0303eIZ`000000000000800000
0P33>QT00`000000eclL0=Lo70070=Lo70@000001`0mFJ/30>Q57B8000000P3oDB840000000303eI
Z`000000000000D0oe@S100000030?mE8`H0?EV[0P3oDb801@0mFJ/0oddO0?m=7`3oCAl0000000P0
ooK^00<0?EV[0?ofkP3om^h01`3om^h603eIZ`<0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`000000
?EV[0?ofkP020?ofkP0303eIZ`3om^h0ooK^00l0ooK^0P0mFJ/40?ofkPL0?EV[2`3om^h00`0mFJ/0
ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<000000?ofkP3om^h0AP3om^h10?ooo`00
BP3om^h2000004X0ooK^00<0e3dI0?ofkP3om^h00P3D?AT40?ofkP040=@m6@3om^h0ooK^0=@m6@<0
ooK^00<0e3dI0?ofkP3om^h00`3om^h>03eIZ`80[3<G200mFJ/200000080`cXI00<0?EV[0<<j6@33
>QT00`33>QT9000000H0eclL00@000000>Q57@3XAAd0?EV[0`3XAAd00`000000?EV[03eIZ`0403eI
Zb4000000`3oDB80100mFJ/000000?mD8`3oE2<500000080oe@S00@000000?mE8`3oEB<0oeDS1000
00030?mC8PH0?EV[00<000000?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3o
m^h0ooK^00<0ooK^1`0mFJ/90?ofkP030000000mFJ/0ooK^0080ooK^00<0?EV[0?ofkP3om^h03`3o
m^h203eIZ`/0ooK^1`0mFJ/30?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h03`3o
m^h00`000000ooK^0?ofkP160?ofkP40oooo001:0?ofkP800000BP3om^h00`3D?AT0ooK^0?ofkP02
0=@m6@@0ooK^00@0e3dI0?ofkP3om^h0e3dI103om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3o
m^h0ooK^00<0ooK^00<0e3dI03eIZ`0mFJ/01P0mFJ/00`3D?AT0[3<G0:`c5`040:`c5`0300000033
>QT0?EV[00D0?EV[0P0000030<<j6@030000003G?a`0eclL00D0eclL200000000`0mFJ/000000000
000]0000000403eIZ`0000000000000000H0oe@S00<000000?mE8`0000000P0000030?mE8`0:0000
003oDb8000000000003oDb80?EV[0?m=7`000000e3dI000000L0?EV[0`3om^h00`0mFJ/0ooK^0?of
kP060?ofkP0303eIZ`3om^h0ooK^00H0ooK^00@0?EV[0?ofkP3om^h0ooK^1P0mFJ/30?ofkP0303eI
Z`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0A0?ofkPL0?EV[
4P3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP030000003om^h0ooK^04L0ooK^0@3oool004X0ooK^0P00
001:0?ofkP040=@m6@3om^h0ooK^0=@m6@D0ooK^00<0e3dI0?ofkP3D?AT01@3om^h00`3D?AT0ooK^
0?ofkP020?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h0103om^h703eIZ`040:`c
5`000000`cXI0<<j6@80?EV[0`33>QT603eIZ`H000001P3G?a`00`000000j4DM03eIZ`050>Q57@l0
000000<0B6kH000000000000300000000`3oCR400000000000050?mA8P@0000000<0?EV[00000000
00002P0000050?mE8`030000003oDb8000000080oe<R00@0000003eIZ`000000oddO0P0000070?of
kPP0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00L0ooK^1P0mFJ/30?of
kP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP020?of
kPL0?EV[2`3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP030000003om^h0ooK^04P0ooK^0@3oool004X0
ooK^00<000000?ofkP3om^h0B@3om^h0103D?AT0ooK^0?ofkP3D?AT50?ofkP030=@m6@3om^h0e3dI
00H0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@060?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI
0?ofkP3om^h00`3om^h00`000000?EV[03eIZ`0403eIZ`L0`cXI00<000000=Lo700mFJ/01@0mFJ/>
000000H0j4DM1`0000000`18K]P00000000000020000000304Q^f000000000000080000000<0B6kH
0000000000001P0000030?mA8PD000000P3oDB800`0mFJ/0oe@S0?mD8`070?mD8`040000003oEB<0
oeDS0?mE8`D000000`3oDb8010000000?EV[0?m=7`3oCAl2000000/0ooK^00<0?EV[0?ofkP3om^h0
0P3om^h703eIZ`L0ooK^00<0?EV[0?ofkP3om^h0203om^h0100mFJ/000000?ofkP3om^h603eIZ`d0
ooK^0P0mFJ/E0?ofkP0303eIZ`3om^h0ooK^00T0ooK^1`0mFJ/30?ofkP0303eIZ`3om^h0ooK^00d0
ooK^00<000000?ofkP3om^h0B@3om^h10?ooo`00BP3om^h00`000000ooK^0?ofkP190?ofkP040=@m
6@3om^h0ooK^0=@m6@H0ooK^0P3D?AT60?ofkP040=@m6@3om^h0ooK^0=@m6@P0ooK^00<0e3dI0?of
kP3om^h00P3om^h00`3D?AT0ooK^0?ofkP080?ofkP030000003D?AT0e3dI0080?EV[00<0e3dI0<<j
6@33>QT00P33>QT00`000000eclL0=Lo70050=Lo70@0?EV[00<0eclL0000003XAAd00P3XAAd?0000
00030=@m6@13J<h0000000L0000000<0B6kH00000018K]P02@00000503eIZ`<0oe4R00<0000003eI
Z`0000003@0000030?mE8`030000003oDb80oe<R0080000000<0?EV[0?m=7`3oCAl00P00000<0?of
kP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h00P3om^h803eIZ`X0ooK^00<0?EV[0000
003om^h0103om^h00`0mFJ/0ooK^0?ofkP0603eIZ`L0ooK^00<0?EV[0?ofkP0mFJ/04`3om^h00`0m
FJ/0ooK^0?ofkP0A0?ofkP@0?EV[3P3om^h00`000000ooK^0?ofkP1:0?ofkP40oooo00190?ofkP80
0000B`3om^h01@3D?AT0ooK^0=@m6@3om^h0e3dI00D0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D
?AT0ooK^0=@m6@090?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT03@3om^h00`3D?AT0ooK^0=@m6@0G
000000@0e3dI1P00000204=XcP030=@m6@00000000000080000000D0@fS>00000013J<h0000004=X
cP070000000304Q^f0000000B6kH008000000P3oDB82000000030?mA8P000000?EV[00L0?EV[1P3o
E2<00`000000oeDS0?mE8`050?mE8`<000000P3oDb80100mFJ/0e3dI00000000000403eIZ`X0ooK^
00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkPL0?EV[0`3om^h00`0mFJ/0ooK^
000000050?ofkP0303eIZ`3om^h0ooK^00H0ooK^1`0mFJ/20?ofkP0303eIZ`3om^h0ooK^0140ooK^
00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP030000003om^h0ooK^04/0ooK^
0@3oool004T0ooK^0P00001;0?ofkP050=@m6@3om^h0e3dI0?ofkP3D?AT01@3om^h00`3D?AT0ooK^
0?ofkP060?ofkP80e3dI2`3om^h0103D?AT0ooK^0?ofkP3D?AT>0?ofkP80e3dI1P3om^h900000003
03MI/@3D?AT0=eVa00@0=eVa1@0000020=@m6@@0@fS>00<000000=@m6@0000000P0000001@13J<h0
000000000013J<h000000080@fS>00L0000004=XcP000000@fS>00000013J<h0e3dI00L000000P3o
DB82000000<0oe4R00<0?EV[0000000000000P00000703eIZ`<0oeDS1@0000030?mC8P0303eIZ`3D
?AT0oddO00800000103om^h703eIZ`<0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?of
kP0:0?ofkP0303eIZ`3om^h0ooK^00@0ooK^1`0mFJ/50?ofkP0303eIZ`3om^h0ooK^00/0ooK^100m
FJ/B0?ofkP0303eIZ`3om^h0ooK^01@0ooK^00<0?EV[0?ofkP3om^h0303om^h00`000000ooK^0?of
kP1;0?ofkP40oooo00190?ofkP800000B`3om^h01@3D?AT0ooK^0=@m6@3om^h0e3dI00D0ooK^0P3D
?AT80?ofkP030=@m6@3om^h0ooK^00X0ooK^0P3D?AT@0?ofkP030=@m6@3om^h0ooK^00`0ooK^0P00
00000`3D?AT0000000000004000000H0=eVa0`3D?AT2000000050=@m6@000000@fS>04=XcP000000
0`13J<h00`000000@fS>0000000204=XcP0500000013J<h0@fS>0=@m6@13J<h00P0000000`13J<h0
00000000000400000080oe4R0P0000000`0mFJ/000000?mD8`040?mD8`H000001`0mFJ/30?mC8P05
0000000mFJ/0oddO0?m=7`000000303om^h803eIZ`d0ooK^00<0?EV[0?ofkP3om^h01P3om^h01@0m
FJ/0ooK^0?ofkP3om^h0000000L0?EV[2`3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[0180ooK^00<0
?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP030000003om^h0ooK^04`0ooK^0@3o
ool004T0ooK^0P00001;0?ofkP80e3dI0`3om^h01`3D?AT0ooK^0?ofkP3om^h0e3dI0?ofkP3D?AT0
203om^h20=@m6@`0ooK^00<0e3dI0?ofkP3om^h03P3om^h30=@m6@h0ooK^00@0e3dI0?ofkP3om^h0
ooK^300000050=@m6@T0000000D0@fS>00000013J<h0@fS>0=@m6@0204=XcP<0000000D0@fS>0000
0013J<h000000?mA8P02000000030?mA8P0mFJ/0000000D00000103oE2<00`000000oeDS0?mE8`05
0?mE8`8000001`0mFJ/@0?ofkP0303eIZ`3om^h0ooK^00L0?EV[2@3om^h00`0mFJ/0ooK^0?ofkP04
0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<000000?ofkP3om^h00`3om^h00`0mFJ/0ooK^03eIZ`06
03eIZ`@0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0
ooK^01@0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`000000ooK^0?ofkP1=0?ofkP40oooo00190?of
kP030000003om^h0ooK^04X0ooK^0P3D?AT30?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT00P3om^h0
0`3D?AT0ooK^0?ofkP040?ofkP040=@m6@3om^h0ooK^0=@m6@/0ooK^0P3D?AT>0?ofkP040=@m6@3o
m^h0ooK^0?ofkP80e3dI2`3om^h00`3D?AT0ooK^0?ofkP080?ofkPL0000000@0e3dI000000000000
=eVa203D?AT01@0gFK400000000000000000e3dI00@000000P13J<h010000000@fS>00000013J<h2
000000040?mA8P0000000000000000D0oe@S3@0000030?mC8P0403eIZ`3oCAl00000000000P0?EV[
2P3om^h203eIZ`L0ooK^1P0mFJ/30?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h0
0P3om^h00`000000ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00H0ooK^1`0mFJ/20?ofkP0303eI
Z`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP030000
003om^h0ooK^04h0ooK^0@3oool004T0ooK^00<000000?ofkP3om^h0BP3om^h20=@m6@<0ooK^00D0
e3dI0?ofkP3om^h0ooK^0=@m6@020?ofkP030=@m6@3om^h0ooK^00@0ooK^00@0e3dI0?ofkP3om^h0
e3dI2P3om^h0103D?AT0ooK^0?ofkP3D?AT=0?ofkP030=@m6@3om^h0ooK^00<0ooK^0P3D?AT90?of
kP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0000000000002P0000080=@m6@8000001@3D?AT01@00
0000@fS>000000000000oe4R008000001`3oE2<00`000000oeDS0?mE8`040?mE8`030000003oDb80
oe<R0080oe<R00H0?EV[000000000000oddO0000000mFJ/70?ofkPL0?EV[0`3om^h203eIZ`d0ooK^
200mFJ/00`3om^h0?EV[0?ofkP040?ofkP030000003om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h0
1`3om^h00`0mFJ/0ooK^0?ofkP020?ofkPL0?EV[2`3om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP0303eI
Z`3om^h0ooK^00X0ooK^00<000000?ofkP3om^h0C`3om^h10?ooo`00B03om^h2000004`0ooK^0P3D
?AT30?ofkP040=@m6@3om^h0ooK^0=@m6@@0ooK^00<0e3dI0?ofkP3om^h00`3om^h01@3D?AT0ooK^
0?ofkP3om^h0e3dI00T0ooK^00@0e3dI0?ofkP3om^h0ooK^0P3D?AT:0?ofkP030=@m6@3om^h0ooK^
00H0ooK^0P3D?AT60?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h02P3om^h40000
00060=@m6@0gFK40=eVa0000000mFJ/0=eVa0P0000000`0gFK40000000000005000000030?mD8`0m
FJ/0?EV[00<0?EV[0`3oE2<00`000000oeDS0?mE8`040?mE8`070000003oDb80oe<R0000000mFJ/0
00000?m=7`0303eIZ`030?ofkP0mFJ/0ooK^00`0ooK^1`0mFJ/?0?ofkP0403eIZ`3om^h0ooK^0?of
kPX0?EV[103om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00H0ooK^00@0?EV[0?of
kP3om^h0ooK^1`0mFJ/40?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h02P3om^h0
0`000000ooK^0?ofkP1@0?ofkP40oooo00180?ofkP800000C03om^h00`3D?AT0ooK^0?ofkP030?of
kP030=@m6@3om^h0e3dI00@0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP020?of
kP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP070?of
kP030=@m6@3om^h0ooK^00P0ooK^0P3D?AT40?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?of
kP3om^h03P3om^h00`3D?AT0ooK^0000000<000000030=@m6@0gFK40=eVa008000000`3oE2<803eI
Z`D0000000<0?EV[0000003oCAl00P3oCAl00`000000ooK^03eIZ`0503eIZ`/0ooK^00<0?EV[0?of
kP0mFJ/00P3om^h703eIZ`P0ooK^00@0?EV[0?ofkP3om^h0?EV[1`3om^h00`000000ooK^0?ofkP08
03eIZ`D0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP080?ofkPL0?EV[4`3om^h0
0`0mFJ/0ooK^0?ofkP0:0?ofkP030000003om^h0ooK^0500ooK^0@3oool004P0ooK^0P00001<0?of
kP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3D?AT01@3om^h01@3D?AT0ooK^0?ofkP3om^h0
e3dI00H0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0
ooK^00D0ooK^00<0e3dI0?ofkP3om^h02`3om^h20=@m6@030?ofkP3D?AT0ooK^0100ooK^00<0e3dI
0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP060?ofkPH0000000<0e3dI0000000000000P0gFK43
000000030?mD8`000000oeDS00D0oeDS200mFJ/00`3D?AT000000?ofkP030?ofkP0403eIZ`3om^h0
ooK^0?ofkP/0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP060?ofkPL0?EV[0P3om^h00`0mFJ/0ooK^03eI
Z`070?ofkP030000003om^h0ooK^00@0ooK^00@0?EV[0?ofkP3om^h0ooK^1P0mFJ/80?ofkP0303eI
Z`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h00P3om^h703eIZ`/0ooK^00<0?EV[0?ofkP3om^h0
2P3om^h00`000000ooK^0?ofkP1A0?ofkP40oooo00180?ofkP800000C03om^h00`3D?AT0ooK^0?of
kP030?ofkP030=@m6@3om^h0e3dI00H0ooK^00@0e3dI0?ofkP3om^h0e3dI1`3om^h00`3D?AT0ooK^
0?ofkP030?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^
0?ofkP0=0?ofkP<0e3dI3`3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00`0ooK^
00<0e3dI0000000000002@0000000`3oEB<0?EV[03eIZ`020?mE8`030000003oDb80?EV[0080?EV[
0P0000000`3D?AT0?EV[03eIZ`0503eIZ``0ooK^2@0mFJ/<0?ofkPL0?EV[1@3om^h00`000000ooK^
0?ofkP050?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h01P0mFJ/30?ofkP0303eI
Z`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h02P3om^h703eIZ`@0ooK^00<0?EV[0?ofkP3om^h0
2@3om^h00`000000ooK^0?ofkP1B0?ofkP40oooo00180?ofkP030000003om^h0ooK^04/0ooK^00<0
e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP050?ofkP040=@m6@3om^h0ooK^0=@m6@P0ooK^
00D0e3dI0?ofkP3om^h0ooK^0=@m6@0:0?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3o
m^h03`3om^h00`3D?AT0ooK^0=@m6@020=@m6@`0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0
ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00@0ooK^10000000103D?AT000000=@m6@3D?AT<03eI
Z`D0ooK^1`0mFJ/40?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h01P0mFJ/80?of
kP80?EV[0`3om^h703eIZ`H0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP070?of
kP@0?EV[2P3om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP@0?EV[2`3om^h00`000000ooK^0?ofkP1C0?of
kP40oooo00180?ofkP030000003om^h0ooK^04`0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0
ooK^0?ofkP060?ofkP030=@m6@3om^h0e3dI00P0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0;0?of
kP80e3dI0P3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00<0ooK^0`3D?AT80?of
kP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP080?of
kP<0e3dI1P0000000`3D?AT0ooK^03eIZ`0?03eIZ`80ooK^1`0mFJ/50?ofkP0303eIZ`3om^h0ooK^
00D0ooK^200mFJ/00`3om^h0?EV[0?ofkP070?ofkP030000003om^h0?EV[00L0?EV[0`3om^h00`0m
FJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h0503om^h00`0m
FJ/0ooK^0?ofkP090?ofkP030000003om^h0ooK^05@0ooK^0@3oool004P0ooK^00<000000?ofkP3o
m^h0C03om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00H0ooK^0P3D?AT:0?ofkP04
0=@m6@3om^h0ooK^0=@m6@d0ooK^0P3D?ATA0?ofkP030=@m6@3om^h0ooK^00H0ooK^0`3D?AT50?of
kP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP080?of
kP80e3dI0`3om^h20=@m6@80ooK^1`3D?AT20?ofkPT0?EV[00<0ooK^03eIZ`0mFJ/0100mFJ/30?of
kPL0?EV[303om^h803eIZ`D0ooK^00<000000?ofkP3om^h01@3om^h703eIZ`/0ooK^00<0?EV[0?of
kP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<000000?of
kP3om^h0E@3om^h10?ooo`00A`3om^h2000004h0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0
ooK^0=@m6@080?ofkP030=@m6@3om^h0ooK^00T0ooK^0P3D?AT?0?ofkP030=@m6@3om^h0ooK^00h0
ooK^00<0e3dI0?ofkP3om^h02P3om^h30=@m6@030?ofkP3D?AT0ooK^00l0ooK^00<0e3dI0?ofkP3o
m^h0303om^h00`3D?AT0ooK^0?ofkP040?ofkPD0e3dI103om^h20=@m6@80ooK^0`3D?AT00`3om^h0
e3dI0=@m6@0:0?ofkPL0?EV[0P3om^h703eIZ`80ooK^200mFJ/40?ofkP0303eIZ`3om^h0ooK^00<0
ooK^00<0?EV[0?ofkP3om^h01P0mFJ/80?ofkP80?EV[103om^h703eIZ`@0ooK^00<0?EV[0?ofkP3o
m^h0103om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<000000?ofkP3o
m^h0E@3om^h10?ooo`00A`3om^h2000004h0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^
0=@m6@080?ofkP80e3dI2`3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP<0e3dI3P3om^h00`3D?AT0ooK^
0?ofkP0=0?ofkPD0e3dI303om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^0080ooK^
0`3D?AT40?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h00`3D?AT00`3om^h0e3dI
0=@m6@0B0?ofkPL0?EV[0P3om^h703eIZ`<0ooK^1`0mFJ/40?ofkP0303eIZ`3om^h0ooK^00@0ooK^
00<0000003eIZ`0mFJ/0100mFJ/20?ofkP0303eIZ`3om^h0ooK^00X0ooK^1`0mFJ/40?ofkP0303eI
Z`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`000000ooK^0?ofkP1F0?ofkP40oooo
00170?ofkP800000C`3om^h0103D?AT0ooK^0?ofkP3D?AT30?ofkP030=@m6@3om^h0ooK^00@0ooK^
00@0e3dI0?ofkP3om^h0e3dI2P3om^h20=@m6@d0ooK^00@0e3dI0?ofkP3om^h0ooK^0P3D?AT;0?of
kP030=@m6@3om^h0ooK^00l0ooK^00@0e3dI0?ofkP3om^h0ooK^203D?AT40?ofkP030=@m6@3om^h0
ooK^00`0ooK^1@3D?AT60?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h00`3D?AT0
0`3om^h0e3dI0=@m6@0I0?ofkPl0?EV[103om^h603eIZ`D0ooK^00<000000?ofkP3om^h0103om^h7
03eIZ`d0ooK^00<0?EV[0?ofkP0mFJ/01P0mFJ/C0?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<00000
0?ofkP3om^h0E`3om^h10?ooo`00A`3om^h00`000000ooK^0?ofkP1>0?ofkP040=@m6@3om^h0ooK^
0=@m6@<0ooK^00<0e3dI0?ofkP3om^h0103om^h0103D?AT0ooK^0?ofkP3D?AT90?ofkP030=@m6@3o
m^h0ooK^0080e3dI2`3om^h00`3D?AT0ooK^0?ofkP030?ofkP80e3dI2@3om^h00`3D?AT0ooK^0?of
kP0>0?ofkP030=@m6@3om^h0ooK^00X0ooK^503D?AT:0?ofkP030=@m6@3om^h0ooK^00<0ooK^00H0
e3dI0?ofkP3D?AT0ooK^0=@m6@3om^h20=@m6B40ooK^1`0mFJ/00`3om^h0?EV[03eIZ`0503eIZ`80
ooK^200mFJ/40?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h01P0mFJ/80?ofkP04
03eIZ`3om^h0ooK^03eIZ`@0ooK^1P0mFJ/<0?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<000000?of
kP3om^h0F03om^h10?ooo`00A`3om^h00`000000ooK^0?ofkP1>0?ofkP040=@m6@3om^h0ooK^0=@m
6@@0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^
00H0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^
00H0ooK^0P3D?AT60?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D
?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h0103om^h20=@m
6@040?ofkP3D?AT0e3dI0?ofkP80e3dI:03om^h603eIZ`80ooK^1`0mFJ/00`3om^h000000?ofkP07
03eIZ`<0ooK^00<0?EV[0?ofkP3om^h01@3om^h603eIZ`80ooK^00<0?EV[0?ofkP0mFJ/02`3om^h7
03eIZ`@0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`000000ooK^0?ofkP1I0?ofkP40oooo00170?of
kP030000003om^h0ooK^04h0ooK^00<0e3dI0?ofkP3D?AT01@3om^h00`3D?AT0ooK^0?ofkP020?of
kP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP040?of
kP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h0203om^h20=@m6@@0ooK^00<0e3dI0?of
kP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?of
kP3om^h0203om^h00`3D?AT0ooK^0?ofkP030?ofkP@0e3dI00<0ooK^0=@m6@3om^h00P3D?AT_0?of
kPl0?EV[103om^h703eIZ`X0ooK^100mFJ/C0?ofkP@0?EV[2`3om^h00`000000ooK^0?ofkP1J0?of
kP40oooo00160?ofkP800000D@3om^h20=@m6@H0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@060?of
kP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h01@3om^h20=@m6@H0ooK^00<0e3dI0?of
kP3om^h02P3om^h20=@m6@030?ofkP3D?AT0ooK^0100ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D
?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00T0ooK^00@0e3dI0?ofkP3om^h0ooK^0P3D?AT2
0?ofkP030=@m6@3om^h0e3dI00<0e3dI=`3om^h?03eIZ`80ooK^00<0?EV[0?ofkP0mFJ/01P0mFJ/4
0?ofkP0403eIZ`3om^h0ooK^03eIZa@0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`000000ooK^0?of
kP1J0?ofkP40oooo00160?ofkP800000D@3om^h00`3D?AT0ooK^0?ofkP050?ofkP040=@m6@3om^h0
ooK^0=@m6@P0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3o
m^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h03@3om^h30=@m6@l0ooK^00<0e3dI0?ofkP3om^h03@3o
m^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h00P3D
?AT30?ofkP80e3dI00<0ooK^0=@m6@3D?AT00P3D?ATj0?ofkP030000003om^h0ooK^0080ooK^3`0m
FJ/30?ofkPL0?EV[00<0ooK^03eIZ`0mFJ/04@3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP030000003o
m^h0ooK^05/0ooK^0@3oool004H0ooK^0P00001A0?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI
0?ofkP3D?AT02@3om^h0103D?AT0ooK^0?ofkP3D?AT;0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT0
3`3om^h00`3D?AT0ooK^0?ofkP030=@m6@`0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^
0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00T0ooK^0`3D?AT50?ofkP030=@m6@3om^h0e3dI00<0e3dI
>`3om^h00`000000ooK^0?ofkP0<0?ofkQD0?EV[303om^h203eIZ``0ooK^00<000000?ofkP3om^h0
G03om^h10?ooo`00AP3om^h00`000000ooK^0?ofkP1A0?ofkP030=@m6@3om^h0ooK^00D0ooK^0P3D
?AT:0?ofkP040=@m6@3om^h0ooK^0=@m6@`0ooK^0`3D?AT@0?ofkP030=@m6@3om^h0ooK^00<0ooK^
0`3D?AT80?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^
0?ofkP070?ofkP<0e3dI1P3om^h70=@m6C/0ooK^00<000000?ofkP3om^h05@3om^hC03eIZ`@0ooK^
00<0?EV[0?ofkP3om^h02`3om^h00`000000ooK^0?ofkP1M0?ofkP40oooo00160?ofkP030000003o
m^h0ooK^0540ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP090?ofkP80e3dI3`3o
m^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00L0ooK^0`3D?AT50?ofkP030=@m6@3o
m^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP050?ofkP<0e3dI00<0
ooK^0=@m6@3om^h01P3om^h30=@m6@030?ofkP3D?AT0e3dI03`0ooK^00<000000?ofkP3om^h06`3o
m^h803eIZ`D0ooK^100mFJ/=0?ofkP030000003om^h0ooK^05h0ooK^0@3oool004H0ooK^00<00000
0?ofkP3om^h0DP3om^h00`3D?AT0ooK^0?ofkP050?ofkP80e3dI2`3om^h00`3D?AT0ooK^0?ofkP0<
0?ofkP040=@m6@3om^h0e3dI0=@m6@d0ooK^00<0e3dI0?ofkP3om^h02P3om^h30=@m6@030?ofkP3D
?AT0ooK^00h0ooK^00<0e3dI0?ofkP3om^h0303om^h0103D?AT0ooK^0?ofkP3om^h40=@m6@<0ooK^
00<0e3dI0?ofkP3om^h01@3om^h40=@m6@030?ofkP3D?AT0e3dI03d0ooK^00<000000?ofkP3om^h0
803om^h703eIZa00ooK^00<000000?ofkP3om^h0G`3om^h10?ooo`00AP3om^h00`000000ooK^0?of
kP1C0?ofkP030=@m6@3om^h0ooK^00<0ooK^00@0e3dI0?ofkP3om^h0e3dI2P3om^h20=@m6@d0ooK^
00@0e3dI0?ofkP3om^h0ooK^0P3D?AT:0?ofkP030=@m6@3om^h0ooK^00h0ooK^1@3D?AT<0?ofkP03
0=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3D?AT00P3D?AT70?ofkP030=@m6@3om^h0ooK^00D0
ooK^00@0e3dI0?ofkP3D?AT0ooK^0P3D?ATn0?ofkP030000003om^h0ooK^03L0ooK^00<000000?of
kP3om^h0G`3om^h10?ooo`00A@3om^h2000005D0ooK^00<0e3dI0?ofkP3om^h00`3om^h0103D?AT0
ooK^0?ofkP3D?AT90?ofkP030=@m6@3om^h0ooK^0080e3dI2P3om^h00`3D?AT0ooK^0?ofkP040?of
kP80e3dI203om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^0080ooK^203D?AT30?of
kP030=@m6@3om^h0ooK^00D0ooK^2@3D?AT90?ofkP030=@m6@3om^h0ooK^00D0ooK^00D0e3dI0?of
kP3om^h0e3dI0?ofkP020=@m6Ch0ooK^00<000000?ofkP3om^h0=P3om^h00`000000ooK^0?ofkP1P
0?ofkP40oooo00150?ofkP800000EP3om^h00`3D?AT0ooK^0?ofkP020?ofkP050=@m6@3om^h0ooK^
0?ofkP3D?AT0203om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI
0?ofkP3om^h01P3om^h20=@m6@D0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP0:
0?ofkP/0e3dI1P3om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^00<0ooK^0P3D?AT3
0?ofkP<0e3dI?`3om^h00`000000ooK^0?ofkP0e0?ofkP030000003om^h0ooK^0640ooK^0@3oool0
04D0ooK^00<000000?ofkP3om^h0E@3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00D0ooK^00<0e3dI
0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI
0?ofkP3om^h02@3om^h20=@m6@<0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0=
0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP03
0?ofkP030=@m6@3om^h0e3dI0080ooK^00<0e3dI0?ofkP3D?AT0@03om^h00`000000ooK^0?ofkP0d
0?ofkP030000003om^h0ooK^0680ooK^0@3oool004D0ooK^00<000000?ofkP3om^h0EP3om^h0103D
?AT0ooK^0?ofkP3D?AT60?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h01@3om^h0
0`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00/0ooK^0`3D?ATA0?ofkP030=@m6@3om^h0
ooK^00d0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP090?ofkP040=@m6@3om^h0
ooK^0?ofkP80e3dI00<0ooK^0=@m6@3om^h00P3om^h30=@m6D00ooK^00<000000?ofkP3om^h0<`3o
m^h00`000000ooK^0?ofkP1S0?ofkP40oooo00150?ofkP030000003om^h0ooK^05L0ooK^00<0e3dI
0?ofkP3D?AT01`3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI
0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP80e3dI3`3om^h00`3D?AT0ooK^0?ofkP0=
0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP02
0=@m6@<0ooK^00<0e3dI0?ofkP3om^h00`3D?AU10?ofkP030000003om^h0ooK^0380ooK^00<00000
0?ofkP3om^h0I03om^h10?ooo`00A@3om^h00`000000ooK^0?ofkP1G0?ofkP80e3dI2@3om^h0103D
?AT0ooK^0?ofkP3D?AT:0?ofkP80e3dI0P3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0
e3dI0080e3dI303om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI
0?ofkP3om^h02@3om^h00`3D?AT0ooK^0=@m6@040?ofkP030=@m6@3om^h0ooK^00<0e3dI@P3om^h0
0`000000ooK^0?ofkP0b0?ofkP030000003om^h0ooK^06@0ooK^0@3oool004@0ooK^0P00001J0?of
kP030=@m6@3om^h0ooK^00L0ooK^00@0e3dI0?ofkP3om^h0e3dI303om^h20=@m6A00ooK^00<0e3dI
0?ofkP3om^h00`3om^h30=@m6@P0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0;
0?ofkP030=@m6@3om^h0ooK^00T0ooK^0`3D?AT40?ofkP050=@m6@3om^h0ooK^0=@m6@3om^h00P3D
?AU20?ofkP030000003om^h0ooK^0340ooK^00<000000?ofkP3om^h0I@3om^h10?ooo`00A03om^h2
000005/0ooK^00<0e3dI0?ofkP3om^h01`3om^h20=@m6@h0ooK^00<0e3dI0?ofkP3om^h03P3om^h0
0`3D?AT0ooK^0?ofkP060?ofkP<0e3dI1@3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0
ooK^00/0ooK^00<0e3dI0?ofkP3om^h01`3om^h30=@m6@H0ooK^00@0e3dI0?ofkP3D?AT0ooK^0P3D
?AU30?ofkP030000003om^h0ooK^0300ooK^00<000000?ofkP3om^h0IP3om^h10?ooo`00A03om^h0
0`000000ooK^0?ofkP1K0?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h0303om^h3
0=@m6@d0ooK^00<0e3dI0?ofkP3om^h02P3om^h30=@m6@030?ofkP3D?AT0ooK^00h0ooK^00<0e3dI
0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP040?ofkP@0e3dI00<0ooK^0=@m6@3om^h01@3om^h3
0=@m6@80ooK^00<0e3dI0?ofkP3om^h0@P3om^h00`000000ooK^0?ofkP0_0?ofkP030000003om^h0
ooK^06L0ooK^0@3oool004@0ooK^00<000000?ofkP3om^h0F`3om^h00`3D?AT0ooK^0?ofkP070?of
kP80e3dI303om^h0103D?AT0ooK^0?ofkP3om^h20=@m6@/0ooK^00<0e3dI0?ofkP3om^h03@3om^h5
0=@m6@`0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0=@m6@040=@m6@D0ooK^00<0e3dI
0?ofkP3om^h0103om^h0103D?AT0ooK^0?ofkP3om^h20=@m6D@0ooK^00<000000?ofkP3om^h0;P3o
m^h00`000000ooK^0?ofkP1X0?ofkP40oooo00140?ofkP030000003om^h0ooK^05`0ooK^00<0e3dI
0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP020=@m6@X0ooK^00<0e3dI0?ofkP3om^h00`3om^h2
0=@m6@T0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP020?ofkPP0e3dI0`3om^h0
0`3D?AT0ooK^0?ofkP050?ofkPT0e3dI2@3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0
ooK^0080ooK^00<0e3dI0?ofkP3om^h0A03om^h00`000000ooK^0?ofkP0/0?ofkP030000003om^h0
ooK^06T0ooK^0@3oool004@0ooK^00<000000?ofkP3om^h0G@3om^h00`3D?AT0ooK^0?ofkP040?of
kP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP060?of
kP80e3dI1P3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00X0ooK^2`3D?AT50?of
kP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h00`3om^h20=@m6@@0ooK^00<0e3dI0?of
kP3om^h0A@3om^h00`000000ooK^0?ofkP0/0?ofkP030000003om^h0ooK^06T0ooK^0@3oool004<0
ooK^0P00001P0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0
ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00P0ooK^0P3D?AT40?ofkP030=@m6@3om^h0ooK^00d0
ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00T0
ooK^00@0e3dI0?ofkP3om^h0ooK^0P3D?AT00`3om^h0e3dI0?ofkP020?ofkP80e3dIA`3om^h00`00
0000ooK^0?ofkP0[0?ofkP030000003om^h0ooK^06X0ooK^0@3oool004<0ooK^0P00001Q0?ofkP05
0=@m6@3om^h0ooK^0?ofkP3D?AT01`3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^
00X0ooK^0P3D?AT00`3om^h0e3dI0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?of
kP3om^h02P3om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^0080e3dI0P3om^h0103D
?AT0ooK^0?ofkP3om^h20=@m6DP0ooK^00<000000?ofkP3om^h0:P3om^h00`000000ooK^0?ofkP1[
0?ofkP40oooo00130?ofkP030000003om^h0ooK^0640ooK^00@0e3dI0?ofkP3om^h0e3dI203om^h0
0`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00d0ooK^0`3D?AT>0?ofkP030=@m6@3om^h0
ooK^00d0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP080?ofkP040=@m6@3om^h0
e3dI0=@m6@@0ooK^00<0e3dI0?ofkP3om^h00`3D?AU80?ofkP030000003om^h0ooK^02T0ooK^00<0
00000?ofkP3om^h0K03om^h10?ooo`00@`3om^h00`000000ooK^0?ofkP1Q0?ofkP040=@m6@3om^h0
ooK^0=@m6@T0ooK^0P3D?AT20?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h00`3D
?AT;0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?of
kP090?ofkP80e3dI1@3om^h01P3D?AT0ooK^0=@m6@3D?AT0ooK^0=@m6DT0ooK^00<000000?ofkP3o
m^h0:03om^h00`000000ooK^0?ofkP1]0?ofkP40oooo00130?ofkP030000003om^h0ooK^0680ooK^
0P3D?AT<0?ofkP80e3dI403om^h00`3D?AT0ooK^0?ofkP030?ofkP80e3dI203om^h00`3D?AT0ooK^
0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h01`3om^h20=@m6@L0ooK^
0P3D?AT20?ofkP030=@m6@3om^h0ooK^04P0ooK^00<000000?ofkP3om^h09`3om^h00`000000ooK^
0?ofkP1^0?ofkP40oooo00130?ofkP030000003om^h0ooK^06<0ooK^00<0e3dI0?ofkP3om^h02`3o
m^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00H0ooK^0`3D?AT50?ofkP030=@m6@3o
m^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP050?ofkP@0e3dI1`3o
m^h20=@m6@<0ooK^00<0e3dI0?ofkP3om^h0B03om^h00`000000ooK^0?ofkP0W0?ofkP030000003o
m^h0ooK^06h0ooK^0@3oool004<0ooK^00<000000?ofkP3om^h0I03om^h00`3D?AT0ooK^0?ofkP0:
0?ofkP<0e3dI3@3om^h00`3D?AT0ooK^0?ofkP090?ofkP<0e3dI00<0ooK^0=@m6@3om^h03P3om^h0
0`3D?AT0ooK^0?ofkP0;0?ofkP040=@m6@3om^h0ooK^0?ofkP@0e3dI0`3om^h00`3D?AT0ooK^0?of
kP050?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT0B`3om^h00`000000ooK^0?ofkP0V0?ofkP030000
003om^h0ooK^06l0ooK^0@3oool00480ooK^0P00001W0?ofkP80e3dI2@3om^h0103D?AT0ooK^0?of
kP3om^h20=@m6@X0ooK^00<0e3dI0?ofkP3om^h03@3om^h50=@m6@`0ooK^00<0e3dI0?ofkP3om^h0
2P3om^h00`3D?AT0ooK^0=@m6@020=@m6@H0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^
0?ofkP020?ofkP030=@m6@3om^h0ooK^04T0ooK^00<000000?ofkP3om^h09@3om^h00`000000ooK^
0?ofkP1`0?ofkP40oooo00120?ofkP030000003om^h0ooK^06P0ooK^00<0e3dI0?ofkP3om^h01P3o
m^h00`3D?AT0ooK^0?ofkP030?ofkP80e3dI203om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3o
m^h0ooK^0080ooK^203D?AT30?ofkP030=@m6@3om^h0ooK^00D0ooK^203D?AT90?ofkP030=@m6@3o
m^h0ooK^00<0ooK^0P3D?AT40?ofkP030=@m6@3om^h0ooK^04X0ooK^00<000000?ofkP3om^h0903o
m^h00`000000ooK^0?ofkP1a0?ofkP40oooo00120?ofkP030000003om^h0ooK^06T0ooK^00<0e3dI
0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP050?ofkP80e3dI1@3om^h00`3D?AT0ooK^0?ofkP0>
0?ofkP030=@m6@3om^h0ooK^00X0ooK^2`3D?AT50?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI
0?ofkP3om^h00`3om^h00`3D?AT0ooK^0=@m6@030?ofkP030=@m6@3om^h0ooK^04/0ooK^00<00000
0?ofkP3om^h08`3om^h00`000000ooK^0?ofkP1b0?ofkP40oooo00120?ofkP030000003om^h0ooK^
06X0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP080?ofkP80e3dI0`3om^h00`3D
?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D
?AT0ooK^0?ofkP080?ofkP040=@m6@3om^h0ooK^0?ofkP80e3dI00<0ooK^0=@m6@3om^h00P3om^h0
0`3D?AT0ooK^0?ofkP1=0?ofkP030000003om^h0ooK^0240ooK^00<000000?ofkP3om^h0L`3om^h1
0?ooo`00@P3om^h00`000000ooK^0?ofkP1[0?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?of
kP3om^h02P3om^h30=@m6A00ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0:0?of
kP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h00P3D?AT30?ofkP040=@m6@3om^h0ooK^
0=@m6E00ooK^00<000000?ofkP3om^h08@3om^h00`000000ooK^0?ofkP1c0?ofkP40oooo00120?of
kP030000003om^h0ooK^06`0ooK^0P3D?AT20?ofkP030=@m6@3om^h0ooK^00`0ooK^0P3D?AT>0?of
kP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP080?of
kP030=@m6@3om^h0e3dI00@0ooK^00@0e3dI0?ofkP3D?AT0e3dID@3om^h00`000000ooK^0?ofkP0P
0?ofkP030000003om^h0ooK^07@0ooK^0@3oool00440ooK^0P00001`0?ofkP80e3dI3`3om^h00`3D
?AT0ooK^0=@m6@030=@m6@X0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0:0?of
kP030=@m6@3om^h0ooK^00P0ooK^0`3D?AT50?ofkP80e3dID`3om^h00`000000ooK^0?ofkP0O0?of
kP030000003om^h0ooK^07D0ooK^0@3oool00440ooK^00<000000?ofkP3om^h0L03om^h00`3D?AT0
ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00@0ooK^0`3D?AT60?ofkP030=@m6@3om^h0ooK^00d0
ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP060?ofkP<0e3dI1P3om^h20=@m6E@0
ooK^00<000000?ofkP3om^h07P3om^h00`000000ooK^0?ofkP1f0?ofkP40oooo00110?ofkP030000
003om^h0ooK^0740ooK^0P3D?AT<0?ofkP030=@m6@3om^h0ooK^00L0ooK^103D?AT20?ofkP030=@m
6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP030?ofkP@0e3dI
00<0ooK^0=@m6@3om^h01P3om^h00`3D?AT0ooK^0?ofkP1C0?ofkP030000003om^h0ooK^01d0ooK^
00<000000?ofkP3om^h0M`3om^h10?ooo`00@@3om^h500000740ooK^0P3D?AT90?ofkP030=@m6@3o
m^h0ooK^00`0ooK^1@3D?AT<0?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3D?AT00`3D
?AT50?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h0E03om^h00`000000ooK^0?of
kP0L0?ofkP030000003om^h0ooK^07P0ooK^0@3oool004H0ooK^2000001[0?ofkP030=@m6@3om^h0
ooK^00H0ooK^00<0e3dI0?ofkP3om^h03@3om^h0103D?AT0ooK^0?ofkP3om^h80=@m6@@0ooK^00<0
e3dI0?ofkP3om^h0103om^h90=@m6@P0ooK^00<0e3dI0?ofkP3om^h00`3om^h20=@m6EL0ooK^00<0
00000?ofkP3om^h0703om^h00`000000ooK^0?ofkP1h0?ofkP40oooo001>0?ofkPP00000I03om^h2
0=@m6@D0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP/0e3dI1@3om^h0
0`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^0080ooK^0P3D?AUI0?ofkP030000003om^h0
ooK^01/0ooK^00<000000?ofkP3om^h0N@3om^h10?ooo`00EP3om^h9000005d0ooK^0P3D?AT30?of
kP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP0;0?of
kP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h00P3D?AUK0?ofkP030000003om^h0ooK^
01X0ooK^00<000000?ofkP3om^h0NP3om^h10?ooo`00G`3om^h8000005L0ooK^0`3D?AT?0?ofkP03
0=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP080?ofkP04
0=@m6@3om^h0e3dI0=@m6Ed0ooK^00<000000?ofkP3om^h06@3om^h00`000000ooK^0?ofkP1k0?of
kP40oooo001W0?ofkPP00000D@3om^h20=@m6@h0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0
ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00P0ooK^0P3D?AUP0?ofkP030000003om^h0ooK^01L0
ooK^00<000000?ofkP3om^h0O03om^h10?ooo`00K`3om^h9000004X0ooK^103D?AT90?ofkP030=@m
6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP070?ofkP80e3dI
HP3om^h00`000000ooK^0?ofkP0F0?ofkP030000003om^h0ooK^07d0ooK^0@3oool007P0ooK^2000
00160?ofkP<0e3dI1P3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0
e3dI0?ofkP3om^h0103om^h30=@m6F@0ooK^00<000000?ofkP3om^h05P3om^h00`000000ooK^0?of
kP1m0?ofkP40oooo00200?ofkPP00000@@3om^h40=@m6@030?ofkP3D?AT0ooK^00h0ooK^00<0e3dI
0?ofkP3om^h02P3om^h0103D?AT0ooK^0?ofkP3om^h40=@m6FL0ooK^00<000000?ofkP3om^h05@3o
m^h00`000000ooK^0?ofkP1n0?ofkP40oooo00280?ofkPT00000?03om^h50=@m6@/0ooK^00<0e3dI
0?ofkP3om^h02`3om^h40=@m6F/0ooK^00<000000?ofkP3om^h0503om^h00`000000ooK^0?ofkP1o
0?ofkP40oooo002A0?ofkPP00000>@3om^h70=@m6@@0ooK^00<0e3dI0?ofkP3om^h0103om^h80=@m
6Fh0ooK^00<000000?ofkP3om^h04`3om^h00`000000ooK^0?ofkP200?ofkP40oooo002I0?ofkPP0
0000>03om^h;0=@m6GH0ooK^00<000000?ofkP3om^h04P3om^h00`000000ooK^0?ofkP210?ofkP40
oooo002Q0?ofkPT00000/03om^h00`000000ooK^0?ofkP0A0?ofkP030000003om^h0ooK^0880ooK^
0@3oool00:X0ooK^2000002X0?ofkP030000003om^h0ooK^0140ooK^00<000000?ofkP3om^h0PP3o
m^h10?ooo`00/P3om^h800000:00ooK^00<000000?ofkP3om^h0403om^h00`000000ooK^0?ofkP23
0?ofkP40oooo002j0?ofkPT00000U`3om^h00`000000ooK^0?ofkP0?0?ofkP030000003om^h0ooK^
08@0ooK^0@3oool00<<0ooK^2000002?0?ofkP030000003om^h0ooK^00h0ooK^00<000000?ofkP3o
m^h0Q@3om^h10?ooo`00b`3om^h8000008P0ooK^00<000000?ofkP3om^h0303om^h00`000000ooK^
0?ofkP260?ofkP40oooo003C0?ofkPP00000P03om^h00`000000ooK^0?ofkP0;0?ofkP030000003o
m^h0ooK^08L0ooK^0@3oool00=/0ooK^2@00001g0?ofkP030000003om^h0ooK^00/0ooK^00<00000
0?ofkP3om^h0Q`3om^h10?ooo`00i03om^h8000006l0ooK^00<000000?ofkP3om^h02P3om^h00`00
0000ooK^0?ofkP280?ofkP40oooo003/0?ofkPP00000I`3om^h00`000000ooK^0?ofkP090?ofkP03
0000003om^h0ooK^08T0ooK^0@3oool00?@0ooK^2@00001N0?ofkP030000003om^h0ooK^00P0ooK^
00<000000?ofkP3om^h0RP3om^h10?ooo`00o@3om^h8000005H0ooK^00<000000?ofkP3om^h01`3o
m^h00`000000ooK^0?ofkP2;0?ofkP40oooo003o0?ofkPH0ooK^2000001>0?ofkP030000003om^h0
ooK^00H0ooK^00<000000?ofkP3om^h0S03om^h10?ooo`00o`3om^h>0?ofkPT00000A@3om^h00`00
0000ooK^0?ofkP060?ofkP030000003om^h0ooK^08`0ooK^0@3oool00?l0ooK^5`3om^h8000003d0
ooK^00<000000?ofkP3om^h01@3om^h00`000000ooK^0?ofkP2=0?ofkP40oooo003o0?ofkQl0ooK^
2000000e0?ofkP030000003om^h0ooK^00@0ooK^00<000000?ofkP3om^h0SP3om^h10?ooo`00o`3o
m^hW0?ofkPT00000;03om^h00`000000ooK^0?ofkP030?ofkP030000003om^h0ooK^08l0ooK^0@3o
ool00?l0ooK^<03om^h8000002D0ooK^00D000000?ofkP3om^h0ooK^0000002B0?ofkP40oooo003o
0?ofkSP0ooK^2000000M0?ofkP040000003om^h0ooK^000009<0ooK^0@3oool00?l0ooK^@03om^h9
000001@0ooK^00@000000?ofkP3om^h00000T`3om^h10?ooo`00o`3om^i90?ofkPP00000303om^h0
0`000000ooK^0000002D0?ofkP40oooo003o0?ofkU40ooK^200000040?ofkP800000U@3om^h10?oo
o`00o`3om^iI0?ofkPD00000UP3om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3o
ool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^
m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?oo
o`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd
0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo
003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0
ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool0
0?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03o
m^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00
o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?of
kP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o
0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^
0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0
ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h1
0?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3o
m^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40
oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?of
k_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3o
ool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^
m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?oo
o`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd
0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo
003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0
ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool0
0?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03o
m^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00
\
\>"],
  ImageRangeCache->{{{0, 499}, {499, 0}} -> {-5.00005*^-06, -5.00005*^-06, \
0.00200403, 0.00200403}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
%%ImageSize: 500 500 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics3D
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Background color
1 .961 .933 r
MFill
% Scaling calculations
0 1 0 1 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 0 r
.25 Mabswid
[ ] 0 setdash
.36195 .03848 m
.33874 .3169 L
s
.33874 .3169 m
.06528 .69847 L
s
.06528 .69847 m
.11236 .44767 L
s
.11236 .44767 m
.36195 .03848 L
s
.93295 .30234 m
.59088 .60318 L
s
.59088 .60318 m
.60039 .8356 L
s
.60039 .8356 m
.99253 .5665 L
s
.99253 .5665 m
.93295 .30234 L
s
.36195 .03848 m
.33874 .3169 L
s
.33874 .3169 m
.99253 .5665 L
s
.99253 .5665 m
.93295 .30234 L
s
.93295 .30234 m
.36195 .03848 L
s
.11236 .44767 m
.59088 .60318 L
s
.59088 .60318 m
.60039 .8356 L
s
.60039 .8356 m
.06528 .69847 L
s
.06528 .69847 m
.11236 .44767 L
s
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
.83 .24 .1 r
.5 Mabswid
.42857 .56253 m
.447 .58135 L
s
.44572 .54453 m
.42857 .56253 L
s
.40755 .54684 m
.42857 .56253 L
s
.447 .58135 m
.46216 .60261 L
s
.46445 .56364 m
.447 .58135 L
s
.4244 .52855 m
.40755 .54684 L
s
.38469 .53486 m
.40755 .54684 L
s
.46216 .60261 m
.47346 .62555 L
s
.4799 .58518 m
.46216 .60261 L
s
.40124 .5163 m
.38469 .53486 L
s
.3608 .52709 m
.38469 .53486 L
s
.47346 .62555 m
.48042 .64934 L
s
.49148 .6084 m
.47346 .62555 L
s
.37708 .50827 m
.3608 .52709 L
s
.33678 .52391 m
.3608 .52709 L
s
.46445 .56364 m
.44572 .54453 L
s
.46342 .52595 m
.44572 .54453 L
s
.44572 .54453 m
.4244 .52855 L
s
.48042 .64934 m
.48268 .6731 L
s
.49869 .63245 m
.48042 .64934 L
s
.4799 .58518 m
.46445 .56364 L
s
.48246 .54535 m
.46445 .56364 L
s
.44179 .50967 m
.4244 .52855 L
s
.4244 .52855 m
.40124 .5163 L
s
.49148 .6084 m
.4799 .58518 L
s
.49822 .56719 m
.4799 .58518 L
s
.35282 .50487 m
.33678 .52391 L
s
.31356 .52555 m
.33678 .52391 L
s
.41833 .49713 m
.40124 .5163 L
s
.40124 .5163 m
.37708 .50827 L
s
.49869 .63245 m
.49148 .6084 L
s
.51009 .59069 m
.49148 .6084 L
s
.48268 .6731 m
.50117 .65643 L
s
.48268 .6731 m
.48002 .69588 L
s
.3939 .48884 m
.37708 .50827 L
s
.37708 .50827 m
.35282 .50487 L
s
.24 .35 .67 r
.6726 .57153 m
.6663 .59771 L
s
.64176 .56096 m
.6726 .57153 L
s
.68175 .54593 m
.6726 .57153 L
s
.65099 .53511 m
.68175 .54593 L
s
.69344 .5218 m
.68175 .54593 L
s
.83 .24 .1 r
.48246 .54535 m
.46342 .52595 L
s
.4817 .50675 m
.46342 .52595 L
s
.46342 .52595 m
.44179 .50967 L
s
.32938 .50634 m
.31356 .52555 L
s
.2921 .53211 m
.31356 .52555 L
s
.50117 .65643 m
.49869 .63245 L
s
.51757 .61499 m
.49869 .63245 L
s
.49822 .56719 m
.48246 .54535 L
s
.50107 .52646 m
.48246 .54535 L
s
.45975 .49016 m
.44179 .50967 L
s
.44179 .50967 m
.41833 .49713 L
s
.24 .35 .67 r
.6663 .59771 m
.66309 .62359 L
s
.63531 .58735 m
.6663 .59771 L
s
.66267 .51071 m
.69344 .5218 L
s
.70729 .49996 m
.69344 .5218 L
s
.83 .24 .1 r
.51009 .59069 m
.49822 .56719 L
s
.51714 .5486 m
.49822 .56719 L
s
.48002 .69588 m
.47238 .71672 L
s
.49867 .6794 m
.48002 .69588 L
s
.36938 .4852 m
.35282 .50487 L
s
.35282 .50487 m
.32938 .50634 L
s
.43599 .47732 m
.41833 .49713 L
s
.41833 .49713 m
.3939 .48884 L
s
.24 .35 .67 r
.66309 .62359 m
.66313 .64824 L
s
.63187 .61341 m
.66309 .62359 L
s
.83 .24 .1 r
.51757 .61499 m
.51009 .59069 L
s
.52932 .57239 m
.51009 .59069 L
s
.24 .35 .67 r
.63531 .58735 m
.64176 .56096 L
s
.61033 .55018 m
.64176 .56096 L
s
.64176 .56096 m
.65099 .53511 L
s
.61963 .52409 m
.65099 .53511 L
s
.65099 .53511 m
.66267 .51071 L
s
.83 .24 .1 r
.49867 .6794 m
.50117 .65643 L
s
.52027 .63921 m
.50117 .65643 L
s
.24 .35 .67 r
.67644 .48859 m
.70729 .49996 L
s
.72286 .48125 m
.70729 .49996 L
s
.83 .24 .1 r
.30775 .51278 m
.2921 .53211 L
s
.27335 .54349 m
.2921 .53211 L
s
.24 .35 .67 r
.63187 .61341 m
.63531 .58735 L
s
.60372 .5768 m
.63531 .58735 L
s
.63132 .49941 m
.66267 .51071 L
s
.66267 .51071 m
.67644 .48859 L
s
.83 .24 .1 r
.41127 .46875 m
.3939 .48884 L
s
.3939 .48884 m
.36938 .4852 L
s
.50107 .52646 m
.4817 .50675 L
s
.5006 .4869 m
.4817 .50675 L
s
.4817 .50675 m
.45975 .49016 L
s
.34573 .48648 m
.32938 .50634 L
s
.32938 .50634 m
.30775 .51278 L
s
.47238 .71672 m
.45991 .73466 L
s
.49113 .70039 m
.47238 .71672 L
s
.52027 .63921 m
.51757 .61499 L
s
.53707 .59696 m
.51757 .61499 L
s
.51714 .5486 m
.50107 .52646 L
s
.5203 .50694 m
.50107 .52646 L
s
.24 .35 .67 r
.66313 .64824 m
.63162 .63821 L
s
.66313 .64824 m
.66652 .67076 L
s
.63162 .63821 m
.63187 .61341 L
s
.60005 .60304 m
.63187 .61341 L
s
.83 .24 .1 r
.47832 .46999 m
.45975 .49016 L
s
.45975 .49016 m
.43599 .47732 L
s
.24 .35 .67 r
.60372 .5768 m
.61033 .55018 L
s
.57829 .5392 m
.61033 .55018 L
s
.61033 .55018 m
.61963 .52409 L
s
.58767 .51285 m
.61963 .52409 L
s
.61963 .52409 m
.63132 .49941 L
s
.64501 .477 m
.67644 .48859 L
s
.67644 .48859 m
.69186 .46959 L
s
.69186 .46959 m
.72286 .48125 L
s
.73962 .46644 m
.72286 .48125 L
s
.83 .24 .1 r
.52932 .57239 m
.51714 .5486 L
s
.5367 .52939 m
.51714 .5486 L
s
.49113 .70039 m
.49867 .6794 L
s
.51794 .66237 m
.49867 .6794 L
s
.24 .35 .67 r
.60005 .60304 m
.60372 .5768 L
s
.57152 .56604 m
.60372 .5768 L
s
.59935 .48789 m
.63132 .49941 L
s
.63132 .49941 m
.64501 .477 L
s
.83 .24 .1 r
.3865 .46487 m
.36938 .4852 L
s
.36938 .4852 m
.34573 .48648 L
s
.45425 .45684 m
.43599 .47732 L
s
.43599 .47732 m
.41127 .46875 L
s
.28888 .5241 m
.27335 .54349 L
s
.25823 .55936 m
.27335 .54349 L
s
.53707 .59696 m
.52932 .57239 L
s
.52027 .63921 m
.54001 .6214 L
s
.51794 .66237 m
.52027 .63921 L
s
.24 .35 .67 r
.63162 .63821 m
.5995 .62799 L
s
.63467 .66082 m
.63162 .63821 L
s
.5995 .62799 m
.60005 .60304 L
s
.56761 .59247 m
.60005 .60304 L
s
.57152 .56604 m
.57829 .5392 L
s
.57829 .5392 m
.58767 .51285 L
s
.55509 .50139 m
.58767 .51285 L
s
.58767 .51285 m
.59935 .48789 L
s
.83 .24 .1 r
.32393 .49279 m
.30775 .51278 L
s
.30775 .51278 m
.28888 .5241 L
s
.45991 .73466 m
.44296 .74882 L
s
.47868 .71843 m
.45991 .73466 L
s
.24 .35 .67 r
.61295 .46519 m
.64501 .477 L
s
.64501 .477 m
.66026 .4577 L
s
.66026 .4577 m
.69186 .46959 L
s
.69186 .46959 m
.70841 .45448 L
s
.66652 .67076 m
.67325 .6902 L
s
.63467 .66082 m
.66652 .67076 L
s
.83 .24 .1 r
.42924 .44798 m
.41127 .46875 L
s
.41127 .46875 m
.3865 .46487 L
s
.24 .35 .67 r
.56761 .59247 m
.57152 .56604 L
s
.70841 .45448 m
.73962 .46644 L
s
.757 .45621 m
.73962 .46644 L
s
.56677 .47615 m
.59935 .48789 L
s
.59935 .48789 m
.61295 .46519 L
s
.83 .24 .1 r
.5203 .50694 m
.5006 .4869 L
s
.5006 .4869 m
.47832 .46999 L
s
.36264 .46595 m
.34573 .48648 L
s
.34573 .48648 m
.32393 .49279 L
s
.47868 .71843 m
.49113 .70039 L
s
.51051 .6835 m
.49113 .70039 L
s
.54001 .6214 m
.53707 .59696 L
s
.5367 .52939 m
.5203 .50694 L
s
.49752 .44914 m
.47832 .46999 L
s
.47832 .46999 m
.45425 .45684 L
s
.27371 .53999 m
.25823 .55936 L
s
.24757 .57919 m
.25823 .55936 L
s
.24 .35 .67 r
.5995 .62799 m
.56675 .61756 L
s
.60219 .6507 m
.5995 .62799 L
s
.56675 .61756 m
.56761 .59247 L
s
.271 .384 .736 r
.52958 .54506 m .54449 .55007 L .54757 .57274 L p F P
0 0 0 r
s
.83 .24 .1 r
.5367 .52939 m
.53847 .5328 L
s
.52932 .57239 m
.54045 .56179 L
s
.278 .395 .76 r
.54449 .55007 m .52958 .54506 L .52687 .52168 L p F P
0 0 0 r
s
.278 .395 .76 r
.52687 .52168 m .54043 .52633 L .54449 .55007 L p F P
0 0 0 r
s
.585 .167 .076 r
.55357 .54137 m .54449 .55007 L .54757 .57274 L p F P
0 0 0 r
s
.24 .35 .67 r
.55022 .55892 m
.57152 .56604 L
s
.659 .189 .085 r
.54449 .55007 m .55357 .54137 L .54865 .51826 L p F P
0 0 0 r
s
.24 .35 .67 r
.55113 .52989 m
.57829 .5392 L
s
.659 .189 .085 r
.54865 .51826 m .54043 .52633 L .54449 .55007 L p F P
0 0 0 r
s
.83 .24 .1 r
.51051 .6835 m
.51794 .66237 L
s
.53787 .64475 m
.51794 .66237 L
s
.24 .35 .67 r
.54882 .51904 m
.55509 .50139 L
s
.55509 .50139 m
.56677 .47615 L
s
.723 .209 .093 r
.54043 .52633 m .54865 .51826 L .54263 .49468 L p F P
0 0 0 r
s
.24 .35 .67 r
.54329 .49724 m
.55509 .50139 L
s
.723 .209 .093 r
.54263 .49468 m .53545 .5019 L .54043 .52633 L p F P
0 0 0 r
s
.282 .404 .78 r
.54043 .52633 m .52687 .52168 L .52355 .49774 L p F P
0 0 0 r
s
.83 .24 .1 r
.5203 .50694 m
.52427 .50291 L
s
.282 .404 .78 r
.52355 .49774 m .53545 .5019 L .54043 .52633 L p F P
0 0 0 r
s
.24 .35 .67 r
.58027 .45314 m
.61295 .46519 L
s
.61295 .46519 m
.62804 .44558 L
s
.62804 .44558 m
.66026 .4577 L
s
.66026 .4577 m
.67658 .4423 L
s
.83 .24 .1 r
.40421 .44384 m
.3865 .46487 L
s
.3865 .46487 m
.36264 .46595 L
s
.24 .35 .67 r
.64101 .68032 m
.63467 .66082 L
s
.60219 .6507 m
.63467 .66082 L
s
.264 .37 .707 r
.53164 .56749 m .54757 .57274 L .54962 .59394 L p F P
0 0 0 r
s
.83 .24 .1 r
.53707 .59696 m
.54604 .58867 L
s
.271 .384 .736 r
.54757 .57274 m .53164 .56749 L .52958 .54506 L p F P
0 0 0 r
s
.24 .35 .67 r
.53869 .55507 m
.54336 .53684 L
s
.53869 .55507 m
.54614 .55756 L
s
.497 .14 .065 r
.55732 .56361 m .54757 .57274 L .54962 .59394 L p F P
0 0 0 r
s
.24 .35 .67 r
.55134 .58717 m
.56761 .59247 L
s
.585 .167 .076 r
.54757 .57274 m .55732 .56361 L .55357 .54137 L p F P
0 0 0 r
s
.83 .24 .1 r
.54466 .55778 m
.5492 .55347 L
s
.54078 .53724 m
.5492 .55347 L
s
.47313 .43566 m
.45425 .45684 L
s
.45425 .45684 m
.42924 .44798 L
s
.30495 .50405 m
.28888 .5241 L
s
.28888 .5241 m
.27371 .53999 L
s
.24 .35 .67 r
.67658 .4423 m
.70841 .45448 L
s
.70841 .45448 m
.7255 .44399 L
s
.781 .227 .1 r
.53545 .5019 m .54263 .49468 L .53561 .47104 L p F P
0 0 0 r
s
.781 .227 .1 r
.53561 .47104 m .52965 .4772 L .53545 .5019 L p F P
0 0 0 r
s
.286 .412 .798 r
.53545 .5019 m .52355 .49774 L .51968 .47365 L p F P
0 0 0 r
s
.286 .412 .798 r
.51968 .47365 m .52965 .4772 L .53545 .5019 L p F P
0 0 0 r
s
.24 .35 .67 r
.56677 .47615 m
.58027 .45314 L
s
.83 .24 .1 r
.44296 .74882 m
.42216 .75839 L
s
.46169 .73262 m
.44296 .74882 L
s
.271 .384 .736 r
.51454 .54001 m .52958 .54506 L .53164 .56749 L p F P
0 0 0 r
s
.278 .395 .76 r
.52958 .54506 m .51454 .54001 L .5132 .517 L p F P
0 0 0 r
s
.278 .395 .76 r
.5132 .517 m .52687 .52168 L .52958 .54506 L p F P
0 0 0 r
s
.282 .404 .78 r
.52687 .52168 m .5132 .517 L .51157 .49355 L p F P
0 0 0 r
s
.282 .404 .78 r
.51157 .49355 m .52355 .49774 L .52687 .52168 L p F P
0 0 0 r
s
.24 .35 .67 r
.67325 .6902 m
.68318 .70568 L
s
.64101 .68032 m
.67325 .6902 L
s
.254 .353 .671 r
.53301 .58856 m .54962 .59394 L .55059 .61329 L p F P
0 0 0 r
s
.264 .37 .707 r
.54962 .59394 m .53301 .58856 L .53164 .56749 L p F P
0 0 0 r
s
.24 .35 .67 r
.53453 .58169 m
.53869 .55507 L
s
.53453 .58169 m
.54949 .58656 L
s
.391 .108 .052 r
.55981 .58459 m .54962 .59394 L .55059 .61329 L p F P
0 0 0 r
s
.497 .14 .065 r
.54962 .59394 m .55981 .58459 L .55732 .56361 L p F P
0 0 0 r
s
.83 .24 .1 r
.54808 .58677 m
.55724 .5783 L
s
.264 .37 .707 r
.51556 .56218 m .53164 .56749 L .53301 .58856 L p F P
0 0 0 r
s
.271 .384 .736 r
.53164 .56749 m .51556 .56218 L .51454 .54001 L p F P
0 0 0 r
s
.585 .167 .076 r
.5628 .53252 m .55357 .54137 L .55732 .56361 L p F P
0 0 0 r
s
.83 .24 .1 r
.5492 .55347 m
.55724 .5783 L
s
.659 .189 .085 r
.55357 .54137 m .5628 .53252 L .55699 .51007 L p F P
0 0 0 r
s
.659 .189 .085 r
.55699 .51007 m .54865 .51826 L .55357 .54137 L p F P
0 0 0 r
s
.723 .209 .093 r
.54865 .51826 m .55699 .51007 L .54989 .48737 L p F P
0 0 0 r
s
.723 .209 .093 r
.54989 .48737 m .54263 .49468 L .54865 .51826 L p F P
0 0 0 r
s
.286 .412 .798 r
.52355 .49774 m .51157 .49355 L .50966 .47008 L p F P
0 0 0 r
s
.83 .24 .1 r
.5006 .4869 m
.51021 .47681 L
s
.286 .412 .798 r
.50966 .47008 m .51968 .47365 L .52355 .49774 L p F P
0 0 0 r
s
.24 .35 .67 r
.52187 .48971 m
.53462 .4942 L
s
.83 .24 .1 r
.34067 .47212 m
.32393 .49279 L
s
.32393 .49279 m
.30495 .50405 L
s
.46169 .73262 m
.47868 .71843 L
s
.49811 .70163 m
.47868 .71843 L
s
.24 .35 .67 r
.7255 .44399 m
.757 .45621 L
s
.77432 .4512 m
.757 .45621 L
s
.278 .395 .76 r
.49943 .51227 m .5132 .517 L .51454 .54001 L p F P
0 0 0 r
s
.282 .404 .78 r
.5132 .517 m .49943 .51227 L .4995 .48933 L p F P
0 0 0 r
s
.282 .404 .78 r
.4995 .48933 m .51157 .49355 L .5132 .517 L p F P
0 0 0 r
s
.271 .384 .736 r
.49937 .53491 m .51454 .54001 L .51556 .56218 L p F P
0 0 0 r
s
.278 .395 .76 r
.51454 .54001 m .49937 .53491 L .49943 .51227 L p F P
0 0 0 r
s
.24 .35 .67 r
.51233 .51658 m
.54143 .52656 L
s
.56907 .64037 m
.56675 .61756 L
s
.83 .24 .1 r
.44783 .4265 m
.42924 .44798 L
s
.42924 .44798 m
.40421 .44384 L
s
.497 .14 .065 r
.56723 .55433 m .55732 .56361 L .55981 .58459 L p F P
0 0 0 r
s
.585 .167 .076 r
.55732 .56361 m .56723 .55433 L .5628 .53252 L p F P
0 0 0 r
s
.24 .35 .67 r
.51233 .51658 m
.52187 .48971 L
s
.289 .419 .812 r
.52965 .4772 m .51968 .47365 L .51532 .44983 L p F P
0 0 0 r
s
.289 .419 .812 r
.51532 .44983 m .52309 .45265 L .52965 .4772 L p F P
0 0 0 r
s
.83 .24 .1 r
.51485 .47193 m
.51864 .46795 L
s
.833 .243 .106 r
.52965 .4772 m .53561 .47104 L .52771 .44776 L p F P
0 0 0 r
s
.833 .243 .106 r
.52771 .44776 m .52309 .45265 L .52965 .4772 L p F P
0 0 0 r
s
.781 .227 .1 r
.54263 .49468 m .54989 .48737 L .54164 .46482 L p F P
0 0 0 r
s
.781 .227 .1 r
.54164 .46482 m .53561 .47104 L .54263 .49468 L p F P
0 0 0 r
s
.24 .35 .67 r
.5426 .46744 m
.56677 .47615 L
s
.53354 .46417 m
.54001 .46651 L
s
.83 .24 .1 r
.53252 .49453 m
.54018 .48675 L
s
.24 .35 .67 r
.52187 .48971 m
.53019 .4715 L
s
.53339 .46449 m
.53354 .46417 L
s
.254 .353 .671 r
.55059 .61329 m .53366 .60791 L .53301 .58856 L p F P
0 0 0 r
s
.254 .353 .671 r
.51624 .58313 m .53301 .58856 L .53366 .60791 L p F P
0 0 0 r
s
.264 .37 .707 r
.53301 .58856 m .51624 .58313 L .51556 .56218 L p F P
0 0 0 r
s
.24 .35 .67 r
.58027 .45314 m
.59518 .43322 L
s
.286 .412 .798 r
.51157 .49355 m .4995 .48933 L .49958 .46649 L p F P
0 0 0 r
s
.286 .412 .798 r
.49958 .46649 m .50966 .47008 L .51157 .49355 L p F P
0 0 0 r
s
.264 .37 .707 r
.49932 .55683 m .51556 .56218 L .51624 .58313 L p F P
0 0 0 r
s
.271 .384 .736 r
.51556 .56218 m .49932 .55683 L .49937 .53491 L p F P
0 0 0 r
s
.24 .35 .67 r
.50521 .54388 m
.51233 .51658 L
s
.50521 .54388 m
.53869 .55507 L
s
.59518 .43322 m
.62804 .44558 L
s
.62804 .44558 m
.64411 .42987 L
s
.60813 .67024 m
.60219 .6507 L
s
.56907 .64037 m
.60219 .6507 L
s
.83 .24 .1 r
.26305 .55992 m
.24757 .57919 L
s
.24202 .6022 m
.24757 .57919 L
s
.52587 .47221 m
.54018 .48675 L
s
.38013 .44471 m
.36264 .46595 L
s
.36264 .46595 m
.34067 .47212 L
s
.49811 .70163 m
.51051 .6835 L
s
.53057 .66603 m
.51051 .6835 L
s
.278 .395 .76 r
.48554 .50751 m .49943 .51227 L .49937 .53491 L p F P
0 0 0 r
s
.282 .404 .78 r
.49943 .51227 m .48554 .50751 L .48734 .48509 L p F P
0 0 0 r
s
.282 .404 .78 r
.48734 .48509 m .4995 .48933 L .49943 .51227 L p F P
0 0 0 r
s
.289 .419 .812 r
.51968 .47365 m .50966 .47008 L .50752 .447 L p F P
0 0 0 r
s
.83 .24 .1 r
.51435 .46197 m
.51806 .4648 L
s
.289 .419 .812 r
.50752 .447 m .51532 .44983 L .51968 .47365 L p F P
0 0 0 r
s
.83 .24 .1 r
.49752 .44914 m
.50849 .45751 L
s
.271 .384 .736 r
.48406 .52976 m .49937 .53491 L .49932 .55683 L p F P
0 0 0 r
s
.278 .395 .76 r
.49937 .53491 m .48406 .52976 L .48554 .50751 L p F P
0 0 0 r
s
.391 .108 .052 r
.55059 .61329 m .56099 .60393 L .55981 .58459 L p F P
0 0 0 r
s
.24 .33 .624 r
.53366 .60791 m .55059 .61329 L .55044 .63042 L p F P
0 0 0 r
s
.83 .24 .1 r
.54001 .6214 m
.54223 .6194 L
s
.53787 .64475 m
.54001 .6214 L
s
.273 .073 .037 r
.56099 .60393 m .55059 .61329 L .55044 .63042 L p F P
0 0 0 r
s
.24 .35 .67 r
.55682 .6144 m
.56675 .61756 L
s
.64411 .42987 m
.67658 .4423 L
s
.67658 .4423 m
.69338 .43152 L
s
.53325 .46407 m
.53354 .46417 L
s
.659 .189 .085 r
.56544 .50177 m .55699 .51007 L .5628 .53252 L p F P
0 0 0 r
s
.723 .209 .093 r
.55699 .51007 m .56544 .50177 L .55725 .47997 L p F P
0 0 0 r
s
.723 .209 .093 r
.55725 .47997 m .54989 .48737 L .55699 .51007 L p F P
0 0 0 r
s
.83 .24 .1 r
.54018 .48675 m
.55693 .50952 L
s
.53924 .5269 m
.55693 .50952 L
s
.286 .412 .798 r
.4995 .48933 m .48734 .48509 L .48944 .46288 L p F P
0 0 0 r
s
.286 .412 .798 r
.48944 .46288 m .49958 .46649 L .4995 .48933 L p F P
0 0 0 r
s
.391 .108 .052 r
.57018 .57508 m .55981 .58459 L .56099 .60393 L p F P
0 0 0 r
s
.497 .14 .065 r
.55981 .58459 m .57018 .57508 L .56723 .55433 L p F P
0 0 0 r
s
.83 .24 .1 r
.55724 .5783 m
.56044 .60298 L
s
.585 .167 .076 r
.57217 .52354 m .5628 .53252 L .56723 .55433 L p F P
0 0 0 r
s
.659 .189 .085 r
.5628 .53252 m .57217 .52354 L .56544 .50177 L p F P
0 0 0 r
s
.833 .243 .106 r
.53561 .47104 m .54164 .46482 L .53236 .44283 L p F P
0 0 0 r
s
.24 .35 .67 r
.53354 .46417 m
.53461 .46231 L
s
.833 .243 .106 r
.53236 .44283 m .52771 .44776 L .53561 .47104 L p F P
0 0 0 r
s
.24 .35 .67 r
.65054 .6958 m
.64101 .68032 L
s
.60813 .67024 m
.64101 .68032 L
s
.264 .37 .707 r
.51624 .58313 m .49929 .57765 L .49932 .55683 L p F P
0 0 0 r
s
.24 .35 .67 r
.5008 .57069 m
.50521 .54388 L
s
.264 .37 .707 r
.48293 .55142 m .49932 .55683 L .49929 .57765 L p F P
0 0 0 r
s
.271 .384 .736 r
.49932 .55683 m .48293 .55142 L .48406 .52976 L p F P
0 0 0 r
s
.289 .419 .812 r
.50966 .47008 m .49958 .46649 L .49967 .44416 L p F P
0 0 0 r
s
.83 .24 .1 r
.49752 .44914 m
.49966 .44681 L
s
.289 .419 .812 r
.49967 .44416 m .50752 .447 L .50966 .47008 L p F P
0 0 0 r
s
.254 .353 .671 r
.53366 .60791 m .51656 .60246 L .51624 .58313 L p F P
0 0 0 r
s
.254 .353 .671 r
.49929 .57765 m .51624 .58313 L .51656 .60246 L p F P
0 0 0 r
s
.24 .35 .67 r
.5008 .57069 m
.53453 .58169 L
s
.781 .227 .1 r
.54989 .48737 m .55725 .47997 L .54773 .45853 L p F P
0 0 0 r
s
.781 .227 .1 r
.54773 .45853 m .54164 .46482 L .54989 .48737 L p F P
0 0 0 r
s
.83 .24 .1 r
.28972 .51995 m
.27371 .53999 L
s
.27371 .53999 m
.26305 .55992 L
s
.42216 .75839 m
.39833 .76276 L
s
.44076 .74215 m
.42216 .75839 L
s
.278 .395 .76 r
.47154 .50272 m .48554 .50751 L .48406 .52976 L p F P
0 0 0 r
s
.282 .404 .78 r
.48554 .50751 m .47154 .50272 L .4751 .48081 L p F P
0 0 0 r
s
.282 .404 .78 r
.4751 .48081 m .48734 .48509 L .48554 .50751 L p F P
0 0 0 r
s
.271 .384 .736 r
.46862 .52457 m .48406 .52976 L .48293 .55142 L p F P
0 0 0 r
s
.278 .395 .76 r
.48406 .52976 m .46862 .52457 L .47154 .50272 L p F P
0 0 0 r
s
.24 .35 .67 r
.47836 .50494 m
.51233 .51658 L
s
.497 .14 .065 r
.5773 .54489 m .56723 .55433 L .57018 .57508 L p F P
0 0 0 r
s
.585 .167 .076 r
.56723 .55433 m .5773 .54489 L .57217 .52354 L p F P
0 0 0 r
s
.83 .24 .1 r
.5492 .55347 m
.56976 .5339 L
s
.24 .33 .624 r
.55044 .63042 m .53356 .62513 L .53366 .60791 L p F P
0 0 0 r
s
.24 .33 .624 r
.51656 .60246 m .53366 .60791 L .53356 .62513 L p F P
0 0 0 r
s
.24 .35 .67 r
.53335 .60692 m
.55132 .61264 L
s
.53335 .60692 m
.53453 .58169 L
s
.286 .412 .798 r
.48734 .48509 m .4751 .48081 L .47924 .45925 L p F P
0 0 0 r
s
.286 .412 .798 r
.47924 .45925 m .48944 .46288 L .48734 .48509 L p F P
0 0 0 r
s
.24 .35 .67 r
.48799 .4778 m
.52187 .48971 L
s
.69338 .43152 m
.7255 .44399 L
s
.7255 .44399 m
.74249 .43872 L
s
.291 .424 .825 r
.52309 .45265 m .51532 .44983 L .51054 .42672 L p F P
0 0 0 r
s
.291 .424 .825 r
.51054 .42672 m .51589 .42869 L .52309 .45265 L p F P
0 0 0 r
s
.883 .258 .112 r
.52309 .45265 m .52771 .44776 L .51904 .42527 L p F P
0 0 0 r
s
.883 .258 .112 r
.51904 .42527 m .51589 .42869 L .52309 .45265 L p F P
0 0 0 r
s
.83 .24 .1 r
.42254 .42208 m
.40421 .44384 L
s
.40421 .44384 m
.38013 .44471 L
s
.289 .419 .812 r
.49958 .46649 m .48944 .46288 L .4918 .4413 L p F P
0 0 0 r
s
.83 .24 .1 r
.47313 .43566 m
.49131 .44571 L
s
.49354 .44694 m
.49752 .44914 L
s
.289 .419 .812 r
.4918 .4413 m .49967 .44416 L .49958 .46649 L p F P
0 0 0 r
s
.24 .35 .67 r
.49965 .45196 m
.52678 .46174 L
s
.47836 .50494 m
.48799 .4778 L
s
.833 .243 .106 r
.54164 .46482 m .54773 .45853 L .53705 .43787 L p F P
0 0 0 r
s
.24 .35 .67 r
.53805 .45632 m
.5397 .45345 L
s
.54255 .4485 m
.54694 .44085 L
s
.54694 .44085 m
.58027 .45314 L
s
.833 .243 .106 r
.53705 .43787 m .53236 .44283 L .54164 .46482 L p F P
0 0 0 r
s
.83 .24 .1 r
.32157 .4833 m
.30495 .50405 L
s
.30495 .50405 m
.28972 .51995 L
s
.264 .37 .707 r
.49929 .57765 m .48218 .57211 L .48293 .55142 L p F P
0 0 0 r
s
.264 .37 .707 r
.46639 .54597 m .48293 .55142 L .48218 .57211 L p F P
0 0 0 r
s
.271 .384 .736 r
.48293 .55142 m .46639 .54597 L .46862 .52457 L p F P
0 0 0 r
s
.24 .35 .67 r
.47107 .53248 m
.50521 .54388 L
s
.278 .395 .76 r
.45743 .49788 m .47154 .50272 L .46862 .52457 L p F P
0 0 0 r
s
.24 .35 .67 r
.47107 .53248 m
.47836 .50494 L
s
.282 .404 .78 r
.47154 .50272 m .45743 .49788 L .46277 .4765 L p F P
0 0 0 r
s
.282 .404 .78 r
.46277 .4765 m .4751 .48081 L .47154 .50272 L p F P
0 0 0 r
s
.291 .424 .825 r
.51532 .44983 m .50752 .447 L .50516 .42474 L p F P
0 0 0 r
s
.291 .424 .825 r
.50516 .42474 m .51054 .42672 L .51532 .44983 L p F P
0 0 0 r
s
.83 .24 .1 r
.5015 .44482 m
.50669 .43918 L
s
.254 .353 .671 r
.51656 .60246 m .49928 .59697 L .49929 .57765 L p F P
0 0 0 r
s
.254 .353 .671 r
.48218 .57211 m .49929 .57765 L .49928 .59697 L p F P
0 0 0 r
s
.24 .35 .67 r
.49929 .59608 m
.5008 .57069 L
s
.56166 .4206 m
.59518 .43322 L
s
.59518 .43322 m
.611 .41719 L
s
.57459 .65996 m
.56907 .64037 L
s
.83 .24 .1 r
.44076 .74215 m
.46169 .73262 L
s
.48108 .71585 m
.46169 .73262 L
s
.24 .35 .67 r
.68318 .70568 m
.69607 .71638 L
s
.65054 .6958 m
.68318 .70568 L
s
.659 .189 .085 r
.57402 .49335 m .56544 .50177 L .57217 .52354 L p F P
0 0 0 r
s
.83 .24 .1 r
.55693 .50952 m
.56976 .5339 L
s
.723 .209 .093 r
.56544 .50177 m .57402 .49335 L .56469 .47247 L p F P
0 0 0 r
s
.723 .209 .093 r
.56469 .47247 m .55725 .47997 L .56544 .50177 L p F P
0 0 0 r
s
.286 .412 .798 r
.4751 .48081 m .46277 .4765 L .46898 .45559 L p F P
0 0 0 r
s
.286 .412 .798 r
.46898 .45559 m .47924 .45925 L .4751 .48081 L p F P
0 0 0 r
s
.391 .108 .052 r
.56099 .60393 m .57157 .5944 L .57018 .57508 L p F P
0 0 0 r
s
.273 .073 .037 r
.55044 .63042 m .56081 .62123 L .56099 .60393 L p F P
0 0 0 r
s
.83 .24 .1 r
.54941 .61292 m
.56044 .60298 L
s
.273 .073 .037 r
.57157 .5944 m .56099 .60393 L .56081 .62123 L p F P
0 0 0 r
s
.289 .419 .812 r
.48944 .46288 m .47924 .45925 L .48388 .43843 L p F P
0 0 0 r
s
.289 .419 .812 r
.48388 .43843 m .4918 .4413 L .48944 .46288 L p F P
0 0 0 r
s
.24 .35 .67 r
.48799 .4778 m
.49965 .45196 L
s
.271 .384 .736 r
.45303 .51933 m .46862 .52457 L .46639 .54597 L p F P
0 0 0 r
s
.278 .395 .76 r
.46862 .52457 m .45303 .51933 L .45743 .49788 L p F P
0 0 0 r
s
.781 .227 .1 r
.55725 .47997 m .56469 .47247 L .55388 .45218 L p F P
0 0 0 r
s
.781 .227 .1 r
.55388 .45218 m .54773 .45853 L .55725 .47997 L p F P
0 0 0 r
s
.883 .258 .112 r
.52771 .44776 m .53236 .44283 L .52221 .42183 L p F P
0 0 0 r
s
.883 .258 .112 r
.52221 .42183 m .51904 .42527 L .52771 .44776 L p F P
0 0 0 r
s
.161 .046 .023 r
.56081 .62123 m .55044 .63042 L .54914 .64493 L p F P
0 0 0 r
s
.24 .35 .67 r
.55374 .63559 m
.56907 .64037 L
s
.221 .299 .561 r
.53356 .62513 m .55044 .63042 L .54914 .64493 L p F P
0 0 0 r
s
.83 .24 .1 r
.53787 .64475 m
.54443 .63895 L
s
.585 .167 .076 r
.58169 .51442 m .57217 .52354 L .5773 .54489 L p F P
0 0 0 r
s
.659 .189 .085 r
.57217 .52354 m .58169 .51442 L .57402 .49335 L p F P
0 0 0 r
s
.291 .424 .825 r
.50752 .447 m .49967 .44416 L .49978 .42275 L p F P
0 0 0 r
s
.291 .424 .825 r
.49978 .42275 m .50516 .42474 L .50752 .447 L p F P
0 0 0 r
s
.24 .33 .624 r
.53356 .62513 m .51651 .61979 L .51656 .60246 L p F P
0 0 0 r
s
.24 .33 .624 r
.49928 .59697 m .51656 .60246 L .51651 .61979 L p F P
0 0 0 r
s
.391 .108 .052 r
.58072 .56541 m .57018 .57508 L .57157 .5944 L p F P
0 0 0 r
s
.497 .14 .065 r
.57018 .57508 m .58072 .56541 L .5773 .54489 L p F P
0 0 0 r
s
.83 .24 .1 r
.25759 .58311 m
.24202 .6022 L
s
.24203 .62739 m
.24202 .6022 L
s
.24 .35 .67 r
.611 .41719 m
.64411 .42987 L
s
.64411 .42987 m
.6606 .4188 L
s
.74249 .43872 m
.77432 .4512 L
s
.79087 .45184 m
.77432 .4512 L
s
.83 .24 .1 r
.35799 .45071 m
.34067 .47212 L
s
.34067 .47212 m
.32157 .4833 L
s
.289 .419 .812 r
.47924 .45925 m .46898 .45559 L .47593 .43555 L p F P
0 0 0 r
s
.83 .24 .1 r
.44783 .4265 m
.47313 .43566 L
s
.289 .419 .812 r
.47593 .43555 m .48388 .43843 L .47924 .45925 L p F P
0 0 0 r
s
.278 .395 .76 r
.4432 .493 m .45743 .49788 L .45303 .51933 L p F P
0 0 0 r
s
.282 .404 .78 r
.45743 .49788 m .4432 .493 L .45036 .47216 L p F P
0 0 0 r
s
.282 .404 .78 r
.45036 .47216 m .46277 .4765 L .45743 .49788 L p F P
0 0 0 r
s
.286 .412 .798 r
.46277 .4765 m .45036 .47216 L .45866 .45192 L p F P
0 0 0 r
s
.286 .412 .798 r
.45866 .45192 m .46898 .45559 L .46277 .4765 L p F P
0 0 0 r
s
.833 .243 .106 r
.54773 .45853 m .55388 .45218 L .54178 .43286 L p F P
0 0 0 r
s
.24 .35 .67 r
.54674 .44078 m
.54694 .44085 L
s
.833 .243 .106 r
.54178 .43286 m .53705 .43787 L .54773 .45853 L p F P
0 0 0 r
s
.83 .24 .1 r
.52414 .46218 m
.54035 .44515 L
s
.264 .37 .707 r
.48218 .57211 m .4649 .56651 L .46639 .54597 L p F P
0 0 0 r
s
.24 .35 .67 r
.46639 .55948 m
.47107 .53248 L
s
.264 .37 .707 r
.44968 .54046 m .46639 .54597 L .4649 .56651 L p F P
0 0 0 r
s
.271 .384 .736 r
.46639 .54597 m .44968 .54046 L .45303 .51933 L p F P
0 0 0 r
s
.291 .424 .825 r
.49967 .44416 m .4918 .4413 L .49437 .42076 L p F P
0 0 0 r
s
.291 .424 .825 r
.49437 .42076 m .49978 .42275 L .49967 .44416 L p F P
0 0 0 r
s
.83 .24 .1 r
.48108 .71585 m
.49811 .70163 L
s
.51822 .68424 m
.49811 .70163 L
s
.24 .35 .67 r
.61723 .68572 m
.60813 .67024 L
s
.57459 .65996 m
.60813 .67024 L
s
.254 .353 .671 r
.49928 .59697 m .48183 .59142 L .48218 .57211 L p F P
0 0 0 r
s
.254 .353 .671 r
.4649 .56651 m .48218 .57211 L .48183 .59142 L p F P
0 0 0 r
s
.24 .35 .67 r
.46639 .55948 m
.5008 .57069 L
s
.497 .14 .065 r
.58754 .53529 m .5773 .54489 L .58072 .56541 L p F P
0 0 0 r
s
.83 .24 .1 r
.55724 .5783 m
.57812 .559 L
s
.585 .167 .076 r
.5773 .54489 m .58754 .53529 L .58169 .51442 L p F P
0 0 0 r
s
.83 .24 .1 r
.56976 .5339 m
.57812 .559 L
s
.44783 .4265 m
.42254 .42208 L
s
.883 .258 .112 r
.53236 .44283 m .53705 .43787 L .5254 .41836 L p F P
0 0 0 r
s
.24 .35 .67 r
.53655 .43702 m
.53751 .43738 L
s
.883 .258 .112 r
.5254 .41836 m .52221 .42183 L .53236 .44283 L p F P
0 0 0 r
s
.271 .384 .736 r
.43731 .51404 m .45303 .51933 L .44968 .54046 L p F P
0 0 0 r
s
.278 .395 .76 r
.45303 .51933 m .43731 .51404 L .4432 .493 L p F P
0 0 0 r
s
.24 .35 .67 r
.44372 .49306 m
.47836 .50494 L
s
.83 .24 .1 r
.39833 .76276 m
.37254 .76154 L
s
.41672 .74641 m
.39833 .76276 L
s
.221 .299 .561 r
.54914 .64493 m .53269 .63986 L .53356 .62513 L p F P
0 0 0 r
s
.83 .24 .1 r
.53057 .66603 m
.53787 .64475 L
s
.221 .299 .561 r
.51651 .61979 m .53356 .62513 L .53269 .63986 L p F P
0 0 0 r
s
.24 .35 .67 r
.53335 .60692 m
.53529 .62983 L
s
.291 .424 .825 r
.4918 .4413 m .48388 .43843 L .48895 .41876 L p F P
0 0 0 r
s
.291 .424 .825 r
.48895 .41876 m .49437 .42076 L .4918 .4413 L p F P
0 0 0 r
s
.289 .419 .812 r
.46898 .45559 m .45866 .45192 L .46794 .43265 L p F P
0 0 0 r
s
.289 .419 .812 r
.46794 .43265 m .47593 .43555 L .46898 .45559 L p F P
0 0 0 r
s
.24 .33 .624 r
.51651 .61979 m .49928 .6144 L .49928 .59697 L p F P
0 0 0 r
s
.24 .35 .67 r
.49929 .59608 m
.53335 .60692 L
s
.24 .33 .624 r
.48183 .59142 m .49928 .59697 L .49928 .6144 L p F P
0 0 0 r
s
.24 .35 .67 r
.6606 .4188 m
.69338 .43152 L
s
.69338 .43152 m
.71001 .42599 L
s
.723 .209 .093 r
.57223 .46489 m .56469 .47247 L .57402 .49335 L p F P
0 0 0 r
s
.781 .227 .1 r
.56469 .47247 m .57223 .46489 L .56009 .44577 L p F P
0 0 0 r
s
.781 .227 .1 r
.56009 .44577 m .55388 .45218 L .56469 .47247 L p F P
0 0 0 r
s
.83 .24 .1 r
.54018 .48675 m
.56076 .46586 L
s
.659 .189 .085 r
.58272 .48481 m .57402 .49335 L .58169 .51442 L p F P
0 0 0 r
s
.723 .209 .093 r
.57402 .49335 m .58272 .48481 L .57223 .46489 L p F P
0 0 0 r
s
.83 .24 .1 r
.55693 .50952 m
.57787 .48896 L
s
.282 .404 .78 r
.43785 .46779 m .45036 .47216 L .4432 .493 L p F P
0 0 0 r
s
.286 .412 .798 r
.45036 .47216 m .43785 .46779 L .44827 .44822 L p F P
0 0 0 r
s
.286 .412 .798 r
.44827 .44822 m .45866 .45192 L .45036 .47216 L p F P
0 0 0 r
s
.24 .35 .67 r
.45344 .46565 m
.48799 .4778 L
s
.278 .395 .76 r
.42885 .48808 m .4432 .493 L .43731 .51404 L p F P
0 0 0 r
s
.282 .404 .78 r
.4432 .493 m .42885 .48808 L .43785 .46779 L p F P
0 0 0 r
s
.83 .24 .1 r
.27909 .53997 m
.26305 .55992 L
s
.26305 .55992 m
.25759 .58311 L
s
.54035 .44515 m
.56076 .46586 L
s
.291 .428 .835 r
.51589 .42869 m .51054 .42672 L .5054 .40477 L p F P
0 0 0 r
s
.291 .428 .835 r
.5054 .40477 m .50815 .4058 L .51589 .42869 L p F P
0 0 0 r
s
.93 .273 .118 r
.51589 .42869 m .51904 .42527 L .50975 .40402 L p F P
0 0 0 r
s
.93 .273 .118 r
.50975 .40402 m .50815 .4058 L .51589 .42869 L p F P
0 0 0 r
s
.83 .24 .1 r
.51389 .43136 m
.51739 .42756 L
s
.24 .35 .67 r
.51295 .42832 m
.5189 .43051 L
s
.49965 .45196 m
.51295 .42832 L
s
.83 .24 .1 r
.38013 .44471 m
.35799 .45071 L
s
.24 .35 .67 r
.44372 .49306 m
.45344 .46565 L
s
.83 .24 .1 r
.51822 .68424 m
.53057 .66603 L
s
.56076 .46586 m
.57787 .48896 L
s
.291 .424 .825 r
.48388 .43843 m .47593 .43555 L .48351 .41675 L p F P
0 0 0 r
s
.83 .24 .1 r
.47389 .43481 m
.47816 .43002 L
s
.291 .424 .825 r
.48351 .41675 m .48895 .41876 L .48388 .43843 L p F P
0 0 0 r
s
.83 .24 .1 r
.48838 .41855 m
.49137 .4152 L
s
.264 .37 .707 r
.4649 .56651 m .44745 .56086 L .44968 .54046 L p F P
0 0 0 r
s
.264 .37 .707 r
.43282 .53489 m .44968 .54046 L .44745 .56086 L p F P
0 0 0 r
s
.271 .384 .736 r
.44968 .54046 m .43282 .53489 L .43731 .51404 L p F P
0 0 0 r
s
.883 .258 .112 r
.53705 .43787 m .54178 .43286 L .5286 .41488 L p F P
0 0 0 r
s
.883 .258 .112 r
.5286 .41488 m .5254 .41836 L .53705 .43787 L p F P
0 0 0 r
s
.83 .24 .1 r
.51739 .42756 m
.54035 .44515 L
s
.833 .243 .106 r
.55388 .45218 m .56009 .44577 L .54654 .42781 L p F P
0 0 0 r
s
.24 .35 .67 r
.54694 .44085 m
.54944 .43742 L
s
.833 .243 .106 r
.54654 .42781 m .54178 .43286 L .55388 .45218 L p F P
0 0 0 r
s
.24 .35 .67 r
.55158 .43448 m
.56166 .4206 L
s
.391 .108 .052 r
.57157 .5944 m .58234 .5847 L .58072 .56541 L p F P
0 0 0 r
s
.273 .073 .037 r
.56081 .62123 m .57136 .61188 L .57157 .5944 L p F P
0 0 0 r
s
.273 .073 .037 r
.58234 .5847 m .57157 .5944 L .57136 .61188 L p F P
0 0 0 r
s
.585 .167 .076 r
.59135 .50516 m .58169 .51442 L .58754 .53529 L p F P
0 0 0 r
s
.659 .189 .085 r
.58169 .51442 m .59135 .50516 L .58272 .48481 L p F P
0 0 0 r
s
.289 .419 .812 r
.45866 .45192 m .44827 .44822 L .45992 .42974 L p F P
0 0 0 r
s
.289 .419 .812 r
.45992 .42974 m .46794 .43265 L .45866 .45192 L p F P
0 0 0 r
s
.24 .35 .67 r
.46507 .4395 m
.49965 .45196 L
s
.254 .353 .671 r
.48183 .59142 m .4642 .58581 L .4649 .56651 L p F P
0 0 0 r
s
.254 .353 .671 r
.44745 .56086 m .4649 .56651 L .4642 .58581 L p F P
0 0 0 r
s
.24 .35 .67 r
.46453 .58501 m
.46639 .55948 L
s
.291 .428 .835 r
.51054 .42672 m .50516 .42474 L .50264 .40374 L p F P
0 0 0 r
s
.291 .428 .835 r
.50264 .40374 m .5054 .40477 L .51054 .42672 L p F P
0 0 0 r
s
.271 .384 .736 r
.42144 .50871 m .43731 .51404 L .43282 .53489 L p F P
0 0 0 r
s
.24 .35 .67 r
.43625 .52084 m
.47107 .53248 L
s
.278 .395 .76 r
.43731 .51404 m .42144 .50871 L .42885 .48808 L p F P
0 0 0 r
s
.24 .35 .67 r
.43625 .52084 m
.44372 .49306 L
s
.161 .046 .023 r
.54914 .64493 m .55923 .63611 L .56081 .62123 L p F P
0 0 0 r
s
.24 .35 .67 r
.53529 .62983 m
.55057 .6346 L
s
.83 .24 .1 r
.54913 .6348 m
.5585 .62652 L
s
.161 .046 .023 r
.57136 .61188 m .56081 .62123 L .55923 .63611 L p F P
0 0 0 r
s
.83 .24 .1 r
.5585 .62652 m
.56044 .60298 L
s
.24 .35 .67 r
.663 .70644 m
.65054 .6958 L
s
.61723 .68572 m
.65054 .6958 L
s
.391 .108 .052 r
.59145 .55556 m .58072 .56541 L .58234 .5847 L p F P
0 0 0 r
s
.497 .14 .065 r
.58072 .56541 m .59145 .55556 L .58754 .53529 L p F P
0 0 0 r
s
.83 .24 .1 r
.57812 .559 m
.58158 .58391 L
s
.93 .273 .118 r
.51904 .42527 m .52221 .42183 L .51136 .40223 L p F P
0 0 0 r
s
.93 .273 .118 r
.51136 .40223 m .50975 .40402 L .51904 .42527 L p F P
0 0 0 r
s
.24 .35 .67 r
.51295 .42832 m
.51824 .42082 L
s
.83 .24 .1 r
.50835 .42251 m
.51739 .42756 L
s
.291 .424 .825 r
.47593 .43555 m .46794 .43265 L .47805 .41474 L p F P
0 0 0 r
s
.291 .424 .825 r
.47805 .41474 m .48351 .41675 L .47593 .43555 L p F P
0 0 0 r
s
.282 .404 .78 r
.42526 .46339 m .43785 .46779 L .42885 .48808 L p F P
0 0 0 r
s
.286 .412 .798 r
.43785 .46779 m .42526 .46339 L .43783 .4445 L p F P
0 0 0 r
s
.286 .412 .798 r
.43783 .4445 m .44827 .44822 L .43785 .46779 L p F P
0 0 0 r
s
.291 .428 .835 r
.50516 .42474 m .49978 .42275 L .49989 .40271 L p F P
0 0 0 r
s
.291 .428 .835 r
.49989 .40271 m .50264 .40374 L .50516 .42474 L p F P
0 0 0 r
s
.221 .299 .561 r
.53269 .63986 m .51608 .63473 L .51651 .61979 L p F P
0 0 0 r
s
.221 .299 .561 r
.49928 .6144 m .51651 .61979 L .51608 .63473 L p F P
0 0 0 r
s
.278 .395 .76 r
.41439 .48312 m .42885 .48808 L .42144 .50871 L p F P
0 0 0 r
s
.282 .404 .78 r
.42885 .48808 m .41439 .48312 L .42526 .46339 L p F P
0 0 0 r
s
.24 .33 .624 r
.49928 .6144 m .48188 .60895 L .48183 .59142 L p F P
0 0 0 r
s
.24 .33 .624 r
.4642 .58581 m .48183 .59142 L .48188 .60895 L p F P
0 0 0 r
s
.83 .24 .1 r
.25776 .60854 m
.24203 .62739 L
s
.24777 .65357 m
.24203 .62739 L
s
.3063 .4992 m
.28972 .51995 L
s
.28972 .51995 m
.27909 .53997 L
s
.41672 .74641 m
.44076 .74215 L
s
.46001 .72534 m
.44076 .74215 L
s
.289 .419 .812 r
.44827 .44822 m .43783 .4445 L .45186 .42682 L p F P
0 0 0 r
s
.289 .419 .812 r
.45186 .42682 m .45992 .42974 L .44827 .44822 L p F P
0 0 0 r
s
.24 .35 .67 r
.45344 .46565 m
.46507 .4395 L
s
.57721 .40425 m
.611 .41719 L
s
.611 .41719 m
.62716 .40581 L
s
.291 .428 .835 r
.49978 .42275 m .49437 .42076 L .49712 .40167 L p F P
0 0 0 r
s
.291 .428 .835 r
.49712 .40167 m .49989 .40271 L .49978 .42275 L p F P
0 0 0 r
s
.084 .024 .01 r
.55923 .63611 m .54914 .64493 L .54667 .65648 L p F P
0 0 0 r
s
.194 .255 .473 r
.53269 .63986 m .54914 .64493 L .54667 .65648 L p F P
0 0 0 r
s
.883 .258 .112 r
.54178 .43286 m .54654 .42781 L .53182 .41138 L p F P
0 0 0 r
s
.883 .258 .112 r
.53182 .41138 m .5286 .41488 L .54178 .43286 L p F P
0 0 0 r
s
.24 .35 .67 r
.71001 .42599 m
.74249 .43872 L
s
.74249 .43872 m
.75866 .43916 L
s
.291 .424 .825 r
.46794 .43265 m .45992 .42974 L .47258 .41272 L p F P
0 0 0 r
s
.291 .424 .825 r
.47258 .41272 m .47805 .41474 L .46794 .43265 L p F P
0 0 0 r
s
.497 .14 .065 r
.59796 .52554 m .58754 .53529 L .59145 .55556 L p F P
0 0 0 r
s
.585 .167 .076 r
.58754 .53529 m .59796 .52554 L .59135 .50516 L p F P
0 0 0 r
s
.83 .24 .1 r
.56976 .5339 m
.59104 .51364 L
s
.93 .273 .118 r
.52221 .42183 m .5254 .41836 L .51297 .40043 L p F P
0 0 0 r
s
.93 .273 .118 r
.51297 .40043 m .51136 .40223 L .52221 .42183 L p F P
0 0 0 r
s
.723 .209 .093 r
.57986 .45721 m .57223 .46489 L .58272 .48481 L p F P
0 0 0 r
s
.781 .227 .1 r
.57223 .46489 m .57986 .45721 L .56637 .43928 L p F P
0 0 0 r
s
.781 .227 .1 r
.56637 .43928 m .56009 .44577 L .57223 .46489 L p F P
0 0 0 r
s
.264 .37 .707 r
.44745 .56086 m .42981 .55515 L .43282 .53489 L p F P
0 0 0 r
s
.264 .37 .707 r
.41578 .52928 m .43282 .53489 L .42981 .55515 L p F P
0 0 0 r
s
.271 .384 .736 r
.43282 .53489 m .41578 .52928 L .42144 .50871 L p F P
0 0 0 r
s
.24 .35 .67 r
.43129 .54804 m
.43625 .52084 L
s
.271 .384 .736 r
.40543 .50333 m .42144 .50871 L .41578 .52928 L p F P
0 0 0 r
s
.278 .395 .76 r
.42144 .50871 m .40543 .50333 L .41439 .48312 L p F P
0 0 0 r
s
.291 .428 .835 r
.49437 .42076 m .48895 .41876 L .49435 .40063 L p F P
0 0 0 r
s
.291 .428 .835 r
.49435 .40063 m .49712 .40167 L .49437 .42076 L p F P
0 0 0 r
s
.24 .35 .67 r
.58323 .67543 m
.57459 .65996 L
s
.833 .243 .106 r
.56009 .44577 m .56637 .43928 L .55135 .42272 L p F P
0 0 0 r
s
.833 .243 .106 r
.55135 .42272 m .54654 .42781 L .56009 .44577 L p F P
0 0 0 r
s
.659 .189 .085 r
.59154 .47615 m .58272 .48481 L .59135 .50516 L p F P
0 0 0 r
s
.83 .24 .1 r
.57787 .48896 m
.59104 .51364 L
s
.723 .209 .093 r
.58272 .48481 m .59154 .47615 L .57986 .45721 L p F P
0 0 0 r
s
.254 .353 .671 r
.4642 .58581 m .44639 .58014 L .44745 .56086 L p F P
0 0 0 r
s
.254 .353 .671 r
.42981 .55515 m .44745 .56086 L .44639 .58014 L p F P
0 0 0 r
s
.24 .35 .67 r
.43129 .54804 m
.46639 .55948 L
s
.282 .404 .78 r
.41257 .45896 m .42526 .46339 L .41439 .48312 L p F P
0 0 0 r
s
.286 .412 .798 r
.42526 .46339 m .41257 .45896 L .42732 .44076 L p F P
0 0 0 r
s
.286 .412 .798 r
.42732 .44076 m .43783 .4445 L .42526 .46339 L p F P
0 0 0 r
s
.289 .419 .812 r
.43783 .4445 m .42732 .44076 L .44376 .42388 L p F P
0 0 0 r
s
.289 .419 .812 r
.44376 .42388 m .45186 .42682 L .43783 .4445 L p F P
0 0 0 r
s
.291 .424 .825 r
.45992 .42974 m .45186 .42682 L .46709 .41069 L p F P
0 0 0 r
s
.291 .424 .825 r
.46709 .41069 m .47258 .41272 L .45992 .42974 L p F P
0 0 0 r
s
.83 .24 .1 r
.37254 .76154 m
.34603 .75463 L
s
.39065 .74501 m
.37254 .76154 L
s
.278 .395 .76 r
.3998 .47813 m .41439 .48312 L .40543 .50333 L p F P
0 0 0 r
s
.282 .404 .78 r
.41439 .48312 m .3998 .47813 L .41257 .45896 L p F P
0 0 0 r
s
.24 .35 .67 r
.40838 .48095 m
.44372 .49306 L
s
.291 .428 .835 r
.48895 .41876 m .48351 .41675 L .49158 .3996 L p F P
0 0 0 r
s
.291 .428 .835 r
.49158 .3996 m .49435 .40063 L .48895 .41876 L p F P
0 0 0 r
s
.93 .273 .118 r
.5254 .41836 m .5286 .41488 L .51459 .39863 L p F P
0 0 0 r
s
.93 .273 .118 r
.51459 .39863 m .51297 .40043 L .5254 .41836 L p F P
0 0 0 r
s
.221 .299 .561 r
.51608 .63473 m .4993 .62955 L .49928 .6144 L p F P
0 0 0 r
s
.24 .35 .67 r
.50082 .61908 m
.53529 .62983 L
s
.221 .299 .561 r
.48188 .60895 m .49928 .6144 L .4993 .62955 L p F P
0 0 0 r
s
.24 .35 .67 r
.49929 .59608 m
.50082 .61908 L
s
.83 .24 .1 r
.33879 .4618 m
.32157 .4833 L
s
.32157 .4833 m
.3063 .4992 L
s
.24 .35 .67 r
.69607 .71638 m
.71151 .72158 L
s
.663 .70644 m
.69607 .71638 L
s
.24 .33 .624 r
.48188 .60895 m .46431 .60345 L .4642 .58581 L p F P
0 0 0 r
s
.24 .35 .67 r
.46453 .58501 m
.49929 .59608 L
s
.24 .33 .624 r
.44639 .58014 m .4642 .58581 L .46431 .60345 L p F P
0 0 0 r
s
.883 .258 .112 r
.54654 .42781 m .55135 .42272 L .53506 .40786 L p F P
0 0 0 r
s
.24 .35 .67 r
.54016 .41251 m
.56166 .4206 L
s
.883 .258 .112 r
.53506 .40786 m .53182 .41138 L .54654 .42781 L p F P
0 0 0 r
s
.24 .35 .67 r
.62716 .40581 m
.6606 .4188 L
s
.6606 .4188 m
.67687 .41301 L
s
.585 .167 .076 r
.60117 .49575 m .59135 .50516 L .59796 .52554 L p F P
0 0 0 r
s
.659 .189 .085 r
.59135 .50516 m .60117 .49575 L .59154 .47615 L p F P
0 0 0 r
s
.83 .24 .1 r
.46001 .72534 m
.48108 .71585 L
s
.50115 .69848 m
.48108 .71585 L
s
.291 .428 .835 r
.48351 .41675 m .47805 .41474 L .48881 .39856 L p F P
0 0 0 r
s
.83 .24 .1 r
.48519 .41097 m
.48608 .4113 L
s
.291 .428 .835 r
.48881 .39856 m .49158 .3996 L .48351 .41675 L p F P
0 0 0 r
s
.24 .35 .67 r
.47826 .41553 m
.51295 .42832 L
s
.194 .255 .473 r
.54667 .65648 m .53104 .65171 L .53269 .63986 L p F P
0 0 0 r
s
.24 .35 .67 r
.53529 .62983 m
.54037 .64947 L
s
.83 .24 .1 r
.53057 .66603 m
.54286 .65532 L
s
.194 .255 .473 r
.51608 .63473 m .53269 .63986 L .53104 .65171 L p F P
0 0 0 r
s
.291 .424 .825 r
.45186 .42682 m .44376 .42388 L .46158 .40866 L p F P
0 0 0 r
s
.291 .424 .825 r
.46158 .40866 m .46709 .41069 L .45186 .42682 L p F P
0 0 0 r
s
.83 .24 .1 r
.46285 .40913 m
.46579 .40573 L
s
.24 .35 .67 r
.46507 .4395 m
.47826 .41553 L
s
.391 .108 .052 r
.58234 .5847 m .5933 .57483 L .59145 .55556 L p F P
0 0 0 r
s
.273 .073 .037 r
.57136 .61188 m .58209 .60236 L .58234 .5847 L p F P
0 0 0 r
s
.273 .073 .037 r
.5933 .57483 m .58234 .5847 L .58209 .60236 L p F P
0 0 0 r
s
.282 .404 .78 r
.39979 .45449 m .41257 .45896 L .3998 .47813 L p F P
0 0 0 r
s
.286 .412 .798 r
.41257 .45896 m .39979 .45449 L .41674 .43699 L p F P
0 0 0 r
s
.286 .412 .798 r
.41674 .43699 m .42732 .44076 L .41257 .45896 L p F P
0 0 0 r
s
.24 .35 .67 r
.41818 .45325 m
.45344 .46565 L
s
.289 .419 .812 r
.42732 .44076 m .41674 .43699 L .43562 .42093 L p F P
0 0 0 r
s
.289 .419 .812 r
.43562 .42093 m .44376 .42388 L .42732 .44076 L p F P
0 0 0 r
s
.24 .35 .67 r
.40838 .48095 m
.41818 .45325 L
s
.161 .046 .023 r
.55923 .63611 m .56948 .62713 L .57136 .61188 L p F P
0 0 0 r
s
.161 .046 .023 r
.58209 .60236 m .57136 .61188 L .56948 .62713 L p F P
0 0 0 r
s
.83 .24 .1 r
.56044 .60298 m
.58158 .58391 L
s
.264 .37 .707 r
.42981 .55515 m .412 .54939 L .41578 .52928 L p F P
0 0 0 r
s
.264 .37 .707 r
.39859 .5236 m .41578 .52928 L .412 .54939 L p F P
0 0 0 r
s
.271 .384 .736 r
.41578 .52928 m .39859 .5236 L .40543 .50333 L p F P
0 0 0 r
s
.271 .384 .736 r
.38928 .49789 m .40543 .50333 L .39859 .5236 L p F P
0 0 0 r
s
.24 .35 .67 r
.40071 .50897 m
.43625 .52084 L
s
.278 .395 .76 r
.40543 .50333 m .38928 .49789 L .3998 .47813 L p F P
0 0 0 r
s
.24 .35 .67 r
.40071 .50897 m
.40838 .48095 L
s
.93 .273 .118 r
.5286 .41488 m .53182 .41138 L .51621 .39682 L p F P
0 0 0 r
s
.24 .35 .67 r
.52521 .41094 m
.52556 .41044 L
s
.93 .273 .118 r
.51621 .39682 m .51459 .39863 L .5286 .41488 L p F P
0 0 0 r
s
.24 .35 .67 r
.52822 .40802 m
.5332 .40989 L
s
.291 .428 .835 r
.47805 .41474 m .47258 .41272 L .48603 .39751 L p F P
0 0 0 r
s
.83 .24 .1 r
.48059 .40926 m
.48147 .40959 L
s
.291 .428 .835 r
.48603 .39751 m .48881 .39856 L .47805 .41474 L p F P
0 0 0 r
s
.391 .108 .052 r
.60237 .54555 m .59145 .55556 L .5933 .57483 L p F P
0 0 0 r
s
.497 .14 .065 r
.59145 .55556 m .60237 .54555 L .59796 .52554 L p F P
0 0 0 r
s
.83 .24 .1 r
.27372 .56333 m
.25759 .58311 L
s
.25759 .58311 m
.25776 .60854 L
s
.781 .227 .1 r
.57272 .43273 m .56637 .43928 L .57986 .45721 L p F P
0 0 0 r
s
.833 .243 .106 r
.56637 .43928 m .57272 .43273 L .55619 .4176 L p F P
0 0 0 r
s
.833 .243 .106 r
.55619 .4176 m .55135 .42272 L .56637 .43928 L p F P
0 0 0 r
s
.24 .35 .67 r
.56166 .4206 m
.57721 .40425 L
s
.254 .353 .671 r
.44639 .58014 m .42839 .57442 L .42981 .55515 L p F P
0 0 0 r
s
.254 .353 .671 r
.412 .54939 m .42981 .55515 L .42839 .57442 L p F P
0 0 0 r
s
.24 .35 .67 r
.42906 .57372 m
.43129 .54804 L
s
.723 .209 .093 r
.58759 .44943 m .57986 .45721 L .59154 .47615 L p F P
0 0 0 r
s
.781 .227 .1 r
.57986 .45721 m .58759 .44943 L .57272 .43273 L p F P
0 0 0 r
s
.278 .395 .76 r
.3851 .47308 m .3998 .47813 L .38928 .49789 L p F P
0 0 0 r
s
.282 .404 .78 r
.3998 .47813 m .3851 .47308 L .39979 .45449 L p F P
0 0 0 r
s
.24 .35 .67 r
.75866 .43916 m
.79087 .45184 L
s
.80587 .4584 m
.79087 .45184 L
s
.62925 .69629 m
.61723 .68572 L
s
.58323 .67543 m
.61723 .68572 L
s
.291 .424 .825 r
.44376 .42388 m .43562 .42093 L .45606 .40662 L p F P
0 0 0 r
s
.291 .424 .825 r
.45606 .40662 m .46158 .40866 L .44376 .42388 L p F P
0 0 0 r
s
.83 .24 .1 r
.26374 .63504 m
.24777 .65357 L
s
.25909 .67945 m
.24777 .65357 L
s
.291 .428 .835 r
.47258 .41272 m .46709 .41069 L .48324 .39647 L p F P
0 0 0 r
s
.83 .24 .1 r
.47597 .40755 m
.47686 .40788 L
s
.291 .428 .835 r
.48324 .39647 m .48603 .39751 L .47258 .41272 L p F P
0 0 0 r
s
.29 .429 .84 r
.5 .38446 m .50815 .4058 L .5054 .40477 L closepath p F P
0 0 0 r
s
.975 .287 .123 r
.5 .38446 m .50815 .4058 L .50975 .40402 L closepath p F P
0 0 0 r
s
.883 .258 .112 r
.55135 .42272 m .55619 .4176 L .53832 .40433 L p F P
0 0 0 r
s
.883 .258 .112 r
.53832 .40433 m .53506 .40786 L .55135 .42272 L p F P
0 0 0 r
s
.084 .024 .01 r
.54667 .65648 m .55623 .64819 L .55923 .63611 L p F P
0 0 0 r
s
.83 .24 .1 r
.5466 .65206 m
.55134 .64794 L
s
.24 .35 .67 r
.54037 .64947 m
.54814 .65185 L
s
.551 .65273 m
.57459 .65996 L
s
.084 .024 .01 r
.56948 .62713 m .55923 .63611 L .55623 .64819 L p F P
0 0 0 r
s
.83 .24 .1 r
.55134 .64794 m
.5585 .62652 L
s
.221 .299 .561 r
.4993 .62955 m .48236 .62432 L .48188 .60895 L p F P
0 0 0 r
s
.221 .299 .561 r
.46431 .60345 m .48188 .60895 L .48236 .62432 L p F P
0 0 0 r
s
.286 .412 .798 r
.40611 .4332 m .41674 .43699 L .39979 .45449 L p F P
0 0 0 r
s
.289 .419 .812 r
.41674 .43699 m .40611 .4332 L .42745 .41797 L p F P
0 0 0 r
s
.289 .419 .812 r
.42745 .41797 m .43562 .42093 L .41674 .43699 L p F P
0 0 0 r
s
.24 .35 .67 r
.41818 .45325 m
.4298 .42679 L
s
.4298 .42679 m
.46507 .4395 L
s
.659 .189 .085 r
.60049 .46737 m .59154 .47615 L .60117 .49575 L p F P
0 0 0 r
s
.723 .209 .093 r
.59154 .47615 m .60049 .46737 L .58759 .44943 L p F P
0 0 0 r
s
.83 .24 .1 r
.57787 .48896 m
.59955 .46767 L
s
.93 .273 .118 r
.53182 .41138 m .53506 .40786 L .51784 .39501 L p F P
0 0 0 r
s
.24 .35 .67 r
.52767 .40751 m
.52811 .40704 L
s
.93 .273 .118 r
.51784 .39501 m .51621 .39682 L .53182 .41138 L p F P
0 0 0 r
s
.83 .24 .1 r
.50115 .69848 m
.51822 .68424 L
s
.53904 .66623 m
.51822 .68424 L
s
.29 .429 .84 r
.5 .38446 m .5054 .40477 L .50264 .40374 L closepath p F P
0 0 0 r
s
.497 .14 .065 r
.60855 .51561 m .59796 .52554 L .60237 .54555 L p F P
0 0 0 r
s
.83 .24 .1 r
.57812 .559 m
.59972 .53902 L
s
.585 .167 .076 r
.59796 .52554 m .60855 .51561 L .60117 .49575 L p F P
0 0 0 r
s
.83 .24 .1 r
.59104 .51364 m
.59972 .53902 L
s
.282 .404 .78 r
.38692 .44999 m .39979 .45449 L .3851 .47308 L p F P
0 0 0 r
s
.286 .412 .798 r
.39979 .45449 m .38692 .44999 L .40611 .4332 L p F P
0 0 0 r
s
.24 .33 .624 r
.46431 .60345 m .44655 .59789 L .44639 .58014 L p F P
0 0 0 r
s
.24 .33 .624 r
.42839 .57442 m .44639 .58014 L .44655 .59789 L p F P
0 0 0 r
s
.291 .428 .835 r
.46709 .41069 m .46158 .40866 L .48045 .39542 L p F P
0 0 0 r
s
.83 .24 .1 r
.47134 .40584 m
.47223 .40617 L
s
.46583 .40568 m
.46707 .40425 L
s
.291 .428 .835 r
.48045 .39542 m .48324 .39647 L .46709 .41069 L p F P
0 0 0 r
s
.83 .24 .1 r
.46707 .40425 m
.46759 .40445 L
s
.975 .287 .123 r
.5 .38446 m .50975 .40402 L .51136 .40223 L closepath p F P
0 0 0 r
s
.29 .429 .84 r
.5 .38446 m .50264 .40374 L .49989 .40271 L closepath p F P
0 0 0 r
s
.291 .424 .825 r
.43562 .42093 m .42745 .41797 L .45051 .40458 L p F P
0 0 0 r
s
.291 .424 .825 r
.45051 .40458 m .45606 .40662 L .43562 .42093 L p F P
0 0 0 r
s
.194 .255 .473 r
.53104 .65171 m .51526 .6469 L .51608 .63473 L p F P
0 0 0 r
s
.194 .255 .473 r
.4993 .62955 m .51608 .63473 L .51526 .6469 L p F P
0 0 0 r
s
.83 .24 .1 r
.34603 .75463 m
.32014 .74226 L
s
.36381 .73785 m
.34603 .75463 L
s
.24 .35 .67 r
.67687 .41301 m
.71001 .42599 L
s
.71001 .42599 m
.72579 .42621 L
s
.271 .384 .736 r
.39859 .5236 m .38122 .51788 L .38928 .49789 L p F P
0 0 0 r
s
.271 .384 .736 r
.37297 .49241 m .38928 .49789 L .38122 .51788 L p F P
0 0 0 r
s
.278 .395 .76 r
.38928 .49789 m .37297 .49241 L .3851 .47308 L p F P
0 0 0 r
s
.29 .429 .84 r
.5 .38446 m .49989 .40271 L .49712 .40167 L closepath p F P
0 0 0 r
s
.264 .37 .707 r
.412 .54939 m .39401 .54356 L .39859 .5236 L p F P
0 0 0 r
s
.264 .37 .707 r
.38122 .51788 m .39859 .5236 L .39401 .54356 L p F P
0 0 0 r
s
.24 .35 .67 r
.39547 .53636 m
.40071 .50897 L
s
.83 .24 .1 r
.39065 .74501 m
.41672 .74641 L
s
.43577 .72948 m
.41672 .74641 L
s
.975 .287 .123 r
.5 .38446 m .51136 .40223 L .51297 .40043 L closepath p F P
0 0 0 r
s
.291 .428 .835 r
.46158 .40866 m .45606 .40662 L .47766 .39438 L p F P
0 0 0 r
s
.83 .24 .1 r
.46663 .40417 m
.46707 .40425 L
s
.291 .428 .835 r
.47766 .39438 m .48045 .39542 L .46158 .40866 L p F P
0 0 0 r
s
.278 .395 .76 r
.37027 .468 m .3851 .47308 L .37297 .49241 L p F P
0 0 0 r
s
.282 .404 .78 r
.3851 .47308 m .37027 .468 L .38692 .44999 L p F P
0 0 0 r
s
.29 .429 .84 r
.5 .38446 m .49712 .40167 L .49435 .40063 L closepath p F P
0 0 0 r
s
.93 .273 .118 r
.53506 .40786 m .53832 .40433 L .51947 .3932 L p F P
0 0 0 r
s
.24 .35 .67 r
.53048 .40444 m
.53092 .40396 L
s
.93 .273 .118 r
.51947 .3932 m .51784 .39501 L .53506 .40786 L p F P
0 0 0 r
s
.83 .24 .1 r
.51739 .42756 m
.53796 .40522 L
s
.286 .412 .798 r
.39541 .42939 m .40611 .4332 L .38692 .44999 L p F P
0 0 0 r
s
.289 .419 .812 r
.40611 .4332 m .39541 .42939 L .41923 .41499 L p F P
0 0 0 r
s
.83 .24 .1 r
.41396 .4223 m
.42166 .4221 L
s
.289 .419 .812 r
.41923 .41499 m .42745 .41797 L .40611 .4332 L p F P
0 0 0 r
s
.83 .24 .1 r
.39824 .42271 m
.40683 .42249 L
s
.254 .353 .671 r
.42839 .57442 m .41021 .56863 L .412 .54939 L p F P
0 0 0 r
s
.254 .353 .671 r
.39401 .54356 m .412 .54939 L .41021 .56863 L p F P
0 0 0 r
s
.24 .35 .67 r
.39547 .53636 m
.43129 .54804 L
s
.781 .227 .1 r
.57913 .42611 m .57272 .43273 L .58759 .44943 L p F P
0 0 0 r
s
.833 .243 .106 r
.57272 .43273 m .57913 .42611 L .56107 .41243 L p F P
0 0 0 r
s
.833 .243 .106 r
.56107 .41243 m .55619 .4176 L .57272 .43273 L p F P
0 0 0 r
s
.83 .24 .1 r
.54035 .44515 m
.56129 .42317 L
s
.291 .424 .825 r
.42745 .41797 m .41923 .41499 L .44495 .40253 L p F P
0 0 0 r
s
.291 .424 .825 r
.44495 .40253 m .45051 .40458 L .42745 .41797 L p F P
0 0 0 r
s
.83 .24 .1 r
.4349 .4074 m
.4355 .40669 L
s
.29 .429 .84 r
.5 .38446 m .49435 .40063 L .49158 .3996 L closepath p F P
0 0 0 r
s
.975 .287 .123 r
.5 .38446 m .51297 .40043 L .51459 .39863 L closepath p F P
0 0 0 r
s
.585 .167 .076 r
.61115 .48619 m .60117 .49575 L .60855 .51561 L p F P
0 0 0 r
s
.659 .189 .085 r
.60117 .49575 m .61115 .48619 L .60049 .46737 L p F P
0 0 0 r
s
.883 .258 .112 r
.55619 .4176 m .56107 .41243 L .5416 .40077 L p F P
0 0 0 r
s
.883 .258 .112 r
.5416 .40077 m .53832 .40433 L .55619 .4176 L p F P
0 0 0 r
s
.83 .24 .1 r
.29569 .51931 m
.27909 .53997 L
s
.27909 .53997 m
.27372 .56333 L
s
.291 .428 .835 r
.45606 .40662 m .45051 .40458 L .47486 .39333 L p F P
0 0 0 r
s
.83 .24 .1 r
.46099 .40313 m
.46192 .4033 L
s
.291 .428 .835 r
.47486 .39333 m .47766 .39438 L .45606 .40662 L p F P
0 0 0 r
s
.83 .24 .1 r
.53796 .40522 m
.56129 .42317 L
s
.282 .404 .78 r
.37395 .44546 m .38692 .44999 L .37027 .468 L p F P
0 0 0 r
s
.286 .412 .798 r
.38692 .44999 m .37395 .44546 L .39541 .42939 L p F P
0 0 0 r
s
.83 .24 .1 r
.38844 .43461 m
.39824 .42271 L
s
.29 .429 .84 r
.5 .38446 m .49158 .3996 L .48881 .39856 L closepath p F P
0 0 0 r
s
.723 .209 .093 r
.59541 .44156 m .58759 .44943 L .60049 .46737 L p F P
0 0 0 r
s
.781 .227 .1 r
.58759 .44943 m .59541 .44156 L .57913 .42611 L p F P
0 0 0 r
s
.83 .24 .1 r
.56129 .42317 m
.58206 .44424 L
s
.56076 .46586 m
.58206 .44424 L
s
.221 .299 .561 r
.48236 .62432 m .46525 .61904 L .46431 .60345 L p F P
0 0 0 r
s
.24 .35 .67 r
.46564 .60811 m
.50082 .61908 L
s
.221 .299 .561 r
.44655 .59789 m .46431 .60345 L .46525 .61904 L p F P
0 0 0 r
s
.24 .35 .67 r
.46453 .58501 m
.46564 .60811 L
s
.83 .24 .1 r
.27536 .66127 m
.25909 .67945 L
s
.2755 .70368 m
.25909 .67945 L
s
.975 .287 .123 r
.5 .38446 m .51459 .39863 L .51621 .39682 L closepath p F P
0 0 0 r
s
.153 .191 .345 r
.53104 .65171 m .54667 .65648 L .54304 .6647 L p F P
0 0 0 r
s
.083 .024 .01 r
.55623 .64819 m .54667 .65648 L .54304 .6647 L p F P
0 0 0 r
s
.29 .429 .84 r
.5 .38446 m .48881 .39856 L .48603 .39751 L closepath p F P
0 0 0 r
s
.391 .108 .052 r
.5933 .57483 m .60446 .56478 L .60237 .54555 L p F P
0 0 0 r
s
.273 .073 .037 r
.58209 .60236 m .59301 .59268 L .5933 .57483 L p F P
0 0 0 r
s
.273 .073 .037 r
.60446 .56478 m .5933 .57483 L .59301 .59268 L p F P
0 0 0 r
s
.291 .428 .835 r
.45051 .40458 m .44495 .40253 L .47205 .39228 L p F P
0 0 0 r
s
.291 .428 .835 r
.47205 .39228 m .47486 .39333 L .45051 .40458 L p F P
0 0 0 r
s
.24 .35 .67 r
.67802 .71152 m
.663 .70644 L
s
.62925 .69629 m
.663 .70644 L
s
.93 .273 .118 r
.53832 .40433 m .5416 .40077 L .5211 .39138 L p F P
0 0 0 r
s
.24 .35 .67 r
.5333 .40136 m
.53374 .40088 L
s
.93 .273 .118 r
.5211 .39138 m .51947 .3932 L .53832 .40433 L p F P
0 0 0 r
s
.289 .419 .812 r
.41098 .41199 m .41923 .41499 L .39541 .42939 L p F P
0 0 0 r
s
.291 .424 .825 r
.41923 .41499 m .41098 .41199 L .43937 .40047 L p F P
0 0 0 r
s
.291 .424 .825 r
.43937 .40047 m .44495 .40253 L .41923 .41499 L p F P
0 0 0 r
s
.24 .33 .624 r
.44655 .59789 m .42862 .59227 L .42839 .57442 L p F P
0 0 0 r
s
.24 .35 .67 r
.42906 .57372 m
.46453 .58501 L
s
.24 .33 .624 r
.41021 .56863 m .42839 .57442 L .42862 .59227 L p F P
0 0 0 r
s
.24 .35 .67 r
.59302 .39257 m
.62716 .40581 L
s
.62716 .40581 m
.64304 .39975 L
s
.161 .046 .023 r
.56948 .62713 m .57992 .618 L .58209 .60236 L p F P
0 0 0 r
s
.161 .046 .023 r
.59301 .59268 m .58209 .60236 L .57992 .618 L p F P
0 0 0 r
s
.83 .24 .1 r
.57986 .60765 m
.58158 .58391 L
s
.29 .429 .84 r
.5 .38446 m .48603 .39751 L .48324 .39647 L closepath p F P
0 0 0 r
s
.286 .412 .798 r
.38464 .42556 m .39541 .42939 L .37395 .44546 L p F P
0 0 0 r
s
.24 .35 .67 r
.3822 .4406 m
.41818 .45325 L
s
.289 .419 .812 r
.39541 .42939 m .38464 .42556 L .41098 .41199 L p F P
0 0 0 r
s
.194 .255 .473 r
.51526 .6469 m .49934 .64204 L .4993 .62955 L p F P
0 0 0 r
s
.24 .35 .67 r
.50082 .61908 m
.50544 .63876 L
s
.194 .255 .473 r
.48236 .62432 m .4993 .62955 L .49934 .64204 L p F P
0 0 0 r
s
.975 .287 .123 r
.5 .38446 m .51621 .39682 L .51784 .39501 L closepath p F P
0 0 0 r
s
.271 .384 .736 r
.38122 .51788 m .36368 .51209 L .37297 .49241 L p F P
0 0 0 r
s
.271 .384 .736 r
.35652 .48688 m .37297 .49241 L .36368 .51209 L p F P
0 0 0 r
s
.24 .35 .67 r
.36445 .49685 m
.40071 .50897 L
s
.278 .395 .76 r
.37297 .49241 m .35652 .48688 L .37027 .468 L p F P
0 0 0 r
s
.24 .35 .67 r
.37231 .46858 m
.40838 .48095 L
s
.83 .24 .1 r
.32014 .74226 m
.29621 .72498 L
s
.33754 .72517 m
.32014 .74226 L
s
.391 .108 .052 r
.61348 .53535 m .60237 .54555 L .60446 .56478 L p F P
0 0 0 r
s
.497 .14 .065 r
.60237 .54555 m .61348 .53535 L .60855 .51561 L p F P
0 0 0 r
s
.83 .24 .1 r
.59972 .53902 m
.60347 .56417 L
s
.29 .429 .84 r
.5 .38446 m .48324 .39647 L .48045 .39542 L closepath p F P
0 0 0 r
s
.278 .395 .76 r
.35532 .46288 m .37027 .468 L .35652 .48688 L p F P
0 0 0 r
s
.282 .404 .78 r
.37027 .468 m .35532 .46288 L .37395 .44546 L p F P
0 0 0 r
s
.264 .37 .707 r
.39401 .54356 m .37583 .53768 L .38122 .51788 L p F P
0 0 0 r
s
.264 .37 .707 r
.36368 .51209 m .38122 .51788 L .37583 .53768 L p F P
0 0 0 r
s
.291 .428 .835 r
.44495 .40253 m .43937 .40047 L .46925 .39123 L p F P
0 0 0 r
s
.291 .428 .835 r
.46925 .39123 m .47205 .39228 L .44495 .40253 L p F P
0 0 0 r
s
.24 .35 .67 r
.44286 .40248 m
.47826 .41553 L
s
.36445 .49685 m
.37231 .46858 L
s
.37231 .46858 m
.3822 .4406 L
s
.659 .189 .085 r
.60957 .45845 m .60049 .46737 L .61115 .48619 L p F P
0 0 0 r
s
.723 .209 .093 r
.60049 .46737 m .60957 .45845 L .59541 .44156 L p F P
0 0 0 r
s
.83 .24 .1 r
.58206 .44424 m
.59955 .46767 L
s
.29 .429 .84 r
.5 .38446 m .48045 .39542 L .47766 .39438 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.47826 .41553 m
.49257 .39461 L
s
.282 .404 .78 r
.36089 .4409 m .37395 .44546 L .35532 .46288 L p F P
0 0 0 r
s
.83 .24 .1 r
.35799 .45071 m
.35859 .44997 L
s
.286 .412 .798 r
.37395 .44546 m .36089 .4409 L .38464 .42556 L p F P
0 0 0 r
s
.833 .243 .106 r
.56599 .40721 m .56107 .41243 L .57913 .42611 L p F P
0 0 0 r
s
.883 .258 .112 r
.56107 .41243 m .56599 .40721 L .54489 .39719 L p F P
0 0 0 r
s
.883 .258 .112 r
.54489 .39719 m .5416 .40077 L .56107 .41243 L p F P
0 0 0 r
s
.975 .287 .123 r
.5 .38446 m .51784 .39501 L .51947 .3932 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.49257 .39461 m
.51355 .4025 L
s
1 .324 .136 r
.44238 .39689 m .43937 .40047 L .41098 .41199 L p F P
0 0 0 r
s
1 .324 .136 r
.41098 .41199 m .41529 .40678 L .44238 .39689 L p F P
0 0 0 r
s
.24 .35 .67 r
.4298 .42679 m
.44286 .40248 L
s
1 .332 .138 r
.41529 .40678 m .41098 .41199 L .38464 .42556 L p F P
0 0 0 r
s
.084 .024 .01 r
.55623 .64819 m .56593 .63977 L .56948 .62713 L p F P
0 0 0 r
s
.084 .024 .01 r
.57992 .618 m .56948 .62713 L .56593 .63977 L p F P
0 0 0 r
s
.83 .24 .1 r
.5585 .62652 m
.57986 .60765 L
s
.29212 .68587 m
.2755 .70368 L
s
.29621 .72498 m
.2755 .70368 L
s
.254 .353 .671 r
.41021 .56863 m .39184 .56279 L .39401 .54356 L p F P
0 0 0 r
s
.254 .353 .671 r
.37583 .53768 m .39401 .54356 L .39184 .56279 L p F P
0 0 0 r
s
.24 .35 .67 r
.39287 .56219 m
.39547 .53636 L
s
.29 .429 .84 r
.5 .38446 m .47766 .39438 L .47486 .39333 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.27406 .58902 m
.25776 .60854 L
s
.25776 .60854 m
.26374 .63504 L
s
.3063 .4992 m
.29569 .51931 L
s
.93 .273 .118 r
.5416 .40077 m .54489 .39719 L .52274 .38955 L p F P
0 0 0 r
s
.24 .35 .67 r
.53613 .39826 m
.53657 .39778 L
s
.93 .273 .118 r
.52274 .38955 m .5211 .39138 L .5416 .40077 L p F P
0 0 0 r
s
.83 .24 .1 r
.43577 .72948 m
.46001 .72534 L
s
.47997 .70792 m
.46001 .72534 L
s
.781 .227 .1 r
.58561 .41942 m .57913 .42611 L .59541 .44156 L p F P
0 0 0 r
s
.833 .243 .106 r
.57913 .42611 m .58561 .41942 L .56599 .40721 L p F P
0 0 0 r
s
.24 .35 .67 r
.72579 .42621 m
.75866 .43916 L
s
.75866 .43916 m
.77326 .44557 L
s
1 .313 .132 r
.47081 .3894 m .46925 .39123 L .43937 .40047 L p F P
0 0 0 r
s
1 .313 .132 r
.43937 .40047 m .44238 .39689 L .47081 .3894 L p F P
0 0 0 r
s
.83 .24 .1 r
.43817 .40351 m
.44152 .39954 L
s
.44152 .39954 m
.45095 .40128 L
s
.24 .35 .67 r
.43664 .40019 m
.44286 .40248 L
s
.497 .14 .065 r
.61932 .50552 m .60855 .51561 L .61348 .53535 L p F P
0 0 0 r
s
.585 .167 .076 r
.60855 .51561 m .61932 .50552 L .61115 .48619 L p F P
0 0 0 r
s
.83 .24 .1 r
.31321 .70755 m
.29621 .72498 L
s
.24 .35 .67 r
.5948 .68593 m
.58323 .67543 L
s
.54854 .66493 m
.58323 .67543 L
s
1 .332 .138 r
.38464 .42556 m .3901 .41886 L .41529 .40678 L p F P
0 0 0 r
s
.24 .35 .67 r
.3938 .41382 m
.39769 .41522 L
s
.40109 .41645 m
.4298 .42679 L
s
.39201 .41794 m
.3938 .41382 L
s
1 .331 .136 r
.3901 .41886 m .38464 .42556 L .36089 .4409 L p F P
0 0 0 r
s
.24 .35 .67 r
.3822 .4406 m
.39047 .42151 L
s
.29 .429 .84 r
.5 .38446 m .47486 .39333 L .47205 .39228 L closepath p F P
0 0 0 r
s
.975 .287 .123 r
.5 .38446 m .51947 .3932 L .5211 .39138 L closepath p F P
0 0 0 r
s
.153 .191 .345 r
.54304 .6647 m .52861 .66034 L .53104 .65171 L p F P
0 0 0 r
s
.83 .24 .1 r
.53904 .66623 m
.54057 .66396 L
s
.153 .191 .345 r
.51526 .6469 m .53104 .65171 L .52861 .66034 L p F P
0 0 0 r
s
.24 .35 .67 r
.50544 .63876 m
.54037 .64947 L
s
.29 .429 .84 r
.5 .38446 m .47205 .39228 L .46925 .39123 L closepath p F P
0 0 0 r
s
.221 .299 .561 r
.46525 .61904 m .44797 .61371 L .44655 .59789 L p F P
0 0 0 r
s
.221 .299 .561 r
.42862 .59227 m .44655 .59789 L .44797 .61371 L p F P
0 0 0 r
s
.975 .287 .123 r
.5 .38446 m .5211 .39138 L .52274 .38955 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.5007 .40473 m
.51291 .39105 L
s
1 .3 .128 r
.46925 .39123 m .47081 .3894 L .5 .38446 L closepath p F P
0 0 0 r
s
.723 .209 .093 r
.60334 .43358 m .59541 .44156 L .60957 .45845 L p F P
0 0 0 r
s
.781 .227 .1 r
.59541 .44156 m .60334 .43358 L .58561 .41942 L p F P
0 0 0 r
s
.194 .255 .473 r
.49934 .64204 m .48326 .63714 L .48236 .62432 L p F P
0 0 0 r
s
.194 .255 .473 r
.46525 .61904 m .48236 .62432 L .48326 .63714 L p F P
0 0 0 r
s
.278 .395 .76 r
.35652 .48688 m .33991 .4813 L .35532 .46288 L p F P
0 0 0 r
s
.278 .395 .76 r
.34024 .45771 m .35532 .46288 L .33991 .4813 L p F P
0 0 0 r
s
.83 .24 .1 r
.33879 .4618 m
.34019 .46099 L
s
.34378 .45892 m
.35799 .45071 L
s
.282 .404 .78 r
.35532 .46288 m .34024 .45771 L .36089 .4409 L p F P
0 0 0 r
s
.24 .33 .624 r
.42862 .59227 m .41049 .5866 L .41021 .56863 L p F P
0 0 0 r
s
.24 .33 .624 r
.39184 .56279 m .41021 .56863 L .41049 .5866 L p F P
0 0 0 r
s
.271 .384 .736 r
.36368 .51209 m .34597 .50625 L .35652 .48688 L p F P
0 0 0 r
s
.271 .384 .736 r
.33991 .4813 m .35652 .48688 L .34597 .50625 L p F P
0 0 0 r
s
.883 .258 .112 r
.5482 .39359 m .54489 .39719 L .56599 .40721 L p F P
0 0 0 r
s
.93 .273 .118 r
.54489 .39719 m .5482 .39359 L .52439 .38772 L p F P
0 0 0 r
s
.24 .35 .67 r
.53898 .39515 m
.53942 .39466 L
s
.93 .273 .118 r
.52439 .38772 m .52274 .38955 L .54489 .39719 L p F P
0 0 0 r
s
.24 .35 .67 r
.54184 .39202 m
.54273 .39105 L
s
.83 .24 .1 r
.51291 .39105 m
.53796 .40522 L
s
.24 .35 .67 r
.54273 .39105 m
.57721 .40425 L
s
1 .331 .136 r
.36089 .4409 m .36733 .43291 L .3901 .41886 L p F P
0 0 0 r
s
.24 .35 .67 r
.36828 .4357 m
.3822 .4406 L
s
1 .316 .128 r
.36733 .43291 m .36089 .4409 L .34024 .45771 L p F P
0 0 0 r
s
1 .313 .132 r
.47238 .38757 m .47081 .3894 L .44238 .39689 L p F P
0 0 0 r
s
1 .313 .132 r
.44238 .39689 m .44541 .39329 L .47238 .38757 L p F P
0 0 0 r
s
1 .324 .136 r
.44541 .39329 m .44238 .39689 L .41529 .40678 L p F P
0 0 0 r
s
.585 .167 .076 r
.62129 .47647 m .61115 .48619 L .61932 .50552 L p F P
0 0 0 r
s
.83 .24 .1 r
.59104 .51364 m
.61308 .49266 L
s
.659 .189 .085 r
.61115 .48619 m .62129 .47647 L .60957 .45845 L p F P
0 0 0 r
s
.83 .24 .1 r
.59955 .46767 m
.61308 .49266 L
s
.264 .37 .707 r
.37583 .53768 m .35747 .53173 L .36368 .51209 L p F P
0 0 0 r
s
.264 .37 .707 r
.34597 .50625 m .36368 .51209 L .35747 .53173 L p F P
0 0 0 r
s
.24 .35 .67 r
.35891 .52445 m
.36445 .49685 L
s
.83 .24 .1 r
.36381 .73785 m
.39065 .74501 L
s
.40942 .72789 m
.39065 .74501 L
s
.833 .243 .106 r
.57095 .40196 m .56599 .40721 L .58561 .41942 L p F P
0 0 0 r
s
.883 .258 .112 r
.56599 .40721 m .57095 .40196 L .5482 .39359 L p F P
0 0 0 r
s
.975 .287 .123 r
.5 .38446 m .52274 .38955 L .52439 .38772 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.64304 .39975 m
.67687 .41301 L
s
.67687 .41301 m
.69223 .413 L
s
1 .3 .128 r
.47081 .3894 m .47238 .38757 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .324 .136 r
.41529 .40678 m .41964 .40152 L .44541 .39329 L p F P
0 0 0 r
s
.24 .35 .67 r
.44286 .40248 m
.448 .39473 L
s
1 .332 .138 r
.41964 .40152 m .41529 .40678 L .3901 .41886 L p F P
0 0 0 r
s
.24 .35 .67 r
.71151 .72158 m
.72891 .72076 L
s
.67802 .71152 m
.71151 .72158 L
s
.83 .24 .1 r
.33879 .4618 m
.34021 .46004 L
s
.083 .024 .01 r
.54304 .6647 m .55181 .65713 L .55623 .64819 L p F P
0 0 0 r
s
.24 .35 .67 r
.54037 .64947 m
.54584 .65981 L
s
.54736 .6627 m
.54854 .66493 L
s
.83 .24 .1 r
.5431 .66019 m
.55134 .64794 L
s
.24 .35 .67 r
.54673 .66151 m
.54736 .6627 L
s
.083 .024 .01 r
.56593 .63977 m .55623 .64819 L .55181 .65713 L p F P
0 0 0 r
s
.254 .353 .671 r
.39184 .56279 m .37328 .55688 L .37583 .53768 L p F P
0 0 0 r
s
.254 .353 .671 r
.35747 .53173 m .37583 .53768 L .37328 .55688 L p F P
0 0 0 r
s
.24 .35 .67 r
.35891 .52445 m
.39547 .53636 L
s
.93 .273 .118 r
.52604 .38588 m .52439 .38772 L .5482 .39359 L p F P
0 0 0 r
s
.975 .287 .123 r
.5 .38446 m .52439 .38772 L .52604 .38588 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.47238 .38757 m .47396 .38573 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .313 .132 r
.47396 .38573 m .47238 .38757 L .44541 .39329 L p F P
0 0 0 r
s
.83 .24 .1 r
.47997 .70792 m
.50115 .69848 L
s
.52195 .68048 m
.50115 .69848 L
s
.781 .227 .1 r
.59216 .41266 m .58561 .41942 L .60334 .43358 L p F P
0 0 0 r
s
.833 .243 .106 r
.58561 .41942 m .59216 .41266 L .57095 .40196 L p F P
0 0 0 r
s
.883 .258 .112 r
.55153 .38997 m .5482 .39359 L .57095 .40196 L p F P
0 0 0 r
s
.93 .273 .118 r
.5482 .39359 m .55153 .38997 L .52604 .38588 L p F P
0 0 0 r
s
.975 .287 .123 r
.5 .38446 m .52935 .3822 L .53101 .38034 L closepath p F P
0 0 0 r
s
.975 .287 .123 r
.5 .38446 m .52604 .38588 L .52769 .38404 L closepath p F P
0 0 0 r
s
.975 .287 .123 r
.5 .38446 m .52769 .38404 L .52935 .3822 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.48351 .3746 m .48512 .37273 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.48191 .37647 m .48351 .3746 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.48031 .37833 m .48191 .37647 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.47871 .38019 m .48031 .37833 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.47713 .38204 m .47871 .38019 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.47554 .38389 m .47713 .38204 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.47396 .38573 m .47554 .38389 L .5 .38446 L closepath p F P
0 0 0 r
s
.285 .426 .838 r
.51423 .37389 m .51142 .37281 L .5 .38446 L closepath p F P
0 0 0 r
s
.285 .426 .838 r
.51704 .37497 m .51423 .37389 L .5 .38446 L closepath p F P
0 0 0 r
s
.285 .426 .838 r
.51984 .37605 m .51704 .37497 L .5 .38446 L closepath p F P
0 0 0 r
s
.285 .426 .838 r
.52264 .37712 m .51984 .37605 L .5 .38446 L closepath p F P
0 0 0 r
s
.285 .426 .838 r
.52544 .3782 m .52264 .37712 L .5 .38446 L closepath p F P
0 0 0 r
s
.285 .426 .838 r
.52823 .37927 m .52544 .3782 L .5 .38446 L closepath p F P
0 0 0 r
s
.285 .426 .838 r
.53101 .38034 m .52823 .37927 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.48997 .36707 m .49159 .36518 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.48835 .36896 m .48997 .36707 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.48673 .37085 m .48835 .36896 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.48512 .37273 m .48673 .37085 L .5 .38446 L closepath p F P
0 0 0 r
s
.285 .426 .838 r
.49444 .36627 m .49159 .36518 L .5 .38446 L closepath p F P
0 0 0 r
s
.285 .426 .838 r
.49728 .36737 m .49444 .36627 L .5 .38446 L closepath p F P
0 0 0 r
s
.285 .426 .838 r
.50012 .36846 m .49728 .36737 L .5 .38446 L closepath p F P
0 0 0 r
s
.285 .426 .838 r
.50295 .36955 m .50012 .36846 L .5 .38446 L closepath p F P
0 0 0 r
s
.285 .426 .838 r
.50578 .37064 m .50295 .36955 L .5 .38446 L closepath p F P
0 0 0 r
s
.285 .426 .838 r
.5086 .37172 m .50578 .37064 L .5 .38446 L closepath p F P
0 0 0 r
s
.285 .426 .838 r
.51142 .37281 m .5086 .37172 L .5 .38446 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.49257 .39461 m
.50753 .37758 L
s
.83 .24 .1 r
.487 .38121 m
.51291 .39105 L
s
1 .313 .132 r
.44541 .39329 m .44846 .38967 L .47396 .38573 L p F P
0 0 0 r
s
.24 .35 .67 r
.47133 .38662 m
.49257 .39461 L
s
1 .324 .136 r
.44846 .38967 m .44541 .39329 L .41964 .40152 L p F P
0 0 0 r
s
.153 .191 .345 r
.52861 .66034 m .51406 .65595 L .51526 .6469 L p F P
0 0 0 r
s
.153 .191 .345 r
.49934 .64204 m .51526 .6469 L .51406 .65595 L p F P
0 0 0 r
s
1 .332 .138 r
.3901 .41886 m .39561 .4121 L .41964 .40152 L p F P
0 0 0 r
s
1 .331 .136 r
.39561 .4121 m .3901 .41886 L .36733 .43291 L p F P
0 0 0 r
s
.83 .24 .1 r
.37594 .42854 m
.39191 .42436 L
s
.36902 .43709 m
.37594 .42854 L
s
.391 .108 .052 r
.60446 .56478 m .61582 .55455 L .61348 .53535 L p F P
0 0 0 r
s
.273 .073 .037 r
.59301 .59268 m .60413 .58282 L .60446 .56478 L p F P
0 0 0 r
s
.273 .073 .037 r
.61582 .55455 m .60446 .56478 L .60413 .58282 L p F P
0 0 0 r
s
.659 .189 .085 r
.61878 .44941 m .60957 .45845 L .62129 .47647 L p F P
0 0 0 r
s
.723 .209 .093 r
.60957 .45845 m .61878 .44941 L .60334 .43358 L p F P
0 0 0 r
s
.161 .046 .023 r
.57992 .618 m .59053 .60871 L .59301 .59268 L p F P
0 0 0 r
s
.161 .046 .023 r
.60413 .58282 m .59301 .59268 L .59053 .60871 L p F P
0 0 0 r
s
.83 .24 .1 r
.58158 .58391 m
.60347 .56417 L
s
.93 .273 .118 r
.52769 .38404 m .52604 .38588 L .55153 .38997 L p F P
0 0 0 r
s
1 .313 .132 r
.47554 .38389 m .47396 .38573 L .44846 .38967 L p F P
0 0 0 r
s
.24 .35 .67 r
.46797 .38535 m
.46823 .38545 L
s
.221 .299 .561 r
.44797 .61371 m .43052 .60832 L .42862 .59227 L p F P
0 0 0 r
s
.221 .299 .561 r
.41049 .5866 m .42862 .59227 L .43052 .60832 L p F P
0 0 0 r
s
.24 .35 .67 r
.42974 .59692 m
.46564 .60811 L
s
.42906 .57372 m
.42974 .59692 L
s
.278 .395 .76 r
.33991 .4813 m .32314 .47566 L .34024 .45771 L p F P
0 0 0 r
s
1 .316 .128 r
.34024 .45771 m .34748 .44865 L .36733 .43291 L p F P
0 0 0 r
s
.918 .277 .11 r
.34748 .44865 m .34024 .45771 L .32314 .47566 L p F P
0 0 0 r
s
.24 .35 .67 r
.34022 .45758 m
.37231 .46858 L
s
.3355 .45596 m
.33962 .45738 L
s
.391 .108 .052 r
.62479 .52497 m .61348 .53535 L .61582 .55455 L p F P
0 0 0 r
s
.497 .14 .065 r
.61348 .53535 m .62479 .52497 L .61932 .50552 L p F P
0 0 0 r
s
.24 .35 .67 r
.77326 .44557 m
.80587 .4584 L
s
.81855 .47088 m
.80587 .4584 L
s
.271 .384 .736 r
.34597 .50625 m .32809 .50035 L .33991 .4813 L p F P
0 0 0 r
s
.271 .384 .736 r
.32314 .47566 m .33991 .4813 L .32809 .50035 L p F P
0 0 0 r
s
.83 .24 .1 r
.29043 .54284 m
.27372 .56333 L
s
.27372 .56333 m
.27406 .58902 L
s
.24 .35 .67 r
.64384 .70125 m
.62925 .69629 L
s
.5948 .68593 m
.62925 .69629 L
s
.194 .255 .473 r
.48326 .63714 m .46704 .63219 L .46525 .61904 L p F P
0 0 0 r
s
.194 .255 .473 r
.44797 .61371 m .46525 .61904 L .46704 .63219 L p F P
0 0 0 r
s
.833 .243 .106 r
.57595 .39666 m .57095 .40196 L .59216 .41266 L p F P
0 0 0 r
s
.24 .35 .67 r
.58089 .40153 m
.59302 .39257 L
s
.883 .258 .112 r
.57095 .40196 m .57595 .39666 L .55153 .38997 L p F P
0 0 0 r
s
.24 .33 .624 r
.41049 .5866 m .39218 .58087 L .39184 .56279 L p F P
0 0 0 r
s
.24 .35 .67 r
.39287 .56219 m
.42906 .57372 L
s
.24 .33 .624 r
.37328 .55688 m .39184 .56279 L .39218 .58087 L p F P
0 0 0 r
s
.93 .273 .118 r
.55153 .38997 m .55488 .38633 L .52769 .38404 L p F P
0 0 0 r
s
.93 .273 .118 r
.52935 .3822 m .52769 .38404 L .55488 .38633 L p F P
0 0 0 r
s
1 .324 .136 r
.41964 .40152 m .42402 .39622 L .44846 .38967 L p F P
0 0 0 r
s
1 .332 .138 r
.42402 .39622 m .41964 .40152 L .39561 .4121 L p F P
0 0 0 r
s
1 .313 .132 r
.47713 .38204 m .47554 .38389 L .45152 .38603 L p F P
0 0 0 r
s
.24 .35 .67 r
.46628 .38472 m
.46797 .38535 L
s
1 .313 .132 r
.44846 .38967 m .45152 .38603 L .47554 .38389 L p F P
0 0 0 r
s
.264 .37 .707 r
.35747 .53173 m .33891 .52572 L .34597 .50625 L p F P
0 0 0 r
s
.264 .37 .707 r
.32809 .50035 m .34597 .50625 L .33891 .52572 L p F P
0 0 0 r
s
.83 .24 .1 r
.28029 .61583 m
.26374 .63504 L
s
.26374 .63504 m
.27536 .66127 L
s
.883 .258 .112 r
.55488 .38633 m .55153 .38997 L .57595 .39666 L p F P
0 0 0 r
s
.084 .024 .01 r
.56593 .63977 m .5758 .63121 L .57992 .618 L p F P
0 0 0 r
s
.084 .024 .01 r
.59053 .60871 m .57992 .618 L .5758 .63121 L p F P
0 0 0 r
s
.83 .24 .1 r
.57285 .6292 m
.57986 .60765 L
s
1 .324 .136 r
.45152 .38603 m .44846 .38967 L .42402 .39622 L p F P
0 0 0 r
s
.24 .35 .67 r
.40673 .38916 m
.42494 .39588 L
s
.723 .209 .093 r
.61137 .4255 m .60334 .43358 L .61878 .44941 L p F P
0 0 0 r
s
.781 .227 .1 r
.60334 .43358 m .61137 .4255 L .59216 .41266 L p F P
0 0 0 r
s
.497 .14 .065 r
.63028 .49525 m .61932 .50552 L .62479 .52497 L p F P
0 0 0 r
s
.83 .24 .1 r
.59972 .53902 m
.62211 .51832 L
s
.585 .167 .076 r
.61932 .50552 m .63028 .49525 L .62129 .47647 L p F P
0 0 0 r
s
.24 .35 .67 r
.33304 .46468 m
.3355 .45596 L
s
.3355 .45596 m
.34548 .42769 L
s
.93 .273 .118 r
.55488 .38633 m .55825 .38268 L .52935 .3822 L p F P
0 0 0 r
s
.93 .273 .118 r
.53101 .38034 m .52935 .3822 L .55825 .38268 L p F P
0 0 0 r
s
1 .331 .136 r
.36733 .43291 m .37384 .42483 L .39561 .4121 L p F P
0 0 0 r
s
.24 .35 .67 r
.3943 .41286 m
.40673 .38916 L
s
1 .316 .128 r
.37384 .42483 m .36733 .43291 L .34748 .44865 L p F P
0 0 0 r
s
.24 .35 .67 r
.34548 .42769 m
.36362 .43406 L
s
1 .313 .132 r
.47871 .38019 m .47713 .38204 L .4546 .38237 L p F P
0 0 0 r
s
.24 .35 .67 r
.45695 .38121 m
.45899 .38197 L
s
1 .313 .132 r
.45152 .38603 m .4546 .38237 L .47713 .38204 L p F P
0 0 0 r
s
.24 .35 .67 r
.45628 .38222 m
.45695 .38121 L
s
.83 .24 .1 r
.47498 .39511 m
.487 .38121 L
s
.24 .35 .67 r
.30799 .4145 m
.34548 .42769 L
s
.34548 .42769 m
.35705 .40058 L
s
.83 .24 .1 r
.53904 .66623 m
.54139 .66421 L
s
.254 .353 .671 r
.37328 .55688 m .35452 .55091 L .35747 .53173 L p F P
0 0 0 r
s
.254 .353 .671 r
.33891 .52572 m .35747 .53173 L .35452 .55091 L p F P
0 0 0 r
s
.24 .35 .67 r
.35591 .55043 m
.35891 .52445 L
s
.36985 .37557 m
.40673 .38916 L
s
.153 .191 .345 r
.51406 .65595 m .49939 .65151 L .49934 .64204 L p F P
0 0 0 r
s
.153 .191 .345 r
.48326 .63714 m .49934 .64204 L .49939 .65151 L p F P
0 0 0 r
s
.24 .35 .67 r
.46979 .62783 m
.50544 .63876 L
s
.69223 .413 m
.72579 .42621 L
s
.72579 .42621 m
.73997 .43246 L
s
.93 .273 .118 r
.55825 .38268 m .56164 .379 L .53101 .38034 L p F P
0 0 0 r
s
.275 .416 .823 r
.52823 .37927 m .53101 .38034 L .56164 .379 L p F P
0 0 0 r
s
.781 .227 .1 r
.59878 .40583 m .59216 .41266 L .61137 .4255 L p F P
0 0 0 r
s
.83 .24 .1 r
.58206 .44424 m
.60413 .42183 L
s
.833 .243 .106 r
.59216 .41266 m .59878 .40583 L .57595 .39666 L p F P
0 0 0 r
s
1 .313 .132 r
.48031 .37833 m .47871 .38019 L .45769 .37869 L p F P
0 0 0 r
s
1 .313 .132 r
.4546 .38237 m .45769 .37869 L .47871 .38019 L p F P
0 0 0 r
s
.83 .24 .1 r
.33754 .72517 m
.36381 .73785 L
s
.38223 .72047 m
.36381 .73785 L
s
.883 .258 .112 r
.57595 .39666 m .581 .39132 L .55488 .38633 L p F P
0 0 0 r
s
.883 .258 .112 r
.55825 .38268 m .55488 .38633 L .581 .39132 L p F P
0 0 0 r
s
1 .332 .138 r
.39561 .4121 m .40118 .40526 L .42402 .39622 L p F P
0 0 0 r
s
1 .331 .136 r
.40118 .40526 m .39561 .4121 L .37384 .42483 L p F P
0 0 0 r
s
.24 .35 .67 r
.35705 .40058 m
.39075 .41272 L
s
.585 .167 .076 r
.63159 .4666 m .62129 .47647 L .63028 .49525 L p F P
0 0 0 r
s
.83 .24 .1 r
.61308 .49266 m
.62211 .51832 L
s
.659 .189 .085 r
.62129 .47647 m .63159 .4666 L .61878 .44941 L p F P
0 0 0 r
s
1 .324 .136 r
.4546 .38237 m .45152 .38603 L .42844 .39087 L p F P
0 0 0 r
s
1 .324 .136 r
.42402 .39622 m .42844 .39087 L .45152 .38603 L p F P
0 0 0 r
s
.275 .416 .823 r
.52544 .3782 m .52823 .37927 L .55615 .37686 L p F P
0 0 0 r
s
.275 .416 .823 r
.56164 .379 m .55615 .37686 L .52823 .37927 L p F P
0 0 0 r
s
.83 .24 .1 r
.40942 .72789 m
.43577 .72948 L
s
.45551 .71193 m
.43577 .72948 L
s
.833 .243 .106 r
.581 .39132 m .57595 .39666 L .59878 .40583 L p F P
0 0 0 r
s
.83 .24 .1 r
.56129 .42317 m
.58297 .4004 L
s
.221 .299 .561 r
.43052 .60832 m .4129 .60288 L .41049 .5866 L p F P
0 0 0 r
s
.221 .299 .561 r
.39218 .58087 m .41049 .5866 L .4129 .60288 L p F P
0 0 0 r
s
.271 .384 .736 r
.32809 .50035 m .31002 .49439 L .32314 .47566 L p F P
0 0 0 r
s
.83 .24 .1 r
.3063 .4992 m
.31012 .49443 L
s
.918 .277 .11 r
.32314 .47566 m .33103 .46577 L .34748 .44865 L p F P
0 0 0 r
s
.083 .024 .01 r
.33103 .46577 m .32314 .47566 L .31002 .49439 L p F P
0 0 0 r
s
.24 .35 .67 r
.32744 .48448 m
.33287 .46528 L
s
.83 .24 .1 r
.32348 .4777 m
.33383 .46696 L
s
.24 .35 .67 r
.32744 .48448 m
.36445 .49685 L
s
.83 .24 .1 r
.31956 .48261 m
.32348 .4777 L
s
1 .332 .138 r
.42844 .39087 m .42402 .39622 L .40118 .40526 L p F P
0 0 0 r
s
.83 .24 .1 r
.417 .39992 m
.44152 .39954 L
s
.40196 .4182 m
.417 .39992 L
s
.112 .127 .241 r
.52861 .66034 m .54304 .6647 L .53825 .66927 L p F P
0 0 0 r
s
.083 .024 .01 r
.55181 .65713 m .54304 .6647 L .53825 .66927 L p F P
0 0 0 r
s
.24 .35 .67 r
.54448 .6637 m
.54854 .66493 L
s
1 .313 .132 r
.48191 .37647 m .48031 .37833 L .4608 .37499 L p F P
0 0 0 r
s
1 .313 .132 r
.45769 .37869 m .4608 .37499 L .48031 .37833 L p F P
0 0 0 r
s
.275 .416 .823 r
.52264 .37712 m .52544 .3782 L .55064 .37472 L p F P
0 0 0 r
s
.275 .416 .823 r
.55615 .37686 m .55064 .37472 L .52544 .3782 L p F P
0 0 0 r
s
.24 .35 .67 r
.50753 .37758 m
.52869 .38568 L
s
.31764 .48121 m
.319 .48166 L
s
.31929 .48176 m
.32744 .48448 L
s
.194 .255 .473 r
.46704 .63219 m .45066 .6272 L .44797 .61371 L p F P
0 0 0 r
s
.24 .35 .67 r
.46564 .60811 m
.46979 .62783 L
s
.194 .255 .473 r
.43052 .60832 m .44797 .61371 L .45066 .6272 L p F P
0 0 0 r
s
.083 .024 .01 r
.55181 .65713 m .56072 .64944 L .56593 .63977 L p F P
0 0 0 r
s
.083 .024 .01 r
.5758 .63121 m .56593 .63977 L .56072 .64944 L p F P
0 0 0 r
s
.83 .24 .1 r
.55134 .64794 m
.57285 .6292 L
s
.24 .33 .624 r
.39218 .58087 m .37368 .57508 L .37328 .55688 L p F P
0 0 0 r
s
.24 .33 .624 r
.35452 .55091 m .37328 .55688 L .37368 .57508 L p F P
0 0 0 r
s
.83 .24 .1 r
.29569 .51931 m
.29043 .54284 L
s
.275 .416 .823 r
.51984 .37605 m .52264 .37712 L .54511 .37257 L p F P
0 0 0 r
s
.275 .416 .823 r
.55064 .37472 m .54511 .37257 L .52264 .37712 L p F P
0 0 0 r
s
.83 .24 .1 r
.51291 .39105 m
.52537 .37706 L
s
.264 .37 .707 r
.33891 .52572 m .32017 .51965 L .32809 .50035 L p F P
0 0 0 r
s
.264 .37 .707 r
.31002 .49439 m .32809 .50035 L .32017 .51965 L p F P
0 0 0 r
s
.24 .35 .67 r
.31954 .38706 m
.35705 .40058 L
s
.35705 .40058 m
.36985 .37557 L
s
.83 .24 .1 r
.58297 .4004 m
.60413 .42183 L
s
.659 .189 .085 r
.62813 .44023 m .61878 .44941 L .63159 .4666 L p F P
0 0 0 r
s
.723 .209 .093 r
.61878 .44941 m .62813 .44023 L .61137 .4255 L p F P
0 0 0 r
s
.83 .24 .1 r
.59955 .46767 m
.622 .44562 L
s
1 .313 .132 r
.48351 .3746 m .48191 .37647 L .46394 .37127 L p F P
0 0 0 r
s
1 .313 .132 r
.4608 .37499 m .46394 .37127 L .48191 .37647 L p F P
0 0 0 r
s
.83 .24 .1 r
.46118 .37619 m
.487 .38121 L
s
.275 .416 .823 r
.51704 .37497 m .51984 .37605 L .53956 .37042 L p F P
0 0 0 r
s
.275 .416 .823 r
.54511 .37257 m .53956 .37042 L .51984 .37605 L p F P
0 0 0 r
s
.24 .35 .67 r
.64304 .39975 m
.65797 .39951 L
s
.883 .258 .112 r
.581 .39132 m .58608 .38593 L .55825 .38268 L p F P
0 0 0 r
s
.24 .35 .67 r
.58336 .38881 m
.59302 .39257 L
s
.883 .258 .112 r
.56164 .379 m .55825 .38268 L .58608 .38593 L p F P
0 0 0 r
s
.83 .24 .1 r
.53796 .40522 m
.55927 .38208 L
s
1 .316 .128 r
.34748 .44865 m .35483 .43946 L .37384 .42483 L p F P
0 0 0 r
s
.918 .277 .11 r
.35483 .43946 m .34748 .44865 L .33103 .46577 L p F P
0 0 0 r
s
.24 .35 .67 r
.29792 .44308 m
.3355 .45596 L
s
1 .324 .136 r
.45769 .37869 m .4546 .38237 L .43289 .38548 L p F P
0 0 0 r
s
1 .324 .136 r
.42844 .39087 m .43289 .38548 L .4546 .38237 L p F P
0 0 0 r
s
.24 .35 .67 r
.69504 .71052 m
.67802 .71152 L
s
.64384 .70125 m
.67802 .71152 L
s
.83 .24 .1 r
.29222 .64242 m
.27536 .66127 L
s
.27536 .66127 m
.29212 .68587 L
s
.275 .416 .823 r
.51423 .37389 m .51704 .37497 L .534 .36826 L p F P
0 0 0 r
s
.275 .416 .823 r
.53956 .37042 m .534 .36826 L .51704 .37497 L p F P
0 0 0 r
s
1 .313 .132 r
.48512 .37273 m .48351 .3746 L .46708 .36752 L p F P
0 0 0 r
s
1 .313 .132 r
.46394 .37127 m .46708 .36752 L .48351 .3746 L p F P
0 0 0 r
s
.391 .108 .052 r
.61582 .55455 m .62739 .54413 L .62479 .52497 L p F P
0 0 0 r
s
.273 .073 .037 r
.60413 .58282 m .61546 .57279 L .61582 .55455 L p F P
0 0 0 r
s
.273 .073 .037 r
.62739 .54413 m .61582 .55455 L .61546 .57279 L p F P
0 0 0 r
s
.153 .191 .345 r
.49939 .65151 m .48459 .64704 L .48326 .63714 L p F P
0 0 0 r
s
.153 .191 .345 r
.46704 .63219 m .48326 .63714 L .48459 .64704 L p F P
0 0 0 r
s
.723 .209 .093 r
.6195 .41732 m .61137 .4255 L .62813 .44023 L p F P
0 0 0 r
s
.781 .227 .1 r
.61137 .4255 m .6195 .41732 L .59878 .40583 L p F P
0 0 0 r
s
.83 .24 .1 r
.60413 .42183 m
.622 .44562 L
s
.161 .046 .023 r
.59053 .60871 m .60133 .59926 L .60413 .58282 L p F P
0 0 0 r
s
.161 .046 .023 r
.61546 .57279 m .60413 .58282 L .60133 .59926 L p F P
0 0 0 r
s
.83 .24 .1 r
.60199 .58809 m
.60347 .56417 L
s
.254 .353 .671 r
.35452 .55091 m .33557 .54488 L .33891 .52572 L p F P
0 0 0 r
s
.254 .353 .671 r
.32017 .51965 m .33891 .52572 L .33557 .54488 L p F P
0 0 0 r
s
.24 .35 .67 r
.32159 .51228 m
.35891 .52445 L
s
.275 .416 .823 r
.51142 .37281 m .51423 .37389 L .52842 .36609 L p F P
0 0 0 r
s
.275 .416 .823 r
.534 .36826 m .52842 .36609 L .51423 .37389 L p F P
0 0 0 r
s
.83 .24 .1 r
.53342 .36803 m
.53387 .36753 L
s
.833 .243 .106 r
.59878 .40583 m .60547 .39892 L .581 .39132 L p F P
0 0 0 r
s
.833 .243 .106 r
.58608 .38593 m .581 .39132 L .60547 .39892 L p F P
0 0 0 r
s
.83 .24 .1 r
.55927 .38208 m
.58297 .4004 L
s
1 .331 .136 r
.37384 .42483 m .38044 .41663 L .40118 .40526 L p F P
0 0 0 r
s
1 .316 .128 r
.38044 .41663 m .37384 .42483 L .35483 .43946 L p F P
0 0 0 r
s
.83 .24 .1 r
.53387 .36753 m
.53757 .36965 L
s
.391 .108 .052 r
.63631 .5144 m .62479 .52497 L .62739 .54413 L p F P
0 0 0 r
s
.497 .14 .065 r
.62479 .52497 m .63631 .5144 L .63028 .49525 L p F P
0 0 0 r
s
.83 .24 .1 r
.62211 .51832 m
.62616 .5437 L
s
.31321 .70755 m
.33754 .72517 L
s
.35557 .70747 m
.33754 .72517 L
s
.781 .227 .1 r
.60547 .39892 m .59878 .40583 L .6195 .41732 L p F P
0 0 0 r
s
1 .332 .138 r
.43289 .38548 m .42844 .39087 L .40681 .39835 L p F P
0 0 0 r
s
1 .332 .138 r
.40118 .40526 m .40681 .39835 L .42844 .39087 L p F P
0 0 0 r
s
.112 .127 .241 r
.53825 .66927 m .52542 .66541 L .52861 .66034 L p F P
0 0 0 r
s
.83 .24 .1 r
.52195 .68048 m
.53616 .66864 L
s
.112 .127 .241 r
.51406 .65595 m .52861 .66034 L .52542 .66541 L p F P
0 0 0 r
s
.275 .416 .823 r
.5086 .37172 m .51142 .37281 L .52282 .36391 L p F P
0 0 0 r
s
.275 .416 .823 r
.52842 .36609 m .52282 .36391 L .51142 .37281 L p F P
0 0 0 r
s
1 .313 .132 r
.48673 .37085 m .48512 .37273 L .47025 .36376 L p F P
0 0 0 r
s
1 .313 .132 r
.46708 .36752 m .47025 .36376 L .48512 .37273 L p F P
0 0 0 r
s
1 .331 .136 r
.40681 .39835 m .40118 .40526 L .38044 .41663 L p F P
0 0 0 r
s
.883 .258 .112 r
.58608 .38593 m .59121 .3805 L .56164 .379 L p F P
0 0 0 r
s
.255 .392 .783 r
.55615 .37686 m .56164 .379 L .59121 .3805 L p F P
0 0 0 r
s
.24 .35 .67 r
.55818 .37904 m
.56428 .38141 L
s
.83 .24 .1 r
.54998 .37676 m
.55927 .38208 L
s
.24 .35 .67 r
.55245 .38349 m
.55818 .37904 L
s
1 .324 .136 r
.4608 .37499 m .45769 .37869 L .43738 .38005 L p F P
0 0 0 r
s
.24 .35 .67 r
.45138 .37911 m
.45339 .37987 L
s
1 .324 .136 r
.43289 .38548 m .43738 .38005 L .45769 .37869 L p F P
0 0 0 r
s
.221 .299 .561 r
.4129 .60288 m .39509 .59738 L .39218 .58087 L p F P
0 0 0 r
s
.221 .299 .561 r
.37368 .57508 m .39218 .58087 L .39509 .59738 L p F P
0 0 0 r
s
.24 .35 .67 r
.39308 .58549 m
.42974 .59692 L
s
.39287 .56219 m
.39308 .58549 L
s
.084 .024 .01 r
.5758 .63121 m .58583 .62252 L .59053 .60871 L p F P
0 0 0 r
s
.084 .024 .01 r
.60133 .59926 m .59053 .60871 L .58583 .62252 L p F P
0 0 0 r
s
.83 .24 .1 r
.57986 .60765 m
.60199 .58809 L
s
.275 .416 .823 r
.50578 .37064 m .5086 .37172 L .5172 .36173 L p F P
0 0 0 r
s
.275 .416 .823 r
.52282 .36391 m .5172 .36173 L .5086 .37172 L p F P
0 0 0 r
s
.194 .255 .473 r
.45066 .6272 m .43413 .62215 L .43052 .60832 L p F P
0 0 0 r
s
.194 .255 .473 r
.4129 .60288 m .43052 .60832 L .43413 .62215 L p F P
0 0 0 r
s
.24 .35 .67 r
.73997 .43246 m
.77326 .44557 L
s
.77326 .44557 m
.78553 .45797 L
s
.497 .14 .065 r
.64144 .4848 m .63028 .49525 L .63631 .5144 L p F P
0 0 0 r
s
.585 .167 .076 r
.63028 .49525 m .64144 .4848 L .63159 .4666 L p F P
0 0 0 r
s
.24 .35 .67 r
.60893 .69076 m
.5948 .68593 L
s
.55962 .67536 m
.5948 .68593 L
s
.83 .24 .1 r
.30936 .66741 m
.29212 .68587 L
s
.29212 .68587 m
.31321 .70755 L
s
.29096 .56878 m
.27406 .58902 L
s
.27406 .58902 m
.28029 .61583 L
s
1 .313 .132 r
.48835 .36896 m .48673 .37085 L .47344 .35997 L p F P
0 0 0 r
s
1 .313 .132 r
.47025 .36376 m .47344 .35997 L .48673 .37085 L p F P
0 0 0 r
s
.83 .24 .1 r
.45551 .71193 m
.47997 .70792 L
s
.50065 .68986 m
.47997 .70792 L
s
.275 .416 .823 r
.50295 .36955 m .50578 .37064 L .51156 .35954 L p F P
0 0 0 r
s
.275 .416 .823 r
.5172 .36173 m .51156 .35954 L .50578 .37064 L p F P
0 0 0 r
s
.24 .33 .624 r
.37368 .57508 m .35498 .56922 L .35452 .55091 L p F P
0 0 0 r
s
.24 .35 .67 r
.35591 .55043 m
.39287 .56219 L
s
.24 .33 .624 r
.33557 .54488 m .35452 .55091 L .35498 .56922 L p F P
0 0 0 r
s
.264 .37 .707 r
.32017 .51965 m .30122 .51352 L .31002 .49439 L p F P
0 0 0 r
s
.083 .024 .01 r
.31002 .49439 m .31838 .48393 L .33103 .46577 L p F P
0 0 0 r
s
.24 .35 .67 r
.32159 .51228 m
.32744 .48448 L
s
.28965 .47185 m
.31764 .48121 L
s
.083 .024 .01 r
.31838 .48393 m .31002 .49439 L .30122 .51352 L p F P
0 0 0 r
s
.83 .24 .1 r
.29569 .51931 m
.30239 .51098 L
s
.33084 .68948 m
.31321 .70755 L
s
.255 .392 .783 r
.55064 .37472 m .55615 .37686 L .58315 .37734 L p F P
0 0 0 r
s
.255 .392 .783 r
.59121 .3805 m .58315 .37734 L .55615 .37686 L p F P
0 0 0 r
s
.83 .24 .1 r
.55927 .38208 m
.56305 .37797 L
s
.275 .416 .823 r
.50012 .36846 m .50295 .36955 L .50591 .35734 L p F P
0 0 0 r
s
.275 .416 .823 r
.51156 .35954 m .50591 .35734 L .50295 .36955 L p F P
0 0 0 r
s
.83 .24 .1 r
.50721 .35785 m
.50765 .35733 L
s
.24 .35 .67 r
.4861 .36937 m
.50753 .37758 L
s
.50753 .37758 m
.5226 .36523 L
s
.30506 .5069 m
.32159 .51228 L
s
1 .313 .132 r
.48997 .36707 m .48835 .36896 L .47664 .35616 L p F P
0 0 0 r
s
1 .313 .132 r
.47344 .35997 m .47664 .35616 L .48835 .36896 L p F P
0 0 0 r
s
.585 .167 .076 r
.64206 .45656 m .63159 .4666 L .64144 .4848 L p F P
0 0 0 r
s
.83 .24 .1 r
.61308 .49266 m
.63592 .47093 L
s
.659 .189 .085 r
.63159 .4666 m .64206 .45656 L .62813 .44023 L p F P
0 0 0 r
s
.24 .35 .67 r
.28965 .47185 m
.29792 .44308 L
s
.25955 .42993 m
.29792 .44308 L
s
.29792 .44308 m
.30799 .4145 L
s
.083 .024 .01 r
.53825 .66927 m .54602 .66257 L .55181 .65713 L p F P
0 0 0 r
s
.24 .35 .67 r
.54854 .66493 m
.55962 .67536 L
s
.083 .024 .01 r
.56072 .64944 m .55181 .65713 L .54602 .66257 L p F P
0 0 0 r
s
.275 .416 .823 r
.49728 .36737 m .50012 .36846 L .50024 .35514 L p F P
0 0 0 r
s
.275 .416 .823 r
.50591 .35734 m .50024 .35514 L .50012 .36846 L p F P
0 0 0 r
s
.24 .35 .67 r
.26972 .40104 m
.30799 .4145 L
s
.30799 .4145 m
.31954 .38706 L
s
1 .324 .136 r
.46394 .37127 m .4608 .37499 L .44191 .37457 L p F P
0 0 0 r
s
1 .324 .136 r
.43738 .38005 m .44191 .37457 L .4608 .37499 L p F P
0 0 0 r
s
.24 .35 .67 r
.42059 .36752 m
.44129 .37532 L
s
.83 .24 .1 r
.44152 .39954 m
.46118 .37619 L
s
.153 .191 .345 r
.48459 .64704 m .46966 .64252 L .46704 .63219 L p F P
0 0 0 r
s
.153 .191 .345 r
.45066 .6272 m .46704 .63219 L .46966 .64252 L p F P
0 0 0 r
s
.833 .243 .106 r
.60547 .39892 m .61223 .39194 L .58608 .38593 L p F P
0 0 0 r
s
.833 .243 .106 r
.59121 .3805 m .58608 .38593 L .61223 .39194 L p F P
0 0 0 r
s
.918 .277 .11 r
.33103 .46577 m .33904 .45572 L .35483 .43946 L p F P
0 0 0 r
s
.083 .024 .01 r
.33904 .45572 m .33103 .46577 L .31838 .48393 L p F P
0 0 0 r
s
.255 .392 .783 r
.54511 .37257 m .55064 .37472 L .57505 .37417 L p F P
0 0 0 r
s
.255 .392 .783 r
.58315 .37734 m .57505 .37417 L .55064 .37472 L p F P
0 0 0 r
s
1 .332 .138 r
.43738 .38005 m .43289 .38548 L .4125 .39136 L p F P
0 0 0 r
s
1 .332 .138 r
.40681 .39835 m .4125 .39136 L .43289 .38548 L p F P
0 0 0 r
s
.24 .35 .67 r
.40673 .38916 m
.42059 .36752 L
s
.275 .416 .823 r
.49444 .36627 m .49728 .36737 L .49454 .35293 L p F P
0 0 0 r
s
.275 .416 .823 r
.50024 .35514 m .49454 .35293 L .49728 .36737 L p F P
0 0 0 r
s
.254 .353 .671 r
.33557 .54488 m .31641 .53879 L .32017 .51965 L p F P
0 0 0 r
s
.254 .353 .671 r
.30122 .51352 m .32017 .51965 L .31641 .53879 L p F P
0 0 0 r
s
.24 .35 .67 r
.72891 .72076 m
.74754 .71367 L
s
.69504 .71052 m
.72891 .72076 L
s
.112 .127 .241 r
.52542 .66541 m .51249 .66153 L .51406 .65595 L p F P
0 0 0 r
s
.112 .127 .241 r
.49939 .65151 m .51406 .65595 L .51249 .66153 L p F P
0 0 0 r
s
.24 .35 .67 r
.51312 .6542 m
.54408 .66358 L
s
.50544 .63876 m
.51312 .6542 L
s
.33219 .36168 m
.36985 .37557 L
s
.36985 .37557 m
.38346 .35355 L
s
1 .313 .132 r
.49159 .36518 m .48997 .36707 L .47986 .35233 L p F P
0 0 0 r
s
1 .313 .132 r
.47664 .35616 m .47986 .35233 L .48997 .36707 L p F P
0 0 0 r
s
.83 .24 .1 r
.487 .38121 m
.49928 .36702 L
s
.083 .024 .01 r
.56072 .64944 m .56976 .64163 L .5758 .63121 L p F P
0 0 0 r
s
.083 .024 .01 r
.58583 .62252 m .5758 .63121 L .56976 .64163 L p F P
0 0 0 r
s
.24 .35 .67 r
.38346 .35355 m
.42059 .36752 L
s
.659 .189 .085 r
.63762 .43091 m .62813 .44023 L .64206 .45656 L p F P
0 0 0 r
s
.83 .24 .1 r
.622 .44562 m
.63592 .47093 L
s
.723 .209 .093 r
.62813 .44023 m .63762 .43091 L .6195 .41732 L p F P
0 0 0 r
s
.24 .35 .67 r
.65797 .39951 m
.69223 .413 L
s
.69223 .413 m
.70596 .41908 L
s
.275 .416 .823 r
.49159 .36518 m .49444 .36627 L .48883 .35071 L p F P
0 0 0 r
s
.275 .416 .823 r
.49454 .35293 m .48883 .35071 L .49444 .36627 L p F P
0 0 0 r
s
.83 .24 .1 r
.38223 .72047 m
.40942 .72789 L
s
.42888 .71013 m
.40942 .72789 L
s
.781 .227 .1 r
.6195 .41732 m .62773 .40903 L .60547 .39892 L p F P
0 0 0 r
s
.781 .227 .1 r
.61223 .39194 m .60547 .39892 L .62773 .40903 L p F P
0 0 0 r
s
1 .316 .128 r
.35483 .43946 m .36229 .43014 L .38044 .41663 L p F P
0 0 0 r
s
.918 .277 .11 r
.36229 .43014 m .35483 .43946 L .33904 .45572 L p F P
0 0 0 r
s
.83 .24 .1 r
.34103 .45902 m
.35664 .43953 L
s
.255 .392 .783 r
.53956 .37042 m .54511 .37257 L .56691 .37098 L p F P
0 0 0 r
s
.255 .392 .783 r
.57505 .37417 m .56691 .37098 L .54511 .37257 L p F P
0 0 0 r
s
.723 .209 .093 r
.62773 .40903 m .6195 .41732 L .63762 .43091 L p F P
0 0 0 r
s
1 .331 .136 r
.4125 .39136 m .40681 .39835 L .38712 .40833 L p F P
0 0 0 r
s
1 .331 .136 r
.38044 .41663 m .38712 .40833 L .40681 .39835 L p F P
0 0 0 r
s
.83 .24 .1 r
.39454 .40557 m
.417 .39992 L
s
1 .313 .132 r
.47986 .35233 m .4831 .34848 L .49159 .36518 L p F P
0 0 0 r
s
.275 .416 .823 r
.48883 .35071 m .4831 .34848 L .49159 .36518 L p F P
0 0 0 r
s
1 .316 .128 r
.38712 .40833 m .38044 .41663 L .36229 .43014 L p F P
0 0 0 r
s
.83 .24 .1 r
.37594 .42854 m
.39454 .40557 L
s
.35664 .43953 m
.37594 .42854 L
s
.221 .299 .561 r
.39509 .59738 m .37711 .59183 L .37368 .57508 L p F P
0 0 0 r
s
.221 .299 .561 r
.35498 .56922 m .37368 .57508 L .37711 .59183 L p F P
0 0 0 r
s
.194 .255 .473 r
.43413 .62215 m .41744 .61706 L .4129 .60288 L p F P
0 0 0 r
s
.24 .35 .67 r
.42974 .59692 m
.43339 .61668 L
s
.194 .255 .473 r
.39509 .59738 m .4129 .60288 L .41744 .61706 L p F P
0 0 0 r
s
1 .324 .136 r
.46708 .36752 m .46394 .37127 L .44648 .36904 L p F P
0 0 0 r
s
1 .324 .136 r
.44191 .37457 m .44648 .36904 L .46394 .37127 L p F P
0 0 0 r
s
.24 .35 .67 r
.28348 .49986 m
.28965 .47185 L
s
.25106 .45896 m
.28965 .47185 L
s
.83 .24 .1 r
.50065 .68986 m
.52195 .68048 L
s
.255 .392 .783 r
.534 .36826 m .53956 .37042 L .55873 .36778 L p F P
0 0 0 r
s
.255 .392 .783 r
.56691 .37098 m .55873 .36778 L .53956 .37042 L p F P
0 0 0 r
s
.24 .33 .624 r
.35498 .56922 m .33609 .56331 L .33557 .54488 L p F P
0 0 0 r
s
.24 .33 .624 r
.31641 .53879 m .33557 .54488 L .33609 .56331 L p F P
0 0 0 r
s
.24 .35 .67 r
.78553 .45797 m
.81855 .47088 L
s
.82818 .48898 m
.81855 .47088 L
s
.28123 .37326 m
.31954 .38706 L
s
.31954 .38706 m
.33219 .36168 L
s
.833 .243 .106 r
.61223 .39194 m .61907 .38488 L .59121 .3805 L p F P
0 0 0 r
s
.24 .35 .67 r
.61522 .38885 m
.64304 .39975 L
s
.216 .343 .692 r
.58315 .37734 m .59121 .3805 L .61907 .38488 L p F P
0 0 0 r
s
.391 .108 .052 r
.62739 .54413 m .63917 .53352 L .63631 .5144 L p F P
0 0 0 r
s
.273 .073 .037 r
.61546 .57279 m .62698 .56257 L .62739 .54413 L p F P
0 0 0 r
s
.273 .073 .037 r
.63917 .53352 m .62739 .54413 L .62698 .56257 L p F P
0 0 0 r
s
.161 .046 .023 r
.60133 .59926 m .61232 .58964 L .61546 .57279 L p F P
0 0 0 r
s
.161 .046 .023 r
.62698 .56257 m .61546 .57279 L .61232 .58964 L p F P
0 0 0 r
s
.83 .24 .1 r
.60347 .56417 m
.62616 .5437 L
s
1 .332 .138 r
.44191 .37457 m .43738 .38005 L .41825 .38429 L p F P
0 0 0 r
s
1 .332 .138 r
.4125 .39136 m .41825 .38429 L .43738 .38005 L p F P
0 0 0 r
s
.153 .191 .345 r
.46966 .64252 m .45461 .63797 L .45066 .6272 L p F P
0 0 0 r
s
.153 .191 .345 r
.43413 .62215 m .45066 .6272 L .45461 .63797 L p F P
0 0 0 r
s
.24 .35 .67 r
.43339 .61668 m
.46979 .62783 L
s
.66045 .70007 m
.64384 .70125 L
s
.60893 .69076 m
.64384 .70125 L
s
.112 .127 .241 r
.51249 .66153 m .49946 .65761 L .49939 .65151 L p F P
0 0 0 r
s
.112 .127 .241 r
.48459 .64704 m .49939 .65151 L .49946 .65761 L p F P
0 0 0 r
s
.255 .392 .783 r
.52842 .36609 m .534 .36826 L .55051 .36456 L p F P
0 0 0 r
s
.255 .392 .783 r
.55873 .36778 m .55051 .36456 L .534 .36826 L p F P
0 0 0 r
s
.391 .108 .052 r
.64804 .50364 m .63631 .5144 L .63917 .53352 L p F P
0 0 0 r
s
.497 .14 .065 r
.63631 .5144 m .64804 .50364 L .64144 .4848 L p F P
0 0 0 r
s
.83 .24 .1 r
.29043 .54284 m
.29096 .56878 L
s
1 .324 .136 r
.47025 .36376 m .46708 .36752 L .45109 .36347 L p F P
0 0 0 r
s
1 .324 .136 r
.44648 .36904 m .45109 .36347 L .46708 .36752 L p F P
0 0 0 r
s
.084 .024 .01 r
.58583 .62252 m .59602 .61367 L .60133 .59926 L p F P
0 0 0 r
s
.084 .024 .01 r
.61232 .58964 m .60133 .59926 L .59602 .61367 L p F P
0 0 0 r
s
.83 .24 .1 r
.59515 .60977 m
.60199 .58809 L
s
.254 .353 .671 r
.31641 .53879 m .29704 .53263 L .30122 .51352 L p F P
0 0 0 r
s
.083 .024 .01 r
.30122 .51352 m .30989 .50274 L .31838 .48393 L p F P
0 0 0 r
s
.24 .35 .67 r
.31818 .53841 m
.32159 .51228 L
s
.143 .041 .02 r
.30989 .50274 m .30122 .51352 L .29704 .53263 L p F P
0 0 0 r
s
.24 .35 .67 r
.28348 .49986 m
.30347 .50638 L
s
.30347 .50638 m
.30454 .50673 L
s
.497 .14 .065 r
.65278 .47417 m .64144 .4848 L .64804 .50364 L p F P
0 0 0 r
s
.83 .24 .1 r
.62211 .51832 m
.64531 .49687 L
s
.585 .167 .076 r
.64144 .4848 m .65278 .47417 L .64206 .45656 L p F P
0 0 0 r
s
.83 .24 .1 r
.29745 .5959 m
.28029 .61583 L
s
.28029 .61583 m
.29222 .64242 L
s
.216 .343 .692 r
.57505 .37417 m .58315 .37734 L .60862 .38077 L p F P
0 0 0 r
s
.216 .343 .692 r
.61907 .38488 m .60862 .38077 L .58315 .37734 L p F P
0 0 0 r
s
.83 .24 .1 r
.58297 .4004 m
.60086 .38161 L
s
.255 .392 .783 r
.52282 .36391 m .52842 .36609 L .54226 .36133 L p F P
0 0 0 r
s
.83 .24 .1 r
.5356 .36559 m
.53813 .36275 L
s
.52935 .36577 m
.52991 .36599 L
s
.255 .392 .783 r
.55051 .36456 m .54226 .36133 L .52842 .36609 L p F P
0 0 0 r
s
.24 .35 .67 r
.5226 .36523 m
.55818 .37904 L
s
.781 .227 .1 r
.62773 .40903 m .63608 .40063 L .61223 .39194 L p F P
0 0 0 r
s
.781 .227 .1 r
.61907 .38488 m .61223 .39194 L .63608 .40063 L p F P
0 0 0 r
s
.83 .24 .1 r
.60413 .42183 m
.627 .39861 L
s
.083 .024 .01 r
.54602 .66257 m .55389 .65578 L .56072 .64944 L p F P
0 0 0 r
s
.083 .024 .01 r
.56976 .64163 m .56072 .64944 L .55389 .65578 L p F P
0 0 0 r
s
.83 .24 .1 r
.54174 .6639 m
.56063 .64757 L
s
.56063 .64757 m
.57285 .6292 L
s
.083 .024 .01 r
.31838 .48393 m .32689 .47328 L .33904 .45572 L p F P
0 0 0 r
s
.083 .024 .01 r
.32689 .47328 m .31838 .48393 L .30989 .50274 L p F P
0 0 0 r
s
.83 .24 .1 r
.31291 .49789 m
.31508 .49375 L
s
.31213 .49886 m
.31291 .49789 L
s
1 .331 .136 r
.41825 .38429 m .4125 .39136 L .3939 .39993 L p F P
0 0 0 r
s
1 .331 .136 r
.38712 .40833 m .3939 .39993 L .4125 .39136 L p F P
0 0 0 r
s
.194 .255 .473 r
.41744 .61706 m .40059 .61192 L .39509 .59738 L p F P
0 0 0 r
s
.194 .255 .473 r
.37711 .59183 m .39509 .59738 L .40059 .61192 L p F P
0 0 0 r
s
.221 .299 .561 r
.37711 .59183 m .35894 .58623 L .35498 .56922 L p F P
0 0 0 r
s
.221 .299 .561 r
.33609 .56331 m .35498 .56922 L .35894 .58623 L p F P
0 0 0 r
s
.24 .35 .67 r
.35566 .57381 m
.39308 .58549 L
s
.35566 .57381 m
.35591 .55043 L
s
.585 .167 .076 r
.65271 .44636 m .64206 .45656 L .65278 .47417 L p F P
0 0 0 r
s
.83 .24 .1 r
.63592 .47093 m
.64531 .49687 L
s
.659 .189 .085 r
.64206 .45656 m .65271 .44636 L .63762 .43091 L p F P
0 0 0 r
s
.24 .35 .67 r
.70596 .41908 m
.73997 .43246 L
s
.73997 .43246 m
.7518 .44478 L
s
.723 .209 .093 r
.63762 .43091 m .64726 .42146 L .62773 .40903 L p F P
0 0 0 r
s
.723 .209 .093 r
.63608 .40063 m .62773 .40903 L .64726 .42146 L p F P
0 0 0 r
s
.24 .35 .67 r
.57327 .68005 m
.55962 .67536 L
s
.918 .277 .11 r
.33904 .45572 m .34719 .44551 L .36229 .43014 L p F P
0 0 0 r
s
.083 .024 .01 r
.34719 .44551 m .33904 .45572 L .32689 .47328 L p F P
0 0 0 r
s
.255 .392 .783 r
.5172 .36173 m .52282 .36391 L .53396 .35808 L p F P
0 0 0 r
s
.83 .24 .1 r
.50765 .35733 m
.51833 .36148 L
s
.52357 .36352 m
.52413 .36374 L
s
.255 .392 .783 r
.54226 .36133 m .53396 .35808 L .52282 .36391 L p F P
0 0 0 r
s
.659 .189 .085 r
.64726 .42146 m .63762 .43091 L .65271 .44636 L p F P
0 0 0 r
s
.83 .24 .1 r
.622 .44562 m
.64529 .42275 L
s
1 .324 .136 r
.47344 .35997 m .47025 .36376 L .45573 .35785 L p F P
0 0 0 r
s
1 .324 .136 r
.45109 .36347 m .45573 .35785 L .47025 .36376 L p F P
0 0 0 r
s
.83 .24 .1 r
.5039 .35656 m
.50765 .35733 L
s
1 .332 .138 r
.44648 .36904 m .44191 .37457 L .42407 .37715 L p F P
0 0 0 r
s
1 .332 .138 r
.41825 .38429 m .42407 .37715 L .44191 .37457 L p F P
0 0 0 r
s
.83 .24 .1 r
.43645 .3763 m
.46118 .37619 L
s
.417 .39992 m
.43645 .3763 L
s
1 .316 .128 r
.3939 .39993 m .38712 .40833 L .36986 .42067 L p F P
0 0 0 r
s
1 .316 .128 r
.36229 .43014 m .36986 .42067 L .38712 .40833 L p F P
0 0 0 r
s
.24 .33 .624 r
.33609 .56331 m .317 .55733 L .31641 .53879 L p F P
0 0 0 r
s
.24 .35 .67 r
.31818 .53841 m
.35591 .55043 L
s
.24 .33 .624 r
.29704 .53263 m .31641 .53879 L .317 .55733 L p F P
0 0 0 r
s
.83 .24 .1 r
.29043 .54284 m
.2979 .53369 L
s
.216 .343 .692 r
.56691 .37098 m .57505 .37417 L .59811 .37664 L p F P
0 0 0 r
s
.216 .343 .692 r
.60862 .38077 m .59811 .37664 L .57505 .37417 L p F P
0 0 0 r
s
.83 .24 .1 r
.60356 .37878 m
.60544 .3768 L
s
.918 .277 .11 r
.36986 .42067 m .36229 .43014 L .34719 .44551 L p F P
0 0 0 r
s
.083 .024 .01 r
.56976 .64163 m .57894 .63371 L .58583 .62252 L p F P
0 0 0 r
s
.083 .024 .01 r
.59602 .61367 m .58583 .62252 L .57894 .63371 L p F P
0 0 0 r
s
.83 .24 .1 r
.57285 .6292 m
.59515 .60977 L
s
.079 .091 .174 r
.52542 .66541 m .53825 .66927 L .53238 .6699 L p F P
0 0 0 r
s
.944 .288 .117 r
.54602 .66257 m .53825 .66927 L .53238 .6699 L p F P
0 0 0 r
s
.24 .35 .67 r
.53748 .6687 m
.53864 .66905 L
s
.53864 .66905 m
.55962 .67536 L
s
.83 .24 .1 r
.35557 .70747 m
.38223 .72047 L
s
.40133 .70243 m
.38223 .72047 L
s
.112 .127 .241 r
.49946 .65761 m .48633 .65367 L .48459 .64704 L p F P
0 0 0 r
s
.112 .127 .241 r
.46966 .64252 m .48459 .64704 L .48633 .65367 L p F P
0 0 0 r
s
.24 .35 .67 r
.47695 .64326 m
.51312 .6542 L
s
.46979 .62783 m
.47695 .64326 L
s
.153 .191 .345 r
.45461 .63797 m .43942 .63338 L .43413 .62215 L p F P
0 0 0 r
s
.153 .191 .345 r
.41744 .61706 m .43413 .62215 L .43942 .63338 L p F P
0 0 0 r
s
.24 .35 .67 r
.27965 .52614 m
.28348 .49986 L
s
.24456 .48718 m
.28348 .49986 L
s
.83 .24 .1 r
.42888 .71013 m
.45551 .71193 L
s
.47599 .69373 m
.45551 .71193 L
s
.255 .392 .783 r
.51156 .35954 m .5172 .36173 L .52562 .35482 L p F P
0 0 0 r
s
.255 .392 .783 r
.53396 .35808 m .52562 .35482 L .5172 .36173 L p F P
0 0 0 r
s
.24 .35 .67 r
.25106 .45896 m
.25955 .42993 L
s
.22036 .41649 m
.25955 .42993 L
s
.25955 .42993 m
.26972 .40104 L
s
.23062 .3873 m
.26972 .40104 L
s
.26972 .40104 m
.28123 .37326 L
s
.71334 .70319 m
.69504 .71052 L
s
.66045 .70007 m
.69504 .71052 L
s
1 .324 .136 r
.47664 .35616 m .47344 .35997 L .46041 .35218 L p F P
0 0 0 r
s
1 .324 .136 r
.45573 .35785 m .46041 .35218 L .47344 .35997 L p F P
0 0 0 r
s
.24 .35 .67 r
.4349 .34977 m
.45579 .35777 L
s
.29372 .3475 m
.33219 .36168 L
s
.33219 .36168 m
.34553 .33929 L
s
.216 .343 .692 r
.55873 .36778 m .56691 .37098 L .58754 .37248 L p F P
0 0 0 r
s
.83 .24 .1 r
.56912 .37139 m
.56933 .37116 L
s
.216 .343 .692 r
.59811 .37664 m .58754 .37248 L .56691 .37098 L p F P
0 0 0 r
s
.24 .35 .67 r
.34553 .33929 m
.38346 .35355 L
s
.38346 .35355 m
.39742 .33542 L
s
.255 .392 .783 r
.50591 .35734 m .51156 .35954 L .51724 .35153 L p F P
0 0 0 r
s
.255 .392 .783 r
.52562 .35482 m .51724 .35153 L .51156 .35954 L p F P
0 0 0 r
s
.83 .24 .1 r
.61161 .38304 m
.627 .39861 L
s
.60544 .3768 m
.60984 .38125 L
s
.781 .227 .1 r
.63608 .40063 m .64453 .39212 L .61907 .38488 L p F P
0 0 0 r
s
.156 .259 .536 r
.60862 .38077 m .61907 .38488 L .64453 .39212 L p F P
0 0 0 r
s
.194 .255 .473 r
.40059 .61192 m .38358 .60673 L .37711 .59183 L p F P
0 0 0 r
s
.24 .35 .67 r
.39308 .58549 m
.39622 .60528 L
s
.194 .255 .473 r
.35894 .58623 m .37711 .59183 L .38358 .60673 L p F P
0 0 0 r
s
.83 .24 .1 r
.30972 .62287 m
.29222 .64242 L
s
.29222 .64242 m
.30936 .66741 L
s
1 .331 .136 r
.42407 .37715 m .41825 .38429 L .40076 .39141 L p F P
0 0 0 r
s
1 .331 .136 r
.3939 .39993 m .40076 .39141 L .41825 .38429 L p F P
0 0 0 r
s
.221 .299 .561 r
.35894 .58623 m .34058 .58056 L .33609 .56331 L p F P
0 0 0 r
s
.221 .299 .561 r
.317 .55733 m .33609 .56331 L .34058 .58056 L p F P
0 0 0 r
s
1 .332 .138 r
.45109 .36347 m .44648 .36904 L .42995 .36993 L p F P
0 0 0 r
s
.24 .35 .67 r
.42059 .36752 m
.4349 .34977 L
s
1 .332 .138 r
.42407 .37715 m .42995 .36993 L .44648 .36904 L p F P
0 0 0 r
s
.079 .091 .174 r
.53238 .6699 m .5215 .66664 L .52542 .66541 L p F P
0 0 0 r
s
.83 .24 .1 r
.52195 .68048 m
.53444 .66968 L
s
.079 .091 .174 r
.51249 .66153 m .52542 .66541 L .5215 .66664 L p F P
0 0 0 r
s
.255 .392 .783 r
.50024 .35514 m .50591 .35734 L .50882 .34824 L p F P
0 0 0 r
s
.255 .392 .783 r
.51724 .35153 m .50882 .34824 L .50591 .35734 L p F P
0 0 0 r
s
.24 .35 .67 r
.24456 .48718 m
.25106 .45896 L
s
.21165 .44579 m
.25106 .45896 L
s
.161 .046 .023 r
.61232 .58964 m .6235 .57985 L .62698 .56257 L p F P
0 0 0 r
s
.161 .046 .023 r
.63873 .55216 m .62698 .56257 L .6235 .57985 L p F P
0 0 0 r
s
.83 .24 .1 r
.62494 .56781 m
.62616 .5437 L
s
.273 .073 .037 r
.62698 .56257 m .63873 .55216 L .63917 .53352 L p F P
0 0 0 r
s
.391 .108 .052 r
.63917 .53352 m .65118 .52271 L .64804 .50364 L p F P
0 0 0 r
s
.273 .073 .037 r
.65118 .52271 m .63917 .53352 L .63873 .55216 L p F P
0 0 0 r
s
.112 .127 .241 r
.48633 .65367 m .4731 .64969 L .46966 .64252 L p F P
0 0 0 r
s
.112 .127 .241 r
.45461 .63797 m .46966 .64252 L .4731 .64969 L p F P
0 0 0 r
s
.216 .343 .692 r
.55051 .36456 m .55873 .36778 L .5769 .36829 L p F P
0 0 0 r
s
.83 .24 .1 r
.57065 .36972 m
.5721 .36815 L
s
.57254 .36767 m
.58137 .35808 L
s
.216 .343 .692 r
.58754 .37248 m .5769 .36829 L .55873 .36778 L p F P
0 0 0 r
s
.83 .24 .1 r
.58137 .35808 m
.60544 .3768 L
s
.24 .35 .67 r
.57322 .37239 m
.60147 .38346 L
s
.55818 .37904 m
.57322 .37239 L
s
.83 .24 .1 r
.60429 .33319 m
.58137 .35808 L
s
.58137 .35808 m
.55561 .34314 L
s
1 .324 .136 r
.47986 .35233 m .47664 .35616 L .46514 .34646 L p F P
0 0 0 r
s
1 .324 .136 r
.46041 .35218 m .46514 .34646 L .47664 .35616 L p F P
0 0 0 r
s
.153 .191 .345 r
.43942 .63338 m .4241 .62875 L .41744 .61706 L p F P
0 0 0 r
s
.153 .191 .345 r
.40059 .61192 m .41744 .61706 L .4241 .62875 L p F P
0 0 0 r
s
.24 .35 .67 r
.39622 .60528 m
.43339 .61668 L
s
.7518 .44478 m
.78553 .45797 L
s
.78553 .45797 m
.79476 .47606 L
s
.391 .108 .052 r
.65998 .49268 m .64804 .50364 L .65118 .52271 L p F P
0 0 0 r
s
.497 .14 .065 r
.64804 .50364 m .65998 .49268 L .65278 .47417 L p F P
0 0 0 r
s
.83 .24 .1 r
.64531 .49687 m
.64969 .52248 L
s
.24 .33 .624 r
.317 .55733 m .2977 .55129 L .29704 .53263 L p F P
0 0 0 r
s
.143 .041 .02 r
.29704 .53263 m .30586 .5218 L .30989 .50274 L p F P
0 0 0 r
s
.212 .061 .032 r
.30586 .5218 m .29704 .53263 L .2977 .55129 L p F P
0 0 0 r
s
.24 .35 .67 r
.27965 .52614 m
.29766 .53188 L
s
.30263 .53346 m
.31818 .53841 L
s
.39742 .33542 m
.4349 .34977 L
s
.83 .24 .1 r
.33084 .68948 m
.35557 .70747 L
s
.37428 .6891 m
.35557 .70747 L
s
.24 .35 .67 r
.2421 .35916 m
.28123 .37326 L
s
.28123 .37326 m
.29372 .3475 L
s
.083 .024 .01 r
.55389 .65578 m .56186 .64891 L .56976 .64163 L p F P
0 0 0 r
s
.083 .024 .01 r
.57894 .63371 m .56976 .64163 L .56186 .64891 L p F P
0 0 0 r
s
.084 .024 .01 r
.59602 .61367 m .60639 .60468 L .61232 .58964 L p F P
0 0 0 r
s
.084 .024 .01 r
.6235 .57985 m .61232 .58964 L .60639 .60468 L p F P
0 0 0 r
s
.83 .24 .1 r
.60199 .58809 m
.62494 .56781 L
s
.723 .209 .093 r
.64726 .42146 m .65703 .41186 L .63608 .40063 L p F P
0 0 0 r
s
.723 .209 .093 r
.64453 .39212 m .63608 .40063 L .65703 .41186 L p F P
0 0 0 r
s
.83 .24 .1 r
.627 .39861 m
.64529 .42275 L
s
.24 .35 .67 r
.64631 .39492 m
.65797 .39951 L
s
.255 .392 .783 r
.49454 .35293 m .50024 .35514 L .50035 .34492 L p F P
0 0 0 r
s
.255 .392 .783 r
.50882 .34824 m .50035 .34492 L .50024 .35514 L p F P
0 0 0 r
s
.083 .024 .01 r
.30989 .50274 m .31872 .49177 L .32689 .47328 L p F P
0 0 0 r
s
.143 .041 .02 r
.31872 .49177 m .30989 .50274 L .30586 .5218 L p F P
0 0 0 r
s
.497 .14 .065 r
.66433 .46335 m .65278 .47417 L .65998 .49268 L p F P
0 0 0 r
s
.585 .167 .076 r
.65278 .47417 m .66433 .46335 L .65271 .44636 L p F P
0 0 0 r
s
1 .316 .128 r
.40076 .39141 m .3939 .39993 L .37755 .41106 L p F P
0 0 0 r
s
1 .316 .128 r
.36986 .42067 m .37755 .41106 L .3939 .39993 L p F P
0 0 0 r
s
.24 .35 .67 r
.62512 .68938 m
.60893 .69076 L
s
.57327 .68005 m
.60893 .69076 L
s
.156 .259 .536 r
.59811 .37664 m .60862 .38077 L .63195 .38715 L p F P
0 0 0 r
s
.156 .259 .536 r
.64453 .39212 m .63195 .38715 L .60862 .38077 L p F P
0 0 0 r
s
.83 .24 .1 r
.627 .39861 m
.63595 .38953 L
s
.944 .288 .117 r
.53238 .6699 m .53891 .66424 L .54602 .66257 L p F P
0 0 0 r
s
.24 .35 .67 r
.52369 .66456 m
.53471 .66787 L
s
.944 .288 .117 r
.55389 .65578 m .54602 .66257 L .53891 .66424 L p F P
0 0 0 r
s
.83 .24 .1 r
.54422 .66124 m
.56063 .64757 L
s
.585 .167 .076 r
.66353 .43599 m .65271 .44636 L .66433 .46335 L p F P
0 0 0 r
s
.83 .24 .1 r
.63592 .47093 m
.65961 .44838 L
s
.659 .189 .085 r
.65271 .44636 m .66353 .43599 L .64726 .42146 L p F P
0 0 0 r
s
.659 .189 .085 r
.65703 .41186 m .64726 .42146 L .66353 .43599 L p F P
0 0 0 r
s
.83 .24 .1 r
.64529 .42275 m
.65961 .44838 L
s
.083 .024 .01 r
.32689 .47328 m .33554 .46244 L .34719 .44551 L p F P
0 0 0 r
s
.83 .24 .1 r
.34129 .45541 m
.35664 .43953 L
s
.083 .024 .01 r
.33554 .46244 m .32689 .47328 L .31872 .49177 L p F P
0 0 0 r
s
.83 .24 .1 r
.33521 .46303 m
.34129 .45541 L
s
.32723 .64825 m
.30936 .66741 L
s
.30936 .66741 m
.33084 .68948 L
s
.29096 .56878 m
.29745 .5959 L
s
.24 .35 .67 r
.74754 .71367 m
.76652 .70035 L
s
.71334 .70319 m
.74754 .71367 L
s
.216 .343 .692 r
.54226 .36133 m .55051 .36456 L .56619 .36407 L p F P
0 0 0 r
s
.216 .343 .692 r
.5769 .36829 m .56619 .36407 L .55051 .36456 L p F P
0 0 0 r
s
.83 .24 .1 r
.47599 .69373 m
.50065 .68986 L
s
.52212 .67112 m
.50065 .68986 L
s
.918 .277 .11 r
.37755 .41106 m .36986 .42067 L .35547 .43512 L p F P
0 0 0 r
s
.83 .24 .1 r
.37514 .41644 m
.39454 .40557 L
s
.918 .277 .11 r
.34719 .44551 m .35547 .43512 L .36986 .42067 L p F P
0 0 0 r
s
.83 .24 .1 r
.35664 .43953 m
.37514 .41644 L
s
.083 .024 .01 r
.35547 .43512 m .34719 .44551 L .33554 .46244 L p F P
0 0 0 r
s
.255 .392 .783 r
.48883 .35071 m .49454 .35293 L .49185 .34159 L p F P
0 0 0 r
s
.255 .392 .783 r
.50035 .34492 m .49185 .34159 L .49454 .35293 L p F P
0 0 0 r
s
.24 .35 .67 r
.48626 .35113 m
.5226 .36523 L
s
.079 .091 .174 r
.5215 .66664 m .51056 .66335 L .51249 .66153 L p F P
0 0 0 r
s
.24 .35 .67 r
.51312 .6542 m
.52369 .66456 L
s
.079 .091 .174 r
.49946 .65761 m .51249 .66153 L .51056 .66335 L p F P
0 0 0 r
s
.83 .24 .1 r
.34913 .67073 m
.33084 .68948 L
s
1 .324 .136 r
.4831 .34848 m .47986 .35233 L .4699 .3407 L p F P
0 0 0 r
s
.83 .24 .1 r
.48157 .35198 m
.4912 .35395 L
s
.24 .35 .67 r
.48083 .35583 m
.48626 .35113 L
s
1 .324 .136 r
.46514 .34646 m .4699 .3407 L .47986 .35233 L p F P
0 0 0 r
s
.83 .24 .1 r
.46118 .37619 m
.48157 .35198 L
s
1 .332 .138 r
.45573 .35785 m .45109 .36347 L .43589 .36264 L p F P
0 0 0 r
s
1 .332 .138 r
.42995 .36993 m .43589 .36264 L .45109 .36347 L p F P
0 0 0 r
s
.083 .024 .01 r
.57894 .63371 m .58826 .62567 L .59602 .61367 L p F P
0 0 0 r
s
.083 .024 .01 r
.60639 .60468 m .59602 .61367 L .58826 .62567 L p F P
0 0 0 r
s
.194 .255 .473 r
.38358 .60673 m .3664 .60149 L .35894 .58623 L p F P
0 0 0 r
s
.194 .255 .473 r
.34058 .58056 m .35894 .58623 L .3664 .60149 L p F P
0 0 0 r
s
.112 .127 .241 r
.4731 .64969 m .45977 .64568 L .45461 .63797 L p F P
0 0 0 r
s
.112 .127 .241 r
.43942 .63338 m .45461 .63797 L .45977 .64568 L p F P
0 0 0 r
s
.221 .299 .561 r
.34058 .58056 m .32204 .57484 L .317 .55733 L p F P
0 0 0 r
s
.221 .299 .561 r
.2977 .55129 m .317 .55733 L .32204 .57484 L p F P
0 0 0 r
s
.24 .35 .67 r
.31743 .56189 m
.35566 .57381 L
s
.31743 .56189 m
.31818 .53841 L
s
.255 .392 .783 r
.4831 .34848 m .48883 .35071 L .4833 .33825 L p F P
0 0 0 r
s
.255 .392 .783 r
.49185 .34159 m .4833 .33825 L .48883 .35071 L p F P
0 0 0 r
s
1 .331 .136 r
.42995 .36993 m .42407 .37715 L .40771 .38278 L p F P
0 0 0 r
s
1 .331 .136 r
.40076 .39141 m .40771 .38278 L .42407 .37715 L p F P
0 0 0 r
s
.24 .35 .67 r
.70596 .41908 m
.71735 .4313 L
s
.156 .259 .536 r
.58754 .37248 m .59811 .37664 L .61926 .38215 L p F P
0 0 0 r
s
.156 .259 .536 r
.63195 .38715 m .61926 .38215 L .59811 .37664 L p F P
0 0 0 r
s
.24 .35 .67 r
.61259 .38608 m
.62297 .38573 L
s
.216 .343 .692 r
.53396 .35808 m .54226 .36133 L .55541 .35983 L p F P
0 0 0 r
s
.83 .24 .1 r
.54173 .35872 m
.55561 .34314 L
s
.216 .343 .692 r
.56619 .36407 m .55541 .35983 L .54226 .36133 L p F P
0 0 0 r
s
.24 .35 .67 r
.79476 .47606 m
.82818 .48898 L
s
.83415 .51203 m
.82818 .48898 L
s
.153 .191 .345 r
.4241 .62875 m .40864 .62408 L .40059 .61192 L p F P
0 0 0 r
s
.153 .191 .345 r
.38358 .60673 m .40059 .61192 L .40864 .62408 L p F P
0 0 0 r
s
.83 .24 .1 r
.57817 .31784 m
.55561 .34314 L
s
.55561 .34314 m
.52908 .33257 L
s
.24 .35 .67 r
.47987 .34865 m
.48626 .35113 L
s
.83 .24 .1 r
.40133 .70243 m
.42888 .71013 L
s
.44907 .69171 m
.42888 .71013 L
s
.24 .35 .67 r
.27965 .52614 m
.24029 .51361 L
s
.27838 .54971 m
.27965 .52614 L
s
1 .324 .136 r
.4699 .3407 m .47471 .33488 L .4831 .34848 L p F P
0 0 0 r
s
.255 .392 .783 r
.4833 .33825 m .47471 .33488 L .4831 .34848 L p F P
0 0 0 r
s
.83 .24 .1 r
.48157 .35198 m
.48519 .34768 L
s
.24 .35 .67 r
.24029 .51361 m
.24456 .48718 L
s
.2048 .47422 m
.24456 .48718 L
s
.079 .091 .174 r
.51056 .66335 m .49954 .66005 L .49946 .65761 L p F P
0 0 0 r
s
.079 .091 .174 r
.48633 .65367 m .49946 .65761 L .49954 .66005 L p F P
0 0 0 r
s
.24 .35 .67 r
.21165 .44579 m
.22036 .41649 L
s
.18033 .40277 m
.22036 .41649 L
s
.22036 .41649 m
.23062 .3873 L
s
.19069 .37325 m
.23062 .3873 L
s
.23062 .3873 m
.2421 .35916 L
s
.216 .343 .692 r
.52562 .35482 m .53396 .35808 L .54456 .35556 L p F P
0 0 0 r
s
.216 .343 .692 r
.55541 .35983 m .54456 .35556 L .53396 .35808 L p F P
0 0 0 r
s
.24 .35 .67 r
.5226 .36523 m
.53719 .35827 L
s
1 .332 .138 r
.46041 .35218 m .45573 .35785 L .4419 .35525 L p F P
0 0 0 r
s
1 .332 .138 r
.43589 .36264 m .4419 .35525 L .45573 .35785 L p F P
0 0 0 r
s
.723 .209 .093 r
.65703 .41186 m .66696 .40212 L .64453 .39212 L p F P
0 0 0 r
s
.073 .085 .164 r
.63195 .38715 m .64453 .39212 L .66696 .40212 L p F P
0 0 0 r
s
.24 .35 .67 r
.62297 .38573 m
.63641 .39102 L
s
.83 .24 .1 r
.63651 .38896 m
.63671 .38876 L
s
.24 .35 .67 r
.6784 .69249 m
.66045 .70007 L
s
.62512 .68938 m
.66045 .70007 L
s
.156 .259 .536 r
.5769 .36829 m .58754 .37248 L .60648 .37711 L p F P
0 0 0 r
s
.156 .259 .536 r
.61926 .38215 m .60648 .37711 L .58754 .37248 L p F P
0 0 0 r
s
1 .316 .128 r
.40771 .38278 m .40076 .39141 L .38535 .4013 L p F P
0 0 0 r
s
1 .316 .128 r
.37755 .41106 m .38535 .4013 L .40076 .39141 L p F P
0 0 0 r
s
.24 .35 .67 r
.25443 .33302 m
.29372 .3475 L
s
.29372 .3475 m
.30679 .32471 L
s
.083 .024 .01 r
.56186 .64891 m .56994 .64194 L .57894 .63371 L p F P
0 0 0 r
s
.083 .024 .01 r
.58826 .62567 m .57894 .63371 L .56994 .64194 L p F P
0 0 0 r
s
.83 .24 .1 r
.56063 .64757 m
.58302 .62821 L
s
.24 .35 .67 r
.30679 .32471 m
.34553 .33929 L
s
.34553 .33929 m
.35912 .32076 L
s
.944 .288 .117 r
.53891 .66424 m .54551 .65851 L .55389 .65578 L p F P
0 0 0 r
s
.944 .288 .117 r
.56186 .64891 m .55389 .65578 L .54551 .65851 L p F P
0 0 0 r
s
.112 .127 .241 r
.45977 .64568 m .44633 .64165 L .43942 .63338 L p F P
0 0 0 r
s
.112 .127 .241 r
.4241 .62875 m .43942 .63338 L .44633 .64165 L p F P
0 0 0 r
s
.24 .35 .67 r
.44001 .63207 m
.47695 .64326 L
s
.43339 .61668 m
.44001 .63207 L
s
.161 .046 .023 r
.6235 .57985 m .63489 .56989 L .63873 .55216 L p F P
0 0 0 r
s
.161 .046 .023 r
.65069 .54156 m .63873 .55216 L .63489 .56989 L p F P
0 0 0 r
s
.273 .073 .037 r
.63873 .55216 m .65069 .54156 L .65118 .52271 L p F P
0 0 0 r
s
.83 .24 .1 r
.62616 .5437 m
.64969 .52248 L
s
.391 .108 .052 r
.65118 .52271 m .66341 .51169 L .65998 .49268 L p F P
0 0 0 r
s
.273 .073 .037 r
.66341 .51169 m .65118 .52271 L .65069 .54156 L p F P
0 0 0 r
s
.194 .255 .473 r
.3664 .60149 m .34906 .5962 L .34058 .58056 L p F P
0 0 0 r
s
.24 .35 .67 r
.35566 .57381 m
.35825 .59364 L
s
.194 .255 .473 r
.32204 .57484 m .34058 .58056 L .34906 .5962 L p F P
0 0 0 r
s
.659 .189 .085 r
.66353 .43599 m .67453 .42545 L .65703 .41186 L p F P
0 0 0 r
s
.659 .189 .085 r
.66696 .40212 m .65703 .41186 L .67453 .42545 L p F P
0 0 0 r
s
.24 .35 .67 r
.67123 .40542 m
.70596 .41908 L
s
.66749 .40375 m
.67123 .40542 L
s
.391 .108 .052 r
.67215 .48152 m .65998 .49268 L .66341 .51169 L p F P
0 0 0 r
s
.497 .14 .065 r
.65998 .49268 m .67215 .48152 L .66433 .46335 L p F P
0 0 0 r
s
.221 .299 .561 r
.32204 .57484 m .3033 .56905 L .2977 .55129 L p F P
0 0 0 r
s
.212 .061 .032 r
.2977 .55129 m .30649 .54067 L .30586 .5218 L p F P
0 0 0 r
s
.34 .095 .048 r
.30649 .54067 m .2977 .55129 L .3033 .56905 L p F P
0 0 0 r
s
.24 .35 .67 r
.27838 .54971 m
.29886 .5561 L
s
.83 .24 .1 r
.29096 .56878 m
.29986 .55813 L
s
.24 .35 .67 r
.29886 .5561 m
.29996 .55645 L
s
.30456 .55788 m
.31743 .56189 L
s
.084 .024 .01 r
.60639 .60468 m .61693 .59554 L .6235 .57985 L p F P
0 0 0 r
s
.084 .024 .01 r
.63489 .56989 m .6235 .57985 L .61693 .59554 L p F P
0 0 0 r
s
.83 .24 .1 r
.61828 .58962 m
.62494 .56781 L
s
.216 .343 .692 r
.51724 .35153 m .52562 .35482 L .53364 .35127 L p F P
0 0 0 r
s
.216 .343 .692 r
.54456 .35556 m .53364 .35127 L .52562 .35482 L p F P
0 0 0 r
s
.143 .041 .02 r
.30586 .5218 m .31484 .51077 L .31872 .49177 L p F P
0 0 0 r
s
.212 .061 .032 r
.31484 .51077 m .30586 .5218 L .30649 .54067 L p F P
0 0 0 r
s
.153 .191 .345 r
.40864 .62408 m .39305 .61936 L .38358 .60673 L p F P
0 0 0 r
s
.153 .191 .345 r
.3664 .60149 m .38358 .60673 L .39305 .61936 L p F P
0 0 0 r
s
.24 .35 .67 r
.35825 .59364 m
.39622 .60528 L
s
1 .331 .136 r
.43589 .36264 m .42995 .36993 L .41476 .37403 L p F P
0 0 0 r
s
1 .331 .136 r
.40771 .38278 m .41476 .37403 L .42995 .36993 L p F P
0 0 0 r
s
.83 .24 .1 r
.39454 .40557 m
.41383 .38174 L
s
.41383 .38174 m
.43645 .3763 L
s
.24 .35 .67 r
.2048 .47422 m
.21165 .44579 L
s
.17139 .43234 m
.21165 .44579 L
s
.497 .14 .065 r
.67609 .45233 m .66433 .46335 L .67215 .48152 L p F P
0 0 0 r
s
.83 .24 .1 r
.64531 .49687 m
.66938 .47461 L
s
.585 .167 .076 r
.66433 .46335 m .67609 .45233 L .66353 .43599 L p F P
0 0 0 r
s
.918 .277 .11 r
.38535 .4013 m .37755 .41106 L .36389 .42456 L p F P
0 0 0 r
s
.918 .277 .11 r
.35547 .43512 m .36389 .42456 L .37755 .41106 L p F P
0 0 0 r
s
.585 .167 .076 r
.67453 .42545 m .66353 .43599 L .67609 .45233 L p F P
0 0 0 r
s
.83 .24 .1 r
.65961 .44838 m
.66938 .47461 L
s
.083 .024 .01 r
.31872 .49177 m .32772 .48059 L .33554 .46244 L p F P
0 0 0 r
s
.143 .041 .02 r
.32772 .48059 m .31872 .49177 L .31484 .51077 L p F P
0 0 0 r
s
.079 .091 .174 r
.49954 .66005 m .48846 .65673 L .48633 .65367 L p F P
0 0 0 r
s
.079 .091 .174 r
.4731 .64969 m .48633 .65367 L .48846 .65673 L p F P
0 0 0 r
s
.083 .024 .01 r
.33554 .46244 m .34436 .45141 L .35547 .43512 L p F P
0 0 0 r
s
.083 .024 .01 r
.34436 .45141 m .33554 .46244 L .32772 .48059 L p F P
0 0 0 r
s
.83 .24 .1 r
.33077 .47567 m
.33331 .47079 L
s
.32991 .47674 m
.33077 .47567 L
s
.24 .35 .67 r
.71735 .4313 m
.7518 .44478 L
s
.7518 .44478 m
.7606 .46286 L
s
.083 .024 .01 r
.36389 .42456 m .35547 .43512 L .34436 .45141 L p F P
0 0 0 r
s
.83 .24 .1 r
.29745 .5959 m
.30972 .62287 L
s
.24 .35 .67 r
.35912 .32076 m
.39742 .33542 L
s
.39742 .33542 m
.41122 .322 L
s
.156 .259 .536 r
.56619 .36407 m .5769 .36829 L .5936 .37203 L p F P
0 0 0 r
s
.24 .35 .67 r
.53719 .35827 m
.57322 .37239 L
s
.156 .259 .536 r
.60648 .37711 m .5936 .37203 L .5769 .36829 L p F P
0 0 0 r
s
.83 .24 .1 r
.60551 .37673 m
.62876 .35232 L
s
.24 .35 .67 r
.20212 .34475 m
.2421 .35916 L
s
.2421 .35916 m
.25443 .33302 L
s
.073 .085 .164 r
.61926 .38215 m .63195 .38715 L .65251 .39642 L p F P
0 0 0 r
s
.073 .085 .164 r
.66696 .40212 m .65251 .39642 L .63195 .38715 L p F P
0 0 0 r
s
1 .332 .138 r
.46514 .34646 m .46041 .35218 L .44798 .34779 L p F P
0 0 0 r
s
1 .332 .138 r
.4419 .35525 m .44798 .34779 L .46041 .35218 L p F P
0 0 0 r
s
.83 .24 .1 r
.45662 .3518 m
.48157 .35198 L
s
.083 .024 .01 r
.58826 .62567 m .59772 .6175 L .60639 .60468 L p F P
0 0 0 r
s
.83 .24 .1 r
.58302 .62821 m
.59515 .60977 L
s
.083 .024 .01 r
.61693 .59554 m .60639 .60468 L .59772 .6175 L p F P
0 0 0 r
s
.83 .24 .1 r
.59515 .60977 m
.61828 .58962 L
s
.216 .343 .692 r
.50882 .34824 m .51724 .35153 L .52265 .34694 L p F P
0 0 0 r
s
.216 .343 .692 r
.53364 .35127 m .52265 .34694 L .51724 .35153 L p F P
0 0 0 r
s
.83 .24 .1 r
.51611 .34755 m
.52908 .33257 L
s
.24 .35 .67 r
.58901 .67847 m
.57327 .68005 L
s
.112 .127 .241 r
.44633 .64165 m .43279 .63758 L .4241 .62875 L p F P
0 0 0 r
s
.112 .127 .241 r
.40864 .62408 m .4241 .62875 L .43279 .63758 L p F P
0 0 0 r
s
.24 .35 .67 r
.73206 .68959 m
.71334 .70319 L
s
.6784 .69249 m
.71334 .70319 L
s
.83 .24 .1 r
.55131 .30686 m
.52908 .33257 L
s
.52908 .33257 m
.50272 .32686 L
s
.15 .249 .511 r
.5215 .66664 m .53238 .6699 L .52548 .66634 L p F P
0 0 0 r
s
1 .315 .13 r
.53891 .66424 m .53238 .6699 L .52548 .66634 L p F P
0 0 0 r
s
.24 .35 .67 r
.53303 .66778 m
.53361 .66798 L
s
.52369 .66456 m
.5278 .66598 L
s
.83 .24 .1 r
.52212 .67112 m
.52736 .66884 L
s
.53743 .66447 m
.53986 .66341 L
s
.52736 .66884 m
.5283 .66843 L
s
.24 .35 .67 r
.53684 .6691 m
.57327 .68005 L
s
.53361 .66798 m
.53684 .6691 L
s
.83 .24 .1 r
.37428 .6891 m
.40133 .70243 L
s
.42116 .68372 m
.40133 .70243 L
s
.194 .255 .473 r
.34906 .5962 m .33155 .59086 L .32204 .57484 L p F P
0 0 0 r
s
.194 .255 .473 r
.3033 .56905 m .32204 .57484 L .33155 .59086 L p F P
0 0 0 r
s
.079 .091 .174 r
.48846 .65673 m .4773 .65338 L .4731 .64969 L p F P
0 0 0 r
s
.24 .35 .67 r
.48699 .65352 m
.52369 .66456 L
s
.079 .091 .174 r
.45977 .64568 m .4731 .64969 L .4773 .65338 L p F P
0 0 0 r
s
.24 .35 .67 r
.47695 .64326 m
.48699 .65352 L
s
.156 .259 .536 r
.55541 .35983 m .56619 .36407 L .58062 .36691 L p F P
0 0 0 r
s
.156 .259 .536 r
.5936 .37203 m .58062 .36691 L .56619 .36407 L p F P
0 0 0 r
s
.24 .35 .67 r
.57322 .37239 m
.58721 .37165 L
s
.83 .24 .1 r
.44907 .69171 m
.47599 .69373 L
s
.49725 .67484 m
.47599 .69373 L
s
.216 .343 .692 r
.50035 .34492 m .50882 .34824 L .51159 .34259 L p F P
0 0 0 r
s
.216 .343 .692 r
.52265 .34694 m .51159 .34259 L .50882 .34824 L p F P
0 0 0 r
s
1 .316 .128 r
.41476 .37403 m .40771 .38278 L .39327 .3914 L p F P
0 0 0 r
s
1 .316 .128 r
.38535 .4013 m .39327 .3914 L .40771 .38278 L p F P
0 0 0 r
s
.153 .191 .345 r
.39305 .61936 m .37732 .61461 L .3664 .60149 L p F P
0 0 0 r
s
.153 .191 .345 r
.34906 .5962 m .3664 .60149 L .37732 .61461 L p F P
0 0 0 r
s
.944 .288 .117 r
.54551 .65851 m .55219 .65272 L .56186 .64891 L p F P
0 0 0 r
s
.944 .288 .117 r
.56994 .64194 m .56186 .64891 L .55219 .65272 L p F P
0 0 0 r
s
.073 .085 .164 r
.60648 .37711 m .61926 .38215 L .63793 .39068 L p F P
0 0 0 r
s
.073 .085 .164 r
.65251 .39642 m .63793 .39068 L .61926 .38215 L p F P
0 0 0 r
s
.83 .24 .1 r
.63671 .38876 m
.65073 .37452 L
s
1 .331 .136 r
.4419 .35525 m .43589 .36264 L .4219 .36516 L p F P
0 0 0 r
s
.83 .24 .1 r
.43645 .3763 m
.45662 .3518 L
s
1 .331 .136 r
.41476 .37403 m .4219 .36516 L .43589 .36264 L p F P
0 0 0 r
s
.24 .35 .67 r
.66756 .40397 m
.67123 .40542 L
s
.7606 .46286 m
.79476 .47606 L
s
.79476 .47606 m
.80034 .49919 L
s
.083 .024 .01 r
.56994 .64194 m .57813 .63487 L .58826 .62567 L p F P
0 0 0 r
s
.083 .024 .01 r
.59772 .6175 m .58826 .62567 L .57813 .63487 L p F P
0 0 0 r
s
.24 .35 .67 r
.76652 .70035 m
.78489 .68126 L
s
.73206 .68959 m
.76652 .70035 L
s
1 .332 .138 r
.4699 .3407 m .46514 .34646 L .45413 .34025 L p F P
0 0 0 r
s
1 .332 .138 r
.44798 .34779 m .45413 .34025 L .46514 .34646 L p F P
0 0 0 r
s
.24 .35 .67 r
.44915 .33672 m
.45856 .34037 L
s
.4349 .34977 m
.44915 .33672 L
s
.41122 .322 m
.44915 .33672 L
s
.83 .24 .1 r
.65073 .37452 m
.62876 .35232 L
s
.65295 .32691 m
.62876 .35232 L
s
.62876 .35232 m
.60429 .33319 L
s
.15 .249 .511 r
.52548 .66634 m .51691 .66377 L .5215 .66664 L p F P
0 0 0 r
s
.15 .249 .511 r
.51056 .66335 m .5215 .66664 L .51691 .66377 L p F P
0 0 0 r
s
.24 .35 .67 r
.24029 .51361 m
.20007 .50081 L
s
.23848 .53727 m
.24029 .51361 L
s
.83 .24 .1 r
.67536 .34952 m
.65073 .37452 L
s
.216 .343 .692 r
.49185 .34159 m .50035 .34492 L .50046 .33821 L p F P
0 0 0 r
s
.216 .343 .692 r
.51159 .34259 m .50046 .33821 L .50035 .34492 L p F P
0 0 0 r
s
.24 .35 .67 r
.48626 .35113 m
.50039 .34385 L
s
.659 .189 .085 r
.67453 .42545 m .68572 .41472 L .66696 .40212 L p F P
0 0 0 r
s
.109 .123 .235 r
.65251 .39642 m .66696 .40212 L .68572 .41472 L p F P
0 0 0 r
s
.83 .24 .1 r
.65073 .37452 m
.66944 .39903 L
s
.66644 .40197 m
.66944 .39903 L
s
.66632 .40209 m
.66644 .40197 L
s
.64529 .42275 m
.66506 .40333 L
s
.24 .35 .67 r
.20007 .50081 m
.2048 .47422 L
s
.16417 .46098 m
.2048 .47422 L
s
.112 .127 .241 r
.43279 .63758 m .41915 .63348 L .40864 .62408 L p F P
0 0 0 r
s
.112 .127 .241 r
.39305 .61936 m .40864 .62408 L .41915 .63348 L p F P
0 0 0 r
s
.24 .35 .67 r
.40228 .62065 m
.44001 .63207 L
s
.39622 .60528 m
.40228 .62065 L
s
.83 .24 .1 r
.30972 .62287 m
.32723 .64825 L
s
.24 .35 .67 r
.17139 .43234 m
.18033 .40277 L
s
.18033 .40277 m
.19069 .37325 L
s
.156 .259 .536 r
.54456 .35556 m .55541 .35983 L .56754 .36175 L p F P
0 0 0 r
s
.156 .259 .536 r
.58062 .36691 m .56754 .36175 L .55541 .35983 L p F P
0 0 0 r
s
.918 .277 .11 r
.39327 .3914 m .38535 .4013 L .37245 .41382 L p F P
0 0 0 r
s
.918 .277 .11 r
.36389 .42456 m .37245 .41382 L .38535 .4013 L p F P
0 0 0 r
s
.24 .35 .67 r
.19069 .37325 m
.20212 .34475 L
s
.80034 .49919 m
.83415 .51203 L
s
.83598 .53904 m
.83415 .51203 L
s
.079 .091 .174 r
.4773 .65338 m .46607 .65002 L .45977 .64568 L p F P
0 0 0 r
s
.079 .091 .174 r
.44633 .64165 m .45977 .64568 L .46607 .65002 L p F P
0 0 0 r
s
.161 .046 .023 r
.63489 .56989 m .64648 .55974 L .65069 .54156 L p F P
0 0 0 r
s
.161 .046 .023 r
.66287 .53076 m .65069 .54156 L .64648 .55974 L p F P
0 0 0 r
s
.83 .24 .1 r
.64874 .54677 m
.64969 .52248 L
s
.273 .073 .037 r
.65069 .54156 m .66287 .53076 L .66341 .51169 L p F P
0 0 0 r
s
.391 .108 .052 r
.66341 .51169 m .67587 .50047 L .67215 .48152 L p F P
0 0 0 r
s
.273 .073 .037 r
.67587 .50047 m .66341 .51169 L .66287 .53076 L p F P
0 0 0 r
s
.084 .024 .01 r
.61693 .59554 m .62765 .58624 L .63489 .56989 L p F P
0 0 0 r
s
.084 .024 .01 r
.64648 .55974 m .63489 .56989 L .62765 .58624 L p F P
0 0 0 r
s
.83 .24 .1 r
.62494 .56781 m
.64874 .54677 L
s
.585 .167 .076 r
.67609 .45233 m .68806 .44112 L .67453 .42545 L p F P
0 0 0 r
s
.585 .167 .076 r
.68572 .41472 m .67453 .42545 L .68806 .44112 L p F P
0 0 0 r
s
.24 .35 .67 r
.64269 .68155 m
.62512 .68938 L
s
.58901 .67847 m
.62512 .68938 L
s
.83 .24 .1 r
.62808 .30736 m
.60429 .33319 L
s
.60429 .33319 m
.57817 .31784 L
s
1 .315 .13 r
.52548 .66634 m .53058 .66188 L .53891 .66424 L p F P
0 0 0 r
s
1 .315 .13 r
.54551 .65851 m .53891 .66424 L .53058 .66188 L p F P
0 0 0 r
s
.24 .35 .67 r
.21428 .31822 m
.25443 .33302 L
s
.25443 .33302 m
.26721 .30982 L
s
.391 .108 .052 r
.68455 .47015 m .67215 .48152 L .67587 .50047 L p F P
0 0 0 r
s
.497 .14 .065 r
.67215 .48152 m .68455 .47015 L .67609 .45233 L p F P
0 0 0 r
s
.83 .24 .1 r
.66938 .47461 m
.67411 .50047 L
s
.212 .061 .032 r
.30649 .54067 m .31545 .52985 L .31484 .51077 L p F P
0 0 0 r
s
.34 .095 .048 r
.31545 .52985 m .30649 .54067 L .3119 .55889 L p F P
0 0 0 r
s
.34 .095 .048 r
.3033 .56905 m .3119 .55889 L .30649 .54067 L p F P
0 0 0 r
s
.24 .35 .67 r
.26721 .30982 m
.30679 .32471 L
s
.30679 .32471 m
.32 .30578 L
s
.83 .24 .1 r
.34913 .67073 m
.37428 .6891 L
s
.3937 .67003 m
.37428 .6891 L
s
.073 .085 .164 r
.5936 .37203 m .60648 .37711 L .62322 .38488 L p F P
0 0 0 r
s
.073 .085 .164 r
.63793 .39068 m .62322 .38488 L .60648 .37711 L p F P
0 0 0 r
s
.24 .35 .67 r
.58721 .37165 m
.62297 .38573 L
s
.497 .14 .065 r
.68806 .44112 m .67609 .45233 L .68455 .47015 L p F P
0 0 0 r
s
.83 .24 .1 r
.65961 .44838 m
.68419 .42499 L
s
.143 .041 .02 r
.31484 .51077 m .32399 .49953 L .32772 .48059 L p F P
0 0 0 r
s
.212 .061 .032 r
.32399 .49953 m .31484 .51077 L .31545 .52985 L p F P
0 0 0 r
s
.24 .35 .67 r
.27981 .5696 m
.27838 .54971 L
s
.23848 .53727 m
.27838 .54971 L
s
.194 .255 .473 r
.33155 .59086 m .31387 .58547 L .3033 .56905 L p F P
0 0 0 r
s
.24 .35 .67 r
.31743 .56189 m
.31945 .58175 L
s
.47 .135 .064 r
.3119 .55889 m .3033 .56905 L .31387 .58547 L p F P
0 0 0 r
s
.83 .24 .1 r
.29745 .5959 m
.31069 .58054 L
s
.083 .024 .01 r
.37245 .41382 m .36389 .42456 L .35333 .44018 L p F P
0 0 0 r
s
.083 .024 .01 r
.34436 .45141 m .35333 .44018 L .36389 .42456 L p F P
0 0 0 r
s
.83 .24 .1 r
.35977 .43229 m
.37514 .41644 L
s
.216 .343 .692 r
.4833 .33825 m .49185 .34159 L .48926 .3338 L p F P
0 0 0 r
s
.216 .343 .692 r
.50046 .33821 m .48926 .3338 L .49185 .34159 L p F P
0 0 0 r
s
.83 .24 .1 r
.49498 .33605 m
.50272 .32686 L
s
.153 .191 .345 r
.37732 .61461 m .36145 .60981 L .34906 .5962 L p F P
0 0 0 r
s
.153 .191 .345 r
.33155 .59086 m .34906 .5962 L .36145 .60981 L p F P
0 0 0 r
s
.24 .35 .67 r
.31945 .58175 m
.35825 .59364 L
s
.083 .024 .01 r
.32772 .48059 m .33688 .46919 L .34436 .45141 L p F P
0 0 0 r
s
.143 .041 .02 r
.33688 .46919 m .32772 .48059 L .32399 .49953 L p F P
0 0 0 r
s
.83 .24 .1 r
.32575 .49953 m
.32748 .49132 L
s
.15 .249 .511 r
.51691 .66377 m .5083 .66119 L .51056 .66335 L p F P
0 0 0 r
s
.15 .249 .511 r
.49954 .66005 m .51056 .66335 L .5083 .66119 L p F P
0 0 0 r
s
.083 .024 .01 r
.35333 .44018 m .34436 .45141 L .33688 .46919 L p F P
0 0 0 r
s
.83 .24 .1 r
.35301 .44076 m
.35977 .43229 L
s
.083 .024 .01 r
.59772 .6175 m .60733 .60921 L .61693 .59554 L p F P
0 0 0 r
s
.083 .024 .01 r
.62765 .58624 m .61693 .59554 L .60733 .60921 L p F P
0 0 0 r
s
1 .332 .138 r
.47471 .33488 m .4699 .3407 L .46034 .33261 L p F P
0 0 0 r
s
1 .332 .138 r
.45413 .34025 m .46034 .33261 L .4699 .3407 L p F P
0 0 0 r
s
.156 .259 .536 r
.53364 .35127 m .54456 .35556 L .55435 .35655 L p F P
0 0 0 r
s
.24 .35 .67 r
.50039 .34385 m
.53719 .35827 L
s
.156 .259 .536 r
.56754 .36175 m .55435 .35655 L .54456 .35556 L p F P
0 0 0 r
s
.24 .35 .67 r
.53719 .35827 m
.55068 .35727 L
s
.83 .24 .1 r
.34579 .62837 m
.32723 .64825 L
s
.32723 .64825 m
.34913 .67073 L
s
.24 .35 .67 r
.16417 .46098 m
.17139 .43234 L
s
1 .331 .136 r
.44798 .34779 m .4419 .35525 L .42913 .35618 L p F P
0 0 0 r
s
1 .331 .136 r
.4219 .36516 m .42913 .35618 L .4419 .35525 L p F P
0 0 0 r
s
.83 .24 .1 r
.49725 .67484 m
.52212 .67112 L
s
.52212 .67112 m
.52652 .66727 L
s
.36812 .65126 m
.34913 .67073 L
s
1 .316 .128 r
.4219 .36516 m .41476 .37403 L .40132 .38134 L p F P
0 0 0 r
s
1 .316 .128 r
.39327 .3914 m .40132 .38134 L .41476 .37403 L p F P
0 0 0 r
s
.109 .123 .235 r
.63793 .39068 m .65251 .39642 L .66973 .40845 L p F P
0 0 0 r
s
.24 .35 .67 r
.65785 .40015 m
.66284 .40211 L
s
.109 .123 .235 r
.68572 .41472 m .66973 .40845 L .65251 .39642 L p F P
0 0 0 r
s
.83 .24 .1 r
.66944 .39903 m
.67425 .40749 L
s
.67624 .411 m
.68419 .42499 L
s
.112 .127 .241 r
.41915 .63348 m .40539 .62934 L .39305 .61936 L p F P
0 0 0 r
s
.112 .127 .241 r
.37732 .61461 m .39305 .61936 L .40539 .62934 L p F P
0 0 0 r
s
.944 .288 .117 r
.55219 .65272 m .55895 .64687 L .56994 .64194 L p F P
0 0 0 r
s
.944 .288 .117 r
.57813 .63487 m .56994 .64194 L .55895 .64687 L p F P
0 0 0 r
s
.83 .24 .1 r
.56564 .64269 m
.56591 .64245 L
s
.24 .35 .67 r
.71735 .4313 m
.7257 .44937 L
s
.32 .30578 m
.35912 .32076 L
s
.35912 .32076 m
.37246 .30695 L
s
.079 .091 .174 r
.46607 .65002 m .45477 .64663 L .44633 .64165 L p F P
0 0 0 r
s
.079 .091 .174 r
.43279 .63758 m .44633 .64165 L .45477 .64663 L p F P
0 0 0 r
s
.24 .35 .67 r
.20212 .34475 m
.21428 .31822 L
s
.216 .343 .692 r
.47471 .33488 m .4833 .33825 L .47798 .32936 L p F P
0 0 0 r
s
.216 .343 .692 r
.48926 .3338 m .47798 .32936 L .4833 .33825 L p F P
0 0 0 r
s
.15 .249 .511 r
.5083 .66119 m .49964 .65859 L .49954 .66005 L p F P
0 0 0 r
s
.15 .249 .511 r
.48846 .65673 m .49954 .66005 L .49964 .65859 L p F P
0 0 0 r
s
.073 .085 .164 r
.58062 .36691 m .5936 .37203 L .60838 .37904 L p F P
0 0 0 r
s
.073 .085 .164 r
.62322 .38488 m .60838 .37904 L .5936 .37203 L p F P
0 0 0 r
s
.24 .35 .67 r
.53684 .6691 m
.55211 .66731 L
s
.52942 .66687 m
.53684 .6691 L
s
.083 .024 .01 r
.57813 .63487 m .58642 .62771 L .59772 .6175 L p F P
0 0 0 r
s
.83 .24 .1 r
.56591 .64245 m
.58302 .62821 L
s
.083 .024 .01 r
.60733 .60921 m .59772 .6175 L .58642 .62771 L p F P
0 0 0 r
s
.83 .24 .1 r
.52469 .30077 m
.50272 .32686 L
s
.24 .35 .67 r
.69684 .67858 m
.6784 .69249 L
s
.64269 .68155 m
.6784 .69249 L
s
.27981 .5696 m
.3106 .57904 L
s
.31345 .57991 m
.31945 .58175 L
s
.156 .259 .536 r
.52265 .34694 m .53364 .35127 L .54106 .35131 L p F P
0 0 0 r
s
.156 .259 .536 r
.55435 .35655 m .54106 .35131 L .53364 .35127 L p F P
0 0 0 r
s
.83 .24 .1 r
.60159 .29157 m
.57817 .31784 L
s
.57817 .31784 m
.55131 .30686 L
s
1 .315 .13 r
.53058 .66188 m .53573 .65738 L .54551 .65851 L p F P
0 0 0 r
s
1 .315 .13 r
.55219 .65272 m .54551 .65851 L .53573 .65738 L p F P
0 0 0 r
s
.153 .191 .345 r
.36145 .60981 m .34544 .60497 L .33155 .59086 L p F P
0 0 0 r
s
.24 .35 .67 r
.35825 .59364 m
.36372 .60898 L
s
.153 .191 .345 r
.31387 .58547 m .33155 .59086 L .34544 .60497 L p F P
0 0 0 r
s
.83 .24 .1 r
.42116 .68372 m
.44907 .69171 L
s
.47003 .67258 m
.44907 .69171 L
s
1 .332 .138 r
.46034 .33261 m .46663 .3249 L .47471 .33488 L p F P
0 0 0 r
s
.24 .35 .67 r
.46277 .32911 m
.4631 .32923 L
s
.216 .343 .692 r
.47798 .32936 m .46663 .3249 L .47471 .33488 L p F P
0 0 0 r
s
.83 .24 .1 r
.45662 .3518 m
.47329 .33156 L
s
.24 .35 .67 r
.47039 .33209 m
.50039 .34385 L
s
.83 .24 .1 r
.47756 .32637 m
.50272 .32686 L
s
.4758 .32851 m
.47756 .32637 L
s
.918 .277 .11 r
.40132 .38134 m .39327 .3914 L .38117 .4029 L p F P
0 0 0 r
s
.83 .24 .1 r
.39434 .39248 m
.41383 .38174 L
s
.918 .277 .11 r
.37245 .41382 m .38117 .4029 L .39327 .3914 L p F P
0 0 0 r
s
.83 .24 .1 r
.37514 .41644 m
.39434 .39248 L
s
.079 .091 .174 r
.45477 .64663 m .44339 .64322 L .43279 .63758 L p F P
0 0 0 r
s
.079 .091 .174 r
.41915 .63348 m .43279 .63758 L .44339 .64322 L p F P
0 0 0 r
s
.24 .35 .67 r
.44001 .63207 m
.44949 .64225 L
s
.109 .123 .235 r
.62322 .38488 m .63793 .39068 L .65359 .40211 L p F P
0 0 0 r
s
.24 .35 .67 r
.64278 .39422 m
.64781 .3962 L
s
.62297 .38573 m
.63125 .38944 L
s
.109 .123 .235 r
.66973 .40845 m .65359 .40211 L .63793 .39068 L p F P
0 0 0 r
s
.83 .24 .1 r
.66944 .39903 m
.69452 .3744 L
s
.112 .127 .241 r
.40539 .62934 m .39154 .62518 L .37732 .61461 L p F P
0 0 0 r
s
.112 .127 .241 r
.36145 .60981 m .37732 .61461 L .39154 .62518 L p F P
0 0 0 r
s
.24 .35 .67 r
.36372 .60898 m
.40228 .62065 L
s
.15 .249 .511 r
.49964 .65859 m .49094 .65597 L .48846 .65673 L p F P
0 0 0 r
s
.15 .249 .511 r
.4773 .65338 m .48846 .65673 L .49094 .65597 L p F P
0 0 0 r
s
.24 .35 .67 r
.44949 .64225 m
.48699 .65352 L
s
.7257 .44937 m
.7606 .46286 L
s
.7606 .46286 m
.76579 .48607 L
s
1 .331 .136 r
.45413 .34025 m .44798 .34779 L .43647 .34707 L p F P
0 0 0 r
s
1 .331 .136 r
.42913 .35618 m .43647 .34707 L .44798 .34779 L p F P
0 0 0 r
s
.83 .24 .1 r
.43384 .35701 m
.45662 .3518 L
s
.24 .35 .67 r
.75025 .67016 m
.73206 .68959 L
s
.69684 .67858 m
.73206 .68959 L
s
.073 .085 .164 r
.56754 .36175 m .58062 .36691 L .59341 .37314 L p F P
0 0 0 r
s
.073 .085 .164 r
.60838 .37904 m .59341 .37314 L .58062 .36691 L p F P
0 0 0 r
s
.24 .35 .67 r
.55068 .35727 m
.58721 .37165 L
s
.78489 .68126 m
.80165 .65721 L
s
.75025 .67016 m
.78489 .68126 L
s
.37246 .30695 m
.41122 .322 L
s
.41122 .322 m
.42432 .31404 L
s
.585 .167 .076 r
.68806 .44112 m .70025 .4297 L .68572 .41472 L p F P
0 0 0 r
s
.152 .189 .336 r
.66973 .40845 m .68572 .41472 L .70025 .4297 L p F P
0 0 0 r
s
.83 .24 .1 r
.68985 .4196 m
.69076 .41874 L
s
.68419 .42499 m
.68812 .42125 L
s
.156 .259 .536 r
.51159 .34259 m .52265 .34694 L .52767 .34603 L p F P
0 0 0 r
s
.156 .259 .536 r
.54106 .35131 m .52767 .34603 L .52265 .34694 L p F P
0 0 0 r
s
.161 .046 .023 r
.64648 .55974 m .65828 .54941 L .66287 .53076 L p F P
0 0 0 r
s
.161 .046 .023 r
.67529 .51975 m .66287 .53076 L .65828 .54941 L p F P
0 0 0 r
s
.273 .073 .037 r
.66287 .53076 m .67529 .51975 L .67587 .50047 L p F P
0 0 0 r
s
.83 .24 .1 r
.64969 .52248 m
.67411 .50047 L
s
.24 .35 .67 r
.20007 .50081 m
.15896 .48772 L
s
.19769 .52455 m
.20007 .50081 L
s
.084 .024 .01 r
.62765 .58624 m .63855 .57679 L .64648 .55974 L p F P
0 0 0 r
s
.084 .024 .01 r
.65828 .54941 m .64648 .55974 L .63855 .57679 L p F P
0 0 0 r
s
.83 .24 .1 r
.64229 .56871 m
.64874 .54677 L
s
.083 .024 .01 r
.38117 .4029 m .37245 .41382 L .36247 .42874 L p F P
0 0 0 r
s
.083 .024 .01 r
.35333 .44018 m .36247 .42874 L .37245 .41382 L p F P
0 0 0 r
s
.391 .108 .052 r
.67587 .50047 m .68857 .48903 L .68455 .47015 L p F P
0 0 0 r
s
.273 .073 .037 r
.68857 .48903 m .67587 .50047 L .67529 .51975 L p F P
0 0 0 r
s
.24 .35 .67 r
.15896 .48772 m
.16417 .46098 L
s
1 .316 .128 r
.42913 .35618 m .4219 .36516 L .40949 .37112 L p F P
0 0 0 r
s
1 .316 .128 r
.40132 .38134 m .40949 .37112 L .4219 .36516 L p F P
0 0 0 r
s
.83 .24 .1 r
.41383 .38174 m
.43384 .35701 L
s
.497 .14 .065 r
.68455 .47015 m .69718 .45856 L .68806 .44112 L p F P
0 0 0 r
s
.497 .14 .065 r
.70025 .4297 m .68806 .44112 L .69718 .45856 L p F P
0 0 0 r
s
.24 .35 .67 r
.6923 .42151 m
.71735 .4313 L
s
.391 .108 .052 r
.69718 .45856 m .68455 .47015 L .68857 .48903 L p F P
0 0 0 r
s
.83 .24 .1 r
.66938 .47461 m
.69436 .45151 L
s
.212 .061 .032 r
.31545 .52985 m .32457 .51883 L .32399 .49953 L p F P
0 0 0 r
s
.83 .24 .1 r
.32405 .50162 m
.32575 .49953 L
s
.34 .095 .048 r
.32457 .51883 m .31545 .52985 L .32065 .54855 L p F P
0 0 0 r
s
.34 .095 .048 r
.3119 .55889 m .32065 .54855 L .31545 .52985 L p F P
0 0 0 r
s
.47 .135 .064 r
.32065 .54855 m .3119 .55889 L .32209 .576 L p F P
0 0 0 r
s
.47 .135 .064 r
.31387 .58547 m .32209 .576 L .3119 .55889 L p F P
0 0 0 r
s
.944 .288 .117 r
.55895 .64687 m .56578 .64095 L .57813 .63487 L p F P
0 0 0 r
s
.944 .288 .117 r
.58642 .62771 m .57813 .63487 L .56578 .64095 L p F P
0 0 0 r
s
.83 .24 .1 r
.58302 .62821 m
.60625 .60812 L
s
.24 .35 .67 r
.80184 .52636 m
.83598 .53904 L
s
.83346 .56866 m
.83598 .53904 L
s
.143 .041 .02 r
.32399 .49953 m .33332 .48807 L .33688 .46919 L p F P
0 0 0 r
s
.212 .061 .032 r
.33332 .48807 m .32399 .49953 L .32457 .51883 L p F P
0 0 0 r
s
.083 .024 .01 r
.60733 .60921 m .61708 .60079 L .62765 .58624 L p F P
0 0 0 r
s
.083 .024 .01 r
.63855 .57679 m .62765 .58624 L .61708 .60079 L p F P
0 0 0 r
s
.83 .24 .1 r
.60625 .60812 m
.61828 .58962 L
s
.61828 .58962 m
.64229 .56871 L
s
.083 .024 .01 r
.36247 .42874 m .35333 .44018 L .34622 .45759 L p F P
0 0 0 r
s
.083 .024 .01 r
.33688 .46919 m .34622 .45759 L .35333 .44018 L p F P
0 0 0 r
s
.83 .24 .1 r
.34836 .45378 m
.3493 .45261 L
s
.3493 .45261 m
.3523 .44679 L
s
.24 .35 .67 r
.76579 .48607 m
.80034 .49919 L
s
.80034 .49919 m
.80184 .52636 L
s
.143 .041 .02 r
.34622 .45759 m .33688 .46919 L .33332 .48807 L p F P
0 0 0 r
s
.15 .249 .511 r
.49094 .65597 m .4822 .65335 L .4773 .65338 L p F P
0 0 0 r
s
.24 .35 .67 r
.48699 .65352 m
.49961 .65792 L
s
.15 .249 .511 r
.46607 .65002 m .4773 .65338 L .4822 .65335 L p F P
0 0 0 r
s
.153 .191 .345 r
.34544 .60497 m .32928 .60009 L .31387 .58547 L p F P
0 0 0 r
s
.83 .24 .1 r
.30972 .62287 m
.32788 .60257 L
s
.575 .166 .076 r
.32209 .576 m .31387 .58547 L .32928 .60009 L p F P
0 0 0 r
s
.24 .35 .67 r
.60619 .67037 m
.58901 .67847 L
s
.55211 .66731 m
.58901 .67847 L
s
.21428 .31822 m
.22675 .29459 L
s
.079 .091 .174 r
.44339 .64322 m .43194 .63978 L .41915 .63348 L p F P
0 0 0 r
s
.079 .091 .174 r
.40539 .62934 m .41915 .63348 L .43194 .63978 L p F P
0 0 0 r
s
.83 .24 .1 r
.32475 .59579 m
.32788 .60257 L
s
.24 .35 .67 r
.22675 .29459 m
.26721 .30982 L
s
.26721 .30982 m
.28 .29047 L
s
1 .315 .13 r
.53573 .65738 m .54093 .65283 L .55219 .65272 L p F P
0 0 0 r
s
1 .315 .13 r
.55895 .64687 m .55219 .65272 L .54093 .65283 L p F P
0 0 0 r
s
.24 .35 .67 r
.23929 .55718 m
.23848 .53727 L
s
.19769 .52455 m
.23848 .53727 L
s
.156 .259 .536 r
.50046 .33821 m .51159 .34259 L .51417 .34071 L p F P
0 0 0 r
s
.156 .259 .536 r
.52767 .34603 m .51417 .34071 L .51159 .34259 L p F P
0 0 0 r
s
.24 .35 .67 r
.50039 .34385 m
.51334 .34257 L
s
.109 .123 .235 r
.60838 .37904 m .62322 .38488 L .63728 .39571 L p F P
0 0 0 r
s
.24 .35 .67 r
.62757 .38824 m
.63266 .39024 L
s
.109 .123 .235 r
.65359 .40211 m .63728 .39571 L .62322 .38488 L p F P
0 0 0 r
s
.112 .127 .241 r
.39154 .62518 m .37757 .62098 L .36145 .60981 L p F P
0 0 0 r
s
.112 .127 .241 r
.34544 .60497 m .36145 .60981 L .37757 .62098 L p F P
0 0 0 r
s
.073 .085 .164 r
.55435 .35655 m .56754 .36175 L .5783 .36718 L p F P
0 0 0 r
s
.073 .085 .164 r
.59341 .37314 m .5783 .36718 L .56754 .36175 L p F P
0 0 0 r
s
.083 .024 .01 r
.58642 .62771 m .59484 .62046 L .60733 .60921 L p F P
0 0 0 r
s
.083 .024 .01 r
.61708 .60079 m .60733 .60921 L .59484 .62046 L p F P
0 0 0 r
s
.213 .34 .684 r
.51691 .66377 m .52548 .66634 L .51767 .65847 L p F P
0 0 0 r
s
.24 .35 .67 r
.49961 .65792 m
.517 .66314 L
s
.52455 .66541 m
.52604 .66586 L
s
1 .322 .134 r
.53058 .66188 m .52548 .66634 L .51767 .65847 L p F P
0 0 0 r
s
.83 .24 .1 r
.57441 .28017 m
.55131 .30686 L
s
.55131 .30686 m
.52469 .30077 L
s
.152 .189 .336 r
.65359 .40211 m .66973 .40845 L .68308 .42301 L p F P
0 0 0 r
s
.152 .189 .336 r
.70025 .4297 m .68308 .42301 L .66973 .40845 L p F P
0 0 0 r
s
.83 .24 .1 r
.68419 .42499 m
.69436 .45151 L
s
1 .331 .136 r
.46034 .33261 m .45413 .34025 L .44391 .33784 L p F P
0 0 0 r
s
.24 .35 .67 r
.45141 .33545 m
.46277 .32911 L
s
1 .331 .136 r
.43647 .34707 m .44391 .33784 L .45413 .34025 L p F P
0 0 0 r
s
.83 .24 .1 r
.3937 .67003 m
.42116 .68372 L
s
.44175 .66428 m
.42116 .68372 L
s
.15 .249 .511 r
.4822 .65335 m .47341 .65071 L .46607 .65002 L p F P
0 0 0 r
s
.15 .249 .511 r
.45477 .64663 m .46607 .65002 L .47341 .65071 L p F P
0 0 0 r
s
.24 .35 .67 r
.28 .29047 m
.32 .30578 L
s
.32 .30578 m
.33285 .29157 L
s
.83 .24 .1 r
.47003 .67258 m
.49725 .67484 L
s
.918 .277 .11 r
.40949 .37112 m .40132 .38134 L .39003 .39179 L p F P
0 0 0 r
s
.918 .277 .11 r
.38117 .4029 m .39003 .39179 L .40132 .38134 L p F P
0 0 0 r
s
.24 .35 .67 r
.46277 .32911 m
.46325 .32905 L
s
.079 .091 .174 r
.43194 .63978 m .42041 .63633 L .40539 .62934 L p F P
0 0 0 r
s
.079 .091 .174 r
.39154 .62518 m .40539 .62934 L .42041 .63633 L p F P
0 0 0 r
s
.24 .35 .67 r
.41117 .63073 m
.44949 .64225 L
s
.40228 .62065 m
.41117 .63073 L
s
.156 .259 .536 r
.48926 .3338 m .50046 .33821 L .50057 .33534 L p F P
0 0 0 r
s
.156 .259 .536 r
.51417 .34071 m .50057 .33534 L .50046 .33821 L p F P
0 0 0 r
s
.213 .34 .684 r
.51767 .65847 m .51172 .65667 L .51691 .66377 L p F P
0 0 0 r
s
.213 .34 .684 r
.5083 .66119 m .51691 .66377 L .51172 .65667 L p F P
0 0 0 r
s
.83 .24 .1 r
.49725 .67484 m
.51232 .66145 L
s
.51232 .66145 m
.51543 .65868 L
s
.24 .35 .67 r
.80165 .65721 m
.81583 .62942 L
s
.76691 .64576 m
.80165 .65721 L
s
.073 .085 .164 r
.54106 .35131 m .55435 .35655 L .56305 .36118 L p F P
0 0 0 r
s
.073 .085 .164 r
.5783 .36718 m .56305 .36118 L .55435 .35655 L p F P
0 0 0 r
s
.24 .35 .67 r
.66083 .66734 m
.64269 .68155 L
s
.60619 .67037 m
.64269 .68155 L
s
.28402 .58485 m
.27981 .5696 L
s
.23929 .55718 m
.27981 .5696 L
s
1 .316 .128 r
.43647 .34707 m .42913 .35618 L .41778 .36074 L p F P
0 0 0 r
s
1 .316 .128 r
.40949 .37112 m .41778 .36074 L .42913 .35618 L p F P
0 0 0 r
s
.109 .123 .235 r
.59341 .37314 m .60838 .37904 L .62081 .38925 L p F P
0 0 0 r
s
.24 .35 .67 r
.58721 .37165 m
.59948 .37718 L
s
.59948 .37718 m
.60191 .37814 L
s
.61223 .3822 m
.61736 .38422 L
s
.109 .123 .235 r
.63728 .39571 m .62081 .38925 L .60838 .37904 L p F P
0 0 0 r
s
.112 .127 .241 r
.37757 .62098 m .36349 .61675 L .34544 .60497 L p F P
0 0 0 r
s
.112 .127 .241 r
.32928 .60009 m .34544 .60497 L .36349 .61675 L p F P
0 0 0 r
s
.944 .288 .117 r
.56578 .64095 m .57269 .63496 L .58642 .62771 L p F P
0 0 0 r
s
.944 .288 .117 r
.59484 .62046 m .58642 .62771 L .57269 .63496 L p F P
0 0 0 r
s
.83 .24 .1 r
.67536 .34952 m
.65295 .32691 L
s
.67809 .30052 m
.65295 .32691 L
s
.65295 .32691 m
.62808 .30736 L
s
.47293 .32737 m
.47756 .32637 L
s
1 .315 .13 r
.54093 .65283 m .54617 .64825 L .55895 .64687 L p F P
0 0 0 r
s
.83 .24 .1 r
.55447 .64735 m
.56223 .64403 L
s
1 .315 .13 r
.56578 .64095 m .55895 .64687 L .54617 .64825 L p F P
0 0 0 r
s
.24 .35 .67 r
.79905 .55622 m
.83346 .56866 L
s
.82664 .59935 m
.83346 .56866 L
s
.83 .24 .1 r
.69452 .3744 m
.67536 .34952 L
s
.70094 .32355 m
.67536 .34952 L
s
.15 .249 .511 r
.47341 .65071 m .46457 .64806 L .45477 .64663 L p F P
0 0 0 r
s
.15 .249 .511 r
.44339 .64322 m .45477 .64663 L .46457 .64806 L p F P
0 0 0 r
s
.83 .24 .1 r
.32788 .60257 m
.32985 .60037 L
s
1 .322 .134 r
.51767 .65847 m .52119 .65535 L .53058 .66188 L p F P
0 0 0 r
s
1 .322 .134 r
.53573 .65738 m .53058 .66188 L .52119 .65535 L p F P
0 0 0 r
s
.083 .024 .01 r
.39003 .39179 m .38117 .4029 L .37178 .4171 L p F P
0 0 0 r
s
.083 .024 .01 r
.36247 .42874 m .37178 .4171 L .38117 .4029 L p F P
0 0 0 r
s
.83 .24 .1 r
.37895 .40828 m
.39434 .39248 L
s
.084 .024 .01 r
.63855 .57679 m .64964 .56717 L .65828 .54941 L p F P
0 0 0 r
s
.084 .024 .01 r
.6703 .53889 m .65828 .54941 L .64964 .56717 L p F P
0 0 0 r
s
.161 .046 .023 r
.65828 .54941 m .6703 .53889 L .67529 .51975 L p F P
0 0 0 r
s
.156 .259 .536 r
.47798 .32936 m .48926 .3338 L .48685 .32993 L p F P
0 0 0 r
s
.156 .259 .536 r
.50057 .33534 m .48685 .32993 L .48926 .3338 L p F P
0 0 0 r
s
.161 .046 .023 r
.68794 .50854 m .67529 .51975 L .6703 .53889 L p F P
0 0 0 r
s
.83 .24 .1 r
.67345 .52494 m
.67411 .50047 L
s
.64874 .54677 m
.67345 .52494 L
s
.273 .073 .037 r
.67529 .51975 m .68794 .50854 L .68857 .48903 L p F P
0 0 0 r
s
.152 .189 .336 r
.63728 .39571 m .65359 .40211 L .66573 .41625 L p F P
0 0 0 r
s
.152 .189 .336 r
.68308 .42301 m .66573 .41625 L .65359 .40211 L p F P
0 0 0 r
s
.213 .34 .684 r
.51172 .65667 m .50575 .65487 L .5083 .66119 L p F P
0 0 0 r
s
.213 .34 .684 r
.49964 .65859 m .5083 .66119 L .50575 .65487 L p F P
0 0 0 r
s
.24 .35 .67 r
.49961 .65792 m
.50107 .65772 L
s
.083 .024 .01 r
.61708 .60079 m .62699 .59224 L .63855 .57679 L p F P
0 0 0 r
s
.083 .024 .01 r
.64964 .56717 m .63855 .57679 L .62699 .59224 L p F P
0 0 0 r
s
.497 .14 .065 r
.69718 .45856 m .71005 .44675 L .70025 .4297 L p F P
0 0 0 r
s
.198 .262 .481 r
.68308 .42301 m .70025 .4297 L .71005 .44675 L p F P
0 0 0 r
s
.24 .35 .67 r
.7257 .44937 m
.73047 .47265 L
s
.391 .108 .052 r
.68857 .48903 m .70152 .47737 L .69718 .45856 L p F P
0 0 0 r
s
.273 .073 .037 r
.70152 .47737 m .68857 .48903 L .68794 .50854 L p F P
0 0 0 r
s
.34 .095 .048 r
.32065 .54855 m .32957 .53801 L .32457 .51883 L p F P
0 0 0 r
s
.47 .135 .064 r
.32957 .53801 m .32065 .54855 L .33045 .56637 L p F P
0 0 0 r
s
.47 .135 .064 r
.32209 .576 m .33045 .56637 L .32065 .54855 L p F P
0 0 0 r
s
.079 .091 .174 r
.42041 .63633 m .40881 .63285 L .39154 .62518 L p F P
0 0 0 r
s
.079 .091 .174 r
.37757 .62098 m .39154 .62518 L .40881 .63285 L p F P
0 0 0 r
s
.83 .24 .1 r
.65279 .28052 m
.62808 .30736 L
s
.62808 .30736 m
.60159 .29157 L
s
.24 .35 .67 r
.71483 .65882 m
.69684 .67858 L
s
.66083 .66734 m
.69684 .67858 L
s
.391 .108 .052 r
.71005 .44675 m .69718 .45856 L .70152 .47737 L p F P
0 0 0 r
s
.212 .061 .032 r
.32457 .51883 m .33388 .5076 L .33332 .48807 L p F P
0 0 0 r
s
.34 .095 .048 r
.33388 .5076 m .32457 .51883 L .32957 .53801 L p F P
0 0 0 r
s
.24 .35 .67 r
.76691 .64576 m
.75025 .67016 L
s
.71483 .65882 m
.75025 .67016 L
s
1 .331 .136 r
.46663 .3249 m .46034 .33261 L .45145 .32848 L p F P
0 0 0 r
s
1 .331 .136 r
.44391 .33784 m .45145 .32848 L .46034 .33261 L p F P
0 0 0 r
s
.83 .24 .1 r
.36812 .65126 m
.3937 .67003 L
s
.41387 .65022 m
.3937 .67003 L
s
.24 .35 .67 r
.33285 .29157 m
.37246 .30695 L
s
.37246 .30695 m
.38502 .29864 L
s
.575 .166 .076 r
.33045 .56637 m .32209 .576 L .33694 .59152 L p F P
0 0 0 r
s
.575 .166 .076 r
.32928 .60009 m .33694 .59152 L .32209 .576 L p F P
0 0 0 r
s
.24 .35 .67 r
.3227 .59198 m
.32361 .59484 L
s
.32361 .59484 m
.32431 .59705 L
s
.083 .024 .01 r
.37178 .4171 m .36247 .42874 L .35573 .44576 L p F P
0 0 0 r
s
.83 .24 .1 r
.36215 .42931 m
.36234 .42908 L
s
.37146 .41766 m
.37895 .40828 L
s
.083 .024 .01 r
.34622 .45759 m .35573 .44576 L .36247 .42874 L p F P
0 0 0 r
s
.143 .041 .02 r
.33332 .48807 m .34283 .47639 L .34622 .45759 L p F P
0 0 0 r
s
.212 .061 .032 r
.34283 .47639 m .33332 .48807 L .33388 .5076 L p F P
0 0 0 r
s
.143 .041 .02 r
.35573 .44576 m .34622 .45759 L .34283 .47639 L p F P
0 0 0 r
s
.83 .24 .1 r
.34443 .47663 m
.34601 .46883 L
s
.073 .085 .164 r
.52767 .34603 m .54106 .35131 L .54767 .35511 L p F P
0 0 0 r
s
.073 .085 .164 r
.56305 .36118 m .54767 .35511 L .54106 .35131 L p F P
0 0 0 r
s
.24 .35 .67 r
.51334 .34257 m
.55068 .35727 L
s
.55068 .35727 m
.56241 .36259 L
s
.156 .51155 m
.15896 .48772 L
s
.81583 .62942 m
.82664 .59935 L
s
.78111 .61761 m
.81583 .62942 L
s
.083 .024 .01 r
.59484 .62046 m .60336 .6131 L .61708 .60079 L p F P
0 0 0 r
s
.083 .024 .01 r
.62699 .59224 m .61708 .60079 L .60336 .6131 L p F P
0 0 0 r
s
.15 .249 .511 r
.46457 .64806 m .4557 .64539 L .44339 .64322 L p F P
0 0 0 r
s
.15 .249 .511 r
.43194 .63978 m .44339 .64322 L .4557 .64539 L p F P
0 0 0 r
s
.24 .35 .67 r
.79202 .5872 m
.82664 .59935 L
s
.83 .24 .1 r
.70971 .40071 m
.69452 .3744 L
s
.72056 .34882 m
.69452 .3744 L
s
.109 .123 .235 r
.5783 .36718 m .59341 .37314 L .60417 .38272 L p F P
0 0 0 r
s
.24 .35 .67 r
.59674 .3761 m
.59948 .37718 L
s
.109 .123 .235 r
.62081 .38925 m .60417 .38272 L .59341 .37314 L p F P
0 0 0 r
s
.24 .35 .67 r
.76694 .5134 m
.80184 .52636 L
s
.80184 .52636 m
.79905 .55622 L
s
.112 .127 .241 r
.36349 .61675 m .3493 .61249 L .32928 .60009 L p F P
0 0 0 r
s
.663 .193 .087 r
.33694 .59152 m .32928 .60009 L .3493 .61249 L p F P
0 0 0 r
s
.83 .24 .1 r
.32788 .60257 m
.34579 .62837 L
s
.24 .35 .67 r
.34365 .6029 m
.36372 .60898 L
s
.32431 .59705 m
.32916 .59852 L
s
.32916 .59852 m
.32936 .59858 L
s
.213 .34 .684 r
.50575 .65487 m .49975 .65306 L .49964 .65859 L p F P
0 0 0 r
s
.213 .34 .684 r
.49094 .65597 m .49964 .65859 L .49975 .65306 L p F P
0 0 0 r
s
.83 .24 .1 r
.34579 .62837 m
.36812 .65126 L
s
.24 .35 .67 r
.73047 .47265 m
.76579 .48607 L
s
.76579 .48607 m
.76694 .5134 L
s
.156 .259 .536 r
.46663 .3249 m .47798 .32936 L .47303 .32448 L p F P
0 0 0 r
s
.156 .259 .536 r
.48685 .32993 m .47303 .32448 L .47798 .32936 L p F P
0 0 0 r
s
.24 .35 .67 r
.56888 .65894 m
.55211 .66731 L
s
.5263 .65951 m
.55211 .66731 L
s
.521 .65791 m
.5263 .65951 L
s
1 .322 .134 r
.52119 .65535 m .52472 .65221 L .53573 .65738 L p F P
0 0 0 r
s
1 .322 .134 r
.54093 .65283 m .53573 .65738 L .52472 .65221 L p F P
0 0 0 r
s
.83 .24 .1 r
.53719 .65269 m
.54184 .65203 L
s
.24 .35 .67 r
.22675 .29459 m
.23911 .27481 L
s
.918 .277 .11 r
.41778 .36074 m .40949 .37112 L .39904 .38049 L p F P
0 0 0 r
s
.918 .277 .11 r
.39003 .39179 m .39904 .38049 L .40949 .37112 L p F P
0 0 0 r
s
.83 .24 .1 r
.39434 .39248 m
.41427 .3676 L
s
.24 .35 .67 r
.19786 .54448 m
.19769 .52455 L
s
.156 .51155 m
.19769 .52455 L
s
.32431 .59705 m
.33194 .60691 L
s
.28402 .58485 m
.32431 .59705 L
s
1 .315 .13 r
.54617 .64825 m .55146 .64362 L .56578 .64095 L p F P
0 0 0 r
s
1 .315 .13 r
.57269 .63496 m .56578 .64095 L .55146 .64362 L p F P
0 0 0 r
s
.079 .091 .174 r
.40881 .63285 m .39713 .62935 L .37757 .62098 L p F P
0 0 0 r
s
.079 .091 .174 r
.36349 .61675 m .37757 .62098 L .39713 .62935 L p F P
0 0 0 r
s
1 .316 .128 r
.44391 .33784 m .43647 .34707 L .42622 .3502 L p F P
0 0 0 r
s
1 .316 .128 r
.41778 .36074 m .42622 .3502 L .43647 .34707 L p F P
0 0 0 r
s
.83 .24 .1 r
.41427 .3676 m
.43384 .35701 L
s
.152 .189 .336 r
.62081 .38925 m .63728 .39571 L .64819 .40942 L p F P
0 0 0 r
s
.152 .189 .336 r
.66573 .41625 m .64819 .40942 L .63728 .39571 L p F P
0 0 0 r
s
.944 .288 .117 r
.57269 .63496 m .57968 .62891 L .59484 .62046 L p F P
0 0 0 r
s
.944 .288 .117 r
.60336 .6131 m .59484 .62046 L .57968 .62891 L p F P
0 0 0 r
s
.83 .24 .1 r
.58792 .62341 m
.58915 .62234 L
s
.58915 .62234 m
.60625 .60812 L
s
.213 .34 .684 r
.49975 .65306 m .49373 .65124 L .49094 .65597 L p F P
0 0 0 r
s
.213 .34 .684 r
.4822 .65335 m .49094 .65597 L .49373 .65124 L p F P
0 0 0 r
s
.83 .24 .1 r
.54751 .27368 m
.52469 .30077 L
s
.52469 .30077 m
.49931 .29996 L
s
.15 .249 .511 r
.4557 .64539 m .44677 .64271 L .43194 .63978 L p F P
0 0 0 r
s
.24 .35 .67 r
.44949 .64225 m
.46156 .64648 L
s
.15 .249 .511 r
.42041 .63633 m .43194 .63978 L .44677 .64271 L p F P
0 0 0 r
s
.073 .085 .164 r
.51417 .34071 m .52767 .34603 L .53214 .349 L p F P
0 0 0 r
s
.073 .085 .164 r
.54767 .35511 m .53214 .349 L .52767 .34603 L p F P
0 0 0 r
s
.198 .262 .481 r
.66573 .41625 m .68308 .42301 L .69209 .43982 L p F P
0 0 0 r
s
.83 .24 .1 r
.69131 .41822 m
.70971 .40071 L
s
.69076 .41874 m
.69131 .41822 L
s
.198 .262 .481 r
.71005 .44675 m .69209 .43982 L .68308 .42301 L p F P
0 0 0 r
s
.83 .24 .1 r
.69436 .45151 m
.70261 .44388 L
s
.24 .35 .67 r
.70752 .44234 m
.7257 .44937 L
s
.83 .24 .1 r
.70591 .44083 m
.70756 .4393 L
s
.70756 .4393 m
.72031 .42751 L
s
.62592 .26427 m
.60159 .29157 L
s
.60159 .29157 m
.57441 .28017 L
s
1 .331 .136 r
.45145 .32848 m .45909 .31899 L .46663 .3249 L p F P
0 0 0 r
s
.24 .35 .67 r
.46628 .32866 m
.47517 .32754 L
s
.83 .24 .1 r
.45463 .33133 m
.47106 .32778 L
s
.24 .35 .67 r
.42432 .31404 m
.45378 .32558 L
s
.156 .259 .536 r
.47303 .32448 m .45909 .31899 L .46663 .3249 L p F P
0 0 0 r
s
.83 .24 .1 r
.44175 .66428 m
.47003 .67258 L
s
.47003 .67258 m
.49036 .65403 L
s
.24 .35 .67 r
.23911 .27481 m
.28 .29047 L
s
.28 .29047 m
.29234 .27585 L
s
.109 .123 .235 r
.56305 .36118 m .5783 .36718 L .58736 .37612 L p F P
0 0 0 r
s
.24 .35 .67 r
.56241 .36259 m
.5706 .36581 L
s
.5811 .36995 m
.58633 .372 L
s
.109 .123 .235 r
.60417 .38272 m .58736 .37612 L .5783 .36718 L p F P
0 0 0 r
s
.24 .35 .67 r
.38502 .29864 m
.42432 .31404 L
s
.42432 .31404 m
.43614 .31217 L
s
.213 .34 .684 r
.49373 .65124 m .4877 .64942 L .4822 .65335 L p F P
0 0 0 r
s
.83 .24 .1 r
.49036 .65403 m
.49181 .65271 L
s
.213 .34 .684 r
.47341 .65071 m .4822 .65335 L .4877 .64942 L p F P
0 0 0 r
s
.24 .35 .67 r
.46156 .64648 m
.47511 .65056 L
s
.083 .024 .01 r
.39904 .38049 m .39003 .39179 L .38126 .40523 L p F P
0 0 0 r
s
.083 .024 .01 r
.37178 .4171 m .38126 .40523 L .39003 .39179 L p F P
0 0 0 r
s
1 .322 .134 r
.52472 .65221 m .52828 .64906 L .54093 .65283 L p F P
0 0 0 r
s
1 .322 .134 r
.54617 .64825 m .54093 .65283 L .52828 .64906 L p F P
0 0 0 r
s
.079 .091 .174 r
.39713 .62935 m .38537 .62582 L .36349 .61675 L p F P
0 0 0 r
s
.079 .091 .174 r
.3493 .61249 m .36349 .61675 L .38537 .62582 L p F P
0 0 0 r
s
.24 .35 .67 r
.37199 .61895 m
.41117 .63073 L
s
.36372 .60898 m
.37199 .61895 L
s
.78111 .61761 m
.76691 .64576 L
s
.7314 .63406 m
.76691 .64576 L
s
.15 .249 .511 r
.44677 .64271 m .4378 .64002 L .42041 .63633 L p F P
0 0 0 r
s
.15 .249 .511 r
.40881 .63285 m .42041 .63633 L .4378 .64002 L p F P
0 0 0 r
s
.24 .35 .67 r
.62402 .65584 m
.60619 .67037 L
s
.56888 .65894 m
.60619 .67037 L
s
.83 .24 .1 r
.70971 .40071 m
.72031 .42751 L
s
.73623 .37547 m
.70971 .40071 L
s
.083 .024 .01 r
.62699 .59224 m .63706 .58355 L .64964 .56717 L p F P
0 0 0 r
s
.083 .024 .01 r
.66092 .55738 m .64964 .56717 L .63706 .58355 L p F P
0 0 0 r
s
.084 .024 .01 r
.64964 .56717 m .66092 .55738 L .6703 .53889 L p F P
0 0 0 r
s
.24 .35 .67 r
.24282 .57238 m
.23929 .55718 L
s
.19786 .54448 m
.23929 .55718 L
s
.084 .024 .01 r
.68255 .52817 m .6703 .53889 L .66092 .55738 L p F P
0 0 0 r
s
.161 .046 .023 r
.6703 .53889 m .68255 .52817 L .68794 .50854 L p F P
0 0 0 r
s
.073 .085 .164 r
.50057 .33534 m .51417 .34071 L .51647 .34282 L p F P
0 0 0 r
s
.073 .085 .164 r
.53214 .349 m .51647 .34282 L .51417 .34071 L p F P
0 0 0 r
s
.161 .046 .023 r
.70084 .4971 m .68794 .50854 L .68255 .52817 L p F P
0 0 0 r
s
.273 .073 .037 r
.68794 .50854 m .70084 .4971 L .70152 .47737 L p F P
0 0 0 r
s
.83 .24 .1 r
.67411 .50047 m
.69947 .4776 L
s
.69436 .45151 m
.69947 .4776 L
s
.47 .135 .064 r
.33045 .56637 m .33896 .55656 L .32957 .53801 L p F P
0 0 0 r
s
.83 .24 .1 r
.32964 .53753 m
.32995 .53876 L
s
.575 .166 .076 r
.33896 .55656 m .33045 .56637 L .34471 .58282 L p F P
0 0 0 r
s
.575 .166 .076 r
.33694 .59152 m .34471 .58282 L .33045 .56637 L p F P
0 0 0 r
s
.083 .024 .01 r
.60336 .6131 m .61201 .60564 L .62699 .59224 L p F P
0 0 0 r
s
.083 .024 .01 r
.63706 .58355 m .62699 .59224 L .61201 .60564 L p F P
0 0 0 r
s
.83 .24 .1 r
.63038 .58725 m
.64229 .56871 L
s
.34 .095 .048 r
.32957 .53801 m .33865 .52728 L .33388 .5076 L p F P
0 0 0 r
s
.47 .135 .064 r
.33865 .52728 m .32957 .53801 L .33896 .55656 L p F P
0 0 0 r
s
.24 .35 .67 r
.76386 .5435 m
.79905 .55622 L
s
.79905 .55622 m
.79202 .5872 L
s
1 .315 .13 r
.55146 .64362 m .55679 .63896 L .57269 .63496 L p F P
0 0 0 r
s
1 .315 .13 r
.57968 .62891 m .57269 .63496 L .55679 .63896 L p F P
0 0 0 r
s
.152 .189 .336 r
.60417 .38272 m .62081 .38925 L .63046 .40251 L p F P
0 0 0 r
s
.152 .189 .336 r
.64819 .40942 m .63046 .40251 L .62081 .38925 L p F P
0 0 0 r
s
.391 .108 .052 r
.70152 .47737 m .71472 .46548 L .71005 .44675 L p F P
0 0 0 r
s
.273 .073 .037 r
.71472 .46548 m .70152 .47737 L .70084 .4971 L p F P
0 0 0 r
s
.213 .34 .684 r
.4877 .64942 m .48164 .64759 L .47341 .65071 L p F P
0 0 0 r
s
.213 .34 .684 r
.46457 .64806 m .47341 .65071 L .48164 .64759 L p F P
0 0 0 r
s
.083 .024 .01 r
.38126 .40523 m .37178 .4171 L .36544 .4337 L p F P
0 0 0 r
s
.083 .024 .01 r
.35573 .44576 m .36544 .4337 L .37178 .4171 L p F P
0 0 0 r
s
.83 .24 .1 r
.36753 .42994 m
.36856 .42866 L
s
.36856 .42866 m
.37213 .42165 L
s
.229 .31 .58 r
.69209 .43982 m .71005 .44675 L .71472 .46548 L p F P
0 0 0 r
s
.212 .061 .032 r
.33388 .5076 m .34336 .49614 L .34283 .47639 L p F P
0 0 0 r
s
.83 .24 .1 r
.34289 .47853 m
.34443 .47663 L
s
.34 .095 .048 r
.34336 .49614 m .33388 .5076 L .33865 .52728 L p F P
0 0 0 r
s
.663 .193 .087 r
.34471 .58282 m .33694 .59152 L .35619 .60502 L p F P
0 0 0 r
s
.83 .24 .1 r
.33726 .59208 m
.33744 .59188 L
s
.663 .193 .087 r
.3493 .61249 m .35619 .60502 L .33694 .59152 L p F P
0 0 0 r
s
.198 .262 .481 r
.64819 .40942 m .66573 .41625 L .67393 .43282 L p F P
0 0 0 r
s
.198 .262 .481 r
.69209 .43982 m .67393 .43282 L .66573 .41625 L p F P
0 0 0 r
s
.143 .041 .02 r
.34283 .47639 m .35252 .46448 L .35573 .44576 L p F P
0 0 0 r
s
.212 .061 .032 r
.35252 .46448 m .34283 .47639 L .34336 .49614 L p F P
0 0 0 r
s
.143 .041 .02 r
.36544 .4337 m .35573 .44576 L .35252 .46448 L p F P
0 0 0 r
s
.109 .123 .235 r
.54767 .35511 m .56305 .36118 L .57039 .36946 L p F P
0 0 0 r
s
.109 .123 .235 r
.58736 .37612 m .57039 .36946 L .56305 .36118 L p F P
0 0 0 r
s
1 .316 .128 r
.45145 .32848 m .44391 .33784 L .43478 .33949 L p F P
0 0 0 r
s
1 .316 .128 r
.42622 .3502 m .43478 .33949 L .44391 .33784 L p F P
0 0 0 r
s
.83 .24 .1 r
.43384 .35701 m
.45463 .33133 L
s
.24 .35 .67 r
.67862 .64722 m
.66083 .66734 L
s
.62402 .65584 m
.66083 .66734 L
s
.918 .277 .11 r
.42622 .3502 m .41778 .36074 L .40821 .36898 L p F P
0 0 0 r
s
.918 .277 .11 r
.39904 .38049 m .40821 .36898 L .41778 .36074 L p F P
0 0 0 r
s
.24 .35 .67 r
.7314 .63406 m
.71483 .65882 L
s
.67862 .64722 m
.71483 .65882 L
s
.944 .288 .117 r
.57968 .62891 m .58675 .62278 L .60336 .6131 L p F P
0 0 0 r
s
.944 .288 .117 r
.61201 .60564 m .60336 .6131 L .58675 .62278 L p F P
0 0 0 r
s
.83 .24 .1 r
.60625 .60812 m
.63038 .58725 L
s
.15 .249 .511 r
.4378 .64002 m .42879 .63731 L .40881 .63285 L p F P
0 0 0 r
s
.15 .249 .511 r
.39713 .62935 m .40881 .63285 L .42879 .63731 L p F P
0 0 0 r
s
.24 .35 .67 r
.29234 .27585 m
.33285 .29157 L
s
.33285 .29157 m
.34482 .28288 L
s
.079 .091 .174 r
.38537 .62582 m .37353 .62227 L .3493 .61249 L p F P
0 0 0 r
s
.738 .216 .096 r
.35619 .60502 m .3493 .61249 L .37353 .62227 L p F P
0 0 0 r
s
.83 .24 .1 r
.34579 .62837 m
.35701 .61635 L
s
.35701 .61635 m
.35752 .61581 L
s
.24 .35 .67 r
.33194 .60691 m
.35554 .61401 L
s
.35554 .61401 m
.35682 .61439 L
s
.36942 .61818 m
.37199 .61895 L
s
1 .322 .134 r
.52828 .64906 m .53185 .64589 L .54617 .64825 L p F P
0 0 0 r
s
1 .322 .134 r
.55146 .64362 m .54617 .64825 L .53185 .64589 L p F P
0 0 0 r
s
.213 .34 .684 r
.48164 .64759 m .47556 .64575 L .46457 .64806 L p F P
0 0 0 r
s
.213 .34 .684 r
.4557 .64539 m .46457 .64806 L .47556 .64575 L p F P
0 0 0 r
s
.24 .35 .67 r
.79202 .5872 m
.78111 .61761 L
s
.7456 .60554 m
.78111 .61761 L
s
.75663 .57479 m
.79202 .5872 L
s
.073 .085 .164 r
.48685 .32993 m .50057 .33534 L .50066 .33659 L p F P
0 0 0 r
s
.073 .085 .164 r
.51647 .34282 m .50066 .33659 L .50057 .33534 L p F P
0 0 0 r
s
.24 .35 .67 r
.47517 .32754 m
.51334 .34257 L
s
.73125 .50014 m
.76694 .5134 L
s
.76694 .5134 m
.76386 .5435 L
s
.259 .4 .793 r
.51172 .65667 m .51767 .65847 L .50912 .64622 L p F P
0 0 0 r
s
.24 .35 .67 r
.51081 .65639 m
.51162 .65628 L
s
1 .316 .133 r
.52119 .65535 m .51767 .65847 L .50912 .64622 L p F P
0 0 0 r
s
.83 .24 .1 r
.52075 .65502 m
.52172 .65488 L
s
.24 .35 .67 r
.71427 .4665 m
.73047 .47265 L
s
.73047 .47265 m
.73125 .50014 L
s
.83 .24 .1 r
.59841 .25242 m
.57441 .28017 L
s
.57441 .28017 m
.54751 .27368 L
s
.41387 .65022 m
.44175 .66428 L
s
.152 .189 .336 r
.58736 .37612 m .60417 .38272 L .61254 .39553 L p F P
0 0 0 r
s
.152 .189 .336 r
.63046 .40251 m .61254 .39553 L .60417 .38272 L p F P
0 0 0 r
s
.24 .35 .67 r
.15549 .53149 m
.156 .51155 L
s
.213 .34 .684 r
.47556 .64575 m .46946 .64391 L .4557 .64539 L p F P
0 0 0 r
s
.83 .24 .1 r
.44175 .66428 m
.46174 .64542 L
s
.213 .34 .684 r
.44677 .64271 m .4557 .64539 L .46946 .64391 L p F P
0 0 0 r
s
.83 .24 .1 r
.46174 .64542 m
.46316 .64408 L
s
.15 .249 .511 r
.42879 .63731 m .41972 .63459 L .39713 .62935 L p F P
0 0 0 r
s
.15 .249 .511 r
.38537 .62582 m .39713 .62935 L .41972 .63459 L p F P
0 0 0 r
s
.24 .35 .67 r
.29097 .5946 m
.28402 .58485 L
s
.24282 .57238 m
.28402 .58485 L
s
1 .315 .13 r
.55679 .63896 m .56217 .63425 L .57968 .62891 L p F P
0 0 0 r
s
1 .315 .13 r
.58675 .62278 m .57968 .62891 L .56217 .63425 L p F P
0 0 0 r
s
.259 .4 .793 r
.50912 .64622 m .50604 .64528 L .51172 .65667 L p F P
0 0 0 r
s
.259 .4 .793 r
.50575 .65487 m .51172 .65667 L .50604 .64528 L p F P
0 0 0 r
s
.229 .31 .58 r
.67393 .43282 m .69209 .43982 L .69639 .45851 L p F P
0 0 0 r
s
.229 .31 .58 r
.71472 .46548 m .69639 .45851 L .69209 .43982 L p F P
0 0 0 r
s
.109 .123 .235 r
.53214 .349 m .54767 .35511 L .55324 .36273 L p F P
0 0 0 r
s
.24 .35 .67 r
.54939 .35747 m
.55472 .35956 L
s
.109 .123 .235 r
.57039 .36946 m .55324 .36273 L .54767 .35511 L p F P
0 0 0 r
s
.198 .262 .481 r
.63046 .40251 m .64819 .40942 L .65556 .42574 L p F P
0 0 0 r
s
.198 .262 .481 r
.67393 .43282 m .65556 .42574 L .64819 .40942 L p F P
0 0 0 r
s
.083 .024 .01 r
.40821 .36898 m .39904 .38049 L .39091 .39314 L p F P
0 0 0 r
s
.083 .024 .01 r
.38126 .40523 m .39091 .39314 L .39904 .38049 L p F P
0 0 0 r
s
1 .322 .134 r
.53185 .64589 m .53545 .64269 L .55146 .64362 L p F P
0 0 0 r
s
1 .322 .134 r
.55679 .63896 m .55146 .64362 L .53545 .64269 L p F P
0 0 0 r
s
1 .316 .133 r
.50912 .64622 m .51091 .6446 L .52119 .65535 L p F P
0 0 0 r
s
.83 .24 .1 r
.50639 .65404 m
.50929 .6543 L
s
1 .316 .133 r
.52472 .65221 m .52119 .65535 L .51091 .6446 L p F P
0 0 0 r
s
.83 .24 .1 r
.70094 .32355 m
.67809 .30052 L
s
.70422 .27308 m
.67809 .30052 L
s
.67809 .30052 m
.65279 .28052 L
s
.073 .085 .164 r
.47303 .32448 m .48685 .32993 L .4847 .3303 L p F P
0 0 0 r
s
.24 .35 .67 r
.46039 .32172 m
.47517 .32754 L
s
.83 .24 .1 r
.47855 .32518 m
.49931 .29996 L
s
.47763 .32629 m
.47855 .32518 L
s
.073 .085 .164 r
.50066 .33659 m .4847 .3303 L .48685 .32993 L p F P
0 0 0 r
s
.259 .4 .793 r
.50604 .64528 m .50296 .64434 L .50575 .65487 L p F P
0 0 0 r
s
.259 .4 .793 r
.49975 .65306 m .50575 .65487 L .50296 .64434 L p F P
0 0 0 r
s
.083 .024 .01 r
.63706 .58355 m .64729 .57472 L .66092 .55738 L p F P
0 0 0 r
s
.083 .024 .01 r
.6724 .54742 m .66092 .55738 L .64729 .57472 L p F P
0 0 0 r
s
.084 .024 .01 r
.66092 .55738 m .6724 .54742 L .68255 .52817 L p F P
0 0 0 r
s
.83 .24 .1 r
.64229 .56871 m
.66723 .54698 L
s
.66723 .54698 m
.67345 .52494 L
s
.083 .024 .01 r
.61201 .60564 m .62077 .59808 L .63706 .58355 L p F P
0 0 0 r
s
.083 .024 .01 r
.64729 .57472 m .63706 .58355 L .62077 .59808 L p F P
0 0 0 r
s
.83 .24 .1 r
.52192 .2725 m
.49931 .29996 L
s
.49931 .29996 m
.47624 .30464 L
s
.213 .34 .684 r
.46946 .64391 m .46334 .64206 L .44677 .64271 L p F P
0 0 0 r
s
.213 .34 .684 r
.4378 .64002 m .44677 .64271 L .46334 .64206 L p F P
0 0 0 r
s
.24 .35 .67 r
.42265 .6348 m
.44086 .64026 L
s
.23911 .27481 m
.25091 .25977 L
s
.83 .24 .1 r
.72581 .45384 m
.72031 .42751 L
s
.74729 .40257 m
.72031 .42751 L
s
.72056 .34882 m
.70094 .32355 L
s
.72754 .29655 m
.70094 .32355 L
s
.084 .024 .01 r
.69502 .51726 m .68255 .52817 L .6724 .54742 L p F P
0 0 0 r
s
.161 .046 .023 r
.68255 .52817 m .69502 .51726 L .70084 .4971 L p F P
0 0 0 r
s
.575 .166 .076 r
.34471 .58282 m .35262 .57399 L .33896 .55656 L p F P
0 0 0 r
s
.663 .193 .087 r
.35262 .57399 m .34471 .58282 L .36318 .59745 L p F P
0 0 0 r
s
.83 .24 .1 r
.34502 .58341 m
.3452 .58321 L
s
.663 .193 .087 r
.35619 .60502 m .36318 .59745 L .34471 .58282 L p F P
0 0 0 r
s
.47 .135 .064 r
.33896 .55656 m .34762 .54659 L .33865 .52728 L p F P
0 0 0 r
s
.575 .166 .076 r
.34762 .54659 m .33896 .55656 L .35262 .57399 L p F P
0 0 0 r
s
1 .316 .128 r
.45909 .31899 m .45145 .32848 L .44348 .32861 L p F P
0 0 0 r
s
.83 .24 .1 r
.45463 .33133 m
.46277 .32127 L
s
1 .316 .128 r
.43478 .33949 m .44348 .32861 L .45145 .32848 L p F P
0 0 0 r
s
.83 .24 .1 r
.43498 .34175 m
.45463 .33133 L
s
.15 .249 .511 r
.41972 .63459 m .41061 .63186 L .38537 .62582 L p F P
0 0 0 r
s
.24 .35 .67 r
.41117 .63073 m
.42265 .6348 L
s
.15 .249 .511 r
.37353 .62227 m .38537 .62582 L .41061 .63186 L p F P
0 0 0 r
s
.24 .35 .67 r
.34482 .28288 m
.38502 .29864 L
s
.38502 .29864 m
.39622 .29645 L
s
.944 .288 .117 r
.58675 .62278 m .5939 .61659 L .61201 .60564 L p F P
0 0 0 r
s
.944 .288 .117 r
.62077 .59808 m .61201 .60564 L .5939 .61659 L p F P
0 0 0 r
s
.34 .095 .048 r
.33865 .52728 m .3479 .51634 L .34336 .49614 L p F P
0 0 0 r
s
.47 .135 .064 r
.3479 .51634 m .33865 .52728 L .34762 .54659 L p F P
0 0 0 r
s
.161 .046 .023 r
.71399 .48545 m .70084 .4971 L .69502 .51726 L p F P
0 0 0 r
s
.83 .24 .1 r
.67345 .52494 m
.69913 .50225 L
s
.273 .073 .037 r
.70084 .4971 m .71399 .48545 L .71472 .46548 L p F P
0 0 0 r
s
.259 .4 .793 r
.50296 .64434 m .49987 .6434 L .49975 .65306 L p F P
0 0 0 r
s
.259 .4 .793 r
.49373 .65124 m .49975 .65306 L .49987 .6434 L p F P
0 0 0 r
s
.83 .24 .1 r
.49181 .65271 m
.50639 .65404 L
s
.738 .216 .096 r
.36318 .59745 m .35619 .60502 L .37945 .61607 L p F P
0 0 0 r
s
.738 .216 .096 r
.37353 .62227 m .37945 .61607 L .35619 .60502 L p F P
0 0 0 r
s
.083 .024 .01 r
.39091 .39314 m .38126 .40523 L .37533 .4214 L p F P
0 0 0 r
s
.83 .24 .1 r
.38094 .40579 m
.38114 .40555 L
s
.39061 .3937 m
.39888 .38334 L
s
.083 .024 .01 r
.36544 .4337 m .37533 .4214 L .38126 .40523 L p F P
0 0 0 r
s
.918 .277 .11 r
.43478 .33949 m .42622 .3502 L .41755 .35728 L p F P
0 0 0 r
s
.918 .277 .11 r
.40821 .36898 m .41755 .35728 L .42622 .3502 L p F P
0 0 0 r
s
.83 .24 .1 r
.39888 .38334 m
.41427 .3676 L
s
.24 .35 .67 r
.7456 .60554 m
.7314 .63406 L
s
.69509 .62209 m
.7314 .63406 L
s
.83 .24 .1 r
.67849 .25262 m
.65279 .28052 L
s
.65279 .28052 m
.62592 .26427 L
s
.24 .35 .67 r
.58637 .64408 m
.56888 .65894 L
s
.249 .344 .649 r
.69639 .45851 m .71472 .46548 L .71399 .48545 L p F P
0 0 0 r
s
.24 .35 .67 r
.69435 .45894 m
.69743 .46011 L
s
.83 .24 .1 r
.69947 .4776 m
.70538 .47227 L
s
.69913 .50225 m
.69947 .4776 L
s
.212 .061 .032 r
.34336 .49614 m .35303 .48447 L .35252 .46448 L p F P
0 0 0 r
s
.34 .095 .048 r
.35303 .48447 m .34336 .49614 L .3479 .51634 L p F P
0 0 0 r
s
.24 .35 .67 r
.20068 .55963 m
.19786 .54448 L
s
.15549 .53149 m
.19786 .54448 L
s
.152 .189 .336 r
.57039 .36946 m .58736 .37612 L .59442 .38847 L p F P
0 0 0 r
s
.152 .189 .336 r
.61254 .39553 m .59442 .38847 L .58736 .37612 L p F P
0 0 0 r
s
1 .316 .133 r
.51091 .6446 m .51271 .64297 L .52472 .65221 L p F P
0 0 0 r
s
1 .316 .133 r
.52828 .64906 m .52472 .65221 L .51271 .64297 L p F P
0 0 0 r
s
.24 .35 .67 r
.52032 .65276 m
.52204 .65185 L
s
.213 .34 .684 r
.46334 .64206 m .45719 .64021 L .4378 .64002 L p F P
0 0 0 r
s
.213 .34 .684 r
.42879 .63731 m .4378 .64002 L .45719 .64021 L p F P
0 0 0 r
s
.109 .123 .235 r
.51647 .34282 m .53214 .349 L .53592 .35594 L p F P
0 0 0 r
s
.24 .35 .67 r
.53331 .35114 m
.53868 .35326 L
s
.51334 .34257 m
.5219 .34649 L
s
.109 .123 .235 r
.55324 .36273 m .53592 .35594 L .53214 .349 L p F P
0 0 0 r
s
.143 .041 .02 r
.35252 .46448 m .36241 .45234 L .36544 .4337 L p F P
0 0 0 r
s
.212 .061 .032 r
.36241 .45234 m .35252 .46448 L .35303 .48447 L p F P
0 0 0 r
s
.143 .041 .02 r
.37533 .4214 m .36544 .4337 L .36241 .45234 L p F P
0 0 0 r
s
.83 .24 .1 r
.36384 .45283 m
.36528 .44548 L
s
.24 .35 .67 r
.72787 .53049 m
.76386 .5435 L
s
.76386 .5435 m
.75663 .57479 L
s
.259 .4 .793 r
.49987 .6434 m .49678 .64246 L .49373 .65124 L p F P
0 0 0 r
s
.259 .4 .793 r
.4877 .64942 m .49373 .65124 L .49678 .64246 L p F P
0 0 0 r
s
.073 .085 .164 r
.45909 .31899 m .47303 .32448 L .46859 .32396 L p F P
0 0 0 r
s
.83 .24 .1 r
.46329 .32064 m
.46346 .32042 L
s
.073 .085 .164 r
.4847 .3303 m .46859 .32396 L .47303 .32448 L p F P
0 0 0 r
s
1 .322 .134 r
.53545 .64269 m .53907 .63948 L .55679 .63896 L p F P
0 0 0 r
s
1 .322 .134 r
.56217 .63425 m .55679 .63896 L .53907 .63948 L p F P
0 0 0 r
s
.229 .31 .58 r
.65556 .42574 m .67393 .43282 L .67784 .45146 L p F P
0 0 0 r
s
.229 .31 .58 r
.69639 .45851 m .67784 .45146 L .67393 .43282 L p F P
0 0 0 r
s
.24 .35 .67 r
.69411 .45764 m
.69435 .45894 L
s
1 .315 .13 r
.56217 .63425 m .5676 .6295 L .58675 .62278 L p F P
0 0 0 r
s
1 .315 .13 r
.5939 .61659 m .58675 .62278 L .5676 .6295 L p F P
0 0 0 r
s
.83 .24 .1 r
.73623 .37547 m
.72056 .34882 L
s
.74765 .32222 m
.72056 .34882 L
s
.198 .262 .481 r
.61254 .39553 m .63046 .40251 L .63699 .41858 L p F P
0 0 0 r
s
.198 .262 .481 r
.65556 .42574 m .63699 .41858 L .63046 .40251 L p F P
0 0 0 r
s
.15 .249 .511 r
.41061 .63186 m .40146 .62911 L .37353 .62227 L p F P
0 0 0 r
s
.83 .24 .1 r
.38785 .63104 m
.41387 .65022 L
s
.36812 .65126 m
.38785 .63104 L
s
.805 .237 .104 r
.37945 .61607 m .37353 .62227 L .40146 .62911 L p F P
0 0 0 r
s
.24 .35 .67 r
.37971 .62171 m
.38019 .62189 L
s
.83 .24 .1 r
.38133 .62436 m
.38785 .63104 L
s
.38785 .63104 m
.3919 .62688 L
s
.259 .4 .793 r
.49678 .64246 m .49368 .64152 L .4877 .64942 L p F P
0 0 0 r
s
.259 .4 .793 r
.48164 .64759 m .4877 .64942 L .49368 .64152 L p F P
0 0 0 r
s
.24 .35 .67 r
.34217 .61062 m
.33194 .60691 L
s
.29097 .5946 m
.33194 .60691 L
s
.64159 .63537 m
.62402 .65584 L
s
.58637 .64408 m
.62402 .65584 L
s
.213 .34 .684 r
.45719 .64021 m .45102 .63835 L .42879 .63731 L p F P
0 0 0 r
s
.213 .34 .684 r
.41972 .63459 m .42879 .63731 L .45102 .63835 L p F P
0 0 0 r
s
.24 .35 .67 r
.69509 .62209 m
.67862 .64722 L
s
.64159 .63537 m
.67862 .64722 L
s
1 .316 .133 r
.51271 .64297 m .51452 .64133 L .52828 .64906 L p F P
0 0 0 r
s
1 .316 .133 r
.53185 .64589 m .52828 .64906 L .51452 .64133 L p F P
0 0 0 r
s
.24 .35 .67 r
.52204 .65185 m
.53072 .64725 L
s
.53072 .64725 m
.56888 .65894 L
s
.25091 .25977 m
.29234 .27585 L
s
.29234 .27585 m
.30371 .26677 L
s
.75663 .57479 m
.7456 .60554 L
s
.70929 .59319 m
.7456 .60554 L
s
.72043 .56209 m
.75663 .57479 L
s
.259 .4 .793 r
.49368 .64152 m .49058 .64057 L .48164 .64759 L p F P
0 0 0 r
s
.259 .4 .793 r
.47556 .64575 m .48164 .64759 L .49058 .64057 L p F P
0 0 0 r
s
.24 .35 .67 r
.47581 .64425 m
.47801 .64491 L
s
.47236 .64479 m
.47581 .64425 L
s
.83 .24 .1 r
.57123 .2455 m
.54751 .27368 L
s
.54751 .27368 m
.52192 .2725 L
s
.24 .35 .67 r
.73125 .50014 m
.72787 .53049 L
s
.152 .189 .336 r
.55324 .36273 m .57039 .36946 L .57611 .38134 L p F P
0 0 0 r
s
.152 .189 .336 r
.59442 .38847 m .57611 .38134 L .57039 .36946 L p F P
0 0 0 r
s
.109 .123 .235 r
.50066 .33659 m .51647 .34282 L .51842 .34907 L p F P
0 0 0 r
s
.24 .35 .67 r
.51707 .34475 m
.5225 .34689 L
s
.109 .123 .235 r
.53592 .35594 m .51842 .34907 L .51647 .34282 L p F P
0 0 0 r
s
.83 .24 .1 r
.65123 .23589 m
.62592 .26427 L
s
.62592 .26427 m
.59841 .25242 L
s
1 .316 .128 r
.44348 .32861 m .45233 .31755 L .45909 .31899 L p F P
0 0 0 r
s
.24 .35 .67 r
.43614 .31217 m
.45172 .3183 L
s
.073 .085 .164 r
.46859 .32396 m .45233 .31755 L .45909 .31899 L p F P
0 0 0 r
s
.83 .24 .1 r
.46346 .32042 m
.47624 .30464 L
s
.083 .024 .01 r
.41755 .35728 m .40821 .36898 L .40076 .38082 L p F P
0 0 0 r
s
.83 .24 .1 r
.41427 .3676 m
.43498 .34175 L
s
.083 .024 .01 r
.39091 .39314 m .40076 .38082 L .40821 .36898 L p F P
0 0 0 r
s
.083 .024 .01 r
.62077 .59808 m .62966 .59041 L .64729 .57472 L p F P
0 0 0 r
s
.083 .024 .01 r
.65768 .56575 m .64729 .57472 L .62966 .59041 L p F P
0 0 0 r
s
.083 .024 .01 r
.64729 .57472 m .65768 .56575 L .6724 .54742 L p F P
0 0 0 r
s
.83 .24 .1 r
.63038 .58725 m
.65546 .56557 L
s
.213 .34 .684 r
.45102 .63835 m .44484 .63648 L .41972 .63459 L p F P
0 0 0 r
s
.213 .34 .684 r
.41061 .63186 m .41972 .63459 L .44484 .63648 L p F P
0 0 0 r
s
.24 .35 .67 r
.39913 .62773 m
.41472 .63241 L
s
.249 .344 .649 r
.67784 .45146 m .69639 .45851 L .69571 .47861 L p F P
0 0 0 r
s
.249 .344 .649 r
.71399 .48545 m .69571 .47861 L .69639 .45851 L p F P
0 0 0 r
s
.83 .24 .1 r
.71344 .46499 m
.72581 .45384 L
s
.944 .288 .117 r
.5939 .61659 m .60113 .61032 L .62077 .59808 L p F P
0 0 0 r
s
.944 .288 .117 r
.62966 .59041 m .62077 .59808 L .60113 .61032 L p F P
0 0 0 r
s
.83 .24 .1 r
.61104 .60341 m
.6133 .60145 L
s
.6133 .60145 m
.63038 .58725 L
s
1 .322 .134 r
.53907 .63948 m .54272 .63625 L .56217 .63425 L p F P
0 0 0 r
s
1 .322 .134 r
.5676 .6295 m .56217 .63425 L .54272 .63625 L p F P
0 0 0 r
s
1 .316 .133 r
.51452 .64133 m .51633 .63969 L .53185 .64589 L p F P
0 0 0 r
s
1 .316 .133 r
.53545 .64269 m .53185 .64589 L .51633 .63969 L p F P
0 0 0 r
s
.575 .166 .076 r
.35262 .57399 m .36064 .565 L .34762 .54659 L p F P
0 0 0 r
s
.663 .193 .087 r
.36064 .565 m .35262 .57399 L .37026 .58977 L p F P
0 0 0 r
s
.83 .24 .1 r
.3529 .57461 m
.35308 .5744 L
s
.663 .193 .087 r
.36318 .59745 m .37026 .58977 L .35262 .57399 L p F P
0 0 0 r
s
.259 .4 .793 r
.49058 .64057 m .48747 .63962 L .47556 .64575 L p F P
0 0 0 r
s
.259 .4 .793 r
.46946 .64391 m .47556 .64575 L .48747 .63962 L p F P
0 0 0 r
s
.83 .24 .1 r
.46316 .64408 m
.49181 .65271 L
s
.083 .024 .01 r
.68409 .53729 m .6724 .54742 L .65768 .56575 L p F P
0 0 0 r
s
.83 .24 .1 r
.65546 .56557 m
.66723 .54698 L
s
.084 .024 .01 r
.6724 .54742 m .68409 .53729 L .69502 .51726 L p F P
0 0 0 r
s
.24 .35 .67 r
.39622 .29645 m
.43614 .31217 L
s
.43614 .31217 m
.44609 .31682 L
s
.738 .216 .096 r
.37026 .58977 m .36318 .59745 L .38544 .60979 L p F P
0 0 0 r
s
.738 .216 .096 r
.37945 .61607 m .38544 .60979 L .36318 .59745 L p F P
0 0 0 r
s
.24 .35 .67 r
.24907 .582 m
.24282 .57238 L
s
.20068 .55963 m
.24282 .57238 L
s
.47 .135 .064 r
.34762 .54659 m .35643 .53644 L .3479 .51634 L p F P
0 0 0 r
s
.575 .166 .076 r
.35643 .53644 m .34762 .54659 L .36064 .565 L p F P
0 0 0 r
s
.229 .31 .58 r
.63699 .41858 m .65556 .42574 L .65908 .44432 L p F P
0 0 0 r
s
.229 .31 .58 r
.67784 .45146 m .65908 .44432 L .65556 .42574 L p F P
0 0 0 r
s
.198 .262 .481 r
.59442 .38847 m .61254 .39553 L .6182 .41134 L p F P
0 0 0 r
s
.198 .262 .481 r
.63699 .41858 m .6182 .41134 L .61254 .39553 L p F P
0 0 0 r
s
1 .315 .13 r
.5676 .6295 m .57308 .62471 L .5939 .61659 L p F P
0 0 0 r
s
1 .315 .13 r
.60113 .61032 m .5939 .61659 L .57308 .62471 L p F P
0 0 0 r
s
.084 .024 .01 r
.70773 .50613 m .69502 .51726 L .68409 .53729 L p F P
0 0 0 r
s
.161 .046 .023 r
.69502 .51726 m .70773 .50613 L .71399 .48545 L p F P
0 0 0 r
s
.918 .277 .11 r
.44348 .32861 m .43478 .33949 L .42705 .34536 L p F P
0 0 0 r
s
.918 .277 .11 r
.41755 .35728 m .42705 .34536 L .43478 .33949 L p F P
0 0 0 r
s
.805 .237 .104 r
.38544 .60979 m .37945 .61607 L .40619 .62431 L p F P
0 0 0 r
s
.805 .237 .104 r
.40146 .62911 m .40619 .62431 L .37945 .61607 L p F P
0 0 0 r
s
.24 .35 .67 r
.38019 .62189 m
.38287 .62284 L
s
.38287 .62284 m
.39093 .62527 L
s
.259 .4 .793 r
.48747 .63962 m .48435 .63867 L .46946 .64391 L p F P
0 0 0 r
s
.259 .4 .793 r
.46334 .64206 m .46946 .64391 L .48435 .63867 L p F P
0 0 0 r
s
.213 .34 .684 r
.44484 .63648 m .43863 .6346 L .41061 .63186 L p F P
0 0 0 r
s
.83 .24 .1 r
.41387 .65022 m
.42818 .63616 L
s
.213 .34 .684 r
.40146 .62911 m .41061 .63186 L .43863 .6346 L p F P
0 0 0 r
s
.83 .24 .1 r
.74729 .40257 m
.73623 .37547 L
s
.7638 .34922 m
.73623 .37547 L
s
.34 .095 .048 r
.3479 .51634 m .35733 .5052 L .35303 .48447 L p F P
0 0 0 r
s
.47 .135 .064 r
.35733 .5052 m .3479 .51634 L .35643 .53644 L p F P
0 0 0 r
s
.263 .368 .699 r
.69571 .47861 m .71399 .48545 L .70773 .50613 L p F P
0 0 0 r
s
.83 .24 .1 r
.71101 .49175 m
.71176 .49108 L
s
.69913 .50225 m
.70411 .49784 L
s
.24 .35 .67 r
.71173 .4929 m
.7123 .49311 L
s
.7123 .49311 m
.73125 .50014 L
s
.83 .24 .1 r
.71176 .49108 m
.72582 .47866 L
s
.083 .024 .01 r
.40076 .38082 m .39091 .39314 L .38541 .40886 L p F P
0 0 0 r
s
.083 .024 .01 r
.37533 .4214 m .38541 .40886 L .39091 .39314 L p F P
0 0 0 r
s
.83 .24 .1 r
.38744 .40516 m
.38857 .40376 L
s
.38857 .40376 m
.3929 .39517 L
s
1 .316 .133 r
.51633 .63969 m .51815 .63805 L .53545 .64269 L p F P
0 0 0 r
s
1 .316 .133 r
.53907 .63948 m .53545 .64269 L .51815 .63805 L p F P
0 0 0 r
s
.83 .24 .1 r
.72581 .45384 m
.75321 .42913 L
s
.72582 .47866 m
.72581 .45384 L
s
.212 .061 .032 r
.35303 .48447 m .36289 .47256 L .36241 .45234 L p F P
0 0 0 r
s
.83 .24 .1 r
.36246 .45452 m
.36384 .45283 L
s
.34 .095 .048 r
.36289 .47256 m .35303 .48447 L .35733 .5052 L p F P
0 0 0 r
s
.259 .4 .793 r
.48435 .63867 m .48123 .63772 L .46334 .64206 L p F P
0 0 0 r
s
.259 .4 .793 r
.45719 .64021 m .46334 .64206 L .48123 .63772 L p F P
0 0 0 r
s
.109 .123 .235 r
.4847 .3303 m .50066 .33659 L .50074 .34213 L p F P
0 0 0 r
s
.24 .35 .67 r
.48574 .33242 m
.48967 .33397 L
s
.50068 .3383 m
.50616 .34046 L
s
.47517 .32754 m
.48574 .33242 L
s
.109 .123 .235 r
.51842 .34907 m .50074 .34213 L .50066 .33659 L p F P
0 0 0 r
s
.24 .35 .67 r
.30371 .26677 m
.34482 .28288 L
s
.34482 .28288 m
.35538 .28037 L
s
.152 .189 .336 r
.53592 .35594 m .55324 .36273 L .55759 .37413 L p F P
0 0 0 r
s
.152 .189 .336 r
.57611 .38134 m .55759 .37413 L .55324 .36273 L p F P
0 0 0 r
s
.24 .35 .67 r
.34217 .61062 m
.38287 .62284 L
s
1 .322 .134 r
.54272 .63625 m .54638 .63299 L .5676 .6295 L p F P
0 0 0 r
s
.83 .24 .1 r
.54227 .63482 m
.54468 .6345 L
s
1 .322 .134 r
.57308 .62471 m .5676 .6295 L .54638 .63299 L p F P
0 0 0 r
s
.143 .041 .02 r
.38541 .40886 m .37533 .4214 L .3725 .43995 L p F P
0 0 0 r
s
.143 .041 .02 r
.36241 .45234 m .3725 .43995 L .37533 .4214 L p F P
0 0 0 r
s
.212 .061 .032 r
.3725 .43995 m .36241 .45234 L .36289 .47256 L p F P
0 0 0 r
s
.213 .34 .684 r
.43863 .6346 m .43239 .63272 L .40146 .62911 L p F P
0 0 0 r
s
.83 .24 .1 r
.42818 .63616 m
.43114 .63326 L
s
.866 .256 .112 r
.40619 .62431 m .40146 .62911 L .43239 .63272 L p F P
0 0 0 r
s
.24 .35 .67 r
.70929 .59319 m
.69509 .62209 L
s
.65794 .60985 m
.69509 .62209 L
s
.51516 .64249 m
.53072 .64725 L
s
.15757 .54658 m
.15549 .53149 L
s
.249 .344 .649 r
.65908 .44432 m .67784 .45146 L .67723 .4717 L p F P
0 0 0 r
s
.24 .35 .67 r
.65742 .44491 m
.66016 .44595 L
s
.6778 .45265 m
.6789 .45307 L
s
.249 .344 .649 r
.69571 .47861 m .67723 .4717 L .67784 .45146 L p F P
0 0 0 r
s
.259 .4 .793 r
.48123 .63772 m .47811 .63677 L .45719 .64021 L p F P
0 0 0 r
s
.259 .4 .793 r
.45102 .63835 m .45719 .64021 L .47811 .63677 L p F P
0 0 0 r
s
.83 .24 .1 r
.49871 .27689 m
.47624 .30464 L
s
.47624 .30464 m
.45652 .31487 L
s
.24 .35 .67 r
.72787 .53049 m
.72043 .56209 L
s
1 .316 .133 r
.51815 .63805 m .51998 .6364 L .53907 .63948 L p F P
0 0 0 r
s
1 .316 .133 r
.54272 .63625 m .53907 .63948 L .51998 .6364 L p F P
0 0 0 r
s
.83 .24 .1 r
.54066 .63626 m
.54227 .63482 L
s
.198 .262 .481 r
.57611 .38134 m .59442 .38847 L .5992 .40402 L p F P
0 0 0 r
s
.198 .262 .481 r
.6182 .41134 m .5992 .40402 L .59442 .38847 L p F P
0 0 0 r
s
.229 .31 .58 r
.6182 .41134 m .63699 .41858 L .6401 .43711 L p F P
0 0 0 r
s
.229 .31 .58 r
.65908 .44432 m .6401 .43711 L .63699 .41858 L p F P
0 0 0 r
s
.24 .35 .67 r
.6572 .44361 m
.65742 .44491 L
s
.944 .288 .117 r
.60113 .61032 m .60845 .60398 L .62966 .59041 L p F P
0 0 0 r
s
.083 .024 .01 r
.62966 .59041 m .63868 .58263 L .65768 .56575 L p F P
0 0 0 r
s
.944 .288 .117 r
.63868 .58263 m .62966 .59041 L .60845 .60398 L p F P
0 0 0 r
s
.282 .427 .841 r
.50604 .64528 m .50912 .64622 L .5 .62969 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.49181 .65271 m
.49867 .64645 L
s
1 .304 .13 r
.51091 .6446 m .50912 .64622 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .315 .13 r
.57308 .62471 m .57861 .61987 L .60113 .61032 L p F P
0 0 0 r
s
1 .315 .13 r
.60845 .60398 m .60113 .61032 L .57861 .61987 L p F P
0 0 0 r
s
.663 .193 .087 r
.37026 .58977 m .37745 .58198 L .36064 .565 L p F P
0 0 0 r
s
.738 .216 .096 r
.37745 .58198 m .37026 .58977 L .39149 .60345 L p F P
0 0 0 r
s
.738 .216 .096 r
.38544 .60979 m .39149 .60345 L .37026 .58977 L p F P
0 0 0 r
s
.259 .4 .793 r
.47811 .63677 m .47497 .63582 L .45102 .63835 L p F P
0 0 0 r
s
.259 .4 .793 r
.44484 .63648 m .45102 .63835 L .47497 .63582 L p F P
0 0 0 r
s
.083 .024 .01 r
.66824 .55664 m .65768 .56575 L .63868 .58263 L p F P
0 0 0 r
s
.083 .024 .01 r
.65768 .56575 m .66824 .55664 L .68409 .53729 L p F P
0 0 0 r
s
.805 .237 .104 r
.39149 .60345 m .38544 .60979 L .41096 .61947 L p F P
0 0 0 r
s
.805 .237 .104 r
.40619 .62431 m .41096 .61947 L .38544 .60979 L p F P
0 0 0 r
s
.24 .35 .67 r
.38287 .62284 m
.396 .62012 L
s
.83 .24 .1 r
.62337 .22356 m
.59841 .25242 L
s
.59841 .25242 m
.57123 .2455 L
s
.282 .427 .841 r
.50296 .64434 m .50604 .64528 L .5 .62969 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.49867 .64645 m
.50078 .64452 L
s
.24 .35 .67 r
.30054 .59811 m
.29097 .5946 L
s
.24907 .582 m
.29097 .5946 L
s
.575 .166 .076 r
.36064 .565 m .3688 .55588 L .35643 .53644 L p F P
0 0 0 r
s
.663 .193 .087 r
.3688 .55588 m .36064 .565 L .37745 .58198 L p F P
0 0 0 r
s
.24 .35 .67 r
.58637 .64408 m
.6037 .62323 L
s
.083 .024 .01 r
.42705 .34536 m .41755 .35728 L .41079 .36827 L p F P
0 0 0 r
s
.083 .024 .01 r
.40076 .38082 m .41079 .36827 L .41755 .35728 L p F P
0 0 0 r
s
1 .304 .13 r
.51271 .64297 m .51091 .6446 L .5 .62969 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.65794 .60985 m
.64159 .63537 L
s
.6037 .62323 m
.64159 .63537 L
s
.109 .123 .235 r
.46859 .32396 m .4847 .3303 L .48287 .33512 L p F P
0 0 0 r
s
.24 .35 .67 r
.48413 .33179 m
.48574 .33242 L
s
.109 .123 .235 r
.50074 .34213 m .48287 .33512 L .4847 .3303 L p F P
0 0 0 r
s
.24 .35 .67 r
.25091 .25977 m
.26164 .25029 L
s
.263 .368 .699 r
.67723 .4717 m .69571 .47861 L .68996 .49961 L p F P
0 0 0 r
s
.263 .368 .699 r
.70773 .50613 m .68996 .49961 L .69571 .47861 L p F P
0 0 0 r
s
.282 .427 .841 r
.49987 .6434 m .50296 .64434 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .322 .134 r
.54638 .63299 m .55007 .62972 L .57308 .62471 L p F P
0 0 0 r
s
1 .322 .134 r
.57861 .61987 m .57308 .62471 L .55007 .62972 L p F P
0 0 0 r
s
.259 .4 .793 r
.47497 .63582 m .47184 .63486 L .44484 .63648 L p F P
0 0 0 r
s
.259 .4 .793 r
.43863 .6346 m .44484 .63648 L .47184 .63486 L p F P
0 0 0 r
s
.83 .24 .1 r
.44827 .63648 m
.46316 .64408 L
s
.44527 .63495 m
.44827 .63648 L
s
.46316 .64408 m
.47198 .63575 L
s
.083 .024 .01 r
.69598 .52697 m .68409 .53729 L .66824 .55664 L p F P
0 0 0 r
s
.084 .024 .01 r
.68409 .53729 m .69598 .52697 L .70773 .50613 L p F P
0 0 0 r
s
.866 .256 .112 r
.41096 .61947 m .40619 .62431 L .43573 .62945 L p F P
0 0 0 r
s
.866 .256 .112 r
.43239 .63272 m .43573 .62945 L .40619 .62431 L p F P
0 0 0 r
s
.152 .189 .336 r
.51842 .34907 m .53592 .35594 L .53887 .36683 L p F P
0 0 0 r
s
.152 .189 .336 r
.55759 .37413 m .53887 .36683 L .53592 .35594 L p F P
0 0 0 r
s
1 .316 .133 r
.51998 .6364 m .52181 .63474 L .54272 .63625 L p F P
0 0 0 r
s
1 .316 .133 r
.54638 .63299 m .54272 .63625 L .52181 .63474 L p F P
0 0 0 r
s
.24 .35 .67 r
.72043 .56209 m
.70929 .59319 L
s
.67215 .58056 m
.70929 .59319 L
s
.282 .427 .841 r
.49678 .64246 m .49987 .6434 L .5 .62969 L closepath p F P
0 0 0 r
s
.918 .277 .11 r
.45233 .31755 m .44348 .32861 L .43673 .33323 L p F P
0 0 0 r
s
.24 .35 .67 r
.45098 .31874 m
.45109 .31879 L
s
.918 .277 .11 r
.42705 .34536 m .43673 .33323 L .44348 .32861 L p F P
0 0 0 r
s
.83 .24 .1 r
.4196 .35742 m
.43498 .34175 L
s
.47 .135 .064 r
.35643 .53644 m .3654 .52611 L .35733 .5052 L p F P
0 0 0 r
s
.575 .166 .076 r
.3654 .52611 m .35643 .53644 L .3688 .55588 L p F P
0 0 0 r
s
1 .304 .13 r
.51452 .64133 m .51271 .64297 L .5 .62969 L closepath p F P
0 0 0 r
s
.282 .427 .841 r
.49368 .64152 m .49678 .64246 L .5 .62969 L closepath p F P
0 0 0 r
s
.259 .4 .793 r
.47184 .63486 m .46869 .6339 L .43863 .6346 L p F P
0 0 0 r
s
.259 .4 .793 r
.43239 .63272 m .43863 .6346 L .46869 .6339 L p F P
0 0 0 r
s
.24 .35 .67 r
.43636 .63232 m
.43834 .63292 L
s
.43385 .63277 m
.43636 .63232 L
s
.83 .24 .1 r
.72754 .29655 m
.70422 .27308 L
s
.73139 .24454 m
.70422 .27308 L
s
.70422 .27308 m
.67849 .25262 L
s
.274 .386 .737 r
.68996 .49961 m .70773 .50613 L .69598 .52697 L p F P
0 0 0 r
s
.24 .35 .67 r
.69973 .52032 m
.72787 .53049 L
s
.83 .24 .1 r
.69315 .5244 m
.6944 .51978 L
s
.66723 .54698 m
.69315 .5244 L
s
.249 .344 .649 r
.6401 .43711 m .65908 .44432 L .65853 .46471 L p F P
0 0 0 r
s
.249 .344 .649 r
.67723 .4717 m .65853 .46471 L .65908 .44432 L p F P
0 0 0 r
s
.24 .35 .67 r
.43364 .6315 m
.43636 .63232 L
s
.282 .427 .841 r
.49058 .64057 m .49368 .64152 L .5 .62969 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.54544 .24394 m
.52192 .2725 L
s
.52192 .2725 m
.49871 .27689 L
s
.70067 .51785 m
.72012 .50091 L
s
.69913 .51919 m
.70067 .51785 L
s
.69315 .5244 m
.69505 .52274 L
s
1 .304 .13 r
.51633 .63969 m .51452 .64133 L .5 .62969 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.75321 .42913 m
.74729 .40257 L
s
.77535 .37662 m
.74729 .40257 L
s
.74765 .32222 m
.72754 .29655 L
s
.7552 .26846 m
.72754 .29655 L
s
.24 .35 .67 r
.35538 .28037 m
.39622 .29645 L
s
.39622 .29645 m
.40551 .30085 L
s
.34 .095 .048 r
.35733 .5052 m .36694 .49384 L .36289 .47256 L p F P
0 0 0 r
s
.47 .135 .064 r
.36694 .49384 m .35733 .5052 L .3654 .52611 L p F P
0 0 0 r
s
.24 .35 .67 r
.20619 .56911 m
.20068 .55963 L
s
.15757 .54658 m
.20068 .55963 L
s
.198 .262 .481 r
.55759 .37413 m .57611 .38134 L .57998 .39661 L p F P
0 0 0 r
s
.198 .262 .481 r
.5992 .40402 m .57998 .39661 L .57611 .38134 L p F P
0 0 0 r
s
.282 .427 .841 r
.48747 .63962 m .49058 .64057 L .5 .62969 L closepath p F P
0 0 0 r
s
.083 .024 .01 r
.41079 .36827 m .40076 .38082 L .3957 .39608 L p F P
0 0 0 r
s
.83 .24 .1 r
.40045 .38138 m
.40066 .38112 L
s
.41049 .36882 m
.4196 .35742 L
s
.083 .024 .01 r
.38541 .40886 m .3957 .39608 L .40076 .38082 L p F P
0 0 0 r
s
.229 .31 .58 r
.5992 .40402 m .6182 .41134 L .62091 .42981 L p F P
0 0 0 r
s
.229 .31 .58 r
.6401 .43711 m .62091 .42981 L .6182 .41134 L p F P
0 0 0 r
s
1 .316 .133 r
.52181 .63474 m .52364 .63308 L .54638 .63299 L p F P
0 0 0 r
s
1 .316 .133 r
.55007 .62972 m .54638 .63299 L .52364 .63308 L p F P
0 0 0 r
s
.259 .4 .793 r
.46869 .6339 m .46554 .63294 L .43239 .63272 L p F P
0 0 0 r
s
.922 .273 .118 r
.43573 .62945 m .43239 .63272 L .46554 .63294 L p F P
0 0 0 r
s
1 .315 .13 r
.57861 .61987 m .58419 .61499 L .60845 .60398 L p F P
0 0 0 r
s
1 .315 .13 r
.61586 .59756 m .60845 .60398 L .58419 .61499 L p F P
0 0 0 r
s
.83 .24 .1 r
.59018 .61169 m
.59161 .61045 L
s
.59161 .61045 m
.59498 .60905 L
s
.60959 .60299 m
.61022 .60273 L
s
.944 .288 .117 r
.60845 .60398 m .61586 .59756 L .63868 .58263 L p F P
0 0 0 r
s
1 .304 .13 r
.51815 .63805 m .51633 .63969 L .5 .62969 L closepath p F P
0 0 0 r
s
.282 .427 .841 r
.48435 .63867 m .48747 .63962 L .5 .62969 L closepath p F P
0 0 0 r
s
.109 .123 .235 r
.45233 .31755 m .46859 .32396 L .46482 .32804 L p F P
0 0 0 r
s
.24 .35 .67 r
.45118 .31882 m
.45619 .32079 L
s
.46743 .32521 m
.47301 .32741 L
s
.109 .123 .235 r
.48287 .33512 m .46482 .32804 L .46859 .32396 L p F P
0 0 0 r
s
1 .322 .134 r
.55007 .62972 m .55378 .62643 L .57861 .61987 L p F P
0 0 0 r
s
1 .322 .134 r
.58419 .61499 m .57861 .61987 L .55378 .62643 L p F P
0 0 0 r
s
.738 .216 .096 r
.39149 .60345 m .39762 .59702 L .37745 .58198 L p F P
0 0 0 r
s
.805 .237 .104 r
.39762 .59702 m .39149 .60345 L .41578 .61459 L p F P
0 0 0 r
s
.805 .237 .104 r
.41096 .61947 m .41578 .61459 L .39149 .60345 L p F P
0 0 0 r
s
.83 .24 .1 r
.70522 .22359 m
.67849 .25262 L
s
.67849 .25262 m
.65123 .23589 L
s
.212 .061 .032 r
.36289 .47256 m .37294 .46042 L .3725 .43995 L p F P
0 0 0 r
s
.34 .095 .048 r
.37294 .46042 m .36289 .47256 L .36694 .49384 L p F P
0 0 0 r
s
.083 .024 .01 r
.63868 .58263 m .64782 .57475 L .66824 .55664 L p F P
0 0 0 r
s
.944 .288 .117 r
.64782 .57475 m .63868 .58263 L .61586 .59756 L p F P
0 0 0 r
s
.866 .256 .112 r
.41578 .61459 m .41096 .61947 L .43909 .62615 L p F P
0 0 0 r
s
.866 .256 .112 r
.43573 .62945 m .43909 .62615 L .41096 .61947 L p F P
0 0 0 r
s
.24 .35 .67 r
.42381 .62852 m
.42942 .63022 L
s
.282 .427 .841 r
.48123 .63772 m .48435 .63867 L .5 .62969 L closepath p F P
0 0 0 r
s
.263 .368 .699 r
.65853 .46471 m .67723 .4717 L .67199 .49302 L p F P
0 0 0 r
s
.263 .368 .699 r
.68996 .49961 m .67199 .49302 L .67723 .4717 L p F P
0 0 0 r
s
.143 .041 .02 r
.3957 .39608 m .38541 .40886 L .38279 .42731 L p F P
0 0 0 r
s
.143 .041 .02 r
.3725 .43995 m .38279 .42731 L .38541 .40886 L p F P
0 0 0 r
s
.83 .24 .1 r
.38403 .42808 m
.38531 .4212 L
s
.663 .193 .087 r
.37745 .58198 m .38473 .57409 L .3688 .55588 L p F P
0 0 0 r
s
.738 .216 .096 r
.38473 .57409 m .37745 .58198 L .39762 .59702 L p F P
0 0 0 r
s
.152 .189 .336 r
.50074 .34213 m .51842 .34907 L .51994 .35946 L p F P
0 0 0 r
s
.152 .189 .336 r
.53887 .36683 m .51994 .35946 L .51842 .34907 L p F P
0 0 0 r
s
.212 .061 .032 r
.38279 .42731 m .3725 .43995 L .37294 .46042 L p F P
0 0 0 r
s
1 .304 .13 r
.51998 .6364 m .51815 .63805 L .5 .62969 L closepath p F P
0 0 0 r
s
.282 .427 .841 r
.47811 .63677 m .48123 .63772 L .5 .62969 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.7638 .34922 m
.74765 .32222 L
s
.77582 .29455 m
.74765 .32222 L
s
.24 .35 .67 r
.26164 .25029 m
.30371 .26677 L
s
.30371 .26677 m
.31359 .26392 L
s
1 .316 .133 r
.52364 .63308 m .52548 .63142 L .55007 .62972 L p F P
0 0 0 r
s
.24 .35 .67 r
.54785 .63205 m
.58637 .64408 L
s
.53072 .64725 m
.54785 .63205 L
s
1 .316 .133 r
.55378 .62643 m .55007 .62972 L .52548 .63142 L p F P
0 0 0 r
s
.083 .024 .01 r
.67897 .54738 m .66824 .55664 L .64782 .57475 L p F P
0 0 0 r
s
.083 .024 .01 r
.66824 .55664 m .67897 .54738 L .69598 .52697 L p F P
0 0 0 r
s
.24 .35 .67 r
.6834 .54909 m
.72043 .56209 L
s
.922 .273 .118 r
.43909 .62615 m .43573 .62945 L .46729 .63128 L p F P
0 0 0 r
s
.922 .273 .118 r
.46554 .63294 m .46729 .63128 L .43573 .62945 L p F P
0 0 0 r
s
.24 .35 .67 r
.35469 .60763 m
.34217 .61062 L
s
.30054 .59811 m
.34217 .61062 L
s
.282 .427 .841 r
.47497 .63582 m .47811 .63677 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .304 .13 r
.52181 .63474 m .51998 .6364 L .5 .62969 L closepath p F P
0 0 0 r
s
.575 .166 .076 r
.3688 .55588 m .3771 .5466 L .3654 .52611 L p F P
0 0 0 r
s
.663 .193 .087 r
.3771 .5466 m .3688 .55588 L .38473 .57409 L p F P
0 0 0 r
s
.24 .35 .67 r
.65794 .60985 m
.67215 .58056 L
s
.274 .386 .737 r
.67199 .49302 m .68996 .49961 L .67916 .52093 L p F P
0 0 0 r
s
.274 .386 .737 r
.69598 .52697 m .67916 .52093 L .68996 .49961 L p F P
0 0 0 r
s
.282 .427 .841 r
.47184 .63486 m .47497 .63582 L .5 .62969 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.72012 .50091 m
.72582 .47866 L
s
.7536 .45411 m
.72582 .47866 L
s
.249 .344 .649 r
.62091 .42981 m .6401 .43711 L .63962 .45764 L p F P
0 0 0 r
s
.24 .35 .67 r
.61963 .43055 m
.62202 .43146 L
s
.64008 .43832 m
.6412 .43875 L
s
.249 .344 .649 r
.65853 .46471 m .63962 .45764 L .6401 .43711 L p F P
0 0 0 r
s
.083 .024 .01 r
.43673 .33323 m .42705 .34536 L .42101 .35547 L p F P
0 0 0 r
s
.083 .024 .01 r
.41079 .36827 m .42101 .35547 L .42705 .34536 L p F P
0 0 0 r
s
.198 .262 .481 r
.53887 .36683 m .55759 .37413 L .56054 .38912 L p F P
0 0 0 r
s
.198 .262 .481 r
.57998 .39661 m .56054 .38912 L .55759 .37413 L p F P
0 0 0 r
s
.282 .427 .841 r
.46869 .6339 m .47184 .63486 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .304 .13 r
.52364 .63308 m .52181 .63474 L .5 .62969 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.52087 .63268 m
.52376 .63297 L
s
.918 .277 .11 r
.43673 .33323 m .44658 .32088 L .45233 .31755 L p F P
0 0 0 r
s
.109 .123 .235 r
.46482 .32804 m .44658 .32088 L .45233 .31755 L p F P
0 0 0 r
s
.24 .35 .67 r
.44609 .31682 m
.45055 .31857 L
s
.83 .24 .1 r
.43498 .34175 m
.45048 .32241 L
s
.45384 .31821 m
.45652 .31487 L
s
.45373 .31834 m
.45384 .31821 L
s
1 .322 .134 r
.55378 .62643 m .55752 .62311 L .58419 .61499 L p F P
0 0 0 r
s
1 .322 .134 r
.58982 .61007 m .58419 .61499 L .55752 .62311 L p F P
0 0 0 r
s
.83 .24 .1 r
.58901 .61077 m
.59161 .61045 L
s
1 .315 .13 r
.58419 .61499 m .58982 .61007 L .61586 .59756 L p F P
0 0 0 r
s
.282 .401 .768 r
.67916 .52093 m .69598 .52697 L .67897 .54738 L p F P
0 0 0 r
s
.24 .35 .67 r
.6834 .54909 m
.68576 .53923 L
s
.83 .24 .1 r
.68321 .54033 m
.68538 .53686 L
s
.68154 .54301 m
.68321 .54033 L
s
.229 .31 .58 r
.57998 .39661 m .5992 .40402 L .60148 .42243 L p F P
0 0 0 r
s
.229 .31 .58 r
.62091 .42981 m .60148 .42243 L .5992 .40402 L p F P
0 0 0 r
s
.24 .35 .67 r
.61944 .42925 m
.61963 .43055 L
s
.805 .237 .104 r
.41578 .61459 m .42064 .60966 L .39762 .59702 L p F P
0 0 0 r
s
.866 .256 .112 r
.42064 .60966 m .41578 .61459 L .44247 .62284 L p F P
0 0 0 r
s
.866 .256 .112 r
.43909 .62615 m .44247 .62284 L .41578 .61459 L p F P
0 0 0 r
s
.83 .24 .1 r
.59592 .21618 m
.57123 .2455 L
s
.57123 .2455 m
.54544 .24394 L
s
.282 .427 .841 r
.46554 .63294 m .46869 .6339 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .316 .133 r
.52548 .63142 m .52733 .62975 L .55378 .62643 L p F P
0 0 0 r
s
1 .316 .133 r
.55752 .62311 m .55378 .62643 L .52733 .62975 L p F P
0 0 0 r
s
.47 .135 .064 r
.3654 .52611 m .37454 .51559 L .36694 .49384 L p F P
0 0 0 r
s
.575 .166 .076 r
.37454 .51559 m .3654 .52611 L .3771 .5466 L p F P
0 0 0 r
s
1 .315 .13 r
.62335 .59106 m .61586 .59756 L .58982 .61007 L p F P
0 0 0 r
s
.944 .288 .117 r
.61586 .59756 m .62335 .59106 L .64782 .57475 L p F P
0 0 0 r
s
.922 .273 .118 r
.44247 .62284 m .43909 .62615 L .46905 .62961 L p F P
0 0 0 r
s
.922 .273 .118 r
.46729 .63128 m .46905 .62961 L .43909 .62615 L p F P
0 0 0 r
s
.24 .35 .67 r
.44194 .62896 m
.44357 .62798 L
s
.83 .24 .1 r
.67756 .20636 m
.65123 .23589 L
s
.65123 .23589 m
.62337 .22356 L
s
.24 .35 .67 r
.40551 .30085 m
.44609 .31682 L
s
.44609 .31682 m
.44817 .31996 L
s
1 .304 .13 r
.52548 .63142 m .52364 .63308 L .5 .62969 L closepath p F P
0 0 0 r
s
.738 .216 .096 r
.39762 .59702 m .40382 .59052 L .38473 .57409 L p F P
0 0 0 r
s
.805 .237 .104 r
.40382 .59052 m .39762 .59702 L .42064 .60966 L p F P
0 0 0 r
s
.974 .29 .124 r
.5 .62969 m .46729 .63128 L .46554 .63294 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.25792 .5853 m
.24907 .582 L
s
.20619 .56911 m
.24907 .582 L
s
.152 .189 .336 r
.48287 .33512 m .50074 .34213 L .5008 .352 L p F P
0 0 0 r
s
.152 .189 .336 r
.51994 .35946 m .5008 .352 L .50074 .34213 L p F P
0 0 0 r
s
.263 .368 .699 r
.63962 .45764 m .65853 .46471 L .65381 .48636 L p F P
0 0 0 r
s
.263 .368 .699 r
.67199 .49302 m .65381 .48636 L .65853 .46471 L p F P
0 0 0 r
s
.83 .24 .1 r
.47893 .28689 m
.45652 .31487 L
s
.45154 .31991 m
.45652 .31487 L
s
1 .304 .13 r
.52733 .62975 m .52548 .63142 L .5 .62969 L closepath p F P
0 0 0 r
s
.083 .024 .01 r
.64782 .57475 m .65709 .56675 L .67897 .54738 L p F P
0 0 0 r
s
.944 .288 .117 r
.65709 .56675 m .64782 .57475 L .62335 .59106 L p F P
0 0 0 r
s
.83 .24 .1 r
.63504 .58264 m
.63841 .57972 L
s
.63841 .57972 m
.65546 .56557 L
s
.24 .35 .67 r
.67215 .58056 m
.6834 .54909 L
s
.974 .29 .124 r
.5 .62969 m .46905 .62961 L .46729 .63128 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.67884 .54749 m
.6834 .54909 L
s
.34 .095 .048 r
.36694 .49384 m .37673 .48227 L .37294 .46042 L p F P
0 0 0 r
s
.47 .135 .064 r
.37673 .48227 m .36694 .49384 L .37454 .51559 L p F P
0 0 0 r
s
.663 .193 .087 r
.38473 .57409 m .39213 .56608 L .3771 .5466 L p F P
0 0 0 r
s
.738 .216 .096 r
.39213 .56608 m .38473 .57409 L .40382 .59052 L p F P
0 0 0 r
s
1 .316 .133 r
.52733 .62975 m .52918 .62807 L .55752 .62311 L p F P
0 0 0 r
s
.24 .35 .67 r
.53584 .6283 m
.54785 .63205 L
s
1 .316 .133 r
.56128 .61978 m .55752 .62311 L .52918 .62807 L p F P
0 0 0 r
s
1 .322 .134 r
.55752 .62311 m .56128 .61978 L .58982 .61007 L p F P
0 0 0 r
s
.083 .024 .01 r
.42101 .35547 m .41079 .36827 L .4062 .38303 L p F P
0 0 0 r
s
.083 .024 .01 r
.3957 .39608 m .4062 .38303 L .41079 .36827 L p F P
0 0 0 r
s
.83 .24 .1 r
.40816 .37939 m
.40938 .37786 L
s
.40938 .37786 m
.41477 .36709 L
s
.866 .256 .112 r
.44247 .62284 m .44587 .6195 L .42064 .60966 L p F P
0 0 0 r
s
.24 .35 .67 r
.396 .62012 m
.42381 .62852 L
s
.922 .273 .118 r
.44587 .6195 m .44247 .62284 L .47081 .62793 L p F P
0 0 0 r
s
.922 .273 .118 r
.46905 .62961 m .47081 .62793 L .44247 .62284 L p F P
0 0 0 r
s
.83 .24 .1 r
.77535 .37662 m
.7638 .34922 L
s
.7925 .32191 m
.7638 .34922 L
s
.274 .386 .737 r
.65381 .48636 m .67199 .49302 L .66216 .51483 L p F P
0 0 0 r
s
.274 .386 .737 r
.67916 .52093 m .66216 .51483 L .67199 .49302 L p F P
0 0 0 r
s
1 .304 .13 r
.52918 .62807 m .52733 .62975 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .322 .134 r
.5955 .6051 m .58982 .61007 L .56128 .61978 L p F P
0 0 0 r
s
1 .315 .13 r
.58982 .61007 m .5955 .6051 L .62335 .59106 L p F P
0 0 0 r
s
.974 .29 .124 r
.5 .62969 m .47081 .62793 L .46905 .62961 L closepath p F P
0 0 0 r
s
.249 .344 .649 r
.60148 .42243 m .62091 .42981 L .62048 .45048 L p F P
0 0 0 r
s
.249 .344 .649 r
.63962 .45764 m .62048 .45048 L .62091 .42981 L p F P
0 0 0 r
s
.24 .35 .67 r
.396 .62012 m
.41086 .61054 L
s
.35469 .60763 m
.396 .62012 L
s
.805 .237 .104 r
.42064 .60966 m .42555 .60469 L .40382 .59052 L p F P
0 0 0 r
s
.866 .256 .112 r
.42555 .60469 m .42064 .60966 L .44587 .6195 L p F P
0 0 0 r
s
.198 .262 .481 r
.51994 .35946 m .53887 .36683 L .54087 .38154 L p F P
0 0 0 r
s
.198 .262 .481 r
.56054 .38912 m .54087 .38154 L .53887 .36683 L p F P
0 0 0 r
s
.24 .35 .67 r
.31359 .26392 m
.35538 .28037 L
s
.35538 .28037 m
.36398 .28451 L
s
.83 .24 .1 r
.75321 .42913 m
.78173 .40341 L
s
.7536 .45411 m
.75321 .42913 L
s
.282 .401 .768 r
.66216 .51483 m .67916 .52093 L .66353 .54196 L p F P
0 0 0 r
s
.282 .401 .768 r
.67897 .54738 m .66353 .54196 L .67916 .52093 L p F P
0 0 0 r
s
.83 .24 .1 r
.65546 .56557 m
.67721 .54676 L
s
.24 .35 .67 r
.1623 .55592 m
.15757 .54658 L
s
.212 .061 .032 r
.37294 .46042 m .3832 .44803 L .38279 .42731 L p F P
0 0 0 r
s
.83 .24 .1 r
.38283 .42955 m
.38403 .42808 L
s
.34 .095 .048 r
.3832 .44803 m .37294 .46042 L .37673 .48227 L p F P
0 0 0 r
s
.288 .412 .793 r
.66353 .54196 m .67897 .54738 L .65709 .56675 L p F P
0 0 0 r
s
.83 .24 .1 r
.6783 .54582 m
.68154 .54301 L
s
.67817 .54593 m
.6783 .54582 L
s
.229 .31 .58 r
.56054 .38912 m .57998 .39661 L .58183 .41496 L p F P
0 0 0 r
s
.229 .31 .58 r
.60148 .42243 m .58183 .41496 L .57998 .39661 L p F P
0 0 0 r
s
1 .304 .13 r
.53104 .62639 m .52918 .62807 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .316 .133 r
.52918 .62807 m .53104 .62639 L .56128 .61978 L p F P
0 0 0 r
s
.24 .35 .67 r
.53215 .62715 m
.53584 .6283 L
s
.922 .273 .118 r
.47081 .62793 m .47258 .62625 L .44587 .6195 L p F P
0 0 0 r
s
.974 .29 .124 r
.5 .62969 m .47258 .62625 L .47081 .62793 L closepath p F P
0 0 0 r
s
.143 .041 .02 r
.4062 .38303 m .3957 .39608 L .39329 .41442 L p F P
0 0 0 r
s
.143 .041 .02 r
.38279 .42731 m .39329 .41442 L .3957 .39608 L p F P
0 0 0 r
s
.575 .166 .076 r
.3771 .5466 m .38552 .53717 L .37454 .51559 L p F P
0 0 0 r
s
.663 .193 .087 r
.38552 .53717 m .3771 .5466 L .39213 .56608 L p F P
0 0 0 r
s
.212 .061 .032 r
.39329 .41442 m .38279 .42731 L .3832 .44803 L p F P
0 0 0 r
s
1 .315 .13 r
.63094 .58449 m .62335 .59106 L .5955 .6051 L p F P
0 0 0 r
s
.944 .288 .117 r
.62335 .59106 m .63094 .58449 L .65709 .56675 L p F P
0 0 0 r
s
.24 .35 .67 r
.64874 .5726 m
.64996 .57302 L
s
.64996 .57302 m
.67215 .58056 L
s
.152 .189 .336 r
.46482 .32804 m .48287 .33512 L .48144 .34446 L p F P
0 0 0 r
s
.152 .189 .336 r
.5008 .352 m .48144 .34446 L .48287 .33512 L p F P
0 0 0 r
s
1 .316 .133 r
.56506 .61643 m .56128 .61978 L .53104 .62639 L p F P
0 0 0 r
s
1 .322 .134 r
.56128 .61978 m .56506 .61643 L .5955 .6051 L p F P
0 0 0 r
s
.974 .29 .124 r
.5 .62969 m .49056 .60913 L .48874 .61087 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.49887 .62722 m
.5051 .62915 L
s
.24 .35 .67 r
.49799 .62944 m
.49918 .62833 L
s
.974 .29 .124 r
.5 .62969 m .48874 .61087 L .48692 .6126 L closepath p F P
0 0 0 r
s
.974 .29 .124 r
.5 .62969 m .48692 .6126 L .4851 .61433 L closepath p F P
0 0 0 r
s
.293 .437 .856 r
.5 .62969 m .49056 .60913 L .49376 .61014 L closepath p F P
0 0 0 r
s
.293 .437 .856 r
.5 .62969 m .49376 .61014 L .49695 .61114 L closepath p F P
0 0 0 r
s
.293 .437 .856 r
.5 .62969 m .49695 .61114 L .50013 .61214 L closepath p F P
0 0 0 r
s
.293 .437 .856 r
.5 .62969 m .50013 .61214 L .50331 .61313 L closepath p F P
0 0 0 r
s
.293 .437 .856 r
.5 .62969 m .50331 .61313 L .50648 .61413 L closepath p F P
0 0 0 r
s
.293 .437 .856 r
.5 .62969 m .50648 .61413 L .50965 .61512 L closepath p F P
0 0 0 r
s
.974 .29 .124 r
.5 .62969 m .4851 .61433 L .4833 .61604 L closepath p F P
0 0 0 r
s
.974 .29 .124 r
.5 .62969 m .4833 .61604 L .4815 .61776 L closepath p F P
0 0 0 r
s
.974 .29 .124 r
.5 .62969 m .4815 .61776 L .4797 .61947 L closepath p F P
0 0 0 r
s
.974 .29 .124 r
.5 .62969 m .4797 .61947 L .47791 .62117 L closepath p F P
0 0 0 r
s
.974 .29 .124 r
.5 .62969 m .47791 .62117 L .47613 .62287 L closepath p F P
0 0 0 r
s
.974 .29 .124 r
.5 .62969 m .47613 .62287 L .47435 .62456 L closepath p F P
0 0 0 r
s
.974 .29 .124 r
.5 .62969 m .47435 .62456 L .47258 .62625 L closepath p F P
0 0 0 r
s
1 .304 .13 r
.53291 .6247 m .53104 .62639 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .304 .13 r
.53478 .62301 m .53291 .6247 L .5 .62969 L closepath p F P
0 0 0 r
s
.293 .437 .856 r
.5 .62969 m .50965 .61512 L .51281 .61612 L closepath p F P
0 0 0 r
s
.293 .437 .856 r
.5 .62969 m .51281 .61612 L .51597 .61711 L closepath p F P
0 0 0 r
s
.293 .437 .856 r
.5 .62969 m .51597 .61711 L .51912 .61809 L closepath p F P
0 0 0 r
s
.293 .437 .856 r
.5 .62969 m .51912 .61809 L .52226 .61908 L closepath p F P
0 0 0 r
s
.293 .437 .856 r
.5 .62969 m .52226 .61908 L .5254 .62007 L closepath p F P
0 0 0 r
s
.293 .437 .856 r
.5 .62969 m .5254 .62007 L .52853 .62105 L closepath p F P
0 0 0 r
s
.293 .437 .856 r
.5 .62969 m .52853 .62105 L .53166 .62203 L closepath p F P
0 0 0 r
s
.293 .437 .856 r
.5 .62969 m .53166 .62203 L .53478 .62301 L closepath p F P
0 0 0 r
s
.866 .256 .112 r
.44587 .6195 m .44929 .61615 L .42555 .60469 L p F P
0 0 0 r
s
.922 .273 .118 r
.44929 .61615 m .44587 .6195 L .47258 .62625 L p F P
0 0 0 r
s
.738 .216 .096 r
.40382 .59052 m .4101 .58394 L .39213 .56608 L p F P
0 0 0 r
s
.805 .237 .104 r
.4101 .58394 m .40382 .59052 L .42555 .60469 L p F P
0 0 0 r
s
.83 .24 .1 r
.52209 .248 m
.49871 .27689 L
s
.49871 .27689 m
.47893 .28689 L
s
1 .316 .133 r
.53104 .62639 m .53291 .6247 L .56506 .61643 L p F P
0 0 0 r
s
.24 .35 .67 r
.55681 .62092 m
.55862 .61867 L
s
.54785 .63205 m
.55681 .62092 L
s
.922 .273 .118 r
.47258 .62625 m .47435 .62456 L .44929 .61615 L p F P
0 0 0 r
s
.263 .368 .699 r
.62048 .45048 m .63962 .45764 L .63544 .47962 L p F P
0 0 0 r
s
.263 .368 .699 r
.65381 .48636 m .63544 .47962 L .63962 .45764 L p F P
0 0 0 r
s
.083 .024 .01 r
.44658 .32088 m .43673 .33323 L .43143 .34243 L p F P
0 0 0 r
s
.083 .024 .01 r
.42101 .35547 m .43143 .34243 L .43673 .33323 L p F P
0 0 0 r
s
.83 .24 .1 r
.66455 .55711 m
.68154 .54301 L
s
.70869 .51954 m
.68154 .54301 L
s
.24 .35 .67 r
.26164 .25029 m
.27081 .24707 L
s
1 .322 .134 r
.60124 .60008 m .5955 .6051 L .56506 .61643 L p F P
0 0 0 r
s
.24 .35 .67 r
.57718 .61474 m
.6037 .62323 L
s
1 .315 .13 r
.5955 .6051 m .60124 .60008 L .63094 .58449 L p F P
0 0 0 r
s
.24 .35 .67 r
.6037 .62323 m
.61993 .59732 L
s
.61993 .59732 m
.65794 .60985 L
s
1 .316 .133 r
.53291 .6247 m .53478 .62301 L .56886 .61305 L p F P
0 0 0 r
s
1 .316 .133 r
.56886 .61305 m .56506 .61643 L .53291 .6247 L p F P
0 0 0 r
s
.83 .24 .1 r
.56857 .61331 m
.57324 .61273 L
s
.24 .35 .67 r
.31242 .59485 m
.30054 .59811 L
s
.25792 .5853 m
.30054 .59811 L
s
.922 .273 .118 r
.45273 .61277 m .44929 .61615 L .47435 .62456 L p F P
0 0 0 r
s
.24 .35 .67 r
.44357 .62798 m
.45174 .62306 L
s
.922 .273 .118 r
.47435 .62456 m .47613 .62287 L .45273 .61277 L p F P
0 0 0 r
s
.24 .35 .67 r
.45174 .62306 m
.46787 .628 L
s
.805 .237 .104 r
.42555 .60469 m .4305 .59967 L .4101 .58394 L p F P
0 0 0 r
s
.866 .256 .112 r
.4305 .59967 m .42555 .60469 L .44929 .61615 L p F P
0 0 0 r
s
.83 .24 .1 r
.64936 .19352 m
.62337 .22356 L
s
.62337 .22356 m
.59592 .21618 L
s
.274 .386 .737 r
.63544 .47962 m .65381 .48636 L .64498 .50866 L p F P
0 0 0 r
s
.274 .386 .737 r
.66216 .51483 m .64498 .50866 L .65381 .48636 L p F P
0 0 0 r
s
.47 .135 .064 r
.37454 .51559 m .38384 .50488 L .37673 .48227 L p F P
0 0 0 r
s
.575 .166 .076 r
.38384 .50488 m .37454 .51559 L .38552 .53717 L p F P
0 0 0 r
s
.83 .24 .1 r
.38535 .53388 m
.38675 .53678 L
s
1 .322 .134 r
.56506 .61643 m .56886 .61305 L .60124 .60008 L p F P
0 0 0 r
s
.24 .35 .67 r
.57173 .613 m
.57718 .61474 L
s
.61993 .59732 m
.62336 .59015 L
s
.62336 .59015 m
.62398 .58885 L
s
.61219 .59477 m
.61993 .59732 L
s
.288 .412 .793 r
.65709 .56675 m .64346 .56207 L .66353 .54196 L p F P
0 0 0 r
s
.292 .422 .814 r
.64346 .56207 m .65709 .56675 L .63094 .58449 L p F P
0 0 0 r
s
.83 .24 .1 r
.64826 .5712 m
.64909 .57048 L
s
.866 .256 .112 r
.44929 .61615 m .45273 .61277 L .4305 .59967 L p F P
0 0 0 r
s
.282 .401 .768 r
.64498 .50866 m .66216 .51483 L .64795 .53649 L p F P
0 0 0 r
s
.282 .401 .768 r
.66353 .54196 m .64795 .53649 L .66216 .51483 L p F P
0 0 0 r
s
.249 .344 .649 r
.58183 .41496 m .60148 .42243 L .60113 .44324 L p F P
0 0 0 r
s
.24 .35 .67 r
.58096 .41587 m
.58298 .41663 L
s
.60146 .42366 m
.60261 .42409 L
s
.249 .344 .649 r
.62048 .45048 m .60113 .44324 L .60148 .42243 L p F P
0 0 0 r
s
.288 .412 .793 r
.64795 .53649 m .66353 .54196 L .64346 .56207 L p F P
0 0 0 r
s
.83 .24 .1 r
.64909 .57048 m
.66455 .55711 L
s
.198 .262 .481 r
.5008 .352 m .51994 .35946 L .52097 .37387 L p F P
0 0 0 r
s
.198 .262 .481 r
.54087 .38154 m .52097 .37387 L .51994 .35946 L p F P
0 0 0 r
s
.663 .193 .087 r
.39213 .56608 m .39963 .55795 L .38552 .53717 L p F P
0 0 0 r
s
.83 .24 .1 r
.3859 .53773 m
.38675 .53678 L
s
.738 .216 .096 r
.39963 .55795 m .39213 .56608 L .4101 .58394 L p F P
0 0 0 r
s
.297 .439 .855 r
.56274 .61109 m .56886 .61305 L .53478 .62301 L p F P
0 0 0 r
s
.297 .439 .855 r
.53478 .62301 m .53166 .62203 L .56274 .61109 L p F P
0 0 0 r
s
.922 .273 .118 r
.45619 .60937 m .45273 .61277 L .47613 .62287 L p F P
0 0 0 r
s
.922 .273 .118 r
.47613 .62287 m .47791 .62117 L .45619 .60937 L p F P
0 0 0 r
s
.24 .35 .67 r
.6455 .5358 m
.64715 .52905 L
s
.229 .31 .58 r
.54087 .38154 m .56054 .38912 L .56195 .4074 L p F P
0 0 0 r
s
.229 .31 .58 r
.58183 .41496 m .56195 .4074 L .56054 .38912 L p F P
0 0 0 r
s
.24 .35 .67 r
.5808 .41456 m
.58096 .41587 L
s
.297 .439 .855 r
.55659 .60912 m .56274 .61109 L .53166 .62203 L p F P
0 0 0 r
s
.297 .439 .855 r
.53166 .62203 m .52853 .62105 L .55659 .60912 L p F P
0 0 0 r
s
.152 .189 .336 r
.44658 .32088 m .46482 .32804 L .46186 .33684 L p F P
0 0 0 r
s
.152 .189 .336 r
.48144 .34446 m .46186 .33684 L .46482 .32804 L p F P
0 0 0 r
s
.922 .273 .118 r
.45968 .60595 m .45619 .60937 L .47791 .62117 L p F P
0 0 0 r
s
.83 .24 .1 r
.45666 .6082 m
.45714 .60844 L
s
.922 .273 .118 r
.47791 .62117 m .4797 .61947 L .45968 .60595 L p F P
0 0 0 r
s
.297 .439 .855 r
.55043 .60715 m .55659 .60912 L .52853 .62105 L p F P
0 0 0 r
s
.297 .439 .855 r
.52853 .62105 m .5254 .62007 L .55043 .60715 L p F P
0 0 0 r
s
.292 .422 .814 r
.63094 .58449 m .61949 .58066 L .64346 .56207 L p F P
0 0 0 r
s
.24 .35 .67 r
.62443 .58791 m
.62674 .58309 L
s
.296 .43 .832 r
.61949 .58066 m .63094 .58449 L .60124 .60008 L p F P
0 0 0 r
s
.83 .24 .1 r
.62198 .58642 m
.62294 .58603 L
s
.24 .35 .67 r
.36398 .28451 m
.40551 .30085 L
s
.40551 .30085 m
.41233 .312 L
s
.83 .24 .1 r
.7552 .26846 m
.73139 .24454 L
s
.73139 .24454 m
.70522 .22359 L
s
.34 .095 .048 r
.37673 .48227 m .38672 .47047 L .3832 .44803 L p F P
0 0 0 r
s
.47 .135 .064 r
.38672 .47047 m .37673 .48227 L .38384 .50488 L p F P
0 0 0 r
s
.297 .436 .846 r
.59231 .59717 m .60124 .60008 L .56886 .61305 L p F P
0 0 0 r
s
.297 .436 .846 r
.56886 .61305 m .56274 .61109 L .59231 .59717 L p F P
0 0 0 r
s
.24 .35 .67 r
.2143 .5722 m
.20619 .56911 L
s
.1623 .55592 m
.20619 .56911 L
s
.738 .216 .096 r
.4101 .58394 m .41645 .57729 L .39963 .55795 L p F P
0 0 0 r
s
.83 .24 .1 r
.40536 .56455 m
.40597 .56389 L
s
.805 .237 .104 r
.41645 .57729 m .4101 .58394 L .4305 .59967 L p F P
0 0 0 r
s
.83 .24 .1 r
.56992 .2142 m
.54544 .24394 L
s
.54544 .24394 m
.52209 .248 L
s
.866 .256 .112 r
.4355 .5946 m .4305 .59967 L .45273 .61277 L p F P
0 0 0 r
s
.866 .256 .112 r
.45273 .61277 m .45619 .60937 L .4355 .5946 L p F P
0 0 0 r
s
.24 .35 .67 r
.41086 .61054 m
.45174 .62306 L
s
.83 .24 .1 r
.45577 .60907 m
.45666 .6082 L
s
.70869 .51954 m
.72012 .50091 L
s
.7482 .47645 m
.72012 .50091 L
s
.78173 .40341 m
.77535 .37662 L
s
.80456 .3496 m
.77535 .37662 L
s
.297 .439 .855 r
.54424 .60517 m .55043 .60715 L .5254 .62007 L p F P
0 0 0 r
s
.297 .439 .855 r
.5254 .62007 m .52226 .61908 L .54424 .60517 L p F P
0 0 0 r
s
.263 .368 .699 r
.60113 .44324 m .62048 .45048 L .61686 .4728 L p F P
0 0 0 r
s
.263 .368 .699 r
.63544 .47962 m .61686 .4728 L .62048 .45048 L p F P
0 0 0 r
s
.83 .24 .1 r
.77582 .29455 m
.7552 .26846 L
s
.083 .024 .01 r
.43143 .34243 m .42101 .35547 L .41691 .36972 L p F P
0 0 0 r
s
.83 .24 .1 r
.42072 .35602 m
.42093 .35575 L
s
.083 .024 .01 r
.4062 .38303 m .41691 .36972 L .42101 .35547 L p F P
0 0 0 r
s
.296 .43 .832 r
.60124 .60008 m .59231 .59717 L .61949 .58066 L p F P
0 0 0 r
s
.922 .273 .118 r
.46319 .60251 m .45968 .60595 L .4797 .61947 L p F P
0 0 0 r
s
.922 .273 .118 r
.4797 .61947 m .4815 .61776 L .46319 .60251 L p F P
0 0 0 r
s
.805 .237 .104 r
.4305 .59967 m .4355 .5946 L .41645 .57729 L p F P
0 0 0 r
s
.83 .24 .1 r
.42908 .58877 m
.4297 .58813 L
s
.288 .412 .793 r
.64346 .56207 m .62971 .55736 L .64795 .53649 L p F P
0 0 0 r
s
.24 .35 .67 r
.6455 .5358 m
.64784 .53662 L
s
.292 .422 .814 r
.62971 .55736 m .64346 .56207 L .61949 .58066 L p F P
0 0 0 r
s
.24 .35 .67 r
.64339 .5417 m
.6455 .5358 L
s
.297 .439 .855 r
.53802 .60318 m .54424 .60517 L .52226 .61908 L p F P
0 0 0 r
s
.297 .439 .855 r
.52226 .61908 m .51912 .61809 L .53802 .60318 L p F P
0 0 0 r
s
.575 .166 .076 r
.38552 .53717 m .39409 .52759 L .38384 .50488 L p F P
0 0 0 r
s
.663 .193 .087 r
.39409 .52759 m .38552 .53717 L .39963 .55795 L p F P
0 0 0 r
s
.83 .24 .1 r
.39889 .5539 m
.40597 .56389 L
s
.297 .436 .846 r
.58334 .59423 m .59231 .59717 L .56274 .61109 L p F P
0 0 0 r
s
.297 .436 .846 r
.56274 .61109 m .55659 .60912 L .58334 .59423 L p F P
0 0 0 r
s
.83 .24 .1 r
.57038 .60984 m
.57183 .60855 L
s
.274 .386 .737 r
.61686 .4728 m .63544 .47962 L .62762 .50243 L p F P
0 0 0 r
s
.274 .386 .737 r
.64498 .50866 m .62762 .50243 L .63544 .47962 L p F P
0 0 0 r
s
.282 .401 .768 r
.64795 .53649 m .63221 .53097 L .64498 .50866 L p F P
0 0 0 r
s
.288 .412 .793 r
.63221 .53097 m .64795 .53649 L .62971 .55736 L p F P
0 0 0 r
s
.297 .439 .855 r
.53179 .60119 m .53802 .60318 L .51912 .61809 L p F P
0 0 0 r
s
.83 .24 .1 r
.53802 .61054 m
.55589 .61249 L
s
.297 .439 .855 r
.51912 .61809 m .51597 .61711 L .53179 .60119 L p F P
0 0 0 r
s
.83 .24 .1 r
.52845 .61927 m
.53068 .61724 L
s
.212 .061 .032 r
.3832 .44803 m .39367 .43539 L .39329 .41442 L p F P
0 0 0 r
s
.34 .095 .048 r
.39367 .43539 m .3832 .44803 L .38672 .47047 L p F P
0 0 0 r
s
.83 .24 .1 r
.70522 .22359 m
.67756 .20636 L
s
.282 .401 .768 r
.62762 .50243 m .64498 .50866 L .63221 .53097 L p F P
0 0 0 r
s
.922 .273 .118 r
.46672 .59904 m .46319 .60251 L .4815 .61776 L p F P
0 0 0 r
s
.922 .273 .118 r
.4815 .61776 m .4833 .61604 L .46672 .59904 L p F P
0 0 0 r
s
.198 .262 .481 r
.48144 .34446 m .5008 .352 L .50084 .36611 L p F P
0 0 0 r
s
.198 .262 .481 r
.52097 .37387 m .50084 .36611 L .5008 .352 L p F P
0 0 0 r
s
.292 .422 .814 r
.61949 .58066 m .60796 .57681 L .62971 .55736 L p F P
0 0 0 r
s
.296 .43 .832 r
.60796 .57681 m .61949 .58066 L .59231 .59717 L p F P
0 0 0 r
s
.83 .24 .1 r
.61664 .58859 m
.62198 .58642 L
s
.61153 .59306 m
.61664 .58859 L
s
.297 .439 .855 r
.52553 .59919 m .53179 .60119 L .51597 .61711 L p F P
0 0 0 r
s
.83 .24 .1 r
.53068 .61724 m
.53802 .61054 L
s
.297 .439 .855 r
.51597 .61711 m .51281 .61612 L .52553 .59919 L p F P
0 0 0 r
s
.143 .041 .02 r
.41691 .36972 m .4062 .38303 L .404 .40125 L p F P
0 0 0 r
s
.143 .041 .02 r
.39329 .41442 m .404 .40125 L .4062 .38303 L p F P
0 0 0 r
s
.83 .24 .1 r
.40504 .40232 m
.40617 .39595 L
s
.24 .35 .67 r
.36902 .59772 m
.35469 .60763 L
s
.31242 .59485 m
.35469 .60763 L
s
.249 .344 .649 r
.56195 .4074 m .58183 .41496 L .58154 .43592 L p F P
0 0 0 r
s
.249 .344 .649 r
.60113 .44324 m .58154 .43592 L .58183 .41496 L p F P
0 0 0 r
s
.296 .43 .832 r
.59231 .59717 m .58334 .59423 L .60796 .57681 L p F P
0 0 0 r
s
.866 .256 .112 r
.44054 .58949 m .4355 .5946 L .45619 .60937 L p F P
0 0 0 r
s
.83 .24 .1 r
.4297 .58813 m
.43672 .59336 L
s
.4533 .6057 m
.45666 .6082 L
s
.866 .256 .112 r
.45619 .60937 m .45968 .60595 L .44054 .58949 L p F P
0 0 0 r
s
.24 .35 .67 r
.27081 .24707 m
.31359 .26392 L
s
.31359 .26392 m
.32146 .26777 L
s
.297 .436 .846 r
.57432 .59129 m .58334 .59423 L .55659 .60912 L p F P
0 0 0 r
s
.297 .436 .846 r
.55659 .60912 m .55043 .60715 L .57432 .59129 L p F P
0 0 0 r
s
.83 .24 .1 r
.57183 .60855 m
.57382 .60678 L
s
.212 .061 .032 r
.404 .40125 m .39329 .41442 L .39367 .43539 L p F P
0 0 0 r
s
.297 .439 .855 r
.51925 .59718 m .52553 .59919 L .51281 .61612 L p F P
0 0 0 r
s
.24 .35 .67 r
.51156 .61572 m
.51402 .61257 L
s
.52464 .5989 m
.52525 .59811 L
s
.297 .439 .855 r
.51281 .61612 m .50965 .61512 L .51925 .59718 L p F P
0 0 0 r
s
.083 .024 .01 r
.43143 .34243 m .44206 .32912 L .44658 .32088 L p F P
0 0 0 r
s
.83 .24 .1 r
.43115 .34297 m
.44116 .33044 L
s
.152 .189 .336 r
.46186 .33684 m .44206 .32912 L .44658 .32088 L p F P
0 0 0 r
s
.83 .24 .1 r
.44116 .33044 m
.44235 .32923 L
s
.922 .273 .118 r
.47027 .59555 m .46672 .59904 L .4833 .61604 L p F P
0 0 0 r
s
.24 .35 .67 r
.45174 .62306 m
.4681 .60714 L
s
.922 .273 .118 r
.4833 .61604 m .4851 .61433 L .47027 .59555 L p F P
0 0 0 r
s
.83 .24 .1 r
.7925 .32191 m
.77582 .29455 L
s
.229 .31 .58 r
.52097 .37387 m .54087 .38154 L .54183 .39975 L p F P
0 0 0 r
s
.229 .31 .58 r
.56195 .4074 m .54183 .39975 L .54087 .38154 L p F P
0 0 0 r
s
.663 .193 .087 r
.39963 .55795 m .40724 .54971 L .39409 .52759 L p F P
0 0 0 r
s
.738 .216 .096 r
.40724 .54971 m .39963 .55795 L .41645 .57729 L p F P
0 0 0 r
s
.83 .24 .1 r
.41508 .5732 m
.4297 .58813 L
s
.44613 .32421 m
.46361 .30235 L
s
.44116 .33044 m
.44217 .32917 L
s
.297 .439 .855 r
.51294 .59516 m .51925 .59718 L .50965 .61512 L p F P
0 0 0 r
s
.297 .439 .855 r
.50965 .61512 m .50648 .61413 L .51294 .59516 L p F P
0 0 0 r
s
.288 .412 .793 r
.62971 .55736 m .61585 .55261 L .63221 .53097 L p F P
0 0 0 r
s
.292 .422 .814 r
.61585 .55261 m .62971 .55736 L .60796 .57681 L p F P
0 0 0 r
s
.83 .24 .1 r
.61664 .58859 m
.64271 .56583 L
s
.297 .436 .846 r
.56526 .58832 m .57432 .59129 L .55043 .60715 L p F P
0 0 0 r
s
.297 .436 .846 r
.55043 .60715 m .54424 .60517 L .56526 .58832 L p F P
0 0 0 r
s
.83 .24 .1 r
.7482 .47645 m
.7536 .45411 L
s
.78252 .42855 m
.7536 .45411 L
s
.805 .237 .104 r
.42288 .57055 m .41645 .57729 L .4355 .5946 L p F P
0 0 0 r
s
.805 .237 .104 r
.4355 .5946 m .44054 .58949 L .42288 .57055 L p F P
0 0 0 r
s
.47 .135 .064 r
.38384 .50488 m .39331 .49397 L .38672 .47047 L p F P
0 0 0 r
s
.575 .166 .076 r
.39331 .49397 m .38384 .50488 L .39409 .52759 L p F P
0 0 0 r
s
.922 .273 .118 r
.47385 .59205 m .47027 .59555 L .4851 .61433 L p F P
0 0 0 r
s
.922 .273 .118 r
.4851 .61433 m .48692 .6126 L .47385 .59205 L p F P
0 0 0 r
s
.297 .439 .855 r
.50662 .59313 m .51294 .59516 L .50648 .61413 L p F P
0 0 0 r
s
.297 .439 .855 r
.50648 .61413 m .50331 .61313 L .50662 .59313 L p F P
0 0 0 r
s
.296 .43 .832 r
.59636 .57292 m .60796 .57681 L .58334 .59423 L p F P
0 0 0 r
s
.296 .43 .832 r
.58334 .59423 m .57432 .59129 L .59636 .57292 L p F P
0 0 0 r
s
.24 .35 .67 r
.58103 .5845 m
.58206 .58484 L
s
.83 .24 .1 r
.57382 .60678 m
.59099 .59153 L
s
.24 .35 .67 r
.57953 .58695 m
.58103 .5845 L
s
.738 .216 .096 r
.41645 .57729 m .42288 .57055 L .40724 .54971 L p F P
0 0 0 r
s
.263 .368 .699 r
.58154 .43592 m .60113 .44324 L .59807 .46591 L p F P
0 0 0 r
s
.263 .368 .699 r
.61686 .4728 m .59807 .46591 L .60113 .44324 L p F P
0 0 0 r
s
.24 .35 .67 r
.41233 .312 m
.44438 .32454 L
s
.292 .422 .814 r
.60796 .57681 m .59636 .57292 L .61585 .55261 L p F P
0 0 0 r
s
.866 .256 .112 r
.44563 .58433 m .44054 .58949 L .45968 .60595 L p F P
0 0 0 r
s
.866 .256 .112 r
.45968 .60595 m .46319 .60251 L .44563 .58433 L p F P
0 0 0 r
s
.297 .439 .855 r
.50026 .5911 m .50662 .59313 L .50331 .61313 L p F P
0 0 0 r
s
.297 .439 .855 r
.50331 .61313 m .50013 .61214 L .50026 .5911 L p F P
0 0 0 r
s
.83 .24 .1 r
.50138 .608 m
.5086 .60119 L
s
.282 .401 .768 r
.63221 .53097 m .61633 .5254 L .62762 .50243 L p F P
0 0 0 r
s
.288 .412 .793 r
.61633 .5254 m .63221 .53097 L .61585 .55261 L p F P
0 0 0 r
s
.297 .436 .846 r
.55614 .58534 m .56526 .58832 L .54424 .60517 L p F P
0 0 0 r
s
.297 .436 .846 r
.54424 .60517 m .53802 .60318 L .55614 .58534 L p F P
0 0 0 r
s
.922 .273 .118 r
.47745 .58851 m .47385 .59205 L .48692 .6126 L p F P
0 0 0 r
s
.922 .273 .118 r
.48692 .6126 m .48874 .61087 L .47745 .58851 L p F P
0 0 0 r
s
.24 .35 .67 r
.4806 .61104 m
.4844 .61223 L
s
.83 .24 .1 r
.62163 .18565 m
.59592 .21618 L
s
.59592 .21618 m
.56992 .2142 L
s
.274 .386 .737 r
.59807 .46591 m .61686 .4728 L .61008 .49613 L p F P
0 0 0 r
s
.274 .386 .737 r
.62762 .50243 m .61008 .49613 L .61686 .4728 L p F P
0 0 0 r
s
.297 .439 .855 r
.49389 .58906 m .50026 .5911 L .50013 .61214 L p F P
0 0 0 r
s
.297 .439 .855 r
.50013 .61214 m .49695 .61114 L .49389 .58906 L p F P
0 0 0 r
s
.83 .24 .1 r
.49919 .61007 m
.50138 .608 L
s
.282 .401 .768 r
.61008 .49613 m .62762 .50243 L .61633 .5254 L p F P
0 0 0 r
s
.24 .35 .67 r
.26913 .58176 m
.25792 .5853 L
s
.2143 .5722 m
.25792 .5853 L
s
.83 .24 .1 r
.67756 .20636 m
.64936 .19352 L
s
.198 .262 .481 r
.46186 .33684 m .48144 .34446 L .48047 .35825 L p F P
0 0 0 r
s
.198 .262 .481 r
.50084 .36611 m .48047 .35825 L .48144 .34446 L p F P
0 0 0 r
s
.24 .35 .67 r
.41086 .61054 m
.42681 .59424 L
s
.36902 .59772 m
.41086 .61054 L
s
.296 .43 .832 r
.58467 .56901 m .59636 .57292 L .57432 .59129 L p F P
0 0 0 r
s
.83 .24 .1 r
.59099 .59153 m
.61664 .58859 L
s
.296 .43 .832 r
.57432 .59129 m .56526 .58832 L .58467 .56901 L p F P
0 0 0 r
s
.297 .439 .855 r
.48749 .58701 m .49389 .58906 L .49695 .61114 L p F P
0 0 0 r
s
.297 .439 .855 r
.49695 .61114 m .49376 .61014 L .48749 .58701 L p F P
0 0 0 r
s
.922 .273 .118 r
.48107 .58496 m .47745 .58851 L .48874 .61087 L p F P
0 0 0 r
s
.24 .35 .67 r
.4681 .60714 m
.4806 .61104 L
s
.922 .273 .118 r
.48874 .61087 m .49056 .60913 L .48107 .58496 L p F P
0 0 0 r
s
.297 .436 .846 r
.54698 .58234 m .55614 .58534 L .53802 .60318 L p F P
0 0 0 r
s
.297 .436 .846 r
.53802 .60318 m .53179 .60119 L .54698 .58234 L p F P
0 0 0 r
s
.83 .24 .1 r
.5086 .60119 m
.53802 .61054 L
s
.249 .344 .649 r
.54183 .39975 m .56195 .4074 L .56173 .42851 L p F P
0 0 0 r
s
.24 .35 .67 r
.54138 .40083 m
.54301 .40145 L
s
.56194 .40864 m
.56311 .40909 L
s
.249 .344 .649 r
.58154 .43592 m .56173 .42851 L .56195 .4074 L p F P
0 0 0 r
s
.288 .412 .793 r
.61585 .55261 m .60187 .54782 L .61633 .5254 L p F P
0 0 0 r
s
.292 .422 .814 r
.60187 .54782 m .61585 .55261 L .59636 .57292 L p F P
0 0 0 r
s
.34 .095 .048 r
.38672 .47047 m .3969 .45843 L .39367 .43539 L p F P
0 0 0 r
s
.47 .135 .064 r
.3969 .45843 m .38672 .47047 L .39331 .49397 L p F P
0 0 0 r
s
.297 .439 .855 r
.48107 .58496 m .48749 .58701 L .49376 .61014 L p F P
0 0 0 r
s
.297 .439 .855 r
.49376 .61014 m .49056 .60913 L .48107 .58496 L p F P
0 0 0 r
s
.83 .24 .1 r
.50227 .25776 m
.47893 .28689 L
s
.47893 .28689 m
.46361 .30235 L
s
.866 .256 .112 r
.45077 .57912 m .44563 .58433 L .46319 .60251 L p F P
0 0 0 r
s
.866 .256 .112 r
.46319 .60251 m .46672 .59904 L .45077 .57912 L p F P
0 0 0 r
s
.575 .166 .076 r
.39409 .52759 m .40281 .51784 L .39331 .49397 L p F P
0 0 0 r
s
.663 .193 .087 r
.40281 .51784 m .39409 .52759 L .40724 .54971 L p F P
0 0 0 r
s
.292 .422 .814 r
.59636 .57292 m .58467 .56901 L .60187 .54782 L p F P
0 0 0 r
s
.24 .35 .67 r
.59523 .55441 m
.59624 .55476 L
s
.59343 .55822 m
.59523 .55441 L
s
.229 .31 .58 r
.50084 .36611 m .52097 .37387 L .52147 .392 L p F P
0 0 0 r
s
.229 .31 .58 r
.54183 .39975 m .52147 .392 L .52097 .37387 L p F P
0 0 0 r
s
.24 .35 .67 r
.54125 .39952 m
.54138 .40083 L
s
.083 .024 .01 r
.44206 .32912 m .43143 .34243 L .42783 .35613 L p F P
0 0 0 r
s
.083 .024 .01 r
.41691 .36972 m .42783 .35613 L .43143 .34243 L p F P
0 0 0 r
s
.83 .24 .1 r
.42972 .35256 m
.43106 .35089 L
s
.43106 .35089 m
.43797 .3369 L
s
.805 .237 .104 r
.42938 .56373 m .42288 .57055 L .44054 .58949 L p F P
0 0 0 r
s
.805 .237 .104 r
.44054 .58949 m .44563 .58433 L .42938 .56373 L p F P
0 0 0 r
s
.83 .24 .1 r
.64271 .56583 m
.66455 .55711 L
s
.69177 .53356 m
.66455 .55711 L
s
.297 .436 .846 r
.53776 .57933 m .54698 .58234 L .53179 .60119 L p F P
0 0 0 r
s
.297 .436 .846 r
.53179 .60119 m .52553 .59919 L .53776 .57933 L p F P
0 0 0 r
s
.24 .35 .67 r
.52525 .59811 m
.52604 .59836 L
s
.83 .24 .1 r
.80456 .3496 m
.7925 .32191 L
s
.296 .43 .832 r
.5729 .56508 m .58467 .56901 L .56526 .58832 L p F P
0 0 0 r
s
.296 .43 .832 r
.56526 .58832 m .55614 .58534 L .5729 .56508 L p F P
0 0 0 r
s
.83 .24 .1 r
.53959 .60911 m
.56256 .58814 L
s
.53802 .61054 m
.53959 .60911 L
s
.24 .35 .67 r
.32146 .26777 m
.36398 .28451 L
s
.36398 .28451 m
.3701 .29548 L
s
.16963 .55878 m
.1623 .55592 L
s
.282 .401 .768 r
.61633 .5254 m .60029 .51977 L .61008 .49613 L p F P
0 0 0 r
s
.288 .412 .793 r
.60029 .51977 m .61633 .5254 L .60187 .54782 L p F P
0 0 0 r
s
.24 .35 .67 r
.46544 .60631 m
.4681 .60714 L
s
.663 .193 .087 r
.40724 .54971 m .41496 .54134 L .40281 .51784 L p F P
0 0 0 r
s
.738 .216 .096 r
.41496 .54134 m .40724 .54971 L .42288 .57055 L p F P
0 0 0 r
s
.263 .368 .699 r
.56173 .42851 m .58154 .43592 L .57906 .45894 L p F P
0 0 0 r
s
.263 .368 .699 r
.59807 .46591 m .57906 .45894 L .58154 .43592 L p F P
0 0 0 r
s
.738 .216 .096 r
.42288 .57055 m .42938 .56373 L .41496 .54134 L p F P
0 0 0 r
s
.83 .24 .1 r
.78173 .40341 m
.81144 .37662 L
s
.78252 .42855 m
.78173 .40341 L
s
.212 .061 .032 r
.39367 .43539 m .40435 .42249 L .404 .40125 L p F P
0 0 0 r
s
.83 .24 .1 r
.40404 .40355 m
.40504 .40232 L
s
.34 .095 .048 r
.40435 .42249 m .39367 .43539 L .3969 .45843 L p F P
0 0 0 r
s
.297 .436 .846 r
.52849 .5763 m .53776 .57933 L .52553 .59919 L p F P
0 0 0 r
s
.24 .35 .67 r
.52525 .59811 m
.52578 .59722 L
s
.297 .436 .846 r
.52553 .59919 m .51925 .59718 L .52849 .5763 L p F P
0 0 0 r
s
.866 .256 .112 r
.45596 .57386 m .45077 .57912 L .46672 .59904 L p F P
0 0 0 r
s
.866 .256 .112 r
.46672 .59904 m .47027 .59555 L .45596 .57386 L p F P
0 0 0 r
s
.24 .35 .67 r
.4681 .60714 m
.47677 .59559 L
s
.47677 .59559 m
.47852 .59325 L
s
.59523 .55441 m
.60128 .53742 L
s
.274 .386 .737 r
.61008 .49613 m .59235 .48976 L .59807 .46591 L p F P
0 0 0 r
s
.282 .401 .768 r
.59235 .48976 m .61008 .49613 L .60029 .51977 L p F P
0 0 0 r
s
.274 .386 .737 r
.57906 .45894 m .59807 .46591 L .59235 .48976 L p F P
0 0 0 r
s
.143 .041 .02 r
.42783 .35613 m .41691 .36972 L .41494 .38782 L p F P
0 0 0 r
s
.143 .041 .02 r
.404 .40125 m .41494 .38782 L .41691 .36972 L p F P
0 0 0 r
s
.292 .422 .814 r
.58777 .54299 m .60187 .54782 L .58467 .56901 L p F P
0 0 0 r
s
.292 .422 .814 r
.58467 .56901 m .5729 .56508 L .58777 .54299 L p F P
0 0 0 r
s
.288 .412 .793 r
.60187 .54782 m .58777 .54299 L .60029 .51977 L p F P
0 0 0 r
s
.212 .061 .032 r
.41494 .38782 m .404 .40125 L .40435 .42249 L p F P
0 0 0 r
s
.296 .43 .832 r
.56105 .56111 m .5729 .56508 L .55614 .58534 L p F P
0 0 0 r
s
.296 .43 .832 r
.55614 .58534 m .54698 .58234 L .56105 .56111 L p F P
0 0 0 r
s
.198 .262 .481 r
.44206 .32912 m .46186 .33684 L .45985 .35031 L p F P
0 0 0 r
s
.198 .262 .481 r
.48047 .35825 m .45985 .35031 L .46186 .33684 L p F P
0 0 0 r
s
.297 .436 .846 r
.51918 .57326 m .52849 .5763 L .51925 .59718 L p F P
0 0 0 r
s
.297 .436 .846 r
.51925 .59718 m .51294 .59516 L .51918 .57326 L p F P
0 0 0 r
s
.83 .24 .1 r
.54646 .2179 m
.52209 .248 L
s
.52209 .248 m
.50227 .25776 L
s
.47 .135 .064 r
.39331 .49397 m .40295 .48287 L .3969 .45843 L p F P
0 0 0 r
s
.575 .166 .076 r
.40295 .48287 m .39331 .49397 L .40281 .51784 L p F P
0 0 0 r
s
.24 .35 .67 r
.32617 .58459 m
.31242 .59485 L
s
.26913 .58176 m
.31242 .59485 L
s
.805 .237 .104 r
.43597 .55683 m .42938 .56373 L .44563 .58433 L p F P
0 0 0 r
s
.805 .237 .104 r
.44563 .58433 m .45077 .57912 L .43597 .55683 L p F P
0 0 0 r
s
.249 .344 .649 r
.52147 .392 m .54183 .39975 L .54168 .42102 L p F P
0 0 0 r
s
.249 .344 .649 r
.56173 .42851 m .54168 .42102 L .54183 .39975 L p F P
0 0 0 r
s
.24 .35 .67 r
.27081 .24707 m
.27792 .25064 L
s
.83 .24 .1 r
.69177 .53356 m
.70869 .51954 L
s
.73697 .49508 m
.70869 .51954 L
s
.229 .31 .58 r
.48047 .35825 m .50084 .36611 L .50086 .38417 L p F P
0 0 0 r
s
.229 .31 .58 r
.52147 .392 m .50086 .38417 L .50084 .36611 L p F P
0 0 0 r
s
.866 .256 .112 r
.4612 .56855 m .45596 .57386 L .47027 .59555 L p F P
0 0 0 r
s
.866 .256 .112 r
.47027 .59555 m .47385 .59205 L .4612 .56855 L p F P
0 0 0 r
s
.24 .35 .67 r
.42681 .59424 m
.46544 .60631 L
s
.297 .436 .846 r
.50981 .57019 m .51918 .57326 L .51294 .59516 L p F P
0 0 0 r
s
.297 .436 .846 r
.51294 .59516 m .50662 .59313 L .50981 .57019 L p F P
0 0 0 r
s
.282 .401 .768 r
.60029 .51977 m .5841 .51409 L .59235 .48976 L p F P
0 0 0 r
s
.288 .412 .793 r
.5841 .51409 m .60029 .51977 L .58777 .54299 L p F P
0 0 0 r
s
.83 .24 .1 r
.64936 .19352 m
.62163 .18565 L
s
.296 .43 .832 r
.54911 .55712 m .56105 .56111 L .54698 .58234 L p F P
0 0 0 r
s
.296 .43 .832 r
.54698 .58234 m .53776 .57933 L .54911 .55712 L p F P
0 0 0 r
s
.292 .422 .814 r
.57355 .53812 m .58777 .54299 L .5729 .56508 L p F P
0 0 0 r
s
.292 .422 .814 r
.5729 .56508 m .56105 .56111 L .57355 .53812 L p F P
0 0 0 r
s
.83 .24 .1 r
.49324 .59315 m
.5086 .60119 L
s
.49014 .59152 m
.49324 .59315 L
s
.288 .412 .793 r
.58777 .54299 m .57355 .53812 L .5841 .51409 L p F P
0 0 0 r
s
.83 .24 .1 r
.56256 .58814 m
.59099 .59153 L
s
.61687 .56852 m
.59099 .59153 L
s
.263 .368 .699 r
.54168 .42102 m .56173 .42851 L .55984 .45189 L p F P
0 0 0 r
s
.263 .368 .699 r
.57906 .45894 m .55984 .45189 L .56173 .42851 L p F P
0 0 0 r
s
.575 .166 .076 r
.40281 .51784 m .41167 .50793 L .40295 .48287 L p F P
0 0 0 r
s
.663 .193 .087 r
.41167 .50793 m .40281 .51784 L .41496 .54134 L p F P
0 0 0 r
s
.738 .216 .096 r
.42279 .53285 m .41496 .54134 L .42938 .56373 L p F P
0 0 0 r
s
.738 .216 .096 r
.42938 .56373 m .43597 .55683 L .42279 .53285 L p F P
0 0 0 r
s
.24 .35 .67 r
.3701 .29548 m
.41233 .312 L
s
.41233 .312 m
.41622 .32975 L
s
.297 .436 .846 r
.50039 .56712 m .50981 .57019 L .50662 .59313 L p F P
0 0 0 r
s
.297 .436 .846 r
.50662 .59313 m .50026 .5911 L .50039 .56712 L p F P
0 0 0 r
s
.274 .386 .737 r
.59235 .48976 m .57442 .48333 L .57906 .45894 L p F P
0 0 0 r
s
.282 .401 .768 r
.57442 .48333 m .59235 .48976 L .5841 .51409 L p F P
0 0 0 r
s
.274 .386 .737 r
.55984 .45189 m .57906 .45894 L .57442 .48333 L p F P
0 0 0 r
s
.663 .193 .087 r
.41496 .54134 m .42279 .53285 L .41167 .50793 L p F P
0 0 0 r
s
.866 .256 .112 r
.46648 .56319 m .4612 .56855 L .47385 .59205 L p F P
0 0 0 r
s
.866 .256 .112 r
.47385 .59205 m .47745 .58851 L .46648 .56319 L p F P
0 0 0 r
s
.34 .095 .048 r
.3969 .45843 m .40729 .44616 L .40435 .42249 L p F P
0 0 0 r
s
.47 .135 .064 r
.40729 .44616 m .3969 .45843 L .40295 .48287 L p F P
0 0 0 r
s
.296 .43 .832 r
.53709 .55309 m .54911 .55712 L .53776 .57933 L p F P
0 0 0 r
s
.24 .35 .67 r
.53667 .57898 m
.53771 .57724 L
s
.296 .43 .832 r
.53776 .57933 m .52849 .5763 L .53709 .55309 L p F P
0 0 0 r
s
.83 .24 .1 r
.51014 .59973 m
.53274 .5784 L
s
.5086 .60119 m
.51014 .59973 L
s
.24 .35 .67 r
.2248 .56836 m
.2143 .5722 L
s
.16963 .55878 m
.2143 .5722 L
s
.805 .237 .104 r
.44263 .54984 m .43597 .55683 L .45077 .57912 L p F P
0 0 0 r
s
.805 .237 .104 r
.45077 .57912 m .45596 .57386 L .44263 .54984 L p F P
0 0 0 r
s
.083 .024 .01 r
.42783 .35613 m .43899 .34227 L .44206 .32912 L p F P
0 0 0 r
s
.198 .262 .481 r
.45985 .35031 m .43899 .34227 L .44206 .32912 L p F P
0 0 0 r
s
.83 .24 .1 r
.4411 .3384 m
.44253 .33662 L
s
.44253 .33662 m
.45364 .3228 L
s
.297 .436 .846 r
.49092 .56402 m .50039 .56712 L .50026 .5911 L p F P
0 0 0 r
s
.297 .436 .846 r
.50026 .5911 m .49389 .58906 L .49092 .56402 L p F P
0 0 0 r
s
.24 .35 .67 r
.38451 .58103 m
.36902 .59772 L
s
.32617 .58459 m
.36902 .59772 L
s
.292 .422 .814 r
.55922 .53321 m .57355 .53812 L .56105 .56111 L p F P
0 0 0 r
s
.292 .422 .814 r
.56105 .56111 m .54911 .55712 L .55922 .53321 L p F P
0 0 0 r
s
.83 .24 .1 r
.59544 .18321 m
.56992 .2142 L
s
.56992 .2142 m
.54646 .2179 L
s
.73697 .49508 m
.7482 .47645 L
s
.77745 .45096 m
.7482 .47645 L
s
.81144 .37662 m
.80456 .3496 L
s
.249 .344 .649 r
.50086 .38417 m .52147 .392 L .52139 .41343 L p F P
0 0 0 r
s
.24 .35 .67 r
.50085 .38544 m
.50208 .38591 L
s
.52146 .39327 m
.52267 .39373 L
s
.249 .344 .649 r
.54168 .42102 m .52139 .41343 L .52147 .392 L p F P
0 0 0 r
s
.282 .401 .768 r
.5841 .51409 m .56774 .50835 L .57442 .48333 L p F P
0 0 0 r
s
.288 .412 .793 r
.56774 .50835 m .5841 .51409 L .57355 .53812 L p F P
0 0 0 r
s
.229 .31 .58 r
.45985 .35031 m .48047 .35825 L .48 .37624 L p F P
0 0 0 r
s
.229 .31 .58 r
.50086 .38417 m .48 .37624 L .48047 .35825 L p F P
0 0 0 r
s
.24 .35 .67 r
.50075 .38413 m
.50085 .38544 L
s
.297 .436 .846 r
.4814 .56091 m .49092 .56402 L .49389 .58906 L p F P
0 0 0 r
s
.297 .436 .846 r
.49389 .58906 m .48749 .58701 L .4814 .56091 L p F P
0 0 0 r
s
.24 .35 .67 r
.48403 .58591 m
.48463 .5851 L
s
.48463 .5851 m
.48724 .58594 L
s
.288 .412 .793 r
.57355 .53812 m .55922 .53321 L .56774 .50835 L p F P
0 0 0 r
s
.296 .43 .832 r
.52498 .54904 m .53709 .55309 L .52849 .5763 L p F P
0 0 0 r
s
.296 .43 .832 r
.52849 .5763 m .51918 .57326 L .52498 .54904 L p F P
0 0 0 r
s
.866 .256 .112 r
.47182 .55777 m .46648 .56319 L .47745 .58851 L p F P
0 0 0 r
s
.866 .256 .112 r
.47745 .58851 m .48107 .58496 L .47182 .55777 L p F P
0 0 0 r
s
.212 .061 .032 r
.40435 .42249 m .41525 .40933 L .41494 .38782 L p F P
0 0 0 r
s
.34 .095 .048 r
.41525 .40933 m .40435 .42249 L .40729 .44616 L p F P
0 0 0 r
s
.24 .35 .67 r
.27792 .25064 m
.32146 .26777 L
s
.32146 .26777 m
.32684 .27856 L
s
.41622 .32975 m
.4394 .33871 L
s
.143 .041 .02 r
.43899 .34227 m .42783 .35613 L .42611 .3741 L p F P
0 0 0 r
s
.143 .041 .02 r
.41494 .38782 m .42611 .3741 L .42783 .35613 L p F P
0 0 0 r
s
.83 .24 .1 r
.42693 .37549 m
.4279 .36966 L
s
.24 .35 .67 r
.38451 .58103 m
.42681 .59424 L
s
.274 .386 .737 r
.57442 .48333 m .55631 .47683 L .55984 .45189 L p F P
0 0 0 r
s
.282 .401 .768 r
.55631 .47683 m .57442 .48333 L .56774 .50835 L p F P
0 0 0 r
s
.24 .35 .67 r
.567 .50826 m
.56729 .50711 L
s
.567 .50826 m
.56769 .5085 L
s
.297 .436 .846 r
.47182 .55777 m .4814 .56091 L .48749 .58701 L p F P
0 0 0 r
s
.297 .436 .846 r
.48749 .58701 m .48107 .58496 L .47182 .55777 L p F P
0 0 0 r
s
.83 .24 .1 r
.48342 .58192 m
.4848 .58057 L
s
.24 .35 .67 r
.4717 .58096 m
.47505 .58204 L
s
.47505 .58204 m
.47748 .58281 L
s
.263 .368 .699 r
.52139 .41343 m .54168 .42102 L .5404 .44476 L p F P
0 0 0 r
s
.263 .368 .699 r
.55984 .45189 m .5404 .44476 L .54168 .42102 L p F P
0 0 0 r
s
.292 .422 .814 r
.54475 .52825 m .55922 .53321 L .54911 .55712 L p F P
0 0 0 r
s
.24 .35 .67 r
.54801 .55675 m
.5488 .55505 L
s
.292 .422 .814 r
.54911 .55712 m .53709 .55309 L .54475 .52825 L p F P
0 0 0 r
s
.47 .135 .064 r
.40295 .48287 m .41278 .47155 L .40729 .44616 L p F P
0 0 0 r
s
.575 .166 .076 r
.41278 .47155 m .40295 .48287 L .41167 .50793 L p F P
0 0 0 r
s
.212 .061 .032 r
.42611 .3741 m .41494 .38782 L .41525 .40933 L p F P
0 0 0 r
s
.738 .216 .096 r
.43074 .52424 m .42279 .53285 L .43597 .55683 L p F P
0 0 0 r
s
.738 .216 .096 r
.43597 .55683 m .44263 .54984 L .43074 .52424 L p F P
0 0 0 r
s
.805 .237 .104 r
.44938 .54277 m .44263 .54984 L .45596 .57386 L p F P
0 0 0 r
s
.24 .35 .67 r
.42681 .59424 m
.44303 .57178 L
s
.805 .237 .104 r
.45596 .57386 m .4612 .56855 L .44938 .54277 L p F P
0 0 0 r
s
.24 .35 .67 r
.44303 .57178 m
.4717 .58096 L
s
.274 .386 .737 r
.5404 .44476 m .55984 .45189 L .55631 .47683 L p F P
0 0 0 r
s
.24 .35 .67 r
.55824 .53287 m
.567 .50826 L
s
.296 .43 .832 r
.51279 .54496 m .52498 .54904 L .51918 .57326 L p F P
0 0 0 r
s
.296 .43 .832 r
.51918 .57326 m .50981 .57019 L .51279 .54496 L p F P
0 0 0 r
s
.83 .24 .1 r
.487 .27307 m
.46361 .30235 L
s
.46361 .30235 m
.45364 .3228 L
s
.61687 .56852 m
.64271 .56583 L
s
.66989 .54211 m
.64271 .56583 L
s
.77745 .45096 m
.78252 .42855 L
s
.81266 .40191 m
.78252 .42855 L
s
.282 .401 .768 r
.56774 .50835 m .55123 .50255 L .55631 .47683 L p F P
0 0 0 r
s
.288 .412 .793 r
.55123 .50255 m .56774 .50835 L .55922 .53321 L p F P
0 0 0 r
s
.288 .412 .793 r
.55922 .53321 m .54475 .52825 L .55123 .50255 L p F P
0 0 0 r
s
.575 .166 .076 r
.41167 .50793 m .42068 .49786 L .41278 .47155 L p F P
0 0 0 r
s
.663 .193 .087 r
.42068 .49786 m .41167 .50793 L .42279 .53285 L p F P
0 0 0 r
s
.663 .193 .087 r
.42279 .53285 m .43074 .52424 L .42068 .49786 L p F P
0 0 0 r
s
.24 .35 .67 r
.28227 .57115 m
.26913 .58176 L
s
.2248 .56836 m
.26913 .58176 L
s
.249 .344 .649 r
.48 .37624 m .50086 .38417 L .50086 .40575 L p F P
0 0 0 r
s
.249 .344 .649 r
.52139 .41343 m .50086 .40575 L .50086 .38417 L p F P
0 0 0 r
s
.292 .422 .814 r
.53017 .52325 m .54475 .52825 L .53709 .55309 L p F P
0 0 0 r
s
.292 .422 .814 r
.53709 .55309 m .52498 .54904 L .53017 .52325 L p F P
0 0 0 r
s
.296 .43 .832 r
.50051 .54086 m .51279 .54496 L .50981 .57019 L p F P
0 0 0 r
s
.83 .24 .1 r
.4848 .58057 m
.4867 .57871 L
s
.296 .43 .832 r
.50981 .57019 m .50039 .56712 L .50051 .54086 L p F P
0 0 0 r
s
.229 .31 .58 r
.43899 .34227 m .45985 .35031 L .45889 .36821 L p F P
0 0 0 r
s
.229 .31 .58 r
.48 .37624 m .45889 .36821 L .45985 .35031 L p F P
0 0 0 r
s
.83 .24 .1 r
.62163 .18565 m
.59544 .18321 L
s
.274 .386 .737 r
.55631 .47683 m .538 .47025 L .5404 .44476 L p F P
0 0 0 r
s
.282 .401 .768 r
.538 .47025 m .55631 .47683 L .55123 .50255 L p F P
0 0 0 r
s
.805 .237 .104 r
.45622 .5356 m .44938 .54277 L .4612 .56855 L p F P
0 0 0 r
s
.805 .237 .104 r
.4612 .56855 m .46648 .56319 L .45622 .5356 L p F P
0 0 0 r
s
.83 .24 .1 r
.53274 .5784 m
.56256 .58814 L
s
.58815 .5648 m
.56256 .58814 L
s
.34 .095 .048 r
.40729 .44616 m .41788 .43364 L .41525 .40933 L p F P
0 0 0 r
s
.47 .135 .064 r
.41788 .43364 m .40729 .44616 L .41278 .47155 L p F P
0 0 0 r
s
.263 .368 .699 r
.50086 .40575 m .52139 .41343 L .52073 .43754 L p F P
0 0 0 r
s
.263 .368 .699 r
.5404 .44476 m .52073 .43754 L .52139 .41343 L p F P
0 0 0 r
s
.24 .35 .67 r
.32684 .27856 m
.3701 .29548 L
s
.3701 .29548 m
.3733 .31316 L
s
.83 .24 .1 r
.52661 .22739 m
.50227 .25776 L
s
.50227 .25776 m
.487 .27307 L
s
.296 .43 .832 r
.48814 .53672 m .50051 .54086 L .50039 .56712 L p F P
0 0 0 r
s
.296 .43 .832 r
.50039 .56712 m .49092 .56402 L .48814 .53672 L p F P
0 0 0 r
s
.274 .386 .737 r
.52073 .43754 m .5404 .44476 L .538 .47025 L p F P
0 0 0 r
s
.738 .216 .096 r
.43881 .51549 m .43074 .52424 L .44263 .54984 L p F P
0 0 0 r
s
.738 .216 .096 r
.44263 .54984 m .44938 .54277 L .43881 .51549 L p F P
0 0 0 r
s
.288 .412 .793 r
.53456 .4967 m .55123 .50255 L .54475 .52825 L p F P
0 0 0 r
s
.288 .412 .793 r
.54475 .52825 m .53017 .52325 L .53456 .4967 L p F P
0 0 0 r
s
.282 .401 .768 r
.55123 .50255 m .53456 .4967 L .538 .47025 L p F P
0 0 0 r
s
.292 .422 .814 r
.51546 .51821 m .53017 .52325 L .52498 .54904 L p F P
0 0 0 r
s
.292 .422 .814 r
.52498 .54904 m .51279 .54496 L .51546 .51821 L p F P
0 0 0 r
s
.83 .24 .1 r
.66989 .54211 m
.69177 .53356 L
s
.72015 .50901 m
.69177 .53356 L
s
.24 .35 .67 r
.17938 .55462 m
.16963 .55878 L
s
.34119 .5675 m
.32617 .58459 L
s
.28227 .57115 m
.32617 .58459 L
s
.83 .24 .1 r
.81266 .40191 m
.81144 .37662 L
s
.212 .061 .032 r
.41525 .40933 m .42638 .39588 L .42611 .3741 L p F P
0 0 0 r
s
.83 .24 .1 r
.42614 .37645 m
.42693 .37549 L
s
.34 .095 .048 r
.42638 .39588 m .41525 .40933 L .41788 .43364 L p F P
0 0 0 r
s
.249 .344 .649 r
.45889 .36821 m .48 .37624 L .48007 .39798 L p F P
0 0 0 r
s
.24 .35 .67 r
.45935 .36967 m
.46015 .36998 L
s
.48001 .37752 m
.48124 .37799 L
s
.4593 .36879 m
.45935 .36967 L
s
.249 .344 .649 r
.50086 .40575 m .48007 .39798 L .48 .37624 L p F P
0 0 0 r
s
.296 .43 .832 r
.47568 .53255 m .48814 .53672 L .49092 .56402 L p F P
0 0 0 r
s
.296 .43 .832 r
.49092 .56402 m .4814 .56091 L .47568 .53255 L p F P
0 0 0 r
s
.83 .24 .1 r
.4867 .57871 m
.50305 .56264 L
s
.47 .135 .064 r
.41278 .47155 m .42279 .46002 L .41788 .43364 L p F P
0 0 0 r
s
.575 .166 .076 r
.42279 .46002 m .41278 .47155 L .42068 .49786 L p F P
0 0 0 r
s
.143 .041 .02 r
.42611 .3741 m .43752 .36009 L .43899 .34227 L p F P
0 0 0 r
s
.229 .31 .58 r
.45889 .36821 m .43752 .36009 L .43899 .34227 L p F P
0 0 0 r
s
.83 .24 .1 r
.44107 .35815 m
.44974 .34751 L
s
.805 .237 .104 r
.46314 .52835 m .45622 .5356 L .46648 .56319 L p F P
0 0 0 r
s
.805 .237 .104 r
.46648 .56319 m .47182 .55777 L .46314 .52835 L p F P
0 0 0 r
s
.663 .193 .087 r
.42984 .4876 m .42068 .49786 L .43074 .52424 L p F P
0 0 0 r
s
.663 .193 .087 r
.43074 .52424 m .43881 .51549 L .42984 .4876 L p F P
0 0 0 r
s
.274 .386 .737 r
.538 .47025 m .51949 .46361 L .52073 .43754 L p F P
0 0 0 r
s
.282 .401 .768 r
.51949 .46361 m .538 .47025 L .53456 .4967 L p F P
0 0 0 r
s
.292 .422 .814 r
.50062 .51313 m .51546 .51821 L .51279 .54496 L p F P
0 0 0 r
s
.292 .422 .814 r
.51279 .54496 m .50051 .54086 L .50062 .51313 L p F P
0 0 0 r
s
.212 .061 .032 r
.43752 .36009 m .42611 .3741 L .42638 .39588 L p F P
0 0 0 r
s
.288 .412 .793 r
.51772 .49079 m .53456 .4967 L .53017 .52325 L p F P
0 0 0 r
s
.288 .412 .793 r
.53017 .52325 m .51546 .51821 L .51772 .49079 L p F P
0 0 0 r
s
.575 .166 .076 r
.42068 .49786 m .42984 .4876 L .42279 .46002 L p F P
0 0 0 r
s
.24 .35 .67 r
.27792 .25064 m
.28251 .26123 L
s
.83 .24 .1 r
.57186 .18652 m
.54646 .2179 L
s
.54646 .2179 m
.52661 .22739 L
s
.24 .35 .67 r
.3733 .31316 m
.41622 .32975 L
s
.41622 .32975 m
.41683 .35352 L
s
.40041 .55814 m
.38451 .58103 L
s
.34119 .5675 m
.38451 .58103 L
s
.44303 .57178 m
.45866 .54416 L
s
.40041 .55814 m
.44303 .57178 L
s
.263 .368 .699 r
.48007 .39798 m .50086 .40575 L .50083 .43024 L p F P
0 0 0 r
s
.263 .368 .699 r
.52073 .43754 m .50083 .43024 L .50086 .40575 L p F P
0 0 0 r
s
.296 .43 .832 r
.46314 .52835 m .47568 .53255 L .4814 .56091 L p F P
0 0 0 r
s
.296 .43 .832 r
.4814 .56091 m .47182 .55777 L .46314 .52835 L p F P
0 0 0 r
s
.83 .24 .1 r
.47253 .54422 m
.47508 .54161 L
s
.47035 .54646 m
.47253 .54422 L
s
.24 .35 .67 r
.45866 .54416 m
.46321 .54566 L
s
.46321 .54566 m
.46713 .54696 L
s
.282 .401 .768 r
.53456 .4967 m .51772 .49079 L .51949 .46361 L p F P
0 0 0 r
s
.274 .386 .737 r
.50083 .43024 m .52073 .43754 L .51949 .46361 L p F P
0 0 0 r
s
.83 .24 .1 r
.72015 .50901 m
.73697 .49508 L
s
.76646 .46958 m
.73697 .49508 L
s
.738 .216 .096 r
.447 .50662 m .43881 .51549 L .44938 .54277 L p F P
0 0 0 r
s
.738 .216 .096 r
.44938 .54277 m .45622 .5356 L .447 .50662 L p F P
0 0 0 r
s
.83 .24 .1 r
.50305 .56264 m
.53274 .5784 L
s
.55792 .55464 m
.53274 .5784 L
s
.292 .422 .814 r
.48565 .508 m .50062 .51313 L .50051 .54086 L p F P
0 0 0 r
s
.292 .422 .814 r
.50051 .54086 m .48814 .53672 L .48565 .508 L p F P
0 0 0 r
s
.83 .24 .1 r
.58815 .5648 m
.61687 .56852 L
s
.64386 .54453 m
.61687 .56852 L
s
.24 .35 .67 r
.2373 .55737 m
.2248 .56836 L
s
.17938 .55462 m
.2248 .56836 L
s
.288 .412 .793 r
.50071 .48483 m .51772 .49079 L .51546 .51821 L p F P
0 0 0 r
s
.288 .412 .793 r
.51546 .51821 m .50062 .51313 L .50071 .48483 L p F P
0 0 0 r
s
.249 .344 .649 r
.43752 .36009 m .45889 .36821 L .45904 .39012 L p F P
0 0 0 r
s
.24 .35 .67 r
.4589 .36951 m
.45935 .36967 L
s
.249 .344 .649 r
.48007 .39798 m .45904 .39012 L .45889 .36821 L p F P
0 0 0 r
s
.34 .095 .048 r
.41788 .43364 m .42869 .42087 L .42638 .39588 L p F P
0 0 0 r
s
.47 .135 .064 r
.42869 .42087 m .41788 .43364 L .42279 .46002 L p F P
0 0 0 r
s
.274 .386 .737 r
.51949 .46361 m .50078 .45689 L .50083 .43024 L p F P
0 0 0 r
s
.282 .401 .768 r
.50078 .45689 m .51949 .46361 L .51772 .49079 L p F P
0 0 0 r
s
.83 .24 .1 r
.47718 .2935 m
.45364 .3228 L
s
.44974 .34751 m
.45364 .3228 L
s
.282 .401 .768 r
.51772 .49079 m .50071 .48483 L .50078 .45689 L p F P
0 0 0 r
s
.83 .24 .1 r
.59544 .18321 m
.57186 .18652 L
s
.76646 .46958 m
.77745 .45096 L
s
.80796 .42439 m
.77745 .45096 L
s
.663 .193 .087 r
.43917 .47717 m .42984 .4876 L .43881 .51549 L p F P
0 0 0 r
s
.663 .193 .087 r
.43881 .51549 m .447 .50662 L .43917 .47717 L p F P
0 0 0 r
s
.263 .368 .699 r
.45904 .39012 m .48007 .39798 L .4807 .42286 L p F P
0 0 0 r
s
.263 .368 .699 r
.50083 .43024 m .4807 .42286 L .48007 .39798 L p F P
0 0 0 r
s
.292 .422 .814 r
.47055 .50282 m .48565 .508 L .48814 .53672 L p F P
0 0 0 r
s
.292 .422 .814 r
.48814 .53672 m .47568 .53255 L .47055 .50282 L p F P
0 0 0 r
s
.274 .386 .737 r
.4807 .42286 m .50083 .43024 L .50078 .45689 L p F P
0 0 0 r
s
.24 .35 .67 r
.28251 .26123 m
.32684 .27856 L
s
.32684 .27856 m
.32931 .29616 L
s
.738 .216 .096 r
.45532 .49761 m .447 .50662 L .45622 .5356 L p F P
0 0 0 r
s
.738 .216 .096 r
.45622 .5356 m .46314 .52835 L .45532 .49761 L p F P
0 0 0 r
s
.47 .135 .064 r
.42279 .46002 m .43299 .44826 L .42869 .42087 L p F P
0 0 0 r
s
.575 .166 .076 r
.43299 .44826 m .42279 .46002 L .42984 .4876 L p F P
0 0 0 r
s
.212 .061 .032 r
.42638 .39588 m .43775 .38215 L .43752 .36009 L p F P
0 0 0 r
s
.83 .24 .1 r
.43754 .36247 m
.43844 .36137 L
s
.24 .35 .67 r
.43753 .36139 m
.43879 .36187 L
s
.41683 .35352 m
.43671 .36108 L
s
.34 .095 .048 r
.43775 .38215 m .42638 .39588 L .42869 .42087 L p F P
0 0 0 r
s
.288 .412 .793 r
.48353 .4788 m .50071 .48483 L .50062 .51313 L p F P
0 0 0 r
s
.288 .412 .793 r
.50062 .51313 m .48565 .508 L .48353 .4788 L p F P
0 0 0 r
s
.575 .166 .076 r
.42984 .4876 m .43917 .47717 L .43299 .44826 L p F P
0 0 0 r
s
.83 .24 .1 r
.47508 .54161 m
.50305 .56264 L
s
.52775 .5384 m
.50305 .56264 L
s
.24 .35 .67 r
.45866 .54416 m
.46208 .53658 L
s
.46208 .53658 m
.4627 .53521 L
s
.2968 .55363 m
.28227 .57115 L
s
.2373 .55737 m
.28227 .57115 L
s
.249 .344 .649 r
.45904 .39012 m .43775 .38215 L .43752 .36009 L p F P
0 0 0 r
s
.83 .24 .1 r
.43902 .36066 m
.44107 .35815 L
s
.274 .386 .737 r
.50078 .45689 m .48186 .4501 L .4807 .42286 L p F P
0 0 0 r
s
.282 .401 .768 r
.48186 .4501 m .50078 .45689 L .50071 .48483 L p F P
0 0 0 r
s
.292 .422 .814 r
.45532 .49761 m .47055 .50282 L .47568 .53255 L p F P
0 0 0 r
s
.292 .422 .814 r
.47568 .53255 m .46314 .52835 L .45532 .49761 L p F P
0 0 0 r
s
.24 .35 .67 r
.41586 .53006 m
.45866 .54416 L
s
.282 .401 .768 r
.50071 .48483 m .48353 .4788 L .48186 .4501 L p F P
0 0 0 r
s
.83 .24 .1 r
.46907 .53549 m
.47508 .54161 L
s
.46799 .53438 m
.46907 .53549 L
s
.5114 .24253 m
.487 .27307 L
s
.487 .27307 m
.47718 .2935 L
s
.64386 .54453 m
.66989 .54211 L
s
.69823 .51737 m
.66989 .54211 L
s
.47508 .54161 m
.49923 .51684 L
s
.80796 .42439 m
.81266 .40191 L
s
.24 .35 .67 r
.32931 .29616 m
.3733 .31316 L
s
.3733 .31316 m
.37325 .33698 L
s
.35674 .54415 m
.34119 .5675 L
s
.2968 .55363 m
.34119 .5675 L
s
.263 .368 .699 r
.4807 .42286 m .46033 .41539 L .45904 .39012 L p F P
0 0 0 r
s
.274 .386 .737 r
.46033 .41539 m .4807 .42286 L .48186 .4501 L p F P
0 0 0 r
s
.288 .412 .793 r
.46618 .47271 m .48353 .4788 L .48565 .508 L p F P
0 0 0 r
s
.83 .24 .1 r
.45921 .50686 m
.45996 .50605 L
s
.288 .412 .793 r
.48565 .508 m .47055 .50282 L .46618 .47271 L p F P
0 0 0 r
s
.24 .35 .67 r
.41586 .53006 m
.40041 .55814 L
s
.35674 .54415 m
.40041 .55814 L
s
.263 .368 .699 r
.43775 .38215 m .45904 .39012 L .46033 .41539 L p F P
0 0 0 r
s
.663 .193 .087 r
.44866 .46656 m .43917 .47717 L .447 .50662 L p F P
0 0 0 r
s
.24 .35 .67 r
.45523 .50681 m
.4566 .50728 L
s
.663 .193 .087 r
.447 .50662 m .45532 .49761 L .44866 .46656 L p F P
0 0 0 r
s
.34 .095 .048 r
.42869 .42087 m .43972 .40783 L .43775 .38215 L p F P
0 0 0 r
s
.47 .135 .064 r
.43972 .40783 m .42869 .42087 L .43299 .44826 L p F P
0 0 0 r
s
.24 .35 .67 r
.41396 .38232 m
.43656 .39071 L
s
.83 .24 .1 r
.55792 .55464 m
.58815 .5648 L
s
.61484 .54044 m
.58815 .5648 L
s
.24 .35 .67 r
.37325 .33698 m
.41683 .35352 L
s
.41683 .35352 m
.41396 .38232 L
s
.274 .386 .737 r
.48186 .4501 m .46274 .44323 L .46033 .41539 L p F P
0 0 0 r
s
.282 .401 .768 r
.46274 .44323 m .48186 .4501 L .48353 .4788 L p F P
0 0 0 r
s
.282 .401 .768 r
.48353 .4788 m .46618 .47271 L .46274 .44323 L p F P
0 0 0 r
s
.24 .35 .67 r
.19121 .54325 m
.17938 .55462 L
s
.83 .24 .1 r
.55199 .1957 m
.52661 .22739 L
s
.52661 .22739 m
.5114 .24253 L
s
.69823 .51737 m
.72015 .50901 L
s
.74975 .4834 m
.72015 .50901 L
s
.288 .412 .793 r
.44866 .46656 m .46618 .47271 L .47055 .50282 L p F P
0 0 0 r
s
.288 .412 .793 r
.47055 .50282 m .45532 .49761 L .44866 .46656 L p F P
0 0 0 r
s
.83 .24 .1 r
.45996 .50605 m
.47393 .49109 L
s
.24 .35 .67 r
.42999 .49823 m
.45523 .50681 L
s
.575 .166 .076 r
.44339 .43629 m .43299 .44826 L .43917 .47717 L p F P
0 0 0 r
s
.575 .166 .076 r
.43917 .47717 m .44866 .46656 L .44339 .43629 L p F P
0 0 0 r
s
.47 .135 .064 r
.43299 .44826 m .44339 .43629 L .43972 .40783 L p F P
0 0 0 r
s
.263 .368 .699 r
.46033 .41539 m .43972 .40783 L .43775 .38215 L p F P
0 0 0 r
s
.24 .35 .67 r
.43656 .39071 m
.43778 .39117 L
s
.83 .24 .1 r
.43952 .39086 m
.44017 .39008 L
s
.44017 .39008 m
.45238 .37546 L
s
.274 .386 .737 r
.43972 .40783 m .46033 .41539 L .46274 .44323 L p F P
0 0 0 r
s
.24 .35 .67 r
.28251 .26123 m
.28422 .27873 L
s
.83 .24 .1 r
.47355 .31832 m
.44974 .34751 L
s
.44974 .34751 m
.45238 .37546 L
s
.282 .401 .768 r
.44339 .43629 m .46274 .44323 L .46618 .47271 L p F P
0 0 0 r
s
.282 .401 .768 r
.46618 .47271 m .44866 .46656 L .44339 .43629 L p F P
0 0 0 r
s
.83 .24 .1 r
.45032 .46573 m
.45319 .46252 L
s
.45021 .46586 m
.45032 .46573 L
s
.24 .35 .67 r
.44197 .46439 m
.44724 .46624 L
s
.44724 .46624 m
.44746 .46632 L
s
.83 .24 .1 r
.44822 .45271 m
.45319 .46252 L
s
.274 .386 .737 r
.46274 .44323 m .44339 .43629 L .43972 .40783 L p F P
0 0 0 r
s
.83 .24 .1 r
.44329 .42663 m
.46165 .40532 L
s
.57186 .18652 m
.55199 .1957 L
s
.24 .35 .67 r
.42999 .49823 m
.41586 .53006 L
s
.372 .5156 m
.41586 .53006 L
s
.25129 .53942 m
.2373 .55737 L
s
.19121 .54325 m
.2373 .55737 L
s
.83 .24 .1 r
.74975 .4834 m
.76646 .46958 L
s
.79724 .44297 m
.76646 .46958 L
s
.24 .35 .67 r
.40767 .41474 m
.43895 .42605 L
s
.43895 .42605 m
.44145 .42695 L
s
.44197 .46439 m
.44498 .45325 L
s
.83 .24 .1 r
.52775 .5384 m
.55792 .55464 L
s
.5842 .52984 m
.55792 .55464 L
s
.24 .35 .67 r
.28422 .27873 m
.32931 .29616 L
s
.32931 .29616 m
.32859 .32001 L
s
.83 .24 .1 r
.61484 .54044 m
.64386 .54453 L
s
.67204 .51949 m
.64386 .54453 L
s
.24 .35 .67 r
.31198 .52982 m
.2968 .55363 L
s
.25129 .53942 m
.2968 .55363 L
s
.372 .5156 m
.35674 .54415 L
s
.31198 .52982 m
.35674 .54415 L
s
.42999 .49823 m
.44197 .46439 L
s
.38609 .4833 m
.42999 .49823 L
s
.39821 .44904 m
.44197 .46439 L
s
.83 .24 .1 r
.50176 .26292 m
.47718 .2935 L
s
.47718 .2935 m
.47355 .31832 L
s
.24 .35 .67 r
.36983 .36593 m
.41396 .38232 L
s
.41396 .38232 m
.40767 .41474 L
s
.32859 .32001 m
.37325 .33698 L
s
.37325 .33698 m
.36983 .36593 L
s
.83 .24 .1 r
.79724 .44297 m
.80796 .42439 L
s
.47728 .4356 m
.45319 .46252 L
s
.45319 .46252 m
.47393 .49109 L
s
.49923 .51684 m
.52775 .5384 L
s
.55352 .51309 m
.52775 .5384 L
s
.49858 .46468 m
.47393 .49109 L
s
.47393 .49109 m
.49923 .51684 L
s
.47655 .3465 m
.45238 .37546 L
s
.45238 .37546 m
.46165 .40532 L
s
.53688 .21065 m
.5114 .24253 L
s
.5114 .24253 m
.50176 .26292 L
s
.67204 .51949 m
.69823 .51737 L
s
.72782 .49153 m
.69823 .51737 L
s
.52445 .49099 m
.49923 .51684 L
s
.24 .35 .67 r
.38609 .4833 m
.372 .5156 L
s
.32703 .50078 m
.372 .5156 L
s
.20464 .52485 m
.19121 .54325 L
s
.36309 .39862 m
.40767 .41474 L
s
.40767 .41474 m
.39821 .44904 L
s
.83 .24 .1 r
.5842 .52984 m
.61484 .54044 L
s
.64271 .51501 m
.61484 .54044 L
s
.24 .35 .67 r
.28422 .27873 m
.28279 .30262 L
s
.26609 .51512 m
.25129 .53942 L
s
.20464 .52485 m
.25129 .53942 L
s
.32703 .50078 m
.31198 .52982 L
s
.26609 .51512 m
.31198 .52982 L
s
.83 .24 .1 r
.55199 .1957 m
.53688 .21065 L
s
.72782 .49153 m
.74975 .4834 L
s
.78067 .45665 m
.74975 .4834 L
s
.24 .35 .67 r
.39821 .44904 m
.38609 .4833 L
s
.34108 .468 m
.38609 .4833 L
s
.35334 .43329 m
.39821 .44904 L
s
.32458 .34913 m
.36983 .36593 L
s
.36983 .36593 m
.36309 .39862 L
s
.28279 .30262 m
.32859 .32001 L
s
.32859 .32001 m
.32458 .34913 L
s
.83 .24 .1 r
.49842 .28784 m
.47355 .31832 L
s
.47355 .31832 m
.47655 .3465 L
s
.48629 .37673 m
.46165 .40532 L
s
.46165 .40532 m
.47728 .4356 L
s
.78067 .45665 m
.79724 .44297 L
s
.55352 .51309 m
.5842 .52984 L
s
.61165 .50393 m
.5842 .52984 L
s
.64271 .51501 m
.67204 .51949 L
s
.70146 .49333 m
.67204 .51949 L
s
.24 .35 .67 r
.34108 .468 m
.32703 .50078 L
s
.28091 .48558 m
.32703 .50078 L
s
.31738 .3821 m
.36309 .39862 L
s
.36309 .39862 m
.35334 .43329 L
s
.83 .24 .1 r
.52744 .23097 m
.50176 .26292 L
s
.50176 .26292 m
.49842 .28784 L
s
.50245 .40747 m
.47728 .4356 L
s
.47728 .4356 m
.49858 .46468 L
s
.24 .35 .67 r
.21902 .50005 m
.20464 .52485 L
s
.28091 .48558 m
.26609 .51512 L
s
.21902 .50005 m
.26609 .51512 L
s
.35334 .43329 m
.34108 .468 L
s
.29492 .45231 m
.34108 .468 L
s
.30731 .41715 m
.35334 .43329 L
s
.83 .24 .1 r
.52445 .49099 m
.55352 .51309 L
s
.58045 .48664 m
.55352 .51309 L
s
.24 .35 .67 r
.27817 .3319 m
.32458 .34913 L
s
.32458 .34913 m
.31738 .3821 L
s
.28279 .30262 m
.27817 .3319 L
s
.83 .24 .1 r
.52433 .43709 m
.49858 .46468 L
s
.49858 .46468 m
.52445 .49099 L
s
.50181 .31625 m
.47655 .3465 L
s
.47655 .3465 m
.48629 .37673 L
s
.53688 .21065 m
.52744 .23097 L
s
.70146 .49333 m
.72782 .49153 L
s
.75874 .46454 m
.72782 .49153 L
s
.55081 .46396 m
.52445 .49099 L
s
.61165 .50393 m
.64271 .51501 L
s
.67184 .48843 m
.64271 .51501 L
s
.24 .35 .67 r
.29492 .45231 m
.28091 .48558 L
s
.2336 .46998 m
.28091 .48558 L
s
.27048 .36514 m
.31738 .3821 L
s
.31738 .3821 m
.30731 .41715 L
s
.83 .24 .1 r
.75874 .46454 m
.78067 .45665 L
s
.24 .35 .67 r
.2336 .46998 m
.21902 .50005 L
s
.83 .24 .1 r
.52441 .25597 m
.49842 .28784 L
s
.49842 .28784 m
.50181 .31625 L
s
.24 .35 .67 r
.30731 .41715 m
.29492 .45231 L
s
.24756 .4362 m
.29492 .45231 L
s
.26009 .40058 m
.30731 .41715 L
s
.83 .24 .1 r
.51204 .34683 m
.48629 .37673 L
s
.48629 .37673 m
.50245 .40747 L
s
.24 .35 .67 r
.27817 .3319 m
.27048 .36514 L
s
.83 .24 .1 r
.58045 .48664 m
.61165 .50393 L
s
.64035 .47684 m
.61165 .50393 L
s
.67184 .48843 m
.70146 .49333 L
s
.73224 .46598 m
.70146 .49333 L
s
.52744 .23097 m
.52441 .25597 L
s
.52878 .37805 m
.50245 .40747 L
s
.50245 .40747 m
.52433 .43709 L
s
.24 .35 .67 r
.24756 .4362 m
.2336 .46998 L
s
.27048 .36514 m
.26009 .40058 L
s
.83 .24 .1 r
.55081 .46396 m
.58045 .48664 L
s
.60862 .45898 m
.58045 .48664 L
s
.55128 .40822 m
.52433 .43709 L
s
.52433 .43709 m
.55081 .46396 L
s
.52824 .2846 m
.50181 .31625 L
s
.50181 .31625 m
.51204 .34683 L
s
.73224 .46598 m
.75874 .46454 L
s
.57838 .4357 m
.55081 .46396 L
s
.24 .35 .67 r
.26009 .40058 m
.24756 .4362 L
s
.83 .24 .1 r
.64035 .47684 m
.67184 .48843 L
s
.70231 .46062 m
.67184 .48843 L
s
.52441 .25597 m
.52824 .2846 L
s
.53899 .31555 m
.51204 .34683 L
s
.51204 .34683 m
.52878 .37805 L
s
.60862 .45898 m
.64035 .47684 L
s
.67039 .44848 m
.64035 .47684 L
s
.70231 .46062 m
.73224 .46598 L
s
.55634 .34725 m
.52878 .37805 L
s
.52878 .37805 m
.55128 .40822 L
s
.57838 .4357 m
.60862 .45898 L
s
.63812 .43002 m
.60862 .45898 L
s
.57949 .378 m
.55128 .40822 L
s
.55128 .40822 m
.57838 .4357 L
s
.52824 .2846 m
.53899 .31555 L
s
.60725 .4061 m
.57838 .4357 L
s
.67039 .44848 m
.70231 .46062 L
s
.53899 .31555 m
.55634 .34725 L
s
.63812 .43002 m
.67039 .44848 L
s
.55634 .34725 m
.57949 .378 L
s
.60725 .4061 m
.63812 .43002 L
s
.57949 .378 m
.60725 .4061 L
s
0 0 0 r
.25 Mabswid
.36195 .03848 m
.33874 .3169 L
s
.33874 .3169 m
.06528 .69847 L
s
.06528 .69847 m
.11236 .44767 L
s
.11236 .44767 m
.36195 .03848 L
s
.36195 .03848 m
.33874 .3169 L
s
.33874 .3169 m
.99253 .5665 L
s
.99253 .5665 m
.93295 .30234 L
s
.93295 .30234 m
.36195 .03848 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{500, 500},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40007d0001m2000`400?l00000o`00003oo`3ooooe
0?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3o
m^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40
oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?of
k_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3o
ool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^
m03om^h10?ooo`00o`3om^kd0?ofkP40oooo002d0?ofkP800000o`3om^hn0?ofkP40oooo002c0?of
kP80000000<0ooK^000000000000o`3om^hl0?ofkP40oooo002c0?ofkP8000000`3om^h200000?l0
ooK^>P3om^h10?ooo`00/P3om^h00`000000ooK^000000050?ofkP800000o`3om^hh0?ofkP40oooo
002b0?ofkP030000003om^h0000000L0ooK^0P00003o0?ofkSH0ooK^0@3oool00;40ooK^00@00000
0?ofkP3om^h000002@3om^h200000?l0ooK^=03om^h10?ooo`00/03om^h01@000000ooK^0?ofkP3o
m^h0000000/0ooK^0`00003o0?ofkS40ooK^0@3oool00;00ooK^00@000000?ofkP3om^h000003`3o
m^h200000?l0ooK^;`3om^h10?ooo`00[`3om^h01@000000ooK^0?ofkP3om^h000000140ooK^0P00
003o0?ofkRd0ooK^0@3oool00:l0ooK^00D000000?ofkP3om^h0ooK^0000000C0?ofkP800000o`3o
m^h[0?ofkP40oooo002^0?ofkP030000003om^h0ooK^0080ooK^00<000000?ofkP3om^h04`3om^h2
00000?l0ooK^:@3om^h10?ooo`00[@3om^h00`000000ooK^0?ofkP030?ofkP030000003om^h0ooK^
01D0ooK^0`00003o0?ofkRH0ooK^0@3oool00:d0ooK^00<000000?ofkP3om^h00`3om^h00`000000
ooK^0?ofkP0H0?ofkP800000o`3om^hT0?ofkP40oooo002/0?ofkP030000003om^h0ooK^00@0ooK^
00<000000?ofkP3om^h06P3om^h200000?l0ooK^8P3om^h10?ooo`00Z`3om^h00`000000ooK^0?of
kP050?ofkP030000003om^h0ooK^01`0ooK^0P00003o0?ofkR00ooK^0@3oool00:/0ooK^00<00000
0?ofkP3om^h01@3om^h00`000000ooK^0?ofkP0N0?ofkP800000o`3om^hN0?ofkP40oooo002Z0?of
kP030000003om^h0ooK^00H0ooK^00<000000?ofkP3om^h0803om^h200000?l0ooK^703om^h10?oo
o`00ZP3om^h00`000000ooK^0?ofkP060?ofkP030000003om^h0ooK^0280ooK^0`00003o0?ofkQT0
ooK^0@3oool00:T0ooK^00<000000?ofkP3om^h01`3om^h00`000000ooK^0?ofkP0U0?ofkP800000
o`3om^hG0?ofkP40oooo002X0?ofkP030000003om^h0ooK^00L0ooK^00<000000?ofkP3om^h0:03o
m^h200000?l0ooK^5@3om^h10?ooo`00Z03om^h00`000000ooK^0?ofkP070?ofkP030000003om^h0
ooK^02X0ooK^0P00003o0?ofkQ<0ooK^0@3oool00:L0ooK^00<000000?ofkP3om^h0203om^h00`00
0000ooK^0?ofkP0/0?ofkP800000o`3om^hA0?ofkP40oooo002W0?ofkP030000003om^h0ooK^00P0
ooK^00<000000?ofkP3om^h0;P3om^h200000?l0ooK^3`3om^h10?ooo`00YP3om^h00`000000ooK^
0?ofkP090?ofkP030000003om^h0ooK^0300ooK^0`00003o0?ofkP`0ooK^0@3oool00:D0ooK^00<0
00000?ofkP3om^h02P3om^h00`000000ooK^0?ofkP0c0?ofkP800000o`3om^h:0?ofkP40oooo002U
0?ofkP030000003om^h0ooK^00X0ooK^00<000000?ofkP3om^h0=@3om^h200000?l0ooK^203om^h1
0?ooo`00Y03om^h00`000000ooK^0?ofkP0;0?ofkP030000003om^h0ooK^03L0ooK^0P00003o0?of
kPH0ooK^0@3oool00:@0ooK^00<000000?ofkP3om^h02`3om^h00`000000ooK^0?ofkP0i0?ofkP80
0000o`3om^h40?ofkP40oooo002S0?ofkP030000003om^h0ooK^00`0ooK^00<000000?ofkP3om^h0
>`3om^h300000?l0ooK^0@3om^h10?ooo`00XP3om^h00`000000ooK^0?ofkP0=0?ofkP030000003o
m^h0ooK^03h0ooK^0P00003n0?ofkP40oooo002R0?ofkP030000003om^h0ooK^00d0ooK^00<00000
0?ofkP3om^h0@03om^h200000?`0ooK^0@3oool00:40ooK^00<000000?ofkP3om^h03P3om^h00`00
0000ooK^0?ofkP120?ofkP800000nP3om^h10?ooo`00X@3om^h00`000000ooK^0?ofkP0=0?ofkP03
0000003om^h0ooK^04D0ooK^0P00003h0?ofkP40oooo002P0?ofkP030000003om^h0ooK^00h0ooK^
00<000000?ofkP3om^h0A`3om^h200000?H0ooK^0@3oool009l0ooK^00<000000?ofkP3om^h03`3o
m^h00`000000ooK^0?ofkP190?ofkP<00000l`3om^h10?ooo`00W`3om^h00`000000ooK^0?ofkP0?
0?ofkP030000003om^h0ooK^04`0ooK^0P00003a0?ofkP40oooo002N0?ofkP030000003om^h0ooK^
0100ooK^00<000000?ofkP3om^h0CP3om^h200000>l0ooK^0@3oool009h0ooK^00<000000?ofkP3o
m^h0403om^h00`000000ooK^0?ofkP1@0?ofkP800000k@3om^h10?ooo`00W@3om^h00`000000ooK^
0?ofkP0A0?ofkP030000003om^h0ooK^0580ooK^0P00003[0?ofkP40oooo002L0?ofkP030000003o
m^h0ooK^0180ooK^00<000000?ofkP3om^h0E03om^h200000>T0ooK^0@3oool009`0ooK^00<00000
0?ofkP3om^h04P3om^h00`000000ooK^0?ofkP1F0?ofkP<00000iP3om^h10?ooo`00V`3om^h00`00
0000ooK^0?ofkP0C0?ofkP030000003om^h0ooK^05T0ooK^0P00003T0?ofkP40oooo002J0?ofkP03
0000003om^h0ooK^01@0ooK^00<000000?ofkP3om^h0F`3om^h200000>80ooK^0@3oool009X0ooK^
00<000000?ofkP3om^h0503om^h00`000000ooK^0?ofkP1M0?ofkP800000h03om^h10?ooo`00V@3o
m^h00`000000ooK^0?ofkP0E0?ofkP030000003om^h0ooK^05l0ooK^0P00003N0?ofkP40oooo002I
0?ofkP030000003om^h0ooK^01@0ooK^00<000000?ofkP3om^h0HP3om^h200000=`0ooK^0@3oool0
09P0ooK^00<000000?ofkP3om^h05@3om^h00`000000ooK^0?ofkP1T0?ofkP<00000f@3om^h10?oo
o`00U`3om^h00`000000ooK^0?ofkP0F0?ofkP030000003om^h0ooK^06L0ooK^0P00003G0?ofkP40
oooo002G0?ofkP030000003om^h0ooK^01H0ooK^00<000000?ofkP3om^h0J@3om^h200000=D0ooK^
0@3oool009H0ooK^00<000000?ofkP3om^h05`3om^h00`000000ooK^0?ofkP1[0?ofkP800000d`3o
m^h10?ooo`00UP3om^h00`000000ooK^0?ofkP0G0?ofkP030000003om^h0ooK^06d0ooK^0P00003A
0?ofkP40oooo002E0?ofkP030000003om^h0ooK^01P0ooK^00<000000?ofkP3om^h0K`3om^h30000
0<h0ooK^0@3oool009@0ooK^00<000000?ofkP3om^h06@3om^h00`000000ooK^0?ofkP1b0?ofkP80
0000c03om^h10?ooo`00U03om^h00`000000ooK^0?ofkP0I0?ofkP030000003om^h0ooK^07@0ooK^
0P00003:0?ofkP40oooo002C0?ofkP030000003om^h0ooK^01X0ooK^00<000000?ofkP3om^h0MP3o
m^h200000<P0ooK^0@3oool009<0ooK^00<000000?ofkP3om^h06P3om^h00`000000ooK^0?ofkP1h
0?ofkP800000aP3om^h10?ooo`00TP3om^h00`000000ooK^0?ofkP0K0?ofkP030000003om^h0ooK^
07X0ooK^0P0000340?ofkP40oooo002A0?ofkP030000003om^h0ooK^01/0ooK^00<000000?ofkP3o
m^h0O@3om^h300000<40ooK^0@3oool00940ooK^00<000000?ofkP3om^h06`3om^h00`000000ooK^
0?ofkP200?ofkP800000_`3om^h10?ooo`00T03om^h00`000000ooK^0?ofkP0L0?ofkP030000003o
m^h0ooK^0880ooK^0P00002m0?ofkP40oooo002@0?ofkP030000003om^h0ooK^01`0ooK^00<00000
0?ofkP3om^h0Q03om^h200000;/0ooK^0@3oool008l0ooK^00<000000?ofkP3om^h07@3om^h00`00
0000ooK^0?ofkP260?ofkP800000^@3om^h10?ooo`00SP3om^h00`000000ooK^0?ofkP0N0?ofkP03
0000003om^h0ooK^08P0ooK^0P00002g0?ofkP40oooo002>0?ofkP030000003om^h0ooK^01h0ooK^
00<000000?ofkP3om^h0RP3om^h300000;@0ooK^0@3oool008d0ooK^00<000000?ofkP3om^h07`3o
m^h00`000000ooK^0?ofkP2=0?ofkP800000/P3om^h10?ooo`00S03om^h00`000000ooK^0?ofkP0P
0?ofkP030000003om^h0ooK^08l0ooK^0P00002`0?ofkP40oooo002<0?ofkP030000003om^h0ooK^
0200ooK^00<000000?ofkP3om^h0T@3om^h200000:h0ooK^0@3oool008/0ooK^00<000000?ofkP3o
m^h08@3om^h00`000000ooK^0?ofkP2C0?ofkP800000[03om^h10?ooo`00R`3om^h00`000000ooK^
0?ofkP0Q0?ofkP030000003om^h0ooK^09D0ooK^0`00002Y0?ofkP40oooo002:0?ofkP030000003o
m^h0ooK^0280ooK^00<000000?ofkP3om^h0V03om^h200000:L0ooK^0@3oool008T0ooK^00<00000
0?ofkP3om^h08P3om^h00`000000ooK^0?ofkP2K0?ofkP800000Y@3om^h10?ooo`00R@3om^h00`00
0000ooK^0?ofkP0R0?ofkP030000003om^h0ooK^09d0ooK^0P00002S0?ofkP40oooo00280?ofkP03
0000003om^h0ooK^02<0ooK^00<000000?ofkP3om^h0MP3om^h90=@m6B00ooK^0P00002Q0?ofkP40
oooo00280?ofkP030000003om^h0ooK^02<0ooK^00<000000?ofkP3om^h0L03om^h60=@m6@030?of
kP3D?AT0ooK^00H0ooK^203D?ATJ0?ofkP800000W`3om^h10?ooo`00Q`3om^h00`000000ooK^0?of
kP0T0?ofkP030000003om^h0ooK^06/0ooK^1@3D?AT60?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0
e3dI0?ofkP3om^h0103D?ATH0?ofkP<00000W03om^h10?ooo`00QP3om^h00`000000ooK^0?ofkP0U
0?ofkP030000003om^h0ooK^06T0ooK^0`3D?AT90?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI
0?ofkP3om^h01@3om^h30=@m6AP0ooK^0P00002J0?ofkP40oooo00260?ofkP030000003om^h0ooK^
02D0ooK^00<000000?ofkP3om^h0IP3om^h30=@m6@030?ofkP3D?AT0ooK^00T0ooK^00<0e3dI0?of
kP3om^h02P3om^h00`3D?AT0ooK^0?ofkP090?ofkP@0e3dI5P3om^h2000009P0ooK^0@3oool008D0
ooK^00<000000?ofkP3om^h09P3om^h00`000000ooK^0?ofkP1T0?ofkP80e3dI0`3om^h00`3D?AT0
ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h03@3om^h30=@m6AD0
ooK^0P00002F0?ofkP40oooo00250?ofkP030000003om^h0ooK^02H0ooK^00<000000?ofkP3om^h0
HP3om^h20=@m6@D0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m
6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h00P3D?ATE0?ofkP800000U03om^h10?ooo`00Q03o
m^h00`000000ooK^0?ofkP0W0?ofkP030000003om^h0ooK^0640ooK^00<0e3dI0?ofkP3om^h0103o
m^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h03P3o
m^h00`3D?AT0ooK^0?ofkP030?ofkP80e3dI5@3om^h200000980ooK^0@3oool008<0ooK^00<00000
0?ofkP3om^h0:03om^h00`000000ooK^0?ofkP1P0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI
0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI
0?ofkP3om^h01P3om^h30=@m6A@0ooK^0`00002?0?ofkP40oooo00230?ofkP030000003om^h0ooK^
02P0ooK^00<000000?ofkP3om^h0G`3om^h20=@m6@D0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D
?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h02@3om^h20=@m
6AD0ooK^0P00002=0?ofkP40oooo00220?ofkP030000003om^h0ooK^02T0ooK^00<000000?ofkP3o
m^h0GP3om^h20=@m6@D0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP03
0=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h0303om^h20=@m6AD0ooK^0P00002;0?ofkP40
oooo00220?ofkP030000003om^h0ooK^02P0ooK^00<000000?ofkP3om^h0GP3om^h20=@m6@D0ooK^
00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00l0ooK^
00<0e3dI0?ofkP3om^h03`3om^h20=@m6AD0ooK^0P0000290?ofkP40oooo00210?ofkP030000003o
m^h0ooK^02T0ooK^00<000000?ofkP3om^h0G@3om^h20=@m6@D0ooK^00<0e3dI0?ofkP3om^h0203o
m^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h0403o
m^h0103D?AT0ooK^0=@m6@3D?ATE0?ofkP800000Q`3om^h10?ooo`00P03om^h00`000000ooK^0?of
kP0Z0?ofkP030000003om^h0ooK^05`0ooK^0P3D?AT50?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0
e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^0100ooK^00<0
e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP0D0?ofkP<00000Q03om^h10?ooo`00P03om^h0
0`000000ooK^0?ofkP0Z0?ofkP030000003om^h0ooK^05/0ooK^0P3D?AT60?ofkP030=@m6@3om^h0
ooK^00L0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0
ooK^0100ooK^00<0e3dI0?ofkP3om^h0103om^h20=@m6AL0ooK^0P0000220?ofkP40oooo001o0?of
kP030000003om^h0ooK^02/0ooK^00<000000?ofkP3om^h0FP3om^h30=@m6@D0ooK^00<0e3dI0?of
kP3om^h01@3om^h90=@m6@L0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0@0?of
kP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h05P3om^h200000800ooK^0@3oool007l0
ooK^00<000000?ofkP3om^h0:`3om^h00`000000ooK^0?ofkP1I0?ofkP<0e3dI1@3om^h00`3D?AT0
ooK^0?ofkP060=@m6@030?ofkP3D?AT0ooK^00H0ooK^203D?AT?0?ofkP030=@m6@3om^h0ooK^0100
ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP0G0?ofkP800000OP3om^h10?ooo`00
OP3om^h00`000000ooK^0?ofkP0/0?ofkP030000003om^h0ooK^05T0ooK^0P3D?AT50?ofkP@0e3dI
1P3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00@0e3dI2`3om^h00`3D?AT0ooK^
0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00/0ooK^0P3D?ATI0?ofkP800000O03om^h10?ooo`00O@3o
m^h00`000000ooK^0?ofkP0]0?ofkP030000003om^h0ooK^05P0ooK^0P3D?AT40?ofkP80e3dI2P3o
m^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00D0ooK^0`3D?AT70?ofkP030=@m6@3o
m^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0H0?ofkP800000NP3o
m^h10?ooo`00O@3om^h00`000000ooK^0?ofkP0]0?ofkP030000003om^h0ooK^05L0ooK^0`3D?AT2
0?ofkP<0e3dI2P3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00P0ooK^103D?AT2
0?ofkP030=@m6@3om^h0ooK^0100ooK^00<0e3dI0?ofkP3om^h03`3om^h20=@m6AX0ooK^0`00001g
0?ofkP40oooo001l0?ofkP030000003om^h0ooK^02h0ooK^00<000000?ofkP3om^h0EP3om^h00`3D
?AT0ooK^0=@m6@030=@m6@80ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP0;0?of
kP030=@m6@3om^h0ooK^00d0ooK^0`3D?ATA0?ofkP030=@m6@3om^h0ooK^0180ooK^00<0e3dI0?of
kP3om^h06P3om^h2000007D0ooK^0@3oool007/0ooK^00<000000?ofkP3om^h0;`3om^h00`000000
ooK^0?ofkP1F0?ofkP@0e3dI0`3om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00/0
ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP020=@m6@h0ooK^00<0e3dI0?ofkP3o
m^h04P3om^h00`3D?AT0ooK^0=@m6@0M0?ofkP800000L`3om^h10?ooo`00N`3om^h00`000000ooK^
0?ofkP0_0?ofkP030000003om^h0ooK^05D0ooK^103D?AT30?ofkP030=@m6@3om^h0ooK^00L0ooK^
00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00<0ooK^
0P3D?AT;0?ofkP030=@m6@3om^h0ooK^0180ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0N0?ofkP80
0000L@3om^h10?ooo`00NP3om^h00`000000ooK^0?ofkP0_0?ofkP030000003om^h0ooK^05D0ooK^
0P3D?AT00`3om^h0e3dI0?ofkP020?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h0
2P3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00H0ooK^0P3D?AT80?ofkP030=@m
6@3om^h0ooK^0180ooK^00<0e3dI0?ofkP3om^h00`3om^h20=@m6Ah0ooK^0P00001_0?ofkP40oooo
001j0?ofkP030000003om^h0ooK^02l0ooK^00<000000?ofkP3om^h0E03om^h20=@m6@80ooK^00@0
e3dI0?ofkP3om^h0e3dI2P3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00d0ooK^
00<0e3dI0?ofkP3om^h02@3om^h20=@m6@D0ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^
0?ofkP050?ofkP030=@m6@3om^h0ooK^01d0ooK^0P00001]0?ofkP40oooo001i0?ofkP030000003o
m^h0ooK^0300ooK^00<000000?ofkP3om^h0E03om^h20=@m6@030?ofkP3D?AT0e3dI0080ooK^00<0
e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0
e3dI0?ofkP3om^h0303om^h20=@m6@80ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?of
kP070?ofkP030=@m6@3om^h0ooK^01h0ooK^0`00001Z0?ofkP40oooo001h0?ofkP030000003om^h0
ooK^0340ooK^00<000000?ofkP3om^h0D`3om^h20=@m6@060?ofkP3D?AT0ooK^0=@m6@3om^h0e3dI
2@3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h0
3`3om^h20=@m6AD0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP0P0?ofkP800000
J03om^h10?ooo`00N03om^h00`000000ooK^0?ofkP0a0?ofkP030000003om^h0ooK^0580ooK^0P3D
?AT20?ofkP80e3dI00<0ooK^0=@m6@3om^h0203om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3o
m^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h0403om^h0103D?AT0ooK^0=@m6@3D?ATB0?ofkP030=@m
6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h08@3om^h2000006H0ooK^0@3oool007L0ooK^00<0
00000?ofkP3om^h0<P3om^h00`000000ooK^0?ofkP1A0?ofkP80e3dI0P3om^h0103D?AT0ooK^0=@m
6@3D?AT:0?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^
0?ofkP0?0?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^
0?ofkP0=0?ofkP80e3dI8`3om^h2000006@0ooK^0@3oool007L0ooK^00<000000?ofkP3om^h0<P3o
m^h00`000000ooK^0?ofkP1A0?ofkP040=@m6@3om^h0ooK^0=@m6@80ooK^00<0e3dI0?ofkP3om^h0
203om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h0
3`3om^h00`3D?AT0ooK^0?ofkP040?ofkP80e3dI3@3om^h00`3D?AT0ooK^0?ofkP0@0?ofkP030=@m
6@3om^h0ooK^0280ooK^0P00001R0?ofkP40oooo001f0?ofkP030000003om^h0ooK^03<0ooK^00<0
00000?ofkP3om^h0D03om^h20=@m6@030?ofkP3D?AT0ooK^0080ooK^00<0e3dI0?ofkP3om^h01@3o
m^h90=@m6@L0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0@0?ofkP030=@m6@3o
m^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP0B0?ofkP030=@m6@3o
m^h0ooK^02<0ooK^0P00001P0?ofkP40oooo001e0?ofkP030000003om^h0ooK^03@0ooK^00<00000
0?ofkP3om^h0C`3om^h20=@m6@030?ofkP3D?AT0ooK^0080ooK^0P3D?AT00`3om^h0e3dI0=@m6@04
0=@m6@030?ofkP3D?AT0ooK^00H0ooK^2@3D?AT=0?ofkP030=@m6@3om^h0ooK^0100ooK^00<0e3dI
0?ofkP3om^h0203om^h20=@m6@P0ooK^00<0e3dI0?ofkP3om^h0503om^h00`3D?AT0ooK^0?ofkP0T
0?ofkP<00000G@3om^h10?ooo`00M@3om^h00`000000ooK^0?ofkP0=0?ofkP@0?EV[8`3om^h00`00
0000ooK^0?ofkP1>0?ofkP80e3dI00<0ooK^0=@m6@3om^h00P3om^h40=@m6@H0ooK^00<0e3dI0?of
kP3om^h02`3om^h0103D?AT0ooK^0?ofkP3om^h40=@m6@P0ooK^00<0e3dI0?ofkP3om^h0403om^h0
0`3D?AT0ooK^0?ofkP0;0?ofkP80e3dI1P3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0
e3dI02P0ooK^0P00001K0?ofkP40oooo001d0?ofkP030000003om^h0ooK^00/0ooK^0`0mFJ/30?of
kP<0?EV[8@3om^h00`000000ooK^0?ofkP1>0?ofkP050=@m6@3om^h0ooK^0=@m6@3om^h00P3D?AT0
0`3om^h0e3dI0?ofkP060?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h01P3om^h4
0=@m6@<0ooK^00<0e3dI0?ofkP3om^h0403om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0
ooK^0080ooK^00<0e3dI0?ofkP3om^h04`3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI02T0ooK^0P00
001I0?ofkP40oooo001d0?ofkP030000003om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h00P0mFJ/4
0?ofkP@0?EV[7P3om^h00`000000ooK^0?ofkP1=0?ofkP80e3dI00<0ooK^0=@m6@3D?AT00P3D?AT2
0?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP0;
0?ofkP@0e3dI4@3om^h00`3D?AT0ooK^0?ofkP0@0?ofkP80e3dI00<0ooK^0=@m6@3om^h0503om^h0
0`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^02P0ooK^0P00001G0?ofkP40oooo001c0?of
kP030000003om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h00`3om^h203eIZ`80ooK^00<0?EV[0?of
kP0mFJ/0100mFJ/K0?ofkP030000003om^h0ooK^04`0ooK^0P3D?AT00`3om^h0e3dI0=@m6@020?of
kP040=@m6@3om^h0ooK^0=@m6@H0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP0<
0?ofkP030=@m6@3om^h0ooK^0080e3dI3P3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0
ooK^01<0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP0Y0?ofkP800000E@3om^h1
0?ooo`00LP3om^h00`000000ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00H0ooK^100mFJ/30?of
kP@0?EV[603om^h00`000000ooK^0?ofkP1<0?ofkP@0e3dI0`3om^h01@3D?AT0ooK^0?ofkP3om^h0
e3dI00D0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0
ooK^00<0ooK^0P3D?AT;0?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3D?AT04`3om^h0
0`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^02X0ooK^0`00001B0?ofkP40oooo001b0?of
kP030000003om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h02P3om^h203eIZ`@0ooK^1@0mFJ/E0?of
kP030000003om^h0ooK^04/0ooK^103D?AT30?ofkP040=@m6@3om^h0ooK^0?ofkP80e3dI103om^h0
0`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h01P3om^h3
0=@m6@P0ooK^00<0e3dI0?ofkP3om^h04P3om^h0103D?AT0ooK^0?ofkP3om^h20=@m6A00ooK^00<0
e3dI0?ofkP3om^h02@3om^h20=@m6Bd0ooK^0P00001@0?ofkP40oooo001a0?ofkP030000003om^h0
ooK^00T0ooK^0P0mFJ/=0?ofkP<0?EV[1@3om^h503eIZa80ooK^00<000000?ofkP3om^h0B`3om^h0
103D?AT0ooK^0=@m6@3D?AT20?ofkP070=@m6@3om^h0ooK^0?ofkP3D?AT0ooK^0=@m6@030?ofkP03
0=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP090?ofkP80
e3dI1@3om^h00`3D?AT0ooK^0?ofkP0B0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3o
m^h0303om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^02`0ooK^0P00001>0?ofkP40
oooo001a0?ofkP030000003om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h00P0mFJ/;0?ofkP80?EV[
00@0ooK^03eIZ`0mFJ/0?EV[1@3om^h403eIZa00ooK^00<000000?ofkP3om^h0BP3om^h0103D?AT0
ooK^0=@m6@3D?AT20?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3D?AT00P3om^h00`3D
?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h0303om^h20=@m
6@80ooK^00<0e3dI0?ofkP3om^h04P3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^
00/0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0]0?ofkP800000C03om^h10?oo
o`00L03om^h00`000000ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00<0ooK^0`0mFJ/80?ofkP04
03eIZ`3om^h0?EV[03eIZ`80ooK^0P0mFJ/60?ofkP@0?EV[3@3om^h00`000000ooK^0?ofkP190?of
kP80e3dI00<0ooK^0=@m6@3om^h00P3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00<0ooK^0P3D?AT=
0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h03`3om^h20=@m6A@0ooK^00<0e3dI
0?ofkP3om^h0203om^h20=@m6@X0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP0^
0?ofkP800000BP3om^h10?ooo`00K`3om^h00`000000ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^
00H0ooK^0P0mFJ/60?ofkP0403eIZ`3om^h0ooK^0?ofkP<0?EV[00<0ooK^03eIZ`0mFJ/00`3om^h2
03eIZ`030?ofkP0mFJ/0?EV[0080?EV[2`3om^h00`000000ooK^0?ofkP180?ofkP80e3dI00<0ooK^
0=@m6@3D?AT00P3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00@0ooK^0P3D?AT<0?ofkP030=@m6@3o
m^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h0403om^h0103D?AT0ooK^0=@m6@3D?ATA0?ofkP030=@m
6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP0A0?ofkP030=@m
6@3om^h0ooK^02l0ooK^0P0000180?ofkP40oooo001_0?ofkP030000003om^h0ooK^00P0ooK^00<0
?EV[0?ofkP3om^h02@3om^h303eIZ`<0ooK^00<0?EV[0?ofkP3om^h0103om^h203eIZ`040?ofkP0m
FJ/0?EV[03eIZ`H0ooK^100mFJ/80?ofkP030000003om^h0ooK^04L0ooK^0P3D?AT01P3om^h0e3dI
0?ofkP3D?AT0ooK^0=@m6@<0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP0;0?of
kP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h0403om^h00`3D?AT0ooK^0?ofkP020?of
kP80e3dI3P3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?of
kP3om^h04`3om^h00`3D?AT0ooK^0?ofkP0`0?ofkP<00000A@3om^h10?ooo`00KP3om^h00`000000
ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00d0ooK^0P0mFJ/00`3om^h0?EV[0?ofkP070?ofkP<0
?EV[00<0ooK^03eIZ`0mFJ/01@3om^h00`0mFJ/0ooK^03eIZ`0303eIZ`D0ooK^00<000000?ofkP3o
m^h0A`3om^h00`3D?AT0ooK^0?ofkP020=@m6@030?ofkP3D?AT0ooK^0080ooK^00<0e3dI0?ofkP3o
m^h00`3om^h20=@m6@`0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP0@0?ofkP03
0=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP80
e3dI0`3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0e3dI03@0ooK^0P0000130?ofkP40
oooo001]0?ofkP030000003om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h0403om^h303eIZ`H0ooK^
00@0?EV[0?ofkP3om^h0ooK^1P0mFJ/30?ofkP0303eIZ`3om^h0ooK^00@0?EV[0`3om^h00`000000
ooK^0?ofkP160?ofkP050=@m6@3om^h0ooK^0=@m6@3om^h00P3D?AT30?ofkP030=@m6@3om^h0ooK^
0080ooK^203D?AT70?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h04@3om^h00`3D
?AT0ooK^0?ofkP060?ofkP80e3dI2@3om^h00`3D?AT0ooK^0?ofkP0B0?ofkP030=@m6@3om^h0e3dI
01D0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0e0?ofkP800000@@3om^h10?ooo`00K@3om^h00`00
0000ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^0180ooK^0`0mFJ/20?ofkP80?EV[1`3om^h203eI
Z`030?ofkP0mFJ/0?EV[0080?EV[1@3om^h403eIZ`030000003om^h0ooK^04D0ooK^0P3D?AT0103o
m^h0e3dI0?ofkP3om^h20=@m6@<0ooK^1P3D?AT20?ofkP030=@m6@3om^h0ooK^0080ooK^2@3D?AT=
0?ofkP030=@m6@3om^h0ooK^0100ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP05
0?ofkP030=@m6@3om^h0ooK^01@0ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP03
0?ofkP030=@m6@3om^h0ooK^03@0ooK^0P00000o0?ofkP40oooo001/0?ofkP030000003om^h0ooK^
00P0ooK^0P0mFJ/D0?ofkP0303eIZ`3om^h0ooK^00<0?EV[2P3om^h303eIZ`030?ofkP0mFJ/0?EV[
00L0ooK^00@0?EV[0000000mFJ/0?EV[A03om^h20=@m6@030?ofkP3D?AT0ooK^0080ooK^00<0e3dI
0?ofkP3D?AT00`3D?AT30?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT02@3om^h0103D?AT0ooK^0?of
kP3om^h40=@m6@P0ooK^00<0e3dI0?ofkP3om^h0403om^h00`3D?AT0ooK^0?ofkP0;0?ofkP80e3dI
103om^h00`3D?AT0ooK^0?ofkP0D0?ofkP030=@m6@3om^h0e3dI01<0ooK^00<0e3dI0?ofkP3om^h0
103om^h00`3D?AT0ooK^0?ofkP0f0?ofkP800000?@3om^h10?ooo`00K03om^h00`000000ooK^0?of
kP070?ofkP0303eIZ`3om^h0ooK^00<0?EV[4@3om^h0100mFJ/0ooK^0?ofkP0mFJ/20?ofkP80?EV[
2`3om^h603eIZ`D0ooK^00<0000003eIZ`0mFJ/00P0mFJ]10?ofkP80e3dI00<0ooK^0=@m6@3om^h0
0P3om^h30=@m6@030?ofkP3D?AT0ooK^00@0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@080?ofkP03
0=@m6@3om^h0ooK^00H0ooK^103D?AT30?ofkP030=@m6@3om^h0ooK^0100ooK^00<0e3dI0?ofkP3o
m^h03P3om^h20=@m6@030?ofkP3D?AT0ooK^01D0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0A0?of
kP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h0=`3om^h2000003/0ooK^0@3oool006/0
ooK^00<000000?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP030?ofkP<0?EV[3P3om^h303eIZ`D0
ooK^0`0mFJ/:0?ofkP<0?EV[00@0ooK^03eIZ`0mFJ/0?EV[0P3om^h010000000ooK^0?ofkP3om^h4
03eIZcd0ooK^0P3D?AT20?ofkP080=@m6@3om^h0e3dI0=@m6@3om^h0e3dI0?ofkP3D?AT50?ofkP03
0=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP0;0?ofkP@0
e3dI4@3om^h00`3D?AT0ooK^0?ofkP0A0?ofkP030=@m6@3om^h0ooK^01@0ooK^00<0e3dI0?ofkP3o
m^h00`3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3o
m^h0>03om^h3000003P0ooK^0@3oool006X0ooK^00<000000?ofkP3om^h0203om^h00`0mFJ/0ooK^
0?ofkP070?ofkP80?EV[303om^h503eIZ`H0ooK^0`0mFJ/80?ofkP0403eIZ`3om^h0?EV[03eIZ`80
ooK^00<0?EV[0000003om^h00P3om^h203eIZ`80ooK^0`0mFJ/k0?ofkP80e3dI00<0ooK^0=@m6@3D
?AT00P3D?AT0103om^h0e3dI0?ofkP3D?AT50?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?of
kP3om^h0103om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^0080e3dI3P3om^h00`3D
?AT0ooK^0?ofkP0A0?ofkP030=@m6@3om^h0e3dI01@0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D
?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h0>P3om^h20000
03H0ooK^0@3oool006X0ooK^00<000000?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP<0
?EV[2@3om^h203eIZ`<0ooK^0`0mFJ/60?ofkP80?EV[1P3om^h0100mFJ/0ooK^0?ofkP3om^h303eI
Z`040000000mFJ/0?EV[03eIZ`H0ooK^100mFJ/g0?ofkP80e3dI00<0ooK^0=@m6@3D?AT00P3om^h0
1@3D?AT0ooK^0=@m6@3om^h0e3dI00@0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?of
kP030?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h00`3om^h20=@m6@/0ooK^00<0
e3dI0?ofkP3om^h04@3om^h0103D?AT0ooK^0?ofkP3om^h20=@m6A40ooK^00<0e3dI0?ofkP3om^h0
1`3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h0
>`3om^h2000003@0ooK^0@3oool006T0ooK^00<000000?ofkP3om^h0203om^h00`0mFJ/0ooK^0?of
kP0=0?ofkP<0?EV[1P3om^h00`0mFJ/0ooK^0?ofkP050?ofkP<0?EV[1@3om^h303eIZ`<0ooK^00<0
?EV[0?ofkP3om^h0103om^h010000000?EV[03eIZ`3om^h203eIZ`D0ooK^00<0?EV[0?ofkP0mFJ/0
0P0mFJ/d0?ofkP@0e3dI0`3om^h00`3D?AT0ooK^0?ofkP020=@m6@@0ooK^00<0e3dI0?ofkP3om^h0
1P3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h0
1@3om^h30=@m6@P0ooK^00<0e3dI0?ofkP3om^h0403om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m
6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h02@3om^h20=@m6@T0ooK^00<0e3dI0?ofkP3om^h0
3@3om^h00`3D?AT0ooK^0?ofkP0l0?ofkP800000<P3om^h10?ooo`00J@3om^h00`000000ooK^0?of
kP070?ofkP0303eIZ`3om^h0ooK^0140ooK^0`0mFJ/20?ofkP80?EV[2P3om^h203eIZ`H0ooK^100m
FJ/50?ofkP0403eIZ`000000ooK^0?ofkP80?EV[00@0ooK^03eIZ`0mFJ/0?EV[0`3om^h00`0mFJ/0
ooK^0?ofkP0403eIZc00ooK^103D?AT30?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT01@3om^h00`3D
?AT0ooK^0?ofkP050?ofkP80e3dI0`3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^
00T0ooK^0P3D?AT50?ofkP030=@m6@3om^h0ooK^0140ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D
?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D
?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^03h0ooK^0P00000`0?ofkP40oooo001X0?ofkP03
0000003om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h05@3om^h403eIZ``0ooK^0`0mFJ/60?ofkP80
?EV[0P3om^h203eIZ`030?ofkP000000ooK^00<0ooK^0`0mFJ/01@3om^h0?EV[03eIZ`3om^h0?EV[
00@0ooK^100mFJ/]0?ofkP80e3dI00<0ooK^0=@m6@3D?AT00P3om^h0103D?AT0ooK^0?ofkP3om^h2
0=@m6@@0ooK^00<0e3dI0?ofkP3om^h01@3om^h01P3D?AT0ooK^0?ofkP3D?AT0ooK^0=@m6@l0ooK^
00<0e3dI0?ofkP3om^h0303om^h20=@m6@80ooK^00<0e3dI0?ofkP3om^h04@3om^h00`3D?AT0ooK^
0?ofkP070?ofkP80e3dI2P3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00<0ooK^
00<0e3dI0?ofkP3om^h0403om^h00`3D?AT0ooK^0?ofkP0o0?ofkP<00000;@3om^h10?ooo`00I`3o
m^h00`000000ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^01D0ooK^00<0?EV[0?ofkP3om^h00P0m
FJ/>0?ofkP<0?EV[103om^h403eIZ`80ooK^00<000000?ofkP3om^h01@3om^h603eIZ`H0ooK^100m
FJ/Y0?ofkP80e3dI00<0ooK^0=@m6@3D?AT00P3om^h01`3D?AT0ooK^0?ofkP3om^h0e3dI0?ofkP3D
?AT00`3om^h00`3D?AT0ooK^0?ofkP050?ofkP040=@m6@3om^h0ooK^0?ofkP80e3dI3`3om^h00`3D
?AT0ooK^0?ofkP0?0?ofkP80e3dI4`3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^
00H0ooK^00<0e3dI0?ofkP3om^h0403om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI01@0ooK^00<0e3dI
0?ofkP3om^h0@@3om^h2000002/0ooK^0@3oool006L0ooK^00<000000?ofkP3om^h01`3om^h203eI
ZaL0ooK^00D0?EV[0?ofkP3om^h0?EV[0?ofkP0303eIZ`h0ooK^0`0mFJ/00`3om^h0?EV[03eIZ`02
0?ofkP80?EV[00<000000?ofkP3om^h0203om^h503eIZ`H0ooK^100mFJ/V0?ofkP<0e3dI00<0ooK^
0=@m6@3om^h00P3om^h01`3D?AT0ooK^0?ofkP3om^h0e3dI0?ofkP3D?AT00P3om^h00`3D?AT0ooK^
0?ofkP060?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT03`3om^h00`3D?AT0ooK^0?ofkP0@0?ofkP04
0=@m6@3om^h0e3dI0=@m6A00ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP040?of
kP030=@m6@3om^h0ooK^0180ooK^00<0e3dI0?ofkP3D?AT05P3om^h00`3D?AT0ooK^0?ofkP120?of
kP800000:@3om^h10?ooo`00IP3om^h00`000000ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^0080
?EV[503om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00@0ooK^0P0mFJ/?0?ofkP<0?EV[103om^h00`00
0000?EV[0?ofkP0:0?ofkPH0?EV[1@3om^h503eIZb<0ooK^0P3D?AT00`3om^h0e3dI0=@m6@020?of
kP050=@m6@3om^h0ooK^0?ofkP3D?AT00`3om^h00`3D?AT0ooK^0=@m6@070?ofkP030=@m6@3om^h0
ooK^0080ooK^0P3D?AT>0?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h00P3om^h2
0=@m6@d0ooK^00<0e3dI0?ofkP3om^h03P3om^h20=@m6@<0ooK^00<0e3dI0?ofkP3om^h0503om^h0
0`3D?AT0ooK^0?ofkP0D0?ofkP030=@m6@3om^h0e3dI04D0ooK^0P00000W0?ofkP40oooo001V0?of
kP030000003om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h00P3om^h303eIZa40ooK^00D0?EV[0?of
kP3om^h0ooK^03eIZ`060?ofkP<0?EV[303om^h203eIZ`030?ofkP0mFJ/0?EV[0080ooK^00<00000
0?ofkP0mFJ/00P0mFJ/90?ofkP0503eIZ`3om^h0?EV[03eIZ`3om^h00P0mFJ/30?ofkP80?EV[00<0
ooK^03eIZ`0mFJ/00P0mFJ/P0?ofkP80e3dI00H0ooK^0=@m6@3om^h0e3dI0?ofkP3D?AT30?ofkP03
0=@m6@3om^h0ooK^0080ooK^0P3D?AT70?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3D
?AT03@3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3o
m^h02@3om^h00`3D?AT0ooK^0?ofkP0A0?ofkP030=@m6@3om^h0e3dI01H0ooK^00<0e3dI0?ofkP3D
?AT0503om^h0103D?AT0ooK^0?ofkP3D?AU70?ofkP8000009@3om^h10?ooo`00I@3om^h00`000000
ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00H0ooK^0P0mFJ/>0?ofkP0303eIZ`3om^h0ooK^0080
ooK^00<0?EV[0?ofkP3om^h01`3om^h203eIZ`T0ooK^00<0?EV[0?ofkP0mFJ/00`3om^h203eIZ`03
0000003om^h0ooK^0080ooK^0P0mFJ/70?ofkP0403eIZ`3om^h0ooK^0?ofkPH0?EV[1@3om^h503eI
Za`0ooK^0P3D?AT20?ofkP80e3dI00<0ooK^0=@m6@3om^h00P3om^h00`3D?AT0ooK^0?ofkP020?of
kPL0e3dI0P3om^h00`3D?AT0ooK^0?ofkP020?ofkP040=@m6@3om^h0ooK^0=@m6@`0ooK^00<0e3dI
0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP070?ofkP80e3dI203om^h00`3D?AT0ooK^0?ofkP0C
0?ofkP030=@m6@3om^h0ooK^01@0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0B0?ofkP030=@m6@3o
m^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h0AP3om^h2000002<0ooK^0@3oool006@0ooK^00<00000
0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP080?ofkP<0?EV[2P3om^h00`0mFJ/0ooK^0?ofkP03
0?ofkP0303eIZ`3om^h0ooK^00T0ooK^0`0mFJ/50?ofkP0403eIZ`3om^h0ooK^03eIZ`D0ooK^00<0
000003eIZ`0mFJ/0103om^h303eIZ`D0ooK^00<0?EV[0?ofkP3om^h00P3om^h703eIZ`@0ooK^1@0m
FJ/I0?ofkP80e3dI0P3om^h01@3D?AT0ooK^0=@m6@3om^h0e3dI0080ooK^00<0e3dI0?ofkP3D?AT0
1@3D?AT50?ofkPT0e3dI0P3om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00l0ooK^
00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^0180ooK^
00<0e3dI0?ofkP3D?AT0503om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00l0ooK^
00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP180?ofkP8000008@3om^h10?ooo`00I03o
m^h00`000000ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00`0ooK^0P0mFJ/80?ofkP0303eIZ`3o
m^h0ooK^00<0ooK^0P0mFJ/=0?ofkP80?EV[0P3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00D0ooK^
00<000000?ofkP3om^h00P0mFJ/50?ofkP80?EV[0`3om^h00`0mFJ/0ooK^0?ofkP0203eIZ`@0ooK^
0P0mFJ/00`3om^h0?EV[03eIZ`040?ofkPH0?EV[5@3om^h30=@m6@040?ofkP3D?AT0ooK^0?ofkP80
e3dI00<0ooK^0=@m6@3D?AT00P3D?AT30?ofkP030=@m6@3om^h0e3dI00D0ooK^00<0e3dI0?ofkP3o
m^h00P3om^h0103D?AT0ooK^0?ofkP3om^h40=@m6@T0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D
?AT0ooK^0?ofkP0<0?ofkP80e3dI103om^h00`3D?AT0ooK^0?ofkP0B0?ofkP050=@m6@3om^h0ooK^
0?ofkP3D?AT04P3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI
0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP170?ofkP8000008@3om^h10?ooo`00H`3om^h00`00
0000ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00l0ooK^0`0mFJ/40?ofkP0303eIZ`3om^h0ooK^
00@0ooK^00<0?EV[0?ofkP0mFJ/00P0mFJ/<0?ofkP<0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP020?of
kP030000003om^h0ooK^00<0ooK^0`0mFJ/40?ofkP80?EV[00@0ooK^03eIZ`0mFJ/0?EV[203om^h6
03eIZ`040?ofkP0mFJ/0ooK^0?ofkPD0?EV[4P3om^h30=@m6@030?ofkP3D?AT0ooK^0080ooK^0`3D
?AT00`3om^h0e3dI0?ofkP030?ofkP040=@m6@3om^h0ooK^0=@m6@@0ooK^00<0e3dI0?ofkP3om^h0
0P3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0e3dI00@0e3dI0`3om^h00`3D?AT0ooK^
0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00h0ooK^0P3D?AT00`3om^h0e3dI0?ofkP0C0?ofkP030=@m
6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m
6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP160?ofkP030000
003om^h000000240ooK^0@3oool006<0ooK^00<000000?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?of
kP0B0?ofkP80?EV[0P3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^0080ooK^0P0m
FJ/:0?ofkP0303eIZ`3om^h0ooK^00<0?EV[1@3om^h00`000000ooK^0?ofkP060?ofkP80?EV[103o
m^h303eIZ``0ooK^1P0mFJ/40?ofkPD0?EV[3`3om^h20=@m6@040?ofkP3D?AT0ooK^0?ofkP<0e3dI
0P3om^h00`3D?AT0ooK^0?ofkP030?ofkP040=@m6@3om^h0ooK^0=@m6@<0ooK^00<0e3dI0?ofkP3o
m^h00P3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00<0ooK^103D?AT@0?ofkP03
0=@m6@3om^h0ooK^0140ooK^00<0e3dI0?ofkP3om^h04P3om^h00`3D?AT0ooK^0?ofkP050?ofkP03
0=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP090?ofkP03
0=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h0A03om^h01@000000ooK^0?ofkP3om^h00000
0200ooK^0@3oool00680ooK^00<000000?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP0E0?ofkP<0
?EV[1@3om^h00`0mFJ/0ooK^0?ofkP050?ofkP<0?EV[1`3om^h00`0mFJ/0ooK^0?ofkP020?ofkP<0
?EV[0`3om^h00`000000ooK^0?ofkP080?ofkP<0?EV[00<0ooK^03eIZ`3om^h0100mFJ/<0?ofkPD0
?EV[103om^h503eIZ``0ooK^0P3D?AT20?ofkP@0e3dI00@0ooK^0=@m6@3om^h0e3dI1@3om^h00`3D
?AT0ooK^0?ofkP020?ofkP040=@m6@3om^h0ooK^0=@m6@@0ooK^00<0e3dI0?ofkP3om^h01P3om^h0
0`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^0080e3dI3@3om^h00`3D?AT0ooK^0?ofkP0A
0?ofkP030=@m6@3om^h0e3dI0180ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP0:
0?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP0:
0?ofkP030=@m6@3om^h0ooK^0440ooK^0P0000040?ofkP030000003om^h0ooK^01h0ooK^0@3oool0
0640ooK^00<000000?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP0E0?ofkP0303eIZ`3om^h0ooK^
0080?EV[0`3om^h00`0mFJ/0ooK^0?ofkP080?ofkP<0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP030?of
kP0303eIZ`3om^h0ooK^0080?EV[00<0ooK^0000003om^h0303om^h203eIZ`030?ofkP0mFJ/0ooK^
0080ooK^0`0mFJ/;0?ofkPH0?EV[103om^h503eIZ`P0ooK^00@0e3dI0?ofkP3D?AT0ooK^0P3D?AT0
1P3om^h0e3dI0?ofkP3D?AT0ooK^0=@m6@D0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^
0=@m6@040?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^
0?ofkP030?ofkP<0e3dI2@3om^h00`3D?AT0ooK^0?ofkP0A0?ofkP050=@m6@3om^h0ooK^0?ofkP3D
?AT0403om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3o
m^h02`3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3o
m^h0@03om^h00`000000ooK^0?ofkP040?ofkP030000003om^h0ooK^01h0ooK^0@3oool00640ooK^
00<000000?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP0F0?ofkP0303eIZ`3om^h0ooK^0080ooK^
100mFJ/=0?ofkP@0?EV[1@3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`000000?EV[00/0ooK^
00<0?EV[0?ofkP3om^h00`0mFJ/50?ofkP80?EV[2P3om^h01@0mFJ/0ooK^03eIZ`0mFJ/0ooK^00D0
?EV[00<0ooK^03eIZ`0mFJ/00`0mFJ/50?ofkP030=@m6@3om^h0e3dI0080e3dI0`3om^h01@3D?AT0
ooK^0=@m6@3om^h0e3dI00@0ooK^00<0e3dI0?ofkP3om^h0103om^h20=@m6@@0ooK^00<0e3dI0?of
kP3om^h02@3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00T0ooK^0`3D?AT50?ofkP030=@m6@3om^h0
ooK^0140ooK^00<0e3dI0?ofkP3om^h00`3om^h20=@m6@d0ooK^00<0e3dI0?ofkP3om^h02P3om^h0
0`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h0103om^h0
0`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^03h0ooK^00<000000?ofkP3om^h01@3om^h0
0`000000ooK^0?ofkP0N0?ofkP40oooo001P0?ofkP030000003om^h0ooK^00P0ooK^00<0?EV[0?of
kP3om^h05@3om^h00`0mFJ/0ooK^0?ofkP060?ofkP80?EV[3P3om^h303eIZ`@0ooK^00<0?EV[0?of
kP3om^h00`3om^h010000000ooK^03eIZ`0mFJ/90?ofkP0603eIZ`3om^h0ooK^0?ofkP0mFJ/0ooK^
0P0mFJ/50?ofkP<0?EV[1`3om^h0100mFJ/0ooK^0?ofkP3om^h303eIZ`030?ofkP0mFJ/0?EV[00@0
ooK^1@0mFJ/00`3om^h0e3dI0?ofkP030=@m6@<0ooK^00<0e3dI0?ofkP3om^h00P3D?AT40?ofkP03
0=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP04
0=@m6@3om^h0ooK^0=@m6@d0ooK^0P3D?AT20?ofkP030=@m6@3om^h0ooK^0140ooK^00<0e3dI0?of
kP3om^h01P3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?of
kP3om^h01@3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?of
kP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0m0?ofkP030000003om^h0ooK^00L0ooK^00<000000?of
kP3om^h07@3om^h10?ooo`00H03om^h00`000000ooK^0?ofkP070?ofkP80?EV[5`3om^h00`0mFJ/0
ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00<0?EV[2P3om^h0100mFJ/0ooK^0?ofkP3om^h303eI
Z`030?ofkP0mFJ/0ooK^00@0ooK^0P0000020?ofkP<0?EV[1@3om^h00`0mFJ/0ooK^0?ofkP020?of
kP0403eIZ`3om^h0ooK^0?ofkP<0?EV[1@3om^h303eIZ`D0ooK^00<0?EV[0?ofkP0mFJ/00`3om^h6
03eIZ`<0ooK^0`0mFJ/00`3D?AT000000=@m6@020=@m6@<0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m
6@040?ofkP030=@m6@3om^h0ooK^00D0ooK^0P3D?AT30?ofkP030=@m6@3om^h0ooK^00X0ooK^00@0
e3dI0?ofkP3D?AT0e3dI403om^h20=@m6A<0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^
0?ofkP080?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^
0?ofkP0@0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT04P3om^h00`3D?AT0ooK^0?ofkP0k0?ofkP03
0000003om^h0ooK^00P0ooK^00<000000?ofkP3om^h07@3om^h10?ooo`00G`3om^h00`000000ooK^
0?ofkP080?ofkP0403eIZ`3om^h0?EV[03eIZa@0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0
ooK^0?ofkP030?ofkP80?EV[203om^h00`0mFJ/0ooK^0?ofkP040?ofkP<0?EV[0`3om^h00`000000
ooK^0?ofkP02000000<0ooK^0P0mFJ/20?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3o
m^h0103om^h303eIZ`D0ooK^0`0mFJ/20?ofkP80?EV[1`3om^h203eIZ`030?ofkP0mFJ/0?EV[00<0
ooK^00@0?EV[0=@m6@3D?AT06all0P3D?AT2000000040=@m6@3om^h0ooK^0?ofkP80e3dI103om^h0
0`3D?AT0ooK^0?ofkP040?ofkP060=@m6@3om^h0ooK^0=@m6@3om^h0e3dI303om^h0103D?AT0ooK^
0?ofkP3D?ATA0?ofkP040=@m6@3om^h0e3dI0=@m6A00ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D
?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00l0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0D
0?ofkP030=@m6@3om^h0e3dI01<0ooK^00<0e3dI0?ofkP3om^h0>P3om^h00`000000ooK^0?ofkP09
0?ofkP030000003om^h0ooK^01d0ooK^0@3oool005h0ooK^00<000000?ofkP3om^h0203om^h00`0m
FJ/0ooK^0?ofkP020?ofkP<0?EV[403om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^
00D0ooK^0`0mFJ/40?ofkP0303eIZ`3om^h0ooK^00H0ooK^00H0?EV[0?ofkP0mFJ/0?EV[0?ofkP00
00040?ofkP<000000P3om^h303eIZ`D0ooK^00<0?EV[0?ofkP3om^h01`3om^h203eIZ`H0ooK^0`0m
FJ/:0?ofkPD0?EV[00@000000=@m6@3D?AT06all0P3D?AT00`0K7c`0000000000003000000030=@m
6@3om^h0e3dI00<0ooK^00<0e3dI0?ofkP3om^h0103om^h01`3D?AT0ooK^0?ofkP3om^h0e3dI0?of
kP3D?AT0303om^h00`3D?AT0ooK^0?ofkP020=@m6@l0ooK^00<0e3dI0?ofkP3om^h00P3om^h20=@m
6@h0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^
0140ooK^00<0e3dI0?ofkP3D?AT05P3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^
03P0ooK^00<000000?ofkP3om^h02P3om^h00`000000ooK^0?ofkP0M0?ofkP40oooo001N0?ofkP03
0000003om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h01@3om^h203eIZ`h0ooK^00<0?EV[0?ofkP3o
m^h01`3om^h00`0mFJ/0ooK^0?ofkP080?ofkP80?EV[0P3om^h00`0mFJ/0ooK^0?ofkP060?ofkP05
03eIZ`3om^h0ooK^0?ofkP0000000P0mFJ/60?ofkP<000000P3om^h303eIZ`80ooK^00<0?EV[0?of
kP3om^h02@3om^h303eIZ`<0ooK^00<0?EV[0?ofkP0mFJ/00P0mFJ/;0?ofkP80?EV[00D0e3dI02H`
EP00000000000=@m6@0501/O?080000000<0e3dI0000003D?AT00P3om^h00`3D?AT0ooK^0?ofkP05
0?ofkP040=@m6@3om^h0ooK^0?ofkP80e3dI303om^h01P3D?AT0ooK^0?ofkP3D?AT0ooK^0=@m6@h0
ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00d0
ooK^0P3D?AT30?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h0503om^h00`3D?AT0
ooK^0=@m6@0C0?ofkP80e3dI>03om^h2000000d0ooK^00<000000?ofkP3om^h07@3om^h10?ooo`00
G@3om^h00`000000ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00P0ooK^0`0mFJ/:0?ofkP0303eI
Z`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h02P3om^h303eIZ`P0ooK^00@0?EV[0?ofkP3om^h0
00000`3om^h203eIZ`D0ooK^00@0?EV[0?ofkP00000000000`3om^h303eIZ`h0ooK^0`0mFJ/30?of
kP0403eIZ`3om^h0?EV[03eIZ`T0ooK^0P00000302H`EP80e3dI0`00000201/O?0060000003D?AT0
6all0000003D?AT04QDY1P3D?AT20?ofkP030=@m6@3om^h0ooK^0080ooK^0P3D?AT;0?ofkP040=@m
6@3om^h0ooK^0=@m6@<0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP060?ofkP80
e3dI2@3om^h00`3D?AT0ooK^0?ofkP0@0?ofkP030=@m6@3om^h0e3dI01D0ooK^00<0e3dI0?ofkP3D
?AT0503om^h0103D?AT0ooK^0?ofkP3D?ATB0?ofkP040=@m6@3om^h0ooK^0=@m6CH0ooK^00<00000
0?ofkP3om^h03P3om^h00`000000ooK^0?ofkP0L0?ofkP40oooo001L0?ofkP030000003om^h0ooK^
00T0ooK^00<0?EV[0?ofkP3om^h02`3om^h203eIZ`P0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0m
FJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00<0?EV[103om^h0100mFJ/0ooK^0?ofkP000006
0?ofkP<0?EV[0P3om^h0100mFJ/0ooK^0?ofkP3om^h300000080ooK^0`0mFJ/=0?ofkP0603eIZ`3o
m^h0?EV[03eIZ`3om^h0?EV[0`3om^h303eIZ`D0ooK^0P00000302H`EP030=@m6@0V<5H0e3dI00<0
9S1F0P0000001@3D?AT06all01/O?00K7c`0e3dI00@000000`3om^h:0=@m6@T0ooK^00@0e3dI0?of
kP3om^h0e3dI103om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI
0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP0B0?ofkP030=@m6@3om^h0ooK^01<0ooK^00D0e3dI
0?ofkP3om^h0ooK^0=@m6@0B0?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h03P3o
m^h01@3D?AT0ooK^0?ofkP3om^h0e3dI03D0ooK^00<000000?ofkP3om^h03`3om^h00`000000ooK^
0?ofkP0L0?ofkP40oooo001L0?ofkP030000003om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h03P3o
m^h303eIZ`@0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3o
m^h0ooK^00<0ooK^0P0mFJ/20?ofkP0403eIZ`3om^h0ooK^000000T0ooK^0`0mFJ/60?ofkP<00000
0P3om^h303eIZ`T0ooK^00<0?EV[0?ofkP3om^h00P3om^h303eIZ`D0ooK^0P0mFJ/30?ofkP<00000
00@09S1F0=@m6@0V<5H0e3dI1@0V<5H01P3D?AT09S1F0000000000006all0=@m6@<06all10000000
0`3D?AT0ooK^0?ofkP020?ofkP050=@m6@3om^h0ooK^0=@m6@3om^h01`3D?AT01@3om^h0e3dI0?of
kP3om^h0e3dI00H0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP0;0?ofkP80e3dI
103om^h00`3D?AT0ooK^0?ofkP0B0?ofkP030=@m6@3om^h0e3dI01<0ooK^00<0e3dI0?ofkP3om^h0
0P3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h0
3@3om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^0340ooK^00<000000?ofkP3om^h0
403om^h00`000000ooK^0?ofkP0L0?ofkP40oooo001K0?ofkP030000003om^h0ooK^00T0ooK^00<0
?EV[0?ofkP3om^h04@3om^h203eIZ`80ooK^00<0?EV[0?ofkP3om^h0203om^h203eIZ`/0ooK^00<0
?EV[0?ofkP3om^h01P3om^h303eIZ`030?ofkP000000ooK^00T0ooK^00<0?EV[0?ofkP3om^h00P0m
FJ/60?ofkP0303eIZ`000000000000<0ooK^0P0mFJ/60?ofkP0303eIZ`3om^h0ooK^00@0ooK^00@0
?EV[0?ofkP0mFJ/0?EV[1@3om^h203eIZ`<0000000D0<T=k0=@m6@0000009S1F0=@m6@0402H`EP03
0=@m6@0000009S1F00809S1F00<000000=@m6@0K7c`00`0K7c`00`0000006all0=@m6@0200000080
ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@080?ofkPD0e3dI1P3om^h00`3D?AT0ooK^0?ofkP070?of
kP030=@m6@3om^h0ooK^00h0ooK^0P3D?AT00`3om^h0e3dI0?ofkP0C0?ofkP050=@m6@3om^h0ooK^
0?ofkP3D?AT04@3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI
0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI
0?ofkP3om^h0<03om^h00`000000ooK^0?ofkP0A0?ofkP030000003om^h0ooK^01`0ooK^0@3oool0
05/0ooK^00<000000?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP<0?EV[2P3om^h0100m
FJ/0ooK^03eIZ`0mFJ/80?ofkP0303eIZ`3om^h0ooK^00T0ooK^00@0?EV[0000000mFJ/0?EV[203o
m^h00`0mFJ/0ooK^0?ofkP030?ofkP<0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP0300000080ooK^0`0m
FJ/20?ofkP0303eIZ`3om^h0ooK^00D0ooK^00@0?EV[0?ofkP3om^h0ooK^0P0mFJ/40?ofkP800000
00<05@H20000003D?AT00P0b@g/00`000000e3dI0000000302H`EP030=@m6@0V<5H09S1F00@09S1F
00P0e3dI0000000K7c`0000001/O?03D?AT06all03eIZ`<000001@3om^h00`3D?AT0ooK^0?ofkP05
0?ofkP030=@m6@3om^h0e3dI0080ooK^0P3D?AT50?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI
0?ofkP3om^h04@3om^h00`3D?AT0ooK^0?ofkP0B0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI
0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI
0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI
0?ofkP3om^h0;P3om^h00`000000ooK^0?ofkP0C0?ofkP030000003om^h0ooK^01/0ooK^0@3oool0
05X0ooK^00<000000?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP0E0?ofkP0303eIZ`3om^h0?EV[
0080?EV[1`3om^h0100mFJ/0ooK^0?ofkP3om^h303eIZ`D0ooK^00<0?EV[0?ofkP3om^h02@3om^h0
100mFJ/000000?ofkP3om^h203eIZ`H0ooK^00<0?EV[0?ofkP3om^h01P3om^h203eIZ`030?ofkP0m
FJ/0ooK^00@0ooK^0P0000030?ofkP<0?EV[1`3om^h00`0mFJ/0ooK^0?ofkP030?ofkP<0?EV[0P00
00000`0E1P8000000=@m6@040393N`060=@m6@0b@g/000000000003D?AT000001P0V<5H01@3D?AT0
9S1F000000000000e3dI00H06all0`0000020?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?of
kP3D?AT01@3om^h20=@m6@@0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP0A0?of
kP030=@m6@3om^h0e3dI0180ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP0;0?of
kP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP080?of
kP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP0]0?of
kP030000003om^h0ooK^01@0ooK^00<000000?ofkP3om^h06`3om^h10?ooo`00F@3om^h00`000000
ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^01@0ooK^00<0?EV[0?ofkP3om^h00`3om^h303eIZ`<0
ooK^00<0?EV[0?ofkP3om^h01@3om^h203eIZ`80ooK^00<0?EV[0?ofkP3om^h02P3om^h00`000000
ooK^0?ofkP030?ofkP<0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP090?ofkP<0?EV[1P3om^h300000003
03eIZ`3om^h0ooK^00<0?EV[103om^h00`0mFJ/0ooK^0?ofkP060?ofkP80?EV[00<05@H20000003D
?AT0100b@g/0103D?AT0<T=k0393N`3D?AT3000000D09S1F00D0e3dI02H`EP0V<5H0e3dI02H`EP03
000000@06all00D0000001/O?000000000000=@m6@050?ofkP030=@m6@3om^h0e3dI00P0ooK^0P3D
?AT20?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h0403om^h0103D?AT0ooK^0?of
kP3om^h20=@m6@l0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m
6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m
6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP0[0?ofkP800000
5`3om^h00`000000ooK^0?ofkP0K0?ofkP40oooo001I0?ofkP030000003om^h0ooK^00T0ooK^00<0
?EV[0?ofkP3om^h05@3om^h00`0mFJ/0ooK^0?ofkP060?ofkP80?EV[00<0ooK^03eIZ`3om^h0203o
m^h303eIZ`/0ooK^00<0000003eIZ`3om^h01`3om^h303eIZ``0ooK^00<0?EV[0?ofkP0mFJ/00P0m
FJ/50?ofkP0403eIZ`0000000000000000<0ooK^0P0mFJ/20?ofkP0303eIZ`3om^h0ooK^00D0ooK^
0P0000000`0E1P80?EV[03eIZ`050393N`030=@m6@0b@g/0e3dI0080<T=k00<000000393N`000000
0P00000202H`EP040=@m6@0V<5H09S1F0=@m6@@09S1F0`0000001`0K7c`0000001/O?00K7c`0?EV[
0000003D?AT00`3om^h00`3D?AT0ooK^0=@m6@0;0?ofkP80e3dI00<0ooK^0=@m6@3om^h00P3om^h0
0`3D?AT0ooK^0?ofkP0@0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h02`3om^h0
0`3D?AT0ooK^0?ofkP090?ofkP80e3dI2@3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0
ooK^00H0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0
ooK^00X0ooK^00<0e3dI0?ofkP3om^h0:@3om^h00`000000ooK^0?ofkP0G0?ofkP030000003om^h0
ooK^01/0ooK^0@3oool005P0ooK^00<000000?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP0D0?of
kP0303eIZ`3om^h0ooK^00T0ooK^0`0mFJ/90?ofkP0303eIZ`3om^h0?EV[0080?EV[1`3om^h00`00
0000ooK^03eIZ`080?ofkP0303eIZ`3om^h0ooK^00<0?EV[2@3om^h00`0mFJ/0ooK^0?ofkP020?of
kP80?EV[0`3om^h0100mFJ/0ooK^0?ofkP3om^h2000000<0ooK^0`0mFJ/60?ofkP8000000`0E1P82
000000<0<T=k00<0e3dI0393N`3D?AT00`0b@g/00`000000<T=k0393N`020393N`80000000@0e3dI
0000003D?AT000001`0V<5H3000000<06all00@0e3dI0000000mFJ/0e3dI0P3om^h00`3D?AT0ooK^
0?ofkP0;0?ofkP80e3dI0P3om^h00`3D?AT0ooK^0?ofkP0@0?ofkP030=@m6@3om^h0ooK^00H0ooK^
00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00D0ooK^
00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00d0ooK^
00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^02P0ooK^
00<000000?ofkP3om^h06@3om^h00`000000ooK^0?ofkP0J0?ofkP40oooo001H0?ofkP030000003o
m^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h05@3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3o
m^h0?EV[0080?EV[1@3om^h00`0mFJ/0ooK^0?ofkP030?ofkP80?EV[1@3om^h00`000000?EV[0?of
kP080?ofkP0303eIZ`3om^h0ooK^00<0ooK^0P0mFJ/70?ofkP0303eIZ`3om^h0ooK^00@0ooK^0`0m
FJ/60?ofkP<000000`3om^h303eIZ`<0ooK^0P00000201D60P80000000L0>TnD000000000000<T=k
0=@m6@0b@g/0e3dI0080<T=k00<000000393N`0b@g/01@0b@g/20=@m6@<000001`0V<5H02P000000
9S1F0000000000006all0=@m6@0K7c`000000=@m6@0mFJ/3000000h0ooK^0P3D?ATB0?ofkP030=@m
6@3om^h0ooK^00P0ooK^0P3D?AT80?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h0
0`3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h0
3P3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h0
9P3om^h00`000000ooK^0?ofkP0J0?ofkP030000003om^h0ooK^01X0ooK^0@3oool005L0ooK^00<0
00000?ofkP3om^h02P3om^h203eIZaD0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?of
kP030?ofkP<0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP050?ofkP<0?EV[00@0ooK^0000003om^h0?EV[
203om^h00`0mFJ/0ooK^0?ofkP060?ofkP<0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eI
Z`3om^h0?EV[0080?EV[1P3om^h30000000303eIZ`3om^h0ooK^0080?EV[0P00000201D60P030000
000T2PD0000000<0>TnD00<000000=@m6@3D?AT00`0b@g/00`000000<T=k0393N`050393N`050=@m
6@0b@g/0<T=k0000000b@g/00P00000502H`EP040000000V<5H09S1F02H`EP8000000P3D?AT01@00
00006all03eIZ`0mFJ/04QDY00800000303om^h0103D?AT0ooK^0=@m6@3D?AT?0?ofkP030=@m6@3o
m^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP0@0?ofkP050=@m6@3o
m^h0ooK^0?ofkP3D?AT04@3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI0180ooK^00@0e3dI0?ofkP3o
m^h0e3dI403om^h00`3D?AT0ooK^0?ofkP0U0?ofkP030000003om^h0ooK^01/0ooK^00<000000?of
kP3om^h06P3om^h10?ooo`00EP3om^h00`000000ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0?EV[0080
?EV[4P3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00H0ooK^0`0mFJ/:0?ofkP04
0000000mFJ/0ooK^03eIZ`L0ooK^00<0?EV[0?ofkP3om^h02P3om^h403eIZ`L0ooK^00<0?EV[0?of
kP3om^h00`3om^h303eIZ`H0ooK^0P0000020?ofkP<0000000D05@H20000000T2PD090X500000004
03Y?U0060=@m6@0jCi@000000000000b@g/000001P0b@g/20=@m6@80<T=k00@000000393N`0b@g/0
<T=k0P00000302H`EP030000000V<5H09S1F00<09S1F00@0e3dI0000000K7c`000000P0K7c`50000
00T0ooK^00<0e3dI0?ofkP3D?AT00P3om^h20=@m6@d0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D
?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^0180ooK^00<0e3dI0?ofkP3D?AT04`3om^h00`3D
?AT0ooK^0=@m6@0C0?ofkP030=@m6@3om^h0e3dI0180ooK^00<0e3dI0?ofkP3om^h08`3om^h00`00
0000ooK^0?ofkP0L0?ofkP030000003om^h0ooK^01X0ooK^0@3oool005H0ooK^00<000000?ofkP3o
m^h02P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP<0?EV[3P3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP03
03eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP0mFJ/00P0mFJ/60?ofkP030000003om^h0ooK^00<0
?EV[1P3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP80?EV[1P3om^h00`0mFJ/0ooK^0?ofkP060?ofkP80
?EV[103om^h00`0mFJ/0ooK^000000020000000401D60P0000005@H20000008090X500@0000003Y?
U00jCi@0>TnD0P3D?AT303Y?U0<00000100b@g/01P3D?AT0<T=k0393N`3D?AT0<T=k000000D0<T=k
0P0000000`0V<5H0000002H`EP0302H`EP030=@m6@0V<5H0e3dI00<00000100K7c`4000000H0ooK^
00D0e3dI0?ofkP3D?AT0ooK^0=@m6@030?ofkP80e3dI2P3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP80
e3dI00<0ooK^0=@m6@3om^h05@3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^01<0
ooK^00<0e3dI0?ofkP3om^h04@3om^h00`3D?AT0ooK^0?ofkP0R0?ofkP030000003om^h0ooK^01d0
ooK^00<000000?ofkP3om^h06P3om^h10?ooo`00E@3om^h00`000000ooK^0?ofkP0;0?ofkP0303eI
Z`3om^h0ooK^00H0ooK^0P0mFJ/<0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h0
1P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP80?EV[103om^h01P000000ooK^0?ofkP3om^h0?EV[0?of
kP<0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0?EV[0080?EV[0P3om^h00`0m
FJ/0ooK^0?ofkP090?ofkP<0?EV[00<0ooK^03eIZ`3om^h00P000000100E1P800000000000000002
02@:1@070000000jCi@0>TnD03Y?U03D?AT0>TnD0=@m6@0403Y?U0040000000jCi@0000000000080
<T=k00D0e3dI0393N`0b@g/0e3dI000000080393N`<000000P0V<5H01`3D?AT09S1F02H`EP3D?AT0
9S1F0000000V<5H00`00000301/O?0D000000P3om^h00`3D?AT0ooK^0=@m6@030?ofkP030=@m6@3o
m^h0ooK^0080ooK^0P3D?AT70?ofkP030=@m6@3om^h0ooK^0140ooK^00<0e3dI0?ofkP3om^h0503o
m^h00`3D?AT0ooK^0=@m6@0C0?ofkP030=@m6@3om^h0e3dI01<0ooK^0P3D?ATB0?ofkP80e3dI8P3o
m^h200000240ooK^00<000000?ofkP3om^h06@3om^h10?ooo`00E@3om^h00`000000ooK^0?ofkP0;
0?ofkP0303eIZ`3om^h0ooK^00P0ooK^0`0mFJ/80?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[
0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP050?ofkP<0?EV[00<000000?ofkP3om^h00P3om^h0
0`0mFJ/0ooK^0?ofkP020?ofkP<0?EV[403om^h00`0mFJ/0ooK^0?ofkP020?ofkP<0?EV[3P3om^h3
03eIZ`0301D60P0000005@H20080000000@090X500000000000000000`0jCi@00`3D?AT0>TnD0=@m
6@0403Y?U0070000000jCi@0>TnD03Y?U0000000e3dI000000020393N`030=@m6@000000<T=k00P0
<T=k00@000000393N`000000e3dI100V<5H00`3D?AT0000002H`EP0302H`EP@000000P0K7c`50000
00030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h0103om^h20=@m6@@0ooK^00<0e3dI0?of
kP3om^h04@3om^h00`3D?AT0ooK^0=@m6@0D0?ofkP040=@m6@3om^h0ooK^0=@m6A80ooK^00@0e3dI
0?ofkP3om^h0e3dI4P3om^h0103D?AT0ooK^0?ofkP3D?AT@0?ofkP030=@m6@3om^h0e3dI0240ooK^
00<000000?ofkP3om^h08@3om^h00`000000ooK^0?ofkP0I0?ofkP40oooo001D0?ofkP030000003o
m^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h0303om^h303eIZ`D0ooK^00<0?EV[0?ofkP3om^h02`3o
m^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00P0ooK^00H0000003eIZ`0mFJ/0?EV[
0?ofkP0mFJ/60?ofkP0303eIZ`3om^h0?EV[0080?EV[3@3om^h00`0mFJ/0ooK^0?ofkP020?ofkP03
03eIZ`3om^h0ooK^0080?EV[3@3om^h01P0mFJ/0e3dI03eIZ`0mFJ/05@H2000000@090X50`000000
103D?AT0>TnD03Y?U03D?AT403Y?U0050000000jCi@0>TnD03Y?U03D?AT00P0jCi@2000000030393
N`3D?AT0<T=k00P0<T=k00@000000393N`3D?AT0<T=k0`000000100V<5H0e3dI02H`EP00000602H`
EP<000000`0K7c`00`000000e3dI0000000300000080ooK^00<0e3dI0?ofkP3om^h01@3om^h20=@m
6@030?ofkP3D?AT0ooK^0180ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0B0?ofkP030=@m6@3om^h0
ooK^0080ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0
ooK^00h0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0>0?ofkP80e3dI0`3om^h00`3D?AT0ooK^0?of
kP0M0?ofkP030000003om^h0ooK^0280ooK^00<000000?ofkP3om^h06@3om^h10?ooo`00D`3om^h0
0`000000ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00l0ooK^0`0mFJ/00`3om^h0?EV[0?ofkP0=
0?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h0203om^h010000000ooK^0?ofkP3o
m^h203eIZ`D0ooK^00<0?EV[0?ofkP3om^h00`3om^h203eIZ`/0ooK^00<0?EV[0?ofkP3om^h00P3o
m^h00`0mFJ/0ooK^0?ofkP020?ofkP<0?EV[2P3om^h0100mFJ/000000000000E1P8203eIZ`@090X5
00<0000003Y?U03D?AT00P0000000`0jCi@0e3dI03Y?U00303Y?U0040000000jCi@0>TnD0=@m6@D0
>TnD00<000000=@m6@000000200b@g/00`000000e3dI0393N`040393N`80000000<0e3dI0000000V
<5H01P0V<5H01`0000009S1F0000000000006all0=@m6@0K7c`01P0000000`3om^h0e3dI0?ofkP07
0?ofkP030=@m6@3om^h0ooK^0140ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP0>
0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP03
0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP0:
0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h0703om^h00`000000ooK^0?ofkP0S
0?ofkP030000003om^h0ooK^01T0ooK^0@3oool005<0ooK^00<000000?ofkP3om^h02`3om^h00`0m
FJ/0ooK^0?ofkP0C0?ofkP<0?EV[3@3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^
00P0ooK^00<000000?ofkP3om^h00`3om^h403eIZ`80ooK^00<0?EV[0?ofkP3om^h01@3om^h303eI
Z`L0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP060?ofkP80?EV[1`3om^h00`00
0000?EV[0000000201D60P8000000P0mFJ/202@:1@030000003D?AT0>TnD0080>TnD0`00000203Y?
U0040000000jCi@0>TnD0=@m6@L0>TnD00@0e3dI03Y?U000000000001P0b@g/00`3D?AT0<T=k0393
N`060393N`030=@m6@000000000000H09S1F00P0000002H`EP0V<5H09S1F0=@m6@0000006all0000
00806all1@0000000`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0e3dI0140ooK^00<0e3dI0?of
kP3om^h01@3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?of
kP3om^h02P3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?of
kP3om^h0103om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?of
kP3om^h06`3om^h00`000000ooK^0?ofkP0U0?ofkP030000003om^h0ooK^01P0ooK^0@3oool00580
ooK^00<000000?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP0303eIZ`3om^h0?EV[0080
?EV[2@3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<000000?ofkP3o
m^h0103om^h0100mFJ/0ooK^0?ofkP3om^h303eIZ`X0ooK^0`0mFJ/40?ofkP0503eIZ`3om^h0ooK^
0?ofkP0mFJ/02`3om^h303eIZ`<0ooK^00P0000003eIZ`0E1P80000001D60P00000090X500000080
90X50P0mFJ/010000000?eRV00000000000203Y?U0030=@m6@0jCi@00000008000000P0jCi@00`3D
?AT0>TnD03Y?U00503Y?U0040000003D?AT0>TnD03Y?U0<000000P0b@g/00`3D?AT000000393N`08
0393N`040=@m6@0b@g/00000000000@09S1F00@0000002H`EP0V<5H0e3dI0P0V<5H3000000<06all
100000000`3D?AT0ooK^0?ofkP020?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT03`3om^h00`3D?AT0
ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00T0ooK^0P3D?AT90?ofkP030=@m6@3om^h0ooK^00P0
ooK^0P3D?AT90?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0
ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h06P3om^h00`000000
ooK^0?ofkP0V0?ofkP030000003om^h0ooK^01P0ooK^0@3oool00580ooK^00<000000?ofkP3om^h0
303om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^00<0ooK^0`0mFJ/60?ofkP0303eI
Z`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`000000ooK^0?ofkP050?ofkP0303eI
Z`3om^h0ooK^0080ooK^00<0?EV[0?ofkP0mFJ/00P0mFJ/:0?ofkP<0?EV[00<0ooK^03eIZ`3om^h0
0P3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP80?EV[0P000000100mFJ/05@H200000000000202@:1@06
0000000T2PD090X50000000f3`P000000`0oF:H3000000030=@m6@0jCi@0>TnD00<00000200jCi@0
0`000000e3dI03Y?U00403Y?U080000000<0e3dI0000000b@g/0200b@g/0103D?AT0<T=k0393N`0b
@g/2000000<09S1F00<0000002H`EP3D?AT0100V<5H3000000<06all00<0000003eIZ`3D?AT00P00
00000`3om^h0e3dI0?ofkP040?ofkP80e3dI303om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3o
m^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3o
m^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h01`3om^h20=@m6@T0ooK^00<0e3dI0?ofkP3om^h01P3o
m^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^01P0ooK^00<000000?ofkP3om^h09`3o
m^h00`000000ooK^0?ofkP0H0?ofkP40oooo001A0?ofkP030000003om^h0ooK^00`0ooK^00<0?EV[
0?ofkP3om^h0503om^h00`0mFJ/0ooK^0?ofkP060?ofkP80?EV[103om^h203eIZ`H0ooK^00<0?EV[
0?ofkP3om^h01`3om^h00`000000ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[
0?ofkP3om^h00`3om^h203eIZ`/0ooK^0`0mFJ/00`3om^h0?EV[0?ofkP0@0?ofkP050000000E1P80
?EV[01D60P0000000P0T2PD01000000090X502@:1@00000203H?20030000000oF:H0?eRV00@0?eRV
00H0e3dI0000000jCi@000000=@m6@0jCi@3000000D0>TnD00<000000=@m6@0jCi@01@0jCi@0103D
?AT000000000000000080393N`030000003D?AT0<T=k00<0<T=k0P0000000`0V<5H000000=@m6@06
02H`EP040000000V<5H00000000000806all00<0000001/O?03D?AT00`0000070?ofkP030=@m6@3o
m^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3o
m^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3o
m^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3o
m^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h05P3om^h2000002X0ooK^00<000000?ofkP3om^h0603o
m^h10?ooo`00D03om^h00`000000ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^01@0ooK^00<0?EV[
0?ofkP3om^h0203om^h303eIZ`030?ofkP0mFJ/0ooK^00<0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP07
0?ofkP030000003om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP05
0?ofkP<0?EV[2@3om^h00`0mFJ/0ooK^03eIZ`0203eIZ`l0ooK^00@0000001D60P3D?AT0?EV[0P00
000202@:1@040000000T2PD090X500000080=Pl800<0000003mHYP0oF:H0100oF:H01@3D?AT0?eRV
0000003D?AT0000000@0>TnD0`00000203Y?U0030000000jCi@0e3dI00@0>TnD00D0e3dI03Y?U00j
Ci@0000003Y?U002000000H0<T=k00<000000=@m6@0b@g/01@0b@g/00`000000e3dI0000000702H`
EP030000000V<5H09S1F00@0000000<06all0=@m6@0K7c`0100000050?ofkP030=@m6@3om^h0ooK^
00L0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^
00h0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^
00<0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^
00T0ooK^00<0e3dI0?ofkP3om^h05@3om^h00`000000ooK^0?ofkP0Z0?ofkP030000003om^h0ooK^
01P0ooK^0@3oool00500ooK^00<000000?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP03
03eIZ`3om^h0ooK^00`0ooK^0`0mFJ/30?ofkP<0?EV[203om^h00`000000ooK^0?ofkP060?ofkP05
03eIZ`3om^h0ooK^0?ofkP0mFJ/02`3om^h303eIZ`H0ooK^00<0?EV[0?ofkP0mFJ/00P3om^h203eI
Z``0ooK^0P00000201D60P0303eIZ`00000090X5008090X500<0000002@:1@0000000`0f3`P00`00
0000?eRV03mHYP0403mHYP050=@m6@0oF:H0e3dI0000000mFJ/00`00000403Y?U0<0000000<0>TnD
0=@m6@0jCi@00P0jCi@01@3D?AT0>TnD03Y?U00jCi@0000000<0>TnD0`0000030393N`030000000b
@g/0e3dI00D0<T=k00<0e3dI0000000b@g/00`00000402H`EP030000000V<5H09S1F00<09S1F0`00
00001@3D?AT06all01/O?0000000?EV[00@000000P3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m
6@3om^h0ooK^00h0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0A0?ofkP050=@m6@3om^h0ooK^0?of
kP3D?AT0403om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00`0ooK^00@0e3dI0?of
kP3om^h0ooK^0P3D?AT<0?ofkP030=@m6@3om^h0ooK^01@0ooK^00<000000?ofkP3om^h0;03om^h0
0`000000ooK^0?ofkP0G0?ofkP40oooo001?0?ofkP030000003om^h0ooK^00d0ooK^00<0?EV[0?of
kP3om^h0503om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00<0?EV[00<0ooK^03eI
Z`3om^h00`0mFJ/50?ofkP030000003om^h0ooK^00H0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0>
0?ofkP80?EV[0`3om^h00`0mFJ/0ooK^03eIZ`050?ofkP<0?EV[203om^h20000000501D60P3D?AT0
5@H203eIZ`0000000`0T2PD2000000@0=Pl800<0000003mHYP0oF:H0100oF:H0103D?AT0?eRV0=@m
6@00000403mHYP800000100jCi@300000080>TnD00<0e3dI03Y?U00jCi@00P0jCi@00`000000>TnD
03Y?U00403Y?U080000000@0<T=k0000000b@g/0e3dI100b@g/00`3D?AT0<T=k000000040393N`@0
000000<09S1F0000000V<5H0100V<5H01P0000009S1F0000003D?AT0000001/O?080000000<0?EV[
0000000000000P0000000`3om^h0e3dI0?ofkP040?ofkP030=@m6@3om^h0ooK^0100ooK^00<0e3dI
0?ofkP3D?AT04`3om^h00`3D?AT0ooK^0=@m6@0B0?ofkP040=@m6@3om^h0ooK^0=@m6@l0ooK^00@0
e3dI0?ofkP3om^h0e3dI3`3om^h00`3D?AT0ooK^0?ofkP0B0?ofkP030000003om^h0ooK^02d0ooK^
00<000000?ofkP3om^h05`3om^h10?ooo`00CP3om^h00`000000ooK^0?ofkP0>0?ofkP80?EV[503o
m^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00<0ooK^0`0mFJ/30?ofkP<0?EV[00<0
ooK^0000003om^h0203om^h0100mFJ/0ooK^0?ofkP0mFJ/A0?ofkP@0?EV[00<0ooK^03eIZ`3om^h0
1`3om^h303eIZ`@0ooK^0`00000201D60P030000000mFJ/0000000<090X500<0000003H?200f3`P0
0`0f3`P00`000000?eRV03mHYP0403mHYP80e3dI00<0?eRV0000000oF:H01@0oF:H30000000403Y?
U0000000>TnD03Y?U08000001@0jCi@00`000000>TnD03Y?U00603Y?U0<0000000D0<T=k0=@m6@0b
@g/0<T=k0=@m6@020393N`030000000b@g/0<T=k00H0<T=k0`00000502H`EP040000000V<5H0e3dI
02H`EP@000000P0K7c`400000080e3dI0P3om^h00`3D?AT0ooK^0?ofkP0B0?ofkP030=@m6@3om^h0
ooK^01<0ooK^00<0e3dI0?ofkP3om^h04@3om^h00`3D?AT0ooK^0=@m6@0A0?ofkP80e3dI403om^h0
0`3D?AT0ooK^0?ofkP0A0?ofkP030000003om^h0ooK^02h0ooK^00<000000?ofkP3om^h05`3om^h1
0?ooo`00CP3om^h00`000000ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0?EV[0080?EV[4@3om^h00`0m
FJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP0mFJ/00P0mFJ/30?of
kP030000000mFJ/0?EV[00P0ooK^00@0?EV[0?ofkP3om^h0?EV[503om^h303eIZ`/0ooK^0`0mFJ/0
2@3om^h0000001D60P000000e3dI0000000mFJ/090X50000000202@:1@8000001@0f3`P00`000000
?eRV03mHYP0403mHYP040=@m6@0oF:H0?eRV000000T0?eRV0`0000000`0jCi@0e3dI03Y?U0030000
0080>TnD00<0000003Y?U00jCi@01`0jCi@01P000000>TnD0000003D?AT0<T=k0=@m6@@0<T=k00<0
00000393N`0b@g/01P0b@g/010000000<T=k00000000000302H`EP040000000V<5H09S1F0=@m6@<0
9S1F0`00000201/O?0@000000P3D?ATD0?ofkP030=@m6@3om^h0e3dI01<0ooK^00<0e3dI0?ofkP3D
?AT04`3om^h00`3D?AT0ooK^0?ofkP0@0?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3o
m^h0403om^h00`000000ooK^0?ofkP0_0?ofkP030000003om^h0ooK^01L0ooK^0@3oool004d0ooK^
00<000000?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP<0?EV[3P3om^h00`0mFJ/0ooK^
0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h00`3om^h203eIZ`040000
003om^h0ooK^0?ofkP<0?EV[103om^h0100mFJ/0ooK^0?ofkP0mFJ/E0?ofkP0303eIZ`3om^h0ooK^
0080?EV[303om^h203eIZ`0701D60P0000005@H20000000mFJ/090X50000000202@:1@8000001@0f
3`P00`000000?eRV03mHYP0303mHYP80e3dI0P0oF:H00`000000?eRV03mHYP0803mHYP040000000m
FJ/0e3dI0=@m6@@0>TnD0`00000903Y?U0050000000jCi@0>TnD03Y?U03D?AT00P0000030393N`03
0000000b@g/0<T=k00H0<T=k00@000000393N`0b@g/0<T=k0P00000202H`EP040000000V<5H09S1F
0=@m6@<09S1F00D0000002H`EP000000000001/O?0020000000403eIZ`000000000000000180ooK^
00D0e3dI0?ofkP3om^h0ooK^0=@m6@0A0?ofkP040=@m6@3om^h0ooK^0=@m6A80ooK^0P3D?ATA0?of
kP80e3dI403om^h20=@m6A40ooK^00<000000?ofkP3om^h0<@3om^h00`000000ooK^0?ofkP0F0?of
kP40oooo001=0?ofkP030000003om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h01P3om^h203eIZ`/0
ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00D0
ooK^00<0000003eIZ`0mFJ/0103om^h303eIZ`050?ofkP0mFJ/0ooK^0?ofkP0mFJ/05@3om^h00`0m
FJ/0ooK^0?ofkP020?ofkP<0?EV[203om^h20000000701D60P0mFJ/0?EV[03eIZ`0T2PD0?EV[0000
000202@:1@030000000f3`P0000000D0=Pl800<0000003mHYP0oF:H00P0oF:H0103D?AT0?eRV03mH
YP3D?AT203mHYP030000000oF:H0?eRV00L0?eRV00D000000=@m6@0oF:H0?eRV0=@m6@02000000<0
>TnD0`00000703Y?U0070000000jCi@0>TnD0=@m6@0jCi@0e3dI03Y?U002000000030393N`000000
<T=k00L0<T=k00<000000393N`0b@g/00`0b@g/30000000402H`EP3D?AT09S1F0=@m6@<09S1F00<0
000002H`EP0V<5H0100000000`0K7c`0000000000004000000d0ooK^00<0e3dI0?ofkP3om^h00P3o
m^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h03P3o
m^h0103D?AT0ooK^0?ofkP3D?AT?0?ofkP040=@m6@3om^h0ooK^0=@m6@h0ooK^00<0e3dI0?ofkP3D
?AT03`3om^h2000003@0ooK^00<000000?ofkP3om^h05P3om^h10?ooo`00C03om^h00`000000ooK^
0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00T0ooK^0`0mFJ/80?ofkP0303eIZ`3om^h0ooK^00d0ooK^
00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP050?ofkP040000003om^h0ooK^0?ofkP<0
?EV[103om^h403eIZaD0ooK^00<0?EV[0?ofkP3om^h01P3om^h203eIZ`D0ooK^0P00000201D60P80
000000H090X503eIZ`0mFJ/0?EV[02@:1@00000203H?20030000000f3`P0=Pl800<0=Pl80P000002
03mHYP050=@m6@0oF:H0?eRV03mHYP3D?AT00P0oF:H00`000000?eRV03mHYP0703mHYP050000003D
?AT0?eRV03mHYP3D?AT00P0oF:H20000000403Y?U0000000>TnD03Y?U0<00000100jCi@00`000000
>TnD0=@m6@0303Y?U0030=@m6@0jCi@0>TnD00<000001`0b@g/00`000000<T=k0393N`050393N`03
0000003D?AT0000000809S1F00@0e3dI02H`EP0V<5H000001@0V<5H2000000806all00@0000003eI
Z`0mFJ/04QDY0`0000090?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h0303om^h0
0`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00d0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m
6@0>0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT03@3om^h0103D?AT0ooK^0?ofkP3D?AT>0?ofkP03
0000003om^h0ooK^03@0ooK^00<000000?ofkP3om^h05P3om^h10?ooo`00B`3om^h00`000000ooK^
0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00`0ooK^0`0mFJ/50?ofkP0303eIZ`3om^h0ooK^00`0ooK^
00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP040?ofkP030000003om^h0ooK^00D0ooK^
0P0mFJ/30?ofkP0303eIZ`3om^h0?EV[0080?EV[4`3om^h00`0mFJ/0ooK^0?ofkP080?ofkP<0?EV[
00@0ooK^00000000000000000P0E1P801P00000090X502@:1@0T2PD0?EV[000000<0?EV[00<0=Pl8
0000000f3`P00`0f3`P20000000404=N/P00000000000=@m6@<0?eRV00@0e3dI03mHYP0oF:H00000
2@0oF:H00`3D?AT0?eRV03mHYP0203mHYP040=@m6@0oF:H0?eRV03mHYP<00000100jCi@300000080
>TnD00<0e3dI03Y?U00jCi@00P0jCi@01P3D?AT0>TnD03Y?U00jCi@0000003Y?U08000001P0b@g/0
0`000000<T=k0393N`040393N`030=@m6@000000<T=k00<0000000@0e3dI02H`EP0V<5H000001P0V
<5H20000000301/O?00000006all0080?EV[0P0B5BT2000000H0ooK^00<0e3dI0?ofkP3om^h01P3o
m^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h02`3o
m^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h00P3o
m^h00`3D?AT0ooK^0?ofkP0:0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT03@3om^h00`000000ooK^
0?ofkP0e0?ofkP030000003om^h0ooK^01H0ooK^0@3oool004/0ooK^00<000000?ofkP3om^h03P3o
m^h00`0mFJ/0ooK^0?ofkP0@0?ofkP<0?EV[00<0ooK^03eIZ`3om^h03P3om^h00`0mFJ/0ooK^0?of
kP030?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<000000?ofkP3om^h0203om^h303eIZ`030?ofkP0m
FJ/0ooK^0080ooK^0`0mFJ/?0?ofkP80?EV[3@3om^h3000000805@H20P00000302@:1@0303eIZ`00
000000000080=Pl80P0mFJ/303H?20030000001G60`000000080@ejb00@0e3dI04=N/P0000000000
0P0oF:H00`3D?AT0?eRV0000000803mHYP030=@m6@000000?eRV00<0?eRV00<0e3dI03mHYP0oF:H0
0P0oF:H00`000000?EV[00000002000000@0>TnD0P0000000`3D?AT0>TnD03Y?U00303Y?U0040=@m
6@0jCi@0>TnD000000<0>TnD0`0000030393N`030000000b@g/0<T=k00<0<T=k00@0e3dI0393N`0b
@g/000000`0b@g/010000000e3dI00000000000602H`EP030000000V<5H0000000<0000000D06all
0000000000000000018E:@02000000<0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?of
kP080?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?of
kP040?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?of
kP090?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h02P3om^h00`000000ooK^0?of
kP0g0?ofkP030000003om^h0ooK^01D0ooK^0@3oool004X0ooK^00<000000?ofkP3om^h03`3om^h0
0`0mFJ/0ooK^0?ofkP0C0?ofkP<0?EV[3P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0
ooK^00@0ooK^00<000000?ofkP3om^h02P3om^h403eIZ`D0ooK^0`0mFJ/<0?ofkP80?EV[3@3om^h3
0000000401D60P00000090X50000008090X500<0?EV[02@:1@000000100f3`P010000000?EV[03eI
Z`0mFJ/205LH300300000013G[80e3dI00@0@ejb0P0000000`3D?AT0?eRV0000000703mHYP030=@m
6@0oF:H0000000D0?eRV00D0e3dI03mHYP0oF:H0?eRV0000000403mHYP8000000`0jCi@0103D?AT0
000000000000000403Y?U0030=@m6@0jCi@0000000H0>TnD0P0000000`0b@g/000000393N`030393
N`050=@m6@0b@g/0<T=k0393N`0000001@0b@g/0103D?AT0000000000000000502H`EP030000000V
<5H09S1F00<000000P0K7c`20000000503eIZ`00000000000000003D?AT02`3om^h00`3D?AT0ooK^
0?ofkP080?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h01`3om^h20=@m6@L0ooK^
00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00L0ooK^
00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP090?ofkP030000003om^h0ooK^03P0ooK^
00<000000?ofkP3om^h05@3om^h10?ooo`00BP3om^h00`000000ooK^0?ofkP0?0?ofkP0303eIZ`3o
m^h0ooK^01@0ooK^00<0?EV[0?ofkP0mFJ/00P0mFJ/:0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0
?EV[0?ofkP3om^h00`3om^h00`000000ooK^0?ofkP0;0?ofkP0403eIZ`3om^h0?EV[0?ofkP<0?EV[
1@3om^h203eIZ`T0ooK^00<0?EV[0?ofkP0mFJ/0303om^h20000000301D60P0000000000008090X5
00@0000002@:1@0T2PD0?EV[0P00000403H?20040000000f3`P0=Pl800000080?EV[00<000000=@m
6@13G[801P13G[80103D?AT0000000000000000503mHYP040=@m6@0oF:H0?eRV000000D0?eRV00D0
e3dI03mHYP0oF:H0?eRV0000000603mHYP80000000<0e3dI03Y?U00000000P0jCi@2000000<0>TnD
00<0e3dI0000000jCi@01`0jCi@300000080<T=k00<0e3dI0393N`0b@g/00P0b@g/00`000000<T=k
0393N`040393N`030=@m6@000000<T=k008000000`0V<5H00`0000009S1F02H`EP0202H`EP<00000
0P0K7c`00`000000?EV[03eIZ`04000000X0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^
0?ofkP090?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^
0?ofkP050?ofkP80e3dI203om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00D0ooK^
00<0e3dI0?ofkP3om^h01`3om^h00`000000ooK^0?ofkP0i0?ofkP030000003om^h0ooK^01D0ooK^
0@3oool004T0ooK^00<000000?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP0303eIZ`3o
m^h0ooK^00<0ooK^0P0mFJ/80?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h00`3o
m^h00`000000ooK^0?ofkP0<0?ofkP80?EV[1@3om^h303eIZ`@0ooK^0`0mFJ/60?ofkP0303eIZ`3o
m^h0?EV[00/0ooK^00<000000=@m6@0000000P0E1P801000000090X502@:1@00000202@:1@0303eI
Z`0f3`P0000000@0=Pl800<0000003H?200000000`1G60`00`0mFJ/0e3dI04=N/P0704=N/P030=@m
6@000000@ejb008000000`0oF:H0103D?AT0?eRV03mHYP00000603mHYP040=@m6@0oF:H0?eRV0000
00L0?eRV00<0e3dI03mHYP0000000P00000303Y?U0<0000000<0>TnD0=@m6@000000200jCi@01@00
0000>TnD0000003D?AT0000000@0<T=k00<000000393N`0b@g/01@0b@g/0103D?AT000000393N`0b
@g/2000000809S1F00<0000002H`EP0V<5H00`0V<5H40000000301/O?00000006all00806all1000
00080?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?of
kP030?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?of
kP080?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?of
kP060?ofkP030000003om^h0ooK^03X0ooK^00<000000?ofkP3om^h05@3om^h10?ooo`00B03om^h0
0`000000ooK^0?ofkP0@0?ofkP0303eIZ`3om^h0ooK^01@0ooK^00<0?EV[0?ofkP3om^h01@3om^h3
03eIZ`D0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP030?ofkP030000003om^h0
ooK^00/0ooK^00<0?EV[0?ofkP0mFJ/0203om^h403eIZ`<0ooK^0`0mFJ/20?ofkP0303eIZ`3om^h0
?EV[00/0ooK^00@000000=@m6@0000005@H20P00000202@:1@070000000T2PD090X50000000mFJ/0
=Pl80000000403H?20800000101G60`00`000000@ejb04=N/P0704=N/P030=@m6@000000@ejb0080
@ejb0P0000001@3D?AT0?eRV03mHYP0oF:H0000000H0?eRV00@0e3dI03mHYP0oF:H000001P0oF:H0
1P3D?AT0?eRV03mHYP0oF:H0000003mHYP800000100jCi@3000000P0>TnD00D0000003Y?U00jCi@0
e3dI03Y?U004000000030393N`000000<T=k00H0<T=k00<0e3dI0393N`0b@g/00P0b@g/3000000H0
9S1F00<0000002H`EP0V<5H01000000201/O?0D000001`3om^h00`3D?AT0ooK^0?ofkP020?ofkP03
0=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP03
0=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP030?ofkP03
0=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h0103om^h2000003d0ooK^00<000000?ofkP3o
m^h05@3om^h10?ooo`00B03om^h00`000000ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^01@0ooK^
00<0?EV[0?ofkP3om^h02@3om^h303eIZ`80ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^
0?ofkP030?ofkP030000003om^h0ooK^00`0ooK^0P0mFJ/=0?ofkP<0?EV[0`3om^h303eIZ`030?of
kP0mFJ/0ooK^00X0ooK^0`0000000`0E1P80000002@:1@0202@:1@070000003D?AT090X50000000m
FJ/0=Pl80000000403H?20030000001G60`0EaP<00@0EaP<00<0000004=N/P13G[801P13G[800`3D
?AT0000004=N/P0304=N/P060=@m6@13G[8000000000000oF:H000001`0oF:H00`3D?AT0?eRV0000
000503mHYP030=@m6@0oF:H0?eRV0080?eRV00@0000003mHYP0oF:H0?eRV0`00000303Y?U0030=@m
6@000000000000H0>TnD00<0000003Y?U03D?AT01P0jCi@3000000H0<T=k00<000000=@m6@0b@g/0
100b@g/3000000@09S1F00<0000002H`EP0V<5H00`0V<5H3000000806all00<0000001/O?0000000
0P0000050?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT0403om^h0103D?AT0ooK^0?ofkP3D?AT>0?of
kP050=@m6@3om^h0ooK^0?ofkP3D?AT03@3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0
ooK^00P0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`000000ooK^0?ofkP0n0?ofkP030000003om^h0
ooK^01@0ooK^0@3oool004L0ooK^00<000000?ofkP3om^h0403om^h00`0mFJ/0ooK^0?ofkP0D0?of
kP0303eIZ`3om^h0ooK^00`0ooK^0P0mFJ/50?ofkP0303eIZ`3om^h0ooK^0080ooK^00<000000?of
kP3om^h03@3om^h203eIZa00ooK^0`0mFJ/00`3om^h0?EV[0?ofkP0303eIZ`T0ooK^0`0000000`0E
1P8000000000000302@:1@040000000T2PD0000003eIZ`80=Pl800@0000003H?200f3`P0=Pl80P00
000605LH300300000013G[80@ejb00L0@ejb00D0e3dI04=N/P13G[80@ejb0=@m6@0404=N/P<00000
1P0oF:H00`3D?AT0?eRV0000000403mHYP030=@m6@0oF:H0?eRV00<0?eRV00<0000003mHYP0oF:H0
100oF:H20000000403Y?U0000000e3dI03Y?U0<000000`0jCi@00`000000e3dI03Y?U00703Y?U004
0000000jCi@00000000000D0<T=k00<000000=@m6@0b@g/0100b@g/00`000000<T=k000000020000
00809S1F00<0000002H`EP0V<5H0100V<5H30000000401/O?00000006all01/O?0<00000103om^h0
0`3D?AT0ooK^0=@m6@0A0?ofkP030=@m6@3om^h0e3dI00l0ooK^00@0e3dI0?ofkP3om^h0e3dI3P3o
m^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00/0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`000000ooK^
0?ofkP0o0?ofkP030000003om^h0ooK^01@0ooK^0@3oool004L0ooK^00<000000?ofkP3om^h03`3o
m^h00`0mFJ/0ooK^0?ofkP0D0?ofkP0303eIZ`3om^h0ooK^00h0ooK^100mFJ/00`3om^h0?EV[0?of
kP030?ofkP030000003om^h0ooK^00d0ooK^0P0mFJ/D0?ofkP<0?EV[00<0ooK^03eIZ`3om^h00`0m
FJ/50?ofkP80000000<05@H20=@m6@0E1P800P00000302@:1@80000000D0=Pl803eIZ`0f3`P0=Pl8
0000000303H?208000001P1G60`00`000000@ejb04=N/P0704=N/P040=@m6@13G[80@ejb0=@m6@H0
@ejb00@0000004=N/P00000000001@0oF:H00`3D?AT0000003mHYP0203mHYP030=@m6@0oF:H0?eRV
00@0?eRV00<0000003mHYP0oF:H01P0oF:H3000000040=@m6@0jCi@0>TnD03Y?U0<0000000<0e3dI
0000000jCi@01`0jCi@010000000>TnD03Y?U00jCi@300000080<T=k00<000000393N`3D?AT01@0b
@g/010000000<T=k0393N`0b@g/4000000D09S1F00<0000002H`EP0V<5H01000000201/O?0<00000
0`3om^h00`3D?AT0ooK^0?ofkP0A0?ofkP030=@m6@3om^h0ooK^00l0ooK^0P3D?AT?0?ofkP040=@m
6@3om^h0ooK^0=@m6@`0ooK^00D0e3dI0?ofkP3om^h0ooK^000000120?ofkP030000003om^h0ooK^
01@0ooK^0@3oool004H0ooK^00<000000?ofkP3om^h0403om^h203eIZaD0ooK^00<0?EV[0?ofkP3o
m^h03P3om^h00`0mFJ/0ooK^03eIZ`0403eIZ`<0ooK^00<000000?ofkP3om^h03@3om^h203eIZaD0
ooK^00@0?EV[0?ofkP0mFJ/0?EV[103om^h203eIZ`<0ooK^0`000000100E1P80000002@:1@000003
02@:1@040000000f3`P0=Pl803eIZ`80=Pl800H0000003H?200f3`P0000005LH3000000605LH3003
00000013G[80@ejb00L0@ejb00@0e3dI04=N/P13G[80e3dI1P13G[8010000000@ejb04=N/P13G[83
00000080?eRV00<0e3dI0000000oF:H00P0oF:H00`3D?AT0?eRV03mHYP0403mHYP030000000oF:H0
?eRV00L0?eRV00@0000003mHYP000000e3dI100jCi@00`3D?AT000000000000803Y?U0030000000j
Ci@0>TnD00@0>TnD0P000000100b@g/000000393N`3D?AT40393N`030000000b@g/0<T=k00@0<T=k
0`00000402H`EP030000000V<5H09S1F00809S1F0`000000100K7c`000000000000000030=@m6A80
ooK^0P3D?ATA0?ofkP030=@m6@3om^h0ooK^00l0ooK^0P3D?AT=0?ofkP040=@m6@3om^h0ooK^0000
04<0ooK^00<000000?ofkP3om^h0503om^h10?ooo`00A@3om^h00`000000ooK^0?ofkP0A0?ofkP03
03eIZ`3om^h0?EV[0080?EV[4P3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^0080
ooK^1@0mFJ/00`000000ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^01<0ooK^00D0?EV[0?ofkP3o
m^h0?EV[0?ofkP0303eIZ`<0ooK^0`0mFJ/0100000005@H20=@m6@00000202@:1@030000000T2PD0
90X5008000000P0f3`P01P0mFJ/0=Pl803H?20000000=Pl800000080EaP<00<0000005LH301G60`0
101G60`00`000000@ejb04=N/P0704=N/P030000003D?AT0e3dI00L0@ejb00<0000004=N/P13G[80
1013G[820000000503mHYP3D?AT0?eRV03mHYP3D?AT01`0oF:H00`000000?eRV03mHYP0703mHYP04
0000000oF:H0?eRV0=@m6@<0000000<0e3dI03Y?U00jCi@01000000503Y?U0030000000jCi@0>TnD
00H0>TnD0`0000000`0b@g/0e3dI0393N`020393N`030000000b@g/0<T=k00D0<T=k00@000000393
N`00000000000`0V<5H00`0000009S1F02H`EP0302H`EP<0000000<06all0000000K7c`00P000000
0`3D?AT0ooK^0?ofkP0>0?ofkP040=@m6@3om^h0ooK^0=@m6@l0ooK^0P3D?ATA0?ofkP030=@m6@3o
m^h0ooK^00/0ooK^0P3D?AT00`3om^h000000?ofkP140?ofkP030000003om^h0ooK^01<0ooK^0@3o
ool004D0ooK^00<000000?ofkP3om^h0403om^h00`0mFJ/0ooK^0?ofkP030?ofkP<0?EV[3P3om^h0
0`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^0080ooK^00D0?EV[0?ofkP3om^h0?EV[0000
000403eIZ`d0ooK^00<0?EV[0?ofkP3om^h04`3om^h0100mFJ/0ooK^0?ofkP0mFJ/40?ofkP<0?EV[
00<0ooK^0000000000000`0mFJ/202@:1@060000000T2PD090X50000000f3`P000000P0f3`P00`0m
FJ/0=Pl803H?2002000000<0EaP<00<0000005LH301G60`0101G60`00`000000@ejb04=N/P0704=N
/P030000003D?AT0@ejb00L0@ejb00<0000004=N/P13G[801P13G[8010000000e3dI0000003D?AT8
03mHYP030000000oF:H0?eRV00L0?eRV00L0000003mHYP0oF:H0?eRV0=@m6@0oF:H0e3dI00800000
00<0>TnD0000000jCi@00P0jCi@2000000<0>TnD00<0000003Y?U00jCi@01`0jCi@01@000000>TnD
000000000000e3dI00<0<T=k00<000000393N`0b@g/01@0b@g/00`000000<T=k0393N`0200000080
9S1F00<0000002H`EP0V<5H00`0V<5H00`0000009S1F000000030000000301/O?03D?AT0000000h0
ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0>0?ofkP030=@m6@3om^h0e3dI0100ooK^0P3D?AT<0?of
kP040=@m6@3om^h0e3dI000004H0ooK^00<000000?ofkP3om^h04`3om^h10?ooo`00A03om^h00`00
0000ooK^0?ofkP0A0?ofkP0303eIZ`3om^h0ooK^00H0ooK^0P0mFJ/<0?ofkP0303eIZ`3om^h0ooK^
00h0ooK^00<0?EV[0?ofkP3om^h00P3om^h01P0mFJ/0ooK^0?ofkP3om^h000000?ofkP80?EV[00<0
ooK^03eIZ`0mFJ/00P0mFJ/80?ofkP0303eIZ`3om^h0ooK^01<0ooK^00D0?EV[0?ofkP3om^h0ooK^
03eIZ`070?ofkP<0000000<05@H20000000000000`0mFJ/01@0T2PD0000003H?200f3`P000000080
=Pl800<0?EV[03H?200f3`P00P00000305LH30030000001G60`0EaP<00@0EaP<0P00000804=N/P03
0=@m6@13G[80e3dI00L0@ejb00<0000004=N/P13G[801`13G[800`000000e3dI00000002000000H0
?eRV00<0000003mHYP0oF:H01`0oF:H00`000000?eRV03mHYP0203mHYP040=@m6@0oF:H0?eRV03mH
YP<00000100jCi@30000000303Y?U0000000>TnD00L0>TnD00H0000003Y?U00jCi@0e3dI0000003D
?AT20393N`030000000b@g/0<T=k00D0<T=k00<000000393N`0b@g/00P0b@g/3000000H09S1F00@0
000002H`EP0V<5H09S1F0`0000000`3D?AT0000003eIZ`0;0?ofkP030=@m6@3om^h0ooK^0080ooK^
00<0e3dI0?ofkP3om^h02`3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00h0ooK^00<0e3dI0?ofkP3D
?AT02P3om^h20=@m6@030?ofkP3D?AT0000004L0ooK^00<000000?ofkP3om^h04`3om^h10?ooo`00
A03om^h00`000000ooK^0?ofkP0A0?ofkP0303eIZ`3om^h0ooK^00P0ooK^0`0mFJ/80?ofkP0303eI
Z`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h00`3om^h0100mFJ/0ooK^0?ofkP0000040?ofkP<0
?EV[0P3om^h303eIZ`D0ooK^00<0?EV[0?ofkP3om^h04`3om^h0100mFJ/0ooK^0?ofkP0mFJ/70?of
kP<000000P0E1P801@00000090X502@:1@0T2PD000000080?EV[0P0f3`P00`000000=Pl803eIZ`03
03H?20030000001G60`0EaP<00<0EaP<00<0000005LH301G60`00P1G60`20000000304IR_0000000
000000D0@ejb00@0e3dI00000013G[80e3dI1`13G[800`000000@ejb04=N/P0704=N/P030=@m6@13
G[80e3dI0080@ejb0P00000403mHYP030000000oF:H0?eRV00L0?eRV00L0000003mHYP0oF:H0?eRV
0=@m6@0oF:H0e3dI00<0?eRV00@0000003mHYP00000000001@0jCi@3000000L0>TnD00<0000003Y?
U03D?AT00`0jCi@20=@m6@030393N`000000<T=k00D0<T=k00<000000393N`0b@g/0100b@g/30000
00@09S1F00<0000002H`EP0V<5H00`0V<5H30000000401/O?0000000?EV[03eIZ`H0ooK^0P3D?AT6
0?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP0:
0?ofkP80e3dI0P3om^h00`3D?AT0ooK^0?ofkP070?ofkP050=@m6@3om^h0ooK^0000003D?AT0B03o
m^h00`000000ooK^0?ofkP0C0?ofkP40oooo00130?ofkP030000003om^h0ooK^0180ooK^00<0?EV[
0?ofkP3om^h02`3om^h303eIZ`D0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP02
0?ofkP0403eIZ`3om^h0ooK^000000P0ooK^0`0mFJ/20?ofkP<0?EV[00<0ooK^03eIZ`0mFJ/0503o
m^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00H0ooK^0P0000000`0E1P80000001D60P02000000<090X5
0P0000001P0f3`P0?EV[03eIZ`0mFJ/0=Pl803eIZ`80=Pl80P00000505LH30070000001G60`0EaP<
05LH30000000N28@0000000304IR_0<0000000@0@ejb0=@m6@13G[8000000P13G[800`3D?AT0@ejb
04=N/P0404=N/P0300000013G[80@ejb00H0@ejb00@0e3dI00000013G[80e3dI1013G[8300000003
03mHYP000000?eRV00P0?eRV00@0000003mHYP0oF:H0e3dI0`0oF:H0103D?AT0?eRV03mHYP000003
03mHYP<000000`0jCi@010000000>TnD00000000000503Y?U0030000003D?AT0>TnD00D0>TnD00<0
e3dI0000000000001P0b@g/00`000000<T=k0393N`040393N`030000000b@g/00000008000000P0V
<5H00`0000009S1F02H`EP0202H`EP030000000V<5H09S1F00@000000P0mFJ/30?ofkP030=@m6@3o
m^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3o
m^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP060?ofkP060=@m6@3o
m^h0ooK^0000003om^h0e3dIB03om^h00`000000ooK^0?ofkP0C0?ofkP40oooo00120?ofkP030000
003om^h0ooK^0180ooK^00<0?EV[0?ofkP3om^h03`3om^h303eIZ`030?ofkP0mFJ/0ooK^0100ooK^
00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0000000<0?ofkP80?EV[0`3om^h303eIZa@0ooK^
00D0?EV[0?ofkP3om^h0ooK^03eIZ`050?ofkP@0000000@05@H20000000T2PD000000`0T2PD00`00
0000=Pl803H?200203H?20070000000mFJ/0?EV[03eIZ`000000EaP<0000000505LH30040000001G
60`0EaP<00000080N28@00<0000004IR_016H[`01016H[`0103D?AT0000004=N/P00000204=N/P03
0=@m6@13G[80@ejb00@0@ejb00<0000004=N/P13G[801@13G[800`3D?AT0@ejb0000000204=N/P03
0=@m6@13G[80@ejb00@0@ejb0`00000803mHYP030000000oF:H0e3dI00D0?eRV00<0e3dI03mHYP00
00001P0oF:H20000000303eIZ`000000>TnD0080>TnD0`00000203Y?U0030=@m6@000000>TnD00H0
>TnD00<0e3dI03Y?U00000000P0000030393N`030000000b@g/0<T=k00D0<T=k00@000000393N`0b
@g/0<T=k1000000402H`EP030000000V<5H09S1F00809S1F0P00000303eIZ`030=@m6@3om^h0ooK^
00L0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^
00P0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP050?ofkP040=@m6@3om^h0ooK^
00000080ooK^00<0e3dI0?ofkP3om^h0A`3om^h00`000000ooK^0?ofkP0B0?ofkP40oooo00120?of
kP030000003om^h0ooK^0180ooK^00<0?EV[0?ofkP3om^h04P3om^h303eIZ`l0ooK^00<0?EV[0?of
kP3om^h00P3om^h0100mFJ/0ooK^0?ofkP00000>0?ofkP<0?EV[00<0ooK^03eIZ`3om^h00`0mFJ/A
0?ofkP0403eIZ`3om^h0ooK^03eIZ`D0ooK^00@0000001D60P0000005@H20P00000202@:1@030000
000T2PD090X500800000100f3`P010000000=Pl803eIZ`00000203eIZ`030000001G60`0EaP<00<0
EaP<00@0000005LH301G60`000000`1h8Q000`000000AV:l04IR_00204IR_0030=@m6@16H[`0AV:l
00<000000P13G[800`3D?AT0@ejb04=N/P0304=N/P0300000013G[80@ejb00D0@ejb00<0e3dI04=N
/P0000000`13G[800`3D?AT0@ejb04=N/P0404=N/P0400000013G[800000000000H0?eRV00<00000
0=@m6@0oF:H01P0oF:H00`3D?AT0000003mHYP0703mHYP<000001@0jCi@4000000L0>TnD00<00000
0=@m6@0jCi@00P0jCi@3000000030393N`000000<T=k00D0<T=k00<000000393N`0b@g/0100b@g/2
000000@09S1F00<0000002H`EP0V<5H00`0V<5H00`000000ooK^0=@m6@0403eIZ`L0ooK^00<0e3dI
0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI
0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP040?ofkP040=@m6@3om^h0ooK^000000<0ooK^00<0
e3dI0?ofkP3om^h0A`3om^h00`000000ooK^0?ofkP0B0?ofkP40oooo00110?ofkP030000003om^h0
ooK^01<0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^03eIZ`0203eIZ``0ooK^00<0?EV[
0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0000000B0?ofkP<0?EV[0`3om^h203eIZ`h0ooK^00D0?EV[
0?ofkP3om^h0ooK^03eIZ`040?ofkP<000000P0E1P820000008090X500<0000002@:1@0T2PD00P00
000403H?20030000000mFJ/0000000<0EaP<0`0mFJ/305LH30030000001G60`0000000@0N28@00<0
000004IR_016H[`00P16H[`01P3D?AT0AV:l04IR_016H[`0000004IR_080000000<0e3dI04=N/P13
G[800`13G[800`000000@ejb04=N/P0404=N/P040=@m6@13G[80@ejb000000@0@ejb00<0e3dI04=N
/P13G[800`13G[8010000000@ejb04=N/P13G[83000000<0?eRV00<0e3dI03mHYP0oF:H01`0oF:H0
0`3D?AT0?eRV03mHYP0703mHYP030000000oF:H00000008000000P0jCi@00`3D?AT0>TnD03Y?U002
000000H0>TnD00@0000003Y?U03D?AT0e3dI100jCi@3000000H0<T=k00<000000393N`0b@g/0100b
@g/00`000000<T=k0000000302H`EP030000000V<5H09S1F00<09S1F00<0e3dI0?ofkP3om^h00P3o
m^h403eIZ`@0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3o
m^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP030?ofkP040=@m6@3o
m^h0ooK^000000@0ooK^00<0e3dI0?ofkP3om^h0A`3om^h00`000000ooK^0?ofkP0B0?ofkP40oooo
00110?ofkP030000003om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h04P3om^h00`0mFJ/0ooK^0?of
kP030?ofkP<0?EV[2@3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`000000ooK^0180ooK^0P0m
FJ/0103om^h0?EV[03eIZ`0mFJ/20?ofkP<0?EV[2`3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00@0
ooK^0`0000000`0E1P8000000000000202@:1@060000000T2PD090X50000000f3`P00000100f3`P0
0`000000?EV[05LH300305LH30030000001G60`0EaP<00<0?EV[0P00000507PR400500000016H[`0
AV:l04IR_03D?AT01016H[`01`000000AV:l04IR_016H[`000000=@m6@0000000`13G[800`000000
@ejb04=N/P0304=N/P050=@m6@13G[80@ejb04=N/P0000001013G[800`3D?AT0@ejb04=N/P0304=N
/P0300000013G[80@ejb00@0@ejb0P0000000`3D?AT0000003mHYP0803mHYP030000003D?AT0?eRV
00L0?eRV00<0000003mHYP0oF:H00P0oF:H01`000000e3dI000000000000>TnD0000000jCi@00`00
000303Y?U0050000000jCi@0>TnD03Y?U03D?AT0100jCi@010000000>TnD0000000000040393N`03
0000000b@g/0<T=k00D0<T=k00H000000393N`000000000002H`EP00000502H`EP030=@m6@000000
?EV[00@0ooK^100mFJ/30?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h0203om^h0
0`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h00P3om^h0
103D?AT0ooK^0?ofkP0000040?ofkP030=@m6@3om^h0ooK^04P0ooK^00<000000?ofkP3om^h04P3o
m^h10?ooo`00@03om^h00`000000ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[
0?ofkP3om^h01P3om^h203eIZ`H0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0000000C
0?ofkP0303eIZ`3om^h0ooK^00<0ooK^0`0mFJ/20?ofkP<0?EV[1`3om^h00`0mFJ/0ooK^0?ofkP02
0?ofkP0403eIZ`3om^h0ooK^0?ofkP<0000000<0e3dI01D60P0000000`0T2PD00`000000e3dI0000
000203H?20030000000f3`P0=Pl80080=Pl800<0000003eIZ`1G60`00`1G60`00`000000EaP<05LH
300305LH3080?EV[1@1h8Q0010000000AV:l04IR_03D?AT504IR_00300000016H[`0AV:l0080AV:l
00H0e3dI04IR_0000000000004=N/P00000404=N/P030=@m6@13G[80@ejb0080@ejb00<0000004=N
/P13G[800`13G[800`3D?AT0@ejb04=N/P0204=N/P0300000013G[80@ejb00D0@ejb00@0e3dI0000
000000000000200oF:H00`000000e3dI03mHYP0703mHYP030000000oF:H0?eRV0080?eRV00@0e3dI
03mHYP0oF:H0?eRV0`00000303Y?U0<0000000<0>TnD0000000jCi@00P0jCi@01@3D?AT0>TnD03Y?
U00jCi@0000000<0>TnD0`0000020393N`030000000b@g/0<T=k00@0<T=k00@000000393N`0b@g/0
<T=k0`00000502H`EPD0?EV[0`3om^h503eIZ`050=@m6@3om^h0ooK^0?ofkP3D?AT02`3om^h00`3D
?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h00P3D?AT20?of
kP030000003om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h0B@3om^h00`000000ooK^0?ofkP0A0?of
kP40oooo000o0?ofkP030000003om^h0ooK^01@0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0
ooK^0?ofkP080?ofkP<0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`000000ooK^0180
ooK^0P0mFJ/80?ofkP<0?EV[0P3om^h203eIZ`D0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`030?of
kP80000000<05@H20=@m6@0E1P800P00000302@:1@8000000`0f3`P010000000=Pl803H?200f3`P2
0000000303eIZ`1G60`0EaP<00<0EaP<00@0000005LH301G60`0EaP<0P000000101h8Q00?EV[03eI
Z`0mFJ/207PR400300000016H[`0e3dI00H0AV:l00<0000004IR_016H[`00`16H[`00`3D?AT0AV:l
04IR_00300000080@ejb00<0e3dI04=N/P13G[800`13G[800`000000@ejb04=N/P0404=N/P050=@m
6@13G[80@ejb04=N/P0000001`13G[80103D?AT0@ejb00000013G[83000000D0?eRV00<0000003mH
YP3D?AT01`0oF:H01@000000?eRV03mHYP0oF:H0e3dI00D0?eRV00@0000003mHYP0000000000100j
Ci@2000000@0>TnD00D0e3dI03Y?U00jCi@0>TnD0000000503Y?U0<000001`0b@g/00`000000<T=k
0393N`020393N`<00000100V<5H010000000?EV[03eIZ`3om^h303eIZ`060?ofkP0mFJ/0ooK^0?of
kP0mFJ/0e3dI0P0mFJ/00`3D?AT0ooK^0?ofkP0:0?ofkP040=@m6@3om^h0ooK^0?ofkP80e3dI2P3o
m^h00`3D?AT0ooK^0=@m6@020?ofkP8000001P3om^h00`3D?AT0ooK^0?ofkP190?ofkP030000003o
m^h0ooK^0140ooK^0@3oool003l0ooK^00<000000?ofkP3om^h0503om^h00`0mFJ/0ooK^0?ofkP0C
0?ofkP0303eIZ`3om^h0ooK^00/0ooK^100mFJ/40?ofkP030000003om^h0ooK^0180ooK^0P0mFJ/;
0?ofkP80?EV[0P3om^h303eIZ`030?ofkP0mFJ/0ooK^00<0ooK^00<0?EV[0?ofkP3om^h00P000000
1P0E1P8000000=@m6@00000090X5000000<090X500<0e3dI0000000f3`P00P0f3`P01P000000=Pl8
03H?200f3`P0000003eIZ`H0EaP<00H0000005LH301G60`0000007PR4000000407PR4080?EV[00<0
00000=@m6@16H[`01P16H[`00`000000AV:l04IR_00304IR_0090=@m6@16H[`0AV:l04IR_0000000
AV:l0000003D?AT0000000D0@ejb00<0000004=N/P13G[801@13G[800`3D?AT0@ejb0000000704=N
/P040=@m6@13G[80@ejb000000@0@ejb100000001@0oF:H0000003mHYP0oF:H0e3dI00H0?eRV00@0
000003mHYP0oF:H0e3dI1P0oF:H010000000?eRV03mHYP0oF:H2000000<0>TnD1000000203Y?U080
e3dI00<0>TnD0000000jCi@01P0jCi@3000000D0<T=k00<000000393N`0b@g/0100b@g/400000080
9S1F00@000000?ofkP0mFJ/0?EV[0P3om^h603eIZ`80e3dI0`0mFJ/;0?ofkP030=@m6@3om^h0e3dI
00`0ooK^0P3D?AT20?ofkP030000003om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h0BP3om^h00`00
0000ooK^0?ofkP0A0?ofkP40oooo000n0?ofkP030000003om^h0ooK^01D0ooK^00<0?EV[0?ofkP3o
m^h04P3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP@0?EV[00<0ooK^0000003om^h0503om^h00`0mFJ/0
ooK^0?ofkP0<0?ofkP<0?EV[0P3om^h303eIZ`<0ooK^00@0?EV[0?ofkP3om^h000000P0E1P80103D
?AT0000002@:1@00000402@:1@030000000f3`P0=Pl80080=Pl800H0000003H?200f3`P0000005LH
300mFJ/605LH30030000001G60`0000000<0N28@00<0000007PR401h8Q000`1h8Q000`0mFJ/0AV:l
04IR_00604IR_00300000016H[`0AV:l00@0AV:l00H0e3dI04IR_016H[`0000004IR_03D?AT204IR
_0@0000000<0@ejb00000013G[801P13G[800`3D?AT0@ejb0000000604=N/P050=@m6@13G[80@ejb
04=N/P0000002013G[8300000080?eRV00<0e3dI03mHYP0oF:H00`0oF:H00`000000?eRV0=@m6@07
03mHYP030000000oF:H0?eRV00<0?eRV0P0000000`0jCi@0000003Y?U00203Y?U08000000P0jCi@0
0`3D?AT0000003Y?U00703Y?U0030000000jCi@00000008000000`0b@g/00`000000<T=k0393N`03
0393N`040000000b@g/0<T=k0393N`@0000000<0ooK^03eIZ`0mFJ/00P0mFJ/01P3om^h0?EV[03eI
Z`0mFJ/0ooK^0=@m6@80ooK^100mFJ/90?ofkP80e3dI3@3om^h0103D?AT0ooK^0?ofkP0000070?of
kP80e3dIC03om^h00`000000ooK^0?ofkP0A0?ofkP40oooo000m0?ofkP030000003om^h0ooK^01D0
ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0703eIZ`3om^h0ooK^0?of
kP0mFJ/0000003eIZ`0C0?ofkP80?EV[4@3om^h403eIZ`030?ofkP0mFJ/0?EV[0080?EV[00<0ooK^
0000000000000P0E1P80103D?AT0000002@:1@00000302@:1@800000100f3`P00`000000=Pl80000
000205LH300303eIZ`000000EaP<00@0EaP<00<0000005LH300000000`1h8Q000`000000N28@07PR
400407PR400300000016H[`0AV:l00D0AV:l00<0000004IR_016H[`01016H[`01P3D?AT0AV:l04IR
_0000000AV:l0=@m6@H0AV:l0`00000704=N/P030=@m6@000000@ejb00@0@ejb00<0e3dI04=N/P13
G[800P13G[800`000000@ejb04=N/P0704=N/P0600000013G[8000000000000oF:H0e3dI100oF:H0
0`000000e3dI03mHYP0703mHYP030000000oF:H0?eRV00D0?eRV0`00000403Y?U0<0000000<0e3dI
03Y?U00jCi@01P0jCi@00`000000>TnD03Y?U00203Y?U0@000001P0b@g/00`000000<T=k0393N`03
0393N`800000103om^h303eIZ`040?ofkP3D?AT0e3dI03eIZ`@0ooK^0`0mFJ/70?ofkP030=@m6@3o
m^h0ooK^00/0ooK^0P3D?AT00`3om^h000000?ofkP060?ofkP80e3dICP3om^h00`000000ooK^0?of
kP0@0?ofkP40oooo000m0?ofkP030000003om^h0ooK^01D0ooK^0P0mFJ/D0?ofkP0303eIZ`3om^h0
ooK^00h0ooK^00L0?EV[0?ofkP3om^h0ooK^0000000mFJ/0ooK^00<0?EV[403om^h203eIZa<0ooK^
100mFJ/00`3om^h0?EV[03eIZ`02000000805@H20P00000202@:1@060000000T2PD090X50000000f
3`P00000100f3`P200000080EaP<00<0?EV[05LH300000001@1G60`2000000@0N28@00<0000007PR
401h8Q00101h8Q000`000000AV:l04IR_00604IR_00300000016H[`0AV:l00@0AV:l00@0e3dI04IR
_0000000e3dI2016H[`010000000AV:l00000000000604=N/P030=@m6@13G[80@ejb0080@ejb00<0
e3dI04=N/P13G[800`13G[800`000000@ejb04=N/P0704=N/P0400000013G[80@ejb04=N/P800000
00D0e3dI03mHYP0oF:H0?eRV0=@m6@0903mHYP030000000oF:H0?eRV00H0?eRV00@0000003eIZ`00
00000000100jCi@0103D?AT0000000000000000603Y?U0030000000jCi@0>TnD00D0>TnD0`000004
0393N`030000000b@g/0<T=k00D0<T=k00<000000?ofkP3om^h00`3om^h01@0mFJ/0e3dI03eIZ`3D
?AT0ooK^00<0?EV[103om^h303eIZ`<0ooK^0P3D?AT<0?ofkP80e3dI00<0ooK^0000003om^h01@3o
m^h20=@m6@030?ofkP3D?AT0ooK^04d0ooK^00<000000?ofkP3om^h0403om^h10?ooo`00?03om^h0
0`000000ooK^0?ofkP0F0?ofkP0303eIZ`3om^h0?EV[0080?EV[4@3om^h00`0mFJ/0ooK^0?ofkP0=
0?ofkP0603eIZ`3om^h0ooK^0?ofkP000000?EV[1@3om^h203eIZ`h0ooK^00<0?EV[0?ofkP3om^h0
4P3om^h0100mFJ/0ooK^0?ofkP3om^h303eIZ`8000000P0E1P801`00000090X502@:1@0T2PD00000
02@:1@0000000P0f3`P00`000000=Pl803H?200203H?208000000P1G60`00`0mFJ/0EaP<00000005
05LH30030000001h8Q00N28@00<0N28@00<0000007PR401h8Q00101h8Q000`000000AV:l04IR_006
04IR_00300000016H[`0AV:l00@0AV:l00<0e3dI04IR_03D?AT02@16H[`010000000AV:l04IR_016
H[`3000000<0@ejb00D000000=@m6@13G[80@ejb0=@m6@0504=N/P0300000013G[80@ejb00P0@ejb
00<0000004=N/P13G[801013G[80103D?AT000000=@m6@00000803mHYP030000000oF:H0?eRV00L0
?eRV00@0000003mHYP0oF:H0?eRV0`0000001@3D?AT0>TnD03Y?U0000000>TnD00800000100jCi@0
0`000000>TnD03Y?U00603Y?U0040000000jCi@00000000000<0<T=k00<000000393N`0b@g/0100b
@g/00`000000ooK^0?ofkP030?ofkP060=@m6@3om^h0?EV[03eIZ`3D?AT0?EV[0P3om^h203eIZ`@0
ooK^0`0mFJ/00`3D?AT0ooK^0=@m6@0;0?ofkP040=@m6@3om^h0e3dI000000H0ooK^00@0e3dI0?of
kP3om^h0e3dIC`3om^h00`000000ooK^0?ofkP0@0?ofkP40oooo000l0?ofkP030000003om^h0ooK^
01D0ooK^00<0?EV[0?ofkP3om^h00`3om^h303eIZ`d0ooK^00<0?EV[0?ofkP3om^h03P3om^h203eI
Z`040?ofkP000000ooK^03eIZ`L0ooK^0`0mFJ/:0?ofkP80?EV[503om^h00`0mFJ/0ooK^0?ofkP02
0?ofkP0303eIZ`000000?EV[0080?EV[0P00000202@:1@030000000T2PD0000000<0=Pl800<00000
03H?200f3`P00P0f3`P01`000000EaP<05LH301G60`0?EV[05LH30000000101G60`2000000H0N28@
00<0000007PR401h8Q000`1h8Q02000000L0AV:l00<0000004IR_016H[`01@16H[`00`3D?AT00000
04IR_00804IR_00300000016H[`0AV:l00@0AV:l0P0000001@13G[8000000=@m6@13G[80e3dI00H0
@ejb00<0000004=N/P13G[802013G[800`000000@ejb04=N/P0504=N/P040=@m6@00000000000000
00L0?eRV00<0000003mHYP0oF:H01`0oF:H00`000000?eRV03mHYP0303mHYP050=@m6@0000000000
03Y?U00000000`0jCi@300000080>TnD00<0000003Y?U00jCi@01@0jCi@010000000>TnD03Y?U00j
Ci@200000080<T=k00<000000393N`0b@g/0100b@g/01@000000?EV[0?ofkP3om^h0e3dI0080ooK^
00@0?EV[0?ofkP3D?AT0ooK^0`0mFJ/0103om^h0?EV[03eIZ`0mFJ/20?ofkP0503eIZ`3D?AT0?EV[
03eIZ`3D?AT02P3om^h0103D?AT0ooK^0?ofkP3D?AT60?ofkP040=@m6@3om^h0ooK^0=@m6E00ooK^
00<000000?ofkP3om^h0403om^h10?ooo`00>`3om^h00`000000ooK^0?ofkP0F0?ofkP0303eIZ`3o
m^h0ooK^00H0ooK^0P0mFJ/;0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00@0?EV[0?ofkP0mFJ/00000
0P0mFJ/:0?ofkP<0?EV[1`3om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^0080ooK^
00H0?EV[01D60P000000000001D60P00000203eIZ`8090X50P00000403H?20040000000f3`P0=Pl8
03H?208000000`1G60`00`0mFJ/0EaP<0000000305LH30030000001h8Q00000000H0N28@00<00000
07PR401h8Q000P1h8Q020000000304QVa0000000000000D0AV:l00<0000004IR_016H[`01016H[`0
103D?AT0AV:l0=@m6@00000804IR_00300000016H[`0AV:l00H0AV:l0`0000000`3D?AT0@ejb04=N
/P0504=N/P0300000013G[80@ejb00P0@ejb00<0000004=N/P13G[801013G[801@3D?AT0@ejb0=@m
6@000000@ejb008000001@0oF:H00`000000?eRV03mHYP0703mHYP030000000oF:H0?eRV0080?eRV
00@0e3dI03mHYP0oF:H0?eRV0`00000403Y?U0040=@m6@0000000000000000P0>TnD00<0000003Y?
U00jCi@00P0jCi@3000000H0<T=k00@000000?ofkP0mFJ/0e3dI103om^h00`0mFJ/0e3dI0?ofkP03
0?ofkP<0?EV[00@0ooK^03eIZ`0mFJ/0e3dI0P0mFJ/00`3om^h0e3dI03eIZ`080?ofkP050=@m6@3o
m^h000000000003D?AT01@3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI0500ooK^00<000000?ofkP3o
m^h0403om^h10?ooo`00>P3om^h00`000000ooK^0?ofkP0G0?ofkP0303eIZ`3om^h0ooK^00P0ooK^
0`0mFJ/80?ofkP0303eIZ`3om^h0ooK^00d0ooK^00@0?EV[0?ofkP3om^h000000P3om^h303eIZ`/0
ooK^0P0mFJ/50?ofkP0303eIZ`3om^h0ooK^0180ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0
000001D60P020000000302@:1@00000090X500<0?EV[1@0f3`P01P000000=Pl803H?20000000EaP<
00000080EaP<00@0?EV[05LH301G60`000000P1G60`010000000N28@07PR4000000607PR40070000
001h8Q00N28@07PR40000000TbXC0000000304QVa08000000`16H[`00`000000AV:l04IR_00304IR
_0050=@m6@16H[`0AV:l0=@m6@0000002016H[`00`000000AV:l04IR_00704IR_0050000003D?AT0
00000=@m6@0000001@13G[800`000000@ejb04=N/P0704=N/P0300000013G[80@ejb00@0@ejb00@0
e3dI04=N/P13G[80@ejb0P3D?AT204=N/P8000000`0oF:H00`000000?eRV03mHYP0703mHYP050000
000oF:H0?eRV03mHYP3D?AT01@0oF:H00`000000?eRV0000000200000080>TnD0P3D?AT3000000H0
>TnD00<0000003Y?U00jCi@0100jCi@3000000D0<T=k0P3D?AT01`3om^h0?EV[03eIZ`0mFJ/0ooK^
03eIZ`3D?AT01P3om^h303eIZ`030=@m6@3om^h0?EV[0080?EV[00<0e3dI03eIZ`0mFJ/00P0mFJ/4
0?ofkP050=@m6@3om^h000000?ofkP3D?AT01@3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI0580ooK^
00<000000?ofkP3om^h03`3om^h10?ooo`00>P3om^h00`000000ooK^0?ofkP0G0?ofkP0303eIZ`3o
m^h0ooK^00/0ooK^0`0mFJ/50?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP0000000P3o
m^h0100mFJ/0ooK^0?ofkP3om^h303eIZ`X0ooK^0`0mFJ/00`3om^h0?EV[03eIZ`0C0?ofkP0303eI
Z`3om^h0ooK^00<0ooK^00<0?EV[0000000E1P800P000000100T2PD0000002@:1@0T2PD2000000<0
?EV[0P0f3`P00`000000=Pl80000000305LH30030000001G60`0?EV[00<0EaP<00<0000005LH3000
00000`1h8Q000`000000N28@07PR400307PR40040000001h8Q00N28@00000080TbXC00<0000004QV
a018I/@00`18I/@20000000304IR_0000000AV:l00<0AV:l00<0e3dI04IR_016H[`00P16H[`00`3D
?AT0AV:l04IR_00604IR_00300000016H[`0AV:l00L0AV:l00D0e3dI04IR_016H[`0AV:l0=@m6@04
0000000304=N/P000000@ejb00P0@ejb00<0000004=N/P13G[800`13G[801@3D?AT0@ejb04=N/P13
G[8000000080@ejb00@0e3dI04=N/P13G[80@ejb0P0000000`0oF:H0000003mHYP0803mHYP040000
000oF:H0?eRV0=@m6@H0?eRV00<0000003mHYP0oF:H00P0oF:H30000000403Y?U03D?AT0e3dI03Y?
U0<000000`0jCi@00`000000>TnD03Y?U00503Y?U0030000000jCi@00000008000000`0b@g/203eI
Z`<0ooK^0`0mFJ/00`3D?AT0ooK^0?ofkP0303eIZ`040?ofkP3D?AT0e3dI0?ofkP@0?EV[00<0e3dI
0?ofkP3om^h00P3om^h203eIZ`80e3dI00D0ooK^0000003om^h0ooK^0=@m6@040?ofkP030=@m6@3o
m^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h0D03om^h00`000000ooK^0?ofkP0?0?ofkP40oooo000i
0?ofkP030000003om^h0ooK^01L0ooK^00<0?EV[0?ofkP3om^h03`3om^h303eIZ`030?ofkP0mFJ/0
ooK^00h0ooK^00@0?EV[0?ofkP3om^h000000P3om^h00`0mFJ/0ooK^0?ofkP040?ofkP<0?EV[2P3o
m^h303eIZa<0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0000001D60P020000008090X500D0
000002@:1@000000=Pl80000000303H?20<0?EV[00<0=Pl80000001G60`00P1G60`00`000000EaP<
03eIZ`0305LH30800000101h8Q000`000000N28@07PR400407PR40030000001h8Q00000000<0TbXC
00<0000004QVa018I/@01018I/@300000080AV:l00<0e3dI04IR_016H[`00`16H[`00`000000e3dI
04IR_00604IR_00300000016H[`0AV:l00H0AV:l00<0e3dI00000016H[`00`16H[`0103D?AT0AV:l
04IR_016H[`3000000P0@ejb00<0000004=N/P13G[800P13G[800`3D?AT0@ejb04=N/P0204=N/P05
00000013G[80@ejb04=N/P3D?AT01013G[83000000P0?eRV00<0000003mHYP3D?AT01`0oF:H00`00
0000?eRV03mHYP0503mHYP<000000P3D?AT203Y?U080000000<0>TnD0000000jCi@01P0jCi@00`00
0000>TnD03Y?U00203Y?U0@0000000<0ooK^03eIZ`0mFJ/00`3om^h0100mFJ/0e3dI03eIZ`0mFJ/3
0?ofkP030=@m6@3om^h0ooK^00@0ooK^0P0mFJ/00`3D?AT0?EV[0?ofkP020?ofkP040=@m6@0mFJ/0
?EV[03eIZ`<0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@040?ofkP030=@m6@3om^h0ooK^0540ooK^
00<000000?ofkP3om^h03`3om^h10?ooo`00>@3om^h00`000000ooK^0?ofkP0G0?ofkP0303eIZ`3o
m^h0ooK^0180ooK^0`0mFJ/>0?ofkP0303eIZ`3om^h0000000<0ooK^00<0?EV[0?ofkP3om^h01`3o
m^h303eIZ`P0ooK^00<0?EV[0?ofkP0mFJ/00P0mFJ/@0?ofkP0903eIZ`3om^h0ooK^0?ofkP000000
?EV[0=@m6@0E1P80000000<090X50P00000203H?20030000000f3`P0=Pl800<0=Pl800<0000003eI
Z`0mFJ/00`1G60`00`000000EaP<03eIZ`0305LH30030000001h8Q00N28@00<0N28@00<0000007PR
401h8Q00101h8Q02000000@0TbXC00<0000004QVa018I/@01@18I/@01@000000B6K40000003D?AT0
000000D0AV:l00<0000004IR_03D?AT01P16H[`00`000000AV:l04IR_00504IR_0030=@m6@16H[`0
000000D0AV:l00H0e3dI04IR_016H[`0AV:l00000016H[`2000000H0@ejb00D0000004=N/P13G[80
@ejb0=@m6@0504=N/P0300000013G[80@ejb0080@ejb00<0e3dI04=N/P13G[800P13G[800`000000
@ejb00000002000000D0?eRV00<000000=@m6@0oF:H01`0oF:H00`000000?eRV03mHYP0603mHYP04
0000000mFJ/0000000000080e3dI0P0jCi@3000000L0>TnD00<0000003Y?U00jCi@0100jCi@20000
0080ooK^0P0mFJ/00`3om^h0?EV[0=@m6@020?ofkP80?EV[00<0e3dI0?ofkP3om^h01P3om^h00`0m
FJ/0e3dI03eIZ`0203eIZ`040=@m6@3om^h0ooK^000000@0?EV[00@0e3dI0?ofkP3D?AT0e3dI103o
m^h00`3D?AT0ooK^0?ofkP1B0?ofkP030000003om^h0ooK^00l0ooK^0@3oool003P0ooK^0P00000I
0?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP0mFJ/00P0mFJ/;0?ofkP0303eIZ`000000
ooK^00<0ooK^00<0?EV[0?ofkP3om^h02P3om^h303eIZ`@0ooK^0P0mFJ/40?ofkP<0?EV[303om^h0
100mFJ/0ooK^0?ofkP3om^h20000000403eIZ`0E1P8000000000008090X500<0000002@:1@000000
0P0f3`P00`000000=Pl803H?200303H?20030000001G60`0EaP<00<0?EV[00<0000003eIZ`1G60`0
0P1G60`2000000D0N28@00<0000007PR401h8Q00101h8Q000`000000TbXC09<Z4`0309<Z4`030000
0018I/@0B6K400D0B6K400<0000004QVa03D?AT00P18I/@40000000404IR_0000000AV:l0=@m6@H0
AV:l00<0000004IR_016H[`01016H[`0103D?AT0AV:l04IR_000000604IR_0040=@m6@16H[`0AV:l
000000<0AV:l0`00000304=N/P0400000013G[80@ejb0=@m6@H0@ejb00<0000004=N/P13G[800`13
G[820=@m6@80@ejb00<0000004=N/P13G[800P13G[840000000303mHYP3D?AT0?eRV00P0?eRV00<0
000003mHYP0oF:H01P0oF:H010000000?eRV03mHYP0oF:H200000080e3dI0P0jCi@4000000@0>TnD
00<0000003Y?U00jCi@01@0jCi@010000000ooK^0?ofkP3om^h303eIZ`050=@m6@3om^h0ooK^0?of
kP3D?AT00`0mFJ/70?ofkP040=@m6@3om^h0ooK^0=@m6@<0?EV[0`3om^h0100mFJ/0e3dI03eIZ`3D
?AT40?ofkP80e3dIEP3om^h00`000000ooK^0?ofkP0>0?ofkP40oooo000h0?ofkP030000003om^h0
0000008000005P3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^0080ooK^0`0mFJ/7
0?ofkP0303eIZ`000000ooK^00<0ooK^00<0?EV[0?ofkP3om^h03P3om^h303eIZ`030?ofkP0mFJ/0
ooK^00L0ooK^100mFJ/80?ofkP0303eIZ`3om^h0ooK^0080000000D0?EV[0=@m6@00000090X50000
000202@:1@8000000`0f3`P00`000000=Pl803H?200203H?208000001@1G60`303eIZ`0405LH3000
0000N28@000000D0N28@00<0000007PR401h8Q000`1h8Q02000000D0TbXC00<0000004QVa018I/@0
1@18I/@00`000000B6K40=@m6@0604QVa0<0000000<0AV:l0=@m6@16H[`01016H[`00`000000AV:l
04IR_00304IR_0050=@m6@16H[`0AV:l04IR_00000001`16H[`00`3D?AT0AV:l0000000604IR_080
000000@0@ejb00000013G[80e3dI1`13G[800`000000@ejb04=N/P0504=N/P030=@m6@13G[800000
00P0@ejb00<0e3dI000000000000200oF:H00`000000?eRV03mHYP0603mHYP030000000oF:H0?eRV
0080?eRV00<0e3dI03mHYP0000000P3D?AT010000000>TnD03Y?U00jCi@200000080>TnD00<00000
03Y?U00jCi@01@0jCi@010000000ooK^03eIZ`0mFJ/30?ofkP0403eIZ`3D?AT0?EV[0=@m6@@0ooK^
0P0mFJ/50?ofkP030=@m6@3om^h0e3dI0080ooK^100mFJ/20?ofkP80e3dI00@0ooK^03eIZ`0mFJ/0
?EV[0P3D?AUG0?ofkP030000003om^h0ooK^00h0ooK^0@3oool003P0ooK^00<000000?ofkP3om^h0
0P3om^h300000180ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP060?ofkP80?EV[
1@3om^h00`0mFJ/000000?ofkP030?ofkP0303eIZ`3om^h0ooK^0140ooK^0`0mFJ/;0?ofkP<0?EV[
1@3om^h02@0mFJ/0ooK^0?ofkP0000005@H203eIZ`00000090X50000000302@:1@030000000f3`P0
=Pl800<0=Pl800H0000003H?200f3`P0000005LH3000000505LH30030000000mFJ/0EaP<00<0?EV[
00<0000007PR401h8Q000`1h8Q000`000000N28@07PR400207PR40030000002C:Q<0000000D0TbXC
00<000000=@m6@18I/@01P18I/@00`3D?AT0B6K404QVa00604QVa00500000018I/@000000000003D
?AT01016H[`00`000000AV:l04IR_00204IR_0030=@m6@16H[`0AV:l0080AV:l00<0000004IR_016
H[`01P16H[`00`3D?AT0000004IR_00704IR_080000000<0e3dI04=N/P13G[801P13G[800`000000
@ejb04=N/P0604=N/P030=@m6@000000@ejb00H0@ejb00@0e3dI04=N/P000000@ejb0P00000603mH
YP030000000oF:H0?eRV00H0?eRV00D0000003mHYP0oF:H0?eRV0=@m6@0403mHYP040000003D?AT0
e3dI0=@m6@<0>TnD0`00000803Y?U0030000003om^h0ooK^00@0ooK^0P3D?AT303eIZ`@0ooK^0`0m
FJ/20?ofkP80e3dI00<0ooK^0000000000000P3om^h403eIZ`030=@m6@0mFJ/0?EV[0080?EV[00@0
e3dI03eIZ`0mFJ/0?EV[EP3om^h00`000000ooK^0?ofkP0>0?ofkP40oooo000g0?ofkP030000003o
m^h0ooK^00H0ooK^0`00000?0?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h0203o
m^h303eIZ`030?ofkP0mFJ/0000000D0ooK^00<0?EV[0?ofkP3om^h04P3om^h00`0mFJ/0ooK^03eI
Z`0203eIZ`/0ooK^0`0mFJ/0103om^h0?EV[0?ofkP3om^h20000000503eIZ`3D?AT0000002@:1@00
00000P0T2PD2000000D0=Pl800<0000003H?200000000P1G60`00`000000EaP<05LH300305LH3004
03eIZ`000000EaP<00000080N28@0`0mFJ/407PR40040000001h8Q00N28@000000<0TbXC00<00000
09<Z4`2C:Q<00P2C:Q<00`0mFJ/0B6K40=@m6@0504QVa0030=@m6@000000B6K400L0B6K400D00000
04QVa018I/@0B6K40=@m6@030000000304IR_0000000AV:l0080AV:l00<0e3dI04IR_016H[`00`16
H[`00`000000AV:l04IR_00704IR_0030=@m6@16H[`0AV:l00L0AV:l00@0e3dI04IR_00000000000
1@13G[800`000000@ejb04=N/P0804=N/P030=@m6@13G[80@ejb00@0@ejb00@0e3dI04=N/P13G[80
00000`13G[83000000<0?eRV00<0000003mHYP0oF:H01P0oF:H010000000?eRV03mHYP3D?AT603mH
YP030000000oF:H0000000<0e3dI0`0jCi@3000000D0>TnD00<000000?ofkP3om^h0103om^h00`3D
?AT0ooK^0?ofkP020?ofkP<0?EV[103om^h203eIZ`040=@m6@0mFJ/000000?ofkP@0?EV[0P3om^h0
103D?AT0?EV[0?ofkP0mFJ/20=@m6@<0ooK^0`0mFJ]D0?ofkP030000003om^h0ooK^00h0ooK^0@3o
ool003L0ooK^00<000000?ofkP3om^h02@3om^h3000000`0ooK^00<0?EV[0?ofkP3om^h04`3om^h0
0`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`000000?EV[00D0ooK^00<0?EV[0?ofkP3om^h04@3om^h0
0`0mFJ/0ooK^0?ofkP030?ofkP<0?EV[2`3om^h203eIZ`060?ofkP000000000001D60P0mFJ/00000
0P0T2PD01@00000090X50000000f3`P0000000D0=Pl800<0000003H?200000000P1G60`00`000000
EaP<05LH300305LH300303eIZ`000000000000@0N28@00<0000007PR400mFJ/00P0mFJ/0101h8Q00
000007PR4000000409<Z4`030000002C:Q<0TbXC0080TbXC00<0?EV[04QVa03D?AT01018I/@00`3D
?AT0B6K40000000804QVa00300000018I/@0B6K40080B6K400<0e3dI04QVa018I/@00`0000000`16
H[`0e3dI04IR_00504IR_00300000016H[`0AV:l00L0AV:l00<000000=@m6@16H[`01P16H[`00`3D
?AT0000004IR_00204IR_08000000`13G[800`000000@ejb04=N/P0704=N/P0400000013G[80e3dI
0=@m6@<0@ejb00@0e3dI04=N/P13G[8000001`13G[820000000303mHYP000000?eRV00L0?eRV00<0
000003mHYP3D?AT01`0oF:H00`000000?eRV03mHYP0203mHYP050000003D?AT0e3dI03Y?U0000000
0P0jCi@2000000<0>TnD00<0000003eIZ`3om^h00`3om^h20=@m6@0303eIZ`3om^h0ooK^00@0ooK^
0P0mFJ/30?ofkP80e3dI0`0mFJ/50?ofkP80e3dI00@0ooK^0=@m6@3D?AT0e3dI1`3om^h303eIZe40
ooK^00<000000?ofkP3om^h03P3om^h10?ooo`00=`3om^h00`000000ooK^0?ofkP0<0?ofkP<00000
2@3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0000003om^h0
0`0mFJ/00`3om^h0?EV[0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^00H0ooK^0`0mFJ/90?ofkP0603eI
Z`00000000000000000E1P80?EV[0`0T2PD200000080=Pl800<0000003H?200f3`P00`0f3`P20000
00<0EaP<00<0000005LH301G60`00`1G60`00`0mFJ/0000007PR400407PR40030000001h8Q00N28@
0080N28@100mFJ/409<Z4`060000002C:Q<0TbXC09<Z4`0mFJ/000000P18I/@0103D?AT0B6K404QV
a03D?AT204QVa00300000018I/@0B6K400H0B6K400<0000004QVa018I/@00`18I/@01`3D?AT0B6K4
04QVa0000000B6K40=@m6@0000001P16H[`00`000000AV:l04IR_00604IR_00400000016H[`0AV:l
0=@m6@D0AV:l00<0e3dI00000016H[`01@16H[`20000000304=N/P000000@ejb00P0@ejb00L00000
04=N/P13G[80@ejb0=@m6@13G[80e3dI00<0@ejb00<0000004=N/P13G[801`13G[83000000L0?eRV
00<000000=@m6@0oF:H01`0oF:H00`000000?eRV03mHYP0503mHYP<0e3dI0`0jCi@4000000080?of
kP0mFJ/0?EV[03eIZ`3D?AT0ooK^0=@m6@0mFJ/80?ofkP80?EV[0P3D?AT00`0mFJ/0ooK^03eIZ`04
0?ofkPL0e3dI0`0mFJ/80?ofkP80?EV[D03om^h00`000000ooK^0?ofkP0=0?ofkP40oooo000g0?of
kP030000003om^h0ooK^00l0ooK^100000040?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?of
kP3om^h0303om^h00`000000ooK^0?ofkP030?ofkP<0?EV[4P3om^h203eIZ`/0ooK^0P0mFJ/60?of
kP0703eIZ`000000000001D60P000000?EV[0000000202@:1@030000000T2PD000000080=Pl800<0
000003H?200f3`P00`0f3`P00`000000EaP<05LH300305LH30050000001G60`0EaP<05LH300mFJ/0
0P00000507PR40030000001h8Q00N28@00<0N28@00<0000009<Z4`2C:Q<00`0mFJ/00`2C:Q<00000
09<Z4`0209<Z4`0703eIZ`2C:Q<0000004QVa03D?AT0B6K40=@m6@0304QVa00300000018I/@0B6K4
00H0B6K400<0000004QVa018I/@01018I/@0103D?AT0B6K40000003D?AT204QVa0<000000`16H[`0
0`000000AV:l04IR_00604IR_00500000016H[`0AV:l04IR_03D?AT00`16H[`00`3D?AT0AV:l0000
000804IR_0<000002013G[800`000000@ejb04=N/P0204=N/P030=@m6@13G[80@ejb0080@ejb00<0
000004=N/P13G[802013G[800`000000@ejb00000002000000@0?eRV00<0e3dI03mHYP0oF:H01`0o
F:H00`000000?eRV03mHYP0603mHYP030000000mFJ/0e3dI00<0e3dI0P0jCi@200000080ooK^00D0
e3dI03eIZ`0mFJ/0e3dI03eIZ`080?ofkP80e3dI00H0?EV[0=@m6@0mFJ/0?EV[0?ofkP0mFJ/20?of
kP@0e3dI00<0ooK^0=@m6@3D?AT00`3om^h403eIZ`L0ooK^00<0?EV[0?ofkP3om^h0C@3om^h00`00
0000ooK^0?ofkP0=0?ofkP40oooo000g0?ofkP030000003om^h0ooK^01<0ooK^0`0000000`3om^h0
?EV[03eIZ`0D0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0000003eIZ`3om^h01@3om^h00`0mFJ/0
ooK^03eIZ`0203eIZ`l0ooK^00<0?EV[0?ofkP3om^h0303om^h303eIZ`<0ooK^00L0?EV[0000000E
1P80000001D60P0mFJ/00000008090X50P00000303H?20030000000f3`P0=Pl80080=Pl80P000005
05LH30070000001G60`0EaP<05LH300mFJ/0N28@0000000507PR40030000001h8Q00N28@0080N28@
0P00000509<Z4`<0?EV[00D0TbXC03eIZ`2C:Q<0TbXC0000000204QVa0030=@m6@18I/@0B6K40080
B6K400<0000004QVa018I/@01P18I/@00`000000B6K404QVa00404QVa0030=@m6@18I/@0e3dI00H0
B6K40P0000000`16H[`0000004IR_00704IR_00300000016H[`0AV:l0080AV:l00<0e3dI04IR_03D
?AT00P16H[`00`000000AV:l04IR_00704IR_00300000016H[`00000008000001@13G[801P000000
@ejb04=N/P13G[80e3dI04=N/P80e3dI0P13G[800`000000@ejb04=N/P0804=N/P0300000013G[80
@ejb0080@ejb0P0000020=@m6@030000000oF:H0?eRV00H0?eRV00<0000003mHYP0oF:H01`0oF:H0
10000000?eRV0=@m6@0oF:H2000000@0e3dI0`0000020?ofkP030=@m6@0mFJ/0?EV[00H0ooK^00D0
e3dI03eIZ`0mFJ/000000=@m6@020?ofkP80?EV[0`3D?AT00`3om^h0e3dI0?ofkP020=@m6@@0ooK^
00@0?EV[0?ofkP3om^h0ooK^0`0mFJ/50?ofkP0303eIZ`3om^h0ooK^04`0ooK^00<000000?ofkP3o
m^h03@3om^h10?ooo`00=P3om^h00`000000ooK^0?ofkP0G0?ofkP030000000mFJ/0000000@0?EV[
403om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP030000000mFJ/0ooK^00H0ooK^00<0?EV[0?ofkP3om^h0
0P3om^h303eIZ``0ooK^00<0?EV[0?ofkP3om^h03`3om^h303eIZ`80000000D05@H2000000000000
?EV[0000000202@:1@030000000f3`P0=Pl800<0=Pl800H0000003H?200f3`P0000005LH30000005
05LH30050000001G60`0EaP<0000000mFJ/00P1h8Q000`000000N28@07PR400207PR40050000001h
8Q00N28@07PR400000000P2C:Q<00`000000TbXC09<Z4`0409<Z4`0:0000000mFJ/0?EV[03eIZ`2C
:Q<0000004QVa03D?AT0B6K40=@m6@<0B6K400<0000004QVa018I/@01P18I/@00`000000B6K404QV
a00504QVa0030=@m6@000000B6K400L0B6K40`00000704IR_00300000016H[`0AV:l00<0AV:l00D0
e3dI04IR_016H[`0AV:l0000000904IR_00300000016H[`0AV:l0080AV:l100000001@13G[800000
04=N/P13G[80e3dI00@0@ejb0P3D?AT00`000000@ejb04=N/P0704=N/P0300000013G[80@ejb00@0
@ejb00<0e3dI04=N/P0000000P00000703mHYP030000000oF:H0?eRV00L0?eRV00<000000=@m6@0o
F:H00`0oF:H20000000303Y?U0000000e3dI0080e3dI0`0000000`0mFJ/0ooK^03eIZ`0203eIZ`80
ooK^00<0e3dI03eIZ`3D?AT0203D?AT203eIZ`040?ofkP3D?AT0e3dI0=@m6@H0ooK^00<0?EV[0?of
kP3om^h00`3om^h203eIZ`@0ooK^00<0?EV[0?ofkP3om^h0B`3om^h00`000000ooK^0?ofkP0=0?of
kP40oooo000f0?ofkP030000003om^h0ooK^01P0ooK^00<0?EV[0?ofkP0000000P000000103om^h0
?EV[03eIZ`0mFJ/=0?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0000003eIZ`3om^h01@3om^h00`0m
FJ/0ooK^0?ofkP060?ofkP@0?EV[1`3om^h203eIZa<0ooK^00T0000003eIZ`0mFJ/0?EV[0000000m
FJ/090X50000000T2PD00P00000503H?20030000000f3`P000000080EaP<00<0000005LH301G60`0
0`1G60`010000000EaP<0000000mFJ/307PR40030000001h8Q00N28@00<0N28@00<0000007PR4000
00000`2C:Q<00`000000TbXC09<Z4`0409<Z4`040000002C:Q<0?EV[09<Z4`80?EV[00@0e3dI04QV
a018I/@0e3dI1018I/@00`000000B6K404QVa00604QVa00300000018I/@0B6K400<0B6K400<0e3dI
04QVa03D?AT02@18I/@00`000000B6K400000002000000@0AV:l00<0000004IR_016H[`00P16H[`0
1P3D?AT0AV:l0=@m6@3D?AT0AV:l000000P0AV:l00<0000004IR_016H[`01`16H[`3000000030=@m
6@13G[80@ejb00D0@ejb0P3D?AT804=N/P0300000013G[80@ejb00<0@ejb00H0e3dI04=N/P13G[80
@ejb00000013G[82000000D0?eRV00<0000003mHYP0oF:H01`0oF:H00`3D?AT0?eRV03mHYP0503mH
YP030000003D?AT0?EV[00@0ooK^00<0e3dI0000000000001`3D?AT00`000000ooK^0=@m6@020?of
kP030=@m6@3om^h0e3dI00<0ooK^0P3D?AT00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^
00D0ooK^0`0mFJ/20?ofkP0303eIZ`3om^h0ooK^04/0ooK^00<000000?ofkP3om^h0303om^h10?oo
o`00=P3om^h00`000000ooK^0?ofkP0H0?ofkP0303eIZ`3om^h0ooK^0080ooK^0`0000000`3om^h0
?EV[03eIZ`0203eIZ`T0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`000000?EV[0?ofkP060?ofkP03
03eIZ`3om^h0ooK^00X0ooK^0`0mFJ/40?ofkP80?EV[4P3om^h30000000301D60P000000?EV[0080
?EV[00@0e3dI02@:1@00000000001@0f3`P00`000000=Pl80000000205LH30030000001G60`0EaP<
00<0EaP<0P0000000`1h8Q00?EV[07PR400207PR40030000001h8Q00N28@00<0N28@00<0000007PR
400000000`2C:Q<00`000000TbXC09<Z4`0409<Z4`040000000mFJ/0TbXC09<Z4`80000000D0BFW;
00000000000000000=@m6@0304QVa00300000018I/@0B6K400H0B6K400<0000004QVa018I/@00P18
I/@01@3D?AT0B6K404QVa0000000e3dI00P0B6K400<0000004QVa018I/@00P18I/@30000000304IR
_0000000AV:l0080AV:l00<0e3dI04IR_016H[`00P16H[`00`3D?AT0000004IR_00704IR_0030000
0016H[`0AV:l00P0AV:l00<000000=@m6@0000000P00000404=N/P0300000013G[80@ejb0080e3dI
1P13G[800`000000@ejb04=N/P0204=N/P030=@m6@13G[80@ejb0080@ejb00@0000004=N/P13G[80
@ejb0P00000303mHYP030000000oF:H0?eRV00H0?eRV00<0e3dI0000000oF:H01`0oF:H010000000
ooK^03eIZ`0mFJ/20?ofkP030=@m6@3om^h0e3dI00<0000000<0e3dI0?ofkP0000000`3om^h01`3D
?AT0ooK^0=@m6@3om^h0e3dI0?ofkP0mFJ/00P3om^h00`3D?AT0ooK^0?ofkP0203eIZ`H0ooK^00<0
?EV[0?ofkP3om^h01`3om^h403eIZd`0ooK^00<000000?ofkP3om^h0303om^h10?ooo`00=P3om^h0
0`000000ooK^0?ofkP0G0?ofkP0303eIZ`3om^h0ooK^00H0ooK^0`0000020?ofkP<0?EV[1@3om^h0
0`0mFJ/0ooK^0?ofkP090?ofkP040000003om^h0?EV[03eIZ`H0ooK^00<0?EV[0?ofkP3om^h03@3o
m^h503eIZa80ooK^0`00000201D60P040000000T2PD0?EV[000000<0?EV[00<0000003H?200f3`P0
0`0f3`P2000000<0EaP<00<0000005LH301G60`00`1G60`00`000000N28@03eIZ`0407PR40030000
001h8Q00N28@00<0N28@0P00000409<Z4`030000002C:Q<0TbXC00@0TbXC00@0000003eIZ`2C:Q<0
TbXC0P00000404UYb`050000003D?AT0000004QVa00000002018I/@01@000000B6K404QVa018I/@0
e3dI00<0B6K400<0000004QVa03D?AT01`18I/@00`000000B6K404QVa00504QVa0<0000000<0AV:l
0=@m6@16H[`01016H[`00`000000e3dI04IR_00704IR_00300000016H[`0AV:l00L0AV:l00<00000
0=@m6@16H[`00`16H[`30000000304=N/P000000@ejb00<0@ejb0P3D?AT404=N/P0500000013G[80
@ejb04=N/P3D?AT01013G[800`000000@ejb04=N/P0404=N/P80000000<0?eRV0000000oF:H01P0o
F:H00`3D?AT0?eRV0000000803mHYP040000003om^h0ooK^0?ofkP80?EV[0P3D?AT0100mFJ/0ooK^
0?ofkP3D?AT3000000<0ooK^103D?AT20?ofkP0303eIZ`3D?AT0e3dI00D0ooK^0P0mFJ/40?ofkP03
03eIZ`3om^h0ooK^00X0ooK^0P0mFJ];0?ofkP030000003om^h0ooK^00`0ooK^0@3oool003H0ooK^
00<000000?ofkP3om^h05`3om^h00`0mFJ/0ooK^0?ofkP090?ofkP<000000P3om^h403eIZ`030?of
kP0mFJ/0ooK^00T0ooK^00D000000?ofkP3om^h0?EV[0?ofkP0303eIZ`<0ooK^00<0?EV[0?ofkP3o
m^h0403om^h303eIZa40ooK^00@05@H20000000000005@H20P000000100mFJ/090X50=@m6@000002
03H?2080?EV[100f3`P00`000000EaP<05LH300305LH30040000001G60`0EaP<05LH3080000000<0
N28@03eIZ`1h8Q00101h8Q000`000000N28@07PR400207PR40030000002C:Q<0TbXC00@0TbXC00<0
000009<Z4`2C:Q<00`2C:Q<010000000?EV[09<Z4`0000020:Ta5P0300000019JL/0BFW;0080BFW;
00<0e3dI04UYb`0000000P00000704QVa00500000018I/@0B6K404QVa03D?AT00`18I/@010000000
B6K404QVa03D?AT604QVa00300000018I/@0B6K400H0B6K400<0000004QVa03D?AT00P00000404IR
_00400000016H[`0e3dI0=@m6@H0AV:l00<0000004IR_016H[`01`16H[`00`3D?AT0AV:l04IR_006
04IR_0<000001@13G[820=@m6@80@ejb00@0000004=N/P13G[80e3dI1@13G[800`000000@ejb04=N
/P0604=N/P<000001@0oF:H0103D?AT0?eRV03mHYP00000803mHYP030000003om^h0ooK^00<0ooK^
00<0e3dI03eIZ`0mFJ/00P3D?AT0103om^h000000?ofkP3om^h2000000030?ofkP3D?AT0e3dI00@0
ooK^0P3D?AT80?ofkP<0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^04P0
ooK^00<000000?ofkP3om^h0303om^h10?ooo`00=P3om^h00`000000ooK^0?ofkP0G0?ofkP0303eI
Z`3om^h0ooK^00`0ooK^0`0000030?ofkP<0?EV[2@3om^h00`000000ooK^03eIZ`050?ofkP<0?EV[
4P3om^h0100mFJ/0ooK^03eIZ`3om^h303eIZ`d0ooK^00/05@H20000000000005@H20000000T2PD0
000003eIZ`0T2PD0e3dI0000000203H?20030000000f3`P0?EV[0080?EV[0P00000505LH30040000
001G60`0EaP<00000080N28@00<0000003eIZ`1h8Q00101h8Q0010000000N28@07PR401h8Q020000
00H0TbXC00<0000009<Z4`2C:Q<00`2C:Q<00`0mFJ/00000000000030:Ta5P0300000019JL/0BFW;
00<0BFW;00@0e3dI04UYb`000000BFW;0`00000404QVa00400000018I/@0B6K40=@m6@@0B6K400D0
000004QVa018I/@0B6K40=@m6@0504QVa00300000018I/@0B6K400H0B6K400<000000=@m6@18I/@0
0P18I/@30000000304IR_0000000AV:l0080AV:l00<0e3dI04IR_016H[`00`16H[`00`000000AV:l
04IR_00504IR_080e3dI00<0000004IR_016H[`01`16H[`010000000AV:l00000000000504=N/P80
e3dI00<0000004=N/P3D?AT01P13G[800`000000@ejb04=N/P0704=N/P0300000013G[8000000080
00000P3D?AT303mHYP030000000oF:H0?eRV00H0?eRV00<000000?ofkP3om^h00P3om^h20=@m6@03
0?ofkP3D?AT0?EV[0080?EV[1@3om^h3000000<0ooK^0P3D?AT<0?ofkP<0?EV[3@3om^h00`0mFJ/0
ooK^0?ofkP190?ofkP030000003om^h0ooK^00/0ooK^0@3oool003D0ooK^00<000000?ofkP3om^h0
603om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP<0000000<0ooK^03eIZ`3om^h00`0mFJ/50?ofkP040000
003om^h0ooK^03eIZ`L0ooK^100mFJ/?0?ofkP0303eIZ`3om^h0?EV[00@0ooK^0P0mFJ/:0?ofkP<0
000000D0e3dI0000000T2PD0000003eIZ`0202@:1@030000000f3`P0=Pl80080=Pl800@0000003H?
200f3`P000000`0mFJ/405LH30030000001G60`0000000<0N28@00<0?EV[07PR401h8Q00101h8Q00
10000000N28@07PR4000000209<Z4`030000002C:Q<0TbXC00<0TbXC00<0000009<Z4`2C:Q<00`2C
:Q<00`0mFJ/00000000000030:Ta5P0300000019JL/0BFW;00@0BFW;00<0e3dI00000019JL/00`19
JL/30000000404QVa0000000B6K40=@m6@D0B6K400<0000004QVa018I/@00P18I/@00`3D?AT0B6K4
04QVa00204QVa00300000018I/@0B6K400H0B6K400<0e3dI04QVa018I/@01@18I/@3000000<0AV:l
00<0e3dI04IR_016H[`00P16H[`00`000000AV:l04IR_00404IR_0040=@m6@16H[`0AV:l000000P0
AV:l00<0000004IR_016H[`00P16H[`3000000<0@ejb00@000000=@m6@3D?AT0e3dI1P13G[800`00
0000@ejb04=N/P0704=N/P0500000013G[80@ejb04=N/P3D?AT0100000000`0oF:H0000003mHYP07
03mHYP060000003om^h0ooK^0?ofkP3D?AT0ooK^0P3D?AT0100mFJ/0ooK^0000003om^h303eIZ`03
0?ofkP3D?AT0e3dI0080ooK^0`0000000`3D?AT0ooK^03eIZ`0=0?ofkP<0?EV[303om^h00`0mFJ/0
ooK^0?ofkP180?ofkP030000003om^h0ooK^00/0ooK^0@3oool003D0ooK^00<000000?ofkP3om^h0
603om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP030000000mFJ/0000000<0ooK^0`0mFJ/01@3om^h00000
0?ofkP3om^h0?EV[00P0ooK^00@0?EV[0?ofkP3om^h0ooK^0`0mFJ/<0?ofkP80?EV[1`3om^h303eI
Z`H0ooK^1@00000202@:1@030000000mFJ/090X500800000100f3`P00`000000=Pl80000000305LH
30080000000mFJ/0?EV[03eIZ`1G60`0000005LH3000000307PR400303eIZ`1h8Q00N28@00@0N28@
00@0000007PR401h8Q0000000P2C:Q<00`000000TbXC09<Z4`0409<Z4`030000002C:Q<0TbXC0080
TbXC00<0?EV[0000002Y<AH00`2Y<AH00`000000BFW;04UYb`0404UYb`030=@m6@000000BFW;00H0
BFW;0P0000000`3D?AT0B6K404QVa00404QVa00300000018I/@0B6K40080B6K400D0e3dI04QVa018
I/@0B6K40000000804QVa0030=@m6@18I/@0B6K400L0B6K400@0000004QVa000000000000P16H[`2
0=@m6@0304IR_0000000AV:l00D0AV:l00@0e3dI04IR_016H[`000002@16H[`00`000000AV:l04IR
_00504IR_080000000<0@ejb0000003D?AT00P13G[820=@m6@@0@ejb00<0000004=N/P13G[801P13
G[801@000000@ejb04=N/P13G[80e3dI00D0@ejb0`00000703mHYP040000003om^h0ooK^0=@m6@80
ooK^00@0e3dI0?ofkP0mFJ/00000103om^h30=@m6@@0ooK^0P3D?AT20000000303eIZ`3om^h0ooK^
00`0ooK^00<0?EV[0?ofkP0mFJ/00P0mFJ/90?ofkP0303eIZ`3om^h0ooK^04P0ooK^00<000000?of
kP3om^h02`3om^h10?ooo`00=@3om^h00`000000ooK^0?ofkP0H0?ofkP0303eIZ`3om^h0ooK^0180
ooK^00<0?EV[0?ofkP3om^h00`0000030?ofkP0503eIZ`000000ooK^0?ofkP0mFJ/0203om^h00`0m
FJ/0ooK^0?ofkP040?ofkP<0?EV[203om^h00`0mFJ/0ooK^03eIZ`0:0?ofkP<0?EV[0P3om^h20000
000301D60P000000000000<090X500D0?EV[02@:1@000000=Pl80000000403H?20030000000f3`P0
000000<0EaP<00@0000005LH301G60`0EaP<0P0mFJ/00`000000N28@07PR400207PR400303eIZ`00
0000N28@00D0N28@0P00000309<Z4`030000002C:Q<0TbXC00@0TbXC00D0000009<Z4`2C:Q<0TbXC
03eIZ`02000000D0ZC4F00<0000004UYb`19JL/01019JL/00`3D?AT0000004UYb`0604UYb`040=@m
6@19JL/00000000000@0B6K400<0000004QVa018I/@00`18I/@0103D?AT0B6K404QVa000000804QV
a0030=@m6@18I/@0B6K400L0B6K400@0000004QVa018I/@0B6K40P00000204IR_0030=@m6@000000
AV:l00@0AV:l00D0e3dI04IR_016H[`0AV:l0000000904IR_00300000016H[`0AV:l00L0AV:l00<0
00000=@m6@0000001013G[830=@m6@0304=N/P000000@ejb00L0@ejb00@0000004=N/P13G[80e3dI
1`13G[8010000000@ejb00000000000503mHYP030000003D?AT0e3dI0080ooK^0P3D?AT00`000000
?EV[0?ofkP030?ofkP040=@m6@3om^h0e3dI0=@m6@<0?EV[00<0e3dI0?ofkP3om^h00P3om^h30000
00`0ooK^00<0?EV[0?ofkP3om^h00P3om^h303eIZ`L0ooK^00<0?EV[0?ofkP3om^h0A`3om^h00`00
0000ooK^0?ofkP0;0?ofkP40oooo000e0?ofkP030000003om^h0ooK^01L0ooK^00<0?EV[0?ofkP3o
m^h04`3om^h00`0mFJ/0ooK^0?ofkP030?ofkP@0000000@0ooK^03eIZ`0mFJ/0?EV[203om^h00`0m
FJ/0ooK^0?ofkP070?ofkP<0?EV[1@3om^h00`0mFJ/0ooK^03eIZ`0=0?ofkP80?EV[00<0000001D6
0P0000000P00000302@:1@0503eIZ`000000=Pl803H?20000000100f3`P2000000@0EaP<00<00000
05LH301G60`00P1G60`020000000?EV[03eIZ`0mFJ/0N28@03eIZ`1h8Q0000001P1h8Q000`000000
TbXC09<Z4`0309<Z4`030000002C:Q<0TbXC00<0TbXC00D0000009<Z4`2C:Q<0TbXC03eIZ`020:Ta
5P030000002Y<AH0ZC4F0080ZC4F00<0000004UYb`19JL/01@19JL/00`3D?AT0BFW;04UYb`0404UY
b`030=@m6@000000BFW;0080BFW;0`0000000`18I/@0000004QVa00504QVa0030=@m6@18I/@00000
00L0B6K400<0e3dI00000018I/@02018I/@00`000000B6K404QVa00304QVa080000000<0AV:l0=@m
6@16H[`00`16H[`00`3D?AT0AV:l04IR_00204IR_00300000016H[`0AV:l00L0AV:l00<0000004IR
_016H[`01`16H[`00`3D?AT0000004IR_003000000@0@ejb0`3D?AT704=N/P0300000013G[80e3dI
00L0@ejb00<0000004=N/P13G[800P13G[82000000<0?eRV00@0e3dI0?ofkP3om^h0?EV[0P3D?AT0
0`000000ooK^03eIZ`030?ofkP@0e3dI0`3om^h0103D?AT0?EV[03eIZ`0mFJ/20?ofkP0303eIZ`3o
m^h0ooK^008000002`3om^h00`0mFJ/0ooK^0?ofkP040?ofkP80?EV[1@3om^h00`0mFJ/0ooK^0?of
kP170?ofkP030000003om^h0ooK^00/0ooK^0@3oool003D0ooK^00<000000?ofkP3om^h05`3om^h0
0`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00H000000?ofkP000000000003eI
Z`3om^h303eIZ`@0ooK^00<0?EV[0?ofkP3om^h02`3om^h303eIZ`050?ofkP0mFJ/0ooK^0?ofkP0m
FJ/03P3om^h00`0000005@H201D60P030000008090X500<0?EV[02@:1@0000000P0f3`P00`000000
=Pl803H?200203H?20030000001G60`0EaP<00<0EaP<00@0000005LH301G60`0EaP<0P00000307PR
40<0?EV[00<0000007PR401h8Q000`1h8Q02000000D0TbXC00<0000009<Z4`2C:Q<00`2C:Q<01000
0000TbXC09<Z4`0mFJ/30:Ta5P030000002Y<AH0ZC4F0080ZC4F00<0000004UYb`19JL/01@19JL/0
0`3D?AT0BFW;04UYb`0304UYb`030=@m6@19JL/0000000H0BFW;0`00000604QVa0030=@m6@000000
B6K400D0B6K400<0e3dI04QVa00000002018I/@00`000000B6K404QVa00604QVa08000000P3D?AT0
0`16H[`0e3dI04IR_00404IR_00300000016H[`0AV:l00H0AV:l00<0000004IR_016H[`01`16H[`0
0`3D?AT0000004IR_00404IR_0<0000000@0@ejb00000013G[80@ejb0P3D?AT504=N/P030000003D
?AT0@ejb00L0@ejb00<0000004=N/P13G[801013G[82000000070=@m6@000000ooK^0?ofkP3D?AT0
ooK^0=@m6@020?ofkP0303eIZ`3om^h0ooK^0080e3dI0P3om^h0103D?AT0ooK^0=@m6@3D?AT40?of
kP80?EV[00<0ooK^03eIZ`3om^h00P3om^h3000000P0ooK^00<0?EV[0?ofkP3om^h01P3om^h303eI
Z`<0ooK^00<0?EV[0?ofkP3om^h0A`3om^h00`000000ooK^0?ofkP0:0?ofkP40oooo000d0?ofkP03
0000003om^h0ooK^01P0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP040?ofkP06
0000003om^h0ooK^0?ofkP0mFJ/0ooK^0`0000001P3om^h0?EV[03eIZ`0mFJ/0ooK^03eIZa00ooK^
100mFJ/>0?ofkP80000000@05@H200000000000000000`0T2PD00`0mFJ/0000003H?200203H?2004
0000000f3`P0=Pl803H?208000001@1G60`01`000000EaP<05LH301G60`0000007PR400000000`1h
8Q000`0mFJ/0N28@03eIZ`0203eIZ`80N28@00@0000009<Z4`2C:Q<00000102C:Q<00`000000TbXC
09<Z4`0409<Z4`80000000D0?EV[0:Ta5P2Y<AH0ZC4F000000040:Ta5P0300000019JL/0BFW;00D0
BFW;00<000000=@m6@19JL/00`19JL/00`3D?AT0BFW;0000000704UYb`0300000019JL/000000080
00001018I/@00`3D?AT0B6K404QVa00304QVa0040=@m6@18I/@0B6K4000000P0B6K400<0000004QV
a018I/@01`18I/@01@000000B6K40000003D?AT0000000@0AV:l00<0000004IR_016H[`01`16H[`0
0`000000AV:l04IR_00604IR_0030=@m6@16H[`0000000P0AV:l0`00000304=N/P<0e3dI0P13G[80
0`3D?AT0@ejb04=N/P0704=N/P0300000013G[80@ejb00D0@ejb00P0e3dI000000000000ooK^0=@m
6@3om^h000000=@m6@80ooK^00@0?EV[0?ofkP3D?AT0e3dI0P3om^h40=@m6@L0ooK^0`0mFJ/50?of
kP<000001@3om^h00`0mFJ/0ooK^0?ofkP090?ofkP@0?EV[B@3om^h00`000000ooK^0?ofkP0:0?of
kP40oooo000d0?ofkP030000003om^h0ooK^01P0ooK^0P0mFJ/C0?ofkP0303eIZ`3om^h0ooK^00D0
ooK^00D000000?ofkP3om^h0ooK^03eIZ`040?ofkP<0000000@0ooK^03eIZ`0mFJ/0?EV[3`3om^h0
0`0mFJ/0ooK^0?ofkP0303eIZ`/0ooK^0P00000201D60P030000000T2PD0000000<090X500<0?EV[
03H?200f3`P00P0f3`P01P000000=Pl803H?20000000EaP<000000D0EaP<00@0000005LH301G60`0
00000P1h8Q0010000000N28@07PR400mFJ/307PR40030000001h8Q00?EV[0080?EV[0P2C:Q<00`00
0000TbXC09<Z4`0209<Z4`030000002C:Q<0TbXC00@0TbXC00<000000:Ta5P0mFJ/00`2Y<AH00`00
0000ZC4F0:Ta5P030:Ta5P0300000019JL/0BFW;00@0BFW;00<0000004UYb`3D?AT00P19JL/0103D
?AT0BFW;04UYb`00000704UYb`0300000019JL/0BFW;0080BFW;0`0000000`18I/@000000=@m6@03
04QVa0050=@m6@18I/@0B6K404QVa00000002018I/@00`000000B6K404QVa00604QVa00500000018
I/@0B6K40=@m6@18I/@00P3D?AT20000000304IR_0000000AV:l00P0AV:l00<0000004IR_016H[`0
1@16H[`0103D?AT0AV:l04IR_000000904IR_00400000016H[`00000000000@0@ejb103D?AT804=N
/P0300000013G[80@ejb00@0@ejb00T0e3dI04=N/P13G[8000000=@m6@3om^h000000?ofkP3D?AT0
0P3om^h0100mFJ/0e3dI0=@m6@3om^h20=@m6@030?ofkP3D?AT0e3dI00T0ooK^00@0?EV[0?ofkP0m
FJ/0?EV[1P3om^h2000000<0ooK^00<0?EV[0?ofkP3om^h0303om^h203eIZdP0ooK^00<000000?of
kP3om^h02P3om^h10?ooo`00=03om^h00`000000ooK^0?ofkP0H0?ofkP0303eIZ`3om^h0?EV[0080
?EV[403om^h00`0mFJ/0ooK^0?ofkP040?ofkP050000003om^h0ooK^0?ofkP0mFJ/0203om^h20000
000303eIZ`3om^h0?EV[0080?EV[303om^h0100mFJ/0ooK^0?ofkP0mFJ/20?ofkP@0?EV[1`3om^h2
0000000501D60P000000000002@:1@0000000P0T2PD00`0mFJ/0000003H?200303H?20030000000f
3`P0000000<0EaP<00<0000005LH301G60`00`1G60`2000000<0N28@00@0000007PR401h8Q00?EV[
0`1h8Q001@000000N28@07PR40000000TbXC00<0?EV[1@2C:Q<00`000000TbXC09<Z4`0209<Z4`80
000000<0?EV[0:Ta5P2Y<AH00`2Y<AH00`000000ZC4F0:Ta5P020:Ta5P0300000019JL/0BFW;00@0
BFW;00D0000004UYb`3D?AT0BFW;0=@m6@0304UYb`0300000019JL/0BFW;00D0BFW;00<0000004UY
b`19JL/01@19JL/3000000030=@m6@18I/@0e3dI00<0B6K400<0000004QVa018I/@01`18I/@00`00
0000B6K404QVa00604QVa00300000018I/@0e3dI00@0B6K40P3D?AT3000000P0AV:l00<0000004IR
_016H[`01016H[`0103D?AT0AV:l04IR_000000904IR_00300000016H[`0AV:l0080AV:l0P000002
04=N/P040=@m6@000000@ejb04=N/PD0e3dI0P13G[800`000000@ejb04=N/P0404=N/P090=@m6@13
G[80@ejb0000003D?AT0ooK^0000003om^h0e3dI00<0ooK^103D?AT0103om^h0e3dI0=@m6@3D?AT:
0?ofkP0403eIZ`3om^h0ooK^0?ofkP<0?EV[1@3om^h3000000030?ofkP0mFJ/0ooK^00d0ooK^00<0
?EV[0?ofkP3om^h0AP3om^h00`000000ooK^0?ofkP0:0?ofkP40oooo000d0?ofkP030000003om^h0
ooK^01P0ooK^00<0?EV[0?ofkP3om^h00P3om^h403eIZ``0ooK^00<0?EV[0?ofkP3om^h00`3om^h0
0`000000ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00P0ooK^00D0?EV[00000000000000000?of
kP0303eIZ`P0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`060?ofkP<0?EV[0`3om^h2000000805@H2
00P0000002@:1@0T2PD0000002@:1@000000?EV[000000@0=Pl800<0000003H?200000000`1G60`0
0`000000EaP<05LH300305LH30800000101h8Q000`000000?EV[07PR400407PR408000001@2C:Q<4
03eIZ`0309<Z4`000000TbXC0080TbXC00@000000:Ta5P2Y<AH0?EV[1@2Y<AH00`000000ZC4F0:Ta
5P020:Ta5P0300000019JL/0BFW;00@0BFW;00@0000004UYb`19JL/0e3dI1019JL/00`000000BFW;
04UYb`0504UYb`0300000019JL/0BFW;00H0BFW;00@0000004UYb`000000e3dI1018I/@00`000000
B6K404QVa00704QVa00300000018I/@0B6K400H0B6K400<000000=@m6@18I/@01P18I/@20=@m6@04
04QVa00000000000000000@0AV:l00<0000004IR_016H[`01016H[`01@3D?AT0AV:l04IR_016H[`0
000000T0AV:l00<0000004IR_016H[`01016H[`010000000e3dI04=N/P00000704=N/PD0e3dI0`13
G[800`3D?AT0@ejb04=N/P020=@m6@0303eIZ`3D?AT0e3dI00H0e3dI0`3om^h20=@m6@`0ooK^00<0
?EV[0?ofkP3om^h0103om^h203eIZ`H0ooK^0`00000=0?ofkP0303eIZ`3om^h0ooK^04L0ooK^00<0
00000?ofkP3om^h02@3om^h10?ooo`00=03om^h00`000000ooK^0?ofkP0G0?ofkP0303eIZ`3om^h0
ooK^00L0ooK^0`0mFJ/90?ofkP0303eIZ`3om^h0ooK^00<0ooK^00D000000?ofkP3om^h0ooK^03eI
Z`0:0?ofkP0303eIZ`3om^h0ooK^0080ooK^0`0000000`3om^h0?EV[03eIZ`0203eIZ`@0ooK^00D0
?EV[0?ofkP3om^h0ooK^03eIZ`090?ofkP<0?EV[00<05@H20000000E1P800P00000202@:1@800000
00<0?EV[03H?20000000100f3`P2000000@0EaP<00<0000005LH301G60`00`1G60`00`000000N28@
07PR400307PR40030000000mFJ/0N28@00@0N28@00<0000009<Z4`2C:Q<0102C:Q<010000000TbXC
09<Z4`2C:Q<303eIZ`0309<Z4`000000ZC4F0080ZC4F00<0?EV[0:Ta5P2Y<AH00`2Y<AH00`000000
ZC4F0:Ta5P020:Ta5P0300000019JL/0BFW;00@0BFW;00D0000004UYb`3D?AT0BFW;0=@m6@0404UY
b`0300000019JL/0BFW;00@0BFW;00<0000004UYb`19JL/01P19JL/010000000BFW;0=@m6@19JL/2
0=@m6@0300000018I/@0000000T0B6K400<0000004QVa018I/@01P18I/@00`3D?AT0B6K404QVa006
04QVa00300000018I/@0e3dI00<0B6K40`0000000`16H[`0000004IR_00404IR_0050=@m6@16H[`0
AV:l04IR_00000002@16H[`00`000000AV:l04IR_00404IR_080e3dI00@0AV:l0000000000000000
2013G[800`000000@ejb04=N/P090=@m6@<0ooK^00D0e3dI0?ofkP3D?AT0e3dI03eIZ`030?ofkP03
0=@m6@3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h01P3om^h203eIZ`D0ooK^00@0?EV[0?ofkP00
00000000303om^h00`0mFJ/0ooK^0?ofkP160?ofkP030000003om^h0ooK^00T0ooK^0@3oool003<0
ooK^00<000000?ofkP3om^h0603om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP<0?EV[1@3om^h00`0mFJ/0
ooK^0?ofkP030?ofkP030000003om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0
ooK^0?ofkP050?ofkP<000000P3om^h403eIZ`<0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`3D?AT0
000003eIZ`0303eIZ`080000000T2PD0000002@:1@000000?EV[03H?2000000403H?20030000001G
60`0EaP<00<0EaP<00<0000005LH301G60`00P1G60`2000000D0N28@00<0?EV[0000001h8Q000`1h
8Q02000000H0TbXC00<0000009<Z4`2C:Q<00`2C:Q<01`000000?EV[03eIZ`0mFJ/0ZC4F03eIZ`00
00001P2Y<AH00`000000ZC4F0:Ta5P020:Ta5P0300000019JL/0BFW;00@0BFW;00D0e3dI04UYb`19
JL/0BFW;0=@m6@0304UYb`0300000019JL/0BFW;00@0BFW;00<0000004UYb`19JL/01P19JL/00`00
0000e3dI04UYb`0304UYb`040=@m6@0000000000000000L0B6K400<0000004QVa018I/@01P18I/@0
0`3D?AT0B6K404QVa00704QVa00300000018I/@0B6K40080e3dI1018I/@3000000<0AV:l00<0e3dI
04IR_016H[`00P16H[`00`000000AV:l04IR_00704IR_00300000016H[`0AV:l00<0AV:l00D0e3dI
04IR_016H[`0AV:l0000000204IR_0<000001@13G[801@000000@ejb04=N/P13G[80e3dI00@0@ejb
00<000000?ofkP3om^h00`0mFJ/20=@m6@80ooK^00@0?EV[0?ofkP3D?AT0e3dI3P3om^h00`0mFJ/0
ooK^0?ofkP080?ofkP<0?EV[0P3om^h0100mFJ/0ooK^0?ofkP3om^h3000000T0ooK^00<0?EV[0?of
kP3om^h0AP3om^h00`000000ooK^0?ofkP090?ofkP40oooo000c0?ofkP030000003om^h0ooK^01P0
ooK^00<0?EV[0?ofkP3om^h03@3om^h403eIZ`030?ofkP0mFJ/0ooK^00<0ooK^00<000000?ofkP3o
m^h00P3om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^00P0ooK^0`0000020?ofkP<0
?EV[00<0ooK^03eIZ`3om^h02P3om^h01P0000005@H20=@m6@00000090X5000000<0?EV[00D00000
03eIZ`0f3`P0=Pl80000000303H?208000001@1G60`01@000000EaP<05LH301G60`000000080N28@
00<0000007PR401h8Q000P1h8Q000`0mFJ/0000007PR400207PR40040000002C:Q<0TbXC000000D0
TbXC00<0000009<Z4`2C:Q<00`2C:Q<010000000ZC4F0:Ta5P2Y<AH303eIZ`H0ZC4F00<000000:Ta
5P2Y<AH00P2Y<AH2000000@0BFW;00<0e3dI00000019JL/00`19JL/0103D?AT0BFW;04UYb`000006
04UYb`0300000019JL/0BFW;00H0BFW;00<0e3dI04UYb`19JL/01019JL/00`3D?AT0000004UYb`03
000000@0B6K400<0000004QVa018I/@01@18I/@00`3D?AT0000004QVa00804QVa00300000018I/@0
B6K40080B6K40P3D?AT304QVa00500000018I/@000000000003D?AT01@16H[`00`000000AV:l04IR
_00604IR_00300000016H[`0AV:l00<0AV:l00<0e3dI04IR_016H[`00P16H[`00`000000AV:l04IR
_00304IR_0<0000000<0@ejb00000013G[800P13G[800`3D?AT0@ejb04=N/P0304=N/P030000003o
m^h0ooK^0080ooK^0P3D?AT203eIZ`040?ofkP0mFJ/0e3dI0=@m6@l0ooK^00<0?EV[0?ofkP3om^h0
2`3om^h203eIZ`030?ofkP0mFJ/0ooK^00@0ooK^0P0000070?ofkP0303eIZ`3om^h0ooK^04H0ooK^
00<000000?ofkP3om^h02@3om^h10?ooo`00<`3om^h00`000000ooK^0?ofkP0H0?ofkP0303eIZ`3o
m^h0ooK^0140ooK^0`0mFJ/20?ofkP030000003om^h0ooK^00<0ooK^0P0mFJ/:0?ofkP0303eIZ`3o
m^h0ooK^00/0ooK^00<0000003eIZ`0000000P3om^h303eIZ`T0ooK^00@0e3dI0000000000000000
0P0T2PD01000000090X502@:1@00000303eIZ`0703H?20000000=Pl803H?20000000EaP<00000005
05LH30040000001G60`0EaP<000000<0N28@00L0000007PR401h8Q00N28@03eIZ`1h8Q0000000080
N28@00D0000009<Z4`2C:Q<0TbXC0000000609<Z4`040000002C:Q<0TbXC09<Z4`800000102Y<AH0
0`0mFJ/0ZC4F03eIZ`0203eIZ`<0ZC4F00@000000:Ta5P2Y<AH0ZC4F0P0000001`1:K=0000000000
00000000e3dI04UYb`0000001@19JL/00`3D?AT0BFW;0000000604UYb`0300000019JL/0BFW;00D0
BFW;00<0e3dI00000019JL/01P19JL/20=@m6@<0BFW;0`0000000`18I/@0000004QVa00504QVa003
0=@m6@18I/@0000000P0B6K400<0000004QVa018I/@01@18I/@20=@m6@0600000018I/@0B6K404QV
a03D?AT0B6K40`0000000`16H[`0000004IR_00804IR_00300000016H[`0AV:l0080AV:l00<0e3dI
04IR_016H[`00P16H[`00`000000AV:l04IR_00704IR_0<000000P3D?AT604=N/P040000003om^h0
ooK^0?ofkP80e3dI0`3om^h00`0mFJ/0e3dI0=@m6@0@0?ofkP0303eIZ`3om^h0ooK^00d0ooK^0`0m
FJ/60?ofkP<00000103om^h00`0mFJ/0ooK^0?ofkP160?ofkP030000003om^h0ooK^00T0ooK^0@3o
ool003<0ooK^00<000000?ofkP3om^h0603om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP0503eIZ`3om^h0
?EV[03eIZ`000000103om^h00`0mFJ/0ooK^0?ofkP0303eIZ`H0ooK^00<0?EV[0?ofkP3om^h03@3o
m^h00`0mFJ/0ooK^000000020000000303eIZ`3om^h0?EV[0080?EV[1@3om^h0103D?AT0000001D6
0P00000302@:1@050000000T2PD000000000000mFJ/00P0f3`P303eIZ`050000001G60`0EaP<05LH
300000001@1G60`00`000000EaP<0000000307PR40050000001h8Q00N28@07PR400mFJ/00P1h8Q02
000000D0TbXC00<0000009<Z4`2C:Q<00`2C:Q<010000000TbXC09<Z4`0000020:Ta5P040000002Y
<AH0ZC4F03eIZ`80ZC4F00<000000:Ta5P2Y<AH0100mFJ/20:Ta5P040000002l=aP0_3LH00000080
BVc@00<0e3dI04Y/d00000000P00000504UYb`030=@m6@000000BFW;00D0BFW;00<0000004UYb`19
JL/01019JL/00`3D?AT0BFW;0000000704UYb`0300000019JL/0e3dI00D0BFW;0`00000504QVa003
0=@m6@18I/@0000000P0B6K400<0000004QVa018I/@01`18I/@20=@m6@0304QVa03D?AT0B6K400@0
B6K40`00000704IR_00300000016H[`0AV:l0080AV:l00<0e3dI04IR_016H[`00`16H[`00`000000
AV:l04IR_00704IR_00300000016H[`0e3dI00<000001@13G[800`000000ooK^0?ofkP020=@m6@@0
ooK^0P3D?AT00`3om^h0?EV[03eIZ`0>0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP0m
FJ/00P0mFJ/60?ofkP<000000P3om^h00`0mFJ/0ooK^0?ofkP160?ofkP030000003om^h0ooK^00P0
ooK^0@3oool003<0ooK^00<000000?ofkP3om^h0603om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP0503eI
Z`3om^h0ooK^0000003om^h00`0mFJ/00`3om^h0?EV[0?ofkP040?ofkP<0?EV[0`3om^h00`0mFJ/0
ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00D0?EV[00000000000000000?ofkP0403eI
Z`80e3dI0`00000302@:1@80000000<0=Pl80000000mFJ/00`0f3`P010000000=Pl803eIZ`0mFJ/2
05LH30030000001G60`0EaP<00<0EaP<0P00000407PR40050000001h8Q00N28@07PR400mFJ/00P1h
8Q000`000000TbXC09<Z4`0409<Z4`030000002C:Q<0TbXC00<0TbXC00@0000009<Z4`2C:Q<00000
0P2Y<AH010000000ZC4F0:Ta5P0mFJ/20:Ta5P030000002Y<AH0ZC4F00@0ZC4F0`0mFJ/20;`g6003
0000001:K=00e3dI00<0BVc@00@0000004Y/d000000000001019JL/20=@m6@D0BFW;00<0000004UY
b`19JL/00`19JL/00`3D?AT0BFW;0000000704UYb`0500000019JL/0BFW;04UYb`3D?AT01@19JL/0
10000000BFW;00000000000204QVa0030=@m6@18I/@0000000T0B6K400<0000004QVa018I/@01P18
I/@00`000000B6K404QVa0020=@m6@D0B6K400<0000004QVa018I/@00P00000504IR_00500000016
H[`0AV:l04IR_03D?AT01@16H[`00`000000AV:l04IR_00804IR_0030000003D?AT0AV:l00<0AV:l
0`0000001013G[8000000?ofkP3om^h30=@m6@80ooK^0P3D?AT00`3om^h0?EV[0?ofkP020?ofkP<0
?EV[2`3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^0080ooK^0`0mFJ/60?ofkP80
000000<0?EV[0?ofkP3om^h0AP3om^h00`000000ooK^0?ofkP080?ofkP40oooo000b0?ofkP030000
003om^h0ooK^01P0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^000000050?ofkP80?EV[
203om^h403eIZ`h0ooK^00<0?EV[0?ofkP3om^h00`3om^h0100mFJ/0ooK^0?ofkP3om^h300000080
ooK^0`0mFJ/20000008090X500D0000002@:1@000000=Pl803eIZ`0403H?208000000P1G60`303eI
Z`D0EaP<00<0000007PR401h8Q00101h8Q000`000000N28@03eIZ`0207PR408000001P2C:Q<00`00
0000TbXC09<Z4`0509<Z4`030000002Y<AH0ZC4F0080ZC4F00<0000003eIZ`2Y<AH00`2Y<AH00`00
0000ZC4F0:Ta5P030:Ta5P030000002l=aP0_3LH0080?EV[00<000000=@m6@1:K=000`1:K=001000
0000BVc@04Y/d01:K=030000000404UYb`000000BFW;0=@m6@@0BFW;00<0000004UYb`19JL/00P19
JL/0103D?AT0BFW;04UYb`00000704UYb`0300000019JL/0BFW;0080BFW;0P3D?AT204UYb`030000
0019JL/0BFW;0080BFW;00D000000=@m6@000000B6K40000000804QVa00300000018I/@0B6K400L0
B6K400<0000004QVa03D?AT00P18I/@30=@m6@80B6K400<0000004QVa018I/@00P18I/@300000003
04IR_0000000AV:l0080AV:l00<0e3dI04IR_016H[`01016H[`00`000000AV:l04IR_00704IR_003
0000003D?AT0AV:l00L0AV:l0P000000103om^h0e3dI0=@m6@3D?AT20?ofkP80e3dI0P3om^h00`0m
FJ/0ooK^0?ofkP040?ofkP80?EV[2@3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^
00D0ooK^0P0mFJ/60?ofkP<00000AP3om^h00`000000ooK^0?ofkP080?ofkP40oooo000b0?ofkP03
0000003om^h0ooK^01P0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/000000?ofkP050?ofkP03
03eIZ`3om^h0?EV[0080?EV[203om^h203eIZ``0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0
ooK^0?ofkP050?ofkP030000003D?AT0e3dI00<000000`0T2PD200000080=Pl800<0?EV[03H?200f
3`P00P0f3`P00`000000EaP<05LH300305LH30050000000mFJ/0?EV[03eIZ`1G60`00P00000607PR
40050000001h8Q00?EV[07PR400000000P2C:Q<00`000000TbXC09<Z4`0409<Z4`030000002C:Q<0
TbXC00<0TbXC00<000000:Ta5P2Y<AH00`2Y<AH00`000000?EV[0:Ta5P030:Ta5P030000002Y<AH0
ZC4F0080ZC4F0P0000030;`g600303eIZ`000000BVc@00D0BVc@00<0000004Y/d01:K=000`1:K=03
0000000304UYb`3D?AT0BFW;0080BFW;00D0000004UYb`19JL/0BFW;0=@m6@0304UYb`0300000019
JL/0BFW;00D0BFW;00<0000004UYb`19JL/01019JL/00`3D?AT0BFW;0000000404UYb`030=@m6@19
JL/0BFW;00<000001`18I/@00`000000B6K404QVa00604QVa00300000018I/@0e3dI00H0B6K40`3D
?AT704QVa0<000000P3D?AT604IR_00300000016H[`0AV:l00P0AV:l00<0e3dI04IR_016H[`01`16
H[`01@000000ooK^0=@m6@3D?AT0ooK^00@0e3dI0`3om^h00`0mFJ/0ooK^0?ofkP060?ofkP<0?EV[
1P3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00L0ooK^0`0mFJ/30?ofkP0303eI
Z`3om^h0ooK^00<00000@`3om^h00`000000ooK^0?ofkP080?ofkP40oooo000b0?ofkP030000003o
m^h0ooK^01P0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/000000?ofkP040?ofkP0303eIZ`3o
m^h0ooK^00<0ooK^0`0mFJ/40?ofkP0303eIZ`3om^h0ooK^00<0?EV[2@3om^h00`0mFJ/0ooK^0?of
kP030?ofkP0303eIZ`3om^h0ooK^00D0ooK^0`3D?AT00`00000090X50000000302@:1@050000000f
3`P0=Pl803eIZ`0000000`0f3`P2000000D0EaP<00@0000005LH301G60`0EaP<0`0mFJ/00`000000
N28@07PR400307PR40040000000mFJ/0N28@000000<0TbXC00<0000009<Z4`2C:Q<0102C:Q<00`00
0000TbXC09<Z4`0209<Z4`8000001@2Y<AH00`0mFJ/0ZC4F0:Ta5P030:Ta5P050000002Y<AH0ZC4F
0:Ta5P0000000P2l=aP00`000000_3LH0;`g60020;`g60030000001:K=00BVc@00<0BVc@00<00000
04Y/d01:K=00101:K=001@000000BVc@000000000000e3dI0080BFW;00@0000004UYb`19JL/0e3dI
1019JL/00`000000BFW;04UYb`0504UYb`0300000019JL/0BFW;00D0BFW;00<0e3dI00000019JL/0
0P19JL/00`3D?AT0BFW;04UYb`0204UYb`0400000019JL/00000000000D0B6K400<0000004QVa018
I/@01P18I/@00`000000e3dI04QVa00704QVa00300000018I/@0e3dI0080e3dI1018I/@00`000000
B6K40=@m6@03000000D0AV:l00<0000004IR_016H[`01`16H[`00`3D?AT0AV:l04IR_00804IR_004
0000003D?AT0e3dI0?ofkP@0e3dI103om^h00`0mFJ/0ooK^0?ofkP090?ofkP<0?EV[0`3om^h00`0m
FJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00X0ooK^0`0mFJ/00`3om^h0?EV[0?ofkP030?of
kP800000@P3om^h00`000000ooK^0?ofkP070?ofkP40oooo000b0?ofkP030000003om^h0ooK^01P0
ooK^0P0mFJ/C0?ofkP0303eIZ`000000ooK^00@0ooK^00<0?EV[0?ofkP3om^h01`3om^h303eIZ`03
0?ofkP0mFJ/0ooK^00@0ooK^0`0mFJ/50?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3o
m^h0103om^h30=@m6@80000000@090X50000000T2PD090X50P00000203H?200703eIZ`000000=Pl8
03H?20000000EaP<0000000605LH30030000001G60`0000000<0N28@0P0mFJ/407PR40040000000m
FJ/0N28@000000@0TbXC00<0000009<Z4`2C:Q<0102C:Q<010000000TbXC09<Z4`0000020:Ta5P03
0000002Y<AH0ZC4F0080ZC4F00<0?EV[0000002Y<AH00`2Y<AH010000000ZC4F0:Ta5P0000030;`g
60030000002l=aP0_3LH0080_3LH00<0000004Y/d01:K=000`1:K=000`000000BVc@04Y/d00404Y/
d00:0000001:K=00BVc@04Y/d0000000e3dI04UYb`000000BFW;0=@m6@D0BFW;00<0000004UYb`19
JL/01@19JL/00`000000BFW;04UYb`0504UYb`050000003D?AT0e3dI04UYb`3D?AT01019JL/00`00
0000BFW;04UYb`0204UYb`<0000000<0B6K400000018I/@02018I/@00`3D?AT0B6K404QVa00604QV
a00300000018I/@0B6K400<0B6K40`3D?AT00`18I/@000000=@m6@0404QVa0<0000000<0AV:l0000
0016H[`02016H[`00`3D?AT0AV:l04IR_00804IR_080e3dI00@0ooK^0=@m6@3D?AT0ooK^0P3D?AT5
0?ofkP0303eIZ`3om^h0ooK^00`0ooK^0P0mFJ/00`3om^h0?EV[0?ofkP0?0?ofkP0303eIZ`3om^h0
ooK^00d0ooK^0P0mFJ/60?ofkP<00000?`3om^h00`000000ooK^0?ofkP070?ofkP40oooo000b0?of
kP030000003om^h0ooK^01P0ooK^00<0?EV[0?ofkP0mFJ/00`0mFJ/?0?ofkP030000003om^h0ooK^
00@0ooK^00<0?EV[0?ofkP3om^h02P3om^h303eIZ`L0ooK^0`0mFJ/20?ofkP0303eIZ`3om^h0ooK^
00@0ooK^00<0?EV[0?ofkP3om^h00`3om^h40=@m6@0>0000000T2PD090X50000000T2PD0000003H?
20000000=Pl803eIZ`0f3`P0000003H?2000000305LH30030000001G60`0EaP<00<0EaP<0P000005
07PR40060000000mFJ/0?EV[03eIZ`1h8Q00?EV[0P00000509<Z4`030000002C:Q<0TbXC00@0TbXC
00@0000009<Z4`2C:Q<000000P2Y<AH01`000000ZC4F0:Ta5P2Y<AH0?EV[0:Ta5P0000001@2Y<AH2
000000@0_3LH00<000000;`g602l=aP00P2l=aP00`000000BVc@04Y/d00304Y/d0030000001:K=00
BVc@00@0BVc@00<0000004Y/d01:K=000`1:K=000`3D?AT000000=@m6@0604UYb`0300000019JL/0
BFW;00D0BFW;00<0000004UYb`19JL/01@19JL/010000000BFW;04UYb`3D?AT504UYb`0300000019
JL/0BFW;00D0BFW;0`00000704QVa0030=@m6@18I/@0B6K400L0B6K400<0000004QVa018I/@01P18
I/@40=@m6@H0B6K40`00000604IR_080e3dI00<0000004IR_016H[`01`16H[`40=@m6@040?ofkP3D
?AT0e3dI0=@m6@H0ooK^00<0?EV[0?ofkP3om^h03P3om^h303eIZa00ooK^00<0?EV[0?ofkP3om^h0
3@3om^h00`0mFJ/0ooK^0?ofkP070?ofkP800000?@3om^h00`000000ooK^0?ofkP070?ofkP40oooo
000a0?ofkP030000003om^h0ooK^01T0ooK^00<0?EV[0?ofkP3om^h00`3om^h303eIZ``0ooK^00<0
00000?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0?EV[0080?EV[1`3o
m^h303eIZ`H0ooK^00<0?EV[0?ofkP3om^h00`3om^h30=@m6@040?ofkP00000090X502@:1@800000
0P0f3`P010000000=Pl803eIZ`0f3`P2000000@0EaP<00<0000005LH301G60`00`1G60`00`000000
N28@07PR400407PR40040000001h8Q00N28@07PR40<0?EV[1P2C:Q<00`000000TbXC09<Z4`0609<Z
4`030000002Y<AH0ZC4F0080ZC4F00H000000:Ta5P2Y<AH0?EV[0:Ta5P0000050:Ta5P030000002l
=aP0_3LH00<0_3LH00<000000;`g602l=aP00P2l=aP00`000000BVc@04Y/d00304Y/d0030000001:
K=00BVc@00@0BVc@00<0000004Y/d01:K=00101:K=000`3D?AT0BVc@0000000300000080BFW;00<0
000004UYb`19JL/01@19JL/00`000000BFW;04UYb`0504UYb`0400000019JL/0e3dI04UYb`80e3dI
0`19JL/00`000000BFW;04UYb`0604UYb`0400000019JL/00000000000@0B6K400<0e3dI00000018
I/@01`18I/@00`000000B6K404QVa00704QVa0040=@m6@18I/@0B6K404QVa0D0e3dI00@0B6K40000
0018I/@0B6K40P00000304IR_0030=@m6@16H[`0000000T0AV:l0`3D?AT20?ofkP80e3dI1`3om^h0
0`0mFJ/0ooK^0?ofkP0@0?ofkP0303eIZ`3om^h0?EV[0080?EV[3@3om^h00`0mFJ/0ooK^0?ofkP0=
0?ofkP0303eIZ`3om^h0ooK^00T0ooK^0`00000j0?ofkP030000003om^h0ooK^00L0ooK^0@3oool0
0340ooK^00<000000?ofkP3om^h06@3om^h00`0mFJ/0ooK^0?ofkP060?ofkP@0?EV[1`3om^h00`00
0000?EV[0?ofkP040?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h00P3om^h403eI
Z`<0ooK^00<0?EV[0?ofkP3om^h00`0mFJ/30?ofkP0303eIZ`3om^h0ooK^0080ooK^1@3D?AT01@00
000090X50000000T2PD000000080=Pl800D0000003eIZ`0f3`P0=Pl80000000505LH30030000001G
60`0EaP<0080EaP<0P00000607PR40070000001h8Q00N28@07PR400mFJ/0000009<Z4`0303eIZ`@0
TbXC00<0000009<Z4`2C:Q<0102C:Q<00`000000ZC4F0:Ta5P030:Ta5P040000002Y<AH0ZC4F03eI
Z`80ZC4F00@000000:Ta5P2Y<AH0ZC4F0P0000060;`g60030000002l=aP0_3LH0080_3LH00<00000
04Y/d01:K=000`1:K=000`000000BVc@04Y/d00304Y/d0030000001:K=00BVc@00<0BVc@00<0e3dI
0000003D?AT0101:K=04000000D0BFW;00<0000004UYb`19JL/01P19JL/00`000000e3dI04UYb`03
04UYb`80e3dI00<0000004UYb`19JL/01P19JL/00`000000BFW;04UYb`0204UYb`8000000P3D?AT0
0`000000B6K404QVa00704QVa00300000018I/@0B6K400H0B6K400<0e3dI04QVa018I/@01`18I/@5
0=@m6@0404QVa000000000000=@m6@80AV:l00<0000004IR_016H[`0203D?AT40?ofkP030=@m6@3o
m^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h0403om^h00`0mFJ/0ooK^0?ofkP020?ofkP<0?EV[2P3o
m^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00`0ooK^0`00000h0?ofkP030000003o
m^h0ooK^00H0ooK^0@3oool00340ooK^00<000000?ofkP3om^h06@3om^h00`0mFJ/0ooK^0?ofkP0:
0?ofkP<0?EV[0`3om^h00`000000ooK^03eIZ`040?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[
0?ofkP3om^h01P3om^h403eIZ`D0ooK^100mFJ/30?ofkP060=@m6@3om^h0e3dI0=@m6@3om^h00000
0P0T2PD2000000<0=Pl800<0000003eIZ`0f3`P00P00000505LH30050000001G60`0EaP<05LH3000
00000P1h8Q000`000000N28@07PR400407PR40040000001h8Q00N28@03eIZ`80TbXC00<0000009<Z
4`2C:Q<00`0mFJ/00`2C:Q<0000009<Z4`0409<Z4`8000001@2Y<AH00`000000ZC4F03eIZ`030:Ta
5P040000002Y<AH0ZC4F00000080_3LH00<000000;`g602l=aP00`2l=aP00`000000_3LH0;`g6002
0;`g60030000001:K=00BVc@00<0BVc@00<0000004Y/d01:K=000`1:K=000`000000BVc@04Y/d002
04Y/d0040=@m6@1:K=00000004Y/d080e3dI101:K=0010000000BVc@00000000000304UYb`030000
0019JL/0BFW;00D0BFW;00<000000=@m6@19JL/01P19JL/20=@m6@L0BFW;00<0000004UYb`19JL/0
0`19JL/00`3D?AT0BFW;00000002000000L0B6K400<0000004QVa018I/@01P18I/@00`3D?AT00000
04QVa00804QVa00300000018I/@0B6K40080B6K42@3D?AT504IR_080e3dI0P0mFJ/20?ofkP030=@m
6@3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h0403om^h00`0mFJ/0ooK^0?ofkP050?ofkP<0?EV[
1`3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00l0ooK^0P00000f0?ofkP030000
003om^h0ooK^00H0ooK^0@3oool00340ooK^00<000000?ofkP3om^h06@3om^h00`0mFJ/0ooK^0?of
kP0=0?ofkP80?EV[00@0000003eIZ`3om^h0?EV[103om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eI
Z`3om^h0ooK^00P0ooK^100mFJ/50?ofkP0303eIZ`3om^h0?EV[0080?EV[00H0ooK^0=@m6@3D?AT0
e3dI0?ofkP00000202@:1@030000000f3`P0=Pl80080=Pl800H0?EV[03H?200f3`P0000005LH3000
000405LH30040000001G60`0EaP<000000<0N28@00<0000007PR401h8Q00101h8Q0010000000N28@
03eIZ`00000309<Z4`030000002C:Q<0TbXC0080TbXC0`0mFJ/309<Z4`040000002Y<AH0ZC4F0000
00D0ZC4F00<0000003eIZ`2Y<AH0102Y<AH01@000000_3LH0;`g602l=aP0000000D0_3LH00<00000
0;`g602l=aP00P2l=aP00`000000BVc@04Y/d00304Y/d0030000001:K=00BVc@00<0BVc@00D00000
04Y/d01:K=00BVc@0=@m6@0204Y/d0050000001:K=00BVc@04Y/d03D?AT00`1:K=0010000000BVc@
04Y/d01:K=020000000304UYb`000000BFW;00H0BFW;00<0e3dI04UYb`19JL/01P19JL/010000000
BFW;0=@m6@3D?AT404UYb`0300000019JL/0BFW;00<0BFW;00@0e3dI04UYb`19JL/000000P19JL/2
000000D0B6K400<0000004QVa018I/@01@18I/@00`3D?AT0000004QVa00804QVa00300000018I/@0
B6K400@0B6K400@0e3dI04QVa018I/@000000P18I/@3000000<0AV:l00<0e3dI04IR_00000000P3o
m^h20=@m6@0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h0403om^h00`0mFJ/0ooK^0?of
kP080?ofkP<0?EV[103om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^0140ooK^0`00
000c0?ofkP030000003om^h0ooK^00H0ooK^0@3oool00340ooK^00<000000?ofkP3om^h06@3om^h0
0`0mFJ/0ooK^0?ofkP0?0?ofkP030000003om^h0?EV[0080?EV[0P3om^h203eIZ`l0ooK^00<0?EV[
0?ofkP3om^h0203om^h0100mFJ/0ooK^0?ofkP3om^h403eIZ`040?ofkP0mFJ/0ooK^0?ofkP80e3dI
0`0mFJ/0103om^h0e3dI0000000T2PD2000000@0=Pl800<0?EV[03H?200000000P1G60`00`000000
EaP<05LH300305LH30030000001G60`0000000@0N28@00<0000007PR401h8Q00101h8Q000`000000
?EV[09<Z4`0309<Z4`030000002C:Q<0TbXC00@0TbXC00<0000003eIZ`0mFJ/00P0mFJ/20:Ta5P03
0000002Y<AH0ZC4F00<0ZC4F00<0?EV[0:Ta5P2Y<AH00`2Y<AH00`000000_3LH0;`g60030;`g6003
0000002l=aP0_3LH0080_3LH00<000000;`g602l=aP00P2l=aP00`000000BVc@04Y/d00304Y/d003
0000001:K=00BVc@00@0BVc@00<0000004Y/d03D?AT00`1:K=000`000000BVc@04Y/d00204Y/d004
0=@m6@1:K=00BVc@000000D0BVc@0`00000504UYb`030=@m6@000000BFW;00L0BFW;00@0000004UY
b`19JL/0BFW;0P3D?AT204UYb`0300000019JL/0BFW;0080BFW;00D0e3dI04UYb`19JL/0BFW;0000
000404UYb`<0000000<0B6K400000018I/@01P18I/@00`3D?AT0B6K40000000904QVa00300000018
I/@0B6K400<0B6K400D0e3dI04QVa018I/@0B6K40000000504QVa0030000003D?AT0e3dI0080AV:l
00@000000?ofkP3D?AT0e3dI0P3om^h203eIZ`L0ooK^00<0?EV[0?ofkP3om^h0403om^h00`0mFJ/0
ooK^0?ofkP0;0?ofkP<0?EV[00<0ooK^03eIZ`3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP<0
0000<03om^h00`000000ooK^0?ofkP060?ofkP40oooo000a0?ofkP030000003om^h0ooK^01T0ooK^
00<0?EV[0?ofkP3om^h03P3om^h01P000000ooK^0?ofkP3om^h0?EV[0?ofkP<0?EV[00@0ooK^03eI
Z`0mFJ/0?EV[303om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00H0ooK^0`0mFJ/0
103om^h0e3dI0=@m6@3om^h20=@m6@@0?EV[00<0=Pl80000000f3`P00P0f3`P00`0mFJ/000000000
000305LH30030000001G60`0EaP<00<0EaP<0P00000507PR40030000001h8Q00N28@00@0N28@00<0
?EV[09<Z4`2C:Q<0102C:Q<00`000000TbXC09<Z4`0509<Z4`030000002Y<AH0ZC4F00<0?EV[00<0
00000:Ta5P2Y<AH00P2Y<AH00`0mFJ/000000:Ta5P020:Ta5P8000001@2l=aP00`000000_3LH0;`g
60030;`g60030000002l=aP0_3LH0080_3LH00<0000004Y/d01:K=000P1:K=000`000000BVc@04Y/
d00404Y/d0030000003D?AT0BVc@00<0BVc@00<0000004Y/d01:K=000`1:K=000`3D?AT0000004Y/
d00604Y/d0030000001:K=000000008000000P3D?AT00`000000BFW;04UYb`0604UYb`0300000019
JL/0BFW;00@0BFW;0P3D?AT404UYb`050=@m6@19JL/0BFW;04UYb`0000002019JL/3000000D0B6K4
00<0e3dI04QVa00000002@18I/@00`000000B6K404QVa00204QVa080e3dI0`18I/@00`000000B6K4
04QVa00404QVa0030=@m6@18I/@0B6K40080000000<0ooK^0=@m6@3D?AT01@3om^h303eIZ`@0ooK^
00<0?EV[0?ofkP3om^h0403om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP<0?EV[3`3om^h00`0mFJ/0ooK^
0?ofkP0F0?ofkP800000;P3om^h00`000000ooK^0?ofkP060?ofkP40oooo000`0?ofkP030000003o
m^h0ooK^01X0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`000000ooK^0?ofkP020?ofkP0503eIZ`3o
m^h0ooK^03eIZ`3om^h00`0mFJ/0103om^h0?EV[03eIZ`0mFJ/90?ofkP0303eIZ`3om^h0ooK^00H0
ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^03eIZ`0203eIZ`070=@m6@3om^h0e3dI0=@m
6@00000090X50000000303eIZ`80=Pl800<0?EV[0000000000000`1G60`00`000000EaP<05LH3003
05LH30030000001h8Q00N28@00@0N28@00<0000007PR401h8Q000`1h8Q000`000000?EV[00000005
09<Z4`030000002C:Q<0TbXC00@0TbXC00<000000:Ta5P2Y<AH0102Y<AH303eIZ`040:Ta5P0mFJ/0
ZC4F00000080ZC4F00@000000;`g602l=aP000001@2l=aP00`000000_3LH0;`g60020;`g60030000
002l=aP0_3LH0080_3LH0P00000404Y/d0030000001:K=00BVc@00<0BVc@00<0e3dI04Y/d01:K=00
0`1:K=000`000000BVc@04Y/d00404Y/d080e3dI1@1:K=000`000000BVc@04Y/d00204Y/d0030=@m
6@1:K=000000008000001`19JL/00`000000BFW;04UYb`0504UYb`050000003D?AT0e3dI04UYb`3D
?AT01019JL/00`000000BFW;04UYb`0604UYb`0300000019JL/0BFW;00<000000P3D?AT204QVa003
00000018I/@0B6K400L0B6K400D0000004QVa018I/@0B6K40=@m6@0404QVa00300000018I/@0B6K4
00@0B6K400H0e3dI04QVa018I/@0B6K40000003om^h20=@m6@T0ooK^0`0mFJ/00`3om^h0?EV[0?of
kP0A0?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP0mFJ/00P0mFJ/<0?ofkP0303eIZ`3o
m^h0ooK^01P0ooK^0`00000/0?ofkP030000003om^h0ooK^00D0ooK^0@3oool00300ooK^00<00000
0?ofkP3om^h06P3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP030000003om^h0ooK^0080ooK^00<0?EV[
0?ofkP0mFJ/01@3om^h303eIZ`040?ofkP0mFJ/0?EV[03eIZ`H0ooK^00<0?EV[0?ofkP3om^h01P3o
m^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3D?AT0e3dI0080e3dI0`0mFJ/00`3D?AT000000000
000203H?20030000000f3`P0?EV[0080?EV[00<0000005LH301G60`00`1G60`01`000000EaP<05LH
301G60`0000007PR400000001P1h8Q0020000000N28@07PR401h8Q00000003eIZ`2C:Q<000001P2C
:Q<00`000000TbXC09<Z4`0209<Z4`030000002Y<AH0000000H0ZC4F00<000000:Ta5P0mFJ/00P0m
FJ/20:Ta5P050000002l=aP0_3LH0;`g600000001@2l=aP00`000000_3LH0;`g60020;`g60040000
002l=aP0_3LH0;`g6080000000H0BfkD000000000000000004Y/d000000504Y/d0030=@m6@1:K=00
BVc@00<0BVc@00<0000004Y/d01:K=00101:K=000`000000BVc@0=@m6@0404Y/d0050000001:K=00
BVc@04Y/d03D?AT00`1:K=0010000000BVc@00000000000504UYb`0300000019JL/0BFW;00D0BFW;
00<0000004UYb`19JL/00P3D?AT304UYb`0300000019JL/0BFW;00L0BFW;00<0000004UYb`19JL/0
0P19JL/00`3D?AT0BFW;00000003000000P0B6K400D0000004QVa018I/@0B6K40=@m6@0504QVa003
00000018I/@0B6K400<0B6K400L0e3dI04QVa018I/@0B6K40000003om^h0e3dI00h0ooK^0`0mFJ/@
0?ofkP0303eIZ`3om^h0ooK^0100ooK^00<0?EV[0?ofkP3om^h00P3om^h303eIZ`T0ooK^00<0?EV[
0?ofkP3om^h06`3om^h2000002X0ooK^00<000000?ofkP3om^h01@3om^h10?ooo`00<03om^h00`00
0000ooK^0?ofkP0J0?ofkP80?EV[3@3om^h00`000000ooK^0?ofkP030?ofkP80?EV[2@3om^h303eI
Z`030?ofkP0mFJ/0?EV[00@0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP090?of
kP0403eIZ`3D?AT0e3dI0=@m6@80ooK^0P3D?AT203eIZ`<0=Pl800D0000003H?200mFJ/0=Pl80000
000303eIZ`<0EaP<00@0000005LH301G60`000000P1h8Q000`000000N28@07PR400407PR40060000
001h8Q00N28@0000002C:Q<0?EV[0P2C:Q<00`000000TbXC09<Z4`0309<Z4`050000002C:Q<0TbXC
09<Z4`0000000P2Y<AH00`000000ZC4F0:Ta5P040:Ta5P030000002Y<AH0?EV[0080ZC4F0`0mFJ/4
0;`g60030000002l=aP0_3LH00<0_3LH00D000000;`g602l=aP0_3LH000000020;`g60040000003>
?1X0cS`J000000<0BfkD0`00000304Y/d0030=@m6@000000BVc@00@0BVc@00<0000004Y/d01:K=00
101:K=0010000000BVc@04Y/d03D?AT304Y/d0040000001:K=00BVc@0=@m6@<0BVc@00<0000004Y/
d01:K=000P1:K=030000000304UYb`000000BFW;00H0BFW;00@0000004UYb`19JL/0e3dI0P19JL/3
0=@m6@0300000019JL/0BFW;00H0BFW;00<0000004UYb`19JL/00P19JL/01@3D?AT0BFW;04UYb`19
JL/000000080BFW;0P00000504QVa00500000018I/@0B6K404QVa03D?AT01@18I/@00`000000B6K4
04QVa00304QVa0030=@m6@18I/@0B6K40080B6K400<000000=@m6@3om^h03`3om^h0100mFJ/0ooK^
03eIZ`0mFJ/>0?ofkP0303eIZ`3om^h0ooK^0100ooK^00<0?EV[0?ofkP3om^h01@3om^h203eIZ`L0
ooK^00<0?EV[0?ofkP3om^h07@3om^h3000002L0ooK^00<000000?ofkP3om^h01@3om^h10?ooo`00
<03om^h00`000000ooK^0?ofkP0J0?ofkP0303eIZ`3om^h0?EV[00<0?EV[203om^h00`000000ooK^
0?ofkP040?ofkP0303eIZ`3om^h0ooK^00/0ooK^1P0mFJ/00`3om^h0?EV[0?ofkP060?ofkP0303eI
Z`3om^h0ooK^00P0ooK^00D0e3dI03eIZ`3D?AT0e3dI0?ofkP030=@m6@80ooK^00P0000003H?200f
3`P0=Pl80000000f3`P0?EV[00000080EaP<00<0000005LH300mFJ/00`0mFJ/205LH30050000001h
8Q00N28@07PR400000001P1h8Q020000000309<Z4`0mFJ/0TbXC0080TbXC00<0000009<Z4`2C:Q<0
102C:Q<010000000TbXC09<Z4`0000030:Ta5P030000002Y<AH0ZC4F00@0ZC4F00L0000003eIZ`2Y
<AH0ZC4F0000002l=aP0000000<0?EV[00<0_3LH0000002l=aP0102l=aP00`000000_3LH0;`g6003
0;`g60060000003>?1X0cS`J0<hl6P000000e3dI0`1;K]@01`000000BfkD000000000000e3dI04Y/
d00000001@1:K=000`000000BVc@04Y/d00404Y/d0040000001:K=00BVc@04Y/d080e3dI00@0BVc@
0000001:K=00e3dI101:K=000`000000BVc@04Y/d00504Y/d0<000001P19JL/00`000000BFW;0=@m
6@0504UYb`040000003D?AT0e3dI0=@m6@D0BFW;00<0000004UYb`19JL/00P19JL/00`3D?AT0BFW;
04UYb`0204UYb`0300000019JL/0BFW;0080BFW;0`00000204QVa00400000018I/@0B6K40=@m6@H0
B6K400<0000004QVa018I/@00P18I/@00`3D?AT0B6K404QVa00204QVa080e3dI403om^h00`0mFJ/0
ooK^0?ofkP020?ofkP<0?EV[2`3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00P0
ooK^0`0mFJ/40?ofkP0303eIZ`3om^h0ooK^0200ooK^0`00000T0?ofkP030000003om^h0ooK^00D0
ooK^0@3oool00300ooK^00<000000?ofkP3om^h06P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP<0?EV[
103om^h00`000000ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00h0ooK^1P0mFJ/50?ofkP0303eI
Z`3om^h0ooK^00T0ooK^00<0e3dI03eIZ`3D?AT00P3D?AT20?ofkP040=@m6@3om^h0e3dI000000<0
=Pl800<0000003eIZ`0000000`1G60`00`000000EaP<05LH300305LH30<0?EV[0`1h8Q000`000000
N28@07PR400407PR40040000002C:Q<0TbXC03eIZ`@0TbXC00<0000009<Z4`2C:Q<00`2C:Q<00`00
0000TbXC000000050:Ta5P030000002Y<AH0ZC4F00<0ZC4F00L0?EV[0:Ta5P2Y<AH0ZC4F0000002l
=aP0000000<0_3LH0`0mFJ/50;`g60050000002l=aP0_3LH0;`g600000000P3>?1X01@0mFJ/0cS`J
0000001;K]@0e3dI0080BfkD00D0000004]^e01;K]@0e3dI04]^e003000000@0BVc@00<0000004Y/
d01:K=00101:K=000`000000BVc@04Y/d00304Y/d0030=@m6@1:K=00e3dI00D0BVc@00<0000004Y/
d01:K=001P1:K=000`000000BVc@000000030000000404UYb`000000BFW;0=@m6@H0BFW;00@00000
04UYb`19JL/0BFW;0`3D?AT204UYb`0500000019JL/0BFW;04UYb`3D?AT01019JL/00`000000BFW;
04UYb`0604UYb`<0000000<0B6K40=@m6@18I/@01@18I/@010000000B6K404QVa018I/@20=@m6@80
B6K4103D?ATA0?ofkP0303eIZ`3om^h0ooK^00D0ooK^0P0mFJ/90?ofkP0303eIZ`3om^h0ooK^00l0
ooK^00<0?EV[0?ofkP3om^h02`3om^h303eIZ`030?ofkP0mFJ/0ooK^02@0ooK^0P00000S0?ofkP03
0000003om^h0ooK^00@0ooK^0@3oool002l0ooK^00<000000?ofkP3om^h06`3om^h00`0mFJ/0ooK^
0?ofkP060?ofkP@0?EV[00<000000?ofkP3om^h0103om^h203eIZa<0ooK^1P0mFJ/20?ofkP0303eI
Z`3om^h0ooK^00P0ooK^00<0e3dI03eIZ`3D?AT00P3D?AT30?ofkP80e3dI00<0ooK^0000000f3`P0
0P0f3`P00`000000?EV[05LH300305LH30030000001G60`0EaP<00<0EaP<00<0000007PR401h8Q00
0`0mFJ/00`1h8Q00000007PR400307PR40040000002C:Q<0000003eIZ`H0TbXC00<0000009<Z4`2C
:Q<00`2C:Q<00`000000ZC4F0:Ta5P040:Ta5P030000002Y<AH0ZC4F00<0ZC4F00@0?EV[0000002Y
<AH000000`2l=aP00`000000_3LH0;`g60020;`g60040000000mFJ/0?EV[03eIZ`80_3LH00<00000
0;`g602l=aP00P0000001@3>?1X0?EV[0<hl6P3>?1X000000080BfkD00D0e3dI04]^e01;K]@00000
0=@m6@0304]^e0030000001;K]@000000080000000<0BVc@0000001:K=00101:K=000`000000BVc@
04Y/d00404Y/d0030000003D?AT0BVc@00D0BVc@00<0000004Y/d01:K=001@1:K=000`000000BVc@
04Y/d00404Y/d080000000<0e3dI04UYb`19JL/01019JL/00`000000BFW;04UYb`0304UYb`0303eI
Z`19JL/0e3dI0080e3dI0P19JL/00`3D?AT0BFW;04UYb`0204UYb`0300000019JL/0BFW;00L0BFW;
00D0000004UYb`3D?AT0e3dI0000000504QVa00500000018I/@0B6K404QVa03D?AT00P18I/@50=@m
6A80ooK^00<0?EV[0?ofkP3om^h01`3om^h303eIZ`H0ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0m
FJ/0ooK^0?ofkP0>0?ofkP80?EV[9`3om^h300000200ooK^00<000000?ofkP3om^h0103om^h10?oo
o`00;`3om^h00`000000ooK^0?ofkP0L0?ofkP0303eIZ`3om^h0ooK^00P0ooK^00@0000003eIZ`0m
FJ/0?EV[0`3om^h00`0mFJ/0ooK^03eIZ`0D0?ofkP0303eIZ`3om^h0?EV[00D0?EV[2@3om^h0103D
?AT0ooK^03eIZ`3D?AT40?ofkP80e3dI0P3om^h01@000000=Pl803H?200f3`P0?EV[00H0EaP<00L0
000005LH301G60`0EaP<0000001h8Q00000000@0N28@100mFJ/01P1h8Q00000009<Z4`2C:Q<00000
03eIZ`H0TbXC00<0000009<Z4`2C:Q<00P2C:Q<00`000000ZC4F000000060:Ta5P090000002Y<AH0
ZC4F0:Ta5P0mFJ/0ZC4F0000002Y<AH0000000<0_3LH00<000000;`g602l=aP00`2l=aP00`000000
_3LH0;`g600303eIZ`060;`g60000000cS`J0<hl6P000000?EV[0`3>?1X01P000000BfkD04]^e03D
?AT0BfkD0=@m6@@0BfkD00<0000004]^e01;K]@00P1;K]@3000000@0BVc@00<0000004Y/d01:K=00
101:K=00103D?AT0BVc@0=@m6@3D?AT304Y/d0030000001:K=00BVc@00H0BVc@00<0000004Y/d01:
K=00101:K=000`000000e3dI04Y/d00400000080BFW;00<0000004UYb`19JL/00`19JL/01@0mFJ/0
BFW;04UYb`000000BFW;00D0e3dI00<0BFW;00000019JL/02019JL/00`000000BFW;0=@m6@0304UY
b`<000000P18I/@00`000000B6K404QVa0040=@m6@0404QVa03D?AT0e3dI03eIZa<0ooK^00<0?EV[
0?ofkP3om^h02P3om^h303eIZ`<0ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP0?
0?ofkP0303eIZ`3om^h0ooK^02P0ooK^0`00000M0?ofkP030000003om^h0ooK^00@0ooK^0@3oool0
02l0ooK^00<000000?ofkP3om^h0703om^h00`0mFJ/0ooK^0?ofkP070?ofkP030000003om^h0ooK^
0080ooK^100mFJ/00`3om^h0?EV[0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^0080ooK^1P0mFJ/50?of
kP050=@m6@3om^h0e3dI03eIZ`3D?AT0103om^h01@3D?AT0ooK^0?ofkP3om^h000000080=Pl800<0
?EV[0000001G60`01@1G60`010000000EaP<05LH3000000207PR40030000001h8Q00N28@00@0N28@
00<0000007PR400mFJ/00P0mFJ/00`2C:Q<0?EV[0000000709<Z4`040000002C:Q<0TbXC00000080
ZC4F00<000000:Ta5P2Y<AH0102Y<AH01@000000ZC4F0:Ta5P2Y<AH0?EV[0080ZC4F00<000000;`g
602l=aP00`2l=aP00`000000_3LH0;`g60020;`g60030000002l=aP0_3LH00<0_3LH0`0mFJ/00`3>
?1X0?EV[0<hl6P030<hl6P060000001;K]@0BfkD04]^e03D?AT00000101;K]@00`000000BfkD04]^
e00304]^e0030000001;K]@000000080000000<0BVc@0000001:K=00101:K=000`3D?AT0000004Y/
d00204Y/d080e3dI00<0BVc@0000001:K=001P1:K=000`000000BVc@04Y/d00404Y/d080e3dI1P1:
K=03000000L0BFW;00@0000004UYb`19JL/0e3dI1019JL/80=@m6@<0BFW;00<000000=@m6@19JL/0
1019JL/80=@m6@@0B6K400<0e3dI03eIZ`0mFJ/04P3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP80?EV[
00<0ooK^03eIZ`3om^h0403om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^02/0ooK^
0P00000K0?ofkP030000003om^h0ooK^00@0ooK^0@3oool002l0ooK^00<000000?ofkP3om^h0703o
m^h00`0mFJ/0ooK^0?ofkP070?ofkP030000003om^h0ooK^00@0ooK^1@0mFJ/C0?ofkP0503eIZ`3o
m^h0ooK^0?ofkP0mFJ/00`3om^h703eIZ`@0e3dI00<0?EV[0?ofkP3om^h00P3om^h20=@m6@<0ooK^
00H0000003H?200f3`P0?EV[05LH3000000505LH30040000001G60`0EaP<000000<0N28@00<00000
07PR401h8Q000`1h8Q000`000000N28@0000000209<Z4`<0?EV[00<0000009<Z4`2C:Q<0102C:Q<0
0`000000TbXC000000040:Ta5P030000002Y<AH0ZC4F00@0ZC4F00<000000:Ta5P0mFJ/00P2Y<AH0
0`000000_3LH000000040;`g60030000002l=aP0_3LH00<0_3LH00@000000;`g602l=aP0_3LH0P00
00020<hl6P<0?EV[0`3>?1X01@000000BfkD0=@m6@3D?AT0BfkD0080e3dI0`1;K]@00`000000BfkD
04]^e00304]^e0030000001;K]@0BfkD0080BfkD0`00000304Y/d0030=@m6@000000BVc@00D0BVc@
0P3D?AT704Y/d0030000001:K=00BVc@00<0BVc@00<0e3dI0000001:K=001P1:K=000`000000BVc@
04Y/d002000000@0BFW;00@0000004UYb`19JL/0e3dI1@19JL/00`000000BFW;04UYb`0504UYb`X0
e3dI0P19JL/01@000000BFW;04UYb`3D?AT0000000@0B6K400<0e3dI0000000mFJ/04`3om^h00`0m
FJ/0ooK^0?ofkP0@0?ofkP<0?EV[403om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^
02d0ooK^0`00000H0?ofkP030000003om^h0ooK^00@0ooK^0@3oool002l0ooK^00<000000?ofkP3o
m^h0703om^h203eIZ`L0ooK^00<000000?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0603eIZa00
ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`070?ofkPH0?EV[00<0e3dI03eIZ`3om^h00`3om^h20=@m
6@<0ooK^00<0000003H?200mFJ/00P1G60`00`000000EaP<05LH300405LH30800000101h8Q000`00
0000N28@07PR400407PR40050000002C:Q<0TbXC09<Z4`0mFJ/00P2C:Q<303eIZ`D0TbXC00<00000
0:Ta5P2Y<AH0102Y<AH00`000000ZC4F0:Ta5P040:Ta5P0403eIZ`2Y<AH0ZC4F00000080_3LH00<0
00000;`g602l=aP00`2l=aP00`000000_3LH0;`g60020;`g60040000002l=aP0_3LH00000080cS`J
00D000000<hl6P0mFJ/0cS`J0000000403eIZ`070=@m6@1;K]@0BfkD04]^e0000000BfkD0=@m6@02
04]^e0030000001;K]@0BfkD00<0BfkD00<0000004]^e01;K]@00`1;K]@01`000000BfkD00000000
0000e3dI04Y/d00000001`1:K=000`000000e3dI0=@m6@0404Y/d0030000001:K=00BVc@00<0BVc@
00<0e3dI0000001:K=001`1:K=000`000000BVc@04Y/d00204Y/d08000000P19JL/00`000000BFW;
0=@m6@0504UYb`0300000019JL/0BFW;00L0BFW;00<000000=@m6@19JL/01`19JL/010000000BFW;
04UYb`3D?AT204UYb`8000000P3D?AT00`000000?EV[03eIZ`0C0?ofkP0303eIZ`3om^h0ooK^0140
ooK^00<0?EV[0?ofkP0mFJ/00P0mFJ/=0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3o
m^h0<@3om^h3000001H0ooK^00<000000?ofkP3om^h00`3om^h10?ooo`00;P3om^h00`000000ooK^
0?ofkP0M0?ofkP0303eIZ`3om^h0?EV[0080?EV[0`3om^h00`000000ooK^0?ofkP040?ofkP0303eI
Z`3om^h0ooK^0080ooK^00<0?EV[0?ofkP0mFJ/01@0mFJ/=0?ofkP0403eIZ`3om^h0ooK^03eIZ`X0
ooK^00<0e3dI03eIZ`0mFJ/0100mFJ/20?ofkP030=@m6@3om^h0e3dI00<0ooK^0P000000100mFJ/0
EaP<05LH3000000605LH30030000001h8Q00N28@00@0N28@00<0000007PR401h8Q000P1h8Q000`00
0000TbXC0000000209<Z4`0603eIZ`2C:Q<0TbXC09<Z4`000000TbXC0`0mFJ/0102C:Q<000000:Ta
5P0000050:Ta5P030000002Y<AH0ZC4F00@0ZC4F00<0?EV[0:Ta5P000000102l=aP00`000000_3LH
0;`g60030;`g60030000002l=aP0_3LH00<0_3LH00T000000<hl6P3>?1X0cS`J0000003>?1X0?EV[
0<hl6P000000103>?1X00`000000BfkD04]^e00204]^e0050000001;K]@0e3dI04]^e00000001@1;
K]@00`000000BfkD04]^e00304]^e0050000001;K]@0BfkD0=@m6@1;K]@00`00000504Y/d0040000
001:K=00BVc@04Y/d080e3dI0P1:K=000`000000BVc@04Y/d00204Y/d0030=@m6@1:K=00000000L0
BVc@00<0000004Y/d01:K=001@1:K=03000000030=@m6@19JL/0BFW;00<0BFW;00<0000004UYb`19
JL/01`19JL/00`000000e3dI04UYb`0704UYb`0400000019JL/0e3dI0=@m6@@0BFW;00<0e3dI0000
00000000100mFJ/B0?ofkP0303eIZ`3om^h0ooK^0100ooK^00<0?EV[0?ofkP3om^h00`3om^h303eI
Z`X0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0d0?ofkP800000503om^h00`00
0000ooK^0?ofkP030?ofkP40oooo000^0?ofkP030000003om^h0ooK^01h0ooK^00@0?EV[0?ofkP3o
m^h0ooK^0P0mFJ/00`000000ooK^0?ofkP030?ofkP80?EV[1P3om^h00`0mFJ/0ooK^0?ofkP020?of
kPD0?EV[2P3om^h00`0mFJ/0ooK^03eIZ`0:0?ofkP80e3dI00<0ooK^0=@m6@3om^h01`0mFJ/01P3D
?AT0ooK^0?ofkP3om^h0000003eIZ`@0EaP<00<0000005LH301G60`00P1G60`2000000H0N28@00D0
000007PR401h8Q00N28@0000000209<Z4`030000002C:Q<0?EV[00D0TbXC00@0000009<Z4`2C:Q<0
TbXC0`0mFJ/00`000000ZC4F0:Ta5P040:Ta5P030000002Y<AH0ZC4F0080ZC4F00<0?EV[0:Ta5P00
00001P2l=aP00`000000_3LH0;`g60020;`g60030000002l=aP0_3LH0080_3LH00<000000<hl6P3>
?1X00`3>?1X0100mFJ/0cS`J0<hl6P0000040<hl6P030000001;K]@0BfkD0080BfkD00<0000004]^
e01;K]@00P3D?AT504]^e0030000001;K]@0BfkD00<0BfkD00<0000004]^e03D?AT00`1;K]@00`00
0000BfkD000000030000000304Y/d0000000BVc@00@0BVc@0P3D?AT01`000000BVc@04Y/d01:K=00
e3dI04Y/d00000001`1:K=000`000000BVc@04Y/d00604Y/d0030000001:K=00e3dI00@000000P19
JL/00`000000BFW;04UYb`0604UYb`80e3dI2019JL/00`000000BFW;0=@m6@0504UYb`080=@m6@19
JL/000000?ofkP0mFJ/0ooK^03eIZ`3om^h203eIZ`l0ooK^00<0?EV[0?ofkP3om^h04@3om^h00`0m
FJ/0ooK^0?ofkP060?ofkP80?EV[1`3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^
03H0ooK^0`00000A0?ofkP030000003om^h0ooK^00<0ooK^0@3oool002h0ooK^00<000000?ofkP3o
m^h07P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP060000000mFJ/0?EV[03eIZ`3om^h0?EV[203om^h0
0`0mFJ/0ooK^0?ofkP050?ofkPD0?EV[1`3om^h203eIZ`X0ooK^103D?AT20?ofkP030=@m6@0mFJ/0
ooK^00L0?EV[00<0ooK^0000000mFJ/0101G60`01@000000EaP<05LH301G60`000000080N28@00<0
000007PR401h8Q00101h8Q0010000000N28@07PR4000000309<Z4`0303eIZ`2C:Q<0TbXC00D0TbXC
00@0000009<Z4`2C:Q<000000P2Y<AH303eIZ`D0ZC4F00P000000:Ta5P2Y<AH0ZC4F03eIZ`000000
_3LH000000D0_3LH00<000000;`g602l=aP00`2l=aP01P000000_3LH0;`g60000000cS`J000000@0
cS`J00D0?EV[0<hl6P3>?1X0cS`J000000030<hl6P030000001;K]@0BfkD0080BfkD00<0000004]^
e01;K]@00P1;K]@00`3D?AT0BfkD04]^e00204]^e0030000001;K]@0BfkD00<0BfkD00<000000=@m
6@1;K]@00`1;K]@00`000000BfkD04]^e00304]^e08000001P1:K=001@000000e3dI0=@m6@1:K=00
e3dI0080BVc@00<0000004Y/d01:K=00101:K=000`000000BVc@04Y/d00604Y/d0030000003D?AT0
e3dI00D0BVc@0`00000704UYb`030=@m6@19JL/0BFW;00L0BFW;00<0000004UYb`3D?AT01019JL/2
0=@m6@8000000P3om^h203eIZ`@0ooK^0`0mFJ/<0?ofkP0303eIZ`3om^h0ooK^0140ooK^00<0?EV[
0?ofkP3om^h0203om^h303eIZ`@0ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP0i
0?ofkP8000003`3om^h00`000000ooK^0?ofkP030?ofkP40oooo000^0?ofkP030000003om^h0ooK^
01l0ooK^00D0?EV[0?ofkP3om^h0ooK^000000030?ofkPD0?EV[1P3om^h00`0mFJ/0ooK^0?ofkP08
0?ofkPD0?EV[103om^h203eIZ`T0ooK^103D?AT30?ofkP040=@m6@0mFJ/0ooK^0=@m6@<0ooK^1P0m
FJ/405LH30040000001G60`0EaP<000000<0N28@00<0000007PR401h8Q00101h8Q000`000000N28@
0000000409<Z4`0303eIZ`000000TbXC00D0TbXC00<0000009<Z4`0000001@2Y<AH010000000?EV[
03eIZ`0mFJ/30:Ta5P040000002Y<AH0?EV[000000<0_3LH00<000000;`g602l=aP00`2l=aP00`00
0000_3LH0;`g60020;`g60030000002l=aP000000080cS`J00L000000<hl6P3>?1X0cS`J03eIZ`3>
?1X000000080cS`J00D000000<hl6P3>?1X0cS`J0000000404]^e0030000001;K]@0BfkD0080BfkD
00<000000=@m6@3D?AT00P1;K]@00`000000BfkD04]^e00304]^e0030=@m6@1;K]@0BfkD00<0BfkD
00<0000004]^e01;K]@0101;K]@3000000@0BVc@00<0000004Y/d01:K=000P3D?AT00`1:K=000000
04Y/d00604Y/d0030000001:K=00BVc@00D0BVc@00<000000=@m6@1:K=001P1:K=000`000000BVc@
04Y/d002000000@0BFW;00<0e3dI00000019JL/01`19JL/00`000000BFW;0=@m6@0404UYb`030=@m
6@19JL/0000000<0ooK^00<0?EV[0?ofkP0mFJ/01`3om^h203eIZ`X0ooK^00<0?EV[0?ofkP3om^h0
4@3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP<0?EV[00<0ooK^03eIZ`3om^h0403om^h00`0mFJ/0ooK^
0?ofkP0k0?ofkP<000003@3om^h00`000000ooK^0?ofkP020?ofkP40oooo000^0?ofkP030000003o
m^h0ooK^01l0ooK^0P0mFJ/0103om^h000000?ofkP3om^h203eIZ`<0ooK^1@0mFJ/30?ofkP0303eI
Z`3om^h0ooK^00`0ooK^100mFJ/00`3om^h0?EV[0?ofkP090?ofkP040=@m6@3om^h0e3dI0=@m6@<0
ooK^00<0e3dI03eIZ`3D?AT01@3om^h00`3D?AT0ooK^03eIZ`0503eIZ`80EaP<0P00000507PR4003
0000001h8Q00N28@00@0N28@00<0000009<Z4`2C:Q<00P2C:Q<00`0mFJ/0TbXC0000000709<Z4`03
0000002Y<AH0ZC4F00@0ZC4F00@000000:Ta5P2Y<AH0ZC4F0`0mFJ/00`000000ZC4F03eIZ`040;`g
60030000002l=aP0_3LH00<0_3LH00<000000;`g602l=aP00`2l=aP00`000000cS`J0<hl6P020<hl
6P060000003>?1X0cS`J03eIZ`3>?1X000000`3>?1X01@000000cS`J0<hl6P3>?1X0000000@0BfkD
00D0000004]^e01;K]@0BfkD0000000204]^e0030=@m6@1;K]@0000000@0BfkD00<0e3dI0000001;
K]@00`1;K]@00`000000BfkD04]^e00404]^e0040000001;K]@0BfkD04]^e080000000D0BVc@0000
001:K=00BVc@0=@m6@0204Y/d0<0e3dI1@1:K=000`000000BVc@04Y/d00504Y/d0030000003D?AT0
BVc@00H0BVc@00<0000004Y/d01:K=000`1:K=020000000304UYb`3D?AT0000000P0BFW;00<00000
04UYb`3D?AT00`19JL/20=@m6@0304UYb`000000ooK^00<0ooK^0P0mFJ/:0?ofkP<0?EV[1`3om^h0
0`0mFJ/0ooK^0?ofkP0@0?ofkP0303eIZ`3om^h0ooK^00l0ooK^0`0mFJ/@0?ofkP0303eIZ`3om^h0
ooK^03h0ooK^0`00000:0?ofkP030000003om^h0ooK^0080ooK^0@3oool002d0ooK^00<000000?of
kP3om^h08P3om^h010000000?EV[03eIZ`0mFJ/80?ofkPD0?EV[00<0ooK^03eIZ`3om^h03`3om^h4
03eIZ`P0ooK^00@0e3dI0?ofkP3D?AT0e3dI103om^h00`3D?AT0?EV[0?ofkP050?ofkP080=@m6@0m
FJ/0ooK^0?ofkP3D?AT0EaP<03eIZ`1G60`303eIZ`H0N28@00<0000007PR401h8Q000`1h8Q000`00
0000TbXC0000000209<Z4`0503eIZ`2C:Q<0TbXC09<Z4`0000001@2C:Q<00`000000ZC4F00000006
0:Ta5P030000002Y<AH0ZC4F00<0ZC4F0`0mFJ/50;`g60030000002l=aP0_3LH00<0_3LH00L00000
0;`g602l=aP0_3LH0000003>?1X0000000<0cS`J00<000000<hl6P0mFJ/00`3>?1X010000000cS`J
0<hl6P0000030<hl6P<000000P1;K]@01@000000BfkD04]^e01;K]@0000000<0BfkD00<0e3dI0000
001;K]@00P1;K]@00`3D?AT0000004]^e00404]^e0030000001;K]@0BfkD00@0BfkD00<0000004]^
e01;K]@00`1;K]@3000000050=@m6@1:K=00BVc@04Y/d00000000P1:K=030=@m6@0304Y/d0000000
BVc@00H0BVc@00<000000=@m6@1:K=001P1:K=000`000000BVc@04Y/d00604Y/d0030=@m6@000000
000000L0BFW;00<0000004UYb`3D?AT00P19JL/30=@m6@0304UYb`000000ooK^00@0ooK^0P0mFJ/=
0?ofkP<0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP0303eIZ`3om^h0ooK^0100ooK^00<0?EV[
0?ofkP0mFJ/00P0mFJ/=0?ofkP0303eIZ`3om^h0ooK^0440ooK^0P0000080?ofkP030000003om^h0
ooK^0080ooK^0@3oool002d0ooK^00<000000?ofkP3om^h08P3om^h010000000ooK^0?ofkP3om^h4
03eIZ`P0ooK^100mFJ/?0?ofkP0303eIZ`3om^h0?EV[00@0?EV[103om^h0103D?AT0ooK^0?ofkP3D
?AT40?ofkP80e3dI00<0?EV[0?ofkP3om^h0103om^h01@0mFJ/0ooK^0?ofkP3D?AT0000000@0EaP<
00<0000007PR400mFJ/00P0mFJ/407PR40050000001h8Q00N28@07PR400000000P2C:Q<010000000
TbXC09<Z4`0mFJ/409<Z4`030000002C:Q<0TbXC008000000`2Y<AH00`000000ZC4F0:Ta5P040:Ta
5P030000002Y<AH0ZC4F0080ZC4F00<0?EV[0;`g600000000`0mFJ/30;`g60030000002l=aP0_3LH
00<0_3LH00<000000;`g600000000P3>?1X00`000000cS`J0<hl6P020<hl6P030000000mFJ/0cS`J
0080cS`J00@000000<hl6P3>?1X000000P3>?1X200000080C6oH0`00000304]^e0030000001;K]@0
BfkD0080BfkD0P3D?AT0101;K]@0e3dI04]^e000000504]^e0030000001;K]@0BfkD00<0BfkD00<0
000004]^e01;K]@0101;K]@010000000BfkD0=@m6@1;K]@4000000D0BVc@0`3D?AT604Y/d0030=@m
6@1:K=00BVc@00D0BVc@00<0000004Y/d01:K=001P1:K=00103D?AT0000004Y/d01:K=0400000080
BFW;00@000000=@m6@3D?AT0BFW;0P3D?AT01019JL/0e3dI04UYb`0000050?ofkP0303eIZ`3om^h0
?EV[0100ooK^0P0mFJ/00`3om^h0?EV[0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^0100ooK^00<0?EV[
0?ofkP3om^h00P3om^h303eIZ`X0ooK^00<0?EV[0?ofkP3om^h0@`3om^h3000000D0ooK^00<00000
0?ofkP3om^h00P3om^h10?ooo`00;@3om^h00`000000ooK^0?ofkP0Q0?ofkP030000003om^h0ooK^
00D0ooK^100mFJ/70?ofkPH0?EV[2P3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[0080ooK^1@0mFJ/2
0?ofkP80e3dI103om^h20=@m6@030?ofkP0mFJ/0ooK^00<0ooK^00@0?EV[0=@m6@3om^h0e3dI0P3o
m^h010000000EaP<05LH3000000207PR40030000001h8Q00N28@00@0?EV[00@0000007PR401h8Q00
0000102C:Q<00`000000?EV[09<Z4`0409<Z4`030000002C:Q<0000000D0ZC4F00<000000:Ta5P2Y
<AH01@2Y<AH01@000000ZC4F0:Ta5P000000?EV[0080_3LH00<000000;`g602l=aP00`0mFJ/00`2l
=aP000000;`g60030;`g60030000002l=aP0000000<0cS`J00D000000<hl6P3>?1X0cS`J03eIZ`05
0<hl6P050000003>?1X0cS`J0<hl6P0000000P3M@A`010000000C6oH04a_f01<KmP30000000304]^
e0000000BfkD00<0BfkD00<0000004]^e03D?AT00P1;K]@00`000000BfkD04]^e00304]^e0030000
001;K]@0BfkD00<0BfkD00<0000004]^e01;K]@0101;K]@00`000000e3dI04]^e00204]^e0030000
001;K]@0BfkD00<000000P1:K=000`000000BVc@04Y/d0030=@m6@80BVc@00<0e3dI04Y/d01:K=00
1@1:K=000`000000BVc@04Y/d00504Y/d080e3dI00<0000004Y/d01:K=001@1:K=02000000040=@m
6@19JL/0e3dI0=@m6@80BFW;00<0e3dI0000000000001P3om^h203eIZa<0ooK^0`0mFJ/B0?ofkP03
03eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h01P3om^h203eIZ`L0ooK^00<0?EV[0?ofkP3o
m^h0A`3om^h3000000<0ooK^00@000000?ofkP3om^h0ooK^0@3oool002d0ooK^00<000000?ofkP3o
m^h0803om^h00`000000ooK^0?ofkP090?ofkPD0?EV[103om^h00`0mFJ/0ooK^0?ofkP0503eIZ`D0
ooK^0P0mFJ/40?ofkP0303eIZ`3om^h0ooK^00<0ooK^1@0mFJ/50?ofkP040=@m6@3om^h0ooK^03eI
Z`@0ooK^00@0?EV[0=@m6@3om^h0e3dI0P3om^h010000000EaP<05LH3000000307PR40030000001h
8Q00N28@00<0N28@0`0mFJ/509<Z4`0303eIZ`000000TbXC00D0TbXC00<000000:Ta5P2Y<AH01@2Y
<AH00`000000ZC4F0:Ta5P040:Ta5P040000002Y<AH0000003eIZ`<0_3LH00<000000;`g602l=aP0
0`2l=aP303eIZ`@0_3LH00<000000<hl6P3>?1X00`3>?1X01@000000cS`J0<hl6P0mFJ/0000000@0
cS`J00@000000<hl6P3>?1X000000`3M@A`01@000000C6oH04a_f01<KmP000000080C6oH10000002
04]^e0030000003D?AT0BfkD0080e3dI00<0000004]^e01;K]@00`1;K]@00`000000BfkD04]^e002
04]^e0030000001;K]@0BfkD00@0BfkD00<000000=@m6@1;K]@00`1;K]@00`000000BfkD04]^e003
04]^e0<000001@1:K=050=@m6@@0BVc@00<0000004Y/d01:K=001@1:K=000`3D?AT0000004Y/d008
04Y/d0040000003D?AT0e3dI0=@m6@8000000P3D?AT2000000L0ooK^0P0mFJ/D0?ofkP0303eIZ`3o
m^h0?EV[0080?EV[3P3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0303eIZ`3om^h0ooK^00P0ooK^0`0m
FJ/40?ofkP0303eIZ`3om^h0ooK^04X0ooK^0P0000000`3om^h000000?ofkP020?ofkP40oooo000]
0?ofkP030000003om^h0ooK^0200ooK^00<000000?ofkP3om^h0303om^h703eIZ`H0ooK^1P0mFJ/6
0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h01@0mFJ/00`3om^h0e3dI0=@m6@02
0?ofkP0603eIZ`3om^h0ooK^0?ofkP0mFJ/0ooK^0P3D?AT40?ofkP800000101h8Q000`000000N28@
07PR400407PR40030000002C:Q<0?EV[0080?EV[0P2C:Q<00`0mFJ/0000009<Z4`0409<Z4`030000
002Y<AH0000000L0ZC4F00<000000:Ta5P2Y<AH0102Y<AH00`000000?EV[0;`g60040;`g60030000
002l=aP0_3LH00@0_3LH00<0000003eIZ`0mFJ/00P0mFJ/00`3>?1X000000<hl6P030<hl6P030000
003>?1X0?EV[0080cS`J00<000000<hl6P3>?1X00`3>?1X2000000@0gD4L00D0000004a_f01<KmP0
C6oH0000000204a_f0030000001<KmP0C6oH0080000000<0e3dI0000001;K]@00P1;K]@20=@m6@@0
BfkD00<0000004]^e01;K]@00P1;K]@00`000000BfkD04]^e00304]^e080e3dI101;K]@00`000000
BfkD04]^e00404]^e0030000001;K]@0BfkD00<000000P1:K=000`3D?AT0BVc@04Y/d00204Y/d0L0
e3dI101:K=000`3D?AT0000004Y/d00304Y/d0P0e3dI0`1:K=00103D?AT000000000000000070?of
kP0303eIZ`3om^h0?EV[01<0ooK^00<0?EV[0?ofkP3om^h00`3om^h303eIZ`/0ooK^00<0?EV[0?of
kP3om^h0403om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP<0?EV[00<0ooK^03eIZ`3om^h0C@3om^h20000
00<0ooK^0@3oool002`0ooK^00<000000?ofkP3om^h0803om^h00`000000ooK^0?ofkP0A0?ofkPD0
?EV[1`3om^h503eIZ`@0ooK^00<0?EV[0?ofkP3om^h00`3om^h01@3D?AT0ooK^0=@m6@3om^h0e3dI
0080ooK^1@0mFJ/01@3om^h0?EV[0?ofkP3om^h0?EV[0080ooK^00<0e3dI0?ofkP3om^h00`3om^h0
0`000000N28@07PR400407PR40030000001h8Q00N28@0080N28@00<0000009<Z4`0000000`2C:Q<3
03eIZ`0309<Z4`000000TbXC0080TbXC00D000000:Ta5P2Y<AH0ZC4F000000070:Ta5P030000002Y
<AH0ZC4F0080ZC4F00<0000003eIZ`0000001P2l=aP00`000000_3LH0;`g60040;`g60040000002l
=aP000000<hl6P<0?EV[103>?1X01@000000?EV[0<hl6P3>?1X0000000@0cS`J00@000000=e1703M
@A`000000`3M@A`01@000000C6oH04a_f01<KmP000000080C6oH00L0000004a_f01<KmP0C6oH0=@m
6@000000C6oH0080000000<0BfkD0000001;K]@00P3D?AT00`1;K]@0000004]^e00404]^e0030000
001;K]@0BfkD0080BfkD00<0e3dI0000001;K]@00`1;K]@00`000000BfkD04]^e00504]^e0030000
001;K]@0BfkD00<0BfkD00<000000=@m6@0000001P1:K=000`000000BVc@04Y/d00204Y/d0X0e3dI
0`1:K=000`000000BVc@0=@m6@0404Y/d0050=@m6@00000000000000003om^h00`0mFJ/40?ofkP80
?EV[503om^h00`0mFJ/0ooK^0?ofkP060?ofkP<0?EV[203om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP03
03eIZ`3om^h0ooK^00h0ooK^0P0mFJ]=0?ofkP800000103om^h10?ooo`00;03om^h00`000000ooK^
0?ofkP0O0?ofkP030000003om^h0ooK^01D0ooK^1@0mFJ/0103om^h0?EV[03eIZ`0mFJ/30?ofkPH0
?EV[00<0ooK^03eIZ`3om^h00P3om^h00`3D?AT0ooK^0=@m6@020?ofkP040=@m6@3om^h0ooK^0=@m
6@80ooK^1P0mFJ/20?ofkP80e3dI1P3om^h00`000000N28@07PR400307PR40050000001h8Q00N28@
07PR400000000`2C:Q<010000000TbXC09<Z4`0mFJ/209<Z4`@0?EV[00<0TbXC0000002Y<AH00`2Y
<AH00`000000ZC4F0:Ta5P040:Ta5P090000002Y<AH0ZC4F0:Ta5P000000_3LH03eIZ`2l=aP00000
00H0_3LH00<000000;`g602l=aP0102l=aP00`000000cS`J0<hl6P020<hl6P060000000mFJ/0?EV[
03eIZ`3>?1X0?EV[103>?1X00`000000cS`J0<hl6P0200000080gD4L00D000000=e1703M@A`0gD4L
0000000304a_f0050000001<KmP0C6oH0000001<KmP00P3D?AT00`1<KmP0000004a_f00204a_f0<0
00000P1;K]@00`3D?AT0000004]^e00304]^e0030000001;K]@0BfkD0080BfkD00<0e3dI04]^e000
0000101;K]@00`000000BfkD04]^e00404]^e0030000001;K]@0BfkD00@0BfkD00<0e3dI04]^e01;
K]@00`00000204Y/d0030000001:K=00BVc@00D0BVc@00<0e3dI0000001:K=001`1:K=000`000000
BVc@0=@m6@0404Y/d0040=@m6@000000e3dI000000D0ooK^0P0mFJ/0103om^h0?EV[0?ofkP0mFJ/C
0?ofkP0303eIZ`3om^h0ooK^00X0ooK^0`0mFJ/50?ofkP0303eIZ`3om^h0ooK^0100ooK^00<0?EV[
0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP1:0?ofkP030000003om^h0ooK^00@0ooK^0@3oool0
02`0ooK^00<000000?ofkP3om^h07P3om^h00`000000ooK^0?ofkP0I0?ofkPD0?EV[1`3om^h603eI
Z`80ooK^0P3D?AT20?ofkP040=@m6@3om^h0ooK^0=@m6@<0ooK^00<0e3dI0?ofkP3om^h01P0mFJ/0
0`3D?AT0ooK^0?ofkP040?ofkP030000001h8Q00N28@00@0N28@00@0000007PR401h8Q000000102C
:Q<00`000000?EV[09<Z4`0409<Z4`030000002C:Q<0?EV[0080?EV[102Y<AH00`000000ZC4F0:Ta
5P040:Ta5P050000002Y<AH000000;`g600mFJ/00`2l=aP00`000000_3LH0;`g60040;`g60030000
002l=aP0_3LH0080_3LH00<000000<hl6P000000103>?1X00`000000cS`J0<hl6P0303eIZ`<0cS`J
00<000000<hl6P0000000P3M@A`010000000gD4L0=e1700000030=e170040000001<KmP0C6oH0000
00<0C6oH00D0e3dI04a_f01<KmP0C6oH0000000404a_f0050000001<KmP000000000001;K]@00P3D
?AT304]^e0070000001;K]@0BfkD04]^e03D?AT0BfkD0000000404]^e0030000001;K]@0BfkD00@0
BfkD00<0000004]^e01;K]@0101;K]@00`3D?AT0BfkD04]^e00404]^e0<000001P1:K=000`3D?AT0
000004Y/d00604Y/d08000000P3D?AT404Y/d0040000003D?AT0?EV[03eIZ`P0ooK^0`0mFJ/D0?of
kP0303eIZ`3om^h0ooK^00d0ooK^0`0mFJ/00`3om^h0?EV[0?ofkP0A0?ofkP0303eIZ`3om^h0ooK^
0100ooK^00<0?EV[0?ofkP3om^h0B03om^h2000000L0ooK^0@3oool002`0ooK^00<000000?ofkP3o
m^h07P3om^h00`000000ooK^0?ofkP0L0?ofkPD0?EV[1`3om^h603eIZ`<0ooK^00@0e3dI0?ofkP3o
m^h0e3dI0`3om^h00`3D?AT0ooK^0?ofkP0203eIZ`030?ofkP0mFJ/0?EV[00D0?EV[103om^h00`00
0000N28@07PR400307PR40030000001h8Q00000000D0TbXC00<0?EV[0000002C:Q<01@2C:Q<01000
0000e3dI0:Ta5P2Y<AH403eIZ`030:Ta5P000000ZC4F00D0ZC4F00<000000;`g600mFJ/01@2l=aP0
0`000000_3LH0;`g60030;`g60050000002l=aP0_3LH0;`g600000000`3>?1X00`000000cS`J0<hl
6P020<hl6P030000003>?1X0?EV[0080cS`J100mFJ/01@000000gD4L0=e1703M@A`000000080gD4L
00D000000=e1703M@A`0gD4L0000000304a_f0040000001<KmP0e3dI000000<0C6oH00<0000004a_
f01<KmP00P1<KmP010000000C6oH04a_f01<KmP300000080e3dI00D0000004]^e01;K]@0BfkD0=@m
6@0204]^e0030000001;K]@0BfkD0080BfkD00<0000004]^e01;K]@00`1;K]@00`000000BfkD04]^
e00404]^e0030=@m6@1;K]@0BfkD00D0BfkD00<0000004]^e01;K]@00`00000204Y/d0030=@m6@1:
K=00BVc@00H0BVc@00<0000004Y/d03D?AT01@1:K=000`000000e3dI000000020?ofkP<0?EV[1P3o
m^h203eIZa@0ooK^00<0?EV[0?ofkP3om^h0403om^h303eIZa40ooK^00<0?EV[0?ofkP3om^h03`3o
m^h00`0mFJ/0ooK^0?ofkP180?ofkP030000003om^h0ooK^00L0ooK^0@3oool002`0ooK^00<00000
0?ofkP3om^h07@3om^h00`000000ooK^0?ofkP0P0?ofkPH0?EV[1@3om^h803eIZ`030?ofkP3D?AT0
ooK^00<0ooK^00H0e3dI0?ofkP0mFJ/0ooK^03eIZ`3D?AT40?ofkPL0?EV[00<0000007PR401h8Q00
101h8Q000`000000TbXC09<Z4`0309<Z4`0403eIZ`2C:Q<0TbXC000000@0TbXC00<000000:Ta5P00
00001P2Y<AH303eIZ`@0ZC4F00<000000;`g600mFJ/01`2l=aP00`000000_3LH0;`g60030;`g6003
0000002l=aP0000000@0cS`J00<000000<hl6P3>?1X00`3>?1X01P0mFJ/0cS`J0<hl6P3>?1X00000
0<hl6P8000000`0mFJ/20=e170040000003M@A`0gD4L00000080gD4L00P0000004a_f01<KmP0C6oH
0000003D?AT0C6oH000000<0C6oH00D0000004a_f01<KmP0C6oH0000000504a_f0040000001<KmP0
000000000080e3dI00D0BfkD0=@m6@1;K]@0BfkD0000000404]^e0030000001;K]@0BfkD00@0BfkD
00<0000004]^e01;K]@00P1;K]@20=@m6@L0BfkD00<0000004]^e01;K]@0101;K]@00`000000e3dI
0000000704Y/d0030000001:K=00e3dI00D0BVc@00<000000=@m6@0000001P3om^h203eIZ`@0ooK^
0P0mFJ/C0?ofkP0303eIZ`3om^h0ooK^0180ooK^00@0?EV[0?ofkP0mFJ/0?EV[3`3om^h00`0mFJ/0
ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^04H0ooK^0P00000:0?ofkP40oooo000/0?ofkP030000
003om^h0ooK^01`0ooK^00<000000?ofkP3om^h0903om^h603eIZ`<0ooK^00@0?EV[0=@m6@3om^h0
ooK^1P0mFJ/30?ofkP80?EV[0P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP040=@m6@3om^h0ooK^0?of
kPD0?EV[101h8Q000`000000TbXC0000000309<Z4`0303eIZ`2C:Q<0TbXC0080TbXC00@0000009<Z
4`2C:Q<000000`2Y<AH00`000000ZC4F0:Ta5P060:Ta5P@0?EV[0P2l=aP00`0mFJ/0000000000006
0;`g60030000002l=aP0_3LH00<0_3LH00<000000<hl6P3>?1X0103>?1X00`000000cS`J0<hl6P02
0<hl6P0303eIZ`000000cS`J0080cS`J00H000000=e1703M@A`0gD4L0000003M@A`403eIZ`030=e1
70000000gD4L0080gD4L00@0000004a_f01<KmP0e3dI0P1<KmP01@000000C6oH04a_f01<KmP00000
00<0C6oH00<0000004a_f01<KmP00P1<KmP00`000000C6oH04a_f00204a_f0070000001<KmP0e3dI
0=@m6@1;K]@0?EV[0000000304]^e0030000001;K]@0BfkD00@0BfkD00<0000004]^e01;K]@00P1;
K]@00`3D?AT0000004]^e00604]^e0030000001;K]@0BfkD00D0BfkD00<0e3dI04]^e01;K]@00`00
000204Y/d080000000<0BVc@0=@m6@1:K=000`1:K=04000000T0ooK^1@0mFJ/D0?ofkP0303eIZ`3o
m^h0ooK^0140ooK^00<0?EV[0?ofkP3om^h00P3om^h303eIZ``0ooK^00<0?EV[0?ofkP3om^h03`3o
m^h00`0mFJ/0ooK^0?ofkP150?ofkP030000003om^h0ooK^00X0ooK^0@3oool002/0ooK^00<00000
0?ofkP3om^h07@3om^h00`000000ooK^0?ofkP0W0?ofkPL0?EV[103om^h20=@m6@H0?EV[00D0e3dI
0?ofkP3om^h0ooK^03eIZ`050?ofkP030=@m6@3om^h0ooK^00@0ooK^100mFJ/00`1h8Q00000009<Z
4`0209<Z4`030000002C:Q<0?EV[00H0TbXC00<0000009<Z4`000000102Y<AH00`000000ZC4F0:Ta
5P060:Ta5P030000002Y<AH0000000<0?EV[0P2l=aP00`000000_3LH0;`g60040;`g60070000002l
=aP0_3LH0;`g60000000cS`J000000060<hl6P060000003>?1X0cS`J03eIZ`3>?1X000000P3>?1X0
0`000000gD4L000000030=e170050000003M@A`0gD4L0=e1700000000P0mFJ/01`000000gD4L0=e1
70000000C6oH0=@m6@0000000P1<KmP01@000000C6oH04a_f01<KmP0000000<0C6oH00<0000004a_
f01<KmP00P1<KmP01`000000C6oH04a_f01<KmP0000004a_f03D?AT00P1<KmP30=@m6@<0BfkD00<0
000004]^e01;K]@00`1;K]@00`000000BfkD04]^e00204]^e0030=@m6@1;K]@0000000H0BfkD00<0
000004]^e01;K]@0101;K]@20=@m6@H0BfkD0`0000000`1:K=00e3dI04Y/d00304Y/d0030000003D
?AT0000000h0ooK^0`0mFJ/B0?ofkP0303eIZ`3om^h0ooK^0180ooK^00<0?EV[0?ofkP3om^h01@3o
m^h203eIZ`X0ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP140?ofkP030000003o
m^h0ooK^00/0ooK^0@3oool002/0ooK^00<000000?ofkP3om^h0703om^h00`000000ooK^0?ofkP0/
0?ofkPD0?EV[0P3om^h00`3D?AT0ooK^0?ofkP020?ofkPL0?EV[00<0ooK^03eIZ`3om^h00`3om^h0
0`3D?AT0ooK^0?ofkP050?ofkP030=@m6@000000N28@00@0?EV[0P2C:Q<00`0mFJ/0TbXC09<Z4`06
09<Z4`030000002Y<AH0ZC4F00@0ZC4F0P0000070:Ta5P030000002l=aP0?EV[0080_3LH0`0mFJ/0
0`000000_3LH0;`g60040;`g60030000002l=aP0000000<0cS`J0P0000050<hl6P030000000mFJ/0
cS`J0080cS`J00<000000<hl6P0000000P3M@A`01@000000gD4L0=e1703M@A`000000080gD4L00<0
00000=e1703M@A`00`0mFJ/01`3M@A`000000=@m6@1<KmP0000004a_f00000000`1<KmP01@000000
C6oH04a_f01<KmP0000000<0C6oH00<0000004a_f01<KmP00P1<KmP00`000000e3dI04a_f00204a_
f0030000001<KmP0C6oH00<0e3dI00<0000004]^e01;K]@00P1;K]@00`000000BfkD04]^e00204]^
e0030=@m6@1;K]@0000000D0BfkD0P00000604]^e0030=@m6@1;K]@0BfkD00D0BfkD0P000000101;
K]@0e3dI0=@m6@00000204Y/d080000000<0e3dI0000003om^h03P3om^h203eIZ`040?ofkP0mFJ/0
?EV[03eIZ`l0ooK^00<0?EV[0?ofkP3om^h04P3om^h00`0mFJ/0ooK^0?ofkP070?ofkP<0?EV[1`3o
m^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^0480ooK^0P00000>0?ofkP40oooo000[
0?ofkP030000003om^h0ooK^01/0ooK^00<000000?ofkP3om^h0;P3om^h00`3D?AT0ooK^03eIZ`08
03eIZ`<0ooK^1`0mFJ/40?ofkP030=@m6@3om^h0ooK^00<0ooK^00D0e3dI0?ofkP000000N28@0000
000309<Z4`<0?EV[00<0000009<Z4`2C:Q<0102C:Q<00`000000e3dI000000070:Ta5P030000002Y
<AH0ZC4F00<0ZC4F00@000000;`g600mFJ/000001@2l=aP303eIZ`D0_3LH00<000000<hl6P3>?1X0
103>?1X00`000000cS`J0<hl6P020<hl6P0303eIZ`000000cS`J00<0cS`J00D000000=e1703M@A`0
gD4L000000030=e170050000003M@A`0gD4L0=e1700000000P3M@A`00`000000gD4L0=e170020000
000504a_f0000000C6oH04a_f00000000P1<KmP01@000000C6oH04a_f01<KmP0000000<0C6oH00H0
000004a_f01<KmP0C6oH0000003D?AT404a_f0060000001<KmP0C6oH04a_f0000000C6oH0`3D?AT2
04]^e0070000001;K]@0BfkD04]^e03D?AT0BfkD0000000504]^e0030000001;K]@0BfkD00D0BfkD
00<0e3dI04]^e01;K]@0101;K]@200000080BfkD00@0e3dI04]^e01;K]@0BfkD1@00000@0?ofkP03
03eIZ`3om^h0ooK^00<0ooK^0`0mFJ/<0?ofkP0303eIZ`3om^h0ooK^0140ooK^00<0?EV[0?ofkP3o
m^h02`3om^h303eIZ`<0ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP120?ofkP03
0000003om^h0ooK^00h0ooK^0@3oool002/0ooK^00<000000?ofkP3om^h06P3om^h00`000000ooK^
0?ofkP0_0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT01P0mFJ/30?ofkP80e3dI0P3om^h603eIZ`03
0?ofkP3D?AT0ooK^00<0ooK^00D0e3dI0?ofkP3om^h0ooK^0000000309<Z4`80?EV[0P2C:Q<303eI
Z`<0TbXC00D000000:Ta5P2Y<AH0ZC4F000000070:Ta5P050000002Y<AH0ZC4F0:Ta5P0000000P2l
=aP00`0mFJ/0_3LH000000060;`g60080000000mFJ/0?EV[03eIZ`2l=aP000000<hl6P0000060<hl
6P060000003>?1X0cS`J03eIZ`3>?1X000000`3>?1X00`000000gD4L000000030=e170050000003M
@A`0gD4L0=e1700000000P3M@A`01@000000gD4L0=e170000000gD4L0080000000H0?EV[00000000
0000000004a_f000000204a_f0050000001<KmP0C6oH04a_f00000000`1<KmP01@000000C6oH04a_
f01<KmP0e3dI00@0C6oH00D0000004a_f01<KmP0C6oH0000000504a_f0<0e3dI00D0000004]^e03D
?AT0BfkD0000000504]^e0030000001;K]@0BfkD00@0BfkD00<000000=@m6@1;K]@0101;K]@20000
00<0BfkD0`3D?AT00`1;K]@00000000000030000000303eIZ`3om^h0ooK^00d0ooK^0P0mFJ/80?of
kP<0?EV[203om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^00h0ooK^0P0mFJ/00`3o
m^h0?EV[0?ofkP0@0?ofkP0303eIZ`3om^h0ooK^0400ooK^0P00000A0?ofkP40oooo000[0?ofkP03
0000003om^h0ooK^01X0ooK^00<000000?ofkP3om^h0;`3om^h0203D?AT0ooK^0?ofkP3om^h0e3dI
0?ofkP3D?AT0ooK^1`0mFJ/60?ofkPL0?EV[00<0ooK^0=@m6@3om^h0103om^h00`000000TbXC03eI
Z`0609<Z4`050000000mFJ/0?EV[03eIZ`000000102Y<AH00`000000ZC4F0:Ta5P050:Ta5P030000
002Y<AH000000080_3LH00D0?EV[0;`g602l=aP0_3LH000000070;`g60030000002l=aP0?EV[0080
?EV[00<0cS`J0000000000001@3>?1X00`000000?EV[0<hl6P020<hl6P030000003>?1X0000000<0
gD4L00D000000=e1703M@A`0gD4L000000020=e170050000003M@A`0gD4L0=e1700000000P3M@A`0
1`000000k4DN0>a57P000000C73J0000001<L=X00`0000001@1<KmP0000004a_f01<KmP0000000<0
C6oH00H0000004a_f01<KmP0C6oH0=@m6@00000304a_f0030000001<KmP0C6oH0080C6oH00<00000
04a_f01<KmP00`1<KmP00`000000C6oH04a_f0050=@m6@@0BfkD00<0000004]^e01;K]@0101;K]@0
0`000000e3dI04]^e00404]^e0030000001;K]@0e3dI00@0e3dI00<0BfkD00000000000010000003
03eIZ`h0ooK^00<0?EV[0?ofkP3om^h02P3om^h303eIZ`D0ooK^00<0?EV[0?ofkP3om^h04P3om^h0
0`0mFJ/0ooK^0?ofkP0@0?ofkP<0?EV[403om^h00`0mFJ/0ooK^0?ofkP0o0?ofkP030000003om^h0
ooK^0140ooK^0@3oool002X0ooK^00<000000?ofkP3om^h06P3om^h00`000000ooK^0?ofkP0`0?of
kP040=@m6@3om^h0ooK^0=@m6@80ooK^00<0e3dI0?ofkP3om^h00`3om^h603eIZ`<0ooK^00@0?EV[
0?ofkP3om^h0ooK^1P0mFJ/50?ofkP0303eIZ`2C:Q<0TbXC00H0TbXC00<0000009<Z4`0000000`0m
FJ/30:Ta5P8000001P2Y<AH010000000_3LH0;`g600mFJ/50;`g608000001P2l=aP010000000cS`J
0<hl6P3>?1X303eIZ`030000003>?1X0cS`J00<0cS`J00<0?EV[0000003>?1X00P3>?1X00`000000
gD4L0=e170030=e170050000003M@A`0gD4L0=e1700000000P3M@A`01@000000gD4L0=e170000000
gD4L008000000P3/AAh00`000000C73J0000000204a`fP030000001<L=X000000080000000<0C6oH
0000001<KmP00P1<KmP01@000000C6oH04a_f03D?AT0000000@0C6oH00D0000004a_f01<KmP0C6oH
0000000504a_f0050000001<KmP0C6oH04a_f03D?AT00P0000000`1<KmP000000=@m6@060=@m6@<0
BfkD00@000000=@m6@1;K]@0BfkD1P3D?AT204]^e0070=@m6@1;K]@000000000003oD240?EV[0?59
7@0200000080ooK^00<0?EV[0?ofkP0mFJ/00P0mFJ/;0?ofkP0303eIZ`3om^h0ooK^00d0ooK^0`0m
FJ/00`3om^h0?EV[0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^0180ooK^00<0?EV[0?ofkP0mFJ/00P0m
FJ/=0?ofkP0303eIZ`3om^h0ooK^03d0ooK^0P00000D0?ofkP40oooo000Z0?ofkP030000003om^h0
ooK^01T0ooK^00<000000?ofkP3om^h0<03om^h0103D?AT0ooK^0?ofkP3D?AT30?ofkP030=@m6@3o
m^h0ooK^00<0ooK^00<0e3dI0?ofkP3D?AT0200mFJ/30?ofkP030=@m6@3om^h0?EV[00L0?EV[00@0
ooK^0000002C:Q<0?EV[1P2C:Q<00`000000ZC4F0:Ta5P020:Ta5P@0?EV[00<0ZC4F0000002Y<AH0
0`2Y<AH010000000_3LH0000000mFJ/80;`g60030000002l=aP0_3LH0080_3LH00@000000<hl6P00
00000000103>?1X303eIZ`80cS`J00P0?EV[0<hl6P3>?1X000000<hl6P000000gD4L000000D0gD4L
00D000000=e1703M@A`0gD4L000000020=e170040000003M@A`0gD4L00000080k4DN00<000000>a5
7P0000000P1<L=X30=@m6@80C73J00<0000004a`fP0000000P0000001`1<KmP0000004a_f01<KmP0
e3dI04a_f00000000`1<KmP01@000000C6oH04a_f01<KmP0000000D0C6oH00H0000004a_f01<KmP0
C6oH0=@m6@00000504a_f0@000000P1;K]@70=@m6@8000001@1;K]@01P3D?AT0BfkD0000003oD240
000003eIZ`<000000`3om^h00`0mFJ/0ooK^0?ofkP020?ofkP<0?EV[1`3om^h203eIZa80ooK^0`0m
FJ/C0?ofkP0303eIZ`3om^h0ooK^0140ooK^00<0?EV[0?ofkP3om^h00`3om^h303eIZ`X0ooK^00<0
?EV[0?ofkP3om^h0?03om^h00`000000ooK^0?ofkP0D0?ofkP40oooo000Z0?ofkP030000003om^h0
ooK^01P0ooK^00<000000?ofkP3om^h0<@3om^h00`3D?AT0ooK^0=@m6@040?ofkP030=@m6@3om^h0
ooK^00<0ooK^00@0e3dI0?ofkP3om^h0e3dI0`3om^h603eIZ`030?ofkP3D?AT0e3dI00@0ooK^1P0m
FJ/00`000000?EV[09<Z4`0409<Z4`040000002Y<AH00000000000H0ZC4F0`0mFJ/20:Ta5P060000
002l=aP0_3LH0;`g600mFJ/00000202l=aP2000000030;`g60000000cS`J00<0cS`J00<000000<hl
6P3>?1X00`3>?1X010000000?EV[03eIZ`0mFJ/30<hl6P040000003M@A`0gD4L0=e170800000103M
@A`010000000gD4L0=e1700000020=e170070000003M@A`000000>a57P000000?EV[000000020>a5
7P050000001<L=X0000004a`fP0000000P3D?AT01@000000C73J04a`fP000000C73J00<0000000<0
e3dI04a_f00000000`1<KmP01@000000C6oH04a_f01<KmP0000000@0C6oH0P00000304a_f0030=@m
6@000000C6oH00@0C6oH0P00000304a_f0@0000000<0e3dI04]^e01;K]@00P00000704]^e0D00000
00<0?EV[000000000000103om^h00`0mFJ/0ooK^0?ofkP050?ofkP<0?EV[103om^h00`0mFJ/0ooK^
0?ofkP0B0?ofkP0303eIZ`3om^h0?EV[0080?EV[403om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP0303eI
Z`3om^h0ooK^00H0ooK^0P0mFJ/80?ofkP0303eIZ`3om^h0ooK^03X0ooK^0P00000G0?ofkP40oooo
000Z0?ofkP030000003om^h0ooK^01P0ooK^00<000000?ofkP3om^h0<@3om^h20=@m6@D0ooK^00<0
e3dI0?ofkP3om^h00P3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00H0ooK^1P0mFJ/0103om^h0?EV[
03eIZ`0mFJ/30?ofkPH0?EV[0`2C:Q<00`000000ZC4F0:Ta5P020:Ta5P030000002Y<AH0ZC4F00H0
ZC4F0`0mFJ/20;`g600303eIZ`2l=aP0_3LH00800000202l=aP00`000000cS`J0<hl6P040<hl6P80
0000103>?1X00`0mFJ/000000<hl6P0303eIZ`030=e170000000gD4L00<0gD4L00<000000=e1703M
@A`00P3M@A`010000000gD4L0=e1700000020=e170040000003/AAh0k4DN03eIZ`80k4DN00L00000
0>a57P000000C73J0000001<L=X000000080C73J0P3D?AT01P1<L=X0000004a`fP1<L=X000000=@m
6@@000000P1<KmP01@000000C6oH04a_f01<KmP0000000<0C6oH00<0000004a_f01<KmP00P1<KmP0
0`3D?AT0000004a_f00304a_f08000001@1<KmP20000000304a_f03D?AT0000000<000001P1;K]@3
00000080?EV[00<0000003eIZ`0000001@3om^h00`0mFJ/0ooK^0?ofkP090?ofkPD0?EV[4`3om^h0
0`0mFJ/0ooK^0?ofkP030?ofkP80?EV[3P3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0303eIZ`3om^h0
ooK^00T0ooK^0`0mFJ/40?ofkP0303eIZ`3om^h0ooK^03X0ooK^00<000000?ofkP3om^h05`3om^h1
0?ooo`00:P3om^h00`000000ooK^0?ofkP0G0?ofkP030000003om^h0ooK^0380ooK^0P3D?AT50?of
kP050=@m6@3om^h0ooK^0?ofkP3D?AT0103om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@0mFJ/0
?EV[00@0?EV[1P3om^h503eIZ`030000002Y<AH0ZC4F00@0ZC4F0P0000070:Ta5P030000002l=aP0
?EV[0080?EV[102l=aP2000000D0_3LH00@000000<hl6P00000000001P3>?1X2000000080<hl6P0m
FJ/0cS`J0<hl6P000000cS`J0000003M@A`403eIZ`<0gD4L00<000000=e1703M@A`00P3M@A`00`00
0000gD4L0=e170020000000=0>a57P000000?EV[0>a57P000000k4DN0000003/AAh0000004a`fP00
0000C73J0000000204a`fP070000001<L=X0e3dI0=@m6@1<L=X000000=@m6@0204a`fP030000001<
L=X0C73J00<000000P1<KmP01@000000C6oH04a_f01<KmP0000000<0C6oH0P3D?AT504a_f0030000
001<KmP0C6oH00<0C6oH0P00000204a_f0030=@m6@000000000000<0C6oH0P00000204]^e0@00000
00<0oe0Q0000000000000`0mFJ/50?ofkP0303eIZ`3om^h0ooK^00`0ooK^0P0mFJ/C0?ofkP0303eI
Z`3om^h0ooK^00D0ooK^0`0mFJ/:0?ofkP0303eIZ`3om^h0ooK^0140ooK^00<0?EV[0?ofkP3om^h0
303om^h303eIZ`030?ofkP0mFJ/0ooK^03T0ooK^0P00000J0?ofkP40oooo000Y0?ofkP030000003o
m^h0ooK^01L0ooK^00<000000?ofkP3om^h0<P3om^h20=@m6@H0ooK^00@0e3dI0?ofkP3om^h0e3dI
1@3om^h00`3D?AT0ooK^0?ofkP060?ofkP050=@m6@3om^h0ooK^0=@m6@3om^h01P0mFJ/60?ofkP<0
?EV[202Y<AH00`000000ZC4F0:Ta5P030:Ta5P040000002l=aP0?EV[03eIZ`80_3LH100mFJ/20;`g
60050000002l=aP0_3LH0;`g60000000103>?1X00`000000cS`J0<hl6P050<hl6P0303eIZ`3>?1X0
cS`J0080cS`J00<000000=e1703M@A`0103M@A`303eIZ`030=e170000000gD4L00<0gD4L0P000000
1`3/AAh000000>a57P0mFJ/000000>a57P0000000P3/AAh02@000000k4DN0000001<L=X0000004a`
fP000000C73J0000000204a`fP030000003D?AT0e3dI00<0C73J00@0000004a`fP1<L=X000000P1<
L=X300000080C6oH00H0000004a_f01<KmP0C6oH0=@m6@00000404a_f0800000101<KmP200000080
C6oH0P3D?AT00`000000C6oH04a_f00504a_f0@0000000H0oe0Q00000000000000000=@m6@0mFJ/2
0?ofkP<0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0?EV[0180ooK^00<0?EV[
0?ofkP3om^h02@3om^h303eIZ`L0ooK^00<0?EV[0?ofkP3om^h04@3om^h00`0mFJ/0ooK^0?ofkP0?
0?ofkP80?EV[>@3om^h00`000000ooK^0?ofkP0J0?ofkP40oooo000Y0?ofkP030000003om^h0ooK^
01L0ooK^00<000000?ofkP3om^h0<P3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0e3dI
00H0ooK^00<0e3dI0?ofkP3om^h01@3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00D0ooK^1@0mFJ/3
0?ofkP0303eIZ`3om^h0000000<0?EV[1P2Y<AH2000000050:Ta5P00000000000;`g600mFJ/00P2l
=aP2000000@0_3LH0`0mFJ/2000000030;`g60000000cS`J00@0cS`J0P0000040<hl6P0703eIZ`3>
?1X000000000003>?1X000000=e17002000000D0gD4L00<000000=e1700mFJ/00P0mFJ/01@000000
gD4L0=e1703M@A`000000080k4DN01D0000003eIZ`3/AAh000000>a57P000000k4DN0000003/AAh0
000004a`fP000000C73J0000001<L=X0000004a`fP000000e3dI04a`fP0000000`3D?AT204a`fP05
0000001<L=X0C73J04a`fP0000000P1<L=X300000080C6oH00<0e3dI0000001<KmP00P1<KmP20000
00@0C6oH0P00000304a_f0030=@m6@000000C6oH00D0C6oH1@0000000`3oD2400000000000020000
00030=@m6@000000?EV[00D0ooK^0`0mFJ/=0?ofkP0303eIZ`3om^h0?EV[0180ooK^00<0?EV[0?of
kP3om^h0303om^h203eIZ`D0ooK^00<0?EV[0?ofkP3om^h0403om^h00`0mFJ/0ooK^0?ofkP0A0?of
kP0303eIZ`3om^h0ooK^03D0ooK^0P00000M0?ofkP40oooo000Y0?ofkP030000003om^h0ooK^01H0
ooK^00<000000?ofkP3om^h0<`3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0e3dI00L0
ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00D0
ooK^1`0mFJ/20?ofkP8000000`0mFJ/50:Ta5P040000002l=aP0?EV[03eIZ`D0_3LH0P0000050;`g
60@0?EV[1`3>?1X200000080cS`J00D0?EV[0<hl6P3>?1X0cS`J000000040=e170800000103M@A`0
10000000gD4L0=e1703M@A`403eIZ`050>a57P000000k4DN03eIZ`0000000P3/AAh010000000k4DN
0000003/AAh20000000:04a`fP000000C73J0000001<L=X0000004a`fP3D?AT0C73J000000<0C73J
00@000000=@m6@3D?AT0e3dI0P1<L=X01@000000C73J04a`fP1<L=X000000080C73J00<000000=@m
6@0000000P1<KmP2000000@0C6oH0P00000304a_f0030000003D?AT0C6oH00@0C6oH1P0000000`3o
D24000000000000200000080e3dI00<0000003eIZ`3om^h01`3om^h503eIZ`P0ooK^00@0?EV[0?of
kP3om^h0?EV[4@3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP<0?EV[00<0ooK^03eIZ`3om^h04P3om^h0
0`0mFJ/0ooK^0?ofkP0@0?ofkP0303eIZ`3om^h0ooK^03D0ooK^00<000000?ofkP3om^h07@3om^h1
0?ooo`00:@3om^h00`000000ooK^0?ofkP0E0?ofkP030000003om^h0ooK^03@0ooK^00<0e3dI0?of
kP3om^h01@3om^h20=@m6@P0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP040?of
kP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI03eIZ`0mFJ/00`0mFJ/20?ofkP030000002Y<AH0ZC4F
00<0?EV[00D0ZC4F0000000mFJ/0?EV[000000080;`g60800000102l=aP00`000000cS`J0<hl6P03
03eIZ`H0cS`J00<0000003eIZ`3>?1X00P3>?1X010000000gD4L0000000000040=e1708000000`3M
@A`2000000<0gD4L00<000000>a57P0mFJ/00`0mFJ/02P3/AAh000000>a57P000000k4DN0000003/
AAh000000>a57P00000204a`fP070000001<L=X0000004a`fP3D?AT0C73J0000000204a`fP050000
001<L=X0C73J0000001<L=X00`3D?AT204a`fP050000001<L=X0C73J0000003D?AT00P1<L=X30000
00<0C6oH0P00000304a_f080000000<0e3dI04a_f01<KmP00P1<KmP2000000050?mB8P0000000000
0000003oD2401P0000000`3aBAd0000003eIZ`090?ofkP0303eIZ`3om^h0ooK^0080ooK^0`0mFJ/5
0?ofkP0303eIZ`3om^h0?EV[0180ooK^00<0?EV[0?ofkP3om^h04P3om^h303eIZa40ooK^00<0?EV[
0?ofkP3om^h04@3om^h00`0mFJ/0ooK^0?ofkP0d0?ofkP030000003om^h0ooK^01h0ooK^0@3oool0
02T0ooK^00<000000?ofkP3om^h0503om^h00`000000ooK^0?ofkP0e0?ofkP030=@m6@3om^h0ooK^
00D0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^
00D0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP020?ofkPD0?EV[0P0000020:Ta
5P@0?EV[0P2l=aP2000000P0_3LH0P0000000`2l=aP000000<hl6P040<hl6P030000000mFJ/0?EV[
0080?EV[0P3>?1X01@0mFJ/000000000003>?1X0000000@0gD4L0P0000040=e1708000000`3M@A`0
10000000gD4L0000003/AAh20000000303eIZ`3/AAh0000000<0?EV[00@0k4DN0000003/AAh00000
0P3/AAh02P000000C73J000000000000C73J0000003D?AT0000004a`fP00000204a`fP030000001<
L=X000000080C73J00<0000004a`fP1<L=X00`3D?AT00`1<L=X000000=@m6@0204a`fP8000000P1<
L=X3000000<0C6oH0P000000101<KmP0e3dI04a_f01<KmP6000000030?mB8P000000000000D00000
00@0lDTM000000000000ooK^0`0mFJ/60?ofkP0303eIZ`3om^h0ooK^00H0ooK^0`0mFJ/01@3om^h0
?EV[0?ofkP3om^h0?EV[0140ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP0303eI
Z`h0ooK^00<0?EV[0?ofkP3om^h04@3om^h00`0mFJ/0ooK^0?ofkP0b0?ofkP8000008@3om^h10?oo
o`00:03om^h00`000000ooK^0?ofkP0E0?ofkP030000003om^h0ooK^03D0ooK^00<0e3dI0?ofkP3o
m^h0103om^h20=@m6@T0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@080?ofkP030=@m6@3om^h0ooK^
00D0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP0503eIZ`040:Ta5P000000_3LH
0;`g60@0?EV[0P0000080;`g608000001`3>?1X3000000<0?EV[0P3>?1X2000000H0gD4L0P000004
0=e1708000000P3M@A`200000080k4DN00@0?EV[0000003/AAh0k4DN0P0000000`3/AAh0?EV[03eI
Z`02000000030>a57P000000000000<0000000X0C73J0=@m6@1<L=X0000004a`fP000000C73J0000
001<L=X000000P1<L=X00`000000C73J04a`fP020000000304a`fP000000e3dI00D0e3dI00<0C73J
0000000000000`1<L=X300000080C6oH00D0e3dI00000000000000000?mB8P0200000080oe8R1`00
00001P3aBAd00000000000000000ooK^03eIZ`<0ooK^0P0mFJ/40?ofkP0303eIZ`3om^h0ooK^00T0
ooK^0`0mFJ/00`3om^h0?EV[0?ofkP0@0?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3o
m^h00`3om^h303eIZ`/0ooK^00<0?EV[0?ofkP3om^h0403om^h00`0mFJ/0ooK^0?ofkP0b0?ofkP03
0000003om^h0ooK^0240ooK^0@3oool002P0ooK^00<000000?ofkP3om^h0503om^h00`000000ooK^
0?ofkP0f0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3D?AT02P3om^h00`3D?AT0ooK^
0=@m6@0:0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^
0?ofkP030?ofkP@0?EV[1P2l=aP303eIZ`030000002l=aP0_3LH00<0_3LH00<000000<hl6P3>?1X0
0P0000070<hl6P80?EV[00<000000<hl6P0mFJ/00P0mFJ/00`3M@A`00000000000060=e170800000
103M@A`200000080k4DN00D0000003eIZ`3/AAh0k4DN000000030>a57P030000003/AAh000000080
?EV[00<000000?U:7`0000002000000204a`fP050000000mFJ/0000004a`fP0000000P1<L=X02000
0000C73J000000000000C73J0=@m6@1<L=X000000P1<L=X00`000000e3dI0=@m6@030=@m6@040000
001<L=X0C73J04a`fP<000000P0mFJ/00`000000oe8R0?mB8P04000000030=@m6@3oD240000000D0
00000P3om^h00`0mFJ/0ooK^0?ofkP040?ofkP<0?EV[00<0ooK^03eIZ`3om^h02P3om^h00`0mFJ/0
ooK^0?ofkP0303eIZ`l0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP070?ofkP80
?EV[203om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP0303eIZ`3om^h0ooK^0300ooK^0P00000T0?ofkP40
oooo000X0?ofkP030000003om^h0ooK^01<0ooK^00<000000?ofkP3om^h0=`3om^h00`3D?AT0ooK^
0?ofkP030?ofkP040=@m6@3om^h0ooK^0=@m6@T0ooK^0P3D?AT;0?ofkP030=@m6@3om^h0ooK^00<0
ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP060?ofkP<0?EV[1P2l=aP403eIZ`03
0;`g60000000cS`J00@0cS`J0`0000030<hl6P0403eIZ`3>?1X0cS`J0<hl6P<0000000<0gD4L03eI
Z`0mFJ/00P0mFJ/2000000D0gD4L0P000000103M@A`000000>a57P3/AAh20000000503eIZ`3/AAh0
00000000003/AAh00P0000020>a57P040000003/AAh000000>a57P@0000000D0BfoK0000001;Km/0
000004]_f`040000000404a`fP000000C73J00000080C73J00<0000004a`fP0000000P1<L=X00`3D
?AT000000000000300000080C73J0`0000000`1<L=X0000000000003000000040?mB8P3D?AT00000
0?mB8P<0?EV[0`000000103oD24000000000003oD244000000<0ooK^00<0?EV[0?ofkP3om^h01`3o
m^h303eIZ`X0ooK^00H0?EV[0?ofkP3om^h0ooK^03eIZ`3om^h303eIZ``0ooK^00<0?EV[0?ofkP3o
m^h04`3om^h00`0mFJ/0ooK^0?ofkP090?ofkP<0?EV[1@3om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP03
03eIZ`3om^h0ooK^02l0ooK^00<000000?ofkP3om^h0903om^h10?ooo`00:03om^h00`000000ooK^
0?ofkP0C0?ofkP030000003om^h0ooK^03L0ooK^00<0e3dI0?ofkP3om^h00P3om^h01@3D?AT0ooK^
0?ofkP3om^h0e3dI00T0ooK^00<0e3dI0?ofkP3om^h02`3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI
00X0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0?EV[03eIZ`0203eIZ`D0_3LH00@0000003eI
Z`0mFJ/0?EV[1`3>?1X00`000000?EV[03eIZ`040<hl6P030000003M@A`0gD4L00<000000P3M@A`3
03eIZ`800000103M@A`300000080k4DN00<0?EV[0000000000000P3/AAh2000000080>a57P000000
k4DN0>a57P000000k4DN0000003iBQl70000000504]_f`00000000000000001;Km/00`00000204a`
fP<000000P1<L=X0103D?AT0000000000000000304a`fP80000000@0C73J00000000000000000P3o
D28300000080oe8R1@00000303eIZ`030000003oD240000000@000000`3om^h00`0mFJ/0ooK^0?of
kP090?ofkP0303eIZ`3om^h0?EV[0080?EV[1P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3o
m^h0ooK^0080ooK^0`0mFJ/80?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h03@3o
m^h303eIZ`030?ofkP0mFJ/0ooK^0180ooK^00<0?EV[0?ofkP3om^h0;P3om^h2000002L0ooK^0@3o
ool002P0ooK^00<000000?ofkP3om^h04P3om^h00`000000ooK^0?ofkP0h0?ofkP050=@m6@3om^h0
ooK^0?ofkP3D?AT0103om^h00`3D?AT0ooK^0?ofkP060?ofkP80e3dI3@3om^h0103D?AT0ooK^0?of
kP3D?AT<0?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h00`00000303eIZ`80_3LH
00@000000<hl6P3>?1X00000100mFJ/20<hl6P80?EV[0P3>?1X200000080cS`J00<000000=e1703M
@A`00`3M@A`4000000050=e1700mFJ/0?EV[03eIZ`0000000P3M@A`01P000000k4DN0>a57P000000
?EV[00000080k4DN0`0000000`3/AAh0000000000002000000050>a57P000000nDXO0000003iBQl0
200000001P1;Km/000000000001;Km/0000004]_f`<000000`1<L=X00`3D?AT000000000000204a`
fPH0000000<0oe0R0000000000000`0000020?mB8P@000000P3oDR84000000@0?EV[0P000000100m
FJ/0ooK^0?ofkP0mFJ/<0?ofkP0303eIZ`3om^h0ooK^0080ooK^0`0mFJ/30?ofkP0503eIZ`3om^h0
ooK^0?ofkP0mFJ/0203om^h303eIZ`D0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?of
kP0@0?ofkP<0?EV[4P3om^h00`0mFJ/0ooK^0?ofkP0]0?ofkP030000003om^h0ooK^02L0ooK^0@3o
ool002L0ooK^00<000000?ofkP3om^h04P3om^h00`000000ooK^0?ofkP0i0?ofkP040=@m6@3om^h0
ooK^0=@m6@D0ooK^00<0e3dI0?ofkP3om^h01@3om^h0103D?AT0ooK^0?ofkP3D?AT=0?ofkP80e3dI
3@3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00@0ooK^0P0000000`2l=aP0?EV[
03eIZ`0203eIZ`@0cS`J00<0000003eIZ`0mFJ/00P0mFJ/50<hl6P@00000203M@A`3000000030=e1
700mFJ/0?EV[0080?EV[00<000000>a57P0mFJ/00P3/AAh300000080k4DN0P0000001@3/AAh00000
000000000000nDXO00<0000000<0nDXO0000000000001`0000000`1;Km/0000004]_f`0300000005
04]_f`00000000000=@m6@0000000P1<L=X9000000030?m@8P0mFJ/0000000@00000103oDR850000
00050?m@8@00000000000?597@0000000`0mFJ/20?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[
0?ofkP3om^h01@3om^h303eIZ`@0ooK^00<0?EV[0?ofkP3om^h02@3om^h303eIZ`030?ofkP0mFJ/0
ooK^01@0ooK^00<0?EV[0?ofkP3om^h04@3om^h00`0mFJ/0ooK^0?ofkP0303eIZ`l0ooK^00<0?EV[
0?ofkP3om^h0:`3om^h2000002X0ooK^0@3oool002L0ooK^00<000000?ofkP3om^h04@3om^h00`00
0000ooK^0?ofkP0j0?ofkP030=@m6@3om^h0e3dI00L0ooK^00<0e3dI0?ofkP3om^h00`3om^h01@3D
?AT0ooK^0?ofkP3om^h0e3dI00d0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP02
0?ofkP030=@m6@3om^h0ooK^00L0ooK^1000000603eIZ`<0cS`J00<0000003eIZ`0mFJ/00P0mFJ/2
000000<0gD4L100000070=e170@0000000@0k4DN03eIZ`0mFJ/0?EV[0P0000030>a57P<0000000D0
k4DN00000000000000000?U:7`02000000030?U:7`000000000000P0000000<0BfoK000000000000
0P000000101;Km/0000000000000000204]_f`P0000000D0oe0R000000000000000003eIZ`030000
00<0oe8R1`000000103oD24000000000003aBAd300000080ooK^100mFJ/<0?ofkP0303eIZ`3om^h0
ooK^00H0ooK^00<0?EV[0?ofkP0mFJ/00P0mFJ/00`3om^h0?EV[0?ofkP0=0?ofkP<0?EV[4`3om^h0
0`0mFJ/0ooK^0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^00<0ooK^0`0mFJ/;0?ofkP0303eIZ`3om^h0
ooK^02/0ooK^00<000000?ofkP3om^h0:P3om^h10?ooo`009`3om^h00`000000ooK^0?ofkP0A0?of
kP030000003om^h0ooK^03X0ooK^00<0e3dI0?ofkP3D?AT01`3om^h00`3D?AT0ooK^0?ofkP020?of
kP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0=@m6@0?0?of
kP040=@m6@3om^h0ooK^0=@m6@d0ooK^0P000000103D?AT0000003eIZ`0mFJ/70<hl6P8000000`0m
FJ/60=e170D000000P3M@A`01P000000k4DN0>a57P3/AAh0000003eIZ`8000000P0mFJ/400000080
k4DN600000000`1;Km/000000000000>0000000303eIZ`000000oe8R00@0000000@0oe8R00000000
000000000P3oD244000000030=@m6@000000000000<0ooK^0P0mFJ/20?ofkP<0?EV[2@3om^h00`0m
FJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^0080ooK^0P0mFJ/>0?ofkP0303eIZ`3om^h0ooK^
00<0?EV[403om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP0303eIZ`3om^h0ooK^00L0ooK^0`0mFJ/80?of
kP0303eIZ`3om^h0ooK^02T0ooK^0P00000]0?ofkP40oooo000W0?ofkP030000003om^h0ooK^0100
ooK^00<000000?ofkP3om^h0>`3om^h20=@m6@P0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0
ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00P0ooK^00@0e3dI0?ofkP3om^h0e3dI3`3om^h00`3D
?AT0ooK^0=@m6@0A0?ofkP030=@m6@00000000000080?EV[0P0000030<hl6P050000003M@A`0gD4L
0=e170000000100mFJ/70=e170D000000P0mFJ/30>a57P8000000`0mFJ/00`3/AAh000000000000P
000000030?m@8P00000000000080000000@0oe0R000000000000?EV[0`0000000`3oDR8000000000
000300000080oe0Q0P0000001@3oD24000000000003aBAd0000000@0?EV[00<0ooK^03eIZ`3om^h0
1@3om^h203eIZ`L0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eI
Z`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h00`3om^h303eIZ``0ooK^00<0?EV[0?ofkP3om^h0
4P3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP<0?EV[1@3om^h00`0mFJ/0ooK^0?ofkP0X0?ofkP030000
003om^h0ooK^02d0ooK^0@3oool002L0ooK^00<000000?ofkP3om^h03`3om^h00`000000ooK^0?of
kP0l0?ofkP030=@m6@3om^h0ooK^00L0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@070?ofkP030=@m
6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m
6@3om^h0ooK^0140ooK^00<0e3dI0?ofkP3D?AT00P0000000`0V?h80000003eIZ`04000000H0gD4L
0`0mFJ/2000000<0gD4L00D000000>a57P0mFJ/0?EV[0>a57P08000000030>a57P0mFJ/0?EV[0200
00000`0mFJ/4000000040?m@8P0mFJ/000000?mB8P<00000103oDR83000000040?m@8@0000000000
0?597@8000000P3om^h00`000000ooK^0?ofkP0303eIZ`L0ooK^0`0mFJ/40?ofkP0303eIZ`3om^h0
ooK^00@0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0
ooK^00L0ooK^0`0mFJ/90?ofkP0303eIZ`3om^h0ooK^0140ooK^00<0?EV[0?ofkP3om^h03P3om^h3
03eIZ`030?ofkP0mFJ/0ooK^02P0ooK^0P00000`0?ofkP40oooo000W0?ofkP030000003om^h0ooK^
00l0ooK^00<000000?ofkP3om^h0?03om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0e3dI
00P0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^
00/0ooK^00<0e3dI0?ofkP3D?AT04`3om^h0103D?AT0ooK^0?ofkP3om^h60000000303IG[`000000
000000H0000000<0gD4L03eIZ`0mFJ/02P0000060>a57R@000000P3oD28303eIZ`80000000@0?EV[
0000003oDR80oe8R3P0000030?ofkP030000003om^h0ooK^0080?EV[00@0ooK^03eIZ`0mFJ/0?EV[
1`3om^h303eIZ`030?ofkP0mFJ/0ooK^00D0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^
0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00/0ooK^0`0mFJ/50?ofkP0303eIZ`3om^h0ooK^0180ooK^
00<0?EV[0?ofkP3om^h04@3om^h203eIZbP0ooK^00<000000?ofkP3om^h0<03om^h10?ooo`009P3o
m^h00`000000ooK^0?ofkP0?0?ofkP030000003om^h0ooK^03d0ooK^00<0e3dI0?ofkP3om^h0203o
m^h20=@m6@X0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3o
m^h0ooK^00X0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0A0?ofkP030=@m6@3om^h0e3dI00H0ooK^
2P0000000`0fEjl000000000000j000000<0?EV[0`0000030?mB8P@0000000<0oe0Q000000000000
0`0000040?ofkP050000003om^h0?EV[0?ofkP0mFJ/0103om^h303eIZ`L0ooK^0P0mFJ/50?ofkP03
03eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP<0
?EV[0P3om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP0303eIZ`3om^h0ooK^0180ooK^00<0?EV[0?ofkP3o
m^h09P3om^h00`000000ooK^0?ofkP0a0?ofkP40oooo000V0?ofkP030000003om^h0ooK^00h0ooK^
00<000000?ofkP3om^h0?`3om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00T0ooK^
00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00P0ooK^
00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP040=@m6@3om^h0ooK^0?ofkP80
e3dI203om^h00`0000009Sn200000006000000030=@m6@000000000001H0000000<0B6gG00000000
00005`0000060?m@8P040000000mFJ/0oe8R0?mB8P<0?EV[100000020?m@8@<0000000<0lDTM0000
003om^h01@3om^h01@000000?EV[0?ofkP3om^h0?EV[00L0ooK^100mFJ/40?ofkP@0?EV[0P3om^h0
0`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h04P3om^h3
03eIZa<0ooK^00<0?EV[0?ofkP3om^h04P3om^h00`0mFJ/0ooK^0?ofkP0T0?ofkP800000=03om^h1
0?ooo`009P3om^h00`000000ooK^0?ofkP0=0?ofkP030000003om^h0ooK^0400ooK^00<0e3dI0?of
kP3om^h01P3om^h20=@m6@`0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0:0?ofkP030=@m6@3om^h0
ooK^00H0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0
ooK^00@0ooK^00<0e3dI0?ofkP3om^h0203om^h40000000303IG[`3D?AT0=UN_00P0000000<0e3dI
0000000000000`000006049Vb`030=@m6@0000000000008000000P18KML?000000030?m=8@000000
000000D0oe0R1@00000203eIZ`@000000P3oDR8303eIZ`@0000000<0lDTM0000000000001`3om^h0
1@0mFJ/0ooK^0?ofkP3om^h0?EV[00/0ooK^0`0mFJ/00`3om^h0?EV[0?ofkP020?ofkP<0?EV[203o
m^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h00`0m
FJ/?0?ofkP0303eIZ`3om^h0ooK^0180ooK^00<0?EV[0?ofkP3om^h0903om^h00`000000ooK^0?of
kP0d0?ofkP40oooo000V0?ofkP030000003om^h0ooK^00d0ooK^00<000000?ofkP3om^h0@03om^h0
0`3D?AT0ooK^0?ofkP050?ofkP040=@m6@3om^h0ooK^0=@m6@/0ooK^00@0e3dI0?ofkP3om^h0e3dI
303om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h0
2@3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00X0ooK^00<000000=@m6@000000
2P0000020=@m6@P0000000<0e3dI00000012I//00P12I//40000000404Q]e`000000000004Q]e``0
00000`3oD284000000<0oe0R00@0?EV[0?mB8P3oDR80oe8R1`0000000`3oD240?EV[03eIZ`0203eI
Z`8000001`3om^h00`0mFJ/000000?ofkP020?ofkP0303eIZ`3om^h0ooK^00`0ooK^0`0mFJ/20?of
kP0303eIZ`3om^h0ooK^00@0?EV[103om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^
01<0ooK^00<0?EV[0?ofkP3om^h00`3om^h303eIZ``0ooK^00<0?EV[0?ofkP3om^h04P3om^h00`0m
FJ/0ooK^0?ofkP0R0?ofkP800000=`3om^h10?ooo`009P3om^h00`000000ooK^0?ofkP0<0?ofkP03
0000003om^h0ooK^0440ooK^00<0e3dI0?ofkP3om^h01@3om^h0103D?AT0ooK^0?ofkP3D?AT<0?of
kP80e3dI3@3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?of
kP3om^h01`3om^h00`3D?AT0ooK^0?ofkP080?ofkP80e3dI2P3om^h00`3D?AT0ooK^0?ofkP0<0000
0080e3dI0`000002049Vb`030=@m6@000000000000@000000P12I//30000000404Q]e`0000000000
04Q]e`L0000000<0oddQ0000003oD2800P3oD284000000040?m@8P000000000003eIZ`@000000`3o
DR800`000000oe0Q0?m@8@020?m@8@<0000000@0lDTM03eIZ`0mFJ/0?EV[1P3om^h00`0mFJ/00000
0?ofkP030?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP0mFJ/00P0mFJ/60?ofkP<0?EV[
00<0ooK^03eIZ`3om^h0203om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^00L0ooK^
0`0mFJ/80?ofkP0303eIZ`3om^h0ooK^0180ooK^00<0?EV[0?ofkP3om^h08P3om^h00`000000ooK^
0?ofkP0g0?ofkP40oooo000U0?ofkP030000003om^h0ooK^00`0ooK^00<000000?ofkP3om^h0@`3o
m^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h02@3o
m^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h02P3o
m^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h01P3o
m^h00`3D?AT0ooK^0?ofkP050?ofkPX000000P3D?AT2000000040=@m6@000000@VK;049Vb`800000
0`12I//300000005049Vb`000000000000000018KML00P0000001018KML000000000003oCB420000
0080?EV[0P0000040?m@8P030000000mFJ/0?EV[00<000001@3oDR86000000030=@m6@0000000000
00H0?EV[0P3om^h00`0mFJ/0ooK^000000040?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?of
kP0mFJ/00P3om^h303eIZ`H0ooK^100mFJ/60?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?of
kP3om^h02`3om^h303eIZ`D0ooK^00<0?EV[0?ofkP3om^h04P3om^h00`0mFJ/0ooK^0?ofkP0P0?of
kP800000>P3om^h10?ooo`009@3om^h00`000000ooK^0?ofkP0;0?ofkP030000003om^h0ooK^04@0
ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00P0
ooK^00<0e3dI0?ofkP3D?AT03`3om^h0103D?AT0ooK^0?ofkP3D?AT>0?ofkP030=@m6@3om^h0ooK^
00<0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^
00/0ooK^00<09Sn2000000000000100fEjl30=@m6@<000000`12I//200000006049Vb`000000@VK;
049Vb`000000@VK;20000000103oD28000000?m@8P00000403eIZ`040000003oD280?EV[000000@0
oe8R1P0000020?m@8@D0000000<0?EV[0?ofkP3om^h00P3om^h503eIZ`030?ofkP000000ooK^00<0
ooK^00<0?EV[0?ofkP3om^h0303om^h203eIZ`H0ooK^0`0mFJ/40?ofkP0303eIZ`3om^h0ooK^00@0
?EV[0P3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^00h0ooK^0`0mFJ/00`3om^h0
?EV[0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^0200ooK^00<000000?ofkP3om^h0>P3om^h10?ooo`00
9@3om^h00`000000ooK^0?ofkP0;0?ofkP030000003om^h0ooK^04@0ooK^00D0e3dI0?ofkP3om^h0
ooK^0=@m6@070?ofkP030=@m6@3om^h0ooK^00H0ooK^00@0e3dI0?ofkP3om^h0e3dI3`3om^h00`3D
?AT0ooK^0=@m6@0@0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT04@3om^h20=@m6@<0ooK^00<0e3dI
0?ofkP3om^h03P3om^h5000000030=@m6@0fEjl0=UN_00@0e3dI0P000002049Vb`0800000012I//0
@VK;00000012I//00000049Vb`3D?AT200000003049Vb`00000000000080000000@0oe0R0000003o
D280oe0R0P0000000`3oD280?EV[03eIZ`04000000@0oe8R0P0000001P3oD2400000000000000000
e3dI0?597@80000000<0ooK^03eIZ`3om^h01@3om^h603eIZ`<0ooK^00<0?EV[0?ofkP3om^h0303o
m^h00`0mFJ/0ooK^0?ofkP080?ofkP<0?EV[00<0ooK^03eIZ`3om^h01@3om^h303eIZa@0ooK^00<0
?EV[0?ofkP3om^h04P3om^h303eIZa<0ooK^00<0?EV[0?ofkP3om^h07P3om^h2000003d0ooK^0@3o
ool002D0ooK^00<000000?ofkP3om^h02P3om^h00`000000ooK^0?ofkP150?ofkP040=@m6@3om^h0
ooK^0=@m6@P0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3o
m^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h0403om^h00`3D?AT0ooK^0=@m6@0D0?ofkP030=@m6@3o
m^h0e3dI01@0ooK^00<000000=@m6@0000001000000203IG[`<0e3dI0P000002049Vb`0;00000012
I//000000=@m6@12I//00000049Vb`000000@VK;00000012I//00P0000000`3oD280000000000002
0?m@8P040000000mFJ/000000?mB8P<0?EV[1`0000020=@m6@030?597@000000000000<0ooK^00<0
?EV[0?ofkP3om^h00P3om^h203eIZ`@0ooK^1P0mFJ/>0?ofkP0303eIZ`3om^h0ooK^00/0ooK^0P0m
FJ/60?ofkP0303eIZ`3om^h0ooK^00<0?EV[403om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3o
m^h0ooK^00@0?EV[3P3om^h00`0mFJ/0ooK^0?ofkP0N0?ofkP030000003om^h0ooK^03d0ooK^0@3o
ool002D0ooK^00<000000?ofkP3om^h02@3om^h00`000000ooK^0?ofkP170?ofkP030=@m6@3om^h0
e3dI00T0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0
ooK^00/0ooK^00<0e3dI0?ofkP3D?AT04P3om^h00`3D?AT0ooK^0?ofkP0D0?ofkP030=@m6@3om^h0
ooK^01<0ooK^00<0e3dI0?ofkP3om^h0200000000`0fEjl0e3dI0=@m6@020=@m6@80000000`0e3dI
00000012I//00000049Vb`000000@VK;00000012I//000000?m@8P0000020?m@8P030000000mFJ/0
?EV[0080oe8R0`000000103oDR80?EV[03eIZ`0mFJ/40?m@8@@00000103om^h01@0mFJ/0ooK^0?of
kP3om^h0?EV[00H0ooK^00@000000?ofkP3om^h0ooK^1@0mFJ/:0?ofkP0303eIZ`3om^h0?EV[00d0
ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP040?ofkP<0?EV[3@3om^h00`0mFJ/0
ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^00@0ooK^0`0mFJ/;0?ofkP0303eIZ`3om^h0ooK^01`0
ooK^0P0000100?ofkP40oooo000T0?ofkP030000003om^h0ooK^00X0ooK^00<000000?ofkP3om^h0
A`3om^h20=@m6@X0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m
6@3om^h0ooK^00X0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0@0?ofkP030=@m6@3om^h0e3dI01@0
ooK^00@0e3dI0?ofkP3D?AT0e3dI4P3om^h00`3D?AT0ooK^0?ofkP040?ofkP80000000<09Sn20000
000000000P0fEjl20000000303IG[`3D?AT0e3dI00<0e3dI0P0000002012I//00000049Vb`000000
@VK;0000003oD28000000P0mFJ/00`000000oe8R0?mB8P040?mB8P80000000<0e3dI0000000mFJ/0
0`0mFJ/00`000000lDTM000000060?ofkP0303eIZ`3om^h0?EV[00L0ooK^00<000000?ofkP3om^h0
0P3om^h00`0mFJ/0ooK^03eIZ`0403eIZ`H0ooK^00@0?EV[0?ofkP3om^h0?EV[3@3om^h00`0mFJ/0
ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00P0ooK^0`0mFJ/90?ofkP0303eIZ`3om^h0ooK^01<0
ooK^00<0?EV[0?ofkP3om^h0203om^h403eIZ`H0ooK^00<0?EV[0?ofkP3om^h0703om^h00`000000
ooK^0?ofkP100?ofkP40oooo000T0?ofkP030000003om^h0ooK^00T0ooK^00<000000?ofkP3om^h0
B03om^h00`3D?AT0ooK^0?ofkP0:0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT0203om^h00`3D?AT0
ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h0303om^h0103D?AT0
ooK^0?ofkP3om^h20=@m6A40ooK^00<0e3dI0?ofkP3om^h00P3om^h20=@m6@l0ooK^00<0e3dI0?of
kP3om^h0203om^h500000080=UN_00<0e3dI0000000fEjl00P0fEjl60=@m6@80@VK;00D000000?m@
8P00000000000?mB8P02000000@0oe8R00<000000?m@8@3oD2400`3oD2400`000000lDTM03eIZ`02
03eIZ`H0ooK^0P0mFJ/80?ofkP030000003om^h0ooK^00<0ooK^00@0?EV[0?ofkP3om^h0ooK^1@0m
FJ/20?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/03P3om^h0100mFJ/0ooK^0?ofkP0mFJ/>0?ofkP<0
?EV[1@3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^00d0ooK^100mFJ/20?ofkP03
03eIZ`3om^h0ooK^01X0ooK^0P0000130?ofkP40oooo000T0?ofkP030000003om^h0ooK^00P0ooK^
00<000000?ofkP3om^h0B@3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP040=@m6@3om^h0ooK^0=@m6@X0
ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00X0
ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00D0
ooK^0P3D?AT;0?ofkP80e3dI3@3om^h01@3D?AT0ooK^000000000000e3dI00<000000P0fEjl01@00
0000=UN_03IG[`000000=UN_00@000000P3oD28010000000oe8R0?mB8P3oDR8200000080oe8R00<0
00000?m@8@3oD2400P3oD24010000000lDTM0000000000020?ofkP<0?EV[0P3om^h203eIZ`T0ooK^
00<000000?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP040?ofkPD0?EV[0`3om^h00`0mFJ/0ooK^
0?ofkP0<0?ofkP0303eIZ`3om^h0?EV[0180ooK^0`0mFJ/20?ofkP0303eIZ`3om^h0ooK^01<0ooK^
00<0?EV[0?ofkP3om^h04@3om^h203eIZa`0ooK^00<000000?ofkP3om^h0@`3om^h10?ooo`00903o
m^h00`000000ooK^0?ofkP070?ofkP030000003om^h0ooK^04/0ooK^00<0e3dI0?ofkP3om^h02P3o
m^h20=@m6@`0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3o
m^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3o
m^h0ooK^00P0ooK^0P3D?AT80?ofkP030=@m6@3om^h0ooK^00d0ooK^00@0e3dI0?ofkP3om^h0e3dI
0P3om^h50000000703eIZ`0fEjl0=UN_0000000fEjl0000003IG[`030000000303eIZ`000000oe8R
00<0oe8R2P0000060?ofkP<0?EV[00<0ooK^03eIZ`3om^h01`3om^h00`000000ooK^0?ofkP030?of
kP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP0mFJ/0100mFJ/>0?ofkP0303eIZ`3om^h0?EV[
01D0ooK^0`0mFJ/D0?ofkP0303eIZ`3om^h0ooK^0180ooK^00<0?EV[0?ofkP3om^h06@3om^h20000
04H0ooK^0@3oool002@0ooK^00<000000?ofkP3om^h01`3om^h00`000000ooK^0?ofkP1;0?ofkP03
0=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP040?ofkP03
0=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP080?ofkP80
e3dI2P3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP80e3dI1@3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP03
0=@m6@3om^h0e3dI00D0ooK^00@0e3dI0000000000009Sn20`00000203IG[`050=@m6@0fEjl0=UN_
0000003oDR80100mFJ/2000000@0oe0Q00@000000?597@00000000001P3om^h203eIZ`80ooK^0`0m
FJ/70?ofkP030000003om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h0103om^h203eIZ`D0ooK^1@0m
FJ/;0?ofkP80?EV[5P3om^h00`0mFJ/0ooK^0?ofkP0303eIZa00ooK^00<0?EV[0?ofkP3om^h04P3o
m^h00`0mFJ/0ooK^0?ofkP0I0?ofkP030000003om^h0ooK^04H0ooK^0@3oool002<0ooK^00<00000
0?ofkP3om^h01`3om^h00`000000ooK^0?ofkP1=0?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI
0?ofkP3D?AT03@3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI
0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI
0?ofkP3om^h03P3om^h20=@m6@80ooK^00<0e3dI0?ofkP3om^h0403om^h00`3D?AT0ooK^0?ofkP03
0?ofkP050=@m6@3om^h0ooK^0=@m6@3om^h0100000000`3D?AT0000003IG[`0203IG[`050000003o
DR80oe8R0?mB8P000000100mFJ/40000000303eIZ`3om^h0ooK^00<0ooK^0P0mFJ/60?ofkPD0?EV[
0`3om^h00`000000ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h0
1P3om^h00`0mFJ/0ooK^03eIZ`0503eIZ`L0ooK^00<0?EV[0?ofkP3om^h0503om^h00`0mFJ/0ooK^
0?ofkP040?ofkP<0?EV[3@3om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^01P0ooK^
00<000000?ofkP3om^h0A`3om^h10?ooo`008`3om^h00`000000ooK^0?ofkP060?ofkP030000003o
m^h0ooK^04h0ooK^00<0e3dI0?ofkP3om^h01`3om^h0103D?AT0ooK^0?ofkP3D?AT>0?ofkP040=@m
6@3om^h0ooK^0=@m6@h0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP03
0=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h04@3om^h30=@m6A00ooK^0`3D?AT40?ofkP05
0=@m6@3om^h0ooK^0?ofkP3D?AT00`3om^h00`000000e3dI02HoPP040000000403IG[`000000oe8R
00000080oe0Q0`00000603eIZ`80ooK^0P0mFJ/80?ofkP0403eIZ`3om^h0ooK^0?ofkP@0?EV[00<0
00000?ofkP3om^h0103om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00X0ooK^00@0?EV[0?ofkP3om^h0
ooK^1`0mFJ/20?ofkP80?EV[5@3om^h00`0mFJ/0ooK^0?ofkP080?ofkP<0?EV[2@3om^h00`0mFJ/0
ooK^0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^01L0ooK^0P00001:0?ofkP40oooo000S0?ofkP030000
003om^h0ooK^00H0ooK^00<000000?ofkP3om^h0C`3om^h00`3D?AT0ooK^0?ofkP060?ofkP050=@m
6@3om^h0ooK^0?ofkP3D?AT03@3om^h00`3D?AT0ooK^0=@m6@0@0?ofkP050=@m6@3om^h0ooK^0?of
kP3D?AT0403om^h20=@m6@<0ooK^00<0e3dI0?ofkP3om^h04P3om^h00`3D?AT0ooK^0?ofkP040=@m
6@/0ooK^00@0e3dI0?ofkP3om^h0e3dI0`3om^h00`3D?AT0ooK^0?ofkP020?ofkP050=@m6@3om^h0
ooK^0?ofkP3D?AT00P3om^h00`3D?AT00000000000020000000303eIZ`000000?EV[0080?EV[00<0
oe0Q0000003aBAd00P0000000`3om^h0?EV[03eIZ`0403eIZ`X0ooK^00<0?EV[0?ofkP3om^h0103o
m^h303eIZ`@0ooK^00@0?EV[0?ofkP0mFJ/0?EV[2`3om^h00`0mFJ/0ooK^0?ofkP040?ofkPL0?EV[
00<0ooK^03eIZ`3om^h04P3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP<0?EV[1@3om^h00`0mFJ/0ooK^
0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^01L0ooK^00<000000?ofkP3om^h0BP3om^h10?ooo`008`3o
m^h00`000000ooK^0?ofkP050?ofkP030000003om^h0ooK^0500ooK^00<0e3dI0?ofkP3om^h01@3o
m^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h0403o
m^h00`3D?AT0ooK^0=@m6@0C0?ofkP030=@m6@3om^h0e3dI01@0ooK^00<0e3dI0?ofkP3om^h01@3o
m^h30=@m6@L0ooK^00H0e3dI0?ofkP3om^h0ooK^0=@m6@3om^h20=@m6@D0ooK^00@0e3dI0?ofkP3D
?AT0e3dI0P3om^h00`3D?AT0ooK^0=@m6@030?ofkP<0e3dI00<0000003eIZ`0mFJ/01@0mFJ/30?of
kP0303eIZ`3om^h0?EV[00<0?EV[1`3om^h00`0mFJ/0ooK^0?ofkP040?ofkP030000003om^h0ooK^
00@0?EV[00<0ooK^03eIZ`3om^h0303om^h00`0mFJ/0ooK^0?ofkP080?ofkPH0?EV[4@3om^h00`0m
FJ/0ooK^0?ofkP0@0?ofkP<0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP0303eIZ`3om^h0ooK^
01H0ooK^0P00001=0?ofkP40oooo000S0?ofkP030000003om^h0ooK^00@0ooK^00<000000?ofkP3o
m^h0DP3om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3o
m^h02P3om^h00`3D?AT0ooK^0=@m6@0B0?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3o
m^h04P3om^h00`3D?AT0ooK^0?ofkP090?ofkP@0e3dI0P3om^h00`3D?AT0ooK^0?ofkP020?ofkP80
e3dI1`3om^h20=@m6@<0ooK^00<0e3dI0?ofkP3om^h01`3D?AT2000000030=@m6@3om^h0ooK^00@0
?EV[0`3om^h0100mFJ/0ooK^0?ofkP3om^h403eIZ`D0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`00
0000ooK^0?ofkP030?ofkP@0?EV[303om^h00`0mFJ/0ooK^0?ofkP070?ofkP0403eIZ`3om^h0ooK^
0?ofkP80?EV[00@0ooK^03eIZ`0mFJ/0?EV[3P3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP<0?EV[4`3o
m^h00`0mFJ/0ooK^0?ofkP0E0?ofkP030000003om^h0ooK^04d0ooK^0@3oool00280ooK^00<00000
0?ofkP3om^h0103om^h00`000000ooK^0?ofkP1C0?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI
0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP080?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT0403o
m^h00`3D?AT0ooK^0=@m6@0C0?ofkP040=@m6@3om^h0e3dI0=@m6A40ooK^00<0e3dI0?ofkP3om^h0
3P3om^h80=@m6@P0ooK^00<0e3dI0?ofkP3om^h01P3D?AT00`3om^h0e3dI0?ofkP020=@m6@80ooK^
00<0e3dI0?ofkP3om^h0103om^h303eIZ`80ooK^00<0?EV[0?ofkP3om^h00`3om^h403eIZ`<0ooK^
00<0?EV[0?ofkP3om^h00`3om^h00`000000ooK^0?ofkP0203eIZ`80ooK^1@0mFJ/:0?ofkP0303eI
Z`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP020?ofkP<0?EV[
2P3om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP0303eIZ`3om^h0ooK^00@0?EV[3P3om^h00`0mFJ/0ooK^
0?ofkP0D0?ofkP800000D03om^h10?ooo`008P3om^h00`000000ooK^0?ofkP040?ofkP030000003o
m^h0ooK^05@0ooK^00@0e3dI0?ofkP3om^h0e3dI2@3om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m
6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h0303om^h0103D?AT0ooK^0?ofkP3om^h20=@m6A00
ooK^00<0e3dI0?ofkP3om^h00P3om^h20=@m6@h0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0
ooK^0?ofkP040?ofkP`0e3dI103om^h0103D?AT0ooK^0=@m6@3om^h20=@m6@030?ofkP3D?AT0e3dI
00X0ooK^100mFJ/70?ofkPD0?EV[1@3om^h00`000000?EV[03eIZ`050?ofkP0303eIZ`3om^h0ooK^
00@0?EV[1`3om^h00`0mFJ/0ooK^0?ofkP030?ofkP80?EV[1`3om^h00`0mFJ/0ooK^0?ofkP040?of
kP<0?EV[1P3om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP0303eIZ`3om^h0ooK^00D0ooK^0`0mFJ/:0?of
kP0303eIZ`3om^h0ooK^01@0ooK^00<000000?ofkP3om^h0D03om^h10?ooo`008P3om^h00`000000
ooK^0?ofkP030?ofkP030000003om^h0ooK^05D0ooK^00@0e3dI0?ofkP3om^h0e3dI2P3om^h00`3D
?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D
?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h01@3om^h20=@m
6@/0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^
00@0ooK^0P3D?AT00`3om^h0e3dI0?ofkP030?ofkP030=@m6@3om^h0e3dI0080e3dI00@0ooK^0=@m
6@3D?AT0e3dI3P3om^h403eIZ`L0ooK^100mFJ/20?ofkP80?EV[1`3om^h00`0mFJ/0ooK^0?ofkP03
0?ofkPD0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[
0?ofkP3om^h01`3om^h303eIZ`80ooK^00<0?EV[0?ofkP3om^h0503om^h00`0mFJ/0ooK^0?ofkP09
0?ofkP<0?EV[1P3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP800000D`3om^h10?ooo`008P3om^h00`00
0000ooK^0?ofkP020?ofkP030000003om^h0ooK^05L0ooK^0P3D?AT<0?ofkP030=@m6@3om^h0ooK^
00<0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^
00H0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP080?ofkP80e3dI203om^h00`3D
?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h00`3om^h0103D
?AT0ooK^0=@m6@3D?AT50?ofkP<0e3dI0P3om^h20=@m6A<0ooK^100mFJ/50?ofkPH0?EV[00<00000
0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP050?ofkPD0?EV[00D0ooK^03eIZ`3om^h0ooK^03eI
Z`0:0?ofkP0303eIZ`3om^h0ooK^00X0ooK^0`0mFJ/E0?ofkP0303eIZ`3om^h0ooK^00d0ooK^100m
FJ/20?ofkP0303eIZ`3om^h0ooK^0180ooK^00<000000?ofkP3om^h0D`3om^h10?ooo`008P3om^h0
1@000000ooK^0?ofkP3om^h0000005X0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?of
kP020?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?of
kP080?ofkP80e3dI203om^h20=@m6@d0ooK^0P3D?AT50?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0
e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP020?ofkP040=@m6@3om^h0ooK^0=@m6@D0ooK^
0`3D?AT20?ofkP80e3dI603om^h503eIZ`<0ooK^00<0?EV[0?ofkP0mFJ/00`0mFJ/60?ofkP0303eI
Z`3om^h0ooK^00P0ooK^1P0mFJ/;0?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h0
0`0mFJ/A0?ofkP0303eIZ`3om^h0ooK^0180ooK^0P0mFJ/C0?ofkP800000EP3om^h10?ooo`008P3o
m^h01@000000ooK^0?ofkP3om^h0000005/0ooK^00<0e3dI0?ofkP3om^h02`3om^h0103D?AT0ooK^
0?ofkP3D?AT=0?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0
ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00l0ooK^0P3D?AT20?ofkP030=@m6@3om^h0ooK^00l0
ooK^00<0e3dI0?ofkP3om^h0203om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI0080ooK^0P3D?AT40?of
kP<0e3dI00@0ooK^0=@m6@3D?AT0e3dI703om^h403eIZ`80ooK^00<0?EV[0?ofkP0000000P3om^h4
03eIZ`<0ooK^00<0?EV[0?ofkP3om^h02P3om^h503eIZ`X0ooK^00<0?EV[0?ofkP3om^h01`3om^h2
03eIZ`H0ooK^0`0mFJ/>0?ofkP0303eIZ`3om^h0ooK^0180ooK^00<0?EV[0?ofkP3om^h04@3om^h0
0`000000ooK^0?ofkP1F0?ofkP40oooo000Q0?ofkP050000003om^h0ooK^0?ofkP000000G03om^h0
0`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0e3dI00l0ooK^00<0e3dI0?ofkP3om^h00`3om^h0
0`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h04P3om^h3
0=@m6A00ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP020=@m6@80ooK^0P3D?AT4
0?ofkP030=@m6@3om^h0e3dI0080e3dI00<0ooK^0=@m6@3om^h07`3om^h503eIZ`030000003om^h0
ooK^00<0ooK^1@0mFJ/90?ofkP<0?EV[00<0ooK^03eIZ`3om^h01@0mFJ/70?ofkP0303eIZ`3om^h0
ooK^00H0ooK^00<0?EV[0?ofkP3om^h02@3om^h303eIZ`X0ooK^00<0?EV[0?ofkP3om^h04P3om^h0
0`0mFJ/0ooK^0?ofkP0@0?ofkP800000F@3om^h10?ooo`008@3om^h010000000ooK^0?ofkP00001N
0?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h03`3om^h01@3D?AT0ooK^0?ofkP3o
m^h0e3dI0100ooK^0P3D?AT00`3om^h0e3dI0?ofkP0D0?ofkP030=@m6@3om^h0ooK^00@0e3dI2`3o
m^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0e3dI00<0ooK^00<0e3dI0?ofkP3D?AT00`3o
m^h0103D?AT0ooK^0=@m6@3D?AT20?ofkP030=@m6@3om^h0ooK^02<0ooK^0`0mFJ/80?ofkP@0?EV[
0`3om^h303eIZ`D0ooK^00<0?EV[0?ofkP3om^h00P3om^h503eIZ`<0ooK^00<0?EV[0?ofkP3om^h0
1@3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP<0?EV[1P3om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP0303eI
Z`3om^h0ooK^0100ooK^00<000000?ofkP3om^h0F@3om^h10?ooo`008@3om^h010000000ooK^0?of
kP00001O0?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3D?AT04@3om^h00`3D?AT0ooK^
0=@m6@0C0?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h01@3om^h30=@m6@L0ooK^
00<0e3dI0?ofkP3om^h02P3om^h20=@m6@80ooK^0P3D?AT20?ofkP030=@m6@3om^h0ooK^00@0e3dI
0P3om^h00`3D?AT0ooK^0?ofkP0U0?ofkP030000003om^h0?EV[00<0?EV[1P3om^h503eIZ`P0ooK^
00<0?EV[0?ofkP3om^h01@3om^h503eIZ`030?ofkP0mFJ/0ooK^00<0ooK^0P0mFJ/C0?ofkP<0?EV[
0P3om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^0100ooK^00<000000?ofkP3om^h0
FP3om^h10?ooo`008@3om^h00`000000ooK^0000001P0?ofkP030=@m6@3om^h0ooK^00P0ooK^00D0
e3dI0?ofkP3om^h0ooK^0=@m6@0A0?ofkP030=@m6@3om^h0ooK^0140ooK^00@0e3dI0?ofkP3D?AT0
e3dI4P3om^h00`3D?AT0ooK^0?ofkP090?ofkP@0e3dI0P3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP04
0=@m6@3om^h0ooK^0=@m6@<0ooK^1`3D?AT00`3om^h0e3dI0=@m6@0X0?ofkP030000003om^h0ooK^
00<0ooK^1P0mFJ/00`3om^h0?EV[0?ofkP020?ofkP<0?EV[1P3om^h00`0mFJ/0ooK^0?ofkP080?of
kP@0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP0F0?ofkP<0?EV[4`3om^h00`0mFJ/0ooK^0?ofkP0?0?of
kP800000G@3om^h10?ooo`008@3om^h200000680ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0
ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3D?AT04@3om^h00`3D?AT0
ooK^0?ofkP020?ofkP80e3dI3`3om^h00`3D?AT0ooK^0?ofkP0>0?ofkPP0e3dI1`3om^h20=@m6@03
0?ofkP3D?AT0e3dI00@0e3dI00<0ooK^0=@m6@3D?AT00P3D?AT00`3om^h0e3dI0=@m6@0Y0?ofkP03
0000003om^h0ooK^00H0ooK^100mFJ/00`3om^h0?EV[03eIZ`040?ofkP<0?EV[103om^h00`0mFJ/0
ooK^0?ofkP0:0?ofkP@0?EV[5`3om^h203eIZ`80ooK^100mFJ/?0?ofkP0303eIZ`3om^h0ooK^00h0
ooK^00<000000?ofkP3om^h0G@3om^h10?ooo`00803om^h2000006@0ooK^00<0e3dI0?ofkP3om^h0
103om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00/0ooK^00@0e3dI0?ofkP3om^h0
ooK^0P3D?AT>0?ofkP030=@m6@3om^h0ooK^00D0ooK^0P3D?AT;0?ofkP80e3dI4@3om^h00`3D?AT0
ooK^0?ofkP050?ofkPX0e3dI1@3om^h30=@m6@80ooK^0`3D?ATZ0?ofkP030000003om^h0ooK^00T0
ooK^1@0mFJ/60?ofkPD0?EV[2`3om^h203eIZ`<0ooK^100mFJ/A0?ofkP80?EV[203om^h303eIZ`/0
ooK^00<0?EV[0?ofkP3om^h03@3om^h200000600ooK^0@3oool00200ooK^0P00001T0?ofkP030=@m
6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m
6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP080?ofkP80e3dI
203om^h00`3D?AT0ooK^0?ofkP0@0?ofkP030=@m6@3om^h0ooK^00/0ooK^00@0e3dI0?ofkP3om^h0
e3dI1P3om^h20=@m6@80ooK^0P3D?AT/0?ofkP030000003om^h0ooK^00d0ooK^100mFJ/60?ofkP@0
?EV[1`3om^h203eIZ`80ooK^00<0?EV[0?ofkP3om^h0103om^h303eIZ`d0ooK^00<0?EV[0?ofkP3o
m^h02`3om^h303eIZ`L0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`000000ooK^0?ofkP1P0?ofkP40
oooo000P0?ofkP800000I@3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00P0ooK^
00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00P0ooK^
00<0e3dI0?ofkP3om^h02`3om^h20=@m6@D0ooK^00<0e3dI0?ofkP3om^h0403om^h00`3D?AT0ooK^
0?ofkP0;0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT01@3om^h20=@m6@80ooK^0P3D?AT]0?ofkP03
0000003om^h0ooK^0100ooK^1@0mFJ/50?ofkP@0?EV[0P3om^h203eIZ`@0ooK^00<0?EV[0?ofkP3o
m^h01`3om^h303eIZ`P0ooK^0P0mFJ/A0?ofkP@0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP80
0000H`3om^h10?ooo`008P3om^h400000680ooK^00@0e3dI0?ofkP3om^h0e3dI303om^h00`3D?AT0
ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00P0ooK^0P3D?AT80?ofkP030=@m6@3om^h0ooK^00d0
ooK^0P3D?AT20?ofkP030=@m6@3om^h0ooK^0100ooK^00<0e3dI0?ofkP3om^h02`3om^h01@3D?AT0
ooK^0?ofkP3om^h0e3dI00@0ooK^0`3D?AT0103om^h0e3dI0=@m6@3D?AT^0?ofkP030000003om^h0
ooK^01@0ooK^3@0mFJ/60?ofkP0303eIZ`3om^h0ooK^00T0ooK^100mFJ/20?ofkP80?EV[5`3om^h2
03eIZ`h0ooK^00<000000?ofkP3om^h0H`3om^h10?ooo`009P3om^h4000005h0ooK^00<0e3dI0?of
kP3D?AT03P3om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?of
kP3om^h0103om^h00`3D?AT0ooK^0?ofkP0@0?ofkP<0e3dI403om^h20=@m6@d0ooK^00<0e3dI0?of
kP3om^h00P3om^h01P3D?AT0ooK^0?ofkP3om^h0e3dI0?ofkP<0e3dI00<0ooK^0=@m6@3om^h0;P3o
m^h00`000000ooK^0?ofkP0G0?ofkP@0?EV[00<0ooK^03eIZ`0mFJ/00P3om^h503eIZ`<0ooK^00<0
?EV[0?ofkP3om^h0303om^h303eIZaP0ooK^00<0?EV[0?ofkP3om^h02`3om^h2000006H0ooK^0@3o
ool002X0ooK^1000001K0?ofkP030=@m6@3om^h0ooK^00h0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m
6@0?0?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h04@3om^h00`3D?AT0ooK^0?of
kP040=@m6@/0ooK^00<0e3dI0?ofkP3om^h02`3om^h20=@m6@@0ooK^00@0e3dI0?ofkP3om^h0ooK^
103D?AT20?ofkP030=@m6@3om^h0ooK^02h0ooK^00<000000?ofkP3om^h06P3om^h503eIZ`D0ooK^
1@0mFJ/<0?ofkP80?EV[0`3om^h303eIZa<0ooK^0P0mFJ/=0?ofkP030000003om^h0ooK^06H0ooK^
0@3oool002h0ooK^1000001H0?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3D?AT04@3o
m^h20=@m6@030?ofkP3D?AT0ooK^0180ooK^00<0e3dI0?ofkP3om^h01@3om^h30=@m6@L0ooK^00<0
e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00@0e3dI00<0
ooK^0=@m6@3D?AT0<@3om^h00`000000ooK^0?ofkP0N0?ofkP<0?EV[1P3om^h303eIZ`T0ooK^0P0m
FJ/80?ofkP<0?EV[3`3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP800000J@3om^h10?ooo`00<P3om^h4
000005D0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0B0?ofkP80e3dI4P3om^h0
0`3D?AT0ooK^0?ofkP090?ofkP@0e3dI0P3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0
ooK^00D0ooK^103D?AT00`3om^h0e3dI0?ofkP020=@m6C80ooK^00<000000?ofkP3om^h0803om^h5
03eIZ`D0ooK^100mFJ/30?ofkP80?EV[3@3om^h303eIZ`/0ooK^00<0?EV[0?ofkP3om^h02`3om^h0
0`000000ooK^0?ofkP1Y0?ofkP40oooo000f0?ofkP@00000DP3om^h00`3D?AT0ooK^0?ofkP0<0?of
kP040=@m6@3om^h0e3dI0=@m6A40ooK^00<0e3dI0?ofkP3om^h00P3D?AT?0?ofkP030=@m6@3om^h0
ooK^00h0ooK^203D?AT70?ofkP030=@m6@3om^h0ooK^00H0e3dI00H0ooK^0=@m6@3D?AT0ooK^0=@m
6@3om^h20=@m6C<0ooK^00<000000?ofkP3om^h08`3om^h503eIZ`@0ooK^1@0mFJ/B0?ofkP<0?EV[
1P3om^h203eIZ``0ooK^0P00001/0?ofkP40oooo000j0?ofkP@00000C`3om^h00`3D?AT0ooK^0?of
kP0:0?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?of
kP030?ofkP80e3dI2`3om^h20=@m6A40ooK^00<0e3dI0?ofkP3om^h01@3om^h:0=@m6@D0ooK^0`3D
?AT0103om^h0e3dI0?ofkP3D?ATe0?ofkP030000003om^h0ooK^02H0ooK^1P0mFJ/00`3om^h0?EV[
0?ofkP020?ofkP@0?EV[4@3om^h303eIZ`80ooK^00<0?EV[0?ofkP3om^h02`3om^h00`000000ooK^
0?ofkP1/0?ofkP40oooo000n0?ofkP@00000C03om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3o
m^h0ooK^00@0ooK^0P3D?AT<0?ofkP030=@m6@3om^h0ooK^00H0ooK^0P3D?AT80?ofkP030=@m6@3o
m^h0ooK^0100ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP060?ofkP80e3dI0`3o
m^h20=@m6CH0ooK^00<000000?ofkP3om^h0:@3om^h703eIZ`D0ooK^0`0mFJ/A0?ofkP80?EV[3@3o
m^h00`000000ooK^0?ofkP1]0?ofkP40oooo00120?ofkP@00000B@3om^h00`3D?AT0ooK^0?ofkP05
0?ofkP80e3dI2@3om^h00`3D?AT0ooK^0?ofkP070?ofkP80e3dI2`3om^h20=@m6@D0ooK^00<0e3dI
0?ofkP3om^h0403om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00H0ooK^0P3D?AT3
0?ofkP80e3dI=`3om^h00`000000ooK^0?ofkP0]0?ofkPD0?EV[1P3om^h303eIZ`/0ooK^0`0mFJ/=
0?ofkP800000L03om^h10?ooo`00AP3om^h4000004H0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D
?AT0ooK^0?ofkP0:0?ofkP80e3dI1P3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP80e3dI0P3om^h00`3D
?AT0ooK^0?ofkP0@0?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h01P3om^h20=@m
6@030?ofkP3D?AT0e3dI0080e3dI>03om^h00`000000ooK^0?ofkP0`0?ofkP@0?EV[1`3om^h403eI
Z`<0ooK^100mFJ/?0?ofkP030000003om^h0ooK^0700ooK^0@3oool004X0ooK^100000130?ofkP05
0=@m6@3om^h0ooK^0?ofkP3D?AT03`3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^
0100ooK^0`3D?AT@0?ofkP80e3dI3@3om^h00`3D?AT0ooK^0?ofkP050?ofkP80e3dI00@0ooK^0=@m
6@3D?AT0ooK^0P3D?ATj0?ofkP030000003om^h0ooK^0380ooK^100mFJ/60?ofkPD0?EV[4@3om^h2
000007<0ooK^0@3oool004h0ooK^100000100?ofkP030=@m6@3om^h0e3dI0140ooK^0P3D?AT00`3o
m^h0e3dI0?ofkP0B0?ofkP030=@m6@3om^h0ooK^00@0e3dI2`3om^h00`3D?AT0ooK^0?ofkP0;0?of
kP80e3dI1`3om^h40=@m6@80ooK^00<0e3dI0?ofkP3om^h0>P3om^h00`000000ooK^0?ofkP0f0?of
kPH0?EV[5@3om^h00`000000ooK^0?ofkP1c0?ofkP40oooo001B0?ofkP@00000?@3om^h00`3D?AT0
ooK^0?ofkP0B0?ofkP030=@m6@3om^h0ooK^0140ooK^00<0e3dI0?ofkP3om^h01@3om^h30=@m6@L0
ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP050?ofkP<0e3dI00D0ooK^0=@m6@3o
m^h0ooK^0=@m6@0m0?ofkP030000003om^h0ooK^04l0ooK^0P00001f0?ofkP40oooo001F0?ofkP<0
0000>`3om^h00`3D?AT0ooK^0?ofkP0@0?ofkP040=@m6@3om^h0e3dI0=@m6A00ooK^00<0e3dI0?of
kP3om^h02@3om^h40=@m6@80ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP020?of
kPD0e3dI0`3om^h30=@m6Ch0ooK^00<000000?ofkP3om^h0CP3om^h00`000000ooK^0?ofkP1f0?of
kP40oooo001I0?ofkP@00000>03om^h20=@m6@l0ooK^00<0e3dI0?ofkP3om^h00P3om^h20=@m6@d0
ooK^00<0e3dI0?ofkP3om^h03P3om^h80=@m6@L0ooK^00<0e3dI0?ofkP3D?AT00`3D?AT30?ofkP04
0=@m6@3om^h0ooK^0?ofkP<0e3dI?`3om^h00`000000ooK^0?ofkP1<0?ofkP800000N@3om^h10?oo
o`00G@3om^h4000003H0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP050?ofkP80
e3dI2P3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00D0ooK^2@3D?AT60?ofkP04
0=@m6@3om^h0ooK^0?ofkP80e3dI@@3om^h00`000000ooK^0?ofkP1;0?ofkP030000003om^h0ooK^
07T0ooK^0@3oool00640ooK^1000000c0?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3o
m^h0203om^h20=@m6@L0ooK^00<0e3dI0?ofkP3om^h03P3om^h20=@m6@d0ooK^00<0e3dI0?ofkP3o
m^h01P3om^h0103D?AT0ooK^0?ofkP3om^h20=@m6D80ooK^00<000000?ofkP3om^h0B@3om^h20000
07`0ooK^0@3oool006D0ooK^1000000`0?ofkP80e3dI203om^h00`3D?AT0ooK^0?ofkP0;0?ofkP80
e3dI103om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00/0ooK^0P3D?AT70?ofkP80
e3dI0P3om^h30=@m6D<0ooK^00<000000?ofkP3om^h0B03om^h00`000000ooK^0?ofkP1l0?ofkP40
oooo001Y0?ofkP@00000;P3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00h0ooK^
0P3D?AT00`3om^h0e3dI0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h0
1P3om^h00`3D?AT0ooK^0?ofkP020=@m6@030?ofkP3D?AT0ooK^04<0ooK^00<000000?ofkP3om^h0
AP3om^h2000007l0ooK^0@3oool006d0ooK^1000000[0?ofkP030=@m6@3om^h0ooK^0080ooK^00<0
e3dI0?ofkP3om^h04@3om^h30=@m6@h0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?of
kP060?ofkP040=@m6@3om^h0e3dI0=@m6@80ooK^00<0e3dI0?ofkP3om^h0@`3om^h00`000000ooK^
0?ofkP150?ofkP030000003om^h0ooK^07l0ooK^0@3oool00740ooK^1000000X0?ofkP80e3dI00<0
ooK^0=@m6@3om^h04P3om^h0103D?AT0ooK^0?ofkP3om^h40=@m6@P0ooK^0P3D?AT=0?ofkP030=@m
6@3om^h0ooK^00H0ooK^0`3D?AT20?ofkP80e3dIAP3om^h00`000000ooK^0?ofkP140?ofkP030000
003om^h0ooK^0800ooK^0@3oool007D0ooK^1000000V0?ofkP80e3dI4P3om^h00`3D?AT0ooK^0?of
kP060?ofkP@0e3dI0`3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP80e3dI1P3om^h40=@m6@<0ooK^0P3D
?AU70?ofkP030000003om^h0ooK^0480ooK^0P0000230?ofkP40oooo001i0?ofkP@00000903om^h2
0=@m6@l0ooK^00<0e3dI0?ofkP3om^h02`3om^h90=@m6@L0ooK^00<0e3dI0?ofkP3om^h01P3D?AT0
0`3om^h0e3dI0?ofkP030?ofkP030=@m6@3om^h0ooK^04L0ooK^00<000000?ofkP3om^h0@@3om^h0
0`000000ooK^0?ofkP230?ofkP40oooo001m0?ofkP@000008P3om^h20=@m6@/0ooK^0P3D?AT?0?of
kP030=@m6@3om^h0ooK^00D0ooK^2P3D?AT60?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?of
kP3om^h0B03om^h00`000000ooK^0?ofkP0o0?ofkP800000QP3om^h10?ooo`00P@3om^h400000200
ooK^0P3D?AT80?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0
ooK^0?ofkP070?ofkP040=@m6@3om^h0ooK^0?ofkP80e3dIB`3om^h00`000000ooK^0?ofkP0n0?of
kP030000003om^h0ooK^08H0ooK^0@3oool008D0ooK^1000000N0?ofkP80e3dI1@3om^h00`3D?AT0
ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h01P3om^h20=@m6@80
ooK^0P3D?AU=0?ofkP030000003om^h0ooK^03`0ooK^0P0000290?ofkP40oooo00290?ofkP<00000
7@3om^h20=@m6@80ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m
6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h00P3D?AU?0?ofkP030000003om^h0ooK^03/0ooK^
00<000000?ofkP3om^h0R@3om^h10?ooo`00S03om^h4000001/0ooK^0`3D?AT?0?ofkP030=@m6@3o
m^h0ooK^00X0ooK^0P3D?AT80?ofkP040=@m6@3om^h0e3dI0=@m6E40ooK^00<000000?ofkP3om^h0
>@3om^h2000008`0ooK^0@3oool00900ooK^1000000J0?ofkP<0e3dI2`3om^h00`3D?AT0ooK^0?of
kP0:0?ofkP030=@m6@3om^h0ooK^00L0ooK^0`3D?AUC0?ofkP030000003om^h0ooK^03P0ooK^00<0
00000?ofkP3om^h0S03om^h10?ooo`00U03om^h4000001T0ooK^103D?AT60?ofkP030=@m6@3om^h0
ooK^00X0ooK^00<0e3dI0?ofkP3om^h01@3om^h40=@m6ED0ooK^00<000000?ofkP3om^h0=P3om^h2
000008l0ooK^0@3oool009P0ooK^1000000I0?ofkP<0e3dI0P3om^h00`3D?AT0ooK^0?ofkP0:0?of
kP030=@m6@3om^h0ooK^00H0e3dIF@3om^h00`000000ooK^0?ofkP0e0?ofkP030000003om^h0ooK^
08l0ooK^0@3oool009`0ooK^1000000H0?ofkQ80e3dIG`3om^h00`000000ooK^0?ofkP0c0?ofkP80
0000TP3om^h10?ooo`00X03om^h4000008D0ooK^00<000000?ofkP3om^h0<P3om^h00`000000ooK^
0?ofkP2B0?ofkP40oooo002T0?ofkP@00000PP3om^h00`000000ooK^0?ofkP0`0?ofkP030000003o
m^h0ooK^09<0ooK^0@3oool00:P0ooK^1000001n0?ofkP030000003om^h0ooK^02h0ooK^0P00002F
0?ofkP40oooo002/0?ofkP@00000NP3om^h00`000000ooK^0?ofkP0]0?ofkP030000003om^h0ooK^
09H0ooK^0@3oool00;00ooK^1000001f0?ofkP030000003om^h0ooK^02/0ooK^0P00002I0?ofkP40
oooo002d0?ofkP@00000LP3om^h00`000000ooK^0?ofkP0Z0?ofkP030000003om^h0ooK^09T0ooK^
0@3oool00;P0ooK^1000001^0?ofkP030000003om^h0ooK^02P0ooK^0P00002L0?ofkP40oooo002l
0?ofkP@00000JP3om^h00`000000ooK^0?ofkP0W0?ofkP030000003om^h0ooK^09`0ooK^0@3oool0
0<00ooK^0`00001W0?ofkP030000003om^h0ooK^02D0ooK^0P00002O0?ofkP40oooo00330?ofkP@0
0000H`3om^h00`000000ooK^0?ofkP0T0?ofkP030000003om^h0ooK^09l0ooK^0@3oool00<L0ooK^
1000001O0?ofkP030000003om^h0ooK^0280ooK^0P00002R0?ofkP40oooo003;0?ofkP@00000F`3o
m^h00`000000ooK^0?ofkP0Q0?ofkP030000003om^h0ooK^0:80ooK^0@3oool00<l0ooK^1000001G
0?ofkP030000003om^h0ooK^01l0ooK^0P00002U0?ofkP40oooo003C0?ofkP@00000D`3om^h00`00
0000ooK^0?ofkP0N0?ofkP030000003om^h0ooK^0:D0ooK^0@3oool00=L0ooK^1000001?0?ofkP03
0000003om^h0ooK^01`0ooK^0P00002X0?ofkP40oooo003K0?ofkP@00000B`3om^h00`000000ooK^
0?ofkP0K0?ofkP030000003om^h0ooK^0:P0ooK^0@3oool00=l0ooK^100000170?ofkP030000003o
m^h0ooK^01X0ooK^00<000000?ofkP3om^h0Z@3om^h10?ooo`00h`3om^h4000004<0ooK^00<00000
0?ofkP3om^h0603om^h200000:`0ooK^0@3oool00>L0ooK^1000000o0?ofkP030000003om^h0ooK^
01L0ooK^00<000000?ofkP3om^h0[03om^h10?ooo`00j`3om^h4000003/0ooK^00<000000?ofkP3o
m^h05@3om^h200000:l0ooK^0@3oool00>l0ooK^1000000g0?ofkP030000003om^h0ooK^01@0ooK^
00<000000?ofkP3om^h0[`3om^h10?ooo`00l`3om^h3000003@0ooK^00<000000?ofkP3om^h04P3o
m^h200000;80ooK^0@3oool00?H0ooK^1000000`0?ofkP030000003om^h0ooK^0140ooK^00<00000
0?ofkP3om^h0/P3om^h10?ooo`00nP3om^h4000002`0ooK^00<000000?ofkP3om^h03`3om^h20000
0;D0ooK^0@3oool00?h0ooK^1000000Y0?ofkP030000003om^h0ooK^00d0ooK^00<000000?ofkP3o
m^h0]@3om^h10?ooo`00o`3om^h30?ofkP@000009@3om^h00`000000ooK^0?ofkP0;0?ofkP800000
^03om^h10?ooo`00o`3om^h70?ofkP@000008@3om^h00`000000ooK^0?ofkP0:0?ofkP030000003o
m^h0ooK^0;P0ooK^0@3oool00?l0ooK^2`3om^h4000001d0ooK^00<000000?ofkP3om^h0203om^h2
00000;/0ooK^0@3oool00?l0ooK^3`3om^h4000001T0ooK^00<000000?ofkP3om^h01`3om^h00`00
0000ooK^0?ofkP2k0?ofkP40oooo003o0?ofkQ<0ooK^1000000E0?ofkP030000003om^h0ooK^00H0
ooK^00<000000?ofkP3om^h0_03om^h10?ooo`00o`3om^hG0?ofkP@000004@3om^h00`000000ooK^
0?ofkP040?ofkP800000_`3om^h10?ooo`00o`3om^hK0?ofkP@000003@3om^h00`000000ooK^0?of
kP030?ofkP030000003om^h0ooK^0;l0ooK^0@3oool00?l0ooK^7`3om^h4000000T0ooK^00@00000
0?ofkP3om^h0ooK^0P0000320?ofkP40oooo003o0?ofkR<0ooK^100000050?ofkP040000003om^h0
ooK^00000<@0ooK^0@3oool00?l0ooK^9`3om^h4000000040?ofkP000000000000000<D0ooK^0@3o
ool00?l0ooK^:`3om^h200000<L0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40
oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?of
k_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3o
ool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^
m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?oo
o`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd
0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo
003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0
ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool0
0?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03o
m^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00
o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?of
kP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o
0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^
0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0
ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h1
0?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3o
m^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40
oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?of
k_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3o
ool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^
m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?oo
o`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd
0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00\
\>"],
  ImageRangeCache->{{{0, 499}, {499, 0}} -> {-5.00005*^-06, -5.00005*^-06, \
0.00200403, 0.00200403}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
%%ImageSize: 500 500 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics3D
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Background color
1 .961 .933 r
MFill
% Scaling calculations
0 1 0 1 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 0 r
.25 Mabswid
[ ] 0 setdash
.5 .02321 m
.5 .30205 L
s
.5 .30205 m
.02189 .6366 L
s
.02189 .6366 m
.07653 .37901 L
s
.07653 .37901 m
.5 .02321 L
s
.92347 .37901 m
.5 .60969 L
s
.5 .60969 m
.5 .84126 L
s
.5 .84126 m
.97811 .6366 L
s
.97811 .6366 m
.92347 .37901 L
s
.5 .02321 m
.5 .30205 L
s
.5 .30205 m
.97811 .6366 L
s
.97811 .6366 m
.92347 .37901 L
s
.92347 .37901 m
.5 .02321 L
s
.07653 .37901 m
.5 .60969 L
s
.5 .60969 m
.5 .84126 L
s
.5 .84126 m
.02189 .6366 L
s
.02189 .6366 m
.07653 .37901 L
s
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
.83 .24 .1 r
.5 Mabswid
.38003 .56857 m
.39252 .59209 L
s
.40454 .55382 m
.38003 .56857 L
s
.36454 .54698 m
.38003 .56857 L
s
.24 .35 .67 r
.61997 .56857 m
.60748 .59209 L
s
.59546 .55382 m
.61997 .56857 L
s
.63546 .54698 m
.61997 .56857 L
s
.83 .24 .1 r
.39252 .59209 m
.40156 .6167 L
s
.41723 .57763 m
.39252 .59209 L
s
.24 .35 .67 r
.60748 .59209 m
.59844 .6167 L
s
.58277 .57763 m
.60748 .59209 L
s
.83 .24 .1 r
.3889 .53191 m
.36454 .54698 L
s
.34659 .52807 m
.36454 .54698 L
s
.24 .35 .67 r
.6111 .53191 m
.63546 .54698 L
s
.65341 .52807 m
.63546 .54698 L
s
.83 .24 .1 r
.40156 .6167 m
.40679 .64154 L
s
.42649 .6025 m
.40156 .6167 L
s
.24 .35 .67 r
.59844 .6167 m
.59321 .64154 L
s
.57351 .6025 m
.59844 .6167 L
s
.83 .24 .1 r
.37083 .51268 m
.34659 .52807 L
s
.32679 .51257 m
.34659 .52807 L
s
.24 .35 .67 r
.62917 .51268 m
.65341 .52807 L
s
.67321 .51257 m
.65341 .52807 L
s
.83 .24 .1 r
.40679 .64154 m
.40794 .6657 L
s
.43196 .62758 m
.40679 .64154 L
s
.24 .35 .67 r
.59321 .64154 m
.59206 .6657 L
s
.56804 .62758 m
.59321 .64154 L
s
.83 .24 .1 r
.41723 .57763 m
.40454 .55382 L
s
.42972 .53867 m
.40454 .55382 L
s
.40454 .55382 m
.3889 .53191 L
s
.24 .35 .67 r
.58277 .57763 m
.59546 .55382 L
s
.57028 .53867 m
.59546 .55382 L
s
.59546 .55382 m
.6111 .53191 L
s
.83 .24 .1 r
.35094 .49686 m
.32679 .51257 L
s
.30581 .50112 m
.32679 .51257 L
s
.24 .35 .67 r
.64906 .49686 m
.67321 .51257 L
s
.69419 .50112 m
.67321 .51257 L
s
.83 .24 .1 r
.42649 .6025 m
.41723 .57763 L
s
.4426 .56278 m
.41723 .57763 L
s
.24 .35 .67 r
.57351 .6025 m
.58277 .57763 L
s
.5574 .56278 m
.58277 .57763 L
s
.83 .24 .1 r
.41391 .51644 m
.3889 .53191 L
s
.3889 .53191 m
.37083 .51268 L
s
.24 .35 .67 r
.58609 .51644 m
.6111 .53191 L
s
.6111 .53191 m
.62917 .51268 L
s
.83 .24 .1 r
.43196 .62758 m
.42649 .6025 L
s
.45208 .58793 m
.42649 .6025 L
s
.24 .35 .67 r
.56804 .62758 m
.57351 .6025 L
s
.54792 .58793 m
.57351 .6025 L
s
.83 .24 .1 r
.39571 .49688 m
.37083 .51268 L
s
.37083 .51268 m
.35094 .49686 L
s
.24 .35 .67 r
.60429 .49688 m
.62917 .51268 L
s
.62917 .51268 m
.64906 .49686 L
s
.83 .24 .1 r
.40794 .6657 m
.43336 .65194 L
s
.40794 .6657 m
.40486 .68827 L
s
.24 .35 .67 r
.59206 .6657 m
.56664 .65194 L
s
.59206 .6657 m
.59514 .68827 L
s
.83 .24 .1 r
.32992 .4851 m
.30581 .50112 L
s
.28443 .49427 m
.30581 .50112 L
s
.24 .35 .67 r
.67008 .4851 m
.69419 .50112 L
s
.71557 .49427 m
.69419 .50112 L
s
.83 .24 .1 r
.43336 .65194 m
.43196 .62758 L
s
.45781 .61324 m
.43196 .62758 L
s
.24 .35 .67 r
.56664 .65194 m
.56804 .62758 L
s
.54219 .61324 m
.56804 .62758 L
s
.83 .24 .1 r
.4426 .56278 m
.42972 .53867 L
s
.45557 .52311 m
.42972 .53867 L
s
.42972 .53867 m
.41391 .51644 L
s
.24 .35 .67 r
.5574 .56278 m
.57028 .53867 L
s
.54443 .52311 m
.57028 .53867 L
s
.57028 .53867 m
.58609 .51644 L
s
.83 .24 .1 r
.37574 .48073 m
.35094 .49686 L
s
.35094 .49686 m
.32992 .4851 L
s
.24 .35 .67 r
.62426 .48073 m
.64906 .49686 L
s
.64906 .49686 m
.67008 .4851 L
s
.83 .24 .1 r
.45208 .58793 m
.4426 .56278 L
s
.46865 .54753 m
.4426 .56278 L
s
.24 .35 .67 r
.54792 .58793 m
.5574 .56278 L
s
.53135 .54753 m
.5574 .56278 L
s
.83 .24 .1 r
.43959 .50056 m
.41391 .51644 L
s
.41391 .51644 m
.39571 .49688 L
s
.24 .35 .67 r
.56041 .50056 m
.58609 .51644 L
s
.58609 .51644 m
.60429 .49688 L
s
.83 .24 .1 r
.45781 .61324 m
.45208 .58793 L
s
.47838 .57296 m
.45208 .58793 L
s
.24 .35 .67 r
.54219 .61324 m
.54792 .58793 L
s
.52162 .57296 m
.54792 .58793 L
s
.83 .24 .1 r
.40486 .68827 m
.39752 .70829 L
s
.43053 .67465 m
.40486 .68827 L
s
.24 .35 .67 r
.59514 .68827 m
.60248 .70829 L
s
.56947 .67465 m
.59514 .68827 L
s
.83 .24 .1 r
.42127 .48066 m
.39571 .49688 L
s
.39571 .49688 m
.37574 .48073 L
s
.24 .35 .67 r
.57873 .48066 m
.60429 .49688 L
s
.60429 .49688 m
.62426 .48073 L
s
.83 .24 .1 r
.43336 .65194 m
.45947 .63779 L
s
.24 .35 .67 r
.56664 .65194 m
.54053 .63779 L
s
.83 .24 .1 r
.43053 .67465 m
.43336 .65194 L
s
.24 .35 .67 r
.56947 .67465 m
.56664 .65194 L
s
.83 .24 .1 r
.30854 .47797 m
.28443 .49427 L
s
.26348 .49245 m
.28443 .49427 L
s
.24 .35 .67 r
.69146 .47797 m
.71557 .49427 L
s
.73652 .49245 m
.71557 .49427 L
s
.83 .24 .1 r
.35468 .46865 m
.32992 .4851 L
s
.32992 .4851 m
.30854 .47797 L
s
.24 .35 .67 r
.64532 .46865 m
.67008 .4851 L
s
.67008 .4851 m
.69146 .47797 L
s
.83 .24 .1 r
.45947 .63779 m
.45781 .61324 L
s
.48436 .59851 m
.45781 .61324 L
s
.24 .35 .67 r
.54053 .63779 m
.54219 .61324 L
s
.51564 .59851 m
.54219 .61324 L
s
.83 .24 .1 r
.46865 .54753 m
.45557 .52311 L
s
.48212 .50713 m
.45557 .52311 L
s
.45557 .52311 m
.43959 .50056 L
s
.24 .35 .67 r
.53135 .54753 m
.54443 .52311 L
s
.51788 .50713 m
.54443 .52311 L
s
.54443 .52311 m
.56041 .50056 L
s
.83 .24 .1 r
.40122 .46416 m
.37574 .48073 L
s
.37574 .48073 m
.35468 .46865 L
s
.24 .35 .67 r
.59878 .46416 m
.62426 .48073 L
s
.62426 .48073 m
.64532 .46865 L
s
.83 .24 .1 r
.47838 .57296 m
.46865 .54753 L
s
.49542 .53186 m
.46865 .54753 L
s
.24 .35 .67 r
.52162 .57296 m
.53135 .54753 L
s
.50458 .53186 m
.53135 .54753 L
s
.83 .24 .1 r
.46598 .48423 m
.43959 .50056 L
s
.43959 .50056 m
.42127 .48066 L
s
.24 .35 .67 r
.53402 .48423 m
.56041 .50056 L
s
.56041 .50056 m
.57873 .48066 L
s
.83 .24 .1 r
.48436 .59851 m
.47838 .57296 L
s
.24 .35 .67 r
.51564 .59851 m
.52162 .57296 L
s
.83 .24 .1 r
.39752 .70829 m
.38606 .72487 L
s
.42343 .69477 m
.39752 .70829 L
s
.24 .35 .67 r
.60248 .70829 m
.61394 .72487 L
s
.57657 .69477 m
.60248 .70829 L
s
.83 .24 .1 r
.42343 .69477 m
.43053 .67465 L
s
.45691 .66065 m
.43053 .67465 L
s
.24 .35 .67 r
.57657 .69477 m
.56947 .67465 L
s
.54309 .66065 m
.56947 .67465 L
s
.83 .24 .1 r
.44753 .46398 m
.42127 .48066 L
s
.42127 .48066 m
.40122 .46416 L
s
.24 .35 .67 r
.55247 .46398 m
.57873 .48066 L
s
.57873 .48066 m
.59878 .46416 L
s
.83 .24 .1 r
.45947 .63779 m
.4863 .62326 L
s
.45691 .66065 m
.45947 .63779 L
s
.24 .35 .67 r
.54053 .63779 m
.5137 .62326 L
s
.54309 .66065 m
.54053 .63779 L
s
.83 .24 .1 r
.28762 .4759 m
.26348 .49245 L
s
.24382 .49594 m
.26348 .49245 L
s
.24 .35 .67 r
.71238 .4759 m
.73652 .49245 L
s
.75618 .49594 m
.73652 .49245 L
s
.83 .24 .1 r
.3333 .46122 m
.30854 .47797 L
s
.30854 .47797 m
.28762 .4759 L
s
.24 .35 .67 r
.6667 .46122 m
.69146 .47797 L
s
.69146 .47797 m
.71238 .4759 L
s
.83 .24 .1 r
.38013 .45174 m
.35468 .46865 L
s
.35468 .46865 m
.3333 .46122 L
s
.24 .35 .67 r
.61987 .45174 m
.64532 .46865 L
s
.64532 .46865 m
.6667 .46122 L
s
.83 .24 .1 r
.49542 .53186 m
.48212 .50713 L
s
.48212 .50713 m
.46598 .48423 L
s
.24 .35 .67 r
.50458 .53186 m
.51788 .50713 L
s
.51788 .50713 m
.53402 .48423 L
s
.83 .24 .1 r
.4274 .44712 m
.40122 .46416 L
s
.40122 .46416 m
.38013 .45174 L
s
.24 .35 .67 r
.5726 .44712 m
.59878 .46416 L
s
.59878 .46416 m
.61987 .45174 L
s
.667 .188 .084 r
.51232 .54637 m .5 .55343 L .5 .57626 L p F P
0 0 0 r
s
.24 .35 .67 r
.50521 .56361 m
.52162 .57296 L
s
.721 .205 .091 r
.5 .55343 m .51232 .54637 L .51119 .52289 L p F P
0 0 0 r
s
.721 .205 .091 r
.51119 .52289 m .5 .52944 L .5 .55343 L p F P
0 0 0 r
s
.287 .407 .773 r
.48768 .54637 m .5 .55343 L .5 .57626 L p F P
0 0 0 r
s
.83 .24 .1 r
.47838 .57296 m
.49479 .56361 L
s
.292 .417 .795 r
.5 .55343 m .48768 .54637 L .48881 .52289 L p F P
0 0 0 r
s
.292 .417 .795 r
.48881 .52289 m .5 .52944 L .5 .55343 L p F P
0 0 0 r
s
.83 .24 .1 r
.46598 .48423 m
.44753 .46398 L
s
.24 .35 .67 r
.53402 .48423 m
.55247 .46398 L
s
.77 .221 .097 r
.5 .52944 m .51119 .52289 L .50981 .49883 L p F P
0 0 0 r
s
.24 .35 .67 r
.51001 .5024 m
.51788 .50713 L
s
.77 .221 .097 r
.50981 .49883 m .5 .50469 L .5 .52944 L p F P
0 0 0 r
s
.296 .424 .813 r
.5 .52944 m .48881 .52289 L .49019 .49883 L p F P
0 0 0 r
s
.83 .24 .1 r
.48212 .50713 m
.48999 .5024 L
s
.296 .424 .813 r
.49019 .49883 m .5 .50469 L .5 .52944 L p F P
0 0 0 r
s
.604 .168 .076 r
.51317 .56886 m .5 .57626 L .5 .59754 L p F P
0 0 0 r
s
.24 .35 .67 r
.50282 .5914 m
.51564 .59851 L
s
.667 .188 .084 r
.5 .57626 m .51317 .56886 L .51232 .54637 L p F P
0 0 0 r
s
.28 .394 .743 r
.48683 .56886 m .5 .57626 L .5 .59754 L p F P
0 0 0 r
s
.83 .24 .1 r
.48436 .59851 m
.49718 .5914 L
s
.287 .407 .773 r
.5 .57626 m .48683 .56886 L .48768 .54637 L p F P
0 0 0 r
s
.83 .24 .1 r
.49924 .56107 m
.50539 .55757 L
s
.24 .35 .67 r
.49461 .55757 m
.50076 .56107 L
s
.83 .24 .1 r
.49867 .54025 m
.50539 .55757 L
s
.24 .35 .67 r
.49461 .55757 m
.50133 .54025 L
s
.83 .24 .1 r
.41218 .71138 m
.42343 .69477 L
s
.45007 .68087 m
.42343 .69477 L
s
.24 .35 .67 r
.58782 .71138 m
.57657 .69477 L
s
.54993 .68087 m
.57657 .69477 L
s
.83 .24 .1 r
.45007 .68087 m
.45691 .66065 L
s
.48402 .64627 m
.45691 .66065 L
s
.24 .35 .67 r
.54993 .68087 m
.54309 .66065 L
s
.51598 .64627 m
.54309 .66065 L
s
.815 .235 .102 r
.5 .50469 m .50981 .49883 L .5082 .47458 L p F P
0 0 0 r
s
.815 .235 .102 r
.5082 .47458 m .5 .47958 L .5 .50469 L p F P
0 0 0 r
s
.298 .43 .827 r
.5 .50469 m .49019 .49883 L .4918 .47458 L p F P
0 0 0 r
s
.298 .43 .827 r
.4918 .47458 m .5 .47958 L .5 .50469 L p F P
0 0 0 r
s
.83 .24 .1 r
.38606 .72487 m
.37078 .73714 L
s
.41218 .71138 m
.38606 .72487 L
s
.24 .35 .67 r
.61394 .72487 m
.62922 .73714 L
s
.58782 .71138 m
.61394 .72487 L
s
.83 .24 .1 r
.47453 .44684 m
.44753 .46398 L
s
.44753 .46398 m
.4274 .44712 L
s
.24 .35 .67 r
.52547 .44684 m
.55247 .46398 L
s
.55247 .46398 m
.5726 .44712 L
s
.528 .145 .066 r
.51374 .58997 m .5 .59754 L .5 .6169 L p F P
0 0 0 r
s
.24 .35 .67 r
.5137 .62326 m
.51564 .59851 L
s
.604 .168 .076 r
.5 .59754 m .51374 .58997 L .51317 .56886 L p F P
0 0 0 r
s
.83 .24 .1 r
.50539 .55757 m
.51165 .58337 L
s
.269 .375 .705 r
.48626 .58997 m .5 .59754 L .5 .6169 L p F P
0 0 0 r
s
.83 .24 .1 r
.48436 .59851 m
.4863 .62326 L
s
.28 .394 .743 r
.5 .59754 m .48626 .58997 L .48683 .56886 L p F P
0 0 0 r
s
.83 .24 .1 r
.49928 .59023 m
.51165 .58337 L
s
.24 .35 .67 r
.48835 .58337 m
.50072 .59023 L
s
.48835 .58337 m
.49461 .55757 L
s
.667 .188 .084 r
.52479 .53922 m .51232 .54637 L .51317 .56886 L p F P
0 0 0 r
s
.721 .205 .091 r
.51232 .54637 m .52479 .53922 L .52251 .51627 L p F P
0 0 0 r
s
.721 .205 .091 r
.52251 .51627 m .51119 .52289 L .51232 .54637 L p F P
0 0 0 r
s
.287 .407 .773 r
.47521 .53922 m .48768 .54637 L .48683 .56886 L p F P
0 0 0 r
s
.292 .417 .795 r
.48768 .54637 m .47521 .53922 L .47749 .51627 L p F P
0 0 0 r
s
.292 .417 .795 r
.47749 .51627 m .48881 .52289 L .48768 .54637 L p F P
0 0 0 r
s
.77 .221 .097 r
.51119 .52289 m .52251 .51627 L .51972 .49291 L p F P
0 0 0 r
s
.77 .221 .097 r
.51972 .49291 m .50981 .49883 L .51119 .52289 L p F P
0 0 0 r
s
.296 .424 .813 r
.48881 .52289 m .47749 .51627 L .48028 .49291 L p F P
0 0 0 r
s
.296 .424 .813 r
.48028 .49291 m .49019 .49883 L .48881 .52289 L p F P
0 0 0 r
s
.83 .24 .1 r
.31243 .45889 m
.28762 .4759 L
s
.28762 .4759 m
.26804 .4792 L
s
.24 .35 .67 r
.68757 .45889 m
.71238 .4759 L
s
.71238 .4759 m
.73196 .4792 L
s
.83 .24 .1 r
.35876 .444 m
.3333 .46122 L
s
.3333 .46122 m
.31243 .45889 L
s
.24 .35 .67 r
.64124 .444 m
.6667 .46122 L
s
.6667 .46122 m
.68757 .45889 L
s
.83 .24 .1 r
.26804 .4792 m
.24382 .49594 L
s
.22636 .50483 m
.24382 .49594 L
s
.24 .35 .67 r
.73196 .4792 m
.75618 .49594 L
s
.77364 .50483 m
.75618 .49594 L
s
.604 .168 .076 r
.52652 .56136 m .51317 .56886 L .51374 .58997 L p F P
0 0 0 r
s
.667 .188 .084 r
.51317 .56886 m .52652 .56136 L .52479 .53922 L p F P
0 0 0 r
s
.28 .394 .743 r
.47348 .56136 m .48683 .56886 L .48626 .58997 L p F P
0 0 0 r
s
.287 .407 .773 r
.48683 .56886 m .47348 .56136 L .47521 .53922 L p F P
0 0 0 r
s
.83 .24 .1 r
.40629 .43436 m
.38013 .45174 L
s
.38013 .45174 m
.35876 .444 L
s
.24 .35 .67 r
.59371 .43436 m
.61987 .45174 L
s
.61987 .45174 m
.64124 .444 L
s
.815 .235 .102 r
.50981 .49883 m .51972 .49291 L .51647 .46953 L p F P
0 0 0 r
s
.24 .35 .67 r
.51705 .47374 m
.53402 .48423 L
s
.815 .235 .102 r
.51647 .46953 m .5082 .47458 L .50981 .49883 L p F P
0 0 0 r
s
.83 .24 .1 r
.49892 .49702 m
.50942 .4907 L
s
.298 .43 .827 r
.49019 .49883 m .48028 .49291 L .48353 .46953 L p F P
0 0 0 r
s
.83 .24 .1 r
.46598 .48423 m
.48295 .47374 L
s
.298 .43 .827 r
.48353 .46953 m .4918 .47458 L .49019 .49883 L p F P
0 0 0 r
s
.24 .35 .67 r
.49058 .4907 m
.50108 .49702 L
s
.858 .248 .108 r
.5 .47958 m .5082 .47458 L .50638 .45057 L p F P
0 0 0 r
s
.24 .35 .67 r
.5077 .46795 m
.51334 .47144 L
s
.858 .248 .108 r
.50638 .45057 m .5 .45454 L .5 .47958 L p F P
0 0 0 r
s
.299 .434 .837 r
.5 .47958 m .4918 .47458 L .49362 .45057 L p F P
0 0 0 r
s
.83 .24 .1 r
.48666 .47144 m
.4923 .46795 L
s
.299 .434 .837 r
.49362 .45057 m .5 .45454 L .5 .47958 L p F P
0 0 0 r
s
.721 .205 .091 r
.53395 .50958 m .52251 .51627 L .52479 .53922 L p F P
0 0 0 r
s
.77 .221 .097 r
.52251 .51627 m .53395 .50958 L .52972 .48693 L p F P
0 0 0 r
s
.77 .221 .097 r
.52972 .48693 m .51972 .49291 L .52251 .51627 L p F P
0 0 0 r
s
.83 .24 .1 r
.49887 .52984 m
.52293 .51576 L
s
.292 .417 .795 r
.46605 .50958 m .47749 .51627 L .47521 .53922 L p F P
0 0 0 r
s
.296 .424 .813 r
.47749 .51627 m .46605 .50958 L .47028 .48693 L p F P
0 0 0 r
s
.296 .424 .813 r
.47028 .48693 m .48028 .49291 L .47749 .51627 L p F P
0 0 0 r
s
.24 .35 .67 r
.47707 .51576 m
.50113 .52984 L
s
.667 .188 .084 r
.53742 .53199 m .52479 .53922 L .52652 .56136 L p F P
0 0 0 r
s
.721 .205 .091 r
.52479 .53922 m .53742 .53199 L .53395 .50958 L p F P
0 0 0 r
s
.287 .407 .773 r
.46258 .53199 m .47521 .53922 L .47348 .56136 L p F P
0 0 0 r
s
.292 .417 .795 r
.47521 .53922 m .46258 .53199 L .46605 .50958 L p F P
0 0 0 r
s
.83 .24 .1 r
.50942 .4907 m
.52293 .51576 L
s
.49778 .47412 m
.50942 .4907 L
s
.24 .35 .67 r
.47707 .51576 m
.49058 .4907 L
s
.49058 .4907 m
.50222 .47412 L
s
.528 .145 .066 r
.5 .6169 m .51401 .60931 L .51374 .58997 L p F P
0 0 0 r
s
.528 .145 .066 r
.52768 .58229 m .51374 .58997 L .51401 .60931 L p F P
0 0 0 r
s
.604 .168 .076 r
.51374 .58997 m .52768 .58229 L .52652 .56136 L p F P
0 0 0 r
s
.83 .24 .1 r
.51165 .58337 m
.51389 .60832 L
s
.269 .375 .705 r
.5 .6169 m .48599 .60931 L .48626 .58997 L p F P
0 0 0 r
s
.269 .375 .705 r
.47232 .58229 m .48626 .58997 L .48599 .60931 L p F P
0 0 0 r
s
.28 .394 .743 r
.48626 .58997 m .47232 .58229 L .47348 .56136 L p F P
0 0 0 r
s
.24 .35 .67 r
.48611 .60832 m
.48835 .58337 L
s
.435 .116 .054 r
.51401 .60931 m .5 .6169 L .5 .63395 L p F P
0 0 0 r
s
.24 .35 .67 r
.50787 .62011 m
.5137 .62326 L
s
.5137 .62326 m
.51598 .64627 L
s
.254 .35 .652 r
.48599 .60931 m .5 .6169 L .5 .63395 L p F P
0 0 0 r
s
.83 .24 .1 r
.4863 .62326 m
.49213 .62011 L
s
.48402 .64627 m
.4863 .62326 L
s
.45433 .42961 m
.4274 .44712 L
s
.4274 .44712 m
.40629 .43436 L
s
.24 .35 .67 r
.54567 .42961 m
.5726 .44712 L
s
.5726 .44712 m
.59371 .43436 L
s
.815 .235 .102 r
.51972 .49291 m .52972 .48693 L .52481 .46444 L p F P
0 0 0 r
s
.815 .235 .102 r
.52481 .46444 m .51647 .46953 L .51972 .49291 L p F P
0 0 0 r
s
.298 .43 .827 r
.48028 .49291 m .47028 .48693 L .47519 .46444 L p F P
0 0 0 r
s
.298 .43 .827 r
.47519 .46444 m .48353 .46953 L .48028 .49291 L p F P
0 0 0 r
s
.604 .168 .076 r
.54006 .55376 m .52652 .56136 L .52768 .58229 L p F P
0 0 0 r
s
.667 .188 .084 r
.52652 .56136 m .54006 .55376 L .53742 .53199 L p F P
0 0 0 r
s
.83 .24 .1 r
.50539 .55757 m
.53316 .54176 L
s
.52293 .51576 m
.53316 .54176 L
s
.28 .394 .743 r
.45994 .55376 m .47348 .56136 L .47232 .58229 L p F P
0 0 0 r
s
.287 .407 .773 r
.47348 .56136 m .45994 .55376 L .46258 .53199 L p F P
0 0 0 r
s
.24 .35 .67 r
.46684 .54176 m
.49461 .55757 L
s
.46684 .54176 m
.47707 .51576 L
s
.858 .248 .108 r
.5082 .47458 m .51647 .46953 L .51281 .44656 L p F P
0 0 0 r
s
.24 .35 .67 r
.5076 .46668 m
.50992 .4641 L
s
.51475 .45874 m
.52547 .44684 L
s
.858 .248 .108 r
.51281 .44656 m .50638 .45057 L .5082 .47458 L p F P
0 0 0 r
s
.299 .434 .837 r
.4918 .47458 m .48353 .46953 L .48719 .44656 L p F P
0 0 0 r
s
.83 .24 .1 r
.47453 .44684 m
.48525 .45874 L
s
.49008 .4641 m
.4924 .46668 L
s
.299 .434 .837 r
.48719 .44656 m .49362 .45057 L .4918 .47458 L p F P
0 0 0 r
s
.721 .205 .091 r
.54553 .5028 m .53395 .50958 L .53742 .53199 L p F P
0 0 0 r
s
.77 .221 .097 r
.53395 .50958 m .54553 .5028 L .53983 .48089 L p F P
0 0 0 r
s
.77 .221 .097 r
.53983 .48089 m .52972 .48693 L .53395 .50958 L p F P
0 0 0 r
s
.292 .417 .795 r
.45447 .5028 m .46605 .50958 L .46258 .53199 L p F P
0 0 0 r
s
.296 .424 .813 r
.46605 .50958 m .45447 .5028 L .46017 .48089 L p F P
0 0 0 r
s
.296 .424 .813 r
.46017 .48089 m .47028 .48693 L .46605 .50958 L p F P
0 0 0 r
s
.83 .24 .1 r
.43905 .69751 m
.45007 .68087 L
s
.47745 .66657 m
.45007 .68087 L
s
.24 .35 .67 r
.56095 .69751 m
.54993 .68087 L
s
.52255 .66657 m
.54993 .68087 L
s
.667 .188 .084 r
.5502 .52466 m .53742 .53199 L .54006 .55376 L p F P
0 0 0 r
s
.721 .205 .091 r
.53742 .53199 m .5502 .52466 L .54553 .5028 L p F P
0 0 0 r
s
.287 .407 .773 r
.4498 .52466 m .46258 .53199 L .45994 .55376 L p F P
0 0 0 r
s
.292 .417 .795 r
.46258 .53199 m .4498 .52466 L .45447 .5028 L p F P
0 0 0 r
s
.83 .24 .1 r
.47745 .66657 m
.48402 .64627 L
s
.24 .35 .67 r
.52255 .66657 m
.51598 .64627 L
s
.83 .24 .1 r
.39708 .72362 m
.41218 .71138 L
s
.43905 .69751 m
.41218 .71138 L
s
.24 .35 .67 r
.60292 .72362 m
.58782 .71138 L
s
.56095 .69751 m
.58782 .71138 L
s
.858 .248 .108 r
.51647 .46953 m .52481 .46444 L .51928 .44254 L p F P
0 0 0 r
s
.24 .35 .67 r
.51939 .44298 m
.52547 .44684 L
s
.858 .248 .108 r
.51928 .44254 m .51281 .44656 L .51647 .46953 L p F P
0 0 0 r
s
.299 .434 .837 r
.48353 .46953 m .47519 .46444 L .48072 .44254 L p F P
0 0 0 r
s
.83 .24 .1 r
.47453 .44684 m
.48061 .44298 L
s
.299 .434 .837 r
.48072 .44254 m .48719 .44656 L .48353 .46953 L p F P
0 0 0 r
s
.83 .24 .1 r
.37078 .73714 m
.35219 .74436 L
s
.39708 .72362 m
.37078 .73714 L
s
.24 .35 .67 r
.62922 .73714 m
.64781 .74436 L
s
.60292 .72362 m
.62922 .73714 L
s
.815 .235 .102 r
.52972 .48693 m .53983 .48089 L .53321 .45931 L p F P
0 0 0 r
s
.815 .235 .102 r
.53321 .45931 m .52481 .46444 L .52972 .48693 L p F P
0 0 0 r
s
.298 .43 .827 r
.47028 .48693 m .46017 .48089 L .46679 .45931 L p F P
0 0 0 r
s
.298 .43 .827 r
.46679 .45931 m .47519 .46444 L .47028 .48693 L p F P
0 0 0 r
s
.528 .145 .066 r
.51401 .60931 m .52823 .60162 L .52768 .58229 L p F P
0 0 0 r
s
.528 .145 .066 r
.54181 .57451 m .52768 .58229 L .52823 .60162 L p F P
0 0 0 r
s
.604 .168 .076 r
.52768 .58229 m .54181 .57451 L .54006 .55376 L p F P
0 0 0 r
s
.83 .24 .1 r
.51165 .58337 m
.53971 .5678 L
s
.53316 .54176 m
.53971 .5678 L
s
.269 .375 .705 r
.48599 .60931 m .47177 .60162 L .47232 .58229 L p F P
0 0 0 r
s
.269 .375 .705 r
.45819 .57451 m .47232 .58229 L .47177 .60162 L p F P
0 0 0 r
s
.28 .394 .743 r
.47232 .58229 m .45819 .57451 L .45994 .55376 L p F P
0 0 0 r
s
.24 .35 .67 r
.46029 .5678 m
.48835 .58337 L
s
.46029 .5678 m
.46684 .54176 L
s
.435 .116 .054 r
.5 .63395 m .51397 .62651 L .51401 .60931 L p F P
0 0 0 r
s
.435 .116 .054 r
.52823 .60162 m .51401 .60931 L .51397 .62651 L p F P
0 0 0 r
s
.254 .35 .652 r
.5 .63395 m .48603 .62651 L .48599 .60931 L p F P
0 0 0 r
s
.83 .24 .1 r
.49903 .61637 m
.51389 .60832 L
s
.24 .35 .67 r
.48611 .60832 m
.50097 .61637 L
s
.254 .35 .652 r
.47177 .60162 m .48599 .60931 L .48603 .62651 L p F P
0 0 0 r
s
.898 .261 .113 r
.5 .45454 m .50638 .45057 L .50439 .42723 L p F P
0 0 0 r
s
.898 .261 .113 r
.50439 .42723 m .5 .43002 L .5 .45454 L p F P
0 0 0 r
s
.298 .435 .844 r
.5 .45454 m .49362 .45057 L .49561 .42723 L p F P
0 0 0 r
s
.298 .435 .844 r
.49561 .42723 m .5 .43002 L .5 .45454 L p F P
0 0 0 r
s
.83 .24 .1 r
.33795 .4414 m
.31243 .45889 L
s
.31243 .45889 m
.29294 .46199 L
s
.24 .35 .67 r
.66205 .4414 m
.68757 .45889 L
s
.68757 .45889 m
.70706 .46199 L
s
.83 .24 .1 r
.38494 .42629 m
.35876 .444 L
s
.35876 .444 m
.33795 .4414 L
s
.24 .35 .67 r
.61506 .42629 m
.64124 .444 L
s
.64124 .444 m
.66205 .4414 L
s
.604 .168 .076 r
.55377 .54606 m .54006 .55376 L .54181 .57451 L p F P
0 0 0 r
s
.667 .188 .084 r
.54006 .55376 m .55377 .54606 L .5502 .52466 L p F P
0 0 0 r
s
.28 .394 .743 r
.44623 .54606 m .45994 .55376 L .45819 .57451 L p F P
0 0 0 r
s
.287 .407 .773 r
.45994 .55376 m .44623 .54606 L .4498 .52466 L p F P
0 0 0 r
s
.83 .24 .1 r
.29294 .46199 m
.26804 .4792 L
s
.26804 .4792 m
.2507 .48796 L
s
.24 .35 .67 r
.70706 .46199 m
.73196 .4792 L
s
.73196 .4792 m
.7493 .48796 L
s
.319 .081 .039 r
.51397 .62651 m .5 .63395 L .5 .64833 L p F P
0 0 0 r
s
.24 .35 .67 r
.50504 .64046 m
.51598 .64627 L
s
.232 .315 .578 r
.48603 .62651 m .5 .63395 L .5 .64833 L p F P
0 0 0 r
s
.83 .24 .1 r
.48402 .64627 m
.49496 .64046 L
s
.2507 .48796 m
.22636 .50483 L
s
.21199 .51895 m
.22636 .50483 L
s
.24 .35 .67 r
.7493 .48796 m
.77364 .50483 L
s
.78801 .51895 m
.77364 .50483 L
s
.83 .24 .1 r
.43319 .41648 m
.40629 .43436 L
s
.40629 .43436 m
.38494 .42629 L
s
.24 .35 .67 r
.56681 .41648 m
.59371 .43436 L
s
.59371 .43436 m
.61506 .42629 L
s
.898 .261 .113 r
.50638 .45057 m .51281 .44656 L .5088 .42443 L p F P
0 0 0 r
s
.24 .35 .67 r
.51122 .43779 m
.51898 .44272 L
s
.898 .261 .113 r
.5088 .42443 m .50439 .42723 L .50638 .45057 L p F P
0 0 0 r
s
.298 .435 .844 r
.49362 .45057 m .48719 .44656 L .4912 .42443 L p F P
0 0 0 r
s
.83 .24 .1 r
.48102 .44272 m
.48878 .43779 L
s
.298 .435 .844 r
.4912 .42443 m .49561 .42723 L .49362 .45057 L p F P
0 0 0 r
s
.858 .248 .108 r
.52481 .46444 m .53321 .45931 L .52579 .43848 L p F P
0 0 0 r
s
.24 .35 .67 r
.52547 .44684 m
.52547 .44684 L
s
.528 .44468 m
.54567 .42961 L
s
.858 .248 .108 r
.52579 .43848 m .51928 .44254 L .52481 .46444 L p F P
0 0 0 r
s
.83 .24 .1 r
.49864 .46403 m
.52099 .45021 L
s
.299 .434 .837 r
.47519 .46444 m .46679 .45931 L .47421 .43848 L p F P
0 0 0 r
s
.83 .24 .1 r
.45433 .42961 m
.472 .44468 L
s
.47453 .44684 m
.47453 .44684 L
s
.299 .434 .837 r
.47421 .43848 m .48072 .44254 L .47519 .46444 L p F P
0 0 0 r
s
.24 .35 .67 r
.47901 .45021 m
.50136 .46403 L
s
.721 .205 .091 r
.55724 .49595 m .54553 .5028 L .5502 .52466 L p F P
0 0 0 r
s
.77 .221 .097 r
.54553 .5028 m .55724 .49595 L .55004 .47478 L p F P
0 0 0 r
s
.77 .221 .097 r
.55004 .47478 m .53983 .48089 L .54553 .5028 L p F P
0 0 0 r
s
.292 .417 .795 r
.44276 .49595 m .45447 .5028 L .4498 .52466 L p F P
0 0 0 r
s
.296 .424 .813 r
.45447 .5028 m .44276 .49595 L .44996 .47478 L p F P
0 0 0 r
s
.296 .424 .813 r
.44996 .47478 m .46017 .48089 L .45447 .5028 L p F P
0 0 0 r
s
.815 .235 .102 r
.53983 .48089 m .55004 .47478 L .54169 .45414 L p F P
0 0 0 r
s
.815 .235 .102 r
.54169 .45414 m .53321 .45931 L .53983 .48089 L p F P
0 0 0 r
s
.83 .24 .1 r
.50942 .4907 m
.53748 .47381 L
s
.298 .43 .827 r
.46017 .48089 m .44996 .47478 L .45831 .45414 L p F P
0 0 0 r
s
.298 .43 .827 r
.45831 .45414 m .46679 .45931 L .46017 .48089 L p F P
0 0 0 r
s
.24 .35 .67 r
.46252 .47381 m
.49058 .4907 L
s
.667 .188 .084 r
.56315 .51724 m .5502 .52466 L .55377 .54606 L p F P
0 0 0 r
s
.721 .205 .091 r
.5502 .52466 m .56315 .51724 L .55724 .49595 L p F P
0 0 0 r
s
.83 .24 .1 r
.52293 .51576 m
.55122 .4992 L
s
.287 .407 .773 r
.43685 .51724 m .4498 .52466 L .44623 .54606 L p F P
0 0 0 r
s
.292 .417 .795 r
.4498 .52466 m .43685 .51724 L .44276 .49595 L p F P
0 0 0 r
s
.24 .35 .67 r
.44878 .4992 m
.47707 .51576 L
s
.83 .24 .1 r
.53748 .47381 m
.55122 .4992 L
s
.24 .35 .67 r
.44878 .4992 m
.46252 .47381 L
s
.898 .261 .113 r
.51281 .44656 m .51928 .44254 L .51323 .42162 L p F P
0 0 0 r
s
.898 .261 .113 r
.51323 .42162 m .5088 .42443 L .51281 .44656 L p F P
0 0 0 r
s
.298 .435 .844 r
.48719 .44656 m .48072 .44254 L .48677 .42162 L p F P
0 0 0 r
s
.298 .435 .844 r
.48677 .42162 m .4912 .42443 L .48719 .44656 L p F P
0 0 0 r
s
.528 .145 .066 r
.52823 .60162 m .54265 .59382 L .54181 .57451 L p F P
0 0 0 r
s
.528 .145 .066 r
.55615 .56661 m .54181 .57451 L .54265 .59382 L p F P
0 0 0 r
s
.604 .168 .076 r
.54181 .57451 m .55615 .56661 L .55377 .54606 L p F P
0 0 0 r
s
.83 .24 .1 r
.53971 .5678 m
.54225 .59296 L
s
.269 .375 .705 r
.47177 .60162 m .45735 .59382 L .45819 .57451 L p F P
0 0 0 r
s
.269 .375 .705 r
.44385 .56661 m .45819 .57451 L .45735 .59382 L p F P
0 0 0 r
s
.28 .394 .743 r
.45819 .57451 m .44385 .56661 L .44623 .54606 L p F P
0 0 0 r
s
.24 .35 .67 r
.45775 .59296 m
.46029 .5678 L
s
.435 .116 .054 r
.51397 .62651 m .52814 .61897 L .52823 .60162 L p F P
0 0 0 r
s
.435 .116 .054 r
.54265 .59382 m .52823 .60162 L .52814 .61897 L p F P
0 0 0 r
s
.254 .35 .652 r
.48603 .62651 m .47186 .61897 L .47177 .60162 L p F P
0 0 0 r
s
.254 .35 .652 r
.45735 .59382 m .47177 .60162 L .47186 .61897 L p F P
0 0 0 r
s
.858 .248 .108 r
.53321 .45931 m .54169 .45414 L .53234 .4344 L p F P
0 0 0 r
s
.858 .248 .108 r
.53234 .4344 m .52579 .43848 L .53321 .45931 L p F P
0 0 0 r
s
.83 .24 .1 r
.52099 .45021 m
.53748 .47381 L
s
.299 .434 .837 r
.46679 .45931 m .45831 .45414 L .46766 .4344 L p F P
0 0 0 r
s
.299 .434 .837 r
.46766 .4344 m .47421 .43848 L .46679 .45931 L p F P
0 0 0 r
s
.24 .35 .67 r
.46252 .47381 m
.47901 .45021 L
s
.604 .168 .076 r
.56767 .53826 m .55377 .54606 L .55615 .56661 L p F P
0 0 0 r
s
.667 .188 .084 r
.55377 .54606 m .56767 .53826 L .56315 .51724 L p F P
0 0 0 r
s
.83 .24 .1 r
.53316 .54176 m
.56172 .5255 L
s
.28 .394 .743 r
.43233 .53826 m .44623 .54606 L .44385 .56661 L p F P
0 0 0 r
s
.287 .407 .773 r
.44623 .54606 m .43233 .53826 L .43685 .51724 L p F P
0 0 0 r
s
.24 .35 .67 r
.43828 .5255 m
.46684 .54176 L
s
.319 .081 .039 r
.5 .64833 m .51361 .64118 L .51397 .62651 L p F P
0 0 0 r
s
.319 .081 .039 r
.52814 .61897 m .51397 .62651 L .51361 .64118 L p F P
0 0 0 r
s
.83 .24 .1 r
.5119 .63147 m
.51389 .60832 L
s
.232 .315 .578 r
.5 .64833 m .48639 .64118 L .48603 .62651 L p F P
0 0 0 r
s
.83 .24 .1 r
.49926 .63818 m
.5119 .63147 L
s
.24 .35 .67 r
.4881 .63147 m
.50074 .63818 L
s
.232 .315 .578 r
.47186 .61897 m .48603 .62651 L .48639 .64118 L p F P
0 0 0 r
s
.24 .35 .67 r
.48611 .60832 m
.4881 .63147 L
s
.721 .205 .091 r
.56908 .48902 m .55724 .49595 L .56315 .51724 L p F P
0 0 0 r
s
.83 .24 .1 r
.55122 .4992 m
.56172 .5255 L
s
.77 .221 .097 r
.55724 .49595 m .56908 .48902 L .56035 .46862 L p F P
0 0 0 r
s
.77 .221 .097 r
.56035 .46862 m .55004 .47478 L .55724 .49595 L p F P
0 0 0 r
s
.292 .417 .795 r
.43092 .48902 m .44276 .49595 L .43685 .51724 L p F P
0 0 0 r
s
.24 .35 .67 r
.43828 .5255 m
.44878 .4992 L
s
.296 .424 .813 r
.44276 .49595 m .43092 .48902 L .43965 .46862 L p F P
0 0 0 r
s
.296 .424 .813 r
.43965 .46862 m .44996 .47478 L .44276 .49595 L p F P
0 0 0 r
s
.815 .235 .102 r
.55004 .47478 m .56035 .46862 L .55024 .44892 L p F P
0 0 0 r
s
.815 .235 .102 r
.55024 .44892 m .54169 .45414 L .55004 .47478 L p F P
0 0 0 r
s
.298 .43 .827 r
.44996 .47478 m .43965 .46862 L .44976 .44892 L p F P
0 0 0 r
s
.298 .43 .827 r
.44976 .44892 m .45831 .45414 L .44996 .47478 L p F P
0 0 0 r
s
.898 .261 .113 r
.51928 .44254 m .52579 .43848 L .51768 .41879 L p F P
0 0 0 r
s
.898 .261 .113 r
.51768 .41879 m .51323 .42162 L .51928 .44254 L p F P
0 0 0 r
s
.298 .435 .844 r
.48072 .44254 m .47421 .43848 L .48232 .41879 L p F P
0 0 0 r
s
.298 .435 .844 r
.48232 .41879 m .48677 .42162 L .48072 .44254 L p F P
0 0 0 r
s
.667 .188 .084 r
.57627 .50972 m .56315 .51724 L .56767 .53826 L p F P
0 0 0 r
s
.721 .205 .091 r
.56315 .51724 m .57627 .50972 L .56908 .48902 L p F P
0 0 0 r
s
.287 .407 .773 r
.42373 .50972 m .43685 .51724 L .43233 .53826 L p F P
0 0 0 r
s
.292 .417 .795 r
.43685 .51724 m .42373 .50972 L .43092 .48902 L p F P
0 0 0 r
s
.938 .274 .118 r
.5 .43002 m .50439 .42723 L .50225 .40504 L p F P
0 0 0 r
s
.938 .274 .118 r
.50225 .40504 m .5 .4065 L .5 .43002 L p F P
0 0 0 r
s
.296 .435 .847 r
.5 .43002 m .49561 .42723 L .49775 .40504 L p F P
0 0 0 r
s
.296 .435 .847 r
.49775 .40504 m .5 .4065 L .5 .43002 L p F P
0 0 0 r
s
.83 .24 .1 r
.49742 .43231 m
.50229 .42921 L
s
.24 .35 .67 r
.49771 .42921 m
.50258 .43231 L
s
.858 .248 .108 r
.54169 .45414 m .55024 .44892 L .53893 .43029 L p F P
0 0 0 r
s
.858 .248 .108 r
.53893 .43029 m .53234 .4344 L .54169 .45414 L p F P
0 0 0 r
s
.299 .434 .837 r
.45831 .45414 m .44976 .44892 L .46107 .43029 L p F P
0 0 0 r
s
.299 .434 .837 r
.46107 .43029 m .46766 .4344 L .45831 .45414 L p F P
0 0 0 r
s
.83 .24 .1 r
.46668 .68324 m
.47745 .66657 L
s
.24 .35 .67 r
.53332 .68324 m
.52255 .66657 L
s
.83 .24 .1 r
.42414 .70971 m
.43905 .69751 L
s
.46668 .68324 m
.43905 .69751 L
s
.24 .35 .67 r
.57586 .70971 m
.56095 .69751 L
s
.53332 .68324 m
.56095 .69751 L
s
.898 .261 .113 r
.52579 .43848 m .53234 .4344 L .52215 .41595 L p F P
0 0 0 r
s
.898 .261 .113 r
.52215 .41595 m .51768 .41879 L .52579 .43848 L p F P
0 0 0 r
s
.83 .24 .1 r
.50229 .42921 m
.52099 .45021 L
s
.298 .435 .844 r
.47421 .43848 m .46766 .4344 L .47785 .41595 L p F P
0 0 0 r
s
.298 .435 .844 r
.47785 .41595 m .48232 .41879 L .47421 .43848 L p F P
0 0 0 r
s
.24 .35 .67 r
.47901 .45021 m
.49771 .42921 L
s
.938 .274 .118 r
.50439 .42723 m .5088 .42443 L .50451 .40358 L p F P
0 0 0 r
s
.938 .274 .118 r
.50451 .40358 m .50225 .40504 L .50439 .42723 L p F P
0 0 0 r
s
.296 .435 .847 r
.49561 .42723 m .4912 .42443 L .49549 .40358 L p F P
0 0 0 r
s
.296 .435 .847 r
.49549 .40358 m .49775 .40504 L .49561 .42723 L p F P
0 0 0 r
s
.83 .24 .1 r
.37862 .73074 m
.39708 .72362 L
s
.42414 .70971 m
.39708 .72362 L
s
.24 .35 .67 r
.62138 .73074 m
.60292 .72362 L
s
.57586 .70971 m
.60292 .72362 L
s
.528 .145 .066 r
.54265 .59382 m .55727 .58591 L .55615 .56661 L p F P
0 0 0 r
s
.528 .145 .066 r
.57068 .5586 m .55615 .56661 L .55727 .58591 L p F P
0 0 0 r
s
.604 .168 .076 r
.55615 .56661 m .57068 .5586 L .56767 .53826 L p F P
0 0 0 r
s
.269 .375 .705 r
.45735 .59382 m .44273 .58591 L .44385 .56661 L p F P
0 0 0 r
s
.269 .375 .705 r
.42932 .5586 m .44385 .56661 L .44273 .58591 L p F P
0 0 0 r
s
.28 .394 .743 r
.44385 .56661 m .42932 .5586 L .43233 .53826 L p F P
0 0 0 r
s
.215 .055 .025 r
.51361 .64118 m .5 .64833 L .5 .65967 L p F P
0 0 0 r
s
.199 .262 .472 r
.48639 .64118 m .5 .64833 L .5 .65967 L p F P
0 0 0 r
s
.435 .116 .054 r
.52814 .61897 m .54252 .61131 L .54265 .59382 L p F P
0 0 0 r
s
.83 .24 .1 r
.51389 .60832 m
.54225 .59296 L
s
.435 .116 .054 r
.55727 .58591 m .54265 .59382 L .54252 .61131 L p F P
0 0 0 r
s
.254 .35 .652 r
.47186 .61897 m .45748 .61131 L .45735 .59382 L p F P
0 0 0 r
s
.24 .35 .67 r
.45775 .59296 m
.48611 .60832 L
s
.254 .35 .652 r
.44273 .58591 m .45735 .59382 L .45748 .61131 L p F P
0 0 0 r
s
.83 .24 .1 r
.35219 .74436 m
.33101 .74598 L
s
.37862 .73074 m
.35219 .74436 L
s
.24 .35 .67 r
.64781 .74436 m
.66899 .74598 L
s
.62138 .73074 m
.64781 .74436 L
s
.77 .221 .097 r
.57077 .4624 m .56035 .46862 L .56908 .48902 L p F P
0 0 0 r
s
.815 .235 .102 r
.56035 .46862 m .57077 .4624 L .55886 .44366 L p F P
0 0 0 r
s
.815 .235 .102 r
.55886 .44366 m .55024 .44892 L .56035 .46862 L p F P
0 0 0 r
s
.296 .424 .813 r
.42923 .4624 m .43965 .46862 L .43092 .48902 L p F P
0 0 0 r
s
.298 .43 .827 r
.43965 .46862 m .42923 .4624 L .44114 .44366 L p F P
0 0 0 r
s
.298 .43 .827 r
.44114 .44366 m .44976 .44892 L .43965 .46862 L p F P
0 0 0 r
s
.604 .168 .076 r
.58176 .53034 m .56767 .53826 L .57068 .5586 L p F P
0 0 0 r
s
.83 .24 .1 r
.53971 .5678 m
.56856 .5518 L
s
.667 .188 .084 r
.56767 .53826 m .58176 .53034 L .57627 .50972 L p F P
0 0 0 r
s
.83 .24 .1 r
.56172 .5255 m
.56856 .5518 L
s
.28 .394 .743 r
.41824 .53034 m .43233 .53826 L .42932 .5586 L p F P
0 0 0 r
s
.24 .35 .67 r
.43144 .5518 m
.46029 .5678 L
s
.287 .407 .773 r
.43233 .53826 m .41824 .53034 L .42373 .50972 L p F P
0 0 0 r
s
.24 .35 .67 r
.43144 .5518 m
.43828 .5255 L
s
.721 .205 .091 r
.58107 .482 m .56908 .48902 L .57627 .50972 L p F P
0 0 0 r
s
.77 .221 .097 r
.56908 .48902 m .58107 .482 L .57077 .4624 L p F P
0 0 0 r
s
.292 .417 .795 r
.41893 .482 m .43092 .48902 L .42373 .50972 L p F P
0 0 0 r
s
.296 .424 .813 r
.43092 .48902 m .41893 .482 L .42923 .4624 L p F P
0 0 0 r
s
.83 .24 .1 r
.3642 .4234 m
.33795 .4414 L
s
.33795 .4414 m
.31857 .44427 L
s
.24 .35 .67 r
.6358 .4234 m
.66205 .4414 L
s
.66205 .4414 m
.68143 .44427 L
s
.83 .24 .1 r
.41188 .40807 m
.38494 .42629 L
s
.38494 .42629 m
.3642 .4234 L
s
.24 .35 .67 r
.58812 .40807 m
.61506 .42629 L
s
.61506 .42629 m
.6358 .4234 L
s
.938 .274 .118 r
.5088 .42443 m .51323 .42162 L .50677 .40212 L p F P
0 0 0 r
s
.938 .274 .118 r
.50677 .40212 m .50451 .40358 L .5088 .42443 L p F P
0 0 0 r
s
.24 .35 .67 r
.49771 .42921 m
.50511 .42278 L
s
.296 .435 .847 r
.4912 .42443 m .48677 .42162 L .49323 .40212 L p F P
0 0 0 r
s
.296 .435 .847 r
.49323 .40212 m .49549 .40358 L .4912 .42443 L p F P
0 0 0 r
s
.83 .24 .1 r
.49489 .42278 m
.50229 .42921 L
s
.31857 .44427 m
.29294 .46199 L
s
.29294 .46199 m
.27574 .47061 L
s
.24 .35 .67 r
.68143 .44427 m
.70706 .46199 L
s
.70706 .46199 m
.72426 .47061 L
s
.858 .248 .108 r
.55024 .44892 m .55886 .44366 L .54557 .42616 L p F P
0 0 0 r
s
.24 .35 .67 r
.54567 .42961 m
.54621 .42928 L
s
.858 .248 .108 r
.54557 .42616 m .53893 .43029 L .55024 .44892 L p F P
0 0 0 r
s
.24 .35 .67 r
.54738 .42855 m
.56681 .41648 L
s
.299 .434 .837 r
.44976 .44892 m .44114 .44366 L .45443 .42616 L p F P
0 0 0 r
s
.83 .24 .1 r
.45379 .42928 m
.45433 .42961 L
s
.299 .434 .837 r
.45443 .42616 m .46107 .43029 L .44976 .44892 L p F P
0 0 0 r
s
.83 .24 .1 r
.43319 .41648 m
.45262 .42855 L
s
.898 .261 .113 r
.53234 .4344 m .53893 .43029 L .52664 .4131 L p F P
0 0 0 r
s
.24 .35 .67 r
.53216 .42082 m
.54291 .42782 L
s
.898 .261 .113 r
.52664 .4131 m .52215 .41595 L .53234 .4344 L p F P
0 0 0 r
s
.298 .435 .844 r
.46766 .4344 m .46107 .43029 L .47336 .4131 L p F P
0 0 0 r
s
.83 .24 .1 r
.45709 .42782 m
.46784 .42082 L
s
.298 .435 .844 r
.47336 .4131 m .47785 .41595 L .46766 .4344 L p F P
0 0 0 r
s
.319 .081 .039 r
.51361 .64118 m .52741 .63394 L .52814 .61897 L p F P
0 0 0 r
s
.319 .081 .039 r
.54252 .61131 m .52814 .61897 L .52741 .63394 L p F P
0 0 0 r
s
.232 .315 .578 r
.48639 .64118 m .47259 .63394 L .47186 .61897 L p F P
0 0 0 r
s
.232 .315 .578 r
.45748 .61131 m .47186 .61897 L .47259 .63394 L p F P
0 0 0 r
s
.83 .24 .1 r
.27574 .47061 m
.2507 .48796 L
s
.2507 .48796 m
.23648 .50203 L
s
.24 .35 .67 r
.72426 .47061 m
.7493 .48796 L
s
.7493 .48796 m
.76352 .50203 L
s
.83 .24 .1 r
.23648 .50203 m
.21199 .51895 L
s
.20151 .53787 m
.21199 .51895 L
s
.24 .35 .67 r
.76352 .50203 m
.78801 .51895 L
s
.79849 .53787 m
.78801 .51895 L
s
.667 .188 .084 r
.58955 .50211 m .57627 .50972 L .58176 .53034 L p F P
0 0 0 r
s
.721 .205 .091 r
.57627 .50972 m .58955 .50211 L .58107 .482 L p F P
0 0 0 r
s
.83 .24 .1 r
.55122 .4992 m
.58032 .48217 L
s
.287 .407 .773 r
.41045 .50211 m .42373 .50972 L .41824 .53034 L p F P
0 0 0 r
s
.292 .417 .795 r
.42373 .50972 m .41045 .50211 L .41893 .482 L p F P
0 0 0 r
s
.24 .35 .67 r
.41968 .48217 m
.44878 .4992 L
s
.938 .274 .118 r
.51323 .42162 m .51768 .41879 L .50903 .40065 L p F P
0 0 0 r
s
.938 .274 .118 r
.50903 .40065 m .50677 .40212 L .51323 .42162 L p F P
0 0 0 r
s
.296 .435 .847 r
.48677 .42162 m .48232 .41879 L .49097 .40065 L p F P
0 0 0 r
s
.296 .435 .847 r
.49097 .40065 m .49323 .40212 L .48677 .42162 L p F P
0 0 0 r
s
.898 .261 .113 r
.53893 .43029 m .54557 .42616 L .53115 .41024 L p F P
0 0 0 r
s
.898 .261 .113 r
.53115 .41024 m .52664 .4131 L .53893 .43029 L p F P
0 0 0 r
s
.298 .435 .844 r
.46107 .43029 m .45443 .42616 L .46885 .41024 L p F P
0 0 0 r
s
.298 .435 .844 r
.46885 .41024 m .47336 .4131 L .46107 .43029 L p F P
0 0 0 r
s
.77 .221 .097 r
.58129 .45611 m .57077 .4624 L .58107 .482 L p F P
0 0 0 r
s
.815 .235 .102 r
.57077 .4624 m .58129 .45611 L .56755 .43835 L p F P
0 0 0 r
s
.815 .235 .102 r
.56755 .43835 m .55886 .44366 L .57077 .4624 L p F P
0 0 0 r
s
.83 .24 .1 r
.53748 .47381 m
.56635 .45644 L
s
.296 .424 .813 r
.41871 .45611 m .42923 .4624 L .41893 .482 L p F P
0 0 0 r
s
.298 .43 .827 r
.42923 .4624 m .41871 .45611 L .43245 .43835 L p F P
0 0 0 r
s
.298 .43 .827 r
.43245 .43835 m .44114 .44366 L .42923 .4624 L p F P
0 0 0 r
s
.24 .35 .67 r
.43365 .45644 m
.46252 .47381 L
s
.938 .274 .118 r
.51768 .41879 m .52215 .41595 L .5113 .39918 L p F P
0 0 0 r
s
.24 .35 .67 r
.52031 .41312 m
.52342 .41514 L
s
.938 .274 .118 r
.5113 .39918 m .50903 .40065 L .51768 .41879 L p F P
0 0 0 r
s
.296 .435 .847 r
.48232 .41879 m .47785 .41595 L .4887 .39918 L p F P
0 0 0 r
s
.83 .24 .1 r
.47658 .41514 m
.47969 .41312 L
s
.296 .435 .847 r
.4887 .39918 m .49097 .40065 L .48232 .41879 L p F P
0 0 0 r
s
.858 .248 .108 r
.55886 .44366 m .56755 .43835 L .55225 .422 L p F P
0 0 0 r
s
.858 .248 .108 r
.55225 .422 m .54557 .42616 L .55886 .44366 L p F P
0 0 0 r
s
.83 .24 .1 r
.52099 .45021 m
.54967 .43247 L
s
.299 .434 .837 r
.44114 .44366 m .43245 .43835 L .44775 .422 L p F P
0 0 0 r
s
.299 .434 .837 r
.44775 .422 m .45443 .42616 L .44114 .44366 L p F P
0 0 0 r
s
.24 .35 .67 r
.45033 .43247 m
.47901 .45021 L
s
.83 .24 .1 r
.56635 .45644 m
.58032 .48217 L
s
.54967 .43247 m
.56635 .45644 L
s
.24 .35 .67 r
.41968 .48217 m
.43365 .45644 L
s
.43365 .45644 m
.45033 .43247 L
s
.215 .055 .025 r
.5 .65967 m .51292 .65296 L .51361 .64118 L p F P
0 0 0 r
s
.24 .35 .67 r
.50468 .65724 m
.52255 .66657 L
s
.83 .24 .1 r
.50563 .65186 m
.5119 .63147 L
s
.215 .055 .025 r
.52741 .63394 m .51361 .64118 L .51292 .65296 L p F P
0 0 0 r
s
.199 .262 .472 r
.5 .65967 m .48708 .65296 L .48639 .64118 L p F P
0 0 0 r
s
.83 .24 .1 r
.49921 .65521 m
.50563 .65186 L
s
.24 .35 .67 r
.49437 .65186 m
.50079 .65521 L
s
.4881 .63147 m
.49437 .65186 L
s
.83 .24 .1 r
.47745 .66657 m
.49532 .65724 L
s
.199 .262 .472 r
.47259 .63394 m .48639 .64118 L .48708 .65296 L p F P
0 0 0 r
s
.528 .145 .066 r
.55727 .58591 m .57211 .57788 L .57068 .5586 L p F P
0 0 0 r
s
.528 .145 .066 r
.58543 .55048 m .57068 .5586 L .57211 .57788 L p F P
0 0 0 r
s
.604 .168 .076 r
.57068 .5586 m .58543 .55048 L .58176 .53034 L p F P
0 0 0 r
s
.83 .24 .1 r
.56856 .5518 m
.57144 .57715 L
s
.269 .375 .705 r
.44273 .58591 m .42789 .57788 L .42932 .5586 L p F P
0 0 0 r
s
.269 .375 .705 r
.41457 .55048 m .42932 .5586 L .42789 .57788 L p F P
0 0 0 r
s
.28 .394 .743 r
.42932 .5586 m .41457 .55048 L .41824 .53034 L p F P
0 0 0 r
s
.24 .35 .67 r
.42856 .57715 m
.43144 .5518 L
s
.721 .205 .091 r
.59319 .47491 m .58107 .482 L .58955 .50211 L p F P
0 0 0 r
s
.77 .221 .097 r
.58107 .482 m .59319 .47491 L .58129 .45611 L p F P
0 0 0 r
s
.292 .417 .795 r
.40681 .47491 m .41893 .482 L .41045 .50211 L p F P
0 0 0 r
s
.296 .424 .813 r
.41893 .482 m .40681 .47491 L .41871 .45611 L p F P
0 0 0 r
s
.435 .116 .054 r
.54252 .61131 m .5571 .60355 L .55727 .58591 L p F P
0 0 0 r
s
.435 .116 .054 r
.57211 .57788 m .55727 .58591 L .5571 .60355 L p F P
0 0 0 r
s
.254 .35 .652 r
.45748 .61131 m .4429 .60355 L .44273 .58591 L p F P
0 0 0 r
s
.254 .35 .652 r
.42789 .57788 m .44273 .58591 L .4429 .60355 L p F P
0 0 0 r
s
.604 .168 .076 r
.59605 .52232 m .58176 .53034 L .58543 .55048 L p F P
0 0 0 r
s
.667 .188 .084 r
.58176 .53034 m .59605 .52232 L .58955 .50211 L p F P
0 0 0 r
s
.28 .394 .743 r
.40395 .52232 m .41824 .53034 L .41457 .55048 L p F P
0 0 0 r
s
.287 .407 .773 r
.41824 .53034 m .40395 .52232 L .41045 .50211 L p F P
0 0 0 r
s
.938 .274 .118 r
.52215 .41595 m .52664 .4131 L .51358 .39771 L p F P
0 0 0 r
s
.24 .35 .67 r
.51893 .41099 m
.51961 .41055 L
s
.938 .274 .118 r
.51358 .39771 m .5113 .39918 L .52215 .41595 L p F P
0 0 0 r
s
.296 .435 .847 r
.47785 .41595 m .47336 .4131 L .48642 .39771 L p F P
0 0 0 r
s
.83 .24 .1 r
.48039 .41055 m
.48107 .41099 L
s
.296 .435 .847 r
.48642 .39771 m .4887 .39918 L .47785 .41595 L p F P
0 0 0 r
s
.898 .261 .113 r
.54557 .42616 m .55225 .422 L .53567 .40736 L p F P
0 0 0 r
s
.898 .261 .113 r
.53567 .40736 m .53115 .41024 L .54557 .42616 L p F P
0 0 0 r
s
.298 .435 .844 r
.45443 .42616 m .44775 .422 L .46433 .40736 L p F P
0 0 0 r
s
.298 .435 .844 r
.46433 .40736 m .46885 .41024 L .45443 .42616 L p F P
0 0 0 r
s
.319 .081 .039 r
.52741 .63394 m .5414 .62659 L .54252 .61131 L p F P
0 0 0 r
s
.83 .24 .1 r
.5119 .63147 m
.54059 .61625 L
s
.319 .081 .039 r
.5571 .60355 m .54252 .61131 L .5414 .62659 L p F P
0 0 0 r
s
.83 .24 .1 r
.54059 .61625 m
.54225 .59296 L
s
.232 .315 .578 r
.47259 .63394 m .4586 .62659 L .45748 .61131 L p F P
0 0 0 r
s
.24 .35 .67 r
.45941 .61625 m
.4881 .63147 L
s
.232 .315 .578 r
.4429 .60355 m .45748 .61131 L .4586 .62659 L p F P
0 0 0 r
s
.24 .35 .67 r
.45775 .59296 m
.45941 .61625 L
s
.667 .188 .084 r
.60301 .4944 m .58955 .50211 L .59605 .52232 L p F P
0 0 0 r
s
.83 .24 .1 r
.56172 .5255 m
.59109 .50877 L
s
.721 .205 .091 r
.58955 .50211 m .60301 .4944 L .59319 .47491 L p F P
0 0 0 r
s
.83 .24 .1 r
.58032 .48217 m
.59109 .50877 L
s
.287 .407 .773 r
.39699 .4944 m .41045 .50211 L .40395 .52232 L p F P
0 0 0 r
s
.24 .35 .67 r
.40891 .50877 m
.43828 .5255 L
s
.292 .417 .795 r
.41045 .50211 m .39699 .4944 L .40681 .47491 L p F P
0 0 0 r
s
.24 .35 .67 r
.40891 .50877 m
.41968 .48217 L
s
.938 .274 .118 r
.52664 .4131 m .53115 .41024 L .51586 .39623 L p F P
0 0 0 r
s
.24 .35 .67 r
.52277 .40854 m
.52344 .40811 L
s
.938 .274 .118 r
.51586 .39623 m .51358 .39771 L .52664 .4131 L p F P
0 0 0 r
s
.83 .24 .1 r
.50229 .42921 m
.53085 .41108 L
s
.296 .435 .847 r
.47336 .4131 m .46885 .41024 L .48414 .39623 L p F P
0 0 0 r
s
.83 .24 .1 r
.47656 .40811 m
.47723 .40854 L
s
.296 .435 .847 r
.48414 .39623 m .48642 .39771 L .47336 .4131 L p F P
0 0 0 r
s
.24 .35 .67 r
.46915 .41108 m
.49771 .42921 L
s
.815 .235 .102 r
.57632 .433 m .56755 .43835 L .58129 .45611 L p F P
0 0 0 r
s
.858 .248 .108 r
.56755 .43835 m .57632 .433 L .55898 .41781 L p F P
0 0 0 r
s
.858 .248 .108 r
.55898 .41781 m .55225 .422 L .56755 .43835 L p F P
0 0 0 r
s
.298 .43 .827 r
.42368 .433 m .43245 .43835 L .41871 .45611 L p F P
0 0 0 r
s
.299 .434 .837 r
.43245 .43835 m .42368 .433 L .44102 .41781 L p F P
0 0 0 r
s
.299 .434 .837 r
.44102 .41781 m .44775 .422 L .43245 .43835 L p F P
0 0 0 r
s
.978 .287 .123 r
.5 .38446 m .5 .4065 L .50225 .40504 L closepath p F P
0 0 0 r
s
.292 .431 .844 r
.5 .38446 m .5 .4065 L .49775 .40504 L closepath p F P
0 0 0 r
s
.77 .221 .097 r
.59192 .44975 m .58129 .45611 L .59319 .47491 L p F P
0 0 0 r
s
.815 .235 .102 r
.58129 .45611 m .59192 .44975 L .57632 .433 L p F P
0 0 0 r
s
.296 .424 .813 r
.40808 .44975 m .41871 .45611 L .40681 .47491 L p F P
0 0 0 r
s
.298 .43 .827 r
.41871 .45611 m .40808 .44975 L .42368 .433 L p F P
0 0 0 r
s
.978 .287 .123 r
.5 .38446 m .50225 .40504 L .50451 .40358 L closepath p F P
0 0 0 r
s
.292 .431 .844 r
.5 .38446 m .49775 .40504 L .49549 .40358 L closepath p F P
0 0 0 r
s
.898 .261 .113 r
.55225 .422 m .55898 .41781 L .54022 .40447 L p F P
0 0 0 r
s
.898 .261 .113 r
.54022 .40447 m .53567 .40736 L .55225 .422 L p F P
0 0 0 r
s
.83 .24 .1 r
.53085 .41108 m
.54967 .43247 L
s
.298 .435 .844 r
.44775 .422 m .44102 .41781 L .45978 .40447 L p F P
0 0 0 r
s
.298 .435 .844 r
.45978 .40447 m .46433 .40736 L .44775 .422 L p F P
0 0 0 r
s
.24 .35 .67 r
.45033 .43247 m
.46915 .41108 L
s
.938 .274 .118 r
.53115 .41024 m .53567 .40736 L .51814 .39476 L p F P
0 0 0 r
s
.24 .35 .67 r
.52661 .40608 m
.52729 .40565 L
s
.938 .274 .118 r
.51814 .39476 m .51586 .39623 L .53115 .41024 L p F P
0 0 0 r
s
.296 .435 .847 r
.46885 .41024 m .46433 .40736 L .48186 .39476 L p F P
0 0 0 r
s
.83 .24 .1 r
.47271 .40565 m
.47339 .40608 L
s
.296 .435 .847 r
.48186 .39476 m .48414 .39623 L .46885 .41024 L p F P
0 0 0 r
s
.721 .205 .091 r
.60546 .46773 m .59319 .47491 L .60301 .4944 L p F P
0 0 0 r
s
.77 .221 .097 r
.59319 .47491 m .60546 .46773 L .59192 .44975 L p F P
0 0 0 r
s
.292 .417 .795 r
.39454 .46773 m .40681 .47491 L .39699 .4944 L p F P
0 0 0 r
s
.296 .424 .813 r
.40681 .47491 m .39454 .46773 L .40808 .44975 L p F P
0 0 0 r
s
.978 .287 .123 r
.5 .38446 m .50451 .40358 L .50677 .40212 L closepath p F P
0 0 0 r
s
.292 .431 .844 r
.5 .38446 m .49549 .40358 L .49323 .40212 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.45199 .69539 m
.46668 .68324 L
s
.49513 .66855 m
.46668 .68324 L
s
.24 .35 .67 r
.54801 .69539 m
.53332 .68324 L
s
.50487 .66855 m
.53332 .68324 L
s
.215 .055 .025 r
.51292 .65296 m .52602 .64616 L .52741 .63394 L p F P
0 0 0 r
s
.215 .055 .025 r
.5414 .62659 m .52741 .63394 L .52602 .64616 L p F P
0 0 0 r
s
.199 .262 .472 r
.48708 .65296 m .47398 .64616 L .47259 .63394 L p F P
0 0 0 r
s
.199 .262 .472 r
.4586 .62659 m .47259 .63394 L .47398 .64616 L p F P
0 0 0 r
s
.1 .028 .011 r
.51292 .65296 m .5 .65967 L .5 .66762 L p F P
0 0 0 r
s
.156 .195 .345 r
.48708 .65296 m .5 .65967 L .5 .66762 L p F P
0 0 0 r
s
.83 .24 .1 r
.40583 .71672 m
.42414 .70971 L
s
.45199 .69539 m
.42414 .70971 L
s
.24 .35 .67 r
.59417 .71672 m
.57586 .70971 L
s
.54801 .69539 m
.57586 .70971 L
s
.528 .145 .066 r
.57211 .57788 m .58716 .56973 L .58543 .55048 L p F P
0 0 0 r
s
.528 .145 .066 r
.60039 .54224 m .58543 .55048 L .58716 .56973 L p F P
0 0 0 r
s
.604 .168 .076 r
.58543 .55048 m .60039 .54224 L .59605 .52232 L p F P
0 0 0 r
s
.269 .375 .705 r
.42789 .57788 m .41284 .56973 L .41457 .55048 L p F P
0 0 0 r
s
.269 .375 .705 r
.39961 .54224 m .41457 .55048 L .41284 .56973 L p F P
0 0 0 r
s
.28 .394 .743 r
.41457 .55048 m .39961 .54224 L .40395 .52232 L p F P
0 0 0 r
s
.978 .287 .123 r
.5 .38446 m .50677 .40212 L .50903 .40065 L closepath p F P
0 0 0 r
s
.292 .431 .844 r
.5 .38446 m .49323 .40212 L .49097 .40065 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.33101 .74598 m
.30815 .74169 L
s
.35751 .73219 m
.33101 .74598 L
s
.24 .35 .67 r
.66899 .74598 m
.69185 .74169 L
s
.64249 .73219 m
.66899 .74598 L
s
.435 .116 .054 r
.5571 .60355 m .57189 .59567 L .57211 .57788 L p F P
0 0 0 r
s
.83 .24 .1 r
.54225 .59296 m
.57144 .57715 L
s
.435 .116 .054 r
.58716 .56973 m .57211 .57788 L .57189 .59567 L p F P
0 0 0 r
s
.254 .35 .652 r
.4429 .60355 m .42811 .59567 L .42789 .57788 L p F P
0 0 0 r
s
.24 .35 .67 r
.42856 .57715 m
.45775 .59296 L
s
.254 .35 .652 r
.41284 .56973 m .42789 .57788 L .42811 .59567 L p F P
0 0 0 r
s
.83 .24 .1 r
.35751 .73219 m
.37862 .73074 L
s
.40583 .71672 m
.37862 .73074 L
s
.24 .35 .67 r
.64249 .73219 m
.62138 .73074 L
s
.59417 .71672 m
.62138 .73074 L
s
.604 .168 .076 r
.61053 .51419 m .59605 .52232 L .60039 .54224 L p F P
0 0 0 r
s
.83 .24 .1 r
.56856 .5518 m
.59825 .53532 L
s
.667 .188 .084 r
.59605 .52232 m .61053 .51419 L .60301 .4944 L p F P
0 0 0 r
s
.83 .24 .1 r
.59109 .50877 m
.59825 .53532 L
s
.28 .394 .743 r
.38947 .51419 m .40395 .52232 L .39961 .54224 L p F P
0 0 0 r
s
.24 .35 .67 r
.40175 .53532 m
.43144 .5518 L
s
.287 .407 .773 r
.40395 .52232 m .38947 .51419 L .39699 .4944 L p F P
0 0 0 r
s
.24 .35 .67 r
.40175 .53532 m
.40891 .50877 L
s
.815 .235 .102 r
.58517 .4276 m .57632 .433 L .59192 .44975 L p F P
0 0 0 r
s
.858 .248 .108 r
.57632 .433 m .58517 .4276 L .56575 .41359 L p F P
0 0 0 r
s
.24 .35 .67 r
.56681 .41648 m
.56723 .41631 L
s
.858 .248 .108 r
.56575 .41359 m .55898 .41781 L .57632 .433 L p F P
0 0 0 r
s
.24 .35 .67 r
.56871 .41573 m
.58812 .40807 L
s
.298 .43 .827 r
.41483 .4276 m .42368 .433 L .40808 .44975 L p F P
0 0 0 r
s
.299 .434 .837 r
.42368 .433 m .41483 .4276 L .43425 .41359 L p F P
0 0 0 r
s
.83 .24 .1 r
.43277 .41631 m
.43319 .41648 L
s
.299 .434 .837 r
.43425 .41359 m .44102 .41781 L .42368 .433 L p F P
0 0 0 r
s
.83 .24 .1 r
.41188 .40807 m
.43129 .41573 L
s
.938 .274 .118 r
.53567 .40736 m .54022 .40447 L .52044 .39327 L p F P
0 0 0 r
s
.24 .35 .67 r
.53047 .40362 m
.53115 .40318 L
s
.938 .274 .118 r
.52044 .39327 m .51814 .39476 L .53567 .40736 L p F P
0 0 0 r
s
.296 .435 .847 r
.46433 .40736 m .45978 .40447 L .47956 .39327 L p F P
0 0 0 r
s
.83 .24 .1 r
.46885 .40318 m
.46953 .40362 L
s
.296 .435 .847 r
.47956 .39327 m .48186 .39476 L .46433 .40736 L p F P
0 0 0 r
s
.978 .287 .123 r
.5 .38446 m .50903 .40065 L .5113 .39918 L closepath p F P
0 0 0 r
s
.292 .431 .844 r
.5 .38446 m .49097 .40065 L .4887 .39918 L closepath p F P
0 0 0 r
s
.898 .261 .113 r
.55898 .41781 m .56575 .41359 L .54479 .40157 L p F P
0 0 0 r
s
.898 .261 .113 r
.54479 .40157 m .54022 .40447 L .55898 .41781 L p F P
0 0 0 r
s
.24 .35 .67 r
.54095 .3993 m
.54457 .40171 L
s
.298 .435 .844 r
.44102 .41781 m .43425 .41359 L .45521 .40157 L p F P
0 0 0 r
s
.298 .435 .844 r
.45521 .40157 m .45978 .40447 L .44102 .41781 L p F P
0 0 0 r
s
.83 .24 .1 r
.45543 .40171 m
.45905 .3993 L
s
.3642 .4234 m
.34494 .42604 L
s
.24 .35 .67 r
.6358 .4234 m
.65506 .42604 L
s
.77 .221 .097 r
.60267 .44333 m .59192 .44975 L .60546 .46773 L p F P
0 0 0 r
s
.815 .235 .102 r
.59192 .44975 m .60267 .44333 L .58517 .4276 L p F P
0 0 0 r
s
.296 .424 .813 r
.39733 .44333 m .40808 .44975 L .39454 .46773 L p F P
0 0 0 r
s
.298 .43 .827 r
.40808 .44975 m .39733 .44333 L .41483 .4276 L p F P
0 0 0 r
s
.83 .24 .1 r
.34494 .42604 m
.31857 .44427 L
s
.31857 .44427 m
.30151 .45274 L
s
.24 .35 .67 r
.65506 .42604 m
.68143 .44427 L
s
.68143 .44427 m
.69849 .45274 L
s
.978 .287 .123 r
.5 .38446 m .5113 .39918 L .51358 .39771 L closepath p F P
0 0 0 r
s
.292 .431 .844 r
.5 .38446 m .4887 .39918 L .48642 .39771 L closepath p F P
0 0 0 r
s
.667 .188 .084 r
.61665 .48658 m .60301 .4944 L .61053 .51419 L p F P
0 0 0 r
s
.721 .205 .091 r
.60301 .4944 m .61665 .48658 L .60546 .46773 L p F P
0 0 0 r
s
.287 .407 .773 r
.38335 .48658 m .39699 .4944 L .38947 .51419 L p F P
0 0 0 r
s
.292 .417 .795 r
.39699 .4944 m .38335 .48658 L .39454 .46773 L p F P
0 0 0 r
s
.319 .081 .039 r
.5414 .62659 m .55558 .61914 L .5571 .60355 L p F P
0 0 0 r
s
.319 .081 .039 r
.57189 .59567 m .5571 .60355 L .55558 .61914 L p F P
0 0 0 r
s
.232 .315 .578 r
.4586 .62659 m .44442 .61914 L .4429 .60355 L p F P
0 0 0 r
s
.232 .315 .578 r
.42811 .59567 m .4429 .60355 L .44442 .61914 L p F P
0 0 0 r
s
.83 .24 .1 r
.30151 .45274 m
.27574 .47061 L
s
.27574 .47061 m
.26169 .48462 L
s
.24 .35 .67 r
.69849 .45274 m
.72426 .47061 L
s
.72426 .47061 m
.73831 .48462 L
s
.83 .24 .1 r
.22619 .521 m
.20151 .53787 L
s
.19559 .56088 m
.20151 .53787 L
s
.24 .35 .67 r
.77381 .521 m
.79849 .53787 L
s
.80441 .56088 m
.79849 .53787 L
s
.938 .274 .118 r
.54022 .40447 m .54479 .40157 L .52273 .39179 L p F P
0 0 0 r
s
.24 .35 .67 r
.53434 .40114 m
.53503 .4007 L
s
.938 .274 .118 r
.52273 .39179 m .52044 .39327 L .54022 .40447 L p F P
0 0 0 r
s
.24 .35 .67 r
.53913 .39809 m
.54095 .3993 L
s
.53823 .39866 m
.53913 .39809 L
s
.296 .435 .847 r
.45978 .40447 m .45521 .40157 L .47727 .39179 L p F P
0 0 0 r
s
.83 .24 .1 r
.46497 .4007 m
.46566 .40114 L
s
.296 .435 .847 r
.47727 .39179 m .47956 .39327 L .45978 .40447 L p F P
0 0 0 r
s
.83 .24 .1 r
.45905 .3993 m
.46087 .39809 L
s
.46087 .39809 m
.46177 .39866 L
s
.978 .287 .123 r
.5 .38446 m .51358 .39771 L .51586 .39623 L closepath p F P
0 0 0 r
s
.292 .431 .844 r
.5 .38446 m .48642 .39771 L .48414 .39623 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.26169 .48462 m
.23648 .50203 L
s
.23648 .50203 m
.22619 .521 L
s
.24 .35 .67 r
.73831 .48462 m
.76352 .50203 L
s
.76352 .50203 m
.77381 .521 L
s
.858 .248 .108 r
.57256 .40934 m .56575 .41359 L .58517 .4276 L p F P
0 0 0 r
s
.898 .261 .113 r
.56575 .41359 m .57256 .40934 L .54939 .39865 L p F P
0 0 0 r
s
.898 .261 .113 r
.54939 .39865 m .54479 .40157 L .56575 .41359 L p F P
0 0 0 r
s
.299 .434 .837 r
.42744 .40934 m .43425 .41359 L .41483 .4276 L p F P
0 0 0 r
s
.298 .435 .844 r
.43425 .41359 m .42744 .40934 L .45061 .39865 L p F P
0 0 0 r
s
.298 .435 .844 r
.45061 .39865 m .45521 .40157 L .43425 .41359 L p F P
0 0 0 r
s
.978 .287 .123 r
.5 .38446 m .51586 .39623 L .51814 .39476 L closepath p F P
0 0 0 r
s
.292 .431 .844 r
.5 .38446 m .48414 .39623 L .48186 .39476 L closepath p F P
0 0 0 r
s
.721 .205 .091 r
.61787 .46047 m .60546 .46773 L .61665 .48658 L p F P
0 0 0 r
s
.77 .221 .097 r
.60546 .46773 m .61787 .46047 L .60267 .44333 L p F P
0 0 0 r
s
.83 .24 .1 r
.58032 .48217 m
.61026 .46465 L
s
.292 .417 .795 r
.38213 .46047 m .39454 .46773 L .38335 .48658 L p F P
0 0 0 r
s
.296 .424 .813 r
.39454 .46773 m .38213 .46047 L .39733 .44333 L p F P
0 0 0 r
s
.24 .35 .67 r
.38974 .46465 m
.41968 .48217 L
s
.815 .235 .102 r
.59409 .42216 m .58517 .4276 L .60267 .44333 L p F P
0 0 0 r
s
.83 .24 .1 r
.56635 .45644 m
.59605 .43857 L
s
.858 .248 .108 r
.58517 .4276 m .59409 .42216 L .57256 .40934 L p F P
0 0 0 r
s
.298 .43 .827 r
.40591 .42216 m .41483 .4276 L .39733 .44333 L p F P
0 0 0 r
s
.24 .35 .67 r
.40395 .43857 m
.43365 .45644 L
s
.299 .434 .837 r
.41483 .4276 m .40591 .42216 L .42744 .40934 L p F P
0 0 0 r
s
.938 .274 .118 r
.54479 .40157 m .54939 .39865 L .52503 .3903 L p F P
0 0 0 r
s
.938 .274 .118 r
.52503 .3903 m .52273 .39179 L .54479 .40157 L p F P
0 0 0 r
s
.296 .435 .847 r
.45521 .40157 m .45061 .39865 L .47497 .3903 L p F P
0 0 0 r
s
.296 .435 .847 r
.47497 .3903 m .47727 .39179 L .45521 .40157 L p F P
0 0 0 r
s
.978 .287 .123 r
.5 .38446 m .51814 .39476 L .52044 .39327 L closepath p F P
0 0 0 r
s
.292 .431 .844 r
.5 .38446 m .48186 .39476 L .47956 .39327 L closepath p F P
0 0 0 r
s
.1 .028 .011 r
.5 .66762 m .51191 .66148 L .51292 .65296 L p F P
0 0 0 r
s
.24 .35 .67 r
.50324 .66595 m
.50336 .66615 L
s
.50336 .66615 m
.50487 .66855 L
s
.1 .028 .011 r
.52602 .64616 m .51292 .65296 L .51191 .66148 L p F P
0 0 0 r
s
.156 .195 .345 r
.5 .66762 m .48809 .66148 L .48708 .65296 L p F P
0 0 0 r
s
.83 .24 .1 r
.4986 .66303 m
.50563 .65186 L
s
.24 .35 .67 r
.49437 .65186 m
.5014 .66303 L
s
.83 .24 .1 r
.49513 .66855 m
.49664 .66615 L
s
.49664 .66615 m
.49676 .66595 L
s
.156 .195 .345 r
.47398 .64616 m .48708 .65296 L .48809 .66148 L p F P
0 0 0 r
s
.215 .055 .025 r
.52602 .64616 m .53928 .63926 L .5414 .62659 L p F P
0 0 0 r
s
.215 .055 .025 r
.55558 .61914 m .5414 .62659 L .53928 .63926 L p F P
0 0 0 r
s
.83 .24 .1 r
.53462 .63673 m
.54059 .61625 L
s
.199 .262 .472 r
.47398 .64616 m .46072 .63926 L .4586 .62659 L p F P
0 0 0 r
s
.199 .262 .472 r
.44442 .61914 m .4586 .62659 L .46072 .63926 L p F P
0 0 0 r
s
.24 .35 .67 r
.45941 .61625 m
.46538 .63673 L
s
.978 .287 .123 r
.5 .38446 m .52044 .39327 L .52273 .39179 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.51052 .39306 m
.53085 .41108 L
s
.292 .431 .844 r
.5 .38446 m .47956 .39327 L .47727 .39179 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.49336 .40423 m
.51052 .39306 L
s
.24 .35 .67 r
.48948 .39306 m
.50664 .40423 L
s
.46915 .41108 m
.48948 .39306 L
s
.77 .221 .097 r
.61352 .43685 m .60267 .44333 L .61787 .46047 L p F P
0 0 0 r
s
.815 .235 .102 r
.60267 .44333 m .61352 .43685 L .59409 .42216 L p F P
0 0 0 r
s
.83 .24 .1 r
.59605 .43857 m
.61026 .46465 L
s
.296 .424 .813 r
.38648 .43685 m .39733 .44333 L .38213 .46047 L p F P
0 0 0 r
s
.298 .43 .827 r
.39733 .44333 m .38648 .43685 L .40591 .42216 L p F P
0 0 0 r
s
.24 .35 .67 r
.38974 .46465 m
.40395 .43857 L
s
.528 .145 .066 r
.58716 .56973 m .60244 .56147 L .60039 .54224 L p F P
0 0 0 r
s
.528 .145 .066 r
.61556 .53388 m .60039 .54224 L .60244 .56147 L p F P
0 0 0 r
s
.604 .168 .076 r
.60039 .54224 m .61556 .53388 L .61053 .51419 L p F P
0 0 0 r
s
.83 .24 .1 r
.59825 .53532 m
.60147 .56088 L
s
.269 .375 .705 r
.41284 .56973 m .39756 .56147 L .39961 .54224 L p F P
0 0 0 r
s
.269 .375 .705 r
.38444 .53388 m .39961 .54224 L .39756 .56147 L p F P
0 0 0 r
s
.28 .394 .743 r
.39961 .54224 m .38444 .53388 L .38947 .51419 L p F P
0 0 0 r
s
.24 .35 .67 r
.39853 .56088 m
.40175 .53532 L
s
.604 .168 .076 r
.62522 .50594 m .61053 .51419 L .61556 .53388 L p F P
0 0 0 r
s
.667 .188 .084 r
.61053 .51419 m .62522 .50594 L .61665 .48658 L p F P
0 0 0 r
s
.28 .394 .743 r
.37478 .50594 m .38947 .51419 L .38444 .53388 L p F P
0 0 0 r
s
.287 .407 .773 r
.38947 .51419 m .37478 .50594 L .38335 .48658 L p F P
0 0 0 r
s
.435 .116 .054 r
.57189 .59567 m .58689 .58768 L .58716 .56973 L p F P
0 0 0 r
s
.435 .116 .054 r
.60244 .56147 m .58716 .56973 L .58689 .58768 L p F P
0 0 0 r
s
.254 .35 .652 r
.42811 .59567 m .41311 .58768 L .41284 .56973 L p F P
0 0 0 r
s
.254 .35 .652 r
.39756 .56147 m .41284 .56973 L .41311 .58768 L p F P
0 0 0 r
s
.898 .261 .113 r
.554 .39572 m .54939 .39865 L .57256 .40934 L p F P
0 0 0 r
s
.938 .274 .118 r
.54939 .39865 m .554 .39572 L .52734 .3888 L p F P
0 0 0 r
s
.24 .35 .67 r
.54304 .39647 m
.54381 .39616 L
s
.938 .274 .118 r
.52734 .3888 m .52503 .3903 L .54939 .39865 L p F P
0 0 0 r
s
.298 .435 .844 r
.446 .39572 m .45061 .39865 L .42744 .40934 L p F P
0 0 0 r
s
.296 .435 .847 r
.45061 .39865 m .446 .39572 L .47266 .3888 L p F P
0 0 0 r
s
.83 .24 .1 r
.45619 .39616 m
.45696 .39647 L
s
.296 .435 .847 r
.47266 .3888 m .47497 .3903 L .45061 .39865 L p F P
0 0 0 r
s
.858 .248 .108 r
.57942 .40507 m .57256 .40934 L .59409 .42216 L p F P
0 0 0 r
s
.83 .24 .1 r
.57919 .41421 m
.59605 .43857 L
s
.54967 .43247 m
.57919 .41421 L
s
.898 .261 .113 r
.57256 .40934 m .57942 .40507 L .554 .39572 L p F P
0 0 0 r
s
.299 .434 .837 r
.42058 .40507 m .42744 .40934 L .40591 .42216 L p F P
0 0 0 r
s
.24 .35 .67 r
.40395 .43857 m
.42081 .41421 L
s
.42081 .41421 m
.45033 .43247 L
s
.298 .435 .844 r
.42744 .40934 m .42058 .40507 L .446 .39572 L p F P
0 0 0 r
s
.978 .287 .123 r
.5 .38446 m .52273 .39179 L .52503 .3903 L closepath p F P
0 0 0 r
s
.292 .431 .844 r
.5 .38446 m .47727 .39179 L .47497 .3903 L closepath p F P
0 0 0 r
s
.667 .188 .084 r
.63046 .47867 m .61665 .48658 L .62522 .50594 L p F P
0 0 0 r
s
.83 .24 .1 r
.59109 .50877 m
.62132 .49156 L
s
.721 .205 .091 r
.61665 .48658 m .63046 .47867 L .61787 .46047 L p F P
0 0 0 r
s
.287 .407 .773 r
.36954 .47867 m .38335 .48658 L .37478 .50594 L p F P
0 0 0 r
s
.24 .35 .67 r
.37868 .49156 m
.40891 .50877 L
s
.292 .417 .795 r
.38335 .48658 m .36954 .47867 L .38213 .46047 L p F P
0 0 0 r
s
.978 .287 .123 r
.5 .38446 m .52503 .3903 L .52734 .3888 L closepath p F P
0 0 0 r
s
.292 .431 .844 r
.5 .38446 m .47497 .3903 L .47266 .3888 L closepath p F P
0 0 0 r
s
.815 .235 .102 r
.60309 .41667 m .59409 .42216 L .61352 .43685 L p F P
0 0 0 r
s
.858 .248 .108 r
.59409 .42216 m .60309 .41667 L .57942 .40507 L p F P
0 0 0 r
s
.298 .43 .827 r
.39691 .41667 m .40591 .42216 L .38648 .43685 L p F P
0 0 0 r
s
.299 .434 .837 r
.40591 .42216 m .39691 .41667 L .42058 .40507 L p F P
0 0 0 r
s
.319 .081 .039 r
.55558 .61914 m .56997 .61158 L .57189 .59567 L p F P
0 0 0 r
s
.319 .081 .039 r
.58689 .58768 m .57189 .59567 L .56997 .61158 L p F P
0 0 0 r
s
.83 .24 .1 r
.54059 .61625 m
.57011 .60059 L
s
.57011 .60059 m
.57144 .57715 L
s
.232 .315 .578 r
.44442 .61914 m .43003 .61158 L .42811 .59567 L p F P
0 0 0 r
s
.232 .315 .578 r
.41311 .58768 m .42811 .59567 L .43003 .61158 L p F P
0 0 0 r
s
.24 .35 .67 r
.42989 .60059 m
.45941 .61625 L
s
.42856 .57715 m
.42989 .60059 L
s
.898 .261 .113 r
.55863 .39278 m .554 .39572 L .57942 .40507 L p F P
0 0 0 r
s
.938 .274 .118 r
.554 .39572 m .55863 .39278 L .52965 .38731 L p F P
0 0 0 r
s
.24 .35 .67 r
.54839 .39427 m
.54903 .394 L
s
.938 .274 .118 r
.52965 .38731 m .52734 .3888 L .554 .39572 L p F P
0 0 0 r
s
.298 .435 .844 r
.44137 .39278 m .446 .39572 L .42058 .40507 L p F P
0 0 0 r
s
.296 .435 .847 r
.446 .39572 m .44137 .39278 L .47035 .38731 L p F P
0 0 0 r
s
.83 .24 .1 r
.45097 .394 m
.45161 .39427 L
s
.296 .435 .847 r
.47035 .38731 m .47266 .3888 L .446 .39572 L p F P
0 0 0 r
s
.978 .287 .123 r
.5 .38446 m .52734 .3888 L .52965 .38731 L closepath p F P
0 0 0 r
s
.292 .431 .844 r
.5 .38446 m .47266 .3888 L .47035 .38731 L closepath p F P
0 0 0 r
s
.721 .205 .091 r
.63044 .45311 m .61787 .46047 L .63046 .47867 L p F P
0 0 0 r
s
.83 .24 .1 r
.61026 .46465 m
.62132 .49156 L
s
.77 .221 .097 r
.61787 .46047 m .63044 .45311 L .61352 .43685 L p F P
0 0 0 r
s
.292 .417 .795 r
.36956 .45311 m .38213 .46047 L .36954 .47867 L p F P
0 0 0 r
s
.24 .35 .67 r
.37868 .49156 m
.38974 .46465 L
s
.296 .424 .813 r
.38213 .46047 m .36956 .45311 L .38648 .43685 L p F P
0 0 0 r
s
.858 .248 .108 r
.58633 .40077 m .57942 .40507 L .60309 .41667 L p F P
0 0 0 r
s
.898 .261 .113 r
.57942 .40507 m .58633 .40077 L .55863 .39278 L p F P
0 0 0 r
s
.24 .35 .67 r
.56917 .39525 m
.57063 .39624 L
s
.299 .434 .837 r
.41367 .40077 m .42058 .40507 L .39691 .41667 L p F P
0 0 0 r
s
.298 .435 .844 r
.42058 .40507 m .41367 .40077 L .44137 .39278 L p F P
0 0 0 r
s
.83 .24 .1 r
.42937 .39624 m
.43083 .39525 L
s
.938 .274 .118 r
.53197 .38581 m .52965 .38731 L .55863 .39278 L p F P
0 0 0 r
s
.978 .287 .123 r
.5 .38446 m .52965 .38731 L .53197 .38581 L closepath p F P
0 0 0 r
s
.296 .435 .847 r
.46803 .38581 m .47035 .38731 L .44137 .39278 L p F P
0 0 0 r
s
.292 .431 .844 r
.5 .38446 m .47035 .38731 L .46803 .38581 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.47253 .3828 m .47479 .38129 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.47028 .3843 m .47253 .3828 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.46803 .38581 m .47028 .3843 L .5 .38446 L closepath p F P
0 0 0 r
s
.284 .424 .834 r
.52747 .3828 m .52521 .38129 L .5 .38446 L closepath p F P
0 0 0 r
s
.284 .424 .834 r
.52972 .3843 m .52747 .3828 L .5 .38446 L closepath p F P
0 0 0 r
s
.284 .424 .834 r
.53197 .38581 m .52972 .3843 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.48617 .37368 m .48846 .37215 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.48388 .37521 m .48617 .37368 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.4816 .37673 m .48388 .37521 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.47933 .37826 m .4816 .37673 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.47706 .37977 m .47933 .37826 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.47479 .38129 m .47706 .37977 L .5 .38446 L closepath p F P
0 0 0 r
s
.284 .424 .834 r
.51383 .37368 m .51154 .37215 L .5 .38446 L closepath p F P
0 0 0 r
s
.284 .424 .834 r
.51612 .37521 m .51383 .37368 L .5 .38446 L closepath p F P
0 0 0 r
s
.284 .424 .834 r
.5184 .37673 m .51612 .37521 L .5 .38446 L closepath p F P
0 0 0 r
s
.284 .424 .834 r
.52067 .37826 m .5184 .37673 L .5 .38446 L closepath p F P
0 0 0 r
s
.284 .424 .834 r
.52294 .37977 m .52067 .37826 L .5 .38446 L closepath p F P
0 0 0 r
s
.284 .424 .834 r
.52521 .38129 m .52294 .37977 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.49768 .36599 m .5 .36444 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.49537 .36754 m .49768 .36599 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.49306 .36908 m .49537 .36754 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.49076 .37062 m .49306 .36908 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.48846 .37215 m .49076 .37062 L .5 .38446 L closepath p F P
0 0 0 r
s
.284 .424 .834 r
.50232 .36599 m .5 .36444 L .5 .38446 L closepath p F P
0 0 0 r
s
.284 .424 .834 r
.50463 .36754 m .50232 .36599 L .5 .38446 L closepath p F P
0 0 0 r
s
.284 .424 .834 r
.50694 .36908 m .50463 .36754 L .5 .38446 L closepath p F P
0 0 0 r
s
.284 .424 .834 r
.50924 .37062 m .50694 .36908 L .5 .38446 L closepath p F P
0 0 0 r
s
.284 .424 .834 r
.51154 .37215 m .50924 .37062 L .5 .38446 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.48937 .37916 m
.51052 .39306 L
s
.24 .35 .67 r
.48948 .39306 m
.51063 .37916 L
s
.77 .221 .097 r
.62449 .43029 m .61352 .43685 L .63044 .45311 L p F P
0 0 0 r
s
.815 .235 .102 r
.61352 .43685 m .62449 .43029 L .60309 .41667 L p F P
0 0 0 r
s
.296 .424 .813 r
.37551 .43029 m .38648 .43685 L .36956 .45311 L p F P
0 0 0 r
s
.298 .43 .827 r
.38648 .43685 m .37551 .43029 L .39691 .41667 L p F P
0 0 0 r
s
.898 .261 .113 r
.56328 .38982 m .55863 .39278 L .58633 .40077 L p F P
0 0 0 r
s
.938 .274 .118 r
.55863 .39278 m .56328 .38982 L .53197 .38581 L p F P
0 0 0 r
s
.83 .24 .1 r
.56025 .39241 m
.57919 .41421 L
s
.53085 .41108 m
.56025 .39241 L
s
.298 .435 .844 r
.43672 .38982 m .44137 .39278 L .41367 .40077 L p F P
0 0 0 r
s
.296 .435 .847 r
.44137 .39278 m .43672 .38982 L .46803 .38581 L p F P
0 0 0 r
s
.24 .35 .67 r
.42081 .41421 m
.43975 .39241 L
s
.43975 .39241 m
.46915 .41108 L
s
1 .312 .132 r
.47028 .3843 m .46803 .38581 L .43672 .38982 L p F P
0 0 0 r
s
.271 .409 .811 r
.52972 .3843 m .53197 .38581 L .56328 .38982 L p F P
0 0 0 r
s
.1 .028 .011 r
.51191 .66148 m .52397 .65527 L .52602 .64616 L p F P
0 0 0 r
s
.1 .028 .011 r
.53928 .63926 m .52602 .64616 L .52397 .65527 L p F P
0 0 0 r
s
.83 .24 .1 r
.50563 .65186 m
.53462 .63673 L
s
.156 .195 .345 r
.48809 .66148 m .47603 .65527 L .47398 .64616 L p F P
0 0 0 r
s
.156 .195 .345 r
.46072 .63926 m .47398 .64616 L .47603 .65527 L p F P
0 0 0 r
s
.24 .35 .67 r
.46538 .63673 m
.49437 .65186 L
s
.83 .24 .1 r
.30815 .74169 m
.2847 .73146 L
s
.33466 .72765 m
.30815 .74169 L
s
.24 .35 .67 r
.69185 .74169 m
.7153 .73146 L
s
.66534 .72765 m
.69185 .74169 L
s
.83 .24 .1 r
.49513 .66855 m
.49846 .66683 L
s
.24 .35 .67 r
.50154 .66683 m
.50487 .66855 L
s
.215 .055 .025 r
.53928 .63926 m .55273 .63228 L .55558 .61914 L p F P
0 0 0 r
s
.215 .055 .025 r
.56997 .61158 m .55558 .61914 L .55273 .63228 L p F P
0 0 0 r
s
.199 .262 .472 r
.46072 .63926 m .44727 .63228 L .44442 .61914 L p F P
0 0 0 r
s
.199 .262 .472 r
.43003 .61158 m .44442 .61914 L .44727 .63228 L p F P
0 0 0 r
s
.815 .235 .102 r
.61216 .41113 m .60309 .41667 L .62449 .43029 L p F P
0 0 0 r
s
.858 .248 .108 r
.60309 .41667 m .61216 .41113 L .58633 .40077 L p F P
0 0 0 r
s
.298 .43 .827 r
.38784 .41113 m .39691 .41667 L .37551 .43029 L p F P
0 0 0 r
s
.299 .434 .837 r
.39691 .41667 m .38784 .41113 L .41367 .40077 L p F P
0 0 0 r
s
1 .312 .132 r
.47253 .3828 m .47028 .3843 L .4411 .38685 L p F P
0 0 0 r
s
1 .312 .132 r
.43672 .38982 m .4411 .38685 L .47028 .3843 L p F P
0 0 0 r
s
.271 .409 .811 r
.52747 .3828 m .52972 .3843 L .5589 .38685 L p F P
0 0 0 r
s
.271 .409 .811 r
.56328 .38982 m .5589 .38685 L .52972 .3843 L p F P
0 0 0 r
s
.83 .24 .1 r
.43384 .70229 m
.45199 .69539 L
s
.48066 .68066 m
.45199 .69539 L
s
.24 .35 .67 r
.56616 .70229 m
.54801 .69539 L
s
.51934 .68066 m
.54801 .69539 L
s
.528 .145 .066 r
.60244 .56147 m .61795 .55308 L .61556 .53388 L p F P
0 0 0 r
s
.528 .145 .066 r
.63096 .5254 m .61556 .53388 L .61795 .55308 L p F P
0 0 0 r
s
.604 .168 .076 r
.61556 .53388 m .63096 .5254 L .62522 .50594 L p F P
0 0 0 r
s
.269 .375 .705 r
.39756 .56147 m .38205 .55308 L .38444 .53388 L p F P
0 0 0 r
s
.269 .375 .705 r
.36904 .5254 m .38444 .53388 L .38205 .55308 L p F P
0 0 0 r
s
.28 .394 .743 r
.38444 .53388 m .36904 .5254 L .37478 .50594 L p F P
0 0 0 r
s
.858 .248 .108 r
.59328 .39644 m .58633 .40077 L .61216 .41113 L p F P
0 0 0 r
s
.24 .35 .67 r
.6049 .40548 m
.60877 .40488 L
s
.60877 .40488 m
.6358 .4234 L
s
.898 .261 .113 r
.58633 .40077 m .59328 .39644 L .56328 .38982 L p F P
0 0 0 r
s
.299 .434 .837 r
.40672 .39644 m .41367 .40077 L .38784 .41113 L p F P
0 0 0 r
s
.83 .24 .1 r
.39123 .40488 m
.3951 .40548 L
s
.3642 .4234 m
.39123 .40488 L
s
.298 .435 .844 r
.41367 .40077 m .40672 .39644 L .43672 .38982 L p F P
0 0 0 r
s
1 .32 .135 r
.4411 .38685 m .43672 .38982 L .40672 .39644 L p F P
0 0 0 r
s
.83 .24 .1 r
.43473 .39261 m
.43961 .38932 L
s
.24 .35 .67 r
.43456 .38912 m
.43975 .39241 L
s
.83 .24 .1 r
.43961 .38932 m
.44747 .39256 L
s
.25 .383 .767 r
.5589 .38685 m .56328 .38982 L .59328 .39644 L p F P
0 0 0 r
s
.24 .35 .67 r
.56039 .38932 m
.56527 .39261 L
s
.83 .24 .1 r
.56025 .39241 m
.56544 .38912 L
s
.24 .35 .67 r
.55253 .39256 m
.56039 .38932 L
s
.604 .168 .076 r
.64011 .49757 m .62522 .50594 L .63096 .5254 L p F P
0 0 0 r
s
.83 .24 .1 r
.59825 .53532 m
.62882 .51837 L
s
.667 .188 .084 r
.62522 .50594 m .64011 .49757 L .63046 .47867 L p F P
0 0 0 r
s
.83 .24 .1 r
.62132 .49156 m
.62882 .51837 L
s
.28 .394 .743 r
.35989 .49757 m .37478 .50594 L .36904 .5254 L p F P
0 0 0 r
s
.24 .35 .67 r
.37118 .51837 m
.40175 .53532 L
s
.287 .407 .773 r
.37478 .50594 m .35989 .49757 L .36954 .47867 L p F P
0 0 0 r
s
.24 .35 .67 r
.37118 .51837 m
.37868 .49156 L
s
.83 .24 .1 r
.33466 .72765 m
.35751 .73219 L
s
.3848 .71799 m
.35751 .73219 L
s
.24 .35 .67 r
.66534 .72765 m
.64249 .73219 L
s
.6152 .71799 m
.64249 .73219 L
s
1 .312 .132 r
.47479 .38129 m .47253 .3828 L .44551 .38387 L p F P
0 0 0 r
s
1 .312 .132 r
.4411 .38685 m .44551 .38387 L .47253 .3828 L p F P
0 0 0 r
s
.271 .409 .811 r
.52521 .38129 m .52747 .3828 L .55449 .38387 L p F P
0 0 0 r
s
.271 .409 .811 r
.5589 .38685 m .55449 .38387 L .52747 .3828 L p F P
0 0 0 r
s
.435 .116 .054 r
.58689 .58768 m .60212 .57957 L .60244 .56147 L p F P
0 0 0 r
s
.83 .24 .1 r
.57144 .57715 m
.60147 .56088 L
s
.435 .116 .054 r
.61795 .55308 m .60244 .56147 L .60212 .57957 L p F P
0 0 0 r
s
.254 .35 .652 r
.41311 .58768 m .39788 .57957 L .39756 .56147 L p F P
0 0 0 r
s
.24 .35 .67 r
.39853 .56088 m
.42856 .57715 L
s
.254 .35 .652 r
.38205 .55308 m .39756 .56147 L .39788 .57957 L p F P
0 0 0 r
s
.83 .24 .1 r
.3848 .71799 m
.40583 .71672 L
s
.43384 .70229 m
.40583 .71672 L
s
.24 .35 .67 r
.6152 .71799 m
.59417 .71672 L
s
.56616 .70229 m
.59417 .71672 L
s
.083 .024 .01 r
.51191 .66148 m .5 .66762 L .5 .67186 L p F P
0 0 0 r
s
.111 .126 .238 r
.48809 .66148 m .5 .66762 L .5 .67186 L p F P
0 0 0 r
s
.667 .188 .084 r
.64445 .47065 m .63046 .47867 L .64011 .49757 L p F P
0 0 0 r
s
.721 .205 .091 r
.63046 .47867 m .64445 .47065 L .63044 .45311 L p F P
0 0 0 r
s
.287 .407 .773 r
.35555 .47065 m .36954 .47867 L .35989 .49757 L p F P
0 0 0 r
s
.292 .417 .795 r
.36954 .47867 m .35555 .47065 L .36956 .45311 L p F P
0 0 0 r
s
.83 .24 .1 r
.2205 .54413 m
.19559 .56088 L
s
.19471 .58696 m
.19559 .56088 L
s
.24 .35 .67 r
.7795 .54413 m
.80441 .56088 L
s
.80529 .58696 m
.80441 .56088 L
s
1 .312 .132 r
.47706 .37977 m .47479 .38129 L .44993 .38087 L p F P
0 0 0 r
s
1 .312 .132 r
.44551 .38387 m .44993 .38087 L .47479 .38129 L p F P
0 0 0 r
s
.24 .35 .67 r
.47201 .3817 m
.48948 .39306 L
s
.271 .409 .811 r
.52294 .37977 m .52521 .38129 L .55007 .38087 L p F P
0 0 0 r
s
.271 .409 .811 r
.55449 .38387 m .55007 .38087 L .52521 .38129 L p F P
0 0 0 r
s
.83 .24 .1 r
.51052 .39306 m
.52799 .3817 L
s
.721 .205 .091 r
.64315 .44568 m .63044 .45311 L .64445 .47065 L p F P
0 0 0 r
s
.77 .221 .097 r
.63044 .45311 m .64315 .44568 L .62449 .43029 L p F P
0 0 0 r
s
.83 .24 .1 r
.61026 .46465 m
.64108 .44661 L
s
.292 .417 .795 r
.35685 .44568 m .36956 .45311 L .35555 .47065 L p F P
0 0 0 r
s
.296 .424 .813 r
.36956 .45311 m .35685 .44568 L .37551 .43029 L p F P
0 0 0 r
s
.24 .35 .67 r
.35892 .44661 m
.38974 .46465 L
s
1 .32 .135 r
.44551 .38387 m .4411 .38685 L .41309 .39208 L p F P
0 0 0 r
s
1 .32 .135 r
.40672 .39644 m .41309 .39208 L .4411 .38685 L p F P
0 0 0 r
s
.24 .35 .67 r
.43975 .39241 m
.4472 .38568 L
s
.25 .383 .767 r
.55449 .38387 m .5589 .38685 L .58691 .39208 L p F P
0 0 0 r
s
.25 .383 .767 r
.59328 .39644 m .58691 .39208 L .5589 .38685 L p F P
0 0 0 r
s
.83 .24 .1 r
.5528 .38568 m
.56025 .39241 L
s
.319 .081 .039 r
.56997 .61158 m .58456 .60391 L .58689 .58768 L p F P
0 0 0 r
s
.319 .081 .039 r
.60212 .57957 m .58689 .58768 L .58456 .60391 L p F P
0 0 0 r
s
.232 .315 .578 r
.43003 .61158 m .41544 .60391 L .41311 .58768 L p F P
0 0 0 r
s
.232 .315 .578 r
.39788 .57957 m .41311 .58768 L .41544 .60391 L p F P
0 0 0 r
s
1 .312 .132 r
.47933 .37826 m .47706 .37977 L .45438 .37786 L p F P
0 0 0 r
s
1 .312 .132 r
.44993 .38087 m .45438 .37786 L .47706 .37977 L p F P
0 0 0 r
s
.83 .24 .1 r
.4722 .39056 m
.48937 .37916 L
s
.271 .409 .811 r
.52067 .37826 m .52294 .37977 L .54562 .37786 L p F P
0 0 0 r
s
.271 .409 .811 r
.55007 .38087 m .54562 .37786 L .52294 .37977 L p F P
0 0 0 r
s
.24 .35 .67 r
.51063 .37916 m
.5278 .39056 L
s
.77 .221 .097 r
.63557 .42367 m .62449 .43029 L .64315 .44568 L p F P
0 0 0 r
s
.815 .235 .102 r
.62449 .43029 m .63557 .42367 L .61216 .41113 L p F P
0 0 0 r
s
.296 .424 .813 r
.36443 .42367 m .37551 .43029 L .35685 .44568 L p F P
0 0 0 r
s
.298 .43 .827 r
.37551 .43029 m .36443 .42367 L .38784 .41113 L p F P
0 0 0 r
s
.83 .24 .1 r
.30151 .45274 m
.28765 .46669 L
s
.24 .35 .67 r
.69849 .45274 m
.71235 .46669 L
s
.83 .24 .1 r
.25161 .50362 m
.22619 .521 L
s
.22619 .521 m
.2205 .54413 L
s
.24 .35 .67 r
.74839 .50362 m
.77381 .521 L
s
.77381 .521 m
.7795 .54413 L
s
.858 .248 .108 r
.61216 .41113 m .62132 .40554 L .59328 .39644 L p F P
0 0 0 r
s
1 .322 .134 r
.41309 .39208 m .40672 .39644 L .37868 .40554 L p F P
0 0 0 r
s
.299 .434 .837 r
.38784 .41113 m .37868 .40554 L .40672 .39644 L p F P
0 0 0 r
s
.24 .35 .67 r
.3966 .39923 m
.42081 .41421 L
s
.215 .337 .686 r
.58691 .39208 m .59328 .39644 L .62132 .40554 L p F P
0 0 0 r
s
.83 .24 .1 r
.57919 .41421 m
.6034 .39923 L
s
.815 .235 .102 r
.62132 .40554 m .61216 .41113 L .63557 .42367 L p F P
0 0 0 r
s
.83 .24 .1 r
.59605 .43857 m
.62662 .42017 L
s
.298 .43 .827 r
.37868 .40554 m .38784 .41113 L .36443 .42367 L p F P
0 0 0 r
s
.24 .35 .67 r
.37338 .42017 m
.40395 .43857 L
s
.83 .24 .1 r
.28765 .46669 m
.26169 .48462 L
s
.26169 .48462 m
.25161 .50362 L
s
.24 .35 .67 r
.71235 .46669 m
.73831 .48462 L
s
.73831 .48462 m
.74839 .50362 L
s
1 .312 .132 r
.4816 .37673 m .47933 .37826 L .45885 .37484 L p F P
0 0 0 r
s
1 .312 .132 r
.45438 .37786 m .45885 .37484 L .47933 .37826 L p F P
0 0 0 r
s
.271 .409 .811 r
.5184 .37673 m .52067 .37826 L .54115 .37484 L p F P
0 0 0 r
s
.271 .409 .811 r
.54562 .37786 m .54115 .37484 L .52067 .37826 L p F P
0 0 0 r
s
1 .32 .135 r
.44993 .38087 m .44551 .38387 L .41951 .38769 L p F P
0 0 0 r
s
.24 .35 .67 r
.4299 .38616 m
.43177 .38735 L
s
1 .32 .135 r
.41309 .39208 m .41951 .38769 L .44551 .38387 L p F P
0 0 0 r
s
.25 .383 .767 r
.55007 .38087 m .55449 .38387 L .58049 .38769 L p F P
0 0 0 r
s
.83 .24 .1 r
.56823 .38735 m
.5701 .38616 L
s
.25 .383 .767 r
.58691 .39208 m .58049 .38769 L .55449 .38387 L p F P
0 0 0 r
s
.1 .028 .011 r
.52397 .65527 m .53618 .64897 L .53928 .63926 L p F P
0 0 0 r
s
.1 .028 .011 r
.55273 .63228 m .53928 .63926 L .53618 .64897 L p F P
0 0 0 r
s
.156 .195 .345 r
.47603 .65527 m .46382 .64897 L .46072 .63926 L p F P
0 0 0 r
s
.156 .195 .345 r
.44727 .63228 m .46072 .63926 L .46382 .64897 L p F P
0 0 0 r
s
1 .312 .132 r
.48388 .37521 m .4816 .37673 L .46334 .3718 L p F P
0 0 0 r
s
1 .312 .132 r
.45885 .37484 m .46334 .3718 L .4816 .37673 L p F P
0 0 0 r
s
.271 .409 .811 r
.51612 .37521 m .5184 .37673 L .53666 .3718 L p F P
0 0 0 r
s
.271 .409 .811 r
.54115 .37484 m .53666 .3718 L .5184 .37673 L p F P
0 0 0 r
s
.215 .055 .025 r
.55273 .63228 m .56635 .6252 L .56997 .61158 L p F P
0 0 0 r
s
.215 .055 .025 r
.58456 .60391 m .56997 .61158 L .56635 .6252 L p F P
0 0 0 r
s
.83 .24 .1 r
.56447 .62114 m
.57011 .60059 L
s
.199 .262 .472 r
.44727 .63228 m .43365 .6252 L .43003 .61158 L p F P
0 0 0 r
s
.199 .262 .472 r
.41544 .60391 m .43003 .61158 L .43365 .6252 L p F P
0 0 0 r
s
.24 .35 .67 r
.42989 .60059 m
.43553 .62114 L
s
1 .312 .132 r
.48617 .37368 m .48388 .37521 L .46785 .36874 L p F P
0 0 0 r
s
1 .312 .132 r
.46334 .3718 m .46785 .36874 L .48388 .37521 L p F P
0 0 0 r
s
.271 .409 .811 r
.51383 .37368 m .51612 .37521 L .53215 .36874 L p F P
0 0 0 r
s
.271 .409 .811 r
.53666 .3718 m .53215 .36874 L .51612 .37521 L p F P
0 0 0 r
s
1 .322 .134 r
.41951 .38769 m .41309 .39208 L .38685 .39991 L p F P
0 0 0 r
s
1 .322 .134 r
.37868 .40554 m .38685 .39991 L .41309 .39208 L p F P
0 0 0 r
s
.24 .35 .67 r
.39043 .39541 m
.39361 .39738 L
s
.215 .337 .686 r
.58049 .38769 m .58691 .39208 L .61315 .39991 L p F P
0 0 0 r
s
.215 .337 .686 r
.62132 .40554 m .61315 .39991 L .58691 .39208 L p F P
0 0 0 r
s
.83 .24 .1 r
.60639 .39738 m
.60957 .39541 L
s
.083 .024 .01 r
.5 .67186 m .51059 .66642 L .51191 .66148 L p F P
0 0 0 r
s
.24 .35 .67 r
.50547 .66905 m
.51934 .68066 L
s
.083 .024 .01 r
.52397 .65527 m .51191 .66148 L .51059 .66642 L p F P
0 0 0 r
s
.111 .126 .238 r
.5 .67186 m .48941 .66642 L .48809 .66148 L p F P
0 0 0 r
s
.83 .24 .1 r
.48066 .68066 m
.49453 .66905 L
s
.111 .126 .238 r
.47603 .65527 m .48809 .66148 L .48941 .66642 L p F P
0 0 0 r
s
.83 .24 .1 r
.60957 .39541 m
.6125 .39967 L
s
.24 .35 .67 r
.3875 .39967 m
.39043 .39541 L
s
1 .32 .135 r
.45438 .37786 m .44993 .38087 L .42596 .38327 L p F P
0 0 0 r
s
1 .32 .135 r
.41951 .38769 m .42596 .38327 L .44993 .38087 L p F P
0 0 0 r
s
.25 .383 .767 r
.54562 .37786 m .55007 .38087 L .57404 .38327 L p F P
0 0 0 r
s
.25 .383 .767 r
.58049 .38769 m .57404 .38327 L .55007 .38087 L p F P
0 0 0 r
s
.528 .145 .066 r
.61795 .55308 m .63368 .54456 L .63096 .5254 L p F P
0 0 0 r
s
.528 .145 .066 r
.64658 .51679 m .63096 .5254 L .63368 .54456 L p F P
0 0 0 r
s
.604 .168 .076 r
.63096 .5254 m .64658 .51679 L .64011 .49757 L p F P
0 0 0 r
s
.83 .24 .1 r
.62882 .51837 m
.6324 .54413 L
s
.269 .375 .705 r
.38205 .55308 m .36632 .54456 L .36904 .5254 L p F P
0 0 0 r
s
.269 .375 .705 r
.35342 .51679 m .36904 .5254 L .36632 .54456 L p F P
0 0 0 r
s
.28 .394 .743 r
.36904 .5254 m .35342 .51679 L .35989 .49757 L p F P
0 0 0 r
s
.24 .35 .67 r
.3676 .54413 m
.37118 .51837 L
s
.604 .168 .076 r
.65522 .48909 m .64011 .49757 L .64658 .51679 L p F P
0 0 0 r
s
.667 .188 .084 r
.64011 .49757 m .65522 .48909 L .64445 .47065 L p F P
0 0 0 r
s
.28 .394 .743 r
.34478 .48909 m .35989 .49757 L .35342 .51679 L p F P
0 0 0 r
s
.287 .407 .773 r
.35989 .49757 m .34478 .48909 L .35555 .47065 L p F P
0 0 0 r
s
1 .312 .132 r
.48846 .37215 m .48617 .37368 L .47237 .36568 L p F P
0 0 0 r
s
1 .312 .132 r
.46785 .36874 m .47237 .36568 L .48617 .37368 L p F P
0 0 0 r
s
.271 .409 .811 r
.51154 .37215 m .51383 .37368 L .52763 .36568 L p F P
0 0 0 r
s
.271 .409 .811 r
.53215 .36874 m .52763 .36568 L .51383 .37368 L p F P
0 0 0 r
s
.667 .188 .084 r
.65863 .46252 m .64445 .47065 L .65522 .48909 L p F P
0 0 0 r
s
.83 .24 .1 r
.62132 .49156 m
.65245 .47383 L
s
.721 .205 .091 r
.64445 .47065 m .65863 .46252 L .64315 .44568 L p F P
0 0 0 r
s
.287 .407 .773 r
.34137 .46252 m .35555 .47065 L .34478 .48909 L p F P
0 0 0 r
s
.24 .35 .67 r
.34755 .47383 m
.37868 .49156 L
s
.292 .417 .795 r
.35555 .47065 m .34137 .46252 L .35685 .44568 L p F P
0 0 0 r
s
.815 .235 .102 r
.63557 .42367 m .64677 .41697 L .62132 .40554 L p F P
0 0 0 r
s
.298 .43 .827 r
.36443 .42367 m .35323 .41697 L .37868 .40554 L p F P
0 0 0 r
s
1 .308 .127 r
.38685 .39991 m .37868 .40554 L .35323 .41697 L p F P
0 0 0 r
s
.24 .35 .67 r
.37338 .42017 m
.38554 .40251 L
s
.159 .261 .547 r
.61315 .39991 m .62132 .40554 L .64677 .41697 L p F P
0 0 0 r
s
.83 .24 .1 r
.61446 .40251 m
.62662 .42017 L
s
.435 .116 .054 r
.60212 .57957 m .61757 .57134 L .61795 .55308 L p F P
0 0 0 r
s
.435 .116 .054 r
.63368 .54456 m .61795 .55308 L .61757 .57134 L p F P
0 0 0 r
s
.254 .35 .652 r
.39788 .57957 m .38243 .57134 L .38205 .55308 L p F P
0 0 0 r
s
.254 .35 .652 r
.36632 .54456 m .38205 .55308 L .38243 .57134 L p F P
0 0 0 r
s
.721 .205 .091 r
.65602 .43815 m .64315 .44568 L .65863 .46252 L p F P
0 0 0 r
s
.77 .221 .097 r
.64315 .44568 m .65602 .43815 L .63557 .42367 L p F P
0 0 0 r
s
.24 .35 .67 r
.64418 .41852 m
.65506 .42604 L
s
.83 .24 .1 r
.62662 .42017 m
.64108 .44661 L
s
.292 .417 .795 r
.34398 .43815 m .35685 .44568 L .34137 .46252 L p F P
0 0 0 r
s
.296 .424 .813 r
.35685 .44568 m .34398 .43815 L .36443 .42367 L p F P
0 0 0 r
s
.83 .24 .1 r
.34494 .42604 m
.35582 .41852 L
s
.24 .35 .67 r
.35892 .44661 m
.37338 .42017 L
s
.83 .24 .1 r
.64108 .44661 m
.65245 .47383 L
s
.24 .35 .67 r
.34755 .47383 m
.35892 .44661 L
s
.77 .221 .097 r
.64677 .41697 m .63557 .42367 L .65602 .43815 L p F P
0 0 0 r
s
.296 .424 .813 r
.35323 .41697 m .36443 .42367 L .34398 .43815 L p F P
0 0 0 r
s
1 .312 .132 r
.49076 .37062 m .48846 .37215 L .47693 .3626 L p F P
0 0 0 r
s
1 .312 .132 r
.47237 .36568 m .47693 .3626 L .48846 .37215 L p F P
0 0 0 r
s
.271 .409 .811 r
.50924 .37062 m .51154 .37215 L .52307 .3626 L p F P
0 0 0 r
s
.271 .409 .811 r
.52763 .36568 m .52307 .3626 L .51154 .37215 L p F P
0 0 0 r
s
.83 .24 .1 r
.2847 .73146 m
.26183 .71564 L
s
.31115 .71712 m
.2847 .73146 L
s
.24 .35 .67 r
.7153 .73146 m
.73817 .71564 L
s
.68885 .71712 m
.7153 .73146 L
s
1 .32 .135 r
.45885 .37484 m .45438 .37786 L .43246 .37882 L p F P
0 0 0 r
s
1 .32 .135 r
.42596 .38327 m .43246 .37882 L .45438 .37786 L p F P
0 0 0 r
s
.25 .383 .767 r
.54115 .37484 m .54562 .37786 L .56754 .37882 L p F P
0 0 0 r
s
.25 .383 .767 r
.57404 .38327 m .56754 .37882 L .54562 .37786 L p F P
0 0 0 r
s
1 .312 .132 r
.49306 .36908 m .49076 .37062 L .4815 .3595 L p F P
0 0 0 r
s
1 .312 .132 r
.47693 .3626 m .4815 .3595 L .49076 .37062 L p F P
0 0 0 r
s
.83 .24 .1 r
.46816 .37001 m
.48937 .37916 L
s
.271 .409 .811 r
.50694 .36908 m .50924 .37062 L .5185 .3595 L p F P
0 0 0 r
s
.271 .409 .811 r
.52307 .3626 m .5185 .3595 L .50924 .37062 L p F P
0 0 0 r
s
.24 .35 .67 r
.51063 .37916 m
.53184 .37001 L
s
.319 .081 .039 r
.58456 .60391 m .59936 .59614 L .60212 .57957 L p F P
0 0 0 r
s
.319 .081 .039 r
.61757 .57134 m .60212 .57957 L .59936 .59614 L p F P
0 0 0 r
s
.83 .24 .1 r
.6005 .58447 m
.60147 .56088 L
s
.232 .315 .578 r
.41544 .60391 m .40064 .59614 L .39788 .57957 L p F P
0 0 0 r
s
.232 .315 .578 r
.38243 .57134 m .39788 .57957 L .40064 .59614 L p F P
0 0 0 r
s
.24 .35 .67 r
.39853 .56088 m
.3995 .58447 L
s
1 .322 .134 r
.42596 .38327 m .41951 .38769 L .3951 .39422 L p F P
0 0 0 r
s
1 .322 .134 r
.38685 .39991 m .3951 .39422 L .41951 .38769 L p F P
0 0 0 r
s
.215 .337 .686 r
.57404 .38327 m .58049 .38769 L .6049 .39422 L p F P
0 0 0 r
s
.215 .337 .686 r
.61315 .39991 m .6049 .39422 L .58049 .38769 L p F P
0 0 0 r
s
1 .312 .132 r
.49537 .36754 m .49306 .36908 L .48609 .35639 L p F P
0 0 0 r
s
1 .312 .132 r
.4815 .3595 m .48609 .35639 L .49306 .36908 L p F P
0 0 0 r
s
.271 .409 .811 r
.50463 .36754 m .50694 .36908 L .51391 .35639 L p F P
0 0 0 r
s
.83 .24 .1 r
.48937 .37916 m
.50683 .36755 L
s
.271 .409 .811 r
.5185 .3595 m .51391 .35639 L .50694 .36908 L p F P
0 0 0 r
s
.24 .35 .67 r
.49317 .36755 m
.51063 .37916 L
s
.83 .24 .1 r
.21986 .57043 m
.19471 .58696 L
s
.19906 .61486 m
.19471 .58696 L
s
.24 .35 .67 r
.78014 .57043 m
.80529 .58696 L
s
.80094 .61486 m
.80529 .58696 L
s
.1 .028 .011 r
.53618 .64897 m .54853 .6426 L .55273 .63228 L p F P
0 0 0 r
s
.1 .028 .011 r
.56635 .6252 m .55273 .63228 L .54853 .6426 L p F P
0 0 0 r
s
.83 .24 .1 r
.53462 .63673 m
.56447 .62114 L
s
.156 .195 .345 r
.46382 .64897 m .45147 .6426 L .44727 .63228 L p F P
0 0 0 r
s
.156 .195 .345 r
.43365 .6252 m .44727 .63228 L .45147 .6426 L p F P
0 0 0 r
s
.24 .35 .67 r
.43553 .62114 m
.46538 .63673 L
s
1 .32 .135 r
.46334 .3718 m .45885 .37484 L .43901 .37434 L p F P
0 0 0 r
s
1 .32 .135 r
.43246 .37882 m .43901 .37434 L .45885 .37484 L p F P
0 0 0 r
s
.25 .383 .767 r
.53666 .3718 m .54115 .37484 L .56099 .37434 L p F P
0 0 0 r
s
.25 .383 .767 r
.56754 .37882 m .56099 .37434 L .54115 .37484 L p F P
0 0 0 r
s
1 .312 .132 r
.49768 .36599 m .49537 .36754 L .49071 .35327 L p F P
0 0 0 r
s
1 .312 .132 r
.48609 .35639 m .49071 .35327 L .49537 .36754 L p F P
0 0 0 r
s
.271 .409 .811 r
.50232 .36599 m .50463 .36754 L .50929 .35327 L p F P
0 0 0 r
s
.271 .409 .811 r
.51391 .35639 m .50929 .35327 L .50463 .36754 L p F P
0 0 0 r
s
1 .308 .127 r
.3951 .39422 m .38685 .39991 L .36299 .41021 L p F P
0 0 0 r
s
1 .308 .127 r
.35323 .41697 m .36299 .41021 L .38685 .39991 L p F P
0 0 0 r
s
.24 .35 .67 r
.36148 .41301 m
.37338 .42017 L
s
.159 .261 .547 r
.6049 .39422 m .61315 .39991 L .63701 .41021 L p F P
0 0 0 r
s
.159 .261 .547 r
.64677 .41697 m .63701 .41021 L .61315 .39991 L p F P
0 0 0 r
s
.83 .24 .1 r
.62662 .42017 m
.63852 .41301 L
s
.083 .024 .01 r
.51059 .66642 m .52129 .66093 L .52397 .65527 L p F P
0 0 0 r
s
.083 .024 .01 r
.53618 .64897 m .52397 .65527 L .52129 .66093 L p F P
0 0 0 r
s
.83 .24 .1 r
.4988 .66665 m
.52441 .65343 L
s
.52441 .65343 m
.53462 .63673 L
s
.111 .126 .238 r
.48941 .66642 m .47871 .66093 L .47603 .65527 L p F P
0 0 0 r
s
.111 .126 .238 r
.46382 .64897 m .47603 .65527 L .47871 .66093 L p F P
0 0 0 r
s
.24 .35 .67 r
.47559 .65343 m
.5012 .66665 L
s
.46538 .63673 m
.47559 .65343 L
s
.215 .055 .025 r
.56635 .6252 m .58015 .61803 L .58456 .60391 L p F P
0 0 0 r
s
.215 .055 .025 r
.59936 .59614 m .58456 .60391 L .58015 .61803 L p F P
0 0 0 r
s
.83 .24 .1 r
.57011 .60059 m
.6005 .58447 L
s
.199 .262 .472 r
.43365 .6252 m .41985 .61803 L .41544 .60391 L p F P
0 0 0 r
s
.199 .262 .472 r
.40064 .59614 m .41544 .60391 L .41985 .61803 L p F P
0 0 0 r
s
.24 .35 .67 r
.3995 .58447 m
.42989 .60059 L
s
1 .312 .132 r
.5 .36444 m .49768 .36599 L .49534 .35013 L p F P
0 0 0 r
s
1 .312 .132 r
.49071 .35327 m .49534 .35013 L .49768 .36599 L p F P
0 0 0 r
s
.271 .409 .811 r
.5 .36444 m .50232 .36599 L .50466 .35013 L p F P
0 0 0 r
s
.271 .409 .811 r
.50929 .35327 m .50466 .35013 L .50232 .36599 L p F P
0 0 0 r
s
.83 .24 .1 r
.31115 .71712 m
.33466 .72765 L
s
.36197 .7132 m
.33466 .72765 L
s
.24 .35 .67 r
.68885 .71712 m
.66534 .72765 L
s
.63803 .7132 m
.66534 .72765 L
s
1 .322 .134 r
.43246 .37882 m .42596 .38327 L .40341 .38848 L p F P
0 0 0 r
s
.24 .35 .67 r
.40949 .3732 m
.4232 .3819 L
s
.42551 .38337 m
.42557 .38341 L
s
1 .322 .134 r
.3951 .39422 m .40341 .38848 L .42596 .38327 L p F P
0 0 0 r
s
.83 .24 .1 r
.39675 .40109 m
.41905 .38581 L
s
.41905 .38581 m
.43961 .38932 L
s
.24 .35 .67 r
.39043 .39541 m
.40949 .3732 L
s
.215 .337 .686 r
.56754 .37882 m .57404 .38327 L .59659 .38848 L p F P
0 0 0 r
s
.83 .24 .1 r
.57443 .38341 m
.57449 .38337 L
s
.5768 .3819 m
.59051 .3732 L
s
.215 .337 .686 r
.6049 .39422 m .59659 .38848 L .57404 .38327 L p F P
0 0 0 r
s
.24 .35 .67 r
.58095 .38581 m
.60325 .40109 L
s
.56039 .38932 m
.58095 .38581 L
s
.83 .24 .1 r
.59051 .3732 m
.60957 .39541 L
s
.77 .221 .097 r
.65602 .43815 m .66904 .43053 L .64677 .41697 L p F P
0 0 0 r
s
.296 .424 .813 r
.34398 .43815 m .33096 .43053 L .35323 .41697 L p F P
0 0 0 r
s
.862 .266 .108 r
.36299 .41021 m .35323 .41697 L .33096 .43053 L p F P
0 0 0 r
s
.119 .189 .415 r
.63701 .41021 m .64677 .41697 L .66904 .43053 L p F P
0 0 0 r
s
1 .32 .135 r
.46785 .36874 m .46334 .3718 L .4456 .36983 L p F P
0 0 0 r
s
.24 .35 .67 r
.45544 .37092 m
.45769 .37239 L
s
1 .32 .135 r
.43901 .37434 m .4456 .36983 L .46334 .3718 L p F P
0 0 0 r
s
.83 .24 .1 r
.43961 .38932 m
.46816 .37001 L
s
.25 .383 .767 r
.53215 .36874 m .53666 .3718 L .5544 .36983 L p F P
0 0 0 r
s
.83 .24 .1 r
.54231 .37239 m
.54456 .37092 L
s
.25 .383 .767 r
.56099 .37434 m .5544 .36983 L .53666 .3718 L p F P
0 0 0 r
s
.24 .35 .67 r
.53184 .37001 m
.56039 .38932 L
s
.721 .205 .091 r
.65863 .46252 m .67301 .45428 L .65602 .43815 L p F P
0 0 0 r
s
.721 .205 .091 r
.66904 .43053 m .65602 .43815 L .67301 .45428 L p F P
0 0 0 r
s
.24 .35 .67 r
.67195 .43435 m
.69849 .45274 L
s
.66948 .43313 m
.67195 .43435 L
s
.292 .417 .795 r
.34137 .46252 m .32699 .45428 L .34398 .43815 L p F P
0 0 0 r
s
.292 .417 .795 r
.33096 .43053 m .34398 .43815 L .32699 .45428 L p F P
0 0 0 r
s
.83 .24 .1 r
.30151 .45274 m
.32805 .43435 L
s
.32805 .43435 m
.33052 .43313 L
s
.62169 .35341 m
.59051 .3732 L
s
.24 .35 .67 r
.37831 .35341 m
.40949 .3732 L
s
.667 .188 .084 r
.65522 .48909 m .67055 .48048 L .65863 .46252 L p F P
0 0 0 r
s
.667 .188 .084 r
.67301 .45428 m .65863 .46252 L .67055 .48048 L p F P
0 0 0 r
s
.287 .407 .773 r
.34478 .48909 m .32945 .48048 L .34137 .46252 L p F P
0 0 0 r
s
.287 .407 .773 r
.32699 .45428 m .34137 .46252 L .32945 .48048 L p F P
0 0 0 r
s
.604 .168 .076 r
.64658 .51679 m .66244 .50806 L .65522 .48909 L p F P
0 0 0 r
s
.604 .168 .076 r
.67055 .48048 m .65522 .48909 L .66244 .50806 L p F P
0 0 0 r
s
.83 .24 .1 r
.65245 .47383 m
.66029 .50091 L
s
.28 .394 .743 r
.35342 .51679 m .33756 .50806 L .34478 .48909 L p F P
0 0 0 r
s
.28 .394 .743 r
.32945 .48048 m .34478 .48909 L .33756 .50806 L p F P
0 0 0 r
s
.24 .35 .67 r
.33971 .50091 m
.34755 .47383 L
s
1 .312 .132 r
.49534 .35013 m .5 .34697 L .5 .36444 L p F P
0 0 0 r
s
.271 .409 .811 r
.50466 .35013 m .5 .34697 L .5 .36444 L p F P
0 0 0 r
s
.83 .24 .1 r
.46269 .68742 m
.48066 .68066 L
s
.24 .35 .67 r
.53731 .68742 m
.51934 .68066 L
s
.528 .145 .066 r
.63368 .54456 m .64966 .53592 L .64658 .51679 L p F P
0 0 0 r
s
.528 .145 .066 r
.66244 .50806 m .64658 .51679 L .64966 .53592 L p F P
0 0 0 r
s
.83 .24 .1 r
.62882 .51837 m
.66029 .50091 L
s
.269 .375 .705 r
.36632 .54456 m .35034 .53592 L .35342 .51679 L p F P
0 0 0 r
s
.269 .375 .705 r
.33756 .50806 m .35342 .51679 L .35034 .53592 L p F P
0 0 0 r
s
.24 .35 .67 r
.33971 .50091 m
.37118 .51837 L
s
.83 .24 .1 r
.36197 .7132 m
.3848 .71799 L
s
.41291 .70336 m
.3848 .71799 L
s
.24 .35 .67 r
.63803 .7132 m
.6152 .71799 L
s
.58709 .70336 m
.6152 .71799 L
s
.83 .24 .1 r
.41291 .70336 m
.43384 .70229 L
s
.46269 .68742 m
.43384 .70229 L
s
.24 .35 .67 r
.58709 .70336 m
.56616 .70229 L
s
.53731 .68742 m
.56616 .70229 L
s
.435 .116 .054 r
.61757 .57134 m .63326 .56299 L .63368 .54456 L p F P
0 0 0 r
s
.83 .24 .1 r
.60147 .56088 m
.6324 .54413 L
s
.435 .116 .054 r
.64966 .53592 m .63368 .54456 L .63326 .56299 L p F P
0 0 0 r
s
.254 .35 .652 r
.38243 .57134 m .36674 .56299 L .36632 .54456 L p F P
0 0 0 r
s
.24 .35 .67 r
.3676 .54413 m
.39853 .56088 L
s
.254 .35 .652 r
.35034 .53592 m .36632 .54456 L .36674 .56299 L p F P
0 0 0 r
s
.83 .24 .1 r
.24616 .52688 m
.2205 .54413 L
s
.2205 .54413 m
.21986 .57043 L
s
.24 .35 .67 r
.75384 .52688 m
.7795 .54413 L
s
.7795 .54413 m
.78014 .57043 L
s
1 .32 .135 r
.47237 .36568 m .46785 .36874 L .45224 .36529 L p F P
0 0 0 r
s
1 .32 .135 r
.4456 .36983 m .45224 .36529 L .46785 .36874 L p F P
0 0 0 r
s
.24 .35 .67 r
.42993 .35433 m
.44958 .36711 L
s
.25 .383 .767 r
.52763 .36568 m .53215 .36874 L .54776 .36529 L p F P
0 0 0 r
s
.25 .383 .767 r
.5544 .36983 m .54776 .36529 L .53215 .36874 L p F P
0 0 0 r
s
.83 .24 .1 r
.55042 .36711 m
.57007 .35433 L
s
1 .308 .127 r
.40341 .38848 m .3951 .39422 L .37286 .40337 L p F P
0 0 0 r
s
1 .308 .127 r
.36299 .41021 m .37286 .40337 L .3951 .39422 L p F P
0 0 0 r
s
.83 .24 .1 r
.36164 .4145 m
.3721 .40727 L
s
.3721 .40727 m
.38581 .40556 L
s
.159 .261 .547 r
.59659 .38848 m .6049 .39422 L .62714 .40337 L p F P
0 0 0 r
s
.159 .261 .547 r
.63701 .41021 m .62714 .40337 L .6049 .39422 L p F P
0 0 0 r
s
.24 .35 .67 r
.6279 .40727 m
.63836 .4145 L
s
.61419 .40556 m
.6279 .40727 L
s
1 .322 .134 r
.43901 .37434 m .43246 .37882 L .41181 .3827 L p F P
0 0 0 r
s
1 .322 .134 r
.40341 .38848 m .41181 .3827 L .43246 .37882 L p F P
0 0 0 r
s
.215 .337 .686 r
.56099 .37434 m .56754 .37882 L .58819 .3827 L p F P
0 0 0 r
s
.215 .337 .686 r
.59659 .38848 m .58819 .3827 L .56754 .37882 L p F P
0 0 0 r
s
.319 .081 .039 r
.59936 .59614 m .61437 .58826 L .61757 .57134 L p F P
0 0 0 r
s
.319 .081 .039 r
.63326 .56299 m .61757 .57134 L .61437 .58826 L p F P
0 0 0 r
s
.232 .315 .578 r
.40064 .59614 m .38563 .58826 L .38243 .57134 L p F P
0 0 0 r
s
.232 .315 .578 r
.36674 .56299 m .38243 .57134 L .38563 .58826 L p F P
0 0 0 r
s
.83 .24 .1 r
.26183 .71564 m
.24078 .69491 L
s
.28816 .70094 m
.26183 .71564 L
s
.24 .35 .67 r
.73817 .71564 m
.75922 .69491 L
s
.71184 .70094 m
.73817 .71564 L
s
.83 .24 .1 r
.32805 .43435 m
.33062 .43257 L
s
.24 .35 .67 r
.66938 .43257 m
.67195 .43435 L
s
.83 .24 .1 r
.2778 .48571 m
.25161 .50362 L
s
.25161 .50362 m
.24616 .52688 L
s
.24 .35 .67 r
.7222 .48571 m
.74839 .50362 L
s
.74839 .50362 m
.75384 .52688 L
s
.083 .024 .01 r
.51059 .66642 m .5 .67186 L .5 .67208 L p F P
0 0 0 r
s
.24 .35 .67 r
.50212 .67181 m
.51934 .68066 L
s
.073 .085 .162 r
.48941 .66642 m .5 .67186 L .5 .67208 L p F P
0 0 0 r
s
.83 .24 .1 r
.48066 .68066 m
.49788 .67181 L
s
.1 .028 .011 r
.54853 .6426 m .56104 .63616 L .56635 .6252 L p F P
0 0 0 r
s
.1 .028 .011 r
.58015 .61803 m .56635 .6252 L .56104 .63616 L p F P
0 0 0 r
s
.156 .195 .345 r
.45147 .6426 m .43896 .63616 L .43365 .6252 L p F P
0 0 0 r
s
.156 .195 .345 r
.41985 .61803 m .43365 .6252 L .43896 .63616 L p F P
0 0 0 r
s
1 .32 .135 r
.47693 .3626 m .47237 .36568 L .45892 .36072 L p F P
0 0 0 r
s
1 .32 .135 r
.45224 .36529 m .45892 .36072 L .47237 .36568 L p F P
0 0 0 r
s
.25 .383 .767 r
.52307 .3626 m .52763 .36568 L .54108 .36072 L p F P
0 0 0 r
s
.25 .383 .767 r
.54776 .36529 m .54108 .36072 L .52763 .36568 L p F P
0 0 0 r
s
.83 .24 .1 r
.28765 .46669 m
.2778 .48571 L
s
.24 .35 .67 r
.71235 .46669 m
.7222 .48571 L
s
.862 .266 .108 r
.37286 .40337 m .36299 .41021 L .34207 .42281 L p F P
0 0 0 r
s
.24 .35 .67 r
.35991 .41206 m
.35999 .41211 L
s
.862 .266 .108 r
.33096 .43053 m .34207 .42281 L .36299 .41021 L p F P
0 0 0 r
s
.24 .35 .67 r
.3419 .40122 m
.35949 .41181 L
s
.119 .189 .415 r
.62714 .40337 m .63701 .41021 L .65793 .42281 L p F P
0 0 0 r
s
.83 .24 .1 r
.64001 .41211 m
.64009 .41206 L
s
.119 .189 .415 r
.66904 .43053 m .65793 .42281 L .63701 .41021 L p F P
0 0 0 r
s
.83 .24 .1 r
.64051 .41181 m
.6581 .40122 L
s
.22447 .59862 m
.19906 .61486 L
s
.20852 .64315 m
.19906 .61486 L
s
.24 .35 .67 r
.77553 .59862 m
.80094 .61486 L
s
.79148 .64315 m
.80094 .61486 L
s
.083 .024 .01 r
.52129 .66093 m .5321 .65537 L .53618 .64897 L p F P
0 0 0 r
s
.083 .024 .01 r
.54853 .6426 m .53618 .64897 L .5321 .65537 L p F P
0 0 0 r
s
.111 .126 .238 r
.47871 .66093 m .4679 .65537 L .46382 .64897 L p F P
0 0 0 r
s
.111 .126 .238 r
.45147 .6426 m .46382 .64897 L .4679 .65537 L p F P
0 0 0 r
s
.721 .205 .091 r
.67301 .45428 m .68757 .44594 L .66904 .43053 L p F P
0 0 0 r
s
.292 .417 .795 r
.32699 .45428 m .31243 .44594 L .33096 .43053 L p F P
0 0 0 r
s
.083 .024 .01 r
.34207 .42281 m .33096 .43053 L .31243 .44594 L p F P
0 0 0 r
s
.24 .35 .67 r
.32718 .42803 m
.33111 .43033 L
s
.33111 .43033 m
.33127 .43042 L
s
.33187 .43077 m
.35892 .44661 L
s
.104 .117 .224 r
.65793 .42281 m .66904 .43053 L .68757 .44594 L p F P
0 0 0 r
s
.83 .24 .1 r
.66889 .43033 m
.67282 .42803 L
s
.66873 .43042 m
.66889 .43033 L
s
.64108 .44661 m
.66813 .43077 L
s
.215 .055 .025 r
.58015 .61803 m .59415 .61076 L .59936 .59614 L p F P
0 0 0 r
s
.215 .055 .025 r
.61437 .58826 m .59936 .59614 L .59415 .61076 L p F P
0 0 0 r
s
.199 .262 .472 r
.41985 .61803 m .40585 .61076 L .40064 .59614 L p F P
0 0 0 r
s
.199 .262 .472 r
.38563 .58826 m .40064 .59614 L .40585 .61076 L p F P
0 0 0 r
s
1 .322 .134 r
.4456 .36983 m .43901 .37434 L .42027 .37686 L p F P
0 0 0 r
s
.24 .35 .67 r
.40949 .3732 m
.42993 .35433 L
s
1 .322 .134 r
.41181 .3827 m .42027 .37686 L .43901 .37434 L p F P
0 0 0 r
s
.215 .337 .686 r
.5544 .36983 m .56099 .37434 L .57973 .37686 L p F P
0 0 0 r
s
.83 .24 .1 r
.57007 .35433 m
.59051 .3732 L
s
.215 .337 .686 r
.58819 .3827 m .57973 .37686 L .56099 .37434 L p F P
0 0 0 r
s
1 .32 .135 r
.4815 .3595 m .47693 .3626 L .46565 .35611 L p F P
0 0 0 r
s
1 .32 .135 r
.45892 .36072 m .46565 .35611 L .47693 .3626 L p F P
0 0 0 r
s
.25 .383 .767 r
.5185 .3595 m .52307 .3626 L .53435 .35611 L p F P
0 0 0 r
s
.25 .383 .767 r
.54108 .36072 m .53435 .35611 L .52307 .3626 L p F P
0 0 0 r
s
.667 .188 .084 r
.67055 .48048 m .68609 .47175 L .67301 .45428 L p F P
0 0 0 r
s
.667 .188 .084 r
.68757 .44594 m .67301 .45428 L .68609 .47175 L p F P
0 0 0 r
s
.287 .407 .773 r
.32945 .48048 m .31391 .47175 L .32699 .45428 L p F P
0 0 0 r
s
.287 .407 .773 r
.31243 .44594 m .32699 .45428 L .31391 .47175 L p F P
0 0 0 r
s
1 .308 .127 r
.41181 .3827 m .40341 .38848 L .38282 .39646 L p F P
0 0 0 r
s
.24 .35 .67 r
.38854 .39425 m
.38988 .39508 L
s
1 .308 .127 r
.37286 .40337 m .38282 .39646 L .40341 .38848 L p F P
0 0 0 r
s
.24 .35 .67 r
.35913 .37606 m
.38808 .39397 L
s
.159 .261 .547 r
.58819 .3827 m .59659 .38848 L .61718 .39646 L p F P
0 0 0 r
s
.83 .24 .1 r
.61012 .39508 m
.61146 .39425 L
s
.159 .261 .547 r
.62714 .40337 m .61718 .39646 L .59659 .38848 L p F P
0 0 0 r
s
.83 .24 .1 r
.61192 .39397 m
.64087 .37606 L
s
.604 .168 .076 r
.66244 .50806 m .67854 .49919 L .67055 .48048 L p F P
0 0 0 r
s
.604 .168 .076 r
.68609 .47175 m .67055 .48048 L .67854 .49919 L p F P
0 0 0 r
s
.83 .24 .1 r
.65245 .47383 m
.6845 .45558 L
s
.28 .394 .743 r
.33756 .50806 m .32146 .49919 L .32945 .48048 L p F P
0 0 0 r
s
.28 .394 .743 r
.31391 .47175 m .32945 .48048 L .32146 .49919 L p F P
0 0 0 r
s
.24 .35 .67 r
.3155 .45558 m
.34755 .47383 L
s
.83 .24 .1 r
.6581 .40122 m
.67282 .42803 L
s
.69054 .3817 m
.6581 .40122 L
s
.6581 .40122 m
.64087 .37606 L
s
.24 .35 .67 r
.32718 .42803 m
.3419 .40122 L
s
.30946 .3817 m
.3419 .40122 L
s
.3419 .40122 m
.35913 .37606 L
s
.528 .145 .066 r
.64966 .53592 m .66587 .52714 L .66244 .50806 L p F P
0 0 0 r
s
.528 .145 .066 r
.67854 .49919 m .66244 .50806 L .66587 .52714 L p F P
0 0 0 r
s
.83 .24 .1 r
.66029 .50091 m
.66425 .52688 L
s
.269 .375 .705 r
.35034 .53592 m .33413 .52714 L .33756 .50806 L p F P
0 0 0 r
s
.269 .375 .705 r
.32146 .49919 m .33756 .50806 L .33413 .52714 L p F P
0 0 0 r
s
.24 .35 .67 r
.33575 .52688 m
.33971 .50091 L
s
.83 .24 .1 r
.60119 .33409 m
.57007 .35433 L
s
.57007 .35433 m
.54893 .33958 L
s
.24 .35 .67 r
.39881 .33409 m
.42993 .35433 L
s
.42993 .35433 m
.45107 .33958 L
s
.83 .24 .1 r
.24078 .69491 m
.22268 .67032 L
s
.26692 .67982 m
.24078 .69491 L
s
.24 .35 .67 r
.75922 .69491 m
.77732 .67032 L
s
.73308 .67982 m
.75922 .69491 L
s
.435 .116 .054 r
.63326 .56299 m .64918 .55451 L .64966 .53592 L p F P
0 0 0 r
s
.435 .116 .054 r
.66587 .52714 m .64966 .53592 L .64918 .55451 L p F P
0 0 0 r
s
.254 .35 .652 r
.36674 .56299 m .35082 .55451 L .35034 .53592 L p F P
0 0 0 r
s
.254 .35 .652 r
.33413 .52714 m .35034 .53592 L .35082 .55451 L p F P
0 0 0 r
s
.83 .24 .1 r
.67282 .42803 m
.67663 .43702 L
s
.24 .35 .67 r
.32337 .43702 m
.32718 .42803 L
s
1 .32 .135 r
.48609 .35639 m .4815 .3595 L .47242 .35148 L p F P
0 0 0 r
s
1 .32 .135 r
.46565 .35611 m .47242 .35148 L .4815 .3595 L p F P
0 0 0 r
s
.24 .35 .67 r
.45107 .33958 m
.47072 .35264 L
s
.25 .383 .767 r
.51391 .35639 m .5185 .3595 L .52758 .35148 L p F P
0 0 0 r
s
.25 .383 .767 r
.53435 .35611 m .52758 .35148 L .5185 .3595 L p F P
0 0 0 r
s
.83 .24 .1 r
.52928 .35264 m
.54893 .33958 L
s
.083 .024 .01 r
.5 .67208 m .50896 .66749 L .51059 .66642 L p F P
0 0 0 r
s
.24 .35 .67 r
.50133 .6714 m
.50212 .67181 L
s
.083 .024 .01 r
.52129 .66093 m .51059 .66642 L .50896 .66749 L p F P
0 0 0 r
s
.073 .085 .162 r
.5 .67208 m .49104 .66749 L .48941 .66642 L p F P
0 0 0 r
s
.83 .24 .1 r
.49788 .67181 m
.49867 .6714 L
s
.073 .085 .162 r
.47871 .66093 m .48941 .66642 L .49104 .66749 L p F P
0 0 0 r
s
.83 .24 .1 r
.2342 .62726 m
.20852 .64315 L
s
.22268 .67032 m
.20852 .64315 L
s
.24 .35 .67 r
.7658 .62726 m
.79148 .64315 L
s
.77732 .67032 m
.79148 .64315 L
s
1 .322 .134 r
.45224 .36529 m .4456 .36983 L .42881 .37097 L p F P
0 0 0 r
s
1 .322 .134 r
.42027 .37686 m .42881 .37097 L .4456 .36983 L p F P
0 0 0 r
s
.215 .337 .686 r
.54776 .36529 m .5544 .36983 L .57119 .37097 L p F P
0 0 0 r
s
.215 .337 .686 r
.57973 .37686 m .57119 .37097 L .5544 .36983 L p F P
0 0 0 r
s
.83 .24 .1 r
.67311 .35611 m
.64087 .37606 L
s
.64087 .37606 m
.62169 .35341 L
s
.24 .35 .67 r
.32689 .35611 m
.35913 .37606 L
s
.35913 .37606 m
.37831 .35341 L
s
.83 .24 .1 r
.28816 .70094 m
.31115 .71712 L
s
.3384 .70234 m
.31115 .71712 L
s
.24 .35 .67 r
.71184 .70094 m
.68885 .71712 L
s
.6616 .70234 m
.68885 .71712 L
s
.862 .266 .108 r
.38282 .39646 m .37286 .40337 L .35332 .415 L p F P
0 0 0 r
s
.862 .266 .108 r
.34207 .42281 m .35332 .415 L .37286 .40337 L p F P
0 0 0 r
s
.119 .189 .415 r
.61718 .39646 m .62714 .40337 L .64668 .415 L p F P
0 0 0 r
s
.119 .189 .415 r
.65793 .42281 m .64668 .415 L .62714 .40337 L p F P
0 0 0 r
s
.319 .081 .039 r
.61437 .58826 m .6296 .58026 L .63326 .56299 L p F P
0 0 0 r
s
.319 .081 .039 r
.64918 .55451 m .63326 .56299 L .6296 .58026 L p F P
0 0 0 r
s
.83 .24 .1 r
.6318 .56786 m
.6324 .54413 L
s
.232 .315 .578 r
.38563 .58826 m .3704 .58026 L .36674 .56299 L p F P
0 0 0 r
s
.232 .315 .578 r
.35082 .55451 m .36674 .56299 L .3704 .58026 L p F P
0 0 0 r
s
.24 .35 .67 r
.3676 .54413 m
.3682 .56786 L
s
.83 .24 .1 r
.2486 .65483 m
.22268 .67032 L
s
.24 .35 .67 r
.7514 .65483 m
.77732 .67032 L
s
.1 .028 .011 r
.56104 .63616 m .5737 .62963 L .58015 .61803 L p F P
0 0 0 r
s
.1 .028 .011 r
.59415 .61076 m .58015 .61803 L .5737 .62963 L p F P
0 0 0 r
s
.156 .195 .345 r
.43896 .63616 m .4263 .62963 L .41985 .61803 L p F P
0 0 0 r
s
.156 .195 .345 r
.40585 .61076 m .41985 .61803 L .4263 .62963 L p F P
0 0 0 r
s
.083 .024 .01 r
.5321 .65537 m .54304 .64976 L .54853 .6426 L p F P
0 0 0 r
s
.083 .024 .01 r
.56104 .63616 m .54853 .6426 L .54304 .64976 L p F P
0 0 0 r
s
.83 .24 .1 r
.52441 .65343 m
.55457 .63785 L
s
.55457 .63785 m
.56447 .62114 L
s
.111 .126 .238 r
.4679 .65537 m .45696 .64976 L .45147 .6426 L p F P
0 0 0 r
s
.111 .126 .238 r
.43896 .63616 m .45147 .6426 L .45696 .64976 L p F P
0 0 0 r
s
.24 .35 .67 r
.44543 .63785 m
.47559 .65343 L
s
.43553 .62114 m
.44543 .63785 L
s
1 .32 .135 r
.49071 .35327 m .48609 .35639 L .47925 .34681 L p F P
0 0 0 r
s
1 .32 .135 r
.47242 .35148 m .47925 .34681 L .48609 .35639 L p F P
0 0 0 r
s
.25 .383 .767 r
.50929 .35327 m .51391 .35639 L .52075 .34681 L p F P
0 0 0 r
s
.25 .383 .767 r
.52758 .35148 m .52075 .34681 L .51391 .35639 L p F P
0 0 0 r
s
1 .308 .127 r
.42027 .37686 m .41181 .3827 L .3929 .38948 L p F P
0 0 0 r
s
1 .308 .127 r
.38282 .39646 m .3929 .38948 L .41181 .3827 L p F P
0 0 0 r
s
.159 .261 .547 r
.57973 .37686 m .58819 .3827 L .6071 .38948 L p F P
0 0 0 r
s
.159 .261 .547 r
.61718 .39646 m .6071 .38948 L .58819 .3827 L p F P
0 0 0 r
s
.83 .24 .1 r
.24578 .55339 m
.21986 .57043 L
s
.21986 .57043 m
.22447 .59862 L
s
.24 .35 .67 r
.75422 .55339 m
.78014 .57043 L
s
.78014 .57043 m
.77553 .59862 L
s
.083 .024 .01 r
.35332 .415 m .34207 .42281 L .32464 .43747 L p F P
0 0 0 r
s
.083 .024 .01 r
.31243 .44594 m .32464 .43747 L .34207 .42281 L p F P
0 0 0 r
s
.24 .35 .67 r
.3155 .45558 m
.32257 .43891 L
s
.104 .117 .224 r
.64668 .415 m .65793 .42281 L .67536 .43747 L p F P
0 0 0 r
s
.104 .117 .224 r
.68757 .44594 m .67536 .43747 L .65793 .42281 L p F P
0 0 0 r
s
.83 .24 .1 r
.67743 .43891 m
.6845 .45558 L
s
1 .322 .134 r
.45892 .36072 m .45224 .36529 L .43743 .36502 L p F P
0 0 0 r
s
1 .322 .134 r
.42881 .37097 m .43743 .36502 L .45224 .36529 L p F P
0 0 0 r
s
.83 .24 .1 r
.44771 .36616 m
.46816 .37001 L
s
.215 .337 .686 r
.54108 .36072 m .54776 .36529 L .56257 .36502 L p F P
0 0 0 r
s
.215 .337 .686 r
.57119 .37097 m .56257 .36502 L .54776 .36529 L p F P
0 0 0 r
s
.24 .35 .67 r
.53184 .37001 m
.55229 .36616 L
s
.215 .055 .025 r
.59415 .61076 m .60833 .60339 L .61437 .58826 L p F P
0 0 0 r
s
.83 .24 .1 r
.56447 .62114 m
.59522 .60509 L
s
.59522 .60509 m
.6005 .58447 L
s
.215 .055 .025 r
.6296 .58026 m .61437 .58826 L .60833 .60339 L p F P
0 0 0 r
s
.83 .24 .1 r
.6005 .58447 m
.6318 .56786 L
s
.199 .262 .472 r
.40585 .61076 m .39167 .60339 L .38563 .58826 L p F P
0 0 0 r
s
.24 .35 .67 r
.40478 .60509 m
.43553 .62114 L
s
.3995 .58447 m
.40478 .60509 L
s
.199 .262 .472 r
.3704 .58026 m .38563 .58826 L .39167 .60339 L p F P
0 0 0 r
s
.24 .35 .67 r
.3682 .56786 m
.3995 .58447 L
s
.667 .188 .084 r
.68609 .47175 m .70186 .4629 L .68757 .44594 L p F P
0 0 0 r
s
.287 .407 .773 r
.31391 .47175 m .29814 .4629 L .31243 .44594 L p F P
0 0 0 r
s
.083 .024 .01 r
.32464 .43747 m .31243 .44594 L .29814 .4629 L p F P
0 0 0 r
s
.83 .24 .1 r
.28765 .46669 m
.30509 .45465 L
s
.31099 .45057 m
.3144 .44822 L
s
.24 .35 .67 r
.30696 .45072 m
.30815 .45139 L
s
.30939 .4521 m
.3155 .45558 L
s
.83 .24 .1 r
.3144 .44822 m
.32363 .43884 L
s
.157 .196 .347 r
.67536 .43747 m .68757 .44594 L .70186 .4629 L p F P
0 0 0 r
s
.24 .35 .67 r
.69491 .45465 m
.71235 .46669 L
s
.6856 .44822 m
.68901 .45057 L
s
.83 .24 .1 r
.69185 .45139 m
.69304 .45072 L
s
.6845 .45558 m
.69061 .4521 L
s
.24 .35 .67 r
.67637 .43884 m
.6856 .44822 L
s
1 .32 .135 r
.49534 .35013 m .49071 .35327 L .48611 .34211 L p F P
0 0 0 r
s
1 .32 .135 r
.47925 .34681 m .48611 .34211 L .49071 .35327 L p F P
0 0 0 r
s
.25 .383 .767 r
.50466 .35013 m .50929 .35327 L .51389 .34211 L p F P
0 0 0 r
s
.25 .383 .767 r
.52075 .34681 m .51389 .34211 L .50929 .35327 L p F P
0 0 0 r
s
.83 .24 .1 r
.3384 .70234 m
.36197 .7132 L
s
.3901 .6983 m
.36197 .7132 L
s
.24 .35 .67 r
.6616 .70234 m
.63803 .7132 L
s
.6099 .6983 m
.63803 .7132 L
s
.604 .168 .076 r
.67854 .49919 m .69488 .49019 L .68609 .47175 L p F P
0 0 0 r
s
.604 .168 .076 r
.70186 .4629 m .68609 .47175 L .69488 .49019 L p F P
0 0 0 r
s
.28 .394 .743 r
.32146 .49919 m .30512 .49019 L .31391 .47175 L p F P
0 0 0 r
s
.28 .394 .743 r
.29814 .4629 m .31391 .47175 L .30512 .49019 L p F P
0 0 0 r
s
.083 .024 .01 r
.50896 .66749 m .51799 .66285 L .52129 .66093 L p F P
0 0 0 r
s
.83 .24 .1 r
.49883 .67132 m
.5102 .66547 L
s
.083 .024 .01 r
.5321 .65537 m .52129 .66093 L .51799 .66285 L p F P
0 0 0 r
s
.83 .24 .1 r
.5102 .66547 m
.52441 .65343 L
s
.073 .085 .162 r
.49104 .66749 m .48201 .66285 L .47871 .66093 L p F P
0 0 0 r
s
.24 .35 .67 r
.4898 .66547 m
.50117 .67132 L
s
.073 .085 .162 r
.4679 .65537 m .47871 .66093 L .48201 .66285 L p F P
0 0 0 r
s
.24 .35 .67 r
.47559 .65343 m
.4898 .66547 L
s
.83 .24 .1 r
.65381 .33301 m
.62169 .35341 L
s
.62169 .35341 m
.60119 .33409 L
s
.24 .35 .67 r
.34619 .33301 m
.37831 .35341 L
s
.37831 .35341 m
.39881 .33409 L
s
.528 .145 .066 r
.66587 .52714 m .68234 .51823 L .67854 .49919 L p F P
0 0 0 r
s
.528 .145 .066 r
.69488 .49019 m .67854 .49919 L .68234 .51823 L p F P
0 0 0 r
s
.83 .24 .1 r
.66029 .50091 m
.69271 .48292 L
s
.269 .375 .705 r
.33413 .52714 m .31766 .51823 L .32146 .49919 L p F P
0 0 0 r
s
.269 .375 .705 r
.30512 .49019 m .32146 .49919 L .31766 .51823 L p F P
0 0 0 r
s
.24 .35 .67 r
.30729 .48292 m
.33971 .50091 L
s
.862 .266 .108 r
.3929 .38948 m .38282 .39646 L .36471 .4071 L p F P
0 0 0 r
s
.862 .266 .108 r
.35332 .415 m .36471 .4071 L .38282 .39646 L p F P
0 0 0 r
s
.119 .189 .415 r
.6071 .38948 m .61718 .39646 L .63529 .4071 L p F P
0 0 0 r
s
.119 .189 .415 r
.64668 .415 m .63529 .4071 L .61718 .39646 L p F P
0 0 0 r
s
.83 .24 .1 r
.3901 .6983 m
.41291 .70336 L
s
.44188 .68829 m
.41291 .70336 L
s
.24 .35 .67 r
.6099 .6983 m
.58709 .70336 L
s
.55812 .68829 m
.58709 .70336 L
s
1 .308 .127 r
.42881 .37097 m .42027 .37686 L .40309 .38242 L p F P
0 0 0 r
s
1 .308 .127 r
.3929 .38948 m .40309 .38242 L .42027 .37686 L p F P
0 0 0 r
s
.83 .24 .1 r
.41905 .38581 m
.44771 .36616 L
s
.3721 .40727 m
.40007 .38793 L
s
.40007 .38793 m
.41905 .38581 L
s
.159 .261 .547 r
.57119 .37097 m .57973 .37686 L .59691 .38242 L p F P
0 0 0 r
s
.159 .261 .547 r
.6071 .38948 m .59691 .38242 L .57973 .37686 L p F P
0 0 0 r
s
.24 .35 .67 r
.55229 .36616 m
.58095 .38581 L
s
.59993 .38793 m
.6279 .40727 L
s
.58095 .38581 m
.59993 .38793 L
s
1 .32 .135 r
.5 .34697 m .49534 .35013 L .49303 .33737 L p F P
0 0 0 r
s
1 .32 .135 r
.48611 .34211 m .49303 .33737 L .49534 .35013 L p F P
0 0 0 r
s
.83 .24 .1 r
.46816 .37001 m
.49756 .35012 L
s
.25 .383 .767 r
.5 .34697 m .50466 .35013 L .50697 .33737 L p F P
0 0 0 r
s
.24 .35 .67 r
.49461 .35365 m
.50244 .35012 L
s
.25 .383 .767 r
.51389 .34211 m .50697 .33737 L .50466 .35013 L p F P
0 0 0 r
s
.24 .35 .67 r
.50244 .35012 m
.53184 .37001 L
s
.83 .24 .1 r
.49756 .35012 m
.50539 .35365 L
s
.44188 .68829 m
.46269 .68742 L
s
.49242 .6721 m
.46269 .68742 L
s
.24 .35 .67 r
.55812 .68829 m
.53731 .68742 L
s
.50758 .6721 m
.53731 .68742 L
s
.435 .116 .054 r
.64918 .55451 m .66534 .54591 L .66587 .52714 L p F P
0 0 0 r
s
.83 .24 .1 r
.6324 .54413 m
.66425 .52688 L
s
.435 .116 .054 r
.68234 .51823 m .66587 .52714 L .66534 .54591 L p F P
0 0 0 r
s
.254 .35 .652 r
.35082 .55451 m .33466 .54591 L .33413 .52714 L p F P
0 0 0 r
s
.24 .35 .67 r
.33575 .52688 m
.3676 .54413 L
s
.254 .35 .652 r
.31766 .51823 m .33413 .52714 L .33466 .54591 L p F P
0 0 0 r
s
1 .322 .134 r
.46565 .35611 m .45892 .36072 L .44613 .35903 L p F P
0 0 0 r
s
1 .322 .134 r
.43743 .36502 m .44613 .35903 L .45892 .36072 L p F P
0 0 0 r
s
.215 .337 .686 r
.53435 .35611 m .54108 .36072 L .55387 .35903 L p F P
0 0 0 r
s
.215 .337 .686 r
.56257 .36502 m .55387 .35903 L .54108 .36072 L p F P
0 0 0 r
s
.83 .24 .1 r
.2726 .5091 m
.24616 .52688 L
s
.24616 .52688 m
.24578 .55339 L
s
.24 .35 .67 r
.7274 .5091 m
.75384 .52688 L
s
.75384 .52688 m
.75422 .55339 L
s
.083 .024 .01 r
.54304 .64976 m .55409 .64409 L .56104 .63616 L p F P
0 0 0 r
s
.083 .024 .01 r
.5737 .62963 m .56104 .63616 L .55409 .64409 L p F P
0 0 0 r
s
.111 .126 .238 r
.45696 .64976 m .44591 .64409 L .43896 .63616 L p F P
0 0 0 r
s
.111 .126 .238 r
.4263 .62963 m .43896 .63616 L .44591 .64409 L p F P
0 0 0 r
s
.1 .028 .011 r
.5737 .62963 m .58651 .62302 L .59415 .61076 L p F P
0 0 0 r
s
.1 .028 .011 r
.60833 .60339 m .59415 .61076 L .58651 .62302 L p F P
0 0 0 r
s
.156 .195 .345 r
.4263 .62963 m .41349 .62302 L .40585 .61076 L p F P
0 0 0 r
s
.156 .195 .345 r
.39167 .60339 m .40585 .61076 L .41349 .62302 L p F P
0 0 0 r
s
.319 .081 .039 r
.6296 .58026 m .64505 .57214 L .64918 .55451 L p F P
0 0 0 r
s
.319 .081 .039 r
.66534 .54591 m .64918 .55451 L .64505 .57214 L p F P
0 0 0 r
s
.232 .315 .578 r
.3704 .58026 m .35495 .57214 L .35082 .55451 L p F P
0 0 0 r
s
.232 .315 .578 r
.33466 .54591 m .35082 .55451 L .35495 .57214 L p F P
0 0 0 r
s
.83 .24 .1 r
.26692 .67982 m
.28816 .70094 L
s
.31529 .68579 m
.28816 .70094 L
s
.24 .35 .67 r
.73308 .67982 m
.71184 .70094 L
s
.68471 .68579 m
.71184 .70094 L
s
.083 .024 .01 r
.36471 .4071 m .35332 .415 L .33702 .4289 L p F P
0 0 0 r
s
.83 .24 .1 r
.35539 .4154 m
.3721 .40727 L
s
.3331 .43085 m
.34185 .42478 L
s
.083 .024 .01 r
.32464 .43747 m .33702 .4289 L .35332 .415 L p F P
0 0 0 r
s
.83 .24 .1 r
.34519 .42247 m
.35539 .4154 L
s
.24 .35 .67 r
.29448 .40889 m
.32718 .42803 L
s
.104 .117 .224 r
.63529 .4071 m .64668 .415 L .66298 .4289 L p F P
0 0 0 r
s
.24 .35 .67 r
.6279 .40727 m
.64461 .4154 L
s
.65815 .42478 m
.6669 .43085 L
s
.104 .117 .224 r
.67536 .43747 m .66298 .4289 L .64668 .415 L p F P
0 0 0 r
s
.24 .35 .67 r
.64461 .4154 m
.65481 .42247 L
s
.83 .24 .1 r
.67282 .42803 m
.70552 .40889 L
s
1 .32 .135 r
.49303 .33737 m .5 .3326 L .5 .34697 L p F P
0 0 0 r
s
.25 .383 .767 r
.50697 .33737 m .5 .3326 L .5 .34697 L p F P
0 0 0 r
s
.83 .24 .1 r
.49756 .35012 m
.50276 .3466 L
s
.24 .35 .67 r
.49724 .3466 m
.50244 .35012 L
s
.83 .24 .1 r
.2778 .48571 m
.2726 .5091 L
s
.24 .35 .67 r
.7222 .48571 m
.7274 .5091 L
s
.83 .24 .1 r
.58008 .31888 m
.54893 .33958 L
s
.54893 .33958 m
.52787 .32962 L
s
.24 .35 .67 r
.41992 .31888 m
.45107 .33958 L
s
.45107 .33958 m
.47213 .32962 L
s
.83 .24 .1 r
.25066 .58189 m
.22447 .59862 L
s
.22447 .59862 m
.2342 .62726 L
s
.24 .35 .67 r
.74934 .58189 m
.77553 .59862 L
s
.77553 .59862 m
.7658 .62726 L
s
1 .322 .134 r
.47242 .35148 m .46565 .35611 L .4549 .35297 L p F P
0 0 0 r
s
1 .322 .134 r
.44613 .35903 m .4549 .35297 L .46565 .35611 L p F P
0 0 0 r
s
.215 .337 .686 r
.52758 .35148 m .53435 .35611 L .5451 .35297 L p F P
0 0 0 r
s
.215 .337 .686 r
.55387 .35903 m .5451 .35297 L .53435 .35611 L p F P
0 0 0 r
s
.083 .024 .01 r
.51799 .66285 m .52711 .65817 L .5321 .65537 L p F P
0 0 0 r
s
.083 .024 .01 r
.54304 .64976 m .5321 .65537 L .52711 .65817 L p F P
0 0 0 r
s
.073 .085 .162 r
.48201 .66285 m .47289 .65817 L .4679 .65537 L p F P
0 0 0 r
s
.073 .085 .162 r
.45696 .64976 m .4679 .65537 L .47289 .65817 L p F P
0 0 0 r
s
1 .308 .127 r
.43743 .36502 m .42881 .37097 L .41339 .37528 L p F P
0 0 0 r
s
1 .308 .127 r
.40309 .38242 m .41339 .37528 L .42881 .37097 L p F P
0 0 0 r
s
.159 .261 .547 r
.56257 .36502 m .57119 .37097 L .58661 .37528 L p F P
0 0 0 r
s
.159 .261 .547 r
.59691 .38242 m .58661 .37528 L .57119 .37097 L p F P
0 0 0 r
s
.083 .024 .01 r
.33702 .4289 m .32464 .43747 L .31119 .45391 L p F P
0 0 0 r
s
.083 .024 .01 r
.29814 .4629 m .31119 .45391 L .32464 .43747 L p F P
0 0 0 r
s
.24 .35 .67 r
.30729 .48292 m
.3155 .45558 L
s
.28246 .43677 m
.30696 .45072 L
s
.157 .196 .347 r
.66298 .4289 m .67536 .43747 L .68881 .45391 L p F P
0 0 0 r
s
.157 .196 .347 r
.70186 .4629 m .68881 .45391 L .67536 .43747 L p F P
0 0 0 r
s
.83 .24 .1 r
.6845 .45558 m
.69271 .48292 L
s
.69304 .45072 m
.71754 .43677 L
s
.215 .055 .025 r
.60833 .60339 m .62271 .59592 L .6296 .58026 L p F P
0 0 0 r
s
.215 .055 .025 r
.64505 .57214 m .6296 .58026 L .62271 .59592 L p F P
0 0 0 r
s
.199 .262 .472 r
.39167 .60339 m .37729 .59592 L .3704 .58026 L p F P
0 0 0 r
s
.199 .262 .472 r
.35495 .57214 m .3704 .58026 L .37729 .59592 L p F P
0 0 0 r
s
.862 .266 .108 r
.40309 .38242 m .3929 .38948 L .37625 .39909 L p F P
0 0 0 r
s
.862 .266 .108 r
.36471 .4071 m .37625 .39909 L .3929 .38948 L p F P
0 0 0 r
s
.119 .189 .415 r
.59691 .38242 m .6071 .38948 L .62375 .39909 L p F P
0 0 0 r
s
.119 .189 .415 r
.63529 .4071 m .62375 .39909 L .6071 .38948 L p F P
0 0 0 r
s
.604 .168 .076 r
.69488 .49019 m .71146 .48105 L .70186 .4629 L p F P
0 0 0 r
s
.28 .394 .743 r
.30512 .49019 m .28854 .48105 L .29814 .4629 L p F P
0 0 0 r
s
.15 .041 .019 r
.31119 .45391 m .29814 .4629 L .28854 .48105 L p F P
0 0 0 r
s
.202 .266 .472 r
.68881 .45391 m .70186 .4629 L .71146 .48105 L p F P
0 0 0 r
s
.914 .283 .117 r
.50896 .66749 m .5 .67208 L .5 .66807 L p F P
0 0 0 r
s
.24 .35 .67 r
.50321 .67048 m
.50758 .6721 L
s
.50243 .67018 m
.50321 .67048 L
s
.83 .24 .1 r
.50392 .66782 m
.5102 .66547 L
s
.156 .257 .535 r
.49104 .66749 m .5 .67208 L .5 .66807 L p F P
0 0 0 r
s
.83 .24 .1 r
.49679 .67048 m
.49757 .67018 L
s
.24 .35 .67 r
.4898 .66547 m
.49608 .66782 L
s
.83 .24 .1 r
.49242 .6721 m
.49679 .67048 L
s
.70552 .40889 m
.69054 .3817 L
s
.72397 .36158 m
.69054 .3817 L
s
.69054 .3817 m
.67311 .35611 L
s
.24 .35 .67 r
.29448 .40889 m
.30946 .3817 L
s
.27603 .36158 m
.30946 .3817 L
s
.30946 .3817 m
.32689 .35611 L
s
.528 .145 .066 r
.68234 .51823 m .69906 .50919 L .69488 .49019 L p F P
0 0 0 r
s
.528 .145 .066 r
.71146 .48105 m .69488 .49019 L .69906 .50919 L p F P
0 0 0 r
s
.83 .24 .1 r
.69271 .48292 m
.69708 .5091 L
s
.69271 .48292 m
.7066 .47522 L
s
.24 .35 .67 r
.70924 .47685 m
.7222 .48571 L
s
.269 .375 .705 r
.31766 .51823 m .30094 .50919 L .30512 .49019 L p F P
0 0 0 r
s
.269 .375 .705 r
.28854 .48105 m .30512 .49019 L .30094 .50919 L p F P
0 0 0 r
s
.24 .35 .67 r
.30292 .5091 m
.30729 .48292 L
s
.2934 .47522 m
.30729 .48292 L
s
.83 .24 .1 r
.2778 .48571 m
.29076 .47685 L
s
.083 .024 .01 r
.55409 .64409 m .56526 .63835 L .5737 .62963 L p F P
0 0 0 r
s
.083 .024 .01 r
.58651 .62302 m .5737 .62963 L .56526 .63835 L p F P
0 0 0 r
s
.111 .126 .238 r
.44591 .64409 m .43474 .63835 L .4263 .62963 L p F P
0 0 0 r
s
.111 .126 .238 r
.41349 .62302 m .4263 .62963 L .43474 .63835 L p F P
0 0 0 r
s
.83 .24 .1 r
.63327 .31322 m
.60119 .33409 L
s
.60119 .33409 m
.58008 .31888 L
s
.24 .35 .67 r
.36673 .31322 m
.39881 .33409 L
s
.39881 .33409 m
.41992 .31888 L
s
1 .322 .134 r
.47925 .34681 m .47242 .35148 L .46376 .34686 L p F P
0 0 0 r
s
1 .322 .134 r
.4549 .35297 m .46376 .34686 L .47242 .35148 L p F P
0 0 0 r
s
.215 .337 .686 r
.52075 .34681 m .52758 .35148 L .53624 .34686 L p F P
0 0 0 r
s
.215 .337 .686 r
.5451 .35297 m .53624 .34686 L .52758 .35148 L p F P
0 0 0 r
s
.83 .24 .1 r
.2486 .65483 m
.26692 .67982 L
s
.29388 .66427 m
.26692 .67982 L
s
.24 .35 .67 r
.7514 .65483 m
.73308 .67982 L
s
.70612 .66427 m
.73308 .67982 L
s
.83 .24 .1 r
.71754 .43677 m
.70552 .40889 L
s
.73923 .38916 m
.70552 .40889 L
s
.24 .35 .67 r
.28246 .43677 m
.29448 .40889 L
s
.26077 .38916 m
.29448 .40889 L
s
.435 .116 .054 r
.66534 .54591 m .68174 .53717 L .68234 .51823 L p F P
0 0 0 r
s
.435 .116 .054 r
.69906 .50919 m .68234 .51823 L .68174 .53717 L p F P
0 0 0 r
s
.254 .35 .652 r
.33466 .54591 m .31826 .53717 L .31766 .51823 L p F P
0 0 0 r
s
.254 .35 .652 r
.30094 .50919 m .31766 .51823 L .31826 .53717 L p F P
0 0 0 r
s
.1 .028 .011 r
.58651 .62302 m .59949 .61633 L .60833 .60339 L p F P
0 0 0 r
s
.1 .028 .011 r
.62271 .59592 m .60833 .60339 L .59949 .61633 L p F P
0 0 0 r
s
.156 .195 .345 r
.41349 .62302 m .40051 .61633 L .39167 .60339 L p F P
0 0 0 r
s
.156 .195 .345 r
.37729 .59592 m .39167 .60339 L .40051 .61633 L p F P
0 0 0 r
s
.83 .24 .1 r
.26067 .61089 m
.2342 .62726 L
s
.2342 .62726 m
.2486 .65483 L
s
.24 .35 .67 r
.73933 .61089 m
.7658 .62726 L
s
.7658 .62726 m
.7514 .65483 L
s
.083 .024 .01 r
.37625 .39909 m .36471 .4071 L .34958 .4202 L p F P
0 0 0 r
s
.083 .024 .01 r
.33702 .4289 m .34958 .4202 L .36471 .4071 L p F P
0 0 0 r
s
.104 .117 .224 r
.62375 .39909 m .63529 .4071 L .65042 .4202 L p F P
0 0 0 r
s
.104 .117 .224 r
.66298 .4289 m .65042 .4202 L .63529 .4071 L p F P
0 0 0 r
s
.83 .24 .1 r
.70635 .33556 m
.67311 .35611 L
s
.67311 .35611 m
.65381 .33301 L
s
.24 .35 .67 r
.29365 .33556 m
.32689 .35611 L
s
.32689 .35611 m
.34619 .33301 L
s
1 .308 .127 r
.44613 .35903 m .43743 .36502 L .4238 .36807 L p F P
0 0 0 r
s
1 .308 .127 r
.41339 .37528 m .4238 .36807 L .43743 .36502 L p F P
0 0 0 r
s
.159 .261 .547 r
.55387 .35903 m .56257 .36502 L .5762 .36807 L p F P
0 0 0 r
s
.159 .261 .547 r
.58661 .37528 m .5762 .36807 L .56257 .36502 L p F P
0 0 0 r
s
.83 .24 .1 r
.31529 .68579 m
.3384 .70234 L
s
.36649 .68711 m
.3384 .70234 L
s
.24 .35 .67 r
.68471 .68579 m
.6616 .70234 L
s
.63351 .68711 m
.6616 .70234 L
s
.083 .024 .01 r
.52711 .65817 m .53632 .65344 L .54304 .64976 L p F P
0 0 0 r
s
.083 .024 .01 r
.55409 .64409 m .54304 .64976 L .53632 .65344 L p F P
0 0 0 r
s
.83 .24 .1 r
.54064 .64983 m
.55457 .63785 L
s
.073 .085 .162 r
.47289 .65817 m .46368 .65344 L .45696 .64976 L p F P
0 0 0 r
s
.073 .085 .162 r
.44591 .64409 m .45696 .64976 L .46368 .65344 L p F P
0 0 0 r
s
.24 .35 .67 r
.44543 .63785 m
.45936 .64983 L
s
.319 .081 .039 r
.64505 .57214 m .66073 .5639 L .66534 .54591 L p F P
0 0 0 r
s
.319 .081 .039 r
.68174 .53717 m .66534 .54591 L .66073 .5639 L p F P
0 0 0 r
s
.83 .24 .1 r
.66406 .55074 m
.66425 .52688 L
s
.232 .315 .578 r
.35495 .57214 m .33927 .5639 L .33466 .54591 L p F P
0 0 0 r
s
.232 .315 .578 r
.31826 .53717 m .33466 .54591 L .33927 .5639 L p F P
0 0 0 r
s
.24 .35 .67 r
.33575 .52688 m
.33594 .55074 L
s
.83 .24 .1 r
.27533 .63885 m
.2486 .65483 L
s
.24 .35 .67 r
.72467 .63885 m
.7514 .65483 L
s
.862 .266 .108 r
.41339 .37528 m .40309 .38242 L .38792 .39099 L p F P
0 0 0 r
s
.862 .266 .108 r
.37625 .39909 m .38792 .39099 L .40309 .38242 L p F P
0 0 0 r
s
.119 .189 .415 r
.58661 .37528 m .59691 .38242 L .61208 .39099 L p F P
0 0 0 r
s
.119 .189 .415 r
.62375 .39909 m .61208 .39099 L .59691 .38242 L p F P
0 0 0 r
s
.914 .283 .117 r
.5 .66807 m .50704 .66444 L .50896 .66749 L p F P
0 0 0 r
s
.914 .283 .117 r
.51799 .66285 m .50896 .66749 L .50704 .66444 L p F P
0 0 0 r
s
.83 .24 .1 r
.51425 .66339 m
.54064 .64983 L
s
.156 .257 .535 r
.5 .66807 m .49296 .66444 L .49104 .66749 L p F P
0 0 0 r
s
.156 .257 .535 r
.48201 .66285 m .49104 .66749 L .49296 .66444 L p F P
0 0 0 r
s
.24 .35 .67 r
.45936 .64983 m
.48575 .66339 L
s
1 .322 .134 r
.48611 .34211 m .47925 .34681 L .47269 .3407 L p F P
0 0 0 r
s
1 .322 .134 r
.46376 .34686 m .47269 .3407 L .47925 .34681 L p F P
0 0 0 r
s
.83 .24 .1 r
.47725 .34591 m
.49756 .35012 L
s
.215 .337 .686 r
.51389 .34211 m .52075 .34681 L .52731 .3407 L p F P
0 0 0 r
s
.215 .337 .686 r
.53624 .34686 m .52731 .3407 L .52075 .34681 L p F P
0 0 0 r
s
.24 .35 .67 r
.50244 .35012 m
.52275 .34591 L
s
.83 .24 .1 r
.2725 .53583 m
.24578 .55339 L
s
.24578 .55339 m
.25066 .58189 L
s
.24 .35 .67 r
.7275 .53583 m
.75422 .55339 L
s
.75422 .55339 m
.74934 .58189 L
s
.083 .024 .01 r
.34958 .4202 m .33702 .4289 L .32443 .44479 L p F P
0 0 0 r
s
.083 .024 .01 r
.31119 .45391 m .32443 .44479 L .33702 .4289 L p F P
0 0 0 r
s
.157 .196 .347 r
.65042 .4202 m .66298 .4289 L .67557 .44479 L p F P
0 0 0 r
s
.157 .196 .347 r
.68881 .45391 m .67557 .44479 L .66298 .4289 L p F P
0 0 0 r
s
.215 .055 .025 r
.62271 .59592 m .63728 .58835 L .64505 .57214 L p F P
0 0 0 r
s
.83 .24 .1 r
.59522 .60509 m
.6269 .58855 L
s
.6269 .58855 m
.6318 .56786 L
s
.215 .055 .025 r
.66073 .5639 m .64505 .57214 L .63728 .58835 L p F P
0 0 0 r
s
.83 .24 .1 r
.6318 .56786 m
.66406 .55074 L
s
.199 .262 .472 r
.37729 .59592 m .36272 .58835 L .35495 .57214 L p F P
0 0 0 r
s
.24 .35 .67 r
.3731 .58855 m
.40478 .60509 L
s
.3682 .56786 m
.3731 .58855 L
s
.199 .262 .472 r
.33927 .5639 m .35495 .57214 L .36272 .58835 L p F P
0 0 0 r
s
.24 .35 .67 r
.33594 .55074 m
.3682 .56786 L
s
.83 .24 .1 r
.72613 .46438 m
.71754 .43677 L
s
.75159 .41737 m
.71754 .43677 L
s
.24 .35 .67 r
.27387 .46438 m
.28246 .43677 L
s
.24841 .41737 m
.28246 .43677 L
s
.15 .041 .019 r
.32443 .44479 m .31119 .45391 L .30213 .47178 L p F P
0 0 0 r
s
.15 .041 .019 r
.28854 .48105 m .30213 .47178 L .31119 .45391 L p F P
0 0 0 r
s
.202 .266 .472 r
.67557 .44479 m .68881 .45391 L .69787 .47178 L p F P
0 0 0 r
s
.202 .266 .472 r
.71146 .48105 m .69787 .47178 L .68881 .45391 L p F P
0 0 0 r
s
.83 .24 .1 r
.36649 .68711 m
.3901 .6983 L
s
.41911 .68294 m
.3901 .6983 L
s
.24 .35 .67 r
.63351 .68711 m
.6099 .6983 L
s
.58089 .68294 m
.6099 .6983 L
s
1 .308 .127 r
.4549 .35297 m .44613 .35903 L .43432 .36077 L p F P
0 0 0 r
s
.83 .24 .1 r
.44771 .36616 m
.47725 .34591 L
s
1 .308 .127 r
.4238 .36807 m .43432 .36077 L .44613 .35903 L p F P
0 0 0 r
s
.83 .24 .1 r
.4289 .368 m
.44771 .36616 L
s
.159 .261 .547 r
.5451 .35297 m .55387 .35903 L .56568 .36077 L p F P
0 0 0 r
s
.24 .35 .67 r
.52275 .34591 m
.55229 .36616 L
s
.159 .261 .547 r
.5762 .36807 m .56568 .36077 L .55387 .35903 L p F P
0 0 0 r
s
.24 .35 .67 r
.55229 .36616 m
.5711 .368 L
s
.083 .024 .01 r
.56526 .63835 m .57656 .63255 L .58651 .62302 L p F P
0 0 0 r
s
.083 .024 .01 r
.59949 .61633 m .58651 .62302 L .57656 .63255 L p F P
0 0 0 r
s
.83 .24 .1 r
.55457 .63785 m
.58566 .6218 L
s
.58566 .6218 m
.59522 .60509 L
s
.111 .126 .238 r
.43474 .63835 m .42344 .63255 L .41349 .62302 L p F P
0 0 0 r
s
.111 .126 .238 r
.40051 .61633 m .41349 .62302 L .42344 .63255 L p F P
0 0 0 r
s
.24 .35 .67 r
.41434 .6218 m
.44543 .63785 L
s
.40478 .60509 m
.41434 .6218 L
s
.83 .24 .1 r
.68693 .31198 m
.65381 .33301 L
s
.65381 .33301 m
.63327 .31322 L
s
.24 .35 .67 r
.31307 .31198 m
.34619 .33301 L
s
.34619 .33301 m
.36673 .31322 L
s
1 .322 .134 r
.49303 .33737 m .48611 .34211 L .48171 .33448 L p F P
0 0 0 r
s
1 .322 .134 r
.47269 .3407 m .48171 .33448 L .48611 .34211 L p F P
0 0 0 r
s
.24 .35 .67 r
.47213 .32962 m
.48052 .3353 L
s
.215 .337 .686 r
.50697 .33737 m .51389 .34211 L .51829 .33448 L p F P
0 0 0 r
s
.215 .337 .686 r
.52731 .3407 m .51829 .33448 L .51389 .34211 L p F P
0 0 0 r
s
.83 .24 .1 r
.51948 .3353 m
.52787 .32962 L
s
.528 .145 .066 r
.69906 .50919 m .71603 .5 L .71146 .48105 L p F P
0 0 0 r
s
.269 .375 .705 r
.30094 .50919 m .28397 .5 L .28854 .48105 L p F P
0 0 0 r
s
.276 .072 .035 r
.30213 .47178 m .28854 .48105 L .28397 .5 L p F P
0 0 0 r
s
.24 .35 .67 r
.27387 .46438 m
.29144 .47413 L
s
.29144 .47413 m
.29238 .47465 L
s
.24 .327 .596 r
.69787 .47178 m .71146 .48105 L .71603 .5 L p F P
0 0 0 r
s
.83 .24 .1 r
.70856 .47413 m
.72613 .46438 L
s
.70762 .47465 m
.70856 .47413 L
s
.083 .024 .01 r
.38792 .39099 m .37625 .39909 L .3623 .41139 L p F P
0 0 0 r
s
.83 .24 .1 r
.35745 .41397 m
.36644 .40774 L
s
.083 .024 .01 r
.34958 .4202 m .3623 .41139 L .37625 .39909 L p F P
0 0 0 r
s
.83 .24 .1 r
.36987 .40536 m
.38356 .39587 L
s
.104 .117 .224 r
.61208 .39099 m .62375 .39909 L .6377 .41139 L p F P
0 0 0 r
s
.24 .35 .67 r
.63356 .40774 m
.64255 .41397 L
s
.104 .117 .224 r
.65042 .4202 m .6377 .41139 L .62375 .39909 L p F P
0 0 0 r
s
.24 .35 .67 r
.61644 .39587 m
.63013 .40536 L
s
.083 .024 .01 r
.53632 .65344 m .5456 .64867 L .55409 .64409 L p F P
0 0 0 r
s
.083 .024 .01 r
.56526 .63835 m .55409 .64409 L .5456 .64867 L p F P
0 0 0 r
s
.073 .085 .162 r
.46368 .65344 m .4544 .64867 L .44591 .64409 L p F P
0 0 0 r
s
.073 .085 .162 r
.43474 .63835 m .44591 .64409 L .4544 .64867 L p F P
0 0 0 r
s
.83 .24 .1 r
.41911 .68294 m
.44188 .68829 L
s
.47174 .67275 m
.44188 .68829 L
s
.24 .35 .67 r
.58089 .68294 m
.55812 .68829 L
s
.52826 .67275 m
.55812 .68829 L
s
.1 .028 .011 r
.59949 .61633 m .61263 .60956 L .62271 .59592 L p F P
0 0 0 r
s
.1 .028 .011 r
.63728 .58835 m .62271 .59592 L .61263 .60956 L p F P
0 0 0 r
s
.156 .195 .345 r
.40051 .61633 m .38737 .60956 L .37729 .59592 L p F P
0 0 0 r
s
.156 .195 .345 r
.36272 .58835 m .37729 .59592 L .38737 .60956 L p F P
0 0 0 r
s
.83 .24 .1 r
.47174 .67275 m
.49242 .6721 L
s
.49242 .6721 m
.49851 .66897 L
s
.24 .35 .67 r
.52826 .67275 m
.50758 .6721 L
s
.50149 .66897 m
.50758 .6721 L
s
.914 .283 .117 r
.50704 .66444 m .51414 .66079 L .51799 .66285 L p F P
0 0 0 r
s
.914 .283 .117 r
.52711 .65817 m .51799 .66285 L .51414 .66079 L p F P
0 0 0 r
s
.156 .257 .535 r
.49296 .66444 m .48586 .66079 L .48201 .66285 L p F P
0 0 0 r
s
.156 .257 .535 r
.47289 .65817 m .48201 .66285 L .48586 .66079 L p F P
0 0 0 r
s
.862 .266 .108 r
.4238 .36807 m .41339 .37528 L .39975 .38278 L p F P
0 0 0 r
s
.862 .266 .108 r
.38792 .39099 m .39975 .38278 L .41339 .37528 L p F P
0 0 0 r
s
.83 .24 .1 r
.40007 .38793 m
.4289 .368 L
s
.38356 .39587 m
.40007 .38793 L
s
.119 .189 .415 r
.5762 .36807 m .58661 .37528 L .60025 .38278 L p F P
0 0 0 r
s
.119 .189 .415 r
.61208 .39099 m .60025 .38278 L .58661 .37528 L p F P
0 0 0 r
s
.24 .35 .67 r
.5711 .368 m
.59993 .38793 L
s
.59993 .38793 m
.61644 .39587 L
s
.435 .116 .054 r
.68174 .53717 m .6984 .5283 L .69906 .50919 L p F P
0 0 0 r
s
.83 .24 .1 r
.66425 .52688 m
.69708 .5091 L
s
.435 .116 .054 r
.71603 .5 m .69906 .50919 L .6984 .5283 L p F P
0 0 0 r
s
.254 .35 .652 r
.31826 .53717 m .3016 .5283 L .30094 .50919 L p F P
0 0 0 r
s
.24 .35 .67 r
.30292 .5091 m
.33575 .52688 L
s
.254 .35 .652 r
.28397 .5 m .30094 .50919 L .3016 .5283 L p F P
0 0 0 r
s
.83 .24 .1 r
.2726 .5091 m
.2846 .50102 L
s
.2726 .5091 m
.2725 .53583 L
s
.24 .35 .67 r
.7154 .50102 m
.7274 .5091 L
s
.7274 .5091 m
.7275 .53583 L
s
.83 .24 .1 r
.55912 .30849 m
.52787 .32962 L
s
.24 .35 .67 r
.44088 .30849 m
.47213 .32962 L
s
.319 .081 .039 r
.66073 .5639 m .67665 .55554 L .68174 .53717 L p F P
0 0 0 r
s
.319 .081 .039 r
.6984 .5283 m .68174 .53717 L .67665 .55554 L p F P
0 0 0 r
s
.232 .315 .578 r
.33927 .5639 m .32335 .55554 L .31826 .53717 L p F P
0 0 0 r
s
.232 .315 .578 r
.3016 .5283 m .31826 .53717 L .32335 .55554 L p F P
0 0 0 r
s
.83 .24 .1 r
.29388 .66427 m
.31529 .68579 L
s
.34326 .67017 m
.31529 .68579 L
s
.24 .35 .67 r
.70612 .66427 m
.68471 .68579 L
s
.65674 .67017 m
.68471 .68579 L
s
1 .308 .127 r
.46376 .34686 m .4549 .35297 L .44497 .3534 L p F P
0 0 0 r
s
1 .308 .127 r
.43432 .36077 m .44497 .3534 L .4549 .35297 L p F P
0 0 0 r
s
.159 .261 .547 r
.53624 .34686 m .5451 .35297 L .55503 .3534 L p F P
0 0 0 r
s
.159 .261 .547 r
.56568 .36077 m .55503 .3534 L .5451 .35297 L p F P
0 0 0 r
s
1 .322 .134 r
.5 .3326 m .49303 .33737 L .49081 .3282 L p F P
0 0 0 r
s
1 .322 .134 r
.48171 .33448 m .49081 .3282 L .49303 .33737 L p F P
0 0 0 r
s
.215 .337 .686 r
.5 .3326 m .50697 .33737 L .50919 .3282 L p F P
0 0 0 r
s
.215 .337 .686 r
.51829 .33448 m .50919 .3282 L .50697 .33737 L p F P
0 0 0 r
s
.083 .024 .01 r
.3623 .41139 m .34958 .4202 L .33786 .43554 L p F P
0 0 0 r
s
.083 .024 .01 r
.32443 .44479 m .33786 .43554 L .34958 .4202 L p F P
0 0 0 r
s
.157 .196 .347 r
.6377 .41139 m .65042 .4202 L .66214 .43554 L p F P
0 0 0 r
s
.157 .196 .347 r
.67557 .44479 m .66214 .43554 L .65042 .4202 L p F P
0 0 0 r
s
.83 .24 .1 r
.6122 .29754 m
.58008 .31888 L
s
.58008 .31888 m
.55912 .30849 L
s
.24 .35 .67 r
.3878 .29754 m
.41992 .31888 L
s
.41992 .31888 m
.44088 .30849 L
s
.83 .24 .1 r
.27767 .56463 m
.25066 .58189 L
s
.25066 .58189 m
.26067 .61089 L
s
.24 .35 .67 r
.72233 .56463 m
.74934 .58189 L
s
.74934 .58189 m
.73933 .61089 L
s
.215 .055 .025 r
.63728 .58835 m .65207 .58067 L .66073 .5639 L p F P
0 0 0 r
s
.215 .055 .025 r
.67665 .55554 m .66073 .5639 L .65207 .58067 L p F P
0 0 0 r
s
.199 .262 .472 r
.36272 .58835 m .34793 .58067 L .33927 .5639 L p F P
0 0 0 r
s
.199 .262 .472 r
.32335 .55554 m .33927 .5639 L .34793 .58067 L p F P
0 0 0 r
s
.083 .024 .01 r
.57656 .63255 m .58798 .62669 L .59949 .61633 L p F P
0 0 0 r
s
.083 .024 .01 r
.61263 .60956 m .59949 .61633 L .58798 .62669 L p F P
0 0 0 r
s
.111 .126 .238 r
.42344 .63255 m .41202 .62669 L .40051 .61633 L p F P
0 0 0 r
s
.111 .126 .238 r
.38737 .60956 m .40051 .61633 L .41202 .62669 L p F P
0 0 0 r
s
.914 .283 .117 r
.51414 .66079 m .52128 .6571 L .52711 .65817 L p F P
0 0 0 r
s
.914 .283 .117 r
.53632 .65344 m .52711 .65817 L .52128 .6571 L p F P
0 0 0 r
s
.156 .257 .535 r
.48586 .66079 m .47872 .6571 L .47289 .65817 L p F P
0 0 0 r
s
.156 .257 .535 r
.46368 .65344 m .47289 .65817 L .47872 .6571 L p F P
0 0 0 r
s
.083 .024 .01 r
.5456 .64867 m .55498 .64386 L .56526 .63835 L p F P
0 0 0 r
s
.083 .024 .01 r
.57656 .63255 m .56526 .63835 L .55498 .64386 L p F P
0 0 0 r
s
.073 .085 .162 r
.4544 .64867 m .44502 .64386 L .43474 .63835 L p F P
0 0 0 r
s
.073 .085 .162 r
.42344 .63255 m .43474 .63835 L .44502 .64386 L p F P
0 0 0 r
s
.15 .041 .019 r
.33786 .43554 m .32443 .44479 L .31594 .46236 L p F P
0 0 0 r
s
.15 .041 .019 r
.30213 .47178 m .31594 .46236 L .32443 .44479 L p F P
0 0 0 r
s
.202 .266 .472 r
.66214 .43554 m .67557 .44479 L .68406 .46236 L p F P
0 0 0 r
s
.202 .266 .472 r
.69787 .47178 m .68406 .46236 L .67557 .44479 L p F P
0 0 0 r
s
.83 .24 .1 r
.73093 .49076 m
.72613 .46438 L
s
.76059 .44527 m
.72613 .46438 L
s
.24 .35 .67 r
.26907 .49076 m
.27387 .46438 L
s
.23941 .44527 m
.27387 .46438 L
s
.083 .024 .01 r
.39975 .38278 m .38792 .39099 L .37521 .40245 L p F P
0 0 0 r
s
.083 .024 .01 r
.3623 .41139 m .37521 .40245 L .38792 .39099 L p F P
0 0 0 r
s
.104 .117 .224 r
.60025 .38278 m .61208 .39099 L .62479 .40245 L p F P
0 0 0 r
s
.104 .117 .224 r
.6377 .41139 m .62479 .40245 L .61208 .39099 L p F P
0 0 0 r
s
.862 .266 .108 r
.43432 .36077 m .4238 .36807 L .41172 .37447 L p F P
0 0 0 r
s
.862 .266 .108 r
.39975 .38278 m .41172 .37447 L .4238 .36807 L p F P
0 0 0 r
s
.119 .189 .415 r
.56568 .36077 m .5762 .36807 L .58828 .37447 L p F P
0 0 0 r
s
.119 .189 .415 r
.60025 .38278 m .58828 .37447 L .5762 .36807 L p F P
0 0 0 r
s
1 .322 .134 r
.49081 .3282 m .5 .32187 L .5 .3326 L p F P
0 0 0 r
s
.24 .35 .67 r
.4923 .32504 m
.49385 .3261 L
s
.215 .337 .686 r
.50919 .3282 m .5 .32187 L .5 .3326 L p F P
0 0 0 r
s
.83 .24 .1 r
.50615 .3261 m
.5077 .32504 L
s
.73923 .38916 m
.72397 .36158 L
s
.75845 .34083 m
.72397 .36158 L
s
.72397 .36158 m
.70635 .33556 L
s
.24 .35 .67 r
.26077 .38916 m
.27603 .36158 L
s
.24155 .34083 m
.27603 .36158 L
s
.27603 .36158 m
.29365 .33556 L
s
.1 .028 .011 r
.61263 .60956 m .62594 .60269 L .63728 .58835 L p F P
0 0 0 r
s
.1 .028 .011 r
.65207 .58067 m .63728 .58835 L .62594 .60269 L p F P
0 0 0 r
s
.156 .195 .345 r
.38737 .60956 m .37406 .60269 L .36272 .58835 L p F P
0 0 0 r
s
.156 .195 .345 r
.34793 .58067 m .36272 .58835 L .37406 .60269 L p F P
0 0 0 r
s
.276 .072 .035 r
.31594 .46236 m .30213 .47178 L .29783 .49067 L p F P
0 0 0 r
s
.276 .072 .035 r
.28397 .5 m .29783 .49067 L .30213 .47178 L p F P
0 0 0 r
s
.24 .327 .596 r
.68406 .46236 m .69787 .47178 L .70217 .49067 L p F P
0 0 0 r
s
.24 .327 .596 r
.71603 .5 m .70217 .49067 L .69787 .47178 L p F P
0 0 0 r
s
1 .308 .127 r
.47269 .3407 m .46376 .34686 L .45573 .34594 L p F P
0 0 0 r
s
1 .308 .127 r
.44497 .3534 m .45573 .34594 L .46376 .34686 L p F P
0 0 0 r
s
.159 .261 .547 r
.52731 .3407 m .53624 .34686 L .54427 .34594 L p F P
0 0 0 r
s
.159 .261 .547 r
.55503 .3534 m .54427 .34594 L .53624 .34686 L p F P
0 0 0 r
s
.83 .24 .1 r
.66636 .2917 m
.63327 .31322 L
s
.63327 .31322 m
.6122 .29754 L
s
.24 .35 .67 r
.33364 .2917 m
.36673 .31322 L
s
.36673 .31322 m
.3878 .29754 L
s
.83 .24 .1 r
.27533 .63885 m
.29388 .66427 L
s
.32167 .64822 m
.29388 .66427 L
s
.24 .35 .67 r
.72467 .63885 m
.70612 .66427 L
s
.67833 .64822 m
.70612 .66427 L
s
.83 .24 .1 r
.75159 .41737 m
.73923 .38916 L
s
.77399 .36881 m
.73923 .38916 L
s
.24 .35 .67 r
.24841 .41737 m
.26077 .38916 L
s
.22601 .36881 m
.26077 .38916 L
s
.435 .116 .054 r
.6984 .5283 m .71532 .51929 L .71603 .5 L p F P
0 0 0 r
s
.254 .35 .652 r
.3016 .5283 m .28468 .51929 L .28397 .5 L p F P
0 0 0 r
s
.4 .107 .051 r
.29783 .49067 m .28397 .5 L .28468 .51929 L p F P
0 0 0 r
s
.83 .24 .1 r
.29685 .49279 m
.29986 .49076 L
s
.24 .35 .67 r
.29206 .50322 m
.30292 .5091 L
s
.26907 .49076 m
.28493 .49935 L
s
.265 .367 .679 r
.70217 .49067 m .71603 .5 L .71532 .51929 L p F P
0 0 0 r
s
.24 .35 .67 r
.70014 .49076 m
.70315 .49279 L
s
.83 .24 .1 r
.69708 .5091 m
.70794 .50322 L
s
.71507 .49935 m
.73093 .49076 L
s
.28796 .594 m
.26067 .61089 L
s
.26067 .61089 m
.27533 .63885 L
s
.24 .35 .67 r
.71204 .594 m
.73933 .61089 L
s
.73933 .61089 m
.72467 .63885 L
s
.83 .24 .1 r
.74062 .31435 m
.70635 .33556 L
s
.70635 .33556 m
.68693 .31198 L
s
.24 .35 .67 r
.25938 .31435 m
.29365 .33556 L
s
.29365 .33556 m
.31307 .31198 L
s
.83 .24 .1 r
.34326 .67017 m
.36649 .68711 L
s
.39546 .6714 m
.36649 .68711 L
s
.24 .35 .67 r
.65674 .67017 m
.63351 .68711 L
s
.60454 .6714 m
.63351 .68711 L
s
.914 .283 .117 r
.52128 .6571 m .52848 .6534 L .53632 .65344 L p F P
0 0 0 r
s
.83 .24 .1 r
.53093 .65341 m
.54064 .64983 L
s
.914 .283 .117 r
.5456 .64867 m .53632 .65344 L .52848 .6534 L p F P
0 0 0 r
s
.156 .257 .535 r
.47872 .6571 m .47152 .6534 L .46368 .65344 L p F P
0 0 0 r
s
.24 .35 .67 r
.45936 .64983 m
.46907 .65341 L
s
.156 .257 .535 r
.4544 .64867 m .46368 .65344 L .47152 .6534 L p F P
0 0 0 r
s
.319 .081 .039 r
.67665 .55554 m .6928 .54706 L .6984 .5283 L p F P
0 0 0 r
s
.319 .081 .039 r
.71532 .51929 m .6984 .5283 L .6928 .54706 L p F P
0 0 0 r
s
.83 .24 .1 r
.69708 .5091 m
.69732 .5331 L
s
.232 .315 .578 r
.32335 .55554 m .3072 .54706 L .3016 .5283 L p F P
0 0 0 r
s
.232 .315 .578 r
.28468 .51929 m .3016 .5283 L .3072 .54706 L p F P
0 0 0 r
s
.24 .35 .67 r
.30268 .5331 m
.30292 .5091 L
s
.083 .024 .01 r
.37521 .40245 m .3623 .41139 L .3515 .42615 L p F P
0 0 0 r
s
.083 .024 .01 r
.33786 .43554 m .3515 .42615 L .3623 .41139 L p F P
0 0 0 r
s
.157 .196 .347 r
.62479 .40245 m .6377 .41139 L .6485 .42615 L p F P
0 0 0 r
s
.157 .196 .347 r
.66214 .43554 m .6485 .42615 L .6377 .41139 L p F P
0 0 0 r
s
.83 .24 .1 r
.30289 .62238 m
.27533 .63885 L
s
.24 .35 .67 r
.69711 .62238 m
.72467 .63885 L
s
1 .308 .129 r
.50704 .66444 m .5 .66807 L .5 .65968 L p F P
0 0 0 r
s
.215 .34 .689 r
.49296 .66444 m .5 .66807 L .5 .65968 L p F P
0 0 0 r
s
.083 .024 .01 r
.55498 .64386 m .56444 .63901 L .57656 .63255 L p F P
0 0 0 r
s
.083 .024 .01 r
.58798 .62669 m .57656 .63255 L .56444 .63901 L p F P
0 0 0 r
s
.83 .24 .1 r
.57202 .6337 m
.58566 .6218 L
s
.073 .085 .162 r
.44502 .64386 m .43556 .63901 L .42344 .63255 L p F P
0 0 0 r
s
.073 .085 .162 r
.41202 .62669 m .42344 .63255 L .43556 .63901 L p F P
0 0 0 r
s
.24 .35 .67 r
.41434 .6218 m
.42798 .6337 L
s
.083 .024 .01 r
.58798 .62669 m .59953 .62076 L .61263 .60956 L p F P
0 0 0 r
s
.083 .024 .01 r
.62594 .60269 m .61263 .60956 L .59953 .62076 L p F P
0 0 0 r
s
.83 .24 .1 r
.58566 .6218 m
.6177 .60526 L
s
.6177 .60526 m
.6269 .58855 L
s
.111 .126 .238 r
.41202 .62669 m .40047 .62076 L .38737 .60956 L p F P
0 0 0 r
s
.111 .126 .238 r
.37406 .60269 m .38737 .60956 L .40047 .62076 L p F P
0 0 0 r
s
.24 .35 .67 r
.3823 .60526 m
.41434 .6218 L
s
.3731 .58855 m
.3823 .60526 L
s
.83 .24 .1 r
.2725 .53583 m
.27767 .56463 L
s
.24 .35 .67 r
.7275 .53583 m
.72233 .56463 L
s
.215 .055 .025 r
.65207 .58067 m .66705 .57288 L .67665 .55554 L p F P
0 0 0 r
s
.83 .24 .1 r
.6269 .58855 m
.65957 .5715 L
s
.65957 .5715 m
.66406 .55074 L
s
.215 .055 .025 r
.6928 .54706 m .67665 .55554 L .66705 .57288 L p F P
0 0 0 r
s
.83 .24 .1 r
.66406 .55074 m
.69732 .5331 L
s
.199 .262 .472 r
.34793 .58067 m .33295 .57288 L .32335 .55554 L p F P
0 0 0 r
s
.24 .35 .67 r
.34043 .5715 m
.3731 .58855 L
s
.33594 .55074 m
.34043 .5715 L
s
.199 .262 .472 r
.3072 .54706 m .32335 .55554 L .33295 .57288 L p F P
0 0 0 r
s
.24 .35 .67 r
.30268 .5331 m
.33594 .55074 L
s
.862 .266 .108 r
.44497 .3534 m .43432 .36077 L .42385 .36605 L p F P
0 0 0 r
s
.862 .266 .108 r
.41172 .37447 m .42385 .36605 L .43432 .36077 L p F P
0 0 0 r
s
.83 .24 .1 r
.41261 .37574 m
.4289 .368 L
s
.119 .189 .415 r
.55503 .3534 m .56568 .36077 L .57615 .36605 L p F P
0 0 0 r
s
.119 .189 .415 r
.58828 .37447 m .57615 .36605 L .56568 .36077 L p F P
0 0 0 r
s
.24 .35 .67 r
.5711 .368 m
.58739 .37574 L
s
1 .308 .127 r
.48171 .33448 m .47269 .3407 L .46661 .3384 L p F P
0 0 0 r
s
.83 .24 .1 r
.47725 .34591 m
.50151 .32928 L
s
1 .308 .127 r
.45573 .34594 m .46661 .3384 L .47269 .3407 L p F P
0 0 0 r
s
.83 .24 .1 r
.45863 .34746 m
.47725 .34591 L
s
.159 .261 .547 r
.51829 .33448 m .52731 .3407 L .53339 .3384 L p F P
0 0 0 r
s
.24 .35 .67 r
.49849 .32928 m
.52275 .34591 L
s
.159 .261 .547 r
.54427 .34594 m .53339 .3384 L .52731 .3407 L p F P
0 0 0 r
s
.24 .35 .67 r
.52275 .34591 m
.54137 .34746 L
s
.083 .024 .01 r
.41172 .37447 m .39975 .38278 L .38829 .39338 L p F P
0 0 0 r
s
.83 .24 .1 r
.38356 .39587 m
.39169 .39024 L
s
.083 .024 .01 r
.37521 .40245 m .38829 .39338 L .39975 .38278 L p F P
0 0 0 r
s
.83 .24 .1 r
.39522 .38779 m
.41261 .37574 L
s
.104 .117 .224 r
.58828 .37447 m .60025 .38278 L .61171 .39338 L p F P
0 0 0 r
s
.24 .35 .67 r
.60831 .39024 m
.61644 .39587 L
s
.104 .117 .224 r
.62479 .40245 m .61171 .39338 L .60025 .38278 L p F P
0 0 0 r
s
.24 .35 .67 r
.58739 .37574 m
.60478 .38779 L
s
.15 .041 .019 r
.3515 .42615 m .33786 .43554 L .32997 .45279 L p F P
0 0 0 r
s
.15 .041 .019 r
.31594 .46236 m .32997 .45279 L .33786 .43554 L p F P
0 0 0 r
s
.202 .266 .472 r
.6485 .42615 m .66214 .43554 L .67003 .45279 L p F P
0 0 0 r
s
.202 .266 .472 r
.68406 .46236 m .67003 .45279 L .66214 .43554 L p F P
0 0 0 r
s
.83 .24 .1 r
.76059 .44527 m
.75159 .41737 L
s
.78672 .39737 m
.75159 .41737 L
s
.24 .35 .67 r
.23941 .44527 m
.24841 .41737 L
s
.21328 .39737 m
.24841 .41737 L
s
.83 .24 .1 r
.39546 .6714 m
.41911 .68294 L
s
.44903 .6671 m
.41911 .68294 L
s
.24 .35 .67 r
.60454 .6714 m
.58089 .68294 L
s
.55097 .6671 m
.58089 .68294 L
s
.1 .028 .011 r
.62594 .60269 m .63942 .59574 L .65207 .58067 L p F P
0 0 0 r
s
.1 .028 .011 r
.66705 .57288 m .65207 .58067 L .63942 .59574 L p F P
0 0 0 r
s
.156 .195 .345 r
.37406 .60269 m .36058 .59574 L .34793 .58067 L p F P
0 0 0 r
s
.156 .195 .345 r
.33295 .57288 m .34793 .58067 L .36058 .59574 L p F P
0 0 0 r
s
1 .308 .129 r
.5 .65968 m .50488 .65714 L .50704 .66444 L p F P
0 0 0 r
s
1 .308 .129 r
.51414 .66079 m .50704 .66444 L .50488 .65714 L p F P
0 0 0 r
s
.215 .34 .689 r
.5 .65968 m .49512 .65714 L .49296 .66444 L p F P
0 0 0 r
s
.215 .34 .689 r
.48586 .66079 m .49296 .66444 L .49512 .65714 L p F P
0 0 0 r
s
.914 .283 .117 r
.52848 .6534 m .53573 .64966 L .5456 .64867 L p F P
0 0 0 r
s
.914 .283 .117 r
.55498 .64386 m .5456 .64867 L .53573 .64966 L p F P
0 0 0 r
s
.83 .24 .1 r
.54837 .64585 m
.57202 .6337 L
s
.156 .257 .535 r
.47152 .6534 m .46427 .64966 L .4544 .64867 L p F P
0 0 0 r
s
.156 .257 .535 r
.44502 .64386 m .4544 .64867 L .46427 .64966 L p F P
0 0 0 r
s
.24 .35 .67 r
.42798 .6337 m
.45163 .64585 L
s
.83 .24 .1 r
.72109 .29029 m
.68693 .31198 L
s
.68693 .31198 m
.66636 .2917 L
s
.24 .35 .67 r
.27891 .29029 m
.31307 .31198 L
s
.31307 .31198 m
.33364 .2917 L
s
.276 .072 .035 r
.32997 .45279 m .31594 .46236 L .3119 .48119 L p F P
0 0 0 r
s
.276 .072 .035 r
.29783 .49067 m .3119 .48119 L .31594 .46236 L p F P
0 0 0 r
s
.83 .24 .1 r
.29986 .49076 m
.30022 .48906 L
s
.24 .327 .596 r
.67003 .45279 m .68406 .46236 L .6881 .48119 L p F P
0 0 0 r
s
.24 .327 .596 r
.70217 .49067 m .6881 .48119 L .68406 .46236 L p F P
0 0 0 r
s
.24 .35 .67 r
.69978 .48906 m
.70014 .49076 L
s
.83 .24 .1 r
.44903 .6671 m
.47174 .67275 L
s
.47174 .67275 m
.49279 .6618 L
s
.24 .35 .67 r
.55097 .6671 m
.52826 .67275 L
s
.50721 .6618 m
.52826 .67275 L
s
.83 .24 .1 r
.73093 .49076 m
.76584 .47185 L
s
.24 .35 .67 r
.26907 .49076 m
.23416 .47185 L
s
.83 .24 .1 r
.73162 .5149 m
.73093 .49076 L
s
.24 .35 .67 r
.26838 .5149 m
.26907 .49076 L
s
.4 .107 .051 r
.3119 .48119 m .29783 .49067 L .2985 .51014 L p F P
0 0 0 r
s
.4 .107 .051 r
.28468 .51929 m .2985 .51014 L .29783 .49067 L p F P
0 0 0 r
s
.265 .367 .679 r
.6881 .48119 m .70217 .49067 L .7015 .51014 L p F P
0 0 0 r
s
.265 .367 .679 r
.71532 .51929 m .7015 .51014 L .70217 .49067 L p F P
0 0 0 r
s
.083 .024 .01 r
.56444 .63901 m .57399 .63411 L .58798 .62669 L p F P
0 0 0 r
s
.083 .024 .01 r
.59953 .62076 m .58798 .62669 L .57399 .63411 L p F P
0 0 0 r
s
.073 .085 .162 r
.43556 .63901 m .42601 .63411 L .41202 .62669 L p F P
0 0 0 r
s
.073 .085 .162 r
.40047 .62076 m .41202 .62669 L .42601 .63411 L p F P
0 0 0 r
s
1 .308 .127 r
.49081 .3282 m .48171 .33448 L .47761 .33077 L p F P
0 0 0 r
s
.24 .35 .67 r
.47213 .32962 m
.4923 .32504 L
s
1 .308 .127 r
.46661 .3384 m .47761 .33077 L .48171 .33448 L p F P
0 0 0 r
s
.159 .261 .547 r
.50919 .3282 m .51829 .33448 L .52239 .33077 L p F P
0 0 0 r
s
.83 .24 .1 r
.5077 .32504 m
.52787 .32962 L
s
.159 .261 .547 r
.53339 .3384 m .52239 .33077 L .51829 .33448 L p F P
0 0 0 r
s
.83 .24 .1 r
.50487 .32523 m
.5077 .32504 L
s
.24 .35 .67 r
.4923 .32504 m
.49513 .32523 L
s
.083 .024 .01 r
.38829 .39338 m .37521 .40245 L .36534 .41661 L p F P
0 0 0 r
s
.083 .024 .01 r
.3515 .42615 m .36534 .41661 L .37521 .40245 L p F P
0 0 0 r
s
.157 .196 .347 r
.61171 .39338 m .62479 .40245 L .63466 .41661 L p F P
0 0 0 r
s
.157 .196 .347 r
.6485 .42615 m .63466 .41661 L .62479 .40245 L p F P
0 0 0 r
s
.83 .24 .1 r
.59135 .28669 m
.55912 .30849 L
s
.55912 .30849 m
.53912 .3035 L
s
.24 .35 .67 r
.40865 .28669 m
.44088 .30849 L
s
.44088 .30849 m
.46088 .3035 L
s
.862 .266 .108 r
.45573 .34594 m .44497 .3534 L .43613 .35752 L p F P
0 0 0 r
s
.862 .266 .108 r
.42385 .36605 m .43613 .35752 L .44497 .3534 L p F P
0 0 0 r
s
.83 .24 .1 r
.4289 .368 m
.45863 .34746 L
s
.119 .189 .415 r
.54427 .34594 m .55503 .3534 L .56387 .35752 L p F P
0 0 0 r
s
.119 .189 .415 r
.57615 .36605 m .56387 .35752 L .55503 .3534 L p F P
0 0 0 r
s
.24 .35 .67 r
.54137 .34746 m
.5711 .368 L
s
.083 .024 .01 r
.59953 .62076 m .61121 .61476 L .62594 .60269 L p F P
0 0 0 r
s
.083 .024 .01 r
.63942 .59574 m .62594 .60269 L .61121 .61476 L p F P
0 0 0 r
s
.111 .126 .238 r
.40047 .62076 m .38879 .61476 L .37406 .60269 L p F P
0 0 0 r
s
.111 .126 .238 r
.36058 .59574 m .37406 .60269 L .38879 .61476 L p F P
0 0 0 r
s
.319 .081 .039 r
.6928 .54706 m .70919 .53845 L .71532 .51929 L p F P
0 0 0 r
s
.232 .315 .578 r
.3072 .54706 m .29081 .53845 L .28468 .51929 L p F P
0 0 0 r
s
.511 .142 .065 r
.2985 .51014 m .28468 .51929 L .29081 .53845 L p F P
0 0 0 r
s
.83 .24 .1 r
.2725 .53583 m
.28678 .52645 L
s
.24 .35 .67 r
.28642 .52447 m
.28738 .52498 L
s
.29358 .52826 m
.30268 .5331 L
s
.26838 .5149 m
.28642 .52447 L
s
.83 .24 .1 r
.28678 .52645 m
.28694 .52634 L
s
.281 .394 .737 r
.7015 .51014 m .71532 .51929 L .70919 .53845 L p F P
0 0 0 r
s
.24 .35 .67 r
.71322 .52645 m
.7275 .53583 L
s
.83 .24 .1 r
.71262 .52498 m
.71358 .52447 L
s
.69732 .5331 m
.70642 .52826 L
s
.71358 .52447 m
.73162 .5149 L
s
.24 .35 .67 r
.71306 .52634 m
.71322 .52645 L
s
1 .308 .129 r
.50488 .65714 m .50979 .65459 L .51414 .66079 L p F P
0 0 0 r
s
.24 .35 .67 r
.50287 .65954 m
.50721 .6618 L
s
1 .308 .129 r
.52128 .6571 m .51414 .66079 L .50979 .65459 L p F P
0 0 0 r
s
.83 .24 .1 r
.5181 .65641 m
.52282 .65631 L
s
.215 .34 .689 r
.49512 .65714 m .49021 .65459 L .48586 .66079 L p F P
0 0 0 r
s
.83 .24 .1 r
.49279 .6618 m
.49713 .65954 L
s
.215 .34 .689 r
.47872 .6571 m .48586 .66079 L .49021 .65459 L p F P
0 0 0 r
s
.24 .35 .67 r
.47718 .65631 m
.4819 .65641 L
s
.83 .24 .1 r
.32167 .64822 m
.34326 .67017 L
s
.37212 .65406 m
.34326 .67017 L
s
.24 .35 .67 r
.67833 .64822 m
.65674 .67017 L
s
.62788 .65406 m
.65674 .67017 L
s
.083 .024 .01 r
.42385 .36605 m .41172 .37447 L .40156 .38419 L p F P
0 0 0 r
s
.083 .024 .01 r
.38829 .39338 m .40156 .38419 L .41172 .37447 L p F P
0 0 0 r
s
.104 .117 .224 r
.57615 .36605 m .58828 .37447 L .59844 .38419 L p F P
0 0 0 r
s
.104 .117 .224 r
.61171 .39338 m .59844 .38419 L .58828 .37447 L p F P
0 0 0 r
s
.914 .283 .117 r
.53573 .64966 m .54303 .6459 L .55498 .64386 L p F P
0 0 0 r
s
.914 .283 .117 r
.56444 .63901 m .55498 .64386 L .54303 .6459 L p F P
0 0 0 r
s
.156 .257 .535 r
.46427 .64966 m .45697 .6459 L .44502 .64386 L p F P
0 0 0 r
s
.156 .257 .535 r
.43556 .63901 m .44502 .64386 L .45697 .6459 L p F P
0 0 0 r
s
.83 .24 .1 r
.64533 .27553 m
.6122 .29754 L
s
.6122 .29754 m
.59135 .28669 L
s
.24 .35 .67 r
.35467 .27553 m
.3878 .29754 L
s
.3878 .29754 m
.40865 .28669 L
s
.215 .055 .025 r
.66705 .57288 m .68225 .56498 L .6928 .54706 L p F P
0 0 0 r
s
.215 .055 .025 r
.70919 .53845 m .6928 .54706 L .68225 .56498 L p F P
0 0 0 r
s
.199 .262 .472 r
.33295 .57288 m .31775 .56498 L .3072 .54706 L p F P
0 0 0 r
s
.199 .262 .472 r
.29081 .53845 m .3072 .54706 L .31775 .56498 L p F P
0 0 0 r
s
.83 .24 .1 r
.27767 .56463 m
.28796 .594 L
s
.24 .35 .67 r
.72233 .56463 m
.71204 .594 L
s
.15 .041 .019 r
.36534 .41661 m .3515 .42615 L .34421 .44307 L p F P
0 0 0 r
s
.15 .041 .019 r
.32997 .45279 m .34421 .44307 L .3515 .42615 L p F P
0 0 0 r
s
.202 .266 .472 r
.63466 .41661 m .6485 .42615 L .65579 .44307 L p F P
0 0 0 r
s
.202 .266 .472 r
.67003 .45279 m .65579 .44307 L .6485 .42615 L p F P
0 0 0 r
s
.1 .028 .011 r
.63942 .59574 m .65308 .58871 L .66705 .57288 L p F P
0 0 0 r
s
.1 .028 .011 r
.68225 .56498 m .66705 .57288 L .65308 .58871 L p F P
0 0 0 r
s
.156 .195 .345 r
.36058 .59574 m .34692 .58871 L .33295 .57288 L p F P
0 0 0 r
s
.156 .195 .345 r
.31775 .56498 m .33295 .57288 L .34692 .58871 L p F P
0 0 0 r
s
.83 .24 .1 r
.76584 .47185 m
.76059 .44527 L
s
.79615 .42555 m
.76059 .44527 L
s
.24 .35 .67 r
.23416 .47185 m
.23941 .44527 L
s
.20385 .42555 m
.23941 .44527 L
s
1 .308 .129 r
.50979 .65459 m .51472 .65203 L .52128 .6571 L p F P
0 0 0 r
s
1 .308 .129 r
.52848 .6534 m .52128 .6571 L .51472 .65203 L p F P
0 0 0 r
s
.215 .34 .689 r
.49021 .65459 m .48528 .65203 L .47872 .6571 L p F P
0 0 0 r
s
.215 .34 .689 r
.47152 .6534 m .47872 .6571 L .48528 .65203 L p F P
0 0 0 r
s
1 .308 .127 r
.5 .32187 m .49081 .3282 L .48874 .32305 L p F P
0 0 0 r
s
1 .308 .127 r
.47761 .33077 m .48874 .32305 L .49081 .3282 L p F P
0 0 0 r
s
.159 .261 .547 r
.5 .32187 m .50919 .3282 L .51126 .32305 L p F P
0 0 0 r
s
.83 .24 .1 r
.48929 .32626 m
.50249 .32538 L
s
.159 .261 .547 r
.52239 .33077 m .51126 .32305 L .50919 .3282 L p F P
0 0 0 r
s
.24 .35 .67 r
.49751 .32538 m
.51071 .32626 L
s
.083 .024 .01 r
.57399 .63411 m .58363 .62916 L .59953 .62076 L p F P
0 0 0 r
s
.083 .024 .01 r
.61121 .61476 m .59953 .62076 L .58363 .62916 L p F P
0 0 0 r
s
.073 .085 .162 r
.42601 .63411 m .41637 .62916 L .40047 .62076 L p F P
0 0 0 r
s
.073 .085 .162 r
.38879 .61476 m .40047 .62076 L .41637 .62916 L p F P
0 0 0 r
s
.83 .24 .1 r
.77399 .36881 m
.75845 .34083 L
s
.79402 .31942 m
.75845 .34083 L
s
.75845 .34083 m
.74062 .31435 L
s
.24 .35 .67 r
.22601 .36881 m
.24155 .34083 L
s
.20598 .31942 m
.24155 .34083 L
s
.24155 .34083 m
.25938 .31435 L
s
.276 .072 .035 r
.34421 .44307 m .32997 .45279 L .32621 .47156 L p F P
0 0 0 r
s
.276 .072 .035 r
.3119 .48119 m .32621 .47156 L .32997 .45279 L p F P
0 0 0 r
s
.24 .327 .596 r
.65579 .44307 m .67003 .45279 L .67379 .47156 L p F P
0 0 0 r
s
.24 .327 .596 r
.6881 .48119 m .67379 .47156 L .67003 .45279 L p F P
0 0 0 r
s
.862 .266 .108 r
.46661 .3384 m .45573 .34594 L .44857 .34889 L p F P
0 0 0 r
s
.862 .266 .108 r
.43613 .35752 m .44857 .34889 L .45573 .34594 L p F P
0 0 0 r
s
.119 .189 .415 r
.53339 .3384 m .54427 .34594 L .55143 .34889 L p F P
0 0 0 r
s
.119 .189 .415 r
.56387 .35752 m .55143 .34889 L .54427 .34594 L p F P
0 0 0 r
s
.83 .24 .1 r
.70049 .2695 m
.66636 .2917 L
s
.66636 .2917 m
.64533 .27553 L
s
.24 .35 .67 r
.29951 .2695 m
.33364 .2917 L
s
.33364 .2917 m
.35467 .27553 L
s
.914 .283 .117 r
.54303 .6459 m .55039 .64211 L .56444 .63901 L p F P
0 0 0 r
s
.914 .283 .117 r
.57399 .63411 m .56444 .63901 L .55039 .64211 L p F P
0 0 0 r
s
.156 .257 .535 r
.45697 .6459 m .44961 .64211 L .43556 .63901 L p F P
0 0 0 r
s
.156 .257 .535 r
.42601 .63411 m .43556 .63901 L .44961 .64211 L p F P
0 0 0 r
s
.83 .24 .1 r
.30289 .62238 m
.32167 .64822 L
s
.35034 .63167 m
.32167 .64822 L
s
.24 .35 .67 r
.69711 .62238 m
.67833 .64822 L
s
.64966 .63167 m
.67833 .64822 L
s
.083 .024 .01 r
.61121 .61476 m .62302 .6087 L .63942 .59574 L p F P
0 0 0 r
s
.083 .024 .01 r
.65308 .58871 m .63942 .59574 L .62302 .6087 L p F P
0 0 0 r
s
.83 .24 .1 r
.6177 .60526 m
.65075 .58819 L
s
.111 .126 .238 r
.38879 .61476 m .37698 .6087 L .36058 .59574 L p F P
0 0 0 r
s
.111 .126 .238 r
.34692 .58871 m .36058 .59574 L .37698 .6087 L p F P
0 0 0 r
s
.24 .35 .67 r
.34925 .58819 m
.3823 .60526 L
s
.83 .24 .1 r
.78672 .39737 m
.77399 .36881 L
s
.80986 .34782 m
.77399 .36881 L
s
.24 .35 .67 r
.21328 .39737 m
.22601 .36881 L
s
.19014 .34782 m
.22601 .36881 L
s
.083 .024 .01 r
.40156 .38419 m .38829 .39338 L .37939 .40693 L p F P
0 0 0 r
s
.083 .024 .01 r
.36534 .41661 m .37939 .40693 L .38829 .39338 L p F P
0 0 0 r
s
.157 .196 .347 r
.59844 .38419 m .61171 .39338 L .62061 .40693 L p F P
0 0 0 r
s
.157 .196 .347 r
.63466 .41661 m .62061 .40693 L .61171 .39338 L p F P
0 0 0 r
s
.4 .107 .051 r
.32621 .47156 m .3119 .48119 L .31254 .50085 L p F P
0 0 0 r
s
.83 .24 .1 r
.31091 .48333 m
.31195 .48263 L
s
.32519 .47373 m
.32798 .47185 L
s
.4 .107 .051 r
.2985 .51014 m .31254 .50085 L .3119 .48119 L p F P
0 0 0 r
s
.265 .367 .679 r
.67379 .47156 m .6881 .48119 L .68746 .50085 L p F P
0 0 0 r
s
.24 .35 .67 r
.67202 .47185 m
.67481 .47373 L
s
.68805 .48263 m
.68909 .48333 L
s
.265 .367 .679 r
.7015 .51014 m .68746 .50085 L .6881 .48119 L p F P
0 0 0 r
s
.83 .24 .1 r
.28796 .594 m
.30289 .62238 L
s
.24 .35 .67 r
.71204 .594 m
.69711 .62238 L
s
.83 .24 .1 r
.77599 .29248 m
.74062 .31435 L
s
.74062 .31435 m
.72109 .29029 L
s
.24 .35 .67 r
.22401 .29248 m
.25938 .31435 L
s
.25938 .31435 m
.27891 .29029 L
s
1 .308 .129 r
.51472 .65203 m .51968 .64945 L .52848 .6534 L p F P
0 0 0 r
s
1 .308 .129 r
.53573 .64966 m .52848 .6534 L .51968 .64945 L p F P
0 0 0 r
s
.215 .34 .689 r
.48528 .65203 m .48032 .64945 L .47152 .6534 L p F P
0 0 0 r
s
.215 .34 .689 r
.46427 .64966 m .47152 .6534 L .48032 .64945 L p F P
0 0 0 r
s
.83 .24 .1 r
.37212 .65406 m
.39546 .6714 L
s
.42535 .6552 m
.39546 .6714 L
s
.24 .35 .67 r
.62788 .65406 m
.60454 .6714 L
s
.57465 .6552 m
.60454 .6714 L
s
.083 .024 .01 r
.43613 .35752 m .42385 .36605 L .41502 .37487 L p F P
0 0 0 r
s
.83 .24 .1 r
.41261 .37574 m
.41765 .37225 L
s
.083 .024 .01 r
.40156 .38419 m .41502 .37487 L .42385 .36605 L p F P
0 0 0 r
s
.104 .117 .224 r
.56387 .35752 m .57615 .36605 L .58498 .37487 L p F P
0 0 0 r
s
.24 .35 .67 r
.58235 .37225 m
.58739 .37574 L
s
.104 .117 .224 r
.59844 .38419 m .58498 .37487 L .57615 .36605 L p F P
0 0 0 r
s
.511 .142 .065 r
.31254 .50085 m .2985 .51014 L .30428 .52971 L p F P
0 0 0 r
s
.511 .142 .065 r
.29081 .53845 m .30428 .52971 L .2985 .51014 L p F P
0 0 0 r
s
.281 .394 .737 r
.68746 .50085 m .7015 .51014 L .69572 .52971 L p F P
0 0 0 r
s
.281 .394 .737 r
.70919 .53845 m .69572 .52971 L .7015 .51014 L p F P
0 0 0 r
s
.83 .24 .1 r
.33133 .60538 m
.30289 .62238 L
s
.24 .35 .67 r
.66867 .60538 m
.69711 .62238 L
s
1 .308 .127 r
.48874 .32305 m .5 .31525 L .5 .32187 L p F P
0 0 0 r
s
.24 .35 .67 r
.46088 .3035 m
.48907 .32283 L
s
.159 .261 .547 r
.51126 .32305 m .5 .31525 L .5 .32187 L p F P
0 0 0 r
s
.83 .24 .1 r
.51093 .32283 m
.53912 .3035 L
s
.215 .055 .025 r
.68225 .56498 m .69767 .55697 L .70919 .53845 L p F P
0 0 0 r
s
.199 .262 .472 r
.31775 .56498 m .30233 .55697 L .29081 .53845 L p F P
0 0 0 r
s
.599 .169 .076 r
.30428 .52971 m .29081 .53845 L .30233 .55697 L p F P
0 0 0 r
s
.83 .24 .1 r
.29757 .55191 m
.29872 .55117 L
s
.27767 .56463 m
.29757 .55191 L
s
.24 .35 .67 r
.30367 .53818 m
.30674 .55392 L
s
.291 .413 .778 r
.69572 .52971 m .70919 .53845 L .69767 .55697 L p F P
0 0 0 r
s
.24 .35 .67 r
.70128 .55117 m
.70243 .55191 L
s
.70243 .55191 m
.72233 .56463 L
s
.83 .24 .1 r
.69326 .55392 m
.69633 .53818 L
s
.083 .024 .01 r
.58363 .62916 m .59335 .62416 L .61121 .61476 L p F P
0 0 0 r
s
.083 .024 .01 r
.62302 .6087 m .61121 .61476 L .59335 .62416 L p F P
0 0 0 r
s
.83 .24 .1 r
.60438 .61706 m
.6177 .60526 L
s
.073 .085 .162 r
.41637 .62916 m .40665 .62416 L .38879 .61476 L p F P
0 0 0 r
s
.073 .085 .162 r
.37698 .6087 m .38879 .61476 L .40665 .62416 L p F P
0 0 0 r
s
.24 .35 .67 r
.3823 .60526 m
.39562 .61706 L
s
.15 .041 .019 r
.37939 .40693 m .36534 .41661 L .35868 .4332 L p F P
0 0 0 r
s
.15 .041 .019 r
.34421 .44307 m .35868 .4332 L .36534 .41661 L p F P
0 0 0 r
s
.202 .266 .472 r
.62061 .40693 m .63466 .41661 L .64132 .4332 L p F P
0 0 0 r
s
.202 .266 .472 r
.65579 .44307 m .64132 .4332 L .63466 .41661 L p F P
0 0 0 r
s
.1 .028 .011 r
.65308 .58871 m .6669 .58158 L .68225 .56498 L p F P
0 0 0 r
s
.83 .24 .1 r
.65075 .58819 m
.65957 .5715 L
s
.1 .028 .011 r
.69767 .55697 m .68225 .56498 L .6669 .58158 L p F P
0 0 0 r
s
.83 .24 .1 r
.65957 .5715 m
.69326 .55392 L
s
.156 .195 .345 r
.34692 .58871 m .3331 .58158 L .31775 .56498 L p F P
0 0 0 r
s
.24 .35 .67 r
.34043 .5715 m
.34925 .58819 L
s
.156 .195 .345 r
.30233 .55697 m .31775 .56498 L .3331 .58158 L p F P
0 0 0 r
s
.24 .35 .67 r
.30674 .55392 m
.34043 .5715 L
s
.914 .283 .117 r
.55039 .64211 m .55779 .63829 L .57399 .63411 L p F P
0 0 0 r
s
.83 .24 .1 r
.56341 .63684 m
.57202 .6337 L
s
.914 .283 .117 r
.58363 .62916 m .57399 .63411 L .55779 .63829 L p F P
0 0 0 r
s
.83 .24 .1 r
.57475 .6323 m
.60438 .61706 L
s
.156 .257 .535 r
.44961 .64211 m .44221 .63829 L .42601 .63411 L p F P
0 0 0 r
s
.24 .35 .67 r
.42798 .6337 m
.43659 .63684 L
s
.156 .257 .535 r
.41637 .62916 m .42601 .63411 L .44221 .63829 L p F P
0 0 0 r
s
.24 .35 .67 r
.39562 .61706 m
.42525 .6323 L
s
.862 .266 .108 r
.47761 .33077 m .46661 .3384 L .46118 .34014 L p F P
0 0 0 r
s
.862 .266 .108 r
.44857 .34889 m .46118 .34014 L .46661 .3384 L p F P
0 0 0 r
s
.83 .24 .1 r
.45863 .34746 m
.48929 .32626 L
s
.119 .189 .415 r
.52239 .33077 m .53339 .3384 L .53882 .34014 L p F P
0 0 0 r
s
.119 .189 .415 r
.55143 .34889 m .53882 .34014 L .53339 .3384 L p F P
0 0 0 r
s
.24 .35 .67 r
.51071 .32626 m
.54137 .34746 L
s
1 .308 .129 r
.51968 .64945 m .52466 .64686 L .53573 .64966 L p F P
0 0 0 r
s
1 .308 .129 r
.54303 .6459 m .53573 .64966 L .52466 .64686 L p F P
0 0 0 r
s
.215 .34 .689 r
.48032 .64945 m .47534 .64686 L .46427 .64966 L p F P
0 0 0 r
s
.215 .34 .689 r
.45697 .6459 m .46427 .64966 L .47534 .64686 L p F P
0 0 0 r
s
.83 .24 .1 r
.79615 .42555 m
.78672 .39737 L
s
.82296 .37673 m
.78672 .39737 L
s
.24 .35 .67 r
.20385 .42555 m
.21328 .39737 L
s
.17704 .37673 m
.21328 .39737 L
s
.83 .24 .1 r
.70298 .54884 m
.72802 .53577 L
s
.70099 .54988 m
.70298 .54884 L
s
.69326 .55392 m
.6973 .55181 L
s
.24 .35 .67 r
.27198 .53577 m
.29702 .54884 L
s
.29702 .54884 m
.29901 .54988 L
s
.3027 .55181 m
.30674 .55392 L
s
.83 .24 .1 r
.42535 .6552 m
.44903 .6671 L
s
.44903 .6671 m
.47991 .65076 L
s
.24 .35 .67 r
.57465 .6552 m
.55097 .6671 L
s
.52009 .65076 m
.55097 .6671 L
s
.83 .24 .1 r
.72802 .53577 m
.73162 .5149 L
s
.76702 .49611 m
.73162 .5149 L
s
.24 .35 .67 r
.27198 .53577 m
.26838 .5149 L
s
.23298 .49611 m
.26838 .5149 L
s
1 .311 .131 r
.50488 .65714 m .5 .65968 L .5 .64685 L p F P
0 0 0 r
s
.83 .24 .1 r
.50466 .65668 m
.50582 .65665 L
s
.49843 .65886 m
.5 .65804 L
s
.256 .395 .786 r
.49512 .65714 m .5 .65968 L .5 .64685 L p F P
0 0 0 r
s
.24 .35 .67 r
.49418 .65665 m
.49534 .65668 L
s
.083 .024 .01 r
.62302 .6087 m .63496 .60257 L .65308 .58871 L p F P
0 0 0 r
s
.083 .024 .01 r
.6669 .58158 m .65308 .58871 L .63496 .60257 L p F P
0 0 0 r
s
.111 .126 .238 r
.37698 .6087 m .36504 .60257 L .34692 .58871 L p F P
0 0 0 r
s
.111 .126 .238 r
.3331 .58158 m .34692 .58871 L .36504 .60257 L p F P
0 0 0 r
s
.83 .24 .1 r
.75634 .26791 m
.72109 .29029 L
s
.72109 .29029 m
.70049 .2695 L
s
.24 .35 .67 r
.24366 .26791 m
.27891 .29029 L
s
.27891 .29029 m
.29951 .2695 L
s
.276 .072 .035 r
.35868 .4332 m .34421 .44307 L .34074 .46178 L p F P
0 0 0 r
s
.276 .072 .035 r
.32621 .47156 m .34074 .46178 L .34421 .44307 L p F P
0 0 0 r
s
.83 .24 .1 r
.32798 .47185 m
.32832 .47014 L
s
.24 .327 .596 r
.64132 .4332 m .65579 .44307 L .65926 .46178 L p F P
0 0 0 r
s
.24 .327 .596 r
.67379 .47156 m .65926 .46178 L .65579 .44307 L p F P
0 0 0 r
s
.24 .35 .67 r
.67168 .47014 m
.67202 .47185 L
s
.083 .024 .01 r
.41502 .37487 m .40156 .38419 L .39366 .39711 L p F P
0 0 0 r
s
.083 .024 .01 r
.37939 .40693 m .39366 .39711 L .40156 .38419 L p F P
0 0 0 r
s
.157 .196 .347 r
.58498 .37487 m .59844 .38419 L .60634 .39711 L p F P
0 0 0 r
s
.157 .196 .347 r
.62061 .40693 m .60634 .39711 L .59844 .38419 L p F P
0 0 0 r
s
.083 .024 .01 r
.44857 .34889 m .43613 .35752 L .42868 .36541 L p F P
0 0 0 r
s
.83 .24 .1 r
.44258 .35496 m
.45863 .34746 L
s
.42127 .36974 m
.43089 .36306 L
s
.083 .024 .01 r
.41502 .37487 m .42868 .36541 L .43613 .35752 L p F P
0 0 0 r
s
.83 .24 .1 r
.43457 .36052 m
.44258 .35496 L
s
.104 .117 .224 r
.55143 .34889 m .56387 .35752 L .57132 .36541 L p F P
0 0 0 r
s
.24 .35 .67 r
.54137 .34746 m
.55742 .35496 L
s
.56911 .36306 m
.57873 .36974 L
s
.104 .117 .224 r
.58498 .37487 m .57132 .36541 L .56387 .35752 L p F P
0 0 0 r
s
.24 .35 .67 r
.55742 .35496 m
.56543 .36052 L
s
.83 .24 .1 r
.76584 .47185 m
.80187 .45234 L
s
.24 .35 .67 r
.23416 .47185 m
.19813 .45234 L
s
.83 .24 .1 r
.76702 .49611 m
.76584 .47185 L
s
.24 .35 .67 r
.23298 .49611 m
.23416 .47185 L
s
1 .308 .129 r
.52466 .64686 m .52967 .64426 L .54303 .6459 L p F P
0 0 0 r
s
1 .308 .129 r
.55039 .64211 m .54303 .6459 L .52967 .64426 L p F P
0 0 0 r
s
.215 .34 .689 r
.47534 .64686 m .47033 .64426 L .45697 .6459 L p F P
0 0 0 r
s
.215 .34 .689 r
.44961 .64211 m .45697 .6459 L .47033 .64426 L p F P
0 0 0 r
s
.4 .107 .051 r
.34074 .46178 m .32621 .47156 L .3268 .49141 L p F P
0 0 0 r
s
.4 .107 .051 r
.31254 .50085 m .3268 .49141 L .32621 .47156 L p F P
0 0 0 r
s
.265 .367 .679 r
.65926 .46178 m .67379 .47156 L .6732 .49141 L p F P
0 0 0 r
s
.265 .367 .679 r
.68746 .50085 m .6732 .49141 L .67379 .47156 L p F P
0 0 0 r
s
.83 .24 .1 r
.57154 .28128 m
.53912 .3035 L
s
.53912 .3035 m
.52094 .30438 L
s
.24 .35 .67 r
.42846 .28128 m
.46088 .3035 L
s
.46088 .3035 m
.47906 .30438 L
s
1 .311 .131 r
.5 .64685 m .50252 .64553 L .50488 .65714 L p F P
0 0 0 r
s
1 .311 .131 r
.50979 .65459 m .50488 .65714 L .50252 .64553 L p F P
0 0 0 r
s
.256 .395 .786 r
.5 .64685 m .49748 .64553 L .49512 .65714 L p F P
0 0 0 r
s
.256 .395 .786 r
.49021 .65459 m .49512 .65714 L .49748 .64553 L p F P
0 0 0 r
s
.914 .283 .117 r
.55779 .63829 m .56525 .63445 L .58363 .62916 L p F P
0 0 0 r
s
.914 .283 .117 r
.59335 .62416 m .58363 .62916 L .56525 .63445 L p F P
0 0 0 r
s
.156 .257 .535 r
.44221 .63829 m .43475 .63445 L .41637 .62916 L p F P
0 0 0 r
s
.156 .257 .535 r
.40665 .62416 m .41637 .62916 L .43475 .63445 L p F P
0 0 0 r
s
.83 .24 .1 r
.62461 .26419 m
.59135 .28669 L
s
.59135 .28669 m
.57154 .28128 L
s
.24 .35 .67 r
.37539 .26419 m
.40865 .28669 L
s
.40865 .28669 m
.42846 .28128 L
s
.083 .024 .01 r
.59335 .62416 m .60317 .61912 L .62302 .6087 L p F P
0 0 0 r
s
.083 .024 .01 r
.63496 .60257 m .62302 .6087 L .60317 .61912 L p F P
0 0 0 r
s
.073 .085 .162 r
.40665 .62416 m .39683 .61912 L .37698 .6087 L p F P
0 0 0 r
s
.073 .085 .162 r
.36504 .60257 m .37698 .6087 L .39683 .61912 L p F P
0 0 0 r
s
.83 .24 .1 r
.48929 .32626 m
.50124 .318 L
s
.24 .35 .67 r
.49876 .318 m
.51071 .32626 L
s
.511 .142 .065 r
.3268 .49141 m .31254 .50085 L .31795 .52083 L p F P
0 0 0 r
s
.511 .142 .065 r
.30428 .52971 m .31795 .52083 L .31254 .50085 L p F P
0 0 0 r
s
.281 .394 .737 r
.6732 .49141 m .68746 .50085 L .68205 .52083 L p F P
0 0 0 r
s
.281 .394 .737 r
.69572 .52971 m .68205 .52083 L .68746 .50085 L p F P
0 0 0 r
s
.83 .24 .1 r
.35034 .63167 m
.37212 .65406 L
s
.4019 .63743 m
.37212 .65406 L
s
.24 .35 .67 r
.64966 .63167 m
.62788 .65406 L
s
.5981 .63743 m
.62788 .65406 L
s
.862 .266 .108 r
.48874 .32305 m .47761 .33077 L .47395 .33127 L p F P
0 0 0 r
s
.862 .266 .108 r
.46118 .34014 m .47395 .33127 L .47761 .33077 L p F P
0 0 0 r
s
.119 .189 .415 r
.51126 .32305 m .52239 .33077 L .52605 .33127 L p F P
0 0 0 r
s
.119 .189 .415 r
.53882 .34014 m .52605 .33127 L .52239 .33077 L p F P
0 0 0 r
s
.599 .169 .076 r
.31795 .52083 m .30428 .52971 L .31514 .54885 L p F P
0 0 0 r
s
.599 .169 .076 r
.30233 .55697 m .31514 .54885 L .30428 .52971 L p F P
0 0 0 r
s
.291 .413 .778 r
.68205 .52083 m .69572 .52971 L .68486 .54885 L p F P
0 0 0 r
s
.291 .413 .778 r
.69767 .55697 m .68486 .54885 L .69572 .52971 L p F P
0 0 0 r
s
.83 .24 .1 r
.67953 .2528 m
.64533 .27553 L
s
.64533 .27553 m
.62461 .26419 L
s
.24 .35 .67 r
.32047 .2528 m
.35467 .27553 L
s
.35467 .27553 m
.37539 .26419 L
s
1 .311 .131 r
.50252 .64553 m .50504 .6442 L .50979 .65459 L p F P
0 0 0 r
s
1 .311 .131 r
.51472 .65203 m .50979 .65459 L .50504 .6442 L p F P
0 0 0 r
s
.24 .35 .67 r
.50569 .65455 m
.50808 .65392 L
s
.256 .395 .786 r
.49748 .64553 m .49496 .6442 L .49021 .65459 L p F P
0 0 0 r
s
.256 .395 .786 r
.48528 .65203 m .49021 .65459 L .49496 .6442 L p F P
0 0 0 r
s
.83 .24 .1 r
.49192 .65392 m
.49431 .65455 L
s
.1 .028 .011 r
.6669 .58158 m .68091 .57435 L .69767 .55697 L p F P
0 0 0 r
s
.24 .35 .67 r
.68387 .57657 m
.71204 .594 L
s
.156 .195 .345 r
.3331 .58158 m .31909 .57435 L .30233 .55697 L p F P
0 0 0 r
s
.83 .24 .1 r
.28796 .594 m
.31613 .57657 L
s
.672 .192 .086 r
.31514 .54885 m .30233 .55697 L .31909 .57435 L p F P
0 0 0 r
s
.24 .35 .67 r
.31236 .56506 m
.31393 .56818 L
s
.299 .426 .808 r
.68486 .54885 m .69767 .55697 L .68091 .57435 L p F P
0 0 0 r
s
.83 .24 .1 r
.68607 .56818 m
.68764 .56506 L
s
.31314 .56819 m
.31613 .57657 L
s
.24 .35 .67 r
.68387 .57657 m
.68686 .56819 L
s
.15 .041 .019 r
.39366 .39711 m .37939 .40693 L .37338 .42317 L p F P
0 0 0 r
s
.15 .041 .019 r
.35868 .4332 m .37338 .42317 L .37939 .40693 L p F P
0 0 0 r
s
.202 .266 .472 r
.60634 .39711 m .62061 .40693 L .62662 .42317 L p F P
0 0 0 r
s
.202 .266 .472 r
.64132 .4332 m .62662 .42317 L .62061 .40693 L p F P
0 0 0 r
s
1 .308 .129 r
.52967 .64426 m .5347 .64165 L .55039 .64211 L p F P
0 0 0 r
s
1 .308 .129 r
.55779 .63829 m .55039 .64211 L .5347 .64165 L p F P
0 0 0 r
s
.215 .34 .689 r
.47033 .64426 m .4653 .64165 L .44961 .64211 L p F P
0 0 0 r
s
.215 .34 .689 r
.44221 .63829 m .44961 .64211 L .4653 .64165 L p F P
0 0 0 r
s
.083 .024 .01 r
.63496 .60257 m .64704 .59636 L .6669 .58158 L p F P
0 0 0 r
s
.083 .024 .01 r
.68091 .57435 m .6669 .58158 L .64704 .59636 L p F P
0 0 0 r
s
.111 .126 .238 r
.36504 .60257 m .35296 .59636 L .3331 .58158 L p F P
0 0 0 r
s
.111 .126 .238 r
.31909 .57435 m .3331 .58158 L .35296 .59636 L p F P
0 0 0 r
s
.83 .24 .1 r
.80187 .45234 m
.79615 .42555 L
s
.83284 .40519 m
.79615 .42555 L
s
.24 .35 .67 r
.19813 .45234 m
.20385 .42555 L
s
.16716 .40519 m
.20385 .42555 L
s
.914 .283 .117 r
.56525 .63445 m .57277 .63057 L .59335 .62416 L p F P
0 0 0 r
s
.914 .283 .117 r
.60317 .61912 m .59335 .62416 L .57277 .63057 L p F P
0 0 0 r
s
.156 .257 .535 r
.43475 .63445 m .42723 .63057 L .40665 .62416 L p F P
0 0 0 r
s
.156 .257 .535 r
.39683 .61912 m .40665 .62416 L .42723 .63057 L p F P
0 0 0 r
s
1 .311 .131 r
.50504 .6442 m .50757 .64287 L .51472 .65203 L p F P
0 0 0 r
s
1 .311 .131 r
.51968 .64945 m .51472 .65203 L .50757 .64287 L p F P
0 0 0 r
s
.24 .35 .67 r
.50808 .65392 m
.52009 .65076 L
s
.256 .395 .786 r
.49496 .6442 m .49243 .64287 L .48528 .65203 L p F P
0 0 0 r
s
.256 .395 .786 r
.48032 .64945 m .48528 .65203 L .49243 .64287 L p F P
0 0 0 r
s
.83 .24 .1 r
.47991 .65076 m
.49192 .65392 L
s
.083 .024 .01 r
.46118 .34014 m .44857 .34889 L .44253 .35582 L p F P
0 0 0 r
s
.83 .24 .1 r
.44258 .35496 m
.44433 .35375 L
s
.083 .024 .01 r
.42868 .36541 m .44253 .35582 L .44857 .34889 L p F P
0 0 0 r
s
.104 .117 .224 r
.53882 .34014 m .55143 .34889 L .55747 .35582 L p F P
0 0 0 r
s
.24 .35 .67 r
.55567 .35375 m
.55742 .35496 L
s
.104 .117 .224 r
.57132 .36541 m .55747 .35582 L .55143 .34889 L p F P
0 0 0 r
s
.083 .024 .01 r
.42868 .36541 m .41502 .37487 L .40815 .38713 L p F P
0 0 0 r
s
.083 .024 .01 r
.39366 .39711 m .40815 .38713 L .41502 .37487 L p F P
0 0 0 r
s
.157 .196 .347 r
.57132 .36541 m .58498 .37487 L .59185 .38713 L p F P
0 0 0 r
s
.157 .196 .347 r
.60634 .39711 m .59185 .38713 L .58498 .37487 L p F P
0 0 0 r
s
.83 .24 .1 r
.80986 .34782 m
.79402 .31942 L
s
.79402 .31942 m
.77599 .29248 L
s
.24 .35 .67 r
.19014 .34782 m
.20598 .31942 L
s
.20598 .31942 m
.22401 .29248 L
s
.276 .072 .035 r
.37338 .42317 m .35868 .4332 L .3555 .45183 L p F P
0 0 0 r
s
.276 .072 .035 r
.34074 .46178 m .3555 .45183 L .35868 .4332 L p F P
0 0 0 r
s
.24 .327 .596 r
.62662 .42317 m .64132 .4332 L .6445 .45183 L p F P
0 0 0 r
s
.24 .327 .596 r
.65926 .46178 m .6445 .45183 L .64132 .4332 L p F P
0 0 0 r
s
.083 .024 .01 r
.60317 .61912 m .61309 .61403 L .63496 .60257 L p F P
0 0 0 r
s
.083 .024 .01 r
.64704 .59636 m .63496 .60257 L .61309 .61403 L p F P
0 0 0 r
s
.073 .085 .162 r
.39683 .61912 m .38691 .61403 L .36504 .60257 L p F P
0 0 0 r
s
.073 .085 .162 r
.35296 .59636 m .36504 .60257 L .38691 .61403 L p F P
0 0 0 r
s
.83 .24 .1 r
.73573 .24658 m
.70049 .2695 L
s
.70049 .2695 m
.67953 .2528 L
s
.24 .35 .67 r
.26427 .24658 m
.29951 .2695 L
s
.29951 .2695 m
.32047 .2528 L
s
.83 .24 .1 r
.33133 .60538 m
.35034 .63167 L
s
.24 .35 .67 r
.66867 .60538 m
.64966 .63167 L
s
1 .308 .129 r
.5347 .64165 m .53976 .63902 L .55779 .63829 L p F P
0 0 0 r
s
1 .308 .129 r
.56525 .63445 m .55779 .63829 L .53976 .63902 L p F P
0 0 0 r
s
.215 .34 .689 r
.4653 .64165 m .46024 .63902 L .44221 .63829 L p F P
0 0 0 r
s
.215 .34 .689 r
.43475 .63445 m .44221 .63829 L .46024 .63902 L p F P
0 0 0 r
s
.83 .24 .1 r
.82296 .37673 m
.80986 .34782 L
s
.24 .35 .67 r
.17704 .37673 m
.19014 .34782 L
s
.862 .266 .108 r
.5 .31525 m .48874 .32305 L .48689 .32229 L p F P
0 0 0 r
s
.862 .266 .108 r
.47395 .33127 m .48689 .32229 L .48874 .32305 L p F P
0 0 0 r
s
.119 .189 .415 r
.5 .31525 m .51126 .32305 L .51311 .32229 L p F P
0 0 0 r
s
.119 .189 .415 r
.52605 .33127 m .51311 .32229 L .51126 .32305 L p F P
0 0 0 r
s
1 .311 .131 r
.50757 .64287 m .51011 .64153 L .51968 .64945 L p F P
0 0 0 r
s
1 .311 .131 r
.52466 .64686 m .51968 .64945 L .51011 .64153 L p F P
0 0 0 r
s
.256 .395 .786 r
.49243 .64287 m .48989 .64153 L .48032 .64945 L p F P
0 0 0 r
s
.256 .395 .786 r
.47534 .64686 m .48032 .64945 L .48989 .64153 L p F P
0 0 0 r
s
.83 .24 .1 r
.31613 .57657 m
.31939 .57455 L
s
.31613 .57657 m
.33133 .60538 L
s
.24 .35 .67 r
.68061 .57455 m
.68387 .57657 L
s
.66867 .60538 m
.68387 .57657 L
s
.4 .107 .051 r
.3555 .45183 m .34074 .46178 L .34128 .48182 L p F P
0 0 0 r
s
.83 .24 .1 r
.33971 .46397 m
.34078 .46325 L
s
.35445 .45405 m
.35701 .45234 L
s
.4 .107 .051 r
.3268 .49141 m .34128 .48182 L .34074 .46178 L p F P
0 0 0 r
s
.265 .367 .679 r
.6445 .45183 m .65926 .46178 L .65872 .48182 L p F P
0 0 0 r
s
.24 .35 .67 r
.64299 .45234 m
.64555 .45405 L
s
.65922 .46325 m
.66029 .46397 L
s
.265 .367 .679 r
.6732 .49141 m .65872 .48182 L .65926 .46178 L p F P
0 0 0 r
s
.83 .24 .1 r
.77599 .29248 m
.75634 .26791 L
s
.24 .35 .67 r
.22401 .29248 m
.24366 .26791 L
s
.83 .24 .1 r
.4019 .63743 m
.42535 .6552 L
s
.24 .35 .67 r
.57465 .6552 m
.5981 .63743 L
s
.511 .142 .065 r
.34128 .48182 m .3268 .49141 L .33184 .51182 L p F P
0 0 0 r
s
.511 .142 .065 r
.31795 .52083 m .33184 .51182 L .3268 .49141 L p F P
0 0 0 r
s
.281 .394 .737 r
.65872 .48182 m .6732 .49141 L .66816 .51182 L p F P
0 0 0 r
s
.281 .394 .737 r
.68205 .52083 m .66816 .51182 L .6732 .49141 L p F P
0 0 0 r
s
.599 .169 .076 r
.33184 .51182 m .31795 .52083 L .32813 .54061 L p F P
0 0 0 r
s
.599 .169 .076 r
.31514 .54885 m .32813 .54061 L .31795 .52083 L p F P
0 0 0 r
s
.291 .413 .778 r
.66816 .51182 m .68205 .52083 L .67187 .54061 L p F P
0 0 0 r
s
.291 .413 .778 r
.68486 .54885 m .67187 .54061 L .68205 .52083 L p F P
0 0 0 r
s
.914 .283 .117 r
.57277 .63057 m .58034 .62667 L .60317 .61912 L p F P
0 0 0 r
s
.914 .283 .117 r
.61309 .61403 m .60317 .61912 L .58034 .62667 L p F P
0 0 0 r
s
.156 .257 .535 r
.42723 .63057 m .41966 .62667 L .39683 .61912 L p F P
0 0 0 r
s
.156 .257 .535 r
.38691 .61403 m .39683 .61912 L .41966 .62667 L p F P
0 0 0 r
s
.672 .192 .086 r
.32813 .54061 m .31514 .54885 L .33091 .56704 L p F P
0 0 0 r
s
.672 .192 .086 r
.31909 .57435 m .33091 .56704 L .31514 .54885 L p F P
0 0 0 r
s
.24 .35 .67 r
.32062 .57341 m
.34925 .58819 L
s
.31393 .56818 m
.31514 .57058 L
s
.299 .426 .808 r
.67187 .54061 m .68486 .54885 L .66909 .56704 L p F P
0 0 0 r
s
.299 .426 .808 r
.68091 .57435 m .66909 .56704 L .68486 .54885 L p F P
0 0 0 r
s
.83 .24 .1 r
.65075 .58819 m
.67938 .57341 L
s
.68486 .57058 m
.68607 .56818 L
s
1 .311 .131 r
.51011 .64153 m .51265 .6402 L .52466 .64686 L p F P
0 0 0 r
s
1 .311 .131 r
.52967 .64426 m .52466 .64686 L .51265 .6402 L p F P
0 0 0 r
s
.256 .395 .786 r
.48989 .64153 m .48735 .6402 L .47534 .64686 L p F P
0 0 0 r
s
.256 .395 .786 r
.47033 .64426 m .47534 .64686 L .48735 .6402 L p F P
0 0 0 r
s
1 .308 .129 r
.53976 .63902 m .54484 .63638 L .56525 .63445 L p F P
0 0 0 r
s
1 .308 .129 r
.57277 .63057 m .56525 .63445 L .54484 .63638 L p F P
0 0 0 r
s
.215 .34 .689 r
.46024 .63902 m .45516 .63638 L .43475 .63445 L p F P
0 0 0 r
s
.215 .34 .689 r
.42723 .63057 m .43475 .63445 L .45516 .63638 L p F P
0 0 0 r
s
.15 .041 .019 r
.40815 .38713 m .39366 .39711 L .38832 .41298 L p F P
0 0 0 r
s
.15 .041 .019 r
.37338 .42317 m .38832 .41298 L .39366 .39711 L p F P
0 0 0 r
s
.202 .266 .472 r
.59185 .38713 m .60634 .39711 L .61168 .41298 L p F P
0 0 0 r
s
.202 .266 .472 r
.62662 .42317 m .61168 .41298 L .60634 .39711 L p F P
0 0 0 r
s
.083 .024 .01 r
.64704 .59636 m .65926 .59009 L .68091 .57435 L p F P
0 0 0 r
s
.111 .126 .238 r
.35296 .59636 m .34074 .59009 L .31909 .57435 L p F P
0 0 0 r
s
.735 .211 .094 r
.33091 .56704 m .31909 .57435 L .34074 .59009 L p F P
0 0 0 r
s
.24 .35 .67 r
.31514 .57058 m
.31936 .57276 L
s
.31936 .57276 m
.31953 .57285 L
s
.303 .436 .831 r
.66909 .56704 m .68091 .57435 L .65926 .59009 L p F P
0 0 0 r
s
.83 .24 .1 r
.68064 .57276 m
.68486 .57058 L
s
.68047 .57285 m
.68064 .57276 L
s
.083 .024 .01 r
.47395 .33127 m .46118 .34014 L .45658 .34608 L p F P
0 0 0 r
s
.83 .24 .1 r
.47351 .33352 m
.48929 .32626 L
s
.44805 .35117 m
.45795 .34431 L
s
.46173 .34169 m
.47351 .33352 L
s
.083 .024 .01 r
.44253 .35582 m .45658 .34608 L .46118 .34014 L p F P
0 0 0 r
s
.104 .117 .224 r
.52605 .33127 m .53882 .34014 L .54342 .34608 L p F P
0 0 0 r
s
.24 .35 .67 r
.51071 .32626 m
.52649 .33352 L
s
.52649 .33352 m
.53827 .34169 L
s
.54205 .34431 m
.55195 .35117 L
s
.104 .117 .224 r
.55747 .35582 m .54342 .34608 L .53882 .34014 L p F P
0 0 0 r
s
.83 .24 .1 r
.83284 .40519 m
.82296 .37673 L
s
.24 .35 .67 r
.16716 .40519 m
.17704 .37673 L
s
.083 .024 .01 r
.61309 .61403 m .6231 .6089 L .64704 .59636 L p F P
0 0 0 r
s
.083 .024 .01 r
.65926 .59009 m .64704 .59636 L .6231 .6089 L p F P
0 0 0 r
s
.83 .24 .1 r
.60438 .61706 m
.63779 .59989 L
s
.63779 .59989 m
.65075 .58819 L
s
.073 .085 .162 r
.38691 .61403 m .3769 .6089 L .35296 .59636 L p F P
0 0 0 r
s
.073 .085 .162 r
.34074 .59009 m .35296 .59636 L .3769 .6089 L p F P
0 0 0 r
s
.24 .35 .67 r
.36221 .59989 m
.39562 .61706 L
s
.34925 .58819 m
.36221 .59989 L
s
.83 .24 .1 r
.72008 .5524 m
.72802 .53577 L
s
.76392 .51703 m
.72802 .53577 L
s
.24 .35 .67 r
.27992 .5524 m
.27198 .53577 L
s
.23608 .51703 m
.27198 .53577 L
s
1 .311 .131 r
.51265 .6402 m .5152 .63885 L .52967 .64426 L p F P
0 0 0 r
s
1 .311 .131 r
.5347 .64165 m .52967 .64426 L .5152 .63885 L p F P
0 0 0 r
s
.83 .24 .1 r
.5322 .64129 m
.53434 .64018 L
s
.53434 .64018 m
.53758 .64015 L
s
.256 .395 .786 r
.48735 .6402 m .4848 .63885 L .47033 .64426 L p F P
0 0 0 r
s
.256 .395 .786 r
.4653 .64165 m .47033 .64426 L .4848 .63885 L p F P
0 0 0 r
s
.24 .35 .67 r
.46566 .64018 m
.4678 .64129 L
s
.46242 .64015 m
.46566 .64018 L
s
.83 .24 .1 r
.47991 .65076 m
.49257 .64406 L
s
.24 .35 .67 r
.50743 .64406 m
.52009 .65076 L
s
.083 .024 .01 r
.44253 .35582 m .42868 .36541 L .42286 .377 L p F P
0 0 0 r
s
.083 .024 .01 r
.40815 .38713 m .42286 .377 L .42868 .36541 L p F P
0 0 0 r
s
.157 .196 .347 r
.55747 .35582 m .57132 .36541 L .57714 .377 L p F P
0 0 0 r
s
.157 .196 .347 r
.59185 .38713 m .57714 .377 L .57132 .36541 L p F P
0 0 0 r
s
.862 .266 .108 r
.48689 .32229 m .5 .31319 L .5 .31525 L p F P
0 0 0 r
s
.24 .35 .67 r
.47906 .30438 m
.49591 .31603 L
s
.119 .189 .415 r
.51311 .32229 m .5 .31319 L .5 .31525 L p F P
0 0 0 r
s
.83 .24 .1 r
.50409 .31603 m
.52094 .30438 L
s
.76392 .51703 m
.76702 .49611 L
s
.80357 .47672 m
.76702 .49611 L
s
.24 .35 .67 r
.23608 .51703 m
.23298 .49611 L
s
.19643 .47672 m
.23298 .49611 L
s
.83 .24 .1 r
.67228 .58217 m
.68486 .57058 L
s
.68486 .57058 m
.72008 .5524 L
s
.24 .35 .67 r
.31514 .57058 m
.32772 .58217 L
s
.27992 .5524 m
.31514 .57058 L
s
.83 .24 .1 r
.75634 .26791 m
.73573 .24658 L
s
.24 .35 .67 r
.24366 .26791 m
.26427 .24658 L
s
.276 .072 .035 r
.38832 .41298 m .37338 .42317 L .37051 .44173 L p F P
0 0 0 r
s
.276 .072 .035 r
.3555 .45183 m .37051 .44173 L .37338 .42317 L p F P
0 0 0 r
s
.83 .24 .1 r
.35701 .45234 m
.35732 .45061 L
s
.24 .327 .596 r
.61168 .41298 m .62662 .42317 L .62949 .44173 L p F P
0 0 0 r
s
.24 .327 .596 r
.6445 .45183 m .62949 .44173 L .62662 .42317 L p F P
0 0 0 r
s
.24 .35 .67 r
.64268 .45061 m
.64299 .45234 L
s
1 .308 .129 r
.54484 .63638 m .54995 .63373 L .57277 .63057 L p F P
0 0 0 r
s
1 .308 .129 r
.58034 .62667 m .57277 .63057 L .54995 .63373 L p F P
0 0 0 r
s
.215 .34 .689 r
.45516 .63638 m .45005 .63373 L .42723 .63057 L p F P
0 0 0 r
s
.215 .34 .689 r
.41966 .62667 m .42723 .63057 L .45005 .63373 L p F P
0 0 0 r
s
.914 .283 .117 r
.58034 .62667 m .58797 .62274 L .61309 .61403 L p F P
0 0 0 r
s
.914 .283 .117 r
.6231 .6089 m .61309 .61403 L .58797 .62274 L p F P
0 0 0 r
s
.156 .257 .535 r
.41966 .62667 m .41203 .62274 L .38691 .61403 L p F P
0 0 0 r
s
.156 .257 .535 r
.3769 .6089 m .38691 .61403 L .41203 .62274 L p F P
0 0 0 r
s
1 .311 .131 r
.5152 .63885 m .51776 .63751 L .5347 .64165 L p F P
0 0 0 r
s
1 .311 .131 r
.53976 .63902 m .5347 .64165 L .51776 .63751 L p F P
0 0 0 r
s
.256 .395 .786 r
.4848 .63885 m .48224 .63751 L .4653 .64165 L p F P
0 0 0 r
s
.256 .395 .786 r
.46024 .63902 m .4653 .64165 L .48224 .63751 L p F P
0 0 0 r
s
.83 .24 .1 r
.80187 .45234 m
.83908 .43218 L
s
.24 .35 .67 r
.19813 .45234 m
.16092 .43218 L
s
.83 .24 .1 r
.80357 .47672 m
.80187 .45234 L
s
.24 .35 .67 r
.19643 .47672 m
.19813 .45234 L
s
.4 .107 .051 r
.37051 .44173 m .3555 .45183 L .356 .47207 L p F P
0 0 0 r
s
.4 .107 .051 r
.34128 .48182 m .356 .47207 L .3555 .45183 L p F P
0 0 0 r
s
.265 .367 .679 r
.62949 .44173 m .6445 .45183 L .644 .47207 L p F P
0 0 0 r
s
.265 .367 .679 r
.65872 .48182 m .644 .47207 L .6445 .45183 L p F P
0 0 0 r
s
.83 .24 .1 r
.60501 .25833 m
.57154 .28128 L
s
.57154 .28128 m
.55362 .28179 L
s
.24 .35 .67 r
.39499 .25833 m
.42846 .28128 L
s
.42846 .28128 m
.44638 .28179 L
s
.83 .24 .1 r
.65896 .24096 m
.62461 .26419 L
s
.62461 .26419 m
.60501 .25833 L
s
.24 .35 .67 r
.34104 .24096 m
.37539 .26419 L
s
.37539 .26419 m
.39499 .25833 L
s
.511 .142 .065 r
.356 .47207 m .34128 .48182 L .34594 .50267 L p F P
0 0 0 r
s
.511 .142 .065 r
.33184 .51182 m .34594 .50267 L .34128 .48182 L p F P
0 0 0 r
s
.281 .394 .737 r
.644 .47207 m .65872 .48182 L .65406 .50267 L p F P
0 0 0 r
s
.281 .394 .737 r
.66816 .51182 m .65406 .50267 L .65872 .48182 L p F P
0 0 0 r
s
.83 .24 .1 r
.55362 .28179 m
.52094 .30438 L
s
.52094 .30438 m
.50545 .31139 L
s
.24 .35 .67 r
.44638 .28179 m
.47906 .30438 L
s
.47906 .30438 m
.49455 .31139 L
s
1 .303 .129 r
.50252 .64553 m .5 .64685 L .5 .62969 L closepath p F P
0 0 0 r
s
.281 .425 .837 r
.49748 .64553 m .5 .64685 L .5 .62969 L closepath p F P
0 0 0 r
s
.599 .169 .076 r
.34594 .50267 m .33184 .51182 L .3413 .53225 L p F P
0 0 0 r
s
.599 .169 .076 r
.32813 .54061 m .3413 .53225 L .33184 .51182 L p F P
0 0 0 r
s
.291 .413 .778 r
.65406 .50267 m .66816 .51182 L .6587 .53225 L p F P
0 0 0 r
s
.291 .413 .778 r
.67187 .54061 m .6587 .53225 L .66816 .51182 L p F P
0 0 0 r
s
.672 .192 .086 r
.3413 .53225 m .32813 .54061 L .34289 .55962 L p F P
0 0 0 r
s
.672 .192 .086 r
.33091 .56704 m .34289 .55962 L .32813 .54061 L p F P
0 0 0 r
s
.299 .426 .808 r
.6587 .53225 m .67187 .54061 L .65711 .55962 L p F P
0 0 0 r
s
.299 .426 .808 r
.66909 .56704 m .65711 .55962 L .67187 .54061 L p F P
0 0 0 r
s
.735 .211 .094 r
.34289 .55962 m .33091 .56704 L .35126 .58375 L p F P
0 0 0 r
s
.83 .24 .1 r
.33104 .56735 m
.33118 .56726 L
s
.735 .211 .094 r
.34074 .59009 m .35126 .58375 L .33091 .56704 L p F P
0 0 0 r
s
.303 .436 .831 r
.65711 .55962 m .66909 .56704 L .64874 .58375 L p F P
0 0 0 r
s
.24 .35 .67 r
.66882 .56726 m
.66896 .56735 L
s
.303 .436 .831 r
.65926 .59009 m .64874 .58375 L .66909 .56704 L p F P
0 0 0 r
s
1 .311 .131 r
.51776 .63751 m .52032 .63616 L .53976 .63902 L p F P
0 0 0 r
s
1 .311 .131 r
.54484 .63638 m .53976 .63902 L .52032 .63616 L p F P
0 0 0 r
s
.24 .35 .67 r
.52009 .65076 m
.54379 .63847 L
s
.54379 .63847 m
.57465 .6552 L
s
.256 .395 .786 r
.48224 .63751 m .47968 .63616 L .46024 .63902 L p F P
0 0 0 r
s
.256 .395 .786 r
.45516 .63638 m .46024 .63902 L .47968 .63616 L p F P
0 0 0 r
s
.83 .24 .1 r
.45621 .63847 m
.47991 .65076 L
s
.42535 .6552 m
.45621 .63847 L
s
.073 .085 .162 r
.3769 .6089 m .3668 .60371 L .34074 .59009 L p F P
0 0 0 r
s
.791 .229 .101 r
.35126 .58375 m .34074 .59009 L .3668 .60371 L p F P
0 0 0 r
s
.24 .35 .67 r
.34809 .59263 m
.34919 .5932 L
s
.83 .24 .1 r
.33133 .60538 m
.34844 .59516 L
s
.34844 .59516 m
.34937 .5946 L
s
.083 .024 .01 r
.6231 .6089 m .6332 .60371 L .65926 .59009 L p F P
0 0 0 r
s
.306 .443 .849 r
.64874 .58375 m .65926 .59009 L .6332 .60371 L p F P
0 0 0 r
s
.24 .35 .67 r
.65063 .5946 m
.65156 .59516 L
s
.65156 .59516 m
.66867 .60538 L
s
.83 .24 .1 r
.65081 .5932 m
.65191 .59263 L
s
1 .308 .129 r
.54995 .63373 m .55508 .63106 L .58034 .62667 L p F P
0 0 0 r
s
1 .308 .129 r
.58797 .62274 m .58034 .62667 L .55508 .63106 L p F P
0 0 0 r
s
.215 .34 .689 r
.45005 .63373 m .44492 .63106 L .41966 .62667 L p F P
0 0 0 r
s
.215 .34 .689 r
.41203 .62274 m .41966 .62667 L .44492 .63106 L p F P
0 0 0 r
s
.83 .24 .1 r
.71485 .22934 m
.67953 .2528 L
s
.67953 .2528 m
.65896 .24096 L
s
.24 .35 .67 r
.28515 .22934 m
.32047 .2528 L
s
.32047 .2528 m
.34104 .24096 L
s
1 .303 .129 r
.50504 .6442 m .50252 .64553 L .5 .62969 L closepath p F P
0 0 0 r
s
.281 .425 .837 r
.49496 .6442 m .49748 .64553 L .5 .62969 L closepath p F P
0 0 0 r
s
.15 .041 .019 r
.42286 .377 m .40815 .38713 L .4035 .40262 L p F P
0 0 0 r
s
.15 .041 .019 r
.38832 .41298 m .4035 .40262 L .40815 .38713 L p F P
0 0 0 r
s
.202 .266 .472 r
.57714 .377 m .59185 .38713 L .5965 .40262 L p F P
0 0 0 r
s
.202 .266 .472 r
.61168 .41298 m .5965 .40262 L .59185 .38713 L p F P
0 0 0 r
s
.083 .024 .01 r
.48689 .32229 m .47395 .33127 L .47084 .3362 L p F P
0 0 0 r
s
.083 .024 .01 r
.45658 .34608 m .47084 .3362 L .47395 .33127 L p F P
0 0 0 r
s
.104 .117 .224 r
.51311 .32229 m .52605 .33127 L .52916 .3362 L p F P
0 0 0 r
s
.104 .117 .224 r
.54342 .34608 m .52916 .3362 L .52605 .33127 L p F P
0 0 0 r
s
.83 .24 .1 r
.34237 .55078 m
.3452 .55859 L
s
.24 .35 .67 r
.6548 .55859 m
.65763 .55078 L
s
.914 .283 .117 r
.58797 .62274 m .59565 .61878 L .6231 .6089 L p F P
0 0 0 r
s
.914 .283 .117 r
.6332 .60371 m .6231 .6089 L .59565 .61878 L p F P
0 0 0 r
s
.24 .35 .67 r
.62005 .61459 m
.64966 .63167 L
s
.5981 .63743 m
.62005 .61459 L
s
.156 .257 .535 r
.41203 .62274 m .40435 .61878 L .3769 .6089 L p F P
0 0 0 r
s
.156 .257 .535 r
.3668 .60371 m .3769 .6089 L .40435 .61878 L p F P
0 0 0 r
s
.83 .24 .1 r
.35034 .63167 m
.37995 .61459 L
s
.37995 .61459 m
.4019 .63743 L
s
1 .303 .129 r
.50757 .64287 m .50504 .6442 L .5 .62969 L closepath p F P
0 0 0 r
s
.281 .425 .837 r
.49243 .64287 m .49496 .6442 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .311 .131 r
.52032 .63616 m .52289 .63481 L .54484 .63638 L p F P
0 0 0 r
s
1 .311 .131 r
.54995 .63373 m .54484 .63638 L .52289 .63481 L p F P
0 0 0 r
s
.256 .395 .786 r
.47968 .63616 m .47711 .63481 L .45516 .63638 L p F P
0 0 0 r
s
.256 .395 .786 r
.45005 .63373 m .45516 .63638 L .47711 .63481 L p F P
0 0 0 r
s
.083 .024 .01 r
.45658 .34608 m .44253 .35582 L .43781 .3667 L p F P
0 0 0 r
s
.083 .024 .01 r
.42286 .377 m .43781 .3667 L .44253 .35582 L p F P
0 0 0 r
s
.157 .196 .347 r
.54342 .34608 m .55747 .35582 L .56219 .3667 L p F P
0 0 0 r
s
.157 .196 .347 r
.57714 .377 m .56219 .3667 L .55747 .35582 L p F P
0 0 0 r
s
.83 .24 .1 r
.83908 .43218 m
.83284 .40519 L
s
.24 .35 .67 r
.16092 .43218 m
.16716 .40519 L
s
1 .303 .129 r
.51011 .64153 m .50757 .64287 L .5 .62969 L closepath p F P
0 0 0 r
s
.281 .425 .837 r
.48989 .64153 m .49243 .64287 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .308 .129 r
.55508 .63106 m .56024 .62838 L .58797 .62274 L p F P
0 0 0 r
s
1 .308 .129 r
.59565 .61878 m .58797 .62274 L .56024 .62838 L p F P
0 0 0 r
s
.215 .34 .689 r
.44492 .63106 m .43976 .62838 L .41203 .62274 L p F P
0 0 0 r
s
.215 .34 .689 r
.40435 .61878 m .41203 .62274 L .43976 .62838 L p F P
0 0 0 r
s
.276 .072 .035 r
.4035 .40262 m .38832 .41298 L .38577 .43146 L p F P
0 0 0 r
s
.276 .072 .035 r
.37051 .44173 m .38577 .43146 L .38832 .41298 L p F P
0 0 0 r
s
.24 .327 .596 r
.5965 .40262 m .61168 .41298 L .61423 .43146 L p F P
0 0 0 r
s
.24 .327 .596 r
.62949 .44173 m .61423 .43146 L .61168 .41298 L p F P
0 0 0 r
s
1 .303 .129 r
.51265 .6402 m .51011 .64153 L .5 .62969 L closepath p F P
0 0 0 r
s
.281 .425 .837 r
.48735 .6402 m .48989 .64153 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .311 .131 r
.52289 .63481 m .52547 .63346 L .54995 .63373 L p F P
0 0 0 r
s
1 .311 .131 r
.55508 .63106 m .54995 .63373 L .52547 .63346 L p F P
0 0 0 r
s
.256 .395 .786 r
.47711 .63481 m .47453 .63346 L .45005 .63373 L p F P
0 0 0 r
s
.256 .395 .786 r
.44492 .63106 m .45005 .63373 L .47453 .63346 L p F P
0 0 0 r
s
.83 .24 .1 r
.73573 .24658 m
.71485 .22934 L
s
.24 .35 .67 r
.26427 .24658 m
.28515 .22934 L
s
.83 .24 .1 r
.37444 .60694 m
.37528 .60811 L
s
.37528 .60811 m
.37995 .61459 L
s
.24 .35 .67 r
.62472 .60811 m
.62556 .60694 L
s
.62005 .61459 m
.62472 .60811 L
s
1 .303 .129 r
.5152 .63885 m .51265 .6402 L .5 .62969 L closepath p F P
0 0 0 r
s
.281 .425 .837 r
.4848 .63885 m .48735 .6402 L .5 .62969 L closepath p F P
0 0 0 r
s
.735 .211 .094 r
.35126 .58375 m .36191 .57733 L .34289 .55962 L p F P
0 0 0 r
s
.24 .35 .67 r
.32772 .58217 m
.34809 .59263 L
s
.83 .24 .1 r
.34314 .55986 m
.3452 .55859 L
s
.791 .229 .101 r
.36191 .57733 m .35126 .58375 L .37572 .59847 L p F P
0 0 0 r
s
.791 .229 .101 r
.3668 .60371 m .37572 .59847 L .35126 .58375 L p F P
0 0 0 r
s
.83 .24 .1 r
.37054 .60152 m
.37428 .60671 L
s
.303 .436 .831 r
.64874 .58375 m .63809 .57733 L .65711 .55962 L p F P
0 0 0 r
s
.83 .24 .1 r
.65191 .59263 m
.67228 .58217 L
s
.24 .35 .67 r
.6548 .55859 m
.65686 .55986 L
s
.306 .443 .849 r
.63809 .57733 m .64874 .58375 L .62428 .59847 L p F P
0 0 0 r
s
.306 .443 .849 r
.6332 .60371 m .62428 .59847 L .64874 .58375 L p F P
0 0 0 r
s
.24 .35 .67 r
.62572 .60671 m
.62946 .60152 L
s
.672 .192 .086 r
.34289 .55962 m .35502 .55211 L .3413 .53225 L p F P
0 0 0 r
s
.735 .211 .094 r
.35502 .55211 m .34289 .55962 L .36191 .57733 L p F P
0 0 0 r
s
.299 .426 .808 r
.65711 .55962 m .64498 .55211 L .6587 .53225 L p F P
0 0 0 r
s
.303 .436 .831 r
.64498 .55211 m .65711 .55962 L .63809 .57733 L p F P
0 0 0 r
s
.4 .107 .051 r
.38577 .43146 m .37051 .44173 L .37096 .46217 L p F P
0 0 0 r
s
.83 .24 .1 r
.36944 .44398 m
.37055 .44323 L
s
.38467 .43373 m
.38697 .43218 L
s
.4 .107 .051 r
.356 .47207 m .37096 .46217 L .37051 .44173 L p F P
0 0 0 r
s
.265 .367 .679 r
.61423 .43146 m .62949 .44173 L .62904 .46217 L p F P
0 0 0 r
s
.24 .35 .67 r
.61303 .43218 m
.61533 .43373 L
s
.62945 .44323 m
.63056 .44398 L
s
.265 .367 .679 r
.644 .47207 m .62904 .46217 L .62949 .44173 L p F P
0 0 0 r
s
.843 .246 .107 r
.37572 .59847 m .3668 .60371 L .39661 .61479 L p F P
0 0 0 r
s
.24 .35 .67 r
.39567 .61444 m
.40317 .61831 L
s
.914 .283 .117 r
.59565 .61878 m .60339 .61479 L .6332 .60371 L p F P
0 0 0 r
s
.307 .447 .861 r
.62428 .59847 m .6332 .60371 L .60339 .61479 L p F P
0 0 0 r
s
.24 .35 .67 r
.61399 .61109 m
.62005 .61459 L
s
.83 .24 .1 r
.62515 .60438 m
.62589 .60412 L
s
.156 .257 .535 r
.40435 .61878 m .39661 .61479 L .3668 .60371 L p F P
0 0 0 r
s
.83 .24 .1 r
.37995 .61459 m
.38601 .61109 L
s
.24 .35 .67 r
.37411 .60412 m
.37485 .60438 L
s
.599 .169 .076 r
.3413 .53225 m .35467 .52376 L .34594 .50267 L p F P
0 0 0 r
s
.672 .192 .086 r
.35467 .52376 m .3413 .53225 L .35502 .55211 L p F P
0 0 0 r
s
.291 .413 .778 r
.6587 .53225 m .64533 .52376 L .65406 .50267 L p F P
0 0 0 r
s
.299 .426 .808 r
.64533 .52376 m .6587 .53225 L .64498 .55211 L p F P
0 0 0 r
s
1 .303 .129 r
.51776 .63751 m .5152 .63885 L .5 .62969 L closepath p F P
0 0 0 r
s
.281 .425 .837 r
.48224 .63751 m .4848 .63885 L .5 .62969 L closepath p F P
0 0 0 r
s
.511 .142 .065 r
.34594 .50267 m .36026 .49337 L .356 .47207 L p F P
0 0 0 r
s
.599 .169 .076 r
.36026 .49337 m .34594 .50267 L .35467 .52376 L p F P
0 0 0 r
s
.281 .394 .737 r
.65406 .50267 m .63974 .49337 L .644 .47207 L p F P
0 0 0 r
s
.291 .413 .778 r
.63974 .49337 m .65406 .50267 L .64533 .52376 L p F P
0 0 0 r
s
.511 .142 .065 r
.37096 .46217 m .356 .47207 L .36026 .49337 L p F P
0 0 0 r
s
.281 .394 .737 r
.62904 .46217 m .644 .47207 L .63974 .49337 L p F P
0 0 0 r
s
1 .311 .131 r
.52547 .63346 m .52805 .6321 L .55508 .63106 L p F P
0 0 0 r
s
1 .311 .131 r
.56024 .62838 m .55508 .63106 L .52805 .6321 L p F P
0 0 0 r
s
.256 .395 .786 r
.47453 .63346 m .47195 .6321 L .44492 .63106 L p F P
0 0 0 r
s
.256 .395 .786 r
.43976 .62838 m .44492 .63106 L .47195 .6321 L p F P
0 0 0 r
s
.083 .024 .01 r
.5 .31319 m .48689 .32229 L .48531 .32618 L p F P
0 0 0 r
s
.83 .24 .1 r
.4756 .33208 m
.48578 .32502 L
s
.083 .024 .01 r
.47084 .3362 m .48531 .32618 L .48689 .32229 L p F P
0 0 0 r
s
.104 .117 .224 r
.5 .31319 m .51311 .32229 L .51469 .32618 L p F P
0 0 0 r
s
.24 .35 .67 r
.51422 .32502 m
.5244 .33208 L
s
.104 .117 .224 r
.52916 .3362 m .51469 .32618 L .51311 .32229 L p F P
0 0 0 r
s
1 .308 .129 r
.56024 .62838 m .56542 .62568 L .59565 .61878 L p F P
0 0 0 r
s
.24 .35 .67 r
.57709 .6257 m
.5981 .63743 L
s
1 .308 .129 r
.60339 .61479 m .59565 .61878 L .56542 .62568 L p F P
0 0 0 r
s
.215 .34 .689 r
.43976 .62838 m .43458 .62568 L .40435 .61878 L p F P
0 0 0 r
s
.83 .24 .1 r
.4019 .63743 m
.42291 .6257 L
s
.215 .34 .689 r
.39661 .61479 m .40435 .61878 L .43458 .62568 L p F P
0 0 0 r
s
1 .303 .129 r
.52032 .63616 m .51776 .63751 L .5 .62969 L closepath p F P
0 0 0 r
s
.281 .425 .837 r
.47968 .63616 m .48224 .63751 L .5 .62969 L closepath p F P
0 0 0 r
s
.15 .041 .019 r
.43781 .3667 m .42286 .377 L .41892 .3921 L p F P
0 0 0 r
s
.15 .041 .019 r
.4035 .40262 m .41892 .3921 L .42286 .377 L p F P
0 0 0 r
s
.202 .266 .472 r
.56219 .3667 m .57714 .377 L .58108 .3921 L p F P
0 0 0 r
s
.202 .266 .472 r
.5965 .40262 m .58108 .3921 L .57714 .377 L p F P
0 0 0 r
s
1 .303 .129 r
.52289 .63481 m .52032 .63616 L .5 .62969 L closepath p F P
0 0 0 r
s
.281 .425 .837 r
.47711 .63481 m .47968 .63616 L .5 .62969 L closepath p F P
0 0 0 r
s
.083 .024 .01 r
.47084 .3362 m .45658 .34608 L .45299 .35625 L p F P
0 0 0 r
s
.83 .24 .1 r
.46588 .34178 m
.47138 .33583 L
s
.083 .024 .01 r
.43781 .3667 m .45299 .35625 L .45658 .34608 L p F P
0 0 0 r
s
.157 .196 .347 r
.52916 .3362 m .54342 .34608 L .54701 .35625 L p F P
0 0 0 r
s
.24 .35 .67 r
.52862 .33583 m
.53412 .34178 L
s
.157 .196 .347 r
.56219 .3667 m .54701 .35625 L .54342 .34608 L p F P
0 0 0 r
s
1 .311 .131 r
.52805 .6321 m .53064 .63073 L .56024 .62838 L p F P
0 0 0 r
s
.24 .35 .67 r
.53113 .6316 m
.54379 .63847 L
s
1 .311 .131 r
.56542 .62568 m .56024 .62838 L .53064 .63073 L p F P
0 0 0 r
s
.24 .35 .67 r
.54379 .63847 m
.55615 .62891 L
s
.55615 .62891 m
.55865 .62698 L
s
.256 .395 .786 r
.47195 .6321 m .46936 .63073 L .43976 .62838 L p F P
0 0 0 r
s
.83 .24 .1 r
.45621 .63847 m
.46887 .6316 L
s
.256 .395 .786 r
.43458 .62568 m .43976 .62838 L .46936 .63073 L p F P
0 0 0 r
s
.83 .24 .1 r
.44385 .62891 m
.45621 .63847 L
s
.44135 .62698 m
.44385 .62891 L
s
1 .303 .129 r
.52547 .63346 m .52289 .63481 L .5 .62969 L closepath p F P
0 0 0 r
s
.281 .425 .837 r
.47453 .63346 m .47711 .63481 L .5 .62969 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.75645 .53361 m
.76392 .51703 L
s
.80099 .49768 m
.76392 .51703 L
s
.24 .35 .67 r
.24355 .53361 m
.23608 .51703 L
s
.19901 .49768 m
.23608 .51703 L
s
.791 .229 .101 r
.37572 .59847 m .38472 .59319 L .36191 .57733 L p F P
0 0 0 r
s
.843 .246 .107 r
.38472 .59319 m .37572 .59847 L .40363 .61077 L p F P
0 0 0 r
s
.843 .246 .107 r
.39661 .61479 m .40363 .61077 L .37572 .59847 L p F P
0 0 0 r
s
.24 .35 .67 r
.37897 .60584 m
.38583 .60937 L
s
.37485 .60438 m
.37897 .60584 L
s
.306 .443 .849 r
.62428 .59847 m .61528 .59319 L .63809 .57733 L p F P
0 0 0 r
s
.307 .447 .861 r
.61528 .59319 m .62428 .59847 L .59637 .61077 L p F P
0 0 0 r
s
.307 .447 .861 r
.60339 .61479 m .59637 .61077 L .62428 .59847 L p F P
0 0 0 r
s
.83 .24 .1 r
.61417 .60937 m
.62103 .60584 L
s
.62103 .60584 m
.62515 .60438 L
s
.891 .261 .113 r
.40363 .61077 m .39661 .61479 L .42936 .62298 L p F P
0 0 0 r
s
1 .308 .129 r
.56542 .62568 m .57064 .62298 L .60339 .61479 L p F P
0 0 0 r
s
.24 .35 .67 r
.57276 .62328 m
.57709 .6257 L
s
.306 .449 .868 r
.59637 .61077 m .60339 .61479 L .57064 .62298 L p F P
0 0 0 r
s
.215 .34 .689 r
.43458 .62568 m .42936 .62298 L .39661 .61479 L p F P
0 0 0 r
s
.83 .24 .1 r
.42291 .6257 m
.42724 .62328 L
s
.80099 .49768 m
.80357 .47672 L
s
.84132 .45669 m
.80357 .47672 L
s
.24 .35 .67 r
.19901 .49768 m
.19643 .47672 L
s
.15868 .45669 m
.19643 .47672 L
s
.83 .24 .1 r
.7079 .56386 m
.72008 .5524 L
s
.75645 .53361 m
.72008 .5524 L
s
.24 .35 .67 r
.2921 .56386 m
.27992 .5524 L
s
.24355 .53361 m
.27992 .5524 L
s
.735 .211 .094 r
.36191 .57733 m .37268 .57083 L .35502 .55211 L p F P
0 0 0 r
s
.791 .229 .101 r
.37268 .57083 m .36191 .57733 L .38472 .59319 L p F P
0 0 0 r
s
.303 .436 .831 r
.63809 .57733 m .62732 .57083 L .64498 .55211 L p F P
0 0 0 r
s
.306 .443 .849 r
.62732 .57083 m .63809 .57733 L .61528 .59319 L p F P
0 0 0 r
s
1 .303 .129 r
.52805 .6321 m .52547 .63346 L .5 .62969 L closepath p F P
0 0 0 r
s
.281 .425 .837 r
.47195 .6321 m .47453 .63346 L .5 .62969 L closepath p F P
0 0 0 r
s
.276 .072 .035 r
.41892 .3921 m .4035 .40262 L .40127 .42102 L p F P
0 0 0 r
s
.276 .072 .035 r
.38577 .43146 m .40127 .42102 L .4035 .40262 L p F P
0 0 0 r
s
.83 .24 .1 r
.38697 .43218 m
.38726 .43045 L
s
.24 .327 .596 r
.58108 .3921 m .5965 .40262 L .59873 .42102 L p F P
0 0 0 r
s
.24 .327 .596 r
.61423 .43146 m .59873 .42102 L .5965 .40262 L p F P
0 0 0 r
s
.24 .35 .67 r
.61274 .43045 m
.61303 .43218 L
s
1 .311 .131 r
.53064 .63073 m .53324 .62937 L .56542 .62568 L p F P
0 0 0 r
s
1 .311 .131 r
.57064 .62298 m .56542 .62568 L .53324 .62937 L p F P
0 0 0 r
s
.83 .24 .1 r
.5658 .6238 m
.56716 .62309 L
s
.56716 .62309 m
.56987 .62311 L
s
.256 .395 .786 r
.46936 .63073 m .46676 .62937 L .43458 .62568 L p F P
0 0 0 r
s
.256 .395 .786 r
.42936 .62298 m .43458 .62568 L .46676 .62937 L p F P
0 0 0 r
s
.24 .35 .67 r
.43284 .62309 m
.4342 .6238 L
s
.43013 .62311 m
.43284 .62309 L
s
.83 .24 .1 r
.65584 .5879 m
.67228 .58217 L
s
.7079 .56386 m
.67228 .58217 L
s
.24 .35 .67 r
.34416 .5879 m
.32772 .58217 L
s
.2921 .56386 m
.32772 .58217 L
s
.672 .192 .086 r
.35502 .55211 m .36732 .5445 L .35467 .52376 L p F P
0 0 0 r
s
.735 .211 .094 r
.36732 .5445 m .35502 .55211 L .37268 .57083 L p F P
0 0 0 r
s
.299 .426 .808 r
.64498 .55211 m .63268 .5445 L .64533 .52376 L p F P
0 0 0 r
s
.303 .436 .831 r
.63268 .5445 m .64498 .55211 L .62732 .57083 L p F P
0 0 0 r
s
1 .303 .129 r
.53064 .63073 m .52805 .6321 L .5 .62969 L closepath p F P
0 0 0 r
s
.281 .425 .837 r
.46936 .63073 m .47195 .6321 L .5 .62969 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.84132 .45669 m
.83908 .43218 L
s
.24 .35 .67 r
.15868 .45669 m
.16092 .43218 L
s
.599 .169 .076 r
.35467 .52376 m .36824 .51516 L .36026 .49337 L p F P
0 0 0 r
s
.83 .24 .1 r
.36052 .49262 m
.3612 .49595 L
s
.672 .192 .086 r
.36824 .51516 m .35467 .52376 L .36732 .5445 L p F P
0 0 0 r
s
.291 .413 .778 r
.64533 .52376 m .63176 .51516 L .63974 .49337 L p F P
0 0 0 r
s
.24 .35 .67 r
.6388 .49595 m
.63948 .49262 L
s
.299 .426 .808 r
.63176 .51516 m .64533 .52376 L .63268 .5445 L p F P
0 0 0 r
s
.083 .024 .01 r
.48531 .32618 m .5 .316 L .5 .31319 L p F P
0 0 0 r
s
.24 .35 .67 r
.5 .31517 m
.51033 .32233 L
s
.49455 .31139 m
.4985 .31413 L
s
.4985 .31413 m
.49866 .31424 L
s
.104 .117 .224 r
.51469 .32618 m .5 .316 L .5 .31319 L p F P
0 0 0 r
s
.83 .24 .1 r
.5015 .31413 m
.50545 .31139 L
s
.50134 .31424 m
.5015 .31413 L
s
.6396 .23463 m
.60501 .25833 L
s
.60501 .25833 m
.58738 .25846 L
s
.24 .35 .67 r
.3604 .23463 m
.39499 .25833 L
s
.39499 .25833 m
.41262 .25846 L
s
.4 .107 .051 r
.40127 .42102 m .38577 .43146 L .38617 .4521 L p F P
0 0 0 r
s
.4 .107 .051 r
.37096 .46217 m .38617 .4521 L .38577 .43146 L p F P
0 0 0 r
s
.265 .367 .679 r
.59873 .42102 m .61423 .43146 L .61383 .4521 L p F P
0 0 0 r
s
.265 .367 .679 r
.62904 .46217 m .61383 .4521 L .61423 .43146 L p F P
0 0 0 r
s
1 .303 .129 r
.53324 .62937 m .53064 .63073 L .5 .62969 L closepath p F P
0 0 0 r
s
.281 .425 .837 r
.46676 .62937 m .46936 .63073 L .5 .62969 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.69445 .21696 m
.65896 .24096 L
s
.65896 .24096 m
.6396 .23463 L
s
.24 .35 .67 r
.30555 .21696 m
.34104 .24096 L
s
.34104 .24096 m
.3604 .23463 L
s
.511 .142 .065 r
.36026 .49337 m .37481 .48393 L .37096 .46217 L p F P
0 0 0 r
s
.599 .169 .076 r
.37481 .48393 m .36026 .49337 L .36824 .51516 L p F P
0 0 0 r
s
.281 .394 .737 r
.63974 .49337 m .62519 .48393 L .62904 .46217 L p F P
0 0 0 r
s
.291 .413 .778 r
.62519 .48393 m .63974 .49337 L .63176 .51516 L p F P
0 0 0 r
s
1 .311 .131 r
.53324 .62937 m .53584 .628 L .57064 .62298 L p F P
0 0 0 r
s
.256 .395 .786 r
.46676 .62937 m .46416 .628 L .42936 .62298 L p F P
0 0 0 r
s
.891 .261 .113 r
.42936 .62298 m .43424 .62026 L .40363 .61077 L p F P
0 0 0 r
s
.24 .35 .67 r
.43093 .6221 m
.43284 .62309 L
s
.937 .276 .119 r
.43424 .62026 m .42936 .62298 L .46416 .628 L p F P
0 0 0 r
s
.306 .449 .868 r
.57064 .62298 m .56576 .62026 L .59637 .61077 L p F P
0 0 0 r
s
.83 .24 .1 r
.56716 .62309 m
.56907 .6221 L
s
.302 .447 .869 r
.56576 .62026 m .57064 .62298 L .53584 .628 L p F P
0 0 0 r
s
.843 .246 .107 r
.40363 .61077 m .41071 .60672 L .38472 .59319 L p F P
0 0 0 r
s
.891 .261 .113 r
.41071 .60672 m .40363 .61077 L .43424 .62026 L p F P
0 0 0 r
s
.307 .447 .861 r
.59637 .61077 m .58929 .60672 L .61528 .59319 L p F P
0 0 0 r
s
.306 .449 .868 r
.58929 .60672 m .59637 .61077 L .56576 .62026 L p F P
0 0 0 r
s
.511 .142 .065 r
.38617 .4521 m .37096 .46217 L .37481 .48393 L p F P
0 0 0 r
s
.281 .394 .737 r
.61383 .4521 m .62904 .46217 L .62519 .48393 L p F P
0 0 0 r
s
.83 .24 .1 r
.58738 .25846 m
.55362 .28179 L
s
.55362 .28179 m
.53845 .28851 L
s
.24 .35 .67 r
.41262 .25846 m
.44638 .28179 L
s
.44638 .28179 m
.46155 .28851 L
s
1 .303 .129 r
.53584 .628 m .53324 .62937 L .5 .62969 L closepath p F P
0 0 0 r
s
.281 .425 .837 r
.46416 .628 m .46676 .62937 L .5 .62969 L closepath p F P
0 0 0 r
s
.791 .229 .101 r
.38472 .59319 m .39381 .58785 L .37268 .57083 L p F P
0 0 0 r
s
.24 .35 .67 r
.34416 .5879 m
.37897 .60584 L
s
.843 .246 .107 r
.39381 .58785 m .38472 .59319 L .41071 .60672 L p F P
0 0 0 r
s
.306 .443 .849 r
.61528 .59319 m .60619 .58785 L .62732 .57083 L p F P
0 0 0 r
s
.83 .24 .1 r
.62103 .60584 m
.65584 .5879 L
s
.307 .447 .861 r
.60619 .58785 m .61528 .59319 L .58929 .60672 L p F P
0 0 0 r
s
.15 .041 .019 r
.45299 .35625 m .43781 .3667 L .43461 .3814 L p F P
0 0 0 r
s
.15 .041 .019 r
.41892 .3921 m .43461 .3814 L .43781 .3667 L p F P
0 0 0 r
s
.202 .266 .472 r
.54701 .35625 m .56219 .3667 L .56539 .3814 L p F P
0 0 0 r
s
.202 .266 .472 r
.58108 .3921 m .56539 .3814 L .56219 .3667 L p F P
0 0 0 r
s
.83 .24 .1 r
.53845 .28851 m
.50545 .31139 L
s
.50158 .31564 m
.50545 .31139 L
s
.24 .35 .67 r
.46155 .28851 m
.49455 .31139 L
s
.49455 .31139 m
.49842 .31564 L
s
.83 .24 .1 r
.71485 .22934 m
.69445 .21696 L
s
.24 .35 .67 r
.28515 .22934 m
.30555 .21696 L
s
.083 .024 .01 r
.48531 .32618 m .47084 .3362 L .46841 .34563 L p F P
0 0 0 r
s
.083 .024 .01 r
.45299 .35625 m .46841 .34563 L .47084 .3362 L p F P
0 0 0 r
s
.157 .196 .347 r
.51469 .32618 m .52916 .3362 L .53159 .34563 L p F P
0 0 0 r
s
.157 .196 .347 r
.54701 .35625 m .53159 .34563 L .52916 .3362 L p F P
0 0 0 r
s
.937 .276 .119 r
.46416 .628 m .46668 .62663 L .43424 .62026 L p F P
0 0 0 r
s
.98 .291 .125 r
.5 .62969 m .46668 .62663 L .46416 .628 L closepath p F P
0 0 0 r
s
.302 .447 .869 r
.53584 .628 m .53332 .62663 L .56576 .62026 L p F P
0 0 0 r
s
.295 .44 .861 r
.5 .62969 m .53332 .62663 L .53584 .628 L closepath p F P
0 0 0 r
s
.891 .261 .113 r
.43424 .62026 m .43915 .61752 L .41071 .60672 L p F P
0 0 0 r
s
.24 .35 .67 r
.42233 .61763 m
.42703 .62007 L
s
.937 .276 .119 r
.43915 .61752 m .43424 .62026 L .46668 .62663 L p F P
0 0 0 r
s
.306 .449 .868 r
.56576 .62026 m .56085 .61752 L .58929 .60672 L p F P
0 0 0 r
s
.83 .24 .1 r
.57297 .62007 m
.57767 .61763 L
s
.302 .447 .869 r
.56085 .61752 m .56576 .62026 L .53332 .62663 L p F P
0 0 0 r
s
.735 .211 .094 r
.37268 .57083 m .38357 .56426 L .36732 .5445 L p F P
0 0 0 r
s
.791 .229 .101 r
.38357 .56426 m .37268 .57083 L .39381 .58785 L p F P
0 0 0 r
s
.303 .436 .831 r
.62732 .57083 m .61643 .56426 L .63268 .5445 L p F P
0 0 0 r
s
.306 .443 .849 r
.61643 .56426 m .62732 .57083 L .60619 .58785 L p F P
0 0 0 r
s
.98 .291 .125 r
.5 .62969 m .5 .60846 L .4974 .60988 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.49662 .62938 m
.49974 .62771 L
s
.83 .24 .1 r
.5 .62757 m
.50338 .62938 L
s
.98 .291 .125 r
.5 .62969 m .4974 .60988 L .4948 .61129 L closepath p F P
0 0 0 r
s
.98 .291 .125 r
.5 .62969 m .4948 .61129 L .49221 .6127 L closepath p F P
0 0 0 r
s
.98 .291 .125 r
.5 .62969 m .49221 .6127 L .48963 .61411 L closepath p F P
0 0 0 r
s
.295 .44 .861 r
.5 .62969 m .5 .60846 L .5026 .60988 L closepath p F P
0 0 0 r
s
.295 .44 .861 r
.5 .62969 m .5026 .60988 L .5052 .61129 L closepath p F P
0 0 0 r
s
.295 .44 .861 r
.5 .62969 m .5052 .61129 L .50779 .6127 L closepath p F P
0 0 0 r
s
.295 .44 .861 r
.5 .62969 m .50779 .6127 L .51037 .61411 L closepath p F P
0 0 0 r
s
.98 .291 .125 r
.5 .62969 m .48963 .61411 L .48705 .61552 L closepath p F P
0 0 0 r
s
.98 .291 .125 r
.5 .62969 m .48705 .61552 L .48448 .61692 L closepath p F P
0 0 0 r
s
.98 .291 .125 r
.5 .62969 m .48448 .61692 L .48192 .61832 L closepath p F P
0 0 0 r
s
.98 .291 .125 r
.5 .62969 m .48192 .61832 L .47936 .61971 L closepath p F P
0 0 0 r
s
.98 .291 .125 r
.5 .62969 m .47936 .61971 L .47681 .6211 L closepath p F P
0 0 0 r
s
.98 .291 .125 r
.5 .62969 m .47681 .6211 L .47427 .62249 L closepath p F P
0 0 0 r
s
.98 .291 .125 r
.5 .62969 m .47427 .62249 L .47173 .62387 L closepath p F P
0 0 0 r
s
.98 .291 .125 r
.5 .62969 m .47173 .62387 L .4692 .62525 L closepath p F P
0 0 0 r
s
.98 .291 .125 r
.5 .62969 m .4692 .62525 L .46668 .62663 L closepath p F P
0 0 0 r
s
.295 .44 .861 r
.5 .62969 m .51037 .61411 L .51295 .61552 L closepath p F P
0 0 0 r
s
.295 .44 .861 r
.5 .62969 m .51295 .61552 L .51552 .61692 L closepath p F P
0 0 0 r
s
.295 .44 .861 r
.5 .62969 m .51552 .61692 L .51808 .61832 L closepath p F P
0 0 0 r
s
.295 .44 .861 r
.5 .62969 m .51808 .61832 L .52064 .61971 L closepath p F P
0 0 0 r
s
.295 .44 .861 r
.5 .62969 m .52064 .61971 L .52319 .6211 L closepath p F P
0 0 0 r
s
.295 .44 .861 r
.5 .62969 m .52319 .6211 L .52573 .62249 L closepath p F P
0 0 0 r
s
.295 .44 .861 r
.5 .62969 m .52573 .62249 L .52827 .62387 L closepath p F P
0 0 0 r
s
.295 .44 .861 r
.5 .62969 m .52827 .62387 L .5308 .62525 L closepath p F P
0 0 0 r
s
.295 .44 .861 r
.5 .62969 m .5308 .62525 L .53332 .62663 L closepath p F P
0 0 0 r
s
.937 .276 .119 r
.46668 .62663 m .4692 .62525 L .43915 .61752 L p F P
0 0 0 r
s
.302 .447 .869 r
.53332 .62663 m .5308 .62525 L .56085 .61752 L p F P
0 0 0 r
s
.843 .246 .107 r
.41071 .60672 m .41784 .60264 L .39381 .58785 L p F P
0 0 0 r
s
.24 .35 .67 r
.37897 .60584 m
.39893 .60545 L
s
.891 .261 .113 r
.41784 .60264 m .41071 .60672 L .43915 .61752 L p F P
0 0 0 r
s
.307 .447 .861 r
.58929 .60672 m .58216 .60264 L .60619 .58785 L p F P
0 0 0 r
s
.83 .24 .1 r
.60107 .60545 m
.62103 .60584 L
s
.306 .449 .868 r
.58216 .60264 m .58929 .60672 L .56085 .61752 L p F P
0 0 0 r
s
.672 .192 .086 r
.36732 .5445 m .37979 .53678 L .36824 .51516 L p F P
0 0 0 r
s
.735 .211 .094 r
.37979 .53678 m .36732 .5445 L .38357 .56426 L p F P
0 0 0 r
s
.299 .426 .808 r
.63268 .5445 m .62021 .53678 L .63176 .51516 L p F P
0 0 0 r
s
.303 .436 .831 r
.62021 .53678 m .63268 .5445 L .61643 .56426 L p F P
0 0 0 r
s
.937 .276 .119 r
.44407 .61477 m .43915 .61752 L .4692 .62525 L p F P
0 0 0 r
s
.24 .35 .67 r
.441 .62068 m
.44337 .61998 L
s
.937 .276 .119 r
.4692 .62525 m .47173 .62387 L .44407 .61477 L p F P
0 0 0 r
s
.302 .447 .869 r
.55593 .61477 m .56085 .61752 L .5308 .62525 L p F P
0 0 0 r
s
.83 .24 .1 r
.55663 .61998 m
.559 .62068 L
s
.302 .447 .869 r
.5308 .62525 m .52827 .62387 L .55593 .61477 L p F P
0 0 0 r
s
.891 .261 .113 r
.43915 .61752 m .44407 .61477 L .41784 .60264 L p F P
0 0 0 r
s
.306 .449 .868 r
.56085 .61752 m .55593 .61477 L .58216 .60264 L p F P
0 0 0 r
s
.276 .072 .035 r
.43461 .3814 m .41892 .3921 L .41704 .4104 L p F P
0 0 0 r
s
.276 .072 .035 r
.40127 .42102 m .41704 .4104 L .41892 .3921 L p F P
0 0 0 r
s
.24 .327 .596 r
.56539 .3814 m .58108 .3921 L .58296 .4104 L p F P
0 0 0 r
s
.24 .327 .596 r
.59873 .42102 m .58296 .4104 L .58108 .3921 L p F P
0 0 0 r
s
.791 .229 .101 r
.39381 .58785 m .403 .58246 L .38357 .56426 L p F P
0 0 0 r
s
.843 .246 .107 r
.403 .58246 m .39381 .58785 L .41784 .60264 L p F P
0 0 0 r
s
.306 .443 .849 r
.60619 .58785 m .597 .58246 L .61643 .56426 L p F P
0 0 0 r
s
.307 .447 .861 r
.597 .58246 m .60619 .58785 L .58216 .60264 L p F P
0 0 0 r
s
.937 .276 .119 r
.44903 .61201 m .44407 .61477 L .47173 .62387 L p F P
0 0 0 r
s
.937 .276 .119 r
.47173 .62387 m .47427 .62249 L .44903 .61201 L p F P
0 0 0 r
s
.302 .447 .869 r
.55097 .61201 m .55593 .61477 L .52827 .62387 L p F P
0 0 0 r
s
.302 .447 .869 r
.52827 .62387 m .52573 .62249 L .55097 .61201 L p F P
0 0 0 r
s
.599 .169 .076 r
.36824 .51516 m .38201 .50642 L .37481 .48393 L p F P
0 0 0 r
s
.672 .192 .086 r
.38201 .50642 m .36824 .51516 L .37979 .53678 L p F P
0 0 0 r
s
.291 .413 .778 r
.63176 .51516 m .61799 .50642 L .62519 .48393 L p F P
0 0 0 r
s
.299 .426 .808 r
.61799 .50642 m .63176 .51516 L .62021 .53678 L p F P
0 0 0 r
s
.937 .276 .119 r
.45401 .60923 m .44903 .61201 L .47427 .62249 L p F P
0 0 0 r
s
.937 .276 .119 r
.47427 .62249 m .47681 .6211 L .45401 .60923 L p F P
0 0 0 r
s
.302 .447 .869 r
.54599 .60923 m .55097 .61201 L .52573 .62249 L p F P
0 0 0 r
s
.302 .447 .869 r
.52573 .62249 m .52319 .6211 L .54599 .60923 L p F P
0 0 0 r
s
.843 .246 .107 r
.41784 .60264 m .42503 .59853 L .403 .58246 L p F P
0 0 0 r
s
.891 .261 .113 r
.42503 .59853 m .41784 .60264 L .44407 .61477 L p F P
0 0 0 r
s
.24 .35 .67 r
.39893 .60545 m
.42233 .61763 L
s
.307 .447 .861 r
.58216 .60264 m .57497 .59853 L .597 .58246 L p F P
0 0 0 r
s
.306 .449 .868 r
.57497 .59853 m .58216 .60264 L .55593 .61477 L p F P
0 0 0 r
s
.83 .24 .1 r
.57767 .61763 m
.60107 .60545 L
s
.891 .261 .113 r
.44407 .61477 m .44903 .61201 L .42503 .59853 L p F P
0 0 0 r
s
.306 .449 .868 r
.55593 .61477 m .55097 .61201 L .57497 .59853 L p F P
0 0 0 r
s
.4 .107 .051 r
.41704 .4104 m .40127 .42102 L .40162 .44186 L p F P
0 0 0 r
s
.83 .24 .1 r
.40016 .42332 m
.4013 .42255 L
s
.4159 .41273 m
.41793 .41137 L
s
.4 .107 .051 r
.38617 .4521 m .40162 .44186 L .40127 .42102 L p F P
0 0 0 r
s
.265 .367 .679 r
.58296 .4104 m .59873 .42102 L .59838 .44186 L p F P
0 0 0 r
s
.24 .35 .67 r
.58207 .41137 m
.5841 .41273 L
s
.5987 .42255 m
.59984 .42332 L
s
.265 .367 .679 r
.61383 .4521 m .59838 .44186 L .59873 .42102 L p F P
0 0 0 r
s
.511 .142 .065 r
.37481 .48393 m .38959 .47434 L .38617 .4521 L p F P
0 0 0 r
s
.599 .169 .076 r
.38959 .47434 m .37481 .48393 L .38201 .50642 L p F P
0 0 0 r
s
.281 .394 .737 r
.62519 .48393 m .61041 .47434 L .61383 .4521 L p F P
0 0 0 r
s
.291 .413 .778 r
.61041 .47434 m .62519 .48393 L .61799 .50642 L p F P
0 0 0 r
s
.511 .142 .065 r
.40162 .44186 m .38617 .4521 L .38959 .47434 L p F P
0 0 0 r
s
.281 .394 .737 r
.59838 .44186 m .61383 .4521 L .61041 .47434 L p F P
0 0 0 r
s
.735 .211 .094 r
.38357 .56426 m .3946 .55761 L .37979 .53678 L p F P
0 0 0 r
s
.791 .229 .101 r
.3946 .55761 m .38357 .56426 L .403 .58246 L p F P
0 0 0 r
s
.303 .436 .831 r
.61643 .56426 m .6054 .55761 L .62021 .53678 L p F P
0 0 0 r
s
.306 .443 .849 r
.6054 .55761 m .61643 .56426 L .597 .58246 L p F P
0 0 0 r
s
.937 .276 .119 r
.45901 .60644 m .45401 .60923 L .47681 .6211 L p F P
0 0 0 r
s
.24 .35 .67 r
.44337 .61998 m
.45529 .61645 L
s
.937 .276 .119 r
.47681 .6211 m .47936 .61971 L .45901 .60644 L p F P
0 0 0 r
s
.302 .447 .869 r
.54099 .60644 m .54599 .60923 L .52319 .6211 L p F P
0 0 0 r
s
.83 .24 .1 r
.54471 .61645 m
.55663 .61998 L
s
.302 .447 .869 r
.52319 .6211 m .52064 .61971 L .54099 .60644 L p F P
0 0 0 r
s
.15 .041 .019 r
.46841 .34563 m .45299 .35625 L .45055 .37053 L p F P
0 0 0 r
s
.15 .041 .019 r
.43461 .3814 m .45055 .37053 L .45299 .35625 L p F P
0 0 0 r
s
.202 .266 .472 r
.53159 .34563 m .54701 .35625 L .54945 .37053 L p F P
0 0 0 r
s
.202 .266 .472 r
.56539 .3814 m .54945 .37053 L .54701 .35625 L p F P
0 0 0 r
s
.083 .024 .01 r
.5 .316 m .48531 .32618 L .48408 .33484 L p F P
0 0 0 r
s
.083 .024 .01 r
.46841 .34563 m .48408 .33484 L .48531 .32618 L p F P
0 0 0 r
s
.157 .196 .347 r
.5 .316 m .51469 .32618 L .51592 .33484 L p F P
0 0 0 r
s
.157 .196 .347 r
.53159 .34563 m .51592 .33484 L .51469 .32618 L p F P
0 0 0 r
s
.937 .276 .119 r
.46404 .60363 m .45901 .60644 L .47936 .61971 L p F P
0 0 0 r
s
.937 .276 .119 r
.47936 .61971 m .48192 .61832 L .46404 .60363 L p F P
0 0 0 r
s
.302 .447 .869 r
.53596 .60363 m .54099 .60644 L .52064 .61971 L p F P
0 0 0 r
s
.302 .447 .869 r
.52064 .61971 m .51808 .61832 L .53596 .60363 L p F P
0 0 0 r
s
.891 .261 .113 r
.43227 .59439 m .42503 .59853 L .44903 .61201 L p F P
0 0 0 r
s
.891 .261 .113 r
.44903 .61201 m .45401 .60923 L .43227 .59439 L p F P
0 0 0 r
s
.306 .449 .868 r
.56773 .59439 m .57497 .59853 L .55097 .61201 L p F P
0 0 0 r
s
.306 .449 .868 r
.55097 .61201 m .54599 .60923 L .56773 .59439 L p F P
0 0 0 r
s
.791 .229 .101 r
.403 .58246 m .41227 .57701 L .3946 .55761 L p F P
0 0 0 r
s
.843 .246 .107 r
.41227 .57701 m .403 .58246 L .42503 .59853 L p F P
0 0 0 r
s
.306 .443 .849 r
.597 .58246 m .58773 .57701 L .6054 .55761 L p F P
0 0 0 r
s
.307 .447 .861 r
.58773 .57701 m .597 .58246 L .57497 .59853 L p F P
0 0 0 r
s
.672 .192 .086 r
.37979 .53678 m .39242 .52897 L .38201 .50642 L p F P
0 0 0 r
s
.735 .211 .094 r
.39242 .52897 m .37979 .53678 L .3946 .55761 L p F P
0 0 0 r
s
.299 .426 .808 r
.62021 .53678 m .60758 .52897 L .61799 .50642 L p F P
0 0 0 r
s
.303 .436 .831 r
.60758 .52897 m .62021 .53678 L .6054 .55761 L p F P
0 0 0 r
s
.937 .276 .119 r
.4691 .60081 m .46404 .60363 L .48192 .61832 L p F P
0 0 0 r
s
.83 .24 .1 r
.46443 .60251 m
.4651 .60304 L
s
.24 .35 .67 r
.45529 .61645 m
.46863 .62351 L
s
.937 .276 .119 r
.48192 .61832 m .48448 .61692 L .4691 .60081 L p F P
0 0 0 r
s
.302 .447 .869 r
.5309 .60081 m .53596 .60363 L .51808 .61832 L p F P
0 0 0 r
s
.24 .35 .67 r
.5349 .60304 m
.53557 .60251 L
s
.83 .24 .1 r
.53137 .62351 m
.54471 .61645 L
s
.302 .447 .869 r
.51808 .61832 m .51552 .61692 L .5309 .60081 L p F P
0 0 0 r
s
.843 .246 .107 r
.42503 .59853 m .43227 .59439 L .41227 .57701 L p F P
0 0 0 r
s
.307 .447 .861 r
.57497 .59853 m .56773 .59439 L .58773 .57701 L p F P
0 0 0 r
s
.83 .24 .1 r
.79405 .5142 m
.80099 .49768 L
s
.83931 .47767 m
.80099 .49768 L
s
.24 .35 .67 r
.20595 .5142 m
.19901 .49768 L
s
.16069 .47767 m
.19901 .49768 L
s
.83 .24 .1 r
.54471 .61645 m
.54689 .6153 L
s
.24 .35 .67 r
.45311 .6153 m
.45529 .61645 L
s
.937 .276 .119 r
.47418 .59797 m .4691 .60081 L .48448 .61692 L p F P
0 0 0 r
s
.937 .276 .119 r
.48448 .61692 m .48705 .61552 L .47418 .59797 L p F P
0 0 0 r
s
.302 .447 .869 r
.52582 .59797 m .5309 .60081 L .51552 .61692 L p F P
0 0 0 r
s
.302 .447 .869 r
.51552 .61692 m .51295 .61552 L .52582 .59797 L p F P
0 0 0 r
s
.891 .261 .113 r
.43957 .59022 m .43227 .59439 L .45401 .60923 L p F P
0 0 0 r
s
.891 .261 .113 r
.45401 .60923 m .45901 .60644 L .43957 .59022 L p F P
0 0 0 r
s
.306 .449 .868 r
.56043 .59022 m .56773 .59439 L .54599 .60923 L p F P
0 0 0 r
s
.306 .449 .868 r
.54599 .60923 m .54099 .60644 L .56043 .59022 L p F P
0 0 0 r
s
.83 .24 .1 r
.83931 .47767 m
.84132 .45669 L
s
.24 .35 .67 r
.16069 .47767 m
.15868 .45669 L
s
.83 .24 .1 r
.74473 .54493 m
.75645 .53361 L
s
.79405 .5142 m
.75645 .53361 L
s
.24 .35 .67 r
.25527 .54493 m
.24355 .53361 L
s
.20595 .5142 m
.24355 .53361 L
s
.276 .072 .035 r
.45055 .37053 m .43461 .3814 L .43307 .39961 L p F P
0 0 0 r
s
.276 .072 .035 r
.41704 .4104 m .43307 .39961 L .43461 .3814 L p F P
0 0 0 r
s
.83 .24 .1 r
.41793 .41137 m
.41819 .40963 L
s
.24 .327 .596 r
.54945 .37053 m .56539 .3814 L .56693 .39961 L p F P
0 0 0 r
s
.24 .327 .596 r
.58296 .4104 m .56693 .39961 L .56539 .3814 L p F P
0 0 0 r
s
.24 .35 .67 r
.58181 .40963 m
.58207 .41137 L
s
.599 .169 .076 r
.38201 .50642 m .39599 .49755 L .38959 .47434 L p F P
0 0 0 r
s
.672 .192 .086 r
.39599 .49755 m .38201 .50642 L .39242 .52897 L p F P
0 0 0 r
s
.291 .413 .778 r
.61799 .50642 m .60401 .49755 L .61041 .47434 L p F P
0 0 0 r
s
.299 .426 .808 r
.60401 .49755 m .61799 .50642 L .60758 .52897 L p F P
0 0 0 r
s
.937 .276 .119 r
.47929 .59512 m .47418 .59797 L .48705 .61552 L p F P
0 0 0 r
s
.937 .276 .119 r
.48705 .61552 m .48963 .61411 L .47929 .59512 L p F P
0 0 0 r
s
.302 .447 .869 r
.52071 .59512 m .52582 .59797 L .51295 .61552 L p F P
0 0 0 r
s
.302 .447 .869 r
.51295 .61552 m .51037 .61411 L .52071 .59512 L p F P
0 0 0 r
s
.83 .24 .1 r
.69182 .56936 m
.7079 .56386 L
s
.74473 .54493 m
.7079 .56386 L
s
.24 .35 .67 r
.30818 .56936 m
.2921 .56386 L
s
.25527 .54493 m
.2921 .56386 L
s
.735 .211 .094 r
.3946 .55761 m .40575 .55089 L .39242 .52897 L p F P
0 0 0 r
s
.791 .229 .101 r
.40575 .55089 m .3946 .55761 L .41227 .57701 L p F P
0 0 0 r
s
.303 .436 .831 r
.6054 .55761 m .59425 .55089 L .60758 .52897 L p F P
0 0 0 r
s
.306 .443 .849 r
.59425 .55089 m .6054 .55761 L .58773 .57701 L p F P
0 0 0 r
s
.83 .24 .1 r
.57874 .59844 m
.60107 .60545 L
s
.63612 .58721 m
.60107 .60545 L
s
.24 .35 .67 r
.39893 .60545 m
.42126 .59844 L
s
.36388 .58721 m
.39893 .60545 L
s
.83 .24 .1 r
.63612 .58721 m
.65584 .5879 L
s
.69182 .56936 m
.65584 .5879 L
s
.24 .35 .67 r
.36388 .58721 m
.34416 .5879 L
s
.30818 .56936 m
.34416 .5879 L
s
.843 .246 .107 r
.42163 .57152 m .41227 .57701 L .43227 .59439 L p F P
0 0 0 r
s
.843 .246 .107 r
.43227 .59439 m .43957 .59022 L .42163 .57152 L p F P
0 0 0 r
s
.307 .447 .861 r
.57837 .57152 m .58773 .57701 L .56773 .59439 L p F P
0 0 0 r
s
.307 .447 .861 r
.56773 .59439 m .56043 .59022 L .57837 .57152 L p F P
0 0 0 r
s
.937 .276 .119 r
.48443 .59226 m .47929 .59512 L .48963 .61411 L p F P
0 0 0 r
s
.937 .276 .119 r
.48963 .61411 m .49221 .6127 L .48443 .59226 L p F P
0 0 0 r
s
.302 .447 .869 r
.51557 .59226 m .52071 .59512 L .51037 .61411 L p F P
0 0 0 r
s
.302 .447 .869 r
.51037 .61411 m .50779 .6127 L .51557 .59226 L p F P
0 0 0 r
s
.891 .261 .113 r
.44692 .58601 m .43957 .59022 L .45901 .60644 L p F P
0 0 0 r
s
.891 .261 .113 r
.45901 .60644 m .46404 .60363 L .44692 .58601 L p F P
0 0 0 r
s
.83 .24 .1 r
.46348 .60305 m
.46443 .60251 L
s
.306 .449 .868 r
.55308 .58601 m .56043 .59022 L .54099 .60644 L p F P
0 0 0 r
s
.306 .449 .868 r
.54099 .60644 m .53596 .60363 L .55308 .58601 L p F P
0 0 0 r
s
.24 .35 .67 r
.53557 .60251 m
.53652 .60305 L
s
.791 .229 .101 r
.41227 .57701 m .42163 .57152 L .40575 .55089 L p F P
0 0 0 r
s
.306 .443 .849 r
.58773 .57701 m .57837 .57152 L .59425 .55089 L p F P
0 0 0 r
s
.511 .142 .065 r
.38959 .47434 m .4046 .46459 L .40162 .44186 L p F P
0 0 0 r
s
.599 .169 .076 r
.4046 .46459 m .38959 .47434 L .39599 .49755 L p F P
0 0 0 r
s
.281 .394 .737 r
.61041 .47434 m .5954 .46459 L .59838 .44186 L p F P
0 0 0 r
s
.291 .413 .778 r
.5954 .46459 m .61041 .47434 L .60401 .49755 L p F P
0 0 0 r
s
.83 .24 .1 r
.67534 .21012 m
.6396 .23463 L
s
.6396 .23463 m
.62227 .23433 L
s
.24 .35 .67 r
.32466 .21012 m
.3604 .23463 L
s
.3604 .23463 m
.37773 .23433 L
s
.4 .107 .051 r
.43307 .39961 m .41704 .4104 L .41734 .43146 L p F P
0 0 0 r
s
.4 .107 .051 r
.40162 .44186 m .41734 .43146 L .41704 .4104 L p F P
0 0 0 r
s
.265 .367 .679 r
.56693 .39961 m .58296 .4104 L .58266 .43146 L p F P
0 0 0 r
s
.265 .367 .679 r
.59838 .44186 m .58266 .43146 L .58296 .4104 L p F P
0 0 0 r
s
.83 .24 .1 r
.69445 .21696 m
.67534 .21012 L
s
.24 .35 .67 r
.30555 .21696 m
.32466 .21012 L
s
.937 .276 .119 r
.48959 .58938 m .48443 .59226 L .49221 .6127 L p F P
0 0 0 r
s
.24 .35 .67 r
.47899 .60333 m
.48922 .60888 L
s
.937 .276 .119 r
.49221 .6127 m .4948 .61129 L .48959 .58938 L p F P
0 0 0 r
s
.302 .447 .869 r
.51041 .58938 m .51557 .59226 L .50779 .6127 L p F P
0 0 0 r
s
.83 .24 .1 r
.51078 .60888 m
.52101 .60333 L
s
.302 .447 .869 r
.50779 .6127 m .5052 .61129 L .51041 .58938 L p F P
0 0 0 r
s
.511 .142 .065 r
.41734 .43146 m .40162 .44186 L .4046 .46459 L p F P
0 0 0 r
s
.281 .394 .737 r
.58266 .43146 m .59838 .44186 L .5954 .46459 L p F P
0 0 0 r
s
.83 .24 .1 r
.62227 .23433 m
.58738 .25846 L
s
.58738 .25846 m
.57256 .26487 L
s
.24 .35 .67 r
.37773 .23433 m
.41262 .25846 L
s
.41262 .25846 m
.42744 .26487 L
s
.083 .024 .01 r
.48408 .33484 m .5 .32387 L .5 .316 L p F P
0 0 0 r
s
.83 .24 .1 r
.5 .31738 m
.5006 .31672 L
s
.157 .196 .347 r
.51592 .33484 m .5 .32387 L .5 .316 L p F P
0 0 0 r
s
.15 .041 .019 r
.48408 .33484 m .46841 .34563 L .46675 .35947 L p F P
0 0 0 r
s
.15 .041 .019 r
.45055 .37053 m .46675 .35947 L .46841 .34563 L p F P
0 0 0 r
s
.202 .266 .472 r
.51592 .33484 m .53159 .34563 L .53325 .35947 L p F P
0 0 0 r
s
.202 .266 .472 r
.54945 .37053 m .53325 .35947 L .53159 .34563 L p F P
0 0 0 r
s
.83 .24 .1 r
.57256 .26487 m
.53845 .28851 L
s
.53845 .28851 m
.52687 .30147 L
s
.24 .35 .67 r
.42744 .26487 m
.46155 .28851 L
s
.46155 .28851 m
.47313 .30147 L
s
.937 .276 .119 r
.49478 .58648 m .48959 .58938 L .4948 .61129 L p F P
0 0 0 r
s
.24 .35 .67 r
.48922 .60888 m
.49233 .61056 L
s
.937 .276 .119 r
.4948 .61129 m .4974 .60988 L .49478 .58648 L p F P
0 0 0 r
s
.302 .447 .869 r
.50522 .58648 m .51041 .58938 L .5052 .61129 L p F P
0 0 0 r
s
.83 .24 .1 r
.50767 .61056 m
.51078 .60888 L
s
.302 .447 .869 r
.5052 .61129 m .5026 .60988 L .50522 .58648 L p F P
0 0 0 r
s
.672 .192 .086 r
.39242 .52897 m .40522 .52104 L .39599 .49755 L p F P
0 0 0 r
s
.735 .211 .094 r
.40522 .52104 m .39242 .52897 L .40575 .55089 L p F P
0 0 0 r
s
.299 .426 .808 r
.60758 .52897 m .59478 .52104 L .60401 .49755 L p F P
0 0 0 r
s
.303 .436 .831 r
.59478 .52104 m .60758 .52897 L .59425 .55089 L p F P
0 0 0 r
s
.891 .261 .113 r
.45433 .58178 m .44692 .58601 L .46404 .60363 L p F P
0 0 0 r
s
.83 .24 .1 r
.46275 .60072 m
.46443 .60251 L
s
.24 .35 .67 r
.42126 .59844 m
.45311 .6153 L
s
.891 .261 .113 r
.46404 .60363 m .4691 .60081 L .45433 .58178 L p F P
0 0 0 r
s
.24 .35 .67 r
.45529 .61645 m
.47899 .60333 L
s
.306 .449 .868 r
.54567 .58178 m .55308 .58601 L .53596 .60363 L p F P
0 0 0 r
s
.24 .35 .67 r
.53557 .60251 m
.53725 .60072 L
s
.83 .24 .1 r
.54689 .6153 m
.57874 .59844 L
s
.306 .449 .868 r
.53596 .60363 m .5309 .60081 L .54567 .58178 L p F P
0 0 0 r
s
.83 .24 .1 r
.52101 .60333 m
.54471 .61645 L
s
.50092 .31939 m
.52687 .30147 L
s
.24 .35 .67 r
.47313 .30147 m
.49908 .31939 L
s
.843 .246 .107 r
.43109 .56596 m .42163 .57152 L .43957 .59022 L p F P
0 0 0 r
s
.843 .246 .107 r
.43957 .59022 m .44692 .58601 L .43109 .56596 L p F P
0 0 0 r
s
.307 .447 .861 r
.56891 .56596 m .57837 .57152 L .56043 .59022 L p F P
0 0 0 r
s
.307 .447 .861 r
.56043 .59022 m .55308 .58601 L .56891 .56596 L p F P
0 0 0 r
s
.937 .276 .119 r
.5 .58357 m .49478 .58648 L .4974 .60988 L p F P
0 0 0 r
s
.937 .276 .119 r
.4974 .60988 m .5 .60846 L .5 .58357 L p F P
0 0 0 r
s
.302 .447 .869 r
.5 .58357 m .50522 .58648 L .5026 .60988 L p F P
0 0 0 r
s
.302 .447 .869 r
.5026 .60988 m .5 .60846 L .5 .58357 L p F P
0 0 0 r
s
.735 .211 .094 r
.40575 .55089 m .41704 .54408 L .40522 .52104 L p F P
0 0 0 r
s
.791 .229 .101 r
.41704 .54408 m .40575 .55089 L .42163 .57152 L p F P
0 0 0 r
s
.303 .436 .831 r
.59425 .55089 m .58296 .54408 L .59478 .52104 L p F P
0 0 0 r
s
.306 .443 .849 r
.58296 .54408 m .59425 .55089 L .57837 .57152 L p F P
0 0 0 r
s
.791 .229 .101 r
.42163 .57152 m .43109 .56596 L .41704 .54408 L p F P
0 0 0 r
s
.83 .24 .1 r
.42171 .55136 m
.42235 .55098 L
s
.306 .443 .849 r
.57837 .57152 m .56891 .56596 L .58296 .54408 L p F P
0 0 0 r
s
.24 .35 .67 r
.57765 .55098 m
.57829 .55136 L
s
.891 .261 .113 r
.46179 .57751 m .45433 .58178 L .4691 .60081 L p F P
0 0 0 r
s
.891 .261 .113 r
.4691 .60081 m .47418 .59797 L .46179 .57751 L p F P
0 0 0 r
s
.306 .449 .868 r
.53821 .57751 m .54567 .58178 L .5309 .60081 L p F P
0 0 0 r
s
.306 .449 .868 r
.5309 .60081 m .52582 .59797 L .53821 .57751 L p F P
0 0 0 r
s
.599 .169 .076 r
.39599 .49755 m .41017 .48855 L .4046 .46459 L p F P
0 0 0 r
s
.672 .192 .086 r
.41017 .48855 m .39599 .49755 L .40522 .52104 L p F P
0 0 0 r
s
.83 .24 .1 r
.40555 .51893 m
.40625 .52081 L
s
.40538 .52135 m
.40625 .52081 L
s
.291 .413 .778 r
.60401 .49755 m .58983 .48855 L .5954 .46459 L p F P
0 0 0 r
s
.299 .426 .808 r
.58983 .48855 m .60401 .49755 L .59478 .52104 L p F P
0 0 0 r
s
.24 .35 .67 r
.59375 .52081 m
.59445 .51893 L
s
.59375 .52081 m
.59462 .52135 L
s
.276 .072 .035 r
.46675 .35947 m .45055 .37053 L .44938 .38863 L p F P
0 0 0 r
s
.276 .072 .035 r
.43307 .39961 m .44938 .38863 L .45055 .37053 L p F P
0 0 0 r
s
.24 .327 .596 r
.53325 .35947 m .54945 .37053 L .55062 .38863 L p F P
0 0 0 r
s
.24 .327 .596 r
.56693 .39961 m .55062 .38863 L .54945 .37053 L p F P
0 0 0 r
s
.843 .246 .107 r
.44064 .56036 m .43109 .56596 L .44692 .58601 L p F P
0 0 0 r
s
.83 .24 .1 r
.4462 .58308 m
.44824 .58526 L
s
.843 .246 .107 r
.44692 .58601 m .45433 .58178 L .44064 .56036 L p F P
0 0 0 r
s
.307 .447 .861 r
.55936 .56036 m .56891 .56596 L .55308 .58601 L p F P
0 0 0 r
s
.24 .35 .67 r
.55176 .58526 m
.5538 .58308 L
s
.307 .447 .861 r
.55308 .58601 m .54567 .58178 L .55936 .56036 L p F P
0 0 0 r
s
.83 .24 .1 r
.42235 .55098 m
.43245 .56516 L
s
.24 .35 .67 r
.56755 .56516 m
.57765 .55098 L
s
.891 .261 .113 r
.46932 .5732 m .46179 .57751 L .47418 .59797 L p F P
0 0 0 r
s
.891 .261 .113 r
.47418 .59797 m .47929 .59512 L .46932 .5732 L p F P
0 0 0 r
s
.306 .449 .868 r
.53068 .5732 m .53821 .57751 L .52582 .59797 L p F P
0 0 0 r
s
.306 .449 .868 r
.52582 .59797 m .52071 .59512 L .53068 .5732 L p F P
0 0 0 r
s
.511 .142 .065 r
.4046 .46459 m .41986 .45469 L .41734 .43146 L p F P
0 0 0 r
s
.599 .169 .076 r
.41986 .45469 m .4046 .46459 L .41017 .48855 L p F P
0 0 0 r
s
.281 .394 .737 r
.5954 .46459 m .58014 .45469 L .58266 .43146 L p F P
0 0 0 r
s
.291 .413 .778 r
.58014 .45469 m .5954 .46459 L .58983 .48855 L p F P
0 0 0 r
s
.4 .107 .051 r
.44938 .38863 m .43307 .39961 L .43331 .42088 L p F P
0 0 0 r
s
.83 .24 .1 r
.43191 .40197 m
.43309 .40117 L
s
.44819 .39102 m
.44993 .38985 L
s
.4 .107 .051 r
.41734 .43146 m .43331 .42088 L .43307 .39961 L p F P
0 0 0 r
s
.265 .367 .679 r
.55062 .38863 m .56693 .39961 L .56669 .42088 L p F P
0 0 0 r
s
.24 .35 .67 r
.55007 .38985 m
.55181 .39102 L
s
.56691 .40117 m
.56809 .40197 L
s
.265 .367 .679 r
.58266 .43146 m .56669 .42088 L .56693 .39961 L p F P
0 0 0 r
s
.83 .24 .1 r
.50604 .59125 m
.50855 .59328 L
s
.52101 .60333 m
.5232 .60214 L
s
.24 .35 .67 r
.49145 .59328 m
.49396 .59125 L
s
.4768 .60214 m
.47899 .60333 L
s
.672 .192 .086 r
.40522 .52104 m .41821 .513 L .41017 .48855 L p F P
0 0 0 r
s
.735 .211 .094 r
.41821 .513 m .40522 .52104 L .41704 .54408 L p F P
0 0 0 r
s
.83 .24 .1 r
.41715 .54123 m
.42235 .55098 L
s
.299 .426 .808 r
.59478 .52104 m .58179 .513 L .58983 .48855 L p F P
0 0 0 r
s
.303 .436 .831 r
.58179 .513 m .59478 .52104 L .58296 .54408 L p F P
0 0 0 r
s
.24 .35 .67 r
.57765 .55098 m
.58285 .54123 L
s
.511 .142 .065 r
.43331 .42088 m .41734 .43146 L .41986 .45469 L p F P
0 0 0 r
s
.281 .394 .737 r
.56669 .42088 m .58266 .43146 L .58014 .45469 L p F P
0 0 0 r
s
.15 .041 .019 r
.5 .32387 m .48408 .33484 L .48324 .34822 L p F P
0 0 0 r
s
.15 .041 .019 r
.46675 .35947 m .48324 .34822 L .48408 .33484 L p F P
0 0 0 r
s
.202 .266 .472 r
.5 .32387 m .51592 .33484 L .51676 .34822 L p F P
0 0 0 r
s
.202 .266 .472 r
.53325 .35947 m .51676 .34822 L .51592 .33484 L p F P
0 0 0 r
s
.791 .229 .101 r
.42847 .53719 m .41704 .54408 L .43109 .56596 L p F P
0 0 0 r
s
.791 .229 .101 r
.43109 .56596 m .44064 .56036 L .42847 .53719 L p F P
0 0 0 r
s
.306 .443 .849 r
.57153 .53719 m .58296 .54408 L .56891 .56596 L p F P
0 0 0 r
s
.306 .443 .849 r
.56891 .56596 m .55936 .56036 L .57153 .53719 L p F P
0 0 0 r
s
.891 .261 .113 r
.4769 .56887 m .46932 .5732 L .47929 .59512 L p F P
0 0 0 r
s
.24 .35 .67 r
.44494 .58487 m
.4768 .60214 L
s
.891 .261 .113 r
.47929 .59512 m .48443 .59226 L .4769 .56887 L p F P
0 0 0 r
s
.24 .35 .67 r
.47899 .60333 m
.49145 .59328 L
s
.306 .449 .868 r
.5231 .56887 m .53068 .5732 L .52071 .59512 L p F P
0 0 0 r
s
.83 .24 .1 r
.5232 .60214 m
.55506 .58487 L
s
.306 .449 .868 r
.52071 .59512 m .51557 .59226 L .5231 .56887 L p F P
0 0 0 r
s
.83 .24 .1 r
.50855 .59328 m
.52101 .60333 L
s
.735 .211 .094 r
.41704 .54408 m .42847 .53719 L .41821 .513 L p F P
0 0 0 r
s
.303 .436 .831 r
.58296 .54408 m .57153 .53719 L .58179 .513 L p F P
0 0 0 r
s
.843 .246 .107 r
.45028 .55469 m .44064 .56036 L .45433 .58178 L p F P
0 0 0 r
s
.843 .246 .107 r
.45433 .58178 m .46179 .57751 L .45028 .55469 L p F P
0 0 0 r
s
.307 .447 .861 r
.54972 .55469 m .55936 .56036 L .54567 .58178 L p F P
0 0 0 r
s
.307 .447 .861 r
.54567 .58178 m .53821 .57751 L .54972 .55469 L p F P
0 0 0 r
s
.891 .261 .113 r
.48454 .5645 m .4769 .56887 L .48443 .59226 L p F P
0 0 0 r
s
.891 .261 .113 r
.48443 .59226 m .48959 .58938 L .48454 .5645 L p F P
0 0 0 r
s
.306 .449 .868 r
.51546 .5645 m .5231 .56887 L .51557 .59226 L p F P
0 0 0 r
s
.306 .449 .868 r
.51557 .59226 m .51041 .58938 L .51546 .5645 L p F P
0 0 0 r
s
.599 .169 .076 r
.41017 .48855 m .42458 .47941 L .41986 .45469 L p F P
0 0 0 r
s
.672 .192 .086 r
.42458 .47941 m .41017 .48855 L .41821 .513 L p F P
0 0 0 r
s
.291 .413 .778 r
.58983 .48855 m .57542 .47941 L .58014 .45469 L p F P
0 0 0 r
s
.299 .426 .808 r
.57542 .47941 m .58983 .48855 L .58179 .513 L p F P
0 0 0 r
s
.83 .24 .1 r
.83293 .49412 m
.83931 .47767 L
s
.24 .35 .67 r
.16707 .49412 m
.16069 .47767 L
s
.83 .24 .1 r
.55506 .58487 m
.57874 .59844 L
s
.61393 .5798 m
.57874 .59844 L
s
.24 .35 .67 r
.42126 .59844 m
.44494 .58487 L
s
.38607 .5798 m
.42126 .59844 L
s
.83 .24 .1 r
.78281 .52535 m
.79405 .5142 L
s
.83293 .49412 m
.79405 .5142 L
s
.24 .35 .67 r
.21719 .52535 m
.20595 .5142 L
s
.16707 .49412 m
.20595 .5142 L
s
.276 .072 .035 r
.48324 .34822 m .46675 .35947 L .46596 .37747 L p F P
0 0 0 r
s
.276 .072 .035 r
.44938 .38863 m .46596 .37747 L .46675 .35947 L p F P
0 0 0 r
s
.83 .24 .1 r
.44993 .38985 m
.45017 .3881 L
s
.24 .327 .596 r
.51676 .34822 m .53325 .35947 L .53404 .37747 L p F P
0 0 0 r
s
.24 .327 .596 r
.55062 .38863 m .53404 .37747 L .53325 .35947 L p F P
0 0 0 r
s
.24 .35 .67 r
.54983 .3881 m
.55007 .38985 L
s
.843 .246 .107 r
.46003 .54897 m .45028 .55469 L .46179 .57751 L p F P
0 0 0 r
s
.843 .246 .107 r
.46179 .57751 m .46932 .5732 L .46003 .54897 L p F P
0 0 0 r
s
.307 .447 .861 r
.53997 .54897 m .54972 .55469 L .53821 .57751 L p F P
0 0 0 r
s
.307 .447 .861 r
.53821 .57751 m .53068 .5732 L .53997 .54897 L p F P
0 0 0 r
s
.791 .229 .101 r
.44003 .53022 m .42847 .53719 L .44064 .56036 L p F P
0 0 0 r
s
.791 .229 .101 r
.44064 .56036 m .45028 .55469 L .44003 .53022 L p F P
0 0 0 r
s
.306 .443 .849 r
.55997 .53022 m .57153 .53719 L .55936 .56036 L p F P
0 0 0 r
s
.306 .443 .849 r
.55936 .56036 m .54972 .55469 L .55997 .53022 L p F P
0 0 0 r
s
.83 .24 .1 r
.72903 .55019 m
.74473 .54493 L
s
.78281 .52535 m
.74473 .54493 L
s
.24 .35 .67 r
.27097 .55019 m
.25527 .54493 L
s
.21719 .52535 m
.25527 .54493 L
s
.891 .261 .113 r
.49224 .56009 m .48454 .5645 L .48959 .58938 L p F P
0 0 0 r
s
.891 .261 .113 r
.48959 .58938 m .49478 .58648 L .49224 .56009 L p F P
0 0 0 r
s
.306 .449 .868 r
.50776 .56009 m .51546 .5645 L .51041 .58938 L p F P
0 0 0 r
s
.306 .449 .868 r
.51041 .58938 m .50522 .58648 L .50776 .56009 L p F P
0 0 0 r
s
.83 .24 .1 r
.61393 .5798 m
.63612 .58721 L
s
.67237 .56835 m
.63612 .58721 L
s
.24 .35 .67 r
.38607 .5798 m
.36388 .58721 L
s
.32763 .56835 m
.36388 .58721 L
s
.83 .24 .1 r
.67237 .56835 m
.69182 .56936 L
s
.72903 .55019 m
.69182 .56936 L
s
.24 .35 .67 r
.32763 .56835 m
.30818 .56936 L
s
.27097 .55019 m
.30818 .56936 L
s
.672 .192 .086 r
.41821 .513 m .43137 .50486 L .42458 .47941 L p F P
0 0 0 r
s
.735 .211 .094 r
.43137 .50486 m .41821 .513 L .42847 .53719 L p F P
0 0 0 r
s
.299 .426 .808 r
.58179 .513 m .56863 .50486 L .57542 .47941 L p F P
0 0 0 r
s
.303 .436 .831 r
.56863 .50486 m .58179 .513 L .57153 .53719 L p F P
0 0 0 r
s
.511 .142 .065 r
.41986 .45469 m .43537 .44463 L .43331 .42088 L p F P
0 0 0 r
s
.599 .169 .076 r
.43537 .44463 m .41986 .45469 L .42458 .47941 L p F P
0 0 0 r
s
.281 .394 .737 r
.58014 .45469 m .56463 .44463 L .56669 .42088 L p F P
0 0 0 r
s
.291 .413 .778 r
.56463 .44463 m .58014 .45469 L .57542 .47941 L p F P
0 0 0 r
s
.735 .211 .094 r
.42847 .53719 m .44003 .53022 L .43137 .50486 L p F P
0 0 0 r
s
.303 .436 .831 r
.57153 .53719 m .55997 .53022 L .56863 .50486 L p F P
0 0 0 r
s
.83 .24 .1 r
.67534 .21012 m
.65837 .20938 L
s
.24 .35 .67 r
.32466 .21012 m
.34163 .20938 L
s
.4 .107 .051 r
.46596 .37747 m .44938 .38863 L .44956 .41012 L p F P
0 0 0 r
s
.4 .107 .051 r
.43331 .42088 m .44956 .41012 L .44938 .38863 L p F P
0 0 0 r
s
.265 .367 .679 r
.53404 .37747 m .55062 .38863 L .55044 .41012 L p F P
0 0 0 r
s
.265 .367 .679 r
.56669 .42088 m .55044 .41012 L .55062 .38863 L p F P
0 0 0 r
s
.15 .041 .019 r
.48324 .34822 m .5 .33679 L .5 .32387 L p F P
0 0 0 r
s
.202 .266 .472 r
.51676 .34822 m .5 .33679 L .5 .32387 L p F P
0 0 0 r
s
.511 .142 .065 r
.44956 .41012 m .43331 .42088 L .43537 .44463 L p F P
0 0 0 r
s
.281 .394 .737 r
.55044 .41012 m .56669 .42088 L .56463 .44463 L p F P
0 0 0 r
s
.83 .24 .1 r
.65837 .20938 m
.62227 .23433 L
s
.62227 .23433 m
.60785 .24042 L
s
.24 .35 .67 r
.34163 .20938 m
.37773 .23433 L
s
.37773 .23433 m
.39215 .24042 L
s
.891 .261 .113 r
.5 .55565 m .49224 .56009 L .49478 .58648 L p F P
0 0 0 r
s
.891 .261 .113 r
.49478 .58648 m .5 .58357 L .5 .55565 L p F P
0 0 0 r
s
.306 .449 .868 r
.5 .55565 m .50776 .56009 L .50522 .58648 L p F P
0 0 0 r
s
.306 .449 .868 r
.50522 .58648 m .5 .58357 L .5 .55565 L p F P
0 0 0 r
s
.83 .24 .1 r
.50507 .57982 m
.5078 .5783 L
s
.50309 .58093 m
.50507 .57982 L
s
.24 .35 .67 r
.4922 .5783 m
.49493 .57982 L
s
.49493 .57982 m
.49691 .58093 L
s
.843 .246 .107 r
.46987 .54319 m .46003 .54897 L .46932 .5732 L p F P
0 0 0 r
s
.843 .246 .107 r
.46932 .5732 m .4769 .56887 L .46987 .54319 L p F P
0 0 0 r
s
.307 .447 .861 r
.53013 .54319 m .53997 .54897 L .53068 .5732 L p F P
0 0 0 r
s
.307 .447 .861 r
.53068 .5732 m .5231 .56887 L .53013 .54319 L p F P
0 0 0 r
s
.83 .24 .1 r
.60785 .24042 m
.57256 .26487 L
s
.57256 .26487 m
.5614 .27762 L
s
.24 .35 .67 r
.39215 .24042 m
.42744 .26487 L
s
.42744 .26487 m
.4386 .27762 L
s
.83 .24 .1 r
.50089 .33317 m
.51962 .32037 L
s
.24 .35 .67 r
.48038 .32037 m
.49911 .33317 L
s
.83 .24 .1 r
.5614 .27762 m
.52687 .30147 L
s
.52687 .30147 m
.51962 .32037 L
s
.24 .35 .67 r
.4386 .27762 m
.47313 .30147 L
s
.47313 .30147 m
.48038 .32037 L
s
.791 .229 .101 r
.45173 .52316 m .44003 .53022 L .45028 .55469 L p F P
0 0 0 r
s
.791 .229 .101 r
.45028 .55469 m .46003 .54897 L .45173 .52316 L p F P
0 0 0 r
s
.306 .443 .849 r
.54827 .52316 m .55997 .53022 L .54972 .55469 L p F P
0 0 0 r
s
.306 .443 .849 r
.54972 .55469 m .53997 .54897 L .54827 .52316 L p F P
0 0 0 r
s
.599 .169 .076 r
.42458 .47941 m .4392 .47013 L .43537 .44463 L p F P
0 0 0 r
s
.672 .192 .086 r
.4392 .47013 m .42458 .47941 L .43137 .50486 L p F P
0 0 0 r
s
.291 .413 .778 r
.57542 .47941 m .5608 .47013 L .56463 .44463 L p F P
0 0 0 r
s
.299 .426 .808 r
.5608 .47013 m .57542 .47941 L .56863 .50486 L p F P
0 0 0 r
s
.843 .246 .107 r
.47981 .53736 m .46987 .54319 L .4769 .56887 L p F P
0 0 0 r
s
.843 .246 .107 r
.4769 .56887 m .48454 .5645 L .47981 .53736 L p F P
0 0 0 r
s
.24 .35 .67 r
.46876 .56521 m
.4922 .5783 L
s
.307 .447 .861 r
.52019 .53736 m .53013 .54319 L .5231 .56887 L p F P
0 0 0 r
s
.307 .447 .861 r
.5231 .56887 m .51546 .5645 L .52019 .53736 L p F P
0 0 0 r
s
.83 .24 .1 r
.5078 .5783 m
.53124 .56521 L
s
.735 .211 .094 r
.44471 .4966 m .43137 .50486 L .44003 .53022 L p F P
0 0 0 r
s
.735 .211 .094 r
.44003 .53022 m .45173 .52316 L .44471 .4966 L p F P
0 0 0 r
s
.303 .436 .831 r
.55529 .4966 m .56863 .50486 L .55997 .53022 L p F P
0 0 0 r
s
.303 .436 .831 r
.55997 .53022 m .54827 .52316 L .55529 .4966 L p F P
0 0 0 r
s
.672 .192 .086 r
.43137 .50486 m .44471 .4966 L .4392 .47013 L p F P
0 0 0 r
s
.299 .426 .808 r
.56863 .50486 m .55529 .4966 L .5608 .47013 L p F P
0 0 0 r
s
.276 .072 .035 r
.5 .33679 m .48324 .34822 L .48283 .36611 L p F P
0 0 0 r
s
.276 .072 .035 r
.46596 .37747 m .48283 .36611 L .48324 .34822 L p F P
0 0 0 r
s
.24 .327 .596 r
.5 .33679 m .51676 .34822 L .51717 .36611 L p F P
0 0 0 r
s
.24 .327 .596 r
.53404 .37747 m .51717 .36611 L .51676 .34822 L p F P
0 0 0 r
s
.511 .142 .065 r
.43537 .44463 m .45113 .4344 L .44956 .41012 L p F P
0 0 0 r
s
.599 .169 .076 r
.45113 .4344 m .43537 .44463 L .4392 .47013 L p F P
0 0 0 r
s
.281 .394 .737 r
.56463 .44463 m .54887 .4344 L .55044 .41012 L p F P
0 0 0 r
s
.291 .413 .778 r
.54887 .4344 m .56463 .44463 L .5608 .47013 L p F P
0 0 0 r
s
.791 .229 .101 r
.46358 .51602 m .45173 .52316 L .46003 .54897 L p F P
0 0 0 r
s
.791 .229 .101 r
.46003 .54897 m .46987 .54319 L .46358 .51602 L p F P
0 0 0 r
s
.306 .443 .849 r
.53642 .51602 m .54827 .52316 L .53997 .54897 L p F P
0 0 0 r
s
.306 .443 .849 r
.53997 .54897 m .53013 .54319 L .53642 .51602 L p F P
0 0 0 r
s
.83 .24 .1 r
.53124 .56521 m
.55506 .58487 L
s
.59029 .56576 m
.55506 .58487 L
s
.24 .35 .67 r
.44494 .58487 m
.46876 .56521 L
s
.40971 .56576 m
.44494 .58487 L
s
.4 .107 .051 r
.48283 .36611 m .46596 .37747 L .46609 .39918 L p F P
0 0 0 r
s
.83 .24 .1 r
.46475 .37988 m
.46597 .37906 L
s
.48159 .36856 m
.48302 .36759 L
s
.4 .107 .051 r
.44956 .41012 m .46609 .39918 L .46596 .37747 L p F P
0 0 0 r
s
.265 .367 .679 r
.51717 .36611 m .53404 .37747 L .53391 .39918 L p F P
0 0 0 r
s
.24 .35 .67 r
.51698 .36759 m
.51841 .36856 L
s
.53403 .37906 m
.53525 .37988 L
s
.265 .367 .679 r
.55044 .41012 m .53391 .39918 L .53404 .37747 L p F P
0 0 0 r
s
.511 .142 .065 r
.46609 .39918 m .44956 .41012 L .45113 .4344 L p F P
0 0 0 r
s
.281 .394 .737 r
.53391 .39918 m .55044 .41012 L .54887 .4344 L p F P
0 0 0 r
s
.843 .246 .107 r
.48985 .53146 m .47981 .53736 L .48454 .5645 L p F P
0 0 0 r
s
.843 .246 .107 r
.48454 .5645 m .49224 .56009 L .48985 .53146 L p F P
0 0 0 r
s
.307 .447 .861 r
.51015 .53146 m .52019 .53736 L .51546 .5645 L p F P
0 0 0 r
s
.307 .447 .861 r
.51546 .5645 m .50776 .56009 L .51015 .53146 L p F P
0 0 0 r
s
.599 .169 .076 r
.4392 .47013 m .45405 .46071 L .45113 .4344 L p F P
0 0 0 r
s
.672 .192 .086 r
.45405 .46071 m .4392 .47013 L .44471 .4966 L p F P
0 0 0 r
s
.291 .413 .778 r
.5608 .47013 m .54595 .46071 L .54887 .4344 L p F P
0 0 0 r
s
.299 .426 .808 r
.54595 .46071 m .5608 .47013 L .55529 .4966 L p F P
0 0 0 r
s
.735 .211 .094 r
.45824 .48822 m .44471 .4966 L .45173 .52316 L p F P
0 0 0 r
s
.735 .211 .094 r
.45173 .52316 m .46358 .51602 L .45824 .48822 L p F P
0 0 0 r
s
.303 .436 .831 r
.54176 .48822 m .55529 .4966 L .54827 .52316 L p F P
0 0 0 r
s
.303 .436 .831 r
.54827 .52316 m .53642 .51602 L .54176 .48822 L p F P
0 0 0 r
s
.672 .192 .086 r
.44471 .4966 m .45824 .48822 L .45405 .46071 L p F P
0 0 0 r
s
.299 .426 .808 r
.55529 .4966 m .54176 .48822 L .54595 .46071 L p F P
0 0 0 r
s
.791 .229 .101 r
.47557 .50879 m .46358 .51602 L .46987 .54319 L p F P
0 0 0 r
s
.791 .229 .101 r
.46987 .54319 m .47981 .53736 L .47557 .50879 L p F P
0 0 0 r
s
.306 .443 .849 r
.52443 .50879 m .53642 .51602 L .53013 .54319 L p F P
0 0 0 r
s
.306 .443 .849 r
.53013 .54319 m .52019 .53736 L .52443 .50879 L p F P
0 0 0 r
s
.843 .246 .107 r
.5 .5255 m .48985 .53146 L .49224 .56009 L p F P
0 0 0 r
s
.843 .246 .107 r
.49224 .56009 m .5 .55565 L .5 .5255 L p F P
0 0 0 r
s
.24 .35 .67 r
.49144 .54036 m
.49514 .54249 L
s
.49514 .54249 m
.49833 .54433 L
s
.307 .447 .861 r
.5 .5255 m .51015 .53146 L .50776 .56009 L p F P
0 0 0 r
s
.307 .447 .861 r
.50776 .56009 m .5 .55565 L .5 .5255 L p F P
0 0 0 r
s
.83 .24 .1 r
.50486 .54249 m
.50856 .54036 L
s
.50167 .54433 m
.50486 .54249 L
s
.59029 .56576 m
.61393 .5798 L
s
.65035 .56053 m
.61393 .5798 L
s
.24 .35 .67 r
.40971 .56576 m
.38607 .5798 L
s
.34965 .56053 m
.38607 .5798 L
s
.83 .24 .1 r
.82221 .5051 m
.83293 .49412 L
s
.24 .35 .67 r
.17779 .5051 m
.16707 .49412 L
s
.276 .072 .035 r
.48283 .36611 m .5 .35455 L .5 .33679 L p F P
0 0 0 r
s
.83 .24 .1 r
.48302 .36759 m
.48323 .36584 L
s
.24 .327 .596 r
.51717 .36611 m .5 .35455 L .5 .33679 L p F P
0 0 0 r
s
.24 .35 .67 r
.51677 .36584 m
.51698 .36759 L
s
.83 .24 .1 r
.76753 .53035 m
.78281 .52535 L
s
.82221 .5051 m
.78281 .52535 L
s
.24 .35 .67 r
.23247 .53035 m
.21719 .52535 L
s
.17779 .5051 m
.21719 .52535 L
s
.511 .142 .065 r
.45113 .4344 m .46715 .424 L .46609 .39918 L p F P
0 0 0 r
s
.599 .169 .076 r
.46715 .424 m .45113 .4344 L .45405 .46071 L p F P
0 0 0 r
s
.281 .394 .737 r
.54887 .4344 m .53285 .424 L .53391 .39918 L p F P
0 0 0 r
s
.291 .413 .778 r
.53285 .424 m .54887 .4344 L .54595 .46071 L p F P
0 0 0 r
s
.83 .24 .1 r
.65035 .56053 m
.67237 .56835 L
s
.70988 .54883 m
.67237 .56835 L
s
.24 .35 .67 r
.34965 .56053 m
.32763 .56835 L
s
.29012 .54883 m
.32763 .56835 L
s
.83 .24 .1 r
.70988 .54883 m
.72903 .55019 L
s
.76753 .53035 m
.72903 .55019 L
s
.24 .35 .67 r
.29012 .54883 m
.27097 .55019 L
s
.23247 .53035 m
.27097 .55019 L
s
.4 .107 .051 r
.5 .35455 m .48283 .36611 L .4829 .38805 L p F P
0 0 0 r
s
.4 .107 .051 r
.46609 .39918 m .4829 .38805 L .48283 .36611 L p F P
0 0 0 r
s
.265 .367 .679 r
.5 .35455 m .51717 .36611 L .5171 .38805 L p F P
0 0 0 r
s
.83 .24 .1 r
.49873 .35703 m
.50062 .35576 L
s
.24 .35 .67 r
.49938 .35576 m
.50127 .35703 L
s
.265 .367 .679 r
.53391 .39918 m .5171 .38805 L .51717 .36611 L p F P
0 0 0 r
s
.511 .142 .065 r
.4829 .38805 m .46609 .39918 L .46715 .424 L p F P
0 0 0 r
s
.281 .394 .737 r
.5171 .38805 m .53391 .39918 L .53285 .424 L p F P
0 0 0 r
s
.735 .211 .094 r
.47197 .47973 m .45824 .48822 L .46358 .51602 L p F P
0 0 0 r
s
.735 .211 .094 r
.46358 .51602 m .47557 .50879 L .47197 .47973 L p F P
0 0 0 r
s
.303 .436 .831 r
.52803 .47973 m .54176 .48822 L .53642 .51602 L p F P
0 0 0 r
s
.303 .436 .831 r
.53642 .51602 m .52443 .50879 L .52803 .47973 L p F P
0 0 0 r
s
.83 .24 .1 r
.65837 .20938 m
.64436 .21511 L
s
.24 .35 .67 r
.34163 .20938 m
.35564 .21511 L
s
.791 .229 .101 r
.48771 .50147 m .47557 .50879 L .47981 .53736 L p F P
0 0 0 r
s
.791 .229 .101 r
.47981 .53736 m .48985 .53146 L .48771 .50147 L p F P
0 0 0 r
s
.306 .443 .849 r
.51229 .50147 m .52443 .50879 L .52019 .53736 L p F P
0 0 0 r
s
.306 .443 .849 r
.52019 .53736 m .51015 .53146 L .51229 .50147 L p F P
0 0 0 r
s
.83 .24 .1 r
.50856 .54036 m
.53124 .56521 L
s
.56639 .54558 m
.53124 .56521 L
s
.24 .35 .67 r
.46876 .56521 m
.49144 .54036 L
s
.43361 .54558 m
.46876 .56521 L
s
.83 .24 .1 r
.64436 .21511 m
.60785 .24042 L
s
.60785 .24042 m
.59712 .25295 L
s
.24 .35 .67 r
.35564 .21511 m
.39215 .24042 L
s
.39215 .24042 m
.40288 .25295 L
s
.83 .24 .1 r
.5546 .29645 m
.51962 .32037 L
s
.51962 .32037 m
.51727 .34457 L
s
.24 .35 .67 r
.4454 .29645 m
.48038 .32037 L
s
.48038 .32037 m
.48273 .34457 L
s
.599 .169 .076 r
.45405 .46071 m .46913 .45115 L .46715 .424 L p F P
0 0 0 r
s
.672 .192 .086 r
.46913 .45115 m .45405 .46071 L .45824 .48822 L p F P
0 0 0 r
s
.291 .413 .778 r
.54595 .46071 m .53087 .45115 L .53285 .424 L p F P
0 0 0 r
s
.299 .426 .808 r
.53087 .45115 m .54595 .46071 L .54176 .48822 L p F P
0 0 0 r
s
.83 .24 .1 r
.59712 .25295 m
.5614 .27762 L
s
.5614 .27762 m
.5546 .29645 L
s
.24 .35 .67 r
.40288 .25295 m
.4386 .27762 L
s
.4386 .27762 m
.4454 .29645 L
s
.672 .192 .086 r
.45824 .48822 m .47197 .47973 L .46913 .45115 L p F P
0 0 0 r
s
.299 .426 .808 r
.54176 .48822 m .52803 .47973 L .53087 .45115 L p F P
0 0 0 r
s
.791 .229 .101 r
.5 .49406 m .48771 .50147 L .48985 .53146 L p F P
0 0 0 r
s
.791 .229 .101 r
.48985 .53146 m .5 .5255 L .5 .49406 L p F P
0 0 0 r
s
.306 .443 .849 r
.5 .49406 m .51229 .50147 L .51015 .53146 L p F P
0 0 0 r
s
.306 .443 .849 r
.51015 .53146 m .5 .5255 L .5 .49406 L p F P
0 0 0 r
s
.511 .142 .065 r
.46715 .424 m .48344 .41343 L .4829 .38805 L p F P
0 0 0 r
s
.599 .169 .076 r
.48344 .41343 m .46715 .424 L .46913 .45115 L p F P
0 0 0 r
s
.281 .394 .737 r
.53285 .424 m .51656 .41343 L .5171 .38805 L p F P
0 0 0 r
s
.291 .413 .778 r
.51656 .41343 m .53285 .424 L .53087 .45115 L p F P
0 0 0 r
s
.735 .211 .094 r
.48588 .47112 m .47197 .47973 L .47557 .50879 L p F P
0 0 0 r
s
.735 .211 .094 r
.47557 .50879 m .48771 .50147 L .48588 .47112 L p F P
0 0 0 r
s
.303 .436 .831 r
.51412 .47112 m .52803 .47973 L .52443 .50879 L p F P
0 0 0 r
s
.303 .436 .831 r
.52443 .50879 m .51229 .50147 L .51412 .47112 L p F P
0 0 0 r
s
.83 .24 .1 r
.50276 .53213 m
.50856 .54036 L
s
.50856 .54036 m
.54353 .52017 L
s
.24 .35 .67 r
.49144 .54036 m
.49724 .53213 L
s
.45647 .52017 m
.49144 .54036 L
s
.83 .24 .1 r
.56639 .54558 m
.59029 .56576 L
s
.62676 .54599 m
.59029 .56576 L
s
.24 .35 .67 r
.43361 .54558 m
.40971 .56576 L
s
.37324 .54599 m
.40971 .56576 L
s
.4 .107 .051 r
.4829 .38805 m .5 .37673 L .5 .35455 L p F P
0 0 0 r
s
.24 .35 .67 r
.48273 .34457 m
.49879 .35536 L
s
.265 .367 .679 r
.5171 .38805 m .5 .37673 L .5 .35455 L p F P
0 0 0 r
s
.83 .24 .1 r
.50121 .35536 m
.51727 .34457 L
s
.511 .142 .065 r
.5 .37673 m .4829 .38805 L .48344 .41343 L p F P
0 0 0 r
s
.281 .394 .737 r
.5 .37673 m .5171 .38805 L .51656 .41343 L p F P
0 0 0 r
s
.83 .24 .1 r
.50136 .50375 m
.50247 .50309 L
s
.24 .35 .67 r
.49753 .50309 m
.49864 .50375 L
s
.599 .169 .076 r
.46913 .45115 m .48444 .44143 L .48344 .41343 L p F P
0 0 0 r
s
.672 .192 .086 r
.48444 .44143 m .46913 .45115 L .47197 .47973 L p F P
0 0 0 r
s
.291 .413 .778 r
.53087 .45115 m .51556 .44143 L .51656 .41343 L p F P
0 0 0 r
s
.299 .426 .808 r
.51556 .44143 m .53087 .45115 L .52803 .47973 L p F P
0 0 0 r
s
.672 .192 .086 r
.47197 .47973 m .48588 .47112 L .48444 .44143 L p F P
0 0 0 r
s
.299 .426 .808 r
.52803 .47973 m .51412 .47112 L .51556 .44143 L p F P
0 0 0 r
s
.735 .211 .094 r
.5 .46238 m .48588 .47112 L .48771 .50147 L p F P
0 0 0 r
s
.735 .211 .094 r
.48771 .50147 m .5 .49406 L .5 .46238 L p F P
0 0 0 r
s
.24 .35 .67 r
.47703 .49084 m
.49753 .50309 L
s
.303 .436 .831 r
.5 .46238 m .51412 .47112 L .51229 .50147 L p F P
0 0 0 r
s
.303 .436 .831 r
.51229 .50147 m .5 .49406 L .5 .46238 L p F P
0 0 0 r
s
.83 .24 .1 r
.50247 .50309 m
.52297 .49084 L
s
.62676 .54599 m
.65035 .56053 L
s
.68805 .54057 m
.65035 .56053 L
s
.24 .35 .67 r
.37324 .54599 m
.34965 .56053 L
s
.31195 .54057 m
.34965 .56053 L
s
.511 .142 .065 r
.48344 .41343 m .5 .40268 L .5 .37673 L p F P
0 0 0 r
s
.24 .35 .67 r
.47984 .37305 m
.49909 .3857 L
s
.599 .169 .076 r
.5 .40268 m .48344 .41343 L .48444 .44143 L p F P
0 0 0 r
s
.281 .394 .737 r
.51656 .41343 m .5 .40268 L .5 .37673 L p F P
0 0 0 r
s
.83 .24 .1 r
.50091 .3857 m
.52016 .37305 L
s
.291 .413 .778 r
.5 .40268 m .51656 .41343 L .51556 .44143 L p F P
0 0 0 r
s
.83 .24 .1 r
.8074 .50981 m
.82221 .5051 L
s
.24 .35 .67 r
.1926 .50981 m
.17779 .5051 L
s
.83 .24 .1 r
.68805 .54057 m
.70988 .54883 L
s
.74871 .52862 m
.70988 .54883 L
s
.24 .35 .67 r
.31195 .54057 m
.29012 .54883 L
s
.25129 .52862 m
.29012 .54883 L
s
.83 .24 .1 r
.74871 .52862 m
.76753 .53035 L
s
.8074 .50981 m
.76753 .53035 L
s
.24 .35 .67 r
.25129 .52862 m
.23247 .53035 L
s
.1926 .50981 m
.23247 .53035 L
s
.83 .24 .1 r
.55273 .32072 m
.51727 .34457 L
s
.51727 .34457 m
.52016 .37305 L
s
.24 .35 .67 r
.44727 .32072 m
.48273 .34457 L
s
.48273 .34457 m
.47984 .37305 L
s
.672 .192 .086 r
.5 .43156 m .48444 .44143 L .48588 .47112 L p F P
0 0 0 r
s
.672 .192 .086 r
.48588 .47112 m .5 .46238 L .5 .43156 L p F P
0 0 0 r
s
.24 .35 .67 r
.49413 .45917 m
.49839 .46181 L
s
.49839 .46181 m
.49856 .46192 L
s
.299 .426 .808 r
.5 .43156 m .51556 .44143 L .51412 .47112 L p F P
0 0 0 r
s
.299 .426 .808 r
.51412 .47112 m .5 .46238 L .5 .43156 L p F P
0 0 0 r
s
.83 .24 .1 r
.50161 .46181 m
.50587 .45917 L
s
.50144 .46192 m
.50161 .46181 L
s
.599 .169 .076 r
.48444 .44143 m .5 .43156 L .5 .40268 L p F P
0 0 0 r
s
.291 .413 .778 r
.51556 .44143 m .5 .43156 L .5 .40268 L p F P
0 0 0 r
s
.83 .24 .1 r
.54353 .52017 m
.56639 .54558 L
s
.6028 .52526 m
.56639 .54558 L
s
.24 .35 .67 r
.45647 .52017 m
.43361 .54558 L
s
.3972 .52526 m
.43361 .54558 L
s
.83 .24 .1 r
.64436 .21511 m
.63412 .2274 L
s
.24 .35 .67 r
.35564 .21511 m
.36588 .2274 L
s
.83 .24 .1 r
.59081 .27169 m
.5546 .29645 L
s
.5546 .29645 m
.55273 .32072 L
s
.24 .35 .67 r
.40919 .27169 m
.4454 .29645 L
s
.4454 .29645 m
.44727 .32072 L
s
.83 .24 .1 r
.63412 .2274 m
.59712 .25295 L
s
.59712 .25295 m
.59081 .27169 L
s
.24 .35 .67 r
.36588 .2274 m
.40288 .25295 L
s
.40288 .25295 m
.40919 .27169 L
s
.83 .24 .1 r
.50298 .42065 m
.52832 .40446 L
s
.50097 .42194 m
.50298 .42065 L
s
.50406 .45457 m
.50587 .45917 L
s
.50169 .44858 m
.50406 .45457 L
s
.24 .35 .67 r
.47168 .40446 m
.49702 .42065 L
s
.49702 .42065 m
.49903 .42194 L
s
.49413 .45917 m
.49594 .45457 L
s
.49594 .45457 m
.49831 .44858 L
s
.83 .24 .1 r
.52297 .49084 m
.54353 .52017 L
s
.57975 .49927 m
.54353 .52017 L
s
.24 .35 .67 r
.47703 .49084 m
.45647 .52017 L
s
.42025 .49927 m
.45647 .52017 L
s
.83 .24 .1 r
.54145 .43716 m
.50587 .45917 L
s
.50587 .45917 m
.52297 .49084 L
s
.24 .35 .67 r
.45855 .43716 m
.49413 .45917 L
s
.49413 .45917 m
.47703 .49084 L
s
.83 .24 .1 r
.6028 .52526 m
.62676 .54599 L
s
.66453 .52551 m
.62676 .54599 L
s
.24 .35 .67 r
.3972 .52526 m
.37324 .54599 L
s
.33547 .52551 m
.37324 .54599 L
s
.83 .24 .1 r
.55891 .46936 m
.52297 .49084 L
s
.24 .35 .67 r
.44109 .46936 m
.47703 .49084 L
s
.83 .24 .1 r
.55611 .34942 m
.52016 .37305 L
s
.52016 .37305 m
.52832 .40446 L
s
.24 .35 .67 r
.44389 .34942 m
.47984 .37305 L
s
.47984 .37305 m
.47168 .40446 L
s
.83 .24 .1 r
.66453 .52551 m
.68805 .54057 L
s
.7271 .51989 m
.68805 .54057 L
s
.24 .35 .67 r
.33547 .52551 m
.31195 .54057 L
s
.2729 .51989 m
.31195 .54057 L
s
.83 .24 .1 r
.7271 .51989 m
.74871 .52862 L
s
.78895 .50768 m
.74871 .52862 L
s
.24 .35 .67 r
.2729 .51989 m
.25129 .52862 L
s
.21105 .50768 m
.25129 .52862 L
s
.83 .24 .1 r
.78895 .50768 m
.8074 .50981 L
s
.24 .35 .67 r
.21105 .50768 m
.1926 .50981 L
s
.83 .24 .1 r
.58947 .29602 m
.55273 .32072 L
s
.55273 .32072 m
.55611 .34942 L
s
.24 .35 .67 r
.41053 .29602 m
.44727 .32072 L
s
.44727 .32072 m
.44389 .34942 L
s
.83 .24 .1 r
.57975 .49927 m
.6028 .52526 L
s
.64051 .5042 m
.6028 .52526 L
s
.24 .35 .67 r
.42025 .49927 m
.3972 .52526 L
s
.35949 .5042 m
.3972 .52526 L
s
.83 .24 .1 r
.62834 .24603 m
.59081 .27169 L
s
.59081 .27169 m
.58947 .29602 L
s
.24 .35 .67 r
.37166 .24603 m
.40919 .27169 L
s
.40919 .27169 m
.41053 .29602 L
s
.83 .24 .1 r
.63412 .2274 m
.62834 .24603 L
s
.24 .35 .67 r
.36588 .2274 m
.37166 .24603 L
s
.83 .24 .1 r
.56475 .38118 m
.52832 .40446 L
s
.52832 .40446 m
.54145 .43716 L
s
.24 .35 .67 r
.43525 .38118 m
.47168 .40446 L
s
.47168 .40446 m
.45855 .43716 L
s
.83 .24 .1 r
.55891 .46936 m
.57975 .49927 L
s
.61729 .4776 m
.57975 .49927 L
s
.24 .35 .67 r
.44109 .46936 m
.42025 .49927 L
s
.38271 .4776 m
.42025 .49927 L
s
.83 .24 .1 r
.57833 .41434 m
.54145 .43716 L
s
.54145 .43716 m
.55891 .46936 L
s
.24 .35 .67 r
.42167 .41434 m
.45855 .43716 L
s
.45855 .43716 m
.44109 .46936 L
s
.83 .24 .1 r
.64051 .5042 m
.66453 .52551 L
s
.70367 .50429 m
.66453 .52551 L
s
.24 .35 .67 r
.35949 .5042 m
.33547 .52551 L
s
.29633 .50429 m
.33547 .52551 L
s
.83 .24 .1 r
.59616 .44709 m
.55891 .46936 L
s
.24 .35 .67 r
.40384 .44709 m
.44109 .46936 L
s
.83 .24 .1 r
.59337 .32493 m
.55611 .34942 L
s
.55611 .34942 m
.56475 .38118 L
s
.24 .35 .67 r
.40663 .32493 m
.44389 .34942 L
s
.44389 .34942 m
.43525 .38118 L
s
.83 .24 .1 r
.70367 .50429 m
.7271 .51989 L
s
.76758 .49846 m
.7271 .51989 L
s
.24 .35 .67 r
.29633 .50429 m
.2729 .51989 L
s
.23242 .49846 m
.2729 .51989 L
s
.83 .24 .1 r
.76758 .49846 m
.78895 .50768 L
s
.24 .35 .67 r
.23242 .49846 m
.21105 .50768 L
s
.83 .24 .1 r
.62755 .27041 m
.58947 .29602 L
s
.58947 .29602 m
.59337 .32493 L
s
.24 .35 .67 r
.37245 .27041 m
.41053 .29602 L
s
.41053 .29602 m
.40663 .32493 L
s
.83 .24 .1 r
.61729 .4776 m
.64051 .5042 L
s
.67962 .48236 m
.64051 .5042 L
s
.24 .35 .67 r
.38271 .4776 m
.35949 .5042 L
s
.32038 .48236 m
.35949 .5042 L
s
.83 .24 .1 r
.62834 .24603 m
.62755 .27041 L
s
.24 .35 .67 r
.37166 .24603 m
.37245 .27041 L
s
.83 .24 .1 r
.60253 .35704 m
.56475 .38118 L
s
.56475 .38118 m
.57833 .41434 L
s
.24 .35 .67 r
.39747 .35704 m
.43525 .38118 L
s
.43525 .38118 m
.42167 .41434 L
s
.83 .24 .1 r
.59616 .44709 m
.61729 .4776 L
s
.65622 .45513 m
.61729 .4776 L
s
.24 .35 .67 r
.40384 .44709 m
.38271 .4776 L
s
.34378 .45513 m
.38271 .4776 L
s
.83 .24 .1 r
.61657 .39068 m
.57833 .41434 L
s
.57833 .41434 m
.59616 .44709 L
s
.24 .35 .67 r
.38343 .39068 m
.42167 .41434 L
s
.42167 .41434 m
.40384 .44709 L
s
.83 .24 .1 r
.67962 .48236 m
.70367 .50429 L
s
.74427 .48227 m
.70367 .50429 L
s
.24 .35 .67 r
.32038 .48236 m
.29633 .50429 L
s
.25573 .48227 m
.29633 .50429 L
s
.83 .24 .1 r
.6348 .424 m
.59616 .44709 L
s
.24 .35 .67 r
.3652 .424 m
.40384 .44709 L
s
.83 .24 .1 r
.63203 .29952 m
.59337 .32493 L
s
.59337 .32493 m
.60253 .35704 L
s
.24 .35 .67 r
.36797 .29952 m
.40663 .32493 L
s
.40663 .32493 m
.39747 .35704 L
s
.83 .24 .1 r
.74427 .48227 m
.76758 .49846 L
s
.24 .35 .67 r
.25573 .48227 m
.23242 .49846 L
s
.83 .24 .1 r
.62755 .27041 m
.63203 .29952 L
s
.24 .35 .67 r
.37245 .27041 m
.36797 .29952 L
s
.83 .24 .1 r
.65622 .45513 m
.67962 .48236 L
s
.72019 .45971 m
.67962 .48236 L
s
.24 .35 .67 r
.34378 .45513 m
.32038 .48236 L
s
.27981 .45971 m
.32038 .48236 L
s
.83 .24 .1 r
.64172 .33199 m
.60253 .35704 L
s
.60253 .35704 m
.61657 .39068 L
s
.24 .35 .67 r
.35828 .33199 m
.39747 .35704 L
s
.39747 .35704 m
.38343 .39068 L
s
.83 .24 .1 r
.6348 .424 m
.65622 .45513 L
s
.69662 .43181 m
.65622 .45513 L
s
.24 .35 .67 r
.3652 .424 m
.34378 .45513 L
s
.30338 .43181 m
.34378 .45513 L
s
.83 .24 .1 r
.65626 .36612 m
.61657 .39068 L
s
.61657 .39068 m
.6348 .424 L
s
.24 .35 .67 r
.34374 .36612 m
.38343 .39068 L
s
.38343 .39068 m
.3652 .424 L
s
.83 .24 .1 r
.72019 .45971 m
.74427 .48227 L
s
.24 .35 .67 r
.27981 .45971 m
.25573 .48227 L
s
.83 .24 .1 r
.6749 .40003 m
.6348 .424 L
s
.24 .35 .67 r
.3251 .40003 m
.3652 .424 L
s
.83 .24 .1 r
.63203 .29952 m
.64172 .33199 L
s
.24 .35 .67 r
.36797 .29952 m
.35828 .33199 L
s
.83 .24 .1 r
.69662 .43181 m
.72019 .45971 L
s
.24 .35 .67 r
.30338 .43181 m
.27981 .45971 L
s
.83 .24 .1 r
.64172 .33199 m
.65626 .36612 L
s
.24 .35 .67 r
.35828 .33199 m
.34374 .36612 L
s
.83 .24 .1 r
.6749 .40003 m
.69662 .43181 L
s
.24 .35 .67 r
.3251 .40003 m
.30338 .43181 L
s
.83 .24 .1 r
.65626 .36612 m
.6749 .40003 L
s
.24 .35 .67 r
.34374 .36612 m
.3251 .40003 L
s
0 0 0 r
.25 Mabswid
.5 .02321 m
.5 .30205 L
s
.5 .30205 m
.02189 .6366 L
s
.02189 .6366 m
.07653 .37901 L
s
.07653 .37901 m
.5 .02321 L
s
.5 .02321 m
.5 .30205 L
s
.5 .30205 m
.97811 .6366 L
s
.97811 .6366 m
.92347 .37901 L
s
.92347 .37901 m
.5 .02321 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{500, 500},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40007d0001m2000`400?l00000o`00003oo`3ooooe
0?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3o
m^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40
oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?of
k_@0ooK^0@3oool00?T0ooK^00<000000?ofkP3om^h0m`3om^h10?ooo`00n03om^h300000?P0ooK^
0@3oool00?L0ooK^00D000000?ofkP000000ooK^0000003g0?ofkP40oooo003e0?ofkP8000000P3o
m^h00`000000ooK^0?ofkP0200000?D0ooK^0@3oool00?@0ooK^00<000000?ofkP3om^h00P3om^h0
0`000000ooK^0?ofkP020?ofkP030000003om^h0ooK^0?80ooK^0@3oool00?<0ooK^00<000000?of
kP3om^h00`3om^h00`000000ooK^0?ofkP030?ofkP030000003om^h0ooK^0?40ooK^0@3oool00?80
ooK^00<000000?ofkP3om^h0103om^h00`000000ooK^0?ofkP040?ofkP030000003om^h0ooK^0?00
ooK^0@3oool00?40ooK^00<000000?ofkP3om^h01@3om^h00`000000ooK^0?ofkP050?ofkP030000
003om^h0ooK^0>l0ooK^0@3oool00>l0ooK^0P0000080?ofkP030000003om^h0ooK^00H0ooK^0P00
003_0?ofkP40oooo003^0?ofkP030000003om^h0ooK^00P0ooK^00<000000?ofkP3om^h0203om^h0
0`000000ooK^0?ofkP3/0?ofkP40oooo003]0?ofkP030000003om^h0ooK^00T0ooK^00<000000?of
kP3om^h02@3om^h00`000000ooK^0?ofkP3[0?ofkP40oooo003/0?ofkP030000003om^h0ooK^00X0
ooK^00<000000?ofkP3om^h02P3om^h00`000000ooK^0?ofkP3Z0?ofkP40oooo003[0?ofkP030000
003om^h0ooK^00/0ooK^00<000000?ofkP3om^h02`3om^h00`000000ooK^0?ofkP3Y0?ofkP40oooo
003Y0?ofkP8000003P3om^h00`000000ooK^0?ofkP0<0?ofkP800000j@3om^h10?ooo`00j03om^h0
0`000000ooK^0?ofkP0>0?ofkP030000003om^h0ooK^00h0ooK^00<000000?ofkP3om^h0iP3om^h1
0?ooo`00i`3om^h00`000000ooK^0?ofkP0?0?ofkP030000003om^h0ooK^00l0ooK^00<000000?of
kP3om^h0i@3om^h10?ooo`00iP3om^h00`000000ooK^0?ofkP0@0?ofkP030000003om^h0ooK^0100
ooK^00<000000?ofkP3om^h0i03om^h10?ooo`00i@3om^h00`000000ooK^0?ofkP0A0?ofkP030000
003om^h0ooK^0140ooK^00<000000?ofkP3om^h0h`3om^h10?ooo`00i03om^h00`000000ooK^0?of
kP0B0?ofkP030000003om^h0ooK^0180ooK^00<000000?ofkP3om^h0hP3om^h10?ooo`00hP3om^h2
000001D0ooK^00<000000?ofkP3om^h04`3om^h200000>80ooK^0@3oool00>40ooK^00<000000?of
kP3om^h05@3om^h00`000000ooK^0?ofkP0E0?ofkP030000003om^h0ooK^0=l0ooK^0@3oool00>00
ooK^00<000000?ofkP3om^h05P3om^h00`000000ooK^0?ofkP0F0?ofkP030000003om^h0ooK^0=h0
ooK^0@3oool00=l0ooK^00<000000?ofkP3om^h05`3om^h00`000000ooK^0?ofkP0G0?ofkP030000
003om^h0ooK^0=d0ooK^0@3oool00=h0ooK^00<000000?ofkP3om^h0603om^h00`000000ooK^0?of
kP0H0?ofkP030000003om^h0ooK^0=`0ooK^0@3oool00=`0ooK^0P00000K0?ofkP030000003om^h0
ooK^01T0ooK^0P00003L0?ofkP40oooo003K0?ofkP030000003om^h0ooK^01/0ooK^00<000000?of
kP3om^h06`3om^h00`000000ooK^0?ofkP3I0?ofkP40oooo003J0?ofkP030000003om^h0ooK^01`0
ooK^00<000000?ofkP3om^h0703om^h00`000000ooK^0?ofkP3H0?ofkP40oooo003I0?ofkP030000
003om^h0ooK^01d0ooK^00<000000?ofkP3om^h07@3om^h00`000000ooK^0?ofkP3G0?ofkP40oooo
003H0?ofkP030000003om^h0ooK^01h0ooK^00<000000?ofkP3om^h07P3om^h00`000000ooK^0?of
kP3F0?ofkP40oooo003G0?ofkP030000003om^h0ooK^01l0ooK^00<000000?ofkP3om^h07`3om^h0
0`000000ooK^0?ofkP3E0?ofkP40oooo003E0?ofkP8000008P3om^h00`000000ooK^0?ofkP0P0?of
kP800000e@3om^h10?ooo`00e03om^h00`000000ooK^0?ofkP0R0?ofkP030000003om^h0ooK^0280
ooK^00<000000?ofkP3om^h0dP3om^h10?ooo`00d`3om^h00`000000ooK^0?ofkP0S0?ofkP030000
003om^h0ooK^02<0ooK^00<000000?ofkP3om^h0d@3om^h10?ooo`00dP3om^h00`000000ooK^0?of
kP0T0?ofkP030000003om^h0ooK^02@0ooK^00<000000?ofkP3om^h0d03om^h10?ooo`00d@3om^h0
0`000000ooK^0?ofkP0U0?ofkP030000003om^h0ooK^02D0ooK^00<000000?ofkP3om^h0c`3om^h1
0?ooo`00c`3om^h2000002P0ooK^00<000000?ofkP3om^h09P3om^h200000<l0ooK^0@3oool00<h0
ooK^00<000000?ofkP3om^h0:03om^h00`000000ooK^0?ofkP0X0?ofkP030000003om^h0ooK^0<`0
ooK^0@3oool00<d0ooK^00<000000?ofkP3om^h0:@3om^h00`000000ooK^0?ofkP0Y0?ofkP030000
003om^h0ooK^0</0ooK^0@3oool00<`0ooK^00<000000?ofkP3om^h0:P3om^h00`000000ooK^0?of
kP0Z0?ofkP030000003om^h0ooK^0<X0ooK^0@3oool00</0ooK^00<000000?ofkP3om^h0:`3om^h0
0`000000ooK^0?ofkP0[0?ofkP030000003om^h0ooK^0<T0ooK^0@3oool00<T0ooK^0P00000^0?of
kP030000003om^h0ooK^02`0ooK^0P0000390?ofkP40oooo00380?ofkP030000003om^h0ooK^02h0
ooK^00<000000?ofkP3om^h0;P3om^h00`000000ooK^0?ofkP360?ofkP40oooo00370?ofkP030000
003om^h0ooK^02l0ooK^00<000000?ofkP3om^h0;`3om^h00`000000ooK^0?ofkP350?ofkP40oooo
00360?ofkP030000003om^h0ooK^0300ooK^00<000000?ofkP3om^h0<03om^h00`000000ooK^0?of
kP340?ofkP40oooo00350?ofkP030000003om^h0ooK^0340ooK^00<000000?ofkP3om^h0<@3om^h0
0`000000ooK^0?ofkP330?ofkP40oooo00340?ofkP030000003om^h0ooK^0380ooK^00<000000?of
kP3om^h0<P3om^h00`000000ooK^0?ofkP320?ofkP40oooo00320?ofkP800000=@3om^h00`000000
ooK^0?ofkP0c0?ofkP800000`P3om^h10?ooo`00`@3om^h00`000000ooK^0?ofkP0e0?ofkP030000
003om^h0ooK^03D0ooK^00<000000?ofkP3om^h0_`3om^h10?ooo`00`03om^h00`000000ooK^0?of
kP0f0?ofkP030000003om^h0ooK^03H0ooK^00<000000?ofkP3om^h0_P3om^h10?ooo`00_`3om^h0
0`000000ooK^0?ofkP0g0?ofkP030000003om^h0ooK^03L0ooK^00<000000?ofkP3om^h0_@3om^h1
0?ooo`00_P3om^h00`000000ooK^0?ofkP0h0?ofkP030000003om^h0ooK^03P0ooK^00<000000?of
kP3om^h0_03om^h10?ooo`00_03om^h2000003/0ooK^00<000000?ofkP3om^h0>@3om^h200000;`0
ooK^0@3oool00;/0ooK^00<000000?ofkP3om^h0>`3om^h00`000000ooK^0?ofkP0k0?ofkP030000
003om^h0ooK^0;T0ooK^0@3oool00;X0ooK^00<000000?ofkP3om^h0?03om^h00`000000ooK^0?of
kP0l0?ofkP030000003om^h0ooK^0;P0ooK^0@3oool00;T0ooK^00<000000?ofkP3om^h0?@3om^h0
0`000000ooK^0?ofkP0m0?ofkP030000003om^h0ooK^0;L0ooK^0@3oool00;P0ooK^00<000000?of
kP3om^h0?P3om^h00`000000ooK^0?ofkP0n0?ofkP030000003om^h0ooK^0;H0ooK^0@3oool00;L0
ooK^00<000000?ofkP3om^h0?`3om^h00`000000ooK^0?ofkP0o0?ofkP030000003om^h0ooK^0;D0
ooK^0@3oool00;D0ooK^0P0000120?ofkP030000003om^h0ooK^0400ooK^0P00002e0?ofkP40oooo
002d0?ofkP030000003om^h0ooK^0480ooK^00<000000?ofkP3om^h0@P3om^h00`000000ooK^0?of
kP2b0?ofkP40oooo002c0?ofkP030000003om^h0ooK^04<0ooK^00<000000?ofkP3om^h0@`3om^h0
0`000000ooK^0?ofkP2a0?ofkP40oooo002b0?ofkP030000003om^h0ooK^04@0ooK^00<000000?of
kP3om^h0A03om^h00`000000ooK^0?ofkP2`0?ofkP40oooo002a0?ofkP030000003om^h0ooK^04D0
ooK^00<000000?ofkP3om^h0A@3om^h00`000000ooK^0?ofkP2_0?ofkP40oooo002_0?ofkP800000
B03om^h00`000000ooK^0?ofkP160?ofkP800000[`3om^h10?ooo`00[P3om^h00`000000ooK^0?of
kP180?ofkP030000003om^h0ooK^04P0ooK^00<000000?ofkP3om^h0[03om^h10?ooo`00[@3om^h0
0`000000ooK^0?ofkP190?ofkP030000003om^h0ooK^04T0ooK^00<000000?ofkP3om^h0Z`3om^h1
0?ooo`00[03om^h00`000000ooK^0?ofkP1:0?ofkP030000003om^h0ooK^04X0ooK^00<000000?of
kP3om^h0ZP3om^h10?ooo`00Z`3om^h00`000000ooK^0?ofkP1;0?ofkP030000003om^h0ooK^04/0
ooK^00<000000?ofkP3om^h0Z@3om^h10?ooo`00Z@3om^h2000004h0ooK^00<000000?ofkP3om^h0
C03om^h200000:T0ooK^0@3oool00:P0ooK^00<000000?ofkP3om^h0CP3om^h00`000000ooK^0?of
kP1>0?ofkP030000003om^h0ooK^0:H0ooK^0@3oool00:L0ooK^00<000000?ofkP3om^h0C`3om^h0
0`000000ooK^0?ofkP1?0?ofkP030000003om^h0ooK^0:D0ooK^0@3oool00:H0ooK^00<000000?of
kP3om^h0D03om^h00`000000ooK^0?ofkP1@0?ofkP030000003om^h0ooK^0:@0ooK^0@3oool00:D0
ooK^00<000000?ofkP3om^h0D@3om^h00`000000ooK^0?ofkP1A0?ofkP030000003om^h0ooK^0:<0
ooK^0@3oool00:@0ooK^00<000000?ofkP3om^h0DP3om^h00`000000ooK^0?ofkP1B0?ofkP030000
003om^h0ooK^0:80ooK^0@3oool00:80ooK^0P00001E0?ofkP030000003om^h0ooK^05<0ooK^0P00
002R0?ofkP40oooo002Q0?ofkP030000003om^h0ooK^05D0ooK^00<000000?ofkP3om^h0E@3om^h0
0`000000ooK^0?ofkP2O0?ofkP40oooo002P0?ofkP030000003om^h0ooK^05H0ooK^00<000000?of
kP3om^h0EP3om^h00`000000ooK^0?ofkP2N0?ofkP40oooo002O0?ofkP030000003om^h0ooK^05L0
ooK^00<000000?ofkP3om^h0E`3om^h00`000000ooK^0?ofkP2M0?ofkP40oooo002N0?ofkP030000
003om^h0ooK^05P0ooK^00<000000?ofkP3om^h0F03om^h00`000000ooK^0?ofkP2L0?ofkP40oooo
002L0?ofkP800000F`3om^h00`000000ooK^0?ofkP1I0?ofkP800000W03om^h10?ooo`00V`3om^h0
0`000000ooK^0?ofkP1K0?ofkP030000003om^h0ooK^05/0ooK^00<000000?ofkP3om^h0V@3om^h1
0?ooo`00VP3om^h00`000000ooK^0?ofkP1L0?ofkP030000003om^h0ooK^05`0ooK^00<000000?of
kP3om^h0V03om^h10?ooo`00V@3om^h00`000000ooK^0?ofkP1M0?ofkP030000003om^h0ooK^05d0
ooK^00<000000?ofkP3om^h0U`3om^h10?ooo`00V03om^h00`000000ooK^0?ofkP1N0?ofkP030000
003om^h0ooK^05h0ooK^00<000000?ofkP3om^h0UP3om^h10?ooo`00U`3om^h00`000000ooK^0?of
kP1O0?ofkP030000003om^h0ooK^05l0ooK^00<000000?ofkP3om^h0U@3om^h10?ooo`00U@3om^h2
00000680ooK^00<000000?ofkP3om^h0H03om^h2000009D0ooK^0@3oool009@0ooK^00<000000?of
kP3om^h0HP3om^h00`000000ooK^0?ofkP1R0?ofkP030000003om^h0ooK^0980ooK^0@3oool009<0
ooK^00<000000?ofkP3om^h0H`3om^h00`000000ooK^0?ofkP1S0?ofkP030000003om^h0ooK^0940
ooK^0@3oool00980ooK^00<000000?ofkP3om^h0I03om^h00`000000ooK^0?ofkP1T0?ofkP030000
003om^h0ooK^0900ooK^0@3oool00940ooK^00<000000?ofkP3om^h0I@3om^h00`000000ooK^0?of
kP1U0?ofkP030000003om^h0ooK^08l0ooK^0@3oool008l0ooK^0P00001X0?ofkP030000003om^h0
ooK^06H0ooK^0P00002?0?ofkP40oooo002>0?ofkP030000003om^h0ooK^06P0ooK^00<000000?of
kP3om^h0J03om^h00`000000ooK^0?ofkP2<0?ofkP40oooo002=0?ofkP030000003om^h0ooK^06T0
ooK^00<000000?ofkP3om^h0J@3om^h00`000000ooK^0?ofkP2;0?ofkP40oooo002<0?ofkP030000
003om^h0ooK^06X0ooK^00<000000?ofkP3om^h0JP3om^h00`000000ooK^0?ofkP2:0?ofkP40oooo
002;0?ofkP030000003om^h0ooK^01<0ooK^2`0mFJ]=0?ofkP030000003om^h0ooK^04/0ooK^2`3D
?ATE0?ofkP030000003om^h0ooK^08T0ooK^0@3oool008T0ooK^0P00000D0?ofkP80?EV[0P3om^h0
0`0mFJ/0ooK^0?ofkP050?ofkP<0?EV[B`3om^h00`000000ooK^0?ofkP190?ofkP<0e3dI1`3om^h0
0`3D?AT0ooK^0?ofkP020=@m6A@0ooK^0P0000290?ofkP40oooo00280?ofkP030000003om^h0ooK^
0140ooK^0`0mFJ/50?ofkP80?EV[1`3om^h303eIZdT0ooK^00<000000?ofkP3om^h0A`3om^h30=@m
6@L0ooK^0P3D?AT50?ofkP<0e3dI4`3om^h00`000000ooK^0?ofkP260?ofkP40oooo00270?ofkP03
0000003om^h0ooK^0100ooK^0P0mFJ/:0?ofkP0303eIZ`3om^h0ooK^00D0ooK^100mFJ]70?ofkP03
0000003om^h0ooK^04D0ooK^103D?AT70?ofkP030=@m6@3om^h0ooK^00P0ooK^0P3D?ATB0?ofkP03
0000003om^h0ooK^08D0ooK^0@3oool008H0ooK^00<000000?ofkP3om^h03`3om^h203eIZ`d0ooK^
00<0?EV[0?ofkP3om^h01P3om^h0100mFJ/0ooK^03eIZ`0mFJ]50?ofkP030000003om^h0ooK^04<0
ooK^0P3D?AT00`3om^h0e3dI0?ofkP070?ofkP030=@m6@3om^h0ooK^00/0ooK^0P3D?ATA0?ofkP03
0000003om^h0ooK^08@0ooK^0@3oool008D0ooK^00<000000?ofkP3om^h03P3om^h203eIZ`030?of
kP0mFJ/0?EV[00d0ooK^0P0mFJ/70?ofkP@0?EV[A03om^h00`000000ooK^0?ofkP120?ofkP@0e3dI
1`3om^h20=@m6@d0ooK^0P3D?AT00`3om^h0e3dI0=@m6@0@0?ofkP030000003om^h0ooK^08<0ooK^
0@3oool008@0ooK^00<000000?ofkP3om^h03@3om^h203eIZ`D0ooK^00<0?EV[0?ofkP3om^h0303o
m^h00`0mFJ/0ooK^0?ofkP060?ofkP0403eIZ`3om^h0?EV[03eIZd80ooK^00<000000?ofkP3om^h0
@03om^h40=@m6@P0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP030?ofkP80e3dI
3`3om^h00`000000ooK^0?ofkP220?ofkP40oooo00220?ofkP8000003`3om^h00`0mFJ/0ooK^0?of
kP060?ofkP80?EV[3@3om^h00`0mFJ/0ooK^0?ofkP060?ofkP80?EV[00<0ooK^03eIZ`3om^h0@03o
m^h00`000000ooK^0?ofkP0o0?ofkP040=@m6@3om^h0e3dI0=@m6@P0ooK^00<0e3dI0?ofkP3om^h0
2`3om^h20=@m6@P0ooK^00<0e3dI0?ofkP3om^h03@3om^h200000880ooK^0@3oool00840ooK^00<0
00000?ofkP3om^h03@3om^h203eIZ`/0ooK^00<0?EV[0?ofkP3om^h02`3om^h203eIZ`L0ooK^0P0m
FJ/00`3om^h0?EV[03eIZ`0o0?ofkP030000003om^h0ooK^03d0ooK^0P3D?AT00`3om^h0e3dI0=@m
6@070?ofkP80e3dI3@3om^h00`3D?AT0ooK^0?ofkP090?ofkP80e3dI3`3om^h00`000000ooK^0?of
kP1o0?ofkP40oooo00200?ofkP030000003om^h0ooK^00`0ooK^0P0mFJ/>0?ofkP80?EV[3@3om^h0
0`0mFJ/0ooK^0?ofkP050?ofkP<0?EV[00<0ooK^03eIZ`3om^h0?@3om^h00`000000ooK^0?ofkP0l
0?ofkP030=@m6@3om^h0e3dI0080e3dI1`3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP80e3dI3P3om^h2
0=@m6@h0ooK^00<000000?ofkP3om^h0OP3om^h10?ooo`00O`3om^h00`000000ooK^0?ofkP0<0?of
kP0303eIZ`3om^h0ooK^0100ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP040?of
kP@0?EV[00<0ooK^03eIZ`0mFJ/0?03om^h00`000000ooK^0?ofkP0j0?ofkP80e3dI00<0ooK^0=@m
6@3D?AT00P3D?AT60?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h0403om^h00`3D
?AT0ooK^0?ofkP0<0?ofkP030000003om^h0ooK^07d0ooK^0@3oool007h0ooK^00<000000?ofkP3o
m^h0303om^h0100mFJ/0ooK^03eIZ`0mFJ/A0?ofkP80?EV[303om^h203eIZ`D0ooK^00<0?EV[0?of
kP0mFJ/00P0mFJ/00`3om^h0?EV[0?ofkP0j0?ofkP030000003om^h0ooK^03T0ooK^00<0e3dI0?of
kP3D?AT00P3D?AT00`3om^h0e3dI0?ofkP040?ofkP80e3dI303om^h20=@m6A40ooK^0P3D?AT00`3o
m^h0e3dI0?ofkP0=0?ofkP030000003om^h0ooK^07`0ooK^0@3oool007`0ooK^0P00000=0?ofkP80
?EV[103om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3o
m^h00P3om^h903eIZcT0ooK^00<000000?ofkP3om^h0=`3om^h90=@m6@@0ooK^00<0e3dI0?ofkP3o
m^h02`3om^h00`3D?AT0ooK^0?ofkP0@0?ofkP030=@m6@3om^h0ooK^0080ooK^0P3D?AT=0?ofkP80
0000O03om^h10?ooo`00N`3om^h00`000000ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00D0ooK^
00<0?EV[0?ofkP3om^h0403om^h203eIZ`/0ooK^1P0mFJ/40?ofkPD0?EV[>03om^h00`000000ooK^
0?ofkP0f0?ofkPD0e3dI103om^h60=@m6@/0ooK^0P3D?ATB0?ofkP030=@m6@3om^h0ooK^00D0ooK^
00<0e3dI0?ofkP3om^h0303om^h00`000000ooK^0?ofkP1i0?ofkP40oooo001j0?ofkP030000003o
m^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h01`3om^h203eIZa80ooK^00<0?EV[0?ofkP3om^h01@3o
m^h303eIZ`80ooK^0P0mFJ/20?ofkP0303eIZ`3om^h0ooK^0080ooK^1P0mFJ/f0?ofkP030000003o
m^h0ooK^03@0ooK^1P3D?AT40?ofkP030=@m6@3om^h0ooK^0080e3dI0P3om^h30=@m6@L0ooK^00<0
e3dI0?ofkP3om^h0403om^h20=@m6@T0ooK^00<0e3dI0?ofkP3om^h0303om^h00`000000ooK^0?of
kP1h0?ofkP40oooo001i0?ofkP030000003om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h02P3om^h0
0`0mFJ/0ooK^0?ofkP0@0?ofkP80?EV[0P3om^h303eIZ`L0ooK^0`0mFJ/60?ofkP80?EV[00<0ooK^
03eIZ`0mFJ/0=@3om^h00`000000ooK^0?ofkP0c0?ofkP80e3dI00<0ooK^0=@m6@3D?AT01P3om^h3
0=@m6@L0ooK^0`3D?AT20?ofkP80e3dI4P3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0
ooK^00`0ooK^00<000000?ofkP3om^h0M`3om^h10?ooo`00N03om^h00`000000ooK^0?ofkP0<0?of
kP0303eIZ`3om^h0ooK^00`0ooK^0P0mFJ/B0?ofkP80?EV[303om^h00`0mFJ/0ooK^0?ofkP050?of
kP<0?EV[00<0ooK^03eIZ`0mFJ/0<`3om^h00`000000ooK^0?ofkP0a0?ofkP80e3dI00@0ooK^0=@m
6@3D?AT0e3dI1`3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP80e3dI4P3om^h20=@m6@h0ooK^00<0e3dI
0?ofkP3om^h0303om^h00`000000ooK^0?ofkP1f0?ofkP40oooo001g0?ofkP030000003om^h0ooK^
00/0ooK^0P0mFJ/A0?ofkP0303eIZ`3om^h0ooK^00d0ooK^0P0mFJ/00`3om^h0?EV[03eIZ`0<0?of
kP80?EV[1P3om^h303eIZ`030?ofkP0mFJ/0?EV[0380ooK^00<000000?ofkP3om^h0<03om^h20=@m
6@040?ofkP3D?AT0e3dI0=@m6@H0ooK^0P3D?AT<0?ofkP80e3dI00<0ooK^0=@m6@3D?AT03`3om^h0
0`3D?AT0ooK^0?ofkP0?0?ofkP80e3dI3@3om^h00`000000ooK^0?ofkP1e0?ofkP40oooo001e0?of
kP8000003@3om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP80?EV[2`3om^h203eIZ`D0ooK^00<0?EV[0?of
kP3om^h02@3om^h00`0mFJ/0ooK^03eIZ`070?ofkPD0?EV[<@3om^h00`000000ooK^0?ofkP0_0?of
kPD0e3dI1`3om^h00`3D?AT0ooK^0=@m6@0;0?ofkP030=@m6@3om^h0ooK^00<0ooK^0P3D?AT;0?of
kP80e3dI503om^h00`3D?AT0ooK^0?ofkP0;0?ofkP800000M@3om^h10?ooo`00M03om^h00`000000
ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^01D0ooK^00<0?EV[0?ofkP3om^h01P3om^h203eIZ`P0
ooK^0P0mFJ/90?ofkPD0?EV[1P3om^h303eIZ`030?ofkP0mFJ/0?EV[02l0ooK^00<000000?ofkP3o
m^h0;@3om^h20=@m6@040?ofkP3D?AT0e3dI0=@m6@H0ooK^1@3D?AT90?ofkP80e3dI203om^h20=@m
6@P0ooK^00<0e3dI0?ofkP3om^h05@3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030000003om^h0ooK^
0780ooK^0@3oool007<0ooK^00<000000?ofkP3om^h0303om^h0100mFJ/0ooK^03eIZ`0mFJ/F0?of
kP0303eIZ`3om^h0ooK^00<0ooK^0P0mFJ/<0?ofkP0303eIZ`3om^h0ooK^00H0ooK^00D0?EV[0?of
kP3om^h0?EV[0?ofkP0203eIZ`H0ooK^0`0mFJ/00`3om^h0?EV[0?ofkP0]0?ofkP030000003om^h0
ooK^02`0ooK^00<0e3dI0?ofkP3D?AT00P3D?AT60?ofkP80e3dI00D0ooK^0=@m6@3om^h0ooK^0=@m
6@080?ofkP030=@m6@3om^h0ooK^00X0ooK^0P3D?AT50?ofkP030=@m6@3om^h0ooK^01@0ooK^0P3D
?AT00`3om^h0e3dI0?ofkP0=0?ofkP030000003om^h0ooK^0740ooK^0@3oool00780ooK^00<00000
0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP020?ofkP80?EV[5@3om^h203eIZ`030?ofkP0mFJ/0
?EV[00l0ooK^0P0mFJ/60?ofkP0403eIZ`3om^h0ooK^0?ofkP80?EV[00<0ooK^03eIZ`3om^h01@3o
m^h303eIZ`030?ofkP0mFJ/0ooK^02`0ooK^00<000000?ofkP3om^h0:`3om^h00`3D?AT0ooK^0=@m
6@020=@m6@H0ooK^00@0e3dI0?ofkP3D?AT0e3dI0`3om^h00`3D?AT0ooK^0?ofkP040?ofkP80e3dI
3`3om^h20=@m6@030?ofkP3D?AT0e3dI01D0ooK^0P3D?AT40?ofkP030=@m6@3om^h0ooK^00`0ooK^
00<000000?ofkP3om^h0L03om^h10?ooo`00L@3om^h00`000000ooK^0?ofkP0<0?ofkP0303eIZ`3o
m^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h0503om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP80?EV[103o
m^h00`0mFJ/0ooK^0?ofkP030?ofkP0403eIZ`3om^h0?EV[03eIZ`H0ooK^0P0mFJ/00`3om^h0?EV[
03eIZ`0[0?ofkP030000003om^h0ooK^02T0ooK^0P3D?AT00`3om^h0e3dI0=@m6@060?ofkP80e3dI
00<0ooK^0=@m6@3om^h0103om^h00`3D?AT0ooK^0?ofkP020?ofkP80e3dI4`3om^h00`3D?AT0ooK^
0?ofkP0D0?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h0303om^h00`000000ooK^
0?ofkP1_0?ofkP40oooo001_0?ofkP8000003P3om^h00`0mFJ/0ooK^0?ofkP070?ofkP80?EV[4`3o
m^h0100mFJ/0ooK^03eIZ`0mFJ/C0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/01P3om^h203eIZ`03
0?ofkP0mFJ/0?EV[00@0ooK^100mFJ/00`3om^h0?EV[0?ofkP0Y0?ofkP030000003om^h0ooK^02P0
ooK^00<0e3dI0?ofkP3D?AT00`3D?AT40?ofkP80e3dI00<0ooK^0=@m6@3D?AT01P3om^h01@3D?AT0
ooK^0?ofkP3om^h0e3dI01<0ooK^0P3D?AT00`3om^h0e3dI0?ofkP0B0?ofkP80e3dI2@3om^h00`3D
?AT0ooK^0?ofkP0<0?ofkP800000K`3om^h10?ooo`00KP3om^h00`000000ooK^0?ofkP0=0?ofkP03
03eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h03P3om^h203eIZ`@0ooK^00<0?EV[0?ofkP3o
m^h04@3om^h203eIZ`030?ofkP0mFJ/0ooK^00L0ooK^00<0?EV[0?ofkP0mFJ/02@0mFJ/00`3om^h0
?EV[03eIZ`0X0?ofkP030000003om^h0ooK^02H0ooK^0P3D?AT00`3om^h0e3dI0=@m6@080=@m6@03
0?ofkP3D?AT0ooK^00L0ooK^00@0e3dI0?ofkP3D?AT0e3dI4`3om^h00`3D?AT0ooK^0?ofkP020?of
kP80e3dI403om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<000000?of
kP3om^h0K03om^h10?ooo`00K@3om^h00`000000ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00`0
ooK^0P0mFJ/=0?ofkP0303eIZ`3om^h0ooK^00D0ooK^0P0mFJ/C0?ofkP80?EV[1`3om^h303eIZ`80
ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`020?ofkP<0?EV[00<0ooK^03eIZ`3om^h09P3om^h00`00
0000ooK^0?ofkP0U0?ofkP030=@m6@3om^h0e3dI0080e3dI0P3om^h01@3D?AT0ooK^0?ofkP3om^h0
e3dI0080ooK^0`3D?AT70?ofkP80e3dI4`3om^h20=@m6@L0ooK^00<0e3dI0?ofkP3om^h02`3om^h2
0=@m6@h0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`000000ooK^0?ofkP1[0?ofkP40oooo001/0?of
kP030000003om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h03`3om^h203eIZ`X0ooK^00<0?EV[0?of
kP3om^h0203om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP80?EV[0P3om^h403eIZ`<0ooK^0P0mFJ/01@3o
m^h0?EV[03eIZ`3om^h0?EV[00<0ooK^1@0mFJ/V0?ofkP030000003om^h0ooK^02@0ooK^1@3D?AT3
0?ofkP050=@m6@3om^h0e3dI0=@m6@3om^h00P3D?AT30?ofkP@0e3dI0P3om^h20=@m6A<0ooK^00<0
e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP080?ofkP80e3dI4@3om^h00`3D?AT0ooK^0?of
kP0=0?ofkP030000003om^h0ooK^06X0ooK^0@3oool006/0ooK^00<000000?ofkP3om^h03@3om^h0
0`0mFJ/0ooK^0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h02P3om^h2
03eIZa40ooK^00@0?EV[0?ofkP0mFJ/0?EV[2@3om^h01P0mFJ/0ooK^0?ofkP0mFJ/0ooK^03eIZ`@0
ooK^1@0mFJ/T0?ofkP030000003om^h0ooK^0280ooK^1@3D?AT40?ofkP030=@m6@3om^h0e3dI0080
ooK^00<0e3dI0?ofkP3om^h01`3om^h20=@m6@030?ofkP3D?AT0ooK^0100ooK^0P3D?AT<0?ofkP03
0=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h04P3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP03
0000003om^h0ooK^06T0ooK^0@3oool006T0ooK^0P00000?0?ofkP0303eIZ`3om^h0ooK^01@0ooK^
0P0mFJ/40?ofkP80?EV[3`3om^h203eIZ`l0ooK^0P0mFJ/00`3om^h0?EV[0?ofkP090?ofkP80?EV[
00<0ooK^03eIZ`0mFJ/01@3om^h503eIZb<0ooK^00<000000?ofkP3om^h08@3om^h50=@m6@D0ooK^
0P3D?AT00`3om^h0e3dI0=@m6@0:0?ofkP040=@m6@3om^h0e3dI0=@m6@l0ooK^0P3D?AT?0?ofkP80
e3dI103om^h20=@m6AH0ooK^00<0e3dI0?ofkP3om^h03@3om^h2000006T0ooK^0@3oool006P0ooK^
00<000000?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0G0?ofkP80?EV[00<0ooK^03eIZ`3om^h0
4P3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP<0?EV[0`3om^h203eIZ`X0ooK^00@0?EV[0?ofkP0mFJ/0
?EV[1P3om^h203eIZ`030?ofkP0mFJ/0?EV[0240ooK^00<000000?ofkP3om^h07`3om^h20=@m6@03
0?ofkP3D?AT0e3dI00H0ooK^0P3D?AT00`3om^h0e3dI0?ofkP090?ofkP80e3dI0`3om^h30=@m6@`0
ooK^00<0e3dI0?ofkP3om^h04@3om^h0103D?AT0ooK^0=@m6@3D?ATI0?ofkP030=@m6@3om^h0ooK^
00h0ooK^00<000000?ofkP3om^h0IP3om^h10?ooo`00I`3om^h00`000000ooK^0?ofkP0>0?ofkP04
03eIZ`3om^h0?EV[03eIZaT0ooK^00<0?EV[0?ofkP3om^h04`3om^h203eIZ`P0ooK^0P0mFJ/20?of
kP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h0203om^h403eIZ`H0ooK^1@0mFJ/P0?of
kP030000003om^h0ooK^01h0ooK^1@3D?AT60?ofkP@0e3dI2P3om^h00`3D?AT0ooK^0?ofkP030?of
kP030=@m6@3om^h0ooK^0080e3dI203om^h20=@m6AD0ooK^00<0e3dI0?ofkP3om^h05`3om^h20=@m
6@030?ofkP3D?AT0ooK^00l0ooK^00<000000?ofkP3om^h0I@3om^h10?ooo`00IP3om^h00`000000
ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^0080ooK^0P0mFJ/F0?ofkP0403eIZ`3om^h0?EV[03eI
ZaD0ooK^00<0?EV[0?ofkP3om^h00`3om^h203eIZ`@0ooK^0`0mFJ/40?ofkP0303eIZ`3om^h0ooK^
00T0ooK^00<0?EV[0?ofkP0mFJ/01`3om^h203eIZ`030?ofkP0mFJ/0?EV[01h0ooK^00<000000?of
kP3om^h0703om^h50=@m6@L0ooK^00<0e3dI0?ofkP3D?AT02`3om^h00`3D?AT0ooK^0?ofkP020?of
kP<0e3dI103om^h20=@m6@D0ooK^00<0e3dI0?ofkP3om^h04`3om^h20=@m6@030?ofkP3D?AT0ooK^
01D0ooK^0P3D?AT40?ofkP030=@m6@3om^h0ooK^00h0ooK^00<000000?ofkP3om^h0I03om^h10?oo
o`00I@3om^h00`000000ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3o
m^h04P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^01<0ooK^0P0mFJ/00`3om^h0
?EV[03eIZ`060?ofkP0403eIZ`3om^h0ooK^03eIZ`@0ooK^0P0mFJ/90?ofkPD0?EV[1P3om^h303eI
Z`030?ofkP0mFJ/0ooK^01`0ooK^00<000000?ofkP3om^h06`3om^h00`3D?AT0ooK^0=@m6@020=@m
6@H0ooK^1@3D?AT90?ofkP80e3dI103om^h0103D?AT0ooK^0?ofkP3D?AT60?ofkP80e3dI00<0ooK^
0=@m6@3D?AT05@3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^0180ooK^00<0e3dI
0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030000003om^h0ooK^06<0ooK^0@3oool0
06@0ooK^00<000000?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP060?ofkP80?EV[4@3om^h00`0m
FJ/0ooK^0?ofkP040?ofkP80?EV[5@3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0403eIZ`3om^h0ooK^
0?ofkP80?EV[103om^h00`0mFJ/0ooK^0?ofkP060?ofkP0603eIZ`3om^h0ooK^03eIZ`3om^h0?EV[
1P3om^h303eIZ`030?ofkP0mFJ/0?EV[01/0ooK^00<000000?ofkP3om^h06@3om^h20=@m6@040?of
kP3D?AT0e3dI0=@m6@H0ooK^00<0e3dI0?ofkP3D?AT00P3om^h00`3D?AT0ooK^0?ofkP060?ofkP03
0=@m6@3om^h0ooK^0080ooK^0P3D?AT30?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3o
m^h04`3om^h20=@m6@H0ooK^00<0e3dI0?ofkP3om^h03`3om^h20=@m6@P0ooK^00<0e3dI0?ofkP3o
m^h03`3om^h00`000000ooK^0?ofkP1R0?ofkP40oooo001R0?ofkP8000004@3om^h00`0mFJ/0ooK^
0?ofkP090?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^
0?ofkP0A0?ofkP0403eIZ`3om^h0?EV[03eIZ`D0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0
ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00D0ooK^00@0?EV[0?ofkP3om^h0ooK^0`0mFJ/70?of
kP80?EV[0P3om^h203eIZaT0ooK^00<000000?ofkP3om^h05`3om^h20=@m6@80ooK^0P3D?AT70?of
kP<0e3dI0`3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?of
kP3om^h0103om^h00`3D?AT0ooK^0?ofkP030?ofkP80e3dI00<0ooK^0=@m6@3om^h04P3om^h00`3D
?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D
?AT0ooK^0?ofkP0?0?ofkP800000HP3om^h10?ooo`00H@3om^h00`000000ooK^0?ofkP0@0?ofkP03
03eIZ`3om^h0ooK^00/0ooK^0P0mFJ/<0?ofkP0303eIZ`3om^h0ooK^00T0ooK^0P0mFJ/?0?ofkP80
?EV[103om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00D0ooK^0P0mFJ/30?ofkP80
?EV[1@3om^h00`0mFJ/0ooK^0?ofkP030?ofkP<0?EV[1@3om^h403eIZ`80ooK^00<0?EV[0?ofkP3o
m^h05P3om^h00`000000ooK^0?ofkP0F0?ofkP030=@m6@3om^h0ooK^00@0e3dI1@3om^h30=@m6@D0
ooK^00<0e3dI0?ofkP3om^h00`3om^h20=@m6@<0ooK^0P3D?AT70?ofkP030=@m6@3om^h0ooK^0080
ooK^00<0e3dI0?ofkP3om^h00P3om^h20=@m6@l0ooK^0P3D?AT;0?ofkP030=@m6@3om^h0ooK^00X0
ooK^0P3D?AT=0?ofkP030=@m6@3om^h0ooK^0100ooK^00<000000?ofkP3om^h0G`3om^h10?ooo`00
H03om^h00`000000ooK^0?ofkP0@0?ofkP0303eIZ`3om^h0ooK^00h0ooK^0P0mFJ/90?ofkP0303eI
Z`3om^h0ooK^00`0ooK^0P0mFJ/<0?ofkP0303eIZ`3om^h0ooK^00D0ooK^0P0mFJ/20?ofkP0303eI
Z`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eI
Z`3om^h0ooK^00@0ooK^3@0mFJ/00`3om^h0?EV[03eIZ`0F0?ofkP030000003om^h0ooK^01@0ooK^
0P3D?AT00`3om^h0e3dI0=@m6@0;0=@m6@H0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^
0?ofkP020?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h00P3D?AT70?ofkP030=@m
6@3om^h0ooK^00X0ooK^0P3D?AT>0?ofkP030=@m6@3om^h0ooK^00L0ooK^0P3D?AT@0?ofkP030=@m
6@3om^h0ooK^0100ooK^00<000000?ofkP3om^h0GP3om^h10?ooo`00G`3om^h00`000000ooK^0?of
kP0@0?ofkP0303eIZ`3om^h0ooK^0140ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?of
kP0?0?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^03eI
Z`0:0?ofkP0303eIZ`3om^h0ooK^0080ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`040?ofkP<0?EV[
00@0ooK^03eIZ`0mFJ/0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP0403eIZ`030?ofkP0mFJ/0ooK^01@0
ooK^00<000000?ofkP3om^h04`3om^h00`3D?AT0ooK^0=@m6@030=@m6@80ooK^00@0e3dI0?ofkP3o
m^h0ooK^0`3D?AT0103om^h0e3dI0=@m6@3D?AT40?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT0103o
m^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0e3dI00X0ooK^00<0e3dI0?ofkP3om^h0203o
m^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h04@3o
m^h00`3D?AT0ooK^0?ofkP0@0?ofkP030000003om^h0ooK^05d0ooK^0@3oool005h0ooK^00<00000
0?ofkP3om^h0403om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP80?EV[103om^h00`0mFJ/0ooK^0?ofkP0A
0?ofkP80?EV[1`3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP80?EV[2`3om^h203eIZ`<0ooK^0P0mFJ/0
0`3om^h0?EV[03eIZ`0303eIZ`D0ooK^0`0mFJ/30?ofkP0403eIZ`3om^h0ooK^0?ofkPH0?EV[4`3o
m^h00`000000ooK^0?ofkP0A0?ofkPH0e3dI0`3om^h0103D?AT0ooK^0?ofkP3om^h30=@m6@D0ooK^
1@3D?AT00`3om^h0e3dI0=@m6@030?ofkP80e3dI2`3om^h20=@m6@`0ooK^00<0e3dI0?ofkP3om^h0
1@3om^h20=@m6A<0ooK^00<0e3dI0?ofkP3om^h00P3om^h20=@m6A@0ooK^00<0e3dI0?ofkP3om^h0
4@3om^h00`000000ooK^0?ofkP1L0?ofkP40oooo001L0?ofkP8000004`3om^h00`0mFJ/0ooK^0?of
kP0E0?ofkP80?EV[00<0ooK^03eIZ`3om^h05@3om^h00`0mFJ/0ooK^0?ofkP020?ofkP80?EV[3P3o
m^h303eIZ`/0ooK^00<0?EV[0?ofkP3om^h00P3om^h203eIZ`/0ooK^0`0mFJ/00`3om^h0?EV[0?of
kP030?ofkP<0?EV[00<0ooK^03eIZ`0mFJ/04P3om^h00`000000ooK^0?ofkP0@0?ofkP80e3dI00@0
ooK^0=@m6@3D?AT0e3dI103om^h00`3D?AT0ooK^0=@m6@020=@m6@/0ooK^0P3D?AT40?ofkP030=@m
6@3om^h0ooK^00T0ooK^0`3D?AT>0?ofkP80e3dI103om^h00`3D?AT0ooK^0?ofkP0D0?ofkP040=@m
6@3om^h0e3dI0=@m6AL0ooK^00<0e3dI0?ofkP3om^h04@3om^h2000005`0ooK^0@3oool005/0ooK^
00<000000?ofkP3om^h04P3om^h00`0mFJ/0ooK^0?ofkP0H0?ofkP0303eIZ`3om^h0ooK^01H0ooK^
0P0mFJ/00`3om^h0?EV[0?ofkP0?0?ofkP0403eIZ`3om^h0ooK^03eIZ`/0ooK^100mFJ/00`3om^h0
?EV[03eIZ`0;0?ofkP<0?EV[00<0ooK^03eIZ`3om^h0103om^h203eIZ`80ooK^00<0?EV[0?ofkP3o
m^h03`3om^h00`000000ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^0080e3dI1@3om^h00`3D?AT0
ooK^0=@m6@020=@m6@/0ooK^0P3D?AT00`3om^h0e3dI0=@m6@020=@m6@/0ooK^00@0e3dI0?ofkP3o
m^h0e3dI403om^h0103D?AT0ooK^0=@m6@3D?ATH0?ofkP030=@m6@3om^h0ooK^01P0ooK^00<0e3dI
0?ofkP3om^h04P3om^h00`000000ooK^0?ofkP1I0?ofkP40oooo001J0?ofkP030000003om^h0ooK^
0180ooK^00<0?EV[0?ofkP3om^h0603om^h0100mFJ/0ooK^03eIZ`0mFJ/H0?ofkP0303eIZ`3om^h0
ooK^00l0ooK^00@0?EV[0?ofkP3om^h0ooK^0P0mFJ/90?ofkP<0?EV[0P3om^h0100mFJ/0ooK^03eI
Z`0mFJ/;0?ofkP<0?EV[1P3om^h303eIZ`030?ofkP0mFJ/0?EV[00l0ooK^00<000000?ofkP3om^h0
3@3om^h20=@m6@040?ofkP3D?AT0e3dI0=@m6@H0ooK^0`3D?AT<0?ofkP030=@m6@3om^h0e3dI0080
ooK^0`3D?AT90?ofkP80e3dI0`3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^01H0
ooK^0P3D?AT00`3om^h0e3dI0?ofkP0I0?ofkP030=@m6@3om^h0ooK^0180ooK^00<000000?ofkP3o
m^h0F03om^h10?ooo`00F@3om^h00`000000ooK^0?ofkP0B0?ofkP0403eIZ`3om^h0?EV[03eIZaL0
ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP0403eIZ`3om^h0?EV[03eI
Z`h0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP040?ofkP80?EV[0`3om^h303eI
Z`<0ooK^00<0?EV[0?ofkP3om^h02@3om^h303eIZ`L0ooK^1@0mFJ/>0?ofkP030000003om^h0ooK^
00`0ooK^1@3D?AT70?ofkP<0e3dI2`3om^h20=@m6@80ooK^0`3D?AT30?ofkP80e3dI1P3om^h00`3D
?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00`0ooK^0P3D?AT00`3om^h0e3dI0?ofkP0E0?of
kP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h05@3om^h20=@m6@030?ofkP3D?AT0ooK^
01<0ooK^00<000000?ofkP3om^h0E`3om^h10?ooo`00F03om^h00`000000ooK^0?ofkP0C0?ofkP04
03eIZ`3om^h0ooK^0?ofkP80?EV[503om^h00`0mFJ/0ooK^0?ofkP040?ofkP80?EV[4`3om^h00`0m
FJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h01@3om^h203eI
Z`80ooK^0P0mFJ/70?ofkP0303eIZ`3om^h0ooK^0080ooK^0P0mFJ/;0?ofkP80?EV[1`3om^h303eI
Z`030?ofkP0mFJ/0ooK^00`0ooK^00<000000?ofkP3om^h02`3om^h00`3D?AT0ooK^0=@m6@020=@m
6@L0ooK^0P3D?AT;0?ofkP80e3dI103om^h00`3D?AT0ooK^0?ofkP050?ofkP80e3dI0P3om^h20=@m
6@L0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^
0140ooK^0P3D?AT50?ofkP030=@m6@3om^h0ooK^01<0ooK^0P3D?AT30?ofkP030=@m6@3om^h0ooK^
01<0ooK^00<000000?ofkP3om^h0EP3om^h10?ooo`00E`3om^h00`000000ooK^0?ofkP0C0?ofkP03
03eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h04@3om^h00`0mFJ/0ooK^0?ofkP060?ofkP03
03eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h0103om^h203eIZ`/0ooK^00<0?EV[0?ofkP3o
m^h01`3om^h203eIZ`T0ooK^0`0mFJ/40?ofkP80?EV[2@3om^h403eIZ`L0ooK^1@0mFJ/;0?ofkP03
0000003om^h0ooK^00T0ooK^1@3D?AT70?ofkP@0e3dI2P3om^h00`3D?AT0ooK^0?ofkP020?ofkP<0
e3dI2@3om^h20=@m6@T0ooK^00<0e3dI0?ofkP3om^h02@3om^h20=@m6@H0ooK^00<0e3dI0?ofkP3o
m^h03`3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^0140ooK^00<0e3dI0?ofkP3o
m^h0103om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030000003om^h0ooK^05D0ooK^0@3oool005D0ooK^
0P00000E0?ofkP0303eIZ`3om^h0ooK^00H0ooK^0P0mFJ/@0?ofkP0303eIZ`3om^h0ooK^00P0ooK^
0P0mFJ/>0?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^
0?ofkP060?ofkP0403eIZ`3om^h0?EV[03eIZ`P0ooK^00@0?EV[0?ofkP3om^h0?EV[1@3om^h203eI
Z`L0ooK^00<0?EV[0?ofkP3om^h00P0mFJ/70?ofkP<0?EV[00<0ooK^03eIZ`3om^h02@3om^h00`00
0000ooK^0?ofkP080?ofkP030=@m6@3om^h0e3dI0080e3dI1`3om^h20=@m6@80ooK^00<0e3dI0?of
kP3om^h01P3om^h20=@m6@@0ooK^00@0e3dI0?ofkP3om^h0e3dI203om^h20=@m6@030?ofkP3D?AT0
e3dI00L0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0
ooK^00`0ooK^0P3D?AT:0?ofkP030=@m6@3om^h0ooK^00h0ooK^0P3D?AT80?ofkP030=@m6@3om^h0
ooK^01<0ooK^0P00001E0?ofkP40oooo001D0?ofkP030000003om^h0ooK^01D0ooK^00<0?EV[0?of
kP3om^h0203om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00/0ooK^0P0mFJ/;0?of
kP0303eIZ`3om^h0ooK^00T0ooK^0P0mFJ/80?ofkP<0?EV[103om^h203eIZ`@0ooK^00<0?EV[0?of
kP3om^h01@3om^h0100mFJ/0ooK^0?ofkP3om^h203eIZ`D0ooK^00<0?EV[0?ofkP3om^h0103om^h0
100mFJ/0ooK^0?ofkP3om^h303eIZ`L0ooK^100mFJ/90?ofkP030000003om^h0ooK^00L0ooK^103D
?AT70?ofkP<0e3dI0`3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^0080ooK^0P3D
?AT30?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?of
kP020?ofkP<0e3dI2@3om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^00T0ooK^0P3D
?AT=0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?of
kP0E0?ofkP030000003om^h0ooK^0580ooK^0@3oool005<0ooK^00<000000?ofkP3om^h05@3om^h0
0`0mFJ/0ooK^0?ofkP0:0?ofkP80?EV[2`3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0
ooK^00L0ooK^00<0?EV[0?ofkP3om^h0303om^h203eIZ`D0ooK^00D0?EV[0?ofkP3om^h0ooK^03eI
Z`020?ofkP0303eIZ`3om^h0ooK^00D0ooK^0P0mFJ/40?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0
?EV[0?ofkP3om^h00`3om^h203eIZ`@0ooK^00<0?EV[0?ofkP3om^h00P3om^h?03eIZ`D0ooK^0P00
00000`3om^h00000000000050?ofkPl0e3dI103om^h00`3D?AT0ooK^0?ofkP030?ofkP80e3dI103o
m^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^0080ooK^0P3D?AT70?ofkP040=@m6@3o
m^h0ooK^0=@m6@<0ooK^00<0e3dI0?ofkP3om^h0103om^h20=@m6@d0ooK^00<0e3dI0?ofkP3om^h0
1`3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00T0ooK^0P3D?AT<0?ofkP030=@m
6@3om^h0ooK^01D0ooK^00<000000?ofkP3om^h0D@3om^h10?ooo`00DP3om^h00`000000ooK^0?of
kP0E0?ofkP0303eIZ`3om^h0ooK^00d0ooK^0P0mFJ/80?ofkP0303eIZ`3om^h0ooK^0100ooK^0P0m
FJ/60?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?of
kP020?ofkP80?EV[2P3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00L0ooK^0P0mFJ/50?ofkP80?EV[
0P3om^h503eIZ`80ooK^0`0mFJ/50?ofkP0303eIZ`3om^h0?EV[00<0?EV[0`3om^h00`000000ooK^
0?ofkP030?ofkP040000003om^h0ooK^0?ofkP@0e3dI00<0ooK^0=@m6@3om^h0103om^h30=@m6@80
ooK^1@3D?AT30?ofkP80e3dI103om^h20=@m6@L0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0:0?of
kP80e3dI103om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?of
kP3om^h0103om^h20=@m6A80ooK^00<0e3dI0?ofkP3om^h01P3om^h20=@m6@h0ooK^00<0e3dI0?of
kP3om^h05P3om^h00`000000ooK^0?ofkP1@0?ofkP40oooo001A0?ofkP030000003om^h0ooK^01H0
ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^01<0
ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP80?EV[0P3om^h00`0mFJ/0
ooK^0?ofkP020?ofkP0303eIZ`3om^h0?EV[00X0ooK^00@0?EV[0?ofkP3om^h0?EV[2@3om^h00`0m
FJ/0ooK^0?ofkP040?ofkP<0?EV[1`3om^h303eIZ`@0ooK^00<0?EV[0?ofkP3om^h0100mFJ/20000
00L0ooK^0P0000040=@m6@80ooK^00<0e3dI0?ofkP3om^h00P3om^h30=@m6@L0ooK^103D?AT50?of
kP030=@m6@3om^h0ooK^00L0ooK^00@0e3dI0?ofkP3om^h0e3dI2P3om^h0103D?AT0ooK^0?ofkP3D
?AT30?ofkP040=@m6@3om^h0ooK^0?ofkP80e3dI4P3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m
6@3om^h0ooK^0180ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m
6@3om^h0ooK^01H0ooK^00<000000?ofkP3om^h0C`3om^h10?ooo`00C`3om^h2000001P0ooK^00<0
?EV[0?ofkP3om^h04@3om^h203eIZ`@0ooK^00<0?EV[0?ofkP3om^h0503om^h203eIZ`030?ofkP0m
FJ/0ooK^01D0ooK^0P0mFJ/30?ofkP80?EV[0`3om^h203eIZ`T0ooK^0`0mFJ/:0?ofkP0403eIZ`3o
m^h0ooK^0?ofkP80?EV[00@0ooK^03eIZ`0mFJ/0?EV[203om^h303eIZ`80ooK^00<0?EV[0?ofkP3o
m^h00P3om^h0100mFJ/0000003eIZ`0mFJ/70?ofkP80e3dI00<000000=@m6@3om^h00`3om^h00`3D
?AT0ooK^0?ofkP030=@m6@P0ooK^00D0e3dI0?ofkP3D?AT0e3dI0?ofkP020=@m6@80ooK^00<0e3dI
0?ofkP3om^h0203om^h30=@m6@T0ooK^0P3D?AT40?ofkP070=@m6@3om^h0ooK^0?ofkP3D?AT0ooK^
0=@m6@0E0?ofkP040=@m6@3om^h0e3dI0=@m6AH0ooK^00<0e3dI0?ofkP3om^h00P3om^h20=@m6A<0
ooK^00<0e3dI0?ofkP3om^h05P3om^h2000004l0ooK^0@3oool004h0ooK^00<000000?ofkP3om^h0
603om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP80?EV[00<0ooK^03eIZ`3om^h0603om^h00`0mFJ/0ooK^
0?ofkP0F0?ofkP80?EV[00<0ooK^03eIZ`3om^h01P3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eI
Z`3om^h0ooK^00T0ooK^0`0mFJ/50?ofkP0303eIZ`3om^h0ooK^00L0ooK^0`0mFJ/20?ofkP0503eI
Z`3om^h0ooK^0?ofkP0000000P0mFJ/00`3om^h0?EV[0?ofkP040?ofkP050=@m6@3om^h0e3dI0=@m
6@0000000`3om^h00`3D?AT0ooK^0?ofkP030=@m6@T0ooK^0P3D?AT50?ofkP80e3dI2`3om^h00`3D
?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00D0ooK^0P3D?AT00`3om^h0e3dI0=@m6@0G0?of
kP030=@m6@3om^h0ooK^01L0ooK^00@0e3dI0?ofkP3D?AT0e3dI5@3om^h00`3D?AT0ooK^0?ofkP0H
0?ofkP030000003om^h0ooK^04`0ooK^0@3oool004d0ooK^00<000000?ofkP3om^h0603om^h00`0m
FJ/0ooK^0?ofkP0F0?ofkP0303eIZ`3om^h0ooK^01L0ooK^00@0?EV[0?ofkP0mFJ/0?EV[5P3om^h0
0`0mFJ/0ooK^03eIZ`090?ofkP0303eIZ`3om^h0ooK^00L0ooK^0`0mFJ/80?ofkP80?EV[00<0ooK^
03eIZ`3om^h0103om^h203eIZ`X0ooK^100mFJ/00`3om^h00000000000020?ofkPD0?EV[00<00000
0=@m6@3D?AT00`3D?AT20?ofkP80000000<0ooK^0=@m6@3D?AT00P3D?AT:0?ofkP80e3dI1@3om^h0
103D?AT0ooK^0?ofkP3D?AT80?ofkP<0e3dI2@3om^h00`3D?AT0ooK^0?ofkP080?ofkP80e3dI5P3o
m^h20=@m6@030?ofkP3D?AT0ooK^01P0ooK^00<0e3dI0?ofkP3om^h05P3om^h00`3D?AT0ooK^0?of
kP0H0?ofkP030000003om^h0ooK^04/0ooK^0@3oool004`0ooK^00<000000?ofkP3om^h0603om^h0
0`0mFJ/0ooK^0?ofkP0F0?ofkP0403eIZ`3om^h0?EV[03eIZaH0ooK^00<0?EV[0?ofkP3om^h00P3o
m^h00`0mFJ/0ooK^0?ofkP0B0?ofkP0403eIZ`3om^h0?EV[0?ofkP80?EV[203om^h203eIZ`L0ooK^
00@0?EV[0?ofkP3om^h0?EV[1@3om^h203eIZ`@0ooK^0P0mFJ/30?ofkP0403eIZ`3om^h0?EV[03eI
Z`T0ooK^00@0?EV[0?ofkP0mFJ/000001P3om^h01`0mFJ/0000003eIZ`000000e3dI0000003D?AT0
1P3om^h010000000e3dI0?ofkP3D?AT:0?ofkP030=@m6@3om^h0e3dI00<0ooK^0P3D?AT40?ofkP80
e3dI1@3om^h0103D?AT0ooK^0?ofkP3D?AT70?ofkP80e3dI2@3om^h20=@m6@030?ofkP3D?AT0ooK^
01@0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP0D0?ofkP80e3dI00<0ooK^0=@m
6@3om^h05`3om^h00`3D?AT0ooK^0?ofkP0H0?ofkP030000003om^h0ooK^04X0ooK^0@3oool004/0
ooK^00<000000?ofkP3om^h06@3om^h00`0mFJ/0ooK^0?ofkP0F0?ofkP0503eIZ`3om^h0ooK^0?of
kP0mFJ/0503om^h00`0mFJ/0ooK^0?ofkP040?ofkP80?EV[4P3om^h203eIZ`@0ooK^00<0?EV[0?of
kP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0403eIZ`3om^h0ooK^0?ofkP80?EV[00<0ooK^
03eIZ`0mFJ/0203om^h0100mFJ/0ooK^0?ofkP0mFJ/30?ofkP0303eIZ`3om^h0ooK^00L0ooK^0P00
000203eIZ`@0ooK^0P00000203eIZ`030000003D?AT0e3dI00800000103om^h20=@m6@8000002P3o
m^h0103D?AT0ooK^0?ofkP3D?AT20?ofkP030=@m6@3om^h0ooK^00H0ooK^0P3D?AT00`3om^h0e3dI
0=@m6@030?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h01`3om^h20=@m6@@0ooK^
00<0e3dI0?ofkP3om^h0403om^h20=@m6@D0ooK^00<0e3dI0?ofkP3om^h04`3om^h01@3D?AT0ooK^
0?ofkP3om^h0e3dI01P0ooK^00<0e3dI0?ofkP3om^h06@3om^h00`000000ooK^0?ofkP190?ofkP40
oooo00190?ofkP8000006`3om^h00`0mFJ/0ooK^0?ofkP0F0?ofkP0303eIZ`3om^h0ooK^00<0ooK^
0P0mFJ/B0?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^
0?ofkP040?ofkP80?EV[203om^h203eIZ`<0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^
0?ofkP090?ofkP<0?EV[103om^h00`0mFJ/0ooK^0?ofkP050?ofkP070000003om^h0ooK^03eIZ`3o
m^h0?EV[0?ofkP020000000501D60P0000005@H201D60P0mFJ/00P0X<UP020000000?EV[00000000
0000ooK^0=@m6@3om^h0e3dI0P3om^h00`000000ooK^0?ofkP050?ofkP80e3dI0`3om^h30=@m6@/0
ooK^00<0e3dI0?ofkP3om^h0103om^h0103D?AT0ooK^0?ofkP3om^h20=@m6@T0ooK^00<0e3dI0?of
kP3om^h0103om^h20=@m6A00ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP0@0?of
kP80e3dI1@3om^h00`3D?AT0ooK^0?ofkP0F0?ofkP030=@m6@3om^h0ooK^01T0ooK^0P0000190?of
kP40oooo00180?ofkP030000003om^h0ooK^01X0ooK^00@0?EV[0?ofkP0mFJ/0?EV[5@3om^h00`0m
FJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0m
FJ/0ooK^0?ofkP0=0?ofkP80?EV[203om^h203eIZ`P0ooK^00@0?EV[0?ofkP3om^h0?EV[103om^h2
03eIZ`030?ofkP0mFJ/0?EV[00/0ooK^00<0?EV[0?ofkP3om^h00`3om^h203eIZ`<0ooK^0P000003
0?ofkP<0?EV[00@0000001D60P0E1P8000000`0E1P8020000000:39H02PbF00X<UP0000003eIZ`0J
7CT000000`3D?AT30?ofkP800000103om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^
00T0ooK^0P3D?AT00`3om^h0e3dI0=@m6@040?ofkP040=@m6@3om^h0ooK^0=@m6@T0ooK^0P3D?AT7
0?ofkP030=@m6@3om^h0e3dI00h0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP0>
0?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h04`3om^h20=@m6@030?ofkP3D?AT0
ooK^01/0ooK^00<000000?ofkP3om^h0AP3om^h10?ooo`00A`3om^h00`000000ooK^0?ofkP0K0?of
kP0403eIZ`3om^h0ooK^0?ofkP80?EV[4`3om^h00`0mFJ/0ooK^0?ofkP070?ofkP80?EV[3@3om^h0
0`0mFJ/0ooK^0?ofkP0:0?ofkP80?EV[2`3om^h303eIZ`/0ooK^00<0?EV[0?ofkP3om^h01P3om^h3
03eIZ`<0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP080?ofkP<0?EV[1@3om^h0
0`0mFJ/0ooK^000000050?ofkP0403eIZ`3om^h05@H203eIZ`800000100E1P800`000000:39H02Pb
F00202PbF080000000@0e3dI01XM>@3om^h0e3dI1@3om^h010000000ooK^0=@m6@3D?AT40?ofkP<0
e3dI2P3om^h00`3D?AT0ooK^0?ofkP030?ofkP040=@m6@3om^h0ooK^0?ofkP<0e3dI203om^h20=@m
6@X0ooK^00<0e3dI0?ofkP3D?AT02`3om^h20=@m6@`0ooK^00<0e3dI0?ofkP3om^h02`3om^h20=@m
6@T0ooK^00<0e3dI0?ofkP3om^h04@3om^h20=@m6@<0ooK^00<0e3dI0?ofkP3om^h06`3om^h00`00
0000ooK^0?ofkP150?ofkP40oooo00160?ofkP030000003om^h0ooK^01/0ooK^00<0?EV[0?ofkP3o
m^h0103om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00X0ooK^0P0mFJ/:0?ofkP03
03eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h01`3om^h0100mFJ/0ooK^0?ofkP0mFJ/<0?of
kP80?EV[203om^h0100mFJ/0ooK^0?ofkP0mFJ/70?ofkP80?EV[203om^h0100mFJ/0ooK^0?ofkP0m
FJ/50?ofkP030000003om^h0ooK^00@0ooK^00D0?EV[01D60P0E1P80000003eIZ`0401D60P<00000
100X<UP01@3D?AT0000001XM>@0J7CT0e3dI00H0ooK^00<000000?ofkP3om^h00`3om^h0103D?AT0
ooK^0?ofkP3D?AT80?ofkP80e3dI1`3om^h0103D?AT0ooK^0?ofkP3D?AT80?ofkP80e3dI303om^h0
103D?AT0ooK^0?ofkP3D?AT90?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h0203o
m^h20=@m6@`0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3o
m^h0ooK^01/0ooK^00<000000?ofkP3om^h0A03om^h10?ooo`00A@3om^h00`000000ooK^0?ofkP0L
0?ofkP0303eIZ`3om^h0ooK^00D0ooK^0P0mFJ/>0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[
0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP80?EV[1P3om^h01@0mFJ/0ooK^0?ofkP3o
m^h0?EV[00h0ooK^00<0?EV[0?ofkP3om^h01@3om^h303eIZ`X0ooK^0P0mFJ/60?ofkP0403eIZ`3o
m^h0ooK^0?ofkP80?EV[00@0ooK^000000000000ooK^0P0mFJ/30?ofkP030000000mFJ/000000080
000000<05@H203eIZ`0mFJ/00P0000000`0V2P@0000003=4N00200000080e3dI00H0:39H00000000
000000000=@m6@0000030?ofkP80e3dI00@0ooK^000000000000ooK^0P3D?AT30?ofkP030=@m6@3o
m^h0ooK^00@0ooK^0P3D?AT:0?ofkP<0e3dI1`3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP050=@m6@3o
m^h0ooK^0?ofkP3D?AT01P3om^h20=@m6A40ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^
0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00d0ooK^0P3D?AT70?ofkP030=@m6@3om^h0ooK^01`0ooK^
00<000000?ofkP3om^h0@`3om^h10?ooo`00A03om^h00`000000ooK^0?ofkP0L0?ofkP0303eIZ`3o
m^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP80?EV[1@3o
m^h00`0mFJ/0ooK^0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^0080ooK^00D0?EV[0?ofkP3om^h0ooK^
03eIZ`0@0?ofkP80?EV[103om^h203eIZ`80ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^
0?ofkP020?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<000000?ofkP3om^h00`3om^h203eIZ`030000
000E1P80?EV[00805@H200D0000001D60P0E1P80000003eIZ`0202H:10050000000cA7P0<dAh0=@m
6@0000000P0X<UP01P000000:39H02PbF03D?AT06Qdi00000080e3dI1@3om^h00`000000ooK^0?of
kP040?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h02@3om^h0103D?AT0ooK^0?of
kP3D?AT50?ofkP80e3dI403om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00@0ooK^00<0e3dI0?ofkP3o
m^h04@3om^h00`3D?AT0ooK^0?ofkP040?ofkP80e3dI403om^h00`3D?AT0ooK^0?ofkP0;0?ofkP03
0=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h0703om^h00`000000ooK^0?ofkP120?ofkP40
oooo00120?ofkP8000007`3om^h00`0mFJ/0ooK^0?ofkP090?ofkP80?EV[2P3om^h00`0mFJ/0ooK^
0?ofkP0A0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h04`3om^h203eIZ`030?of
kP0mFJ/0ooK^00<0ooK^00<0?EV[0?ofkP3om^h0403om^h203eIZ`030?ofkP0mFJ/0?EV[00@0ooK^
0P0mFJ/:0?ofkP80?EV[0P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP80000000@0ooK^03eIZ`0mFJ/0
ooK^0P0mFJ/01`3om^h00000000000000000?EV[01D60P0000000P0E1P800`0000009PX402H:1002
03eIZ`030000003D?AT0e3dI0080<dAh00H0000002PbF00X<UP000000=@m6@0X<UP3000000040?of
kP3D?AT0e3dI0?ofkP80e3dI00<0ooK^000000000000103om^h00`3D?AT0ooK^0?ofkP020=@m6@X0
ooK^0P3D?AT40?ofkP80e3dI00<0ooK^0=@m6@3D?AT04P3om^h00`3D?AT0ooK^0?ofkP020?ofkP04
0=@m6@3om^h0e3dI0=@m6AD0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP0A0?of
kP030=@m6@3om^h0ooK^00P0ooK^0P3D?AT;0?ofkP030=@m6@3om^h0ooK^01d0ooK^0P0000120?of
kP40oooo00110?ofkP030000003om^h0ooK^01h0ooK^00<0?EV[0?ofkP3om^h0303om^h203eIZ`P0
ooK^00<0?EV[0?ofkP3om^h04P3om^h203eIZ`030?ofkP0mFJ/0ooK^01L0ooK^00<0?EV[0?ofkP3o
m^h00`3om^h303eIZa80ooK^00<0?EV[0?ofkP0mFJ/01P3om^h203eIZ`X0ooK^00<0?EV[0?ofkP0m
FJ/00`3om^h00`000000ooK^0?ofkP020?ofkP<0?EV[0`00000301D60P0403eIZ`00000000000000
00D09PX400<0?EV[03=4N00cA7P00`0cA7P3000000040=@m6@0X<UP0:39H02PbF0<000000`3D?AT4
0?ofkP070000003om^h0ooK^0?ofkP3D?AT0ooK^0=@m6@0:0?ofkP80e3dI1P3om^h00`3D?AT0ooK^
0=@m6@0B0?ofkP<0e3dI1@3om^h00`3D?AT0ooK^0?ofkP0F0?ofkP040=@m6@3om^h0e3dI0=@m6A@0
ooK^00<0e3dI0?ofkP3om^h01P3om^h20=@m6@h0ooK^00<0e3dI0?ofkP3om^h07P3om^h00`000000
ooK^0?ofkP0o0?ofkP40oooo00100?ofkP030000003om^h0ooK^01h0ooK^00<0?EV[0?ofkP3om^h0
3`3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^01D0ooK^00<0?EV[0?ofkP3om^h0
5P3om^h0100mFJ/0ooK^03eIZ`0mFJ/20?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/0403om^h0100m
FJ/0ooK^03eIZ`0mFJ/80?ofkP0303eIZ`3om^h0ooK^00P0ooK^0P0mFJ/00`3om^h0000000000003
0?ofkP80?EV[0P3om^h00`000000?EV[01D60P0401D60P0303eIZ`0000009PX400H09PX400<00000
03=4N00cA7P01@0cA7P00`000000e3dI02PbF00402PbF0040=@m6@000000ooK^0?ofkP80e3dI0`3o
m^h2000000030?ofkP3D?AT0e3dI00X0ooK^00<0e3dI0?ofkP3om^h01P3om^h20=@m6@030?ofkP3D
?AT0ooK^00l0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@020?ofkP80e3dI00<0ooK^0=@m6@3om^h0
5`3om^h00`3D?AT0ooK^0?ofkP0E0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h0
3`3om^h00`3D?AT0ooK^0?ofkP0N0?ofkP030000003om^h0ooK^03h0ooK^0@3oool003l0ooK^00<0
00000?ofkP3om^h07`3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP80?EV[0`3om^h00`0mFJ/0ooK^0?of
kP0E0?ofkP0403eIZ`3om^h0?EV[03eIZaD0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^
03eIZ`040?ofkP80?EV[3@3om^h01P0mFJ/0ooK^0?ofkP0mFJ/0ooK^03eIZ`P0ooK^0P0mFJ/90?of
kP0303eIZ`000000?EV[0080ooK^0P0mFJ/20?ofkP@000000P0mFJ/201D60P030000000mFJ/00000
00L09PX400<0000003=4N00cA7P01@0cA7P00`000000e3dI0000000202PbF080e3dI100000020?of
kP80e3dI0P3om^h00`3D?AT000000=@m6@090?ofkP80e3dI203om^h20=@m6@<0ooK^00<0e3dI0?of
kP3om^h02`3om^h20=@m6@@0ooK^00<0e3dI0?ofkP3D?AT0103om^h00`3D?AT0ooK^0?ofkP0C0?of
kP80e3dI00<0ooK^0=@m6@3om^h05P3om^h0103D?AT0ooK^0?ofkP3om^h20=@m6A80ooK^00<0e3dI
0?ofkP3om^h07`3om^h00`000000ooK^0?ofkP0m0?ofkP40oooo000n0?ofkP030000003om^h0ooK^
01l0ooK^00<0?EV[0?ofkP3om^h04`3om^h203eIZ`030?ofkP0mFJ/0ooK^01H0ooK^00@0?EV[0?of
kP3om^h0ooK^0P0mFJ/C0?ofkP0303eIZ`3om^h0ooK^00<0ooK^0P0mFJ/60?ofkP0303eIZ`3om^h0
ooK^00T0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`020?ofkP80?EV[203om^h00`0mFJ/0ooK^0?of
kP060?ofkP030000003om^h0ooK^0080?EV[0`3om^h2000000805@H200P0000001D60P0E1P80?EV[
0000000V2P@0?EV[000000D09PX41@00000503=4N0050000003D?AT0<dAh0000003D?AT00P0X<UP0
0`000000:39H02PbF002000000<0ooK^0P3D?AT20?ofkP030000003om^h0ooK^00H0ooK^00<0e3dI
0?ofkP3om^h01P3om^h20=@m6@80ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0;0?ofkP030=@m6@3o
m^h0ooK^00@0ooK^0P3D?AT50?ofkP030=@m6@3om^h0ooK^0140ooK^0P3D?AT30?ofkP030=@m6@3o
m^h0ooK^01D0ooK^00@0e3dI0?ofkP3D?AT0e3dI5@3om^h00`3D?AT0ooK^0?ofkP0O0?ofkP030000
003om^h0ooK^03`0ooK^0@3oool003`0ooK^0P00000R0?ofkP0303eIZ`3om^h0ooK^01D0ooK^00<0
?EV[0?ofkP3om^h05@3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0
?EV[0?ofkP3om^h0103om^h0100mFJ/0ooK^03eIZ`0mFJ/50?ofkP80?EV[203om^h00`0mFJ/0ooK^
0?ofkP020?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h01P3om^h203eIZ`@0ooK^
0P00000303eIZ`030?ofkP0mFJ/0?EV[00<000000P0E1P800`0000005@H201D60P02000000<0?EV[
00<0000002H:100V2P@00P0V2P@010000000AQ8804HB2000000203eCV0030000000cA7P0<dAh0080
<dAh00@000000=@m6@3D?AT0e3dI0P00000202PbF0030000000X<UP0:39H00<000000P3D?AT0103o
m^h0e3dI0=@m6@3D?AT2000000@0ooK^0P3D?AT80?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI
0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP060?ofkP80e3dI1@3om^h20=@m6@030?ofkP3D?AT0
ooK^00D0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0
ooK^01D0ooK^00<0e3dI0?ofkP3om^h05@3om^h00`3D?AT0ooK^0?ofkP0P0?ofkP800000?03om^h1
0?ooo`00>`3om^h00`000000ooK^0?ofkP0Q0?ofkP0303eIZ`3om^h0ooK^01D0ooK^00@0?EV[0?of
kP0mFJ/0?EV[503om^h00`0mFJ/0ooK^0?ofkP060?ofkP80?EV[3P3om^h00`0mFJ/0ooK^0?ofkP05
0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/01P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP80?EV[1@3o
m^h00`0mFJ/0ooK^0?ofkP030?ofkP80?EV[203om^h203eIZ`030?ofkP000000ooK^0080?EV[103o
m^h3000000<05@H20`00000402H:100403eIZ`0000009PX402H:108000000`164PP010000000?E>H
03eCV00mDiP200000080<dAh00<000000=@m6@0cA7P00`0cA7P3000000<0:39H0`0000040?ofkP80
e3dI00<0ooK^0000003om^h00P3D?AT80?ofkP80e3dI1@3om^h00`3D?AT0ooK^0?ofkP030?ofkP80
e3dI1@3om^h00`3D?AT0ooK^0?ofkP040?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT01`3om^h00`3D
?AT0ooK^0?ofkP0<0?ofkP80e3dI203om^h00`3D?AT0ooK^0?ofkP0B0?ofkP80e3dI00<0ooK^0=@m
6@3om^h05P3om^h00`3D?AT0ooK^0?ofkP0Q0?ofkP030000003om^h0ooK^03T0ooK^0@3oool003X0
ooK^00<000000?ofkP3om^h08P3om^h00`0mFJ/0ooK^0?ofkP0E0?ofkP0403eIZ`3om^h0ooK^0?of
kP80?EV[4P3om^h00`0mFJ/0ooK^0?ofkP080?ofkP80?EV[2`3om^h00`0mFJ/0ooK^0?ofkP050?of
kP0303eIZ`3om^h0ooK^00<0ooK^0P0mFJ/50?ofkP80?EV[0P3om^h00`0mFJ/0ooK^0?ofkP040?of
kP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h01P3om^h2000000030?ofkP0mFJ/0?EV[
00@0ooK^0P00000501D60P030000000V2P@09PX400@09PX40P0mFJ/2000000D0AQ8800<0000003eC
V00mDiP00`0mDiP200000080e3dI1P0cA7P00`000000:39H02PbF00302PbF0800000103om^h20=@m
6@030?ofkP000000000000P0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP050?of
kP030=@m6@3om^h0ooK^0080e3dI1@3om^h20=@m6@D0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D
?AT0ooK^0?ofkP090?ofkP80e3dI2P3om^h00`3D?AT0ooK^0?ofkP0@0?ofkP80e3dI0`3om^h00`3D
?AT0ooK^0?ofkP0E0?ofkP030=@m6@3om^h0ooK^0280ooK^00<000000?ofkP3om^h0>03om^h10?oo
o`00>@3om^h00`000000ooK^0?ofkP0R0?ofkP0303eIZ`3om^h0ooK^01D0ooK^00<0?EV[0?ofkP3o
m^h0103om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00/0ooK^0P0mFJ/80?ofkP03
03eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP040?ofkP80
?EV[1`3om^h00`0mFJ/0ooK^0?ofkP070?ofkP80?EV[1@3om^h00`000000ooK^03eIZ`0303eIZ`80
ooK^1000000301D60P<000001P0V2P@0100mFJ/0000003eIZ`0mFJ/504HB20030000000mDiP0?E>H
00<0?E>H0P3D?AT00`000000e3dI03=4N00503=4N0<000000`0X<UP400000080ooK^103D?AT00`3o
m^h000000?ofkP040?ofkP80e3dI2@3om^h00`3D?AT0ooK^0?ofkP050?ofkP80e3dI1P3om^h00`3D
?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h01P3om^h20=@m
6@d0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^
01D0ooK^00<0e3dI0?ofkP3om^h08P3om^h00`000000ooK^0?ofkP0g0?ofkP40oooo000h0?ofkP03
0000003om^h0ooK^02<0ooK^0`0mFJ/E0?ofkP0303eIZ`3om^h0ooK^00D0ooK^0P0mFJ/=0?ofkP03
03eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP060?ofkP03
03eIZ`3om^h0ooK^00L0ooK^0P0mFJ/40?ofkP0303eIZ`3om^h0?EV[00H0ooK^00<0?EV[0?ofkP3o
m^h02@3om^h00`0mFJ/0ooK^0?ofkP02000000030?ofkP0mFJ/0ooK^0080ooK^00@0?EV[0?ofkP00
000000000P0E1P80100000005@H201D60P00000202H:10030000000V2P@09PX400<09PX400<00000
03eIZ`0000000P164PP00`0mFJ/0AQ8804HB200204HB20030000000mDiP0?E>H0080?E>H00H0e3dI
03eCV00mDiP000000=@m6@00000503=4N0040000000cA7P0<dAh00000080:39H00<0000002PbF00X
<UP00P0000000`3om^h0e3dI0?ofkP020?ofkP040=@m6@3om^h0000000000080ooK^00<0e3dI0?of
kP3om^h02@3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0e3dI00@0ooK^0P3D?AT90?of
kP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP0>0?of
kP030=@m6@3om^h0ooK^00/0ooK^0P3D?AT70?ofkP030=@m6@3om^h0ooK^01<0ooK^0`3D?ATU0?of
kP030000003om^h0ooK^03H0ooK^0@3oool003L0ooK^00<000000?ofkP3om^h08`3om^h0100mFJ/0
ooK^0?ofkP3om^h203eIZa80ooK^00<0?EV[0?ofkP3om^h0203om^h203eIZ`X0ooK^00<0?EV[0?of
kP3om^h0403om^h203eIZ`@0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP090?of
kP80?EV[00<0ooK^03eIZ`3om^h00P3om^h203eIZ`@0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0m
FJ/000000?ofkP0203eIZ`@0ooK^0`0mFJ/201D60P040000000E1P805@H2000000<09PX400<00000
02H:100V2P@00P0V2P@010000000AQ8803eIZ`00000304HB200503eIZ`164PP0AQ8804HB20000000
0`0mDiP0203D?AT0?E>H03eCV00mDiP000000=@m6@0mDiP00000100cA7P01@000000<dAh03=4N00c
A7P000000080:39H00<0000002PbF00X<UP00`3D?AT40?ofkP80e3dI00<0ooK^0000003D?AT0303o
m^h00`3D?AT0ooK^0?ofkP020?ofkP80e3dI0`3om^h0103D?AT0ooK^0=@m6@3D?AT;0?ofkP030=@m
6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h00P3om^h20=@m6A80ooK^00<0e3dI0?ofkP3om^h0
203om^h20=@m6@X0ooK^00<0e3dI0?ofkP3om^h0403om^h20=@m6@<0ooK^00<0e3dI0?ofkP3om^h0
8`3om^h00`000000ooK^0?ofkP0e0?ofkP40oooo000e0?ofkP8000009P3om^h00`0mFJ/0ooK^0?of
kP030?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h02P3om^h203eIZ`P0ooK^00<0
?EV[0?ofkP3om^h04P3om^h203eIZ`030?ofkP0mFJ/0ooK^00L0ooK^00<0?EV[0?ofkP3om^h0303o
m^h00`0mFJ/0ooK^0?ofkP040?ofkP0403eIZ`3om^h0ooK^03eIZ`d0ooK^00<000000?ofkP0mFJ/0
1@3om^h01P0mFJ/000000000000E1P80?EV[01D60P<000000`0V2P@0100000009PX402H:100V2P@2
00000080AQ8800<0?EV[000000164PP00`164PP203eIZ`0304HB20000000?E>H0080e3dI100mDiP0
10000000e3dI03eCV00mDiP2000000<0<dAh00@0000003=4N00cA7P0<dAh0`0000001P0X<UP0e3dI
02PbF0000000e3dI000000D0ooK^00<0e3dI0?ofkP000000303om^h01@3D?AT0ooK^0?ofkP3om^h0
e3dI00H0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP060?ofkP040=@m6@3om^h0
e3dI0=@m6A@0ooK^00<0e3dI0?ofkP3om^h01P3om^h20=@m6@`0ooK^00<0e3dI0?ofkP3om^h03`3o
m^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^02@0ooK^0P00000e0?ofkP40oooo000d
0?ofkP030000003om^h0ooK^02D0ooK^00<0?EV[0?ofkP3om^h01@3om^h203eIZ`h0ooK^00<0?EV[
0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^01D0ooK^00<0?EV[
0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0403eIZ`3om^h0?EV[03eIZ`D0ooK^0`0m
FJ/;0?ofkP80000000<0ooK^03eIZ`3om^h00P0mFJ/0103om^h000000000000mFJ/401D60P80?EV[
1@0V2P@0100000009PX402H:1000000404HB200303eIZ`000000AQ8800@0AQ8800D0000003eIZ`00
0000e3dI0000000503eCV0030000003D?AT0?E>H00<0?E>H00@0000003=4N00cA7P000001@0cA7P2
0=@m6@@0:39H00@0e3dI000000000000ooK^0P3D?AT00`3om^h0e3dI0?ofkP02000000/0ooK^0`3D
?AT50?ofkP80e3dI00<0ooK^0=@m6@3om^h0303om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3o
m^h0ooK^01D0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3o
m^h0ooK^00`0ooK^0P3D?AT70?ofkP030=@m6@3om^h0ooK^02D0ooK^00<000000?ofkP3om^h0<P3o
m^h10?ooo`00<`3om^h00`000000ooK^0?ofkP0V0?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[
0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP80?EV[0`3om^h00`0mFJ/0ooK^0?ofkP0E
0?ofkP0403eIZ`3om^h0?EV[03eIZ`L0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?of
kP020?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h0203om^h010000000ooK^0?of
kP0mFJ/40?ofkP<0000000@0?EV[01D60P0E1P805@H20`0000000`0mFJ/09PX402H:100202H:10<0
00001@164PP00`0mFJ/0AQ8804HB200304HB20040000001V6`d0IQ/=00000080@ef]00<0000003eC
V00mDiP00`0mDiP00`3D?AT0?E>H03eCV00303eCV0<00000100cA7P0103D?AT00000000000000003
02PbF0040=@m6@0000000000000000@0ooK^00@0e3dI0?ofkP3om^h000002P3om^h00`3D?AT0ooK^
0?ofkP040?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^
0?ofkP050?ofkP80e3dI00<0ooK^0=@m6@3om^h05P3om^h0103D?AT0ooK^0?ofkP3om^h20=@m6A40
ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^02H0
ooK^00<000000?ofkP3om^h0<@3om^h10?ooo`00<P3om^h00`000000ooK^0?ofkP0V0?ofkP0303eI
Z`3om^h0ooK^00T0ooK^0P0mFJ/:0?ofkP0303eIZ`3om^h0ooK^0140ooK^0P0mFJ/00`3om^h0?EV[
0?ofkP0F0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/01@3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP03
03eIZ`3om^h0ooK^00<0ooK^0P0mFJ/40?ofkP<0?EV[1P3om^h200000080ooK^00X0?EV[0?ofkP3o
m^h0ooK^0000003D?AT0000001D60P000000?EV[0P0E1P800`0000009PX40000000202H:1080?EV[
0P0V2P@00`000000AQ8804HB200404HB200303eIZ`000000AQ880080AQ880P00000306HK3@040000
0013GJd0@ef]04=M[@8000000`0mDiP00`000000e3dI03eCV00503eCV0030000000cA7P0<dAh0080
e3dI0P0cA7P00`000000<dAh0000000202PbF0060=@m6@000000:39H0000000mFJ/000000`3om^h0
0`3D?AT0ooK^0?ofkP02000000H0ooK^0`3D?AT40?ofkP80e3dI1@3om^h00`3D?AT0ooK^0?ofkP0;
0?ofkP030=@m6@3om^h0ooK^00<0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0G0?ofkP040=@m6@3o
m^h0e3dI0=@m6A<0ooK^00<0e3dI0?ofkP3om^h0203om^h20=@m6@/0ooK^00<0e3dI0?ofkP3om^h0
9P3om^h00`000000ooK^0?ofkP0`0?ofkP40oooo000a0?ofkP030000003om^h0ooK^02L0ooK^00<0
?EV[0?ofkP3om^h02`3om^h203eIZ`L0ooK^00<0?EV[0?ofkP3om^h0503om^h00`0mFJ/0ooK^0?of
kP0E0?ofkP0303eIZ`3om^h0ooK^00<0ooK^0P0mFJ/30?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0
?EV[0?ofkP3om^h01P3om^h203eIZ`030?ofkP0mFJ/0ooK^0080ooK^00<0?EV[0?ofkP3om^h00P3o
m^h01@000000ooK^0?ofkP3om^h0?EV[00<0ooK^0`00000201D60P0403eIZ`0E1P80000000000080
9PX400<0000002H:100V2P@00P0V2P@00`0mFJ/000000000000604HB200503eIZ`000000AQ8804HB
200000001@1V6`d00`000000@ef]04=M[@0304=M[@050000000mDiP0?E>H0000003D?AT01P0mDiP2
000000030=@m6@0cA7P0<dAh0080<dAh00<0000003=4N00cA7P00P000000103D?AT0000002PbF00X
<UP3000000<0ooK^00D0e3dI0?ofkP3om^h0ooK^000000040?ofkP060=@m6@3om^h0ooK^0?ofkP3D
?AT0ooK^0P3D?AT80?ofkP030=@m6@3om^h0ooK^00X0ooK^00@0e3dI0?ofkP3om^h0ooK^0P3D?AT5
0?ofkP030=@m6@3om^h0ooK^01D0ooK^00<0e3dI0?ofkP3om^h0503om^h00`3D?AT0ooK^0?ofkP05
0?ofkP80e3dI3@3om^h00`3D?AT0ooK^0?ofkP0W0?ofkP030000003om^h0ooK^02l0ooK^0@3oool0
02l0ooK^0P00000Z0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0m
FJ/0ooK^0?ofkP0C0?ofkP0403eIZ`3om^h0?EV[03eIZa@0ooK^00<0?EV[0?ofkP3om^h01P3om^h3
03eIZ``0ooK^00<0?EV[0?ofkP3om^h02@3om^h203eIZ`@0ooK^0P0mFJ/2000000<0ooK^00<0?EV[
0?ofkP3om^h01000000201D60P030000000mFJ/0000000@09PX400H0000002H:100V2P@09PX40000
00164PP203eIZ`H0AQ8800@0?EV[00000000000000001P1V6`d00`000000@ef]04=M[@0404=M[@<0
000000<0e3dI03eCV00mDiP0100mDiP20=@m6@0303eCV0000000<dAh0080<dAh00<0000003=4N00c
A7P00P0cA7P00`000000e3dI0000000202PbF0@000000P3om^h0103D?AT0ooK^0?ofkP3om^h20000
0080e3dI103om^h20=@m6@/0ooK^00<0e3dI0?ofkP3om^h02P3om^h30=@m6@P0ooK^00<0e3dI0?of
kP3om^h04P3om^h30=@m6AH0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP0=0?of
kP030=@m6@3om^h0ooK^02P0ooK^0P00000_0?ofkP40oooo000^0?ofkP030000003om^h0ooK^02T0
ooK^00<0?EV[0?ofkP3om^h03`3om^h203eIZ`<0ooK^00<0?EV[0?ofkP3om^h0503om^h0100mFJ/0
ooK^0?ofkP3om^h203eIZa80ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP090?of
kP0303eIZ`3om^h0ooK^00X0ooK^0`0mFJ/40?ofkP030000000mFJ/0?EV[0080ooK^00H0?EV[0?of
kP3om^h0000001D60P00000401D60P030000000mFJ/09PX400@09PX400@0000002H:100000000000
0`164PP00`000000?EV[04HB200404HB200303eIZ`000000IQ/=00L0IQ/=00<0000004=M[@13GJd0
1P13GJd00`000000e3dI03eCV00403eCV0030=@m6@000000?E>H0080?E>H0P0000000`0cA7P00000
03=4N00403=4N0030=@m6@000000:39H00<0:39H00<0000001XM>@0000000P3om^h00`3D?AT0ooK^
0?ofkP020=@m6@030000003om^h0ooK^0080ooK^0`3D?AT<0?ofkP030=@m6@3om^h0ooK^00T0ooK^
00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP0@0?ofkP80e3dI0`3om^h00`3D?AT0ooK^
0?ofkP0D0?ofkP040=@m6@3om^h0ooK^0?ofkP80e3dI4@3om^h00`3D?AT0ooK^0?ofkP0Y0?ofkP03
0000003om^h0ooK^02`0ooK^0@3oool002d0ooK^00<000000?ofkP3om^h0:P3om^h00`0mFJ/0ooK^
0?ofkP0A0?ofkP80?EV[00<0ooK^03eIZ`3om^h0503om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eI
Z`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h0203om^h0100mFJ/0ooK^03eIZ`0mFJ/80?ofkP03
03eIZ`3om^h0ooK^00/0ooK^00@0?EV[0?ofkP3om^h0?EV[0P3om^h010000000ooK^0?ofkP3om^h2
03eIZ`040?ofkP00000000000=@m6@8000000`0E1P820000000303eIZ`0V2P@09PX400809PX40`00
000504HB2004000000164PP0?EV[03eIZ`<0AQ8800<0?EV[0000001V6`d01`1V6`d00`000000@ef]
04=M[@0604=M[@030000003D?AT0?E>H0080?E>H0P3D?AT00`0mDiP0000003eCV00403eCV0<00000
100cA7P00`3D?AT000000000000302PbF080000000@0?EV[000000000000ooK^0P3D?AT30?ofkP04
0000003om^h0ooK^0=@m6@80ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP060?of
kP80e3dI00<0ooK^0=@m6@3om^h02@3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^
00<0ooK^00<0e3dI0?ofkP3om^h0503om^h0103D?AT0ooK^0=@m6@3D?ATC0?ofkP030=@m6@3om^h0
ooK^02X0ooK^00<000000?ofkP3om^h0:`3om^h10?ooo`00;03om^h00`000000ooK^0?ofkP0Z0?of
kP0303eIZ`3om^h0ooK^01@0ooK^00<0?EV[0?ofkP3om^h0503om^h00`0mFJ/0ooK^0?ofkP050?of
kP80?EV[3@3om^h00`0mFJ/0ooK^0?ofkP090?ofkP0403eIZ`3om^h0ooK^0?ofkP80?EV[1@3om^h0
0`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^0080ooK^0P0000040?ofkP<0?EV[00@00000
0=@m6@00000000000`0E1P820000000303eIZ`0V2P@09PX400<09PX400<0000004HB20164PP01@16
4PP01@000000AQ8804HB20164PP0?EV[0080000000<0?EV[0000001V6`d01`1V6`d00`000000@ef]
04=M[@0604=M[@050000003D?AT000000000003D?AT00`0mDiP00`000000?E>H03eCV00503eCV003
0000000cA7P0<dAh0080<dAh00@0e3dI0000000cA7P000000`0X<UP20000000303eIZ`000000e3dI
0080e3dI103om^h2000000@0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP030?of
kP80e3dI0`3om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^00/0ooK^0P3D?AT70?of
kP030=@m6@3om^h0ooK^01@0ooK^00<0e3dI0?ofkP3om^h0503om^h00`3D?AT0ooK^0?ofkP0Z0?of
kP030000003om^h0ooK^02X0ooK^0@3oool002/0ooK^00<000000?ofkP3om^h0:`3om^h00`0mFJ/0
ooK^0?ofkP0D0?ofkP<0?EV[4`3om^h00`0mFJ/0ooK^0?ofkP080?ofkP80?EV[2P3om^h00`0mFJ/0
ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^00<0ooK^0P0mFJ/40?ofkP0303eIZ`3om^h0ooK^00/0
ooK^00D0?EV[0?ofkP3om^h0ooK^000000020?ofkP80?EV[00X0ooK^03eIZ`000000000001D60P0m
FJ/0000001D60P0000005@H20P0000000`0V2P@0000003eIZ`0402H:108000001`164PP01@000000
AQ8804HB20164PP0000000<0?EV[00<0000006HK3@1V6`d01P1V6`d00`000000@ef]04=M[@0604=M
[@050000003D?AT0e3dI0=@m6@0000000`0mDiP00`000000?E>H03eCV00503eCV0800000100cA7P0
0`3D?AT0000003=4N0020000000602PbF0000000:39H0000003D?AT06Qdi0P000000103D?AT0ooK^
0=@m6@3D?AT20?ofkP050000003om^h0ooK^0?ofkP3D?AT03@3om^h00`3D?AT0ooK^0?ofkP020?of
kP80e3dI1@3om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^00P0ooK^0P3D?AT90?of
kP030=@m6@3om^h0ooK^0180ooK^0`3D?ATF0?ofkP030=@m6@3om^h0ooK^02/0ooK^00<000000?of
kP3om^h0:@3om^h10?ooo`00:@3om^h2000002d0ooK^00<0?EV[0?ofkP3om^h0503om^h0100mFJ/0
ooK^0?ofkP3om^h203eIZa40ooK^00<0?EV[0?ofkP3om^h02P3om^h203eIZ`P0ooK^00<0?EV[0?of
kP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP050?ofkP80?EV[00<0ooK^03eIZ`3om^h0303om^h00`0m
FJ/0ooK^0?ofkP02000000D0ooK^00H0?EV[0000003D?AT05@H20000000E1P8203eIZ`8000000`0V
2P@010000000?EV[02H:100V2P@20000000304HB20000000AQ8800H0AQ8800@0000004HB20164PP0
00000`1V6`d00`0mFJ/0000006HK3@0706HK3@0300000013GJd0@ef]00H0@ef]00<000000=@m6@13
GJd00P13GJd010000000?E>H03eCV000000703eCV0040000000mDiP0000000000080<dAh00<0e3dI
0000000cA7P00P0cA7P200000080e3dI00H0:39H0000000J7CT0?EV[0000003D?AT50?ofkP800000
00<0ooK^0=@m6@3om^h03@3om^h0103D?AT0ooK^0=@m6@3D?AT70?ofkP030=@m6@3om^h0ooK^00T0
ooK^00<0e3dI0?ofkP3om^h01P3om^h20=@m6@`0ooK^00<0e3dI0?ofkP3om^h03`3om^h20=@m6@<0
ooK^00<0e3dI0?ofkP3om^h0503om^h00`3D?AT0ooK^0?ofkP0[0?ofkP800000:@3om^h10?ooo`00
:03om^h00`000000ooK^0?ofkP0]0?ofkP0303eIZ`3om^h0ooK^01@0ooK^00<0?EV[0?ofkP3om^h0
0`3om^h203eIZ`h0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eI
Z`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h0203om^h203eIZ`d0ooK^00<0?EV[0?ofkP000000
1P3om^h01@0mFJ/0000001D60P0E1P80000000<05@H200<0000003eIZ`0mFJ/00`0V2P@010000000
?EV[02H:1000000304HB2003000000164PP0AQ8800D0AQ880`00000406HK3@<0?EV[1`1V6`d00`00
0000@ef]04=M[@0504=M[@<0e3dI1013GJd3000000L0?E>H00P0000003eCV00mDiP0?E>H0000000c
A7P0e3dI000000<0<dAh0P3D?AT01@000000:39H02PbF00X<UP0000000806Qdi00<000000=@m6@3o
m^h01@3om^h00`000000ooK^0=@m6@0=0?ofkP80e3dI2P3om^h00`3D?AT0ooK^0?ofkP090?ofkP03
0=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP0=0?ofkP80
e3dI1@3om^h00`3D?AT0ooK^0?ofkP0D0?ofkP030=@m6@3om^h0ooK^02d0ooK^00<000000?ofkP3o
m^h09P3om^h10?ooo`009`3om^h00`000000ooK^0?ofkP0^0?ofkP<0?EV[4`3om^h00`0mFJ/0ooK^
0?ofkP060?ofkP80?EV[303om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP80?EV[0`3om^h00`0mFJ/0ooK^
0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00L0ooK^00@0?EV[0?ofkP0mFJ/0?EV[303om^h2000000H0
ooK^00<0?EV[0000000E1P800P00000401D60P090000000V2P@09PX403eIZ`0V2P@0000003eIZ`0V
2P@0000000@0AQ8800<0000004HB20164PP01@164PP00`000000IQ/=06HK3@0306HK3@0403eIZ`1V
6`d0000006HK3@80?EV[0`1V6`d5000000<0@ef]0P3D?AT01013GJd0000004=M[@3D?AT504=M[@03
0000000mDiP0?E>H00D0?E>H00<0000003eCV00mDiP00P0mDiP00`000000e3dI0000000203=4N004
0=@m6@0cA7P0<dAh000000@0:39H0P0000000`0J7CT000000=@m6@060?ofkP800000303om^h20=@m
6@030?ofkP3D?AT0ooK^00P0ooK^00<0e3dI0?ofkP3om^h02P3om^h0103D?AT0ooK^0?ofkP3om^h2
0=@m6A00ooK^00<0e3dI0?ofkP3om^h02P3om^h20=@m6@P0ooK^00<0e3dI0?ofkP3om^h04@3om^h3
0=@m6C00ooK^00<000000?ofkP3om^h09@3om^h10?ooo`009P3om^h00`000000ooK^0?ofkP0^0?of
kP0403eIZ`3om^h0ooK^0?ofkP80?EV[4@3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0
ooK^00P0ooK^00<0?EV[0?ofkP3om^h04@3om^h203eIZ`030?ofkP0mFJ/0ooK^00X0ooK^00<0?EV[
0?ofkP3om^h0203om^h0100mFJ/0ooK^0?ofkP3om^h203eIZ`T0ooK^00<000000?ofkP3om^h01@3o
m^h40000000401D60P0000005@H201D60P<000000`0V2P@303eIZ`03000000164PP0AQ8800<0AQ88
00<0000004HB20164PP00`164PP00`000000e3dI0000000506HK3@0303eIZ`1V6`d0000000<0IQ/=
00<0?EV[06HK3@0000000P2291001P000000AfBl04MT_0000000@ef]0=@m6@<0@ef]00<0000004=M
[@3D?AT01@13GJd00`000000?EV[0000000503eCV0030000000mDiP0?E>H00<0?E>H00@000000=@m
6@3D?AT0e3dI0`0cA7P300000080:39H00<0000002PbF00000000`0000070?ofkP030000003om^h0
ooK^00L0ooK^0P3D?AT30?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h02@3om^h0
103D?AT0ooK^0=@m6@3D?ATB0?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h0203o
m^h00`3D?AT0ooK^0?ofkP0?0?ofkP80e3dI0`3om^h00`3D?AT0ooK^0?ofkP0^0?ofkP030000003o
m^h0ooK^02@0ooK^0@3oool002H0ooK^0`00000^0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[
0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP80?EV[203om^h00`0mFJ/0ooK^0?ofkP0C
0?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP03
0?ofkP<0?EV[1P3om^h00`000000?EV[0?ofkP050?ofkP<000000P0E1P801P0000005@H201D60P00
00009PX4000000D09PX400<0000003eIZ`164PP01@164PP00`000000AQ8804HB200204HB20040000
001V6`d0IQ/=000000D0IQ/=00<0?EV[06HK3@0000000`1V6`d00`000000?EV[03eIZ`02088T4003
00000017I;`0AfBl0080e3dI00L0000004=M[@13GJd0@ef]00000013GJd0e3dI00D0@ef]00@00000
04=M[@13GJd00000100mDiP00`000000?E>H03eCV00403eCV0030=@m6@000000<dAh00@0<dAh00<0
000003=4N00000000P0X<UP00`000000:39H02PbF003000000H0ooK^00<0e3dI0000003om^h01@3o
m^h30=@m6@D0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3o
m^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h01P3om^h20=@m6@`0ooK^00<0e3dI0?ofkP3om^h03@3o
m^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^02`0ooK^0`00000V0?ofkP40oooo000V
0?ofkP030000003om^h0ooK^00800000;03om^h00`0mFJ/0ooK^0?ofkP040?ofkP80?EV[3@3om^h0
0`0mFJ/0ooK^0?ofkP0<0?ofkP80?EV[1@3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0403eIZ`3om^h0
?EV[03eIZ`T0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP060?ofkP80?EV[0`3o
m^h20000000303eIZ`3om^h0ooK^00@0ooK^00<05@H20000000E1P800P0E1P80100000005@H20000
0000000202H:10040000000V2P@09PX402H:10<000000`0mFJ/404HB2003000000164PP0AQ880080
00000`1V6`d00`000000IQ/=06HK3@0306HK3@0303eIZ`1V6`d000000080IQ/=00@00000088T4022
9100PR@@0P0mFJ/00`000000e3dI0=@m6@0304MT_00600000013GJd0@ef]00000013GJd0e3dI1@13
GJd010000000@ef]04=M[@13GJd200000080?E>H00<0000003eCV00mDiP00P0mDiP30=@m6@<00000
0`0cA7P00`000000<dAh03=4N0020000000302PbF0000000:39H0080:39H0P0000060?ofkP030=@m
6@000000000000<0ooK^0P3D?AT80?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h0
1`3om^h20=@m6@030?ofkP3D?AT0ooK^01<0ooK^00<0e3dI0?ofkP3om^h0103om^h20=@m6@h0ooK^
00<0e3dI0?ofkP3om^h02`3om^h20=@m6@H0ooK^00<0e3dI0?ofkP3om^h0:P3om^h200000080ooK^
00<000000?ofkP3om^h0903om^h10?ooo`009@3om^h00`000000ooK^0?ofkP030?ofkP800000:@3o
m^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h03P3o
m^h203eIZ`<0ooK^00<0?EV[0?ofkP3om^h04`3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00P0ooK^
00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP070?ofkP<0?EV[00@000000?ofkP3om^h0
?EV[103om^h3000000@05@H20P00000402H:10040000000V2P@09PX400000080AQ8800@0?EV[04HB
20164PP0AQ880P0mFJ/204HB20<000001@1V6`d00`000000IQ/=06HK3@0206HK3@0303eIZ`1V6`d0
IQ/=00<000001P2291000`3D?AT0AfBl04MT_00404MT_0<000000P13GJd00`3D?AT0@ef]04=M[@02
04=M[@0300000013GJd0@ef]00<0@ef]0`00000203eCV080e3dI0`0mDiP0103D?AT0?E>H03eCV000
000203=4N0030000000cA7P0<dAh0080<dAh0P00000402PbF0<00000103om^h0103D?AT0ooK^0?of
kP0000030=@m6@T0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP060?ofkP050=@m
6@3om^h0ooK^0?ofkP3D?AT05@3om^h0103D?AT0ooK^0?ofkP3om^h20=@m6A00ooK^00<0e3dI0?of
kP3om^h02P3om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^02L0ooK^0P0000050?of
kP030000003om^h0ooK^02<0ooK^0@3oool002D0ooK^00<000000?ofkP3om^h01@3om^h2000002L0
ooK^00<0?EV[0?ofkP3om^h0203om^h203eIZ`T0ooK^00<0?EV[0?ofkP3om^h04@3om^h303eIZaD0
ooK^00<0?EV[0?ofkP3om^h00`3om^h203eIZ`D0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0
ooK^0?ofkP090?ofkP8000000`0mFJ/40?ofkP80000000<05@H20000000E1P800P0E1P800`000000
9PX402H:100402H:10030000000V2P@0000000<0AQ8800<0?EV[04HB20164PP00`164PP00`0mFJ/0
AQ880000000706HK3@030000001V6`d0IQ/=0080IQ/=00@0?EV[06HK3@1V6`d00000202291000`00
0000AfBl04MT_00604MT_00400000013GJd0@ef]0=@m6@@0@ef]00<0000004=M[@13GJd01@13GJd0
0`000000?E>H0=@m6@0503eCV0070=@m6@0mDiP0?E>H03eCV0000000<dAh0000000603=4N0060000
000X<UP0:39H02PbF0000000:39H0P0000040?ofkP<0e3dI0P00000;0?ofkP030=@m6@3om^h0ooK^
00L0ooK^00<0e3dI0?ofkP3om^h00`3om^h20=@m6@D0ooK^00<0e3dI0?ofkP3om^h04P3om^h0103D
?AT0ooK^0=@m6@3D?ATC0?ofkP030=@m6@3om^h0ooK^00L0ooK^0P3D?AT:0?ofkP030=@m6@3om^h0
ooK^02D0ooK^0P0000070?ofkP030000003om^h0ooK^02<0ooK^0@3oool002D0ooK^00<000000?of
kP3om^h01`3om^h2000002D0ooK^00<0?EV[0?ofkP3om^h02P3om^h203eIZ`L0ooK^00<0?EV[0?of
kP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^00D0ooK^0P0mFJ/30?of
kP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h02@3om^h010000000ooK^0?ofkP3om^h2
03eIZ`80ooK^0`000000100E1P80000001D60P0E1P83000000D09PX40`00000304HB200303eIZ`00
0000AQ8800D0AQ880P0mFJ/706HK3@030000001V6`d0IQ/=0080IQ/=00@0?EV[06HK3@0000000000
202291000`000000AfBl04MT_00604MT_080000000<0@ef]0=@m6@13GJd00`13GJd00`000000@ef]
04=M[@0504=M[@80e3dI1P0mDiP00`000000e3dI03eCV00203eCV0<000001@0cA7P300000080:39H
00<0000002PbF00000000P0000020?ofkP80e3dI0`3om^h00`000000ooK^0?ofkP090?ofkP030=@m
6@3om^h0ooK^00H0ooK^00@0e3dI0?ofkP3om^h0ooK^0P3D?AT70?ofkP030=@m6@3om^h0ooK^01<0
ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP050?ofkP80e3dI303om^h00`3D?AT0
ooK^0?ofkP0S0?ofkP8000002@3om^h00`000000ooK^0?ofkP0S0?ofkP40oooo000U0?ofkP030000
003om^h0ooK^00T0ooK^00<000000?ofkP3om^h08@3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eI
Z`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h04`3om^h0100mFJ/0ooK^03eIZ`0mFJ/B0?ofkP03
03eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP0mFJ/0203om^h00`0mFJ/0ooK^0?ofkP080?ofkP80
0000103om^h403eIZ`8000000P0E1P801@0000005@H20000000V2P@0000000H09PX400<0000004HB
20164PP00`164PP00`0mFJ/0000004HB200304HB2080000000<0e3dI0000000mFJ/01P1V6`d00`00
0000IQ/=06HK3@0206HK3@0403eIZ`000000PR@@000000P0PR@@00<0000004MT_017I;`01P17I;`0
10000000AfBl0000003D?AT404=M[@0300000013GJd0@ef]00@0@ef]00<0e3dI0000000mFJ/00P00
000403eCV0030000003D?AT0?E>H00@0?E>H00<0000003=4N00cA7P0100cA7P01@000000<dAh0000
000X<UP000000080:39H0P0000040=@m6@@0ooK^0P00000:0?ofkP030=@m6@3om^h0ooK^00H0ooK^
00<0e3dI0?ofkP3D?AT02P3om^h00`3D?AT0ooK^0?ofkP0@0?ofkP<0e3dI5P3om^h00`3D?AT0ooK^
0?ofkP030?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h08@3om^h00`000000ooK^
0?ofkP090?ofkP030000003om^h0ooK^02<0ooK^0@3oool002@0ooK^00<000000?ofkP3om^h02`3o
m^h200000240ooK^00<0?EV[0?ofkP3om^h03P3om^h203eIZ`<0ooK^00<0?EV[0?ofkP3om^h04`3o
m^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[0140ooK^00<0?EV[0?ofkP3om^h02@3om^h203eIZ`P0ooK^
00<0?EV[0?ofkP3om^h01`3om^h00`000000ooK^0?ofkP040?ofkP0503eIZ`000000e3dI0000000m
FJ/00P0E1P800`0000005@H20000000202H:10030000000V2P@09PX400809PX40`00000404HB2003
03eIZ`164PP0000000<0AQ8800H0000006HK3@1V6`d0IQ/=0000001V6`d203eIZ`@0IQ/=00D00000
06HK3@1V6`d0IQ/=03eIZ`03088T4003000000229100PR@@00H0PR@@00<0000004MT_017I;`01P17
I;`01@000000AfBl04MT_017I;`0e3dI00<0@ef]00<0000004=M[@13GJd00P13GJd20=@m6@0304=M
[@000000@ef]0080@ef]00L0000003eCV00mDiP0?E>H0000000mDiP0e3dI00@0?E>H0`00000403=4
N0060000000cA7P0<dAh0000000X<UP000000P0X<UP01@3D?AT0000003eIZ`000000e3dI00H0ooK^
00<000000?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP060?ofkP80e3dI2`3om^h00`3D?AT0ooK^
0?ofkP0?0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT05@3om^h0103D?AT0ooK^0?ofkP3om^h20=@m
6A00ooK^00<0e3dI0?ofkP3om^h07`3om^h2000000d0ooK^00<000000?ofkP3om^h08P3om^h10?oo
o`00903om^h00`000000ooK^0?ofkP0=0?ofkP8000007`3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP<0
?EV[5@3om^h00`0mFJ/0ooK^0?ofkP030?ofkP80?EV[3P3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP03
03eIZ`3om^h0?EV[00H0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`000000ooK^0?ofkP040?ofkP04
03eIZ`0000000000000000805@H20P0mFJ/2000000<09PX400D0000002H:100V2P@09PX400000002
04HB2003000000164PP0AQ880080AQ8800<0?EV[04HB200000000P164PP00`000000IQ/=06HK3@02
06HK3@040000001V6`d0IQ/=06HK3@80?EV[0P1V6`d01@000000IQ/=06HK3@000000?EV[00<0PR@@
00<00000088T402291001P2291000`000000AfBl04MT_00604MT_00600000017I;`0AfBl04MT_03D
?AT000000P13GJd00`000000@ef]04=M[@020=@m6@<0@ef]00<0000004=M[@13GJd00P13GJd01P00
0000?E>H03eCV0000000?E>H0=@m6@@0?E>H00@0000003eCV00mDiP000000`0cA7P010000000<dAh
03=4N00cA7P200000080e3dI0P0X<UP3000000030=@m6@3om^h0ooK^00@0ooK^00<000000?ofkP3o
m^h01`3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0e3dI00`0ooK^00<0e3dI0?ofkP3o
m^h0303om^h20=@m6@@0ooK^00<0e3dI0?ofkP3om^h0503om^h30=@m6A80ooK^00<0e3dI0?ofkP3o
m^h07@3om^h2000000l0ooK^00<000000?ofkP3om^h08P3om^h10?ooo`00903om^h00`000000ooK^
0?ofkP0?0?ofkP800000703om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^01<0ooK^
00<0?EV[0?ofkP3om^h01@3om^h203eIZ`/0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^
0?ofkP0203eIZ`<0ooK^00<0?EV[0?ofkP3om^h01P3om^h2000000H0ooK^00D0000003eIZ`000000
5@H20000000301D60P030000000mFJ/0?EV[00<09PX400@0000002H:1000000000000`164PP01@00
0000AQ8804HB20164PP0?EV[0080AQ880`00000506HK3@030000001V6`d0IQ/=00<0IQ/=00<0?EV[
06HK3@0000000P0000000`229100?EV[088T4002088T4003000000229100PR@@00H0PR@@00<00000
04MT_017I;`01P17I;`01P000000AfBl04MT_017I;`0e3dI04MT_0<0000000<0@ef]0=@m6@13GJd0
1013GJd00`000000@ef]04=M[@0304=M[@<0000000<0?E>H0=@m6@0mDiP00`0mDiP010000000?E>H
03eCV00mDiP20000000303=4N0000000<dAh0080<dAh0P3D?AT02@000000:39H02PbF00X<UP00000
02PbF0000000e3dI000000060?ofkP800000203om^h0103D?AT0ooK^0?ofkP3om^h20=@m6@80ooK^
00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP090?ofkP80e3dI1`3om^h00`3D?AT0ooK^
0?ofkP0C0?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h06P3om^h200000140ooK^
00<000000?ofkP3om^h08P3om^h10?ooo`00903om^h00`000000ooK^0?ofkP0A0?ofkP8000006P3o
m^h00`0mFJ/0ooK^0?ofkP0C0?ofkP<0?EV[4P3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3o
m^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP80?EV[00<0
ooK^03eIZ`3om^h01P3om^h00`000000ooK^0?ofkP050?ofkP050000000mFJ/0000001D60P000000
0P0E1P83000000809PX400<0?EV[02H:100000000P00000504HB2005000000164PP0AQ8804HB200m
FJ/00P164PP00`000000IQ/=06HK3@0506HK3@030000001V6`d0IQ/=00@0IQ/=0P0mFJ/3088T4005
03eIZ`229100PR@@088T40000000202291000`000000AfBl04MT_00604MT_00500000017I;`0AfBl
04MT_03D?AT00`17I;`20=@m6@H0@ef]00<0000004=M[@13GJd01@13GJd010000000?E>H03eCV03D
?AT303eCV0030000000mDiP0?E>H00<0?E>H0`000000100cA7P0e3dI03=4N00cA7P300000080:39H
00D0000002PbF0000000e3dI000000070?ofkP030000003om^h0ooK^00D0ooK^00@0e3dI0?ofkP3D
?AT0e3dI1@3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?of
kP3om^h01`3om^h00`3D?AT0ooK^0?ofkP0A0?ofkP<0e3dI5@3om^h00`3D?AT0ooK^0?ofkP0H0?of
kP8000004`3om^h00`000000ooK^0?ofkP0R0?ofkP40oooo000T0?ofkP030000003om^h0ooK^01<0
ooK^0P00000H0?ofkP0303eIZ`3om^h0ooK^0180ooK^00@0?EV[0?ofkP3om^h0ooK^0P0mFJ/@0?of
kP0303eIZ`3om^h0ooK^00T0ooK^0P0mFJ/70?ofkP0303eIZ`3om^h0ooK^00X0ooK^00@0?EV[0?of
kP0mFJ/0?EV[1@3om^h00`0mFJ/0ooK^0?ofkP040?ofkP8000001P3om^h30000000803eIZ`0E1P80
5@H20000000E1P80000002H:1000000402H:1080?EV[1P164PP00`000000AQ8804HB200204HB2004
03eIZ`000000e3dI000000L0IQ/=00<0000006HK3@1V6`d00`1V6`d3000000<0?EV[1@2291000`00
0000PR@@088T4005088T400300000017I;`0AfBl00D0AfBl00<0000004MT_017I;`00`17I;`30=@m
6@<000001@13GJd00`000000@ef]04=M[@0504=M[@040000000mFJ/000000=@m6@@0?E>H00<00000
03eCV00mDiP0100mDiP20=@m6@@0<dAh00D0000003=4N0000000:39H0000000202PbF0040=@m6@00
00000000000000H0ooK^0P0000060?ofkP030=@m6@3om^h0ooK^00<0ooK^0P3D?AT00`3om^h0e3dI
0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00D0ooK^0P3D?AT;0?ofkP030=@m6@3om^h0ooK^00h0ooK^
0P3D?AT30?ofkP030=@m6@3om^h0ooK^0180ooK^00<0e3dI0?ofkP3om^h05P3om^h2000001D0ooK^
00<000000?ofkP3om^h08P3om^h10?ooo`008`3om^h00`000000ooK^0?ofkP0F0?ofkP030000003o
m^h0ooK^01@0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3o
m^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3o
m^h0ooK^00X0ooK^00@0?EV[0?ofkP3om^h0ooK^0P0mFJ/20?ofkP0403eIZ`3om^h0?EV[03eIZ`<0
ooK^00<000000?ofkP3om^h01@3om^h30000000603eIZ`0E1P805@H20000000E1P8000000P0V2P@0
0`0000009PX402H:100202H:1080000000<0?EV[04HB20164PP00`164PP01P000000AQ8804HB2016
4PP0?EV[00000080IQ/=00<0000006HK3@1V6`d01@1V6`d00`000000IQ/=06HK3@0206HK3@040000
00229100PR@@00000080PR@@00<0?EV[088T402291000`2291000`000000PR@@088T4004088T40<0
00001P17I;`00`000000AfBl04MT_00304MT_0040=@m6@17I;`0AfBl00000080AfBl00<0000004=M
[@13GJd00P13GJd00`000000@ef]04=M[@0504=M[@0500000013GJd0@ef]0000003D?AT00`0mDiP0
0`000000?E>H03eCV00303eCV0030=@m6@000000000000@0<dAh00H0000003=4N00cA7P0000002Pb
F000000202PbF0040=@m6@0000000000000000L0ooK^00@000000?ofkP3om^h0ooK^0P3D?AT0103o
m^h0e3dI0?ofkP3om^h20=@m6@<0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP04
0?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP03
0?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h0503om^h00`000000ooK^0?ofkP0F
0?ofkP030000003om^h0ooK^0240ooK^0@3oool002<0ooK^00<000000?ofkP3om^h05`3om^h20000
01@0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP040?ofkP80?EV[303om^h00`0m
FJ/0ooK^0?ofkP0=0?ofkP80?EV[0`3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^
00@0ooK^00<0?EV[0?ofkP0mFJ/00`3om^h00`0mFJ/00000000000060?ofkP<0000000<05@H20000
000mFJ/00P0E1P82000000809PX400@0000002H:100V2P@09PX40P0000000`164PP0000004HB2002
03eIZ`<0AQ8800D0000004HB20164PP0000003eIZ`0306HK3@030000001V6`d0IQ/=00D0IQ/=00<0
000006HK3@1V6`d00P000003088T4003000000229100PR@@00<0?EV[0`2291000`000000PR@@088T
4002088T4080000000<0VB/C0000001:JLL00P00000404MT_00400000017I;`0AfBl04MT_0<0e3dI
0P17I;`010000000AfBl04MT_017I;`200000080@ef]00<0000004=M[@13GJd01@13GJd01P000000
@ef]04=M[@13GJd0e3dI00000080?E>H00@0000003eCV00mDiP0?E>H0P3D?AT00`0mDiP0000003eC
V00200000080<dAh00@0000003=4N00cA7P0<dAh0P00000202PbF0030=@m6@000000:39H00<00000
1P3om^h2000000070=@m6@3om^h0ooK^0?ofkP3D?AT0ooK^0=@m6@060?ofkP030=@m6@3om^h0ooK^
00X0ooK^00@0e3dI0?ofkP3om^h0ooK^0P3D?AT?0?ofkP030=@m6@3om^h0ooK^00X0ooK^0P3D?AT6
0?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h04P3om^h2000001T0ooK^00<00000
0?ofkP3om^h08@3om^h10?ooo`008`3om^h00`000000ooK^0?ofkP0I0?ofkP8000004P3om^h303eI
Za80ooK^00<0?EV[0?ofkP3om^h01`3om^h203eIZ`T0ooK^00<0?EV[0?ofkP3om^h0403om^h203eI
Z`030?ofkP0mFJ/0ooK^00X0ooK^00<0?EV[0?ofkP3om^h01P3om^h203eIZ`<0ooK^00@000000?of
kP0mFJ/0?EV[103om^h30000000301D60P000000?EV[00805@H200<0000002H:100V2P@00P0V2P@0
100000009PX402H:1000000304HB2004000000164PP0AQ8804HB2080?EV[00D0AQ88000000000000
000003eIZ`0406HK3@030000001V6`d0IQ/=00D0IQ/=0`000005088T4003000000229100?EV[00<0
PR@@0P0mFJ/00`2291000000088T4002088T40050000002I:a<0VB/C09T[4`0000000`1:JLL01P00
0000AfBl04MT_017I;`0000004MT_080e3dI0`17I;`00`3D?AT0AfBl0000000504MT_0<000001`13
GJd00`000000@ef]04=M[@0204=M[@050=@m6@00000000000000000mDiP00P3D?AT303eCV0050000
000mDiP0?E>H03eCV00000000P0cA7P00`000000<dAh03=4N00203=4N0060000000X<UP0:39H0=@m
6@000000:39H0`0000040?ofkP80e3dI00<0ooK^0000003om^h00P3om^h20=@m6@P0ooK^00<0e3dI
0?ofkP3om^h02@3om^h0103D?AT0ooK^0=@m6@3D?ATA0?ofkP030=@m6@3om^h0ooK^00P0ooK^0P3D
?AT90?ofkP030=@m6@3om^h0ooK^0100ooK^0`3D?ATB0?ofkP8000006`3om^h00`000000ooK^0?of
kP0Q0?ofkP40oooo000S0?ofkP030000003om^h0ooK^01/0ooK^0P00000@0?ofkP0303eIZ`3om^h0
ooK^0080?EV[403om^h00`0mFJ/0ooK^0?ofkP090?ofkP80?EV[1`3om^h00`0mFJ/0ooK^0?ofkP0B
0?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h01P3om^h01@0mFJ/0ooK^03eIZ`0m
FJ/0000000@0ooK^0P0mFJ/0203om^h000000000000000005@H20000000E1P80?EV[0`00000402H:
10030000000V2P@0000000@0AQ8800<0000004HB20164PP00`164PP01@0mFJ/0000006HK3@1V6`d0
?EV[00@0IQ/=00<0000006HK3@1V6`d01@1V6`d00`000000PR@@088T4005088T4003000000229100
?EV[00D0PR@@00D0?EV[000000229100PR@@0000000409T[4`030000001:JLL0BVW70080BVW700D0
000004MT_017I;`000000=@m6@0504MT_0030=@m6@17I;`0000000L0AfBl00<0000004=M[@13GJd0
1@13GJd00`000000@ef]04=M[@0204=M[@050=@m6@13GJd0@ef]0000003D?AT01@0mDiP00`000000
?E>H03eCV00203eCV0030000000cA7P0000000@0<dAh0`000000103D?AT0:39H0000000X<UP30000
00030?ofkP3D?AT0e3dI00@0ooK^00D000000=@m6@3D?AT0ooK^0=@m6@080?ofkP030=@m6@3om^h0
ooK^00X0ooK^00<0e3dI0?ofkP3om^h04P3om^h00`3D?AT0ooK^0?ofkP050?ofkP80e3dI2`3om^h0
0`3D?AT0ooK^0?ofkP0>0?ofkP80e3dI0P3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP8000007@3om^h0
0`000000ooK^0?ofkP0Q0?ofkP40oooo000R0?ofkP030000003om^h0ooK^01h0ooK^0P00000=0?of
kP0303eIZ`3om^h0ooK^00<0ooK^0P0mFJ/=0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?of
kP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP<0?EV[2@3om^h00`0mFJ/0ooK^0?ofkP060?of
kP0303eIZ`3om^h0ooK^0080000000<0?EV[0?ofkP3om^h00`3om^h00`000000e3dI0000000201D6
0P060000000E1P80?EV[0000000V2P@00000100V2P@3000000@0AQ8800<0000004HB20164PP01016
4PP0103D?AT0?EV[03eIZ`0mFJ/506HK3@030000001V6`d0IQ/=00@0IQ/=0P000007088T40030000
000mFJ/0PR@@00H0PR@@0P0mFJ/00`000000VB/C09T[4`0309T[4`030000001:JLL0BVW700<0BVW7
00<000000=@m6@3D?AT01`17I;`00`3D?AT0AfBl04MT_00604MT_08000001P13GJd00`000000@ef]
04=M[@0304=M[@<0e3dI00<0?EV[03eCV00mDiP00`0mDiP00`000000?E>H03eCV00303eCV0<00000
100cA7P01P000000<dAh0000003D?AT0:39H00000080:39H00<0000003eIZ`0000001@3om^h00`3D
?AT00000000000020?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h01`3om^h30=@m
6A@0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^
00`0ooK^0P3D?AT50?ofkP030=@m6@3om^h0ooK^00/0ooK^0P00000O0?ofkP030000003om^h0ooK^
0240ooK^0@3oool00280ooK^00<000000?ofkP3om^h0803om^h2000000/0ooK^00<0?EV[0?ofkP3o
m^h01@3om^h203eIZ`/0ooK^00<0?EV[0?ofkP3om^h03@3om^h203eIZ`<0ooK^00<0?EV[0?ofkP3o
m^h04P3om^h0100mFJ/0ooK^0?ofkP3om^h203eIZ`H0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0m
FJ/0ooK^000000030?ofkP80?EV[0P3om^h3000000<05@H20P000000100mFJ/09PX402H:10000004
02H:1003000000164PP0AQ8800@0AQ8800<0000004HB20164PP00P164PP20000000406HK3@000000
IQ/=03eIZ`D0IQ/=00<0000006HK3@1V6`d00P1V6`d200000003088T40000000PR@@00L0PR@@00<0
?EV[088T402291001@2291000`000000VB/C03eIZ`0509T[4`030000001:JLL0BVW700<0BVW700<0
e3dI04YYa`0000001`17I;`00`3D?AT0AfBl04MT_00604MT_00400000017I;`00000000000@0@ef]
00<0000004=M[@13GJd00`13GJd0103D?AT0@ef]00000013GJd2000000@0?E>H00<0000003eCV00m
DiP0100mDiP00`000000<dAh03=4N00203=4N0040000000cA7P0<dAh0=@m6@8000000`0X<UP30000
0080ooK^0P3D?AT30?ofkP030000003om^h0e3dI00T0ooK^00<0e3dI0?ofkP3om^h0103om^h20=@m
6@<0ooK^00<0e3dI0?ofkP3om^h04P3om^h0103D?AT0ooK^0?ofkP3om^h20=@m6@l0ooK^00<0e3dI
0?ofkP3om^h02@3om^h20=@m6@L0ooK^00<0e3dI0?ofkP3om^h02@3om^h200000280ooK^00<00000
0?ofkP3om^h0803om^h10?ooo`008P3om^h00`000000ooK^0?ofkP0R0?ofkP030000003om^h0ooK^
00P0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^
00l0ooK^0`0mFJ/E0?ofkP0303eIZ`3om^h0ooK^00<0ooK^0P0mFJ/30?ofkP0303eIZ`3om^h0ooK^
00L0ooK^00<0?EV[0000000000001P3om^h203eIZ`030000000E1P80000000805@H200<0000002H:
100mFJ/00P0V2P@0100000009PX402H:100V2P@3000000H0AQ8800D0000004HB20164PP0AQ880000
000306HK3@030000000mFJ/0IQ/=0080?EV[0`1V6`d01@000000IQ/=06HK3@1V6`d0000000<0PR@@
00<00000088T402291001P2291000`0mFJ/0PR@@088T4003088T40<000000P2I:a<203eIZ`<0VB/C
00@0000004YYa`1:JLL0BVW70P3D?AT204YYa`<000001@17I;`00`3D?AT0AfBl04MT_00604MT_005
00000017I;`0AfBl04MT_00000000`13GJd010000000@ef]04=M[@13GJd20=@m6@0304=M[@3D?AT0
000000<0@ef]00D0000003eCV00mDiP0?E>H0000000603eCV0<000000P0cA7P01`000000<dAh03=4
N00cA7P0e3dI03=4N00000000P0X<UP00`000000:39H000000020=@m6@H0ooK^0P0000000`3D?AT0
ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^0080ooK^0P3D?AT50?ofkP030=@m6@3om^h0ooK^0180
ooK^00@0e3dI0?ofkP3D?AT0e3dI4@3om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^
00L0ooK^00<0e3dI0?ofkP3om^h0203om^h00`000000ooK^0?ofkP0R0?ofkP030000003om^h0ooK^
0200ooK^0@3oool00280ooK^00<000000?ofkP3om^h08`3om^h2000000P0ooK^00<0?EV[0?ofkP3o
m^h0203om^h203eIZ`L0ooK^00<0?EV[0?ofkP3om^h04P3om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP03
03eIZ`3om^h0ooK^00H0ooK^0P0mFJ/00`3om^h0?EV[0?ofkP080?ofkP030000003om^h0ooK^00@0
ooK^100000000`0mFJ/0000001D60P030000000502H:100mFJ/09PX402H:100000000P0V2P@01000
0000AQ8804HB2000000604HB2004000000164PP0AQ88000000@0IQ/=00<0000003eIZ`1V6`d00P1V
6`d0100mFJ/0IQ/=06HK3@00000206HK3@03000000229100PR@@0080PR@@00<00000088T40229100
1@2291000`0mFJ/00000088T4003088T40040000002I:a<0VB/C000000@0VB/C0P0mFJ/00`2I:a<0
000004YYa`020=@m6@@0BVW700@0000004YYa`1:JLL000001017I;`00`000000e3dI04MT_00604MT
_00300000017I;`0AfBl0080AfBl00@0000004=M[@13GJd000000P13GJd01P3D?AT0@ef]04=M[@13
GJd0e3dI000000@0@ef]00@0000003eCV00mDiP000001P0mDiP010000000?E>H03eCV000000203=4
N0050000000cA7P0<dAh0=@m6@0cA7P00`0000000`0X<UP000000=@m6@04000000H0ooK^00<00000
0?ofkP3om^h01`3om^h0103D?AT0ooK^0=@m6@3D?AT80?ofkP030=@m6@3om^h0ooK^0180ooK^00<0
e3dI0?ofkP3om^h04P3om^h00`3D?AT0ooK^0?ofkP050?ofkP80e3dI2P3om^h00`3D?AT0ooK^0?of
kP060?ofkP8000009@3om^h00`000000ooK^0?ofkP0P0?ofkP40oooo000R0?ofkP030000003om^h0
ooK^02D0ooK^0P0000050?ofkP0303eIZ`3om^h0ooK^00/0ooK^0P0mFJ/50?ofkP0303eIZ`3om^h0
ooK^0180ooK^0`0mFJ/B0?ofkP0303eIZ`3om^h0ooK^00P0ooK^0P0mFJ/70?ofkP8000001@3om^h2
000000050=@m6@0000005@H201D60P0000000P0mFJ/0100V2P@0000002H:100mFJ/302H:10030000
000V2P@0000000<0AQ8800<0000004HB20164PP010164PP3000000D0IQ/=00<0?EV[06HK3@1V6`d0
0`1V6`d203eIZ`<000001@2291000`000000PR@@088T4005088T400403eIZ`000000PR@@088T4080
00000`2I:a<00`000000VB/C09T[4`0409T[4`0303eIZ`000000e3dI00H0BVW700@0000004YYa`1:
JLL0BVW70P00000204MT_0030000003D?AT0AfBl00H0AfBl00<0000004MT_017I;`00`17I;`30000
0080e3dI1@13GJd00`3D?AT0@ef]04=M[@0304=M[@<000001P0mDiP01`000000?E>H03eCV00mDiP0
000003=4N00000000`0cA7P0103D?AT0<dAh0000000cA7P20=@m6@050000000X<UP0:39H0000000m
FJ/00P0000050?ofkP8000001`3om^h20=@m6@X0ooK^00<0e3dI0?ofkP3om^h0403om^h30=@m6A@0
ooK^00<0e3dI0?ofkP3om^h00`3om^h20=@m6@d0ooK^00<0e3dI0?ofkP3om^h00`3om^h2000002L0
ooK^00<000000?ofkP3om^h0803om^h10?ooo`008@3om^h00`000000ooK^0?ofkP0X0?ofkP800000
0`3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP80?EV[0`3om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP0403eI
Z`3om^h0ooK^0?ofkP80?EV[3`3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^0080
?EV[103om^h00`000000ooK^03eIZ`040?ofkP80000000P0e3dI0000000E1P805@H20000000E1P80
000002H:1080?EV[00@09PX403eIZ`0V2P@09PX40`00000404HB2003000000164PP0AQ8800@0AQ88
00<0000006HK3@1V6`d01@1V6`d00`0mFJ/0IQ/=06HK3@0506HK3@0303eIZ`229100PR@@00D0PR@@
00<00000088T40229100102291000`0mFJ/0PR@@00000002000000D0VB/C00<0000009T[4`2I:a<0
1@2I:a<00`0mFJ/0BVW704YYa`0504YYa`030000001:JLL0BVW700<0BVW70`0000000`17I;`0e3dI
04MT_00404MT_00300000017I;`0AfBl00H0AfBl00<0e3dI04=M[@13GJd01@13GJd00`3D?AT0@ef]
04=M[@0504=M[@030000000mDiP0?E>H00@0?E>H00<0000003eCV00mDiP00P0mDiP300000080<dAh
00P0e3dI03=4N03D?AT0e3dI03=4N0000000:39H00000080:39H00@0000003eIZ`0000000000103o
m^h00`3D?AT0ooK^000000040?ofkP80e3dI0P3om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3o
m^h0ooK^00d0ooK^0P3D?AT30?ofkP030=@m6@3om^h0ooK^0140ooK^00@0e3dI0?ofkP3om^h0ooK^
0P3D?AT?0?ofkP040=@m6@3om^h0ooK^0?ofkP800000:P3om^h00`000000ooK^0?ofkP0O0?ofkP40
oooo000Q0?ofkP030000003om^h0ooK^02X0ooK^0P0000000`3om^h0?EV[0?ofkP0@0?ofkP<0?EV[
503om^h00`0mFJ/0ooK^0?ofkP030?ofkP80?EV[3@3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eI
Z`3om^h0ooK^0080ooK^0P0mFJ/2000000030?ofkP0mFJ/0ooK^00<0ooK^00@000000=@m6@000000
00000`0E1P82000000809PX400<0000002H:100mFJ/00`0V2P@00`000000AQ8804HB200304HB2003
000000164PP0AQ8800<0AQ8800<000000=@m6@0000001P1V6`d00`0mFJ/0000006HK3@0406HK3@<0
00000P0mFJ/6088T4003000000229100PR@@00<0PR@@00<0?EV[088T400000001`2I:a<00`000000
VB/C09T[4`0509T[4`030000001:JLL0BVW700D0BVW700<0000004YYa`1:JLL01@1:JLL00`000000
AfBl0=@m6@0504MT_00300000017I;`0AfBl00@0AfBl0P3D?AT3000000D0@ef]00<000000=@m6@13
GJd01@13GJd00`000000?EV[0000000503eCV0030000000mDiP0?E>H00<0?E>H00L0000003=4N00c
A7P0<dAh0=@m6@0cA7P000000080<dAh0P00000202PbF0050000000X<UP0000003eIZ`000000103o
m^h0103D?AT0ooK^0000000000020=@m6@@0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^
0?ofkP0;0?ofkP80e3dI1@3om^h00`3D?AT0ooK^0?ofkP0B0?ofkP<0e3dI4@3om^h0103D?AT0ooK^
00000000000/0?ofkP030000003om^h0ooK^01l0ooK^0@3oool00240ooK^00<000000?ofkP3om^h0
;03om^h00`000000?EV[0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^0180ooK^00<0?EV[0?ofkP3om^h0
1@3om^h203eIZ`X0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP040?ofkP050000
000mFJ/0?EV[0?ofkP0mFJ/00P3om^h2000000040=@m6@0000005@H2000000805@H200<0000002H:
100V2P@00P0V2P@00`000000?EV[02H:100203eIZ`8000001@164PP00`000000AQ8804HB200204HB
20040000001V6`d0IQ/=000000H0IQ/=00<0?EV[0000001V6`d00`1V6`d010000000PR@@088T4000
0002088T400303eIZ`229100PR@@00<0PR@@00<00000088T402291000P229100100mFJ/000000000
0000000709T[4`030000002I:a<0VB/C00D0VB/C00<0000004YYa`1:JLL01@1:JLL00`000000BVW7
04YYa`0504YYa`<0000000<0e3dI04MT_017I;`00P17I;`00`000000AfBl04MT_00304MT_0040=@m
6@17I;`0AfBl00000080AfBl00<0000004=M[@13GJd00P13GJd00`000000e3dI04=M[@0504=M[@04
00000013GJd0@ef]000000@0?E>H00<0000003eCV00mDiP00`0mDiP200000080e3dI00<0<dAh0=@m
6@000000100cA7P01`000000:39H02PbF0000000:39H0000000mFJ/00P0000020?ofkP050=@m6@3o
m^h0e3dI0=@m6@0000001P3om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00P0ooK^
0P3D?AT70?ofkP030=@m6@3om^h0ooK^0180ooK^00<0e3dI0?ofkP3om^h04@3om^h00`3D?AT00000
0?ofkP0]0?ofkP030000003om^h0ooK^01l0ooK^0@3oool00240ooK^00<000000?ofkP3om^h0;03o
m^h00`0mFJ/0ooK^0000000B0?ofkP<0?EV[4P3om^h00`0mFJ/0ooK^0?ofkP070?ofkP80?EV[203o
m^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00@0ooK^00D000000?ofkP3om^h0ooK^
03eIZ`020?ofkP070000003D?AT05@H20000000E1P80000001D60P03000000<09PX400P0000002H:
100mFJ/09PX4000000164PP0?EV[000000D0AQ8800<0000004HB20164PP00P00000306HK3@030000
001V6`d0IQ/=00<0IQ/=00<0?EV[06HK3@0000000P1V6`d2000000<0PR@@00@00000088T40229100
PR@@0P0mFJ/3088T4003000000229100PR@@0080PR@@00@0?EV[09T[4`2I:a<000001`2I:a<00`00
0000VB/C09T[4`0509T[4`030000001:JLL0BVW700D0BVW700<0000004YYa`1:JLL01@1:JLL01000
0000BVW704YYa`3D?AT404MT_00400000017I;`0AfBl04MT_080e3dI0`17I;`010000000AfBl04MT
_017I;`200000080@ef]00<0000004=M[@3D?AT01@13GJd010000000@ef]04=M[@13GJd200000080
?E>H00<0000003eCV00mDiP00`0mDiP020000000e3dI03eCV0000000<dAh0=@m6@0cA7P000000`0c
A7P30000000702PbF0000000:39H0000000J7CT0?EV[000000020?ofkP050=@m6@3om^h0ooK^0?of
kP0000001P3om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00H0ooK^0P3D?AT90?of
kP030=@m6@3om^h0ooK^0100ooK^0`3D?ATB0?ofkP030000003om^h0e3dI02h0ooK^00<000000?of
kP3om^h07`3om^h10?ooo`008@3om^h00`000000ooK^0?ofkP0/0?ofkP0303eIZ`3om^h0ooK^0080
0000403om^h00`0mFJ/0ooK^0?ofkP0203eIZ`l0ooK^00<0?EV[0?ofkP3om^h02P3om^h203eIZ`D0
ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP020?ofkP800000103om^h203eIZ`0:
0000003D?AT05@H20000000E1P80000001D60P0000009PX4000000@09PX400@0000003eIZ`000000
00000P164PP00`000000?EV[03eIZ`0404HB20<000001@1V6`d00`000000IQ/=06HK3@0306HK3@03
03eIZ`1V6`d00000008000001@2291000`000000PR@@088T4003088T400403eIZ`229100PR@@0000
0080PR@@0P000000100mFJ/0VB/C09T[4`00000709T[4`030000002I:a<0VB/C00D0VB/C00<00000
04YYa`1:JLL01@1:JLL00`000000BVW704YYa`0504YYa`040000001:JLL0BVW70=@m6@8000000P17
I;`010000000AfBl04MT_03D?AT504MT_00300000017I;`0AfBl00<0AfBl0`0000000`13GJd0e3dI
04=M[@0404=M[@0300000013GJd0@ef]00<0@ef]0`00000403eCV080e3dI00<0000003eCV00mDiP0
0P0000000`3D?AT0000003=4N00303=4N00:0000000cA7P0000002PbF0000000:39H0000000J7CT0
?EV[00000080e3dI103om^h2000000@0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?of
kP030?ofkP80e3dI303om^h00`3D?AT0ooK^0?ofkP0=0?ofkP80e3dI0P3om^h00`3D?AT0ooK^0?of
kP0>0?ofkP8000000P3om^h00`3D?AT0ooK^0?ofkP0/0?ofkP030000003om^h0ooK^01l0ooK^0@3o
ool00200ooK^00<000000?ofkP3om^h0;@3om^h00`0mFJ/0ooK^0?ofkP020?ofkP8000003@3om^h0
0`0mFJ/0ooK^0?ofkP030?ofkP80?EV[3@3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP80?EV[0`3om^h0
0`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^0080ooK^00<000000?ofkP3om^h00`3om^h0
100mFJ/0ooK^0000000E1P820000000401D60P0000005@H2000000809PX400L0000002H:100V2P@0
9PX40000000mFJ/0000000@0AQ8800<0000004HB20164PP00P0mFJ/204HB20030000001V6`d0IQ/=
00D0IQ/=00<0000006HK3@1V6`d00P1V6`d0100mFJ/0IQ/=06HK3@000007088T4003000000229100
PR@@00@0PR@@0P0mFJ/30000000309T[4`0mFJ/0VB/C0080VB/C00<0000009T[4`2I:a<01@2I:a<0
0`000000VB/C09T[4`0509T[4`030000001:JLL0BVW700D0BVW700<0000004YYa`1:JLL01@1:JLL0
1P000000BVW704YYa`1:JLL0e3dI04YYa`<000000P3D?AT604MT_00300000017I;`0AfBl00D0AfBl
00@0000004=M[@13GJd0e3dI1013GJd00`000000@ef]04=M[@0504=M[@030000000mDiP0?E>H0080
e3dI0P0mDiP00`000000?E>H03eCV00203eCV0030000003D?AT0000000<0<dAh00<0000003=4N00c
A7P00P00000202PbF080000000@06Qdi0000003om^h0e3dI1@3om^h00`000000ooK^0?ofkP020?of
kP030=@m6@3om^h0ooK^00L0ooK^00@0e3dI0?ofkP3om^h0ooK^0P3D?AT>0?ofkP030=@m6@3om^h0
ooK^00/0ooK^0P3D?AT50?ofkP030=@m6@3om^h0ooK^00/0ooK^0P0000040?ofkP030=@m6@3om^h0
ooK^02d0ooK^00<000000?ofkP3om^h07P3om^h10?ooo`00803om^h00`000000ooK^0?ofkP0]0?of
kP<0?EV[103om^h2000000/0ooK^00<0?EV[0?ofkP3om^h01@3om^h203eIZ`/0ooK^00<0?EV[0?of
kP3om^h03P3om^h303eIZ`T0ooK^00@0?EV[0?ofkP0mFJ/0?EV[0P0000060?ofkP0303eIZ`000000
0000008000000P0E1P82000000809PX400<0000002H:100V2P@00P0V2P@00`000000?EV[04HB2004
04HB2003000000164PP0AQ880080AQ8800<0?EV[0=@m6@0000001`1V6`d00`000000IQ/=06HK3@02
06HK3@0403eIZ`0000000000000000P0PR@@00<00000088T402291001@2291001@0mFJ/0VB/C09T[
4`2I:a<0?EV[00<0VB/C00<0000009T[4`2I:a<01@2I:a<00`000000VB/C09T[4`0309T[4`D00000
1@1:JLL00`000000BVW704YYa`0504YYa`050000001:JLL0BVW704YYa`3D?AT00`1:JLL00`3D?AT0
AfBl04MT_00504MT_00300000017I;`0AfBl00H0AfBl0`0000000`3D?AT0@ef]04=M[@0204=M[@03
00000013GJd0@ef]00D0@ef]00<0000003eIZ`3D?AT0100mDiP00`000000?E>H03eCV00303eCV003
0=@m6@000000<dAh00<0<dAh00<0000003=4N00cA7P00P00000202PbF0@0000000<0e3dI0?ofkP3o
m^h0103om^h200000080e3dI00<0ooK^0=@m6@3om^h0203om^h30=@m6A00ooK^00<0e3dI0?ofkP3o
m^h02@3om^h20=@m6@L0ooK^00<0e3dI0?ofkP3om^h02@3om^h2000000@0ooK^0`3D?AT_0?ofkP03
0000003om^h0ooK^01h0ooK^0@3oool00200ooK^00<000000?ofkP3om^h0;@3om^h00`0mFJ/0ooK^
0?ofkP0203eIZ`@0ooK^0P0000090?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h0
1`3om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP0303eIZ`3om^h0ooK^00H0ooK^00D0?EV[0?ofkP3om^h0
ooK^0000000203eIZ`D0ooK^00D0?EV[0000000000005@H20000000201D60P030000000V2P@09PX4
00809PX400<0000002H:100V2P@00P0000000`0mFJ/0AQ8804HB200404HB2006000000164PP0AQ88
04HB20000000IQ/=0P0mFJ/706HK3@060000001V6`d0IQ/=06HK3@0mFJ/000000P2291000`000000
PR@@088T4006088T4003000000229100PR@@00<0PR@@0`00000303eIZ`@0VB/C00<0000009T[4`2I
:a<01@2I:a<00`000000VB/C09T[4`0209T[4`040000002/<AH0[34F00000080C6g>00<0000004YY
a`1:JLL00P1:JLL00`000000BVW704YYa`0504YYa`030000001:JLL0BVW70080BVW70`3D?AT30000
00D0AfBl00<0000004MT_017I;`01P17I;`01@000000AfBl04MT_0000000e3dI00<0@ef]00<00000
04=M[@13GJd01@13GJd20=@m6@0304=M[@000000?E>H0080?E>H00<0000003eCV00mDiP0100mDiP0
0`3D?AT000000000000203=4N0030000000cA7P0<dAh0080<dAh00D0000002PbF00X<UP0000002Pb
F002000000030=@m6@3om^h0ooK^00<0ooK^0P3D?AT01@000000ooK^0?ofkP3om^h0e3dI00P0ooK^
00<0e3dI0?ofkP3om^h04@3om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00L0ooK^
00<0e3dI0?ofkP3om^h01`3om^h2000000@0ooK^0P3D?AT20?ofkP030=@m6@3om^h0ooK^02d0ooK^
00<000000?ofkP3om^h07P3om^h10?ooo`00803om^h00`000000ooK^0?ofkP0]0?ofkP0303eIZ`3o
m^h0ooK^0080ooK^0P0mFJ/40?ofkP8000001`3om^h00`0mFJ/0ooK^0?ofkP080?ofkP80?EV[1`3o
m^h00`0mFJ/0ooK^0?ofkP0A0?ofkP<0?EV[1@3om^h00`0mFJ/0ooK^0?ofkP02000000<0ooK^00H0
?EV[0?ofkP3om^h0ooK^01D60P00000201D60P040000000E1P800000000000@09PX400L0000002H:
100V2P@0000004HB200mFJ/0000000D0AQ8800<0000004HB20164PP00P00000306HK3@030000000m
FJ/0IQ/=00D0IQ/=00D0000006HK3@1V6`d0000003eIZ`03088T4003000000229100PR@@00H0PR@@
00<00000088T402291000P22910010000000VB/C09T[4`00000209T[4`0303eIZ`2I:a<0VB/C0080
VB/C00<0000009T[4`2I:a<01@2I:a<00`000000VB/C09T[4`02000000<0[34F00@0000004a]cP1<
KLh0C6g>0P00000204YYa`030000001:JLL0BVW700@0BVW700<0000004YYa`1:JLL00`1:JLL0103D
?AT0BVW704YYa`00000204YYa`0300000017I;`0AfBl0080AfBl00<0000004MT_017I;`01P17I;`0
1P000000AfBl04MT_017I;`0e3dI00000080@ef]00<0000004=M[@13GJd01013GJd00`3D?AT00000
04=M[@0204=M[@8000000P0mDiP00`000000?E>H03eCV00303eCV0040000003D?AT0?E>H00000080
<dAh00@0000003=4N00cA7P0<dAh0`000000100X<UP0000002PbF00X<UP2000000<0ooK^00@0e3dI
0?ofkP3om^h0ooK^0P0000020?ofkP030=@m6@3om^h0ooK^00<0ooK^0`3D?ATC0?ofkP030=@m6@3o
m^h0ooK^00D0ooK^0P3D?AT:0?ofkP030=@m6@3om^h0ooK^00D0ooK^0P0000040?ofkP80e3dI103o
m^h00`3D?AT0ooK^0?ofkP0]0?ofkP030000003om^h0ooK^01h0ooK^0@3oool001l0ooK^00<00000
0?ofkP3om^h0;P3om^h00`0mFJ/0ooK^0?ofkP040?ofkP80?EV[103om^h00`000000ooK^0?ofkP03
0?ofkP0303eIZ`3om^h0ooK^00/0ooK^0P0mFJ/50?ofkP0303eIZ`3om^h0ooK^0100ooK^00@0?EV[
0?ofkP3om^h0ooK^0P0mFJ/30?ofkP0303eIZ`3om^h0000000H0ooK^0P0mFJ/2000000805@H20`00
00000`0V2P@0000002H:100302H:10070000000V2P@0000004HB200mFJ/0AQ880000000504HB20<0
00001@1V6`d010000000IQ/=03eIZ`0mFJ/406HK3@<0000000<0?EV[088T402291000P2291000`00
0000PR@@088T4006088T4003000000229100PR@@008000000`2I:a<010000000VB/C03eIZ`2I:a<2
03eIZ`<0VB/C00<0000009T[4`2I:a<0102I:a<3000000D0[34F00<0000004a]cP1<KLh00`1<KLh3
000000H0BVW700@0000004YYa`1:JLL0BVW70`3D?AT204YYa`040000001:JLL0BVW704YYa`800000
0P17I;`00`000000AfBl04MT_00604MT_00300000017I;`0AfBl0080AfBl00@0e3dI000000000000
00001013GJd20=@m6@0304=M[@000000@ef]00@0@ef]0`00000503eCV0070000003D?AT0?E>H03eC
V0000000<dAh0000000403=4N0030000000cA7P00000008000000P0X<UP200000080e3dI1P3om^h0
0`000000ooK^0=@m6@030?ofkP80e3dI0`3om^h00`3D?AT0ooK^0?ofkP0@0?ofkP030=@m6@3om^h0
ooK^00<0ooK^0P3D?AT=0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<000000?ofkP3om^h00P3om^h2
0=@m6@H0ooK^00<0e3dI0?ofkP3om^h0;P3om^h00`000000ooK^0?ofkP0M0?ofkP40oooo000O0?of
kP030000003om^h0ooK^02h0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP020?of
kP8000000`3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP80?EV[0`3om^h00`0mFJ/0ooK^0?ofkP0@0?of
kP0303eIZ`3om^h0ooK^00<0ooK^0`0mFJ/00`3om^h000000?ofkP060?ofkP8000000P0mFJ/00`0E
1P8000000000000202H:10030000000V2P@09PX400809PX40`00000204HB200303eIZ`164PP00000
00D0AQ8800<0000006HK3@1V6`d01@1V6`d010000000IQ/=06HK3@1V6`d203eIZ`80IQ/=00@00000
088T40229100?EV[102291000`000000PR@@088T4006088T40<000001@2I:a<00`000000VB/C03eI
Z`0309T[4`80?EV[00<0VB/C0000002I:a<01@2I:a<00`000000[34F0:`a5P050:`a5P030000001<
KLh0C6g>00D0C6g>00<0000004YYa`1:JLL0101:JLL010000000BVW70=@m6@3D?AT304YYa`030=@m
6@1:JLL0000000D0BVW70`00000804MT_00300000017I;`0AfBl0080AfBl00@0e3dI04MT_017I;`0
00000P13GJd20=@m6@<0@ef]00<0000004=M[@13GJd01@13GJd00`000000?E>H03eCV00303eCV003
0000000mDiP0e3dI0080?E>H0`00000303=4N0040000000cA7P0<dAh03=4N080000000<0:39H0=@m
6@3D?AT00P0000070?ofkP030000003om^h0e3dI0080e3dI1@3om^h00`3D?AT0ooK^0?ofkP0@0?of
kP040=@m6@3om^h0ooK^0?ofkP80e3dI3`3om^h0103D?AT0ooK^0?ofkP3om^h2000000@0ooK^00<0
e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP0^0?ofkP030000003om^h0ooK^01d0ooK^0@3o
ool001l0ooK^00<000000?ofkP3om^h0;@3om^h00`0mFJ/0ooK^0?ofkP080?ofkP80?EV[103om^h2
000000030?ofkP0mFJ/0ooK^0100ooK^0`0mFJ/C0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[
0000000000001`3om^h20000000401D60P0000005@H203eIZ`@09PX400<0000002H:100V2P@00P0V
2P@01`000000AQ8804HB20164PP0?EV[04HB2000000010164PP3000000L0IQ/=00<0000006HK3@1V
6`d00`1V6`d01@0mFJ/00000000000229100?EV[00H0PR@@00<00000088T402291001@2291000`00
0000VB/C09T[4`0509T[4`030000000mFJ/0VB/C00D0VB/C00<0?EV[0000002I:a<00`2I:a<30000
00L0[34F00<0000004a]cP1<KLh01@1<KLh3000000@0BVW700<000000=@m6@1:JLL0101:JLL00`3D
?AT0BVW70000000704YYa`0300000017I;`0AfBl00D0AfBl00<0000004MT_017I;`01017I;`01@3D
?AT0AfBl000000000000e3dI00D0@ef]00<0000004=M[@13GJd01@13GJd3000000@0?E>H00<00000
03eCV03D?AT00`0mDiP00`000000<dAh03=4N00203=4N0030000000cA7P0<dAh0080<dAh00@0e3dI
02PbF0000000:39H0P0000070?ofkP80000000<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?of
kP0A0?ofkP<0e3dI4@3om^h0103D?AT0ooK^0000000000040?ofkP80e3dI2@3om^h00`3D?AT0ooK^
0?ofkP0^0?ofkP030000003om^h0ooK^01d0ooK^0@3oool001l0ooK^00<000000?ofkP3om^h0;@3o
m^h00`0mFJ/0ooK^0?ofkP0:0?ofkP80?EV[103om^h00`000000?EV[0?ofkP0B0?ofkP0303eIZ`3o
m^h0ooK^0140ooK^00<0?EV[0?ofkP3om^h00`3om^h0100mFJ/000000?ofkP3om^h203eIZ`<0ooK^
00H0e3dI0000000E1P805@H20000000E1P8200000080?EV[00<09PX40000000V2P@00P0V2P@30000
0080AQ8800@0?EV[04HB20164PP000000`164PP010000000IQ/=06HK3@00000706HK3@030000001V
6`d0IQ/=0080IQ/=00H00000088T400mFJ/0?EV[088T400mFJ/6088T4003000000229100PR@@00<0
PR@@0`00000709T[4`030000000mFJ/0VB/C00H0VB/C0P0mFJ/209T[4`040000002/<AH0[34F0000
00L0[34F00<0000004a]cP1<KLh01@1<KLh010000000C6g>04a]cP00000204YYa`80e3dI1`1:JLL0
0`3D?AT0000004YYa`0604YYa`<000001@17I;`00`000000AfBl04MT_00404MT_0060=@m6@17I;`0
e3dI0=@m6@17I;`000001013GJd00`000000@ef]04=M[@0504=M[@0400000013GJd0@ef]000000<0
?E>H00@0000003eCV00mDiP0e3dI0P0mDiP300000080<dAh00<0000003=4N00cA7P00P3D?AT20000
000602PbF0000000:39H02PbF0000000?EV[0`3om^h20=@m6@80ooK^00<000000=@m6@3om^h0103o
m^h00`3D?AT0ooK^0?ofkP0A0?ofkP030=@m6@3om^h0ooK^0140ooK^00<0e3dI0000003om^h00`3o
m^h20=@m6@`0ooK^00<0e3dI0?ofkP3om^h0;@3om^h00`000000ooK^0?ofkP0M0?ofkP40oooo000O
0?ofkP030000003om^h0ooK^02d0ooK^00<0?EV[0?ofkP3om^h0303om^h203eIZ`80ooK^00@0?EV[
0?ofkP00000000004@3om^h303eIZa00ooK^00<0?EV[0?ofkP3om^h00`3om^h2000000D0ooK^0P0m
FJ/01P3D?AT0000001D60P0E1P80000001D60P8000000`0V2P@203eIZ`0302H:1000000000000080
AQ8800@0000004HB20164PP0?EV[0P164PP010000000AQ8804HB2000000306HK3@030000001V6`d0
IQ/=00D0IQ/=00<0000006HK3@1V6`d00P000003088T40030000000mFJ/0PR@@00H0PR@@00<00000
088T402291000P22910010000000VB/C09T[4`00000709T[4`0303eIZ`000000VB/C00H0VB/C00@0
000009T[4`0mFJ/000000`2/<AH00`000000[34F0:`a5P040:`a5P0303eIZ`000000e3dI00H0C6g>
00P0000004a]cP1<KLh0C6g>0000003D?AT0BVW7000000L0BVW700<0e3dI04YYa`1:JLL01P1:JLL0
10000000BVW704YYa`00000404MT_00300000017I;`0AfBl00D0AfBl00<0e3dI00000017I;`00P17
I;`200000080@ef]00<0000004=M[@13GJd01@13GJd01@000000@ef]04=M[@13GJd000000080?E>H
00@0000003eCV00mDiP0e3dI0P0mDiP00`000000?E>H03eCV0020000000303=4N03D?AT0e3dI00<0
<dAh0P0000001P0X<UP0000002PbF00X<UP0000003eIZ`80e3dI1@3om^h2000000D0ooK^00<0e3dI
0?ofkP3om^h03P3om^h30=@m6A40ooK^0P000000103om^h0e3dI0?ofkP3om^h20=@m6@h0ooK^00<0
e3dI0?ofkP3om^h0;@3om^h00`000000ooK^0?ofkP0M0?ofkP40oooo000N0?ofkP030000003om^h0
ooK^02h0ooK^00<0?EV[0?ofkP3om^h03P3om^h303eIZ`<0ooK^0P00000?0?ofkP0303eIZ`3om^h0
ooK^0080?EV[3P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP030000003om^h0ooK^00D0ooK^0P3D?AT0
0`0mFJ/05@H201D60P030000000302H:100000009PX400809PX40P0000000`0mFJ/0AQ8804HB2002
04HB2003000000164PP0?EV[00<0AQ880`00000406HK3@030000001V6`d0IQ/=00D0IQ/=0`000005
088T400403eIZ`229100?EV[03eIZ`D0PR@@00<00000088T402291000P00000309T[4`030000002I
:a<0VB/C00D0VB/C00<0?EV[0000002I:a<01P2I:a<300000080?EV[0P2/<AH00`000000[34F0:`a
5P040:`a5P0303eIZ`000000e3dI00H0C6g>00<0000004a]cP1<KLh00P3D?AT3000000L0BVW700<0
00000=@m6@1:JLL01P1:JLL010000000BVW704YYa`1:JLL200000080AfBl00<0000004MT_017I;`0
0`17I;`20=@m6@0304MT_03D?AT0AfBl00@0AfBl0`00000704=M[@0300000013GJd0@ef]0080@ef]
0`00000303eCV0030=@m6@0mDiP0000000@0?E>H00<0e3dI0000000cA7P00`0cA7P010000000<dAh
00000000000302PbF0030=@m6@0mFJ/0?EV[00L0ooK^00<000000?ofkP3om^h00P3om^h00`3D?AT0
ooK^0?ofkP0<0?ofkP80e3dI0P3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP8000000`3om^h30=@m6A00
ooK^00<0e3dI0?ofkP3om^h0;P3om^h00`000000ooK^0?ofkP0L0?ofkP40oooo000N0?ofkP030000
003om^h0ooK^02h0ooK^00<0?EV[0?ofkP3om^h0403om^h00`0mFJ/0ooK^0?ofkP030?ofkP030000
003om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h00`3om^h203eIZ``0ooK^00<0?EV[0?ofkP3om^h0
0P0000070?ofkP80e3dI00D0000003eIZ`0E1P805@H20000000202H:10030000000V2P@09PX40080
9PX400<0000004HB20164PP00P0mFJ/204HB20030000000mFJ/0AQ8800<0AQ8800<0000006HK3@1V
6`d0101V6`d00`000000IQ/=06HK3@0506HK3@03000000229100PR@@00D0PR@@00@0?EV[088T4022
9100PR@@0P0mFJ/3088T40<000001P2I:a<00`000000VB/C09T[4`0309T[4`0303eIZ`2I:a<00000
00L0VB/C00<000000:`a5P2/<AH00P2/<AH203eIZ`030000002/<AH0[34F00<0[34F00D0?EV[0:`a
5P000000C6g>0=@m6@0504a]cP030000003D?AT0e3dI00@0C6g>00<0000004YYa`1:JLL01@1:JLL0
0`000000e3dI04YYa`0504YYa`030000001:JLL0BVW700@0BVW70`00000304MT_080e3dI0`17I;`0
0`3D?AT0AfBl04MT_00504MT_00300000013GJd0@ef]00@0@ef]00<0000004=M[@13GJd01@13GJd0
0`000000?E>H03eCV00203eCV0040=@m6@000000?E>H03eCV080e3dI0P0mDiP00`000000<dAh03=4
N00203=4N0040000000cA7P0<dAh00000080:39H00@0e3dI0000000mFJ/0?EV[1`3om^h200000080
ooK^00<0e3dI0?ofkP3om^h02P3om^h20=@m6@D0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`000000
ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^0100ooK^00<0e3dI0?ofkP3om^h0;P3om^h00`000000
ooK^0?ofkP0L0?ofkP40oooo000N0?ofkP030000003om^h0ooK^02h0ooK^00<0?EV[0?ofkP3om^h0
403om^h303eIZ`@0ooK^0P00000;0?ofkP0303eIZ`3om^h0ooK^00D0ooK^0P0mFJ/90?ofkP0603eI
Z`3om^h0ooK^0000003om^h0?EV[1@3om^h20=@m6@030?ofkP000000e3dI00805@H200D0000002H:
100V2P@09PX40000000202H:10<0000010164PP203eIZ`0704HB200mFJ/0AQ8804HB20000000e3dI
0000000706HK3@030000001V6`d0IQ/=0080IQ/=0`000006088T400303eIZ`229100000000@0PR@@
0P0mFJ/00`229100000009T[4`0709T[4`030000002I:a<0VB/C00<0VB/C00<0?EV[09T[4`000000
1@2I:a<3000000H0[34F00<0?EV[0:`a5P2/<AH00`2/<AH01@0mFJ/0[34F0000001<KLh0e3dI00D0
C6g>00<0e3dI04a]cP1<KLh0101<KLh3000000D0BVW700<0000004YYa`3D?AT01@1:JLL00`000000
BVW704YYa`0604YYa`0400000017I;`0e3dI0=@m6@@0AfBl00<0000004MT_03D?AT01P17I;`30000
00@0@ef]00<0000004=M[@13GJd01@13GJd00`000000?EV[0000000203eCV0040=@m6@0mDiP0e3dI
0=@m6@@0?E>H0`00000203=4N0050000000cA7P0<dAh03=4N00000000P0X<UP203eIZ`030?ofkP0m
FJ/0?EV[00D0ooK^00<0e3dI0?ofkP0000000P3om^h00`3D?AT0ooK^0?ofkP070?ofkP80e3dI1`3o
m^h00`3D?AT0ooK^0?ofkP090?ofkP800000103om^h30=@m6A80ooK^00<0e3dI0?ofkP3om^h0;P3o
m^h00`000000ooK^0?ofkP0L0?ofkP40oooo000N0?ofkP030000003om^h0ooK^02h0ooK^00<0?EV[
0?ofkP3om^h0403om^h00`0mFJ/0ooK^0?ofkP0203eIZ`@0ooK^0P0000090?ofkP0303eIZ`3om^h0
ooK^00L0ooK^0P0mFJ/70?ofkP0503eIZ`3om^h000000?ofkP0mFJ/01@3om^h20=@m6@040?ofkP3D
?AT0e3dI01D60P8000000`0V2P@0100000009PX402H:1000000204HB2003000000164PP0AQ8800<0
AQ8800D0000003eIZ`164PP0AQ880000000206HK3@030000001V6`d0IQ/=00D0IQ/=00D0000006HK
3@1V6`d0IQ/=00000002088T4003000000229100PR@@00<0PR@@00@0?EV[088T4022910000001@22
91000`000000?EV[0000000809T[4`030000002I:a<0VB/C0080VB/C00@0?EV[09T[4`2I:a<00000
0`2I:a<200000080[34F00<000000:`a5P2/<AH0102/<AH00`000000?EV[03eIZ`030:`a5P0503eI
Z`2/<AH0000004a]cP3D?AT00`1<KLh20=@m6@030000001<KLh0C6g>00@0C6g>00<0000004a]cP1<
KLh00P00000304YYa`030000001:JLL0e3dI00D0BVW700<0000004YYa`1:JLL01P1:JLL00`000000
e3dI0000000504MT_00400000017I;`0AfBl0=@m6@D0AfBl00@0000004MT_017I;`000000`13GJd0
0`000000@ef]04=M[@0504=M[@0400000013GJd0@ef]00000080?E>H00<0e3dI0000000mDiP0100m
DiP010000000?E>H03eCV000000203=4N0040000000cA7P0<dAh03=4N080000000@0:39H03eIZ`0m
FJ/0ooK^0P0mFJ/50?ofkP050=@m6@3om^h000000?ofkP3D?AT01`3om^h20=@m6@T0ooK^00<0e3dI
0?ofkP3om^h01`3om^h2000000@0ooK^0P3D?AT20?ofkP030=@m6@3om^h0ooK^0100ooK^00<0e3dI
0?ofkP3om^h0;P3om^h00`000000ooK^0?ofkP0L0?ofkP40oooo000M0?ofkP030000003om^h0ooK^
02l0ooK^0`0mFJ/@0?ofkP0303eIZ`3om^h0ooK^0080ooK^0P0mFJ/40?ofkP8000001`3om^h00`0m
FJ/0ooK^0?ofkP090?ofkP80?EV[1@3om^h2000000030?ofkP0mFJ/0ooK^00<0ooK^0`3D?AT00`3o
m^h0e3dI000000020000000302H:100000009PX400809PX400<0000002H:100000000P164PP00`00
0000AQ8804HB200404HB200403eIZ`164PP0?EV[03eIZ`<0IQ/=00<0000006HK3@1V6`d01@1V6`d0
10000000IQ/=06HK3@000004088T4005000000229100PR@@088T400mFJ/00`2291000`000000PR@@
088T4002088T40030000002I:a<0VB/C0080?EV[1`2I:a<00`000000VB/C09T[4`0209T[4`0503eI
Z`2I:a<0VB/C0000002I:a<00P0000040:`a5P030000002/<AH0[34F00D0[34F00<000000:`a5P0m
FJ/00P0mFJ/20:`a5P030000001<KLh0C6g>00<0e3dI00<0C6g>0000001<KLh01P1<KLh00`000000
C6g>04a]cP0204a]cP80000000D0BVW70000001:JLL0BVW70=@m6@0404YYa`030000001:JLL0BVW7
00D0BVW70P3D?AT204YYa`0300000017I;`0AfBl0080AfBl00D0000004MT_017I;`0AfBl0=@m6@03
04MT_00300000017I;`0AfBl0080AfBl00@0000004=M[@13GJd000001`13GJd010000000@ef]04=M
[@13GJd20=@m6@0303eCV03D?AT0?E>H00D0?E>H00H0000003eCV00mDiP0000003=4N000000303=4
N0030000000cA7P000000080000000<0?EV[0?ofkP0mFJ/00P0mFJ/40?ofkP040=@m6@3om^h00000
000000D0ooK^0P3D?AT;0?ofkP030=@m6@3om^h0ooK^00D0ooK^0P0000040?ofkP80e3dI103om^h0
0`3D?AT0ooK^0?ofkP0>0?ofkP<0e3dI<@3om^h00`000000ooK^0?ofkP0K0?ofkP40oooo000M0?of
kP030000003om^h0ooK^02l0ooK^00<0?EV[0?ofkP3om^h00P0mFJ/>0?ofkP0303eIZ`3om^h0ooK^
00@0ooK^0P0mFJ/40?ofkP800000103om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP80?EV[0P3om^h01000
0000?EV[0?ofkP0mFJ/40?ofkP030=@m6@3om^h0e3dI0080e3dI0P00000202H:10040000000V2P@0
9PX402H:10<000000`164PP00`000000AQ8804HB200304HB200503eIZ`00000000000000001V6`d0
0P0mFJ/00`1V6`d0000006HK3@0606HK3@<000001@2291001@000000PR@@088T40229100?EV[00<0
PR@@00<00000088T402291000P00000309T[4`040000002I:a<0?EV[03eIZ`D0VB/C00D0000009T[
4`2I:a<0VB/C03eIZ`0309T[4`8000001P2/<AH00`000000[34F0:`a5P050:`a5P050000002/<AH0
[34F0:`a5P0mFJ/00P2/<AH010000000C6g>04a]cP3D?AT304a]cP030000001<KLh0C6g>00D0C6g>
00<0000004a]cP1<KLh0101<KLh200000080BVW700<0e3dI04YYa`1:JLL00P1:JLL00`000000BVW7
04YYa`0304YYa`80e3dI00<0BVW70000001:JLL00P1:JLL200000080AfBl00D0000004MT_017I;`0
AfBl0=@m6@0304MT_00300000017I;`0AfBl00<0AfBl0`00000704=M[@0500000013GJd0e3dI0=@m
6@13GJd00`0000000`3D?AT0?E>H03eCV00303eCV0040000000mDiP0?E>H03eCV0<000000`0cA7P0
0`000000<dAh03=4N002000000<0?EV[00<0ooK^03eIZ`3om^h00`3om^h0103D?AT0ooK^0=@m6@00
00020?ofkP80e3dI3P3om^h00`3D?AT0ooK^0?ofkP020?ofkP800000103om^h20=@m6@H0ooK^00<0
e3dI0?ofkP3om^h0303om^h20=@m6@80ooK^00<0e3dI0?ofkP3om^h0;`3om^h00`000000ooK^0?of
kP0K0?ofkP40oooo000M0?ofkP030000003om^h0ooK^02l0ooK^00<0?EV[0?ofkP3om^h00P3om^h2
03eIZ``0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP8000000P3om^h0
0`0mFJ/0ooK^0?ofkP0>0?ofkP80000000@0?EV[0?ofkP0mFJ/0ooK^0P0mFJ/00`3om^h0e3dI0?of
kP030=@m6@030000000V2P@09PX400809PX400D0000002H:100V2P@09PX40000000504HB20030000
00164PP0AQ880080AQ8800<0?EV[04HB200000001@1V6`d203eIZ`L0IQ/=00<00000088T40229100
1@22910010000000PR@@088T400mFJ/4088T40<000001P2I:a<010000000VB/C09T[4`0mFJ/409T[
4`060000002I:a<0VB/C09T[4`0mFJ/0VB/C0`0000070:`a5P030000002/<AH0[34F00D0[34F00D0
00000:`a5P2/<AH0?EV[0:`a5P0203eIZ`050000003D?AT0e3dI04a]cP3D?AT00P1<KLh00`000000
C6g>04a]cP0504a]cP030000001<KLh0C6g>00D0C6g>0`0000000`1:JLL0e3dI04YYa`0204YYa`03
0000001:JLL0BVW70080BVW700@0e3dI04YYa`1:JLL000001P1:JLL3000000@0AfBl00@0e3dI04MT
_017I;`000001`17I;`00`000000@ef]04=M[@0504=M[@80e3dI1@13GJd00`000000?E>H0=@m6@04
03eCV0030000000mDiP0?E>H00<0?E>H00D0000003=4N00cA7P0<dAh0000000403=4N0070000000m
FJ/0?EV[03eIZ`3om^h0?EV[0?ofkP020=@m6@040?ofkP3D?AT0ooK^0=@m6@800000403om^h00`3D
?AT0ooK^0?ofkP02000000D0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP0:0?of
kP80e3dI103om^h00`3D?AT0ooK^0?ofkP0_0?ofkP030000003om^h0ooK^01/0ooK^0@3oool001d0
ooK^00<000000?ofkP3om^h0;`3om^h00`0mFJ/0ooK^0?ofkP040?ofkP80?EV[2P3om^h00`0mFJ/0
ooK^0?ofkP070?ofkP80?EV[1@3om^h00`000000ooK^03eIZ`0?0?ofkP030000003om^h0ooK^0080
?EV[0`3om^h00`3D?AT0?EV[03eIZ`020=@m6@030?ofkP0000009PX400<09PX400<0000002H:100V
2P@00`00000504HB2008000000164PP0AQ8804HB200mFJ/000000=@m6@00000606HK3@030000000m
FJ/0IQ/=00<0IQ/=0`000007088T4003000000229100?EV[00D0PR@@00<0000009T[4`2I:a<01P2I
:a<010000000VB/C09T[4`2I:a<203eIZ`<0VB/C00D0000009T[4`0mFJ/0VB/C000000020:`a5P03
0000002/<AH0[34F00D0[34F00<000000:`a5P2/<AH01@2/<AH01@000000[34F0:`a5P0mFJ/0[34F
00D0000000D0C6g>0=@m6@1<KLh0C6g>0000000704a]cP030000001<KLh0C6g>00D0C6g>00D00000
04a]cP1<KLh000000=@m6@0204YYa`040000001:JLL0BVW704YYa`80e3dI0`1:JLL00`000000BVW7
04YYa`0604YYa`0300000017I;`0AfBl00<0AfBl00<0e3dI04MT_00000001`17I;`3000000@0@ef]
00<0e3dI00000013GJd01@13GJd010000000?EV[0000003D?AT303eCV0030000000mDiP0?E>H00<0
?E>H0`00000203=4N0050000000cA7P0<dAh03=4N00000000P3om^h203eIZ`80e3dI00@0?EV[0?of
kP3om^h0ooK^0P3D?AT20?ofkP030000003om^h0ooK^00d0ooK^00<0e3dI0?ofkP0000001@3om^h2
0=@m6@T0ooK^00<0e3dI0?ofkP3om^h0203om^h20=@m6@H0ooK^00<0e3dI0?ofkP3om^h0;`3om^h0
0`000000ooK^0?ofkP0K0?ofkP40oooo000M0?ofkP030000003om^h0ooK^02l0ooK^00<0?EV[0?of
kP3om^h01P3om^h203eIZ`P0ooK^00<0?EV[0?ofkP3om^h02@3om^h203eIZ`@0ooK^00<0000003eI
Z`3om^h0303om^h2000000<0ooK^0`0mFJ/00`3om^h0e3dI0=@m6@020=@m6@80?EV[00<0ooK^0000
000V2P@00`0V2P@00`0000009PX40000000204HB2003000000164PP0AQ8800<0AQ8800D0000004HB
20164PP0?EV[0000000206HK3@030000001V6`d0IQ/=00@0IQ/=00H0000006HK3@0mFJ/0?EV[06HK
3@000002088T4003000000229100PR@@00D0PR@@00<0000003eIZ`2291000`229103000000P0VB/C
00<0000009T[4`2I:a<00`2I:a<203eIZ`0509T[4`000000VB/C03eIZ`0000000`2/<AH00`000000
[34F0:`a5P050:`a5P030000002/<AH0[34F00D0[34F00D000000:`a5P0mFJ/0[34F000000020;`f
60080000001=Km@0CFoD0000001<KLh0e3dI04a]cP00000604a]cP030000001<KLh0C6g>00H0C6g>
00T0000004a]cP1<KLh0C6g>0000003D?AT0BVW70000001:JLL00P3D?AT504YYa`030000001:JLL0
BVW700H0BVW70`00000404MT_0030=@m6@000000AfBl00H0AfBl00D0000004MT_017I;`0000004=M
[@020=@m6@0304=M[@000000@ef]00D0@ef]00D0000004=M[@13GJd000000=@m6@0203eCV0030000
000mDiP0?E>H00<0?E>H00H0000003eCV00mDiP0000003=4N000000403=4N0040000003om^h0e3dI
0=@m6@@0?EV[00@0ooK^0=@m6@3D?AT0e3dI0`3om^h2000000d0ooK^00<0e3dI0000003om^h00`3o
m^h20=@m6@/0ooK^00<0e3dI0?ofkP3om^h01P3om^h20=@m6@P0ooK^00<0e3dI0?ofkP3om^h0;`3o
m^h00`000000ooK^0?ofkP0K0?ofkP40oooo000L0?ofkP030000003om^h0ooK^0340ooK^00<0?EV[
0?ofkP3om^h01`3om^h203eIZ`H0ooK^00<0?EV[0?ofkP3om^h02`3om^h203eIZ`80ooK^00@0?EV[
0?ofkP00000000002P3om^h00`000000ooK^0?ofkP020?ofkP80?EV[00@0ooK^0=@m6@0mFJ/0?EV[
0P3D?AT30?ofkP80?EV[0`0V2P@00`0000009PX40000000204HB2003000000164PP0AQ8800<0AQ88
00D0000004HB20164PP0?EV[0000000306HK3@030000001V6`d0IQ/=00@0IQ/=00@0000006HK3@1V
6`d000000P0mFJ/3088T4003000000229100PR@@00@0PR@@00<0000003eIZ`2291000P2291001000
0000VB/C09T[4`00000809T[4`030000002I:a<0VB/C00D0VB/C0`0mFJ/00`000000[34F0:`a5P03
0:`a5P030000002/<AH0[34F00D0[34F00<000000:`a5P2/<AH0102/<AH010000000[34F03eIZ`00
00030;`f60080000001=Km@0CFoD04e_e0000000e3dI04a]cP00000604a]cP030000001<KLh0C6g>
00D0C6g>00<0000004a]cP1<KLh00`1<KLh0103D?AT000000=@m6@3D?AT704YYa`030000001:JLL0
BVW700D0BVW700D0000004YYa`1:JLL0BVW70000000304MT_0030=@m6@000000AfBl00D0AfBl00@0
000004MT_017I;`0AfBl0P3D?AT010000000@ef]04=M[@00000604=M[@0600000013GJd0@ef]04=M
[@000000e3dI0P0mDiP00`000000?E>H03eCV00303eCV0060000000mDiP0?E>H0000000cA7P00000
0`0cA7P20=@m6@80ooK^0`0mFJ/20=@m6@0403eIZ`3om^h0e3dI0=@m6@@0ooK^00<000000?ofkP3o
m^h0203om^h2000000040?ofkP3D?AT0ooK^0?ofkP80e3dI3@3om^h00`3D?AT0ooK^0?ofkP040?of
kP80e3dI2@3om^h00`3D?AT0ooK^0?ofkP0a0?ofkP030000003om^h0ooK^01X0ooK^0@3oool001`0
ooK^00<000000?ofkP3om^h0<@3om^h00`0mFJ/0ooK^0?ofkP090?ofkP80?EV[103om^h00`0mFJ/0
ooK^0?ofkP0=0?ofkP<0?EV[0`3om^h2000000L0ooK^00<000000?ofkP3om^h00P3om^h00`0mFJ/0
ooK^03eIZ`020=@m6@040?ofkP3D?AT0?EV[03eIZ`<0ooK^00<0000002H:100mFJ/00P0V2P@20000
00<0AQ8800<0000004HB20164PP00`164PP30000000303eIZ`1V6`d0IQ/=0080IQ/=00<0000006HK
3@1V6`d0101V6`d3000000<0PR@@00@0?EV[088T4022910000001P2291001@0mFJ/00000088T4022
9100000000@0VB/C00<0000009T[4`2I:a<01@2I:a<00`000000VB/C09T[4`0609T[4`030000000m
FJ/0[34F00D0[34F00<000000:`a5P2/<AH01@2/<AH00`000000[34F0:`a5P040:`a5P030000000m
FJ/0000000@0_3HH00<0000004e_e01=Km@00P1=Km@00`000000e3dI0000000604a]cP030000001<
KLh0C6g>00D0C6g>00<0000004a]cP1<KLh0101<KLh00`3D?AT0000004YYa`0704YYa`030000001:
JLL0BVW700D0BVW700<0000004YYa`1:JLL00P1:JLL01@000000AfBl04MT_0000000e3dI00H0AfBl
00@0000004MT_017I;`0e3dI0`17I;`3000000H0@ef]00<0000004=M[@13GJd00P13GJd0103D?AT0
000000000000000503eCV0040000000mDiP0?E>H03eCV08000000P0cA7P00`3D?AT0<dAh00000003
0?ofkP80e3dI00L0?EV[0?ofkP0mFJ/0?EV[0=@m6@3om^h0e3dI00@0ooK^00<000000?ofkP3om^h0
1@3om^h2000000<0ooK^0`3D?AT?0?ofkP030=@m6@3om^h0ooK^0080ooK^0P3D?AT;0?ofkP030=@m
6@3om^h0ooK^0340ooK^00<000000?ofkP3om^h06P3om^h10?ooo`00703om^h00`000000ooK^0?of
kP0a0?ofkP0303eIZ`3om^h0ooK^00/0ooK^0P0mFJ/20?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0
?EV[0?ofkP3om^h00`3om^h2000000<0ooK^0P0000030?ofkP80?EV[00@0ooK^03eIZ`3D?AT0ooK^
0P3D?AT00`3om^h0e3dI0?ofkP0203eIZ`040000000V2P@09PX402H:1080?EV[1@164PP00`000000
AQ8804HB200304HB20030000001V6`d0?EV[00D0IQ/=00<0000006HK3@1V6`d0101V6`d00`000000
PR@@088T4004088T4080?EV[00<00000088T402291000`2291000`0mFJ/0PR@@00000002000000D0
VB/C00<0000009T[4`2I:a<01@2I:a<00`000000VB/C09T[4`0409T[4`80000000@0?EV[0:`a5P0m
FJ/0?EV[102/<AH00`000000[34F0:`a5P050:`a5P030000002/<AH0[34F00@0[34F00<0000003eI
Z`2l=QP0102l=QP00`000000CFoD04e_e00304e_e0030=@m6@000000C6g>00D0C6g>00<0000004a]
cP1<KLh01@1<KLh00`000000C6g>04a]cP0204a]cP80e3dI00@0C6g>0=@m6@00000000001P1:JLL0
0`000000BVW704YYa`0504YYa`030000001:JLL0BVW700<0BVW70`0000000`17I;`0e3dI04MT_004
04MT_0030000003D?AT0e3dI00H0AfBl00<0000004=M[@13GJd01013GJd00`000000@ef]04=M[@03
04=M[@030=@m6@13GJd0000000D0?E>H00<0000003eCV00mDiP00`0mDiP20=@m6@80<dAh00D00000
0?ofkP3D?AT0e3dI03eIZ`020?ofkP80?EV[00@0ooK^03eIZ`3D?AT0ooK^0P3D?AT30?ofkP800000
0`3om^h2000000D0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP020=@m6@d0ooK^
00<0e3dI0?ofkP3om^h0<@3om^h00`000000ooK^0?ofkP0J0?ofkP40oooo000L0?ofkP030000003o
m^h0ooK^0340ooK^00<0?EV[0?ofkP3om^h03@3om^h303eIZa40ooK^0`0mFJ/50?ofkP<00000103o
m^h01P0mFJ/0ooK^0?ofkP3D?AT0?EV[0?ofkP80e3dI0P3om^h01@3D?AT0ooK^0?ofkP3D?AT0?EV[
00809PX40`00000203eIZ`<0AQ8800@0000004HB20164PP0AQ880`0000000`0mFJ/0IQ/=06HK3@04
06HK3@030000001V6`d0IQ/=0080IQ/=0`000008088T4080?EV[0`229100100mFJ/0PR@@088T4000
000709T[4`030000002I:a<0VB/C00H0VB/C00<0000009T[4`2I:a<00P2I:a<010000000[34F0:`a
5P0mFJ/30:`a5P80?EV[0P2/<AH00`000000[34F0:`a5P050:`a5P030000002/<AH0[34F0080[34F
0P0000000`0mFJ/0_3HH0;`f60040;`f60030000001=Km@0CFoD00@0CFoD00<0e3dI000000000000
101<KLh00`000000C6g>04a]cP0504a]cP030000001<KLh0C6g>0080e3dI0`1<KLh0103D?AT0C6g>
04a]cP00000404YYa`030000001:JLL0BVW700H0BVW700<0000004YYa`1:JLL01@1:JLL010000000
AfBl04MT_03D?AT304MT_080e3dI2017I;`3000000@0@ef]00<0000004=M[@13GJd01013GJd0103D
?AT0000000000000000303eCV0040000000mDiP0?E>H03eCV080e3dI0`00000203=4N0050=@m6@0m
FJ/0ooK^0?ofkP0mFJ/00P3om^h203eIZ`030?ofkP3D?AT0?EV[0080ooK^00<0e3dI0?ofkP3om^h0
0P3om^h3000000D0ooK^0`3D?ATA0?ofkP<0e3dI3`3om^h00`3D?AT0ooK^0?ofkP0a0?ofkP030000
003om^h0ooK^01X0ooK^0@3oool001/0ooK^00<000000?ofkP3om^h0<P3om^h00`0mFJ/0ooK^0?of
kP0?0?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h00P0mFJ/30?ofkP<000000`3o
m^h00`0mFJ/0ooK^0?ofkP020=@m6@0303eIZ`3D?AT0ooK^0080ooK^103D?AT010000000e3dI02H:
1000000204HB2003000000164PP0AQ880080?EV[00D0AQ88000000164PP0AQ880000000206HK3@03
03eIZ`1V6`d0IQ/=00D0IQ/=00D0000006HK3@1V6`d0IQ/=00000002088T4003000000229100PR@@
00H0PR@@00H00000088T400mFJ/0?EV[088T400mFJ/3000000L0VB/C00<0000009T[4`2I:a<01P2I
:a<00`000000VB/C09T[4`0200000080[34F00<0?EV[0000002/<AH0102/<AH203eIZ`030000002/
<AH0[34F00D0[34F00<000000:`a5P2/<AH00P0000020;`f600303eIZ`2l=QP0_3HH00@0_3HH00<0
000004e_e01=Km@0101=Km@00`3D?AT0CFoD04e_e00200000080C6g>00<0000004a]cP1<KLh01@1<
KLh00`000000e3dI0=@m6@0504a]cP040000003D?AT0C6g>04a]cP8000000P1:JLL00`000000BVW7
04YYa`0504YYa`030000001:JLL0BVW700H0BVW70`0000001P3D?AT0AfBl0=@m6@3D?AT0AfBl0000
00P0AfBl00@0000004MT_017I;`000000`13GJd00`000000@ef]04=M[@0504=M[@040=@m6@13GJd0
@ef]00000080?E>H00@0000003eCV03D?AT0e3dI0P0mDiP01@000000?E>H03eCV0000000<dAh00D0
?EV[103om^h0100mFJ/0e3dI03eIZ`0mFJ/20?ofkP040=@m6@3om^h0ooK^0?ofkP<000000`3om^h2
0=@m6@80ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0
ooK^0340ooK^00<000000?ofkP3om^h06P3om^h10?ooo`006`3om^h00`000000ooK^0?ofkP0b0?of
kP0303eIZ`3om^h0ooK^00l0ooK^0`0mFJ/?0?ofkP0303eIZ`3om^h0ooK^0080ooK^0P0mFJ/01000
0000ooK^0?ofkP3om^h20000000303eIZ`3om^h0ooK^00<0e3dI00<0?EV[0=@m6@3D?AT01`3D?AT0
1@0V2P@0000004HB20164PP0000000D0AQ880P0mFJ/01P164PP0000006HK3@1V6`d0?EV[000000L0
IQ/=00@0000006HK3@1V6`d00000102291000`000000PR@@088T4005088T4006000000229100PR@@
088T400mFJ/000000P2I:a<00`000000VB/C09T[4`0609T[4`030000002I:a<0VB/C00D0VB/C0`00
00030:`a5P0403eIZ`2/<AH0[34F000000H0[34F0P0mFJ/60:`a5P<000000`2l=QP00`0mFJ/00000
0;`f60050;`f60030000001=Km@0CFoD00@0CFoD00<000000=@m6@1=Km@00P1=Km@3000000H0C6g>
0P3D?AT604a]cP040000001<KLh0C6g>0=@m6@<0C6g>0`00000704YYa`030000001:JLL0BVW700D0
BVW700H0000004YYa`1:JLL0BVW70000003D?AT304MT_00300000017I;`0AfBl00D0AfBl00<00000
04MT_017I;`00P17I;`010000000@ef]04=M[@00000704=M[@060000003D?AT0@ef]04=M[@000000
?E>H0P3D?AT503eCV0050000000mDiP0?E>H0000000cA7P02@0mFJ/0103D?AT0?EV[03eIZ`0mFJ/2
0?ofkP030=@m6@000000000000<0ooK^00<000000=@m6@3D?AT0103om^h00`3D?AT0ooK^0?ofkP0=
0?ofkP<0e3dI4@3om^h00`3D?AT0ooK^0?ofkP0b0?ofkP030000003om^h0ooK^01T0ooK^0@3oool0
01/0ooK^00<000000?ofkP3om^h0<P3om^h303eIZ`l0ooK^00<0?EV[0?ofkP3om^h00P0mFJ/=0?of
kP0303eIZ`3om^h0ooK^0080ooK^0P00000203eIZ`<0ooK^00<0?EV[0000003D?AT0103D?AT0100m
FJ/0ooK^0?ofkP3om^h20=@m6@030?ofkP3D?AT00000008000000`164PP00`000000AQ8804HB2003
04HB208000000P0mFJ/0101V6`d0?EV[06HK3@00000706HK3@<000001@2291000`000000PR@@088T
4006088T4004000000229100?EV[00000080?EV[0P2I:a<00`000000VB/C09T[4`0509T[4`030000
002I:a<0VB/C00D0VB/C00<000000:`a5P2/<AH00P2/<AH01@0mFJ/0[34F0:`a5P2/<AH0000000H0
[34F00<000000:`a5P0mFJ/01@2/<AH00`000000_3HH0;`f60030;`f600303eIZ`000000_3HH00D0
_3HH00<0000004e_e01=Km@0101=Km@00`000000e3dI04e_e00404e_e0030000001<KLh0C6g>00<0
C6g>00<0e3dI04a]cP0000001P1<KLh01@000000C6g>04a]cP1<KLh0e3dI00@0C6g>00<0000004YY
a`1:JLL01@1:JLL00`000000BVW704YYa`0504YYa`030000001:JLL0BVW70080e3dI00@000000=@m
6@17I;`000002017I;`00`000000AfBl04MT_00304MT_0<000001`13GJd010000000@ef]0=@m6@13
GJd20=@m6@8000001@0mDiP010000000?E>H03eCV00mDiP2000000040?ofkP0mFJ/0ooK^03eIZ`@0
ooK^00<0e3dI03eIZ`0mFJ/00`0mFJ/00`000000e3dI0?ofkP020?ofkP80e3dI0P0000040?ofkP03
0=@m6@3om^h0ooK^00/0ooK^0P3D?AT20?ofkP030=@m6@3om^h0ooK^00d0ooK^0`3D?ATd0?ofkP03
0000003om^h0ooK^01T0ooK^0@3oool001/0ooK^00<000000?ofkP3om^h0<`3om^h0100mFJ/0ooK^
03eIZ`0mFJ/=0?ofkP0303eIZ`3om^h0ooK^0080ooK^0P0mFJ/;0?ofkP0503eIZ`3om^h0ooK^0?of
kP000000103om^h303eIZ`030?ofkP3D?AT0ooK^0080e3dI0P3om^h00`0mFJ/0ooK^0?ofkP020=@m
6@040?ofkP3D?AT0ooK^000000D0AQ8800<0000004HB20164PP00`164PP01@000000IQ/=06HK3@1V
6`d0?EV[0080IQ/=00<0000006HK3@1V6`d01@1V6`d00`000000PR@@088T4005088T400300000022
9100PR@@00H0PR@@00<0000003eIZ`0000000`2I:a<203eIZ`030000002I:a<0VB/C00D0VB/C00<0
000009T[4`2I:a<00`2I:a<3000000@0[34F00D0?EV[0:`a5P2/<AH0[34F000000070:`a5P050000
002/<AH0?EV[03eIZ`2/<AH00`0000040;`f600303eIZ`2l=QP0000000H0_3HH00<0000004e_e01=
Km@0101=Km@00`000000CFoD0=@m6@0404e_e0<0000000D0C6g>0=@m6@3D?AT0C6g>0000000704a]
cP050000001<KLh0C6g>04a]cP3D?AT0101<KLh3000000D0BVW700<0000004YYa`1:JLL01@1:JLL0
0`000000e3dI0=@m6@0304YYa`030000003D?AT0000000P0AfBl00<0000004MT_017I;`01@17I;`0
0`000000@ef]04=M[@0404=M[@0500000013GJd0@ef]04=M[@3D?AT00`13GJd00`000000?E>H03eC
V00303eCV0030000000mDiP0?E>H00<0?E>H00@000000?ofkP0mFJ/0ooK^0P0mFJ/20?ofkP030=@m
6@3om^h0ooK^0080?EV[00<0ooK^03eIZ`3om^h00`3D?AT40?ofkP050000003om^h0ooK^0?ofkP3D
?AT02`3om^h20=@m6@@0ooK^00<0e3dI0?ofkP3om^h02`3om^h20=@m6@030?ofkP3D?AT0ooK^03@0
ooK^00<000000?ofkP3om^h06@3om^h10?ooo`006`3om^h00`000000ooK^0?ofkP0c0?ofkP0403eI
Z`3om^h0ooK^0?ofkP80?EV[2`3om^h00`0mFJ/0ooK^0?ofkP040?ofkP80?EV[2@3om^h0100mFJ/0
ooK^0?ofkP0000050?ofkPD0?EV[00D0e3dI0?ofkP3om^h0000003eIZ`020?ofkP@0e3dI0P3om^h0
0`000000AQ8804HB200304HB2004000000164PP0AQ8804HB20<000000P1V6`d01P0mFJ/0IQ/=03eI
Z`0mFJ/0IQ/=000000@0IQ/=0`000007088T4003000000229100PR@@00H0PR@@00<0?EV[09T[4`2I
:a<01@2I:a<203eIZ`H0VB/C00@0000009T[4`2I:a<0VB/C0P0000030:`a5P040000002/<AH0[34F
03eIZ`@0[34F00<000000:`a5P2/<AH01@2/<AH010000000[34F0:`a5P00000203eIZ`030;`f6000
0000_3HH00<0_3HH00<0?EV[0;`f600000001P2l=QP00`000000CFoD04e_e00404e_e0030000001=
Km@0e3dI00@0CFoD00D0000004e_e03D?AT0e3dI0000000204a]cP030000001<KLh0C6g>00D0C6g>
00<0000004a]cP1<KLh00P1<KLh0103D?AT0C6g>04a]cP00000304a]cP8000000P1:JLL00`000000
BVW704YYa`0504YYa`80e3dI1`1:JLL00`3D?AT0AfBl04MT_00604MT_00300000017I;`0AfBl00D0
AfBl0`00000404=M[@0600000013GJd0e3dI0=@m6@13GJd0e3dI0P13GJd3000000<0?E>H00<00000
03eCV00mDiP00`0mDiP00`000000ooK^0?ofkP0203eIZ`060?ofkP0mFJ/0ooK^0?ofkP3D?AT00000
0P3om^h00`0mFJ/0e3dI0=@m6@030=@m6@D0ooK^00@000000?ofkP3om^h0e3dI2@3om^h20=@m6@H0
ooK^00<0e3dI0?ofkP3om^h02@3om^h20=@m6@<0ooK^00<0e3dI0?ofkP3om^h0<`3om^h00`000000
ooK^0?ofkP0I0?ofkP40oooo000J0?ofkP030000003om^h0ooK^03@0ooK^00<0?EV[0?ofkP3om^h0
0`3om^h203eIZ`T0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eI
Z`000000000000D0ooK^00<0?EV[0?ofkP3D?AT00P3D?AT303eIZ`80ooK^00D0?EV[0=@m6@3D?AT0
ooK^0=@m6@040?ofkP03000000164PP0AQ880080AQ8800<0000004HB20164PP00P00000206HK3@03
0000001V6`d0?EV[00@0IQ/=0P0mFJ/306HK3@04000000229100PR@@000000L0PR@@00<00000088T
40229100102291020000000303eIZ`2I:a<0VB/C00D0VB/C00<0000009T[4`0mFJ/01P2I:a<30000
00D0[34F00<000000:`a5P0mFJ/01@2/<AH00`000000[34F0:`a5P050:`a5P<000000`2l=QP203eI
Z`<0_3HH00@0?EV[0;`f602l=QP000001P2l=QP00`000000CFoD04e_e00404e_e0040000001=Km@0
CFoD0=@m6@<0CFoD0P3D?AT304e_e0<000001`1<KLh00`000000C6g>04a]cP0304a]cP030=@m6@1<
KLh0000000D0C6g>0`00000604YYa`030=@m6@000000BVW700L0BVW700<0e3dI0000000000001P17
I;`00`000000AfBl04MT_00504MT_00400000017I;`0AfBl000000<0@ef]0P3D?AT404=M[@030=@m
6@13GJd000000080@ef]0P00000203eCV0030000000mDiP0?E>H0080?E>H00<000000?ofkP3om^h0
0P3om^h01@0mFJ/0ooK^03eIZ`0mFJ/0e3dI0080ooK^0`3D?AT303eIZ`030?ofkP3D?AT0ooK^00@0
ooK^0P0000000`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3o
m^h01`3om^h20=@m6@@0ooK^00<0e3dI0?ofkP3om^h0=@3om^h00`000000ooK^0?ofkP0H0?ofkP40
oooo000J0?ofkP030000003om^h0ooK^03D0ooK^00<0?EV[0?ofkP3om^h0103om^h203eIZ`P0ooK^
00<0?EV[0?ofkP3om^h01P3om^h203eIZ`H0ooK^00<000000?ofkP3om^h00`3om^h203eIZ`030?of
kP3D?AT0e3dI00<0e3dI00<0ooK^03eIZ`0mFJ/00P0mFJ/0103om^h0e3dI0=@m6@3D?AT30?ofkP03
000000164PP0AQ8800<0AQ880`00000406HK3@030000000mFJ/0IQ/=00D0IQ/=00@0000003eIZ`0m
FJ/00000102291000`000000PR@@088T4004088T4003000000229100PR@@00<0PR@@00D0000009T[
4`0mFJ/0VB/C0000000709T[4`040000002I:a<0?EV[03eIZ`@0VB/C00<000000:`a5P2/<AH01@2/
<AH00`000000?EV[0:`a5P050:`a5P030000002/<AH0[34F00D0[34F00<000000;`f602l=QP01@2l
=QP203eIZ`030;`f600mFJ/0_3HH0080_3HH00<000000;`f602l=QP00`2l=QP00`000000CFoD04e_
e00304e_e0060000001=Km@0CFoD04e_e03D?AT0CFoD0P3D?AT704e_e0030000001<KLh0C6g>00D0
C6g>00<0000004a]cP1<KLh0101<KLh00`3D?AT0000004a]cP0604a]cP030000001:JLL0BVW70080
BVW70P3D?AT00`1:JLL0000004YYa`0604YYa`050000001:JLL0e3dI04YYa`0000001@17I;`00`00
0000AfBl04MT_00404MT_00300000017I;`0AfBl0080AfBl00@000000=@m6@3D?AT000001P13GJd0
0`3D?AT0000004=M[@0304=M[@<000001@0mDiP010000000ooK^0?ofkP3om^h303eIZ`030?ofkP3D
?AT0e3dI0080e3dI00<0ooK^03eIZ`0mFJ/00`0mFJ/00`3om^h0e3dI0=@m6@050?ofkP030000003o
m^h0ooK^00@0ooK^0P3D?AT80?ofkP030=@m6@3om^h0ooK^00H0ooK^0P3D?AT60?ofkP030=@m6@3o
m^h0ooK^03D0ooK^00<000000?ofkP3om^h0603om^h10?ooo`006P3om^h00`000000ooK^0?ofkP0e
0?ofkP0303eIZ`3om^h0ooK^00H0ooK^0P0mFJ/60?ofkP0303eIZ`3om^h0ooK^00P0ooK^0P0mFJ/2
0?ofkP80000000<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0=@m6@030=@m6@030?ofkP3D?AT0
ooK^0080ooK^00@0e3dI03eIZ`0mFJ/0?EV[0P3om^h01@3D?AT000000?ofkP3om^h0000000D0AQ88
00<0000006HK3@1V6`d0101V6`d00`0mFJ/0IQ/=06HK3@0506HK3@<000000P0mFJ/3088T40030000
00229100PR@@00D0PR@@00<00000088T402291000P0000001@2I:a<0?EV[09T[4`2I:a<0000000L0
VB/C00@0000009T[4`2I:a<0VB/C0P0mFJ/3000000P0[34F00<0?EV[0:`a5P2/<AH01@2/<AH00`00
0000[34F0:`a5P020:`a5P<000001`2l=QP00`000000_3HH03eIZ`040;`f60030000002l=QP0_3HH
00<0_3HH00<0000004e_e01=Km@00`1=Km@00`000000CFoD04e_e00204e_e0030=@m6@1=Km@00000
00L0CFoD0`00000404a]cP030000001<KLh0C6g>00D0C6g>00<0e3dI04a]cP1<KLh01P1<KLh30000
0080e3dI0`1:JLL00`000000BVW704YYa`0504YYa`050000001:JLL0BVW70=@m6@1:JLL00P000002
04MT_00300000017I;`0AfBl00D0AfBl00@0000004MT_017I;`0AfBl0P3D?AT3000000L0@ef]00<0
e3dI04=M[@13GJd01013GJd00`000000?E>H03eCV00303eCV0050000003om^h0ooK^0000000mFJ/0
0P3om^h30=@m6@0403eIZ`3om^h0ooK^03eIZ`80ooK^100mFJ/00`3om^h0e3dI0?ofkP030?ofkP03
0=@m6@00000000000080ooK^0P3D?AT:0?ofkP030=@m6@3om^h0ooK^00@0ooK^0P3D?AT80?ofkP03
0=@m6@3om^h0ooK^03D0ooK^00<000000?ofkP3om^h0603om^h10?ooo`006P3om^h00`000000ooK^
0?ofkP0f0?ofkP0303eIZ`3om^h0ooK^00L0ooK^0P0mFJ/40?ofkP0303eIZ`3om^h0ooK^00X0ooK^
00D0?EV[0000003om^h0ooK^03eIZ`020?ofkP80?EV[1@3D?AT20?ofkPH0e3dI0`0mFJ/00`3D?AT0
ooK^0?ofkP03000000<0AQ880`00000506HK3@0303eIZ`000000IQ/=00H0IQ/=00<00000088T4022
91000P229100100mFJ/0PR@@088T40000007088T40030=@m6@00000000000080VB/C00D0?EV[09T[
4`2I:a<0VB/C0000000709T[4`030000002I:a<0VB/C0080VB/C00D0000003eIZ`2/<AH0[34F0000
00060:`a5P0303eIZ`000000[34F00H0[34F00<000000:`a5P2/<AH00P0000020;`f60030000002l
=QP0_3HH00D0_3HH00<0000003eIZ`2l=QP00P0mFJ/20;`f60030000002l=QP0_3HH00<0_3HH00<0
000004e_e01=Km@00`1=Km@00`000000CFoD04e_e0020=@m6@0304e_e03D?AT0000000L0CFoD00<0
000004e_e01=Km@00P00000204a]cP030000001<KLh0C6g>00D0C6g>00<000000=@m6@1<KLh01@1<
KLh01@000000C6g>04a]cP3D?AT0000000@0BVW700<0000004YYa`1:JLL01@1:JLL01@000000BVW7
04YYa`1:JLL0e3dI0080BVW70P0000000`0mFJ/0AfBl04MT_00504MT_00400000017I;`0AfBl0=@m
6@@0AfBl00<0000004=M[@13GJd01@13GJd00`000000e3dI04=M[@0404=M[@<000000`0mDiP30000
00030?ofkP0mFJ/0ooK^00<0e3dI1P0mFJ/20?ofkPD0?EV[0P3D?AT20?ofkP050=@m6@3om^h0ooK^
0000003D?AT0303om^h00`3D?AT0ooK^0?ofkP020?ofkP80e3dI2@3om^h00`3D?AT0ooK^0?ofkP0f
0?ofkP030000003om^h0ooK^01P0ooK^0@3oool001X0ooK^00<000000?ofkP3om^h0=P3om^h00`0m
FJ/0ooK^0?ofkP090?ofkP80?EV[0P3om^h00`0mFJ/0ooK^0?ofkP090?ofkP80000000T0ooK^03eI
Z`0mFJ/0?EV[0?ofkP0mFJ/0ooK^0=@m6@3om^h01`3D?AT30?ofkP050=@m6@3om^h0?EV[0?ofkP3D
?AT00P0mFJ/30=@m6@04000000164PP0AQ8800000080IQ/=00@0000006HK3@1V6`d0IQ/=0P0mFJ/0
0`1V6`d0000006HK3@0406HK3@<000001@22910203eIZ`03000000229100PR@@00D0PR@@00D00000
09T[4`2I:a<0VB/C03eIZ`0409T[4`030000002I:a<0VB/C00D0VB/C00D0000009T[4`2I:a<0VB/C
000000020:`a5P80?EV[00<000000:`a5P2/<AH00`2/<AH00`0mFJ/0[34F000000070:`a5P<00000
1@2l=QP00`000000_3HH0;`f60040;`f60030000000mFJ/0_3HH0080_3HH00<0?EV[0;`f60000000
1@2l=QP00`000000CFoD04e_e00304e_e0030000001=Km@0e3dI00<0CFoD00<0e3dI0000001=Km@0
1@1=Km@00`000000CFoD04e_e00304e_e0<000001`1<KLh00`000000C6g>0=@m6@0504a]cP030000
003D?AT0e3dI0080C6g>00@0000004YYa`1:JLL00000201:JLL00`000000BVW704YYa`0204YYa`05
0=@m6@1:JLL0BVW704YYa`0000001`17I;`00`000000e3dI0=@m6@0504MT_0<000001@13GJd01000
0000@ef]0=@m6@3D?AT304=M[@0400000013GJd0@ef]00000080?E>H00@0000003eIZ`0mFJ/0?EV[
0P3D?AT01@0mFJ/0ooK^0=@m6@3om^h0?EV[00<0ooK^1`0mFJ/01@3om^h0?EV[0?ofkP3D?AT0ooK^
00<0e3dI00<0ooK^0000000000002`3om^h00`3D?AT0ooK^0?ofkP020=@m6@/0ooK^00<0e3dI0?of
kP3om^h0=P3om^h00`000000ooK^0?ofkP0H0?ofkP40oooo000I0?ofkP030000003om^h0ooK^03P0
ooK^0P0mFJ/;0?ofkP<0?EV[2P3om^h00`000000ooK^0?ofkP030?ofkP80?EV[1P3D?AT30?ofkP05
0=@m6@3om^h0ooK^0?ofkP3D?AT00P3om^h0100mFJ/0ooK^0?ofkP3D?AT303eIZ`04000000164PP0
AQ88000000<0IQ/=00@0000006HK3@1V6`d0?EV[0`1V6`d010000000IQ/=06HK3@1V6`d200000080
PR@@00<00000088T402291001@22910203eIZ`@0PR@@0`00000209T[4`0303eIZ`2I:a<0VB/C00@0
VB/C00<0000009T[4`2I:a<01@2I:a<3000000D0[34F0P0mFJ/30:`a5P0503eIZ`2/<AH0[34F0:`a
5P0000001P2/<AH00`000000_3HH0;`f60050;`f60030000002l=QP0_3HH00@0_3HH00<0?EV[0;`f
602l=QP00`2l=QP00`0mFJ/000000;`f60020;`f60D000000`1=Km@00`000000e3dI04e_e00404e_
e0030=@m6@1=Km@0CFoD00@0CFoD00<0000004e_e01=Km@01@1=Km@00`000000C6g>04a]cP0404a]
cP050000001<KLh0C6g>04a]cP3D?AT00`1<KLh20=@m6@D0C6g>0`00000704YYa`030000001:JLL0
BVW700@0BVW700<0e3dI04YYa`1:JLL00`00000404MT_080e3dI1`17I;`00`000000AfBl04MT_002
000000<0@ef]00D0000004=M[@13GJd0@ef]0=@m6@0204=M[@0500000013GJd0@ef]04=M[@000000
0P0mDiP01@000000e3dI0=@m6@3D?AT0?EV[0080ooK^00@0e3dI0?ofkP3om^h0?EV[0`3om^h0100m
FJ/0ooK^0?ofkP3om^h603eIZ`80e3dI1@3om^h00`000000ooK^0?ofkP080?ofkP<0e3dI2`3om^h2
0=@m6CX0ooK^00<000000?ofkP3om^h05`3om^h10?ooo`006@3om^h00`000000ooK^0?ofkP0i0?of
kP<0?EV[2`3om^h00`0mFJ/0ooK^0?ofkP070?ofkP030000003om^h0ooK^00<0ooK^100mFJ/30=@m
6@@0ooK^00<0e3dI0?ofkP3om^h00P3D?AT30?ofkP0403eIZ`3om^h0ooK^0=@m6@80ooK^0`0mFJ/0
0`000000IQ/=06HK3@0206HK3@030000001V6`d0?EV[00@0IQ/=00@0000006HK3@00000000001@22
91000`000000PR@@088T4005088T40030000000mFJ/0?EV[008000000`2I:a<00`000000VB/C03eI
Z`0609T[4`030000002I:a<0VB/C00D0VB/C00<000000:`a5P2/<AH01P2/<AH01@000000?EV[03eI
Z`2/<AH0?EV[00<0[34F00<000000:`a5P2/<AH00P2/<AH3000000L0_3HH00<000000;`f602l=QP0
0`2l=QP00`0mFJ/000000;`f60050;`f6080?EV[00D0_3HH0000003:>QT0bSXI0000000204iaf@04
0000001=Km@0e3dI0=@m6@H0CFoD00<000000=@m6@1=Km@0101=Km@00`000000CFoD04e_e00504e_
e0<00000101<KLh01P000000C6g>04a]cP1<KLh0e3dI04a]cP80e3dI00<0000004a]cP1<KLh01P1<
KLh00`000000BVW704YYa`0504YYa`030000001:JLL0BVW700@0BVW700<0e3dI04YYa`0000000`1:
JLL200000080e3dI00<0000004MT_017I;`01@17I;`00`000000AfBl04MT_00304MT_080000000<0
@ef]00000013GJd00`13GJd00`3D?AT0@ef]0000000404=M[@040000003D?AT0e3dI0=@m6@80ooK^
00@0?EV[0?ofkP3om^h0e3dI0`3om^h203eIZ`030?ofkP0mFJ/0ooK^00@0ooK^0`0mFJ/40=@m6@D0
ooK^00<000000?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP090?ofkP<0e3dI>`3om^h00`000000
ooK^0?ofkP0G0?ofkP40oooo000I0?ofkP030000003om^h0ooK^03T0ooK^00<0?EV[0?ofkP3om^h0
0P0mFJ/90?ofkP<0?EV[1@3om^h2000000@0ooK^0P0mFJ/0103D?AT0?EV[03eIZ`3om^h203eIZ`D0
ooK^00<0e3dI0?ofkP3D?AT01@3om^h0100mFJ/0ooK^0?ofkP3D?AT30?ofkP040000000mFJ/0?EV[
03eIZ`<0IQ/=00<0000003eIZ`1V6`d0101V6`d2000000L0PR@@00<00000088T402291001@229103
00000080?EV[0`2I:a<00`000000?EV[09T[4`0609T[4`030000002I:a<0VB/C00<0VB/C0`000008
0:`a5P040000002/<AH0[34F03eIZ`@0[34F00D000000:`a5P2/<AH0[34F000000030;`f60030000
002l=QP0_3HH00@0_3HH00<000000;`f602l=QP00P2l=QP00`0mFJ/0_3HH000000060;`f60800000
00D0?EV[0<Xj6@3:>QT0bSXI0000000304iaf@030=@m6@000000000000H0CFoD00<0000004e_e03D
?AT0101=Km@00`000000CFoD04e_e00404e_e0050000001=Km@0CFoD04e_e00000000`1<KLh00`00
0000C6g>04a]cP0204a]cP040=@m6@1<KLh0C6g>000000P0C6g>0`00000504YYa`030000001:JLL0
BVW700D0BVW700<0e3dI0000001:JLL00P1:JLL20=@m6@<000001`17I;`00`000000AfBl04MT_005
04MT_08000001@13GJd00`3D?AT0000004=M[@0204=M[@<0e3dI00D000000?ofkP3om^h0ooK^03eI
Z`020?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0?EV[0?ofkP0mFJ/01@3om^h20=@m6@040?ofkP3D
?AT0e3dI03eIZ`80e3dI103om^h2000000D0ooK^0`3D?AT90?ofkP80e3dI00<0ooK^0=@m6@3om^h0
>`3om^h00`000000ooK^0?ofkP0G0?ofkP40oooo000I0?ofkP030000003om^h0ooK^03X0ooK^00@0
?EV[0?ofkP3om^h0ooK^0P0mFJ/80?ofkP0403eIZ`3om^h0?EV[03eIZ`80ooK^00<000000?ofkP3o
m^h00P3om^h203eIZ`<0e3dI00D0?EV[0?ofkP0mFJ/0?EV[0?ofkP0203eIZ`80ooK^0`3D?AT50?of
kP0503eIZ`3om^h0ooK^0?ofkP3D?AT00`3om^h010000000IQ/=06HK3@1V6`d203eIZ`0306HK3@0m
FJ/0IQ/=00<0IQ/=0`000008088T4003000000229100PR@@00D0PR@@00<0000009T[4`2I:a<00P2I
:a<203eIZ`0309T[4`0mFJ/0VB/C00L0VB/C00@0000009T[4`2I:a<0VB/C0P0000030:`a5P030000
002/<AH0[34F00D0[34F00@000000:`a5P0mFJ/0[34F0P0mFJ/30:`a5P<00000102l=QP00`000000
_3HH0;`f60040;`f60030000002l=QP0_3HH0080_3HH00@0?EV[0;`f602l=QP000001@2l=QP00`00
0000bSXI0<Xj6@0203eIZ`030<Xj6@000000CW7I0080e3dI0P1>LMT00`000000CFoD04e_e00304e_
e0040000001=Km@0CFoD0=@m6@<0CFoD00<0000004e_e01=Km@01@1=Km@00`000000CFoD04e_e002
04e_e0<000000`1<KLh20=@m6@0404a]cP3D?AT0C6g>000000L0C6g>00@0000004a]cP1<KLh0C6g>
0P00000304YYa`030000001:JLL0BVW700H0BVW700@0e3dI04YYa`3D?AT0e3dI101:JLL00`000000
AfBl04MT_00504MT_00300000017I;`0AfBl00H0AfBl0`00000404=M[@040=@m6@13GJd0e3dI0=@m
6@<0@ef]00D000000?ofkP3om^h0ooK^03eIZ`020?ofkP030=@m6@3om^h0ooK^00@0ooK^0P0mFJ/3
0?ofkP80e3dI00D0ooK^0=@m6@3D?AT0ooK^0=@m6@0303eIZ`80e3dI103om^h00`000000ooK^0?of
kP020=@m6@030?ofkP3D?AT0ooK^00L0ooK^0P3D?AT30?ofkP030=@m6@3om^h0ooK^03X0ooK^00<0
00000?ofkP3om^h05`3om^h10?ooo`00603om^h00`000000ooK^0?ofkP0l0?ofkP0303eIZ`3om^h0
ooK^0080ooK^0P0mFJ/60?ofkP0403eIZ`3om^h0ooK^0?ofkP8000000`3om^h203eIZ`030?ofkP3D
?AT0e3dI0080ooK^00@0?EV[0=@m6@3om^h0ooK^0P0mFJ/0103om^h0?EV[03eIZ`3D?AT70?ofkP04
03eIZ`3om^h0ooK^0=@m6@<0ooK^00<0e3dI0000001V6`d00P1V6`d0100mFJ/0IQ/=03eIZ`000003
06HK3@05000000229100PR@@088T400000001`2291000`000000PR@@088T4003088T40<000001P2I
:a<00`0mFJ/0VB/C0000000809T[4`<000001@2/<AH00`000000[34F0:`a5P060:`a5P0303eIZ`2/
<AH0[34F0080[34F0P0mFJ/00`2/<AH000000;`f60050;`f60030000002l=QP0_3HH00D0_3HH00@0
00000;`f602l=QP0?EV[0`2l=QP010000000_3HH0;`f602l=QP3000000@0bSXI00<0?EV[0000003D
?AT0101>LMT3000000<0CFoD00D0000004e_e01=Km@0CFoD0=@m6@0204e_e0030000001=Km@0CFoD
00D0CFoD00<0000004e_e01=Km@0101=Km@010000000C6g>0=@m6@3D?AT404a]cP030=@m6@1<KLh0
C6g>00H0C6g>00<0000004a]cP1<KLh00`1<KLh3000000P0BVW700<0000004YYa`3D?AT01P1:JLL3
000000D0AfBl00<0000004MT_017I;`01@17I;`01@000000AfBl04MT_017I;`0000000<0@ef]00@0
00000=@m6@13GJd0e3dI0`13GJd01@000000?EV[0?ofkP3om^h0?EV[00<0ooK^00<0e3dI0?ofkP3o
m^h01@3om^h0100mFJ/0e3dI0=@m6@3om^h20=@m6@80ooK^00@0?EV[0=@m6@3om^h0ooK^0P0mFJ/0
0`3om^h0e3dI0=@m6@030?ofkP8000000`3om^h00`3D?AT0ooK^0?ofkP040?ofkP80e3dI103om^h0
0`3D?AT0ooK^0?ofkP0l0?ofkP030000003om^h0ooK^01H0ooK^0@3oool001P0ooK^00<000000?of
kP3om^h0?@3om^h203eIZ`@0ooK^0P0mFJ/40?ofkP0403eIZ`3om^h0ooK^00000080ooK^0`0mFJ/2
0?ofkP030=@m6@3om^h0ooK^0080e3dI00<0?EV[0=@m6@3om^h00`3om^h203eIZ`030=@m6@0mFJ/0
?EV[00H0ooK^00@0?EV[0?ofkP3om^h0e3dI0P3om^h00`3D?AT0ooK^0000000306HK3@80?EV[00D0
IQ/=03eIZ`0mFJ/0IQ/=00000004088T4003000000229100PR@@00D0PR@@00<00000088T40229100
0P2291001@000000VB/C09T[4`2I:a<0000000@0VB/C00@0?EV[09T[4`0mFJ/0?EV[202I:a<00`00
0000[34F0:`a5P060:`a5P030000002/<AH0[34F00@0[34F00<0?EV[0000002/<AH0102/<AH00`00
0000?EV[03eIZ`060;`f60030000002l=QP0_3HH00D0_3HH00<000000;`f600mFJ/0102l=QP01000
0000_3HH0000000000020<Xj6@030000003:>QT0bSXI00<0bSXI00<0000004iaf@1>LMT00`1>LMT0
0`000000CW7I04iaf@020000000304e_e0000000CFoD00<0CFoD00<0e3dI04e_e00000001`1=Km@0
0`000000CFoD04e_e00404e_e080e3dI00<0000004a]cP1<KLh00`1<KLh00`000000e3dI04a]cP05
04a]cP030000001<KLh0C6g>00H0C6g>00<0000004YYa`1:JLL01P1:JLL20=@m6@0304YYa`3D?AT0
BVW700<0BVW700D0000004YYa`1:JLL0BVW70000000404MT_00300000017I;`0AfBl00D0AfBl00<0
000004MT_017I;`00P17I;`01@000000@ef]0=@m6@3D?AT0@ef]0080e3dI0`13GJd00`000000ooK^
03eIZ`020?ofkP0403eIZ`3om^h0ooK^0=@m6@H0ooK^0P3D?AT00`0mFJ/0e3dI0=@m6@040?ofkP04
0=@m6@3om^h0?EV[03eIZ`80ooK^00<0?EV[0?ofkP3om^h00`3D?AT20?ofkP030000003om^h0e3dI
00D0ooK^0P3D?AT40?ofkP80e3dI?`3om^h00`000000ooK^0?ofkP0F0?ofkP40oooo000H0?ofkP03
0000003om^h0ooK^03h0ooK^1@0mFJ/20?ofkP80?EV[0`3om^h2000000@0?EV[00@0ooK^03eIZ`0m
FJ/0e3dI0P3om^h01@3D?AT0ooK^0?ofkP3D?AT0?EV[00<0ooK^0P3D?AT0103om^h0?EV[03eIZ`3o
m^h203eIZ`@0ooK^00<0?EV[0?ofkP3om^h00`3D?AT20?ofkP040000001V6`d0IQ/=03eIZ`<0IQ/=
0P00000203eIZ`@0PR@@00<00000088T402291001P22910010000000PR@@088T4000000409T[4`05
0000002I:a<0VB/C09T[4`0mFJ/0102I:a<203eIZ`@0VB/C0`0000080:`a5P030000002/<AH0[34F
00@0[34F00<0?EV[0000002/<AH00P2/<AH2000000<0_3HH0P0mFJ/50;`f60030000002l=QP0_3HH
00@0_3HH00<0000003eIZ`2l=QP0102l=QP2000000@0bSXI00<000000<Xj6@3:>QT00`3:>QT00`00
0000CW7I04iaf@0304iaf@030000001>LMT0CW7I0080CW7I0P00000504e_e0030=@m6@000000CFoD
00D0CFoD00<0000004e_e01=Km@00`1=Km@20=@m6@<0CFoD0P00000304a]cP030000003D?AT0C6g>
00D0C6g>00<0000004a]cP1<KLh01P1<KLh3000000@0BVW70P3D?AT404YYa`050=@m6@1:JLL0BVW7
04YYa`000000101:JLL010000000AfBl04MT_000000804MT_00300000017I;`0AfBl0080AfBl0P3D
?AT2000000<0@ef]00@0e3dI04=M[@13GJd000000P3om^h303eIZ`80ooK^00<0e3dI0?ofkP3om^h0
0P3om^h20=@m6@040?ofkP3D?AT0e3dI0?ofkP80?EV[0`3om^h01@3D?AT0?EV[0?ofkP3om^h0?EV[
0080ooK^00@0?EV[0=@m6@3D?AT0ooK^103D?AT2000000<0ooK^0P3D?AT20?ofkPD0e3dI@03om^h0
0`000000ooK^0?ofkP0F0?ofkP40oooo000H0?ofkP030000003om^h0ooK^0400ooK^0P0mFJ/00`3o
m^h0?EV[03eIZ`0403eIZ`030000000mFJ/0ooK^00<0ooK^0P0mFJ/01@3om^h0e3dI03eIZ`0mFJ/0
e3dI0080ooK^00<0e3dI0?ofkP0mFJ/00P3om^h01P3D?AT0ooK^0?ofkP3om^h0e3dI0?ofkP80?EV[
00<0ooK^03eIZ`0mFJ/00P3om^h0100mFJ/0ooK^0?ofkP3D?AT40?ofkP030000001V6`d0?EV[00@0
IQ/=00@00000088T40229100PR@@0P0mFJ/2088T4003000000229100PR@@00H0PR@@0`00000509T[
4`040000002I:a<0VB/C03eIZ`D0VB/C00H0000009T[4`0mFJ/0?EV[09T[4`0000030:`a5P030000
002/<AH0[34F00H0[34F00<000000:`a5P2/<AH00P2/<AH00`0mFJ/0[34F0:`a5P03000000D0_3HH
00<000000;`f600mFJ/0102l=QP00`000000_3HH0;`f60040;`f60030000000mFJ/0_3HH0080_3HH
0`0000050<Xj6@030000003:>QT0bSXI00<0bSXI00<0000004iaf@1>LMT00`1>LMT00`000000CW7I
04iaf@0304iaf@<000000`1=Km@00`3D?AT0000004e_e00504e_e0030000001=Km@0CFoD0080CFoD
00<0e3dI04e_e00000001@1=Km@300000080C6g>00<0e3dI04a]cP1<KLh00P1<KLh00`000000C6g>
04a]cP0604a]cP060000001<KLh0C6g>04a]cP000000BVW70P3D?AT00`1:JLL0000004YYa`0404YY
a`040=@m6@1:JLL0BVW7000000D0BVW70`00000704MT_00400000017I;`0AfBl04MT_080e3dI0`17
I;`00`000000@ef]04=M[@0204=M[@030=@m6@000000ooK^00@0ooK^00@0?EV[0?ofkP3om^h0e3dI
0P3om^h20=@m6@050?ofkP3D?AT0e3dI0?ofkP0mFJ/00`3om^h01P0mFJ/0ooK^0?ofkP3D?AT0ooK^
03eIZ`80ooK^00D0?EV[0=@m6@3D?AT0?EV[0?ofkP020=@m6@@0ooK^00<0e3dI0000003D?AT01@3D
?AT00`3om^h0e3dI0=@m6@120?ofkP030000003om^h0ooK^01H0ooK^0@3oool001P0ooK^00<00000
0?ofkP3om^h0@P3om^h203eIZ`80ooK^0P0mFJ/010000000?EV[03eIZ`0mFJ/50?ofkP80?EV[00P0
e3dI0?ofkP0mFJ/0?EV[0?ofkP3D?AT0ooK^03eIZ`80e3dI103om^h0103D?AT0ooK^0?ofkP3om^h2
03eIZ`040?ofkP0mFJ/0?EV[03eIZ`<0e3dI103om^h203eIZ`@0IQ/=0P000005088T4080?EV[00<0
PR@@0000002291001P2291000`000000VB/C09T[4`0609T[4`030000000mFJ/0VB/C00D0VB/C00D0
000009T[4`2I:a<0VB/C03eIZ`040:`a5P030000002/<AH0[34F00H0[34F00D000000:`a5P2/<AH0
[34F03eIZ`030:`a5P030000002l=QP0_3HH00D0_3HH00<000000;`f602l=QP00P0mFJ/20;`f6003
0000002l=QP0_3HH00@0_3HH00D0?EV[0000002l=QP0_3HH000000020<Xj6@030000003:>QT0bSXI
00<0bSXI00<000000<Xj6@3:>QT00`3:>QT00`000000CW7I04iaf@0304iaf@030000001>LMT0CW7I
00<0CW7I00@0000004iaf@1>LMT000000P1=Km@00`000000e3dI04e_e00504e_e0030000001=Km@0
CFoD0080e3dI0P1=Km@00`000000CFoD04e_e00504e_e0050000001<KLh0C6g>04a]cP3D?AT00`1<
KLh00`000000C6g>04a]cP0604a]cP030000001<KLh0C6g>0080C6g>00D0e3dI04YYa`1:JLL0BVW7
0000000604YYa`030=@m6@000000BVW700L0BVW700<0000004MT_017I;`01@17I;`010000000AfBl
0=@m6@3D?AT504MT_08000001013GJd20=@m6@@0ooK^0`0mFJ/30=@m6@030?ofkP3D?AT0e3dI00<0
ooK^00<0?EV[0?ofkP3om^h00P3om^h203eIZ`040=@m6@3om^h0?EV[0?ofkP80e3dI00@0ooK^03eI
Z`3D?AT0e3dI1@3om^h30=@m6@030000003D?AT0e3dI0080ooK^0P3D?AU40?ofkP030000003om^h0
ooK^01H0ooK^0@3oool001L0ooK^00<000000?ofkP3om^h0A@3om^h203eIZ`8000000P0mFJ/00`3o
m^h0?EV[0?ofkP030?ofkP<0e3dI0P0mFJ/20?ofkP80?EV[00<0ooK^03eIZ`3om^h01@3om^h00`3D
?AT0ooK^0?ofkP030?ofkP80?EV[00D0e3dI03eIZ`3om^h0ooK^0=@m6@030?ofkP0303eIZ`3om^h0
000000<0IQ/=00@00000088T4022910000001P2291000`0mFJ/00000088T4004088T40<00000202I
:a<00`0mFJ/0VB/C09T[4`0609T[4`<0000000<0[34F03eIZ`0mFJ/00`2/<AH00`000000[34F0:`a
5P060:`a5P030000002/<AH0?EV[0080[34F0`0000080;`f60040000002l=QP0_3HH0;`f6080?EV[
00<0_3HH0000002l=QP00`2l=QP00`0mFJ/0_3HH00000002000000<0bSXI00<000000<Xj6@3:>QT0
0`3:>QT00`000000bSXI0<Xj6@030<Xj6@030000001>LMT0CW7I00<0CW7I00<0000004iaf@1>LMT0
0`1>LMT010000000CW7I04iaf@1>LMT30000000304e_e03D?AT0CFoD00<0CFoD00@0000004e_e03D
?AT0e3dI0`1=Km@00`000000CFoD04e_e00604e_e0<000000P1<KLh00`3D?AT0C6g>0000000804a]
cP040000001<KLh0C6g>04a]cP80e3dI00@0C6g>0000000000000000201:JLL00`3D?AT0BVW704YY
a`0504YYa`040000001:JLL00000000000D0AfBl00<000000=@m6@17I;`01@17I;`010000000AfBl
04MT_000000304=M[@030000003om^h0e3dI00<0ooK^00D0?EV[0?ofkP3om^h0e3dI03eIZ`020=@m
6@D0ooK^00<0?EV[0?ofkP3om^h0103om^h0103D?AT0ooK^0=@m6@3D?AT20?ofkP80e3dI0`0mFJ/4
0?ofkP040=@m6@3om^h0e3dI0=@m6@8000000P3D?AU70?ofkP030000003om^h0ooK^01D0ooK^0@3o
ool001L0ooK^00<000000?ofkP3om^h0AP3om^h00`000000?EV[03eIZ`020?ofkP@0?EV[00<0ooK^
0=@m6@3D?AT0103om^h203eIZ`040?ofkP3D?AT0?EV[03eIZ`D0ooK^00<0e3dI0?ofkP3om^h0103o
m^h20=@m6@@0?EV[00@0e3dI0?ofkP3om^h0?EV[0P3om^h010000000IQ/=000000000003088T4003
000000229100PR@@00D0PR@@0P0mFJ/2088T408000000`2I:a<00`000000VB/C09T[4`0309T[4`80
?EV[00<0VB/C0000002I:a<01P2I:a<00`000000[34F0:`a5P030:`a5P80?EV[00<0[34F0000002/
<AH01`2/<AH01@000000?EV[0:`a5P2/<AH0000000<0_3HH00<000000;`f602l=QP01@2l=QP00`00
0000_3HH0;`f60030;`f6080?EV[0`2l=QP0100mFJ/0_3HH0;`f600000060<Xj6@030000003:>QT0
bSXI0080bSXI00<000000<Xj6@3:>QT00`3:>QT00`000000CW7I04iaf@0304iaf@030000001>LMT0
CW7I0080CW7I00<0000004iaf@1>LMT0101>LMT010000000CFoD04e_e03D?AT304e_e080e3dI1@1=
Km@00`000000CFoD04e_e00504e_e0050000001=Km@0CFoD04e_e00000000P1<KLh00`3D?AT00000
04a]cP0704a]cP040000001<KLh0e3dI0=@m6@D0C6g>00<0000004YYa`1:JLL01@1:JLL010000000
BVW70=@m6@3D?AT504YYa`040000001:JLL0BVW704YYa`8000000P17I;`20=@m6@L0AfBl00@00000
04MT_017I;`0AfBl0P0000001@13GJd000000?ofkP3om^h0e3dI0080ooK^00<0?EV[0=@m6@3D?AT0
0P3D?AT203eIZ`H0ooK^00<0?EV[0?ofkP3om^h00`3om^h20=@m6@0403eIZ`3om^h0e3dI0=@m6@@0
ooK^0P0mFJ/00`3om^h0e3dI0=@m6@020=@m6@80ooK^0P3D?AT00`000000ooK^0?ofkP160?ofkP03
0000003om^h0ooK^01D0ooK^0@3oool001L0ooK^00<000000?ofkP3om^h0A03om^h2000000<0ooK^
0P0mFJ/20?ofkP@0?EV[1P3om^h0103D?AT0?EV[03eIZ`3om^h303eIZ`<0ooK^00<0e3dI0?ofkP3o
m^h00`3om^h0103D?AT0ooK^0?ofkP3om^h603eIZ`<0ooK^0P000005088T4003000000229100PR@@
00H0PR@@00<0000003eIZ`0mFJ/01@2I:a<00`000000VB/C09T[4`0209T[4`0503eIZ`2I:a<0VB/C
09T[4`0000001@2I:a<2000000030:`a5P000000[34F00D0[34F00<0?EV[0:`a5P0000001`2/<AH0
100mFJ/0e3dI0000000000040;`f60030000002l=QP0_3HH00D0_3HH00<000000;`f602l=QP0102l
=QP01@000000?EV[03eIZ`2l=QP0?EV[00<000001P3:>QT00`000000bSXI0<Xj6@030<Xj6@030000
003:>QT0bSXI0080bSXI00<0000004iaf@1>LMT00P1>LMT00`000000CW7I04iaf@0304iaf@030000
001>LMT0CW7I00@0CW7I0`0000001@3D?AT0CFoD0=@m6@3D?AT0000000H0CFoD00<0000004e_e01=
Km@01@1=Km@00`000000CFoD04e_e00204e_e080000000<0?EV[0=@m6@1<KLh01P1<KLh00`000000
C6g>0=@m6@0604a]cP040000001<KLh00000000000D0BVW700D0000004YYa`1:JLL0BVW70=@m6@03
04YYa`030000001:JLL0BVW700@0BVW70P3D?AT00`000000AfBl04MT_00604MT_00300000017I;`0
AfBl00<0AfBl0P0000030?ofkPH0e3dI0`3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0403eIZ`3om^h0
ooK^0?ofkP<0e3dI00@0ooK^0=@m6@3D?AT0?EV[1P3om^h40=@m6@80ooK^0P3D?AT30?ofkP800000
AP3om^h00`000000ooK^0?ofkP0E0?ofkP40oooo000G0?ofkP030000003om^h0ooK^04<0ooK^00<0
00000?ofkP3om^h01@3om^h203eIZ`030?ofkP3D?AT0?EV[00<0?EV[0`3om^h0103D?AT0ooK^0?of
kP3om^h303eIZ`050?ofkP0mFJ/0?EV[0?ofkP3D?AT00`3om^h20=@m6@D0ooK^0`0mFJ/00`3om^h0
?EV[03eIZ`020?ofkP03000000229100PR@@00@0PR@@00<00000088T402291001P2291000`000000
VB/C09T[4`0203eIZ`@0VB/C00@0000009T[4`2I:a<0?EV[102I:a<010000000VB/C09T[4`2I:a<2
000000<0[34F00<000000:`a5P2/<AH01@2/<AH203eIZ`L0[34F00<0?EV[0000002l=QP01P2l=QP0
0`000000_3HH0;`f60040;`f60030000002l=QP0_3HH00@0_3HH00D000000;`f602l=QP0?EV[0000
00020<Xj6@030000003:>QT0bSXI00@0bSXI00<000000<Xj6@3:>QT00`3:>QT00`000000bSXI0<Xj
6@020<Xj6@030000001>LMT0CW7I0080CW7I00<0000004iaf@1>LMT00`1>LMT00`000000CW7I04ia
f@0404iaf@050000001>LMT0CW7I0000003D?AT00P1=Km@00`000000CFoD04e_e00404e_e0030000
001=Km@0CFoD00@0CFoD00<0000004e_e01=Km@01@1=Km@00`000000e3dI04a]cP0604a]cP80e3dI
1`1<KLh010000000C6g>04a]cP1<KLh2000000<0BVW700<0000004YYa`1:JLL00P1:JLL0103D?AT0
BVW704YYa`00000404YYa`80e3dI0P1:JLL00`000000AfBl04MT_00504MT_00300000017I;`0AfBl
00D0AfBl00<000000?ofkP3om^h00P3D?AT0103om^h0e3dI0=@m6@3D?AT50?ofkP80?EV[0`3om^h0
1@0mFJ/0ooK^0=@m6@3D?AT0ooK^00<0e3dI0`3om^h0100mFJ/0ooK^0?ofkP3om^h40=@m6@80ooK^
0P3D?AT70?ofkP030000003om^h0ooK^04<0ooK^00<000000?ofkP3om^h05@3om^h10?ooo`005P3o
m^h00`000000ooK^0?ofkP120?ofkP8000002P3om^h203eIZ`030?ofkP0mFJ/0?EV[00<0?EV[0P3D
?AT50?ofkP80?EV[0P3om^h203eIZ`030?ofkP3D?AT0e3dI00D0ooK^0`0mFJ/01@3om^h0e3dI03eI
Z`0mFJ/0ooK^0080?EV[00<00000088T402291001@2291000`000000PR@@088T4003088T40<00000
102I:a<203eIZ`80VB/C00<0000009T[4`0mFJ/01P2I:a<3000000H0[34F00<000000:`a5P2/<AH0
1P2/<AH203eIZ`@0[34F00<0?EV[0000000000001`2l=QP00`000000_3HH0;`f60050;`f60030000
002l=QP0_3HH00@0_3HH00<0000003eIZ`0000000P0mFJ/20<Xj6@030000003:>QT0bSXI00<0bSXI
00<000000<Xj6@3:>QT00`3:>QT00`000000bSXI0<Xj6@020<Xj6@030000001>LMT0CW7I0080CW7I
00<0000004iaf@1>LMT00`1>LMT00`000000CW7I04iaf@0304iaf@030000001>LMT0CW7I0080e3dI
00<000000=@m6@0000001P1=Km@00`000000CFoD04e_e00504e_e0030000001=Km@0CFoD00@0CFoD
00@0000003eIZ`000000e3dI101<KLh20=@m6@P0C6g>00<0000004a]cP1<KLh0101<KLh3000000H0
BVW700<0e3dI0000001:JLL00P1:JLL20=@m6@<0BVW700@0000004YYa`00000000001@17I;`00`00
0000AfBl04MT_00504MT_0040000003D?AT0e3dI0?ofkP80e3dI00<0?EV[0?ofkP3D?AT00P3D?AT5
0?ofkP80?EV[00<0ooK^0=@m6@3D?AT00P3om^h20=@m6@D0ooK^0P0mFJ/50=@m6@030?ofkP3D?AT0
e3dI00X0ooK^0P0000140?ofkP030000003om^h0ooK^01@0ooK^0@3oool001H0ooK^00<000000?of
kP3om^h0@@3om^h00`000000ooK^0?ofkP0:0?ofkP030=@m6@3om^h0?EV[0080?EV[00<0ooK^03eI
Z`0mFJ/00P0mFJ/60?ofkP<0?EV[0P3D?AT203eIZ`@0ooK^0P0mFJ/20?ofkP0303eIZ`3D?AT0ooK^
0080ooK^0P0mFJ/00`3om^h0?EV[03eIZ`06088T4003000000229100PR@@0080PR@@00D0000009T[
4`2I:a<0VB/C0000000509T[4`80?EV[00<0VB/C03eIZ`2I:a<01P2I:a<00`000000[34F0:`a5P06
0:`a5P030000002/<AH0[34F00H0[34F00H000000:`a5P0mFJ/0?EV[0000000mFJ/30;`f60030000
002l=QP0_3HH00@0_3HH00<000000;`f602l=QP01@2l=QP00`000000_3HH0;`f60040;`f600303eI
Z`3:>QT0bSXI0080bSXI0P0mFJ/00`000000bSXI0<Xj6@030<Xj6@030000003:>QT0bSXI00<0bSXI
00<000000<Xj6@3:>QT00P3:>QT00`000000CW7I04iaf@0204iaf@030000001>LMT0CW7I00<0CW7I
00<0000004iaf@1>LMT00`1>LMT00`000000e3dI0=@m6@0404iaf@030=@m6@1=Km@0CFoD00@0CFoD
00<0000004e_e01=Km@01@1=Km@00`000000CFoD04e_e00404e_e0060000001=Km@0CFoD04e_e03D
?AT000000P3D?AT00`1<KLh0000004a]cP0704a]cP030000001<KLh0C6g>00H0C6g>00<0000004YY
a`1:JLL01@1:JLL0103D?AT0BVW70=@m6@3D?AT504YYa`050000001:JLL0BVW704YYa`0000001017
I;`00`000000AfBl04MT_00404MT_080e3dI00<0ooK^0=@m6@3D?AT00`3om^h0100mFJ/0e3dI0?of
kP3om^h20=@m6@@0ooK^0P3D?AT203eIZ`<0e3dI1P3om^h40=@m6@050?ofkP3D?AT0e3dI0=@m6@0m
FJ/03@3om^h00`000000ooK^0?ofkP110?ofkP030000003om^h0ooK^01@0ooK^0@3oool001H0ooK^
00<000000?ofkP3om^h0?`3om^h2000000d0ooK^00@0e3dI0?ofkP3om^h0ooK^0`0mFJ/00`3om^h0
?EV[03eIZ`0203eIZ`@0ooK^00<0?EV[0?ofkP3om^h00P0mFJ/20?ofkP@0?EV[103om^h00`0mFJ/0
e3dI0?ofkP040?ofkP80?EV[00<0e3dI088T40229100102291001@000000PR@@088T402291000000
00@0VB/C00<0000009T[4`2I:a<01@2I:a<00`0mFJ/0000009T[4`0409T[4`80000000<0[34F0000
002/<AH01`2/<AH00`000000[34F0:`a5P060:`a5P<0000000<0?EV[0;`f602l=QP00P2l=QP00`00
0000_3HH0;`f60050;`f60030000002l=QP0_3HH00@0_3HH00<000000;`f602l=QP00P2l=QP00`00
0000?EV[000000060<Xj6@80?EV[103:>QT00`000000bSXI0<Xj6@030<Xj6@030000003:>QT0bSXI
0080bSXI00<0000004iaf@1>LMT00P1>LMT00`000000CW7I04iaf@0304iaf@030000001>LMT0CW7I
0080CW7I0P3D?AT604iaf@030000003D?AT0000000@0CFoD00<0000004e_e01=Km@0101=Km@00`00
0000CFoD04e_e00404e_e0030000001=Km@0CFoD00<0CFoD00@0e3dI0000000000000000201<KLh0
0`000000C6g>04a]cP0604a]cP040000001<KLh00000000000@0BVW700<0000004YYa`3D?AT01P1:
JLL00`000000BVW704YYa`0304YYa`0500000017I;`0AfBl04MT_00000001P17I;`00`0mFJ/0e3dI
0=@m6@050?ofkP0303eIZ`3D?AT0ooK^00<0ooK^103D?AT20?ofkP80e3dI0P3om^h00`3D?AT0ooK^
0?ofkP020?ofkP@0e3dI00@0ooK^0=@m6@3D?AT0e3dI0`3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP80
0000@@3om^h00`000000ooK^0?ofkP0D0?ofkP40oooo000F0?ofkP030000003om^h0ooK^03h0ooK^
00<000000?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00L0?EV[
0`3om^h903eIZ`D0ooK^00<0?EV[0=@m6@3om^h0103om^h20=@m6@80?EV[00<0PR@@03eIZ`229100
0`229103000000H0VB/C00<0000009T[4`2I:a<00P2I:a<203eIZ`0309T[4`0mFJ/0?EV[00<0VB/C
00D000000:`a5P2/<AH0[34F000000090:`a5P030000002/<AH0[34F00D0[34F00@000000;`f600m
FJ/0_3HH0P0mFJ/30;`f60030000002l=QP0_3HH00@0_3HH00<000000;`f602l=QP01@2l=QP02000
0000_3HH000000000000bSXI03eIZ`3:>QT000001@3:>QT010000000bSXI03eIZ`0mFJ/20<Xj6@03
0000003:>QT0bSXI00<0bSXI00<000000<Xj6@3:>QT01@00000204iaf@030000001>LMT0CW7I00<0
CW7I00<0000004iaf@1>LMT00P3D?AT00`1>LMT0000004iaf@0404iaf@040000001>LMT0e3dI04ia
f@80000000<0CFoD0000001=Km@01P1=Km@00`000000CFoD04e_e00404e_e0040000001=Km@0CFoD
04e_e080e3dI00@0CFoD0=@m6@1=Km@000001`1<KLh00`000000C6g>04a]cP0704a]cP050000001<
KLh0C6g>04a]cP0000000`1:JLL20=@m6@0304YYa`3D?AT0e3dI00@0BVW700<0000004YYa`1:JLL0
101:JLL3000000@0AfBl00@0e3dI04MT_03D?AT0e3dI0P0mFJ/50?ofkP0303eIZ`3D?AT0ooK^00@0
ooK^2@3D?AT30?ofkPL0e3dI0P3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00l0ooK^00<000000?of
kP3om^h0?P3om^h00`000000ooK^0?ofkP0D0?ofkP40oooo000F0?ofkP030000003om^h0ooK^03d0
ooK^00<000000?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP020=@m6@@0ooK^00<0e3dI03eIZ`0m
FJ/01`0mFJ/00`3om^h0e3dI0?ofkP020?ofkP80?EV[00<0ooK^03eIZ`0mFJ/00`3om^h00`0mFJ/0
e3dI0?ofkP030?ofkP050=@m6@3om^h0ooK^0?ofkP0000000P0mFJ/4088T40030000002I:a<0VB/C
00H0VB/C00<0000009T[4`2I:a<00P0mFJ/409T[4`040000000mFJ/0?EV[000000D0[34F00<00000
0:`a5P2/<AH01P2/<AH00`000000[34F0:`a5P030:`a5P80000000<0_3HH03eIZ`2l=QP00`2l=QP2
03eIZ`030;`f60000000_3HH00D0_3HH00<000000;`f602l=QP01@2l=QP200000080bSXI00@0?EV[
0<Xj6@3:>QT000001@3:>QT01`000000bSXI0<Xj6@3:>QT0?EV[0<Xj6@0000001@3:>QT300000080
echK00<0000004ibg01>L]`00`00000504iaf@030000001>LMT0e3dI0080CW7I00<0000004iaf@1>
LMT0101>LMT010000000CW7I04iaf@3D?AT204iaf@8000001`1=Km@00`000000CFoD04e_e00304e_
e0030000001=Km@0CFoD0080e3dI101=Km@0103D?AT0CFoD00000000000504a]cP030000001<KLh0
C6g>00H0C6g>00<0000004a]cP1<KLh00`1<KLh00`000000e3dI0=@m6@0504YYa`80e3dI00<0BVW7
0000001:JLL0201:JLL00`000000AfBl04MT_00204MT_080e3dI00D000000?ofkP3om^h0ooK^03eI
Z`040?ofkP0303eIZ`3D?AT0ooK^0080ooK^0P3D?AT00`3om^h0e3dI0=@m6@030?ofkP0303eIZ`3o
m^h0e3dI00P0e3dI00<0?EV[0?ofkP3om^h00P3om^h203eIZ`80ooK^00<0?EV[0?ofkP3om^h03@3o
m^h00`000000ooK^0?ofkP0m0?ofkP030000003om^h0ooK^01@0ooK^0@3oool001D0ooK^00<00000
0?ofkP3om^h0?03om^h2000000l0ooK^00@0e3dI0?ofkP3om^h0e3dI1P3om^h00`3D?AT0ooK^0?of
kP0203eIZ`030?ofkP0mFJ/0?EV[00<0?EV[00<0e3dI0?ofkP3om^h00`3om^h203eIZ`030?ofkP0m
FJ/0?EV[0080ooK^00<0?EV[0?ofkP3om^h00P3D?AT40?ofkP03000000229100PR@@0080?EV[0P00
00000`2I:a<0000009T[4`0709T[4`030000000mFJ/0VB/C00H0VB/C00@000000:`a5P0mFJ/0?EV[
1@2/<AH00`000000[34F0:`a5P060:`a5P060000002/<AH0[34F0:`a5P000000_3HH0P0mFJ/00`00
0000_3HH0;`f60040;`f6080?EV[00<000000;`f602l=QP0102l=QP00`000000_3HH0;`f60020;`f
60<000000P3:>QT01@0mFJ/0bSXI0<Xj6@3:>QT0000000H0bSXI00@000000<Xj6@3:>QT0bSXI0P0m
FJ/00`000000bSXI0<Xj6@020<Xj6@070000003G?Q/0echK0=Ln6`0mFJ/000000=@m6@0304ibg003
0000001>LMT0CW7I0080CW7I00<000000=@m6@3D?AT00`1>LMT00`000000CW7I04iaf@0404iaf@05
0000001>LMT0CW7I04iaf@3D?AT00P1>LMT3000000@0CFoD00<0000004e_e01=Km@0101=Km@00`00
0000e3dI0=@m6@0604e_e0050000003D?AT0e3dI04e_e00000000`1<KLh00`000000C6g>04a]cP06
04a]cP030000001<KLh0C6g>00<0C6g>0P3D?AT00`1<KLh0000004YYa`0604YYa`030=@m6@000000
BVW700L0BVW700@0000004YYa`00000000000P3D?AT204MT_0030000003om^h0ooK^0080ooK^0P0m
FJ/20?ofkP030=@m6@3om^h0ooK^0080e3dI00<0ooK^0=@m6@3D?AT01@3om^h00`0mFJ/0e3dI0=@m
6@030=@m6@030?ofkP3D?AT0e3dI0080ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^03eI
Z`0@0?ofkP800000?P3om^h00`000000ooK^0?ofkP0C0?ofkP40oooo000E0?ofkP030000003om^h0
ooK^03/0ooK^00<000000?ofkP3om^h03`3om^h00`3D?AT0ooK^0=@m6@070?ofkP030=@m6@3om^h0
ooK^0080ooK^0P0mFJ/01@3om^h0?EV[03eIZ`0mFJ/0e3dI00L0ooK^0P0mFJ/0103om^h0?EV[03eI
Z`0mFJ/20=@m6@H0ooK^00D00000088T40229100PR@@0000000203eIZ`0309T[4`000000VB/C00H0
VB/C0P0mFJ/609T[4`80000000@0[34F0000002/<AH0[34F0P0mFJ/30:`a5P030000002/<AH0[34F
00H0[34F00H000000:`a5P00000000000;`f600mFJ/30;`f60030000002l=QP0_3HH00D0_3HH0P0m
FJ/50;`f60050000002l=QP0_3HH0;`f600000000`3:>QT00`000000?EV[0<Xj6@040<Xj6@030000
003:>QT0bSXI00<0bSXI00<000000<Xj6@3:>QT00`3:>QT203eIZ`040<Xj6@000000000000000080
echK00D0?EV[0=Ln6`000000CW;L0=@m6@0204ibg0<0000000<0CW7I0=@m6@3D?AT01@1>LMT00`00
0000CW7I04iaf@0304iaf@030000001>LMT0CW7I00<0CW7I00<0e3dI0000001>LMT00P1>LMT01@00
0000CFoD04e_e01=Km@0000000D0CFoD0P3D?AT704e_e0060000001=Km@0CFoD04e_e03D?AT0CFoD
0P0000000`1<KLh0000004a]cP0604a]cP030000001<KLh0C6g>0080C6g>0P3D?AT204a]cP040000
001<KLh00000000000D0BVW700<000000=@m6@3D?AT01`1:JLL01@000000BVW70=@m6@3D?AT00000
00<0AfBl00<000000?ofkP3om^h0103om^h203eIZ`<0e3dI00<0ooK^0=@m6@3D?AT01`3om^h01@0m
FJ/0e3dI0=@m6@3D?AT0ooK^0080e3dI103om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0
?EV[0140ooK^00<000000?ofkP3om^h0>`3om^h00`000000ooK^0?ofkP0C0?ofkP40oooo000E0?of
kP030000003om^h0ooK^03T0ooK^0P00000A0?ofkP<0e3dI203om^h0103D?AT0ooK^0?ofkP3om^h2
0=@m6@040?ofkP0mFJ/0?EV[0?ofkP<0?EV[203om^h203eIZ`030?ofkP0mFJ/0?EV[00P0ooK^0`00
000309T[4`80?EV[00<0000009T[4`2I:a<00P2I:a<203eIZ`80VB/C00@0000009T[4`2I:a<0VB/C
0P0000030:`a5P030000002/<AH0[34F0080[34F0P0mFJ/20:`a5P030000002/<AH0[34F00H0[34F
00@000000;`f602l=QP0?EV[1@2l=QP00`000000_3HH0;`f60050;`f60030000000mFJ/0_3HH00@0
_3HH0`0000040<Xj6@0303eIZ`3:>QT0bSXI00@0bSXI00<000000<Xj6@3:>QT00`3:>QT00`000000
bSXI0<Xj6@030<Xj6@8000000P0mFJ/0103G?Q/000000=Ln6`0mFJ/20=Ln6`030000001>L]`0e3dI
0080CW;L00@0000004ibg03D?AT0e3dI0P00000504iaf@030000001>LMT0CW7I00<0CW7I00<00000
04iaf@1>LMT0101>LMT00`3D?AT0CW7I04iaf@0204iaf@<000001@1=Km@00`3D?AT0000004e_e006
04e_e0030000001=Km@0CFoD00<0CFoD00@0e3dI04e_e01=Km@00000201<KLh00`000000C6g>04a]
cP020=@m6@@0C6g>00@0000004a]cP1<KLh0C6g>0P00000304YYa`030000001:JLL0BVW70080e3dI
101:JLL00`000000e3dI0=@m6@0304YYa`<00000203om^h20=@m6@030?ofkP3D?AT0e3dI00P0ooK^
0`3D?AT0103om^h0e3dI0=@m6@3om^h203eIZ`<0ooK^00<0?EV[0?ofkP3om^h01P3om^h203eIZa80
ooK^0P00000k0?ofkP030000003om^h0ooK^01<0ooK^0@3oool001D0ooK^00<000000?ofkP3om^h0
>03om^h00`000000ooK^0?ofkP0A0?ofkP030=@m6@3om^h0ooK^00L0ooK^00D0e3dI0?ofkP3om^h0
ooK^0=@m6@050?ofkP80?EV[00@0e3dI03eIZ`0mFJ/0?EV[1`3om^h0103D?AT0?EV[03eIZ`3om^h2
03eIZ`H0ooK^00<0000009T[4`2I:a<01@2I:a<203eIZ`0309T[4`0mFJ/0?EV[00@0VB/C00@00000
09T[4`00000000001P2/<AH00`000000[34F0:`a5P030:`a5P80?EV[00<0[34F0000002/<AH0102/
<AH2000000030;`f60000000?EV[00H0_3HH00<000000;`f602l=QP01@2l=QP010000000_3HH03eI
Z`0mFJ/30;`f60030000003:>QT0bSXI00<0bSXI00<0?EV[0<Xj6@0000001@3:>QT00`000000bSXI
0<Xj6@030<Xj6@030000003:>QT0bSXI00<0bSXI00@000000=Ln6`3G?Q/0echK0P0mFJ/01@3G?Q/0
?EV[0=Ln6`3G?Q/000000080CW;L00@0e3dI04ibg03D?AT0e3dI0`1>L]`00`000000CW7I04iaf@03
04iaf@030000001>LMT0CW7I00<0CW7I00<0000004iaf@1>LMT00`1>LMT00`000000CW7I0=@m6@05
04iaf@040000001=Km@0CFoD04e_e080e3dI00<0000004e_e01=Km@01P1=Km@00`000000CFoD04e_
e00404e_e0030=@m6@000000CFoD008000001@1<KLh010000000C6g>0=@m6@3D?AT504a]cP030000
001<KLh0C6g>00@0C6g>0`00000504YYa`80e3dI00<0BVW70=@m6@3D?AT01`1:JLL00`000000ooK^
0?ofkP040?ofkPD0e3dI00<0?EV[0?ofkP3om^h01@3om^h30=@m6@0303eIZ`3D?AT0e3dI00D0ooK^
00@0?EV[0?ofkP3om^h0?EV[2P3om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP030000003om^h0ooK^03P0
ooK^00<000000?ofkP3om^h04`3om^h10?ooo`00503om^h00`000000ooK^0?ofkP0g0?ofkP800000
503om^h00`3D?AT0ooK^0?ofkP070?ofkP040=@m6@3om^h0ooK^0=@m6@P0ooK^1P0mFJ/40?ofkP04
0=@m6@3om^h0ooK^0=@m6@80?EV[00<0ooK^03eIZ`0mFJ/01@3om^h00`000000VB/C09T[4`0509T[
4`80?EV[1`2I:a<00`000000[34F0:`a5P070:`a5P030000002/<AH0[34F00@0[34F0P0mFJ/01@00
0000[34F0:`a5P2/<AH0000000<0_3HH00<0?EV[0;`f602l=QP01P2l=QP00`000000_3HH0;`f6005
0;`f60030000002l=QP0_3HH0080?EV[00<000000<Xj6@000000103:>QT00`0mFJ/0bSXI00000006
0<Xj6@030000003:>QT0bSXI00<0bSXI00<000000<Xj6@3:>QT00`0000040=Ln6`030000000mFJ/0
echK0080echK00H0000004ibg01>L]`0CW;L0=@m6@00000404ibg0<000000P1>LMT00`000000CW7I
04iaf@0304iaf@030000001>LMT0CW7I00@0CW7I00<0000004iaf@3D?AT0101>LMT00`000000CW7I
000000020=@m6@80CFoD00<0000004e_e01=Km@01@1=Km@00`000000CFoD04e_e00604e_e0050=@m
6@1=Km@0CFoD04e_e00000000`1<KLh00`000000e3dI0=@m6@0604a]cP030000001<KLh0C6g>00L0
C6g>00<0000004YYa`1:JLL01@1:JLL20=@m6@L0BVW700<000000?ofkP3om^h00`3om^h20=@m6@04
0?ofkP3D?AT0e3dI03eIZ`80ooK^00<0?EV[0?ofkP3om^h00P3om^h60=@m6@P0ooK^00@0?EV[0?of
kP3om^h0?EV[2@3om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP800000>03om^h00`000000ooK^0?ofkP0C
0?ofkP40oooo000D0?ofkP030000003om^h0ooK^03H0ooK^00<000000?ofkP3om^h04`3om^h00`3D
?AT0ooK^0?ofkP080?ofkP<0e3dI2@3om^h00`3D?AT0ooK^03eIZ`0503eIZ`80e3dI103om^h01@0m
FJ/0ooK^03eIZ`0mFJ/0ooK^0080?EV[0`3om^h00`000000VB/C09T[4`0209T[4`<0?EV[00@0VB/C
0000000mFJ/0?EV[0`2I:a<2000000030:`a5P000000[34F00L0[34F00<000000:`a5P2/<AH01P2/
<AH203eIZ`8000000P2l=QP203eIZ`030;`f60000000_3HH00H0_3HH00<000000;`f602l=QP01@2l
=QP01@000000_3HH000000000000bSXI0080?EV[00D000000<Xj6@3:>QT0bSXI03eIZ`020<Xj6@03
0000003:>QT0bSXI00@0bSXI00<000000<Xj6@3:>QT00`3:>QT300000080echK00<000000=Ln6`3G
?Q/00P3G?Q/01`0mFJ/0echK03eIZ`0mFJ/0echK0000001>L]`00P3D?AT00`1>L]`0e3dI04ibg003
04ibg0030000001>L]`0CW;L00<000001@1>LMT00`000000CW7I04iaf@0304iaf@050000001>LMT0
CW7I04iaf@3D?AT00`1>LMT010000000e3dI0=@m6@1>LMT20000000303eIZ`1=Km@0CFoD00H0CFoD
00<0000004e_e01=Km@01@1=Km@010000000CFoD0=@m6@3D?AT204e_e08000000P3D?AT704a]cP03
0000001<KLh0C6g>00L0C6g>00@0000004a]cP00000000000`1:JLL20=@m6@030000001:JLL0e3dI
0080e3dI101:JLL010000000ooK^0?ofkP3om^h20=@m6@050?ofkP3D?AT0e3dI0=@m6@0mFJ/0103o
m^h203eIZ`H0e3dI00<0ooK^03eIZ`3om^h0203om^h303eIZ`X0ooK^00<0?EV[0?ofkP3om^h04`3o
m^h00`000000ooK^0?ofkP0f0?ofkP030000003om^h0ooK^0180ooK^0@3oool001@0ooK^00<00000
0?ofkP3om^h0=@3om^h00`000000ooK^0?ofkP0D0?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI
0?ofkP3om^h02@3om^h0103D?AT0ooK^0?ofkP3om^h603eIZ`@0ooK^00@0e3dI03eIZ`3om^h0ooK^
0P0mFJ/00`3om^h0?EV[03eIZ`020?ofkP040000002I:a<0?EV[03eIZ`D0VB/C00D0000009T[4`0m
FJ/0?EV[000000040:`a5P030000002/<AH0[34F00H0[34F00<000000:`a5P2/<AH01P2/<AH01@00
0000?EV[03eIZ`2l=QP0?EV[00@0_3HH00<000000;`f602l=QP01@2l=QP00`000000_3HH0;`f6005
0;`f60030000003:>QT0bSXI00<0bSXI0P0mFJ/00`3:>QT0?EV[0<Xj6@030<Xj6@030000003:>QT0
bSXI00<0bSXI00<000000<Xj6@3:>QT00P3:>QT2000000@0echK00H000000=Ln6`3G?Q/0echK03eI
Z`0000030=Ln6`0303eIZ`000000e3dI00<0CW;L00<000000=@m6@1>L]`00P1>L]`00`000000CW;L
04ibg00204ibg0800000101>LMT00`000000CW7I04iaf@0304iaf@030000001>LMT0CW7I0080CW7I
00@0e3dI04iaf@3D?AT0e3dI1@1>LMT00`000000CFoD04e_e00504e_e0030000001=Km@0CFoD00D0
CFoD00<0000004e_e01=Km@00P1=Km@01@3D?AT0CFoD0=@m6@3D?AT0000000P0C6g>00<0000004a]
cP1<KLh01P1<KLh00`000000C6g>04a]cP0204a]cP050000003D?AT0e3dI04YYa`0000001@1:JLL2
0=@m6@0404YYa`000000ooK^0?ofkP80e3dI00<0ooK^0=@m6@3D?AT00P3om^h00`3D?AT0?EV[0?of
kP030?ofkPH0e3dI0`3om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0
?EV[0?ofkP3om^h0503om^h00`000000ooK^0?ofkP0e0?ofkP030000003om^h0ooK^0180ooK^0@3o
ool001@0ooK^00<000000?ofkP3om^h0<`3om^h2000001L0ooK^00<0e3dI0?ofkP3om^h01P3om^h3
0=@m6@/0ooK^00<0e3dI0?ofkP3om^h00`3om^h603eIZ`80ooK^00<0e3dI03eIZ`3om^h00`3om^h2
03eIZ`030?ofkP0mFJ/0?EV[0080?EV[1`2I:a<010000000VB/C00000000000203eIZ`<0[34F00<0
00000:`a5P2/<AH01`2/<AH00`000000[34F0:`a5P030:`a5P80000000@0_3HH0000002l=QP0?EV[
1@2l=QP00`000000_3HH0;`f60060;`f60030000002l=QP0_3HH0080_3HH0P0000000`3:>QT00000
0<Xj6@040<Xj6@030000000mFJ/0bSXI00@0bSXI00<000000<Xj6@3:>QT0103:>QT01P000000bSXI
000000000000echK000000D0echK00D000000=Ln6`0mFJ/0echK000000040=Ln6`050000001>L]`0
CW;L04ibg00000000P1>L]`00`3D?AT0CW;L0000000504ibg0060000001>L]`000000000001>LMT0
00001P1>LMT00`000000CW7I04iaf@0304iaf@030=@m6@000000CW7I00@0CW7I00@0000004iaf@00
00000000101=Km@00`000000CFoD04e_e00604e_e0030000001=Km@0CFoD00<0CFoD00@0e3dI04e_
e0000000CFoD0P00000504a]cP030000001<KLh0C6g>00L0C6g>00@0000004a]cP1<KLh0C6g>0P3D
?AT20000000304YYa`000000BVW700H0BVW7103D?AT00`3om^h0e3dI0=@m6@030?ofkP030=@m6@3o
m^h0?EV[0080ooK^1P3D?AT50?ofkP0303eIZ`3om^h0ooK^00T0ooK^0`0mFJ/80?ofkP0303eIZ`3o
m^h0ooK^01D0ooK^0P00000e0?ofkP030000003om^h0ooK^0180ooK^0@3oool001@0ooK^00<00000
0?ofkP3om^h0<P3om^h00`000000ooK^0?ofkP0G0?ofkP030=@m6@3om^h0ooK^00@0ooK^0P3D?AT2
0?ofkP030=@m6@3om^h0ooK^00T0ooK^00@0e3dI0?ofkP3om^h0ooK^0P3D?AT20?ofkPH0?EV[00@0
e3dI0?ofkP0mFJ/0ooK^1P0mFJ/00`3om^h0?EV[03eIZ`0809T[4`030000002/<AH0[34F0080[34F
0P0mFJ/20:`a5P030000002/<AH0[34F00L0[34F00D000000:`a5P2/<AH0[34F000000030;`f6080
?EV[00<0_3HH03eIZ`0mFJ/0102l=QP00`000000_3HH0;`f60050;`f60030000002l=QP0_3HH0080
00000`3:>QT00`000000bSXI0<Xj6@030<Xj6@0403eIZ`000000?EV[03eIZ`@0bSXI00<000000<Xj
6@3:>QT00`3:>QT2000000<0echK00<000000=Ln6`3G?Q/00`3G?Q/00`000000?EV[0=Ln6`020=Ln
6`050000003G?Q/0echK0=Ln6`0000000`1>L]`01P000000CW;L04ibg01>L]`0e3dI000000@0CW;L
00<0000004ibg01>L]`00P1>L]`2000000D0CW7I00<0000004iaf@1>LMT00P1>LMT20=@m6@030000
003D?AT0CW7I00@0CW7I00@0000004iaf@1>LMT0CW7I0P00000204e_e0030000001=Km@0CFoD00D0
CFoD00<0000004e_e01=Km@00P1=Km@20=@m6@0304e_e03D?AT0e3dI00<0CFoD00D0000004a]cP1<
KLh0C6g>0000000904a]cP030000001<KLh0C6g>0080e3dI101<KLh00`000000BVW704YYa`0604YY
a`80e3dI00<0ooK^0=@m6@3D?AT0103D?AT0103om^h0e3dI0?ofkP0mFJ/60=@m6@80ooK^0P0mFJ/3
0?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h00P0mFJ/60?ofkP0303eIZ`3om^h0
ooK^01L0ooK^00<000000?ofkP3om^h0<P3om^h00`000000ooK^0?ofkP0B0?ofkP40oooo000C0?of
kP030000003om^h0ooK^0340ooK^0P00000I0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?of
kP3om^h00P3om^h00`3D?AT0ooK^0?ofkP090?ofkP040=@m6@3om^h0ooK^0=@m6@H0ooK^200mFJ/5
0?ofkP80?EV[00<0ooK^0000000mFJ/01@2I:a<2000000030:`a5P000000[34F00@0[34F0P0mFJ/0
1@2/<AH000000:`a5P2/<AH0e3dI00D0[34F00@000000:`a5P00000000000P2l=QP203eIZ`030;`f
60000000_3HH0080_3HH0P0mFJ/20;`f60030000002l=QP0_3HH00H0_3HH0P0000060<Xj6@070000
003:>QT0bSXI0<Xj6@0mFJ/0bSXI000000020<Xj6@80?EV[0P3:>QT010000000bSXI0<Xj6@3:>QT3
000000D0echK00<000000=Ln6`3G?Q/00P3G?Q/00`0mFJ/0echK0=Ln6`020=Ln6`050000003G?Q/0
echK0=Ln6`0000000`1>L]`00`000000CW;L04ibg00204ibg0030=@m6@1>L]`0CW;L0080CW;L00<0
000004ibg01>L]`00`1>L]`3000000<0CW7I00<0000004iaf@1>LMT00P3D?AT204iaf@030000001>
LMT0e3dI00<0CW7I00<0000004iaf@1>LMT0101>LMT2000000P0CFoD00<0000004e_e01=Km@00P3D
?AT304e_e0040000001=Km@0e3dI0=@m6@80CFoD0P0000000`1<KLh0000004a]cP0404a]cP0503eI
Z`1<KLh0C6g>0000001<KLh00P3D?AT504a]cP040000001<KLh00000000000D0BVW700<0e3dI0000
003om^h00P3D?AT50?ofkPP0e3dI1P3om^h0100mFJ/0ooK^0?ofkP0mFJ/;0?ofkP0303eIZ`3om^h0
ooK^0080ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0G0?ofkP800000<`3om^h0
0`000000ooK^0?ofkP0A0?ofkP40oooo000C0?ofkP030000003om^h0ooK^0300ooK^00<000000?of
kP3om^h06@3om^h00`3D?AT0ooK^0?ofkP020?ofkP80e3dI1@3om^h00`3D?AT0ooK^0?ofkP090?of
kP<0e3dI2@3om^h603eIZ`L0ooK^0P0mFJ/0103D?AT0VB/C09T[4`2I:a<2000000@0[34F00<00000
0:`a5P2/<AH0102/<AH203eIZ`030000002/<AH0e3dI00H0[34F00D000000;`f602l=QP0_3HH03eI
Z`040;`f60030000002l=QP0_3HH0080_3HH0P0mFJ/00`2l=QP000000;`f60040;`f6080000000<0
bSXI0000003:>QT01@3:>QT0103D?AT0000003eIZ`0mFJ/30<Xj6@050000003:>QT0bSXI0<Xj6@0m
FJ/00P3:>QT3000000<0echK00<000000=Ln6`3G?Q/00P3G?Q/01P000000echK0=Ln6`3G?Q/0?EV[
000000@0echK00D000000=Ln6`3G?Q/0echK0000000304ibg0030000001>L]`0CW;L0080CW;L00<0
00000=@m6@1>L]`00P1>L]`00`000000CW;L04ibg00204ibg0040000001>L]`0CW;L04ibg0<00000
0P1>LMT01@3D?AT0CW7I04iaf@1>LMT0000000<0CW7I0P3D?AT00`000000?EV[04iaf@0504iaf@04
0000001>LMT00000000000D0CFoD00@0000004e_e03D?AT0e3dI101=Km@00`000000CFoD04e_e002
04e_e0050=@m6@1=Km@0CFoD04e_e0000000201<KLh00`000000e3dI0=@m6@0604a]cP030000001<
KLh0C6g>0080C6g>0P00000304YYa`0303eIZ`3D?AT0e3dI00L0ooK^1P3D?AT90?ofkP<0?EV[2`3o
m^h00`0mFJ/0ooK^0?ofkP030?ofkP80?EV[103om^h00`0mFJ/0ooK^0?ofkP0I0?ofkP030000003o
m^h0ooK^0300ooK^00<000000?ofkP3om^h04@3om^h10?ooo`004`3om^h00`000000ooK^0?ofkP0^
0?ofkP800000703om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00L0ooK^00<0e3dI0?ofkP3om^h02@3o
m^h00`3D?AT0ooK^0?ofkP0;0?ofkP0303eIZ`3D?AT0?EV[00<0?EV[103om^h20=@m6@030?ofkP0m
FJ/0?EV[008000001`2/<AH00`000000[34F0:`a5P050:`a5P80?EV[1@2/<AH2000000040;`f6000
0000?EV[03eIZ`H0_3HH00<000000;`f602l=QP00`2l=QP203eIZ`050000002l=QP0_3HH0;`f6000
00000`3:>QT00`000000bSXI0<Xj6@050<Xj6@0303eIZ`3:>QT0bSXI00<0bSXI00<000000<Xj6@3:
>QT00P3:>QT203eIZ`030000003G?Q/0echK00<0echK00<000000=Ln6`3G?Q/00P3G?Q/01P000000
echK0=Ln6`3G?Q/0?EV[000000@0echK00D000000=Ln6`3G?Q/0echK0000000304ibg0030000001>
L]`0CW;L0080CW;L00<000000=@m6@1>L]`00P1>L]`00`000000CW;L04ibg00204ibg0030000001>
L]`0CW;L00<0CW;L00<000000=@m6@3D?AT0101>LMT00`000000CW7I04iaf@0304iaf@030=@m6@1>
LMT0CW7I00D0CW7I00D0000004iaf@1>LMT0CW7I0000000304e_e0030000003D?AT0e3dI00D0CFoD
00<0000004e_e01=Km@0101=Km@20=@m6@040000001=Km@00000000000D0C6g>0P3D?AT704a]cP03
0000001<KLh0C6g>00D0C6g>0P0000020=@m6@030?ofkP0mFJ/0?EV[00@0ooK^103D?AT00`0mFJ/0
e3dI0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h01@3om^h01@0mFJ/0
ooK^0?ofkP3om^h0?EV[01`0ooK^0P00000`0?ofkP030000003om^h0ooK^0140ooK^0@3oool001<0
ooK^00<000000?ofkP3om^h0;@3om^h00`000000ooK^0?ofkP0L0?ofkP040=@m6@3om^h0e3dI0=@m
6@P0ooK^00<0e3dI0?ofkP3om^h01`3om^h30=@m6@h0ooK^0P0mFJ/00`3om^h0?EV[03eIZ`0203eI
Z`80e3dI103om^h00`000000?EV[03eIZ`080:`a5P030000002/<AH0[34F00D0[34F00<0000003eI
Z`0mFJ/00P2/<AH00`000000_3HH0;`f600203eIZ`030000002l=QP0_3HH00H0_3HH00<000000;`f
602l=QP0102l=QP0100mFJ/0_3HH0000000000050<Xj6@030000003:>QT0bSXI00<0bSXI00<0?EV[
0<Xj6@0000001@3:>QT010000000bSXI0<Xj6@3:>QT200000080?EV[1@3G?Q/01@000000echK0=Ln
6`3G?Q/000000080echK00<0?EV[0=Ln6`000000103G?Q/01@000000echK0=Ln6`3G?Q/0000000<0
CW;L00<0000004ibg01>L]`00P1>L]`01@000000CW;L0=@m6@1>L]`0000000@0CW;L00<0000004ib
g01>L]`00`1>L]`20=@m6@8000000`1>LMT00`000000CW7I04iaf@0304iaf@030000001>LMT0e3dI
00D0CW7I00<0000004iaf@1>LMT00`1>LMT20000000304e_e03D?AT0CFoD00D0CFoD00<0000004e_
e01=Km@01P1=Km@00`000000e3dI0=@m6@0204e_e0030000001<KLh0C6g>0080e3dI00<0000004a]
cP1<KLh01@1<KLh00`000000C6g>04a]cP0604a]cP80e3dI00<000000?ofkP3om^h00P3om^h203eI
Z`@0e3dI00<0ooK^0=@m6@3D?AT03P3om^h303eIZ`T0ooK^00<0?EV[0?ofkP3om^h01P3om^h203eI
Z`030?ofkP0mFJ/0ooK^01d0ooK^00<000000?ofkP3om^h0;@3om^h00`000000ooK^0?ofkP0A0?of
kP40oooo000C0?ofkP030000003om^h0ooK^02`0ooK^00<000000?ofkP3om^h0703om^h30=@m6@T0
ooK^00<0e3dI0?ofkP3om^h01P3om^h20=@m6@80ooK^00<0e3dI0?ofkP3om^h0303om^h01@3D?AT0
ooK^03eIZ`0mFJ/0ooK^00@0?EV[1@3om^h010000000[34F03eIZ`0mFJ/60:`a5P030000002/<AH0
[34F00H0[34F00D000000:`a5P0mFJ/0?EV[0;`f600203eIZ`<0_3HH00<000000;`f602l=QP01P2l
=QP00`000000_3HH0;`f60040;`f6080?EV[1`3:>QT01@000000bSXI0<Xj6@3:>QT0?EV[0080bSXI
00<000000<Xj6@3:>QT00`3:>QT010000000bSXI0000000000030=Ln6`030000000mFJ/0?EV[00<0
echK00<000000=Ln6`3G?Q/00P3G?Q/00`000000?EV[0=Ln6`020=Ln6`060000003G?Q/0echK0=Ln
6`000000echK1@0000000`1>L]`0000004ibg00204ibg0060000001>L]`0CW;L04ibg03D?AT00000
101>L]`010000000CW;L04ibg01>L]`20=@m6@040000001>L]`0CW;L04ibg080000000<0CW7I0000
001>LMT0101>LMT010000000CW7I04iaf@3D?AT304iaf@030000001>LMT0CW7I00D0CW7I0P3D?AT6
04e_e0030000001=Km@0CFoD00H0CFoD00@0000004e_e01=Km@0CFoD0P3D?AT01@1=Km@0e3dI0=@m
6@1<KLh0000000P0C6g>00<0000004a]cP1<KLh0101<KLh20=@m6@0304a]cP000000ooK^00@0ooK^
103D?AT01@3om^h0e3dI0=@m6@3om^h0?EV[00h0ooK^00<0?EV[0?ofkP3om^h00P0mFJ/80?ofkP03
03eIZ`3om^h0ooK^00L0ooK^0`0mFJ/N0?ofkP030000003om^h0ooK^02`0ooK^00<000000?ofkP3o
m^h04@3om^h10?ooo`004P3om^h00`000000ooK^0?ofkP0[0?ofkP8000007`3om^h00`3D?AT0ooK^
0?ofkP090?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^
0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00@0?EV[00<0ooK^03eIZ`0mFJ/0103om^h00`000000[34F
0:`a5P0203eIZ`D0[34F00<000000:`a5P2/<AH01P2/<AH010000000_3HH03eIZ`0mFJ/60;`f6003
0000002l=QP0_3HH00D0_3HH00<000000;`f602l=QP00P2l=QP2000000040<Xj6@000000?EV[03eI
Z`H0bSXI00<000000<Xj6@0mFJ/0103:>QT00`000000bSXI0<Xj6@030<Xj6@030000003G?Q/0echK
00<0echK00@000000=Ln6`3G?Q/0?EV[0P3G?Q/00`000000echK0=Ln6`020=Ln6`0303eIZ`3G?Q/0
echK0080echK00@000000=Ln6`3G?Q/0echK0P0000020>A270030000001>L]h0CW;N008000000`1>
L]`00`000000CW;L04ibg00204ibg0030=@m6@1>L]`0CW;L0080CW;L00H0000004ibg01>L]`0e3dI
04ibg000000604ibg0030000001>LMT0CW7I00<0CW7I00<0000004iaf@1>LMT00P1>LMT00`3D?AT0
CW7I0000000604iaf@80e3dI00@0000004iaf@0000000000101=Km@00`000000CFoD04e_e00504e_
e0030000001=Km@0CFoD00@0CFoD0P3D?AT00`1=Km@0000004a]cP0704a]cP030000001<KLh0C6g>
00<0C6g>0P3D?AT204a]cP030000003om^h0ooK^0080ooK^0P3D?AT00`3om^h0e3dI0=@m6@020=@m
6@80ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^
00D0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP0M0?ofkP800000;@3om^h00`00
0000ooK^0?ofkP0@0?ofkP40oooo000B0?ofkP030000003om^h0ooK^02X0ooK^00<000000?ofkP3o
m^h07`3om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^00<0ooK^0P3D?AT60?ofkP03
0=@m6@3om^h0ooK^00`0ooK^0`3D?AT20?ofkP@0?EV[00<0ooK^03eIZ`0mFJ/00`3om^h010000000
[34F0:`a5P2/<AH203eIZ`@0[34F00<000000:`a5P2/<AH00`2/<AH010000000?EV[03eIZ`0mFJ/2
0;`f6080?EV[102l=QP00`000000_3HH0;`f60060;`f60040000002l=QP00000000000@0bSXI00@0
00000<Xj6@0mFJ/0?EV[103:>QT203eIZ`H0bSXI00L000000<Xj6@3:>QT0bSXI0000003G?Q/00000
00D0echK00<000000=Ln6`3G?Q/00P0mFJ/01P3G?Q/000000=Ln6`3G?Q/0?EV[000000@0echK00<0
00000=Ln6`0000000P0000030>A270040000001>L]h0CW;N04ibgP<0000000<0CW;L0000001>L]`0
0`1>L]`01P000000e3dI04ibg01>L]`0000004ibg080e3dI0P1>L]`00`000000CW;L04ibg00304ib
g0030000001>L]`0000000<0CW7I00<0000004iaf@1>LMT0101>LMT20=@m6@@0CW7I0P3D?AT00`1>
LMT0000004iaf@0304iaf@80000000<0CFoD0000001=Km@01`1=Km@00`000000CFoD04e_e00204e_
e080e3dI0P1=Km@30=@m6@030000001<KLh0C6g>00<0C6g>00<0000004a]cP1<KLh00P1<KLh20=@m
6@<0C6g>00@000000?ofkP3om^h0ooK^0P3D?AT00`3om^h0e3dI0=@m6@020=@m6@80ooK^0`0mFJ/>
0?ofkP0303eIZ`3om^h0ooK^00@0ooK^0P0mFJ/50?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[
0?ofkP3om^h07`3om^h00`000000ooK^0?ofkP0Z0?ofkP030000003om^h0ooK^0100ooK^0@3oool0
0180ooK^00<000000?ofkP3om^h0:03om^h200000280ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D
?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D
?AT0ooK^0?ofkP040?ofkP@0?EV[00<0ooK^03eIZ`0mFJ/00P3om^h00`000000?EV[0:`a5P020:`a
5P80?EV[0`2/<AH010000000[34F0:`a5P00000203eIZ`<0_3HH00@000000;`f602l=QP0_3HH0P0m
FJ/30;`f60030000002l=QP0_3HH00H0_3HH00<000000<Xj6@3:>QT01@3:>QT00`000000bSXI0<Xj
6@0203eIZ`040<Xj6@0mFJ/0bSXI000000H0bSXI00@000000<Xj6@00000000000P3G?Q/00`000000
echK0=Ln6`030=Ln6`030000003G?Q/0echK0080echK0P0mFJ/0103G?Q/0?EV[0=Ln6`0000040=Ln
6`8000000P3T@Q`01@000000i48L0>A2703T@Q`0000000<0CW;N00<0000004ibgP1>L]h00P000003
04ibg0050000001>L]`0CW;L0=@m6@1>L]`00P3D?AT304ibg0030000001>L]`0CW;L00@0CW;L00<0
000004ibg01>L]`00P0000000`1>LMT0000004iaf@0504iaf@040000001>LMT0e3dI04iaf@80e3dI
0P1>LMT00`000000CW7I04iaf@0504iaf@030000001=Km@0CFoD00H0CFoD00@0000004e_e01=Km@0
CFoD0P3D?AT304e_e0040000001=Km@0CFoD04e_e080e3dI00@0000004a]cP1<KLh000000`1<KLh2
0=@m6@<0C6g>00@0e3dI0000003om^h0ooK^0P3D?AT00`3om^h0e3dI0=@m6@020=@m6@H0ooK^00<0
?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0
?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP0P0?ofkP800000:P3om^h00`000000ooK^0?of
kP0@0?ofkP40oooo000B0?ofkP030000003om^h0ooK^02L0ooK^00<000000?ofkP3om^h08P3om^h0
0`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^0080e3dI2@3om^h00`3D?AT0ooK^0?ofkP0:
0?ofkP<0e3dI1`3om^h503eIZ`050?ofkP0mFJ/0?EV[0?ofkP0mFJ/01@2/<AH203eIZ`80[34F0`0m
FJ/60;`f60030000002l=QP0_3HH0080_3HH0P0mFJ/20;`f60030000002l=QP0_3HH00<0_3HH0P00
00000`3:>QT000000<Xj6@060<Xj6@050000003:>QT0bSXI0<Xj6@0mFJ/00`3:>QT00`000000bSXI
0<Xj6@040<Xj6@030000003G?Q/0echK00<0echK00<000000=Ln6`3G?Q/00`3G?Q/00`000000echK
0=Ln6`020=Ln6`030000000mFJ/0echK0080echK00<000000=Ln6`0000000P0000030>A270050000
003T@Q`0i48L0>A2700000000`1>L]h010000000CW;N04ibgP1>L]h30000000304ibg0000000CW;L
0080CW;L00<0e3dI0000001>L]`00`1>L]`00`000000CW;L04ibg00304ibg0030000001>L]`0CW;L
00<0CW;L00<0000004iaf@1>LMT0101>LMT01@000000CW7I04iaf@1>LMT0e3dI00<0CW7I00<00000
04iaf@1>LMT01@1>LMT010000000CW7I00000000000504e_e0030000001=Km@0CFoD0080e3dI101=
Km@00`000000CFoD04e_e00404e_e0<0e3dI0P1<KLh20=@m6@@0C6g>00<0e3dI0000003om^h00P3D
?AT00`3om^h0e3dI0=@m6@030=@m6@L0ooK^0`0mFJ/<0?ofkP0303eIZ`3om^h0ooK^00L0ooK^0P0m
FJ/20?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h08P3om^h00`000000ooK^0?of
kP0W0?ofkP030000003om^h0ooK^0100ooK^0@3oool00140ooK^00<000000?ofkP3om^h09P3om^h2
000002D0ooK^00<0e3dI0?ofkP3om^h02@3om^h30=@m6@/0ooK^00<0e3dI0?ofkP3om^h02@3om^h0
1@3D?AT0ooK^0?ofkP3om^h0e3dI00P0ooK^1@0mFJ/0103om^h0?EV[03eIZ`0mFJ/20:`a5PH0?EV[
00<0e3dI0000002l=QP01`2l=QP00`000000_3HH0;`f60030;`f6080?EV[00@0_3HH0000002l=QP0
_3HH0P0000040<Xj6@030000003:>QT0bSXI00D0bSXI00@0000003eIZ`0mFJ/0bSXI0P0mFJ/20<Xj
6@040000003:>QT0bSXI0<Xj6@80000000<0echK0000003G?Q/0103G?Q/00`000000echK0=Ln6`02
0=Ln6`030000003G?Q/0echK0080echK00D0?EV[0000000mFJ/0?EV[0=Ln6`0200000080i48L00D0
00000>A2703T@Q`0i48L000000030>A270050000001>L]h0CW;N04ibgP0000000`1>L]h00`000000
CW;N04ibgP020000000504ibg03D?AT0e3dI0000003D?AT00`1>L]`00`000000CW;L04ibg00304ib
g0030000001>L]`0CW;L00<0CW;L00@0000004ibg000000000000`1>LMT00`000000CW7I04iaf@02
0=@m6@0404iaf@3D?AT0e3dI000000L0CW7I00<0000004iaf@1>LMT00P1>LMT200000080CFoD00@0
000004e_e03D?AT0e3dI1@1=Km@00`000000CFoD04e_e00604e_e0030000000mFJ/0e3dI00D0e3dI
0P1<KLh30=@m6@030?ofkP3D?AT0e3dI00<0e3dI203om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00X0
ooK^00<0?EV[0?ofkP3om^h02P3om^h303eIZ`/0ooK^00<0?EV[0?ofkP3om^h08`3om^h2000002P0
ooK^00<000000?ofkP3om^h03`3om^h10?ooo`004@3om^h00`000000ooK^0?ofkP0U0?ofkP030000
003om^h0ooK^02D0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m
6@3om^h0ooK^00H0ooK^0P3D?AT40?ofkP030=@m6@3om^h0ooK^00P0ooK^2@0mFJ/30:`a5P060000
002l=QP0?EV[03eIZ`2l=QP00000202l=QP00`000000_3HH0;`f60040;`f600403eIZ`2l=QP00000
000000L0bSXI00<000000<Xj6@3:>QT00`3:>QT203eIZ`030000003:>QT0bSXI0080bSXI0P0mFJ/0
10000000bSXI0000000000040=Ln6`030000003G?Q/0echK0080echK00<000000=Ln6`3G?Q/00`3G
?Q/01P000000echK03eIZ`0mFJ/0echK00000080echK0P0mFJ/40>A270040000003T@Q`0i48L0000
00<0i48L00D0000004ibgP1>L]h0CW;N0000000204ibgP030000001>L]h0CW;N0080CW;N0P3D?AT2
04ibg0060000001>L]`0e3dI0=@m6@1>L]`000001@1>L]`00`000000CW;L04ibg00204ibg0030000
001>L]`0CW;L0080CW;L0P000000101>LMT000000=@m6@3D?AT404iaf@030000003D?AT0e3dI00D0
CW7I00<0000004iaf@1>LMT01@1>LMT20000000304e_e03D?AT0CFoD00D0CFoD00<0000004e_e01=
Km@01P1=Km@01P000000CFoD0=@m6@3D?AT0CFoD000000<0C6g>2@3D?AT:0?ofkP0303eIZ`3om^h0
ooK^0080ooK^0P0mFJ/80?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h02@3om^h0
0`0mFJ/0ooK^0?ofkP0U0?ofkP030000003om^h0ooK^02D0ooK^00<000000?ofkP3om^h03`3om^h1
0?ooo`004@3om^h00`000000ooK^0?ofkP0T0?ofkP030000003om^h0ooK^02H0ooK^00<0e3dI0?of
kP3om^h01`3om^h30=@m6@h0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP040?of
kP030=@m6@3om^h0ooK^00X0ooK^100mFJ/0103D?AT0ooK^03eIZ`0mFJ/2000000@0_3HH0P0mFJ/0
0`000000_3HH0;`f60060;`f60030000002l=QP0_3HH00@0_3HH0P0mFJ/00`000000bSXI0<Xj6@06
0<Xj6@050000003:>QT0bSXI0<Xj6@0mFJ/00`3:>QT00`000000bSXI0<Xj6@030<Xj6@80?EV[1P3G
?Q/00`000000echK0=Ln6`030=Ln6`030000003G?Q/0echK0080echK00<0000003eIZ`3G?Q/0103G
?Q/00`000000i48L0>A2700203eIZ`80i48L00@000000>A2703T@Q`000000`3T@Q`01@000000CW;N
04ibgP1>L]h000000080CW;N00<0000004ibgP1>L]h00P3D?AT204ibgP800000101>L]`00`3D?AT0
CW;L04ibg00304ibg0030000001>L]`0CW;L00<0CW;L00<0000004ibg01>L]`0101>L]`20=@m6@D0
CW7I00D0000004iaf@1>LMT0CW7I0=@m6@0304iaf@030000001>LMT0CW7I00H0CW7I00<000000=@m
6@3D?AT01P1=Km@00`000000CFoD04e_e00604e_e0030000003D?AT0e3dI00@0CFoD0P0000020=@m
6@0303eIZ`3om^h0e3dI00<0e3dI303om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^
00D0ooK^00<0?EV[0?ofkP3om^h0303om^h303eIZ`T0ooK^00<0?EV[0?ofkP3om^h09P3om^h00`00
0000ooK^0?ofkP0T0?ofkP030000003om^h0ooK^00l0ooK^0@3oool00140ooK^00<000000?ofkP3o
m^h08P3om^h2000002T0ooK^00<0e3dI0?ofkP3om^h01P3om^h0103D?AT0ooK^0?ofkP3D?AT>0?of
kP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP0;0?of
kP@0?EV[00<0ooK^03eIZ`2l=QP01`2l=QP203eIZ`P0_3HH00@000000;`f602l=QP0_3HH0P000002
0<Xj6@80?EV[00<000000<Xj6@3:>QT01@3:>QT00`000000?EV[03eIZ`050<Xj6@030000003:>QT0
bSXI008000000P3G?Q/203eIZ`D0echK00<000000=Ln6`3G?Q/00P3G?Q/00`000000echK0=Ln6`02
0=Ln6`0303eIZ`000000echK00<0echK00H000000>A2703T@Q`0i48L0000003T@Q`203eIZ`050000
003T@Q`0i48L0>A2700000000P3T@Q`010000000CW;N04ibgP00000304ibgP050000003D?AT0e3dI
04ibgP0000000`1>L]h00`000000CW;L04ibg00204ibg0030000003D?AT0CW;L00<0CW;L00<00000
04ibg01>L]`00P1>L]`00`000000CW;L04ibg00304ibg080e3dI0P1>L]`200000080CW7I00<00000
04iaf@1>LMT00`1>LMT20=@m6@030000001>LMT0CW7I00D0CW7I00<000000=@m6@3D?AT00P1>LMT2
000000<0CFoD00<0000004e_e01=Km@01P1=Km@20=@m6@P0CFoD00<0e3dI0?ofkP3D?AT00`3D?AT=
0?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0<
0?ofkP0403eIZ`3om^h0ooK^03eIZ`P0ooK^00<0?EV[0?ofkP3om^h09`3om^h2000002@0ooK^00<0
00000?ofkP3om^h03`3om^h10?ooo`004@3om^h00`000000ooK^0?ofkP0Q0?ofkP030000003om^h0
ooK^02T0ooK^00<0e3dI0?ofkP3om^h0103om^h20=@m6@@0ooK^00<0e3dI0?ofkP3om^h02`3om^h0
0`3D?AT0ooK^0?ofkP020?ofkP80e3dI2@3om^h00`3D?AT0ooK^0?ofkP0=0?ofkPD0?EV[00<00000
0;`f602l=QP01P2l=QP203eIZ`L0_3HH00<000000;`f600000001P3:>QT203eIZ`D0bSXI0P0mFJ/0
0`3:>QT000000<Xj6@050<Xj6@8000001@3G?Q/00`000000?EV[03eIZ`040=Ln6`030000003G?Q/0
echK0080echK00H000000=Ln6`3G?Q/0?EV[0=Ln6`0000020=Ln6`<000000`3T@Q`010000000i48L
0>A2703T@Q`203eIZ`80i48L00@000000>A2703T@Q`000000P1>L]h00`000000CW;N04ibgP020=@m
6@<0CW;N00D0000004ibgP1>L]h0000004ibgP02000000@0CW;L00@0e3dI04ibg01>L]`00000101>
L]`00`000000CW;L04ibg00204ibg080e3dI00<0000004ibg01>L]`00`1>L]`2000000H0CW7I00@0
000004iaf@3D?AT0e3dI1@1>LMT20=@m6@H0CW7I00<0000004e_e00000001`1=Km@20=@m6@P0CFoD
00<000000=@m6@3D?AT00`3D?AT?0?ofkP0303eIZ`3om^h0ooK^00L0ooK^0P0mFJ/40?ofkP0303eI
Z`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h00P3om^h203eIZ`H0ooK^00<0?EV[0?ofkP3om^h0
:@3om^h00`000000ooK^0?ofkP0Q0?ofkP030000003om^h0ooK^00l0ooK^0@3oool00100ooK^00<0
00000?ofkP3om^h0803om^h2000002`0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?of
kP040?ofkP030=@m6@3om^h0ooK^00`0ooK^00@0e3dI0?ofkP3om^h0e3dI2`3om^h00`3D?AT0ooK^
0?ofkP0<0?ofkP80e3dI00<0ooK^03eIZ`0mFJ/00P0mFJ/00`000000_3HH0;`f60070;`f600303eI
Z`2l=QP0_3HH00D0_3HH00<000000<Xj6@3:>QT01`3:>QT203eIZ`030<Xj6@0mFJ/0?EV[00@0bSXI
00<000000<Xj6@3:>QT00P3:>QT00`000000echK000000060=Ln6`040000003G?Q/0?EV[03eIZ`<0
echK00<000000=Ln6`3G?Q/00P3G?Q/00`000000?EV[0=Ln6`020=Ln6`8000000`3T@Q`01@000000
i48L0>A2703T@Q`0000000<0i48L00@0000003eIZ`0mFJ/000000P3T@Q`010000000CW;N04ibgP00
00020=@m6@050000001>L]h0CW;N04ibgP0000000`1>L]h010000000CW;N04ibgP1>L]h2000000<0
CW;L00<0e3dI0000001>L]`00`1>L]`010000000CW;L04ibg01>L]`20=@m6@0304ibg0000000CW;L
00D0CW;L00<0000004ibg0000000101>LMT00`000000CW7I04iaf@0204iaf@80e3dI00<0CW7I0=@m
6@3D?AT02@1>LMT00`000000CFoD04e_e00504e_e0030=@m6@1=Km@0CFoD00L0CFoD00<000000=@m
6@3D?AT00P3D?AT00`3om^h0?EV[03eIZ`0>0?ofkP0303eIZ`3om^h0ooK^00T0ooK^00@0?EV[0?of
kP3om^h0?EV[3P3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[
0?ofkP3om^h0:P3om^h200000280ooK^00<000000?ofkP3om^h03P3om^h10?ooo`00403om^h00`00
0000ooK^0?ofkP0O0?ofkP030000003om^h0ooK^02`0ooK^00@0e3dI0?ofkP3om^h0ooK^0P3D?AT7
0?ofkP030=@m6@3om^h0ooK^00`0ooK^0`3D?AT=0?ofkP030=@m6@3om^h0ooK^00X0ooK^00H0e3dI
0?ofkP3om^h0ooK^0=@m6@3om^h403eIZ`T0_3HH0P0mFJ/30;`f6080000000<0bSXI000000000000
203:>QT203eIZ`L0bSXI00@000000<Xj6@00000000000`3G?Q/00`000000echK0=Ln6`040=Ln6`03
0000003G?Q/0echK0080?EV[0P3G?Q/00`000000echK0=Ln6`0203eIZ`80echK0P0000000`3T@Q`0
00000>A270020>A270050000003T@Q`0i48L0>A2700000000`3T@Q`00`000000i48L0>A2700203eI
Z`030>A270000000CW;N0080e3dI0P1>L]h01@000000CW;N04ibgP1>L]h000000080CW;N00<00000
04ibgP1>L]h00P1>L]h010000000CW;N00000000000204ibg080e3dI0P1>L]`00`000000CW;L04ib
g0020=@m6@80CW;L00<0000004ibg01>L]`0101>L]`010000000CW;L04ibg01>L]`20000000304ia
f@000000CW7I00H0CW7I0P3D?AT804iaf@80000000<0CW7I0000000000000`1=Km@20=@m6@T0CFoD
103D?AT00`3om^h0?EV[0?ofkP020?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h0
2`3om^h303eIZ`h0ooK^00<0?EV[0?ofkP3om^h01@3om^h203eIZ`<0ooK^00<0?EV[0?ofkP3om^h0
;03om^h00`000000ooK^0?ofkP0O0?ofkP030000003om^h0ooK^00h0ooK^0@3oool00100ooK^00<0
00000?ofkP3om^h07@3om^h2000002l0ooK^00@0e3dI0?ofkP3om^h0e3dI2@3om^h00`3D?AT0ooK^
0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h0203om^h20=@m6@D0ooK^
00<0e3dI0?ofkP3om^h0100mFJ/80;`f60040000000mFJ/0?EV[000000D0bSXI00<000000<Xj6@3:
>QT00P3:>QT303eIZ`040<Xj6@000000?EV[03eIZ`H0bSXI00<000000=Ln6`3G?Q/0103G?Q/00`00
0000echK0=Ln6`040=Ln6`040000003G?Q/0echK0=Ln6`80?EV[00<000000=@m6@0mFJ/00P3G?Q/2
000000<0i48L00<000000>A2703T@Q`00P3T@Q`010000000i48L0>A2700000030>A270040000003T
@Q`0i48L00000080i48L00@0000004ibgP1>L]h000000P1>L]h01@000000CW;N04ibgP1>L]h00000
0080CW;N00<0000004ibgP1>L]h00P1>L]h010000000CW;N04ibgP1>L]h200000080CW;L00<0e3dI
03eIZ`0000000P3D?AT304ibg0030000001>L]`0CW;L00@0CW;L00<0000004ibg01>L]`0101>L]`0
0`000000CW7I04iaf@0404iaf@80e3dI00<0000004iaf@3D?AT00P3D?AT404iaf@030000001>LMT0
CW7I00<0CW7I00@000000=@m6@3D?AT00000201=Km@40=@m6@80ooK^00<0?EV[0?ofkP3om^h00`3o
m^h203eIZ`X0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3o
m^h0ooK^00L0ooK^00@0?EV[0?ofkP3om^h0?EV[;`3om^h2000001l0ooK^00<000000?ofkP3om^h0
3P3om^h10?ooo`00403om^h00`000000ooK^0?ofkP0L0?ofkP030000003om^h0ooK^02l0ooK^0`3D
?AT:0?ofkP030=@m6@3om^h0ooK^00X0ooK^0`3D?AT?0?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0
e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP020?ofkP@0?EV[1`2l=QP010000000bSXI03eI
Z`0mFJ/50<Xj6@8000000P0mFJ/50<Xj6@8000000P0mFJ/20<Xj6@80000000<0echK000000000000
1@3G?Q/00`000000echK0=Ln6`040=Ln6`030000003G?Q/0echK0080echK0P0mFJ/01@3G?Q/00000
0000003T@Q`0000000@0i48L00D000000>A2703T@Q`0i48L000000030>A270040000003T@Q`0i48L
00000080i48L00<000000>A2700000000P0000001@1>L]h0000004ibgP1>L]h000000080CW;N00@0
000004ibgP1>L]h00000101>L]h00`000000CW;N04ibgP0204ibgP050000001>L]h000000000001>
L]`00P3D?AT404ibg0030000001>L]`0CW;L00@0CW;L00<0000004ibg01>L]`00`1>L]`200000003
04ibg000000000000080CW7I0P3D?AT2000000D0CW7I0P3D?AT2000000D0CW7I0P3D?AT00`1>LMT0
000004e_e00604e_e0@0e3dI103om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00L0
ooK^00<0?EV[0?ofkP3om^h03@3om^h303eIZ`/0ooK^00<0?EV[0?ofkP3om^h02@3om^h303eIZc40
ooK^00<000000?ofkP3om^h0703om^h00`000000ooK^0?ofkP0>0?ofkP40oooo000?0?ofkP030000
003om^h0ooK^01`0ooK^00<000000?ofkP3om^h0<03om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m
6@3om^h0ooK^00L0ooK^0P3D?AT30?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h0
103om^h20=@m6@T0ooK^00<0e3dI0?ofkP3om^h00`3om^h403eIZ`<0_3HH0P000000103:>QT00000
0000003:>QT203eIZ`80bSXI0`0mFJ/2000000L0bSXI00@000000<Xj6@0mFJ/0?EV[1@3G?Q/00`00
0000echK0=Ln6`030=Ln6`8000001@3G?Q/00`000000echK0=Ln6`0203eIZ`030=Ln6`0mFJ/0?EV[
00<0i48L00D000000>A2703T@Q`0i48L000000040>A270040000003T@Q`0i48L000000<0i48L00L0
00000>A27000000000000>m67P000000CG;N0080000000<0CW;N0000001>L]h00P1>L]h010000000
CW;N04ibgP00000404ibgP050000001>L]h0CW;N04ibgP0000000`1>L]h20=@m6@0304ibg03D?AT0
e3dI0080CW;L00<0000004ibg01>L]`00`1>L]`2000000D0CW;L00<0000004ibg01>L]`00`1>L]`2
0=@m6@0304iaf@000000CW7I00H0CW7I0P0000030=@m6@80CW7I0P3D?AT0101>LMT000000000001>
LMT2000000<0CFoD103D?AT50?ofkP0303eIZ`3om^h0ooK^00L0ooK^0P0mFJ/60?ofkP0303eIZ`3o
m^h0ooK^00d0ooK^00@0?EV[0?ofkP3om^h0ooK^0P0mFJ/90?ofkP0303eIZ`3om^h0ooK^00/0ooK^
00<0?EV[0?ofkP3om^h0<03om^h00`000000ooK^0?ofkP0L0?ofkP030000003om^h0ooK^00d0ooK^
0@3oool000l0ooK^00<000000?ofkP3om^h06P3om^h2000003<0ooK^00<0e3dI0?ofkP3om^h02`3o
m^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h03@3o
m^h00`3D?AT0ooK^0?ofkP020?ofkP80e3dI2`3om^h00`3D?AT0ooK^0?ofkP050?ofkPl0?EV[1@3:
>QT00`000000bSXI0<Xj6@040<Xj6@8000000P3G?Q/203eIZ`@0echK00<000000=Ln6`3G?Q/0103G
?Q/00`000000echK0=Ln6`030=Ln6`80?EV[00D0echK000000000000i48L0000000203eIZ`80i48L
00D000000>A2703T@Q`0i48L000000030>A270040000003T@Q`0i48L000000<0i48L0`0000020>m6
7P030000001=L]h0CG;N00<000000`1>L]h00`000000CW;N0000000404ibgP050000001>L]h0CW;N
04ibgP0000000P1>L]h20=@m6@050000001>L]h000000000001>L]`00P3D?AT504ibg0030000001>
L]`0CW;L00@0CW;L00<0000004ibg01>L]`00P1>L]`20=@m6@80CW;L0P00000604iaf@030000001>
LMT0CW7I00<0CW7I3`3D?AT70?ofkP0303eIZ`3om^h0ooK^00T0ooK^0P0mFJ/40?ofkP0303eIZ`3o
m^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3o
m^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h0<@3om^h2000001`0ooK^00<000000?ofkP3om^h03@3o
m^h10?ooo`003`3om^h00`000000ooK^0?ofkP0I0?ofkP030000003om^h0ooK^03<0ooK^00<0e3dI
0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP040?ofkP80e3dI1P3om^h00`3D?AT0ooK^0?ofkP0=
0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT03P3om^h00`3D?AT0ooK^0?ofkP060?ofkP@0?EV[1P3:
>QT010000000bSXI03eIZ`0mFJ/50<Xj6@8000000P3:>QT200000080echK0P0000020=Ln6`80?EV[
0`3G?Q/2000000D0echK00H000000=Ln6`3G?Q/0echK03eIZ`3G?Q/2000000@0i48L00<000000>A2
700mFJ/00P3T@Q`01@000000i48L0>A2703T@Q`0000000<0i48L00<000000>A2703T@Q`00P3T@Q`2
000000050>m67P000000kdHN0>m67P0000000P1=L]h01P000000CG;N000000000000CW;N00000080
CW;N00D0000004ibgP1>L]h0CW;N0000000304ibgP060000001>L]h0CW;N0=@m6@1>L]h00000101>
L]h20000000304ibg03D?AT0CW;L0080CW;L00<0000004ibg01>L]`00`1>L]`2000000<0CW;L0P3D
?AT204ibg08000000P1>L]`200000080CW7I0P00000504iaf@80e3dI00<0CW7I0000001>LMT01@1>
LMT40=@m6@P0ooK^00<0?EV[0?ofkP3om^h0303om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00l0ooK^
00<0?EV[0?ofkP3om^h0103om^h203eIZ`H0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^
0?ofkP0c0?ofkP030000003om^h0ooK^01T0ooK^00<000000?ofkP3om^h03@3om^h10?ooo`003`3o
m^h00`000000ooK^0?ofkP0G0?ofkP800000=P3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3o
m^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP<0e3dI3`3o
m^h00`3D?AT0ooK^0?ofkP070?ofkP030000000mFJ/0?EV[0080?EV[1@3:>QT2000000030<Xj6@0m
FJ/0?EV[00D0bSXI0P0000060=Ln6`8000000P3G?Q/203eIZ`<0echK00<000000=Ln6`3G?Q/00`3G
?Q/00`000000?EV[03eIZ`02000000030>A270000000i48L00@0i48L00D000000>A2700mFJ/0?EV[
000000030>A270050000003T@Q`0i48L0>A2700000000P3T@Q`2000000040>m67P000000kdHN03eI
Z`80kdHN00L0000004ebgP000000e3dI04ebgP000000CG;N008000001P1>L]h01@000000CW;N04ib
gP1>L]h000000080e3dI00<0CW;N0000001>L]h0101>L]h010000000CW;N0000000000020=@m6@03
0000001>L]`0CW;L00<0CW;L00@0000004ibg01>L]`0CW;L0P3D?AT204ibg08000001P1>L]`20000
00D0CW7I0P3D?AT00`1>LMT000000000000504iaf@@0e3dI00<000000?ofkP3om^h01`3om^h00`0m
FJ/0ooK^0?ofkP0=0?ofkP<0?EV[3`3om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^
00<0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP0d0?ofkP8000006@3om^h00`00
0000ooK^0?ofkP0=0?ofkP40oooo000?0?ofkP030000003om^h0ooK^01H0ooK^00<000000?ofkP3o
m^h0=`3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^0080e3dI2P3om^h00`3D?AT0
ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^0100ooK^00<0e3dI0?ofkP3om^h0203om^h20=@m6@03
0<Xj6@0mFJ/0?EV[00D0bSXI0P0000000`3:>QT0?EV[03eIZ`020<Xj6@040000003G?Q/000000000
00L0echK00@000000=Ln6`3G?Q/0echK0P0mFJ/20=Ln6`040000003G?Q/0echK0=Ln6`80?EV[0P00
00040>A270800000103T@Q`00`000000i48L0>A2700203eIZ`<0i48L00@000000>A2703T@Q`0i48L
0`0000020>m67P0;0000000mFJ/0kdHN0000003_AQh0000004ebgP000000CG;N0=@m6@0000000P1=
L]h3000000<0CW;N00@0000004ibgP1>L]h0CW;N0P3D?AT204ibgP030000001>L]h0CW;N0080CW;N
0P00000404ibgP8000000P3D?AT304ibg0030000001>L]`0CW;L0080e3dI0`1>L]`00`000000CW;L
04ibg00504ibg080000000@0CW;L0000001>LMT0CW7I0P3D?AT00`1>LMT000000000000504iaf@80
e3dI00<0CW7I0=@m6@0mFJ/02P3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0303eIZ`3om^h0ooK^00d0
ooK^00<0?EV[0?ofkP3om^h0203om^h203eIZ`80ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0
ooK^0?ofkP0g0?ofkP030000003om^h0ooK^01H0ooK^00<000000?ofkP3om^h03@3om^h10?ooo`00
3P3om^h00`000000ooK^0?ofkP0E0?ofkP800000>P3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP<0e3dI
303om^h00`3D?AT0ooK^0?ofkP0;0?ofkP80e3dI00<0ooK^0=@m6@3om^h0403om^h00`3D?AT0ooK^
0?ofkP070?ofkP030=@m6@3om^h0ooK^0080000000<0bSXI03eIZ`0mFJ/01@3:>QT2000000030<Xj
6@0mFJ/0?EV[00@0echK0P0000060=Ln6`8000000`3G?Q/203eIZ`040=Ln6`000000?EV[03eIZ`80
000000<0i48L0000000000001@3T@Q`01@000000i48L0>A2703T@Q`0000000@0i48L00D0?EV[0>A2
703T@Q`000000>A2700300000080kdHN018000000>m67P0mFJ/000000>m67P000000kdHN0000001=
L]h0000004ebgP000000e3dI04ebgP000000CG;N0000001=L]h20000000504ibgP000000CW;N04ib
gP3D?AT0101>L]h01@000000CW;N04ibgP1>L]h0000000D0CW;N0P0000000`1>L]h0000000000002
0=@m6@040000001>L]`0e3dI0=@m6@<0CW;L0P00000604ibg0800000101>L]`20=@m6@0304iaf@00
0000000000D0CW7I0P3D?AT00`1>LMT00000000000020?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0
?EV[0?ofkP3om^h03`3om^h0100mFJ/0ooK^03eIZ`0mFJ/<0?ofkP0303eIZ`3om^h0ooK^00/0ooK^
0`0mFJ/=0?ofkP0303eIZ`3om^h0ooK^03P0ooK^0P00000G0?ofkP030000003om^h0ooK^00`0ooK^
0@3oool000h0ooK^00<000000?ofkP3om^h0503om^h00`000000ooK^0?ofkP0j0?ofkP030=@m6@3o
m^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP080?ofkP80e3dI0`3o
m^h00`3D?AT0ooK^0?ofkP0@0?ofkP030=@m6@3om^h0ooK^00@0ooK^0P3D?AT50?ofkP80000000<0
bSXI03eIZ`0mFJ/01@3:>QT2000000030=Ln6`0mFJ/0?EV[00@0echK0P0000060=Ln6`8000000`3G
?Q/203eIZ`030=Ln6`000000i48L00@0i48L00<000000>A2703T@Q`00`3T@Q`01@000000i48L0>A2
703T@Q`0000000@0i48L0P0mFJ/00`3T@Q`000000>m67P020>m67P0C0000003_AQh0000003eIZ`3_
AQh000000>m67P000000kdHN0000001=L]h0000004ebgP000000CG;N0=@m6@000000CG;N00000003
04ebgP040000001>L]h0e3dI0=@m6@@0CW;N00D0000004ibgP1>L]h0CW;N0000000504ibgP030000
001>L]h0CW;N00<0CW;N00@0000004ibg03D?AT0e3dI0`1>L]`2000000H0CW;L0P00000404ibg080
e3dI00<0CW;L0000000000001@1>LMT20=@m6@0304iaf@000000000000D0ooK^0P0mFJ/60?ofkP03
03eIZ`3om^h0ooK^0100ooK^00@0?EV[0?ofkP3om^h0ooK^0P0mFJ/:0?ofkP0303eIZ`3om^h0ooK^
00d0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP0j0?ofkP030000003om^h0ooK^
01@0ooK^00<000000?ofkP3om^h0303om^h10?ooo`003P3om^h00`000000ooK^0?ofkP0C0?ofkP03
0000003om^h0ooK^03/0ooK^00<0e3dI0?ofkP3om^h02@3om^h30=@m6@l0ooK^00<0e3dI0?ofkP3o
m^h01`3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3o
m^h00`3om^h00`3D?AT0ooK^0?ofkP070?ofkP80000000<0bSXI03eIZ`0mFJ/00P3:>QT00`000000
echK0=Ln6`02000000030=Ln6`0mFJ/0?EV[00@0echK0P0000060=Ln6`<0?EV[00@0echK0000000m
FJ/0?EV[0P0000040>A270030000003T@Q`0i48L00<0i48L00H000000>A2703T@Q`0i48L0000003D
?AT30>A270040000000mFJ/0?EV[00000080kdHN0100000003eIZ`0mFJ/000000>m67P000000kdHN
0000003_AQh0000004ebgP000000CG;N0000001=L]h000000P3D?AT304ebgP040000003D?AT0e3dI
000000<0CW;N00<0?EV[0000001>L]h00P1>L]h00`000000CW;N04ibgP0304ibgP030000001>L]h0
CW;N0080CW;N0P0000020=@m6@030000001>L]`0e3dI0080e3dI1P1>L]`2000000@0CW;L0P3D?AT0
0`1>L]`000000000000204ibg0030000001>LMT0CW7I0080e3dI00<0CW7I0000000000002@3om^h0
0`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h0103om^h0
0`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00d0ooK^0`0mFJ/;0?ofkP0303eIZ`3om^h0
ooK^03/0ooK^00<000000?ofkP3om^h04`3om^h00`000000ooK^0?ofkP0<0?ofkP40oooo000>0?of
kP030000003om^h0ooK^0140ooK^0P00000n0?ofkP030=@m6@3om^h0ooK^00L0ooK^0P3D?AT30?of
kP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h0103om^h20=@m6@L0ooK^00<0e3dI0?of
kP3om^h0403om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00`0ooK^0P0000000`3:>QT0?EV[03eIZ`05
0=Ln6`80000000<0echK03eIZ`0mFJ/0103G?Q/200000080echK0P0mFJ/20=Ln6`8000000`3T@Q`2
03eIZ`8000000`3T@Q`2000000@0i48L0P0000020>A2700S0000003T@Q`000000000003_AQh00000
0>m67P0mFJ/000000>m67P0mFJ/000000>m67P000000kdHN0000003_AQh000000>m67P000000CG;N
0000001=L]h0000004ebgP000000CG;N0000003D?AT0CG;N0000003D?AT0CG;N0000001=L]h00P00
0000101>L]h0000004ibgP1>L]h2000000@0CW;N0P00000304ibgP8000000P3D?AT304ibgP800000
0P1>L]`20=@m6@80CW;L0P00000404ibg080e3dI00<0CW;L0000000000001@1>L]`20=@m6@0304ia
f@000000000000`0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0B0?ofkP0303eIZ`3om^h0ooK^00D0
ooK^0P0mFJ/60?ofkP0303eIZ`3om^h0ooK^00d0ooK^00@0?EV[0?ofkP3om^h0ooK^0P0mFJ/90?of
kP0303eIZ`3om^h0ooK^03`0ooK^0P00000C0?ofkP030000003om^h0ooK^00`0ooK^0@3oool000d0
ooK^00<000000?ofkP3om^h04@3om^h00`000000ooK^0?ofkP0n0?ofkP030=@m6@3om^h0ooK^00H0
ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00<0
ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP0?0?ofkP040=@m6@3om^h0e3dI0=@m
6@l0ooK^0P0000000`3G?Q/0?EV[03eIZ`050=Ln6`<000000P0mFJ/30=Ln6`<0?EV[0P3G?Q/20000
0080i48L0P0000030>A27080?EV[00<000000>A2703T@Q`00P3T@Q`00`000000i48L0>A270030>A2
70040000003T@Q`0i48L000000@0kdHN00<000000>m67P0mFJ/00P0mFJ/020000000kdHN0000003_
AQh000000>m67P000000kdHN0P00000204ebgP050000001=L]h000000000001=L]h00`3D?AT00`1=
L]h0000004ebgP0304ebgP040000001>L]h0CW;N000000D0CW;N00<0000004ibgP1>L]h00P1>L]h0
0`000000e3dI0=@m6@0304ibgP8000000P1>L]h200000080CW;L0`3D?AT304ibg080e3dI0`000005
04ibg080e3dI00<0CW;L0000000000003`3om^h203eIZ`030?ofkP0mFJ/0ooK^0100ooK^00<0?EV[
0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[
0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^03h0ooK^00<00000
0?ofkP3om^h0403om^h00`000000ooK^0?ofkP0<0?ofkP40oooo000=0?ofkP030000003om^h0ooK^
00l0ooK^0P0000110?ofkP030=@m6@3om^h0ooK^00@0ooK^0P3D?AT60?ofkP030=@m6@3om^h0ooK^
00d0ooK^00@0e3dI0?ofkP3om^h0ooK^0P3D?AT;0?ofkP030=@m6@3om^h0ooK^0100ooK^00<0e3dI
0?ofkP3om^h04@3om^h3000000d0?EV[0`3G?Q/2000000H0i48L0P0000030>A2700303eIZ`000000
000000<0i48L00<000000>A2703T@Q`00`3T@Q`2000000030>m67P000000kdHN00<0kdHN0P0mFJ/0
1@000000kdHN03eIZ`0mFJ/0kdHN008000000P3_AQh300000080CG;N0P0000001@1=L]h0e3dI0=@m
6@1=L]h000000080e3dI101=L]h010000000CG;N00000000000504ibgP040000001>L]h0CW;N04ib
gP80000000@0e3dI04ibgP1>L]h0CW;N0P00000604ibgP8000000`1>L]`=0=@m6@<000004`3om^h0
0`0mFJ/0ooK^0?ofkP0@0?ofkP0303eIZ`3om^h0ooK^00T0ooK^0P0mFJ/30?ofkP0303eIZ`3om^h0
ooK^00d0ooK^00<0?EV[0?ofkP3om^h0103om^h203eIZ`H0ooK^00<0?EV[0?ofkP3om^h0?`3om^h2
00000140ooK^00<000000?ofkP3om^h02`3om^h10?ooo`003@3om^h00`000000ooK^0?ofkP0>0?of
kP030000003om^h0ooK^0480ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP060?of
kP030=@m6@3om^h0ooK^00h0ooK^0`3D?AT>0?ofkP030=@m6@3om^h0ooK^00d0ooK^0P3D?AT00`3o
m^h0e3dI0?ofkP0C0?ofkP030=@m6@00000000000080?EV[1P3G?Q/200000080?EV[0P0000020>A2
708000001P3T@Q`200000080i48L0P0mFJ/200000080i48L0P000000103T@Q`000000000003_AQh2
000000030>m67P00000000000080?EV[00H000000>m67P3_AQh000000>m67P00000203eIZ`<0kdHN
0`0000000`1=L]h0000004ebgP020=@m6@80CG;N00@0000004ebgP000000CG;N0P3D?AT200000004
04ebgP000000000004ebgP80000000<0CW;N0000000000000P1>L]h200000080e3dI0P1>L]h20000
00H0CW;N0P00000204ibgP8000000P3D?AT2000000H0CW;L0P3D?AT20000000303eIZ`3om^h0ooK^
0180ooK^00@0?EV[0?ofkP0mFJ/0?EV[3`3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP<0?EV[403om^h0
0`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h0@P3om^h0
0`000000ooK^0?ofkP0>0?ofkP030000003om^h0ooK^00/0ooK^0@3oool000d0ooK^00<000000?of
kP3om^h0303om^h2000004D0ooK^00<0e3dI0?ofkP3om^h00P3D?AT:0?ofkP030=@m6@3om^h0ooK^
00d0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP80e3dI0`3om^h00`3D
?AT0ooK^0?ofkP0C0?ofkP050=@m6@00000000000000000mFJ/01`3G?Q/200000080?EV[103T@Q`3
000000D0i48L0P0000020>A27080?EV[00@000000>A2703T@Q`0i48L0P0000040>m67P040000000m
FJ/0?EV[00000080kdHN00P000000>m67P3_AQh000000>m67P000000kdHN03eIZ`80kdHN0`000000
1`1=L]h000000=@m6@1=L]h0000004ebgP0000000P1=L]h010000000CG;N04ebgP0000020=@m6@03
0000001=L]h0CG;N0080CG;N0P00000204ibgP8000000P3D?AT204ibgP8000001@1>L]h3000000@0
CW;N0P3D?AT2000000L0CW;L00D0e3dI000000000000000003eIZ`0E0?ofkP0403eIZ`3om^h0ooK^
0?ofkP80?EV[303om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[
0?ofkP3om^h0203om^h203eIZ`80ooK^00<0?EV[0?ofkP3om^h0@`3om^h2000000h0ooK^00<00000
0?ofkP3om^h02`3om^h10?ooo`003@3om^h00`000000ooK^0?ofkP0;0?ofkP030000003om^h0ooK^
04D0ooK^0`3D?AT<0?ofkP030=@m6@3om^h0ooK^00/0ooK^0`3D?ATA0?ofkP030=@m6@3om^h0ooK^
00P0ooK^0P3D?AT60?ofkP030=@m6@3om^h0ooK^0180ooK^00@0e3dI0?ofkP3D?AT0e3dI10000003
0=Ln6`8000000P3T@Q`00`000000?EV[03eIZ`050>A2708000001@3T@Q`200000080i48L0P0mFJ/2
00000080kdHN0P000000103_AQh0?EV[03eIZ`0000020>m67P090000003_AQh0kdHN0000003_AQh0
00000>m67P000000kdHN00T000000`1=L]h00`000000CG;N0000000204ebgP040000001=L]h0CG;N
00000080e3dI00<0CG;N0000000000000P1=L]h200000080e3dI0P1>L]h2000000D0CW;N0P000005
04ibgP80e3dI00<0000004ibgP1>L]h00P00000304ibg0@000000P0mFJ/00`3om^h0?EV[0?ofkP0C
0?ofkP0303eIZ`3om^h0ooK^00@0ooK^0P0mFJ/:0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00@0?EV[
0?ofkP0mFJ/0?EV[3@3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP<0?EV[A`3om^h00`000000ooK^0?of
kP0;0?ofkP030000003om^h0ooK^00/0ooK^0@3oool000`0ooK^00<000000?ofkP3om^h02`3om^h0
0`000000ooK^0?ofkP160?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h02P3om^h0
1@3D?AT0ooK^0?ofkP3om^h0e3dI0140ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?of
kP070?ofkP030=@m6@3om^h0ooK^0180ooK^00@0e3dI0?ofkP3om^h0ooK^1`0000060>A27080?EV[
00<000000>A2703T@Q`00P3T@Q`3000000@0i48L0`0000000`3_AQh0?EV[03eIZ`02000000040>m6
7P0mFJ/0?EV[00000080kdHN0P000000203_AQh000000000003_AQh000000>m67P000000kdHN0`00
00001@3jBQl00000000000000000Bg3L00<0000000D0CG;N0000001=L]h0000004ebgP0200000003
04ebgP00000000000080CG;N00@000000=@m6@3D?AT0CG;N0P0000020=@m6@0404ebgP0000000000
000000@0CW;N0`00000404ibgP030000003D?AT0e3dI00H0CW;N1`0000030?ofkP0303eIZ`3om^h0
ooK^0180ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0
ooK^00l0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0<0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0
?EV[0?ofkP3om^h0AP3om^h00`000000ooK^0?ofkP0;0?ofkP030000003om^h0ooK^00X0ooK^0@3o
ool000`0ooK^00<000000?ofkP3om^h02@3om^h2000004T0ooK^00<0e3dI0?ofkP3om^h0303om^h0
0`3D?AT0ooK^0?ofkP080?ofkP80e3dI103om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0
ooK^00@0ooK^0P3D?AT:0?ofkP030=@m6@3om^h0ooK^0100ooK^0P3D?AT00`3om^h0e3dI0?ofkP03
0?ofkPT00000103T@Q`203eIZ`800000103T@Q`200000080i48L00<000000>m67P3_AQh00`000003
03eIZ`030000003_AQh0kdHN008000000P3_AQh01@000000kdHN0>m67P000000kdHN00<0000000<0
nTXO0000000000001`0000001P1;L=`00000000000000000CG;N00000080CG;N00<0000004ebgP1=
L]h00P00000204ebgP040000003D?AT0e3dI0=@m6@<000000P1=L]h00`000000CW;N04ibgP020000
00@0CW;N0P0000020=@m6@@0CW;N2@0000040?ofkP0403eIZ`3om^h0?EV[03eIZa80ooK^00<0?EV[
0?ofkP3om^h0203om^h203eIZ`H0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP03
0?ofkP80?EV[2P3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^04L0ooK^0P00000;
0?ofkP030000003om^h0ooK^00X0ooK^0@3oool000`0ooK^00<000000?ofkP3om^h0203om^h00`00
0000ooK^0?ofkP1:0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D
?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00l0ooK^00@0e3dI0?ofkP3om^h0ooK^0P3D?AT=
0?ofkP030=@m6@3om^h0ooK^00d0ooK^0P3D?AT40?ofkP030=@m6@3om^h0ooK^00<0ooK^1P000000
0`0gEk0000000000000200000080i48L0P0mFJ/3000000<0i48L10000000103_AQh0?EV[03eIZ`0m
FJ/200000080?EV[0`0000001@3_AQh000000000003_AQh000000080kdHN00@000000?Y:7`000000
nTXO2`0000001@1;L=`0000004]`g0000000CG;N0080000000@0CG;N000000000000CG;N0`000002
0=@m6@8000000`3D?AT00`1=L]h0000000000002000000<0CW;N0`0000020=@m6@80CW;N10000000
0`3oCR40000000000004000000D0ooK^00<0?EV[0?ofkP3om^h00P3om^h203eIZ`l0ooK^00<0?EV[
0?ofkP3om^h02`3om^h203eIZ`<0ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP05
0?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP1:
0?ofkP030000003om^h0ooK^00P0ooK^00<000000?ofkP3om^h02P3om^h10?ooo`00303om^h00`00
0000ooK^0?ofkP060?ofkP800000C@3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^
00@0ooK^0P3D?AT80?ofkP030=@m6@3om^h0ooK^00l0ooK^00@0e3dI0?ofkP3D?AT0e3dI403om^h0
0`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h00`3om^h9
0000000303MG/00000000000008000000P0mFJ/00`3T@Q`0000000000002000000040>m67P0mFJ/0
?EV[03eIZ`@0000000@0kdHN000000000000?EV[0P3_AQh2000000030>m67P000000000000800000
00D0nTXO00000000000000000?Y:7`050000000504]`g000000000000000001;L=`00`0000000`1;
L=`00000000000020000000304ebgP00000000000080CG;N00@0e3dI000000000000CG;N10000003
0=@m6@0304ebgP00000000000080000000<0CW;N0=@m6@3D?AT0100000000`3oCR40000000000007
000000D0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0
ooK^00h0ooK^0P0mFJ/00`3om^h0?EV[0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00L0ooK^0P0mFJ/6
0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h0B`3om^h2000000P0ooK^00<00000
0?ofkP3om^h02P3om^h10?ooo`00303om^h00`000000ooK^0?ofkP050?ofkP030000003om^h0ooK^
04d0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP020?ofkP80e3dI2`3om^h00`3D
?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^0140ooK^00<0e3dI0?ofkP3om^h0203om^h20=@m
6@T0ooK^00<0e3dI0?ofkP3om^h0103om^h20000000302M1R0000000000000D000000P0gEk050000
0080kdHN1@0000030>m67P@000000P0mFJ/00`000000kdHN00000002000000050?Y:7`0000000000
0000003jBQl00P0000000`3jBQl00000000000050000000404]`g0000000000004]`g0<0000000H0
Bg3L000000000000000004ebgP0000020=@m6@@000000`1=L]h500000080CG;N1@0000020?m>8@L0
000000<0jDPM0000000000001P3om^h00`0mFJ/0ooK^0?ofkP070?ofkP80?EV[2P3om^h00`0mFJ/0
ooK^0?ofkP0A0?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h02@3om^h203eIZ`@0
ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP1=0?ofkP030000003om^h0ooK^00D0
ooK^00<000000?ofkP3om^h02P3om^h10?ooo`002`3om^h00`000000ooK^0?ofkP040?ofkP800000
D@3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT03@3om^h00`3D?AT0
ooK^0?ofkP0=0?ofkP80e3dI00<0ooK^0=@m6@3om^h04@3om^h00`3D?AT0ooK^0?ofkP060?ofkP80
e3dI303om^h00`3D?AT0ooK^0?ofkP040?ofkP040=@m6@000000000002M1R0P0000000@0e3dI03MG
/0000000?EV[1P0000000`3_AQh0000000000003000000<0kdHN00<0000003eIZ`0000007P000000
0`3D?AT0000004ebgP0204ebgPD0000000<0CG;N00000000000010000000103D?AT000000?m>8@0m
FJ/8000000040>U87@000000000003eIZ`H0ooK^00<0?EV[0?ofkP3om^h02P3om^h203eIZ`P0ooK^
00<0?EV[0?ofkP3om^h0403om^h0100mFJ/0ooK^03eIZ`0mFJ/>0?ofkP0303eIZ`3om^h0ooK^00`0
ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0=0?ofkP0303eIZ`3om^h0ooK^04l0ooK^0P0000060?of
kP030000003om^h0ooK^00T0ooK^0@3oool000/0ooK^00<000000?ofkP3om^h00`3om^h00`000000
ooK^0?ofkP1A0?ofkP030=@m6@3om^h0ooK^00`0ooK^0`3D?AT?0?ofkP030=@m6@3om^h0ooK^00X0
ooK^0P3D?AT30?ofkP030=@m6@3om^h0ooK^0140ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0
ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h01`0000020=@m6@L0
00000`11ILT500000080kdHN9`00000204ebgPD000000`3oCb4700000080?EV[1`0000020?ofkP03
03eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP040?ofkP03
03eIZ`3om^h0ooK^0140ooK^00@0?EV[0?ofkP3om^h0ooK^0P0mFJ/<0?ofkP0303eIZ`3om^h0ooK^
00d0ooK^0`0mFJ/>0?ofkP0303eIZ`3om^h0ooK^0540ooK^00<000000?ofkP3om^h00`3om^h00`00
0000ooK^0?ofkP090?ofkP40oooo000;0?ofkP030000003om^h0ooK^0080ooK^00<000000?ofkP3o
m^h0DP3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3o
m^h0203om^h20=@m6@H0ooK^00<0e3dI0?ofkP3om^h04@3om^h0103D?AT0ooK^0?ofkP3om^h20=@m
6A00ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP020?ofkP<000000P3D?AT00`00
0000=eN`0000000>00000003045Ub@000000000002L0000000<0odlQ0000000000003@000000103o
CR40000003eIZ`0mFJ/3000000@0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP0>
0?ofkP80?EV[0`3om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP0303eIZ`3om^h0ooK^00@0ooK^0P0mFJ/9
0?ofkP0303eIZ`3om^h0ooK^0100ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP1C
0?ofkP030000003om^h0ooK^0080ooK^00<000000?ofkP3om^h02@3om^h10?ooo`002`3om^h00`00
0000ooK^0?ofkP02000005H0ooK^00<0e3dI0?ofkP3om^h02@3om^h20=@m6@030?ofkP3D?AT0ooK^
0100ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^
0100ooK^00@0e3dI0?ofkP3D?AT0e3dI4`3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0
ooK^00<0ooK^0P3D?AT20000000302M1R00000000000008000000`0gEk03000000030=@m6@000000
000003<0000000@0?EV[00000000000000000`3oCR44000000030>U87@00000000000080?EV[1@3o
m^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^0140ooK^0P0mFJ/00`3om^h0?EV[0?of
kP0A0?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?of
kP0?0?ofkP0403eIZ`3om^h0?EV[03eIZ`/0ooK^00<0?EV[0?ofkP3om^h0E03om^h200000080ooK^
00<000000?ofkP3om^h02@3om^h10?ooo`002P3om^h010000000ooK^0?ofkP00001H0?ofkP030=@m
6@3om^h0ooK^00L0ooK^0P3D?AT30?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h0
103om^h20=@m6@X0ooK^00<0e3dI0?ofkP3om^h04@3om^h00`3D?AT0ooK^0?ofkP0D0?ofkP050=@m
6@3om^h0ooK^0?ofkP3D?AT00`3om^h20=@m6@<0ooK^2`00000203MG/0030=@m6@11ILT0@FG900<0
@FG9100000000`3D?AT000000000000M0000000303eIZ`0000000000008000001@3oCb400`0mFJ/0
odhQ0?m>8@0;000000<0ooK^0P0mFJ/30?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/05P3om^h00`0m
FJ/0ooK^0?ofkP0A0?ofkP0303eIZ`3om^h0ooK^00P0ooK^0P0mFJ/50?ofkP0303eIZ`3om^h0ooK^
0100ooK^00@0?EV[0?ofkP3om^h0ooK^0P0mFJ/90?ofkP0303eIZ`3om^h0ooK^05H0ooK^00@00000
0?ofkP3om^h000002P3om^h10?ooo`002P3om^h3000005X0ooK^00<0e3dI0?ofkP3om^h01@3om^h0
0`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00l0ooK^00@0e3dI0?ofkP3om^h0ooK^0P3D
?AT=0?ofkP030=@m6@3om^h0ooK^00h0ooK^0P3D?AT00`3om^h0e3dI0?ofkP0E0?ofkP050=@m6@3o
m^h0ooK^0=@m6@3om^h00P3D?AT40?ofkP80e3dI00@0ooK^0000000000009d682@0000020=@m6@D0
00000P3D?ATQ00000080?EV[1@00000203eIZ`T0000000@0jDPM000000000000ooK^0P0mFJ/40?of
kP80?EV[00D0ooK^03eIZ`3om^h0ooK^03eIZ`0F0?ofkP0403eIZ`3om^h0?EV[03eIZa00ooK^00<0
?EV[0?ofkP3om^h02`3om^h203eIZ`<0ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?of
kP040?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h0F03om^h3000000X0ooK^0@3o
ool000X0ooK^0P00001K0?ofkP030=@m6@3om^h0ooK^00<0ooK^0P3D?AT70?ofkP030=@m6@3om^h0
ooK^00l0ooK^00@0e3dI0?ofkP3D?AT0e3dI403om^h00`3D?AT0ooK^0?ofkP0;0?ofkP80e3dI103o
m^h00`3D?AT0ooK^0?ofkP0D0?ofkP040=@m6@3om^h0e3dI0=@m6@@0ooK^0P3D?AT50?ofkPD00000
0`0gEk04000000030=@m6@00000000000080e3dI0P000006045Ub@80000000<0AfcF000000000000
3@0000000`3oCB400000000000060?m?8@8000000P0mFJ/20000000303eIZ`000000000000800000
0`3oCR45000000D0ooK^0P0mFJ/40?ofkP80?EV[00<0ooK^03eIZ`3om^h05@3om^h00`0mFJ/0ooK^
0?ofkP020?ofkP80?EV[3@3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP<0?EV[4P3om^h00`0mFJ/0ooK^
0?ofkP050?ofkP80?EV[1@3om^h00`0mFJ/0ooK^0?ofkP1I0?ofkP8000002P3om^h10?ooo`00303o
m^h2000005T0ooK^00@0e3dI0?ofkP3om^h0ooK^0P3D?AT:0?ofkP030=@m6@3om^h0ooK^00l0ooK^
00<0e3dI0?ofkP3om^h04@3om^h00`3D?AT0ooK^0?ofkP080?ofkP80e3dI1`3om^h00`3D?AT0ooK^
0?ofkP0D0?ofkP030=@m6@3om^h0e3dI0080ooK^0P3D?AT80?ofkP030=@m6@000000000000T00000
0P3D?AT6000000D0@FG90`0000000`17K=H0000004M/eP04000000060?m=8@00000000000?m=8@00
0000oddQ0`0000050?m?8@H000000P0mFJ/;0000000303eIZ`3om^h0ooK^00H0ooK^0P0mFJ/20?of
kP0303eIZ`3om^h0?EV[01H0ooK^00<0?EV[0?ofkP3om^h01@3om^h203eIZ`X0ooK^00<0?EV[0?of
kP3om^h04@3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00P0ooK^0P0mFJ/30?of
kP0303eIZ`3om^h0ooK^05L0ooK^0P00000<0?ofkP40oooo000>0?ofkP800000F03om^h30=@m6@d0
ooK^00<0e3dI0?ofkP3om^h0303om^h20=@m6@030?ofkP3D?AT0ooK^0140ooK^00<0e3dI0?ofkP3o
m^h01`3om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^0140ooK^0P3D?AT00`3om^h0
e3dI0=@m6@020=@m6@X0ooK^00<0e3dI0?ofkP0000001@00000203MG/080e3dI00<0=eN`0=@m6@3D
?AT00P000003045Ub@D000000P11ILT20000000304M/eP000000000000L0000000<0oddQ00000000
00000P3oCb45000000<0odlQ0P00000203eIZ`030?m>8@0mFJ/0?EV[0080odhQ1P0000000`0mFJ/0
ooK^0?ofkP090?ofkP@0?EV[00<0ooK^03eIZ`0mFJ/04`3om^h00`0mFJ/0ooK^0?ofkP080?ofkP03
03eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h0403om^h0100mFJ/0ooK^03eIZ`0mFJ/>0?of
kP0303eIZ`3om^h0ooK^00/0ooK^0`0mFJ]H0?ofkP8000003P3om^h10?ooo`00403om^h3000005D0
ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP80e3dI0`3om^h00`3D?AT0
ooK^0?ofkP0A0?ofkP030=@m6@3om^h0ooK^00@0ooK^0P3D?AT<0?ofkP030=@m6@3om^h0ooK^00h0
ooK^0P3D?AT40?ofkP80e3dI303om^h00`3D?AT0ooK^0?ofkP030000000302M1R03D?AT0e3dI00D0
00000P3D?AT300000003045Ub@000000000000<0@FG90P0000001@11ILT00000000000000000AfcF
00<0000000D0oddQ00000000000000000?m?8@02000000<0odlQ0P000000103oCb40000000000000
000203eIZ`D000000P0mFJ/0103YB1d000000000000000020?ofkP0303eIZ`3om^h0ooK^00X0ooK^
0P0mFJ/40?ofkP80?EV[403om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP80?EV[1P3om^h00`0mFJ/0ooK^
0?ofkP0A0?ofkP0403eIZ`3om^h0ooK^0?ofkP80?EV[303om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP03
03eIZ`3om^h0ooK^05<0ooK^0`00000@0?ofkP40oooo000C0?ofkP800000D`3om^h00`3D?AT0ooK^
0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^
0?ofkP0A0?ofkP040=@m6@3om^h0ooK^0?ofkP80e3dI3`3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP80
e3dI1P3om^h0103D?AT0ooK^0=@m6@3D?AT:0?ofkP030=@m6@3om^h0ooK^0080ooK^0P3D?AT40000
00D0=eN`0P3D?AT2000000<0@FG90P000002045Ub@80000000<0e3dI00000017K=H00`0000000`3o
CB40000003eIZ`0200000080odlQ0P0000030?m?8@8000000P0mFJ/50?m>8@@000000P0mFJ/40?of
kP0303eIZ`3om^h0ooK^00P0ooK^0P0mFJ/00`3om^h0?EV[0?ofkP050?ofkP80?EV[3@3om^h00`0m
FJ/0ooK^0?ofkP0=0?ofkP80?EV[0`3om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP0303eIZ`3om^h0ooK^
00@0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^
0580ooK^0P00000C0?ofkP40oooo000E0?ofkP800000DP3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP03
0=@m6@3om^h0ooK^00D0ooK^0P3D?AT80?ofkP030=@m6@3om^h0ooK^0100ooK^00@0e3dI0?ofkP3D
?AT0e3dI4P3om^h00`3D?AT0ooK^0?ofkP080?ofkP80e3dI203om^h01@3D?AT0ooK^0?ofkP3om^h0
e3dI00T0ooK^00<0e3dI0?ofkP3om^h0103D?AT00`000000?EV[0000000600000080=eN`0P3D?AT3
00000080@FG90P0000020=@m6@03045Ub@000000000000D0000000<0odlQ03eIZ`0mFJ/00P000002
0?m?8@<000000P0mFJ/20?m>8@L0000000<0e3dI0000000mFJ/00`0mFJ/20?ofkP0303eIZ`3om^h0
ooK^00L0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`080?ofkP80?EV[2P3om^h00`0mFJ/0ooK^0?of
kP0@0?ofkP80?EV[00<0ooK^03eIZ`3om^h04@3om^h00`0mFJ/0ooK^0?ofkP060?ofkP80?EV[1`3o
m^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^0500ooK^0P00000E0?ofkP40oooo000G
0?ofkP<00000C`3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI
0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP0A0?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI
0?ofkP3om^h01@3om^h20=@m6@X0ooK^00<0e3dI0?ofkP3om^h00P3om^h20=@m6@L0ooK^1@3D?AT4
0?ofkP<0000000<09d680000000000000P0gEk0300000080e3dI00<00000045Ub@0000000P3D?AT0
0`000000@FG900000002045Ub@<000000P3oCb400`000000odlQ0000000203eIZ`030000003oCb40
00000080?EV[0`0000020?m>8@H00000103om^h503eIZ`L0ooK^0P0mFJ/40?ofkP0303eIZ`3om^h0
ooK^00P0ooK^0P0mFJ/70?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h04@3om^h0
0`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h03@3om^h0
0`0mFJ/0ooK^0?ofkP1>0?ofkP<000005`3om^h10?ooo`006P3om^h2000004h0ooK^00<0e3dI0?of
kP3om^h03P3om^h0103D?AT0ooK^0?ofkP3om^h20=@m6@`0ooK^00<0e3dI0?ofkP3om^h03P3om^h2
0=@m6@030?ofkP3D?AT0ooK^01@0ooK^00<0e3dI0?ofkP3om^h00P3om^h20=@m6@`0ooK^00<0e3dI
0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP030?ofkP@0e3dI203om^h6000000D0=eN`0`3D?AT2
045Ub@0300000011ILT000000080@FG90`0000020?m?8@030000003oCb4000000080odlQ0`0mFJ/5
0?m>8@H00000203om^h403eIZ`D0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0:
0?ofkP80?EV[103om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0403eIZ`3om^h0?EV[03eIZa00ooK^00<0
?EV[0?ofkP3om^h02P3om^h203eIZ`<0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?of
kP1<0?ofkP8000006P3om^h10?ooo`00703om^h2000004`0ooK^00<0e3dI0?ofkP3om^h03P3om^h0
103D?AT0ooK^0=@m6@3D?AT?0?ofkP030=@m6@3om^h0ooK^00/0ooK^0P3D?AT40?ofkP030=@m6@3o
m^h0ooK^01<0ooK^00@0e3dI0?ofkP3D?AT0e3dI3P3om^h00`3D?AT0ooK^0?ofkP050?ofkP80e3dI
00D0ooK^0=@m6@3D?AT0ooK^0=@m6@0;0?ofkP040=@m6@000000000002M1R08000000`0gEk020=@m
6@80=eN`0`3D?AT020000000@FG9045Ub@000000@FG90000003oCb4000000P3oCb4010000000?EV[
03eIZ`0mFJ/20?m>8@80?EV[0`3oCR42000000040>U87@000000000003eIZ`/0ooK^00D0?EV[0?of
kP0mFJ/0?EV[0?ofkP0203eIZ`L0ooK^00<0?EV[0?ofkP3om^h0303om^h203eIZ`030?ofkP0mFJ/0
ooK^01@0ooK^00<0?EV[0?ofkP3om^h00P3om^h203eIZ`d0ooK^00<0?EV[0?ofkP3om^h03@3om^h2
03eIZ`030?ofkP0mFJ/0ooK^00h0ooK^00<0?EV[0?ofkP3om^h0B`3om^h2000001`0ooK^0@3oool0
01h0ooK^0`00001:0?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h0403om^h00`3D
?AT0ooK^0?ofkP080?ofkP80e3dI1`3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^
00h0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0=@m6@020=@m6@/0ooK^00<0e3dI0?of
kP3om^h0100000020=@m6@<0=eN`0P0000000`0gEk0000000=@m6@020=@m6@0500000011ILT00000
0?m?8@0000000`0mFJ/010000000odhQ0000000000030?m>8@80?EV[100000020?ofkP0303eIZ`3o
m^h0ooK^00T0ooK^0`0mFJ/00`3om^h0?EV[0?ofkP070?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0
?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP050?ofkP80?EV[2P3om^h00`0mFJ/0ooK^0?of
kP0@0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h0B03om^h3000001h0ooK^0@3o
ool00240ooK^0P0000180?ofkP030=@m6@3om^h0ooK^00`0ooK^0P3D?AT00`3om^h0e3dI0?ofkP0@
0?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP0@
0?ofkP80e3dI00<0ooK^0=@m6@3om^h03`3om^h00`3D?AT0ooK^0?ofkP040?ofkPD0e3dI00<0ooK^
0=@m6@3om^h02P3om^h01@3D?AT0ooK^0?ofkP3D?AT000000080e3dI0P0W@HP30000000403eIZ`0g
Ek00=eN`00000080=eN`0P0000000`11ILT000000?m?8@0200000080odhQ00@000000?m>8@3oCR40
e3dI0`0000020>U87@80?EV[00<0000003eIZ`3om^h00P3om^h00`0mFJ/0ooK^0?ofkP080?ofkP03
03eIZ`3om^h0?EV[00@0?EV[1P3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0403eIZ`3om^h0?EV[03eI
Za80ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^
00l0ooK^00@0?EV[0?ofkP0mFJ/0?EV[3@3om^h00`0mFJ/0ooK^0?ofkP170?ofkP8000008@3om^h1
0?ooo`008`3om^h2000004L0ooK^00<0e3dI0?ofkP3om^h02@3om^h20=@m6@<0ooK^00<0e3dI0?of
kP3om^h0403om^h00`3D?AT0ooK^0?ofkP040?ofkP80e3dI303om^h00`3D?AT0ooK^0?ofkP0=0?of
kP80e3dI103om^h20=@m6@h0ooK^00<0e3dI0?ofkP3om^h00P3om^h40=@m6@<0ooK^0P3D?AT;0?of
kPD0e3dI00@0ooK^00000000000000000P0W@HP200000080=eN`00D0000003MG/00gEk00000003MG
/004000000<0odhQ00<000000?m>8@3oCR400P0000020>U87@<0000000<0ooK^03eIZ`0mFJ/00P0m
FJ/00`3om^h0?EV[0?ofkP090?ofkP80?EV[0`3om^h403eIZ`@0ooK^00<0?EV[0?ofkP3om^h0303o
m^h203eIZ`@0ooK^0P0mFJ/?0?ofkP0303eIZ`3om^h0ooK^00X0ooK^0P0mFJ/60?ofkP0303eIZ`3o
m^h0ooK^0100ooK^00@0?EV[0?ofkP3om^h0ooK^0P0mFJ/;0?ofkP0303eIZ`3om^h0ooK^04D0ooK^
0P00000S0?ofkP40oooo000U0?ofkP<00000A03om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3o
m^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h0403om^h0103D?AT0ooK^0?ofkP3om^h20=@m6@l0ooK^
00<0e3dI0?ofkP3om^h02P3om^h20=@m6@P0ooK^00<0e3dI0?ofkP3om^h02`3om^h0103D?AT0ooK^
0?ofkP3om^h30=@m6@D0ooK^00@0e3dI0?ofkP3D?AT0e3dI2@3om^h30=@m6@H0ooK^0P00000202M1
R08000000`0gEk0010000000e3dI0=@m6@00000203eIZ`040000003oCR40odhQ0?m>8@8000000P3Y
B1d2000000H0ooK^100mFJ/80?ofkP80?EV[00<0ooK^03eIZ`3om^h0103om^h303eIZ`<0ooK^00<0
?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP060?ofkP80?EV[303om^h00`0mFJ/0ooK^0?of
kP0=0?ofkP80?EV[0`3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0
?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP130?ofkP<000009@3om^h10?ooo`00:03om^h2
000004<0ooK^00<0e3dI0?ofkP3om^h01@3om^h20=@m6@P0ooK^00<0e3dI0?ofkP3om^h03`3om^h0
103D?AT0ooK^0=@m6@3D?ATB0?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h02@3o
m^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0e3dI0080e3dI1`3om^h0103D?AT0ooK^0?of
kP3om^h20=@m6@D0ooK^0`3D?AT:0?ofkP<0000000<09d680000000000000P3D?AT203MG/0030000
003oCR40odhQ0080?EV[0P000000103YB1d0000000000000000:0?ofkP@0?EV[103om^h203eIZ`<0
ooK^00<0?EV[0?ofkP3om^h01@3om^h303eIZ`030?ofkP0mFJ/0ooK^00/0ooK^00<0?EV[0?ofkP3o
m^h02@3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^0100ooK^0P0mFJ/00`3om^h0
?EV[0?ofkP0@0?ofkP0303eIZ`3om^h0ooK^00H0ooK^0P0mFJ/70?ofkP0303eIZ`3om^h0ooK^0440
ooK^0P00000X0?ofkP40oooo000Z0?ofkP800000@@3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m
6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h0403om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m
6@3om^h0ooK^00D0ooK^0P3D?AT=0?ofkP80e3dI2P3om^h30=@m6@T0ooK^00<0e3dI0?ofkP3om^h0
0`3om^h20=@m6@030?ofkP3D?AT0e3dI0080e3dI2P3om^h30=@m6@050000000mFJ/0e3dI0=@m6@00
00000`0gEk001@000000odhQ0?m>8@3oCR4000000080?EV[00<0e3dI0000000mFJ/00P0mFJ/;0?of
kPH0?EV[1@3om^h00`0mFJ/0ooK^0?ofkP070?ofkP<0?EV[2P3om^h203eIZ`d0ooK^0P0mFJ/70?of
kP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h0403om^h00`0mFJ/0ooK^0?ofkP080?of
kP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h0@03om^h2000002X0ooK^0@3oool002`0
ooK^0`00000o0?ofkP040=@m6@3om^h0ooK^0?ofkP80e3dI303om^h00`3D?AT0ooK^0?ofkP0=0?of
kP80e3dI00<0ooK^0=@m6@3om^h0503om^h00`3D?AT0ooK^0?ofkP020?ofkP80e3dI4@3om^h00`3D
?AT0ooK^0?ofkP060?ofkP80e3dI2`3om^h00`3D?AT0ooK^0?ofkP040?ofkP@0e3dI00<0ooK^0=@m
6@3om^h02@3om^h00`3D?AT0ooK^0?ofkP020=@m6@D0000000<0=eN`0000003oCR401@00000203eI
Z`80ooK^00<0?EV[0?ofkP3om^h02@3om^h603eIZ`D0ooK^00<0?EV[0?ofkP3om^h02@3om^h203eI
Z`P0ooK^00<0?EV[0?ofkP3om^h03`3om^h203eIZ`@0ooK^00<0?EV[0?ofkP3om^h04`3om^h0100m
FJ/0ooK^03eIZ`0mFJ/?0?ofkP0303eIZ`3om^h0ooK^00X0ooK^0P0mFJ/30?ofkP0303eIZ`3om^h0
ooK^03d0ooK^0`00000/0?ofkP40oooo000_0?ofkP800000?@3om^h0103D?AT0ooK^0=@m6@3D?AT?
0?ofkP030=@m6@3om^h0ooK^00X0ooK^0P3D?AT40?ofkP030=@m6@3om^h0ooK^01<0ooK^00@0e3dI
0?ofkP3D?AT0e3dI503om^h00`3D?AT0ooK^0?ofkP030?ofkP80e3dI00<0ooK^0=@m6@3om^h02P3o
m^h00`3D?AT0ooK^0?ofkP020?ofkP@0e3dI0P3om^h40=@m6@H0ooK^0P3D?AT00`3om^h0e3dI0=@m
6@040?ofkP030000000W@HP09d6800<000000P3YB1d00`000000ooK^0?ofkP020?ofkP80?EV[00<0
ooK^03eIZ`0mFJ/01P3om^h403eIZ`80ooK^0P0mFJ/00`3om^h0?EV[03eIZ`030?ofkP0303eIZ`3o
m^h0ooK^00T0ooK^00@0?EV[0?ofkP0mFJ/0?EV[1@3om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP80?EV[
00<0ooK^03eIZ`3om^h0503om^h00`0mFJ/0ooK^0?ofkP020?ofkP80?EV[303om^h00`0mFJ/0ooK^
0?ofkP0=0?ofkP<0?EV[?P3om^h2000002l0ooK^0@3oool00340ooK^0`00000k0?ofkP030=@m6@3o
m^h0ooK^0100ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3o
m^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h05@3om^h20=@m6@030?ofkP3D?AT0e3dI00<0ooK^00<0
e3dI0?ofkP3om^h0203om^h0103D?AT0ooK^0?ofkP3om^h40=@m6@@0ooK^00@0e3dI0?ofkP3om^h0
ooK^2@3D?AT50?ofkPD0e3dI00<0000003eIZ`0mFJ/00`0mFJ/50?ofkP80?EV[00<0ooK^03eIZ`0m
FJ/0100mFJ/30?ofkP0303eIZ`3om^h0ooK^0080ooK^0P0mFJ/00`3om^h0?EV[03eIZ`020?ofkP03
03eIZ`3om^h0ooK^00P0ooK^00@0?EV[0?ofkP3om^h0ooK^0P0mFJ/00`3om^h0?EV[03eIZ`0G0?of
kP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP080?of
kP0303eIZ`3om^h0ooK^0100ooK^00<0?EV[0?ofkP3om^h0>@3om^h300000340ooK^0@3oool003@0
ooK^0P00000j0?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h01P3om^h20=@m6@T0
ooK^00<0e3dI0?ofkP3om^h0403om^h20=@m6@030?ofkP3D?AT0e3dI01H0ooK^0`3D?AT40?ofkP03
0=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3D?AT00`3D?AT60?ofkP030=@m6@3om^h0ooK^00<0
ooK^403D?AT300000100?EV[1P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP80?EV[00@0ooK^03eIZ`0m
FJ/0?EV[2P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP<0?EV[5P3om^h203eIZ`030?ofkP0mFJ/0?EV[
0180ooK^00<0?EV[0?ofkP3om^h01`3om^h203eIZ`P0ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0m
FJ/0ooK^0?ofkP0h0?ofkP800000=03om^h10?ooo`00=P3om^h2000003P0ooK^00<0e3dI0?ofkP3o
m^h0403om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3o
m^h03@3om^h20=@m6@D0ooK^00<0e3dI0?ofkP3om^h04@3om^h20=@m6@<0ooK^0P3D?AT20?ofkP03
0=@m6@3om^h0ooK^00P0ooK^103D?AT70?ofkP030=@m6@3om^h0ooK^0080ooK^0P3D?AT0103om^h0
e3dI0=@m6@3D?AT40?ofkPL0e3dI0P3om^h00`000000ooK^0?ofkP0703eIZ`@0ooK^0`0mFJ/00`3o
m^h0?EV[03eIZ`040?ofkP0303eIZ`3om^h0ooK^00D0ooK^0P0mFJ/00`3om^h0?EV[0?ofkP090?of
kP0303eIZ`3om^h0ooK^0080?EV[0`3om^h203eIZa<0ooK^00<0?EV[0?ofkP3om^h00`3om^h203eI
Z`l0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^
00l0ooK^00<0?EV[0?ofkP3om^h0=`3om^h2000003H0ooK^0@3oool003P0ooK^0`00000f0?ofkP03
0=@m6@3om^h0ooK^0100ooK^00@0e3dI0?ofkP3om^h0ooK^0P3D?AT>0?ofkP030=@m6@3om^h0ooK^
00X0ooK^0P3D?AT80?ofkP030=@m6@3om^h0ooK^00h0ooK^0P3D?AT70?ofkP<0e3dI203om^h40=@m
6@T0ooK^00<0e3dI0?ofkP3om^h00P3D?AT01@3om^h0e3dI0=@m6@3om^h0e3dI00<0ooK^0P3D?AT0
0`3om^h0e3dI0=@m6@020=@m6@@0ooK^00<000000?ofkP3om^h00P3om^h403eIZ`030?ofkP0mFJ/0
?EV[00<0ooK^00D0?EV[0?ofkP0mFJ/0?EV[0?ofkP0203eIZ`80ooK^00<0?EV[0?ofkP3om^h01`3o
m^h403eIZ`P0ooK^0`0mFJ/70?ofkP80?EV[403om^h00`0mFJ/0ooK^0?ofkP060?ofkP80?EV[303o
m^h00`0mFJ/0ooK^0?ofkP0<0?ofkP80?EV[0`3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0303eIZ`3o
m^h0ooK^03@0ooK^0`00000h0?ofkP40oooo000k0?ofkP800000=@3om^h00`3D?AT0ooK^0?ofkP0?
0?ofkP040=@m6@3om^h0e3dI0=@m6A40ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?of
kP090?ofkP80e3dI303om^h20=@m6@X0ooK^103D?AT40?ofkP@0e3dI2P3om^h01@3D?AT0ooK^0=@m
6@3D?AT0ooK^0080e3dI0P3om^h00`3D?AT0ooK^0?ofkP020=@m6@030?ofkP3D?AT0e3dI0080e3dI
1P3om^h00`000000ooK^0?ofkP040?ofkP@0?EV[00D0ooK^03eIZ`0mFJ/0ooK^03eIZ`030?ofkP80
?EV[00D0ooK^03eIZ`0mFJ/0ooK^03eIZ`0:0?ofkP@0?EV[103om^h403eIZ`X0ooK^0P0mFJ/<0?of
kP80?EV[2`3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00l0ooK^0P0mFJ/00`3o
m^h0?EV[0?ofkP0@0?ofkP0303eIZ`3om^h0ooK^03<0ooK^0P00000k0?ofkP40oooo000m0?ofkP80
0000=03om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^0180ooK^00<0e3dI0?ofkP3o
m^h01@3om^h20=@m6@h0ooK^00<0e3dI0?ofkP3om^h01`3om^h20=@m6@`0ooK^00@0e3dI0?ofkP3o
m^h0ooK^0P3D?AT01P3om^h0e3dI0=@m6@3D?AT0ooK^0=@m6@X0ooK^0P3D?AT00`3om^h0e3dI0=@m
6@040?ofkP<0e3dI00<0ooK^0=@m6@3D?AT00P3D?AT80?ofkP030000003om^h0ooK^00H0ooK^100m
FJ/0103om^h0?EV[03eIZ`0mFJ/40?ofkP80?EV[00<0ooK^03eIZ`0mFJ/02P3om^h00`0mFJ/0ooK^
03eIZ`0203eIZ`030?ofkP0mFJ/0?EV[00<0ooK^00<0?EV[0?ofkP3om^h02P3om^h203eIZ`T0ooK^
00<0?EV[0?ofkP3om^h0303om^h203eIZ`L0ooK^00<0?EV[0?ofkP3om^h04P3om^h00`0mFJ/0ooK^
0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^0380ooK^0P00000m0?ofkP40oooo000o0?ofkP<00000<@3o
m^h00`3D?AT0ooK^0?ofkP0=0?ofkP80e3dI00<0ooK^0=@m6@3om^h04`3om^h00`3D?AT0ooK^0?of
kP020?ofkP80e3dI4@3om^h00`3D?AT0ooK^0?ofkP040?ofkP80e3dI3P3om^h00`3D?AT0ooK^0?of
kP020?ofkP@0e3dI0P3om^h00`3D?AT0ooK^0?ofkP060?ofkP80e3dI00<0ooK^0=@m6@3D?AT01@3o
m^h20=@m6@030?ofkP3D?AT0e3dI0080e3dI2P3om^h00`000000ooK^0?ofkP080?ofkP@0?EV[00<0
ooK^03eIZ`0mFJ/01@3om^h203eIZ`030?ofkP0mFJ/0?EV[00P0ooK^00<0?EV[0?ofkP3om^h0100m
FJ/40?ofkP0303eIZ`3om^h0ooK^00`0ooK^0P0mFJ/60?ofkP0303eIZ`3om^h0ooK^00l0ooK^0P0m
FJ/40?ofkP0303eIZ`3om^h0ooK^0180ooK^00@0?EV[0?ofkP0mFJ/0?EV[3P3om^h00`0mFJ/0ooK^
0?ofkP0`0?ofkP<00000?`3om^h10?ooo`00@P3om^h200000300ooK^00<0e3dI0?ofkP3om^h02P3o
m^h20=@m6@@0ooK^00<0e3dI0?ofkP3om^h04P3om^h0103D?AT0ooK^0=@m6@3D?ATD0?ofkP80e3dI
0P3om^h20=@m6A00ooK^00<0e3dI0?ofkP3om^h0103D?AT20?ofkP@0e3dI1@3om^h20=@m6@030?of
kP3D?AT0e3dI00D0ooK^0P3D?AT00`3om^h0e3dI0=@m6@020=@m6@`0ooK^00<000000?ofkP3om^h0
2P3om^h403eIZ`030?ofkP0mFJ/0?EV[00D0ooK^0P0mFJ/00`3om^h0?EV[03eIZ`050?ofkP@0?EV[
0P3om^h403eIZ`80ooK^00<0?EV[0?ofkP3om^h03P3om^h203eIZ`80ooK^0P0mFJ/D0?ofkP80?EV[
00<0ooK^03eIZ`3om^h04`3om^h00`0mFJ/0ooK^0?ofkP020?ofkP80?EV[303om^h00`0mFJ/0ooK^
0?ofkP0^0?ofkP800000@P3om^h10?ooo`00A03om^h2000002l0ooK^00<0e3dI0?ofkP3om^h01`3o
m^h20=@m6@L0ooK^00<0e3dI0?ofkP3om^h04P3om^h00`3D?AT0ooK^0?ofkP0F0?ofkP80e3dI4P3o
m^h50=@m6@D0ooK^00<0e3dI0?ofkP3om^h01@3D?AT00`3om^h0e3dI0=@m6@050?ofkPL0e3dI3P3o
m^h00`000000ooK^0?ofkP0<0?ofkPL0?EV[1@3om^h203eIZ`030?ofkP0mFJ/0?EV[00<0?EV[0P3o
m^h00`0mFJ/0ooK^0?ofkP030?ofkPD0?EV[4P3om^h203eIZaP0ooK^00<0?EV[0?ofkP3om^h04P3o
m^h00`0mFJ/0ooK^0?ofkP050?ofkP80?EV[2@3om^h00`0mFJ/0ooK^0?ofkP0]0?ofkP800000A03o
m^h10?ooo`00AP3om^h3000002d0ooK^00<0e3dI0?ofkP3om^h0103om^h20=@m6@X0ooK^00<0e3dI
0?ofkP3om^h03`3om^h20=@m6@030?ofkP3D?AT0e3dI01@0ooK^0P3D?AT00`3om^h0e3dI0=@m6@0A
0?ofkP<0e3dI1`3om^h0103D?AT0ooK^0?ofkP3om^h20=@m6@030?ofkP3D?AT0e3dI00`0e3dI403o
m^h00`000000ooK^0?ofkP0>0?ofkPh0?EV[00<0ooK^03eIZ`0mFJ/00`3om^h00`0mFJ/0ooK^0?of
kP050?ofkP<0?EV[4@3om^h203eIZ`030?ofkP0mFJ/0?EV[01@0ooK^0P0mFJ/00`3om^h0?EV[03eI
Z`0A0?ofkP0303eIZ`3om^h0ooK^00P0ooK^0P0mFJ/60?ofkP0303eIZ`3om^h0ooK^02/0ooK^0`00
00160?ofkP40oooo00190?ofkP800000:`3om^h00`3D?AT0ooK^0?ofkP020?ofkP80e3dI3@3om^h0
0`3D?AT0ooK^0?ofkP0<0?ofkP80e3dI1@3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP80e3dI1@3om^h2
0=@m6@h0ooK^0P3D?AT90?ofkP040=@m6@3om^h0e3dI0=@m6@80ooK^0P3D?AT00`3om^h0e3dI0?of
kP020?ofkPH0e3dI4P3om^h00`000000ooK^0?ofkP0@0?ofkPH0?EV[0`3om^h0100mFJ/0ooK^03eI
Z`0mFJ/20?ofkP80?EV[00<0ooK^03eIZ`3om^h0203om^h203eIZ`h0ooK^0P0mFJ/50?ofkP80?EV[
4@3om^h00`0mFJ/0ooK^0?ofkP030?ofkP80?EV[3P3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP80?EV[
0`3om^h00`0mFJ/0ooK^0?ofkP0Z0?ofkP800000B@3om^h10?ooo`00B`3om^h2000002X0ooK^00@0
e3dI0?ofkP3D?AT0e3dI403om^h00`3D?AT0ooK^0?ofkP090?ofkP80e3dI203om^h00`3D?AT0ooK^
0?ofkP0<0?ofkP80e3dI2@3om^h20=@m6@X0ooK^0`3D?AT90?ofkP<0e3dI0P3om^h20=@m6@<0ooK^
00D0e3dI0?ofkP3om^h0e3dI0?ofkP030=@m6A@0ooK^00<000000?ofkP3om^h04P3om^h303eIZ`05
0?ofkP0mFJ/0ooK^0?ofkP0mFJ/00`3om^h203eIZ`80ooK^0`0mFJ/90?ofkP<0?EV[2P3om^h203eI
Z`T0ooK^0P0mFJ/>0?ofkP0303eIZ`3om^h0ooK^00H0ooK^0P0mFJ/;0?ofkP0303eIZ`3om^h0ooK^
00h0ooK^0P0mFJ/00`3om^h0?EV[0?ofkP0Y0?ofkP800000B`3om^h10?ooo`00C@3om^h3000002P0
ooK^00<0e3dI0?ofkP3om^h04@3om^h00`3D?AT0ooK^0?ofkP060?ofkP80e3dI2`3om^h20=@m6@/0
ooK^00<0e3dI0?ofkP3om^h02`3om^h20=@m6@H0ooK^0P3D?AT20?ofkP030=@m6@3om^h0ooK^00L0
ooK^00<0e3dI0?ofkP3om^h00P3D?AT40?ofkP030=@m6@3om^h0e3dI00@0e3dI5P3om^h00`000000
ooK^0?ofkP0D0?ofkPD0?EV[00<0ooK^03eIZ`3om^h00`3om^h203eIZ`80ooK^00<0?EV[0?ofkP3o
m^h01`3om^h00`0mFJ/0ooK^0?ofkP0203eIZ`H0ooK^0P0mFJ/=0?ofkP0303eIZ`3om^h0ooK^00T0
ooK^0P0mFJ/;0?ofkP80?EV[203om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP0303eIZ`3om^h0ooK^02H0
ooK^0`00001=0?ofkP40oooo001@0?ofkP8000009`3om^h00`3D?AT0ooK^0?ofkP0A0?ofkP030=@m
6@3om^h0ooK^00<0ooK^0P3D?AT?0?ofkP030=@m6@3om^h0ooK^00H0ooK^0P3D?AT@0?ofkP80e3dI
0P3om^h20=@m6@<0ooK^00<0e3dI0?ofkP3om^h01P3om^h20=@m6@030?ofkP3D?AT0e3dI00H0ooK^
1@3D?ATH0?ofkP030000003om^h0ooK^01H0ooK^1@0mFJ/60?ofkP80?EV[00<0ooK^03eIZ`0mFJ/0
203om^h0100mFJ/0ooK^0?ofkP3om^h203eIZ`80ooK^0P0mFJ/@0?ofkP80?EV[203om^h00`0mFJ/0
ooK^0?ofkP0=0?ofkP80?EV[1@3om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP0303eIZ`3om^h0ooK^02D0
ooK^0P00001@0?ofkP40oooo001B0?ofkP8000009P3om^h00`3D?AT0ooK^0?ofkP0A0?ofkP030=@m
6@3om^h0ooK^0080e3dI4P3om^h00`3D?AT0ooK^0?ofkP030?ofkP80e3dI503om^h40=@m6@<0ooK^
00<0e3dI0?ofkP3om^h0103om^h50=@m6@H0ooK^1@3D?ATJ0?ofkP030000003om^h0ooK^01P0ooK^
1@0mFJ/60?ofkP80?EV[00<0ooK^03eIZ`0mFJ/01P3om^h0100mFJ/0ooK^0?ofkP3om^h403eIZa@0
ooK^0P0mFJ/50?ofkP0303eIZ`3om^h0ooK^0100ooK^0P0mFJ/20?ofkP0303eIZ`3om^h0ooK^0140
ooK^00<0?EV[0?ofkP3om^h0903om^h200000580ooK^0@3oool005@0ooK^0`00000T0?ofkP030=@m
6@3om^h0ooK^0140ooK^0P3D?ATE0?ofkP80e3dI00<0ooK^0=@m6@3D?AT05@3om^h20=@m6@<0ooK^
1P3D?AT20?ofkP80e3dI00<0ooK^0=@m6@3D?AT01P3om^h50=@m6A`0ooK^00<000000?ofkP3om^h0
6P3om^h503eIZ`H0ooK^0P0mFJ/00`3om^h0?EV[03eIZ`020?ofkPH0?EV[0`3om^h203eIZaD0ooK^
0P0mFJ/00`3om^h0?EV[03eIZ`0E0?ofkP80?EV[4`3om^h00`0mFJ/0ooK^0?ofkP0R0?ofkP<00000
E03om^h10?ooo`00E`3om^h2000002<0ooK^00<0e3dI0?ofkP3om^h03P3om^h20=@m6@030?ofkP3D
?AT0e3dI01H0ooK^0P3D?ATD0?ofkP80e3dI1`3om^h0103D?AT0ooK^0?ofkP3om^h@0=@m6Ah0ooK^
00<000000?ofkP3om^h0703om^h@03eIZ`<0ooK^00<0?EV[0?ofkP3om^h01@3om^h203eIZa@0ooK^
0P0mFJ/F0?ofkP80?EV[00<0ooK^03eIZ`0mFJ/0403om^h00`0mFJ/0ooK^0?ofkP0Q0?ofkP800000
E`3om^h10?ooo`00F@3om^h200000280ooK^00<0e3dI0?ofkP3om^h02`3om^h20=@m6@D0ooK^00<0
e3dI0?ofkP3om^h04@3om^h20=@m6@80ooK^0P3D?AT@0?ofkP80e3dI2@3om^h01@3D?AT0ooK^0=@m
6@3D?AT0ooK^0080e3dI00<0ooK^0=@m6@3om^h00P3om^h70=@m6Al0ooK^00<000000?ofkP3om^h0
7@3om^h703eIZ`<0ooK^00D0?EV[0?ofkP0mFJ/0?EV[0?ofkP0203eIZ`030?ofkP0mFJ/0ooK^00P0
ooK^0P0mFJ/@0?ofkP80?EV[0P3om^h203eIZa<0ooK^00<0?EV[0?ofkP3om^h00`3om^h203eIZ`d0
ooK^00<0?EV[0?ofkP3om^h0803om^h2000005T0ooK^0@3oool005/0ooK^0`00000O0?ofkP030=@m
6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h01P3om^h20=@m6@l0ooK^0P3D?AT60?ofkP80e3dI
303om^h20=@m6@X0ooK^0`3D?AT00`3om^h0e3dI0=@m6@020?ofkP030=@m6@3om^h0ooK^0080e3dI
00<0ooK^0=@m6@3D?AT00P3D?ATQ0?ofkP030000003om^h0ooK^01l0ooK^100mFJ/01@3om^h0?EV[
03eIZ`3om^h0?EV[00<0ooK^0P0mFJ/0103om^h0?EV[03eIZ`0mFJ/:0?ofkP80?EV[303om^h203eI
Z`H0ooK^0P0mFJ/?0?ofkP80?EV[203om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^
01d0ooK^0`00001K0?ofkP40oooo001N0?ofkP8000007P3om^h00`3D?AT0ooK^0?ofkP070?ofkP80
e3dI2`3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP80e3dI2P3om^h30=@m6@L0ooK^0P3D?AT<0?ofkP04
0=@m6@3om^h0e3dI0=@m6@@0ooK^0`3D?AT00`3om^h0e3dI0=@m6@020=@m6B<0ooK^00<000000?of
kP3om^h08@3om^h403eIZ`040?ofkP0mFJ/0?EV[03eIZ`@0ooK^0P0mFJ/00`3om^h0?EV[0?ofkP0;
0?ofkP80?EV[1`3om^h303eIZ`X0ooK^0P0mFJ/<0?ofkP0303eIZ`3om^h0ooK^00T0ooK^0P0mFJ/9
0?ofkP0303eIZ`3om^h0ooK^01`0ooK^0P00001N0?ofkP40oooo001P0?ofkP8000007@3om^h00`3D
?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00`0ooK^0P3D?AT80?ofkP80e3dI3`3om^h20=@m
6@<0ooK^0P3D?AT=0?ofkP030=@m6@3om^h0e3dI00D0ooK^0P3D?AT00`3om^h0e3dI0=@m6@020=@m
6BD0ooK^00<000000?ofkP3om^h08`3om^h403eIZ`030?ofkP0mFJ/0?EV[00D0ooK^00<0?EV[0?of
kP0mFJ/03@3om^h203eIZ`<0ooK^0P0mFJ/?0?ofkP80?EV[203om^h203eIZ`h0ooK^00<0?EV[0?of
kP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP0K0?ofkP800000H03om^h10?ooo`00HP3om^h3000001/0
ooK^00<0e3dI0?ofkP3om^h00P3om^h20=@m6A40ooK^00<0e3dI0?ofkP3om^h00`3om^h20=@m6A<0
ooK^0`3D?AT>0?ofkP<0e3dI103om^h20=@m6@030?ofkP3D?AT0e3dI00<0e3dI9P3om^h00`000000
ooK^0?ofkP0T0?ofkPD0?EV[00<0ooK^03eIZ`0mFJ/0103om^h203eIZ`l0ooK^0`0mFJ/C0?ofkP80
?EV[1@3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP80?EV[103om^h00`0mFJ/0ooK^0?ofkP0I0?ofkP<0
0000HP3om^h10?ooo`00I@3om^h2000001X0ooK^00@0e3dI0?ofkP3D?AT0e3dI503om^h20=@m6@03
0?ofkP3D?AT0e3dI01@0ooK^0P3D?AT20?ofkP@0e3dI2@3om^h20=@m6@@0ooK^203D?ATX0?ofkP03
0000003om^h0ooK^02H0ooK^200mFJ/40?ofkP80?EV[2@3om^h403eIZ`80ooK^0P0mFJ/D0?ofkP80
?EV[00<0ooK^03eIZ`0mFJ/0503om^h203eIZ`030?ofkP0mFJ/0ooK^01T0ooK^0P00001U0?ofkP40
oooo001W0?ofkP8000006@3om^h00`3D?AT0ooK^0?ofkP0F0?ofkP030=@m6@3om^h0ooK^0180ooK^
0P3D?AT80?ofkP@0e3dI0`3om^h30=@m6@80ooK^1P3D?AT00`3om^h0e3dI0=@m6@0Z0?ofkP030000
003om^h0ooK^02P0ooK^0P0mFJ/00`3om^h0?EV[03eIZ`0403eIZ`80ooK^0`0mFJ/30?ofkP@0?EV[
203om^h203eIZa@0ooK^00<0?EV[0?ofkP3om^h05P3om^h00`0mFJ/0ooK^0?ofkP0G0?ofkP800000
I`3om^h10?ooo`00J@3om^h3000001L0ooK^0P3D?ATD0?ofkP80e3dI00<0ooK^0=@m6@3D?AT0403o
m^h20=@m6@h0ooK^2@3D?AT0103om^h0e3dI0=@m6@3om^h20=@m6B`0ooK^00<000000?ofkP3om^h0
:P3om^h203eIZ`040?ofkP0mFJ/0?EV[0?ofkPT0?EV[3P3om^h203eIZa00ooK^0P0mFJ/00`3om^h0
?EV[03eIZ`0D0?ofkP80?EV[5`3om^h3000006T0ooK^0@3oool006`0ooK^0P00000G0?ofkP80e3dI
403om^h20=@m6@D0ooK^0P3D?AT=0?ofkP030=@m6@3om^h0ooK^00h0ooK^0P3D?AT00`3om^h0e3dI
0?ofkP020=@m6@030?ofkP3D?AT0e3dI00<0e3dI;P3om^h00`000000ooK^0?ofkP0/0?ofkPD0?EV[
00@0ooK^03eIZ`0mFJ/0?EV[0P3om^h203eIZa00ooK^00<0?EV[0?ofkP3om^h02`3om^h203eIZ`D0
ooK^0P0mFJ/@0?ofkP80?EV[5`3om^h2000006`0ooK^0@3oool006h0ooK^0P00000G0?ofkP030=@m
6@3om^h0ooK^00/0ooK^0P3D?AT90?ofkP80e3dI2@3om^h20=@m6@l0ooK^0P3D?AT30?ofkP80e3dI
00@0ooK^0=@m6@3D?AT0ooK^0P3D?AT`0?ofkP030000003om^h0ooK^02h0ooK^0P0mFJ/0103om^h0
?EV[03eIZ`3om^h203eIZ`<0ooK^0P0mFJ/?0?ofkP80?EV[2@3om^h203eIZ`T0ooK^0P0mFJ/=0?of
kP0303eIZ`3om^h0ooK^01D0ooK^0P00001^0?ofkP40oooo001`0?ofkP<000005@3om^h20=@m6@T0
ooK^0P3D?AT=0?ofkP80e3dI1@3om^h20=@m6@l0ooK^0P3D?AT40?ofkP050=@m6@3om^h0e3dI0=@m
6@3om^h00P3D?ATb0?ofkP030000003om^h0ooK^0300ooK^0P0mFJ/01@3om^h0?EV[03eIZ`3om^h0
?EV[00@0ooK^0P0mFJ/?0?ofkP80?EV[1@3om^h203eIZ`d0ooK^0P0mFJ/90?ofkP80?EV[5@3om^h3
00000700ooK^0@3oool007<0ooK^0P00000E0?ofkP80e3dI1@3om^h20=@m6A40ooK^0P3D?AT00`3o
m^h0e3dI0=@m6@0?0?ofkP80e3dI1@3om^h60=@m6C@0ooK^00<000000?ofkP3om^h0<P3om^h603eI
Z`D0ooK^0P0mFJ/?0?ofkP80?EV[00<0ooK^03eIZ`0mFJ/04@3om^h203eIZ`D0ooK^0P0mFJ/E0?of
kP800000L`3om^h10?ooo`00M@3om^h2000001D0ooK^0P3D?AT00`3om^h0e3dI0=@m6@0E0?ofkP<0
e3dI3@3om^h20=@m6@H0ooK^1@3D?ATf0?ofkP030000003om^h0ooK^03@0ooK^1@0mFJ/60?ofkP80
?EV[3@3om^h303eIZaD0ooK^0P0mFJ/00`3om^h0?EV[03eIZ`0E0?ofkP800000M@3om^h10?ooo`00
M`3om^h3000001@0ooK^00<0e3dI0?ofkP3om^h04`3om^h20=@m6@<0ooK^1P3D?AT50?ofkP80e3dI
0P3om^h60=@m6@030?ofkP3D?AT0e3dI03P0ooK^00<000000?ofkP3om^h0=P3om^h203eIZ`030?of
kP0mFJ/0?EV[00@0?EV[0P3om^h203eIZ`D0ooK^1P0mFJ/30?ofkP80?EV[5@3om^h00`0mFJ/0ooK^
0?ofkP0B0?ofkP<00000M`3om^h10?ooo`00NP3om^h2000001<0ooK^0P3D?ATA0?ofkP80e3dI2`3o
m^h90=@m6@80ooK^0P3D?AT00`3om^h0e3dI0=@m6@0j0?ofkP030000003om^h0ooK^03P0ooK^0P0m
FJ/00`3om^h0?EV[03eIZ`020?ofkPT0?EV[2`3om^h203eIZa40ooK^0P0mFJ/C0?ofkP800000NP3o
m^h10?ooo`00O03om^h2000001<0ooK^0P3D?AT=0?ofkP80e3dI3P3om^h20=@m6@H0ooK^1@3D?ATl
0?ofkP030000003om^h0ooK^03X0ooK^1@0mFJ/60?ofkP80?EV[3P3om^h203eIZ`d0ooK^0P0mFJ/C
0?ofkP800000O03om^h10?ooo`00OP3om^h300000180ooK^0P3D?AT90?ofkP80e3dI3P3om^h20=@m
6@H0ooK^1@3D?ATn0?ofkP030000003om^h0ooK^03`0ooK^1@0mFJ/60?ofkP80?EV[3P3om^h203eI
Z`T0ooK^0P0mFJ/B0?ofkP<00000OP3om^h10?ooo`00P@3om^h200000180ooK^0P3D?AT50?ofkP80
e3dI3P3om^h20=@m6@H0ooK^103D?AU10?ofkP030000003om^h0ooK^03l0ooK^100mFJ/60?ofkP80
?EV[3P3om^h203eIZ`D0ooK^0P0mFJ/B0?ofkP800000P@3om^h10?ooo`00P`3om^h300000140ooK^
0P3D?AT00`3om^h0e3dI0=@m6@0>0?ofkP80e3dI1P3om^h40=@m6D<0ooK^00<000000?ofkP3om^h0
@@3om^h403eIZ`H0ooK^0P0mFJ/>0?ofkP80?EV[00<0ooK^03eIZ`0mFJ/04@3om^h3000008<0ooK^
0@3oool008H0ooK^0P00000A0?ofkP<0e3dI303om^h20=@m6@H0ooK^0`3D?AU60?ofkP030000003o
m^h0ooK^04@0ooK^0`0mFJ/60?ofkP80?EV[303om^h303eIZa40ooK^0P0000260?ofkP40oooo0028
0?ofkP8000004P3om^h60=@m6@@0ooK^0P3D?AT30?ofkPH0e3dIB03om^h00`000000ooK^0?ofkP16
0?ofkPH0?EV[0`3om^h203eIZ`@0ooK^1P0mFJ/B0?ofkP800000R03om^h10?ooo`00RP3om^h30000
01D0ooK^2@3D?AU>0?ofkP030000003om^h0ooK^04`0ooK^2@0mFJ/E0?ofkP<00000RP3om^h10?oo
o`00S@3om^h2000006X0ooK^00<000000?ofkP3om^h0J03om^h2000008d0ooK^0@3oool008l0ooK^
0P00001X0?ofkP030000003om^h0ooK^06H0ooK^0P00002?0?ofkP40oooo002A0?ofkP<00000I@3o
m^h00`000000ooK^0?ofkP1S0?ofkP<00000T@3om^h10?ooo`00U03om^h2000006<0ooK^00<00000
0?ofkP3om^h0H@3om^h2000009@0ooK^0@3oool009H0ooK^0P00001Q0?ofkP030000003om^h0ooK^
05l0ooK^0P00002F0?ofkP40oooo002H0?ofkP<00000GP3om^h00`000000ooK^0?ofkP1L0?ofkP<0
0000V03om^h10?ooo`00V`3om^h2000005`0ooK^00<000000?ofkP3om^h0FP3om^h2000009/0ooK^
0@3oool009d0ooK^0P00001J0?ofkP030000003om^h0ooK^05P0ooK^0P00002M0?ofkP40oooo002O
0?ofkP<00000E`3om^h00`000000ooK^0?ofkP1E0?ofkP<00000W`3om^h10?ooo`00XP3om^h20000
05D0ooK^00<000000?ofkP3om^h0D`3om^h200000:80ooK^0@3oool00:@0ooK^0P00001C0?ofkP03
0000003om^h0ooK^0540ooK^0P00002T0?ofkP40oooo002V0?ofkP<00000D03om^h00`000000ooK^
0?ofkP1>0?ofkP<00000YP3om^h10?ooo`00Z@3om^h2000004h0ooK^00<000000?ofkP3om^h0C03o
m^h200000:T0ooK^0@3oool00:/0ooK^0P00001<0?ofkP030000003om^h0ooK^04X0ooK^0P00002[
0?ofkP40oooo002]0?ofkP<00000B@3om^h00`000000ooK^0?ofkP170?ofkP<00000[@3om^h10?oo
o`00/03om^h2000004L0ooK^00<000000?ofkP3om^h0A@3om^h200000;00ooK^0@3oool00;80ooK^
0P0000150?ofkP030000003om^h0ooK^04<0ooK^0P00002b0?ofkP40oooo002d0?ofkP<00000@P3o
m^h00`000000ooK^0?ofkP100?ofkP<00000]03om^h10?ooo`00]`3om^h200000400ooK^00<00000
0?ofkP3om^h0?P3om^h200000;L0ooK^0@3oool00;T0ooK^0P00000n0?ofkP030000003om^h0ooK^
03`0ooK^0P00002i0?ofkP40oooo002k0?ofkP<00000>`3om^h00`000000ooK^0?ofkP0i0?ofkP<0
0000^`3om^h10?ooo`00_P3om^h2000003T0ooK^00<000000?ofkP3om^h0=`3om^h200000;h0ooK^
0@3oool00<00ooK^0P00000g0?ofkP030000003om^h0ooK^03D0ooK^0P0000300?ofkP40oooo0032
0?ofkP<00000=03om^h00`000000ooK^0?ofkP0b0?ofkP<00000`P3om^h10?ooo`00a@3om^h20000
0380ooK^00<000000?ofkP3om^h0<03om^h200000<D0ooK^0@3oool00<L0ooK^0P00000`0?ofkP03
0000003om^h0ooK^02h0ooK^0P0000370?ofkP40oooo00390?ofkP<00000;@3om^h00`000000ooK^
0?ofkP0[0?ofkP<00000b@3om^h10?ooo`00c03om^h2000002/0ooK^00<000000?ofkP3om^h0:@3o
m^h200000<`0ooK^0@3oool00<h0ooK^0P00000Y0?ofkP030000003om^h0ooK^02L0ooK^0P00003>
0?ofkP40oooo003@0?ofkP<000009P3om^h00`000000ooK^0?ofkP0T0?ofkP<00000d03om^h10?oo
o`00d`3om^h2000002@0ooK^00<000000?ofkP3om^h08P3om^h200000=<0ooK^0@3oool00=D0ooK^
0`00000Q0?ofkP030000003om^h0ooK^01l0ooK^0`00003E0?ofkP40oooo003H0?ofkP8000007`3o
m^h00`000000ooK^0?ofkP0M0?ofkP800000f03om^h10?ooo`00fP3om^h2000001d0ooK^00<00000
0?ofkP3om^h06`3om^h200000=X0ooK^0@3oool00=`0ooK^0`00000J0?ofkP030000003om^h0ooK^
01P0ooK^0`00003L0?ofkP40oooo003O0?ofkP800000603om^h00`000000ooK^0?ofkP0F0?ofkP80
0000g`3om^h10?ooo`00h@3om^h2000001H0ooK^00<000000?ofkP3om^h0503om^h200000>40ooK^
0@3oool00><0ooK^0`00000C0?ofkP030000003om^h0ooK^0140ooK^0`00003S0?ofkP40oooo003V
0?ofkP8000004@3om^h00`000000ooK^0?ofkP0?0?ofkP800000iP3om^h10?ooo`00j03om^h20000
00l0ooK^00<000000?ofkP3om^h03@3om^h200000>P0ooK^0@3oool00>X0ooK^0`00000<0?ofkP03
0000003om^h0ooK^00X0ooK^0`00003Z0?ofkP40oooo003]0?ofkP8000002P3om^h00`000000ooK^
0?ofkP080?ofkP800000k@3om^h10?ooo`00k`3om^h2000000P0ooK^00<000000?ofkP3om^h01P3o
m^h200000>l0ooK^0@3oool00?40ooK^0`0000050?ofkP030000003om^h0ooK^00<0ooK^0`00003a
0?ofkP40oooo003d0?ofkP8000000`3om^h010000000ooK^0?ofkP3om^h200000?@0ooK^0@3oool0
0?H0ooK^0P0000000`3om^h000000?ofkP0200000?H0ooK^0@3oool00?P0ooK^0`00003h0?ofkP40
oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?of
k_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3o
ool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^
m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?oo
o`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd
0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo
003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0
ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool0
0?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03o
m^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00
o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?of
kP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o
0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^
0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0
ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h1
0?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3o
m^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40
oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?of
k_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3o
ool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^
m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?oo
o`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd
0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00001\
\>"],
  ImageRangeCache->{{{0, 499}, {499, 0}} -> {-5.00005*^-06, -5.00005*^-06, \
0.00200403, 0.00200403}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
%%ImageSize: 500 500 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics3D
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Background color
1 .961 .933 r
MFill
% Scaling calculations
0 1 0 1 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 0 r
.25 Mabswid
[ ] 0 setdash
.63805 .03848 m
.66126 .3169 L
s
.66126 .3169 m
.00747 .5665 L
s
.00747 .5665 m
.06705 .30234 L
s
.06705 .30234 m
.63805 .03848 L
s
.88764 .44767 m
.40912 .60318 L
s
.40912 .60318 m
.39961 .8356 L
s
.39961 .8356 m
.93472 .69847 L
s
.93472 .69847 m
.88764 .44767 L
s
.63805 .03848 m
.66126 .3169 L
s
.66126 .3169 m
.93472 .69847 L
s
.93472 .69847 m
.88764 .44767 L
s
.88764 .44767 m
.63805 .03848 L
s
.06705 .30234 m
.40912 .60318 L
s
.40912 .60318 m
.39961 .8356 L
s
.39961 .8356 m
.00747 .5665 L
s
.00747 .5665 m
.06705 .30234 L
s
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
.24 .35 .67 r
.5 Mabswid
.57143 .56253 m
.553 .58135 L
s
.55428 .54453 m
.57143 .56253 L
s
.59245 .54684 m
.57143 .56253 L
s
.553 .58135 m
.53784 .60261 L
s
.53555 .56364 m
.553 .58135 L
s
.5756 .52855 m
.59245 .54684 L
s
.61531 .53486 m
.59245 .54684 L
s
.53784 .60261 m
.52654 .62555 L
s
.5201 .58518 m
.53784 .60261 L
s
.59876 .5163 m
.61531 .53486 L
s
.6392 .52709 m
.61531 .53486 L
s
.52654 .62555 m
.51958 .64934 L
s
.50852 .6084 m
.52654 .62555 L
s
.62292 .50827 m
.6392 .52709 L
s
.66322 .52391 m
.6392 .52709 L
s
.53555 .56364 m
.55428 .54453 L
s
.53658 .52595 m
.55428 .54453 L
s
.55428 .54453 m
.5756 .52855 L
s
.51958 .64934 m
.51732 .6731 L
s
.50131 .63245 m
.51958 .64934 L
s
.5201 .58518 m
.53555 .56364 L
s
.51754 .54535 m
.53555 .56364 L
s
.55821 .50967 m
.5756 .52855 L
s
.5756 .52855 m
.59876 .5163 L
s
.50852 .6084 m
.5201 .58518 L
s
.50178 .56719 m
.5201 .58518 L
s
.64718 .50487 m
.66322 .52391 L
s
.68644 .52555 m
.66322 .52391 L
s
.58167 .49713 m
.59876 .5163 L
s
.59876 .5163 m
.62292 .50827 L
s
.50131 .63245 m
.50852 .6084 L
s
.48991 .59069 m
.50852 .6084 L
s
.51732 .6731 m
.49883 .65643 L
s
.51732 .6731 m
.51998 .69588 L
s
.6061 .48884 m
.62292 .50827 L
s
.62292 .50827 m
.64718 .50487 L
s
.83 .24 .1 r
.3274 .57153 m
.3337 .59771 L
s
.35824 .56096 m
.3274 .57153 L
s
.31825 .54593 m
.3274 .57153 L
s
.34901 .53511 m
.31825 .54593 L
s
.30656 .5218 m
.31825 .54593 L
s
.24 .35 .67 r
.51754 .54535 m
.53658 .52595 L
s
.5183 .50675 m
.53658 .52595 L
s
.53658 .52595 m
.55821 .50967 L
s
.67062 .50634 m
.68644 .52555 L
s
.7079 .53211 m
.68644 .52555 L
s
.49883 .65643 m
.50131 .63245 L
s
.48243 .61499 m
.50131 .63245 L
s
.50178 .56719 m
.51754 .54535 L
s
.49893 .52646 m
.51754 .54535 L
s
.54025 .49016 m
.55821 .50967 L
s
.55821 .50967 m
.58167 .49713 L
s
.83 .24 .1 r
.3337 .59771 m
.33691 .62359 L
s
.36469 .58735 m
.3337 .59771 L
s
.33733 .51071 m
.30656 .5218 L
s
.29271 .49996 m
.30656 .5218 L
s
.24 .35 .67 r
.48991 .59069 m
.50178 .56719 L
s
.48286 .5486 m
.50178 .56719 L
s
.51998 .69588 m
.52762 .71672 L
s
.50133 .6794 m
.51998 .69588 L
s
.63062 .4852 m
.64718 .50487 L
s
.64718 .50487 m
.67062 .50634 L
s
.56401 .47732 m
.58167 .49713 L
s
.58167 .49713 m
.6061 .48884 L
s
.83 .24 .1 r
.33691 .62359 m
.33687 .64824 L
s
.36813 .61341 m
.33691 .62359 L
s
.24 .35 .67 r
.48243 .61499 m
.48991 .59069 L
s
.47068 .57239 m
.48991 .59069 L
s
.83 .24 .1 r
.36469 .58735 m
.35824 .56096 L
s
.38967 .55018 m
.35824 .56096 L
s
.35824 .56096 m
.34901 .53511 L
s
.38037 .52409 m
.34901 .53511 L
s
.34901 .53511 m
.33733 .51071 L
s
.24 .35 .67 r
.50133 .6794 m
.49883 .65643 L
s
.47973 .63921 m
.49883 .65643 L
s
.83 .24 .1 r
.32356 .48859 m
.29271 .49996 L
s
.27714 .48125 m
.29271 .49996 L
s
.24 .35 .67 r
.69225 .51278 m
.7079 .53211 L
s
.72665 .54349 m
.7079 .53211 L
s
.83 .24 .1 r
.36813 .61341 m
.36469 .58735 L
s
.39628 .5768 m
.36469 .58735 L
s
.36868 .49941 m
.33733 .51071 L
s
.33733 .51071 m
.32356 .48859 L
s
.24 .35 .67 r
.58873 .46875 m
.6061 .48884 L
s
.6061 .48884 m
.63062 .4852 L
s
.49893 .52646 m
.5183 .50675 L
s
.4994 .4869 m
.5183 .50675 L
s
.5183 .50675 m
.54025 .49016 L
s
.65427 .48648 m
.67062 .50634 L
s
.67062 .50634 m
.69225 .51278 L
s
.52762 .71672 m
.54009 .73466 L
s
.50887 .70039 m
.52762 .71672 L
s
.47973 .63921 m
.48243 .61499 L
s
.46293 .59696 m
.48243 .61499 L
s
.48286 .5486 m
.49893 .52646 L
s
.4797 .50694 m
.49893 .52646 L
s
.83 .24 .1 r
.33687 .64824 m
.36838 .63821 L
s
.33687 .64824 m
.33348 .67076 L
s
.36838 .63821 m
.36813 .61341 L
s
.39995 .60304 m
.36813 .61341 L
s
.24 .35 .67 r
.52168 .46999 m
.54025 .49016 L
s
.54025 .49016 m
.56401 .47732 L
s
.83 .24 .1 r
.39628 .5768 m
.38967 .55018 L
s
.42171 .5392 m
.38967 .55018 L
s
.38967 .55018 m
.38037 .52409 L
s
.41233 .51285 m
.38037 .52409 L
s
.38037 .52409 m
.36868 .49941 L
s
.35499 .477 m
.32356 .48859 L
s
.32356 .48859 m
.30814 .46959 L
s
.30814 .46959 m
.27714 .48125 L
s
.26038 .46644 m
.27714 .48125 L
s
.24 .35 .67 r
.47068 .57239 m
.48286 .5486 L
s
.4633 .52939 m
.48286 .5486 L
s
.50887 .70039 m
.50133 .6794 L
s
.48206 .66237 m
.50133 .6794 L
s
.83 .24 .1 r
.39995 .60304 m
.39628 .5768 L
s
.42848 .56604 m
.39628 .5768 L
s
.40065 .48789 m
.36868 .49941 L
s
.36868 .49941 m
.35499 .477 L
s
.24 .35 .67 r
.6135 .46487 m
.63062 .4852 L
s
.63062 .4852 m
.65427 .48648 L
s
.54575 .45684 m
.56401 .47732 L
s
.56401 .47732 m
.58873 .46875 L
s
.71112 .5241 m
.72665 .54349 L
s
.74177 .55936 m
.72665 .54349 L
s
.46293 .59696 m
.47068 .57239 L
s
.47973 .63921 m
.45999 .6214 L
s
.48206 .66237 m
.47973 .63921 L
s
.83 .24 .1 r
.36838 .63821 m
.4005 .62799 L
s
.36533 .66082 m
.36838 .63821 L
s
.4005 .62799 m
.39995 .60304 L
s
.43239 .59247 m
.39995 .60304 L
s
.42848 .56604 m
.42171 .5392 L
s
.42171 .5392 m
.41233 .51285 L
s
.44491 .50139 m
.41233 .51285 L
s
.41233 .51285 m
.40065 .48789 L
s
.24 .35 .67 r
.67607 .49279 m
.69225 .51278 L
s
.69225 .51278 m
.71112 .5241 L
s
.54009 .73466 m
.55704 .74882 L
s
.52132 .71843 m
.54009 .73466 L
s
.83 .24 .1 r
.38705 .46519 m
.35499 .477 L
s
.35499 .477 m
.33974 .4577 L
s
.33974 .4577 m
.30814 .46959 L
s
.30814 .46959 m
.29159 .45448 L
s
.33348 .67076 m
.32675 .6902 L
s
.36533 .66082 m
.33348 .67076 L
s
.24 .35 .67 r
.57076 .44798 m
.58873 .46875 L
s
.58873 .46875 m
.6135 .46487 L
s
.83 .24 .1 r
.43239 .59247 m
.42848 .56604 L
s
.29159 .45448 m
.26038 .46644 L
s
.243 .45621 m
.26038 .46644 L
s
.43323 .47615 m
.40065 .48789 L
s
.40065 .48789 m
.38705 .46519 L
s
.24 .35 .67 r
.4797 .50694 m
.4994 .4869 L
s
.4994 .4869 m
.52168 .46999 L
s
.63736 .46595 m
.65427 .48648 L
s
.65427 .48648 m
.67607 .49279 L
s
.52132 .71843 m
.50887 .70039 L
s
.48949 .6835 m
.50887 .70039 L
s
.45999 .6214 m
.46293 .59696 L
s
.4633 .52939 m
.4797 .50694 L
s
.50248 .44914 m
.52168 .46999 L
s
.52168 .46999 m
.54575 .45684 L
s
.72629 .53999 m
.74177 .55936 L
s
.75243 .57919 m
.74177 .55936 L
s
.83 .24 .1 r
.4005 .62799 m
.43325 .61756 L
s
.39781 .6507 m
.4005 .62799 L
s
.43325 .61756 m
.43239 .59247 L
s
.731 .205 .09 r
.47042 .54506 m .45551 .55007 L .45243 .57274 L p F P
0 0 0 r
s
.24 .35 .67 r
.46153 .5328 m
.4633 .52939 L
s
.45955 .56179 m
.47068 .57239 L
s
.774 .219 .095 r
.45551 .55007 m .47042 .54506 L .47313 .52168 L p F P
0 0 0 r
s
.774 .219 .095 r
.47313 .52168 m .45957 .52633 L .45551 .55007 L p F P
0 0 0 r
s
.303 .432 .811 r
.44643 .54137 m .45551 .55007 L .45243 .57274 L p F P
0 0 0 r
s
.83 .24 .1 r
.42848 .56604 m
.44978 .55892 L
s
.307 .441 .834 r
.45551 .55007 m .44643 .54137 L .45135 .51826 L p F P
0 0 0 r
s
.83 .24 .1 r
.42171 .5392 m
.44887 .52989 L
s
.307 .441 .834 r
.45135 .51826 m .45957 .52633 L .45551 .55007 L p F P
0 0 0 r
s
.24 .35 .67 r
.48949 .6835 m
.48206 .66237 L
s
.46213 .64475 m
.48206 .66237 L
s
.83 .24 .1 r
.44491 .50139 m
.45118 .51904 L
s
.44491 .50139 m
.43323 .47615 L
s
.813 .232 .1 r
.45957 .52633 m .47313 .52168 L .47645 .49774 L p F P
0 0 0 r
s
.24 .35 .67 r
.47573 .50291 m
.4797 .50694 L
s
.813 .232 .1 r
.47645 .49774 m .46455 .5019 L .45957 .52633 L p F P
0 0 0 r
s
.309 .446 .849 r
.45957 .52633 m .45135 .51826 L .45737 .49468 L p F P
0 0 0 r
s
.83 .24 .1 r
.44491 .50139 m
.45671 .49724 L
s
.309 .446 .849 r
.45737 .49468 m .46455 .5019 L .45957 .52633 L p F P
0 0 0 r
s
.83 .24 .1 r
.41973 .45314 m
.38705 .46519 L
s
.38705 .46519 m
.37196 .44558 L
s
.37196 .44558 m
.33974 .4577 L
s
.33974 .4577 m
.32342 .4423 L
s
.24 .35 .67 r
.59579 .44384 m
.6135 .46487 L
s
.6135 .46487 m
.63736 .46595 L
s
.83 .24 .1 r
.35899 .68032 m
.36533 .66082 L
s
.39781 .6507 m
.36533 .66082 L
s
.683 .19 .083 r
.46836 .56749 m .45243 .57274 L .45038 .59394 L p F P
0 0 0 r
s
.24 .35 .67 r
.45396 .58867 m
.46293 .59696 L
s
.731 .205 .09 r
.45243 .57274 m .46836 .56749 L .47042 .54506 L p F P
0 0 0 r
s
.83 .24 .1 r
.45664 .53684 m
.46131 .55507 L
s
.45386 .55756 m
.46131 .55507 L
s
.295 .418 .779 r
.44268 .56361 m .45243 .57274 L .45038 .59394 L p F P
0 0 0 r
s
.83 .24 .1 r
.43239 .59247 m
.44866 .58717 L
s
.303 .432 .811 r
.45243 .57274 m .44268 .56361 L .44643 .54137 L p F P
0 0 0 r
s
.24 .35 .67 r
.4508 .55347 m
.45534 .55778 L
s
.4508 .55347 m
.45922 .53724 L
s
.52687 .43566 m
.54575 .45684 L
s
.54575 .45684 m
.57076 .44798 L
s
.69505 .50405 m
.71112 .5241 L
s
.71112 .5241 m
.72629 .53999 L
s
.83 .24 .1 r
.32342 .4423 m
.29159 .45448 L
s
.29159 .45448 m
.2745 .44399 L
s
.849 .243 .105 r
.46455 .5019 m .47645 .49774 L .48032 .47365 L p F P
0 0 0 r
s
.849 .243 .105 r
.48032 .47365 m .47035 .4772 L .46455 .5019 L p F P
0 0 0 r
s
.31 .449 .858 r
.46455 .5019 m .45737 .49468 L .46439 .47104 L p F P
0 0 0 r
s
.31 .449 .858 r
.46439 .47104 m .47035 .4772 L .46455 .5019 L p F P
0 0 0 r
s
.83 .24 .1 r
.43323 .47615 m
.41973 .45314 L
s
.24 .35 .67 r
.55704 .74882 m
.57784 .75839 L
s
.53831 .73262 m
.55704 .74882 L
s
.731 .205 .09 r
.48546 .54001 m .47042 .54506 L .46836 .56749 L p F P
0 0 0 r
s
.774 .219 .095 r
.47042 .54506 m .48546 .54001 L .4868 .517 L p F P
0 0 0 r
s
.774 .219 .095 r
.4868 .517 m .47313 .52168 L .47042 .54506 L p F P
0 0 0 r
s
.813 .232 .1 r
.47313 .52168 m .4868 .517 L .48843 .49355 L p F P
0 0 0 r
s
.813 .232 .1 r
.48843 .49355 m .47645 .49774 L .47313 .52168 L p F P
0 0 0 r
s
.83 .24 .1 r
.32675 .6902 m
.31682 .70568 L
s
.35899 .68032 m
.32675 .6902 L
s
.625 .171 .076 r
.46699 .58856 m .45038 .59394 L .44941 .61329 L p F P
0 0 0 r
s
.683 .19 .083 r
.45038 .59394 m .46699 .58856 L .46836 .56749 L p F P
0 0 0 r
s
.83 .24 .1 r
.46131 .55507 m
.46547 .58169 L
s
.45051 .58656 m
.46547 .58169 L
s
.283 .397 .733 r
.44019 .58459 m .45038 .59394 L .44941 .61329 L p F P
0 0 0 r
s
.295 .418 .779 r
.45038 .59394 m .44019 .58459 L .44268 .56361 L p F P
0 0 0 r
s
.24 .35 .67 r
.44276 .5783 m
.45192 .58677 L
s
.683 .19 .083 r
.48444 .56218 m .46836 .56749 L .46699 .58856 L p F P
0 0 0 r
s
.731 .205 .09 r
.46836 .56749 m .48444 .56218 L .48546 .54001 L p F P
0 0 0 r
s
.303 .432 .811 r
.4372 .53252 m .44643 .54137 L .44268 .56361 L p F P
0 0 0 r
s
.24 .35 .67 r
.44276 .5783 m
.4508 .55347 L
s
.307 .441 .834 r
.44643 .54137 m .4372 .53252 L .44301 .51007 L p F P
0 0 0 r
s
.307 .441 .834 r
.44301 .51007 m .45135 .51826 L .44643 .54137 L p F P
0 0 0 r
s
.309 .446 .849 r
.45135 .51826 m .44301 .51007 L .45011 .48737 L p F P
0 0 0 r
s
.309 .446 .849 r
.45011 .48737 m .45737 .49468 L .45135 .51826 L p F P
0 0 0 r
s
.849 .243 .105 r
.47645 .49774 m .48843 .49355 L .49034 .47008 L p F P
0 0 0 r
s
.24 .35 .67 r
.48979 .47681 m
.4994 .4869 L
s
.849 .243 .105 r
.49034 .47008 m .48032 .47365 L .47645 .49774 L p F P
0 0 0 r
s
.83 .24 .1 r
.46538 .4942 m
.47813 .48971 L
s
.24 .35 .67 r
.65933 .47212 m
.67607 .49279 L
s
.67607 .49279 m
.69505 .50405 L
s
.53831 .73262 m
.52132 .71843 L
s
.50189 .70163 m
.52132 .71843 L
s
.83 .24 .1 r
.2745 .44399 m
.243 .45621 L
s
.22568 .4512 m
.243 .45621 L
s
.774 .219 .095 r
.50057 .51227 m .4868 .517 L .48546 .54001 L p F P
0 0 0 r
s
.813 .232 .1 r
.4868 .517 m .50057 .51227 L .5005 .48933 L p F P
0 0 0 r
s
.813 .232 .1 r
.5005 .48933 m .48843 .49355 L .4868 .517 L p F P
0 0 0 r
s
.731 .205 .09 r
.50063 .53491 m .48546 .54001 L .48444 .56218 L p F P
0 0 0 r
s
.774 .219 .095 r
.48546 .54001 m .50063 .53491 L .50057 .51227 L p F P
0 0 0 r
s
.83 .24 .1 r
.45857 .52656 m
.48767 .51658 L
s
.43093 .64037 m
.43325 .61756 L
s
.24 .35 .67 r
.55217 .4265 m
.57076 .44798 L
s
.57076 .44798 m
.59579 .44384 L
s
.295 .418 .779 r
.43277 .55433 m .44268 .56361 L .44019 .58459 L p F P
0 0 0 r
s
.303 .432 .811 r
.44268 .56361 m .43277 .55433 L .4372 .53252 L p F P
0 0 0 r
s
.83 .24 .1 r
.47813 .48971 m
.48767 .51658 L
s
.883 .255 .11 r
.47035 .4772 m .48032 .47365 L .48468 .44983 L p F P
0 0 0 r
s
.883 .255 .11 r
.48468 .44983 m .47691 .45265 L .47035 .4772 L p F P
0 0 0 r
s
.24 .35 .67 r
.48136 .46795 m
.48515 .47193 L
s
.308 .449 .863 r
.47035 .4772 m .46439 .47104 L .47229 .44776 L p F P
0 0 0 r
s
.308 .449 .863 r
.47229 .44776 m .47691 .45265 L .47035 .4772 L p F P
0 0 0 r
s
.31 .449 .858 r
.45737 .49468 m .45011 .48737 L .45836 .46482 L p F P
0 0 0 r
s
.31 .449 .858 r
.45836 .46482 m .46439 .47104 L .45737 .49468 L p F P
0 0 0 r
s
.83 .24 .1 r
.45999 .46651 m
.46646 .46417 L
s
.43323 .47615 m
.4574 .46744 L
s
.24 .35 .67 r
.45982 .48675 m
.46748 .49453 L
s
.83 .24 .1 r
.46981 .4715 m
.47813 .48971 L
s
.46646 .46417 m
.46661 .46449 L
s
.625 .171 .076 r
.44941 .61329 m .46634 .60791 L .46699 .58856 L p F P
0 0 0 r
s
.625 .171 .076 r
.48376 .58313 m .46699 .58856 L .46634 .60791 L p F P
0 0 0 r
s
.683 .19 .083 r
.46699 .58856 m .48376 .58313 L .48444 .56218 L p F P
0 0 0 r
s
.83 .24 .1 r
.41973 .45314 m
.40482 .43322 L
s
.849 .243 .105 r
.48843 .49355 m .5005 .48933 L .50042 .46649 L p F P
0 0 0 r
s
.849 .243 .105 r
.50042 .46649 m .49034 .47008 L .48843 .49355 L p F P
0 0 0 r
s
.683 .19 .083 r
.50068 .55683 m .48444 .56218 L .48376 .58313 L p F P
0 0 0 r
s
.731 .205 .09 r
.48444 .56218 m .50068 .55683 L .50063 .53491 L p F P
0 0 0 r
s
.83 .24 .1 r
.48767 .51658 m
.49479 .54388 L
s
.46131 .55507 m
.49479 .54388 L
s
.40482 .43322 m
.37196 .44558 L
s
.37196 .44558 m
.35589 .42987 L
s
.39187 .67024 m
.39781 .6507 L
s
.43093 .64037 m
.39781 .6507 L
s
.24 .35 .67 r
.73695 .55992 m
.75243 .57919 L
s
.75798 .6022 m
.75243 .57919 L
s
.45982 .48675 m
.47413 .47221 L
s
.61987 .44471 m
.63736 .46595 L
s
.63736 .46595 m
.65933 .47212 L
s
.50189 .70163 m
.48949 .6835 L
s
.46943 .66603 m
.48949 .6835 L
s
.774 .219 .095 r
.51446 .50751 m .50057 .51227 L .50063 .53491 L p F P
0 0 0 r
s
.813 .232 .1 r
.50057 .51227 m .51446 .50751 L .51266 .48509 L p F P
0 0 0 r
s
.813 .232 .1 r
.51266 .48509 m .5005 .48933 L .50057 .51227 L p F P
0 0 0 r
s
.883 .255 .11 r
.48032 .47365 m .49034 .47008 L .49248 .447 L p F P
0 0 0 r
s
.24 .35 .67 r
.48194 .4648 m
.48565 .46197 L
s
.883 .255 .11 r
.49248 .447 m .48468 .44983 L .48032 .47365 L p F P
0 0 0 r
s
.24 .35 .67 r
.49151 .45751 m
.50248 .44914 L
s
.731 .205 .09 r
.51594 .52976 m .50063 .53491 L .50068 .55683 L p F P
0 0 0 r
s
.774 .219 .095 r
.50063 .53491 m .51594 .52976 L .51446 .50751 L p F P
0 0 0 r
s
.554 .149 .066 r
.46634 .60791 m .44941 .61329 L .44956 .63042 L p F P
0 0 0 r
s
.24 .35 .67 r
.45777 .6194 m
.45999 .6214 L
s
.45999 .6214 m
.46213 .64475 L
s
.283 .397 .733 r
.44941 .61329 m .43901 .60393 L .44019 .58459 L p F P
0 0 0 r
s
.264 .365 .665 r
.43901 .60393 m .44941 .61329 L .44956 .63042 L p F P
0 0 0 r
s
.83 .24 .1 r
.43325 .61756 m
.44318 .6144 L
s
.35589 .42987 m
.32342 .4423 L
s
.32342 .4423 m
.30662 .43152 L
s
.46646 .46417 m
.46675 .46407 L
s
.307 .441 .834 r
.43456 .50177 m .44301 .51007 L .4372 .53252 L p F P
0 0 0 r
s
.309 .446 .849 r
.44301 .51007 m .43456 .50177 L .44275 .47997 L p F P
0 0 0 r
s
.309 .446 .849 r
.44275 .47997 m .45011 .48737 L .44301 .51007 L p F P
0 0 0 r
s
.24 .35 .67 r
.44307 .50952 m
.45982 .48675 L
s
.44307 .50952 m
.46076 .5269 L
s
.849 .243 .105 r
.5005 .48933 m .51266 .48509 L .51056 .46288 L p F P
0 0 0 r
s
.849 .243 .105 r
.51056 .46288 m .50042 .46649 L .5005 .48933 L p F P
0 0 0 r
s
.283 .397 .733 r
.42982 .57508 m .44019 .58459 L .43901 .60393 L p F P
0 0 0 r
s
.295 .418 .779 r
.44019 .58459 m .42982 .57508 L .43277 .55433 L p F P
0 0 0 r
s
.24 .35 .67 r
.43956 .60298 m
.44276 .5783 L
s
.303 .432 .811 r
.42783 .52354 m .4372 .53252 L .43277 .55433 L p F P
0 0 0 r
s
.307 .441 .834 r
.4372 .53252 m .42783 .52354 L .43456 .50177 L p F P
0 0 0 r
s
.308 .449 .863 r
.46439 .47104 m .45836 .46482 L .46764 .44283 L p F P
0 0 0 r
s
.83 .24 .1 r
.46539 .46231 m
.46646 .46417 L
s
.308 .449 .863 r
.46764 .44283 m .47229 .44776 L .46439 .47104 L p F P
0 0 0 r
s
.83 .24 .1 r
.34946 .6958 m
.35899 .68032 L
s
.39187 .67024 m
.35899 .68032 L
s
.683 .19 .083 r
.48376 .58313 m .50071 .57765 L .50068 .55683 L p F P
0 0 0 r
s
.83 .24 .1 r
.49479 .54388 m
.4992 .57069 L
s
.683 .19 .083 r
.51707 .55142 m .50068 .55683 L .50071 .57765 L p F P
0 0 0 r
s
.731 .205 .09 r
.50068 .55683 m .51707 .55142 L .51594 .52976 L p F P
0 0 0 r
s
.883 .255 .11 r
.49034 .47008 m .50042 .46649 L .50033 .44416 L p F P
0 0 0 r
s
.24 .35 .67 r
.50034 .44681 m
.50248 .44914 L
s
.883 .255 .11 r
.50033 .44416 m .49248 .447 L .49034 .47008 L p F P
0 0 0 r
s
.625 .171 .076 r
.46634 .60791 m .48344 .60246 L .48376 .58313 L p F P
0 0 0 r
s
.625 .171 .076 r
.50071 .57765 m .48376 .58313 L .48344 .60246 L p F P
0 0 0 r
s
.83 .24 .1 r
.46547 .58169 m
.4992 .57069 L
s
.31 .449 .858 r
.45011 .48737 m .44275 .47997 L .45227 .45853 L p F P
0 0 0 r
s
.31 .449 .858 r
.45227 .45853 m .45836 .46482 L .45011 .48737 L p F P
0 0 0 r
s
.24 .35 .67 r
.71028 .51995 m
.72629 .53999 L
s
.72629 .53999 m
.73695 .55992 L
s
.57784 .75839 m
.60167 .76276 L
s
.55924 .74215 m
.57784 .75839 L
s
.774 .219 .095 r
.52846 .50272 m .51446 .50751 L .51594 .52976 L p F P
0 0 0 r
s
.813 .232 .1 r
.51446 .50751 m .52846 .50272 L .5249 .48081 L p F P
0 0 0 r
s
.813 .232 .1 r
.5249 .48081 m .51266 .48509 L .51446 .50751 L p F P
0 0 0 r
s
.731 .205 .09 r
.53138 .52457 m .51594 .52976 L .51707 .55142 L p F P
0 0 0 r
s
.774 .219 .095 r
.51594 .52976 m .53138 .52457 L .52846 .50272 L p F P
0 0 0 r
s
.83 .24 .1 r
.48767 .51658 m
.52164 .50494 L
s
.295 .418 .779 r
.4227 .54489 m .43277 .55433 L .42982 .57508 L p F P
0 0 0 r
s
.303 .432 .811 r
.43277 .55433 m .4227 .54489 L .42783 .52354 L p F P
0 0 0 r
s
.24 .35 .67 r
.43024 .5339 m
.4508 .55347 L
s
.554 .149 .066 r
.44956 .63042 m .46644 .62513 L .46634 .60791 L p F P
0 0 0 r
s
.554 .149 .066 r
.48344 .60246 m .46634 .60791 L .46644 .62513 L p F P
0 0 0 r
s
.83 .24 .1 r
.44868 .61264 m
.46665 .60692 L
s
.46547 .58169 m
.46665 .60692 L
s
.849 .243 .105 r
.51266 .48509 m .5249 .48081 L .52076 .45925 L p F P
0 0 0 r
s
.849 .243 .105 r
.52076 .45925 m .51056 .46288 L .51266 .48509 L p F P
0 0 0 r
s
.83 .24 .1 r
.47813 .48971 m
.51201 .4778 L
s
.30662 .43152 m
.2745 .44399 L
s
.2745 .44399 m
.25751 .43872 L
s
.917 .266 .114 r
.47691 .45265 m .48468 .44983 L .48946 .42672 L p F P
0 0 0 r
s
.917 .266 .114 r
.48946 .42672 m .48411 .42869 L .47691 .45265 L p F P
0 0 0 r
s
.305 .447 .863 r
.47691 .45265 m .47229 .44776 L .48096 .42527 L p F P
0 0 0 r
s
.305 .447 .863 r
.48096 .42527 m .48411 .42869 L .47691 .45265 L p F P
0 0 0 r
s
.24 .35 .67 r
.57746 .42208 m
.59579 .44384 L
s
.59579 .44384 m
.61987 .44471 L
s
.883 .255 .11 r
.50042 .46649 m .51056 .46288 L .5082 .4413 L p F P
0 0 0 r
s
.24 .35 .67 r
.50248 .44914 m
.50646 .44694 L
s
.50869 .44571 m
.52687 .43566 L
s
.883 .255 .11 r
.5082 .4413 m .50033 .44416 L .50042 .46649 L p F P
0 0 0 r
s
.83 .24 .1 r
.47322 .46174 m
.50035 .45196 L
s
.51201 .4778 m
.52164 .50494 L
s
.308 .449 .863 r
.45836 .46482 m .45227 .45853 L .46295 .43787 L p F P
0 0 0 r
s
.83 .24 .1 r
.45306 .44085 m
.45745 .4485 L
s
.4603 .45345 m
.46195 .45632 L
s
.41973 .45314 m
.45306 .44085 L
s
.308 .449 .863 r
.46295 .43787 m .46764 .44283 L .45836 .46482 L p F P
0 0 0 r
s
.24 .35 .67 r
.67843 .4833 m
.69505 .50405 L
s
.69505 .50405 m
.71028 .51995 L
s
.683 .19 .083 r
.50071 .57765 m .51782 .57211 L .51707 .55142 L p F P
0 0 0 r
s
.683 .19 .083 r
.53361 .54597 m .51707 .55142 L .51782 .57211 L p F P
0 0 0 r
s
.731 .205 .09 r
.51707 .55142 m .53361 .54597 L .53138 .52457 L p F P
0 0 0 r
s
.83 .24 .1 r
.49479 .54388 m
.52893 .53248 L
s
.774 .219 .095 r
.54257 .49788 m .52846 .50272 L .53138 .52457 L p F P
0 0 0 r
s
.83 .24 .1 r
.52164 .50494 m
.52893 .53248 L
s
.813 .232 .1 r
.52846 .50272 m .54257 .49788 L .53723 .4765 L p F P
0 0 0 r
s
.813 .232 .1 r
.53723 .4765 m .5249 .48081 L .52846 .50272 L p F P
0 0 0 r
s
.917 .266 .114 r
.48468 .44983 m .49248 .447 L .49484 .42474 L p F P
0 0 0 r
s
.917 .266 .114 r
.49484 .42474 m .48946 .42672 L .48468 .44983 L p F P
0 0 0 r
s
.24 .35 .67 r
.49331 .43918 m
.4985 .44482 L
s
.625 .171 .076 r
.48344 .60246 m .50072 .59697 L .50071 .57765 L p F P
0 0 0 r
s
.625 .171 .076 r
.51782 .57211 m .50071 .57765 L .50072 .59697 L p F P
0 0 0 r
s
.83 .24 .1 r
.4992 .57069 m
.50071 .59608 L
s
.43834 .4206 m
.40482 .43322 L
s
.40482 .43322 m
.389 .41719 L
s
.42541 .65996 m
.43093 .64037 L
s
.24 .35 .67 r
.55924 .74215 m
.53831 .73262 L
s
.51892 .71585 m
.53831 .73262 L
s
.83 .24 .1 r
.31682 .70568 m
.30393 .71638 L
s
.34946 .6958 m
.31682 .70568 L
s
.307 .441 .834 r
.42598 .49335 m .43456 .50177 L .42783 .52354 L p F P
0 0 0 r
s
.24 .35 .67 r
.43024 .5339 m
.44307 .50952 L
s
.309 .446 .849 r
.43456 .50177 m .42598 .49335 L .43531 .47247 L p F P
0 0 0 r
s
.309 .446 .849 r
.43531 .47247 m .44275 .47997 L .43456 .50177 L p F P
0 0 0 r
s
.849 .243 .105 r
.5249 .48081 m .53723 .4765 L .53102 .45559 L p F P
0 0 0 r
s
.849 .243 .105 r
.53102 .45559 m .52076 .45925 L .5249 .48081 L p F P
0 0 0 r
s
.283 .397 .733 r
.43901 .60393 m .42843 .5944 L .42982 .57508 L p F P
0 0 0 r
s
.264 .365 .665 r
.44956 .63042 m .43919 .62123 L .43901 .60393 L p F P
0 0 0 r
s
.24 .35 .67 r
.43956 .60298 m
.45059 .61292 L
s
.264 .365 .665 r
.42843 .5944 m .43901 .60393 L .43919 .62123 L p F P
0 0 0 r
s
.883 .255 .11 r
.51056 .46288 m .52076 .45925 L .51612 .43843 L p F P
0 0 0 r
s
.883 .255 .11 r
.51612 .43843 m .5082 .4413 L .51056 .46288 L p F P
0 0 0 r
s
.83 .24 .1 r
.50035 .45196 m
.51201 .4778 L
s
.731 .205 .09 r
.54697 .51933 m .53138 .52457 L .53361 .54597 L p F P
0 0 0 r
s
.774 .219 .095 r
.53138 .52457 m .54697 .51933 L .54257 .49788 L p F P
0 0 0 r
s
.31 .449 .858 r
.44275 .47997 m .43531 .47247 L .44612 .45218 L p F P
0 0 0 r
s
.31 .449 .858 r
.44612 .45218 m .45227 .45853 L .44275 .47997 L p F P
0 0 0 r
s
.305 .447 .863 r
.47229 .44776 m .46764 .44283 L .47779 .42183 L p F P
0 0 0 r
s
.305 .447 .863 r
.47779 .42183 m .48096 .42527 L .47229 .44776 L p F P
0 0 0 r
s
.464 .121 .054 r
.46644 .62513 m .44956 .63042 L .45086 .64493 L p F P
0 0 0 r
s
.24 .35 .67 r
.45557 .63895 m
.46213 .64475 L
s
.234 .317 .566 r
.43919 .62123 m .44956 .63042 L .45086 .64493 L p F P
0 0 0 r
s
.83 .24 .1 r
.43093 .64037 m
.44626 .63559 L
s
.303 .432 .811 r
.41831 .51442 m .42783 .52354 L .4227 .54489 L p F P
0 0 0 r
s
.307 .441 .834 r
.42783 .52354 m .41831 .51442 L .42598 .49335 L p F P
0 0 0 r
s
.917 .266 .114 r
.49248 .447 m .50033 .44416 L .50022 .42275 L p F P
0 0 0 r
s
.917 .266 .114 r
.50022 .42275 m .49484 .42474 L .49248 .447 L p F P
0 0 0 r
s
.554 .149 .066 r
.46644 .62513 m .48349 .61979 L .48344 .60246 L p F P
0 0 0 r
s
.554 .149 .066 r
.50072 .59697 m .48344 .60246 L .48349 .61979 L p F P
0 0 0 r
s
.283 .397 .733 r
.41928 .56541 m .42982 .57508 L .42843 .5944 L p F P
0 0 0 r
s
.295 .418 .779 r
.42982 .57508 m .41928 .56541 L .4227 .54489 L p F P
0 0 0 r
s
.24 .35 .67 r
.74241 .58311 m
.75798 .6022 L
s
.75797 .62739 m
.75798 .6022 L
s
.83 .24 .1 r
.389 .41719 m
.35589 .42987 L
s
.35589 .42987 m
.3394 .4188 L
s
.25751 .43872 m
.22568 .4512 L
s
.20913 .45184 m
.22568 .4512 L
s
.24 .35 .67 r
.64201 .45071 m
.65933 .47212 L
s
.65933 .47212 m
.67843 .4833 L
s
.883 .255 .11 r
.52076 .45925 m .53102 .45559 L .52407 .43555 L p F P
0 0 0 r
s
.24 .35 .67 r
.52687 .43566 m
.55217 .4265 L
s
.883 .255 .11 r
.52407 .43555 m .51612 .43843 L .52076 .45925 L p F P
0 0 0 r
s
.774 .219 .095 r
.5568 .493 m .54257 .49788 L .54697 .51933 L p F P
0 0 0 r
s
.813 .232 .1 r
.54257 .49788 m .5568 .493 L .54964 .47216 L p F P
0 0 0 r
s
.813 .232 .1 r
.54964 .47216 m .53723 .4765 L .54257 .49788 L p F P
0 0 0 r
s
.849 .243 .105 r
.53723 .4765 m .54964 .47216 L .54134 .45192 L p F P
0 0 0 r
s
.849 .243 .105 r
.54134 .45192 m .53102 .45559 L .53723 .4765 L p F P
0 0 0 r
s
.308 .449 .863 r
.45227 .45853 m .44612 .45218 L .45822 .43286 L p F P
0 0 0 r
s
.83 .24 .1 r
.45306 .44085 m
.45326 .44078 L
s
.308 .449 .863 r
.45822 .43286 m .46295 .43787 L .45227 .45853 L p F P
0 0 0 r
s
.24 .35 .67 r
.45965 .44515 m
.47586 .46218 L
s
.683 .19 .083 r
.51782 .57211 m .5351 .56651 L .53361 .54597 L p F P
0 0 0 r
s
.83 .24 .1 r
.52893 .53248 m
.53361 .55948 L
s
.683 .19 .083 r
.55032 .54046 m .53361 .54597 L .5351 .56651 L p F P
0 0 0 r
s
.731 .205 .09 r
.53361 .54597 m .55032 .54046 L .54697 .51933 L p F P
0 0 0 r
s
.917 .266 .114 r
.50033 .44416 m .5082 .4413 L .50563 .42076 L p F P
0 0 0 r
s
.917 .266 .114 r
.50563 .42076 m .50022 .42275 L .50033 .44416 L p F P
0 0 0 r
s
.24 .35 .67 r
.51892 .71585 m
.50189 .70163 L
s
.48178 .68424 m
.50189 .70163 L
s
.83 .24 .1 r
.38277 .68572 m
.39187 .67024 L
s
.42541 .65996 m
.39187 .67024 L
s
.625 .171 .076 r
.50072 .59697 m .51817 .59142 L .51782 .57211 L p F P
0 0 0 r
s
.625 .171 .076 r
.5351 .56651 m .51782 .57211 L .51817 .59142 L p F P
0 0 0 r
s
.83 .24 .1 r
.4992 .57069 m
.53361 .55948 L
s
.295 .418 .779 r
.41246 .53529 m .4227 .54489 L .41928 .56541 L p F P
0 0 0 r
s
.24 .35 .67 r
.42188 .559 m
.44276 .5783 L
s
.303 .432 .811 r
.4227 .54489 m .41246 .53529 L .41831 .51442 L p F P
0 0 0 r
s
.24 .35 .67 r
.42188 .559 m
.43024 .5339 L
s
.55217 .4265 m
.57746 .42208 L
s
.305 .447 .863 r
.46764 .44283 m .46295 .43787 L .4746 .41836 L p F P
0 0 0 r
s
.83 .24 .1 r
.46249 .43738 m
.46345 .43702 L
s
.305 .447 .863 r
.4746 .41836 m .47779 .42183 L .46764 .44283 L p F P
0 0 0 r
s
.731 .205 .09 r
.56269 .51404 m .54697 .51933 L .55032 .54046 L p F P
0 0 0 r
s
.774 .219 .095 r
.54697 .51933 m .56269 .51404 L .5568 .493 L p F P
0 0 0 r
s
.83 .24 .1 r
.52164 .50494 m
.55628 .49306 L
s
.24 .35 .67 r
.60167 .76276 m
.62746 .76154 L
s
.58328 .74641 m
.60167 .76276 L
s
.464 .121 .054 r
.45086 .64493 m .46731 .63986 L .46644 .62513 L p F P
0 0 0 r
s
.24 .35 .67 r
.46213 .64475 m
.46943 .66603 L
s
.464 .121 .054 r
.48349 .61979 m .46644 .62513 L .46731 .63986 L p F P
0 0 0 r
s
.83 .24 .1 r
.46471 .62983 m
.46665 .60692 L
s
.917 .266 .114 r
.5082 .4413 m .51612 .43843 L .51105 .41876 L p F P
0 0 0 r
s
.917 .266 .114 r
.51105 .41876 m .50563 .42076 L .5082 .4413 L p F P
0 0 0 r
s
.883 .255 .11 r
.53102 .45559 m .54134 .45192 L .53206 .43265 L p F P
0 0 0 r
s
.883 .255 .11 r
.53206 .43265 m .52407 .43555 L .53102 .45559 L p F P
0 0 0 r
s
.554 .149 .066 r
.48349 .61979 m .50072 .6144 L .50072 .59697 L p F P
0 0 0 r
s
.83 .24 .1 r
.46665 .60692 m
.50071 .59608 L
s
.554 .149 .066 r
.51817 .59142 m .50072 .59697 L .50072 .6144 L p F P
0 0 0 r
s
.83 .24 .1 r
.3394 .4188 m
.30662 .43152 L
s
.30662 .43152 m
.28999 .42599 L
s
.309 .446 .849 r
.42777 .46489 m .43531 .47247 L .42598 .49335 L p F P
0 0 0 r
s
.31 .449 .858 r
.43531 .47247 m .42777 .46489 L .43991 .44577 L p F P
0 0 0 r
s
.31 .449 .858 r
.43991 .44577 m .44612 .45218 L .43531 .47247 L p F P
0 0 0 r
s
.24 .35 .67 r
.43924 .46586 m
.45982 .48675 L
s
.307 .441 .834 r
.41728 .48481 m .42598 .49335 L .41831 .51442 L p F P
0 0 0 r
s
.309 .446 .849 r
.42598 .49335 m .41728 .48481 L .42777 .46489 L p F P
0 0 0 r
s
.24 .35 .67 r
.42213 .48896 m
.44307 .50952 L
s
.813 .232 .1 r
.56215 .46779 m .54964 .47216 L .5568 .493 L p F P
0 0 0 r
s
.849 .243 .105 r
.54964 .47216 m .56215 .46779 L .55173 .44822 L p F P
0 0 0 r
s
.849 .243 .105 r
.55173 .44822 m .54134 .45192 L .54964 .47216 L p F P
0 0 0 r
s
.83 .24 .1 r
.51201 .4778 m
.54656 .46565 L
s
.774 .219 .095 r
.57115 .48808 m .5568 .493 L .56269 .51404 L p F P
0 0 0 r
s
.813 .232 .1 r
.5568 .493 m .57115 .48808 L .56215 .46779 L p F P
0 0 0 r
s
.24 .35 .67 r
.72091 .53997 m
.73695 .55992 L
s
.73695 .55992 m
.74241 .58311 L
s
.43924 .46586 m
.45965 .44515 L
s
.949 .277 .119 r
.48411 .42869 m .48946 .42672 L .4946 .40477 L p F P
0 0 0 r
s
.949 .277 .119 r
.4946 .40477 m .49185 .4058 L .48411 .42869 L p F P
0 0 0 r
s
.3 .442 .859 r
.48411 .42869 m .48096 .42527 L .49025 .40402 L p F P
0 0 0 r
s
.3 .442 .859 r
.49025 .40402 m .49185 .4058 L .48411 .42869 L p F P
0 0 0 r
s
.24 .35 .67 r
.48261 .42756 m
.48611 .43136 L
s
.83 .24 .1 r
.4811 .43051 m
.48705 .42832 L
s
.48705 .42832 m
.50035 .45196 L
s
.24 .35 .67 r
.61987 .44471 m
.64201 .45071 L
s
.83 .24 .1 r
.54656 .46565 m
.55628 .49306 L
s
.24 .35 .67 r
.48178 .68424 m
.46943 .66603 L
s
.42213 .48896 m
.43924 .46586 L
s
.917 .266 .114 r
.51612 .43843 m .52407 .43555 L .51649 .41675 L p F P
0 0 0 r
s
.24 .35 .67 r
.52184 .43002 m
.52611 .43481 L
s
.917 .266 .114 r
.51649 .41675 m .51105 .41876 L .51612 .43843 L p F P
0 0 0 r
s
.24 .35 .67 r
.50863 .4152 m
.51162 .41855 L
s
.683 .19 .083 r
.5351 .56651 m .55255 .56086 L .55032 .54046 L p F P
0 0 0 r
s
.683 .19 .083 r
.56718 .53489 m .55032 .54046 L .55255 .56086 L p F P
0 0 0 r
s
.731 .205 .09 r
.55032 .54046 m .56718 .53489 L .56269 .51404 L p F P
0 0 0 r
s
.305 .447 .863 r
.46295 .43787 m .45822 .43286 L .4714 .41488 L p F P
0 0 0 r
s
.305 .447 .863 r
.4714 .41488 m .4746 .41836 L .46295 .43787 L p F P
0 0 0 r
s
.24 .35 .67 r
.45965 .44515 m
.48261 .42756 L
s
.308 .449 .863 r
.44612 .45218 m .43991 .44577 L .45346 .42781 L p F P
0 0 0 r
s
.83 .24 .1 r
.45056 .43742 m
.45306 .44085 L
s
.308 .449 .863 r
.45346 .42781 m .45822 .43286 L .44612 .45218 L p F P
0 0 0 r
s
.83 .24 .1 r
.43834 .4206 m
.44842 .43448 L
s
.283 .397 .733 r
.42843 .5944 m .41766 .5847 L .41928 .56541 L p F P
0 0 0 r
s
.264 .365 .665 r
.43919 .62123 m .42864 .61188 L .42843 .5944 L p F P
0 0 0 r
s
.264 .365 .665 r
.41766 .5847 m .42843 .5944 L .42864 .61188 L p F P
0 0 0 r
s
.303 .432 .811 r
.40865 .50516 m .41831 .51442 L .41246 .53529 L p F P
0 0 0 r
s
.307 .441 .834 r
.41831 .51442 m .40865 .50516 L .41728 .48481 L p F P
0 0 0 r
s
.883 .255 .11 r
.54134 .45192 m .55173 .44822 L .54008 .42974 L p F P
0 0 0 r
s
.883 .255 .11 r
.54008 .42974 m .53206 .43265 L .54134 .45192 L p F P
0 0 0 r
s
.83 .24 .1 r
.50035 .45196 m
.53493 .4395 L
s
.625 .171 .076 r
.51817 .59142 m .5358 .58581 L .5351 .56651 L p F P
0 0 0 r
s
.625 .171 .076 r
.55255 .56086 m .5351 .56651 L .5358 .58581 L p F P
0 0 0 r
s
.83 .24 .1 r
.53361 .55948 m
.53547 .58501 L
s
.949 .277 .119 r
.48946 .42672 m .49484 .42474 L .49736 .40374 L p F P
0 0 0 r
s
.949 .277 .119 r
.49736 .40374 m .4946 .40477 L .48946 .42672 L p F P
0 0 0 r
s
.731 .205 .09 r
.57856 .50871 m .56269 .51404 L .56718 .53489 L p F P
0 0 0 r
s
.83 .24 .1 r
.52893 .53248 m
.56375 .52084 L
s
.774 .219 .095 r
.56269 .51404 m .57856 .50871 L .57115 .48808 L p F P
0 0 0 r
s
.83 .24 .1 r
.55628 .49306 m
.56375 .52084 L
s
.234 .317 .566 r
.45086 .64493 m .44077 .63611 L .43919 .62123 L p F P
0 0 0 r
s
.83 .24 .1 r
.44943 .6346 m
.46471 .62983 L
s
.24 .35 .67 r
.4415 .62652 m
.45087 .6348 L
s
.234 .317 .566 r
.42864 .61188 m .43919 .62123 L .44077 .63611 L p F P
0 0 0 r
s
.24 .35 .67 r
.43956 .60298 m
.4415 .62652 L
s
.83 .24 .1 r
.337 .70644 m
.34946 .6958 L
s
.38277 .68572 m
.34946 .6958 L
s
.283 .397 .733 r
.40855 .55556 m .41928 .56541 L .41766 .5847 L p F P
0 0 0 r
s
.295 .418 .779 r
.41928 .56541 m .40855 .55556 L .41246 .53529 L p F P
0 0 0 r
s
.24 .35 .67 r
.41842 .58391 m
.42188 .559 L
s
.3 .442 .859 r
.48096 .42527 m .47779 .42183 L .48864 .40223 L p F P
0 0 0 r
s
.3 .442 .859 r
.48864 .40223 m .49025 .40402 L .48096 .42527 L p F P
0 0 0 r
s
.83 .24 .1 r
.48176 .42082 m
.48705 .42832 L
s
.24 .35 .67 r
.48261 .42756 m
.49165 .42251 L
s
.917 .266 .114 r
.52407 .43555 m .53206 .43265 L .52195 .41474 L p F P
0 0 0 r
s
.917 .266 .114 r
.52195 .41474 m .51649 .41675 L .52407 .43555 L p F P
0 0 0 r
s
.813 .232 .1 r
.57474 .46339 m .56215 .46779 L .57115 .48808 L p F P
0 0 0 r
s
.849 .243 .105 r
.56215 .46779 m .57474 .46339 L .56217 .4445 L p F P
0 0 0 r
s
.849 .243 .105 r
.56217 .4445 m .55173 .44822 L .56215 .46779 L p F P
0 0 0 r
s
.949 .277 .119 r
.49484 .42474 m .50022 .42275 L .50011 .40271 L p F P
0 0 0 r
s
.949 .277 .119 r
.50011 .40271 m .49736 .40374 L .49484 .42474 L p F P
0 0 0 r
s
.464 .121 .054 r
.46731 .63986 m .48392 .63473 L .48349 .61979 L p F P
0 0 0 r
s
.464 .121 .054 r
.50072 .6144 m .48349 .61979 L .48392 .63473 L p F P
0 0 0 r
s
.774 .219 .095 r
.58561 .48312 m .57115 .48808 L .57856 .50871 L p F P
0 0 0 r
s
.813 .232 .1 r
.57115 .48808 m .58561 .48312 L .57474 .46339 L p F P
0 0 0 r
s
.554 .149 .066 r
.50072 .6144 m .51812 .60895 L .51817 .59142 L p F P
0 0 0 r
s
.554 .149 .066 r
.5358 .58581 m .51817 .59142 L .51812 .60895 L p F P
0 0 0 r
s
.24 .35 .67 r
.74224 .60854 m
.75797 .62739 L
s
.75223 .65357 m
.75797 .62739 L
s
.6937 .4992 m
.71028 .51995 L
s
.71028 .51995 m
.72091 .53997 L
s
.58328 .74641 m
.55924 .74215 L
s
.53999 .72534 m
.55924 .74215 L
s
.883 .255 .11 r
.55173 .44822 m .56217 .4445 L .54814 .42682 L p F P
0 0 0 r
s
.883 .255 .11 r
.54814 .42682 m .54008 .42974 L .55173 .44822 L p F P
0 0 0 r
s
.83 .24 .1 r
.53493 .4395 m
.54656 .46565 L
s
.42279 .40425 m
.389 .41719 L
s
.389 .41719 m
.37284 .40581 L
s
.949 .277 .119 r
.50022 .42275 m .50563 .42076 L .50288 .40167 L p F P
0 0 0 r
s
.949 .277 .119 r
.50288 .40167 m .50011 .40271 L .50022 .42275 L p F P
0 0 0 r
s
.343 .084 .039 r
.46731 .63986 m .45086 .64493 L .45333 .65648 L p F P
0 0 0 r
s
.188 .246 .422 r
.44077 .63611 m .45086 .64493 L .45333 .65648 L p F P
0 0 0 r
s
.305 .447 .863 r
.45822 .43286 m .45346 .42781 L .46818 .41138 L p F P
0 0 0 r
s
.305 .447 .863 r
.46818 .41138 m .4714 .41488 L .45822 .43286 L p F P
0 0 0 r
s
.83 .24 .1 r
.28999 .42599 m
.25751 .43872 L
s
.25751 .43872 m
.24134 .43916 L
s
.917 .266 .114 r
.53206 .43265 m .54008 .42974 L .52742 .41272 L p F P
0 0 0 r
s
.917 .266 .114 r
.52742 .41272 m .52195 .41474 L .53206 .43265 L p F P
0 0 0 r
s
.295 .418 .779 r
.40204 .52554 m .41246 .53529 L .40855 .55556 L p F P
0 0 0 r
s
.303 .432 .811 r
.41246 .53529 m .40204 .52554 L .40865 .50516 L p F P
0 0 0 r
s
.24 .35 .67 r
.40896 .51364 m
.43024 .5339 L
s
.3 .442 .859 r
.47779 .42183 m .4746 .41836 L .48703 .40043 L p F P
0 0 0 r
s
.3 .442 .859 r
.48703 .40043 m .48864 .40223 L .47779 .42183 L p F P
0 0 0 r
s
.309 .446 .849 r
.42014 .45721 m .42777 .46489 L .41728 .48481 L p F P
0 0 0 r
s
.31 .449 .858 r
.42777 .46489 m .42014 .45721 L .43363 .43928 L p F P
0 0 0 r
s
.31 .449 .858 r
.43363 .43928 m .43991 .44577 L .42777 .46489 L p F P
0 0 0 r
s
.683 .19 .083 r
.55255 .56086 m .57019 .55515 L .56718 .53489 L p F P
0 0 0 r
s
.683 .19 .083 r
.58422 .52928 m .56718 .53489 L .57019 .55515 L p F P
0 0 0 r
s
.731 .205 .09 r
.56718 .53489 m .58422 .52928 L .57856 .50871 L p F P
0 0 0 r
s
.83 .24 .1 r
.56375 .52084 m
.56871 .54804 L
s
.731 .205 .09 r
.59457 .50333 m .57856 .50871 L .58422 .52928 L p F P
0 0 0 r
s
.774 .219 .095 r
.57856 .50871 m .59457 .50333 L .58561 .48312 L p F P
0 0 0 r
s
.949 .277 .119 r
.50563 .42076 m .51105 .41876 L .50565 .40063 L p F P
0 0 0 r
s
.949 .277 .119 r
.50565 .40063 m .50288 .40167 L .50563 .42076 L p F P
0 0 0 r
s
.83 .24 .1 r
.41677 .67543 m
.42541 .65996 L
s
.308 .449 .863 r
.43991 .44577 m .43363 .43928 L .44865 .42272 L p F P
0 0 0 r
s
.308 .449 .863 r
.44865 .42272 m .45346 .42781 L .43991 .44577 L p F P
0 0 0 r
s
.307 .441 .834 r
.40846 .47615 m .41728 .48481 L .40865 .50516 L p F P
0 0 0 r
s
.24 .35 .67 r
.40896 .51364 m
.42213 .48896 L
s
.309 .446 .849 r
.41728 .48481 m .40846 .47615 L .42014 .45721 L p F P
0 0 0 r
s
.625 .171 .076 r
.5358 .58581 m .55361 .58014 L .55255 .56086 L p F P
0 0 0 r
s
.625 .171 .076 r
.57019 .55515 m .55255 .56086 L .55361 .58014 L p F P
0 0 0 r
s
.83 .24 .1 r
.53361 .55948 m
.56871 .54804 L
s
.813 .232 .1 r
.58743 .45896 m .57474 .46339 L .58561 .48312 L p F P
0 0 0 r
s
.849 .243 .105 r
.57474 .46339 m .58743 .45896 L .57268 .44076 L p F P
0 0 0 r
s
.849 .243 .105 r
.57268 .44076 m .56217 .4445 L .57474 .46339 L p F P
0 0 0 r
s
.883 .255 .11 r
.56217 .4445 m .57268 .44076 L .55624 .42388 L p F P
0 0 0 r
s
.883 .255 .11 r
.55624 .42388 m .54814 .42682 L .56217 .4445 L p F P
0 0 0 r
s
.917 .266 .114 r
.54008 .42974 m .54814 .42682 L .53291 .41069 L p F P
0 0 0 r
s
.917 .266 .114 r
.53291 .41069 m .52742 .41272 L .54008 .42974 L p F P
0 0 0 r
s
.24 .35 .67 r
.62746 .76154 m
.65397 .75463 L
s
.60935 .74501 m
.62746 .76154 L
s
.774 .219 .095 r
.6002 .47813 m .58561 .48312 L .59457 .50333 L p F P
0 0 0 r
s
.813 .232 .1 r
.58561 .48312 m .6002 .47813 L .58743 .45896 L p F P
0 0 0 r
s
.83 .24 .1 r
.55628 .49306 m
.59162 .48095 L
s
.949 .277 .119 r
.51105 .41876 m .51649 .41675 L .50842 .3996 L p F P
0 0 0 r
s
.949 .277 .119 r
.50842 .3996 m .50565 .40063 L .51105 .41876 L p F P
0 0 0 r
s
.3 .442 .859 r
.4746 .41836 m .4714 .41488 L .48541 .39863 L p F P
0 0 0 r
s
.3 .442 .859 r
.48541 .39863 m .48703 .40043 L .4746 .41836 L p F P
0 0 0 r
s
.464 .121 .054 r
.48392 .63473 m .5007 .62955 L .50072 .6144 L p F P
0 0 0 r
s
.83 .24 .1 r
.46471 .62983 m
.49918 .61908 L
s
.464 .121 .054 r
.51812 .60895 m .50072 .6144 L .5007 .62955 L p F P
0 0 0 r
s
.83 .24 .1 r
.49918 .61908 m
.50071 .59608 L
s
.24 .35 .67 r
.66121 .4618 m
.67843 .4833 L
s
.67843 .4833 m
.6937 .4992 L
s
.83 .24 .1 r
.30393 .71638 m
.28849 .72158 L
s
.337 .70644 m
.30393 .71638 L
s
.554 .149 .066 r
.51812 .60895 m .53569 .60345 L .5358 .58581 L p F P
0 0 0 r
s
.83 .24 .1 r
.50071 .59608 m
.53547 .58501 L
s
.554 .149 .066 r
.55361 .58014 m .5358 .58581 L .53569 .60345 L p F P
0 0 0 r
s
.305 .447 .863 r
.45346 .42781 m .44865 .42272 L .46494 .40786 L p F P
0 0 0 r
s
.83 .24 .1 r
.43834 .4206 m
.45984 .41251 L
s
.305 .447 .863 r
.46494 .40786 m .46818 .41138 L .45346 .42781 L p F P
0 0 0 r
s
.83 .24 .1 r
.37284 .40581 m
.3394 .4188 L
s
.3394 .4188 m
.32313 .41301 L
s
.303 .432 .811 r
.39883 .49575 m .40865 .50516 L .40204 .52554 L p F P
0 0 0 r
s
.307 .441 .834 r
.40865 .50516 m .39883 .49575 L .40846 .47615 L p F P
0 0 0 r
s
.24 .35 .67 r
.53999 .72534 m
.51892 .71585 L
s
.49885 .69848 m
.51892 .71585 L
s
.949 .277 .119 r
.51649 .41675 m .52195 .41474 L .51119 .39856 L p F P
0 0 0 r
s
.24 .35 .67 r
.51392 .4113 m
.51481 .41097 L
s
.949 .277 .119 r
.51119 .39856 m .50842 .3996 L .51649 .41675 L p F P
0 0 0 r
s
.83 .24 .1 r
.48705 .42832 m
.52174 .41553 L
s
.343 .084 .039 r
.45333 .65648 m .46896 .65171 L .46731 .63986 L p F P
0 0 0 r
s
.24 .35 .67 r
.45714 .65532 m
.46943 .66603 L
s
.83 .24 .1 r
.45963 .64947 m
.46471 .62983 L
s
.343 .084 .039 r
.48392 .63473 m .46731 .63986 L .46896 .65171 L p F P
0 0 0 r
s
.917 .266 .114 r
.54814 .42682 m .55624 .42388 L .53842 .40866 L p F P
0 0 0 r
s
.917 .266 .114 r
.53842 .40866 m .53291 .41069 L .54814 .42682 L p F P
0 0 0 r
s
.24 .35 .67 r
.53421 .40573 m
.53715 .40913 L
s
.83 .24 .1 r
.52174 .41553 m
.53493 .4395 L
s
.283 .397 .733 r
.41766 .5847 m .4067 .57483 L .40855 .55556 L p F P
0 0 0 r
s
.264 .365 .665 r
.42864 .61188 m .41791 .60236 L .41766 .5847 L p F P
0 0 0 r
s
.264 .365 .665 r
.4067 .57483 m .41766 .5847 L .41791 .60236 L p F P
0 0 0 r
s
.813 .232 .1 r
.60021 .45449 m .58743 .45896 L .6002 .47813 L p F P
0 0 0 r
s
.849 .243 .105 r
.58743 .45896 m .60021 .45449 L .58326 .43699 L p F P
0 0 0 r
s
.849 .243 .105 r
.58326 .43699 m .57268 .44076 L .58743 .45896 L p F P
0 0 0 r
s
.83 .24 .1 r
.54656 .46565 m
.58182 .45325 L
s
.883 .255 .11 r
.57268 .44076 m .58326 .43699 L .56438 .42093 L p F P
0 0 0 r
s
.883 .255 .11 r
.56438 .42093 m .55624 .42388 L .57268 .44076 L p F P
0 0 0 r
s
.83 .24 .1 r
.58182 .45325 m
.59162 .48095 L
s
.234 .317 .566 r
.44077 .63611 m .43052 .62713 L .42864 .61188 L p F P
0 0 0 r
s
.234 .317 .566 r
.41791 .60236 m .42864 .61188 L .43052 .62713 L p F P
0 0 0 r
s
.24 .35 .67 r
.41842 .58391 m
.43956 .60298 L
s
.683 .19 .083 r
.57019 .55515 m .588 .54939 L .58422 .52928 L p F P
0 0 0 r
s
.683 .19 .083 r
.60141 .5236 m .58422 .52928 L .588 .54939 L p F P
0 0 0 r
s
.731 .205 .09 r
.58422 .52928 m .60141 .5236 L .59457 .50333 L p F P
0 0 0 r
s
.731 .205 .09 r
.61072 .49789 m .59457 .50333 L .60141 .5236 L p F P
0 0 0 r
s
.83 .24 .1 r
.56375 .52084 m
.59929 .50897 L
s
.774 .219 .095 r
.59457 .50333 m .61072 .49789 L .6002 .47813 L p F P
0 0 0 r
s
.83 .24 .1 r
.59162 .48095 m
.59929 .50897 L
s
.3 .442 .859 r
.4714 .41488 m .46818 .41138 L .48379 .39682 L p F P
0 0 0 r
s
.83 .24 .1 r
.47444 .41044 m
.47479 .41094 L
s
.3 .442 .859 r
.48379 .39682 m .48541 .39863 L .4714 .41488 L p F P
0 0 0 r
s
.83 .24 .1 r
.4668 .40989 m
.47178 .40802 L
s
.949 .277 .119 r
.52195 .41474 m .52742 .41272 L .51397 .39751 L p F P
0 0 0 r
s
.24 .35 .67 r
.51853 .40959 m
.51941 .40926 L
s
.949 .277 .119 r
.51397 .39751 m .51119 .39856 L .52195 .41474 L p F P
0 0 0 r
s
.283 .397 .733 r
.39763 .54555 m .40855 .55556 L .4067 .57483 L p F P
0 0 0 r
s
.295 .418 .779 r
.40855 .55556 m .39763 .54555 L .40204 .52554 L p F P
0 0 0 r
s
.24 .35 .67 r
.72628 .56333 m
.74241 .58311 L
s
.74241 .58311 m
.74224 .60854 L
s
.31 .449 .858 r
.42728 .43273 m .43363 .43928 L .42014 .45721 L p F P
0 0 0 r
s
.308 .449 .863 r
.43363 .43928 m .42728 .43273 L .44381 .4176 L p F P
0 0 0 r
s
.308 .449 .863 r
.44381 .4176 m .44865 .42272 L .43363 .43928 L p F P
0 0 0 r
s
.83 .24 .1 r
.42279 .40425 m
.43834 .4206 L
s
.625 .171 .076 r
.55361 .58014 m .57161 .57442 L .57019 .55515 L p F P
0 0 0 r
s
.625 .171 .076 r
.588 .54939 m .57019 .55515 L .57161 .57442 L p F P
0 0 0 r
s
.83 .24 .1 r
.56871 .54804 m
.57094 .57372 L
s
.309 .446 .849 r
.41241 .44943 m .42014 .45721 L .40846 .47615 L p F P
0 0 0 r
s
.31 .449 .858 r
.42014 .45721 m .41241 .44943 L .42728 .43273 L p F P
0 0 0 r
s
.774 .219 .095 r
.6149 .47308 m .6002 .47813 L .61072 .49789 L p F P
0 0 0 r
s
.813 .232 .1 r
.6002 .47813 m .6149 .47308 L .60021 .45449 L p F P
0 0 0 r
s
.83 .24 .1 r
.24134 .43916 m
.20913 .45184 L
s
.19413 .4584 m
.20913 .45184 L
s
.37075 .69629 m
.38277 .68572 L
s
.41677 .67543 m
.38277 .68572 L
s
.917 .266 .114 r
.55624 .42388 m .56438 .42093 L .54394 .40662 L p F P
0 0 0 r
s
.917 .266 .114 r
.54394 .40662 m .53842 .40866 L .55624 .42388 L p F P
0 0 0 r
s
.24 .35 .67 r
.73626 .63504 m
.75223 .65357 L
s
.74091 .67945 m
.75223 .65357 L
s
.949 .277 .119 r
.52742 .41272 m .53291 .41069 L .51676 .39647 L p F P
0 0 0 r
s
.24 .35 .67 r
.52314 .40788 m
.52403 .40755 L
s
.949 .277 .119 r
.51676 .39647 m .51397 .39751 L .52742 .41272 L p F P
0 0 0 r
s
.982 .288 .123 r
.5 .38446 m .49185 .4058 L .4946 .40477 L closepath p F P
0 0 0 r
s
.293 .434 .848 r
.5 .38446 m .49185 .4058 L .49025 .40402 L closepath p F P
0 0 0 r
s
.305 .447 .863 r
.44865 .42272 m .44381 .4176 L .46168 .40433 L p F P
0 0 0 r
s
.305 .447 .863 r
.46168 .40433 m .46494 .40786 L .44865 .42272 L p F P
0 0 0 r
s
.188 .246 .422 r
.45333 .65648 m .44377 .64819 L .44077 .63611 L p F P
0 0 0 r
s
.24 .35 .67 r
.44866 .64794 m
.4534 .65206 L
s
.83 .24 .1 r
.45186 .65185 m
.45963 .64947 L
s
.42541 .65996 m
.449 .65273 L
s
.188 .246 .422 r
.43052 .62713 m .44077 .63611 L .44377 .64819 L p F P
0 0 0 r
s
.24 .35 .67 r
.4415 .62652 m
.44866 .64794 L
s
.464 .121 .054 r
.5007 .62955 m .51764 .62432 L .51812 .60895 L p F P
0 0 0 r
s
.464 .121 .054 r
.53569 .60345 m .51812 .60895 L .51764 .62432 L p F P
0 0 0 r
s
.849 .243 .105 r
.59389 .4332 m .58326 .43699 L .60021 .45449 L p F P
0 0 0 r
s
.883 .255 .11 r
.58326 .43699 m .59389 .4332 L .57255 .41797 L p F P
0 0 0 r
s
.883 .255 .11 r
.57255 .41797 m .56438 .42093 L .58326 .43699 L p F P
0 0 0 r
s
.83 .24 .1 r
.5702 .42679 m
.58182 .45325 L
s
.53493 .4395 m
.5702 .42679 L
s
.307 .441 .834 r
.39951 .46737 m .40846 .47615 L .39883 .49575 L p F P
0 0 0 r
s
.309 .446 .849 r
.40846 .47615 m .39951 .46737 L .41241 .44943 L p F P
0 0 0 r
s
.24 .35 .67 r
.40045 .46767 m
.42213 .48896 L
s
.3 .442 .859 r
.46818 .41138 m .46494 .40786 L .48216 .39501 L p F P
0 0 0 r
s
.83 .24 .1 r
.47189 .40704 m
.47233 .40751 L
s
.3 .442 .859 r
.48216 .39501 m .48379 .39682 L .46818 .41138 L p F P
0 0 0 r
s
.24 .35 .67 r
.49885 .69848 m
.48178 .68424 L
s
.46096 .66623 m
.48178 .68424 L
s
.982 .288 .123 r
.5 .38446 m .4946 .40477 L .49736 .40374 L closepath p F P
0 0 0 r
s
.295 .418 .779 r
.39145 .51561 m .40204 .52554 L .39763 .54555 L p F P
0 0 0 r
s
.24 .35 .67 r
.40028 .53902 m
.42188 .559 L
s
.303 .432 .811 r
.40204 .52554 m .39145 .51561 L .39883 .49575 L p F P
0 0 0 r
s
.24 .35 .67 r
.40028 .53902 m
.40896 .51364 L
s
.813 .232 .1 r
.61308 .44999 m .60021 .45449 L .6149 .47308 L p F P
0 0 0 r
s
.849 .243 .105 r
.60021 .45449 m .61308 .44999 L .59389 .4332 L p F P
0 0 0 r
s
.554 .149 .066 r
.53569 .60345 m .55345 .59789 L .55361 .58014 L p F P
0 0 0 r
s
.554 .149 .066 r
.57161 .57442 m .55361 .58014 L .55345 .59789 L p F P
0 0 0 r
s
.949 .277 .119 r
.53291 .41069 m .53842 .40866 L .51955 .39542 L p F P
0 0 0 r
s
.24 .35 .67 r
.52777 .40617 m
.52866 .40584 L
s
.53293 .40425 m
.53417 .40568 L
s
.949 .277 .119 r
.51955 .39542 m .51676 .39647 L .53291 .41069 L p F P
0 0 0 r
s
.24 .35 .67 r
.53241 .40445 m
.53293 .40425 L
s
.293 .434 .848 r
.5 .38446 m .49025 .40402 L .48864 .40223 L closepath p F P
0 0 0 r
s
.982 .288 .123 r
.5 .38446 m .49736 .40374 L .50011 .40271 L closepath p F P
0 0 0 r
s
.917 .266 .114 r
.56438 .42093 m .57255 .41797 L .54949 .40458 L p F P
0 0 0 r
s
.917 .266 .114 r
.54949 .40458 m .54394 .40662 L .56438 .42093 L p F P
0 0 0 r
s
.343 .084 .039 r
.46896 .65171 m .48474 .6469 L .48392 .63473 L p F P
0 0 0 r
s
.343 .084 .039 r
.5007 .62955 m .48392 .63473 L .48474 .6469 L p F P
0 0 0 r
s
.24 .35 .67 r
.65397 .75463 m
.67986 .74226 L
s
.63619 .73785 m
.65397 .75463 L
s
.83 .24 .1 r
.32313 .41301 m
.28999 .42599 L
s
.28999 .42599 m
.27421 .42621 L
s
.731 .205 .09 r
.60141 .5236 m .61878 .51788 L .61072 .49789 L p F P
0 0 0 r
s
.731 .205 .09 r
.62703 .49241 m .61072 .49789 L .61878 .51788 L p F P
0 0 0 r
s
.774 .219 .095 r
.61072 .49789 m .62703 .49241 L .6149 .47308 L p F P
0 0 0 r
s
.982 .288 .123 r
.5 .38446 m .50011 .40271 L .50288 .40167 L closepath p F P
0 0 0 r
s
.683 .19 .083 r
.588 .54939 m .60599 .54356 L .60141 .5236 L p F P
0 0 0 r
s
.683 .19 .083 r
.61878 .51788 m .60141 .5236 L .60599 .54356 L p F P
0 0 0 r
s
.83 .24 .1 r
.59929 .50897 m
.60453 .53636 L
s
.24 .35 .67 r
.60935 .74501 m
.58328 .74641 L
s
.56423 .72948 m
.58328 .74641 L
s
.293 .434 .848 r
.5 .38446 m .48864 .40223 L .48703 .40043 L closepath p F P
0 0 0 r
s
.949 .277 .119 r
.53842 .40866 m .54394 .40662 L .52234 .39438 L p F P
0 0 0 r
s
.24 .35 .67 r
.53293 .40425 m
.53337 .40417 L
s
.949 .277 .119 r
.52234 .39438 m .51955 .39542 L .53842 .40866 L p F P
0 0 0 r
s
.774 .219 .095 r
.62973 .468 m .6149 .47308 L .62703 .49241 L p F P
0 0 0 r
s
.813 .232 .1 r
.6149 .47308 m .62973 .468 L .61308 .44999 L p F P
0 0 0 r
s
.982 .288 .123 r
.5 .38446 m .50288 .40167 L .50565 .40063 L closepath p F P
0 0 0 r
s
.3 .442 .859 r
.46494 .40786 m .46168 .40433 L .48053 .3932 L p F P
0 0 0 r
s
.83 .24 .1 r
.46908 .40396 m
.46952 .40444 L
s
.3 .442 .859 r
.48053 .3932 m .48216 .39501 L .46494 .40786 L p F P
0 0 0 r
s
.24 .35 .67 r
.46204 .40522 m
.48261 .42756 L
s
.849 .243 .105 r
.60459 .42939 m .59389 .4332 L .61308 .44999 L p F P
0 0 0 r
s
.883 .255 .11 r
.59389 .4332 m .60459 .42939 L .58077 .41499 L p F P
0 0 0 r
s
.24 .35 .67 r
.57834 .4221 m
.58604 .4223 L
s
.883 .255 .11 r
.58077 .41499 m .57255 .41797 L .59389 .4332 L p F P
0 0 0 r
s
.24 .35 .67 r
.59317 .42249 m
.60176 .42271 L
s
.625 .171 .076 r
.57161 .57442 m .58979 .56863 L .588 .54939 L p F P
0 0 0 r
s
.625 .171 .076 r
.60599 .54356 m .588 .54939 L .58979 .56863 L p F P
0 0 0 r
s
.83 .24 .1 r
.56871 .54804 m
.60453 .53636 L
s
.31 .449 .858 r
.42087 .42611 m .42728 .43273 L .41241 .44943 L p F P
0 0 0 r
s
.308 .449 .863 r
.42728 .43273 m .42087 .42611 L .43893 .41243 L p F P
0 0 0 r
s
.308 .449 .863 r
.43893 .41243 m .44381 .4176 L .42728 .43273 L p F P
0 0 0 r
s
.24 .35 .67 r
.43871 .42317 m
.45965 .44515 L
s
.917 .266 .114 r
.57255 .41797 m .58077 .41499 L .55505 .40253 L p F P
0 0 0 r
s
.917 .266 .114 r
.55505 .40253 m .54949 .40458 L .57255 .41797 L p F P
0 0 0 r
s
.24 .35 .67 r
.5645 .40669 m
.5651 .4074 L
s
.982 .288 .123 r
.5 .38446 m .50565 .40063 L .50842 .3996 L closepath p F P
0 0 0 r
s
.293 .434 .848 r
.5 .38446 m .48703 .40043 L .48541 .39863 L closepath p F P
0 0 0 r
s
.303 .432 .811 r
.38885 .48619 m .39883 .49575 L .39145 .51561 L p F P
0 0 0 r
s
.307 .441 .834 r
.39883 .49575 m .38885 .48619 L .39951 .46737 L p F P
0 0 0 r
s
.305 .447 .863 r
.44381 .4176 m .43893 .41243 L .4584 .40077 L p F P
0 0 0 r
s
.305 .447 .863 r
.4584 .40077 m .46168 .40433 L .44381 .4176 L p F P
0 0 0 r
s
.24 .35 .67 r
.70431 .51931 m
.72091 .53997 L
s
.72091 .53997 m
.72628 .56333 L
s
.949 .277 .119 r
.54394 .40662 m .54949 .40458 L .52514 .39333 L p F P
0 0 0 r
s
.24 .35 .67 r
.53808 .4033 m
.53901 .40313 L
s
.949 .277 .119 r
.52514 .39333 m .52234 .39438 L .54394 .40662 L p F P
0 0 0 r
s
.24 .35 .67 r
.43871 .42317 m
.46204 .40522 L
s
.813 .232 .1 r
.62605 .44546 m .61308 .44999 L .62973 .468 L p F P
0 0 0 r
s
.849 .243 .105 r
.61308 .44999 m .62605 .44546 L .60459 .42939 L p F P
0 0 0 r
s
.24 .35 .67 r
.60176 .42271 m
.61156 .43461 L
s
.982 .288 .123 r
.5 .38446 m .50842 .3996 L .51119 .39856 L closepath p F P
0 0 0 r
s
.309 .446 .849 r
.40459 .44156 m .41241 .44943 L .39951 .46737 L p F P
0 0 0 r
s
.31 .449 .858 r
.41241 .44943 m .40459 .44156 L .42087 .42611 L p F P
0 0 0 r
s
.24 .35 .67 r
.41794 .44424 m
.43871 .42317 L
s
.41794 .44424 m
.43924 .46586 L
s
.464 .121 .054 r
.51764 .62432 m .53475 .61904 L .53569 .60345 L p F P
0 0 0 r
s
.83 .24 .1 r
.49918 .61908 m
.53436 .60811 L
s
.464 .121 .054 r
.55345 .59789 m .53569 .60345 L .53475 .61904 L p F P
0 0 0 r
s
.83 .24 .1 r
.53436 .60811 m
.53547 .58501 L
s
.24 .35 .67 r
.72464 .66127 m
.74091 .67945 L
s
.7245 .70368 m
.74091 .67945 L
s
.293 .434 .848 r
.5 .38446 m .48541 .39863 L .48379 .39682 L closepath p F P
0 0 0 r
s
.229 .055 .024 r
.46896 .65171 m .45333 .65648 L .45696 .6647 L p F P
0 0 0 r
s
.147 .182 .324 r
.44377 .64819 m .45333 .65648 L .45696 .6647 L p F P
0 0 0 r
s
.982 .288 .123 r
.5 .38446 m .51119 .39856 L .51397 .39751 L closepath p F P
0 0 0 r
s
.283 .397 .733 r
.4067 .57483 m .39554 .56478 L .39763 .54555 L p F P
0 0 0 r
s
.264 .365 .665 r
.41791 .60236 m .40699 .59268 L .4067 .57483 L p F P
0 0 0 r
s
.264 .365 .665 r
.39554 .56478 m .4067 .57483 L .40699 .59268 L p F P
0 0 0 r
s
.949 .277 .119 r
.54949 .40458 m .55505 .40253 L .52795 .39228 L p F P
0 0 0 r
s
.949 .277 .119 r
.52795 .39228 m .52514 .39333 L .54949 .40458 L p F P
0 0 0 r
s
.83 .24 .1 r
.32198 .71152 m
.337 .70644 L
s
.37075 .69629 m
.337 .70644 L
s
.3 .442 .859 r
.46168 .40433 m .4584 .40077 L .4789 .39138 L p F P
0 0 0 r
s
.83 .24 .1 r
.46626 .40088 m
.4667 .40136 L
s
.3 .442 .859 r
.4789 .39138 m .48053 .3932 L .46168 .40433 L p F P
0 0 0 r
s
.883 .255 .11 r
.58902 .41199 m .58077 .41499 L .60459 .42939 L p F P
0 0 0 r
s
.917 .266 .114 r
.58077 .41499 m .58902 .41199 L .56063 .40047 L p F P
0 0 0 r
s
.917 .266 .114 r
.56063 .40047 m .55505 .40253 L .58077 .41499 L p F P
0 0 0 r
s
.554 .149 .066 r
.55345 .59789 m .57138 .59227 L .57161 .57442 L p F P
0 0 0 r
s
.83 .24 .1 r
.53547 .58501 m
.57094 .57372 L
s
.554 .149 .066 r
.58979 .56863 m .57161 .57442 L .57138 .59227 L p F P
0 0 0 r
s
.83 .24 .1 r
.40698 .39257 m
.37284 .40581 L
s
.37284 .40581 m
.35696 .39975 L
s
.234 .317 .566 r
.43052 .62713 m .42008 .618 L .41791 .60236 L p F P
0 0 0 r
s
.234 .317 .566 r
.40699 .59268 m .41791 .60236 L .42008 .618 L p F P
0 0 0 r
s
.24 .35 .67 r
.41842 .58391 m
.42014 .60765 L
s
.982 .288 .123 r
.5 .38446 m .51397 .39751 L .51676 .39647 L closepath p F P
0 0 0 r
s
.849 .243 .105 r
.61536 .42556 m .60459 .42939 L .62605 .44546 L p F P
0 0 0 r
s
.83 .24 .1 r
.58182 .45325 m
.6178 .4406 L
s
.883 .255 .11 r
.60459 .42939 m .61536 .42556 L .58902 .41199 L p F P
0 0 0 r
s
.343 .084 .039 r
.48474 .6469 m .50066 .64204 L .5007 .62955 L p F P
0 0 0 r
s
.83 .24 .1 r
.49456 .63876 m
.49918 .61908 L
s
.343 .084 .039 r
.51764 .62432 m .5007 .62955 L .50066 .64204 L p F P
0 0 0 r
s
.293 .434 .848 r
.5 .38446 m .48379 .39682 L .48216 .39501 L closepath p F P
0 0 0 r
s
.731 .205 .09 r
.61878 .51788 m .63632 .51209 L .62703 .49241 L p F P
0 0 0 r
s
.731 .205 .09 r
.64348 .48688 m .62703 .49241 L .63632 .51209 L p F P
0 0 0 r
s
.83 .24 .1 r
.59929 .50897 m
.63555 .49685 L
s
.774 .219 .095 r
.62703 .49241 m .64348 .48688 L .62973 .468 L p F P
0 0 0 r
s
.83 .24 .1 r
.59162 .48095 m
.62769 .46858 L
s
.24 .35 .67 r
.67986 .74226 m
.70379 .72498 L
s
.66246 .72517 m
.67986 .74226 L
s
.283 .397 .733 r
.38652 .53535 m .39763 .54555 L .39554 .56478 L p F P
0 0 0 r
s
.295 .418 .779 r
.39763 .54555 m .38652 .53535 L .39145 .51561 L p F P
0 0 0 r
s
.24 .35 .67 r
.39653 .56417 m
.40028 .53902 L
s
.982 .288 .123 r
.5 .38446 m .51676 .39647 L .51955 .39542 L closepath p F P
0 0 0 r
s
.774 .219 .095 r
.64468 .46288 m .62973 .468 L .64348 .48688 L p F P
0 0 0 r
s
.813 .232 .1 r
.62973 .468 m .64468 .46288 L .62605 .44546 L p F P
0 0 0 r
s
.683 .19 .083 r
.60599 .54356 m .62417 .53768 L .61878 .51788 L p F P
0 0 0 r
s
.683 .19 .083 r
.63632 .51209 m .61878 .51788 L .62417 .53768 L p F P
0 0 0 r
s
.949 .277 .119 r
.55505 .40253 m .56063 .40047 L .53075 .39123 L p F P
0 0 0 r
s
.949 .277 .119 r
.53075 .39123 m .52795 .39228 L .55505 .40253 L p F P
0 0 0 r
s
.83 .24 .1 r
.52174 .41553 m
.55714 .40248 L
s
.62769 .46858 m
.63555 .49685 L
s
.6178 .4406 m
.62769 .46858 L
s
.307 .441 .834 r
.39043 .45845 m .39951 .46737 L .38885 .48619 L p F P
0 0 0 r
s
.309 .446 .849 r
.39951 .46737 m .39043 .45845 L .40459 .44156 L p F P
0 0 0 r
s
.24 .35 .67 r
.40045 .46767 m
.41794 .44424 L
s
.982 .288 .123 r
.5 .38446 m .51955 .39542 L .52234 .39438 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.50743 .39461 m
.52174 .41553 L
s
.813 .232 .1 r
.63911 .4409 m .62605 .44546 L .64468 .46288 L p F P
0 0 0 r
s
.24 .35 .67 r
.64141 .44997 m
.64201 .45071 L
s
.849 .243 .105 r
.62605 .44546 m .63911 .4409 L .61536 .42556 L p F P
0 0 0 r
s
.308 .449 .863 r
.43401 .40721 m .43893 .41243 L .42087 .42611 L p F P
0 0 0 r
s
.305 .447 .863 r
.43893 .41243 m .43401 .40721 L .45511 .39719 L p F P
0 0 0 r
s
.305 .447 .863 r
.45511 .39719 m .4584 .40077 L .43893 .41243 L p F P
0 0 0 r
s
.293 .434 .848 r
.5 .38446 m .48216 .39501 L .48053 .3932 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.48645 .4025 m
.50743 .39461 L
s
.247 .376 .756 r
.55762 .39689 m .56063 .40047 L .58902 .41199 L p F P
0 0 0 r
s
.247 .376 .756 r
.58902 .41199 m .58471 .40678 L .55762 .39689 L p F P
0 0 0 r
s
.83 .24 .1 r
.55714 .40248 m
.5702 .42679 L
s
.217 .336 .687 r
.58471 .40678 m .58902 .41199 L .61536 .42556 L p F P
0 0 0 r
s
.188 .246 .422 r
.44377 .64819 m .43407 .63977 L .43052 .62713 L p F P
0 0 0 r
s
.188 .246 .422 r
.42008 .618 m .43052 .62713 L .43407 .63977 L p F P
0 0 0 r
s
.24 .35 .67 r
.42014 .60765 m
.4415 .62652 L
s
.70788 .68587 m
.7245 .70368 L
s
.70379 .72498 m
.7245 .70368 L
s
.625 .171 .076 r
.58979 .56863 m .60816 .56279 L .60599 .54356 L p F P
0 0 0 r
s
.625 .171 .076 r
.62417 .53768 m .60599 .54356 L .60816 .56279 L p F P
0 0 0 r
s
.83 .24 .1 r
.60453 .53636 m
.60713 .56219 L
s
.982 .288 .123 r
.5 .38446 m .52234 .39438 L .52514 .39333 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.72594 .58902 m
.74224 .60854 L
s
.74224 .60854 m
.73626 .63504 L
s
.6937 .4992 m
.70431 .51931 L
s
.3 .442 .859 r
.4584 .40077 m .45511 .39719 L .47726 .38955 L p F P
0 0 0 r
s
.83 .24 .1 r
.46343 .39778 m
.46387 .39826 L
s
.3 .442 .859 r
.47726 .38955 m .4789 .39138 L .4584 .40077 L p F P
0 0 0 r
s
.24 .35 .67 r
.56423 .72948 m
.53999 .72534 L
s
.52003 .70792 m
.53999 .72534 L
s
.31 .449 .858 r
.41439 .41942 m .42087 .42611 L .40459 .44156 L p F P
0 0 0 r
s
.308 .449 .863 r
.42087 .42611 m .41439 .41942 L .43401 .40721 L p F P
0 0 0 r
s
.83 .24 .1 r
.27421 .42621 m
.24134 .43916 L
s
.24134 .43916 m
.22674 .44557 L
s
.268 .403 .801 r
.52919 .3894 m .53075 .39123 L .56063 .40047 L p F P
0 0 0 r
s
.268 .403 .801 r
.56063 .40047 m .55762 .39689 L .52919 .3894 L p F P
0 0 0 r
s
.24 .35 .67 r
.55848 .39954 m
.56183 .40351 L
s
.54905 .40128 m
.55848 .39954 L
s
.83 .24 .1 r
.55714 .40248 m
.56336 .40019 L
s
.295 .418 .779 r
.38068 .50552 m .39145 .51561 L .38652 .53535 L p F P
0 0 0 r
s
.303 .432 .811 r
.39145 .51561 m .38068 .50552 L .38885 .48619 L p F P
0 0 0 r
s
.24 .35 .67 r
.68679 .70755 m
.70379 .72498 L
s
.83 .24 .1 r
.4052 .68593 m
.41677 .67543 L
s
.45146 .66493 m
.41677 .67543 L
s
.217 .336 .687 r
.61536 .42556 m .6099 .41886 L .58471 .40678 L p F P
0 0 0 r
s
.83 .24 .1 r
.60231 .41522 m
.6062 .41382 L
s
.5702 .42679 m
.59891 .41645 L
s
.6062 .41382 m
.60799 .41794 L
s
.174 .276 .58 r
.6099 .41886 m .61536 .42556 L .63911 .4409 L p F P
0 0 0 r
s
.83 .24 .1 r
.60953 .42151 m
.6178 .4406 L
s
.982 .288 .123 r
.5 .38446 m .52514 .39333 L .52795 .39228 L closepath p F P
0 0 0 r
s
.293 .434 .848 r
.5 .38446 m .48053 .3932 L .4789 .39138 L closepath p F P
0 0 0 r
s
.229 .055 .024 r
.45696 .6647 m .47139 .66034 L .46896 .65171 L p F P
0 0 0 r
s
.24 .35 .67 r
.45943 .66396 m
.46096 .66623 L
s
.229 .055 .024 r
.48474 .6469 m .46896 .65171 L .47139 .66034 L p F P
0 0 0 r
s
.83 .24 .1 r
.45963 .64947 m
.49456 .63876 L
s
.982 .288 .123 r
.5 .38446 m .52795 .39228 L .53075 .39123 L closepath p F P
0 0 0 r
s
.464 .121 .054 r
.53475 .61904 m .55203 .61371 L .55345 .59789 L p F P
0 0 0 r
s
.464 .121 .054 r
.57138 .59227 m .55345 .59789 L .55203 .61371 L p F P
0 0 0 r
s
.293 .434 .848 r
.5 .38446 m .4789 .39138 L .47726 .38955 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.48709 .39105 m
.4993 .40473 L
s
.283 .421 .83 r
.53075 .39123 m .52919 .3894 L .5 .38446 L closepath p F P
0 0 0 r
s
.309 .446 .849 r
.39666 .43358 m .40459 .44156 L .39043 .45845 L p F P
0 0 0 r
s
.31 .449 .858 r
.40459 .44156 m .39666 .43358 L .41439 .41942 L p F P
0 0 0 r
s
.343 .084 .039 r
.50066 .64204 m .51674 .63714 L .51764 .62432 L p F P
0 0 0 r
s
.343 .084 .039 r
.53475 .61904 m .51764 .62432 L .51674 .63714 L p F P
0 0 0 r
s
.774 .219 .095 r
.64348 .48688 m .66009 .4813 L .64468 .46288 L p F P
0 0 0 r
s
.774 .219 .095 r
.65976 .45771 m .64468 .46288 L .66009 .4813 L p F P
0 0 0 r
s
.24 .35 .67 r
.64201 .45071 m
.65622 .45892 L
s
.65981 .46099 m
.66121 .4618 L
s
.813 .232 .1 r
.64468 .46288 m .65976 .45771 L .63911 .4409 L p F P
0 0 0 r
s
.554 .149 .066 r
.57138 .59227 m .58951 .5866 L .58979 .56863 L p F P
0 0 0 r
s
.554 .149 .066 r
.60816 .56279 m .58979 .56863 L .58951 .5866 L p F P
0 0 0 r
s
.731 .205 .09 r
.63632 .51209 m .65403 .50625 L .64348 .48688 L p F P
0 0 0 r
s
.731 .205 .09 r
.66009 .4813 m .64348 .48688 L .65403 .50625 L p F P
0 0 0 r
s
.305 .447 .863 r
.4518 .39359 m .45511 .39719 L .43401 .40721 L p F P
0 0 0 r
s
.3 .442 .859 r
.45511 .39719 m .4518 .39359 L .47561 .38772 L p F P
0 0 0 r
s
.83 .24 .1 r
.46058 .39466 m
.46102 .39515 L
s
.3 .442 .859 r
.47561 .38772 m .47726 .38955 L .45511 .39719 L p F P
0 0 0 r
s
.83 .24 .1 r
.45727 .39105 m
.45816 .39202 L
s
.24 .35 .67 r
.46204 .40522 m
.48709 .39105 L
s
.83 .24 .1 r
.42279 .40425 m
.45727 .39105 L
s
.174 .276 .58 r
.63911 .4409 m .63267 .43291 L .6099 .41886 L p F P
0 0 0 r
s
.83 .24 .1 r
.6178 .4406 m
.63172 .4357 L
s
.131 .209 .459 r
.63267 .43291 m .63911 .4409 L .65976 .45771 L p F P
0 0 0 r
s
.268 .403 .801 r
.52762 .38757 m .52919 .3894 L .55762 .39689 L p F P
0 0 0 r
s
.268 .403 .801 r
.55762 .39689 m .55459 .39329 L .52762 .38757 L p F P
0 0 0 r
s
.247 .376 .756 r
.55459 .39329 m .55762 .39689 L .58471 .40678 L p F P
0 0 0 r
s
.303 .432 .811 r
.37871 .47647 m .38885 .48619 L .38068 .50552 L p F P
0 0 0 r
s
.24 .35 .67 r
.38692 .49266 m
.40896 .51364 L
s
.307 .441 .834 r
.38885 .48619 m .37871 .47647 L .39043 .45845 L p F P
0 0 0 r
s
.24 .35 .67 r
.38692 .49266 m
.40045 .46767 L
s
.683 .19 .083 r
.62417 .53768 m .64253 .53173 L .63632 .51209 L p F P
0 0 0 r
s
.683 .19 .083 r
.65403 .50625 m .63632 .51209 L .64253 .53173 L p F P
0 0 0 r
s
.83 .24 .1 r
.63555 .49685 m
.64109 .52445 L
s
.24 .35 .67 r
.63619 .73785 m
.60935 .74501 L
s
.59058 .72789 m
.60935 .74501 L
s
.308 .449 .863 r
.42905 .40196 m .43401 .40721 L .41439 .41942 L p F P
0 0 0 r
s
.305 .447 .863 r
.43401 .40721 m .42905 .40196 L .4518 .39359 L p F P
0 0 0 r
s
.293 .434 .848 r
.5 .38446 m .47726 .38955 L .47561 .38772 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.35696 .39975 m
.32313 .41301 L
s
.32313 .41301 m
.30777 .413 L
s
.283 .421 .83 r
.52919 .3894 m .52762 .38757 L .5 .38446 L closepath p F P
0 0 0 r
s
.247 .376 .756 r
.58471 .40678 m .58036 .40152 L .55459 .39329 L p F P
0 0 0 r
s
.83 .24 .1 r
.552 .39473 m
.55714 .40248 L
s
.217 .336 .687 r
.58036 .40152 m .58471 .40678 L .6099 .41886 L p F P
0 0 0 r
s
.83 .24 .1 r
.28849 .72158 m
.27109 .72076 L
s
.32198 .71152 m
.28849 .72158 L
s
.24 .35 .67 r
.65979 .46004 m
.66121 .4618 L
s
.147 .182 .324 r
.45696 .6647 m .44819 .65713 L .44377 .64819 L p F P
0 0 0 r
s
.83 .24 .1 r
.45416 .65981 m
.45963 .64947 L
s
.45146 .66493 m
.45264 .6627 L
s
.24 .35 .67 r
.44866 .64794 m
.4569 .66019 L
s
.83 .24 .1 r
.45264 .6627 m
.45327 .66151 L
s
.147 .182 .324 r
.43407 .63977 m .44377 .64819 L .44819 .65713 L p F P
0 0 0 r
s
.625 .171 .076 r
.60816 .56279 m .62672 .55688 L .62417 .53768 L p F P
0 0 0 r
s
.625 .171 .076 r
.64253 .53173 m .62417 .53768 L .62672 .55688 L p F P
0 0 0 r
s
.83 .24 .1 r
.60453 .53636 m
.64109 .52445 L
s
.3 .442 .859 r
.47396 .38588 m .47561 .38772 L .4518 .39359 L p F P
0 0 0 r
s
.293 .434 .848 r
.5 .38446 m .47561 .38772 L .47396 .38588 L closepath p F P
0 0 0 r
s
.283 .421 .83 r
.52762 .38757 m .52604 .38573 L .5 .38446 L closepath p F P
0 0 0 r
s
.268 .403 .801 r
.52604 .38573 m .52762 .38757 L .55459 .39329 L p F P
0 0 0 r
s
.24 .35 .67 r
.52003 .70792 m
.49885 .69848 L
s
.47805 .68048 m
.49885 .69848 L
s
.31 .449 .858 r
.40784 .41266 m .41439 .41942 L .39666 .43358 L p F P
0 0 0 r
s
.308 .449 .863 r
.41439 .41942 m .40784 .41266 L .42905 .40196 L p F P
0 0 0 r
s
.305 .447 .863 r
.44847 .38997 m .4518 .39359 L .42905 .40196 L p F P
0 0 0 r
s
.3 .442 .859 r
.4518 .39359 m .44847 .38997 L .47396 .38588 L p F P
0 0 0 r
s
.293 .434 .848 r
.5 .38446 m .47065 .3822 L .46899 .38034 L closepath p F P
0 0 0 r
s
1 .299 .127 r
.48577 .37389 m .48858 .37281 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .299 .127 r
.48296 .37497 m .48577 .37389 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .299 .127 r
.48016 .37605 m .48296 .37497 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .299 .127 r
.47736 .37712 m .48016 .37605 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .299 .127 r
.47456 .3782 m .47736 .37712 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .299 .127 r
.47177 .37927 m .47456 .3782 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .299 .127 r
.46899 .38034 m .47177 .37927 L .5 .38446 L closepath p F P
0 0 0 r
s
.293 .434 .848 r
.5 .38446 m .47396 .38588 L .47231 .38404 L closepath p F P
0 0 0 r
s
.293 .434 .848 r
.5 .38446 m .47231 .38404 L .47065 .3822 L closepath p F P
0 0 0 r
s
.283 .421 .83 r
.51649 .3746 m .51488 .37273 L .5 .38446 L closepath p F P
0 0 0 r
s
.283 .421 .83 r
.51809 .37647 m .51649 .3746 L .5 .38446 L closepath p F P
0 0 0 r
s
.283 .421 .83 r
.51969 .37833 m .51809 .37647 L .5 .38446 L closepath p F P
0 0 0 r
s
.283 .421 .83 r
.52129 .38019 m .51969 .37833 L .5 .38446 L closepath p F P
0 0 0 r
s
.283 .421 .83 r
.52287 .38204 m .52129 .38019 L .5 .38446 L closepath p F P
0 0 0 r
s
.283 .421 .83 r
.52446 .38389 m .52287 .38204 L .5 .38446 L closepath p F P
0 0 0 r
s
.283 .421 .83 r
.52604 .38573 m .52446 .38389 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .299 .127 r
.50556 .36627 m .50841 .36518 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .299 .127 r
.50272 .36737 m .50556 .36627 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .299 .127 r
.49988 .36846 m .50272 .36737 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .299 .127 r
.49705 .36955 m .49988 .36846 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .299 .127 r
.49422 .37064 m .49705 .36955 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .299 .127 r
.4914 .37172 m .49422 .37064 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .299 .127 r
.48858 .37281 m .4914 .37172 L .5 .38446 L closepath p F P
0 0 0 r
s
.283 .421 .83 r
.51003 .36707 m .50841 .36518 L .5 .38446 L closepath p F P
0 0 0 r
s
.283 .421 .83 r
.51165 .36896 m .51003 .36707 L .5 .38446 L closepath p F P
0 0 0 r
s
.283 .421 .83 r
.51327 .37085 m .51165 .36896 L .5 .38446 L closepath p F P
0 0 0 r
s
.283 .421 .83 r
.51488 .37273 m .51327 .37085 L .5 .38446 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.49247 .37758 m
.50743 .39461 L
s
.24 .35 .67 r
.48709 .39105 m
.513 .38121 L
s
.268 .403 .801 r
.55459 .39329 m .55154 .38967 L .52604 .38573 L p F P
0 0 0 r
s
.83 .24 .1 r
.50743 .39461 m
.52867 .38662 L
s
.247 .376 .756 r
.55154 .38967 m .55459 .39329 L .58036 .40152 L p F P
0 0 0 r
s
.229 .055 .024 r
.47139 .66034 m .48594 .65595 L .48474 .6469 L p F P
0 0 0 r
s
.229 .055 .024 r
.50066 .64204 m .48474 .6469 L .48594 .65595 L p F P
0 0 0 r
s
.217 .336 .687 r
.6099 .41886 m .60439 .4121 L .58036 .40152 L p F P
0 0 0 r
s
.174 .276 .58 r
.60439 .4121 m .6099 .41886 L .63267 .43291 L p F P
0 0 0 r
s
.24 .35 .67 r
.60809 .42436 m
.62406 .42854 L
s
.62406 .42854 m
.63098 .43709 L
s
.283 .397 .733 r
.39554 .56478 m .38418 .55455 L .38652 .53535 L p F P
0 0 0 r
s
.264 .365 .665 r
.40699 .59268 m .39587 .58282 L .39554 .56478 L p F P
0 0 0 r
s
.264 .365 .665 r
.38418 .55455 m .39554 .56478 L .39587 .58282 L p F P
0 0 0 r
s
.307 .441 .834 r
.38122 .44941 m .39043 .45845 L .37871 .47647 L p F P
0 0 0 r
s
.309 .446 .849 r
.39043 .45845 m .38122 .44941 L .39666 .43358 L p F P
0 0 0 r
s
.234 .317 .566 r
.42008 .618 m .40947 .60871 L .40699 .59268 L p F P
0 0 0 r
s
.234 .317 .566 r
.39587 .58282 m .40699 .59268 L .40947 .60871 L p F P
0 0 0 r
s
.24 .35 .67 r
.39653 .56417 m
.41842 .58391 L
s
.3 .442 .859 r
.47231 .38404 m .47396 .38588 L .44847 .38997 L p F P
0 0 0 r
s
.268 .403 .801 r
.52446 .38389 m .52604 .38573 L .55154 .38967 L p F P
0 0 0 r
s
.83 .24 .1 r
.53177 .38545 m
.53203 .38535 L
s
.464 .121 .054 r
.55203 .61371 m .56948 .60832 L .57138 .59227 L p F P
0 0 0 r
s
.464 .121 .054 r
.58951 .5866 m .57138 .59227 L .56948 .60832 L p F P
0 0 0 r
s
.83 .24 .1 r
.53436 .60811 m
.57026 .59692 L
s
.57026 .59692 m
.57094 .57372 L
s
.774 .219 .095 r
.66009 .4813 m .67686 .47566 L .65976 .45771 L p F P
0 0 0 r
s
.131 .209 .459 r
.65976 .45771 m .65252 .44865 L .63267 .43291 L p F P
0 0 0 r
s
.089 .134 .321 r
.65252 .44865 m .65976 .45771 L .67686 .47566 L p F P
0 0 0 r
s
.83 .24 .1 r
.62769 .46858 m
.65978 .45758 L
s
.66038 .45738 m
.6645 .45596 L
s
.283 .397 .733 r
.37521 .52497 m .38652 .53535 L .38418 .55455 L p F P
0 0 0 r
s
.295 .418 .779 r
.38652 .53535 m .37521 .52497 L .38068 .50552 L p F P
0 0 0 r
s
.83 .24 .1 r
.22674 .44557 m
.19413 .4584 L
s
.18145 .47088 m
.19413 .4584 L
s
.731 .205 .09 r
.65403 .50625 m .67191 .50035 L .66009 .4813 L p F P
0 0 0 r
s
.731 .205 .09 r
.67686 .47566 m .66009 .4813 L .67191 .50035 L p F P
0 0 0 r
s
.24 .35 .67 r
.70957 .54284 m
.72628 .56333 L
s
.72628 .56333 m
.72594 .58902 L
s
.83 .24 .1 r
.35616 .70125 m
.37075 .69629 L
s
.4052 .68593 m
.37075 .69629 L
s
.343 .084 .039 r
.51674 .63714 m .53296 .63219 L .53475 .61904 L p F P
0 0 0 r
s
.343 .084 .039 r
.55203 .61371 m .53475 .61904 L .53296 .63219 L p F P
0 0 0 r
s
.308 .449 .863 r
.42405 .39666 m .42905 .40196 L .40784 .41266 L p F P
0 0 0 r
s
.83 .24 .1 r
.40698 .39257 m
.41911 .40153 L
s
.305 .447 .863 r
.42905 .40196 m .42405 .39666 L .44847 .38997 L p F P
0 0 0 r
s
.554 .149 .066 r
.58951 .5866 m .60782 .58087 L .60816 .56279 L p F P
0 0 0 r
s
.83 .24 .1 r
.57094 .57372 m
.60713 .56219 L
s
.554 .149 .066 r
.62672 .55688 m .60816 .56279 L .60782 .58087 L p F P
0 0 0 r
s
.3 .442 .859 r
.44847 .38997 m .44512 .38633 L .47231 .38404 L p F P
0 0 0 r
s
.3 .442 .859 r
.47065 .3822 m .47231 .38404 L .44512 .38633 L p F P
0 0 0 r
s
.247 .376 .756 r
.58036 .40152 m .57598 .39622 L .55154 .38967 L p F P
0 0 0 r
s
.217 .336 .687 r
.57598 .39622 m .58036 .40152 L .60439 .4121 L p F P
0 0 0 r
s
.268 .403 .801 r
.52287 .38204 m .52446 .38389 L .54848 .38603 L p F P
0 0 0 r
s
.83 .24 .1 r
.53203 .38535 m
.53372 .38472 L
s
.268 .403 .801 r
.55154 .38967 m .54848 .38603 L .52446 .38389 L p F P
0 0 0 r
s
.683 .19 .083 r
.64253 .53173 m .66109 .52572 L .65403 .50625 L p F P
0 0 0 r
s
.683 .19 .083 r
.67191 .50035 m .65403 .50625 L .66109 .52572 L p F P
0 0 0 r
s
.24 .35 .67 r
.71971 .61583 m
.73626 .63504 L
s
.73626 .63504 m
.72464 .66127 L
s
.305 .447 .863 r
.44512 .38633 m .44847 .38997 L .42405 .39666 L p F P
0 0 0 r
s
.188 .246 .422 r
.43407 .63977 m .4242 .63121 L .42008 .618 L p F P
0 0 0 r
s
.188 .246 .422 r
.40947 .60871 m .42008 .618 L .4242 .63121 L p F P
0 0 0 r
s
.24 .35 .67 r
.42014 .60765 m
.42715 .6292 L
s
.247 .376 .756 r
.54848 .38603 m .55154 .38967 L .57598 .39622 L p F P
0 0 0 r
s
.83 .24 .1 r
.57506 .39588 m
.59327 .38916 L
s
.309 .446 .849 r
.38863 .4255 m .39666 .43358 L .38122 .44941 L p F P
0 0 0 r
s
.31 .449 .858 r
.39666 .43358 m .38863 .4255 L .40784 .41266 L p F P
0 0 0 r
s
.295 .418 .779 r
.36972 .49525 m .38068 .50552 L .37521 .52497 L p F P
0 0 0 r
s
.24 .35 .67 r
.37789 .51832 m
.40028 .53902 L
s
.303 .432 .811 r
.38068 .50552 m .36972 .49525 L .37871 .47647 L p F P
0 0 0 r
s
.83 .24 .1 r
.6645 .45596 m
.66696 .46468 L
s
.65452 .42769 m
.6645 .45596 L
s
.3 .442 .859 r
.44512 .38633 m .44175 .38268 L .47065 .3822 L p F P
0 0 0 r
s
.3 .442 .859 r
.46899 .38034 m .47065 .3822 L .44175 .38268 L p F P
0 0 0 r
s
.174 .276 .58 r
.63267 .43291 m .62616 .42483 L .60439 .4121 L p F P
0 0 0 r
s
.83 .24 .1 r
.59327 .38916 m
.6057 .41286 L
s
.131 .209 .459 r
.62616 .42483 m .63267 .43291 L .65252 .44865 L p F P
0 0 0 r
s
.83 .24 .1 r
.63638 .43406 m
.65452 .42769 L
s
.268 .403 .801 r
.52129 .38019 m .52287 .38204 L .5454 .38237 L p F P
0 0 0 r
s
.83 .24 .1 r
.54101 .38197 m
.54305 .38121 L
s
.268 .403 .801 r
.54848 .38603 m .5454 .38237 L .52287 .38204 L p F P
0 0 0 r
s
.83 .24 .1 r
.54305 .38121 m
.54372 .38222 L
s
.24 .35 .67 r
.513 .38121 m
.52502 .39511 L
s
.83 .24 .1 r
.69201 .4145 m
.65452 .42769 L
s
.64295 .40058 m
.65452 .42769 L
s
.24 .35 .67 r
.45861 .66421 m
.46096 .66623 L
s
.625 .171 .076 r
.62672 .55688 m .64548 .55091 L .64253 .53173 L p F P
0 0 0 r
s
.625 .171 .076 r
.66109 .52572 m .64253 .53173 L .64548 .55091 L p F P
0 0 0 r
s
.83 .24 .1 r
.64109 .52445 m
.64409 .55043 L
s
.63015 .37557 m
.59327 .38916 L
s
.229 .055 .024 r
.48594 .65595 m .50061 .65151 L .50066 .64204 L p F P
0 0 0 r
s
.229 .055 .024 r
.51674 .63714 m .50066 .64204 L .50061 .65151 L p F P
0 0 0 r
s
.83 .24 .1 r
.49456 .63876 m
.53021 .62783 L
s
.30777 .413 m
.27421 .42621 L
s
.27421 .42621 m
.26003 .43246 L
s
.3 .442 .859 r
.44175 .38268 m .43836 .379 L .46899 .38034 L p F P
0 0 0 r
s
1 .308 .131 r
.47177 .37927 m .46899 .38034 L .43836 .379 L p F P
0 0 0 r
s
.31 .449 .858 r
.40122 .40583 m .40784 .41266 L .38863 .4255 L p F P
0 0 0 r
s
.24 .35 .67 r
.39587 .42183 m
.41794 .44424 L
s
.308 .449 .863 r
.40784 .41266 m .40122 .40583 L .42405 .39666 L p F P
0 0 0 r
s
.268 .403 .801 r
.51969 .37833 m .52129 .38019 L .54231 .37869 L p F P
0 0 0 r
s
.268 .403 .801 r
.5454 .38237 m .54231 .37869 L .52129 .38019 L p F P
0 0 0 r
s
.24 .35 .67 r
.66246 .72517 m
.63619 .73785 L
s
.61777 .72047 m
.63619 .73785 L
s
.305 .447 .863 r
.42405 .39666 m .419 .39132 L .44512 .38633 L p F P
0 0 0 r
s
.305 .447 .863 r
.44175 .38268 m .44512 .38633 L .419 .39132 L p F P
0 0 0 r
s
.217 .336 .687 r
.60439 .4121 m .59882 .40526 L .57598 .39622 L p F P
0 0 0 r
s
.174 .276 .58 r
.59882 .40526 m .60439 .4121 L .62616 .42483 L p F P
0 0 0 r
s
.83 .24 .1 r
.60925 .41272 m
.64295 .40058 L
s
.303 .432 .811 r
.36841 .4666 m .37871 .47647 L .36972 .49525 L p F P
0 0 0 r
s
.24 .35 .67 r
.37789 .51832 m
.38692 .49266 L
s
.307 .441 .834 r
.37871 .47647 m .36841 .4666 L .38122 .44941 L p F P
0 0 0 r
s
.247 .376 .756 r
.5454 .38237 m .54848 .38603 L .57156 .39087 L p F P
0 0 0 r
s
.247 .376 .756 r
.57598 .39622 m .57156 .39087 L .54848 .38603 L p F P
0 0 0 r
s
1 .308 .131 r
.47456 .3782 m .47177 .37927 L .44385 .37686 L p F P
0 0 0 r
s
1 .308 .131 r
.43836 .379 m .44385 .37686 L .47177 .37927 L p F P
0 0 0 r
s
.24 .35 .67 r
.59058 .72789 m
.56423 .72948 L
s
.54449 .71193 m
.56423 .72948 L
s
.308 .449 .863 r
.419 .39132 m .42405 .39666 L .40122 .40583 L p F P
0 0 0 r
s
.24 .35 .67 r
.41703 .4004 m
.43871 .42317 L
s
.464 .121 .054 r
.56948 .60832 m .5871 .60288 L .58951 .5866 L p F P
0 0 0 r
s
.464 .121 .054 r
.60782 .58087 m .58951 .5866 L .5871 .60288 L p F P
0 0 0 r
s
.731 .205 .09 r
.67191 .50035 m .68998 .49439 L .67686 .47566 L p F P
0 0 0 r
s
.24 .35 .67 r
.68988 .49443 m
.6937 .4992 L
s
.089 .134 .321 r
.67686 .47566 m .66897 .46577 L .65252 .44865 L p F P
0 0 0 r
s
.136 .17 .302 r
.66897 .46577 m .67686 .47566 L .68998 .49439 L p F P
0 0 0 r
s
.83 .24 .1 r
.66713 .46528 m
.67256 .48448 L
s
.24 .35 .67 r
.66617 .46696 m
.67652 .4777 L
s
.83 .24 .1 r
.63555 .49685 m
.67256 .48448 L
s
.24 .35 .67 r
.67652 .4777 m
.68044 .48261 L
s
.217 .336 .687 r
.57156 .39087 m .57598 .39622 L .59882 .40526 L p F P
0 0 0 r
s
.24 .35 .67 r
.55848 .39954 m
.583 .39992 L
s
.583 .39992 m
.59804 .4182 L
s
.145 .037 .015 r
.47139 .66034 m .45696 .6647 L .46175 .66927 L p F P
0 0 0 r
s
.094 .106 .204 r
.44819 .65713 m .45696 .6647 L .46175 .66927 L p F P
0 0 0 r
s
.83 .24 .1 r
.45146 .66493 m
.45552 .6637 L
s
.268 .403 .801 r
.51809 .37647 m .51969 .37833 L .5392 .37499 L p F P
0 0 0 r
s
.268 .403 .801 r
.54231 .37869 m .5392 .37499 L .51969 .37833 L p F P
0 0 0 r
s
1 .308 .131 r
.47736 .37712 m .47456 .3782 L .44936 .37472 L p F P
0 0 0 r
s
1 .308 .131 r
.44385 .37686 m .44936 .37472 L .47456 .3782 L p F P
0 0 0 r
s
.83 .24 .1 r
.47131 .38568 m
.49247 .37758 L
s
.681 .48166 m
.68236 .48121 L
s
.67256 .48448 m
.68071 .48176 L
s
.343 .084 .039 r
.53296 .63219 m .54934 .6272 L .55203 .61371 L p F P
0 0 0 r
s
.83 .24 .1 r
.53021 .62783 m
.53436 .60811 L
s
.343 .084 .039 r
.56948 .60832 m .55203 .61371 L .54934 .6272 L p F P
0 0 0 r
s
.147 .182 .324 r
.44819 .65713 m .43928 .64944 L .43407 .63977 L p F P
0 0 0 r
s
.147 .182 .324 r
.4242 .63121 m .43407 .63977 L .43928 .64944 L p F P
0 0 0 r
s
.24 .35 .67 r
.42715 .6292 m
.44866 .64794 L
s
.554 .149 .066 r
.60782 .58087 m .62632 .57508 L .62672 .55688 L p F P
0 0 0 r
s
.554 .149 .066 r
.64548 .55091 m .62672 .55688 L .62632 .57508 L p F P
0 0 0 r
s
.24 .35 .67 r
.70431 .51931 m
.70957 .54284 L
s
1 .308 .131 r
.48016 .37605 m .47736 .37712 L .45489 .37257 L p F P
0 0 0 r
s
1 .308 .131 r
.44936 .37472 m .45489 .37257 L .47736 .37712 L p F P
0 0 0 r
s
.24 .35 .67 r
.47463 .37706 m
.48709 .39105 L
s
.683 .19 .083 r
.66109 .52572 m .67983 .51965 L .67191 .50035 L p F P
0 0 0 r
s
.683 .19 .083 r
.68998 .49439 m .67191 .50035 L .67983 .51965 L p F P
0 0 0 r
s
.83 .24 .1 r
.68046 .38706 m
.64295 .40058 L
s
.64295 .40058 m
.63015 .37557 L
s
.24 .35 .67 r
.39587 .42183 m
.41703 .4004 L
s
.307 .441 .834 r
.37187 .44023 m .38122 .44941 L .36841 .4666 L p F P
0 0 0 r
s
.309 .446 .849 r
.38122 .44941 m .37187 .44023 L .38863 .4255 L p F P
0 0 0 r
s
.24 .35 .67 r
.378 .44562 m
.40045 .46767 L
s
.268 .403 .801 r
.51649 .3746 m .51809 .37647 L .53606 .37127 L p F P
0 0 0 r
s
.268 .403 .801 r
.5392 .37499 m .53606 .37127 L .51809 .37647 L p F P
0 0 0 r
s
.24 .35 .67 r
.513 .38121 m
.53882 .37619 L
s
1 .308 .131 r
.48296 .37497 m .48016 .37605 L .46044 .37042 L p F P
0 0 0 r
s
1 .308 .131 r
.45489 .37257 m .46044 .37042 L .48016 .37605 L p F P
0 0 0 r
s
.83 .24 .1 r
.35696 .39975 m
.34203 .39951 L
s
.305 .447 .863 r
.419 .39132 m .41392 .38593 L .44175 .38268 L p F P
0 0 0 r
s
.83 .24 .1 r
.40698 .39257 m
.41664 .38881 L
s
.305 .447 .863 r
.43836 .379 m .44175 .38268 L .41392 .38593 L p F P
0 0 0 r
s
.24 .35 .67 r
.44073 .38208 m
.46204 .40522 L
s
.131 .209 .459 r
.65252 .44865 m .64517 .43946 L .62616 .42483 L p F P
0 0 0 r
s
.089 .134 .321 r
.64517 .43946 m .65252 .44865 L .66897 .46577 L p F P
0 0 0 r
s
.83 .24 .1 r
.6645 .45596 m
.70208 .44308 L
s
.247 .376 .756 r
.54231 .37869 m .5454 .38237 L .56711 .38548 L p F P
0 0 0 r
s
.247 .376 .756 r
.57156 .39087 m .56711 .38548 L .5454 .38237 L p F P
0 0 0 r
s
.83 .24 .1 r
.30496 .71052 m
.32198 .71152 L
s
.35616 .70125 m
.32198 .71152 L
s
.24 .35 .67 r
.70778 .64242 m
.72464 .66127 L
s
.72464 .66127 m
.70788 .68587 L
s
1 .308 .131 r
.48577 .37389 m .48296 .37497 L .466 .36826 L p F P
0 0 0 r
s
1 .308 .131 r
.46044 .37042 m .466 .36826 L .48296 .37497 L p F P
0 0 0 r
s
.268 .403 .801 r
.51488 .37273 m .51649 .3746 L .53292 .36752 L p F P
0 0 0 r
s
.268 .403 .801 r
.53606 .37127 m .53292 .36752 L .51649 .3746 L p F P
0 0 0 r
s
.283 .397 .733 r
.38418 .55455 m .37261 .54413 L .37521 .52497 L p F P
0 0 0 r
s
.264 .365 .665 r
.39587 .58282 m .38454 .57279 L .38418 .55455 L p F P
0 0 0 r
s
.264 .365 .665 r
.37261 .54413 m .38418 .55455 L .38454 .57279 L p F P
0 0 0 r
s
.229 .055 .024 r
.50061 .65151 m .51541 .64704 L .51674 .63714 L p F P
0 0 0 r
s
.229 .055 .024 r
.53296 .63219 m .51674 .63714 L .51541 .64704 L p F P
0 0 0 r
s
.309 .446 .849 r
.3805 .41732 m .38863 .4255 L .37187 .44023 L p F P
0 0 0 r
s
.31 .449 .858 r
.38863 .4255 m .3805 .41732 L .40122 .40583 L p F P
0 0 0 r
s
.24 .35 .67 r
.378 .44562 m
.39587 .42183 L
s
.234 .317 .566 r
.40947 .60871 m .39867 .59926 L .39587 .58282 L p F P
0 0 0 r
s
.234 .317 .566 r
.38454 .57279 m .39587 .58282 L .39867 .59926 L p F P
0 0 0 r
s
.24 .35 .67 r
.39653 .56417 m
.39801 .58809 L
s
.625 .171 .076 r
.64548 .55091 m .66443 .54488 L .66109 .52572 L p F P
0 0 0 r
s
.625 .171 .076 r
.67983 .51965 m .66109 .52572 L .66443 .54488 L p F P
0 0 0 r
s
.83 .24 .1 r
.64109 .52445 m
.67841 .51228 L
s
1 .308 .131 r
.48858 .37281 m .48577 .37389 L .47158 .36609 L p F P
0 0 0 r
s
1 .308 .131 r
.466 .36826 m .47158 .36609 L .48577 .37389 L p F P
0 0 0 r
s
.24 .35 .67 r
.46613 .36753 m
.46658 .36803 L
s
.308 .449 .863 r
.40122 .40583 m .39453 .39892 L .419 .39132 L p F P
0 0 0 r
s
.308 .449 .863 r
.41392 .38593 m .419 .39132 L .39453 .39892 L p F P
0 0 0 r
s
.24 .35 .67 r
.41703 .4004 m
.44073 .38208 L
s
.174 .276 .58 r
.62616 .42483 m .61956 .41663 L .59882 .40526 L p F P
0 0 0 r
s
.131 .209 .459 r
.61956 .41663 m .62616 .42483 L .64517 .43946 L p F P
0 0 0 r
s
.24 .35 .67 r
.46243 .36965 m
.46613 .36753 L
s
.283 .397 .733 r
.36369 .5144 m .37521 .52497 L .37261 .54413 L p F P
0 0 0 r
s
.295 .418 .779 r
.37521 .52497 m .36369 .5144 L .36972 .49525 L p F P
0 0 0 r
s
.24 .35 .67 r
.37384 .5437 m
.37789 .51832 L
s
.68679 .70755 m
.66246 .72517 L
s
.64443 .70747 m
.66246 .72517 L
s
.31 .449 .858 r
.39453 .39892 m .40122 .40583 L .3805 .41732 L p F P
0 0 0 r
s
.217 .336 .687 r
.56711 .38548 m .57156 .39087 L .59319 .39835 L p F P
0 0 0 r
s
.217 .336 .687 r
.59882 .40526 m .59319 .39835 L .57156 .39087 L p F P
0 0 0 r
s
.145 .037 .015 r
.46175 .66927 m .47458 .66541 L .47139 .66034 L p F P
0 0 0 r
s
.24 .35 .67 r
.46384 .66864 m
.47805 .68048 L
s
.145 .037 .015 r
.48594 .65595 m .47139 .66034 L .47458 .66541 L p F P
0 0 0 r
s
1 .308 .131 r
.4914 .37172 m .48858 .37281 L .47718 .36391 L p F P
0 0 0 r
s
1 .308 .131 r
.47158 .36609 m .47718 .36391 L .48858 .37281 L p F P
0 0 0 r
s
.268 .403 .801 r
.51327 .37085 m .51488 .37273 L .52975 .36376 L p F P
0 0 0 r
s
.268 .403 .801 r
.53292 .36752 m .52975 .36376 L .51488 .37273 L p F P
0 0 0 r
s
.174 .276 .58 r
.59319 .39835 m .59882 .40526 L .61956 .41663 L p F P
0 0 0 r
s
.305 .447 .863 r
.41392 .38593 m .40879 .3805 L .43836 .379 L p F P
0 0 0 r
s
1 .312 .132 r
.44385 .37686 m .43836 .379 L .40879 .3805 L p F P
0 0 0 r
s
.83 .24 .1 r
.43572 .38141 m
.44182 .37904 L
s
.24 .35 .67 r
.44073 .38208 m
.45002 .37676 L
s
.83 .24 .1 r
.44182 .37904 m
.44755 .38349 L
s
.247 .376 .756 r
.5392 .37499 m .54231 .37869 L .56262 .38005 L p F P
0 0 0 r
s
.83 .24 .1 r
.54661 .37987 m
.54862 .37911 L
s
.247 .376 .756 r
.56711 .38548 m .56262 .38005 L .54231 .37869 L p F P
0 0 0 r
s
.464 .121 .054 r
.5871 .60288 m .60491 .59738 L .60782 .58087 L p F P
0 0 0 r
s
.464 .121 .054 r
.62632 .57508 m .60782 .58087 L .60491 .59738 L p F P
0 0 0 r
s
.83 .24 .1 r
.57026 .59692 m
.60692 .58549 L
s
.60692 .58549 m
.60713 .56219 L
s
.188 .246 .422 r
.4242 .63121 m .41417 .62252 L .40947 .60871 L p F P
0 0 0 r
s
.188 .246 .422 r
.39867 .59926 m .40947 .60871 L .41417 .62252 L p F P
0 0 0 r
s
.24 .35 .67 r
.39801 .58809 m
.42014 .60765 L
s
1 .308 .131 r
.49422 .37064 m .4914 .37172 L .4828 .36173 L p F P
0 0 0 r
s
1 .308 .131 r
.47718 .36391 m .4828 .36173 L .4914 .37172 L p F P
0 0 0 r
s
.343 .084 .039 r
.54934 .6272 m .56587 .62215 L .56948 .60832 L p F P
0 0 0 r
s
.343 .084 .039 r
.5871 .60288 m .56948 .60832 L .56587 .62215 L p F P
0 0 0 r
s
.83 .24 .1 r
.26003 .43246 m
.22674 .44557 L
s
.22674 .44557 m
.21447 .45797 L
s
.295 .418 .779 r
.35856 .4848 m .36972 .49525 L .36369 .5144 L p F P
0 0 0 r
s
.303 .432 .811 r
.36972 .49525 m .35856 .4848 L .36841 .4666 L p F P
0 0 0 r
s
.83 .24 .1 r
.39107 .69076 m
.4052 .68593 L
s
.44038 .67536 m
.4052 .68593 L
s
.24 .35 .67 r
.69064 .66741 m
.70788 .68587 L
s
.70788 .68587 m
.68679 .70755 L
s
.70904 .56878 m
.72594 .58902 L
s
.72594 .58902 m
.71971 .61583 L
s
.268 .403 .801 r
.51165 .36896 m .51327 .37085 L .52656 .35997 L p F P
0 0 0 r
s
.268 .403 .801 r
.52975 .36376 m .52656 .35997 L .51327 .37085 L p F P
0 0 0 r
s
.24 .35 .67 r
.54449 .71193 m
.52003 .70792 L
s
.49935 .68986 m
.52003 .70792 L
s
1 .308 .131 r
.49705 .36955 m .49422 .37064 L .48844 .35954 L p F P
0 0 0 r
s
1 .308 .131 r
.4828 .36173 m .48844 .35954 L .49422 .37064 L p F P
0 0 0 r
s
.554 .149 .066 r
.62632 .57508 m .64502 .56922 L .64548 .55091 L p F P
0 0 0 r
s
.83 .24 .1 r
.60713 .56219 m
.64409 .55043 L
s
.554 .149 .066 r
.66443 .54488 m .64548 .55091 L .64502 .56922 L p F P
0 0 0 r
s
.683 .19 .083 r
.67983 .51965 m .69878 .51352 L .68998 .49439 L p F P
0 0 0 r
s
.136 .17 .302 r
.68998 .49439 m .68162 .48393 L .66897 .46577 L p F P
0 0 0 r
s
.83 .24 .1 r
.67256 .48448 m
.67841 .51228 L
s
.68236 .48121 m
.71035 .47185 L
s
.185 .244 .417 r
.68162 .48393 m .68998 .49439 L .69878 .51352 L p F P
0 0 0 r
s
.24 .35 .67 r
.69761 .51098 m
.70431 .51931 L
s
.66916 .68948 m
.68679 .70755 L
s
1 .312 .132 r
.44936 .37472 m .44385 .37686 L .41685 .37734 L p F P
0 0 0 r
s
1 .312 .132 r
.40879 .3805 m .41685 .37734 L .44385 .37686 L p F P
0 0 0 r
s
.24 .35 .67 r
.43695 .37797 m
.44073 .38208 L
s
1 .308 .131 r
.49988 .36846 m .49705 .36955 L .49409 .35734 L p F P
0 0 0 r
s
1 .308 .131 r
.48844 .35954 m .49409 .35734 L .49705 .36955 L p F P
0 0 0 r
s
.24 .35 .67 r
.49235 .35733 m
.49279 .35785 L
s
.83 .24 .1 r
.49247 .37758 m
.5139 .36937 L
s
.4774 .36523 m
.49247 .37758 L
s
.67841 .51228 m
.69494 .5069 L
s
.268 .403 .801 r
.51003 .36707 m .51165 .36896 L .52336 .35616 L p F P
0 0 0 r
s
.268 .403 .801 r
.52656 .35997 m .52336 .35616 L .51165 .36896 L p F P
0 0 0 r
s
.303 .432 .811 r
.35794 .45656 m .36841 .4666 L .35856 .4848 L p F P
0 0 0 r
s
.24 .35 .67 r
.36408 .47093 m
.38692 .49266 L
s
.307 .441 .834 r
.36841 .4666 m .35794 .45656 L .37187 .44023 L p F P
0 0 0 r
s
.83 .24 .1 r
.71035 .47185 m
.70208 .44308 L
s
.74045 .42993 m
.70208 .44308 L
s
.70208 .44308 m
.69201 .4145 L
s
.094 .106 .204 r
.46175 .66927 m .45398 .66257 L .44819 .65713 L p F P
0 0 0 r
s
.83 .24 .1 r
.44038 .67536 m
.45146 .66493 L
s
.094 .106 .204 r
.43928 .64944 m .44819 .65713 L .45398 .66257 L p F P
0 0 0 r
s
1 .308 .131 r
.50272 .36737 m .49988 .36846 L .49976 .35514 L p F P
0 0 0 r
s
1 .308 .131 r
.49409 .35734 m .49976 .35514 L .49988 .36846 L p F P
0 0 0 r
s
.83 .24 .1 r
.73028 .40104 m
.69201 .4145 L
s
.69201 .4145 m
.68046 .38706 L
s
.247 .376 .756 r
.53606 .37127 m .5392 .37499 L .55809 .37457 L p F P
0 0 0 r
s
.247 .376 .756 r
.56262 .38005 m .55809 .37457 L .5392 .37499 L p F P
0 0 0 r
s
.83 .24 .1 r
.55871 .37532 m
.57941 .36752 L
s
.24 .35 .67 r
.53882 .37619 m
.55848 .39954 L
s
.229 .055 .024 r
.51541 .64704 m .53034 .64252 L .53296 .63219 L p F P
0 0 0 r
s
.229 .055 .024 r
.54934 .6272 m .53296 .63219 L .53034 .64252 L p F P
0 0 0 r
s
.308 .449 .863 r
.39453 .39892 m .38777 .39194 L .41392 .38593 L p F P
0 0 0 r
s
.308 .449 .863 r
.40879 .3805 m .41392 .38593 L .38777 .39194 L p F P
0 0 0 r
s
.089 .134 .321 r
.66897 .46577 m .66096 .45572 L .64517 .43946 L p F P
0 0 0 r
s
.136 .17 .302 r
.66096 .45572 m .66897 .46577 L .68162 .48393 L p F P
0 0 0 r
s
1 .312 .132 r
.45489 .37257 m .44936 .37472 L .42495 .37417 L p F P
0 0 0 r
s
1 .312 .132 r
.41685 .37734 m .42495 .37417 L .44936 .37472 L p F P
0 0 0 r
s
.217 .336 .687 r
.56262 .38005 m .56711 .38548 L .5875 .39136 L p F P
0 0 0 r
s
.217 .336 .687 r
.59319 .39835 m .5875 .39136 L .56711 .38548 L p F P
0 0 0 r
s
.83 .24 .1 r
.57941 .36752 m
.59327 .38916 L
s
1 .308 .131 r
.50556 .36627 m .50272 .36737 L .50546 .35293 L p F P
0 0 0 r
s
1 .308 .131 r
.49976 .35514 m .50546 .35293 L .50272 .36737 L p F P
0 0 0 r
s
.625 .171 .076 r
.66443 .54488 m .68359 .53879 L .67983 .51965 L p F P
0 0 0 r
s
.625 .171 .076 r
.69878 .51352 m .67983 .51965 L .68359 .53879 L p F P
0 0 0 r
s
.83 .24 .1 r
.27109 .72076 m
.25246 .71367 L
s
.30496 .71052 m
.27109 .72076 L
s
.145 .037 .015 r
.47458 .66541 m .48751 .66153 L .48594 .65595 L p F P
0 0 0 r
s
.145 .037 .015 r
.50061 .65151 m .48594 .65595 L .48751 .66153 L p F P
0 0 0 r
s
.83 .24 .1 r
.45592 .66358 m
.48688 .6542 L
s
.48688 .6542 m
.49456 .63876 L
s
.66781 .36168 m
.63015 .37557 L
s
.63015 .37557 m
.61654 .35355 L
s
.268 .403 .801 r
.50841 .36518 m .51003 .36707 L .52014 .35233 L p F P
0 0 0 r
s
.268 .403 .801 r
.52336 .35616 m .52014 .35233 L .51003 .36707 L p F P
0 0 0 r
s
.24 .35 .67 r
.50072 .36702 m
.513 .38121 L
s
.147 .182 .324 r
.43928 .64944 m .43024 .64163 L .4242 .63121 L p F P
0 0 0 r
s
.147 .182 .324 r
.41417 .62252 m .4242 .63121 L .43024 .64163 L p F P
0 0 0 r
s
.83 .24 .1 r
.61654 .35355 m
.57941 .36752 L
s
.307 .441 .834 r
.36238 .43091 m .37187 .44023 L .35794 .45656 L p F P
0 0 0 r
s
.24 .35 .67 r
.36408 .47093 m
.378 .44562 L
s
.309 .446 .849 r
.37187 .44023 m .36238 .43091 L .3805 .41732 L p F P
0 0 0 r
s
.83 .24 .1 r
.34203 .39951 m
.30777 .413 L
s
.30777 .413 m
.29404 .41908 L
s
1 .308 .131 r
.50841 .36518 m .50556 .36627 L .51117 .35071 L p F P
0 0 0 r
s
1 .308 .131 r
.50546 .35293 m .51117 .35071 L .50556 .36627 L p F P
0 0 0 r
s
.24 .35 .67 r
.61777 .72047 m
.59058 .72789 L
s
.57112 .71013 m
.59058 .72789 L
s
.31 .449 .858 r
.3805 .41732 m .37227 .40903 L .39453 .39892 L p F P
0 0 0 r
s
.31 .449 .858 r
.38777 .39194 m .39453 .39892 L .37227 .40903 L p F P
0 0 0 r
s
.131 .209 .459 r
.64517 .43946 m .63771 .43014 L .61956 .41663 L p F P
0 0 0 r
s
.089 .134 .321 r
.63771 .43014 m .64517 .43946 L .66096 .45572 L p F P
0 0 0 r
s
.24 .35 .67 r
.64336 .43953 m
.65897 .45902 L
s
1 .312 .132 r
.46044 .37042 m .45489 .37257 L .43309 .37098 L p F P
0 0 0 r
s
1 .312 .132 r
.42495 .37417 m .43309 .37098 L .45489 .37257 L p F P
0 0 0 r
s
.309 .446 .849 r
.37227 .40903 m .3805 .41732 L .36238 .43091 L p F P
0 0 0 r
s
.174 .276 .58 r
.5875 .39136 m .59319 .39835 L .61288 .40833 L p F P
0 0 0 r
s
.174 .276 .58 r
.61956 .41663 m .61288 .40833 L .59319 .39835 L p F P
0 0 0 r
s
.24 .35 .67 r
.583 .39992 m
.60546 .40557 L
s
.268 .403 .801 r
.52014 .35233 m .5169 .34848 L .50841 .36518 L p F P
0 0 0 r
s
1 .308 .131 r
.51117 .35071 m .5169 .34848 L .50841 .36518 L p F P
0 0 0 r
s
.131 .209 .459 r
.61288 .40833 m .61956 .41663 L .63771 .43014 L p F P
0 0 0 r
s
.24 .35 .67 r
.60546 .40557 m
.62406 .42854 L
s
.62406 .42854 m
.64336 .43953 L
s
.464 .121 .054 r
.60491 .59738 m .62289 .59183 L .62632 .57508 L p F P
0 0 0 r
s
.464 .121 .054 r
.64502 .56922 m .62632 .57508 L .62289 .59183 L p F P
0 0 0 r
s
.343 .084 .039 r
.56587 .62215 m .58256 .61706 L .5871 .60288 L p F P
0 0 0 r
s
.83 .24 .1 r
.56661 .61668 m
.57026 .59692 L
s
.343 .084 .039 r
.60491 .59738 m .5871 .60288 L .58256 .61706 L p F P
0 0 0 r
s
.247 .376 .756 r
.53292 .36752 m .53606 .37127 L .55352 .36904 L p F P
0 0 0 r
s
.247 .376 .756 r
.55809 .37457 m .55352 .36904 L .53606 .37127 L p F P
0 0 0 r
s
.83 .24 .1 r
.71652 .49986 m
.71035 .47185 L
s
.74894 .45896 m
.71035 .47185 L
s
.24 .35 .67 r
.49935 .68986 m
.47805 .68048 L
s
1 .312 .132 r
.466 .36826 m .46044 .37042 L .44127 .36778 L p F P
0 0 0 r
s
1 .312 .132 r
.43309 .37098 m .44127 .36778 L .46044 .37042 L p F P
0 0 0 r
s
.554 .149 .066 r
.64502 .56922 m .66391 .56331 L .66443 .54488 L p F P
0 0 0 r
s
.554 .149 .066 r
.68359 .53879 m .66443 .54488 L .66391 .56331 L p F P
0 0 0 r
s
.83 .24 .1 r
.21447 .45797 m
.18145 .47088 L
s
.17182 .48898 m
.18145 .47088 L
s
.71877 .37326 m
.68046 .38706 L
s
.68046 .38706 m
.66781 .36168 L
s
.308 .449 .863 r
.38777 .39194 m .38093 .38488 L .40879 .3805 L p F P
0 0 0 r
s
.83 .24 .1 r
.35696 .39975 m
.38478 .38885 L
s
.996 .304 .128 r
.41685 .37734 m .40879 .3805 L .38093 .38488 L p F P
0 0 0 r
s
.283 .397 .733 r
.37261 .54413 m .36083 .53352 L .36369 .5144 L p F P
0 0 0 r
s
.264 .365 .665 r
.38454 .57279 m .37302 .56257 L .37261 .54413 L p F P
0 0 0 r
s
.264 .365 .665 r
.36083 .53352 m .37261 .54413 L .37302 .56257 L p F P
0 0 0 r
s
.234 .317 .566 r
.39867 .59926 m .38768 .58964 L .38454 .57279 L p F P
0 0 0 r
s
.234 .317 .566 r
.37302 .56257 m .38454 .57279 L .38768 .58964 L p F P
0 0 0 r
s
.24 .35 .67 r
.37384 .5437 m
.39653 .56417 L
s
.217 .336 .687 r
.55809 .37457 m .56262 .38005 L .58175 .38429 L p F P
0 0 0 r
s
.217 .336 .687 r
.5875 .39136 m .58175 .38429 L .56262 .38005 L p F P
0 0 0 r
s
.229 .055 .024 r
.53034 .64252 m .54539 .63797 L .54934 .6272 L p F P
0 0 0 r
s
.229 .055 .024 r
.56587 .62215 m .54934 .6272 L .54539 .63797 L p F P
0 0 0 r
s
.83 .24 .1 r
.53021 .62783 m
.56661 .61668 L
s
.33955 .70007 m
.35616 .70125 L
s
.39107 .69076 m
.35616 .70125 L
s
.145 .037 .015 r
.48751 .66153 m .50054 .65761 L .50061 .65151 L p F P
0 0 0 r
s
.145 .037 .015 r
.51541 .64704 m .50061 .65151 L .50054 .65761 L p F P
0 0 0 r
s
1 .312 .132 r
.47158 .36609 m .466 .36826 L .44949 .36456 L p F P
0 0 0 r
s
1 .312 .132 r
.44127 .36778 m .44949 .36456 L .466 .36826 L p F P
0 0 0 r
s
.283 .397 .733 r
.35196 .50364 m .36369 .5144 L .36083 .53352 L p F P
0 0 0 r
s
.295 .418 .779 r
.36369 .5144 m .35196 .50364 L .35856 .4848 L p F P
0 0 0 r
s
.24 .35 .67 r
.70957 .54284 m
.70904 .56878 L
s
.247 .376 .756 r
.52975 .36376 m .53292 .36752 L .54891 .36347 L p F P
0 0 0 r
s
.247 .376 .756 r
.55352 .36904 m .54891 .36347 L .53292 .36752 L p F P
0 0 0 r
s
.188 .246 .422 r
.41417 .62252 m .40398 .61367 L .39867 .59926 L p F P
0 0 0 r
s
.188 .246 .422 r
.38768 .58964 m .39867 .59926 L .40398 .61367 L p F P
0 0 0 r
s
.24 .35 .67 r
.39801 .58809 m
.40485 .60977 L
s
.625 .171 .076 r
.68359 .53879 m .70296 .53263 L .69878 .51352 L p F P
0 0 0 r
s
.185 .244 .417 r
.69878 .51352 m .69011 .50274 L .68162 .48393 L p F P
0 0 0 r
s
.83 .24 .1 r
.67841 .51228 m
.68182 .53841 L
s
.235 .32 .564 r
.69011 .50274 m .69878 .51352 L .70296 .53263 L p F P
0 0 0 r
s
.83 .24 .1 r
.69653 .50638 m
.71652 .49986 L
s
.69546 .50673 m
.69653 .50638 L
s
.295 .418 .779 r
.34722 .47417 m .35856 .4848 L .35196 .50364 L p F P
0 0 0 r
s
.24 .35 .67 r
.35469 .49687 m
.37789 .51832 L
s
.303 .432 .811 r
.35856 .4848 m .34722 .47417 L .35794 .45656 L p F P
0 0 0 r
s
.24 .35 .67 r
.70255 .5959 m
.71971 .61583 L
s
.71971 .61583 m
.70778 .64242 L
s
.996 .304 .128 r
.42495 .37417 m .41685 .37734 L .39138 .38077 L p F P
0 0 0 r
s
.996 .304 .128 r
.38093 .38488 m .39138 .38077 L .41685 .37734 L p F P
0 0 0 r
s
.24 .35 .67 r
.39914 .38161 m
.41703 .4004 L
s
1 .312 .132 r
.47718 .36391 m .47158 .36609 L .45774 .36133 L p F P
0 0 0 r
s
.24 .35 .67 r
.46187 .36275 m
.4644 .36559 L
s
.47009 .36599 m
.47065 .36577 L
s
1 .312 .132 r
.44949 .36456 m .45774 .36133 L .47158 .36609 L p F P
0 0 0 r
s
.83 .24 .1 r
.44182 .37904 m
.4774 .36523 L
s
.31 .449 .858 r
.37227 .40903 m .36392 .40063 L .38777 .39194 L p F P
0 0 0 r
s
.31 .449 .858 r
.38093 .38488 m .38777 .39194 L .36392 .40063 L p F P
0 0 0 r
s
.24 .35 .67 r
.373 .39861 m
.39587 .42183 L
s
.094 .106 .204 r
.45398 .66257 m .44611 .65578 L .43928 .64944 L p F P
0 0 0 r
s
.094 .106 .204 r
.43024 .64163 m .43928 .64944 L .44611 .65578 L p F P
0 0 0 r
s
.24 .35 .67 r
.43937 .64757 m
.45826 .6639 L
s
.42715 .6292 m
.43937 .64757 L
s
.136 .17 .302 r
.68162 .48393 m .67311 .47328 L .66096 .45572 L p F P
0 0 0 r
s
.185 .244 .417 r
.67311 .47328 m .68162 .48393 L .69011 .50274 L p F P
0 0 0 r
s
.24 .35 .67 r
.68492 .49375 m
.68709 .49789 L
s
.68709 .49789 m
.68787 .49886 L
s
.174 .276 .58 r
.58175 .38429 m .5875 .39136 L .6061 .39993 L p F P
0 0 0 r
s
.174 .276 .58 r
.61288 .40833 m .6061 .39993 L .5875 .39136 L p F P
0 0 0 r
s
.343 .084 .039 r
.58256 .61706 m .59941 .61192 L .60491 .59738 L p F P
0 0 0 r
s
.343 .084 .039 r
.62289 .59183 m .60491 .59738 L .59941 .61192 L p F P
0 0 0 r
s
.464 .121 .054 r
.62289 .59183 m .64106 .58623 L .64502 .56922 L p F P
0 0 0 r
s
.464 .121 .054 r
.66391 .56331 m .64502 .56922 L .64106 .58623 L p F P
0 0 0 r
s
.83 .24 .1 r
.60692 .58549 m
.64434 .57381 L
s
.64409 .55043 m
.64434 .57381 L
s
.303 .432 .811 r
.34729 .44636 m .35794 .45656 L .34722 .47417 L p F P
0 0 0 r
s
.24 .35 .67 r
.35469 .49687 m
.36408 .47093 L
s
.307 .441 .834 r
.35794 .45656 m .34729 .44636 L .36238 .43091 L p F P
0 0 0 r
s
.83 .24 .1 r
.29404 .41908 m
.26003 .43246 L
s
.26003 .43246 m
.2482 .44478 L
s
.309 .446 .849 r
.36238 .43091 m .35274 .42146 L .37227 .40903 L p F P
0 0 0 r
s
.309 .446 .849 r
.36392 .40063 m .37227 .40903 L .35274 .42146 L p F P
0 0 0 r
s
.83 .24 .1 r
.42673 .68005 m
.44038 .67536 L
s
.089 .134 .321 r
.66096 .45572 m .65281 .44551 L .63771 .43014 L p F P
0 0 0 r
s
.136 .17 .302 r
.65281 .44551 m .66096 .45572 L .67311 .47328 L p F P
0 0 0 r
s
1 .312 .132 r
.4828 .36173 m .47718 .36391 L .46604 .35808 L p F P
0 0 0 r
s
.24 .35 .67 r
.47587 .36374 m
.47643 .36352 L
s
.48167 .36148 m
.49235 .35733 L
s
1 .312 .132 r
.45774 .36133 m .46604 .35808 L .47718 .36391 L p F P
0 0 0 r
s
.307 .441 .834 r
.35274 .42146 m .36238 .43091 L .34729 .44636 L p F P
0 0 0 r
s
.24 .35 .67 r
.35471 .42275 m
.378 .44562 L
s
.247 .376 .756 r
.52656 .35997 m .52975 .36376 L .54427 .35785 L p F P
0 0 0 r
s
.247 .376 .756 r
.54891 .36347 m .54427 .35785 L .52975 .36376 L p F P
0 0 0 r
s
.24 .35 .67 r
.49235 .35733 m
.4961 .35656 L
s
.217 .336 .687 r
.55352 .36904 m .55809 .37457 L .57593 .37715 L p F P
0 0 0 r
s
.217 .336 .687 r
.58175 .38429 m .57593 .37715 L .55809 .37457 L p F P
0 0 0 r
s
.24 .35 .67 r
.53882 .37619 m
.56355 .3763 L
s
.56355 .3763 m
.583 .39992 L
s
.131 .209 .459 r
.6061 .39993 m .61288 .40833 L .63014 .42067 L p F P
0 0 0 r
s
.131 .209 .459 r
.63771 .43014 m .63014 .42067 L .61288 .40833 L p F P
0 0 0 r
s
.554 .149 .066 r
.66391 .56331 m .683 .55733 L .68359 .53879 L p F P
0 0 0 r
s
.83 .24 .1 r
.64409 .55043 m
.68182 .53841 L
s
.554 .149 .066 r
.70296 .53263 m .68359 .53879 L .683 .55733 L p F P
0 0 0 r
s
.24 .35 .67 r
.7021 .53369 m
.70957 .54284 L
s
.996 .304 .128 r
.43309 .37098 m .42495 .37417 L .40189 .37664 L p F P
0 0 0 r
s
.996 .304 .128 r
.39138 .38077 m .40189 .37664 L .42495 .37417 L p F P
0 0 0 r
s
.24 .35 .67 r
.39456 .3768 m
.39644 .37878 L
s
.089 .134 .321 r
.63014 .42067 m .63771 .43014 L .65281 .44551 L p F P
0 0 0 r
s
.147 .182 .324 r
.43024 .64163 m .42106 .63371 L .41417 .62252 L p F P
0 0 0 r
s
.147 .182 .324 r
.40398 .61367 m .41417 .62252 L .42106 .63371 L p F P
0 0 0 r
s
.24 .35 .67 r
.40485 .60977 m
.42715 .6292 L
s
.083 .024 .01 r
.47458 .66541 m .46175 .66927 L .46762 .6699 L p F P
0 0 0 r
s
.127 .202 .442 r
.45398 .66257 m .46175 .66927 L .46762 .6699 L p F P
0 0 0 r
s
.83 .24 .1 r
.46136 .66905 m
.46252 .6687 L
s
.44038 .67536 m
.46136 .66905 L
s
.24 .35 .67 r
.64443 .70747 m
.61777 .72047 L
s
.59867 .70243 m
.61777 .72047 L
s
.145 .037 .015 r
.50054 .65761 m .51367 .65367 L .51541 .64704 L p F P
0 0 0 r
s
.145 .037 .015 r
.53034 .64252 m .51541 .64704 L .51367 .65367 L p F P
0 0 0 r
s
.83 .24 .1 r
.48688 .6542 m
.52305 .64326 L
s
.52305 .64326 m
.53021 .62783 L
s
.229 .055 .024 r
.54539 .63797 m .56058 .63338 L .56587 .62215 L p F P
0 0 0 r
s
.229 .055 .024 r
.58256 .61706 m .56587 .62215 L .56058 .63338 L p F P
0 0 0 r
s
.83 .24 .1 r
.72035 .52614 m
.71652 .49986 L
s
.75544 .48718 m
.71652 .49986 L
s
.24 .35 .67 r
.57112 .71013 m
.54449 .71193 L
s
.52401 .69373 m
.54449 .71193 L
s
1 .312 .132 r
.48844 .35954 m .4828 .36173 L .47438 .35482 L p F P
0 0 0 r
s
1 .312 .132 r
.46604 .35808 m .47438 .35482 L .4828 .36173 L p F P
0 0 0 r
s
.83 .24 .1 r
.74894 .45896 m
.74045 .42993 L
s
.77964 .41649 m
.74045 .42993 L
s
.74045 .42993 m
.73028 .40104 L
s
.76938 .3873 m
.73028 .40104 L
s
.73028 .40104 m
.71877 .37326 L
s
.28666 .70319 m
.30496 .71052 L
s
.33955 .70007 m
.30496 .71052 L
s
.247 .376 .756 r
.52336 .35616 m .52656 .35997 L .53959 .35218 L p F P
0 0 0 r
s
.247 .376 .756 r
.54427 .35785 m .53959 .35218 L .52656 .35997 L p F P
0 0 0 r
s
.83 .24 .1 r
.54421 .35777 m
.5651 .34977 L
s
.70628 .3475 m
.66781 .36168 L
s
.66781 .36168 m
.65447 .33929 L
s
.996 .304 .128 r
.44127 .36778 m .43309 .37098 L .41246 .37248 L p F P
0 0 0 r
s
.24 .35 .67 r
.43067 .37116 m
.43088 .37139 L
s
.996 .304 .128 r
.40189 .37664 m .41246 .37248 L .43309 .37098 L p F P
0 0 0 r
s
.83 .24 .1 r
.65447 .33929 m
.61654 .35355 L
s
.61654 .35355 m
.60258 .33542 L
s
1 .312 .132 r
.49409 .35734 m .48844 .35954 L .48276 .35153 L p F P
0 0 0 r
s
1 .312 .132 r
.47438 .35482 m .48276 .35153 L .48844 .35954 L p F P
0 0 0 r
s
.24 .35 .67 r
.373 .39861 m
.38839 .38304 L
s
.39016 .38125 m
.39456 .3768 L
s
.31 .449 .858 r
.36392 .40063 m .35547 .39212 L .38093 .38488 L p F P
0 0 0 r
s
.865 .27 .112 r
.39138 .38077 m .38093 .38488 L .35547 .39212 L p F P
0 0 0 r
s
.343 .084 .039 r
.59941 .61192 m .61642 .60673 L .62289 .59183 L p F P
0 0 0 r
s
.83 .24 .1 r
.60378 .60528 m
.60692 .58549 L
s
.343 .084 .039 r
.64106 .58623 m .62289 .59183 L .61642 .60673 L p F P
0 0 0 r
s
.24 .35 .67 r
.69028 .62287 m
.70778 .64242 L
s
.70778 .64242 m
.69064 .66741 L
s
.174 .276 .58 r
.57593 .37715 m .58175 .38429 L .59924 .39141 L p F P
0 0 0 r
s
.174 .276 .58 r
.6061 .39993 m .59924 .39141 L .58175 .38429 L p F P
0 0 0 r
s
.464 .121 .054 r
.64106 .58623 m .65942 .58056 L .66391 .56331 L p F P
0 0 0 r
s
.464 .121 .054 r
.683 .55733 m .66391 .56331 L .65942 .58056 L p F P
0 0 0 r
s
.217 .336 .687 r
.54891 .36347 m .55352 .36904 L .57005 .36993 L p F P
0 0 0 r
s
.83 .24 .1 r
.5651 .34977 m
.57941 .36752 L
s
.217 .336 .687 r
.57593 .37715 m .57005 .36993 L .55352 .36904 L p F P
0 0 0 r
s
.083 .024 .01 r
.46762 .6699 m .4785 .66664 L .47458 .66541 L p F P
0 0 0 r
s
.24 .35 .67 r
.46556 .66968 m
.47805 .68048 L
s
.083 .024 .01 r
.48751 .66153 m .47458 .66541 L .4785 .66664 L p F P
0 0 0 r
s
1 .312 .132 r
.49976 .35514 m .49409 .35734 L .49118 .34824 L p F P
0 0 0 r
s
1 .312 .132 r
.48276 .35153 m .49118 .34824 L .49409 .35734 L p F P
0 0 0 r
s
.83 .24 .1 r
.75544 .48718 m
.74894 .45896 L
s
.78835 .44579 m
.74894 .45896 L
s
.234 .317 .566 r
.38768 .58964 m .3765 .57985 L .37302 .56257 L p F P
0 0 0 r
s
.234 .317 .566 r
.36127 .55216 m .37302 .56257 L .3765 .57985 L p F P
0 0 0 r
s
.24 .35 .67 r
.37384 .5437 m
.37506 .56781 L
s
.264 .365 .665 r
.37302 .56257 m .36127 .55216 L .36083 .53352 L p F P
0 0 0 r
s
.283 .397 .733 r
.36083 .53352 m .34882 .52271 L .35196 .50364 L p F P
0 0 0 r
s
.264 .365 .665 r
.34882 .52271 m .36083 .53352 L .36127 .55216 L p F P
0 0 0 r
s
.145 .037 .015 r
.51367 .65367 m .5269 .64969 L .53034 .64252 L p F P
0 0 0 r
s
.145 .037 .015 r
.54539 .63797 m .53034 .64252 L .5269 .64969 L p F P
0 0 0 r
s
.996 .304 .128 r
.44949 .36456 m .44127 .36778 L .4231 .36829 L p F P
0 0 0 r
s
.24 .35 .67 r
.41863 .35808 m
.42746 .36767 L
s
.4279 .36815 m
.42935 .36972 L
s
.996 .304 .128 r
.41246 .37248 m .4231 .36829 L .44127 .36778 L p F P
0 0 0 r
s
.24 .35 .67 r
.39456 .3768 m
.41863 .35808 L
s
.83 .24 .1 r
.39853 .38346 m
.42678 .37239 L
s
.42678 .37239 m
.44182 .37904 L
s
.24 .35 .67 r
.39571 .33319 m
.41863 .35808 L
s
.41863 .35808 m
.44439 .34314 L
s
.247 .376 .756 r
.52014 .35233 m .52336 .35616 L .53486 .34646 L p F P
0 0 0 r
s
.247 .376 .756 r
.53959 .35218 m .53486 .34646 L .52336 .35616 L p F P
0 0 0 r
s
.229 .055 .024 r
.56058 .63338 m .5759 .62875 L .58256 .61706 L p F P
0 0 0 r
s
.229 .055 .024 r
.59941 .61192 m .58256 .61706 L .5759 .62875 L p F P
0 0 0 r
s
.83 .24 .1 r
.56661 .61668 m
.60378 .60528 L
s
.2482 .44478 m
.21447 .45797 L
s
.21447 .45797 m
.20524 .47606 L
s
.283 .397 .733 r
.34002 .49268 m .35196 .50364 L .34882 .52271 L p F P
0 0 0 r
s
.295 .418 .779 r
.35196 .50364 m .34002 .49268 L .34722 .47417 L p F P
0 0 0 r
s
.24 .35 .67 r
.35031 .52248 m
.35469 .49687 L
s
.554 .149 .066 r
.683 .55733 m .7023 .55129 L .70296 .53263 L p F P
0 0 0 r
s
.235 .32 .564 r
.70296 .53263 m .69414 .5218 L .69011 .50274 L p F P
0 0 0 r
s
.272 .378 .683 r
.69414 .5218 m .70296 .53263 L .7023 .55129 L p F P
0 0 0 r
s
.83 .24 .1 r
.70234 .53188 m
.72035 .52614 L
s
.68182 .53841 m
.69737 .53346 L
s
.60258 .33542 m
.5651 .34977 L
s
.24 .35 .67 r
.66916 .68948 m
.64443 .70747 L
s
.62572 .6891 m
.64443 .70747 L
s
.83 .24 .1 r
.7579 .35916 m
.71877 .37326 L
s
.71877 .37326 m
.70628 .3475 L
s
.094 .106 .204 r
.44611 .65578 m .43814 .64891 L .43024 .64163 L p F P
0 0 0 r
s
.094 .106 .204 r
.42106 .63371 m .43024 .64163 L .43814 .64891 L p F P
0 0 0 r
s
.188 .246 .422 r
.40398 .61367 m .39361 .60468 L .38768 .58964 L p F P
0 0 0 r
s
.188 .246 .422 r
.3765 .57985 m .38768 .58964 L .39361 .60468 L p F P
0 0 0 r
s
.24 .35 .67 r
.37506 .56781 m
.39801 .58809 L
s
.309 .446 .849 r
.35274 .42146 m .34297 .41186 L .36392 .40063 L p F P
0 0 0 r
s
.309 .446 .849 r
.35547 .39212 m .36392 .40063 L .34297 .41186 L p F P
0 0 0 r
s
.24 .35 .67 r
.35471 .42275 m
.373 .39861 L
s
.83 .24 .1 r
.34203 .39951 m
.35369 .39492 L
s
1 .312 .132 r
.50546 .35293 m .49976 .35514 L .49965 .34492 L p F P
0 0 0 r
s
1 .312 .132 r
.49118 .34824 m .49965 .34492 L .49976 .35514 L p F P
0 0 0 r
s
.185 .244 .417 r
.69011 .50274 m .68128 .49177 L .67311 .47328 L p F P
0 0 0 r
s
.235 .32 .564 r
.68128 .49177 m .69011 .50274 L .69414 .5218 L p F P
0 0 0 r
s
.295 .418 .779 r
.33567 .46335 m .34722 .47417 L .34002 .49268 L p F P
0 0 0 r
s
.303 .432 .811 r
.34722 .47417 m .33567 .46335 L .34729 .44636 L p F P
0 0 0 r
s
.131 .209 .459 r
.59924 .39141 m .6061 .39993 L .62245 .41106 L p F P
0 0 0 r
s
.131 .209 .459 r
.63014 .42067 m .62245 .41106 L .6061 .39993 L p F P
0 0 0 r
s
.83 .24 .1 r
.37488 .68938 m
.39107 .69076 L
s
.42673 .68005 m
.39107 .69076 L
s
.865 .27 .112 r
.40189 .37664 m .39138 .38077 L .36805 .38715 L p F P
0 0 0 r
s
.865 .27 .112 r
.35547 .39212 m .36805 .38715 L .39138 .38077 L p F P
0 0 0 r
s
.24 .35 .67 r
.36405 .38953 m
.373 .39861 L
s
.127 .202 .442 r
.46762 .6699 m .46109 .66424 L .45398 .66257 L p F P
0 0 0 r
s
.83 .24 .1 r
.46529 .66787 m
.47631 .66456 L
s
.127 .202 .442 r
.44611 .65578 m .45398 .66257 L .46109 .66424 L p F P
0 0 0 r
s
.24 .35 .67 r
.43937 .64757 m
.45578 .66124 L
s
.303 .432 .811 r
.33647 .43599 m .34729 .44636 L .33567 .46335 L p F P
0 0 0 r
s
.24 .35 .67 r
.34039 .44838 m
.36408 .47093 L
s
.307 .441 .834 r
.34729 .44636 m .33647 .43599 L .35274 .42146 L p F P
0 0 0 r
s
.307 .441 .834 r
.34297 .41186 m .35274 .42146 L .33647 .43599 L p F P
0 0 0 r
s
.24 .35 .67 r
.34039 .44838 m
.35471 .42275 L
s
.136 .17 .302 r
.67311 .47328 m .66446 .46244 L .65281 .44551 L p F P
0 0 0 r
s
.24 .35 .67 r
.64336 .43953 m
.65871 .45541 L
s
.185 .244 .417 r
.66446 .46244 m .67311 .47328 L .68128 .49177 L p F P
0 0 0 r
s
.24 .35 .67 r
.65871 .45541 m
.66479 .46303 L
s
.67277 .64825 m
.69064 .66741 L
s
.69064 .66741 m
.66916 .68948 L
s
.70904 .56878 m
.70255 .5959 L
s
.83 .24 .1 r
.25246 .71367 m
.23348 .70035 L
s
.28666 .70319 m
.25246 .71367 L
s
.996 .304 .128 r
.45774 .36133 m .44949 .36456 L .43381 .36407 L p F P
0 0 0 r
s
.996 .304 .128 r
.4231 .36829 m .43381 .36407 L .44949 .36456 L p F P
0 0 0 r
s
.24 .35 .67 r
.52401 .69373 m
.49935 .68986 L
s
.47788 .67112 m
.49935 .68986 L
s
.089 .134 .321 r
.62245 .41106 m .63014 .42067 L .64453 .43512 L p F P
0 0 0 r
s
.24 .35 .67 r
.60546 .40557 m
.62486 .41644 L
s
.089 .134 .321 r
.65281 .44551 m .64453 .43512 L .63014 .42067 L p F P
0 0 0 r
s
.24 .35 .67 r
.62486 .41644 m
.64336 .43953 L
s
.136 .17 .302 r
.64453 .43512 m .65281 .44551 L .66446 .46244 L p F P
0 0 0 r
s
1 .312 .132 r
.51117 .35071 m .50546 .35293 L .50815 .34159 L p F P
0 0 0 r
s
1 .312 .132 r
.49965 .34492 m .50815 .34159 L .50546 .35293 L p F P
0 0 0 r
s
.83 .24 .1 r
.4774 .36523 m
.51374 .35113 L
s
.083 .024 .01 r
.4785 .66664 m .48944 .66335 L .48751 .66153 L p F P
0 0 0 r
s
.83 .24 .1 r
.47631 .66456 m
.48688 .6542 L
s
.083 .024 .01 r
.50054 .65761 m .48751 .66153 L .48944 .66335 L p F P
0 0 0 r
s
.24 .35 .67 r
.65087 .67073 m
.66916 .68948 L
s
.247 .376 .756 r
.5169 .34848 m .52014 .35233 L .5301 .3407 L p F P
0 0 0 r
s
.24 .35 .67 r
.5088 .35395 m
.51843 .35198 L
s
.83 .24 .1 r
.51374 .35113 m
.51917 .35583 L
s
.247 .376 .756 r
.53486 .34646 m .5301 .3407 L .52014 .35233 L p F P
0 0 0 r
s
.24 .35 .67 r
.51843 .35198 m
.53882 .37619 L
s
.217 .336 .687 r
.54427 .35785 m .54891 .36347 L .56411 .36264 L p F P
0 0 0 r
s
.217 .336 .687 r
.57005 .36993 m .56411 .36264 L .54891 .36347 L p F P
0 0 0 r
s
.147 .182 .324 r
.42106 .63371 m .41174 .62567 L .40398 .61367 L p F P
0 0 0 r
s
.147 .182 .324 r
.39361 .60468 m .40398 .61367 L .41174 .62567 L p F P
0 0 0 r
s
.343 .084 .039 r
.61642 .60673 m .6336 .60149 L .64106 .58623 L p F P
0 0 0 r
s
.343 .084 .039 r
.65942 .58056 m .64106 .58623 L .6336 .60149 L p F P
0 0 0 r
s
.145 .037 .015 r
.5269 .64969 m .54023 .64568 L .54539 .63797 L p F P
0 0 0 r
s
.145 .037 .015 r
.56058 .63338 m .54539 .63797 L .54023 .64568 L p F P
0 0 0 r
s
.464 .121 .054 r
.65942 .58056 m .67796 .57484 L .683 .55733 L p F P
0 0 0 r
s
.464 .121 .054 r
.7023 .55129 m .683 .55733 L .67796 .57484 L p F P
0 0 0 r
s
.83 .24 .1 r
.64434 .57381 m
.68257 .56189 L
s
.68182 .53841 m
.68257 .56189 L
s
1 .312 .132 r
.5169 .34848 m .51117 .35071 L .5167 .33825 L p F P
0 0 0 r
s
1 .312 .132 r
.50815 .34159 m .5167 .33825 L .51117 .35071 L p F P
0 0 0 r
s
.174 .276 .58 r
.57005 .36993 m .57593 .37715 L .59229 .38278 L p F P
0 0 0 r
s
.174 .276 .58 r
.59924 .39141 m .59229 .38278 L .57593 .37715 L p F P
0 0 0 r
s
.83 .24 .1 r
.29404 .41908 m
.28265 .4313 L
s
.865 .27 .112 r
.41246 .37248 m .40189 .37664 L .38074 .38215 L p F P
0 0 0 r
s
.865 .27 .112 r
.36805 .38715 m .38074 .38215 L .40189 .37664 L p F P
0 0 0 r
s
.83 .24 .1 r
.37703 .38573 m
.38741 .38608 L
s
.996 .304 .128 r
.46604 .35808 m .45774 .36133 L .44459 .35983 L p F P
0 0 0 r
s
.24 .35 .67 r
.44439 .34314 m
.45827 .35872 L
s
.996 .304 .128 r
.43381 .36407 m .44459 .35983 L .45774 .36133 L p F P
0 0 0 r
s
.83 .24 .1 r
.20524 .47606 m
.17182 .48898 L
s
.16585 .51203 m
.17182 .48898 L
s
.229 .055 .024 r
.5759 .62875 m .59136 .62408 L .59941 .61192 L p F P
0 0 0 r
s
.229 .055 .024 r
.61642 .60673 m .59941 .61192 L .59136 .62408 L p F P
0 0 0 r
s
.24 .35 .67 r
.42183 .31784 m
.44439 .34314 L
s
.44439 .34314 m
.47092 .33257 L
s
.83 .24 .1 r
.51374 .35113 m
.52013 .34865 L
s
.24 .35 .67 r
.59867 .70243 m
.57112 .71013 L
s
.55093 .69171 m
.57112 .71013 L
s
.83 .24 .1 r
.72035 .52614 m
.75971 .51361 L
s
.72162 .54971 m
.72035 .52614 L
s
.247 .376 .756 r
.5301 .3407 m .52529 .33488 L .5169 .34848 L p F P
0 0 0 r
s
1 .312 .132 r
.5167 .33825 m .52529 .33488 L .5169 .34848 L p F P
0 0 0 r
s
.24 .35 .67 r
.51481 .34768 m
.51843 .35198 L
s
.83 .24 .1 r
.75971 .51361 m
.75544 .48718 L
s
.7952 .47422 m
.75544 .48718 L
s
.083 .024 .01 r
.48944 .66335 m .50046 .66005 L .50054 .65761 L p F P
0 0 0 r
s
.083 .024 .01 r
.51367 .65367 m .50054 .65761 L .50046 .66005 L p F P
0 0 0 r
s
.83 .24 .1 r
.78835 .44579 m
.77964 .41649 L
s
.81967 .40277 m
.77964 .41649 L
s
.77964 .41649 m
.76938 .3873 L
s
.80931 .37325 m
.76938 .3873 L
s
.76938 .3873 m
.7579 .35916 L
s
.996 .304 .128 r
.47438 .35482 m .46604 .35808 L .45544 .35556 L p F P
0 0 0 r
s
.996 .304 .128 r
.44459 .35983 m .45544 .35556 L .46604 .35808 L p F P
0 0 0 r
s
.83 .24 .1 r
.46281 .35827 m
.4774 .36523 L
s
.217 .336 .687 r
.53959 .35218 m .54427 .35785 L .5581 .35525 L p F P
0 0 0 r
s
.217 .336 .687 r
.56411 .36264 m .5581 .35525 L .54427 .35785 L p F P
0 0 0 r
s
.309 .446 .849 r
.34297 .41186 m .33304 .40212 L .35547 .39212 L p F P
0 0 0 r
s
.083 .024 .01 r
.36805 .38715 m .35547 .39212 L .33304 .40212 L p F P
0 0 0 r
s
.83 .24 .1 r
.36359 .39102 m
.37703 .38573 L
s
.24 .35 .67 r
.36329 .38876 m
.36349 .38896 L
s
.83 .24 .1 r
.3216 .69249 m
.33955 .70007 L
s
.37488 .68938 m
.33955 .70007 L
s
.865 .27 .112 r
.4231 .36829 m .41246 .37248 L .39352 .37711 L p F P
0 0 0 r
s
.865 .27 .112 r
.38074 .38215 m .39352 .37711 L .41246 .37248 L p F P
0 0 0 r
s
.131 .209 .459 r
.59229 .38278 m .59924 .39141 L .61465 .4013 L p F P
0 0 0 r
s
.131 .209 .459 r
.62245 .41106 m .61465 .4013 L .59924 .39141 L p F P
0 0 0 r
s
.83 .24 .1 r
.74557 .33302 m
.70628 .3475 L
s
.70628 .3475 m
.69321 .32471 L
s
.094 .106 .204 r
.43814 .64891 m .43006 .64194 L .42106 .63371 L p F P
0 0 0 r
s
.094 .106 .204 r
.41174 .62567 m .42106 .63371 L .43006 .64194 L p F P
0 0 0 r
s
.24 .35 .67 r
.41698 .62821 m
.43937 .64757 L
s
.83 .24 .1 r
.69321 .32471 m
.65447 .33929 L
s
.65447 .33929 m
.64088 .32076 L
s
.127 .202 .442 r
.46109 .66424 m .45449 .65851 L .44611 .65578 L p F P
0 0 0 r
s
.127 .202 .442 r
.43814 .64891 m .44611 .65578 L .45449 .65851 L p F P
0 0 0 r
s
.145 .037 .015 r
.54023 .64568 m .55367 .64165 L .56058 .63338 L p F P
0 0 0 r
s
.145 .037 .015 r
.5759 .62875 m .56058 .63338 L .55367 .64165 L p F P
0 0 0 r
s
.83 .24 .1 r
.52305 .64326 m
.55999 .63207 L
s
.55999 .63207 m
.56661 .61668 L
s
.234 .317 .566 r
.3765 .57985 m .36511 .56989 L .36127 .55216 L p F P
0 0 0 r
s
.234 .317 .566 r
.34931 .54156 m .36127 .55216 L .36511 .56989 L p F P
0 0 0 r
s
.264 .365 .665 r
.36127 .55216 m .34931 .54156 L .34882 .52271 L p F P
0 0 0 r
s
.24 .35 .67 r
.35031 .52248 m
.37384 .5437 L
s
.283 .397 .733 r
.34882 .52271 m .33659 .51169 L .34002 .49268 L p F P
0 0 0 r
s
.264 .365 .665 r
.33659 .51169 m .34882 .52271 L .34931 .54156 L p F P
0 0 0 r
s
.343 .084 .039 r
.6336 .60149 m .65094 .5962 L .65942 .58056 L p F P
0 0 0 r
s
.83 .24 .1 r
.64175 .59364 m
.64434 .57381 L
s
.343 .084 .039 r
.67796 .57484 m .65942 .58056 L .65094 .5962 L p F P
0 0 0 r
s
.307 .441 .834 r
.33647 .43599 m .32547 .42545 L .34297 .41186 L p F P
0 0 0 r
s
.307 .441 .834 r
.33304 .40212 m .34297 .41186 L .32547 .42545 L p F P
0 0 0 r
s
.83 .24 .1 r
.29404 .41908 m
.32877 .40542 L
s
.32877 .40542 m
.33251 .40375 L
s
.283 .397 .733 r
.32785 .48152 m .34002 .49268 L .33659 .51169 L p F P
0 0 0 r
s
.295 .418 .779 r
.34002 .49268 m .32785 .48152 L .33567 .46335 L p F P
0 0 0 r
s
.464 .121 .054 r
.67796 .57484 m .6967 .56905 L .7023 .55129 L p F P
0 0 0 r
s
.272 .378 .683 r
.7023 .55129 m .69351 .54067 L .69414 .5218 L p F P
0 0 0 r
s
.294 .415 .762 r
.69351 .54067 m .7023 .55129 L .6967 .56905 L p F P
0 0 0 r
s
.83 .24 .1 r
.70114 .5561 m
.72162 .54971 L
s
.24 .35 .67 r
.70014 .55813 m
.70904 .56878 L
s
.83 .24 .1 r
.70004 .55645 m
.70114 .5561 L
s
.68257 .56189 m
.69544 .55788 L
s
.188 .246 .422 r
.39361 .60468 m .38307 .59554 L .3765 .57985 L p F P
0 0 0 r
s
.188 .246 .422 r
.36511 .56989 m .3765 .57985 L .38307 .59554 L p F P
0 0 0 r
s
.24 .35 .67 r
.37506 .56781 m
.38172 .58962 L
s
.996 .304 .128 r
.48276 .35153 m .47438 .35482 L .46636 .35127 L p F P
0 0 0 r
s
.996 .304 .128 r
.45544 .35556 m .46636 .35127 L .47438 .35482 L p F P
0 0 0 r
s
.235 .32 .564 r
.69414 .5218 m .68516 .51077 L .68128 .49177 L p F P
0 0 0 r
s
.272 .378 .683 r
.68516 .51077 m .69414 .5218 L .69351 .54067 L p F P
0 0 0 r
s
.229 .055 .024 r
.59136 .62408 m .60695 .61936 L .61642 .60673 L p F P
0 0 0 r
s
.229 .055 .024 r
.6336 .60149 m .61642 .60673 L .60695 .61936 L p F P
0 0 0 r
s
.83 .24 .1 r
.60378 .60528 m
.64175 .59364 L
s
.174 .276 .58 r
.56411 .36264 m .57005 .36993 L .58524 .37403 L p F P
0 0 0 r
s
.174 .276 .58 r
.59229 .38278 m .58524 .37403 L .57005 .36993 L p F P
0 0 0 r
s
.24 .35 .67 r
.58617 .38174 m
.60546 .40557 L
s
.56355 .3763 m
.58617 .38174 L
s
.83 .24 .1 r
.7952 .47422 m
.78835 .44579 L
s
.82861 .43234 m
.78835 .44579 L
s
.295 .418 .779 r
.32391 .45233 m .33567 .46335 L .32785 .48152 L p F P
0 0 0 r
s
.24 .35 .67 r
.33062 .47461 m
.35469 .49687 L
s
.303 .432 .811 r
.33567 .46335 m .32391 .45233 L .33647 .43599 L p F P
0 0 0 r
s
.089 .134 .321 r
.61465 .4013 m .62245 .41106 L .63611 .42456 L p F P
0 0 0 r
s
.089 .134 .321 r
.64453 .43512 m .63611 .42456 L .62245 .41106 L p F P
0 0 0 r
s
.303 .432 .811 r
.32547 .42545 m .33647 .43599 L .32391 .45233 L p F P
0 0 0 r
s
.24 .35 .67 r
.33062 .47461 m
.34039 .44838 L
s
.185 .244 .417 r
.68128 .49177 m .67228 .48059 L .66446 .46244 L p F P
0 0 0 r
s
.235 .32 .564 r
.67228 .48059 m .68128 .49177 L .68516 .51077 L p F P
0 0 0 r
s
.083 .024 .01 r
.50046 .66005 m .51154 .65673 L .51367 .65367 L p F P
0 0 0 r
s
.083 .024 .01 r
.5269 .64969 m .51367 .65367 L .51154 .65673 L p F P
0 0 0 r
s
.136 .17 .302 r
.66446 .46244 m .65564 .45141 L .64453 .43512 L p F P
0 0 0 r
s
.185 .244 .417 r
.65564 .45141 m .66446 .46244 L .67228 .48059 L p F P
0 0 0 r
s
.24 .35 .67 r
.66669 .47079 m
.66923 .47567 L
s
.66923 .47567 m
.67009 .47674 L
s
.83 .24 .1 r
.28265 .4313 m
.2482 .44478 L
s
.2482 .44478 m
.2394 .46286 L
s
.136 .17 .302 r
.63611 .42456 m .64453 .43512 L .65564 .45141 L p F P
0 0 0 r
s
.24 .35 .67 r
.70255 .5959 m
.69028 .62287 L
s
.83 .24 .1 r
.64088 .32076 m
.60258 .33542 L
s
.60258 .33542 m
.58878 .322 L
s
.865 .27 .112 r
.43381 .36407 m .4231 .36829 L .4064 .37203 L p F P
0 0 0 r
s
.83 .24 .1 r
.42678 .37239 m
.46281 .35827 L
s
.865 .27 .112 r
.39352 .37711 m .4064 .37203 L .4231 .36829 L p F P
0 0 0 r
s
.24 .35 .67 r
.37124 .35232 m
.39449 .37673 L
s
.83 .24 .1 r
.79788 .34475 m
.7579 .35916 L
s
.7579 .35916 m
.74557 .33302 L
s
.083 .024 .01 r
.38074 .38215 m .36805 .38715 L .34749 .39642 L p F P
0 0 0 r
s
.083 .024 .01 r
.33304 .40212 m .34749 .39642 L .36805 .38715 L p F P
0 0 0 r
s
.217 .336 .687 r
.53486 .34646 m .53959 .35218 L .55202 .34779 L p F P
0 0 0 r
s
.217 .336 .687 r
.5581 .35525 m .55202 .34779 L .53959 .35218 L p F P
0 0 0 r
s
.24 .35 .67 r
.51843 .35198 m
.54338 .3518 L
s
.147 .182 .324 r
.41174 .62567 m .40228 .6175 L .39361 .60468 L p F P
0 0 0 r
s
.24 .35 .67 r
.40485 .60977 m
.41698 .62821 L
s
.147 .182 .324 r
.38307 .59554 m .39361 .60468 L .40228 .6175 L p F P
0 0 0 r
s
.24 .35 .67 r
.38172 .58962 m
.40485 .60977 L
s
.996 .304 .128 r
.49118 .34824 m .48276 .35153 L .47735 .34694 L p F P
0 0 0 r
s
.996 .304 .128 r
.46636 .35127 m .47735 .34694 L .48276 .35153 L p F P
0 0 0 r
s
.24 .35 .67 r
.47092 .33257 m
.48389 .34755 L
s
.83 .24 .1 r
.41099 .67847 m
.42673 .68005 L
s
.145 .037 .015 r
.55367 .64165 m .56721 .63758 L .5759 .62875 L p F P
0 0 0 r
s
.145 .037 .015 r
.59136 .62408 m .5759 .62875 L .56721 .63758 L p F P
0 0 0 r
s
.83 .24 .1 r
.26794 .68959 m
.28666 .70319 L
s
.3216 .69249 m
.28666 .70319 L
s
.24 .35 .67 r
.44869 .30686 m
.47092 .33257 L
s
.47092 .33257 m
.49728 .32686 L
s
.763 .242 .101 r
.4785 .66664 m .46762 .6699 L .47452 .66634 L p F P
0 0 0 r
s
.168 .272 .57 r
.46109 .66424 m .46762 .6699 L .47452 .66634 L p F P
0 0 0 r
s
.83 .24 .1 r
.46639 .66798 m
.46697 .66778 L
s
.4722 .66598 m
.47631 .66456 L
s
.24 .35 .67 r
.47264 .66884 m
.47788 .67112 L
s
.46014 .66341 m
.46257 .66447 L
s
.4717 .66843 m
.47264 .66884 L
s
.83 .24 .1 r
.42673 .68005 m
.46316 .6691 L
s
.46316 .6691 m
.46639 .66798 L
s
.24 .35 .67 r
.62572 .6891 m
.59867 .70243 L
s
.57884 .68372 m
.59867 .70243 L
s
.343 .084 .039 r
.65094 .5962 m .66845 .59086 L .67796 .57484 L p F P
0 0 0 r
s
.343 .084 .039 r
.6967 .56905 m .67796 .57484 L .66845 .59086 L p F P
0 0 0 r
s
.083 .024 .01 r
.51154 .65673 m .5227 .65338 L .5269 .64969 L p F P
0 0 0 r
s
.83 .24 .1 r
.47631 .66456 m
.51301 .65352 L
s
.083 .024 .01 r
.54023 .64568 m .5269 .64969 L .5227 .65338 L p F P
0 0 0 r
s
.83 .24 .1 r
.51301 .65352 m
.52305 .64326 L
s
.865 .27 .112 r
.44459 .35983 m .43381 .36407 L .41938 .36691 L p F P
0 0 0 r
s
.865 .27 .112 r
.4064 .37203 m .41938 .36691 L .43381 .36407 L p F P
0 0 0 r
s
.83 .24 .1 r
.41279 .37165 m
.42678 .37239 L
s
.24 .35 .67 r
.55093 .69171 m
.52401 .69373 L
s
.50275 .67484 m
.52401 .69373 L
s
.996 .304 .128 r
.49965 .34492 m .49118 .34824 L .48841 .34259 L p F P
0 0 0 r
s
.996 .304 .128 r
.47735 .34694 m .48841 .34259 L .49118 .34824 L p F P
0 0 0 r
s
.131 .209 .459 r
.58524 .37403 m .59229 .38278 L .60673 .3914 L p F P
0 0 0 r
s
.131 .209 .459 r
.61465 .4013 m .60673 .3914 L .59229 .38278 L p F P
0 0 0 r
s
.229 .055 .024 r
.60695 .61936 m .62268 .61461 L .6336 .60149 L p F P
0 0 0 r
s
.229 .055 .024 r
.65094 .5962 m .6336 .60149 L .62268 .61461 L p F P
0 0 0 r
s
.127 .202 .442 r
.45449 .65851 m .44781 .65272 L .43814 .64891 L p F P
0 0 0 r
s
.127 .202 .442 r
.43006 .64194 m .43814 .64891 L .44781 .65272 L p F P
0 0 0 r
s
.083 .024 .01 r
.39352 .37711 m .38074 .38215 L .36207 .39068 L p F P
0 0 0 r
s
.083 .024 .01 r
.34749 .39642 m .36207 .39068 L .38074 .38215 L p F P
0 0 0 r
s
.24 .35 .67 r
.34927 .37452 m
.36329 .38876 L
s
.174 .276 .58 r
.5581 .35525 m .56411 .36264 L .5781 .36516 L p F P
0 0 0 r
s
.24 .35 .67 r
.54338 .3518 m
.56355 .3763 L
s
.174 .276 .58 r
.58524 .37403 m .5781 .36516 L .56411 .36264 L p F P
0 0 0 r
s
.83 .24 .1 r
.32877 .40542 m
.33244 .40397 L
s
.2394 .46286 m
.20524 .47606 L
s
.20524 .47606 m
.19966 .49919 L
s
.094 .106 .204 r
.43006 .64194 m .42187 .63487 L .41174 .62567 L p F P
0 0 0 r
s
.094 .106 .204 r
.40228 .6175 m .41174 .62567 L .42187 .63487 L p F P
0 0 0 r
s
.83 .24 .1 r
.23348 .70035 m
.21511 .68126 L
s
.26794 .68959 m
.23348 .70035 L
s
.217 .336 .687 r
.5301 .3407 m .53486 .34646 L .54587 .34025 L p F P
0 0 0 r
s
.217 .336 .687 r
.55202 .34779 m .54587 .34025 L .53486 .34646 L p F P
0 0 0 r
s
.83 .24 .1 r
.54144 .34037 m
.55085 .33672 L
s
.55085 .33672 m
.5651 .34977 L
s
.58878 .322 m
.55085 .33672 L
s
.24 .35 .67 r
.34927 .37452 m
.37124 .35232 L
s
.34705 .32691 m
.37124 .35232 L
s
.37124 .35232 m
.39571 .33319 L
s
.763 .242 .101 r
.47452 .66634 m .48309 .66377 L .4785 .66664 L p F P
0 0 0 r
s
.763 .242 .101 r
.48944 .66335 m .4785 .66664 L .48309 .66377 L p F P
0 0 0 r
s
.83 .24 .1 r
.75971 .51361 m
.79993 .50081 L
s
.76152 .53727 m
.75971 .51361 L
s
.24 .35 .67 r
.32464 .34952 m
.34927 .37452 L
s
.996 .304 .128 r
.50815 .34159 m .49965 .34492 L .49954 .33821 L p F P
0 0 0 r
s
.996 .304 .128 r
.48841 .34259 m .49954 .33821 L .49965 .34492 L p F P
0 0 0 r
s
.83 .24 .1 r
.49961 .34385 m
.51374 .35113 L
s
.307 .441 .834 r
.32547 .42545 m .31428 .41472 L .33304 .40212 L p F P
0 0 0 r
s
.092 .026 .011 r
.34749 .39642 m .33304 .40212 L .31428 .41472 L p F P
0 0 0 r
s
.24 .35 .67 r
.33056 .39903 m
.34927 .37452 L
s
.33056 .39903 m
.33356 .40197 L
s
.33356 .40197 m
.33368 .40209 L
s
.33494 .40333 m
.35471 .42275 L
s
.83 .24 .1 r
.79993 .50081 m
.7952 .47422 L
s
.83583 .46098 m
.7952 .47422 L
s
.145 .037 .015 r
.56721 .63758 m .58085 .63348 L .59136 .62408 L p F P
0 0 0 r
s
.145 .037 .015 r
.60695 .61936 m .59136 .62408 L .58085 .63348 L p F P
0 0 0 r
s
.83 .24 .1 r
.55999 .63207 m
.59772 .62065 L
s
.59772 .62065 m
.60378 .60528 L
s
.24 .35 .67 r
.69028 .62287 m
.67277 .64825 L
s
.83 .24 .1 r
.82861 .43234 m
.81967 .40277 L
s
.81967 .40277 m
.80931 .37325 L
s
.865 .27 .112 r
.45544 .35556 m .44459 .35983 L .43246 .36175 L p F P
0 0 0 r
s
.865 .27 .112 r
.41938 .36691 m .43246 .36175 L .44459 .35983 L p F P
0 0 0 r
s
.089 .134 .321 r
.60673 .3914 m .61465 .4013 L .62755 .41382 L p F P
0 0 0 r
s
.089 .134 .321 r
.63611 .42456 m .62755 .41382 L .61465 .4013 L p F P
0 0 0 r
s
.83 .24 .1 r
.80931 .37325 m
.79788 .34475 L
s
.19966 .49919 m
.16585 .51203 L
s
.16402 .53904 m
.16585 .51203 L
s
.083 .024 .01 r
.5227 .65338 m .53393 .65002 L .54023 .64568 L p F P
0 0 0 r
s
.083 .024 .01 r
.55367 .64165 m .54023 .64568 L .53393 .65002 L p F P
0 0 0 r
s
.234 .317 .566 r
.36511 .56989 m .35352 .55974 L .34931 .54156 L p F P
0 0 0 r
s
.234 .317 .566 r
.33713 .53076 m .34931 .54156 L .35352 .55974 L p F P
0 0 0 r
s
.24 .35 .67 r
.35031 .52248 m
.35126 .54677 L
s
.264 .365 .665 r
.34931 .54156 m .33713 .53076 L .33659 .51169 L p F P
0 0 0 r
s
.283 .397 .733 r
.33659 .51169 m .32413 .50047 L .32785 .48152 L p F P
0 0 0 r
s
.264 .365 .665 r
.32413 .50047 m .33659 .51169 L .33713 .53076 L p F P
0 0 0 r
s
.188 .246 .422 r
.38307 .59554 m .37235 .58624 L .36511 .56989 L p F P
0 0 0 r
s
.188 .246 .422 r
.35352 .55974 m .36511 .56989 L .37235 .58624 L p F P
0 0 0 r
s
.24 .35 .67 r
.35126 .54677 m
.37506 .56781 L
s
.303 .432 .811 r
.32391 .45233 m .31194 .44112 L .32547 .42545 L p F P
0 0 0 r
s
.303 .432 .811 r
.31428 .41472 m .32547 .42545 L .31194 .44112 L p F P
0 0 0 r
s
.83 .24 .1 r
.35731 .68155 m
.37488 .68938 L
s
.41099 .67847 m
.37488 .68938 L
s
.24 .35 .67 r
.37192 .30736 m
.39571 .33319 L
s
.39571 .33319 m
.42183 .31784 L
s
.168 .272 .57 r
.47452 .66634 m .46942 .66188 L .46109 .66424 L p F P
0 0 0 r
s
.168 .272 .57 r
.45449 .65851 m .46109 .66424 L .46942 .66188 L p F P
0 0 0 r
s
.83 .24 .1 r
.78572 .31822 m
.74557 .33302 L
s
.74557 .33302 m
.73279 .30982 L
s
.283 .397 .733 r
.31545 .47015 m .32785 .48152 L .32413 .50047 L p F P
0 0 0 r
s
.295 .418 .779 r
.32785 .48152 m .31545 .47015 L .32391 .45233 L p F P
0 0 0 r
s
.24 .35 .67 r
.32589 .50047 m
.33062 .47461 L
s
.272 .378 .683 r
.69351 .54067 m .68455 .52985 L .68516 .51077 L p F P
0 0 0 r
s
.294 .415 .762 r
.68455 .52985 m .69351 .54067 L .6881 .55889 L p F P
0 0 0 r
s
.294 .415 .762 r
.6967 .56905 m .6881 .55889 L .69351 .54067 L p F P
0 0 0 r
s
.83 .24 .1 r
.73279 .30982 m
.69321 .32471 L
s
.69321 .32471 m
.68 .30578 L
s
.24 .35 .67 r
.65087 .67073 m
.62572 .6891 L
s
.6063 .67003 m
.62572 .6891 L
s
.083 .024 .01 r
.4064 .37203 m .39352 .37711 L .37678 .38488 L p F P
0 0 0 r
s
.083 .024 .01 r
.36207 .39068 m .37678 .38488 L .39352 .37711 L p F P
0 0 0 r
s
.83 .24 .1 r
.37703 .38573 m
.41279 .37165 L
s
.295 .418 .779 r
.31194 .44112 m .32391 .45233 L .31545 .47015 L p F P
0 0 0 r
s
.24 .35 .67 r
.31581 .42499 m
.34039 .44838 L
s
.235 .32 .564 r
.68516 .51077 m .67601 .49953 L .67228 .48059 L p F P
0 0 0 r
s
.272 .378 .683 r
.67601 .49953 m .68516 .51077 L .68455 .52985 L p F P
0 0 0 r
s
.83 .24 .1 r
.72019 .5696 m
.72162 .54971 L
s
.76152 .53727 m
.72162 .54971 L
s
.343 .084 .039 r
.66845 .59086 m .68613 .58547 L .6967 .56905 L p F P
0 0 0 r
s
.83 .24 .1 r
.68055 .58175 m
.68257 .56189 L
s
.308 .438 .814 r
.6881 .55889 m .6967 .56905 L .68613 .58547 L p F P
0 0 0 r
s
.24 .35 .67 r
.68931 .58054 m
.70255 .5959 L
s
.136 .17 .302 r
.62755 .41382 m .63611 .42456 L .64667 .44018 L p F P
0 0 0 r
s
.136 .17 .302 r
.65564 .45141 m .64667 .44018 L .63611 .42456 L p F P
0 0 0 r
s
.24 .35 .67 r
.62486 .41644 m
.64023 .43229 L
s
.996 .304 .128 r
.5167 .33825 m .50815 .34159 L .51074 .3338 L p F P
0 0 0 r
s
.996 .304 .128 r
.49954 .33821 m .51074 .3338 L .50815 .34159 L p F P
0 0 0 r
s
.24 .35 .67 r
.49728 .32686 m
.50502 .33605 L
s
.229 .055 .024 r
.62268 .61461 m .63855 .60981 L .65094 .5962 L p F P
0 0 0 r
s
.229 .055 .024 r
.66845 .59086 m .65094 .5962 L .63855 .60981 L p F P
0 0 0 r
s
.83 .24 .1 r
.64175 .59364 m
.68055 .58175 L
s
.185 .244 .417 r
.67228 .48059 m .66312 .46919 L .65564 .45141 L p F P
0 0 0 r
s
.235 .32 .564 r
.66312 .46919 m .67228 .48059 L .67601 .49953 L p F P
0 0 0 r
s
.24 .35 .67 r
.67252 .49132 m
.67425 .49953 L
s
.763 .242 .101 r
.48309 .66377 m .4917 .66119 L .48944 .66335 L p F P
0 0 0 r
s
.763 .242 .101 r
.50046 .66005 m .48944 .66335 L .4917 .66119 L p F P
0 0 0 r
s
.185 .244 .417 r
.64667 .44018 m .65564 .45141 L .66312 .46919 L p F P
0 0 0 r
s
.24 .35 .67 r
.64023 .43229 m
.64699 .44076 L
s
.147 .182 .324 r
.40228 .6175 m .39267 .60921 L .38307 .59554 L p F P
0 0 0 r
s
.147 .182 .324 r
.37235 .58624 m .38307 .59554 L .39267 .60921 L p F P
0 0 0 r
s
.217 .336 .687 r
.52529 .33488 m .5301 .3407 L .53966 .33261 L p F P
0 0 0 r
s
.217 .336 .687 r
.54587 .34025 m .53966 .33261 L .5301 .3407 L p F P
0 0 0 r
s
.865 .27 .112 r
.46636 .35127 m .45544 .35556 L .44565 .35655 L p F P
0 0 0 r
s
.83 .24 .1 r
.46281 .35827 m
.49961 .34385 L
s
.865 .27 .112 r
.43246 .36175 m .44565 .35655 L .45544 .35556 L p F P
0 0 0 r
s
.83 .24 .1 r
.44932 .35727 m
.46281 .35827 L
s
.24 .35 .67 r
.65421 .62837 m
.67277 .64825 L
s
.67277 .64825 m
.65087 .67073 L
s
.83 .24 .1 r
.83583 .46098 m
.82861 .43234 L
s
.174 .276 .58 r
.55202 .34779 m .5581 .35525 L .57087 .35618 L p F P
0 0 0 r
s
.174 .276 .58 r
.5781 .36516 m .57087 .35618 L .5581 .35525 L p F P
0 0 0 r
s
.24 .35 .67 r
.50275 .67484 m
.47788 .67112 L
s
.47348 .66727 m
.47788 .67112 L
s
.63188 .65126 m
.65087 .67073 L
s
.131 .209 .459 r
.5781 .36516 m .58524 .37403 L .59868 .38134 L p F P
0 0 0 r
s
.131 .209 .459 r
.60673 .3914 m .59868 .38134 L .58524 .37403 L p F P
0 0 0 r
s
.092 .026 .011 r
.36207 .39068 m .34749 .39642 L .33027 .40845 L p F P
0 0 0 r
s
.83 .24 .1 r
.33716 .40211 m
.34215 .40015 L
s
.092 .026 .011 r
.31428 .41472 m .33027 .40845 L .34749 .39642 L p F P
0 0 0 r
s
.24 .35 .67 r
.32575 .40749 m
.33056 .39903 L
s
.31581 .42499 m
.32376 .411 L
s
.145 .037 .015 r
.58085 .63348 m .59461 .62934 L .60695 .61936 L p F P
0 0 0 r
s
.145 .037 .015 r
.62268 .61461 m .60695 .61936 L .59461 .62934 L p F P
0 0 0 r
s
.127 .202 .442 r
.44781 .65272 m .44105 .64687 L .43006 .64194 L p F P
0 0 0 r
s
.127 .202 .442 r
.42187 .63487 m .43006 .64194 L .44105 .64687 L p F P
0 0 0 r
s
.24 .35 .67 r
.43409 .64245 m
.43436 .64269 L
s
.83 .24 .1 r
.28265 .4313 m
.2743 .44937 L
s
.68 .30578 m
.64088 .32076 L
s
.64088 .32076 m
.62754 .30695 L
s
.083 .024 .01 r
.53393 .65002 m .54523 .64663 L .55367 .64165 L p F P
0 0 0 r
s
.083 .024 .01 r
.56721 .63758 m .55367 .64165 L .54523 .64663 L p F P
0 0 0 r
s
.83 .24 .1 r
.79788 .34475 m
.78572 .31822 L
s
.996 .304 .128 r
.52529 .33488 m .5167 .33825 L .52202 .32936 L p F P
0 0 0 r
s
.996 .304 .128 r
.51074 .3338 m .52202 .32936 L .5167 .33825 L p F P
0 0 0 r
s
.763 .242 .101 r
.4917 .66119 m .50036 .65859 L .50046 .66005 L p F P
0 0 0 r
s
.763 .242 .101 r
.51154 .65673 m .50046 .66005 L .50036 .65859 L p F P
0 0 0 r
s
.083 .024 .01 r
.41938 .36691 m .4064 .37203 L .39162 .37904 L p F P
0 0 0 r
s
.083 .024 .01 r
.37678 .38488 m .39162 .37904 L .4064 .37203 L p F P
0 0 0 r
s
.83 .24 .1 r
.44789 .66731 m
.46316 .6691 L
s
.46316 .6691 m
.47058 .66687 L
s
.094 .106 .204 r
.42187 .63487 m .41358 .62771 L .40228 .6175 L p F P
0 0 0 r
s
.24 .35 .67 r
.41698 .62821 m
.43409 .64245 L
s
.094 .106 .204 r
.39267 .60921 m .40228 .6175 L .41358 .62771 L p F P
0 0 0 r
s
.24 .35 .67 r
.47531 .30077 m
.49728 .32686 L
s
.83 .24 .1 r
.30316 .67858 m
.3216 .69249 L
s
.35731 .68155 m
.3216 .69249 L
s
.6894 .57904 m
.72019 .5696 L
s
.68055 .58175 m
.68655 .57991 L
s
.865 .27 .112 r
.47735 .34694 m .46636 .35127 L .45894 .35131 L p F P
0 0 0 r
s
.865 .27 .112 r
.44565 .35655 m .45894 .35131 L .46636 .35127 L p F P
0 0 0 r
s
.24 .35 .67 r
.39841 .29157 m
.42183 .31784 L
s
.42183 .31784 m
.44869 .30686 L
s
.168 .272 .57 r
.46942 .66188 m .46427 .65738 L .45449 .65851 L p F P
0 0 0 r
s
.168 .272 .57 r
.44781 .65272 m .45449 .65851 L .46427 .65738 L p F P
0 0 0 r
s
.229 .055 .024 r
.63855 .60981 m .65456 .60497 L .66845 .59086 L p F P
0 0 0 r
s
.83 .24 .1 r
.63628 .60898 m
.64175 .59364 L
s
.229 .055 .024 r
.68613 .58547 m .66845 .59086 L .65456 .60497 L p F P
0 0 0 r
s
.24 .35 .67 r
.57884 .68372 m
.55093 .69171 L
s
.52997 .67258 m
.55093 .69171 L
s
.217 .336 .687 r
.53966 .33261 m .53337 .3249 L .52529 .33488 L p F P
0 0 0 r
s
.83 .24 .1 r
.5369 .32923 m
.53723 .32911 L
s
.996 .304 .128 r
.52202 .32936 m .53337 .3249 L .52529 .33488 L p F P
0 0 0 r
s
.24 .35 .67 r
.52671 .33156 m
.54338 .3518 L
s
.83 .24 .1 r
.49961 .34385 m
.52961 .33209 L
s
.24 .35 .67 r
.49728 .32686 m
.52244 .32637 L
s
.52244 .32637 m
.5242 .32851 L
s
.089 .134 .321 r
.59868 .38134 m .60673 .3914 L .61883 .4029 L p F P
0 0 0 r
s
.24 .35 .67 r
.58617 .38174 m
.60566 .39248 L
s
.089 .134 .321 r
.62755 .41382 m .61883 .4029 L .60673 .3914 L p F P
0 0 0 r
s
.24 .35 .67 r
.60566 .39248 m
.62486 .41644 L
s
.083 .024 .01 r
.54523 .64663 m .55661 .64322 L .56721 .63758 L p F P
0 0 0 r
s
.083 .024 .01 r
.58085 .63348 m .56721 .63758 L .55661 .64322 L p F P
0 0 0 r
s
.83 .24 .1 r
.55051 .64225 m
.55999 .63207 L
s
.092 .026 .011 r
.37678 .38488 m .36207 .39068 L .34641 .40211 L p F P
0 0 0 r
s
.83 .24 .1 r
.35219 .3962 m
.35722 .39422 L
s
.36875 .38944 m
.37703 .38573 L
s
.092 .026 .011 r
.33027 .40845 m .34641 .40211 L .36207 .39068 L p F P
0 0 0 r
s
.24 .35 .67 r
.30548 .3744 m
.33056 .39903 L
s
.145 .037 .015 r
.59461 .62934 m .60846 .62518 L .62268 .61461 L p F P
0 0 0 r
s
.145 .037 .015 r
.63855 .60981 m .62268 .61461 L .60846 .62518 L p F P
0 0 0 r
s
.83 .24 .1 r
.59772 .62065 m
.63628 .60898 L
s
.763 .242 .101 r
.50036 .65859 m .50906 .65597 L .51154 .65673 L p F P
0 0 0 r
s
.763 .242 .101 r
.5227 .65338 m .51154 .65673 L .50906 .65597 L p F P
0 0 0 r
s
.83 .24 .1 r
.51301 .65352 m
.55051 .64225 L
s
.2743 .44937 m
.2394 .46286 L
s
.2394 .46286 m
.23421 .48607 L
s
.174 .276 .58 r
.54587 .34025 m .55202 .34779 L .56353 .34707 L p F P
0 0 0 r
s
.174 .276 .58 r
.57087 .35618 m .56353 .34707 L .55202 .34779 L p F P
0 0 0 r
s
.24 .35 .67 r
.54338 .3518 m
.56616 .35701 L
s
.83 .24 .1 r
.24975 .67016 m
.26794 .68959 L
s
.30316 .67858 m
.26794 .68959 L
s
.083 .024 .01 r
.43246 .36175 m .41938 .36691 L .40659 .37314 L p F P
0 0 0 r
s
.083 .024 .01 r
.39162 .37904 m .40659 .37314 L .41938 .36691 L p F P
0 0 0 r
s
.83 .24 .1 r
.41279 .37165 m
.44932 .35727 L
s
.21511 .68126 m
.19835 .65721 L
s
.24975 .67016 m
.21511 .68126 L
s
.62754 .30695 m
.58878 .322 L
s
.58878 .322 m
.57568 .31404 L
s
.303 .432 .811 r
.31194 .44112 m .29975 .4297 L .31428 .41472 L p F P
0 0 0 r
s
.178 .043 .018 r
.33027 .40845 m .31428 .41472 L .29975 .4297 L p F P
0 0 0 r
s
.24 .35 .67 r
.30924 .41874 m
.31015 .4196 L
s
.31188 .42125 m
.31581 .42499 L
s
.865 .27 .112 r
.48841 .34259 m .47735 .34694 L .47233 .34603 L p F P
0 0 0 r
s
.865 .27 .112 r
.45894 .35131 m .47233 .34603 L .47735 .34694 L p F P
0 0 0 r
s
.234 .317 .566 r
.35352 .55974 m .34172 .54941 L .33713 .53076 L p F P
0 0 0 r
s
.234 .317 .566 r
.32471 .51975 m .33713 .53076 L .34172 .54941 L p F P
0 0 0 r
s
.264 .365 .665 r
.33713 .53076 m .32471 .51975 L .32413 .50047 L p F P
0 0 0 r
s
.24 .35 .67 r
.32589 .50047 m
.35031 .52248 L
s
.83 .24 .1 r
.79993 .50081 m
.84104 .48772 L
s
.80231 .52455 m
.79993 .50081 L
s
.188 .246 .422 r
.37235 .58624 m .36145 .57679 L .35352 .55974 L p F P
0 0 0 r
s
.188 .246 .422 r
.34172 .54941 m .35352 .55974 L .36145 .57679 L p F P
0 0 0 r
s
.24 .35 .67 r
.35126 .54677 m
.35771 .56871 L
s
.136 .17 .302 r
.61883 .4029 m .62755 .41382 L .63753 .42874 L p F P
0 0 0 r
s
.136 .17 .302 r
.64667 .44018 m .63753 .42874 L .62755 .41382 L p F P
0 0 0 r
s
.283 .397 .733 r
.32413 .50047 m .31143 .48903 L .31545 .47015 L p F P
0 0 0 r
s
.264 .365 .665 r
.31143 .48903 m .32413 .50047 L .32471 .51975 L p F P
0 0 0 r
s
.83 .24 .1 r
.84104 .48772 m
.83583 .46098 L
s
.131 .209 .459 r
.57087 .35618 m .5781 .36516 L .59051 .37112 L p F P
0 0 0 r
s
.131 .209 .459 r
.59868 .38134 m .59051 .37112 L .5781 .36516 L p F P
0 0 0 r
s
.24 .35 .67 r
.56616 .35701 m
.58617 .38174 L
s
.295 .418 .779 r
.31545 .47015 m .30282 .45856 L .31194 .44112 L p F P
0 0 0 r
s
.295 .418 .779 r
.29975 .4297 m .31194 .44112 L .30282 .45856 L p F P
0 0 0 r
s
.83 .24 .1 r
.28265 .4313 m
.3077 .42151 L
s
.283 .397 .733 r
.30282 .45856 m .31545 .47015 L .31143 .48903 L p F P
0 0 0 r
s
.24 .35 .67 r
.30564 .45151 m
.33062 .47461 L
s
.272 .378 .683 r
.68455 .52985 m .67543 .51883 L .67601 .49953 L p F P
0 0 0 r
s
.24 .35 .67 r
.67425 .49953 m
.67595 .50162 L
s
.294 .415 .762 r
.67543 .51883 m .68455 .52985 L .67935 .54855 L p F P
0 0 0 r
s
.294 .415 .762 r
.6881 .55889 m .67935 .54855 L .68455 .52985 L p F P
0 0 0 r
s
.308 .438 .814 r
.67935 .54855 m .6881 .55889 L .67791 .576 L p F P
0 0 0 r
s
.308 .438 .814 r
.68613 .58547 m .67791 .576 L .6881 .55889 L p F P
0 0 0 r
s
.127 .202 .442 r
.44105 .64687 m .43422 .64095 L .42187 .63487 L p F P
0 0 0 r
s
.127 .202 .442 r
.41358 .62771 m .42187 .63487 L .43422 .64095 L p F P
0 0 0 r
s
.24 .35 .67 r
.39375 .60812 m
.41698 .62821 L
s
.83 .24 .1 r
.19816 .52636 m
.16402 .53904 L
s
.16654 .56866 m
.16402 .53904 L
s
.235 .32 .564 r
.67601 .49953 m .66668 .48807 L .66312 .46919 L p F P
0 0 0 r
s
.272 .378 .683 r
.66668 .48807 m .67601 .49953 L .67543 .51883 L p F P
0 0 0 r
s
.147 .182 .324 r
.39267 .60921 m .38292 .60079 L .37235 .58624 L p F P
0 0 0 r
s
.147 .182 .324 r
.36145 .57679 m .37235 .58624 L .38292 .60079 L p F P
0 0 0 r
s
.24 .35 .67 r
.38172 .58962 m
.39375 .60812 L
s
.35771 .56871 m
.38172 .58962 L
s
.185 .244 .417 r
.63753 .42874 m .64667 .44018 L .65378 .45759 L p F P
0 0 0 r
s
.185 .244 .417 r
.66312 .46919 m .65378 .45759 L .64667 .44018 L p F P
0 0 0 r
s
.24 .35 .67 r
.6507 .45261 m
.65164 .45378 L
s
.6477 .44679 m
.6507 .45261 L
s
.83 .24 .1 r
.23421 .48607 m
.19966 .49919 L
s
.19966 .49919 m
.19816 .52636 L
s
.235 .32 .564 r
.65378 .45759 m .66312 .46919 L .66668 .48807 L p F P
0 0 0 r
s
.763 .242 .101 r
.50906 .65597 m .5178 .65335 L .5227 .65338 L p F P
0 0 0 r
s
.83 .24 .1 r
.50039 .65792 m
.51301 .65352 L
s
.763 .242 .101 r
.53393 .65002 m .5227 .65338 L .5178 .65335 L p F P
0 0 0 r
s
.229 .055 .024 r
.65456 .60497 m .67072 .60009 L .68613 .58547 L p F P
0 0 0 r
s
.24 .35 .67 r
.67212 .60257 m
.69028 .62287 L
s
.315 .452 .849 r
.67791 .576 m .68613 .58547 L .67072 .60009 L p F P
0 0 0 r
s
.83 .24 .1 r
.39381 .67037 m
.41099 .67847 L
s
.44789 .66731 m
.41099 .67847 L
s
.78572 .31822 m
.77325 .29459 L
s
.083 .024 .01 r
.55661 .64322 m .56806 .63978 L .58085 .63348 L p F P
0 0 0 r
s
.083 .024 .01 r
.59461 .62934 m .58085 .63348 L .56806 .63978 L p F P
0 0 0 r
s
.24 .35 .67 r
.67212 .60257 m
.67525 .59579 L
s
.83 .24 .1 r
.77325 .29459 m
.73279 .30982 L
s
.73279 .30982 m
.72 .29047 L
s
.168 .272 .57 r
.46427 .65738 m .45907 .65283 L .44781 .65272 L p F P
0 0 0 r
s
.168 .272 .57 r
.44105 .64687 m .44781 .65272 L .45907 .65283 L p F P
0 0 0 r
s
.83 .24 .1 r
.76071 .55718 m
.76152 .53727 L
s
.80231 .52455 m
.76152 .53727 L
s
.865 .27 .112 r
.49954 .33821 m .48841 .34259 L .48583 .34071 L p F P
0 0 0 r
s
.865 .27 .112 r
.47233 .34603 m .48583 .34071 L .48841 .34259 L p F P
0 0 0 r
s
.83 .24 .1 r
.48666 .34257 m
.49961 .34385 L
s
.092 .026 .011 r
.39162 .37904 m .37678 .38488 L .36272 .39571 L p F P
0 0 0 r
s
.83 .24 .1 r
.36734 .39024 m
.37243 .38824 L
s
.092 .026 .011 r
.34641 .40211 m .36272 .39571 L .37678 .38488 L p F P
0 0 0 r
s
.145 .037 .015 r
.60846 .62518 m .62243 .62098 L .63855 .60981 L p F P
0 0 0 r
s
.145 .037 .015 r
.65456 .60497 m .63855 .60981 L .62243 .62098 L p F P
0 0 0 r
s
.083 .024 .01 r
.44565 .35655 m .43246 .36175 L .4217 .36718 L p F P
0 0 0 r
s
.083 .024 .01 r
.40659 .37314 m .4217 .36718 L .43246 .36175 L p F P
0 0 0 r
s
.094 .106 .204 r
.41358 .62771 m .40516 .62046 L .39267 .60921 L p F P
0 0 0 r
s
.094 .106 .204 r
.38292 .60079 m .39267 .60921 L .40516 .62046 L p F P
0 0 0 r
s
.934 .288 .121 r
.48309 .66377 m .47452 .66634 L .48233 .65847 L p F P
0 0 0 r
s
.83 .24 .1 r
.47396 .66586 m
.47545 .66541 L
s
.483 .66314 m
.50039 .65792 L
s
.22 .344 .7 r
.46942 .66188 m .47452 .66634 L .48233 .65847 L p F P
0 0 0 r
s
.24 .35 .67 r
.42559 .28017 m
.44869 .30686 L
s
.44869 .30686 m
.47531 .30077 L
s
.178 .043 .018 r
.34641 .40211 m .33027 .40845 L .31692 .42301 L p F P
0 0 0 r
s
.178 .043 .018 r
.29975 .4297 m .31692 .42301 L .33027 .40845 L p F P
0 0 0 r
s
.24 .35 .67 r
.30564 .45151 m
.31581 .42499 L
s
.174 .276 .58 r
.53966 .33261 m .54587 .34025 L .55609 .33784 L p F P
0 0 0 r
s
.83 .24 .1 r
.53723 .32911 m
.54859 .33545 L
s
.174 .276 .58 r
.56353 .34707 m .55609 .33784 L .54587 .34025 L p F P
0 0 0 r
s
.24 .35 .67 r
.6063 .67003 m
.57884 .68372 L
s
.55825 .66428 m
.57884 .68372 L
s
.763 .242 .101 r
.5178 .65335 m .52659 .65071 L .53393 .65002 L p F P
0 0 0 r
s
.763 .242 .101 r
.54523 .64663 m .53393 .65002 L .52659 .65071 L p F P
0 0 0 r
s
.83 .24 .1 r
.72 .29047 m
.68 .30578 L
s
.68 .30578 m
.66715 .29157 L
s
.24 .35 .67 r
.52997 .67258 m
.50275 .67484 L
s
.089 .134 .321 r
.59051 .37112 m .59868 .38134 L .60997 .39179 L p F P
0 0 0 r
s
.089 .134 .321 r
.61883 .4029 m .60997 .39179 L .59868 .38134 L p F P
0 0 0 r
s
.83 .24 .1 r
.53675 .32905 m
.53723 .32911 L
s
.083 .024 .01 r
.56806 .63978 m .57959 .63633 L .59461 .62934 L p F P
0 0 0 r
s
.083 .024 .01 r
.60846 .62518 m .59461 .62934 L .57959 .63633 L p F P
0 0 0 r
s
.83 .24 .1 r
.55051 .64225 m
.58883 .63073 L
s
.58883 .63073 m
.59772 .62065 L
s
.865 .27 .112 r
.51074 .3338 m .49954 .33821 L .49943 .33534 L p F P
0 0 0 r
s
.865 .27 .112 r
.48583 .34071 m .49943 .33534 L .49954 .33821 L p F P
0 0 0 r
s
.934 .288 .121 r
.48233 .65847 m .48828 .65667 L .48309 .66377 L p F P
0 0 0 r
s
.934 .288 .121 r
.4917 .66119 m .48309 .66377 L .48828 .65667 L p F P
0 0 0 r
s
.24 .35 .67 r
.48768 .66145 m
.50275 .67484 L
s
.48457 .65868 m
.48768 .66145 L
s
.83 .24 .1 r
.19835 .65721 m
.18417 .62942 L
s
.23309 .64576 m
.19835 .65721 L
s
.083 .024 .01 r
.45894 .35131 m .44565 .35655 L .43695 .36118 L p F P
0 0 0 r
s
.083 .024 .01 r
.4217 .36718 m .43695 .36118 L .44565 .35655 L p F P
0 0 0 r
s
.83 .24 .1 r
.33917 .66734 m
.35731 .68155 L
s
.39381 .67037 m
.35731 .68155 L
s
.71598 .58485 m
.72019 .5696 L
s
.76071 .55718 m
.72019 .5696 L
s
.131 .209 .459 r
.56353 .34707 m .57087 .35618 L .58222 .36074 L p F P
0 0 0 r
s
.131 .209 .459 r
.59051 .37112 m .58222 .36074 L .57087 .35618 L p F P
0 0 0 r
s
.092 .026 .011 r
.40659 .37314 m .39162 .37904 L .37919 .38925 L p F P
0 0 0 r
s
.83 .24 .1 r
.40052 .37718 m
.41279 .37165 L
s
.38264 .38422 m
.38777 .3822 L
s
.39809 .37814 m
.40052 .37718 L
s
.092 .026 .011 r
.36272 .39571 m .37919 .38925 L .39162 .37904 L p F P
0 0 0 r
s
.145 .037 .015 r
.62243 .62098 m .63651 .61675 L .65456 .60497 L p F P
0 0 0 r
s
.145 .037 .015 r
.67072 .60009 m .65456 .60497 L .63651 .61675 L p F P
0 0 0 r
s
.127 .202 .442 r
.43422 .64095 m .42731 .63496 L .41358 .62771 L p F P
0 0 0 r
s
.127 .202 .442 r
.40516 .62046 m .41358 .62771 L .42731 .63496 L p F P
0 0 0 r
s
.24 .35 .67 r
.32464 .34952 m
.34705 .32691 L
s
.32191 .30052 m
.34705 .32691 L
s
.34705 .32691 m
.37192 .30736 L
s
.52244 .32637 m
.52707 .32737 L
s
.168 .272 .57 r
.45907 .65283 m .45383 .64825 L .44105 .64687 L p F P
0 0 0 r
s
.24 .35 .67 r
.43777 .64403 m
.44553 .64735 L
s
.168 .272 .57 r
.43422 .64095 m .44105 .64687 L .45383 .64825 L p F P
0 0 0 r
s
.83 .24 .1 r
.20095 .55622 m
.16654 .56866 L
s
.17336 .59935 m
.16654 .56866 L
s
.24 .35 .67 r
.30548 .3744 m
.32464 .34952 L
s
.29906 .32355 m
.32464 .34952 L
s
.763 .242 .101 r
.52659 .65071 m .53543 .64806 L .54523 .64663 L p F P
0 0 0 r
s
.763 .242 .101 r
.55661 .64322 m .54523 .64663 L .53543 .64806 L p F P
0 0 0 r
s
.24 .35 .67 r
.67015 .60037 m
.67212 .60257 L
s
.22 .344 .7 r
.48233 .65847 m .47881 .65535 L .46942 .66188 L p F P
0 0 0 r
s
.22 .344 .7 r
.46427 .65738 m .46942 .66188 L .47881 .65535 L p F P
0 0 0 r
s
.136 .17 .302 r
.60997 .39179 m .61883 .4029 L .62822 .4171 L p F P
0 0 0 r
s
.136 .17 .302 r
.63753 .42874 m .62822 .4171 L .61883 .4029 L p F P
0 0 0 r
s
.24 .35 .67 r
.60566 .39248 m
.62105 .40828 L
s
.188 .246 .422 r
.36145 .57679 m .35036 .56717 L .34172 .54941 L p F P
0 0 0 r
s
.188 .246 .422 r
.3297 .53889 m .34172 .54941 L .35036 .56717 L p F P
0 0 0 r
s
.234 .317 .566 r
.34172 .54941 m .3297 .53889 L .32471 .51975 L p F P
0 0 0 r
s
.865 .27 .112 r
.52202 .32936 m .51074 .3338 L .51315 .32993 L p F P
0 0 0 r
s
.865 .27 .112 r
.49943 .33534 m .51315 .32993 L .51074 .3338 L p F P
0 0 0 r
s
.234 .317 .566 r
.31206 .50854 m .32471 .51975 L .3297 .53889 L p F P
0 0 0 r
s
.24 .35 .67 r
.32589 .50047 m
.32655 .52494 L
s
.32655 .52494 m
.35126 .54677 L
s
.264 .365 .665 r
.32471 .51975 m .31206 .50854 L .31143 .48903 L p F P
0 0 0 r
s
.178 .043 .018 r
.36272 .39571 m .34641 .40211 L .33427 .41625 L p F P
0 0 0 r
s
.178 .043 .018 r
.31692 .42301 m .33427 .41625 L .34641 .40211 L p F P
0 0 0 r
s
.934 .288 .121 r
.48828 .65667 m .49425 .65487 L .4917 .66119 L p F P
0 0 0 r
s
.934 .288 .121 r
.50036 .65859 m .4917 .66119 L .49425 .65487 L p F P
0 0 0 r
s
.83 .24 .1 r
.49893 .65772 m
.50039 .65792 L
s
.147 .182 .324 r
.38292 .60079 m .37301 .59224 L .36145 .57679 L p F P
0 0 0 r
s
.147 .182 .324 r
.35036 .56717 m .36145 .57679 L .37301 .59224 L p F P
0 0 0 r
s
.295 .418 .779 r
.30282 .45856 m .28995 .44675 L .29975 .4297 L p F P
0 0 0 r
s
.31 .076 .035 r
.31692 .42301 m .29975 .4297 L .28995 .44675 L p F P
0 0 0 r
s
.83 .24 .1 r
.2743 .44937 m
.26953 .47265 L
s
.283 .397 .733 r
.31143 .48903 m .29848 .47737 L .30282 .45856 L p F P
0 0 0 r
s
.264 .365 .665 r
.29848 .47737 m .31143 .48903 L .31206 .50854 L p F P
0 0 0 r
s
.294 .415 .762 r
.67935 .54855 m .67043 .53801 L .67543 .51883 L p F P
0 0 0 r
s
.308 .438 .814 r
.67043 .53801 m .67935 .54855 L .66955 .56637 L p F P
0 0 0 r
s
.308 .438 .814 r
.67791 .576 m .66955 .56637 L .67935 .54855 L p F P
0 0 0 r
s
.083 .024 .01 r
.57959 .63633 m .59119 .63285 L .60846 .62518 L p F P
0 0 0 r
s
.083 .024 .01 r
.62243 .62098 m .60846 .62518 L .59119 .63285 L p F P
0 0 0 r
s
.24 .35 .67 r
.34721 .28052 m
.37192 .30736 L
s
.37192 .30736 m
.39841 .29157 L
s
.83 .24 .1 r
.28517 .65882 m
.30316 .67858 L
s
.33917 .66734 m
.30316 .67858 L
s
.283 .397 .733 r
.28995 .44675 m .30282 .45856 L .29848 .47737 L p F P
0 0 0 r
s
.272 .378 .683 r
.67543 .51883 m .66612 .5076 L .66668 .48807 L p F P
0 0 0 r
s
.294 .415 .762 r
.66612 .5076 m .67543 .51883 L .67043 .53801 L p F P
0 0 0 r
s
.83 .24 .1 r
.23309 .64576 m
.24975 .67016 L
s
.28517 .65882 m
.24975 .67016 L
s
.174 .276 .58 r
.53337 .3249 m .53966 .33261 L .54855 .32848 L p F P
0 0 0 r
s
.174 .276 .58 r
.55609 .33784 m .54855 .32848 L .53966 .33261 L p F P
0 0 0 r
s
.24 .35 .67 r
.63188 .65126 m
.6063 .67003 L
s
.58613 .65022 m
.6063 .67003 L
s
.83 .24 .1 r
.66715 .29157 m
.62754 .30695 L
s
.62754 .30695 m
.61498 .29864 L
s
.315 .452 .849 r
.66955 .56637 m .67791 .576 L .66306 .59152 L p F P
0 0 0 r
s
.315 .452 .849 r
.67072 .60009 m .66306 .59152 L .67791 .576 L p F P
0 0 0 r
s
.83 .24 .1 r
.67639 .59484 m
.6773 .59198 L
s
.67569 .59705 m
.67639 .59484 L
s
.185 .244 .417 r
.62822 .4171 m .63753 .42874 L .64427 .44576 L p F P
0 0 0 r
s
.24 .35 .67 r
.62105 .40828 m
.62854 .41766 L
s
.63766 .42908 m
.63785 .42931 L
s
.185 .244 .417 r
.65378 .45759 m .64427 .44576 L .63753 .42874 L p F P
0 0 0 r
s
.235 .32 .564 r
.66668 .48807 m .65717 .47639 L .65378 .45759 L p F P
0 0 0 r
s
.272 .378 .683 r
.65717 .47639 m .66668 .48807 L .66612 .5076 L p F P
0 0 0 r
s
.235 .32 .564 r
.64427 .44576 m .65378 .45759 L .65717 .47639 L p F P
0 0 0 r
s
.24 .35 .67 r
.65399 .46883 m
.65557 .47663 L
s
.083 .024 .01 r
.47233 .34603 m .45894 .35131 L .45233 .35511 L p F P
0 0 0 r
s
.083 .024 .01 r
.43695 .36118 m .45233 .35511 L .45894 .35131 L p F P
0 0 0 r
s
.83 .24 .1 r
.44932 .35727 m
.48666 .34257 L
s
.43759 .36259 m
.44932 .35727 L
s
.844 .51155 m
.84104 .48772 L
s
.18417 .62942 m
.17336 .59935 L
s
.21889 .61761 m
.18417 .62942 L
s
.094 .106 .204 r
.40516 .62046 m .39664 .6131 L .38292 .60079 L p F P
0 0 0 r
s
.094 .106 .204 r
.37301 .59224 m .38292 .60079 L .39664 .6131 L p F P
0 0 0 r
s
.763 .242 .101 r
.53543 .64806 m .5443 .64539 L .55661 .64322 L p F P
0 0 0 r
s
.763 .242 .101 r
.56806 .63978 m .55661 .64322 L .5443 .64539 L p F P
0 0 0 r
s
.83 .24 .1 r
.20798 .5872 m
.17336 .59935 L
s
.24 .35 .67 r
.29029 .40071 m
.30548 .3744 L
s
.27944 .34882 m
.30548 .3744 L
s
.092 .026 .011 r
.4217 .36718 m .40659 .37314 L .39583 .38272 L p F P
0 0 0 r
s
.83 .24 .1 r
.40052 .37718 m
.40326 .3761 L
s
.092 .026 .011 r
.37919 .38925 m .39583 .38272 L .40659 .37314 L p F P
0 0 0 r
s
.83 .24 .1 r
.23306 .5134 m
.19816 .52636 L
s
.19816 .52636 m
.20095 .55622 L
s
.145 .037 .015 r
.63651 .61675 m .6507 .61249 L .67072 .60009 L p F P
0 0 0 r
s
.319 .46 .871 r
.66306 .59152 m .67072 .60009 L .6507 .61249 L p F P
0 0 0 r
s
.24 .35 .67 r
.65421 .62837 m
.67212 .60257 L
s
.83 .24 .1 r
.63628 .60898 m
.65635 .6029 L
s
.67084 .59852 m
.67569 .59705 L
s
.67064 .59858 m
.67084 .59852 L
s
.934 .288 .121 r
.49425 .65487 m .50025 .65306 L .50036 .65859 L p F P
0 0 0 r
s
.934 .288 .121 r
.50906 .65597 m .50036 .65859 L .50025 .65306 L p F P
0 0 0 r
s
.24 .35 .67 r
.65421 .62837 m
.63188 .65126 L
s
.83 .24 .1 r
.26953 .47265 m
.23421 .48607 L
s
.23421 .48607 m
.23306 .5134 L
s
.865 .27 .112 r
.53337 .3249 m .52202 .32936 L .52697 .32448 L p F P
0 0 0 r
s
.865 .27 .112 r
.51315 .32993 m .52697 .32448 L .52202 .32936 L p F P
0 0 0 r
s
.83 .24 .1 r
.43112 .65894 m
.44789 .66731 L
s
.44789 .66731 m
.4737 .65951 L
s
.4737 .65951 m
.479 .65791 L
s
.22 .344 .7 r
.47881 .65535 m .47528 .65221 L .46427 .65738 L p F P
0 0 0 r
s
.22 .344 .7 r
.45907 .65283 m .46427 .65738 L .47528 .65221 L p F P
0 0 0 r
s
.24 .35 .67 r
.45816 .65203 m
.46281 .65269 L
s
.83 .24 .1 r
.77325 .29459 m
.76089 .27481 L
s
.089 .134 .321 r
.58222 .36074 m .59051 .37112 L .60096 .38049 L p F P
0 0 0 r
s
.089 .134 .321 r
.60997 .39179 m .60096 .38049 L .59051 .37112 L p F P
0 0 0 r
s
.24 .35 .67 r
.58573 .3676 m
.60566 .39248 L
s
.83 .24 .1 r
.80214 .54448 m
.80231 .52455 L
s
.844 .51155 m
.80231 .52455 L
s
.66806 .60691 m
.67569 .59705 L
s
.67569 .59705 m
.71598 .58485 L
s
.168 .272 .57 r
.45383 .64825 m .44854 .64362 L .43422 .64095 L p F P
0 0 0 r
s
.168 .272 .57 r
.42731 .63496 m .43422 .64095 L .44854 .64362 L p F P
0 0 0 r
s
.083 .024 .01 r
.59119 .63285 m .60287 .62935 L .62243 .62098 L p F P
0 0 0 r
s
.083 .024 .01 r
.63651 .61675 m .62243 .62098 L .60287 .62935 L p F P
0 0 0 r
s
.131 .209 .459 r
.55609 .33784 m .56353 .34707 L .57378 .3502 L p F P
0 0 0 r
s
.131 .209 .459 r
.58222 .36074 m .57378 .3502 L .56353 .34707 L p F P
0 0 0 r
s
.24 .35 .67 r
.56616 .35701 m
.58573 .3676 L
s
.178 .043 .018 r
.37919 .38925 m .36272 .39571 L .35181 .40942 L p F P
0 0 0 r
s
.178 .043 .018 r
.33427 .41625 m .35181 .40942 L .36272 .39571 L p F P
0 0 0 r
s
.127 .202 .442 r
.42731 .63496 m .42032 .62891 L .40516 .62046 L p F P
0 0 0 r
s
.127 .202 .442 r
.39664 .6131 m .40516 .62046 L .42032 .62891 L p F P
0 0 0 r
s
.24 .35 .67 r
.41085 .62234 m
.41208 .62341 L
s
.39375 .60812 m
.41085 .62234 L
s
.934 .288 .121 r
.50025 .65306 m .50627 .65124 L .50906 .65597 L p F P
0 0 0 r
s
.934 .288 .121 r
.5178 .65335 m .50906 .65597 L .50627 .65124 L p F P
0 0 0 r
s
.24 .35 .67 r
.45249 .27368 m
.47531 .30077 L
s
.47531 .30077 m
.50069 .29996 L
s
.763 .242 .101 r
.5443 .64539 m .55323 .64271 L .56806 .63978 L p F P
0 0 0 r
s
.83 .24 .1 r
.53844 .64648 m
.55051 .64225 L
s
.763 .242 .101 r
.57959 .63633 m .56806 .63978 L .55323 .64271 L p F P
0 0 0 r
s
.083 .024 .01 r
.48583 .34071 m .47233 .34603 L .46786 .349 L p F P
0 0 0 r
s
.083 .024 .01 r
.45233 .35511 m .46786 .349 L .47233 .34603 L p F P
0 0 0 r
s
.31 .076 .035 r
.33427 .41625 m .31692 .42301 L .30791 .43982 L p F P
0 0 0 r
s
.24 .35 .67 r
.29029 .40071 m
.30869 .41822 L
s
.30869 .41822 m
.30924 .41874 L
s
.31 .076 .035 r
.28995 .44675 m .30791 .43982 L .31692 .42301 L p F P
0 0 0 r
s
.24 .35 .67 r
.29739 .44388 m
.30564 .45151 L
s
.83 .24 .1 r
.2743 .44937 m
.29248 .44234 L
s
.24 .35 .67 r
.29244 .4393 m
.29409 .44083 L
s
.27969 .42751 m
.29244 .4393 L
s
.37408 .26427 m
.39841 .29157 L
s
.39841 .29157 m
.42559 .28017 L
s
.174 .276 .58 r
.54855 .32848 m .54091 .31899 L .53337 .3249 L p F P
0 0 0 r
s
.83 .24 .1 r
.52483 .32754 m
.53372 .32866 L
s
.24 .35 .67 r
.52894 .32778 m
.54537 .33133 L
s
.83 .24 .1 r
.54622 .32558 m
.57568 .31404 L
s
.865 .27 .112 r
.52697 .32448 m .54091 .31899 L .53337 .3249 L p F P
0 0 0 r
s
.24 .35 .67 r
.55825 .66428 m
.52997 .67258 L
s
.50964 .65403 m
.52997 .67258 L
s
.83 .24 .1 r
.76089 .27481 m
.72 .29047 L
s
.72 .29047 m
.70766 .27585 L
s
.092 .026 .011 r
.43695 .36118 m .4217 .36718 L .41264 .37612 L p F P
0 0 0 r
s
.83 .24 .1 r
.41367 .372 m
.4189 .36995 L
s
.4294 .36581 m
.43759 .36259 L
s
.092 .026 .011 r
.39583 .38272 m .41264 .37612 L .4217 .36718 L p F P
0 0 0 r
s
.83 .24 .1 r
.61498 .29864 m
.57568 .31404 L
s
.57568 .31404 m
.56386 .31217 L
s
.934 .288 .121 r
.50627 .65124 m .5123 .64942 L .5178 .65335 L p F P
0 0 0 r
s
.24 .35 .67 r
.50819 .65271 m
.50964 .65403 L
s
.934 .288 .121 r
.52659 .65071 m .5178 .65335 L .5123 .64942 L p F P
0 0 0 r
s
.83 .24 .1 r
.52489 .65056 m
.53844 .64648 L
s
.136 .17 .302 r
.60096 .38049 m .60997 .39179 L .61874 .40523 L p F P
0 0 0 r
s
.136 .17 .302 r
.62822 .4171 m .61874 .40523 L .60997 .39179 L p F P
0 0 0 r
s
.22 .344 .7 r
.47528 .65221 m .47172 .64906 L .45907 .65283 L p F P
0 0 0 r
s
.22 .344 .7 r
.45383 .64825 m .45907 .65283 L .47172 .64906 L p F P
0 0 0 r
s
.083 .024 .01 r
.60287 .62935 m .61463 .62582 L .63651 .61675 L p F P
0 0 0 r
s
.083 .024 .01 r
.6507 .61249 m .63651 .61675 L .61463 .62582 L p F P
0 0 0 r
s
.83 .24 .1 r
.58883 .63073 m
.62801 .61895 L
s
.62801 .61895 m
.63628 .60898 L
s
.21889 .61761 m
.23309 .64576 L
s
.2686 .63406 m
.23309 .64576 L
s
.763 .242 .101 r
.55323 .64271 m .5622 .64002 L .57959 .63633 L p F P
0 0 0 r
s
.763 .242 .101 r
.59119 .63285 m .57959 .63633 L .5622 .64002 L p F P
0 0 0 r
s
.83 .24 .1 r
.37598 .65584 m
.39381 .67037 L
s
.43112 .65894 m
.39381 .67037 L
s
.24 .35 .67 r
.27969 .42751 m
.29029 .40071 L
s
.26377 .37547 m
.29029 .40071 L
s
.147 .182 .324 r
.37301 .59224 m .36294 .58355 L .35036 .56717 L p F P
0 0 0 r
s
.147 .182 .324 r
.33908 .55738 m .35036 .56717 L .36294 .58355 L p F P
0 0 0 r
s
.188 .246 .422 r
.35036 .56717 m .33908 .55738 L .3297 .53889 L p F P
0 0 0 r
s
.83 .24 .1 r
.75718 .57238 m
.76071 .55718 L
s
.80214 .54448 m
.76071 .55718 L
s
.188 .246 .422 r
.31745 .52817 m .3297 .53889 L .33908 .55738 L p F P
0 0 0 r
s
.234 .317 .566 r
.3297 .53889 m .31745 .52817 L .31206 .50854 L p F P
0 0 0 r
s
.083 .024 .01 r
.49943 .33534 m .48583 .34071 L .48353 .34282 L p F P
0 0 0 r
s
.083 .024 .01 r
.46786 .349 m .48353 .34282 L .48583 .34071 L p F P
0 0 0 r
s
.234 .317 .566 r
.29916 .4971 m .31206 .50854 L .31745 .52817 L p F P
0 0 0 r
s
.264 .365 .665 r
.31206 .50854 m .29916 .4971 L .29848 .47737 L p F P
0 0 0 r
s
.24 .35 .67 r
.30053 .4776 m
.32589 .50047 L
s
.30053 .4776 m
.30564 .45151 L
s
.308 .438 .814 r
.66955 .56637 m .66104 .55656 L .67043 .53801 L p F P
0 0 0 r
s
.24 .35 .67 r
.67005 .53876 m
.67036 .53753 L
s
.315 .452 .849 r
.66104 .55656 m .66955 .56637 L .65529 .58282 L p F P
0 0 0 r
s
.315 .452 .849 r
.66306 .59152 m .65529 .58282 L .66955 .56637 L p F P
0 0 0 r
s
.094 .106 .204 r
.39664 .6131 m .38799 .60564 L .37301 .59224 L p F P
0 0 0 r
s
.094 .106 .204 r
.36294 .58355 m .37301 .59224 L .38799 .60564 L p F P
0 0 0 r
s
.24 .35 .67 r
.35771 .56871 m
.36962 .58725 L
s
.294 .415 .762 r
.67043 .53801 m .66135 .52728 L .66612 .5076 L p F P
0 0 0 r
s
.308 .438 .814 r
.66135 .52728 m .67043 .53801 L .66104 .55656 L p F P
0 0 0 r
s
.83 .24 .1 r
.23614 .5435 m
.20095 .55622 L
s
.20095 .55622 m
.20798 .5872 L
s
.168 .272 .57 r
.44854 .64362 m .44321 .63896 L .42731 .63496 L p F P
0 0 0 r
s
.168 .272 .57 r
.42032 .62891 m .42731 .63496 L .44321 .63896 L p F P
0 0 0 r
s
.178 .043 .018 r
.39583 .38272 m .37919 .38925 L .36954 .40251 L p F P
0 0 0 r
s
.178 .043 .018 r
.35181 .40942 m .36954 .40251 L .37919 .38925 L p F P
0 0 0 r
s
.283 .397 .733 r
.29848 .47737 m .28528 .46548 L .28995 .44675 L p F P
0 0 0 r
s
.264 .365 .665 r
.28528 .46548 m .29848 .47737 L .29916 .4971 L p F P
0 0 0 r
s
.934 .288 .121 r
.5123 .64942 m .51836 .64759 L .52659 .65071 L p F P
0 0 0 r
s
.934 .288 .121 r
.53543 .64806 m .52659 .65071 L .51836 .64759 L p F P
0 0 0 r
s
.185 .244 .417 r
.61874 .40523 m .62822 .4171 L .63456 .4337 L p F P
0 0 0 r
s
.185 .244 .417 r
.64427 .44576 m .63456 .4337 L .62822 .4171 L p F P
0 0 0 r
s
.24 .35 .67 r
.63144 .42866 m
.63247 .42994 L
s
.62787 .42165 m
.63144 .42866 L
s
.44 .115 .052 r
.30791 .43982 m .28995 .44675 L .28528 .46548 L p F P
0 0 0 r
s
.272 .378 .683 r
.66612 .5076 m .65664 .49614 L .65717 .47639 L p F P
0 0 0 r
s
.24 .35 .67 r
.65557 .47663 m
.65711 .47853 L
s
.294 .415 .762 r
.65664 .49614 m .66612 .5076 L .66135 .52728 L p F P
0 0 0 r
s
.319 .46 .871 r
.65529 .58282 m .66306 .59152 L .64381 .60502 L p F P
0 0 0 r
s
.24 .35 .67 r
.66256 .59188 m
.66274 .59208 L
s
.319 .46 .871 r
.6507 .61249 m .64381 .60502 L .66306 .59152 L p F P
0 0 0 r
s
.31 .076 .035 r
.35181 .40942 m .33427 .41625 L .32607 .43282 L p F P
0 0 0 r
s
.31 .076 .035 r
.30791 .43982 m .32607 .43282 L .33427 .41625 L p F P
0 0 0 r
s
.235 .32 .564 r
.65717 .47639 m .64748 .46448 L .64427 .44576 L p F P
0 0 0 r
s
.272 .378 .683 r
.64748 .46448 m .65717 .47639 L .65664 .49614 L p F P
0 0 0 r
s
.235 .32 .564 r
.63456 .4337 m .64427 .44576 L .64748 .46448 L p F P
0 0 0 r
s
.092 .026 .011 r
.45233 .35511 m .43695 .36118 L .42961 .36946 L p F P
0 0 0 r
s
.092 .026 .011 r
.41264 .37612 m .42961 .36946 L .43695 .36118 L p F P
0 0 0 r
s
.131 .209 .459 r
.54855 .32848 m .55609 .33784 L .56522 .33949 L p F P
0 0 0 r
s
.131 .209 .459 r
.57378 .3502 m .56522 .33949 L .55609 .33784 L p F P
0 0 0 r
s
.24 .35 .67 r
.54537 .33133 m
.56616 .35701 L
s
.83 .24 .1 r
.32138 .64722 m
.33917 .66734 L
s
.37598 .65584 m
.33917 .66734 L
s
.089 .134 .321 r
.57378 .3502 m .58222 .36074 L .59179 .36898 L p F P
0 0 0 r
s
.089 .134 .321 r
.60096 .38049 m .59179 .36898 L .58222 .36074 L p F P
0 0 0 r
s
.83 .24 .1 r
.2686 .63406 m
.28517 .65882 L
s
.32138 .64722 m
.28517 .65882 L
s
.127 .202 .442 r
.42032 .62891 m .41325 .62278 L .39664 .6131 L p F P
0 0 0 r
s
.127 .202 .442 r
.38799 .60564 m .39664 .6131 L .41325 .62278 L p F P
0 0 0 r
s
.24 .35 .67 r
.36962 .58725 m
.39375 .60812 L
s
.763 .242 .101 r
.5622 .64002 m .57121 .63731 L .59119 .63285 L p F P
0 0 0 r
s
.763 .242 .101 r
.60287 .62935 m .59119 .63285 L .57121 .63731 L p F P
0 0 0 r
s
.83 .24 .1 r
.70766 .27585 m
.66715 .29157 L
s
.66715 .29157 m
.65518 .28288 L
s
.083 .024 .01 r
.61463 .62582 m .62647 .62227 L .6507 .61249 L p F P
0 0 0 r
s
.319 .464 .884 r
.64381 .60502 m .6507 .61249 L .62647 .62227 L p F P
0 0 0 r
s
.24 .35 .67 r
.64299 .61635 m
.65421 .62837 L
s
.64248 .61581 m
.64299 .61635 L
s
.83 .24 .1 r
.64446 .61401 m
.66806 .60691 L
s
.64318 .61439 m
.64446 .61401 L
s
.62801 .61895 m
.63058 .61818 L
s
.22 .344 .7 r
.47172 .64906 m .46815 .64589 L .45383 .64825 L p F P
0 0 0 r
s
.22 .344 .7 r
.44854 .64362 m .45383 .64825 L .46815 .64589 L p F P
0 0 0 r
s
.934 .288 .121 r
.51836 .64759 m .52444 .64575 L .53543 .64806 L p F P
0 0 0 r
s
.934 .288 .121 r
.5443 .64539 m .53543 .64806 L .52444 .64575 L p F P
0 0 0 r
s
.83 .24 .1 r
.20798 .5872 m
.21889 .61761 L
s
.2544 .60554 m
.21889 .61761 L
s
.24337 .57479 m
.20798 .5872 L
s
.083 .024 .01 r
.51315 .32993 m .49943 .33534 L .49934 .33659 L p F P
0 0 0 r
s
.083 .024 .01 r
.48353 .34282 m .49934 .33659 L .49943 .33534 L p F P
0 0 0 r
s
.83 .24 .1 r
.48666 .34257 m
.52483 .32754 L
s
.26875 .50014 m
.23306 .5134 L
s
.23306 .5134 m
.23614 .5435 L
s
1 .304 .129 r
.48828 .65667 m .48233 .65847 L .49088 .64622 L p F P
0 0 0 r
s
.83 .24 .1 r
.48838 .65628 m
.48919 .65639 L
s
.256 .392 .783 r
.47881 .65535 m .48233 .65847 L .49088 .64622 L p F P
0 0 0 r
s
.24 .35 .67 r
.47828 .65488 m
.47925 .65502 L
s
.83 .24 .1 r
.26953 .47265 m
.28573 .4665 L
s
.26953 .47265 m
.26875 .50014 L
s
.24 .35 .67 r
.40159 .25242 m
.42559 .28017 L
s
.42559 .28017 m
.45249 .27368 L
s
.58613 .65022 m
.55825 .66428 L
s
.178 .043 .018 r
.41264 .37612 m .39583 .38272 L .38746 .39553 L p F P
0 0 0 r
s
.178 .043 .018 r
.36954 .40251 m .38746 .39553 L .39583 .38272 L p F P
0 0 0 r
s
.83 .24 .1 r
.84451 .53149 m
.844 .51155 L
s
.934 .288 .121 r
.52444 .64575 m .53054 .64391 L .5443 .64539 L p F P
0 0 0 r
s
.24 .35 .67 r
.53826 .64542 m
.55825 .66428 L
s
.934 .288 .121 r
.55323 .64271 m .5443 .64539 L .53054 .64391 L p F P
0 0 0 r
s
.24 .35 .67 r
.53684 .64408 m
.53826 .64542 L
s
.763 .242 .101 r
.57121 .63731 m .58028 .63459 L .60287 .62935 L p F P
0 0 0 r
s
.763 .242 .101 r
.61463 .62582 m .60287 .62935 L .58028 .63459 L p F P
0 0 0 r
s
.83 .24 .1 r
.70903 .5946 m
.71598 .58485 L
s
.75718 .57238 m
.71598 .58485 L
s
.168 .272 .57 r
.44321 .63896 m .43783 .63425 L .42032 .62891 L p F P
0 0 0 r
s
.168 .272 .57 r
.41325 .62278 m .42032 .62891 L .43783 .63425 L p F P
0 0 0 r
s
1 .304 .129 r
.49088 .64622 m .49396 .64528 L .48828 .65667 L p F P
0 0 0 r
s
1 .304 .129 r
.49425 .65487 m .48828 .65667 L .49396 .64528 L p F P
0 0 0 r
s
.44 .115 .052 r
.32607 .43282 m .30791 .43982 L .30361 .45851 L p F P
0 0 0 r
s
.44 .115 .052 r
.28528 .46548 m .30361 .45851 L .30791 .43982 L p F P
0 0 0 r
s
.092 .026 .011 r
.46786 .349 m .45233 .35511 L .44676 .36273 L p F P
0 0 0 r
s
.83 .24 .1 r
.44528 .35956 m
.45061 .35747 L
s
.092 .026 .011 r
.42961 .36946 m .44676 .36273 L .45233 .35511 L p F P
0 0 0 r
s
.31 .076 .035 r
.36954 .40251 m .35181 .40942 L .34444 .42574 L p F P
0 0 0 r
s
.31 .076 .035 r
.32607 .43282 m .34444 .42574 L .35181 .40942 L p F P
0 0 0 r
s
.136 .17 .302 r
.59179 .36898 m .60096 .38049 L .60909 .39314 L p F P
0 0 0 r
s
.136 .17 .302 r
.61874 .40523 m .60909 .39314 L .60096 .38049 L p F P
0 0 0 r
s
.22 .344 .7 r
.46815 .64589 m .46455 .64269 L .44854 .64362 L p F P
0 0 0 r
s
.22 .344 .7 r
.44321 .63896 m .44854 .64362 L .46455 .64269 L p F P
0 0 0 r
s
.256 .392 .783 r
.49088 .64622 m .48909 .6446 L .47881 .65535 L p F P
0 0 0 r
s
.24 .35 .67 r
.49071 .6543 m
.49361 .65404 L
s
.256 .392 .783 r
.47528 .65221 m .47881 .65535 L .48909 .6446 L p F P
0 0 0 r
s
.24 .35 .67 r
.29906 .32355 m
.32191 .30052 L
s
.29578 .27308 m
.32191 .30052 L
s
.32191 .30052 m
.34721 .28052 L
s
.083 .024 .01 r
.52697 .32448 m .51315 .32993 L .5153 .3303 L p F P
0 0 0 r
s
.83 .24 .1 r
.52483 .32754 m
.53961 .32172 L
s
.24 .35 .67 r
.50069 .29996 m
.52145 .32518 L
s
.52145 .32518 m
.52237 .32629 L
s
.083 .024 .01 r
.49934 .33659 m .5153 .3303 L .51315 .32993 L p F P
0 0 0 r
s
1 .304 .129 r
.49396 .64528 m .49704 .64434 L .49425 .65487 L p F P
0 0 0 r
s
1 .304 .129 r
.50025 .65306 m .49425 .65487 L .49704 .64434 L p F P
0 0 0 r
s
.147 .182 .324 r
.36294 .58355 m .35271 .57472 L .33908 .55738 L p F P
0 0 0 r
s
.147 .182 .324 r
.3276 .54742 m .33908 .55738 L .35271 .57472 L p F P
0 0 0 r
s
.188 .246 .422 r
.33908 .55738 m .3276 .54742 L .31745 .52817 L p F P
0 0 0 r
s
.24 .35 .67 r
.33277 .54698 m
.35771 .56871 L
s
.32655 .52494 m
.33277 .54698 L
s
.094 .106 .204 r
.38799 .60564 m .37923 .59808 L .36294 .58355 L p F P
0 0 0 r
s
.094 .106 .204 r
.35271 .57472 m .36294 .58355 L .37923 .59808 L p F P
0 0 0 r
s
.24 .35 .67 r
.47808 .2725 m
.50069 .29996 L
s
.50069 .29996 m
.52376 .30464 L
s
.934 .288 .121 r
.53054 .64391 m .53666 .64206 L .55323 .64271 L p F P
0 0 0 r
s
.934 .288 .121 r
.5622 .64002 m .55323 .64271 L .53666 .64206 L p F P
0 0 0 r
s
.83 .24 .1 r
.55914 .64026 m
.57735 .6348 L
s
.76089 .27481 m
.74909 .25977 L
s
.24 .35 .67 r
.27419 .45384 m
.27969 .42751 L
s
.25271 .40257 m
.27969 .42751 L
s
.27944 .34882 m
.29906 .32355 L
s
.27246 .29655 m
.29906 .32355 L
s
.188 .246 .422 r
.30498 .51726 m .31745 .52817 L .3276 .54742 L p F P
0 0 0 r
s
.234 .317 .566 r
.31745 .52817 m .30498 .51726 L .29916 .4971 L p F P
0 0 0 r
s
.315 .452 .849 r
.65529 .58282 m .64738 .57399 L .66104 .55656 L p F P
0 0 0 r
s
.319 .46 .871 r
.64738 .57399 m .65529 .58282 L .63682 .59745 L p F P
0 0 0 r
s
.24 .35 .67 r
.6548 .58321 m
.65498 .58341 L
s
.319 .46 .871 r
.64381 .60502 m .63682 .59745 L .65529 .58282 L p F P
0 0 0 r
s
.308 .438 .814 r
.66104 .55656 m .65238 .54659 L .66135 .52728 L p F P
0 0 0 r
s
.315 .452 .849 r
.65238 .54659 m .66104 .55656 L .64738 .57399 L p F P
0 0 0 r
s
.131 .209 .459 r
.54091 .31899 m .54855 .32848 L .55652 .32861 L p F P
0 0 0 r
s
.24 .35 .67 r
.53723 .32127 m
.54537 .33133 L
s
.131 .209 .459 r
.56522 .33949 m .55652 .32861 L .54855 .32848 L p F P
0 0 0 r
s
.24 .35 .67 r
.54537 .33133 m
.56502 .34175 L
s
.763 .242 .101 r
.58028 .63459 m .58939 .63186 L .61463 .62582 L p F P
0 0 0 r
s
.83 .24 .1 r
.57735 .6348 m
.58883 .63073 L
s
.763 .242 .101 r
.62647 .62227 m .61463 .62582 L .58939 .63186 L p F P
0 0 0 r
s
.83 .24 .1 r
.65518 .28288 m
.61498 .29864 L
s
.61498 .29864 m
.60378 .29645 L
s
.127 .202 .442 r
.41325 .62278 m .4061 .61659 L .38799 .60564 L p F P
0 0 0 r
s
.127 .202 .442 r
.37923 .59808 m .38799 .60564 L .4061 .61659 L p F P
0 0 0 r
s
.294 .415 .762 r
.66135 .52728 m .6521 .51634 L .65664 .49614 L p F P
0 0 0 r
s
.308 .438 .814 r
.6521 .51634 m .66135 .52728 L .65238 .54659 L p F P
0 0 0 r
s
.234 .317 .566 r
.28601 .48545 m .29916 .4971 L .30498 .51726 L p F P
0 0 0 r
s
.24 .35 .67 r
.30087 .50225 m
.32655 .52494 L
s
.264 .365 .665 r
.29916 .4971 m .28601 .48545 L .28528 .46548 L p F P
0 0 0 r
s
1 .304 .129 r
.49704 .64434 m .50013 .6434 L .50025 .65306 L p F P
0 0 0 r
s
1 .304 .129 r
.50627 .65124 m .50025 .65306 L .50013 .6434 L p F P
0 0 0 r
s
.24 .35 .67 r
.49361 .65404 m
.50819 .65271 L
s
.319 .464 .884 r
.63682 .59745 m .64381 .60502 L .62055 .61607 L p F P
0 0 0 r
s
.319 .464 .884 r
.62647 .62227 m .62055 .61607 L .64381 .60502 L p F P
0 0 0 r
s
.185 .244 .417 r
.60909 .39314 m .61874 .40523 L .62467 .4214 L p F P
0 0 0 r
s
.24 .35 .67 r
.60112 .38334 m
.60939 .3937 L
s
.61886 .40555 m
.61906 .40579 L
s
.185 .244 .417 r
.63456 .4337 m .62467 .4214 L .61874 .40523 L p F P
0 0 0 r
s
.089 .134 .321 r
.56522 .33949 m .57378 .3502 L .58245 .35728 L p F P
0 0 0 r
s
.089 .134 .321 r
.59179 .36898 m .58245 .35728 L .57378 .3502 L p F P
0 0 0 r
s
.24 .35 .67 r
.58573 .3676 m
.60112 .38334 L
s
.83 .24 .1 r
.2544 .60554 m
.2686 .63406 L
s
.30491 .62209 m
.2686 .63406 L
s
.24 .35 .67 r
.32151 .25262 m
.34721 .28052 L
s
.34721 .28052 m
.37408 .26427 L
s
.83 .24 .1 r
.41363 .64408 m
.43112 .65894 L
s
.545 .147 .066 r
.30361 .45851 m .28528 .46548 L .28601 .48545 L p F P
0 0 0 r
s
.83 .24 .1 r
.30257 .46011 m
.30565 .45894 L
s
.24 .35 .67 r
.29462 .47227 m
.30053 .4776 L
s
.30053 .4776 m
.30087 .50225 L
s
.272 .378 .683 r
.65664 .49614 m .64697 .48447 L .64748 .46448 L p F P
0 0 0 r
s
.294 .415 .762 r
.64697 .48447 m .65664 .49614 L .6521 .51634 L p F P
0 0 0 r
s
.83 .24 .1 r
.79932 .55963 m
.80214 .54448 L
s
.84451 .53149 m
.80214 .54448 L
s
.178 .043 .018 r
.42961 .36946 m .41264 .37612 L .40558 .38847 L p F P
0 0 0 r
s
.178 .043 .018 r
.38746 .39553 m .40558 .38847 L .41264 .37612 L p F P
0 0 0 r
s
.256 .392 .783 r
.48909 .6446 m .48729 .64297 L .47528 .65221 L p F P
0 0 0 r
s
.256 .392 .783 r
.47172 .64906 m .47528 .65221 L .48729 .64297 L p F P
0 0 0 r
s
.83 .24 .1 r
.47796 .65185 m
.47968 .65276 L
s
.934 .288 .121 r
.53666 .64206 m .54281 .64021 L .5622 .64002 L p F P
0 0 0 r
s
.934 .288 .121 r
.57121 .63731 m .5622 .64002 L .54281 .64021 L p F P
0 0 0 r
s
.092 .026 .011 r
.48353 .34282 m .46786 .349 L .46408 .35594 L p F P
0 0 0 r
s
.83 .24 .1 r
.46132 .35326 m
.46669 .35114 L
s
.4781 .34649 m
.48666 .34257 L
s
.092 .026 .011 r
.44676 .36273 m .46408 .35594 L .46786 .349 L p F P
0 0 0 r
s
.235 .32 .564 r
.64748 .46448 m .63759 .45234 L .63456 .4337 L p F P
0 0 0 r
s
.272 .378 .683 r
.63759 .45234 m .64748 .46448 L .64697 .48447 L p F P
0 0 0 r
s
.235 .32 .564 r
.62467 .4214 m .63456 .4337 L .63759 .45234 L p F P
0 0 0 r
s
.24 .35 .67 r
.63472 .44548 m
.63616 .45283 L
s
.83 .24 .1 r
.27213 .53049 m
.23614 .5435 L
s
.23614 .5435 m
.24337 .57479 L
s
1 .304 .129 r
.50013 .6434 m .50322 .64246 L .50627 .65124 L p F P
0 0 0 r
s
1 .304 .129 r
.5123 .64942 m .50627 .65124 L .50322 .64246 L p F P
0 0 0 r
s
.083 .024 .01 r
.54091 .31899 m .52697 .32448 L .53141 .32396 L p F P
0 0 0 r
s
.24 .35 .67 r
.53654 .32042 m
.53671 .32064 L
s
.083 .024 .01 r
.5153 .3303 m .53141 .32396 L .52697 .32448 L p F P
0 0 0 r
s
.22 .344 .7 r
.46455 .64269 m .46093 .63948 L .44321 .63896 L p F P
0 0 0 r
s
.22 .344 .7 r
.43783 .63425 m .44321 .63896 L .46093 .63948 L p F P
0 0 0 r
s
.44 .115 .052 r
.34444 .42574 m .32607 .43282 L .32216 .45146 L p F P
0 0 0 r
s
.44 .115 .052 r
.30361 .45851 m .32216 .45146 L .32607 .43282 L p F P
0 0 0 r
s
.83 .24 .1 r
.30565 .45894 m
.30589 .45764 L
s
.168 .272 .57 r
.43783 .63425 m .4324 .6295 L .41325 .62278 L p F P
0 0 0 r
s
.168 .272 .57 r
.4061 .61659 m .41325 .62278 L .4324 .6295 L p F P
0 0 0 r
s
.24 .35 .67 r
.26377 .37547 m
.27944 .34882 L
s
.25235 .32222 m
.27944 .34882 L
s
.31 .076 .035 r
.38746 .39553 m .36954 .40251 L .36301 .41858 L p F P
0 0 0 r
s
.31 .076 .035 r
.34444 .42574 m .36301 .41858 L .36954 .40251 L p F P
0 0 0 r
s
.763 .242 .101 r
.58939 .63186 m .59854 .62911 L .62647 .62227 L p F P
0 0 0 r
s
.24 .35 .67 r
.58613 .65022 m
.61215 .63104 L
s
.61215 .63104 m
.63188 .65126 L
s
.318 .465 .89 r
.62055 .61607 m .62647 .62227 L .59854 .62911 L p F P
0 0 0 r
s
.83 .24 .1 r
.61981 .62189 m
.62029 .62171 L
s
.24 .35 .67 r
.61215 .63104 m
.61867 .62436 L
s
.6081 .62688 m
.61215 .63104 L
s
1 .304 .129 r
.50322 .64246 m .50632 .64152 L .5123 .64942 L p F P
0 0 0 r
s
1 .304 .129 r
.51836 .64759 m .5123 .64942 L .50632 .64152 L p F P
0 0 0 r
s
.83 .24 .1 r
.65783 .61062 m
.66806 .60691 L
s
.70903 .5946 m
.66806 .60691 L
s
.35841 .63537 m
.37598 .65584 L
s
.41363 .64408 m
.37598 .65584 L
s
.934 .288 .121 r
.54281 .64021 m .54898 .63835 L .57121 .63731 L p F P
0 0 0 r
s
.934 .288 .121 r
.58028 .63459 m .57121 .63731 L .54898 .63835 L p F P
0 0 0 r
s
.83 .24 .1 r
.30491 .62209 m
.32138 .64722 L
s
.35841 .63537 m
.32138 .64722 L
s
.256 .392 .783 r
.48729 .64297 m .48548 .64133 L .47172 .64906 L p F P
0 0 0 r
s
.256 .392 .783 r
.46815 .64589 m .47172 .64906 L .48548 .64133 L p F P
0 0 0 r
s
.83 .24 .1 r
.46928 .64725 m
.47796 .65185 L
s
.43112 .65894 m
.46928 .64725 L
s
.74909 .25977 m
.70766 .27585 L
s
.70766 .27585 m
.69629 .26677 L
s
.24337 .57479 m
.2544 .60554 L
s
.29071 .59319 m
.2544 .60554 L
s
.27957 .56209 m
.24337 .57479 L
s
1 .304 .129 r
.50632 .64152 m .50942 .64057 L .51836 .64759 L p F P
0 0 0 r
s
1 .304 .129 r
.52444 .64575 m .51836 .64759 L .50942 .64057 L p F P
0 0 0 r
s
.83 .24 .1 r
.52199 .64491 m
.52419 .64425 L
s
.52419 .64425 m
.52764 .64479 L
s
.24 .35 .67 r
.42877 .2455 m
.45249 .27368 L
s
.45249 .27368 m
.47808 .2725 L
s
.83 .24 .1 r
.26875 .50014 m
.27213 .53049 L
s
.178 .043 .018 r
.44676 .36273 m .42961 .36946 L .42389 .38134 L p F P
0 0 0 r
s
.178 .043 .018 r
.40558 .38847 m .42389 .38134 L .42961 .36946 L p F P
0 0 0 r
s
.092 .026 .011 r
.49934 .33659 m .48353 .34282 L .48158 .34907 L p F P
0 0 0 r
s
.83 .24 .1 r
.4775 .34689 m
.48293 .34475 L
s
.092 .026 .011 r
.46408 .35594 m .48158 .34907 L .48353 .34282 L p F P
0 0 0 r
s
.24 .35 .67 r
.34877 .23589 m
.37408 .26427 L
s
.37408 .26427 m
.40159 .25242 L
s
.131 .209 .459 r
.55652 .32861 m .54767 .31755 L .54091 .31899 L p F P
0 0 0 r
s
.83 .24 .1 r
.54828 .3183 m
.56386 .31217 L
s
.083 .024 .01 r
.53141 .32396 m .54767 .31755 L .54091 .31899 L p F P
0 0 0 r
s
.24 .35 .67 r
.52376 .30464 m
.53654 .32042 L
s
.136 .17 .302 r
.58245 .35728 m .59179 .36898 L .59924 .38082 L p F P
0 0 0 r
s
.24 .35 .67 r
.56502 .34175 m
.58573 .3676 L
s
.136 .17 .302 r
.60909 .39314 m .59924 .38082 L .59179 .36898 L p F P
0 0 0 r
s
.094 .106 .204 r
.37923 .59808 m .37034 .59041 L .35271 .57472 L p F P
0 0 0 r
s
.094 .106 .204 r
.34232 .56575 m .35271 .57472 L .37034 .59041 L p F P
0 0 0 r
s
.147 .182 .324 r
.35271 .57472 m .34232 .56575 L .3276 .54742 L p F P
0 0 0 r
s
.24 .35 .67 r
.34454 .56557 m
.36962 .58725 L
s
.934 .288 .121 r
.54898 .63835 m .55516 .63648 L .58028 .63459 L p F P
0 0 0 r
s
.934 .288 .121 r
.58939 .63186 m .58028 .63459 L .55516 .63648 L p F P
0 0 0 r
s
.83 .24 .1 r
.58528 .63241 m
.60087 .62773 L
s
.545 .147 .066 r
.32216 .45146 m .30361 .45851 L .30429 .47861 L p F P
0 0 0 r
s
.545 .147 .066 r
.28601 .48545 m .30429 .47861 L .30361 .45851 L p F P
0 0 0 r
s
.24 .35 .67 r
.27419 .45384 m
.28656 .46499 L
s
.127 .202 .442 r
.4061 .61659 m .39887 .61032 L .37923 .59808 L p F P
0 0 0 r
s
.127 .202 .442 r
.37034 .59041 m .37923 .59808 L .39887 .61032 L p F P
0 0 0 r
s
.24 .35 .67 r
.3867 .60145 m
.38896 .60341 L
s
.36962 .58725 m
.3867 .60145 L
s
.22 .344 .7 r
.46093 .63948 m .45728 .63625 L .43783 .63425 L p F P
0 0 0 r
s
.22 .344 .7 r
.4324 .6295 m .43783 .63425 L .45728 .63625 L p F P
0 0 0 r
s
.256 .392 .783 r
.48548 .64133 m .48367 .63969 L .46815 .64589 L p F P
0 0 0 r
s
.256 .392 .783 r
.46455 .64269 m .46815 .64589 L .48367 .63969 L p F P
0 0 0 r
s
.315 .452 .849 r
.64738 .57399 m .63936 .565 L .65238 .54659 L p F P
0 0 0 r
s
.319 .46 .871 r
.63936 .565 m .64738 .57399 L .62974 .58977 L p F P
0 0 0 r
s
.24 .35 .67 r
.64692 .5744 m
.6471 .57461 L
s
.319 .46 .871 r
.63682 .59745 m .62974 .58977 L .64738 .57399 L p F P
0 0 0 r
s
1 .304 .129 r
.50942 .64057 m .51253 .63962 L .52444 .64575 L p F P
0 0 0 r
s
1 .304 .129 r
.53054 .64391 m .52444 .64575 L .51253 .63962 L p F P
0 0 0 r
s
.24 .35 .67 r
.50819 .65271 m
.53684 .64408 L
s
.147 .182 .324 r
.31591 .53729 m .3276 .54742 L .34232 .56575 L p F P
0 0 0 r
s
.24 .35 .67 r
.33277 .54698 m
.34454 .56557 L
s
.188 .246 .422 r
.3276 .54742 m .31591 .53729 L .30498 .51726 L p F P
0 0 0 r
s
.83 .24 .1 r
.60378 .29645 m
.56386 .31217 L
s
.56386 .31217 m
.55391 .31682 L
s
.319 .464 .884 r
.62974 .58977 m .63682 .59745 L .61456 .60979 L p F P
0 0 0 r
s
.319 .464 .884 r
.62055 .61607 m .61456 .60979 L .63682 .59745 L p F P
0 0 0 r
s
.83 .24 .1 r
.75093 .582 m
.75718 .57238 L
s
.79932 .55963 m
.75718 .57238 L
s
.308 .438 .814 r
.65238 .54659 m .64357 .53644 L .6521 .51634 L p F P
0 0 0 r
s
.315 .452 .849 r
.64357 .53644 m .65238 .54659 L .63936 .565 L p F P
0 0 0 r
s
.44 .115 .052 r
.36301 .41858 m .34444 .42574 L .34092 .44432 L p F P
0 0 0 r
s
.44 .115 .052 r
.32216 .45146 m .34092 .44432 L .34444 .42574 L p F P
0 0 0 r
s
.31 .076 .035 r
.40558 .38847 m .38746 .39553 L .3818 .41134 L p F P
0 0 0 r
s
.31 .076 .035 r
.36301 .41858 m .3818 .41134 L .38746 .39553 L p F P
0 0 0 r
s
.168 .272 .57 r
.4324 .6295 m .42692 .62471 L .4061 .61659 L p F P
0 0 0 r
s
.168 .272 .57 r
.39887 .61032 m .4061 .61659 L .42692 .62471 L p F P
0 0 0 r
s
.188 .246 .422 r
.29227 .50613 m .30498 .51726 L .31591 .53729 L p F P
0 0 0 r
s
.234 .317 .566 r
.30498 .51726 m .29227 .50613 L .28601 .48545 L p F P
0 0 0 r
s
.089 .134 .321 r
.55652 .32861 m .56522 .33949 L .57295 .34536 L p F P
0 0 0 r
s
.089 .134 .321 r
.58245 .35728 m .57295 .34536 L .56522 .33949 L p F P
0 0 0 r
s
.318 .465 .89 r
.61456 .60979 m .62055 .61607 L .59381 .62431 L p F P
0 0 0 r
s
.318 .465 .89 r
.59854 .62911 m .59381 .62431 L .62055 .61607 L p F P
0 0 0 r
s
.83 .24 .1 r
.61713 .62284 m
.61981 .62189 L
s
.60907 .62527 m
.61713 .62284 L
s
1 .304 .129 r
.51253 .63962 m .51565 .63867 L .53054 .64391 L p F P
0 0 0 r
s
1 .304 .129 r
.53666 .64206 m .53054 .64391 L .51565 .63867 L p F P
0 0 0 r
s
.934 .288 .121 r
.55516 .63648 m .56137 .6346 L .58939 .63186 L p F P
0 0 0 r
s
.24 .35 .67 r
.57182 .63616 m
.58613 .65022 L
s
.934 .288 .121 r
.59854 .62911 m .58939 .63186 L .56137 .6346 L p F P
0 0 0 r
s
.24 .35 .67 r
.25271 .40257 m
.26377 .37547 L
s
.2362 .34922 m
.26377 .37547 L
s
.294 .415 .762 r
.6521 .51634 m .64267 .5052 L .64697 .48447 L p F P
0 0 0 r
s
.308 .438 .814 r
.64267 .5052 m .6521 .51634 L .64357 .53644 L p F P
0 0 0 r
s
.626 .173 .077 r
.30429 .47861 m .28601 .48545 L .29227 .50613 L p F P
0 0 0 r
s
.24 .35 .67 r
.28824 .49108 m
.28899 .49175 L
s
.29589 .49784 m
.30087 .50225 L
s
.83 .24 .1 r
.2877 .49311 m
.28827 .4929 L
s
.26875 .50014 m
.2877 .49311 L
s
.24 .35 .67 r
.27418 .47866 m
.28824 .49108 L
s
.185 .244 .417 r
.59924 .38082 m .60909 .39314 L .61459 .40886 L p F P
0 0 0 r
s
.185 .244 .417 r
.62467 .4214 m .61459 .40886 L .60909 .39314 L p F P
0 0 0 r
s
.24 .35 .67 r
.61143 .40376 m
.61256 .40516 L
s
.6071 .39517 m
.61143 .40376 L
s
.256 .392 .783 r
.48367 .63969 m .48185 .63805 L .46455 .64269 L p F P
0 0 0 r
s
.256 .392 .783 r
.46093 .63948 m .46455 .64269 L .48185 .63805 L p F P
0 0 0 r
s
.24 .35 .67 r
.27419 .45384 m
.24679 .42913 L
s
.27418 .47866 m
.27419 .45384 L
s
.272 .378 .683 r
.64697 .48447 m .63711 .47256 L .63759 .45234 L p F P
0 0 0 r
s
.24 .35 .67 r
.63616 .45283 m
.63754 .45452 L
s
.294 .415 .762 r
.63711 .47256 m .64697 .48447 L .64267 .5052 L p F P
0 0 0 r
s
1 .304 .129 r
.51565 .63867 m .51877 .63772 L .53666 .64206 L p F P
0 0 0 r
s
1 .304 .129 r
.54281 .64021 m .53666 .64206 L .51877 .63772 L p F P
0 0 0 r
s
.092 .026 .011 r
.5153 .3303 m .49934 .33659 L .49926 .34213 L p F P
0 0 0 r
s
.83 .24 .1 r
.49384 .34046 m
.49932 .3383 L
s
.51033 .33397 m
.51426 .33242 L
s
.51426 .33242 m
.52483 .32754 L
s
.092 .026 .011 r
.48158 .34907 m .49926 .34213 L .49934 .33659 L p F P
0 0 0 r
s
.83 .24 .1 r
.69629 .26677 m
.65518 .28288 L
s
.65518 .28288 m
.64462 .28037 L
s
.178 .043 .018 r
.46408 .35594 m .44676 .36273 L .44241 .37413 L p F P
0 0 0 r
s
.178 .043 .018 r
.42389 .38134 m .44241 .37413 L .44676 .36273 L p F P
0 0 0 r
s
.83 .24 .1 r
.61713 .62284 m
.65783 .61062 L
s
.22 .344 .7 r
.45728 .63625 m .45362 .63299 L .4324 .6295 L p F P
0 0 0 r
s
.24 .35 .67 r
.45532 .6345 m
.45773 .63482 L
s
.22 .344 .7 r
.42692 .62471 m .4324 .6295 L .45362 .63299 L p F P
0 0 0 r
s
.235 .32 .564 r
.61459 .40886 m .62467 .4214 L .6275 .43995 L p F P
0 0 0 r
s
.235 .32 .564 r
.63759 .45234 m .6275 .43995 L .62467 .4214 L p F P
0 0 0 r
s
.272 .378 .683 r
.6275 .43995 m .63759 .45234 L .63711 .47256 L p F P
0 0 0 r
s
.934 .288 .121 r
.56137 .6346 m .56761 .63272 L .59854 .62911 L p F P
0 0 0 r
s
.24 .35 .67 r
.56886 .63326 m
.57182 .63616 L
s
.313 .462 .89 r
.59381 .62431 m .59854 .62911 L .56761 .63272 L p F P
0 0 0 r
s
.83 .24 .1 r
.29071 .59319 m
.30491 .62209 L
s
.34206 .60985 m
.30491 .62209 L
s
.46928 .64725 m
.48484 .64249 L
s
.84243 .54658 m
.84451 .53149 L
s
.545 .147 .066 r
.34092 .44432 m .32216 .45146 L .32277 .4717 L p F P
0 0 0 r
s
.83 .24 .1 r
.3211 .45307 m
.3222 .45265 L
s
.33984 .44595 m
.34258 .44491 L
s
.545 .147 .066 r
.30429 .47861 m .32277 .4717 L .32216 .45146 L p F P
0 0 0 r
s
1 .304 .129 r
.51877 .63772 m .52189 .63677 L .54281 .64021 L p F P
0 0 0 r
s
1 .304 .129 r
.54898 .63835 m .54281 .64021 L .52189 .63677 L p F P
0 0 0 r
s
.24 .35 .67 r
.50129 .27689 m
.52376 .30464 L
s
.52376 .30464 m
.54348 .31487 L
s
.83 .24 .1 r
.27213 .53049 m
.27957 .56209 L
s
.256 .392 .783 r
.48185 .63805 m .48002 .6364 L .46093 .63948 L p F P
0 0 0 r
s
.256 .392 .783 r
.45728 .63625 m .46093 .63948 L .48002 .6364 L p F P
0 0 0 r
s
.24 .35 .67 r
.45773 .63482 m
.45934 .63626 L
s
.31 .076 .035 r
.42389 .38134 m .40558 .38847 L .4008 .40402 L p F P
0 0 0 r
s
.31 .076 .035 r
.3818 .41134 m .4008 .40402 L .40558 .38847 L p F P
0 0 0 r
s
.44 .115 .052 r
.3818 .41134 m .36301 .41858 L .3599 .43711 L p F P
0 0 0 r
s
.44 .115 .052 r
.34092 .44432 m .3599 .43711 L .36301 .41858 L p F P
0 0 0 r
s
.83 .24 .1 r
.34258 .44491 m
.3428 .44361 L
s
.127 .202 .442 r
.39887 .61032 m .39155 .60398 L .37034 .59041 L p F P
0 0 0 r
s
.094 .106 .204 r
.37034 .59041 m .36132 .58263 L .34232 .56575 L p F P
0 0 0 r
s
.127 .202 .442 r
.36132 .58263 m .37034 .59041 L .39155 .60398 L p F P
0 0 0 r
s
1 .301 .129 r
.49396 .64528 m .49088 .64622 L .5 .62969 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.50133 .64645 m
.50819 .65271 L
s
.28 .423 .834 r
.48909 .6446 m .49088 .64622 L .5 .62969 L closepath p F P
0 0 0 r
s
.168 .272 .57 r
.42692 .62471 m .42139 .61987 L .39887 .61032 L p F P
0 0 0 r
s
.168 .272 .57 r
.39155 .60398 m .39887 .61032 L .42139 .61987 L p F P
0 0 0 r
s
.319 .46 .871 r
.62974 .58977 m .62255 .58198 L .63936 .565 L p F P
0 0 0 r
s
.319 .464 .884 r
.62255 .58198 m .62974 .58977 L .60851 .60345 L p F P
0 0 0 r
s
.319 .464 .884 r
.61456 .60979 m .60851 .60345 L .62974 .58977 L p F P
0 0 0 r
s
1 .304 .129 r
.52189 .63677 m .52503 .63582 L .54898 .63835 L p F P
0 0 0 r
s
1 .304 .129 r
.55516 .63648 m .54898 .63835 L .52503 .63582 L p F P
0 0 0 r
s
.094 .106 .204 r
.33176 .55664 m .34232 .56575 L .36132 .58263 L p F P
0 0 0 r
s
.147 .182 .324 r
.34232 .56575 m .33176 .55664 L .31591 .53729 L p F P
0 0 0 r
s
.318 .465 .89 r
.60851 .60345 m .61456 .60979 L .58904 .61947 L p F P
0 0 0 r
s
.318 .465 .89 r
.59381 .62431 m .58904 .61947 L .61456 .60979 L p F P
0 0 0 r
s
.83 .24 .1 r
.604 .62012 m
.61713 .62284 L
s
.24 .35 .67 r
.37663 .22356 m
.40159 .25242 L
s
.40159 .25242 m
.42877 .2455 L
s
1 .301 .129 r
.49704 .64434 m .49396 .64528 L .5 .62969 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.49922 .64452 m
.50133 .64645 L
s
.83 .24 .1 r
.69946 .59811 m
.70903 .5946 L
s
.75093 .582 m
.70903 .5946 L
s
.315 .452 .849 r
.63936 .565 m .6312 .55588 L .64357 .53644 L p F P
0 0 0 r
s
.319 .46 .871 r
.6312 .55588 m .63936 .565 L .62255 .58198 L p F P
0 0 0 r
s
.83 .24 .1 r
.3963 .62323 m
.41363 .64408 L
s
.136 .17 .302 r
.57295 .34536 m .58245 .35728 L .58921 .36827 L p F P
0 0 0 r
s
.136 .17 .302 r
.59924 .38082 m .58921 .36827 L .58245 .35728 L p F P
0 0 0 r
s
.28 .423 .834 r
.48729 .64297 m .48909 .6446 L .5 .62969 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.34206 .60985 m
.35841 .63537 L
s
.3963 .62323 m
.35841 .63537 L
s
.092 .026 .011 r
.53141 .32396 m .5153 .3303 L .51713 .33512 L p F P
0 0 0 r
s
.83 .24 .1 r
.51426 .33242 m
.51587 .33179 L
s
.092 .026 .011 r
.49926 .34213 m .51713 .33512 L .5153 .3303 L p F P
0 0 0 r
s
.83 .24 .1 r
.74909 .25977 m
.73836 .25029 L
s
.626 .173 .077 r
.32277 .4717 m .30429 .47861 L .31004 .49961 L p F P
0 0 0 r
s
.626 .173 .077 r
.29227 .50613 m .31004 .49961 L .30429 .47861 L p F P
0 0 0 r
s
1 .301 .129 r
.50013 .6434 m .49704 .64434 L .5 .62969 L closepath p F P
0 0 0 r
s
.22 .344 .7 r
.45362 .63299 m .44993 .62972 L .42692 .62471 L p F P
0 0 0 r
s
.22 .344 .7 r
.42139 .61987 m .42692 .62471 L .44993 .62972 L p F P
0 0 0 r
s
1 .304 .129 r
.52503 .63582 m .52816 .63486 L .55516 .63648 L p F P
0 0 0 r
s
1 .304 .129 r
.56137 .6346 m .55516 .63648 L .52816 .63486 L p F P
0 0 0 r
s
.24 .35 .67 r
.53684 .64408 m
.55173 .63648 L
s
.55173 .63648 m
.55473 .63495 L
s
.52802 .63575 m
.53684 .64408 L
s
.147 .182 .324 r
.30402 .52697 m .31591 .53729 L .33176 .55664 L p F P
0 0 0 r
s
.188 .246 .422 r
.31591 .53729 m .30402 .52697 L .29227 .50613 L p F P
0 0 0 r
s
.313 .462 .89 r
.58904 .61947 m .59381 .62431 L .56427 .62945 L p F P
0 0 0 r
s
.313 .462 .89 r
.56761 .63272 m .56427 .62945 L .59381 .62431 L p F P
0 0 0 r
s
.178 .043 .018 r
.48158 .34907 m .46408 .35594 L .46113 .36683 L p F P
0 0 0 r
s
.178 .043 .018 r
.44241 .37413 m .46113 .36683 L .46408 .35594 L p F P
0 0 0 r
s
.256 .392 .783 r
.48002 .6364 m .47819 .63474 L .45728 .63625 L p F P
0 0 0 r
s
.256 .392 .783 r
.45362 .63299 m .45728 .63625 L .47819 .63474 L p F P
0 0 0 r
s
.83 .24 .1 r
.27957 .56209 m
.29071 .59319 L
s
.32785 .58056 m
.29071 .59319 L
s
1 .301 .129 r
.50322 .64246 m .50013 .6434 L .5 .62969 L closepath p F P
0 0 0 r
s
.089 .134 .321 r
.54767 .31755 m .55652 .32861 L .56327 .33323 L p F P
0 0 0 r
s
.83 .24 .1 r
.54891 .31879 m
.54902 .31874 L
s
.089 .134 .321 r
.57295 .34536 m .56327 .33323 L .55652 .32861 L p F P
0 0 0 r
s
.24 .35 .67 r
.56502 .34175 m
.5804 .35742 L
s
.308 .438 .814 r
.64357 .53644 m .6346 .52611 L .64267 .5052 L p F P
0 0 0 r
s
.315 .452 .849 r
.6346 .52611 m .64357 .53644 L .6312 .55588 L p F P
0 0 0 r
s
.28 .423 .834 r
.48548 .64133 m .48729 .64297 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .301 .129 r
.50632 .64152 m .50322 .64246 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .304 .129 r
.52816 .63486 m .53131 .6339 L .56137 .6346 L p F P
0 0 0 r
s
1 .304 .129 r
.56761 .63272 m .56137 .6346 L .53131 .6339 L p F P
0 0 0 r
s
.83 .24 .1 r
.56166 .63292 m
.56364 .63232 L
s
.56364 .63232 m
.56615 .63277 L
s
.24 .35 .67 r
.27246 .29655 m
.29578 .27308 L
s
.26861 .24454 m
.29578 .27308 L
s
.29578 .27308 m
.32151 .25262 L
s
.691 .194 .085 r
.31004 .49961 m .29227 .50613 L .30402 .52697 L p F P
0 0 0 r
s
.83 .24 .1 r
.27213 .53049 m
.30027 .52032 L
s
.24 .35 .67 r
.3056 .51978 m
.30685 .5244 L
s
.30685 .5244 m
.33277 .54698 L
s
.545 .147 .066 r
.3599 .43711 m .34092 .44432 L .34147 .46471 L p F P
0 0 0 r
s
.545 .147 .066 r
.32277 .4717 m .34147 .46471 L .34092 .44432 L p F P
0 0 0 r
s
.83 .24 .1 r
.56364 .63232 m
.56636 .6315 L
s
1 .301 .129 r
.50942 .64057 m .50632 .64152 L .5 .62969 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.45456 .24394 m
.47808 .2725 L
s
.47808 .2725 m
.50129 .27689 L
s
.27988 .50091 m
.29933 .51785 L
s
.29933 .51785 m
.30087 .51919 L
s
.30495 .52274 m
.30685 .5244 L
s
.28 .423 .834 r
.48367 .63969 m .48548 .64133 L .5 .62969 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.24679 .42913 m
.25271 .40257 L
s
.22465 .37662 m
.25271 .40257 L
s
.25235 .32222 m
.27246 .29655 L
s
.2448 .26846 m
.27246 .29655 L
s
.83 .24 .1 r
.64462 .28037 m
.60378 .29645 L
s
.60378 .29645 m
.59449 .30085 L
s
.294 .415 .762 r
.64267 .5052 m .63306 .49384 L .63711 .47256 L p F P
0 0 0 r
s
.308 .438 .814 r
.63306 .49384 m .64267 .5052 L .6346 .52611 L p F P
0 0 0 r
s
.83 .24 .1 r
.79381 .56911 m
.79932 .55963 L
s
.84243 .54658 m
.79932 .55963 L
s
.31 .076 .035 r
.44241 .37413 m .42389 .38134 L .42002 .39661 L p F P
0 0 0 r
s
.31 .076 .035 r
.4008 .40402 m .42002 .39661 L .42389 .38134 L p F P
0 0 0 r
s
1 .301 .129 r
.51253 .63962 m .50942 .64057 L .5 .62969 L closepath p F P
0 0 0 r
s
.185 .244 .417 r
.58921 .36827 m .59924 .38082 L .6043 .39608 L p F P
0 0 0 r
s
.24 .35 .67 r
.5804 .35742 m
.58951 .36882 L
s
.59934 .38112 m
.59955 .38138 L
s
.185 .244 .417 r
.61459 .40886 m .6043 .39608 L .59924 .38082 L p F P
0 0 0 r
s
.44 .115 .052 r
.4008 .40402 m .3818 .41134 L .37909 .42981 L p F P
0 0 0 r
s
.44 .115 .052 r
.3599 .43711 m .37909 .42981 L .3818 .41134 L p F P
0 0 0 r
s
.256 .392 .783 r
.47819 .63474 m .47636 .63308 L .45362 .63299 L p F P
0 0 0 r
s
.256 .392 .783 r
.44993 .62972 m .45362 .63299 L .47636 .63308 L p F P
0 0 0 r
s
1 .304 .129 r
.53131 .6339 m .53446 .63294 L .56761 .63272 L p F P
0 0 0 r
s
.306 .454 .882 r
.56427 .62945 m .56761 .63272 L .53446 .63294 L p F P
0 0 0 r
s
.168 .272 .57 r
.42139 .61987 m .41581 .61499 L .39155 .60398 L p F P
0 0 0 r
s
.168 .272 .57 r
.38414 .59756 m .39155 .60398 L .41581 .61499 L p F P
0 0 0 r
s
.24 .35 .67 r
.40839 .61045 m
.40982 .61169 L
s
.38978 .60273 m
.39041 .60299 L
s
.40502 .60905 m
.40839 .61045 L
s
.127 .202 .442 r
.39155 .60398 m .38414 .59756 L .36132 .58263 L p F P
0 0 0 r
s
.28 .423 .834 r
.48185 .63805 m .48367 .63969 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .301 .129 r
.51565 .63867 m .51253 .63962 L .5 .62969 L closepath p F P
0 0 0 r
s
.092 .026 .011 r
.54767 .31755 m .53141 .32396 L .53518 .32804 L p F P
0 0 0 r
s
.83 .24 .1 r
.52699 .32741 m
.53257 .32521 L
s
.54381 .32079 m
.54882 .31882 L
s
.092 .026 .011 r
.51713 .33512 m .53518 .32804 L .53141 .32396 L p F P
0 0 0 r
s
.22 .344 .7 r
.44993 .62972 m .44622 .62643 L .42139 .61987 L p F P
0 0 0 r
s
.22 .344 .7 r
.41581 .61499 m .42139 .61987 L .44622 .62643 L p F P
0 0 0 r
s
.319 .464 .884 r
.60851 .60345 m .60238 .59702 L .62255 .58198 L p F P
0 0 0 r
s
.318 .465 .89 r
.60238 .59702 m .60851 .60345 L .58422 .61459 L p F P
0 0 0 r
s
.318 .465 .89 r
.58904 .61947 m .58422 .61459 L .60851 .60345 L p F P
0 0 0 r
s
.24 .35 .67 r
.29478 .22359 m
.32151 .25262 L
s
.32151 .25262 m
.34877 .23589 L
s
.272 .378 .683 r
.63711 .47256 m .62706 .46042 L .6275 .43995 L p F P
0 0 0 r
s
.294 .415 .762 r
.62706 .46042 m .63711 .47256 L .63306 .49384 L p F P
0 0 0 r
s
.094 .106 .204 r
.36132 .58263 m .35218 .57475 L .33176 .55664 L p F P
0 0 0 r
s
.127 .202 .442 r
.35218 .57475 m .36132 .58263 L .38414 .59756 L p F P
0 0 0 r
s
.313 .462 .89 r
.58422 .61459 m .58904 .61947 L .56091 .62615 L p F P
0 0 0 r
s
.313 .462 .89 r
.56427 .62945 m .56091 .62615 L .58904 .61947 L p F P
0 0 0 r
s
.83 .24 .1 r
.57058 .63022 m
.57619 .62852 L
s
1 .301 .129 r
.51877 .63772 m .51565 .63867 L .5 .62969 L closepath p F P
0 0 0 r
s
.626 .173 .077 r
.34147 .46471 m .32277 .4717 L .32801 .49302 L p F P
0 0 0 r
s
.626 .173 .077 r
.31004 .49961 m .32801 .49302 L .32277 .4717 L p F P
0 0 0 r
s
.235 .32 .564 r
.6043 .39608 m .61459 .40886 L .61721 .42731 L p F P
0 0 0 r
s
.235 .32 .564 r
.6275 .43995 m .61721 .42731 L .61459 .40886 L p F P
0 0 0 r
s
.24 .35 .67 r
.61469 .4212 m
.61597 .42808 L
s
.319 .46 .871 r
.62255 .58198 m .61527 .57409 L .6312 .55588 L p F P
0 0 0 r
s
.319 .464 .884 r
.61527 .57409 m .62255 .58198 L .60238 .59702 L p F P
0 0 0 r
s
.178 .043 .018 r
.49926 .34213 m .48158 .34907 L .48006 .35946 L p F P
0 0 0 r
s
.178 .043 .018 r
.46113 .36683 m .48006 .35946 L .48158 .34907 L p F P
0 0 0 r
s
.272 .378 .683 r
.61721 .42731 m .6275 .43995 L .62706 .46042 L p F P
0 0 0 r
s
.28 .423 .834 r
.48002 .6364 m .48185 .63805 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .301 .129 r
.52189 .63677 m .51877 .63772 L .5 .62969 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.2362 .34922 m
.25235 .32222 L
s
.22418 .29455 m
.25235 .32222 L
s
.83 .24 .1 r
.73836 .25029 m
.69629 .26677 L
s
.69629 .26677 m
.68641 .26392 L
s
.256 .392 .783 r
.47636 .63308 m .47452 .63142 L .44993 .62972 L p F P
0 0 0 r
s
.83 .24 .1 r
.41363 .64408 m
.45215 .63205 L
s
.45215 .63205 m
.46928 .64725 L
s
.256 .392 .783 r
.44622 .62643 m .44993 .62972 L .47452 .63142 L p F P
0 0 0 r
s
.094 .106 .204 r
.32103 .54738 m .33176 .55664 L .35218 .57475 L p F P
0 0 0 r
s
.147 .182 .324 r
.33176 .55664 m .32103 .54738 L .30402 .52697 L p F P
0 0 0 r
s
.83 .24 .1 r
.27957 .56209 m
.3166 .54909 L
s
.306 .454 .882 r
.56091 .62615 m .56427 .62945 L .53271 .63128 L p F P
0 0 0 r
s
.306 .454 .882 r
.53446 .63294 m .53271 .63128 L .56427 .62945 L p F P
0 0 0 r
s
.83 .24 .1 r
.64531 .60763 m
.65783 .61062 L
s
.69946 .59811 m
.65783 .61062 L
s
1 .301 .129 r
.52503 .63582 m .52189 .63677 L .5 .62969 L closepath p F P
0 0 0 r
s
.28 .423 .834 r
.47819 .63474 m .48002 .6364 L .5 .62969 L closepath p F P
0 0 0 r
s
.315 .452 .849 r
.6312 .55588 m .6229 .5466 L .6346 .52611 L p F P
0 0 0 r
s
.319 .46 .871 r
.6229 .5466 m .6312 .55588 L .61527 .57409 L p F P
0 0 0 r
s
.83 .24 .1 r
.32785 .58056 m
.34206 .60985 L
s
.691 .194 .085 r
.32801 .49302 m .31004 .49961 L .32084 .52093 L p F P
0 0 0 r
s
.691 .194 .085 r
.30402 .52697 m .32084 .52093 L .31004 .49961 L p F P
0 0 0 r
s
1 .301 .129 r
.52816 .63486 m .52503 .63582 L .5 .62969 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.27988 .50091 m
.27418 .47866 L
s
.2464 .45411 m
.27418 .47866 L
s
.545 .147 .066 r
.37909 .42981 m .3599 .43711 L .36038 .45764 L p F P
0 0 0 r
s
.83 .24 .1 r
.3588 .43875 m
.35992 .43832 L
s
.37798 .43146 m
.38037 .43055 L
s
.545 .147 .066 r
.34147 .46471 m .36038 .45764 L .3599 .43711 L p F P
0 0 0 r
s
.136 .17 .302 r
.56327 .33323 m .57295 .34536 L .57899 .35547 L p F P
0 0 0 r
s
.136 .17 .302 r
.58921 .36827 m .57899 .35547 L .57295 .34536 L p F P
0 0 0 r
s
.31 .076 .035 r
.46113 .36683 m .44241 .37413 L .43946 .38912 L p F P
0 0 0 r
s
.31 .076 .035 r
.42002 .39661 m .43946 .38912 L .44241 .37413 L p F P
0 0 0 r
s
1 .301 .129 r
.53131 .6339 m .52816 .63486 L .5 .62969 L closepath p F P
0 0 0 r
s
.28 .423 .834 r
.47636 .63308 m .47819 .63474 L .5 .62969 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.47624 .63297 m
.47913 .63268 L
s
.089 .134 .321 r
.56327 .33323 m .55342 .32088 L .54767 .31755 L p F P
0 0 0 r
s
.092 .026 .011 r
.53518 .32804 m .55342 .32088 L .54767 .31755 L p F P
0 0 0 r
s
.83 .24 .1 r
.54945 .31857 m
.55391 .31682 L
s
.24 .35 .67 r
.54952 .32241 m
.56502 .34175 L
s
.54348 .31487 m
.54616 .31821 L
s
.54616 .31821 m
.54627 .31834 L
s
.22 .344 .7 r
.44622 .62643 m .44248 .62311 L .41581 .61499 L p F P
0 0 0 r
s
.22 .344 .7 r
.41018 .61007 m .41581 .61499 L .44248 .62311 L p F P
0 0 0 r
s
.24 .35 .67 r
.40839 .61045 m
.41099 .61077 L
s
.168 .272 .57 r
.41581 .61499 m .41018 .61007 L .38414 .59756 L p F P
0 0 0 r
s
.746 .211 .092 r
.32084 .52093 m .30402 .52697 L .32103 .54738 L p F P
0 0 0 r
s
.83 .24 .1 r
.31424 .53923 m
.3166 .54909 L
s
.24 .35 .67 r
.31462 .53686 m
.31679 .54033 L
s
.31679 .54033 m
.31846 .54301 L
s
.44 .115 .052 r
.42002 .39661 m .4008 .40402 L .39852 .42243 L p F P
0 0 0 r
s
.44 .115 .052 r
.37909 .42981 m .39852 .42243 L .4008 .40402 L p F P
0 0 0 r
s
.83 .24 .1 r
.38037 .43055 m
.38056 .42925 L
s
.318 .465 .89 r
.58422 .61459 m .57936 .60966 L .60238 .59702 L p F P
0 0 0 r
s
.313 .462 .89 r
.57936 .60966 m .58422 .61459 L .55753 .62284 L p F P
0 0 0 r
s
.313 .462 .89 r
.56091 .62615 m .55753 .62284 L .58422 .61459 L p F P
0 0 0 r
s
.24 .35 .67 r
.40408 .21618 m
.42877 .2455 L
s
.42877 .2455 m
.45456 .24394 L
s
1 .301 .129 r
.53446 .63294 m .53131 .6339 L .5 .62969 L closepath p F P
0 0 0 r
s
.256 .392 .783 r
.47452 .63142 m .47267 .62975 L .44622 .62643 L p F P
0 0 0 r
s
.256 .392 .783 r
.44248 .62311 m .44622 .62643 L .47267 .62975 L p F P
0 0 0 r
s
.308 .438 .814 r
.6346 .52611 m .62546 .51559 L .63306 .49384 L p F P
0 0 0 r
s
.315 .452 .849 r
.62546 .51559 m .6346 .52611 L .6229 .5466 L p F P
0 0 0 r
s
.168 .272 .57 r
.37665 .59106 m .38414 .59756 L .41018 .61007 L p F P
0 0 0 r
s
.127 .202 .442 r
.38414 .59756 m .37665 .59106 L .35218 .57475 L p F P
0 0 0 r
s
.306 .454 .882 r
.55753 .62284 m .56091 .62615 L .53095 .62961 L p F P
0 0 0 r
s
.306 .454 .882 r
.53271 .63128 m .53095 .62961 L .56091 .62615 L p F P
0 0 0 r
s
.83 .24 .1 r
.55643 .62798 m
.55806 .62896 L
s
.24 .35 .67 r
.32244 .20636 m
.34877 .23589 L
s
.34877 .23589 m
.37663 .22356 L
s
.83 .24 .1 r
.59449 .30085 m
.55391 .31682 L
s
.55183 .31996 m
.55391 .31682 L
s
.28 .423 .834 r
.47452 .63142 m .47636 .63308 L .5 .62969 L closepath p F P
0 0 0 r
s
.319 .464 .884 r
.60238 .59702 m .59618 .59052 L .61527 .57409 L p F P
0 0 0 r
s
.318 .465 .89 r
.59618 .59052 m .60238 .59702 L .57936 .60966 L p F P
0 0 0 r
s
.296 .442 .865 r
.5 .62969 m .53271 .63128 L .53446 .63294 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.74208 .5853 m
.75093 .582 L
s
.79381 .56911 m
.75093 .582 L
s
.178 .043 .018 r
.51713 .33512 m .49926 .34213 L .4992 .352 L p F P
0 0 0 r
s
.178 .043 .018 r
.48006 .35946 m .4992 .352 L .49926 .34213 L p F P
0 0 0 r
s
.626 .173 .077 r
.36038 .45764 m .34147 .46471 L .34619 .48636 L p F P
0 0 0 r
s
.626 .173 .077 r
.32801 .49302 m .34619 .48636 L .34147 .46471 L p F P
0 0 0 r
s
.24 .35 .67 r
.52107 .28689 m
.54348 .31487 L
s
.54348 .31487 m
.54846 .31991 L
s
.28 .423 .834 r
.47267 .62975 m .47452 .63142 L .5 .62969 L closepath p F P
0 0 0 r
s
.094 .106 .204 r
.35218 .57475 m .34291 .56675 L .32103 .54738 L p F P
0 0 0 r
s
.127 .202 .442 r
.34291 .56675 m .35218 .57475 L .37665 .59106 L p F P
0 0 0 r
s
.24 .35 .67 r
.36159 .57972 m
.36496 .58264 L
s
.34454 .56557 m
.36159 .57972 L
s
.83 .24 .1 r
.3166 .54909 m
.32785 .58056 L
s
.296 .442 .865 r
.5 .62969 m .53095 .62961 L .53271 .63128 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.3166 .54909 m
.32116 .54749 L
s
.294 .415 .762 r
.63306 .49384 m .62327 .48227 L .62706 .46042 L p F P
0 0 0 r
s
.308 .438 .814 r
.62327 .48227 m .63306 .49384 L .62546 .51559 L p F P
0 0 0 r
s
.319 .46 .871 r
.61527 .57409 m .60787 .56608 L .6229 .5466 L p F P
0 0 0 r
s
.319 .464 .884 r
.60787 .56608 m .61527 .57409 L .59618 .59052 L p F P
0 0 0 r
s
.256 .392 .783 r
.47267 .62975 m .47082 .62807 L .44248 .62311 L p F P
0 0 0 r
s
.83 .24 .1 r
.45215 .63205 m
.46416 .6283 L
s
.256 .392 .783 r
.43872 .61978 m .44248 .62311 L .47082 .62807 L p F P
0 0 0 r
s
.22 .344 .7 r
.44248 .62311 m .43872 .61978 L .41018 .61007 L p F P
0 0 0 r
s
.185 .244 .417 r
.57899 .35547 m .58921 .36827 L .5938 .38303 L p F P
0 0 0 r
s
.185 .244 .417 r
.6043 .39608 m .5938 .38303 L .58921 .36827 L p F P
0 0 0 r
s
.24 .35 .67 r
.59062 .37786 m
.59184 .37939 L
s
.58523 .36709 m
.59062 .37786 L
s
.313 .462 .89 r
.55753 .62284 m .55413 .6195 L .57936 .60966 L p F P
0 0 0 r
s
.83 .24 .1 r
.57619 .62852 m
.604 .62012 L
s
.306 .454 .882 r
.55413 .6195 m .55753 .62284 L .52919 .62793 L p F P
0 0 0 r
s
.306 .454 .882 r
.53095 .62961 m .52919 .62793 L .55753 .62284 L p F P
0 0 0 r
s
.24 .35 .67 r
.22465 .37662 m
.2362 .34922 L
s
.2075 .32191 m
.2362 .34922 L
s
.691 .194 .085 r
.34619 .48636 m .32801 .49302 L .33784 .51483 L p F P
0 0 0 r
s
.691 .194 .085 r
.32084 .52093 m .33784 .51483 L .32801 .49302 L p F P
0 0 0 r
s
.28 .423 .834 r
.47082 .62807 m .47267 .62975 L .5 .62969 L closepath p F P
0 0 0 r
s
.22 .344 .7 r
.4045 .6051 m .41018 .61007 L .43872 .61978 L p F P
0 0 0 r
s
.168 .272 .57 r
.41018 .61007 m .4045 .6051 L .37665 .59106 L p F P
0 0 0 r
s
.296 .442 .865 r
.5 .62969 m .52919 .62793 L .53095 .62961 L closepath p F P
0 0 0 r
s
.545 .147 .066 r
.39852 .42243 m .37909 .42981 L .37952 .45048 L p F P
0 0 0 r
s
.545 .147 .066 r
.36038 .45764 m .37952 .45048 L .37909 .42981 L p F P
0 0 0 r
s
.83 .24 .1 r
.58914 .61054 m
.604 .62012 L
s
.64531 .60763 m
.604 .62012 L
s
.318 .465 .89 r
.57936 .60966 m .57445 .60469 L .59618 .59052 L p F P
0 0 0 r
s
.313 .462 .89 r
.57445 .60469 m .57936 .60966 L .55413 .6195 L p F P
0 0 0 r
s
.31 .076 .035 r
.48006 .35946 m .46113 .36683 L .45913 .38154 L p F P
0 0 0 r
s
.31 .076 .035 r
.43946 .38912 m .45913 .38154 L .46113 .36683 L p F P
0 0 0 r
s
.83 .24 .1 r
.68641 .26392 m
.64462 .28037 L
s
.64462 .28037 m
.63602 .28451 L
s
.24 .35 .67 r
.24679 .42913 m
.21827 .40341 L
s
.2464 .45411 m
.24679 .42913 L
s
.746 .211 .092 r
.33784 .51483 m .32084 .52093 L .33647 .54196 L p F P
0 0 0 r
s
.746 .211 .092 r
.32103 .54738 m .33647 .54196 L .32084 .52093 L p F P
0 0 0 r
s
.24 .35 .67 r
.32279 .54676 m
.34454 .56557 L
s
.83 .24 .1 r
.8377 .55592 m
.84243 .54658 L
s
.272 .378 .683 r
.62706 .46042 m .6168 .44803 L .61721 .42731 L p F P
0 0 0 r
s
.24 .35 .67 r
.61597 .42808 m
.61717 .42955 L
s
.294 .415 .762 r
.6168 .44803 m .62706 .46042 L .62327 .48227 L p F P
0 0 0 r
s
.794 .227 .099 r
.33647 .54196 m .32103 .54738 L .34291 .56675 L p F P
0 0 0 r
s
.24 .35 .67 r
.31846 .54301 m
.3217 .54582 L
s
.3217 .54582 m
.32183 .54593 L
s
.44 .115 .052 r
.43946 .38912 m .42002 .39661 L .41817 .41496 L p F P
0 0 0 r
s
.44 .115 .052 r
.39852 .42243 m .41817 .41496 L .42002 .39661 L p F P
0 0 0 r
s
.28 .423 .834 r
.46896 .62639 m .47082 .62807 L .5 .62969 L closepath p F P
0 0 0 r
s
.256 .392 .783 r
.47082 .62807 m .46896 .62639 L .43872 .61978 L p F P
0 0 0 r
s
.83 .24 .1 r
.46416 .6283 m
.46785 .62715 L
s
.306 .454 .882 r
.52919 .62793 m .52742 .62625 L .55413 .6195 L p F P
0 0 0 r
s
.296 .442 .865 r
.5 .62969 m .52742 .62625 L .52919 .62793 L closepath p F P
0 0 0 r
s
.235 .32 .564 r
.5938 .38303 m .6043 .39608 L .60671 .41442 L p F P
0 0 0 r
s
.235 .32 .564 r
.61721 .42731 m .60671 .41442 L .6043 .39608 L p F P
0 0 0 r
s
.315 .452 .849 r
.6229 .5466 m .61448 .53717 L .62546 .51559 L p F P
0 0 0 r
s
.319 .46 .871 r
.61448 .53717 m .6229 .5466 L .60787 .56608 L p F P
0 0 0 r
s
.272 .378 .683 r
.60671 .41442 m .61721 .42731 L .6168 .44803 L p F P
0 0 0 r
s
.168 .272 .57 r
.36906 .58449 m .37665 .59106 L .4045 .6051 L p F P
0 0 0 r
s
.127 .202 .442 r
.37665 .59106 m .36906 .58449 L .34291 .56675 L p F P
0 0 0 r
s
.83 .24 .1 r
.35004 .57302 m
.35126 .5726 L
s
.32785 .58056 m
.35004 .57302 L
s
.178 .043 .018 r
.53518 .32804 m .51713 .33512 L .51856 .34446 L p F P
0 0 0 r
s
.178 .043 .018 r
.4992 .352 m .51856 .34446 L .51713 .33512 L p F P
0 0 0 r
s
.256 .392 .783 r
.43494 .61643 m .43872 .61978 L .46896 .62639 L p F P
0 0 0 r
s
.22 .344 .7 r
.43872 .61978 m .43494 .61643 L .4045 .6051 L p F P
0 0 0 r
s
.986 .292 .125 r
.5 .62969 m .50944 .60913 L .50624 .61014 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.4949 .62915 m
.50075 .62734 L
s
.83 .24 .1 r
.50068 .62821 m
.50201 .62944 L
s
.986 .292 .125 r
.5 .62969 m .50624 .61014 L .50305 .61114 L closepath p F P
0 0 0 r
s
.986 .292 .125 r
.5 .62969 m .50305 .61114 L .49987 .61214 L closepath p F P
0 0 0 r
s
.986 .292 .125 r
.5 .62969 m .49987 .61214 L .49669 .61313 L closepath p F P
0 0 0 r
s
.986 .292 .125 r
.5 .62969 m .49669 .61313 L .49352 .61413 L closepath p F P
0 0 0 r
s
.986 .292 .125 r
.5 .62969 m .49352 .61413 L .49035 .61512 L closepath p F P
0 0 0 r
s
.296 .442 .865 r
.5 .62969 m .50944 .60913 L .51126 .61087 L closepath p F P
0 0 0 r
s
.296 .442 .865 r
.5 .62969 m .51126 .61087 L .51308 .6126 L closepath p F P
0 0 0 r
s
.296 .442 .865 r
.5 .62969 m .51308 .6126 L .5149 .61433 L closepath p F P
0 0 0 r
s
.986 .292 .125 r
.5 .62969 m .49035 .61512 L .48719 .61612 L closepath p F P
0 0 0 r
s
.986 .292 .125 r
.5 .62969 m .48719 .61612 L .48403 .61711 L closepath p F P
0 0 0 r
s
.986 .292 .125 r
.5 .62969 m .48403 .61711 L .48088 .61809 L closepath p F P
0 0 0 r
s
.986 .292 .125 r
.5 .62969 m .48088 .61809 L .47774 .61908 L closepath p F P
0 0 0 r
s
.986 .292 .125 r
.5 .62969 m .47774 .61908 L .4746 .62007 L closepath p F P
0 0 0 r
s
.986 .292 .125 r
.5 .62969 m .4746 .62007 L .47147 .62105 L closepath p F P
0 0 0 r
s
.986 .292 .125 r
.5 .62969 m .47147 .62105 L .46834 .62203 L closepath p F P
0 0 0 r
s
.986 .292 .125 r
.5 .62969 m .46834 .62203 L .46522 .62301 L closepath p F P
0 0 0 r
s
.296 .442 .865 r
.5 .62969 m .5149 .61433 L .5167 .61604 L closepath p F P
0 0 0 r
s
.296 .442 .865 r
.5 .62969 m .5167 .61604 L .5185 .61776 L closepath p F P
0 0 0 r
s
.296 .442 .865 r
.5 .62969 m .5185 .61776 L .5203 .61947 L closepath p F P
0 0 0 r
s
.296 .442 .865 r
.5 .62969 m .5203 .61947 L .52209 .62117 L closepath p F P
0 0 0 r
s
.296 .442 .865 r
.5 .62969 m .52209 .62117 L .52387 .62287 L closepath p F P
0 0 0 r
s
.296 .442 .865 r
.5 .62969 m .52387 .62287 L .52565 .62456 L closepath p F P
0 0 0 r
s
.296 .442 .865 r
.5 .62969 m .52565 .62456 L .52742 .62625 L closepath p F P
0 0 0 r
s
.28 .423 .834 r
.46709 .6247 m .46896 .62639 L .5 .62969 L closepath p F P
0 0 0 r
s
.28 .423 .834 r
.46522 .62301 m .46709 .6247 L .5 .62969 L closepath p F P
0 0 0 r
s
.313 .462 .89 r
.55413 .6195 m .55071 .61615 L .57445 .60469 L p F P
0 0 0 r
s
.306 .454 .882 r
.55071 .61615 m .55413 .6195 L .52742 .62625 L p F P
0 0 0 r
s
.319 .464 .884 r
.59618 .59052 m .5899 .58394 L .60787 .56608 L p F P
0 0 0 r
s
.318 .465 .89 r
.5899 .58394 m .59618 .59052 L .57445 .60469 L p F P
0 0 0 r
s
.24 .35 .67 r
.47791 .248 m
.50129 .27689 L
s
.50129 .27689 m
.52107 .28689 L
s
.256 .392 .783 r
.46896 .62639 m .46709 .6247 L .43494 .61643 L p F P
0 0 0 r
s
.83 .24 .1 r
.44138 .61867 m
.44319 .62092 L
s
.44319 .62092 m
.45215 .63205 L
s
.306 .454 .882 r
.52742 .62625 m .52565 .62456 L .55071 .61615 L p F P
0 0 0 r
s
.626 .173 .077 r
.37952 .45048 m .36038 .45764 L .36456 .47962 L p F P
0 0 0 r
s
.626 .173 .077 r
.34619 .48636 m .36456 .47962 L .36038 .45764 L p F P
0 0 0 r
s
.136 .17 .302 r
.55342 .32088 m .56327 .33323 L .56857 .34243 L p F P
0 0 0 r
s
.136 .17 .302 r
.57899 .35547 m .56857 .34243 L .56327 .33323 L p F P
0 0 0 r
s
.24 .35 .67 r
.31846 .54301 m
.33545 .55711 L
s
.29131 .51954 m
.31846 .54301 L
s
.83 .24 .1 r
.73836 .25029 m
.72919 .24707 L
s
.22 .344 .7 r
.39876 .60008 m .4045 .6051 L .43494 .61643 L p F P
0 0 0 r
s
.83 .24 .1 r
.3963 .62323 m
.42282 .61474 L
s
.168 .272 .57 r
.4045 .6051 m .39876 .60008 L .36906 .58449 L p F P
0 0 0 r
s
.83 .24 .1 r
.38007 .59732 m
.3963 .62323 L
s
.34206 .60985 m
.38007 .59732 L
s
.256 .392 .783 r
.46709 .6247 m .46522 .62301 L .43114 .61305 L p F P
0 0 0 r
s
.256 .392 .783 r
.43114 .61305 m .43494 .61643 L .46709 .6247 L p F P
0 0 0 r
s
.24 .35 .67 r
.42676 .61273 m
.43143 .61331 L
s
.83 .24 .1 r
.68758 .59485 m
.69946 .59811 L
s
.74208 .5853 m
.69946 .59811 L
s
.306 .454 .882 r
.54727 .61277 m .55071 .61615 L .52565 .62456 L p F P
0 0 0 r
s
.83 .24 .1 r
.54826 .62306 m
.55643 .62798 L
s
.306 .454 .882 r
.52565 .62456 m .52387 .62287 L .54727 .61277 L p F P
0 0 0 r
s
.83 .24 .1 r
.53213 .628 m
.54826 .62306 L
s
.318 .465 .89 r
.57445 .60469 m .5695 .59967 L .5899 .58394 L p F P
0 0 0 r
s
.313 .462 .89 r
.5695 .59967 m .57445 .60469 L .55071 .61615 L p F P
0 0 0 r
s
.24 .35 .67 r
.35064 .19352 m
.37663 .22356 L
s
.37663 .22356 m
.40408 .21618 L
s
.691 .194 .085 r
.36456 .47962 m .34619 .48636 L .35502 .50866 L p F P
0 0 0 r
s
.691 .194 .085 r
.33784 .51483 m .35502 .50866 L .34619 .48636 L p F P
0 0 0 r
s
.308 .438 .814 r
.62546 .51559 m .61616 .50488 L .62327 .48227 L p F P
0 0 0 r
s
.315 .452 .849 r
.61616 .50488 m .62546 .51559 L .61448 .53717 L p F P
0 0 0 r
s
.24 .35 .67 r
.61325 .53678 m
.61465 .53388 L
s
.22 .344 .7 r
.43494 .61643 m .43114 .61305 L .39876 .60008 L p F P
0 0 0 r
s
.83 .24 .1 r
.42282 .61474 m
.42827 .613 L
s
.37664 .59015 m
.38007 .59732 L
s
.37602 .58885 m
.37664 .59015 L
s
.38007 .59732 m
.38781 .59477 L
s
.794 .227 .099 r
.34291 .56675 m .35654 .56207 L .33647 .54196 L p F P
0 0 0 r
s
.838 .241 .105 r
.35654 .56207 m .34291 .56675 L .36906 .58449 L p F P
0 0 0 r
s
.24 .35 .67 r
.35091 .57048 m
.35174 .5712 L
s
.313 .462 .89 r
.55071 .61615 m .54727 .61277 L .5695 .59967 L p F P
0 0 0 r
s
.746 .211 .092 r
.35502 .50866 m .33784 .51483 L .35205 .53649 L p F P
0 0 0 r
s
.746 .211 .092 r
.33647 .54196 m .35205 .53649 L .33784 .51483 L p F P
0 0 0 r
s
.545 .147 .066 r
.41817 .41496 m .39852 .42243 L .39887 .44324 L p F P
0 0 0 r
s
.83 .24 .1 r
.39739 .42409 m
.39854 .42366 L
s
.41702 .41663 m
.41904 .41587 L
s
.545 .147 .066 r
.37952 .45048 m .39887 .44324 L .39852 .42243 L p F P
0 0 0 r
s
.794 .227 .099 r
.35205 .53649 m .33647 .54196 L .35654 .56207 L p F P
0 0 0 r
s
.24 .35 .67 r
.33545 .55711 m
.35091 .57048 L
s
.31 .076 .035 r
.4992 .352 m .48006 .35946 L .47903 .37387 L p F P
0 0 0 r
s
.31 .076 .035 r
.45913 .38154 m .47903 .37387 L .48006 .35946 L p F P
0 0 0 r
s
.319 .46 .871 r
.60787 .56608 m .60037 .55795 L .61448 .53717 L p F P
0 0 0 r
s
.24 .35 .67 r
.61325 .53678 m
.6141 .53773 L
s
.319 .464 .884 r
.60037 .55795 m .60787 .56608 L .5899 .58394 L p F P
0 0 0 r
s
.954 .28 .12 r
.43726 .61109 m .43114 .61305 L .46522 .62301 L p F P
0 0 0 r
s
.954 .28 .12 r
.46522 .62301 m .46834 .62203 L .43726 .61109 L p F P
0 0 0 r
s
.306 .454 .882 r
.54381 .60937 m .54727 .61277 L .52387 .62287 L p F P
0 0 0 r
s
.306 .454 .882 r
.52387 .62287 m .52209 .62117 L .54381 .60937 L p F P
0 0 0 r
s
.83 .24 .1 r
.35285 .52905 m
.3545 .5358 L
s
.44 .115 .052 r
.45913 .38154 m .43946 .38912 L .43805 .4074 L p F P
0 0 0 r
s
.44 .115 .052 r
.41817 .41496 m .43805 .4074 L .43946 .38912 L p F P
0 0 0 r
s
.83 .24 .1 r
.41904 .41587 m
.4192 .41456 L
s
.954 .28 .12 r
.44341 .60912 m .43726 .61109 L .46834 .62203 L p F P
0 0 0 r
s
.954 .28 .12 r
.46834 .62203 m .47147 .62105 L .44341 .60912 L p F P
0 0 0 r
s
.178 .043 .018 r
.55342 .32088 m .53518 .32804 L .53814 .33684 L p F P
0 0 0 r
s
.178 .043 .018 r
.51856 .34446 m .53814 .33684 L .53518 .32804 L p F P
0 0 0 r
s
.306 .454 .882 r
.54032 .60595 m .54381 .60937 L .52209 .62117 L p F P
0 0 0 r
s
.24 .35 .67 r
.54286 .60844 m
.54334 .6082 L
s
.306 .454 .882 r
.52209 .62117 m .5203 .61947 L .54032 .60595 L p F P
0 0 0 r
s
.954 .28 .12 r
.44957 .60715 m .44341 .60912 L .47147 .62105 L p F P
0 0 0 r
s
.954 .28 .12 r
.47147 .62105 m .4746 .62007 L .44957 .60715 L p F P
0 0 0 r
s
.838 .241 .105 r
.36906 .58449 m .38051 .58066 L .35654 .56207 L p F P
0 0 0 r
s
.83 .24 .1 r
.37326 .58309 m
.37557 .58791 L
s
.879 .254 .11 r
.38051 .58066 m .36906 .58449 L .39876 .60008 L p F P
0 0 0 r
s
.24 .35 .67 r
.37706 .58603 m
.37802 .58642 L
s
.83 .24 .1 r
.63602 .28451 m
.59449 .30085 L
s
.59449 .30085 m
.58767 .312 L
s
.24 .35 .67 r
.2448 .26846 m
.26861 .24454 L
s
.26861 .24454 m
.29478 .22359 L
s
.294 .415 .762 r
.62327 .48227 m .61328 .47047 L .6168 .44803 L p F P
0 0 0 r
s
.308 .438 .814 r
.61328 .47047 m .62327 .48227 L .61616 .50488 L p F P
0 0 0 r
s
.917 .268 .115 r
.40769 .59717 m .39876 .60008 L .43114 .61305 L p F P
0 0 0 r
s
.917 .268 .115 r
.43114 .61305 m .43726 .61109 L .40769 .59717 L p F P
0 0 0 r
s
.83 .24 .1 r
.7857 .5722 m
.79381 .56911 L
s
.8377 .55592 m
.79381 .56911 L
s
.319 .464 .884 r
.5899 .58394 m .58355 .57729 L .60037 .55795 L p F P
0 0 0 r
s
.24 .35 .67 r
.59403 .56389 m
.59464 .56455 L
s
.318 .465 .89 r
.58355 .57729 m .5899 .58394 L .5695 .59967 L p F P
0 0 0 r
s
.24 .35 .67 r
.43008 .2142 m
.45456 .24394 L
s
.45456 .24394 m
.47791 .248 L
s
.313 .462 .89 r
.5645 .5946 m .5695 .59967 L .54727 .61277 L p F P
0 0 0 r
s
.313 .462 .89 r
.54727 .61277 m .54381 .60937 L .5645 .5946 L p F P
0 0 0 r
s
.83 .24 .1 r
.54826 .62306 m
.58914 .61054 L
s
.24 .35 .67 r
.54334 .6082 m
.54423 .60907 L
s
.29131 .51954 m
.27988 .50091 L
s
.2518 .47645 m
.27988 .50091 L
s
.21827 .40341 m
.22465 .37662 L
s
.19544 .3496 m
.22465 .37662 L
s
.954 .28 .12 r
.45576 .60517 m .44957 .60715 L .4746 .62007 L p F P
0 0 0 r
s
.954 .28 .12 r
.4746 .62007 m .47774 .61908 L .45576 .60517 L p F P
0 0 0 r
s
.626 .173 .077 r
.39887 .44324 m .37952 .45048 L .38314 .4728 L p F P
0 0 0 r
s
.626 .173 .077 r
.36456 .47962 m .38314 .4728 L .37952 .45048 L p F P
0 0 0 r
s
.24 .35 .67 r
.22418 .29455 m
.2448 .26846 L
s
.185 .244 .417 r
.56857 .34243 m .57899 .35547 L .58309 .36972 L p F P
0 0 0 r
s
.24 .35 .67 r
.57907 .35575 m
.57928 .35602 L
s
.185 .244 .417 r
.5938 .38303 m .58309 .36972 L .57899 .35547 L p F P
0 0 0 r
s
.879 .254 .11 r
.39876 .60008 m .40769 .59717 L .38051 .58066 L p F P
0 0 0 r
s
.306 .454 .882 r
.53681 .60251 m .54032 .60595 L .5203 .61947 L p F P
0 0 0 r
s
.306 .454 .882 r
.5203 .61947 m .5185 .61776 L .53681 .60251 L p F P
0 0 0 r
s
.318 .465 .89 r
.5695 .59967 m .5645 .5946 L .58355 .57729 L p F P
0 0 0 r
s
.24 .35 .67 r
.5703 .58813 m
.57092 .58877 L
s
.794 .227 .099 r
.35654 .56207 m .37029 .55736 L .35205 .53649 L p F P
0 0 0 r
s
.83 .24 .1 r
.35216 .53662 m
.3545 .5358 L
s
.838 .241 .105 r
.37029 .55736 m .35654 .56207 L .38051 .58066 L p F P
0 0 0 r
s
.83 .24 .1 r
.3545 .5358 m
.35661 .5417 L
s
.954 .28 .12 r
.46198 .60318 m .45576 .60517 L .47774 .61908 L p F P
0 0 0 r
s
.954 .28 .12 r
.47774 .61908 m .48088 .61809 L .46198 .60318 L p F P
0 0 0 r
s
.315 .452 .849 r
.61448 .53717 m .60591 .52759 L .61616 .50488 L p F P
0 0 0 r
s
.319 .46 .871 r
.60591 .52759 m .61448 .53717 L .60037 .55795 L p F P
0 0 0 r
s
.24 .35 .67 r
.59403 .56389 m
.60111 .5539 L
s
.917 .268 .115 r
.41666 .59423 m .40769 .59717 L .43726 .61109 L p F P
0 0 0 r
s
.917 .268 .115 r
.43726 .61109 m .44341 .60912 L .41666 .59423 L p F P
0 0 0 r
s
.24 .35 .67 r
.42817 .60855 m
.42962 .60984 L
s
.691 .194 .085 r
.38314 .4728 m .36456 .47962 L .37238 .50243 L p F P
0 0 0 r
s
.691 .194 .085 r
.35502 .50866 m .37238 .50243 L .36456 .47962 L p F P
0 0 0 r
s
.746 .211 .092 r
.35205 .53649 m .36779 .53097 L .35502 .50866 L p F P
0 0 0 r
s
.794 .227 .099 r
.36779 .53097 m .35205 .53649 L .37029 .55736 L p F P
0 0 0 r
s
.954 .28 .12 r
.46821 .60119 m .46198 .60318 L .48088 .61809 L p F P
0 0 0 r
s
.24 .35 .67 r
.44411 .61249 m
.46198 .61054 L
s
.954 .28 .12 r
.48088 .61809 m .48403 .61711 L .46821 .60119 L p F P
0 0 0 r
s
.24 .35 .67 r
.46932 .61724 m
.47155 .61927 L
s
.272 .378 .683 r
.6168 .44803 m .60633 .43539 L .60671 .41442 L p F P
0 0 0 r
s
.294 .415 .762 r
.60633 .43539 m .6168 .44803 L .61328 .47047 L p F P
0 0 0 r
s
.24 .35 .67 r
.29478 .22359 m
.32244 .20636 L
s
.746 .211 .092 r
.37238 .50243 m .35502 .50866 L .36779 .53097 L p F P
0 0 0 r
s
.306 .454 .882 r
.53328 .59904 m .53681 .60251 L .5185 .61776 L p F P
0 0 0 r
s
.306 .454 .882 r
.5185 .61776 m .5167 .61604 L .53328 .59904 L p F P
0 0 0 r
s
.31 .076 .035 r
.51856 .34446 m .4992 .352 L .49916 .36611 L p F P
0 0 0 r
s
.31 .076 .035 r
.47903 .37387 m .49916 .36611 L .4992 .352 L p F P
0 0 0 r
s
.838 .241 .105 r
.38051 .58066 m .39204 .57681 L .37029 .55736 L p F P
0 0 0 r
s
.879 .254 .11 r
.39204 .57681 m .38051 .58066 L .40769 .59717 L p F P
0 0 0 r
s
.24 .35 .67 r
.37802 .58642 m
.38336 .58859 L
s
.38336 .58859 m
.38847 .59306 L
s
.954 .28 .12 r
.47447 .59919 m .46821 .60119 L .48403 .61711 L p F P
0 0 0 r
s
.24 .35 .67 r
.46198 .61054 m
.46932 .61724 L
s
.954 .28 .12 r
.48403 .61711 m .48719 .61612 L .47447 .59919 L p F P
0 0 0 r
s
.235 .32 .564 r
.58309 .36972 m .5938 .38303 L .596 .40125 L p F P
0 0 0 r
s
.235 .32 .564 r
.60671 .41442 m .596 .40125 L .5938 .38303 L p F P
0 0 0 r
s
.24 .35 .67 r
.59383 .39595 m
.59496 .40232 L
s
.83 .24 .1 r
.63098 .59772 m
.64531 .60763 L
s
.68758 .59485 m
.64531 .60763 L
s
.545 .147 .066 r
.43805 .4074 m .41817 .41496 L .41846 .43592 L p F P
0 0 0 r
s
.545 .147 .066 r
.39887 .44324 m .41846 .43592 L .41817 .41496 L p F P
0 0 0 r
s
.879 .254 .11 r
.40769 .59717 m .41666 .59423 L .39204 .57681 L p F P
0 0 0 r
s
.313 .462 .89 r
.55946 .58949 m .5645 .5946 L .54381 .60937 L p F P
0 0 0 r
s
.24 .35 .67 r
.54334 .6082 m
.5467 .6057 L
s
.56328 .59336 m
.5703 .58813 L
s
.313 .462 .89 r
.54381 .60937 m .54032 .60595 L .55946 .58949 L p F P
0 0 0 r
s
.83 .24 .1 r
.72919 .24707 m
.68641 .26392 L
s
.68641 .26392 m
.67854 .26777 L
s
.917 .268 .115 r
.42568 .59129 m .41666 .59423 L .44341 .60912 L p F P
0 0 0 r
s
.917 .268 .115 r
.44341 .60912 m .44957 .60715 L .42568 .59129 L p F P
0 0 0 r
s
.24 .35 .67 r
.42618 .60678 m
.42817 .60855 L
s
.272 .378 .683 r
.596 .40125 m .60671 .41442 L .60633 .43539 L p F P
0 0 0 r
s
.954 .28 .12 r
.48075 .59718 m .47447 .59919 L .48719 .61612 L p F P
0 0 0 r
s
.83 .24 .1 r
.47475 .59811 m
.47536 .5989 L
s
.48598 .61257 m
.48844 .61572 L
s
.954 .28 .12 r
.48719 .61612 m .49035 .61512 L .48075 .59718 L p F P
0 0 0 r
s
.136 .17 .302 r
.56857 .34243 m .55794 .32912 L .55342 .32088 L p F P
0 0 0 r
s
.24 .35 .67 r
.55884 .33044 m
.56885 .34297 L
s
.178 .043 .018 r
.53814 .33684 m .55794 .32912 L .55342 .32088 L p F P
0 0 0 r
s
.24 .35 .67 r
.55765 .32923 m
.55884 .33044 L
s
.306 .454 .882 r
.52973 .59555 m .53328 .59904 L .5167 .61604 L p F P
0 0 0 r
s
.83 .24 .1 r
.5319 .60714 m
.54826 .62306 L
s
.306 .454 .882 r
.5167 .61604 m .5149 .61433 L .52973 .59555 L p F P
0 0 0 r
s
.24 .35 .67 r
.2075 .32191 m
.22418 .29455 L
s
.44 .115 .052 r
.47903 .37387 m .45913 .38154 L .45817 .39975 L p F P
0 0 0 r
s
.44 .115 .052 r
.43805 .4074 m .45817 .39975 L .45913 .38154 L p F P
0 0 0 r
s
.319 .46 .871 r
.60037 .55795 m .59276 .54971 L .60591 .52759 L p F P
0 0 0 r
s
.319 .464 .884 r
.59276 .54971 m .60037 .55795 L .58355 .57729 L p F P
0 0 0 r
s
.24 .35 .67 r
.5703 .58813 m
.58492 .5732 L
s
.53639 .30235 m
.55387 .32421 L
s
.55783 .32917 m
.55884 .33044 L
s
.954 .28 .12 r
.48706 .59516 m .48075 .59718 L .49035 .61512 L p F P
0 0 0 r
s
.954 .28 .12 r
.49035 .61512 m .49352 .61413 L .48706 .59516 L p F P
0 0 0 r
s
.794 .227 .099 r
.37029 .55736 m .38415 .55261 L .36779 .53097 L p F P
0 0 0 r
s
.838 .241 .105 r
.38415 .55261 m .37029 .55736 L .39204 .57681 L p F P
0 0 0 r
s
.24 .35 .67 r
.35729 .56583 m
.38336 .58859 L
s
.917 .268 .115 r
.43474 .58832 m .42568 .59129 L .44957 .60715 L p F P
0 0 0 r
s
.917 .268 .115 r
.44957 .60715 m .45576 .60517 L .43474 .58832 L p F P
0 0 0 r
s
.24 .35 .67 r
.2518 .47645 m
.2464 .45411 L
s
.21748 .42855 m
.2464 .45411 L
s
.318 .465 .89 r
.57712 .57055 m .58355 .57729 L .5645 .5946 L p F P
0 0 0 r
s
.318 .465 .89 r
.5645 .5946 m .55946 .58949 L .57712 .57055 L p F P
0 0 0 r
s
.308 .438 .814 r
.61616 .50488 m .60669 .49397 L .61328 .47047 L p F P
0 0 0 r
s
.315 .452 .849 r
.60669 .49397 m .61616 .50488 L .60591 .52759 L p F P
0 0 0 r
s
.306 .454 .882 r
.52615 .59205 m .52973 .59555 L .5149 .61433 L p F P
0 0 0 r
s
.306 .454 .882 r
.5149 .61433 m .51308 .6126 L .52615 .59205 L p F P
0 0 0 r
s
.954 .28 .12 r
.49338 .59313 m .48706 .59516 L .49352 .61413 L p F P
0 0 0 r
s
.954 .28 .12 r
.49352 .61413 m .49669 .61313 L .49338 .59313 L p F P
0 0 0 r
s
.879 .254 .11 r
.40364 .57292 m .39204 .57681 L .41666 .59423 L p F P
0 0 0 r
s
.879 .254 .11 r
.41666 .59423 m .42568 .59129 L .40364 .57292 L p F P
0 0 0 r
s
.83 .24 .1 r
.41794 .58484 m
.41897 .5845 L
s
.24 .35 .67 r
.40901 .59153 m
.42618 .60678 L
s
.83 .24 .1 r
.41897 .5845 m
.42047 .58695 L
s
.319 .464 .884 r
.58355 .57729 m .57712 .57055 L .59276 .54971 L p F P
0 0 0 r
s
.626 .173 .077 r
.41846 .43592 m .39887 .44324 L .40193 .46591 L p F P
0 0 0 r
s
.626 .173 .077 r
.38314 .4728 m .40193 .46591 L .39887 .44324 L p F P
0 0 0 r
s
.83 .24 .1 r
.55562 .32454 m
.58767 .312 L
s
.838 .241 .105 r
.39204 .57681 m .40364 .57292 L .38415 .55261 L p F P
0 0 0 r
s
.313 .462 .89 r
.55437 .58433 m .55946 .58949 L .54032 .60595 L p F P
0 0 0 r
s
.313 .462 .89 r
.54032 .60595 m .53681 .60251 L .55437 .58433 L p F P
0 0 0 r
s
.954 .28 .12 r
.49974 .5911 m .49338 .59313 L .49669 .61313 L p F P
0 0 0 r
s
.954 .28 .12 r
.49669 .61313 m .49987 .61214 L .49974 .5911 L p F P
0 0 0 r
s
.24 .35 .67 r
.4914 .60119 m
.49862 .608 L
s
.746 .211 .092 r
.36779 .53097 m .38367 .5254 L .37238 .50243 L p F P
0 0 0 r
s
.794 .227 .099 r
.38367 .5254 m .36779 .53097 L .38415 .55261 L p F P
0 0 0 r
s
.917 .268 .115 r
.44386 .58534 m .43474 .58832 L .45576 .60517 L p F P
0 0 0 r
s
.917 .268 .115 r
.45576 .60517 m .46198 .60318 L .44386 .58534 L p F P
0 0 0 r
s
.306 .454 .882 r
.52255 .58851 m .52615 .59205 L .51308 .6126 L p F P
0 0 0 r
s
.306 .454 .882 r
.51308 .6126 m .51126 .61087 L .52255 .58851 L p F P
0 0 0 r
s
.83 .24 .1 r
.5156 .61223 m
.5194 .61104 L
s
.24 .35 .67 r
.37837 .18565 m
.40408 .21618 L
s
.40408 .21618 m
.43008 .2142 L
s
.691 .194 .085 r
.40193 .46591 m .38314 .4728 L .38992 .49613 L p F P
0 0 0 r
s
.691 .194 .085 r
.37238 .50243 m .38992 .49613 L .38314 .4728 L p F P
0 0 0 r
s
.954 .28 .12 r
.50611 .58906 m .49974 .5911 L .49987 .61214 L p F P
0 0 0 r
s
.954 .28 .12 r
.49987 .61214 m .50305 .61114 L .50611 .58906 L p F P
0 0 0 r
s
.24 .35 .67 r
.49862 .608 m
.50081 .61007 L
s
.746 .211 .092 r
.38992 .49613 m .37238 .50243 L .38367 .5254 L p F P
0 0 0 r
s
.83 .24 .1 r
.73087 .58176 m
.74208 .5853 L
s
.7857 .5722 m
.74208 .5853 L
s
.24 .35 .67 r
.32244 .20636 m
.35064 .19352 L
s
.31 .076 .035 r
.53814 .33684 m .51856 .34446 L .51953 .35825 L p F P
0 0 0 r
s
.31 .076 .035 r
.49916 .36611 m .51953 .35825 L .51856 .34446 L p F P
0 0 0 r
s
.83 .24 .1 r
.57319 .59424 m
.58914 .61054 L
s
.63098 .59772 m
.58914 .61054 L
s
.879 .254 .11 r
.41533 .56901 m .40364 .57292 L .42568 .59129 L p F P
0 0 0 r
s
.24 .35 .67 r
.38336 .58859 m
.40901 .59153 L
s
.879 .254 .11 r
.42568 .59129 m .43474 .58832 L .41533 .56901 L p F P
0 0 0 r
s
.954 .28 .12 r
.51251 .58701 m .50611 .58906 L .50305 .61114 L p F P
0 0 0 r
s
.954 .28 .12 r
.50305 .61114 m .50624 .61014 L .51251 .58701 L p F P
0 0 0 r
s
.306 .454 .882 r
.51893 .58496 m .52255 .58851 L .51126 .61087 L p F P
0 0 0 r
s
.83 .24 .1 r
.5194 .61104 m
.5319 .60714 L
s
.306 .454 .882 r
.51126 .61087 m .50944 .60913 L .51893 .58496 L p F P
0 0 0 r
s
.917 .268 .115 r
.45302 .58234 m .44386 .58534 L .46198 .60318 L p F P
0 0 0 r
s
.917 .268 .115 r
.46198 .60318 m .46821 .60119 L .45302 .58234 L p F P
0 0 0 r
s
.24 .35 .67 r
.46198 .61054 m
.4914 .60119 L
s
.545 .147 .066 r
.45817 .39975 m .43805 .4074 L .43827 .42851 L p F P
0 0 0 r
s
.83 .24 .1 r
.43689 .40909 m
.43806 .40864 L
s
.45699 .40145 m
.45862 .40083 L
s
.545 .147 .066 r
.41846 .43592 m .43827 .42851 L .43805 .4074 L p F P
0 0 0 r
s
.794 .227 .099 r
.38415 .55261 m .39813 .54782 L .38367 .5254 L p F P
0 0 0 r
s
.838 .241 .105 r
.39813 .54782 m .38415 .55261 L .40364 .57292 L p F P
0 0 0 r
s
.294 .415 .762 r
.61328 .47047 m .6031 .45843 L .60633 .43539 L p F P
0 0 0 r
s
.308 .438 .814 r
.6031 .45843 m .61328 .47047 L .60669 .49397 L p F P
0 0 0 r
s
.954 .28 .12 r
.51893 .58496 m .51251 .58701 L .50624 .61014 L p F P
0 0 0 r
s
.954 .28 .12 r
.50624 .61014 m .50944 .60913 L .51893 .58496 L p F P
0 0 0 r
s
.24 .35 .67 r
.49773 .25776 m
.52107 .28689 L
s
.52107 .28689 m
.53639 .30235 L
s
.313 .462 .89 r
.54923 .57912 m .55437 .58433 L .53681 .60251 L p F P
0 0 0 r
s
.313 .462 .89 r
.53681 .60251 m .53328 .59904 L .54923 .57912 L p F P
0 0 0 r
s
.315 .452 .849 r
.60591 .52759 m .59719 .51784 L .60669 .49397 L p F P
0 0 0 r
s
.319 .46 .871 r
.59719 .51784 m .60591 .52759 L .59276 .54971 L p F P
0 0 0 r
s
.838 .241 .105 r
.40364 .57292 m .41533 .56901 L .39813 .54782 L p F P
0 0 0 r
s
.83 .24 .1 r
.40376 .55476 m
.40477 .55441 L
s
.40477 .55441 m
.40657 .55822 L
s
.44 .115 .052 r
.49916 .36611 m .47903 .37387 L .47853 .392 L p F P
0 0 0 r
s
.44 .115 .052 r
.45817 .39975 m .47853 .392 L .47903 .37387 L p F P
0 0 0 r
s
.83 .24 .1 r
.45862 .40083 m
.45875 .39952 L
s
.185 .244 .417 r
.55794 .32912 m .56857 .34243 L .57217 .35613 L p F P
0 0 0 r
s
.185 .244 .417 r
.58309 .36972 m .57217 .35613 L .56857 .34243 L p F P
0 0 0 r
s
.24 .35 .67 r
.56894 .35089 m
.57028 .35256 L
s
.56203 .3369 m
.56894 .35089 L
s
.318 .465 .89 r
.57062 .56373 m .57712 .57055 L .55946 .58949 L p F P
0 0 0 r
s
.318 .465 .89 r
.55946 .58949 m .55437 .58433 L .57062 .56373 L p F P
0 0 0 r
s
.24 .35 .67 r
.35729 .56583 m
.33545 .55711 L
s
.30823 .53356 m
.33545 .55711 L
s
.917 .268 .115 r
.46224 .57933 m .45302 .58234 L .46821 .60119 L p F P
0 0 0 r
s
.917 .268 .115 r
.46821 .60119 m .47447 .59919 L .46224 .57933 L p F P
0 0 0 r
s
.83 .24 .1 r
.47396 .59836 m
.47475 .59811 L
s
.24 .35 .67 r
.19544 .3496 m
.2075 .32191 L
s
.879 .254 .11 r
.4271 .56508 m .41533 .56901 L .43474 .58832 L p F P
0 0 0 r
s
.879 .254 .11 r
.43474 .58832 m .44386 .58534 L .4271 .56508 L p F P
0 0 0 r
s
.24 .35 .67 r
.43744 .58814 m
.46041 .60911 L
s
.46041 .60911 m
.46198 .61054 L
s
.83 .24 .1 r
.67854 .26777 m
.63602 .28451 L
s
.63602 .28451 m
.6299 .29548 L
s
.83037 .55878 m
.8377 .55592 L
s
.746 .211 .092 r
.38367 .5254 m .39971 .51977 L .38992 .49613 L p F P
0 0 0 r
s
.794 .227 .099 r
.39971 .51977 m .38367 .5254 L .39813 .54782 L p F P
0 0 0 r
s
.83 .24 .1 r
.5319 .60714 m
.53456 .60631 L
s
.319 .46 .871 r
.59276 .54971 m .58504 .54134 L .59719 .51784 L p F P
0 0 0 r
s
.319 .464 .884 r
.58504 .54134 m .59276 .54971 L .57712 .57055 L p F P
0 0 0 r
s
.626 .173 .077 r
.43827 .42851 m .41846 .43592 L .42094 .45894 L p F P
0 0 0 r
s
.626 .173 .077 r
.40193 .46591 m .42094 .45894 L .41846 .43592 L p F P
0 0 0 r
s
.319 .464 .884 r
.57712 .57055 m .57062 .56373 L .58504 .54134 L p F P
0 0 0 r
s
.24 .35 .67 r
.21827 .40341 m
.18856 .37662 L
s
.21748 .42855 m
.21827 .40341 L
s
.272 .378 .683 r
.60633 .43539 m .59565 .42249 L .596 .40125 L p F P
0 0 0 r
s
.24 .35 .67 r
.59496 .40232 m
.59596 .40355 L
s
.294 .415 .762 r
.59565 .42249 m .60633 .43539 L .6031 .45843 L p F P
0 0 0 r
s
.917 .268 .115 r
.47151 .5763 m .46224 .57933 L .47447 .59919 L p F P
0 0 0 r
s
.83 .24 .1 r
.47422 .59722 m
.47475 .59811 L
s
.917 .268 .115 r
.47447 .59919 m .48075 .59718 L .47151 .5763 L p F P
0 0 0 r
s
.313 .462 .89 r
.54404 .57386 m .54923 .57912 L .53328 .59904 L p F P
0 0 0 r
s
.313 .462 .89 r
.53328 .59904 m .52973 .59555 L .54404 .57386 L p F P
0 0 0 r
s
.83 .24 .1 r
.52323 .59559 m
.5319 .60714 L
s
.52148 .59325 m
.52323 .59559 L
s
.39872 .53742 m
.40477 .55441 L
s
.691 .194 .085 r
.38992 .49613 m .40765 .48976 L .40193 .46591 L p F P
0 0 0 r
s
.746 .211 .092 r
.40765 .48976 m .38992 .49613 L .39971 .51977 L p F P
0 0 0 r
s
.691 .194 .085 r
.42094 .45894 m .40193 .46591 L .40765 .48976 L p F P
0 0 0 r
s
.235 .32 .564 r
.57217 .35613 m .58309 .36972 L .58506 .38782 L p F P
0 0 0 r
s
.235 .32 .564 r
.596 .40125 m .58506 .38782 L .58309 .36972 L p F P
0 0 0 r
s
.838 .241 .105 r
.41223 .54299 m .39813 .54782 L .41533 .56901 L p F P
0 0 0 r
s
.838 .241 .105 r
.41533 .56901 m .4271 .56508 L .41223 .54299 L p F P
0 0 0 r
s
.794 .227 .099 r
.39813 .54782 m .41223 .54299 L .39971 .51977 L p F P
0 0 0 r
s
.272 .378 .683 r
.58506 .38782 m .596 .40125 L .59565 .42249 L p F P
0 0 0 r
s
.879 .254 .11 r
.43895 .56111 m .4271 .56508 L .44386 .58534 L p F P
0 0 0 r
s
.879 .254 .11 r
.44386 .58534 m .45302 .58234 L .43895 .56111 L p F P
0 0 0 r
s
.31 .076 .035 r
.55794 .32912 m .53814 .33684 L .54015 .35031 L p F P
0 0 0 r
s
.31 .076 .035 r
.51953 .35825 m .54015 .35031 L .53814 .33684 L p F P
0 0 0 r
s
.917 .268 .115 r
.48082 .57326 m .47151 .5763 L .48075 .59718 L p F P
0 0 0 r
s
.917 .268 .115 r
.48075 .59718 m .48706 .59516 L .48082 .57326 L p F P
0 0 0 r
s
.24 .35 .67 r
.45354 .2179 m
.47791 .248 L
s
.47791 .248 m
.49773 .25776 L
s
.308 .438 .814 r
.60669 .49397 m .59705 .48287 L .6031 .45843 L p F P
0 0 0 r
s
.315 .452 .849 r
.59705 .48287 m .60669 .49397 L .59719 .51784 L p F P
0 0 0 r
s
.83 .24 .1 r
.67383 .58459 m
.68758 .59485 L
s
.73087 .58176 m
.68758 .59485 L
s
.318 .465 .89 r
.56403 .55683 m .57062 .56373 L .55437 .58433 L p F P
0 0 0 r
s
.318 .465 .89 r
.55437 .58433 m .54923 .57912 L .56403 .55683 L p F P
0 0 0 r
s
.545 .147 .066 r
.47853 .392 m .45817 .39975 L .45832 .42102 L p F P
0 0 0 r
s
.545 .147 .066 r
.43827 .42851 m .45832 .42102 L .45817 .39975 L p F P
0 0 0 r
s
.83 .24 .1 r
.72919 .24707 m
.72208 .25064 L
s
.24 .35 .67 r
.30823 .53356 m
.29131 .51954 L
s
.26303 .49508 m
.29131 .51954 L
s
.44 .115 .052 r
.51953 .35825 m .49916 .36611 L .49914 .38417 L p F P
0 0 0 r
s
.44 .115 .052 r
.47853 .392 m .49914 .38417 L .49916 .36611 L p F P
0 0 0 r
s
.313 .462 .89 r
.5388 .56855 m .54404 .57386 L .52973 .59555 L p F P
0 0 0 r
s
.313 .462 .89 r
.52973 .59555 m .52615 .59205 L .5388 .56855 L p F P
0 0 0 r
s
.83 .24 .1 r
.53456 .60631 m
.57319 .59424 L
s
.917 .268 .115 r
.49019 .57019 m .48082 .57326 L .48706 .59516 L p F P
0 0 0 r
s
.917 .268 .115 r
.48706 .59516 m .49338 .59313 L .49019 .57019 L p F P
0 0 0 r
s
.746 .211 .092 r
.39971 .51977 m .4159 .51409 L .40765 .48976 L p F P
0 0 0 r
s
.794 .227 .099 r
.4159 .51409 m .39971 .51977 L .41223 .54299 L p F P
0 0 0 r
s
.24 .35 .67 r
.35064 .19352 m
.37837 .18565 L
s
.879 .254 .11 r
.45089 .55712 m .43895 .56111 L .45302 .58234 L p F P
0 0 0 r
s
.879 .254 .11 r
.45302 .58234 m .46224 .57933 L .45089 .55712 L p F P
0 0 0 r
s
.838 .241 .105 r
.42645 .53812 m .41223 .54299 L .4271 .56508 L p F P
0 0 0 r
s
.838 .241 .105 r
.4271 .56508 m .43895 .56111 L .42645 .53812 L p F P
0 0 0 r
s
.24 .35 .67 r
.4914 .60119 m
.50676 .59315 L
s
.50676 .59315 m
.50986 .59152 L
s
.794 .227 .099 r
.41223 .54299 m .42645 .53812 L .4159 .51409 L p F P
0 0 0 r
s
.24 .35 .67 r
.43744 .58814 m
.40901 .59153 L
s
.38313 .56852 m
.40901 .59153 L
s
.626 .173 .077 r
.45832 .42102 m .43827 .42851 L .44016 .45189 L p F P
0 0 0 r
s
.626 .173 .077 r
.42094 .45894 m .44016 .45189 L .43827 .42851 L p F P
0 0 0 r
s
.315 .452 .849 r
.59719 .51784 m .58833 .50793 L .59705 .48287 L p F P
0 0 0 r
s
.319 .46 .871 r
.58833 .50793 m .59719 .51784 L .58504 .54134 L p F P
0 0 0 r
s
.319 .464 .884 r
.57721 .53285 m .58504 .54134 L .57062 .56373 L p F P
0 0 0 r
s
.319 .464 .884 r
.57062 .56373 m .56403 .55683 L .57721 .53285 L p F P
0 0 0 r
s
.83 .24 .1 r
.6299 .29548 m
.58767 .312 L
s
.58767 .312 m
.58378 .32975 L
s
.917 .268 .115 r
.49961 .56712 m .49019 .57019 L .49338 .59313 L p F P
0 0 0 r
s
.917 .268 .115 r
.49338 .59313 m .49974 .5911 L .49961 .56712 L p F P
0 0 0 r
s
.691 .194 .085 r
.40765 .48976 m .42558 .48333 L .42094 .45894 L p F P
0 0 0 r
s
.746 .211 .092 r
.42558 .48333 m .40765 .48976 L .4159 .51409 L p F P
0 0 0 r
s
.691 .194 .085 r
.44016 .45189 m .42094 .45894 L .42558 .48333 L p F P
0 0 0 r
s
.319 .46 .871 r
.58504 .54134 m .57721 .53285 L .58833 .50793 L p F P
0 0 0 r
s
.313 .462 .89 r
.53352 .56319 m .5388 .56855 L .52615 .59205 L p F P
0 0 0 r
s
.313 .462 .89 r
.52615 .59205 m .52255 .58851 L .53352 .56319 L p F P
0 0 0 r
s
.294 .415 .762 r
.6031 .45843 m .59271 .44616 L .59565 .42249 L p F P
0 0 0 r
s
.308 .438 .814 r
.59271 .44616 m .6031 .45843 L .59705 .48287 L p F P
0 0 0 r
s
.879 .254 .11 r
.46291 .55309 m .45089 .55712 L .46224 .57933 L p F P
0 0 0 r
s
.83 .24 .1 r
.46229 .57724 m
.46333 .57898 L
s
.879 .254 .11 r
.46224 .57933 m .47151 .5763 L .46291 .55309 L p F P
0 0 0 r
s
.24 .35 .67 r
.46726 .5784 m
.48986 .59973 L
s
.48986 .59973 m
.4914 .60119 L
s
.83 .24 .1 r
.7752 .56836 m
.7857 .5722 L
s
.83037 .55878 m
.7857 .5722 L
s
.318 .465 .89 r
.55737 .54984 m .56403 .55683 L .54923 .57912 L p F P
0 0 0 r
s
.318 .465 .89 r
.54923 .57912 m .54404 .57386 L .55737 .54984 L p F P
0 0 0 r
s
.31 .076 .035 r
.54015 .35031 m .56101 .34227 L .55794 .32912 L p F P
0 0 0 r
s
.24 .35 .67 r
.54636 .3228 m
.55747 .33662 L
s
.185 .244 .417 r
.57217 .35613 m .56101 .34227 L .55794 .32912 L p F P
0 0 0 r
s
.24 .35 .67 r
.55747 .33662 m
.5589 .3384 L
s
.917 .268 .115 r
.50908 .56402 m .49961 .56712 L .49974 .5911 L p F P
0 0 0 r
s
.917 .268 .115 r
.49974 .5911 m .50611 .58906 L .50908 .56402 L p F P
0 0 0 r
s
.83 .24 .1 r
.61549 .58103 m
.63098 .59772 L
s
.67383 .58459 m
.63098 .59772 L
s
.838 .241 .105 r
.44078 .53321 m .42645 .53812 L .43895 .56111 L p F P
0 0 0 r
s
.838 .241 .105 r
.43895 .56111 m .45089 .55712 L .44078 .53321 L p F P
0 0 0 r
s
.24 .35 .67 r
.40456 .18321 m
.43008 .2142 L
s
.43008 .2142 m
.45354 .2179 L
s
.26303 .49508 m
.2518 .47645 L
s
.22255 .45096 m
.2518 .47645 L
s
.18856 .37662 m
.19544 .3496 L
s
.545 .147 .066 r
.49914 .38417 m .47853 .392 L .47861 .41343 L p F P
0 0 0 r
s
.83 .24 .1 r
.47733 .39373 m
.47854 .39327 L
s
.49792 .38591 m
.49915 .38544 L
s
.545 .147 .066 r
.45832 .42102 m .47861 .41343 L .47853 .392 L p F P
0 0 0 r
s
.746 .211 .092 r
.4159 .51409 m .43226 .50835 L .42558 .48333 L p F P
0 0 0 r
s
.794 .227 .099 r
.43226 .50835 m .4159 .51409 L .42645 .53812 L p F P
0 0 0 r
s
.44 .115 .052 r
.54015 .35031 m .51953 .35825 L .52 .37624 L p F P
0 0 0 r
s
.44 .115 .052 r
.49914 .38417 m .52 .37624 L .51953 .35825 L p F P
0 0 0 r
s
.83 .24 .1 r
.49915 .38544 m
.49925 .38413 L
s
.917 .268 .115 r
.5186 .56091 m .50908 .56402 L .50611 .58906 L p F P
0 0 0 r
s
.917 .268 .115 r
.50611 .58906 m .51251 .58701 L .5186 .56091 L p F P
0 0 0 r
s
.83 .24 .1 r
.51537 .5851 m
.51597 .58591 L
s
.51276 .58594 m
.51537 .5851 L
s
.794 .227 .099 r
.42645 .53812 m .44078 .53321 L .43226 .50835 L p F P
0 0 0 r
s
.879 .254 .11 r
.47502 .54904 m .46291 .55309 L .47151 .5763 L p F P
0 0 0 r
s
.879 .254 .11 r
.47151 .5763 m .48082 .57326 L .47502 .54904 L p F P
0 0 0 r
s
.313 .462 .89 r
.52818 .55777 m .53352 .56319 L .52255 .58851 L p F P
0 0 0 r
s
.313 .462 .89 r
.52255 .58851 m .51893 .58496 L .52818 .55777 L p F P
0 0 0 r
s
.272 .378 .683 r
.59565 .42249 m .58475 .40933 L .58506 .38782 L p F P
0 0 0 r
s
.294 .415 .762 r
.58475 .40933 m .59565 .42249 L .59271 .44616 L p F P
0 0 0 r
s
.83 .24 .1 r
.72208 .25064 m
.67854 .26777 L
s
.67854 .26777 m
.67316 .27856 L
s
.5606 .33871 m
.58378 .32975 L
s
.235 .32 .564 r
.56101 .34227 m .57217 .35613 L .57389 .3741 L p F P
0 0 0 r
s
.235 .32 .564 r
.58506 .38782 m .57389 .3741 L .57217 .35613 L p F P
0 0 0 r
s
.24 .35 .67 r
.5721 .36966 m
.57307 .37549 L
s
.83 .24 .1 r
.61549 .58103 m
.57319 .59424 L
s
.691 .194 .085 r
.42558 .48333 m .44369 .47683 L .44016 .45189 L p F P
0 0 0 r
s
.746 .211 .092 r
.44369 .47683 m .42558 .48333 L .43226 .50835 L p F P
0 0 0 r
s
.83 .24 .1 r
.43271 .50711 m
.433 .50826 L
s
.43231 .5085 m
.433 .50826 L
s
.917 .268 .115 r
.52818 .55777 m .5186 .56091 L .51251 .58701 L p F P
0 0 0 r
s
.917 .268 .115 r
.51251 .58701 m .51893 .58496 L .52818 .55777 L p F P
0 0 0 r
s
.24 .35 .67 r
.5152 .58057 m
.51658 .58192 L
s
.83 .24 .1 r
.52495 .58204 m
.5283 .58096 L
s
.52252 .58281 m
.52495 .58204 L
s
.626 .173 .077 r
.47861 .41343 m .45832 .42102 L .4596 .44476 L p F P
0 0 0 r
s
.626 .173 .077 r
.44016 .45189 m .4596 .44476 L .45832 .42102 L p F P
0 0 0 r
s
.838 .241 .105 r
.45525 .52825 m .44078 .53321 L .45089 .55712 L p F P
0 0 0 r
s
.83 .24 .1 r
.4512 .55505 m
.45199 .55675 L
s
.838 .241 .105 r
.45089 .55712 m .46291 .55309 L .45525 .52825 L p F P
0 0 0 r
s
.308 .438 .814 r
.59705 .48287 m .58722 .47155 L .59271 .44616 L p F P
0 0 0 r
s
.315 .452 .849 r
.58722 .47155 m .59705 .48287 L .58833 .50793 L p F P
0 0 0 r
s
.272 .378 .683 r
.57389 .3741 m .58506 .38782 L .58475 .40933 L p F P
0 0 0 r
s
.319 .464 .884 r
.56926 .52424 m .57721 .53285 L .56403 .55683 L p F P
0 0 0 r
s
.319 .464 .884 r
.56403 .55683 m .55737 .54984 L .56926 .52424 L p F P
0 0 0 r
s
.318 .465 .89 r
.55062 .54277 m .55737 .54984 L .54404 .57386 L p F P
0 0 0 r
s
.83 .24 .1 r
.55697 .57178 m
.57319 .59424 L
s
.318 .465 .89 r
.54404 .57386 m .5388 .56855 L .55062 .54277 L p F P
0 0 0 r
s
.83 .24 .1 r
.5283 .58096 m
.55697 .57178 L
s
.691 .194 .085 r
.4596 .44476 m .44016 .45189 L .44369 .47683 L p F P
0 0 0 r
s
.83 .24 .1 r
.433 .50826 m
.44176 .53287 L
s
.879 .254 .11 r
.48721 .54496 m .47502 .54904 L .48082 .57326 L p F P
0 0 0 r
s
.879 .254 .11 r
.48082 .57326 m .49019 .57019 L .48721 .54496 L p F P
0 0 0 r
s
.24 .35 .67 r
.513 .27307 m
.53639 .30235 L
s
.53639 .30235 m
.54636 .3228 L
s
.38313 .56852 m
.35729 .56583 L
s
.33011 .54211 m
.35729 .56583 L
s
.22255 .45096 m
.21748 .42855 L
s
.18734 .40191 m
.21748 .42855 L
s
.746 .211 .092 r
.43226 .50835 m .44877 .50255 L .44369 .47683 L p F P
0 0 0 r
s
.794 .227 .099 r
.44877 .50255 m .43226 .50835 L .44078 .53321 L p F P
0 0 0 r
s
.794 .227 .099 r
.44078 .53321 m .45525 .52825 L .44877 .50255 L p F P
0 0 0 r
s
.315 .452 .849 r
.58833 .50793 m .57932 .49786 L .58722 .47155 L p F P
0 0 0 r
s
.319 .46 .871 r
.57932 .49786 m .58833 .50793 L .57721 .53285 L p F P
0 0 0 r
s
.319 .46 .871 r
.57721 .53285 m .56926 .52424 L .57932 .49786 L p F P
0 0 0 r
s
.83 .24 .1 r
.71773 .57115 m
.73087 .58176 L
s
.7752 .56836 m
.73087 .58176 L
s
.545 .147 .066 r
.52 .37624 m .49914 .38417 L .49914 .40575 L p F P
0 0 0 r
s
.545 .147 .066 r
.47861 .41343 m .49914 .40575 L .49914 .38417 L p F P
0 0 0 r
s
.838 .241 .105 r
.46983 .52325 m .45525 .52825 L .46291 .55309 L p F P
0 0 0 r
s
.838 .241 .105 r
.46291 .55309 m .47502 .54904 L .46983 .52325 L p F P
0 0 0 r
s
.879 .254 .11 r
.49949 .54086 m .48721 .54496 L .49019 .57019 L p F P
0 0 0 r
s
.24 .35 .67 r
.5133 .57871 m
.5152 .58057 L
s
.879 .254 .11 r
.49019 .57019 m .49961 .56712 L .49949 .54086 L p F P
0 0 0 r
s
.44 .115 .052 r
.56101 .34227 m .54015 .35031 L .54111 .36821 L p F P
0 0 0 r
s
.44 .115 .052 r
.52 .37624 m .54111 .36821 L .54015 .35031 L p F P
0 0 0 r
s
.24 .35 .67 r
.37837 .18565 m
.40456 .18321 L
s
.691 .194 .085 r
.44369 .47683 m .462 .47025 L .4596 .44476 L p F P
0 0 0 r
s
.746 .211 .092 r
.462 .47025 m .44369 .47683 L .44877 .50255 L p F P
0 0 0 r
s
.318 .465 .89 r
.54378 .5356 m .55062 .54277 L .5388 .56855 L p F P
0 0 0 r
s
.318 .465 .89 r
.5388 .56855 m .53352 .56319 L .54378 .5356 L p F P
0 0 0 r
s
.24 .35 .67 r
.46726 .5784 m
.43744 .58814 L
s
.41185 .5648 m
.43744 .58814 L
s
.294 .415 .762 r
.59271 .44616 m .58212 .43364 L .58475 .40933 L p F P
0 0 0 r
s
.308 .438 .814 r
.58212 .43364 m .59271 .44616 L .58722 .47155 L p F P
0 0 0 r
s
.626 .173 .077 r
.49914 .40575 m .47861 .41343 L .47927 .43754 L p F P
0 0 0 r
s
.626 .173 .077 r
.4596 .44476 m .47927 .43754 L .47861 .41343 L p F P
0 0 0 r
s
.83 .24 .1 r
.67316 .27856 m
.6299 .29548 L
s
.6299 .29548 m
.6267 .31316 L
s
.24 .35 .67 r
.47339 .22739 m
.49773 .25776 L
s
.49773 .25776 m
.513 .27307 L
s
.879 .254 .11 r
.51186 .53672 m .49949 .54086 L .49961 .56712 L p F P
0 0 0 r
s
.879 .254 .11 r
.49961 .56712 m .50908 .56402 L .51186 .53672 L p F P
0 0 0 r
s
.691 .194 .085 r
.47927 .43754 m .4596 .44476 L .462 .47025 L p F P
0 0 0 r
s
.319 .464 .884 r
.56119 .51549 m .56926 .52424 L .55737 .54984 L p F P
0 0 0 r
s
.319 .464 .884 r
.55737 .54984 m .55062 .54277 L .56119 .51549 L p F P
0 0 0 r
s
.794 .227 .099 r
.46544 .4967 m .44877 .50255 L .45525 .52825 L p F P
0 0 0 r
s
.794 .227 .099 r
.45525 .52825 m .46983 .52325 L .46544 .4967 L p F P
0 0 0 r
s
.746 .211 .092 r
.44877 .50255 m .46544 .4967 L .462 .47025 L p F P
0 0 0 r
s
.838 .241 .105 r
.48454 .51821 m .46983 .52325 L .47502 .54904 L p F P
0 0 0 r
s
.838 .241 .105 r
.47502 .54904 m .48721 .54496 L .48454 .51821 L p F P
0 0 0 r
s
.24 .35 .67 r
.33011 .54211 m
.30823 .53356 L
s
.27985 .50901 m
.30823 .53356 L
s
.83 .24 .1 r
.82062 .55462 m
.83037 .55878 L
s
.65881 .5675 m
.67383 .58459 L
s
.71773 .57115 m
.67383 .58459 L
s
.24 .35 .67 r
.18734 .40191 m
.18856 .37662 L
s
.272 .378 .683 r
.58475 .40933 m .57362 .39588 L .57389 .3741 L p F P
0 0 0 r
s
.24 .35 .67 r
.57307 .37549 m
.57386 .37645 L
s
.294 .415 .762 r
.57362 .39588 m .58475 .40933 L .58212 .43364 L p F P
0 0 0 r
s
.545 .147 .066 r
.54111 .36821 m .52 .37624 L .51993 .39798 L p F P
0 0 0 r
s
.83 .24 .1 r
.51876 .37799 m
.51999 .37752 L
s
.53985 .36998 m
.54065 .36967 L
s
.54065 .36967 m
.5407 .36879 L
s
.545 .147 .066 r
.49914 .40575 m .51993 .39798 L .52 .37624 L p F P
0 0 0 r
s
.879 .254 .11 r
.52432 .53255 m .51186 .53672 L .50908 .56402 L p F P
0 0 0 r
s
.879 .254 .11 r
.50908 .56402 m .5186 .56091 L .52432 .53255 L p F P
0 0 0 r
s
.24 .35 .67 r
.49695 .56264 m
.5133 .57871 L
s
.308 .438 .814 r
.58722 .47155 m .57721 .46002 L .58212 .43364 L p F P
0 0 0 r
s
.315 .452 .849 r
.57721 .46002 m .58722 .47155 L .57932 .49786 L p F P
0 0 0 r
s
.235 .32 .564 r
.57389 .3741 m .56248 .36009 L .56101 .34227 L p F P
0 0 0 r
s
.44 .115 .052 r
.54111 .36821 m .56248 .36009 L .56101 .34227 L p F P
0 0 0 r
s
.24 .35 .67 r
.55026 .34751 m
.55893 .35815 L
s
.318 .465 .89 r
.53686 .52835 m .54378 .5356 L .53352 .56319 L p F P
0 0 0 r
s
.318 .465 .89 r
.53352 .56319 m .52818 .55777 L .53686 .52835 L p F P
0 0 0 r
s
.319 .46 .871 r
.57016 .4876 m .57932 .49786 L .56926 .52424 L p F P
0 0 0 r
s
.319 .46 .871 r
.56926 .52424 m .56119 .51549 L .57016 .4876 L p F P
0 0 0 r
s
.691 .194 .085 r
.462 .47025 m .48051 .46361 L .47927 .43754 L p F P
0 0 0 r
s
.746 .211 .092 r
.48051 .46361 m .462 .47025 L .46544 .4967 L p F P
0 0 0 r
s
.838 .241 .105 r
.49938 .51313 m .48454 .51821 L .48721 .54496 L p F P
0 0 0 r
s
.838 .241 .105 r
.48721 .54496 m .49949 .54086 L .49938 .51313 L p F P
0 0 0 r
s
.272 .378 .683 r
.56248 .36009 m .57389 .3741 L .57362 .39588 L p F P
0 0 0 r
s
.794 .227 .099 r
.48228 .49079 m .46544 .4967 L .46983 .52325 L p F P
0 0 0 r
s
.794 .227 .099 r
.46983 .52325 m .48454 .51821 L .48228 .49079 L p F P
0 0 0 r
s
.315 .452 .849 r
.57932 .49786 m .57016 .4876 L .57721 .46002 L p F P
0 0 0 r
s
.83 .24 .1 r
.72208 .25064 m
.71749 .26123 L
s
.24 .35 .67 r
.42814 .18652 m
.45354 .2179 L
s
.45354 .2179 m
.47339 .22739 L
s
.83 .24 .1 r
.6267 .31316 m
.58378 .32975 L
s
.58378 .32975 m
.58317 .35352 L
s
.59959 .55814 m
.61549 .58103 L
s
.65881 .5675 m
.61549 .58103 L
s
.54134 .54416 m
.55697 .57178 L
s
.55697 .57178 m
.59959 .55814 L
s
.626 .173 .077 r
.51993 .39798 m .49914 .40575 L .49917 .43024 L p F P
0 0 0 r
s
.626 .173 .077 r
.47927 .43754 m .49917 .43024 L .49914 .40575 L p F P
0 0 0 r
s
.879 .254 .11 r
.53686 .52835 m .52432 .53255 L .5186 .56091 L p F P
0 0 0 r
s
.879 .254 .11 r
.5186 .56091 m .52818 .55777 L .53686 .52835 L p F P
0 0 0 r
s
.24 .35 .67 r
.52492 .54161 m
.52747 .54422 L
s
.52747 .54422 m
.52965 .54646 L
s
.83 .24 .1 r
.53679 .54566 m
.54134 .54416 L
s
.53287 .54696 m
.53679 .54566 L
s
.746 .211 .092 r
.46544 .4967 m .48228 .49079 L .48051 .46361 L p F P
0 0 0 r
s
.691 .194 .085 r
.49917 .43024 m .47927 .43754 L .48051 .46361 L p F P
0 0 0 r
s
.24 .35 .67 r
.27985 .50901 m
.26303 .49508 L
s
.23354 .46958 m
.26303 .49508 L
s
.319 .464 .884 r
.553 .50662 m .56119 .51549 L .55062 .54277 L p F P
0 0 0 r
s
.319 .464 .884 r
.55062 .54277 m .54378 .5356 L .553 .50662 L p F P
0 0 0 r
s
.24 .35 .67 r
.46726 .5784 m
.49695 .56264 L
s
.44208 .55464 m
.46726 .5784 L
s
.838 .241 .105 r
.51435 .508 m .49938 .51313 L .49949 .54086 L p F P
0 0 0 r
s
.838 .241 .105 r
.49949 .54086 m .51186 .53672 L .51435 .508 L p F P
0 0 0 r
s
.24 .35 .67 r
.41185 .5648 m
.38313 .56852 L
s
.35614 .54453 m
.38313 .56852 L
s
.83 .24 .1 r
.7627 .55737 m
.7752 .56836 L
s
.82062 .55462 m
.7752 .56836 L
s
.794 .227 .099 r
.49929 .48483 m .48228 .49079 L .48454 .51821 L p F P
0 0 0 r
s
.794 .227 .099 r
.48454 .51821 m .49938 .51313 L .49929 .48483 L p F P
0 0 0 r
s
.545 .147 .066 r
.56248 .36009 m .54111 .36821 L .54096 .39012 L p F P
0 0 0 r
s
.83 .24 .1 r
.54065 .36967 m
.5411 .36951 L
s
.545 .147 .066 r
.51993 .39798 m .54096 .39012 L .54111 .36821 L p F P
0 0 0 r
s
.294 .415 .762 r
.58212 .43364 m .57131 .42087 L .57362 .39588 L p F P
0 0 0 r
s
.308 .438 .814 r
.57131 .42087 m .58212 .43364 L .57721 .46002 L p F P
0 0 0 r
s
.691 .194 .085 r
.48051 .46361 m .49922 .45689 L .49917 .43024 L p F P
0 0 0 r
s
.746 .211 .092 r
.49922 .45689 m .48051 .46361 L .48228 .49079 L p F P
0 0 0 r
s
.24 .35 .67 r
.52282 .2935 m
.54636 .3228 L
s
.54636 .3228 m
.55026 .34751 L
s
.746 .211 .092 r
.48228 .49079 m .49929 .48483 L .49922 .45689 L p F P
0 0 0 r
s
.24 .35 .67 r
.40456 .18321 m
.42814 .18652 L
s
.23354 .46958 m
.22255 .45096 L
s
.19204 .42439 m
.22255 .45096 L
s
.319 .46 .871 r
.56083 .47717 m .57016 .4876 L .56119 .51549 L p F P
0 0 0 r
s
.319 .46 .871 r
.56119 .51549 m .553 .50662 L .56083 .47717 L p F P
0 0 0 r
s
.626 .173 .077 r
.54096 .39012 m .51993 .39798 L .5193 .42286 L p F P
0 0 0 r
s
.626 .173 .077 r
.49917 .43024 m .5193 .42286 L .51993 .39798 L p F P
0 0 0 r
s
.838 .241 .105 r
.52945 .50282 m .51435 .508 L .51186 .53672 L p F P
0 0 0 r
s
.838 .241 .105 r
.51186 .53672 m .52432 .53255 L .52945 .50282 L p F P
0 0 0 r
s
.691 .194 .085 r
.5193 .42286 m .49917 .43024 L .49922 .45689 L p F P
0 0 0 r
s
.83 .24 .1 r
.71749 .26123 m
.67316 .27856 L
s
.67316 .27856 m
.67069 .29616 L
s
.319 .464 .884 r
.54468 .49761 m .553 .50662 L .54378 .5356 L p F P
0 0 0 r
s
.319 .464 .884 r
.54378 .5356 m .53686 .52835 L .54468 .49761 L p F P
0 0 0 r
s
.308 .438 .814 r
.57721 .46002 m .56701 .44826 L .57131 .42087 L p F P
0 0 0 r
s
.315 .452 .849 r
.56701 .44826 m .57721 .46002 L .57016 .4876 L p F P
0 0 0 r
s
.272 .378 .683 r
.57362 .39588 m .56225 .38215 L .56248 .36009 L p F P
0 0 0 r
s
.24 .35 .67 r
.56156 .36137 m
.56246 .36247 L
s
.83 .24 .1 r
.56121 .36187 m
.56247 .36139 L
s
.56329 .36108 m
.58317 .35352 L
s
.294 .415 .762 r
.56225 .38215 m .57362 .39588 L .57131 .42087 L p F P
0 0 0 r
s
.794 .227 .099 r
.51647 .4788 m .49929 .48483 L .49938 .51313 L p F P
0 0 0 r
s
.794 .227 .099 r
.49938 .51313 m .51435 .508 L .51647 .4788 L p F P
0 0 0 r
s
.315 .452 .849 r
.57016 .4876 m .56083 .47717 L .56701 .44826 L p F P
0 0 0 r
s
.24 .35 .67 r
.49695 .56264 m
.52492 .54161 L
s
.47225 .5384 m
.49695 .56264 L
s
.83 .24 .1 r
.53792 .53658 m
.54134 .54416 L
s
.5373 .53521 m
.53792 .53658 L
s
.7032 .55363 m
.71773 .57115 L
s
.7627 .55737 m
.71773 .57115 L
s
.545 .147 .066 r
.54096 .39012 m .56225 .38215 L .56248 .36009 L p F P
0 0 0 r
s
.24 .35 .67 r
.55893 .35815 m
.56098 .36066 L
s
.691 .194 .085 r
.49922 .45689 m .51814 .4501 L .5193 .42286 L p F P
0 0 0 r
s
.746 .211 .092 r
.51814 .4501 m .49922 .45689 L .49929 .48483 L p F P
0 0 0 r
s
.838 .241 .105 r
.54468 .49761 m .52945 .50282 L .52432 .53255 L p F P
0 0 0 r
s
.838 .241 .105 r
.52432 .53255 m .53686 .52835 L .54468 .49761 L p F P
0 0 0 r
s
.83 .24 .1 r
.54134 .54416 m
.58414 .53006 L
s
.746 .211 .092 r
.49929 .48483 m .51647 .4788 L .51814 .4501 L p F P
0 0 0 r
s
.24 .35 .67 r
.52492 .54161 m
.53093 .53549 L
s
.53093 .53549 m
.53201 .53438 L
s
.4886 .24253 m
.513 .27307 L
s
.513 .27307 m
.52282 .2935 L
s
.35614 .54453 m
.33011 .54211 L
s
.30177 .51737 m
.33011 .54211 L
s
.50077 .51684 m
.52492 .54161 L
s
.19204 .42439 m
.18734 .40191 L
s
.83 .24 .1 r
.67069 .29616 m
.6267 .31316 L
s
.6267 .31316 m
.62675 .33698 L
s
.64326 .54415 m
.65881 .5675 L
s
.7032 .55363 m
.65881 .5675 L
s
.626 .173 .077 r
.5193 .42286 m .53967 .41539 L .54096 .39012 L p F P
0 0 0 r
s
.691 .194 .085 r
.53967 .41539 m .5193 .42286 L .51814 .4501 L p F P
0 0 0 r
s
.794 .227 .099 r
.53382 .47271 m .51647 .4788 L .51435 .508 L p F P
0 0 0 r
s
.24 .35 .67 r
.54004 .50605 m
.54079 .50686 L
s
.794 .227 .099 r
.51435 .508 m .52945 .50282 L .53382 .47271 L p F P
0 0 0 r
s
.83 .24 .1 r
.58414 .53006 m
.59959 .55814 L
s
.64326 .54415 m
.59959 .55814 L
s
.626 .173 .077 r
.56225 .38215 m .54096 .39012 L .53967 .41539 L p F P
0 0 0 r
s
.319 .46 .871 r
.55134 .46656 m .56083 .47717 L .553 .50662 L p F P
0 0 0 r
s
.83 .24 .1 r
.5434 .50728 m
.54477 .50681 L
s
.319 .46 .871 r
.553 .50662 m .54468 .49761 L .55134 .46656 L p F P
0 0 0 r
s
.294 .415 .762 r
.57131 .42087 m .56028 .40783 L .56225 .38215 L p F P
0 0 0 r
s
.308 .438 .814 r
.56028 .40783 m .57131 .42087 L .56701 .44826 L p F P
0 0 0 r
s
.83 .24 .1 r
.56344 .39071 m
.58604 .38232 L
s
.24 .35 .67 r
.44208 .55464 m
.41185 .5648 L
s
.38516 .54044 m
.41185 .5648 L
s
.83 .24 .1 r
.62675 .33698 m
.58317 .35352 L
s
.58317 .35352 m
.58604 .38232 L
s
.691 .194 .085 r
.51814 .4501 m .53726 .44323 L .53967 .41539 L p F P
0 0 0 r
s
.746 .211 .092 r
.53726 .44323 m .51814 .4501 L .51647 .4788 L p F P
0 0 0 r
s
.746 .211 .092 r
.51647 .4788 m .53382 .47271 L .53726 .44323 L p F P
0 0 0 r
s
.83 .24 .1 r
.80879 .54325 m
.82062 .55462 L
s
.24 .35 .67 r
.44801 .1957 m
.47339 .22739 L
s
.47339 .22739 m
.4886 .24253 L
s
.30177 .51737 m
.27985 .50901 L
s
.25025 .4834 m
.27985 .50901 L
s
.794 .227 .099 r
.55134 .46656 m .53382 .47271 L .52945 .50282 L p F P
0 0 0 r
s
.794 .227 .099 r
.52945 .50282 m .54468 .49761 L .55134 .46656 L p F P
0 0 0 r
s
.24 .35 .67 r
.52607 .49109 m
.54004 .50605 L
s
.83 .24 .1 r
.54477 .50681 m
.57001 .49823 L
s
.315 .452 .849 r
.55661 .43629 m .56701 .44826 L .56083 .47717 L p F P
0 0 0 r
s
.315 .452 .849 r
.56083 .47717 m .55134 .46656 L .55661 .43629 L p F P
0 0 0 r
s
.308 .438 .814 r
.56701 .44826 m .55661 .43629 L .56028 .40783 L p F P
0 0 0 r
s
.626 .173 .077 r
.53967 .41539 m .56028 .40783 L .56225 .38215 L p F P
0 0 0 r
s
.83 .24 .1 r
.56222 .39117 m
.56344 .39071 L
s
.24 .35 .67 r
.55983 .39008 m
.56048 .39086 L
s
.54762 .37546 m
.55983 .39008 L
s
.691 .194 .085 r
.56028 .40783 m .53967 .41539 L .53726 .44323 L p F P
0 0 0 r
s
.83 .24 .1 r
.71749 .26123 m
.71578 .27873 L
s
.24 .35 .67 r
.52645 .31832 m
.55026 .34751 L
s
.55026 .34751 m
.54762 .37546 L
s
.746 .211 .092 r
.55661 .43629 m .53726 .44323 L .53382 .47271 L p F P
0 0 0 r
s
.746 .211 .092 r
.53382 .47271 m .55134 .46656 L .55661 .43629 L p F P
0 0 0 r
s
.24 .35 .67 r
.54681 .46252 m
.54968 .46573 L
s
.54968 .46573 m
.54979 .46586 L
s
.83 .24 .1 r
.55276 .46624 m
.55803 .46439 L
s
.55254 .46632 m
.55276 .46624 L
s
.24 .35 .67 r
.54681 .46252 m
.55178 .45271 L
s
.691 .194 .085 r
.53726 .44323 m .55661 .43629 L .56028 .40783 L p F P
0 0 0 r
s
.24 .35 .67 r
.53835 .40532 m
.55671 .42663 L
s
.42814 .18652 m
.44801 .1957 L
s
.83 .24 .1 r
.57001 .49823 m
.58414 .53006 L
s
.628 .5156 m
.58414 .53006 L
s
.74871 .53942 m
.7627 .55737 L
s
.80879 .54325 m
.7627 .55737 L
s
.24 .35 .67 r
.25025 .4834 m
.23354 .46958 L
s
.20276 .44297 m
.23354 .46958 L
s
.83 .24 .1 r
.56105 .42605 m
.59233 .41474 L
s
.55855 .42695 m
.56105 .42605 L
s
.55502 .45325 m
.55803 .46439 L
s
.24 .35 .67 r
.47225 .5384 m
.44208 .55464 L
s
.4158 .52984 m
.44208 .55464 L
s
.83 .24 .1 r
.71578 .27873 m
.67069 .29616 L
s
.67069 .29616 m
.67141 .32001 L
s
.24 .35 .67 r
.38516 .54044 m
.35614 .54453 L
s
.32796 .51949 m
.35614 .54453 L
s
.83 .24 .1 r
.68802 .52982 m
.7032 .55363 L
s
.74871 .53942 m
.7032 .55363 L
s
.628 .5156 m
.64326 .54415 L
s
.68802 .52982 m
.64326 .54415 L
s
.55803 .46439 m
.57001 .49823 L
s
.61391 .4833 m
.57001 .49823 L
s
.55803 .46439 m
.60179 .44904 L
s
.24 .35 .67 r
.49824 .26292 m
.52282 .2935 L
s
.52282 .2935 m
.52645 .31832 L
s
.83 .24 .1 r
.63017 .36593 m
.58604 .38232 L
s
.58604 .38232 m
.59233 .41474 L
s
.67141 .32001 m
.62675 .33698 L
s
.62675 .33698 m
.63017 .36593 L
s
.24 .35 .67 r
.20276 .44297 m
.19204 .42439 L
s
.52272 .4356 m
.54681 .46252 L
s
.54681 .46252 m
.52607 .49109 L
s
.50077 .51684 m
.47225 .5384 L
s
.44648 .51309 m
.47225 .5384 L
s
.50142 .46468 m
.52607 .49109 L
s
.52607 .49109 m
.50077 .51684 L
s
.52345 .3465 m
.54762 .37546 L
s
.54762 .37546 m
.53835 .40532 L
s
.46312 .21065 m
.4886 .24253 L
s
.4886 .24253 m
.49824 .26292 L
s
.32796 .51949 m
.30177 .51737 L
s
.27218 .49153 m
.30177 .51737 L
s
.47555 .49099 m
.50077 .51684 L
s
.83 .24 .1 r
.61391 .4833 m
.628 .5156 L
s
.67297 .50078 m
.628 .5156 L
s
.79536 .52485 m
.80879 .54325 L
s
.63691 .39862 m
.59233 .41474 L
s
.59233 .41474 m
.60179 .44904 L
s
.24 .35 .67 r
.4158 .52984 m
.38516 .54044 L
s
.35729 .51501 m
.38516 .54044 L
s
.83 .24 .1 r
.71578 .27873 m
.71721 .30262 L
s
.73391 .51512 m
.74871 .53942 L
s
.79536 .52485 m
.74871 .53942 L
s
.67297 .50078 m
.68802 .52982 L
s
.73391 .51512 m
.68802 .52982 L
s
.24 .35 .67 r
.44801 .1957 m
.46312 .21065 L
s
.27218 .49153 m
.25025 .4834 L
s
.21933 .45665 m
.25025 .4834 L
s
.83 .24 .1 r
.60179 .44904 m
.61391 .4833 L
s
.65892 .468 m
.61391 .4833 L
s
.64666 .43329 m
.60179 .44904 L
s
.67542 .34913 m
.63017 .36593 L
s
.63017 .36593 m
.63691 .39862 L
s
.71721 .30262 m
.67141 .32001 L
s
.67141 .32001 m
.67542 .34913 L
s
.24 .35 .67 r
.50158 .28784 m
.52645 .31832 L
s
.52645 .31832 m
.52345 .3465 L
s
.51371 .37673 m
.53835 .40532 L
s
.53835 .40532 m
.52272 .4356 L
s
.21933 .45665 m
.20276 .44297 L
s
.44648 .51309 m
.4158 .52984 L
s
.38835 .50393 m
.4158 .52984 L
s
.35729 .51501 m
.32796 .51949 L
s
.29854 .49333 m
.32796 .51949 L
s
.83 .24 .1 r
.65892 .468 m
.67297 .50078 L
s
.71909 .48558 m
.67297 .50078 L
s
.68262 .3821 m
.63691 .39862 L
s
.63691 .39862 m
.64666 .43329 L
s
.24 .35 .67 r
.47256 .23097 m
.49824 .26292 L
s
.49824 .26292 m
.50158 .28784 L
s
.49755 .40747 m
.52272 .4356 L
s
.52272 .4356 m
.50142 .46468 L
s
.83 .24 .1 r
.78098 .50005 m
.79536 .52485 L
s
.71909 .48558 m
.73391 .51512 L
s
.78098 .50005 m
.73391 .51512 L
s
.64666 .43329 m
.65892 .468 L
s
.70508 .45231 m
.65892 .468 L
s
.69269 .41715 m
.64666 .43329 L
s
.24 .35 .67 r
.47555 .49099 m
.44648 .51309 L
s
.41955 .48664 m
.44648 .51309 L
s
.83 .24 .1 r
.72183 .3319 m
.67542 .34913 L
s
.67542 .34913 m
.68262 .3821 L
s
.71721 .30262 m
.72183 .3319 L
s
.24 .35 .67 r
.47567 .43709 m
.50142 .46468 L
s
.50142 .46468 m
.47555 .49099 L
s
.49819 .31625 m
.52345 .3465 L
s
.52345 .3465 m
.51371 .37673 L
s
.46312 .21065 m
.47256 .23097 L
s
.29854 .49333 m
.27218 .49153 L
s
.24126 .46454 m
.27218 .49153 L
s
.44919 .46396 m
.47555 .49099 L
s
.38835 .50393 m
.35729 .51501 L
s
.32816 .48843 m
.35729 .51501 L
s
.83 .24 .1 r
.70508 .45231 m
.71909 .48558 L
s
.7664 .46998 m
.71909 .48558 L
s
.72952 .36514 m
.68262 .3821 L
s
.68262 .3821 m
.69269 .41715 L
s
.24 .35 .67 r
.24126 .46454 m
.21933 .45665 L
s
.83 .24 .1 r
.7664 .46998 m
.78098 .50005 L
s
.24 .35 .67 r
.47559 .25597 m
.50158 .28784 L
s
.50158 .28784 m
.49819 .31625 L
s
.83 .24 .1 r
.69269 .41715 m
.70508 .45231 L
s
.75244 .4362 m
.70508 .45231 L
s
.73991 .40058 m
.69269 .41715 L
s
.24 .35 .67 r
.48796 .34683 m
.51371 .37673 L
s
.51371 .37673 m
.49755 .40747 L
s
.83 .24 .1 r
.72183 .3319 m
.72952 .36514 L
s
.24 .35 .67 r
.41955 .48664 m
.38835 .50393 L
s
.35965 .47684 m
.38835 .50393 L
s
.32816 .48843 m
.29854 .49333 L
s
.26776 .46598 m
.29854 .49333 L
s
.47256 .23097 m
.47559 .25597 L
s
.47122 .37805 m
.49755 .40747 L
s
.49755 .40747 m
.47567 .43709 L
s
.83 .24 .1 r
.75244 .4362 m
.7664 .46998 L
s
.72952 .36514 m
.73991 .40058 L
s
.24 .35 .67 r
.44919 .46396 m
.41955 .48664 L
s
.39138 .45898 m
.41955 .48664 L
s
.44872 .40822 m
.47567 .43709 L
s
.47567 .43709 m
.44919 .46396 L
s
.47176 .2846 m
.49819 .31625 L
s
.49819 .31625 m
.48796 .34683 L
s
.26776 .46598 m
.24126 .46454 L
s
.42162 .4357 m
.44919 .46396 L
s
.83 .24 .1 r
.73991 .40058 m
.75244 .4362 L
s
.24 .35 .67 r
.35965 .47684 m
.32816 .48843 L
s
.29769 .46062 m
.32816 .48843 L
s
.47559 .25597 m
.47176 .2846 L
s
.46101 .31555 m
.48796 .34683 L
s
.48796 .34683 m
.47122 .37805 L
s
.39138 .45898 m
.35965 .47684 L
s
.32961 .44848 m
.35965 .47684 L
s
.29769 .46062 m
.26776 .46598 L
s
.44366 .34725 m
.47122 .37805 L
s
.47122 .37805 m
.44872 .40822 L
s
.42162 .4357 m
.39138 .45898 L
s
.36188 .43002 m
.39138 .45898 L
s
.42051 .378 m
.44872 .40822 L
s
.44872 .40822 m
.42162 .4357 L
s
.47176 .2846 m
.46101 .31555 L
s
.39275 .4061 m
.42162 .4357 L
s
.32961 .44848 m
.29769 .46062 L
s
.46101 .31555 m
.44366 .34725 L
s
.36188 .43002 m
.32961 .44848 L
s
.44366 .34725 m
.42051 .378 L
s
.39275 .4061 m
.36188 .43002 L
s
.42051 .378 m
.39275 .4061 L
s
0 0 0 r
.25 Mabswid
.63805 .03848 m
.66126 .3169 L
s
.66126 .3169 m
.00747 .5665 L
s
.00747 .5665 m
.06705 .30234 L
s
.06705 .30234 m
.63805 .03848 L
s
.63805 .03848 m
.66126 .3169 L
s
.66126 .3169 m
.93472 .69847 L
s
.93472 .69847 m
.88764 .44767 L
s
.88764 .44767 m
.63805 .03848 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{500, 500},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40007d0001m2000`400?l00000o`00003oo`3ooooe
0?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3o
m^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40
oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?of
k_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3o
ool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^
m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofkSh0ooK^0P00002d0?ofkP40oooo003o0?of
kS`0ooK^0P0000000`3om^h000000000002c0?ofkP40oooo003o0?ofkSX0ooK^0P0000030?ofkP80
0000/`3om^h10?ooo`00o`3om^hh0?ofkP8000001@3om^h00`000000ooK^0000002b0?ofkP40oooo
003o0?ofkSH0ooK^0P0000070?ofkP030000003om^h000000;80ooK^0@3oool00?l0ooK^=03om^h2
000000T0ooK^00@000000?ofkP3om^h00000/@3om^h10?ooo`00o`3om^ha0?ofkP<000002`3om^h0
1@000000ooK^0?ofkP3om^h000000;00ooK^0@3oool00?l0ooK^;`3om^h2000000l0ooK^00@00000
0?ofkP3om^h00000/03om^h10?ooo`00o`3om^h]0?ofkP8000004@3om^h01@000000ooK^0?ofkP3o
m^h000000:l0ooK^0@3oool00?l0ooK^:`3om^h2000001<0ooK^00D000000?ofkP3om^h0ooK^0000
002_0?ofkP40oooo003o0?ofkRT0ooK^0P00000E0?ofkP030000003om^h0ooK^0080ooK^00<00000
0?ofkP3om^h0[03om^h10?ooo`00o`3om^hV0?ofkP<000005`3om^h00`000000ooK^0?ofkP030?of
kP030000003om^h0ooK^0:/0ooK^0@3oool00?l0ooK^903om^h2000001X0ooK^00<000000?ofkP3o
m^h00`3om^h00`000000ooK^0?ofkP2[0?ofkP40oooo003o0?ofkR80ooK^0P00000L0?ofkP030000
003om^h0ooK^00@0ooK^00<000000?ofkP3om^h0ZP3om^h10?ooo`00o`3om^hP0?ofkP8000007P3o
m^h00`000000ooK^0?ofkP050?ofkP030000003om^h0ooK^0:T0ooK^0@3oool00?l0ooK^7P3om^h2
00000200ooK^00<000000?ofkP3om^h01@3om^h00`000000ooK^0?ofkP2Y0?ofkP40oooo003o0?of
kQ`0ooK^0P00000R0?ofkP030000003om^h0ooK^00H0ooK^00<000000?ofkP3om^h0Z03om^h10?oo
o`00o`3om^hI0?ofkP<00000903om^h00`000000ooK^0?ofkP060?ofkP030000003om^h0ooK^0:P0
ooK^0@3oool00?l0ooK^5`3om^h2000002L0ooK^00<000000?ofkP3om^h01`3om^h00`000000ooK^
0?ofkP2W0?ofkP40oooo003o0?ofkQD0ooK^0P00000Z0?ofkP030000003om^h0ooK^00L0ooK^00<0
00000?ofkP3om^h0YP3om^h10?ooo`00o`3om^hC0?ofkP800000;03om^h00`000000ooK^0?ofkP07
0?ofkP030000003om^h0ooK^0:H0ooK^0@3oool00?l0ooK^4@3om^h2000002h0ooK^00<000000?of
kP3om^h0203om^h00`000000ooK^0?ofkP2U0?ofkP40oooo003o0?ofkPl0ooK^0P00000`0?ofkP03
0000003om^h0ooK^00P0ooK^00<000000?ofkP3om^h0Y@3om^h10?ooo`00o`3om^h<0?ofkP<00000
<P3om^h00`000000ooK^0?ofkP090?ofkP030000003om^h0ooK^0:@0ooK^0@3oool00?l0ooK^2P3o
m^h2000003D0ooK^00<000000?ofkP3om^h02P3om^h00`000000ooK^0?ofkP2S0?ofkP40oooo003o
0?ofkPP0ooK^0P00000g0?ofkP030000003om^h0ooK^00X0ooK^00<000000?ofkP3om^h0X`3om^h1
0?ooo`00o`3om^h60?ofkP800000>@3om^h00`000000ooK^0?ofkP0;0?ofkP030000003om^h0ooK^
0:80ooK^0@3oool00?l0ooK^103om^h2000003/0ooK^00<000000?ofkP3om^h02`3om^h00`000000
ooK^0?ofkP2R0?ofkP40oooo003o0?ofkP40ooK^0`00000m0?ofkP030000003om^h0ooK^00`0ooK^
00<000000?ofkP3om^h0X@3om^h10?ooo`00oP3om^h200000400ooK^00<000000?ofkP3om^h03@3o
m^h00`000000ooK^0?ofkP2P0?ofkP40oooo003l0?ofkP800000@P3om^h00`000000ooK^0?ofkP0=
0?ofkP030000003om^h0ooK^0:00ooK^0@3oool00?X0ooK^0P0000140?ofkP030000003om^h0ooK^
00h0ooK^00<000000?ofkP3om^h0W`3om^h10?ooo`00n03om^h2000004L0ooK^00<000000?ofkP3o
m^h03@3om^h00`000000ooK^0?ofkP2O0?ofkP40oooo003f0?ofkP800000B@3om^h00`000000ooK^
0?ofkP0>0?ofkP030000003om^h0ooK^09h0ooK^0@3oool00?<0ooK^0`00001;0?ofkP030000003o
m^h0ooK^00l0ooK^00<000000?ofkP3om^h0W@3om^h10?ooo`00l@3om^h2000004h0ooK^00<00000
0?ofkP3om^h03`3om^h00`000000ooK^0?ofkP2M0?ofkP40oooo003_0?ofkP800000D03om^h00`00
0000ooK^0?ofkP0@0?ofkP030000003om^h0ooK^09`0ooK^0@3oool00>d0ooK^0P00001B0?ofkP03
0000003om^h0ooK^0100ooK^00<000000?ofkP3om^h0W03om^h10?ooo`00j`3om^h2000005@0ooK^
00<000000?ofkP3om^h04@3om^h00`000000ooK^0?ofkP2K0?ofkP40oooo003Y0?ofkP800000EP3o
m^h00`000000ooK^0?ofkP0B0?ofkP030000003om^h0ooK^09X0ooK^0@3oool00>H0ooK^0`00001H
0?ofkP030000003om^h0ooK^0180ooK^00<000000?ofkP3om^h0VP3om^h10?ooo`00i03om^h20000
05/0ooK^00<000000?ofkP3om^h04`3om^h00`000000ooK^0?ofkP2I0?ofkP40oooo003R0?ofkP80
0000G@3om^h00`000000ooK^0?ofkP0D0?ofkP030000003om^h0ooK^09P0ooK^0@3oool00>00ooK^
0P00001O0?ofkP030000003om^h0ooK^01@0ooK^00<000000?ofkP3om^h0V03om^h10?ooo`00gP3o
m^h200000640ooK^00<000000?ofkP3om^h05@3om^h00`000000ooK^0?ofkP2G0?ofkP40oooo003L
0?ofkP800000I03om^h00`000000ooK^0?ofkP0D0?ofkP030000003om^h0ooK^09L0ooK^0@3oool0
0=T0ooK^0`00001V0?ofkP030000003om^h0ooK^01D0ooK^00<000000?ofkP3om^h0UP3om^h10?oo
o`00e`3om^h2000006T0ooK^00<000000?ofkP3om^h05P3om^h00`000000ooK^0?ofkP2E0?ofkP40
oooo003E0?ofkP800000J`3om^h00`000000ooK^0?ofkP0F0?ofkP030000003om^h0ooK^09D0ooK^
0@3oool00=<0ooK^0P00001]0?ofkP030000003om^h0ooK^01L0ooK^00<000000?ofkP3om^h0U03o
m^h10?ooo`00d@3om^h2000006l0ooK^00<000000?ofkP3om^h05`3om^h00`000000ooK^0?ofkP2D
0?ofkP40oooo003>0?ofkP<00000L@3om^h00`000000ooK^0?ofkP0H0?ofkP030000003om^h0ooK^
09<0ooK^0@3oool00<`0ooK^0P00001d0?ofkP030000003om^h0ooK^01T0ooK^00<000000?ofkP3o
m^h0TP3om^h10?ooo`00bP3om^h2000007H0ooK^00<000000?ofkP3om^h06@3om^h00`000000ooK^
0?ofkP2B0?ofkP40oooo00380?ofkP800000N03om^h00`000000ooK^0?ofkP0J0?ofkP030000003o
m^h0ooK^0940ooK^0@3oool00<H0ooK^0P00001j0?ofkP030000003om^h0ooK^01X0ooK^00<00000
0?ofkP3om^h0T@3om^h10?ooo`00a03om^h2000007`0ooK^00<000000?ofkP3om^h06`3om^h00`00
0000ooK^0?ofkP2@0?ofkP40oooo00310?ofkP<00000O`3om^h00`000000ooK^0?ofkP0K0?ofkP03
0000003om^h0ooK^08l0ooK^0@3oool00;l0ooK^0P0000220?ofkP030000003om^h0ooK^01/0ooK^
00<000000?ofkP3om^h0S`3om^h10?ooo`00_@3om^h2000008@0ooK^00<000000?ofkP3om^h0703o
m^h00`000000ooK^0?ofkP2>0?ofkP40oooo002k0?ofkP800000QP3om^h00`000000ooK^0?ofkP0L
0?ofkP030000003om^h0ooK^08h0ooK^0@3oool00;T0ooK^0P0000280?ofkP030000003om^h0ooK^
01d0ooK^00<000000?ofkP3om^h0S@3om^h10?ooo`00]`3om^h2000008X0ooK^00<000000?ofkP3o
m^h07P3om^h00`000000ooK^0?ofkP2<0?ofkP40oooo002d0?ofkP<00000S03om^h00`000000ooK^
0?ofkP0N0?ofkP030000003om^h0ooK^08`0ooK^0@3oool00;80ooK^0P00002?0?ofkP030000003o
m^h0ooK^01l0ooK^00<000000?ofkP3om^h0R`3om^h10?ooo`00/03om^h200000940ooK^00<00000
0?ofkP3om^h0803om^h00`000000ooK^0?ofkP2:0?ofkP40oooo002^0?ofkP800000T`3om^h00`00
0000ooK^0?ofkP0P0?ofkP030000003om^h0ooK^08X0ooK^0@3oool00:`0ooK^0P00002E0?ofkP03
0000003om^h0ooK^0240ooK^00<000000?ofkP3om^h0R@3om^h10?ooo`00Z@3om^h3000009L0ooK^
00<000000?ofkP3om^h08@3om^h00`000000ooK^0?ofkP290?ofkP40oooo002W0?ofkP800000VP3o
m^h00`000000ooK^0?ofkP0R0?ofkP030000003om^h0ooK^08P0ooK^0@3oool00:D0ooK^0P00002M
0?ofkP030000003om^h0ooK^0280ooK^00<000000?ofkP3om^h0Q`3om^h10?ooo`00X`3om^h20000
09l0ooK^00<000000?ofkP3om^h08P3om^h00`000000ooK^0?ofkP270?ofkP40oooo002Q0?ofkP80
0000803om^h903eIZgP0ooK^00<000000?ofkP3om^h08`3om^h00`000000ooK^0?ofkP260?ofkP40
oooo002O0?ofkP8000006P3om^h803eIZ`L0ooK^00<0?EV[0?ofkP0mFJ/01@0mFJ]b0?ofkP030000
003om^h0ooK^02<0ooK^00<000000?ofkP3om^h0QP3om^h10?ooo`00W03om^h3000001P0ooK^100m
FJ/20?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h0103om^h503eIZfd0ooK^00<0
00000?ofkP3om^h0903om^h00`000000ooK^0?ofkP250?ofkP40oooo002J0?ofkP800000603om^h3
03eIZ`L0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP070?ofkP<0?EV[J`3om^h0
0`000000ooK^0?ofkP0U0?ofkP030000003om^h0ooK^08@0ooK^0@3oool009P0ooK^0P00000F0?of
kP@0?EV[2`3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?of
kP0mFJ/00P0mFJ]X0?ofkP030000003om^h0ooK^02D0ooK^00<000000?ofkP3om^h0Q03om^h10?oo
o`00UP3om^h2000001D0ooK^0`0mFJ/?0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3o
m^h0203om^h0100mFJ/0ooK^0?ofkP3om^h203eIZfH0ooK^00<000000?ofkP3om^h09P3om^h00`00
0000ooK^0?ofkP230?ofkP40oooo002D0?ofkP8000005@3om^h203eIZ`80ooK^00<0?EV[0?ofkP3o
m^h03P3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3o
m^h00`3om^h203eIZf@0ooK^00<000000?ofkP3om^h09P3om^h00`000000ooK^0?ofkP230?ofkP40
oooo002B0?ofkP8000005@3om^h203eIZ`D0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^
0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^
0?ofkP1Q0?ofkP030000003om^h0ooK^02L0ooK^00<000000?ofkP3om^h0PP3om^h10?ooo`00S`3o
m^h3000001@0ooK^0`0mFJ/80?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h02`3o
m^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h0H03o
m^h00`000000ooK^0?ofkP0X0?ofkP030000003om^h0ooK^0840ooK^0@3oool008d0ooK^0P00000E
0?ofkP80?EV[2`3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[
0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP030?ofkP80?EV[H@3om^h00`000000ooK^0?ofkP0X
0?ofkP030000003om^h0ooK^0840ooK^0@3oool008/0ooK^0P00000E0?ofkP80?EV[3P3om^h00`0m
FJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0m
FJ/0ooK^0?ofkP030?ofkP80?EV[H03om^h00`000000ooK^0?ofkP0Y0?ofkP030000003om^h0ooK^
0800ooK^0@3oool008T0ooK^0P00000E0?ofkP80?EV[4@3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP03
03eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP030?ofkP80
?EV[H03om^h00`000000ooK^0?ofkP0X0?ofkP030000003om^h0ooK^0800ooK^0@3oool008L0ooK^
0P00000E0?ofkP80?EV[00<0ooK^03eIZ`3om^h04@3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eI
Z`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP030?ofkP80?EV[
G`3om^h00`000000ooK^0?ofkP0Y0?ofkP030000003om^h0ooK^07l0ooK^0@3oool008@0ooK^0`00
000F0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h0403om^h00`0mFJ/0ooK^0?of
kP0>0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?of
kP030?ofkP80?EV[GP3om^h00`000000ooK^0?ofkP0Z0?ofkP030000003om^h0ooK^07h0ooK^0@3o
ool00880ooK^0P00000G0?ofkP80?EV[1P3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0303eIZ`3om^h0
ooK^00h0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0
ooK^00<0ooK^00<0?EV[0?ofkP0mFJ/0G@3om^h00`000000ooK^0?ofkP0Z0?ofkP030000003om^h0
ooK^07h0ooK^0@3oool00800ooK^0P00000H0?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?of
kP3om^h0403om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00D0ooK^2@0mFJ/70?of
kP0303eIZ`3om^h0ooK^00<0ooK^0`0mFJ]L0?ofkP030000003om^h0ooK^02/0ooK^00<000000?of
kP3om^h0O@3om^h10?ooo`00OP3om^h2000001T0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0
ooK^0?ofkP0@0?ofkP0303eIZ`3om^h0ooK^00d0ooK^200mFJ/70?ofkP0303eIZ`3om^h0?EV[00D0
?EV[0P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP80?EV[G03om^h00`000000ooK^0?ofkP0[0?ofkP03
0000003om^h0ooK^07d0ooK^0@3oool007`0ooK^0P00000I0?ofkP80?EV[3@3om^h00`0mFJ/0ooK^
0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00T0ooK^100mFJ/20?ofkP0303eIZ`3om^h0ooK^00/0ooK^
00<0?EV[0?ofkP3om^h0103om^h403eIZ`D0ooK^0P0mFJ]K0?ofkP030000003om^h0ooK^02`0ooK^
00<000000?ofkP3om^h0O03om^h10?ooo`00NP3om^h2000001X0ooK^00<0?EV[0?ofkP3om^h03P3o
m^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00D0ooK^0`0mFJ/70?ofkP0303eIZ`3o
m^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h0203om^h203eIZ`@0ooK^0P0mFJ]J0?ofkP030000003o
m^h0ooK^02d0ooK^00<000000?ofkP3om^h0N`3om^h10?ooo`00M`3om^h3000001X0ooK^0P0mFJ/A
0?ofkP0303eIZ`3om^h0ooK^0100ooK^00<0?EV[0?ofkP3om^h0100mFJ/:0?ofkP0303eIZ`3om^h0
ooK^00/0ooK^00<0?EV[0?ofkP3om^h0203om^h303eIZ`80ooK^0`0mFJ]I0?ofkP030000003om^h0
ooK^02d0ooK^00<000000?ofkP3om^h0N`3om^h10?ooo`00M@3om^h2000001`0ooK^00<0?EV[0?of
kP3om^h04P3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP<0?EV[3`3om^h00`0mFJ/0ooK^0?ofkP0;0?of
kP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h01@0mFJ]I0?ofkP030000003om^h0ooK^
02h0ooK^00<000000?ofkP3om^h0NP3om^h10?ooo`00L`3om^h2000001d0ooK^00<0?EV[0?ofkP0m
FJ/0503om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP80?EV[0P3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP03
03eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h01`3om^h0100mFJ/0ooK^0?ofkP3om^h403eI
ZeP0ooK^00<000000?ofkP3om^h0;`3om^h00`000000ooK^0?ofkP1i0?ofkP40oooo001a0?ofkP80
00007P3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[01@0ooK^00<0?EV[0?ofkP3om^h02@3om^h203eI
Z`D0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^
00L0ooK^00@0?EV[0?ofkP3om^h0ooK^100mFJ]G0?ofkP030000003om^h0ooK^02l0ooK^00<00000
0?ofkP3om^h0N@3om^h10?ooo`00K`3om^h2000001h0ooK^0P0mFJ/50?ofkP0303eIZ`3om^h0ooK^
0180ooK^00<0?EV[0?ofkP3om^h01P3om^h203eIZ`P0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0m
FJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00P0ooK^00H0?EV[0?ofkP3om^h0ooK^03eIZ`3o
m^h203eIZeL0ooK^00<000000?ofkP3om^h0;`3om^h00`000000ooK^0?ofkP1h0?ofkP40oooo001]
0?ofkP8000007`3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[
0?ofkP3om^h00`3om^h203eIZ`/0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0;
0?ofkP0303eIZ`3om^h0ooK^00P0ooK^00@0?EV[0?ofkP3om^h0?EV[0P3om^h00`0mFJ/0ooK^0?of
kP1E0?ofkP030000003om^h0ooK^02l0ooK^00<000000?ofkP3om^h0N03om^h10?ooo`00JP3om^h3
00000200ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0
ooK^0080?EV[3P3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[
0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP0203eIZ`030?ofkP0mFJ/0?EV[05H0ooK^00<00000
0?ofkP3om^h0<03om^h00`000000ooK^0?ofkP1g0?ofkP40oooo001X0?ofkP8000008P3om^h00`0m
FJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^01<0ooK^0P0mFJ/A0?ofkP0303eIZ`3om^h0ooK^
00d0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP070?ofkP0603eIZ`3om^h0?EV[
0?ofkP0mFJ/0ooK^0P0mFJ]E0?ofkP030000003om^h0ooK^0340ooK^00<000000?ofkP3om^h0MP3o
m^h10?ooo`00IP3om^h2000002<0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP0@
0?ofkP80?EV[00<0ooK^03eIZ`3om^h0403om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0
ooK^00/0ooK^00<0?EV[0?ofkP3om^h01`3om^h203eIZ`040?ofkP0mFJ/0ooK^0?ofkP80?EV[E03o
m^h00`000000ooK^0?ofkP0a0?ofkP030000003om^h0ooK^07H0ooK^0@3oool006@0ooK^0P00000S
0?ofkP80?EV[3`3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[
0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[
0?ofkP3om^h0203om^h203eIZ`050?ofkP0mFJ/0ooK^0?ofkP0mFJ/0E03om^h00`000000ooK^0?of
kP0b0?ofkP030000003om^h0ooK^07D0ooK^0@3oool00680ooK^0P00000T0?ofkP0303eIZ`3om^h0
ooK^0100ooK^00<0?EV[0?ofkP3om^h02`3om^h203eIZ`H0ooK^00<0?EV[0?ofkP3om^h03`3om^h0
0`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h0203om^h0
100mFJ/0ooK^0?ofkP0mFJ/20?ofkP0303eIZ`3om^h0ooK^0540ooK^00<000000?ofkP3om^h0<P3o
m^h00`000000ooK^0?ofkP1e0?ofkP40oooo001P0?ofkP8000009@3om^h00`0mFJ/0ooK^0?ofkP0B
0?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP0@
0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h01@3om^h903eIZ`L0ooK^00H0?EV[
0?ofkP3om^h0ooK^03eIZ`3om^h203eIZe80ooK^00<000000?ofkP3om^h0<`3om^h00`000000ooK^
0?ofkP1d0?ofkP40oooo001M0?ofkP<000009P3om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP0303eIZ`3o
m^h0ooK^00H0ooK^0P0mFJ/:0?ofkP0303eIZ`3om^h0ooK^0100ooK^00<0?EV[0?ofkP3om^h02`3o
m^h903eIZ`L0ooK^00<0?EV[0?ofkP0mFJ/01@0mFJ/00`3om^h0?EV[03eIZ`030?ofkP0403eIZ`3o
m^h0?EV[03eIZe40ooK^00<000000?ofkP3om^h0=03om^h00`000000ooK^0?ofkP1c0?ofkP40oooo
001K0?ofkP800000:03om^h00`0mFJ/0ooK^03eIZ`0E0?ofkP0303eIZ`3om^h0ooK^00@0ooK^0P0m
FJ/=0?ofkP0303eIZ`3om^h0ooK^0100ooK^00<0?EV[0?ofkP3om^h01P3om^h403eIZ`<0ooK^00<0
?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP040?ofkP@0?EV[0P3om^h00`0mFJ/0ooK^0?of
kP0203eIZe00ooK^00<000000?ofkP3om^h08@3om^h40=@m6@l0ooK^00<000000?ofkP3om^h0L`3o
m^h10?ooo`00F@3om^h2000002T0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0E0?ofkP0303eIZ`3o
m^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0403eIZ`3o
m^h0ooK^0?ofkP@0?EV[203om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00@0ooK^
00<0?EV[0?ofkP3om^h00P0mFJ/00`3om^h0?EV[0?ofkP0203eIZe00ooK^00<000000?ofkP3om^h0
7`3om^h30=@m6@<0ooK^0`3D?AT=0?ofkP030000003om^h0ooK^0780ooK^0@3oool005L0ooK^0P00
000Z0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h04`3om^h0100mFJ/0ooK^03eI
Z`0mFJ/B0?ofkP0303eIZ`3om^h0ooK^00l0ooK^100mFJ/=0?ofkP0303eIZ`3om^h0ooK^00X0ooK^
00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP0403eIZ`030?ofkP0mFJ/0?EV[04l0ooK^
00<000000?ofkP3om^h0703om^h40=@m6@@0ooK^0P3D?AT20?ofkP030=@m6@3om^h0ooK^00X0ooK^
00<000000?ofkP3om^h0LP3om^h10?ooo`00E@3om^h2000002/0ooK^00<0?EV[0?ofkP3om^h01@3o
m^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h0303o
m^h203eIZ`80ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3o
m^h0ooK^00@0ooK^00@0?EV[0?ofkP3om^h0?EV[0P3om^h503eIZdh0ooK^00<000000?ofkP3om^h0
6@3om^h50=@m6@040?ofkP3D?AT0ooK^0?ofkP80e3dI1@3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP03
0000003om^h0ooK^0740ooK^0@3oool00580ooK^0`00000/0?ofkP0303eIZ`3om^h0ooK^00L0ooK^
00<0?EV[0?ofkP3om^h04@3om^h00`0mFJ/0ooK^03eIZ`0E0?ofkP0303eIZ`3om^h0ooK^00T0ooK^
0P0mFJ/50?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^
0?ofkP030?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/00`3om^h403eIZdh0ooK^00<000000?ofkP3o
m^h05P3om^h40=@m6@<0ooK^103D?AT80?ofkP030=@m6@3om^h0ooK^00X0ooK^00<000000?ofkP3o
m^h0L03om^h10?ooo`00D03om^h2000002d0ooK^0P0mFJ/;0?ofkP0303eIZ`3om^h0ooK^00h0ooK^
0P0mFJ/30?ofkP0303eIZ`3om^h0ooK^0180ooK^00<0?EV[0?ofkP3om^h01P3om^h303eIZ`P0ooK^
00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^0080ooK^
0P0mFJ/30?ofkP0403eIZ`3om^h0ooK^0?ofkP@0?EV[C@3om^h00`000000ooK^0?ofkP0C0?ofkPD0
e3dI103om^h20=@m6@`0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`000000ooK^0?ofkP1`0?ofkP40
oooo001>0?ofkP800000;P3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00d0ooK^
00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^00<0ooK^
0P0mFJ/;0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h02`3om^h01`0mFJ/0ooK^
0?ofkP3om^h0?EV[0?ofkP0mFJ/00`3om^h00`0mFJ/0ooK^0?ofkP0203eIZ`030?ofkP0mFJ/0ooK^
04`0ooK^00<000000?ofkP3om^h0403om^h50=@m6@D0ooK^0`3D?AT=0?ofkP80e3dI2`3om^h00`00
0000ooK^0?ofkP1_0?ofkP40oooo001<0?ofkP800000;`3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP03
03eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP03
03eIZ`3om^h0ooK^0080?EV[3P3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00/0
ooK^00H0?EV[0?ofkP3om^h0?EV[0?ofkP0mFJ/40?ofkP0403eIZ`3om^h0ooK^03eIZ`80ooK^00<0
?EV[0?ofkP3om^h0BP3om^h00`000000ooK^0?ofkP0>0?ofkP@0e3dI1@3om^h30=@m6@030?ofkP3D
?AT0e3dI00/0ooK^0P3D?AT20?ofkP030=@m6@3om^h0ooK^00P0ooK^00<000000?ofkP3om^h0K`3o
m^h10?ooo`00BP3om^h200000300ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP08
0?ofkP80?EV[2P3om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP80?EV[4@3om^h00`0mFJ/0ooK^0?ofkP0=
0?ofkP0303eIZ`3om^h0ooK^00/0ooK^0P0mFJ/30?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/00`3o
m^h0100mFJ/0ooK^03eIZ`0mFJ];0?ofkP030000003om^h0ooK^00/0ooK^103D?AT60?ofkP80e3dI
0P3om^h20=@m6@030?ofkP3D?AT0ooK^00L0ooK^0`3D?AT40?ofkP030=@m6@3om^h0ooK^00T0ooK^
00<000000?ofkP3om^h0KP3om^h10?ooo`00B03om^h200000340ooK^00<0?EV[0?ofkP3om^h04@3o
m^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h03`3o
m^h203eIZ`030?ofkP0mFJ/0ooK^0140ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?of
kP0:0?ofkP80?EV[103om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[0080ooK^0P0mFJ/00`3om^h0?EV[
03eIZ`1:0?ofkP030000003om^h0ooK^00T0ooK^103D?AT00`3om^h0e3dI0=@m6@030?ofkP80e3dI
00@0ooK^0=@m6@3D?AT0e3dI0`3om^h00`3D?AT0ooK^0?ofkP040?ofkP80e3dI203om^h00`3D?AT0
ooK^0?ofkP090?ofkP030000003om^h0ooK^06d0ooK^0@3oool004D0ooK^0`00000b0?ofkP0303eI
Z`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eI
Z`3om^h0ooK^00`0ooK^0P0mFJ/40?ofkP0303eIZ`3om^h0ooK^0100ooK^00<0?EV[0?ofkP3om^h0
303om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00X0?EV[0?ofkP3om^h0
ooK^03eIZ`3om^h0?EV[0?ofkP0mFJ/0ooK^0P0mFJ]90?ofkP030000003om^h0ooK^00H0ooK^103D
?AT60?ofkP<0e3dI00<0ooK^0=@m6@3D?AT01P3om^h0103D?AT0ooK^0?ofkP3om^h30=@m6@/0ooK^
00<0e3dI0?ofkP3om^h0203om^h00`000000ooK^0?ofkP1]0?ofkP40oooo00130?ofkP800000=03o
m^h00`0mFJ/0ooK^03eIZ`0E0?ofkP0403eIZ`3om^h0ooK^0?ofkP80?EV[4@3om^h00`0mFJ/0ooK^
0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h0403om^h00`0mFJ/0ooK^
0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00X0ooK^0P0mFJ/50?ofkP0403eIZ`3om^h0ooK^0?ofkP80
?EV[00D0ooK^03eIZ`3om^h0ooK^03eIZ`190?ofkP030000003om^h0ooK^00<0ooK^1@3D?AT60?of
kP80e3dI00@0ooK^0=@m6@3D?AT0e3dI203om^h0103D?AT0ooK^0=@m6@3D?AT?0?ofkP030=@m6@3o
m^h0ooK^00P0ooK^00<000000?ofkP3om^h0K03om^h10?ooo`00@@3om^h2000003D0ooK^00D0?EV[
0?ofkP3om^h0ooK^03eIZ`0E0?ofkP0303eIZ`3om^h0?EV[01@0ooK^00<0?EV[0?ofkP3om^h01`3o
m^h203eIZ`P0ooK^00<0?EV[0?ofkP3om^h04@3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3o
m^h0ooK^00D0ooK^200mFJ/30?ofkP0303eIZ`3om^h0ooK^0080ooK^0P0mFJ/01@3om^h0?EV[0?of
kP3om^h0?EV[04P0ooK^00@000000?ofkP3om^h0ooK^103D?AT20?ofkP040=@m6@3om^h0ooK^0?of
kPH0e3dI0`3om^h00`3D?AT0ooK^0?ofkP040?ofkP<0e3dI4@3om^h00`3D?AT0ooK^0?ofkP090?of
kP030000003om^h0ooK^06/0ooK^0@3oool003l0ooK^0P00000f0?ofkP0303eIZ`3om^h0ooK^00<0
ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP0303eIZ`3om^h0ooK^00D0
ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0303eIZ`3om^h0ooK^00/0
ooK^2@0mFJ/40?ofkP0303eIZ`3om^h0ooK^00H0?EV[0`3om^h203eIZ`80ooK^00@0?EV[0?ofkP0m
FJ/0?EV[A`3om^h00`000000e3dI0=@m6@020=@m6@@0ooK^00<0e3dI0?ofkP3D?AT00P3D?AT00`3o
m^h0e3dI0=@m6@070?ofkP80e3dI0P3om^h30=@m6A@0ooK^00<0e3dI0?ofkP3om^h0203om^h00`00
0000ooK^0?ofkP1[0?ofkP40oooo000m0?ofkP800000>03om^h00`0mFJ/0ooK^0?ofkP040?ofkP03
03eIZ`3om^h0ooK^0140ooK^00<0?EV[0?ofkP0mFJ/05P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP80
?EV[3@3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0303eIZ`3om^h0ooK^00H0ooK^100mFJ/30?ofkP03
03eIZ`3om^h0ooK^00L0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`030?ofkP@0?EV[00<0ooK^03eI
Z`3om^h00P3om^h0100mFJ/0ooK^03eIZ`0mFJ]40?ofkP80e3dI00<000000=@m6@3om^h01P3om^h2
0=@m6@040?ofkP3D?AT0e3dI0=@m6@X0ooK^0`3D?AT20?ofkP030=@m6@3om^h0ooK^0180ooK^0P3D
?AT:0?ofkP030000003om^h0ooK^06X0ooK^0@3oool003/0ooK^0P00000i0?ofkP0303eIZ`3om^h0
ooK^00H0ooK^00<0?EV[0?ofkP3om^h03`3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[01H0ooK^00@0
?EV[0?ofkP0mFJ/0?EV[403om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0403eIZ`3om^h0ooK^0?ofkP@0
?EV[203om^h00`0mFJ/0ooK^0?ofkP060?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/01@3om^h00`0m
FJ/0ooK^03eIZ`0203eIZ`<0ooK^00@0?EV[0?ofkP0mFJ/0?EV[@@3om^h40=@m6@030000003om^h0
ooK^00<0ooK^0`3D?AT00`3om^h0e3dI0=@m6@0;0?ofkP80e3dI0P3om^h0103D?AT0ooK^0?ofkP3D
?ATA0?ofkP<0e3dI0P3om^h00`3D?AT0ooK^0?ofkP070?ofkP030000003om^h0ooK^06X0ooK^0@3o
ool003P0ooK^0`00000j0?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h03@3om^h0
0`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^01@0ooK^00<0?EV[0?ofkP3om^h04@3om^h0
0`0mFJ/0ooK^0?ofkP0?0?ofkP@0?EV[3@3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0
ooK^00<0ooK^00<0?EV[0?ofkP3om^h00`3om^h0100mFJ/0ooK^03eIZ`3om^h203eIZ`030?ofkP0m
FJ/0ooK^00<0?EV[?@3om^h40=@m6@<0ooK^00<000000?ofkP3om^h00`3D?AT0103om^h0e3dI0=@m
6@3D?AT:0?ofkP<0e3dI1@3om^h30=@m6@h0ooK^0`3D?AT50?ofkP030=@m6@3om^h0ooK^00P0ooK^
00<000000?ofkP3om^h0J@3om^h10?ooo`00=P3om^h2000003`0ooK^00<0?EV[0?ofkP3om^h02@3o
m^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h04P3o
m^h00`0mFJ/0ooK^03eIZ`0C0?ofkP0303eIZ`3om^h0ooK^00`0ooK^0P0mFJ/20?ofkP0303eIZ`3o
m^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3o
m^h0ooK^00<0ooK^0P0mFJ/20?ofkP@0?EV[00<0ooK^03eIZ`0mFJ/0>`3om^h30=@m6@80ooK^0P3D
?AT30?ofkP040000003D?AT0ooK^0?ofkP80e3dI00<0ooK^0=@m6@3om^h01`3om^h30=@m6@H0ooK^
1@3D?AT<0?ofkP80e3dI2@3om^h00`3D?AT0ooK^0?ofkP080?ofkP030000003om^h0ooK^06P0ooK^
0@3oool003@0ooK^0P00000m0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h02P3o
m^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00l0ooK^0P0mFJ/30?ofkP0303eIZ`3o
m^h0ooK^0140ooK^00<0?EV[0?ofkP3om^h02@3om^h203eIZ`D0ooK^00<0?EV[0?ofkP3om^h0303o
m^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h00P3o
m^h01@0mFJ/0ooK^03eIZ`3om^h0?EV[0080ooK^1@0mFJ/g0?ofkP@0e3dI1P3om^h30=@m6@040000
003D?AT0e3dI0=@m6@<0ooK^00<0e3dI0?ofkP3om^h0103om^h20=@m6@H0ooK^0`3D?AT30?ofkP80
e3dI2@3om^h30=@m6@`0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`000000ooK^0?ofkP1X0?ofkP40
oooo000b0?ofkP800000?P3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00L0ooK^
0P0mFJ/;0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^
0?ofkP0@0?ofkP0303eIZ`3om^h0ooK^00H0ooK^0`0mFJ/70?ofkP0303eIZ`3om^h0ooK^00d0ooK^
00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00<0ooK^
0P0mFJ/20?ofkP0403eIZ`3om^h0ooK^0?ofkP@0?EV[=03om^h40=@m6@H0ooK^0P3D?AT0103om^h0
e3dI0=@m6@0000060?ofkP040=@m6@3om^h0ooK^0?ofkP<0e3dI1@3om^h30=@m6@L0ooK^00<0e3dI
0?ofkP3om^h0103om^h30=@m6@l0ooK^00<0e3dI0?ofkP3om^h0203om^h00`000000ooK^0?ofkP1W
0?ofkP40oooo000`0?ofkP800000@03om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^
00D0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^
00D0ooK^00<0?EV[0?ofkP3om^h04@3om^h00`0mFJ/0ooK^0?ofkP030?ofkP80?EV[2`3om^h00`0m
FJ/0ooK^0?ofkP0=0?ofkP0403eIZ`3om^h0ooK^0?ofkP80?EV[1`3om^h00`0mFJ/0ooK^0?ofkP03
0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/00`3om^h403eIZc00ooK^103D?AT20?ofkP040=@m6@3o
m^h0ooK^0?ofkP<0e3dI00<0ooK^0=@m6@3D?AT00P3om^h00`000000e3dI0?ofkP030?ofkP030=@m
6@3om^h0e3dI0080e3dI1P3om^h20=@m6@X0ooK^0P3D?AT20?ofkP<0e3dI4`3om^h00`3D?AT0ooK^
0?ofkP070?ofkP030000003om^h0ooK^06L0ooK^0@3oool002d0ooK^0`0000110?ofkP0303eIZ`3o
m^h0ooK^0100ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3o
m^h0ooK^00P0ooK^0P0mFJ/90?ofkP0303eIZ`3om^h0ooK^0140ooK^00<0?EV[0?ofkP3om^h00P0m
FJ/>0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP0mFJ/00P3om^h00`0mFJ/0ooK^0?of
kP050?ofkP0303eIZ`3om^h0ooK^0080ooK^0P0mFJ/30?ofkP0303eIZ`3om^h0ooK^0080?EV[00<0
ooK^03eIZ`0mFJ/0;@3om^h40=@m6@<0ooK^00<0e3dI0?ofkP3om^h00P3D?AT0103om^h0e3dI0=@m
6@3D?AT40?ofkP040000003om^h0e3dI0=@m6@80ooK^0P3D?AT60?ofkP<0e3dI303om^h40=@m6AL0
ooK^00<0e3dI0?ofkP3om^h01`3om^h00`000000ooK^0?ofkP1V0?ofkP40oooo000[0?ofkP800000
@`3om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/04P3om^h00`0mFJ/0
ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h04@3om^h203eIZa40
ooK^00<0?EV[0?ofkP3om^h03@3om^h203eIZ`<0ooK^00<0?EV[0?ofkP3om^h01@3om^h01`0mFJ/0
ooK^0?ofkP3om^h0?EV[0?ofkP0mFJ/00P3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[0080ooK^0P0m
FJ/Y0?ofkP@0e3dI1P3om^h60=@m6@L0ooK^00<000000?ofkP3om^h0103D?AT40?ofkP<0e3dI3P3o
m^h20=@m6@80ooK^00<0e3dI0?ofkP3om^h05@3om^h00`3D?AT0ooK^0?ofkP080?ofkP030000003o
m^h0ooK^06D0ooK^0@3oool002T0ooK^0P0000140?ofkP0303eIZ`3om^h0ooK^01@0ooK^00<0?EV[
0?ofkP0mFJ/0503om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[
0?ofkP3om^h03P3om^h203eIZ`030?ofkP0mFJ/0ooK^0100ooK^00<0?EV[0?ofkP3om^h03P3om^h0
1@0mFJ/0ooK^0?ofkP3om^h0?EV[00P0ooK^00H0?EV[0?ofkP3om^h0?EV[0?ofkP0mFJ/30?ofkP06
03eIZ`3om^h0ooK^0?ofkP0mFJ/0ooK^0`0mFJ/V0?ofkP@0e3dI1P3om^h20=@m6@030?ofkP3D?AT0
e3dI00X0ooK^00<000000=@m6@3D?AT00P3om^h20=@m6@040?ofkP3D?AT0e3dI0=@m6@h0ooK^0`3D
?AT01@3om^h0e3dI0?ofkP3om^h0e3dI01L0ooK^0P3D?AT90?ofkP030000003om^h0ooK^06D0ooK^
0@3oool002L0ooK^0P0000150?ofkP0303eIZ`3om^h0?EV[01H0ooK^00<0?EV[0?ofkP3om^h0503o
m^h0100mFJ/0ooK^0?ofkP3om^h203eIZa00ooK^00<0?EV[0?ofkP3om^h02`3om^h203eIZ`@0ooK^
00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP80?EV[103om^h00`0mFJ/0ooK^
0?ofkP050?ofkP0303eIZ`3om^h0?EV[00<0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`020?ofkP80
?EV[00<0ooK^03eIZ`0mFJ/08`3om^h50=@m6@D0ooK^1P3D?AT;0?ofkP030=@m6@000000ooK^00<0
ooK^0`3D?AT?0?ofkP80e3dI103om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI01@0ooK^0P3D?AT20?of
kP030=@m6@3om^h0ooK^00L0ooK^00<000000?ofkP3om^h0I03om^h10?ooo`009@3om^h2000004L0
ooK^00@0?EV[0?ofkP3om^h0?EV[503om^h00`0mFJ/0ooK^03eIZ`0F0?ofkP0303eIZ`3om^h0?EV[
01<0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^
00l0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^03eIZ`040?ofkP0303eIZ`3om^h0ooK^
00D0ooK^0P0mFJ/40?ofkP0:03eIZ`3om^h0ooK^0?ofkP0mFJ/0ooK^03eIZ`3om^h0?EV[0?ofkP80
?EV[803om^h40=@m6@030?ofkP3D?AT0e3dI00<0ooK^0P3D?AT01@3om^h0e3dI0=@m6@3om^h0e3dI
00T0ooK^0`3D?AT0103om^h000000?ofkP3om^h20=@m6@030?ofkP3D?AT0e3dI00`0ooK^0`3D?AT6
0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT04@3om^h30=@m6@@0ooK^00<0e3dI0?ofkP3om^h01`3o
m^h00`000000ooK^0?ofkP1T0?ofkP40oooo000S0?ofkP800000B03om^h00`0mFJ/0ooK^0?ofkP02
0?ofkP0303eIZ`3om^h0ooK^0100ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0F0?ofkP0303eIZ`3o
m^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h01P3om^h203eIZ`T0ooK^00<0?EV[0?ofkP3om^h03`3o
m^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0403eIZ`3om^h0ooK^03eIZ`@0ooK^00<0?EV[0?ofkP3om^h0
1`0mFJ/40?ofkP0403eIZ`3om^h0ooK^0?ofkP80?EV[00@0ooK^03eIZ`3om^h0ooK^0P0mFJ/L0?of
kPD0e3dI1@3om^h60=@m6@<0ooK^00<0e3dI0?ofkP3om^h01@3om^h20=@m6@@0ooK^00<000000=@m
6@3D?AT00`3om^h00`3D?AT0ooK^0=@m6@090?ofkP80e3dI2@3om^h00`3D?AT0ooK^0?ofkP020?of
kP030=@m6@3om^h0ooK^00`0ooK^0P3D?AT80?ofkP030=@m6@3om^h0ooK^00L0ooK^00<000000?of
kP3om^h0H`3om^h10?ooo`008@3om^h2000004X0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0
ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h04P3om^h00`0mFJ/0
ooK^03eIZ`0D0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0
ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h02@0mFJ/50?ofkPH0
?EV[00d0ooK^03eIZ`3om^h0ooK^03eIZ`3om^h0?EV[0?ofkP0mFJ/0ooK^03eIZ`3om^h0?EV[01T0
ooK^1@3D?AT40?ofkPL0e3dI103om^h00`3D?AT0ooK^0?ofkP030?ofkP<0e3dI103om^h20=@m6@03
0000003om^h0ooK^00<0ooK^00@0e3dI0?ofkP3om^h0e3dI1@3om^h30=@m6@/0ooK^00<0e3dI0?of
kP3om^h00`3om^h00`3D?AT0ooK^0?ofkP080?ofkP<0e3dI2P3om^h00`3D?AT0ooK^0?ofkP080?of
kP030000003om^h0ooK^0680ooK^0@3oool00240ooK^0P0000190?ofkP0303eIZ`3om^h0ooK^00D0
ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^0100
ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0D0?ofkP0303eIZ`3om^h0ooK^0080ooK^0P0mFJ/>0?of
kP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h01`3om^h403eIZ`<0ooK^00<0?EV[0?of
kP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0?EV[00<0ooK^100mFJ/00`3o
m^h0?EV[03eIZ`020?ofkP0303eIZ`3om^h0?EV[0080?EV[5@3om^h60=@m6@@0ooK^0P3D?AT00`3o
m^h0e3dI0=@m6@040?ofkP80e3dI0P3om^h0103D?AT0ooK^0?ofkP3om^h20=@m6@D0ooK^0P3D?AT2
0?ofkP030000003om^h0ooK^00<0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@020?ofkP80e3dI3@3o
m^h20=@m6@D0ooK^00<0e3dI0?ofkP3om^h01P3om^h20=@m6@h0ooK^00<0e3dI0?ofkP3om^h01`3o
m^h00`000000ooK^0?ofkP1R0?ofkP40oooo000Q0?ofkP030000003om^h0000004P0ooK^00<0?EV[
0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[
0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^0180ooK^00@0?EV[
0?ofkP0mFJ/0?EV[403om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0403eIZ`3om^h0ooK^0?ofkPD0?EV[
00<0ooK^03eIZ`3om^h01@3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^0080ooK^
00@0?EV[0?ofkP3om^h0?EV[103om^h00`0mFJ/0ooK^03eIZ`0203eIZ`<0ooK^00<0?EV[0?ofkP0m
FJ/00P0mFJ/B0?ofkPD0e3dI0P3om^h00`3D?AT0ooK^0=@m6@050=@m6@P0ooK^0`3D?AT00`3om^h0
e3dI0=@m6@040?ofkP<0e3dI1@3om^h00`000000ooK^0?ofkP020?ofkP040=@m6@3om^h0ooK^0?of
kP<0e3dI303om^h30=@m6@030?ofkP3D?AT0ooK^00D0ooK^00<0e3dI0?ofkP3om^h00P3om^h30=@m
6A00ooK^00<0e3dI0?ofkP3om^h0203om^h00`000000ooK^0?ofkP1Q0?ofkP40oooo000P0?ofkP05
0000003om^h0ooK^0?ofkP000000AP3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^
00T0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^
00D0ooK^00<0?EV[0?ofkP3om^h04P3om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP0303eIZ`3om^h0ooK^
00h0ooK^100mFJ/50?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h00P3om^h01@0m
FJ/0ooK^0?ofkP3om^h0?EV[0080ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP03
03eIZ`80ooK^00@0?EV[0?ofkP0mFJ/0?EV[3`3om^h50=@m6@@0ooK^1P3D?AT<0?ofkP<0e3dI103o
m^h20=@m6@P0ooK^00<000000?ofkP3om^h00P3om^h0103D?AT0ooK^0=@m6@3D?AT20?ofkP030=@m
6@3om^h0ooK^00P0ooK^0P3D?AT40?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h0
0P3D?ATD0?ofkP030=@m6@3om^h0ooK^00L0ooK^00<000000?ofkP3om^h0H@3om^h10?ooo`00803o
m^h00`000000ooK^0?ofkP020?ofkP800000@`3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3o
m^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3o
m^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h0403om^h00`0mFJ/0ooK^03eIZ`0C0?ofkP0303eIZ`3o
m^h0ooK^00/0ooK^0P0mFJ/20?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h01P3o
m^h00`0mFJ/0ooK^0?ofkP020?ofkP0403eIZ`3om^h0ooK^03eIZ`@0ooK^00<0?EV[0?ofkP3om^h0
0`3om^h0100mFJ/0ooK^03eIZ`3om^h403eIZ`80ooK^0P0mFJ/<0?ofkPD0e3dI103om^h50=@m6@`0
ooK^103D?AT00`3om^h0e3dI0?ofkP030=@m6@X0ooK^00@000000?ofkP3om^h0ooK^0`3D?AT40?of
kP030=@m6@3om^h0ooK^00D0ooK^0`3D?AT70?ofkP030=@m6@3om^h0ooK^00<0ooK^0`3D?ATG0?of
kP030=@m6@3om^h0ooK^00L0ooK^00<000000?ofkP3om^h0H03om^h10?ooo`00803om^h00`000000
ooK^0?ofkP040?ofkP030000003om^h0ooK^0400ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0
ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0
ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^00h0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0C0?of
kP0303eIZ`3om^h0ooK^00L0ooK^0`0mFJ/50?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?of
kP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0?EV[00D0ooK^00<0?EV[0?of
kP3om^h00`3om^h203eIZ`80ooK^00P0?EV[0?ofkP0mFJ/0?EV[0?ofkP0mFJ/0ooK^03eIZ`P0ooK^
1@3D?AT40?ofkPH0e3dI2`3om^h30=@m6@<0ooK^00@0e3dI0?ofkP3D?AT0e3dI3@3om^h010000000
ooK^0=@m6@3D?AT20?ofkP030=@m6@3om^h0ooK^00<0ooK^00@0e3dI0?ofkP3om^h0ooK^0`3D?AT:
0?ofkP040=@m6@3om^h0ooK^0?ofkP80e3dI0P3om^h00`3D?AT0ooK^0?ofkP0E0?ofkP030=@m6@3o
m^h0ooK^00P0ooK^00<000000?ofkP3om^h0G`3om^h10?ooo`00803om^h00`000000ooK^0?ofkP05
0?ofkP030000003om^h0ooK^03h0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP04
0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP09
0?ofkP0303eIZ`3om^h0ooK^00`0ooK^0P0mFJ/50?ofkP0303eIZ`3om^h0ooK^0140ooK^00<0?EV[
0?ofkP3om^h00`3om^h303eIZ`T0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0;0?ofkP0303eIZ`3o
m^h0ooK^0080ooK^0P0mFJ/60?ofkP0303eIZ`3om^h0ooK^0080ooK^00D0?EV[0?ofkP0mFJ/0ooK^
03eIZ`030?ofkP<0?EV[00<0ooK^03eIZ`3om^h0103om^h50=@m6@030?ofkP3D?AT0e3dI00<0e3dI
00D0ooK^0=@m6@3D?AT0ooK^0=@m6@0:0?ofkP80e3dI1@3om^h30=@m6@80ooK^00<0e3dI0?ofkP3o
m^h02@3om^h00`3D?AT000000=@m6@040?ofkP030=@m6@3om^h0ooK^00<0ooK^103D?AT=0?ofkP@0
e3dI103om^h00`3D?AT0ooK^0?ofkP0F0?ofkP030=@m6@3om^h0ooK^00L0ooK^00<000000?ofkP3o
m^h0G`3om^h10?ooo`007`3om^h00`000000ooK^0?ofkP070?ofkP030000003om^h0ooK^03d0ooK^
00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00l0ooK^
00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00X0ooK^
00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP0303eIZ`3om^h0ooK^0080?EV[
3@3om^h0100mFJ/0ooK^0?ofkP0mFJ/<0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3o
m^h01@3om^h00`0mFJ/0ooK^0?ofkP020?ofkP80?EV[0P3om^h0100mFJ/0ooK^0?ofkP3om^h303eI
Z`030?ofkP0mFJ/0ooK^00D0e3dI103om^h20=@m6@040?ofkP3D?AT0e3dI0=@m6@<0ooK^00<0e3dI
0?ofkP3om^h01@3om^h30=@m6@D0ooK^0P3D?AT00`3om^h0e3dI0?ofkP020?ofkP030=@m6@3om^h0
ooK^00L0ooK^0P3D?AT00`3om^h000000?ofkP040?ofkP030=@m6@3om^h0ooK^0080ooK^0`3D?AT>
0?ofkP80e3dI203om^h00`3D?AT0ooK^0?ofkP0E0?ofkP030=@m6@3om^h0ooK^00P0ooK^00<00000
0?ofkP3om^h0GP3om^h10?ooo`007`3om^h00`000000ooK^0?ofkP080?ofkP030000003om^h0ooK^
03/0ooK^00<0?EV[0?ofkP3om^h0403om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[0180ooK^00<0?EV[
0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[
0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP80?EV[403om^h203eIZ`030?ofkP0mFJ/0
ooK^00/0ooK^00@0?EV[0?ofkP3om^h0ooK^0P0mFJ/70?ofkP0303eIZ`3om^h0ooK^0080ooK^00D0
?EV[0?ofkP3om^h0ooK^03eIZ`030?ofkP<0?EV[00<0000003eIZ`3D?AT00P3D?AT30?ofkPH0e3dI
0`3om^h00`3D?AT0ooK^0=@m6@050?ofkP<0e3dI1@3om^h30=@m6@<0ooK^00<0e3dI0?ofkP3om^h0
0P3om^h00`3D?AT0ooK^0?ofkP030?ofkP<0e3dI0P3om^h2000000D0ooK^00<0e3dI0?ofkP3D?AT0
0P3D?AT30?ofkP030=@m6@3om^h0ooK^00P0ooK^0`3D?AT00`3om^h0e3dI0?ofkP070?ofkP030=@m
6@3om^h0ooK^01D0ooK^0P3D?AT90?ofkP030000003om^h0ooK^05h0ooK^0@3oool001l0ooK^00<0
00000?ofkP3om^h02@3om^h00`000000ooK^0?ofkP0j0?ofkP0303eIZ`3om^h0ooK^0140ooK^00<0
?EV[0?ofkP0mFJ/0503om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[0140ooK^00<0?EV[0?ofkP3om^h0
1P3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00h0ooK^0P0mFJ/00`3om^h0?EV[
0?ofkP0?0?ofkP80?EV[0P3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0?EV[0080ooK^
00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP020?ofkP80?EV[0`3om^h00`0mFJ/00000
0000000203eIZ`0401L60P0mFJ/0?EV[0=@m6@<0ooK^0P3D?AT00`3om^h0e3dI0=@m6@070?ofkP80
e3dI0P3om^h30=@m6@D0ooK^0`3D?AT60?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3o
m^h00P3D?AT30?ofkP8000000P3om^h010000000ooK^0?ofkP3om^h30=@m6@H0ooK^00<0e3dI0?of
kP3om^h01P3om^h20=@m6@D0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP0B0?of
kP80e3dI00<0ooK^0=@m6@3om^h02@3om^h00`000000ooK^0?ofkP1M0?ofkP40oooo000O0?ofkP03
0000003om^h0ooK^00X0ooK^00<000000?ofkP3om^h0>03om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP03
03eIZ`3om^h0ooK^01@0ooK^00<0?EV[0?ofkP0mFJ/04`3om^h00`0mFJ/0ooK^0?ofkP040?ofkP03
03eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h0303om^h203eIZ`@0ooK^00<0?EV[0?ofkP3o
m^h03@3om^h203eIZ`80ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^03eIZ`030?ofkP03
03eIZ`3om^h0ooK^00@0ooK^00L0?EV[0?ofkP3om^h0ooK^03eIZ`3om^h0?EV[00D0000000@05`H2
03eIZ`0mFJ/05`H20P0mFJ/00`000000e3dI0=@m6@030=@m6@X0ooK^0`3D?AT60?ofkP80e3dI2@3o
m^h00`3D?AT0ooK^0?ofkP030?ofkP<0e3dI0P3om^h3000000@0ooK^00H000000?ofkP3D?AT0e3dI
0?ofkP3D?AT80?ofkP030=@m6@3om^h0ooK^0080ooK^0`3D?AT70?ofkP030=@m6@3om^h0ooK^00H0
ooK^00<0e3dI0?ofkP3om^h03`3om^h30=@m6@@0ooK^00<0e3dI0?ofkP3om^h0203om^h00`000000
ooK^0?ofkP1L0?ofkP40oooo000N0?ofkP030000003om^h0ooK^00`0ooK^0P00000h0?ofkP80?EV[
4`3om^h00`0mFJ/0ooK^03eIZ`0F0?ofkP0303eIZ`3om^h0ooK^01<0ooK^00@0?EV[0?ofkP3om^h0
ooK^0P0mFJ/?0?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0
ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0?EV[0080ooK^00<0?EV[0?ofkP3om^h02P3om^h203eIZ`<0
ooK^00<0?EV[0?ofkP3om^h01@3om^h01P0mFJ/0ooK^0?ofkP0mFJ/0000003eIZ`8000001@0G1P80
1@0mFJ/000000000000]2`@0?EV[0080e3dI2`3om^h30=@m6@030?ofkP3D?AT0ooK^0080ooK^0`3D
?AT;0?ofkP030=@m6@3om^h0ooK^00<0e3dI0P3om^h3000000H0ooK^0P3D?AT01@000000ooK^0?of
kP3om^h0e3dI00P0ooK^00<0e3dI0?ofkP3om^h00P3D?AT:0?ofkP030=@m6@3om^h0ooK^00L0ooK^
00<0e3dI0?ofkP3om^h0303om^h20=@m6@L0ooK^00<0e3dI0?ofkP3om^h0203om^h00`000000ooK^
0?ofkP1L0?ofkP40oooo000N0?ofkP030000003om^h0ooK^00h0ooK^00<000000?ofkP3om^h0=03o
m^h0100mFJ/0ooK^0?ofkP0mFJ/B0?ofkP0403eIZ`3om^h0ooK^03eIZa@0ooK^00<0?EV[0?ofkP0m
FJ/05@3om^h00`0mFJ/0ooK^03eIZ`0B0?ofkP0303eIZ`3om^h0ooK^00L0ooK^0P0mFJ/80?ofkP03
03eIZ`3om^h0ooK^00/0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`020?ofkP0303eIZ`3om^h0ooK^
00T0ooK^0P0mFJ/40?ofkP0303eIZ`3om^h0ooK^00H0?EV[00H05@H203eIZ`0000005`H203eIZ`00
000201L60P<000000P0mFJ/302d;108000002@3om^h20=@m6@030?ofkP3D?AT0ooK^0080ooK^0`3D
?AT>0?ofkP<0e3dI0`3om^h2000000030?ofkP3D?AT0ooK^00@0ooK^0P3D?AT30?ofkP040000003o
m^h0ooK^0=@m6@P0ooK^0`3D?AT<0?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h0
203om^h30=@m6@X0ooK^00<0e3dI0?ofkP3om^h0203om^h00`000000ooK^0?ofkP1K0?ofkP40oooo
000N0?ofkP030000003om^h0ooK^00l0ooK^00<000000?ofkP3om^h0<`3om^h01@0mFJ/0ooK^0?of
kP3om^h0?EV[0100ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0503eI
Z`3om^h0ooK^0?ofkP0mFJ/05@3om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^00D0
ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^0080
ooK^00@0?EV[0?ofkP3om^h0?EV[2@3om^h:03eIZ`<0ooK^100000001@0mFJ/05`H201L60P0G1P80
?EV[008000000`0]2`@00`0mFJ/0;@/403eIZ`0202d;10030000000R:dd0ooK^00D0ooK^0`3D?AT3
0?ofkP060=@m6@3om^h0e3dI0=@m6@3om^h0e3dI3@3om^h30=@m6@80ooK^0`0000030?ofkP030=@m
6@3om^h0ooK^00<0e3dI1P3om^h010000000ooK^0?ofkP3D?AT40?ofkP<0e3dI0P3om^h00`3D?AT0
ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h01P3om^h20=@m6@d0
ooK^00<0e3dI0?ofkP3om^h02@3om^h00`000000ooK^0?ofkP1J0?ofkP40oooo000N0?ofkP030000
003om^h0ooK^0100ooK^00<000000?ofkP3om^h0<@3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eI
Z`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eI
Z`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h04@3om^h00`0mFJ/0ooK^03eIZ`0D0?ofkP0303eI
Z`3om^h0ooK^0080ooK^0P0mFJ/=0?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h0
103om^h01@0mFJ/0ooK^0?ofkP0mFJ/0ooK^00L0?EV[00D0ooK^03eIZ`3om^h0ooK^03eIZ`040?of
kP0303eIZ`0000000000008000000`0G1P801P0mFJ/05`H2000000000000;@/403eIZ`@0;@/400D0
?EV[02d;100]2`@0?EV[02d;1003000000<0ooK^0P3D?AT50?ofkP<0e3dI103om^h00`3D?AT0ooK^
0?ofkP070?ofkP<0e3dI0P3om^h3000000H0ooK^0`3D?AT90?ofkP040000003om^h0ooK^0=@m6@80
ooK^0P3D?AT50?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0
ooK^0?ofkP020?ofkP<0e3dI403om^h00`3D?AT0ooK^0?ofkP080?ofkP030000003om^h0ooK^05X0
ooK^0@3oool001h0ooK^00<000000?ofkP3om^h04@3om^h00`000000ooK^0?ofkP0`0?ofkP0303eI
Z`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eI
Z`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0503eI
Z`3om^h0ooK^0?ofkP0mFJ/0503om^h0100mFJ/0ooK^03eIZ`0mFJ/@0?ofkP0303eIZ`3om^h0ooK^
00H0ooK^00<0?EV[0?ofkP3om^h01@3om^h503eIZ`L0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0m
FJ/0ooK^0?ofkP020000000303eIZ`0G1P80000000<05`H200<0?EV[0000000000000`0]2`@00`00
0000?EV[02d;100302d;100503eIZ`0]2`@0000003eIZ`1?4`P00`0000020=@m6@D0ooK^0P3D?AT0
0`3om^h0e3dI0?ofkP050?ofkP030=@m6@3om^h0ooK^00@0ooK^0P3D?AT30?ofkP80000000<0e3dI
0?ofkP3om^h0103om^h20=@m6@80ooK^00<0e3dI0?ofkP3om^h0203om^h00`000000ooK^0=@m6@02
0=@m6@P0ooK^00<0e3dI0?ofkP3om^h02@3om^h20=@m6@X0ooK^00<0e3dI0?ofkP3om^h00P3D?ATC
0?ofkP030=@m6@3om^h0ooK^00T0ooK^00<000000?ofkP3om^h0F@3om^h10?ooo`007@3om^h00`00
0000ooK^0?ofkP0C0?ofkP030000003om^h0ooK^02h0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0m
FJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0m
FJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0m
FJ/0ooK^0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^0140ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0m
FJ/0ooK^0?ofkP030?ofkP80?EV[0P3om^h00`0mFJ/0ooK^03eIZ`070?ofkP0303eIZ`3om^h0ooK^
00<0ooK^0`000000203D?AT05`H203eIZ`0G1P80000001L60P000000?EV[1P0]2`@01`0mFJ/0;@/4
02d;100]2`@0000003eIZ`0000000P1?4`P00`0mFJ/0000002lnJP02000000@0ooK^0P3D?AT30?of
kP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h00`3D?AT20?ofkP<000000P3om^h0103D
?AT0ooK^0?ofkP3om^h30=@m6@D0ooK^00<0e3dI0?ofkP3om^h01P3om^h20=@m6@030000003D?AT0
ooK^00X0ooK^00<0e3dI0?ofkP3om^h01P3om^h20=@m6@030?ofkP3D?AT0ooK^00T0ooK^0`3D?ATE
0?ofkP030=@m6@3om^h0ooK^00T0ooK^00<000000?ofkP3om^h0F@3om^h10?ooo`007@3om^h00`00
0000ooK^0?ofkP0D0?ofkP030000003om^h0ooK^02d0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0m
FJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0m
FJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0m
FJ/0ooK^0?ofkP0@0?ofkP0303eIZ`3om^h0?EV[01<0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0m
FJ/0ooK^0?ofkP020?ofkP80?EV[1@3om^h00`0mFJ/0ooK^03eIZ`060?ofkP0303eIZ`3om^h0ooK^
00<000001P0G1P801@0mFJ/000000000000]2`@0?EV[00H0;@/400H0000003eIZ`000000000004lC
200mFJ/404lC200303eIZ`0_?VX00000008000000`3D?AT50?ofkP030=@m6@3om^h0ooK^00D0ooK^
0`3D?AT30?ofkP8000001@3om^h0103D?AT0ooK^0=@m6@3D?AT80?ofkP030=@m6@3om^h0ooK^00@0
ooK^0P3D?AT20?ofkP030000003D?AT0ooK^00X0ooK^00<0e3dI0?ofkP3om^h00`3om^h30=@m6@<0
ooK^00<0e3dI0?ofkP3om^h01@3om^h30=@m6@030?ofkP3D?AT0ooK^01H0ooK^00<0e3dI0?ofkP3o
m^h02@3om^h00`000000ooK^0?ofkP1H0?ofkP40oooo000M0?ofkP030000003om^h0ooK^01D0ooK^
0P00000]0?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^
0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^
0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h03@3om^h203eIZ`<0ooK^
00<0?EV[0?ofkP3om^h0403om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^0080?EV[
203om^h00`0mFJ/0ooK^03eIZ`050?ofkP0503eIZ`000000000001L60P000000100G1P8300000005
02d;100mFJ/0;@/402d;100mFJ/01@0]2`@30000000403eIZ`1?4`P0Ca<803eIZ`@0Ca<800<0?EV[
0000000_?VX00P3D?AT80?ofkP030=@m6@3om^h0ooK^0080ooK^0`3D?AT20?ofkP040=@m6@000000
0000000000H0ooK^0`3D?AT;0?ofkP030=@m6@3om^h0ooK^00<0e3dI1@3om^h00`000000ooK^0?of
kP0:0?ofkP030=@m6@3om^h0ooK^0080e3dI1`3om^h0103D?AT0ooK^0?ofkP3om^h30=@m6@D0ooK^
00<0e3dI0?ofkP3om^h0503om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030000003om^h0ooK^05L0ooK^
0@3oool001d0ooK^00<000000?ofkP3om^h05`3om^h00`000000ooK^0?ofkP0Y0?ofkP0303eIZ`3o
m^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3o
m^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP070?ofkP80?EV[2`3o
m^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h0403o
m^h01P0mFJ/0ooK^0?ofkP3om^h0?EV[0?ofkP80?EV[2P3om^h0100mFJ/0ooK^0?ofkP0mFJ/30?of
kP0303eIZ`000000e3dI00805`H200<0000001L60P0000000P00000402d;100403eIZ`0]2`@0;@/4
03eIZ`80;@/40`0000001`1?4`P0000004lC201?4`P0?EV[04lC200mFJ/01@1?4`P20=@m6@0302ln
JP000000000000L0ooK^00<0e3dI0?ofkP3om^h00P3D?AT30?ofkP<0000000<0e3dI0?ofkP3om^h0
103om^h20=@m6@030?ofkP3D?AT0ooK^00/0ooK^0`3D?AT80?ofkP030=@m6@000000ooK^00X0ooK^
0`3D?AT90?ofkP040=@m6@3om^h0e3dI0=@m6@P0ooK^00<0e3dI0?ofkP3om^h05@3om^h00`3D?AT0
ooK^0?ofkP090?ofkP030000003om^h0ooK^05L0ooK^0@3oool001`0ooK^00<000000?ofkP3om^h0
6@3om^h00`000000ooK^0?ofkP0X0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h0
0`3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h0
303om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h0
2@3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^0100ooK^00<0?EV[0?ofkP3om^h0
0P0mFJ/=0?ofkP0703eIZ`3om^h0ooK^03eIZ`3D?AT0000003eIZ`0301L60P<000001`0]2`@01000
0000?EV[0000000mFJ/2000000@0Ca<800@0000004lC201?4`P0Ca<80P0mFJ/404lC208000000`0_
?VX2000000H0ooK^0`3D?AT30?ofkP8000000`3om^h0103D?AT0ooK^0?ofkP3om^h30=@m6@<0ooK^
00<0e3dI0?ofkP3om^h01`3om^h30=@m6@80ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^
000000070?ofkP<0e3dI00<0ooK^0=@m6@3om^h0203om^h30=@m6@/0ooK^00<0e3dI0?ofkP3om^h0
503om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030000003om^h0ooK^05H0ooK^0@3oool001`0ooK^00<0
00000?ofkP3om^h06P3om^h00`000000ooK^0?ofkP0V0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0
?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0
?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0
?EV[0?ofkP3om^h01P3om^h203eIZ`X0ooK^00<0?EV[0?ofkP3om^h0403om^h203eIZ`h0ooK^0`00
00001P3D?AT0?EV[0000000G1P80?EV[01L60P80000000<0;@/40000000]2`@01P0]2`@300000080
?EV[1P1?4`P020000000Ca<804lC201?4`P0?EV[04lC200mFJ/0Ca<80P0000000`1`7@d000000000
000202lnJP8000000`3om^h40=@m6@80ooK^0`0000060?ofkP<0e3dI1P3om^h00`3D?AT0ooK^0?of
kP050?ofkP80e3dI1@3om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@000000ooK^00@0ooK^0P3D
?AT50?ofkP030=@m6@3om^h0ooK^00<0ooK^0`3D?AT00`3om^h0e3dI0?ofkP0;0?ofkP030=@m6@3o
m^h0ooK^01D0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`000000ooK^0?ofkP1F0?ofkP40oooo000L
0?ofkP030000003om^h0ooK^01/0ooK^00<000000?ofkP3om^h09@3om^h00`0mFJ/0ooK^0?ofkP0>
0?ofkP0403eIZ`3om^h0ooK^03eIZa80ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0A0?ofkP0503eI
Z`3om^h0ooK^0?ofkP0mFJ/04P3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00X0
ooK^00<0?EV[0?ofkP3om^h03P3om^h203eIZ`030?ofkP0mFJ/0ooK^00/0ooK^0P0000001@0E1P80
e3dI0=@m6@0G1P8000000080?EV[0P00000302d;10030000000]2`@0;@/400<0;@/40P0000001@1?
4`P0000004lC201?4`P0?EV[00L0Ca<800@0000004lC201?4`P0Ca<80P0mFJ/01`000000L1d=070M
3@1`7@d0000003aAT00000000P0_?VX200000080e3dI0`3om^h3000000L0ooK^0P3D?AT00`3om^h0
e3dI0?ofkP070?ofkP040=@m6@3om^h0ooK^0?ofkP<0e3dI203om^h00`3D?AT0ooK^0?ofkP060?of
kP040=@m6@3om^h000000?ofkP<0e3dI1`3om^h00`3D?AT0ooK^0?ofkP030=@m6@D0ooK^00<0e3dI
0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP80e3dI303om^h00`000000ooK^0?ofkP1E
0?ofkP40oooo000L0?ofkP030000003om^h0ooK^01`0ooK^00<000000?ofkP3om^h08`3om^h00`0m
FJ/0ooK^0?ofkP0@0?ofkP0303eIZ`3om^h0?EV[01<0ooK^00<0?EV[0?ofkP0mFJ/04`3om^h00`0m
FJ/0ooK^03eIZ`0D0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h0303om^h00`0m
FJ/0ooK^0?ofkP0;0?ofkP80?EV[0P3om^h00`0mFJ/0ooK^03eIZ`090?ofkP0301D60P0000000000
008000000P0G1P80100000005`H20000000mFJ/502d;10040000000]2`@0;@/402d;108000000`1?
4`P00`000000Ca<804lC200203eIZ`H0Ca<800H0000004lC200000000000070M3@0mFJ/4070M3@05
0000000lDI00?56@0000000_?VX00`0000020?ofkP80000000<0e3dI0?ofkP3om^h0103om^h30=@m
6@@0ooK^00<0e3dI0?ofkP3om^h01@3om^h40=@m6@`0ooK^00<0e3dI0?ofkP3om^h01@3om^h0103D
?AT0ooK^0=@m6@00000:0?ofkP<0e3dI203om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0
ooK^0100ooK^0`3D?AT00`3om^h0e3dI0?ofkP0<0?ofkP030000003om^h0ooK^05@0ooK^0@3oool0
01`0ooK^00<000000?ofkP3om^h07@3om^h00`000000ooK^0?ofkP0R0?ofkP0303eIZ`3om^h0ooK^
0140ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^
01@0ooK^00@0?EV[0?ofkP0mFJ/0?EV[403om^h00`0mFJ/0ooK^0?ofkP080?ofkP80?EV[0`3om^h0
1@0mFJ/0ooK^03eIZ`3om^h0?EV[00H0ooK^00@05@H20000000000000000100G1P830000000303eI
Z`0]2`@0?EV[00@0;@/400@0000002d;1000000000001@1?4`P00`000000Ca<803eIZ`0204lC2003
03eIZ`1?4`P0Ca<80080Ca<80`000003070M3@80?EV[0`1`7@d01`000000?56@03aAT0000000;ciZ
0000000_?VX00`0000020?ofkP040=@m6@3om^h0ooK^0?ofkP<0e3dI1`3om^h00`3D?AT0ooK^0?of
kP040?ofkP80e3dI3`3om^h00`3D?AT0ooK^0?ofkP040?ofkP<0e3dI0P3om^h00`000000ooK^0?of
kP040?ofkP<0e3dI00<0ooK^0=@m6@3om^h0203om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3o
m^h0ooK^00`0ooK^0`3D?AT50?ofkP030=@m6@3om^h0ooK^00X0ooK^00<000000?ofkP3om^h0E03o
m^h10?ooo`006`3om^h00`000000ooK^0?ofkP0O0?ofkP8000008P3om^h203eIZa80ooK^0P0mFJ/C
0?ofkP0303eIZ`3om^h0?EV[01<0ooK^00<0?EV[0?ofkP0mFJ/05P3om^h00`0mFJ/0ooK^0?ofkP0A
0?ofkP0303eIZ`3om^h0ooK^00D0ooK^0P0mFJ/40?ofkP0403eIZ`3om^h0ooK^0?ofkP80?EV[0`3o
m^h00`0000005@H200000002000000<05`H20`000000100]2`@0000002d;100mFJ/202d;100303eI
Z`0]2`@0;@/400<00000201?4`P01@000000?EV[04lC201?4`P0?EV[0080Ca<80P0000000`1`7@d0
0000070M3@03070M3@0303eIZ`1`7@d0?EV[00<0L1d=00<0000003aAT00lDI000`0000000`0_?VX0
00000?ofkP020?ofkP040=@m6@3om^h0e3dI0=@m6@/0ooK^00<0e3dI0?ofkP3om^h00`3D?AT00`3o
m^h0e3dI0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00<0e3dI00<0ooK^0=@m6@3om^h00P3om^h00`00
0000ooK^0?ofkP020?ofkP80e3dI1@3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^
00/0ooK^00<0e3dI0?ofkP3om^h02P3om^h20=@m6@P0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`00
0000ooK^0?ofkP1C0?ofkP40oooo000K0?ofkP030000003om^h0ooK^0240ooK^00<000000?ofkP3o
m^h07`3om^h00`0mFJ/0ooK^03eIZ`0@0?ofkP0403eIZ`3om^h0ooK^03eIZa80ooK^00@0?EV[0?of
kP3om^h0?EV[4@3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[01@0ooK^00<0?EV[0?ofkP0mFJ/04`3o
m^h00`0mFJ/0ooK^0?ofkP020?ofkP80?EV[1P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`00
0000000000<000000P0G1P84000000@0;@/400<0000003eIZ`0]2`@00`0]2`@0100mFJ/0000004lC
2000000904lC20070000000mFJ/0Ca<804lC20000000?EV[00000003070M3@030000001`7@d0L1d=
0080L1d=00<0?EV[070M3@0mFJ/00`1`7@d30000000703aAT0000000000002lnJP0000008R]=0?of
kP030=@m6@d0ooK^0`3D?AT40?ofkP030=@m6@3om^h0ooK^00h0ooK^0`3D?AT40?ofkP030=@m6@3o
m^h0ooK^0080ooK^00@000000=@m6@3D?AT0e3dI1`3om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m
6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h01P3om^h30=@m6@X0ooK^00<0e3dI0?ofkP3om^h0
2`3om^h00`000000ooK^0?ofkP1C0?ofkP40oooo000K0?ofkP030000003om^h0ooK^0280ooK^00<0
00000?ofkP3om^h07@3om^h0100mFJ/0ooK^0?ofkP3om^h203eIZ`h0ooK^00D0?EV[0?ofkP3om^h0
ooK^03eIZ`0@0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0
ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^0100ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0C0?of
kP0403eIZ`3om^h0?EV[03eIZ`L0ooK^00<0?EV[0?ofkP3om^h0100000000`0mFJ/0000001L60P02
01L60P<000001P0]2`@010000000;@/403eIZ`0]2`@30000000404lC200mFJ/0Ca<8000000T0Ca<8
00@0?EV[04lC2000000000000P1`7@d01@0mFJ/0L1d=070M3@1`7@d0000000@0L1d=00@0?EV[070M
3@1`7@d0?EV[0`00000403aAT0030000000_?VX0;ciZ0080e3dI00<0ooK^0=@m6@3om^h02`3om^h2
0=@m6@80ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP<0e3dI00<0ooK^
0=@m6@3om^h01@3om^h00`3D?AT0ooK^0=@m6@020=@m6@030000003om^h0ooK^00P0ooK^00<0e3dI
0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00<0ooK^0`3D?AT>
0?ofkP030=@m6@3om^h0ooK^00/0ooK^00<000000?ofkP3om^h0DP3om^h10?ooo`006`3om^h00`00
0000ooK^0?ofkP0S0?ofkP030000003om^h0ooK^01`0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0m
FJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0m
FJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0m
FJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h04@3om^h00`0m
FJ/0ooK^0?ofkP060?ofkP0403eIZ`3om^h0000001D60P@0000000<05`H203eIZ`0G1P800P000000
0`0]2`@0000002d;100602d;10040000000mFJ/00000000000D0Ca<800<0?EV[0000001?4`P01`1?
4`P00`000000?EV[00000005070M3@0403eIZ`1`7@d0L1d=000000@0L1d=00L0?EV[070M3@000000
000003eIZ`1`7@d0000000@0?56@0`3D?AT3000000030=@m6@3om^h0ooK^00L0ooK^0`3D?AT40?of
kP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h02@3om^h20=@m6@D0ooK^00<0e3dI0?of
kP3om^h00`3om^h20=@m6@<0ooK^00<000000?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP060?of
kP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3D?AT00P3D?ATA0?ofkP030=@m6@3om^h0ooK^
00`0ooK^00<000000?ofkP3om^h0D@3om^h10?ooo`006P3om^h00`000000ooK^0?ofkP0U0?ofkP03
0000003om^h0ooK^01/0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP090?ofkP03
03eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP050?ofkP03
03eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP03
03eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^03eIZ`060?ofkP03
03eIZ`0000005@H200<0000000H05`H20000000G1P805`H20000000mFJ/302d;10030000000]2`@0
;@/400@0;@/40P0000000`0mFJ/0Ca<804lC200604lC200303eIZ`1?4`P0Ca<800@0Ca<80P000000
0`1`7@d0?EV[070M3@06070M3@0403eIZ`1`7@d0L1d=00000080L1d=0`000003070M3@0403eIZ`00
0000?56@03aAT080e3dI0P00000202lnJP80000000<0e3dI0?ofkP3om^h01@3om^h20=@m6@P0ooK^
00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP050?ofkP<0e3dI1`3om^h00`3D?AT0ooK^
0?ofkP040=@m6@D0ooK^00<000000?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m
6@3om^h0ooK^00/0ooK^0`3D?ATD0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<000000?ofkP3om^h0
D@3om^h10?ooo`006P3om^h00`000000ooK^0?ofkP0V0?ofkP030000003om^h0ooK^01X0ooK^00<0
?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0
?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP070?ofkP80?EV[2@3om^h00`0mFJ/0ooK^0?of
kP080?ofkP80?EV[2`3om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00d0ooK^00D0
?EV[0?ofkP3om^h0ooK^03eIZ`040?ofkP0303eIZ`0E1P800000008000000`0G1P8300000080;@/4
00<0?EV[02d;100000001@0]2`@20000000304lC200mFJ/0Ca<800P0Ca<800@0?EV[04lC201?4`P0
Ca<80`000002070M3@0303eIZ`000000L1d=00H0L1d=00<0?EV[070M3@1`7@d00`000000100mFJ/0
L1d=070M3@1`7@d20000000408/U40000000e3dI0=@m6@80?56@00P0000003aAT0000000;ciZ0000
000_?VX0e3dI000000<0ooK^0`3D?AT;0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT0103om^h30=@m
6@X0ooK^0`3D?AT30?ofkP030=@m6@3om^h0ooK^00@0ooK^00<000000?ofkP3om^h01`3om^h00`3D
?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00L0ooK^0`3D?AT00`3om^h0e3dI0?ofkP0E0?of
kP030=@m6@3om^h0ooK^00`0ooK^00<000000?ofkP3om^h0D03om^h10?ooo`006P3om^h00`000000
ooK^0?ofkP0W0?ofkP030000003om^h0ooK^01P0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0
ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00L0ooK^0P0mFJ/90?ofkP0303eIZ`3om^h0ooK^00T0
ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00L0
ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP80?EV[1@3om^h01`0mFJ/0
ooK^0000000E1P80?EV[0=@m6@0000000`0G1P83000000@0;@/400<0?EV[02d;100000000`0]2`@2
000000<0Ca<800<0?EV[04lC201?4`P01`1?4`P010000000?EV[000000000005070M3@0303eIZ`00
0000L1d=00L0L1d=0`000002070M3@0403eIZ`0000000000000000<0RbD@00<0000004EP[P000000
0P0lDI000`000000?56@03aAT0020000000302lnJP3D?AT0000000<0e3dI3P3om^h01P3D?AT0ooK^
0?ofkP3om^h0e3dI0?ofkP<0e3dI2P3om^h30=@m6@030?ofkP3D?AT0ooK^00<0ooK^00<0e3dI0?of
kP3om^h01@3om^h00`000000ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?of
kP3om^h0103om^h30=@m6@D0ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP0<0?of
kP030000003om^h0ooK^0500ooK^0@3oool001X0ooK^00<000000?ofkP3om^h0:03om^h2000001P0
ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00T0
ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00@0
ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00X0
ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP050?ofkP<0000000<0?EV[01L60P00
00000P0G1P820000000302d;10000000;@/400D0;@/400<0?EV[0000000]2`@00P00000404lC2003
03eIZ`000000Ca<800L0Ca<80`0000000`0mFJ/0L1d=070M3@04070M3@0303eIZ`000000L1d=00@0
L1d=0`0000001P1`7@d0?EV[0000001`7@d0000003eIZ`H0RbD@00@0000004EP[P15H:h000000P0l
DI0020000000?56@03aAT0000000;ciZ0=@m6@0_?VX000004@3om^h00`3D?AT0ooK^0=@m6@020=@m
6@/0ooK^0P3D?AT50?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT01`3om^h00`000000ooK^0?ofkP07
0?ofkP030=@m6@3om^h0ooK^00@0ooK^0P3D?AT40?ofkP80e3dI203om^h00`3D?AT0ooK^0?ofkP0D
0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<000000?ofkP3om^h0C`3om^h10?ooo`006@3om^h00`00
0000ooK^0?ofkP0[0?ofkP030000003om^h0ooK^01D0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0m
FJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0m
FJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0m
FJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0m
FJ/0ooK^0?ofkP030?ofkP@0000000<05`H203eIZ`0G1P801000000202d;10030000000]2`@0;@/4
00D0;@/400<0000003eIZ`0000001P1?4`P00`0mFJ/0000004lC200504lC2080000000D0L1d=0000
001`7@d0L1d=03eIZ`04070M3@0303eIZ`1`7@d000000080L1d=0`000004070M3@050000000mFJ/0
000008/U400mFJ/01P2;9A0010000000AF2^04EP[P00000203aAT0030000000lDI00?56@00800000
00@0e3dI03eIZ`0_?VX000003`3om^h30=@m6@030?ofkP3D?AT0ooK^00P0ooK^0`3D?AT70?ofkP03
0=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h01@3om^h00`000000ooK^0?ofkP070?ofkP03
0=@m6@3om^h0ooK^00<0e3dI00<0ooK^0=@m6@3om^h00`3D?AT:0?ofkP030=@m6@3om^h0ooK^01@0
ooK^00<0e3dI0?ofkP3om^h03@3om^h00`000000ooK^0?ofkP1>0?ofkP40oooo000I0?ofkP030000
003om^h0ooK^02`0ooK^00<000000?ofkP3om^h0503om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP80?EV[
0`3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h0
3P3om^h0100mFJ/0ooK^0?ofkP0mFJ/B0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/0403om^h00`0m
FJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00@0000000D0e3dI0000000G1P805`H203eIZ`03
000000D0;@/400<0000002d;100]2`@00P0]2`@30000000304lC20000000?EV[00D0Ca<800<0?EV[
04lC200000000`1?4`P3000000<0L1d=00D00000070M3@1`7@d0L1d=03eIZ`03070M3@0303eIZ`1`
7@d0000000800000101`7@d3000000050=@m6@000000?EV[08/U400mFJ/01P2;9A001`000000AF2^
04EP[P15H:h0000003aAT00000000`0lDI0010000000;ciZ0=@m6@0_?VX2000000`0ooK^0P3D?AT2
0?ofkP030=@m6@3om^h0e3dI00H0ooK^0`3D?AT;0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT0203o
m^h00`000000ooK^0?ofkP060?ofkP<0e3dI0`3om^h30=@m6@h0ooK^00<0e3dI0?ofkP3om^h04`3o
m^h00`3D?AT0ooK^0?ofkP0=0?ofkP030000003om^h0ooK^04h0ooK^0@3oool001T0ooK^00<00000
0?ofkP3om^h0;@3om^h00`000000ooK^0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00@0?EV[
0?ofkP3om^h0?EV[3`3om^h0100mFJ/0ooK^0?ofkP0mFJ/B0?ofkP0303eIZ`3om^h0?EV[01<0ooK^
00<0?EV[0?ofkP0mFJ/04P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0000000<00000
00H0e3dI0000000000005`H20000000mFJ/2000000H0;@/400<0000002d;100000000`00000404lC
20030000001?4`P0?EV[00@0Ca<800@0?EV[04lC20000000Ca<80P000006070M3@030000001`7@d0
L1d=0080L1d=00<0?EV[070M3@1`7@d00`000004070M3@800000102;9A0010000000?EV[08/U400m
FJ/608/U400300000015H:h0AF2^0080AF2^0P00000303aAT080000000<0e3dI03eIZ`0000000P00
00080?ofkP<0e3dI1@3om^h00`3D?AT0ooK^0=@m6@030?ofkP80e3dI3P3om^h01@3D?AT0ooK^0?of
kP3om^h0e3dI00P0ooK^00<000000?ofkP3om^h00`3om^h30=@m6@030?ofkP3D?AT0ooK^00<0e3dI
0P3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^01@0ooK^00<0e3dI0?ofkP3om^h0
3@3om^h00`000000ooK^0?ofkP1=0?ofkP40oooo000I0?ofkP030000003om^h0ooK^02h0ooK^00<0
00000?ofkP3om^h04@3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP80?EV[4@3om^h00`0mFJ/0ooK^03eI
Z`0C0?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h04P3om^h00`0mFJ/0ooK^0?of
kP0203eIZ`@000000P0G1P840000000402d;100mFJ/0;@/4000000D0;@/40`00000804lC20040000
001?4`P0Ca<803eIZ`80Ca<800<0?EV[04lC200000000P000008070M3@030000001`7@d0L1d=00<0
L1d=0P000002070M3@030000001`7@d00000008000001P2;9A0010000000RbD@03eIZ`0mFJ/608/U
400300000015H:h0AF2^00<0AF2^00L0000003aAT00lDI00?56@0000000lDI00e3dI0080;ciZ0`00
00040?ofkP<0e3dI203om^h00`3D?AT0ooK^0=@m6@030=@m6A40ooK^00@0e3dI0?ofkP3om^h0e3dI
2@3om^h00`000000ooK^0=@m6@020=@m6@<0ooK^0`3D?AT50?ofkP030=@m6@3om^h0ooK^00`0ooK^
00<0e3dI0?ofkP3om^h04`3om^h20=@m6A00ooK^00<000000?ofkP3om^h0C03om^h10?ooo`006@3o
m^h00`000000ooK^0?ofkP0_0?ofkP030000003om^h0ooK^0100ooK^00<0?EV[0?ofkP3om^h03`3o
m^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0303eIZ`3om^h0ooK^0140ooK^00<0?EV[0?ofkP0mFJ/04`3o
m^h00`0mFJ/0ooK^03eIZ`0D0?ofkP80?EV[1000000201L60P<000000`0]2`@00`0mFJ/0;@/40000
000402d;1080000000<0Ca<80000001?4`P01`1?4`P00`000000Ca<804lC200204lC200603eIZ`1?
4`P0?EV[0000001`7@d000002@1`7@d00`000000L1d=070M3@0300000003070M3@0mFJ/0L1d=00<0
00002@2;9A0010000000RbD@08/U400mFJ/608/U400300000015H:h0AF2^00<0AF2^0P00000203aA
T0090000000lDI00e3dI0000000mFJ/0000002lnJP000000ooK^00<0e3dI2`3om^h30=@m6A@0ooK^
00@0e3dI0?ofkP3om^h0e3dI203om^h20=@m6@040000003om^h0ooK^0?ofkP<0e3dI00<0ooK^0=@m
6@3om^h01@3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00l0ooK^0`3D?AT00`3o
m^h0e3dI0?ofkP0?0?ofkP030000003om^h0ooK^04`0ooK^0@3oool001P0ooK^00<000000?ofkP3o
m^h0<@3om^h00`000000ooK^0?ofkP0?0?ofkP80?EV[403om^h203eIZa40ooK^0P0mFJ/B0?ofkP04
03eIZ`3om^h0ooK^03eIZa40ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0B0?ofkP<0000000@0e3dI
0000000000005`H20`00000402d;100403eIZ`0]2`@0;@/400000080;@/40P00000304lC20030000
001?4`P0Ca<800H0Ca<800@0000004lC201?4`P0Ca<80P0000001@0mFJ/0L1d=070M3@1`7@d00000
00T0L1d=0`000003070M3@0503eIZ`000000?EV[0=@m6@0000002P2;9A000`000000RbD@08/U4002
03eIZ`D0RbD@00<0000004EP[P15H:h00`15H:h200000080?56@00L0000003aAT03D?AT0000002ln
JP000000;ciZ0080e3dI303om^h20=@m6@030?ofkP3D?AT0e3dI01D0ooK^00@0e3dI0?ofkP3om^h0
e3dI103om^h30=@m6@<0ooK^00<000000=@m6@3D?AT01@3om^h00`3D?AT0ooK^0?ofkP040?ofkP03
0=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h0303om^h30=@m6@D0ooK^00<0e3dI0?ofkP3o
m^h03P3om^h00`000000ooK^0?ofkP1;0?ofkP40oooo000H0?ofkP030000003om^h0ooK^0380ooK^
0P00000?0?ofkP0303eIZ`3om^h0?EV[00h0ooK^00@0?EV[0?ofkP3om^h0?EV[3`3om^h0100mFJ/0
ooK^0?ofkP0mFJ/@0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0m
FJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00/0ooK^1P0000000`0G1P800000000000020000
0080;@/400T0000002d;100]2`@0;@/403eIZ`0]2`@0?EV[0000000]2`@00P00000504lC20030000
001?4`P0Ca<800H0Ca<800P0000004lC200000000000070M3@0mFJ/0L1d=03eIZ`80L1d=00<00000
070M3@1`7@d01@1`7@d3000000<0L1d=0P0000001@0mFJ/0RbD@08/U400mFJ/0000000T0RbD@00@0
000008/U402;9A00?EV[0P2;9A000`0mFJ/0RbD@08/U400208/U400300000015H:h0AF2^00<0AF2^
00<0000004EP[P0000000P0lDI000`000000e3dI03aAT0030=@m6@0302lnJP000000000000P0ooK^
0`3D?AT40?ofkP030=@m6@3om^h0ooK^01<0ooK^00D0e3dI0?ofkP3om^h0e3dI0?ofkP030=@m6@@0
ooK^0P3D?AT00`000000ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3o
m^h03@3om^h00`3D?AT0ooK^0?ofkP090?ofkP80e3dI203om^h00`3D?AT0ooK^0?ofkP0>0?ofkP03
0000003om^h0ooK^04/0ooK^0@3oool001P0ooK^00<000000?ofkP3om^h0=03om^h00`000000ooK^
0?ofkP0<0?ofkP0403eIZ`3om^h0ooK^03eIZ`d0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0>0?of
kP0503eIZ`3om^h0ooK^0?ofkP0mFJ/03`3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0
ooK^00`0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP070?ofkP<0000000@05@H2
0=@m6@3D?AT000000P0G1P82000000@0;@/400D0000002d;100]2`@0;@/403eIZ`0202d;10030000
000mFJ/0000000H0Ca<800<0000004lC201?4`P01P1?4`P300000080L1d=00L0?EV[070M3@1`7@d0
L1d=03eIZ`1`7@d0000000@0L1d=0`000002070M3@060000001`7@d000000000002;9A00?EV[0`2;
9A000`0mFJ/0000008/U400808/U40040000002;9A00RbD@03eIZ`<0RbD@00<0?EV[08/U402;9A00
0P00000504EP[P0500000015H:h0AF2^0000000lDI000`3D?AT00`0lDI0000000000000202lnJP80
00001@3om^h20=@m6@L0ooK^00<0e3dI0?ofkP3om^h0503om^h40=@m6@@0ooK^0`3D?AT30?ofkP03
0000003om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP03
0=@m6@3om^h0ooK^00H0ooK^0`3D?AT;0?ofkP030=@m6@3om^h0ooK^00h0ooK^00<000000?ofkP3o
m^h0BP3om^h10?ooo`00603om^h00`000000ooK^0?ofkP0e0?ofkP030000003om^h0ooK^00/0ooK^
00D0?EV[0?ofkP3om^h0ooK^03eIZ`0<0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3o
m^h02P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3o
m^h01@3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3o
m^h0103om^h2000000805@H20P3D?AT00`0G1P80000001L60P02000000H0;@/400@0000002d;100]
2`@0?EV[0`0000000`1?4`P0000003eIZ`0604lC20030000001?4`P0Ca<800@0Ca<80P0000000`1`
7@d00000070M3@02070M3@0303eIZ`1`7@d0L1d=0080L1d=00<0?EV[070M3@1`7@d00`000004070M
3@<000000`2;9A000`0mFJ/0RbD@08/U400208/U400303eIZ`2;9A00RbD@00L0RbD@00@0000008/U
402;9A00?EV[0`2;9A00100mFJ/000000000002P;1<2000000@0AF2^00<0000004EP[P3D?AT00P3D
?AT00`000000e3dI03aAT00203aAT0030000000_?VX0;ciZ00<0000000@0ooK^0=@m6@3D?AT0e3dI
2P3om^h00`3D?AT0ooK^0?ofkP0A0?ofkP<0e3dI00<0ooK^0=@m6@3om^h00P3om^h20=@m6@L0ooK^
00<000000?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00`0ooK^
00<0e3dI0?ofkP3om^h00`3om^h30=@m6@h0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`000000ooK^
0?ofkP190?ofkP40oooo000G0?ofkP030000003om^h0ooK^03L0ooK^00<000000?ofkP3om^h02P3o
m^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h00`3o
m^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h02@3o
m^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h0203o
m^h0100mFJ/0ooK^0?ofkP3om^h20000000501D60P00000000000000000G1P80100000000`0]2`@0
000002d;100402d;10050000000]2`@0000003eIZ`0000000`1?4`P010000000Ca<804lC200mFJ/5
04lC20040000001?4`P0Ca<804lC20<000000`1`7@d010000000L1d=070M3@0mFJ/5070M3@0303eI
Z`000000000000@0L1d=0`0000000`3D?AT0000008/U400208/U400303eIZ`2;9A00RbD@00<0RbD@
00<0000003eIZ`2;9A001`2;9A000`000000RbD@03eIZ`0208/U4080000000L0X2`C03eIZ`2P;1<0
X2`C0000001;J/<0000000<0AF2^0P3D?AT204EP[P80000000@0e3dI03aAT00lDI00?56@0P000002
02lnJP80000000<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP<0e3dI0`3om^h0
0`3D?AT0ooK^0=@m6@020=@m6@X0ooK^00<000000?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP03
0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3D?AT00P3D?ATB0?ofkP030=@m6@3om^h0
ooK^00h0ooK^00<000000?ofkP3om^h0B@3om^h10?ooo`005`3om^h00`000000ooK^0?ofkP0h0?of
kP030000003om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP070?of
kP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP050?of
kP80?EV[2@3om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?of
kP3om^h02@3om^h01@0mFJ/00000000000000000e3dI008000000P0G1P8300000080;@/400<00000
02d;100]2`@00`0]2`@30000000303eIZ`1?4`P0Ca<800<0Ca<800D0000004lC201?4`P0Ca<803eI
Z`0404lC20040000001?4`P00000000000H0L1d=00<00000070M3@0mFJ/0101`7@d30000000403eI
Z`1`7@d0L1d=070M3@800000102;9A001@000000RbD@08/U402;9A00?EV[00D0RbD@00<0000008/U
400mFJ/01`2;9A000`000000RbD@03eIZ`02000000@0X2`C00<0?EV[0:0/4`0000000P1;J/<30=@m
6@0300000015H:h0AF2^0080AF2^00<0000003aAT03D?AT00P0lDI0010000000?56@0000000_?VX3
000000d0ooK^0P3D?AT<0?ofkP<0e3dI1@3om^h40=@m6@`0ooK^00<000000?ofkP3om^h0103om^h0
0`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00`0ooK^0`3D?ATE0?ofkP030=@m6@3om^h0
ooK^00l0ooK^00<000000?ofkP3om^h0B03om^h10?ooo`005`3om^h00`000000ooK^0?ofkP0i0?of
kP030000003om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP060?of
kP0303eIZ`3om^h0ooK^00H0ooK^0P0mFJ/70?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?of
kP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?of
kP3om^h0203om^h4000000030=@m6@0G1P80000000805`H20`00000402d;10040000000]2`@0;@/4
02d;1080000000<0Ca<80000000mFJ/01P1?4`P00`000000Ca<804lC200204lC200303eIZ`1?4`P0
Ca<800<00000201`7@d00`000000?EV[070M3@02070M3@8000000P1`7@d00`000000L1d=03eIZ`02
000000H0RbD@00@0000008/U402;9A00?EV[1P2;9A0010000000RbD@08/U400mFJ/508/U40<00000
00<0?EV[0:0/4`2P;1<01@2P;1<01@0mFJ/000000=@m6@3D?AT000000080AF2^00<0000004EP[P15
H:h00P15H:h2000000090=@m6@0lDI00?56@0000000lDI00000002lnJP000000;ciZ00800000303o
m^h20=@m6@X0ooK^0P3D?AT50?ofkP<0e3dI00@0ooK^0=@m6@3om^h0e3dI3@3om^h00`000000ooK^
0?ofkP030?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h0203om^h30=@m6@030?of
kP3D?AT0ooK^01D0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`000000ooK^0?ofkP180?ofkP40oooo
000G0?ofkP030000003om^h0ooK^03X0ooK^00<000000?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?of
kP060?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?of
kP040?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?of
kP0;0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h01P3om^h4000000<05`H200<0
000001L60P0000000`00000502d;10030000000]2`@0;@/4008000000P1?4`P00`000000?EV[04lC
200604lC20030000001?4`P0Ca<80080Ca<800D0000003eIZ`000000L1d=00000008070M3@030000
000mFJ/0L1d=00<000000`1`7@d30000000308/U400mFJ/0RbD@00H0RbD@00@0000008/U402;9A00
?EV[1P2;9A0010000000RbD@08/U400mFJ/308/U4080000000<0X2`C0000000mFJ/0202P;1<00`0m
FJ/0e3dI04]Z``0204]Z``0300000015H:h0000000@0AF2^00<0000004EP[P3D?AT00P0lDI000`00
0000?56@03aAT0020000000402lnJP000000?EV[000000/0ooK^00<0e3dI0?ofkP3D?AT01P3om^h3
0=@m6@@0ooK^0`3D?AT50?ofkP80e3dI3P3om^h00`000000ooK^0?ofkP030?ofkP030=@m6@3om^h0
ooK^00<0ooK^00<0e3dI0?ofkP3om^h01P3om^h20=@m6@D0ooK^00<0e3dI0?ofkP3om^h0503om^h0
0`3D?AT0ooK^0?ofkP0?0?ofkP030000003om^h0ooK^04L0ooK^0@3oool001L0ooK^00<000000?of
kP3om^h0>`3om^h2000000H0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP030?of
kP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP0:0?of
kP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP020?of
kP0303eIZ`3om^h0ooK^00D0ooK^1@00000201L60P@000000P0]2`@00`000000;@/402d;100402d;
10<00000101?4`P00`0mFJ/0Ca<804lC200504lC20030000001?4`P0000000<0000000D0L1d=03eI
Z`1`7@d0L1d=00000008070M3@<00000101`7@d20000000308/U40000000RbD@0080RbD@00<0?EV[
08/U402;9A00102;9A000`000000RbD@03eIZ`0708/U40050000002;9A00RbD@08/U400mFJ/00P00
00030:0/4`030000000mFJ/0X2`C00P0X2`C00<0000004]Z``1;J/<00P1;J/<2000000@0AF2^00@0
000004EP[P3D?AT000000P0lDI000`000000?56@03aAT0020000000402lnJP000000?EV[000000/0
ooK^0P3D?AT30?ofkP<0e3dI0`3om^h40=@m6@P0ooK^00<0e3dI0?ofkP3D?AT03@3om^h00`000000
ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h00`3om^h30=@m6@L0
ooK^00<0e3dI0?ofkP3om^h0503om^h00`3D?AT0ooK^0?ofkP0@0?ofkP030000003om^h0ooK^04H0
ooK^0@3oool001H0ooK^00<000000?ofkP3om^h0?P3om^h00`000000ooK^0?ofkP030?ofkP0303eI
Z`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0503eI
Z`3om^h0ooK^0?ofkP0mFJ/03P3om^h0100mFJ/0ooK^0?ofkP0mFJ/@0?ofkP0503eIZ`3om^h0ooK^
0?ofkP0mFJ/01@3om^h30000000401L60P0000005`H201L60P<00000100]2`@00`000000;@/402d;
100302d;10<000001@1?4`P00`0mFJ/0000004lC200504lC20<000001P1`7@d00`0mFJ/0L1d=0000
0006070M3@80000000@0?EV[070M3@1`7@d0L1d=0`00000308/U40030000002;9A00RbD@0080RbD@
00<0?EV[08/U402;9A000`2;9A000`000000RbD@03eIZ`0708/U40060000002;9A0000000000002P
;1<0?EV[102P;1<00`000000?EV[0:0/4`070:0/4`030000001;J/<0Bf[300@0Bf[300<0000004EP
[P15H:h00P15H:h01`000000AF2^0=@m6@000000?56@03eIZ`0000000`0lDI000`000000;ciZ0000
0002000000/0ooK^00<0e3dI0?ofkP3D?AT00P3D?AT30?ofkP<0e3dI3@3om^h20=@m6@h0ooK^00<0
00000?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00<0e3dI2`3o
m^h00`3D?AT0ooK^0?ofkP0D0?ofkP030=@m6@3om^h0ooK^00l0ooK^00<000000?ofkP3om^h0AP3o
m^h10?ooo`005P3om^h00`000000ooK^0?ofkP0o0?ofkP030000003om^h0ooK^0080ooK^00<0?EV[
0?ofkP3om^h02@3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00h0ooK^00@0?EV[0?ofkP3om^h0?EV[
3`3om^h00`0mFJ/0ooK^03eIZ`0A0?ofkP0303eIZ`3om^h0?EV[00@0ooK^0`00000201L60P030000
000G1P800000008000001P0]2`@00`000000;@/402d;10030000000304lC20000000Ca<800@0Ca<8
00<0?EV[04lC20000000101?4`P200000003070M3@000000L1d=00L0L1d=00<0?EV[0000001`7@d0
0P1`7@d300000004070M3@0mFJ/00000070M3@8000001P2;9A000`000000RbD@08/U400308/U4003
03eIZ`2;9A00RbD@0080RbD@00<0000003eIZ`2;9A001P2;9A03000000@0X2`C00D0?EV[0:0/4`2P
;1<0X2`C03eIZ`090:0/4`030000001;J/<0Bf[300@0Bf[30P00000304EP[P0700000015H:h0e3dI
04EP[P000000?56@0000000303aAT080000000@0?EV[00000000000000002@3om^h40=@m6@80ooK^
0`3D?AT@0?ofkP80e3dI3`3om^h00`000000ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00<0ooK^
0P3D?AT>0?ofkP030=@m6@3om^h0ooK^01@0ooK^00<0e3dI0?ofkP3om^h0403om^h00`000000ooK^
0?ofkP150?ofkP40oooo000F0?ofkP030000003om^h0ooK^0400ooK^00D000000?ofkP3om^h0ooK^
03eIZ`0<0?ofkP0403eIZ`3om^h0ooK^03eIZ`l0ooK^0P0mFJ/A0?ofkP0303eIZ`3om^h0ooK^0140
ooK^00@0?EV[0?ofkP3om^h0ooK^0`00000201L60P@000000P0]2`@00`000000;@/402d;100302d;
10@000000`1?4`P00`000000Ca<804lC200304lC200303eIZ`1?4`P0000000<0Ca<80P000003070M
3@030000001`7@d0L1d=00H0L1d=00<0000003eIZ`0000000P000003070M3@0403eIZ`0000000000
000000P0RbD@00<0000008/U402;9A00102;9A001P0mFJ/0RbD@08/U402;9A00000003eIZ`D0RbD@
0P0000000`2P;1<000000:0/4`050:0/4`0403eIZ`2P;1<0X2`C03eIZ`T0X2`C00<0000004]Z``1;
J/<0101;J/<2000000<0AF2^00D0000004EP[P15H:h0e3dI04EP[P02000000<0?56@0P0000000`0_
?VX0000000000002000000D0ooK^0`3D?AT00`3om^h0e3dI0?ofkP030=@m6A@0ooK^00<0e3dI0?of
kP3om^h03P3om^h00`000000ooK^0?ofkP020?ofkP030=@m6@3om^h0e3dI00<0e3dI403om^h00`3D
?AT0ooK^0?ofkP0D0?ofkP030=@m6@3om^h0ooK^00l0ooK^00<000000?ofkP3om^h0A@3om^h10?oo
o`005P3om^h00`000000ooK^0?ofkP110?ofkP040000003om^h0ooK^03eIZ`d0ooK^0P0mFJ/A0?of
kP0303eIZ`3om^h0ooK^00l0ooK^0P0mFJ/A0?ofkP0403eIZ`3om^h0?EV[03eIZ`<0000000@05`H2
0000000000000000100]2`@00`000000;@/402d;100202d;10<000001P1?4`P00`000000Ca<804lC
200204lC200503eIZ`1?4`P0Ca<80000001?4`P00P000005070M3@030000001`7@d0L1d=00H0L1d=
0P0000000`0mFJ/0L1d=070M3@02070M3@0403eIZ`000000RbD@000000T0RbD@00<0000008/U402;
9A00102;9A001@0mFJ/0RbD@08/U402;9A00?EV[00<0RbD@0`0000030:0/4`030000002P;1<0X2`C
00@0X2`C00@0?EV[0:0/4`2P;1<0?EV[2@2P;1<00`000000Bf[304]Z``0404]Z``030000001;J/<0
00000080AF2^00@0000004EP[P15H:h0e3dI0P15H:h02@000000?56@03aAT00lDI00000003aAT000
0000?EV[02lnJP02000000<0ooK^0P3D?AT40?ofkP80e3dI00<0ooK^0=@m6@3om^h0503om^h20=@m
6@l0ooK^00@000000?ofkP3om^h0ooK^1@3D?AT00`3om^h0e3dI0?ofkP0?0?ofkP030=@m6@3om^h0
ooK^01<0ooK^0P3D?ATB0?ofkP030000003om^h0ooK^04@0ooK^0@3oool001D0ooK^00<000000?of
kP3om^h0@`3om^h010000000ooK^03eIZ`0mFJ/=0?ofkP0303eIZ`3om^h0ooK^00l0ooK^0P0mFJ/?
0?ofkP0403eIZ`3om^h0ooK^03eIZa00ooK^00H0?EV[0000000000005`H20000000G1P83000000D0
;@/400@0000002d;100]2`@0;@/40P0000000`1?4`P0000004lC200504lC20030000001?4`P0Ca<8
0080Ca<800<0?EV[04lC201?4`P00`000007070M3@030000001`7@d0L1d=00<0L1d=10000002070M
3@0503eIZ`00000000000000000mFJ/00P2;9A000`000000RbD@08/U400708/U40030000002;9A00
RbD@00D0RbD@00D0?EV[08/U402;9A00?EV[08/U4002000000H0X2`C00<000000:0/4`2P;1<01@2P
;1<203eIZ`030000002P;1<0X2`C00L0X2`C00<0000004]Z``1;J/<0101;J/<01P000000Bf[304]Z
``000000AF2^00000080AF2^00<0e3dI04EP[P15H:h00P00000203aAT0070000000lDI00?56@0000
000mFJ/0;ciZ000000030=@m6@<0ooK^0`3D?AT01@3om^h0e3dI0?ofkP3om^h0e3dI01D0ooK^00<0
e3dI0?ofkP3om^h03P3om^h00`000000e3dI0=@m6@030=@m6@@0ooK^00<0e3dI0?ofkP3om^h03@3o
m^h00`3D?AT0ooK^0?ofkP0@0?ofkP<0e3dI00<0ooK^0=@m6@3om^h04P3om^h00`000000ooK^0?of
kP130?ofkP40oooo000E0?ofkP030000003om^h0ooK^04@0ooK^00@0000003eIZ`3om^h0?EV[303o
m^h203eIZa00ooK^00<0?EV[0?ofkP0mFJ/03P3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00h0ooK^
00<0?EV[0000000G1P80100000000`0]2`@0000002d;100402d;10030000000]2`@0;@/400800000
0P1?4`P00`000000Ca<804lC200504lC20060000001?4`P0Ca<804lC200mFJ/0Ca<80P0000000`1`
7@d00000070M3@06070M3@030000001`7@d0L1d=0080L1d=0P000003070M3@070000001`7@d00000
0000000mFJ/0RbD@03eIZ`0308/U40030000002;9A00RbD@00L0RbD@00<0000008/U402;9A001P2;
9A0203eIZ`800000202P;1<00`000000X2`C0:0/4`060:0/4`0303eIZ`000000X2`C00P0X2`C00<0
000004]Z``1;J/<0101;J/<010000000Bf[304]Z``1;J/<200000080AF2^00H0e3dI04EP[P15H:h0
000004EP[P00000203aAT0030000000lDI00?56@00<0e3dI0P000000103om^h0e3dI0=@m6@3D?AT4
0?ofkP040=@m6@3om^h0ooK^0=@m6AD0ooK^00<0e3dI0?ofkP3om^h02`3om^h40=@m6@050000003D
?AT0ooK^0?ofkP3D?AT0103om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00`0ooK^
0`3D?AT50?ofkP030=@m6@3om^h0ooK^0100ooK^00<000000?ofkP3om^h0@`3om^h10?ooo`005@3o
m^h00`000000ooK^0?ofkP150?ofkP030000000mFJ/0ooK^0080?EV[2P3om^h00`0mFJ/0ooK^03eI
Z`0>0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/03@3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eI
Z`3om^h0ooK^00T0ooK^00<0e3dI0000000mFJ/00`00000302d;10030000000]2`@0;@/400@0;@/4
0`00000404lC20030000001?4`P0Ca<800D0Ca<800H0000004lC201?4`P0?EV[0000000mFJ/3070M
3@030000001`7@d0L1d=00D0L1d=00<00000070M3@0000000P000004070M3@<000000`2;9A000`0m
FJ/0RbD@08/U400208/U40030000002;9A00RbD@00L0RbD@00<0000008/U402;9A00102;9A030000
000303eIZ`000000X2`C00P0X2`C00<000000:0/4`2P;1<01@2P;1<00`0mFJ/0X2`C03eIZ`080:0/
4`8000001P1;J/<010000000Bf[304]Z``1;J/<200000080AF2^00H0e3dI04EP[P15H:h0000004EP
[P00000203aAT0<0e3dI0P000000100_?VX000000000000000070?ofkP050=@m6@3om^h0ooK^0?of
kP3D?AT05@3om^h00`3D?AT0ooK^0?ofkP060?ofkP@0e3dI00D0ooK^0=@m6@3D?AT0ooK^00000003
0?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0:
0?ofkP80e3dI203om^h00`3D?AT0ooK^0?ofkP0A0?ofkP030000003om^h0ooK^0480ooK^0@3oool0
01D0ooK^00<000000?ofkP3om^h0AP3om^h01@0mFJ/000000?ofkP3om^h0?EV[00T0ooK^00<0?EV[
0?ofkP3om^h00P0mFJ/<0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h02@3om^h0
0`0mFJ/0ooK^0?ofkP040?ofkP80?EV[1P3om^h20=@m6@030000000G1P800000008000001@0]2`@0
0`000000;@/402d;100202d;10<000001@1?4`P00`000000Ca<804lC200504lC20040000001?4`P0
?EV[03eIZ`<0L1d=00<0?EV[070M3@0000001`1`7@d3000000D0L1d=0P0000000`2;9A00000008/U
400208/U400303eIZ`2;9A00?EV[00<0RbD@00<0000008/U402;9A001`2;9A000`000000RbD@08/U
400208/U408000000P2P;1<00`0mFJ/0X2`C03eIZ`090:0/4`030000002P;1<0X2`C00D0X2`C00@0
?EV[0:0/4`000000?EV[1@2P;1<2000000030;0a5@000000000000@0Bf[300<0000004]Z``1;J/<0
0`1;J/<01`000000AF2^04EP[P15H:h0e3dI04EP[P0000000P15H:h20=@m6@050000000lDI00?56@
03aAT00000000P0_?VX3000000L0ooK^00@0e3dI0?ofkP3om^h0e3dI5@3om^h00`3D?AT0ooK^0?of
kP030?ofkP<0e3dI0P3om^h30=@m6@@0ooK^00@000000?ofkP3om^h0e3dI1@3om^h00`3D?AT0ooK^
0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00H0ooK^0`3D?AT:0?ofkP030=@m6@3om^h0ooK^0140ooK^
00<000000?ofkP3om^h0@P3om^h10?ooo`00503om^h00`000000ooK^0?ofkP170?ofkP0303eIZ`3o
m^h000000080ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3o
m^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3o
m^h0ooK^00H0ooK^00@0?EV[0?ofkP3om^h0ooK^0P3D?AT40000000302d;10000000;@/400@0;@/4
00<0000002d;100]2`@01000000704lC20030000001?4`P0Ca<800@0Ca<80P0000000`0mFJ/0L1d=
070M3@04070M3@0303eIZ`000000L1d=00@0L1d=0P0000000`1`7@d00000070M3@02070M3@<00000
0`2;9A0010000000RbD@08/U400mFJ/308/U400403eIZ`2;9A00RbD@000000T0RbD@00<0000008/U
400000000P0000040:0/4`0403eIZ`2P;1<0000003eIZ`P0X2`C00<000000:0/4`2P;1<0102P;1<0
1`0mFJ/0X2`C0:0/4`000000X2`C03eIZ`2P;1<00`0000030;0a5@030000001>L=00000000<0Bf[3
00<0000004]Z``1;J/<00`1;J/<200000080AF2^00<0e3dI04EP[P3D?AT00P3D?AT00`15H:h00000
0000000303aAT080000000D0;ciZ000000000000?EV[000000060?ofkP050=@m6@3om^h0ooK^0?of
kP3D?AT0503om^h20=@m6@040?ofkP3D?AT0e3dI0=@m6@80ooK^0`3D?AT80?ofkP040000003om^h0
ooK^0=@m6@@0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP030?ofkP<0e3dI3@3o
m^h00`3D?AT0ooK^0?ofkP0B0?ofkP030000003om^h0ooK^0440ooK^0@3oool001@0ooK^00<00000
0?ofkP3om^h0A`3om^h0100mFJ/0ooK^0?ofkP0000020?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0
?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0
?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0403eIZ`3D?AT0e3dI0=@m6@800000
100]2`@00`000000;@/402d;100202d;10@000000`1?4`P00`000000Ca<804lC200504lC20040000
001?4`P0Ca<804lC20<0000000<0L1d=03eIZ`1`7@d01`1`7@d00`0mFJ/0L1d=070M3@03000000<0
L1d=00@000000=@m6@00000000001P2;9A000`000000RbD@03eIZ`0508/U400303eIZ`2;9A000000
00P0RbD@0`0000060:0/4`0603eIZ`2P;1<0X2`C0000002P;1<0?EV[1`2P;1<00`000000X2`C0:0/
4`040:0/4`0703eIZ`2P;1<0X2`C0000002P;1<0000003eIZ`060;0a5@040000001>L=00CW3@0000
0080Bf[300<0000004]Z``1;J/<00`1;J/<00`000000Bf[3000000030=@m6@0300000015H:h0AF2^
0080AF2^00H0000003aAT00lDI00?56@0000000lDI020000000402lnJP0000000000000000D0ooK^
00D0e3dI0?ofkP3om^h0ooK^0=@m6@0D0?ofkP<0e3dI0`3om^h20=@m6@`0ooK^00<000000?ofkP3D
?AT0103om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0e3dI0080e3dI4@3om^h00`3D?AT0
ooK^0?ofkP0B0?ofkP030000003om^h0ooK^0400ooK^0@3oool001@0ooK^00<000000?ofkP3om^h0
A`3om^h01@0mFJ/0ooK^0?ofkP3om^h000000080ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0
ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0
ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00D0ooK^103D?AT00`0mFJ/0ooK^0000000502d;1003
0000000]2`@0;@/40080;@/40P00000504lC20030000001?4`P0Ca<800D0Ca<800<0000004lC2000
00000P000003070M3@0303eIZ`000000L1d=00L0L1d=0`000005070M3@<00000202;9A000`000000
?EV[08/U400608/U400303eIZ`000000RbD@00D0RbD@0P0000000`2P;1<000000:0/4`050:0/4`07
03eIZ`2P;1<0X2`C0:0/4`000000X2`C03eIZ`070:0/4`030000002P;1<0X2`C00<0X2`C00<0?EV[
0:0/4`2P;1<00`0000000`2`<AD0?EV[0;0a5@040;0a5@050000001>L=00CW3@04i`d00000000P1;
J/<00`000000Bf[304]Z``0304]Z``070000003D?AT0e3dI0000003D?AT0AF2^0000000404EP[P80
00000P0lDI002@000000?56@0000000_?VX0000002lnJP0000008R]=000000040?ofkP050=@m6@3o
m^h0ooK^0?ofkP3D?AT04@3om^h30=@m6@030?ofkP3D?AT0ooK^00<0e3dI3P3om^h00`000000ooK^
0=@m6@050?ofkP030=@m6@3om^h0ooK^00d0ooK^0`3D?ATD0?ofkP030=@m6@3om^h0ooK^0180ooK^
00<000000?ofkP3om^h0@03om^h10?ooo`00503om^h00`000000ooK^0?ofkP170?ofkP0303eIZ`3o
m^h0ooK^0080ooK^00@000000?ofkP3om^h0?EV[1@3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eI
Z`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eI
Z`3om^h0ooK^0080ooK^103D?AT40?ofkP0303eIZ`0]2`@0;@/400<0;@/400@0000002d;100]2`@0
;@/40P00000704lC20030000001?4`P0Ca<800@0Ca<80`000004070M3@80?EV[00<0L1d=0000001`
7@d01@1`7@d200000080L1d=00<0?EV[070M3@1`7@d00`0000000`2;9A00000008/U400808/U4003
03eIZ`2;9A00RbD@00L0RbD@00@0?EV[08/U402;9A00RbD@0`0000030:0/4`030000002P;1<0X2`C
00<0X2`C00<0?EV[0:0/4`2P;1<00P2P;1<010000000X2`C0:0/4`0mFJ/60:0/4`030000002P;1<0
X2`C00<0X2`C00D0?EV[000000000000/34E000000030;0a5@0303eIZ`2`<AD0/34E0080/34E00<0
000004i`d01>L=000P1>L=000`000000Bf[30000000304]Z``<0e3dI0`1;J/<00`000000e3dI0000
000404EP[P8000000P0lDI000`000000?56@03aAT00200000080;ciZ0`0000040?ofkP050=@m6@3o
m^h0ooK^0?ofkP3D?AT03P3om^h20=@m6@<0ooK^0`3D?ATB0?ofkP030000003om^h0e3dI00@0ooK^
00<0e3dI0?ofkP3om^h02P3om^h30=@m6@030?ofkP3D?AT0ooK^01@0ooK^00<0e3dI0?ofkP3om^h0
4`3om^h00`000000ooK^0?ofkP0o0?ofkP40oooo000D0?ofkP030000003om^h0ooK^04P0ooK^00<0
?EV[0?ofkP3om^h00P3om^h010000000ooK^0?ofkP0mFJ/40?ofkP0303eIZ`3om^h0ooK^00H0ooK^
00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^0080ooK^
00@0?EV[0?ofkP3om^h0ooK^103D?AT40?ofkP030=@m6@000000?EV[00@0;@/400<0000002d;100]
2`@00P0000000`1?4`P0000004lC200504lC20030000001?4`P0Ca<800<0Ca<80P0000000`1`7@d0
0000070M3@03070M3@0503eIZ`1`7@d0L1d=070M3@0000000`1`7@d300000003070M3@000000L1d=
0080000000<0?EV[0000002;9A000`2;9A000`000000RbD@08/U400608/U400303eIZ`000000RbD@
00P0RbD@00@0000003eIZ`00000000001P2P;1<00`000000X2`C0:0/4`030:0/4`0303eIZ`2P;1<0
X2`C0080X2`C00D000000:0/4`2P;1<0X2`C03eIZ`050:0/4`070000002P;1<0X2`C0:0/4`000000
?EV[000000030;0a5@030000002`<AD0/34E0080/34E00D0?EV[0;0a5@2`<AD0/34E0000000504i`
d08000000`3D?AT204]Z``030000001;J/<0Bf[30080Bf[300<0e3dI00000015H:h00`15H:h00`00
0000AF2^0000000203aAT0030000000lDI00?56@0080000000@0;ciZ0000000000000000103om^h0
1@3D?AT0ooK^0?ofkP3om^h0e3dI00/0ooK^0`3D?AT20?ofkP<0e3dI00<0ooK^0=@m6@3D?AT04`3o
m^h00`000000e3dI0?ofkP030?ofkP030=@m6@3om^h0ooK^00L0ooK^0`3D?AT50?ofkP030=@m6@3o
m^h0ooK^0180ooK^00<0e3dI0?ofkP3om^h04`3om^h00`000000ooK^0?ofkP0o0?ofkP40oooo000C
0?ofkP030000003om^h0ooK^04T0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`000000ooK^0?ofkP02
03eIZ`80ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0
ooK^00T0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`050=@m6@<0ooK^1@3D?AT502d;10<000000P1?
4`P00`000000Ca<804lC200504lC20030000001?4`P0Ca<800<000000`1`7@d01@000000L1d=070M
3@1`7@d0?EV[00<0L1d=00<00000070M3@0000000P000003070M3@<000000`2;9A000`0mFJ/0RbD@
08/U400208/U40030000002;9A00RbD@00D0RbD@00<0?EV[08/U40000000202;9A030000000303eI
Z`2P;1<0X2`C00D0X2`C00<000000:0/4`2P;1<00P2P;1<00`0mFJ/0X2`C0:0/4`030:0/4`030000
002P;1<0X2`C0080X2`C00<0?EV[0:0/4`2P;1<00P2P;1<01P000000X2`C000000000000/34E03eI
Z`@0/34E00<000000;0a5@2`<AD00`2`<AD0100mFJ/0/34E0;0a5@00000504i`d080e3dI101;J/<0
0`000000Bf[304]Z``0304]Z``030=@m6@000000AF2^00<0AF2^00H0000004EP[P15H:h0000003eI
Z`00000303aAT0030000000_?VX0?EV[00<000000`3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m
6@3om^h0ooK^00D0ooK^0`3D?AT20?ofkP<0e3dI1@3om^h00`3D?AT0ooK^0?ofkP0A0?ofkP030000
003om^h0e3dI00@0ooK^00<0e3dI0?ofkP3om^h0103om^h20=@m6@P0ooK^00<0e3dI0?ofkP3om^h0
4`3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030000003om^h0ooK^03h0ooK^0@3oool001<0ooK^00<0
00000?ofkP3om^h0B@3om^h00`0mFJ/0ooK^0?ofkP040?ofkP8000000P3om^h00`0mFJ/0ooK^03eI
Z`0:0?ofkP80?EV[0`3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0503eIZ`3D?AT0e3dI03eIZ`3D?AT0
0P3om^h00`3D?AT0ooK^0=@m6@020=@m6@040?ofkP3D?AT0e3dI000000@0;@/40`00000404lC2003
0000001?4`P0Ca<800@0Ca<800@0000004lC2000000000001@1`7@d01@000000L1d=070M3@1`7@d0
?EV[00@0L1d=0P000004070M3@80000000<0RbD@0000002;9A00102;9A001@0mFJ/0RbD@08/U402;
9A00000000L0RbD@00<0?EV[08/U400000001@2;9A03000000040:0/4`000000X2`C03eIZ`L0X2`C
00D000000:0/4`2P;1<0X2`C03eIZ`060:0/4`030000002P;1<0X2`C00<0X2`C00<0?EV[0:0/4`2P
;1<00`0000020;0a5@0303eIZ`2`<AD0/34E00<0/34E00<000000;0a5@2`<AD0102`<AD00`0mFJ/0
/34E0000000204i`d0<0e3dI00<0CW3@0000000000000`1;J/<00`000000Bf[304]Z``0304]Z``03
0=@m6@000000000000<0AF2^00@0000004EP[P15H:h0AF2^0P00000303aAT080000000<0;ciZ03eI
Z`0_?VX00P0000030?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT01@3om^h20=@m6@80ooK^0`3D?AT8
0?ofkP80e3dI4`3om^h00`000000e3dI0?ofkP030?ofkP040=@m6@3om^h0ooK^0?ofkP<0e3dI2P3o
m^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^01@0ooK^00<000000?ofkP3om^h0?@3o
m^h10?ooo`004`3om^h00`000000ooK^0?ofkP1:0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<00000
0?ofkP3om^h00P0mFJ/<0?ofkP0303eIZ`3om^h0?EV[00/0ooK^0`3D?AT203eIZ`H0e3dI0P3om^h2
0=@m6@040?ofkP000000;@/402d;10@000001@1?4`P00`000000Ca<804lC200404lC20<000001`1`
7@d010000000L1d=03eIZ`0mFJ/2070M3@@000000`1`7@d2000000<0RbD@00<0000008/U402;9A00
102;9A00100mFJ/0RbD@08/U4000000608/U400503eIZ`2;9A00RbD@0000002;9A00100000040:0/
4`040000002P;1<0X2`C03eIZ`H0X2`C00@000000:0/4`2P;1<0?EV[1`2P;1<00`000000X2`C0:0/
4`030:0/4`050000000mFJ/000000;0a5@0000000`2`<AD00`0mFJ/0/34E0;0a5@030;0a5@030000
002`<AD0/34E00D0/34E00@0?EV[0000003D?AT0e3dI101>L=000`000000CW3@0000000204]Z``03
0000001;J/<0Bf[300@0Bf[300<0e3dI00000015H:h00P15H:h01P000000AF2^04EP[P15H:h00000
03eIZ`<0?56@00@0000003aAT0000000?EV[0P0_?VX200000080ooK^00<0e3dI0?ofkP3om^h00P3o
m^h00`3D?AT0ooK^0=@m6@020=@m6@80ooK^0P3D?AT;0?ofkP80e3dI503om^h00`000000ooK^0?of
kP020?ofkP@0e3dI3@3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^01@0ooK^00<0
00000?ofkP3om^h0?@3om^h10?ooo`004`3om^h00`000000ooK^0?ofkP1:0?ofkP80?EV[1`3om^h0
10000000ooK^0?ofkP0mFJ/=0?ofkP80?EV[2@3om^h40=@m6@80ooK^00<0?EV[0?ofkP3D?AT00P3D
?AT00`3om^h0e3dI0=@m6@020=@m6@030?ofkP0000000000008000000`1?4`P00`000000Ca<804lC
200304lC20040000001?4`P0Ca<804lC20<0000000<0L1d=0000001`7@d01`1`7@d010000000?EV[
070M3@1`7@d2000000<0L1d=00@00000070M3@00000000001@2;9A000`000000RbD@08/U400508/U
400303eIZ`2;9A00000000D0RbD@00<0?EV[08/U402;9A000`0000080:0/4`050000002P;1<0X2`C
0:0/4`0mFJ/01P2P;1<00`000000X2`C03eIZ`070:0/4`030000002P;1<0000000<000000P2`<AD0
0`0mFJ/0/34E000000020;0a5@0303eIZ`2`<AD0/34E00@0/34E00<000000;0a5@2`<AD01P2`<AD0
0`3D?AT0CW3@04i`d00304i`d0040000001>L=00CW3@00000080Bf[300<0000004]Z``1;J/<00`1;
J/<010000000e3dI04]Z``00000204EP[P0300000015H:h0AF2^0080AF2^00<0000003aAT00lDI00
0P0lDI020000000502lnJP0mFJ/0;ciZ02lnJP0000000P3om^h0103D?AT0ooK^0?ofkP3om^h30=@m
6@80ooK^0`3D?AT>0?ofkP030=@m6@3om^h0ooK^01<0ooK^00<000000?ofkP3D?AT00`3D?AT@0?of
kP030=@m6@3om^h0ooK^0180ooK^00<0e3dI0?ofkP3om^h05@3om^h00`000000ooK^0?ofkP0l0?of
kP40oooo000B0?ofkP030000003om^h0ooK^04`0ooK^0P0mFJ/70?ofkP040000003om^h0?EV[03eI
Z`d0ooK^00<0?EV[0?ofkP3om^h01@3om^h30=@m6@@0ooK^00@0e3dI03eIZ`0mFJ/0ooK^0`3D?AT4
0?ofkP8000001@1?4`P00`000000Ca<804lC200304lC20030000001?4`P0000000800000101`7@d0
0`000000L1d=070M3@06070M3@0403eIZ`0000000000000000@0L1d=0`00000708/U40030000002;
9A00RbD@00H0RbD@00<0?EV[0000002;9A000`2;9A001P0mFJ/0RbD@000000000000X2`C000000T0
X2`C00<000000:0/4`2P;1<00P2P;1<00`0mFJ/0X2`C0:0/4`030:0/4`030000000mFJ/0X2`C00H0
X2`C0`0000060;0a5@0303eIZ`2`<AD000000080/34E00<0?EV[0;0a5@2`<AD00`2`<AD00`000000
/34E0;0a5@060;0a5@030000001>L=00CW3@00@0CW3@00L0000004i`d01>L=00CW3@0000001;J/<0
000000D0Bf[300L000000=@m6@1;J/<0Bf[300000015H:h0000000@0AF2^0P00000303aAT0040000
000lDI00000003eIZ`80;ciZ0P0000000`3om^h0e3dI0=@m6@020=@m6@030?ofkP3D?AT0e3dI0080
e3dI4@3om^h20=@m6A<0ooK^00<0e3dI0000003D?AT00`3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP03
0=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h05@3om^h00`000000ooK^0?ofkP0k0?ofkP40
oooo000B0?ofkP030000003om^h0ooK^04`0ooK^00@0?EV[0?ofkP0mFJ/0?EV[1P3om^h010000000
?EV[0?ofkP0mFJ/<0?ofkP80?EV[0`3om^h30=@m6@@0ooK^0`3D?AT01@3om^h0?EV[0=@m6@0mFJ/0
e3dI00D0ooK^00<0000004lC201?4`P0101?4`P00`000000Ca<804lC200304lC20<000001`1`7@d0
0`000000L1d=070M3@04070M3@<0000000<0?EV[070M3@1`7@d00P1`7@d2000000030=@m6@000000
RbD@00L0RbD@00<0000008/U402;9A001`2;9A001@0mFJ/0RbD@08/U402;9A00?EV[008000000`2P
;1<00`000000X2`C0:0/4`070:0/4`030000002P;1<0X2`C00<0X2`C00<0?EV[0:0/4`2P;1<00P2P
;1<00`0mFJ/0X2`C0:0/4`040:0/4`80000000<0/34E0000002`<AD01`2`<AD0100mFJ/000000;0a
5@0mFJ/60;0a5@030000002`<AD0/34E00H0/34E00<0000004i`d01>L=00101>L=000`000000CW3@
04i`d00204i`d08000001@1;J/<00`000000e3dI04]Z``0204]Z``8000001015H:h00`000000AF2^
0000000203aAT0030000000lDI00?56@008000000P0_?VX200000080e3dI00<0ooK^0=@m6@3D?AT0
0P3D?ATC0?ofkP80e3dI403om^h30=@m6@030?ofkP3D?AT0000000<0ooK^00<0e3dI0?ofkP3om^h0
3P3om^h00`3D?AT0ooK^0?ofkP0B0?ofkP80e3dI5`3om^h00`000000ooK^0?ofkP0k0?ofkP40oooo
000B0?ofkP030000003om^h0ooK^04d0ooK^00@0?EV[0?ofkP3om^h0?EV[1P3om^h010000000?EV[
0?ofkP0mFJ/;0?ofkP0303eIZ`3om^h0?EV[00<0e3dI103om^h20=@m6@80ooK^00H0e3dI03eIZ`3D
?AT0e3dI0?ofkP0mFJ/50?ofkP030000001?4`P0Ca<800@0Ca<800@0000004lC201?4`P0Ca<80P00
00000`1`7@d00000070M3@07070M3@030000001`7@d0L1d=0080L1d=0P0000001@1`7@d00000070M
3@1`7@d0?EV[00<000000`2;9A000`000000RbD@08/U400708/U40030000002;9A00RbD@00H0RbD@
00@0000003eIZ`000000?EV[1P2P;1<00`000000X2`C0:0/4`080:0/4`030000002P;1<0X2`C00<0
X2`C00D0?EV[0:0/4`2P;1<0?EV[000000030:0/4`<000000`2`<AD00`000000/34E0;0a5@070;0a
5@0303eIZ`2`<AD0?EV[00H0/34E00<000000;0a5@2`<AD01P2`<AD00`000000CW3@04i`d00404i`
d0030000001>L=00CW3@00<0CW3@00<0000004]Z``1;J/<00`1;J/<00`000000Bf[30=@m6@0204]Z
``8000001015H:h01P000000AF2^04EP[P000000?56@000000<0?56@00<0000002lnJP0_?VX00P00
00030=@m6@<0ooK^00<0e3dI0?ofkP3om^h04P3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP80e3dI1@3o
m^h00`3D?AT000000?ofkP020?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h03`3o
m^h30=@m6@030?ofkP3D?AT0ooK^01L0ooK^00<000000?ofkP3om^h0>P3om^h10?ooo`004P3om^h0
0`000000ooK^0?ofkP1>0?ofkP0403eIZ`3om^h0ooK^03eIZ`H0ooK^00@0?EV[0?ofkP3om^h0?EV[
2P3om^h01@0mFJ/0e3dI0=@m6@0mFJ/0e3dI0080ooK^0`3D?AT0203om^h0e3dI0=@m6@3D?AT0ooK^
03eIZ`3om^h0e3dI0P3om^h01@0mFJ/0ooK^0?ofkP3D?AT0000000H0Ca<800<0000004lC201?4`P0
0P000003070M3@030000001`7@d0L1d=00D0L1d=00<00000070M3@1`7@d00`000003070M3@050000
001`7@d000000000000mFJ/01@2;9A000`000000RbD@08/U400708/U40030000002;9A00RbD@00D0
RbD@0`0000000`0mFJ/0X2`C0:0/4`050:0/4`030000002P;1<0X2`C00P0X2`C00<000000:0/4`2P
;1<0102P;1<01@0mFJ/0X2`C03eIZ`000000X2`C008000001P2`<AD00`000000/34E0;0a5@070;0a
5@030000000mFJ/0/34E00H0/34E00<000000;0a5@2`<AD01@2`<AD2000000D0CW3@00<0000004i`
d01>L=00101>L=02000000@0Bf[300<0000004]Z``3D?AT00`1;J/<00`000000AF2^04EP[P0204EP
[P0700000015H:h0AF2^04EP[P000000?56@0000000203aAT08000000`3D?AT00`000000e3dI0?of
kP030?ofkP030=@m6@3om^h0ooK^0180ooK^0P3D?AT:0?ofkP<0e3dI1`3om^h0103D?AT0ooK^0000
003om^h20=@m6A00ooK^00<0e3dI0?ofkP3om^h02`3om^h30=@m6@D0ooK^00<0e3dI0?ofkP3om^h0
5@3om^h00`000000ooK^0?ofkP0j0?ofkP40oooo000B0?ofkP030000003om^h0ooK^04h0ooK^00D0
?EV[0?ofkP3om^h0ooK^03eIZ`050?ofkP0503eIZ`00000000000?ofkP0mFJ/0203om^h00`3D?AT0
?EV[0?ofkP020=@m6@0403eIZ`3D?AT0e3dI0?ofkP<0e3dI103om^h00`0mFJ/0e3dI0?ofkP030?of
kP0303eIZ`3D?AT0000000L0Ca<80`000004070M3@030000001`7@d0L1d=00H0L1d=0`0000000`0m
FJ/0L1d=070M3@02070M3@<000000`2;9A000`0mFJ/0RbD@08/U400208/U40030000002;9A00RbD@
00L0RbD@00<0000008/U402;9A000`2;9A02000000050:0/4`000000?EV[0:0/4`0mFJ/01P2P;1<0
0`000000X2`C0:0/4`080:0/4`030000002P;1<0X2`C00D0X2`C00@0?EV[0000000000000000202`
<AD00`000000/34E0;0a5@060;0a5@040000000mFJ/0/34E03eIZ`H0/34E00<000000;0a5@2`<AD0
0`2`<AD2000000030;hf5`000000000000@0CW3@00<0000004i`d01>L=00101>L=000`000000CW3@
0000000304]Z``030000001;J/<0e3dI00<0Bf[30P00000304EP[P0300000015H:h0AF2^0080AF2^
0P00000203aAT080e3dI00<0000002lnJP0000000P0000000`3D?AT0ooK^0?ofkP020?ofkP030=@m
6@3om^h0ooK^0180ooK^00<0e3dI0?ofkP3om^h01@3om^h30=@m6@X0ooK^0P3D?AT010000000e3dI
0?ofkP3D?AT@0?ofkP030=@m6@3om^h0ooK^00T0ooK^0P3D?AT80?ofkP030=@m6@3om^h0ooK^01H0
ooK^00<000000?ofkP3om^h0>@3om^h10?ooo`004@3om^h00`000000ooK^0?ofkP1@0?ofkP0503eI
Z`3om^h0ooK^0?ofkP0mFJ/0103om^h01P0mFJ/0ooK^0?ofkP000000ooK^03eIZ`@0ooK^103D?AT0
1P0mFJ/0e3dI0=@m6@3D?AT0ooK^03eIZ`<0e3dI1P3om^h00`0mFJ/0e3dI0?ofkP030=@m6@030?of
kP0mFJ/0?EV[00D0Ca<80`000006070M3@030000001`7@d0L1d=00@0L1d=0`00000203eIZ`80L1d=
0`0000000`2;9A00000008/U400408/U400503eIZ`2;9A00RbD@08/U400000002@2;9A0010000000
RbD@08/U402;9A0200000080X2`C0P0mFJ/30:0/4`0303eIZ`2P;1<0X2`C00<0X2`C00<000000:0/
4`2P;1<0202P;1<00`000000X2`C0:0/4`030:0/4`050000000mFJ/0000003eIZ`0000002@2`<AD0
0`000000/34E0;0a5@060;0a5@050000000mFJ/0/34E0;0a5@0mFJ/01@2`<AD010000000/34E0;0a
5@2`<AD2000000<0_SHG00<00000051cf@0000000`1>L=000`000000CW3@04i`d00404i`d0030000
001>L=0000000080Bf[300D0000004]Z``1;J/<0Bf[30=@m6@0204]Z``030000001;J/<000000080
AF2^00<0000004EP[P15H:h00`15H:h30=@m6@0803aAT0000000000002lnJP000000;ciZ0000003D
?AT40?ofkP030=@m6@3om^h0ooK^0180ooK^00<0e3dI0?ofkP3om^h00`3om^h20=@m6@/0ooK^0`3D
?AT20?ofkP040000003om^h0ooK^0=@m6@l0ooK^00<0e3dI0?ofkP3om^h01P3om^h30=@m6@X0ooK^
00<0e3dI0?ofkP3om^h05`3om^h00`000000ooK^0?ofkP0h0?ofkP40oooo000A0?ofkP030000003o
m^h0ooK^0500ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0503eIZ`3o
m^h0ooK^0000003om^h00P0mFJ/20=@m6@<0ooK^00<0?EV[0=@m6@3D?AT00`3D?AT0103om^h0?EV[
03eIZ`3om^h30=@m6@80ooK^00@0?EV[0=@m6@3D?AT0e3dI0`3om^h20=@m6@<0Ca<80`0000000`1`
7@d00000070M3@06070M3@040000001`7@d0L1d=070M3@<0000000@0L1d=03eIZ`0mFJ/0L1d=0`00
000408/U40030000002;9A00RbD@00@0RbD@00@0?EV[08/U402;9A0000002@2;9A0010000000RbD@
0000000000030:0/4`0303eIZ`2P;1<0000000@0X2`C00<0?EV[0:0/4`2P;1<00`2P;1<00`000000
X2`C0:0/4`070:0/4`030000002P;1<0000000<0000000D0?EV[0;0a5@2`<AD0/34E03eIZ`090;0a
5@030000002`<AD0/34E00H0/34E00<0?EV[0;0a5@2`<AD00P2`<AD00`0mFJ/0/34E0;0a5@020;0a
5@040000002`<AD00000000000D0_SHG00<00000051cf@0000000`1>L=000`000000CW3@04i`d003
04i`d0070000001>L=00CW3@04i`d0000000Bf[30000000304]Z``030=@m6@1;J/<000000080Bf[3
00@0000004EP[P15H:h000000P15H:h30=@m6@8000000P0lDI001`000000?56@000000000000;ciZ
0000003D?AT0103om^h00`3D?AT0ooK^0?ofkP0B0?ofkP80e3dI00@0ooK^0=@m6@3D?AT0e3dI2P3o
m^h30=@m6@<0ooK^00H0e3dI0?ofkP3om^h000000?ofkP3D?AT?0?ofkP030=@m6@3om^h0ooK^00<0
ooK^0`3D?AT=0?ofkP030=@m6@3om^h0ooK^01L0ooK^00<000000?ofkP3om^h0>03om^h10?ooo`00
4@3om^h00`000000ooK^0?ofkP1A0?ofkP0303eIZ`3om^h0ooK^0080ooK^00D0?EV[0?ofkP3om^h0
ooK^03eIZ`030?ofkP<0e3dI00H0?EV[0?ofkP3om^h0ooK^0=@m6@0mFJ/20=@m6@H0ooK^00@0?EV[
0?ofkP3om^h0ooK^0P3D?AT00`0mFJ/0e3dI0?ofkP020?ofkP80e3dI00<0ooK^0000000000000P00
0004070M3@030000001`7@d0L1d=00D0L1d=00@00000070M3@00000000000P1`7@d203eIZ`<00000
1`2;9A000`000000RbD@08/U400508/U400303eIZ`2;9A00000000P0RbD@0`0000040:0/4`0503eI
Z`2P;1<0X2`C0:0/4`000000102P;1<00`0mFJ/0X2`C0:0/4`020:0/4`030000002P;1<0X2`C00H0
X2`C0`0000030;0a5@0303eIZ`2`<AD0/34E0080/34E00<0000003eIZ`2`<AD01`2`<AD00`000000
/34E0;0a5@050;0a5@0303eIZ`000000/34E00@0/34E00<0?EV[0;0a5@2`<AD00`0000060;hf5`07
0000001@LmT0D7?I051cf@000000CW3@0000000604i`d0030000001>L=00CW3@0080CW3@0P000003
04]Z``030=@m6@1;J/<0000000<0Bf[300<0000004EP[P3D?AT00P3D?AT304EP[P0500000015H:h0
000003aAT00000000P0lDI020000000302lnJP000000e3dI00@0ooK^00<0e3dI0?ofkP3om^h04@3o
m^h30=@m6@X0ooK^0`3D?AT60?ofkP040=@m6@3om^h0ooK^00000080ooK^00<0e3dI0?ofkP3om^h0
3@3om^h00`3D?AT0ooK^0=@m6@020=@m6A40ooK^00<0e3dI0?ofkP3om^h05`3om^h00`000000ooK^
0?ofkP0g0?ofkP40oooo000A0?ofkP030000003om^h0ooK^0580ooK^00<0?EV[0?ofkP3om^h00P3o
m^h203eIZ`030?ofkP0mFJ/0e3dI00<0e3dI00@000000?ofkP3om^h0?EV[0`3D?AT00`0mFJ/0e3dI
0?ofkP070?ofkP0303eIZ`3D?AT0e3dI0080ooK^00<0?EV[0=@m6@3om^h00P3D?AT20?ofkP800000
1P1`7@d00`000000L1d=070M3@05070M3@<000000P1`7@d203eIZ`80000000<0e3dI0000002;9A00
1`2;9A000`000000RbD@08/U400608/U400303eIZ`000000RbD@00@0RbD@0`0000000`2P;1<00000
0:0/4`030:0/4`0303eIZ`2P;1<0X2`C0080X2`C00<000000:0/4`2P;1<00`2P;1<01@0mFJ/0X2`C
0:0/4`2P;1<0000000H0X2`C0P0000000`2`<AD000000;0a5@020;0a5@0303eIZ`2`<AD0/34E00<0
/34E00<000000;0a5@0mFJ/01`2`<AD00`000000/34E0;0a5@040;0a5@0303eIZ`2`<AD0000000D0
/34E00D0000003eIZ`000000_SHG000000070;hf5`030000001@LmT0D7?I0080D7?I0P00000604i`
d0030000001>L=00CW3@00<0CW3@00L0000004]Z``1;J/<0Bf[30=@m6@1;J/<0000000<0Bf[30P3D
?AT00`000000AF2^04EP[P0304EP[P0500000015H:h0000003aAT00000000`0lDI001@000000;ciZ
03eIZ`3D?AT0000000<0ooK^00<0e3dI0?ofkP3om^h03P3om^h30=@m6@030?ofkP3D?AT0ooK^00L0
ooK^0`3D?AT90?ofkP070=@m6@3om^h0ooK^0?ofkP000000ooK^0=@m6@0>0?ofkP<0e3dI503om^h0
0`3D?AT0ooK^0?ofkP0G0?ofkP030000003om^h0ooK^03L0ooK^0@3oool00100ooK^00<000000?of
kP3om^h0E03om^h203eIZ`@0ooK^0P0mFJ/20=@m6@<0ooK^0`3D?AT0100mFJ/0ooK^0?ofkP0mFJ/7
0?ofkP<0e3dI00D0?EV[0?ofkP3om^h0ooK^03eIZ`030=@m6@<0ooK^00<00000070M3@1`7@d01@1`
7@d00`000000L1d=070M3@02070M3@@000000P1`7@d203eIZ`8000000`2;9A000`000000RbD@08/U
400608/U40030000002;9A00RbD@00L0RbD@00<0?EV[08/U400000000`0000040:0/4`030000002P
;1<0X2`C0080?EV[1@2P;1<00`000000X2`C0:0/4`040:0/4`0403eIZ`2P;1<0X2`C000000<0X2`C
0`0000030;0a5@040000002`<AD0/34E03eIZ`H0/34E00@000000;0a5@2`<AD0?EV[1P2`<AD00`00
0000/34E0;0a5@040;0a5@0403eIZ`2`<AD000000;0a5@@000000P2n=QL00`0mFJ/0_SHG00000007
0;hf5`030000001@LmT0D7?I00<0D7?I00<0000004i`d01>L=00101>L=000`000000CW3@04i`d003
04i`d08000000`1;J/<00`3D?AT000000=@m6@020=@m6@80Bf[300<0000004EP[P15H:h00`15H:h0
1P000000AF2^04EP[P000000?56@00000080?56@0P000000100_?VX0e3dI0000000000030?ofkP03
0=@m6@3om^h0ooK^00X0ooK^0`3D?AT40?ofkP80e3dI103om^h30=@m6@`0ooK^00<0e3dI0?ofkP3o
m^h00P3om^h00`000000e3dI0?ofkP0:0?ofkP<0e3dI00<0ooK^0=@m6@3om^h0503om^h00`3D?AT0
ooK^0?ofkP0G0?ofkP800000>03om^h10?ooo`00403om^h00`000000ooK^0?ofkP1E0?ofkP80?EV[
0`3D?AT00`3om^h0?EV[03eIZ`020?ofkP@0e3dI0P3om^h00`0mFJ/0ooK^03eIZ`050?ofkP80e3dI
103om^h0100mFJ/0e3dI03eIZ`3D?AT30?ofkP80e3dI00<0ooK^0000001`7@d01P1`7@d00`000000
L1d=070M3@02000000<0L1d=00H0000003eIZ`0mFJ/0000008/U400mFJ/408/U40030000002;9A00
RbD@00H0RbD@00<0000008/U402;9A001P2;9A020000000303eIZ`2P;1<0X2`C00H0X2`C00<00000
0:0/4`0mFJ/01`2P;1<00`000000X2`C0:0/4`050:0/4`0403eIZ`2P;1<000000:0/4`8000001P2`
<AD00`000000/34E03eIZ`070;0a5@050000002`<AD0/34E0;0a5@0mFJ/01@2`<AD00`000000/34E
0;0a5@030;0a5@0303eIZ`2`<AD00000008000001P2n=QL00`0mFJ/0_SHG000000070;hf5`030000
001@LmT0D7?I00<0D7?I0P00000504i`d0030000001>L=00CW3@00<0CW3@00@0000004i`d0000000
Bf[30`3D?AT504]Z``8000000`15H:h00`000000AF2^04EP[P0204EP[P8000000P0lDI001@000000
?56@0000000mFJ/0e3dI008000000P3om^h00`3D?AT0ooK^0?ofkP060?ofkP@0e3dI203om^h00`3D
?AT0ooK^0=@m6@020=@m6A00ooK^00<0e3dI0?ofkP3om^h00P3om^h00`000000e3dI0?ofkP060?of
kP<0e3dI103om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^01@0ooK^0`0000000`3o
m^h000000?ofkP0g0?ofkP40oooo000@0?ofkP030000003om^h0ooK^05@0ooK^0`3D?AT00`0mFJ/0
e3dI0=@m6@020=@m6@0303eIZ`3D?AT0e3dI0080e3dI0P3om^h2000000030?ofkP0mFJ/0?EV[0080
ooK^0`3D?AT40?ofkP<0e3dI0P0mFJ/60?ofkP030000001`7@d0L1d=00H0L1d=0`000003070M3@<0
?EV[00<0000008/U402;9A000P2;9A001@0mFJ/0RbD@08/U402;9A00000000P0RbD@00<0000008/U
402;9A00102;9A02000000040:0/4`000000X2`C03eIZ`L0X2`C00<0000003eIZ`2P;1<01`2P;1<0
0`000000X2`C0:0/4`060:0/4`0303eIZ`000000000000P0/34E00<0000003eIZ`2`<AD01`2`<AD0
0`000000/34E0;0a5@020;0a5@0303eIZ`2`<AD0/34E0080/34E00<000000;0a5@2`<AD00P2`<AD0
1@0mFJ/000000000002n=QL0000000P0_SHG00<0?EV[0;hf5`2n=QL01@2n=QL00`0mFJ/00000051c
f@04051cf@030000001@LmT0000000@0CW3@00<0000004i`d01>L=000`1>L=001`000000e3dI0=@m
6@3D?AT0Bf[30=@m6@0000001@1;J/<00`000000Bf[30000000204EP[P0300000015H:h0AF2^00<0
AF2^00@0000003aAT00lDI00?56@0P000000100_?VX0e3dI02lnJP0000020?ofkP030=@m6@3om^h0
ooK^00<0ooK^0`3D?AT;0?ofkP<0e3dI4`3om^h00`3D?AT0ooK^0?ofkP020?ofkP030000003D?AT0
ooK^00@0ooK^0P3D?AT80?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h0403om^h3
000000@0ooK^00<000000?ofkP3om^h0=P3om^h10?ooo`00403om^h00`000000ooK^0?ofkP1B0?of
kP<0e3dI0`3om^h203eIZ`040=@m6@3om^h0e3dI03eIZ`80ooK^103D?AT0103om^h000000=@m6@0m
FJ/20=@m6@@0ooK^0`3D?AT40?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<00000070M3@1`7@d00`1`
7@d3000000<0L1d=0`0mFJ/00`000000RbD@0000000608/U400403eIZ`2;9A00RbD@000000P0RbD@
00@0000008/U402;9A00RbD@0`0000030:0/4`040000002P;1<0X2`C03eIZ`H0X2`C00<0?EV[0:0/
4`2P;1<01`2P;1<00`000000X2`C0:0/4`040:0/4`80000000<0/34E03eIZ`2`<AD0202`<AD00`0m
FJ/0/34E0;0a5@070;0a5@030000002`<AD0/34E00<0/34E00H0?EV[0;0a5@2`<AD0/34E0000002`
<AD30000000503eIZ`2n=QL0_SHG0;hf5`000000202n=QL00`000000?EV[0;hf5`040;hf5`0303eI
Z`2n=QL0e3dI00@0D7?I00D00000051cf@1@LmT0D7?I0000000204i`d0030000001>L=00CW3@0080
CW3@0`3D?AT204i`d0040000001;J/<000000=@m6@D0Bf[300<0000004]Z``0000000P15H:h00`00
0000AF2^04EP[P0304EP[P8000000P0lDI001@000000?56@0000000mFJ/0e3dI008000000P3om^h0
0`3D?AT0ooK^0=@m6@020=@m6@/0ooK^0`3D?AT00`3om^h0e3dI0?ofkP0C0?ofkP030=@m6@3om^h0
ooK^00<0ooK^00<000000=@m6@3om^h00`3D?AT:0?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI
0?ofkP3om^h03@3om^h3000000P0ooK^00<000000?ofkP3om^h0=@3om^h10?ooo`003`3om^h00`00
0000ooK^0?ofkP1@0?ofkP<0e3dI1`3om^h303eIZ`030?ofkP0mFJ/0?EV[00D0ooK^0`3D?AT203eI
Z`<0ooK^0P3D?AT60?ofkP030=@m6@0mFJ/0?EV[00@0ooK^00<0e3dI0000001`7@d00P1`7@d20000
0080L1d=00D00000070M3@0mFJ/0?EV[0000000408/U40030000002;9A00RbD@00D0RbD@00<0?EV[
08/U40000000202;9A0010000000RbD@0000000000070:0/4`040000002P;1<0X2`C03eIZ`<0X2`C
0P0mFJ/00`2P;1<000000:0/4`080:0/4`040000002P;1<0X2`C0:0/4`8000000`2`<AD00`000000
?EV[0;0a5@060;0a5@0303eIZ`000000/34E00P0/34E00<000000;0a5@2`<AD0102`<AD00`0mFJ/0
/34E0000000200000080_SHG00<0?EV[0;hf5`2n=QL00P2n=QL00`000000_SHG0;hf5`060;hf5`03
0000002n=QL0?EV[00@0_SHG00<0?EV[0;hf5`3D?AT0101@LmT00`000000D7?I051cf@02051cf@04
0000001>L=00000004i`d0<0e3dI00<0CW3@0000001>L=000`1>L=02000000030=@m6@1;J/<0Bf[3
00<0Bf[300H0000004]Z``1;J/<0000004EP[P00000504EP[P0500000015H:h0000003aAT0000000
0P0lDI000`000000e3dI02lnJP02000000030?ofkP3D?AT0e3dI00/0ooK^0`3D?AT50?ofkP030=@m
6@3om^h0ooK^0140ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT000000=@m6@0=0?ofkP030=@m
6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h02P3om^h3000000/0ooK^00<000000?ofkP3om^h0
=@3om^h10?ooo`003`3om^h00`000000ooK^0?ofkP1>0?ofkP80e3dI203om^h30=@m6@L0?EV[103o
m^h00`3D?AT0ooK^0=@m6@0203eIZ`80e3dI203om^h0103D?AT0?EV[0?ofkP0mFJ/30=@m6@030?of
kP0000000000008000000`1`7@d303eIZ`L0RbD@00<0000008/U402;9A001P2;9A000`0mFJ/00000
08/U400608/U40<000002@2P;1<01`000000X2`C0:0/4`2P;1<0?EV[0:0/4`0mFJ/00`2P;1<00`00
0000X2`C0:0/4`070:0/4`040000002P;1<00000000000D0/34E00<000000;0a5@0mFJ/01@2`<AD0
100mFJ/0/34E0;0a5@0000080;0a5@030000002`<AD0/34E00@0/34E00@0000003eIZ`2n=QL00000
0P2n=QL00`0mFJ/0_SHG0;hf5`030;hf5`030000002n=QL0_SHG00H0_SHG00@000000;hf5`2n=QL0
?EV[0P2n=QL01@0mFJ/0_SHG0;hf5`000000e3dI00<0D7?I00<00000051cf@1@LmT00P1@LmT40=@m
6@@0CW3@00<0000004i`d01>L=000`1>L=000`000000e3dI04]Z``0404]Z``040000001;J/<0Bf[3
04]Z``8000001@15H:h01@000000AF2^0000000lDI00000000<0?56@00<0e3dI02lnJP0000000P00
00000`3D?AT0ooK^0?ofkP070?ofkP<0e3dI203om^h00`3D?AT0ooK^0?ofkP0B0?ofkP030=@m6@3o
m^h0e3dI0080e3dI00<0ooK^0000003D?AT03@3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3o
m^h0ooK^00L0ooK^0`00000>0?ofkP030000003om^h0ooK^03D0ooK^0@3oool000l0ooK^00<00000
0?ofkP3om^h0C@3om^h00`3D?AT0ooK^0?ofkP050?ofkP@0e3dI0`3om^h203eIZ`030?ofkP0mFJ/0
?EV[0080?EV[0P3om^h01P3D?AT0ooK^0=@m6@3D?AT0?EV[0=@m6@80?EV[203om^h01@3D?AT0?EV[
0=@m6@3D?AT0?EV[0080ooK^0P000002070M3@@0?EV[00<0e3dI0000002;9A001`2;9A000`000000
RbD@08/U400708/U400303eIZ`2;9A00RbD@0080RbD@0`0000000`2P;1<000000:0/4`090:0/4`03
0000002P;1<0X2`C0080X2`C00<0?EV[0:0/4`2P;1<00P2P;1<00`000000X2`C0:0/4`060:0/4`<0
0000202`<AD00`000000/34E03eIZ`030;0a5@0503eIZ`2`<AD0/34E0;0a5@000000202`<AD01000
0000/34E0;0a5@2`<AD300000080_SHG00@0?EV[0000002n=QL0?EV[1P2n=QL00`000000_SHG0;hf
5`060;hf5`0;0000002n=QL0_SHG0;hf5`0mFJ/0_SHG03eIZ`2n=QL00000051cf@3D?AT00`1@LmT0
0`000000D7?I0=@m6@020=@m6@80D7?I00<0000004i`d01>L=000`1>L=000`000000CW3@04i`d003
04i`d080000000D0e3dI04]Z``1;J/<0Bf[30000000504]Z``0300000015H:h0AF2^00<0AF2^00H0
000004EP[P15H:h0000003aAT000000203aAT0040000003D?AT0000002lnJP8000001`3om^h20=@m
6@/0ooK^0P3D?ATB0?ofkP<0e3dI1@3om^h00`000000ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^
01@0ooK^00<0e3dI0?ofkP3om^h00P3om^h400000140ooK^00<000000?ofkP3om^h0=@3om^h10?oo
o`003`3om^h00`000000ooK^0?ofkP1<0?ofkP030=@m6@3om^h0ooK^00<0ooK^0`3D?AT30?ofkP03
0=@m6@3om^h0ooK^0080ooK^0P0mFJ/00`3om^h0?EV[0?ofkP0303eIZ`80e3dI0P3om^h01@0mFJ/0
00000=@m6@3D?AT0?EV[00H0ooK^0P3D?AT00`0mFJ/0ooK^0?ofkP03000000@0?EV[0P000000102;
9A00?EV[08/U4000000808/U40030000002;9A00RbD@00L0RbD@00<0000003eIZ`0mFJ/00P000004
0:0/4`030000002P;1<0X2`C00P0X2`C00<000000:0/4`2P;1<00P0mFJ/00`2P;1<0?EV[0:0/4`02
0:0/4`030000002P;1<0X2`C00<0X2`C0`0000000`2`<AD000000;0a5@080;0a5@060000002`<AD0
/34E03eIZ`2`<AD0?EV[102`<AD00`000000/34E0;0a5@060;0a5@040000002`<AD00000000000H0
_SHG00<0?EV[0;hf5`0mFJ/01P2n=QL00`000000_SHG0;hf5`060;hf5`030000002n=QL0_SHG0080
_SHG00@0?EV[0;hf5`2n=QL000000P1@LmT00`3D?AT0D7?I0=@m6@020=@m6@D0D7?I0P00000404i`
d0030000001>L=00CW3@0080CW3@00@0000004i`d01>L=00e3dI0`1;J/<00`000000Bf[304]Z``03
04]Z``8000000`15H:h00`000000AF2^04EP[P0204EP[P8000000P0lDI001`000000e3dI02lnJP00
0000;ciZ0000003D?AT00`3om^h30=@m6@h0ooK^00<0e3dI0?ofkP3om^h03@3om^h30=@m6@030?of
kP3D?AT0ooK^00D0ooK^00<0e3dI0000003om^h0303om^h00`3D?AT0ooK^0?ofkP0B0?ofkP80e3dI
00@0ooK^00000000000000005@3om^h00`000000ooK^0?ofkP0e0?ofkP40oooo000?0?ofkP030000
003om^h0ooK^04/0ooK^00<0e3dI0?ofkP3om^h00P3om^h20=@m6@D0ooK^00<0e3dI0?ofkP3om^h0
103om^h303eIZ`030?ofkP3D?AT0e3dI00T0?EV[00@0e3dI03eIZ`3om^h0ooK^0`3D?AT00`3om^h0
e3dI00000002000000<0?EV[00@00000070M3@0000000000102;9A000`0mFJ/0000008/U400808/U
40030000002;9A00RbD@00D0RbD@0`0000000`2P;1<0?EV[0:0/4`050:0/4`030000002P;1<0X2`C
00L0X2`C00<0000003eIZ`0mFJ/0102P;1<01@0mFJ/0X2`C0:0/4`000000X2`C00@00000102`<AD0
0`000000/34E0;0a5@070;0a5@050000002`<AD0/34E0;0a5@0mFJ/01@2`<AD00`000000/34E0;0a
5@050;0a5@<00000202n=QL00`000000?EV[0;hf5`050;hf5`030000002n=QL0_SHG00L0_SHG00X0
00000;hf5`2n=QL0_SHG03eIZ`2n=QL0?EV[0;hf5`000000D7?I0`3D?AT00`000000D7?I051cf@04
051cf@040000001@LmT0D7?I000000<0CW3@00<0000004i`d01>L=000P1>L=001@000000CW3@04i`
d03D?AT000000080Bf[300<0000004]Z``1;J/<00`1;J/<00`000000Bf[30000000204EP[P030000
0015H:h0AF2^00<0AF2^00D0000003aAT00lDI0000000=@m6@020000000302lnJP000000000000<0
e3dI4@3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP<0e3dI103om^h00`3D?AT0ooK^0?ofkP050?ofkP03
0=@m6@000000ooK^00/0ooK^00<0e3dI0?ofkP3om^h03P3om^h40=@m6@030000003D?AT0000001T0
ooK^00<000000?ofkP3om^h0=03om^h10?ooo`003P3om^h00`000000ooK^0?ofkP1;0?ofkP030=@m
6@3om^h0ooK^00<0e3dI1`3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@0mFJ/0?EV[0080ooK^
00@0e3dI03eIZ`3om^h0?EV[0P3om^h00`0mFJ/0ooK^0000000703eIZ`80000000<0?EV[0?ofkP3o
m^h00P3om^h00`3D?AT0?EV[0000000708/U400303eIZ`2;9A00RbD@00L0RbD@00<0000008/U402;
9A000`2;9A02000000030:0/4`000000X2`C0080X2`C00<0?EV[0:0/4`2P;1<00`2P;1<00`000000
X2`C0:0/4`060:0/4`80?EV[1`2P;1<0100mFJ/000000000000000080;0a5@030000002`<AD0/34E
00L0/34E00H000000;0a5@0mFJ/0?EV[0;0a5@0mFJ/40;0a5@030000002`<AD0/34E0080/34E0`00
00000`2n=QL000000;hf5`080;hf5`0303eIZ`2n=QL0?EV[00D0_SHG00<000000;hf5`2n=QL01P2n
=QL00`000000_SHG0;hf5`020;hf5`0403eIZ`2n=QL0_SHG03eIZ`80e3dI00@0D7?I0=@m6@1@LmT0
00001P1@LmT010000000D7?I051cf@00000204i`d0030000001>L=00CW3@00<0CW3@00P0000004i`
d01>L=00CW3@0=@m6@000000Bf[3000000D0Bf[300<0000004]Z``0000000P15H:h00`000000AF2^
04EP[P0304EP[P80000000D0?56@0000000lDI00e3dI000000030=@m6@030000003om^h0ooK^0140
ooK^0P3D?AT70?ofkP@0e3dI203om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@000000ooK^00/0
ooK^00<0e3dI0?ofkP3om^h02`3om^h30=@m6@060?ofkP00000000000000003om^h0e3dI6P3om^h0
0`000000ooK^0?ofkP0d0?ofkP40oooo000>0?ofkP030000003om^h0ooK^04X0ooK^103D?AT90?of
kP030=@m6@3om^h0ooK^00@0ooK^0P3D?AT20?ofkP0:03eIZ`3om^h0ooK^0=@m6@3om^h0?EV[0?of
kP0mFJ/0ooK^03eIZ`<0ooK^00<000000?ofkP0mFJ/00`0000000`0mFJ/0ooK^03eIZ`020?ofkP80
e3dI00<0ooK^0000002;9A001`2;9A000`000000?EV[08/U400708/U40040000002;9A00RbD@08/U
408000000`2P;1<00`000000X2`C0:0/4`020:0/4`0303eIZ`2P;1<0X2`C0080X2`C00<000000:0/
4`2P;1<0102P;1<203eIZ`80X2`C00<000000:0/4`2P;1<00P2P;1<30000000303eIZ`000000/34E
00T0/34E00<000000;0a5@2`<AD01P2`<AD00`000000?EV[0;0a5@030;0a5@0603eIZ`2`<AD0/34E
0;0a5@000000/34E0`0000040;hf5`030000002n=QL0_SHG00H0_SHG00D0?EV[0000002n=QL0_SHG
03eIZ`040;hf5`030000002n=QL0_SHG00H0_SHG00D000000;hf5`2n=QL0_SHG03eIZ`0300000003
0</j6@00000000000080D7?I00<0e3dI0000001@LmT01@1@LmT01`000000D7?I051cf@1@LmT00000
04i`d00000001@1>L=001P000000CW3@04i`d01>L=00e3dI04i`d08000001@1;J/<01P000000Bf[3
04]Z``000000AF2^000000D0AF2^0P0000000`0lDI00?EV[0=@m6@020=@m6@030000000_?VX00000
008000004P3om^h20=@m6@@0ooK^0`3D?AT<0?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0000
003om^h02P3om^h00`3D?AT0ooK^0?ofkP070?ofkP@0e3dI00@0ooK^0000000000000000103om^h0
0`3D?AT0ooK^0?ofkP0H0?ofkP030000003om^h0ooK^03@0ooK^0@3oool000h0ooK^00<000000?of
kP3om^h0B@3om^h20=@m6@`0ooK^00<0e3dI0?ofkP3om^h00P3om^h20=@m6@D0ooK^0P0mFJ/00`3D
?AT0ooK^0?ofkP0403eIZ`<0ooK^0`000000100mFJ/0ooK^0?ofkP3D?AT203eIZ`80e3dI0`3om^h0
0`000000RbD@08/U400608/U40030000002;9A00?EV[00L0RbD@00@0000008/U4000000000001P2P
;1<00`000000X2`C0:0/4`020:0/4`0503eIZ`2P;1<0X2`C0:0/4`000000102P;1<203eIZ`@0X2`C
00<000000:0/4`0000000P0000040;0a5@0303eIZ`2`<AD0/34E00P0/34E00<000000;0a5@2`<AD0
1P2`<AD00`0mFJ/0/34E0;0a5@040;0a5@0303eIZ`2`<AD00000008000001`2n=QL00`000000_SHG
0;hf5`050;hf5`0303eIZ`2n=QL0000000<0_SHG00D0?EV[0;hf5`2n=QL0_SHG000000080;hf5`05
0000002n=QL0000003eIZ`0000000`3;>QT00`000000DGGN00000002051cf@030=@m6@000000D7?I
00D0D7?I00<00000051cf@1@LmT00P1@LmT2000000@0CW3@00<0000004i`d01>L=000`1>L=000`3D
?AT0CW3@0000000504]Z``040000001;J/<0Bf[304]Z``8000001@15H:h020000000e3dI0=@m6@3D
?AT000000=@m6@0lDI0000000P0_?VX300000180ooK^1@3D?AT?0?ofkP030=@m6@3om^h0ooK^00@0
ooK^0P3D?AT00`3om^h000000?ofkP0:0?ofkP030=@m6@3om^h0ooK^00<0ooK^0`3D?AT20?ofkP<0
0000203om^h00`3D?AT0ooK^0?ofkP0G0?ofkP030000003om^h0ooK^03@0ooK^0@3oool000h0ooK^
00<000000?ofkP3om^h0B03om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00<0e3dI
203om^h203eIZ`@0ooK^0P0mFJ/00`3om^h00000000000020?ofkP040000003om^h0?EV[03eIZ`80
e3dI00<0?EV[0?ofkP3om^h00`3om^h00`000000RbD@08/U400608/U40040000002;9A00RbD@03eI
Z`D0RbD@0`0000080:0/4`030000002P;1<0X2`C00<0X2`C00@0?EV[0:0/4`2P;1<000000P2P;1<2
03eIZ`D0X2`C0`0000080;0a5@0303eIZ`2`<AD0/34E00L0/34E00<000000;0a5@2`<AD0102`<AD2
03eIZ`030;0a5@000000/34E00<0/34E0P0000000`0mFJ/0_SHG000000080;hf5`030000002n=QL0
_SHG00@0_SHG00@0?EV[0;hf5`2n=QL000000`2n=QL01@0mFJ/0_SHG0;hf5`2n=QL0000000L0_SHG
0`0000000`3;>QT0?EV[0</j6@030</j6@070000001AMMh0DGGN0000001@LmT0e3dI00000005051c
f@030000001@LmT0D7?I00@0D7?I00<0000004i`d01>L=000P1>L=000`000000CW3@04i`d00304i`
d0040=@m6@1>L=000000000000<0Bf[300<0000004]Z``1;J/<00`1;J/<00`000000AF2^04EP[P02
04EP[P80e3dI0P15H:h20000000503aAT03D?AT000000000000_?VX00P0000000`0R:dd0ooK^0?of
kP0?0?ofkP<0e3dI4P3om^h0103D?AT0ooK^0?ofkP3om^h30=@m6@050?ofkP3D?AT0ooK^0?ofkP00
00002P3om^h00`3D?AT0ooK^0=@m6@030=@m6@80ooK^0`00000;0?ofkP030=@m6@3om^h0ooK^01L0
ooK^00<000000?ofkP3om^h0=03om^h10?ooo`003@3om^h00`000000ooK^0?ofkP190?ofkP030=@m
6@3om^h0ooK^00/0ooK^0`3D?AT;0?ofkP030=@m6@0mFJ/0?EV[00<0ooK^0`0000050?ofkP<0e3dI
00@0?EV[0?ofkP0mFJ/0?EV[103om^h00`000000RbD@08/U400608/U40040000002;9A00RbD@08/U
4080?EV[0`0000000`2P;1<000000:0/4`080:0/4`030000002P;1<0X2`C00@0X2`C00<0?EV[0:0/
4`0000000P0mFJ/50:0/4`80000000<0/34E0000002`<AD0202`<AD00`000000?EV[03eIZ`070;0a
5@030000002`<AD0/34E00<0/34E00H0?EV[0;0a5@2`<AD0/34E0000002`<AD3000000<0_SHG00<0
?EV[0000002n=QL01`2n=QL00`000000_SHG0;hf5`030;hf5`0503eIZ`2n=QL0_SHG0;hf5`000000
102n=QL0100mFJ/0_SHG0;hf5`0000040;hf5`<0000000@0bcXI0000003;>QT0?EV[1@3;>QT01000
0000DGGN055egP1AMMh2000000030=@m6@1@LmT0D7?I00<0D7?I00<00000051cf@1@LmT0101@LmT2
000000<0CW3@00<0000004i`d01>L=000`1>L=001@3D?AT0000004i`d01>L=0000000080Bf[300<0
000004]Z``1;J/<00`1;J/<2000000<0e3dI00`0000004EP[P15H:h0AF2^0000000mFJ/0?56@0=@m
6@000000?56@0000000_?VX200000003028[C@3om^h0ooK^00/0ooK^0`3D?AT0103om^h0e3dI0?of
kP3D?ATA0?ofkP@0e3dI1@3om^h00`3D?AT0ooK^000000090?ofkP<0e3dI0`3om^h3000000h0ooK^
00<0e3dI0?ofkP3om^h05`3om^h00`000000ooK^0?ofkP0d0?ofkP40oooo000=0?ofkP030000003o
m^h0ooK^04P0ooK^00<0e3dI0?ofkP3om^h02P3om^h30=@m6@d0ooK^00<0e3dI0?ofkP0mFJ/00`00
00020?ofkP80?EV[00P0ooK^0=@m6@3D?AT0e3dI0?ofkP000000ooK^0=@m6@80?EV[00<0ooK^03eI
Z`3om^h00P3om^h00`000000RbD@08/U400608/U40030000002;9A00000000<0000000D0?EV[0:0/
4`2P;1<0X2`C000000090:0/4`030000002P;1<0X2`C00@0X2`C0`0mFJ/010000000X2`C0:0/4`2P
;1<3000000<0/34E00<000000;0a5@2`<AD01`2`<AD010000000/34E0;0a5@0mFJ/60;0a5@030000
002`<AD0/34E0080/34E00@0?EV[0;0a5@2`<AD0/34E0`0000070;hf5`0303eIZ`2n=QL0_SHG00H0
_SHG00<000000;hf5`2n=QL00P2n=QL00`0mFJ/0_SHG0;hf5`020;hf5`030000002n=QL0_SHG00<0
_SHG00@0?EV[0;hf5`000000_SHG0`0000040</j6@030000000mFJ/0bcXI00D0bcXI00@00000055e
gP1AMMh0DGGN0P0000000`3D?AT0D7?I051cf@03051cf@030000001@LmT0D7?I00<0D7?I00@00000
051cf@1@LmT000000P1>L=000`000000CW3@04i`d00404i`d0040=@m6@1>L=00CW3@00000080Bf[3
00<0000004]Z``1;J/<00P1;J/<30=@m6@0400000015H:h0AF2^000000@0AF2^00P0000003aAT00l
DI00e3dI0000000lDI00000003eIZ`<000002P3om^h20=@m6@@0ooK^00<0e3dI0?ofkP3D?AT03`3o
m^h40=@m6@L0ooK^00@0e3dI0?ofkP3om^h000001@3om^h30=@m6@030?ofkP3D?AT0ooK^00<00000
4@3om^h00`3D?AT0ooK^0?ofkP0H0?ofkP030000003om^h0ooK^03<0ooK^0@3oool000d0ooK^00<0
00000?ofkP3om^h0B03om^h00`3D?AT0ooK^0?ofkP070?ofkP<0e3dI00<0ooK^0=@m6@3om^h03@3o
m^h00`3D?AT000000000000203eIZ`@0ooK^0`0mFJ/40?ofkP040000003D?AT0ooK^03eIZ`80ooK^
00@0?EV[0?ofkP3om^h000001`2;9A03000000D0X2`C00D0?EV[0:0/4`2P;1<0X2`C000000080:0/
4`030000002P;1<0X2`C0080X2`C0P0mFJ/20:0/4`0303eIZ`000000X2`C008000001`2`<AD00`00
0000/34E0;0a5@060;0a5@050000002`<AD0/34E0;0a5@0mFJ/01@2`<AD00`000000/34E0;0a5@02
03eIZ`80/34E0P0000000`2n=QL000000;hf5`070;hf5`0303eIZ`000000_SHG00L0_SHG00@00000
0;hf5`2n=QL0?EV[1@2n=QL00`000000_SHG0;hf5`040;hf5`0303eIZ`000000000000L0bcXI00<0
000003eIZ`3;>QT0103;>QT00`000000DGGN055egP03055egP030000003D?AT0D7?I00<0D7?I00<0
0000051cf@1@LmT0101@LmT01P000000D7?I051cf@000000CW3@000000L0CW3@00P0e3dI04i`d01>
L=00CW3@0000001;J/<0000004]Z``<0e3dI00@0000004]Z``1;J/<000000P15H:h00`000000AF2^
04EP[P0204EP[P80000000<0?56@0=@m6@0000000P0lDI05000000H0ooK^0`3D?AT70?ofkP80e3dI
303om^h30=@m6@<0ooK^00<0e3dI0?ofkP3om^h01P3om^h01@3D?AT0ooK^0?ofkP000000ooK^00<0
e3dI0`3om^h00`000000e3dI0000000D0?ofkP030=@m6@3om^h0ooK^01P0ooK^00<000000?ofkP3o
m^h0<`3om^h10?ooo`003@3om^h00`000000ooK^0?ofkP170?ofkP030=@m6@3om^h0ooK^00D0ooK^
0`3D?AT30?ofkP030=@m6@3om^h0ooK^00/0ooK^0`0000040?ofkP0403eIZ`3D?AT0e3dI0=@m6@80
?EV[00<0ooK^03eIZ`3om^h00`3om^h0103D?AT0000003eIZ`0mFJ/20?ofkP80?EV[00<0000008/U
402;9A000`2;9A02000000030:0/4`000000X2`C00H0X2`C00@0?EV[0:0/4`2P;1<00000202P;1<0
0`000000X2`C03eIZ`0203eIZ`@0X2`C00<0000003eIZ`0000002@2`<AD00`000000/34E0;0a5@07
0;0a5@050000002`<AD0/34E0;0a5@0mFJ/01@2`<AD010000000?EV[0;0a5@2`<AD2000000<0_SHG
00<000000;hf5`2n=QL01`2n=QL00`0mFJ/0_SHG0;hf5`060;hf5`040000002n=QL0_SHG03eIZ`D0
_SHG00<000000;hf5`2n=QL00P2n=QL2000000030</j6@0mFJ/0bcXI00H0bcXI00<0000003eIZ`3;
>QT01@3;>QT00`000000DGGN055egP03055egP80000000D0e3dI051cf@1@LmT0D7?I00000006051c
f@040000001@LmT0D7?I051cf@8000001P1>L=000`000000e3dI04i`d00304i`d0030000003D?AT0
e3dI00<0Bf[300L0000004]Z``1;J/<0Bf[300000015H:h0000000@0AF2^00D0000004EP[P000000
?56@0=@m6@0303aAT080000000<0;ciZ0000000000000P3om^h30=@m6@X0ooK^00<0e3dI0?ofkP3D
?AT0203om^h30=@m6@H0ooK^00<0e3dI0?ofkP3om^h01P3om^h01@3D?AT0ooK^0?ofkP000000e3dI
00<0ooK^0`0000020?ofkP030=@m6@3om^h0ooK^0180ooK^00<0e3dI0?ofkP3om^h0603om^h00`00
0000ooK^0?ofkP0c0?ofkP40oooo000=0?ofkP030000003om^h0ooK^04L0ooK^00<0e3dI0?ofkP3o
m^h00`3om^h20=@m6@H0ooK^00<0e3dI0?ofkP3om^h02@3om^h2000000030?ofkP3D?AT0ooK^0080
ooK^0`3D?AT0100mFJ/0ooK^0?ofkP3om^h403eIZ`<0ooK^00<0e3dI0?ofkP0000000P0mFJ/0103D
?AT0ooK^0?ofkP0mFJ/308/U40800000102P;1<00`000000X2`C0:0/4`050:0/4`0303eIZ`2P;1<0
000000L0X2`C0`0mFJ/40:0/4`<0000000<0/34E0000000mFJ/02@2`<AD00`000000/34E0;0a5@07
0;0a5@030000002`<AD0/34E0080/34E00<0?EV[0;0a5@2`<AD00P2`<AD0100mFJ/0/34E00000000
00050;hf5`030000002n=QL0_SHG00L0_SHG00<0000003eIZ`2n=QL01P2n=QL00`000000_SHG03eI
Z`060;hf5`030000002n=QL00000008000000`3;>QT00`000000?EV[0</j6@050</j6@0303eIZ`3;
>QT0bcXI00D0bcXI00<00000055egP1AMMh00P1AMMh010000000DGGN055egP3D?AT3051cf@030000
001@LmT0D7?I00<0D7?I00<00000051cf@1@LmT00`1@LmT00`000000CW3@04i`d00404i`d0040000
001>L=00e3dI04i`d0<0e3dI00<0000004]Z``1;J/<00P1;J/<00`000000Bf[304]Z``0204]Z``80
00001015H:h01@000000AF2^0000000lDI00e3dI00<0?56@0`000000100_?VX000000=@m6@3D?AT=
0?ofkP030=@m6@3om^h0e3dI00D0ooK^0`3D?AT90?ofkP030=@m6@3om^h0ooK^00H0ooK^0`3D?AT0
0`3om^h0000000000002000000D0ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP0G
0?ofkP030000003om^h0ooK^03<0ooK^0@3oool000`0ooK^00<000000?ofkP3om^h0A`3om^h0103D
?AT0ooK^0?ofkP3om^h30=@m6@P0ooK^00<0e3dI0?ofkP3om^h01P3om^h3000000<0ooK^00@0e3dI
0?ofkP3D?AT0e3dI103om^h203eIZ`040?ofkP0mFJ/0ooK^0?ofkP80?EV[0P3om^h01P3D?AT0ooK^
0?ofkP0mFJ/0ooK^03eIZ`80ooK^00@0000003eIZ`00000000001P2P;1<00`000000X2`C0:0/4`06
0:0/4`0303eIZ`000000X2`C00@0X2`C0P0mFJ/20:0/4`030000002P;1<00000008000001@2`<AD0
0`000000?EV[0;0a5@070;0a5@030000002`<AD0/34E00L0/34E00<000000;0a5@2`<AD00`2`<AD0
100mFJ/0/34E03eIZ`0mFJ/2000000P0_SHG00<000000;hf5`2n=QL01P2n=QL00`000000_SHG03eI
Z`060;hf5`030000000mFJ/0_SHG00D0_SHG0`0000060</j6@030000003;>QT0?EV[00D0bcXI00<0
?EV[0</j6@3;>QT01@3;>QT00`000000DGGN055egP02055egP050000001AMMh0DGGN055egP3D?AT0
0P1@LmT00`000000D7?I051cf@03051cf@030000001@LmT0D7?I00<0D7?I0P00000504i`d0040000
003D?AT0e3dI0=@m6@<0CW3@0P00000304]Z``030000001;J/<0Bf[300<0Bf[300<0000004EP[P15
H:h00P15H:h01P000000AF2^04EP[P000000e3dI00000080?56@0`00000202lnJP030000003om^h0
ooK^00`0ooK^00D0e3dI0?ofkP3om^h0e3dI0?ofkP030=@m6@d0ooK^00<0e3dI0?ofkP3om^h00P3o
m^h30=@m6@060?ofkP3D?AT000000000003om^h000001`3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP03
0=@m6@3om^h0ooK^01L0ooK^00<000000?ofkP3om^h0<`3om^h10?ooo`00303om^h00`000000ooK^
0?ofkP170?ofkP@0e3dI2`3om^h00`3D?AT0ooK^0?ofkP030?ofkP<000001@3om^h30=@m6@L0ooK^
100mFJ/20?ofkP80?EV[00T0ooK^0=@m6@3om^h0ooK^03eIZ`000000ooK^03eIZ`3om^h00P000000
0`0mFJ/0X2`C0:0/4`050:0/4`030000002P;1<0X2`C00L0X2`C00<0?EV[0:0/4`2P;1<00`0mFJ/3
0:0/4`<00000202`<AD00`000000/34E03eIZ`080;0a5@030000002`<AD0/34E00H0/34E00<00000
0;0a5@2`<AD00`2`<AD01@000000?EV[0000002n=QL0000000T0_SHG00<000000;hf5`2n=QL01P2n
=QL010000000_SHG0;hf5`0mFJ/50;hf5`0303eIZ`2n=QL0_SHG0080_SHG0`0000000`3;>QT00000
0</j6@060</j6@030000003;>QT0?EV[00@0bcXI00<0?EV[0000003;>QT01@3;>QT00`000000DGGN
055egP03055egP050000001AMMh0DGGN055egP3D?AT00P000006051cf@030000001@LmT0D7?I0080
D7?I00@00000051cf@1@LmT000000P1>L=030=@m6@0304i`d03D?AT0CW3@0080CW3@00<0000004i`
d00000000`1;J/<00`000000Bf[304]Z``0304]Z``8000000`15H:h01P000000AF2^04EP[P15H:h0
00000=@m6@<0?56@0`0000000`0_?VX000000000000=0?ofkP030=@m6@3om^h0e3dI0080e3dI403o
m^h00`3D?AT0ooK^0=@m6@020=@m6@060?ofkP00000000000000003om^h0e3dI0`3om^h00`000000
ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h0603om^h00`000000
ooK^0?ofkP0b0?ofkP40oooo000<0?ofkP030000003om^h0ooK^04H0ooK^0P3D?AT=0?ofkP030=@m
6@3om^h0ooK^0080ooK^0P0000060?ofkP80e3dI00<0ooK^0=@m6@3om^h0203om^h203eIZ`040?of
kP0mFJ/0?EV[0?ofkP80?EV[00T0e3dI0?ofkP3om^h0?EV[0?ofkP000000ooK^03eIZ`0000000P2P
;1<00`0mFJ/0X2`C0:0/4`040:0/4`030000002P;1<0X2`C00H0X2`C100mFJ/40:0/4`80000000<0
/34E0000002`<AD0202`<AD010000000/34E0;0a5@0mFJ/70;0a5@030000002`<AD0/34E00L0/34E
00@000000;0a5@00000000000P0mFJ/0102n=QL0?EV[0;hf5`0000090;hf5`030000002n=QL0_SHG
00H0_SHG00D000000;hf5`2n=QL0_SHG03eIZ`030;hf5`0303eIZ`000000_SHG00<00000103;>QT0
0`000000bcXI0</j6@050</j6@040000003;>QT0bcXI03eIZ`80bcXI00<0?EV[0</j6@0000001P3;
>QT00`000000DGGN055egP03055egP070000001AMMh0DGGN055egP3D?AT0DGGN00000006051cf@03
0000001@LmT0D7?I0080D7?I00<00000051cf@1@LmT00`3D?AT00`1>L=00000004i`d00204i`d004
0=@m6@1>L=00CW3@00000080CW3@00@0000004]Z``1;J/<000001@1;J/<00`000000Bf[300000002
04EP[P0300000015H:h0AF2^0080AF2^00L0e3dI03aAT00lDI00?56@0000000lDI0000000080;ciZ
0P00000;0?ofkP<0e3dI0P3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP<0e3dI00@0ooK^000000000000
0000103om^h01@3D?AT0ooK^0?ofkP3om^h0000000L0ooK^00<0e3dI0?ofkP3om^h04@3om^h20=@m
6AX0ooK^00<000000?ofkP3om^h0<P3om^h10?ooo`00303om^h00`000000ooK^0?ofkP160?ofkP03
0=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP0000000P0000050?ofkP<0e3dI0`3om^h00`3D?AT0
ooK^0?ofkP080?ofkP<0?EV[00<0ooK^03eIZ`0mFJ/00P0mFJ/30?ofkP0603eIZ`3om^h000000?of
kP0mFJ/000000P2P;1<00`0mFJ/0X2`C0:0/4`040:0/4`030000002P;1<0X2`C00D0?EV[0P2P;1<0
10000000?EV[0:0/4`2P;1<2000000@0/34E00<000000;0a5@2`<AD01`2`<AD010000000/34E0;0a
5@0mFJ/60;0a5@030000002`<AD0/34E00H0/34E0`00000203eIZ`@0_SHG00<0?EV[0;hf5`000000
202n=QL00`000000_SHG0;hf5`070;hf5`070000002n=QL0_SHG0;hf5`0mFJ/0_SHG03eIZ`030000
00L0bcXI00<000000</j6@3;>QT01@3;>QT02@000000bcXI0</j6@3;>QT0?EV[0</j6@0mFJ/0bcXI
000000060</j6@030000001AMMh0DGGN0080DGGN00<00000055egP1AMMh00`1AMMh00`3D?AT00000
00000004051cf@030000001@LmT0D7?I00<0D7?I0`3D?AT01@1@LmT0000004i`d01>L=00000000<0
CW3@00@0e3dI04i`d01>L=0000000`1>L=02000000D0Bf[300@0000004]Z``1;J/<000000P15H:h0
0`000000AF2^04EP[P0204EP[P060000003D?AT0?56@03aAT0000000?56@0P0000000`0_?VX00000
000000070?ofkP@0e3dI0P3om^h0103D?AT0ooK^0?ofkP3D?AT<0?ofkP<0e3dI00@0ooK^0=@m6@00
00000000203om^h01@3D?AT0ooK^0?ofkP3om^h0000000H0ooK^00<0e3dI0?ofkP3om^h03P3om^h3
0=@m6@030?ofkP3D?AT0ooK^01T0ooK^00<000000?ofkP3om^h0<P3om^h10?ooo`002`3om^h00`00
0000ooK^0?ofkP160?ofkP030=@m6@3om^h0ooK^00`0ooK^0`0000060?ofkP80e3dI1P3om^h00`3D
?AT0ooK^0?ofkP0:0?ofkP80?EV[0`3om^h803eIZ`030=@m6@0mFJ/0?EV[0080X2`C00@0?EV[0:0/
4`2P;1<0X2`C1@0mFJ/70:0/4`040000002P;1<0?EV[000000H0/34E00<000000;0a5@2`<AD01`2`
<AD01@000000/34E0;0a5@2`<AD0?EV[00D0/34E00<000000;0a5@2`<AD00`2`<AD3000000030;hf
5`0mFJ/0?EV[00L0_SHG00<0?EV[0000002n=QL01`2n=QL00`000000_SHG0;hf5`070;hf5`030000
002n=QL0_SHG0080_SHG00@0?EV[0000003;>QT00000203;>QT00`000000bcXI0</j6@050</j6@03
0000003;>QT0bcXI0080bcXI00@0?EV[0</j6@3;>QT000001P3;>QT00`000000DGGN055egP02055e
gP030000001AMMh0DGGN00<0DGGN00@0e3dI055egP1AMMh000000`1@LmT00`000000D7?I0=@m6@03
0=@m6@D0D7?I0P00000504i`d0030=@m6@000000CW3@00<0CW3@0P00000504]Z``070000001;J/<0
Bf[304]Z``000000AF2^0000000404EP[P050000003D?AT0000003aAT00000000P0lDI000`000000
;ciZ02lnJP02000000<0ooK^0`3D?AT60?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT0203om^h30=@m
6@050?ofkP00000000000000003D?AT02P3om^h00`3D?AT0ooK^0?ofkP020?ofkP030000003om^h0
ooK^00<0ooK^00<0e3dI0?ofkP3om^h02P3om^h40=@m6@@0ooK^00<0e3dI0?ofkP3om^h0603om^h0
0`000000ooK^0?ofkP0b0?ofkP40oooo000;0?ofkP030000003om^h0ooK^04H0ooK^00<0e3dI0?of
kP3om^h02P3om^h2000000030?ofkP3D?AT0ooK^00@0ooK^0P3D?AT80?ofkP030=@m6@3om^h0ooK^
00/0ooK^00D0?EV[0?ofkP3om^h0ooK^0=@m6@0203eIZ`030?ofkP0mFJ/0ooK^0080ooK^2@0mFJ/2
0:0/4`030000002P;1<0X2`C00H0X2`C0`0000000`2`<AD0?EV[03eIZ`060;0a5@030000002`<AD0
/34E00L0/34E00D000000;0a5@2`<AD0/34E03eIZ`050;0a5@030000002`<AD00000008000000`2n
=QL00`0mFJ/0_SHG000000080;hf5`0303eIZ`2n=QL0_SHG00H0_SHG00<000000;hf5`2n=QL01`2n
=QL00`000000_SHG0000000203eIZ`040</j6@0mFJ/0bcXI000000P0bcXI00<000000</j6@3;>QT0
103;>QT00`000000bcXI0</j6@020</j6@0503eIZ`3;>QT0?EV[0</j6@0000001@3;>QT00`000000
DGGN055egP03055egP030000001AMMh0DGGN00<0DGGN00H0e3dI055egP1AMMh0DGGN0000001@LmT3
0=@m6@<0D7?I00<00000051cf@1@LmT0101@LmT00`000000CW3@04i`d00304i`d0030=@m6@000000
CW3@00@0CW3@00<0000004]Z``1;J/<00`1;J/<00`000000Bf[304]Z``0204]Z``8000001015H:h0
1@000000AF2^0=@m6@0lDI0000000080?56@0P0000000`0_?VX0000002lnJP030=@m6@T0ooK^00D0
e3dI0?ofkP3om^h0ooK^0=@m6@040?ofkP@0e3dI00@0ooK^0000000000000000103om^h00`3D?AT0
ooK^0?ofkP080?ofkP050=@m6@3om^h0ooK^0?ofkP0000001@3om^h00`3D?AT0ooK^0?ofkP070?of
kP<0e3dI203om^h00`3D?AT0ooK^0?ofkP0H0?ofkP030000003om^h0ooK^0380ooK^0@3oool000/0
ooK^00<000000?ofkP3om^h0AP3om^h00`3D?AT0ooK^0?ofkP070?ofkP<000000P3om^h0103D?AT0
ooK^0?ofkP3om^h30=@m6@X0ooK^00<0e3dI0?ofkP3om^h0303om^h203eIZ`040?ofkP3D?AT0ooK^
0?ofkP80?EV[0`3D?AT00`3om^h000000:0/4`040:0/4`0503eIZ`2P;1<0X2`C0:0/4`0000001@2P
;1<3000000030;0a5@000000/34E00<0/34E00<0?EV[0;0a5@2`<AD00`2`<AD00`000000/34E0;0a
5@070;0a5@030000002`<AD0/34E0080/34E00@0?EV[0;0a5@2`<AD0/34E0`0000040;hf5`80?EV[
0P2n=QL00`000000_SHG0;hf5`060;hf5`030000000mFJ/0_SHG00L0_SHG00<000000;hf5`2n=QL0
1@2n=QL30000000303eIZ`3;>QT0bcXI0080bcXI00<0?EV[0000003;>QT01`3;>QT00`000000bcXI
0</j6@040</j6@050000003;>QT0bcXI0</j6@0mFJ/00`3;>QT00`0mFJ/0bcXI0</j6@040</j6@03
0000001AMMh0DGGN0080DGGN00<00000055egP1AMMh0101AMMh00`000000e3dI055egP030=@m6@03
0000001@LmT0D7?I00<0D7?I00<00000051cf@1@LmT0101@LmT2000000@0CW3@00<000000=@m6@1>
L=00101>L=02000000@0Bf[300<0000004]Z``1;J/<00`1;J/<00`000000AF2^04EP[P0204EP[P08
00000015H:h0e3dI0000000lDI00000003aAT00000040=@m6@030000000mFJ/0ooK^00X0ooK^00@0
e3dI0?ofkP3om^h0ooK^103D?AT20?ofkP<000001`3om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m
6@3om^h0ooK^0080ooK^00<000000?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP030?ofkP<0e3dI
303om^h00`3D?AT0ooK^0?ofkP0H0?ofkP030000003om^h0ooK^0340ooK^0@3oool000/0ooK^00<0
00000?ofkP3om^h0AP3om^h00`3D?AT0ooK^0?ofkP050?ofkP8000001@3om^h0103D?AT0ooK^0=@m
6@3D?AT=0?ofkP030=@m6@3om^h0ooK^00d0ooK^0P0mFJ/0103D?AT0ooK^0=@m6@3D?AT203eIZ`@0
ooK^00<000000:0/4`2P;1<00`2P;1<01P0mFJ/0X2`C0:0/4`2P;1<000000:0/4`<000001@2`<AD0
0`000000/34E0;0a5@020;0a5@0303eIZ`2`<AD0/34E00<0/34E00<000000;0a5@2`<AD01P2`<AD0
0`000000/34E0;0a5@030;0a5@0503eIZ`00000000000;hf5`0000000`2n=QL203eIZ`@0_SHG00<0
00000;hf5`2n=QL01`2n=QL00`000000?EV[0;hf5`060;hf5`030000002n=QL0_SHG0080_SHG0`00
00000`3;>QT0000003eIZ`060</j6@0303eIZ`3;>QT0bcXI00H0bcXI00<000000</j6@3;>QT0103;
>QT010000000bcXI0</j6@0mFJ/40</j6@030000000mFJ/0bcXI00<0bcXI0P000004055egP030000
001AMMh0DGGN00@0DGGN0`3D?AT3055egP030000001@LmT0D7?I00<0D7?I00<00000051cf@1@LmT0
0`1@LmT010000000D7?I051cf@00000304i`d0030000003D?AT0CW3@00<0CW3@00@0000004i`d01>
L=0000000`1;J/<00`000000Bf[304]Z``0304]Z``8000000`15H:h01@000000AF2^04EP[P3D?AT0
000000<0e3dI00H0000003aAT0000000?EV[02lnJP00000;0?ofkP030=@m6@3om^h0e3dI0080e3dI
0P3om^h3000000X0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP020?ofkP030000
003om^h0ooK^0080ooK^00<0e3dI0?ofkP3D?AT00`3D?AT?0?ofkP030=@m6@3om^h0ooK^01P0ooK^
00<000000?ofkP3om^h0<@3om^h10?ooo`002P3om^h00`000000ooK^0?ofkP160?ofkP030=@m6@3o
m^h0ooK^00<0ooK^0`0000060?ofkP<0e3dI3`3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP80?EV[00@0
e3dI0?ofkP3om^h0ooK^0P0mFJ/30?ofkP030000002P;1<0X2`C00@0X2`C0P0mFJ/3000000P0/34E
00<000000;0a5@2`<AD00`2`<AD00`0mFJ/0/34E0;0a5@020;0a5@030000002`<AD0/34E00L0/34E
00<000000;0a5@0000000P0000000`2n=QL0?EV[0;hf5`020;hf5`030000000mFJ/0?EV[00L0_SHG
00<000000;hf5`2n=QL01P2n=QL00`000000?EV[0;hf5`060;hf5`030000002n=QL0000000800000
0`3;>QT203eIZ`L0bcXI00<0000003eIZ`3;>QT01P3;>QT00`000000bcXI0</j6@040</j6@030000
003;>QT0?EV[00D0bcXI00<000000</j6@0mFJ/00`0000000`3F?AX0000000000003055egP040000
001AMMh0DGGN055egP<0e3dI00<0DGGN0=@m6@1AMMh00`1AMMh2000000<0D7?I00<00000051cf@1@
LmT0101@LmT01@000000D7?I051cf@1@LmT000000080CW3@00<000000=@m6@1>L=000`1>L=001000
0000CW3@04i`d000000304]Z``030000001;J/<0Bf[300<0Bf[300<0000004]Z``0000000P15H:h0
0`000000AF2^0=@m6@020=@m6@040000000lDI00?56@00000080?56@0`0000000`0mFJ/0ooK^0?of
kP070?ofkP<0e3dI0P3om^h00`000000e3dI0000000=0?ofkP030=@m6@3om^h0ooK^00P0ooK^0P3D
?AT50?ofkP030000003om^h0ooK^00<0e3dI4`3om^h00`3D?AT0ooK^0?ofkP0H0?ofkP030000003o
m^h0ooK^0340ooK^0@3oool000X0ooK^00<000000?ofkP3om^h0AP3om^h00`3D?AT0ooK^0?ofkP03
000000H0ooK^0`3D?AT00`3om^h0e3dI0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00`0ooK^0P3D?AT0
0`3om^h0?EV[03eIZ`040?ofkP80?EV[0P3om^h00`000000X2`C0:0/4`030:0/4`<0000000<0?EV[
0;0a5@0000002@2`<AD00`000000/34E0;0a5@030;0a5@0303eIZ`2`<AD0/34E0080/34E00<00000
0;0a5@2`<AD01@2`<AD3000000D0_SHG00@0?EV[0;hf5`0mFJ/0?EV[2@2n=QL00`000000_SHG0;hf
5`060;hf5`030000002n=QL0?EV[00D0_SHG0`0000050</j6@0303eIZ`3;>QT0000000L0bcXI00<0
00000</j6@0mFJ/01P3;>QT00`000000bcXI0</j6@040</j6@030000000mFJ/0bcXI00@0bcXI0`00
00001@3F?AX0?EV[0=Hm6P3F?AX000000080DGKR00<00000055egP1AMMh0103D?AT2055egP040000
001AMMh0DGGN0=@m6@80DGGN00@00000055egP1AMMh000000P1@LmT00`000000D7?I051cf@03051c
f@030000001@LmT0D7?I00<0D7?I0P00000204i`d0050=@m6@1>L=00CW3@04i`d00000000`1>L=00
0`000000Bf[30000000504]Z``050000001;J/<0Bf[300000015H:h00`3D?AT204EP[P050=@m6@00
0000000003aAT00000000`0lDI0010000000;ciZ0000000mFJ/50?ofkP<0e3dI00<0ooK^0=@m6@00
00000P0000000`3om^h0e3dI0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00@0ooK^0`3D?AT20?ofkP03
0=@m6@3om^h0ooK^0080ooK^00D000000=@m6@3D?AT0ooK^0=@m6@0D0?ofkP030=@m6@3om^h0ooK^
01P0ooK^00<000000?ofkP3om^h0<@3om^h10?ooo`002P3om^h00`000000ooK^0?ofkP160?ofkP03
0=@m6@000000000000H0ooK^0`3D?AT40?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3o
m^h02@3om^h30=@m6@<0ooK^00@0e3dI0?ofkP0mFJ/0?EV[0P3om^h303eIZ`80ooK^00<000000:0/
4`0000000P0000040;0a5@0303eIZ`000000/34E00P0/34E00<000000;0a5@2`<AD0102`<AD01@0m
FJ/0/34E0;0a5@2`<AD0000000D0/34E0P0000000`2n=QL000000;hf5`050;hf5`80?EV[0P2n=QL0
0`000000_SHG0;hf5`060;hf5`030000002n=QL0_SHG00H0_SHG00@000000;hf5`2n=QL0?EV[0P2n
=QL2000000030</j6@000000bcXI00@0bcXI00D0?EV[0</j6@3;>QT0bcXI000000060</j6@040000
003;>QT0bcXI03eIZ`D0bcXI00<000000</j6@3;>QT00`3;>QT203eIZ`@0bcXI0P0000000`3F?AX0
00000=Hm6P020=Hm6P0303eIZ`3F?AX000000080DGKR0`3D?AT6055egP040000001AMMh0DGGN0=@m
6@80DGGN00@00000055egP1AMMh000000P1@LmT00`000000D7?I051cf@03051cf@030000001@LmT0
D7?I00@0D7?I00@0000004i`d01>L=00e3dI0`1>L=000`000000CW3@04i`d00204i`d08000001@1;
J/<00`000000Bf[304]Z``020=@m6@0304EP[P000000AF2^0080AF2^00<0e3dI00000015H:h00P00
000303aAT0<000000P0mFJ/40=@m6@050?ofkP00000000000000003D?AT01@3om^h00`3D?AT0ooK^
0?ofkP0<0?ofkP040=@m6@3om^h0ooK^0?ofkP<0e3dI1@3om^h00`3D?AT0ooK^0=@m6@020=@m6@05
0?ofkP000000ooK^0?ofkP3D?AT0503om^h00`3D?AT0ooK^0?ofkP0H0?ofkP030000003om^h0ooK^
0340ooK^0@3oool000X0ooK^00<000000?ofkP3om^h0A03om^h3000000H0ooK^0P3D?AT70?ofkP03
0=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h01`3om^h20=@m6@H0ooK^00<0e3dI0?ofkP3o
m^h00P0mFJ/20?ofkP<0?EV[00<0ooK^000000000000202`<AD00`0mFJ/000000;0a5@080;0a5@03
0000002`<AD0/34E00@0/34E00H0?EV[0;0a5@2`<AD0/34E0000002`<AD3000000@0_SHG00<00000
0;hf5`2n=QL00`0mFJ/20;hf5`0303eIZ`2n=QL0000000T0_SHG00<000000;hf5`2n=QL01P2n=QL0
1@000000_SHG0000000mFJ/0000000@0bcXI00<000000</j6@3;>QT00P0mFJ/40</j6@030000003;
>QT0bcXI00D0bcXI00@000000</j6@3;>QT0?EV[103;>QT00`000000bcXI0</j6@020</j6@0403eI
Z`3;>QT000000</j6@<000000`3F?AX00`000000eSdJ0=Hm6P020=Hm6P0403eIZ`000000e3dI0=@m
6@80DGKR00<00000055egP1AMMh00`1AMMh00`000000DGGN055egP02055egP030=@m6@000000DGGN
00<0DGGN0P000005051cf@030000001@LmT0D7?I00D0D7?I0P00000204i`d0030=@m6@1>L=000000
00H0CW3@00<0000004]Z``1;J/<00`1;J/<30=@m6@80Bf[30P00000404EP[P050=@m6@15H:h00000
03aAT00000000P0lDI02000000<0e3dI0P3om^h3000000<0ooK^00<0e3dI0?ofkP3om^h00`3om^h0
0`3D?AT0ooK^0?ofkP0<0?ofkP@0e3dI203om^h20=@m6@D0ooK^00<000000?ofkP3D?AT0503om^h0
0`3D?AT0ooK^0?ofkP0I0?ofkP030000003om^h0ooK^0300ooK^0@3oool000X0ooK^00<000000?of
kP3om^h0@@3om^h3000000030?ofkP3D?AT0ooK^00<0ooK^0`3D?AT90?ofkP030=@m6@3om^h0ooK^
00h0ooK^00<0e3dI0?ofkP3om^h0103om^h30=@m6@P0ooK^00@0e3dI0?ofkP3om^h0ooK^100mFJ/0
1@3om^h0?EV[03eIZ`3om^h0000000T0/34E00<0?EV[0;0a5@2`<AD01`2`<AD00`000000/34E0;0a
5@050;0a5@80?EV[0`0000070;hf5`<0?EV[1P2n=QL00`0mFJ/000000;hf5`080;hf5`030000002n
=QL0_SHG00D0_SHG0`0000020</j6@0303eIZ`3;>QT0bcXI0080bcXI00<000000</j6@0mFJ/01P3;
>QT00`000000bcXI0</j6@050</j6@050000003;>QT0bcXI0</j6@0mFJ/00`3;>QT01P000000bcXI
0</j6@3;>QT0?EV[0</j6@<000001@3F?AX00`000000eSdJ0=Hm6P040=Hm6P030000003D?AT0DGKR
0080DGKR0P000004055egP030000001AMMh0DGGN0080DGGN00<0e3dI0000001AMMh0101AMMh00`00
0000D7?I051cf@03051cf@030000001@LmT0D7?I00@0D7?I00P00000051cf@1@LmT0000004i`d03D
?AT0CW3@000000H0CW3@0P0000001@1;J/<0e3dI0=@m6@3D?AT0000000D0Bf[300<0000004EP[P15
H:h00P15H:h00`3D?AT0AF2^04EP[P02000000<0?56@0`00000203eIZ`030000003om^h0ooK^00D0
ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP80e3dI203om^h30=@m6@03
0?ofkP3D?AT0ooK^00@0ooK^00<000000?ofkP3D?AT05@3om^h00`3D?AT0ooK^0?ofkP0H0?ofkP03
0000003om^h0ooK^0300ooK^0@3oool000T0ooK^00<000000?ofkP3om^h0@03om^h2000000@0ooK^
00<0e3dI0?ofkP3D?AT00P3D?AT<0?ofkP030=@m6@3om^h0ooK^00h0ooK^00@0e3dI0?ofkP3om^h0
ooK^0`3D?AT;0?ofkP030=@m6@3om^h0ooK^0080ooK^100mFJ/0103om^h0?EV[03eIZ`00000:0;0a
5@0303eIZ`2`<AD0/34E00L0/34E00<000000;0a5@2`<AD00`2`<AD30000000303eIZ`2n=QL00000
00@0_SHG0`0mFJ/00`2n=QL000000;hf5`070;hf5`0303eIZ`000000_SHG00L0_SHG00<000000;hf
5`2n=QL00`2n=QL2000000030</j6@000000bcXI00<0bcXI00H0?EV[0</j6@3;>QT0bcXI0000000m
FJ/70</j6@030000003;>QT0bcXI00D0bcXI00<000000</j6@3;>QT00P3;>QT0100mFJ/0bcXI0</j
6@0000020</j6@0503eIZ`00000000000=Hm6P0000001P3F?AX00`000000eSdJ0=Hm6P030=Hm6P03
0000001AM^80DGKR0080DGKR00@00000055fhP1AM^8000000`1AMMh00`000000DGGN055egP03055e
gP030=@m6@1AMMh0DGGN00<0DGGN0P000004051cf@030000001@LmT0D7?I00@0D7?I00@00000051c
f@1@LmT000000P1>L=000`3D?AT0000004i`d00404i`d0040000003D?AT0e3dI0=@m6@<0Bf[300<0
000004]Z``1;J/<00`1;J/<2000000<0AF2^00D000000=@m6@15H:h0AF2^0000000303aAT0030000
000lDI00000000<0?EV[1`3om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00L0ooK^
0`3D?AT20?ofkP030=@m6@3om^h0ooK^0080ooK^0`3D?AT50?ofkP030=@m6@3om^h0ooK^00<0ooK^
00<000000=@m6@3om^h0503om^h00`3D?AT0ooK^0?ofkP0H0?ofkP030000003om^h0ooK^0300ooK^
0@3oool000T0ooK^00<000000?ofkP3om^h0?@3om^h3000000H0ooK^0P3D?AT?0?ofkP030=@m6@3o
m^h0ooK^00h0ooK^00@0e3dI0?ofkP3D?AT0e3dI3P3om^h00`3D?AT0ooK^0?ofkP030?ofkP80?EV[
00@0ooK^03eIZ`0mFJ/0ooK^0P0mFJ/:0;0a5@0303eIZ`2`<AD0/34E00H0/34E00<000000;0a5@2`
<AD00`0000040;hf5`0303eIZ`000000_SHG00<0?EV[102n=QL00`000000_SHG0;hf5`070;hf5`03
03eIZ`2n=QL0_SHG00L0_SHG00<000000;hf5`0000000P0000040</j6@030000003;>QT0bcXI0080
bcXI00D0?EV[0</j6@0mFJ/0?EV[000000070</j6@030000003;>QT0bcXI00D0bcXI00<000000</j
6@3;>QT00`3;>QT01P0mFJ/0bcXI0000003;>QT0?EV[000000<0eSdJ00<000000=Hm6P3F?AX0103F
?AX00`000000eSdJ0=Hm6P030=Hm6P030000001AM^80DGKR0080DGKR00D00000055fhP1AM^80DGKR
00000002055egP030000001AMMh0DGGN0080DGGN00<000000=@m6@1AMMh00`1AMMh010000000DGGN
055egP000002051cf@030000001@LmT0D7?I00@0D7?I00<00000051cf@1@LmT00P1@LmT010000000
CW3@0=@m6@00000404i`d080e3dI0`1>L=000`000000Bf[30000000604]Z``030000001;J/<00000
0080AF2^00@000000=@m6@15H:h0AF2^0P00000203aAT0040000000lDI000000000000<0?EV[1P3o
m^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00<0ooK^0`3D?AT50?ofkP030=@m6@3o
m^h0e3dI0080e3dI203om^h00`3D?AT0ooK^0?ofkP040?ofkP030000003om^h0ooK^0180ooK^0P3D
?ATJ0?ofkP030000003om^h0ooK^0300ooK^0@3oool000T0ooK^00<000000?ofkP3om^h0>`3om^h2
000000T0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP<0e3dI403om^h0
0`3D?AT0ooK^0?ofkP040?ofkP<0?EV[00<0ooK^03eIZ`0mFJ/00P0mFJ/90;0a5@030000000mFJ/0
?EV[00H0/34E0`0000060;hf5`@0?EV[202n=QL00`000000_SHG0;hf5`070;hf5`0303eIZ`2n=QL0
_SHG00D0_SHG0`0000070</j6@030000003;>QT0bcXI00<0bcXI00@0?EV[0</j6@3;>QT000001`3;
>QT00`000000bcXI0</j6@050</j6@030000003;>QT0bcXI00@0bcXI00<0?EV[0000000mFJ/01@3F
?AX00`000000eSdJ0=Hm6P040=Hm6P030000003F?AX0eSdJ00<0eSdJ00<00000055fhP1AM^800P1A
M^800`000000DGKR055fhP02055fhP8000001@1AMMh00`000000e3dI055egP03055egP040000001A
MMh0DGGN00000080D7?I00<00000051cf@1@LmT0101@LmT00`000000D7?I051cf@03051cf@800000
00<0e3dI04i`d03D?AT00P3D?AT00`000000CW3@04i`d00304i`d08000001@1;J/<03`000000Bf[3
04]Z``1;J/<0000004EP[P000000AF2^0=@m6@15H:h0000004EP[P000000?56@0000000203aAT003
0000000mFJ/0?EV[0080?EV[1@3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00<0
e3dI1`3om^h30=@m6@`0ooK^00<0e3dI0?ofkP3om^h0103om^h00`000000ooK^0?ofkP0=0?ofkP@0
e3dI00<0ooK^0=@m6@3om^h06@3om^h00`000000ooK^0?ofkP0`0?ofkP40oooo00090?ofkP030000
003om^h0ooK^03P0ooK^0`00000;0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h0
2`3om^h30=@m6@030?ofkP3D?AT0ooK^0140ooK^00<0e3dI0?ofkP3om^h01@3om^h203eIZ`80ooK^
0`0mFJ/90;0a5@030000002`<AD0?EV[00<0/34E0P0000020;hf5`030000002n=QL0?EV[00@0?EV[
0`2n=QL00`0mFJ/0_SHG0;hf5`060;hf5`030000002n=QL0_SHG00L0_SHG00<0000003eIZ`2n=QL0
0`2n=QL2000000030</j6@000000bcXI00L0bcXI00@000000</j6@3;>QT0bcXI0P0mFJ/0103;>QT0
?EV[0</j6@0000070</j6@030000003;>QT0bcXI00D0bcXI00<000000</j6@3;>QT0100000000`3F
?AX0?EV[0=Hm6P050=Hm6P030000003F?AX0eSdJ00@0eSdJ00<000000=Hm6P3F?AX00`3F?AX00`00
0000DGKR055fhP02055fhP030000001AM^80DGKR00<0DGKR00<00000055egP1AMMh00`1AMMh00`00
0000DGGN0=@m6@02055egP030000001AMMh0DGGN0080DGGN0P000006051cf@030000001@LmT0D7?I
00D0D7?I0`3D?AT304i`d0030000001>L=00CW3@00@0CW3@00<0000004]Z``1;J/<00`1;J/<00`00
0000Bf[304]Z``0204]Z``80000000P0AF2^0=@m6@15H:h0000004EP[P000000?56@00000080?56@
00<000000?ofkP0mFJ/00P0mFJ/50?ofkP030=@m6@3om^h0ooK^00@0ooK^0`3D?AT70?ofkP<0e3dI
00<0ooK^0=@m6@3om^h03@3om^h00`3D?AT0ooK^0?ofkP030?ofkP030000003om^h0ooK^00X0ooK^
0`3D?AT50?ofkP030=@m6@3om^h0ooK^01T0ooK^00<000000?ofkP3om^h0;`3om^h10?ooo`00203o
m^h00`000000ooK^0?ofkP0f0?ofkP<000003P3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3o
m^h0ooK^00P0ooK^0`3D?AT40?ofkP030=@m6@3om^h0ooK^0100ooK^00<0e3dI0?ofkP3om^h01P3o
m^h00`0mFJ/0ooK^0?ofkP020?ofkPP0?EV[0P2`<AD010000000/34E0;0a5@0mFJ/2000000030;hf
5`0mFJ/0?EV[00<0?EV[2@2n=QL00`0mFJ/0_SHG0;hf5`060;hf5`030000002n=QL0_SHG00L0_SHG
00<0000003eIZ`0mFJ/00P0000040</j6@030000003;>QT0bcXI00H0bcXI00<0000003eIZ`0mFJ/0
103;>QT00`0mFJ/000000</j6@070</j6@030000003;>QT0bcXI00<0bcXI100000040=Hm6P0303eI
Z`000000?EV[00D0eSdJ00<000000=Hm6P3F?AX00`3F?AX00`000000eSdJ0=Hm6P030=Hm6P030000
001AM^80DGKR0080DGKR00<00000055fhP1AM^80101AM^82000000<0DGGN00@00000055egP1AMMh0
e3dI0P1AMMh00`000000DGGN055egP03055egP030000001@LmT0D7?I00@0D7?I00<00000051cf@1@
LmT00P1@LmT30=@m6@03051cf@3D?AT0CW3@00<0CW3@00<0000004i`d01>L=00101>L=02000000@0
Bf[300<0000004]Z``1;J/<00`1;J/<01@000000AF2^04EP[P3D?AT000000080AF2^00D0000003aA
T0000000?56@0000000203eIZ`030?ofkP0mFJ/0?EV[00@0ooK^00@0e3dI0?ofkP3om^h0ooK^0`3D
?AT20?ofkP040=@m6@3om^h0ooK^0?ofkP@0e3dI103om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m
6@3om^h0ooK^00<0ooK^00<0e3dI0000003om^h01P3om^h40=@m6@P0ooK^00<0e3dI0?ofkP3om^h0
6@3om^h00`000000ooK^0?ofkP0_0?ofkP40oooo00080?ofkP030000003om^h0ooK^03@0ooK^0P00
000A0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h01@3om^h30=@m6@L0ooK^00<0
e3dI0?ofkP3om^h0403om^h00`3D?AT0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^0080e3dI0P0m
FJ/50;0a5@T0?EV[102n=QL00`000000_SHG0;hf5`070;hf5`030000000mFJ/0_SHG00H0_SHG00<0
00000;hf5`2n=QL01P2n=QL3000000030</j6@0mFJ/0bcXI00@0bcXI00<000000</j6@3;>QT01@3;
>QT203eIZ`L0bcXI00<0?EV[0000003;>QT01P3;>QT010000000bcXI0</j6@3;>QT2000000030=Hm
6P000000eSdJ00<0eSdJ0P0mFJ/0103F?AX000000=Hm6P0mFJ/40=Hm6P030000003F?AX0eSdJ00<0
eSdJ00<000000=Hm6P3F?AX00`3F?AX00`000000DGKR055fhP02055fhP030000001AM^80DGKR00<0
DGKR00@00000055fhP1AM^8000000P1AMMh01P000000DGGN055egP1AMMh0e3dI000000D0DGGN00<0
0000055egP0000001@1@LmT00`000000D7?I0=@m6@020=@m6@80D7?I00@00000051cf@1@LmT0e3dI
0P1>L=000`000000CW3@04i`d00404i`d0040000001>L=00CW3@000000<0Bf[300<0000004]Z``1;
J/<00`1;J/<20000000304EP[P3D?AT0000000<0AF2^0P00000203aAT0060000003om^h0?EV[03eI
Z`3om^h0?EV[0`3om^h40=@m6@D0ooK^103D?AT80?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI
0?ofkP3om^h00P3om^h00`3D?AT0ooK^000000030?ofkP<0e3dI303om^h00`3D?AT0ooK^0?ofkP0I
0?ofkP030000003om^h0ooK^02l0ooK^0@3oool000P0ooK^00<000000?ofkP3om^h0<@3om^h30000
01<0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP020?ofkP<0e3dI2P3om^h00`3D
?AT0ooK^0?ofkP0@0?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI03eIZ`0mFJ/00P3om^h00`00
0000/34E03eIZ`030;0a5@<000000P2n=QL010000000_SHG0;hf5`0mFJ/60;hf5`030000002n=QL0
_SHG00L0_SHG00<0000003eIZ`2n=QL01P2n=QL00`000000_SHG0;hf5`030;hf5`8000000P3;>QT0
10000000bcXI0</j6@0mFJ/50</j6@030000003;>QT0bcXI0080bcXI0P0mFJ/00`3;>QT000000</j
6@070</j6@0303eIZ`3;>QT0bcXI00D0bcXI00@000000</j6@00000000000`3F?AX01@000000eSdJ
0=Hm6P3F?AX0?EV[00<0eSdJ00@000000=Hm6P3F?AX0?EV[0P3F?AX00`000000eSdJ0=Hm6P040=Hm
6P030000003F?AX0eSdJ00<0eSdJ00<00000055fhP1AM^800P1AM^800`000000DGKR055fhP03055f
hP040000001AM^80DGKR055fhP800000101AMMh00`3D?AT00000055egP04055egP040000001AMMh0
DGGN000000<0D7?I0`3D?AT4051cf@050000001@LmT0D7?I051cf@3D?AT00P1>L=000`000000CW3@
04i`d00404i`d0040000001>L=00CW3@000000<0Bf[300<0000004]Z``1;J/<00P1;J/<00`000000
Bf[30000000204EP[P030=@m6@15H:h0AF2^0080AF2^00D0000003aAT00lDI0000000?ofkP0403eI
Z`<0e3dI00<0ooK^0=@m6@3om^h0103om^h40=@m6@X0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D
?AT0ooK^0?ofkP020?ofkP040=@m6@3om^h0e3dI00000080e3dI3`3om^h00`3D?AT0ooK^0?ofkP0I
0?ofkP030000003om^h0ooK^02l0ooK^0@3oool000P0ooK^00<000000?ofkP3om^h0;P3om^h30000
01H0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0=@m6@020=@m6@d0ooK^00<0e3dI0?of
kP3om^h0403om^h00`3D?AT0ooK^0?ofkP050?ofkP80e3dI0P3om^h203eIZ`040?ofkP000000/34E
0;0a5@80?EV[00<000000;hf5`2n=QL00`2n=QL01@000000_SHG0;hf5`2n=QL0?EV[00D0_SHG00<0
00000;hf5`2n=QL01`2n=QL00`000000_SHG03eIZ`060;hf5`030000002n=QL0_SHG00<00000103;
>QT01@000000bcXI0</j6@3;>QT0?EV[00@0bcXI00<000000</j6@3;>QT00P0mFJ/30</j6@030000
003;>QT0bcXI00H0bcXI00<0000003eIZ`3;>QT0103;>QT3000000D0eSdJ00@000000=Hm6P3F?AX0
?EV[103F?AX01`000000eSdJ0=Hm6P3F?AX0?EV[0=Hm6P0000001P3F?AX00`000000eSdJ0=Hm6P03
0=Hm6P030000001AM^80DGKR0080DGKR00<00000055fhP1AM^800P1AM^800`000000DGKR055fhP03
055fhP030000001AMMh0DGGN00<0DGGN00<0e3dI055egP1AMMh00P1AMMh010000000DGGN055egP1A
MMh40=@m6@030000001@LmT0D7?I00@0D7?I00<00000051cf@1@LmT00P1@LmT00`3D?AT0000004i`
d00504i`d0030000001>L=00CW3@0080CW3@00<0000004]Z``0000001@1;J/<01P000000Bf[304]Z
``000000AF2^0=@m6@@0AF2^0P000000100lDI00000003eIZ`3om^h30=@m6@80?EV[0P3om^h00`3D
?AT0ooK^0=@m6@030=@m6@<0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP0=0?of
kP80e3dI0P3om^h30=@m6@030?ofkP000000ooK^0100ooK^00<0e3dI0?ofkP3om^h06@3om^h00`00
0000ooK^0?ofkP0_0?ofkP40oooo00080?ofkP030000003om^h0ooK^02`0ooK^0P00000H0?ofkP03
0=@m6@3om^h0ooK^00d0ooK^0`3D?AT@0?ofkP030=@m6@3om^h0ooK^0100ooK^00<0e3dI0?ofkP3o
m^h00P3om^h30=@m6@D0ooK^0P0mFJ/00`3om^h00000000000020;hf5`0303eIZ`2n=QL0_SHG00@0
_SHG00@000000;hf5`2n=QL0_SHG0P0mFJ/40;hf5`030000002n=QL0_SHG00L0_SHG00<000000;hf
5`0mFJ/01@2n=QL3000000P0bcXI00D000000</j6@3;>QT0bcXI03eIZ`030</j6@030000000mFJ/0
?EV[00H0bcXI00<000000</j6@3;>QT01P3;>QT00`000000?EV[03eIZ`03000000030=Hm6P000000
eSdJ00H0eSdJ00<0000003eIZ`3F?AX0103F?AX00`000000eSdJ0=Hm6P020=Hm6P0303eIZ`000000
eSdJ00D0eSdJ00<000000=Hm6P3F?AX00P3F?AX00`000000DGKR055fhP02055fhP030000001AM^80
DGKR00<0DGKR00<00000055fhP1AM^800`1AM^82000000<0DGGN00<000000=@m6@1AMMh00`1AMMh0
10000000e3dI0=@m6@3D?AT2055egP8000001P1@LmT00`000000D7?I051cf@03051cf@030=@m6@00
0000CW3@00D0CW3@00<0000004i`d01>L=000`1>L=02000000D0Bf[300@0000004]Z``1;J/<0Bf[3
0P0000001P3D?AT0AF2^04EP[P15H:h0000004EP[P@0e3dI0P0mFJ/0103om^h0?EV[03eIZ`3om^h3
0=@m6@P0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP<0e3dI00H0ooK^
0=@m6@3D?AT0e3dI0?ofkP3D?AT30?ofkP030000003om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h0
6@3om^h00`000000ooK^0?ofkP0_0?ofkP40oooo00070?ofkP030000003om^h0ooK^02X0ooK^0`00
000J0?ofkP030=@m6@3om^h0ooK^00X0ooK^0`3D?AT00`3om^h0e3dI0?ofkP0@0?ofkP030=@m6@3o
m^h0ooK^0100ooK^00<0e3dI0?ofkP3D?AT00P3D?AT90?ofkP80?EV[00<0ooK^0000002n=QL00P2n
=QL00`0mFJ/0_SHG0;hf5`040;hf5`030000002n=QL0_SHG0080_SHG00D0?EV[0;hf5`2n=QL0_SHG
000000090;hf5`030000002n=QL0_SHG0080?EV[0`0000020</j6@030000003;>QT0bcXI00H0bcXI
00<000000</j6@3;>QT00P3;>QT01@0mFJ/0bcXI03eIZ`0mFJ/0000000L0bcXI00<000000</j6@3;
>QT01@3;>QT3000000030=Hm6P0mFJ/0eSdJ0080eSdJ00<000000=Hm6P3F?AX0103F?AX203eIZ`H0
eSdJ00<000000=Hm6P3F?AX00`3F?AX00`0mFJ/0eSdJ0=Hm6P030=Hm6P030000003F?AX0eSdJ0080
eSdJ0P000004055fhP030000001AM^80DGKR0080DGKR00<00000055fhP1AM^800`1AM^8010000000
DGKR055fhP000002055egP040000001AMMh0e3dI055egP<0e3dI1P1AMMh00`000000D7?I051cf@04
051cf@030000001@LmT0D7?I00<0D7?I00<000000=@m6@0000001@1>L=000`000000CW3@04i`d004
04i`d0030000001;J/<0Bf[30080Bf[300<0000004]Z``1;J/<00P1;J/<2000000030=@m6@15H:h0
AF2^00<0e3dI00<0000003aAT00000000P0mFJ/00`3om^h0?EV[0=@m6@020=@m6@030?ofkP3D?AT0
ooK^00P0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP070?ofkP<0e3dI00H0ooK^
0=@m6@3D?AT0e3dI0?ofkP3D?AT20?ofkP030=@m6@3om^h0ooK^0080ooK^00<000000?ofkP3om^h0
3@3om^h00`3D?AT0ooK^0?ofkP0J0?ofkP030000003om^h0ooK^02h0ooK^0@3oool000L0ooK^00<0
00000?ofkP3om^h0:03om^h2000001d0ooK^00<0e3dI0?ofkP3om^h01`3om^h30=@m6@@0ooK^00<0
e3dI0?ofkP3om^h0403om^h00`3D?AT0ooK^0?ofkP0>0?ofkP<0e3dI3P3om^h00`0mFJ/0ooK^0000
00030;hf5`0303eIZ`2n=QL0_SHG00<0_SHG00<000000;hf5`2n=QL00`2n=QL01@0mFJ/0_SHG0;hf
5`2n=QL0000000P0_SHG100000000`3;>QT0?EV[0</j6@030</j6@030000003;>QT0bcXI00L0bcXI
00@000000</j6@3;>QT0bcXI0P0mFJ/20</j6@030000003;>QT0bcXI00D0bcXI00<000000</j6@3;
>QT00`3;>QT2000000030=Hm6P000000eSdJ0080eSdJ00D0?EV[0=Hm6P3F?AX0eSdJ000000040=Hm
6P0303eIZ`3F?AX0000000H0eSdJ00<000000=Hm6P3F?AX00`3F?AX00`0mFJ/0eSdJ0=Hm6P030=Hm
6P030000003F?AX000000080000000<0hD4L0000000000000`1AM^800`000000DGKR055fhP02055f
hP030000001AM^80DGKR00<0DGKR00D00000055fhP1AM^80DGKR00000002055egP<0e3dI00<0DGGN
0000001AMMh01@1AMMh00`000000DGGN00000004051cf@030000001@LmT0D7?I00@0D7?I00@00000
0=@m6@1@LmT000000`1>L=000`000000CW3@04i`d00404i`d0030000001>L=00000000<0Bf[300<0
000004]Z``1;J/<00`1;J/<01P000000e3dI0=@m6@3D?AT0AF2^00000080AF2^0P000000100mFJ/0
e3dI0=@m6@3D?AT403eIZ`030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D
?AT0ooK^0?ofkP040?ofkP<0e3dI00@0ooK^0=@m6@3D?AT0e3dI1@3om^h00`3D?AT0ooK^0=@m6@04
0?ofkP030000003om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h06P3om^h00`000000ooK^0?ofkP0^
0?ofkP40oooo00070?ofkP030000003om^h0ooK^02D0ooK^0`00000O0?ofkP030=@m6@3om^h0ooK^
00D0ooK^0P3D?AT70?ofkP030=@m6@3om^h0ooK^0100ooK^00<0e3dI0?ofkP3om^h0303om^h20=@m
6@030?ofkP3D?AT0ooK^00l0ooK^00<0?EV[0000002n=QL00`2n=QL00`0mFJ/0_SHG0;hf5`030;hf
5`030000002n=QL0_SHG00<0_SHG00D0?EV[0;hf5`2n=QL0_SHG000000050;hf5`8000000P3;>QT0
1@000000bcXI0</j6@3;>QT0?EV[00@0bcXI00<000000</j6@3;>QT01P3;>QT010000000?EV[03eI
Z`0mFJ/20</j6@0403eIZ`3;>QT0bcXI000000L0bcXI00<000000</j6@0000000P0000030=Hm6P03
0000003F?AX0eSdJ0080eSdJ00@0?EV[0=Hm6P3F?AX000000`3F?AX0100mFJ/0eSdJ0=Hm6P000006
0=Hm6P030000003F?AX0eSdJ00<0eSdJ00<0000003eIZ`3F?AX00P3F?AX3000000<0hD4L00@00000
055gh`1AMn<000000P1AM^801@000000DGKR055fhP1AM^80000000D0DGKR00<00000055fhP1AM^80
0P1AM^830=@m6@80DGGN00<0e3dI0000001AMMh01P1AMMh010000000DGGN055egP000003051cf@03
0000001@LmT0D7?I00<0D7?I00H00000051cf@1@LmT0e3dI051cf@00000204i`d0030000001>L=00
CW3@00@0CW3@00@0000004i`d01>L=0000000P1;J/<010000000Bf[304]Z``1;J/<30=@m6@050000
0015H:h0e3dI04EP[P0000000`15H:h20=@m6@80?EV[0P3om^h303eIZ`030=@m6@3om^h0ooK^00T0
ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP020?ofkP80e3dI00@0ooK^0=@m6@3D
?AT0e3dI2@3om^h20=@m6@D0ooK^00<000000?ofkP3om^h02`3om^h20=@m6A`0ooK^00<000000?of
kP3om^h0;P3om^h10?ooo`001`3om^h00`000000ooK^0?ofkP0R0?ofkP<000008P3om^h00`3D?AT0
ooK^0?ofkP020?ofkP<0e3dI2P3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00T0
ooK^0`3D?AT30?ofkP030=@m6@3om^h0ooK^00l0ooK^0P0mFJ/40;hf5`0303eIZ`2n=QL0_SHG0080
_SHG00<000000;hf5`2n=QL0102n=QL0100mFJ/0_SHG0;hf5`0000020;hf5`<00000103;>QT00`00
0000bcXI0</j6@020</j6@0303eIZ`3;>QT0bcXI0080bcXI00<000000</j6@3;>QT00`3;>QT303eI
Z`030000003;>QT0bcXI00<0bcXI00<0?EV[0</j6@0000001P3;>QT3000000L0eSdJ00<000000=Hm
6P3F?AX00P3F?AX0100mFJ/0eSdJ0000003F?AX203eIZ`<0eSdJ00<000000=Hm6P3F?AX0103F?AX0
0`000000eSdJ0=Hm6P030=Hm6P030000003F?AX0?EV[0080000000<0hD4L0000003Q@A`00P3Q@A`0
0`0mFJ/00000055gh`02055gh`800000101AM^800`000000DGKR055fhP03055fhP030000001AM^80
e3dI0080e3dI00<00000055fhP0000000P1AMMh00`3D?AT00000055egP05055egP050000001AMMh0
DGGN055egP0000000P1@LmT00`000000D7?I051cf@04051cf@040000001@LmT0D7?I0=@m6@80D7?I
0P00000604i`d0050000001>L=00CW3@04i`d00000000P1;J/<40=@m6@0804]Z``000000Bf[304]Z
``000000e3dI04EP[P00000304EP[P030000003om^h0ooK^00<0?EV[00D0ooK^03eIZ`0mFJ/0e3dI
03eIZ`0:0?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3D?AT01@3D?AT<0?ofkP80e3dI
1P3om^h00`000000ooK^0?ofkP060?ofkP@0e3dI00<0ooK^0=@m6@3om^h06`3om^h00`000000ooK^
0?ofkP0^0?ofkP40oooo00060?ofkP030000003om^h0ooK^0240ooK^0P00000U0?ofkP030=@m6@3o
m^h0e3dI0080e3dI3@3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00L0ooK^0P3D
?AT70?ofkP030=@m6@3om^h0ooK^00l0ooK^100mFJ/20;hf5`80?EV[0`2n=QL00`000000_SHG0;hf
5`040;hf5`0303eIZ`2n=QL0000000800000203;>QT00`000000bcXI0</j6@020</j6@0503eIZ`3;
>QT0bcXI0</j6@0000000P3;>QT303eIZ`<0bcXI00<000000</j6@3;>QT0103;>QT0100mFJ/0bcXI
0000003;>QT4000000030=Hm6P000000eSdJ00L0eSdJ00<000000=Hm6P3F?AX00`3F?AX00`0mFJ/0
000003eIZ`050=Hm6P030000003F?AX0eSdJ00@0eSdJ00<000000=Hm6P3F?AX00P3F?AX300000005
0>51700mFJ/0hD4L0>51700000000P3Q@A`01@0mFJ/0hD4L0000001AMn<0e3dI0080DGOS00D00000
055fhP1AM^80DGKR00000005055fhP<0e3dI0`1AM^800`000000DGKR00000002055egP030000003D
?AT0DGGN00@0DGGN00<00000055egP1AMMh00`1AMMh00`000000D7?I00000005051cf@030000001@
LmT0D7?I0080D7?I00@0e3dI051cf@1@LmT000001P1>L=0010000000CW3@04i`d01>L=030=@m6@D0
Bf[300L0000004]Z``1;J/<0Bf[30000003D?AT0000000<0AF2^00@0000003eIZ`3om^h0?EV[0P3o
m^h303eIZ`030=@m6@0mFJ/0ooK^00X0ooK^00<0e3dI0?ofkP3om^h00`3om^h60=@m6A00ooK^00<0
e3dI0?ofkP3om^h01@3om^h00`000000ooK^0?ofkP020?ofkP<0e3dI1@3om^h00`3D?AT0ooK^0?of
kP0J0?ofkP030000003om^h0ooK^02h0ooK^0@3oool000H0ooK^00<000000?ofkP3om^h07P3om^h3
000002L0ooK^0P3D?AT@0?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h0103om^h3
0=@m6@T0ooK^00<0e3dI0?ofkP3om^h0403om^h503eIZ`80_SHG00D0?EV[0;hf5`2n=QL0_SHG0000
00050;hf5`050000000mFJ/0?EV[0</j6@0000002@3;>QT00`000000bcXI0</j6@020</j6@0303eI
Z`3;>QT0bcXI00<0?EV[00<0bcXI0=@m6@3;>QT0103;>QT00`000000bcXI0</j6@040</j6@0303eI
Z`000000000000H0eSdJ00<000000=Hm6P3F?AX01@3F?AX00`000000eSdJ0=Hm6P040=Hm6P0303eI
Z`000000eSdJ00D0eSdJ00<000000=Hm6P3F?AX00`3F?AX00`000000eSdJ00000002000000030>51
70000000hD4L0080hD4L00D0?EV[0000003Q@A`0hD4L03eIZ`020>5170030000001AMn<0e3dI0080
DGOS0P000002055fhP030000001AM^80DGKR00<0e3dI00<00000055fhP1AM^800P1AM^8020000000
DGKR055fhP1AM^800000055egP000000e3dI1@1AMMh00`000000DGGN055egP04055egP030000001@
LmT0D7?I00<0D7?I00<00000051cf@1@LmT00`1@LmT01@3D?AT0D7?I0000001@LmT0000000@0CW3@
00<0000004i`d03D?AT00P3D?AT204i`d0030000001;J/<0Bf[300<0Bf[300<0000004]Z``1;J/<0
0P1;J/<00`3D?AT0000004EP[P0204EP[P040000003om^h0?EV[03eIZ`<0ooK^0P0mFJ/00`3D?AT0
?EV[03eIZ`0:0?ofkP030=@m6@3om^h0ooK^00H0e3dI4`3om^h20=@m6@H0ooK^00<000000=@m6@3D
?AT00P3D?AT80?ofkP030=@m6@3om^h0ooK^01/0ooK^00<000000?ofkP3om^h0;@3om^h10?ooo`00
1P3om^h00`000000ooK^0?ofkP0K0?ofkP<00000:P3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m
6@3om^h0ooK^00l0ooK^00@0e3dI0?ofkP3om^h0ooK^0`3D?AT<0?ofkP030=@m6@3om^h0ooK^0140
ooK^00@0e3dI03eIZ`0mFJ/0_SHG100mFJ/20;hf5`030000002n=QL0_SHG00<000000`3;>QT00`0m
FJ/0bcXI000000090</j6@030000003;>QT0?EV[00@0?EV[00D0bcXI0000003;>QT0bcXI0=@m6@05
0</j6@030000003;>QT0bcXI00@0000000<0eSdJ03eIZ`0000001P3F?AX00`000000eSdJ0=Hm6P05
0=Hm6P030000003F?AX0eSdJ0080eSdJ0P0mFJ/00`3F?AX0?EV[0=Hm6P050=Hm6P030000003F?AX0
eSdJ0080eSdJ0`0000040>5170030000003Q@A`0hD4L0080hD4L00<0?EV[0>51700mFJ/00P3Q@A`0
1P000000DGOS055gh`1AMn<0e3dI00000080DGOS00<00000055fhP3D?AT00P3D?AT2055fhP030000
001AM^80DGKR00<0DGKR00D00000055fhP1AM^80DGKR00000003055egP050=@m6@1AMMh0DGGN055e
gP0000001P1AMMh00`000000DGGN00000004051cf@030000001@LmT0D7?I00@0D7?I00H0e3dI0000
001@LmT0D7?I0000001>L=040=@m6@@0CW3@00<0000004i`d00000000`1;J/<00`000000Bf[304]Z
``0404]Z``050=@m6@15H:h0AF2^04EP[P0000000P3om^h203eIZ`@0ooK^00@0?EV[0=@m6@3om^h0
?EV[2@3om^h60=@m6@030?ofkP3D?AT0ooK^01<0ooK^00<0e3dI0?ofkP3D?AT00`3om^h30=@m6@03
0000003om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h0703om^h00`000000ooK^0?ofkP0]0?ofkP40
oooo00060?ofkP030000003om^h0ooK^01T0ooK^0P00000]0?ofkP030=@m6@3om^h0ooK^00l0ooK^
00<0e3dI0?ofkP3om^h03`3om^h0103D?AT0ooK^0=@m6@3D?AT?0?ofkP030=@m6@3om^h0ooK^0140
ooK^0P3D?AT00`0mFJ/0_SHG0;hf5`020;hf5`P0?EV[1@3;>QT00`0mFJ/000000</j6@020</j6@P0
?EV[103;>QT0100mFJ/0bcXI0</j6@0000070</j6@<000001P3F?AX203eIZ`H0eSdJ00<000000=Hm
6P3F?AX01@3F?AX010000000eSdJ03eIZ`0mFJ/30=Hm6P030000000mFJ/0eSdJ00@0eSdJ00<00000
0=Hm6P0000000P0000000`3Q@A`000000>5170040>5170030000003Q@A`0hD4L0080hD4L00<00000
03eIZ`3Q@A`00P3Q@A`01`000000DGOS055gh`1AMn<0e3dI0000001AMn<00`3D?AT5055fhP030000
001AM^80DGKR0080DGKR00<00000055fhP1AM^800`1AM^8010000000DGGN055egP3D?AT3055egP03
0000001AMMh0DGGN00@0DGGN00@00000055egP1AMMh000000P1@LmT00`000000D7?I051cf@05051c
f@030=@m6@1@LmT0D7?I00<0e3dI00<0CW3@0000001>L=001@1>L=0010000000CW3@04i`d0000002
04]Z``030000001;J/<0Bf[300@0Bf[300D0e3dI00000015H:h0AF2^000000030?ofkP0303eIZ`3o
m^h0ooK^0080ooK^00<0?EV[0=@m6@0mFJ/00P0mFJ/50?ofkPH0e3dI103om^h00`3D?AT0ooK^0?of
kP0B0?ofkP030=@m6@3om^h0e3dI00<0e3dI103om^h00`000000ooK^0?ofkP070?ofkP030=@m6@3o
m^h0ooK^01`0ooK^00<000000?ofkP3om^h0;@3om^h10?ooo`001@3om^h00`000000ooK^0?ofkP0G
0?ofkP<00000;`3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00h0ooK^0`3D?ATB
0?ofkP030=@m6@3om^h0ooK^0100ooK^0P3D?AT00`000000?EV[0;hf5`030;hf5`050000000mFJ/0
bcXI0</j6@0000000P3;>QT:03eIZ`L0bcXI00<000000</j6@3;>QT00`3;>QT0100mFJ/0bcXI0</j
6@0000040</j6@8000000P3F?AX00`000000eSdJ0=Hm6P050=Hm6P030000000mFJ/0eSdJ00@0eSdJ
00<000000=Hm6P3F?AX01@3F?AX203eIZ`D0eSdJ00<000000=Hm6P0mFJ/00`3F?AX3000000@0hD4L
00<000000>51703Q@A`00`3Q@A`010000000hD4L0>51703Q@A`203eIZ`050>51700mFJ/0?EV[0>51
700000000`1AMn<30=@m6@80DGOS0P000003055fhP030000001AM^80DGKR0080DGKR00<00000055f
hP1AM^800`1AM^800`000000DGKR00000002055egP030=@m6@1AMMh0000000H0DGGN00<00000055e
gP1AMMh00P1AMMh00`000000D7?I00000006051cf@040000003D?AT0e3dI0=@m6@80D7?I00<00000
04i`d00000001@1>L=001@000000CW3@04i`d01>L=0000000080Bf[300<0000004]Z``1;J/<00`1;
J/<00`000000Bf[30=@m6@0204EP[P040000003om^h0ooK^0?ofkP80?EV[0`3om^h00`0mFJ/0e3dI
03eIZ`0303eIZ`L0e3dI0`3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI01<0ooK^1@3D?AT60?ofkP03
0000003om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h0703om^h00`000000ooK^0?ofkP0]0?ofkP40
oooo00050?ofkP030000003om^h0ooK^01@0ooK^0`00000c0?ofkP030=@m6@3om^h0ooK^00h0ooK^
00<0e3dI0?ofkP3om^h02`3om^h30=@m6@030?ofkP3D?AT0ooK^0180ooK^00<0e3dI0?ofkP3om^h0
4@3om^h20=@m6@030000000mFJ/0?EV[008000000P3;>QT0100mFJ/0bcXI0</j6@0000080</j6@03
03eIZ`000000bcXI00P0bcXI00<000000</j6@3;>QT00`3;>QT00`0mFJ/0bcXI000000020</j6@80
0000103F?AX00`000000eSdJ0=Hm6P060=Hm6P030000000mFJ/0eSdJ00<0eSdJ00<000000=Hm6P3F
?AX00`3F?AX203eIZ`030000003F?AX0eSdJ00D0eSdJ00<000000=Hm6P0mFJ/00P0000000`3Q@A`0
00000>5170040>5170030000003Q@A`0hD4L00<0hD4L00D000000>51703Q@A`0?EV[000000040>51
700303eIZ`3D?AT0e3dI0080e3dI00D000000=@m6@1AMn<0DGOS00000002055gh`040000001AM^80
DGKR000000@0DGKR00<00000055fhP1AM^800`1AM^8010000000DGKR055fhP000002055egP030=@m
6@1AMMh0DGGN00@0DGGN00<00000055egP1AMMh0101AMMh00`000000D7?I051cf@03051cf@<0e3dI
0P1@LmT01@3D?AT0D7?I051cf@1@LmT0000000H0CW3@00<0000004i`d01>L=000P1>L=02000000H0
Bf[300H0000004]Z``1;J/<0e3dI04EP[P0000030?ofkP80?EV[103om^h00`3D?AT0?EV[0=@m6@05
0=@m6@L0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0@0?ofkPH0e3dI0P3om^h00`3D?AT0ooK^0?of
kP040?ofkP030000003om^h0ooK^00D0ooK^0P3D?ATN0?ofkP030000003om^h0ooK^02d0ooK^0@3o
ool000D0ooK^00<000000?ofkP3om^h04P3om^h2000003H0ooK^00<0e3dI0?ofkP3om^h03P3om^h0
0`3D?AT0ooK^0?ofkP080?ofkP<0e3dI1@3om^h00`3D?AT0ooK^0?ofkP0@0?ofkP030=@m6@3om^h0
ooK^0100ooK^103D?AT20000000303eIZ`3;>QT0bcXI0080bcXI0P0mFJ/00`3;>QT000000</j6@07
0</j6@0303eIZ`000000bcXI00P0bcXI00<000000</j6@3;>QT00`3;>QT0100mFJ/0000000000000
00070=Hm6P030000003F?AX0eSdJ00D0eSdJ00<000000=Hm6P0mFJ/0103F?AX00`000000eSdJ0=Hm
6P0203eIZ`80eSdJ00<000000=Hm6P3F?AX0103F?AX3000000050>51700mFJ/0hD4L0>5170000000
1@3Q@A`00`000000hD4L0>5170030>5170050000003Q@A`0?EV[0>5170000000103Q@A`00`000000
DGOS055gh`02055gh`050000001AMn<0e3dI055gh`0000000`1AMn<00`000000DGKR055fhP03055f
hP030000001AM^80DGKR00<0DGKR00<00000055fhP1AM^800P1AM^800`000000DGGN0=@m6@05055e
gP030000001AMMh0DGGN00@0DGGN00@00000055egP000000D7?I0`3D?AT00`1@LmT00000051cf@02
051cf@060=@m6@1@LmT0D7?I0000001@LmT00000101>L=000`000000CW3@04i`d00404i`d0030000
001;J/<0Bf[300@0Bf[300@0000004]Z``1;J/<0e3dI0P0000030?ofkP0303eIZ`3om^h0?EV[0080
ooK^1P3D?AT00`0mFJ/0ooK^0?ofkP080?ofkP040=@m6@3om^h0ooK^0=@m6@d0ooK^1`3D?AT50?of
kP030=@m6@3om^h0ooK^00@0ooK^00@000000?ofkP3om^h0ooK^0`3D?AT00`3om^h0e3dI0?ofkP0N
0?ofkP030000003om^h0ooK^02`0ooK^0@3oool000D0ooK^00<000000?ofkP3om^h03`3om^h30000
03P0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP050?ofkP80e3dI203om^h00`3D
?AT0ooK^0?ofkP0@0?ofkP030=@m6@3om^h0ooK^00h0ooK^0P3D?AT0203om^h0e3dI0?ofkP3D?AT0
ooK^0000003;>QT0?EV[1@3;>QT00`0mFJ/0bcXI000000080</j6@80?EV[203;>QT00`000000bcXI
0</j6@040000000303eIZ`3F?AX0000000P0eSdJ00<000000=Hm6P3F?AX01@3F?AX00`000000eSdJ
03eIZ`030=Hm6P030000000mFJ/0?EV[00D0eSdJ00<000000=Hm6P0000000`0000000`3Q@A`00000
0>5170020>51700303eIZ`3Q@A`0000000D0hD4L00<000000>51703Q@A`00P3Q@A`00`000000?EV[
03eIZ`020>5170030000003Q@A`0hD4L0080hD4L00D00000055gh`1AMn<0DGOS00000002055gh`03
0=@m6@000000DGOS00@0DGOS00<00000055fhP1AM^800P1AM^800`000000DGKR055fhP02055fhP03
0000001AM^80DGKR00@0DGKR00<00000055egP3D?AT0101AMMh00`000000DGGN055egP04055egP04
0000003D?AT0e3dI0=@m6@<0D7?I00<00000051cf@1@LmT00`1@LmT00`3D?AT0D7?I00000002051c
f@050000001>L=00CW3@04i`d00000001P1>L=02000000@0Bf[300<0000004]Z``1;J/<00P1;J/<0
0`3D?AT000000?ofkP020?ofkP0303eIZ`3D?AT0e3dI00D0e3dI00<0ooK^03eIZ`0mFJ/00P0mFJ/:
0?ofkP030=@m6@3om^h0e3dI00X0ooK^1@3D?AT40?ofkP030=@m6@3om^h0ooK^00@0ooK^0P3D?AT5
0?ofkP030000003D?AT0e3dI00<0ooK^00<0e3dI0?ofkP3om^h07P3om^h00`000000ooK^0?ofkP0/
0?ofkP40oooo00050?ofkP030000003om^h0ooK^00d0ooK^0P00000k0?ofkP030=@m6@3om^h0ooK^
00l0ooK^00<0e3dI0?ofkP3om^h00P3om^h30=@m6@X0ooK^00<0e3dI0?ofkP3om^h04@3om^h00`3D
?AT0ooK^0?ofkP0:0?ofkP<0e3dI103om^h20=@m6@80ooK^0P00000203eIZ`@0bcXI00<0?EV[0</j
6@0000002@3;>QT00`0mFJ/0bcXI0</j6@050</j6@<000001@3F?AX203eIZ`030000003F?AX0eSdJ
00H0eSdJ00<000000=Hm6P3F?AX0103F?AX01@000000eSdJ0=Hm6P0mFJ/0eSdJ0080?EV[00<00000
0=Hm6P3F?AX0103F?AX2000000D0hD4L00<000000>51703Q@A`00P3Q@A`00`0mFJ/000000>517004
0>5170030000003Q@A`0hD4L0080hD4L00<0?EV[0>51703Q@A`00P3Q@A`00`000000hD4L0>517002
0>5170050000001AMn<0DGOS055gh`0000000`1AMn<00`3D?AT0DGOS055gh`02055gh`030000001A
Mn<000000080DGKR00<00000055fhP1AM^800`1AM^800`000000DGKR055fhP03055fhP040000001A
M^8000000=@m6@<0DGGN00<00000055egP1AMMh00`1AMMh30=@m6@80DGGN00@00000051cf@1@LmT0
00001`1@LmT01@3D?AT0D7?I051cf@1@LmT000000080CW3@00<0000004i`d01>L=00101>L=001000
0000CW3@04i`d000000304]Z``030000001;J/<0Bf[30080Bf[300<0e3dI0000003om^h01`3D?AT0
0`3om^h0e3dI0?ofkP020?ofkP@0?EV[2P3om^h20=@m6@L0ooK^1@3D?AT70?ofkP030=@m6@3om^h0
ooK^00H0ooK^00<0e3dI0?ofkP3D?AT00P3D?AT00`000000ooK^0?ofkP030?ofkP030=@m6@3om^h0
ooK^01h0ooK^00<000000?ofkP3om^h0;03om^h10?ooo`00103om^h00`000000ooK^0?ofkP0;0?of
kP<00000?@3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0e3dI0080e3dI3@3om^h00`3D
?AT0ooK^0?ofkP0A0?ofkP030=@m6@3om^h0ooK^00P0ooK^0P3D?AT70?ofkP030=@m6@3om^h0e3dI
00<0ooK^00<000000</j6@0mFJ/0103;>QT00`0mFJ/0bcXI000000080</j6@030000000mFJ/0bcXI
00<0bcXI0P0000020=Hm6P030000003F?AX0eSdJ00D0eSdJ00<0?EV[0000003F?AX01P3F?AX00`00
0000eSdJ0=Hm6P050=Hm6P040000003F?AX0?EV[03eIZ`80eSdJ00<000000=Hm6P3F?AX00P3F?AX3
000000H0hD4L00<000000>51703Q@A`00`3Q@A`00`0mFJ/0hD4L0>5170030>5170030000003Q@A`0
hD4L0080?EV[00<000000>51703Q@A`00P3Q@A`00`000000hD4L0>5170020>5170050000001AMn<0
DGOS055gh`0000000P1AMn<00`000000e3dI055gh`03055gh`060000001AMn<0DGOS0000001AM^80
0000101AM^800`000000DGKR055fhP03055fhP080000001AM^80DGKR055fhP000000e3dI055egP00
0003055egP<0e3dI00<00000055egP1AMMh00`1AMMh00`000000D7?I00000006051cf@030000003D
?AT0D7?I00<0D7?I00<0000004i`d00000001P1>L=001@000000CW3@04i`d01>L=0000000080Bf[3
00<0000004]Z``1;J/<00P1;J/<60=@m6@<0ooK^00@0?EV[0?ofkP3D?AT0?EV[0`3om^h0100mFJ/0
ooK^03eIZ`0mFJ/90?ofkP80e3dI103om^h50=@m6@X0ooK^00<0e3dI0?ofkP3om^h0103om^h50=@m
6@<0ooK^00D000000?ofkP3om^h0ooK^0=@m6@0Q0?ofkP030000003om^h0ooK^02`0ooK^0@3oool0
00@0ooK^00<000000?ofkP3om^h0203om^h300000400ooK^00<0e3dI0?ofkP3om^h03P3om^h30=@m
6A40ooK^00<0e3dI0?ofkP3om^h0403om^h00`3D?AT0ooK^0?ofkP050?ofkP<0e3dI2@3om^h00`3D
?AT0ooK^0=@m6@040?ofkP040000003;>QT0?EV[03eIZ`<0bcXI00<0?EV[0</j6@000000203;>QT0
0`000000?EV[0</j6@02000000D0eSdJ00<000000=Hm6P3F?AX01@3F?AX00`0mFJ/000000=Hm6P06
0=Hm6P030000003F?AX0eSdJ00<0eSdJ0`0mFJ/20=Hm6P0503eIZ`3F?AX0eSdJ0000003F?AX00P00
00030>5170030000003Q@A`0hD4L00@0hD4L00<000000>51703Q@A`00P3Q@A`00`000000?EV[0>51
70030>5170030000003Q@A`0?EV[0080hD4L00D000000>51703Q@A`0hD4L000000040>5170050000
001AMn<0DGOS055gh`0000000`1AMn<00`000000DGOS0=@m6@02055gh`030000001AMn<0DGOS0080
DGOS00<00000055fhP1AM^800`1AM^800`000000DGKR055fhP03055fhP030000001AM^80DGKR0080
DGKR00<0e3dI055egP0000000`3D?AT2055egP030000001AMMh0DGGN00D0DGGN00<00000051cf@1@
LmT01@1@LmT00`000000D7?I0=@m6@04051cf@030000001>L=00CW3@00@0CW3@00<0000004i`d01>
L=000`1>L=0200000080Bf[31P3D?AT00`3om^h0?EV[0?ofkP040?ofkP0303eIZ`3D?AT0?EV[00<0
ooK^0P0mFJ/00`3om^h0?EV[0?ofkP090?ofkP030=@m6@3om^h0e3dI00<0e3dI3@3om^h00`3D?AT0
ooK^0?ofkP020?ofkPD0e3dI0`3om^h20=@m6@80ooK^00@000000?ofkP3D?AT0e3dI8@3om^h00`00
0000ooK^0?ofkP0/0?ofkP40oooo00040?ofkP030000003om^h0ooK^00H0ooK^0P0000130?ofkP03
0=@m6@3om^h0ooK^00/0ooK^0`3D?AT00`3om^h0e3dI0?ofkP0A0?ofkP030=@m6@3om^h0ooK^0100
ooK^00<0e3dI0?ofkP3om^h00P3om^h30=@m6@d0ooK^0P3D?AT50?ofkP030000003;>QT0?EV[0080
?EV[0P3;>QT00`0mFJ/0bcXI000000070</j6@80000000<0?EV[0=Hm6P3F?AX01P3F?AX00`000000
eSdJ0=Hm6P050=Hm6P0303eIZ`3F?AX0eSdJ00H0eSdJ00<000000=Hm6P0mFJ/00P0mFJ/20=Hm6P05
0000003F?AX0eSdJ0=Hm6P0mFJ/00`0000050>5170030000003Q@A`0hD4L00@0hD4L00<000000>51
703Q@A`00`3Q@A`00`000000?EV[0>5170020>5170030000000mFJ/0hD4L0080hD4L00D000000>51
703Q@A`0hD4L000000020>5170<000000`1AMn<010000000DGOS055gh`000002055gh`040=@m6@1A
Mn<0DGOS000000<0DGOS00<00000055gh`0000000`1AM^800`000000DGKR055fhP03055fhP030000
001AM^80DGKR00<0DGKR0`3D?AT5055egP030000001AMMh0DGGN00@0DGGN00<00000055egP000000
1@1@LmT01@000000D7?I051cf@1@LmT0e3dI0080D7?I00<00000051cf@0000001@1>L=000`000000
CW3@04i`d00404i`d0<0e3dI00@0Bf[30=@m6@1;J/<0?EV[0P3om^h00`3D?AT0?EV[0?ofkP050?of
kP030=@m6@0mFJ/0ooK^00<0ooK^00@0?EV[0?ofkP3om^h0?EV[203om^h40=@m6A00ooK^00<0e3dI
0?ofkP3D?AT0103D?AT80?ofkP<0e3dI00<000000?ofkP3om^h08P3om^h00`000000ooK^0?ofkP0[
0?ofkP40oooo00040?ofkP030000003om^h0ooK^00<0ooK^0`0000150?ofkP030=@m6@3om^h0ooK^
00P0ooK^0`3D?AT40?ofkP030=@m6@3om^h0ooK^0100ooK^00<0e3dI0?ofkP3om^h04@3om^h0103D
?AT0ooK^0=@m6@3D?AT@0?ofkP030=@m6@3om^h0e3dI00D0ooK^00@000000</j6@0mFJ/0bcXI0P0m
FJ/0103;>QT0?EV[03eIZ`0000020</j6@@000000P3F?AX00`000000?EV[0=Hm6P070=Hm6P030000
003F?AX0eSdJ00D0eSdJ00<0?EV[0=Hm6P3F?AX0103F?AX303eIZ`D0eSdJ10000000103Q@A`0?EV[
0>51700000060>5170030000003Q@A`0hD4L00<0hD4L00<000000>51703Q@A`00`3Q@A`010000000
hD4L03eIZ`3Q@A`203eIZ`@0hD4L00@000000>51703Q@A`0hD4L0`0000020>Y47@8000000P1AMn<0
10000000DGOS055gh`000003055gh`030=@m6@000000DGOS00<0DGOS00<00000055gh`0000000P1A
M^800`000000DGKR055fhP03055fhP040000001AM^80DGKR055fhP<0e3dI00<00000055fhP3D?AT0
101AMMh00`000000DGGN055egP04055egP040000001AMMh0DGGN055egP8000000P1@LmT00`000000
D7?I051cf@02051cf@040=@m6@1@LmT0D7?I00000080D7?I00D0000004i`d01>L=00CW3@00000004
04i`d0<0e3dI00<0CW3@0000001;J/<00P1;J/<00`000000ooK^03eIZ`020?ofkP030=@m6@3om^h0
ooK^00<0ooK^00<0e3dI0?ofkP0mFJ/01@3om^h0100mFJ/0ooK^0?ofkP0mFJ/40?ofkPD0e3dI00<0
ooK^0=@m6@3om^h03P3om^h40=@m6@P0ooK^103D?AT30?ofkP030000003om^h0ooK^0280ooK^00<0
00000?ofkP3om^h0:`3om^h10?ooo`000`3om^h010000000ooK^0?ofkP3om^h3000004T0ooK^00<0
e3dI0?ofkP3om^h01@3om^h20=@m6@P0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?of
kP0@0?ofkP<0e3dI4`3om^h20=@m6@H0ooK^0P0000000`0mFJ/0bcXI0</j6@0203eIZ`040</j6@0m
FJ/00000000000L0eSdJ00<0000003eIZ`0mFJ/01`3F?AX00`000000eSdJ0=Hm6P050=Hm6P0303eI
Z`3F?AX0eSdJ00<0?EV[0P3F?AX00`000000eSdJ0=Hm6P0300000080hD4L00H000000>51703Q@A`0
hD4L03eIZ`0000060>5170030000003Q@A`0hD4L00<0hD4L00<000000>51703Q@A`00`3Q@A`01P00
0000hD4L0>51700mFJ/0hD4L000000@0hD4L00<000000>51700000000P0000030>Y47@040000001@
M^<0D7KS000000<0DGOS00<00000055gh`1AMn<00P1AMn<00`3D?AT0DGOS055gh`02055gh`070000
001AMn<0DGOS055gh`000000DGKR00000004055fhP030000001AM^80e3dI0080e3dI0P1AM^801@00
0000DGKR055fhP3D?AT000000080DGGN00<00000055egP1AMMh01@1AMMh00`000000DGGN055egP03
055egP030000001@LmT0000000D0D7?I00<0e3dI0000001@LmT00`1@LmT010000000CW3@04i`d000
00040=@m6@80CW3@00@0000004i`d01>L=0000000P1;J/<01`000000ooK^0?ofkP0mFJ/0ooK^03eI
Z`3D?AT0103om^h0103D?AT0ooK^03eIZ`0mFJ/40?ofkP80?EV[00<0ooK^03eIZ`3D?AT0103D?AT2
0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT02P3om^h50=@m6@P0ooK^103D?AT70?ofkP030000003o
m^h0ooK^0240ooK^00<000000?ofkP3om^h0:`3om^h10?ooo`000`3om^h010000000ooK^00000000
001<0?ofkP030=@m6@3om^h0ooK^0080ooK^0`3D?AT:0?ofkP030=@m6@3om^h0ooK^0100ooK^00<0
e3dI0?ofkP3om^h0303om^h30=@m6@030?ofkP3D?AT0ooK^01<0ooK^0P3D?AT70?ofkP8000000P0m
FJ/2000000<0?EV[00<000000=Hm6P3F?AX01`3F?AX00`000000?EV[0=Hm6P060=Hm6P030000003F
?AX0eSdJ0080eSdJ1@0mFJ/50=Hm6P<000001@3Q@A`00`000000hD4L0>5170020>51700303eIZ`00
0000hD4L00@0hD4L00<000000>51703Q@A`00`3Q@A`00`000000hD4L0>5170030>5170060000000m
FJ/0?EV[0>51700mFJ/000000P3Q@A`400000080jT@M00D000000>Y47@3ZA1d0jT@M00000003051f
h`040000001AMn<0DGOS000000@0DGOS00D000000=@m6@1AMn<0DGOS00000005055gh`030000001A
M^80DGKR0080DGKR0`3D?AT5055fhP080000001AM^80DGKR055fhP3D?AT00000055egP000006055e
gP030000001AMMh0DGGN00D0DGGN00<00000051cf@1@LmT0101@LmT00`000000e3dI051cf@04051c
f@<0e3dI1@1>L=001@000000CW3@04i`d01>L=0000000080Bf[300L000000?ofkP3om^h0?EV[0?of
kP0mFJ/0e3dI00@0ooK^00@0e3dI0?ofkP3om^h0?EV[1@3om^h50=@m6@D0ooK^00<0e3dI0?ofkP3o
m^h00P3om^h20=@m6@D0ooK^1@3D?AT20?ofkP030=@m6@3om^h0ooK^0080ooK^1@3D?AT;0?ofkP03
0000003om^h0ooK^0200ooK^00<000000?ofkP3om^h0:`3om^h10?ooo`000`3om^h2000004h0ooK^
00<0e3dI0?ofkP3D?AT00P3D?AT=0?ofkP030=@m6@3om^h0ooK^0100ooK^00<0e3dI0?ofkP3om^h0
2@3om^h30=@m6@D0ooK^00<0e3dI0?ofkP3om^h04@3om^h00`3D?AT0ooK^0=@m6@070?ofkP<00000
00@0?EV[0=Hm6P3F?AX0eSdJ200mFJ/40=Hm6P030000000mFJ/0eSdJ00<0eSdJ1`0mFJ/40=Hm6P03
03eIZ`3F?AX0eSdJ00<000000P3Q@A`00`000000hD4L0>5170040>5170030000003Q@A`0hD4L0080
hD4L0P0mFJ/50>5170030000003Q@A`0hD4L0080hD4L00<000000>51703Q@A`00P3Q@A`203eIZ`<0
hD4L00@0000003eIZ`00000000000P3ZA1d010000000jT@M0>Y47@0000030>Y47@070000001@M^<0
D7KS051fh`000000D7KS00000005055gh`030000001AMn<0e3dI0080DGOS00<00000055gh`1AMn<0
0P1AMn<00`000000DGOS0=@m6@030=@m6@030000001AM^80DGKR00@0DGKR00<00000055fhP1AM^80
0`1AM^800`3D?AT00000055egP05055egP030000001AMMh0DGGN00D0DGGN00<00000055egP000000
1@1@LmT010000000e3dI051cf@1@LmT30=@m6@03051cf@000000CW3@00D0CW3@00<0000004i`d01>
L=000P1>L=02000000@0ooK^0P0mFJ/00`3om^h0e3dI0?ofkP020?ofkP030=@m6@3om^h0ooK^0080
?EV[00<0ooK^0=@m6@3D?AT00`3D?AT00`3om^h0?EV[0?ofkP050?ofkP030=@m6@3om^h0ooK^00@0
ooK^1P3D?AT50?ofkP030=@m6@3om^h0e3dI00D0e3dI3P3om^h00`000000ooK^0?ofkP0P0?ofkP03
0000003om^h0ooK^02/0ooK^0@3oool000@0ooK^0P00001=0?ofkP80e3dI403om^h00`3D?AT0ooK^
0?ofkP0@0?ofkP030=@m6@3om^h0ooK^00H0ooK^0`3D?AT80?ofkP030=@m6@3om^h0ooK^0180ooK^
0P3D?AT40?ofkP<0e3dI00D0ooK^000000000000000003eIZ`040=Hm6P0303eIZ`3F?AX0000000<0
eSdJ2P0mFJ/40=Hm6P030000003F?AX0eSdJ00@0eSdJ00<0000003eIZ`0000001@3Q@A`00`000000
hD4L0>5170050>5170030000003Q@A`0hD4L0080hD4L00<0000003eIZ`3Q@A`00`3Q@A`00`000000
hD4L0>5170030>5170070000003Q@A`0?EV[03eIZ`3Q@A`000000>517002000000030>Y47@000000
?EV[00<0jT@M00@000000>Y47@3ZA1d000000`3ZA1d01@000000D7KS051fh`1@M^<000000080D7KS
00<00000055gh`1AMn<00P1AMn<01@000000DGOS055gh`3D?AT0000000@0DGOS0`3D?AT0101AMn<0
0000055fhP000006055fhP030000001AM^80DGKR00@0DGKR00<000000=@m6@000000101AMMh00`00
0000DGGN055egP05055egP050000001AMMh0DGGN055egP0000000`1@LmT00`000000D7?I0=@m6@02
0=@m6@<0D7?I00<00000051cf@000000101>L=000`000000CW3@04i`d00404i`d0030000003om^h0
ooK^00<0ooK^00@0?EV[0?ofkP3om^h0e3dI0P3om^h00`3D?AT0ooK^0=@m6@040=@m6@80ooK^00D0
?EV[0?ofkP0mFJ/0ooK^03eIZ`050?ofkP030=@m6@3om^h0ooK^0080ooK^1@3D?AT70?ofkPD0e3dI
4`3om^h00`000000ooK^0?ofkP0P0?ofkP030000003om^h0ooK^02X0ooK^0@3oool000H0ooK^00<0
00000?ofkP3om^h0BP3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^0100ooK^00<0
e3dI0?ofkP3om^h00`3om^h30=@m6@`0ooK^00<0e3dI0?ofkP3om^h04@3om^h0103D?AT0ooK^0=@m
6@3om^h20=@m6@D0ooK^00@0000003eIZ`000000?EV[103F?AX00`0mFJ/0eSdJ000000080=Hm6P03
0000000mFJ/0eSdJ00H0eSdJ00<000000=Hm6P3F?AX00`0000020>51700303eIZ`3Q@A`0hD4L00@0
hD4L00<000000>51703Q@A`0103Q@A`00`000000hD4L0>5170020>5170030000003Q@A`0?EV[00@0
hD4L00<000000>51703Q@A`00P3Q@A`010000000?EV[0>51703Q@A`3000000<0jT@M00D000000>Y4
7@0mFJ/0?EV[000000030>Y47@050000003ZA1d0jT@M0>Y47@0000000P1@M^<01P000000D7KS051f
h`000000D7KS00000080DGOS00L00000055gh`1AMn<0DGOS0=@m6@000000DGOS00<0e3dI00<00000
055gh`1AMn<00P1AMn<00`000000DGKR055fhP04055fhP030000001AM^80DGKR00@0DGKR00D00000
055fhP3D?AT0DGKR00000003055egP030000001AMMh0DGGN00@0DGGN00<00000055egP1AMMh00P1A
MMh00`000000D7?I0=@m6@030=@m6@80D7?I00@0e3dI051cf@1@LmT000000`1@LmT01@000000CW3@
04i`d01>L=00000000D0CW3@00<000000?ofkP3om^h0103om^h203eIZ`80ooK^1P3D?AT20?ofkP04
03eIZ`3om^h0ooK^03eIZ`80ooK^0P0mFJ/40?ofkP030=@m6@3om^h0e3dI00D0e3dI0`3om^h30=@m
6@030?ofkP3D?AT0e3dI00<0e3dI5`3om^h00`000000ooK^0?ofkP0O0?ofkP030000003om^h0ooK^
02X0ooK^0@3oool000L0ooK^0P00001:0?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3o
m^h04@3om^h00`3D?AT0ooK^0=@m6@020=@m6@l0ooK^00<0e3dI0?ofkP3om^h04@3om^h0103D?AT0
ooK^0=@m6@3D?AT80?ofkP80e3dI00<0?EV[0000003F?AX00`3F?AX203eIZ`8000001`3F?AX00`00
0000?EV[0=Hm6P050=Hm6P<000001P3Q@A`00`0mFJ/0hD4L0>5170040>5170030000003Q@A`0hD4L
00@0hD4L00<000000>51703Q@A`00P3Q@A`00`000000hD4L03eIZ`030>5170040000003Q@A`0hD4L
0>517080?EV[00D0hD4L000000000000jT@M000000040>Y47@050000003ZA1d0jT@M0>Y47@0mFJ/0
0`3ZA1d010000000jT@M0>Y47@000003051fh`040000001@M^<0D7KS00000080D7KS00<00000055g
h`0000000`1AMn<30=@m6@80DGOS00<00000055gh`1AMn<00P1AMn<00`000000DGOS00000004055f
hP030000001AM^80DGKR00@0DGKR00T00000055fhP1AM^80DGKR0=@m6@1AM^800000055egP000000
1P1AMMh00`000000DGGN055egP02055egP<0e3dI00<0D7?I0000001@LmT0101@LmT00`3D?AT00000
051cf@03051cf@040000001>L=00CW3@000000H0CW3@00<000000?ofkP3om^h0103om^h00`0mFJ/0
e3dI0=@m6@040=@m6@80ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`020?ofkP0303eIZ`3om^h0ooK^
0080?EV[0P3om^h60=@m6@L0ooK^1@3D?ATK0?ofkP030000003om^h0ooK^01h0ooK^00<000000?of
kP3om^h0:P3om^h10?ooo`002@3om^h00`000000ooK^0?ofkP180?ofkP030=@m6@3om^h0ooK^00l0
ooK^00<0e3dI0?ofkP3om^h03`3om^h30=@m6A80ooK^00<0e3dI0?ofkP3om^h04P3om^h20=@m6@H0
ooK^0`3D?AT20?ofkP030000000mFJ/0000000D0eSdJ00<0?EV[0=Hm6P000000203F?AX00`0mFJ/0
eSdJ0=Hm6P0300000080hD4L00<000000>51703Q@A`01@3Q@A`00`0mFJ/0hD4L0>5170040>517003
0000003Q@A`0hD4L00<0hD4L00<000000>51703Q@A`00P3Q@A`010000000hD4L0>51700mFJ/30>51
70030000000mFJ/0?EV[00<000000`3ZA1d00`000000jT@M0>Y47@020>Y47@080000003ZA1d0jT@M
0>Y47@000000?EV[0>Y47@0000030>Y47@040000001@M^<0D7KS00000080D7KS00<00000051fh`1@
M^<00P1@M^<00`000000e3dI0=@m6@020=@m6@80DGOS00<0e3dI055gh`000000101AMn<01@000000
DGOS055gh`1AMn<0000000<0DGKR00<00000055fhP1AM^800`1AM^800`000000DGKR055fhP03055f
hP030=@m6@1AM^80000000H0DGGN00<00000055egP3D?AT00`3D?AT2055egP0303eIZ`000000D7?I
00D0D7?I00<000000=@m6@1@LmT0101@LmT00`000000CW3@0000000504i`d0030000003om^h0ooK^
0080ooK^1`3D?AT00`3om^h0e3dI0=@m6@020?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/00P3om^h0
100mFJ/0ooK^0?ofkP3om^h60=@m6@L0ooK^1@3D?ATN0?ofkP030000003om^h0ooK^01h0ooK^00<0
00000?ofkP3om^h0:P3om^h10?ooo`002P3om^h2000004P0ooK^00<0e3dI0?ofkP3om^h03`3om^h0
0`3D?AT0ooK^0?ofkP0=0?ofkP80e3dI00<0ooK^0=@m6@3om^h04`3om^h00`3D?AT0ooK^0?ofkP0A
0?ofkP80e3dI103om^h20=@m6@H0ooK^00<0000003eIZ`0000001@3F?AX00`0mFJ/0eSdJ00000007
0=Hm6P030000000mFJ/0000000H0hD4L00<000000>51703Q@A`01@3Q@A`203eIZ`@0hD4L00<00000
0>51703Q@A`0103Q@A`00`000000hD4L0>5170020>5170050000003Q@A`0hD4L03eIZ`3Q@A`00P0m
FJ/2000000030>Y47@000000jT@M00@0jT@M00D000000>Y47@3ZA1d0jT@M000000030>Y47@040000
003ZA1d0?EV[000000<0jT@M00@00000051fh`1@M^<000000P1@M^<00`000000D7KS051fh`030=@m
6@80000000<0DGOS0000001AMn<00P1AMn<00`3D?AT0DGOS055gh`03055gh`030000001AMn<0DGOS
0080DGOS00<00000055fhP0000001@1AM^800`000000DGKR055fhP05055fhP030=@m6@1AM^800000
00@0DGGN0`3D?AT6055egP030000001AMMh0000000@0D7?I00@00000051cf@1@LmT0e3dI1@1@LmT0
0`000000CW3@04i`d00404i`d0030000003D?AT0e3dI00D0e3dI103om^h01P0mFJ/0e3dI0?ofkP3D
?AT0ooK^03eIZ`@0ooK^00<0?EV[0?ofkP3D?AT01`3D?AT50?ofkPH0e3dI8P3om^h00`000000ooK^
0?ofkP0M0?ofkP030000003om^h0ooK^02X0ooK^0@3oool000`0ooK^00<000000?ofkP3om^h0A@3o
m^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00X0ooK^0`3D?AT40?ofkP030=@m6@3o
m^h0ooK^0140ooK^00<0e3dI0?ofkP3om^h04P3om^h50=@m6@T0ooK^100000040=Hm6P0403eIZ`3F
?AX0000000000080eSdJ0`0000020>51700303eIZ`3Q@A`0hD4L00D0hD4L00<000000>51703Q@A`0
103Q@A`00`000000hD4L03eIZ`040>5170030000003Q@A`0hD4L00@0hD4L00D000000>51703Q@A`0
hD4L000000020>517080?EV[00<0jT@M0000003ZA1d00`3ZA1d00`000000jT@M0>Y47@020>Y47@05
0000003ZA1d0jT@M0>Y47@0000000`3ZA1d010000000jT@M0>Y47@0mFJ/20>Y47@040000001@M^<0
D7KS00000080D7KS103D?AT00`1@M^<00000051fh`02051fh`060000001AMn<0DGOS055gh`000000
e3dI101AMn<00`000000DGOS055gh`04055gh`030000001AM^80DGKR00<0DGKR00<00000055fhP1A
M^80101AM^82000000030=@m6@1AM^80000000@0e3dI201AMMh010000000DGGN055egP000003051c
f@030000001@LmT0D7?I0080D7?I00L0e3dI051cf@1@LmT0D7?I0000001@LmT0000000@0CW3@1@3D
?AT30?ofkP0303eIZ`3om^h0ooK^0080ooK^00@0?EV[0=@m6@3om^h0ooK^0P3D?AT30?ofkPH0e3dI
0P3om^h00`0mFJ/0e3dI0?ofkP020?ofkPH0e3dI9P3om^h00`000000ooK^0?ofkP0L0?ofkP030000
003om^h0ooK^02X0ooK^0@3oool000d0ooK^00<000000?ofkP3om^h0A03om^h00`3D?AT0ooK^0?of
kP0?0?ofkP030=@m6@3om^h0ooK^00P0ooK^0P3D?AT70?ofkP030=@m6@3om^h0ooK^0180ooK^00<0
e3dI0?ofkP3om^h0403om^h30=@m6@h0ooK^00<0000003eIZ`000000103F?AX00`0mFJ/0eSdJ0000
0002000000H0hD4L0P0mFJ/60>5170030000003Q@A`0hD4L00@0hD4L00<000000>51700mFJ/0103Q
@A`00`000000hD4L0>5170030>5170040000003Q@A`0hD4L0>5170<0?EV[0P3ZA1d00`0mFJ/0jT@M
000000030>Y47@030000003ZA1d0jT@M0080jT@M00D000000>Y47@3ZA1d0jT@M000000030>Y47@07
0000003ZA1d0jT@M0000000mFJ/0jT@M00000002051fh`040000003D?AT0e3dI000000<0D7KS00L0
0000051fh`1@M^<0D7KS0000001@M^<000000080DGOS00<00000055gh`3D?AT00P1AMn<00`000000
DGOS055gh`04055gh`030000001AMn<0000000<0DGKR00<00000055fhP1AM^80101AM^800`000000
DGKR055fhP030=@m6@030000001AMMh0000000P0DGGN00<00000055egP1AMMh00P1AMMh00`000000
D7?I00000006051cf@030=@m6@1@LmT0000000<0D7?I00<0000004i`d03D?AT00`3D?AT60?ofkP03
03eIZ`3om^h0ooK^00<0ooK^00D0e3dI0?ofkP3om^h0ooK^03eIZ`060=@m6@80?EV[103om^h70=@m
6BT0ooK^00<000000?ofkP3om^h07@3om^h00`000000ooK^0?ofkP0Y0?ofkP40oooo000>0?ofkP80
0000A03om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00D0ooK^0`3D?AT90?ofkP03
0=@m6@3om^h0ooK^0180ooK^00<0e3dI0?ofkP3om^h03@3om^h30=@m6@030?ofkP3D?AT0e3dI00l0
ooK^00@0000003eIZ`00000000000P3F?AX010000000?EV[03eIZ`3Q@A`2000000L0hD4L00<0?EV[
0>51703Q@A`0103Q@A`2000000D0hD4L00<000000>51700mFJ/0103Q@A`00`000000hD4L0>517002
0>5170040000000mFJ/0?EV[03eIZ`80jT@M00H000000>Y47@3ZA1d0jT@M03eIZ`0000040>Y47@05
0000003ZA1d0jT@M0>Y47@0000000`3ZA1d010000000jT@M0>Y47@0000020>Y47@050000003ZA1d0
?EV[0000001@M^<00`3D?AT00`1@M^<00000051fh`02051fh`050000001@M^<0D7KS051fh`000000
0P1@M^<00`000000DGOS00000003055gh`030=@m6@000000DGOS00@0DGOS0P000003055gh`030000
001AM^80000000H0DGKR00@000000=@m6@3D?AT0e3dI0P1AM^800`3D?AT0DGKR00000007055egP80
00001P1AMMh00`000000D7?I051cf@06051cf@030=@m6@1@LmT0D7?I00@0e3dI00<0CW3@0000000m
FJ/01P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP030=@m6@3om^h0e3dI00H0e3dI103om^h00`0mFJ/0
ooK^0?ofkP050=@m6Bh0ooK^00<000000?ofkP3om^h0703om^h00`000000ooK^0?ofkP0Y0?ofkP40
oooo000@0?ofkP030000003om^h0ooK^0440ooK^00<0e3dI0?ofkP3om^h0403om^h0103D?AT0ooK^
0?ofkP3om^h30=@m6@d0ooK^00<0e3dI0?ofkP3om^h04@3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP<0
e3dI1@3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP80000000<083=a0000000000000`3Q@A`00`0mFJ/0
hD4L0>517002000000H0hD4L00<0?EV[0>51703Q@A`01@3Q@A`00`000000hD4L0>5170030>517003
0000003Q@A`0?EV[00<0hD4L00<000000>51703Q@A`00`0mFJ/00`3ZA1d000000>Y47@020>Y47@03
0000003ZA1d0jT@M0080jT@M00<0?EV[0000003ZA1d00P3ZA1d01@000000jT@M0>Y47@3ZA1d00000
00<0jT@M00@000000>Y47@3ZA1d000000P3ZA1d010000000jT@M000000000002051fh`040000001@
M^<0D7KS000000<0D7KS00D00000051fh`1@M^<0D7KS00000003051fh`030000001AMn<0DGOS0080
DGOS00<000000=@m6@1AMn<00`1AMn<00`000000DGOS055gh`04055gh`030000001AM^80DGKR00<0
DGKR0`3D?AT5055fhP040000003D?AT0DGKR000000D0DGGN00<00000055egP1AMMh01@1AMMh00`00
0000?EV[00000006051cf@040000003D?AT0e3dI0=@m6@<0D7?I00D0000004i`d0000000ooK^03eI
Z`050?ofkP0303eIZ`3om^h0ooK^0080ooK^1`3D?AT30?ofkPT0e3dI00<0ooK^03eIZ`3om^h0;`3o
m^h00`000000ooK^0?ofkP0K0?ofkP030000003om^h0ooK^02T0ooK^0@3oool00140ooK^0P000012
0?ofkP030=@m6@3om^h0ooK^00l0ooK^00@0e3dI0?ofkP3D?AT0e3dI403om^h00`3D?AT0ooK^0?of
kP0B0?ofkP030=@m6@3om^h0ooK^00H0ooK^0`3D?AT80?ofkP80e3dI3`3om^h00`3D?AT00000020c
L@03000000040>51700mFJ/0?EV[03eIZ`<0hD4L0P0000050>51700303eIZ`000000hD4L00D0hD4L
00<000000>51703Q@A`00`3Q@A`01@000000hD4L03eIZ`3Q@A`0000000<0?EV[1@3ZA1d01@000000
jT@M0>Y47@3ZA1d0000000@0jT@M00D0?EV[0>Y47@3ZA1d0jT@M000000030>Y47@050000003ZA1d0
jT@M0>Y47@0000000P3ZA1d00`000000jT@M00000002000000030=@m6@000000000000<0D7KS00D0
0000051fh`1@M^<0D7KS00000003051fh`070000001@M^<0D7KS051fh`000000D7KS00000003055g
h`030000001AMn<0e3dI0080DGOS00<00000055gh`1AMn<0101AMn<010000000DGOS0000001AM^83
0=@m6@030000001AM^80DGKR00@0DGKR00<00000055fhP3D?AT00P1AM^801@000000DGGN055egP1A
MMh0000000L0DGGN00D00000055egP1AMMh0DGGN00000003051cf@<0e3dI0P1@LmT20=@m6@<0D7?I
00D000000?ofkP3om^h0ooK^03eIZ`040?ofkP0303eIZ`3om^h0e3dI00D0e3dI0P3om^h203eIZ`<0
ooK^1P3D?AT01@0mFJ/0ooK^0?ofkP3om^h0?EV[0340ooK^00<000000?ofkP3om^h06P3om^h00`00
0000ooK^0?ofkP0Y0?ofkP40oooo000C0?ofkP030000003om^h0ooK^03l0ooK^00<0e3dI0?ofkP3o
m^h03P3om^h30=@m6A80ooK^00<0e3dI0?ofkP3om^h04P3om^h00`3D?AT0ooK^0?ofkP030?ofkP<0
e3dI303om^h00`3D?AT0ooK^0?ofkP0<0?ofkP<0e3dI1P0000000`3Q@A`0?EV[03eIZ`0303eIZ`03
0>5170000000hD4L00@0hD4L00<0?EV[0000003Q@A`01@3Q@A`00`000000hD4L0>5170020>5170D0
?EV[0P3ZA1d00`000000jT@M0>Y47@030>Y47@030000003ZA1d0jT@M0080jT@M00H000000>Y47@3Z
A1d0jT@M0000000mFJ/30>Y47@050000003ZA1d0jT@M0>Y47@0000000P3ZA1d00`000000jT@M0000
0002000000040?A77P000000m4LN00000080CWCQ00@00000051fh`1@M^<000000`1@M^<010000000
D7KS051fh`000003051fh`070000001@M^<0D7KS051fh`000000DGOS00000003055gh`030=@m6@00
0000DGOS00@0DGOS0P0000001P1AMn<0e3dI0=@m6@3D?AT0DGKR000000L0DGKR00D00000055fhP1A
M^80DGKR0=@m6@02055fhP030000001AMMh0000000L0DGGN00<00000055egP1AMMh00P1AMMh01@00
0000e3dI0=@m6@3D?AT0000000H0D7?I00<0e3dI051cf@000000103om^h00`0mFJ/0ooK^0?ofkP07
0=@m6@H0ooK^1`3D?AT0103om^h0?EV[0?ofkP0mFJ/30?ofkP0303eIZ`3om^h0ooK^02l0ooK^00<0
00000?ofkP3om^h06P3om^h00`000000ooK^0?ofkP0Y0?ofkP40oooo000D0?ofkP800000?`3om^h0
0`3D?AT0ooK^0?ofkP0;0?ofkP<0e3dI00<0ooK^0=@m6@3om^h04P3om^h00`3D?AT0ooK^0?ofkP0C
0?ofkP030=@m6@3om^h0e3dI0080e3dI3`3om^h00`3D?AT0ooK^0?ofkP090?ofkP<0e3dI00@0ooK^
0=@m6@3om^h0ooK^0P0000000`0P<g40e3dI02]5T@02000000040>51700mFJ/0hD4L0>5170H0?EV[
0P3Q@A`00`0mFJ/000000>5170020>5170L0?EV[00D000000>Y47@000000000003eIZ`030>Y47@03
0000003ZA1d0jT@M00<0jT@M00D000000>Y47@3ZA1d0jT@M000000040>Y47@050000000mFJ/0jT@M
0>Y47@0000000`3ZA1d00`000000jT@M00000002000000040?A77P000000m4LN00000080m4LN00<0
000004idh@1>M>400P000004051fh`040000001@M^<0D7KS000000<0D7KS00<00000051fh`1@M^<0
0`1@M^<01P000000DGOS055gh`1AMn<000000=@m6@D0DGOS00@000000=@m6@3D?AT0e3dI0`1AMn<0
0`000000DGKR055fhP04055fhP8000001@1AM^80103D?AT0DGKR055fhP000006055egP8000000`1A
MMh30=@m6@030000001@LmT0000000P0D7?I00<0e3dI0?ofkP3om^h00`3om^h60=@m6@<0ooK^00@0
e3dI0?ofkP3om^h0ooK^1P3D?AT50?ofkP0403eIZ`3om^h0ooK^03eIZ`80ooK^00<0?EV[0?ofkP3o
m^h0<03om^h00`000000ooK^0?ofkP0J0?ofkP030000003om^h0ooK^02P0ooK^0@3oool001H0ooK^
00<000000?ofkP3om^h0?03om^h00`3D?AT0ooK^0?ofkP080?ofkP<0e3dI1@3om^h00`3D?AT0ooK^
0?ofkP0A0?ofkP030=@m6@3om^h0ooK^0140ooK^0`3D?ATB0?ofkP80e3dI1`3om^h30=@m6@@0ooK^
00@0e3dI0?ofkP3om^h0ooK^0P0000001`3D?AT000000000000[AI4000000>51700mFJ/01@3Q@A`2
000000L0?EV[0P3Q@A`4000000D0jT@M00<0000003eIZ`3ZA1d00P3ZA1d00`000000jT@M0>Y47@03
0>Y47@050000003ZA1d0jT@M0>Y47@0000000`3ZA1d00`000000jT@M03eIZ`020>Y47@030000003Z
A1d000000080000000@0m4LN0000003dAah0m4LN0`0mFJ/20?A77P030000001>M>4000000080CWCQ
00@00000051fh`1@M^<000000P1@M^<01@000000D7KS051fh`1@M^<0000000D0D7KS00D00000051f
h`000000DGOS00000002055gh`030=@m6@1AMn<0DGOS00<0e3dI101AMn<200000003055gh`000000
DGKR00<0DGKR00<00000055fhP1AM^801P1AM^80103D?AT00000055fhP000004055egP030000001A
MMh0e3dI00<0e3dI101AMMh00`000000D7?I051cf@04051cf@040=@m6@1@LmT000000?ofkPP0e3dI
00<0ooK^03eIZ`3om^h00P3om^h80=@m6@0303eIZ`3om^h0?EV[00D0ooK^00D0?EV[0?ofkP3om^h0
ooK^03eIZ`020?ofkP0303eIZ`3om^h0ooK^0300ooK^00<000000?ofkP3om^h06@3om^h00`000000
ooK^0?ofkP0X0?ofkP40oooo000G0?ofkP800000?03om^h00`3D?AT0ooK^0?ofkP060?ofkP80e3dI
203om^h00`3D?AT0ooK^0?ofkP0A0?ofkP030=@m6@3om^h0ooK^00h0ooK^0`3D?AT00`3om^h0e3dI
0?ofkP0C0?ofkP030=@m6@3om^h0ooK^0080ooK^0`3D?AT70?ofkP030=@m6@3om^h0ooK^0080ooK^
0P0000000`3D?AT0000000000003000000L0hD4L0P0000020>51700303eIZ`000000000000800000
0`3ZA1d2000000D0jT@M00<0000003eIZ`3ZA1d00P3ZA1d2000000@0jT@M00D000000>Y47@3ZA1d0
jT@M000000050>Y47@0603eIZ`00000000000000003dAah000000P3dAah020000000?EV[03eIZ`00
0000m4LN0000003dAah000000P1>M>401`000000e3dI0000001>M>400000051fh`0000000P1@M^<0
10000000D7KS051fh`000004051fh`8000000`1@M^<010000000DGOS055gh`1AMn<30=@m6@030000
001AMn<0DGOS00<0DGOS00<00000055gh`1AMn<00P1AMn<010000000DGKR000000000008055fhP05
0000003D?AT0DGKR055fhP0000000`1AMMh30=@m6@H0DGGN0P0000000`1AMMh00000051cf@04051c
f@030=@m6@000000e3dI00D0e3dI103om^h203eIZ`030?ofkP3D?AT0e3dI00@0e3dI0`3om^h0100m
FJ/0ooK^0?ofkP0mFJ/50?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP0mFJ/0<`3om^h0
0`000000ooK^0?ofkP0H0?ofkP030000003om^h0ooK^02P0ooK^0@3oool001T0ooK^00<000000?of
kP3om^h0>P3om^h00`3D?AT0ooK^0?ofkP020?ofkP<0e3dI2`3om^h00`3D?AT0ooK^0?ofkP0@0?of
kP030=@m6@3om^h0ooK^00`0ooK^0P3D?AT50?ofkP030=@m6@3om^h0ooK^0140ooK^1@3D?AT;0?of
kP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0000000000000P3D?AT3000000H0hD4L10000000100m
FJ/0jT@M0000000000050>Y47@800000103ZA1d00`000000?EV[0>Y47@030>Y47@050000003ZA1d0
jT@M0>Y47@0000000`3ZA1d00`000000jT@M0>Y47@040000000603eIZ`000000m4LN0?A77P000000
m4LN0P0mFJ/20?A77P070000003dAah000000?A77P000000CWCQ0000000204idh@040=@m6@1>M>40
CWCQ00000080D7KS00@00000051fh`1@M^<00000101@M^<00`000000D7KS051fh`02051fh`030000
001@M^<0e3dI0080e3dI00<0DGOS0000003D?AT0101AMn<2000000H0DGOS00<00000055fhP1AM^80
1P1AM^8200000080DGKR00<0e3dI055fhP1AM^800`3D?AT8055egP030000001AMMh0DGGN0080DGGN
00@00000051cf@1@LmT0D7?I1P3D?AT30?ofkP<0e3dI00<0ooK^0=@m6@3D?AT0103D?AT60?ofkP05
03eIZ`3om^h0ooK^0?ofkP0mFJ/0103om^h00`0mFJ/0ooK^0?ofkP030?ofkP80?EV[<`3om^h00`00
0000ooK^0?ofkP0H0?ofkP030000003om^h0ooK^02P0ooK^0@3oool001X0ooK^0P00000j0?ofkP03
0=@m6@3om^h0e3dI0080e3dI3P3om^h00`3D?AT0ooK^0?ofkP0A0?ofkP030=@m6@3om^h0ooK^00P0
ooK^0`3D?AT70?ofkP030=@m6@3om^h0ooK^0140ooK^0P3D?AT>0?ofkP030=@m6@3om^h0ooK^00<0
ooK^0`3D?AT20000000302]5T@0000000000008000000P3Q@A`2000000<0jT@M0P0000000`0mFJ/0
jT@M0>Y47@02000000D0jT@M00<000000>Y47@3ZA1d00`3ZA1d203eIZ`<0jT@M00D000000>Y47@3Z
A1d0jT@M000000020>Y47@<000000P3dAah01P000000m4LN0?A77P0mFJ/000000?A77P80?EV[00@0
m4LN0000003dAah0m4LN0P0000020?A77P090000001>M>40000004idh@000000CWCQ0=@m6@000000
CWCQ008000000P1@M^<00`000000D7KS051fh`02051fh`040000001@M^<0D7KS051fh`@0e3dI00@0
D7KS0000001AMn<000000P1AMn<0103D?AT0DGOS000000000006055gh`80000000<0DGOS0000001A
M^80101AM^82000000@0DGKR0`3D?AT00`1AM^800000055egP06055egP8000001P1AMMh00`000000
e3dI0=@m6@030=@m6@H0ooK^1P3D?AT00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^0080
ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`050?ofkP80?EV[=03om^h00`000000ooK^0?ofkP0G0?of
kP030000003om^h0ooK^02P0ooK^0@3oool001`0ooK^00<000000?ofkP3om^h0=`3om^h20=@m6A40
ooK^00<0e3dI0?ofkP3om^h04@3om^h00`3D?AT0ooK^0?ofkP050?ofkP<0e3dI2`3om^h00`3D?AT0
ooK^0?ofkP0@0?ofkP030=@m6@3om^h0e3dI00d0ooK^00<0e3dI0?ofkP3om^h00`3D?AT20?ofkP03
0=@m6@0mFJ/000000080000000<0:dFA0000000000000P0000070>Y47@030000000mFJ/0?EV[0080
jT@M0P0000040>Y47@800000103ZA1d00`000000?EV[0>Y47@020>Y47@030000003ZA1d0jT@M00<0
00000P3dAah010000000m4LN0?A77P0000030?A77P80?EV[00`000000?A77P3dAah000000?A77P00
0000m4LN0000003dAah0000004idh@00000204idh@050000001>M>4000000=@m6@1>M>400P000000
0`1@M^<00000051fh`03051fh`030000001@M^<0e3dI0080e3dI1P1@M^<00`000000DGOS055gh`02
055gh`030=@m6@1AMn<0DGOS00D0DGOS00D00000055gh`1AMn<0DGOS00000004055fhP030000001A
M^80DGKR00@0e3dI0P1AM^820=@m6@03055fhP000000DGGN00@0DGGN00<00000055egP1AMMh01P1A
MMh30=@m6@H0ooK^1P3D?AT01@3om^h0?EV[0?ofkP3om^h0?EV[00P0ooK^00<0?EV[0?ofkP3om^h0
0`3om^h0100mFJ/0ooK^0?ofkP0mFJ/60?ofkP80?EV[=03om^h00`000000ooK^0?ofkP0G0?ofkP03
0000003om^h0ooK^02L0ooK^0@3oool001d0ooK^0P00000g0?ofkP030=@m6@3om^h0ooK^0140ooK^
00<0e3dI0?ofkP3om^h0403om^h00`3D?AT0ooK^0?ofkP030?ofkP80e3dI3P3om^h00`3D?AT0ooK^
0?ofkP0@0?ofkP030=@m6@3om^h0e3dI00d0ooK^0`3D?AT50?ofkP030=@m6@000000?EV[00@00000
00<0:dFA0000000000000`0000060>Y47@030000000mFJ/0jT@M0080jT@M0P0000040>Y47@800000
0`3ZA1d010000000?EV[0>Y47@3ZA1d300000080m4LN00D000000?A77P3dAah0m4LN000000020?A7
7P<0?EV[00<000000?A77P0mFJ/00P3dAah040000000m4LN0000003dAah000000?A77P000000CWCQ
0000001>M>40000004idh@000000CWCQ0=@m6@00000204idh@050000001@M^<0D7KS051fh`000000
0`3D?AT00`1@M^<00000051fh`04051fh`80000000<0D7KS0000001AMn<00P0000000`3D?AT0DGOS
055gh`03055gh`8000001@1AMn<010000000DGKR0000000000030=@m6@@0DGKR0P000002055fhP05
0=@m6@1AM^8000000000001AMMh00P000003055egP030=@m6@1AMMh0DGGN00<0e3dI00<000000?of
kP3D?AT00`3om^h50=@m6@D0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`060?ofkP0303eIZ`3om^h0
ooK^00D0ooK^00<0?EV[0?ofkP0mFJ/01`3om^h00`0mFJ/0ooK^0?ofkP0b0?ofkP030000003om^h0
ooK^01L0ooK^00<000000?ofkP3om^h09`3om^h10?ooo`007`3om^h00`000000ooK^0?ofkP0e0?of
kP030=@m6@3om^h0ooK^0100ooK^00<0e3dI0?ofkP3om^h04@3om^h00`3D?AT0ooK^0=@m6@020=@m
6A40ooK^00<0e3dI0?ofkP3om^h03`3om^h0103D?AT0ooK^0?ofkP3D?AT80?ofkPD0e3dI203om^h0
103D?AT0000003eIZ`0mFJ/40000000302]5T@000000000000@000001@3ZA1d00`0mFJ/000000>Y4
7@020>Y47@800000103ZA1d200000080jT@M00<0000003eIZ`0000000P3dAah01@000000m4LN0?A7
7P3dAah000000080m4LN0`0mFJ/03P000000m4LN0?A77P000000m4LN03eIZ`000000m4LN0000003d
Aah000000?A77P000000m4LN0P000000101>M>40000004idh@00000204idh@050000003D?AT0CWCQ
0000001>M>40103D?AT3051fh`030000001@M^<0D7KS0080D7KS0P000004051fh`050000001AMn<0
DGOS055gh`3D?AT00P1AMn<2000000L0DGOS103D?AT5055fhP8000001@1AM^820=@m6@03055fhP00
0000DGGN00@0DGGN0`3D?AT200000080ooK^1`3D?AT70?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0
?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0?EV[00L0ooK^00<0
?EV[0?ofkP3om^h0<`3om^h00`000000ooK^0?ofkP0F0?ofkP030000003om^h0ooK^02L0ooK^0@3o
ool00200ooK^00<000000?ofkP3om^h0=03om^h00`3D?AT0ooK^0?ofkP0A0?ofkP030=@m6@3om^h0
ooK^00l0ooK^0`3D?ATD0?ofkP030=@m6@3om^h0ooK^0100ooK^00<0e3dI0?ofkP3D?AT01@3om^h3
0=@m6@@0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT00000020cL@060000000502]5T@000000
00000000000hF;<00P0000040>Y47@0303eIZ`000000000000<0jT@M0P0000030>Y47@<000000P3d
Aah01@0mFJ/000000?A77P3dAah000000080m4LN0`0mFJ/01@3dAah000000?A77P3dAah000000080
m4LN00H000000?A77P0mFJ/0m4LN0000003dAah20000000;0?A77P000000CWCQ0000001>M>400000
04idh@000000CWCQ0000001>M>40103D?AT00`1>M>400000051fh`02051fh`8000000`1@M^<20000
00@0D7KS0P0000000`1@M^<00000055gh`02055gh`030=@m6@000000DGOS00D0DGOS0`3D?AT2055g
h`030000001AM^80DGKR0080DGKR0P000008055fhP050000003D?AT0e3dI0000001AMMh00`3D?AT2
055egP030000003om^h0ooK^00D0e3dI00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP03
0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h01P3om^h203eIZ`L0ooK^00<0?EV[
0?ofkP3om^h0=03om^h00`000000ooK^0?ofkP0E0?ofkP030000003om^h0ooK^02L0ooK^0@3oool0
0240ooK^0P00000d0?ofkP030=@m6@3om^h0ooK^0140ooK^00<0e3dI0?ofkP3om^h0303om^h30=@m
6@80ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP050=@m6@3om^h0ooK^
0=@m6@3om^h00`3D?AT80?ofkP030=@m6@3om^h0ooK^00@0ooK^0`3D?AT0103om^h000000000000P
<g470000000303QH/`000000000000@000000P3ZA1d0100mFJ/0jT@M0000000000030>Y47@<00000
0P3dAah200000080m4LN00<0?EV[0000003dAah00`0mFJ/20?A77P060000003dAah0m4LN0000003d
Aah000000P3dAah01P000000m4LN0000000mFJ/000000?A77P80000000P0m4LN0000001>M>40CWCQ
0000001>M>40000004idh@<0e3dI00<0000004idh@3D?AT00P000000101>M>400000051fh`000003
051fh`800000101@M^<2000000@0D7KS00D00000055gh`00000000000=@m6@02055gh`@0e3dI00<0
0000055gh`1AMn<00`1AMn<010000000DGKR000000000008055fhP8000000P1AM^840=@m6@80DGGN
0P0000050=@m6@@0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eI
Z`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eI
Z`3om^h0ooK^03D0ooK^00<000000?ofkP3om^h0503om^h00`000000ooK^0?ofkP0W0?ofkP40oooo
000S0?ofkP030000003om^h0ooK^0380ooK^00<0e3dI0?ofkP3om^h0403om^h00`3D?AT0ooK^0?of
kP090?ofkP<0e3dI1@3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0
e3dI0?ofkP3D?AT00P3D?AT;0?ofkP030=@m6@3om^h0ooK^0080ooK^0P3D?AT30?ofkP030=@m6@3o
m^h000000080000000<083=a0000000000001@00000203QH/`80000000D0>5Rc0000000000000000
03eIZ`020>Y47@<000000`3dAah2000000030?A77P0mFJ/0?EV[00@0?EV[00@000000?A77P000000
00000P3dAah03@000000m4LN0?A77P000000m4LN0000003dAah000000?A77P000000m4LN03eIZ`3d
Aah01@0000000`1>M>400000000000020=@m6@0304idh@00000000000080CWCQ00@000000=@m6@1>
M>40CWCQ0P000002051fh`800000101@M^<2000000H0D7KS0P000002055gh`<0e3dI0`000007055g
h`800000201AM^82000000@0e3dI0P1AM^800`000000DGGN0=@m6@040=@m6@80ooK^00<0?EV[0?of
kP3om^h0103om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00H0ooK^00D0?EV[0?of
kP3om^h0ooK^03eIZ`090?ofkP80?EV[1P3om^h00`0mFJ/0ooK^0?ofkP0e0?ofkP030000003om^h0
ooK^01D0ooK^00<000000?ofkP3om^h09P3om^h10?ooo`00903om^h200000380ooK^00<0e3dI0?of
kP3om^h04@3om^h00`3D?AT0ooK^0?ofkP060?ofkP80e3dI2@3om^h00`3D?AT0ooK^0?ofkP0C0?of
kP030=@m6@3om^h0ooK^00d0ooK^0`3D?AT20?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?of
kP3D?AT00P3D?AT60?ofkP030=@m6@3om^h0ooK^00H0000000<0:dFA03eIZ`0000000`00000203QH
/`030000003D?AT0e3dI00<000000`3dAah00`000000?EV[03eIZ`0303eIZ`070000003dAah0m4LN
0000003dAah0?EV[0?A77P02000000090?A77P000000m4LN0?A77P000000m4LN0000003D?AT00000
00<0m4LN200000001`1;LMd000000=@m6@3D?AT0000004idh@0000000`1>M>401@000000CWCQ04id
h@3D?AT000000080CWCQ0P000004051fh`8000001P1@M^<200000006051fh`3D?AT0e3dI0=@m6@1A
Mn<000000P3D?AT7055gh`8000000P1AMn<00`000000DGKR055fhP03055fhP040000003D?AT0e3dI
0=@m6@H0DGKR103D?AT50?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h0103om^h0
0`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0?EV[00X0ooK^00<0?EV[0?ofkP0mFJ/01@3om^h0
0`0mFJ/0ooK^0?ofkP0f0?ofkP030000003om^h0ooK^01@0ooK^00<000000?ofkP3om^h09P3om^h1
0?ooo`009P3om^h00`000000ooK^0?ofkP0_0?ofkP030=@m6@3om^h0ooK^0140ooK^00<0e3dI0?of
kP3om^h00`3om^h30=@m6@/0ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP0:0?of
kP<0e3dI00<0ooK^0=@m6@3om^h00P3om^h00`3D?AT0ooK^0?ofkP080?ofkP<0e3dI2@3om^h0103D
?AT0ooK^0?ofkP3om^h40000000402]5T@000000000002]5T@<000000`3D?AT0100hF;<0000003eI
Z`0hF;<5000000040?A77P000000000000000080m4LN1@0000001P0mFJ/0m4LN0?A77P000000m4LN
00000080m4LN00@000000?A77P3D?AT0m4LN100000001@3lBQl000000?a:7`000000o4XO00@00000
00@0CWCQ0000001>M>4000000P1>M>420000000504idh@000000000004idh@3D?AT00P000000101>
M>400000051fh`1@M^<2000000D0D7KS0P0000040=@m6@04051fh`0000000000000000<0DGOS00@0
e3dI055gh`1AMn<0DGOS0`000005055gh`030000001AM^80e3dI00<0e3dI1P1AM^830=@m6@P0ooK^
00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00T0ooK^
0P0mFJ/90?ofkP0403eIZ`3om^h0ooK^03eIZ`D0ooK^00<0?EV[0?ofkP3om^h0=`3om^h00`000000
ooK^0?ofkP0C0?ofkP030000003om^h0ooK^02H0ooK^0@3oool002L0ooK^0P00000`0?ofkP030=@m
6@3om^h0ooK^0140ooK^00<0e3dI0?ofkP3D?AT00P3D?AT?0?ofkP030=@m6@3om^h0ooK^01<0ooK^
00<0e3dI0?ofkP3om^h01P3om^h30=@m6@@0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^
0?ofkP040?ofkP<0e3dI00<0ooK^0=@m6@3om^h02P3om^h0103D?AT0ooK^0?ofkP3om^h500000003
02]5T@000000e3dI0080e3dI1@00000203QH/`<000000P11I<P3000000030?A77P000000000000<0
m4LN0`0000001P0mFJ/0m4LN0?A77P000000m4LN00000080m4LN0`0000001@3lBQl0000000000000
0000o4XO00L0000000@0Bg7M0000001>M>4000000P1>M>4010000000CWCQ00000000000204idh@80
000000<0e3dI04idh@1>M>400`000004051fh`8000000`3D?AT2051fh`<000000P1@M^<00`000000
DGOS055gh`02055gh`80e3dI00<00000055gh`1AMn<01@1AMn<30=@m6@030000001AM^80DGKR00<0
DGKR103D?AT00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00P0ooK^00D0?EV[0?ofkP3o
m^h0ooK^03eIZ`0=0?ofkP0303eIZ`3om^h0ooK^00L0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`04
0?ofkP0303eIZ`3om^h0ooK^03L0ooK^00<000000?ofkP3om^h04`3om^h00`000000ooK^0?ofkP0V
0?ofkP40oooo000Y0?ofkP030000003om^h0ooK^02d0ooK^00<0e3dI0?ofkP3om^h0403om^h30=@m
6A80ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP030?ofkP<0e3dI203om^h01@3D
?AT0ooK^0?ofkP3om^h0e3dI00<0ooK^0`3D?AT40?ofkP030=@m6@3om^h0ooK^00X0ooK^00@0e3dI
0?ofkP3om^h0e3dI0P0000040=@m6@@000000P0hF;<40000000303QH/`000000@FC800@0000000<0
@FC8000000000000100000020?A77P80000000@0?EV[0?A77P3dAah0m4LN0`0000000`3lBQl00000
0?a:7`02000000030?a:7`000000000000H0000000D0Bg7M0000001;LMd0000004idh@0400000004
04idh@000000000000000080CWCQ00<000000=@m6@0000000P1>M>4010000000D7KS051fh`000003
0=@m6@03051fh`0000000000008000001@1@M^<00`000000DGOS055gh`0200000080DGOS0P3D?AT2
055gh`@0e3dI00@00000055gh`1AMn<000000P1AM^830=@m6@<000000P3om^h00`0mFJ/0ooK^0?of
kP050?ofkP0303eIZ`3om^h0ooK^00X0ooK^00@0?EV[0?ofkP3om^h0?EV[3@3om^h203eIZ`P0ooK^
00<0?EV[0?ofkP3om^h00P3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[03X0ooK^00<000000?ofkP3o
m^h04P3om^h00`000000ooK^0?ofkP0V0?ofkP40oooo000Z0?ofkP800000;@3om^h00`3D?AT0ooK^
0?ofkP0=0?ofkP<0e3dI00<0ooK^0=@m6@3om^h04`3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m
6@3om^h0e3dI0080e3dI2`3om^h00`3D?AT0ooK^0?ofkP020?ofkP<0e3dI1`3om^h00`3D?AT0ooK^
0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00<0e3dI00D00000020cL@000000000002]5T@05000000@0
>5Rc1@0000000`3D?AT0@FC80000000800000080m4LN00D0000003eIZ`00000000000?a:7`030000
00030?a:7`000000o4XO00T0000000D0Bg7M000000000000000004]ag@030000000304idh@000000
00000080CWCQ0`00000204idh@030=@m6@1>M>40000000@0e3dI00@0D7KS0000000000000000201@
M^<4000000D0DGOS103D?AT00`000000DGOS055gh`02055gh`@0e3dI00<0DGKR0000000000001P3o
m^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00/0ooK^0P0mFJ/=0?ofkP0403eIZ`3o
m^h0ooK^03eIZ`L0ooK^00<0?EV[0?ofkP3om^h00`3om^h0100mFJ/0ooK^0?ofkP0mFJ/k0?ofkP03
0000003om^h0ooK^0180ooK^00<000000?ofkP3om^h09@3om^h10?ooo`00;03om^h00`000000ooK^
0?ofkP0[0?ofkP030=@m6@3om^h0ooK^00T0ooK^0`3D?AT50?ofkP030=@m6@3om^h0ooK^0180ooK^
00<0e3dI0?ofkP3om^h04@3om^h30=@m6@h0ooK^00<0e3dI0?ofkP3D?AT00P3D?AT00`3om^h0e3dI
0?ofkP070?ofkP030=@m6@3om^h0ooK^00X0ooK^103D?AT20?ofkP<0000000@083=a000000000000
:dFA1`00000303QH/`<0000000D0e3dI0000000000000000045Tb00800000080o4XO0`0000000`3l
BQl0000000000002000000030?a:7`000000000000D0000000@0Bg7M000000000000Bg7M0P000000
1@1;LMd00000000000000000CWCQ00<000000`1>M>42000000<0e3dI00<0CWCQ0000000000000P00
0007051fh`@000000`1@M^<2000000@0e3dI00@00000055gh`1AMn<0DGOS1P3D?AT4000000T0ooK^
00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00/0ooK^
00D0?EV[0?ofkP3om^h0ooK^03eIZ`050?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP0m
FJ/0?03om^h00`000000ooK^0?ofkP0A0?ofkP030000003om^h0ooK^02D0ooK^0@3oool002d0ooK^
0P00000[0?ofkP030=@m6@3om^h0ooK^00H0ooK^0`3D?AT80?ofkP030=@m6@3om^h0ooK^0180ooK^
00<0e3dI0?ofkP3om^h03P3om^h30=@m6@80ooK^00<0e3dI0?ofkP3om^h0303om^h20=@m6@@0ooK^
00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP070?ofkP<0e3dI0P3om^h20=@m6@<0ooK^
0P0000000`0mFJ/083=a0000000200000080:dFA0`0000000`0hF;<00000000000020000000303QH
/`000000e3dI0100000000<0o4XO0000000000005P00000204idh@@000000P3D?AT2000000050=@m
6@000000CWCQ04idh@0000000`1@M^<5000000H0D7KS0`3D?AT2000000L0DGOS0P3D?AT010000000
?EV[00000000000=0?ofkP0403eIZ`3om^h0ooK^03eIZ`l0ooK^00<0?EV[0?ofkP0mFJ/02`3om^h0
0`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h01@3om^h0
0`0mFJ/0ooK^03eIZ`0l0?ofkP030000003om^h0ooK^0140ooK^00<000000?ofkP3om^h09@3om^h1
0?ooo`00;`3om^h00`000000ooK^0?ofkP0X0?ofkP030=@m6@3om^h0ooK^00<0ooK^0`3D?AT<0?of
kP030=@m6@3om^h0ooK^0180ooK^00<0e3dI0?ofkP3om^h02P3om^h30=@m6@D0ooK^00<0e3dI0?of
kP3om^h0303om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?of
kP3om^h01@3om^h20=@m6@H0ooK^00<0e3dI0?ofkP3D?AT00`3D?AT01@00000083=a000000000000
:dFA008000000P0[AI450000000503QH/`00000000000000003D?AT00P0000001011I<P000000000
00000002045Tb280000000@0CWCQ0=@m6@3D?AT0e3dI0P00000304idh@80e3dI1@000007051fh`@0
e3dI00D00000051fh`1@M^<0D7KS00000003055gh`8000000P3D?AT20000000303eIZ`3om^h0ooK^
00l0ooK^00<0?EV[0?ofkP0mFJ/03`3om^h0100mFJ/0ooK^0?ofkP0mFJ/:0?ofkP0303eIZ`3om^h0
ooK^00<0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP060?ofkP80?EV[?@3om^h0
0`000000ooK^0?ofkP0@0?ofkP030000003om^h0ooK^02D0ooK^0@3oool00300ooK^0P00000Y0?of
kP030=@m6@3om^h0e3dI0080e3dI3`3om^h00`3D?AT0ooK^0?ofkP0B0?ofkP030=@m6@3om^h0ooK^
00L0ooK^0`3D?AT90?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D
?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^0080ooK^0`3D?AT70?ofkP<0e3dI0P3om^h00`00
0000ooK^0?ofkP0200000004020cL@000000000002]5T@<00000100hF;<30000000403QH/`000000
e3dI045Tb0@000000`3D?ATP00000080e3dI00<0CWCQ0000000000001P0000001@1>M>40e3dI0=@m
6@1>M>40000000<0D7KS0P0000030=@m6@H0D7KS100000000`3D?AT000000<<m6@020000000303eI
Z`3om^h0?EV[01<0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eI
Z`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h01@3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00T0
ooK^00<0?EV[0?ofkP3om^h0?03om^h00`000000ooK^0?ofkP0?0?ofkP030000003om^h0ooK^02D0
ooK^0@3oool00380ooK^00<000000?ofkP3om^h09P3om^h20=@m6A<0ooK^00<0e3dI0?ofkP3om^h0
4P3om^h00`3D?AT0ooK^0?ofkP030?ofkP<0e3dI3@3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m
6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0=@m6@020=@m6@L0ooK^
0`3D?AT00`3om^h0e3dI0=@m6@020?ofkP040000003om^h0ooK^0?ofkPh000000P0hF;<010000000
e3dI0000000000030=@m6@80@FC89000000604idh@X000000P3D?AT00`1@M^<00000000000060000
00030>m97P000000000000@000000`3om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP0303eIZ`3om^h0?EV[
00d0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^
00H0ooK^00<0?EV[0?ofkP0mFJ/02P3om^h00`0mFJ/0ooK^0?ofkP0l0?ofkP030000003om^h0ooK^
00l0ooK^00<000000?ofkP3om^h09@3om^h10?ooo`00<`3om^h00`000000ooK^0?ofkP0V0?ofkP03
0=@m6@3om^h0ooK^0140ooK^00<0e3dI0?ofkP3om^h04P3om^h00`3D?AT0ooK^0?ofkP030=@m6A00
ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00<0
ooK^0P3D?AT70?ofkP<0e3dI103om^h01@3D?AT0ooK^0=@m6@3om^h0000000@0ooK^1@0000000`0[
AI40000000000002000000<0>5Rc0`0000030=@m6C`0000000<0kdTN000000000000200000060?of
kP0303eIZ`3om^h0?EV[0140ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0<0?ofkP0303eIZ`3om^h0
ooK^00@0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP080?ofkP80?EV[2P3om^h0
0`0mFJ/0ooK^0?ofkP0m0?ofkP030000003om^h0ooK^00l0ooK^00<000000?ofkP3om^h0903om^h1
0?ooo`00=03om^h2000002H0ooK^00<0e3dI0?ofkP3om^h04P3om^h00`3D?AT0ooK^0?ofkP0A0?of
kP<0e3dI503om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?of
kP3om^h0103D?AT40?ofkP@0e3dI1`3om^h01@3D?AT0ooK^0?ofkP3D?AT0000000H0ooK^00<00000
020cL@0000000P00000202]5T@@000000`3D?AT203QH/`030=@m6@000000@FC800D0@FC86@000000
0`3oCB4000000000000F0000000303eIZ`000000000000D0000000<0`cdI0000003om^h01`3om^h2
03eIZ`<0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0
ooK^00P0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0
ooK^00T0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP0o0?ofkP030000003om^h0
ooK^00h0ooK^00<000000?ofkP3om^h0903om^h10?ooo`00=P3om^h00`000000ooK^0?ofkP0T0?of
kP030=@m6@3om^h0ooK^0140ooK^00<0e3dI0?ofkP3om^h03P3om^h30=@m6@80ooK^00<0e3dI0?of
kP3om^h04`3om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00H0ooK^0`3D?AT30?of
kP030=@m6@3om^h0e3dI0080e3dI2`3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00L0ooK^0P000000
0`0P<g40000000000002000000<0e3dI0P0hF;<400000080e3dI1@000005045Tb080000000<0AfcE
0000000000001`0000000`3oCB4000000000000300000080oddQ100000000`0mFJ/0oddQ0?m=8@04
0?m=8@D0000000<0?EV[0000000000001P0000000`3_BAh0?EV[0>m97P04000000X0ooK^00<0?EV[
0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[
0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/0303o
m^h203eIZ`P0ooK^00<0?EV[0?ofkP3om^h0@03om^h00`000000ooK^0?ofkP0=0?ofkP030000003o
m^h0ooK^02@0ooK^0@3oool003L0ooK^0P00000T0?ofkP030=@m6@3om^h0ooK^0180ooK^00<0e3dI
0?ofkP3om^h02P3om^h30=@m6@D0ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP08
0?ofkP030=@m6@3om^h0ooK^0080ooK^103D?AT20?ofkP030=@m6@3om^h0ooK^00<0e3dI3P3om^h0
1P3D?AT0ooK^0?ofkP3om^h000000=@m6@L0ooK^0P0000040=@m6@0302]5T@000000000000D00000
0`0hF;<0103D?AT0@FC8045Tb011I<P4000000<0@FC830000000103oCB4000000000003oCB440000
00<0oddQ00<0000003eIZ`0000001`00000203eIZ`/0000000<0?EV[0000003om^h02`3om^h00`0m
FJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0m
FJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00X0ooK^00@0?EV[0?ofkP3om^h0?EV[2`3om^h0
100mFJ/0ooK^0?ofkP0mFJ/70?ofkP0303eIZ`3om^h0ooK^0400ooK^00<000000?ofkP3om^h03@3o
m^h00`000000ooK^0?ofkP0T0?ofkP40oooo000i0?ofkP030000003om^h0ooK^0280ooK^00<0e3dI
0?ofkP3om^h04@3om^h00`3D?AT0ooK^0?ofkP070?ofkP<0e3dI2@3om^h00`3D?AT0ooK^0?ofkP0C
0?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3D?AT00P3D?AT60?ofkP<0e3dI00<0ooK^
0=@m6@3om^h03@3om^h00`3D?AT0ooK^0?ofkP020?ofkP030000003D?AT0ooK^00D0ooK^0`3D?AT0
100P<g40000000000000000402]5T@040000000hF;<0>5Rc03QH/`@0000000@0e3dI000000000000
@FC810000003045Tb00300000017K=D0000000H0000000@0oddQ0000003oCB40oddQ0`0000020?m=
8@H0000000<0?EV[0?m=8@3oCB400`00000203eIZ``000000P3om^h00`0mFJ/0ooK^0?ofkP080?of
kP80?EV[2P3om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?of
kP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP80?EV[303om^h0100mFJ/0ooK^0?ofkP0mFJ/7
0?ofkP0303eIZ`3om^h0ooK^0440ooK^00<000000?ofkP3om^h0303om^h00`000000ooK^0?ofkP0T
0?ofkP40oooo000j0?ofkP8000008P3om^h00`3D?AT0ooK^0?ofkP0B0?ofkP030=@m6@3om^h0ooK^
00<0ooK^0`3D?AT=0?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h0103om^h40=@m
6@H0ooK^0`3D?AT20?ofkP030=@m6@3om^h0e3dI00h0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`00
0000ooK^0=@m6@020?ofkPH0e3dI0P0000000`0mFJ/00000000000020000000302]5T@000000>5Rc
00@0>5Rc0`0000020=@m6@0300000011I<P0@FC80080@FC80P0000020=@m6@80000000@0AfcE0000
00000000oddQ0P0000001@3oCB400000000000000000oddQ00<000000`3oCB4200000080oddQ00@0
000003eIZ`00000000000P0mFJ/:000000L0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^
0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^
0?ofkP020?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^
0?ofkP020?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h0@`3om^h00`000000ooK^
0?ofkP0<0?ofkP030000003om^h0ooK^02<0ooK^0@3oool003`0ooK^00<000000?ofkP3om^h0803o
m^h00`3D?AT0ooK^0?ofkP0A0?ofkP030=@m6@3om^h0ooK^00<0e3dI403om^h00`3D?AT0ooK^0?of
kP0C0?ofkP030=@m6@3om^h0ooK^00@0e3dI0P3om^h00`3D?AT0ooK^0?ofkP020?ofkP<0e3dI1P3o
m^h20=@m6@h0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`000000ooK^0=@m6@040=@m6@@0ooK^00<0
e3dI0000000000000`00000202]5T@H00000100hF;<010000000e3dI045Tb00000040=@m6@040000
0011I<P00000045Tb0P0000000H0oddQ0000003oCB40oddQ0000003oCB42000000<0oddQ0`000003
03eIZ`@0kdTN0`00000=0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h03@3om^h0
0`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00`0ooK^00@0?EV[0?ofkP3om^h0?EV[3`3o
m^h00`0mFJ/0ooK^03eIZ`0:0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h00P3o
m^h00`0mFJ/0ooK^0?ofkP140?ofkP030000003om^h0ooK^00/0ooK^00<000000?ofkP3om^h08`3o
m^h10?ooo`00?@3om^h200000200ooK^00<0e3dI0?ofkP3om^h04@3om^h30=@m6A@0ooK^00<0e3dI
0?ofkP3om^h04P3om^h30=@m6@H0ooK^00<0e3dI0?ofkP3D?AT00P3D?AT90?ofkP80e3dI3P3om^h0
103D?AT0ooK^0?ofkP3om^h60=@m6@H0ooK^00H0e3dI0?ofkP0000000000020cL@0mFJ/300000003
02]5T@000000000000@0>5Rc100000020=@m6@03045Tb000000000000080@FC800<00000045Tb000
00000P0000020?m=8@80000000@0?EV[0000003oCB4000000`3oCB400`000000oddQ0?m=8@020000
00@0?EV[0P3_BAh00`0mFJ/000000000000300000100ooK^00@0?EV[0?ofkP3om^h0ooK^0P0mFJ/A
0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/0403om^h00`0mFJ/0ooK^03eIZ`0?0?ofkP0403eIZ`3o
m^h0ooK^03eIZ`P0ooK^00<0?EV[0?ofkP3om^h01@3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[04H0
ooK^00<000000?ofkP3om^h02`3om^h00`000000ooK^0?ofkP0S0?ofkP40oooo000o0?ofkP030000
003om^h0ooK^01h0ooK^00<0e3dI0?ofkP3om^h0303om^h40=@m6@80ooK^00<0e3dI0?ofkP3om^h0
4`3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP<0e3dI0P3om^h00`3D?AT0ooK^0?ofkP040?ofkP80e3dI
3@3om^h00`3D?AT0ooK^0?ofkP0<0?ofkPH0e3dI103om^h20=@m6@@0ooK^00@0e3dI0?ofkP3om^h0
ooK^0P0000000`0P<g40?EV[03eIZ`07000000<0e3dI00@0>5Rc0000003D?AT000000P11I<P20000
000>045Tb000000000000?m=8@000000oddQ0000003oCB4000000?m=8@0mFJ/000000?m=8@000002
0?m=8@8000000`0mFJ/20>m97PD0000000<0?EV[0000003om^h04`3om^h00`0mFJ/0ooK^03eIZ`0D
0?ofkP0303eIZ`3om^h0?EV[0180ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP02
0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h01P3om^h0100mFJ/0ooK^0?ofkP0m
FJ]70?ofkP030000003om^h0ooK^00X0ooK^00<000000?ofkP3om^h08`3om^h10?ooo`00@03om^h2
000001h0ooK^00<0e3dI0?ofkP3om^h02@3om^h30=@m6@H0ooK^00<0e3dI0?ofkP3om^h04`3om^h0
0`3D?AT0ooK^0?ofkP0;0?ofkP<0e3dI1P3om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0
ooK^00/0ooK^00<0e3dI0?ofkP3D?AT02P3om^h50=@m6@<0ooK^00<000000?ofkP3om^h0103om^h0
103D?AT0ooK^0?ofkP3D?AT50?ofkP@00000100[AI430=@m6@0403QH/`000000000000000080>5Rc
0P3D?AT01@000000@FC8045Tb0000000@FC8008000000P3oCB401P000000oddQ0000003oCB400000
03eIZ`800000100mFJ/00`3_BAh000000000000600000080ooK^00<0?EV[0?ofkP3om^h04`3om^h0
0`0mFJ/0ooK^0?ofkP0D0?ofkP0303eIZ`3om^h0ooK^0100ooK^00<0?EV[0?ofkP0mFJ/03@3om^h0
0`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h01`3om^h0
0`0mFJ/0ooK^03eIZ`190?ofkP030000003om^h0ooK^00T0ooK^00<000000?ofkP3om^h08`3om^h1
0?ooo`00@P3om^h00`000000ooK^0?ofkP0L0?ofkP030=@m6@3om^h0ooK^00@0ooK^103D?AT:0?of
kP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h01`3om^h30=@m6@X0ooK^00<0e3dI0?of
kP3om^h00P3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP040=@m6@3om^h0ooK^0=@m6@H0ooK^1@3D?AT0
0`3om^h0e3dI0?ofkP030?ofkP030000003om^h0ooK^00D0ooK^00<0e3dI0?ofkP3D?AT01P3om^h0
0`00000083=a000000040=@m6@040000000mFJ/00000000000H0>5Rc00/000000=@m6@3D?AT00000
045Tb0000000oddQ0000003oCB4000000?m=8@02000000D0?EV[00<0kdTN0000000000000P3_BAh5
000000H0ooK^00<0?EV[0?ofkP3om^h0403om^h203eIZ`030?ofkP0mFJ/0ooK^01<0ooK^00<0?EV[
0?ofkP0mFJ/0403om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00`0ooK^00<0?EV[0?ofkP3om^h0103o
m^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00P0ooK^0P0mFJ]90?ofkP030000003o
m^h0ooK^00X0ooK^00<000000?ofkP3om^h08P3om^h10?ooo`00@`3om^h2000001`0ooK^00<0e3dI
0?ofkP3om^h0103D?AT?0?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h00`3om^h3
0=@m6@h0ooK^00@0e3dI0?ofkP3om^h0e3dI3P3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI0080ooK^
1@3D?AT30?ofkP030=@m6@3om^h0ooK^00<0ooK^00<000000?ofkP3om^h01P3om^h20=@m6@H0ooK^
0`3D?AT00`0P<g40000002]5T@0402]5T@030000000hF;<0>5Rc0080>5Rc0`0000001P11I<P00000
045Tb0000000oddQ000000H0?EV[0`3_BAh010000000?EV[0>m97P3_BAh5000000X0ooK^00<0?EV[
0?ofkP3om^h03@3om^h203eIZ`@0ooK^00<0?EV[0?ofkP3om^h03`3om^h203eIZ`<0ooK^00<0?EV[
0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[
0?ofkP3om^h01P3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00`0ooK^00<0?EV[0?ofkP3om^h0B03o
m^h00`000000ooK^0?ofkP090?ofkP030000003om^h0ooK^0280ooK^0@3oool004D0ooK^00<00000
0?ofkP3om^h06P3om^h20=@m6A<0ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP03
0=@m6A40ooK^00@0e3dI0?ofkP3om^h0e3dI3P3om^h0103D?AT0ooK^0?ofkP3om^h50=@m6@H0ooK^
00<0e3dI0?ofkP3om^h00`3om^h00`000000ooK^0?ofkP070?ofkP80e3dI0P3om^h30=@m6@80ooK^
0P0000000`0P<g40000002]5T@0302]5T@030000000hF;<0>5Rc008000000`0hF;<00`000000@FC8
045Tb004000000050>m97P000000kdTN0>m97P0000000P3_BAh30000000503eIZ`00000000000?of
kP0mFJ/03@3om^h203eIZ`/0ooK^0P0mFJ/70?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?of
kP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?of
kP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0403eIZ`3om^h0ooK^03eIZ``0ooK^00<0?EV[
0?ofkP3om^h0B@3om^h00`000000ooK^0?ofkP080?ofkP030000003om^h0ooK^0280ooK^0@3oool0
04H0ooK^0P00000K0?ofkP030=@m6@3om^h0ooK^0180ooK^00<0e3dI0?ofkP3om^h04P3om^h30=@m
6AD0ooK^00<0e3dI0?ofkP3D?AT03P3om^h50=@m6@030?ofkP3D?AT0ooK^00L0ooK^00<0e3dI0?of
kP3om^h00`3om^h00`000000ooK^0?ofkP060?ofkP030=@m6@3om^h0e3dI0080e3dI1P3om^h:0000
00@0>5Rc00<000000=@m6@0000000`0000020>m97P040000003_BAh0kdTN0=@m6@D000000P3om^h0
100mFJ/0ooK^0?ofkP0mFJ/?0?ofkP0303eIZ`3om^h0ooK^00H0ooK^0P0mFJ/:0?ofkP0303eIZ`3o
m^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3o
m^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP80?EV[303o
m^h00`0mFJ/0ooK^0?ofkP1;0?ofkP030000003om^h0ooK^00L0ooK^00<000000?ofkP3om^h08P3o
m^h10?ooo`00B03om^h00`000000ooK^0?ofkP0H0?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI
0?ofkP3om^h03P3om^h30=@m6@80ooK^00<0e3dI0?ofkP3om^h0503om^h20=@m6@/0ooK^1@3D?AT5
0?ofkP80e3dI1@3om^h00`3D?AT0ooK^0?ofkP040?ofkP030000003om^h0ooK^00D0ooK^0`3D?AT2
0?ofkP80e3dI1P3om^h200000003020cL@000000:dFA00<0:dFA0P0000040=@m6@0503QH/`000000
kdTN0>m97P0mFJ/00P3_BAh3000000040<<m6@000000000003eIZ`D0ooK^00<0?EV[0?ofkP0mFJ/0
403om^h00`0mFJ/0ooK^0?ofkP030?ofkP80?EV[3@3om^h00`0mFJ/0ooK^0?ofkP080?ofkP80?EV[
2@3om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h0
103om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h0
B`3om^h00`000000ooK^0?ofkP070?ofkP030000003om^h0ooK^0280ooK^0@3oool004T0ooK^00<0
00000?ofkP3om^h0603om^h00`3D?AT0ooK^0?ofkP0B0?ofkP030=@m6@3om^h0ooK^00/0ooK^0`3D
?AT60?ofkP030=@m6@3om^h0ooK^01@0ooK^00<0e3dI0?ofkP3om^h01@3om^h60=@m6@030?ofkP3D
?AT0ooK^00L0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP040?ofkP040000003o
m^h0ooK^0?ofkPD0e3dI1P3om^h20=@m6@D0ooK^00<0e3dI0000000000000P0000040=@m6@050000
000hF;<0>5Rc03QH/`0000000P3_BAh01@000000kdTN03eIZ`000000`cdI0080000000D0?EV[0?of
kP3om^h0ooK^03eIZ`050?ofkP0303eIZ`3om^h0ooK^0100ooK^00<0?EV[0?ofkP3om^h00P0mFJ/@
0?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP05
0?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP0;
0?ofkP0303eIZ`3om^h0?EV[00X0ooK^00<0?EV[0?ofkP3om^h0C@3om^h00`000000ooK^0?ofkP07
0?ofkP030000003om^h0ooK^0240ooK^0@3oool004X0ooK^0P00000I0?ofkP030=@m6@3om^h0ooK^
0180ooK^00<0e3dI0?ofkP3om^h01`3om^h30=@m6@X0ooK^00<0e3dI0?ofkP3om^h04`3om^h20=@m
6@80ooK^1`3D?AT30?ofkP030=@m6@3om^h0ooK^00P0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@06
0?ofkP030000003D?AT0e3dI0080e3dI0`3om^h00`3D?AT0ooK^0?ofkP060?ofkP80e3dI0P3om^h6
0=@m6@<000000P0[AI4010000000>5Rc0000003_BAh4000000030<<m6@0mFJ/0000000<0ooK^00D0
?EV[0?ofkP3om^h0ooK^03eIZ`040?ofkP<0?EV[403om^h303eIZa<0ooK^00<0?EV[0?ofkP3om^h0
103om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h0
303om^h0100mFJ/0ooK^0?ofkP0mFJ/>0?ofkP0403eIZ`3om^h0ooK^03eIZ`T0ooK^00<0?EV[0?of
kP3om^h0CP3om^h00`000000ooK^0?ofkP060?ofkP030000003om^h0ooK^0240ooK^0@3oool004`0
ooK^00<000000?ofkP3om^h05`3om^h00`3D?AT0ooK^0?ofkP0B0?ofkP030=@m6@3om^h0ooK^00<0
ooK^0`3D?AT>0?ofkP030=@m6@3om^h0ooK^0140ooK^00<0e3dI0?ofkP3D?AT01P3D?AT60?ofkP03
0=@m6@3om^h0ooK^00T0ooK^0P3D?AT00`3om^h0e3dI0?ofkP030?ofkP<0e3dI1P3om^h00`3D?AT0
ooK^0?ofkP080?ofkPH0e3dI00H0ooK^00000000000083=a0000000[AI430=@m6@030000003D?AT0
000000<0000000@0?EV[0?ofkP3om^h0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0503eIZ`3o
m^h0ooK^0?ofkP0mFJ/00P3om^h00`0mFJ/0ooK^0?ofkP090?ofkP@0?EV[0P3om^h00`0mFJ/0ooK^
0?ofkP0B0?ofkP0403eIZ`3om^h0ooK^0?ofkP80?EV[403om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[
0100ooK^00<0?EV[0?ofkP0mFJ/03@3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00P0ooK^00<0?EV[
0?ofkP3om^h0C`3om^h00`000000ooK^0?ofkP060?ofkP030000003om^h0ooK^0240ooK^0@3oool0
04d0ooK^0P00000G0?ofkP030=@m6@3om^h0ooK^0180ooK^00<0e3dI0?ofkP3om^h00`3D?ATA0?of
kP030=@m6@3om^h0ooK^0100ooK^1P3D?AT:0?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?of
kP3D?AT00`3D?AT20?ofkP030000003om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h01P3om^h40=@m
6@030?ofkP3D?AT0ooK^0080ooK^1`3D?AT010000000?EV[03eIZ`0mFJ/30?ofkP0303eIZ`3om^h0
?EV[0080ooK^0P0mFJ/00`3om^h0?EV[0?ofkP040?ofkP80?EV[00<0ooK^03eIZ`3om^h00P3om^h0
0`0mFJ/0ooK^0?ofkP050?ofkP<0?EV[1`3om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP0303eIZ`3om^h0
?EV[01<0ooK^00<0?EV[0?ofkP0mFJ/04P3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0
ooK^0080ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP1@0?ofkP030000003om^h0
ooK^00D0ooK^00<000000?ofkP3om^h08@3om^h10?ooo`00C`3om^h00`000000ooK^0?ofkP0E0?of
kP030=@m6@3om^h0ooK^0140ooK^0`3D?ATE0?ofkP030=@m6@3om^h0ooK^00`0ooK^0`3D?AT00`3o
m^h0e3dI0=@m6@030?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h02`3om^h40=@m
6@D0ooK^00<000000?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP030?ofkP@0e3dI0`3om^h0103D
?AT0ooK^0?ofkP3om^h40=@m6@80ooK^00<0?EV[0000000000001`0mFJ/20?ofkP0403eIZ`3om^h0
ooK^0?ofkP80?EV[1`3om^h203eIZ`@0ooK^00<0?EV[0?ofkP3om^h0100mFJ/;0?ofkP0303eIZ`3o
m^h0ooK^0180ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0303eIZ`3o
m^h0?EV[00`0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3o
m^h0ooK^0580ooK^00<000000?ofkP3om^h0103om^h00`000000ooK^0?ofkP0Q0?ofkP40oooo001@
0?ofkP8000005P3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP@0e3dI0P3om^h00`3D?AT0ooK^0?ofkP0D
0?ofkP030=@m6@3om^h0ooK^00P0ooK^0`3D?AT40?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI
0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP080?ofkP@0e3dI0`3om^h20=@m6@80ooK^00<00000
0?ofkP3om^h00`3om^h0103D?AT0ooK^0?ofkP3om^h40=@m6@D0ooK^00<0e3dI0?ofkP3om^h00`3D
?AT60?ofkP0303eIZ`3om^h0ooK^0080?EV[00<0ooK^03eIZ`3om^h01P0mFJ/20?ofkP0303eIZ`3o
m^h0ooK^00H0ooK^200mFJ/@0?ofkP0303eIZ`3om^h0ooK^00l0ooK^0P0mFJ/00`3om^h0?EV[0?of
kP0B0?ofkP0303eIZ`3om^h0?EV[0100ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0:0?ofkP0303eI
Z`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP1C0?ofkP030000
003om^h0ooK^00@0ooK^00<000000?ofkP3om^h0803om^h10?ooo`00DP3om^h00`000000ooK^0?of
kP0D0?ofkP030=@m6@3om^h0ooK^00P0ooK^0`3D?AT70?ofkP030=@m6@3om^h0ooK^01@0ooK^00<0
e3dI0?ofkP3om^h0103om^h30=@m6@H0ooK^00<0e3dI0?ofkP3om^h01@3om^h20=@m6@D0ooK^00<0
e3dI0?ofkP3om^h01@3om^h40=@m6@80ooK^00<0e3dI0?ofkP3om^h00`3om^h20=@m6@030000003o
m^h0ooK^00<0ooK^1@3D?AT70?ofkP@0e3dI2P3om^h203eIZ`070?ofkP0mFJ/0?EV[0?ofkP0mFJ/0
ooK^03eIZ`040?ofkP`0?EV[1P3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00`0
ooK^0P0mFJ/40?ofkP0303eIZ`3om^h0ooK^00h0ooK^0P0mFJ/30?ofkP0303eIZ`3om^h0ooK^00`0
ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00L0
ooK^00@0?EV[0?ofkP3om^h0?EV[EP3om^h00`000000ooK^0?ofkP040?ofkP030000003om^h0ooK^
0200ooK^0@3oool005<0ooK^0P00000D0?ofkP030=@m6@3om^h0ooK^00D0ooK^0`3D?AT;0?ofkP03
0=@m6@3om^h0ooK^01@0ooK^00<0e3dI0?ofkP3om^h00`3D?AT90?ofkP030=@m6@3om^h0ooK^00L0
ooK^00<0e3dI0?ofkP3om^h00P3om^h0103D?AT0ooK^0?ofkP3om^h50=@m6@@0ooK^00<0e3dI0?of
kP3om^h01P3om^h20=@m6@80ooK^103D?AT70?ofkP@0e3dI3P3om^h303eIZ`060?ofkP0mFJ/0?EV[
03eIZ`3om^h0?EV[103om^h0100mFJ/0ooK^03eIZ`0mFJ/60?ofkP0303eIZ`3om^h0ooK^00D0ooK^
00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP090?ofkP80?EV[1`3om^h00`0mFJ/0ooK^
0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^
0?ofkP050?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h0203om^h0100mFJ/0ooK^
0?ofkP0mFJ]G0?ofkP030000003om^h0ooK^00<0ooK^00<000000?ofkP3om^h0803om^h10?ooo`00
E@3om^h00`000000ooK^0?ofkP0B0?ofkP030=@m6@3om^h0ooK^00@0e3dI3`3om^h00`3D?AT0ooK^
0?ofkP0C0?ofkP<0e3dI303om^h00`3D?AT0ooK^0?ofkP080?ofkP050=@m6@3om^h0ooK^0=@m6@3o
m^h01@3D?AT70?ofkP030=@m6@3om^h0ooK^00H0ooK^00<000000=@m6@3D?AT0103D?AT50?ofkP@0
e3dI4`3om^h203eIZ`80ooK^0`0mFJ/50?ofkP80?EV[00<0ooK^03eIZ`3om^h0103om^h00`0mFJ/0
ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h01P3om^h203eIZ`X0
ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00P0
ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00X0
ooK^0P0mFJ]I0?ofkP030000003om^h0ooK^0080ooK^00<000000?ofkP3om^h0803om^h10?ooo`00
EP3om^h2000001<0ooK^0P3D?ATC0?ofkP030=@m6@3om^h0ooK^0100ooK^0`3D?AT20?ofkP030=@m
6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h02P3om^h60=@m6@T0ooK^00<0e3dI0?ofkP3om^h0
1@3om^h40=@m6@030?ofkP3D?AT0ooK^0080ooK^1@3D?ATH0?ofkP80?EV[0P3om^h303eIZ`D0ooK^
00@0?EV[0?ofkP3om^h0?EV[103om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00l0
ooK^00<0?EV[0?ofkP3om^h00`3om^h203eIZ`d0ooK^0P0mFJ/80?ofkP80?EV[2@3om^h00`0mFJ/0
ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0
ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^05P0ooK^00D000000?ofkP3om^h0ooK^0000000R0?of
kP40oooo001H0?ofkP030000003om^h0ooK^0140ooK^00<0e3dI0?ofkP3om^h04P3om^h00`3D?AT0
ooK^0?ofkP0<0?ofkP<0e3dI1P3om^h20=@m6@T0ooK^00<0e3dI0?ofkP3om^h0203om^h50=@m6@`0
ooK^00@0e3dI0?ofkP3om^h0ooK^103D?AT20?ofkP030000003om^h0e3dI0080ooK^103D?ATL0?of
kP<0?EV[00@0ooK^03eIZ`0mFJ/0?EV[103om^h203eIZ`80ooK^00D0?EV[0?ofkP3om^h0ooK^03eI
Z`0:0?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h00P0mFJ/A0?ofkP0303eIZ`3o
m^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3o
m^h0ooK^00/0ooK^00@0?EV[0?ofkP3om^h0?EV[3@3om^h00`0mFJ/0ooK^0?ofkP1I0?ofkP050000
003om^h0ooK^0?ofkP0000008P3om^h10?ooo`00F@3om^h200000180ooK^00<0e3dI0?ofkP3om^h0
4P3om^h00`3D?AT0ooK^0?ofkP080?ofkP<0e3dI2`3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m
6@3om^h0ooK^00D0ooK^1@3D?AT00`3om^h0e3dI0?ofkP030=@m6@P0ooK^00<0e3dI0?ofkP3D?AT0
0`3D?AT50?ofkP030000003D?AT0e3dI00<0e3dI803om^h00`0mFJ/0ooK^03eIZ`0203eIZ`030?of
kP0mFJ/0ooK^00<0ooK^0P0mFJ/20?ofkP80?EV[00<0ooK^03eIZ`3om^h02P3om^h00`0mFJ/0ooK^
0?ofkP0>0?ofkP<0?EV[503om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00`0ooK^
00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0?EV[00d0ooK^
00<0?EV[0?ofkP3om^h0FP3om^h01@000000ooK^0?ofkP3om^h000000240ooK^0@3oool005/0ooK^
00<000000?ofkP3om^h0403om^h00`3D?AT0ooK^0?ofkP0B0?ofkP030=@m6@3om^h0ooK^00@0ooK^
0`3D?AT?0?ofkP030=@m6@3om^h0ooK^00D0ooK^00@0e3dI0?ofkP3om^h0ooK^1@3D?AT40?ofkP03
0=@m6@3om^h0ooK^00<0ooK^0`3D?AT30?ofkP@0e3dI203om^h30=@m6BD0ooK^00<0?EV[0?ofkP3o
m^h00P0mFJ/00`3om^h0?EV[0?ofkP020?ofkP0303eIZ`3om^h0?EV[00<0ooK^00<0?EV[0?ofkP0m
FJ/02`3om^h00`0mFJ/0ooK^0?ofkP090?ofkP@0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP04
03eIZ`3om^h0?EV[03eIZa00ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0A0?ofkP0303eIZ`3om^h0
ooK^00/0ooK^00<0?EV[0?ofkP3om^h0G03om^h010000000ooK^0?ofkP00000Q0?ofkP40oooo001L
0?ofkP030000003om^h0ooK^0100ooK^00<0e3dI0?ofkP3om^h04P3om^h00`3D?AT0ooK^0?ofkP03
0=@m6A<0ooK^0P3D?AT40?ofkP030=@m6@3om^h0e3dI00@0e3dI1P3om^h00`3D?AT0ooK^0?ofkP07
0?ofkPD0e3dI1P3om^h40=@m6@030?ofkP000000ooK^02H0ooK^00<0?EV[0?ofkP3om^h0100mFJ/2
0?ofkP0303eIZ`3om^h0ooK^0080?EV[0P3om^h203eIZ``0ooK^00<0?EV[0?ofkP3om^h01@3om^h3
03eIZ`L0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP0303eIZ`3om^h0
?EV[0140ooK^00<0?EV[0?ofkP0mFJ/02`3om^h00`0mFJ/0ooK^0?ofkP1M0?ofkP040000003om^h0
ooK^00000240ooK^0@3oool005d0ooK^0P00000@0?ofkP030=@m6@3om^h0ooK^0180ooK^0`3D?ATH
0?ofkP030=@m6@3om^h0ooK^00@0e3dI2P3om^h00`3D?AT0ooK^0?ofkP040?ofkP<0e3dI0`3om^h0
0`3D?AT0ooK^0=@m6@050=@m6@D0ooK^00<000000?ofkP3om^h09P3om^h203eIZ`030?ofkP0mFJ/0
?EV[00@0?EV[103om^h0100mFJ/0ooK^0?ofkP0mFJ/=0?ofkP0303eIZ`3om^h0ooK^00@0?EV[2`3o
m^h00`0mFJ/0ooK^0?ofkP0@0?ofkP80?EV[00<0ooK^03eIZ`3om^h04P3om^h00`0mFJ/0ooK^0?of
kP0?0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/02P3om^h00`0mFJ/0ooK^0?ofkP1N0?ofkP030000
003om^h000000240ooK^0@3oool005l0ooK^00<000000?ofkP3om^h03P3om^h00`3D?AT0ooK^0?of
kP0=0?ofkP@0e3dI0P3om^h20=@m6AL0ooK^103D?AT<0?ofkP030=@m6@3om^h0ooK^0080ooK^0`3D
?AT40?ofkP80e3dI00<0ooK^0=@m6@3D?AT00P3D?AT80?ofkP030000003om^h0ooK^02L0ooK^0P0m
FJ/00`3om^h0?EV[03eIZ`0203eIZ`030?ofkP0mFJ/0?EV[00@0?EV[00<0ooK^03eIZ`0mFJ/01`3o
m^h803eIZa00ooK^00<0?EV[0?ofkP3om^h03@3om^h203eIZ`@0ooK^00<0?EV[0?ofkP3om^h03`3o
m^h00`0mFJ/0ooK^03eIZ`0?0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h01P3o
m^h00`0mFJ/0ooK^0?ofkP1P0?ofkP8000008@3om^h10?ooo`00H03om^h2000000l0ooK^00<0e3dI
0?ofkP3om^h02@3om^h30=@m6@P0ooK^0P3D?ATA0?ofkP@0e3dI0`3om^h20=@m6@/0ooK^1@3D?AT6
0?ofkPD0e3dI2`3om^h00`000000ooK^0?ofkP0X0?ofkP<0?EV[0P3om^h303eIZ`D0ooK^2P0mFJ/7
0?ofkP0303eIZ`3om^h0ooK^00l0ooK^0P0mFJ/;0?ofkP80?EV[1`3om^h00`0mFJ/0ooK^0?ofkP0<
0?ofkP80?EV[0`3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[
0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP1R0?ofkP800000803om^h10?ooo`00HP3om^h00`00
0000ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00D0ooK^0`3D?AT=0?ofkP030=@m6@3om^h0ooK^
00/0ooK^0`3D?AT60?ofkP030=@m6@3om^h0ooK^0080e3dI1`3om^h40=@m6@H0ooK^103D?AT?0?of
kP030000003om^h0ooK^02X0ooK^0P0mFJ/20?ofkP80?EV[1P3om^h0100mFJ/0ooK^0?ofkP0mFJ/=
0?ofkP0303eIZ`3om^h0ooK^0100ooK^00<0?EV[0?ofkP3om^h01P3om^h203eIZ`X0ooK^00<0?EV[
0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[
0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^0680ooK^0P00000P
0?ofkP40oooo001S0?ofkP8000003P3om^h00`3D?AT0ooK^0?ofkP040=@m6A40ooK^0P3D?AT80?of
kP<0e3dI203om^h00`3D?AT0ooK^0?ofkP030?ofkP80e3dI0P3om^h40=@m6@D0ooK^1@3D?ATB0?of
kP030000003om^h0ooK^02/0ooK^0P0mFJ/20?ofkP80?EV[1@3om^h01@0mFJ/0ooK^0?ofkP3om^h0
?EV[00d0ooK^00<0?EV[0?ofkP3om^h0403om^h00`0mFJ/0ooK^0?ofkP030?ofkP80?EV[303om^h0
0`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h01`3om^h0
0`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h0H`3om^h2
00000200ooK^0@3oool006D0ooK^00<000000?ofkP3om^h0303om^h20=@m6AL0ooK^0P3D?AT20?of
kP@0e3dI2`3om^h00`3D?AT0ooK^0?ofkP040?ofkPd0e3dI5P3om^h00`000000ooK^0?ofkP0/0?of
kP<0?EV[00@0ooK^03eIZ`0mFJ/0?EV[103om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00d0ooK^00<0
?EV[0?ofkP3om^h0403om^h00`0mFJ/0ooK^0?ofkP0203eIZ`l0ooK^00<0?EV[0?ofkP3om^h01P3o
m^h203eIZ`X0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0403eIZ`3o
m^h0ooK^03eIZf80ooK^1000000R0?ofkP40oooo001V0?ofkP8000003@3om^h00`3D?AT0ooK^0?of
kP0F0?ofkP<0e3dI3P3om^h0103D?AT0ooK^0?ofkP3om^h50=@m6@80ooK^0P3D?AT00`3om^h0e3dI
0=@m6@020=@m6AT0ooK^00<000000?ofkP3om^h0;@3om^h00`0mFJ/0ooK^03eIZ`0203eIZ`030?of
kP0mFJ/0ooK^0080ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP80?EV[
403om^h303eIZa80ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eI
Z`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^03eIZ`1N0?ofkP@00000
9P3om^h10?ooo`00J03om^h00`000000ooK^0?ofkP0;0?ofkP80e3dI4`3om^h30=@m6@<0ooK^0P3D
?AT<0?ofkPD0e3dI1@3om^h50=@m6A`0ooK^00<000000?ofkP3om^h0;P3om^h00`0mFJ/0ooK^0?of
kP0403eIZ`<0ooK^00<0?EV[0?ofkP3om^h00P3om^h203eIZ`d0ooK^00<0?EV[0?ofkP3om^h02@3o
m^h403eIZ`80ooK^00<0?EV[0?ofkP3om^h04@3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3o
m^h0ooK^00d0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0@0?ofkP0303eIZ`3om^h0ooK^05T0ooK^
1000000Z0?ofkP40oooo001Y0?ofkP8000003@3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP<0e3dI203o
m^h20=@m6@T0ooK^0`3D?AT60?ofkP<0e3dI803om^h00`000000ooK^0?ofkP0_0?ofkP80?EV[00<0
ooK^03eIZ`0mFJ/00P0mFJ/20?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h02`3o
m^h00`0mFJ/0ooK^0?ofkP050?ofkP<0?EV[1`3om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP0403eIZ`3o
m^h0?EV[03eIZa40ooK^00<0?EV[0?ofkP0mFJ/0403om^h00`0mFJ/0ooK^0?ofkP1F0?ofkP@00000
;P3om^h10?ooo`00J`3om^h00`000000ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00T0ooK^0`3D
?AT=0?ofkP80e3dI0`3om^h40=@m6@D0ooK^1@3D?ATR0?ofkP030000003om^h0ooK^0300ooK^0P0m
FJ/00`3om^h0?EV[0?ofkP0403eIZ`L0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?of
kP0403eIZ`/0ooK^00<0?EV[0?ofkP3om^h0403om^h203eIZa@0ooK^00<0?EV[0?ofkP3om^h03P3o
m^h00`0mFJ/0ooK^0?ofkP1C0?ofkP@00000<P3om^h10?ooo`00K03om^h2000000`0ooK^0P3D?AT6
0?ofkP<0e3dI4P3om^h50=@m6@@0ooK^1@3D?ATU0?ofkP030000003om^h0ooK^0340ooK^0P0mFJ/0
0`3om^h0?EV[0?ofkP0203eIZ`030?ofkP0mFJ/0?EV[00@0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP05
0?ofkPP0?EV[403om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP80?EV[0P3om^h00`0mFJ/0ooK^0?ofkP0?
0?ofkP80?EV[00<0ooK^03eIZ`3om^h03@3om^h00`0mFJ/0ooK^0?ofkP1@0?ofkP@00000=P3om^h1
0?ooo`00KP3om^h00`000000ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00<0e3dI4@3om^h40=@m
6@<0ooK^00<0e3dI0?ofkP3D?AT01@3D?ATX0?ofkP030000003om^h0ooK^03<0ooK^00@0?EV[0?of
kP0mFJ/0ooK^0`0mFJ/50?ofkPX0?EV[1`3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP80?EV[2`3om^h2
03eIZ`D0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0
ooK^00X0ooK^00<0?EV[0?ofkP3om^h0C@3om^h4000003X0ooK^0@3oool006l0ooK^00<000000?of
kP3om^h02`3om^h20=@m6A40ooK^0`3D?AT50?ofkPL0e3dI:`3om^h00`000000ooK^0?ofkP0d0?of
kP80?EV[0`3om^h203eIZ`P0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP0@0?of
kP0303eIZ`3om^h0ooK^00H0ooK^0P0mFJ/80?ofkP0303eIZ`3om^h0ooK^00X0ooK^0P0mFJ/60?of
kP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h0BP3om^h4000003h0ooK^0@3oool00700
ooK^0P00000=0?ofkP<0e3dI2`3om^h30=@m6@H0ooK^1@3D?AT_0?ofkP030000003om^h0ooK^03D0
ooK^0P0mFJ/30?ofkP80?EV[203om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^0100
ooK^00<0?EV[0?ofkP3om^h00`3om^h203eIZ`/0ooK^0P0mFJ/90?ofkP0303eIZ`3om^h0ooK^00L0
ooK^0P0mFJ/70?ofkP0303eIZ`3om^h0ooK^04L0ooK^100000120?ofkP40oooo001b0?ofkP030000
003om^h0ooK^00d0ooK^103D?AT30?ofkP@0e3dI1`3om^h40=@m6C40ooK^00<000000?ofkP3om^h0
=`3om^h403eIZ`030?ofkP0mFJ/0?EV[00P0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^
0?ofkP0@0?ofkP0303eIZ`3om^h0ooK^0080?EV[3`3om^h00`0mFJ/0ooK^0?ofkP040?ofkP80?EV[
303om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^04@0ooK^100000160?ofkP40oooo
001c0?ofkP8000004@3om^h50=@m6@H0ooK^103D?ATd0?ofkP030000003om^h0ooK^03P0ooK^0P0m
FJ/0103om^h0?EV[03eIZ`3om^h203eIZ`L0ooK^00<0?EV[0?ofkP3om^h02`3om^h203eIZa00ooK^
0`0mFJ/B0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h03@3om^h01@0mFJ/0ooK^
0?ofkP3om^h0?EV[04<0ooK^1000001:0?ofkP40oooo001e0?ofkP030000003om^h0ooK^01<0ooK^
1P3D?ATh0?ofkP030000003om^h0ooK^03X0ooK^00<0?EV[0?ofkP3om^h0100mFJ/70?ofkP80?EV[
3@3om^h00`0mFJ/0ooK^0?ofkP090?ofkP@0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP0403eI
Z`3om^h0?EV[03eIZa40ooK^00<0?EV[0?ofkP0mFJ/0@03om^h4000004h0ooK^0@3oool007H0ooK^
0P00001A0?ofkP030000003om^h0ooK^03/0ooK^00D0?EV[0?ofkP3om^h0?EV[0?ofkP0303eIZ`L0
ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP050?ofkP<0?EV[1`3om^h00`0mFJ/0
ooK^0?ofkP0A0?ofkP0303eIZ`3om^h0ooK^0180ooK^00<0?EV[0?ofkP3om^h0>`3om^h400000580
ooK^0@3oool007P0ooK^00<000000?ofkP3om^h0CP3om^h00`000000ooK^0?ofkP0l0?ofkP<0?EV[
0`3om^h503eIZ`@0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP0403eIZ`/0ooK^
00<0?EV[0?ofkP3om^h03P3om^h203eIZ`030?ofkP0mFJ/0ooK^0140ooK^00<0?EV[0?ofkP3om^h0
>@3om^h3000005H0ooK^0@3oool007T0ooK^0P00001>0?ofkP030000003om^h0ooK^03d0ooK^0`0m
FJ/30?ofkP0403eIZ`3om^h0ooK^0?ofkP@0?EV[00<0ooK^03eIZ`3om^h01P3om^h803eIZa00ooK^
00<0?EV[0?ofkP3om^h02`3om^h203eIZ`@0ooK^00<0?EV[0?ofkP3om^h03@3om^h203eIZcP0ooK^
1000001I0?ofkP40oooo001k0?ofkP030000003om^h0ooK^04/0ooK^00<000000?ofkP3om^h0?`3o
m^h203eIZ`<0ooK^00<0?EV[0?ofkP3om^h0103om^h903eIZ`L0ooK^00<0?EV[0?ofkP3om^h03`3o
m^h00`0mFJ/0ooK^0?ofkP080?ofkP80?EV[1`3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3o
m^h0ooK^03@0ooK^1000001M0?ofkP40oooo001l0?ofkP800000B`3om^h00`000000ooK^0?ofkP10
0?ofkP80?EV[0`3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00/0ooK^0P0mFJ/@
0?ofkP0303eIZ`3om^h0ooK^00D0ooK^0P0mFJ/:0?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[
0?ofkP3om^h0<@3om^h400000640ooK^0@3oool007h0ooK^00<000000?ofkP3om^h0B03om^h00`00
0000ooK^0?ofkP110?ofkP<0?EV[0P3om^h203eIZ`L0ooK^0P0mFJ/=0?ofkP0303eIZ`3om^h0ooK^
00h0ooK^00<0?EV[0?ofkP3om^h00P3om^h203eIZ`d0ooK^00<0?EV[0?ofkP3om^h01P3om^h203eI
Zc00ooK^1000001U0?ofkP40oooo001o0?ofkP800000B03om^h00`000000ooK^0?ofkP120?ofkP04
03eIZ`3om^h0?EV[03eIZ`80ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP0;0?of
kP0303eIZ`3om^h0ooK^00h0ooK^00@0?EV[0?ofkP0mFJ/0?EV[403om^h00`0mFJ/0ooK^0?ofkP04
0?ofkP0303eIZ`3om^h0ooK^02`0ooK^1000001Y0?ofkP40oooo00210?ofkP030000003om^h0ooK^
04D0ooK^00<000000?ofkP3om^h0@`3om^h00`0mFJ/0ooK^0?ofkP0203eIZ`030?ofkP0mFJ/0ooK^
00L0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP<0?EV[4`3om^h00`0m
FJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^02T0ooK^1000001]0?ofkP40oooo00220?ofkP03
0000003om^h0ooK^04@0ooK^00<000000?ofkP3om^h0A03om^h203eIZ`80ooK^0`0mFJ/80?ofkP03
03eIZ`3om^h0ooK^00/0ooK^0P0mFJ/80?ofkP@0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP04
03eIZ`3om^h0?EV[03eIZbP0ooK^1000001a0?ofkP40oooo00230?ofkP800000A03om^h00`000000
ooK^0?ofkP150?ofkP80?EV[0`3om^h403eIZ`H0ooK^0P0mFJ/=0?ofkP0403eIZ`3om^h0ooK^0?of
kP@0?EV[203om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP80?EV[9P3om^h4000007D0ooK^0@3oool008D0
ooK^00<000000?ofkP3om^h0@@3om^h00`000000ooK^0?ofkP170?ofkP0303eIZ`3om^h0ooK^0080
ooK^00<0?EV[0?ofkP0mFJ/01@0mFJ/20?ofkP0303eIZ`3om^h0ooK^00D0ooK^2@0mFJ/=0?ofkP03
03eIZ`3om^h0ooK^00d0ooK^0P0mFJ/T0?ofkP@00000N@3om^h10?ooo`00QP3om^h200000440ooK^
00<000000?ofkP3om^h0B03om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00@0ooK^
2P0mFJ/70?ofkP0303eIZ`3om^h0ooK^00d0ooK^0P0mFJ/;0?ofkP80?EV[8P3om^h4000007d0ooK^
0@3oool008P0ooK^00<000000?ofkP3om^h0?P3om^h00`000000ooK^0?ofkP190?ofkP80?EV[0`3o
m^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h03P3o
m^h00`0mFJ/0ooK^0?ofkP060?ofkP80?EV[803om^h400000840ooK^0@3oool008T0ooK^0P00000n
0?ofkP030000003om^h0ooK^04/0ooK^0P0mFJ/20?ofkP80?EV[203om^h00`0mFJ/0ooK^0?ofkP0;
0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h00`3om^h203eIZah0ooK^10000025
0?ofkP40oooo002;0?ofkP030000003om^h0ooK^03/0ooK^00<000000?ofkP3om^h0C@3om^h203eI
Z`80ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^
00h0ooK^00<0?EV[0?ofkP3om^h00P0mFJ/M0?ofkP<00000R@3om^h10?ooo`00S03om^h2000003/0
ooK^00<000000?ofkP3om^h0C`3om^h203eIZ`030?ofkP0mFJ/0ooK^00L0ooK^0P0mFJ/<0?ofkP03
03eIZ`3om^h0ooK^00d0ooK^0`0mFJ/K0?ofkP@00000S03om^h10?ooo`00SP3om^h00`000000ooK^
0?ofkP0h0?ofkP030000003om^h0ooK^0540ooK^0`0mFJ/90?ofkP0303eIZ`3om^h0ooK^00X0ooK^
00<0?EV[0?ofkP3om^h02@3om^h303eIZaX0ooK^1000002@0?ofkP40oooo002?0?ofkP800000>03o
m^h00`000000ooK^0?ofkP1C0?ofkP@0?EV[1`3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3o
m^h0ooK^00@0ooK^100mFJ/I0?ofkP@00000U03om^h10?ooo`00T@3om^h00`000000ooK^0?ofkP0e
0?ofkP030000003om^h0ooK^05L0ooK^1P0mFJ/20?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[
0?ofkP3om^h00`0mFJ/I0?ofkP@00000V03om^h10?ooo`00TP3om^h2000003D0ooK^00<000000?of
kP3om^h0G@3om^hB03eIZaP0ooK^1000002L0?ofkP40oooo002D0?ofkP030000003om^h0ooK^0380
ooK^00<000000?ofkP3om^h0P`3om^h400000:00ooK^0@3oool009D0ooK^00<000000?ofkP3om^h0
<03om^h00`000000ooK^0?ofkP200?ofkP@00000Y03om^h10?ooo`00UP3om^h200000300ooK^00<0
00000?ofkP3om^h0O03om^h400000:P0ooK^0@3oool009P0ooK^00<000000?ofkP3om^h0;@3om^h0
0`000000ooK^0?ofkP1h0?ofkP@00000[03om^h10?ooo`00V@3om^h2000002d0ooK^00<000000?of
kP3om^h0M03om^h400000;00ooK^0@3oool009/0ooK^00<000000?ofkP3om^h0:P3om^h00`000000
ooK^0?ofkP1`0?ofkP@00000]03om^h10?ooo`00W03om^h2000002X0ooK^00<000000?ofkP3om^h0
K03om^h400000;P0ooK^0@3oool009h0ooK^00<000000?ofkP3om^h09`3om^h00`000000ooK^0?of
kP1X0?ofkP@00000_03om^h10?ooo`00W`3om^h2000002L0ooK^00<000000?ofkP3om^h0I@3om^h3
00000<00ooK^0@3oool00:40ooK^00<000000?ofkP3om^h0903om^h00`000000ooK^0?ofkP1Q0?of
kP@00000``3om^h10?ooo`00XP3om^h2000002@0ooK^00<000000?ofkP3om^h0G@3om^h400000<L0
ooK^0@3oool00:@0ooK^00<000000?ofkP3om^h08@3om^h00`000000ooK^0?ofkP1I0?ofkP@00000
b`3om^h10?ooo`00Y@3om^h200000240ooK^00<000000?ofkP3om^h0E@3om^h400000<l0ooK^0@3o
ool00:L0ooK^00<000000?ofkP3om^h07P3om^h00`000000ooK^0?ofkP1A0?ofkP@00000d`3om^h1
0?ooo`00Z03om^h2000001h0ooK^00<000000?ofkP3om^h0C@3om^h400000=L0ooK^0@3oool00:X0
ooK^00<000000?ofkP3om^h06`3om^h00`000000ooK^0?ofkP190?ofkP@00000f`3om^h10?ooo`00
Z`3om^h00`000000ooK^0?ofkP0J0?ofkP030000003om^h0ooK^04D0ooK^1000003O0?ofkP40oooo
002/0?ofkP8000006P3om^h00`000000ooK^0?ofkP110?ofkP@00000h`3om^h10?ooo`00[P3om^h0
0`000000ooK^0?ofkP0G0?ofkP030000003om^h0ooK^03d0ooK^1000003W0?ofkP40oooo002_0?of
kP8000005`3om^h00`000000ooK^0?ofkP0i0?ofkP@00000j`3om^h10?ooo`00/@3om^h00`000000
ooK^0?ofkP0D0?ofkP030000003om^h0ooK^03D0ooK^1000003_0?ofkP40oooo002b0?ofkP800000
503om^h00`000000ooK^0?ofkP0b0?ofkP<00000l`3om^h10?ooo`00]03om^h00`000000ooK^0?of
kP0A0?ofkP030000003om^h0ooK^02h0ooK^1000003f0?ofkP40oooo002e0?ofkP8000004@3om^h0
0`000000ooK^0?ofkP0Z0?ofkP@00000nP3om^h10?ooo`00]`3om^h00`000000ooK^0?ofkP0=0?of
kP030000003om^h0ooK^02L0ooK^1000003n0?ofkP40oooo002h0?ofkP8000003@3om^h00`000000
ooK^0?ofkP0S0?ofkP@00000o`3om^h30?ofkP40oooo002j0?ofkP030000003om^h0ooK^00X0ooK^
00<000000?ofkP3om^h07`3om^h400000?l0ooK^1`3om^h10?ooo`00^`3om^h2000000X0ooK^00<0
00000?ofkP3om^h06`3om^h400000?l0ooK^2`3om^h10?ooo`00_@3om^h00`000000ooK^0?ofkP07
0?ofkP030000003om^h0ooK^01L0ooK^1000003o0?ofkPl0ooK^0@3oool00;h0ooK^00<000000?of
kP3om^h01P3om^h00`000000ooK^0?ofkP0C0?ofkP@00000o`3om^hC0?ofkP40oooo002o0?ofkP80
00001P3om^h00`000000ooK^0?ofkP0?0?ofkP@00000o`3om^hG0?ofkP40oooo00310?ofkP030000
003om^h0ooK^00<0ooK^00<000000?ofkP3om^h02`3om^h400000?l0ooK^6`3om^h10?ooo`00`P3o
m^h2000000<0ooK^00<000000?ofkP3om^h01`3om^h400000?l0ooK^7`3om^h10?ooo`00a03om^h0
10000000ooK^0?ofkP0000050?ofkP@00000o`3om^hS0?ofkP40oooo00350?ofkP<0000000<0ooK^
0000000000000P00003o0?ofkRL0ooK^0@3oool00<L0ooK^0P00003o0?ofkR/0ooK^0@3oool00?l0
ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h1
0?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3o
m^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40
oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?of
k_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3o
ool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^
m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?oo
o`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd
0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo
003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0
ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool0
0?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03o
m^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00
o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?of
kP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o
0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^
0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0
ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h1
0?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3o
m^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40
oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?of
k_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3o
ool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^
m03om^h10?ooo`00\
\>"],
  ImageRangeCache->{{{0, 499}, {499, 0}} -> {-5.00005*^-06, -5.00005*^-06, \
0.00200403, 0.00200403}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
%%ImageSize: 500 500 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics3D
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Background color
1 .961 .933 r
MFill
% Scaling calculations
0 1 0 1 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 0 r
.25 Mabswid
[ ] 0 setdash
.75972 .08168 m
.80207 .35868 L
s
.80207 .35868 m
.02925 .49223 L
s
.02925 .49223 m
.08947 .22236 L
s
.08947 .22236 m
.75972 .08168 L
s
.83139 .50547 m
.32128 .58361 L
s
.32128 .58361 m
.3022 .81857 L
s
.3022 .81857 m
.86955 .74993 L
s
.86955 .74993 m
.83139 .50547 L
s
.75972 .08168 m
.80207 .35868 L
s
.80207 .35868 m
.86955 .74993 L
s
.86955 .74993 m
.83139 .50547 L
s
.83139 .50547 m
.75972 .08168 L
s
.08947 .22236 m
.32128 .58361 L
s
.32128 .58361 m
.3022 .81857 L
s
.3022 .81857 m
.02925 .49223 L
s
.02925 .49223 m
.08947 .22236 L
s
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
.24 .35 .67 r
.5 Mabswid
.52744 .55588 m
.50435 .56818 L
s
.51851 .53577 m
.52744 .55588 L
s
.55225 .54761 m
.52744 .55588 L
s
.50435 .56818 m
.48382 .58405 L
s
.49499 .54826 m
.50435 .56818 L
s
.54374 .52733 m
.55225 .54761 L
s
.57783 .54369 m
.55225 .54761 L
s
.48382 .58405 m
.46666 .60293 L
s
.47407 .56436 m
.48382 .58405 L
s
.56975 .52327 m
.57783 .54369 L
s
.60325 .54431 m
.57783 .54369 L
s
.46666 .60293 m
.45358 .62415 L
s
.45655 .58347 m
.46666 .60293 L
s
.59557 .52378 m
.60325 .54431 L
s
.6275 .54952 m
.60325 .54431 L
s
.45358 .62415 m
.44518 .64691 L
s
.44317 .60493 m
.45358 .62415 L
s
.62021 .52894 m
.6275 .54952 L
s
.64963 .55922 m
.6275 .54952 L
s
.49499 .54826 m
.51851 .53577 L
s
.50925 .51493 m
.51851 .53577 L
s
.51851 .53577 m
.54374 .52733 L
s
.47407 .56436 m
.49499 .54826 L
s
.4853 .52763 m
.49499 .54826 L
s
.53492 .50631 m
.54374 .52733 L
s
.54374 .52733 m
.56975 .52327 L
s
.45655 .58347 m
.47407 .56436 L
s
.46397 .54395 m
.47407 .56436 L
s
.56137 .5021 m
.56975 .52327 L
s
.56975 .52327 m
.59557 .52378 L
s
.44518 .64691 m
.4419 .67035 L
s
.43452 .62794 m
.44518 .64691 L
s
.64267 .53862 m
.64963 .55922 L
s
.66866 .57313 m
.64963 .55922 L
s
.44317 .60493 m
.45655 .58347 L
s
.44608 .5633 m
.45655 .58347 L
s
.58762 .5025 m
.59557 .52378 L
s
.59557 .52378 m
.62021 .52894 L
s
.43452 .62794 m
.44317 .60493 L
s
.43237 .58501 m
.44317 .60493 L
s
.4419 .67035 m
.43108 .65162 L
s
.4419 .67035 m
.44405 .6935 L
s
.61265 .50759 m
.62021 .52894 L
s
.62021 .52894 m
.64267 .53862 L
s
.4853 .52763 m
.50925 .51493 L
s
.49964 .49333 m
.50925 .51493 L
s
.50925 .51493 m
.53492 .50631 L
s
.66199 .55258 m
.66866 .57313 L
s
.68373 .59079 m
.66866 .57313 L
s
.46397 .54395 m
.4853 .52763 L
s
.47525 .50624 m
.4853 .52763 L
s
.52578 .48451 m
.53492 .50631 L
s
.53492 .50631 m
.56137 .5021 L
s
.44608 .5633 m
.46397 .54395 L
s
.45349 .52279 m
.46397 .54395 L
s
.55269 .48015 m
.56137 .5021 L
s
.56137 .5021 m
.58762 .5025 L
s
.43108 .65162 m
.43452 .62794 L
s
.42346 .60827 m
.43452 .62794 L
s
.63546 .51727 m
.64267 .53862 L
s
.64267 .53862 m
.66199 .55258 L
s
.43237 .58501 m
.44608 .5633 L
s
.43521 .54239 m
.44608 .5633 L
s
.44405 .6935 m
.45169 .71538 L
s
.43314 .675 m
.44405 .6935 L
s
.57937 .48044 m
.58762 .5025 L
s
.58762 .5025 m
.61265 .50759 L
s
.67726 .57035 m
.68373 .59079 L
s
.69405 .61157 m
.68373 .59079 L
s
.42346 .60827 m
.43237 .58501 L
s
.42117 .56435 m
.43237 .58501 L
s
.43108 .65162 m
.41985 .63219 L
s
.43314 .675 m
.43108 .65162 L
s
.6048 .48545 m
.61265 .50759 L
s
.61265 .50759 m
.63546 .51727 L
s
.47525 .50624 m
.49964 .49333 L
s
.48968 .47091 m
.49964 .49333 L
s
.49964 .49333 m
.52578 .48451 L
s
.65506 .53126 m
.66199 .55258 L
s
.66199 .55258 m
.67726 .57035 L
s
.45349 .52279 m
.47525 .50624 L
s
.46482 .48405 m
.47525 .50624 L
s
.51629 .4619 m
.52578 .48451 L
s
.52578 .48451 m
.55269 .48015 L
s
.45169 .71538 m
.46468 .73497 L
s
.44081 .69708 m
.45169 .71538 L
s
.6877 .59129 m
.69405 .61157 L
s
.699 .63465 m
.69405 .61157 L
s
.43521 .54239 m
.45349 .52279 L
s
.44262 .50083 m
.45349 .52279 L
s
.54367 .45737 m
.55269 .48015 L
s
.55269 .48015 m
.57937 .48044 L
s
.41985 .63219 m
.42346 .60827 L
s
.41199 .58786 m
.42346 .60827 L
s
.62797 .4951 m
.63546 .51727 L
s
.63546 .51727 m
.65506 .53126 L
s
.42117 .56435 m
.43521 .54239 L
s
.42394 .52068 m
.43521 .54239 L
s
.44081 .69708 m
.43314 .675 L
s
.42183 .6558 m
.43314 .675 L
s
.83 .24 .1 r
.27 .54129 m
.27308 .56888 L
s
.30589 .53554 m
.27 .54129 L
s
.26487 .51389 m
.27 .54129 L
s
.24 .35 .67 r
.57081 .45753 m
.57937 .48044 L
s
.57937 .48044 m
.6048 .48545 L
s
.67054 .54912 m
.67726 .57035 L
s
.67726 .57035 m
.6877 .59129 L
s
.83 .24 .1 r
.30078 .50799 m
.26487 .51389 L
s
.25786 .48758 m
.26487 .51389 L
s
.27308 .56888 m
.274 .59574 L
s
.30907 .56326 m
.27308 .56888 L
s
.24 .35 .67 r
.46468 .73497 m
.48259 .75129 L
s
.45392 .71683 m
.46468 .73497 L
s
.69267 .61457 m
.699 .63465 L
s
.69818 .65903 m
.699 .63465 L
s
.83 .24 .1 r
.30907 .56326 m
.30589 .53554 L
s
.34213 .52974 m
.30589 .53554 L
s
.30589 .53554 m
.30078 .50799 L
s
.2939 .48153 m
.25786 .48758 L
s
.24917 .46327 m
.25786 .48758 L
s
.33704 .50204 m
.30078 .50799 L
s
.30078 .50799 m
.2939 .48153 L
s
.24 .35 .67 r
.41199 .58786 m
.42117 .56435 L
s
.41985 .63219 m
.40819 .61202 L
s
.42183 .6558 m
.41985 .63219 L
s
.83 .24 .1 r
.3102 .59022 m
.30907 .56326 L
s
.34541 .55758 m
.30907 .56326 L
s
.24 .35 .67 r
.59666 .46246 m
.6048 .48545 L
s
.6048 .48545 m
.62797 .4951 L
s
.46482 .48405 m
.48968 .47091 L
s
.47934 .44764 m
.48968 .47091 L
s
.48968 .47091 m
.51629 .4619 L
s
.83 .24 .1 r
.274 .59574 m
.27268 .62095 L
s
.3102 .59022 m
.274 .59574 L
s
.24 .35 .67 r
.64787 .50913 m
.65506 .53126 L
s
.65506 .53126 m
.67054 .54912 L
s
.44262 .50083 m
.46482 .48405 L
s
.50645 .43843 m
.51629 .4619 L
s
.51629 .4619 m
.54367 .45737 L
s
.83 .24 .1 r
.34541 .55758 m
.34213 .52974 L
s
.37874 .52387 m
.34213 .52974 L
s
.34213 .52974 m
.33704 .50204 L
s
.24 .35 .67 r
.45392 .71683 m
.44081 .69708 L
s
.42951 .67808 m
.44081 .69708 L
s
.83 .24 .1 r
.33031 .47541 m
.2939 .48153 L
s
.2939 .48153 m
.28547 .45704 L
s
.37368 .49603 m
.33704 .50204 L
s
.33704 .50204 m
.33031 .47541 L
s
.24 .35 .67 r
.6811 .57022 m
.6877 .59129 L
s
.6877 .59129 m
.69267 .61457 L
s
.42394 .52068 m
.44262 .50083 L
s
.83 .24 .1 r
.34677 .58464 m
.34541 .55758 L
s
.38213 .55184 m
.34541 .55758 L
s
.24 .35 .67 r
.48259 .75129 m
.50473 .76347 L
s
.47206 .73327 m
.48259 .75129 L
s
.53431 .43372 m
.54367 .45737 L
s
.54367 .45737 m
.57081 .45753 L
s
.83 .24 .1 r
.30921 .6155 m
.3102 .59022 L
s
.34677 .58464 m
.3102 .59022 L
s
.28547 .45704 m
.24917 .46327 L
s
.23906 .44185 m
.24917 .46327 L
s
.24 .35 .67 r
.69177 .63921 m
.69818 .65903 L
s
.69145 .6836 m
.69818 .65903 L
s
.83 .24 .1 r
.38213 .55184 m
.37874 .52387 L
s
.37874 .52387 m
.37368 .49603 L
s
.24 .35 .67 r
.40819 .61202 m
.41199 .58786 L
s
.83 .24 .1 r
.36709 .46924 m
.33031 .47541 L
s
.33031 .47541 m
.32213 .45075 L
s
.41068 .48996 m
.37368 .49603 L
s
.37368 .49603 m
.36709 .46924 L
s
.24 .35 .67 r
.6202 .47208 m
.62797 .4951 L
s
.62797 .4951 m
.64787 .50913 L
s
.83 .24 .1 r
.27268 .62095 m
.30921 .6155 L
s
.27268 .62095 m
.26911 .64356 L
s
.38371 .57901 m
.38213 .55184 L
s
.24 .35 .67 r
.42951 .67808 m
.42183 .6558 L
s
.41008 .63586 m
.42183 .6558 L
s
.83 .24 .1 r
.34612 .61 m
.34677 .58464 L
s
.38371 .57901 m
.34677 .58464 L
s
.24 .35 .67 r
.56192 .43375 m
.57081 .45753 L
s
.57081 .45753 m
.59666 .46246 L
s
.83 .24 .1 r
.32213 .45075 m
.28547 .45704 L
s
.28547 .45704 m
.27572 .43545 L
s
.24 .35 .67 r
.66357 .52708 m
.67054 .54912 L
s
.67054 .54912 m
.6811 .57022 L
s
.787 .22 .095 r
.43007 .53748 m .41331 .54012 L .40724 .5623 L p F P
0 0 0 r
s
.24 .35 .67 r
.4219 .52382 m
.42394 .52068 L
s
.4153 .55353 m
.42117 .56435 L
s
.822 .232 .1 r
.41331 .54012 m .43007 .53748 L .43651 .51466 L p F P
0 0 0 r
s
.822 .232 .1 r
.43651 .51466 m .42129 .5171 L .41331 .54012 L p F P
0 0 0 r
s
.317 .455 .846 r
.40799 .53023 m .41331 .54012 L .40724 .5623 L p F P
0 0 0 r
s
.83 .24 .1 r
.38213 .55184 m
.40758 .54787 L
s
.322 .464 .871 r
.41331 .54012 m .40799 .53023 L .41652 .50795 L p F P
0 0 0 r
s
.83 .24 .1 r
.37874 .52387 m
.41249 .51847 L
s
.322 .464 .871 r
.41652 .50795 m .42129 .5171 L .41331 .54012 L p F P
0 0 0 r
s
.853 .242 .104 r
.42129 .5171 m .43651 .51466 L .44439 .49147 L p F P
0 0 0 r
s
.24 .35 .67 r
.44178 .49914 m
.44262 .50083 L
s
.853 .242 .104 r
.44439 .49147 m .43103 .49365 L .42129 .5171 L p F P
0 0 0 r
s
.323 .468 .885 r
.42129 .5171 m .41652 .50795 L .42693 .48547 L p F P
0 0 0 r
s
.323 .468 .885 r
.42693 .48547 m .43103 .49365 L .42129 .5171 L p F P
0 0 0 r
s
.83 .24 .1 r
.41068 .48996 m
.41476 .51256 L
s
.40424 .463 m
.36709 .46924 L
s
.36709 .46924 m
.35918 .4444 L
s
.41068 .48996 m
.42602 .48744 L
s
.41068 .48996 m
.40424 .463 L
s
.24 .35 .67 r
.47206 .73327 m
.45392 .71683 L
s
.44275 .698 m
.45392 .71683 L
s
.822 .232 .1 r
.45181 .51221 m .43651 .51466 L .43007 .53748 L p F P
0 0 0 r
s
.853 .242 .104 r
.43651 .51466 m .45181 .51221 L .4578 .48928 L p F P
0 0 0 r
s
.853 .242 .104 r
.4578 .48928 m .44439 .49147 L .43651 .51466 L p F P
0 0 0 r
s
.787 .22 .095 r
.40724 .5623 m .42516 .55954 L .43007 .53748 L p F P
0 0 0 r
s
.83 .24 .1 r
.41687 .52713 m
.41922 .54605 L
s
.24 .35 .67 r
.40954 .5429 m
.41925 .52792 L
s
.83 .24 .1 r
.41084 .54736 m
.41922 .54605 L
s
.24 .35 .67 r
.40954 .5429 m
.4122 .5478 L
s
.787 .22 .095 r
.4469 .53484 m .43007 .53748 L .42516 .55954 L p F P
0 0 0 r
s
.822 .232 .1 r
.43007 .53748 m .4469 .53484 L .45181 .51221 L p F P
0 0 0 r
s
.24 .35 .67 r
.50473 .76347 m
.53016 .77082 L
s
.49453 .74552 m
.50473 .76347 L
s
.747 .207 .089 r
.42516 .55954 m .40724 .5623 L .4032 .58325 L p F P
0 0 0 r
s
.307 .437 .803 r
.40149 .55191 m .40724 .5623 L .4032 .58325 L p F P
0 0 0 r
s
.24 .35 .67 r
.40706 .57908 m
.41199 .58786 L
s
.317 .455 .846 r
.40724 .5623 m .40149 .55191 L .40799 .53023 L p F P
0 0 0 r
s
.882 .252 .108 r
.43103 .49365 m .44439 .49147 L .45356 .4683 L p F P
0 0 0 r
s
.882 .252 .108 r
.45356 .4683 m .44239 .47016 L .43103 .49365 L p F P
0 0 0 r
s
.321 .468 .89 r
.43103 .49365 m .42693 .48547 L .43903 .46321 L p F P
0 0 0 r
s
.321 .468 .89 r
.43903 .46321 m .44239 .47016 L .43103 .49365 L p F P
0 0 0 r
s
.83 .24 .1 r
.30921 .6155 m
.34612 .61 L
s
.30608 .63817 m
.30921 .6155 L
s
.24 .35 .67 r
.6861 .59372 m
.69267 .61457 L
s
.69267 .61457 m
.69177 .63921 L
s
.83 .24 .1 r
.3834 .60445 m
.38371 .57901 L
s
.38371 .57901 m
.40281 .5761 L
s
.24 .35 .67 r
.68485 .66408 m
.69145 .6836 L
s
.67899 .70718 m
.69145 .6836 L
s
.822 .232 .1 r
.46716 .50975 m .45181 .51221 L .4469 .53484 L p F P
0 0 0 r
s
.853 .242 .104 r
.45181 .51221 m .46716 .50975 L .47125 .48708 L p F P
0 0 0 r
s
.853 .242 .104 r
.47125 .48708 m .4578 .48928 L .45181 .51221 L p F P
0 0 0 r
s
.882 .252 .108 r
.44439 .49147 m .4578 .48928 L .46477 .46644 L p F P
0 0 0 r
s
.24 .35 .67 r
.46153 .47705 m
.46482 .48405 L
s
.882 .252 .108 r
.46477 .46644 m .45356 .4683 L .44439 .49147 L p F P
0 0 0 r
s
.83 .24 .1 r
.43376 .48617 m
.44807 .48382 L
s
.35918 .4444 m
.32213 .45075 L
s
.32213 .45075 m
.31276 .42897 L
s
.787 .22 .095 r
.42516 .55954 m .44317 .55676 L .4469 .53484 L p F P
0 0 0 r
s
.787 .22 .095 r
.46381 .53218 m .4469 .53484 L .44317 .55676 L p F P
0 0 0 r
s
.822 .232 .1 r
.4469 .53484 m .46381 .53218 L .46716 .50975 L p F P
0 0 0 r
s
.83 .24 .1 r
.42046 .51719 m
.45309 .51197 L
s
.747 .207 .089 r
.4032 .58325 m .42189 .58042 L .42516 .55954 L p F P
0 0 0 r
s
.83 .24 .1 r
.4042 .57589 m
.42103 .57332 L
s
.41922 .54605 m
.42103 .57332 L
s
.747 .207 .089 r
.44317 .55676 m .42516 .55954 L .42189 .58042 L p F P
0 0 0 r
s
.83 .24 .1 r
.44807 .48382 m
.45309 .51197 L
s
.27572 .43545 m
.23906 .44185 L
s
.22786 .4242 m
.23906 .44185 L
s
.882 .252 .108 r
.4578 .48928 m .47125 .48708 L .47601 .46458 L p F P
0 0 0 r
s
.882 .252 .108 r
.47601 .46458 m .46477 .46644 L .4578 .48928 L p F P
0 0 0 r
s
.822 .232 .1 r
.48258 .50728 m .46716 .50975 L .46381 .53218 L p F P
0 0 0 r
s
.853 .242 .104 r
.46716 .50975 m .48258 .50728 L .48476 .48488 L p F P
0 0 0 r
s
.853 .242 .104 r
.48476 .48488 m .47125 .48708 L .46716 .50975 L p F P
0 0 0 r
s
.83 .24 .1 r
.40424 .463 m
.3966 .43798 L
s
.24 .35 .67 r
.59666 .46246 m
.6202 .47208 L
s
.787 .22 .095 r
.44317 .55676 m .46126 .55397 L .46381 .53218 L p F P
0 0 0 r
s
.83 .24 .1 r
.45309 .51197 m
.45669 .54019 L
s
.41922 .54605 m
.45669 .54019 L
s
.787 .22 .095 r
.4808 .52951 m .46381 .53218 L .46126 .55397 L p F P
0 0 0 r
s
.822 .232 .1 r
.46381 .53218 m .4808 .52951 L .48258 .50728 L p F P
0 0 0 r
s
.24 .35 .67 r
.47934 .44764 m
.50645 .43843 L
s
.7 .192 .083 r
.42189 .58042 m .4032 .58325 L .40129 .60259 L p F P
0 0 0 r
s
.288 .406 .735 r
.39716 .57261 m .4032 .58325 L .40129 .60259 L p F P
0 0 0 r
s
.307 .437 .803 r
.4032 .58325 m .39716 .57261 L .40149 .55191 L p F P
0 0 0 r
s
.91 .262 .112 r
.44239 .47016 m .45356 .4683 L .46389 .44559 L p F P
0 0 0 r
s
.24 .35 .67 r
.45546 .46413 m
.45714 .46771 L
s
.91 .262 .112 r
.46389 .44559 m .45518 .44706 L .44239 .47016 L p F P
0 0 0 r
s
.24 .35 .67 r
.45779 .459 m
.47934 .44764 L
s
.317 .464 .889 r
.44239 .47016 m .43903 .46321 L .45263 .44156 L p F P
0 0 0 r
s
.83 .24 .1 r
.44178 .45669 m
.44214 .45826 L
s
.317 .464 .889 r
.45263 .44156 m .45518 .44706 L .44239 .47016 L p F P
0 0 0 r
s
.83 .24 .1 r
.44358 .46449 m
.44807 .48382 L
s
.747 .207 .089 r
.42189 .58042 m .44068 .57757 L .44317 .55676 L p F P
0 0 0 r
s
.747 .207 .089 r
.46126 .55397 m .44317 .55676 L .44068 .57757 L p F P
0 0 0 r
s
.83 .24 .1 r
.34612 .61 m
.3834 .60445 L
s
.34342 .63272 m
.34612 .61 L
s
.24 .35 .67 r
.6404 .48613 m
.64787 .50913 L
s
.64787 .50913 m
.66357 .52708 L
s
.322 .464 .871 r
.41169 .49865 m .41652 .50795 L .40799 .53023 L p F P
0 0 0 r
s
.323 .468 .885 r
.41652 .50795 m .41169 .49865 L .42277 .47719 L p F P
0 0 0 r
s
.323 .468 .885 r
.42277 .47719 m .42693 .48547 L .41652 .50795 L p F P
0 0 0 r
s
.882 .252 .108 r
.47125 .48708 m .48476 .48488 L .48728 .4627 L p F P
0 0 0 r
s
.882 .252 .108 r
.48728 .4627 m .47601 .46458 L .47125 .48708 L p F P
0 0 0 r
s
.822 .232 .1 r
.49807 .5048 m .48258 .50728 L .4808 .52951 L p F P
0 0 0 r
s
.853 .242 .104 r
.48258 .50728 m .49807 .5048 L .49831 .48267 L p F P
0 0 0 r
s
.853 .242 .104 r
.49831 .48267 m .48476 .48488 L .48258 .50728 L p F P
0 0 0 r
s
.24 .35 .67 r
.50645 .43843 m
.53431 .43372 L
s
.317 .455 .846 r
.40258 .52016 m .40799 .53023 L .40149 .55191 L p F P
0 0 0 r
s
.322 .464 .871 r
.40799 .53023 m .40258 .52016 L .41169 .49865 L p F P
0 0 0 r
s
.91 .262 .112 r
.45356 .4683 m .46477 .46644 L .47261 .44412 L p F P
0 0 0 r
s
.91 .262 .112 r
.47261 .44412 m .46389 .44559 L .45356 .4683 L p F P
0 0 0 r
s
.787 .22 .095 r
.46126 .55397 m .47945 .55116 L .4808 .52951 L p F P
0 0 0 r
s
.787 .22 .095 r
.49787 .52683 m .4808 .52951 L .47945 .55116 L p F P
0 0 0 r
s
.822 .232 .1 r
.4808 .52951 m .49787 .52683 L .49807 .5048 L p F P
0 0 0 r
s
.83 .24 .1 r
.45309 .51197 m
.49083 .50592 L
s
.321 .468 .89 r
.42693 .48547 m .42277 .47719 L .43564 .45617 L p F P
0 0 0 r
s
.321 .468 .89 r
.43564 .45617 m .43903 .46321 L .42693 .48547 L p F P
0 0 0 r
s
.24 .35 .67 r
.43133 .47804 m
.43569 .48683 L
s
.83 .24 .1 r
.43633 .45761 m
.44178 .45669 L
s
.40424 .463 m
.43458 .4579 L
s
.24 .35 .67 r
.43133 .47804 m
.44752 .46587 L
s
.44275 .698 m
.42951 .67808 L
s
.41777 .65834 m
.42951 .67808 L
s
.83 .24 .1 r
.3966 .43798 m
.35918 .4444 L
s
.35918 .4444 m
.35019 .42243 L
s
.26911 .64356 m
.26334 .66268 L
s
.30608 .63817 m
.26911 .64356 L
s
.882 .252 .108 r
.48476 .48488 m .49831 .48267 L .49859 .46083 L p F P
0 0 0 r
s
.882 .252 .108 r
.49859 .46083 m .48728 .4627 L .48476 .48488 L p F P
0 0 0 r
s
.83 .24 .1 r
.44807 .48382 m
.48583 .47763 L
s
.747 .207 .089 r
.44068 .57757 m .45956 .57471 L .46126 .55397 L p F P
0 0 0 r
s
.83 .24 .1 r
.42103 .57332 m
.45874 .56757 L
s
.45669 .54019 m
.45874 .56757 L
s
.747 .207 .089 r
.47945 .55116 m .46126 .55397 L .45956 .57471 L p F P
0 0 0 r
s
.7 .192 .083 r
.40129 .60259 m .42034 .59975 L .42189 .58042 L p F P
0 0 0 r
s
.7 .192 .083 r
.44068 .57757 m .42189 .58042 L .42034 .59975 L p F P
0 0 0 r
s
.24 .35 .67 r
.53016 .77082 m
.55768 .77285 L
s
.52037 .75287 m
.53016 .77082 L
s
.83 .24 .1 r
.48583 .47763 m
.49083 .50592 L
s
.91 .262 .112 r
.46477 .46644 m .47601 .46458 L .48135 .44264 L p F P
0 0 0 r
s
.91 .262 .112 r
.48135 .44264 m .47261 .44412 L .46477 .46644 L p F P
0 0 0 r
s
.822 .232 .1 r
.51362 .50231 m .49807 .5048 L .49787 .52683 L p F P
0 0 0 r
s
.853 .242 .104 r
.49807 .5048 m .51362 .50231 L .51192 .48045 L p F P
0 0 0 r
s
.853 .242 .104 r
.51192 .48045 m .49831 .48267 L .49807 .5048 L p F P
0 0 0 r
s
.83 .24 .1 r
.31276 .42897 m
.27572 .43545 L
s
.27572 .43545 m
.26498 .41761 L
s
.24 .35 .67 r
.67425 .54833 m
.6811 .57022 L
s
.6811 .57022 m
.6861 .59372 L
s
.67209 .68796 m
.67899 .70718 L
s
.66127 .72857 m
.67899 .70718 L
s
.83 .24 .1 r
.44178 .45669 m
.44328 .45644 L
s
.787 .22 .095 r
.47945 .55116 m .49772 .54834 L .49787 .52683 L p F P
0 0 0 r
s
.83 .24 .1 r
.49083 .50592 m
.49455 .53428 L
s
.45669 .54019 m
.49455 .53428 L
s
.787 .22 .095 r
.51502 .52413 m .49787 .52683 L .49772 .54834 L p F P
0 0 0 r
s
.822 .232 .1 r
.49787 .52683 m .51502 .52413 L .51362 .50231 L p F P
0 0 0 r
s
.882 .252 .108 r
.49831 .48267 m .51192 .48045 L .50993 .45894 L p F P
0 0 0 r
s
.882 .252 .108 r
.50993 .45894 m .49859 .46083 L .49831 .48267 L p F P
0 0 0 r
s
.307 .437 .803 r
.39564 .54133 m .40149 .55191 L .39716 .57261 L p F P
0 0 0 r
s
.317 .455 .846 r
.40149 .55191 m .39564 .54133 L .40258 .52016 L p F P
0 0 0 r
s
.24 .35 .67 r
.40008 .56666 m
.40954 .5429 L
s
.91 .262 .112 r
.47601 .46458 m .48728 .4627 L .49012 .44116 L p F P
0 0 0 r
s
.91 .262 .112 r
.49012 .44116 m .48135 .44264 L .47601 .46458 L p F P
0 0 0 r
s
.83 .24 .1 r
.4797 .45032 m
.48583 .47763 L
s
.24 .35 .67 r
.49453 .74552 m
.47206 .73327 L
s
.46112 .71456 m
.47206 .73327 L
s
.53431 .43372 m
.56192 .43375 L
s
.747 .207 .089 r
.45956 .57471 m .47854 .57184 L .47945 .55116 L p F P
0 0 0 r
s
.747 .207 .089 r
.49772 .54834 m .47945 .55116 L .47854 .57184 L p F P
0 0 0 r
s
.7 .192 .083 r
.42034 .59975 m .4395 .5969 L .44068 .57757 L p F P
0 0 0 r
s
.7 .192 .083 r
.45956 .57471 m .44068 .57757 L .4395 .5969 L p F P
0 0 0 r
s
.822 .232 .1 r
.52924 .49981 m .51362 .50231 L .51502 .52413 L p F P
0 0 0 r
s
.853 .242 .104 r
.51362 .50231 m .52924 .49981 L .52557 .47822 L p F P
0 0 0 r
s
.853 .242 .104 r
.52557 .47822 m .51192 .48045 L .51362 .50231 L p F P
0 0 0 r
s
.83 .24 .1 r
.38116 .62721 m
.3834 .60445 L
s
.317 .464 .889 r
.43903 .46321 m .43564 .45617 L .45006 .436 L p F P
0 0 0 r
s
.83 .24 .1 r
.44173 .45654 m
.44178 .45669 L
s
.317 .464 .889 r
.45006 .436 m .45263 .44156 L .43903 .46321 L p F P
0 0 0 r
s
.83 .24 .1 r
.44936 .45542 m
.4797 .45032 L
s
.91 .262 .112 r
.48728 .4627 m .49859 .46083 L .49891 .43968 L p F P
0 0 0 r
s
.91 .262 .112 r
.49891 .43968 m .49012 .44116 L .48728 .4627 L p F P
0 0 0 r
s
.882 .252 .108 r
.51192 .48045 m .52557 .47822 L .52131 .45705 L p F P
0 0 0 r
s
.882 .252 .108 r
.52131 .45705 m .50993 .45894 L .51192 .48045 L p F P
0 0 0 r
s
.24 .35 .67 r
.68511 .61862 m
.69177 .63921 L
s
.69177 .63921 m
.68485 .66408 L
s
.787 .22 .095 r
.49772 .54834 m .51609 .54551 L .51502 .52413 L p F P
0 0 0 r
s
.787 .22 .095 r
.53225 .52142 m .51502 .52413 L .51609 .54551 L p F P
0 0 0 r
s
.822 .232 .1 r
.51502 .52413 m .53225 .52142 L .52924 .49981 L p F P
0 0 0 r
s
.83 .24 .1 r
.49083 .50592 m
.52897 .49981 L
s
.642 .174 .075 r
.42034 .59975 m .40129 .60259 L .40159 .61991 L p F P
0 0 0 r
s
.24 .35 .67 r
.40825 .61275 m
.41008 .63586 L
s
.288 .406 .735 r
.40129 .60259 m .39511 .59192 L .39716 .57261 L p F P
0 0 0 r
s
.24 .35 .67 r
.40008 .56666 m
.4055 .5763 L
s
.257 .356 .631 r
.39511 .59192 m .40129 .60259 L .40159 .61991 L p F P
0 0 0 r
s
.83 .24 .1 r
.3834 .60445 m
.39752 .60234 L
s
.937 .271 .116 r
.45518 .44706 m .46389 .44559 L .4752 .42375 L p F P
0 0 0 r
s
.937 .271 .116 r
.4752 .42375 m .46921 .42478 L .45518 .44706 L p F P
0 0 0 r
s
.311 .457 .882 r
.45518 .44706 m .45263 .44156 L .4675 .42094 L p F P
0 0 0 r
s
.311 .457 .882 r
.4675 .42094 m .46921 .42478 L .45518 .44706 L p F P
0 0 0 r
s
.822 .232 .1 r
.54492 .4973 m .52924 .49981 L .53225 .52142 L p F P
0 0 0 r
s
.853 .242 .104 r
.52924 .49981 m .54492 .4973 L .53927 .47599 L p F P
0 0 0 r
s
.853 .242 .104 r
.53927 .47599 m .52557 .47822 L .52924 .49981 L p F P
0 0 0 r
s
.83 .24 .1 r
.3966 .43798 m
.388 .41582 L
s
.747 .207 .089 r
.47854 .57184 m .49762 .56895 L .49772 .54834 L p F P
0 0 0 r
s
.83 .24 .1 r
.45874 .56757 m
.49683 .56176 L
s
.49455 .53428 m
.49683 .56176 L
s
.747 .207 .089 r
.51609 .54551 m .49772 .54834 L .49762 .56895 L p F P
0 0 0 r
s
.83 .24 .1 r
.30083 .6573 m
.30608 .63817 L
s
.34342 .63272 m
.30608 .63817 L
s
.91 .262 .112 r
.49859 .46083 m .50993 .45894 L .50771 .43819 L p F P
0 0 0 r
s
.91 .262 .112 r
.50771 .43819 m .49891 .43968 L .49859 .46083 L p F P
0 0 0 r
s
.7 .192 .083 r
.4395 .5969 m .45876 .59403 L .45956 .57471 L p F P
0 0 0 r
s
.7 .192 .083 r
.47854 .57184 m .45956 .57471 L .45876 .59403 L p F P
0 0 0 r
s
.882 .252 .108 r
.52557 .47822 m .53927 .47599 L .53273 .45516 L p F P
0 0 0 r
s
.882 .252 .108 r
.53273 .45516 m .52131 .45705 L .52557 .47822 L p F P
0 0 0 r
s
.83 .24 .1 r
.48583 .47763 m
.52399 .47136 L
s
.52399 .47136 m
.52897 .49981 L
s
.322 .464 .871 r
.40677 .4892 m .41169 .49865 L .40258 .52016 L p F P
0 0 0 r
s
.323 .468 .885 r
.41169 .49865 m .40677 .4892 L .41856 .46878 L p F P
0 0 0 r
s
.323 .468 .885 r
.41856 .46878 m .42277 .47719 L .41169 .49865 L p F P
0 0 0 r
s
.24 .35 .67 r
.41223 .49814 m
.42247 .51787 L
s
.41223 .49814 m
.43133 .47804 L
s
.937 .271 .116 r
.46389 .44559 m .47261 .44412 L .4812 .42272 L p F P
0 0 0 r
s
.24 .35 .67 r
.47506 .43801 m
.47742 .44331 L
s
.937 .271 .116 r
.4812 .42272 m .4752 .42375 L .46389 .44559 L p F P
0 0 0 r
s
.83 .24 .1 r
.35019 .42243 m
.31276 .42897 L
s
.31276 .42897 m
.30249 .41095 L
s
.321 .468 .89 r
.42277 .47719 m .41856 .46878 L .4322 .44906 L p F P
0 0 0 r
s
.321 .468 .89 r
.4322 .44906 m .43564 .45617 L .42277 .47719 L p F P
0 0 0 r
s
.787 .22 .095 r
.51609 .54551 m .53454 .54266 L .53225 .52142 L p F P
0 0 0 r
s
.787 .22 .095 r
.54955 .5187 m .53225 .52142 L .53454 .54266 L p F P
0 0 0 r
s
.83 .24 .1 r
.49455 .53428 m
.53279 .5283 L
s
.822 .232 .1 r
.53225 .52142 m .54955 .5187 L .54492 .4973 L p F P
0 0 0 r
s
.83 .24 .1 r
.52897 .49981 m
.53279 .5283 L
s
.24 .35 .67 r
.55768 .77285 m
.58596 .76938 L
s
.54838 .75484 m
.55768 .77285 L
s
.91 .262 .112 r
.50993 .45894 m .52131 .45705 L .51654 .4367 L p F P
0 0 0 r
s
.91 .262 .112 r
.51654 .4367 m .50771 .43819 L .50993 .45894 L p F P
0 0 0 r
s
.822 .232 .1 r
.56067 .49478 m .54492 .4973 L .54955 .5187 L p F P
0 0 0 r
s
.853 .242 .104 r
.54492 .4973 m .56067 .49478 L .55303 .47374 L p F P
0 0 0 r
s
.853 .242 .104 r
.55303 .47374 m .53927 .47599 L .54492 .4973 L p F P
0 0 0 r
s
.937 .271 .116 r
.47261 .44412 m .48135 .44264 L .4872 .42169 L p F P
0 0 0 r
s
.937 .271 .116 r
.4872 .42169 m .4812 .42272 L .47261 .44412 L p F P
0 0 0 r
s
.83 .24 .1 r
.47262 .42494 m
.4797 .45032 L
s
.288 .406 .735 r
.391 .56176 m .39716 .57261 L .39511 .59192 L p F P
0 0 0 r
s
.307 .437 .803 r
.39716 .57261 m .391 .56176 L .39564 .54133 L p F P
0 0 0 r
s
.24 .35 .67 r
.39608 .59107 m
.40008 .56666 L
s
.65399 .70967 m
.66127 .72857 L
s
.6391 .74666 m
.66127 .72857 L
s
.41777 .65834 m
.41008 .63586 L
s
.642 .174 .075 r
.40159 .61991 m .42059 .61713 L .42034 .59975 L p F P
0 0 0 r
s
.642 .174 .075 r
.4395 .5969 m .42034 .59975 L .42059 .61713 L p F P
0 0 0 r
s
.83 .24 .1 r
.40086 .60185 m
.42107 .59883 L
s
.42103 .57332 m
.42107 .59883 L
s
.882 .252 .108 r
.53927 .47599 m .55303 .47374 L .54417 .45326 L p F P
0 0 0 r
s
.882 .252 .108 r
.54417 .45326 m .53273 .45516 L .53927 .47599 L p F P
0 0 0 r
s
.317 .455 .846 r
.39708 .50992 m .40258 .52016 L .39564 .54133 L p F P
0 0 0 r
s
.24 .35 .67 r
.39746 .52061 m
.40954 .5429 L
s
.322 .464 .871 r
.40258 .52016 m .39708 .50992 L .40677 .4892 L p F P
0 0 0 r
s
.747 .207 .089 r
.49762 .56895 m .5168 .56604 L .51609 .54551 L p F P
0 0 0 r
s
.747 .207 .089 r
.53454 .54266 m .51609 .54551 L .5168 .56604 L p F P
0 0 0 r
s
.7 .192 .083 r
.45876 .59403 m .47811 .59115 L .47854 .57184 L p F P
0 0 0 r
s
.7 .192 .083 r
.49762 .56895 m .47854 .57184 L .47811 .59115 L p F P
0 0 0 r
s
.91 .262 .112 r
.52131 .45705 m .53273 .45516 L .52539 .4352 L p F P
0 0 0 r
s
.91 .262 .112 r
.52539 .4352 m .51654 .4367 L .52131 .45705 L p F P
0 0 0 r
s
.83 .24 .1 r
.51802 .44389 m
.52399 .47136 L
s
.4797 .45032 m
.51802 .44389 L
s
.937 .271 .116 r
.48135 .44264 m .49012 .44116 L .49322 .42066 L p F P
0 0 0 r
s
.937 .271 .116 r
.49322 .42066 m .4872 .42169 L .48135 .44264 L p F P
0 0 0 r
s
.787 .22 .095 r
.53454 .54266 m .55309 .5398 L .54955 .5187 L p F P
0 0 0 r
s
.787 .22 .095 r
.56694 .51597 m .54955 .5187 L .55309 .5398 L p F P
0 0 0 r
s
.822 .232 .1 r
.54955 .5187 m .56694 .51597 L .56067 .49478 L p F P
0 0 0 r
s
.317 .464 .889 r
.43564 .45617 m .4322 .44906 L .44746 .4304 L p F P
0 0 0 r
s
.83 .24 .1 r
.4393 .4482 m
.43989 .45023 L
s
.3966 .43798 m
.43442 .43149 L
s
.317 .464 .889 r
.44746 .4304 m .45006 .436 L .43564 .45617 L p F P
0 0 0 r
s
.83 .24 .1 r
.43442 .43149 m
.43761 .44244 L
s
.822 .232 .1 r
.57648 .49224 m .56067 .49478 L .56694 .51597 L p F P
0 0 0 r
s
.853 .242 .104 r
.56067 .49478 m .57648 .49224 L .56683 .47149 L p F P
0 0 0 r
s
.853 .242 .104 r
.56683 .47149 m .55303 .47374 L .56067 .49478 L p F P
0 0 0 r
s
.83 .24 .1 r
.52897 .49981 m
.5675 .49364 L
s
.311 .457 .882 r
.45263 .44156 m .45006 .436 L .46578 .41707 L p F P
0 0 0 r
s
.311 .457 .882 r
.46578 .41707 m .4675 .42094 L .45263 .44156 L p F P
0 0 0 r
s
.882 .252 .108 r
.55303 .47374 m .56683 .47149 L .55566 .45135 L p F P
0 0 0 r
s
.882 .252 .108 r
.55566 .45135 m .54417 .45326 L .55303 .47374 L p F P
0 0 0 r
s
.24 .35 .67 r
.66357 .52708 m
.67425 .54833 L
s
.937 .271 .116 r
.49012 .44116 m .49891 .43968 L .49925 .41963 L p F P
0 0 0 r
s
.937 .271 .116 r
.49925 .41963 m .49322 .42066 L .49012 .44116 L p F P
0 0 0 r
s
.24 .35 .67 r
.4969 .41566 m
.4986 .41974 L
s
.91 .262 .112 r
.53273 .45516 m .54417 .45326 L .53426 .4337 L p F P
0 0 0 r
s
.91 .262 .112 r
.53426 .4337 m .52539 .4352 L .53273 .45516 L p F P
0 0 0 r
s
.83 .24 .1 r
.26498 .41761 m
.22786 .4242 L
s
.21593 .41113 m
.22786 .4242 L
s
.642 .174 .075 r
.42059 .61713 m .43968 .61433 L .4395 .5969 L p F P
0 0 0 r
s
.642 .174 .075 r
.45876 .59403 m .4395 .5969 L .43968 .61433 L p F P
0 0 0 r
s
.747 .207 .089 r
.5168 .56604 m .53608 .56312 L .53454 .54266 L p F P
0 0 0 r
s
.747 .207 .089 r
.55309 .5398 m .53454 .54266 L .53608 .56312 L p F P
0 0 0 r
s
.83 .24 .1 r
.53279 .5283 m
.53532 .55589 L
s
.49683 .56176 m
.53532 .55589 L
s
.46596 .42608 m
.47262 .42494 L
s
.43442 .43149 m
.45702 .42762 L
s
.24 .35 .67 r
.58596 .76938 m
.61357 .7605 L
s
.57718 .75122 m
.58596 .76938 L
s
.83 .24 .1 r
.33871 .65187 m
.34342 .63272 L
s
.38116 .62721 m
.34342 .63272 L
s
.7 .192 .083 r
.47811 .59115 m .49757 .58825 L .49762 .56895 L p F P
0 0 0 r
s
.7 .192 .083 r
.5168 .56604 m .49762 .56895 L .49757 .58825 L p F P
0 0 0 r
s
.24 .35 .67 r
.63136 .72805 m
.6391 .74666 L
s
.61357 .7605 m
.6391 .74666 L
s
.937 .271 .116 r
.49891 .43968 m .50771 .43819 L .50529 .41859 L p F P
0 0 0 r
s
.937 .271 .116 r
.50529 .41859 m .49925 .41963 L .49891 .43968 L p F P
0 0 0 r
s
.24 .35 .67 r
.46112 .71456 m
.44275 .698 L
s
.43113 .67842 m
.44275 .698 L
s
.787 .22 .095 r
.55309 .5398 m .57173 .53692 L .56694 .51597 L p F P
0 0 0 r
s
.787 .22 .095 r
.58441 .51322 m .56694 .51597 L .57173 .53692 L p F P
0 0 0 r
s
.83 .24 .1 r
.53279 .5283 m
.57143 .52226 L
s
.822 .232 .1 r
.56694 .51597 m .58441 .51322 L .57648 .49224 L p F P
0 0 0 r
s
.83 .24 .1 r
.5675 .49364 m
.57143 .52226 L
s
.853 .242 .104 r
.58069 .46923 m .56683 .47149 L .57648 .49224 L p F P
0 0 0 r
s
.882 .252 .108 r
.56683 .47149 m .58069 .46923 L .56718 .44943 L p F P
0 0 0 r
s
.882 .252 .108 r
.56718 .44943 m .55566 .45135 L .56683 .47149 L p F P
0 0 0 r
s
.83 .24 .1 r
.56254 .46504 m
.5675 .49364 L
s
.52399 .47136 m
.56254 .46504 L
s
.307 .437 .803 r
.38967 .53055 m .39564 .54133 L .391 .56176 L p F P
0 0 0 r
s
.317 .455 .846 r
.39564 .54133 m .38967 .53055 L .39708 .50992 L p F P
0 0 0 r
s
.822 .232 .1 r
.59236 .4897 m .57648 .49224 L .58441 .51322 L p F P
0 0 0 r
s
.853 .242 .104 r
.57648 .49224 m .59236 .4897 L .58069 .46923 L p F P
0 0 0 r
s
.83 .24 .1 r
.388 .41582 m
.35019 .42243 L
s
.35019 .42243 m
.3404 .40422 L
s
.91 .262 .112 r
.54417 .45326 m .55566 .45135 L .54315 .4322 L p F P
0 0 0 r
s
.91 .262 .112 r
.54315 .4322 m .53426 .4337 L .54417 .45326 L p F P
0 0 0 r
s
.24 .35 .67 r
.60532 .74214 m
.61357 .7605 L
s
.52037 .75287 m
.49453 .74552 L
s
.48393 .72687 m
.49453 .74552 L
s
.937 .271 .116 r
.50771 .43819 m .51654 .4367 L .51133 .41755 L p F P
0 0 0 r
s
.937 .271 .116 r
.51133 .41755 m .50529 .41859 L .50771 .43819 L p F P
0 0 0 r
s
.747 .207 .089 r
.53608 .56312 m .55545 .56018 L .55309 .5398 L p F P
0 0 0 r
s
.747 .207 .089 r
.57173 .53692 m .55309 .5398 L .55545 .56018 L p F P
0 0 0 r
s
.642 .174 .075 r
.43968 .61433 m .45888 .61151 L .45876 .59403 L p F P
0 0 0 r
s
.642 .174 .075 r
.47811 .59115 m .45876 .59403 L .45888 .61151 L p F P
0 0 0 r
s
.83 .24 .1 r
.42107 .59883 m
.45914 .59316 L
s
.45874 .56757 m
.45914 .59316 L
s
.24 .35 .67 r
.67927 .57204 m
.6861 .59372 L
s
.6861 .59372 m
.68511 .61862 L
s
.91 .262 .112 r
.55566 .45135 m .56718 .44943 L .55206 .4307 L p F P
0 0 0 r
s
.91 .262 .112 r
.55206 .4307 m .54315 .4322 L .55566 .45135 L p F P
0 0 0 r
s
.853 .242 .104 r
.5946 .46696 m .58069 .46923 L .59236 .4897 L p F P
0 0 0 r
s
.882 .252 .108 r
.58069 .46923 m .5946 .46696 L .57873 .44752 L p F P
0 0 0 r
s
.882 .252 .108 r
.57873 .44752 m .56718 .44943 L .58069 .46923 L p F P
0 0 0 r
s
.7 .192 .083 r
.49757 .58825 m .51714 .58533 L .5168 .56604 L p F P
0 0 0 r
s
.7 .192 .083 r
.53608 .56312 m .5168 .56604 L .51714 .58533 L p F P
0 0 0 r
s
.937 .271 .116 r
.51654 .4367 m .52539 .4352 L .51739 .41651 L p F P
0 0 0 r
s
.937 .271 .116 r
.51739 .41651 m .51133 .41755 L .51654 .4367 L p F P
0 0 0 r
s
.323 .468 .885 r
.41428 .46027 m .41856 .46878 L .40677 .4892 L p F P
0 0 0 r
s
.321 .468 .89 r
.41856 .46878 m .41428 .46027 L .42873 .44186 L p F P
0 0 0 r
s
.321 .468 .89 r
.42873 .44186 m .4322 .44906 L .41856 .46878 L p F P
0 0 0 r
s
.24 .35 .67 r
.678 .64378 m
.68485 .66408 L
s
.68485 .66408 m
.67209 .68796 L
s
.822 .232 .1 r
.58441 .51322 m .60196 .51046 L .59236 .4897 L p F P
0 0 0 r
s
.822 .232 .1 r
.60831 .48715 m .59236 .4897 L .60196 .51046 L p F P
0 0 0 r
s
.853 .242 .104 r
.59236 .4897 m .60831 .48715 L .5946 .46696 L p F P
0 0 0 r
s
.787 .22 .095 r
.57173 .53692 m .59047 .53403 L .58441 .51322 L p F P
0 0 0 r
s
.787 .22 .095 r
.60196 .51046 m .58441 .51322 L .59047 .53403 L p F P
0 0 0 r
s
.311 .457 .882 r
.45006 .436 m .44746 .4304 L .46405 .41318 L p F P
0 0 0 r
s
.311 .457 .882 r
.46405 .41318 m .46578 .41707 L .45006 .436 L p F P
0 0 0 r
s
.322 .464 .871 r
.40178 .4796 m .40677 .4892 L .39708 .50992 L p F P
0 0 0 r
s
.24 .35 .67 r
.39746 .52061 m
.41223 .49814 L
s
.323 .468 .885 r
.40677 .4892 m .40178 .4796 L .41428 .46027 L p F P
0 0 0 r
s
.568 .15 .065 r
.42059 .61713 m .40159 .61991 L .40415 .63484 L p F P
0 0 0 r
s
.24 .35 .67 r
.40741 .63133 m
.41008 .63586 L
s
.208 .282 .479 r
.39543 .60945 m .40159 .61991 L .40415 .63484 L p F P
0 0 0 r
s
.257 .356 .631 r
.40159 .61991 m .39543 .60945 L .39511 .59192 L p F P
0 0 0 r
s
.24 .35 .67 r
.39608 .59107 m
.40262 .60239 L
s
.962 .28 .12 r
.46921 .42478 m .4752 .42375 L .48731 .40323 L p F P
0 0 0 r
s
.962 .28 .12 r
.48731 .40323 m .48423 .40376 L .46921 .42478 L p F P
0 0 0 r
s
.304 .448 .87 r
.46921 .42478 m .4675 .42094 L .48338 .40176 L p F P
0 0 0 r
s
.304 .448 .87 r
.48338 .40176 m .48423 .40376 L .46921 .42478 L p F P
0 0 0 r
s
.24 .35 .67 r
.4686 .42347 m
.4705 .42774 L
s
.937 .271 .116 r
.52539 .4352 m .53426 .4337 L .52346 .41547 L p F P
0 0 0 r
s
.937 .271 .116 r
.52346 .41547 m .51739 .41651 L .52539 .4352 L p F P
0 0 0 r
s
.91 .262 .112 r
.56718 .44943 m .57873 .44752 L .561 .42919 L p F P
0 0 0 r
s
.24 .35 .67 r
.56192 .43375 m
.56242 .43384 L
s
.91 .262 .112 r
.561 .42919 m .55206 .4307 L .56718 .44943 L p F P
0 0 0 r
s
.83 .24 .1 r
.51802 .44389 m
.55673 .43739 L
s
.288 .406 .735 r
.39511 .59192 m .38881 .58104 L .391 .56176 L p F P
0 0 0 r
s
.257 .356 .631 r
.38881 .58104 m .39511 .59192 L .39543 .60945 L p F P
0 0 0 r
s
.83 .24 .1 r
.26334 .66268 m
.2555 .67739 L
s
.30083 .6573 m
.26334 .66268 L
s
.317 .464 .889 r
.4322 .44906 m .42873 .44186 L .44484 .42475 L p F P
0 0 0 r
s
.317 .464 .889 r
.44484 .42475 m .44746 .4304 L .4322 .44906 L p F P
0 0 0 r
s
.24 .35 .67 r
.44275 .43707 m
.45177 .45627 L
s
.853 .242 .104 r
.60856 .46468 m .5946 .46696 L .60831 .48715 L p F P
0 0 0 r
s
.882 .252 .108 r
.5946 .46696 m .60856 .46468 L .59032 .44559 L p F P
0 0 0 r
s
.882 .252 .108 r
.59032 .44559 m .57873 .44752 L .5946 .46696 L p F P
0 0 0 r
s
.962 .28 .12 r
.4752 .42375 m .4812 .42272 L .49038 .40269 L p F P
0 0 0 r
s
.962 .28 .12 r
.49038 .40269 m .48731 .40323 L .4752 .42375 L p F P
0 0 0 r
s
.747 .207 .089 r
.55545 .56018 m .57493 .55723 L .57173 .53692 L p F P
0 0 0 r
s
.747 .207 .089 r
.59047 .53403 m .57173 .53692 L .57493 .55723 L p F P
0 0 0 r
s
.83 .24 .1 r
.57143 .52226 m
.57422 .54996 L
s
.53532 .55589 m
.57422 .54996 L
s
.30249 .41095 m
.26498 .41761 L
s
.26498 .41761 m
.2536 .40437 L
s
.642 .174 .075 r
.45888 .61151 m .47818 .60869 L .47811 .59115 L p F P
0 0 0 r
s
.642 .174 .075 r
.49757 .58825 m .47811 .59115 L .47818 .60869 L p F P
0 0 0 r
s
.83 .24 .1 r
.37699 .64638 m
.38116 .62721 L
s
.38116 .62721 m
.40056 .62438 L
s
.937 .271 .116 r
.53426 .4337 m .54315 .4322 L .52954 .41443 L p F P
0 0 0 r
s
.937 .271 .116 r
.52954 .41443 m .52346 .41547 L .53426 .4337 L p F P
0 0 0 r
s
.24 .35 .67 r
.52523 .41078 m
.52686 .41489 L
s
.822 .232 .1 r
.60196 .51046 m .6196 .50769 L .60831 .48715 L p F P
0 0 0 r
s
.83 .24 .1 r
.5675 .49364 m
.60643 .48741 L
s
.822 .232 .1 r
.62433 .48458 m .60831 .48715 L .6196 .50769 L p F P
0 0 0 r
s
.853 .242 .104 r
.60831 .48715 m .62433 .48458 L .60856 .46468 L p F P
0 0 0 r
s
.7 .192 .083 r
.51714 .58533 m .5368 .58241 L .53608 .56312 L p F P
0 0 0 r
s
.7 .192 .083 r
.55545 .56018 m .53608 .56312 L .5368 .58241 L p F P
0 0 0 r
s
.83 .24 .1 r
.53532 .55589 m
.53646 .58164 L
s
.787 .22 .095 r
.59047 .53403 m .6093 .53112 L .60196 .51046 L p F P
0 0 0 r
s
.787 .22 .095 r
.6196 .50769 m .60196 .51046 L .6093 .53112 L p F P
0 0 0 r
s
.962 .28 .12 r
.4812 .42272 m .4872 .42169 L .49346 .40216 L p F P
0 0 0 r
s
.962 .28 .12 r
.49346 .40216 m .49038 .40269 L .4812 .42272 L p F P
0 0 0 r
s
.91 .262 .112 r
.57873 .44752 m .59032 .44559 L .56995 .42767 L p F P
0 0 0 r
s
.24 .35 .67 r
.5882 .43858 m
.5909 .44619 L
s
.56616 .43453 m
.57359 .43589 L
s
.58081 .43722 m
.5882 .43858 L
s
.91 .262 .112 r
.56995 .42767 m .561 .42919 L .57873 .44752 L p F P
0 0 0 r
s
.83 .24 .1 r
.55673 .43739 m
.56254 .46504 L
s
.317 .455 .846 r
.39148 .4995 m .39708 .50992 L .38967 .53055 L p F P
0 0 0 r
s
.322 .464 .871 r
.39708 .50992 m .39148 .4995 L .40178 .4796 L p F P
0 0 0 r
s
.24 .35 .67 r
.44275 .43707 m
.4686 .42347 L
s
.4686 .42347 m
.47873 .42001 L
s
.83 .24 .1 r
.42621 .40915 m
.388 .41582 L
s
.388 .41582 m
.37871 .39742 L
s
.962 .28 .12 r
.4872 .42169 m .49322 .42066 L .49653 .40162 L p F P
0 0 0 r
s
.962 .28 .12 r
.49653 .40162 m .49346 .40216 L .4872 .42169 L p F P
0 0 0 r
s
.853 .242 .104 r
.62257 .4624 m .60856 .46468 L .62433 .48458 L p F P
0 0 0 r
s
.24 .35 .67 r
.62352 .47439 m
.6404 .48613 L
s
.882 .252 .108 r
.60856 .46468 m .62257 .4624 L .60195 .44366 L p F P
0 0 0 r
s
.882 .252 .108 r
.60195 .44366 m .59032 .44559 L .60856 .46468 L p F P
0 0 0 r
s
.83 .24 .1 r
.6015 .45864 m
.60643 .48741 L
s
.56254 .46504 m
.6015 .45864 L
s
.937 .271 .116 r
.54315 .4322 m .55206 .4307 L .53562 .41338 L p F P
0 0 0 r
s
.937 .271 .116 r
.53562 .41338 m .52954 .41443 L .54315 .4322 L p F P
0 0 0 r
s
.568 .15 .065 r
.40415 .63484 m .42266 .63217 L .42059 .61713 L p F P
0 0 0 r
s
.83 .24 .1 r
.40209 .62416 m
.41929 .62165 L
s
.568 .15 .065 r
.43968 .61433 m .42059 .61713 L .42266 .63217 L p F P
0 0 0 r
s
.83 .24 .1 r
.41929 .62165 m
.42107 .59883 L
s
.288 .406 .735 r
.38472 .5507 m .391 .56176 L .38881 .58104 L p F P
0 0 0 r
s
.307 .437 .803 r
.391 .56176 m .38472 .5507 L .38967 .53055 L p F P
0 0 0 r
s
.304 .448 .87 r
.4675 .42094 m .46578 .41707 L .48253 .39976 L p F P
0 0 0 r
s
.304 .448 .87 r
.48253 .39976 m .48338 .40176 L .4675 .42094 L p F P
0 0 0 r
s
.83 .24 .1 r
.46978 .41673 m
.47262 .42494 L
s
.962 .28 .12 r
.49322 .42066 m .49925 .41963 L .49962 .40108 L p F P
0 0 0 r
s
.962 .28 .12 r
.49962 .40108 m .49653 .40162 L .49322 .42066 L p F P
0 0 0 r
s
.747 .207 .089 r
.57493 .55723 m .59451 .55427 L .59047 .53403 L p F P
0 0 0 r
s
.747 .207 .089 r
.6093 .53112 m .59047 .53403 L .59451 .55427 L p F P
0 0 0 r
s
.91 .262 .112 r
.59032 .44559 m .60195 .44366 L .57893 .42616 L p F P
0 0 0 r
s
.91 .262 .112 r
.57893 .42616 m .56995 .42767 L .59032 .44559 L p F P
0 0 0 r
s
.822 .232 .1 r
.6196 .50769 m .63731 .50491 L .62433 .48458 L p F P
0 0 0 r
s
.822 .232 .1 r
.64041 .482 m .62433 .48458 L .63731 .50491 L p F P
0 0 0 r
s
.24 .35 .67 r
.64001 .48495 m
.6404 .48613 L
s
.853 .242 .104 r
.62433 .48458 m .64041 .482 L .62257 .4624 L p F P
0 0 0 r
s
.642 .174 .075 r
.47818 .60869 m .49758 .60584 L .49757 .58825 L p F P
0 0 0 r
s
.642 .174 .075 r
.51714 .58533 m .49757 .58825 L .49758 .60584 L p F P
0 0 0 r
s
.83 .24 .1 r
.45914 .59316 m
.4976 .58743 L
s
.49683 .56176 m
.4976 .58743 L
s
.937 .271 .116 r
.55206 .4307 m .561 .42919 L .54172 .41234 L p F P
0 0 0 r
s
.937 .271 .116 r
.54172 .41234 m .53562 .41338 L .55206 .4307 L p F P
0 0 0 r
s
.787 .22 .095 r
.6093 .53112 m .62822 .5282 L .6196 .50769 L p F P
0 0 0 r
s
.83 .24 .1 r
.60643 .48741 m
.61048 .51616 L
s
.57143 .52226 m
.61048 .51616 L
s
.787 .22 .095 r
.63731 .50491 m .6196 .50769 L .62822 .5282 L p F P
0 0 0 r
s
.311 .457 .882 r
.44746 .4304 m .44484 .42475 L .46231 .40926 L p F P
0 0 0 r
s
.311 .457 .882 r
.46231 .40926 m .46405 .41318 L .44746 .4304 L p F P
0 0 0 r
s
.7 .192 .083 r
.5368 .58241 m .55657 .57946 L .55545 .56018 L p F P
0 0 0 r
s
.7 .192 .083 r
.57493 .55723 m .55545 .56018 L .55657 .57946 L p F P
0 0 0 r
s
.962 .28 .12 r
.49925 .41963 m .50529 .41859 L .5027 .40055 L p F P
0 0 0 r
s
.962 .28 .12 r
.5027 .40055 m .49962 .40108 L .49925 .41963 L p F P
0 0 0 r
s
.189 .292 .609 r
.59945 .4364 m .60195 .44366 L .62257 .4624 L p F P
0 0 0 r
s
.189 .292 .609 r
.62257 .4624 m .61971 .45379 L .59945 .4364 L p F P
0 0 0 r
s
.83 .24 .1 r
.6015 .45864 m
.61647 .45619 L
s
.146 .23 .499 r
.61971 .45379 m .62257 .4624 L .64041 .482 L p F P
0 0 0 r
s
.24 .35 .67 r
.43113 .67842 m
.41777 .65834 L
s
.962 .28 .12 r
.50529 .41859 m .51133 .41755 L .50579 .40001 L p F P
0 0 0 r
s
.83 .24 .1 r
.51123 .41832 m
.51802 .44389 L
s
.962 .28 .12 r
.50579 .40001 m .5027 .40055 L .50529 .41859 L p F P
0 0 0 r
s
.83 .24 .1 r
.47262 .42494 m
.51123 .41832 L
s
.937 .271 .116 r
.561 .42919 m .56995 .42767 L .54783 .41129 L p F P
0 0 0 r
s
.24 .35 .67 r
.5594 .42702 m
.55983 .42817 L
s
.937 .271 .116 r
.54783 .41129 m .54172 .41234 L .561 .42919 L p F P
0 0 0 r
s
.222 .338 .69 r
.57689 .42047 m .57893 .42616 L .60195 .44366 L p F P
0 0 0 r
s
.222 .338 .69 r
.60195 .44366 m .59945 .4364 L .57689 .42047 L p F P
0 0 0 r
s
.83 .24 .1 r
.59237 .4314 m
.59585 .43082 L
s
.55673 .43739 m
.58796 .43214 L
s
.59585 .43082 m
.59657 .43437 L
s
.59748 .43881 m
.6015 .45864 L
s
.568 .15 .065 r
.42266 .63217 m .44126 .62948 L .43968 .61433 L p F P
0 0 0 r
s
.568 .15 .065 r
.45888 .61151 m .43968 .61433 L .44126 .62948 L p F P
0 0 0 r
s
.822 .232 .1 r
.63731 .50491 m .65511 .50211 L .64041 .482 L p F P
0 0 0 r
s
.146 .23 .499 r
.64041 .482 m .63727 .47229 L .61971 .45379 L p F P
0 0 0 r
s
.83 .24 .1 r
.62124 .4554 m
.64086 .45218 L
s
.11 .17 .391 r
.63727 .47229 m .64041 .482 L .65511 .50211 L p F P
0 0 0 r
s
.83 .24 .1 r
.60643 .48741 m
.64074 .48191 L
s
.64283 .48158 m
.64577 .4811 L
s
.24 .35 .67 r
.54838 .75484 m
.52037 .75287 L
s
.5102 .73421 m
.52037 .75287 L
s
.962 .28 .12 r
.51133 .41755 m .51739 .41651 L .50888 .39947 L p F P
0 0 0 r
s
.962 .28 .12 r
.50888 .39947 m .50579 .40001 L .51133 .41755 L p F P
0 0 0 r
s
.83 .24 .1 r
.29358 .672 m
.30083 .6573 L
s
.33871 .65187 m
.30083 .6573 L
s
.747 .207 .089 r
.59451 .55427 m .6142 .55128 L .6093 .53112 L p F P
0 0 0 r
s
.747 .207 .089 r
.62822 .5282 m .6093 .53112 L .6142 .55128 L p F P
0 0 0 r
s
.83 .24 .1 r
.61048 .51616 m
.61352 .54397 L
s
.57422 .54996 m
.61352 .54397 L
s
.304 .448 .87 r
.46578 .41707 m .46405 .41318 L .48168 .39775 L p F P
0 0 0 r
s
.304 .448 .87 r
.48168 .39775 m .48253 .39976 L .46578 .41707 L p F P
0 0 0 r
s
.323 .468 .885 r
.40995 .45163 m .41428 .46027 L .40178 .4796 L p F P
0 0 0 r
s
.321 .468 .89 r
.41428 .46027 m .40995 .45163 L .42521 .43458 L p F P
0 0 0 r
s
.321 .468 .89 r
.42521 .43458 m .42873 .44186 L .41428 .46027 L p F P
0 0 0 r
s
.24 .35 .67 r
.4196 .45435 m
.43133 .47804 L
s
.937 .271 .116 r
.56995 .42767 m .57893 .42616 L .55395 .41024 L p F P
0 0 0 r
s
.937 .271 .116 r
.55395 .41024 m .54783 .41129 L .56995 .42767 L p F P
0 0 0 r
s
.83 .24 .1 r
.3404 .40422 m
.30249 .41095 L
s
.30249 .41095 m
.29167 .39753 L
s
.787 .22 .095 r
.62822 .5282 m .64724 .52527 L .63731 .50491 L p F P
0 0 0 r
s
.787 .22 .095 r
.65511 .50211 m .63731 .50491 L .64724 .52527 L p F P
0 0 0 r
s
.642 .174 .075 r
.49758 .60584 m .51708 .60299 L .51714 .58533 L p F P
0 0 0 r
s
.642 .174 .075 r
.5368 .58241 m .51714 .58533 L .51708 .60299 L p F P
0 0 0 r
s
.307 .437 .803 r
.38359 .51957 m .38967 .53055 L .38472 .5507 L p F P
0 0 0 r
s
.24 .35 .67 r
.3877 .54463 m
.40008 .56666 L
s
.317 .455 .846 r
.38967 .53055 m .38359 .51957 L .39148 .4995 L p F P
0 0 0 r
s
.24 .35 .67 r
.3877 .54463 m
.39746 .52061 L
s
.317 .464 .889 r
.42873 .44186 m .42521 .43458 L .44219 .41904 L p F P
0 0 0 r
s
.317 .464 .889 r
.44219 .41904 m .44484 .42475 L .42873 .44186 L p F P
0 0 0 r
s
.83 .24 .1 r
.42621 .40915 m
.43295 .4275 L
s
.24 .35 .67 r
.4196 .45435 m
.44275 .43707 L
s
.962 .28 .12 r
.51739 .41651 m .52346 .41547 L .51197 .39893 L p F P
0 0 0 r
s
.24 .35 .67 r
.51458 .41088 m
.5156 .4107 L
s
.962 .28 .12 r
.51197 .39893 m .50888 .39947 L .51739 .41651 L p F P
0 0 0 r
s
.7 .192 .083 r
.55657 .57946 m .57645 .5765 L .57493 .55723 L p F P
0 0 0 r
s
.7 .192 .083 r
.59451 .55427 m .57493 .55723 L .57645 .5765 L p F P
0 0 0 r
s
.83 .24 .1 r
.57422 .54996 m
.57573 .57579 L
s
.24 .35 .67 r
.67425 .54833 m
.67927 .57204 L
s
.66493 .66798 m
.67209 .68796 L
s
.67209 .68796 m
.65399 .70967 L
s
.83 .24 .1 r
.64577 .4811 m
.64679 .4882 L
s
.64086 .45218 m
.64577 .4811 L
s
.247 .373 .75 r
.55248 .4063 m .55395 .41024 L .57893 .42616 L p F P
0 0 0 r
s
.247 .373 .75 r
.57893 .42616 m .57689 .42047 L .55248 .4063 L p F P
0 0 0 r
s
.83 .24 .1 r
.55024 .41163 m
.55673 .43739 L
s
.962 .28 .12 r
.52346 .41547 m .52954 .41443 L .51506 .39839 L p F P
0 0 0 r
s
.24 .35 .67 r
.51966 .41 m
.52068 .40982 L
s
.962 .28 .12 r
.51506 .39839 m .51197 .39893 L .52346 .41547 L p F P
0 0 0 r
s
.24 .35 .67 r
.48393 .72687 m
.46112 .71456 L
s
.44974 .69509 m
.46112 .71456 L
s
.322 .464 .871 r
.39671 .46985 m .40178 .4796 L .39148 .4995 L p F P
0 0 0 r
s
.323 .468 .885 r
.40178 .4796 m .39671 .46985 L .40995 .45163 L p F P
0 0 0 r
s
.24 .35 .67 r
.40006 .47471 m
.41223 .49814 L
s
.40006 .47471 m
.4196 .45435 L
s
.568 .15 .065 r
.44126 .62948 m .45996 .62678 L .45888 .61151 L p F P
0 0 0 r
s
.83 .24 .1 r
.41929 .62165 m
.45782 .61602 L
s
.568 .15 .065 r
.47818 .60869 m .45888 .61151 L .45996 .62678 L p F P
0 0 0 r
s
.83 .24 .1 r
.45782 .61602 m
.45914 .59316 L
s
.962 .28 .12 r
.52954 .41443 m .53562 .41338 L .51816 .39786 L p F P
0 0 0 r
s
.24 .35 .67 r
.52477 .40915 m
.52591 .40914 L
s
.962 .28 .12 r
.51816 .39786 m .51506 .39839 L .52954 .41443 L p F P
0 0 0 r
s
.747 .207 .089 r
.6142 .55128 m .63398 .54829 L .62822 .5282 L p F P
0 0 0 r
s
.747 .207 .089 r
.64724 .52527 m .62822 .5282 L .63398 .54829 L p F P
0 0 0 r
s
.311 .457 .882 r
.44484 .42475 m .44219 .41904 L .46056 .40532 L p F P
0 0 0 r
s
.311 .457 .882 r
.46056 .40532 m .46231 .40926 L .44484 .42475 L p F P
0 0 0 r
s
.83 .24 .1 r
.68064 .44566 m
.64086 .45218 L
s
.787 .22 .095 r
.64724 .52527 m .66636 .52232 L .65511 .50211 L p F P
0 0 0 r
s
.83 .24 .1 r
.61048 .51616 m
.64994 .51 L
s
.24 .35 .67 r
.66226 .52295 m
.66357 .52708 L
s
.11 .17 .391 r
.65511 .50211 m .65177 .49155 L .63727 .47229 L p F P
0 0 0 r
s
.83 .24 .1 r
.64713 .49055 m
.64994 .51 L
s
.64577 .4811 m
.68552 .47474 L
s
.077 .112 .279 r
.65177 .49155 m .65511 .50211 L .66636 .52232 L p F P
0 0 0 r
s
.962 .28 .12 r
.53562 .41338 m .54172 .41234 L .52126 .39732 L p F P
0 0 0 r
s
.962 .28 .12 r
.52126 .39732 m .51816 .39786 L .53562 .41338 L p F P
0 0 0 r
s
.642 .174 .075 r
.51708 .60299 m .53669 .60011 L .5368 .58241 L p F P
0 0 0 r
s
.83 .24 .1 r
.4976 .58743 m
.53646 .58164 L
s
.642 .174 .075 r
.55657 .57946 m .5368 .58241 L .53669 .60011 L p F P
0 0 0 r
s
.304 .448 .87 r
.46405 .41318 m .46231 .40926 L .48082 .39573 L p F P
0 0 0 r
s
.83 .24 .1 r
.46736 .40973 m
.46751 .41015 L
s
.304 .448 .87 r
.48082 .39573 m .48168 .39775 L .46405 .41318 L p F P
0 0 0 r
s
.7 .192 .083 r
.57645 .5765 m .59643 .57353 L .59451 .55427 L p F P
0 0 0 r
s
.7 .192 .083 r
.6142 .55128 m .59451 .55427 L .59643 .57353 L p F P
0 0 0 r
s
.24 .35 .67 r
.67819 .5972 m
.68511 .61862 L
s
.68511 .61862 m
.678 .64378 L
s
.208 .282 .479 r
.40415 .63484 m .39818 .6248 L .39543 .60945 L p F P
0 0 0 r
s
.208 .282 .479 r
.38915 .59877 m .39543 .60945 L .39818 .6248 L p F P
0 0 0 r
s
.24 .35 .67 r
.39786 .61514 m
.40342 .62456 L
s
.39608 .59107 m
.39786 .61514 L
s
.257 .356 .631 r
.39543 .60945 m .38915 .59877 L .38881 .58104 L p F P
0 0 0 r
s
.83 .24 .1 r
.64994 .51 m
.65888 .5086 L
s
.962 .28 .12 r
.54172 .41234 m .54783 .41129 L .52436 .39678 L p F P
0 0 0 r
s
.962 .28 .12 r
.52436 .39678 m .52126 .39732 L .54172 .41234 L p F P
0 0 0 r
s
.83 .24 .1 r
.51123 .41832 m
.55024 .41163 L
s
.288 .406 .735 r
.38881 .58104 m .38238 .56995 L .38472 .5507 L p F P
0 0 0 r
s
.257 .356 .631 r
.38238 .56995 m .38881 .58104 L .38915 .59877 L p F P
0 0 0 r
s
.568 .15 .065 r
.45996 .62678 m .47876 .62407 L .47818 .60869 L p F P
0 0 0 r
s
.568 .15 .065 r
.49758 .60584 m .47818 .60869 L .47876 .62407 L p F P
0 0 0 r
s
.962 .28 .12 r
.54783 .41129 m .55395 .41024 L .52747 .39623 L p F P
0 0 0 r
s
.962 .28 .12 r
.52747 .39623 m .52436 .39678 L .54783 .41129 L p F P
0 0 0 r
s
.222 .338 .69 r
.57483 .41472 m .57689 .42047 L .59945 .4364 L p F P
0 0 0 r
s
.222 .338 .69 r
.59945 .4364 m .59691 .42906 L .57483 .41472 L p F P
0 0 0 r
s
.189 .292 .609 r
.59691 .42906 m .59945 .4364 L .61971 .45379 L p F P
0 0 0 r
s
.317 .455 .846 r
.38578 .48889 m .39148 .4995 L .38359 .51957 L p F P
0 0 0 r
s
.322 .464 .871 r
.39148 .4995 m .38578 .48889 L .39671 .46985 L p F P
0 0 0 r
s
.747 .207 .089 r
.63398 .54829 m .65388 .54527 L .64724 .52527 L p F P
0 0 0 r
s
.747 .207 .089 r
.66636 .52232 m .64724 .52527 L .65388 .54527 L p F P
0 0 0 r
s
.83 .24 .1 r
.61352 .54397 m
.65324 .53791 L
s
.33207 .66656 m
.33871 .65187 L
s
.37699 .64638 m
.33871 .65187 L
s
.467 .119 .052 r
.42266 .63217 m .40415 .63484 L .40901 .64701 L p F P
0 0 0 r
s
.162 .212 .366 r
.39818 .6248 m .40415 .63484 L .40901 .64701 L p F P
0 0 0 r
s
.189 .292 .609 r
.61971 .45379 m .6168 .44506 L .59691 .42906 L p F P
0 0 0 r
s
.24 .35 .67 r
.61212 .44816 m
.61523 .45739 L
s
.595 .4413 m
.61212 .44816 L
s
.83 .24 .1 r
.59854 .43037 m
.63539 .42418 L
s
.146 .23 .499 r
.6168 .44506 m .61971 .45379 L .63727 .47229 L p F P
0 0 0 r
s
.83 .24 .1 r
.63539 .42418 m
.64086 .45218 L
s
.986 .289 .124 r
.5 .38446 m .48423 .40376 L .48731 .40323 L closepath p F P
0 0 0 r
s
.294 .436 .852 r
.5 .38446 m .48423 .40376 L .48338 .40176 L closepath p F P
0 0 0 r
s
.267 .399 .794 r
.52668 .39421 m .52747 .39623 L .55395 .41024 L p F P
0 0 0 r
s
.267 .399 .794 r
.55395 .41024 m .55248 .4063 L .52668 .39421 L p F P
0 0 0 r
s
.83 .24 .1 r
.37871 .39742 m
.3404 .40422 L
s
.3404 .40422 m
.33015 .39061 L
s
.642 .174 .075 r
.53669 .60011 m .5564 .59723 L .55657 .57946 L p F P
0 0 0 r
s
.642 .174 .075 r
.57645 .5765 m .55657 .57946 L .5564 .59723 L p F P
0 0 0 r
s
.24 .35 .67 r
.57718 .75122 m
.54838 .75484 L
s
.5387 .7361 m
.54838 .75484 L
s
.247 .373 .75 r
.551 .40235 m .55248 .4063 L .57689 .42047 L p F P
0 0 0 r
s
.247 .373 .75 r
.57689 .42047 m .57483 .41472 L .551 .40235 L p F P
0 0 0 r
s
.24 .35 .67 r
.55267 .40902 m
.55431 .41339 L
s
.54233 .40907 m
.55267 .40902 L
s
.83 .24 .1 r
.55024 .41163 m
.55706 .41046 L
s
.986 .289 .124 r
.5 .38446 m .48731 .40323 L .49038 .40269 L closepath p F P
0 0 0 r
s
.7 .192 .083 r
.59643 .57353 m .61652 .57054 L .6142 .55128 L p F P
0 0 0 r
s
.7 .192 .083 r
.63398 .54829 m .6142 .55128 L .61652 .57054 L p F P
0 0 0 r
s
.83 .24 .1 r
.61352 .54397 m
.61542 .56987 L
s
.2536 .40437 m
.21593 .41113 L
s
.20372 .40341 m
.21593 .41113 L
s
.304 .448 .87 r
.46231 .40926 m .46056 .40532 L .47996 .39371 L p F P
0 0 0 r
s
.83 .24 .1 r
.46606 .40596 m
.46621 .40641 L
s
.304 .448 .87 r
.47996 .39371 m .48082 .39573 L .46231 .40926 L p F P
0 0 0 r
s
.83 .24 .1 r
.46482 .4024 m
.46493 .40271 L
s
.42621 .40915 m
.46482 .4024 L
s
.321 .468 .89 r
.42165 .42722 m .42521 .43458 L .40995 .45163 L p F P
0 0 0 r
s
.317 .464 .889 r
.42521 .43458 m .42165 .42722 L .43952 .41329 L p F P
0 0 0 r
s
.317 .464 .889 r
.43952 .41329 m .44219 .41904 L .42521 .43458 L p F P
0 0 0 r
s
.986 .289 .124 r
.5 .38446 m .49038 .40269 L .49346 .40216 L closepath p F P
0 0 0 r
s
.288 .406 .735 r
.37832 .53942 m .38472 .5507 L .38238 .56995 L p F P
0 0 0 r
s
.307 .437 .803 r
.38472 .5507 m .37832 .53942 L .38359 .51957 L p F P
0 0 0 r
s
.24 .35 .67 r
.38349 .56929 m
.3877 .54463 L
s
.83 .24 .1 r
.68981 .50376 m
.68552 .47474 L
s
.72569 .4683 m
.68552 .47474 L
s
.68552 .47474 m
.68064 .44566 L
s
.24 .35 .67 r
.64642 .69 m
.65399 .70967 L
s
.65399 .70967 m
.63136 .72805 L
s
.986 .289 .124 r
.5 .38446 m .49346 .40216 L .49653 .40162 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.46482 .4024 m
.4657 .40224 L
s
.311 .457 .882 r
.44219 .41904 m .43952 .41329 L .4588 .40136 L p F P
0 0 0 r
s
.311 .457 .882 r
.4588 .40136 m .46056 .40532 L .44219 .41904 L p F P
0 0 0 r
s
.294 .436 .852 r
.5 .38446 m .48338 .40176 L .48253 .39976 L closepath p F P
0 0 0 r
s
.568 .15 .065 r
.47876 .62407 m .49764 .62134 L .49758 .60584 L p F P
0 0 0 r
s
.83 .24 .1 r
.45782 .61602 m
.49676 .61034 L
s
.568 .15 .065 r
.51708 .60299 m .49758 .60584 L .49764 .62134 L p F P
0 0 0 r
s
.83 .24 .1 r
.49676 .61034 m
.4976 .58743 L
s
.986 .289 .124 r
.5 .38446 m .49653 .40162 L .49962 .40108 L closepath p F P
0 0 0 r
s
.323 .468 .885 r
.40555 .44287 m .40995 .45163 L .39671 .46985 L p F P
0 0 0 r
s
.321 .468 .89 r
.40995 .45163 m .40555 .44287 L .42165 .42722 L p F P
0 0 0 r
s
.747 .207 .089 r
.65388 .54527 m .67387 .54224 L .66636 .52232 L p F P
0 0 0 r
s
.24 .35 .67 r
.67242 .54246 m
.67425 .54833 L
s
.077 .112 .279 r
.66636 .52232 m .66287 .51118 L .65177 .49155 L p F P
0 0 0 r
s
.83 .24 .1 r
.64994 .51 m
.65324 .53791 L
s
.66121 .50823 m
.68981 .50376 L
s
.24 .35 .67 r
.65632 .50418 m
.65798 .50941 L
s
.64557 .49199 m
.65632 .50418 L
s
.054 .079 .187 r
.66287 .51118 m .66636 .52232 L .67387 .54224 L p F P
0 0 0 r
s
.986 .289 .124 r
.5 .38446 m .49962 .40108 L .5027 .40055 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.67534 .41747 m
.63539 .42418 L
s
.63539 .42418 m
.62951 .39803 L
s
.146 .23 .499 r
.63727 .47229 m .63407 .46242 L .6168 .44506 L p F P
0 0 0 r
s
.11 .17 .391 r
.63407 .46242 m .63727 .47229 L .65177 .49155 L p F P
0 0 0 r
s
.83 .24 .1 r
.72084 .43906 m
.68064 .44566 L
s
.68064 .44566 m
.67534 .41747 L
s
.467 .119 .052 r
.40901 .64701 m .42659 .6445 L .42266 .63217 L p F P
0 0 0 r
s
.24 .35 .67 r
.41087 .64674 m
.41777 .65834 L
s
.83 .24 .1 r
.41568 .64083 m
.41929 .62165 L
s
.467 .119 .052 r
.44126 .62948 m .42266 .63217 L .42659 .6445 L p F P
0 0 0 r
s
.986 .289 .124 r
.5 .38446 m .5027 .40055 L .50579 .40001 L closepath p F P
0 0 0 r
s
.642 .174 .075 r
.5564 .59723 m .57621 .59432 L .57645 .5765 L p F P
0 0 0 r
s
.83 .24 .1 r
.53646 .58164 m
.57573 .57579 L
s
.642 .174 .075 r
.59643 .57353 m .57645 .5765 L .57621 .59432 L p F P
0 0 0 r
s
.986 .289 .124 r
.5 .38446 m .50579 .40001 L .50888 .39947 L closepath p F P
0 0 0 r
s
.294 .436 .852 r
.5 .38446 m .48253 .39976 L .48168 .39775 L closepath p F P
0 0 0 r
s
.267 .399 .794 r
.52589 .39218 m .52668 .39421 L .55248 .4063 L p F P
0 0 0 r
s
.267 .399 .794 r
.55248 .4063 m .551 .40235 L .52589 .39218 L p F P
0 0 0 r
s
.83 .24 .1 r
.54771 .40327 m
.55024 .41163 L
s
.7 .192 .083 r
.61652 .57054 m .63671 .56753 L .63398 .54829 L p F P
0 0 0 r
s
.7 .192 .083 r
.65388 .54527 m .63398 .54829 L .63671 .56753 L p F P
0 0 0 r
s
.986 .289 .124 r
.5 .38446 m .50888 .39947 L .51197 .39893 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.69337 .53179 m
.68981 .50376 L
s
.7301 .49747 m
.68981 .50376 L
s
.986 .289 .124 r
.5 .38446 m .51197 .39893 L .51506 .39839 L closepath p F P
0 0 0 r
s
.304 .448 .87 r
.46056 .40532 m .4588 .40136 L .47909 .39168 L p F P
0 0 0 r
s
.83 .24 .1 r
.46475 .40224 m
.46482 .4024 L
s
.304 .448 .87 r
.47909 .39168 m .47996 .39371 L .46056 .40532 L p F P
0 0 0 r
s
.986 .289 .124 r
.5 .38446 m .51506 .39839 L .51816 .39786 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.60532 .74214 m
.57718 .75122 L
s
.56804 .73233 m
.57718 .75122 L
s
.322 .464 .871 r
.39155 .45994 m .39671 .46985 L .38578 .48889 L p F P
0 0 0 r
s
.323 .468 .885 r
.39671 .46985 m .39155 .45994 L .40555 .44287 L p F P
0 0 0 r
s
.568 .15 .065 r
.49764 .62134 m .51663 .6186 L .51708 .60299 L p F P
0 0 0 r
s
.568 .15 .065 r
.53669 .60011 m .51708 .60299 L .51663 .6186 L p F P
0 0 0 r
s
.307 .437 .803 r
.3774 .50838 m .38359 .51957 L .37832 .53942 L p F P
0 0 0 r
s
.317 .455 .846 r
.38359 .51957 m .3774 .50838 L .38578 .48889 L p F P
0 0 0 r
s
.83 .24 .1 r
.65324 .53791 m
.67124 .53516 L
s
.986 .289 .124 r
.5 .38446 m .51816 .39786 L .52126 .39732 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.62331 .70869 m
.63136 .72805 L
s
.63136 .72805 m
.60532 .74214 L
s
.294 .436 .852 r
.5 .38446 m .48168 .39775 L .48082 .39573 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.37098 .66105 m
.37699 .64638 L
s
.37699 .64638 m
.40664 .64213 L
s
.247 .373 .75 r
.54951 .39836 m .551 .40235 L .57483 .41472 L p F P
0 0 0 r
s
.247 .373 .75 r
.57483 .41472 m .57276 .40893 L .54951 .39836 L p F P
0 0 0 r
s
.83 .24 .1 r
.5709 .40808 m
.58967 .40486 L
s
.222 .338 .69 r
.57276 .40893 m .57483 .41472 L .59691 .42906 L p F P
0 0 0 r
s
.24 .35 .67 r
.44974 .69509 m
.43113 .67842 L
s
.41905 .65806 m
.43113 .67842 L
s
.986 .289 .124 r
.5 .38446 m .52126 .39732 L .52436 .39678 L closepath p F P
0 0 0 r
s
.467 .119 .052 r
.42659 .6445 m .44426 .64198 L .44126 .62948 L p F P
0 0 0 r
s
.467 .119 .052 r
.45996 .62678 m .44126 .62948 L .44426 .64198 L p F P
0 0 0 r
s
.222 .338 .69 r
.59691 .42906 m .59435 .42162 L .57276 .40893 L p F P
0 0 0 r
s
.83 .24 .1 r
.58967 .40486 m
.59355 .42115 L
s
.189 .292 .609 r
.59435 .42162 m .59691 .42906 L .6168 .44506 L p F P
0 0 0 r
s
.83 .24 .1 r
.41742 .39055 m
.37871 .39742 L
s
.37871 .39742 m
.36905 .38363 L
s
.986 .289 .124 r
.5 .38446 m .52436 .39678 L .52747 .39623 L closepath p F P
0 0 0 r
s
.642 .174 .075 r
.57621 .59432 m .59613 .5914 L .59643 .57353 L p F P
0 0 0 r
s
.642 .174 .075 r
.61652 .57054 m .59643 .57353 L .59613 .5914 L p F P
0 0 0 r
s
.24 .35 .67 r
.59673 .72305 m
.60532 .74214 L
s
.7 .192 .083 r
.63671 .56753 m .65702 .56451 L .65388 .54527 L p F P
0 0 0 r
s
.7 .192 .083 r
.67387 .54224 m .65388 .54527 L .65702 .56451 L p F P
0 0 0 r
s
.83 .24 .1 r
.65324 .53791 m
.65553 .56389 L
s
.282 .42 .827 r
.52747 .39623 m .52668 .39421 L .5 .38446 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.50384 .39558 m
.51123 .41832 L
s
.24 .35 .67 r
.5102 .73421 m
.48393 .72687 L
s
.4729 .70746 m
.48393 .72687 L
s
.83 .24 .1 r
.29167 .39753 m
.2536 .40437 L
s
.2536 .40437 m
.242 .39647 L
s
.2555 .67739 m
.24578 .68689 L
s
.29358 .672 m
.2555 .67739 L
s
.317 .464 .889 r
.43683 .40748 m .43952 .41329 L .42165 .42722 L p F P
0 0 0 r
s
.311 .457 .882 r
.43952 .41329 m .43683 .40748 L .45703 .39737 L p F P
0 0 0 r
s
.311 .457 .882 r
.45703 .39737 m .4588 .40136 L .43952 .41329 L p F P
0 0 0 r
s
.11 .17 .391 r
.65177 .49155 m .64836 .4808 L .63407 .46242 L p F P
0 0 0 r
s
.077 .112 .279 r
.64836 .4808 m .65177 .49155 L .66287 .51118 L p F P
0 0 0 r
s
.267 .399 .794 r
.5251 .39015 m .52589 .39218 L .551 .40235 L p F P
0 0 0 r
s
.267 .399 .794 r
.551 .40235 m .54951 .39836 L .5251 .39015 L p F P
0 0 0 r
s
.294 .436 .852 r
.5 .38446 m .48082 .39573 L .47996 .39371 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.48043 .39967 m
.50384 .39558 L
s
.7301 .49747 m
.72569 .4683 L
s
.76629 .4618 m
.72569 .4683 L
s
.72569 .4683 m
.72084 .43906 L
s
.321 .468 .89 r
.41806 .41976 m .42165 .42722 L .40555 .44287 L p F P
0 0 0 r
s
.317 .464 .889 r
.42165 .42722 m .41806 .41976 L .43683 .40748 L p F P
0 0 0 r
s
.568 .15 .065 r
.51663 .6186 m .53571 .61584 L .53669 .60011 L p F P
0 0 0 r
s
.568 .15 .065 r
.5564 .59723 m .53669 .60011 L .53571 .61584 L p F P
0 0 0 r
s
.24 .35 .67 r
.67927 .57204 m
.67819 .5972 L
s
.304 .448 .87 r
.4588 .40136 m .45703 .39737 L .47823 .38964 L p F P
0 0 0 r
s
.83 .24 .1 r
.4632 .39871 m
.4634 .39916 L
s
.304 .448 .87 r
.47823 .38964 m .47909 .39168 L .4588 .40136 L p F P
0 0 0 r
s
.24 .35 .67 r
.45743 .39834 m
.4686 .42347 L
s
.189 .292 .609 r
.6168 .44506 m .61385 .43621 L .59435 .42162 L p F P
0 0 0 r
s
.146 .23 .499 r
.61385 .43621 m .6168 .44506 L .63407 .46242 L p F P
0 0 0 r
s
.24 .35 .67 r
.67086 .62267 m
.678 .64378 L
s
.678 .64378 m
.66493 .66798 L
s
.282 .42 .827 r
.52668 .39421 m .52589 .39218 L .5 .38446 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.71572 .41069 m
.67534 .41747 L
s
.67534 .41747 m
.66978 .39112 L
s
.467 .119 .052 r
.44426 .64198 m .46201 .63945 L .45996 .62678 L p F P
0 0 0 r
s
.83 .24 .1 r
.45478 .63523 m
.45782 .61602 L
s
.467 .119 .052 r
.47876 .62407 m .45996 .62678 L .46201 .63945 L p F P
0 0 0 r
s
.83 .24 .1 r
.76147 .43239 m
.72084 .43906 L
s
.72084 .43906 m
.71572 .41069 L
s
.294 .436 .852 r
.5 .38446 m .47996 .39371 L .47909 .39168 L closepath p F P
0 0 0 r
s
.208 .282 .479 r
.39818 .6248 m .39209 .61456 L .38915 .59877 L p F P
0 0 0 r
s
.208 .282 .479 r
.38274 .58789 m .38915 .59877 L .39209 .61456 L p F P
0 0 0 r
s
.257 .356 .631 r
.38915 .59877 m .38274 .58789 L .38238 .56995 L p F P
0 0 0 r
s
.24 .35 .67 r
.38349 .56929 m
.39608 .59107 L
s
.642 .174 .075 r
.59613 .5914 m .61615 .58847 L .61652 .57054 L p F P
0 0 0 r
s
.83 .24 .1 r
.57573 .57579 m
.61542 .56987 L
s
.642 .174 .075 r
.63671 .56753 m .61652 .57054 L .61615 .58847 L p F P
0 0 0 r
s
.317 .455 .846 r
.37997 .47809 m .38578 .48889 L .3774 .50838 L p F P
0 0 0 r
s
.24 .35 .67 r
.3849 .49745 m
.39746 .52061 L
s
.322 .464 .871 r
.38578 .48889 m .37997 .47809 L .39155 .45994 L p F P
0 0 0 r
s
.24 .35 .67 r
.3849 .49745 m
.40006 .47471 L
s
.7 .192 .083 r
.65702 .56451 m .67744 .56147 L .67387 .54224 L p F P
0 0 0 r
s
.054 .079 .187 r
.67387 .54224 m .6703 .53079 L .66287 .51118 L p F P
0 0 0 r
s
.191 .261 .437 r
.6703 .53079 m .67387 .54224 L .67744 .56147 L p F P
0 0 0 r
s
.83 .24 .1 r
.67237 .53499 m
.69337 .53179 L
s
.67165 .5351 m
.67237 .53499 L
s
.323 .468 .885 r
.40109 .43398 m .40555 .44287 L .39155 .45994 L p F P
0 0 0 r
s
.321 .468 .89 r
.40555 .44287 m .40109 .43398 L .41806 .41976 L p F P
0 0 0 r
s
.288 .406 .735 r
.38238 .56995 m .37582 .55863 L .37832 .53942 L p F P
0 0 0 r
s
.257 .356 .631 r
.37582 .55863 m .38238 .56995 L .38274 .58789 L p F P
0 0 0 r
s
.83 .24 .1 r
.73394 .5256 m
.7301 .49747 L
s
.77083 .4911 m
.7301 .49747 L
s
.282 .42 .827 r
.52589 .39218 m .5251 .39015 L .5 .38446 L closepath p F P
0 0 0 r
s
.267 .399 .794 r
.5243 .38811 m .5251 .39015 L .54951 .39836 L p F P
0 0 0 r
s
.267 .399 .794 r
.54951 .39836 m .54802 .39436 L .5243 .38811 L p F P
0 0 0 r
s
.83 .24 .1 r
.54328 .38868 m
.54474 .39349 L
s
.53318 .39045 m
.54328 .38868 L
s
.50384 .39558 m
.52741 .39146 L
s
.247 .373 .75 r
.54802 .39436 m .54951 .39836 L .57276 .40893 L p F P
0 0 0 r
s
.294 .436 .852 r
.5 .38446 m .47909 .39168 L .47823 .38964 L closepath p F P
0 0 0 r
s
.162 .212 .366 r
.40901 .64701 m .40339 .63758 L .39818 .6248 L p F P
0 0 0 r
s
.83 .24 .1 r
.40693 .64209 m
.41568 .64083 L
s
.24 .35 .67 r
.40556 .63782 m
.40835 .64251 L
s
.162 .212 .366 r
.39209 .61456 m .39818 .6248 L .40339 .63758 L p F P
0 0 0 r
s
.24 .35 .67 r
.39786 .61514 m
.40556 .63782 L
s
.247 .373 .75 r
.57276 .40893 m .57066 .40308 L .54802 .39436 L p F P
0 0 0 r
s
.222 .338 .69 r
.57066 .40308 m .57276 .40893 L .59435 .42162 L p F P
0 0 0 r
s
.83 .24 .1 r
.58967 .40486 m
.62951 .39803 L
s
.24 .35 .67 r
.55267 .40902 m
.57941 .41375 L
s
.57941 .41375 m
.58646 .43367 L
s
.568 .15 .065 r
.53571 .61584 m .5549 .61307 L .5564 .59723 L p F P
0 0 0 r
s
.83 .24 .1 r
.49676 .61034 m
.53612 .6046 L
s
.53612 .6046 m
.53646 .58164 L
s
.568 .15 .065 r
.57621 .59432 m .5564 .59723 L .5549 .61307 L p F P
0 0 0 r
s
.83 .24 .1 r
.69608 .55785 m
.69337 .53179 L
s
.73394 .5256 m
.69337 .53179 L
s
.311 .457 .882 r
.45524 .39336 m .45703 .39737 L .43683 .40748 L p F P
0 0 0 r
s
.304 .448 .87 r
.45703 .39737 m .45524 .39336 L .47736 .3876 L p F P
0 0 0 r
s
.83 .24 .1 r
.46164 .39516 m
.46184 .39562 L
s
.304 .448 .87 r
.47736 .3876 m .47823 .38964 L .45703 .39737 L p F P
0 0 0 r
s
.467 .119 .052 r
.46201 .63945 m .47984 .6369 L .47876 .62407 L p F P
0 0 0 r
s
.467 .119 .052 r
.49764 .62134 m .47876 .62407 L .47984 .6369 L p F P
0 0 0 r
s
.146 .23 .499 r
.63407 .46242 m .63083 .45239 L .61385 .43621 L p F P
0 0 0 r
s
.11 .17 .391 r
.63083 .45239 m .63407 .46242 L .64836 .4808 L p F P
0 0 0 r
s
.24 .35 .67 r
.63263 .46223 m
.63943 .48315 L
s
.61212 .44816 m
.63263 .46223 L
s
.282 .42 .827 r
.5251 .39015 m .5243 .38811 L .5 .38446 L closepath p F P
0 0 0 r
s
.317 .464 .889 r
.43411 .40162 m .43683 .40748 L .41806 .41976 L p F P
0 0 0 r
s
.83 .24 .1 r
.41742 .39055 m
.42621 .40915 L
s
.24 .35 .67 r
.43105 .41218 m
.44275 .43707 L
s
.311 .457 .882 r
.43683 .40748 m .43411 .40162 L .45524 .39336 L p F P
0 0 0 r
s
.24 .35 .67 r
.43105 .41218 m
.45743 .39834 L
s
.83 .24 .1 r
.66978 .39112 m
.62951 .39803 L
s
.62951 .39803 m
.62342 .37468 L
s
.288 .406 .735 r
.37179 .52791 m .37832 .53942 L .37582 .55863 L p F P
0 0 0 r
s
.307 .437 .803 r
.37832 .53942 m .37179 .52791 L .3774 .50838 L p F P
0 0 0 r
s
.294 .436 .852 r
.5 .38446 m .47823 .38964 L .47736 .3876 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.45743 .39834 m
.48558 .38869 L
s
.48558 .38869 m
.492 .40399 L
s
.642 .174 .075 r
.61615 .58847 m .63629 .58552 L .63671 .56753 L p F P
0 0 0 r
s
.642 .174 .075 r
.65702 .56451 m .63671 .56753 L .63629 .58552 L p F P
0 0 0 r
s
.222 .338 .69 r
.59435 .42162 m .59176 .4141 L .57066 .40308 L p F P
0 0 0 r
s
.189 .292 .609 r
.59176 .4141 m .59435 .42162 L .61385 .43621 L p F P
0 0 0 r
s
.83 .24 .1 r
.33015 .39061 m
.29167 .39753 L
s
.29167 .39753 m
.28071 .38947 L
s
.28452 .68145 m
.29358 .672 L
s
.33207 .66656 m
.29358 .672 L
s
.077 .112 .279 r
.66287 .51118 m .65932 .49983 L .64836 .4808 L p F P
0 0 0 r
s
.054 .079 .187 r
.65932 .49983 m .66287 .51118 L .6703 .53079 L p F P
0 0 0 r
s
.24 .35 .67 r
.65632 .50418 m
.66713 .52558 L
s
.66713 .52558 m
.67037 .53593 L
s
.83 .24 .1 r
.77083 .4911 m
.76629 .4618 L
s
.80732 .45523 m
.76629 .4618 L
s
.76629 .4618 m
.76147 .43239 L
s
.282 .42 .827 r
.5243 .38811 m .5235 .38606 L .5 .38446 L closepath p F P
0 0 0 r
s
.267 .399 .794 r
.5235 .38606 m .5243 .38811 L .54802 .39436 L p F P
0 0 0 r
s
.568 .15 .065 r
.5549 .61307 m .57418 .61028 L .57621 .59432 L p F P
0 0 0 r
s
.568 .15 .065 r
.59613 .5914 m .57621 .59432 L .57418 .61028 L p F P
0 0 0 r
s
.322 .464 .871 r
.38632 .44987 m .39155 .45994 L .37997 .47809 L p F P
0 0 0 r
s
.323 .468 .885 r
.39155 .45994 m .38632 .44987 L .40109 .43398 L p F P
0 0 0 r
s
.24 .35 .67 r
.3874 .45035 m
.40006 .47471 L
s
.267 .399 .794 r
.54802 .39436 m .54652 .39033 L .5235 .38606 L p F P
0 0 0 r
s
.247 .373 .75 r
.54652 .39033 m .54802 .39436 L .57066 .40308 L p F P
0 0 0 r
s
.304 .448 .87 r
.47649 .38555 m .47736 .3876 L .45524 .39336 L p F P
0 0 0 r
s
.294 .436 .852 r
.5 .38446 m .47736 .3876 L .47649 .38555 L closepath p F P
0 0 0 r
s
.321 .468 .89 r
.41441 .41222 m .41806 .41976 L .40109 .43398 L p F P
0 0 0 r
s
.24 .35 .67 r
.40741 .42972 m
.4196 .45435 L
s
.317 .464 .889 r
.41806 .41976 m .41441 .41222 L .43411 .40162 L p F P
0 0 0 r
s
.24 .35 .67 r
.40741 .42972 m
.43105 .41218 L
s
.467 .119 .052 r
.47984 .6369 m .49777 .63434 L .49764 .62134 L p F P
0 0 0 r
s
.83 .24 .1 r
.4943 .62956 m
.49676 .61034 L
s
.467 .119 .052 r
.51663 .6186 m .49764 .62134 L .49777 .63434 L p F P
0 0 0 r
s
.83 .24 .1 r
.75653 .40383 m
.71572 .41069 L
s
.71572 .41069 m
.71048 .38414 L
s
.80253 .42565 m
.76147 .43239 L
s
.76147 .43239 m
.75653 .40383 L
s
.33 .077 .034 r
.42659 .6445 m .40901 .64701 L .41616 .65604 L p F P
0 0 0 r
s
.071 .103 .253 r
.40339 .63758 m .40901 .64701 L .41616 .65604 L p F P
0 0 0 r
s
.83 .24 .1 r
.4122 .65032 m
.41568 .64083 L
s
.24 .35 .67 r
.40556 .63782 m
.4146 .65138 L
s
.83 .24 .1 r
.41568 .64083 m
.45478 .63523 L
s
.311 .457 .882 r
.45345 .38932 m .45524 .39336 L .43411 .40162 L p F P
0 0 0 r
s
.304 .448 .87 r
.45524 .39336 m .45345 .38932 L .47649 .38555 L p F P
0 0 0 r
s
.294 .436 .852 r
.5 .38446 m .47473 .38144 L .47385 .37937 L closepath p F P
0 0 0 r
s
.294 .436 .852 r
.5 .38446 m .47385 .37937 L .47297 .37729 L closepath p F P
0 0 0 r
s
.294 .436 .852 r
.5 .38446 m .47297 .37729 L .47209 .37521 L closepath p F P
0 0 0 r
s
1 .298 .127 r
.48464 .37297 m .48779 .37241 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .298 .127 r
.4815 .37353 m .48464 .37297 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .298 .127 r
.47836 .37409 m .4815 .37353 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .298 .127 r
.47522 .37465 m .47836 .37409 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .298 .127 r
.47209 .37521 m .47522 .37465 L .5 .38446 L closepath p F P
0 0 0 r
s
.294 .436 .852 r
.5 .38446 m .47649 .38555 L .47561 .3835 L closepath p F P
0 0 0 r
s
.294 .436 .852 r
.5 .38446 m .47561 .3835 L .47473 .38144 L closepath p F P
0 0 0 r
s
.282 .42 .827 r
.51948 .37573 m .51867 .37364 L .5 .38446 L closepath p F P
0 0 0 r
s
.282 .42 .827 r
.52029 .37781 m .51948 .37573 L .5 .38446 L closepath p F P
0 0 0 r
s
.282 .42 .827 r
.5211 .37988 m .52029 .37781 L .5 .38446 L closepath p F P
0 0 0 r
s
.282 .42 .827 r
.5219 .38195 m .5211 .37988 L .5 .38446 L closepath p F P
0 0 0 r
s
.282 .42 .827 r
.5227 .38401 m .5219 .38195 L .5 .38446 L closepath p F P
0 0 0 r
s
.282 .42 .827 r
.5235 .38606 m .5227 .38401 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .298 .127 r
.51304 .36791 m .51621 .36734 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .298 .127 r
.50988 .36847 m .51304 .36791 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .298 .127 r
.50671 .36904 m .50988 .36847 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .298 .127 r
.50355 .3696 m .50671 .36904 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .298 .127 r
.50039 .37016 m .50355 .3696 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .298 .127 r
.49724 .37073 m .50039 .37016 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .298 .127 r
.49408 .37129 m .49724 .37073 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .298 .127 r
.49093 .37185 m .49408 .37129 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .298 .127 r
.48779 .37241 m .49093 .37185 L .5 .38446 L closepath p F P
0 0 0 r
s
.282 .42 .827 r
.51703 .36945 m .51621 .36734 L .5 .38446 L closepath p F P
0 0 0 r
s
.282 .42 .827 r
.51785 .37155 m .51703 .36945 L .5 .38446 L closepath p F P
0 0 0 r
s
.282 .42 .827 r
.51867 .37364 m .51785 .37155 L .5 .38446 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.4961 .37658 m
.50384 .39558 L
s
.24 .35 .67 r
.48558 .38869 m
.51448 .3836 L
s
.51448 .3836 m
.52058 .39902 L
s
.642 .174 .075 r
.63629 .58552 m .65653 .58255 L .65702 .56451 L p F P
0 0 0 r
s
.83 .24 .1 r
.61542 .56987 m
.65553 .56389 L
s
.642 .174 .075 r
.67744 .56147 m .65702 .56451 L .65653 .58255 L p F P
0 0 0 r
s
.24 .35 .67 r
.6763 .56261 m
.67927 .57204 L
s
.267 .399 .794 r
.5227 .38401 m .5235 .38606 L .54652 .39033 L p F P
0 0 0 r
s
.307 .437 .803 r
.37108 .49697 m .3774 .50838 L .37179 .52791 L p F P
0 0 0 r
s
.24 .35 .67 r
.37483 .52173 m
.3877 .54463 L
s
.317 .455 .846 r
.3774 .50838 m .37108 .49697 L .37997 .47809 L p F P
0 0 0 r
s
.24 .35 .67 r
.37483 .52173 m
.3849 .49745 L
s
.5387 .7361 m
.5102 .73421 L
s
.49961 .71479 m
.5102 .73421 L
s
.247 .373 .75 r
.57066 .40308 m .56855 .39718 L .54652 .39033 L p F P
0 0 0 r
s
.222 .338 .69 r
.56855 .39718 m .57066 .40308 L .59176 .4141 L p F P
0 0 0 r
s
.304 .448 .87 r
.47561 .3835 m .47649 .38555 L .45345 .38932 L p F P
0 0 0 r
s
.189 .292 .609 r
.61385 .43621 m .61086 .42723 L .59176 .4141 L p F P
0 0 0 r
s
.146 .23 .499 r
.61086 .42723 m .61385 .43621 L .63083 .45239 L p F P
0 0 0 r
s
.83 .24 .1 r
.77494 .51935 m
.77083 .4911 L
s
.81199 .48467 m
.77083 .4911 L
s
.568 .15 .065 r
.57418 .61028 m .59356 .60749 L .59613 .5914 L p F P
0 0 0 r
s
.83 .24 .1 r
.53612 .6046 m
.57589 .59879 L
s
.57573 .57579 m
.57589 .59879 L
s
.568 .15 .065 r
.61615 .58847 m .59613 .5914 L .59356 .60749 L p F P
0 0 0 r
s
.11 .17 .391 r
.64836 .4808 m .64489 .46985 L .63083 .45239 L p F P
0 0 0 r
s
.077 .112 .279 r
.64489 .46985 m .64836 .4808 L .65932 .49983 L p F P
0 0 0 r
s
.83 .24 .1 r
.73706 .55175 m
.73394 .5256 L
s
.77494 .51935 m
.73394 .5256 L
s
.317 .464 .889 r
.43137 .3957 m .43411 .40162 L .41441 .41222 L p F P
0 0 0 r
s
.311 .457 .882 r
.43411 .40162 m .43137 .3957 L .45345 .38932 L p F P
0 0 0 r
s
.24 .35 .67 r
.65747 .64719 m
.66493 .66798 L
s
.66493 .66798 m
.64642 .69 L
s
.467 .119 .052 r
.49777 .63434 m .51577 .63177 L .51663 .6186 L p F P
0 0 0 r
s
.467 .119 .052 r
.53571 .61584 m .51663 .6186 L .51577 .63177 L p F P
0 0 0 r
s
.267 .399 .794 r
.5219 .38195 m .5227 .38401 L .545 .38627 L p F P
0 0 0 r
s
.83 .24 .1 r
.54227 .38599 m
.54328 .38868 L
s
.267 .399 .794 r
.54652 .39033 m .545 .38627 L .5227 .38401 L p F P
0 0 0 r
s
.247 .373 .75 r
.545 .38627 m .54652 .39033 L .56855 .39718 L p F P
0 0 0 r
s
.83 .24 .1 r
.54832 .3878 m
.58314 .38172 L
s
.45478 .63523 m
.4943 .62956 L
s
.33 .077 .034 r
.41616 .65604 m .43237 .65375 L .42659 .6445 L p F P
0 0 0 r
s
.24 .35 .67 r
.41757 .65584 m
.41905 .65806 L
s
.33 .077 .034 r
.44426 .64198 m .42659 .6445 L .43237 .65375 L p F P
0 0 0 r
s
.304 .448 .87 r
.45345 .38932 m .45164 .38526 L .47561 .3835 L p F P
0 0 0 r
s
.304 .448 .87 r
.47473 .38144 m .47561 .3835 L .45164 .38526 L p F P
0 0 0 r
s
.83 .24 .1 r
.45655 .3836 m
.4569 .38439 L
s
.41742 .39055 m
.45655 .3836 L
s
.323 .468 .885 r
.39657 .42497 m .40109 .43398 L .38632 .44987 L p F P
0 0 0 r
s
.321 .468 .89 r
.40109 .43398 m .39657 .42497 L .41441 .41222 L p F P
0 0 0 r
s
.24 .35 .67 r
.4729 .70746 m
.44974 .69509 L
s
.4379 .67484 m
.44974 .69509 L
s
.83 .24 .1 r
.71048 .38414 m
.66978 .39112 L
s
.66978 .39112 m
.66415 .36756 L
s
.311 .457 .882 r
.45164 .38526 m .45345 .38932 L .43137 .3957 L p F P
0 0 0 r
s
.642 .174 .075 r
.65653 .58255 m .67688 .57957 L .67744 .56147 L p F P
0 0 0 r
s
.191 .261 .437 r
.67744 .56147 m .67383 .54997 L .6703 .53079 L p F P
0 0 0 r
s
.247 .347 .604 r
.67383 .54997 m .67744 .56147 L .67688 .57957 L p F P
0 0 0 r
s
.83 .24 .1 r
.67719 .56067 m
.69608 .55785 L
s
.65553 .56389 m
.67496 .561 L
s
.36905 .38363 m
.33015 .39061 L
s
.33015 .39061 m
.31983 .38238 L
s
.32367 .67596 m
.33207 .66656 L
s
.37098 .66105 m
.33207 .66656 L
s
.267 .399 .794 r
.5211 .37988 m .5219 .38195 L .54348 .38219 L p F P
0 0 0 r
s
.267 .399 .794 r
.545 .38627 m .54348 .38219 L .5219 .38195 L p F P
0 0 0 r
s
.222 .338 .69 r
.59176 .4141 m .58914 .4065 L .56855 .39718 L p F P
0 0 0 r
s
.83 .24 .1 r
.58314 .38172 m
.58967 .40486 L
s
.189 .292 .609 r
.58914 .4065 m .59176 .4141 L .61086 .42723 L p F P
0 0 0 r
s
.24 .35 .67 r
.57941 .41375 m
.60371 .42328 L
s
.83 .24 .1 r
.81199 .48467 m
.80732 .45523 L
s
.80732 .45523 m
.80253 .42565 L
s
.304 .448 .87 r
.45164 .38526 m .44983 .38117 L .47473 .38144 L p F P
0 0 0 r
s
.304 .448 .87 r
.47385 .37937 m .47473 .38144 L .44983 .38117 L p F P
0 0 0 r
s
.317 .455 .846 r
.37406 .4671 m .37997 .47809 L .37108 .49697 L p F P
0 0 0 r
s
.322 .464 .871 r
.37997 .47809 m .37406 .4671 L .38632 .44987 L p F P
0 0 0 r
s
.83 .24 .1 r
.62342 .37468 m
.58314 .38172 L
s
.568 .15 .065 r
.59356 .60749 m .61304 .60467 L .61615 .58847 L p F P
0 0 0 r
s
.568 .15 .065 r
.63629 .58552 m .61615 .58847 L .61304 .60467 L p F P
0 0 0 r
s
.467 .119 .052 r
.51577 .63177 m .53387 .62919 L .53571 .61584 L p F P
0 0 0 r
s
.467 .119 .052 r
.5549 .61307 m .53571 .61584 L .53387 .62919 L p F P
0 0 0 r
s
.33 .077 .034 r
.43237 .65375 m .44866 .65145 L .44426 .64198 L p F P
0 0 0 r
s
.33 .077 .034 r
.46201 .63945 m .44426 .64198 L .44866 .65145 L p F P
0 0 0 r
s
.208 .282 .479 r
.39209 .61456 m .38589 .60412 L .38274 .58789 L p F P
0 0 0 r
s
.208 .282 .479 r
.37621 .57679 m .38274 .58789 L .38589 .60412 L p F P
0 0 0 r
s
.24 .35 .67 r
.38349 .56929 m
.38516 .59358 L
s
.257 .356 .631 r
.38274 .58789 m .37621 .57679 L .37582 .55863 L p F P
0 0 0 r
s
.83 .24 .1 r
.79778 .39691 m
.75653 .40383 L
s
.75653 .40383 m
.75162 .37708 L
s
.054 .079 .187 r
.6703 .53079 m .66666 .51911 L .65932 .49983 L p F P
0 0 0 r
s
.191 .261 .437 r
.66666 .51911 m .6703 .53079 L .67383 .54997 L p F P
0 0 0 r
s
.83 .24 .1 r
.80253 .42565 m
.79778 .39691 L
s
.267 .399 .794 r
.52029 .37781 m .5211 .37988 L .54194 .37808 L p F P
0 0 0 r
s
.267 .399 .794 r
.54348 .38219 m .54194 .37808 L .5211 .37988 L p F P
0 0 0 r
s
.146 .23 .499 r
.63083 .45239 m .62752 .44219 L .61086 .42723 L p F P
0 0 0 r
s
.24 .35 .67 r
.60371 .42328 m
.61212 .44816 L
s
.11 .17 .391 r
.62752 .44219 m .63083 .45239 L .64489 .46985 L p F P
0 0 0 r
s
.321 .468 .89 r
.41073 .40459 m .41441 .41222 L .39657 .42497 L p F P
0 0 0 r
s
.317 .464 .889 r
.41441 .41222 m .41073 .40459 L .43137 .3957 L p F P
0 0 0 r
s
.83 .24 .1 r
.242 .39647 m
.20372 .40341 L
s
.19172 .40163 m
.20372 .40341 L
s
.247 .373 .75 r
.56855 .39718 m .56642 .39122 L .545 .38627 L p F P
0 0 0 r
s
.222 .338 .69 r
.56642 .39122 m .56855 .39718 L .58914 .4065 L p F P
0 0 0 r
s
.247 .373 .75 r
.54348 .38219 m .545 .38627 L .56642 .39122 L p F P
0 0 0 r
s
.304 .448 .87 r
.44983 .38117 m .448 .37705 L .47385 .37937 L p F P
0 0 0 r
s
.304 .448 .87 r
.47297 .37729 m .47385 .37937 L .448 .37705 L p F P
0 0 0 r
s
.288 .406 .735 r
.37582 .55863 m .36913 .54708 L .37179 .52791 L p F P
0 0 0 r
s
.257 .356 .631 r
.36913 .54708 m .37582 .55863 L .37621 .57679 L p F P
0 0 0 r
s
.162 .212 .366 r
.40339 .63758 m .39767 .62799 L .39209 .61456 L p F P
0 0 0 r
s
.162 .212 .366 r
.38589 .60412 m .39209 .61456 L .39767 .62799 L p F P
0 0 0 r
s
.24 .35 .67 r
.38516 .59358 m
.39786 .61514 L
s
.311 .457 .882 r
.43137 .3957 m .4286 .38973 L .45164 .38526 L p F P
0 0 0 r
s
.311 .457 .882 r
.44983 .38117 m .45164 .38526 L .4286 .38973 L p F P
0 0 0 r
s
.83 .24 .1 r
.69608 .55785 m
.73706 .55175 L
s
.6978 .581 m
.69608 .55785 L
s
.81639 .51303 m
.81199 .48467 L
s
.317 .464 .889 r
.4286 .38973 m .43137 .3957 L .41073 .40459 L p F P
0 0 0 r
s
.267 .399 .794 r
.51948 .37573 m .52029 .37781 L .5404 .37394 L p F P
0 0 0 r
s
.267 .399 .794 r
.54194 .37808 m .5404 .37394 L .52029 .37781 L p F P
0 0 0 r
s
.24 .35 .67 r
.56804 .73233 m
.5387 .7361 L
s
.52862 .71659 m
.5387 .7361 L
s
.568 .15 .065 r
.61304 .60467 m .63262 .60184 L .63629 .58552 L p F P
0 0 0 r
s
.83 .24 .1 r
.57589 .59879 m
.61609 .59293 L
s
.61542 .56987 m
.61609 .59293 L
s
.568 .15 .065 r
.65653 .58255 m .63629 .58552 L .63262 .60184 L p F P
0 0 0 r
s
.33 .077 .034 r
.44866 .65145 m .46501 .64914 L .46201 .63945 L p F P
0 0 0 r
s
.33 .077 .034 r
.47984 .6369 m .46201 .63945 L .46501 .64914 L p F P
0 0 0 r
s
.304 .448 .87 r
.448 .37705 m .44616 .37291 L .47297 .37729 L p F P
0 0 0 r
s
.304 .448 .87 r
.47209 .37521 m .47297 .37729 L .44616 .37291 L p F P
0 0 0 r
s
.83 .24 .1 r
.47236 .38079 m
.4961 .37658 L
s
.467 .119 .052 r
.53387 .62919 m .55206 .6266 L .5549 .61307 L p F P
0 0 0 r
s
.83 .24 .1 r
.53425 .62383 m
.53612 .6046 L
s
.467 .119 .052 r
.57418 .61028 m .5549 .61307 L .55206 .6266 L p F P
0 0 0 r
s
.83 .24 .1 r
.77848 .54557 m
.77494 .51935 L
s
.81639 .51303 m
.77494 .51935 L
s
.322 .464 .871 r
.38099 .43963 m .38632 .44987 L .37406 .4671 L p F P
0 0 0 r
s
.323 .468 .885 r
.38632 .44987 m .38099 .43963 L .39657 .42497 L p F P
0 0 0 r
s
.24 .35 .67 r
.3874 .45035 m
.40741 .42972 L
s
.288 .406 .735 r
.36513 .51617 m .37179 .52791 L .36913 .54708 L p F P
0 0 0 r
s
.307 .437 .803 r
.37179 .52791 m .36513 .51617 L .37108 .49697 L p F P
0 0 0 r
s
.24 .35 .67 r
.37039 .54663 m
.37483 .52173 L
s
.83 .24 .1 r
.4943 .62956 m
.53425 .62383 L
s
.24 .35 .67 r
.63854 .66954 m
.64642 .69 L
s
.64642 .69 m
.62331 .70869 L
s
.077 .112 .279 r
.65932 .49983 m .6557 .48825 L .64489 .46985 L p F P
0 0 0 r
s
.24 .35 .67 r
.63263 .46223 m
.64878 .48035 L
s
.054 .079 .187 r
.6557 .48825 m .65932 .49983 L .66666 .51911 L p F P
0 0 0 r
s
.24 .35 .67 r
.64878 .48035 m
.65632 .50418 L
s
.189 .292 .609 r
.61086 .42723 m .60782 .41812 L .58914 .4065 L p F P
0 0 0 r
s
.146 .23 .499 r
.60782 .41812 m .61086 .42723 L .62752 .44219 L p F P
0 0 0 r
s
.83 .24 .1 r
.75162 .37708 m
.71048 .38414 L
s
.71048 .38414 m
.70531 .36037 L
s
.267 .399 .794 r
.51867 .37364 m .51948 .37573 L .53885 .36978 L p F P
0 0 0 r
s
.267 .399 .794 r
.5404 .37394 m .53885 .36978 L .51948 .37573 L p F P
0 0 0 r
s
.247 .373 .75 r
.54194 .37808 m .54348 .38219 L .56426 .38521 L p F P
0 0 0 r
s
.24 .35 .67 r
.51448 .3836 m
.54306 .38331 L
s
.247 .373 .75 r
.56642 .39122 m .56426 .38521 L .54348 .38219 L p F P
0 0 0 r
s
.24 .35 .67 r
.54306 .38331 m
.55267 .40902 L
s
.83 .24 .1 r
.40836 .37656 m
.36905 .38363 L
s
.36905 .38363 m
.35938 .37522 L
s
.304 .448 .87 r
.44616 .37291 m .44431 .36874 L .47209 .37521 L p F P
0 0 0 r
s
1 .303 .129 r
.47522 .37465 m .47209 .37521 L .44431 .36874 L p F P
0 0 0 r
s
.83 .24 .1 r
.36325 .6704 m
.37098 .66105 L
s
.071 .103 .253 r
.41616 .65604 m .41104 .64744 L .40339 .63758 L p F P
0 0 0 r
s
.83 .24 .1 r
.37098 .66105 m
.4103 .65549 L
s
.4103 .65549 m
.41208 .65064 L
s
.071 .103 .253 r
.39767 .62799 m .40339 .63758 L .41104 .64744 L p F P
0 0 0 r
s
1 .303 .129 r
.47836 .37409 m .47522 .37465 L .45054 .36762 L p F P
0 0 0 r
s
1 .303 .129 r
.44431 .36874 m .45054 .36762 L .47522 .37465 L p F P
0 0 0 r
s
.311 .457 .882 r
.4286 .38973 m .42581 .3837 L .44983 .38117 L p F P
0 0 0 r
s
.311 .457 .882 r
.448 .37705 m .44983 .38117 L .42581 .3837 L p F P
0 0 0 r
s
.33 .077 .034 r
.46501 .64914 m .48144 .64682 L .47984 .6369 L p F P
0 0 0 r
s
.33 .077 .034 r
.49777 .63434 m .47984 .6369 L .48144 .64682 L p F P
0 0 0 r
s
.83 .24 .1 r
.66415 .36756 m
.62342 .37468 L
s
.62342 .37468 m
.61734 .35506 L
s
1 .303 .129 r
.4815 .37353 m .47836 .37409 L .45678 .3665 L p F P
0 0 0 r
s
1 .303 .129 r
.45054 .36762 m .45678 .3665 L .47836 .37409 L p F P
0 0 0 r
s
.83 .24 .1 r
.4481 .36942 m
.45123 .37468 L
s
.568 .15 .065 r
.63262 .60184 m .65231 .599 L .65653 .58255 L p F P
0 0 0 r
s
.568 .15 .065 r
.67688 .57957 m .65653 .58255 L .65231 .599 L p F P
0 0 0 r
s
.222 .338 .69 r
.58914 .4065 m .58648 .3988 L .56642 .39122 L p F P
0 0 0 r
s
.189 .292 .609 r
.58648 .3988 m .58914 .4065 L .60782 .41812 L p F P
0 0 0 r
s
.467 .119 .052 r
.55206 .6266 m .57033 .62399 L .57418 .61028 L p F P
0 0 0 r
s
.467 .119 .052 r
.59356 .60749 m .57418 .61028 L .57033 .62399 L p F P
0 0 0 r
s
.323 .468 .885 r
.39198 .41583 m .39657 .42497 L .38099 .43963 L p F P
0 0 0 r
s
.321 .468 .89 r
.39657 .42497 m .39198 .41583 L .41073 .40459 L p F P
0 0 0 r
s
.267 .399 .794 r
.51785 .37155 m .51867 .37364 L .53729 .3656 L p F P
0 0 0 r
s
.267 .399 .794 r
.53885 .36978 m .53729 .3656 L .51867 .37364 L p F P
0 0 0 r
s
.83 .24 .1 r
.4961 .37658 m
.51999 .37234 L
s
.222 .338 .69 r
.56426 .38521 m .56642 .39122 L .58648 .3988 L p F P
0 0 0 r
s
1 .303 .129 r
.48464 .37297 m .4815 .37353 L .46304 .36538 L p F P
0 0 0 r
s
1 .303 .129 r
.45678 .3665 m .46304 .36538 L .4815 .37353 L p F P
0 0 0 r
s
.24 .35 .67 r
.47901 .37301 m
.48558 .38869 L
s
.307 .437 .803 r
.36465 .48534 m .37108 .49697 L .36513 .51617 L p F P
0 0 0 r
s
.317 .455 .846 r
.37108 .49697 m .36465 .48534 L .37406 .4671 L p F P
0 0 0 r
s
.83 .24 .1 r
.79778 .39691 m
.79321 .36995 L
s
1 .303 .129 r
.48779 .37241 m .48464 .37297 L .4693 .36425 L p F P
0 0 0 r
s
1 .303 .129 r
.46304 .36538 m .4693 .36425 L .48464 .37297 L p F P
0 0 0 r
s
.83 .24 .1 r
.28071 .38947 m
.242 .39647 L
s
.242 .39647 m
.23067 .39455 L
s
.11 .17 .391 r
.64489 .46985 m .64136 .45871 L .62752 .44219 L p F P
0 0 0 r
s
.077 .112 .279 r
.64136 .45871 m .64489 .46985 L .6557 .48825 L p F P
0 0 0 r
s
1 .303 .129 r
.49093 .37185 m .48779 .37241 L .47558 .36312 L p F P
0 0 0 r
s
1 .303 .129 r
.4693 .36425 m .47558 .36312 L .48779 .37241 L p F P
0 0 0 r
s
.24 .35 .67 r
.47451 .3623 m
.47491 .36324 L
s
.59673 .72305 m
.56804 .73233 L
s
.55853 .71267 m
.56804 .73233 L
s
.83 .24 .1 r
.24578 .68689 m
.23452 .69047 L
s
.28452 .68145 m
.24578 .68689 L
s
.317 .464 .889 r
.41073 .40459 m .407 .39687 L .4286 .38973 L p F P
0 0 0 r
s
.317 .464 .889 r
.42581 .3837 m .4286 .38973 L .407 .39687 L p F P
0 0 0 r
s
.83 .24 .1 r
.40836 .37656 m
.41699 .38988 L
s
.321 .468 .89 r
.407 .39687 m .41073 .40459 L .39198 .41583 L p F P
0 0 0 r
s
1 .303 .129 r
.49408 .37129 m .49093 .37185 L .48186 .36199 L p F P
0 0 0 r
s
1 .303 .129 r
.47558 .36312 m .48186 .36199 L .49093 .37185 L p F P
0 0 0 r
s
.24 .35 .67 r
.61493 .68853 m
.62331 .70869 L
s
.62331 .70869 m
.59673 .72305 L
s
.267 .399 .794 r
.51703 .36945 m .51785 .37155 L .53572 .36138 L p F P
0 0 0 r
s
.267 .399 .794 r
.53729 .3656 m .53572 .36138 L .51785 .37155 L p F P
0 0 0 r
s
.247 .373 .75 r
.5404 .37394 m .54194 .37808 L .56209 .37914 L p F P
0 0 0 r
s
.247 .373 .75 r
.56426 .38521 m .56209 .37914 L .54194 .37808 L p F P
0 0 0 r
s
.24 .35 .67 r
.41772 .65582 m
.41905 .65806 L
s
.83 .24 .1 r
.73706 .55175 m
.77848 .54557 L
s
.73933 .57494 m
.73706 .55175 L
s
1 .303 .129 r
.49724 .37073 m .49408 .37129 L .48816 .36086 L p F P
0 0 0 r
s
1 .303 .129 r
.48186 .36199 m .48816 .36086 L .49408 .37129 L p F P
0 0 0 r
s
.33 .077 .034 r
.48144 .64682 m .49794 .64449 L .49777 .63434 L p F P
0 0 0 r
s
.83 .24 .1 r
.49024 .64418 m
.4943 .62956 L
s
.33 .077 .034 r
.51577 .63177 m .49777 .63434 L .49794 .64449 L p F P
0 0 0 r
s
1 .303 .129 r
.50039 .37016 m .49724 .37073 L .49447 .35972 L p F P
0 0 0 r
s
1 .303 .129 r
.48816 .36086 m .49447 .35972 L .49724 .37073 L p F P
0 0 0 r
s
.467 .119 .052 r
.57033 .62399 m .5887 .62137 L .59356 .60749 L p F P
0 0 0 r
s
.83 .24 .1 r
.57463 .61804 m
.57589 .59879 L
s
.467 .119 .052 r
.61304 .60467 m .59356 .60749 L .5887 .62137 L p F P
0 0 0 r
s
.568 .15 .065 r
.65231 .599 m .6721 .59614 L .67688 .57957 L p F P
0 0 0 r
s
.24 .35 .67 r
.67086 .62267 m
.67819 .5972 L
s
.83 .24 .1 r
.61609 .59293 m
.65673 .587 L
s
.65553 .56389 m
.65673 .587 L
s
.247 .347 .604 r
.67688 .57957 m .67328 .5683 L .67383 .54997 L p F P
0 0 0 r
s
.288 .411 .737 r
.67328 .5683 m .67688 .57957 L .6721 .59614 L p F P
0 0 0 r
s
.24 .35 .67 r
.67481 .58675 m
.67819 .5972 L
s
.5878 .70317 m
.59673 .72305 L
s
.311 .457 .882 r
.42581 .3837 m .42299 .37762 L .448 .37705 L p F P
0 0 0 r
s
.311 .457 .882 r
.44616 .37291 m .448 .37705 L .42299 .37762 L p F P
0 0 0 r
s
1 .303 .129 r
.50355 .3696 m .50039 .37016 L .50079 .35859 L p F P
0 0 0 r
s
1 .303 .129 r
.49447 .35972 m .50079 .35859 L .50039 .37016 L p F P
0 0 0 r
s
.83 .24 .1 r
.48828 .36221 m
.4961 .37658 L
s
.24 .35 .67 r
.49961 .71479 m
.4729 .70746 L
s
.46142 .68725 m
.4729 .70746 L
s
.83 .24 .1 r
.82036 .53933 m
.81639 .51303 L
s
1 .303 .129 r
.50671 .36904 m .50355 .3696 L .50712 .35745 L p F P
0 0 0 r
s
1 .303 .129 r
.50079 .35859 m .50712 .35745 L .50355 .3696 L p F P
0 0 0 r
s
.24 .35 .67 r
.50395 .35701 m
.50433 .35795 L
s
.83 .24 .1 r
.53425 .62383 m
.57463 .61804 L
s
.317 .455 .846 r
.36805 .45591 m .37406 .4671 L .36465 .48534 L p F P
0 0 0 r
s
.24 .35 .67 r
.37184 .47335 m
.3849 .49745 L
s
.322 .464 .871 r
.37406 .4671 m .36805 .45591 L .38099 .43963 L p F P
0 0 0 r
s
.267 .399 .794 r
.51621 .36734 m .51703 .36945 L .53413 .35714 L p F P
0 0 0 r
s
.267 .399 .794 r
.53572 .36138 m .53413 .35714 L .51703 .36945 L p F P
0 0 0 r
s
.191 .261 .437 r
.67383 .54997 m .67015 .53825 L .66666 .51911 L p F P
0 0 0 r
s
.247 .347 .604 r
.67015 .53825 m .67383 .54997 L .67328 .5683 L p F P
0 0 0 r
s
.24 .35 .67 r
.66713 .52558 m
.67049 .54156 L
s
1 .303 .129 r
.50988 .36847 m .50671 .36904 L .51346 .35631 L p F P
0 0 0 r
s
1 .303 .129 r
.50712 .35745 m .51346 .35631 L .50671 .36904 L p F P
0 0 0 r
s
.146 .23 .499 r
.62752 .44219 m .62417 .43183 L .60782 .41812 L p F P
0 0 0 r
s
.11 .17 .391 r
.62417 .43183 m .62752 .44219 L .64136 .45871 L p F P
0 0 0 r
s
.24 .35 .67 r
.62455 .43735 m
.63263 .46223 L
s
.83 .24 .1 r
.79321 .36995 m
.75162 .37708 L
s
.75162 .37708 m
.74693 .35309 L
s
.67515 .58431 m
.6978 .581 L
s
.65673 .587 m
.67258 .58468 L
s
1 .303 .129 r
.51304 .36791 m .50988 .36847 L .51981 .35517 L p F P
0 0 0 r
s
1 .303 .129 r
.51346 .35631 m .51981 .35517 L .50988 .36847 L p F P
0 0 0 r
s
.83 .24 .1 r
.40327 .66478 m
.4103 .65549 L
s
.24 .35 .67 r
.67086 .62267 m
.65747 .64719 L
s
1 .303 .129 r
.51621 .36734 m .51304 .36791 L .52617 .35402 L p F P
0 0 0 r
s
1 .303 .129 r
.51981 .35517 m .52617 .35402 L .51304 .36791 L p F P
0 0 0 r
s
.24 .35 .67 r
.50823 .3678 m
.51448 .3836 L
s
.33 .077 .034 r
.49794 .64449 m .51452 .64214 L .51577 .63177 L p F P
0 0 0 r
s
.33 .077 .034 r
.53387 .62919 m .51577 .63177 L .51452 .64214 L p F P
0 0 0 r
s
.222 .338 .69 r
.56209 .37914 m .56426 .38521 L .5838 .391 L p F P
0 0 0 r
s
.83 .24 .1 r
.57649 .36231 m
.58314 .38172 L
s
.222 .338 .69 r
.58648 .3988 m .5838 .391 L .56426 .38521 L p F P
0 0 0 r
s
.24 .35 .67 r
.57026 .38792 m
.57941 .41375 L
s
.54306 .38331 m
.57026 .38792 L
s
.238 .055 .023 r
.43237 .65375 m .41616 .65604 L .42554 .66161 L p F P
0 0 0 r
s
.105 .162 .375 r
.41104 .64744 m .41616 .65604 L .42554 .66161 L p F P
0 0 0 r
s
.83 .24 .1 r
.4103 .65549 m
.41513 .6548 L
s
.41513 .6548 m
.41533 .65478 L
s
1 .303 .129 r
.52617 .35402 m .53254 .35288 L .51621 .36734 L p F P
0 0 0 r
s
.267 .399 .794 r
.53413 .35714 m .53254 .35288 L .51621 .36734 L p F P
0 0 0 r
s
.247 .373 .75 r
.53885 .36978 m .5404 .37394 L .5599 .37302 L p F P
0 0 0 r
s
.247 .373 .75 r
.56209 .37914 m .5599 .37302 L .5404 .37394 L p F P
0 0 0 r
s
.208 .282 .479 r
.38589 .60412 m .37957 .59347 L .37621 .57679 L p F P
0 0 0 r
s
.208 .282 .479 r
.36955 .56546 m .37621 .57679 L .37957 .59347 L p F P
0 0 0 r
s
.257 .356 .631 r
.37621 .57679 m .36955 .56546 L .36913 .54708 L p F P
0 0 0 r
s
.24 .35 .67 r
.37039 .54663 m
.38349 .56929 L
s
.467 .119 .052 r
.5887 .62137 m .60715 .61874 L .61304 .60467 L p F P
0 0 0 r
s
.467 .119 .052 r
.63262 .60184 m .61304 .60467 L .60715 .61874 L p F P
0 0 0 r
s
.83 .24 .1 r
.70531 .36037 m
.66415 .36756 L
s
.66415 .36756 m
.65864 .34773 L
s
.054 .079 .187 r
.66666 .51911 m .66295 .50719 L .6557 .48825 L p F P
0 0 0 r
s
.191 .261 .437 r
.66295 .50719 m .66666 .51911 L .67015 .53825 L p F P
0 0 0 r
s
.189 .292 .609 r
.60782 .41812 m .60474 .40888 L .58648 .3988 L p F P
0 0 0 r
s
.146 .23 .499 r
.60474 .40888 m .60782 .41812 L .62417 .43183 L p F P
0 0 0 r
s
.24 .35 .67 r
.60371 .42328 m
.62455 .43735 L
s
.162 .212 .366 r
.39767 .62799 m .39184 .61822 L .38589 .60412 L p F P
0 0 0 r
s
.162 .212 .366 r
.37957 .59347 m .38589 .60412 L .39184 .61822 L p F P
0 0 0 r
s
.24 .35 .67 r
.38516 .59358 m
.39286 .61646 L
s
.322 .464 .871 r
.37558 .42922 m .38099 .43963 L .36805 .45591 L p F P
0 0 0 r
s
.24 .35 .67 r
.37184 .47335 m
.3874 .45035 L
s
.323 .468 .885 r
.38099 .43963 m .37558 .42922 L .39198 .41583 L p F P
0 0 0 r
s
.311 .457 .882 r
.42299 .37762 m .42015 .37149 L .44616 .37291 L p F P
0 0 0 r
s
.83 .24 .1 r
.40836 .37656 m
.42141 .37422 L
s
.311 .457 .882 r
.44431 .36874 m .44616 .37291 L .42015 .37149 L p F P
0 0 0 r
s
.24 .35 .67 r
.44581 .37219 m
.45743 .39834 L
s
.189 .292 .609 r
.5838 .391 m .58648 .3988 L .60474 .40888 L p F P
0 0 0 r
s
.317 .464 .889 r
.407 .39687 m .40323 .38905 L .42581 .3837 L p F P
0 0 0 r
s
.317 .464 .889 r
.42299 .37762 m .42581 .3837 L .40323 .38905 L p F P
0 0 0 r
s
.24 .35 .67 r
.41889 .38628 m
.43105 .41218 L
s
.288 .406 .735 r
.36913 .54708 m .3623 .53529 L .36513 .51617 L p F P
0 0 0 r
s
.257 .356 .631 r
.3623 .53529 m .36913 .54708 L .36955 .56546 L p F P
0 0 0 r
s
.83 .24 .1 r
.31983 .38238 m
.28071 .38947 L
s
.28071 .38947 m
.27004 .3874 L
s
.27392 .68495 m
.28452 .68145 L
s
.32367 .67596 m
.28452 .68145 L
s
.33 .077 .034 r
.51452 .64214 m .53117 .63979 L .53387 .62919 L p F P
0 0 0 r
s
.33 .077 .034 r
.55206 .6266 m .53387 .62919 L .53117 .63979 L p F P
0 0 0 r
s
.238 .055 .023 r
.42554 .66161 m .43996 .65959 L .43237 .65375 L p F P
0 0 0 r
s
.238 .055 .023 r
.44866 .65145 m .43237 .65375 L .43996 .65959 L p F P
0 0 0 r
s
.24 .35 .67 r
.41905 .65806 m
.4379 .67484 L
s
.323 .468 .885 r
.38733 .40656 m .39198 .41583 L .37558 .42922 L p F P
0 0 0 r
s
.321 .468 .89 r
.39198 .41583 m .38733 .40656 L .407 .39687 L p F P
0 0 0 r
s
.83 .24 .1 r
.77848 .54557 m
.82036 .53933 L
s
.78131 .56882 m
.77848 .54557 L
s
.321 .468 .89 r
.40323 .38905 m .407 .39687 L .38733 .40656 L p F P
0 0 0 r
s
.24 .35 .67 r
.39472 .40408 m
.40741 .42972 L
s
.41889 .38628 m
.44581 .37219 L
s
.44581 .37219 m
.45633 .36856 L
s
.46839 .36441 m
.47451 .3623 L
s
.467 .119 .052 r
.60715 .61874 m .6257 .61609 L .63262 .60184 L p F P
0 0 0 r
s
.83 .24 .1 r
.61545 .61219 m
.61609 .59293 L
s
.467 .119 .052 r
.65231 .599 m .63262 .60184 L .6257 .61609 L p F P
0 0 0 r
s
.077 .112 .279 r
.6557 .48825 m .65201 .47645 L .64136 .45871 L p F P
0 0 0 r
s
.054 .079 .187 r
.65201 .47645 m .6557 .48825 L .66295 .50719 L p F P
0 0 0 r
s
.24 .35 .67 r
.64878 .48035 m
.65972 .50189 L
s
.65972 .50189 m
.66713 .52558 L
s
.288 .406 .735 r
.35833 .50419 m .36513 .51617 L .3623 .53529 L p F P
0 0 0 r
s
.307 .437 .803 r
.36513 .51617 m .35833 .50419 L .36465 .48534 L p F P
0 0 0 r
s
.247 .373 .75 r
.53729 .3656 m .53885 .36978 L .55768 .36684 L p F P
0 0 0 r
s
.83 .24 .1 r
.5527 .36653 m
.57649 .36231 L
s
.247 .373 .75 r
.5599 .37302 m .55768 .36684 L .53885 .36978 L p F P
0 0 0 r
s
.071 .103 .253 r
.41104 .64744 m .40584 .6387 L .39767 .62799 L p F P
0 0 0 r
s
.071 .103 .253 r
.39184 .61822 m .39767 .62799 L .40584 .6387 L p F P
0 0 0 r
s
.24 .35 .67 r
.39286 .61646 m
.40556 .63782 L
s
.83 .24 .1 r
.57463 .61804 m
.61545 .61219 L
s
.311 .457 .882 r
.42015 .37149 m .41727 .36529 L .44431 .36874 L p F P
0 0 0 r
s
.83 .24 .1 r
.44117 .37067 m
.4481 .36942 L
s
.994 .301 .128 r
.45054 .36762 m .44431 .36874 L .41727 .36529 L p F P
0 0 0 r
s
.83 .24 .1 r
.61734 .35506 m
.57649 .36231 L
s
.238 .055 .023 r
.43996 .65959 m .45442 .65756 L .44866 .65145 L p F P
0 0 0 r
s
.238 .055 .023 r
.46501 .64914 m .44866 .65145 L .45442 .65756 L p F P
0 0 0 r
s
.83 .24 .1 r
.41814 .65438 m
.45005 .64986 L
s
.45005 .64986 m
.45478 .63523 L
s
.79321 .36995 m
.789 .34574 L
s
.69845 .60029 m
.6978 .581 L
s
.73933 .57494 m
.6978 .581 L
s
.222 .338 .69 r
.5599 .37302 m .56209 .37914 L .58108 .38311 L p F P
0 0 0 r
s
.222 .338 .69 r
.5838 .391 m .58108 .38311 L .56209 .37914 L p F P
0 0 0 r
s
.33 .077 .034 r
.53117 .63979 m .54789 .63743 L .55206 .6266 L p F P
0 0 0 r
s
.33 .077 .034 r
.57033 .62399 m .55206 .6266 L .54789 .63743 L p F P
0 0 0 r
s
.994 .301 .128 r
.45678 .3665 m .45054 .36762 L .4265 .36362 L p F P
0 0 0 r
s
.994 .301 .128 r
.41727 .36529 m .4265 .36362 L .45054 .36762 L p F P
0 0 0 r
s
.24 .35 .67 r
.44375 .36754 m
.44581 .37219 L
s
.11 .17 .391 r
.64136 .45871 m .63776 .44736 L .62417 .43183 L p F P
0 0 0 r
s
.077 .112 .279 r
.63776 .44736 m .64136 .45871 L .65201 .47645 L p F P
0 0 0 r
s
.307 .437 .803 r
.35808 .47348 m .36465 .48534 L .35833 .50419 L p F P
0 0 0 r
s
.24 .35 .67 r
.36143 .49788 m
.37483 .52173 L
s
.317 .455 .846 r
.36465 .48534 m .35808 .47348 L .36805 .45591 L p F P
0 0 0 r
s
.467 .119 .052 r
.6257 .61609 m .64434 .61343 L .65231 .599 L p F P
0 0 0 r
s
.467 .119 .052 r
.6721 .59614 m .65231 .599 L .64434 .61343 L p F P
0 0 0 r
s
.317 .464 .889 r
.40323 .38905 m .39941 .38114 L .42299 .37762 L p F P
0 0 0 r
s
.24 .35 .67 r
.39472 .40408 m
.41889 .38628 L
s
.317 .464 .889 r
.42015 .37149 m .42299 .37762 L .39941 .38114 L p F P
0 0 0 r
s
.83 .24 .1 r
.74693 .35309 m
.70531 .36037 L
s
.70531 .36037 m
.70039 .34031 L
s
.994 .301 .128 r
.46304 .36538 m .45678 .3665 L .43575 .36194 L p F P
0 0 0 r
s
.994 .301 .128 r
.4265 .36362 m .43575 .36194 L .45678 .3665 L p F P
0 0 0 r
s
.24 .35 .67 r
.52862 .71659 m
.49961 .71479 L
s
.48858 .69456 m
.49961 .71479 L
s
.247 .373 .75 r
.53572 .36138 m .53729 .3656 L .55545 .3606 L p F P
0 0 0 r
s
.247 .373 .75 r
.55768 .36684 m .55545 .3606 L .53729 .3656 L p F P
0 0 0 r
s
.994 .301 .128 r
.4693 .36425 m .46304 .36538 L .44503 .36027 L p F P
0 0 0 r
s
.994 .301 .128 r
.43575 .36194 m .44503 .36027 L .46304 .36538 L p F P
0 0 0 r
s
.238 .055 .023 r
.45442 .65756 m .46895 .65552 L .46501 .64914 L p F P
0 0 0 r
s
.238 .055 .023 r
.48144 .64682 m .46501 .64914 L .46895 .65552 L p F P
0 0 0 r
s
.83 .24 .1 r
.35938 .37522 m
.31983 .38238 L
s
.31983 .38238 m
.30986 .38017 L
s
.146 .23 .499 r
.62417 .43183 m .62075 .42129 L .60474 .40888 L p F P
0 0 0 r
s
.11 .17 .391 r
.62075 .42129 m .62417 .43183 L .63776 .44736 L p F P
0 0 0 r
s
.189 .292 .609 r
.58108 .38311 m .5838 .391 L .60162 .3995 L p F P
0 0 0 r
s
.189 .292 .609 r
.60474 .40888 m .60162 .3995 L .5838 .391 L p F P
0 0 0 r
s
.24 .35 .67 r
.57026 .38792 m
.59497 .39738 L
s
.33 .077 .034 r
.54789 .63743 m .56469 .63505 L .57033 .62399 L p F P
0 0 0 r
s
.33 .077 .034 r
.5887 .62137 m .57033 .62399 L .56469 .63505 L p F P
0 0 0 r
s
.83 .24 .1 r
.31377 .67937 m
.32367 .67596 L
s
.36325 .6704 m
.32367 .67596 L
s
.24 .35 .67 r
.6497 .62554 m
.65747 .64719 L
s
.65747 .64719 m
.63854 .66954 L
s
.994 .301 .128 r
.47558 .36312 m .4693 .36425 L .45433 .35858 L p F P
0 0 0 r
s
.24 .35 .67 r
.47451 .3623 m
.50395 .35701 L
s
.994 .301 .128 r
.44503 .36027 m .45433 .35858 L .4693 .36425 L p F P
0 0 0 r
s
.317 .455 .846 r
.36192 .44451 m .36805 .45591 L .35808 .47348 L p F P
0 0 0 r
s
.24 .35 .67 r
.36143 .49788 m
.37184 .47335 L
s
.322 .464 .871 r
.36805 .45591 m .36192 .44451 L .37558 .42922 L p F P
0 0 0 r
s
.146 .23 .499 r
.60162 .3995 m .60474 .40888 L .62075 .42129 L p F P
0 0 0 r
s
.24 .35 .67 r
.59497 .39738 m
.60371 .42328 L
s
.247 .347 .604 r
.67328 .5683 m .6696 .5568 L .67015 .53825 L p F P
0 0 0 r
s
.288 .411 .737 r
.6696 .5568 m .67328 .5683 L .66855 .58534 L p F P
0 0 0 r
s
.288 .411 .737 r
.6721 .59614 m .66855 .58534 L .67328 .5683 L p F P
0 0 0 r
s
.83 .24 .1 r
.82375 .56262 m
.82036 .53933 L
s
.467 .119 .052 r
.64434 .61343 m .66307 .61076 L .6721 .59614 L p F P
0 0 0 r
s
.83 .24 .1 r
.65672 .60627 m
.65673 .587 L
s
.313 .45 .822 r
.66855 .58534 m .6721 .59614 L .66307 .61076 L p F P
0 0 0 r
s
.24 .35 .67 r
.6655 .60681 m
.67086 .62267 L
s
.46142 .68725 m
.4379 .67484 L
s
.50395 .35701 m
.51013 .35691 L
s
.105 .162 .375 r
.42554 .66161 m .42107 .65402 L .41104 .64744 L p F P
0 0 0 r
s
.105 .162 .375 r
.40584 .6387 m .41104 .64744 L .42107 .65402 L p F P
0 0 0 r
s
.994 .301 .128 r
.48186 .36199 m .47558 .36312 L .46365 .3569 L p F P
0 0 0 r
s
.994 .301 .128 r
.45433 .35858 m .46365 .3569 L .47558 .36312 L p F P
0 0 0 r
s
.83 .24 .1 r
.4481 .36942 m
.48828 .36221 L
s
.321 .468 .89 r
.38733 .40656 m .38261 .39715 L .40323 .38905 L p F P
0 0 0 r
s
.321 .468 .89 r
.39941 .38114 m .40323 .38905 L .38261 .39715 L p F P
0 0 0 r
s
.191 .261 .437 r
.67015 .53825 m .66639 .52627 L .66295 .50719 L p F P
0 0 0 r
s
.247 .347 .604 r
.66639 .52627 m .67015 .53825 L .6696 .5568 L p F P
0 0 0 r
s
.238 .055 .023 r
.46895 .65552 m .48353 .65347 L .48144 .64682 L p F P
0 0 0 r
s
.238 .055 .023 r
.49794 .64449 m .48144 .64682 L .48353 .65347 L p F P
0 0 0 r
s
.83 .24 .1 r
.45005 .64986 m
.49024 .64418 L
s
.322 .464 .871 r
.37007 .41864 m .37558 .42922 L .36192 .44451 L p F P
0 0 0 r
s
.323 .468 .885 r
.37558 .42922 m .37007 .41864 L .38733 .40656 L p F P
0 0 0 r
s
.24 .35 .67 r
.37422 .42498 m
.3874 .45035 L
s
.994 .301 .128 r
.48816 .36086 m .48186 .36199 L .47299 .35521 L p F P
0 0 0 r
s
.994 .301 .128 r
.46365 .3569 m .47299 .35521 L .48186 .36199 L p F P
0 0 0 r
s
.222 .338 .69 r
.55768 .36684 m .5599 .37302 L .57833 .37513 L p F P
0 0 0 r
s
.222 .338 .69 r
.58108 .38311 m .57833 .37513 L .5599 .37302 L p F P
0 0 0 r
s
.83 .24 .1 r
.61545 .61219 m
.65672 .60627 L
s
.23067 .39455 m
.19172 .40163 L
s
.18049 .40621 m
.19172 .40163 L
s
.33 .077 .034 r
.56469 .63505 m .58157 .63267 L .5887 .62137 L p F P
0 0 0 r
s
.83 .24 .1 r
.57194 .63262 m
.57463 .61804 L
s
.33 .077 .034 r
.60715 .61874 m .5887 .62137 L .58157 .63267 L p F P
0 0 0 r
s
.323 .468 .885 r
.38261 .39715 m .38733 .40656 L .37007 .41864 L p F P
0 0 0 r
s
.24 .35 .67 r
.37422 .42498 m
.39472 .40408 L
s
.247 .373 .75 r
.53413 .35714 m .53572 .36138 L .55319 .3543 L p F P
0 0 0 r
s
.247 .373 .75 r
.55545 .3606 m .55319 .3543 L .53572 .36138 L p F P
0 0 0 r
s
.83 .24 .1 r
.65864 .34773 m
.61734 .35506 L
s
.61734 .35506 m
.61148 .34007 L
s
.74063 .59424 m
.73933 .57494 L
s
.78131 .56882 m
.73933 .57494 L
s
.994 .301 .128 r
.49447 .35972 m .48816 .36086 L .48236 .35351 L p F P
0 0 0 r
s
.994 .301 .128 r
.47299 .35521 m .48236 .35351 L .48816 .36086 L p F P
0 0 0 r
s
.208 .282 .479 r
.37957 .59347 m .37311 .58262 L .36955 .56546 L p F P
0 0 0 r
s
.208 .282 .479 r
.36274 .5539 m .36955 .56546 L .37311 .58262 L p F P
0 0 0 r
s
.24 .35 .67 r
.37039 .54663 m
.37194 .57115 L
s
.257 .356 .631 r
.36955 .56546 m .36274 .5539 L .3623 .53529 L p F P
0 0 0 r
s
.317 .464 .889 r
.39941 .38114 m .39554 .37313 L .42015 .37149 L p F P
0 0 0 r
s
.317 .464 .889 r
.41727 .36529 m .42015 .37149 L .39554 .37313 L p F P
0 0 0 r
s
.162 .212 .366 r
.39184 .61822 m .3859 .60827 L .37957 .59347 L p F P
0 0 0 r
s
.162 .212 .366 r
.37311 .58262 m .37957 .59347 L .3859 .60827 L p F P
0 0 0 r
s
.24 .35 .67 r
.37194 .57115 m
.38516 .59358 L
s
.054 .079 .187 r
.66295 .50719 m .65916 .49503 L .65201 .47645 L p F P
0 0 0 r
s
.191 .261 .437 r
.65916 .49503 m .66295 .50719 L .66639 .52627 L p F P
0 0 0 r
s
.994 .301 .128 r
.50079 .35859 m .49447 .35972 L .49176 .35181 L p F P
0 0 0 r
s
.994 .301 .128 r
.48236 .35351 m .49176 .35181 L .49447 .35972 L p F P
0 0 0 r
s
.238 .055 .023 r
.48353 .65347 m .49818 .65142 L .49794 .64449 L p F P
0 0 0 r
s
.238 .055 .023 r
.51452 .64214 m .49794 .64449 L .49818 .65142 L p F P
0 0 0 r
s
.83 .24 .1 r
.789 .34574 m
.74693 .35309 L
s
.74693 .35309 m
.74261 .33282 L
s
.288 .406 .735 r
.3623 .53529 m .35533 .52326 L .35833 .50419 L p F P
0 0 0 r
s
.257 .356 .631 r
.35533 .52326 m .3623 .53529 L .36274 .5539 L p F P
0 0 0 r
s
.994 .301 .128 r
.50712 .35745 m .50079 .35859 L .50117 .35011 L p F P
0 0 0 r
s
.994 .301 .128 r
.49176 .35181 m .50117 .35011 L .50079 .35859 L p F P
0 0 0 r
s
.33 .077 .034 r
.58157 .63267 m .59852 .63027 L .60715 .61874 L p F P
0 0 0 r
s
.33 .077 .034 r
.6257 .61609 m .60715 .61874 L .59852 .63027 L p F P
0 0 0 r
s
.83 .24 .1 r
.35938 .37522 m
.35012 .37286 L
s
.071 .103 .253 r
.40584 .6387 m .40055 .6298 L .39184 .61822 L p F P
0 0 0 r
s
.071 .103 .253 r
.3859 .60827 m .39184 .61822 L .40055 .6298 L p F P
0 0 0 r
s
.24 .35 .67 r
.55853 .71267 m
.52862 .71659 L
s
.51813 .69627 m
.52862 .71659 L
s
.83 .24 .1 r
.35406 .67373 m
.36325 .6704 L
s
.40327 .66478 m
.36325 .6704 L
s
.994 .301 .128 r
.51346 .35631 m .50712 .35745 L .51061 .3484 L p F P
0 0 0 r
s
.994 .301 .128 r
.50117 .35011 m .51061 .3484 L .50712 .35745 L p F P
0 0 0 r
s
.077 .112 .279 r
.65201 .47645 m .64825 .46441 L .63776 .44736 L p F P
0 0 0 r
s
.054 .079 .187 r
.64825 .46441 m .65201 .47645 L .65916 .49503 L p F P
0 0 0 r
s
.247 .373 .75 r
.53254 .35288 m .53413 .35714 L .55092 .34794 L p F P
0 0 0 r
s
.24 .35 .67 r
.52233 .35671 m
.53306 .35654 L
s
.247 .373 .75 r
.55319 .3543 m .55092 .34794 L .53413 .35714 L p F P
0 0 0 r
s
.24 .35 .67 r
.53306 .35654 m
.54306 .38331 L
s
.189 .292 .609 r
.57833 .37513 m .58108 .38311 L .59845 .38998 L p F P
0 0 0 r
s
.189 .292 .609 r
.60162 .3995 m .59845 .38998 L .58108 .38311 L p F P
0 0 0 r
s
.288 .406 .735 r
.35139 .49197 m .35833 .50419 L .35533 .52326 L p F P
0 0 0 r
s
.307 .437 .803 r
.35833 .50419 m .35139 .49197 L .35808 .47348 L p F P
0 0 0 r
s
.24 .35 .67 r
.35675 .52303 m
.36143 .49788 L
s
.238 .055 .023 r
.49818 .65142 m .51287 .64936 L .51452 .64214 L p F P
0 0 0 r
s
.238 .055 .023 r
.53117 .63979 m .51452 .64214 L .51287 .64936 L p F P
0 0 0 r
s
.24 .35 .67 r
.63033 .64822 m
.63854 .66954 L
s
.63854 .66954 m
.61493 .68853 L
s
.994 .301 .128 r
.51981 .35517 m .51346 .35631 L .52008 .34668 L p F P
0 0 0 r
s
.994 .301 .128 r
.51061 .3484 m .52008 .34668 L .51346 .35631 L p F P
0 0 0 r
s
.222 .338 .69 r
.55545 .3606 m .55768 .36684 L .57554 .36705 L p F P
0 0 0 r
s
.222 .338 .69 r
.57833 .37513 m .57554 .36705 L .55768 .36684 L p F P
0 0 0 r
s
.994 .301 .128 r
.52617 .35402 m .51981 .35517 L .52957 .34497 L p F P
0 0 0 r
s
.994 .301 .128 r
.52008 .34668 m .52957 .34497 L .51981 .35517 L p F P
0 0 0 r
s
.83 .24 .1 r
.52889 .35491 m
.53156 .36032 L
s
.48828 .36221 m
.52889 .35491 L
s
.11 .17 .391 r
.63776 .44736 m .6341 .4358 L .62075 .42129 L p F P
0 0 0 r
s
.077 .112 .279 r
.6341 .4358 m .63776 .44736 L .64825 .46441 L p F P
0 0 0 r
s
.24 .35 .67 r
.62455 .43735 m
.64093 .45555 L
s
.64093 .45555 m
.64878 .48035 L
s
.33 .077 .034 r
.59852 .63027 m .61555 .62787 L .6257 .61609 L p F P
0 0 0 r
s
.33 .077 .034 r
.64434 .61343 m .6257 .61609 L .61555 .62787 L p F P
0 0 0 r
s
.321 .468 .89 r
.38261 .39715 m .37781 .3876 L .39941 .38114 L p F P
0 0 0 r
s
.321 .468 .89 r
.39554 .37313 m .39941 .38114 L .37781 .3876 L p F P
0 0 0 r
s
.83 .24 .1 r
.65672 .60627 m
.66427 .60519 L
s
.27004 .3874 m
.23067 .39455 L
s
.23067 .39455 m
.22011 .39903 L
s
.23452 .69047 m
.22212 .68765 L
s
.27392 .68495 m
.23452 .69047 L
s
.146 .23 .499 r
.59845 .38998 m .60162 .3995 L .61728 .41057 L p F P
0 0 0 r
s
.146 .23 .499 r
.62075 .42129 m .61728 .41057 L .60162 .3995 L p F P
0 0 0 r
s
.317 .464 .889 r
.39554 .37313 m .39162 .36502 L .41727 .36529 L p F P
0 0 0 r
s
.83 .24 .1 r
.35938 .37522 m
.39356 .36903 L
s
.91 .282 .119 r
.4265 .36362 m .41727 .36529 L .39162 .36502 L p F P
0 0 0 r
s
.307 .437 .803 r
.35139 .46138 m .35808 .47348 L .35139 .49197 L p F P
0 0 0 r
s
.317 .455 .846 r
.35808 .47348 m .35139 .46138 L .36192 .44451 L p F P
0 0 0 r
s
.994 .301 .128 r
.53254 .35288 m .52617 .35402 L .53908 .34324 L p F P
0 0 0 r
s
.994 .301 .128 r
.52957 .34497 m .53908 .34324 L .52617 .35402 L p F P
0 0 0 r
s
.83 .24 .1 r
.70039 .34031 m
.65864 .34773 L
s
.65864 .34773 m
.65346 .33253 L
s
.11 .17 .391 r
.61728 .41057 m .62075 .42129 L .6341 .4358 L p F P
0 0 0 r
s
.83 .24 .1 r
.78329 .58812 m
.78131 .56882 L
s
.82375 .56262 m
.78131 .56882 L
s
.238 .055 .023 r
.51287 .64936 m .52763 .64728 L .53117 .63979 L p F P
0 0 0 r
s
.238 .055 .023 r
.54789 .63743 m .53117 .63979 L .52763 .64728 L p F P
0 0 0 r
s
.83 .24 .1 r
.49024 .64418 m
.53087 .63843 L
s
.53087 .63843 m
.53425 .62383 L
s
.52889 .35491 m
.53599 .35363 L
s
.55193 .35077 m
.56996 .34753 L
s
.145 .036 .015 r
.43996 .65959 m .42554 .66161 L .43706 .66343 L p F P
0 0 0 r
s
.14 .226 .491 r
.42107 .65402 m .42554 .66161 L .43706 .66343 L p F P
0 0 0 r
s
.24 .35 .67 r
.43064 .66242 m
.43073 .66257 L
s
.247 .373 .75 r
.55092 .34794 m .54862 .34152 L .53254 .35288 L p F P
0 0 0 r
s
.994 .301 .128 r
.53908 .34324 m .54862 .34152 L .53254 .35288 L p F P
0 0 0 r
s
.24 .35 .67 r
.53128 .35178 m
.53306 .35654 L
s
.91 .282 .119 r
.43575 .36194 m .4265 .36362 L .40368 .36283 L p F P
0 0 0 r
s
.91 .282 .119 r
.39162 .36502 m .40368 .36283 L .4265 .36362 L p F P
0 0 0 r
s
.24 .35 .67 r
.4088 .36482 m
.41889 .38628 L
s
.5878 .70317 m
.55853 .71267 L
s
.54862 .69219 m
.55853 .71267 L
s
.105 .162 .375 r
.42107 .65402 m .41654 .64632 L .40584 .6387 L p F P
0 0 0 r
s
.105 .162 .375 r
.40055 .6298 m .40584 .6387 L .41654 .64632 L p F P
0 0 0 r
s
.24 .35 .67 r
.39286 .61646 m
.40446 .63385 L
s
.83 .24 .1 r
.789 .34574 m
.7853 .32524 L
s
.317 .455 .846 r
.35568 .43289 m .36192 .44451 L .35139 .46138 L p F P
0 0 0 r
s
.24 .35 .67 r
.35824 .44825 m
.37184 .47335 L
s
.322 .464 .871 r
.36192 .44451 m .35568 .43289 L .37007 .41864 L p F P
0 0 0 r
s
.323 .468 .885 r
.37007 .41864 m .36447 .40788 L .38261 .39715 L p F P
0 0 0 r
s
.323 .468 .885 r
.37781 .3876 m .38261 .39715 L .36447 .40788 L p F P
0 0 0 r
s
.33 .077 .034 r
.61555 .62787 m .63266 .62545 L .64434 .61343 L p F P
0 0 0 r
s
.33 .077 .034 r
.66307 .61076 m .64434 .61343 L .63266 .62545 L p F P
0 0 0 r
s
.24 .35 .67 r
.60619 .66753 m
.61493 .68853 L
s
.61493 .68853 m
.5878 .70317 L
s
.322 .464 .871 r
.36447 .40788 m .37007 .41864 L .35568 .43289 L p F P
0 0 0 r
s
.24 .35 .67 r
.35824 .44825 m
.37422 .42498 L
s
.91 .282 .119 r
.44503 .36027 m .43575 .36194 L .41577 .36064 L p F P
0 0 0 r
s
.83 .24 .1 r
.4398 .36066 m
.4481 .36942 L
s
.91 .282 .119 r
.40368 .36283 m .41577 .36064 L .43575 .36194 L p F P
0 0 0 r
s
.24 .35 .67 r
.40622 .35932 m
.40754 .36213 L
s
.83 .24 .1 r
.40745 .36652 m
.4398 .36066 L
s
.238 .055 .023 r
.52763 .64728 m .54245 .64521 L .54789 .63743 L p F P
0 0 0 r
s
.238 .055 .023 r
.56469 .63505 m .54789 .63743 L .54245 .64521 L p F P
0 0 0 r
s
.145 .036 .015 r
.43706 .66343 m .44926 .66172 L .43996 .65959 L p F P
0 0 0 r
s
.24 .35 .67 r
.43073 .66257 m
.4379 .67484 L
s
.145 .036 .015 r
.45442 .65756 m .43996 .65959 L .44926 .66172 L p F P
0 0 0 r
s
.288 .411 .737 r
.66855 .58534 m .66493 .57433 L .6696 .5568 L p F P
0 0 0 r
s
.313 .45 .822 r
.66493 .57433 m .66855 .58534 L .65962 .60067 L p F P
0 0 0 r
s
.313 .45 .822 r
.66307 .61076 m .65962 .60067 L .66855 .58534 L p F P
0 0 0 r
s
.83 .24 .1 r
.66608 .60493 m
.69845 .60029 L
s
.247 .347 .604 r
.6696 .5568 m .66585 .54506 L .66639 .52627 L p F P
0 0 0 r
s
.288 .411 .737 r
.66585 .54506 m .6696 .5568 L .66493 .57433 L p F P
0 0 0 r
s
.83 .24 .1 r
.3948 .66802 m
.40327 .66478 L
s
.40327 .66478 m
.42695 .66146 L
s
.42695 .66146 m
.42825 .66128 L
s
.24 .35 .67 r
.57848 .68245 m
.5878 .70317 L
s
.48858 .69456 m
.46142 .68725 L
s
.44945 .6662 m
.46142 .68725 L
s
.222 .338 .69 r
.55319 .3543 m .55545 .3606 L .57272 .35887 L p F P
0 0 0 r
s
.222 .338 .69 r
.57554 .36705 m .57272 .35887 L .55545 .3606 L p F P
0 0 0 r
s
.83 .24 .1 r
.56996 .34753 m
.57649 .36231 L
s
.24 .35 .67 r
.53306 .35654 m
.56073 .36102 L
s
.56073 .36102 m
.57026 .38792 L
s
.91 .282 .119 r
.45433 .35858 m .44503 .36027 L .4279 .35843 L p F P
0 0 0 r
s
.24 .35 .67 r
.44029 .35976 m
.44054 .36032 L
s
.91 .282 .119 r
.41577 .36064 m .4279 .35843 L .44503 .36027 L p F P
0 0 0 r
s
.191 .261 .437 r
.66639 .52627 m .66256 .51405 L .65916 .49503 L p F P
0 0 0 r
s
.247 .347 .604 r
.66256 .51405 m .66639 .52627 L .66585 .54506 L p F P
0 0 0 r
s
.24 .35 .67 r
.65972 .50189 m
.66286 .51692 L
s
.189 .292 .609 r
.57554 .36705 m .57833 .37513 L .59523 .38033 L p F P
0 0 0 r
s
.189 .292 .609 r
.59845 .38998 m .59523 .38033 L .57833 .37513 L p F P
0 0 0 r
s
.33 .077 .034 r
.63266 .62545 m .64985 .62302 L .66307 .61076 L p F P
0 0 0 r
s
.326 .471 .874 r
.65962 .60067 m .66307 .61076 L .64985 .62302 L p F P
0 0 0 r
s
.83 .24 .1 r
.65661 .60755 m
.65672 .60627 L
s
.24 .35 .67 r
.6497 .62554 m
.6524 .62065 L
s
.145 .036 .015 r
.44926 .66172 m .4615 .66001 L .45442 .65756 L p F P
0 0 0 r
s
.83 .24 .1 r
.44373 .65911 m
.45005 .64986 L
s
.145 .036 .015 r
.46895 .65552 m .45442 .65756 L .4615 .66001 L p F P
0 0 0 r
s
.238 .055 .023 r
.54245 .64521 m .55732 .64312 L .56469 .63505 L p F P
0 0 0 r
s
.238 .055 .023 r
.58157 .63267 m .56469 .63505 L .55732 .64312 L p F P
0 0 0 r
s
.83 .24 .1 r
.53087 .63843 m
.57194 .63262 L
s
.91 .282 .119 r
.46365 .3569 m .45433 .35858 L .44007 .35622 L p F P
0 0 0 r
s
.91 .282 .119 r
.4279 .35843 m .44007 .35622 L .45433 .35858 L p F P
0 0 0 r
s
.24 .35 .67 r
.43371 .34496 m
.43882 .35645 L
s
.83 .24 .1 r
.69794 .61479 m
.69845 .60029 L
s
.74063 .59424 m
.69845 .60029 L
s
.30986 .38017 m
.27004 .3874 L
s
.27004 .3874 m
.26018 .39177 L
s
.162 .212 .366 r
.3859 .60827 m .37985 .59813 L .37311 .58262 L p F P
0 0 0 r
s
.162 .212 .366 r
.36654 .57155 m .37311 .58262 L .37985 .59813 L p F P
0 0 0 r
s
.208 .282 .479 r
.37311 .58262 m .36654 .57155 L .36274 .5539 L p F P
0 0 0 r
s
.24 .35 .67 r
.37194 .57115 m
.37964 .59422 L
s
.208 .282 .479 r
.3558 .5421 m .36274 .5539 L .36654 .57155 L p F P
0 0 0 r
s
.257 .356 .631 r
.36274 .5539 m .3558 .5421 L .35533 .52326 L p F P
0 0 0 r
s
.24 .35 .67 r
.35675 .52303 m
.37039 .54663 L
s
.83 .24 .1 r
.2622 .68201 m
.27392 .68495 L
s
.31377 .67937 m
.27392 .68495 L
s
.74261 .33282 m
.70039 .34031 L
s
.70039 .34031 m
.69592 .3249 L
s
.321 .468 .89 r
.37781 .3876 m .37295 .3779 L .39554 .37313 L p F P
0 0 0 r
s
.321 .468 .89 r
.39162 .36502 m .39554 .37313 L .37295 .3779 L p F P
0 0 0 r
s
.054 .079 .187 r
.65916 .49503 m .65529 .48262 L .64825 .46441 L p F P
0 0 0 r
s
.191 .261 .437 r
.65529 .48262 m .65916 .49503 L .66256 .51405 L p F P
0 0 0 r
s
.83 .24 .1 r
.82643 .58194 m
.82375 .56262 L
s
.61148 .34007 m
.56996 .34753 L
s
.91 .282 .119 r
.47299 .35521 m .46365 .3569 L .45228 .354 L p F P
0 0 0 r
s
.91 .282 .119 r
.44007 .35622 m .45228 .354 L .46365 .3569 L p F P
0 0 0 r
s
.071 .103 .253 r
.40055 .6298 m .39517 .62076 L .3859 .60827 L p F P
0 0 0 r
s
.071 .103 .253 r
.37985 .59813 m .3859 .60827 L .39517 .62076 L p F P
0 0 0 r
s
.24 .35 .67 r
.37964 .59422 m
.39286 .61646 L
s
.288 .406 .735 r
.35533 .52326 m .34821 .51097 L .35139 .49197 L p F P
0 0 0 r
s
.257 .356 .631 r
.34821 .51097 m .35533 .52326 L .3558 .5421 L p F P
0 0 0 r
s
.145 .036 .015 r
.4615 .66001 m .47378 .65829 L .46895 .65552 L p F P
0 0 0 r
s
.145 .036 .015 r
.48353 .65347 m .46895 .65552 L .47378 .65829 L p F P
0 0 0 r
s
.238 .055 .023 r
.55732 .64312 m .57226 .64102 L .58157 .63267 L p F P
0 0 0 r
s
.238 .055 .023 r
.59852 .63027 m .58157 .63267 L .57226 .64102 L p F P
0 0 0 r
s
.146 .23 .499 r
.59523 .38033 m .59845 .38998 L .61376 .39967 L p F P
0 0 0 r
s
.146 .23 .499 r
.61728 .41057 m .61376 .39967 L .59845 .38998 L p F P
0 0 0 r
s
.077 .112 .279 r
.64825 .46441 m .64441 .45213 L .6341 .4358 L p F P
0 0 0 r
s
.054 .079 .187 r
.64441 .45213 m .64825 .46441 L .65529 .48262 L p F P
0 0 0 r
s
.24 .35 .67 r
.64093 .45555 m
.652 .47723 L
s
.652 .47723 m
.65972 .50189 L
s
.91 .282 .119 r
.48236 .35351 m .47299 .35521 L .46454 .35178 L p F P
0 0 0 r
s
.24 .35 .67 r
.47124 .35449 m
.4715 .35512 L
s
.91 .282 .119 r
.45228 .354 m .46454 .35178 L .47299 .35521 L p F P
0 0 0 r
s
.24 .35 .67 r
.40622 .35932 m
.43371 .34496 L
s
.4211 .31658 m
.43371 .34496 L
s
.43371 .34496 m
.46299 .33483 L
s
.14 .226 .491 r
.43706 .66343 m .43335 .65703 L .42107 .65402 L p F P
0 0 0 r
s
.83 .24 .1 r
.43525 .6603 m
.44373 .65911 L
s
.14 .226 .491 r
.41654 .64632 m .42107 .65402 L .43335 .65703 L p F P
0 0 0 r
s
.24 .35 .67 r
.41273 .64239 m
.41883 .64778 L
s
.222 .338 .69 r
.55092 .34794 m .55319 .3543 L .56987 .35058 L p F P
0 0 0 r
s
.222 .338 .69 r
.57272 .35887 m .56987 .35058 L .55319 .3543 L p F P
0 0 0 r
s
.288 .406 .735 r
.34431 .47949 m .35139 .49197 L .34821 .51097 L p F P
0 0 0 r
s
.307 .437 .803 r
.35139 .49197 m .34431 .47949 L .35139 .46138 L p F P
0 0 0 r
s
.11 .17 .391 r
.6341 .4358 m .63037 .42402 L .61728 .41057 L p F P
0 0 0 r
s
.077 .112 .279 r
.63037 .42402 m .6341 .4358 L .64441 .45213 L p F P
0 0 0 r
s
.11 .17 .391 r
.61376 .39967 m .61728 .41057 L .63037 .42402 L p F P
0 0 0 r
s
.24 .35 .67 r
.61613 .41145 m
.62455 .43735 L
s
.59497 .39738 m
.61613 .41145 L
s
.145 .036 .015 r
.47378 .65829 m .4861 .65657 L .48353 .65347 L p F P
0 0 0 r
s
.145 .036 .015 r
.49818 .65142 m .48353 .65347 L .4861 .65657 L p F P
0 0 0 r
s
.83 .24 .1 r
.44373 .65911 m
.48464 .65336 L
s
.91 .282 .119 r
.49176 .35181 m .48236 .35351 L .47683 .34955 L p F P
0 0 0 r
s
.91 .282 .119 r
.46454 .35178 m .47683 .34955 L .48236 .35351 L p F P
0 0 0 r
s
.83 .24 .1 r
.48067 .35326 m
.48828 .36221 L
s
.4398 .36066 m
.48067 .35326 L
s
.24 .35 .67 r
.46299 .33483 m
.4697 .35084 L
s
.323 .468 .885 r
.36447 .40788 m .35878 .39693 L .37781 .3876 L p F P
0 0 0 r
s
.323 .468 .885 r
.37295 .3779 m .37781 .3876 L .35878 .39693 L p F P
0 0 0 r
s
.24 .35 .67 r
.40065 .36338 m
.40622 .35932 L
s
.238 .055 .023 r
.57226 .64102 m .58725 .63892 L .59852 .63027 L p F P
0 0 0 r
s
.238 .055 .023 r
.61555 .62787 m .59852 .63027 L .58725 .63892 L p F P
0 0 0 r
s
.24 .35 .67 r
.45098 .30619 m
.46299 .33483 L
s
.46299 .33483 m
.49299 .32931 L
s
.307 .437 .803 r
.34456 .44904 m .35139 .46138 L .34431 .47949 L p F P
0 0 0 r
s
.24 .35 .67 r
.34748 .47305 m
.36143 .49788 L
s
.317 .455 .846 r
.35139 .46138 m .34456 .44904 L .35568 .43289 L p F P
0 0 0 r
s
.105 .162 .375 r
.41654 .64632 m .41193 .6385 L .40055 .6298 L p F P
0 0 0 r
s
.105 .162 .375 r
.39517 .62076 m .40055 .6298 L .41193 .6385 L p F P
0 0 0 r
s
.91 .282 .119 r
.50117 .35011 m .49176 .35181 L .48917 .34731 L p F P
0 0 0 r
s
.91 .282 .119 r
.47683 .34955 m .48917 .34731 L .49176 .35181 L p F P
0 0 0 r
s
.189 .292 .609 r
.57272 .35887 m .57554 .36705 L .59197 .37053 L p F P
0 0 0 r
s
.189 .292 .609 r
.59523 .38033 m .59197 .37053 L .57554 .36705 L p F P
0 0 0 r
s
.83 .24 .1 r
.74088 .60871 m
.74063 .59424 L
s
.78329 .58812 m
.74063 .59424 L
s
.145 .036 .015 r
.4861 .65657 m .49846 .65484 L .49818 .65142 L p F P
0 0 0 r
s
.83 .24 .1 r
.48464 .65336 m
.49024 .64418 L
s
.145 .036 .015 r
.51287 .64936 m .49818 .65142 L .49846 .65484 L p F P
0 0 0 r
s
.83 .24 .1 r
.35012 .37286 m
.30986 .38017 L
s
.30986 .38017 m
.30071 .38442 L
s
.322 .464 .871 r
.35568 .43289 m .34932 .42106 L .36447 .40788 L p F P
0 0 0 r
s
.322 .464 .871 r
.35878 .39693 m .36447 .40788 L .34932 .42106 L p F P
0 0 0 r
s
.24 .35 .67 r
.3605 .39856 m
.37422 .42498 L
s
.317 .455 .846 r
.34932 .42106 m .35568 .43289 L .34456 .44904 L p F P
0 0 0 r
s
.24 .35 .67 r
.34748 .47305 m
.35824 .44825 L
s
.83 .24 .1 r
.30273 .6763 m
.31377 .67937 L
s
.35406 .67373 m
.31377 .67937 L
s
.7853 .32524 m
.74261 .33282 L
s
.74261 .33282 m
.73885 .31719 L
s
.91 .282 .119 r
.51061 .3484 m .50117 .35011 L .50154 .34506 L p F P
0 0 0 r
s
.91 .282 .119 r
.48917 .34731 m .50154 .34506 L .50117 .35011 L p F P
0 0 0 r
s
.24 .35 .67 r
.49299 .32931 m
.49938 .34545 L
s
.51813 .69627 m
.48858 .69456 L
s
.47708 .67348 m
.48858 .69456 L
s
.321 .468 .89 r
.37295 .3779 m .36801 .36807 L .39162 .36502 L p F P
0 0 0 r
s
.24 .35 .67 r
.3815 .37739 m
.39472 .40408 L
s
.713 .229 .096 r
.40368 .36283 m .39162 .36502 L .36801 .36807 L p F P
0 0 0 r
s
.24 .35 .67 r
.3815 .37739 m
.39916 .36448 L
s
.238 .055 .023 r
.58725 .63892 m .60231 .6368 L .61555 .62787 L p F P
0 0 0 r
s
.238 .055 .023 r
.63266 .62545 m .61555 .62787 L .60231 .6368 L p F P
0 0 0 r
s
.83 .24 .1 r
.57194 .63262 m
.61347 .62674 L
s
.61347 .62674 m
.61545 .61219 L
s
.65346 .33253 m
.61148 .34007 L
s
.61148 .34007 m
.60609 .33056 L
s
.91 .282 .119 r
.52008 .34668 m .51061 .3484 L .51396 .3428 L p F P
0 0 0 r
s
.91 .282 .119 r
.50154 .34506 m .51396 .3428 L .51061 .3484 L p F P
0 0 0 r
s
.145 .036 .015 r
.49846 .65484 m .51086 .6531 L .51287 .64936 L p F P
0 0 0 r
s
.145 .036 .015 r
.52763 .64728 m .51287 .64936 L .51086 .6531 L p F P
0 0 0 r
s
.288 .411 .737 r
.66493 .57433 m .66124 .56309 L .66585 .54506 L p F P
0 0 0 r
s
.313 .45 .822 r
.66124 .56309 m .66493 .57433 L .65611 .59039 L p F P
0 0 0 r
s
.313 .45 .822 r
.65962 .60067 m .65611 .59039 L .66493 .57433 L p F P
0 0 0 r
s
.83 .24 .1 r
.22011 .39903 m
.18049 .40621 L
s
.17059 .41731 m
.18049 .40621 L
s
.222 .338 .69 r
.54862 .34152 m .55092 .34794 L .56698 .3422 L p F P
0 0 0 r
s
.222 .338 .69 r
.56987 .35058 m .56698 .3422 L .55092 .34794 L p F P
0 0 0 r
s
.83 .24 .1 r
.56756 .3439 m
.56996 .34753 L
s
.247 .347 .604 r
.66585 .54506 m .66203 .53307 L .66256 .51405 L p F P
0 0 0 r
s
.288 .411 .737 r
.66203 .53307 m .66585 .54506 L .66124 .56309 L p F P
0 0 0 r
s
.713 .229 .096 r
.41577 .36064 m .40368 .36283 L .38265 .36541 L p F P
0 0 0 r
s
.713 .229 .096 r
.36801 .36807 m .38265 .36541 L .40368 .36283 L p F P
0 0 0 r
s
.24 .35 .67 r
.37631 .36691 m
.3815 .37739 L
s
.83 .24 .1 r
.39083 .36547 m
.39696 .36727 L
s
.326 .471 .874 r
.65611 .59039 m .65962 .60067 L .64657 .61386 L p F P
0 0 0 r
s
.326 .471 .874 r
.64985 .62302 m .64657 .61386 L .65962 .60067 L p F P
0 0 0 r
s
.83 .24 .1 r
.65011 .62156 m
.65547 .6208 L
s
.65547 .6208 m
.65588 .61599 L
s
.24 .35 .67 r
.48157 .30044 m
.49299 .32931 L
s
.49299 .32931 m
.52263 .32866 L
s
.91 .282 .119 r
.52957 .34497 m .52008 .34668 L .52642 .34054 L p F P
0 0 0 r
s
.91 .282 .119 r
.51396 .3428 m .52642 .34054 L .52008 .34668 L p F P
0 0 0 r
s
.83 .24 .1 r
.52201 .34578 m
.52889 .35491 L
s
.48067 .35326 m
.52201 .34578 L
s
.238 .055 .023 r
.60231 .6368 m .61743 .63468 L .63266 .62545 L p F P
0 0 0 r
s
.238 .055 .023 r
.64985 .62302 m .63266 .62545 L .61743 .63468 L p F P
0 0 0 r
s
.24 .35 .67 r
.64892 .62336 m
.6497 .62554 L
s
.191 .261 .437 r
.66256 .51405 m .65864 .50157 L .65529 .48262 L p F P
0 0 0 r
s
.247 .347 .604 r
.65864 .50157 m .66256 .51405 L .66203 .53307 L p F P
0 0 0 r
s
.145 .036 .015 r
.51086 .6531 m .52331 .65136 L .52763 .64728 L p F P
0 0 0 r
s
.145 .036 .015 r
.54245 .64521 m .52763 .64728 L .52331 .65136 L p F P
0 0 0 r
s
.146 .23 .499 r
.59197 .37053 m .59523 .38033 L .61017 .38858 L p F P
0 0 0 r
s
.146 .23 .499 r
.61376 .39967 m .61017 .38858 L .59523 .38033 L p F P
0 0 0 r
s
.713 .229 .096 r
.4279 .35843 m .41577 .36064 L .39734 .36273 L p F P
0 0 0 r
s
.713 .229 .096 r
.38265 .36541 m .39734 .36273 L .41577 .36064 L p F P
0 0 0 r
s
.91 .282 .119 r
.53908 .34324 m .52957 .34497 L .53892 .33827 L p F P
0 0 0 r
s
.91 .282 .119 r
.52642 .34054 m .53892 .33827 L .52957 .34497 L p F P
0 0 0 r
s
.24 .35 .67 r
.52263 .32866 m
.52703 .34043 L
s
.162 .212 .366 r
.37985 .59813 m .37369 .5878 L .36654 .57155 L p F P
0 0 0 r
s
.162 .212 .366 r
.35982 .56026 m .36654 .57155 L .37369 .5878 L p F P
0 0 0 r
s
.208 .282 .479 r
.36654 .57155 m .35982 .56026 L .3558 .5421 L p F P
0 0 0 r
s
.14 .226 .491 r
.43335 .65703 m .4296 .65055 L .41654 .64632 L p F P
0 0 0 r
s
.14 .226 .491 r
.41193 .6385 m .41654 .64632 L .4296 .65055 L p F P
0 0 0 r
s
.208 .282 .479 r
.34871 .53005 m .3558 .5421 L .35982 .56026 L p F P
0 0 0 r
s
.24 .35 .67 r
.35675 .52303 m
.35816 .54777 L
s
.35816 .54777 m
.37194 .57115 L
s
.257 .356 .631 r
.3558 .5421 m .34871 .53005 L .34821 .51097 L p F P
0 0 0 r
s
.071 .103 .253 r
.39517 .62076 m .3897 .61156 L .37985 .59813 L p F P
0 0 0 r
s
.071 .103 .253 r
.37369 .5878 m .37985 .59813 L .3897 .61156 L p F P
0 0 0 r
s
.054 .079 .187 r
.65529 .48262 m .65134 .46994 L .64441 .45213 L p F P
0 0 0 r
s
.191 .261 .437 r
.65134 .46994 m .65529 .48262 L .65864 .50157 L p F P
0 0 0 r
s
.83 .24 .1 r
.78432 .60257 m
.78329 .58812 L
s
.82643 .58194 m
.78329 .58812 L
s
.37524 .3683 m
.39083 .36547 L
s
.238 .055 .023 r
.61743 .63468 m .6326 .63255 L .64985 .62302 L p F P
0 0 0 r
s
.33 .481 .902 r
.64657 .61386 m .64985 .62302 L .6326 .63255 L p F P
0 0 0 r
s
.24 .35 .67 r
.63033 .64822 m
.6497 .62554 L
s
.83 .24 .1 r
.61347 .62674 m
.63972 .62303 L
s
.189 .292 .609 r
.56987 .35058 m .57272 .35887 L .58865 .36058 L p F P
0 0 0 r
s
.189 .292 .609 r
.59197 .37053 m .58865 .36058 L .57272 .35887 L p F P
0 0 0 r
s
.24 .35 .67 r
.58585 .3704 m
.59497 .39738 L
s
.56073 .36102 m
.58585 .3704 L
s
.91 .282 .119 r
.54862 .34152 m .53908 .34324 L .55146 .33599 L p F P
0 0 0 r
s
.91 .282 .119 r
.53892 .33827 m .55146 .33599 L .53908 .34324 L p F P
0 0 0 r
s
.83 .24 .1 r
.34373 .67053 m
.35406 .67373 L
s
.3948 .66802 m
.35406 .67373 L
s
.323 .468 .885 r
.35878 .39693 m .35299 .3858 L .37295 .3779 L p F P
0 0 0 r
s
.323 .468 .885 r
.36801 .36807 m .37295 .3779 L .35299 .3858 L p F P
0 0 0 r
s
.24 .35 .67 r
.3605 .39856 m
.3815 .37739 L
s
.83 .24 .1 r
.35012 .37286 m
.36647 .36989 L
s
.145 .036 .015 r
.52331 .65136 m .5358 .64961 L .54245 .64521 L p F P
0 0 0 r
s
.83 .24 .1 r
.48464 .65336 m
.52601 .64756 L
s
.52601 .64756 m
.53087 .63843 L
s
.145 .036 .015 r
.55732 .64312 m .54245 .64521 L .5358 .64961 L p F P
0 0 0 r
s
.83 .24 .1 r
.7853 .32524 m
.78227 .30939 L
s
.713 .229 .096 r
.44007 .35622 m .4279 .35843 L .4121 .36005 L p F P
0 0 0 r
s
.713 .229 .096 r
.39734 .36273 m .4121 .36005 L .4279 .35843 L p F P
0 0 0 r
s
.288 .406 .735 r
.34821 .51097 m .34094 .49843 L .34431 .47949 L p F P
0 0 0 r
s
.257 .356 .631 r
.34094 .49843 m .34821 .51097 L .34871 .53005 L p F P
0 0 0 r
s
.11 .17 .391 r
.61017 .38858 m .61376 .39967 L .62657 .41202 L p F P
0 0 0 r
s
.11 .17 .391 r
.63037 .42402 m .62657 .41202 L .61376 .39967 L p F P
0 0 0 r
s
.83 .24 .1 r
.69592 .3249 m
.65346 .33253 L
s
.65346 .33253 m
.64884 .32282 L
s
.65295 .62974 m
.65547 .6208 L
s
.65547 .6208 m
.69794 .61479 L
s
.077 .112 .279 r
.64441 .45213 m .64049 .43961 L .63037 .42402 L p F P
0 0 0 r
s
.054 .079 .187 r
.64049 .43961 m .64441 .45213 L .65134 .46994 L p F P
0 0 0 r
s
.626 .205 .086 r
.44926 .66172 m .43706 .66343 L .45053 .66124 L p F P
0 0 0 r
s
.188 .295 .615 r
.43335 .65703 m .43706 .66343 L .45053 .66124 L p F P
0 0 0 r
s
.83 .24 .1 r
.43601 .66225 m
.43791 .66148 L
s
.43791 .66148 m
.43825 .66134 L
s
.44301 .6594 m
.44373 .65911 L
s
.24 .35 .67 r
.44256 .66261 m
.44362 .66316 L
s
.44362 .66316 m
.44945 .6662 L
s
.222 .338 .69 r
.56698 .3422 m .56405 .3337 L .54862 .34152 L p F P
0 0 0 r
s
.91 .282 .119 r
.55146 .33599 m .56405 .3337 L .54862 .34152 L p F P
0 0 0 r
s
.24 .35 .67 r
.55282 .33872 m
.56073 .36102 L
s
.5508 .33299 m
.55183 .33592 L
s
.077 .112 .279 r
.62657 .41202 m .63037 .42402 L .64049 .43961 L p F P
0 0 0 r
s
.24 .35 .67 r
.63276 .4297 m
.64093 .45555 L
s
.61613 .41145 m
.63276 .4297 L
s
.54862 .69219 m
.51813 .69627 L
s
.50719 .67509 m
.51813 .69627 L
s
.713 .229 .096 r
.45228 .354 m .44007 .35622 L .42691 .35736 L p F P
0 0 0 r
s
.713 .229 .096 r
.4121 .36005 m .42691 .35736 L .44007 .35622 L p F P
0 0 0 r
s
.83 .24 .1 r
.43199 .35799 m
.4398 .36066 L
s
.105 .162 .375 r
.41193 .6385 m .40726 .63057 L .39517 .62076 L p F P
0 0 0 r
s
.105 .162 .375 r
.3897 .61156 m .39517 .62076 L .40726 .63057 L p F P
0 0 0 r
s
.24 .35 .67 r
.39337 .61477 m
.39463 .6169 L
s
.37964 .59422 m
.39337 .61477 L
s
.83 .24 .1 r
.26018 .39177 m
.22011 .39903 L
s
.22011 .39903 m
.21088 .41007 L
s
.22212 .68765 m
.20911 .67818 L
s
.2622 .68201 m
.22212 .68765 L
s
.145 .036 .015 r
.5358 .64961 m .54833 .64786 L .55732 .64312 L p F P
0 0 0 r
s
.145 .036 .015 r
.57226 .64102 m .55732 .64312 L .54833 .64786 L p F P
0 0 0 r
s
.288 .406 .735 r
.33708 .46675 m .34431 .47949 L .34094 .49843 L p F P
0 0 0 r
s
.307 .437 .803 r
.34431 .47949 m .33708 .46675 L .34456 .44904 L p F P
0 0 0 r
s
.24 .35 .67 r
.63033 .64822 m
.60619 .66753 L
s
.322 .464 .871 r
.34932 .42106 m .34284 .40901 L .35878 .39693 L p F P
0 0 0 r
s
.322 .464 .871 r
.35299 .3858 m .35878 .39693 L .34284 .40901 L p F P
0 0 0 r
s
.83 .24 .1 r
.52201 .34578 m
.55538 .33974 L
s
.626 .205 .086 r
.45053 .66124 m .46014 .6599 L .44926 .66172 L p F P
0 0 0 r
s
.626 .205 .086 r
.4615 .66001 m .44926 .66172 L .46014 .6599 L p F P
0 0 0 r
s
.307 .437 .803 r
.33759 .43645 m .34456 .44904 L .33708 .46675 L p F P
0 0 0 r
s
.317 .455 .846 r
.34456 .44904 m .33759 .43645 L .34932 .42106 L p F P
0 0 0 r
s
.713 .229 .096 r
.46454 .35178 m .45228 .354 L .44178 .35465 L p F P
0 0 0 r
s
.713 .229 .096 r
.42691 .35736 m .44178 .35465 L .45228 .354 L p F P
0 0 0 r
s
.24 .35 .67 r
.51177 .29958 m
.52263 .32866 L
s
.52263 .32866 m
.5508 .33299 L
s
.317 .455 .846 r
.34284 .40901 m .34932 .42106 L .33759 .43645 L p F P
0 0 0 r
s
.24 .35 .67 r
.34406 .4221 m
.3605 .39856 L
s
.34406 .4221 m
.35824 .44825 L
s
.145 .036 .015 r
.54833 .64786 m .5609 .6461 L .57226 .64102 L p F P
0 0 0 r
s
.145 .036 .015 r
.58725 .63892 m .57226 .64102 L .5609 .6461 L p F P
0 0 0 r
s
.626 .205 .086 r
.46014 .6599 m .46976 .65855 L .4615 .66001 L p F P
0 0 0 r
s
.626 .205 .086 r
.47378 .65829 m .4615 .66001 L .46976 .65855 L p F P
0 0 0 r
s
.713 .229 .096 r
.47683 .34955 m .46454 .35178 L .45672 .35194 L p F P
0 0 0 r
s
.713 .229 .096 r
.44178 .35465 m .45672 .35194 L .46454 .35178 L p F P
0 0 0 r
s
.83 .24 .1 r
.82825 .59635 m
.82643 .58194 L
s
.3852 .6647 m
.3948 .66802 L
s
.3948 .66802 m
.43601 .66225 L
s
.146 .23 .499 r
.58865 .36058 m .59197 .37053 L .60651 .3773 L p F P
0 0 0 r
s
.146 .23 .499 r
.61017 .38858 m .60651 .3773 L .59197 .37053 L p F P
0 0 0 r
s
.24 .35 .67 r
.57848 .68245 m
.54862 .69219 L
s
.53828 .67083 m
.54862 .69219 L
s
.189 .292 .609 r
.56698 .3422 m .56987 .35058 L .58529 .35048 L p F P
0 0 0 r
s
.189 .292 .609 r
.58865 .36058 m .58529 .35048 L .56987 .35058 L p F P
0 0 0 r
s
.24 .35 .67 r
.59708 .64564 m
.60619 .66753 L
s
.60619 .66753 m
.57848 .68245 L
s
.145 .036 .015 r
.5609 .6461 m .57351 .64434 L .58725 .63892 L p F P
0 0 0 r
s
.83 .24 .1 r
.52601 .64756 m
.56785 .64168 L
s
.56785 .64168 m
.57194 .63262 L
s
.145 .036 .015 r
.60231 .6368 m .58725 .63892 L .57351 .64434 L p F P
0 0 0 r
s
.626 .205 .086 r
.46976 .65855 m .47941 .6572 L .47378 .65829 L p F P
0 0 0 r
s
.626 .205 .086 r
.4861 .65657 m .47378 .65829 L .47941 .6572 L p F P
0 0 0 r
s
.288 .411 .737 r
.66124 .56309 m .65747 .55162 L .66203 .53307 L p F P
0 0 0 r
s
.313 .45 .822 r
.65747 .55162 m .66124 .56309 L .65253 .57991 L p F P
0 0 0 r
s
.313 .45 .822 r
.65611 .59039 m .65253 .57991 L .66124 .56309 L p F P
0 0 0 r
s
.83 .24 .1 r
.73885 .31719 m
.69592 .3249 L
s
.69592 .3249 m
.69209 .31499 L
s
.69623 .62367 m
.69794 .61479 L
s
.74088 .60871 m
.69794 .61479 L
s
.326 .471 .874 r
.65253 .57991 m .65611 .59039 L .64324 .60454 L p F P
0 0 0 r
s
.326 .471 .874 r
.64657 .61386 m .64324 .60454 L .65611 .59039 L p F P
0 0 0 r
s
.14 .226 .491 r
.4296 .65055 m .42581 .64399 L .41193 .6385 L p F P
0 0 0 r
s
.14 .226 .491 r
.40726 .63057 m .41193 .6385 L .42581 .64399 L p F P
0 0 0 r
s
.713 .229 .096 r
.48917 .34731 m .47683 .34955 L .47171 .34921 L p F P
0 0 0 r
s
.713 .229 .096 r
.45672 .35194 m .47171 .34921 L .47683 .34955 L p F P
0 0 0 r
s
.83 .24 .1 r
.47363 .35043 m
.48067 .35326 L
s
.247 .347 .604 r
.66203 .53307 m .65812 .52083 L .65864 .50157 L p F P
0 0 0 r
s
.288 .411 .737 r
.65812 .52083 m .66203 .53307 L .65747 .55162 L p F P
0 0 0 r
s
.24 .35 .67 r
.56877 .66085 m
.57848 .68245 L
s
.188 .295 .615 r
.45053 .66124 m .44769 .65621 L .43335 .65703 L p F P
0 0 0 r
s
.188 .295 .615 r
.4296 .65055 m .43335 .65703 L .44769 .65621 L p F P
0 0 0 r
s
.24 .35 .67 r
.47708 .67348 m
.44945 .6662 L
s
.44699 .66186 m
.44945 .6662 L
s
.323 .468 .885 r
.35299 .3858 m .3471 .37447 L .36801 .36807 L p F P
0 0 0 r
s
.103 .028 .012 r
.38265 .36541 m .36801 .36807 L .3471 .37447 L p F P
0 0 0 r
s
.24 .35 .67 r
.37587 .36602 m
.37615 .36659 L
s
.83 .24 .1 r
.30071 .38442 m
.26018 .39177 L
s
.26018 .39177 m
.25163 .40273 L
s
.24984 .67239 m
.2622 .68201 L
s
.30273 .6763 m
.2622 .68201 L
s
.626 .205 .086 r
.47941 .6572 m .48909 .65585 L .4861 .65657 L p F P
0 0 0 r
s
.83 .24 .1 r
.47768 .65641 m
.48464 .65336 L
s
.626 .205 .086 r
.49846 .65484 m .4861 .65657 L .48909 .65585 L p F P
0 0 0 r
s
.145 .036 .015 r
.57351 .64434 m .58617 .64257 L .60231 .6368 L p F P
0 0 0 r
s
.145 .036 .015 r
.61743 .63468 m .60231 .6368 L .58617 .64257 L p F P
0 0 0 r
s
.33 .481 .902 r
.64324 .60454 m .64657 .61386 L .62957 .62452 L p F P
0 0 0 r
s
.24 .35 .67 r
.64571 .6144 m
.64586 .61482 L
s
.33 .481 .902 r
.6326 .63255 m .62957 .62452 L .64657 .61386 L p F P
0 0 0 r
s
.713 .229 .096 r
.50154 .34506 m .48917 .34731 L .48677 .34648 L p F P
0 0 0 r
s
.713 .229 .096 r
.47171 .34921 m .48677 .34648 L .48917 .34731 L p F P
0 0 0 r
s
.191 .261 .437 r
.65864 .50157 m .65464 .48882 L .65134 .46994 L p F P
0 0 0 r
s
.247 .347 .604 r
.65464 .48882 m .65864 .50157 L .65812 .52083 L p F P
0 0 0 r
s
.24 .35 .67 r
.652 .47723 m
.65489 .49114 L
s
.162 .212 .366 r
.37369 .5878 m .36741 .57727 L .35982 .56026 L p F P
0 0 0 r
s
.162 .212 .366 r
.35297 .54874 m .35982 .56026 L .36741 .57727 L p F P
0 0 0 r
s
.208 .282 .479 r
.35982 .56026 m .35297 .54874 L .34871 .53005 L p F P
0 0 0 r
s
.24 .35 .67 r
.35816 .54777 m
.36585 .57104 L
s
.071 .103 .253 r
.3897 .61156 m .38413 .6022 L .37369 .5878 L p F P
0 0 0 r
s
.071 .103 .253 r
.36741 .57727 m .37369 .5878 L .38413 .6022 L p F P
0 0 0 r
s
.24 .35 .67 r
.36585 .57104 m
.37964 .59422 L
s
.11 .17 .391 r
.60651 .3773 m .61017 .38858 L .62269 .3998 L p F P
0 0 0 r
s
.11 .17 .391 r
.62657 .41202 m .62269 .3998 L .61017 .38858 L p F P
0 0 0 r
s
.24 .35 .67 r
.60736 .38445 m
.61613 .41145 L
s
.626 .205 .086 r
.48909 .65585 m .49879 .65449 L .49846 .65484 L p F P
0 0 0 r
s
.626 .205 .086 r
.51086 .6531 m .49846 .65484 L .49879 .65449 L p F P
0 0 0 r
s
.103 .028 .012 r
.39734 .36273 m .38265 .36541 L .36401 .3714 L p F P
0 0 0 r
s
.83 .24 .1 r
.39083 .36547 m
.43199 .35799 L
s
.103 .028 .012 r
.3471 .37447 m .36401 .3714 L .38265 .36541 L p F P
0 0 0 r
s
.208 .282 .479 r
.34147 .51775 m .34871 .53005 L .35297 .54874 L p F P
0 0 0 r
s
.257 .356 .631 r
.34871 .53005 m .34147 .51775 L .34094 .49843 L p F P
0 0 0 r
s
.24 .35 .67 r
.34253 .49844 m
.35675 .52303 L
s
.34253 .49844 m
.34748 .47305 L
s
.054 .079 .187 r
.65134 .46994 m .64731 .45699 L .64049 .43961 L p F P
0 0 0 r
s
.191 .261 .437 r
.64731 .45699 m .65134 .46994 L .65464 .48882 L p F P
0 0 0 r
s
.145 .036 .015 r
.58617 .64257 m .59887 .64079 L .61743 .63468 L p F P
0 0 0 r
s
.145 .036 .015 r
.6326 .63255 m .61743 .63468 L .59887 .64079 L p F P
0 0 0 r
s
.713 .229 .096 r
.51396 .3428 m .50154 .34506 L .50188 .34373 L p F P
0 0 0 r
s
.713 .229 .096 r
.48677 .34648 m .50188 .34373 L .50154 .34506 L p F P
0 0 0 r
s
.105 .162 .375 r
.40726 .63057 m .40251 .62251 L .3897 .61156 L p F P
0 0 0 r
s
.105 .162 .375 r
.38413 .6022 m .3897 .61156 L .40251 .62251 L p F P
0 0 0 r
s
.077 .112 .279 r
.62269 .3998 m .62657 .41202 L .63649 .42683 L p F P
0 0 0 r
s
.077 .112 .279 r
.64049 .43961 m .63649 .42683 L .62657 .41202 L p F P
0 0 0 r
s
.054 .079 .187 r
.63649 .42683 m .64049 .43961 L .64731 .45699 L p F P
0 0 0 r
s
.24 .35 .67 r
.63276 .4297 m
.64395 .45151 L
s
.64395 .45151 m
.65188 .47684 L
s
.288 .406 .735 r
.34094 .49843 m .33351 .48561 L .33708 .46675 L p F P
0 0 0 r
s
.257 .356 .631 r
.33351 .48561 m .34094 .49843 L .34147 .51775 L p F P
0 0 0 r
s
.626 .205 .086 r
.49879 .65449 m .50852 .65313 L .51086 .6531 L p F P
0 0 0 r
s
.626 .205 .086 r
.52331 .65136 m .51086 .6531 L .50852 .65313 L p F P
0 0 0 r
s
.83 .24 .1 r
.42714 .6588 m
.43601 .66225 L
s
.43601 .66225 m
.44434 .66108 L
s
.45 .66029 m
.47768 .65641 L
s
.322 .464 .871 r
.34284 .40901 m .33623 .39672 L .35299 .3858 L p F P
0 0 0 r
s
.322 .464 .871 r
.3471 .37447 m .35299 .3858 L .33623 .39672 L p F P
0 0 0 r
s
.83 .24 .1 r
.34169 .377 m
.35012 .37286 L
s
.103 .028 .012 r
.4121 .36005 m .39734 .36273 L .381 .36832 L p F P
0 0 0 r
s
.103 .028 .012 r
.36401 .3714 m .381 .36832 L .39734 .36273 L p F P
0 0 0 r
s
.24 .35 .67 r
.36772 .34956 m
.37587 .36602 L
s
.713 .229 .096 r
.52642 .34054 m .51396 .3428 L .51706 .34097 L p F P
0 0 0 r
s
.713 .229 .096 r
.50188 .34373 m .51706 .34097 L .51396 .3428 L p F P
0 0 0 r
s
.83 .24 .1 r
.51574 .34278 m
.52201 .34578 L
s
.78227 .30939 m
.73885 .31719 L
s
.73885 .31719 m
.73583 .30707 L
s
.74001 .61752 m
.74088 .60871 L
s
.78432 .60257 m
.74088 .60871 L
s
.145 .036 .015 r
.59887 .64079 m .61161 .63901 L .6326 .63255 L p F P
0 0 0 r
s
.83 .24 .1 r
.56785 .64168 m
.61016 .63575 L
s
.33 .484 .915 r
.62957 .62452 m .6326 .63255 L .61161 .63901 L p F P
0 0 0 r
s
.83 .24 .1 r
.61016 .63575 m
.61347 .62674 L
s
.24 .35 .67 r
.62535 .6353 m
.63033 .64822 L
s
.62517 .63484 m
.62535 .6353 L
s
.5508 .33299 m
.55652 .33507 L
s
.189 .292 .609 r
.56405 .3337 m .56698 .3422 L .58187 .34023 L p F P
0 0 0 r
s
.83 .24 .1 r
.57221 .33669 m
.60609 .33056 L
s
.189 .292 .609 r
.58529 .35048 m .58187 .34023 L .56698 .3422 L p F P
0 0 0 r
s
.24 .35 .67 r
.39301 .33121 m
.4211 .31658 L
s
.40795 .28698 m
.4211 .31658 L
s
.4211 .31658 m
.45098 .30619 L
s
.288 .406 .735 r
.32969 .45373 m .33708 .46675 L .33351 .48561 L p F P
0 0 0 r
s
.307 .437 .803 r
.33708 .46675 m .32969 .45373 L .33759 .43645 L p F P
0 0 0 r
s
.626 .205 .086 r
.50852 .65313 m .51827 .65176 L .52331 .65136 L p F P
0 0 0 r
s
.626 .205 .086 r
.5358 .64961 m .52331 .65136 L .51827 .65176 L p F P
0 0 0 r
s
.146 .23 .499 r
.58529 .35048 m .58865 .36058 L .6028 .36583 L p F P
0 0 0 r
s
.146 .23 .499 r
.60651 .3773 m .6028 .36583 L .58865 .36058 L p F P
0 0 0 r
s
.24 .35 .67 r
.58585 .3704 m
.60736 .38445 L
s
.317 .455 .846 r
.33759 .43645 m .33048 .42361 L .34284 .40901 L p F P
0 0 0 r
s
.317 .455 .846 r
.33623 .39672 m .34284 .40901 L .33048 .42361 L p F P
0 0 0 r
s
.83 .24 .1 r
.30071 .38442 m
.34169 .377 L
s
.30071 .38442 m
.29285 .39532 L
s
.29103 .66653 m
.30273 .6763 L
s
.34373 .67053 m
.30273 .6763 L
s
.307 .437 .803 r
.33048 .42361 m .33759 .43645 L .32969 .45373 L p F P
0 0 0 r
s
.24 .35 .67 r
.33293 .44716 m
.34406 .4221 L
s
.33293 .44716 m
.34748 .47305 L
s
.713 .229 .096 r
.53892 .33827 m .52642 .34054 L .5323 .3382 L p F P
0 0 0 r
s
.713 .229 .096 r
.51706 .34097 m .5323 .3382 L .52642 .34054 L p F P
0 0 0 r
s
.103 .028 .012 r
.42691 .35736 m .4121 .36005 L .39807 .36522 L p F P
0 0 0 r
s
.24 .35 .67 r
.39301 .33121 m
.40562 .35804 L
s
.40562 .35804 m
.40622 .35932 L
s
.103 .028 .012 r
.381 .36832 m .39807 .36522 L .4121 .36005 L p F P
0 0 0 r
s
.83 .24 .1 r
.38314 .36948 m
.3877 .3671 L
s
.24 .35 .67 r
.36772 .34956 m
.39301 .33121 L
s
.37924 .30189 m
.39301 .33121 L
s
.188 .295 .615 r
.44769 .65621 m .44482 .65113 L .4296 .65055 L p F P
0 0 0 r
s
.188 .295 .615 r
.42581 .64399 m .4296 .65055 L .44482 .65113 L p F P
0 0 0 r
s
.24 .35 .67 r
.43845 .27632 m
.45098 .30619 L
s
.45098 .30619 m
.48157 .30044 L
s
.14 .226 .491 r
.42581 .64399 m .42196 .63735 L .40726 .63057 L p F P
0 0 0 r
s
.14 .226 .491 r
.40251 .62251 m .40726 .63057 L .42196 .63735 L p F P
0 0 0 r
s
.83 .24 .1 r
.64884 .32282 m
.60609 .33056 L
s
.60609 .33056 m
.60142 .32722 L
s
.62642 .63346 m
.62779 .63327 L
s
.61016 .63575 m
.61681 .63481 L
s
.21088 .41007 m
.17059 .41731 L
s
.16258 .43474 m
.17059 .41731 L
s
.626 .205 .086 r
.51827 .65176 m .52805 .6504 L .5358 .64961 L p F P
0 0 0 r
s
.83 .24 .1 r
.51982 .65051 m
.52601 .64756 L
s
.626 .205 .086 r
.54833 .64786 m .5358 .64961 L .52805 .6504 L p F P
0 0 0 r
s
.713 .229 .096 r
.55146 .33599 m .53892 .33827 L .54761 .33541 L p F P
0 0 0 r
s
.713 .229 .096 r
.5323 .3382 m .54761 .33541 L .53892 .33827 L p F P
0 0 0 r
s
.103 .028 .012 r
.44178 .35465 m .42691 .35736 L .41522 .36211 L p F P
0 0 0 r
s
.83 .24 .1 r
.43199 .35799 m
.47363 .35043 L
s
.103 .028 .012 r
.39807 .36522 m .41522 .36211 L .42691 .35736 L p F P
0 0 0 r
s
.313 .45 .822 r
.65253 .57991 m .64889 .56923 L .65747 .55162 L p F P
0 0 0 r
s
.326 .471 .874 r
.64889 .56923 m .65253 .57991 L .63984 .59506 L p F P
0 0 0 r
s
.326 .471 .874 r
.64324 .60454 m .63984 .59506 L .65253 .57991 L p F P
0 0 0 r
s
.24 .35 .67 r
.50719 .67509 m
.47708 .67348 L
s
.626 .205 .086 r
.52805 .6504 m .53786 .64902 L .54833 .64786 L p F P
0 0 0 r
s
.626 .205 .086 r
.5609 .6461 m .54833 .64786 L .53786 .64902 L p F P
0 0 0 r
s
.288 .411 .737 r
.65747 .55162 m .65362 .53992 L .65812 .52083 L p F P
0 0 0 r
s
.313 .45 .822 r
.65362 .53992 m .65747 .55162 L .64889 .56923 L p F P
0 0 0 r
s
.713 .229 .096 r
.56405 .3337 m .55146 .33599 L .56297 .33262 L p F P
0 0 0 r
s
.713 .229 .096 r
.54761 .33541 m .56297 .33262 L .55146 .33599 L p F P
0 0 0 r
s
.83 .24 .1 r
.55834 .33505 m
.56227 .33732 L
s
.33 .481 .902 r
.63984 .59506 m .64324 .60454 L .6265 .61637 L p F P
0 0 0 r
s
.24 .35 .67 r
.64239 .60514 m
.64254 .60556 L
s
.33 .481 .902 r
.62957 .62452 m .6265 .61637 L .64324 .60454 L p F P
0 0 0 r
s
.24 .35 .67 r
.35335 .32053 m
.36772 .34956 L
s
.247 .347 .604 r
.65812 .52083 m .65412 .50833 L .65464 .48882 L p F P
0 0 0 r
s
.288 .411 .737 r
.65412 .50833 m .65812 .52083 L .65362 .53992 L p F P
0 0 0 r
s
.103 .028 .012 r
.45672 .35194 m .44178 .35465 L .43245 .35898 L p F P
0 0 0 r
s
.103 .028 .012 r
.41522 .36211 m .43245 .35898 L .44178 .35465 L p F P
0 0 0 r
s
.83 .24 .1 r
.78227 .30939 m
.78008 .29906 L
s
.78429 .61131 m
.78432 .60257 L
s
.82825 .59635 m
.78432 .60257 L
s
.11 .17 .391 r
.6028 .36583 m .60651 .3773 L .61874 .38733 L p F P
0 0 0 r
s
.11 .17 .391 r
.62269 .3998 m .61874 .38733 L .60651 .3773 L p F P
0 0 0 r
s
.626 .205 .086 r
.53786 .64902 m .54769 .64765 L .5609 .6461 L p F P
0 0 0 r
s
.626 .205 .086 r
.57351 .64434 m .5609 .6461 L .54769 .64765 L p F P
0 0 0 r
s
.24 .35 .67 r
.46965 .27032 m
.48157 .30044 L
s
.48157 .30044 m
.51177 .29958 L
s
.071 .103 .253 r
.38413 .6022 m .37846 .59267 L .36741 .57727 L p F P
0 0 0 r
s
.162 .212 .366 r
.36741 .57727 m .36101 .56654 L .35297 .54874 L p F P
0 0 0 r
s
.071 .103 .253 r
.36101 .56654 m .36741 .57727 L .37846 .59267 L p F P
0 0 0 r
s
.24 .35 .67 r
.36585 .57104 m
.3797 .59173 L
s
.856 .268 .114 r
.46014 .6599 m .45053 .66124 L .46574 .65491 L p F P
0 0 0 r
s
.228 .351 .713 r
.44769 .65621 m .45053 .66124 L .46574 .65491 L p F P
0 0 0 r
s
.189 .292 .609 r
.58187 .34023 m .57841 .32981 L .56405 .3337 L p F P
0 0 0 r
s
.24 .35 .67 r
.55806 .33563 m
.57636 .34228 L
s
.713 .229 .096 r
.56297 .33262 m .57841 .32981 L .56405 .3337 L p F P
0 0 0 r
s
.162 .212 .366 r
.34598 .53697 m .35297 .54874 L .36101 .56654 L p F P
0 0 0 r
s
.208 .282 .479 r
.35297 .54874 m .34598 .53697 L .34147 .51775 L p F P
0 0 0 r
s
.83 .24 .1 r
.34169 .377 m
.34627 .37617 L
s
.33269 .6606 m
.34373 .67053 L
s
.3852 .6647 m
.34373 .67053 L
s
.105 .162 .375 r
.40251 .62251 m .39769 .61433 L .38413 .6022 L p F P
0 0 0 r
s
.105 .162 .375 r
.37846 .59267 m .38413 .6022 L .39769 .61433 L p F P
0 0 0 r
s
.24 .35 .67 r
.3797 .59173 m
.38388 .59877 L
s
.191 .261 .437 r
.65464 .48882 m .65055 .4758 L .64731 .45699 L p F P
0 0 0 r
s
.247 .347 .604 r
.65055 .4758 m .65464 .48882 L .65412 .50833 L p F P
0 0 0 r
s
.626 .205 .086 r
.54769 .64765 m .55754 .64627 L .57351 .64434 L p F P
0 0 0 r
s
.626 .205 .086 r
.58617 .64257 m .57351 .64434 L .55754 .64627 L p F P
0 0 0 r
s
.83 .24 .1 r
.20911 .67818 m
.19613 .6622 L
s
.24984 .67239 m
.20911 .67818 L
s
.103 .028 .012 r
.47171 .34921 m .45672 .35194 L .44976 .35584 L p F P
0 0 0 r
s
.103 .028 .012 r
.43245 .35898 m .44976 .35584 L .45672 .35194 L p F P
0 0 0 r
s
.33 .484 .915 r
.6265 .61637 m .62957 .62452 L .60893 .6323 L p F P
0 0 0 r
s
.33 .484 .915 r
.61161 .63901 m .60893 .6323 L .62957 .62452 L p F P
0 0 0 r
s
.83 .24 .1 r
.62779 .63327 m
.65295 .62974 L
s
.69209 .31499 m
.64884 .32282 L
s
.64884 .32282 m
.64501 .31931 L
s
.856 .268 .114 r
.46574 .65491 m .4724 .65397 L .46014 .6599 L p F P
0 0 0 r
s
.856 .268 .114 r
.46976 .65855 m .46014 .6599 L .4724 .65397 L p F P
0 0 0 r
s
.24 .35 .67 r
.46721 .65537 m
.46891 .65848 L
s
.188 .295 .615 r
.44482 .65113 m .44193 .646 L .42581 .64399 L p F P
0 0 0 r
s
.188 .295 .615 r
.42196 .63735 m .42581 .64399 L .44193 .646 L p F P
0 0 0 r
s
.322 .464 .871 r
.33623 .39672 m .3295 .38419 L .3471 .37447 L p F P
0 0 0 r
s
.209 .049 .021 r
.36401 .3714 m .3471 .37447 L .3295 .38419 L p F P
0 0 0 r
s
.83 .24 .1 r
.34121 .37772 m
.34169 .377 L
s
.24 .35 .67 r
.34797 .37444 m
.34804 .37458 L
s
.34923 .37688 m
.3605 .39856 L
s
.83 .24 .1 r
.6492 .63239 m
.65295 .62974 L
s
.69623 .62367 m
.65295 .62974 L
s
.25163 .40273 m
.21088 .41007 L
s
.21088 .41007 m
.2035 .42747 L
s
.208 .282 .479 r
.33407 .50518 m .34147 .51775 L .34598 .53697 L p F P
0 0 0 r
s
.24 .35 .67 r
.34253 .49844 m
.3438 .5234 L
s
.3438 .5234 m
.35816 .54777 L
s
.257 .356 .631 r
.34147 .51775 m .33407 .50518 L .33351 .48561 L p F P
0 0 0 r
s
.077 .112 .279 r
.61874 .38733 m .62269 .3998 L .63241 .41378 L p F P
0 0 0 r
s
.077 .112 .279 r
.63649 .42683 m .63241 .41378 L .62269 .3998 L p F P
0 0 0 r
s
.24 .35 .67 r
.60736 .38445 m
.62423 .40276 L
s
.054 .079 .187 r
.64731 .45699 m .64318 .44377 L .63649 .42683 L p F P
0 0 0 r
s
.191 .261 .437 r
.64318 .44377 m .64731 .45699 L .65055 .4758 L p F P
0 0 0 r
s
.24 .35 .67 r
.64395 .45151 m
.64902 .47604 L
s
.146 .23 .499 r
.58187 .34023 m .58529 .35048 L .59902 .35415 L p F P
0 0 0 r
s
.146 .23 .499 r
.6028 .36583 m .59902 .35415 L .58529 .35048 L p F P
0 0 0 r
s
.24 .35 .67 r
.57636 .34228 m
.58585 .3704 L
s
.054 .079 .187 r
.63241 .41378 m .63649 .42683 L .64318 .44377 L p F P
0 0 0 r
s
.24 .35 .67 r
.62423 .40276 m
.63276 .4297 L
s
.856 .268 .114 r
.4724 .65397 m .47907 .65303 L .46976 .65855 L p F P
0 0 0 r
s
.856 .268 .114 r
.47941 .6572 m .46976 .65855 L .47907 .65303 L p F P
0 0 0 r
s
.24 .35 .67 r
.46891 .65848 m
.47708 .67348 L
s
.626 .205 .086 r
.55754 .64627 m .56743 .64489 L .58617 .64257 L p F P
0 0 0 r
s
.626 .205 .086 r
.59887 .64079 m .58617 .64257 L .56743 .64489 L p F P
0 0 0 r
s
.14 .226 .491 r
.42196 .63735 m .41807 .63062 L .40251 .62251 L p F P
0 0 0 r
s
.14 .226 .491 r
.39769 .61433 m .40251 .62251 L .41807 .63062 L p F P
0 0 0 r
s
.103 .028 .012 r
.48677 .34648 m .47171 .34921 L .46715 .35268 L p F P
0 0 0 r
s
.83 .24 .1 r
.47514 .35016 m
.51574 .34278 L
s
.103 .028 .012 r
.44976 .35584 m .46715 .35268 L .47171 .34921 L p F P
0 0 0 r
s
.288 .406 .735 r
.33351 .48561 m .32593 .47251 L .32969 .45373 L p F P
0 0 0 r
s
.257 .356 .631 r
.32593 .47251 m .33351 .48561 L .33407 .50518 L p F P
0 0 0 r
s
.209 .049 .021 r
.381 .36832 m .36401 .3714 L .34832 .38079 L p F P
0 0 0 r
s
.83 .24 .1 r
.35582 .37443 m
.36029 .37362 L
s
.37324 .37128 m
.38314 .36948 L
s
.24 .35 .67 r
.34619 .37101 m
.36772 .34956 L
s
.209 .049 .021 r
.3295 .38419 m .34832 .38079 L .36401 .3714 L p F P
0 0 0 r
s
.24 .35 .67 r
.34619 .37101 m
.34797 .37444 L
s
.856 .268 .114 r
.47907 .65303 m .48576 .65209 L .47941 .6572 L p F P
0 0 0 r
s
.856 .268 .114 r
.48909 .65585 m .47941 .6572 L .48576 .65209 L p F P
0 0 0 r
s
.83 .24 .1 r
.48827 .65493 m
.51982 .65051 L
s
.24 .35 .67 r
.53828 .67083 m
.50719 .67509 L
s
.57262 .33123 m
.57636 .34228 L
s
.317 .455 .846 r
.33048 .42361 m .32323 .41049 L .33623 .39672 L p F P
0 0 0 r
s
.317 .455 .846 r
.3295 .38419 m .33623 .39672 L .32323 .41049 L p F P
0 0 0 r
s
.626 .205 .086 r
.56743 .64489 m .57733 .6435 L .59887 .64079 L p F P
0 0 0 r
s
.83 .24 .1 r
.56245 .64454 m
.56785 .64168 L
s
.626 .205 .086 r
.61161 .63901 m .59887 .64079 L .57733 .6435 L p F P
0 0 0 r
s
.288 .406 .735 r
.32215 .44044 m .32969 .45373 L .32593 .47251 L p F P
0 0 0 r
s
.307 .437 .803 r
.32969 .45373 m .32215 .44044 L .33048 .42361 L p F P
0 0 0 r
s
.228 .351 .713 r
.46574 .65491 m .46382 .6514 L .44769 .65621 L p F P
0 0 0 r
s
.228 .351 .713 r
.44482 .65113 m .44769 .65621 L .46382 .6514 L p F P
0 0 0 r
s
.83 .24 .1 r
.8291 .60502 m
.82825 .59635 L
s
.24 .35 .67 r
.34068 .37876 m
.34619 .37101 L
s
.32927 .39482 m
.3379 .38267 L
s
.33125 .34227 m
.34619 .37101 L
s
.307 .437 .803 r
.32323 .41049 m .33048 .42361 L .32215 .44044 L p F P
0 0 0 r
s
.24 .35 .67 r
.32927 .39482 m
.34406 .4221 L
s
.103 .028 .012 r
.50188 .34373 m .48677 .34648 L .48463 .34951 L p F P
0 0 0 r
s
.103 .028 .012 r
.46715 .35268 m .48463 .34951 L .48677 .34648 L p F P
0 0 0 r
s
.83 .24 .1 r
.46749 .35419 m
.47113 .35196 L
s
.856 .268 .114 r
.48576 .65209 m .49246 .65115 L .48909 .65585 L p F P
0 0 0 r
s
.856 .268 .114 r
.49879 .65449 m .48909 .65585 L .49246 .65115 L p F P
0 0 0 r
s
.83 .24 .1 r
.37485 .6546 m
.3852 .6647 L
s
.42714 .6588 m
.3852 .6647 L
s
.209 .049 .021 r
.39807 .36522 m .381 .36832 L .36723 .37738 L p F P
0 0 0 r
s
.209 .049 .021 r
.34832 .38079 m .36723 .37738 L .381 .36832 L p F P
0 0 0 r
s
.626 .205 .086 r
.57733 .6435 m .58727 .64211 L .61161 .63901 L p F P
0 0 0 r
s
.326 .48 .916 r
.60893 .6323 m .61161 .63901 L .58727 .64211 L p F P
0 0 0 r
s
.24 .35 .67 r
.60309 .64086 m
.60417 .64 L
s
.59708 .64564 m
.60309 .64086 L
s
.83 .24 .1 r
.6067 .63782 m
.6069 .6377 L
s
.24 .35 .67 r
.50042 .26924 m
.51177 .29958 L
s
.51177 .29958 m
.54044 .30375 L
s
.856 .268 .114 r
.49246 .65115 m .49916 .65021 L .49879 .65449 L p F P
0 0 0 r
s
.24 .35 .67 r
.49577 .65298 m
.49653 .65445 L
s
.856 .268 .114 r
.50852 .65313 m .49879 .65449 L .49916 .65021 L p F P
0 0 0 r
s
.24 .35 .67 r
.49653 .65445 m
.50719 .67509 L
s
.83 .24 .1 r
.23742 .65622 m
.24984 .67239 L
s
.29103 .66653 m
.24984 .67239 L
s
.73583 .30707 m
.69209 .31499 L
s
.69209 .31499 m
.6891 .3113 L
s
.313 .45 .822 r
.64889 .56923 m .64517 .55834 L .65362 .53992 L p F P
0 0 0 r
s
.326 .471 .874 r
.64517 .55834 m .64889 .56923 L .63639 .58541 L p F P
0 0 0 r
s
.326 .471 .874 r
.63984 .59506 m .63639 .58541 L .64889 .56923 L p F P
0 0 0 r
s
.33 .481 .902 r
.63639 .58541 m .63984 .59506 L .62338 .6081 L p F P
0 0 0 r
s
.24 .35 .67 r
.63901 .59572 m
.63916 .59615 L
s
.33 .481 .902 r
.6265 .61637 m .62338 .6081 L .63984 .59506 L p F P
0 0 0 r
s
.83 .24 .1 r
.69333 .62621 m
.69623 .62367 L
s
.74001 .61752 m
.69623 .62367 L
s
.103 .028 .012 r
.51706 .34097 m .50188 .34373 L .50219 .34632 L p F P
0 0 0 r
s
.103 .028 .012 r
.48463 .34951 m .50219 .34632 L .50188 .34373 L p F P
0 0 0 r
s
.83 .24 .1 r
.29285 .39532 m
.25163 .40273 L
s
.25163 .40273 m
.24488 .42011 L
s
.188 .295 .615 r
.44193 .646 m .439 .64081 L .42196 .63735 L p F P
0 0 0 r
s
.24 .35 .67 r
.42127 .63616 m
.42464 .63789 L
s
.188 .295 .615 r
.41807 .63062 m .42196 .63735 L .439 .64081 L p F P
0 0 0 r
s
.856 .268 .114 r
.49916 .65021 m .50589 .64927 L .50852 .65313 L p F P
0 0 0 r
s
.856 .268 .114 r
.51827 .65176 m .50852 .65313 L .50589 .64927 L p F P
0 0 0 r
s
.11 .17 .391 r
.59902 .35415 m .6028 .36583 L .61471 .37462 L p F P
0 0 0 r
s
.11 .17 .391 r
.61874 .38733 m .61471 .37462 L .6028 .36583 L p F P
0 0 0 r
s
.24 .35 .67 r
.59821 .35629 m
.60736 .38445 L
s
.288 .411 .737 r
.65362 .53992 m .6497 .52798 L .65412 .50833 L p F P
0 0 0 r
s
.313 .45 .822 r
.6497 .52798 m .65362 .53992 L .64517 .55834 L p F P
0 0 0 r
s
.24 .35 .67 r
.56877 .66085 m
.53828 .67083 L
s
.209 .049 .021 r
.41522 .36211 m .39807 .36522 L .38625 .37395 L p F P
0 0 0 r
s
.83 .24 .1 r
.39075 .3681 m
.39527 .36728 L
s
.209 .049 .021 r
.36723 .37738 m .38625 .37395 L .39807 .36522 L p F P
0 0 0 r
s
.24 .35 .67 r
.56877 .66085 m
.59708 .64564 L
s
.33 .484 .915 r
.62338 .6081 m .6265 .61637 L .60622 .62551 L p F P
0 0 0 r
s
.33 .484 .915 r
.60893 .6323 m .60622 .62551 L .6265 .61637 L p F P
0 0 0 r
s
.856 .268 .114 r
.50589 .64927 m .51262 .64832 L .51827 .65176 L p F P
0 0 0 r
s
.856 .268 .114 r
.52805 .6504 m .51827 .65176 L .51262 .64832 L p F P
0 0 0 r
s
.83 .24 .1 r
.52427 .64989 m
.56245 .64454 L
s
.103 .028 .012 r
.5323 .3382 m .51706 .34097 L .51983 .34312 L p F P
0 0 0 r
s
.83 .24 .1 r
.51574 .34278 m
.5187 .34224 L
s
.52491 .34112 m
.55834 .33505 L
s
.103 .028 .012 r
.50219 .34632 m .51983 .34312 L .51706 .34097 L p F P
0 0 0 r
s
.105 .162 .375 r
.39769 .61433 m .3928 .60602 L .37846 .59267 L p F P
0 0 0 r
s
.105 .162 .375 r
.3727 .58298 m .37846 .59267 L .3928 .60602 L p F P
0 0 0 r
s
.071 .103 .253 r
.37846 .59267 m .3727 .58298 L .36101 .56654 L p F P
0 0 0 r
s
.162 .212 .366 r
.36101 .56654 m .35448 .5556 L .34598 .53697 L p F P
0 0 0 r
s
.071 .103 .253 r
.35448 .5556 m .36101 .56654 L .3727 .58298 L p F P
0 0 0 r
s
.83 .24 .1 r
.55834 .33505 m
.57471 .33207 L
s
.247 .347 .604 r
.65412 .50833 m .65004 .49556 L .65055 .4758 L p F P
0 0 0 r
s
.24 .35 .67 r
.64902 .47604 m
.65043 .48053 L
s
.288 .411 .737 r
.65004 .49556 m .65412 .50833 L .6497 .52798 L p F P
0 0 0 r
s
.228 .351 .713 r
.46382 .6514 m .4619 .64788 L .44482 .65113 L p F P
0 0 0 r
s
.228 .351 .713 r
.44193 .646 m .44482 .65113 L .4619 .64788 L p F P
0 0 0 r
s
.146 .23 .499 r
.57841 .32981 m .58187 .34023 L .59517 .34226 L p F P
0 0 0 r
s
.83 .24 .1 r
.58012 .33109 m
.60142 .32722 L
s
.146 .23 .499 r
.59902 .35415 m .59517 .34226 L .58187 .34023 L p F P
0 0 0 r
s
.24 .35 .67 r
.57636 .34228 m
.59821 .35629 L
s
.44161 .64544 m
.44485 .64627 L
s
.856 .268 .114 r
.51262 .64832 m .51937 .64737 L .52805 .6504 L p F P
0 0 0 r
s
.856 .268 .114 r
.53786 .64902 m .52805 .6504 L .51937 .64737 L p F P
0 0 0 r
s
.24 .35 .67 r
.52821 .65002 m
.53828 .67083 L
s
.162 .212 .366 r
.33885 .52497 m .34598 .53697 L .35448 .5556 L p F P
0 0 0 r
s
.24 .35 .67 r
.35147 .54685 m
.36585 .57104 L
s
.208 .282 .479 r
.34598 .53697 m .33885 .52497 L .33407 .50518 L p F P
0 0 0 r
s
.24 .35 .67 r
.3438 .5234 m
.35147 .54685 L
s
.14 .226 .491 r
.41807 .63062 m .41412 .6238 L .39769 .61433 L p F P
0 0 0 r
s
.14 .226 .491 r
.3928 .60602 m .39769 .61433 L .41412 .6238 L p F P
0 0 0 r
s
.209 .049 .021 r
.43245 .35898 m .41522 .36211 L .40536 .3705 L p F P
0 0 0 r
s
.83 .24 .1 r
.40835 .36491 m
.41288 .36409 L
s
.209 .049 .021 r
.38625 .37395 m .40536 .3705 L .41522 .36211 L p F P
0 0 0 r
s
.103 .028 .012 r
.54761 .33541 m .5323 .3382 L .53756 .33991 L p F P
0 0 0 r
s
.103 .028 .012 r
.51983 .34312 m .53756 .33991 L .5323 .3382 L p F P
0 0 0 r
s
.191 .261 .437 r
.65055 .4758 m .64638 .46248 L .64318 .44377 L p F P
0 0 0 r
s
.247 .347 .604 r
.64638 .46248 m .65055 .4758 L .65004 .49556 L p F P
0 0 0 r
s
.077 .112 .279 r
.61471 .37462 m .61874 .38733 L .62824 .40046 L p F P
0 0 0 r
s
.077 .112 .279 r
.63241 .41378 m .62824 .40046 L .61874 .38733 L p F P
0 0 0 r
s
.856 .268 .114 r
.51937 .64737 m .52613 .64642 L .53786 .64902 L p F P
0 0 0 r
s
.856 .268 .114 r
.54769 .64765 m .53786 .64902 L .52613 .64642 L p F P
0 0 0 r
s
.24 .35 .67 r
.52749 .64853 m
.52821 .65002 L
s
.83 .24 .1 r
.41749 .64853 m
.42714 .6588 L
s
.42714 .6588 m
.46217 .65387 L
s
.2035 .42747 m
.16258 .43474 L
s
.15699 .45788 m
.16258 .43474 L
s
.208 .282 .479 r
.32652 .49234 m .33407 .50518 L .33885 .52497 L p F P
0 0 0 r
s
.257 .356 .631 r
.33407 .50518 m .32652 .49234 L .32593 .47251 L p F P
0 0 0 r
s
.24 .35 .67 r
.32771 .47279 m
.34253 .49844 L
s
.32771 .47279 m
.33293 .44716 L
s
.326 .48 .916 r
.60622 .62551 m .60893 .6323 L .58506 .63689 L p F P
0 0 0 r
s
.326 .48 .916 r
.58727 .64211 m .58506 .63689 L .60893 .6323 L p F P
0 0 0 r
s
.83 .24 .1 r
.56245 .64454 m
.58685 .64112 L
s
.59687 .63972 m
.60557 .6385 L
s
.24 .35 .67 r
.59521 .64112 m
.59708 .64564 L
s
.83 .24 .1 r
.60557 .6385 m
.6067 .63782 L
s
.2792 .65017 m
.29103 .66653 L
s
.33269 .6606 m
.29103 .66653 L
s
.78008 .29906 m
.73583 .30707 L
s
.73583 .30707 m
.73371 .3032 L
s
.054 .079 .187 r
.64318 .44377 m .63897 .43026 L .63241 .41378 L p F P
0 0 0 r
s
.191 .261 .437 r
.63897 .43026 m .64318 .44377 L .64638 .46248 L p F P
0 0 0 r
s
.054 .079 .187 r
.62824 .40046 m .63241 .41378 L .63897 .43026 L p F P
0 0 0 r
s
.24 .35 .67 r
.63556 .42469 m
.64359 .45036 L
s
.62423 .40276 m
.63556 .42469 L
s
.83 .24 .1 r
.73798 .61995 m
.74001 .61752 L
s
.78429 .61131 m
.74001 .61752 L
s
.29285 .39532 m
.28676 .41267 L
s
.856 .268 .114 r
.52613 .64642 m .5329 .64547 L .54769 .64765 L p F P
0 0 0 r
s
.856 .268 .114 r
.55754 .64627 m .54769 .64765 L .5329 .64547 L p F P
0 0 0 r
s
.209 .049 .021 r
.44976 .35584 m .43245 .35898 L .42457 .36703 L p F P
0 0 0 r
s
.83 .24 .1 r
.42602 .36171 m
.43058 .36088 L
s
.209 .049 .021 r
.40536 .3705 m .42457 .36703 L .43245 .35898 L p F P
0 0 0 r
s
.103 .028 .012 r
.56297 .33262 m .54761 .33541 L .55537 .33667 L p F P
0 0 0 r
s
.24 .35 .67 r
.54044 .30375 m
.55033 .33167 L
s
.55033 .33167 m
.5508 .33299 L
s
.103 .028 .012 r
.53756 .33991 m .55537 .33667 L .54761 .33541 L p F P
0 0 0 r
s
.317 .455 .846 r
.32323 .41049 m .31582 .39711 L .3295 .38419 L p F P
0 0 0 r
s
.305 .071 .031 r
.34832 .38079 m .3295 .38419 L .31582 .39711 L p F P
0 0 0 r
s
.24 .35 .67 r
.32737 .39131 m
.32927 .39482 L
s
.188 .295 .615 r
.439 .64081 m .43605 .63558 L .41807 .63062 L p F P
0 0 0 r
s
.188 .295 .615 r
.41412 .6238 m .41807 .63062 L .43605 .63558 L p F P
0 0 0 r
s
.288 .406 .735 r
.32593 .47251 m .31817 .45913 L .32215 .44044 L p F P
0 0 0 r
s
.257 .356 .631 r
.31817 .45913 m .32593 .47251 L .32652 .49234 L p F P
0 0 0 r
s
.856 .268 .114 r
.5329 .64547 m .53968 .64452 L .55754 .64627 L p F P
0 0 0 r
s
.856 .268 .114 r
.56743 .64489 m .55754 .64627 L .53968 .64452 L p F P
0 0 0 r
s
.24 .35 .67 r
.56186 .64547 m
.56877 .66085 L
s
.228 .351 .713 r
.4619 .64788 m .45996 .64433 L .44193 .646 L p F P
0 0 0 r
s
.228 .351 .713 r
.439 .64081 m .44193 .646 L .45996 .64433 L p F P
0 0 0 r
s
.24 .35 .67 r
.52962 .27323 m
.54044 .30375 L
s
.54044 .30375 m
.56644 .31292 L
s
.37924 .30189 m
.40795 .28698 L
s
.39421 .25608 m
.40795 .28698 L
s
.40795 .28698 m
.43845 .27632 L
s
.83 .24 .1 r
.64501 .31931 m
.60142 .32722 L
s
.288 .406 .735 r
.31444 .42686 m .32215 .44044 L .31817 .45913 L p F P
0 0 0 r
s
.307 .437 .803 r
.32215 .44044 m .31444 .42686 L .32323 .41049 L p F P
0 0 0 r
s
.307 .437 .803 r
.31582 .39711 m .32323 .41049 L .31444 .42686 L p F P
0 0 0 r
s
.24 .35 .67 r
.31775 .42014 m
.33293 .44716 L
s
.103 .028 .012 r
.57841 .32981 m .56297 .33262 L .57327 .33343 L p F P
0 0 0 r
s
.24 .35 .67 r
.56644 .31292 m
.57231 .33029 L
s
.57231 .33029 m
.57251 .33089 L
s
.103 .028 .012 r
.55537 .33667 m .57327 .33343 L .56297 .33262 L p F P
0 0 0 r
s
.209 .049 .021 r
.46715 .35268 m .44976 .35584 L .44389 .36354 L p F P
0 0 0 r
s
.83 .24 .1 r
.44379 .35849 m
.44837 .35766 L
s
.46164 .35526 m
.46749 .35419 L
s
.209 .049 .021 r
.42457 .36703 m .44389 .36354 L .44976 .35584 L p F P
0 0 0 r
s
.856 .268 .114 r
.53968 .64452 m .54647 .64356 L .56743 .64489 L p F P
0 0 0 r
s
.856 .268 .114 r
.57733 .6435 m .56743 .64489 L .54647 .64356 L p F P
0 0 0 r
s
.326 .471 .874 r
.63639 .58541 m .63288 .57559 L .64517 .55834 L p F P
0 0 0 r
s
.24 .35 .67 r
.64481 .55885 m
.6452 .55816 L
s
.33 .481 .902 r
.63288 .57559 m .63639 .58541 L .62021 .5997 L p F P
0 0 0 r
s
.24 .35 .67 r
.63557 .58614 m
.63573 .58657 L
s
.33 .481 .902 r
.62338 .6081 m .62021 .5997 L .63639 .58541 L p F P
0 0 0 r
s
.24 .35 .67 r
.35335 .32053 m
.37924 .30189 L
s
.36486 .27128 m
.37924 .30189 L
s
.305 .071 .031 r
.36723 .37738 m .34832 .38079 L .33611 .39347 L p F P
0 0 0 r
s
.305 .071 .031 r
.31582 .39711 m .33611 .39347 L .34832 .38079 L p F P
0 0 0 r
s
.24 .35 .67 r
.31775 .42014 m
.32927 .39482 L
s
.31384 .36635 m
.32586 .38852 L
s
.83 .24 .1 r
.29285 .39532 m
.32357 .38979 L
s
.33 .484 .915 r
.62021 .5997 m .62338 .6081 L .60347 .61863 L p F P
0 0 0 r
s
.33 .484 .915 r
.60622 .62551 m .60347 .61863 L .62338 .6081 L p F P
0 0 0 r
s
.313 .45 .822 r
.64517 .55834 m .64138 .54724 L .6497 .52798 L p F P
0 0 0 r
s
.326 .471 .874 r
.64138 .54724 m .64517 .55834 L .63288 .57559 L p F P
0 0 0 r
s
.83 .24 .1 r
.19613 .6622 m
.18384 .64023 L
s
.23742 .65622 m
.19613 .6622 L
s
.11 .17 .391 r
.59517 .34226 m .59902 .35415 L .61061 .36166 L p F P
0 0 0 r
s
.11 .17 .391 r
.61471 .37462 m .61061 .36166 L .59902 .35415 L p F P
0 0 0 r
s
.24 .35 .67 r
.42536 .24514 m
.43845 .27632 L
s
.43845 .27632 m
.46965 .27032 L
s
.856 .268 .114 r
.54647 .64356 m .55328 .64261 L .57733 .6435 L p F P
0 0 0 r
s
.856 .268 .114 r
.58727 .64211 m .57733 .6435 L .55328 .64261 L p F P
0 0 0 r
s
.967 .295 .126 r
.4724 .65397 m .46574 .65491 L .48236 .64436 L p F P
0 0 0 r
s
.257 .392 .782 r
.46382 .6514 m .46574 .65491 L .48236 .64436 L p F P
0 0 0 r
s
.24 .35 .67 r
.46367 .65112 m
.46421 .65126 L
s
.146 .23 .499 r
.59517 .34226 m .59125 .33016 L .57841 .32981 L p F P
0 0 0 r
s
.103 .028 .012 r
.57327 .33343 m .59125 .33016 L .57841 .32981 L p F P
0 0 0 r
s
.209 .049 .021 r
.48463 .34951 m .46715 .35268 L .4633 .36003 L p F P
0 0 0 r
s
.209 .049 .021 r
.44389 .36354 m .4633 .36003 L .46715 .35268 L p F P
0 0 0 r
s
.83 .24 .1 r
.24488 .42011 m
.2035 .42747 L
s
.2035 .42747 m
.19844 .45065 L
s
.105 .162 .375 r
.3928 .60602 m .38783 .59759 L .3727 .58298 L p F P
0 0 0 r
s
.105 .162 .375 r
.36683 .57312 m .3727 .58298 L .38783 .59759 L p F P
0 0 0 r
s
.071 .103 .253 r
.3727 .58298 m .36683 .57312 L .35448 .5556 L p F P
0 0 0 r
s
.83 .24 .1 r
.32147 .64405 m
.33269 .6606 L
s
.37485 .6546 m
.33269 .6606 L
s
.967 .295 .126 r
.48236 .64436 m .48579 .64388 L .4724 .65397 L p F P
0 0 0 r
s
.967 .295 .126 r
.47907 .65303 m .4724 .65397 L .48579 .64388 L p F P
0 0 0 r
s
.288 .411 .737 r
.6497 .52798 m .64569 .51578 L .65004 .49556 L p F P
0 0 0 r
s
.313 .45 .822 r
.64569 .51578 m .6497 .52798 L .64138 .54724 L p F P
0 0 0 r
s
.856 .268 .114 r
.55328 .64261 m .5601 .64165 L .58727 .64211 L p F P
0 0 0 r
s
.24 .35 .67 r
.56043 .64229 m
.56186 .64547 L
s
.319 .473 .909 r
.58506 .63689 m .58727 .64211 L .5601 .64165 L p F P
0 0 0 r
s
.14 .226 .491 r
.41412 .6238 m .41013 .6169 L .3928 .60602 L p F P
0 0 0 r
s
.14 .226 .491 r
.38783 .59759 m .3928 .60602 L .41013 .6169 L p F P
0 0 0 r
s
.83 .24 .1 r
.78008 .29906 m
.77885 .295 L
s
.78316 .61362 m
.78429 .61131 L
s
.8291 .60502 m
.78429 .61131 L
s
.326 .48 .916 r
.60347 .61863 m .60622 .62551 L .58282 .63161 L p F P
0 0 0 r
s
.326 .48 .916 r
.58506 .63689 m .58282 .63161 L .60622 .62551 L p F P
0 0 0 r
s
.83 .24 .1 r
.60557 .6385 m
.6492 .63239 L
s
.59985 .63449 m
.60557 .6385 L
s
.305 .071 .031 r
.38625 .37395 m .36723 .37738 L .35652 .38982 L p F P
0 0 0 r
s
.305 .071 .031 r
.33611 .39347 m .35652 .38982 L .36723 .37738 L p F P
0 0 0 r
s
.162 .212 .366 r
.35448 .5556 m .34782 .54445 L .33885 .52497 L p F P
0 0 0 r
s
.071 .103 .253 r
.34782 .54445 m .35448 .5556 L .36683 .57312 L p F P
0 0 0 r
s
.967 .295 .126 r
.48579 .64388 m .48923 .64339 L .47907 .65303 L p F P
0 0 0 r
s
.967 .295 .126 r
.48576 .65209 m .47907 .65303 L .48923 .64339 L p F P
0 0 0 r
s
.24 .35 .67 r
.47955 .65219 m
.49577 .65298 L
s
.4763 .65203 m
.47955 .65219 L
s
.228 .351 .713 r
.45996 .64433 m .45801 .64076 L .439 .64081 L p F P
0 0 0 r
s
.228 .351 .713 r
.43605 .63558 m .439 .64081 L .45801 .64076 L p F P
0 0 0 r
s
.967 .295 .126 r
.48923 .64339 m .49268 .6429 L .48576 .65209 L p F P
0 0 0 r
s
.967 .295 .126 r
.49246 .65115 m .48576 .65209 L .49268 .6429 L p F P
0 0 0 r
s
.24 .35 .67 r
.33125 .34227 m
.35335 .32053 L
s
.33834 .29022 m
.35335 .32053 L
s
.209 .049 .021 r
.50219 .34632 m .48463 .34951 L .48282 .35651 L p F P
0 0 0 r
s
.83 .24 .1 r
.47958 .352 m
.4842 .35117 L
s
.209 .049 .021 r
.4633 .36003 m .48282 .35651 L .48463 .34951 L p F P
0 0 0 r
s
.247 .347 .604 r
.65004 .49556 m .64588 .48251 L .64638 .46248 L p F P
0 0 0 r
s
.288 .411 .737 r
.64588 .48251 m .65004 .49556 L .64569 .51578 L p F P
0 0 0 r
s
.188 .295 .615 r
.43605 .63558 m .43306 .63029 L .41412 .6238 L p F P
0 0 0 r
s
.188 .295 .615 r
.41013 .6169 m .41412 .6238 L .43306 .63029 L p F P
0 0 0 r
s
.257 .392 .782 r
.48236 .64436 m .4814 .64255 L .46382 .6514 L p F P
0 0 0 r
s
.257 .392 .782 r
.4619 .64788 m .46382 .6514 L .4814 .64255 L p F P
0 0 0 r
s
.83 .24 .1 r
.46539 .64794 m
.46633 .64904 L
s
.162 .212 .366 r
.33156 .51271 m .33885 .52497 L .34782 .54445 L p F P
0 0 0 r
s
.208 .282 .479 r
.33885 .52497 m .33156 .51271 L .32652 .49234 L p F P
0 0 0 r
s
.967 .295 .126 r
.49268 .6429 m .49612 .64242 L .49246 .65115 L p F P
0 0 0 r
s
.967 .295 .126 r
.49916 .65021 m .49246 .65115 L .49612 .64242 L p F P
0 0 0 r
s
.83 .24 .1 r
.6891 .3113 m
.64501 .31931 L
s
.64501 .31931 m
.64217 .32253 L
s
.24 .35 .67 r
.4572 .23886 m
.46965 .27032 L
s
.46965 .27032 m
.50042 .26924 L
s
.077 .112 .279 r
.61061 .36166 m .61471 .37462 L .62399 .38686 L p F P
0 0 0 r
s
.077 .112 .279 r
.62824 .40046 m .62399 .38686 L .61471 .37462 L p F P
0 0 0 r
s
.83 .24 .1 r
.64431 .62824 m
.6492 .63239 L
s
.69333 .62621 m
.6492 .63239 L
s
.305 .071 .031 r
.40536 .3705 m .38625 .37395 L .37704 .38614 L p F P
0 0 0 r
s
.305 .071 .031 r
.35652 .38982 m .37704 .38614 L .38625 .37395 L p F P
0 0 0 r
s
.967 .295 .126 r
.49612 .64242 m .49957 .64193 L .49916 .65021 L p F P
0 0 0 r
s
.967 .295 .126 r
.50589 .64927 m .49916 .65021 L .49957 .64193 L p F P
0 0 0 r
s
.191 .261 .437 r
.64638 .46248 m .64211 .44888 L .63897 .43026 L p F P
0 0 0 r
s
.247 .347 .604 r
.64211 .44888 m .64638 .46248 L .64588 .48251 L p F P
0 0 0 r
s
.83 .24 .1 r
.22561 .63404 m
.23742 .65622 L
s
.2792 .65017 m
.23742 .65622 L
s
.209 .049 .021 r
.51983 .34312 m .50219 .34632 L .50245 .35297 L p F P
0 0 0 r
s
.83 .24 .1 r
.4976 .34874 m
.50225 .34789 L
s
.209 .049 .021 r
.48282 .35651 m .50245 .35297 L .50219 .34632 L p F P
0 0 0 r
s
.967 .295 .126 r
.49957 .64193 m .50302 .64144 L .50589 .64927 L p F P
0 0 0 r
s
.967 .295 .126 r
.51262 .64832 m .50589 .64927 L .50302 .64144 L p F P
0 0 0 r
s
.83 .24 .1 r
.51081 .64702 m
.51249 .64679 L
s
.51249 .64679 m
.51488 .648 L
s
.208 .282 .479 r
.3188 .47922 m .32652 .49234 L .33156 .51271 L p F P
0 0 0 r
s
.24 .35 .67 r
.32771 .47279 m
.32882 .49797 L
s
.32882 .49797 m
.3438 .5234 L
s
.257 .356 .631 r
.32652 .49234 m .3188 .47922 L .31817 .45913 L p F P
0 0 0 r
s
.054 .079 .187 r
.62399 .38686 m .62824 .40046 L .63467 .41646 L p F P
0 0 0 r
s
.24 .35 .67 r
.61533 .37464 m
.62423 .40276 L
s
.054 .079 .187 r
.63897 .43026 m .63467 .41646 L .62824 .40046 L p F P
0 0 0 r
s
.319 .473 .909 r
.58282 .63161 m .58506 .63689 L .55849 .63806 L p F P
0 0 0 r
s
.319 .473 .909 r
.5601 .64165 m .55849 .63806 L .58506 .63689 L p F P
0 0 0 r
s
.191 .261 .437 r
.63467 .41646 m .63897 .43026 L .64211 .44888 L p F P
0 0 0 r
s
.24 .35 .67 r
.63556 .42469 m
.64063 .44941 L
s
.967 .295 .126 r
.50302 .64144 m .50648 .64095 L .51262 .64832 L p F P
0 0 0 r
s
.967 .295 .126 r
.51937 .64737 m .51262 .64832 L .50648 .64095 L p F P
0 0 0 r
s
.83 .24 .1 r
.28676 .41267 m
.24488 .42011 L
s
.24488 .42011 m
.24038 .44333 L
s
.36423 .63786 m
.37485 .6546 L
s
.41749 .64853 m
.37485 .6546 L
s
.257 .392 .782 r
.4814 .64255 m .48044 .64072 L .4619 .64788 L p F P
0 0 0 r
s
.257 .392 .782 r
.45996 .64433 m .4619 .64788 L .48044 .64072 L p F P
0 0 0 r
s
.33 .481 .902 r
.62021 .5997 m .61699 .59116 L .63288 .57559 L p F P
0 0 0 r
s
.33 .484 .915 r
.61699 .59116 m .62021 .5997 L .60068 .61166 L p F P
0 0 0 r
s
.33 .484 .915 r
.60347 .61863 m .60068 .61166 L .62021 .5997 L p F P
0 0 0 r
s
.305 .071 .031 r
.42457 .36703 m .40536 .3705 L .39768 .38245 L p F P
0 0 0 r
s
.305 .071 .031 r
.37704 .38614 m .39768 .38245 L .40536 .3705 L p F P
0 0 0 r
s
.83 .24 .1 r
.82887 .60722 m
.8291 .60502 L
s
.228 .351 .713 r
.45801 .64076 m .45604 .63716 L .43605 .63558 L p F P
0 0 0 r
s
.228 .351 .713 r
.43306 .63029 m .43605 .63558 L .45604 .63716 L p F P
0 0 0 r
s
.967 .295 .126 r
.50648 .64095 m .50994 .64046 L .51937 .64737 L p F P
0 0 0 r
s
.967 .295 .126 r
.52613 .64642 m .51937 .64737 L .50994 .64046 L p F P
0 0 0 r
s
.326 .471 .874 r
.63288 .57559 m .6293 .56559 L .64138 .54724 L p F P
0 0 0 r
s
.33 .481 .902 r
.6293 .56559 m .63288 .57559 L .61699 .59116 L p F P
0 0 0 r
s
.209 .049 .021 r
.53756 .33991 m .51983 .34312 L .52217 .3494 L p F P
0 0 0 r
s
.83 .24 .1 r
.51571 .34545 m
.52038 .34461 L
s
.209 .049 .021 r
.50245 .35297 m .52217 .3494 L .51983 .34312 L p F P
0 0 0 r
s
.288 .406 .735 r
.31817 .45913 m .31025 .44545 L .31444 .42686 L p F P
0 0 0 r
s
.257 .356 .631 r
.31025 .44545 m .31817 .45913 L .3188 .47922 L p F P
0 0 0 r
s
.326 .48 .916 r
.60068 .61166 m .60347 .61863 L .58056 .62629 L p F P
0 0 0 r
s
.326 .48 .916 r
.58282 .63161 m .58056 .62629 L .60347 .61863 L p F P
0 0 0 r
s
.967 .295 .126 r
.50994 .64046 m .5134 .63997 L .52613 .64642 L p F P
0 0 0 r
s
.967 .295 .126 r
.5329 .64547 m .52613 .64642 L .5134 .63997 L p F P
0 0 0 r
s
.11 .17 .391 r
.59125 .33016 m .59517 .34226 L .60642 .34845 L p F P
0 0 0 r
s
.11 .17 .391 r
.61061 .36166 m .60642 .34845 L .59517 .34226 L p F P
0 0 0 r
s
.24 .35 .67 r
.59821 .35629 m
.61533 .37464 L
s
.49577 .65298 m
.52749 .64853 L
s
.49105 .64384 m
.49577 .65298 L
s
.55609 .28227 m
.56644 .31292 L
s
.56644 .31292 m
.58866 .32689 L
s
.307 .437 .803 r
.31444 .42686 m .30656 .41298 L .31582 .39711 L p F P
0 0 0 r
s
.45 .114 .05 r
.33611 .39347 m .31582 .39711 L .30656 .41298 L p F P
0 0 0 r
s
.83 .24 .1 r
.19844 .45065 m
.15699 .45788 L
s
.15419 .48576 m
.15699 .45788 L
s
.288 .406 .735 r
.30656 .41298 m .31444 .42686 L .31025 .44545 L p F P
0 0 0 r
s
.14 .226 .491 r
.41013 .6169 m .40608 .60991 L .38783 .59759 L p F P
0 0 0 r
s
.14 .226 .491 r
.38278 .58902 m .38783 .59759 L .40608 .60991 L p F P
0 0 0 r
s
.105 .162 .375 r
.38783 .59759 m .38278 .58902 L .36683 .57312 L p F P
0 0 0 r
s
.313 .45 .822 r
.64138 .54724 m .63752 .53592 L .64569 .51578 L p F P
0 0 0 r
s
.326 .471 .874 r
.63752 .53592 m .64138 .54724 L .6293 .56559 L p F P
0 0 0 r
s
.967 .295 .126 r
.5134 .63997 m .51687 .63948 L .5329 .64547 L p F P
0 0 0 r
s
.967 .295 .126 r
.53968 .64452 m .5329 .64547 L .51687 .63948 L p F P
0 0 0 r
s
.24 .35 .67 r
.31384 .36635 m
.33125 .34227 L
s
.31566 .31224 m
.33125 .34227 L
s
.83 .24 .1 r
.73371 .3032 m
.6891 .3113 L
s
.6891 .3113 m
.68715 .31438 L
s
.305 .071 .031 r
.44389 .36354 m .42457 .36703 L .41843 .37873 L p F P
0 0 0 r
s
.305 .071 .031 r
.39768 .38245 m .41843 .37873 L .42457 .36703 L p F P
0 0 0 r
s
.188 .295 .615 r
.43306 .63029 m .43005 .62495 L .41013 .6169 L p F P
0 0 0 r
s
.188 .295 .615 r
.40608 .60991 m .41013 .6169 L .43005 .62495 L p F P
0 0 0 r
s
.105 .162 .375 r
.36085 .56308 m .36683 .57312 L .38278 .58902 L p F P
0 0 0 r
s
.071 .103 .253 r
.36683 .57312 m .36085 .56308 L .34782 .54445 L p F P
0 0 0 r
s
.24 .35 .67 r
.36543 .56769 m
.36704 .5704 L
s
.83 .24 .1 r
.68929 .62191 m
.69333 .62621 L
s
.73798 .61995 m
.69333 .62621 L
s
.209 .049 .021 r
.55537 .33667 m .53756 .33991 L .54201 .34582 L p F P
0 0 0 r
s
.83 .24 .1 r
.53391 .34216 m
.53861 .3413 L
s
.55221 .33884 m
.55381 .33855 L
s
.55381 .33855 m
.5565 .33647 L
s
.209 .049 .021 r
.52217 .3494 m .54201 .34582 L .53756 .33991 L p F P
0 0 0 r
s
.967 .295 .126 r
.51687 .63948 m .52033 .63899 L .53968 .64452 L p F P
0 0 0 r
s
.967 .295 .126 r
.54647 .64356 m .53968 .64452 L .52033 .63899 L p F P
0 0 0 r
s
.257 .392 .782 r
.48044 .64072 m .47948 .63889 L .45996 .64433 L p F P
0 0 0 r
s
.257 .392 .782 r
.45801 .64076 m .45996 .64433 L .47948 .63889 L p F P
0 0 0 r
s
.83 .24 .1 r
.46064 .64239 m
.46539 .64794 L
s
.24 .35 .67 r
.48857 .23754 m
.50042 .26924 L
s
.50042 .26924 m
.52962 .27323 L
s
.967 .295 .126 r
.52033 .63899 m .52381 .63849 L .54647 .64356 L p F P
0 0 0 r
s
.967 .295 .126 r
.55328 .64261 m .54647 .64356 L .52381 .63849 L p F P
0 0 0 r
s
.83 .24 .1 r
.26787 .62778 m
.2792 .65017 L
s
.32147 .64405 m
.2792 .65017 L
s
.319 .473 .909 r
.58056 .62629 m .58282 .63161 L .55686 .63444 L p F P
0 0 0 r
s
.319 .473 .909 r
.55849 .63806 m .55686 .63444 L .58282 .63161 L p F P
0 0 0 r
s
.45 .114 .05 r
.35652 .38982 m .33611 .39347 L .32785 .40921 L p F P
0 0 0 r
s
.45 .114 .05 r
.30656 .41298 m .32785 .40921 L .33611 .39347 L p F P
0 0 0 r
s
.24 .35 .67 r
.31307 .41183 m
.31775 .42014 L
s
.30969 .40581 m
.3107 .4076 L
s
.30189 .39193 m
.30969 .40581 L
s
.288 .411 .737 r
.64569 .51578 m .6416 .50333 L .64588 .48251 L p F P
0 0 0 r
s
.313 .45 .822 r
.6416 .50333 m .64569 .51578 L .63752 .53592 L p F P
0 0 0 r
s
.162 .212 .366 r
.34782 .54445 m .34104 .53307 L .33156 .51271 L p F P
0 0 0 r
s
.071 .103 .253 r
.34104 .53307 m .34782 .54445 L .36085 .56308 L p F P
0 0 0 r
s
.24 .35 .67 r
.35147 .54685 m
.36543 .56769 L
s
.967 .295 .126 r
.52381 .63849 m .52728 .638 L .55328 .64261 L p F P
0 0 0 r
s
.967 .295 .126 r
.5601 .64165 m .55328 .64261 L .52728 .638 L p F P
0 0 0 r
s
.83 .24 .1 r
.55391 .64096 m
.55591 .64068 L
s
.55591 .64068 m
.55697 .6413 L
s
.56351 .63961 m
.59985 .63449 L
s
.55591 .64068 m
.55944 .64018 L
s
.305 .071 .031 r
.4633 .36003 m .44389 .36354 L .43931 .37499 L p F P
0 0 0 r
s
.305 .071 .031 r
.41843 .37873 m .43931 .37499 L .44389 .36354 L p F P
0 0 0 r
s
.228 .351 .713 r
.45604 .63716 m .45406 .63354 L .43306 .63029 L p F P
0 0 0 r
s
.228 .351 .713 r
.43005 .62495 m .43306 .63029 L .45406 .63354 L p F P
0 0 0 r
s
.83 .24 .1 r
.28676 .41267 m
.30905 .40871 L
s
.28676 .41267 m
.28282 .43592 L
s
.18384 .64023 m
.17295 .61323 L
s
.22561 .63404 m
.18384 .64023 L
s
.209 .049 .021 r
.57327 .33343 m .55537 .33667 L .56195 .34222 L p F P
0 0 0 r
s
.83 .24 .1 r
.55381 .33855 m
.55692 .33799 L
s
.209 .049 .021 r
.54201 .34582 m .56195 .34222 L .55537 .33667 L p F P
0 0 0 r
s
.24 .35 .67 r
.52749 .64853 m
.5439 .64314 L
s
.5439 .64314 m
.5472 .64206 L
s
.83 .24 .1 r
.40751 .63159 m
.41749 .64853 L
s
.41749 .64853 m
.46064 .64239 L
s
.967 .295 .126 r
.52728 .638 m .53076 .63751 L .5601 .64165 L p F P
0 0 0 r
s
.24 .35 .67 r
.52303 .63931 m
.52749 .64853 L
s
.31 .461 .893 r
.55849 .63806 m .5601 .64165 L .53076 .63751 L p F P
0 0 0 r
s
.077 .112 .279 r
.60642 .34845 m .61061 .36166 L .61965 .37298 L p F P
0 0 0 r
s
.077 .112 .279 r
.62399 .38686 m .61965 .37298 L .61061 .36166 L p F P
0 0 0 r
s
.257 .392 .782 r
.47948 .63889 m .47852 .63705 L .45801 .64076 L p F P
0 0 0 r
s
.257 .392 .782 r
.45604 .63716 m .45801 .64076 L .47852 .63705 L p F P
0 0 0 r
s
.247 .347 .604 r
.64588 .48251 m .64162 .46917 L .64211 .44888 L p F P
0 0 0 r
s
.24 .35 .67 r
.64063 .44941 m
.64199 .45374 L
s
.288 .411 .737 r
.64162 .46917 m .64588 .48251 L .6416 .50333 L p F P
0 0 0 r
s
.162 .212 .366 r
.32412 .50019 m .33156 .51271 L .34104 .53307 L p F P
0 0 0 r
s
.208 .282 .479 r
.33156 .51271 m .32412 .50019 L .3188 .47922 L p F P
0 0 0 r
s
.45 .114 .05 r
.37704 .38614 m .35652 .38982 L .34926 .40541 L p F P
0 0 0 r
s
.45 .114 .05 r
.32785 .40921 m .34926 .40541 L .35652 .38982 L p F P
0 0 0 r
s
.33 .484 .915 r
.60068 .61166 m .59786 .6046 L .61699 .59116 L p F P
0 0 0 r
s
.326 .48 .916 r
.59786 .6046 m .60068 .61166 L .57828 .62091 L p F P
0 0 0 r
s
.326 .48 .916 r
.58056 .62629 m .57828 .62091 L .60068 .61166 L p F P
0 0 0 r
s
.83 .24 .1 r
.24038 .44333 m
.19844 .45065 L
s
.19844 .45065 m
.19608 .47861 L
s
.33 .481 .902 r
.61699 .59116 m .61372 .58249 L .6293 .56559 L p F P
0 0 0 r
s
.33 .484 .915 r
.61372 .58249 m .61699 .59116 L .59786 .6046 L p F P
0 0 0 r
s
.209 .049 .021 r
.59125 .33016 m .57327 .33343 L .58199 .3386 L p F P
0 0 0 r
s
.83 .24 .1 r
.57059 .33551 m
.57533 .33465 L
s
.58906 .33216 m
.59212 .33161 L
s
.209 .049 .021 r
.56195 .34222 m .58199 .3386 L .57327 .33343 L p F P
0 0 0 r
s
.305 .071 .031 r
.48282 .35651 m .4633 .36003 L .4603 .37123 L p F P
0 0 0 r
s
.305 .071 .031 r
.43931 .37499 m .4603 .37123 L .4633 .36003 L p F P
0 0 0 r
s
.83 .24 .1 r
.77885 .295 m
.73371 .3032 L
s
.73371 .3032 m
.73266 .30613 L
s
.73481 .6155 m
.73798 .61995 L
s
.78316 .61362 m
.73798 .61995 L
s
.191 .261 .437 r
.64211 .44888 m .63774 .43497 L .63467 .41646 L p F P
0 0 0 r
s
.247 .347 .604 r
.63774 .43497 m .64211 .44888 L .64162 .46917 L p F P
0 0 0 r
s
.319 .473 .909 r
.57828 .62091 m .58056 .62629 L .55522 .6308 L p F P
0 0 0 r
s
.319 .473 .909 r
.55686 .63444 m .55522 .6308 L .58056 .62629 L p F P
0 0 0 r
s
.188 .295 .615 r
.43005 .62495 m .427 .61956 L .40608 .60991 L p F P
0 0 0 r
s
.188 .295 .615 r
.40198 .60282 m .40608 .60991 L .427 .61956 L p F P
0 0 0 r
s
.14 .226 .491 r
.40608 .60991 m .40198 .60282 L .38278 .58902 L p F P
0 0 0 r
s
.31 .461 .893 r
.55686 .63444 m .55849 .63806 L .52988 .63567 L p F P
0 0 0 r
s
.31 .461 .893 r
.53076 .63751 m .52988 .63567 L .55849 .63806 L p F P
0 0 0 r
s
.326 .471 .874 r
.6293 .56559 m .62566 .55541 L .63752 .53592 L p F P
0 0 0 r
s
.33 .481 .902 r
.62566 .55541 m .6293 .56559 L .61372 .58249 L p F P
0 0 0 r
s
.054 .079 .187 r
.61965 .37298 m .62399 .38686 L .63028 .40235 L p F P
0 0 0 r
s
.054 .079 .187 r
.63467 .41646 m .63028 .40235 L .62399 .38686 L p F P
0 0 0 r
s
.24 .35 .67 r
.61533 .37464 m
.62679 .39668 L
s
.14 .226 .491 r
.37766 .58031 m .38278 .58902 L .40198 .60282 L p F P
0 0 0 r
s
.105 .162 .375 r
.38278 .58902 m .37766 .58031 L .36085 .56308 L p F P
0 0 0 r
s
.208 .282 .479 r
.3109 .46581 m .3188 .47922 L .32412 .50019 L p F P
0 0 0 r
s
.257 .356 .631 r
.3188 .47922 m .3109 .46581 L .31025 .44545 L p F P
0 0 0 r
s
.24 .35 .67 r
.31223 .44602 m
.32771 .47279 L
s
.31223 .44602 m
.31775 .42014 L
s
.83 .24 .1 r
.31063 .62144 m
.32147 .64405 L
s
.36423 .63786 m
.32147 .64405 L
s
.45 .114 .05 r
.39768 .38245 m .37704 .38614 L .3708 .4016 L p F P
0 0 0 r
s
.45 .114 .05 r
.34926 .40541 m .3708 .4016 L .37704 .38614 L p F P
0 0 0 r
s
.191 .261 .437 r
.63028 .40235 m .63467 .41646 L .63774 .43497 L p F P
0 0 0 r
s
.24 .35 .67 r
.62679 .39668 m
.63493 .42269 L
s
.257 .392 .782 r
.47852 .63705 m .47755 .63521 L .45604 .63716 L p F P
0 0 0 r
s
.257 .392 .782 r
.45406 .63354 m .45604 .63716 L .47755 .63521 L p F P
0 0 0 r
s
.998 .299 .128 r
.48579 .64388 m .48236 .64436 L .5 .62969 L closepath p F P
0 0 0 r
s
.28 .422 .832 r
.4814 .64255 m .48236 .64436 L .5 .62969 L closepath p F P
0 0 0 r
s
.11 .17 .391 r
.60642 .34845 m .60215 .33496 L .59125 .33016 L p F P
0 0 0 r
s
.209 .049 .021 r
.58199 .3386 m .60215 .33496 L .59125 .33016 L p F P
0 0 0 r
s
.83 .24 .1 r
.59773 .33059 m
.60142 .32722 L
s
.59382 .3313 m
.59773 .33059 L
s
.24 .35 .67 r
.59188 .33682 m
.59821 .35629 L
s
.58866 .32689 m
.58985 .33055 L
s
.58985 .33055 m
.5899 .3307 L
s
.228 .351 .713 r
.45406 .63354 m .45207 .62989 L .43005 .62495 L p F P
0 0 0 r
s
.228 .351 .713 r
.427 .61956 m .43005 .62495 L .45207 .62989 L p F P
0 0 0 r
s
.305 .071 .031 r
.50245 .35297 m .48282 .35651 L .48141 .36745 L p F P
0 0 0 r
s
.305 .071 .031 r
.4603 .37123 m .48141 .36745 L .48282 .35651 L p F P
0 0 0 r
s
.998 .299 .128 r
.48923 .64339 m .48579 .64388 L .5 .62969 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.30189 .39193 m
.31384 .36635 L
s
.29771 .3366 m
.31384 .36635 L
s
.83 .24 .1 r
.59773 .33059 m
.64217 .32253 L
s
.5972 .33279 m
.59773 .33059 L
s
.59319 .62353 m
.59985 .63449 L
s
.64431 .62824 m
.59985 .63449 L
s
.998 .299 .128 r
.49268 .6429 m .48923 .64339 L .5 .62969 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.21506 .60682 m
.22561 .63404 L
s
.26787 .62778 m
.22561 .63404 L
s
.46064 .64239 m
.47809 .6399 L
s
.105 .162 .375 r
.35477 .55285 m .36085 .56308 L .37766 .58031 L p F P
0 0 0 r
s
.071 .103 .253 r
.36085 .56308 m .35477 .55285 L .34104 .53307 L p F P
0 0 0 r
s
.998 .299 .128 r
.49612 .64242 m .49268 .6429 L .5 .62969 L closepath p F P
0 0 0 r
s
.288 .406 .735 r
.31025 .44545 m .30214 .43146 L .30656 .41298 L p F P
0 0 0 r
s
.257 .356 .631 r
.30214 .43146 m .31025 .44545 L .3109 .46581 L p F P
0 0 0 r
s
.28 .422 .832 r
.48044 .64072 m .4814 .64255 L .5 .62969 L closepath p F P
0 0 0 r
s
.313 .45 .822 r
.63752 .53592 m .63357 .52438 L .6416 .50333 L p F P
0 0 0 r
s
.326 .471 .874 r
.63357 .52438 m .63752 .53592 L .62566 .55541 L p F P
0 0 0 r
s
.24 .35 .67 r
.62434 .55483 m
.62699 .55022 L
s
.998 .299 .128 r
.49957 .64193 m .49612 .64242 L .5 .62969 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.19608 .47861 m
.15419 .48576 L
s
.15445 .51698 m
.15419 .48576 L
s
.24 .35 .67 r
.51832 .24133 m
.52962 .27323 L
s
.52962 .27323 m
.55609 .28227 L
s
.998 .299 .128 r
.50302 .64144 m .49957 .64193 L .5 .62969 L closepath p F P
0 0 0 r
s
.31 .461 .893 r
.55522 .6308 m .55686 .63444 L .529 .63382 L p F P
0 0 0 r
s
.31 .461 .893 r
.52988 .63567 m .529 .63382 L .55686 .63444 L p F P
0 0 0 r
s
.24 .35 .67 r
.36486 .27128 m
.39421 .25608 L
s
.37986 .22379 m
.39421 .25608 L
s
.39421 .25608 m
.42536 .24514 L
s
.564 .15 .065 r
.32785 .40921 m .30656 .41298 L .30214 .43146 L p F P
0 0 0 r
s
.45 .114 .05 r
.41843 .37873 m .39768 .38245 L .39247 .39776 L p F P
0 0 0 r
s
.45 .114 .05 r
.3708 .4016 m .39247 .39776 L .39768 .38245 L p F P
0 0 0 r
s
.998 .299 .128 r
.50648 .64095 m .50302 .64144 L .5 .62969 L closepath p F P
0 0 0 r
s
.305 .071 .031 r
.52217 .3494 m .50245 .35297 L .50265 .36364 L p F P
0 0 0 r
s
.305 .071 .031 r
.48141 .36745 m .50265 .36364 L .50245 .35297 L p F P
0 0 0 r
s
.998 .299 .128 r
.50994 .64046 m .50648 .64095 L .5 .62969 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.28282 .43592 m
.24038 .44333 L
s
.24038 .44333 m
.23846 .47138 L
s
.24 .35 .67 r
.57868 .29617 m
.58866 .32689 L
s
.58866 .32689 m
.5943 .33285 L
s
.257 .392 .782 r
.47755 .63521 m .47658 .63336 L .45406 .63354 L p F P
0 0 0 r
s
.257 .392 .782 r
.45207 .62989 m .45406 .63354 L .47658 .63336 L p F P
0 0 0 r
s
.24 .35 .67 r
.45257 .62852 m
.45342 .63008 L
s
.28 .422 .832 r
.47948 .63889 m .48044 .64072 L .5 .62969 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.33834 .29022 m
.36486 .27128 L
s
.34983 .2393 m
.36486 .27128 L
s
.998 .299 .128 r
.5134 .63997 m .50994 .64046 L .5 .62969 L closepath p F P
0 0 0 r
s
.33 .484 .915 r
.59786 .6046 m .59501 .59744 L .61372 .58249 L p F P
0 0 0 r
s
.326 .48 .916 r
.59501 .59744 m .59786 .6046 L .57598 .61547 L p F P
0 0 0 r
s
.326 .48 .916 r
.57828 .62091 m .57598 .61547 L .59786 .6046 L p F P
0 0 0 r
s
.319 .473 .909 r
.57598 .61547 m .57828 .62091 L .55358 .62713 L p F P
0 0 0 r
s
.319 .473 .909 r
.55522 .6308 m .55358 .62713 L .57828 .62091 L p F P
0 0 0 r
s
.83 .24 .1 r
.77885 .295 m
.77872 .29779 L
s
.24 .35 .67 r
.41169 .21254 m
.42536 .24514 L
s
.42536 .24514 m
.4572 .23886 L
s
.998 .299 .128 r
.51687 .63948 m .5134 .63997 L .5 .62969 L closepath p F P
0 0 0 r
s
.162 .212 .366 r
.34104 .53307 m .33411 .52147 L .32412 .50019 L p F P
0 0 0 r
s
.071 .103 .253 r
.33411 .52147 m .34104 .53307 L .35477 .55285 L p F P
0 0 0 r
s
.24 .35 .67 r
.33645 .5216 m
.35147 .54685 L
s
.32882 .49797 m
.33645 .5216 L
s
.83 .24 .1 r
.78089 .60902 m
.78316 .61362 L
s
.82887 .60722 m
.78316 .61362 L
s
.998 .299 .128 r
.52033 .63899 m .51687 .63948 L .5 .62969 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.17295 .61323 m
.16409 .58255 L
s
.21506 .60682 m
.17295 .61323 L
s
.288 .411 .737 r
.6416 .50333 m .63742 .49061 L .64162 .46917 L p F P
0 0 0 r
s
.313 .45 .822 r
.63742 .49061 m .6416 .50333 L .63357 .52438 L p F P
0 0 0 r
s
.998 .299 .128 r
.52381 .63849 m .52033 .63899 L .5 .62969 L closepath p F P
0 0 0 r
s
.228 .351 .713 r
.45207 .62989 m .45006 .62621 L .427 .61956 L p F P
0 0 0 r
s
.24 .35 .67 r
.45112 .62816 m
.45257 .62852 L
s
.228 .351 .713 r
.42393 .61411 m .427 .61956 L .45006 .62621 L p F P
0 0 0 r
s
.188 .295 .615 r
.427 .61956 m .42393 .61411 L .40198 .60282 L p F P
0 0 0 r
s
.28 .422 .832 r
.47852 .63705 m .47948 .63889 L .5 .62969 L closepath p F P
0 0 0 r
s
.33 .481 .902 r
.61372 .58249 m .6104 .57368 L .62566 .55541 L p F P
0 0 0 r
s
.24 .35 .67 r
.62434 .55483 m
.62488 .55635 L
s
.33 .484 .915 r
.6104 .57368 m .61372 .58249 L .59501 .59744 L p F P
0 0 0 r
s
.45 .114 .05 r
.43931 .37499 m .41843 .37873 L .41427 .3939 L p F P
0 0 0 r
s
.45 .114 .05 r
.39247 .39776 m .41427 .3939 L .41843 .37873 L p F P
0 0 0 r
s
.188 .295 .615 r
.39782 .59565 m .40198 .60282 L .42393 .61411 L p F P
0 0 0 r
s
.14 .226 .491 r
.40198 .60282 m .39782 .59565 L .37766 .58031 L p F P
0 0 0 r
s
.564 .15 .065 r
.34926 .40541 m .32785 .40921 L .3239 .42766 L p F P
0 0 0 r
s
.564 .15 .065 r
.30214 .43146 m .3239 .42766 L .32785 .40921 L p F P
0 0 0 r
s
.998 .299 .128 r
.52728 .638 m .52381 .63849 L .5 .62969 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.3539 .61503 m
.36423 .63786 L
s
.40751 .63159 m
.36423 .63786 L
s
.305 .071 .031 r
.54201 .34582 m .52217 .3494 L .524 .35982 L p F P
0 0 0 r
s
.305 .071 .031 r
.50265 .36364 m .524 .35982 L .52217 .3494 L p F P
0 0 0 r
s
.31 .461 .893 r
.55358 .62713 m .55522 .6308 L .52812 .63196 L p F P
0 0 0 r
s
.31 .461 .893 r
.529 .63382 m .52812 .63196 L .55522 .6308 L p F P
0 0 0 r
s
.998 .299 .128 r
.53076 .63751 m .52728 .638 L .5 .62969 L closepath p F P
0 0 0 r
s
.077 .112 .279 r
.60215 .33496 m .60642 .34845 L .61521 .35879 L p F P
0 0 0 r
s
.077 .112 .279 r
.61965 .37298 m .61521 .35879 L .60642 .34845 L p F P
0 0 0 r
s
.83 .24 .1 r
.68715 .31438 m
.64217 .32253 L
s
.64217 .32253 m
.64054 .33276 L
s
.297 .444 .868 r
.5 .62969 m .52988 .63567 L .53076 .63751 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.63844 .61709 m
.64431 .62824 L
s
.68929 .62191 m
.64431 .62824 L
s
.257 .392 .782 r
.47658 .63336 m .4756 .6315 L .45207 .62989 L p F P
0 0 0 r
s
.257 .392 .782 r
.45006 .62621 m .45207 .62989 L .4756 .6315 L p F P
0 0 0 r
s
.28 .422 .832 r
.47755 .63521 m .47852 .63705 L .5 .62969 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.25766 .60033 m
.26787 .62778 L
s
.31063 .62144 m
.26787 .62778 L
s
.14 .226 .491 r
.37245 .57147 m .37766 .58031 L .39782 .59565 L p F P
0 0 0 r
s
.24 .35 .67 r
.3715 .57293 m
.37517 .5761 L
s
.105 .162 .375 r
.37766 .58031 m .37245 .57147 L .35477 .55285 L p F P
0 0 0 r
s
.162 .212 .366 r
.31652 .48741 m .32412 .50019 L .33411 .52147 L p F P
0 0 0 r
s
.208 .282 .479 r
.32412 .50019 m .31652 .48741 L .3109 .46581 L p F P
0 0 0 r
s
.24 .35 .67 r
.31566 .31224 m
.33834 .29022 L
s
.32265 .25853 m
.33834 .29022 L
s
.247 .347 .604 r
.64162 .46917 m .63726 .45554 L .63774 .43497 L p F P
0 0 0 r
s
.288 .411 .737 r
.63726 .45554 m .64162 .46917 L .63742 .49061 L p F P
0 0 0 r
s
.326 .471 .874 r
.62566 .55541 m .62195 .54505 L .63357 .52438 L p F P
0 0 0 r
s
.33 .481 .902 r
.62195 .54505 m .62566 .55541 L .6104 .57368 L p F P
0 0 0 r
s
.83 .24 .1 r
.23846 .47138 m
.19608 .47861 L
s
.19608 .47861 m
.19663 .50996 L
s
.45 .114 .05 r
.4603 .37123 m .43931 .37499 L .4362 .39001 L p F P
0 0 0 r
s
.45 .114 .05 r
.41427 .3939 m .4362 .39001 L .43931 .37499 L p F P
0 0 0 r
s
.297 .444 .868 r
.5 .62969 m .529 .63382 L .52988 .63567 L closepath p F P
0 0 0 r
s
.305 .071 .031 r
.56195 .34222 m .54201 .34582 L .54548 .35597 L p F P
0 0 0 r
s
.305 .071 .031 r
.524 .35982 m .54548 .35597 L .54201 .34582 L p F P
0 0 0 r
s
.564 .15 .065 r
.3708 .4016 m .34926 .40541 L .3458 .42383 L p F P
0 0 0 r
s
.564 .15 .065 r
.3239 .42766 m .3458 .42383 L .34926 .40541 L p F P
0 0 0 r
s
.83 .24 .1 r
.32577 .42843 m
.32593 .4273 L
s
.24 .35 .67 r
.44418 .20598 m
.4572 .23886 L
s
.4572 .23886 m
.48857 .23754 L
s
.28 .422 .832 r
.47658 .63336 m .47755 .63521 L .5 .62969 L closepath p F P
0 0 0 r
s
.326 .48 .916 r
.57598 .61547 m .57365 .60998 L .59501 .59744 L p F P
0 0 0 r
s
.319 .473 .909 r
.57365 .60998 m .57598 .61547 L .55192 .62344 L p F P
0 0 0 r
s
.319 .473 .909 r
.55358 .62713 m .55192 .62344 L .57598 .61547 L p F P
0 0 0 r
s
.83 .24 .1 r
.19663 .50996 m
.15445 .51698 L
s
.15781 .54985 m
.15445 .51698 L
s
.28282 .43592 m
.28136 .46406 L
s
.31 .461 .893 r
.55192 .62344 m .55358 .62713 L .52723 .6301 L p F P
0 0 0 r
s
.31 .461 .893 r
.52812 .63196 m .52723 .6301 L .55358 .62713 L p F P
0 0 0 r
s
.83 .24 .1 r
.5307 .63242 m
.53486 .63183 L
s
.054 .079 .187 r
.61521 .35879 m .61965 .37298 L .62578 .38792 L p F P
0 0 0 r
s
.054 .079 .187 r
.63028 .40235 m .62578 .38792 L .61965 .37298 L p F P
0 0 0 r
s
.191 .261 .437 r
.63774 .43497 m .63328 .42074 L .63028 .40235 L p F P
0 0 0 r
s
.247 .347 .604 r
.63328 .42074 m .63774 .43497 L .63726 .45554 L p F P
0 0 0 r
s
.297 .444 .868 r
.5 .62969 m .52812 .63196 L .529 .63382 L closepath p F P
0 0 0 r
s
.257 .392 .782 r
.4756 .6315 m .47462 .62964 L .45006 .62621 L p F P
0 0 0 r
s
.257 .392 .782 r
.44804 .62252 m .45006 .62621 L .47462 .62964 L p F P
0 0 0 r
s
.228 .351 .713 r
.45006 .62621 m .44804 .62252 L .42393 .61411 L p F P
0 0 0 r
s
.228 .351 .713 r
.42082 .60861 m .42393 .61411 L .44804 .62252 L p F P
0 0 0 r
s
.188 .295 .615 r
.42393 .61411 m .42082 .60861 L .39782 .59565 L p F P
0 0 0 r
s
.83 .24 .1 r
.82752 .60246 m
.82887 .60722 L
s
.33 .484 .915 r
.59501 .59744 m .59211 .59019 L .6104 .57368 L p F P
0 0 0 r
s
.326 .48 .916 r
.59211 .59019 m .59501 .59744 L .57365 .60998 L p F P
0 0 0 r
s
.105 .162 .375 r
.34858 .54244 m .35477 .55285 L .37245 .57147 L p F P
0 0 0 r
s
.071 .103 .253 r
.35477 .55285 m .34858 .54244 L .33411 .52147 L p F P
0 0 0 r
s
.28 .422 .832 r
.4756 .6315 m .47658 .63336 L .5 .62969 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.16409 .58255 m
.15781 .54985 L
s
.20639 .57592 m
.16409 .58255 L
s
.208 .282 .479 r
.30283 .4521 m .3109 .46581 L .31652 .48741 L p F P
0 0 0 r
s
.24 .35 .67 r
.31316 .47141 m
.32882 .49797 L
s
.257 .356 .631 r
.3109 .46581 m .30283 .4521 L .30214 .43146 L p F P
0 0 0 r
s
.83 .24 .1 r
.28282 .43592 m
.30218 .43254 L
s
.20639 .57592 m
.21506 .60682 L
s
.25766 .60033 m
.21506 .60682 L
s
.191 .261 .437 r
.62578 .38792 m .63028 .40235 L .63328 .42074 L p F P
0 0 0 r
s
.24 .35 .67 r
.62679 .39668 m
.63186 .42159 L
s
.305 .071 .031 r
.58199 .3386 m .56195 .34222 L .56709 .3521 L p F P
0 0 0 r
s
.305 .071 .031 r
.54548 .35597 m .56709 .3521 L .56195 .34222 L p F P
0 0 0 r
s
.45 .114 .05 r
.48141 .36745 m .4603 .37123 L .45826 .38611 L p F P
0 0 0 r
s
.45 .114 .05 r
.4362 .39001 m .45826 .38611 L .4603 .37123 L p F P
0 0 0 r
s
.24 .35 .67 r
.29606 .41804 m
.30189 .39193 L
s
.28532 .36243 m
.30189 .39193 L
s
.564 .15 .065 r
.39247 .39776 m .3708 .4016 L .36783 .41999 L p F P
0 0 0 r
s
.564 .15 .065 r
.3458 .42383 m .36783 .41999 L .3708 .4016 L p F P
0 0 0 r
s
.313 .45 .822 r
.63357 .52438 m .62955 .5126 L .63742 .49061 L p F P
0 0 0 r
s
.326 .471 .874 r
.62955 .5126 m .63357 .52438 L .62195 .54505 L p F P
0 0 0 r
s
.297 .444 .868 r
.5 .62969 m .52723 .6301 L .52812 .63196 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.20012 .54302 m
.15781 .54985 L
s
.188 .295 .615 r
.39361 .58837 m .39782 .59565 L .42082 .60861 L p F P
0 0 0 r
s
.14 .226 .491 r
.39782 .59565 m .39361 .58837 L .37245 .57147 L p F P
0 0 0 r
s
.28 .422 .832 r
.47462 .62964 m .4756 .6315 L .5 .62969 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.47396 .62946 m
.47822 .62965 L
s
.83 .24 .1 r
.73266 .30613 m
.68715 .31438 L
s
.68715 .31438 m
.68637 .32451 L
s
.68424 .61057 m
.68929 .62191 L
s
.73481 .6155 m
.68929 .62191 L
s
.648 .176 .076 r
.3239 .42766 m .30214 .43146 L .30283 .4521 L p F P
0 0 0 r
s
.24 .35 .67 r
.31056 .44313 m
.31223 .44602 L
s
.83 .24 .1 r
.3228 .42894 m
.32577 .42843 L
s
.24 .35 .67 r
.31223 .44602 m
.31316 .47141 L
s
.319 .473 .909 r
.55192 .62344 m .55024 .61972 L .57365 .60998 L p F P
0 0 0 r
s
.31 .461 .893 r
.55024 .61972 m .55192 .62344 L .52635 .62823 L p F P
0 0 0 r
s
.31 .461 .893 r
.52723 .6301 m .52635 .62823 L .55192 .62344 L p F P
0 0 0 r
s
.83 .24 .1 r
.53486 .63183 m
.54848 .62989 L
s
.54848 .62989 m
.55322 .63676 L
s
.30078 .59377 m
.31063 .62144 L
s
.3539 .61503 m
.31063 .62144 L
s
.24 .35 .67 r
.54526 .25022 m
.55609 .28227 L
s
.55609 .28227 m
.57868 .29617 L
s
.33 .481 .902 r
.6104 .57368 m .60702 .56474 L .62195 .54505 L p F P
0 0 0 r
s
.33 .484 .915 r
.60702 .56474 m .6104 .57368 L .59211 .59019 L p F P
0 0 0 r
s
.297 .444 .868 r
.5 .62969 m .52635 .62823 L .52723 .6301 L closepath p F P
0 0 0 r
s
.305 .071 .031 r
.60215 .33496 m .58199 .3386 L .58882 .34821 L p F P
0 0 0 r
s
.305 .071 .031 r
.56709 .3521 m .58882 .34821 L .58199 .3386 L p F P
0 0 0 r
s
.257 .392 .782 r
.47462 .62964 m .47364 .62777 L .44804 .62252 L p F P
0 0 0 r
s
.257 .392 .782 r
.446 .61879 m .44804 .62252 L .47364 .62777 L p F P
0 0 0 r
s
.228 .351 .713 r
.44804 .62252 m .446 .61879 L .42082 .60861 L p F P
0 0 0 r
s
.28 .422 .832 r
.47364 .62777 m .47462 .62964 L .5 .62969 L closepath p F P
0 0 0 r
s
.45 .114 .05 r
.50265 .36364 m .48141 .36745 L .48046 .38217 L p F P
0 0 0 r
s
.45 .114 .05 r
.45826 .38611 m .48046 .38217 L .48141 .36745 L p F P
0 0 0 r
s
.24 .35 .67 r
.29771 .3366 m
.31566 .31224 L
s
.29935 .28084 m
.31566 .31224 L
s
.326 .48 .916 r
.57365 .60998 m .5713 .60443 L .59211 .59019 L p F P
0 0 0 r
s
.319 .473 .909 r
.5713 .60443 m .57365 .60998 L .55024 .61972 L p F P
0 0 0 r
s
.83 .24 .1 r
.28136 .46406 m
.23846 .47138 L
s
.23846 .47138 m
.23932 .50287 L
s
.162 .212 .366 r
.33411 .52147 m .32705 .50963 L .31652 .48741 L p F P
0 0 0 r
s
.071 .103 .253 r
.32705 .50963 m .33411 .52147 L .34858 .54244 L p F P
0 0 0 r
s
.564 .15 .065 r
.41427 .3939 m .39247 .39776 L .38999 .41611 L p F P
0 0 0 r
s
.564 .15 .065 r
.36783 .41999 m .38999 .41611 L .39247 .39776 L p F P
0 0 0 r
s
.83 .24 .1 r
.36923 .42084 m
.36937 .41972 L
s
.23932 .50287 m
.19663 .50996 L
s
.19663 .50996 m
.20012 .54302 L
s
.14 .226 .491 r
.36716 .56249 m .37245 .57147 L .39361 .58837 L p F P
0 0 0 r
s
.105 .162 .375 r
.37245 .57147 m .36716 .56249 L .34858 .54244 L p F P
0 0 0 r
s
.24 .35 .67 r
.33645 .5216 m
.35053 .54257 L
s
.35053 .54257 m
.3538 .54808 L
s
.31 .461 .893 r
.52635 .62823 m .52545 .62636 L .55024 .61972 L p F P
0 0 0 r
s
.297 .444 .868 r
.5 .62969 m .52545 .62636 L .52635 .62823 L closepath p F P
0 0 0 r
s
.228 .351 .713 r
.41768 .60304 m .42082 .60861 L .446 .61879 L p F P
0 0 0 r
s
.188 .295 .615 r
.42082 .60861 m .41768 .60304 L .39361 .58837 L p F P
0 0 0 r
s
.83 .24 .1 r
.3977 .60854 m
.40751 .63159 L
s
.24 .35 .67 r
.47619 .2044 m
.48857 .23754 L
s
.48857 .23754 m
.51832 .24133 L
s
.288 .411 .737 r
.63742 .49061 m .63315 .47762 L .63726 .45554 L p F P
0 0 0 r
s
.313 .45 .822 r
.63315 .47762 m .63742 .49061 L .62955 .5126 L p F P
0 0 0 r
s
.24 .35 .67 r
.63039 .50289 m
.63063 .50213 L
s
.63039 .50289 m
.63051 .50326 L
s
.28 .422 .832 r
.47266 .62589 m .47364 .62777 L .5 .62969 L closepath p F P
0 0 0 r
s
.257 .392 .782 r
.47364 .62777 m .47266 .62589 L .446 .61879 L p F P
0 0 0 r
s
.648 .176 .076 r
.3458 .42383 m .3239 .42766 L .32452 .44837 L p F P
0 0 0 r
s
.648 .176 .076 r
.30283 .4521 m .32452 .44837 L .3239 .42766 L p F P
0 0 0 r
s
.24 .35 .67 r
.29606 .41804 m
.30366 .43119 L
s
.992 .294 .126 r
.5 .62969 m .5182 .61112 L .51464 .61163 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.4925 .62865 m
.50195 .62729 L
s
.83 .24 .1 r
.5007 .62898 m
.501 .62956 L
s
.992 .294 .126 r
.5 .62969 m .51464 .61163 L .51109 .61215 L closepath p F P
0 0 0 r
s
.992 .294 .126 r
.5 .62969 m .51109 .61215 L .50754 .61267 L closepath p F P
0 0 0 r
s
.992 .294 .126 r
.5 .62969 m .50754 .61267 L .50399 .61318 L closepath p F P
0 0 0 r
s
.992 .294 .126 r
.5 .62969 m .50399 .61318 L .50044 .6137 L closepath p F P
0 0 0 r
s
.992 .294 .126 r
.5 .62969 m .50044 .6137 L .4969 .61421 L closepath p F P
0 0 0 r
s
.992 .294 .126 r
.5 .62969 m .4969 .61421 L .49336 .61473 L closepath p F P
0 0 0 r
s
.992 .294 .126 r
.5 .62969 m .49336 .61473 L .48982 .61524 L closepath p F P
0 0 0 r
s
.297 .444 .868 r
.5 .62969 m .5182 .61112 L .51912 .61304 L closepath p F P
0 0 0 r
s
.297 .444 .868 r
.5 .62969 m .51912 .61304 L .52004 .61497 L closepath p F P
0 0 0 r
s
.992 .294 .126 r
.5 .62969 m .48982 .61524 L .48629 .61576 L closepath p F P
0 0 0 r
s
.992 .294 .126 r
.5 .62969 m .48629 .61576 L .48276 .61627 L closepath p F P
0 0 0 r
s
.992 .294 .126 r
.5 .62969 m .48276 .61627 L .47924 .61678 L closepath p F P
0 0 0 r
s
.992 .294 .126 r
.5 .62969 m .47924 .61678 L .47571 .61729 L closepath p F P
0 0 0 r
s
.992 .294 .126 r
.5 .62969 m .47571 .61729 L .4722 .61781 L closepath p F P
0 0 0 r
s
.992 .294 .126 r
.5 .62969 m .4722 .61781 L .46868 .61832 L closepath p F P
0 0 0 r
s
.297 .444 .868 r
.5 .62969 m .52004 .61497 L .52095 .61688 L closepath p F P
0 0 0 r
s
.297 .444 .868 r
.5 .62969 m .52095 .61688 L .52185 .61879 L closepath p F P
0 0 0 r
s
.297 .444 .868 r
.5 .62969 m .52185 .61879 L .52276 .62069 L closepath p F P
0 0 0 r
s
.297 .444 .868 r
.5 .62969 m .52276 .62069 L .52366 .62259 L closepath p F P
0 0 0 r
s
.297 .444 .868 r
.5 .62969 m .52366 .62259 L .52456 .62448 L closepath p F P
0 0 0 r
s
.297 .444 .868 r
.5 .62969 m .52456 .62448 L .52545 .62636 L closepath p F P
0 0 0 r
s
.28 .422 .832 r
.47167 .62401 m .47266 .62589 L .5 .62969 L closepath p F P
0 0 0 r
s
.28 .422 .832 r
.47068 .62212 m .47167 .62401 L .5 .62969 L closepath p F P
0 0 0 r
s
.28 .422 .832 r
.46968 .62022 m .47068 .62212 L .5 .62969 L closepath p F P
0 0 0 r
s
.28 .422 .832 r
.46868 .61832 m .46968 .62022 L .5 .62969 L closepath p F P
0 0 0 r
s
.319 .473 .909 r
.55024 .61972 m .54856 .61598 L .5713 .60443 L p F P
0 0 0 r
s
.31 .461 .893 r
.54856 .61598 m .55024 .61972 L .52545 .62636 L p F P
0 0 0 r
s
.077 .112 .279 r
.61521 .35879 m .61068 .34429 L .60215 .33496 L p F P
0 0 0 r
s
.305 .071 .031 r
.58882 .34821 m .61068 .34429 L .60215 .33496 L p F P
0 0 0 r
s
.24 .35 .67 r
.60603 .34526 m
.61533 .37464 L
s
.60593 .34515 m
.60603 .34526 L
s
.59631 .31454 m
.60388 .33846 L
s
.60599 .34513 m
.60603 .34526 L
s
.83 .24 .1 r
.20012 .54302 m
.20639 .57592 L
s
.24919 .56921 m
.20639 .57592 L
s
.24919 .56921 m
.25766 .60033 L
s
.30078 .59377 m
.25766 .60033 L
s
.45 .114 .05 r
.524 .35982 m .50265 .36364 L .50278 .37822 L p F P
0 0 0 r
s
.45 .114 .05 r
.48046 .38217 m .50278 .37822 L .50265 .36364 L p F P
0 0 0 r
s
.33 .484 .915 r
.59211 .59019 m .58918 .58285 L .60702 .56474 L p F P
0 0 0 r
s
.326 .48 .916 r
.58918 .58285 m .59211 .59019 L .5713 .60443 L p F P
0 0 0 r
s
.31 .461 .893 r
.52545 .62636 m .52456 .62448 L .54856 .61598 L p F P
0 0 0 r
s
.257 .392 .782 r
.44395 .61504 m .446 .61879 L .47266 .62589 L p F P
0 0 0 r
s
.228 .351 .713 r
.446 .61879 m .44395 .61504 L .41768 .60304 L p F P
0 0 0 r
s
.326 .471 .874 r
.62195 .54505 m .61818 .53449 L .62955 .5126 L p F P
0 0 0 r
s
.33 .481 .902 r
.61818 .53449 m .62195 .54505 L .60702 .56474 L p F P
0 0 0 r
s
.564 .15 .065 r
.4362 .39001 m .41427 .3939 L .41228 .41222 L p F P
0 0 0 r
s
.564 .15 .065 r
.38999 .41611 m .41228 .41222 L .41427 .3939 L p F P
0 0 0 r
s
.257 .392 .782 r
.47266 .62589 m .47167 .62401 L .44395 .61504 L p F P
0 0 0 r
s
.83 .24 .1 r
.40751 .63159 m
.4513 .62525 L
s
.4513 .62525 m
.46064 .64239 L
s
.24295 .5361 m
.20012 .54302 L
s
.162 .212 .366 r
.30876 .47434 m .31652 .48741 L .32705 .50963 L p F P
0 0 0 r
s
.208 .282 .479 r
.31652 .48741 m .30876 .47434 L .30283 .4521 L p F P
0 0 0 r
s
.83 .24 .1 r
.77872 .29779 m
.73266 .30613 L
s
.73266 .30613 m
.73277 .31616 L
s
.7306 .60397 m
.73481 .6155 L
s
.78089 .60902 m
.73481 .6155 L
s
.188 .295 .615 r
.38935 .581 m .39361 .58837 L .41768 .60304 L p F P
0 0 0 r
s
.14 .226 .491 r
.39361 .58837 m .38935 .581 L .36716 .56249 L p F P
0 0 0 r
s
.648 .176 .076 r
.36783 .41999 m .3458 .42383 L .34634 .44462 L p F P
0 0 0 r
s
.83 .24 .1 r
.34468 .42513 m
.34583 .42492 L
s
.36669 .42128 m
.36923 .42084 L
s
.648 .176 .076 r
.32452 .44837 m .34634 .44462 L .3458 .42383 L p F P
0 0 0 r
s
.31 .461 .893 r
.54687 .61221 m .54856 .61598 L .52456 .62448 L p F P
0 0 0 r
s
.24 .35 .67 r
.54804 .61474 m
.57447 .6006 L
s
.52374 .62276 m
.53357 .61952 L
s
.54801 .61475 m
.54804 .61474 L
s
.83 .24 .1 r
.54848 .62989 m
.59319 .62353 L
s
.24 .35 .67 r
.54804 .61474 m
.54859 .61596 L
s
.31 .461 .893 r
.52456 .62448 m .52366 .62259 L .54687 .61221 L p F P
0 0 0 r
s
.247 .347 .604 r
.63726 .45554 m .63281 .44159 L .63328 .42074 L p F P
0 0 0 r
s
.24 .35 .67 r
.63186 .42159 m
.63316 .42574 L
s
.288 .411 .737 r
.63281 .44159 m .63726 .45554 L .63315 .47762 L p F P
0 0 0 r
s
.83 .24 .1 r
.34443 .58713 m
.3539 .61503 L
s
.3539 .61503 m
.3977 .60854 L
s
.58589 .60576 m
.59319 .62353 L
s
.63844 .61709 m
.59319 .62353 L
s
.326 .48 .916 r
.5713 .60443 m .56892 .59883 L .58918 .58285 L p F P
0 0 0 r
s
.319 .473 .909 r
.56892 .59883 m .5713 .60443 L .54856 .61598 L p F P
0 0 0 r
s
.257 .392 .782 r
.47167 .62401 m .47068 .62212 L .44189 .61126 L p F P
0 0 0 r
s
.257 .392 .782 r
.44189 .61126 m .44395 .61504 L .47167 .62401 L p F P
0 0 0 r
s
.83 .24 .1 r
.4513 .62525 m
.46486 .62328 L
s
.46486 .62328 m
.46902 .62268 L
s
.105 .162 .375 r
.34227 .53184 m .34858 .54244 L .36716 .56249 L p F P
0 0 0 r
s
.071 .103 .253 r
.34858 .54244 m .34227 .53184 L .32705 .50963 L p F P
0 0 0 r
s
.83 .24 .1 r
.60584 .339 m
.64054 .33276 L
s
.45 .114 .05 r
.54548 .35597 m .524 .35982 L .52525 .37424 L p F P
0 0 0 r
s
.45 .114 .05 r
.50278 .37822 m .52525 .37424 L .524 .35982 L p F P
0 0 0 r
s
.319 .473 .909 r
.54856 .61598 m .54687 .61221 L .56892 .59883 L p F P
0 0 0 r
s
.83 .24 .1 r
.28136 .46406 m
.28252 .49569 L
s
.564 .15 .065 r
.45826 .38611 m .4362 .39001 L .43472 .4083 L p F P
0 0 0 r
s
.564 .15 .065 r
.41228 .41222 m .43472 .4083 L .4362 .39001 L p F P
0 0 0 r
s
.83 .24 .1 r
.41322 .41316 m
.41333 .41204 L
s
.228 .351 .713 r
.41451 .59743 m .41768 .60304 L .44395 .61504 L p F P
0 0 0 r
s
.188 .295 .615 r
.41768 .60304 m .41451 .59743 L .38935 .581 L p F P
0 0 0 r
s
.054 .079 .187 r
.61068 .34429 m .61521 .35879 L .62118 .37317 L p F P
0 0 0 r
s
.054 .079 .187 r
.62578 .38792 m .62118 .37317 L .61521 .35879 L p F P
0 0 0 r
s
.31 .461 .893 r
.54516 .60841 m .54687 .61221 L .52366 .62259 L p F P
0 0 0 r
s
.31 .461 .893 r
.52366 .62259 m .52276 .62069 L .54516 .60841 L p F P
0 0 0 r
s
.228 .351 .713 r
.44395 .61504 m .44189 .61126 L .41451 .59743 L p F P
0 0 0 r
s
.257 .392 .782 r
.47068 .62212 m .46968 .62022 L .43981 .60746 L p F P
0 0 0 r
s
.257 .392 .782 r
.43981 .60746 m .44189 .61126 L .47068 .62212 L p F P
0 0 0 r
s
.83 .24 .1 r
.28252 .49569 m
.23932 .50287 L
s
.23932 .50287 m
.24295 .5361 L
s
.191 .261 .437 r
.63328 .42074 m .62871 .40619 L .62578 .38792 L p F P
0 0 0 r
s
.247 .347 .604 r
.62871 .40619 m .63328 .42074 L .63281 .44159 L p F P
0 0 0 r
s
.33 .481 .902 r
.60702 .56474 m .60359 .55564 L .61818 .53449 L p F P
0 0 0 r
s
.33 .484 .915 r
.60359 .55564 m .60702 .56474 L .58918 .58285 L p F P
0 0 0 r
s
.712 .196 .085 r
.32452 .44837 m .30283 .4521 L .30876 .47434 L p F P
0 0 0 r
s
.83 .24 .1 r
.28136 .46406 m
.30395 .4602 L
s
.30395 .4602 m
.30495 .46003 L
s
.24 .35 .67 r
.30543 .45829 m
.30589 .45907 L
s
.31187 .46921 m
.31316 .47141 L
s
.29679 .44363 m
.30543 .45829 L
s
.313 .45 .822 r
.62955 .5126 m .62545 .50058 L .63315 .47762 L p F P
0 0 0 r
s
.326 .471 .874 r
.62545 .50058 m .62955 .5126 L .61818 .53449 L p F P
0 0 0 r
s
.648 .176 .076 r
.38999 .41611 m .36783 .41999 L .36829 .44085 L p F P
0 0 0 r
s
.648 .176 .076 r
.34634 .44462 m .36829 .44085 L .36783 .41999 L p F P
0 0 0 r
s
.191 .261 .437 r
.62118 .37317 m .62578 .38792 L .62871 .40619 L p F P
0 0 0 r
s
.24 .35 .67 r
.61763 .3674 m
.62588 .39376 L
s
.31 .461 .893 r
.54344 .60459 m .54516 .60841 L .52276 .62069 L p F P
0 0 0 r
s
.31 .461 .893 r
.52276 .62069 m .52185 .61879 L .54344 .60459 L p F P
0 0 0 r
s
.83 .24 .1 r
.24295 .5361 m
.24919 .56921 L
s
.29251 .56242 m
.24919 .56921 L
s
.45 .114 .05 r
.56709 .3521 m .54548 .35597 L .54785 .37024 L p F P
0 0 0 r
s
.45 .114 .05 r
.52525 .37424 m .54785 .37024 L .54548 .35597 L p F P
0 0 0 r
s
.83 .24 .1 r
.29251 .56242 m
.30078 .59377 L
s
.34443 .58713 m
.30078 .59377 L
s
.257 .392 .782 r
.46968 .62022 m .46868 .61832 L .43772 .60363 L p F P
0 0 0 r
s
.257 .392 .782 r
.43772 .60363 m .43981 .60746 L .46968 .62022 L p F P
0 0 0 r
s
.83 .24 .1 r
.44644 .61306 m
.4513 .62525 L
s
.24 .35 .67 r
.28532 .36243 m
.29771 .3366 L
s
.28084 .30548 m
.29771 .3366 L
s
.14 .226 .491 r
.36178 .55336 m .36716 .56249 L .38935 .581 L p F P
0 0 0 r
s
.105 .162 .375 r
.36716 .56249 m .36178 .55336 L .34227 .53184 L p F P
0 0 0 r
s
.319 .473 .909 r
.56652 .59317 m .56892 .59883 L .54687 .61221 L p F P
0 0 0 r
s
.319 .473 .909 r
.54687 .61221 m .54516 .60841 L .56652 .59317 L p F P
0 0 0 r
s
.24 .35 .67 r
.29606 .41804 m
.27914 .38877 L
s
.29679 .44363 m
.29606 .41804 L
s
.564 .15 .065 r
.48046 .38217 m .45826 .38611 L .45729 .40436 L p F P
0 0 0 r
s
.564 .15 .065 r
.43472 .4083 m .45729 .40436 L .45826 .38611 L p F P
0 0 0 r
s
.33 .484 .915 r
.58918 .58285 m .5862 .5754 L .60359 .55564 L p F P
0 0 0 r
s
.326 .48 .916 r
.5862 .5754 m .58918 .58285 L .56892 .59883 L p F P
0 0 0 r
s
.83 .24 .1 r
.2863 .5291 m
.24295 .5361 L
s
.31 .461 .893 r
.54171 .60073 m .54344 .60459 L .52185 .61879 L p F P
0 0 0 r
s
.31 .461 .893 r
.52185 .61879 m .52095 .61688 L .54171 .60073 L p F P
0 0 0 r
s
.228 .351 .713 r
.44189 .61126 m .43981 .60746 L .4113 .59175 L p F P
0 0 0 r
s
.228 .351 .713 r
.4113 .59175 m .41451 .59743 L .44189 .61126 L p F P
0 0 0 r
s
.162 .212 .366 r
.32705 .50963 m .31984 .49755 L .30876 .47434 L p F P
0 0 0 r
s
.071 .103 .253 r
.31984 .49755 m .32705 .50963 L .34227 .53184 L p F P
0 0 0 r
s
.24 .35 .67 r
.32076 .49521 m
.33645 .5216 L
s
.326 .48 .916 r
.56892 .59883 m .56652 .59317 L .5862 .5754 L p F P
0 0 0 r
s
.83 .24 .1 r
.77872 .29779 m
.77974 .30771 L
s
.77753 .59729 m
.78089 .60902 L
s
.82752 .60246 m
.78089 .60902 L
s
.24 .35 .67 r
.5065 .20796 m
.51832 .24133 L
s
.51832 .24133 m
.54526 .25022 L
s
.971 .285 .122 r
.44468 .6026 m .43772 .60363 L .46868 .61832 L p F P
0 0 0 r
s
.83 .24 .1 r
.44203 .60198 m
.44241 .60294 L
s
.971 .285 .122 r
.46868 .61832 m .4722 .61781 L .44468 .6026 L p F P
0 0 0 r
s
.712 .196 .085 r
.34634 .44462 m .32452 .44837 L .32981 .47079 L p F P
0 0 0 r
s
.712 .196 .085 r
.30876 .47434 m .32981 .47079 L .32452 .44837 L p F P
0 0 0 r
s
.24 .35 .67 r
.31382 .47349 m
.32076 .49521 L
s
.34983 .2393 m
.37986 .22379 L
s
.36485 .19001 m
.37986 .22379 L
s
.37986 .22379 m
.41169 .21254 L
s
.648 .176 .076 r
.41228 .41222 m .38999 .41611 L .39038 .43706 L p F P
0 0 0 r
s
.83 .24 .1 r
.38884 .41742 m
.39001 .41721 L
s
.41113 .41353 m
.41322 .41316 L
s
.648 .176 .076 r
.36829 .44085 m .39038 .43706 L .38999 .41611 L p F P
0 0 0 r
s
.971 .285 .122 r
.45166 .60157 m .44468 .6026 L .4722 .61781 L p F P
0 0 0 r
s
.83 .24 .1 r
.44546 .61059 m
.44644 .61306 L
s
.971 .285 .122 r
.4722 .61781 m .47571 .61729 L .45166 .60157 L p F P
0 0 0 r
s
.83 .24 .1 r
.63185 .5991 m
.63844 .61709 L
s
.68424 .61057 m
.63844 .61709 L
s
.188 .295 .615 r
.38502 .57353 m .38935 .581 L .41451 .59743 L p F P
0 0 0 r
s
.14 .226 .491 r
.38935 .581 m .38502 .57353 L .36178 .55336 L p F P
0 0 0 r
s
.24 .35 .67 r
.37066 .55981 m
.37216 .56237 L
s
.45 .114 .05 r
.58882 .34821 m .56709 .3521 L .57058 .36621 L p F P
0 0 0 r
s
.45 .114 .05 r
.54785 .37024 m .57058 .36621 L .56709 .3521 L p F P
0 0 0 r
s
.971 .285 .122 r
.45865 .60053 m .45166 .60157 L .47571 .61729 L p F P
0 0 0 r
s
.971 .285 .122 r
.47571 .61729 m .47924 .61678 L .45865 .60053 L p F P
0 0 0 r
s
.24 .35 .67 r
.56823 .26403 m
.57868 .29617 L
s
.57868 .29617 m
.59631 .31454 L
s
.188 .295 .615 r
.41451 .59743 m .4113 .59175 L .38502 .57353 L p F P
0 0 0 r
s
.83 .24 .1 r
.68637 .32451 m
.64054 .33276 L
s
.64054 .33276 m
.64025 .34987 L
s
.31 .461 .893 r
.53997 .59686 m .54171 .60073 L .52095 .61688 L p F P
0 0 0 r
s
.83 .24 .1 r
.54049 .61233 m
.54848 .62989 L
s
.31 .461 .893 r
.52095 .61688 m .52004 .61497 L .53997 .59686 L p F P
0 0 0 r
s
.83 .24 .1 r
.52243 .61495 m
.52665 .61434 L
s
.24 .35 .67 r
.32265 .25853 m
.34983 .2393 L
s
.33411 .20583 m
.34983 .2393 L
s
.971 .285 .122 r
.46566 .59949 m .45865 .60053 L .47924 .61678 L p F P
0 0 0 r
s
.971 .285 .122 r
.47924 .61678 m .48276 .61627 L .46566 .59949 L p F P
0 0 0 r
s
.288 .411 .737 r
.63315 .47762 m .62879 .46434 L .63281 .44159 L p F P
0 0 0 r
s
.313 .45 .822 r
.62879 .46434 m .63315 .47762 L .62545 .50058 L p F P
0 0 0 r
s
.564 .15 .065 r
.50278 .37822 m .48046 .38217 L .48 .40039 L p F P
0 0 0 r
s
.564 .15 .065 r
.45729 .40436 m .48 .40039 L .48046 .38217 L p F P
0 0 0 r
s
.83 .24 .1 r
.45775 .40539 m
.45782 .40426 L
s
.326 .471 .874 r
.61818 .53449 m .61433 .52374 L .62545 .50058 L p F P
0 0 0 r
s
.33 .481 .902 r
.61433 .52374 m .61818 .53449 L .60359 .55564 L p F P
0 0 0 r
s
.24 .35 .67 r
.39739 .17845 m
.41169 .21254 L
s
.41169 .21254 m
.44418 .20598 L
s
.971 .285 .122 r
.47268 .59846 m .46566 .59949 L .48276 .61627 L p F P
0 0 0 r
s
.971 .285 .122 r
.48276 .61627 m .48629 .61576 L .47268 .59846 L p F P
0 0 0 r
s
.319 .473 .909 r
.5641 .58745 m .56652 .59317 L .54516 .60841 L p F P
0 0 0 r
s
.319 .473 .909 r
.54516 .60841 m .54344 .60459 L .5641 .58745 L p F P
0 0 0 r
s
.971 .285 .122 r
.47971 .59741 m .47268 .59846 L .48629 .61576 L p F P
0 0 0 r
s
.24 .35 .67 r
.47527 .61328 m
.47645 .61556 L
s
.47138 .60575 m
.47527 .61328 L
s
.971 .285 .122 r
.48629 .61576 m .48982 .61524 L .47971 .59741 L p F P
0 0 0 r
s
.83 .24 .1 r
.28252 .49569 m
.2863 .5291 L
s
.971 .285 .122 r
.48675 .59637 m .47971 .59741 L .48982 .61524 L p F P
0 0 0 r
s
.971 .285 .122 r
.48982 .61524 m .49336 .61473 L .48675 .59637 L p F P
0 0 0 r
s
.712 .196 .085 r
.36829 .44085 m .34634 .44462 L .35098 .46722 L p F P
0 0 0 r
s
.712 .196 .085 r
.32981 .47079 m .35098 .46722 L .34634 .44462 L p F P
0 0 0 r
s
.228 .351 .713 r
.43981 .60746 m .43772 .60363 L .40806 .58601 L p F P
0 0 0 r
s
.24 .35 .67 r
.43047 .60231 m
.43317 .60297 L
s
.228 .351 .713 r
.40806 .58601 m .4113 .59175 L .43981 .60746 L p F P
0 0 0 r
s
.83 .24 .1 r
.3977 .60854 m
.42807 .60404 L
s
.42807 .60404 m
.43167 .60351 L
s
.43167 .60351 m
.43429 .60312 L
s
.43635 .60282 m
.44203 .60198 L
s
.31 .461 .893 r
.53821 .59295 m .53997 .59686 L .52004 .61497 L p F P
0 0 0 r
s
.31 .461 .893 r
.52004 .61497 m .51912 .61304 L .53821 .59295 L p F P
0 0 0 r
s
.971 .285 .122 r
.49381 .59533 m .48675 .59637 L .49336 .61473 L p F P
0 0 0 r
s
.83 .24 .1 r
.48689 .59533 m
.48725 .5963 L
s
.4934 .61284 m
.49406 .61463 L
s
.971 .285 .122 r
.49336 .61473 m .4969 .61421 L .49381 .59533 L p F P
0 0 0 r
s
.648 .176 .076 r
.43472 .4083 m .41228 .41222 L .4126 .43324 L p F P
0 0 0 r
s
.648 .176 .076 r
.39038 .43706 m .4126 .43324 L .41228 .41222 L p F P
0 0 0 r
s
.971 .285 .122 r
.50088 .59428 m .49381 .59533 L .4969 .61421 L p F P
0 0 0 r
s
.971 .285 .122 r
.4969 .61421 m .50044 .6137 L .50088 .59428 L p F P
0 0 0 r
s
.45 .114 .05 r
.61068 .34429 m .58882 .34821 L .59346 .36216 L p F P
0 0 0 r
s
.24 .35 .67 r
.60734 .34776 m
.61763 .3674 L
s
.45 .114 .05 r
.57058 .36621 m .59346 .36216 L .58882 .34821 L p F P
0 0 0 r
s
.83 .24 .1 r
.2863 .5291 m
.29251 .56242 L
s
.33636 .55555 m
.29251 .56242 L
s
.24 .35 .67 r
.45114 .60497 m
.47138 .60575 L
s
.105 .162 .375 r
.33584 .52104 m .34227 .53184 L .36178 .55336 L p F P
0 0 0 r
s
.24 .35 .67 r
.3588 .54965 m
.37066 .55981 L
s
.071 .103 .253 r
.34227 .53184 m .33584 .52104 L .31984 .49755 L p F P
0 0 0 r
s
.83 .24 .1 r
.33636 .55555 m
.34443 .58713 L
s
.971 .285 .122 r
.50797 .59323 m .50088 .59428 L .50044 .6137 L p F P
0 0 0 r
s
.971 .285 .122 r
.50044 .6137 m .50399 .61318 L .50797 .59323 L p F P
0 0 0 r
s
.764 .213 .092 r
.32981 .47079 m .30876 .47434 L .31984 .49755 L p F P
0 0 0 r
s
.24 .35 .67 r
.31619 .48753 m
.31712 .4891 L
s
.32073 .49517 m
.32076 .49521 L
s
.30434 .4676 m
.31619 .48753 L
s
.83 .24 .1 r
.28252 .49569 m
.31627 .49008 L
s
.33 .481 .902 r
.60359 .55564 m .60011 .5464 L .61433 .52374 L p F P
0 0 0 r
s
.33 .484 .915 r
.60011 .5464 m .60359 .55564 L .5862 .5754 L p F P
0 0 0 r
s
.971 .285 .122 r
.51506 .59218 m .50797 .59323 L .50399 .61318 L p F P
0 0 0 r
s
.971 .285 .122 r
.50399 .61318 m .50754 .61267 L .51506 .59218 L p F P
0 0 0 r
s
.564 .15 .065 r
.52525 .37424 m .50278 .37822 L .50285 .3964 L p F P
0 0 0 r
s
.564 .15 .065 r
.48 .40039 m .50285 .3964 L .50278 .37822 L p F P
0 0 0 r
s
.31 .461 .893 r
.53644 .58902 m .53821 .59295 L .51912 .61304 L p F P
0 0 0 r
s
.31 .461 .893 r
.51912 .61304 m .5182 .61112 L .53644 .58902 L p F P
0 0 0 r
s
.83 .24 .1 r
.52665 .61434 m
.54049 .61233 L
s
.326 .48 .916 r
.58319 .56786 m .5862 .5754 L .56652 .59317 L p F P
0 0 0 r
s
.326 .48 .916 r
.56652 .59317 m .5641 .58745 L .58319 .56786 L p F P
0 0 0 r
s
.83 .24 .1 r
.54049 .61233 m
.58589 .60576 L
s
.971 .285 .122 r
.52218 .59113 m .51506 .59218 L .50754 .61267 L p F P
0 0 0 r
s
.971 .285 .122 r
.50754 .61267 m .51109 .61215 L .52218 .59113 L p F P
0 0 0 r
s
.24 .35 .67 r
.50812 .60849 m
.50923 .61079 L
s
.50444 .60089 m
.50812 .60849 L
s
.29935 .28084 m
.32265 .25853 L
s
.30624 .22537 m
.32265 .25853 L
s
.83 .24 .1 r
.2863 .5291 m
.33018 .52201 L
s
.247 .347 .604 r
.63281 .44159 m .62825 .42733 L .62871 .40619 L p F P
0 0 0 r
s
.288 .411 .737 r
.62825 .42733 m .63281 .44159 L .62879 .46434 L p F P
0 0 0 r
s
.971 .285 .122 r
.5293 .59007 m .52218 .59113 L .51109 .61215 L p F P
0 0 0 r
s
.971 .285 .122 r
.51109 .61215 m .51464 .61163 L .5293 .59007 L p F P
0 0 0 r
s
.33 .484 .915 r
.5862 .5754 m .58319 .56786 L .60011 .5464 L p F P
0 0 0 r
s
.24 .35 .67 r
.59375 .55324 m
.59407 .55406 L
s
.319 .473 .909 r
.56165 .58166 m .5641 .58745 L .54344 .60459 L p F P
0 0 0 r
s
.319 .473 .909 r
.54344 .60459 m .54171 .60073 L .56165 .58166 L p F P
0 0 0 r
s
.83 .24 .1 r
.82504 .59053 m
.82752 .60246 L
s
.712 .196 .085 r
.39038 .43706 m .36829 .44085 L .37228 .46363 L p F P
0 0 0 r
s
.712 .196 .085 r
.35098 .46722 m .37228 .46363 L .36829 .44085 L p F P
0 0 0 r
s
.971 .285 .122 r
.53644 .58902 m .5293 .59007 L .51464 .61163 L p F P
0 0 0 r
s
.971 .285 .122 r
.51464 .61163 m .5182 .61112 L .53644 .58902 L p F P
0 0 0 r
s
.188 .295 .615 r
.4113 .59175 m .40806 .58601 L .38064 .56596 L p F P
0 0 0 r
s
.24 .35 .67 r
.40332 .58504 m
.40443 .58699 L
s
.188 .295 .615 r
.38064 .56596 m .38502 .57353 L .4113 .59175 L p F P
0 0 0 r
s
.83 .24 .1 r
.3886 .5804 m
.3977 .60854 L
s
.34443 .58713 m
.3886 .5804 L
s
.24 .35 .67 r
.43057 .17158 m
.44418 .20598 L
s
.44418 .20598 m
.47619 .2044 L
s
.648 .176 .076 r
.45729 .40436 m .43472 .4083 L .43495 .4294 L p F P
0 0 0 r
s
.83 .24 .1 r
.43355 .40961 m
.43473 .40941 L
s
.45611 .40568 m
.45775 .40539 L
s
.648 .176 .076 r
.4126 .43324 m .43495 .4294 L .43472 .4083 L p F P
0 0 0 r
s
.83 .24 .1 r
.67839 .59236 m
.68424 .61057 L
s
.7306 .60397 m
.68424 .61057 L
s
.944 .274 .118 r
.41831 .58447 m .40806 .58601 L .43772 .60363 L p F P
0 0 0 r
s
.944 .274 .118 r
.43772 .60363 m .44468 .6026 L .41831 .58447 L p F P
0 0 0 r
s
.14 .226 .491 r
.35631 .54408 m .36178 .55336 L .38502 .57353 L p F P
0 0 0 r
s
.105 .162 .375 r
.36178 .55336 m .35631 .54408 L .33584 .52104 L p F P
0 0 0 r
s
.054 .079 .187 r
.62118 .37317 m .61648 .35808 L .61068 .34429 L p F P
0 0 0 r
s
.45 .114 .05 r
.59346 .36216 m .61648 .35808 L .61068 .34429 L p F P
0 0 0 r
s
.24 .35 .67 r
.60804 .33677 m
.61276 .35185 L
s
.61276 .35185 m
.61337 .35379 L
s
.83 .24 .1 r
.73277 .31616 m
.68637 .32451 L
s
.68637 .32451 m
.6869 .34158 L
s
.764 .213 .092 r
.35098 .46722 m .32981 .47079 L .3397 .49427 L p F P
0 0 0 r
s
.764 .213 .092 r
.31984 .49755 m .3397 .49427 L .32981 .47079 L p F P
0 0 0 r
s
.313 .45 .822 r
.62545 .50058 m .62126 .48831 L .62879 .46434 L p F P
0 0 0 r
s
.326 .471 .874 r
.62126 .48831 m .62545 .50058 L .61433 .52374 L p F P
0 0 0 r
s
.14 .226 .491 r
.38502 .57353 m .38064 .56596 L .35631 .54408 L p F P
0 0 0 r
s
.944 .274 .118 r
.42858 .58291 m .41831 .58447 L .44468 .6026 L p F P
0 0 0 r
s
.944 .274 .118 r
.44468 .6026 m .45166 .60157 L .42858 .58291 L p F P
0 0 0 r
s
.564 .15 .065 r
.54785 .37024 m .52525 .37424 L .52584 .39238 L p F P
0 0 0 r
s
.564 .15 .065 r
.50285 .3964 m .52584 .39238 L .52525 .37424 L p F P
0 0 0 r
s
.191 .261 .437 r
.62871 .40619 m .62404 .3913 L .62118 .37317 L p F P
0 0 0 r
s
.247 .347 .604 r
.62404 .3913 m .62871 .40619 L .62825 .42733 L p F P
0 0 0 r
s
.944 .274 .118 r
.43888 .58136 m .42858 .58291 L .45166 .60157 L p F P
0 0 0 r
s
.24 .35 .67 r
.43635 .59878 m
.43715 .60024 L
s
.944 .274 .118 r
.45166 .60157 m .45865 .60053 L .43888 .58136 L p F P
0 0 0 r
s
.191 .261 .437 r
.61648 .35808 m .62118 .37317 L .62404 .3913 L p F P
0 0 0 r
s
.24 .35 .67 r
.61763 .3674 m
.62269 .39249 L
s
.6148 .35838 m
.61763 .3674 L
s
.27914 .38877 m
.28532 .36243 L
s
.26797 .33157 m
.28532 .36243 L
s
.712 .196 .085 r
.4126 .43324 m .39038 .43706 L .39371 .46002 L p F P
0 0 0 r
s
.712 .196 .085 r
.37228 .46363 m .39371 .46002 L .39038 .43706 L p F P
0 0 0 r
s
.319 .473 .909 r
.55917 .57582 m .56165 .58166 L .54171 .60073 L p F P
0 0 0 r
s
.319 .473 .909 r
.54171 .60073 m .53997 .59686 L .55917 .57582 L p F P
0 0 0 r
s
.83 .24 .1 r
.53621 .5999 m
.54049 .61233 L
s
.53534 .59738 m
.53621 .5999 L
s
.648 .176 .076 r
.48 .40039 m .45729 .40436 L .45744 .42554 L p F P
0 0 0 r
s
.648 .176 .076 r
.43495 .4294 m .45744 .42554 L .45729 .40436 L p F P
0 0 0 r
s
.944 .274 .118 r
.44921 .5798 m .43888 .58136 L .45865 .60053 L p F P
0 0 0 r
s
.944 .274 .118 r
.45865 .60053 m .46566 .59949 L .44921 .5798 L p F P
0 0 0 r
s
.808 .228 .098 r
.3397 .49427 m .31984 .49755 L .33584 .52104 L p F P
0 0 0 r
s
.83 .24 .1 r
.32962 .51723 m
.33018 .52201 L
s
.32889 .511 m
.32962 .51723 L
s
.24 .35 .67 r
.33026 .50934 m
.33291 .51327 L
s
.33291 .51327 m
.33495 .5163 L
s
.83 .24 .1 r
.33018 .52201 m
.33636 .55555 L
s
.33636 .55555 m
.36232 .55148 L
s
.36232 .55148 m
.36375 .55125 L
s
.326 .48 .916 r
.58013 .56021 m .58319 .56786 L .5641 .58745 L p F P
0 0 0 r
s
.326 .48 .916 r
.5641 .58745 m .56165 .58166 L .58013 .56021 L p F P
0 0 0 r
s
.764 .213 .092 r
.37228 .46363 m .35098 .46722 L .35967 .49098 L p F P
0 0 0 r
s
.764 .213 .092 r
.3397 .49427 m .35967 .49098 L .35098 .46722 L p F P
0 0 0 r
s
.944 .274 .118 r
.45957 .57823 m .44921 .5798 L .46566 .59949 L p F P
0 0 0 r
s
.944 .274 .118 r
.46566 .59949 m .47268 .59846 L .45957 .57823 L p F P
0 0 0 r
s
.564 .15 .065 r
.57058 .36621 m .54785 .37024 L .54898 .38834 L p F P
0 0 0 r
s
.564 .15 .065 r
.52584 .39238 m .54898 .38834 L .54785 .37024 L p F P
0 0 0 r
s
.83 .24 .1 r
.5783 .58179 m
.58589 .60576 L
s
.63185 .5991 m
.58589 .60576 L
s
.24 .35 .67 r
.47138 .60575 m
.50444 .60089 L
s
.326 .471 .874 r
.61433 .52374 m .61042 .51279 L .62126 .48831 L p F P
0 0 0 r
s
.33 .481 .902 r
.61042 .51279 m .61433 .52374 L .60011 .5464 L p F P
0 0 0 r
s
.24 .35 .67 r
.59375 .55324 m
.60026 .54589 L
s
.53393 .21667 m
.54526 .25022 L
s
.54526 .25022 m
.56823 .26403 L
s
.944 .274 .118 r
.46996 .57666 m .45957 .57823 L .47268 .59846 L p F P
0 0 0 r
s
.944 .274 .118 r
.47268 .59846 m .47971 .59741 L .46996 .57666 L p F P
0 0 0 r
s
.913 .264 .113 r
.39389 .56392 m .38064 .56596 L .40806 .58601 L p F P
0 0 0 r
s
.83 .24 .1 r
.38636 .57134 m
.3886 .5804 L
s
.24 .35 .67 r
.37759 .56322 m
.38256 .56567 L
s
.913 .264 .113 r
.40806 .58601 m .41831 .58447 L .39389 .56392 L p F P
0 0 0 r
s
.83 .24 .1 r
.3886 .5804 m
.39754 .57904 L
s
.33018 .52201 m
.33557 .52114 L
s
.33557 .52114 m
.33579 .52111 L
s
.24 .35 .67 r
.28084 .30548 m
.29935 .28084 L
s
.28228 .24798 m
.29935 .28084 L
s
.30434 .4676 m
.29679 .44363 L
s
.27966 .41457 m
.29679 .44363 L
s
.712 .196 .085 r
.43495 .4294 m .4126 .43324 L .41526 .45639 L p F P
0 0 0 r
s
.712 .196 .085 r
.39371 .46002 m .41526 .45639 L .4126 .43324 L p F P
0 0 0 r
s
.944 .274 .118 r
.48038 .57509 m .46996 .57666 L .47971 .59741 L p F P
0 0 0 r
s
.24 .35 .67 r
.45833 .58049 m
.47138 .60575 L
s
.944 .274 .118 r
.47971 .59741 m .48675 .59637 L .48038 .57509 L p F P
0 0 0 r
s
.83 .24 .1 r
.48646 .59539 m
.48689 .59533 L
s
.61492 .35437 m
.64025 .34987 L
s
.33 .484 .915 r
.59656 .53701 m .60011 .5464 L .58319 .56786 L p F P
0 0 0 r
s
.33 .484 .915 r
.58319 .56786 m .58013 .56021 L .59656 .53701 L p F P
0 0 0 r
s
.288 .411 .737 r
.62879 .46434 m .62432 .45076 L .62825 .42733 L p F P
0 0 0 r
s
.313 .45 .822 r
.62432 .45076 m .62879 .46434 L .62126 .48831 L p F P
0 0 0 r
s
.648 .176 .076 r
.50285 .3964 m .48 .40039 L .48007 .42165 L p F P
0 0 0 r
s
.83 .24 .1 r
.47881 .40171 m
.48 .40151 L
s
.50165 .39773 m
.50282 .39752 L
s
.50282 .39752 m
.50286 .3964 L
s
.648 .176 .076 r
.45744 .42554 m .48007 .42165 L .48 .40039 L p F P
0 0 0 r
s
.808 .228 .098 r
.35967 .49098 m .3397 .49427 L .35397 .51811 L p F P
0 0 0 r
s
.808 .228 .098 r
.33584 .52104 m .35397 .51811 L .3397 .49427 L p F P
0 0 0 r
s
.24 .35 .67 r
.33759 .52076 m
.34161 .52753 L
s
.83 .24 .1 r
.72549 .58554 m
.7306 .60397 L
s
.77753 .59729 m
.7306 .60397 L
s
.913 .264 .113 r
.4072 .56186 m .39389 .56392 L .41831 .58447 L p F P
0 0 0 r
s
.24 .35 .67 r
.38877 .56873 m
.39611 .57234 L
s
.39611 .57234 m
.39902 .57747 L
s
.913 .264 .113 r
.41831 .58447 m .42858 .58291 L .4072 .56186 L p F P
0 0 0 r
s
.24 .35 .67 r
.43526 .59677 m
.43635 .59878 L
s
.33 .481 .902 r
.60011 .5464 m .59656 .53701 L .61042 .51279 L p F P
0 0 0 r
s
.319 .473 .909 r
.55667 .56992 m .55917 .57582 L .53997 .59686 L p F P
0 0 0 r
s
.319 .473 .909 r
.53997 .59686 m .53821 .59295 L .55667 .56992 L p F P
0 0 0 r
s
.764 .213 .092 r
.39371 .46002 m .37228 .46363 L .37975 .48766 L p F P
0 0 0 r
s
.764 .213 .092 r
.35967 .49098 m .37975 .48766 L .37228 .46363 L p F P
0 0 0 r
s
.83 .24 .1 r
.77974 .30771 m
.73277 .31616 L
s
.73277 .31616 m
.73412 .33319 L
s
.944 .274 .118 r
.49083 .57351 m .48038 .57509 L .48675 .59637 L p F P
0 0 0 r
s
.944 .274 .118 r
.48675 .59637 m .49381 .59533 L .49083 .57351 L p F P
0 0 0 r
s
.24 .35 .67 r
.46322 .16971 m
.47619 .2044 L
s
.47619 .2044 m
.5065 .20796 L
s
.846 .24 .104 r
.35397 .51811 m .33584 .52104 L .35631 .54408 L p F P
0 0 0 r
s
.24 .35 .67 r
.33495 .5163 m
.33689 .51957 L
s
.33689 .51957 m
.33697 .51971 L
s
.564 .15 .065 r
.59346 .36216 m .57058 .36621 L .57226 .38427 L p F P
0 0 0 r
s
.564 .15 .065 r
.54898 .38834 m .57226 .38427 L .57058 .36621 L p F P
0 0 0 r
s
.881 .252 .108 r
.37222 .54157 m .35631 .54408 L .38064 .56596 L p F P
0 0 0 r
s
.24 .35 .67 r
.36441 .54912 m
.3649 .54995 L
s
.881 .252 .108 r
.38064 .56596 m .39389 .56392 L .37222 .54157 L p F P
0 0 0 r
s
.913 .264 .113 r
.42055 .5598 m .4072 .56186 L .42858 .58291 L p F P
0 0 0 r
s
.913 .264 .113 r
.42858 .58291 m .43888 .58136 L .42055 .5598 L p F P
0 0 0 r
s
.944 .274 .118 r
.5013 .57193 m .49083 .57351 L .49381 .59533 L p F P
0 0 0 r
s
.944 .274 .118 r
.49381 .59533 m .50088 .59428 L .5013 .57193 L p F P
0 0 0 r
s
.24 .35 .67 r
.58614 .28238 m
.59631 .31454 L
s
.59631 .31454 m
.60804 .33677 L
s
.846 .24 .104 r
.35631 .54408 m .37222 .54157 L .35397 .51811 L p F P
0 0 0 r
s
.944 .274 .118 r
.51181 .57034 m .5013 .57193 L .50088 .59428 L p F P
0 0 0 r
s
.944 .274 .118 r
.50088 .59428 m .50797 .59323 L .51181 .57034 L p F P
0 0 0 r
s
.712 .196 .085 r
.45744 .42554 m .43495 .4294 L .43694 .45273 L p F P
0 0 0 r
s
.712 .196 .085 r
.41526 .45639 m .43694 .45273 L .43495 .4294 L p F P
0 0 0 r
s
.326 .48 .916 r
.57703 .55245 m .58013 .56021 L .56165 .58166 L p F P
0 0 0 r
s
.326 .48 .916 r
.56165 .58166 m .55917 .57582 L .57703 .55245 L p F P
0 0 0 r
s
.808 .228 .098 r
.37975 .48766 m .35967 .49098 L .3722 .51517 L p F P
0 0 0 r
s
.83 .24 .1 r
.37389 .509 m
.37459 .51484 L
s
.808 .228 .098 r
.35397 .51811 m .3722 .51517 L .35967 .49098 L p F P
0 0 0 r
s
.24 .35 .67 r
.50444 .60089 m
.52158 .59521 L
s
.52158 .59521 m
.52502 .59407 L
s
.49211 .57539 m
.50444 .60089 L
s
.913 .264 .113 r
.43395 .55773 m .42055 .5598 L .43888 .58136 L p F P
0 0 0 r
s
.913 .264 .113 r
.43888 .58136 m .44921 .5798 L .43395 .55773 L p F P
0 0 0 r
s
.648 .176 .076 r
.52584 .39238 m .50285 .3964 L .50284 .41774 L p F P
0 0 0 r
s
.83 .24 .1 r
.50282 .39752 m
.50285 .39841 L
s
.50282 .39752 m
.50285 .39752 L
s
.648 .176 .076 r
.48007 .42165 m .50284 .41774 L .50285 .3964 L p F P
0 0 0 r
s
.846 .24 .104 r
.3722 .51517 m .35397 .51811 L .37222 .54157 L p F P
0 0 0 r
s
.24 .35 .67 r
.35535 .5336 m
.36441 .54912 L
s
.881 .252 .108 r
.3882 .53905 m .37222 .54157 L .39389 .56392 L p F P
0 0 0 r
s
.881 .252 .108 r
.39389 .56392 m .4072 .56186 L .3882 .53905 L p F P
0 0 0 r
s
.764 .213 .092 r
.41526 .45639 m .39371 .46002 L .39994 .48433 L p F P
0 0 0 r
s
.764 .213 .092 r
.37975 .48766 m .39994 .48433 L .39371 .46002 L p F P
0 0 0 r
s
.944 .274 .118 r
.52235 .56875 m .51181 .57034 L .50797 .59323 L p F P
0 0 0 r
s
.944 .274 .118 r
.50797 .59323 m .51506 .59218 L .52235 .56875 L p F P
0 0 0 r
s
.24 .35 .67 r
.33495 .5163 m
.35535 .5336 L
s
.31863 .48881 m
.33495 .5163 L
s
.319 .473 .909 r
.55414 .56395 m .55667 .56992 L .53821 .59295 L p F P
0 0 0 r
s
.319 .473 .909 r
.53821 .59295 m .53644 .58902 L .55414 .56395 L p F P
0 0 0 r
s
.247 .347 .604 r
.62825 .42733 m .62359 .41274 L .62404 .3913 L p F P
0 0 0 r
s
.24 .35 .67 r
.62269 .39249 m
.62393 .39644 L
s
.288 .411 .737 r
.62359 .41274 m .62825 .42733 L .62432 .45076 L p F P
0 0 0 r
s
.564 .15 .065 r
.61648 .35808 m .59346 .36216 L .59568 .38018 L p F P
0 0 0 r
s
.564 .15 .065 r
.57226 .38427 m .59568 .38018 L .59346 .36216 L p F P
0 0 0 r
s
.913 .264 .113 r
.4474 .55566 m .43395 .55773 L .44921 .5798 L p F P
0 0 0 r
s
.24 .35 .67 r
.42579 .57941 m
.43526 .59677 L
s
.913 .264 .113 r
.44921 .5798 m .45957 .57823 L .4474 .55566 L p F P
0 0 0 r
s
.846 .24 .104 r
.37222 .54157 m .3882 .53905 L .3722 .51517 L p F P
0 0 0 r
s
.83 .24 .1 r
.37459 .51484 m
.37557 .5202 L
s
.37223 .51522 m
.37459 .51484 L
s
.944 .274 .118 r
.53292 .56716 m .52235 .56875 L .51506 .59218 L p F P
0 0 0 r
s
.944 .274 .118 r
.51506 .59218 m .52218 .59113 L .53292 .56716 L p F P
0 0 0 r
s
.83 .24 .1 r
.62485 .57489 m
.63185 .5991 L
s
.67839 .59236 m
.63185 .5991 L
s
.24 .35 .67 r
.39611 .57234 m
.42579 .57941 L
s
.313 .45 .822 r
.62126 .48831 m .61699 .47579 L .62432 .45076 L p F P
0 0 0 r
s
.326 .471 .874 r
.61699 .47579 m .62126 .48831 L .61042 .51279 L p F P
0 0 0 r
s
.881 .252 .108 r
.40425 .53651 m .3882 .53905 L .4072 .56186 L p F P
0 0 0 r
s
.24 .35 .67 r
.38121 .54613 m
.39611 .57234 L
s
.881 .252 .108 r
.4072 .56186 m .42055 .5598 L .40425 .53651 L p F P
0 0 0 r
s
.944 .274 .118 r
.54351 .56556 m .53292 .56716 L .52218 .59113 L p F P
0 0 0 r
s
.944 .274 .118 r
.52218 .59113 m .5293 .59007 L .54351 .56556 L p F P
0 0 0 r
s
.83 .24 .1 r
.53231 .5886 m
.53265 .58958 L
s
.52995 .58895 m
.53231 .5886 L
s
.808 .228 .098 r
.39994 .48433 m .37975 .48766 L .39051 .51221 L p F P
0 0 0 r
s
.808 .228 .098 r
.3722 .51517 m .39051 .51221 L .37975 .48766 L p F P
0 0 0 r
s
.712 .196 .085 r
.48007 .42165 m .45744 .42554 L .45875 .44905 L p F P
0 0 0 r
s
.712 .196 .085 r
.43694 .45273 m .45875 .44905 L .45744 .42554 L p F P
0 0 0 r
s
.846 .24 .104 r
.39051 .51221 m .3722 .51517 L .3882 .53905 L p F P
0 0 0 r
s
.913 .264 .113 r
.4609 .55357 m .4474 .55566 L .45957 .57823 L p F P
0 0 0 r
s
.913 .264 .113 r
.45957 .57823 m .46996 .57666 L .4609 .55357 L p F P
0 0 0 r
s
.83 .24 .1 r
.6869 .34158 m
.64025 .34987 L
s
.64025 .34987 m
.6414 .37334 L
s
.648 .176 .076 r
.54898 .38834 m .52584 .39238 L .52575 .4138 L p F P
0 0 0 r
s
.83 .24 .1 r
.52463 .39372 m
.52584 .39351 L
s
.54776 .38968 m
.54844 .38956 L
s
.54844 .38956 m
.54845 .38892 L
s
.648 .176 .076 r
.50284 .41774 m .52575 .4138 L .52584 .39238 L p F P
0 0 0 r
s
.83 .24 .1 r
.77319 .57863 m
.77753 .59729 L
s
.82504 .59053 m
.77753 .59729 L
s
.764 .213 .092 r
.43694 .45273 m .41526 .45639 L .42024 .48097 L p F P
0 0 0 r
s
.764 .213 .092 r
.39994 .48433 m .42024 .48097 L .41526 .45639 L p F P
0 0 0 r
s
.944 .274 .118 r
.55414 .56395 m .54351 .56556 L .5293 .59007 L p F P
0 0 0 r
s
.944 .274 .118 r
.5293 .59007 m .53644 .58902 L .55414 .56395 L p F P
0 0 0 r
s
.24 .35 .67 r
.53432 .58421 m
.53499 .58571 L
s
.83 .24 .1 r
.54026 .58742 m
.5783 .58179 L
s
.846 .24 .104 r
.3882 .53905 m .40425 .53651 L .39051 .51221 L p F P
0 0 0 r
s
.33 .484 .915 r
.59296 .52746 m .59656 .53701 L .58013 .56021 L p F P
0 0 0 r
s
.33 .484 .915 r
.58013 .56021 m .57703 .55245 L .59296 .52746 L p F P
0 0 0 r
s
.83 .24 .1 r
.77974 .30771 m
.78194 .32469 L
s
.191 .261 .437 r
.62404 .3913 m .61926 .37606 L .61648 .35808 L p F P
0 0 0 r
s
.247 .347 .604 r
.61926 .37606 m .62404 .3913 L .62359 .41274 L p F P
0 0 0 r
s
.881 .252 .108 r
.42037 .53397 m .40425 .53651 L .42055 .5598 L p F P
0 0 0 r
s
.881 .252 .108 r
.42055 .5598 m .43395 .55773 L .42037 .53397 L p F P
0 0 0 r
s
.913 .264 .113 r
.47445 .55148 m .4609 .55357 L .46996 .57666 L p F P
0 0 0 r
s
.913 .264 .113 r
.46996 .57666 m .48038 .57509 L .47445 .55148 L p F P
0 0 0 r
s
.564 .15 .065 r
.59568 .38018 m .61926 .37606 L .61648 .35808 L p F P
0 0 0 r
s
.24 .35 .67 r
.61309 .36202 m
.61674 .37362 L
s
.326 .471 .874 r
.61042 .51279 m .60642 .50163 L .61699 .47579 L p F P
0 0 0 r
s
.33 .481 .902 r
.60642 .50163 m .61042 .51279 L .59656 .53701 L p F P
0 0 0 r
s
.326 .48 .916 r
.57389 .54459 m .57703 .55245 L .55917 .57582 L p F P
0 0 0 r
s
.326 .48 .916 r
.55917 .57582 m .55667 .56992 L .57389 .54459 L p F P
0 0 0 r
s
.808 .228 .098 r
.42024 .48097 m .39994 .48433 L .40891 .50924 L p F P
0 0 0 r
s
.808 .228 .098 r
.39051 .51221 m .40891 .50924 L .39994 .48433 L p F P
0 0 0 r
s
.846 .24 .104 r
.40891 .50924 m .39051 .51221 L .40425 .53651 L p F P
0 0 0 r
s
.24 .35 .67 r
.26797 .33157 m
.28084 .30548 L
s
.26318 .27289 m
.28084 .30548 L
s
.33 .481 .902 r
.59656 .53701 m .59296 .52746 L .60642 .50163 L p F P
0 0 0 r
s
.24 .35 .67 r
.60547 .50223 m
.60573 .50296 L
s
.913 .264 .113 r
.48805 .54938 m .47445 .55148 L .48038 .57509 L p F P
0 0 0 r
s
.83 .24 .1 r
.4807 .57401 m
.48099 .575 L
s
.913 .264 .113 r
.48038 .57509 m .49083 .57351 L .48805 .54938 L p F P
0 0 0 r
s
.712 .196 .085 r
.50284 .41774 m .48007 .42165 L .48068 .44536 L p F P
0 0 0 r
s
.712 .196 .085 r
.45875 .44905 m .48068 .44536 L .48007 .42165 L p F P
0 0 0 r
s
.846 .24 .104 r
.40425 .53651 m .42037 .53397 L .40891 .50924 L p F P
0 0 0 r
s
.881 .252 .108 r
.43656 .53141 m .42037 .53397 L .43395 .55773 L p F P
0 0 0 r
s
.881 .252 .108 r
.43395 .55773 m .4474 .55566 L .43656 .53141 L p F P
0 0 0 r
s
.24 .35 .67 r
.27914 .38877 m
.26143 .35813 L
s
.27966 .41457 m
.27914 .38877 L
s
.648 .176 .076 r
.57226 .38427 m .54898 .38834 L .5488 .40984 L p F P
0 0 0 r
s
.83 .24 .1 r
.54844 .38956 m
.54897 .38947 L
s
.648 .176 .076 r
.52575 .4138 m .5488 .40984 L .54898 .38834 L p F P
0 0 0 r
s
.764 .213 .092 r
.45875 .44905 m .43694 .45273 L .44066 .4776 L p F P
0 0 0 r
s
.764 .213 .092 r
.42024 .48097 m .44066 .4776 L .43694 .45273 L p F P
0 0 0 r
s
.913 .264 .113 r
.5017 .54728 m .48805 .54938 L .49083 .57351 L p F P
0 0 0 r
s
.913 .264 .113 r
.49083 .57351 m .5013 .57193 L .5017 .54728 L p F P
0 0 0 r
s
.24 .35 .67 r
.49412 .17302 m
.5065 .20796 L
s
.5065 .20796 m
.53393 .21667 L
s
.33411 .20583 m
.36485 .19001 L
s
.36485 .19001 m
.39739 .17845 L
s
.881 .252 .108 r
.45283 .52884 m .43656 .53141 L .4474 .55566 L p F P
0 0 0 r
s
.881 .252 .108 r
.4474 .55566 m .4609 .55357 L .45283 .52884 L p F P
0 0 0 r
s
.83 .24 .1 r
.67199 .5679 m
.67839 .59236 L
s
.72549 .58554 m
.67839 .59236 L
s
.808 .228 .098 r
.40891 .50924 m .42741 .50625 L .42024 .48097 L p F P
0 0 0 r
s
.846 .24 .104 r
.42741 .50625 m .40891 .50924 L .42037 .53397 L p F P
0 0 0 r
s
.83 .24 .1 r
.42268 .5249 m
.4242 .53336 L
s
.288 .411 .737 r
.62432 .45076 m .61976 .43689 L .62359 .41274 L p F P
0 0 0 r
s
.313 .45 .822 r
.61976 .43689 m .62432 .45076 L .61699 .47579 L p F P
0 0 0 r
s
.846 .24 .104 r
.42037 .53397 m .43656 .53141 L .42741 .50625 L p F P
0 0 0 r
s
.808 .228 .098 r
.44066 .4776 m .42024 .48097 L .42741 .50625 L p F P
0 0 0 r
s
.24 .35 .67 r
.5573 .23037 m
.56823 .26403 L
s
.56823 .26403 m
.58614 .28238 L
s
.913 .264 .113 r
.5154 .54516 m .5017 .54728 L .5013 .57193 L p F P
0 0 0 r
s
.913 .264 .113 r
.5013 .57193 m .51181 .57034 L .5154 .54516 L p F P
0 0 0 r
s
.24 .35 .67 r
.30624 .22537 m
.33411 .20583 L
s
.712 .196 .085 r
.52575 .4138 m .50284 .41774 L .50275 .44164 L p F P
0 0 0 r
s
.712 .196 .085 r
.48068 .44536 m .50275 .44164 L .50284 .41774 L p F P
0 0 0 r
s
.83 .24 .1 r
.73412 .33319 m
.6869 .34158 L
s
.6869 .34158 m
.68875 .36507 L
s
.24 .35 .67 r
.39739 .17845 m
.43057 .17158 L
s
.83 .24 .1 r
.5783 .58179 m
.62485 .57489 L
s
.764 .213 .092 r
.48068 .44536 m .45875 .44905 L .46118 .47421 L p F P
0 0 0 r
s
.764 .213 .092 r
.44066 .4776 m .46118 .47421 L .45875 .44905 L p F P
0 0 0 r
s
.648 .176 .076 r
.59568 .38018 m .57226 .38427 L .572 .40585 L p F P
0 0 0 r
s
.83 .24 .1 r
.57102 .38562 m
.57224 .38541 L
s
.59444 .38153 m
.59463 .3815 L
s
.59463 .38133 m
.59463 .3815 L
s
.648 .176 .076 r
.5488 .40984 m .572 .40585 L .57226 .38427 L p F P
0 0 0 r
s
.83 .24 .1 r
.82149 .57164 m
.82504 .59053 L
s
.881 .252 .108 r
.46916 .52626 m .45283 .52884 L .4609 .55357 L p F P
0 0 0 r
s
.881 .252 .108 r
.4609 .55357 m .47445 .55148 L .46916 .52626 L p F P
0 0 0 r
s
.913 .264 .113 r
.52915 .54304 m .5154 .54516 L .51181 .57034 L p F P
0 0 0 r
s
.24 .35 .67 r
.53339 .58215 m
.53432 .58421 L
s
.913 .264 .113 r
.51181 .57034 m .52235 .56875 L .52915 .54304 L p F P
0 0 0 r
s
.24 .35 .67 r
.31863 .48881 m
.30434 .4676 L
s
.28714 .43869 m
.30434 .4676 L
s
.846 .24 .104 r
.44601 .50325 m .42741 .50625 L .43656 .53141 L p F P
0 0 0 r
s
.846 .24 .104 r
.43656 .53141 m .45283 .52884 L .44601 .50325 L p F P
0 0 0 r
s
.326 .48 .916 r
.57071 .53663 m .57389 .54459 L .55667 .56992 L p F P
0 0 0 r
s
.83 .24 .1 r
.57081 .55267 m
.5783 .58179 L
s
.326 .48 .916 r
.55667 .56992 m .55414 .56395 L .57071 .53663 L p F P
0 0 0 r
s
.808 .228 .098 r
.42741 .50625 m .44601 .50325 L .44066 .4776 L p F P
0 0 0 r
s
.33 .484 .915 r
.5893 .51776 m .59296 .52746 L .57703 .55245 L p F P
0 0 0 r
s
.33 .484 .915 r
.57703 .55245 m .57389 .54459 L .5893 .51776 L p F P
0 0 0 r
s
.808 .228 .098 r
.46118 .47421 m .44066 .4776 L .44601 .50325 L p F P
0 0 0 r
s
.24 .35 .67 r
.45833 .58049 m
.42579 .57941 L
s
.41145 .55311 m
.42579 .57941 L
s
.913 .264 .113 r
.54295 .54091 m .52915 .54304 L .52235 .56875 L p F P
0 0 0 r
s
.913 .264 .113 r
.52235 .56875 m .53292 .56716 L .54295 .54091 L p F P
0 0 0 r
s
.881 .252 .108 r
.48557 .52367 m .46916 .52626 L .47445 .55148 L p F P
0 0 0 r
s
.83 .24 .1 r
.47485 .55048 m
.47506 .55139 L
s
.881 .252 .108 r
.47445 .55148 m .48805 .54938 L .48557 .52367 L p F P
0 0 0 r
s
.712 .196 .085 r
.5488 .40984 m .52575 .4138 L .52495 .43789 L p F P
0 0 0 r
s
.712 .196 .085 r
.50275 .44164 m .52495 .43789 L .52575 .4138 L p F P
0 0 0 r
s
.764 .213 .092 r
.50275 .44164 m .48068 .44536 L .48183 .47081 L p F P
0 0 0 r
s
.764 .213 .092 r
.46118 .47421 m .48183 .47081 L .48068 .44536 L p F P
0 0 0 r
s
.313 .45 .822 r
.61699 .47579 m .61262 .463 L .61976 .43689 L p F P
0 0 0 r
s
.326 .471 .874 r
.61262 .463 m .61699 .47579 L .60642 .50163 L p F P
0 0 0 r
s
.24 .35 .67 r
.60547 .50223 m
.60665 .50025 L
s
.846 .24 .104 r
.46469 .50023 m .44601 .50325 L .45283 .52884 L p F P
0 0 0 r
s
.846 .24 .104 r
.45283 .52884 m .46916 .52626 L .46469 .50023 L p F P
0 0 0 r
s
.648 .176 .076 r
.61926 .37606 m .59568 .38018 L .59534 .40184 L p F P
0 0 0 r
s
.83 .24 .1 r
.59463 .3815 m
.59567 .38132 L
s
.648 .176 .076 r
.572 .40585 m .59534 .40184 L .59568 .38018 L p F P
0 0 0 r
s
.24 .35 .67 r
.598 .30468 m
.60804 .33677 L
s
.60804 .33677 m
.61309 .36202 L
s
.28228 .24798 m
.30624 .22537 L
s
.247 .347 .604 r
.62359 .41274 m .61882 .39781 L .61926 .37606 L p F P
0 0 0 r
s
.24 .35 .67 r
.61795 .37747 m
.61915 .38127 L
s
.83 .24 .1 r
.618 .37742 m
.61923 .3772 L
s
.6196 .37714 m
.6414 .37334 L
s
.288 .411 .737 r
.61882 .39781 m .62359 .41274 L .61976 .43689 L p F P
0 0 0 r
s
.913 .264 .113 r
.55681 .53877 m .54295 .54091 L .53292 .56716 L p F P
0 0 0 r
s
.913 .264 .113 r
.53292 .56716 m .54351 .56556 L .55681 .53877 L p F P
0 0 0 r
s
.24 .35 .67 r
.52537 .56431 m
.53339 .58215 L
s
.808 .228 .098 r
.44601 .50325 m .46469 .50023 L .46118 .47421 L p F P
0 0 0 r
s
.881 .252 .108 r
.50205 .52107 m .48557 .52367 L .48805 .54938 L p F P
0 0 0 r
s
.881 .252 .108 r
.48805 .54938 m .5017 .54728 L .50205 .52107 L p F P
0 0 0 r
s
.24 .35 .67 r
.38121 .54613 m
.35535 .5336 L
s
.3393 .50615 m
.35535 .5336 L
s
.43057 .17158 m
.46322 .16971 L
s
.808 .228 .098 r
.48183 .47081 m .46118 .47421 L .46469 .50023 L p F P
0 0 0 r
s
.83 .24 .1 r
.46501 .49968 m
.46508 .50023 L
s
.46508 .50023 m
.4697 .52618 L
s
.4647 .50029 m
.46508 .50023 L
s
.33 .481 .902 r
.60236 .49026 m .60642 .50163 L .59296 .52746 L p F P
0 0 0 r
s
.33 .481 .902 r
.59296 .52746 m .5893 .51776 L .60236 .49026 L p F P
0 0 0 r
s
.83 .24 .1 r
.71972 .56083 m
.72549 .58554 L
s
.77319 .57863 m
.72549 .58554 L
s
.913 .264 .113 r
.57071 .53663 m .55681 .53877 L .54351 .56556 L p F P
0 0 0 r
s
.913 .264 .113 r
.54351 .56556 m .55414 .56395 L .57071 .53663 L p F P
0 0 0 r
s
.24 .35 .67 r
.55639 .5478 m
.55862 .55315 L
s
.83 .24 .1 r
.56144 .5541 m
.57081 .55267 L
s
.326 .471 .874 r
.60642 .50163 m .60236 .49026 L .61262 .463 L p F P
0 0 0 r
s
.846 .24 .104 r
.48347 .4972 m .46469 .50023 L .46916 .52626 L p F P
0 0 0 r
s
.846 .24 .104 r
.46916 .52626 m .48557 .52367 L .48347 .4972 L p F P
0 0 0 r
s
.712 .196 .085 r
.572 .40585 m .5488 .40984 L .54729 .43413 L p F P
0 0 0 r
s
.712 .196 .085 r
.52495 .43789 m .54729 .43413 L .5488 .40984 L p F P
0 0 0 r
s
.881 .252 .108 r
.51861 .51846 m .50205 .52107 L .5017 .54728 L p F P
0 0 0 r
s
.881 .252 .108 r
.5017 .54728 m .5154 .54516 L .51861 .51846 L p F P
0 0 0 r
s
.83 .24 .1 r
.78194 .32469 m
.73412 .33319 L
s
.73412 .33319 m
.7367 .3567 L
s
.764 .213 .092 r
.52495 .43789 m .50275 .44164 L .50259 .46738 L p F P
0 0 0 r
s
.764 .213 .092 r
.48183 .47081 m .50259 .46738 L .50275 .44164 L p F P
0 0 0 r
s
.83 .24 .1 r
.61779 .54552 m
.62485 .57489 L
s
.67199 .5679 m
.62485 .57489 L
s
.808 .228 .098 r
.46469 .50023 m .48347 .4972 L .48183 .47081 L p F P
0 0 0 r
s
.648 .176 .076 r
.59534 .40184 m .61882 .39781 L .61926 .37606 L p F P
0 0 0 r
s
.24 .35 .67 r
.61674 .37362 m
.6176 .37635 L
s
.808 .228 .098 r
.50259 .46738 m .48183 .47081 L .48347 .4972 L p F P
0 0 0 r
s
.24 .35 .67 r
.26143 .35813 m
.26797 .33157 L
s
.2498 .29923 m
.26797 .33157 L
s
.846 .24 .104 r
.50235 .49415 m .48347 .4972 L .48557 .52367 L p F P
0 0 0 r
s
.846 .24 .104 r
.48557 .52367 m .50205 .52107 L .50235 .49415 L p F P
0 0 0 r
s
.881 .252 .108 r
.53524 .51583 m .51861 .51846 L .5154 .54516 L p F P
0 0 0 r
s
.881 .252 .108 r
.5154 .54516 m .52915 .54304 L .53524 .51583 L p F P
0 0 0 r
s
.33 .484 .915 r
.58558 .50788 m .5893 .51776 L .57389 .54459 L p F P
0 0 0 r
s
.33 .484 .915 r
.57389 .54459 m .57071 .53663 L .58558 .50788 L p F P
0 0 0 r
s
.83 .24 .1 r
.68875 .36507 m
.6414 .37334 L
s
.6414 .37334 m
.64398 .40217 L
s
.808 .228 .098 r
.48347 .4972 m .50235 .49415 L .50259 .46738 L p F P
0 0 0 r
s
.712 .196 .085 r
.59534 .40184 m .572 .40585 L .56976 .43034 L p F P
0 0 0 r
s
.712 .196 .085 r
.54729 .43413 m .56976 .43034 L .572 .40585 L p F P
0 0 0 r
s
.764 .213 .092 r
.54729 .43413 m .52495 .43789 L .52346 .46393 L p F P
0 0 0 r
s
.764 .213 .092 r
.50259 .46738 m .52346 .46393 L .52495 .43789 L p F P
0 0 0 r
s
.24 .35 .67 r
.49211 .57539 m
.45833 .58049 L
s
.44466 .55402 m
.45833 .58049 L
s
.52206 .18153 m
.53393 .21667 L
s
.53393 .21667 m
.5573 .23037 L
s
.881 .252 .108 r
.55194 .5132 m .53524 .51583 L .52915 .54304 L p F P
0 0 0 r
s
.881 .252 .108 r
.52915 .54304 m .54295 .54091 L .55194 .5132 L p F P
0 0 0 r
s
.288 .411 .737 r
.61976 .43689 m .6151 .42269 L .61882 .39781 L p F P
0 0 0 r
s
.313 .45 .822 r
.6151 .42269 m .61976 .43689 L .61262 .463 L p F P
0 0 0 r
s
.846 .24 .104 r
.52133 .49108 m .50235 .49415 L .50205 .52107 L p F P
0 0 0 r
s
.846 .24 .104 r
.50205 .52107 m .51861 .51846 L .52133 .49108 L p F P
0 0 0 r
s
.808 .228 .098 r
.52346 .46393 m .50259 .46738 L .50235 .49415 L p F P
0 0 0 r
s
.83 .24 .1 r
.56913 .54476 m
.57081 .55267 L
s
.56883 .54333 m
.56913 .54476 L
s
.57081 .55267 m
.61779 .54552 L
s
.24 .35 .67 r
.26318 .27289 m
.28228 .24798 L
s
.55639 .5478 m
.56419 .54175 L
s
.28714 .43869 m
.27966 .41457 L
s
.26172 .38411 m
.27966 .41457 L
s
.83 .24 .1 r
.76805 .55367 m
.77319 .57863 L
s
.82149 .57164 m
.77319 .57863 L
s
.808 .228 .098 r
.50235 .49415 m .52133 .49108 L .52346 .46393 L p F P
0 0 0 r
s
.881 .252 .108 r
.56872 .51055 m .55194 .5132 L .54295 .54091 L p F P
0 0 0 r
s
.881 .252 .108 r
.54295 .54091 m .55681 .53877 L .56872 .51055 L p F P
0 0 0 r
s
.24 .35 .67 r
.46322 .16971 m
.49412 .17302 L
s
.712 .196 .085 r
.61882 .39781 m .59534 .40184 L .59236 .42653 L p F P
0 0 0 r
s
.712 .196 .085 r
.56976 .43034 m .59236 .42653 L .59534 .40184 L p F P
0 0 0 r
s
.764 .213 .092 r
.56976 .43034 m .54729 .43413 L .54446 .46046 L p F P
0 0 0 r
s
.83 .24 .1 r
.55258 .45079 m
.55312 .4507 L
s
.55307 .45021 m
.55312 .4507 L
s
.764 .213 .092 r
.52346 .46393 m .54446 .46046 L .54729 .43413 L p F P
0 0 0 r
s
.846 .24 .104 r
.5404 .488 m .52133 .49108 L .51861 .51846 L p F P
0 0 0 r
s
.846 .24 .104 r
.51861 .51846 m .53524 .51583 L .5404 .488 L p F P
0 0 0 r
s
.83 .24 .1 r
.78194 .32469 m
.78526 .34823 L
s
.66537 .53828 m
.67199 .5679 L
s
.71972 .56083 m
.67199 .5679 L
s
.24 .35 .67 r
.57548 .24869 m
.58614 .28238 L
s
.58614 .28238 m
.598 .30468 L
s
.33 .481 .902 r
.59821 .47867 m .60236 .49026 L .5893 .51776 L p F P
0 0 0 r
s
.33 .481 .902 r
.5893 .51776 m .58558 .50788 L .59821 .47867 L p F P
0 0 0 r
s
.808 .228 .098 r
.54446 .46046 m .52346 .46393 L .52133 .49108 L p F P
0 0 0 r
s
.881 .252 .108 r
.58558 .50788 m .56872 .51055 L .55681 .53877 L p F P
0 0 0 r
s
.881 .252 .108 r
.55681 .53877 m .57071 .53663 L .58558 .50788 L p F P
0 0 0 r
s
.313 .45 .822 r
.61262 .463 m .60816 .44995 L .6151 .42269 L p F P
0 0 0 r
s
.326 .471 .874 r
.60816 .44995 m .61262 .463 L .60236 .49026 L p F P
0 0 0 r
s
.83 .24 .1 r
.61921 .4064 m
.64398 .40217 L
s
.24 .35 .67 r
.52537 .56431 m
.49211 .57539 L
s
.47918 .54868 m
.49211 .57539 L
s
.808 .228 .098 r
.52133 .49108 m .5404 .488 L .54446 .46046 L p F P
0 0 0 r
s
.24 .35 .67 r
.545 .52041 m
.55639 .5478 L
s
.52537 .56431 m
.55639 .5478 L
s
.846 .24 .104 r
.55957 .48491 m .5404 .488 L .53524 .51583 L p F P
0 0 0 r
s
.846 .24 .104 r
.53524 .51583 m .55194 .5132 L .55957 .48491 L p F P
0 0 0 r
s
.326 .471 .874 r
.60236 .49026 m .59821 .47867 L .60816 .44995 L p F P
0 0 0 r
s
.24 .35 .67 r
.3393 .50615 m
.31863 .48881 L
s
.30154 .45999 m
.31863 .48881 L
s
.83 .24 .1 r
.7367 .3567 m
.68875 .36507 L
s
.68875 .36507 m
.6919 .394 L
s
.764 .213 .092 r
.59236 .42653 m .56976 .43034 L .56557 .45698 L p F P
0 0 0 r
s
.764 .213 .092 r
.54446 .46046 m .56557 .45698 L .56976 .43034 L p F P
0 0 0 r
s
.712 .196 .085 r
.59236 .42653 m .6151 .42269 L .61882 .39781 L p F P
0 0 0 r
s
.83 .24 .1 r
.61788 .40663 m
.61921 .4064 L
s
.24 .35 .67 r
.61094 .38925 m
.6161 .4052 L
s
.6161 .4052 m
.61637 .40605 L
s
.51322 .53729 m
.52537 .56431 L
s
.808 .228 .098 r
.56557 .45698 m .54446 .46046 L .5404 .488 L p F P
0 0 0 r
s
.24 .35 .67 r
.41145 .55311 m
.38121 .54613 L
s
.3656 .51866 m
.38121 .54613 L
s
.83 .24 .1 r
.58331 .51684 m
.61108 .51249 L
s
.5818 .51708 m
.58331 .51684 L
s
.61108 .51249 m
.61779 .54552 L
s
.66537 .53828 m
.61779 .54552 L
s
.808 .228 .098 r
.5404 .488 m .55957 .48491 L .56557 .45698 L p F P
0 0 0 r
s
.846 .24 .104 r
.57884 .48179 m .55957 .48491 L .55194 .5132 L p F P
0 0 0 r
s
.24 .35 .67 r
.57918 .51539 m
.57952 .51628 L
s
.846 .24 .104 r
.55194 .5132 m .56872 .51055 L .57884 .48179 L p F P
0 0 0 r
s
.24 .35 .67 r
.60302 .33009 m
.61309 .36202 L
s
.61309 .36202 m
.61094 .38925 L
s
.83 .24 .1 r
.817 .54642 m
.82149 .57164 L
s
.764 .213 .092 r
.6151 .42269 m .59236 .42653 L .58681 .45347 L p F P
0 0 0 r
s
.83 .24 .1 r
.59983 .43931 m
.60021 .44288 L
s
.59589 .44359 m
.60021 .44288 L
s
.764 .213 .092 r
.56557 .45698 m .58681 .45347 L .59236 .42653 L p F P
0 0 0 r
s
.808 .228 .098 r
.58681 .45347 m .56557 .45698 L .55957 .48491 L p F P
0 0 0 r
s
.83 .24 .1 r
.71356 .53094 m
.71972 .56083 L
s
.76805 .55367 m
.71972 .56083 L
s
.846 .24 .104 r
.59821 .47867 m .57884 .48179 L .56872 .51055 L p F P
0 0 0 r
s
.846 .24 .104 r
.56872 .51055 m .58558 .50788 L .59821 .47867 L p F P
0 0 0 r
s
.24 .35 .67 r
.57285 .49894 m
.57918 .51539 L
s
.808 .228 .098 r
.55957 .48491 m .57884 .48179 L .58681 .45347 L p F P
0 0 0 r
s
.24 .35 .67 r
.2498 .29923 m
.26318 .27289 L
s
.83 .24 .1 r
.6919 .394 m
.64398 .40217 L
s
.64398 .40217 m
.6479 .43495 L
s
.24 .35 .67 r
.26143 .35813 m
.24286 .32601 L
s
.26172 .38411 m
.26143 .35813 L
s
.83 .24 .1 r
.78526 .34823 m
.7367 .3567 L
s
.7367 .3567 m
.74043 .38571 L
s
.764 .213 .092 r
.58681 .45347 m .60816 .44995 L .6151 .42269 L p F P
0 0 0 r
s
.83 .24 .1 r
.6109 .4411 m
.61364 .44064 L
s
.61364 .44064 m
.6479 .43495 L
s
.24 .35 .67 r
.60143 .41721 m
.60873 .4388 L
s
.60873 .4388 m
.6093 .4405 L
s
.49412 .17302 m
.52206 .18153 L
s
.808 .228 .098 r
.60816 .44995 m .58681 .45347 L .57884 .48179 L p F P
0 0 0 r
s
.808 .228 .098 r
.57884 .48179 m .59821 .47867 L .60816 .44995 L p F P
0 0 0 r
s
.24 .35 .67 r
.59537 .47407 m
.6007 .46519 L
s
.83 .24 .1 r
.59931 .47855 m
.60511 .47761 L
s
.59907 .47859 m
.59931 .47855 L
s
.24 .35 .67 r
.59537 .47407 m
.59663 .47758 L
s
.59663 .47758 m
.59668 .47772 L
s
.83 .24 .1 r
.6035 .46622 m
.60511 .47761 L
s
.24 .35 .67 r
.54583 .19509 m
.5573 .23037 L
s
.5573 .23037 m
.57548 .24869 L
s
.83 .24 .1 r
.60511 .47761 m
.61108 .51249 L
s
.65891 .50499 m
.61108 .51249 L
s
.65891 .50499 m
.66537 .53828 L
s
.71356 .53094 m
.66537 .53828 L
s
.60511 .47761 m
.65297 .46988 L
s
.24 .35 .67 r
.30154 .45999 m
.28714 .43869 L
s
.26912 .40837 m
.28714 .43869 L
s
.83 .24 .1 r
.76236 .52352 m
.76805 .55367 L
s
.817 .54642 m
.76805 .55367 L
s
.24 .35 .67 r
.44466 .55402 m
.41145 .55311 L
s
.39642 .52553 m
.41145 .55311 L
s
.83 .24 .1 r
.74043 .38571 m
.6919 .394 L
s
.6919 .394 m
.6962 .42692 L
s
.24 .35 .67 r
.58747 .27104 m
.598 .30468 L
s
.598 .30468 m
.60302 .33009 L
s
.58478 .44453 m
.59537 .47407 L
s
.59537 .47407 m
.57285 .49894 L
s
.83 .24 .1 r
.6962 .42692 m
.6479 .43495 L
s
.6479 .43495 m
.65297 .46988 L
s
.78526 .34823 m
.78958 .37733 L
s
.24 .35 .67 r
.3656 .51866 m
.3393 .50615 L
s
.32248 .47737 m
.3393 .50615 L
s
.83 .24 .1 r
.65297 .46988 m
.65891 .50499 L
s
.70735 .4974 m
.65891 .50499 L
s
.70735 .4974 m
.71356 .53094 L
s
.76236 .52352 m
.71356 .53094 L
s
.24 .35 .67 r
.60069 .35756 m
.61094 .38925 L
s
.61094 .38925 m
.60143 .41721 L
s
.83 .24 .1 r
.70145 .46205 m
.65297 .46988 L
s
.24 .35 .67 r
.24286 .32601 m
.2498 .29923 L
s
.83 .24 .1 r
.81178 .51599 m
.817 .54642 L
s
.78958 .37733 m
.74043 .38571 L
s
.74043 .38571 m
.74513 .41879 L
s
.24 .35 .67 r
.47918 .54868 m
.44466 .55402 L
s
.43032 .52626 m
.44466 .55402 L
s
.52206 .18153 m
.54583 .19509 L
s
.83 .24 .1 r
.74513 .41879 m
.6962 .42692 L
s
.6962 .42692 m
.70145 .46205 L
s
.24 .35 .67 r
.56163 .46981 m
.57285 .49894 L
s
.57285 .49894 m
.545 .52041 L
s
.26912 .40837 m
.26172 .38411 L
s
.24289 .35217 m
.26172 .38411 L
s
.83 .24 .1 r
.70145 .46205 m
.70735 .4974 L
s
.75641 .48971 m
.70735 .4974 L
s
.75641 .48971 m
.76236 .52352 L
s
.81178 .51599 m
.76236 .52352 L
s
.24 .35 .67 r
.56429 .21335 m
.57548 .24869 L
s
.57548 .24869 m
.58747 .27104 L
s
.83 .24 .1 r
.75056 .45412 m
.70145 .46205 L
s
.24 .35 .67 r
.51322 .53729 m
.47918 .54868 L
s
.46562 .52065 m
.47918 .54868 L
s
.53305 .49167 m
.545 .52041 L
s
.545 .52041 m
.51322 .53729 L
s
.32248 .47737 m
.30154 .45999 L
s
.2836 .42976 m
.30154 .45999 L
s
.83 .24 .1 r
.78958 .37733 m
.79468 .41055 L
s
.24 .35 .67 r
.50048 .50893 m
.51322 .53729 L
s
.39642 .52553 m
.3656 .51866 L
s
.34922 .48984 m
.3656 .51866 L
s
.83 .24 .1 r
.79468 .41055 m
.74513 .41879 L
s
.74513 .41879 m
.75056 .45412 L
s
.24 .35 .67 r
.59247 .29659 m
.60302 .33009 L
s
.60302 .33009 m
.60069 .35756 L
s
.59083 .38583 m
.60143 .41721 L
s
.60143 .41721 m
.58478 .44453 L
s
.83 .24 .1 r
.75056 .45412 m
.75641 .48971 L
s
.80611 .48192 m
.75641 .48971 L
s
.80611 .48192 m
.81178 .51599 L
s
.8003 .44609 m
.75056 .45412 L
s
.24 .35 .67 r
.24289 .35217 m
.24286 .32601 L
s
.54583 .19509 m
.56429 .21335 L
s
.83 .24 .1 r
.79468 .41055 m
.8003 .44609 L
s
.8003 .44609 m
.80611 .48192 L
s
.24 .35 .67 r
.2836 .42976 m
.26912 .40837 L
s
.25019 .37655 m
.26912 .40837 L
s
.43032 .52626 m
.39642 .52553 L
s
.38063 .49659 m
.39642 .52553 L
s
.57642 .23572 m
.58747 .27104 L
s
.58747 .27104 m
.59247 .29659 L
s
.57366 .41353 m
.58478 .44453 L
s
.58478 .44453 m
.56163 .46981 L
s
.34922 .48984 m
.32248 .47737 L
s
.30482 .44716 m
.32248 .47737 L
s
.58994 .32428 m
.60069 .35756 L
s
.60069 .35756 m
.59083 .38583 L
s
.46562 .52065 m
.43032 .52626 L
s
.41526 .4971 m
.43032 .52626 L
s
.54984 .43921 m
.56163 .46981 L
s
.56163 .46981 m
.53305 .49167 L
s
.25019 .37655 m
.24289 .35217 L
s
.56429 .21335 m
.57642 .23572 L
s
.50048 .50893 m
.46562 .52065 L
s
.45138 .49122 m
.46562 .52065 L
s
.52049 .46149 m
.53305 .49167 L
s
.53305 .49167 m
.50048 .50893 L
s
.30482 .44716 m
.2836 .42976 L
s
.26476 .39801 m
.2836 .42976 L
s
.48709 .47914 m
.50048 .50893 L
s
.38063 .49659 m
.34922 .48984 L
s
.33201 .45956 m
.34922 .48984 L
s
.58138 .2614 m
.59247 .29659 L
s
.59247 .29659 m
.58994 .32428 L
s
.57969 .35287 m
.59083 .38583 L
s
.59083 .38583 m
.57366 .41353 L
s
.26476 .39801 m
.25019 .37655 L
s
.41526 .4971 m
.38063 .49659 L
s
.36405 .46617 m
.38063 .49659 L
s
.57642 .23572 m
.58138 .2614 L
s
.56197 .38094 m
.57366 .41353 L
s
.57366 .41353 m
.54984 .43921 L
s
.33201 .45956 m
.30482 .44716 L
s
.28625 .4154 m
.30482 .44716 L
s
.57863 .28931 m
.58994 .32428 L
s
.58994 .32428 m
.57969 .35287 L
s
.45138 .49122 m
.41526 .4971 L
s
.39944 .46646 m
.41526 .4971 L
s
.53746 .40704 m
.54984 .43921 L
s
.54984 .43921 m
.52049 .46149 L
s
.48709 .47914 m
.45138 .49122 L
s
.4364 .46026 m
.45138 .49122 L
s
.50729 .42975 m
.52049 .46149 L
s
.52049 .46149 m
.48709 .47914 L
s
.28625 .4154 m
.26476 .39801 L
s
.473 .44782 m
.48709 .47914 L
s
.36405 .46617 m
.33201 .45956 L
s
.31391 .42772 m
.33201 .45956 L
s
.58138 .2614 m
.57863 .28931 L
s
.56798 .3182 m
.57969 .35287 L
s
.57969 .35287 m
.56197 .38094 L
s
.39944 .46646 m
.36405 .46617 L
s
.34659 .43416 m
.36405 .46617 L
s
.54967 .34665 m
.56197 .38094 L
s
.56197 .38094 m
.53746 .40704 L
s
.31391 .42772 m
.28625 .4154 L
s
.57863 .28931 m
.56798 .3182 L
s
.4364 .46026 m
.39944 .46646 L
s
.38277 .43419 m
.39944 .46646 L
s
.52441 .37317 m
.53746 .40704 L
s
.53746 .40704 m
.50729 .42975 L
s
.473 .44782 m
.4364 .46026 L
s
.42063 .42767 m
.4364 .46026 L
s
.49339 .39633 m
.50729 .42975 L
s
.50729 .42975 m
.473 .44782 L
s
.45817 .41483 m
.473 .44782 L
s
.34659 .43416 m
.31391 .42772 L
s
.56798 .3182 m
.54967 .34665 L
s
.38277 .43419 m
.34659 .43416 L
s
.54967 .34665 m
.52441 .37317 L
s
.42063 .42767 m
.38277 .43419 L
s
.52441 .37317 m
.49339 .39633 L
s
.45817 .41483 m
.42063 .42767 L
s
.49339 .39633 m
.45817 .41483 L
s
0 0 0 r
.25 Mabswid
.75972 .08168 m
.80207 .35868 L
s
.80207 .35868 m
.02925 .49223 L
s
.02925 .49223 m
.08947 .22236 L
s
.08947 .22236 m
.75972 .08168 L
s
.75972 .08168 m
.80207 .35868 L
s
.80207 .35868 m
.86955 .74993 L
s
.86955 .74993 m
.83139 .50547 L
s
.83139 .50547 m
.75972 .08168 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{500, 500},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40007d0001m2000`400?l00000o`00003oo`3ooooe
0?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3o
m^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40
oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?of
k_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3o
ool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^
m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?oo
o`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd
0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo
003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0
ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool0
0?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03o
m^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofkWX0ooK^0`00001g0?ofkP40oooo003o0?ofkWD0
ooK^1@0000020?ofkP030000003om^h0ooK^07D0ooK^0@3oool00?l0ooK^L@3om^h4000000L0ooK^
00<000000?ofkP3om^h0M@3om^h10?ooo`00o`3om^i/0?ofkPD000002`3om^h00`000000ooK^0?of
kP1e0?ofkP40oooo003o0?ofkVL0ooK^1@00000A0?ofkP030000003om^h0ooK^07@0ooK^0@3oool0
0?l0ooK^HP3om^h5000001H0ooK^00<000000?ofkP3om^h0M03om^h10?ooo`00o`3om^iM0?ofkPD0
00006`3om^h00`000000ooK^0?ofkP1d0?ofkP40oooo003o0?ofkUT0ooK^1000000P0?ofkP030000
003om^h0ooK^07@0ooK^0@3oool00?l0ooK^E03om^h5000002@0ooK^00<000000?ofkP3om^h0M03o
m^h10?ooo`00o`3om^i?0?ofkPD00000:@3om^h00`000000ooK^0?ofkP1d0?ofkP40oooo003o0?of
kTX0ooK^1@00000_0?ofkP030000003om^h0ooK^07<0ooK^0@3oool00?l0ooK^A@3om^h5000003@0
ooK^00<000000?ofkP3om^h0L`3om^h10?ooo`00o`3om^i10?ofkP@00000>@3om^h00`000000ooK^
0?ofkP1c0?ofkP40oooo003o0?ofkS`0ooK^1@00000m0?ofkP030000003om^h0ooK^07<0ooK^0@3o
ool00?l0ooK^=`3om^h500000480ooK^00<000000?ofkP3om^h0L`3om^h10?ooo`00o`3om^hb0?of
kPD00000A`3om^h00`000000ooK^0?ofkP1c0?ofkP40oooo003o0?ofkRh0ooK^1000001<0?ofkP80
0000M03om^h10?ooo`00o`3om^hY0?ofkPD00000D@3om^h00`000000ooK^0?ofkP1b0?ofkP40oooo
003o0?ofkR@0ooK^1@00001F0?ofkP030000003om^h0ooK^0780ooK^0@3oool00?l0ooK^7`3om^h5
000005/0ooK^00<000000?ofkP3om^h0LP3om^h10?ooo`00o`3om^hJ0?ofkPD00000H03om^h00`00
0000ooK^0?ofkP1b0?ofkP40oooo003o0?ofkQH0ooK^1000001U0?ofkP030000003om^h0ooK^0780
ooK^0@3oool00?l0ooK^4@3om^h5000006T0ooK^0P00001c0?ofkP40oooo003o0?ofkP`0ooK^1@00
001^0?ofkP800000L`3om^h10?ooo`00o`3om^h70?ofkPD00000M03om^h00`000000ooK^0?ofkP1a
0?ofkP40oooo003o0?ofkP80ooK^1@00001i0?ofkP030000003om^h0ooK^0740ooK^0@3oool00?d0
ooK^1000001n0?ofkP030000003om^h0ooK^0740ooK^0@3oool00?P0ooK^1@0000220?ofkP030000
003om^h0ooK^0740ooK^0@3oool00?<0ooK^1@0000270?ofkP800000LP3om^h10?ooo`00kP3om^h5
000008`0ooK^0P00001b0?ofkP40oooo003Z0?ofkP@00000TP3om^h00`000000ooK^0?ofkP1`0?of
kP40oooo003U0?ofkPD00000UP3om^h00`000000ooK^0?ofkP1`0?ofkP40oooo003P0?ofkPD00000
V`3om^h00`000000ooK^0?ofkP1`0?ofkP40oooo003K0?ofkPD00000X03om^h00`000000ooK^0?of
kP1`0?ofkP40oooo003F0?ofkPD00000Y@3om^h200000740ooK^0@3oool00=80ooK^1000002Z0?of
kP800000L@3om^h10?ooo`00c@3om^h500000:h0ooK^0P00001a0?ofkP40oooo00380?ofkPD00000
]03om^h00`000000ooK^0?ofkP1_0?ofkP40oooo00330?ofkPD00000^@3om^h00`000000ooK^0?of
kP1_0?ofkP40oooo002n0?ofkPD00000_P3om^h00`000000ooK^0?ofkP1_0?ofkP40oooo002j0?of
kP@00000``3om^h200000700ooK^0@3oool00;D0ooK^1@0000370?ofkP800000L03om^h10?ooo`00
/03om^h500000<`0ooK^0P00001`0?ofkP40oooo002[0?ofkPD00000dP3om^h00`000000ooK^0?of
kP1^0?ofkP40oooo002W0?ofkP@00000=03om^h<03eIZiL0ooK^00<000000?ofkP3om^h0KP3om^h1
0?ooo`00XP3om^h5000002h0ooK^2P0mFJ/80?ofkP0403eIZ`3om^h0ooK^0?ofkPP0?EV[S`3om^h0
0`000000ooK^0?ofkP1^0?ofkP40oooo002M0?ofkPD00000;`3om^h403eIZ`030?ofkP0mFJ/0ooK^
0100ooK^00<0?EV[0?ofkP3om^h0203om^h503eIZhX0ooK^0P00001_0?ofkP40oooo002H0?ofkPD0
0000<03om^h403eIZ`H0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP03
03eIZ`3om^h0?EV[00<0?EV[QP3om^h2000006l0ooK^0@3oool009<0ooK^1@00000a0?ofkP@0?EV[
2P3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h0
0P3om^h303eIZh<0ooK^0P00001_0?ofkP40oooo002?0?ofkP@00000<P3om^h403eIZ`l0ooK^00<0
?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00D0ooK^100m
FJ]o0?ofkP800000K`3om^h10?ooo`00RP3om^h5000003<0ooK^0`0mFJ/00`3om^h0?EV[0?ofkP0@
0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP09
0?ofkP80?EV[OP3om^h00`000000ooK^0?ofkP1]0?ofkP40oooo00250?ofkPD00000=@3om^h303eI
Z`D0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^
00`0ooK^00<0?EV[0?ofkP3om^h02@3om^h303eIZg`0ooK^00<000000?ofkP3om^h0K@3om^h10?oo
o`00P03om^h5000003H0ooK^100mFJ/80?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3o
m^h03P3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00X0ooK^00@0?EV[0?ofkP0m
FJ/0?EV[NP3om^h2000006h0ooK^0@3oool007/0ooK^1@00000h0?ofkP<0?EV[3@3om^h00`0mFJ/0
ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0
ooK^0?ofkP0:0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/0N@3om^h2000006h0ooK^0@3oool007L0
ooK^1000000k0?ofkP80?EV[403om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00h0
ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^0080
ooK^0P0mFJ]g0?ofkP800000KP3om^h10?ooo`00LP3om^h5000003d0ooK^0`0mFJ/A0?ofkP0303eI
Z`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eI
Z`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h00`3om^h203eIZgD0ooK^0P00001^0?ofkP40oooo
001]0?ofkPD00000@03om^h203eIZ`<0ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?of
kP0?0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?of
kP090?ofkP0303eIZ`3om^h0ooK^00D0ooK^0P0mFJ]d0?ofkP030000003om^h0ooK^06`0ooK^0@3o
ool006P0ooK^1@0000130?ofkP80?EV[1@3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0
ooK^00l0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0
ooK^00T0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP1a0?ofkP030000003om^h0
ooK^06`0ooK^0@3oool006@0ooK^100000160?ofkP80?EV[203om^h00`0mFJ/0ooK^0?ofkP0?0?of
kP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0;0?of
kP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h01P3om^h203eIZg80ooK^0P00001]0?of
kP40oooo001O0?ofkPD00000B03om^h203eIZ`X0ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0
ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0
ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^00L0ooK^0P0mFJ]a0?ofkP800000K@3om^h10?ooo`00
FP3om^h5000004/0ooK^0P0mFJ/<0?ofkP0303eIZ`3om^h0ooK^0100ooK^00<0?EV[0?ofkP3om^h0
3P3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h0
2@3om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0?EV[0700ooK^0P00001]0?ofkP40oooo
001E0?ofkPD00000CP3om^h203eIZ`l0ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?of
kP0?0?ofkP0303eIZ`3om^h0ooK^00H0ooK^2`0mFJ/:0?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0
?EV[0?ofkP3om^h01P3om^h0100mFJ/0ooK^0?ofkP0mFJ]_0?ofkP800000K@3om^h10?ooo`00D03o
m^h500000540ooK^0P0mFJ/A0?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h03P3o
m^h:03eIZ`L0ooK^00@0?EV[0?ofkP3om^h0ooK^200mFJ/30?ofkP0303eIZ`3om^h0ooK^00T0ooK^
00<0?EV[0?ofkP3om^h01`3om^h0100mFJ/0ooK^0?ofkP0mFJ]^0?ofkP800000K@3om^h10?ooo`00
C03om^h4000005@0ooK^0`0mFJ/C0?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h0
2@3om^h403eIZ`030?ofkP0mFJ/0ooK^00l0ooK^00<0?EV[0?ofkP3om^h0203om^h503eIZ`X0ooK^
00<0?EV[0?ofkP3om^h01`3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[06h0ooK^00<000000?ofkP3o
m^h0J`3om^h10?ooo`00A`3om^h5000005L0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0B0?ofkP03
03eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h01@3om^h403eIZ`H0ooK^00<0?EV[0?ofkP3o
m^h03@3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0?EV[0080?EV[203om^h00`0mFJ/0
ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h0J`3om^h2000006`0
ooK^0@3oool00480ooK^1@00001K0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h0
4@3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00@0?EV[2P3om^h00`0mFJ/0ooK^
0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00@0?EV[0?ofkP3om^h0ooK^0P0mFJ/60?ofkP03
03eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP1Z0?ofkP80
0000K03om^h10?ooo`00?@3om^h5000005h0ooK^0P0mFJ/60?ofkP0303eIZ`3om^h0ooK^0100ooK^
00<0?EV[0?ofkP3om^h03P3om^h403eIZ`l0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^
0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00<0ooK^0`0mFJ/30?ofkP0303eIZ`3om^h0ooK^00L0ooK^
00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP1Y0?ofkP800000K03om^h10?ooo`00>03o
m^h500000680ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0303eIZ`3o
m^h0ooK^00/0ooK^0`0mFJ/00`3om^h0?EV[0?ofkP0@0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0
?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP060?ofkP<0?EV[00<0ooK^03eIZ`3om^h0203o
m^h00`0mFJ/0ooK^0?ofkP020?ofkP80?EV[JP3om^h2000006`0ooK^0@3oool003@0ooK^1000001U
0?ofkP80?EV[2P3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0303eIZ`3om^h0ooK^00L0ooK^0`0mFJ/5
0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0<
0?ofkP0303eIZ`3om^h0ooK^00P0ooK^0P0mFJ/90?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[
0?ofkP3om^h0J03om^h2000006`0ooK^0@3oool002l0ooK^1@00001X0?ofkP0303eIZ`3om^h0ooK^
00X0ooK^00<0?EV[0?ofkP3om^h0403om^h00`0mFJ/0ooK^0?ofkP030?ofkP@0?EV[203om^h00`0m
FJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0m
FJ/0ooK^0?ofkP090?ofkP<0?EV[1`3om^h00`0mFJ/0ooK^0?ofkP030?ofkP80?EV[J@3om^h20000
06`0ooK^0@3oool002`0ooK^0`00001/0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3o
m^h0403om^h00`0mFJ/0ooK^03eIZ`0203eIZ`d0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0
ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h02P3om^h0100mFJ/0
ooK^03eIZ`0mFJ/60?ofkP0303eIZ`3om^h0ooK^0080ooK^0P0mFJ]Z0?ofkP800000J`3om^h10?oo
o`00;03om^h2000006/0ooK^0P0mFJ/?0?ofkP0303eIZ`3om^h0ooK^0100ooK^0P0mFJ/@0?ofkP03
03eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP03
03eIZ`3om^h0ooK^00T0ooK^00@0?EV[0?ofkP3om^h0ooK^0P0mFJ/40?ofkP0303eIZ`3om^h0ooK^
00<0ooK^0P0mFJ]Y0?ofkP800000J`3om^h10?ooo`00;03om^h2000006X0ooK^00<0?EV[0?ofkP3o
m^h0403om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP<0?EV[4P3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP03
03eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP090?ofkP03
03eIZ`3om^h0ooK^00<0ooK^0P0mFJ/20?ofkP0303eIZ`3om^h0ooK^00<0ooK^0P0mFJ]Y0?ofkP80
0000J`3om^h10?ooo`00:`3om^h010000000ooK^0?ofkP00001X0?ofkP0303eIZ`3om^h0?EV[0140
ooK^00<0?EV[0?ofkP3om^h02`3om^h203eIZ`<0ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0
ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0
ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^00@0ooK^0P0mFJ/00`3om^h0?EV[0?ofkP030?ofkP03
03eIZ`3om^h0?EV[06P0ooK^0P00001[0?ofkP40oooo000[0?ofkP050000003om^h0ooK^0?ofkP00
0000IP3om^h0100mFJ/0ooK^0?ofkP0mFJ/B0?ofkP0303eIZ`3om^h0ooK^00P0ooK^0P0mFJ/50?of
kP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP0=0?of
kP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP060?of
kP80?EV[1@3om^h203eIZfP0ooK^0P00001[0?ofkP40oooo000[0?ofkP050000003om^h0ooK^0?of
kP000000I@3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?of
kP3om^h01P3om^h203eIZ`P0ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP0>0?of
kP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP0:0?of
kP0303eIZ`3om^h0ooK^00H0ooK^0P0mFJ/40?ofkP0303eIZ`3om^h0?EV[06L0ooK^0P00001[0?of
kP40oooo000[0?ofkP030000003om^h0ooK^0080ooK^00<000000?ofkP3om^h0H@3om^h00`0mFJ/0
ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^0100ooK^00<0?EV[0?ofkP3om^h00`3om^h203eIZ`X0
ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00`0
ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^00L0
ooK^0P0mFJ/30?ofkP0303eIZ`3om^h0?EV[06P0ooK^0P00001Z0?ofkP40oooo000Z0?ofkP030000
003om^h0ooK^00<0ooK^00<000000?ofkP3om^h0H03om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eI
Z`3om^h0ooK^00l0ooK^00@0?EV[0?ofkP3om^h0ooK^0P0mFJ/=0?ofkP0303eIZ`3om^h0ooK^00l0
ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00/0
ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0?EV[00<0
ooK^00<0?EV[0?ofkP0mFJ/0I`3om^h2000006X0ooK^0@3oool002X0ooK^00<000000?ofkP3om^h0
103om^h00`000000ooK^0?ofkP1M0?ofkP80?EV[203om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP<0?EV[
3`3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h0
1@3om^h;03eIZ`X0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0403eI
Z`3om^h0ooK^03eIZ`80ooK^00<0?EV[0?ofkP0mFJ/0I`3om^h2000006X0ooK^0@3oool002X0ooK^
00<000000?ofkP3om^h01@3om^h00`000000ooK^0?ofkP1K0?ofkP0303eIZ`3om^h0ooK^00T0ooK^
00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^0100ooK^
00<0?EV[0?ofkP3om^h0303om^h:03eIZ`L0ooK^00@0?EV[0?ofkP3om^h0ooK^200mFJ/30?ofkP03
03eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h01P3om^h0100mFJ/0ooK^0?ofkP0mFJ/20?of
kP0403eIZ`3om^h0?EV[03eIZfH0ooK^0P00001Z0?ofkP40oooo000Z0?ofkP030000003om^h0ooK^
00D0ooK^00<000000?ofkP3om^h0FP3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^
00h0ooK^0P0mFJ/B0?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h01`3om^h503eI
Z`80ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP080?ofkPD0?EV[2P3om^h00`0m
FJ/0ooK^0?ofkP070?ofkP0403eIZ`3om^h0ooK^03eIZ`80ooK^00<0?EV[0?ofkP0mFJ/0IP3om^h2
000006X0ooK^0@3oool002X0ooK^00<000000?ofkP3om^h01P3om^h00`000000ooK^0?ofkP1H0?of
kP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h02`3om^h203eIZ`80ooK^00<0?EV[0?of
kP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0303eIZ`3om^h0ooK^00H0?EV[203om^h00`0m
FJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP0mFJ/00`0mFJ/70?of
kP0303eIZ`3om^h0ooK^00H0ooK^00T0?EV[0?ofkP3om^h0ooK^03eIZ`3om^h0?EV[0?ofkP0mFJ/0
IP3om^h2000006X0ooK^0@3oool002T0ooK^00<000000?ofkP3om^h0203om^h00`000000ooK^0?of
kP1F0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?of
kP020?ofkP0303eIZ`3om^h0ooK^0100ooK^00<0?EV[0?ofkP3om^h03P3om^h403eIZ`h0ooK^00<0
?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^0080ooK^0`0m
FJ/40?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h00P3om^h203eIZ`030?ofkP0m
FJ/0?EV[06D0ooK^00<000000?ofkP000000J@3om^h10?ooo`00:@3om^h00`000000ooK^0?ofkP08
0?ofkP030000003om^h0ooK^05D0ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP08
0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP0;
0?ofkP<0?EV[00<0ooK^03eIZ`3om^h0403om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0
ooK^00/0ooK^00<0?EV[0?ofkP3om^h01@3om^h403eIZ`030?ofkP0mFJ/0ooK^00L0ooK^00<0?EV[
0?ofkP3om^h00P3om^h403eIZfH0ooK^0P00001Y0?ofkP40oooo000Y0?ofkP030000003om^h0ooK^
00T0ooK^00<000000?ofkP3om^h0D`3om^h00`0mFJ/0ooK^03eIZ`0@0?ofkP0303eIZ`3om^h0ooK^
00H0ooK^0P0mFJ/70?ofkP0303eIZ`3om^h0ooK^0100ooK^00<0?EV[0?ofkP3om^h01`3om^h303eI
Z`D0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^
00/0ooK^00<0?EV[0?ofkP3om^h02@3om^h203eIZ`P0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0m
FJ/0ooK^03eIZ`1V0?ofkP800000J@3om^h10?ooo`00:@3om^h00`000000ooK^0?ofkP0:0?ofkP03
0000003om^h0ooK^0580ooK^00<0?EV[0?ofkP0mFJ/04@3om^h00`0mFJ/0ooK^0?ofkP040?ofkP03
03eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP030?ofkP@0
?EV[203om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3o
m^h02`3om^h00`0mFJ/0ooK^0?ofkP090?ofkP<0?EV[1P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP@0
?EV[I@3om^h2000006T0ooK^0@3oool002P0ooK^00<000000?ofkP3om^h02`3om^h00`000000ooK^
0?ofkP1A0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/0403om^h00`0mFJ/0ooK^0?ofkP030?ofkP03
03eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h0403om^h00`0mFJ/0ooK^03eIZ`0203eIZ`d0
ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00/0
ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^03eIZ`060?ofkP0303eIZ`3om^h0ooK^00<0
ooK^0`0mFJ]U0?ofkP800000J@3om^h10?ooo`00:03om^h00`000000ooK^0?ofkP0<0?ofkP030000
003om^h0ooK^04l0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eI
Z`3om^h0ooK^0080?EV[3@3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP80?EV[403om^h00`0mFJ/0ooK^
0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^
0?ofkP090?ofkP0303eIZ`3om^h0ooK^0080?EV[103om^h00`0mFJ/0ooK^0?ofkP030?ofkP<0?EV[
I@3om^h2000006T0ooK^0@3oool002P0ooK^00<000000?ofkP3om^h03@3om^h00`000000ooK^0?of
kP1>0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^03eI
Z`0?0?ofkP0303eIZ`3om^h0ooK^00d0ooK^0`0mFJ/A0?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0
?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0
?EV[0?ofkP3om^h00P3om^h203eIZ`80ooK^00<0?EV[0?ofkP3om^h00`3om^h403eIZf@0ooK^00<0
00000?ofkP000000J03om^h10?ooo`00:03om^h00`000000ooK^0?ofkP0=0?ofkP030000003om^h0
ooK^04d0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0
ooK^00l0ooK^00<0?EV[0?ofkP3om^h02P3om^h203eIZ`<0ooK^00<0?EV[0?ofkP3om^h03`3om^h0
0`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h02`3om^h0
0`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP0mFJ/01P3om^h3
03eIZfD0ooK^0P00001X0?ofkP40oooo000X0?ofkP030000003om^h0ooK^00h0ooK^00<000000?of
kP3om^h0B`3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00d0ooK^0P0mFJ/A0?of
kP0303eIZ`3om^h0ooK^00P0ooK^0P0mFJ/50?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?of
kP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?of
kP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP040?ofkP<0?EV[1@3om^h303eIZfD0ooK^0P00001X0?of
kP40oooo000W0?ofkP030000003om^h0ooK^00l0ooK^00<000000?ofkP3om^h0BP3om^h00`0mFJ/0
ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00`0ooK^00@0?EV[0?ofkP3om^h0?EV[4@3om^h00`0m
FJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0m
FJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0m
FJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h00`3om^h403eI
Zf@0ooK^0P00001X0?ofkP40oooo000W0?ofkP030000003om^h0ooK^0100ooK^00<000000?ofkP3o
m^h0B@3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00X0ooK^00D0?EV[0?ofkP3o
m^h0ooK^03eIZ`0A0?ofkP0303eIZ`3om^h0ooK^00@0ooK^0P0mFJ/90?ofkP0303eIZ`3om^h0ooK^
00l0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^
00/0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP060?ofkP80?EV[103om^h403eI
Zf@0ooK^0P00001X0?ofkP40oooo000W0?ofkP030000003om^h0ooK^0140ooK^00<000000?ofkP3o
m^h0A`3om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3o
m^h00`3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0403eIZ`3om^h0ooK^0?ofkP80?EV[303om^h00`0m
FJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0m
FJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h01P3om^h203eI
Z`@0ooK^0`0mFJ]T0?ofkP800000J03om^h10?ooo`009`3om^h00`000000ooK^0?ofkP0A0?ofkP03
0000003om^h0ooK^04H0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP070?ofkP03
03eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h03`3om^h0100mFJ/0ooK^03eIZ`0mFJ/>0?of
kP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h0303om^hE03eIZ`X0ooK^00<0?EV[0?of
kP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0?EV[0080ooK^1@0mFJ]S0?of
kP030000003om^h0000006L0ooK^0@3oool002H0ooK^00<000000?ofkP3om^h04`3om^h00`000000
ooK^0?ofkP150?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h01@3om^h203eIZ`P0
ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00l0
ooK^00<0?EV[0?ofkP3om^h01`3om^h503eIZ`80ooK^00<0?EV[0?ofkP3om^h0303om^h0100mFJ/0
ooK^0?ofkP3om^h803eIZ`<0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP060?of
kP0503eIZ`3om^h0ooK^03eIZ`3om^h00`0mFJ/00`3om^h0?EV[0?ofkP1R0?ofkP030000003om^h0
000006L0ooK^0@3oool002H0ooK^00<000000?ofkP3om^h0503om^h00`000000ooK^0?ofkP130?of
kP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP080?of
kP0303eIZ`3om^h0ooK^00d0ooK^0`0mFJ/A0?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?of
kP3om^h01P0mFJ/80?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h0203om^h503eI
Z`X0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP0203eIZ`040?ofkP0mFJ/0?EV[
03eIZf@0ooK^0P00001W0?ofkP40oooo000V0?ofkP030000003om^h0ooK^01@0ooK^00<000000?of
kP3om^h0@P3om^h00`0mFJ/0ooK^03eIZ`0>0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?of
kP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/0403om^h0
0`0mFJ/0ooK^0?ofkP0>0?ofkP@0?EV[3P3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0
ooK^00/0ooK^00<0?EV[0?ofkP0mFJ/00P0mFJ/70?ofkP0303eIZ`3om^h0ooK^00H0ooK^00H0?EV[
0?ofkP3om^h0ooK^03eIZ`3om^h403eIZf<0ooK^0P00001W0?ofkP40oooo000V0?ofkP030000003o
m^h0ooK^01D0ooK^00<000000?ofkP3om^h0@@3om^h00`0mFJ/0ooK^03eIZ`0?0?ofkP0403eIZ`3o
m^h0ooK^03eIZ`d0ooK^00<0?EV[0?ofkP3om^h02@3om^h203eIZ`@0ooK^00<0?EV[0?ofkP3om^h0
3`3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP80?EV[00<0ooK^03eIZ`3om^h0403om^h00`0mFJ/0ooK^
0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00@0?EV[0?ofkP3om^h0ooK^100mFJ/30?ofkP03
03eIZ`3om^h0ooK^00H0ooK^00@0?EV[0?ofkP3om^h0ooK^1P0mFJ]S0?ofkP800000I`3om^h10?oo
o`009P3om^h00`000000ooK^0?ofkP0F0?ofkP030000003om^h0ooK^03l0ooK^00D0?EV[0?ofkP3o
m^h0ooK^03eIZ`0>0?ofkP0303eIZ`3om^h0?EV[00l0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0m
FJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h0203om^h303eI
Z`@0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^
00/0ooK^00<0?EV[0?ofkP3om^h01@3om^h303eIZ`030?ofkP0mFJ/0ooK^00H0ooK^00H0?EV[0?of
kP3om^h0ooK^03eIZ`3om^h403eIZf<0ooK^0P00001W0?ofkP40oooo000U0?ofkP030000003om^h0
ooK^01L0ooK^00<000000?ofkP3om^h0?`3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00l0ooK^00<0
?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP050?ofkP80?EV[203om^h00`0mFJ/0ooK^0?of
kP0?0?ofkP0303eIZ`3om^h0ooK^00D0ooK^0P0mFJ/70?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0
?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00P0ooK^0P0m
FJ/80?ofkP0403eIZ`3om^h0ooK^03eIZ`80ooK^0`0mFJ]S0?ofkP030000003om^h0000006H0ooK^
0@3oool002D0ooK^00<000000?ofkP3om^h0603om^h00`000000ooK^0?ofkP0m0?ofkP0303eIZ`3o
m^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^03eIZ`0@0?ofkP0303eIZ`3o
m^h0ooK^0080ooK^0P0mFJ/;0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h00P3o
m^h303eIZ`X0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3o
m^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h0203om^h303eIZ`H0ooK^00<0?EV[0?ofkP0mFJ/00`3o
m^h403eIZf80ooK^00<000000?ofkP000000IP3om^h10?ooo`009@3om^h00`000000ooK^0?ofkP0I
0?ofkP030000003om^h0ooK^03`0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP0:
0?ofkP0403eIZ`3om^h0ooK^03eIZa00ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0=0?ofkP0303eI
Z`3om^h0ooK^00l0ooK^00@0?EV[0?ofkP0mFJ/0?EV[3@3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP03
03eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP090?ofkP03
03eIZ`3om^h0?EV[00D0ooK^00<0?EV[0?ofkP0mFJ/0103om^h303eIZf<0ooK^0P00001V0?ofkP40
oooo000U0?ofkP030000003om^h0ooK^01T0ooK^00<000000?ofkP3om^h0>`3om^h00`0mFJ/0ooK^
0?ofkP050?ofkP0303eIZ`3om^h0ooK^00T0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0@0?ofkP<0
?EV[3`3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP80?EV[403om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP03
03eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP090?ofkP03
03eIZ`3om^h0ooK^0080?EV[103om^h203eIZ`@0ooK^0`0mFJ]S0?ofkP800000IP3om^h10?ooo`00
903om^h00`000000ooK^0?ofkP0K0?ofkP030000003om^h0ooK^03X0ooK^00<0?EV[0?ofkP3om^h0
1@3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h0
3P3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00`0ooK^0`0mFJ/A0?ofkP0303eI
Z`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eI
Z`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h00P3om^h203eIZ`80ooK^0P0mFJ/40?ofkP80?EV[
00<0ooK^03eIZ`3om^h0H@3om^h2000006H0ooK^0@3oool002@0ooK^00<000000?ofkP3om^h06`3o
m^h00`000000ooK^0?ofkP0i0?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h01P3o
m^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP0mFJ/04@3o
m^h00`0mFJ/0ooK^0?ofkP090?ofkP80?EV[0`3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3o
m^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3o
m^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h00`3om^h0100mFJ/0ooK^03eIZ`0mFJ/50?ofkP<0?EV[
HP3om^h2000006H0ooK^0@3oool002@0ooK^00<000000?ofkP3om^h0703om^h00`000000ooK^0?of
kP0h0?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?of
kP050?ofkP0303eIZ`3om^h0ooK^00/0ooK^00@0?EV[0?ofkP3om^h0?EV[4@3om^h00`0mFJ/0ooK^
0?ofkP070?ofkP80?EV[1@3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00h0ooK^
00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00T0ooK^
00<0?EV[0?ofkP3om^h0103om^h403eIZ`@0ooK^0`0mFJ]R0?ofkP800000IP3om^h10?ooo`00903o
m^h00`000000ooK^0?ofkP0M0?ofkP030000003om^h0ooK^03H0ooK^00<0?EV[0?ofkP3om^h02@3o
m^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h02@3o
m^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h0103o
m^h203eIZ`P0ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3o
m^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3o
m^h0ooK^00D0ooK^0`0mFJ/40?ofkP80?EV[00<0ooK^03eIZ`3om^h0E`3om^h30=@m6@H0ooK^00<0
00000?ofkP000000I@3om^h10?ooo`00903om^h00`000000ooK^0?ofkP0M0?ofkP030000003om^h0
ooK^03H0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0
ooK^00L0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0
ooK^00l0ooK^00<0?EV[0?ofkP3om^h00P3om^h203eIZ`X0ooK^00<0?EV[0?ofkP3om^h03`3om^h0
0`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h02P3om^h0
0`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00D0ooK^0`0mFJ/40?ofkP@0?EV[DP3om^h9
0=@m6@H0ooK^00<000000?ofkP000000I@3om^h10?ooo`008`3om^h00`000000ooK^0?ofkP0O0?of
kP030000003om^h0ooK^03@0ooK^00<0?EV[0?ofkP3om^h02`3om^h01@0mFJ/0ooK^0?ofkP3om^h0
?EV[00/0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0
ooK^00l0ooK^00@0?EV[0?ofkP0mFJ/0?EV[3@3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3o
m^h0ooK^00/0ooK^5@0mFJ/90?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h00`3o
m^h00`0mFJ/0ooK^0?ofkP0203eIZ`@0ooK^0`0mFJ]=0?ofkP/0e3dI00@0ooK^0=@m6@3D?AT0e3dI
1P3om^h2000006D0ooK^0@3oool002<0ooK^00<000000?ofkP3om^h0803om^h00`000000ooK^0?of
kP0c0?ofkP80?EV[3@3om^h00`0mFJ/0ooK^03eIZ`0<0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0
?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP80?EV[3`3om^h00`0mFJ/0ooK^0?of
kP0?0?ofkP0303eIZ`3om^h0ooK^00H0ooK^1@0mFJ/20?ofkP0303eIZ`3om^h0ooK^00`0ooK^00@0
?EV[0?ofkP3om^h0ooK^1`0mFJ/30?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h0
0`3om^h00`0mFJ/0ooK^0?ofkP0303eIZ`<0ooK^0`0mFJ]70?ofkP/0e3dI00<0ooK^0=@m6@3D?AT0
103D?AT00`3om^h0e3dI0=@m6@060?ofkP800000I@3om^h10?ooo`008`3om^h00`000000ooK^0?of
kP0P0?ofkP030000003om^h0ooK^03<0ooK^0P0mFJ/=0?ofkP0303eIZ`3om^h0?EV[00d0ooK^00<0
?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00`0ooK^0`0m
FJ/A0?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h01@0mFJ/80?ofkP0303eIZ`3o
m^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h01`3om^h503eIZ`T0ooK^00<0?EV[0?ofkP3om^h00P3o
m^h0100mFJ/0ooK^0?ofkP3om^h203eIZ`040?ofkP0mFJ/0ooK^0?ofkP@0?EV[@@3om^h:0=@m6@80
ooK^1@3D?AT80?ofkP030=@m6@3om^h0ooK^00@0ooK^0P00001U0?ofkP40oooo000S0?ofkP030000
003om^h0ooK^0240ooK^00<000000?ofkP3om^h0<@3om^h0100mFJ/0ooK^0?ofkP0mFJ/=0?ofkP03
03eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP090?ofkP03
03eIZ`3om^h0ooK^00/0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0@0?ofkP0303eIZ`3om^h0ooK^
00h0ooK^100mFJ/=0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h02P3om^h0100m
FJ/0ooK^03eIZ`0mFJ/80?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/0103om^h203eIZ`030?ofkP0m
FJ/0ooK^0080?EV[00<0ooK^03eIZ`3om^h0>P3om^h:0=@m6@80ooK^1P3D?AT=0?ofkP80e3dI1@3o
m^h2000006D0ooK^0@3oool00280ooK^00<000000?ofkP3om^h08`3om^h00`000000ooK^0?ofkP0`
0?ofkP0403eIZ`3om^h0ooK^03eIZ``0ooK^00<0?EV[0?ofkP0mFJ/03P3om^h0100mFJ/0ooK^0?of
kP0mFJ/=0?ofkP0303eIZ`3om^h0ooK^00P0ooK^0P0mFJ/40?ofkP0303eIZ`3om^h0ooK^00l0ooK^
00<0?EV[0?ofkP3om^h02P3om^h303eIZ`030?ofkP0mFJ/0ooK^00l0ooK^00<0?EV[0?ofkP3om^h0
2`3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00<0?EV[1@3om^h01@0mFJ/0ooK^
0?ofkP3om^h0?EV[00@0ooK^0P0mFJ/20?ofkPD0?EV[=@3om^h;0=@m6@80ooK^1@3D?ATA0?ofkP@0
e3dI1@3om^h00`000000ooK^0000001T0?ofkP40oooo000R0?ofkP030000003om^h0ooK^02<0ooK^
00<000000?ofkP3om^h0<03om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00/0ooK^00<0?EV[0?ofkP0m
FJ/03P3om^h00`0mFJ/0ooK^03eIZ`0>0?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3o
m^h01@3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00L0ooK^0`0mFJ/50?ofkP03
03eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP03
03eIZ`3om^h0ooK^00<0ooK^0`0mFJ/20?ofkP0403eIZ`3om^h0ooK^03eIZ`D0ooK^00@0?EV[0?of
kP0mFJ/0ooK^1P0mFJ/^0?ofkP/0e3dI0P3om^h70=@m6@030?ofkP3D?AT0ooK^00`0ooK^1P3D?AT0
103om^h0e3dI0=@m6@3D?AT50?ofkP030000003om^h0000006@0ooK^0@3oool00280ooK^00<00000
0?ofkP3om^h0903om^h00`000000ooK^0?ofkP0_0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/02P3o
m^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00h0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^
0?ofkP050?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^
0?ofkP030?ofkP<0?EV[203om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00`0ooK^
00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP060?ofkP80?EV[00@0ooK^03eIZ`3om^h0
?EV[1@3om^h01P0mFJ/0ooK^03eIZ`3om^h0?EV[0?ofkP@0?EV[:@3om^h:0=@m6@<0ooK^1@3D?AT6
0?ofkP030=@m6@3om^h0e3dI00L0ooK^1P3D?AT00`3om^h0e3dI0=@m6@040=@m6@030?ofkP3D?AT0
e3dI00D0ooK^00<000000?ofkP000000I03om^h10?ooo`008P3om^h00`000000ooK^0?ofkP0T0?of
kP030000003om^h0ooK^02h0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP070?of
kP0503eIZ`3om^h0ooK^0?ofkP0mFJ/03@3om^h00`0mFJ/0ooK^03eIZ`0?0?ofkP0303eIZ`3om^h0
ooK^00<0ooK^0P0mFJ/:0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h00`0mFJ/<
0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP0;
0?ofkP0303eIZ`3om^h0ooK^00L0ooK^0P0mFJ/00`3om^h0?EV[0?ofkP050?ofkP80?EV[00@0ooK^
03eIZ`3om^h0ooK^0`0mFJ/S0?ofkPX0e3dI0`3om^h60=@m6@/0ooK^00<0e3dI0?ofkP3om^h01`3D
?AT20?ofkPD0e3dI1`3om^h20=@m6@H0ooK^0P00001T0?ofkP40oooo000R0?ofkP030000003om^h0
ooK^02D0ooK^00<000000?ofkP3om^h0;@3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0
ooK^00H0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP090?ofkP0403eIZ`3om^h0
ooK^03eIZa00ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0<0?ofkP0303eIZ`3om^h0ooK^00l0ooK^
0P0mFJ/?0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^
0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00P0ooK^0`0mFJ/60?ofkP0403eIZ`3om^h0?EV[03eIZ`80
ooK^100mFJ/M0?ofkPX0e3dI0P3om^h60=@m6@l0ooK^1P3D?AT20?ofkPH0e3dI303om^h20=@m6@H0
ooK^0P00001T0?ofkP40oooo000Q0?ofkP030000003om^h0ooK^02L0ooK^00<000000?ofkP3om^h0
;03om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h0
0`3om^h00`0mFJ/0ooK^0?ofkP090?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/03`3om^h0100mFJ/0
ooK^03eIZ`0mFJ/>0?ofkP0303eIZ`3om^h0ooK^00`0ooK^0`0mFJ/@0?ofkP0303eIZ`3om^h0ooK^
00h0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^
00T0ooK^00<0?EV[0?ofkP0mFJ/01@3om^h0100mFJ/0ooK^03eIZ`0mFJ/30?ofkP<0?EV[5`3om^h:
0=@m6@<0ooK^1P3D?AT20?ofkP030=@m6@3om^h0ooK^00T0ooK^1P3D?AT20?ofkPH0e3dI4`3om^h0
0`3D?AT0ooK^0?ofkP040?ofkP800000I03om^h10?ooo`008@3om^h00`000000ooK^0?ofkP0W0?of
kP030000003om^h0ooK^02`0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP030?of
kP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP020?of
kP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0:0?of
kP80?EV[0`3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?of
kP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00L0ooK^0P0mFJ/20?of
kP80?EV[103om^h303eIZ`<0ooK^0`0mFJ/B0?ofkPX0e3dI0`3om^h50=@m6@D0ooK^00D0e3dI0?of
kP3om^h0ooK^0=@m6@040?ofkPH0e3dI103om^h50=@m6@80ooK^00<0e3dI0?ofkP3om^h04`3om^h2
0=@m6@D0ooK^00<000000?ofkP000000H`3om^h10?ooo`008@3om^h00`000000ooK^0?ofkP0X0?of
kP030000003om^h0ooK^02X0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP030?of
kP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP040?of
kP0303eIZ`3om^h0ooK^00`0ooK^0P0mFJ/A0?ofkP0303eIZ`3om^h0ooK^00L0ooK^0P0mFJ/50?of
kP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0<0?of
kP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h01`3om^h303eIZ`<0ooK^0P0mFJ/20?of
kP0303eIZ`3om^h0?EV[00<0ooK^0`0mFJ/=0?ofkPT0e3dI0`3om^h60=@m6@X0ooK^00<0e3dI0?of
kP3om^h01P3D?AT40?ofkPH0e3dI103om^h0103D?AT0ooK^0?ofkP3D?ATE0?ofkP80e3dI1@3om^h0
0`000000ooK^0000001S0?ofkP40oooo000Q0?ofkP030000003om^h0ooK^02T0ooK^00<000000?of
kP3om^h0:@3om^h00`0mFJ/0ooK^0?ofkP070?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/02@3om^h0
0`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h02`3om^h0
100mFJ/0ooK^0?ofkP0mFJ/@0?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h01P3o
m^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h02`3o
m^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00@0?EV[0?ofkP3om^h0?EV[
1@3om^h01@0mFJ/0ooK^03eIZ`3om^h0?EV[00@0ooK^00<0?EV[0?ofkP0mFJ/01P3om^h:0=@m6@80
ooK^1P3D?AT>0?ofkPD0e3dI0P3om^h00`3D?AT0ooK^0?ofkP050=@m6@X0ooK^00D0e3dI0?ofkP3o
m^h0ooK^0=@m6@0D0?ofkP80e3dI1@3om^h00`000000ooK^0000001S0?ofkP40oooo000P0?ofkP03
0000003om^h0ooK^02X0ooK^00<000000?ofkP3om^h0:@3om^h00`0mFJ/0ooK^0?ofkP070?ofkP05
03eIZ`3om^h0ooK^0?ofkP0mFJ/02@3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^
00H0ooK^00<0?EV[0?ofkP3om^h02@3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[0140ooK^00<0?EV[
0?ofkP3om^h00`3om^h203eIZ`T0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0=
0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP04
0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/01P3om^h403eIZ`@0ooK^0`0mFJ/00`3om^h0e3dI0=@m
6@070=@m6@030?ofkP3D?AT0e3dI00H0e3dI0`3om^h00`3D?AT0ooK^0?ofkP090?ofkP@0e3dI0P3o
m^h00`3D?AT0ooK^0=@m6@050=@m6A00ooK^00@0e3dI0?ofkP3om^h0e3dI4P3om^h40=@m6@H0ooK^
0P00001S0?ofkP40oooo000P0?ofkP030000003om^h0ooK^02/0ooK^00<000000?ofkP3om^h0:03o
m^h203eIZ`T0ooK^00<0?EV[0?ofkP0mFJ/02`3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3o
m^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3o
m^h0ooK^00h0ooK^00@0?EV[0?ofkP3om^h0ooK^0P0mFJ/;0?ofkP0303eIZ`3om^h0ooK^00h0ooK^
00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00X0ooK^
00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00D0ooK^
00<0?EV[0?ofkP0mFJ/00P3om^h0103D?AT0?EV[03eIZ`0mFJ/;0=@m6@H0ooK^00<0e3dI0?ofkP3o
m^h00P3om^h00`3D?AT0ooK^0?ofkP040?ofkPD0e3dI00<0ooK^0=@m6@3D?AT01@3D?AT30?ofkP03
0=@m6@3om^h0ooK^0100ooK^00@0e3dI0?ofkP3om^h0e3dI303om^h70=@m6@030?ofkP3D?AT0e3dI
00H0ooK^0P00001S0?ofkP40oooo000P0?ofkP030000003om^h0ooK^02`0ooK^00<000000?ofkP3o
m^h09`3om^h203eIZ`T0ooK^00<0?EV[0?ofkP0mFJ/02`3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[
00/0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^
00l0ooK^0`0mFJ/>0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h02`3om^hD03eI
Z`X0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`0000000000
00D000000`0mFJ/40=@m6@<0?EV[0`3D?AT=0?ofkP030=@m6@3om^h0ooK^00<0ooK^303D?AT50?of
kP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h03`3om^h0103D?AT0ooK^0?ofkP3D?AT6
0?ofkPP0e3dI1P3om^h20=@m6@H0ooK^0P00001S0?ofkP40oooo000P0?ofkP030000003om^h0ooK^
02`0ooK^00<000000?ofkP3om^h09`3om^h00`0mFJ/0ooK^03eIZ`090?ofkP0303eIZ`3om^h0ooK^
00/0ooK^00<0?EV[0?ofkP0mFJ/0303om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^
00H0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^
00h0ooK^00<0?EV[0?ofkP3om^h01P3om^h503eIZ`80ooK^00<0?EV[0?ofkP3om^h02`3om^h0100m
FJ/0ooK^0?ofkP3om^h703eIZ`<0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`060000000403eIZ`0J
1`<06PL301X70`@000000`0mFJ/40=@m6@<0?EV[00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^
0?ofkP080=@m6@`0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP040=@m
6@3om^h0ooK^0?ofkPP0e3dI303om^h00`3D?AT0ooK^0=@m6@050?ofkP030000003om^h000000680
ooK^0@3oool00200ooK^00<000000?ofkP3om^h0;@3om^h00`000000ooK^0?ofkP0V0?ofkP0303eI
Z`3om^h0?EV[00T0ooK^0P0mFJ/<0?ofkP0303eIZ`3om^h0?EV[00d0ooK^00<0?EV[0?ofkP3om^h0
0`3om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00`0ooK^0`0mFJ/A0?ofkP0303eI
Z`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h01@0mFJ/80?ofkP0303eIZ`3om^h0ooK^00/0ooK^
00<0?EV[0?ofkP3om^h01`3om^h403eIZ`<0000000@0?EV[01X70`0J1`<06PL3100000000`0mFJ/0
e3dI0000000303D<1@0303eIZ`0e30D0=@`50080?EV[00<0=@`50=@m6@0000000`0mFJ/00`3D?AT0
ooK^0?ofkP0;0?ofkPL0e3dI0P3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00<0
ooK^00<0e3dI0?ofkP3om^h03@3om^h90=@m6A40ooK^00<0e3dI0?ofkP3D?AT01@3om^h00`000000
ooK^0000001R0?ofkP40oooo000O0?ofkP030000003om^h0ooK^02l0ooK^00<000000?ofkP3om^h0
9@3om^h0100mFJ/0ooK^0?ofkP0mFJ/80?ofkP80?EV[3@3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP03
03eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP05
03eIZ`3om^h0ooK^0?ofkP0mFJ/0403om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP@0?EV[3@3om^h00`0m
FJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00H0ooK^1`0000000`0mFJ/00000000000020000
0080=@`500<0e3dI03D<1@0mFJ/00P00000303D<1@0503eIZ`0e30D0=@`503D<1@0mFJ/00`000004
03eIZ`030=@m6@3om^h0ooK^00@0ooK^2@3D?AT60?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI
0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP070?ofkPT0e3dI0`3om^h00`3D?AT0ooK^0?ofkP0A
0?ofkP030=@m6@3om^h0e3dI00D0ooK^00<000000?ofkP000000HP3om^h10?ooo`007`3om^h00`00
0000ooK^0?ofkP0_0?ofkP030000003om^h0ooK^02D0ooK^00@0?EV[0?ofkP3om^h0?EV[1`3om^h0
100mFJ/0ooK^0?ofkP0mFJ/<0?ofkP80?EV[3P3om^h0100mFJ/0ooK^0?ofkP0mFJ/<0?ofkP0303eI
Z`3om^h0ooK^00P0ooK^0P0mFJ/40?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h0
2P3om^h303eIZ`030?ofkP0mFJ/0ooK^00h0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^
000000050000000301X70`0000000000008000000P0e30D00`0mFJ/0000003D<1@0603D<1@0303eI
Z`0e30D0000000<0000000D0?EV[000000000000000003eIZ`0304hB1`80?EV[00<0ooK^03eIZ`3D
?AT0203D?AT60?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0
ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00P0e3dI1P3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI
01@0ooK^0P3D?AT50?ofkP030000003om^h000000680ooK^0@3oool001l0ooK^00<000000?ofkP3o
m^h0<03om^h00`000000ooK^0?ofkP0T0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/01P3om^h0100m
FJ/0ooK^0?ofkP0mFJ/;0?ofkP0303eIZ`3om^h0?EV[00h0ooK^00<0?EV[0?ofkP0mFJ/03P3om^h0
0`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h03P3om^h0
0`0mFJ/0ooK^0?ofkP060?ofkP<0?EV[1@3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0
ooK^00T0ooK^0`00000301X70`D000001@0e30D0100mFJ/0=@`503D<1@00000303D<1@@0000000D0
?EV[04hB1`1>4PL0CQ8703eIZ`0404hB1`0603eIZ`1>4PL0CQ8704hB1`0mFJ/0CQ870P0mFJ/40=@m
6@/0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP040=@m6@3om^h0ooK^
0?ofkPL0e3dI3@3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^0140ooK^0P3D?AT6
0?ofkP800000HP3om^h10?ooo`007`3om^h00`000000ooK^0?ofkP0`0?ofkP030000003om^h0ooK^
02@0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`060?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/02P3o
m^h0100mFJ/0ooK^0?ofkP0mFJ/>0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h0
1@3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h0
0`3om^h303eIZ`P0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP040?ofkPD00000
0P0J1`<4000000040=@m6@0e30D0=@`5000000D0=@`500<0?EV[03D<1@0e30D01@00000404hB1`05
03eIZ`1>4PL0CQ8704hB1`0mFJ/01@1>4PL01@0mFJ/0CQ8704hB1`0mFJ/0CQ8700<0?EV[00<0e3dI
0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00X0ooK^1`3D?AT2
0?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP0A
0?ofkP030=@m6@3om^h0e3dI00D0ooK^0P00001R0?ofkP40oooo000N0?ofkP030000003om^h0ooK^
0380ooK^00<000000?ofkP3om^h08`3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^
00<0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0503eIZ`3om^h0ooK^
0?ofkP0mFJ/03@3om^h203eIZa00ooK^00<0?EV[0?ofkP3om^h00P3om^h203eIZ`X0ooK^00<0?EV[
0?ofkP3om^h03P3om^h00`0mFJ/0ooK^03eIZ`0203eIZ`/0ooK^00<0?EV[0?ofkP3om^h0303om^h7
0000000301X70`000000000000D000001`0e30D010000000=@`503D<1@0e30D20000000303eIZ`00
000000000080CQ8700<0000004hB1`1>4PL0101>4PL01P0mFJ/0CQ8704hB1`1>4PL0?EV[000000@0
CQ8700<0?EV[04hB1`0mFJ/00P1>4PL303eIZ`030?ofkP3D?AT0ooK^00/0ooK^00<0e3dI0?ofkP3o
m^h01@3om^h00`3D?AT0ooK^0?ofkP040?ofkPT0e3dI1P3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP03
0=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h04@3om^h00`3D?AT0ooK^0=@m6@050?ofkP03
0000003om^h000000640ooK^0@3oool001h0ooK^00<000000?ofkP3om^h0<`3om^h00`000000ooK^
0?ofkP0R0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`050?ofkP03
03eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP090?ofkP04
03eIZ`3om^h0ooK^03eIZ`l0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0<0?ofkP0303eIZ`3om^h0
ooK^00h0ooK^0P0mFJ/?0?ofkP0303eIZ`3om^h0ooK^00D0ooK^1P0000000`0J1`<0000000000005
00000080=@`500<0e3dI03D<1@000000200e30D50000000304hB1`0mFJ/0CQ8700D0CQ8700<00000
04hB1`1>4PL0101>4PL01@0mFJ/0CQ8703eIZ`1>4PL0000000<0CQ8700@0000003eIZ`000000?EV[
0P0000001@0mFJ/0Lad<03eIZ`3om^h0e3dI00`0ooK^00<0e3dI0?ofkP3om^h01P3om^h80=@m6@H0
ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP050=@m6@3om^h0ooK^0?of
kP3D?AT04`3om^h30=@m6@D0ooK^00<000000?ofkP000000H@3om^h10?ooo`007P3om^h00`000000
ooK^0?ofkP0c0?ofkP030000003om^h0ooK^0280ooK^00<0?EV[0?ofkP3om^h00`3om^h01@0mFJ/0
ooK^0?ofkP3om^h0?EV[00H0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP030?of
kP0303eIZ`3om^h0ooK^00T0ooK^00@0?EV[0?ofkP3om^h0?EV[403om^h303eIZ`h0ooK^00<0?EV[
0?ofkP3om^h02`3om^h303eIZa00ooK^00@0?EV[0?ofkP3om^h0ooK^0P00000201X70`030000000J
1`<06PL300@000000P0e30D00`000000=@`503D<1@0703D<1@030000000e30D0=@`500D000000P1>
4PL00`000000CQ8704hB1`0203eIZ`H0CQ8700<0000004hB1`1>4PL0101>4PL00`0mFJ/0CQ8703eI
Z`0500000080Lad<0P0mFJ/307<M3080?EV[00<000000=@m6@3om^h02`3om^h00`3D?AT0ooK^0?of
kP090=@m6@/0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP050=@m6@3o
m^h0ooK^0?ofkP3D?AT03P3om^h60=@m6@030?ofkP3D?AT0ooK^00@0ooK^00<000000?ofkP000000
H@3om^h10?ooo`007P3om^h00`000000ooK^0?ofkP0d0?ofkP030000003om^h0ooK^0240ooK^00<0
?EV[0?ofkP3om^h0103om^h0100mFJ/0ooK^0?ofkP0mFJ/60?ofkP0303eIZ`3om^h0ooK^00@0ooK^
00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^0080ooK^
00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00T0ooK^
0P0mFJ/30?ofkP0303eIZ`3om^h0ooK^00`0ooK^1000000201X70`H000001P0e30D00`000000=@`5
03D<1@0503D<1@D00000201>4PL01@000000?EV[04hB1`1>4PL0?EV[00H0CQ8700<0000004hB1`1>
4PL00`0000000`0mFJ/0000003eIZ`0207<M30030000001c7@`0Lad<0080Lad<0P0mFJ/307<M30<0
?EV[00<0ooK^0=@m6@3om^h01`3om^h:0=@m6@80ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0
ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0
ooK^0?ofkP050?ofkPT0e3dI0P3om^h00`3D?AT0ooK^0=@m6@050?ofkP030000003om^h000000640
ooK^0@3oool001h0ooK^00<000000?ofkP3om^h0=@3om^h00`000000ooK^0?ofkP0P0?ofkP0303eI
Z`3om^h0ooK^00@0ooK^00@0?EV[0?ofkP3om^h0?EV[1`3om^h00`0mFJ/0ooK^0?ofkP020?ofkP03
03eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP03
03eIZ`3om^h0ooK^00`0ooK^0P0mFJ/A0?ofkP0303eIZ`3om^h0ooK^00H0ooK^0P0mFJ/50?ofkP03
03eIZ`3om^h0ooK^00@0ooK^3P00000303D<1@030000000e30D0=@`500H0=@`500<0000003D<1@0e
30D01@00000204hB1`030000001>4PL0CQ8700P0CQ8700D0?EV[04hB1`1>4PL0CQ8703eIZ`0404hB
1`D00000101c7@`00`0mFJ/0Lad<07<M300207<M30040000001c7@`0Lad<07<M3080?EV[0`1c7@`3
03eIZ`040000003D?AT0ooK^0?ofkP/0e3dI203om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3o
m^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3o
m^h0ooK^00P0e3dI203om^h00`3D?AT0ooK^0=@m6@060?ofkP800000H@3om^h10?ooo`007@3om^h0
0`000000ooK^0?ofkP0f0?ofkP030000003om^h0ooK^0200ooK^0P0mFJ/60?ofkP80?EV[2@3om^h0
1@0mFJ/0ooK^0?ofkP3om^h0?EV[00P0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?of
kP050?ofkP0303eIZ`3om^h0ooK^00X0ooK^00@0?EV[0?ofkP3om^h0?EV[403om^h00`0mFJ/0ooK^
0?ofkP040?ofkP80?EV[203om^h00`0mFJ/00000000000030000000301X70`000000000000@00000
00<0=@`50000000e30D01P0e30D00`000000=@`503D<1@0303D<1@L000001`1>4PL00`000000CQ87
04hB1`0704hB1`0303eIZ`1>4PL000000080CQ8700<0?EV[0000000000000P00000207<M30030000
001c7@`0Lad<00@0Lad<00<0?EV[07<M301c7@`00P1c7@`010000000Lad<07<M301c7@`203eIZ`@0
Lad<00<0?EV[07<M303D?AT00`3D?AT00`3om^h0e3dI0=@m6@030=@m6@<0ooK^00<0e3dI0?ofkP3o
m^h01`3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3o
m^h03P3om^h00`3D?AT0ooK^0=@m6@070=@m6@l0ooK^00<0e3dI0?ofkP3D?AT01@3om^h200000640
ooK^0@3oool001d0ooK^00<000000?ofkP3om^h0=`3om^h00`000000ooK^0?ofkP0O0?ofkP80?EV[
1P3om^h203eIZ`T0ooK^00@0?EV[0?ofkP3om^h0?EV[2@3om^h00`0mFJ/0ooK^0?ofkP040?ofkP03
03eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h02@3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[
0140ooK^00@0?EV[0?ofkP3om^h0ooK^0P0mFJ/70?ofkP80000000<06PL30000000000000P0J1`<5
000000D0=@`500<0000003D<1@0e30D00`0e30D8000000@0CQ8700<0000004hB1`1>4PL0201>4PL0
0`000000CQ8704hB1`0504hB1`0303eIZ`000000000000<0000000<0Lad<03eIZ`1c7@`01@1c7@`0
0`000000Lad<07<M300207<M3080?EV[1@1c7@`01@000000Lad<07<M301c7@`0?EV[00@0Lad<00@0
?EV[07<M301c7@`000000`3D?AT80?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h0
2`3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00P0ooK^2@3D?AT00`3om^h0e3dI
0?ofkP0B0?ofkP030=@m6@3om^h0e3dI00D0ooK^00<000000?ofkP000000H03om^h10?ooo`007@3o
m^h00`000000ooK^0?ofkP0h0?ofkP030000003om^h0ooK^01l0ooK^0P0mFJ/60?ofkP0303eIZ`3o
m^h0ooK^00P0ooK^00<0?EV[0?ofkP0mFJ/02P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3o
m^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3o
m^h0ooK^00h0ooK^00@0?EV[0?ofkP0mFJ/0?EV[103om^h4000000806PL31@0000000`3D?AT0=@`5
0000000703D<1@030000000e30D0=@`500@000000P1>4PL00`000000CQ8704hB1`0704hB1`030000
001>4PL0CQ8700P0CQ8700<0000004hB1`1>4PL0100000001@0mFJ/0000007<M301c7@`0000000<0
Lad<00<0?EV[07<M301c7@`0101c7@`00`000000Lad<07<M300207<M300303eIZ`1c7@`0?EV[00@0
Lad<00D0000007<M301c7@`0Lad<03eIZ`0407<M3080?EV[0P0000000`3D?AT0ooK^0?ofkP080?of
kP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP050?of
kP040=@m6@3om^h0ooK^0?ofkPX0e3dI0P3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0
ooK^0140ooK^00<0e3dI0?ofkP3D?AT00`3om^h3000000030?ofkP000000ooK^05l0ooK^0@3oool0
01d0ooK^00<000000?ofkP3om^h0>03om^h00`000000ooK^0?ofkP0O0?ofkP80?EV[1P3om^h203eI
Z`T0ooK^0P0mFJ/;0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/02P3om^h00`0mFJ/0ooK^0?ofkP06
0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h03P3om^h203eIZ`L0000000<06PL3
0000000000001000000403D<1@030000000e30D0=@`500@0=@`51@00000604hB1`030000001>4PL0
CQ8700L0CQ8700<0000004hB1`1>4PL01P1>4PL5000000<0Lad<00<0?EV[07<M301c7@`00P1c7@`0
1@000000Lad<07<M301c7@`0?EV[00H0Lad<00D0000007<M301c7@`0Lad<03eIZ`0207<M300303eI
Z`1c7@`0Lad<00<0Lad<00@0000007<M301c7@`0?EV[1@0000001@0mFJ/0T2H@0000003om^h0e3dI
00T0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^
00<0ooK^1P3D?AT00`3om^h0e3dI0=@m6@020=@m6@L0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D
?AT0ooK^0?ofkP0@0?ofkPH000000P3om^h00`000000ooK^0000001P0?ofkP40oooo000L0?ofkP03
0000003om^h0ooK^03X0ooK^00<000000?ofkP3om^h07P3om^h00`0mFJ/0ooK^03eIZ`050?ofkP80
?EV[2P3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0?EV[00`0ooK^00<0?EV[0?ofkP3o
m^h0103om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00/0ooK^100000000`0J1`<0
000000000005000000030=@m6@0e30D0000000L0=@`500<0000003D<1@0000001000000204hB1`03
0000001>4PL0CQ8700H0CQ8700<0000004hB1`1>4PL01`1>4PL00`000000CQ8704hB1`0600000080
Lad<00<0000007<M301c7@`00`1c7@`00`0mFJ/0Lad<07<M300207<M30030000001c7@`0Lad<0080
Lad<00<0?EV[07<M301c7@`00`1c7@`010000000Lad<07<M300mFJ/307<M300403eIZ`1c7@`0Lad<
07<M30@0000000<0?EV[090V400mFJ/0102@9Q001@0mFJ/0T2H@0000003om^h0e3dI00T0ooK^00<0
e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP0:0?ofkPH0e3dI0P3om^h50=@m6@/0ooK^00<0
e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP0:0?ofkPH0000000<0e3dI0?ofkP3D?AT01@3o
m^h00`000000ooK^0000001P0?ofkP40oooo000L0?ofkP030000003om^h0ooK^03/0ooK^00<00000
0?ofkP3om^h07@3om^h00`0mFJ/0ooK^03eIZ`050?ofkP0303eIZ`3om^h0?EV[00T0ooK^0P0mFJ/;
0?ofkP0303eIZ`3om^h0?EV[00`0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP07
0?ofkP0303eIZ`3om^h0ooK^00H0ooK^0`00000201X70`D0000000<0=@`50000000e30D01@0e30D0
0`000000=@`503D<1@0303D<1@D000001P1>4PL00`000000CQ8704hB1`0704hB1`030000001>4PL0
CQ8700D0CQ871@00000807<M30030000001c7@`0Lad<0080Lad<00<0?EV[07<M301c7@`0101c7@`0
1@000000Lad<07<M301c7@`0?EV[00H0Lad<00@0000007<M300mFJ/0Lad<0`0000000`0mFJ/00000
00000002090V40050000002@9Q00?EV[090V400mFJ/0102@9Q001@0mFJ/0T2H@090V40000000e3dI
00X0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP060?ofkPD0e3dI0P3om^h60=@m
6A00ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP040?ofkPH000001`3om^h20=@m
6@H0ooK^0P00001P0?ofkP40oooo000L0?ofkP030000003om^h0ooK^03/0ooK^00<000000?ofkP3o
m^h07P3om^h00`0mFJ/0ooK^03eIZ`040?ofkP0303eIZ`3om^h0?EV[00T0ooK^0P0mFJ/<0?ofkP03
03eIZ`3om^h0ooK^00`0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0;0?ofkP0303eIZ`0000000000
00@0000000<06PL30000000000001000000303D<1@8000001P0e30D00`000000=@`5000000040000
0080CQ8700<0000004hB1`1>4PL01P1>4PL00`000000CQ8704hB1`0704hB1`030000001>4PL0CQ87
00D000000P1c7@`00`000000Lad<07<M300807<M30050000001c7@`0Lad<07<M300mFJ/01`1c7@`0
1@000000Lad<07<M301c7@`0?EV[00@0Lad<0`0000000`0mFJ/0000000000003090V400303eIZ`2@
9Q00T2H@0080T2H@00D00000090V400mFJ/0T2H@03eIZ`04090V4080?EV[00@0T2H@0000003om^h0
e3dI2@3om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00D0e3dI0P3om^h50=@m6@H0
ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0000000@0
00003@3om^h00`3D?AT0ooK^0=@m6@050?ofkP800000H03om^h10?ooo`00703om^h00`000000ooK^
0?ofkP0l0?ofkP030000003om^h0ooK^01d0ooK^00<0?EV[0?ofkP0mFJ/0103om^h0100mFJ/0ooK^
0?ofkP0mFJ/70?ofkP0403eIZ`3om^h0ooK^03eIZ`/0ooK^0P0mFJ/=0?ofkP0403eIZ`3om^h0ooK^
03eIZ`L0ooK^300000020=@m6@8000001@0e30D010000000=@`503D<1@0e30D7000000H0CQ8700<0
000004hB1`1>4PL01`1>4PL00`000000CQ8704hB1`0504hB1`D000001`1c7@`00`000000Lad<07<M
300907<M30030000001c7@`0?EV[00P0Lad<00<0000007<M301c7@`00P000000100mFJ/000000000
00000002090V400303eIZ`2@9Q00T2H@00@0T2H@00<0?EV[090V402@9Q000P2@9Q000`000000?EV[
090V4002090V400403eIZ`2@9Q00T2H@090V4080?EV[00@0T2H@0000003om^h0e3dI2@3om^h00`3D
?AT0ooK^0?ofkP050?ofkPH0e3dI00<0ooK^0=@m6@3D?AT0103D?AT20?ofkP030=@m6@3om^h0ooK^
00H0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT000000000000400000180ooK^00<0e3dI0?of
kP3D?AT01@3om^h00`000000ooK^0000001O0?ofkP40oooo000L0?ofkP030000003om^h0ooK^03`0
ooK^00<000000?ofkP3om^h07@3om^h0100mFJ/0ooK^0?ofkP0mFJ/30?ofkP0503eIZ`3om^h0ooK^
0?ofkP0mFJ/01P3om^h0100mFJ/0ooK^0?ofkP0mFJ/:0?ofkP0303eIZ`3om^h0?EV[00h0ooK^0P0m
FJ/50?ofkP<0000000<06PL30000000000001@00000503D<1@030000000e30D0=@`50080=@`51`00
000304hB1`030000001>4PL0CQ8700L0CQ8700<0000004hB1`1>4PL01P1>4PL00`000000CQ8704hB
1`0600000080Lad<00<0000007<M301c7@`01`1c7@`00`000000Lad<07<M300907<M30030000000m
FJ/0Lad<00H0Lad<1@000002090V400303eIZ`2@9Q00T2H@00<0T2H@00<0?EV[090V402@9Q00102@
9Q000`0mFJ/0T2H@090V4002090V40030000000mFJ/0T2H@0080T2H@00@0?EV[090V402@9Q00T2H@
0P0mFJ/0102@9Q0000000?ofkP3D?AT90?ofkP030=@m6@3om^h0e3dI00D0e3dI00<0ooK^0=@m6@3D
?AT0103D?AT80?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h0203om^h6000000D0
ooK^00<0e3dI0?ofkP3om^h0403om^h30=@m6@D0ooK^00<000000?ofkP000000G`3om^h10?ooo`00
6`3om^h00`000000ooK^0?ofkP0n0?ofkP030000003om^h0ooK^01`0ooK^00D0?EV[0?ofkP3om^h0
ooK^03eIZ`020?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/01P3om^h01@0mFJ/0ooK^0?ofkP3om^h0
?EV[00T0ooK^00@0?EV[0?ofkP3om^h0?EV[3@3om^h00`0mFJ/0ooK^0?ofkP09000000<0=@`500<0
000003D<1@0e30D00`0e30D70000000304hB1`000000CQ8700L0CQ8700<0000004hB1`1>4PL01`1>
4PL00`000000CQ8704hB1`0404hB1`D00000201c7@`00`000000Lad<07<M300707<M30030000001c
7@`0Lad<00T0Lad<00<0?EV[07<M301c7@`01P000002090V40030000002@9Q00T2H@0080T2H@00<0
?EV[090V402@9Q000P2@9Q000`0mFJ/00000090V4006090V400603eIZ`2@9Q00T2H@090V400mFJ/0
00000`2@9Q002`0mFJ/0T2H@090V402@9Q00?EV[090V400mFJ/0T2H@0000003om^h0e3dI00<0ooK^
1`3D?AT00`3om^h0e3dI0=@m6@040=@m6@80ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^
0?ofkP060?ofkP030=@m6@3om^h0ooK^0080ooK^1P0000050?ofkP030=@m6@3om^h0ooK^00<0ooK^
00<0e3dI0?ofkP3om^h02`3om^h60=@m6@030?ofkP3D?AT0ooK^00@0ooK^00<000000?ofkP000000
G`3om^h10?ooo`006`3om^h00`000000ooK^0?ofkP0o0?ofkP030000003om^h0ooK^01`0ooK^00@0
?EV[0?ofkP3om^h0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00<0ooK^
00D0?EV[0?ofkP3om^h0ooK^03eIZ`080?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/0303om^h00`0m
FJ/0e3dI03eIZ`0300000080e3dI0P00000503D<1@040000000e30D0=@`503D<1@D000001P1>4PL0
0`000000CQ8704hB1`0504hB1`030000001>4PL0CQ8700L0CQ8700<0000004hB1`1>4PL01@000002
07<M30030000001c7@`0Lad<00P0Lad<00<0000007<M301c7@`01`1c7@`00`000000Lad<07<M3007
07<M30030000000mFJ/0000000800000202@9Q000`000000T2H@090V4003090V400603eIZ`2@9Q00
T2H@090V400mFJ/000001`2@9Q001P0mFJ/0T2H@090V402@9Q00?EV[000000<0T2H@00T0?EV[090V
402@9Q00T2H@03eIZ`2@9Q00?EV[090V400000001@3D?AT30?ofkPD0e3dI2@3om^h00`3D?AT0ooK^
0?ofkP090?ofkP030=@m6@3om^h0ooK^00D0ooK^1@00000;0?ofkP030=@m6@3om^h0ooK^00<0ooK^
00<0e3dI0?ofkP3om^h01P3om^h50=@m6@H0ooK^0P3D?AT50?ofkP030000003om^h0000005l0ooK^
0@3oool001/0ooK^00<000000?ofkP3om^h0?`3om^h00`000000ooK^0?ofkP0L0?ofkP0703eIZ`3o
m^h0ooK^0?ofkP0mFJ/0ooK^03eIZ`040?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3o
m^h00`3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3o
m^h00`3om^h60=@m6@0303eIZ`000000=@`500@0=@`500<0000003D<1@0e30D00`0e30D600000003
04hB1`000000CQ8700L0CQ8700<0000004hB1`1>4PL01P1>4PL00`000000CQ8704hB1`0204hB1`P0
00001`1c7@`00`000000Lad<07<M300707<M30030000001c7@`0Lad<00P0Lad<00@0000007<M301c
7@`0Lad<1@00000303eIZ`030000002@9Q00T2H@00P0T2H@00<00000090V402@9Q000`2@9Q00100m
FJ/0T2H@090V400mFJ/2090V40030000002@9Q00T2H@00@0T2H@00H0?EV[090V402@9Q00T2H@03eI
Z`000004090V400303eIZ`2@9Q00?EV[0080T2H@00@0000003eIZ`000000ooK^1`3D?AT20?ofkP03
0=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0000000500000003
0?ofkP3D?AT0ooK^00d0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP050=@m6@/0
ooK^00<0e3dI0?ofkP3D?AT01@3om^h2000005l0ooK^0@3oool001/0ooK^00<000000?ofkP3om^h0
@03om^h00`000000ooK^0?ofkP0L0?ofkP0603eIZ`3om^h0ooK^03eIZ`3om^h0?EV[1@3om^h01@0m
FJ/0ooK^0?ofkP3om^h0?EV[00D0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP02
0?ofkP030=@m6@0mFJ/0e3dI00@0e3dI0P3om^h20=@m6@030000000mFJ/0=@`500@0=@`50P000003
03D<1@D000001@1>4PL00`000000CQ8704hB1`0504hB1`030000001>4PL0CQ8700@0CQ8720000005
07<M30030000001c7@`0Lad<00L0Lad<00<0000007<M301c7@`01`1c7@`00`000000Lad<07<M3006
07<M30H00000102@9Q001@0mFJ/0T2H@090V402@9Q00?EV[00X0T2H@00<00000090V402@9Q000`2@
9Q000`0mFJ/0T2H@03eIZ`03090V40030000002@9Q00T2H@00D0T2H@00D0?EV[090V400mFJ/0T2H@
00000003090V40040000000mFJ/0000003eIZ`80000000<0YBdC0=@m6@0000000P3D?AT80?ofkP03
0=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h01@3om^h6000000L0ooK^00<0e3dI0?ofkP3o
m^h0303om^h0103D?AT0ooK^0?ofkP3om^h60=@m6@d0ooK^103D?AT00`3om^h0e3dI0?ofkP040?of
kP800000G`3om^h10?ooo`006P3om^h00`000000ooK^0?ofkP120?ofkP030000003om^h0ooK^01/0
ooK^00@0?EV[0?ofkP3om^h0ooK^0P0mFJ/60?ofkP0403eIZ`3om^h0ooK^03eIZ`H0ooK^00<0?EV[
0?ofkP3om^h00P3om^h00`3D?AT0?EV[0=@m6@030=@m6@80ooK^00<0?EV[0=@m6@3D?AT0103D?AT2
000000D0=@`51`0000000`1>4PL0000004hB1`0604hB1`030000001>4PL0CQ8700H0CQ8700<00000
04hB1`0000001000000207<M30030000001c7@`0Lad<00L0Lad<00<0000007<M301c7@`01`1c7@`0
0`000000Lad<07<M300807<M30030000001c7@`0Lad<00H000000P2@9Q000`000000T2H@090V4004
090V400303eIZ`2@9Q00T2H@0080T2H@00<0?EV[090V402@9Q00202@9Q000`000000T2H@090V4004
090V4080?EV[0`2@9Q000`000000T2H@090V4005090V400303eIZ`2@9Q00?EV[00D0000000@0YBdC
03eIZ`2U;A<0?EV[102U;A<2000000030?ofkP3D?AT0ooK^00H0ooK^00<0e3dI0?ofkP3om^h02@3o
m^h00`3D?AT0ooK^00000005000000@0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?of
kP090?ofkPL0e3dI0`3om^h00`3D?AT0ooK^0?ofkP070?ofkPH0e3dI0`3om^h00`3D?AT0ooK^0=@m
6@050?ofkP030000003om^h0000005h0ooK^0@3oool001X0ooK^00<000000?ofkP3om^h0@P3om^h0
0`000000ooK^0?ofkP0L0?ofkP0303eIZ`3om^h0ooK^0080?EV[1P3om^h0100mFJ/0ooK^0?ofkP0m
FJ/60?ofkP0303eIZ`3D?AT0e3dI0080e3dI00<0?EV[0=@m6@3D?AT01@3D?AT00`0mFJ/0e3dI0=@m
6@020?ofkP80000000<0=@`503eIZ`0000001P00000504hB1`030000001>4PL0CQ8700D0CQ8700<0
000004hB1`1>4PL0101>4PL5000000H0Lad<00<0000007<M301c7@`0201c7@`00`000000Lad<07<M
300707<M30030000001c7@`0Lad<00H0Lad<1@000008090V40030000002@9Q00T2H@0080T2H@0P0m
FJ/5090V40030000000mFJ/0T2H@00P0T2H@00<00000090V402@9Q00102@9Q000`0mFJ/0T2H@090V
4002090V40040000002@9Q00T2H@090V40@0000000D0?EV[0000000mFJ/0e3dI000000050:D]4`80
?EV[102U;A<3000000030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h01@3om^h6000000X0
ooK^00<0e3dI0?ofkP3om^h01`3om^h0103D?AT0ooK^0?ofkP3om^h70=@m6@@0ooK^00<0e3dI0?of
kP3om^h00`3om^h0103D?AT0ooK^0?ofkP3om^h60=@m6@T0ooK^00<0e3dI0?ofkP3D?AT01@3om^h0
0`000000ooK^0000001N0?ofkP40oooo000J0?ofkP030000003om^h0ooK^04<0ooK^00<000000?of
kP3om^h06`3om^h203eIZ`80ooK^00<0?EV[0?ofkP3om^h01@3om^h203eIZ`80ooK^1@3D?AT00`3o
m^h0?EV[0=@m6@020=@m6@0303eIZ`3D?AT0e3dI0080e3dI0`3om^h0103D?AT0?EV[0?ofkP3om^h5
000000<0CQ8700<0000004hB1`1>4PL01@1>4PL00`000000CQ8704hB1`0604hB1`030000001>4PL0
000000@000000P1c7@`00`000000Lad<07<M300607<M30030000001c7@`0Lad<00P0Lad<00<00000
07<M301c7@`01`1c7@`00`000000Lad<07<M300600000080T2H@00<00000090V402@9Q00202@9Q00
1@000000T2H@090V402@9Q00?EV[00L0T2H@00<0000003eIZ`2@9Q00202@9Q000`000000T2H@090V
4003090V4080?EV[0P2@9Q06000000D0YBdC00@0?EV[0:D]4`2U;A<000001@2U;A<203eIZ`@0YBdC
0`0000000`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00D000001@3om^h00`3D?AT0ooK^
0?ofkP080?ofkP030=@m6@3om^h0ooK^00D0ooK^1P3D?AT;0?ofkP040=@m6@3om^h0ooK^0?ofkPH0
e3dI3`3om^h00`3D?AT0ooK^0=@m6@050?ofkP030000003om^h0000005h0ooK^0@3oool001X0ooK^
00<000000?ofkP3om^h0A03om^h00`000000ooK^0?ofkP0K0?ofkP80?EV[00<0ooK^03eIZ`0mFJ/0
1@3om^h00`3D?AT0?EV[03eIZ`020=@m6@030?ofkP3D?AT0e3dI00<0e3dI00@0?EV[0=@m6@3D?AT0
?EV[2@3om^h00`0mFJ/0e3dI0000000704hB1`030000001>4PL0CQ8700D0CQ8700<0000004hB1`1>
4PL0101>4PL5000000H0Lad<00<0000007<M301c7@`01`1c7@`00`000000Lad<07<M300807<M3003
0000001c7@`0Lad<00D0Lad<1@000008090V40030000002@9Q00T2H@00P0T2H@00@00000090V402@
9Q00?EV[202@9Q000`000000?EV[090V4008090V40060000002@9Q00T2H@090V40000000?EV[0P00
00001@0mFJ/000000:D]4`3D?AT0000000P0YBdC00@0?EV[0:D]4`2U;A<000001@2U;A<203eIZ`@0
YBdC0P0000000`0mFJ/000000?ofkP030?ofkPH000002P3om^h00`3D?AT0ooK^0?ofkP080?ofkP03
0=@m6@3om^h0ooK^00D0e3dI0P3om^h00`3D?AT0ooK^0?ofkP0:0?ofkPH0e3dI0`3om^h00`3D?AT0
ooK^0?ofkP0?0?ofkP040=@m6@3om^h0ooK^0=@m6@@0ooK^00<000000?ofkP000000GP3om^h10?oo
o`006P3om^h00`000000ooK^0?ofkP140?ofkP030000003om^h0ooK^01`0ooK^00@0?EV[0?ofkP3o
m^h0?EV[1`3D?AT00`0mFJ/0e3dI0=@m6@060=@m6@040?ofkP0mFJ/0ooK^03eIZ`X0ooK^00<0?EV[
04hB1`1>4PL01@1>4PL00`000000CQ8704hB1`0504hB1`030000001>4PL0000000D000000P1c7@`0
0`000000Lad<07<M300607<M30030000001c7@`0Lad<00L0Lad<00<0000007<M301c7@`01`1c7@`0
0`000000Lad<07<M300600000080T2H@00<00000090V402@9Q00202@9Q000`000000T2H@090V4008
090V40030000000mFJ/0?EV[00T0T2H@00<00000090V400mFJ/01P2@9Q060000000503eIZ`2U;A<0
YBdC0:D]4`0mFJ/00`2U;A<00`000000YBdC0:D]4`050:D]4`80?EV[0P2U;A<00`000000YBdC0:D]
4`040:D]4`0603eIZ`2U;A<0YBdC0:D]4`000000?eRJ1`0000030?ofkP030=@m6@3om^h0ooK^00X0
ooK^00<0e3dI0?ofkP3om^h01P3om^h50=@m6@L0ooK^00<0e3dI0?ofkP3om^h0103om^h60=@m6@80
ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP0@0?ofkP030=@m6@3om^h0e3dI00D0
ooK^0P00001N0?ofkP40oooo000I0?ofkP030000003om^h0ooK^04H0ooK^00<000000?ofkP3om^h0
603om^h30=@m6@80?EV[00<0e3dI03eIZ`0mFJ/01P3D?AT203eIZ`80e3dI1@3om^h00`3D?AT0?EV[
03eIZ`080?ofkP<0e3dI1`1>4PL00`000000CQ8704hB1`0304hB1`D000001`1c7@`00`000000Lad<
07<M300607<M30030000001c7@`0Lad<00L0Lad<00<0000007<M301c7@`01P1c7@`5000000P0T2H@
00<00000090V402@9Q00202@9Q000`000000T2H@090V4008090V400303eIZ`2@9Q00T2H@00T0T2H@
00<00000090V400mFJ/01P0000020:D]4`040000002U;A<0YBdC03eIZ`@0YBdC00D0?EV[0:D]4`2U
;A<0YBdC000000070:D]4`0503eIZ`2U;A<0?EV[0:D]4`0000001P2U;A<00`0mFJ/0000000000006
000000030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP05
0=@m6@<0ooK^00<0e3dI0?ofkP3om^h01`3om^h60=@m6@P0ooK^00<0e3dI0?ofkP3om^h0103om^h0
0`3D?AT0ooK^0?ofkP0@0?ofkP030=@m6@3om^h0e3dI00D0ooK^0P00001N0?ofkP40oooo000I0?of
kP030000003om^h0ooK^04H0ooK^00<000000?ofkP3om^h04P3om^h60=@m6@80ooK^0P3D?AT403eI
Z`@0e3dI0P3om^h203eIZ`030=@m6@3om^h0ooK^00<0ooK^00@0e3dI0?ofkP3om^h0?EV[0`3om^h6
0=@m6@030000001>4PL0CQ8700D0CQ8700<0000004hB1`0000001000000207<M30030000001c7@`0
Lad<00L0Lad<00<0000007<M301c7@`01P1c7@`00`000000Lad<07<M300707<M30030000001c7@`0
Lad<00H000000P2@9Q000`000000T2H@090V4008090V40030000002@9Q00T2H@00P0T2H@00<00000
090V402@9Q001`2@9Q000`0mFJ/00000090V4008090V40D0000000<0?EV[0:D]4`2U;A<01@2U;A<0
0`000000YBdC03eIZ`060:D]4`0403eIZ`2U;A<0YBdC000000H0YBdC00H0?EV[0:D]4`2U;A<0?EV[
0:D]4`0000020:D]4`D000000`2U;A<01P000000?eRJ03mHVP000000?EV[000000L0ooK^00<0e3dI
0?ofkP3om^h01`3om^h60=@m6@P0ooK^00@0e3dI0?ofkP3om^h0ooK^1`3D?AT=0?ofkP030=@m6@3o
m^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h0403om^h00`3D?AT0ooK^0=@m6@050?ofkP030000003o
m^h0000005d0ooK^0@3oool001T0ooK^00<000000?ofkP3om^h0A`3om^h00`000000ooK^0?ofkP0;
0?ofkPH0e3dI0`3om^h80=@m6@@0?EV[1@3om^h00`0mFJ/0ooK^03eIZ`020=@m6@<0ooK^00<0e3dI
0?ofkP3D?AT00P0mFJ/50=@m6@80ooK^00<0000004hB1`1>4PL00`1>4PL5000000H0Lad<00<00000
07<M301c7@`01`1c7@`00`000000Lad<07<M300707<M30030000001c7@`0Lad<00D0Lad<1@000008
090V40030000002@9Q00T2H@00P0T2H@00<00000090V402@9Q00202@9Q000`000000T2H@090V4005
090V4080?EV[00<0T2H@0000002@9Q000P2@9Q06000000030:D]4`3D?AT000000080YBdC00<0?EV[
0:D]4`2U;A<01@2U;A<00`000000?EV[0:D]4`060:D]4`0403eIZ`2U;A<0YBdC000000H0YBdC00<0
?EV[0:D]4`0000001@0000030:D]4`0303eIZ`2U;A<0?EV[0080YBdC00H0000003mHVP0oF9X00000
03eIZ`0000070?ofkP040=@m6@3om^h0ooK^0?ofkPH0e3dI0`3om^h00`3D?AT0ooK^0?ofkP060?of
kPH0e3dI1P3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?of
kP3om^h0403om^h0103D?AT0ooK^0?ofkP3D?AT40?ofkP030000003om^h0000005d0ooK^0@3oool0
01T0ooK^00<000000?ofkP3om^h0B03om^h00`000000ooK^0?ofkP050?ofkPL0e3dI0P3om^h70=@m
6@<0ooK^00<0e3dI0?ofkP3om^h00`0mFJ/00`3om^h0?EV[0?ofkP030?ofkP0403eIZ`3om^h0?EV[
0?ofkPL0e3dI0P0mFJ/00`3D?AT0ooK^0?ofkP030?ofkP030000001>4PL0000000@0000000<0Lad<
0000001c7@`0201c7@`00`000000Lad<07<M300707<M30030000001c7@`0Lad<00H0Lad<00<00000
07<M301c7@`01P000002090V40030000002@9Q00T2H@00P0T2H@00<00000090V402@9Q00202@9Q00
0`000000T2H@090V4008090V40030000002@9Q00T2H@00@0T2H@00<0?EV[090V400000001@000008
0:D]4`050000002U;A<0YBdC0:D]4`0mFJ/01P2U;A<00`000000?EV[0:D]4`070:D]4`0303eIZ`2U
;A<000000080YBdC1P0000020:D]4`0303eIZ`000000YBdC00@0YBdC00<0?EV[0:D]4`0mFJ/00P2U
;A<00`000000?eRJ03mHVP03000000040=@m6@3om^h0ooK^0?ofkPL0e3dI2@3om^h00`3D?AT0ooK^
0?ofkP060=@m6@80ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m
6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h0403om^h0103D?AT0ooK^0?ofkP3D?AT40?ofkP03
0000003om^h0000005d0ooK^0@3oool001P0ooK^00<000000?ofkP3om^h0B@3om^h00`000000ooK^
0?ofkP050=@m6@<0ooK^1`3D?AT30?ofkP80e3dI103om^h0103D?AT0ooK^0?ofkP3om^h203eIZ`03
0?ofkP0mFJ/0ooK^00<0e3dI00@0?EV[0=@m6@3D?AT0?EV[1@3D?AT01@3om^h0?EV[0?ofkP3om^h0
?EV[00@0ooK^0`00000607<M30030000001c7@`0Lad<00H0Lad<00<0000007<M301c7@`0201c7@`0
0`000000Lad<07<M300407<M30D00000202@9Q000`000000T2H@090V4008090V40030000002@9Q00
T2H@00P0T2H@00<00000090V402@9Q00202@9Q000`000000T2H@090V4002000000<0?EV[00D00000
0:D]4`2U;A<000000=@m6@0:0:D]4`050000002U;A<0YBdC0:D]4`0mFJ/01P2U;A<00`0mFJ/0YBdC
0:D]4`060:D]4`H000000`2U;A<00`0mFJ/0YBdC0:D]4`020:D]4`0303eIZ`000000YBdC00@0YBdC
00<0?EV[0:D]4`0mFJ/00`00000203mHVP<00000103D?AT30?ofkP030=@m6@3om^h0ooK^00L0ooK^
1P3D?AT80?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^
0?ofkP040?ofkP030=@m6@3om^h0ooK^00l0ooK^103D?AT40?ofkP030000003om^h0000005d0ooK^
0@3oool001P0ooK^00<000000?ofkP3om^h0A`3om^h50=@m6@<0ooK^1`3D?AT:0?ofkP040=@m6@3o
m^h0ooK^0=@m6@80ooK^0P3D?AT01@0mFJ/0e3dI03eIZ`3D?AT0?EV[00<0e3dI00@0?EV[0=@m6@3D
?AT0?EV[0P3om^h20=@m6@80ooK^00@0?EV[0?ofkP3om^h0?EV[0`3om^h00`000000Lad<07<M3006
07<M30030000001c7@`0Lad<00L0Lad<00<0000007<M301c7@`01`1c7@`00`000000Lad<07<M3005
00000080T2H@00<00000090V402@9Q00202@9Q000`000000T2H@090V4007090V40030000002@9Q00
T2H@00T0T2H@00<00000090V402@9Q001P2@9Q0500000080?EV[0`2U;A<0100mFJ/0YBdC0:D]4`00
000;0:D]4`050000002U;A<0YBdC0:D]4`0mFJ/01@2U;A<00`0mFJ/000000:D]4`020:D]4`D00000
00@0YBdC03eIZ`2U;A<00000102U;A<00`0mFJ/0YBdC0:D]4`040:D]4`0303eIZ`2U;A<0YBdC00<0
000000H0?EV[000000000000?EV[0;Hb5@00000203mHVP@000001P3om^h0103D?AT0ooK^0?ofkP3o
m^h60=@m6@@0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3o
m^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP080?ofkPP0e3dI0P3o
m^h00`3D?AT0ooK^0?ofkP030?ofkP800000G@3om^h10?ooo`00603om^h00`000000ooK^0?ofkP13
0?ofkP@0e3dI0P3om^h90=@m6@h0ooK^1P3D?AT00`3om^h0e3dI0=@m6@0403eIZ`<0ooK^00H0?EV[
0?ofkP3om^h0ooK^03eIZ`3om^h20=@m6@80ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`020?ofkP03
0000001c7@`0Lad<00H0Lad<00<0000007<M301c7@`01`1c7@`00`000000Lad<07<M300507<M30D0
00001`2@9Q000`000000T2H@090V4008090V40030000002@9Q00T2H@00L0T2H@00<00000090V402@
9Q002@2@9Q000`000000T2H@090V4006000000030:D]4`3D?AT000000080?EV[1@2U;A<0100mFJ/0
YBdC0:D]4`00000;0:D]4`030000002U;A<0YBdC0080YBdC00@0?EV[0:D]4`2U;A<0YBdC1P000007
0:D]4`0303eIZ`000000YBdC0080YBdC00<0?EV[0:D]4`2U;A<00`2U;A<20000000303eIZ`000000
00000080]S8E00H0?EV[0;Hb5@2f<QD0]S8E03eIZ`2f<QD20000000303mHVP000000000000800000
0`3om^h70=@m6@X0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m
6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h0103om^h0103D?AT0ooK^0?ofkP3om^h70=@m6@L0
ooK^00@0e3dI0?ofkP3om^h0e3dI1@3om^h2000005d0ooK^0@3oool001P0ooK^00<000000?ofkP3o
m^h0@@3om^h<0=@m6@<0ooK^00<0e3dI0?ofkP3om^h0203om^h50=@m6@030?ofkP3D?AT0e3dI00@0
e3dI0`3om^h403eIZ`80ooK^00H0?EV[0?ofkP3om^h0ooK^03eIZ`3D?AT20?ofkP030=@m6@3om^h0
?EV[00<0ooK^00<0?EV[0?ofkP000000201c7@`00`000000Lad<07<M300707<M30030000001c7@`0
Lad<00H000000P2@9Q000`000000T2H@090V4007090V40030000002@9Q00T2H@00L0T2H@00<00000
090V402@9Q00202@9Q000`000000T2H@090V4007090V40D000001`2U;A<203eIZ`P0YBdC00<0?EV[
0:D]4`0000002`2U;A<00`000000YBdC0:D]4`0600000080YBdC00<000000:D]4`2U;A<0202U;A<0
0`0mFJ/000000:D]4`020:D]4`0303eIZ`000000000000<000000P2f<QD00`0mFJ/0]S8E0;Hb5@02
0;Hb5@0303eIZ`2f<QD0]S8E0080]S8E00D0?EV[04UY_0000000?eRJ000000060=@m6@<0ooK^00<0
e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0
e3dI0?ofkP3om^h02`3om^h0103D?AT0ooK^0?ofkP3om^h70=@m6@l0ooK^00<0e3dI0?ofkP3D?AT0
1@3om^h00`000000ooK^0000001L0?ofkP40oooo000H0?ofkP030000003om^h0ooK^03l0ooK^103D
?AT80?ofkP80e3dI0`3om^h00`3D?AT0ooK^0?ofkP030?ofkPD0e3dI00<0ooK^0=@m6@3D?AT0103D
?AT20?ofkP030=@m6@3om^h0ooK^00<0ooK^0P0mFJ/01@3om^h0?EV[03eIZ`3om^h0?EV[00@0ooK^
00D0?EV[0?ofkP3om^h0ooK^03eIZ`050?ofkP0303eIZ`1c7@`0Lad<00L0Lad<00<0000007<M301c
7@`01@1c7@`5000000P0T2H@00<00000090V402@9Q001`2@9Q000`000000T2H@090V4007090V4003
0000002@9Q00T2H@00P0T2H@00@00000090V402@9Q00T2H@1P0000000`2U;A<0e3dI000000070:D]
4`80?EV[00<0YBdC0000002U;A<01`2U;A<00`0mFJ/0YBdC000000080:D]4`H000000`2U;A<203eI
Z`<0YBdC00<000000:D]4`2U;A<01`2U;A<00`000000?EV[000000020000000303eIZ`2f<QD0]S8E
00H0]S8E00<0000003eIZ`2f<QD00P2f<QD00`0mFJ/0]S8E0;Hb5@020;Hb5@0303eIZ`3D?AT0e3dI
0080e3dI00@0?eRJ0000000`@Vl000001@3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0
ooK^00P0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP080?ofkPH0e3dI0`3om^h0
0`3D?AT0ooK^0?ofkP0@0?ofkP040=@m6@3om^h0ooK^0=@m6@@0ooK^00<000000?ofkP000000G03o
m^h10?ooo`005`3om^h00`000000ooK^0?ofkP0o0?ofkP030=@m6@3om^h0ooK^00`0ooK^00@0e3dI
0?ofkP3D?AT0ooK^1@3D?AT20?ofkP@0e3dI1@3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00D0ooK^
0P0mFJ/0103om^h0?EV[03eIZ`0mFJ/40?ofkP0603eIZ`3om^h0ooK^0?ofkP0mFJ/0e3dI0P3om^h3
0=@m6@0303eIZ`1c7@`0Lad<00D0Lad<00<0000007<M301c7@`01P000002090V40030000002@9Q00
T2H@00L0T2H@00<00000090V402@9Q001`2@9Q000`000000T2H@090V4008090V40030000002@9Q00
T2H@00H0T2H@1P0000080:D]4`030000002U;A<0YBdC00<0YBdC0P0mFJ/30:D]4`030000002U;A<0
YBdC00H0YBdC00<0?EV[0:D]4`0000000`2U;A<5000000<0YBdC00<000000:D]4`2U;A<00`2U;A<0
0`0mFJ/0YBdC0:D]4`020:D]4`040000002U;A<0YBdC0:D]4`H000000P2f<QD0100mFJ/0]S8E0;Hb
5@0mFJ/70;Hb5@030000002f<QD0?EV[0080]S8E00<0?EV[0;Hb5@2f<QD00`2f<QD00`000000BFVl
04UY_0020000000403mHVP000000<49_000000D0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0
ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00P0ooK^00@0e3dI0?ofkP3om^h0ooK^1`3D?AT20?of
kP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h0403om^h0103D?AT0ooK^0?ofkP3D?AT4
0?ofkP030000003om^h0000005`0ooK^0@3oool001L0ooK^00<000000?ofkP3om^h0?P3om^h00`3D
?AT0ooK^0?ofkP0<0?ofkPD0e3dI0P3om^h50=@m6@T0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D
?AT0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^0080?EV[0`3om^h00`3D?AT0ooK^03eIZ`020=@m
6@0603eIZ`3D?AT0e3dI0=@m6@3om^h000001`1c7@`5000000P0T2H@00<00000090V402@9Q001`2@
9Q000`000000T2H@090V4007090V40030000002@9Q00T2H@00P0T2H@00<00000090V402@9Q001P00
00020:D]4`030000002U;A<0YBdC00T0YBdC00@000000:D]4`2U;A<0YBdC0P0mFJ/50:D]4`030000
002U;A<0YBdC00H0YBdC1P0000080:D]4`040000002U;A<0YBdC0:D]4`<0?EV[0P2U;A<6000000P0
]S8E00<0?EV[0;Hb5@0mFJ/0202f<QD00`000000]S8E03eIZ`020;Hb5@0303eIZ`2f<QD0]S8E00<0
]S8E00H0000004UY_019JK`0BFVl0000000oF9X3000000D0ooK^00<0e3dI0?ofkP3om^h02`3om^h0
0`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00H0ooK^1P3D?AT90?ofkP030=@m6@3om^h0
ooK^00@0ooK^00<0e3dI0?ofkP3om^h03@3om^h40=@m6@80ooK^00<0e3dI0?ofkP3om^h00P3om^h0
0`000000ooK^0000001L0?ofkP40oooo000G0?ofkP030000003om^h0ooK^03d0ooK^00<0e3dI0?of
kP3om^h0203om^h50=@m6@80ooK^00<0e3dI0?ofkP3D?AT00P3D?AT=0?ofkP030=@m6@3om^h0ooK^
00<0ooK^00<0e3dI0?ofkP3om^h00`3om^h203eIZ`040?ofkP0mFJ/0?EV[03eIZ`@0e3dI00@0?EV[
0?ofkP3om^h0?EV[103D?AT00`000000Lad<0000000500000080T2H@00<00000090V402@9Q001`2@
9Q000`000000T2H@090V4008090V40030000002@9Q00T2H@00L0T2H@00<00000090V402@9Q001P2@
9Q05000000P0YBdC00<000000:D]4`2U;A<02@2U;A<010000000YBdC03eIZ`0mFJ/70:D]4`030000
002U;A<0YBdC00H0000000<0YBdC03eIZ`0000002`2U;A<010000000YBdC0:D]4`0mFJ/300000005
03eIZ`000000]S8E0;Hb5@0000002`2f<QD00`000000?EV[03eIZ`080;Hb5@060000002f<QD0]S8E
03eIZ`2f<QD0?EV[1@2f<QD01P000000BFVl04UY_019JK`0000003mHVP<0000000<0e3dI0?ofkP3o
m^h00`3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00L0ooK^00@0e3dI0?ofkP3o
m^h0ooK^1@3D?AT20?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D
?AT0ooK^0?ofkP060?ofkPH0e3dI0`3om^h0103D?AT0ooK^0?ofkP3D?AT50?ofkP800000G03om^h1
0?ooo`005`3om^h00`000000ooK^0?ofkP0m0?ofkP030=@m6@3om^h0ooK^00<0ooK^1@3D?AT60?of
kP050=@m6@3om^h000000?ofkP3D?AT03P3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0
ooK^00<0ooK^00H0?EV[0=@m6@3D?AT0?EV[0=@m6@0mFJ/40=@m6@80?EV[0`3om^h0103D?AT00000
000000000008090V40030000002@9Q00T2H@00L0T2H@00<00000090V402@9Q00202@9Q000`000000
T2H@090V4007090V40030000002@9Q00T2H@00H000000P2U;A<00`000000YBdC0:D]4`080:D]4`03
0000002U;A<0YBdC00P0YBdC0`0mFJ/60:D]4`H00000202U;A<00`0mFJ/0YBdC0:D]4`070:D]4`@0
000000<0?EV[0;Hb5@2f<QD00P2f<QD01@0mFJ/0]S8E0;Hb5@2f<QD0000000/0]S8E00<0000003eI
Z`2f<QD0202f<QD01P000000]S8E0;Hb5@0mFJ/0]S8E03eIZ`D0]S8E00P0000004UY_019JK`0BFVl
0000000oF9X0000003mHVP8000001@3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^
00D0ooK^1P3D?AT70?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D
?AT0ooK^0?ofkP060=@m6@T0ooK^00@0e3dI0?ofkP3om^h0e3dI1@3om^h2000005`0ooK^0@3oool0
01H0ooK^00<000000?ofkP3om^h0?@3om^h00`3D?AT0ooK^0=@m6@040=@m6@/0ooK^00<0e3dI0?of
kP0000000P3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00@0ooK^1P3D?AT203eI
Z`040=@m6@0mFJ/0?EV[0=@m6@80?EV[0P3om^h203eIZ`<0ooK^00<0e3dI0000002@9Q00202@9Q00
0`000000T2H@090V4008090V40030000002@9Q00T2H@00L0T2H@00<00000090V402@9Q001P2@9Q05
000000P0YBdC00<000000:D]4`2U;A<0202U;A<00`000000YBdC0:D]4`050:D]4`<0?EV[00@0YBdC
03eIZ`2U;A<0YBdC1@0000030:D]4`030000002U;A<0YBdC00P0YBdC00@0?EV[0:D]4`2U;A<0YBdC
1P0000020;Hb5@80?EV[1@2f<QD01@0mFJ/0]S8E0;Hb5@2f<QD0000000/0]S8E0P0mFJ/90;Hb5@05
0000002f<QD0]S8E0;Hb5@0mFJ/01@2f<QD00`000000BFVl04UY_00204UY_0040000000oF9X00000
03mHVP8000001@3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00D0e3dI0P3om^h0
0`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00/0ooK^00@0e3dI0?ofkP3om^h0ooK^1P3D
?AT?0?ofkP040=@m6@3om^h0ooK^0=@m6@D0ooK^00<000000?ofkP000000F`3om^h10?ooo`005P3o
m^h00`000000ooK^0?ofkP0l0?ofkP<0e3dI3`3om^h01@3D?AT0ooK^0?ofkP3om^h000000080ooK^
00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP0;0=@m6@070?ofkP0mFJ/0?EV[0?ofkP0m
FJ/0ooK^0=@m6@0303eIZ`030?ofkP0mFJ/0ooK^00<0ooK^00<00000090V402@9Q001`2@9Q000`00
0000T2H@090V4008090V40030000002@9Q00T2H@00L0T2H@00<00000090V402@9Q001P0000020:D]
4`030000002U;A<0YBdC00P0YBdC00<000000:D]4`2U;A<0202U;A<00`000000YBdC0:D]4`030:D]
4`80?EV[00<0YBdC000000000000100000080:D]4`030000002U;A<0YBdC00H0YBdC0`0000000`0m
FJ/00000000000070;Hb5@0303eIZ`000000]S8E00H0]S8E00@0?EV[0;Hb5@2f<QD000002P2f<QD0
100mFJ/0]S8E0;Hb5@0mFJ/80;Hb5@050000002f<QD0]S8E0;Hb5@0mFJ/01@2f<QD00`000000BFVl
04UY_00204UY_0<000000P0oF9X00`000000ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00P0ooK^
1P3D?AT70?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h0203om^h60=@m6@<0ooK^
00<0e3dI0?ofkP3om^h0403om^h00`3D?AT0ooK^0=@m6@050?ofkP030000003om^h0000005/0ooK^
0@3oool001H0ooK^00<000000?ofkP3om^h0>`3om^h00`3D?AT0ooK^0?ofkP0@0?ofkP050=@m6@3o
m^h0ooK^0?ofkP0000000`3om^h00`3D?AT0ooK^0?ofkP060?ofkPT0e3dI103om^h00`3D?AT0ooK^
0?ofkP020?ofkP0603eIZ`3om^h0?EV[03eIZ`3D?AT0?EV[0P3om^h303eIZ`80ooK^00<00000090V
402@9Q00202@9Q000`000000T2H@090V4007090V40030000002@9Q00T2H@00H0T2H@1@0000080:D]
4`030000002U;A<0YBdC00P0YBdC00<000000:D]4`2U;A<02@2U;A<00`000000YBdC000000050000
00<0YBdC00<0000003eIZ`2U;A<0202U;A<00`000000YBdC0:D]4`0600000080]S8E00<0000003eI
Z`2f<QD01`2f<QD00`0mFJ/0]S8E000000070;Hb5@0403eIZ`2f<QD0]S8E000000T0]S8E00D0?EV[
0000002f<QD0]S8E03eIZ`070;Hb5@040000002f<QD0]S8E0;Hb5@80?EV[1@2f<QD01P000000BFVl
04UY_019JK`0000004UY_08000000P0oF9X2000000@0ooK^00<0e3dI0?ofkP3om^h00P3om^h60=@m
6@<0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^
00<0ooK^1@3D?AT20?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h0403om^h0103D
?AT0ooK^0?ofkP3D?AT40?ofkP030000003om^h0000005/0ooK^0@3oool001H0ooK^00<000000?of
kP3om^h0>`3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00<0ooK^00D000000?of
kP3om^h0ooK^0=@m6@020?ofkPP0e3dI2P3om^h00`3D?AT0ooK^0?ofkP020?ofkP@0?EV[00<0e3dI
0?ofkP0mFJ/00P3om^h403eIZ`030000002@9Q00T2H@00P0T2H@00<00000090V402@9Q001`2@9Q00
0`000000T2H@090V4006000000030:D]4`3D?AT0000000X0YBdC00<000000:D]4`2U;A<0202U;A<0
0`000000YBdC0:D]4`050:D]4`H000002@2U;A<00`000000YBdC03eIZ`060:D]4`D00000202f<QD0
0`000000?EV[0;Hb5@050;Hb5@80?EV[0P2f<QD00`000000]S8E0;Hb5@060;Hb5@0303eIZ`2f<QD0
000000P0]S8E00<0?EV[0;Hb5@0000000P2f<QD00`0mFJ/0]S8E0;Hb5@050;Hb5@070000002f<QD0
]S8E0;Hb5@0mFJ/0]S8E03eIZ`020;Hb5@<000000`19JK`010000000BFVl00000000000203mHVP80
00000`3om^h60=@m6@T0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP080?ofkP03
0=@m6@3om^h0e3dI00<0e3dI1`3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^0100
ooK^00@0e3dI0?ofkP3om^h0e3dI103om^h00`000000ooK^0000001K0?ofkP40oooo000F0?ofkP03
0000003om^h0ooK^03X0ooK^00<0e3dI0?ofkP3om^h0403om^h00`3D?AT0ooK^0?ofkP040?ofkPP0
e3dI103om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^0080ooK^00H0?EV[0?ofkP0m
FJ/0?EV[0?ofkP0mFJ/20?ofkP0403eIZ`3om^h0?EV[0?ofkP80?EV[202@9Q000`000000T2H@090V
4006090V40D00000202U;A<00`000000YBdC0:D]4`080:D]4`030000002U;A<0YBdC00P0YBdC00<0
00000:D]4`2U;A<01@0000001@2U;A<0?EV[03eIZ`2U;A<0000000X0YBdC00<000000:D]4`0mFJ/0
1P0000020;Hb5@030000002f<QD0]S8E00P0]S8E00<000000;Hb5@0mFJ/0102f<QD00`0mFJ/0]S8E
0;Hb5@020;Hb5@030000002f<QD0]S8E00H0]S8E00<0?EV[0;Hb5@0000001`2f<QD0100mFJ/0]S8E
0;Hb5@0000030;Hb5@0303eIZ`2f<QD0]S8E00@0]S8E00@000000;Hb5@2f<QD0?EV[0P0000000`0m
FJ/00000000000020<<f5`0600000019JK`0BFVl04UY_0000000BFVl0P00000203mHVP8000000`3D
?AT00`3om^h0e3dI0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h01@3o
m^h50=@m6@/0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP0@0?ofkP040=@m6@3o
m^h0ooK^0=@m6@D0ooK^0P00001K0?ofkP40oooo000E0?ofkP030000003om^h0ooK^03/0ooK^00<0
e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP050=@m6@030000003om^h0ooK^0080ooK^00<0
e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^0080ooK^0`0m
FJ/02`3D?AT0?EV[0?ofkP0mFJ/0ooK^03eIZ`3om^h0?EV[0?ofkP000000T2H@0080?EV[1P2@9Q00
0`000000T2H@090V4006000000030:D]4`3D?AT0000000X0YBdC00<000000:D]4`2U;A<0202U;A<0
0`000000YBdC0:D]4`050:D]4`H000000`2U;A<303eIZ`<0YBdC00<000000:D]4`2U;A<01P2U;A<5
0000000303eIZ`2f<QD0]S8E00D0]S8E00<000000;Hb5@2f<QD0202f<QD00`000000]S8E03eIZ`03
0;Hb5@0303eIZ`2f<QD0]S8E0080]S8E00<000000;Hb5@2f<QD01`2f<QD00`0mFJ/0]S8E00000006
0;Hb5@0503eIZ`2f<QD0]S8E0;Hb5@0000000`2f<QD00`0mFJ/0]S8E0;Hb5@020;Hb5@@0000000D0
?EV[0<<f5`33=QL0`cHG03eIZ`040<<f5`8000000P19JK`010000000BFVl04UY_000000203mHVP80
0000103om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3o
m^h01@3D?AT30?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0
ooK^0?ofkP0?0?ofkP@0e3dI1@3om^h2000005/0ooK^0@3oool001D0ooK^00<000000?ofkP3om^h0
>P3om^h00`3D?AT0ooK^0?ofkP0=0?ofkPH0e3dI1P3om^h01@000000ooK^0?ofkP3om^h0e3dI00H0
ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP020?ofkP80?EV[00@0e3dI03eIZ`3o
m^h0ooK^0P0mFJ/20?ofkP0303eIZ`2@9Q00T2H@0080T2H@100mFJ/5000000P0YBdC00<000000:D]
4`2U;A<0202U;A<00`000000YBdC0:D]4`080:D]4`030000002U;A<0000000D000000`2U;A<00`00
0000YBdC03eIZ`0303eIZ`H0YBdC00<000000:D]4`2U;A<01P0000020;Hb5@040000002f<QD0]S8E
03eIZ`L0]S8E00<000000;Hb5@2f<QD0202f<QD00`000000]S8E0;Hb5@0303eIZ`D0]S8E00<00000
0;Hb5@2f<QD0202f<QD00`0mFJ/000000;Hb5@050;Hb5@0503eIZ`2f<QD0]S8E0;Hb5@0000000P2f
<QD00`000000?EV[0000000300000080`cHG00<000000<<f5`0mFJ/00`33=QL01`0mFJ/0`cHG0<<f
5`33=QL00000051cdP0000000P19JK`010000000BFVl04UY_000000203mHVP<00000103om^h00`3D
?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00D0ooK^1@3D?AT80?ofkP030=@m6@3om^h0ooK^
00/0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP080?ofkPP0e3dI0P3om^h00`3D
?AT0ooK^0?ofkP030?ofkP030000003om^h0000005X0ooK^0@3oool001D0ooK^00<000000?ofkP3o
m^h0>P3om^h00`3D?AT0ooK^0?ofkP070?ofkPH0e3dI0`3om^h00`3D?AT0ooK^0?ofkP070?ofkP05
0000003om^h0ooK^0?ofkP3D?AT01@3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^
00<0ooK^0P0mFJ/00`3om^h0?EV[0?ofkP0203eIZ`80ooK^00<0?EV[090V402@9Q00100000000`0m
FJ/0000003eIZ`0403eIZ`P0YBdC00<000000:D]4`2U;A<0202U;A<00`000000YBdC0:D]4`040:D]
4`H000001@2U;A<603eIZ`80YBdC00<0?EV[0:D]4`2U;A<00`2U;A<5000000P0]S8E00D000000;Hb
5@2f<QD0]S8E03eIZ`060;Hb5@030000002f<QD0]S8E00P0]S8E00@000000;Hb5@2f<QD0?EV[1`2f
<QD00`000000]S8E0;Hb5@080;Hb5@0303eIZ`000000]S8E00@0]S8E00<0?EV[0;Hb5@2f<QD01@00
00020<<f5`0303eIZ`33=QL0`cHG00<0`cHG00<0000003eIZ`33=QL01033=QL01P0mFJ/0`cHG0<<f
5`000000D7?B00000080BFVl00@0000004UY_019JK`000000P0oF9X3000000@0ooK^00<0e3dI0?of
kP3om^h02`3om^h00`3D?AT0ooK^0=@m6@050=@m6@80ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D
?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00@0ooK^00@0e3dI0?ofkP3om^h0ooK^1`3D?AT8
0?ofkP030=@m6@3om^h0e3dI00D0ooK^00<000000?ofkP000000FP3om^h10?ooo`005@3om^h00`00
0000ooK^0?ofkP0i0?ofkP040=@m6@3om^h0ooK^0?ofkPL0e3dI2@3om^h00`3D?AT0ooK^0?ofkP07
0?ofkP030000003om^h0ooK^0080ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0?0?ofkP030=@m6@3o
m^h0ooK^0080ooK^0P0mFJ/0103om^h0?EV[0?ofkP3om^h203eIZ`040=@m6@000000?EV[000000@0
YBdC00D0?EV[0:D]4`2U;A<0YBdC000000020:D]4`H0?EV[0P2U;A<00`000000YBdC0:D]4`080:D]
4`L00000102U;A<00`000000?EV[03eIZ`0403eIZ`@0YBdC00H000000:D]4`2U;A<0YBdC0000000m
FJ/400000080]S8E00<000000;Hb5@2f<QD0202f<QD01@000000]S8E0;Hb5@2f<QD0?EV[00H0]S8E
00<000000;Hb5@2f<QD0202f<QD010000000?EV[03eIZ`0mFJ/70;Hb5@030000002f<QD0]S8E00P0
]S8E00@0?EV[0000002f<QD0]S8E0P000000100mFJ/000000000000000020<<f5`0300000033=QL0
`cHG0080`cHG00<0?EV[0<<f5`33=QL00P33=QL00`000000?EV[0<<f5`050<<f5`0403eIZ`33=QL0
`cHG00000080D7?B0P00000304UY_0<0000000<0?eRJ000000000000103om^h00`3D?AT0ooK^0?of
kP070?ofkPH0e3dI203om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0
e3dI0?ofkP3om^h00P3om^h60=@m6@l0ooK^00<0e3dI0?ofkP3D?AT01@3om^h00`000000ooK^0000
001J0?ofkP40oooo000D0?ofkP030000003om^h0ooK^03X0ooK^103D?AT?0?ofkP030=@m6@3om^h0
ooK^00T0ooK^00D000000?ofkP3om^h0ooK^0=@m6@030?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0
e3dI0?ofkP3om^h00P3om^h00`3D?AT0?EV[03eIZ`0203eIZ`80e3dI00<0?EV[0?ofkP0000001`2U
;A<0100mFJ/0YBdC0:D]4`0000080:D]4`T0?EV[1@00000;03eIZ`P0YBdC1P0000000`2f<QD0?EV[
0;Hb5@050;Hb5@030000002f<QD0]S8E00P0]S8E00<000000;Hb5@2f<QD00P2f<QD00`0mFJ/0]S8E
0;Hb5@030;Hb5@030000002f<QD0]S8E00L0]S8E0P0mFJ/30;Hb5@0303eIZ`2f<QD0]S8E00@0]S8E
00<000000;Hb5@2f<QD01`2f<QD20000000503eIZ`00000000000<<f5`0mFJ/01P33=QL00`000000
`cHG0<<f5`020<<f5`0303eIZ`33=QL0`cHG0080`cHG00<0?EV[0<<f5`33=QL01@33=QL0100mFJ/0
`cHG0<<f5`000002051cdP8000000P19JK`010000000BFVl00000000000203mHVP030000000mFJ/0
ooK^0080ooK^00@0e3dI0?ofkP3om^h0ooK^1P3D?AT50?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0
e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP0:0?ofkPD0e3dI0P3om^h00`3D?AT0ooK^0?of
kP0@0?ofkP040=@m6@3om^h0ooK^0=@m6@@0ooK^00<000000?ofkP000000FP3om^h10?ooo`00503o
m^h00`000000ooK^0?ofkP0j0?ofkP030=@m6@3om^h0ooK^0100ooK^00<0e3dI0?ofkP3om^h02P3o
m^h01@000000ooK^0?ofkP3om^h0e3dI0080ooK^00<0e3dI0?ofkP3om^h0303om^h70=@m6@80?EV[
00L0ooK^03eIZ`0mFJ/0ooK^03eIZ`3om^h0000000L0YBdC00@0?EV[0:D]4`2U;A<000002P2U;A<7
000000@0YBdC00<000000:D]4`2U;A<01@2U;A<0100mFJ/0YBdC0:D]4`0000020:D]4`H000000P2f
<QD00`000000]S8E0;Hb5@030;Hb5@0303eIZ`2f<QD0]S8E00<0]S8E00<000000;Hb5@2f<QD0202f
<QD00`000000]S8E0;Hb5@020;Hb5@0303eIZ`2f<QD0]S8E00<0]S8E00<000000;Hb5@2f<QD01@2f
<QD203eIZ`030;Hb5@000000]S8E0080]S8E00<0?EV[0;Hb5@2f<QD0102f<QD010000000]S8E0;Hb
5@2f<QD600000080`cHG00@0?EV[0<<f5`33=QL0?EV[1`33=QL00`000000`cHG0<<f5`030<<f5`05
03eIZ`33=QL0`cHG0<<f5`0mFJ/02033=QL00`0mFJ/00000051cdP03051cdP0500000019JK`0BFVl
00000019JK`00P00000203mHVP030000003D?AT0e3dI00H0e3dI2`3om^h00`3D?AT0ooK^0?ofkP07
0?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h01@3om^h60=@m6@H0ooK^00<0e3dI
0?ofkP3om^h0403om^h0103D?AT0ooK^0?ofkP3D?AT50?ofkP800000FP3om^h10?ooo`00503om^h0
0`000000ooK^0?ofkP0i0?ofkP030=@m6@3om^h0ooK^0140ooK^00<0e3dI0?ofkP3om^h02P3om^h0
0`000000ooK^0?ofkP020?ofkP030=@m6@3om^h0e3dI00P0ooK^2P3D?AT20?ofkP030=@m6@3om^h0
?EV[0080ooK^00D0?EV[0?ofkP0mFJ/0?EV[000000080:D]4`0303eIZ`2U;A<0000000D0YBdC1P00
00000`0mFJ/0YBdC0:D]4`070:D]4`030000002U;A<0YBdC00<0YBdC0`0000000`0mFJ/000000000
0002000000P0]S8E00<000000;Hb5@2f<QD00`2f<QD00`0mFJ/0]S8E0;Hb5@030;Hb5@030000002f
<QD0]S8E00P0]S8E00<000000;Hb5@2f<QD00`2f<QD00`0mFJ/0]S8E0;Hb5@020;Hb5@030000002f
<QD0]S8E00<0]S8E0P0mFJ/30;Hb5@050000002f<QD0]S8E0;Hb5@0mFJ/0102f<QD6000000P0`cHG
00<0000003eIZ`0mFJ/01`33=QL00`000000`cHG0<<f5`040<<f5`0503eIZ`33=QL0`cHG03eIZ`00
00002033=QL00`0mFJ/00000051cdP03051cdP0300000019JK`0e3dI00L0e3dI00D000000?ofkP3o
m^h0ooK^0=@m6@0>0?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D
?AT0ooK^0?ofkP050=@m6@H0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP0?0?of
kP040=@m6@3om^h0ooK^0=@m6@D0ooK^0P00001J0?ofkP40oooo000D0?ofkP030000003om^h0ooK^
03T0ooK^00<0e3dI0?ofkP3om^h04@3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP040000003om^h0ooK^
0?ofkP80e3dI0`3om^h:0=@m6@D0ooK^00@0e3dI0?ofkP3om^h0e3dI0P3om^h00`0mFJ/0ooK^0?of
kP0303eIZ`030000002U;A<0YBdC00H0YBdC00<0?EV[0:D]4`0000001@0000050:D]4`030000002U
;A<0?EV[00H0YBdC200000030;Hb5@0303eIZ`2f<QD0000000/0]S8E00<000000;Hb5@2f<QD00`2f
<QD00`0mFJ/0]S8E0;Hb5@020;Hb5@030000002f<QD0]S8E00P0]S8E00<000000;Hb5@2f<QD00`2f
<QD00`0mFJ/0]S8E0;Hb5@020;Hb5@040000002f<QD0]S8E0;Hb5@80?EV[1@2f<QD00`000000]S8E
0;Hb5@020000000403eIZ`000000000000000080`cHG00<000000<<f5`33=QL02@33=QL00`000000
?EV[0<<f5`070<<f5`0300000033=QL0`cHG00@0`cHG00@0?EV[0<<f5`0mFJ/000002P33=QL00`0m
FJ/0D7?B0=@m6@040=@m6@0504UY_0000000BFVl04UY_00000000P0oF9X2000000<0ooK^00<0e3dI
0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00D0ooK^1P3D?AT;
0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h03`3om^h0103D?AT0ooK^0?ofkP3D
?AT50?ofkP030000003om^h0000005T0ooK^0@3oool001@0ooK^00<000000?ofkP3om^h0>@3om^h0
0`3D?AT0ooK^0?ofkP0A0?ofkP030=@m6@3om^h0ooK^00/0ooK^00<000000?ofkP3om^h00P3om^h9
0=@m6@X0ooK^00@0e3dI0?ofkP3om^h0e3dI0P3om^h203eIZ`050?ofkP0mFJ/0?EV[0?ofkP0mFJ/0
1@2U;A<6000000X0YBdC00<000000:D]4`0mFJ/01P0000020;Hb5@030000002f<QD0]S8E00L0]S8E
00<0?EV[0000002f<QD02P2f<QD00`000000]S8E0;Hb5@030;Hb5@0303eIZ`2f<QD0]S8E00<0]S8E
00<000000;Hb5@2f<QD01`2f<QD00`000000]S8E0;Hb5@040;Hb5@0603eIZ`2f<QD0]S8E0;Hb5@00
0000]S8E0P0mFJ/50;Hb5@D000000P33=QL00`0mFJ/0`cHG0<<f5`030<<f5`0300000033=QL0`cHG
00P0`cHG0`0mFJ/80<<f5`0300000033=QL0`cHG00D0`cHG0P0mFJ/00`000000`cHG0<<f5`080<<f
5`80e3dI0P1@Lm801@000000D7?B00000019JK`000000080BFVl00<0000003mHVP0oF9X00P000000
100mFJ/0ooK^0?ofkP3D?AT?0?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3D?AT01@3D
?AT30?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?of
kP0@0?ofkP030=@m6@3om^h0e3dI00D0ooK^00<000000?ofkP000000F@3om^h10?ooo`004`3om^h0
0`000000ooK^0?ofkP0j0?ofkP030=@m6@3om^h0ooK^0140ooK^00<0e3dI0?ofkP3om^h0303om^h0
0`000000e3dI0=@m6@040=@m6A40ooK^00<0e3dI0?ofkP3D?AT00`3om^h00`0mFJ/0ooK^0?ofkP02
03eIZ`H00000102U;A<00`0mFJ/000000:D]4`070:D]4`D0000000<0?EV[0;Hb5@2f<QD01@2f<QD0
0`000000]S8E0;Hb5@070;Hb5@0303eIZ`2f<QD0000000X0]S8E00<000000;Hb5@2f<QD0102f<QD0
0`0mFJ/0]S8E0;Hb5@020;Hb5@030000002f<QD0]S8E00L0]S8E00<000000;Hb5@2f<QD0102f<QD0
100mFJ/0]S8E0;Hb5@2f<QD203eIZ`030;Hb5@000000000000@000000P33=QL00`000000`cHG0<<f
5`030<<f5`0303eIZ`33=QL0`cHG0080`cHG00<000000<<f5`33=QL01`33=QL01@0mFJ/000000<<f
5`33=QL0?EV[00L0`cHG00<000000<<f5`33=QL01@33=QL00`0mFJ/0`cHG0000000:0<<f5`090000
001@Lm80D7?B051cdP000000D7?B00000019JK`000000080BFVl00<0000003mHVP0oF9X00`000002
0?ofkP030=@m6@3om^h0ooK^00d0ooK^00@0e3dI0?ofkP3om^h0ooK^1`3D?AT90?ofkP030=@m6@3o
m^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP0@0?ofkP030=@m6@3o
m^h0e3dI00D0ooK^00<000000?ofkP000000F@3om^h10?ooo`004`3om^h00`000000ooK^0?ofkP0i
0?ofkP030=@m6@3om^h0ooK^0140ooK^00<0e3dI0?ofkP3om^h0203om^h60=@m6@030000003om^h0
ooK^0080e3dI4P3om^h00`3D?AT0ooK^0=@m6@020?ofkPH0000000<0ooK^03eIZ`2U;A<0202U;A<0
0`0mFJ/0YBdC0:D]4`0600000080]S8E00@000000;Hb5@2f<QD0?EV[1`2f<QD00`000000]S8E0;Hb
5@080;Hb5@0303eIZ`000000]S8E00T0]S8E00<000000;Hb5@2f<QD0102f<QD00`0mFJ/0]S8E0;Hb
5@020;Hb5@030000002f<QD0]S8E00L0]S8E00<000000;Hb5@2f<QD01@2f<QD303eIZ`<000002033
=QL00`000000`cHG0<<f5`030<<f5`0303eIZ`33=QL0`cHG0080`cHG00<000000<<f5`33=QL01P33
=QL00`0mFJ/0`cHG000000020<<f5`0303eIZ`33=QL0`cHG00D0`cHG00<000000<<f5`33=QL01033
=QL203eIZ`030<<f5`000000`cHG00P0`cHG00<00000051cdP1@Lm800P1@Lm8010000000D7?B0000
0000000304UY_0<000000P0oF9X01@000000ooK^0?ofkP3om^h0e3dI00/0ooK^1`3D?AT60?ofkP03
0=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP040?ofkP03
0=@m6@3om^h0ooK^00d0ooK^103D?AT00`3om^h0e3dI0?ofkP040?ofkP030000003om^h0000005T0
ooK^0@3oool001<0ooK^00<000000?ofkP3om^h0>@3om^h00`3D?AT0ooK^0?ofkP0A0?ofkP040=@m
6@3om^h0ooK^0?ofkPL0e3dI1P3om^h00`000000ooK^0?ofkP020=@m6A40ooK^1P0000020?ofkP06
03eIZ`3om^h0?EV[03eIZ`3om^h000000P0mFJ/50:D]4`<0000000<0?EV[0000002f<QD01`2f<QD0
1@000000]S8E0;Hb5@2f<QD0?EV[00L0]S8E00<000000;Hb5@2f<QD01`2f<QD00`0mFJ/000000;Hb
5@090;Hb5@030000002f<QD0]S8E00D0]S8E00D0?EV[0;Hb5@2f<QD0]S8E000000090;Hb5@030000
002f<QD0]S8E00@000000P0mFJ/20<<f5`0300000033=QL0`cHG00P0`cHG00<000000<<f5`33=QL0
0`33=QL00`0mFJ/0`cHG0<<f5`020<<f5`0300000033=QL0`cHG00@0`cHG0P0mFJ/20<<f5`050000
0033=QL0`cHG0<<f5`0mFJ/01P33=QL00`000000`cHG0<<f5`030<<f5`0503eIZ`33=QL0`cHG03eI
Z`0000002@33=QL01@000000D7?B051cdP1@Lm80000000<0D7?B00D0000004UY_019JK`0000004UY
_00200000080?eRJ00D0000003eIZ`3om^h0ooK^0=@m6@050?ofkPH0e3dI0`3om^h00`3D?AT0ooK^
0?ofkP070?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^
0?ofkP050?ofkP030=@m6@3om^h0ooK^00H0ooK^1P3D?AT30?ofkP030=@m6@3om^h0e3dI00H0ooK^
0P00001I0?ofkP40oooo000C0?ofkP030000003om^h0ooK^03T0ooK^00<0e3dI0?ofkP3om^h03`3o
m^h60=@m6@h0ooK^00D000000?ofkP3D?AT0ooK^0=@m6@0;0?ofkPD000000P3om^h00`3D?AT0ooK^
0?ofkP030?ofkP80?EV[00D0ooK^03eIZ`0mFJ/000000:D]4`0303eIZ`<000000P2f<QD00`000000
?EV[0;Hb5@090;Hb5@040000002f<QD0]S8E03eIZ`L0]S8E00<000000;Hb5@2f<QD0202f<QD00`0m
FJ/0]S8E0;Hb5@080;Hb5@030000002f<QD0]S8E00D0]S8E00D0?EV[0;Hb5@2f<QD0]S8E00000005
0;Hb5@L0000000H0`cHG03eIZ`0mFJ/0?EV[0<<f5`0mFJ/20<<f5`0300000033=QL0`cHG00P0`cHG
00<000000<<f5`33=QL01033=QL01@0mFJ/0`cHG0<<f5`33=QL0000000D0`cHG00<0?EV[0<<f5`33
=QL00P33=QL01@000000`cHG0<<f5`3D?AT0?EV[00H0`cHG00<000000<<f5`33=QL00P33=QL01@0m
FJ/0`cHG0<<f5`33=QL0?EV[00P0`cHG0`000003051cdP050000001@Lm80D7?B051cdP0000000P19
JK`010000000BFVl00000000000203mHVP030000000mFJ/0ooK^00L0e3dI2@3om^h00`3D?AT0ooK^
0?ofkP070?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^
0?ofkP040?ofkP030=@m6@3om^h0ooK^00H0e3dI2@3om^h0103D?AT0ooK^0?ofkP3D?AT50?ofkP80
0000F@3om^h10?ooo`004P3om^h00`000000ooK^0?ofkP0j0?ofkP030=@m6@3om^h0ooK^00X0ooK^
1@3D?AT20?ofkP030=@m6@3om^h0ooK^0100ooK^00@000000=@m6@3om^h0e3dI1@3om^h6000000L0
ooK^0P3D?AT50?ofkP@0?EV[0P0000000`0mFJ/0]S8E0;Hb5@0203eIZ`@0]S8E00<0000003eIZ`2f
<QD0202f<QD01@000000]S8E0;Hb5@2f<QD0?EV[00H0]S8E00<000000;Hb5@2f<QD0202f<QD00`0m
FJ/0]S8E0;Hb5@090;Hb5@030000002f<QD0]S8E00D0]S8E00<0?EV[0000000000001P0000040<<f
5`040000000mFJ/0?EV[03eIZ`D0`cHG00<0?EV[0<<f5`0000002P33=QL00`000000`cHG0<<f5`04
0<<f5`0503eIZ`33=QL0`cHG0<<f5`0000001033=QL00`0mFJ/0`cHG0<<f5`030<<f5`0500000033
=QL0`cHG0<<f5`0mFJ/01@33=QL00`000000`cHG0<<f5`030<<f5`0703eIZ`33=QL0`cHG0<<f5`00
0000?EV[0<<f5`0600000080cSXI00D00000051cdP1@Lm80D7?B00000003051cdP0500000019JK`0
BFVl00000019JK`00P00000203mHVP<0000000<0ooK^0=@m6@3om^h03P3om^h00`3D?AT0ooK^0?of
kP060?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h02`3om^h0103D?AT0ooK^0?of
kP3om^h60=@m6@l0ooK^00@0e3dI0?ofkP3om^h0e3dI1@3om^h00`000000ooK^0000001H0?ofkP40
oooo000B0?ofkP030000003om^h0ooK^03T0ooK^00<0e3dI0?ofkP3om^h01@3om^h60=@m6@L0ooK^
00<0e3dI0?ofkP3om^h0403om^h00`000000e3dI0?ofkP06000000d0ooK^0P3D?AT50?ofkP<0?EV[
00D0e3dI03eIZ`2f<QD0]S8E03eIZ`030;Hb5@80?EV[0P2f<QD00`000000?EV[0;Hb5@080;Hb5@03
0000002f<QD0]S8E0080]S8E00<0?EV[0;Hb5@2f<QD00`2f<QD00`000000]S8E0;Hb5@080;Hb5@03
0000000mFJ/0]S8E00T0]S8E00<000000;Hb5@2f<QD01@000000100mFJ/0`cHG0<<f5`0000060<<f
5`@0?EV[2033=QL00`0mFJ/0`cHG0000000:0<<f5`0300000033=QL0`cHG00@0`cHG00D0?EV[0<<f
5`33=QL0`cHG000000020<<f5`80?EV[1@33=QL00`000000`cHG0<<f5`030<<f5`0303eIZ`33=QL0
`cHG0080`cHG00<000000<<f5`33=QL00P33=QL00`0mFJ/0`cHG0<<f5`030000000303eIZ`000000
cSXI00H0cSXI00<0000005=hg`0000000P1@Lm8020000000D7?B051cdP000000D7?B00000019JK`0
00000P19JK`00`000000?eRJ03mHVP03000000030?ofkP3D?AT0ooK^00h0ooK^00<0e3dI0?ofkP3o
m^h01P3om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00T0ooK^1P3D?AT30?ofkP03
0=@m6@3om^h0ooK^0100ooK^00<0e3dI0?ofkP3D?AT01@3om^h00`000000ooK^0000001H0?ofkP40
oooo000B0?ofkP030000003om^h0ooK^03T0ooK^00<0e3dI0?ofkP3om^h01@3D?AT=0?ofkP030=@m
6@3om^h0ooK^00d0ooK^1P0000000`3om^h0e3dI0?ofkP0@0?ofkP030=@m6@3om^h0e3dI0080ooK^
0`3D?AT203eIZ`050?ofkP0mFJ/000000;Hb5@0mFJ/01@2f<QD203eIZ`030000002f<QD0?EV[00P0
]S8E00<000000;Hb5@2f<QD00P2f<QD00`0mFJ/0]S8E0;Hb5@030;Hb5@030000002f<QD0]S8E00T0
]S8E00<0?EV[0;Hb5@2f<QD01P2f<QD5000000H0`cHG00<0?EV[0<<f5`0000000`33=QL303eIZ`<0
`cHG00<000000<<f5`33=QL01`33=QL00`0mFJ/000000<<f5`090<<f5`0300000033=QL0`cHG00D0
`cHG00H0?EV[0<<f5`33=QL000000<<f5`0mFJ/70<<f5`0300000033=QL0`cHG00<0`cHG00<0?EV[
0<<f5`33=QL00P33=QL01@000000`cHG0<<f5`000000?EV[00<000000P3>>QT00`000000?EV[0<hj
6@070<hj6@050000001CN=l00000051cdP0000000`1@Lm801@000000D7?B00000019JK`000000080
BFVl00<0000003mHVP0oF9X00P0000000`0`@Vl000000=@m6@0?0?ofkP030=@m6@3om^h0ooK^00H0
ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP020?ofkPH0e3dI0P3om^h00`3D?AT0
ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00l0ooK^103D?AT50?ofkP030000003om^h0000005P0
ooK^0@3oool00180ooK^00<000000?ofkP3om^h0>@3om^h30=@m6A40ooK^00<0e3dI0?ofkP3om^h0
2@3om^h5000000<0ooK^00<0e3dI0?ofkP0000000P3om^h00`3D?AT0ooK^0?ofkP0>0?ofkPD0e3dI
0`3om^h303eIZ`050?ofkP0mFJ/0]S8E0;Hb5@0mFJ/01P2f<QD303eIZ`T0]S8E00<000000;Hb5@2f
<QD00P2f<QD00`0mFJ/0]S8E0;Hb5@020;Hb5@030000002f<QD0]S8E00T0]S8E00<0000003eIZ`2f
<QD01P0000020<<f5`0300000033=QL0`cHG00H0`cHG00<0?EV[0<<f5`0000000`0mFJ/70<<f5`03
00000033=QL0`cHG00H0`cHG00<0?EV[00000033=QL02@33=QL00`000000`cHG0<<f5`050<<f5`05
03eIZ`33=QL0`cHG0000000mFJ/02033=QL00`000000`cHG0<<f5`030<<f5`030000000mFJ/00000
00D0000000<0?EV[0<hj6@3>>QT00`3>>QT010000000cSXI0<hj6@0mFJ/70<hj6@050000001CN=l0
0000051cdP0000000`1@Lm801@000000D7?B00000019JK`000000080BFVl00<0000003mHVP0oF9X0
100000000`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h0
1`3om^h60=@m6@P0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP080?ofkPH0e3dI
00@0ooK^0=@m6@3om^h0e3dI1@3om^h00`000000ooK^0000001H0?ofkP40oooo000B0?ofkP030000
003om^h0ooK^03T0ooK^00<0e3dI0?ofkP3om^h04@3om^h00`3D?AT0ooK^0?ofkP030?ofkPH00000
203om^h00`3D?AT0ooK^000000020?ofkP030=@m6@3om^h0ooK^00P0ooK^1`3D?AT00`3om^h0e3dI
0?ofkP050?ofkP80?EV[00D0e3dI03eIZ`2f<QD0]S8E03eIZ`070;Hb5@030000000mFJ/0?EV[0080
?EV[1P2f<QD00`000000]S8E0;Hb5@020;Hb5@0303eIZ`2f<QD0]S8E00<0]S8E00<000000;Hb5@2f
<QD01P2f<QD30000000303eIZ`000000`cHG00L0`cHG00<000000<<f5`33=QL01@33=QL403eIZ`X0
`cHG00<000000<<f5`33=QL01`33=QL00`0mFJ/000000<<f5`080<<f5`0300000033=QL0`cHG00H0
`cHG0`0mFJ/70<<f5`P0000000<0cSXI03eIZ`3>>QT00P3>>QT00`000000cSXI03eIZ`060<hj6@04
0000003>>QT0cSXI03eIZ`H0cSXI00H0000005=hg`1CN=l00000051cdP000002051cdP030000001@
Lm80D7?B008000000`19JK`20000000303mHVP000000?eRJ0080000000<0e3dI0?ofkP3om^h03@3o
m^h00`3D?AT0ooK^0?ofkP070?ofkP040=@m6@3om^h0ooK^0?ofkPH0e3dI00<0ooK^0=@m6@3om^h0
2`3om^h00`3D?AT0ooK^0?ofkP050?ofkP040=@m6@3om^h0ooK^0?ofkPL0e3dI1`3om^h00`3D?AT0
ooK^0=@m6@060?ofkP800000F03om^h10?ooo`004@3om^h00`000000ooK^0?ofkP0j0?ofkP030=@m
6@3om^h0ooK^0140ooK^1P00000>0?ofkP040=@m6@3om^h0ooK^00000080ooK^00@0e3dI0?ofkP3o
m^h0ooK^1P3D?AT60?ofkP030=@m6@3om^h0ooK^00H0e3dI0`0mFJ/01@000000]S8E0;Hb5@2f<QD0
?EV[00H0]S8E00D000000;Hb5@2f<QD0?EV[0;Hb5@0503eIZ`030;Hb5@000000]S8E00@0]S8E00<0
?EV[0;Hb5@2f<QD00P2f<QD00`000000]S8E0;Hb5@0600000080`cHG00<000000<<f5`0mFJ/02033
=QL00`000000`cHG03eIZ`0503eIZ`80`cHG00<0?EV[00000033=QL02@33=QL00`000000`cHG0<<f
5`070<<f5`0303eIZ`000000`cHG00P0`cHG00<000000<<f5`33=QL01P33=QL00`0mFJ/0`cHG0000
00020<<f5`D000000P3>>QT00`000000cSXI0<hj6@040<hj6@0603eIZ`3>>QT0cSXI0<hj6@000000
?EV[1`3>>QT01@000000cSXI0<hj6@3>>QT0?EV[00D0cSXI00D0000005=hg`1CN=l0DgSO00000003
051cdP050000001@Lm80D7?B051cdP0000000P19JK`01P000000BFVl0000000oF9X0000003mHVP<0
000000<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP030?ofkPL0e3dI1`3om^h00`3D?AT0
ooK^0?ofkP0;0?ofkP040=@m6@3om^h0ooK^0?ofkPL0e3dI3P3om^h0103D?AT0ooK^0?ofkP3D?AT5
0?ofkP800000F03om^h10?ooo`004@3om^h00`000000ooK^0?ofkP0j0?ofkP030=@m6@3om^h0ooK^
00/0ooK^1P0000000`3D?AT0ooK^0?ofkP0A0?ofkP060=@m6@3om^h0ooK^0?ofkP000000ooK^103D
?AT:0?ofkPH0e3dI1P3om^h303eIZ`040000002f<QD0]S8E03eIZ`H0]S8E00@000000;Hb5@2f<QD0
?EV[1P2f<QD603eIZ`040;Hb5@0mFJ/0]S8E0;Hb5@D000002033=QL00`000000`cHG03eIZ`040<<f
5`H0?EV[2@33=QL00`0mFJ/0`cHG0<<f5`080<<f5`0300000033=QL0`cHG00L0`cHG00<0?EV[0000
0033=QL02033=QL00`000000`cHG0<<f5`040<<f5`<0?EV[100000070<hj6@030000003>>QT0cSXI
00D0cSXI00D0?EV[0<hj6@000000cSXI03eIZ`070<hj6@050000003>>QT0cSXI0<hj6@0mFJ/0103>
>QT00`000000DgSO05=hg`0205=hg`050000001@Lm80D7?B051cdP0000000`1@Lm8010000000BFVl
04UY_000000204UY_080000000D0?eRJ00000000000000000=@m6@0?0?ofkPH0e3dI0`3om^h00`3D
?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^00P0ooK^1P3D?AT30?ofkP030=@m6@3om^h0ooK^
00l0ooK^00@0e3dI0?ofkP3om^h0e3dI1@3om^h00`000000ooK^0000001G0?ofkP40oooo000A0?of
kP030000003om^h0ooK^03T0ooK^00<0e3dI0?ofkP3om^h01`3om^h5000000H0ooK^00<0e3dI0?of
kP3om^h04@3om^h01`3D?AT0ooK^0?ofkP3om^h000000?ofkP3D?AT01`3om^h60=@m6@80ooK^00@0
e3dI0?ofkP3om^h0e3dI1P3om^h403eIZ`<0]S8E00<0?EV[0;Hb5@2f<QD00`2f<QD01@000000]S8E
0;Hb5@2f<QD0?EV[00L0]S8E00@000000;Hb5@2f<QD00000600mFJ/50<<f5`0300000033=QL0`cHG
00L0`cHG00<0?EV[00000033=QL02033=QL00`000000`cHG0<<f5`080<<f5`0303eIZ`33=QL0`cHG
00L0`cHG00<000000<<f5`33=QL00P00000203eIZ`80000000<0cSXI03eIZ`0000002@3>>QT00`00
0000cSXI0<hj6@050<hj6@0403eIZ`3>>QT0000003eIZ`L0cSXI00<000000<hj6@3>>QT00P3>>QT0
1`0mFJ/0cSXI0<hj6@3>>QT0?EV[0000003D?AT00`1CN=l01@000000D7?B051cdP1@Lm80000000<0
D7?B00@0000004UY_019JK`000000P19JK`20000000503mHVP00000000000000003D?AT02@3om^h7
0=@m6@P0ooK^00<0e3dI0?ofkP3om^h02@3om^h0103D?AT0ooK^0?ofkP3om^h70=@m6@80ooK^00<0
e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP0@0?ofkP030=@m6@3om^h0e3dI00D0ooK^00<0
00000?ofkP000000E`3om^h10?ooo`004@3om^h00`000000ooK^0?ofkP0i0?ofkP040=@m6@3om^h0
ooK^0?ofkPH000002`3om^h00`3D?AT0ooK^0?ofkP0A0?ofkP030=@m6@3om^h0ooK^0080ooK^00@0
00000?ofkP3D?AT0ooK^1@3D?AT80?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT01P3om^h203eIZ`05
0000000mFJ/0]S8E0;Hb5@0mFJ/01P2f<QD010000000]S8E0;Hb5@0mFJ/20;Hb5@P000001033=QL0
1@0mFJ/0`cHG0<<f5`33=QL0000000X0`cHG00<000000<<f5`0mFJ/02033=QL00`000000`cHG0<<f
5`080<<f5`0303eIZ`33=QL0`cHG00L0`cHG00<000000<<f5`33=QL02033=QL00`0mFJ/0`cHG0<<f
5`030<<f5`L000000P0mFJ/50<hj6@0303eIZ`000000cSXI00L0cSXI00<000000<hj6@3>>QT01`3>
>QT203eIZ`P0cSXI00<000000<hj6@3>>QT00`3>>QT01P0mFJ/0cSXI03eIZ`3>>QT000000=@m6@80
DgSO00D0000005=hg`000000D7?B00000003051cdP050000001@Lm80000004UY_00000000`19JK`0
0`000000?eRJ00000002000000040=@m6@3om^h0ooK^0?ofkPH0e3dI1P3om^h00`3D?AT0ooK^0?of
kP060?ofkP030=@m6@3om^h0ooK^00H0ooK^1`3D?AT90?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0
e3dI0?ofkP3om^h0403om^h00`3D?AT0ooK^0=@m6@050?ofkP030000003om^h0000005L0ooK^0@3o
ool00100ooK^00<000000?ofkP3om^h0>03om^h600000140ooK^00<0e3dI0?ofkP3om^h04@3om^h0
0`3D?AT0ooK^0?ofkP060=@m6@d0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@070?ofkP80?EV[00D0
]S8E03eIZ`0mFJ/0]S8E03eIZ`030;Hb5@H0000000<0?EV[00000033=QL01033=QL00`000000`cHG
0<<f5`040<<f5`0503eIZ`33=QL0`cHG0<<f5`0000002P33=QL010000000`cHG0<<f5`0mFJ/70<<f
5`0300000033=QL0`cHG00P0`cHG00<0?EV[0<<f5`33=QL02033=QL00`000000`cHG0<<f5`050<<f
5`<0000000<0?EV[0000000000000P0000040<hj6@030000003>>QT0?EV[00P0cSXI00<0?EV[0<hj
6@3>>QT01P3>>QT00`000000cSXI0<hj6@070<hj6@0303eIZ`000000cSXI00L0cSXI00<000000<hj
6@3>>QT00`3>>QT01P0mFJ/0cSXI03eIZ`000000DgSO0=@m6@80DgSO00D0000005=hg`000000D7?B
00000003051cdP050000001@Lm80000004UY_00000000`19JK`00`000000?eRJ000000060=@m6@d0
ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP060=@m6@<0ooK^00<0e3dI0?ofkP3o
m^h02P3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3D
?AT01@3om^h00`000000ooK^0000001G0?ofkP40oooo000@0?ofkP030000003om^h0ooK^0380ooK^
1P0000020?ofkP030=@m6@3om^h0ooK^0140ooK^00<0e3dI0?ofkP3om^h03`3om^h60=@m6@<0ooK^
00<000000=@m6@3om^h03@3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00L0ooK^0P0mFJ/00`000000
]S8E0;Hb5@0203eIZ`<000000P33=QL00`000000`cHG0<<f5`020<<f5`0303eIZ`33=QL0`cHG00@0
`cHG00<000000<<f5`33=QL01033=QL0100mFJ/0`cHG0<<f5`00000:0<<f5`0400000033=QL0`cHG
03eIZ`L0`cHG00<000000<<f5`33=QL02033=QL00`000000?EV[0<<f5`080<<f5`0300000033=QL0
`cHG00D000000P3>>QT00`000000?EV[0<hj6@070<hj6@80?EV[2@3>>QT00`0mFJ/0cSXI0<hj6@06
0<hj6@030000003>>QT0cSXI00D0cSXI0`0mFJ/80<hj6@030000003>>QT0cSXI00D0cSXI00L0?EV[
0<hj6@000000DgSO0=@m6@1CN=l000000080DgSO00<00000051cdP0000000`1@Lm801@000000D7?B
00000019JK`0000000H0e3dI0P0000000`3D?AT0ooK^0?ofkP0>0?ofkP040=@m6@3om^h0ooK^0?of
kPL0e3dI2@3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?of
kP3om^h03`3om^h0103D?AT0ooK^0?ofkP3D?AT50?ofkP800000E`3om^h10?ooo`00403om^h00`00
0000ooK^0?ofkP0/0?ofkPH00000203om^h00`3D?AT0ooK^0?ofkP0A0?ofkP030=@m6@3om^h0ooK^
00P0ooK^1`3D?AT30?ofkP030=@m6@3om^h0ooK^00@0ooK^00<000000=@m6@3om^h0303om^h00`3D
?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00D0ooK^0P0mFJ/2000000030<<f5`0mFJ/0?EV[
00D0`cHG00D000000<<f5`33=QL0`cHG03eIZ`060<<f5`0300000033=QL0`cHG00@0`cHG00D0?EV[
0<<f5`33=QL0`cHG0000000:0<<f5`0400000033=QL0`cHG03eIZ`H0`cHG00<000000<<f5`33=QL0
2033=QL00`000000?EV[0<<f5`060<<f5`D000001`3>>QT00`000000cSXI03eIZ`050<hj6@80?EV[
00<000000<hj6@3>>QT0203>>QT00`0mFJ/0cSXI0<hj6@060<hj6@030000003>>QT0cSXI00@0cSXI
00D0?EV[0<hj6@3>>QT0000003eIZ`070<hj6@030000003>>QT0cSXI00D0cSXI00L0?EV[0<hj6@00
0000DgSO0=@m6@1CN=l0000000<0DgSO00@00000051cdP1@Lm80D7?B1P3D?AT304UY_0<0000000<0
?eRJ0000003D?AT03P3om^h60=@m6@D0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?of
kP0;0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h03`3om^h0103D?AT0ooK^0?of
kP3D?AT50?ofkP800000E`3om^h10?ooo`00403om^h00`000000ooK^0?ofkP0W0?ofkPD000003P3o
m^h00`3D?AT0ooK^0?ofkP0A0?ofkP040=@m6@3om^h0ooK^0?ofkPL0e3dI2P3om^h00`3D?AT0ooK^
0?ofkP040?ofkP030000003D?AT0ooK^00`0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^
0?ofkP050?ofkP<0?EV[0`33=QL00`0mFJ/0`cHG0<<f5`030<<f5`0300000033=QL0`cHG0080`cHG
00<0?EV[0<<f5`33=QL00`33=QL00`000000`cHG0<<f5`050<<f5`0403eIZ`33=QL0`cHG000000X0
`cHG00@000000<<f5`33=QL0?EV[1`33=QL00`000000`cHG0<<f5`070<<f5`0300000033=QL0?EV[
00H000000P3>>QT00`000000cSXI0<hj6@070<hj6@030000003>>QT0?EV[00<0cSXI0P0mFJ/20<hj
6@030000003>>QT0cSXI00P0cSXI00<0000003eIZ`3>>QT01P3>>QT00`000000cSXI0<hj6@030<hj
6@0603eIZ`3>>QT0cSXI0<hj6@000000?EV[1`3>>QT00`000000cSXI0<hj6@040<hj6@80?EV[00L0
000005=hg`1CN=l0e3dI05=hg`000000DgSO00H0e3dI00D00000051cdP1@Lm80D7?B0000000304UY
_00800000019JK`000000000000oF9X0000003eIZ`3D?AT80?ofkPD0e3dI0P3om^h00`3D?AT0ooK^
0?ofkP060?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^
0?ofkP040?ofkP030=@m6@3om^h0ooK^00l0ooK^00@0e3dI0?ofkP3om^h0e3dI1@3om^h00`000000
ooK^0000001F0?ofkP40oooo000@0?ofkP030000003om^h0ooK^0240ooK^1P00000C0?ofkP030=@m
6@3om^h0ooK^00l0ooK^1P3D?ATA0?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h0
2`3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00H0ooK^0P0mFJ/40<<f5`80?EV[
1033=QL01@000000`cHG0<<f5`33=QL0?EV[00H0`cHG00<000000<<f5`33=QL01033=QL0100mFJ/0
`cHG0<<f5`00000:0<<f5`0500000033=QL0`cHG0<<f5`0mFJ/01P33=QL00`000000`cHG0<<f5`05
0<<f5`@0000000<0?EV[0<hj6@3>>QT01P3>>QT00`000000cSXI0<hj6@070<hj6@030000003>>QT0
cSXI00<0?EV[103>>QT00`000000cSXI0<hj6@070<hj6@030000003>>QT0?EV[00L0cSXI00@00000
0<hj6@3>>QT0cSXI0P0mFJ/40<hj6@030000000mFJ/0cSXI00H0cSXI00<000000<hj6@3>>QT00`3>
>QT00`0mFJ/0000003eIZ`070=@m6@80DgSO00D00000051cdP1@Lm80D7?B00000003051cdP060000
0019JK`0BFVl04UY_0000000BFVl0P000000100oF9X000000000003D?AT30?ofkPD0e3dI1`3om^h0
0`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h02P3om^h0
0`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^0100ooK^00<0e3dI0?ofkP3D?AT01@3om^h0
0`000000ooK^0000001F0?ofkP40oooo000?0?ofkP030000003om^h0ooK^01`0ooK^1P00000H0?of
kP030=@m6@3om^h0ooK^00/0ooK^1@3D?AT20?ofkP030=@m6@3om^h0ooK^0180ooK^00<0e3dI0?of
kP3om^h01P3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00<0ooK^00@0e3dI0?of
kP3om^h0ooK^1@3D?AT203eIZ`@0`cHG0`0mFJ/20<<f5`0300000033=QL0`cHG0080`cHG00<0?EV[
0<<f5`33=QL00`33=QL00`000000`cHG0<<f5`050<<f5`0403eIZ`33=QL0`cHG000000T0`cHG00D0
00000<<f5`33=QL0`cHG03eIZ`060<<f5`0300000033=QL0`cHG00D000000P3>>QT010000000cSXI
0<hj6@0mFJ/70<hj6@030000003>>QT0cSXI00L0cSXI00@000000<hj6@0mFJ/0?EV[1P3>>QT00`00
0000cSXI0<hj6@070<hj6@040000003>>QT0cSXI03eIZ`H0cSXI00@000000<hj6@3>>QT0?EV[1@3>
>QT010000000cSXI0<hj6@0mFJ/50<hj6@030000003>>QT0cSXI00<0000000D0?EV[0000003H?AX0
f3dJ0000000205=hg`030=@m6@000000DgSO0080DgSO00<0000005=hg`0000000P1@Lm801@000000
D7?B051cdP1@Lm80000000<0BFVl00D0000004UY_019JK`0000003mHVP02000000@0e3dI303om^h0
0`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h02P3om^h0
0`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^0100ooK^00@0e3dI0?ofkP3om^h0e3dI103o
m^h00`000000ooK^0000001F0?ofkP40oooo000?0?ofkP030000003om^h0ooK^01H0ooK^1P00000N
0?ofkP030=@m6@3om^h0ooK^00D0ooK^1P3D?AT70?ofkP030=@m6@3om^h0ooK^0180ooK^00<0e3dI
0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP040=@m6@3om^h0ooK^0?ofkPH0e3dI1@3o
m^h203eIZ`@0`cHG00<0?EV[0<<f5`33=QL00P0mFJ/00`000000`cHG0<<f5`030<<f5`0303eIZ`33
=QL0`cHG00<0`cHG00<000000<<f5`33=QL01033=QL0100mFJ/0`cHG0<<f5`00000:0<<f5`060000
0033=QL0`cHG0<<f5`0mFJ/0`cHG1`0000070<hj6@040000003>>QT0cSXI03eIZ`L0cSXI00<00000
0<hj6@3>>QT01P3>>QT303eIZ`030<hj6@0mFJ/0cSXI00D0cSXI00<000000<hj6@3>>QT01`3>>QT0
10000000cSXI0<hj6@0mFJ/50<hj6@040000003>>QT0cSXI03eIZ`H0cSXI00D000000<hj6@3>>QT0
?EV[0<hj6@0700000080f3dJ00X0?EV[0=Pm6P3H?AX0f3dJ0000001DNnH0000005=hg`3D?AT00000
0`1CN=l00`000000DgSO00000002051cdP060000001@Lm80D7?B0000001@Lm8000000P19JK`01@00
0000BFVl04UY_0000000?eRJ0080000000<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP05
0?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP04
0?ofkP030=@m6@3om^h0ooK^00d0ooK^103D?AT20?ofkP030=@m6@3om^h0ooK^0080ooK^00<00000
0?ofkP000000EP3om^h10?ooo`003`3om^h00`000000ooK^0?ofkP0A0?ofkPD00000903om^h00`3D
?AT0ooK^0?ofkP050=@m6@d0ooK^00<0e3dI0?ofkP3om^h04P3om^h00`3D?AT0ooK^0?ofkP060?of
kP030=@m6@000000ooK^00P0ooK^1P3D?AT20?ofkP030=@m6@3om^h0ooK^00L0ooK^0P0mFJ/40<<f
5`0403eIZ`33=QL0`cHG0<<f5`<0?EV[0`33=QL00`0mFJ/0`cHG0<<f5`030<<f5`0300000033=QL0
`cHG00D0`cHG00<0?EV[0<<f5`0000002033=QL60000000303eIZ`000000cSXI00<0cSXI00<00000
0<hj6@3>>QT0203>>QT010000000cSXI0<hj6@0mFJ/60<hj6@030000003>>QT0cSXI00<0cSXI0`0m
FJ/00`3>>QT000000<hj6@020<hj6@0303eIZ`3>>QT0cSXI00<0cSXI00<000000<hj6@3>>QT01`3>
>QT010000000cSXI0<hj6@0mFJ/50<hj6@030000000mFJ/0?EV[00D0cSXI1@0000000`0mFJ/00000
0=Pm6P030=Pm6P050000003H?AX0f3dJ0=Pm6P0mFJ/0103H?AX01P000000E7_V0000001CN=l00000
0=@m6@80DgSO00D0000005=hg`1CN=l0DgSO00000004051cdP030000001@Lm8000000080BFVl00D0
000004UY_019JK`0000003mHVP02000000030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h0
1@3om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h0
103om^h00`3D?AT0ooK^0?ofkP070?ofkPH0e3dI0`3om^h40=@m6@D0ooK^0P00001F0?ofkP40oooo
000?0?ofkP030000003om^h0ooK^00/0ooK^1P00000Y0?ofkP<0e3dI4P3om^h00`3D?AT0ooK^0?of
kP0B0?ofkP030=@m6@3om^h0ooK^00L0ooK^00@0e3dI0000003om^h0ooK^1P3D?AT20?ofkP030=@m
6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h01P3om^h203eIZ`D0`cHG00H0?EV[0<<f5`33=QL0
`cHG00000033=QL203eIZ`80`cHG00<0?EV[0<<f5`33=QL00P33=QL00`000000`cHG0<<f5`050<<f
5`0403eIZ`33=QL0`cHG00000080`cHG1@0000020<hj6@030000003>>QT0cSXI0080cSXI00<0?EV[
0<hj6@3>>QT00`3>>QT00`000000cSXI0<hj6@070<hj6@040000003>>QT0cSXI03eIZ`H0cSXI00<0
00000<hj6@3>>QT00`0mFJ/50<hj6@040000003>>QT0cSXI03eIZ`D0cSXI00<000000<hj6@3>>QT0
1`3>>QT01@000000cSXI0<hj6@3>>QT0?EV[00@0cSXI00<0?EV[0<hj6@3>>QT01@0000020=Pm6P05
0000003H?AX0f3dJ0=Pm6P0mFJ/00`3H?AX01@000000f3dJ0=Pm6P3H?AX0?EV[00@0f3dJ00L00000
05AkiP1DNnH0000005=hg`000000e3dI0080DgSO00D0000005=hg`1CN=l0DgSO00000004051cdP03
0000001@Lm80D7?B008000000`19JK`30000000303mHVP3D?AT0000000l0ooK^00<0e3dI0?ofkP3o
m^h01@3om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3o
m^h0103om^h00`3D?AT0ooK^0?ofkP060=@m6@D0ooK^1@3D?AT20?ofkP030=@m6@3om^h0ooK^00<0
ooK^0P00001F0?ofkP40oooo000>0?ofkP030000003om^h0ooK^00H0ooK^1P00000_0?ofkP030=@m
6@3om^h0ooK^0180ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP060?ofkP@0e3dI
203om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00L0ooK^0P0mFJ/40<<f5`0303eI
Z`33=QL0`cHG0080`cHG00<000000<<f5`33=QL00`0mFJ/50<<f5`0300000033=QL0`cHG00<0`cHG
0P0000000`0mFJ/0000000000002000000P0cSXI00D000000<hj6@3>>QT0cSXI03eIZ`050<hj6@03
0000003>>QT0cSXI00L0cSXI00D000000<hj6@3>>QT0cSXI03eIZ`050<hj6@<0?EV[203>>QT01@00
0000cSXI0<hj6@3>>QT0?EV[00@0cSXI00<000000<hj6@3>>QT01`3>>QT01@000000cSXI0<hj6@3>
>QT0?EV[0080cSXI00<0000003eIZ`0000000P0000060=Pm6P030000003H?AX0f3dJ0080f3dJ00D0
?EV[0=Pm6P3H?AX0f3dJ000000020=Pm6P0303eIZ`3H?AX0f3dJ00<0f3dJ00L0000005AkiP1DNnH0
E7_V0000001CN=l0e3dI0080DgSO00<0000005=hg`1CN=l00P1CN=l01@000000D7?B051cdP1@Lm80
00000080D7?B0P00000204UY_00700000019JK`000000000000oF9X000000=@m6@0?0?ofkP030=@m
6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP040=@m
6@3om^h0ooK^0?ofkPH0e3dI1@3om^h60=@m6@D0ooK^00<0e3dI0?ofkP3D?AT01@3om^h00`000000
ooK^0000001E0?ofkP40oooo000>0?ofkP030000003om^h0ooK^00H00000=@3om^h00`3D?AT0ooK^
0?ofkP0B0?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^
000000090?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h01@3om^h30=@m6@80?EV[
1033=QL01@0mFJ/0`cHG0<<f5`33=QL0000000@0`cHG100mFJ/800000080cSXI00<0?EV[0<hj6@00
00002P3>>QT00`000000cSXI0<hj6@020<hj6@0303eIZ`3>>QT0cSXI0080cSXI00<000000<hj6@3>
>QT01`3>>QT01@000000cSXI0<hj6@3>>QT0?EV[0080cSXI0`0mFJ/00`3>>QT000000<hj6@080<hj
6@050000003>>QT0cSXI0<hj6@0mFJ/0103>>QT00`000000cSXI0<hj6@070<hj6@030000003>>QT0
cSXI008000000`0mFJ/00`3H?AX000000=Pm6P070=Pm6P030000003H?AX0f3dJ00<0f3dJ00H0?EV[
0=Pm6P3H?AX000000=Pm6P0mFJ/60=Pm6P090000001DNnH0E7_V05AkiP000000DgSO0=@m6@1CN=l0
000000@0DgSO0P000002051cdP030000001@Lm80D7?B0080D7?B00D0000004UY_019JK`0000004UY
_0020000000303mHVP000000e3dI00l0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?of
kP080?ofkP030=@m6@3om^h0ooK^00P0ooK^1`3D?AT30?ofkP030=@m6@3om^h0ooK^00D0e3dI2`3o
m^h00`3D?AT0ooK^0=@m6@050?ofkP030000003om^h0000005D0ooK^0@3oool000h0ooK^0`00000k
0?ofkP030=@m6@3om^h0ooK^0180ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP07
0?ofkP030=@m6@3om^h0000000P0ooK^00<0e3dI0?ofkP3om^h01@3om^h70=@m6@<0ooK^00@00000
03eIZ`0mFJ/0?EV[0P33=QL00`0mFJ/0`cHG0<<f5`020<<f5`0300000033=QL0`cHG00<0000000<0
?EV[0000000mFJ/0100mFJ/60<hj6@0303eIZ`3>>QT0000000X0cSXI00D000000<hj6@3>>QT0cSXI
03eIZ`050<hj6@030000003>>QT0cSXI00L0cSXI00<000000<hj6@0mFJ/00`0mFJ/40<hj6@030000
003>>QT0cSXI00L0cSXI00<000000<hj6@3>>QT00P3>>QT01@0mFJ/0cSXI0<hj6@3>>QT0000000D0
cSXI1`0000020=Pm6P0503eIZ`3H?AX0f3dJ0=Pm6P000000203H?AX00`000000f3dJ0=Pm6P030=Pm
6P0503eIZ`3H?AX000000=Pm6P0mFJ/01P3H?AX00`000000E7_V05AkiP0205AkiP050000001CN=l0
e3dI05=hg`000000101CN=l01@000000DgSO0000001@Lm80000000@0D7?B00D0000004UY_019JK`0
000004UY_0020000000403mHVP000000e3dI000000h0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D
?AT0ooK^0?ofkP090?ofkP040=@m6@3om^h0ooK^0?ofkPH0e3dI0`3om^h0103D?AT0ooK^0?ofkP3o
m^h60=@m6A00ooK^00@0e3dI0?ofkP3om^h0e3dI103om^h00`000000ooK^0000001E0?ofkP40oooo
000?0?ofkP030000003om^h0ooK^03X0ooK^00<0e3dI0?ofkP3om^h04P3om^h00`3D?AT0ooK^0?of
kP0C0?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP000000203om^h00`3D?AT0ooK^0?of
kP060=@m6@T0ooK^00D000000<<f5`0mFJ/0`cHG03eIZ`020<<f5`0303eIZ`33=QL0000000@00000
0`3>>QT00`0mFJ/0cSXI0<hj6@020<hj6@030000003>>QT0?EV[00@0?EV[00@0cSXI03eIZ`3>>QT0
00002P3>>QT00`000000cSXI0<hj6@020<hj6@0303eIZ`3>>QT0cSXI0080cSXI00<000000<hj6@3>
>QT00`3>>QT603eIZ`80cSXI00<0?EV[0<hj6@3>>QT00`3>>QT00`000000cSXI0<hj6@070<hj6@03
0000003>>QT0cSXI0080cSXI00<0?EV[0<hj6@0000001`0000040=Pm6P030000003H?AX0f3dJ00<0
?EV[0`3H?AX00`000000f3dJ0=Pm6P060=Pm6P030000003H?AX0f3dJ00<0f3dJ00@0?EV[0=Pm6P00
0000?EV[1`3H?AX02P000000E7_V05AkiP1DNnH0000005AkiP000000e3dI05=hg`00000305=hg`06
0000001CN=l0DgSO0000001@Lm8000000`1@Lm801@000000D7?B00000019JK`000000080BFVl00D0
000003mHVP000000e3dI03eIZ`0>0?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h0
1`3om^h60=@m6@L0ooK^1P3D?AT30?ofkP030=@m6@3om^h0ooK^0100ooK^00@0e3dI0?ofkP3om^h0
e3dI103om^h00`000000ooK^0000001E0?ofkP40oooo000@0?ofkP030000003om^h0ooK^03T0ooK^
00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP0B0?ofkP030=@m6@3om^h0ooK^00L0ooK^
00@0e3dI0?ofkP3om^h00000103om^h60=@m6@D0ooK^00<0e3dI0?ofkP3om^h0203om^h01@000000
`cHG03eIZ`000000?EV[0080000000D0?EV[0<hj6@3>>QT0cSXI000000050<hj6@0503eIZ`3>>QT0
cSXI0<hj6@0000001P3>>QT;03eIZ`<0cSXI00<000000<hj6@3>>QT00P3>>QT00`0mFJ/0cSXI0<hj
6@020<hj6@H0?EV[103>>QT00`000000cSXI0<hj6@020<hj6@0303eIZ`3>>QT0cSXI0080cSXI00<0
00000<hj6@3>>QT01`3>>QT00`000000cSXI0<hj6@020000000503eIZ`000000f3dJ0=Pm6P000000
2@3H?AX00`000000?EV[03eIZ`030=Pm6P0303eIZ`3H?AX0000000P0f3dJ00<000000=Pm6P3H?AX0
1@3H?AX203eIZ`L0f3dJ00<0000005AkiP1DNnH00P1DNnH01@000000E7_V0000001CN=l0e3dI00@0
DgSO00H0000005=hg`1CN=l00000051cdP000003051cdP050000001@Lm80000004UY_00000000P19
JK`01@000000?eRJ0000003D?AT0?EV[00h0ooK^00<0e3dI0?ofkP3om^h01P3om^h0103D?AT0ooK^
0?ofkP3om^h60=@m6@80ooK^00@0e3dI0?ofkP3om^h0ooK^1`3D?AT30?ofkP030=@m6@3om^h0ooK^
00<0ooK^00<0e3dI0?ofkP3om^h0403om^h0103D?AT0ooK^0?ofkP3D?AT50?ofkP800000E@3om^h1
0?ooo`004@3om^h00`000000ooK^0?ofkP0h0?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?of
kP3om^h04P3om^h00`3D?AT0ooK^0?ofkP080?ofkPL0e3dI0`3om^h00`3D?AT0ooK^0?ofkP050?of
kP030=@m6@3om^h0ooK^00P0ooK^0P0000001P0mFJ/0cSXI0<hj6@0mFJ/0cSXI03eIZ`<0cSXI00<0
00000<hj6@3>>QT00`3>>QT00`0mFJ/0cSXI0<hj6@020<hj6@030000003>>QT0cSXI00H0cSXI00<0
?EV[0000003>>QT01@3>>QT=03eIZ`030<hj6@000000cSXI00L0cSXI00<000000<hj6@3>>QT00P3>
>QT00`0mFJ/0cSXI0<hj6@020<hj6@030000003>>QT0cSXI00<0cSXI1`0000030=Pm6P0403eIZ`3H
?AX0f3dJ000000P0f3dJ0P0mFJ/50=Pm6P0303eIZ`3H?AX0000000P0f3dJ00<000000=Pm6P3H?AX0
1@3H?AX00`0mFJ/0f3dJ0=Pm6P060=Pm6P050000001DNnH0E7_V05AkiP0000000P1DNnH00`000000
DgSO0=@m6@0305=hg`030000001CN=l0DgSO0080DgSO00<00000051cdP1@Lm800P1@Lm801@000000
D7?B00000019JK`000000080BFVl00@0000003mHVP000000e3dI0P00000>0?ofkP030=@m6@3om^h0
ooK^0080ooK^1`3D?AT50?ofkPL0e3dI2P3om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0
ooK^0100ooK^00@0e3dI0?ofkP3om^h0e3dI1@3om^h2000005D0ooK^0@3oool00140ooK^00<00000
0?ofkP3om^h0>03om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^0180ooK^00@0e3dI
0?ofkP3om^h0ooK^203D?AT20?ofkP030000003om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h01P3o
m^h00`3D?AT0ooK^0?ofkP080?ofkP030000003>>QT0?EV[0080cSXI00<0?EV[0<hj6@0mFJ/00`3>
>QT00`000000cSXI0<hj6@030<hj6@0503eIZ`3>>QT0cSXI0<hj6@000000203>>QT00`0mFJ/00000
0<hj6@090<hj6@030000003>>QT0cSXI0080cSXI00<0?EV[0<hj6@3>>QT00P3>>QT00`000000cSXI
0<hj6@070<hj6@030000003>>QT0cSXI0080cSXI00<0?EV[0<hj6@0000001`0000040=Pm6P030000
003H?AX0f3dJ00<0f3dJ00@0?EV[0=Pm6P3H?AX000001P3H?AX203eIZ`030000003H?AX0f3dJ00D0
f3dJ00<0?EV[0000003H?AX01`3H?AX00`000000f3dJ0=Pm6P040=Pm6P80?EV[203H?AX01@000000
E7_V05AkiP1DNnH0000000<0E7_V00<000000=@m6@1CN=l00P1CN=l00`000000DgSO05=hg`0205=h
g`050000001@Lm80D7?B051cdP0000000P1@Lm82000000<0BFVl0`0000000`0oF9X0e3dI03eIZ`0;
0?ofkPP0e3dI0`3om^h00`3D?AT0ooK^0?ofkP060=@m6@<0ooK^00<0e3dI0?ofkP3om^h02`3om^h0
0`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^0100ooK^00<0e3dI0?ofkP3D?AT01@3om^h0
0`000000ooK^0000001D0?ofkP40oooo000B0?ofkP030000003om^h0ooK^03P0ooK^00<0e3dI0?of
kP3om^h04P3om^h00`3D?AT0ooK^0?ofkP0@0?ofkPH0e3dI1`3om^h01@3D?AT0ooK^0?ofkP3om^h0
000000D0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP080?ofkP030000003>>QT0
?EV[00<0cSXI0`0mFJ/20<hj6@030000003>>QT0cSXI00<0cSXI00<0?EV[0<hj6@3>>QT00P3>>QT0
0`000000cSXI0<hj6@060<hj6@0303eIZ`000000cSXI00P0cSXI00<000000<hj6@3>>QT00`3>>QT0
1@0mFJ/0cSXI0<hj6@3>>QT0000000T0cSXI00<000000<hj6@3>>QT00P0000001@0mFJ/000000=Pm
6P3H?AX0000000T0f3dJ00<000000=Pm6P3H?AX0103H?AX00`0mFJ/0f3dJ000000040=Pm6P80?EV[
0P3H?AX00`000000f3dJ0=Pm6P050=Pm6P0303eIZ`000000f3dJ00L0f3dJ00<000000=Pm6P3H?AX0
0P3H?AX203eIZ`030000003H?AX0?EV[00H0f3dJ00D0000005AkiP1DNnH0E7_V0000000405AkiP05
0000003D?AT0DgSO05=hg`000000101CN=l2000000<0D7?B00D00000051cdP1@Lm80D7?B00000002
04UY_00700000019JK`000000000000oF9X0e3dI03eIZ`030?ofkPP0e3dI0`3om^h0103D?AT0ooK^
0?ofkP3om^h70=@m6@T0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP040?ofkP03
0=@m6@3om^h0ooK^0100ooK^00<0e3dI0?ofkP3D?AT01@3om^h00`000000ooK^0000001D0?ofkP40
oooo000C0?ofkP030000003om^h0ooK^03L0ooK^00<0e3dI0?ofkP3om^h04P3om^h00`3D?AT0ooK^
0?ofkP0;0?ofkPD0e3dI0P3om^h00`3D?AT0ooK^0?ofkP080?ofkP050=@m6@3om^h0ooK^0?ofkP00
00001@3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00P0ooK^00@0e3dI0000003>
>QT0?EV[103>>QT01@0mFJ/0cSXI0<hj6@3>>QT0000000D0cSXI00D0?EV[0<hj6@3>>QT0cSXI0000
00080<hj6@0303eIZ`000000cSXI00T0cSXI00<000000<hj6@3>>QT00P3>>QT00`0mFJ/0cSXI0<hj
6@020<hj6@030000003>>QT0cSXI0080cSXI1`0000030=Pm6P0403eIZ`3H?AX0f3dJ000000T0f3dJ
00<000000=Pm6P3H?AX0103H?AX00`0mFJ/0f3dJ000000020=Pm6P80?EV[103H?AX00`000000f3dJ
0=Pm6P060=Pm6P0303eIZ`3H?AX0f3dJ00D0f3dJ00<000000=Pm6P3H?AX00P3H?AX01P0mFJ/0f3dJ
0=Pm6P000000f3dJ03eIZ`H0f3dJ00D0000005AkiP1DNnH0E7_V0000000305AkiP80000000@0e3dI
05=hg`1CN=l00000101CN=l01@000000DgSO0000001@Lm80000000@0D7?B00H0000004UY_019JK`0
000004UY_00000070=@m6@P0ooK^1`3D?AT50?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?of
kP3om^h02`3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^0100ooK^00<0e3dI0?of
kP3D?AT01@3om^h00`000000ooK^0000001D0?ofkP40oooo000D0?ofkP030000003om^h0ooK^03H0
ooK^00<0e3dI0?ofkP3om^h04P3om^h00`3D?AT0ooK^0?ofkP050?ofkPH0e3dI1`3om^h00`3D?AT0
ooK^0?ofkP090?ofkP050=@m6@3om^h0ooK^0?ofkP0000001@3om^h00`3D?AT0ooK^0?ofkP060?of
kP040=@m6@3om^h0ooK^0?ofkPH0e3dI0P3om^h00`000000cSXI03eIZ`040<hj6@80?EV[00<0cSXI
0000003>>QT01@3>>QT01@0mFJ/0cSXI0<hj6@3>>QT0000000P0cSXI00<0?EV[0000003>>QT0203>
>QT00`000000cSXI0<hj6@030<hj6@0303eIZ`3>>QT0000000H00000103H?AX00`000000f3dJ0=Pm
6P030=Pm6P0503eIZ`3H?AX0f3dJ0=Pm6P000000203H?AX00`000000f3dJ0=Pm6P050=Pm6P0403eI
Z`000000?EV[03eIZ`H0f3dJ00<000000=Pm6P3H?AX01P3H?AX00`0mFJ/0f3dJ0=Pm6P050=Pm6P05
0000003H?AX0f3dJ0=Pm6P0mFJ/00`3H?AX010000000f3dJ0=Pm6P0mFJ/40=Pm6P030000001DNnH0
E7_V0080E7_V00T0000005AkiP1DNnH0E7_V0000001DNnH0e3dI05=hg`000000101CN=l01P000000
DgSO05=hg`000000D7?B000000@0D7?B1P3D?AT00`000000?eRJ0=@m6@0200000080ooK^203D?AT3
0?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP0:
0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h0403om^h0103D?AT0ooK^0?ofkP3D
?AT30?ofkP@00000E03om^h10?ooo`005@3om^h00`000000ooK^0?ofkP0e0?ofkP030=@m6@3om^h0
ooK^0180ooK^00<0e3dI0?ofkP3om^h01@3D?AT=0?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI
0?ofkP3om^h00P3om^h00`000000ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00@0ooK^1P3D?AT8
0?ofkP80000000<0?EV[0<hj6@3>>QT00`3>>QT303eIZ`030000003>>QT0cSXI00<0cSXI00D0?EV[
0<hj6@3>>QT0cSXI000000020<hj6@030=@m6@3>>QT0cSXI00<0cSXI00<0?EV[0000003>>QT02@3>
>QT00`000000cSXI0<hj6@020000000503eIZ`000000f3dJ0=Pm6P000000203H?AX00`000000f3dJ
0=Pm6P040=Pm6P0403eIZ`3H?AX0f3dJ000000P0f3dJ00<000000=Pm6P3H?AX0103H?AX303eIZ`P0
f3dJ00<000000=Pm6P3H?AX01P3H?AX00`0mFJ/0f3dJ0=Pm6P050=Pm6P040000003H?AX0f3dJ03eI
Z`<0f3dJ00D000000=Pm6P3H?AX0f3dJ03eIZ`05000000<0E7_V00D0000005AkiP1DNnH0E7_V0000
000205AkiP030000003D?AT0000000@0DgSO00@0000005=hg`1CN=l000001P3D?AT0101@Lm800000
04UY_000000204UY_0030000000oF9X0e3dI008000000P3D?AT;0?ofkP030=@m6@3om^h0ooK^00H0
ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00<0
ooK^00<0e3dI0?ofkP3om^h0403om^h0103D?AT000000000003D?AT300000080ooK^0P00001D0?of
kP40oooo000F0?ofkP030000003om^h0ooK^03@0ooK^00<0e3dI0?ofkP3om^h03`3om^h60=@m6A80
ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP020?ofkP030000003om^h0ooK^0080
ooK^1`3D?AT20?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0000003eIZ`0mFJ/0103>>QT00`0mFJ/0
cSXI0<hj6@0203eIZ`D0cSXI00D0?EV[0<hj6@3>>QT0cSXI000000080<hj6@0303eIZ`000000cSXI
00@0cSXI1`0000030=Pm6P0503eIZ`3H?AX0f3dJ0=Pm6P000000203H?AX00`000000f3dJ0=Pm6P03
0=Pm6P0403eIZ`3H?AX0f3dJ000000P0f3dJ00@000000=Pm6P3H?AX0f3dJ0`0mFJ/00`3H?AX0?EV[
000000080=Pm6P030000003H?AX0f3dJ00D0f3dJ00<000000=Pm6P0mFJ/01P3H?AX00`000000?EV[
03eIZ`030=Pm6PH0000000<0?EV[0>506`3Q@1/00P00000305AkiP050000001DNnH0E7_V05AkiP00
00000`1DNnH0103D?AT0DgSO05=hg`1CN=l60=@m6@030000001@Lm80D7?B0080D7?B00D00000051c
dP000000BFVl0000000204UY_0050000000oF9X000000=@m6@0000003@3om^h00`3D?AT0ooK^0?of
kP060?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?of
kP030?ofkP030=@m6@3om^h0ooK^00X0ooK^1P000000103D?AT0ooK^0?ofkP3D?AT50?ofkP800000
E03om^h10?ooo`005P3om^h00`000000ooK^0?ofkP0d0?ofkP030=@m6@3om^h0ooK^00P0ooK^1`3D
?AT30?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h02@3om^h0103D?AT0ooK^0?of
kP3om^h60=@m6@P0ooK^00<0e3dI0?ofkP3om^h02P3om^h010000000e3dI03eIZ`0mFJ/40<hj6@04
03eIZ`3>>QT0cSXI00000080?EV[0`3>>QT01@0mFJ/0cSXI0<hj6@3>>QT0000000L0cSXI00<00000
03eIZ`0000001@0000040=Pm6P030000003H?AX0f3dJ00<0f3dJ00D0?EV[0=Pm6P3H?AX0f3dJ0000
00080=Pm6P030000003H?AX0f3dJ00@0f3dJ00<0?EV[0=Pm6P0000002@3H?AX303eIZ`D0f3dJ00<0
?EV[0=Pm6P3H?AX01@3H?AX00`000000f3dJ0=Pm6P060=Pm6P030000003H?AX0?EV[00D0f3dJ00<0
000003eIZ`3H?AX0100000000`3Q@1/000000>506`030>506`0803eIZ`3Q@1/0hD0K0000001DNnX0
000005AkiP00000305AkiP030000001DNnH0e3dI00H0e3dI00<0DgSO0000001CN=l00`1CN=l01@00
0000D7?B051cdP1@Lm8000000080D7?B0P00000304UY_0<0000000<0e3dI000000000000303om^h0
0`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h02`3om^h0
0`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00@0ooK^1P0000070?ofkP<0e3dI1@3om^h2
000005@0ooK^0@3oool001L0ooK^00<000000?ofkP3om^h0<`3om^h0103D?AT0ooK^0?ofkP3om^h7
0=@m6@X0ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP090?ofkP@0e3dI0P3om^h0
10000000ooK^0?ofkP3D?AT80?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0000000mFJ/0103>
>QT01P0mFJ/0cSXI0<hj6@3>>QT000000<hj6@80?EV[0P3>>QT01@0mFJ/0cSXI0<hj6@3>>QT00000
0080cSXI100000020=Pm6P0303eIZ`000000f3dJ00P0f3dJ00<000000=Pm6P3H?AX00`3H?AX0100m
FJ/0f3dJ0=Pm6P0000080=Pm6P030000003H?AX0f3dJ00@0f3dJ00@0?EV[0=Pm6P3H?AX000001P3H
?AX203eIZ`030000003H?AX0f3dJ00D0f3dJ00<0?EV[0=Pm6P3H?AX01@3H?AX00`000000f3dJ0=Pm
6P060=Pm6P050000003H?AX0f3dJ03eIZ`3H?AX00`0000000`0mFJ/00000000000040>506`030000
003Q@1/0hD0K00@0hD0K00H0?EV[0000001DNnX0E7_Z0000001DNnH60=@m6@80E7_V00<000000=@m
6@1CN=l00P1CN=l00`000000DgSO05=hg`0205=hg`8000000`1@Lm801@000000D7?B051cdP1@Lm80
00000080BFVl00D0000004UY_000000000000=@m6@02000000`0ooK^00<0e3dI0?ofkP3om^h01`3o
m^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h00`3o
m^h00`000000e3dI00000004000000P0ooK^1P3D?AT00`3om^h0e3dI0?ofkP040?ofkP030000003o
m^h0000005<0ooK^0@3oool001P0ooK^00<000000?ofkP3om^h0<P3om^h40=@m6A40ooK^00<0e3dI
0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^00<0ooK^00@00000
0?ofkP3om^h0e3dI2@3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP040=@m6@0B6T00000003eIZ`@0cSXI
00@0?EV[0<hj6@3>>QT000000`3>>QT303eIZ`H000001P3H?AX00`0mFJ/000000=Pm6P080=Pm6P03
0000003H?AX0f3dJ00<0f3dJ00D0?EV[0=Pm6P3H?AX0f3dJ000000070=Pm6P030000003H?AX0f3dJ
00D0f3dJ00<0?EV[0=Pm6P0000000`3H?AX303eIZ`80f3dJ00<000000=Pm6P3H?AX01@3H?AX00`00
0000?EV[0=Pm6P050=Pm6P030000003H?AX0f3dJ0080f3dJ1`0000000`0mFJ/000000>506`0203eI
Z`030000003Q@1/0hD0K00@0hD0K00<000000>506`3Q@1/0103Q@1/00`0mFJ/000000=@m6@030=@m
6@<0E7_V00<0000005AkiP1DNnH00P1DNnH00`000000e3dI0000000205=hg`030000001CN=l0DgSO
0080DgSO00<0000005=hg`0000000P1@Lm801@000000D7?B051cdP1@Lm8000000080BFVl00D00000
04UY_000000000000=@m6@02000000`0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?of
kP080?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0000000000000`0000000`3om^h0e3dI0?of
kP060?ofkPH0e3dI0P3om^h40=@m6@030?ofkP3D?AT0ooK^00@0ooK^00<000000?ofkP000000D`3o
m^h10?ooo`006@3om^h00`000000ooK^0?ofkP0a0?ofkP030=@m6@3om^h0ooK^0180ooK^00<0e3dI
0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^00@0ooK^00<00000
0?ofkP3D?AT02@3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@00000000000080?EV[0`3>>QT0
0`0mFJ/0000000000006000000<0?EV[0P3H?AX00`000000f3dJ0=Pm6P060=Pm6P0303eIZ`000000
f3dJ00P0f3dJ00<000000=Pm6P3H?AX00`3H?AX0100mFJ/0f3dJ0=Pm6P0000080=Pm6P030000003H
?AX0f3dJ00@0f3dJ00<0?EV[0=Pm6P0000000`0mFJ/50=Pm6P030000003H?AX0f3dJ00D0f3dJ00<0
000003eIZ`3H?AX0103H?AX6000000@0hD0K00@000000>506`3Q@1/0hD0K0P0mFJ/00`3Q@1/00000
0>506`050>506`030000003Q@1/0hD0K00D0hD0K00<000000=@m6@1DNnX00P1DNnX01@000000E7_V
05AkiP1DNnH0000000<0E7_V00H0000005AkiP1DNnH0e3dI05=hg`00000405=hg`060000001CN=l0
DgSO0000001@Lm800000101@Lm8010000000BFVl04UY_000000204UY_0030000000oF9X0e3dI0080
00002`3om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3o
m^h0103om^h7000000030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h01@3D?AT20?ofkPH0
e3dI0`3om^h00`3D?AT0ooK^0=@m6@050?ofkP030000003om^h0000005<0ooK^0@3oool001X0ooK^
00<000000?ofkP3om^h0<03om^h00`3D?AT0ooK^0?ofkP0B0?ofkP030=@m6@3om^h0ooK^01<0ooK^
00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP040?ofkP030000003om^h0e3dI00T0ooK^
00<0e3dI0?ofkP3om^h02P3om^h0103D?AT0000003eIZ`00000203eIZ`80000000<0f3dJ03eIZ`3H
?AX00P3H?AX00`000000f3dJ0=Pm6P030=Pm6PD0?EV[1`3H?AX00`0mFJ/000000=Pm6P080=Pm6P03
0000003H?AX0f3dJ00<0f3dJ00@0?EV[0=Pm6P3H?AX00000203H?AX00`000000f3dJ0=Pm6P030=Pm
6P@0?EV[203H?AX00`000000f3dJ0=Pm6P050=Pm6P030000003H?AX0?EV[00@0000000<0hD0K0000
003Q@1/01`3Q@1/01@000000hD0K0>506`3Q@1/0?EV[0080hD0K00<000000>506`3Q@1/0103Q@1/0
0`000000hD0K0>506`050>506`040000001DNnX0E7_Z05AkjP8000000P1DNnH00`000000E7_V05Ak
iP0205AkiP060000001DNnH0E7_V0=@m6@1CN=l00000101CN=l01P000000DgSO05=hg`000000D7?B
000000<0D7?B00D00000051cdP000000BFVl0000000204UY_0030000000oF9X0e3dI00800000303o
m^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0000000000000`00
00080?ofkP030=@m6@3om^h0ooK^00H0e3dI00<0ooK^0=@m6@3D?AT0103D?AT90?ofkP040=@m6@3o
m^h0ooK^0=@m6@D0ooK^0P00001C0?ofkP40oooo000K0?ofkP030000003om^h0ooK^02l0ooK^00<0
e3dI0?ofkP3om^h04P3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0
e3dI0?ofkP3om^h0103om^h00`000000ooK^0=@m6@080?ofkP030=@m6@3om^h0ooK^00P0ooK^1P3D
?AT00`000000f3dJ03eIZ`030=Pm6P0403eIZ`3H?AX0f3dJ000000D0f3dJ00D0?EV[0=Pm6P3H?AX0
f3dJ0000000403eIZ`@0f3dJ00<0?EV[0000003H?AX01`3H?AX00`000000f3dJ0=Pm6P040=Pm6P03
03eIZ`3H?AX0000000P0f3dJ1P0mFJ/20=Pm6P0303eIZ`3H?AX0000000L0f3dJ00<000000=Pm6P3H
?AX00P3H?AX50000000303eIZ`3Q@1/0hD0K00<0hD0K00<000000>506`3Q@1/01@3Q@1/00`000000
hD0K0>506`0303eIZ`030>506`000000hD0K00D0hD0K00<000000>506`3Q@1/01@3Q@1/00`000000
E7_Z05AkjP0205AkjP8000000P1DNnH01@000000E7_V05AkiP1DNnH0000000<0E7_V00<0e3dI0000
001CN=l00`1CN=l00`000000DgSO05=hg`0205=hg`030000001@Lm80D7?B0080D7?B00D00000051c
dP000000BFVl0000000204UY_0030000000oF9X0e3dI00800000303om^h00`3D?AT0ooK^0?ofkP07
0?ofkP040=@m6@3om^h0ooK^0?ofkPL0000000<0e3dI0?ofkP3om^h0203om^h60=@m6@030?ofkP3D
?AT0e3dI00@0e3dI3`3om^h0103D?AT0ooK^0?ofkP3D?AT50?ofkP800000D`3om^h10?ooo`006`3o
m^h00`000000ooK^0?ofkP0_0?ofkP030=@m6@3om^h0ooK^0180ooK^00<0e3dI0?ofkP3om^h04`3o
m^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00D0ooK^00<000000=@m6@3om^h01`3o
m^h00`3D?AT0ooK^0?ofkP020?ofkPH0e3dI0P3om^h00`3D?AT0ooK^0?ofkP03000000050=Pm6P0m
FJ/0f3dJ0=Pm6P0mFJ/00`3H?AX00`000000f3dJ0=Pm6P030=Pm6P0503eIZ`3H?AX0f3dJ0=Pm6P00
00000`3H?AX503eIZ`030000003H?AX0f3dJ00L0f3dJ00@000000=Pm6P3H?AX0e3dI0P3H?AX01@0m
FJ/0f3dJ0=Pm6P000000f3dJ00H0?EV[00<000000=Pm6P3H?AX01P3H?AX00`0mFJ/000000=Pm6P03
0=Pm6PP000000`3Q@1/010000000hD0K0>506`0mFJ/40>506`030000003Q@1/0hD0K00D0hD0K00<0
000003eIZ`0mFJ/00`3Q@1/00`0mFJ/000000>506`050>506`030000003Q@1/0hD0K00@0hD0K00<0
000005AkjP1DNnX00P1DNnX00`000000E7_Z05AkjP02000000<0E7_V00<0000005AkiP1DNnH00P1D
NnH00`3D?AT0000005=hg`0305=hg`030000001CN=l0DgSO0080DgSO00D00000051cdP1@Lm80D7?B
00000002051cdP8000000`19JK`2000000040=@m6@0oF9X00000000000/0ooK^00<0e3dI0?ofkP3o
m^h01@3om^h2000000040=@m6@0000000000000000L0ooK^00@0e3dI0?ofkP3om^h0ooK^3P3D?AT2
0?ofkP030=@m6@3om^h0ooK^0140ooK^00<0e3dI0?ofkP3D?AT01@3om^h2000005<0ooK^0@3oool0
01`0ooK^00<000000?ofkP3om^h0;P3om^h00`3D?AT0ooK^0?ofkP0B0?ofkP030=@m6@3om^h0ooK^
01<0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP050?ofkP030000003D?AT0ooK^
00L0ooK^1@3D?AT80?ofkP030=@m6@3om^h0ooK^00<000000P3H?AX203eIZ`030=Pm6P0mFJ/0f3dJ
0080f3dJ00<000000=Pm6P3H?AX00P3H?AX00`0mFJ/0f3dJ0=Pm6P020=Pm6P030000003H?AX0f3dJ
00@0f3dJ5P0mFJ/70=Pm6P030000003H?AX0f3dJ0080f3dJ0`0000000`0mFJ/00000000000030000
00<0hD0K00<000000>506`3Q@1/01@3Q@1/010000000hD0K0>506`0mFJ/40>506`030000003Q@1/0
hD0K00D0hD0K00<0?EV[0>506`3Q@1/00`3Q@1/00`0mFJ/000000>506`050>506`030000003Q@1/0
hD0K00@0hD0K00<0000005AkjP1DNnX00P1DNnX00`000000E7_Z05AkjP02000000<0E7_V00<00000
05AkiP1DNnH00P1DNnH00`000000e3dI05=hg`0205=hg`030000001CN=l0DgSO0080DgSO0P000003
051cdP050000001@Lm80D7?B051cdP0000000P19JK`01@000000BFVl000000000000e3dI00800000
2`3om^h00`3D?AT000000000000500000080ooK^00<0e3dI0?ofkP3om^h01@3om^h>0=@m6@<0ooK^
00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP0A0?ofkP030=@m6@3om^h0e3dI00D0ooK^
00<000000?ofkP000000DP3om^h10?ooo`007@3om^h00`000000ooK^0?ofkP0]0?ofkP030=@m6@3o
m^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3o
m^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h01`3D?AT=0?ofkP030=@m6@3om^h0ooK^00<000000`3H
?AX203eIZ`@0f3dJ00<000000=Pm6P3H?AX00P3H?AX01@0mFJ/0f3dJ0=Pm6P3H?AX0000000P0f3dJ
00<0?EV[0000003H?AX01`3H?AX00`000000f3dJ0=Pm6P030=Pm6P0303eIZ`3H?AX0000000L0f3dJ
1P0000040>506`0303eIZ`3Q@1/0hD0K00D0hD0K00<000000>506`3Q@1/01@3Q@1/01@000000hD0K
0>506`3Q@1/0?EV[00<0hD0K00<000000>506`3Q@1/00`3Q@1/203eIZ`030000003Q@1/0hD0K00<0
hD0K00<0000003eIZ`3Q@1/0103Q@1/00`000000hD0K0>506`040>506`030000001DNnX0E7_Z0080
E7_Z00D0000005AkjP1DNnX0E7_Z0000000305AkiP030000001DNnH0E7_V00<0E7_V00<000000=@m
6@0000000P1CN=l00`000000DgSO05=hg`0205=hg`030000001CN=l000000080D7?B00D00000051c
dP1@Lm80D7?B0000000204UY_00500000019JK`000000000003D?AT00`0000050?ofkPD0000000<0
e3dI0?ofkP3om^h0203om^h=0=@m6@/0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?of
kP0@0?ofkP030=@m6@3om^h0e3dI00D0ooK^00<000000?ofkP000000DP3om^h10?ooo`007P3om^h0
0`000000ooK^0?ofkP0/0?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h04`3om^h0
0`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^00<0ooK^1P3D?AT70?ofkP030=@m6@3om^h0
ooK^00X0ooK^00L0e3dI0?ofkP3om^h0e3dI0000000J:El0000000<0f3dJ0P0mFJ/30=Pm6P030000
003H?AX0f3dJ0080f3dJ00<0?EV[0=Pm6P3H?AX00P3H?AX00`000000f3dJ0=Pm6P050=Pm6P0303eI
Z`000000f3dJ00L0f3dJ00<000000=Pm6P3H?AX0103H?AX00`0mFJ/0f3dJ000000020=Pm6P@00000
00<0hD0K0000003Q@1/01`3Q@1/00`0mFJ/0hD0K0>506`050>506`030000003Q@1/0hD0K00D0hD0K
00D000000>506`3Q@1/0hD0K03eIZ`030>506`040000003Q@1/0hD0K0>506`80?EV[00<0hD0K0000
003Q@1/01@3Q@1/00`000000?EV[0>506`040>506`030000003Q@1/0hD0K00@0hD0K00D0000005Ak
jP1DNnX0E7_Z0000000305AkjP8000000`1DNnH00`000000E7_V05AkiP0205AkiP060000001DNnH0
e3dI0000001CN=l00000101CN=l01P000000DgSO05=hg`000000D7?B000000@0D7?B00@0000004UY
_019JK`000000P19JK`00`000000e3dI00000007000000D0ooK^00@0e3dI0?ofkP3om^h0ooK^303D
?AT50?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?of
kP0@0?ofkP030=@m6@3om^h0e3dI00D0ooK^00<000000?ofkP000000DP3om^h10?ooo`007`3om^h0
0`000000ooK^0?ofkP0[0?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h04`3om^h0
0`3D?AT0ooK^0?ofkP080?ofkPL0e3dI0`3om^h00`3D?AT000000?ofkP070?ofkP030=@m6@3om^h0
ooK^00L0ooK^1P3D?AT01@3om^h000000000000J:El0000000<0f3dJ00<0?EV[0=Pm6P3H?AX00P3H
?AX00`000000f3dJ0=Pm6P020=Pm6P0303eIZ`3H?AX0f3dJ0080f3dJ00<000000=Pm6P3H?AX01@3H
?AX00`0mFJ/000000=Pm6P070=Pm6P030000003H?AX0f3dJ0080f3dJ00<0000003eIZ`0000000`00
00060>506`030000003Q@1/0hD0K00D0hD0K00<0000003eIZ`3Q@1/01@3Q@1/00`000000hD0K0>50
6`050>506`030000003Q@1/0hD0K0080hD0K00<0?EV[0>506`0000000`3Q@1/01@0mFJ/0hD0K0>50
6`3Q@1/0000000H0hD0K00<000000>506`0mFJ/00`3Q@1/00`000000hD0K0>506`040>506`030000
001DNnX0E7_Z0080E7_Z00T0000005AkjP1DNnX0E7_Z0000001DNnX0000005AkiP000000101DNnH0
1@000000E7_V05AkiP3D?AT0E7_V00800000101CN=l01P000000DgSO05=hg`000000D7?B000000<0
D7?B00D00000051cdP000000BFVl0000000204UY_0030000003D?AT00000008000001P3om^h=0=@m
6@80ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^
00<0ooK^00<0e3dI0?ofkP3om^h0403om^h00`3D?AT0ooK^0=@m6@060?ofkP800000DP3om^h10?oo
o`00803om^h00`000000ooK^0?ofkP0[0?ofkP030=@m6@3om^h0ooK^0180ooK^00<0e3dI0?ofkP3o
m^h04`3om^h0103D?AT0ooK^0?ofkP3om^h70=@m6@030?ofkP3D?AT0ooK^00L0ooK^00<0e3dI0?of
kP0000001`3om^h0103D?AT0ooK^0?ofkP3om^h60=@m6@<0ooK^00<0e3dI0?ofkP3om^h00P3om^h2
0000000301XYG`000000f3dJ0080f3dJ0P0mFJ/30=Pm6P030000003H?AX0f3dJ0080f3dJ00<0?EV[
0=Pm6P3H?AX00P3H?AX00`000000f3dJ0=Pm6P040=Pm6P0303eIZ`000000f3dJ00@0f3dJ20000002
0>506`0303eIZ`000000hD0K00L0hD0K00<000000>506`3Q@1/01P3Q@1/00`0mFJ/0hD0K0>506`04
0>506`030000003Q@1/0hD0K00D0hD0K00<000000>506`3Q@1/00P3Q@1/0100mFJ/0hD0K0000003Q
@1/203eIZ`@0hD0K00<000000>506`3Q@1/00`3Q@1/010000000hD0K0>506`0mFJ/30>506`030000
003Q@1/0hD0K00@0hD0K00D0000005AkjP1DNnX0E7_Z0000000305AkjP060000001DNnX0E7_Z0000
001DNnH00000101DNnH01P000000E7_V05AkiP1DNnH0e3dI000000@0DgSO00<0000005=hg`1CN=l0
0P1CN=l00`000000D7?B051cdP02051cdP050000001@Lm80000004UY_00000000P19JK`00`000000
?eRJ0=@m6@02000000H0e3dI00<0ooK^0=@m6@3D?AT0103D?AT80?ofkP030=@m6@3om^h0ooK^00L0
ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^0100
ooK^00@0e3dI0?ofkP3om^h0e3dI1@3om^h200000580ooK^0@3oool00200ooK^00<000000?ofkP3o
m^h0:`3om^h00`3D?AT0ooK^0?ofkP0B0?ofkP030=@m6@3om^h0ooK^0100ooK^1`3D?AT90?ofkP03
0=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP000000103om^h60=@m6@T0ooK^00<0e3dI0?ofkP3o
m^h00P3om^h01@3D?AT000000000000J:El000000080f3dJ00@0?EV[0=Pm6P0mFJ/0?EV[0P3H?AX0
1@000000f3dJ0=Pm6P3H?AX0?EV[00@0f3dJ00<000000=Pm6P3H?AX00`3H?AX20000000303eIZ`00
0000000000<00000103Q@1/00`000000hD0K0>506`030>506`0303eIZ`3Q@1/0000000L0hD0K00<0
00000>506`3Q@1/01P3Q@1/00`000000?EV[0>506`040>506`030000003Q@1/0hD0K00D0hD0K00<0
00000>506`3Q@1/00`3Q@1/303eIZ`H0hD0K00<000000>506`3Q@1/00`3Q@1/010000000hD0K0>50
6`0mFJ/20>506`040000003Q@1/0hD0K0>506`@000000`1DNnX01@000000E7_Z05AkjP1DNnX00000
00@0E7_Z00<0000005AkiP1DNnH00P1DNnH00`000000E7_V05AkiP0205AkiP030=@m6@000000DgSO
0080DgSO00<0000005=hg`1CN=l00`1CN=l01@000000D7?B051cdP1@Lm8000000080D7?B0P000003
04UY_080000000@0e3dI03mHVP00000000001P3D?AT30?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0
e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0
e3dI0?ofkP3om^h0403om^h0103D?AT0ooK^0?ofkP3D?AT50?ofkP800000DP3om^h10?ooo`008@3o
m^h00`000000ooK^0?ofkP0Z0?ofkP030=@m6@3om^h0ooK^0180ooK^00<0e3dI0?ofkP3om^h02@3o
m^h70=@m6@<0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP060?ofkPL0e3dI0P3o
m^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00<0ooK^100000030=Pm6P0303eIZ`3H
?AX0f3dJ0080?EV[00<000000=Pm6P3H?AX00P3H?AX0100mFJ/0f3dJ0=Pm6P3H?AX6000000<0hD0K
00<0?EV[0000003Q@1/01P3Q@1/00`000000hD0K0>506`040>506`0303eIZ`000000hD0K00L0hD0K
00<000000>506`3Q@1/01@3Q@1/00`000000?EV[0>506`050>506`030000003Q@1/0hD0K00@0hD0K
00<000000>506`3Q@1/00P3Q@1/203eIZ`030000003Q@1/0hD0K00@0hD0K00<000000>506`3Q@1/0
0`3Q@1/01P000000hD0K0>506`3Q@1/0000003eIZ`D000000P3Y@a`2000000<0E7_Z00D0000005Ak
jP1DNnX0E7_Z0000000305AkjP800000101DNnH00`000000E7_V05AkiP0205AkiP030=@m6@1DNnH0
00000080DgSO00<0000005=hg`1CN=l00P1CN=l2000000<0D7?B00D00000051cdP1@Lm80D7?B0000
000204UY_0030000003D?AT0e3dI00@0e3dI2@3om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3o
m^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3o
m^h0ooK^0100ooK^00@0e3dI0?ofkP3om^h0e3dI1@3om^h200000580ooK^0@3oool00280ooK^00<0
00000?ofkP3om^h0:@3om^h00`3D?AT0ooK^0?ofkP0B0?ofkP040=@m6@3om^h0ooK^0?ofkPP0e3dI
2P3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP040=@m6@3om^h0ooK^0?ofkPH0e3dI0P3om^h00`000000
ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0
000001XYG`0200000080f3dJ00<0?EV[0=Pm6P3H?AX00P3H?AX203eIZ`<0f3dJ00@0?EV[00000000
000000000P3Q@1/00`000000hD0K0>506`040>506`0303eIZ`000000hD0K00L0hD0K00<000000>50
6`3Q@1/00`3Q@1/00`0mFJ/0hD0K000000070>506`030000003Q@1/0hD0K00D0hD0K00<000000>50
6`0mFJ/01@3Q@1/00`000000hD0K0>506`040>506`030000000mFJ/0?EV[0080?EV[00<0hD0K03eI
Z`0000001P3Q@1/010000000hD0K0>506`3Q@1/6000000040>U3700mFJ/0jD<L000000D0jD<L00D0
000005=jjP000000E7_Z0000000305AkjP030000001DNnX0E7_Z0080E7_Z00<0000005AkjP000000
0P1DNnH00`000000E7_V05AkiP0205AkiP060000003D?AT0E7_V0000001CN=l000001@1CN=l00`00
0000DgSO00000002051cdP030000001@Lm80e3dI00D0e3dI00@0BFVl0000003D?AT0?eRJ0`000009
0?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP0<
0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h03`3om^h40=@m6@D0ooK^00<00000
0?ofkP000000D@3om^h10?ooo`008`3om^h00`000000ooK^0?ofkP0X0?ofkP030=@m6@3om^h0ooK^
0100ooK^1P3D?ATC0?ofkP030=@m6@3om^h0ooK^00T0ooK^103D?AT50?ofkP050=@m6@3om^h0ooK^
0?ofkP000000103om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^0080ooK^00@0e3dI
0000000000006RUO0P0000020=Pm6P0303eIZ`3H?AX0f3dJ00<000000P0mFJ/00`000000hD0K03eI
Z`050>506`030000003Q@1/0hD0K00@0hD0K00<0?EV[0000003Q@1/01P3Q@1/00`000000hD0K0>50
6`040>506`0303eIZ`000000hD0K00H0hD0K00<000000>506`3Q@1/01@3Q@1/00`000000hD0K03eI
Z`050>506`030000003Q@1/0hD0K0080hD0K0`0mFJ/60>506`0303eIZ`3Q@1/0hD0K00<0hD0K1@00
00020>U370030000003Y@a`0jD<L00<0jD<L00<0?EV[0>U3703Y@a`00P3Y@a`01`0mFJ/0000005=j
jP1CN^X0000005AkjP0000000P1DNnX00`000000E7_Z05AkjP0205AkjP060000001DNnX0E7_Z0000
001DNnH00000101DNnH01@000000E7_V05AkiP3D?AT0E7_V00800000101CN=l00`000000DgSO0=@m
6@050=@m6@03051cdP00000000000080BFVl00D0000004UY_019JK`0e3dI03mHVP03000000T0ooK^
00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00`0ooK^
00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP080?ofkPL0e3dI00@0ooK^0=@m6@3om^h0
e3dI1@3om^h00`000000ooK^0000001A0?ofkP40oooo000T0?ofkP030000003om^h0ooK^02L0ooK^
00<0e3dI0?ofkP3om^h02`3om^h50=@m6@80ooK^00<0e3dI0?ofkP3om^h0503om^h00`3D?AT0ooK^
0?ofkP090?ofkP030=@m6@3om^h0ooK^00H0ooK^00D0e3dI0?ofkP3om^h0ooK^000000050?ofkP03
0=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0000000200000004
01XYG`000000000003eIZ`800000103Q@1/010000000?EV[03eIZ`0mFJ/50>506`030000003Q@1/0
hD0K00D0hD0K00<0?EV[0000003Q@1/01P3Q@1/00`000000hD0K0>506`030>506`0303eIZ`3Q@1/0
000000H0hD0K00<000000>506`3Q@1/01@3Q@1/010000000hD0K0>506`0mFJ/40>506`030000003Q
@1/0?EV[0080?EV[0P3Q@1/00`000000hD0K0>506`040>506`0303eIZ`3Q@1/0000000<0000000<0
jD<L0000003Y@a`00`3Y@a`00`000000jD<L0>U370040>U3700803eIZ`3Y@a`0jD<L0>U3700mFJ/0
jD<L0000003D?AT205=jjP050000001DNnX0E7_Z05AkjP0000000`1DNnX00`000000E7_Z05AkjP02
05AkjP800000101DNnH01`000000E7_V05AkiP3D?AT0E7_V0000001CN=l01P3D?AT0101CN=l00000
051cdP000003051cdP050000001@Lm80000004UY_00000000P19JK`00`000000e3dI000000020000
00T0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^
00`0ooK^00<0e3dI0?ofkP3om^h00`3om^h0103D?AT0ooK^0?ofkP3om^h70=@m6@P0ooK^00<0e3dI
0?ofkP3D?AT01P3om^h200000540ooK^0@3oool002D0ooK^00<000000?ofkP3om^h09P3om^h00`3D
?AT0ooK^0?ofkP050?ofkPH0e3dI1`3om^h00`3D?AT0ooK^0?ofkP0D0?ofkP030=@m6@3om^h0ooK^
00T0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP020?ofkP030000003om^h0ooK^
0080ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h00000
00<0000000@06RUO0000003Q@1/0?EV[1P3Q@1/00`000000hD0K03eIZ`0303eIZ`<0hD0K00<00000
0>506`3Q@1/0103Q@1/00`0mFJ/000000>506`060>506`030000003Q@1/0hD0K00@0hD0K00<0?EV[
0000003Q@1/01P3Q@1/00`000000hD0K0>506`050>506`030000003Q@1/0?EV[0080hD0K100mFJ/5
0>506`040000003Q@1/0hD0K0>506`@0000000<0?EV[0>U3703Y@a`00P3Y@a`00`000000jD<L0>U3
70030>U370030000003Y@a`0jD<L00<0jD<L00<000000>U3700mFJ/00P0mFJ/01@3Y@a`0000005=j
jP3D?AT0Dg[Z008000000P1DNnX00`000000E7_Z05AkjP0205AkjP030000001DNnX0E7_Z0080E7_Z
00<0000005AkiP1DNnH00P1DNnH00`000000e3dI0=@m6@050=@m6@<0DgSO00<0000005=hg`1CN=l0
0P1CN=l01@000000D7?B051cdP1@Lm8000000080D7?B00<0000004UY_00000000P19JK`00`000000
e3dI00000002000000T0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP060?ofkP03
0=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h01`3D?AT=0?ofkP<0e3dI0P3om^h00`3D?AT0
ooK^0?ofkP030?ofkP800000D@3om^h10?ooo`009@3om^h00`000000ooK^0?ofkP0V0?ofkP030=@m
6@3om^h0ooK^00D0e3dI3P3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^00T0ooK^
00<0e3dI0?ofkP3om^h01`3om^h01@3D?AT0ooK^0?ofkP3om^h0000000@0ooK^00<0e3dI0?ofkP3o
m^h02P3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00H0000000<0?EV[0>506`3Q
@1/01@3Q@1/01@000000hD0K0>506`0mFJ/0hD0K00D0?EV[1P3Q@1/00`0mFJ/000000>506`060>50
6`030000003Q@1/0hD0K00<0hD0K00<0?EV[0>506`0000001P3Q@1/00`000000hD0K0>506`050>50
6`030000000mFJ/0?EV[0080?EV[0P3Q@1/010000000hD0K0>506`3Q@1/7000000<0jD<L00<00000
03eIZ`3Y@a`00`3Y@a`00`000000jD<L0>U370030>U370030000003Y@a`0jD<L00<0jD<L00<00000
0>U3700mFJ/00`3Y@a`010000000Dg[Z0=@m6@1CN^X20000000305AkjP000000E7_Z00<0E7_Z00@0
000005AkjP1DNnX0E7_Z203D?AT305AkiP040=@m6@1DNnH0E7_V00000080DgSO00<0000005=hg`1C
N=l00`1CN=l01@000000D7?B051cdP1@Lm8000000080D7?B0P00000204UY_00500000019JK`0e3dI
0000000oF9X00P0000080?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h01P3om^h0
0`3D?AT0ooK^0?ofkP080?ofkPL0e3dI0`3om^h00`3D?AT0ooK^0?ofkP080?ofkPH0e3dI0P3om^h0
103D?AT0ooK^0?ofkP3D?AT50?ofkP800000D@3om^h10?ooo`009P3om^h00`000000ooK^0?ofkP0U
0?ofkP<0e3dI4`3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI
0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP020?ofkP050000003om^h0ooK^0?ofkP3D?AT0303o
m^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00L000000P0mFJ/60>506`030000003Q
@1/0?EV[00H0hD0K1@0mFJ/0103Q@1/0?EV[0>506`0000070>506`030000003Q@1/0hD0K00<0hD0K
00<0?EV[0000003Q@1/01@3Q@1/00`000000hD0K0>506`0603eIZ`80hD0K00<0?EV[000000000000
1@0000030>U370030000003Y@a`0jD<L00@0jD<L00<000000>U3700mFJ/00`3Y@a`00`000000jD<L
0>U370020>U370030000003Y@a`0jD<L00<0jD<L00@0000003eIZ`0mFJ/0?EV[0P3Y@a`01@000000
Dg[Z05=jjP1CN^X0e3dI0080Dg[Z0P0000080=@m6@0405AkjP000000E7_Z00000080E7_V00<00000
05AkiP1DNnH00P1DNnH0103D?AT0E7_V05AkiP00000205=hg`030000001CN=l0DgSO0080DgSO0P00
0002051cdP030000001@Lm80D7?B0080D7?B00P0000004UY_019JK`0000004UY_03D?AT0000003mH
VP800000203om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^00H0ooK^00@0e3dI0?of
kP3om^h0ooK^1`3D?AT50?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h00P3om^h6
0=@m6@P0ooK^00@0e3dI0?ofkP3om^h0e3dI1@3om^h200000540ooK^0@3oool002L0ooK^00<00000
0?ofkP3om^h0903om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI
0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00<0ooK^00@00000
0?ofkP3om^h0e3dI3@3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00800000103D
?AT00`000000hD0K0>506`060>506`030000003Q@1/0?EV[00H0hD0K00@000000>506`3Q@1/0hD0K
2P0mFJ/00`3Q@1/000000>506`040>506`0303eIZ`3Q@1/000000080hD0K1P0mFJ/20>506`L00000
00@0?EV[0>U3703Y@a`000001P3Y@a`00`000000jD<L0>U370030>U370040000003Y@a`0jD<L03eI
Z`80jD<L00<000000>U3703Y@a`00`3Y@a`00`000000jD<L0>U370020>U37080?EV[0`3Y@a`00`0m
FJ/0000005=jjP0205=jjPH0e3dI0`1DNnX00`000000E7_Z05AkjP0205AkjP060000001DNnX0E7_Z
0000001DNnH00000101DNnH01`000000E7_V0=@m6@1DNnH0000005=hg`0000001@1CN=l200000080
D7?B00<00000051cdP1@Lm800P1@Lm8020000000BFVl04UY_0000000BFVl0=@m6@000000?eRJ0P00
00090?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h00`3om^h70=@m6@`0ooK^00@0
e3dI0?ofkP3om^h0ooK^1P3D?AT>0?ofkP040=@m6@3om^h0ooK^0=@m6@D0ooK^00<000000?ofkP00
0000D03om^h10?ooo`00:03om^h00`000000ooK^0?ofkP0S0?ofkP030=@m6@3om^h0ooK^01<0ooK^
00<0e3dI0?ofkP3om^h0503om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^00H0ooK^
00<0e3dI0?ofkP3om^h00`3om^h010000000ooK^0?ofkP3D?AT=0?ofkP040=@m6@3om^h0ooK^0?of
kPH0e3dI00H0000001XYG`000000000002<iO@0000080>506`030000000mFJ/0hD0K00H0hD0K00<0
00000>506`3Q@1/00P3Q@1/00`0mFJ/0hD0K000000050>506``0?EV[0P3Q@1/6000000<0jD<L00D0
00000>U3703Y@a`0jD<L03eIZ`020>U370030000003Y@a`0jD<L00@0jD<L00<000000>U3703Y@a`0
0`3Y@a`01`000000jD<L0>U3703Y@a`0?EV[0>U370000000103Y@a`010000000jD<L0>U3703Y@a`2
03eIZ`030>U370000000jD<L0080jD<L00<0?EV[0000003D?AT00P3D?AT00`000000e3dI05=jjP02
000000<0E7_Z00<0000005AkjP1DNnX00P1DNnX00`000000E7_Z05AkjP0205AkjP8000000`1DNnH0
10000000E7_V05AkiP3D?AT205AkiP800000101CN=l00`000000DgSO05=hg`02000000@0D7?B0P00
00000`19JK`0000004UY_00204UY_0040=@m6@0oF9X00000000000T0ooK^00<0e3dI0?ofkP3om^h0
203om^h60=@m6@<0ooK^00<0e3dI0?ofkP3om^h02P3om^h70=@m6@030?ofkP3D?AT0ooK^0180ooK^
00<0e3dI0?ofkP3D?AT01@3om^h00`000000ooK^0000001@0?ofkP40oooo000Y0?ofkP030000003o
m^h0ooK^02<0ooK^00<0e3dI0?ofkP3om^h04P3om^h00`3D?AT0ooK^0?ofkP0D0?ofkP030=@m6@3o
m^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP040?ofkP030000003o
m^h0e3dI00X0ooK^1`3D?AT00`3om^h0e3dI0?ofkP020?ofkP040000000B6T00000001XYG`800000
00<08cUm0000000000001`3Q@1/00`000000?EV[0>506`050>506`030000003Q@1/0hD0K00<0hD0K
00<0?EV[0>506`0000001P3Q@1/00`000000hD0K0>506`020>506`80000000<0?EV[000000000000
0P0000020>U370030000003Y@a`0jD<L00D0jD<L00L000000>U3703Y@a`0jD<L03eIZ`3Y@a`00000
00H0jD<L00<000000>U3703Y@a`00`3Y@a`01`000000jD<L0>U3703Y@a`0?EV[0>U370000000103Y
@a`010000000jD<L03eIZ`0mFJ/20>U370030000003Y@a`0jD<L0080jD<L00D0000005=jjP1CN^X0
Dg[Z0000000205=jjP060=@m6@000000Dg[Z0000001DNnX00000101DNnX00`000000E7_Z05AkjP03
05AkjP050000001DNnH0E7_V05AkiP0000000`1DNnH0103D?AT0E7_V05AkiP00000405=hg`040000
001CN=l0DgSO05=hg`800000101@Lm820000000304UY_0000000BFVl0080BFVl00@0e3dI03mHVP00
000000002@3om^h0103D?AT0ooK^0?ofkP3om^h70=@m6@030?ofkP3D?AT0ooK^00H0ooK^00<0e3dI
0?ofkP3om^h00P3om^h80=@m6@<0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP0A
0?ofkP030=@m6@3om^h0e3dI00H0ooK^0P00001@0?ofkP40oooo000Z0?ofkP030000003om^h0ooK^
0280ooK^00<0e3dI0?ofkP3om^h04P3om^h00`3D?AT0ooK^0?ofkP0D0?ofkP030=@m6@3om^h0ooK^
00T0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP040?ofkP030000003om^h0e3dI
0080ooK^1`3D?AT30?ofkP030=@m6@3om^h0ooK^00H0e3dI00D0ooK^000000000000000001XYG`02
000000808cUm00<000000>506`3Q@1/01@3Q@1/00`0mFJ/0hD0K0>506`050>506`030000003Q@1/0
hD0K0080hD0K00<0?EV[0>506`000000103Q@1/700000080jD<L00<0?EV[0>U3700000001@3Y@a`0
0`000000jD<L0>U370040>U370070000003Y@a`0jD<L0>U3700mFJ/0jD<L000000060>U370030000
003Y@a`0jD<L00<0jD<L00<000000>U3703Y@a`00P3Y@a`00`0mFJ/000000>U370030>U37080?EV[
103Y@a`00`000000jD<L0>U370020>U370040000001CN^X0Dg[Z000000<0Dg[Z00H0e3dI05=jjP1C
N^X0000005AkjP00000405AkjP030000001DNnX0E7_Z0080E7_Z0P00000205AkiP030000001DNnH0
E7_V0080E7_V00@0e3dI05AkiP0000000000101CN=l01@000000DgSO05=hg`1CN=l0000000@0D7?B
00<00000051cdP1@Lm800P00000304UY_0030=@m6@0oF9X0000000800000103om^h80=@m6@P0ooK^
00<0e3dI0?ofkP3om^h00P3om^h80=@m6@/0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^
0?ofkP0@0?ofkP040=@m6@3om^h0ooK^0=@m6@D0ooK^0P00001@0?ofkP40oooo000Z0?ofkP030000
003om^h0ooK^0280ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m
6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h01`3om^h0103D?AT0ooK^0?ofkP3om^h80=@m6@L0
ooK^1P3D?AT20?ofkP030=@m6@3om^h0ooK^00<0ooK^0`0000001P0J:El000000000000000008cUm
000000L0hD0K00<0?EV[0>506`3Q@1/01@3Q@1/00`000000hD0K0>506`020>506`0303eIZ`000000
000000<00000103Y@a`00`000000jD<L0>U370030>U3700303eIZ`000000jD<L00@0jD<L00<00000
0>U3703Y@a`0103Y@a`00`000000jD<L0>U370020>U3700303eIZ`000000jD<L00D0jD<L00<00000
0>U3703Y@a`00`3Y@a`00`000000jD<L0>U370020>U3700403eIZ`3Y@a`0jD<L0>U37080?EV[1@3Y
@a`00`000000jD<L0>U370020>U370040000001CN^X0Dg[Z000000<0Dg[Z00<000000=@m6@1CN^X0
0P1CN^X00`000000E7_Z05AkjP0205AkjP030000001DNnX0E7_Z0080E7_Z00<0000005AkjP000000
0P1DNnH00`000000E7_V05AkiP0205AkiP050=@m6@000000E7_V05AkiP0000000P1CN=l010000000
DgSO05=hg`1CN=l2000000@0D7?B00@00000051cdP1@Lm8000000`19JK`010000000e3dI0000000o
F9X60=@m6@@0ooK^00<0e3dI0?ofkP3om^h01`3om^h70=@m6@<0ooK^00<0e3dI0?ofkP3om^h03@3o
m^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^0100ooK^00@0e3dI0?ofkP3om^h0e3dI
1@3om^h200000500ooK^0@3oool002/0ooK^00<000000?ofkP3om^h08@3om^h00`3D?AT0ooK^0?of
kP0C0?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?of
kP040?ofkPH0e3dI103om^h00`000000e3dI0?ofkP020?ofkPH0e3dI103om^h01@3D?AT0ooK^0?of
kP3om^h0e3dI00D0ooK^0`00000201XYG`050000000S>Gd0000002<iO@0000001P3Q@1/00`0mFJ/0
00000>506`030>506`L0000000@0?EV[0>U3703Y@a`000001P3Y@a`00`000000jD<L0>U370030>U3
700303eIZ`3Y@a`0000000D0jD<L00<000000>U3703Y@a`00`3Y@a`00`000000jD<L0>U370020>U3
700303eIZ`000000jD<L00D0jD<L00<000000>U3703Y@a`00`3Y@a`00`000000jD<L0>U370020>U3
70060000000mFJ/0?EV[03eIZ`3Y@a`000001@3Y@a`00`000000jD<L0>U370020>U370040000001C
N^X0Dg[Z000000<0Dg[Z00@000000=@m6@1CN^X0Dg[Z0P00000305AkjP030000001DNnX0E7_Z0080
E7_Z00@0000005AkjP1DNnX0E7_Z0P00000505AkiP070000003D?AT0E7_V05AkiP000000DgSO0000
000405=hg`030000001CN=l000000080D7?B00D00000051cdP1@Lm80D7?B0000000304UY_0030000
003D?AT000000080?eRJ00<000000?ofkP3om^h01P3om^h0103D?AT0ooK^0?ofkP3om^h60=@m6@80
ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^0080
ooK^00<0e3dI0?ofkP3om^h0403om^h40=@m6@D0ooK^0P00001@0?ofkP40oooo000/0?ofkP030000
003om^h0ooK^0200ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m
6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3D?AT0103D?AT20?ofkP030=@m6@3om^h0ooK^0080ooK^
203D?AT:0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT01P3om^h0100000004QY00000000J:El20000
000402<iO@0000008cUm000000@0hD0K0P0000000`0mFJ/0000000000002000000@0jD<L00D00000
0>U3703Y@a`0jD<L03eIZ`020>U370030000003Y@a`0jD<L00@0jD<L00<000000>U3703Y@a`00`3Y
@a`00`0mFJ/000000>U370040>U370030000003Y@a`0jD<L00@0jD<L00L000000>U3703Y@a`0jD<L
03eIZ`3Y@a`0000000D0jD<L00<000000>U3703Y@a`00P3Y@a`00`000000jD<L0>U370030>U37080
?EV[0`3Y@a`00`000000jD<L0>U370020>U370030000003Y@a`0jD<L00<000000P1CN^X01@000000
Dg[Z05=jjP1CN^X000000080Dg[Z00L0e3dI0000001CN^X0Dg[Z0000001DNnX0000000@0E7_Z00<0
000005AkjP1DNnX00P1DNnX00`000000E7_V05AkiP0305AkiP030000001DNnH0e3dI00<0E7_V0P00
000305=hg`040000001CN=l0DgSO00000080D7?B00D00000051cdP1@Lm80D7?B0000000304UY_003
00000019JK`0e3dI0080?eRJ00<000000?ofkP3om^h0103om^h60=@m6@P0ooK^00<0e3dI0?ofkP3o
m^h01P3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3o
m^h02@3om^h80=@m6@80ooK^00<0e3dI0?ofkP3om^h00`3om^h00`000000ooK^0000001?0?ofkP40
oooo000]0?ofkP030000003om^h0ooK^01l0ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^
0?ofkP0D0?ofkP030=@m6@3om^h0ooK^00D0ooK^1P3D?AT30?ofkPT0e3dI103om^h00`3D?AT0ooK^
0?ofkP0;0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT01`3om^h010000000?EV[0000000J:El40000
000302<iO@0000000000008000000P3Y@a`00`0mFJ/0jD<L000000070>U370040000003Y@a`0jD<L
03eIZ`<0jD<L00<000000>U3703Y@a`0103Y@a`00`000000jD<L0>U370020>U3700303eIZ`3Y@a`0
000000D0jD<L00<000000>U3703Y@a`00`3Y@a`00`000000jD<L0>U370020>U3700303eIZ`000000
jD<L00@0jD<L00<000000>U3703Y@a`00P3Y@a`00`000000jD<L0>U3700303eIZ`050>U3700mFJ/0
jD<L0>U3700000000`3Y@a`5000000050?567P000000000005=jjP0000000`1CN^X01P000000Dg[Z
05=jjP1CN^X0e3dI00000080Dg[Z00<0000005AkjP0000000`1DNnX00`000000E7_Z05AkjP0205Ak
jP8000001@1DNnH00`000000E7_V0=@m6@0305AkiP050000001CN=l0DgSO05=hg`0000000`1CN=l0
0`000000D7?B00000003051cdP050000001@Lm80000004UY_00000000P19JK`0103D?AT0?eRJ03mH
VP0000060=@m6@80ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m
6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h00P3om^h0103D?AT0ooK^0?ofkP3om^h80=@m6@P0
ooK^00<0e3dI0?ofkP3D?AT01P3om^h2000004l0ooK^0@3oool002h0ooK^00<000000?ofkP3om^h0
7`3om^h00`3D?AT0ooK^0?ofkP0B0?ofkP030=@m6@3om^h0ooK^01@0ooK^00<0e3dI0?ofkP3om^h0
1@3D?AT40?ofkPD0e3dI1@3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@000000ooK^00`0ooK^
00@0e3dI0?ofkP3om^h0e3dI1`3om^h20000000303eIZ`000000000000808cUm0P0000001@0S>Gd0
00000000003Y@a`0?EV[0080jD<L00<0?EV[0>U3700000001`3Y@a`010000000jD<L0>U3700mFJ/3
0>U370030000003Y@a`0jD<L00@0jD<L00<000000>U3703Y@a`00P3Y@a`00`0mFJ/000000>U37004
0>U370030000003Y@a`0jD<L00<0jD<L00<000000>U3703Y@a`00P3Y@a`00`0mFJ/000000>U37004
0>U370030000003Y@a`0jD<L0080jD<L0`0mFJ/50000000303eIZ`000000000000<0000000<0lDHN
0000003aAQh00P3aAQh00`000000DGWX055ij002000000<0Dg[Z00D0000005=jjP1CN^X0Dg[Z0=@m
6@0405=jjP030000001DNnX0E7_Z0080E7_Z00D0000005AkjP1DNnX0E7_Z0000000205AkjP050000
001DNnH0E7_V05AkiP0000000P1DNnH00`3D?AT0E7_V05AkiP02000000<0DgSO00<0000005=hg`1C
N=l00P1CN=l2000000<0D7?B00@00000051cdP000000BFVl1`3D?AT00`0mFJ/0ooK^0?ofkP050?of
kP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP0=0?of
kP030=@m6@3om^h0e3dI00H0e3dI403om^h00`3D?AT0ooK^0=@m6@060?ofkP800000C`3om^h10?oo
o`00;`3om^h00`000000ooK^0?ofkP0N0?ofkP030=@m6@3om^h0ooK^0180ooK^00<0e3dI0?ofkP3o
m^h04@3om^h60=@m6@T0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP050?ofkP03
0=@m6@3om^h0000000`0ooK^00@0e3dI0?ofkP3om^h0e3dI203om^h00`0B6T00000003eIZ`020000
00808cUm0`0000000`0`Bid000000>U3700303eIZ`80jD<L0P0000060>U370030000003Y@a`0?EV[
00@0jD<L00<000000>U3703Y@a`00`3Y@a`00`000000jD<L0>U370020>U3700303eIZ`3Y@a`00000
00D0jD<L00<000000>U3703Y@a`00P3Y@a`00`000000jD<L0>U370030>U3700303eIZ`3Y@a`0jD<L
00<0jD<L00<000000>U3703Y@a`00P0mFJ/300000080lDHN00H000000?567P3aAQh0?EV[0?567P00
00040?567P050000003aAQh0lDHN0?567P0000000P1ANNP01@000000Dg[Z05=jjP1CN^X0000000<0
Dg[Z00<000000=@m6@1CN^X00P1CN^X2000000<0E7_Z00D0000005AkjP1DNnX0E7_Z0000000305Ak
jP040000001DNnH0E7_V000000@0E7_V00@0e3dI0000001DNnH000000P1CN=l00`000000DgSO05=h
g`0305=hg`030000003D?AT0e3dI00H0e3dI00@0000004UY_019JK`0e3dI0P0oF9X00`000000?EV[
0?ofkP070?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^
0?ofkP080?ofkPL0e3dI0`3om^h00`3D?AT0ooK^0?ofkP0A0?ofkP030=@m6@3om^h0e3dI00H0ooK^
0P00001?0?ofkP40oooo000_0?ofkP030000003om^h0ooK^01h0ooK^00<0e3dI0?ofkP3om^h04`3o
m^h00`3D?AT0ooK^0?ofkP090?ofkPL0e3dI0`3om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3o
m^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0000000<0?ofkP050=@m6@3o
m^h0ooK^0?ofkP3D?AT01`3om^h00`0000004QY000000002000000<08cUm00D0000002<iO@000000
e3dI000000020>U370<0?EV[0P3Y@a`00`000000jD<L0>U370040>U370030000003Y@a`0?EV[00<0
jD<L00<000000>U3703Y@a`0103Y@a`00`000000jD<L0>U370020>U3700303eIZ`000000jD<L00@0
jD<L00<000000>U3703Y@a`00`3Y@a`00`000000jD<L0>U370020>U3700403eIZ`3Y@a`0jD<L0>U3
708000000`0mFJ/20?567P050000003aAQh0lDHN0?567P000000103aAQh00`0mFJ/0lDHN0?567P02
0?567P050000003aAQh0lDHN0?567P0000000P1ANNP01@000000DGWX0000001CN^X0000000<0Dg[Z
00P0000005=jjP1CN^X0e3dI05=jjP000000Dg[Z00000080E7_Z00D0000005AkjP1DNnX0E7_Z0000
000505AkjP8000001@1DNnH01@3D?AT0E7_V05AkiP1DNnH0000000P0e3dI0`1@Lm801@000000D7?B
051cdP1@Lm80000000<0BFVl00<0e3dI0000000000000P0mFJ/80?ofkP030=@m6@3om^h0ooK^00T0
ooK^00<0e3dI0?ofkP3om^h01@3om^h0103D?AT0ooK^0?ofkP3om^h70=@m6@D0ooK^00<0e3dI0?of
kP3om^h00P3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP@0e3dI00<0ooK^0=@m6@3om^h01@3om^h20000
04l0ooK^0@3oool00300ooK^00<000000?ofkP3om^h07@3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP04
0=@m6@3om^h0ooK^0?ofkPP0e3dI2`3om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^
00P0ooK^00<0e3dI0?ofkP3om^h0103om^h0103D?AT0ooK^0?ofkP00000;0?ofkP050=@m6@3om^h0
ooK^0?ofkP3D?AT0203om^h6000000808cUm00@0000002<iO@3D?AT0<4^M0P0000020>U370D0?EV[
1P3Y@a`00`000000?EV[0>U370030>U370030000003Y@a`0jD<L00@0jD<L00L000000>U3703Y@a`0
jD<L03eIZ`3Y@a`0000000D0jD<L00<000000>U3703Y@a`0200000000`0mFJ/0000003eIZ`0203eI
Z`030000003aAQh0lDHN0080lDHN00D000000?567P3aAQh0lDHN000000040?567P0303eIZ`3aAQh0
lDHN0080lDHN00@000000?567P3aAQh000000P1ANNP01P000000DGWX055ij0000000Dg[Z00000080
Dg[Z00H0000005=jjP1CN^X0Dg[Z0=@m6@00000305=jjP800000101DNnX00`000000E7_Z05AkjP03
05AkjP030000001DNnH0E7_V0080E7_V1`3D?AT00`000000DgSO05=hg`0205=hg`060000001CN=l0
DgSO0000001@Lm800000101@Lm801`000000BFVl04UY_0000000BFVl0=@m6@0000000`0mFJ/70?of
kP030=@m6@3om^h0ooK^00X0ooK^00@0e3dI0?ofkP3om^h0ooK^1`3D?AT=0?ofkP050=@m6@3om^h0
ooK^0?ofkP3D?AT0203om^h80=@m6@<0ooK^00@0e3dI0?ofkP3om^h0e3dI1@3om^h2000004l0ooK^
0@3oool00340ooK^00<000000?ofkP3om^h0703om^h00`3D?AT0ooK^0?ofkP0@0?ofkPL0e3dI4`3o
m^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h0103o
m^h0103D?AT0ooK^0?ofkP00000<0?ofkP040=@m6@3om^h0ooK^0=@m6@P0ooK^00<00000018J@000
00000P0000001P0mFJ/0000002<iO@0S>Gd000000=@m6@80000000@0<4^M0000003Y@a`0?EV[103Y
@a`403eIZ`<0jD<L00<0000003eIZ`3Y@a`00`3Y@a`00`000000jD<L0>U370040>U370060000003Y
@a`0jD<L0>U3700mFJ/000000`3Y@a`500000080lDHN00<000000?567P0mFJ/01@0mFJ/30?567P05
0000003aAQh0lDHN0?567P000000103aAQh01`000000lDHN0?567P3aAQh000000?567P0mFJ/00P3a
AQh010000000lDHN0?567P000003055ij0050000001ANNP0DGWX055ij00000000P1CN^X00`000000
Dg[Z05=jjP0205=jjP030=@m6@1CN^X0Dg[Z0080Dg[Z00<0000005AkjP1DNnX00P1DNnX00`000000
E7_Z05AkjP0305AkjPH0e3dI00<0000005AkiP3D?AT00`1DNnH00`000000DgSO05=hg`0305=hg`06
0000001CN=l0DgSO0000001@Lm8000000`1@Lm8200000080BFVl00@0000004UY_03D?AT000000`0m
FJ/70?ofkP030=@m6@3om^h0ooK^00P0ooK^1P3D?AT30?ofkP030=@m6@3om^h0ooK^00h0ooK^00@0
e3dI0?ofkP3om^h0ooK^2@3D?AT;0?ofkP040=@m6@3om^h0ooK^0=@m6@D0ooK^0P00001?0?ofkP40
oooo000b0?ofkP030000003om^h0ooK^01`0ooK^00<0e3dI0?ofkP3om^h0203om^h70=@m6@<0ooK^
00<0e3dI0?ofkP3om^h0503om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00P0ooK^
00<0e3dI0?ofkP3om^h0103om^h01@3D?AT0ooK^0?ofkP3om^h0000000/0ooK^00@0e3dI0?ofkP3o
m^h0e3dI0`3om^h80000000501XYG`000000000002<iO@0000000`0S>Gd00`3D?AT0<4^M00000003
0=@m6@0303eIZ`3Y@a`0jD<L0080jD<L00<000000>U3703Y@a`01@0mFJ/50>U370030000003Y@a`0
jD<L00<0jD<L00D000000>U3703Y@a`0jD<L03eIZ`04000000030?567P0mFJ/0?EV[00H0?EV[0`3a
AQh00`000000?EV[0?567P030?567P050000003aAQh0lDHN0?567P000000103aAQh02@000000lDHN
0?567P3aAQh000000?567P0mFJ/0lDHN000000030?567P040000001ANNP0DGWX000000<0DGWX0P00
000205=jjP060000001CN^X0Dg[Z05=jjP000000e3dI0`1CN^X00`000000Dg[Z0000000205AkjP03
0000003D?AT0e3dI00@0e3dI0P1DNnX010000000E7_V05AkiP00000305AkiP040=@m6@1DNnH00000
000000@0DgSO00<0000005=hg`1CN=l00P1CN=l00`000000D7?B051cdP02051cdP080000001@Lm80
000004UY_0000000BFVl0=@m6@00000303eIZ`L0ooK^00@0e3dI0?ofkP3om^h0ooK^1`3D?AT20?of
kP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h0303om^h70=@m6A@0ooK^00<0e3dI0?of
kP3D?AT01P3om^h2000004h0ooK^0@3oool003<0ooK^00<000000?ofkP3om^h06`3om^h0103D?AT0
ooK^0?ofkP3om^h70=@m6@/0ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP080?of
kP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP020?of
kP030000003om^h0ooK^00P0ooK^00@0e3dI000000000000e3dI0`0000060?ofkP040=@m6@000000
000001XYG`80000000<08cUm0=@m6@3D?AT0103D?AT200000003031;W@000000jD<L00@0jD<L0P00
00040>U371H0?EV[0P3aAQh00`000000lDHN0?567P020?567P030000003aAQh0lDHN0080lDHN00<0
000003eIZ`3aAQh00P3aAQh01@000000lDHN0?567P3aAQh0000000<0lDHN00D000000?567P3aAQh0
lDHN000000030?567P0503eIZ`000000lDHN0?567P0000000P1ANNP01@000000DGWX055ij01ANNP0
00000080DGWX0P00000305=jjP040000001CN^X0Dg[Z0=@m6@8000001P3D?AT405AkjP070000001D
NnX0E7_Z05AkjP000000E7_V0000000405AkiP050=@m6@000000E7_V05AkiP0000000P1CN=l00`00
0000DgSO05=hg`0305=hg`050000001@Lm80D7?B051cdP0000000P1@Lm801P000000BFVl00000019
JK`0e3dI000000@0?EV[103om^h60=@m6@T0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^
0?ofkP060?ofkPH0e3dI0P3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^0140ooK^
00<0e3dI0?ofkP3D?AT01P3om^h2000004h0ooK^0@3oool003@0ooK^00<000000?ofkP3om^h06P3o
m^h40=@m6A80ooK^00<0e3dI0?ofkP3om^h0503om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3o
m^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP020?ofkP030000003o
m^h0ooK^0080ooK^1P000000103D?AT0ooK^0?ofkP3D?AT30?ofkPd0e3dI0P0S>Gd010000000e3dI
000000000002031;W@030000000`Bid0000000H0jD<L00@000000>U3703Y@a`0jD<L0P0000000`0m
FJ/0000000000006000000<0lDHN00H000000?567P3aAQh0lDHN03eIZ`0000040?567P030000003a
AQh0lDHN0080lDHN00<000000?567P3aAQh00P3aAQh00`000000?EV[0?567P020?567P050000003a
AQh0lDHN0?567P0000000`3aAQh01@000000lDHN0?567P3aAQh0000000<0lDHN00@0?EV[0?567P3a
AQh000000P1ANNP01@000000DGWX055ij01ANNP0000000<0DGWX00D0000005=jjP1CN^X0Dg[Z0000
00060=@m6@<0Dg[Z00<0000005AkjP1DNnX00P1DNnX2000000D0E7_Z00<0000005AkiP1DNnH00`1D
NnH01`3D?AT0E7_V05AkiP1DNnH0000005=hg`0000001@1CN=l2000000<0D7?B00@00000051cdP1@
Lm8000001019JK`00`3D?AT0?EV[03eIZ`060=@m6@80ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D
?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00H0e3dI203om^h00`3D?AT0ooK^0?ofkP020?of
kP030=@m6@3om^h0ooK^0100ooK^103D?AT60?ofkP800000CP3om^h10?ooo`00=03om^h00`000000
ooK^0?ofkP0J0?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h0503om^h00`3D?AT0
ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0
ooK^0?ofkP030?ofkP@000001P3om^h=0=@m6@80ooK^0P00000201XYG`<0000000<08cUm0000003D
?AT00`0000000`0`Bid00000031;W@02000000<0jD<L1@0000020?567P0303eIZ`000000lDHN00@0
lDHN00<000000?567P3aAQh00`3aAQh01P000000lDHN0?567P0mFJ/0lDHN000000@0lDHN00D00000
0?567P3aAQh0lDHN000000040?567P050000003aAQh0?EV[0?567P000000103aAQh01@000000lDHN
0?567P3aAQh000000080lDHN00<000000?567P3aAQh00P3aAQh00`0mFJ/0lDHN00000002055ij005
0000001ANNP0DGWX055ij00000000`1ANNP60=@m6@80Dg[Z00<000000=@m6@1CN^X00P1CN^X30000
00<0E7_Z00<0000005AkjP1DNnX0101DNnX2000000<0E7_V0P0000000`1DNnH0e3dI05AkiP0205Ak
iP800000101CN=l01P000000DgSO05=hg`000000D7?B000000@0D7?B00<0000004UY_03D?AT0103D
?AT303eIZ`D0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP060=@m6@l0ooK^00D0
e3dI0?ofkP3om^h0ooK^0=@m6@0;0?ofkPL0e3dI00@0ooK^0=@m6@3om^h0e3dI1P3om^h2000004h0
ooK^0@3oool003D0ooK^00<000000?ofkP3om^h06P3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m
6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m
6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h00`3om^h010000000ooK^0?ofkP3om^h;0=@m6@X0
ooK^0`00000201XYG`060000000S>Gd0000002<iO@3D?AT000000P0`Bid01@000000<4^M00000000
0000<4^M00<000000`3aAQh2000000<0lDHN00<0?EV[0000003aAQh0103aAQh00`000000lDHN0?56
7P020?567P060000003aAQh0lDHN0?567P0mFJ/00000103aAQh00`000000lDHN0?567P020?567P09
0000003aAQh0lDHN0?567P000000lDHN03eIZ`3aAQh0000000@0lDHN00D000000?567P3aAQh0lDHN
000000020?567P0:0000003aAQh0lDHN0?567P000000?EV[0?567P000000DGWX00000080DGWX1P3D
?AT2055ij08000000`1CN^X01P000000Dg[Z05=jjP3D?AT0Dg[Z00000080Dg[Z00@0000005AkjP1D
NnX000001@1DNnX20000000505AkjP000000E7_V05AkiP0000000`1DNnH01@3D?AT0E7_V05AkiP1D
NnH0000000@0DgSO00L0000005=hg`1CN=l0DgSO0000001@Lm80000000@0D7?B00D0000004UY_019
JK`0?EV[0=@m6@0503eIZ`D0ooK^00<0e3dI0?ofkP3om^h0203om^h60=@m6@@0ooK^00<0e3dI0?of
kP3om^h03P3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00<0ooK^203D?AT90?ofkP80e3dI1P3om^h2
000004h0ooK^0@3oool003H0ooK^00<000000?ofkP3om^h06@3om^h00`3D?AT0ooK^0?ofkP0C0?of
kP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP0:0?of
kP030=@m6@3om^h0ooK^0080ooK^00@0e3dI0?ofkP3om^h0ooK^2`3D?AT20?ofkP030=@m6@3om^h0
e3dI00`0ooK^0`00000201XYG`060000000S>Gd000000=@m6@0S>Gd000000P0`Bid01@000000<4^M
031;W@000000<4^M008000001@3aAQh01@000000lDHN0?567P0mFJ/0lDHN00800000103aAQh00`00
0000lDHN0?567P020?567P060000003aAQh0lDHN03eIZ`3aAQh00000103aAQh01@000000lDHN0?56
7P3aAQh0000000<0lDHN00D000000?567P3aAQh0?EV[000000030?567P050000003aAQh0lDHN0?56
7P0000000P3aAQh01P000000lDHN0?567P3aAQh0e3dI0?567P80000000<0DGWX0=@m6@3D?AT00P3D
?AT01@000000DGWX055ij01ANNP0000000<0DGWX00<0000005=jjP1CN^X00P00000305=jjP030=@m
6@000000Dg[Z00<0Dg[Z0P00000505AkjP030000001DNnX0E7_Z0080E7_Z0P00000405AkiP030=@m
6@1DNnH0E7_V00800000101CN=l00`000000DgSO05=hg`0205=hg`030000001@Lm80D7?B0080D7?B
0P00000204UY_00403eIZ`3D?AT0?EV[0?ofkP<0?EV[1@3om^h00`3D?AT0ooK^0?ofkP080=@m6@<0
ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP0>0?ofkPP0e3dI4@3om^h20=@m6@H0
ooK^0P00001>0?ofkP40oooo000g0?ofkP030000003om^h0ooK^01P0ooK^00<0e3dI0?ofkP3om^h0
4`3om^h00`3D?AT0ooK^0?ofkP0D0?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h0
2P3om^h00`3D?AT0ooK^0?ofkP0<0=@m6@P0ooK^0P3D?AT=0?ofkP040000000J:El0000001XYG`80
000000<08cUm0000003D?AT00`000000100`Bid000000000000`Bid20000000303YI]P0000000000
00@0lDHN0P0000001@3aAQh0?EV[0?567P3aAQh0000000@0lDHN00<000000?567P3aAQh00P3aAQh0
1P000000lDHN0?567P0mFJ/0lDHN000000<0lDHN00D000000?567P3aAQh0lDHN000000030?567P05
0000003aAQh0lDHN03eIZ`0000000`3aAQh01P000000lDHN0?567P3aAQh000000?567PT0000000D0
DGWX0000001ANNP0DGWX00000003055ij0040000001ANNP0DGWX055ij080000000<0Dg[Z0000001C
N^X00`1CN^X00`000000e3dI05=jjP0405=jjP030000001DNnX0E7_Z00<0E7_Z00<0000005AkjP1D
NnX00`1DNnX00`000000E7_V05AkiP0405AkiP050=@m6@000000E7_V05AkiP0000000P1CN=l00`00
0000DgSO05=hg`0305=hg`030000001@Lm80D7?B0080D7?B00L00000051cdP000000BFVl0000000m
FJ/0e3dI0080ooK^0P0mFJ/80=@m6@/0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?of
kP080?ofkPL0e3dI0`3om^h00`3D?AT0ooK^0?ofkP0@0?ofkP<0e3dI00<0ooK^0=@m6@3om^h01@3o
m^h2000004d0ooK^0@3oool003P0ooK^00<000000?ofkP3om^h0603om^h00`3D?AT0ooK^0?ofkP0C
0?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP07
0?ofkPH0e3dI00<0ooK^0=@m6@3D?AT00`3D?AT20?ofkP030000003om^h0ooK^00T0ooK^0P3D?AT=
0?ofkP80000000<06RUO0000000J:El00`000000103D?AT08cUm0000000`Bid200000005031;W@00
0000<4^M031;W@0000000P0jFKH00`000000lDHN0?567P030?567P030000003aAQh0?EV[0080lDHN
00<000000?567P3aAQh00P3aAQh00`000000lDHN0?567P020?567P050000003aAQh0?EV[0?567P00
0000103aAQh010000000lDHN0?567P0000040?567P040000003aAQh0lDHN03eIZ`<0lDHN00<00000
0?567P3aAQh00`0000001`3hB1l000000?Q87`3hB1l000000?Q87`0000000P1?M^@010000000DGWX
055ij0000002055ij08000000P1ANNP200000080DGWX00<0000005=jjP1CN^X00P1CN^X010000000
Dg[Z05=jjP3D?AT205=jjP<00000101DNnX00`000000E7_Z05AkjP0305AkjP8000001P1DNnH01`3D
?AT0E7_V05AkiP1DNnH0000005=hg`0000001@1CN=l2000000<0D7?B00@00000051cdP1@Lm800000
203D?AT00`0mFJ/0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h0
0`3om^h0103D?AT0ooK^0?ofkP3om^h70=@m6@H0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0<0?of
kPH0e3dI0P3om^h00`3D?AT0ooK^0=@m6@060?ofkP800000C@3om^h10?ooo`00>@3om^h00`000000
ooK^0?ofkP0G0?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0
ooK^0?ofkP060?ofkP040=@m6@3om^h0ooK^0?ofkPH0e3dI00<0ooK^0=@m6@3D?AT0103D?AT00`3o
m^h0e3dI0?ofkP040?ofkP030000003om^h0ooK^00T0ooK^0P3D?AT>0?ofkP80000000<06RUO0000
000000000P0S>Gd00`3D?AT08cUm00000003031;W@040000000`Bid00000031;W@<0000000<0>UVf
000000000000103aAQh00`000000?EV[0?567P020?567P030000003aAQh0lDHN0080lDHN00<00000
0?567P3aAQh00P3aAQh01@000000lDHN03eIZ`3aAQh0000000<0lDHN00D000000?567P3aAQh0lDHN
000000030?567P040000003aAQh0000003eIZ`H0000000/0n4PO0000003hB1l000000?Q87`0mFJ/0
n4PO0000003hB1l0000004mfi00200000005055ij0000000DGWX055ij00000000`1ANNP010000000
DGWX055ij01ANNP2000000<0Dg[Z00L0000005=jjP1CN^X0Dg[Z0=@m6@1CN^X000000080Dg[Z00<0
000005AkjP1DNnX00P00000405AkjP8000000P1DNnX010000000E7_V05AkiP1DNnH2000000030=@m
6@1DNnH0E7_V0080E7_V00<0000005=hg`1CN=l00`1CN=l00`000000DgSO0=@m6@070=@m6@040000
003om^h0?EV[0=@m6@<0ooK^0P0mFJ/40?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3o
m^h01`3D?AT>0?ofkP040=@m6@3om^h0ooK^0=@m6@H0ooK^1P3D?AT80?ofkP030=@m6@3om^h0e3dI
00H0ooK^0P00001=0?ofkP40oooo000i0?ofkP030000003om^h0ooK^01L0ooK^00<0e3dI0?ofkP3o
m^h04`3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^00H0ooK^2`3D?AT30?ofkP05
0=@m6@3om^h0ooK^0?ofkP3D?AT0103om^h00`000000ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^
00`0ooK^0`0000000`0J:El000000000000202<iO@030=@m6@0S>Gd0000000<0<4^M0`0000000`0`
Bid0000003YI]P020000000303YI]P000000000000<0lDHN00<0000003eIZ`3aAQh00P3aAQh00`00
0000lDHN0?567P020?567P090000003aAQh0lDHN0?567P000000lDHN03eIZ`3aAQh0000000H0lDHN
1`0000000`3hB1l0000003eIZ`020?Q87`050000003hB1l0n4PO0000003hB1l00`0mFJ/01P3hB1l0
00000?Q87`000000CgKT00000080CgKT00@00000055ij01ANNP000000`1ANNP00`000000DGWX055i
j00200000080DGWX0`00000405=jjP030=@m6@000000Dg[Z00<0Dg[Z0P00000505AkjP030000001D
NnX0E7_Z0080E7_Z00@0000005AkiP1DNnH000000`1DNnH0103D?AT0E7_V05AkiP0000080=@m6@04
05=hg`000000D7?B000000@0D7?B00D000000?ofkP3om^h0?EV[0=@m6@020?ofkP<0?EV[0`3om^h0
0`3D?AT0ooK^0?ofkP080?ofkPL0e3dI0`3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP040=@m6@3om^h0
ooK^0?ofkPH0e3dI3@3om^h40=@m6@H0ooK^0P00001=0?ofkP40oooo000j0?ofkP030000003om^h0
ooK^01L0ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP040=@m6@3om^h0
ooK^0?ofkPP0e3dI2`3om^h0103D?AT0ooK^0?ofkP3D?AT40?ofkP030000003om^h0ooK^00X0ooK^
0P3D?AT?0?ofkP<0000000L06RUO0000000S>Gd08cUm0=@m6@0000008cUm008000000`0`Bid30000
00<0>UVf0P0000000`0jFKH000000?567P020?567P0303eIZ`000000lDHN0080lDHN0P0000030?56
7P070000003aAQh0lDHN0?567P000000lDHN03eIZ`07000000030?Q87`000000n4PO0080n4PO00D0
00000?Q87`3hB1l0000003eIZ`020?Q87`030000000mFJ/0?EV[0080?EV[00X000000?Q87`3hB1l0
00000?Q87`000000CgKT0000001?M^@0e3dI0P0000000`1ANNP00000055ij002055ij0040000001A
NNP0DGWX000000@0DGWX00<0000005=jjP1CN^X00`1CN^X2000000030=@m6@1CN^X0Dg[Z0080Dg[Z
00<0000005AkjP1DNnX00`1DNnX00`000000E7_Z05AkjP0405AkjP8000000P1DNnH60=@m6@050000
001CN=l0DgSO05=hg`0000001@1CN=l2000000<0D7?B00H000000?ofkP3om^h0ooK^03eIZ`3D?AT2
0?ofkP<0?EV[0`3om^h0103D?AT0ooK^0?ofkP3om^h70=@m6@@0ooK^00<0e3dI0?ofkP3om^h00`3o
m^h00`3D?AT0ooK^0?ofkP0<0?ofkPP0e3dI2`3om^h70=@m6@80ooK^0P3D?AT60?ofkP800000C@3o
m^h10?ooo`00>`3om^h00`000000ooK^0?ofkP0F0?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI
0?ofkP3om^h0403om^h70=@m6@@0ooK^00<0e3dI0?ofkP3om^h0303om^h0103D?AT0ooK^0?ofkP3D
?AT40?ofkP030000003om^h0ooK^00X0ooK^0P3D?AT@0?ofkP030000000J:El0000000<0000000D0
8cUm0=@m6@0S>Gd00000031;W@02000000<0<4^M0`00000303YI]P040000000jFKH0000000000080
lDHN00<0?EV[0000000000000`3aAQh00`000000lDHN0?567P060000000403eIZ`3hB1l0n4PO0000
00<0n4PO00@000000?Q87`3hB1l000000P3hB1l00`000000n4PO0?Q87`0503eIZ`0;0?Q87`000000
n4PO0?Q87`000000n4PO0000003hB1l0000004mfi00000000P1?M^@0103D?AT0CgKT04mfi0000002
055ij08000000P1ANNP010000000DGWX055ij01ANNP200000003055ij0000000Dg[Z0080Dg[Z00@0
000005=jjP1CN^X0e3dI0P1CN^X20000000405=jjP000000E7_Z05AkjP8000001@1DNnX60=@m6@80
E7_V00<0e3dI0000001DNnH00P1DNnH00`000000DgSO0000000605=hg`030000001@Lm80D7?B0080
D7?B00H000000?ofkP3om^h0ooK^03eIZ`3D?AT20?ofkP<0?EV[1`3D?AT<0?ofkP030=@m6@3om^h0
ooK^0080ooK^00<0e3dI0?ofkP3om^h0103om^h80=@m6@<0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m
6@030?ofkPP0e3dI2@3om^h20=@m6@H0ooK^0P00001=0?ofkP40oooo000l0?ofkP030000003om^h0
ooK^01D0ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP090?ofkPL0e3dI0`3om^h0
0`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00`0ooK^00@0e3dI0?ofkP3om^h0e3dI103o
m^h00`000000ooK^0?ofkP0:0?ofkP030=@m6@3om^h0e3dI00l0ooK^0P00000201XYG`040000000S
>Gd000000=@m6@808cUm00<00000031;W@0`Bid00P000003031;W@<000000P0jFKH20000000303eI
Z`000000lDHN0080lDHN1`0000020?Q87`8000000P3hB1l01@000000?EV[0?Q87`3hB1l000000080
n4PO00@000000?Q87`3hB1l000001@0mFJ/010000000n4PO03eIZ`0000020?Q87`030000003hB1l0
00000080n4PO0P0000001P1?M^@0000004mfi01?M^@000000=@m6@<0000000<0DGWX0000001ANNP0
0P1ANNP01@000000DGWX055ij01ANNP0000000<0DGWX00@0000005=jjP00000000000`1CN^X00`3D
?AT000000000000305=jjP040000001DNnX0000005AkjPH0e3dI0`00000405AkiP80000000@0e3dI
05AkiP1DNnH0E7_V0P00000605=hg`8000000`1@Lm8010000000ooK^0?ofkP3om^h80=@m6@<0ooK^
00<0e3dI0?ofkP3om^h03@3om^h0103D?AT0ooK^0?ofkP3om^h80=@m6@`0ooK^1`3D?AT>0?ofkPD0
e3dI1`3om^h00`000000ooK^0?ofkP1;0?ofkP40oooo000m0?ofkP030000003om^h0ooK^01D0ooK^
00<0e3dI0?ofkP3om^h04`3om^h0103D?AT0ooK^0?ofkP3om^h70=@m6@/0ooK^00<0e3dI0?ofkP3o
m^h0103om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0e3dI00@0ooK^00<000000?ofkP3o
m^h02P3om^h00`3D?AT0ooK^0=@m6@0=0?ofkP<0e3dI0P00000201XYG`050000000S>Gd0e3dI0000
000S>Gd00`000002031;W@80000000<0<4^M0000000jFKH01P3D?AT010000000>UVf000000000002
0?Q87`80000000<0n4PO03eIZ`0mFJ/00`0mFJ/01@3hB1l000000?Q87`3hB1l0?EV[0080n4PO00<0
000003eIZ`0mFJ/0100mFJ/00`000000n4PO000000020?Q87`040000003hB1l0n4PO03eIZ`80n4PO
00@000000?Q87`000000n4PO0P00000204mfi0060000001?M^@0000004mfi0000000e3dI0P1?M^@0
0`000000DGWX055ij00200000080DGWX0P000005055ij0030000001CN^X0Dg[Z00<0Dg[Z00@00000
0=@m6@1CN^X0Dg[Z1P3D?AT405AkjP8000000`1DNnX010000000E7_V05AkiP00000205AkiP050=@m
6@1DNnH0E7_V05AkiP0000001P1CN=l010000000DgSO0000001@Lm860=@m6@0503eIZ`3om^h0?EV[
0=@m6@3om^h0100mFJ/20?ofkP030=@m6@3om^h0ooK^00X0ooK^1`3D?AT00`3om^h0e3dI0?ofkP0:
0?ofkPP0e3dI0P3om^h00`3D?AT0ooK^0?ofkP070?ofkPP0e3dI0P3om^h30=@m6@L0ooK^0P00001<
0?ofkP40oooo000n0?ofkP030000003om^h0ooK^01@0ooK^00<0e3dI0?ofkP3om^h0403om^h70=@m
6A80ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0e3dI
00@0ooK^00<000000?ofkP3om^h02P3om^h0103D?AT0ooK^0?ofkP3D?AT60?ofkPH0e3dI0`3om^h3
000000806RUO00H0000002<iO@3D?AT0000002<iO@0000080=@m6@80>UVf0`00000203YI]P800000
00<0@FC80000000000000P3hB1l200000080n4PO00<000000?Q87`0mFJ/01`0mFJ/010000000n4PO
0?Q87`0000020?Q87`060000003hB1l0n4PO0000003hB1l000000P3hB1l02P0mFJ/0n4PO0000003h
B1l000000?Q87`000000n4PO0000001?M^@30000000404mfi0000000CgKT0=@m6@<0000000@0DGWX
0000001ANNP0DGWX0P000005055ij0<000000`1CN^X60=@m6@0405=jjP0000000000000000D0E7_Z
00<0000005AkjP1DNnX00`1DNnX00`000000E7_V0000000305AkiP050=@m6@1DNnH0E7_V0000000m
FJ/01@1CN=l010000000DgSO05=hg`1CN=l20000000303eIZ`3om^h0ooK^0080ooK^00D0?EV[0?of
kP0mFJ/0e3dI03eIZ`020?ofkP80?EV[0P3om^h00`3D?AT0ooK^0?ofkP020?ofkPP0e3dI0`3om^h0
0`3D?AT0ooK^0?ofkP020?ofkP040=@m6@3om^h0ooK^0?ofkPP0e3dI203om^h0103D?AT0ooK^0=@m
6@3om^h80=@m6@@0ooK^1P3D?AT20?ofkP030=@m6@3om^h0ooK^00D0ooK^0P00001<0?ofkP40oooo
000n0?ofkP030000003om^h0ooK^01@0ooK^00<0e3dI0?ofkP3om^h02@3om^h70=@m6@<0ooK^00<0
e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0
e3dI0?ofkP3D?AT0103om^h00`000000ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00L0e3dI2@3o
m^h0103D?AT000000000000000070=@m6@<0<4^M0P000002031;W@8000000`0jFKH300000080>UVf
0P0000000`11I<P00000000000020?Q87`80000000<0n4PO0000000000000P3hB1l20000000503eI
Z`000000n4PO0?Q87`0000000P3hB1l03P000000n4PO0?Q87`000000n4PO0000003hB1l000000?Q8
7`000000n4PO03eIZ`000000n4PO0P0000000`3hB1l0000004mfi0020000000304mfi00000000000
0080CgKT00D0e3dI04mfi01?M^@0CgKT00000002055ij0030000001ANNP0DGWX00<0DGWX203D?AT3
05=jjP040=@m6@1CN^X0000000000080Dg[Z00@0000005AkjP1DNnX0E7_Z0P00000705AkjP030000
001DNnH0E7_V00<0E7_V00D0e3dI0000001DNnH0E7_V0000000305=hg`030000001CN=l0DgSO0080
DgSO0P0000001@0mFJ/0ooK^0?ofkP3om^h0?EV[0080ooK^00<0?EV[0?ofkP3D?AT00P3om^h00`0m
FJ/0e3dI0=@m6@060=@m6@`0ooK^203D?AT>0?ofkPH0e3dI1`3om^h50=@m6@D0ooK^103D?AT70?of
kP800000C03om^h10?ooo`00?`3om^h00`000000ooK^0?ofkP0D0?ofkP040=@m6@3om^h0ooK^0?of
kPL0e3dI2`3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?of
kP3om^h03P3om^h20=@m6@@0ooK^00<000000?ofkP3om^h0203om^h60=@m6@`0ooK^1`3D?AT01@0J
:El000000000003D?AT0000000808cUm0P000003031;W@80000000@0<4^M00000000000000000`0j
FKH400000004045Tb0000000e3dI045Tb08000000P3hB1l010000000n4PO0?Q87`0000030?Q87`03
0000000mFJ/000000080n4PO00<000000?Q87`0000000P3hB1l02`000000n4PO0000003hB1l00000
0?Q87`000000n4PO0000000mFJ/000000080n4PO00H0000004mfi0000000000004mfi000000204mf
i080000000<0CgKT0=@m6@0000000P0000080=@m6@@0DGWX0P00000505=jjP030000003D?AT0Dg[Z
00@0Dg[Z0`00000705AkjP<00000101DNnH00`000000e3dI05AkiP0205AkiP040000001CN=l0DgSO
000000D0DgSO00<000000?ofkP0mFJ/00`3om^h00`0mFJ/0ooK^0=@m6@060=@m6@80?EV[00<0ooK^
0=@m6@3om^h02@3om^h70=@m6@<0ooK^00<0e3dI0?ofkP3om^h02@3om^h60=@m6@80ooK^00<0e3dI
0?ofkP3D?AT00P3om^h60=@m6@80ooK^203D?AT;0?ofkP800000C03om^h10?ooo`00@03om^h00`00
0000ooK^0?ofkP0C0?ofkP@0e3dI4P3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^
00<0ooK^00<0e3dI0?ofkP3om^h03P3om^h20=@m6@@0ooK^00<000000?ofkP3om^h00P3om^h60=@m
6@80ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@030?ofkPP0e3dI0`3om^h0103D?AT0ooK^00000000
000201XYG`030000000S>Gd0e3dI0080000000@08cUm00000000000000000`0`Bid200000080>UVf
0`00000203YI]P@0000000<0e3dI0000000000000`000000103hB1l000000000003hB1l200000080
n4PO00D0?EV[0?Q87`000000n4PO000000020?Q87`080000003hB1l0n4PO0?Q87`000000n4PO0000
003hB1l70000000604aagP000000000004mfi0000000CgKT0P0000070=@m6@@0DGWX0P000004055i
j080000000<0DGWX0000001CN^X00P1CN^X20000000305=jjP3D?AT0Dg[Z00<0Dg[Z0P00000705Ak
jP8000000P1DNnX01`000000E7_V05AkiP1DNnH0000005AkiP3D?AT0101DNnH2000000D0DgSO00<0
00000=@m6@3D?AT01P3D?AT20?ofkP0303eIZ`3D?AT0ooK^0080ooK^0P0mFJ/00`3om^h0e3dI0?of
kP020?ofkPL0e3dI1P3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00D0ooK^1P3D?AT70?ofkPh0e3dI
4`3om^h2000004`0ooK^0@3oool00440ooK^00<000000?ofkP3om^h04P3om^h00`3D?AT0ooK^0?of
kP0C0?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?of
kP0?0?ofkP040=@m6@3om^h0ooK^0?ofkPH0e3dI203om^h00`3D?AT0ooK^0=@m6@050=@m6@/0ooK^
00<0e3dI0?ofkP3om^h00P00000201XYG`040000003D?AT08cUm02<iO@8000000P0`Bid2000000<0
<4^M0P00000303YI]P<0000000@0>UVf000000000000e3dI0P0000000`11I<P00000000000020000
00050?Q87`00000000000?Q87`0000000P3hB1l01`0mFJ/000000000003hB1l000000?Q87`000000
0P3hB1l6000000030?e;8000000000000080000000<0C77N0000000000001P3D?AT20000000504mf
i03D?AT0000004mfi00000000P1ANNP2000000@0DGWX0P000004055ij0<00000101CN^X0103D?AT0
000000000000000205=jjP030000001DNnX0E7_Z0080E7_Z0P00000505AkjP<000000`1DNnH0103D
?AT0E7_V05AkiP1DNnH80=@m6@<0ooK^00<0?EV[0?ofkP0mFJ/0103om^h203eIZ`030=@m6@3om^h0
ooK^00L0e3dI3P3om^h00`3D?AT0ooK^0?ofkP060=@m6@H0ooK^3@3D?ATL0?ofkP030000003om^h0
ooK^04X0ooK^0@3oool00480ooK^00<000000?ofkP3om^h04P3om^h00`3D?AT0ooK^0?ofkP0C0?of
kP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP0;0?of
kPP0e3dI00<0ooK^0000003om^h0203om^h50=@m6@80ooK^00<0e3dI0?ofkP3om^h02`3om^h0103D
?AT0ooK^0?ofkP3om^h30000000401XYG`00000000000=@m6@<08cUm0P000002031;W@8000000P0`
Bid4000000<0>UVf0`0000000`11I<P0e3dI0000000200000003045Tb000000000000080000000L0
n4PO0000003hB1l000000?Q87`0mFJ/0n4PO00T0000000<0oD/P0000003mBb000P000000103mBb00
00000000001<LMh300000080CgKT00D0000004mfi0000000000004mfi0020000000304mfi03D?AT0
CgKT00<000000`1ANNP3000000D0DGWX0P00000505=jjP030000003D?AT0Dg[Z00@0Dg[Z00<00000
05AkjP1DNnX00P00000705AkjP040000001DNnH0E7_V05AkiPH0e3dI00<0000005=hg`1CN=l00P1C
N=l00`3D?AT0ooK^0?ofkP030?ofkP0303eIZ`3om^h0?EV[0080ooK^1`3D?AT203eIZ`030?ofkP3D
?AT0ooK^00d0ooK^1`3D?AT30?ofkPh0e3dI8`3om^h2000004/0ooK^0@3oool004<0ooK^00<00000
0?ofkP3om^h04@3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI
0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP020?ofkPT0e3dI103om^h00`3D?AT0ooK^0?ofkP02
0?ofkP040000003om^h0ooK^0?ofkPH0e3dI0`3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3o
m^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h00P3om^h5000000060=@m6@0000008cUm02<iO@000000
<4^M0P000002031;W@<000000`0jFKH300000080>UVf0P0000000`3D?AT0@FC8045Tb00400000003
045Tb0000000000000H0000000X0oD/P000000000000oD/P0000003mBb0000000?e;80000000oD/P
0P0000001@3mBb000000000000000000C77N00<0000000<0C77N0000001?M^@00P0000000`1?M^@0
00000000000204mfi0050000003D?AT0000004mfi00000000P1ANNP2000000D0DGWX0`000000101A
NNP0000005=jjP1CN^X300000080Dg[Z00<0e3dI05=jjP1CN^X00P1CN^X3000000L0E7_Z1P3D?AT2
05AkiP030=@m6@000000E7_V0080E7_V00D0000005=hg`1CN=l000000=@m6@030?ofkPL0e3dI0`3o
m^h0100mFJ/0e3dI0?ofkP3om^h303eIZ`030=@m6@3om^h0ooK^00@0ooK^203D?AT30?ofkPh0e3dI
:P3om^h2000004/0ooK^0@3oool004<0ooK^00<000000?ofkP3om^h04@3om^h00`3D?AT0ooK^0?of
kP0C0?ofkP030=@m6@3om^h0ooK^01@0ooK^00@0e3dI0?ofkP3om^h0ooK^1@3D?AT=0?ofkP80e3dI
0P3om^h50=@m6@T0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m
6@3om^h0ooK^00<0ooK^00H04QY00000000J:El000000=@m6@0S>Gd20000000402<iO@000000<4^M
031;W@<0000000@0<4^M0000000000000000100jFKH20000000403YI]P000000@FC80=@m6@800000
00<0@FC80000000000002P0000020?e;80@0000000<0oD/P0000000000001@000000101<LMh00000
0000001<LMh40000000304mfi000000000000080?EV[0P00000204mfi0030=@m6@1?M^@000000080
0000101ANNP3000000@0DGWX0`00000505=jjP030=@m6@1CN^X000000080000000<0Dg[Z0000001D
NnX00P1DNnX50=@m6@<0E7_Z00@0000005AkiP1DNnH0E7_V0P0000001`3D?AT0E7_V05AkiP1DNnH0
000005=hg`0mFJ/01@3D?AT30?ofkP0303eIZ`3om^h0ooK^00@0ooK^00@0?EV[0?ofkP3D?AT0ooK^
0P0mFJ/80=@m6@@0ooK^3@3D?ATb0?ofkP800000B`3om^h10?ooo`00A03om^h00`000000ooK^0?of
kP0A0?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h04`3om^h01@3D?AT0ooK^0?of
kP3om^h0e3dI00l0ooK^1P3D?AT00`000000ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00@0ooK^
00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP030?ofkP<0000000<06RUO0000003D?AT0
0P0S>Gd2000000D0<4^M0`0000000`0jFKH0000000000002000000<0>UVf0P0000000`3D?AT00000
045Tb00?000000030?e;80000000000000h0000000D0C77N000000000000000003eIZ`02000000<0
CgKT0P000000103D?AT0000004mfi0000002055ij0<000000`1ANNP400000003055ij0000000Dg[Z
00@0Dg[Z0P0000000`3D?AT0Dg[Z05=jjP060=@m6@0305AkjP000000000000D0E7_Z00@0000005Ak
iP00000000000P1DNnH00`3D?AT0E7_V05AkiP0205AkiP040000003D?AT0ooK^0=@m6@H0ooK^00<0
?EV[0?ofkP3om^h00`3om^h80=@m6@<0ooK^3P3D?ATi0?ofkP800000B`3om^h10?ooo`00A@3om^h0
0`000000ooK^0?ofkP0@0?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h04`3om^h0
1@3D?AT0ooK^0?ofkP3om^h0e3dI00P0ooK^1`3D?AT0103om^h0e3dI0?ofkP3D?AT20?ofkP030000
003om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m
6@3om^h0ooK^0080ooK^0P3D?AT30000000301XYG`3D?AT0000000<08cUm0P000005031;W@<00000
0`0jFKH30000000303YI]P3D?AT0e3dI00P0e3dI00<0@FC80000000000006`00000204mfi0@00000
0`1?M^@00`3D?AT000000000000200000080DGWX10000006055ij0040000001CN^X00000000000H0
e3dI0`1CN^X010000000E7_Z00000000000705AkjP8000001@1DNnH01`3D?AT0E7_V000000000000
?EV[0?ofkP3D?AT01P3om^h70=@m6@0403eIZ`3om^h0?EV[0?ofkPd0e3dI@@3om^h2000004/0ooK^
0@3oool004H0ooK^00<000000?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP0D0?ofkP030=@m6@3o
m^h0ooK^01<0ooK^00@0e3dI0?ofkP3D?AT0ooK^203D?AT80?ofkP060=@m6@3om^h0ooK^0=@m6@3o
m^h00000303om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00H0ooK^203D?AT20?of
kP80000000@06RUO000000000000e3dI0P00000202<iO@@00000100`Bid2000000H0e3dI0P000000
0`3D?AT00000045Tb002045Tb2<0000000<0CgKT000000000000100000000`3D?AT0000000000004
000000H0DGWX203D?AT405=jjP040=@m6@1CN^X0Dg[Z05=jjP<000001P1DNnX30000000305AkjP00
0000E7_V00@0E7_V00D0e3dI0000003om^h0ooK^03eIZ`080=@m6@0403eIZ`3om^h0?EV[0?ofkP`0
e3dIBP3om^h00`000000ooK^0?ofkP190?ofkP40oooo00170?ofkP030000003om^h0ooK^00l0ooK^
00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP0@0?ofkPL0e3dI403om^h01P3D?AT0ooK^
0?ofkP3D?AT0ooK^000000`0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0=@m6@050=@m
6@<0ooK^00<0e3dI0?ofkP3om^h01@3om^h2000000806RUO00<0e3dI02<iO@0S>Gd00`000003031;
W@030000003D?AT0e3dI00<0e3dI0`0jFKH30000000403YI]P000000@FC80=@m6@H0000000<0@FC8
0000000000007P0000000`1?M^@0000000000004000000040=@m6@1?M^@0CgKT000000P0e3dI0P00
0002055ij0030000001CN^X0Dg[Z00D0Dg[Z00H0e3dI000000000000000005=jjP00000505AkjP80
0000101DNnX010000000E7_V05AkiP1DNnH80=@m6@<0ooK^3@3D?AT01P3om^h0?EV[0?ofkP0mFJ/0
ooK^03eIZd/0ooK^00<000000?ofkP3om^h0B@3om^h10?ooo`00B03om^h00`000000ooK^0?ofkP0>
0?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h02@3om^h70=@m6@@0ooK^0P3D?ATA
0?ofkP060=@m6@3om^h0ooK^0?ofkP3D?AT00000303om^h0103D?AT0ooK^0?ofkP3om^h60=@m6@T0
ooK^00<0e3dI0?ofkP3om^h01P3om^h01@0000006RUO01XYG`0J:El0e3dI00808cUm1P3D?AT3031;
W@@000001@0jFKH2000000030=@m6@0000000000008000000P11I<PR000000<0CgKT1`3D?AT40000
00T0DGWX00<0000005=jjP1CN^X0100000000`1CN^X0e3dI05=jjP0305=jjP030000001DNnX00000
008000000`1DNnX70=@m6@80ooK^3`3D?AT00`0mFJ/0ooK^0?ofkP020?ofkP0703eIZ`3om^h0ooK^
03eIZ`3om^h0?EV[0?ofkP0203eIZdX0ooK^0P00001:0?ofkP40oooo00180?ofkP030000003om^h0
ooK^00l0ooK^00<0e3dI0?ofkP3om^h04`3om^h0103D?AT0ooK^0?ofkP3om^h70=@m6@/0ooK^0P3D
?ATA0?ofkP060=@m6@3om^h0ooK^0?ofkP3D?AT000002@3om^h70=@m6@D0ooK^00<0e3dI0?ofkP3o
m^h01P3om^h00`3D?AT0ooK^0?ofkP070?ofkP030000003D?AT0e3dI00@0e3dI0P0S>Gd00`000000
<4^M00000002000000<0<4^M00<0000003YI]P0jFKH01@000000100jFKH00000045Tb03D?AT3045T
b24000001P3D?AT01@000000CgKT04mfi01?M^@0e3dI0080CgKT00<00000055ij01ANNP0101ANNP9
000000D0Dg[Z00<0e3dI05=jjP1CN^X00P0000080=@m6@80E7_Z3P3D?AT40?ofkP0303eIZ`3om^h0
ooK^0080ooK^00@0?EV[0?ofkP3om^h0?EV[103om^h203eIZ`80ooK^00<0?EV[0?ofkP3om^h0B03o
m^h2000004X0ooK^0@3oool004T0ooK^00<000000?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0@
0?ofkPL0e3dI4`3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00<0ooK^00@0e3dI
0?ofkP3om^h0ooK^1P3D?AT30?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h01P3o
m^h0103D?AT0ooK^0?ofkP3om^h70=@m6@060000000J:El0000001XYG`3D?AT08cUm0P0000000`0S
>Gd00000031;W@02031;W@<0000000<0<4^M0000000jFKH01@0jFKH3000000030=@m6@0000000000
02d0000000<0e3dI0000000000001P000006055ij0030000001CN^X0Dg[Z0080Dg[Z0P0000060=@m
6@0305=jjP000000E7_Z00D0E7_Z00<0?EV[0=@m6@3D?AT01P3D?AT00`0mFJ/0ooK^0?ofkP030?of
kP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h00P3om^h0100mFJ/0ooK^0?ofkP0mFJ/4
0?ofkP80?EV[0P3om^h00`0mFJ/0ooK^0?ofkP180?ofkP800000BP3om^h10?ooo`00BP3om^h00`00
0000ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00T0ooK^1`3D?AT40?ofkP030=@m6@3om^h0ooK^
01<0ooK^00<0e3dI0?ofkP3om^h03P3om^h0103D?AT0ooK^0?ofkP3om^h60=@m6@T0ooK^00<0e3dI
0?ofkP3om^h01`3om^h0103D?AT0ooK^0?ofkP3om^h80=@m6@L0ooK^0P0000000`0J:El000000=@m
6@0302<iO@8000001P0`Bid<000000030=@m6@0000000000008000001@11I<P20000000304M/e000
0000000000`0000000<0od`P0000000000003@00000504mfi0030=@m6@000000DGWX00H0DGWX1P00
00060=@m6@<0Dg[Z0P3D?AT205=jjP030000001DNnX0e3dI00H0e3dI1P3om^h00`0mFJ/0ooK^0?of
kP040?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/01P3om^h00`0mFJ/0ooK^03eIZ`050?ofkP0403eI
Z`3om^h0ooK^03eIZdX0ooK^0P00001:0?ofkP40oooo001;0?ofkP030000003om^h0ooK^00d0ooK^
00@0e3dI0?ofkP3om^h0ooK^1`3D?AT;0?ofkP030=@m6@3om^h0ooK^0180ooK^00<0e3dI0?ofkP3D
?AT03@3om^h60=@m6@80ooK^00<000000=@m6@3om^h02@3om^h00`3D?AT0ooK^0?ofkP050?ofkPL0
e3dI103om^h00`3D?AT0ooK^0?ofkP090?ofkP8000000P0J:El00`3D?AT0000002<iO@0202<iO@D0
00000`0`Bid00`000000>UVf03YI]P0603YI]P040000003D?AT0@FC8045Tb0D000000`11I<P80000
00030?m<8000000000000080000000<0od`P0000000000000P0000000`3oC2000000000000050000
00H0CgKT3P0000060=@m6@03055ij0000000Dg[Z00H0Dg[Z1P3D?AT00`000000ooK^0?ofkP030?of
kP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h0103om^h01@0mFJ/0ooK^0?ofkP3om^h0
?EV[00H0ooK^00<0?EV[0?ofkP0mFJ/01@3om^h0100mFJ/0ooK^0?ofkP0mFJ];0?ofkP030000003o
m^h0ooK^04P0ooK^0@3oool004`0ooK^00<000000?ofkP3om^h0303om^h40=@m6A<0ooK^00<0e3dI
0?ofkP3om^h04@3om^h00`3D?AT0ooK^0=@m6@070?ofkPH0e3dI0P3om^h00`3D?AT0ooK^0?ofkP03
0?ofkP030000003D?AT0ooK^00T0ooK^203D?AT40?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI
0?ofkP3om^h02P3om^h20000000301XYG`3D?AT08cUm008000000P0S>Gd010000000<4^M031;W@0`
Bid>000000030=@m6@000000@FC80080@FC81@3D?AT9000000030?m<80000000od`P00P0000000<0
md/P03eIZ`0000003P00000204mfi0030000003D?AT0DGWX00@0e3dI1`1ANNP00`000000Dg[Z05=j
jP0205=jjP0303eIZ`3D?AT0e3dI0080?EV[00<000000?ofkP3om^h0203om^h00`0mFJ/0ooK^0?of
kP020?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP0mFJ/01`3om^h203eIZ`H0ooK^00@0
?EV[0?ofkP3om^h0?EV[B`3om^h00`000000ooK^0?ofkP180?ofkP40oooo001=0?ofkP030000003o
m^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP0A0?ofkP030=@m6@3o
m^h0ooK^00L0e3dI203om^h00`3D?AT0ooK^0?ofkP030?ofkP030000003om^h0e3dI00<0ooK^1`3D
?AT;0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h0203om^h30=@m6@<0000000@0
6RUO0=@m6@0S>Gd08cUm0`000007031;W@030000000jFKH0>UVf00@0>UVf203D?AT010000000@FC8
000000000002045Tb080000000<0od`P0000003oC2001`0000001@3gBb0000000?M;80000000md/P
00@0000000<0?EV[0?M;803gBb001P00000403eIZaL0000000<0?EV[0?ofkP0mFJ/03@3om^h01@0m
FJ/0ooK^0?ofkP3om^h0?EV[00T0ooK^00<0?EV[0?ofkP0mFJ/0203om^h00`0mFJ/0ooK^0?ofkP03
0?ofkP0503eIZ`3om^h0?EV[0?ofkP0mFJ/0B`3om^h2000004T0ooK^0@3oool004d0ooK^00<00000
0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP0D0?ofkP030=@m6@3om^h0ooK^0100ooK^103D?AT=
0?ofkP030=@m6@3om^h0ooK^00<0ooK^1`3D?AT60?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI
0?ofkP3om^h00P3om^h0103D?AT0ooK^0?ofkP3om^h70=@m6@@0ooK^0P0000000`0J:El000000=@m
6@0302<iO@D000000`0`Bid70=@m6@@0000000@0e3dI045Tb011I<P0@FC80P000002045Tb0L00000
00T0?EV[0000003gBb00md/P0000003gBb0000000?M;800000000P3gBb02000000040?M;80000000
000003eIZ`800000103gBb0203eIZ`D00000103KA1d00`0mFJ/0fd@M0=]47@09000000H0ooK^0P0m
FJ/>0?ofkP0403eIZ`3om^h0ooK^03eIZ`/0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^
0?ofkP030?ofkP0503eIZ`3om^h0?EV[0?ofkP0mFJ/0B`3om^h2000004T0ooK^0@3oool004h0ooK^
00<000000?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^0100ooK^
00D0e3dI0?ofkP3om^h0ooK^0=@m6@0;0?ofkPL0e3dI00D000000?ofkP3om^h0ooK^0=@m6@080?of
kP030=@m6@3om^h0ooK^00/0ooK^203D?AT<0?ofkP050000000J:El06RUO0=@m6@0000000`0S>Gd7
0=@m6@H00000100jFKH00`000000@FC80=@m6@0200000080@FC80`000000103gBb0000000000003g
Bb020000000503eIZ`000000md/P0?M;800000000P3gBb000`000000md/P000000030?M;80050000
003gBb00md/P0000000mFJ/00P00000303eIZ`H0fd@M1P0000000`0mFJ/000000000000>0?ofkP03
03eIZ`3om^h0ooK^00h0ooK^0P0mFJ/<0?ofkP0303eIZ`3om^h0ooK^00H0ooK^0P0mFJ/50?ofkP05
03eIZ`3om^h0?EV[0?ofkP0mFJ/0B`3om^h2000004T0ooK^0@3oool004l0ooK^00<000000?ofkP3o
m^h02`3om^h00`3D?AT0ooK^0?ofkP0D0?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3o
m^h00P3om^h00`3D?AT0ooK^0?ofkP020?ofkPL0e3dI00<0ooK^0=@m6@3om^h0103om^h01@000000
ooK^0?ofkP3om^h0e3dI00L0ooK^00<0e3dI0?ofkP3om^h01`3om^h70=@m6@80ooK^00<0e3dI0?of
kP3om^h03P3om^h70=@m6@8000001P0`Bid00`000000>UVf03YI]P0303YI]PH0000000T0e3dI045T
b00000000000045Tb0000000md/P0000003gBb000`0000000`3gBb00000003eIZ`020?M;80030000
003gBb00000000P000001@0mFJ/<000000<0ooK^00<0?EV[0?ofkP3om^h0303om^h303eIZa00ooK^
00<0?EV[0?ofkP3om^h02P3om^h203eIZ`P0ooK^00<0?EV[0?ofkP0mFJ/00`3om^h01P0mFJ/0ooK^
0?ofkP0mFJ/0ooK^03eIZd/0ooK^0P0000190?ofkP40oooo001@0?ofkP030000003om^h0ooK^00/0
ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00L0
e3dI203om^h00`3D?AT0ooK^0?ofkP030?ofkP030000003om^h0ooK^0080ooK^00<0e3dI0?ofkP3o
m^h0103om^h0103D?AT0ooK^0?ofkP3om^h60=@m6@H0ooK^00<0e3dI0?ofkP3D?AT02P3om^h70=@m
6@@0000000@0e3dI02<iO@0S>Gd08cUm3@00000403YI]P0500000011I<P0000000000011I<P00P00
0000103gBb0000000?M;800000020?M;80<0000000<0?EV[0000000000000P0000000`3KA1d0?EV[
03eIZ`0603eIZ`040=]47@000000000003eIZ`L000002P3om^h00`0mFJ/0ooK^0?ofkP090?ofkP80
?EV[0`3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP80?EV[2`3om^h0100mFJ/0ooK^0?ofkP0mFJ/60?of
kP0403eIZ`3om^h0ooK^03eIZ`<0ooK^00@0?EV[0?ofkP3om^h0ooK^0P0mFJ]<0?ofkP030000003o
m^h0ooK^04L0ooK^0@3oool00540ooK^00<000000?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP0D
0?ofkP030=@m6@3om^h0ooK^00T0ooK^1`3D?AT40?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI
0?ofkP3om^h0103om^h00`000000ooK^0?ofkP030?ofkP030=@m6@3om^h0e3dI00L0e3dI3@3om^h2
0=@m6@<0ooK^1`3D?AT70?ofkP030=@m6@0000006RUO0080000000<0e3dI02<iO@0S>Gd00P0S>Gd0
0`000000<4^M031;W@04031;W@030000000jFKH0>UVf00D0>UVf0P0000001@11I<P000000000003g
Bb00000000D0?EV[0P00000803eIZ`/0000000<0?EV[0000003om^h03`3om^h00`0mFJ/0ooK^0?of
kP070?ofkP80?EV[1@3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0403eIZ`3om^h0ooK^03eIZ`T0ooK^
00D0?EV[0?ofkP3om^h0ooK^03eIZ`060?ofkP0403eIZ`3om^h0ooK^03eIZ`<0ooK^00@0?EV[0?of
kP3om^h0ooK^0P0mFJ]<0?ofkP030000003om^h0ooK^04L0ooK^0@3oool00580ooK^00<000000?of
kP3om^h02P3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^0080ooK^1`3D?AT30?of
kP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP020?of
kPX0e3dI0`3om^h00`3D?AT0ooK^0?ofkP0=0?ofkPL0e3dI3@3om^h0103D?AT0ooK^0=@m6@3D?AT2
01XYG`030000003D?AT0000000808cUm00<00000031;W@0`Bid0100`Bid010000000>UVf03YI]P0j
FKH50=@m6@0303YI]P000000000000D0000000<0fd@M0000000000000P3KA1d010000000fd@M0=]4
7@0mFJ/4000000`0ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP040?ofkP80?EV[
203om^h00`0mFJ/0ooK^0?ofkP080?ofkP80?EV[0`3om^h00`0mFJ/0ooK^0?ofkP070?ofkP0503eI
Z`3om^h0ooK^0?ofkP0mFJ/01@3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00<0ooK^00@0?EV[0?of
kP3om^h0ooK^0P0mFJ]<0?ofkP800000B03om^h10?ooo`00DP3om^h00`000000ooK^0?ofkP0:0?of
kP030=@m6@3om^h0ooK^0140ooK^1`3D?AT:0?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?of
kP3om^h00`3om^h80=@m6@80ooK^00<000000?ofkP3om^h0103om^h01@3D?AT0ooK^0?ofkP3om^h0
e3dI00P0ooK^1`3D?AT20?ofkP030=@m6@3om^h0e3dI00/0ooK^1P3D?AT01`3om^h0000001XYG`0J
:El0000002<iO@3D?AT01@0000080=@m6@<0>UVf0P0000020=]47@0303eIZ`000000000000/00000
00<0ooK^03eIZ`3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^0080ooK^
0P0mFJ/:0?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^
0?ofkP060?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^
0?ofkP030?ofkP0303eIZ`3om^h0?EV[00D0ooK^00<0?EV[0?ofkP3om^h0BP3om^h2000004P0ooK^
0@3oool005<0ooK^00<000000?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP090?ofkPL0e3dI103o
m^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00H0ooK^1P3D?AT20?ofkP030=@m6@3o
m^h0ooK^00D0ooK^00<000000?ofkP3om^h01@3om^h00`3D?AT0ooK^0=@m6@020?ofkPL0e3dI203o
m^h0103D?AT0ooK^0?ofkP3om^h;0=@m6@<0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`000000?EV[
0=@m6@070=@m6@D0<4^M00<0000003YI]P0jFKH00`0000020=]47@80000000<0?EV[000000000000
100000080?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h03`3om^h0100mFJ/0ooK^
03eIZ`0mFJ/=0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0
ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00@0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`050?of
kP0303eIZ`3om^h0?EV[00D0ooK^00<0?EV[0?ofkP3om^h0BP3om^h2000004P0ooK^0@3oool005@0
ooK^00<000000?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP020?ofkPL0e3dI2`3om^h00`3D?AT0
ooK^0?ofkP090?ofkP040=@m6@3om^h0ooK^0?ofkPH0e3dI0P3om^h00`3D?AT0ooK^0?ofkP030?of
kP030=@m6@3om^h0ooK^00D0ooK^00<000000?ofkP3om^h00`3om^h70=@m6@`0ooK^2@3D?AT;0?of
kPP0e3dI00<0?EV[0000000S>Gd00`3D?AT0100S>Gd00000031;W@0`Bid20=@m6@03031;W@000000
000000T0000000<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0
ooK^00h0ooK^0`0mFJ/?0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h01P3om^h0
0`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00D0ooK^00@0?EV[0?ofkP3om^h0?EV[1P3o
m^h00`0mFJ/0ooK^03eIZ`050?ofkP0303eIZ`3om^h0ooK^04X0ooK^0P0000180?ofkP40oooo001E
0?ofkP030000003om^h0ooK^00T0ooK^103D?ATC0?ofkP030=@m6@3om^h0ooK^00P0ooK^103D?AT8
0?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h01@3om^h70=@m6@<0ooK^0P3D?AT8
0?ofkPH0e3dI0P3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^0080ooK^1`3D?AT5
0?ofkP`0e3dI0P0mFJ/00`000000?EV[00000003000000H0ooK^00<0?EV[0?ofkP3om^h0303om^h0
0`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00X0ooK^0`0mFJ/00`3om^h0?EV[0?ofkP0@
0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h0203om^h01@0mFJ/0ooK^0?ofkP3o
m^h0?EV[00P0ooK^00@0?EV[0?ofkP3om^h0?EV[1`3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eI
Z`3om^h0ooK^04/0ooK^00<000000?ofkP3om^h0AP3om^h10?ooo`00EP3om^h00`000000ooK^0?of
kP090?ofkP030=@m6@3om^h0ooK^01@0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?of
kP0;0?ofkP040=@m6@3om^h0ooK^0?ofkPP0e3dI00<0ooK^0000003om^h01`3om^h00`3D?AT0ooK^
0=@m6@070=@m6@L0ooK^00<0e3dI0?ofkP3om^h00`3om^h70=@m6@80ooK^403D?AT00`3om^h0?EV[
0000000500000080?EV[2`3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00d0ooK^
00<0?EV[0?ofkP3om^h01`3om^h303eIZ`D0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^
0?ofkP0203eIZ`/0ooK^00@0?EV[0?ofkP3om^h0?EV[2@3om^h00`0mFJ/0ooK^03eIZ`080?ofkP03
03eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h0C03om^h00`000000ooK^0?ofkP160?ofkP40
oooo001G0?ofkP030000003om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h0503om^h00`3D?AT0ooK^
0?ofkP050?ofkP030=@m6@3om^h0ooK^00T0ooK^1`3D?AT70?ofkP030000003om^h0ooK^00<0ooK^
203D?AT<0?ofkPL0e3dI0`3om^h60=@m6@030?ofkP3D?AT0e3dI00L0e3dI0P3om^h703eIZ`80ooK^
0P0mFJ/30?ofkP80?EV[2@3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00d0ooK^
00<0?EV[0?ofkP3om^h00`3om^h303eIZ`P0ooK^00<0?EV[0?ofkP3om^h03`3om^h203eIZ`d0ooK^
00@0?EV[0?ofkP3om^h0?EV[2P3om^h203eIZ`L0ooK^0P0mFJ/50?ofkP0303eIZ`3om^h0ooK^04`0
ooK^00<000000?ofkP3om^h0AP3om^h10?ooo`00E`3om^h00`000000ooK^0?ofkP0:0?ofkP030=@m
6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP030?ofkPL0e3dI
103om^h20=@m6@P0ooK^1P3D?AT20?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h0
0P3om^h80=@m6@80ooK^1`3D?AT20?ofkPL0e3dI2P3om^h203eIZ`040?ofkP0mFJ/0?EV[03eIZ`80
ooK^0P0mFJ/40?ofkPD0?EV[1P3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00d0
ooK^00<0?EV[0?ofkP3om^h00`0mFJ/<0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3o
m^h03@3om^h203eIZ`/0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^03eIZ`040?ofkP03
03eIZ`3om^h0ooK^04`0ooK^0P0000170?ofkP40oooo001H0?ofkP030000003om^h0ooK^00T0ooK^
00<0e3dI0?ofkP3om^h0503om^h00`3D?AT0ooK^0?ofkP020?ofkPL0e3dI2`3om^h20=@m6@80ooK^
1P3D?AT00`000000ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^0080ooK^1`3D?AT30?ofkPL0e3dI
0P3om^h70=@m6A80ooK^0P0mFJ/0103om^h0?EV[03eIZ`0mFJ/20?ofkP0303eIZ`3om^h0ooK^0080
ooK^00<0?EV[0?ofkP3om^h00P3om^h303eIZ`@0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0
ooK^0?ofkP0:0?ofkPD0?EV[3`3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP<0?EV[3`3om^h00`0mFJ/0
ooK^0?ofkP090?ofkP80?EV[1`3om^h0100mFJ/0ooK^0?ofkP0mFJ/40?ofkP0303eIZ`3om^h0ooK^
04`0ooK^0P0000170?ofkP40oooo001I0?ofkP030000003om^h0ooK^00T0ooK^00<0e3dI0?ofkP3o
m^h04@3om^h80=@m6@h0ooK^1`3D?AT60?ofkP030000003om^h0ooK^00<0ooK^1P3D?AT40?ofkPl0
e3dI6@3om^h203eIZ`040?ofkP0mFJ/0?EV[03eIZ`80ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0m
FJ/0ooK^0?ofkP040?ofkPD0?EV[3P3om^h00`0mFJ/0ooK^0?ofkP020?ofkPP0?EV[0`3om^h00`0m
FJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00T0ooK^0P0mFJ/30?ofkP0303eIZ`3om^h0ooK^
00/0ooK^0P0mFJ/:0?ofkP0403eIZ`3om^h0ooK^03eIZ`H0ooK^00D0?EV[0?ofkP3om^h0ooK^03eI
Z`020?ofkP0303eIZ`3om^h0ooK^04d0ooK^0P0000170?ofkP40oooo001J0?ofkP030000003om^h0
ooK^00T0ooK^00<0e3dI0?ofkP3om^h02P3om^h60=@m6@@0ooK^00@0e3dI0?ofkP3om^h0e3dI203o
m^h60=@m6@80ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP020?ofkPP0e3dI0P3o
m^h70=@m6@030?ofkP3D?AT0e3dI00D0e3dI8@3om^h203eIZ`060?ofkP0mFJ/0ooK^03eIZ`3om^h0
?EV[1@3om^h00`0mFJ/0ooK^0?ofkP080?ofkQ@0?EV[303om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP03
03eIZ`3om^h0ooK^00L0ooK^0P0mFJ/50?ofkP0303eIZ`3om^h0ooK^00T0ooK^0P0mFJ/20?ofkP03
03eIZ`3om^h0ooK^00L0ooK^00@0?EV[0?ofkP3om^h0?EV[1@3om^h00`0mFJ/0ooK^0?ofkP020?of
kP0403eIZ`3om^h0ooK^03eIZe00ooK^00<000000?ofkP3om^h0A@3om^h10?ooo`00F`3om^h00`00
0000ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^0080ooK^1`3D?AT;0?ofkP80e3dI0`3om^h60=@m
6@L0ooK^00@0e3dI0?ofkP3om^h0ooK^1`3D?AT00`3om^h000000?ofkP070=@m6@80ooK^1P3D?ATX
0?ofkP80?EV[00@0ooK^03eIZ`3om^h0ooK^0P0mFJ/60?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0
?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0
?EV[0?ofkP3om^h0103om^h203eIZ`P0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?of
kP020?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?of
kP020?ofkP0303eIZ`3om^h0ooK^0080ooK^00@0?EV[0?ofkP3om^h0?EV[D03om^h00`000000ooK^
0?ofkP150?ofkP40oooo001L0?ofkP030000003om^h0ooK^00T0ooK^103D?ATC0?ofkP@0e3dI2P3o
m^h70=@m6@@0ooK^3`3D?AT_0?ofkP80?EV[00<0ooK^03eIZ`3om^h0100mFJ/50?ofkP0303eIZ`3o
m^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3o
m^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h00P3om^h203eIZ`X0ooK^00<0?EV[0?ofkP3om^h01P3o
m^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h00`3o
m^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00H0ooK^00<0?EV[0?ofkP0mFJ/0D03om^h00`000000ooK^
0?ofkP150?ofkP40oooo001L0?ofkP030000003om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h04P3o
m^h0103D?AT0ooK^0?ofkP3D?AT40?ofkPL0e3dI00@0ooK^0=@m6@3om^h0ooK^3`3D?ATg0?ofkP<0
?EV[0P3om^h00`0mFJ/0ooK^0?ofkP0203eIZ`<0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0
ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h03`3om^h0100mFJ/0
ooK^03eIZ`0mFJ/<0?ofkP0303eIZ`3om^h0ooK^00@0ooK^0P0mFJ/70?ofkP0303eIZ`3om^h0ooK^
00<0ooK^00<0?EV[0?ofkP3om^h0103om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00H0ooK^0P0mFJ]A
0?ofkP800000AP3om^h10?ooo`00G@3om^h00`000000ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^
00l0ooK^0P3D?AT00`3om^h0e3dI0=@m6@050=@m6@<0ooK^3`3D?AT40?ofkP030000003om^h0ooK^
03P0ooK^100mFJ/00`3om^h0?EV[0?ofkP030?ofkP80?EV[0P3om^h00`0mFJ/0ooK^0?ofkP080?of
kP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0=0?of
kP<0?EV[3`3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?of
kP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0?EV[00P0ooK^00<0?EV[0?of
kP3om^h0C`3om^h2000004H0ooK^0@3oool005h0ooK^00<000000?ofkP3om^h02P3om^h20=@m6@`0
ooK^5@3D?AT>0?ofkP030000003om^h0ooK^03T0ooK^0`0mFJ/20?ofkP0303eIZ`3om^h0ooK^00<0
ooK^0`0mFJ/:0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0
ooK^0?ofkP0:0?ofkP<0?EV[00<0ooK^03eIZ`3om^h03`3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[
00/0ooK^00@0?EV[0?ofkP3om^h0?EV[2@3om^h00`0mFJ/0ooK^03eIZ`080?ofkP0303eIZ`3om^h0
ooK^04l0ooK^0P0000160?ofkP40oooo001O0?ofkP030000003om^h0ooK^00/0ooK^00<0e3dI0?of
kP3om^h00P3om^hC0=@m6AL0ooK^00<000000?ofkP3om^h0>@3om^h703eIZ`H0ooK^0`0mFJ/90?of
kP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP060?of
kP<0?EV[1@3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP<0?EV[303om^h0100mFJ/0ooK^0?ofkP0mFJ/:
0?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h0D@3om^h00`000000ooK^0?ofkP14
0?ofkP40oooo001P0?ofkP030000003om^h0ooK^00/0ooK^103D?AT50?ofkPP0e3dI7@3om^h00`00
0000ooK^0?ofkP0j0?ofkP<0?EV[00<0ooK^03eIZ`0mFJ/01`3om^h00`0mFJ/0ooK^03eIZ`0203eI
Z`H0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^
00<0ooK^0`0mFJ/80?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h03@3om^h203eI
Z`/0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP1A0?ofkP030000003om^h0ooK^
04@0ooK^0@3oool00640ooK^00<000000?ofkP3om^h03P3om^h70=@m6B80ooK^00<000000?ofkP3o
m^h0>`3om^h203eIZ`030?ofkP0mFJ/0?EV[0080?EV[1`3om^h0100mFJ/0ooK^0?ofkP3om^h403eI
Z`<0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0?EV[
0080?EV[303om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP<0?EV[3`3om^h00`0mFJ/0ooK^0?ofkP090?of
kP80?EV[1`3om^h00`0mFJ/0ooK^0?ofkP1B0?ofkP030000003om^h0ooK^04@0ooK^0@3oool00640
ooK^00<000000?ofkP3om^h0=`3om^h00`000000ooK^0?ofkP0l0?ofkP0603eIZ`3om^h0?EV[03eI
Z`3om^h0?EV[1`3om^h00`0mFJ/0ooK^0?ofkP050?ofkP@0?EV[3P3om^h00`0mFJ/0ooK^0?ofkP0:
0?ofkPD0?EV[3`3om^h00`0mFJ/0ooK^0?ofkP090?ofkP80?EV[0`3om^h00`0mFJ/0ooK^0?ofkP0;
0?ofkP80?EV[2P3om^h0100mFJ/0ooK^0?ofkP0mFJ/50?ofkP0303eIZ`3om^h0ooK^05<0ooK^00<0
00000?ofkP3om^h0A03om^h10?ooo`00HP3om^h00`000000ooK^0?ofkP0f0?ofkP030000003om^h0
ooK^03`0ooK^0P0mFJ/01@3om^h0?EV[0?ofkP3om^h0?EV[00L0ooK^00<0?EV[0?ofkP3om^h01`3o
m^h903eIZ`L0ooK^00@0?EV[0?ofkP3om^h0ooK^200mFJ/30?ofkP0303eIZ`3om^h0ooK^00l0ooK^
00<0?EV[0?ofkP3om^h01P3om^h203eIZ`D0ooK^00<0?EV[0?ofkP3om^h02@3om^h203eIZ`80ooK^
00<0?EV[0?ofkP3om^h01`3om^h0100mFJ/0ooK^0?ofkP0mFJ/50?ofkP0303eIZ`3om^h0ooK^05<0
ooK^0P0000150?ofkP40oooo001S0?ofkP030000003om^h0ooK^03D0ooK^00<000000?ofkP3om^h0
?@3om^h00`0mFJ/0ooK^03eIZ`030?ofkP80?EV[1@3om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eI
Z`3om^h0ooK^00@0ooK^2`0mFJ/<0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h0
103om^h203eIZ`P0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eI
Z`3om^h0ooK^00H0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`040?ofkP0303eIZ`3om^h0ooK^05@0
ooK^0P0000150?ofkP40oooo001T0?ofkP030000003om^h0ooK^03@0ooK^00<000000?ofkP3om^h0
?P3om^h00`0mFJ/0ooK^03eIZ`020?ofkP0303eIZ`3om^h0?EV[00D0ooK^00<0?EV[0?ofkP3om^h0
203om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h0
3`3om^h0100mFJ/0ooK^0?ofkP3om^h203eIZ`X0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0
ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h00`3om^h01@0mFJ/0
ooK^0?ofkP3om^h0?EV[05L0ooK^00<000000?ofkP3om^h0@`3om^h10?ooo`00I@3om^h00`000000
ooK^0?ofkP0c0?ofkP030000003om^h0ooK^03h0ooK^0`0mFJ/30?ofkP0403eIZ`3om^h0?EV[03eI
Z`<0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^
00d0ooK^00<0?EV[0?ofkP3om^h03P3om^h0100mFJ/0ooK^03eIZ`0mFJ/=0?ofkP0303eIZ`3om^h0
ooK^00@0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0
ooK^00@0ooK^00@0?EV[0?ofkP3om^h0?EV[F03om^h00`000000ooK^0?ofkP130?ofkP40oooo001V
0?ofkP030000003om^h0ooK^0380ooK^00<000000?ofkP3om^h0?`3om^h303eIZ`80ooK^00@0?EV[
0?ofkP3om^h0ooK^0P0mFJ/20?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h02`3o
m^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00h0ooK^0P0mFJ/?0?ofkP0303eIZ`3o
m^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3o
m^h0ooK^00D0ooK^00<0?EV[0?ofkP0mFJ/0F@3om^h00`000000ooK^0?ofkP130?ofkP40oooo001V
0?ofkP030000003om^h0ooK^0380ooK^00<000000?ofkP3om^h0@03om^h303eIZ`80ooK^00<0?EV[
0?ofkP3om^h00P3om^h00`0mFJ/0ooK^03eIZ`0;0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[
0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP<0?EV[00<0ooK^03eIZ`3om^h03`3om^h0
0`0mFJ/0ooK^0?ofkP0203eIZ`X0ooK^00@0?EV[0?ofkP3om^h0?EV[2@3om^h203eIZeT0ooK^00<0
00000?ofkP3om^h0@`3om^h10?ooo`00I`3om^h00`000000ooK^0?ofkP0a0?ofkP030000003om^h0
ooK^0400ooK^0P0mFJ/01@3om^h0?EV[0?ofkP3om^h0?EV[00@0ooK^0`0mFJ/;0?ofkP0303eIZ`3o
m^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP070?ofkP<0?EV[1@3o
m^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0?EV[00`0ooK^00@0?EV[0?ofkP3om^h0?EV[
2@3om^h00`0mFJ/0ooK^0?ofkP1H0?ofkP800000A03om^h10?ooo`00J03om^h00`000000ooK^0?of
kP0`0?ofkP030000003om^h0ooK^0440ooK^0P0mFJ/0103om^h0?EV[0?ofkP0mFJ/60?ofkP<0?EV[
2@3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h0
0`3om^h303eIZ`P0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP80?EV[
2@3om^h00`0mFJ/0ooK^0?ofkP1I0?ofkP800000A03om^h10?ooo`00J@3om^h00`000000ooK^0?of
kP0_0?ofkP030000003om^h0ooK^0480ooK^00<0?EV[0?ofkP3om^h00`0mFJ/60?ofkP0303eIZ`3o
m^h0?EV[00<0?EV[1P3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0
?EV[0?ofkP3om^h00`0mFJ/<0?ofkP0303eIZ`3om^h0ooK^00/0ooK^0`0mFJ/>0?ofkP0303eIZ`3o
m^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h0F`3om^h00`000000ooK^0?ofkP120?ofkP40oooo001Z
0?ofkP030000003om^h0ooK^02h0ooK^00<000000?ofkP3om^h0@P3om^h203eIZ`<0ooK^00<0?EV[
0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP030?ofkPD0?EV[00<0ooK^03eIZ`3om^h0303om^h0
0`0mFJ/0ooK^0?ofkP0:0?ofkPD0?EV[3`3om^h00`0mFJ/0ooK^0?ofkP090?ofkP80?EV[0`3om^h0
0`0mFJ/0ooK^0?ofkP0:0?ofkP80?EV[2@3om^h00`0mFJ/0ooK^0?ofkP1K0?ofkP030000003om^h0
ooK^0480ooK^0@3oool006/0ooK^00<000000?ofkP3om^h0;03om^h00`000000ooK^0?ofkP140?of
kP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP070?of
kPT0?EV[1P3om^h00`0mFJ/0ooK^0?ofkP020?ofkPP0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP0>0?of
kP0303eIZ`3om^h0ooK^00L0ooK^0P0mFJ/50?ofkP0303eIZ`3om^h0ooK^00P0ooK^0P0mFJ/20?of
kP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h0G03om^h00`000000ooK^0?ofkP120?of
kP40oooo001[0?ofkP030000003om^h0ooK^02`0ooK^00<000000?ofkP3om^h0A@3om^h00`0mFJ/0
ooK^0?ofkP020?ofkP80?EV[1@3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00@0
ooK^2`0mFJ/<0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h0103om^h203eIZ`P0
ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00@0
ooK^00<0?EV[0?ofkP3om^h0G@3om^h00`000000ooK^0?ofkP120?ofkP40oooo001/0?ofkP030000
003om^h0ooK^02/0ooK^00<000000?ofkP3om^h0A@3om^h203eIZ`<0ooK^00@0?EV[0?ofkP0mFJ/0
?EV[0`3om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3o
m^h03@3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^0080ooK^0P0mFJ/:0?ofkP03
03eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP030?ofkP03
03eIZ`3om^h0ooK^05h0ooK^0P0000130?ofkP40oooo001]0?ofkP030000003om^h0ooK^02X0ooK^
00<000000?ofkP3om^h0AP3om^h203eIZ`<0ooK^00<0?EV[0?ofkP3om^h00P0mFJ/20?ofkP0303eI
Z`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eI
Z`3om^h0ooK^00h0ooK^00@0?EV[0?ofkP0mFJ/0?EV[303om^h00`0mFJ/0ooK^0?ofkP040?ofkP03
03eIZ`3om^h0ooK^00D0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`1Q0?ofkP800000@`3om^h10?oo
o`00KP3om^h00`000000ooK^0?ofkP0Y0?ofkP030000003om^h0ooK^04H0ooK^0`0mFJ/20?ofkP03
03eIZ`3om^h0ooK^0080ooK^0P0mFJ/00`3om^h0?EV[0?ofkP090?ofkP0303eIZ`3om^h0ooK^00X0
ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP<0?EV[3`3om^h00`0mFJ/0
ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00H0ooK^00@0?EV[0?ofkP3om^h0?EV[H`3om^h00`00
0000ooK^0?ofkP110?ofkP40oooo001_0?ofkP030000003om^h0ooK^02P0ooK^00<000000?ofkP3o
m^h0A`3om^h01P0mFJ/0ooK^03eIZ`0mFJ/0ooK^03eIZ`D0ooK^0P0mFJ/:0?ofkP0303eIZ`3om^h0
ooK^00/0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP090?ofkP<0?EV[00<0ooK^
03eIZ`3om^h03`3om^h00`0mFJ/0ooK^0?ofkP0203eIZ`T0ooK^00@0?EV[0?ofkP3om^h0?EV[H`3o
m^h00`000000ooK^0?ofkP110?ofkP40oooo001`0?ofkP030000003om^h0ooK^02L0ooK^00<00000
0?ofkP3om^h0B03om^h00`0mFJ/0ooK^0?ofkP0203eIZ`L0ooK^0P0mFJ/90?ofkP0303eIZ`3om^h0
ooK^00X0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP070?ofkP80?EV[1@3om^h0
0`0mFJ/0ooK^0?ofkP0>0?ofkP80?EV[303om^h203eIZf@0ooK^00<000000?ofkP3om^h0@@3om^h1
0?ooo`00L03om^h00`000000ooK^0?ofkP0W0?ofkP030000003om^h0ooK^04P0ooK^00@0?EV[0?of
kP3om^h0ooK^0P0mFJ/60?ofkP0303eIZ`3om^h0?EV[0080?EV[1P3om^h00`0mFJ/0ooK^0?ofkP0;
0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h00`3om^h303eIZ`L0ooK^00<0?EV[
0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^06<0ooK^00<00000
0?ofkP3om^h0@@3om^h10?ooo`00L@3om^h00`000000ooK^0?ofkP0V0?ofkP030000003om^h0ooK^
04T0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`070?ofkP0403eIZ`3om^h0ooK^0?ofkP@0?EV[0`3o
m^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h00`0m
FJ/;0?ofkP0303eIZ`3om^h0ooK^00/0ooK^0`0mFJ/<0?ofkP0303eIZ`3om^h0ooK^06@0ooK^00<0
00000?ofkP3om^h0@@3om^h10?ooo`00LP3om^h00`000000ooK^0?ofkP0U0?ofkP030000003om^h0
ooK^04T0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0
ooK^00D0ooK^100mFJ/=0?ofkP0303eIZ`3om^h0ooK^00X0ooK^1@0mFJ/>0?ofkP0303eIZ`3om^h0
ooK^00T0ooK^0P0mFJ/30?ofkP0303eIZ`3om^h0ooK^00L0ooK^0P0mFJ]W0?ofkP800000@P3om^h1
0?ooo`00L`3om^h00`000000ooK^0?ofkP0T0?ofkP030000003om^h0ooK^04X0ooK^00<0?EV[0?of
kP3om^h00P3om^h203eIZ`D0ooK^00<0?EV[0?ofkP3om^h01`3om^h803eIZ`H0ooK^00<0?EV[0?of
kP3om^h00P3om^h803eIZ`@0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP060?of
kP80?EV[1@3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^06P0ooK^00<000000?of
kP3om^h0@03om^h10?ooo`00M03om^h00`000000ooK^0?ofkP0S0?ofkP030000003om^h0ooK^04/0
ooK^00L0?EV[0?ofkP3om^h0ooK^03eIZ`3om^h0?EV[00@0ooK^00<0?EV[0?ofkP3om^h02@3om^h0
0`0mFJ/0ooK^0?ofkP030?ofkP/0?EV[303om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0
ooK^00@0ooK^0P0mFJ/70?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h0J@3om^h0
0`000000ooK^0?ofkP100?ofkP40oooo001e0?ofkP030000003om^h0ooK^0240ooK^00<000000?of
kP3om^h0C@3om^h01P0mFJ/0ooK^0?ofkP3om^h0?EV[0?ofkP80?EV[0`3om^h00`0mFJ/0ooK^0?of
kP080?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?of
kP0=0?ofkP0403eIZ`3om^h0ooK^0?ofkP80?EV[2P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eI
Z`3om^h0ooK^06X0ooK^00<000000?ofkP3om^h0@03om^h10?ooo`00M@3om^h00`000000ooK^0?of
kP0Q0?ofkP030000003om^h0ooK^04h0ooK^00@0?EV[0?ofkP3om^h0?EV[0`3om^h203eIZ`030?of
kP0mFJ/0ooK^00X0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eI
Z`3om^h0ooK^00d0ooK^00@0?EV[0?ofkP0mFJ/0?EV[303om^h00`0mFJ/0ooK^0?ofkP020?ofkP03
03eIZ`3om^h0ooK^06/0ooK^00<000000?ofkP3om^h0@03om^h10?ooo`00MP3om^h00`000000ooK^
0?ofkP0P0?ofkP030000003om^h0ooK^04l0ooK^0P0mFJ/00`3om^h0?EV[0?ofkP030?ofkP0303eI
Z`3om^h0?EV[00X0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eI
Z`3om^h0ooK^00`0ooK^0P0mFJ/>0?ofkP0303eIZ`3om^h0ooK^0080?EV[KP3om^h00`000000ooK^
0?ofkP100?ofkP40oooo001g0?ofkP030000003om^h0ooK^01l0ooK^00<000000?ofkP3om^h0D@3o
m^h203eIZ`D0ooK^0P0mFJ/;0?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h03@3o
m^h00`0mFJ/0ooK^0?ofkP080?ofkP@0?EV[00<0ooK^03eIZ`3om^h03P3om^h203eIZg00ooK^0P00
00110?ofkP40oooo001h0?ofkP030000003om^h0ooK^01h0ooK^00<000000?ofkP3om^h0DP3om^h2
03eIZ`H0ooK^0`0mFJ/80?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h03@3om^h0
0`0mFJ/0ooK^0?ofkP040?ofkP<0?EV[1P3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0
ooK^0700ooK^00<000000?ofkP3om^h0?`3om^h10?ooo`00N@3om^h00`000000ooK^0?ofkP0M0?of
kP030000003om^h0ooK^05<0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^03eIZ`0303eI
Z`D0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^
00@0?EV[2@3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP80?EV[L`3om^h00`000000ooK^0?ofkP0o0?of
kP40oooo001j0?ofkP030000003om^h0ooK^01`0ooK^00<000000?ofkP3om^h0E03om^h00`0mFJ/0
ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00<0ooK^100mFJ/00`3om^h0?EV[0?ofkP0<0?ofkP03
03eIZ`3om^h0ooK^00X0ooK^1@0mFJ/>0?ofkP0303eIZ`3om^h0ooK^00L0ooK^0P0mFJ]a0?ofkPD0
0000@@3om^h10?ooo`00NP3om^h00`000000ooK^0?ofkP0L0?ofkP030000003om^h0ooK^05D0ooK^
0P0mFJ/50?ofkP0303eIZ`3om^h0ooK^00H0ooK^2@0mFJ/60?ofkP0303eIZ`3om^h0ooK^0080ooK^
200mFJ/30?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^
0?ofkP1Y0?ofkPP00000AP3om^h10?ooo`00N`3om^h00`000000ooK^0?ofkP0K0?ofkP030000003o
m^h0ooK^05L0ooK^0P0mFJ/30?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h00`3o
m^h;03eIZ``0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP030?ofkP80?EV[I03o
m^h8000004h0ooK^0@3oool007`0ooK^00<000000?ofkP3om^h06P3om^h00`000000ooK^0?ofkP1I
0?ofkP80?EV[0P3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[
0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0403eIZ`3om^h0ooK^0?ofkP80?EV[G@3o
m^h9000005H0ooK^0@3oool007d0ooK^00<000000?ofkP3om^h06@3om^h00`000000ooK^0?ofkP1K
0?ofkP80?EV[00<0ooK^03eIZ`3om^h02@3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0
ooK^00d0ooK^00<0?EV[0?ofkP3om^h03@3om^h303eIZeL0ooK^2000001O0?ofkP40oooo001n0?of
kP030000003om^h0ooK^01L0ooK^00<000000?ofkP3om^h0GP3om^h203eIZ`X0ooK^00<0?EV[0?of
kP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00`0ooK^0P0mFJ]A0?of
kPP00000I`3om^h10?ooo`00O`3om^h00`000000ooK^0?ofkP0F0?ofkP030000003om^h0ooK^0600
ooK^0P0mFJ/90?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0
ooK^0?ofkP070?ofkP@0?EV[BP3om^h9000006l0ooK^0@3oool007l0ooK^00<000000?ofkP3om^h0
5P3om^h00`000000ooK^0?ofkP1R0?ofkP<0?EV[1P3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eI
Z`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h0103om^h303eIZdH0ooK^2000001h0?ofkP40oooo
00200?ofkP030000003om^h0ooK^01D0ooK^00<000000?ofkP3om^h0I@3om^h403eIZ`<0ooK^00<0
?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0?EV[00<0?EV[@@3o
m^h800000800ooK^0@3oool00840ooK^00<000000?ofkP3om^h0503om^h00`000000ooK^0?ofkP1Y
0?ofkP@0?EV[3@3om^h00`0mFJ/0ooK^0?ofkP090?ofkPD0?EV[?03om^h9000008P0ooK^0@3oool0
0880ooK^00<000000?ofkP3om^h04`3om^h00`000000ooK^0?ofkP1/0?ofkPP0?EV[1P3om^h00`0m
FJ/0ooK^0?ofkP020?ofkPL0?EV[>@3om^h800000940ooK^0@3oool008<0ooK^00<000000?ofkP3o
m^h04P3om^h00`000000ooK^0?ofkP1d0?ofkP/0?EV[>03om^h8000009T0ooK^0@3oool008@0ooK^
00<000000?ofkP3om^h04@3om^h00`000000ooK^0?ofkP2^0?ofkPT00000X@3om^h10?ooo`00Q03o
m^h00`000000ooK^0?ofkP0A0?ofkP030000003om^h0ooK^0:H0ooK^2000002Z0?ofkP40oooo0025
0?ofkP030000003om^h0ooK^0100ooK^00<000000?ofkP3om^h0WP3om^h800000;80ooK^0@3oool0
08H0ooK^00<000000?ofkP3om^h03`3om^h00`000000ooK^0?ofkP2E0?ofkPT00000^P3om^h10?oo
o`00Q`3om^h00`000000ooK^0?ofkP0>0?ofkP030000003om^h0ooK^08d0ooK^200000330?ofkP40
oooo00280?ofkP030000003om^h0ooK^00`0ooK^00<000000?ofkP3om^h0QP3om^h800000</0ooK^
0@3oool008T0ooK^00<000000?ofkP3om^h02`3om^h00`000000ooK^0?ofkP1n0?ofkPP00000d`3o
m^h10?ooo`00R@3om^h00`000000ooK^0?ofkP0;0?ofkP030000003om^h0ooK^07D0ooK^2@00003K
0?ofkP40oooo002:0?ofkP030000003om^h0ooK^00X0ooK^00<000000?ofkP3om^h0K@3om^h80000
0>@0ooK^0@3oool008/0ooK^00<000000?ofkP3om^h02@3om^h00`000000ooK^0?ofkP1U0?ofkPP0
0000k03om^h10?ooo`00S03om^h00`000000ooK^0?ofkP080?ofkP030000003om^h0ooK^05`0ooK^
2@00003d0?ofkP40oooo002=0?ofkP030000003om^h0ooK^00L0ooK^00<000000?ofkP3om^h0E03o
m^h800000?d0ooK^0@3oool008h0ooK^00<000000?ofkP3om^h01P3om^h00`000000ooK^0?ofkP1<
0?ofkPP00000o`3om^h60?ofkP40oooo002>0?ofkP030000003om^h0ooK^00H0ooK^00<000000?of
kP3om^h0@`3om^h900000?l0ooK^3P3om^h10?ooo`00S`3om^h00`000000ooK^0?ofkP050?ofkP03
0000003om^h0ooK^03/0ooK^2000003o0?ofkQL0ooK^0@3oool00900ooK^00<000000?ofkP3om^h0
103om^h00`000000ooK^0?ofkP0c0?ofkPP00000o`3om^hO0?ofkP40oooo002A0?ofkP030000003o
m^h0ooK^00<0ooK^00<000000?ofkP3om^h0:P3om^h900000?l0ooK^9`3om^h10?ooo`00TP3om^h0
1@000000ooK^0?ofkP3om^h0000002D0ooK^2000003o0?ofkS00ooK^0@3oool009<0ooK^00@00000
0?ofkP3om^h000007@3om^h800000?l0ooK^>03om^h10?ooo`00T`3om^h010000000ooK^0?ofkP00
000D0?ofkPT00000o`3om^i00?ofkP40oooo002D0?ofkP030000003om^h0000000`0ooK^2000003o
0?ofkTT0ooK^0@3oool009D0ooK^0P0000040?ofkPP00000o`3om^iA0?ofkP40oooo002F0?ofkPD0
0000o`3om^iI0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd
0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo
003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0
ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool0
0?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03o
m^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00
o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?of
kP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o
0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^
0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0
ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h1
0?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3o
m^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40
oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?of
k_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3o
ool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^
m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?oo
o`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd
0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo
003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0
ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool0
0?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03o
m^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00
o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?of
kP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o
0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo0000\
\>"],
  ImageRangeCache->{{{0, 499}, {499, 0}} -> {-5.00005*^-06, -5.00005*^-06, \
0.00200403, 0.00200403}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
%%ImageSize: 500 500 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics3D
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Background color
1 .961 .933 r
MFill
% Scaling calculations
0 1 0 1 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 0 r
.25 Mabswid
[ ] 0 setdash
.85264 .14594 m
.90748 .42015 L
s
.90748 .42015 m
.09252 .42015 L
s
.09252 .42015 m
.14736 .14594 L
s
.14736 .14594 m
.85264 .14594 L
s
.76019 .55099 m
.23981 .55099 L
s
.23981 .55099 m
.21113 .79004 L
s
.21113 .79004 m
.78887 .79004 L
s
.78887 .79004 m
.76019 .55099 L
s
.85264 .14594 m
.90748 .42015 L
s
.90748 .42015 m
.78887 .79004 L
s
.78887 .79004 m
.76019 .55099 L
s
.76019 .55099 m
.85264 .14594 L
s
.14736 .14594 m
.23981 .55099 L
s
.23981 .55099 m
.21113 .79004 L
s
.21113 .79004 m
.09252 .42015 L
s
.09252 .42015 m
.14736 .14594 L
s
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
.24 .35 .67 r
.5 Mabswid
.48693 .55057 m
.46127 .55504 L
s
.48669 .52967 m
.48693 .55057 L
s
.51307 .55057 m
.48693 .55057 L
s
.51331 .52967 m
.51307 .55057 L
s
.53873 .55504 m
.51307 .55057 L
s
.46127 .55504 m
.43708 .56382 L
s
.46056 .53417 m
.46127 .55504 L
s
.53944 .53417 m
.53873 .55504 L
s
.56292 .56382 m
.53873 .55504 L
s
.43708 .56382 m
.41531 .57664 L
s
.43592 .54303 m
.43708 .56382 L
s
.56408 .54303 m
.56292 .56382 L
s
.58469 .57664 m
.56292 .56382 L
s
.41531 .57664 m
.39684 .59306 L
s
.41374 .55596 m
.41531 .57664 L
s
.58626 .55596 m
.58469 .57664 L
s
.60316 .59306 m
.58469 .57664 L
s
.46056 .53417 m
.48669 .52967 L
s
.48644 .50798 m
.48669 .52967 L
s
.48669 .52967 m
.51331 .52967 L
s
.51356 .50798 m
.51331 .52967 L
s
.51331 .52967 m
.53944 .53417 L
s
.39684 .59306 m
.38248 .61251 L
s
.39491 .57253 m
.39684 .59306 L
s
.60509 .57253 m
.60316 .59306 L
s
.61752 .61251 m
.60316 .59306 L
s
.43592 .54303 m
.46056 .53417 L
s
.45982 .51252 m
.46056 .53417 L
s
.54018 .51252 m
.53944 .53417 L
s
.53944 .53417 m
.56408 .54303 L
s
.41374 .55596 m
.43592 .54303 L
s
.43472 .52145 m
.43592 .54303 L
s
.56528 .52145 m
.56408 .54303 L
s
.56408 .54303 m
.58626 .55596 L
s
.38248 .61251 m
.37294 .63427 L
s
.38026 .59216 m
.38248 .61251 L
s
.61974 .59216 m
.61752 .61251 L
s
.62706 .63427 m
.61752 .61251 L
s
.39491 .57253 m
.41374 .55596 L
s
.41211 .5345 m
.41374 .55596 L
s
.58789 .5345 m
.58626 .55596 L
s
.58626 .55596 m
.60509 .57253 L
s
.45982 .51252 m
.48644 .50798 L
s
.48618 .48547 m
.48644 .50798 L
s
.48644 .50798 m
.51356 .50798 L
s
.51382 .48547 m
.51356 .50798 L
s
.51356 .50798 m
.54018 .51252 L
s
.62948 .61413 m
.62706 .63427 L
s
.63123 .65748 m
.62706 .63427 L
s
.37294 .63427 m
.36877 .65748 L
s
.37052 .61413 m
.37294 .63427 L
s
.38026 .59216 m
.39491 .57253 L
s
.3929 .55122 m
.39491 .57253 L
s
.6071 .55122 m
.60509 .57253 L
s
.60509 .57253 m
.61974 .59216 L
s
.43472 .52145 m
.45982 .51252 L
s
.45906 .49005 m
.45982 .51252 L
s
.54094 .49005 m
.54018 .51252 L
s
.54018 .51252 m
.56528 .52145 L
s
.41211 .5345 m
.43472 .52145 L
s
.43347 .49905 m
.43472 .52145 L
s
.56653 .49905 m
.56528 .52145 L
s
.56528 .52145 m
.58789 .5345 L
s
.37052 .61413 m
.38026 .59216 L
s
.37796 .57104 m
.38026 .59216 L
s
.62204 .57104 m
.61974 .59216 L
s
.61974 .59216 m
.62948 .61413 L
s
.36877 .65748 m
.36624 .63758 L
s
.36877 .65748 m
.3703 .68118 L
s
.63376 .63758 m
.63123 .65748 L
s
.6297 .68118 m
.63123 .65748 L
s
.3929 .55122 m
.41211 .5345 L
s
.41041 .51221 m
.41211 .5345 L
s
.58959 .51221 m
.58789 .5345 L
s
.58789 .5345 m
.6071 .55122 L
s
.45906 .49005 m
.48618 .48547 L
s
.48591 .46208 m
.48618 .48547 L
s
.48618 .48547 m
.51382 .48547 L
s
.51409 .46208 m
.51382 .48547 L
s
.51382 .48547 m
.54094 .49005 L
s
.63199 .59322 m
.62948 .61413 L
s
.62948 .61413 m
.63376 .63758 L
s
.36624 .63758 m
.37052 .61413 L
s
.36801 .59322 m
.37052 .61413 L
s
.37796 .57104 m
.3929 .55122 L
s
.39082 .52908 m
.3929 .55122 L
s
.60918 .52908 m
.6071 .55122 L
s
.6071 .55122 m
.62204 .57104 L
s
.43347 .49905 m
.45906 .49005 L
s
.45826 .4667 m
.45906 .49005 L
s
.54174 .4667 m
.54094 .49005 L
s
.54094 .49005 m
.56653 .49905 L
s
.3703 .68118 m
.37764 .7043 L
s
.36777 .66153 m
.3703 .68118 L
s
.63223 .66153 m
.6297 .68118 L
s
.62236 .7043 m
.6297 .68118 L
s
.41041 .51221 m
.43347 .49905 L
s
.43217 .47578 m
.43347 .49905 L
s
.56783 .47578 m
.56653 .49905 L
s
.56653 .49905 m
.58959 .51221 L
s
.36801 .59322 m
.37796 .57104 L
s
.37557 .54908 m
.37796 .57104 L
s
.62443 .54908 m
.62204 .57104 L
s
.62204 .57104 m
.63199 .59322 L
s
.36624 .63758 m
.36361 .6169 L
s
.36777 .66153 m
.36624 .63758 L
s
.63639 .6169 m
.63376 .63758 L
s
.63376 .63758 m
.63223 .66153 L
s
.39082 .52908 m
.41041 .51221 L
s
.40865 .48905 m
.41041 .51221 L
s
.59135 .48905 m
.58959 .51221 L
s
.58959 .51221 m
.60918 .52908 L
s
.37764 .7043 m
.39064 .72577 L
s
.37524 .68491 m
.37764 .7043 L
s
.62476 .68491 m
.62236 .7043 L
s
.60936 .72577 m
.62236 .7043 L
s
.45826 .4667 m
.48591 .46208 L
s
.48563 .43777 m
.48591 .46208 L
s
.48591 .46208 m
.51409 .46208 L
s
.51437 .43777 m
.51409 .46208 L
s
.51409 .46208 m
.54174 .4667 L
s
.63461 .57147 m
.63199 .59322 L
s
.63199 .59322 m
.63639 .6169 L
s
.36361 .6169 m
.36801 .59322 L
s
.36539 .57147 m
.36801 .59322 L
s
.37557 .54908 m
.39082 .52908 L
s
.38866 .50606 m
.39082 .52908 L
s
.61134 .50606 m
.60918 .52908 L
s
.60918 .52908 m
.62443 .54908 L
s
.43217 .47578 m
.45826 .4667 L
s
.45743 .44242 m
.45826 .4667 L
s
.54257 .44242 m
.54174 .4667 L
s
.54174 .4667 m
.56783 .47578 L
s
.39064 .72577 m
.40883 .74451 L
s
.38847 .70662 m
.39064 .72577 L
s
.61153 .70662 m
.60936 .72577 L
s
.59117 .74451 m
.60936 .72577 L
s
.63485 .6411 m
.63223 .66153 L
s
.63223 .66153 m
.62476 .68491 L
s
.37524 .68491 m
.36777 .66153 L
s
.36515 .6411 m
.36777 .66153 L
s
.40865 .48905 m
.43217 .47578 L
s
.56783 .47578 m
.59135 .48905 L
s
.36539 .57147 m
.37557 .54908 L
s
.62443 .54908 m
.63461 .57147 L
s
.593 .72558 m
.59117 .74451 L
s
.56856 .75955 m
.59117 .74451 L
s
.40883 .74451 m
.43144 .75955 L
s
.407 .72558 m
.40883 .74451 L
s
.36361 .6169 m
.36088 .5954 L
s
.36515 .6411 m
.36361 .6169 L
s
.63912 .5954 m
.63639 .6169 L
s
.63639 .6169 m
.63485 .6411 L
s
.38866 .50606 m
.40865 .48905 L
s
.59135 .48905 m
.61134 .50606 L
s
.38847 .70662 m
.37524 .68491 L
s
.37274 .66473 m
.37524 .68491 L
s
.62726 .66473 m
.62476 .68491 L
s
.62476 .68491 m
.61153 .70662 L
s
.56994 .74079 m
.56856 .75955 L
s
.54256 .77007 m
.56856 .75955 L
s
.43144 .75955 m
.45744 .77007 L
s
.43006 .74079 m
.43144 .75955 L
s
.45743 .44242 m
.48563 .43777 L
s
.48563 .43777 m
.51437 .43777 L
s
.51437 .43777 m
.54257 .44242 L
s
.63461 .57147 m
.63912 .5954 L
s
.36088 .5954 m
.36539 .57147 L
s
.54342 .75144 m
.54256 .77007 L
s
.51443 .77548 m
.54256 .77007 L
s
.45744 .77007 m
.48557 .77548 L
s
.45658 .75144 m
.45744 .77007 L
s
.43082 .45158 m
.45743 .44242 L
s
.54257 .44242 m
.56918 .45158 L
s
.407 .72558 m
.38847 .70662 L
s
.38621 .68669 m
.38847 .70662 L
s
.61379 .68669 m
.61153 .70662 L
s
.61153 .70662 m
.593 .72558 L
s
.37274 .66473 m
.36515 .6411 L
s
.36242 .61984 m
.36515 .6411 L
s
.63758 .61984 m
.63485 .6411 L
s
.63485 .6411 m
.62726 .66473 L
s
.867 .244 .104 r
.37567 .52392 m .39343 .52392 L .40337 .50212 L p F P
0 0 0 r
s
.867 .244 .104 r
.40337 .50212 m .38726 .50212 L .37567 .52392 L p F P
0 0 0 r
s
.867 .244 .104 r
.39343 .52392 m .4112 .52392 L .41947 .50212 L p F P
0 0 0 r
s
.867 .244 .104 r
.41947 .50212 m .40337 .50212 L .39343 .52392 L p F P
0 0 0 r
s
.867 .244 .104 r
.4112 .52392 m .42896 .52392 L .43558 .50212 L p F P
0 0 0 r
s
.867 .244 .104 r
.43558 .50212 m .41947 .50212 L .4112 .52392 L p F P
0 0 0 r
s
.867 .244 .104 r
.42896 .52392 m .44672 .52392 L .45168 .50212 L p F P
0 0 0 r
s
.867 .244 .104 r
.45168 .50212 m .43558 .50212 L .42896 .52392 L p F P
0 0 0 r
s
.867 .244 .104 r
.44672 .52392 m .46448 .52392 L .46779 .50212 L p F P
0 0 0 r
s
.867 .244 .104 r
.46779 .50212 m .45168 .50212 L .44672 .52392 L p F P
0 0 0 r
s
.867 .244 .104 r
.46448 .52392 m .48224 .52392 L .48389 .50212 L p F P
0 0 0 r
s
.867 .244 .104 r
.48389 .50212 m .46779 .50212 L .46448 .52392 L p F P
0 0 0 r
s
.867 .244 .104 r
.48224 .52392 m .5 .52392 L .5 .50212 L p F P
0 0 0 r
s
.867 .244 .104 r
.5 .50212 m .48389 .50212 L .48224 .52392 L p F P
0 0 0 r
s
.867 .244 .104 r
.5 .52392 m .51776 .52392 L .51611 .50212 L p F P
0 0 0 r
s
.867 .244 .104 r
.51611 .50212 m .5 .50212 L .5 .52392 L p F P
0 0 0 r
s
.867 .244 .104 r
.51776 .52392 m .53552 .52392 L .53221 .50212 L p F P
0 0 0 r
s
.867 .244 .104 r
.53221 .50212 m .51611 .50212 L .51776 .52392 L p F P
0 0 0 r
s
.867 .244 .104 r
.53552 .52392 m .55328 .52392 L .54832 .50212 L p F P
0 0 0 r
s
.867 .244 .104 r
.54832 .50212 m .53221 .50212 L .53552 .52392 L p F P
0 0 0 r
s
.867 .244 .104 r
.55328 .52392 m .57104 .52392 L .56442 .50212 L p F P
0 0 0 r
s
.867 .244 .104 r
.56442 .50212 m .54832 .50212 L .55328 .52392 L p F P
0 0 0 r
s
.867 .244 .104 r
.57104 .52392 m .5888 .52392 L .58053 .50212 L p F P
0 0 0 r
s
.867 .244 .104 r
.58053 .50212 m .56442 .50212 L .57104 .52392 L p F P
0 0 0 r
s
.867 .244 .104 r
.5888 .52392 m .60657 .52392 L .59663 .50212 L p F P
0 0 0 r
s
.867 .244 .104 r
.59663 .50212 m .58053 .50212 L .5888 .52392 L p F P
0 0 0 r
s
.867 .244 .104 r
.60657 .52392 m .62433 .52392 L .61274 .50212 L p F P
0 0 0 r
s
.24 .35 .67 r
.61134 .50606 m
.61155 .50633 L
s
.867 .244 .104 r
.61274 .50212 m .59663 .50212 L .60657 .52392 L p F P
0 0 0 r
s
.893 .253 .108 r
.38726 .50212 m .40337 .50212 L .41546 .48028 L p F P
0 0 0 r
s
.893 .253 .108 r
.41546 .48028 m .40138 .48028 L .38726 .50212 L p F P
0 0 0 r
s
.893 .253 .108 r
.40337 .50212 m .41947 .50212 L .42955 .48028 L p F P
0 0 0 r
s
.893 .253 .108 r
.42955 .48028 m .41546 .48028 L .40337 .50212 L p F P
0 0 0 r
s
.893 .253 .108 r
.41947 .50212 m .43558 .50212 L .44364 .48028 L p F P
0 0 0 r
s
.893 .253 .108 r
.44364 .48028 m .42955 .48028 L .41947 .50212 L p F P
0 0 0 r
s
.893 .253 .108 r
.43558 .50212 m .45168 .50212 L .45773 .48028 L p F P
0 0 0 r
s
.893 .253 .108 r
.45773 .48028 m .44364 .48028 L .43558 .50212 L p F P
0 0 0 r
s
.893 .253 .108 r
.45168 .50212 m .46779 .50212 L .47182 .48028 L p F P
0 0 0 r
s
.893 .253 .108 r
.47182 .48028 m .45773 .48028 L .45168 .50212 L p F P
0 0 0 r
s
.893 .253 .108 r
.46779 .50212 m .48389 .50212 L .48591 .48028 L p F P
0 0 0 r
s
.893 .253 .108 r
.48591 .48028 m .47182 .48028 L .46779 .50212 L p F P
0 0 0 r
s
.893 .253 .108 r
.48389 .50212 m .5 .50212 L .5 .48028 L p F P
0 0 0 r
s
.893 .253 .108 r
.5 .48028 m .48591 .48028 L .48389 .50212 L p F P
0 0 0 r
s
.893 .253 .108 r
.5 .50212 m .51611 .50212 L .51409 .48028 L p F P
0 0 0 r
s
.893 .253 .108 r
.51409 .48028 m .5 .48028 L .5 .50212 L p F P
0 0 0 r
s
.893 .253 .108 r
.51611 .50212 m .53221 .50212 L .52818 .48028 L p F P
0 0 0 r
s
.893 .253 .108 r
.52818 .48028 m .51409 .48028 L .51611 .50212 L p F P
0 0 0 r
s
.893 .253 .108 r
.53221 .50212 m .54832 .50212 L .54227 .48028 L p F P
0 0 0 r
s
.893 .253 .108 r
.54227 .48028 m .52818 .48028 L .53221 .50212 L p F P
0 0 0 r
s
.893 .253 .108 r
.54832 .50212 m .56442 .50212 L .55636 .48028 L p F P
0 0 0 r
s
.893 .253 .108 r
.55636 .48028 m .54227 .48028 L .54832 .50212 L p F P
0 0 0 r
s
.893 .253 .108 r
.56442 .50212 m .58053 .50212 L .57045 .48028 L p F P
0 0 0 r
s
.893 .253 .108 r
.57045 .48028 m .55636 .48028 L .56442 .50212 L p F P
0 0 0 r
s
.893 .253 .108 r
.58053 .50212 m .59663 .50212 L .58454 .48028 L p F P
0 0 0 r
s
.893 .253 .108 r
.58454 .48028 m .57045 .48028 L .58053 .50212 L p F P
0 0 0 r
s
.893 .253 .108 r
.59663 .50212 m .61274 .50212 L .59862 .48028 L p F P
0 0 0 r
s
.893 .253 .108 r
.59862 .48028 m .58454 .48028 L .59663 .50212 L p F P
0 0 0 r
s
.173 .262 .553 r
.59933 .47162 m .59862 .48028 L .61274 .50212 L p F P
0 0 0 r
s
.173 .262 .553 r
.61274 .50212 m .61366 .49239 L .59933 .47162 L p F P
0 0 0 r
s
.135 .206 .453 r
.61366 .49239 m .61274 .50212 L .62433 .52392 L p F P
0 0 0 r
s
.33 .481 .895 r
.38634 .49239 m .38726 .50212 L .37567 .52392 L p F P
0 0 0 r
s
.332 .486 .914 r
.38726 .50212 m .38634 .49239 L .40067 .47162 L p F P
0 0 0 r
s
.332 .486 .914 r
.40067 .47162 m .40138 .48028 L .38726 .50212 L p F P
0 0 0 r
s
.24 .35 .67 r
.51472 .75692 m
.51443 .77548 L
s
.48557 .77548 m
.51443 .77548 L
s
.48528 .75692 m
.48557 .77548 L
s
.203 .306 .632 r
.58272 .45146 m .58223 .45879 L .59862 .48028 L p F P
0 0 0 r
s
.203 .306 .632 r
.59862 .48028 m .59933 .47162 L .58272 .45146 L p F P
0 0 0 r
s
.917 .262 .111 r
.40138 .48028 m .41546 .48028 L .42952 .45879 L p F P
0 0 0 r
s
.917 .262 .111 r
.42952 .45879 m .41777 .45879 L .40138 .48028 L p F P
0 0 0 r
s
.917 .262 .111 r
.41546 .48028 m .42955 .48028 L .44126 .45879 L p F P
0 0 0 r
s
.24 .35 .67 r
.43216 .4755 m
.43217 .47578 L
s
.917 .262 .111 r
.44126 .45879 m .42952 .45879 L .41546 .48028 L p F P
0 0 0 r
s
.917 .262 .111 r
.42955 .48028 m .44364 .48028 L .45301 .45879 L p F P
0 0 0 r
s
.917 .262 .111 r
.45301 .45879 m .44126 .45879 L .42955 .48028 L p F P
0 0 0 r
s
.24 .35 .67 r
.43082 .45158 m
.43122 .45879 L
s
.917 .262 .111 r
.44364 .48028 m .45773 .48028 L .46476 .45879 L p F P
0 0 0 r
s
.917 .262 .111 r
.46476 .45879 m .45301 .45879 L .44364 .48028 L p F P
0 0 0 r
s
.917 .262 .111 r
.45773 .48028 m .47182 .48028 L .47651 .45879 L p F P
0 0 0 r
s
.917 .262 .111 r
.47651 .45879 m .46476 .45879 L .45773 .48028 L p F P
0 0 0 r
s
.917 .262 .111 r
.47182 .48028 m .48591 .48028 L .48825 .45879 L p F P
0 0 0 r
s
.917 .262 .111 r
.48825 .45879 m .47651 .45879 L .47182 .48028 L p F P
0 0 0 r
s
.917 .262 .111 r
.48591 .48028 m .5 .48028 L .5 .45879 L p F P
0 0 0 r
s
.917 .262 .111 r
.5 .45879 m .48825 .45879 L .48591 .48028 L p F P
0 0 0 r
s
.917 .262 .111 r
.5 .48028 m .51409 .48028 L .51175 .45879 L p F P
0 0 0 r
s
.917 .262 .111 r
.51175 .45879 m .5 .45879 L .5 .48028 L p F P
0 0 0 r
s
.917 .262 .111 r
.51409 .48028 m .52818 .48028 L .52349 .45879 L p F P
0 0 0 r
s
.917 .262 .111 r
.52349 .45879 m .51175 .45879 L .51409 .48028 L p F P
0 0 0 r
s
.917 .262 .111 r
.52818 .48028 m .54227 .48028 L .53524 .45879 L p F P
0 0 0 r
s
.917 .262 .111 r
.53524 .45879 m .52349 .45879 L .52818 .48028 L p F P
0 0 0 r
s
.917 .262 .111 r
.54227 .48028 m .55636 .48028 L .54699 .45879 L p F P
0 0 0 r
s
.917 .262 .111 r
.54699 .45879 m .53524 .45879 L .54227 .48028 L p F P
0 0 0 r
s
.917 .262 .111 r
.55636 .48028 m .57045 .48028 L .55874 .45879 L p F P
0 0 0 r
s
.917 .262 .111 r
.55874 .45879 m .54699 .45879 L .55636 .48028 L p F P
0 0 0 r
s
.917 .262 .111 r
.57045 .48028 m .58454 .48028 L .57048 .45879 L p F P
0 0 0 r
s
.917 .262 .111 r
.57048 .45879 m .55874 .45879 L .57045 .48028 L p F P
0 0 0 r
s
.24 .35 .67 r
.56878 .45879 m
.56918 .45158 L
s
.917 .262 .111 r
.58454 .48028 m .59862 .48028 L .58223 .45879 L p F P
0 0 0 r
s
.917 .262 .111 r
.58223 .45879 m .57048 .45879 L .58454 .48028 L p F P
0 0 0 r
s
.33 .484 .918 r
.40138 .48028 m .40067 .47162 L .41728 .45146 L p F P
0 0 0 r
s
.33 .484 .918 r
.41728 .45146 m .41777 .45879 L .40138 .48028 L p F P
0 0 0 r
s
.83 .24 .1 r
.26277 .53082 m
.26329 .5021 L
s
.22384 .5021 m
.22323 .53082 L
s
.26329 .5021 m
.22384 .5021 L
s
.30231 .53082 m
.30274 .5021 L
s
.30274 .5021 m
.26329 .5021 L
s
.34185 .53082 m
.34219 .5021 L
s
.34219 .5021 m
.30274 .5021 L
s
.38161 .50638 m
.38164 .5021 L
s
.34219 .5021 m
.38164 .5021 L
s
.38666 .5021 m
.4211 .5021 L
s
.38164 .5021 m
.38305 .5021 L
s
.46055 .5021 m
.4211 .5021 L
s
.5 .5021 m
.46055 .5021 L
s
.53945 .5021 m
.5 .5021 L
s
.5789 .5021 m
.53945 .5021 L
s
.61836 .5021 m
.61839 .50638 L
s
.5789 .5021 m
.61334 .5021 L
s
.61695 .5021 m
.61836 .5021 L
s
.65815 .53082 m
.65781 .5021 L
s
.61836 .5021 m
.65781 .5021 L
s
.69769 .53082 m
.69726 .5021 L
s
.69726 .5021 m
.65781 .5021 L
s
.73723 .53082 m
.73671 .5021 L
s
.73671 .5021 m
.69726 .5021 L
s
.77677 .53082 m
.77616 .5021 L
s
.77616 .5021 m
.73671 .5021 L
s
.26329 .5021 m
.2629 .4733 L
s
.22339 .4733 m
.22384 .5021 L
s
.30274 .5021 m
.30242 .4733 L
s
.34219 .5021 m
.34193 .4733 L
s
.42097 .4733 m
.4211 .5021 L
s
.46048 .4733 m
.46055 .5021 L
s
.5 .4733 m
.5 .5021 L
s
.53945 .5021 m
.53952 .4733 L
s
.5789 .5021 m
.57903 .4733 L
s
.65781 .5021 m
.65807 .4733 L
s
.69726 .5021 m
.69758 .4733 L
s
.73671 .5021 m
.7371 .4733 L
s
.77616 .5021 m
.77661 .4733 L
s
.838 .234 .1 r
.36684 .54528 m .38586 .54528 L .39343 .52392 L p F P
0 0 0 r
s
.24 .35 .67 r
.37516 .54528 m
.37557 .54908 L
s
.838 .234 .1 r
.39343 .52392 m .37567 .52392 L .36684 .54528 L p F P
0 0 0 r
s
.838 .234 .1 r
.38586 .54528 m .40489 .54528 L .4112 .52392 L p F P
0 0 0 r
s
.838 .234 .1 r
.4112 .52392 m .39343 .52392 L .38586 .54528 L p F P
0 0 0 r
s
.838 .234 .1 r
.40489 .54528 m .42391 .54528 L .42896 .52392 L p F P
0 0 0 r
s
.838 .234 .1 r
.42896 .52392 m .4112 .52392 L .40489 .54528 L p F P
0 0 0 r
s
.83 .24 .1 r
.42092 .53082 m
.4211 .5021 L
s
.838 .234 .1 r
.42391 .54528 m .44293 .54528 L .44672 .52392 L p F P
0 0 0 r
s
.838 .234 .1 r
.44672 .52392 m .42896 .52392 L .42391 .54528 L p F P
0 0 0 r
s
.838 .234 .1 r
.44293 .54528 m .46195 .54528 L .46448 .52392 L p F P
0 0 0 r
s
.838 .234 .1 r
.46448 .52392 m .44672 .52392 L .44293 .54528 L p F P
0 0 0 r
s
.83 .24 .1 r
.46046 .53082 m
.46055 .5021 L
s
.838 .234 .1 r
.46195 .54528 m .48098 .54528 L .48224 .52392 L p F P
0 0 0 r
s
.838 .234 .1 r
.48224 .52392 m .46448 .52392 L .46195 .54528 L p F P
0 0 0 r
s
.838 .234 .1 r
.48098 .54528 m .5 .54528 L .5 .52392 L p F P
0 0 0 r
s
.838 .234 .1 r
.5 .52392 m .48224 .52392 L .48098 .54528 L p F P
0 0 0 r
s
.838 .234 .1 r
.5 .54528 m .51902 .54528 L .51776 .52392 L p F P
0 0 0 r
s
.838 .234 .1 r
.51776 .52392 m .5 .52392 L .5 .54528 L p F P
0 0 0 r
s
.83 .24 .1 r
.5 .5021 m
.5 .53082 L
s
.838 .234 .1 r
.51902 .54528 m .53805 .54528 L .53552 .52392 L p F P
0 0 0 r
s
.838 .234 .1 r
.53552 .52392 m .51776 .52392 L .51902 .54528 L p F P
0 0 0 r
s
.838 .234 .1 r
.53805 .54528 m .55707 .54528 L .55328 .52392 L p F P
0 0 0 r
s
.838 .234 .1 r
.55328 .52392 m .53552 .52392 L .53805 .54528 L p F P
0 0 0 r
s
.83 .24 .1 r
.53945 .5021 m
.53954 .53082 L
s
.838 .234 .1 r
.55707 .54528 m .57609 .54528 L .57104 .52392 L p F P
0 0 0 r
s
.838 .234 .1 r
.57104 .52392 m .55328 .52392 L .55707 .54528 L p F P
0 0 0 r
s
.838 .234 .1 r
.57609 .54528 m .59511 .54528 L .5888 .52392 L p F P
0 0 0 r
s
.838 .234 .1 r
.5888 .52392 m .57104 .52392 L .57609 .54528 L p F P
0 0 0 r
s
.83 .24 .1 r
.5789 .5021 m
.57908 .53082 L
s
.838 .234 .1 r
.59511 .54528 m .61414 .54528 L .60657 .52392 L p F P
0 0 0 r
s
.838 .234 .1 r
.60657 .52392 m .5888 .52392 L .59511 .54528 L p F P
0 0 0 r
s
.838 .234 .1 r
.61414 .54528 m .63316 .54528 L .62433 .52392 L p F P
0 0 0 r
s
.24 .35 .67 r
.62443 .54908 m
.62484 .54528 L
s
.838 .234 .1 r
.62433 .52392 m .60657 .52392 L .61414 .54528 L p F P
0 0 0 r
s
.135 .206 .453 r
.62433 .52392 m .62545 .51338 L .61366 .49239 L p F P
0 0 0 r
s
.83 .24 .1 r
.61844 .51149 m
.61861 .53082 L
s
.61837 .50077 m
.61855 .4733 L
s
.096 .145 .343 r
.62545 .51338 m .62433 .52392 L .63316 .54528 L p F P
0 0 0 r
s
.32 .464 .852 r
.37455 .51338 m .37567 .52392 L .36684 .54528 L p F P
0 0 0 r
s
.33 .481 .895 r
.37567 .52392 m .37455 .51338 L .38634 .49239 L p F P
0 0 0 r
s
.83 .24 .1 r
.38139 .53082 m
.38156 .51149 L
s
.38145 .4733 m
.38163 .50077 L
s
.2629 .4733 m
.22339 .4733 L
s
.30242 .4733 m
.2629 .4733 L
s
.34193 .4733 m
.30242 .4733 L
s
.38145 .4733 m
.34193 .4733 L
s
.40589 .4733 m
.42097 .4733 L
s
.38145 .4733 m
.39951 .4733 L
s
.42097 .4733 m
.46048 .4733 L
s
.46048 .4733 m
.5 .4733 L
s
.5 .4733 m
.53952 .4733 L
s
.53952 .4733 m
.57903 .4733 L
s
.57903 .4733 m
.59411 .4733 L
s
.60049 .4733 m
.61855 .4733 L
s
.65807 .4733 m
.61855 .4733 L
s
.69758 .4733 m
.65807 .4733 L
s
.7371 .4733 m
.69758 .4733 L
s
.77661 .4733 m
.7371 .4733 L
s
.2629 .4733 m
.26162 .44538 L
s
.22189 .44538 m
.22339 .4733 L
s
.30242 .4733 m
.30135 .44538 L
s
.34193 .4733 m
.34108 .44538 L
s
.38145 .4733 m
.38081 .44538 L
s
.61855 .4733 m
.61919 .44538 L
s
.65807 .4733 m
.65892 .44538 L
s
.69758 .4733 m
.69865 .44538 L
s
.7371 .4733 m
.73838 .44538 L
s
.77661 .4733 m
.77811 .44538 L
s
.26137 .55854 m
.26277 .53082 L
s
.22323 .53082 m
.22159 .55854 L
s
.26277 .53082 m
.22323 .53082 L
s
.30114 .55854 m
.30231 .53082 L
s
.30231 .53082 m
.26277 .53082 L
s
.34091 .55854 m
.34185 .53082 L
s
.34185 .53082 m
.30231 .53082 L
s
.37248 .53082 m
.38139 .53082 L
s
.34185 .53082 m
.37033 .53082 L
s
.38139 .53082 m
.42092 .53082 L
s
.42092 .53082 m
.46046 .53082 L
s
.46046 .53082 m
.5 .53082 L
s
.5 .53082 m
.53954 .53082 L
s
.53954 .53082 m
.57908 .53082 L
s
.57908 .53082 m
.61861 .53082 L
s
.65909 .55854 m
.65815 .53082 L
s
.61861 .53082 m
.62752 .53082 L
s
.62967 .53082 m
.65815 .53082 L
s
.69886 .55854 m
.69769 .53082 L
s
.69769 .53082 m
.65815 .53082 L
s
.73863 .55854 m
.73723 .53082 L
s
.73723 .53082 m
.69769 .53082 L
s
.77841 .55854 m
.77677 .53082 L
s
.77677 .53082 m
.73723 .53082 L
s
.228 .342 .695 r
.56413 .43229 m .56384 .43807 L .58223 .45879 L p F P
0 0 0 r
s
.228 .342 .695 r
.58223 .45879 m .58272 .45146 L .56413 .43229 L p F P
0 0 0 r
s
.938 .269 .115 r
.41777 .45879 m .42952 .45879 L .44528 .43807 L p F P
0 0 0 r
s
.938 .269 .115 r
.44528 .43807 m .43616 .43807 L .41777 .45879 L p F P
0 0 0 r
s
.938 .269 .115 r
.42952 .45879 m .44126 .45879 L .4544 .43807 L p F P
0 0 0 r
s
.938 .269 .115 r
.4544 .43807 m .44528 .43807 L .42952 .45879 L p F P
0 0 0 r
s
.938 .269 .115 r
.44126 .45879 m .45301 .45879 L .46352 .43807 L p F P
0 0 0 r
s
.938 .269 .115 r
.46352 .43807 m .4544 .43807 L .44126 .45879 L p F P
0 0 0 r
s
.938 .269 .115 r
.45301 .45879 m .46476 .45879 L .47264 .43807 L p F P
0 0 0 r
s
.938 .269 .115 r
.47264 .43807 m .46352 .43807 L .45301 .45879 L p F P
0 0 0 r
s
.83 .24 .1 r
.46027 .44538 m
.46048 .4733 L
s
.938 .269 .115 r
.46476 .45879 m .47651 .45879 L .48176 .43807 L p F P
0 0 0 r
s
.938 .269 .115 r
.48176 .43807 m .47264 .43807 L .46476 .45879 L p F P
0 0 0 r
s
.938 .269 .115 r
.47651 .45879 m .48825 .45879 L .49088 .43807 L p F P
0 0 0 r
s
.938 .269 .115 r
.49088 .43807 m .48176 .43807 L .47651 .45879 L p F P
0 0 0 r
s
.938 .269 .115 r
.48825 .45879 m .5 .45879 L .5 .43807 L p F P
0 0 0 r
s
.938 .269 .115 r
.5 .43807 m .49088 .43807 L .48825 .45879 L p F P
0 0 0 r
s
.938 .269 .115 r
.5 .45879 m .51175 .45879 L .50912 .43807 L p F P
0 0 0 r
s
.938 .269 .115 r
.50912 .43807 m .5 .43807 L .5 .45879 L p F P
0 0 0 r
s
.83 .24 .1 r
.5 .44538 m
.5 .4733 L
s
.938 .269 .115 r
.51175 .45879 m .52349 .45879 L .51824 .43807 L p F P
0 0 0 r
s
.938 .269 .115 r
.51824 .43807 m .50912 .43807 L .51175 .45879 L p F P
0 0 0 r
s
.938 .269 .115 r
.52349 .45879 m .53524 .45879 L .52736 .43807 L p F P
0 0 0 r
s
.938 .269 .115 r
.52736 .43807 m .51824 .43807 L .52349 .45879 L p F P
0 0 0 r
s
.938 .269 .115 r
.53524 .45879 m .54699 .45879 L .53648 .43807 L p F P
0 0 0 r
s
.938 .269 .115 r
.53648 .43807 m .52736 .43807 L .53524 .45879 L p F P
0 0 0 r
s
.938 .269 .115 r
.54699 .45879 m .55874 .45879 L .5456 .43807 L p F P
0 0 0 r
s
.938 .269 .115 r
.5456 .43807 m .53648 .43807 L .54699 .45879 L p F P
0 0 0 r
s
.83 .24 .1 r
.53952 .4733 m
.53973 .44538 L
s
.938 .269 .115 r
.55874 .45879 m .57048 .45879 L .55472 .43807 L p F P
0 0 0 r
s
.938 .269 .115 r
.55472 .43807 m .5456 .43807 L .55874 .45879 L p F P
0 0 0 r
s
.938 .269 .115 r
.57048 .45879 m .58223 .45879 L .56384 .43807 L p F P
0 0 0 r
s
.83 .24 .1 r
.57903 .4733 m
.57934 .4534 L
s
.57942 .44805 m
.57946 .44538 L
s
.938 .269 .115 r
.56384 .43807 m .55472 .43807 L .57048 .45879 L p F P
0 0 0 r
s
.324 .477 .912 r
.41777 .45879 m .41728 .45146 L .43587 .43229 L p F P
0 0 0 r
s
.324 .477 .912 r
.43587 .43229 m .43616 .43807 L .41777 .45879 L p F P
0 0 0 r
s
.83 .24 .1 r
.42054 .44538 m
.42058 .44805 L
s
.42066 .4534 m
.42097 .4733 L
s
.804 .223 .095 r
.36095 .56581 m .38081 .56581 L .38586 .54528 L p F P
0 0 0 r
s
.24 .35 .67 r
.36471 .56581 m
.36539 .57147 L
s
.804 .223 .095 r
.38586 .54528 m .36684 .54528 L .36095 .56581 L p F P
0 0 0 r
s
.804 .223 .095 r
.38081 .56581 m .40068 .56581 L .40489 .54528 L p F P
0 0 0 r
s
.804 .223 .095 r
.40489 .54528 m .38586 .54528 L .38081 .56581 L p F P
0 0 0 r
s
.83 .24 .1 r
.38068 .55854 m
.38139 .53082 L
s
.804 .223 .095 r
.40068 .56581 m .42054 .56581 L .42391 .54528 L p F P
0 0 0 r
s
.804 .223 .095 r
.42391 .54528 m .40489 .54528 L .40068 .56581 L p F P
0 0 0 r
s
.804 .223 .095 r
.42054 .56581 m .44041 .56581 L .44293 .54528 L p F P
0 0 0 r
s
.804 .223 .095 r
.44293 .54528 m .42391 .54528 L .42054 .56581 L p F P
0 0 0 r
s
.83 .24 .1 r
.42046 .55854 m
.42092 .53082 L
s
.804 .223 .095 r
.44041 .56581 m .46027 .56581 L .46195 .54528 L p F P
0 0 0 r
s
.804 .223 .095 r
.46195 .54528 m .44293 .54528 L .44041 .56581 L p F P
0 0 0 r
s
.804 .223 .095 r
.46027 .56581 m .48014 .56581 L .48098 .54528 L p F P
0 0 0 r
s
.804 .223 .095 r
.48098 .54528 m .46195 .54528 L .46027 .56581 L p F P
0 0 0 r
s
.83 .24 .1 r
.46023 .55854 m
.46046 .53082 L
s
.804 .223 .095 r
.48014 .56581 m .5 .56581 L .5 .54528 L p F P
0 0 0 r
s
.804 .223 .095 r
.5 .54528 m .48098 .54528 L .48014 .56581 L p F P
0 0 0 r
s
.804 .223 .095 r
.5 .56581 m .51986 .56581 L .51902 .54528 L p F P
0 0 0 r
s
.804 .223 .095 r
.51902 .54528 m .5 .54528 L .5 .56581 L p F P
0 0 0 r
s
.83 .24 .1 r
.5 .53082 m
.5 .55854 L
s
.804 .223 .095 r
.51986 .56581 m .53973 .56581 L .53805 .54528 L p F P
0 0 0 r
s
.804 .223 .095 r
.53805 .54528 m .51902 .54528 L .51986 .56581 L p F P
0 0 0 r
s
.804 .223 .095 r
.53973 .56581 m .55959 .56581 L .55707 .54528 L p F P
0 0 0 r
s
.804 .223 .095 r
.55707 .54528 m .53805 .54528 L .53973 .56581 L p F P
0 0 0 r
s
.83 .24 .1 r
.53954 .53082 m
.53977 .55854 L
s
.804 .223 .095 r
.55959 .56581 m .57946 .56581 L .57609 .54528 L p F P
0 0 0 r
s
.804 .223 .095 r
.57609 .54528 m .55707 .54528 L .55959 .56581 L p F P
0 0 0 r
s
.804 .223 .095 r
.57946 .56581 m .59932 .56581 L .59511 .54528 L p F P
0 0 0 r
s
.804 .223 .095 r
.59511 .54528 m .57609 .54528 L .57946 .56581 L p F P
0 0 0 r
s
.83 .24 .1 r
.57908 .53082 m
.57954 .55854 L
s
.804 .223 .095 r
.59932 .56581 m .61919 .56581 L .61414 .54528 L p F P
0 0 0 r
s
.804 .223 .095 r
.61414 .54528 m .59511 .54528 L .59932 .56581 L p F P
0 0 0 r
s
.804 .223 .095 r
.61919 .56581 m .63905 .56581 L .63316 .54528 L p F P
0 0 0 r
s
.24 .35 .67 r
.63461 .57147 m
.63529 .56581 L
s
.804 .223 .095 r
.63316 .54528 m .61414 .54528 L .61919 .56581 L p F P
0 0 0 r
s
.83 .24 .1 r
.61861 .53082 m
.61932 .55854 L
s
.096 .145 .343 r
.63316 .54528 m .63445 .5342 L .62545 .51338 L p F P
0 0 0 r
s
.24 .35 .67 r
.62635 .53146 m
.62692 .52624 L
s
.61641 .51263 m
.62692 .52624 L
s
.072 .105 .259 r
.63445 .5342 m .63316 .54528 L .63905 .56581 L p F P
0 0 0 r
s
.298 .43 .775 r
.36555 .5342 m .36684 .54528 L .36095 .56581 L p F P
0 0 0 r
s
.32 .464 .852 r
.36684 .54528 m .36555 .5342 L .37455 .51338 L p F P
0 0 0 r
s
.24 .35 .67 r
.37308 .52624 m
.38359 .51263 L
s
.37308 .52624 m
.37365 .53146 L
s
.59489 .70587 m
.593 .72558 L
s
.593 .72558 m
.56994 .74079 L
s
.43006 .74079 m
.407 .72558 L
s
.40511 .70587 m
.407 .72558 L
s
.83 .24 .1 r
.26162 .44538 m
.22189 .44538 L
s
.30135 .44538 m
.26162 .44538 L
s
.34108 .44538 m
.30135 .44538 L
s
.38081 .44538 m
.34108 .44538 L
s
.38081 .44538 m
.42054 .44538 L
s
.42852 .44538 m
.46027 .44538 L
s
.42054 .44538 m
.42318 .44538 L
s
.46027 .44538 m
.5 .44538 L
s
.5 .44538 m
.53973 .44538 L
s
.53973 .44538 m
.57148 .44538 L
s
.57682 .44538 m
.57946 .44538 L
s
.57946 .44538 m
.61919 .44538 L
s
.65892 .44538 m
.61919 .44538 L
s
.69865 .44538 m
.65892 .44538 L
s
.73838 .44538 m
.69865 .44538 L
s
.77811 .44538 m
.73838 .44538 L
s
.26162 .44538 m
.25948 .41926 L
s
.21939 .41926 m
.22189 .44538 L
s
.30135 .44538 m
.29957 .41926 L
s
.34108 .44538 m
.33965 .41926 L
s
.38081 .44538 m
.37974 .41926 L
s
.61919 .44538 m
.62026 .41926 L
s
.65892 .44538 m
.66035 .41926 L
s
.69865 .44538 m
.70043 .41926 L
s
.73838 .44538 m
.74052 .41926 L
s
.77811 .44538 m
.78061 .41926 L
s
.203 .306 .632 r
.58321 .44404 m .58272 .45146 L .59933 .47162 L p F P
0 0 0 r
s
.203 .306 .632 r
.59933 .47162 m .60004 .46284 L .58321 .44404 L p F P
0 0 0 r
s
.24 .35 .67 r
.59247 .47426 m
.59318 .46496 L
s
.57602 .45539 m
.59318 .46496 L
s
.173 .262 .553 r
.60004 .46284 m .59933 .47162 L .61366 .49239 L p F P
0 0 0 r
s
.332 .486 .914 r
.39996 .46284 m .40067 .47162 L .38634 .49239 L p F P
0 0 0 r
s
.33 .484 .918 r
.40067 .47162 m .39996 .46284 L .41679 .44404 L p F P
0 0 0 r
s
.33 .484 .918 r
.41679 .44404 m .41728 .45146 L .40067 .47162 L p F P
0 0 0 r
s
.24 .35 .67 r
.40682 .46496 m
.40753 .47426 L
s
.40682 .46496 m
.42398 .45539 L
s
.173 .262 .553 r
.61366 .49239 m .6146 .4825 L .60004 .46284 L p F P
0 0 0 r
s
.135 .206 .453 r
.6146 .4825 m .61366 .49239 L .62545 .51338 L p F P
0 0 0 r
s
.33 .481 .895 r
.3854 .4825 m .38634 .49239 L .37455 .51338 L p F P
0 0 0 r
s
.332 .486 .914 r
.38634 .49239 m .3854 .4825 L .39996 .46284 L p F P
0 0 0 r
s
.83 .24 .1 r
.2591 .58431 m
.26137 .55854 L
s
.22159 .55854 m
.21895 .58431 L
s
.26137 .55854 m
.22159 .55854 L
s
.29925 .58431 m
.30114 .55854 L
s
.30114 .55854 m
.26137 .55854 L
s
.3394 .58431 m
.34091 .55854 L
s
.34091 .55854 m
.30114 .55854 L
s
.36279 .55854 m
.38068 .55854 L
s
.34091 .55854 m
.36201 .55854 L
s
.38068 .55854 m
.42046 .55854 L
s
.42046 .55854 m
.46023 .55854 L
s
.46023 .55854 m
.5 .55854 L
s
.5 .55854 m
.53977 .55854 L
s
.53977 .55854 m
.57954 .55854 L
s
.57954 .55854 m
.61932 .55854 L
s
.6606 .58431 m
.65909 .55854 L
s
.61932 .55854 m
.63721 .55854 L
s
.63799 .55854 m
.65909 .55854 L
s
.70075 .58431 m
.69886 .55854 L
s
.69886 .55854 m
.65909 .55854 L
s
.7409 .58431 m
.73863 .55854 L
s
.73863 .55854 m
.69886 .55854 L
s
.78105 .58431 m
.77841 .55854 L
s
.77841 .55854 m
.73863 .55854 L
s
.959 .277 .118 r
.43616 .43807 m .44528 .43807 L .46249 .41851 L p F P
0 0 0 r
s
.959 .277 .118 r
.46249 .41851 m .45624 .41851 L .43616 .43807 L p F P
0 0 0 r
s
.959 .277 .118 r
.44528 .43807 m .4544 .43807 L .46874 .41851 L p F P
0 0 0 r
s
.24 .35 .67 r
.45716 .43431 m
.45729 .43807 L
s
.959 .277 .118 r
.46874 .41851 m .46249 .41851 L .44528 .43807 L p F P
0 0 0 r
s
.959 .277 .118 r
.4544 .43807 m .46352 .43807 L .47499 .41851 L p F P
0 0 0 r
s
.959 .277 .118 r
.47499 .41851 m .46874 .41851 L .4544 .43807 L p F P
0 0 0 r
s
.83 .24 .1 r
.45991 .41926 m
.46027 .44538 L
s
.959 .277 .118 r
.46352 .43807 m .47264 .43807 L .48124 .41851 L p F P
0 0 0 r
s
.959 .277 .118 r
.48124 .41851 m .47499 .41851 L .46352 .43807 L p F P
0 0 0 r
s
.959 .277 .118 r
.47264 .43807 m .48176 .43807 L .4875 .41851 L p F P
0 0 0 r
s
.24 .35 .67 r
.48549 .42535 m
.48563 .43777 L
s
.959 .277 .118 r
.4875 .41851 m .48124 .41851 L .47264 .43807 L p F P
0 0 0 r
s
.959 .277 .118 r
.48176 .43807 m .49088 .43807 L .49375 .41851 L p F P
0 0 0 r
s
.959 .277 .118 r
.49375 .41851 m .4875 .41851 L .48176 .43807 L p F P
0 0 0 r
s
.959 .277 .118 r
.49088 .43807 m .5 .43807 L .5 .41851 L p F P
0 0 0 r
s
.959 .277 .118 r
.5 .41851 m .49375 .41851 L .49088 .43807 L p F P
0 0 0 r
s
.959 .277 .118 r
.5 .43807 m .50912 .43807 L .50625 .41851 L p F P
0 0 0 r
s
.959 .277 .118 r
.50625 .41851 m .5 .41851 L .5 .43807 L p F P
0 0 0 r
s
.83 .24 .1 r
.5 .41926 m
.5 .44538 L
s
.959 .277 .118 r
.50912 .43807 m .51824 .43807 L .5125 .41851 L p F P
0 0 0 r
s
.959 .277 .118 r
.5125 .41851 m .50625 .41851 L .50912 .43807 L p F P
0 0 0 r
s
.959 .277 .118 r
.51824 .43807 m .52736 .43807 L .51876 .41851 L p F P
0 0 0 r
s
.959 .277 .118 r
.51876 .41851 m .5125 .41851 L .51824 .43807 L p F P
0 0 0 r
s
.959 .277 .118 r
.52736 .43807 m .53648 .43807 L .52501 .41851 L p F P
0 0 0 r
s
.959 .277 .118 r
.52501 .41851 m .51876 .41851 L .52736 .43807 L p F P
0 0 0 r
s
.959 .277 .118 r
.53648 .43807 m .5456 .43807 L .53126 .41851 L p F P
0 0 0 r
s
.959 .277 .118 r
.53126 .41851 m .52501 .41851 L .53648 .43807 L p F P
0 0 0 r
s
.959 .277 .118 r
.5456 .43807 m .55472 .43807 L .53751 .41851 L p F P
0 0 0 r
s
.24 .35 .67 r
.54284 .43431 m
.54293 .43163 L
s
.959 .277 .118 r
.53751 .41851 m .53126 .41851 L .5456 .43807 L p F P
0 0 0 r
s
.959 .277 .118 r
.55472 .43807 m .56384 .43807 L .54376 .41851 L p F P
0 0 0 r
s
.959 .277 .118 r
.54376 .41851 m .53751 .41851 L .55472 .43807 L p F P
0 0 0 r
s
.83 .24 .1 r
.53973 .44538 m
.54009 .41926 L
s
.249 .372 .747 r
.5439 .41449 m .54376 .41851 L .56384 .43807 L p F P
0 0 0 r
s
.249 .372 .747 r
.56384 .43807 m .56413 .43229 L .5439 .41449 L p F P
0 0 0 r
s
.316 .466 .898 r
.43616 .43807 m .43587 .43229 L .4561 .41449 L p F P
0 0 0 r
s
.316 .466 .898 r
.4561 .41449 m .45624 .41851 L .43616 .43807 L p F P
0 0 0 r
s
.24 .35 .67 r
.38621 .68669 m
.37274 .66473 L
s
.37013 .64374 m
.37274 .66473 L
s
.62987 .64374 m
.62726 .66473 L
s
.62726 .66473 m
.61379 .68669 L
s
.228 .342 .695 r
.56443 .42645 m .56413 .43229 L .58272 .45146 L p F P
0 0 0 r
s
.228 .342 .695 r
.58272 .45146 m .58321 .44404 L .56443 .42645 L p F P
0 0 0 r
s
.324 .477 .912 r
.41728 .45146 m .41679 .44404 L .43557 .42645 L p F P
0 0 0 r
s
.324 .477 .912 r
.43557 .42645 m .43587 .43229 L .41728 .45146 L p F P
0 0 0 r
s
.764 .21 .089 r
.35816 .58511 m .37842 .58511 L .38081 .56581 L p F P
0 0 0 r
s
.764 .21 .089 r
.38081 .56581 m .36095 .56581 L .35816 .58511 L p F P
0 0 0 r
s
.764 .21 .089 r
.37842 .58511 m .39868 .58511 L .40068 .56581 L p F P
0 0 0 r
s
.764 .21 .089 r
.40068 .56581 m .38081 .56581 L .37842 .58511 L p F P
0 0 0 r
s
.83 .24 .1 r
.37955 .58431 m
.38068 .55854 L
s
.764 .21 .089 r
.39868 .58511 m .41895 .58511 L .42054 .56581 L p F P
0 0 0 r
s
.764 .21 .089 r
.42054 .56581 m .40068 .56581 L .39868 .58511 L p F P
0 0 0 r
s
.764 .21 .089 r
.41895 .58511 m .43921 .58511 L .44041 .56581 L p F P
0 0 0 r
s
.764 .21 .089 r
.44041 .56581 m .42054 .56581 L .41895 .58511 L p F P
0 0 0 r
s
.83 .24 .1 r
.4197 .58431 m
.42046 .55854 L
s
.764 .21 .089 r
.43921 .58511 m .45947 .58511 L .46027 .56581 L p F P
0 0 0 r
s
.764 .21 .089 r
.46027 .56581 m .44041 .56581 L .43921 .58511 L p F P
0 0 0 r
s
.764 .21 .089 r
.45947 .58511 m .47974 .58511 L .48014 .56581 L p F P
0 0 0 r
s
.764 .21 .089 r
.48014 .56581 m .46027 .56581 L .45947 .58511 L p F P
0 0 0 r
s
.83 .24 .1 r
.45985 .58431 m
.46023 .55854 L
s
.764 .21 .089 r
.47974 .58511 m .5 .58511 L .5 .56581 L p F P
0 0 0 r
s
.764 .21 .089 r
.5 .56581 m .48014 .56581 L .47974 .58511 L p F P
0 0 0 r
s
.764 .21 .089 r
.5 .58511 m .52026 .58511 L .51986 .56581 L p F P
0 0 0 r
s
.764 .21 .089 r
.51986 .56581 m .5 .56581 L .5 .58511 L p F P
0 0 0 r
s
.83 .24 .1 r
.5 .55854 m
.5 .58431 L
s
.764 .21 .089 r
.52026 .58511 m .54053 .58511 L .53973 .56581 L p F P
0 0 0 r
s
.764 .21 .089 r
.53973 .56581 m .51986 .56581 L .52026 .58511 L p F P
0 0 0 r
s
.764 .21 .089 r
.54053 .58511 m .56079 .58511 L .55959 .56581 L p F P
0 0 0 r
s
.764 .21 .089 r
.55959 .56581 m .53973 .56581 L .54053 .58511 L p F P
0 0 0 r
s
.83 .24 .1 r
.53977 .55854 m
.54015 .58431 L
s
.764 .21 .089 r
.56079 .58511 m .58105 .58511 L .57946 .56581 L p F P
0 0 0 r
s
.764 .21 .089 r
.57946 .56581 m .55959 .56581 L .56079 .58511 L p F P
0 0 0 r
s
.764 .21 .089 r
.58105 .58511 m .60132 .58511 L .59932 .56581 L p F P
0 0 0 r
s
.764 .21 .089 r
.59932 .56581 m .57946 .56581 L .58105 .58511 L p F P
0 0 0 r
s
.83 .24 .1 r
.57954 .55854 m
.5803 .58431 L
s
.764 .21 .089 r
.60132 .58511 m .62158 .58511 L .61919 .56581 L p F P
0 0 0 r
s
.764 .21 .089 r
.61919 .56581 m .59932 .56581 L .60132 .58511 L p F P
0 0 0 r
s
.764 .21 .089 r
.62158 .58511 m .64184 .58511 L .63905 .56581 L p F P
0 0 0 r
s
.764 .21 .089 r
.63905 .56581 m .61919 .56581 L .62158 .58511 L p F P
0 0 0 r
s
.83 .24 .1 r
.61932 .55854 m
.62045 .58431 L
s
.072 .105 .259 r
.63905 .56581 m .64046 .55444 L .63445 .5342 L p F P
0 0 0 r
s
.052 .076 .18 r
.64046 .55444 m .63905 .56581 L .64184 .58511 L p F P
0 0 0 r
s
.26 .371 .651 r
.35954 .55444 m .36095 .56581 L .35816 .58511 L p F P
0 0 0 r
s
.298 .43 .775 r
.36095 .56581 m .35954 .55444 L .36555 .5342 L p F P
0 0 0 r
s
.135 .206 .453 r
.62545 .51338 m .62659 .50265 L .6146 .4825 L p F P
0 0 0 r
s
.096 .145 .343 r
.62659 .50265 m .62545 .51338 L .63445 .5342 L p F P
0 0 0 r
s
.32 .464 .852 r
.37341 .50265 m .37455 .51338 L .36555 .5342 L p F P
0 0 0 r
s
.33 .481 .895 r
.37455 .51338 m .37341 .50265 L .3854 .4825 L p F P
0 0 0 r
s
.249 .372 .747 r
.54404 .41044 m .5439 .41449 L .56413 .43229 L p F P
0 0 0 r
s
.249 .372 .747 r
.56413 .43229 m .56443 .42645 L .54404 .41044 L p F P
0 0 0 r
s
.316 .466 .898 r
.43587 .43229 m .43557 .42645 L .45596 .41044 L p F P
0 0 0 r
s
.316 .466 .898 r
.45596 .41044 m .4561 .41449 L .43587 .43229 L p F P
0 0 0 r
s
.24 .35 .67 r
.57138 .72127 m
.56994 .74079 L
s
.56994 .74079 m
.54342 .75144 L
s
.45658 .75144 m
.43006 .74079 L
s
.42862 .72127 m
.43006 .74079 L
s
.096 .145 .343 r
.63445 .5342 m .63576 .52289 L .62659 .50265 L p F P
0 0 0 r
s
.072 .105 .259 r
.63576 .52289 m .63445 .5342 L .64046 .55444 L p F P
0 0 0 r
s
.24 .35 .67 r
.62692 .52624 m
.63733 .54885 L
s
.63609 .55914 m
.63733 .54885 L
s
.298 .43 .775 r
.36424 .52289 m .36555 .5342 L .35954 .55444 L p F P
0 0 0 r
s
.24 .35 .67 r
.36267 .54885 m
.36391 .55914 L
s
.32 .464 .852 r
.36555 .5342 m .36424 .52289 L .37341 .50265 L p F P
0 0 0 r
s
.24 .35 .67 r
.36267 .54885 m
.37308 .52624 L
s
.203 .306 .632 r
.58372 .43652 m .58321 .44404 L .60004 .46284 L p F P
0 0 0 r
s
.203 .306 .632 r
.60004 .46284 m .60077 .45393 L .58372 .43652 L p F P
0 0 0 r
s
.173 .262 .553 r
.60077 .45393 m .60004 .46284 L .6146 .4825 L p F P
0 0 0 r
s
.332 .486 .914 r
.39923 .45393 m .39996 .46284 L .3854 .4825 L p F P
0 0 0 r
s
.33 .484 .918 r
.39996 .46284 m .39923 .45393 L .41628 .43652 L p F P
0 0 0 r
s
.33 .484 .918 r
.41628 .43652 m .41679 .44404 L .39996 .46284 L p F P
0 0 0 r
s
.228 .342 .695 r
.56473 .42056 m .56443 .42645 L .58321 .44404 L p F P
0 0 0 r
s
.228 .342 .695 r
.58321 .44404 m .58372 .43652 L .56473 .42056 L p F P
0 0 0 r
s
.83 .24 .1 r
.57979 .43322 m
.58017 .41926 L
s
.324 .477 .912 r
.41679 .44404 m .41628 .43652 L .43527 .42056 L p F P
0 0 0 r
s
.83 .24 .1 r
.42038 .43947 m
.42041 .44064 L
s
.324 .477 .912 r
.43527 .42056 m .43557 .42645 L .41679 .44404 L p F P
0 0 0 r
s
.83 .24 .1 r
.41983 .41926 m
.42021 .43322 L
s
.266 .397 .789 r
.52239 .39843 m .52235 .40051 L .54376 .41851 L p F P
0 0 0 r
s
.266 .397 .789 r
.54376 .41851 m .5439 .41449 L .52239 .39843 L p F P
0 0 0 r
s
.977 .284 .121 r
.45624 .41851 m .46249 .41851 L .48084 .40051 L p F P
0 0 0 r
s
.977 .284 .121 r
.48084 .40051 m .47765 .40051 L .45624 .41851 L p F P
0 0 0 r
s
.977 .284 .121 r
.46249 .41851 m .46874 .41851 L .48403 .40051 L p F P
0 0 0 r
s
.977 .284 .121 r
.48403 .40051 m .48084 .40051 L .46249 .41851 L p F P
0 0 0 r
s
.977 .284 .121 r
.46874 .41851 m .47499 .41851 L .48723 .40051 L p F P
0 0 0 r
s
.977 .284 .121 r
.48723 .40051 m .48403 .40051 L .46874 .41851 L p F P
0 0 0 r
s
.977 .284 .121 r
.47499 .41851 m .48124 .41851 L .49042 .40051 L p F P
0 0 0 r
s
.977 .284 .121 r
.49042 .40051 m .48723 .40051 L .47499 .41851 L p F P
0 0 0 r
s
.977 .284 .121 r
.48124 .41851 m .4875 .41851 L .49361 .40051 L p F P
0 0 0 r
s
.977 .284 .121 r
.49361 .40051 m .49042 .40051 L .48124 .41851 L p F P
0 0 0 r
s
.977 .284 .121 r
.4875 .41851 m .49375 .41851 L .49681 .40051 L p F P
0 0 0 r
s
.977 .284 .121 r
.49681 .40051 m .49361 .40051 L .4875 .41851 L p F P
0 0 0 r
s
.977 .284 .121 r
.49375 .41851 m .5 .41851 L .5 .40051 L p F P
0 0 0 r
s
.977 .284 .121 r
.5 .40051 m .49681 .40051 L .49375 .41851 L p F P
0 0 0 r
s
.977 .284 .121 r
.5 .41851 m .50625 .41851 L .50319 .40051 L p F P
0 0 0 r
s
.977 .284 .121 r
.50319 .40051 m .5 .40051 L .5 .41851 L p F P
0 0 0 r
s
.977 .284 .121 r
.50625 .41851 m .5125 .41851 L .50639 .40051 L p F P
0 0 0 r
s
.977 .284 .121 r
.50639 .40051 m .50319 .40051 L .50625 .41851 L p F P
0 0 0 r
s
.977 .284 .121 r
.5125 .41851 m .51876 .41851 L .50958 .40051 L p F P
0 0 0 r
s
.977 .284 .121 r
.50958 .40051 m .50639 .40051 L .5125 .41851 L p F P
0 0 0 r
s
.977 .284 .121 r
.51876 .41851 m .52501 .41851 L .51277 .40051 L p F P
0 0 0 r
s
.977 .284 .121 r
.51277 .40051 m .50958 .40051 L .51876 .41851 L p F P
0 0 0 r
s
.977 .284 .121 r
.52501 .41851 m .53126 .41851 L .51597 .40051 L p F P
0 0 0 r
s
.977 .284 .121 r
.51597 .40051 m .51277 .40051 L .52501 .41851 L p F P
0 0 0 r
s
.977 .284 .121 r
.53126 .41851 m .53751 .41851 L .51916 .40051 L p F P
0 0 0 r
s
.977 .284 .121 r
.51916 .40051 m .51597 .40051 L .53126 .41851 L p F P
0 0 0 r
s
.977 .284 .121 r
.53751 .41851 m .54376 .41851 L .52235 .40051 L p F P
0 0 0 r
s
.24 .35 .67 r
.54328 .42163 m
.54343 .41717 L
s
.977 .284 .121 r
.52235 .40051 m .51916 .40051 L .53751 .41851 L p F P
0 0 0 r
s
.306 .453 .879 r
.45624 .41851 m .4561 .41449 L .47761 .39843 L p F P
0 0 0 r
s
.306 .453 .879 r
.47761 .39843 m .47765 .40051 L .45624 .41851 L p F P
0 0 0 r
s
.24 .35 .67 r
.45657 .41717 m
.45672 .42163 L
s
.45657 .41717 m
.46715 .41544 L
s
.53285 .41544 m
.54343 .41717 L
s
.173 .262 .553 r
.6146 .4825 m .61555 .47245 L .60077 .45393 L p F P
0 0 0 r
s
.24 .35 .67 r
.61162 .50307 m
.61359 .48212 L
s
.59318 .46496 m
.61359 .48212 L
s
.135 .206 .453 r
.61555 .47245 m .6146 .4825 L .62659 .50265 L p F P
0 0 0 r
s
.33 .481 .895 r
.38445 .47245 m .3854 .4825 L .37341 .50265 L p F P
0 0 0 r
s
.332 .486 .914 r
.3854 .4825 m .38445 .47245 L .39923 .45393 L p F P
0 0 0 r
s
.24 .35 .67 r
.38641 .48212 m
.38838 .50307 L
s
.38641 .48212 m
.40682 .46496 L
s
.83 .24 .1 r
.25948 .41926 m
.21939 .41926 L
s
.29957 .41926 m
.25948 .41926 L
s
.33965 .41926 m
.29957 .41926 L
s
.37974 .41926 m
.33965 .41926 L
s
.41983 .41926 m
.37974 .41926 L
s
.45295 .41926 m
.45991 .41926 L
s
.41983 .41926 m
.44472 .41926 L
s
.5 .41926 m
.45991 .41926 L
s
.54009 .41926 m
.5 .41926 L
s
.54009 .41926 m
.54705 .41926 L
s
.55528 .41926 m
.58017 .41926 L
s
.62026 .41926 m
.58017 .41926 L
s
.66035 .41926 m
.62026 .41926 L
s
.70043 .41926 m
.66035 .41926 L
s
.74052 .41926 m
.70043 .41926 L
s
.78061 .41926 m
.74052 .41926 L
s
.25948 .41926 m
.25652 .39591 L
s
.21594 .39591 m
.21939 .41926 L
s
.29957 .41926 m
.2971 .39591 L
s
.33965 .41926 m
.33768 .39591 L
s
.37974 .41926 m
.37826 .39591 L
s
.62026 .41926 m
.62174 .39591 L
s
.66035 .41926 m
.66232 .39591 L
s
.70043 .41926 m
.7029 .39591 L
s
.74052 .41926 m
.74348 .39591 L
s
.78061 .41926 m
.78406 .39591 L
s
.713 .193 .082 r
.35859 .60276 m .37879 .60276 L .37842 .58511 L p F P
0 0 0 r
s
.24 .35 .67 r
.36088 .5954 m
.3612 .60044 L
s
.713 .193 .082 r
.37842 .58511 m .35816 .58511 L .35859 .60276 L p F P
0 0 0 r
s
.24 .35 .67 r
.36135 .60276 m
.36242 .61984 L
s
.713 .193 .082 r
.37879 .60276 m .399 .60276 L .39868 .58511 L p F P
0 0 0 r
s
.713 .193 .082 r
.39868 .58511 m .37842 .58511 L .37879 .60276 L p F P
0 0 0 r
s
.713 .193 .082 r
.399 .60276 m .4192 .60276 L .41895 .58511 L p F P
0 0 0 r
s
.713 .193 .082 r
.41895 .58511 m .39868 .58511 L .399 .60276 L p F P
0 0 0 r
s
.713 .193 .082 r
.4192 .60276 m .4394 .60276 L .43921 .58511 L p F P
0 0 0 r
s
.713 .193 .082 r
.43921 .58511 m .41895 .58511 L .4192 .60276 L p F P
0 0 0 r
s
.713 .193 .082 r
.4394 .60276 m .4596 .60276 L .45947 .58511 L p F P
0 0 0 r
s
.713 .193 .082 r
.45947 .58511 m .43921 .58511 L .4394 .60276 L p F P
0 0 0 r
s
.713 .193 .082 r
.4596 .60276 m .4798 .60276 L .47974 .58511 L p F P
0 0 0 r
s
.713 .193 .082 r
.47974 .58511 m .45947 .58511 L .4596 .60276 L p F P
0 0 0 r
s
.713 .193 .082 r
.4798 .60276 m .5 .60276 L .5 .58511 L p F P
0 0 0 r
s
.713 .193 .082 r
.5 .58511 m .47974 .58511 L .4798 .60276 L p F P
0 0 0 r
s
.713 .193 .082 r
.5 .60276 m .5202 .60276 L .52026 .58511 L p F P
0 0 0 r
s
.713 .193 .082 r
.52026 .58511 m .5 .58511 L .5 .60276 L p F P
0 0 0 r
s
.713 .193 .082 r
.5202 .60276 m .5404 .60276 L .54053 .58511 L p F P
0 0 0 r
s
.713 .193 .082 r
.54053 .58511 m .52026 .58511 L .5202 .60276 L p F P
0 0 0 r
s
.713 .193 .082 r
.5404 .60276 m .5606 .60276 L .56079 .58511 L p F P
0 0 0 r
s
.713 .193 .082 r
.56079 .58511 m .54053 .58511 L .5404 .60276 L p F P
0 0 0 r
s
.713 .193 .082 r
.5606 .60276 m .5808 .60276 L .58105 .58511 L p F P
0 0 0 r
s
.713 .193 .082 r
.58105 .58511 m .56079 .58511 L .5606 .60276 L p F P
0 0 0 r
s
.713 .193 .082 r
.5808 .60276 m .601 .60276 L .60132 .58511 L p F P
0 0 0 r
s
.713 .193 .082 r
.60132 .58511 m .58105 .58511 L .5808 .60276 L p F P
0 0 0 r
s
.713 .193 .082 r
.601 .60276 m .62121 .60276 L .62158 .58511 L p F P
0 0 0 r
s
.713 .193 .082 r
.62158 .58511 m .60132 .58511 L .601 .60276 L p F P
0 0 0 r
s
.713 .193 .082 r
.62121 .60276 m .64141 .60276 L .64184 .58511 L p F P
0 0 0 r
s
.713 .193 .082 r
.64184 .58511 m .62158 .58511 L .62121 .60276 L p F P
0 0 0 r
s
.24 .35 .67 r
.63758 .61984 m
.63865 .60276 L
s
.26 .371 .651 r
.35816 .58511 m .35669 .5737 L .35954 .55444 L p F P
0 0 0 r
s
.052 .076 .18 r
.64184 .58511 m .64331 .5737 L .64046 .55444 L p F P
0 0 0 r
s
.028 .041 .084 r
.64331 .5737 m .64184 .58511 L .64141 .60276 L p F P
0 0 0 r
s
.203 .284 .476 r
.35669 .5737 m .35816 .58511 L .35859 .60276 L p F P
0 0 0 r
s
.249 .372 .747 r
.54418 .40637 m .54404 .41044 L .56443 .42645 L p F P
0 0 0 r
s
.249 .372 .747 r
.56443 .42645 m .56473 .42056 L .54418 .40637 L p F P
0 0 0 r
s
.316 .466 .898 r
.43557 .42645 m .43527 .42056 L .45582 .40637 L p F P
0 0 0 r
s
.316 .466 .898 r
.45582 .40637 m .45596 .41044 L .43557 .42645 L p F P
0 0 0 r
s
.24 .35 .67 r
.54432 .73204 m
.54342 .75144 L
s
.54342 .75144 m
.51472 .75692 L
s
.48528 .75692 m
.45658 .75144 L
s
.45568 .73204 m
.45658 .75144 L
s
.83 .24 .1 r
.21895 .58431 m
.2591 .58431 L
s
.2591 .58431 m
.29925 .58431 L
s
.29925 .58431 m
.3394 .58431 L
s
.35806 .58431 m
.37955 .58431 L
s
.3394 .58431 m
.35739 .58431 L
s
.37955 .58431 m
.4197 .58431 L
s
.4197 .58431 m
.45985 .58431 L
s
.45985 .58431 m
.5 .58431 L
s
.5 .58431 m
.54015 .58431 L
s
.54015 .58431 m
.5803 .58431 L
s
.5803 .58431 m
.62045 .58431 L
s
.62045 .58431 m
.64194 .58431 L
s
.64261 .58431 m
.6606 .58431 L
s
.6606 .58431 m
.70075 .58431 L
s
.70075 .58431 m
.7409 .58431 L
s
.7409 .58431 m
.78105 .58431 L
s
.25603 .6072 m
.2591 .58431 L
s
.21895 .58431 m
.21537 .6072 L
s
.29669 .6072 m
.29925 .58431 L
s
.33735 .6072 m
.3394 .58431 L
s
.66265 .6072 m
.6606 .58431 L
s
.70331 .6072 m
.70075 .58431 L
s
.74397 .6072 m
.7409 .58431 L
s
.78463 .6072 m
.78105 .58431 L
s
.266 .397 .789 r
.52243 .39634 m .52239 .39843 L .5439 .41449 L p F P
0 0 0 r
s
.266 .397 .789 r
.5439 .41449 m .54404 .41044 L .52243 .39634 L p F P
0 0 0 r
s
.83 .24 .1 r
.54009 .41926 m
.54027 .41076 L
s
.306 .453 .879 r
.4561 .41449 m .45596 .41044 L .47757 .39634 L p F P
0 0 0 r
s
.306 .453 .879 r
.47757 .39634 m .47761 .39843 L .4561 .41449 L p F P
0 0 0 r
s
.83 .24 .1 r
.45973 .41076 m
.45991 .41926 L
s
.24 .35 .67 r
.61614 .66594 m
.61379 .68669 L
s
.61379 .68669 m
.59489 .70587 L
s
.40511 .70587 m
.38621 .68669 L
s
.38386 .66594 m
.38621 .68669 L
s
.37013 .64374 m
.36242 .61984 L
s
.63758 .61984 m
.62987 .64374 L
s
.135 .206 .453 r
.62659 .50265 m .62776 .49173 L .61555 .47245 L p F P
0 0 0 r
s
.096 .145 .343 r
.62776 .49173 m .62659 .50265 L .63576 .52289 L p F P
0 0 0 r
s
.32 .464 .852 r
.37224 .49173 m .37341 .50265 L .36424 .52289 L p F P
0 0 0 r
s
.33 .481 .895 r
.37341 .50265 m .37224 .49173 L .38445 .47245 L p F P
0 0 0 r
s
.072 .105 .259 r
.64046 .55444 m .64189 .54283 L .63576 .52289 L p F P
0 0 0 r
s
.052 .076 .18 r
.64189 .54283 m .64046 .55444 L .64331 .5737 L p F P
0 0 0 r
s
.26 .371 .651 r
.35811 .54283 m .35954 .55444 L .35669 .5737 L p F P
0 0 0 r
s
.298 .43 .775 r
.35954 .55444 m .35811 .54283 L .36424 .52289 L p F P
0 0 0 r
s
.24 .35 .67 r
.51503 .73759 m
.51472 .75692 L
s
.51472 .75692 m
.48528 .75692 L
s
.48497 .73759 m
.48528 .75692 L
s
.228 .342 .695 r
.56503 .41462 m .56473 .42056 L .58372 .43652 L p F P
0 0 0 r
s
.228 .342 .695 r
.58372 .43652 m .58422 .42892 L .56503 .41462 L p F P
0 0 0 r
s
.24 .35 .67 r
.56946 .4466 m
.57059 .42639 L
s
.203 .306 .632 r
.58422 .42892 m .58372 .43652 L .60077 .45393 L p F P
0 0 0 r
s
.33 .484 .918 r
.41578 .42892 m .41628 .43652 L .39923 .45393 L p F P
0 0 0 r
s
.324 .477 .912 r
.41628 .43652 m .41578 .42892 L .43497 .41462 L p F P
0 0 0 r
s
.324 .477 .912 r
.43497 .41462 m .43527 .42056 L .41628 .43652 L p F P
0 0 0 r
s
.24 .35 .67 r
.42941 .42639 m
.43054 .4466 L
s
.203 .306 .632 r
.60077 .45393 m .60151 .4449 L .58422 .42892 L p F P
0 0 0 r
s
.173 .262 .553 r
.60151 .4449 m .60077 .45393 L .61555 .47245 L p F P
0 0 0 r
s
.332 .486 .914 r
.39849 .4449 m .39923 .45393 L .38445 .47245 L p F P
0 0 0 r
s
.33 .484 .918 r
.39923 .45393 m .39849 .4449 L .41578 .42892 L p F P
0 0 0 r
s
.306 .453 .879 r
.45596 .41044 m .45582 .40637 L .47754 .39425 L p F P
0 0 0 r
s
.306 .453 .879 r
.47754 .39425 m .47757 .39634 L .45596 .41044 L p F P
0 0 0 r
s
.266 .397 .789 r
.52246 .39425 m .52243 .39634 L .54404 .41044 L p F P
0 0 0 r
s
.266 .397 .789 r
.54404 .41044 m .54418 .40637 L .52246 .39425 L p F P
0 0 0 r
s
.249 .372 .747 r
.54432 .40227 m .54418 .40637 L .56473 .42056 L p F P
0 0 0 r
s
.249 .372 .747 r
.56473 .42056 m .56503 .41462 L .54432 .40227 L p F P
0 0 0 r
s
.24 .35 .67 r
.54343 .41717 m
.57059 .42639 L
s
.316 .466 .898 r
.43527 .42056 m .43497 .41462 L .45568 .40227 L p F P
0 0 0 r
s
.316 .466 .898 r
.45568 .40227 m .45582 .40637 L .43527 .42056 L p F P
0 0 0 r
s
.24 .35 .67 r
.42941 .42639 m
.45657 .41717 L
s
.096 .145 .343 r
.63576 .52289 m .6371 .51137 L .62776 .49173 L p F P
0 0 0 r
s
.24 .35 .67 r
.62692 .52624 m
.62951 .50248 L
s
.072 .105 .259 r
.6371 .51137 m .63576 .52289 L .64189 .54283 L p F P
0 0 0 r
s
.298 .43 .775 r
.3629 .51137 m .36424 .52289 L .35811 .54283 L p F P
0 0 0 r
s
.32 .464 .852 r
.36424 .52289 m .3629 .51137 L .37224 .49173 L p F P
0 0 0 r
s
.24 .35 .67 r
.37049 .50248 m
.37308 .52624 L
s
.173 .262 .553 r
.61555 .47245 m .61652 .46224 L .60151 .4449 L p F P
0 0 0 r
s
.135 .206 .453 r
.61652 .46224 m .61555 .47245 L .62776 .49173 L p F P
0 0 0 r
s
.24 .35 .67 r
.61359 .48212 m
.62951 .50248 L
s
.33 .481 .895 r
.38348 .46224 m .38445 .47245 L .37224 .49173 L p F P
0 0 0 r
s
.24 .35 .67 r
.37049 .50248 m
.38641 .48212 L
s
.332 .486 .914 r
.38445 .47245 m .38348 .46224 L .39849 .4449 L p F P
0 0 0 r
s
.281 .419 .825 r
.52235 .40051 m .52239 .39843 L .5 .38446 L closepath p F P
0 0 0 r
s
.992 .291 .124 r
.5 .38446 m .47765 .40051 L .48084 .40051 L closepath p F P
0 0 0 r
s
.992 .291 .124 r
.5 .38446 m .48084 .40051 L .48403 .40051 L closepath p F P
0 0 0 r
s
.992 .291 .124 r
.5 .38446 m .48403 .40051 L .48723 .40051 L closepath p F P
0 0 0 r
s
.992 .291 .124 r
.5 .38446 m .48723 .40051 L .49042 .40051 L closepath p F P
0 0 0 r
s
.992 .291 .124 r
.5 .38446 m .49042 .40051 L .49361 .40051 L closepath p F P
0 0 0 r
s
.992 .291 .124 r
.5 .38446 m .49361 .40051 L .49681 .40051 L closepath p F P
0 0 0 r
s
.992 .291 .124 r
.5 .38446 m .49681 .40051 L .5 .40051 L closepath p F P
0 0 0 r
s
.992 .291 .124 r
.5 .38446 m .5 .40051 L .50319 .40051 L closepath p F P
0 0 0 r
s
.992 .291 .124 r
.5 .38446 m .50319 .40051 L .50639 .40051 L closepath p F P
0 0 0 r
s
.992 .291 .124 r
.5 .38446 m .50639 .40051 L .50958 .40051 L closepath p F P
0 0 0 r
s
.992 .291 .124 r
.5 .38446 m .50958 .40051 L .51277 .40051 L closepath p F P
0 0 0 r
s
.992 .291 .124 r
.5 .38446 m .51277 .40051 L .51597 .40051 L closepath p F P
0 0 0 r
s
.992 .291 .124 r
.5 .38446 m .51597 .40051 L .51916 .40051 L closepath p F P
0 0 0 r
s
.992 .291 .124 r
.5 .38446 m .51916 .40051 L .52235 .40051 L closepath p F P
0 0 0 r
s
.295 .437 .854 r
.5 .38446 m .47765 .40051 L .47761 .39843 L closepath p F P
0 0 0 r
s
.266 .397 .789 r
.5225 .39215 m .52246 .39425 L .54418 .40637 L p F P
0 0 0 r
s
.266 .397 .789 r
.54418 .40637 m .54432 .40227 L .5225 .39215 L p F P
0 0 0 r
s
.306 .453 .879 r
.45582 .40637 m .45568 .40227 L .4775 .39215 L p F P
0 0 0 r
s
.83 .24 .1 r
.45959 .4039 m
.4596 .40426 L
s
.306 .453 .879 r
.4775 .39215 m .47754 .39425 L .45582 .40637 L p F P
0 0 0 r
s
.281 .419 .825 r
.52239 .39843 m .52243 .39634 L .5 .38446 L closepath p F P
0 0 0 r
s
.295 .437 .854 r
.5 .38446 m .47761 .39843 L .47757 .39634 L closepath p F P
0 0 0 r
s
.647 .172 .073 r
.36234 .61838 m .382 .61838 L .37879 .60276 L p F P
0 0 0 r
s
.647 .172 .073 r
.37879 .60276 m .35859 .60276 L .36234 .61838 L p F P
0 0 0 r
s
.24 .35 .67 r
.36211 .61742 m
.36242 .61984 L
s
.647 .172 .073 r
.382 .61838 m .40167 .61838 L .399 .60276 L p F P
0 0 0 r
s
.647 .172 .073 r
.399 .60276 m .37879 .60276 L .382 .61838 L p F P
0 0 0 r
s
.83 .24 .1 r
.37801 .6072 m
.37955 .58431 L
s
.647 .172 .073 r
.40167 .61838 m .42134 .61838 L .4192 .60276 L p F P
0 0 0 r
s
.647 .172 .073 r
.4192 .60276 m .399 .60276 L .40167 .61838 L p F P
0 0 0 r
s
.647 .172 .073 r
.42134 .61838 m .441 .61838 L .4394 .60276 L p F P
0 0 0 r
s
.647 .172 .073 r
.4394 .60276 m .4192 .60276 L .42134 .61838 L p F P
0 0 0 r
s
.83 .24 .1 r
.41868 .6072 m
.4197 .58431 L
s
.647 .172 .073 r
.441 .61838 m .46067 .61838 L .4596 .60276 L p F P
0 0 0 r
s
.647 .172 .073 r
.4596 .60276 m .4394 .60276 L .441 .61838 L p F P
0 0 0 r
s
.647 .172 .073 r
.46067 .61838 m .48033 .61838 L .4798 .60276 L p F P
0 0 0 r
s
.647 .172 .073 r
.4798 .60276 m .4596 .60276 L .46067 .61838 L p F P
0 0 0 r
s
.83 .24 .1 r
.45934 .6072 m
.45985 .58431 L
s
.647 .172 .073 r
.48033 .61838 m .5 .61838 L .5 .60276 L p F P
0 0 0 r
s
.647 .172 .073 r
.5 .60276 m .4798 .60276 L .48033 .61838 L p F P
0 0 0 r
s
.647 .172 .073 r
.5 .61838 m .51967 .61838 L .5202 .60276 L p F P
0 0 0 r
s
.647 .172 .073 r
.5202 .60276 m .5 .60276 L .5 .61838 L p F P
0 0 0 r
s
.83 .24 .1 r
.5 .58431 m
.5 .6072 L
s
.647 .172 .073 r
.51967 .61838 m .53933 .61838 L .5404 .60276 L p F P
0 0 0 r
s
.647 .172 .073 r
.5404 .60276 m .5202 .60276 L .51967 .61838 L p F P
0 0 0 r
s
.647 .172 .073 r
.53933 .61838 m .559 .61838 L .5606 .60276 L p F P
0 0 0 r
s
.647 .172 .073 r
.5606 .60276 m .5404 .60276 L .53933 .61838 L p F P
0 0 0 r
s
.83 .24 .1 r
.54015 .58431 m
.54066 .6072 L
s
.647 .172 .073 r
.559 .61838 m .57866 .61838 L .5808 .60276 L p F P
0 0 0 r
s
.647 .172 .073 r
.5808 .60276 m .5606 .60276 L .559 .61838 L p F P
0 0 0 r
s
.647 .172 .073 r
.57866 .61838 m .59833 .61838 L .601 .60276 L p F P
0 0 0 r
s
.647 .172 .073 r
.601 .60276 m .5808 .60276 L .57866 .61838 L p F P
0 0 0 r
s
.83 .24 .1 r
.5803 .58431 m
.58132 .6072 L
s
.647 .172 .073 r
.59833 .61838 m .618 .61838 L .62121 .60276 L p F P
0 0 0 r
s
.647 .172 .073 r
.62121 .60276 m .601 .60276 L .59833 .61838 L p F P
0 0 0 r
s
.647 .172 .073 r
.618 .61838 m .63766 .61838 L .64141 .60276 L p F P
0 0 0 r
s
.24 .35 .67 r
.63758 .61984 m
.63789 .61742 L
s
.647 .172 .073 r
.64141 .60276 m .62121 .60276 L .618 .61838 L p F P
0 0 0 r
s
.83 .24 .1 r
.62045 .58431 m
.62199 .6072 L
s
.028 .041 .084 r
.64141 .60276 m .64286 .59157 L .64331 .5737 L p F P
0 0 0 r
s
.23 .333 .575 r
.64286 .59157 m .64141 .60276 L .63766 .61838 L p F P
0 0 0 r
s
.203 .284 .476 r
.35859 .60276 m .35714 .59157 L .35669 .5737 L p F P
0 0 0 r
s
.045 .066 .152 r
.35714 .59157 m .35859 .60276 L .36234 .61838 L p F P
0 0 0 r
s
.249 .372 .747 r
.54446 .39815 m .54432 .40227 L .56503 .41462 L p F P
0 0 0 r
s
.249 .372 .747 r
.56503 .41462 m .56534 .40861 L .54446 .39815 L p F P
0 0 0 r
s
.228 .342 .695 r
.56534 .40861 m .56503 .41462 L .58422 .42892 L p F P
0 0 0 r
s
.324 .477 .912 r
.43466 .40861 m .43497 .41462 L .41578 .42892 L p F P
0 0 0 r
s
.316 .466 .898 r
.43497 .41462 m .43466 .40861 L .45554 .39815 L p F P
0 0 0 r
s
.316 .466 .898 r
.45554 .39815 m .45568 .40227 L .43497 .41462 L p F P
0 0 0 r
s
.24 .35 .67 r
.42862 .72127 m
.40511 .70587 L
s
.40313 .68534 m
.40511 .70587 L
s
.59687 .68534 m
.59489 .70587 L
s
.59489 .70587 m
.57138 .72127 L
s
.33 .484 .918 r
.41526 .42122 m .41578 .42892 L .39849 .4449 L p F P
0 0 0 r
s
.24 .35 .67 r
.40491 .43988 m
.40682 .46496 L
s
.324 .477 .912 r
.41578 .42892 m .41526 .42122 L .43466 .40861 L p F P
0 0 0 r
s
.24 .35 .67 r
.40491 .43988 m
.42941 .42639 L
s
.83 .24 .1 r
.41884 .39591 m
.41979 .41828 L
s
.228 .342 .695 r
.58422 .42892 m .58474 .42122 L .56534 .40861 L p F P
0 0 0 r
s
.83 .24 .1 r
.58021 .41828 m
.58116 .39591 L
s
.203 .306 .632 r
.58474 .42122 m .58422 .42892 L .60151 .4449 L p F P
0 0 0 r
s
.24 .35 .67 r
.57059 .42639 m
.59509 .43988 L
s
.59318 .46496 m
.59509 .43988 L
s
.052 .076 .18 r
.64331 .5737 m .6448 .56206 L .64189 .54283 L p F P
0 0 0 r
s
.24 .35 .67 r
.64042 .58511 m
.64196 .57301 L
s
.63733 .54885 m
.64196 .57301 L
s
.028 .041 .084 r
.6448 .56206 m .64331 .5737 L .64286 .59157 L p F P
0 0 0 r
s
.26 .371 .651 r
.35669 .5737 m .3552 .56206 L .35811 .54283 L p F P
0 0 0 r
s
.24 .35 .67 r
.35804 .57301 m
.35958 .58511 L
s
.35804 .57301 m
.36267 .54885 L
s
.203 .284 .476 r
.3552 .56206 m .35669 .5737 L .35714 .59157 L p F P
0 0 0 r
s
.281 .419 .825 r
.52243 .39634 m .52246 .39425 L .5 .38446 L closepath p F P
0 0 0 r
s
.295 .437 .854 r
.5 .38446 m .47757 .39634 L .47754 .39425 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.5 .39591 m
.5 .41926 L
s
.135 .206 .453 r
.62776 .49173 m .62894 .4806 L .61652 .46224 L p F P
0 0 0 r
s
.096 .145 .343 r
.62894 .4806 m .62776 .49173 L .6371 .51137 L p F P
0 0 0 r
s
.32 .464 .852 r
.37106 .4806 m .37224 .49173 L .3629 .51137 L p F P
0 0 0 r
s
.33 .481 .895 r
.37224 .49173 m .37106 .4806 L .38348 .46224 L p F P
0 0 0 r
s
.266 .397 .789 r
.52253 .39004 m .5225 .39215 L .54432 .40227 L p F P
0 0 0 r
s
.266 .397 .789 r
.54432 .40227 m .54446 .39815 L .52253 .39004 L p F P
0 0 0 r
s
.83 .24 .1 r
.54056 .39671 m
.54058 .39591 L
s
.306 .453 .879 r
.45568 .40227 m .45554 .39815 L .47747 .39004 L p F P
0 0 0 r
s
.83 .24 .1 r
.45951 .40012 m
.45952 .40049 L
s
.306 .453 .879 r
.47747 .39004 m .4775 .39215 L .45568 .40227 L p F P
0 0 0 r
s
.83 .24 .1 r
.45942 .39591 m
.45944 .39671 L
s
.25652 .39591 m
.21594 .39591 L
s
.2971 .39591 m
.25652 .39591 L
s
.33768 .39591 m
.2971 .39591 L
s
.37826 .39591 m
.33768 .39591 L
s
.41884 .39591 m
.37826 .39591 L
s
.41884 .39591 m
.45942 .39591 L
s
.4757 .39591 m
.5 .39591 L
s
.45942 .39591 m
.4616 .39591 L
s
.5 .39591 m
.5243 .39591 L
s
.5384 .39591 m
.54058 .39591 L
s
.54058 .39591 m
.58116 .39591 L
s
.62174 .39591 m
.58116 .39591 L
s
.66232 .39591 m
.62174 .39591 L
s
.7029 .39591 m
.66232 .39591 L
s
.74348 .39591 m
.7029 .39591 L
s
.78406 .39591 m
.74348 .39591 L
s
.25652 .39591 m
.25282 .37624 L
s
.21163 .37624 m
.21594 .39591 L
s
.2971 .39591 m
.29402 .37624 L
s
.33768 .39591 m
.33522 .37624 L
s
.37826 .39591 m
.37641 .37624 L
s
.62174 .39591 m
.62359 .37624 L
s
.66232 .39591 m
.66478 .37624 L
s
.7029 .39591 m
.70598 .37624 L
s
.74348 .39591 m
.74718 .37624 L
s
.78406 .39591 m
.78837 .37624 L
s
.203 .306 .632 r
.60151 .4449 m .60225 .43573 L .58474 .42122 L p F P
0 0 0 r
s
.173 .262 .553 r
.60225 .43573 m .60151 .4449 L .61652 .46224 L p F P
0 0 0 r
s
.332 .486 .914 r
.39775 .43573 m .39849 .4449 L .38348 .46224 L p F P
0 0 0 r
s
.33 .484 .918 r
.39849 .4449 m .39775 .43573 L .41526 .42122 L p F P
0 0 0 r
s
.281 .419 .825 r
.52246 .39425 m .5225 .39215 L .5 .38446 L closepath p F P
0 0 0 r
s
.295 .437 .854 r
.5 .38446 m .47754 .39425 L .4775 .39215 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.38386 .66594 m
.37013 .64374 L
s
.62987 .64374 m
.61614 .66594 L
s
.072 .105 .259 r
.64189 .54283 m .64336 .53099 L .6371 .51137 L p F P
0 0 0 r
s
.052 .076 .18 r
.64336 .53099 m .64189 .54283 L .6448 .56206 L p F P
0 0 0 r
s
.26 .371 .651 r
.35664 .53099 m .35811 .54283 L .3552 .56206 L p F P
0 0 0 r
s
.298 .43 .775 r
.35811 .54283 m .35664 .53099 L .3629 .51137 L p F P
0 0 0 r
s
.83 .24 .1 r
.25223 .62625 m
.25603 .6072 L
s
.21537 .6072 m
.21094 .62625 L
s
.25603 .6072 m
.21537 .6072 L
s
.29353 .62625 m
.29669 .6072 L
s
.29669 .6072 m
.25603 .6072 L
s
.33482 .62625 m
.33735 .6072 L
s
.33735 .6072 m
.29669 .6072 L
s
.33735 .6072 m
.35972 .6072 L
s
.36017 .6072 m
.37801 .6072 L
s
.37801 .6072 m
.41868 .6072 L
s
.41868 .6072 m
.45934 .6072 L
s
.45934 .6072 m
.5 .6072 L
s
.5 .6072 m
.54066 .6072 L
s
.54066 .6072 m
.58132 .6072 L
s
.58132 .6072 m
.62199 .6072 L
s
.66518 .62625 m
.66265 .6072 L
s
.64028 .6072 m
.66265 .6072 L
s
.62199 .6072 m
.63983 .6072 L
s
.70647 .62625 m
.70331 .6072 L
s
.70331 .6072 m
.66265 .6072 L
s
.74777 .62625 m
.74397 .6072 L
s
.74397 .6072 m
.70331 .6072 L
s
.78906 .62625 m
.78463 .6072 L
s
.78463 .6072 m
.74397 .6072 L
s
.295 .437 .854 r
.5 .38446 m .4775 .39215 L .47747 .39004 L closepath p F P
0 0 0 r
s
.281 .419 .825 r
.5225 .39215 m .52253 .39004 L .5 .38446 L closepath p F P
0 0 0 r
s
.266 .397 .789 r
.52257 .38793 m .52253 .39004 L .54446 .39815 L p F P
0 0 0 r
s
.266 .397 .789 r
.54446 .39815 m .54461 .394 L .52257 .38793 L p F P
0 0 0 r
s
.249 .372 .747 r
.54461 .394 m .54446 .39815 L .56534 .40861 L p F P
0 0 0 r
s
.316 .466 .898 r
.45539 .394 m .45554 .39815 L .43466 .40861 L p F P
0 0 0 r
s
.306 .453 .879 r
.45554 .39815 m .45539 .394 L .47743 .38793 L p F P
0 0 0 r
s
.306 .453 .879 r
.47743 .38793 m .47747 .39004 L .45554 .39815 L p F P
0 0 0 r
s
.249 .372 .747 r
.56534 .40861 m .56565 .40255 L .54461 .394 L p F P
0 0 0 r
s
.228 .342 .695 r
.56565 .40255 m .56534 .40861 L .58474 .42122 L p F P
0 0 0 r
s
.324 .477 .912 r
.43435 .40255 m .43466 .40861 L .41526 .42122 L p F P
0 0 0 r
s
.316 .466 .898 r
.43466 .40861 m .43435 .40255 L .45539 .394 L p F P
0 0 0 r
s
.173 .262 .553 r
.61652 .46224 m .61751 .45184 L .60225 .43573 L p F P
0 0 0 r
s
.24 .35 .67 r
.61359 .48212 m
.61593 .45718 L
s
.135 .206 .453 r
.61751 .45184 m .61652 .46224 L .62894 .4806 L p F P
0 0 0 r
s
.33 .481 .895 r
.38249 .45184 m .38348 .46224 L .37106 .4806 L p F P
0 0 0 r
s
.332 .486 .914 r
.38348 .46224 m .38249 .45184 L .39775 .43573 L p F P
0 0 0 r
s
.24 .35 .67 r
.38407 .45718 m
.38641 .48212 L
s
.281 .419 .825 r
.52253 .39004 m .52257 .38793 L .5 .38446 L closepath p F P
0 0 0 r
s
.295 .437 .854 r
.5 .38446 m .47747 .39004 L .47743 .38793 L closepath p F P
0 0 0 r
s
.298 .43 .775 r
.36153 .49961 m .3629 .51137 L .35664 .53099 L p F P
0 0 0 r
s
.24 .35 .67 r
.35984 .52529 m
.36267 .54885 L
s
.32 .464 .852 r
.3629 .51137 m .36153 .49961 L .37106 .4806 L p F P
0 0 0 r
s
.24 .35 .67 r
.35984 .52529 m
.37049 .50248 L
s
.096 .145 .343 r
.6371 .51137 m .63847 .49961 L .62894 .4806 L p F P
0 0 0 r
s
.072 .105 .259 r
.63847 .49961 m .6371 .51137 L .64336 .53099 L p F P
0 0 0 r
s
.24 .35 .67 r
.62951 .50248 m
.64016 .52529 L
s
.63733 .54885 m
.64016 .52529 L
s
.228 .342 .695 r
.58474 .42122 m .58526 .41343 L .56565 .40255 L p F P
0 0 0 r
s
.203 .306 .632 r
.58526 .41343 m .58474 .42122 L .60225 .43573 L p F P
0 0 0 r
s
.33 .484 .918 r
.41474 .41343 m .41526 .42122 L .39775 .43573 L p F P
0 0 0 r
s
.324 .477 .912 r
.41526 .42122 m .41474 .41343 L .43435 .40255 L p F P
0 0 0 r
s
.24 .35 .67 r
.57288 .70093 m
.57138 .72127 L
s
.57138 .72127 m
.54432 .73204 L
s
.45568 .73204 m
.42862 .72127 L
s
.42712 .70093 m
.42862 .72127 L
s
.306 .453 .879 r
.47739 .38581 m .47743 .38793 L .45539 .394 L p F P
0 0 0 r
s
.295 .437 .854 r
.5 .38446 m .47743 .38793 L .47739 .38581 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.48504 .38615 m
.48522 .40205 L
s
.281 .419 .825 r
.52257 .38793 m .52261 .38581 L .5 .38446 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.51478 .40205 m
.51496 .38615 L
s
.266 .397 .789 r
.52261 .38581 m .52257 .38793 L .54461 .394 L p F P
0 0 0 r
s
.316 .466 .898 r
.45525 .38982 m .45539 .394 L .43435 .40255 L p F P
0 0 0 r
s
.306 .453 .879 r
.45539 .394 m .45525 .38982 L .47739 .38581 L p F P
0 0 0 r
s
.24 .35 .67 r
.45568 .39087 m
.45657 .41717 L
s
.266 .397 .789 r
.54461 .394 m .54475 .38982 L .52261 .38581 L p F P
0 0 0 r
s
.24 .35 .67 r
.54343 .41717 m
.54432 .39087 L
s
.249 .372 .747 r
.54475 .38982 m .54461 .394 L .56565 .40255 L p F P
0 0 0 r
s
.295 .437 .854 r
.5 .38446 m .47717 .37294 L .47713 .37077 L closepath p F P
0 0 0 r
s
.295 .437 .854 r
.5 .38446 m .47739 .38581 L .47736 .38368 L closepath p F P
0 0 0 r
s
.295 .437 .854 r
.5 .38446 m .47736 .38368 L .47732 .38155 L closepath p F P
0 0 0 r
s
.295 .437 .854 r
.5 .38446 m .47732 .38155 L .47728 .37941 L closepath p F P
0 0 0 r
s
.295 .437 .854 r
.5 .38446 m .47728 .37941 L .47724 .37726 L closepath p F P
0 0 0 r
s
.295 .437 .854 r
.5 .38446 m .47724 .37726 L .47721 .3751 L closepath p F P
0 0 0 r
s
.295 .437 .854 r
.5 .38446 m .47721 .3751 L .47717 .37294 L closepath p F P
0 0 0 r
s
.281 .419 .825 r
.52264 .38368 m .52268 .38155 L .5 .38446 L closepath p F P
0 0 0 r
s
.281 .419 .825 r
.52261 .38581 m .52264 .38368 L .5 .38446 L closepath p F P
0 0 0 r
s
.281 .419 .825 r
.52279 .3751 m .52283 .37294 L .5 .38446 L closepath p F P
0 0 0 r
s
.281 .419 .825 r
.52276 .37726 m .52279 .3751 L .5 .38446 L closepath p F P
0 0 0 r
s
.281 .419 .825 r
.52272 .37941 m .52276 .37726 L .5 .38446 L closepath p F P
0 0 0 r
s
.281 .419 .825 r
.52268 .38155 m .52272 .37941 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .296 .126 r
.5196 .37077 m .52287 .37077 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .296 .126 r
.51633 .37077 m .5196 .37077 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .296 .126 r
.51307 .37077 m .51633 .37077 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .296 .126 r
.5098 .37077 m .51307 .37077 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .296 .126 r
.50653 .37077 m .5098 .37077 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .296 .126 r
.50327 .37077 m .50653 .37077 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .296 .126 r
.5 .37077 m .50327 .37077 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .296 .126 r
.49673 .37077 m .5 .37077 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .296 .126 r
.49347 .37077 m .49673 .37077 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .296 .126 r
.4902 .37077 m .49347 .37077 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .296 .126 r
.48693 .37077 m .4902 .37077 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .296 .126 r
.48367 .37077 m .48693 .37077 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .296 .126 r
.4804 .37077 m .48367 .37077 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .296 .126 r
.47713 .37077 m .4804 .37077 L .5 .38446 L closepath p F P
0 0 0 r
s
.281 .419 .825 r
.52283 .37294 m .52287 .37077 L .5 .38446 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.5 .37624 m
.5 .39591 L
s
.306 .453 .879 r
.47736 .38368 m .47739 .38581 L .45525 .38982 L p F P
0 0 0 r
s
.266 .397 .789 r
.52264 .38368 m .52261 .38581 L .54475 .38982 L p F P
0 0 0 r
s
.24 .35 .67 r
.48504 .38615 m
.51496 .38615 L
s
.249 .372 .747 r
.56565 .40255 m .56596 .39644 L .54475 .38982 L p F P
0 0 0 r
s
.228 .342 .695 r
.56596 .39644 m .56565 .40255 L .58526 .41343 L p F P
0 0 0 r
s
.324 .477 .912 r
.43404 .39644 m .43435 .40255 L .41474 .41343 L p F P
0 0 0 r
s
.316 .466 .898 r
.43435 .40255 m .43404 .39644 L .45525 .38982 L p F P
0 0 0 r
s
.203 .306 .632 r
.60225 .43573 m .60301 .42642 L .58526 .41343 L p F P
0 0 0 r
s
.173 .262 .553 r
.60301 .42642 m .60225 .43573 L .61751 .45184 L p F P
0 0 0 r
s
.24 .35 .67 r
.59509 .43988 m
.61593 .45718 L
s
.332 .486 .914 r
.39699 .42642 m .39775 .43573 L .38249 .45184 L p F P
0 0 0 r
s
.24 .35 .67 r
.38407 .45718 m
.40491 .43988 L
s
.33 .484 .918 r
.39775 .43573 m .39699 .42642 L .41474 .41343 L p F P
0 0 0 r
s
.028 .041 .084 r
.64286 .59157 m .64434 .58015 L .6448 .56206 L p F P
0 0 0 r
s
.23 .333 .575 r
.64434 .58015 m .64286 .59157 L .63904 .60765 L p F P
0 0 0 r
s
.24 .35 .67 r
.63913 .60778 m
.63928 .60665 L
s
.23 .333 .575 r
.63766 .61838 m .63904 .60765 L .64286 .59157 L p F P
0 0 0 r
s
.24 .35 .67 r
.63936 .60596 m
.64042 .59771 L
s
.64042 .59771 m
.64196 .57301 L
s
.045 .066 .152 r
.36234 .61838 m .36096 .60765 L .35714 .59157 L p F P
0 0 0 r
s
.203 .284 .476 r
.35714 .59157 m .35566 .58015 L .3552 .56206 L p F P
0 0 0 r
s
.045 .066 .152 r
.35566 .58015 m .35714 .59157 L .36096 .60765 L p F P
0 0 0 r
s
.24 .35 .67 r
.35958 .59771 m
.36064 .60596 L
s
.35804 .57301 m
.35958 .59771 L
s
.135 .206 .453 r
.62894 .4806 m .63015 .46926 L .61751 .45184 L p F P
0 0 0 r
s
.096 .145 .343 r
.63015 .46926 m .62894 .4806 L .63847 .49961 L p F P
0 0 0 r
s
.32 .464 .852 r
.36985 .46926 m .37106 .4806 L .36153 .49961 L p F P
0 0 0 r
s
.33 .481 .895 r
.37106 .4806 m .36985 .46926 L .38249 .45184 L p F P
0 0 0 r
s
.557 .144 .061 r
.61192 .63157 m .63058 .63157 L .63766 .61838 L p F P
0 0 0 r
s
.557 .144 .061 r
.63766 .61838 m .618 .61838 L .61192 .63157 L p F P
0 0 0 r
s
.281 .411 .734 r
.63904 .60765 m .63766 .61838 L .63058 .63157 L p F P
0 0 0 r
s
.24 .35 .67 r
.62987 .64374 m
.63162 .62964 L
s
.557 .144 .061 r
.36942 .63157 m .38808 .63157 L .382 .61838 L p F P
0 0 0 r
s
.557 .144 .061 r
.382 .61838 m .36234 .61838 L .36942 .63157 L p F P
0 0 0 r
s
.83 .24 .1 r
.37612 .62625 m
.37801 .6072 L
s
.557 .144 .061 r
.38808 .63157 m .40673 .63157 L .40167 .61838 L p F P
0 0 0 r
s
.557 .144 .061 r
.40167 .61838 m .382 .61838 L .38808 .63157 L p F P
0 0 0 r
s
.557 .144 .061 r
.40673 .63157 m .42538 .63157 L .42134 .61838 L p F P
0 0 0 r
s
.557 .144 .061 r
.42134 .61838 m .40167 .61838 L .40673 .63157 L p F P
0 0 0 r
s
.83 .24 .1 r
.41741 .62625 m
.41868 .6072 L
s
.557 .144 .061 r
.42538 .63157 m .44404 .63157 L .441 .61838 L p F P
0 0 0 r
s
.557 .144 .061 r
.441 .61838 m .42134 .61838 L .42538 .63157 L p F P
0 0 0 r
s
.557 .144 .061 r
.44404 .63157 m .46269 .63157 L .46067 .61838 L p F P
0 0 0 r
s
.557 .144 .061 r
.46067 .61838 m .441 .61838 L .44404 .63157 L p F P
0 0 0 r
s
.83 .24 .1 r
.45871 .62625 m
.45934 .6072 L
s
.557 .144 .061 r
.46269 .63157 m .48135 .63157 L .48033 .61838 L p F P
0 0 0 r
s
.557 .144 .061 r
.48033 .61838 m .46067 .61838 L .46269 .63157 L p F P
0 0 0 r
s
.557 .144 .061 r
.48135 .63157 m .5 .63157 L .5 .61838 L p F P
0 0 0 r
s
.557 .144 .061 r
.5 .61838 m .48033 .61838 L .48135 .63157 L p F P
0 0 0 r
s
.557 .144 .061 r
.5 .63157 m .51865 .63157 L .51967 .61838 L p F P
0 0 0 r
s
.557 .144 .061 r
.51967 .61838 m .5 .61838 L .5 .63157 L p F P
0 0 0 r
s
.83 .24 .1 r
.5 .6072 m
.5 .62625 L
s
.557 .144 .061 r
.51865 .63157 m .53731 .63157 L .53933 .61838 L p F P
0 0 0 r
s
.557 .144 .061 r
.53933 .61838 m .51967 .61838 L .51865 .63157 L p F P
0 0 0 r
s
.557 .144 .061 r
.53731 .63157 m .55596 .63157 L .559 .61838 L p F P
0 0 0 r
s
.557 .144 .061 r
.559 .61838 m .53933 .61838 L .53731 .63157 L p F P
0 0 0 r
s
.83 .24 .1 r
.54066 .6072 m
.54129 .62625 L
s
.557 .144 .061 r
.55596 .63157 m .57462 .63157 L .57866 .61838 L p F P
0 0 0 r
s
.557 .144 .061 r
.57866 .61838 m .559 .61838 L .55596 .63157 L p F P
0 0 0 r
s
.557 .144 .061 r
.57462 .63157 m .59327 .63157 L .59833 .61838 L p F P
0 0 0 r
s
.557 .144 .061 r
.59833 .61838 m .57866 .61838 L .57462 .63157 L p F P
0 0 0 r
s
.83 .24 .1 r
.58132 .6072 m
.58259 .62625 L
s
.557 .144 .061 r
.59327 .63157 m .61192 .63157 L .618 .61838 L p F P
0 0 0 r
s
.557 .144 .061 r
.618 .61838 m .59833 .61838 L .59327 .63157 L p F P
0 0 0 r
s
.83 .24 .1 r
.62199 .6072 m
.62388 .62625 L
s
.068 .1 .244 r
.36096 .60765 m .36234 .61838 L .36942 .63157 L p F P
0 0 0 r
s
.24 .35 .67 r
.36838 .62964 m
.37013 .64374 L
s
.306 .453 .879 r
.45525 .38982 m .45511 .38562 L .47736 .38368 L p F P
0 0 0 r
s
.24 .35 .67 r
.45568 .39087 m
.48504 .38615 L
s
.306 .453 .879 r
.47732 .38155 m .47736 .38368 L .45511 .38562 L p F P
0 0 0 r
s
.266 .397 .789 r
.52268 .38155 m .52264 .38368 L .54489 .38562 L p F P
0 0 0 r
s
.83 .24 .1 r
.5408 .38873 m
.54091 .38527 L
s
.266 .397 .789 r
.54475 .38982 m .54489 .38562 L .52264 .38368 L p F P
0 0 0 r
s
.24 .35 .67 r
.51496 .38615 m
.54432 .39087 L
s
.052 .076 .18 r
.6448 .56206 m .64632 .55017 L .64336 .53099 L p F P
0 0 0 r
s
.028 .041 .084 r
.64632 .55017 m .6448 .56206 L .64434 .58015 L p F P
0 0 0 r
s
.26 .371 .651 r
.3552 .56206 m .35368 .55017 L .35664 .53099 L p F P
0 0 0 r
s
.203 .284 .476 r
.35368 .55017 m .3552 .56206 L .35566 .58015 L p F P
0 0 0 r
s
.316 .466 .898 r
.45511 .38562 m .45525 .38982 L .43404 .39644 L p F P
0 0 0 r
s
.249 .372 .747 r
.54489 .38562 m .54475 .38982 L .56596 .39644 L p F P
0 0 0 r
s
.24 .35 .67 r
.54525 .71183 m
.54432 .73204 L
s
.54432 .73204 m
.51503 .73759 L
s
.48497 .73759 m
.45568 .73204 L
s
.45475 .71183 m
.45568 .73204 L
s
.306 .453 .879 r
.45511 .38562 m .45496 .38139 L .47732 .38155 L p F P
0 0 0 r
s
.306 .453 .879 r
.47728 .37941 m .47732 .38155 L .45496 .38139 L p F P
0 0 0 r
s
.266 .397 .789 r
.52272 .37941 m .52268 .38155 L .54504 .38139 L p F P
0 0 0 r
s
.266 .397 .789 r
.54489 .38562 m .54504 .38139 L .52268 .38155 L p F P
0 0 0 r
s
.24 .35 .67 r
.40313 .68534 m
.38386 .66594 L
s
.38141 .64431 m
.38386 .66594 L
s
.61859 .64431 m
.61614 .66594 L
s
.61614 .66594 m
.59687 .68534 L
s
.228 .342 .695 r
.58526 .41343 m .58578 .40554 L .56596 .39644 L p F P
0 0 0 r
s
.203 .306 .632 r
.58578 .40554 m .58526 .41343 L .60301 .42642 L p F P
0 0 0 r
s
.33 .484 .918 r
.41422 .40554 m .41474 .41343 L .39699 .42642 L p F P
0 0 0 r
s
.324 .477 .912 r
.41474 .41343 m .41422 .40554 L .43404 .39644 L p F P
0 0 0 r
s
.072 .105 .259 r
.64336 .53099 m .64485 .51889 L .63847 .49961 L p F P
0 0 0 r
s
.052 .076 .18 r
.64485 .51889 m .64336 .53099 L .64632 .55017 L p F P
0 0 0 r
s
.26 .371 .651 r
.35515 .51889 m .35664 .53099 L .35368 .55017 L p F P
0 0 0 r
s
.298 .43 .775 r
.35664 .53099 m .35515 .51889 L .36153 .49961 L p F P
0 0 0 r
s
.24 .35 .67 r
.51534 .71745 m
.51503 .73759 L
s
.51503 .73759 m
.48497 .73759 L
s
.48466 .71745 m
.48497 .73759 L
s
.306 .453 .879 r
.45496 .38139 m .45481 .37713 L .47728 .37941 L p F P
0 0 0 r
s
.306 .453 .879 r
.47724 .37726 m .47728 .37941 L .45481 .37713 L p F P
0 0 0 r
s
.266 .397 .789 r
.52276 .37726 m .52272 .37941 L .54519 .37713 L p F P
0 0 0 r
s
.266 .397 .789 r
.54504 .38139 m .54519 .37713 L .52272 .37941 L p F P
0 0 0 r
s
.173 .262 .553 r
.61751 .45184 m .61851 .44128 L .60301 .42642 L p F P
0 0 0 r
s
.135 .206 .453 r
.61851 .44128 m .61751 .45184 L .63015 .46926 L p F P
0 0 0 r
s
.33 .481 .895 r
.38149 .44128 m .38249 .45184 L .36985 .46926 L p F P
0 0 0 r
s
.332 .486 .914 r
.38249 .45184 m .38149 .44128 L .39699 .42642 L p F P
0 0 0 r
s
.316 .466 .898 r
.43404 .39644 m .43373 .39026 L .45511 .38562 L p F P
0 0 0 r
s
.316 .466 .898 r
.45496 .38139 m .45511 .38562 L .43373 .39026 L p F P
0 0 0 r
s
.249 .372 .747 r
.54504 .38139 m .54489 .38562 L .56627 .39026 L p F P
0 0 0 r
s
.249 .372 .747 r
.56596 .39644 m .56627 .39026 L .54489 .38562 L p F P
0 0 0 r
s
.228 .342 .695 r
.56627 .39026 m .56596 .39644 L .58578 .40554 L p F P
0 0 0 r
s
.24 .35 .67 r
.54432 .39087 m
.57205 .40016 L
s
.57059 .42639 m
.57205 .40016 L
s
.83 .24 .1 r
.58116 .39591 m
.58239 .37624 L
s
.324 .477 .912 r
.43373 .39026 m .43404 .39644 L .41422 .40554 L p F P
0 0 0 r
s
.24 .35 .67 r
.42795 .40016 m
.45568 .39087 L
s
.42795 .40016 m
.42941 .42639 L
s
.83 .24 .1 r
.41761 .37624 m
.41884 .39591 L
s
.306 .453 .879 r
.45481 .37713 m .45467 .37284 L .47724 .37726 L p F P
0 0 0 r
s
.306 .453 .879 r
.47721 .3751 m .47724 .37726 L .45467 .37284 L p F P
0 0 0 r
s
.266 .397 .789 r
.52279 .3751 m .52276 .37726 L .54533 .37284 L p F P
0 0 0 r
s
.266 .397 .789 r
.54519 .37713 m .54533 .37284 L .52276 .37726 L p F P
0 0 0 r
s
.096 .145 .343 r
.63847 .49961 m .63986 .48762 L .63015 .46926 L p F P
0 0 0 r
s
.072 .105 .259 r
.63986 .48762 m .63847 .49961 L .64485 .51889 L p F P
0 0 0 r
s
.298 .43 .775 r
.36014 .48762 m .36153 .49961 L .35515 .51889 L p F P
0 0 0 r
s
.32 .464 .852 r
.36153 .49961 m .36014 .48762 L .36985 .46926 L p F P
0 0 0 r
s
.83 .24 .1 r
.25282 .37624 m
.21163 .37624 L
s
.29402 .37624 m
.25282 .37624 L
s
.33522 .37624 m
.29402 .37624 L
s
.37641 .37624 m
.33522 .37624 L
s
.41761 .37624 m
.37641 .37624 L
s
.41761 .37624 m
.45478 .37624 L
s
.47533 .37624 m
.5 .37624 L
s
.5 .37624 m
.52467 .37624 L
s
.54522 .37624 m
.58239 .37624 L
s
.62359 .37624 m
.58239 .37624 L
s
.66478 .37624 m
.62359 .37624 L
s
.70598 .37624 m
.66478 .37624 L
s
.74718 .37624 m
.70598 .37624 L
s
.78837 .37624 m
.74718 .37624 L
s
.25282 .37624 m
.24849 .36117 L
s
.20657 .36117 m
.21163 .37624 L
s
.29402 .37624 m
.29041 .36117 L
s
.33522 .37624 m
.33233 .36117 L
s
.37641 .37624 m
.37425 .36117 L
s
.62359 .37624 m
.62575 .36117 L
s
.66478 .37624 m
.66767 .36117 L
s
.70598 .37624 m
.70959 .36117 L
s
.74718 .37624 m
.75151 .36117 L
s
.78837 .37624 m
.79343 .36117 L
s
.203 .306 .632 r
.60301 .42642 m .60378 .41697 L .58578 .40554 L p F P
0 0 0 r
s
.173 .262 .553 r
.60378 .41697 m .60301 .42642 L .61851 .44128 L p F P
0 0 0 r
s
.332 .486 .914 r
.39622 .41697 m .39699 .42642 L .38149 .44128 L p F P
0 0 0 r
s
.33 .484 .918 r
.39699 .42642 m .39622 .41697 L .41422 .40554 L p F P
0 0 0 r
s
.306 .453 .879 r
.45467 .37284 m .45452 .36853 L .47721 .3751 L p F P
0 0 0 r
s
.306 .453 .879 r
.47717 .37294 m .47721 .3751 L .45452 .36853 L p F P
0 0 0 r
s
.266 .397 .789 r
.52283 .37294 m .52279 .3751 L .54548 .36853 L p F P
0 0 0 r
s
.266 .397 .789 r
.54533 .37284 m .54548 .36853 L .52279 .3751 L p F P
0 0 0 r
s
.316 .466 .898 r
.43373 .39026 m .43341 .38403 L .45496 .38139 L p F P
0 0 0 r
s
.316 .466 .898 r
.45481 .37713 m .45496 .38139 L .43341 .38403 L p F P
0 0 0 r
s
.249 .372 .747 r
.54519 .37713 m .54504 .38139 L .56659 .38403 L p F P
0 0 0 r
s
.249 .372 .747 r
.56627 .39026 m .56659 .38403 L .54504 .38139 L p F P
0 0 0 r
s
.228 .342 .695 r
.58578 .40554 m .58632 .39756 L .56627 .39026 L p F P
0 0 0 r
s
.203 .306 .632 r
.58632 .39756 m .58578 .40554 L .60378 .41697 L p F P
0 0 0 r
s
.24 .35 .67 r
.57205 .40016 m
.59707 .41375 L
s
.59509 .43988 m
.59707 .41375 L
s
.33 .484 .918 r
.41368 .39756 m .41422 .40554 L .39622 .41697 L p F P
0 0 0 r
s
.24 .35 .67 r
.40293 .41375 m
.40491 .43988 L
s
.324 .477 .912 r
.41422 .40554 m .41368 .39756 L .43373 .39026 L p F P
0 0 0 r
s
.24 .35 .67 r
.40293 .41375 m
.42795 .40016 L
s
.306 .453 .879 r
.45452 .36853 m .45437 .36418 L .47717 .37294 L p F P
0 0 0 r
s
.306 .453 .879 r
.47713 .37077 m .47717 .37294 L .45437 .36418 L p F P
0 0 0 r
s
.266 .397 .789 r
.52287 .37077 m .52283 .37294 L .54563 .36418 L p F P
0 0 0 r
s
.266 .397 .789 r
.54548 .36853 m .54563 .36418 L .52283 .37294 L p F P
0 0 0 r
s
.228 .342 .695 r
.56659 .38403 m .56627 .39026 L .58632 .39756 L p F P
0 0 0 r
s
.324 .477 .912 r
.43341 .38403 m .43373 .39026 L .41368 .39756 L p F P
0 0 0 r
s
.83 .24 .1 r
.24782 .64058 m
.25223 .62625 L
s
.21094 .62625 m
.20579 .64058 L
s
.25223 .62625 m
.21094 .62625 L
s
.28985 .64058 m
.29353 .62625 L
s
.29353 .62625 m
.25223 .62625 L
s
.33188 .64058 m
.33482 .62625 L
s
.33482 .62625 m
.29353 .62625 L
s
.33482 .62625 m
.36682 .62625 L
s
.36754 .62625 m
.37612 .62625 L
s
.37612 .62625 m
.41741 .62625 L
s
.41741 .62625 m
.45871 .62625 L
s
.45871 .62625 m
.5 .62625 L
s
.5 .62625 m
.54129 .62625 L
s
.54129 .62625 m
.58259 .62625 L
s
.58259 .62625 m
.62388 .62625 L
s
.66812 .64058 m
.66518 .62625 L
s
.63318 .62625 m
.66518 .62625 L
s
.62388 .62625 m
.63246 .62625 L
s
.71015 .64058 m
.70647 .62625 L
s
.70647 .62625 m
.66518 .62625 L
s
.75218 .64058 m
.74777 .62625 L
s
.74777 .62625 m
.70647 .62625 L
s
.79421 .64058 m
.78906 .62625 L
s
.78906 .62625 m
.74777 .62625 L
s
.135 .206 .453 r
.63015 .46926 m .63138 .45771 L .61851 .44128 L p F P
0 0 0 r
s
.096 .145 .343 r
.63138 .45771 m .63015 .46926 L .63986 .48762 L p F P
0 0 0 r
s
.24 .35 .67 r
.61593 .45718 m
.63221 .47772 L
s
.62951 .50248 m
.63221 .47772 L
s
.32 .464 .852 r
.36862 .45771 m .36985 .46926 L .36014 .48762 L p F P
0 0 0 r
s
.24 .35 .67 r
.36779 .47772 m
.37049 .50248 L
s
.33 .481 .895 r
.36985 .46926 m .36862 .45771 L .38149 .44128 L p F P
0 0 0 r
s
.24 .35 .67 r
.36779 .47772 m
.38407 .45718 L
s
.028 .041 .084 r
.64434 .58015 m .64586 .56849 L .64632 .55017 L p F P
0 0 0 r
s
.23 .333 .575 r
.64586 .56849 m .64434 .58015 L .64045 .5967 L p F P
0 0 0 r
s
.24 .35 .67 r
.64042 .59771 m
.64069 .59568 L
s
.23 .333 .575 r
.63904 .60765 m .64045 .5967 L .64434 .58015 L p F P
0 0 0 r
s
.045 .066 .152 r
.36096 .60765 m .35955 .5967 L .35566 .58015 L p F P
0 0 0 r
s
.203 .284 .476 r
.35566 .58015 m .35414 .56849 L .35368 .55017 L p F P
0 0 0 r
s
.045 .066 .152 r
.35414 .56849 m .35566 .58015 L .35955 .5967 L p F P
0 0 0 r
s
.306 .453 .879 r
.45437 .36418 m .45422 .35981 L .47713 .37077 L p F P
0 0 0 r
s
.266 .397 .789 r
.54563 .36418 m .54578 .35981 L .52287 .37077 L p F P
0 0 0 r
s
.992 .297 .127 r
.52287 .37077 m .5196 .37077 L .53924 .35981 L p F P
0 0 0 r
s
.992 .297 .127 r
.53924 .35981 m .54578 .35981 L .52287 .37077 L p F P
0 0 0 r
s
.83 .24 .1 r
.54165 .36676 m
.54192 .36117 L
s
.992 .297 .127 r
.5196 .37077 m .51633 .37077 L .5327 .35981 L p F P
0 0 0 r
s
.992 .297 .127 r
.5327 .35981 m .53924 .35981 L .5196 .37077 L p F P
0 0 0 r
s
.992 .297 .127 r
.51633 .37077 m .51307 .37077 L .52616 .35981 L p F P
0 0 0 r
s
.992 .297 .127 r
.52616 .35981 m .5327 .35981 L .51633 .37077 L p F P
0 0 0 r
s
.992 .297 .127 r
.51307 .37077 m .5098 .37077 L .51962 .35981 L p F P
0 0 0 r
s
.992 .297 .127 r
.51962 .35981 m .52616 .35981 L .51307 .37077 L p F P
0 0 0 r
s
.992 .297 .127 r
.5098 .37077 m .50653 .37077 L .51308 .35981 L p F P
0 0 0 r
s
.992 .297 .127 r
.51308 .35981 m .51962 .35981 L .5098 .37077 L p F P
0 0 0 r
s
.24 .35 .67 r
.51496 .38615 m
.51514 .36985 L
s
.51526 .35981 m
.51527 .35871 L
s
.992 .297 .127 r
.50653 .37077 m .50327 .37077 L .50654 .35981 L p F P
0 0 0 r
s
.992 .297 .127 r
.50654 .35981 m .51308 .35981 L .50653 .37077 L p F P
0 0 0 r
s
.992 .297 .127 r
.50327 .37077 m .5 .37077 L .5 .35981 L p F P
0 0 0 r
s
.992 .297 .127 r
.5 .35981 m .50654 .35981 L .50327 .37077 L p F P
0 0 0 r
s
.992 .297 .127 r
.5 .37077 m .49673 .37077 L .49346 .35981 L p F P
0 0 0 r
s
.992 .297 .127 r
.49346 .35981 m .5 .35981 L .5 .37077 L p F P
0 0 0 r
s
.83 .24 .1 r
.5 .36117 m
.5 .37624 L
s
.992 .297 .127 r
.49673 .37077 m .49347 .37077 L .48692 .35981 L p F P
0 0 0 r
s
.992 .297 .127 r
.48692 .35981 m .49346 .35981 L .49673 .37077 L p F P
0 0 0 r
s
.992 .297 .127 r
.49347 .37077 m .4902 .37077 L .48038 .35981 L p F P
0 0 0 r
s
.992 .297 .127 r
.48038 .35981 m .48692 .35981 L .49347 .37077 L p F P
0 0 0 r
s
.992 .297 .127 r
.4902 .37077 m .48693 .37077 L .47384 .35981 L p F P
0 0 0 r
s
.992 .297 .127 r
.47384 .35981 m .48038 .35981 L .4902 .37077 L p F P
0 0 0 r
s
.992 .297 .127 r
.48693 .37077 m .48367 .37077 L .4673 .35981 L p F P
0 0 0 r
s
.992 .297 .127 r
.4673 .35981 m .47384 .35981 L .48693 .37077 L p F P
0 0 0 r
s
.24 .35 .67 r
.48486 .36985 m
.48504 .38615 L
s
.48473 .35871 m
.48474 .35981 L
s
.992 .297 .127 r
.48367 .37077 m .4804 .37077 L .46076 .35981 L p F P
0 0 0 r
s
.992 .297 .127 r
.46076 .35981 m .4673 .35981 L .48367 .37077 L p F P
0 0 0 r
s
.992 .297 .127 r
.4804 .37077 m .47713 .37077 L .45422 .35981 L p F P
0 0 0 r
s
.992 .297 .127 r
.45422 .35981 m .46076 .35981 L .4804 .37077 L p F P
0 0 0 r
s
.83 .24 .1 r
.45808 .36117 m
.45835 .36676 L
s
.281 .411 .734 r
.64045 .5967 m .63904 .60765 L .63182 .62152 L p F P
0 0 0 r
s
.281 .411 .734 r
.63058 .63157 m .63182 .62152 L .63904 .60765 L p F P
0 0 0 r
s
.068 .1 .244 r
.36942 .63157 m .36818 .62152 L .36096 .60765 L p F P
0 0 0 r
s
.068 .1 .244 r
.35955 .5967 m .36096 .60765 L .36818 .62152 L p F P
0 0 0 r
s
.316 .466 .898 r
.43341 .38403 m .43309 .37774 L .45481 .37713 L p F P
0 0 0 r
s
.316 .466 .898 r
.45467 .37284 m .45481 .37713 L .43309 .37774 L p F P
0 0 0 r
s
.24 .35 .67 r
.45474 .36346 m
.45568 .39087 L
s
.249 .372 .747 r
.54533 .37284 m .54519 .37713 L .56691 .37774 L p F P
0 0 0 r
s
.249 .372 .747 r
.56659 .38403 m .56691 .37774 L .54519 .37713 L p F P
0 0 0 r
s
.24 .35 .67 r
.54432 .39087 m
.54526 .36346 L
s
.42712 .70093 m
.40313 .68534 L
s
.40107 .66394 m
.40313 .68534 L
s
.59893 .66394 m
.59687 .68534 L
s
.59687 .68534 m
.57288 .70093 L
s
.052 .076 .18 r
.64632 .55017 m .64788 .53803 L .64485 .51889 L p F P
0 0 0 r
s
.24 .35 .67 r
.64196 .57301 m
.64492 .54969 L
s
.64016 .52529 m
.64492 .54969 L
s
.028 .041 .084 r
.64788 .53803 m .64632 .55017 L .64586 .56849 L p F P
0 0 0 r
s
.26 .371 .651 r
.35368 .55017 m .35212 .53803 L .35515 .51889 L p F P
0 0 0 r
s
.24 .35 .67 r
.35508 .54969 m
.35804 .57301 L
s
.35508 .54969 m
.35984 .52529 L
s
.203 .284 .476 r
.35212 .53803 m .35368 .55017 L .35414 .56849 L p F P
0 0 0 r
s
.173 .262 .553 r
.61851 .44128 m .61953 .43053 L .60378 .41697 L p F P
0 0 0 r
s
.24 .35 .67 r
.61593 .45718 m
.61837 .4312 L
s
.135 .206 .453 r
.61953 .43053 m .61851 .44128 L .63138 .45771 L p F P
0 0 0 r
s
.33 .481 .895 r
.38047 .43053 m .38149 .44128 L .36862 .45771 L p F P
0 0 0 r
s
.332 .486 .914 r
.38149 .44128 m .38047 .43053 L .39622 .41697 L p F P
0 0 0 r
s
.24 .35 .67 r
.38163 .4312 m
.38407 .45718 L
s
.428 .104 .044 r
.37982 .64196 m .39699 .64196 L .38808 .63157 L p F P
0 0 0 r
s
.428 .104 .044 r
.38808 .63157 m .36942 .63157 L .37982 .64196 L p F P
0 0 0 r
s
.428 .104 .044 r
.39699 .64196 m .41416 .64196 L .40673 .63157 L p F P
0 0 0 r
s
.428 .104 .044 r
.40673 .63157 m .38808 .63157 L .39699 .64196 L p F P
0 0 0 r
s
.428 .104 .044 r
.41416 .64196 m .43133 .64196 L .42538 .63157 L p F P
0 0 0 r
s
.428 .104 .044 r
.42538 .63157 m .40673 .63157 L .41416 .64196 L p F P
0 0 0 r
s
.83 .24 .1 r
.41594 .64058 m
.41741 .62625 L
s
.428 .104 .044 r
.43133 .64196 m .44849 .64196 L .44404 .63157 L p F P
0 0 0 r
s
.428 .104 .044 r
.44404 .63157 m .42538 .63157 L .43133 .64196 L p F P
0 0 0 r
s
.428 .104 .044 r
.44849 .64196 m .46566 .64196 L .46269 .63157 L p F P
0 0 0 r
s
.428 .104 .044 r
.46269 .63157 m .44404 .63157 L .44849 .64196 L p F P
0 0 0 r
s
.83 .24 .1 r
.45797 .64058 m
.45871 .62625 L
s
.428 .104 .044 r
.46566 .64196 m .48283 .64196 L .48135 .63157 L p F P
0 0 0 r
s
.428 .104 .044 r
.48135 .63157 m .46269 .63157 L .46566 .64196 L p F P
0 0 0 r
s
.428 .104 .044 r
.48283 .64196 m .5 .64196 L .5 .63157 L p F P
0 0 0 r
s
.428 .104 .044 r
.5 .63157 m .48135 .63157 L .48283 .64196 L p F P
0 0 0 r
s
.428 .104 .044 r
.5 .64196 m .51717 .64196 L .51865 .63157 L p F P
0 0 0 r
s
.428 .104 .044 r
.51865 .63157 m .5 .63157 L .5 .64196 L p F P
0 0 0 r
s
.83 .24 .1 r
.5 .62625 m
.5 .64058 L
s
.428 .104 .044 r
.51717 .64196 m .53434 .64196 L .53731 .63157 L p F P
0 0 0 r
s
.428 .104 .044 r
.53731 .63157 m .51865 .63157 L .51717 .64196 L p F P
0 0 0 r
s
.428 .104 .044 r
.53434 .64196 m .55151 .64196 L .55596 .63157 L p F P
0 0 0 r
s
.428 .104 .044 r
.55596 .63157 m .53731 .63157 L .53434 .64196 L p F P
0 0 0 r
s
.83 .24 .1 r
.54129 .62625 m
.54203 .64058 L
s
.428 .104 .044 r
.55151 .64196 m .56867 .64196 L .57462 .63157 L p F P
0 0 0 r
s
.428 .104 .044 r
.57462 .63157 m .55596 .63157 L .55151 .64196 L p F P
0 0 0 r
s
.428 .104 .044 r
.56867 .64196 m .58584 .64196 L .59327 .63157 L p F P
0 0 0 r
s
.428 .104 .044 r
.59327 .63157 m .57462 .63157 L .56867 .64196 L p F P
0 0 0 r
s
.83 .24 .1 r
.58259 .62625 m
.58406 .64058 L
s
.428 .104 .044 r
.58584 .64196 m .60301 .64196 L .61192 .63157 L p F P
0 0 0 r
s
.428 .104 .044 r
.61192 .63157 m .59327 .63157 L .58584 .64196 L p F P
0 0 0 r
s
.428 .104 .044 r
.60301 .64196 m .62018 .64196 L .63058 .63157 L p F P
0 0 0 r
s
.428 .104 .044 r
.63058 .63157 m .61192 .63157 L .60301 .64196 L p F P
0 0 0 r
s
.313 .46 .84 r
.63182 .62152 m .63058 .63157 L .62018 .64196 L p F P
0 0 0 r
s
.83 .24 .1 r
.62388 .62625 m
.625 .63349 L
s
.092 .138 .333 r
.36818 .62152 m .36942 .63157 L .37982 .64196 L p F P
0 0 0 r
s
.83 .24 .1 r
.375 .63349 m
.37612 .62625 L
s
.24 .35 .67 r
.37995 .64196 m
.38141 .64431 L
s
.61859 .64431 m
.62005 .64196 L
s
.072 .105 .259 r
.64485 .51889 m .64638 .50655 L .63986 .48762 L p F P
0 0 0 r
s
.052 .076 .18 r
.64638 .50655 m .64485 .51889 L .64788 .53803 L p F P
0 0 0 r
s
.26 .371 .651 r
.35362 .50655 m .35515 .51889 L .35212 .53803 L p F P
0 0 0 r
s
.298 .43 .775 r
.35515 .51889 m .35362 .50655 L .36014 .48762 L p F P
0 0 0 r
s
.324 .477 .912 r
.41368 .39756 m .41314 .38947 L .43341 .38403 L p F P
0 0 0 r
s
.324 .477 .912 r
.43309 .37774 m .43341 .38403 L .41314 .38947 L p F P
0 0 0 r
s
.228 .342 .695 r
.56691 .37774 m .56659 .38403 L .58686 .38947 L p F P
0 0 0 r
s
.228 .342 .695 r
.58632 .39756 m .58686 .38947 L .56659 .38403 L p F P
0 0 0 r
s
.316 .466 .898 r
.43309 .37774 m .43276 .37138 L .45467 .37284 L p F P
0 0 0 r
s
.316 .466 .898 r
.45452 .36853 m .45467 .37284 L .43276 .37138 L p F P
0 0 0 r
s
.249 .372 .747 r
.54548 .36853 m .54533 .37284 L .56724 .37138 L p F P
0 0 0 r
s
.249 .372 .747 r
.56691 .37774 m .56724 .37138 L .54533 .37284 L p F P
0 0 0 r
s
.203 .306 .632 r
.60378 .41697 m .60456 .40739 L .58632 .39756 L p F P
0 0 0 r
s
.173 .262 .553 r
.60456 .40739 m .60378 .41697 L .61953 .43053 L p F P
0 0 0 r
s
.332 .486 .914 r
.39544 .40739 m .39622 .41697 L .38047 .43053 L p F P
0 0 0 r
s
.33 .484 .918 r
.39622 .41697 m .39544 .40739 L .41368 .39756 L p F P
0 0 0 r
s
.33 .484 .918 r
.41314 .38947 m .41368 .39756 L .39544 .40739 L p F P
0 0 0 r
s
.203 .306 .632 r
.58686 .38947 m .58632 .39756 L .60456 .40739 L p F P
0 0 0 r
s
.096 .145 .343 r
.63986 .48762 m .64129 .47539 L .63138 .45771 L p F P
0 0 0 r
s
.072 .105 .259 r
.64129 .47539 m .63986 .48762 L .64638 .50655 L p F P
0 0 0 r
s
.24 .35 .67 r
.63221 .47772 m
.64311 .50075 L
s
.64016 .52529 m
.64311 .50075 L
s
.298 .43 .775 r
.35871 .47539 m .36014 .48762 L .35362 .50655 L p F P
0 0 0 r
s
.24 .35 .67 r
.35689 .50075 m
.35984 .52529 L
s
.32 .464 .852 r
.36014 .48762 m .35871 .47539 L .36862 .45771 L p F P
0 0 0 r
s
.24 .35 .67 r
.35689 .50075 m
.36779 .47772 L
s
.316 .466 .898 r
.43276 .37138 m .43244 .36497 L .45452 .36853 L p F P
0 0 0 r
s
.316 .466 .898 r
.45437 .36418 m .45452 .36853 L .43244 .36497 L p F P
0 0 0 r
s
.249 .372 .747 r
.54563 .36418 m .54548 .36853 L .56756 .36497 L p F P
0 0 0 r
s
.249 .372 .747 r
.56724 .37138 m .56756 .36497 L .54548 .36853 L p F P
0 0 0 r
s
.24 .35 .67 r
.57444 .67971 m
.57288 .70093 L
s
.57288 .70093 m
.54525 .71183 L
s
.45475 .71183 m
.42712 .70093 L
s
.42556 .67971 m
.42712 .70093 L
s
.324 .477 .912 r
.41314 .38947 m .4126 .38129 L .43309 .37774 L p F P
0 0 0 r
s
.324 .477 .912 r
.43276 .37138 m .43309 .37774 L .4126 .38129 L p F P
0 0 0 r
s
.228 .342 .695 r
.56724 .37138 m .56691 .37774 L .5874 .38129 L p F P
0 0 0 r
s
.228 .342 .695 r
.58686 .38947 m .5874 .38129 L .56691 .37774 L p F P
0 0 0 r
s
.135 .206 .453 r
.63138 .45771 m .63263 .44594 L .61953 .43053 L p F P
0 0 0 r
s
.096 .145 .343 r
.63263 .44594 m .63138 .45771 L .64129 .47539 L p F P
0 0 0 r
s
.32 .464 .852 r
.36737 .44594 m .36862 .45771 L .35871 .47539 L p F P
0 0 0 r
s
.33 .481 .895 r
.36862 .45771 m .36737 .44594 L .38047 .43053 L p F P
0 0 0 r
s
.24 .35 .67 r
.45474 .36346 m
.46576 .36171 L
s
.47775 .35981 m
.48473 .35871 L
s
.48473 .35871 m
.51527 .35871 L
s
.53424 .36171 m
.54526 .36346 L
s
.51527 .35871 m
.52225 .35981 L
s
.316 .466 .898 r
.43244 .36497 m .43211 .35849 L .45437 .36418 L p F P
0 0 0 r
s
.316 .466 .898 r
.45422 .35981 m .45437 .36418 L .43211 .35849 L p F P
0 0 0 r
s
.249 .372 .747 r
.54578 .35981 m .54563 .36418 L .56789 .35849 L p F P
0 0 0 r
s
.249 .372 .747 r
.56756 .36497 m .56789 .35849 L .54563 .36418 L p F P
0 0 0 r
s
.23 .333 .575 r
.64045 .5967 m .64188 .58552 L .64586 .56849 L p F P
0 0 0 r
s
.281 .411 .734 r
.64188 .58552 m .64045 .5967 L .63308 .61128 L p F P
0 0 0 r
s
.281 .411 .734 r
.63182 .62152 m .63308 .61128 L .64045 .5967 L p F P
0 0 0 r
s
.068 .1 .244 r
.36818 .62152 m .36692 .61128 L .35955 .5967 L p F P
0 0 0 r
s
.068 .1 .244 r
.35812 .58552 m .35955 .5967 L .36692 .61128 L p F P
0 0 0 r
s
.045 .066 .152 r
.35955 .5967 m .35812 .58552 L .35414 .56849 L p F P
0 0 0 r
s
.028 .041 .084 r
.64586 .56849 m .64741 .55658 L .64788 .53803 L p F P
0 0 0 r
s
.23 .333 .575 r
.64741 .55658 m .64586 .56849 L .64188 .58552 L p F P
0 0 0 r
s
.24 .35 .67 r
.64222 .58375 m
.64339 .57464 L
s
.64339 .57464 m
.64492 .54969 L
s
.203 .284 .476 r
.35414 .56849 m .35259 .55658 L .35212 .53803 L p F P
0 0 0 r
s
.045 .066 .152 r
.35259 .55658 m .35414 .56849 L .35812 .58552 L p F P
0 0 0 r
s
.24 .35 .67 r
.35508 .54969 m
.35661 .57464 L
s
.35661 .57464 m
.35778 .58375 L
s
.173 .262 .553 r
.61953 .43053 m .62057 .41959 L .60456 .40739 L p F P
0 0 0 r
s
.24 .35 .67 r
.59707 .41375 m
.61837 .4312 L
s
.135 .206 .453 r
.62057 .41959 m .61953 .43053 L .63263 .44594 L p F P
0 0 0 r
s
.33 .481 .895 r
.37943 .41959 m .38047 .43053 L .36737 .44594 L p F P
0 0 0 r
s
.332 .486 .914 r
.38047 .43053 m .37943 .41959 L .39544 .40739 L p F P
0 0 0 r
s
.24 .35 .67 r
.38163 .4312 m
.40293 .41375 L
s
.33 .484 .918 r
.39544 .40739 m .39464 .39766 L .41314 .38947 L p F P
0 0 0 r
s
.33 .484 .918 r
.4126 .38129 m .41314 .38947 L .39464 .39766 L p F P
0 0 0 r
s
.203 .306 .632 r
.5874 .38129 m .58686 .38947 L .60536 .39766 L p F P
0 0 0 r
s
.203 .306 .632 r
.60456 .40739 m .60536 .39766 L .58686 .38947 L p F P
0 0 0 r
s
.173 .262 .553 r
.60536 .39766 m .60456 .40739 L .62057 .41959 L p F P
0 0 0 r
s
.332 .486 .914 r
.39464 .39766 m .39544 .40739 L .37943 .41959 L p F P
0 0 0 r
s
.052 .076 .18 r
.64788 .53803 m .64947 .52562 L .64638 .50655 L p F P
0 0 0 r
s
.028 .041 .084 r
.64947 .52562 m .64788 .53803 L .64741 .55658 L p F P
0 0 0 r
s
.26 .371 .651 r
.35212 .53803 m .35053 .52562 L .35362 .50655 L p F P
0 0 0 r
s
.203 .284 .476 r
.35053 .52562 m .35212 .53803 L .35259 .55658 L p F P
0 0 0 r
s
.24 .35 .67 r
.54623 .69075 m
.54525 .71183 L
s
.54525 .71183 m
.51534 .71745 L
s
.48466 .71745 m
.45475 .71183 L
s
.45377 .69075 m
.45475 .71183 L
s
.313 .46 .84 r
.63308 .61128 m .63182 .62152 L .62123 .63281 L p F P
0 0 0 r
s
.313 .46 .84 r
.62018 .64196 m .62123 .63281 L .63182 .62152 L p F P
0 0 0 r
s
.83 .24 .1 r
.62536 .63583 m
.62609 .64058 L
s
.092 .138 .333 r
.37982 .64196 m .37877 .63281 L .36818 .62152 L p F P
0 0 0 r
s
.83 .24 .1 r
.37391 .64058 m
.37464 .63583 L
s
.092 .138 .333 r
.36692 .61128 m .36818 .62152 L .37877 .63281 L p F P
0 0 0 r
s
.24 .35 .67 r
.38115 .64196 m
.38141 .64431 L
s
.61859 .64431 m
.61885 .64196 L
s
.324 .477 .912 r
.4126 .38129 m .41204 .37299 L .43276 .37138 L p F P
0 0 0 r
s
.324 .477 .912 r
.43244 .36497 m .43276 .37138 L .41204 .37299 L p F P
0 0 0 r
s
.24 .35 .67 r
.42642 .37282 m
.42795 .40016 L
s
.83 .24 .1 r
.41616 .36117 m
.41711 .371 L
s
.24 .35 .67 r
.42642 .37282 m
.45474 .36346 L
s
.228 .342 .695 r
.56756 .36497 m .56724 .37138 L .58796 .37299 L p F P
0 0 0 r
s
.83 .24 .1 r
.58239 .37624 m
.58274 .37259 L
s
.58289 .371 m
.58384 .36117 L
s
.228 .342 .695 r
.5874 .38129 m .58796 .37299 L .56724 .37138 L p F P
0 0 0 r
s
.24 .35 .67 r
.57205 .40016 m
.57358 .37282 L
s
.54526 .36346 m
.57358 .37282 L
s
.316 .466 .898 r
.43211 .35849 m .43177 .35194 L .45422 .35981 L p F P
0 0 0 r
s
.249 .372 .747 r
.56789 .35849 m .56823 .35194 L .54578 .35981 L p F P
0 0 0 r
s
.949 .289 .124 r
.54578 .35981 m .53924 .35981 L .55848 .35194 L p F P
0 0 0 r
s
.949 .289 .124 r
.55848 .35194 m .56823 .35194 L .54578 .35981 L p F P
0 0 0 r
s
.949 .289 .124 r
.53924 .35981 m .5327 .35981 L .54873 .35194 L p F P
0 0 0 r
s
.949 .289 .124 r
.54873 .35194 m .55848 .35194 L .53924 .35981 L p F P
0 0 0 r
s
.949 .289 .124 r
.5327 .35981 m .52616 .35981 L .53899 .35194 L p F P
0 0 0 r
s
.949 .289 .124 r
.53899 .35194 m .54873 .35194 L .5327 .35981 L p F P
0 0 0 r
s
.24 .35 .67 r
.54526 .36346 m
.54543 .35858 L
s
.949 .289 .124 r
.52616 .35981 m .51962 .35981 L .52924 .35194 L p F P
0 0 0 r
s
.949 .289 .124 r
.52924 .35194 m .53899 .35194 L .52616 .35981 L p F P
0 0 0 r
s
.949 .289 .124 r
.51962 .35981 m .51308 .35981 L .51949 .35194 L p F P
0 0 0 r
s
.949 .289 .124 r
.51949 .35194 m .52924 .35194 L .51962 .35981 L p F P
0 0 0 r
s
.949 .289 .124 r
.51308 .35981 m .50654 .35981 L .50975 .35194 L p F P
0 0 0 r
s
.949 .289 .124 r
.50975 .35194 m .51949 .35194 L .51308 .35981 L p F P
0 0 0 r
s
.949 .289 .124 r
.50654 .35981 m .5 .35981 L .5 .35194 L p F P
0 0 0 r
s
.949 .289 .124 r
.5 .35194 m .50975 .35194 L .50654 .35981 L p F P
0 0 0 r
s
.949 .289 .124 r
.5 .35981 m .49346 .35981 L .49025 .35194 L p F P
0 0 0 r
s
.949 .289 .124 r
.49025 .35194 m .5 .35194 L .5 .35981 L p F P
0 0 0 r
s
.949 .289 .124 r
.49346 .35981 m .48692 .35981 L .48051 .35194 L p F P
0 0 0 r
s
.24 .35 .67 r
.48471 .3571 m
.48473 .35871 L
s
.949 .289 .124 r
.48051 .35194 m .49025 .35194 L .49346 .35981 L p F P
0 0 0 r
s
.949 .289 .124 r
.48692 .35981 m .48038 .35981 L .47076 .35194 L p F P
0 0 0 r
s
.949 .289 .124 r
.47076 .35194 m .48051 .35194 L .48692 .35981 L p F P
0 0 0 r
s
.949 .289 .124 r
.48038 .35981 m .47384 .35981 L .46101 .35194 L p F P
0 0 0 r
s
.949 .289 .124 r
.46101 .35194 m .47076 .35194 L .48038 .35981 L p F P
0 0 0 r
s
.949 .289 .124 r
.47384 .35981 m .4673 .35981 L .45127 .35194 L p F P
0 0 0 r
s
.949 .289 .124 r
.45127 .35194 m .46101 .35194 L .47384 .35981 L p F P
0 0 0 r
s
.949 .289 .124 r
.4673 .35981 m .46076 .35981 L .44152 .35194 L p F P
0 0 0 r
s
.949 .289 .124 r
.44152 .35194 m .45127 .35194 L .4673 .35981 L p F P
0 0 0 r
s
.949 .289 .124 r
.46076 .35981 m .45422 .35981 L .43177 .35194 L p F P
0 0 0 r
s
.949 .289 .124 r
.43177 .35194 m .44152 .35194 L .46076 .35981 L p F P
0 0 0 r
s
.24 .35 .67 r
.45457 .35858 m
.45474 .36346 L
s
.83 .24 .1 r
.24849 .36117 m
.20657 .36117 L
s
.29041 .36117 m
.24849 .36117 L
s
.33233 .36117 m
.29041 .36117 L
s
.37425 .36117 m
.33233 .36117 L
s
.41616 .36117 m
.37425 .36117 L
s
.4508 .36117 m
.45808 .36117 L
s
.41616 .36117 m
.43224 .36117 L
s
.5 .36117 m
.45808 .36117 L
s
.54192 .36117 m
.5 .36117 L
s
.54192 .36117 m
.5492 .36117 L
s
.56776 .36117 m
.58384 .36117 L
s
.62575 .36117 m
.58384 .36117 L
s
.66767 .36117 m
.62575 .36117 L
s
.70959 .36117 m
.66767 .36117 L
s
.75151 .36117 m
.70959 .36117 L
s
.79343 .36117 m
.75151 .36117 L
s
.24849 .36117 m
.24367 .35155 L
s
.20094 .35155 m
.20657 .36117 L
s
.29041 .36117 m
.28639 .35155 L
s
.33233 .36117 m
.32911 .35155 L
s
.37425 .36117 m
.37183 .35155 L
s
.62575 .36117 m
.62817 .35155 L
s
.66767 .36117 m
.67089 .35155 L
s
.70959 .36117 m
.71361 .35155 L
s
.75151 .36117 m
.75633 .35155 L
s
.79343 .36117 m
.79906 .35155 L
s
.072 .105 .259 r
.64638 .50655 m .64794 .49394 L .64129 .47539 L p F P
0 0 0 r
s
.052 .076 .18 r
.64794 .49394 m .64638 .50655 L .64947 .52562 L p F P
0 0 0 r
s
.26 .371 .651 r
.35206 .49394 m .35362 .50655 L .35053 .52562 L p F P
0 0 0 r
s
.298 .43 .775 r
.35362 .50655 m .35206 .49394 L .35871 .47539 L p F P
0 0 0 r
s
.24 .35 .67 r
.51568 .69643 m
.51534 .71745 L
s
.51534 .71745 m
.48466 .71745 L
s
.48432 .69643 m
.48466 .71745 L
s
.304 .069 .029 r
.39343 .64919 m .40866 .64919 L .39699 .64196 L p F P
0 0 0 r
s
.304 .069 .029 r
.39699 .64196 m .37982 .64196 L .39343 .64919 L p F P
0 0 0 r
s
.304 .069 .029 r
.40866 .64919 m .42388 .64919 L .41416 .64196 L p F P
0 0 0 r
s
.304 .069 .029 r
.41416 .64196 m .39699 .64196 L .40866 .64919 L p F P
0 0 0 r
s
.304 .069 .029 r
.42388 .64919 m .4391 .64919 L .43133 .64196 L p F P
0 0 0 r
s
.304 .069 .029 r
.43133 .64196 m .41416 .64196 L .42388 .64919 L p F P
0 0 0 r
s
.304 .069 .029 r
.4391 .64919 m .45433 .64919 L .44849 .64196 L p F P
0 0 0 r
s
.304 .069 .029 r
.44849 .64196 m .43133 .64196 L .4391 .64919 L p F P
0 0 0 r
s
.304 .069 .029 r
.45433 .64919 m .46955 .64919 L .46566 .64196 L p F P
0 0 0 r
s
.304 .069 .029 r
.46566 .64196 m .44849 .64196 L .45433 .64919 L p F P
0 0 0 r
s
.304 .069 .029 r
.46955 .64919 m .48478 .64919 L .48283 .64196 L p F P
0 0 0 r
s
.304 .069 .029 r
.48283 .64196 m .46566 .64196 L .46955 .64919 L p F P
0 0 0 r
s
.304 .069 .029 r
.48478 .64919 m .5 .64919 L .5 .64196 L p F P
0 0 0 r
s
.304 .069 .029 r
.5 .64196 m .48283 .64196 L .48478 .64919 L p F P
0 0 0 r
s
.304 .069 .029 r
.5 .64919 m .51522 .64919 L .51717 .64196 L p F P
0 0 0 r
s
.304 .069 .029 r
.51717 .64196 m .5 .64196 L .5 .64919 L p F P
0 0 0 r
s
.304 .069 .029 r
.51522 .64919 m .53045 .64919 L .53434 .64196 L p F P
0 0 0 r
s
.304 .069 .029 r
.53434 .64196 m .51717 .64196 L .51522 .64919 L p F P
0 0 0 r
s
.304 .069 .029 r
.53045 .64919 m .54567 .64919 L .55151 .64196 L p F P
0 0 0 r
s
.304 .069 .029 r
.55151 .64196 m .53434 .64196 L .53045 .64919 L p F P
0 0 0 r
s
.304 .069 .029 r
.54567 .64919 m .5609 .64919 L .56867 .64196 L p F P
0 0 0 r
s
.304 .069 .029 r
.56867 .64196 m .55151 .64196 L .54567 .64919 L p F P
0 0 0 r
s
.304 .069 .029 r
.5609 .64919 m .57612 .64919 L .58584 .64196 L p F P
0 0 0 r
s
.304 .069 .029 r
.58584 .64196 m .56867 .64196 L .5609 .64919 L p F P
0 0 0 r
s
.304 .069 .029 r
.57612 .64919 m .59134 .64919 L .60301 .64196 L p F P
0 0 0 r
s
.304 .069 .029 r
.60301 .64196 m .58584 .64196 L .57612 .64919 L p F P
0 0 0 r
s
.304 .069 .029 r
.59134 .64919 m .60657 .64919 L .62018 .64196 L p F P
0 0 0 r
s
.304 .069 .029 r
.62018 .64196 m .60301 .64196 L .59134 .64919 L p F P
0 0 0 r
s
.329 .485 .9 r
.62123 .63281 m .62018 .64196 L .60657 .64919 L p F P
0 0 0 r
s
.24 .35 .67 r
.59893 .66394 m
.61859 .64431 L
s
.124 .196 .438 r
.37877 .63281 m .37982 .64196 L .39343 .64919 L p F P
0 0 0 r
s
.24 .35 .67 r
.38141 .64431 m
.40107 .66394 L
s
.096 .145 .343 r
.64129 .47539 m .64274 .4629 L .63263 .44594 L p F P
0 0 0 r
s
.072 .105 .259 r
.64274 .4629 m .64129 .47539 L .64794 .49394 L p F P
0 0 0 r
s
.298 .43 .775 r
.35726 .4629 m .35871 .47539 L .35206 .49394 L p F P
0 0 0 r
s
.32 .464 .852 r
.35871 .47539 m .35726 .4629 L .36737 .44594 L p F P
0 0 0 r
s
.83 .24 .1 r
.24294 .64935 m
.24782 .64058 L
s
.20579 .64058 m
.20009 .64935 L
s
.24782 .64058 m
.20579 .64058 L
s
.28578 .64935 m
.28985 .64058 L
s
.28985 .64058 m
.24782 .64058 L
s
.32862 .64935 m
.33188 .64058 L
s
.33188 .64058 m
.28985 .64058 L
s
.37147 .64935 m
.37391 .64058 L
s
.33188 .64058 m
.37391 .64058 L
s
.37391 .64058 m
.37904 .64058 L
s
.37904 .64058 m
.37925 .64058 L
s
.38573 .64058 m
.41594 .64058 L
s
.45797 .64058 m
.41594 .64058 L
s
.5 .64058 m
.45797 .64058 L
s
.54203 .64058 m
.5 .64058 L
s
.58406 .64058 m
.54203 .64058 L
s
.62609 .64058 m
.62853 .64935 L
s
.62096 .64058 m
.62609 .64058 L
s
.62075 .64058 m
.62096 .64058 L
s
.58406 .64058 m
.61427 .64058 L
s
.67138 .64935 m
.66812 .64058 L
s
.62609 .64058 m
.66812 .64058 L
s
.71422 .64935 m
.71015 .64058 L
s
.71015 .64058 m
.66812 .64058 L
s
.75706 .64935 m
.75218 .64058 L
s
.75218 .64058 m
.71015 .64058 L
s
.79991 .64935 m
.79421 .64058 L
s
.79421 .64058 m
.75218 .64058 L
s
.33 .484 .918 r
.39464 .39766 m .39384 .38777 L .4126 .38129 L p F P
0 0 0 r
s
.33 .484 .918 r
.41204 .37299 m .4126 .38129 L .39384 .38777 L p F P
0 0 0 r
s
.203 .306 .632 r
.58796 .37299 m .5874 .38129 L .60616 .38777 L p F P
0 0 0 r
s
.203 .306 .632 r
.60536 .39766 m .60616 .38777 L .5874 .38129 L p F P
0 0 0 r
s
.324 .477 .912 r
.41204 .37299 m .41148 .3646 L .43244 .36497 L p F P
0 0 0 r
s
.324 .477 .912 r
.43211 .35849 m .43244 .36497 L .41148 .3646 L p F P
0 0 0 r
s
.228 .342 .695 r
.56789 .35849 m .56756 .36497 L .58852 .3646 L p F P
0 0 0 r
s
.228 .342 .695 r
.58796 .37299 m .58852 .3646 L .56756 .36497 L p F P
0 0 0 r
s
.135 .206 .453 r
.63263 .44594 m .63391 .43394 L .62057 .41959 L p F P
0 0 0 r
s
.096 .145 .343 r
.63391 .43394 m .63263 .44594 L .64274 .4629 L p F P
0 0 0 r
s
.24 .35 .67 r
.63221 .47772 m
.63502 .45191 L
s
.32 .464 .852 r
.36609 .43394 m .36737 .44594 L .35726 .4629 L p F P
0 0 0 r
s
.24 .35 .67 r
.36498 .45191 m
.36779 .47772 L
s
.33 .481 .895 r
.36737 .44594 m .36609 .43394 L .37943 .41959 L p F P
0 0 0 r
s
.332 .486 .914 r
.37943 .41959 m .37838 .40846 L .39464 .39766 L p F P
0 0 0 r
s
.332 .486 .914 r
.39384 .38777 m .39464 .39766 L .37838 .40846 L p F P
0 0 0 r
s
.173 .262 .553 r
.60616 .38777 m .60536 .39766 L .62162 .40846 L p F P
0 0 0 r
s
.173 .262 .553 r
.62057 .41959 m .62162 .40846 L .60536 .39766 L p F P
0 0 0 r
s
.135 .206 .453 r
.62162 .40846 m .62057 .41959 L .63391 .43394 L p F P
0 0 0 r
s
.24 .35 .67 r
.61837 .4312 m
.63502 .45191 L
s
.33 .481 .895 r
.37838 .40846 m .37943 .41959 L .36609 .43394 L p F P
0 0 0 r
s
.24 .35 .67 r
.36498 .45191 m
.38163 .4312 L
s
.23 .333 .575 r
.64188 .58552 m .64334 .57412 L .64741 .55658 L p F P
0 0 0 r
s
.281 .411 .734 r
.64334 .57412 m .64188 .58552 L .63437 .60084 L p F P
0 0 0 r
s
.281 .411 .734 r
.63308 .61128 m .63437 .60084 L .64188 .58552 L p F P
0 0 0 r
s
.068 .1 .244 r
.36692 .61128 m .36563 .60084 L .35812 .58552 L p F P
0 0 0 r
s
.068 .1 .244 r
.35666 .57412 m .35812 .58552 L .36563 .60084 L p F P
0 0 0 r
s
.24 .35 .67 r
.35661 .57464 m
.3568 .57521 L
s
.045 .066 .152 r
.35812 .58552 m .35666 .57412 L .35259 .55658 L p F P
0 0 0 r
s
.028 .041 .084 r
.64741 .55658 m .64899 .54442 L .64947 .52562 L p F P
0 0 0 r
s
.23 .333 .575 r
.64899 .54442 m .64741 .55658 L .64334 .57412 L p F P
0 0 0 r
s
.203 .284 .476 r
.35259 .55658 m .35101 .54442 L .35053 .52562 L p F P
0 0 0 r
s
.045 .066 .152 r
.35101 .54442 m .35259 .55658 L .35666 .57412 L p F P
0 0 0 r
s
.24 .35 .67 r
.42556 .67971 m
.40107 .66394 L
s
.59893 .66394 m
.57444 .67971 L
s
.313 .46 .84 r
.63437 .60084 m .63308 .61128 L .6223 .62349 L p F P
0 0 0 r
s
.313 .46 .84 r
.62123 .63281 m .6223 .62349 L .63308 .61128 L p F P
0 0 0 r
s
.092 .138 .333 r
.37877 .63281 m .3777 .62349 L .36692 .61128 L p F P
0 0 0 r
s
.092 .138 .333 r
.36563 .60084 m .36692 .61128 L .3777 .62349 L p F P
0 0 0 r
s
.052 .076 .18 r
.64947 .52562 m .6511 .51295 L .64794 .49394 L p F P
0 0 0 r
s
.24 .35 .67 r
.64492 .54969 m
.64801 .52537 L
s
.64311 .50075 m
.64801 .52537 L
s
.028 .041 .084 r
.6511 .51295 m .64947 .52562 L .64899 .54442 L p F P
0 0 0 r
s
.26 .371 .651 r
.35053 .52562 m .3489 .51295 L .35206 .49394 L p F P
0 0 0 r
s
.24 .35 .67 r
.35199 .52537 m
.35508 .54969 L
s
.35199 .52537 m
.35689 .50075 L
s
.203 .284 .476 r
.3489 .51295 m .35053 .52562 L .35101 .54442 L p F P
0 0 0 r
s
.324 .477 .912 r
.41148 .3646 m .41092 .35609 L .43211 .35849 L p F P
0 0 0 r
s
.324 .477 .912 r
.43177 .35194 m .43211 .35849 L .41092 .35609 L p F P
0 0 0 r
s
.228 .342 .695 r
.56823 .35194 m .56789 .35849 L .58908 .35609 L p F P
0 0 0 r
s
.83 .24 .1 r
.58384 .36117 m
.5846 .3566 L
s
.228 .342 .695 r
.58852 .3646 m .58908 .35609 L .56789 .35849 L p F P
0 0 0 r
s
.33 .484 .918 r
.39384 .38777 m .39302 .37774 L .41204 .37299 L p F P
0 0 0 r
s
.24 .35 .67 r
.40086 .38651 m
.40293 .41375 L
s
.33 .484 .918 r
.41148 .3646 m .41204 .37299 L .39302 .37774 L p F P
0 0 0 r
s
.24 .35 .67 r
.40086 .38651 m
.42642 .37282 L
s
.203 .306 .632 r
.58852 .3646 m .58796 .37299 L .60698 .37774 L p F P
0 0 0 r
s
.203 .306 .632 r
.60616 .38777 m .60698 .37774 L .58796 .37299 L p F P
0 0 0 r
s
.24 .35 .67 r
.57358 .37282 m
.59914 .38651 L
s
.59707 .41375 m
.59914 .38651 L
s
.072 .105 .259 r
.64794 .49394 m .64953 .48105 L .64274 .4629 L p F P
0 0 0 r
s
.052 .076 .18 r
.64953 .48105 m .64794 .49394 L .6511 .51295 L p F P
0 0 0 r
s
.26 .371 .651 r
.35047 .48105 m .35206 .49394 L .3489 .51295 L p F P
0 0 0 r
s
.298 .43 .775 r
.35206 .49394 m .35047 .48105 L .35726 .4629 L p F P
0 0 0 r
s
.329 .485 .9 r
.6223 .62349 m .62123 .63281 L .60739 .64114 L p F P
0 0 0 r
s
.24 .35 .67 r
.6197 .63452 m
.61979 .63367 L
s
.329 .485 .9 r
.60657 .64919 m .60739 .64114 L .62123 .63281 L p F P
0 0 0 r
s
.124 .196 .438 r
.39343 .64919 m .39261 .64114 L .37877 .63281 L p F P
0 0 0 r
s
.124 .196 .438 r
.3777 .62349 m .37877 .63281 L .39261 .64114 L p F P
0 0 0 r
s
.096 .145 .343 r
.64274 .4629 m .64422 .45015 L .63391 .43394 L p F P
0 0 0 r
s
.072 .105 .259 r
.64422 .45015 m .64274 .4629 L .64953 .48105 L p F P
0 0 0 r
s
.24 .35 .67 r
.63502 .45191 m
.64619 .47514 L
s
.64311 .50075 m
.64619 .47514 L
s
.298 .43 .775 r
.35578 .45015 m .35726 .4629 L .35047 .48105 L p F P
0 0 0 r
s
.24 .35 .67 r
.35381 .47514 m
.35689 .50075 L
s
.32 .464 .852 r
.35726 .4629 m .35578 .45015 L .36609 .43394 L p F P
0 0 0 r
s
.24 .35 .67 r
.35381 .47514 m
.36498 .45191 L
s
.332 .486 .914 r
.37838 .40846 m .3773 .39713 L .39384 .38777 L p F P
0 0 0 r
s
.24 .35 .67 r
.37908 .40409 m
.38163 .4312 L
s
.332 .486 .914 r
.39302 .37774 m .39384 .38777 L .3773 .39713 L p F P
0 0 0 r
s
.24 .35 .67 r
.37908 .40409 m
.40086 .38651 L
s
.173 .262 .553 r
.60698 .37774 m .60616 .38777 L .6227 .39713 L p F P
0 0 0 r
s
.173 .262 .553 r
.62162 .40846 m .6227 .39713 L .60616 .38777 L p F P
0 0 0 r
s
.24 .35 .67 r
.59914 .38651 m
.62092 .40409 L
s
.61837 .4312 m
.62092 .40409 L
s
.324 .477 .912 r
.41092 .35609 m .41034 .34748 L .43177 .35194 L p F P
0 0 0 r
s
.228 .342 .695 r
.58908 .35609 m .58966 .34748 L .56823 .35194 L p F P
0 0 0 r
s
.831 .26 .112 r
.56823 .35194 m .55848 .35194 L .57685 .34748 L p F P
0 0 0 r
s
.831 .26 .112 r
.57685 .34748 m .58966 .34748 L .56823 .35194 L p F P
0 0 0 r
s
.831 .26 .112 r
.55848 .35194 m .54873 .35194 L .56404 .34748 L p F P
0 0 0 r
s
.831 .26 .112 r
.56404 .34748 m .57685 .34748 L .55848 .35194 L p F P
0 0 0 r
s
.24 .35 .67 r
.57358 .37282 m
.57484 .35013 L
s
.57499 .34748 m
.57517 .3443 L
s
.831 .26 .112 r
.54873 .35194 m .53899 .35194 L .55123 .34748 L p F P
0 0 0 r
s
.831 .26 .112 r
.55123 .34748 m .56404 .34748 L .54873 .35194 L p F P
0 0 0 r
s
.831 .26 .112 r
.53899 .35194 m .52924 .35194 L .53843 .34748 L p F P
0 0 0 r
s
.831 .26 .112 r
.53843 .34748 m .55123 .34748 L .53899 .35194 L p F P
0 0 0 r
s
.24 .35 .67 r
.5458 .34748 m
.54623 .33487 L
s
.83 .24 .1 r
.54192 .36117 m
.54272 .35155 L
s
.831 .26 .112 r
.52924 .35194 m .51949 .35194 L .52562 .34748 L p F P
0 0 0 r
s
.831 .26 .112 r
.52562 .34748 m .53843 .34748 L .52924 .35194 L p F P
0 0 0 r
s
.831 .26 .112 r
.51949 .35194 m .50975 .35194 L .51281 .34748 L p F P
0 0 0 r
s
.831 .26 .112 r
.51281 .34748 m .52562 .34748 L .51949 .35194 L p F P
0 0 0 r
s
.24 .35 .67 r
.5154 .34748 m
.5156 .33009 L
s
.831 .26 .112 r
.50975 .35194 m .5 .35194 L .5 .34748 L p F P
0 0 0 r
s
.831 .26 .112 r
.5 .34748 m .51281 .34748 L .50975 .35194 L p F P
0 0 0 r
s
.831 .26 .112 r
.5 .35194 m .49025 .35194 L .48719 .34748 L p F P
0 0 0 r
s
.831 .26 .112 r
.48719 .34748 m .5 .34748 L .5 .35194 L p F P
0 0 0 r
s
.83 .24 .1 r
.5 .35155 m
.5 .36117 L
s
.831 .26 .112 r
.49025 .35194 m .48051 .35194 L .47438 .34748 L p F P
0 0 0 r
s
.831 .26 .112 r
.47438 .34748 m .48719 .34748 L .49025 .35194 L p F P
0 0 0 r
s
.24 .35 .67 r
.4844 .33009 m
.4846 .34748 L
s
.831 .26 .112 r
.48051 .35194 m .47076 .35194 L .46157 .34748 L p F P
0 0 0 r
s
.831 .26 .112 r
.46157 .34748 m .47438 .34748 L .48051 .35194 L p F P
0 0 0 r
s
.831 .26 .112 r
.47076 .35194 m .46101 .35194 L .44877 .34748 L p F P
0 0 0 r
s
.24 .35 .67 r
.45426 .34948 m
.45435 .35194 L
s
.831 .26 .112 r
.44877 .34748 m .46157 .34748 L .47076 .35194 L p F P
0 0 0 r
s
.831 .26 .112 r
.46101 .35194 m .45127 .35194 L .43596 .34748 L p F P
0 0 0 r
s
.831 .26 .112 r
.43596 .34748 m .44877 .34748 L .46101 .35194 L p F P
0 0 0 r
s
.24 .35 .67 r
.45377 .33487 m
.4542 .34748 L
s
.83 .24 .1 r
.45728 .35155 m
.45808 .36117 L
s
.831 .26 .112 r
.45127 .35194 m .44152 .35194 L .42315 .34748 L p F P
0 0 0 r
s
.831 .26 .112 r
.42315 .34748 m .43596 .34748 L .45127 .35194 L p F P
0 0 0 r
s
.831 .26 .112 r
.44152 .35194 m .43177 .35194 L .41034 .34748 L p F P
0 0 0 r
s
.831 .26 .112 r
.41034 .34748 m .42315 .34748 L .44152 .35194 L p F P
0 0 0 r
s
.24 .35 .67 r
.42483 .3443 m
.42501 .34748 L
s
.42516 .35013 m
.42642 .37282 L
s
.135 .206 .453 r
.63391 .43394 m .63522 .4217 L .62162 .40846 L p F P
0 0 0 r
s
.096 .145 .343 r
.63522 .4217 m .63391 .43394 L .64422 .45015 L p F P
0 0 0 r
s
.32 .464 .852 r
.36478 .4217 m .36609 .43394 L .35578 .45015 L p F P
0 0 0 r
s
.33 .481 .895 r
.36609 .43394 m .36478 .4217 L .37838 .40846 L p F P
0 0 0 r
s
.135 .206 .453 r
.6227 .39713 m .62162 .40846 L .63522 .4217 L p F P
0 0 0 r
s
.33 .481 .895 r
.3773 .39713 m .37838 .40846 L .36478 .4217 L p F P
0 0 0 r
s
.24 .35 .67 r
.57607 .65756 m
.57444 .67971 L
s
.57444 .67971 m
.54623 .69075 L
s
.45377 .69075 m
.42556 .67971 L
s
.42393 .65756 m
.42556 .67971 L
s
.33 .484 .918 r
.39302 .37774 m .39219 .36755 L .41148 .3646 L p F P
0 0 0 r
s
.33 .484 .918 r
.41092 .35609 m .41148 .3646 L .39219 .36755 L p F P
0 0 0 r
s
.203 .306 .632 r
.58908 .35609 m .58852 .3646 L .60781 .36755 L p F P
0 0 0 r
s
.203 .306 .632 r
.60698 .37774 m .60781 .36755 L .58852 .3646 L p F P
0 0 0 r
s
.213 .05 .021 r
.41008 .65296 m .42292 .65296 L .40866 .64919 L p F P
0 0 0 r
s
.213 .05 .021 r
.40866 .64919 m .39343 .64919 L .41008 .65296 L p F P
0 0 0 r
s
.213 .05 .021 r
.42292 .65296 m .43577 .65296 L .42388 .64919 L p F P
0 0 0 r
s
.213 .05 .021 r
.42388 .64919 m .40866 .64919 L .42292 .65296 L p F P
0 0 0 r
s
.83 .24 .1 r
.41431 .64935 m
.41594 .64058 L
s
.213 .05 .021 r
.43577 .65296 m .44862 .65296 L .4391 .64919 L p F P
0 0 0 r
s
.213 .05 .021 r
.4391 .64919 m .42388 .64919 L .43577 .65296 L p F P
0 0 0 r
s
.213 .05 .021 r
.44862 .65296 m .46146 .65296 L .45433 .64919 L p F P
0 0 0 r
s
.213 .05 .021 r
.45433 .64919 m .4391 .64919 L .44862 .65296 L p F P
0 0 0 r
s
.213 .05 .021 r
.46146 .65296 m .47431 .65296 L .46955 .64919 L p F P
0 0 0 r
s
.213 .05 .021 r
.46955 .64919 m .45433 .64919 L .46146 .65296 L p F P
0 0 0 r
s
.83 .24 .1 r
.45716 .64935 m
.45797 .64058 L
s
.213 .05 .021 r
.47431 .65296 m .48715 .65296 L .48478 .64919 L p F P
0 0 0 r
s
.213 .05 .021 r
.48478 .64919 m .46955 .64919 L .47431 .65296 L p F P
0 0 0 r
s
.213 .05 .021 r
.48715 .65296 m .5 .65296 L .5 .64919 L p F P
0 0 0 r
s
.213 .05 .021 r
.5 .64919 m .48478 .64919 L .48715 .65296 L p F P
0 0 0 r
s
.213 .05 .021 r
.5 .65296 m .51285 .65296 L .51522 .64919 L p F P
0 0 0 r
s
.213 .05 .021 r
.51522 .64919 m .5 .64919 L .5 .65296 L p F P
0 0 0 r
s
.83 .24 .1 r
.5 .64058 m
.5 .64935 L
s
.213 .05 .021 r
.51285 .65296 m .52569 .65296 L .53045 .64919 L p F P
0 0 0 r
s
.213 .05 .021 r
.53045 .64919 m .51522 .64919 L .51285 .65296 L p F P
0 0 0 r
s
.213 .05 .021 r
.52569 .65296 m .53854 .65296 L .54567 .64919 L p F P
0 0 0 r
s
.213 .05 .021 r
.54567 .64919 m .53045 .64919 L .52569 .65296 L p F P
0 0 0 r
s
.213 .05 .021 r
.53854 .65296 m .55138 .65296 L .5609 .64919 L p F P
0 0 0 r
s
.213 .05 .021 r
.5609 .64919 m .54567 .64919 L .53854 .65296 L p F P
0 0 0 r
s
.83 .24 .1 r
.54203 .64058 m
.54284 .64935 L
s
.213 .05 .021 r
.55138 .65296 m .56423 .65296 L .57612 .64919 L p F P
0 0 0 r
s
.213 .05 .021 r
.57612 .64919 m .5609 .64919 L .55138 .65296 L p F P
0 0 0 r
s
.213 .05 .021 r
.56423 .65296 m .57708 .65296 L .59134 .64919 L p F P
0 0 0 r
s
.213 .05 .021 r
.59134 .64919 m .57612 .64919 L .56423 .65296 L p F P
0 0 0 r
s
.213 .05 .021 r
.57708 .65296 m .58992 .65296 L .60657 .64919 L p F P
0 0 0 r
s
.213 .05 .021 r
.60657 .64919 m .59134 .64919 L .57708 .65296 L p F P
0 0 0 r
s
.83 .24 .1 r
.58406 .64058 m
.58569 .64935 L
s
.333 .493 .926 r
.60739 .64114 m .60657 .64919 L .58992 .65296 L p F P
0 0 0 r
s
.24 .35 .67 r
.59893 .66394 m
.60018 .65096 L
s
.60018 .65096 m
.60022 .65063 L
s
.169 .262 .556 r
.39261 .64114 m .39343 .64919 L .41008 .65296 L p F P
0 0 0 r
s
.24 .35 .67 r
.39978 .65063 m
.39982 .65096 L
s
.39982 .65096 m
.40107 .66394 L
s
.23 .333 .575 r
.64334 .57412 m .64484 .56248 L .64899 .54442 L p F P
0 0 0 r
s
.281 .411 .734 r
.64484 .56248 m .64334 .57412 L .63568 .59019 L p F P
0 0 0 r
s
.281 .411 .734 r
.63437 .60084 m .63568 .59019 L .64334 .57412 L p F P
0 0 0 r
s
.068 .1 .244 r
.36563 .60084 m .36432 .59019 L .35666 .57412 L p F P
0 0 0 r
s
.068 .1 .244 r
.35516 .56248 m .35666 .57412 L .36432 .59019 L p F P
0 0 0 r
s
.045 .066 .152 r
.35666 .57412 m .35516 .56248 L .35101 .54442 L p F P
0 0 0 r
s
.24 .35 .67 r
.45377 .33487 m
.4844 .33009 L
s
.48406 .30021 m
.4844 .33009 L
s
.4844 .33009 m
.5156 .33009 L
s
.51594 .30021 m
.5156 .33009 L
s
.5156 .33009 m
.54623 .33487 L
s
.313 .46 .84 r
.63568 .59019 m .63437 .60084 L .62338 .61402 L p F P
0 0 0 r
s
.313 .46 .84 r
.6223 .62349 m .62338 .61402 L .63437 .60084 L p F P
0 0 0 r
s
.092 .138 .333 r
.3777 .62349 m .37662 .61402 L .36563 .60084 L p F P
0 0 0 r
s
.24 .35 .67 r
.36562 .60068 m
.36596 .60123 L
s
.092 .138 .333 r
.36432 .59019 m .36563 .60084 L .37662 .61402 L p F P
0 0 0 r
s
.028 .041 .084 r
.64899 .54442 m .6506 .53199 L .6511 .51295 L p F P
0 0 0 r
s
.23 .333 .575 r
.6506 .53199 m .64899 .54442 L .64484 .56248 L p F P
0 0 0 r
s
.24 .35 .67 r
.64519 .56061 m
.64648 .55058 L
s
.64648 .55058 m
.64801 .52537 L
s
.203 .284 .476 r
.35101 .54442 m .3494 .53199 L .3489 .51295 L p F P
0 0 0 r
s
.045 .066 .152 r
.3494 .53199 m .35101 .54442 L .35516 .56248 L p F P
0 0 0 r
s
.24 .35 .67 r
.35199 .52537 m
.35352 .55058 L
s
.35352 .55058 m
.35481 .56061 L
s
.83 .24 .1 r
.24367 .35155 m
.20094 .35155 L
s
.28639 .35155 m
.24367 .35155 L
s
.32911 .35155 m
.28639 .35155 L
s
.37183 .35155 m
.32911 .35155 L
s
.37183 .35155 m
.41061 .35155 L
s
.42314 .35155 m
.45728 .35155 L
s
.45728 .35155 m
.5 .35155 L
s
.5 .35155 m
.54272 .35155 L
s
.54272 .35155 m
.57686 .35155 L
s
.58939 .35155 m
.62817 .35155 L
s
.67089 .35155 m
.62817 .35155 L
s
.71361 .35155 m
.67089 .35155 L
s
.75633 .35155 m
.71361 .35155 L
s
.79906 .35155 m
.75633 .35155 L
s
.24367 .35155 m
.23852 .34808 L
s
.19494 .34808 m
.20094 .35155 L
s
.28639 .35155 m
.2821 .34808 L
s
.32911 .35155 m
.32568 .34808 L
s
.37183 .35155 m
.36926 .34808 L
s
.41284 .34808 m
.41407 .35057 L
s
.45642 .34808 m
.45728 .35155 L
s
.5 .34808 m
.5 .35155 L
s
.54272 .35155 m
.54358 .34808 L
s
.58593 .35057 m
.58716 .34808 L
s
.62817 .35155 m
.63074 .34808 L
s
.67089 .35155 m
.67432 .34808 L
s
.71361 .35155 m
.7179 .34808 L
s
.75633 .35155 m
.76148 .34808 L
s
.79906 .35155 m
.80506 .34808 L
s
.052 .076 .18 r
.6511 .51295 m .65276 .5 L .64953 .48105 L p F P
0 0 0 r
s
.028 .041 .084 r
.65276 .5 m .6511 .51295 L .6506 .53199 L p F P
0 0 0 r
s
.26 .371 .651 r
.3489 .51295 m .34724 .5 L .35047 .48105 L p F P
0 0 0 r
s
.203 .284 .476 r
.34724 .5 m .3489 .51295 L .3494 .53199 L p F P
0 0 0 r
s
.24 .35 .67 r
.54724 .66874 m
.54623 .69075 L
s
.54623 .69075 m
.51568 .69643 L
s
.48432 .69643 m
.45377 .69075 L
s
.45276 .66874 m
.45377 .69075 L
s
.42483 .3443 m
.45377 .33487 L
s
.45275 .30502 m
.45377 .33487 L
s
.54725 .30502 m
.54623 .33487 L
s
.54623 .33487 m
.57517 .3443 L
s
.329 .485 .9 r
.62338 .61402 m .6223 .62349 L .60823 .63297 L p F P
0 0 0 r
s
.24 .35 .67 r
.62074 .62534 m
.62083 .62448 L
s
.329 .485 .9 r
.60739 .64114 m .60823 .63297 L .6223 .62349 L p F P
0 0 0 r
s
.124 .196 .438 r
.39261 .64114 m .39177 .63297 L .3777 .62349 L p F P
0 0 0 r
s
.124 .196 .438 r
.37662 .61402 m .3777 .62349 L .39177 .63297 L p F P
0 0 0 r
s
.332 .486 .914 r
.3773 .39713 m .37621 .38561 L .39302 .37774 L p F P
0 0 0 r
s
.332 .486 .914 r
.39219 .36755 m .39302 .37774 L .37621 .38561 L p F P
0 0 0 r
s
.173 .262 .553 r
.60781 .36755 m .60698 .37774 L .62379 .38561 L p F P
0 0 0 r
s
.173 .262 .553 r
.6227 .39713 m .62379 .38561 L .60698 .37774 L p F P
0 0 0 r
s
.072 .105 .259 r
.64953 .48105 m .65115 .46789 L .64422 .45015 L p F P
0 0 0 r
s
.052 .076 .18 r
.65115 .46789 m .64953 .48105 L .65276 .5 L p F P
0 0 0 r
s
.26 .371 .651 r
.34885 .46789 m .35047 .48105 L .34724 .5 L p F P
0 0 0 r
s
.298 .43 .775 r
.35047 .48105 m .34885 .46789 L .35578 .45015 L p F P
0 0 0 r
s
.83 .24 .1 r
.23776 .65188 m
.24294 .64935 L
s
.20009 .64935 m
.19405 .65188 L
s
.24294 .64935 m
.20009 .64935 L
s
.28147 .65188 m
.28578 .64935 L
s
.28578 .64935 m
.24294 .64935 L
s
.32517 .65188 m
.32862 .64935 L
s
.32862 .64935 m
.28578 .64935 L
s
.36888 .65188 m
.37147 .64935 L
s
.37147 .64935 m
.32862 .64935 L
s
.37147 .64935 m
.39797 .64935 L
s
.40474 .64935 m
.41431 .64935 L
s
.45629 .65188 m
.45716 .64935 L
s
.41431 .64935 m
.45716 .64935 L
s
.5 .64935 m
.5 .65188 L
s
.45716 .64935 m
.5 .64935 L
s
.54284 .64935 m
.54371 .65188 L
s
.5 .64935 m
.54284 .64935 L
s
.54284 .64935 m
.58569 .64935 L
s
.63112 .65188 m
.62853 .64935 L
s
.60203 .64935 m
.62853 .64935 L
s
.58569 .64935 m
.59526 .64935 L
s
.67483 .65188 m
.67138 .64935 L
s
.67138 .64935 m
.62853 .64935 L
s
.71853 .65188 m
.71422 .64935 L
s
.71422 .64935 m
.67138 .64935 L
s
.76224 .65188 m
.75706 .64935 L
s
.75706 .64935 m
.71422 .64935 L
s
.80595 .65188 m
.79991 .64935 L
s
.79991 .64935 m
.75706 .64935 L
s
.24 .35 .67 r
.51602 .67449 m
.51568 .69643 L
s
.51568 .69643 m
.48432 .69643 L
s
.48398 .67449 m
.48432 .69643 L
s
.33 .484 .918 r
.39219 .36755 m .39135 .3572 L .41092 .35609 L p F P
0 0 0 r
s
.24 .35 .67 r
.3987 .35809 m
.40086 .38651 L
s
.33 .484 .918 r
.41034 .34748 m .41092 .35609 L .39135 .3572 L p F P
0 0 0 r
s
.203 .306 .632 r
.58966 .34748 m .58908 .35609 L .60865 .3572 L p F P
0 0 0 r
s
.203 .306 .632 r
.60781 .36755 m .60865 .3572 L .58908 .35609 L p F P
0 0 0 r
s
.24 .35 .67 r
.59914 .38651 m
.6013 .35809 L
s
.096 .145 .343 r
.64422 .45015 m .64573 .43714 L .63522 .4217 L p F P
0 0 0 r
s
.072 .105 .259 r
.64573 .43714 m .64422 .45015 L .65115 .46789 L p F P
0 0 0 r
s
.298 .43 .775 r
.35427 .43714 m .35578 .45015 L .34885 .46789 L p F P
0 0 0 r
s
.32 .464 .852 r
.35578 .45015 m .35427 .43714 L .36478 .4217 L p F P
0 0 0 r
s
.135 .206 .453 r
.62379 .38561 m .6227 .39713 L .63654 .40923 L p F P
0 0 0 r
s
.135 .206 .453 r
.63522 .4217 m .63654 .40923 L .6227 .39713 L p F P
0 0 0 r
s
.33 .481 .895 r
.36478 .4217 m .36346 .40923 L .3773 .39713 L p F P
0 0 0 r
s
.33 .481 .895 r
.37621 .38561 m .3773 .39713 L .36346 .40923 L p F P
0 0 0 r
s
.096 .145 .343 r
.63654 .40923 m .63522 .4217 L .64573 .43714 L p F P
0 0 0 r
s
.24 .35 .67 r
.62092 .40409 m
.63795 .42498 L
s
.63502 .45191 m
.63795 .42498 L
s
.32 .464 .852 r
.36346 .40923 m .36478 .4217 L .35427 .43714 L p F P
0 0 0 r
s
.24 .35 .67 r
.36205 .42498 m
.37908 .40409 L
s
.36205 .42498 m
.36498 .45191 L
s
.4188 .34748 m
.42483 .3443 L
s
.42317 .31451 m
.42483 .3443 L
s
.57683 .31451 m
.57517 .3443 L
s
.57517 .3443 m
.5812 .34748 L
s
.333 .493 .926 r
.60823 .63297 m .60739 .64114 L .59051 .6462 L p F P
0 0 0 r
s
.333 .493 .926 r
.58992 .65296 m .59051 .6462 L .60739 .64114 L p F P
0 0 0 r
s
.169 .262 .556 r
.41008 .65296 m .40949 .6462 L .39261 .64114 L p F P
0 0 0 r
s
.169 .262 .556 r
.39177 .63297 m .39261 .64114 L .40949 .6462 L p F P
0 0 0 r
s
.281 .411 .734 r
.63568 .59019 m .63702 .57934 L .64484 .56248 L p F P
0 0 0 r
s
.313 .46 .84 r
.63702 .57934 m .63568 .59019 L .62449 .60437 L p F P
0 0 0 r
s
.313 .46 .84 r
.62338 .61402 m .62449 .60437 L .63568 .59019 L p F P
0 0 0 r
s
.092 .138 .333 r
.37662 .61402 m .37551 .60437 L .36432 .59019 L p F P
0 0 0 r
s
.092 .138 .333 r
.36298 .57934 m .36432 .59019 L .37551 .60437 L p F P
0 0 0 r
s
.068 .1 .244 r
.36432 .59019 m .36298 .57934 L .35516 .56248 L p F P
0 0 0 r
s
.23 .333 .575 r
.64484 .56248 m .64636 .55059 L .6506 .53199 L p F P
0 0 0 r
s
.281 .411 .734 r
.64636 .55059 m .64484 .56248 L .63702 .57934 L p F P
0 0 0 r
s
.068 .1 .244 r
.35364 .55059 m .35516 .56248 L .36298 .57934 L p F P
0 0 0 r
s
.24 .35 .67 r
.35352 .55058 m
.35371 .55115 L
s
.045 .066 .152 r
.35516 .56248 m .35364 .55059 L .3494 .53199 L p F P
0 0 0 r
s
.332 .486 .914 r
.37621 .38561 m .3751 .37387 L .39219 .36755 L p F P
0 0 0 r
s
.24 .35 .67 r
.37642 .3758 m
.37908 .40409 L
s
.332 .486 .914 r
.39135 .3572 m .39219 .36755 L .3751 .37387 L p F P
0 0 0 r
s
.173 .262 .553 r
.60865 .3572 m .60781 .36755 L .6249 .37387 L p F P
0 0 0 r
s
.173 .262 .553 r
.62379 .38561 m .6249 .37387 L .60781 .36755 L p F P
0 0 0 r
s
.24 .35 .67 r
.62092 .40409 m
.62358 .3758 L
s
.028 .041 .084 r
.6506 .53199 m .65225 .51929 L .65276 .5 L p F P
0 0 0 r
s
.23 .333 .575 r
.65225 .51929 m .6506 .53199 L .64636 .55059 L p F P
0 0 0 r
s
.203 .284 .476 r
.3494 .53199 m .34775 .51929 L .34724 .5 L p F P
0 0 0 r
s
.045 .066 .152 r
.34775 .51929 m .3494 .53199 L .35364 .55059 L p F P
0 0 0 r
s
.329 .485 .9 r
.62449 .60437 m .62338 .61402 L .60908 .62466 L p F P
0 0 0 r
s
.24 .35 .67 r
.6218 .616 m
.62189 .61512 L
s
.329 .485 .9 r
.60823 .63297 m .60908 .62466 L .62338 .61402 L p F P
0 0 0 r
s
.124 .196 .438 r
.39177 .63297 m .39092 .62466 L .37662 .61402 L p F P
0 0 0 r
s
.124 .196 .438 r
.37551 .60437 m .37662 .61402 L .39092 .62466 L p F P
0 0 0 r
s
.33 .484 .918 r
.39135 .3572 m .39049 .34669 L .41034 .34748 L p F P
0 0 0 r
s
.24 .35 .67 r
.3987 .35809 m
.41739 .34823 L
s
.203 .306 .632 r
.60865 .3572 m .60951 .34669 L .58966 .34748 L p F P
0 0 0 r
s
.24 .35 .67 r
.58261 .34823 m
.6013 .35809 L
s
.594 .196 .084 r
.58966 .34748 m .57685 .34748 L .59386 .34669 L p F P
0 0 0 r
s
.594 .196 .084 r
.59386 .34669 m .60951 .34669 L .58966 .34748 L p F P
0 0 0 r
s
.594 .196 .084 r
.57685 .34748 m .56404 .34748 L .57822 .34669 L p F P
0 0 0 r
s
.594 .196 .084 r
.57822 .34669 m .59386 .34669 L .57685 .34748 L p F P
0 0 0 r
s
.594 .196 .084 r
.56404 .34748 m .55123 .34748 L .56258 .34669 L p F P
0 0 0 r
s
.594 .196 .084 r
.56258 .34669 m .57822 .34669 L .56404 .34748 L p F P
0 0 0 r
s
.594 .196 .084 r
.55123 .34748 m .53843 .34748 L .54693 .34669 L p F P
0 0 0 r
s
.594 .196 .084 r
.54693 .34669 m .56258 .34669 L .55123 .34748 L p F P
0 0 0 r
s
.594 .196 .084 r
.53843 .34748 m .52562 .34748 L .53129 .34669 L p F P
0 0 0 r
s
.594 .196 .084 r
.53129 .34669 m .54693 .34669 L .53843 .34748 L p F P
0 0 0 r
s
.594 .196 .084 r
.52562 .34748 m .51281 .34748 L .51564 .34669 L p F P
0 0 0 r
s
.594 .196 .084 r
.51564 .34669 m .53129 .34669 L .52562 .34748 L p F P
0 0 0 r
s
.594 .196 .084 r
.51281 .34748 m .5 .34748 L .5 .34669 L p F P
0 0 0 r
s
.594 .196 .084 r
.5 .34669 m .51564 .34669 L .51281 .34748 L p F P
0 0 0 r
s
.594 .196 .084 r
.5 .34748 m .48719 .34748 L .48436 .34669 L p F P
0 0 0 r
s
.594 .196 .084 r
.48436 .34669 m .5 .34669 L .5 .34748 L p F P
0 0 0 r
s
.594 .196 .084 r
.48719 .34748 m .47438 .34748 L .46871 .34669 L p F P
0 0 0 r
s
.594 .196 .084 r
.46871 .34669 m .48436 .34669 L .48719 .34748 L p F P
0 0 0 r
s
.594 .196 .084 r
.47438 .34748 m .46157 .34748 L .45307 .34669 L p F P
0 0 0 r
s
.594 .196 .084 r
.45307 .34669 m .46871 .34669 L .47438 .34748 L p F P
0 0 0 r
s
.594 .196 .084 r
.46157 .34748 m .44877 .34748 L .43742 .34669 L p F P
0 0 0 r
s
.594 .196 .084 r
.43742 .34669 m .45307 .34669 L .46157 .34748 L p F P
0 0 0 r
s
.594 .196 .084 r
.44877 .34748 m .43596 .34748 L .42178 .34669 L p F P
0 0 0 r
s
.594 .196 .084 r
.42178 .34669 m .43742 .34669 L .44877 .34748 L p F P
0 0 0 r
s
.594 .196 .084 r
.43596 .34748 m .42315 .34748 L .40614 .34669 L p F P
0 0 0 r
s
.594 .196 .084 r
.40614 .34669 m .42178 .34669 L .43596 .34748 L p F P
0 0 0 r
s
.594 .196 .084 r
.42315 .34748 m .41034 .34748 L .39049 .34669 L p F P
0 0 0 r
s
.594 .196 .084 r
.39049 .34669 m .40614 .34669 L .42315 .34748 L p F P
0 0 0 r
s
.24 .35 .67 r
.41783 .65367 m
.42393 .65756 L
s
.57607 .65756 m
.58217 .65367 L
s
.052 .076 .18 r
.65276 .5 m .65446 .48676 L .65115 .46789 L p F P
0 0 0 r
s
.24 .35 .67 r
.64801 .52537 m
.65123 .5 L
s
.64619 .47514 m
.65123 .5 L
s
.028 .041 .084 r
.65446 .48676 m .65276 .5 L .65225 .51929 L p F P
0 0 0 r
s
.26 .371 .651 r
.34724 .5 m .34554 .48676 L .34885 .46789 L p F P
0 0 0 r
s
.24 .35 .67 r
.34877 .5 m
.35381 .47514 L
s
.34877 .5 m
.35199 .52537 L
s
.203 .284 .476 r
.34554 .48676 m .34724 .5 L .34775 .51929 L p F P
0 0 0 r
s
.24 .35 .67 r
.39785 .34691 m
.3987 .35809 L
s
.6013 .35809 m
.60215 .34691 L
s
.085 .024 .01 r
.42949 .65302 m .43956 .65302 L .42292 .65296 L p F P
0 0 0 r
s
.085 .024 .01 r
.42292 .65296 m .41008 .65296 L .42949 .65302 L p F P
0 0 0 r
s
.085 .024 .01 r
.43956 .65302 m .44963 .65302 L .43577 .65296 L p F P
0 0 0 r
s
.085 .024 .01 r
.43577 .65296 m .42292 .65296 L .43956 .65302 L p F P
0 0 0 r
s
.085 .024 .01 r
.44963 .65302 m .45971 .65302 L .44862 .65296 L p F P
0 0 0 r
s
.085 .024 .01 r
.44862 .65296 m .43577 .65296 L .44963 .65302 L p F P
0 0 0 r
s
.085 .024 .01 r
.45971 .65302 m .46978 .65302 L .46146 .65296 L p F P
0 0 0 r
s
.085 .024 .01 r
.46146 .65296 m .44862 .65296 L .45971 .65302 L p F P
0 0 0 r
s
.085 .024 .01 r
.46978 .65302 m .47985 .65302 L .47431 .65296 L p F P
0 0 0 r
s
.085 .024 .01 r
.47431 .65296 m .46146 .65296 L .46978 .65302 L p F P
0 0 0 r
s
.085 .024 .01 r
.47985 .65302 m .48993 .65302 L .48715 .65296 L p F P
0 0 0 r
s
.085 .024 .01 r
.48715 .65296 m .47431 .65296 L .47985 .65302 L p F P
0 0 0 r
s
.085 .024 .01 r
.48993 .65302 m .5 .65302 L .5 .65296 L p F P
0 0 0 r
s
.085 .024 .01 r
.5 .65296 m .48715 .65296 L .48993 .65302 L p F P
0 0 0 r
s
.085 .024 .01 r
.5 .65302 m .51007 .65302 L .51285 .65296 L p F P
0 0 0 r
s
.085 .024 .01 r
.51285 .65296 m .5 .65296 L .5 .65302 L p F P
0 0 0 r
s
.085 .024 .01 r
.51007 .65302 m .52015 .65302 L .52569 .65296 L p F P
0 0 0 r
s
.085 .024 .01 r
.52569 .65296 m .51285 .65296 L .51007 .65302 L p F P
0 0 0 r
s
.085 .024 .01 r
.52015 .65302 m .53022 .65302 L .53854 .65296 L p F P
0 0 0 r
s
.085 .024 .01 r
.53854 .65296 m .52569 .65296 L .52015 .65302 L p F P
0 0 0 r
s
.085 .024 .01 r
.53022 .65302 m .54029 .65302 L .55138 .65296 L p F P
0 0 0 r
s
.085 .024 .01 r
.55138 .65296 m .53854 .65296 L .53022 .65302 L p F P
0 0 0 r
s
.085 .024 .01 r
.54029 .65302 m .55037 .65302 L .56423 .65296 L p F P
0 0 0 r
s
.085 .024 .01 r
.56423 .65296 m .55138 .65296 L .54029 .65302 L p F P
0 0 0 r
s
.085 .024 .01 r
.55037 .65302 m .56044 .65302 L .57708 .65296 L p F P
0 0 0 r
s
.085 .024 .01 r
.57708 .65296 m .56423 .65296 L .55037 .65302 L p F P
0 0 0 r
s
.085 .024 .01 r
.56044 .65302 m .57051 .65302 L .58992 .65296 L p F P
0 0 0 r
s
.085 .024 .01 r
.58992 .65296 m .57708 .65296 L .56044 .65302 L p F P
0 0 0 r
s
.33 .49 .931 r
.59051 .6462 m .58992 .65296 L .57051 .65302 L p F P
0 0 0 r
s
.24 .35 .67 r
.58217 .65367 m
.58325 .65298 L
s
.206 .315 .651 r
.40949 .6462 m .41008 .65296 L .42949 .65302 L p F P
0 0 0 r
s
.24 .35 .67 r
.41675 .65298 m
.41783 .65367 L
s
.33 .481 .895 r
.36346 .40923 m .3621 .39651 L .37621 .38561 L p F P
0 0 0 r
s
.33 .481 .895 r
.3751 .37387 m .37621 .38561 L .3621 .39651 L p F P
0 0 0 r
s
.135 .206 .453 r
.6249 .37387 m .62379 .38561 L .6379 .39651 L p F P
0 0 0 r
s
.135 .206 .453 r
.63654 .40923 m .6379 .39651 L .62379 .38561 L p F P
0 0 0 r
s
.072 .105 .259 r
.65115 .46789 m .65282 .45444 L .64573 .43714 L p F P
0 0 0 r
s
.052 .076 .18 r
.65282 .45444 m .65115 .46789 L .65446 .48676 L p F P
0 0 0 r
s
.26 .371 .651 r
.34718 .45444 m .34885 .46789 L .34554 .48676 L p F P
0 0 0 r
s
.298 .43 .775 r
.34885 .46789 m .34718 .45444 L .35427 .43714 L p F P
0 0 0 r
s
.333 .493 .926 r
.60908 .62466 m .60823 .63297 L .5911 .63935 L p F P
0 0 0 r
s
.333 .493 .926 r
.59051 .6462 m .5911 .63935 L .60823 .63297 L p F P
0 0 0 r
s
.169 .262 .556 r
.40949 .6462 m .4089 .63935 L .39177 .63297 L p F P
0 0 0 r
s
.169 .262 .556 r
.39092 .62466 m .39177 .63297 L .4089 .63935 L p F P
0 0 0 r
s
.096 .145 .343 r
.64573 .43714 m .64728 .42385 L .63654 .40923 L p F P
0 0 0 r
s
.072 .105 .259 r
.64728 .42385 m .64573 .43714 L .65282 .45444 L p F P
0 0 0 r
s
.24 .35 .67 r
.63795 .42498 m
.6494 .44841 L
s
.64619 .47514 m
.6494 .44841 L
s
.298 .43 .775 r
.35272 .42385 m .35427 .43714 L .34718 .45444 L p F P
0 0 0 r
s
.24 .35 .67 r
.3506 .44841 m
.35381 .47514 L
s
.32 .464 .852 r
.35427 .43714 m .35272 .42385 L .36346 .40923 L p F P
0 0 0 r
s
.24 .35 .67 r
.3506 .44841 m
.36205 .42498 L
s
.096 .145 .343 r
.6379 .39651 m .63654 .40923 L .64728 .42385 L p F P
0 0 0 r
s
.32 .464 .852 r
.3621 .39651 m .36346 .40923 L .35272 .42385 L p F P
0 0 0 r
s
.332 .486 .914 r
.3751 .37387 m .37397 .36193 L .39135 .3572 L p F P
0 0 0 r
s
.332 .486 .914 r
.39049 .34669 m .39135 .3572 L .37397 .36193 L p F P
0 0 0 r
s
.24 .35 .67 r
.37642 .3758 m
.3987 .35809 L
s
.173 .262 .553 r
.60951 .34669 m .60865 .3572 L .62603 .36193 L p F P
0 0 0 r
s
.173 .262 .553 r
.6249 .37387 m .62603 .36193 L .60865 .3572 L p F P
0 0 0 r
s
.24 .35 .67 r
.6013 .35809 m
.62358 .3758 L
s
.57607 .65756 m
.54724 .66874 L
s
.45276 .66874 m
.42393 .65756 L
s
.281 .411 .734 r
.63702 .57934 m .63838 .56827 L .64636 .55059 L p F P
0 0 0 r
s
.313 .46 .84 r
.63838 .56827 m .63702 .57934 L .62561 .59454 L p F P
0 0 0 r
s
.313 .46 .84 r
.62449 .60437 m .62561 .59454 L .63702 .57934 L p F P
0 0 0 r
s
.092 .138 .333 r
.37551 .60437 m .37439 .59454 L .36298 .57934 L p F P
0 0 0 r
s
.092 .138 .333 r
.36162 .56827 m .36298 .57934 L .37439 .59454 L p F P
0 0 0 r
s
.24 .35 .67 r
.36167 .57529 m
.36268 .57689 L
s
.068 .1 .244 r
.36298 .57934 m .36162 .56827 L .35364 .55059 L p F P
0 0 0 r
s
.329 .485 .9 r
.62561 .59454 m .62449 .60437 L .60994 .61622 L p F P
0 0 0 r
s
.24 .35 .67 r
.62287 .60649 m
.62297 .6056 L
s
.329 .485 .9 r
.60908 .62466 m .60994 .61622 L .62449 .60437 L p F P
0 0 0 r
s
.124 .196 .438 r
.39092 .62466 m .39006 .61622 L .37551 .60437 L p F P
0 0 0 r
s
.124 .196 .438 r
.37439 .59454 m .37551 .60437 L .39006 .61622 L p F P
0 0 0 r
s
.23 .333 .575 r
.64636 .55059 m .64792 .53845 L .65225 .51929 L p F P
0 0 0 r
s
.281 .411 .734 r
.64792 .53845 m .64636 .55059 L .63838 .56827 L p F P
0 0 0 r
s
.068 .1 .244 r
.35208 .53845 m .35364 .55059 L .36162 .56827 L p F P
0 0 0 r
s
.045 .066 .152 r
.35364 .55059 m .35208 .53845 L .34775 .51929 L p F P
0 0 0 r
s
.33 .49 .931 r
.5911 .63935 m .59051 .6462 L .57087 .64773 L p F P
0 0 0 r
s
.33 .49 .931 r
.57051 .65302 m .57087 .64773 L .59051 .6462 L p F P
0 0 0 r
s
.24 .35 .67 r
.57607 .65756 m
.5764 .653 L
s
.83 .24 .1 r
.58691 .65114 m
.58741 .65188 L
s
.206 .315 .651 r
.42949 .65302 m .42913 .64773 L .40949 .6462 L p F P
0 0 0 r
s
.24 .35 .67 r
.4236 .653 m
.42393 .65756 L
s
.83 .24 .1 r
.41259 .65188 m
.41309 .65114 L
s
.206 .315 .651 r
.4089 .63935 m .40949 .6462 L .42913 .64773 L p F P
0 0 0 r
s
.24 .35 .67 r
.45275 .30502 m
.48406 .30021 L
s
.4837 .26899 m
.48406 .30021 L
s
.48406 .30021 m
.51594 .30021 L
s
.5163 .26899 m
.51594 .30021 L
s
.51594 .30021 m
.54725 .30502 L
s
.83 .24 .1 r
.23852 .34808 m
.19494 .34808 L
s
.2821 .34808 m
.23852 .34808 L
s
.32568 .34808 m
.2821 .34808 L
s
.36926 .34808 m
.32568 .34808 L
s
.39622 .34808 m
.41284 .34808 L
s
.36926 .34808 m
.38899 .34808 L
s
.45642 .34808 m
.41284 .34808 L
s
.5 .34808 m
.45642 .34808 L
s
.54358 .34808 m
.5 .34808 L
s
.58716 .34808 m
.54358 .34808 L
s
.58716 .34808 m
.60378 .34808 L
s
.61101 .34808 m
.63074 .34808 L
s
.67432 .34808 m
.63074 .34808 L
s
.7179 .34808 m
.67432 .34808 L
s
.76148 .34808 m
.7179 .34808 L
s
.80506 .34808 m
.76148 .34808 L
s
.23852 .34808 m
.23326 .35131 L
s
.18881 .35131 m
.19494 .34808 L
s
.2821 .34808 m
.27772 .35131 L
s
.32568 .34808 m
.32218 .35131 L
s
.67432 .34808 m
.67782 .35131 L
s
.7179 .34808 m
.72228 .35131 L
s
.76148 .34808 m
.76674 .35131 L
s
.80506 .34808 m
.81119 .35131 L
s
.028 .041 .084 r
.65225 .51929 m .65394 .50631 L .65446 .48676 L p F P
0 0 0 r
s
.23 .333 .575 r
.65394 .50631 m .65225 .51929 L .64792 .53845 L p F P
0 0 0 r
s
.24 .35 .67 r
.64829 .53649 m
.64971 .52546 L
s
.64971 .52546 m
.65123 .5 L
s
.203 .284 .476 r
.34775 .51929 m .34606 .50631 L .34554 .48676 L p F P
0 0 0 r
s
.045 .066 .152 r
.34606 .50631 m .34775 .51929 L .35208 .53845 L p F P
0 0 0 r
s
.24 .35 .67 r
.34877 .5 m
.35029 .52546 L
s
.35029 .52546 m
.35171 .53649 L
s
.333 .493 .926 r
.60994 .61622 m .60908 .62466 L .5917 .63241 L p F P
0 0 0 r
s
.333 .493 .926 r
.5911 .63935 m .5917 .63241 L .60908 .62466 L p F P
0 0 0 r
s
.169 .262 .556 r
.4089 .63935 m .4083 .63241 L .39092 .62466 L p F P
0 0 0 r
s
.169 .262 .556 r
.39006 .61622 m .39092 .62466 L .4083 .63241 L p F P
0 0 0 r
s
.33 .481 .895 r
.3621 .39651 m .36072 .38353 L .3751 .37387 L p F P
0 0 0 r
s
.33 .481 .895 r
.37397 .36193 m .3751 .37387 L .36072 .38353 L p F P
0 0 0 r
s
.135 .206 .453 r
.62603 .36193 m .6249 .37387 L .63928 .38353 L p F P
0 0 0 r
s
.135 .206 .453 r
.6379 .39651 m .63928 .38353 L .6249 .37387 L p F P
0 0 0 r
s
.24 .35 .67 r
.54724 .66874 m
.54797 .65306 L
s
.54724 .66874 m
.51602 .67449 L
s
.48398 .67449 m
.45276 .66874 L
s
.45203 .65306 m
.45276 .66874 L
s
.42317 .31451 m
.45275 .30502 L
s
.45169 .27383 m
.45275 .30502 L
s
.54831 .27383 m
.54725 .30502 L
s
.54725 .30502 m
.57683 .31451 L
s
.052 .076 .18 r
.65446 .48676 m .65619 .47322 L .65282 .45444 L p F P
0 0 0 r
s
.028 .041 .084 r
.65619 .47322 m .65446 .48676 L .65394 .50631 L p F P
0 0 0 r
s
.26 .371 .651 r
.34554 .48676 m .34381 .47322 L .34718 .45444 L p F P
0 0 0 r
s
.203 .284 .476 r
.34381 .47322 m .34554 .48676 L .34606 .50631 L p F P
0 0 0 r
s
.83 .24 .1 r
.23251 .64765 m
.23776 .65188 L
s
.19405 .65188 m
.18792 .64765 L
s
.23776 .65188 m
.19405 .65188 L
s
.27709 .64765 m
.28147 .65188 L
s
.28147 .65188 m
.23776 .65188 L
s
.32167 .64765 m
.32517 .65188 L
s
.32517 .65188 m
.28147 .65188 L
s
.36625 .64765 m
.36888 .65188 L
s
.36888 .65188 m
.32517 .65188 L
s
.36888 .65188 m
.41259 .65188 L
s
.41259 .65188 m
.42137 .65188 L
s
.42941 .65188 m
.45629 .65188 L
s
.5 .65188 m
.45629 .65188 L
s
.54371 .65188 m
.5 .65188 L
s
.57863 .65188 m
.58741 .65188 L
s
.54371 .65188 m
.57059 .65188 L
s
.63375 .64765 m
.63112 .65188 L
s
.58741 .65188 m
.63112 .65188 L
s
.67833 .64765 m
.67483 .65188 L
s
.67483 .65188 m
.63112 .65188 L
s
.72291 .64765 m
.71853 .65188 L
s
.71853 .65188 m
.67483 .65188 L
s
.76749 .64765 m
.76224 .65188 L
s
.76224 .65188 m
.71853 .65188 L
s
.81208 .64765 m
.80595 .65188 L
s
.80595 .65188 m
.76224 .65188 L
s
.072 .105 .259 r
.65282 .45444 m .65452 .44069 L .64728 .42385 L p F P
0 0 0 r
s
.052 .076 .18 r
.65452 .44069 m .65282 .45444 L .65619 .47322 L p F P
0 0 0 r
s
.26 .371 .651 r
.34548 .44069 m .34718 .45444 L .34381 .47322 L p F P
0 0 0 r
s
.298 .43 .775 r
.34718 .45444 m .34548 .44069 L .35272 .42385 L p F P
0 0 0 r
s
.096 .145 .343 r
.63928 .38353 m .6379 .39651 L .64885 .41027 L p F P
0 0 0 r
s
.096 .145 .343 r
.64728 .42385 m .64885 .41027 L .6379 .39651 L p F P
0 0 0 r
s
.24 .35 .67 r
.63795 .42498 m
.64102 .39685 L
s
.32 .464 .852 r
.35272 .42385 m .35115 .41027 L .3621 .39651 L p F P
0 0 0 r
s
.32 .464 .852 r
.36072 .38353 m .3621 .39651 L .35115 .41027 L p F P
0 0 0 r
s
.24 .35 .67 r
.35898 .39685 m
.36205 .42498 L
s
.51602 .67449 m
.51636 .65309 L
s
.51602 .67449 m
.48398 .67449 L
s
.48364 .65309 m
.48398 .67449 L
s
.072 .105 .259 r
.64885 .41027 m .64728 .42385 L .65452 .44069 L p F P
0 0 0 r
s
.298 .43 .775 r
.35115 .41027 m .35272 .42385 L .34548 .44069 L p F P
0 0 0 r
s
.332 .486 .914 r
.37397 .36193 m .37281 .34976 L .39049 .34669 L p F P
0 0 0 r
s
.173 .262 .553 r
.62603 .36193 m .62719 .34976 L .60951 .34669 L p F P
0 0 0 r
s
.189 .045 .019 r
.60951 .34669 m .59386 .34669 L .60902 .34976 L p F P
0 0 0 r
s
.24 .35 .67 r
.60222 .34597 m
.60356 .32839 L
s
.60217 .34669 m
.60222 .34597 L
s
.189 .045 .019 r
.60902 .34976 m .62719 .34976 L .60951 .34669 L p F P
0 0 0 r
s
.189 .045 .019 r
.59386 .34669 m .57822 .34669 L .59085 .34976 L p F P
0 0 0 r
s
.189 .045 .019 r
.59085 .34976 m .60902 .34976 L .59386 .34669 L p F P
0 0 0 r
s
.189 .045 .019 r
.57822 .34669 m .56258 .34669 L .57268 .34976 L p F P
0 0 0 r
s
.189 .045 .019 r
.57268 .34976 m .59085 .34976 L .57822 .34669 L p F P
0 0 0 r
s
.83 .24 .1 r
.58807 .34976 m
.58891 .35131 L
s
.189 .045 .019 r
.56258 .34669 m .54693 .34669 L .55451 .34976 L p F P
0 0 0 r
s
.189 .045 .019 r
.55451 .34976 m .57268 .34976 L .56258 .34669 L p F P
0 0 0 r
s
.189 .045 .019 r
.54693 .34669 m .53129 .34669 L .53634 .34976 L p F P
0 0 0 r
s
.189 .045 .019 r
.53634 .34976 m .55451 .34976 L .54693 .34669 L p F P
0 0 0 r
s
.83 .24 .1 r
.54404 .34976 m
.54446 .35131 L
s
.189 .045 .019 r
.53129 .34669 m .51564 .34669 L .51817 .34976 L p F P
0 0 0 r
s
.189 .045 .019 r
.51817 .34976 m .53634 .34976 L .53129 .34669 L p F P
0 0 0 r
s
.189 .045 .019 r
.51564 .34669 m .5 .34669 L .5 .34976 L p F P
0 0 0 r
s
.189 .045 .019 r
.5 .34976 m .51817 .34976 L .51564 .34669 L p F P
0 0 0 r
s
.189 .045 .019 r
.5 .34669 m .48436 .34669 L .48183 .34976 L p F P
0 0 0 r
s
.189 .045 .019 r
.48183 .34976 m .5 .34976 L .5 .34669 L p F P
0 0 0 r
s
.83 .24 .1 r
.5 .34976 m
.5 .35131 L
s
.189 .045 .019 r
.48436 .34669 m .46871 .34669 L .46366 .34976 L p F P
0 0 0 r
s
.189 .045 .019 r
.46366 .34976 m .48183 .34976 L .48436 .34669 L p F P
0 0 0 r
s
.189 .045 .019 r
.46871 .34669 m .45307 .34669 L .44549 .34976 L p F P
0 0 0 r
s
.189 .045 .019 r
.44549 .34976 m .46366 .34976 L .46871 .34669 L p F P
0 0 0 r
s
.83 .24 .1 r
.45554 .35131 m
.45596 .34976 L
s
.189 .045 .019 r
.45307 .34669 m .43742 .34669 L .42732 .34976 L p F P
0 0 0 r
s
.189 .045 .019 r
.42732 .34976 m .44549 .34976 L .45307 .34669 L p F P
0 0 0 r
s
.189 .045 .019 r
.43742 .34669 m .42178 .34669 L .40915 .34976 L p F P
0 0 0 r
s
.189 .045 .019 r
.40915 .34976 m .42732 .34976 L .43742 .34669 L p F P
0 0 0 r
s
.189 .045 .019 r
.42178 .34669 m .40614 .34669 L .39098 .34976 L p F P
0 0 0 r
s
.24 .35 .67 r
.39644 .32839 m
.39778 .34597 L
s
.39778 .34597 m
.39783 .34669 L
s
.189 .045 .019 r
.39098 .34976 m .40915 .34976 L .42178 .34669 L p F P
0 0 0 r
s
.83 .24 .1 r
.41109 .35131 m
.41193 .34976 L
s
.189 .045 .019 r
.40614 .34669 m .39049 .34669 L .37281 .34976 L p F P
0 0 0 r
s
.189 .045 .019 r
.37281 .34976 m .39098 .34976 L .40614 .34669 L p F P
0 0 0 r
s
.33 .49 .931 r
.5917 .63241 m .5911 .63935 L .57124 .64238 L p F P
0 0 0 r
s
.33 .49 .931 r
.57087 .64773 m .57124 .64238 L .5911 .63935 L p F P
0 0 0 r
s
.83 .24 .1 r
.58741 .65188 m
.58916 .64765 L
s
.206 .315 .651 r
.42913 .64773 m .42876 .64238 L .4089 .63935 L p F P
0 0 0 r
s
.83 .24 .1 r
.41084 .64765 m
.41259 .65188 L
s
.206 .315 .651 r
.4083 .63241 m .4089 .63935 L .42876 .64238 L p F P
0 0 0 r
s
.24 .35 .67 r
.39644 .32839 m
.42317 .31451 L
s
.42143 .28338 m
.42317 .31451 L
s
.57857 .28338 m
.57683 .31451 L
s
.57683 .31451 m
.60356 .32839 L
s
.313 .46 .84 r
.62561 .59454 m .62676 .58454 L .63838 .56827 L p F P
0 0 0 r
s
.329 .485 .9 r
.62676 .58454 m .62561 .59454 L .61082 .60765 L p F P
0 0 0 r
s
.24 .35 .67 r
.62397 .59682 m
.62407 .59591 L
s
.329 .485 .9 r
.60994 .61622 m .61082 .60765 L .62561 .59454 L p F P
0 0 0 r
s
.124 .196 .438 r
.39006 .61622 m .38918 .60765 L .37439 .59454 L p F P
0 0 0 r
s
.124 .196 .438 r
.37324 .58454 m .37439 .59454 L .38918 .60765 L p F P
0 0 0 r
s
.092 .138 .333 r
.37439 .59454 m .37324 .58454 L .36162 .56827 L p F P
0 0 0 r
s
.281 .411 .734 r
.63838 .56827 m .63977 .55697 L .64792 .53845 L p F P
0 0 0 r
s
.313 .46 .84 r
.63977 .55697 m .63838 .56827 L .62676 .58454 L p F P
0 0 0 r
s
.092 .138 .333 r
.36023 .55697 m .36162 .56827 L .37324 .58454 L p F P
0 0 0 r
s
.068 .1 .244 r
.36162 .56827 m .36023 .55697 L .35208 .53845 L p F P
0 0 0 r
s
.792 .25 .107 r
.45128 .64919 m .45824 .64919 L .43956 .65302 L p F P
0 0 0 r
s
.792 .25 .107 r
.43956 .65302 m .42949 .65302 L .45128 .64919 L p F P
0 0 0 r
s
.792 .25 .107 r
.45824 .64919 m .4652 .64919 L .44963 .65302 L p F P
0 0 0 r
s
.83 .24 .1 r
.4562 .65141 m
.45629 .65188 L
s
.792 .25 .107 r
.44963 .65302 m .43956 .65302 L .45824 .64919 L p F P
0 0 0 r
s
.792 .25 .107 r
.4652 .64919 m .47216 .64919 L .45971 .65302 L p F P
0 0 0 r
s
.792 .25 .107 r
.45971 .65302 m .44963 .65302 L .4652 .64919 L p F P
0 0 0 r
s
.24 .35 .67 r
.45188 .64981 m
.45203 .65306 L
s
.83 .24 .1 r
.45542 .64765 m
.45574 .64919 L
s
.792 .25 .107 r
.47216 .64919 m .47912 .64919 L .46978 .65302 L p F P
0 0 0 r
s
.792 .25 .107 r
.46978 .65302 m .45971 .65302 L .47216 .64919 L p F P
0 0 0 r
s
.792 .25 .107 r
.47912 .64919 m .48608 .64919 L .47985 .65302 L p F P
0 0 0 r
s
.792 .25 .107 r
.47985 .65302 m .46978 .65302 L .47912 .64919 L p F P
0 0 0 r
s
.792 .25 .107 r
.48608 .64919 m .49304 .64919 L .48993 .65302 L p F P
0 0 0 r
s
.792 .25 .107 r
.48993 .65302 m .47985 .65302 L .48608 .64919 L p F P
0 0 0 r
s
.24 .35 .67 r
.48362 .65156 m
.48364 .65309 L
s
.792 .25 .107 r
.49304 .64919 m .5 .64919 L .5 .65302 L p F P
0 0 0 r
s
.792 .25 .107 r
.5 .65302 m .48993 .65302 L .49304 .64919 L p F P
0 0 0 r
s
.792 .25 .107 r
.5 .64919 m .50696 .64919 L .51007 .65302 L p F P
0 0 0 r
s
.792 .25 .107 r
.51007 .65302 m .5 .65302 L .5 .64919 L p F P
0 0 0 r
s
.83 .24 .1 r
.5 .64765 m
.5 .64919 L
s
.792 .25 .107 r
.50696 .64919 m .51392 .64919 L .52015 .65302 L p F P
0 0 0 r
s
.792 .25 .107 r
.52015 .65302 m .51007 .65302 L .50696 .64919 L p F P
0 0 0 r
s
.792 .25 .107 r
.51392 .64919 m .52088 .64919 L .53022 .65302 L p F P
0 0 0 r
s
.792 .25 .107 r
.53022 .65302 m .52015 .65302 L .51392 .64919 L p F P
0 0 0 r
s
.24 .35 .67 r
.51636 .65309 m
.51638 .65156 L
s
.792 .25 .107 r
.52088 .64919 m .52784 .64919 L .54029 .65302 L p F P
0 0 0 r
s
.792 .25 .107 r
.54029 .65302 m .53022 .65302 L .52088 .64919 L p F P
0 0 0 r
s
.792 .25 .107 r
.52784 .64919 m .5348 .64919 L .55037 .65302 L p F P
0 0 0 r
s
.792 .25 .107 r
.55037 .65302 m .54029 .65302 L .52784 .64919 L p F P
0 0 0 r
s
.792 .25 .107 r
.5348 .64919 m .54176 .64919 L .56044 .65302 L p F P
0 0 0 r
s
.792 .25 .107 r
.56044 .65302 m .55037 .65302 L .5348 .64919 L p F P
0 0 0 r
s
.792 .25 .107 r
.54176 .64919 m .54872 .64919 L .57051 .65302 L p F P
0 0 0 r
s
.792 .25 .107 r
.57051 .65302 m .56044 .65302 L .54176 .64919 L p F P
0 0 0 r
s
.24 .35 .67 r
.54797 .65306 m
.54812 .64981 L
s
.83 .24 .1 r
.54426 .64919 m
.54458 .64765 L
s
.322 .48 .92 r
.57087 .64773 m .57051 .65302 L .54872 .64919 L p F P
0 0 0 r
s
.235 .358 .725 r
.42913 .64773 m .42949 .65302 L .45128 .64919 L p F P
0 0 0 r
s
.333 .493 .926 r
.61082 .60765 m .60994 .61622 L .59231 .62538 L p F P
0 0 0 r
s
.333 .493 .926 r
.5917 .63241 m .59231 .62538 L .60994 .61622 L p F P
0 0 0 r
s
.169 .262 .556 r
.4083 .63241 m .40769 .62538 L .39006 .61622 L p F P
0 0 0 r
s
.169 .262 .556 r
.38918 .60765 m .39006 .61622 L .40769 .62538 L p F P
0 0 0 r
s
.23 .333 .575 r
.64792 .53845 m .64951 .52605 L .65394 .50631 L p F P
0 0 0 r
s
.281 .411 .734 r
.64951 .52605 m .64792 .53845 L .63977 .55697 L p F P
0 0 0 r
s
.24 .35 .67 r
.64118 .5525 m
.64144 .55038 L
s
.068 .1 .244 r
.35049 .52605 m .35208 .53845 L .36023 .55697 L p F P
0 0 0 r
s
.24 .35 .67 r
.35856 .55038 m
.35882 .5525 L
s
.045 .066 .152 r
.35208 .53845 m .35049 .52605 L .34606 .50631 L p F P
0 0 0 r
s
.33 .481 .895 r
.36072 .38353 m .35931 .3703 L .37397 .36193 L p F P
0 0 0 r
s
.24 .35 .67 r
.35898 .39685 m
.37642 .3758 L
s
.33 .481 .895 r
.37281 .34976 m .37397 .36193 L .35931 .3703 L p F P
0 0 0 r
s
.83 .24 .1 r
.36663 .35131 m
.36926 .34808 L
s
.135 .206 .453 r
.62719 .34976 m .62603 .36193 L .64069 .3703 L p F P
0 0 0 r
s
.83 .24 .1 r
.63074 .34808 m
.63337 .35131 L
s
.135 .206 .453 r
.63928 .38353 m .64069 .3703 L .62603 .36193 L p F P
0 0 0 r
s
.24 .35 .67 r
.62358 .3758 m
.64102 .39685 L
s
.028 .041 .084 r
.65394 .50631 m .65566 .49304 L .65619 .47322 L p F P
0 0 0 r
s
.24 .35 .67 r
.6494 .44841 m
.6546 .4735 L
s
.23 .333 .575 r
.65566 .49304 m .65394 .50631 L .64951 .52605 L p F P
0 0 0 r
s
.24 .35 .67 r
.65123 .5 m
.6546 .4735 L
s
.64144 .55038 m
.64952 .52602 L
s
.203 .284 .476 r
.34606 .50631 m .34434 .49304 L .34381 .47322 L p F P
0 0 0 r
s
.045 .066 .152 r
.34434 .49304 m .34606 .50631 L .35049 .52605 L p F P
0 0 0 r
s
.24 .35 .67 r
.35048 .52602 m
.35856 .55038 L
s
.3454 .4735 m
.34877 .5 L
s
.3454 .4735 m
.3506 .44841 L
s
.33 .49 .931 r
.59231 .62538 m .5917 .63241 L .5716 .63697 L p F P
0 0 0 r
s
.24 .35 .67 r
.59041 .62644 m
.59273 .62498 L
s
.33 .49 .931 r
.57124 .64238 m .5716 .63697 L .5917 .63241 L p F P
0 0 0 r
s
.206 .315 .651 r
.42876 .64238 m .4284 .63697 L .4083 .63241 L p F P
0 0 0 r
s
.206 .315 .651 r
.40769 .62538 m .4083 .63241 L .4284 .63697 L p F P
0 0 0 r
s
.24 .35 .67 r
.40727 .62498 m
.40959 .62644 L
s
.322 .48 .92 r
.57124 .64238 m .57087 .64773 L .54889 .64553 L p F P
0 0 0 r
s
.322 .48 .92 r
.54872 .64919 m .54889 .64553 L .57087 .64773 L p F P
0 0 0 r
s
.235 .358 .725 r
.45128 .64919 m .45111 .64553 L .42913 .64773 L p F P
0 0 0 r
s
.235 .358 .725 r
.42876 .64238 m .42913 .64773 L .45111 .64553 L p F P
0 0 0 r
s
.052 .076 .18 r
.65619 .47322 m .65797 .45938 L .65452 .44069 L p F P
0 0 0 r
s
.028 .041 .084 r
.65797 .45938 m .65619 .47322 L .65566 .49304 L p F P
0 0 0 r
s
.26 .371 .651 r
.34381 .47322 m .34203 .45938 L .34548 .44069 L p F P
0 0 0 r
s
.203 .284 .476 r
.34203 .45938 m .34381 .47322 L .34434 .49304 L p F P
0 0 0 r
s
.096 .145 .343 r
.64069 .3703 m .63928 .38353 L .65047 .3964 L p F P
0 0 0 r
s
.096 .145 .343 r
.64885 .41027 m .65047 .3964 L .63928 .38353 L p F P
0 0 0 r
s
.32 .464 .852 r
.35115 .41027 m .34953 .3964 L .36072 .38353 L p F P
0 0 0 r
s
.32 .464 .852 r
.35931 .3703 m .36072 .38353 L .34953 .3964 L p F P
0 0 0 r
s
.24 .35 .67 r
.37364 .34623 m
.39644 .32839 L
s
.39408 .29735 m
.39644 .32839 L
s
.60592 .29735 m
.60356 .32839 L
s
.60356 .32839 m
.62636 .34623 L
s
.072 .105 .259 r
.65452 .44069 m .65625 .42663 L .64885 .41027 L p F P
0 0 0 r
s
.052 .076 .18 r
.65625 .42663 m .65452 .44069 L .65797 .45938 L p F P
0 0 0 r
s
.26 .371 .651 r
.34375 .42663 m .34548 .44069 L .34203 .45938 L p F P
0 0 0 r
s
.298 .43 .775 r
.34548 .44069 m .34375 .42663 L .35115 .41027 L p F P
0 0 0 r
s
.072 .105 .259 r
.65047 .3964 m .64885 .41027 L .65625 .42663 L p F P
0 0 0 r
s
.24 .35 .67 r
.6494 .44841 m
.65276 .42048 L
s
.64102 .39685 m
.65276 .42048 L
s
.298 .43 .775 r
.34953 .3964 m .35115 .41027 L .34375 .42663 L p F P
0 0 0 r
s
.24 .35 .67 r
.34724 .42048 m
.3506 .44841 L
s
.34724 .42048 m
.35898 .39685 L
s
.313 .46 .84 r
.62676 .58454 m .62792 .57435 L .63977 .55697 L p F P
0 0 0 r
s
.329 .485 .9 r
.62792 .57435 m .62676 .58454 L .61171 .59894 L p F P
0 0 0 r
s
.24 .35 .67 r
.62509 .58697 m
.62519 .58604 L
s
.329 .485 .9 r
.61082 .60765 m .61171 .59894 L .62676 .58454 L p F P
0 0 0 r
s
.124 .196 .438 r
.38918 .60765 m .38829 .59894 L .37324 .58454 L p F P
0 0 0 r
s
.124 .196 .438 r
.37208 .57435 m .37324 .58454 L .38829 .59894 L p F P
0 0 0 r
s
.092 .138 .333 r
.37324 .58454 m .37208 .57435 L .36023 .55697 L p F P
0 0 0 r
s
.333 .493 .926 r
.61171 .59894 m .61082 .60765 L .59293 .61825 L p F P
0 0 0 r
s
.333 .493 .926 r
.59231 .62538 m .59293 .61825 L .61082 .60765 L p F P
0 0 0 r
s
.169 .262 .556 r
.40769 .62538 m .40707 .61825 L .38918 .60765 L p F P
0 0 0 r
s
.169 .262 .556 r
.38829 .59894 m .38918 .60765 L .40707 .61825 L p F P
0 0 0 r
s
.281 .411 .734 r
.63977 .55697 m .64119 .54545 L .64951 .52605 L p F P
0 0 0 r
s
.313 .46 .84 r
.64119 .54545 m .63977 .55697 L .62792 .57435 L p F P
0 0 0 r
s
.24 .35 .67 r
.6266 .57358 m
.63254 .5643 L
s
.092 .138 .333 r
.35881 .54545 m .36023 .55697 L .37208 .57435 L p F P
0 0 0 r
s
.24 .35 .67 r
.35856 .55038 m
.35962 .55204 L
s
.36746 .5643 m
.3734 .57358 L
s
.068 .1 .244 r
.36023 .55697 m .35881 .54545 L .35049 .52605 L p F P
0 0 0 r
s
.322 .48 .92 r
.5716 .63697 m .57124 .64238 L .54907 .64183 L p F P
0 0 0 r
s
.322 .48 .92 r
.54889 .64553 m .54907 .64183 L .57124 .64238 L p F P
0 0 0 r
s
.235 .358 .725 r
.45111 .64553 m .45093 .64183 L .42876 .64238 L p F P
0 0 0 r
s
.235 .358 .725 r
.4284 .63697 m .42876 .64238 L .45093 .64183 L p F P
0 0 0 r
s
.33 .49 .931 r
.59293 .61825 m .59231 .62538 L .57198 .63152 L p F P
0 0 0 r
s
.33 .49 .931 r
.5716 .63697 m .57198 .63152 L .59231 .62538 L p F P
0 0 0 r
s
.206 .315 .651 r
.4284 .63697 m .42802 .63152 L .40769 .62538 L p F P
0 0 0 r
s
.206 .315 .651 r
.40707 .61825 m .40769 .62538 L .42802 .63152 L p F P
0 0 0 r
s
.24 .35 .67 r
.57054 .63721 m
.57162 .63679 L
s
.42838 .63679 m
.42946 .63721 L
s
.83 .24 .1 r
.23326 .35131 m
.18881 .35131 L
s
.27772 .35131 m
.23326 .35131 L
s
.32218 .35131 m
.27772 .35131 L
s
.32218 .35131 m
.36663 .35131 L
s
.37228 .35131 m
.41109 .35131 L
s
.36663 .35131 m
.37179 .35131 L
s
.45554 .35131 m
.41109 .35131 L
s
.5 .35131 m
.45554 .35131 L
s
.54446 .35131 m
.5 .35131 L
s
.58891 .35131 m
.54446 .35131 L
s
.58891 .35131 m
.62772 .35131 L
s
.62821 .35131 m
.63337 .35131 L
s
.63337 .35131 m
.67782 .35131 L
s
.72228 .35131 m
.67782 .35131 L
s
.76674 .35131 m
.72228 .35131 L
s
.81119 .35131 m
.76674 .35131 L
s
.23326 .35131 m
.22814 .36147 L
s
.18283 .36147 m
.18881 .35131 L
s
.27772 .35131 m
.27345 .36147 L
s
.32218 .35131 m
.31876 .36147 L
s
.67782 .35131 m
.68124 .36147 L
s
.72228 .35131 m
.72655 .36147 L
s
.76674 .35131 m
.77186 .36147 L
s
.81119 .35131 m
.81717 .36147 L
s
.23 .333 .575 r
.64951 .52605 m .65114 .51338 L .65566 .49304 L p F P
0 0 0 r
s
.281 .411 .734 r
.65114 .51338 m .64951 .52605 L .64119 .54545 L p F P
0 0 0 r
s
.068 .1 .244 r
.34886 .51338 m .35049 .52605 L .35881 .54545 L p F P
0 0 0 r
s
.045 .066 .152 r
.35049 .52605 m .34886 .51338 L .34434 .49304 L p F P
0 0 0 r
s
.33 .481 .895 r
.35931 .3703 m .35787 .35679 L .37281 .34976 L p F P
0 0 0 r
s
.135 .206 .453 r
.64069 .3703 m .64213 .35679 L .62719 .34976 L p F P
0 0 0 r
s
.291 .066 .028 r
.62719 .34976 m .60902 .34976 L .62183 .35679 L p F P
0 0 0 r
s
.24 .35 .67 r
.62358 .3758 m
.62586 .3515 L
s
.291 .066 .028 r
.62183 .35679 m .64213 .35679 L .62719 .34976 L p F P
0 0 0 r
s
.24 .35 .67 r
.626 .35006 m
.62601 .34991 L
s
.62601 .34991 m
.62636 .34623 L
s
.83 .24 .1 r
.63337 .35131 m
.63376 .35285 L
s
.291 .066 .028 r
.60902 .34976 m .59085 .34976 L .60152 .35679 L p F P
0 0 0 r
s
.291 .066 .028 r
.60152 .35679 m .62183 .35679 L .60902 .34976 L p F P
0 0 0 r
s
.291 .066 .028 r
.59085 .34976 m .57268 .34976 L .58122 .35679 L p F P
0 0 0 r
s
.291 .066 .028 r
.58122 .35679 m .60152 .35679 L .59085 .34976 L p F P
0 0 0 r
s
.291 .066 .028 r
.57268 .34976 m .55451 .34976 L .56091 .35679 L p F P
0 0 0 r
s
.291 .066 .028 r
.56091 .35679 m .58122 .35679 L .57268 .34976 L p F P
0 0 0 r
s
.291 .066 .028 r
.55451 .34976 m .53634 .34976 L .54061 .35679 L p F P
0 0 0 r
s
.291 .066 .028 r
.54061 .35679 m .56091 .35679 L .55451 .34976 L p F P
0 0 0 r
s
.291 .066 .028 r
.53634 .34976 m .51817 .34976 L .5203 .35679 L p F P
0 0 0 r
s
.291 .066 .028 r
.5203 .35679 m .54061 .35679 L .53634 .34976 L p F P
0 0 0 r
s
.291 .066 .028 r
.51817 .34976 m .5 .34976 L .5 .35679 L p F P
0 0 0 r
s
.291 .066 .028 r
.5 .35679 m .5203 .35679 L .51817 .34976 L p F P
0 0 0 r
s
.291 .066 .028 r
.5 .34976 m .48183 .34976 L .4797 .35679 L p F P
0 0 0 r
s
.291 .066 .028 r
.4797 .35679 m .5 .35679 L .5 .34976 L p F P
0 0 0 r
s
.291 .066 .028 r
.48183 .34976 m .46366 .34976 L .45939 .35679 L p F P
0 0 0 r
s
.291 .066 .028 r
.45939 .35679 m .4797 .35679 L .48183 .34976 L p F P
0 0 0 r
s
.291 .066 .028 r
.46366 .34976 m .44549 .34976 L .43909 .35679 L p F P
0 0 0 r
s
.291 .066 .028 r
.43909 .35679 m .45939 .35679 L .46366 .34976 L p F P
0 0 0 r
s
.291 .066 .028 r
.44549 .34976 m .42732 .34976 L .41878 .35679 L p F P
0 0 0 r
s
.291 .066 .028 r
.41878 .35679 m .43909 .35679 L .44549 .34976 L p F P
0 0 0 r
s
.291 .066 .028 r
.42732 .34976 m .40915 .34976 L .39848 .35679 L p F P
0 0 0 r
s
.291 .066 .028 r
.39848 .35679 m .41878 .35679 L .42732 .34976 L p F P
0 0 0 r
s
.291 .066 .028 r
.40915 .34976 m .39098 .34976 L .37817 .35679 L p F P
0 0 0 r
s
.291 .066 .028 r
.37817 .35679 m .39848 .35679 L .40915 .34976 L p F P
0 0 0 r
s
.291 .066 .028 r
.39098 .34976 m .37281 .34976 L .35787 .35679 L p F P
0 0 0 r
s
.24 .35 .67 r
.37431 .3533 m
.37642 .3758 L
s
.291 .066 .028 r
.35787 .35679 m .37817 .35679 L .39098 .34976 L p F P
0 0 0 r
s
.24 .35 .67 r
.37399 .34991 m
.374 .35006 L
s
.37364 .34623 m
.37399 .34991 L
s
.83 .24 .1 r
.36624 .35285 m
.36663 .35131 L
s
.24 .35 .67 r
.45169 .27383 m
.4837 .26899 L
s
.48332 .23634 m
.4837 .26899 L
s
.4837 .26899 m
.5163 .26899 L
s
.51668 .23634 m
.5163 .26899 L
s
.5163 .26899 m
.54831 .27383 L
s
.028 .041 .084 r
.65566 .49304 m .65743 .47947 L .65797 .45938 L p F P
0 0 0 r
s
.23 .333 .575 r
.65743 .47947 m .65566 .49304 L .65114 .51338 L p F P
0 0 0 r
s
.24 .35 .67 r
.65152 .51131 m
.65308 .4992 L
s
.65308 .4992 m
.6546 .4735 L
s
.203 .284 .476 r
.34434 .49304 m .34257 .47947 L .34203 .45938 L p F P
0 0 0 r
s
.045 .066 .152 r
.34257 .47947 m .34434 .49304 L .34886 .51338 L p F P
0 0 0 r
s
.24 .35 .67 r
.3454 .4735 m
.34692 .4992 L
s
.34692 .4992 m
.34848 .51131 L
s
.83 .24 .1 r
.22743 .63648 m
.23251 .64765 L
s
.18792 .64765 m
.182 .63648 L
s
.23251 .64765 m
.18792 .64765 L
s
.27286 .63648 m
.27709 .64765 L
s
.27709 .64765 m
.23251 .64765 L
s
.31828 .63648 m
.32167 .64765 L
s
.32167 .64765 m
.27709 .64765 L
s
.36371 .63648 m
.36625 .64765 L
s
.36625 .64765 m
.32167 .64765 L
s
.40914 .63648 m
.41084 .64765 L
s
.41084 .64765 m
.36625 .64765 L
s
.41084 .64765 m
.44768 .64765 L
s
.45121 .64765 m
.45542 .64765 L
s
.5 .64765 m
.45542 .64765 L
s
.54458 .64765 m
.5 .64765 L
s
.58916 .64765 m
.59086 .63648 L
s
.55232 .64765 m
.58916 .64765 L
s
.54458 .64765 m
.54879 .64765 L
s
.63629 .63648 m
.63375 .64765 L
s
.63375 .64765 m
.58916 .64765 L
s
.68172 .63648 m
.67833 .64765 L
s
.67833 .64765 m
.63375 .64765 L
s
.72714 .63648 m
.72291 .64765 L
s
.72291 .64765 m
.67833 .64765 L
s
.77257 .63648 m
.76749 .64765 L
s
.76749 .64765 m
.72291 .64765 L
s
.818 .63648 m
.81208 .64765 L
s
.81208 .64765 m
.76749 .64765 L
s
.936 .286 .123 r
.47498 .6414 m .47855 .6414 L .45824 .64919 L p F P
0 0 0 r
s
.936 .286 .123 r
.45824 .64919 m .45128 .64919 L .47498 .6414 L p F P
0 0 0 r
s
.936 .286 .123 r
.47855 .6414 m .48213 .6414 L .4652 .64919 L p F P
0 0 0 r
s
.936 .286 .123 r
.4652 .64919 m .45824 .64919 L .47855 .6414 L p F P
0 0 0 r
s
.936 .286 .123 r
.48213 .6414 m .4857 .6414 L .47216 .64919 L p F P
0 0 0 r
s
.936 .286 .123 r
.47216 .64919 m .4652 .64919 L .48213 .6414 L p F P
0 0 0 r
s
.936 .286 .123 r
.4857 .6414 m .48928 .6414 L .47912 .64919 L p F P
0 0 0 r
s
.936 .286 .123 r
.47912 .64919 m .47216 .64919 L .4857 .6414 L p F P
0 0 0 r
s
.936 .286 .123 r
.48928 .6414 m .49285 .6414 L .48608 .64919 L p F P
0 0 0 r
s
.936 .286 .123 r
.48608 .64919 m .47912 .64919 L .48928 .6414 L p F P
0 0 0 r
s
.936 .286 .123 r
.49285 .6414 m .49643 .6414 L .49304 .64919 L p F P
0 0 0 r
s
.936 .286 .123 r
.49304 .64919 m .48608 .64919 L .49285 .6414 L p F P
0 0 0 r
s
.936 .286 .123 r
.49643 .6414 m .5 .6414 L .5 .64919 L p F P
0 0 0 r
s
.936 .286 .123 r
.5 .64919 m .49304 .64919 L .49643 .6414 L p F P
0 0 0 r
s
.936 .286 .123 r
.5 .6414 m .50357 .6414 L .50696 .64919 L p F P
0 0 0 r
s
.936 .286 .123 r
.50696 .64919 m .5 .64919 L .5 .6414 L p F P
0 0 0 r
s
.936 .286 .123 r
.50357 .6414 m .50715 .6414 L .51392 .64919 L p F P
0 0 0 r
s
.936 .286 .123 r
.51392 .64919 m .50696 .64919 L .50357 .6414 L p F P
0 0 0 r
s
.936 .286 .123 r
.50715 .6414 m .51072 .6414 L .52088 .64919 L p F P
0 0 0 r
s
.936 .286 .123 r
.52088 .64919 m .51392 .64919 L .50715 .6414 L p F P
0 0 0 r
s
.936 .286 .123 r
.51072 .6414 m .5143 .6414 L .52784 .64919 L p F P
0 0 0 r
s
.936 .286 .123 r
.52784 .64919 m .52088 .64919 L .51072 .6414 L p F P
0 0 0 r
s
.936 .286 .123 r
.5143 .6414 m .51787 .6414 L .5348 .64919 L p F P
0 0 0 r
s
.936 .286 .123 r
.5348 .64919 m .52784 .64919 L .5143 .6414 L p F P
0 0 0 r
s
.936 .286 .123 r
.51787 .6414 m .52145 .6414 L .54176 .64919 L p F P
0 0 0 r
s
.936 .286 .123 r
.54176 .64919 m .5348 .64919 L .51787 .6414 L p F P
0 0 0 r
s
.936 .286 .123 r
.52145 .6414 m .52502 .6414 L .54872 .64919 L p F P
0 0 0 r
s
.24 .35 .67 r
.54815 .64919 m
.54815 .64903 L
s
.936 .286 .123 r
.54872 .64919 m .54176 .64919 L .52145 .6414 L p F P
0 0 0 r
s
.311 .464 .899 r
.54889 .64553 m .54872 .64919 L .52502 .6414 L p F P
0 0 0 r
s
.24 .35 .67 r
.54887 .64552 m
.54889 .64551 L
s
.26 .393 .784 r
.45111 .64553 m .45128 .64919 L .47498 .6414 L p F P
0 0 0 r
s
.24 .35 .67 r
.45111 .64551 m
.45113 .64552 L
s
.322 .48 .92 r
.57198 .63152 m .5716 .63697 L .54924 .63812 L p F P
0 0 0 r
s
.322 .48 .92 r
.54907 .64183 m .54924 .63812 L .5716 .63697 L p F P
0 0 0 r
s
.235 .358 .725 r
.45093 .64183 m .45076 .63812 L .4284 .63697 L p F P
0 0 0 r
s
.235 .358 .725 r
.42802 .63152 m .4284 .63697 L .45076 .63812 L p F P
0 0 0 r
s
.24 .35 .67 r
.36784 .35312 m
.37364 .34623 L
s
.37074 .31531 m
.37364 .34623 L
s
.62926 .31531 m
.62636 .34623 L
s
.62636 .34623 m
.63216 .35312 L
s
.096 .145 .343 r
.64213 .35679 m .64069 .3703 L .65211 .38223 L p F P
0 0 0 r
s
.24 .35 .67 r
.63525 .35679 m
.64422 .36744 L
s
.096 .145 .343 r
.65047 .3964 m .65211 .38223 L .64069 .3703 L p F P
0 0 0 r
s
.24 .35 .67 r
.64102 .39685 m
.64422 .36744 L
s
.32 .464 .852 r
.34953 .3964 m .34789 .38223 L .35931 .3703 L p F P
0 0 0 r
s
.32 .464 .852 r
.35787 .35679 m .35931 .3703 L .34789 .38223 L p F P
0 0 0 r
s
.24 .35 .67 r
.35578 .36744 m
.35898 .39685 L
s
.35578 .36744 m
.36475 .35679 L
s
.51638 .65156 m
.53661 .64787 L
s
.46339 .64787 m
.48362 .65156 L
s
.42143 .28338 m
.45169 .27383 L
s
.45057 .24121 m
.45169 .27383 L
s
.54943 .24121 m
.54831 .27383 L
s
.54831 .27383 m
.57857 .28338 L
s
.052 .076 .18 r
.65797 .45938 m .65979 .44522 L .65625 .42663 L p F P
0 0 0 r
s
.028 .041 .084 r
.65979 .44522 m .65797 .45938 L .65743 .47947 L p F P
0 0 0 r
s
.26 .371 .651 r
.34203 .45938 m .34021 .44522 L .34375 .42663 L p F P
0 0 0 r
s
.203 .284 .476 r
.34021 .44522 m .34203 .45938 L .34257 .47947 L p F P
0 0 0 r
s
.329 .485 .9 r
.61171 .59894 m .61261 .59009 L .62792 .57435 L p F P
0 0 0 r
s
.24 .35 .67 r
.62633 .576 m
.6266 .57358 L
s
.333 .493 .926 r
.61261 .59009 m .61171 .59894 L .59355 .61103 L p F P
0 0 0 r
s
.333 .493 .926 r
.59293 .61825 m .59355 .61103 L .61171 .59894 L p F P
0 0 0 r
s
.169 .262 .556 r
.40707 .61825 m .40645 .61103 L .38829 .59894 L p F P
0 0 0 r
s
.169 .262 .556 r
.38739 .59009 m .38829 .59894 L .40645 .61103 L p F P
0 0 0 r
s
.124 .196 .438 r
.38829 .59894 m .38739 .59009 L .37208 .57435 L p F P
0 0 0 r
s
.24 .35 .67 r
.3734 .57358 m
.37367 .576 L
s
.33 .49 .931 r
.59355 .61103 m .59293 .61825 L .57235 .626 L p F P
0 0 0 r
s
.33 .49 .931 r
.57198 .63152 m .57235 .626 L .59293 .61825 L p F P
0 0 0 r
s
.206 .315 .651 r
.42802 .63152 m .42765 .626 L .40707 .61825 L p F P
0 0 0 r
s
.206 .315 .651 r
.40645 .61103 m .40707 .61825 L .42765 .626 L p F P
0 0 0 r
s
.313 .46 .84 r
.62792 .57435 m .62911 .56398 L .64119 .54545 L p F P
0 0 0 r
s
.329 .485 .9 r
.62911 .56398 m .62792 .57435 L .61261 .59009 L p F P
0 0 0 r
s
.124 .196 .438 r
.37089 .56398 m .37208 .57435 L .38739 .59009 L p F P
0 0 0 r
s
.092 .138 .333 r
.37208 .57435 m .37089 .56398 L .35881 .54545 L p F P
0 0 0 r
s
.072 .105 .259 r
.65625 .42663 m .65803 .41225 L .65047 .3964 L p F P
0 0 0 r
s
.052 .076 .18 r
.65803 .41225 m .65625 .42663 L .65979 .44522 L p F P
0 0 0 r
s
.26 .371 .651 r
.34197 .41225 m .34375 .42663 L .34021 .44522 L p F P
0 0 0 r
s
.298 .43 .775 r
.34375 .42663 m .34197 .41225 L .34953 .3964 L p F P
0 0 0 r
s
.072 .105 .259 r
.65211 .38223 m .65047 .3964 L .65803 .41225 L p F P
0 0 0 r
s
.298 .43 .775 r
.34789 .38223 m .34953 .3964 L .34197 .41225 L p F P
0 0 0 r
s
.311 .464 .899 r
.54907 .64183 m .54889 .64553 L .52507 .63951 L p F P
0 0 0 r
s
.24 .35 .67 r
.54832 .64543 m
.54832 .64538 L
s
.311 .464 .899 r
.52502 .6414 m .52507 .63951 L .54889 .64553 L p F P
0 0 0 r
s
.26 .393 .784 r
.47498 .6414 m .47493 .63951 L .45111 .64553 L p F P
0 0 0 r
s
.26 .393 .784 r
.45093 .64183 m .45111 .64553 L .47493 .63951 L p F P
0 0 0 r
s
.24 .35 .67 r
.51638 .65156 m
.51653 .64207 L
s
.51638 .65156 m
.48362 .65156 L
s
.48347 .64207 m
.48362 .65156 L
s
.281 .411 .734 r
.64119 .54545 m .64264 .53369 L .65114 .51338 L p F P
0 0 0 r
s
.313 .46 .84 r
.64264 .53369 m .64119 .54545 L .62911 .56398 L p F P
0 0 0 r
s
.092 .138 .333 r
.35736 .53369 m .35881 .54545 L .37089 .56398 L p F P
0 0 0 r
s
.068 .1 .244 r
.35881 .54545 m .35736 .53369 L .34886 .51338 L p F P
0 0 0 r
s
.322 .48 .92 r
.57235 .626 m .57198 .63152 L .54941 .63437 L p F P
0 0 0 r
s
.322 .48 .92 r
.54924 .63812 m .54941 .63437 L .57198 .63152 L p F P
0 0 0 r
s
.235 .358 .725 r
.45076 .63812 m .45059 .63437 L .42802 .63152 L p F P
0 0 0 r
s
.235 .358 .725 r
.42765 .626 m .42802 .63152 L .45059 .63437 L p F P
0 0 0 r
s
.24 .35 .67 r
.39408 .29735 m
.42143 .28338 L
s
.41961 .25081 m
.42143 .28338 L
s
.58039 .25081 m
.57857 .28338 L
s
.57857 .28338 m
.60592 .29735 L
s
.311 .464 .899 r
.54924 .63812 m .54907 .64183 L .52511 .63761 L p F P
0 0 0 r
s
.24 .35 .67 r
.54849 .64178 m
.54849 .64173 L
s
.311 .464 .899 r
.52507 .63951 m .52511 .63761 L .54907 .64183 L p F P
0 0 0 r
s
.26 .393 .784 r
.47493 .63951 m .47489 .63761 L .45093 .64183 L p F P
0 0 0 r
s
.26 .393 .784 r
.45076 .63812 m .45093 .64183 L .47489 .63761 L p F P
0 0 0 r
s
.23 .333 .575 r
.65114 .51338 m .6528 .50043 L .65743 .47947 L p F P
0 0 0 r
s
.281 .411 .734 r
.6528 .50043 m .65114 .51338 L .64264 .53369 L p F P
0 0 0 r
s
.24 .35 .67 r
.64411 .52888 m
.64467 .52438 L
s
.068 .1 .244 r
.3472 .50043 m .34886 .51338 L .35736 .53369 L p F P
0 0 0 r
s
.24 .35 .67 r
.35533 .52438 m
.35589 .52888 L
s
.045 .066 .152 r
.34886 .51338 m .3472 .50043 L .34257 .47947 L p F P
0 0 0 r
s
.333 .493 .926 r
.59355 .61103 m .59419 .60371 L .61261 .59009 L p F P
0 0 0 r
s
.33 .49 .931 r
.59419 .60371 m .59355 .61103 L .57273 .62042 L p F P
0 0 0 r
s
.33 .49 .931 r
.57235 .626 m .57273 .62042 L .59355 .61103 L p F P
0 0 0 r
s
.206 .315 .651 r
.42765 .626 m .42727 .62042 L .40645 .61103 L p F P
0 0 0 r
s
.206 .315 .651 r
.40581 .60371 m .40645 .61103 L .42727 .62042 L p F P
0 0 0 r
s
.169 .262 .556 r
.40645 .61103 m .40581 .60371 L .38739 .59009 L p F P
0 0 0 r
s
.329 .485 .9 r
.61261 .59009 m .61353 .5811 L .62911 .56398 L p F P
0 0 0 r
s
.333 .493 .926 r
.61353 .5811 m .61261 .59009 L .59419 .60371 L p F P
0 0 0 r
s
.169 .262 .556 r
.38647 .5811 m .38739 .59009 L .40581 .60371 L p F P
0 0 0 r
s
.24 .35 .67 r
.38261 .58252 m
.38705 .58684 L
s
.124 .196 .438 r
.38739 .59009 m .38647 .5811 L .37089 .56398 L p F P
0 0 0 r
s
.311 .464 .899 r
.54941 .63437 m .54924 .63812 L .52516 .6357 L p F P
0 0 0 r
s
.24 .35 .67 r
.54866 .6381 m
.54866 .63806 L
s
.311 .464 .899 r
.52511 .63761 m .52516 .6357 L .54924 .63812 L p F P
0 0 0 r
s
.83 .24 .1 r
.54489 .6436 m
.54543 .63648 L
s
.26 .393 .784 r
.47489 .63761 m .47484 .6357 L .45076 .63812 L p F P
0 0 0 r
s
.26 .393 .784 r
.45059 .63437 m .45076 .63812 L .47484 .6357 L p F P
0 0 0 r
s
.83 .24 .1 r
.45457 .63648 m
.45511 .6436 L
s
.322 .48 .92 r
.57273 .62042 m .57235 .626 L .54959 .6306 L p F P
0 0 0 r
s
.322 .48 .92 r
.54941 .63437 m .54959 .6306 L .57235 .626 L p F P
0 0 0 r
s
.235 .358 .725 r
.45059 .63437 m .45041 .6306 L .42765 .626 L p F P
0 0 0 r
s
.235 .358 .725 r
.42727 .62042 m .42765 .626 L .45041 .6306 L p F P
0 0 0 r
s
.028 .041 .084 r
.65743 .47947 m .65923 .46558 L .65979 .44522 L p F P
0 0 0 r
s
.24 .35 .67 r
.65276 .42048 m
.65812 .44579 L
s
.23 .333 .575 r
.65923 .46558 m .65743 .47947 L .6528 .50043 L p F P
0 0 0 r
s
.24 .35 .67 r
.6546 .4735 m
.65812 .44579 L
s
.64467 .52438 m
.65296 .49954 L
s
.203 .284 .476 r
.34257 .47947 m .34077 .46558 L .34021 .44522 L p F P
0 0 0 r
s
.045 .066 .152 r
.34077 .46558 m .34257 .47947 L .3472 .50043 L p F P
0 0 0 r
s
.24 .35 .67 r
.34704 .49954 m
.35533 .52438 L
s
.34188 .44579 m
.3454 .4735 L
s
.34188 .44579 m
.34724 .42048 L
s
.096 .145 .343 r
.65211 .38223 m .6538 .36775 L .64213 .35679 L p F P
0 0 0 r
s
.32 .464 .852 r
.34789 .38223 m .3462 .36775 L .35787 .35679 L p F P
0 0 0 r
s
.411 .099 .041 r
.64213 .35679 m .62183 .35679 L .63183 .36775 L p F P
0 0 0 r
s
.411 .099 .041 r
.63183 .36775 m .6538 .36775 L .64213 .35679 L p F P
0 0 0 r
s
.24 .35 .67 r
.64497 .36063 m
.64758 .33666 L
s
.411 .099 .041 r
.62183 .35679 m .60152 .35679 L .60985 .36775 L p F P
0 0 0 r
s
.411 .099 .041 r
.60985 .36775 m .63183 .36775 L .62183 .35679 L p F P
0 0 0 r
s
.411 .099 .041 r
.60152 .35679 m .58122 .35679 L .58788 .36775 L p F P
0 0 0 r
s
.411 .099 .041 r
.58788 .36775 m .60985 .36775 L .60152 .35679 L p F P
0 0 0 r
s
.411 .099 .041 r
.58122 .35679 m .56091 .35679 L .56591 .36775 L p F P
0 0 0 r
s
.411 .099 .041 r
.56591 .36775 m .58788 .36775 L .58122 .35679 L p F P
0 0 0 r
s
.411 .099 .041 r
.56091 .35679 m .54061 .35679 L .54394 .36775 L p F P
0 0 0 r
s
.411 .099 .041 r
.54394 .36775 m .56591 .36775 L .56091 .35679 L p F P
0 0 0 r
s
.411 .099 .041 r
.54061 .35679 m .5203 .35679 L .52197 .36775 L p F P
0 0 0 r
s
.411 .099 .041 r
.52197 .36775 m .54394 .36775 L .54061 .35679 L p F P
0 0 0 r
s
.411 .099 .041 r
.5203 .35679 m .5 .35679 L .5 .36775 L p F P
0 0 0 r
s
.411 .099 .041 r
.5 .36775 m .52197 .36775 L .5203 .35679 L p F P
0 0 0 r
s
.411 .099 .041 r
.5 .35679 m .4797 .35679 L .47803 .36775 L p F P
0 0 0 r
s
.411 .099 .041 r
.47803 .36775 m .5 .36775 L .5 .35679 L p F P
0 0 0 r
s
.411 .099 .041 r
.4797 .35679 m .45939 .35679 L .45606 .36775 L p F P
0 0 0 r
s
.411 .099 .041 r
.45606 .36775 m .47803 .36775 L .4797 .35679 L p F P
0 0 0 r
s
.411 .099 .041 r
.45939 .35679 m .43909 .35679 L .43409 .36775 L p F P
0 0 0 r
s
.411 .099 .041 r
.43409 .36775 m .45606 .36775 L .45939 .35679 L p F P
0 0 0 r
s
.411 .099 .041 r
.43909 .35679 m .41878 .35679 L .41212 .36775 L p F P
0 0 0 r
s
.411 .099 .041 r
.41212 .36775 m .43409 .36775 L .43909 .35679 L p F P
0 0 0 r
s
.411 .099 .041 r
.41878 .35679 m .39848 .35679 L .39015 .36775 L p F P
0 0 0 r
s
.411 .099 .041 r
.39015 .36775 m .41212 .36775 L .41878 .35679 L p F P
0 0 0 r
s
.411 .099 .041 r
.39848 .35679 m .37817 .35679 L .36817 .36775 L p F P
0 0 0 r
s
.411 .099 .041 r
.36817 .36775 m .39015 .36775 L .39848 .35679 L p F P
0 0 0 r
s
.411 .099 .041 r
.37817 .35679 m .35787 .35679 L .3462 .36775 L p F P
0 0 0 r
s
.411 .099 .041 r
.3462 .36775 m .36817 .36775 L .37817 .35679 L p F P
0 0 0 r
s
.24 .35 .67 r
.35242 .33666 m
.35503 .36063 L
s
.313 .46 .84 r
.62911 .56398 m .63032 .55341 L .64264 .53369 L p F P
0 0 0 r
s
.329 .485 .9 r
.63032 .55341 m .62911 .56398 L .61353 .5811 L p F P
0 0 0 r
s
.124 .196 .438 r
.36968 .55341 m .37089 .56398 L .38647 .5811 L p F P
0 0 0 r
s
.092 .138 .333 r
.37089 .56398 m .36968 .55341 L .35736 .53369 L p F P
0 0 0 r
s
.052 .076 .18 r
.65979 .44522 m .66164 .43072 L .65803 .41225 L p F P
0 0 0 r
s
.028 .041 .084 r
.66164 .43072 m .65979 .44522 L .65923 .46558 L p F P
0 0 0 r
s
.26 .371 .651 r
.34021 .44522 m .33836 .43072 L .34197 .41225 L p F P
0 0 0 r
s
.203 .284 .476 r
.33836 .43072 m .34021 .44522 L .34077 .46558 L p F P
0 0 0 r
s
.24 .35 .67 r
.37074 .31531 m
.39408 .29735 L
s
.39161 .26485 m
.39408 .29735 L
s
.60839 .26485 m
.60592 .29735 L
s
.60592 .29735 m
.62926 .31531 L
s
.311 .464 .899 r
.54959 .6306 m .54941 .63437 L .5252 .63378 L p F P
0 0 0 r
s
.24 .35 .67 r
.54883 .6344 m
.54883 .63436 L
s
.311 .464 .899 r
.52516 .6357 m .5252 .63378 L .54941 .63437 L p F P
0 0 0 r
s
.26 .393 .784 r
.47484 .6357 m .4748 .63378 L .45059 .63437 L p F P
0 0 0 r
s
.26 .393 .784 r
.45041 .6306 m .45059 .63437 L .4748 .63378 L p F P
0 0 0 r
s
.298 .43 .775 r
.34197 .41225 m .34015 .39754 L .34789 .38223 L p F P
0 0 0 r
s
.298 .43 .775 r
.3462 .36775 m .34789 .38223 L .34015 .39754 L p F P
0 0 0 r
s
.24 .35 .67 r
.34372 .39126 m
.34724 .42048 L
s
.34372 .39126 m
.35562 .36775 L
s
.072 .105 .259 r
.6538 .36775 m .65211 .38223 L .65985 .39754 L p F P
0 0 0 r
s
.072 .105 .259 r
.65803 .41225 m .65985 .39754 L .65211 .38223 L p F P
0 0 0 r
s
.24 .35 .67 r
.65276 .42048 m
.65628 .39126 L
s
.64438 .36775 m
.65628 .39126 L
s
.99 .297 .127 r
.47855 .6414 m .47498 .6414 L .5 .62969 L closepath p F P
0 0 0 r
s
.99 .297 .127 r
.48213 .6414 m .47855 .6414 L .5 .62969 L closepath p F P
0 0 0 r
s
.99 .297 .127 r
.4857 .6414 m .48213 .6414 L .5 .62969 L closepath p F P
0 0 0 r
s
.99 .297 .127 r
.48928 .6414 m .4857 .6414 L .5 .62969 L closepath p F P
0 0 0 r
s
.99 .297 .127 r
.49285 .6414 m .48928 .6414 L .5 .62969 L closepath p F P
0 0 0 r
s
.99 .297 .127 r
.49643 .6414 m .49285 .6414 L .5 .62969 L closepath p F P
0 0 0 r
s
.99 .297 .127 r
.5 .6414 m .49643 .6414 L .5 .62969 L closepath p F P
0 0 0 r
s
.99 .297 .127 r
.50357 .6414 m .5 .6414 L .5 .62969 L closepath p F P
0 0 0 r
s
.99 .297 .127 r
.50715 .6414 m .50357 .6414 L .5 .62969 L closepath p F P
0 0 0 r
s
.99 .297 .127 r
.51072 .6414 m .50715 .6414 L .5 .62969 L closepath p F P
0 0 0 r
s
.99 .297 .127 r
.5143 .6414 m .51072 .6414 L .5 .62969 L closepath p F P
0 0 0 r
s
.99 .297 .127 r
.51787 .6414 m .5143 .6414 L .5 .62969 L closepath p F P
0 0 0 r
s
.99 .297 .127 r
.52145 .6414 m .51787 .6414 L .5 .62969 L closepath p F P
0 0 0 r
s
.99 .297 .127 r
.52502 .6414 m .52145 .6414 L .5 .62969 L closepath p F P
0 0 0 r
s
.297 .445 .87 r
.5 .62969 m .52507 .63951 L .52502 .6414 L closepath p F P
0 0 0 r
s
.28 .421 .831 r
.47493 .63951 m .47498 .6414 L .5 .62969 L closepath p F P
0 0 0 r
s
.052 .076 .18 r
.65985 .39754 m .65803 .41225 L .66164 .43072 L p F P
0 0 0 r
s
.26 .371 .651 r
.34015 .39754 m .34197 .41225 L .33836 .43072 L p F P
0 0 0 r
s
.281 .411 .734 r
.64264 .53369 m .64412 .52169 L .6528 .50043 L p F P
0 0 0 r
s
.313 .46 .84 r
.64412 .52169 m .64264 .53369 L .63032 .55341 L p F P
0 0 0 r
s
.092 .138 .333 r
.35588 .52169 m .35736 .53369 L .36968 .55341 L p F P
0 0 0 r
s
.24 .35 .67 r
.35533 .52438 m
.35642 .52606 L
s
.068 .1 .244 r
.35736 .53369 m .35588 .52169 L .3472 .50043 L p F P
0 0 0 r
s
.83 .24 .1 r
.22814 .36147 m
.18283 .36147 L
s
.27345 .36147 m
.22814 .36147 L
s
.31876 .36147 m
.27345 .36147 L
s
.31876 .36147 m
.35288 .36147 L
s
.64712 .36147 m
.68124 .36147 L
s
.72655 .36147 m
.68124 .36147 L
s
.77186 .36147 m
.72655 .36147 L
s
.81717 .36147 m
.77186 .36147 L
s
.22814 .36147 m
.22342 .37848 L
s
.17732 .37848 m
.18283 .36147 L
s
.27345 .36147 m
.26952 .37848 L
s
.31876 .36147 m
.31561 .37848 L
s
.68124 .36147 m
.68439 .37848 L
s
.72655 .36147 m
.73048 .37848 L
s
.77186 .36147 m
.77658 .37848 L
s
.81717 .36147 m
.82268 .37848 L
s
.33 .49 .931 r
.57273 .62042 m .57311 .61479 L .59419 .60371 L p F P
0 0 0 r
s
.322 .48 .92 r
.57311 .61479 m .57273 .62042 L .54977 .6268 L p F P
0 0 0 r
s
.322 .48 .92 r
.54959 .6306 m .54977 .6268 L .57273 .62042 L p F P
0 0 0 r
s
.235 .358 .725 r
.45041 .6306 m .45023 .6268 L .42727 .62042 L p F P
0 0 0 r
s
.235 .358 .725 r
.42689 .61479 m .42727 .62042 L .45023 .6268 L p F P
0 0 0 r
s
.206 .315 .651 r
.42727 .62042 m .42689 .61479 L .40581 .60371 L p F P
0 0 0 r
s
.297 .445 .87 r
.5 .62969 m .52511 .63761 L .52507 .63951 L closepath p F P
0 0 0 r
s
.28 .421 .831 r
.47489 .63761 m .47493 .63951 L .5 .62969 L closepath p F P
0 0 0 r
s
.333 .493 .926 r
.59419 .60371 m .59483 .59629 L .61353 .5811 L p F P
0 0 0 r
s
.33 .49 .931 r
.59483 .59629 m .59419 .60371 L .57311 .61479 L p F P
0 0 0 r
s
.206 .315 .651 r
.40517 .59629 m .40581 .60371 L .42689 .61479 L p F P
0 0 0 r
s
.24 .35 .67 r
.40098 .59806 m
.40557 .60093 L
s
.169 .262 .556 r
.40581 .60371 m .40517 .59629 L .38647 .5811 L p F P
0 0 0 r
s
.311 .464 .899 r
.54977 .6268 m .54959 .6306 L .52525 .63186 L p F P
0 0 0 r
s
.24 .35 .67 r
.549 .63068 m
.549 .63063 L
s
.311 .464 .899 r
.5252 .63378 m .52525 .63186 L .54959 .6306 L p F P
0 0 0 r
s
.26 .393 .784 r
.4748 .63378 m .47475 .63186 L .45041 .6306 L p F P
0 0 0 r
s
.26 .393 .784 r
.45023 .6268 m .45041 .6306 L .47475 .63186 L p F P
0 0 0 r
s
.297 .445 .87 r
.5 .62969 m .52516 .6357 L .52511 .63761 L closepath p F P
0 0 0 r
s
.28 .421 .831 r
.47484 .6357 m .47489 .63761 L .5 .62969 L closepath p F P
0 0 0 r
s
.329 .485 .9 r
.61353 .5811 m .61447 .57195 L .63032 .55341 L p F P
0 0 0 r
s
.333 .493 .926 r
.61447 .57195 m .61353 .5811 L .59483 .59629 L p F P
0 0 0 r
s
.169 .262 .556 r
.38553 .57195 m .38647 .5811 L .40517 .59629 L p F P
0 0 0 r
s
.124 .196 .438 r
.38647 .5811 m .38553 .57195 L .36968 .55341 L p F P
0 0 0 r
s
.83 .24 .1 r
.22278 .61852 m
.22743 .63648 L
s
.182 .63648 m
.17658 .61852 L
s
.22743 .63648 m
.182 .63648 L
s
.26899 .61852 m
.27286 .63648 L
s
.27286 .63648 m
.22743 .63648 L
s
.31519 .61852 m
.31828 .63648 L
s
.31828 .63648 m
.27286 .63648 L
s
.36139 .61852 m
.36371 .63648 L
s
.36371 .63648 m
.31828 .63648 L
s
.40759 .61852 m
.40914 .63648 L
s
.40914 .63648 m
.36371 .63648 L
s
.40914 .63648 m
.45457 .63648 L
s
.45457 .63648 m
.47279 .63648 L
s
.52721 .63648 m
.54543 .63648 L
s
.59086 .63648 m
.59241 .61852 L
s
.54543 .63648 m
.59086 .63648 L
s
.63861 .61852 m
.63629 .63648 L
s
.63629 .63648 m
.59086 .63648 L
s
.68481 .61852 m
.68172 .63648 L
s
.68172 .63648 m
.63629 .63648 L
s
.73101 .61852 m
.72714 .63648 L
s
.72714 .63648 m
.68172 .63648 L
s
.77722 .61852 m
.77257 .63648 L
s
.77257 .63648 m
.72714 .63648 L
s
.82342 .61852 m
.818 .63648 L
s
.818 .63648 m
.77257 .63648 L
s
.23 .333 .575 r
.6528 .50043 m .6545 .48719 L .65923 .46558 L p F P
0 0 0 r
s
.281 .411 .734 r
.6545 .48719 m .6528 .50043 L .64412 .52169 L p F P
0 0 0 r
s
.068 .1 .244 r
.3455 .48719 m .3472 .50043 L .35588 .52169 L p F P
0 0 0 r
s
.045 .066 .152 r
.3472 .50043 m .3455 .48719 L .34077 .46558 L p F P
0 0 0 r
s
.297 .445 .87 r
.5 .62969 m .5252 .63378 L .52516 .6357 L closepath p F P
0 0 0 r
s
.28 .421 .831 r
.4748 .63378 m .47484 .6357 L .5 .62969 L closepath p F P
0 0 0 r
s
.33 .49 .931 r
.57311 .61479 m .5735 .6091 L .59483 .59629 L p F P
0 0 0 r
s
.322 .48 .92 r
.5735 .6091 m .57311 .61479 L .54995 .62298 L p F P
0 0 0 r
s
.322 .48 .92 r
.54977 .6268 m .54995 .62298 L .57311 .61479 L p F P
0 0 0 r
s
.24 .35 .67 r
.54942 .62168 m
.55711 .61875 L
s
.235 .358 .725 r
.45023 .6268 m .45005 .62298 L .42689 .61479 L p F P
0 0 0 r
s
.235 .358 .725 r
.4265 .6091 m .42689 .61479 L .45005 .62298 L p F P
0 0 0 r
s
.24 .35 .67 r
.42241 .61098 m
.42674 .61262 L
s
.44289 .61875 m
.45058 .62168 L
s
.206 .315 .651 r
.42689 .61479 m .4265 .6091 L .40517 .59629 L p F P
0 0 0 r
s
.311 .464 .899 r
.54995 .62298 m .54977 .6268 L .5253 .62994 L p F P
0 0 0 r
s
.24 .35 .67 r
.54918 .62692 m
.54918 .62688 L
s
.54935 .62315 m
.54942 .62168 L
s
.311 .464 .899 r
.52525 .63186 m .5253 .62994 L .54977 .6268 L p F P
0 0 0 r
s
.26 .393 .784 r
.47475 .63186 m .4747 .62994 L .45023 .6268 L p F P
0 0 0 r
s
.26 .393 .784 r
.45005 .62298 m .45023 .6268 L .4747 .62994 L p F P
0 0 0 r
s
.24 .35 .67 r
.45058 .62168 m
.45065 .62315 L
s
.313 .46 .84 r
.63032 .55341 m .63156 .54264 L .64412 .52169 L p F P
0 0 0 r
s
.329 .485 .9 r
.63156 .54264 m .63032 .55341 L .61447 .57195 L p F P
0 0 0 r
s
.124 .196 .438 r
.36844 .54264 m .36968 .55341 L .38553 .57195 L p F P
0 0 0 r
s
.092 .138 .333 r
.36968 .55341 m .36844 .54264 L .35588 .52169 L p F P
0 0 0 r
s
.297 .445 .87 r
.5 .62969 m .52525 .63186 L .5252 .63378 L closepath p F P
0 0 0 r
s
.28 .421 .831 r
.47475 .63186 m .4748 .63378 L .5 .62969 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.45057 .24121 m
.48332 .23634 L
s
.48293 .20215 m
.48332 .23634 L
s
.48332 .23634 m
.51668 .23634 L
s
.51707 .20215 m
.51668 .23634 L
s
.51668 .23634 m
.54943 .24121 L
s
.028 .041 .084 r
.65923 .46558 m .66108 .45138 L .66164 .43072 L p F P
0 0 0 r
s
.23 .333 .575 r
.66108 .45138 m .65923 .46558 L .6545 .48719 L p F P
0 0 0 r
s
.24 .35 .67 r
.6549 .48501 m
.65661 .47174 L
s
.65661 .47174 m
.65812 .44579 L
s
.203 .284 .476 r
.34077 .46558 m .33892 .45138 L .33836 .43072 L p F P
0 0 0 r
s
.045 .066 .152 r
.33892 .45138 m .34077 .46558 L .3455 .48719 L p F P
0 0 0 r
s
.24 .35 .67 r
.34188 .44579 m
.34339 .47174 L
s
.34339 .47174 m
.3451 .48501 L
s
.333 .493 .926 r
.59483 .59629 m .59548 .58877 L .61447 .57195 L p F P
0 0 0 r
s
.33 .49 .931 r
.59548 .58877 m .59483 .59629 L .5735 .6091 L p F P
0 0 0 r
s
.206 .315 .651 r
.40452 .58877 m .40517 .59629 L .4265 .6091 L p F P
0 0 0 r
s
.169 .262 .556 r
.40517 .59629 m .40452 .58877 L .38553 .57195 L p F P
0 0 0 r
s
.24 .35 .67 r
.35242 .33666 m
.37074 .31531 L
s
.36769 .28292 m
.37074 .31531 L
s
.63231 .28292 m
.62926 .31531 L
s
.62926 .31531 m
.64758 .33666 L
s
.297 .445 .87 r
.5 .62969 m .5253 .62994 L .52525 .63186 L closepath p F P
0 0 0 r
s
.28 .421 .831 r
.4747 .62994 m .47475 .63186 L .5 .62969 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.41961 .25081 m
.45057 .24121 L
s
.44941 .20704 m
.45057 .24121 L
s
.55059 .20704 m
.54943 .24121 L
s
.54943 .24121 m
.58039 .25081 L
s
.322 .48 .92 r
.54995 .62298 m .55013 .61912 L .5735 .6091 L p F P
0 0 0 r
s
.311 .464 .899 r
.55013 .61912 m .54995 .62298 L .52534 .628 L p F P
0 0 0 r
s
.311 .464 .899 r
.5253 .62994 m .52534 .628 L .54995 .62298 L p F P
0 0 0 r
s
.24 .35 .67 r
.51676 .62757 m
.53647 .62401 L
s
.26 .393 .784 r
.4747 .62994 m .47466 .628 L .45005 .62298 L p F P
0 0 0 r
s
.26 .393 .784 r
.44987 .61912 m .45005 .62298 L .47466 .628 L p F P
0 0 0 r
s
.24 .35 .67 r
.46353 .62401 m
.48324 .62757 L
s
.235 .358 .725 r
.45005 .62298 m .44987 .61912 L .4265 .6091 L p F P
0 0 0 r
s
.052 .076 .18 r
.66164 .43072 m .66355 .41589 L .65985 .39754 L p F P
0 0 0 r
s
.028 .041 .084 r
.66355 .41589 m .66164 .43072 L .66108 .45138 L p F P
0 0 0 r
s
.26 .371 .651 r
.33836 .43072 m .33645 .41589 L .34015 .39754 L p F P
0 0 0 r
s
.203 .284 .476 r
.33645 .41589 m .33836 .43072 L .33892 .45138 L p F P
0 0 0 r
s
.297 .445 .87 r
.5 .62969 m .52534 .628 L .5253 .62994 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.51674 .62857 m
.51676 .62757 L
s
.28 .421 .831 r
.47466 .628 m .4747 .62994 L .5 .62969 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.48324 .62757 m
.48326 .62857 L
s
.072 .105 .259 r
.65985 .39754 m .66171 .38248 L .6538 .36775 L p F P
0 0 0 r
s
.298 .43 .775 r
.34015 .39754 m .33829 .38248 L .3462 .36775 L p F P
0 0 0 r
s
.557 .144 .061 r
.6538 .36775 m .63183 .36775 L .63861 .38248 L p F P
0 0 0 r
s
.557 .144 .061 r
.63861 .38248 m .66171 .38248 L .6538 .36775 L p F P
0 0 0 r
s
.24 .35 .67 r
.65791 .37767 m
.65995 .36067 L
s
.65628 .39126 m
.65733 .38248 L
s
.557 .144 .061 r
.63183 .36775 m .60985 .36775 L .61551 .38248 L p F P
0 0 0 r
s
.557 .144 .061 r
.61551 .38248 m .63861 .38248 L .63183 .36775 L p F P
0 0 0 r
s
.557 .144 .061 r
.60985 .36775 m .58788 .36775 L .59241 .38248 L p F P
0 0 0 r
s
.557 .144 .061 r
.59241 .38248 m .61551 .38248 L .60985 .36775 L p F P
0 0 0 r
s
.557 .144 .061 r
.58788 .36775 m .56591 .36775 L .5693 .38248 L p F P
0 0 0 r
s
.557 .144 .061 r
.5693 .38248 m .59241 .38248 L .58788 .36775 L p F P
0 0 0 r
s
.557 .144 .061 r
.56591 .36775 m .54394 .36775 L .5462 .38248 L p F P
0 0 0 r
s
.557 .144 .061 r
.5462 .38248 m .5693 .38248 L .56591 .36775 L p F P
0 0 0 r
s
.557 .144 .061 r
.54394 .36775 m .52197 .36775 L .5231 .38248 L p F P
0 0 0 r
s
.557 .144 .061 r
.5231 .38248 m .5462 .38248 L .54394 .36775 L p F P
0 0 0 r
s
.557 .144 .061 r
.52197 .36775 m .5 .36775 L .5 .38248 L p F P
0 0 0 r
s
.557 .144 .061 r
.5 .38248 m .5231 .38248 L .52197 .36775 L p F P
0 0 0 r
s
.557 .144 .061 r
.5 .36775 m .47803 .36775 L .4769 .38248 L p F P
0 0 0 r
s
.557 .144 .061 r
.4769 .38248 m .5 .38248 L .5 .36775 L p F P
0 0 0 r
s
.557 .144 .061 r
.47803 .36775 m .45606 .36775 L .4538 .38248 L p F P
0 0 0 r
s
.557 .144 .061 r
.4538 .38248 m .4769 .38248 L .47803 .36775 L p F P
0 0 0 r
s
.557 .144 .061 r
.45606 .36775 m .43409 .36775 L .4307 .38248 L p F P
0 0 0 r
s
.557 .144 .061 r
.4307 .38248 m .4538 .38248 L .45606 .36775 L p F P
0 0 0 r
s
.557 .144 .061 r
.43409 .36775 m .41212 .36775 L .40759 .38248 L p F P
0 0 0 r
s
.557 .144 .061 r
.40759 .38248 m .4307 .38248 L .43409 .36775 L p F P
0 0 0 r
s
.557 .144 .061 r
.41212 .36775 m .39015 .36775 L .38449 .38248 L p F P
0 0 0 r
s
.557 .144 .061 r
.38449 .38248 m .40759 .38248 L .41212 .36775 L p F P
0 0 0 r
s
.557 .144 .061 r
.39015 .36775 m .36817 .36775 L .36139 .38248 L p F P
0 0 0 r
s
.557 .144 .061 r
.36139 .38248 m .38449 .38248 L .39015 .36775 L p F P
0 0 0 r
s
.557 .144 .061 r
.36817 .36775 m .3462 .36775 L .33829 .38248 L p F P
0 0 0 r
s
.557 .144 .061 r
.33829 .38248 m .36139 .38248 L .36817 .36775 L p F P
0 0 0 r
s
.24 .35 .67 r
.34267 .38248 m
.34372 .39126 L
s
.34005 .36067 m
.34209 .37767 L
s
.281 .411 .734 r
.64412 .52169 m .64563 .50943 L .6545 .48719 L p F P
0 0 0 r
s
.313 .46 .84 r
.64563 .50943 m .64412 .52169 L .63156 .54264 L p F P
0 0 0 r
s
.092 .138 .333 r
.35437 .50943 m .35588 .52169 L .36844 .54264 L p F P
0 0 0 r
s
.068 .1 .244 r
.35588 .52169 m .35437 .50943 L .3455 .48719 L p F P
0 0 0 r
s
.052 .076 .18 r
.66171 .38248 m .65985 .39754 L .66355 .41589 L p F P
0 0 0 r
s
.26 .371 .651 r
.33829 .38248 m .34015 .39754 L .33645 .41589 L p F P
0 0 0 r
s
.329 .485 .9 r
.61447 .57195 m .61542 .56266 L .63156 .54264 L p F P
0 0 0 r
s
.333 .493 .926 r
.61542 .56266 m .61447 .57195 L .59548 .58877 L p F P
0 0 0 r
s
.169 .262 .556 r
.38458 .56266 m .38553 .57195 L .40452 .58877 L p F P
0 0 0 r
s
.124 .196 .438 r
.38553 .57195 m .38458 .56266 L .36844 .54264 L p F P
0 0 0 r
s
.33 .49 .931 r
.5735 .6091 m .57389 .60335 L .59548 .58877 L p F P
0 0 0 r
s
.322 .48 .92 r
.57389 .60335 m .5735 .6091 L .55013 .61912 L p F P
0 0 0 r
s
.235 .358 .725 r
.42611 .60335 m .4265 .6091 L .44987 .61912 L p F P
0 0 0 r
s
.206 .315 .651 r
.4265 .6091 m .42611 .60335 L .40452 .58877 L p F P
0 0 0 r
s
.24 .35 .67 r
.51676 .62757 m
.48324 .62757 L
s
.311 .464 .899 r
.52534 .628 m .52539 .62606 L .55013 .61912 L p F P
0 0 0 r
s
.297 .445 .87 r
.5 .62969 m .52539 .62606 L .52534 .628 L closepath p F P
0 0 0 r
s
.28 .421 .831 r
.47461 .62606 m .47466 .628 L .5 .62969 L closepath p F P
0 0 0 r
s
.26 .393 .784 r
.47466 .628 m .47461 .62606 L .44987 .61912 L p F P
0 0 0 r
s
.999 .296 .126 r
.5 .62969 m .52567 .61425 L .522 .61425 L closepath p F P
0 0 0 r
s
.999 .296 .126 r
.5 .62969 m .522 .61425 L .51834 .61425 L closepath p F P
0 0 0 r
s
.999 .296 .126 r
.5 .62969 m .51834 .61425 L .51467 .61425 L closepath p F P
0 0 0 r
s
.999 .296 .126 r
.5 .62969 m .51467 .61425 L .511 .61425 L closepath p F P
0 0 0 r
s
.999 .296 .126 r
.5 .62969 m .511 .61425 L .50733 .61425 L closepath p F P
0 0 0 r
s
.999 .296 .126 r
.5 .62969 m .50733 .61425 L .50367 .61425 L closepath p F P
0 0 0 r
s
.999 .296 .126 r
.5 .62969 m .50367 .61425 L .5 .61425 L closepath p F P
0 0 0 r
s
.999 .296 .126 r
.5 .62969 m .5 .61425 L .49633 .61425 L closepath p F P
0 0 0 r
s
.999 .296 .126 r
.5 .62969 m .49633 .61425 L .49267 .61425 L closepath p F P
0 0 0 r
s
.999 .296 .126 r
.5 .62969 m .49267 .61425 L .489 .61425 L closepath p F P
0 0 0 r
s
.999 .296 .126 r
.5 .62969 m .489 .61425 L .48533 .61425 L closepath p F P
0 0 0 r
s
.999 .296 .126 r
.5 .62969 m .48533 .61425 L .48166 .61425 L closepath p F P
0 0 0 r
s
.999 .296 .126 r
.5 .62969 m .48166 .61425 L .478 .61425 L closepath p F P
0 0 0 r
s
.999 .296 .126 r
.5 .62969 m .478 .61425 L .47433 .61425 L closepath p F P
0 0 0 r
s
.297 .445 .87 r
.5 .62969 m .52567 .61425 L .52562 .61624 L closepath p F P
0 0 0 r
s
.297 .445 .87 r
.5 .62969 m .52562 .61624 L .52557 .61822 L closepath p F P
0 0 0 r
s
.297 .445 .87 r
.5 .62969 m .52557 .61822 L .52553 .62019 L closepath p F P
0 0 0 r
s
.297 .445 .87 r
.5 .62969 m .52553 .62019 L .52548 .62215 L closepath p F P
0 0 0 r
s
.297 .445 .87 r
.5 .62969 m .52548 .62215 L .52543 .62411 L closepath p F P
0 0 0 r
s
.297 .445 .87 r
.5 .62969 m .52543 .62411 L .52539 .62606 L closepath p F P
0 0 0 r
s
.28 .421 .831 r
.47457 .62411 m .47461 .62606 L .5 .62969 L closepath p F P
0 0 0 r
s
.28 .421 .831 r
.47452 .62215 m .47457 .62411 L .5 .62969 L closepath p F P
0 0 0 r
s
.28 .421 .831 r
.47447 .62019 m .47452 .62215 L .5 .62969 L closepath p F P
0 0 0 r
s
.28 .421 .831 r
.47443 .61822 m .47447 .62019 L .5 .62969 L closepath p F P
0 0 0 r
s
.28 .421 .831 r
.47438 .61624 m .47443 .61822 L .5 .62969 L closepath p F P
0 0 0 r
s
.28 .421 .831 r
.47433 .61425 m .47438 .61624 L .5 .62969 L closepath p F P
0 0 0 r
s
.322 .48 .92 r
.55013 .61912 m .55031 .61524 L .57389 .60335 L p F P
0 0 0 r
s
.311 .464 .899 r
.55031 .61524 m .55013 .61912 L .52539 .62606 L p F P
0 0 0 r
s
.26 .393 .784 r
.44969 .61524 m .44987 .61912 L .47461 .62606 L p F P
0 0 0 r
s
.235 .358 .725 r
.44987 .61912 m .44969 .61524 L .42611 .60335 L p F P
0 0 0 r
s
.311 .464 .899 r
.52539 .62606 m .52543 .62411 L .55031 .61524 L p F P
0 0 0 r
s
.26 .393 .784 r
.47461 .62606 m .47457 .62411 L .44969 .61524 L p F P
0 0 0 r
s
.24 .35 .67 r
.39161 .26485 m
.41961 .25081 L
s
.41771 .21669 m
.41961 .25081 L
s
.58229 .21669 m
.58039 .25081 L
s
.58039 .25081 m
.60839 .26485 L
s
.333 .493 .926 r
.59548 .58877 m .59614 .58114 L .61542 .56266 L p F P
0 0 0 r
s
.33 .49 .931 r
.59614 .58114 m .59548 .58877 L .57389 .60335 L p F P
0 0 0 r
s
.206 .315 .651 r
.40386 .58114 m .40452 .58877 L .42611 .60335 L p F P
0 0 0 r
s
.169 .262 .556 r
.40452 .58877 m .40386 .58114 L .38458 .56266 L p F P
0 0 0 r
s
.23 .333 .575 r
.6545 .48719 m .65624 .47365 L .66108 .45138 L p F P
0 0 0 r
s
.281 .411 .734 r
.65624 .47365 m .6545 .48719 L .64563 .50943 L p F P
0 0 0 r
s
.068 .1 .244 r
.34376 .47365 m .3455 .48719 L .35437 .50943 L p F P
0 0 0 r
s
.045 .066 .152 r
.3455 .48719 m .34376 .47365 L .33892 .45138 L p F P
0 0 0 r
s
.311 .464 .899 r
.55049 .61133 m .55031 .61524 L .52543 .62411 L p F P
0 0 0 r
s
.311 .464 .899 r
.52543 .62411 m .52548 .62215 L .55049 .61133 L p F P
0 0 0 r
s
.26 .393 .784 r
.47457 .62411 m .47452 .62215 L .44951 .61133 L p F P
0 0 0 r
s
.26 .393 .784 r
.44951 .61133 m .44969 .61524 L .47457 .62411 L p F P
0 0 0 r
s
.313 .46 .84 r
.63156 .54264 m .63282 .53166 L .64563 .50943 L p F P
0 0 0 r
s
.329 .485 .9 r
.63282 .53166 m .63156 .54264 L .61542 .56266 L p F P
0 0 0 r
s
.124 .196 .438 r
.36718 .53166 m .36844 .54264 L .38458 .56266 L p F P
0 0 0 r
s
.092 .138 .333 r
.36844 .54264 m .36718 .53166 L .35437 .50943 L p F P
0 0 0 r
s
.33 .49 .931 r
.57389 .60335 m .57428 .59753 L .59614 .58114 L p F P
0 0 0 r
s
.322 .48 .92 r
.57428 .59753 m .57389 .60335 L .55031 .61524 L p F P
0 0 0 r
s
.235 .358 .725 r
.42572 .59753 m .42611 .60335 L .44969 .61524 L p F P
0 0 0 r
s
.206 .315 .651 r
.42611 .60335 m .42572 .59753 L .40386 .58114 L p F P
0 0 0 r
s
.322 .48 .92 r
.55031 .61524 m .55049 .61133 L .57428 .59753 L p F P
0 0 0 r
s
.235 .358 .725 r
.44969 .61524 m .44951 .61133 L .42572 .59753 L p F P
0 0 0 r
s
.311 .464 .899 r
.55068 .6074 m .55049 .61133 L .52548 .62215 L p F P
0 0 0 r
s
.311 .464 .899 r
.52548 .62215 m .52553 .62019 L .55068 .6074 L p F P
0 0 0 r
s
.26 .393 .784 r
.47452 .62215 m .47447 .62019 L .44932 .6074 L p F P
0 0 0 r
s
.26 .393 .784 r
.44932 .6074 m .44951 .61133 L .47452 .62215 L p F P
0 0 0 r
s
.83 .24 .1 r
.22342 .37848 m
.17732 .37848 L
s
.26952 .37848 m
.22342 .37848 L
s
.31561 .37848 m
.26952 .37848 L
s
.31561 .37848 m
.34044 .37848 L
s
.65956 .37848 m
.68439 .37848 L
s
.73048 .37848 m
.68439 .37848 L
s
.77658 .37848 m
.73048 .37848 L
s
.82268 .37848 m
.77658 .37848 L
s
.22342 .37848 m
.21936 .40178 L
s
.17259 .40178 m
.17732 .37848 L
s
.26952 .37848 m
.26614 .40178 L
s
.31561 .37848 m
.31291 .40178 L
s
.68439 .37848 m
.68709 .40178 L
s
.73048 .37848 m
.73386 .40178 L
s
.77658 .37848 m
.78064 .40178 L
s
.82268 .37848 m
.82741 .40178 L
s
.028 .041 .084 r
.66108 .45138 m .66297 .43684 L .66355 .41589 L p F P
0 0 0 r
s
.24 .35 .67 r
.65628 .39126 m
.6618 .41679 L
s
.23 .333 .575 r
.66297 .43684 m .66108 .45138 L .65624 .47365 L p F P
0 0 0 r
s
.24 .35 .67 r
.65812 .44579 m
.6618 .41679 L
s
.203 .284 .476 r
.33892 .45138 m .33703 .43684 L .33645 .41589 L p F P
0 0 0 r
s
.045 .066 .152 r
.33703 .43684 m .33892 .45138 L .34376 .47365 L p F P
0 0 0 r
s
.24 .35 .67 r
.3382 .41679 m
.34188 .44579 L
s
.3382 .41679 m
.34372 .39126 L
s
.65109 .30442 m
.64758 .33666 L
s
.64758 .33666 m
.65995 .36067 L
s
.34005 .36067 m
.35242 .33666 L
s
.34891 .30442 m
.35242 .33666 L
s
.311 .464 .899 r
.55086 .60343 m .55068 .6074 L .52553 .62019 L p F P
0 0 0 r
s
.311 .464 .899 r
.52553 .62019 m .52557 .61822 L .55086 .60343 L p F P
0 0 0 r
s
.83 .24 .1 r
.54543 .63648 m
.5462 .61852 L
s
.26 .393 .784 r
.47447 .62019 m .47443 .61822 L .44914 .60343 L p F P
0 0 0 r
s
.26 .393 .784 r
.44914 .60343 m .44932 .6074 L .47447 .62019 L p F P
0 0 0 r
s
.83 .24 .1 r
.4538 .61852 m
.45457 .63648 L
s
.329 .485 .9 r
.61542 .56266 m .61639 .55321 L .63282 .53166 L p F P
0 0 0 r
s
.333 .493 .926 r
.61639 .55321 m .61542 .56266 L .59614 .58114 L p F P
0 0 0 r
s
.169 .262 .556 r
.38361 .55321 m .38458 .56266 L .40386 .58114 L p F P
0 0 0 r
s
.24 .35 .67 r
.38303 .55989 m
.38444 .56124 L
s
.124 .196 .438 r
.38458 .56266 m .38361 .55321 L .36718 .53166 L p F P
0 0 0 r
s
.83 .24 .1 r
.21885 .59437 m
.22278 .61852 L
s
.17658 .61852 m
.17199 .59437 L
s
.22278 .61852 m
.17658 .61852 L
s
.26571 .59437 m
.26899 .61852 L
s
.26899 .61852 m
.22278 .61852 L
s
.31256 .59437 m
.31519 .61852 L
s
.31519 .61852 m
.26899 .61852 L
s
.35942 .59437 m
.36139 .61852 L
s
.36139 .61852 m
.31519 .61852 L
s
.40759 .61852 m
.36139 .61852 L
s
.40759 .61852 m
.4538 .61852 L
s
.4538 .61852 m
.46799 .61852 L
s
.46799 .61852 m
.47233 .61852 L
s
.53201 .61852 m
.5462 .61852 L
s
.52767 .61852 m
.53201 .61852 L
s
.5462 .61852 m
.59241 .61852 L
s
.64058 .59437 m
.63861 .61852 L
s
.63861 .61852 m
.59241 .61852 L
s
.68744 .59437 m
.68481 .61852 L
s
.68481 .61852 m
.63861 .61852 L
s
.73429 .59437 m
.73101 .61852 L
s
.73101 .61852 m
.68481 .61852 L
s
.78115 .59437 m
.77722 .61852 L
s
.77722 .61852 m
.73101 .61852 L
s
.82801 .59437 m
.82342 .61852 L
s
.82342 .61852 m
.77722 .61852 L
s
.322 .48 .92 r
.57468 .59165 m .57428 .59753 L .55049 .61133 L p F P
0 0 0 r
s
.322 .48 .92 r
.55049 .61133 m .55068 .6074 L .57468 .59165 L p F P
0 0 0 r
s
.235 .358 .725 r
.44951 .61133 m .44932 .6074 L .42532 .59165 L p F P
0 0 0 r
s
.235 .358 .725 r
.42532 .59165 m .42572 .59753 L .44951 .61133 L p F P
0 0 0 r
s
.281 .411 .734 r
.64563 .50943 m .64717 .49692 L .65624 .47365 L p F P
0 0 0 r
s
.24 .35 .67 r
.6542 .47889 m
.65657 .47185 L
s
.313 .46 .84 r
.64717 .49692 m .64563 .50943 L .63282 .53166 L p F P
0 0 0 r
s
.092 .138 .333 r
.35283 .49692 m .35437 .50943 L .36718 .53166 L p F P
0 0 0 r
s
.068 .1 .244 r
.35437 .50943 m .35283 .49692 L .34376 .47365 L p F P
0 0 0 r
s
.24 .35 .67 r
.34343 .47185 m
.3458 .47889 L
s
.311 .464 .899 r
.55105 .59943 m .55086 .60343 L .52557 .61822 L p F P
0 0 0 r
s
.311 .464 .899 r
.52557 .61822 m .52562 .61624 L .55105 .59943 L p F P
0 0 0 r
s
.26 .393 .784 r
.47443 .61822 m .47438 .61624 L .44895 .59943 L p F P
0 0 0 r
s
.26 .393 .784 r
.44895 .59943 m .44914 .60343 L .47443 .61822 L p F P
0 0 0 r
s
.052 .076 .18 r
.66355 .41589 m .6655 .4007 L .66171 .38248 L p F P
0 0 0 r
s
.028 .041 .084 r
.6655 .4007 m .66355 .41589 L .66297 .43684 L p F P
0 0 0 r
s
.26 .371 .651 r
.33645 .41589 m .3345 .4007 L .33829 .38248 L p F P
0 0 0 r
s
.203 .284 .476 r
.3345 .4007 m .33645 .41589 L .33703 .43684 L p F P
0 0 0 r
s
.333 .493 .926 r
.59614 .58114 m .59681 .57341 L .61639 .55321 L p F P
0 0 0 r
s
.33 .49 .931 r
.59681 .57341 m .59614 .58114 L .57428 .59753 L p F P
0 0 0 r
s
.206 .315 .651 r
.40319 .57341 m .40386 .58114 L .42572 .59753 L p F P
0 0 0 r
s
.169 .262 .556 r
.40386 .58114 m .40319 .57341 L .38361 .55321 L p F P
0 0 0 r
s
.24 .35 .67 r
.36769 .28292 m
.39161 .26485 L
s
.38902 .23081 m
.39161 .26485 L
s
.61098 .23081 m
.60839 .26485 L
s
.60839 .26485 m
.63231 .28292 L
s
.33 .49 .931 r
.57428 .59753 m .57468 .59165 L .59681 .57341 L p F P
0 0 0 r
s
.24 .35 .67 r
.58132 .58618 m
.58142 .5849 L
s
.83 .24 .1 r
.59241 .61852 m
.59372 .59437 L
s
.24 .35 .67 r
.58142 .5849 m
.58724 .5813 L
s
.206 .315 .651 r
.42572 .59753 m .42532 .59165 L .40319 .57341 L p F P
0 0 0 r
s
.24 .35 .67 r
.41858 .5849 m
.41868 .58618 L
s
.41276 .5813 m
.41858 .5849 L
s
.83 .24 .1 r
.40628 .59437 m
.40759 .61852 L
s
.657 .175 .074 r
.66171 .38248 m .63861 .38248 L .64185 .4007 L p F P
0 0 0 r
s
.657 .175 .074 r
.64185 .4007 m .6655 .4007 L .66171 .38248 L p F P
0 0 0 r
s
.657 .175 .074 r
.63861 .38248 m .61551 .38248 L .61821 .4007 L p F P
0 0 0 r
s
.657 .175 .074 r
.61821 .4007 m .64185 .4007 L .63861 .38248 L p F P
0 0 0 r
s
.83 .24 .1 r
.64022 .4007 m
.64032 .40178 L
s
.657 .175 .074 r
.61551 .38248 m .59241 .38248 L .59457 .4007 L p F P
0 0 0 r
s
.657 .175 .074 r
.59457 .4007 m .61821 .4007 L .61551 .38248 L p F P
0 0 0 r
s
.657 .175 .074 r
.59241 .38248 m .5693 .38248 L .57093 .4007 L p F P
0 0 0 r
s
.657 .175 .074 r
.57093 .4007 m .59457 .4007 L .59241 .38248 L p F P
0 0 0 r
s
.83 .24 .1 r
.59348 .4007 m
.59355 .40178 L
s
.657 .175 .074 r
.5693 .38248 m .5462 .38248 L .54728 .4007 L p F P
0 0 0 r
s
.657 .175 .074 r
.54728 .4007 m .57093 .4007 L .5693 .38248 L p F P
0 0 0 r
s
.657 .175 .074 r
.5462 .38248 m .5231 .38248 L .52364 .4007 L p F P
0 0 0 r
s
.657 .175 .074 r
.52364 .4007 m .54728 .4007 L .5462 .38248 L p F P
0 0 0 r
s
.83 .24 .1 r
.54674 .4007 m
.54677 .40178 L
s
.657 .175 .074 r
.5231 .38248 m .5 .38248 L .5 .4007 L p F P
0 0 0 r
s
.657 .175 .074 r
.5 .4007 m .52364 .4007 L .5231 .38248 L p F P
0 0 0 r
s
.657 .175 .074 r
.5 .38248 m .4769 .38248 L .47636 .4007 L p F P
0 0 0 r
s
.657 .175 .074 r
.47636 .4007 m .5 .4007 L .5 .38248 L p F P
0 0 0 r
s
.83 .24 .1 r
.5 .4007 m
.5 .40178 L
s
.657 .175 .074 r
.4769 .38248 m .4538 .38248 L .45272 .4007 L p F P
0 0 0 r
s
.83 .24 .1 r
.45378 .38281 m
.45379 .38248 L
s
.657 .175 .074 r
.45272 .4007 m .47636 .4007 L .4769 .38248 L p F P
0 0 0 r
s
.657 .175 .074 r
.4538 .38248 m .4307 .38248 L .42907 .4007 L p F P
0 0 0 r
s
.657 .175 .074 r
.42907 .4007 m .45272 .4007 L .4538 .38248 L p F P
0 0 0 r
s
.83 .24 .1 r
.45323 .40178 m
.45326 .4007 L
s
.657 .175 .074 r
.4307 .38248 m .40759 .38248 L .40543 .4007 L p F P
0 0 0 r
s
.83 .24 .1 r
.40755 .38281 m
.40757 .38248 L
s
.657 .175 .074 r
.40543 .4007 m .42907 .4007 L .4307 .38248 L p F P
0 0 0 r
s
.657 .175 .074 r
.40759 .38248 m .38449 .38248 L .38179 .4007 L p F P
0 0 0 r
s
.657 .175 .074 r
.38179 .4007 m .40543 .4007 L .40759 .38248 L p F P
0 0 0 r
s
.83 .24 .1 r
.40645 .40178 m
.40652 .4007 L
s
.657 .175 .074 r
.38449 .38248 m .36139 .38248 L .35815 .4007 L p F P
0 0 0 r
s
.83 .24 .1 r
.36133 .38281 m
.36136 .38248 L
s
.657 .175 .074 r
.35815 .4007 m .38179 .4007 L .38449 .38248 L p F P
0 0 0 r
s
.657 .175 .074 r
.36139 .38248 m .33829 .38248 L .3345 .4007 L p F P
0 0 0 r
s
.657 .175 .074 r
.3345 .4007 m .35815 .4007 L .36139 .38248 L p F P
0 0 0 r
s
.83 .24 .1 r
.35968 .40178 m
.35978 .4007 L
s
.311 .464 .899 r
.55124 .59541 m .55105 .59943 L .52562 .61624 L p F P
0 0 0 r
s
.311 .464 .899 r
.52562 .61624 m .52567 .61425 L .55124 .59541 L p F P
0 0 0 r
s
.26 .393 .784 r
.47438 .61624 m .47433 .61425 L .44876 .59541 L p F P
0 0 0 r
s
.26 .393 .784 r
.44876 .59541 m .44895 .59943 L .47438 .61624 L p F P
0 0 0 r
s
.322 .48 .92 r
.57509 .58571 m .57468 .59165 L .55068 .6074 L p F P
0 0 0 r
s
.322 .48 .92 r
.55068 .6074 m .55086 .60343 L .57509 .58571 L p F P
0 0 0 r
s
.235 .358 .725 r
.44932 .6074 m .44914 .60343 L .42491 .58571 L p F P
0 0 0 r
s
.235 .358 .725 r
.42491 .58571 m .42532 .59165 L .44932 .6074 L p F P
0 0 0 r
s
.99 .29 .124 r
.55124 .59541 m .54392 .59541 L .522 .61425 L p F P
0 0 0 r
s
.99 .29 .124 r
.522 .61425 m .52567 .61425 L .55124 .59541 L p F P
0 0 0 r
s
.83 .24 .1 r
.5462 .61852 m
.54662 .60331 L
s
.54683 .59541 m
.54686 .59437 L
s
.99 .29 .124 r
.54392 .59541 m .5366 .59541 L .51834 .61425 L p F P
0 0 0 r
s
.99 .29 .124 r
.51834 .61425 m .522 .61425 L .54392 .59541 L p F P
0 0 0 r
s
.99 .29 .124 r
.5366 .59541 m .52928 .59541 L .51467 .61425 L p F P
0 0 0 r
s
.99 .29 .124 r
.51467 .61425 m .51834 .61425 L .5366 .59541 L p F P
0 0 0 r
s
.99 .29 .124 r
.52928 .59541 m .52196 .59541 L .511 .61425 L p F P
0 0 0 r
s
.99 .29 .124 r
.511 .61425 m .51467 .61425 L .52928 .59541 L p F P
0 0 0 r
s
.99 .29 .124 r
.52196 .59541 m .51464 .59541 L .50733 .61425 L p F P
0 0 0 r
s
.99 .29 .124 r
.50733 .61425 m .511 .61425 L .52196 .59541 L p F P
0 0 0 r
s
.24 .35 .67 r
.51703 .61029 m
.51716 .60245 L
s
.517 .61267 m
.51703 .61029 L
s
.99 .29 .124 r
.51464 .59541 m .50732 .59541 L .50367 .61425 L p F P
0 0 0 r
s
.99 .29 .124 r
.50367 .61425 m .50733 .61425 L .51464 .59541 L p F P
0 0 0 r
s
.99 .29 .124 r
.50732 .59541 m .5 .59541 L .5 .61425 L p F P
0 0 0 r
s
.99 .29 .124 r
.5 .61425 m .50367 .61425 L .50732 .59541 L p F P
0 0 0 r
s
.99 .29 .124 r
.5 .59541 m .49268 .59541 L .49633 .61425 L p F P
0 0 0 r
s
.99 .29 .124 r
.49633 .61425 m .5 .61425 L .5 .59541 L p F P
0 0 0 r
s
.83 .24 .1 r
.5 .59437 m
.5 .59541 L
s
.99 .29 .124 r
.49268 .59541 m .48536 .59541 L .49267 .61425 L p F P
0 0 0 r
s
.99 .29 .124 r
.49267 .61425 m .49633 .61425 L .49268 .59541 L p F P
0 0 0 r
s
.99 .29 .124 r
.48536 .59541 m .47804 .59541 L .489 .61425 L p F P
0 0 0 r
s
.99 .29 .124 r
.489 .61425 m .49267 .61425 L .48536 .59541 L p F P
0 0 0 r
s
.99 .29 .124 r
.47804 .59541 m .47072 .59541 L .48533 .61425 L p F P
0 0 0 r
s
.99 .29 .124 r
.48533 .61425 m .489 .61425 L .47804 .59541 L p F P
0 0 0 r
s
.99 .29 .124 r
.47072 .59541 m .4634 .59541 L .48166 .61425 L p F P
0 0 0 r
s
.99 .29 .124 r
.48166 .61425 m .48533 .61425 L .47072 .59541 L p F P
0 0 0 r
s
.24 .35 .67 r
.48284 .60245 m
.48297 .61029 L
s
.48297 .61029 m
.483 .61267 L
s
.99 .29 .124 r
.4634 .59541 m .45608 .59541 L .478 .61425 L p F P
0 0 0 r
s
.99 .29 .124 r
.478 .61425 m .48166 .61425 L .4634 .59541 L p F P
0 0 0 r
s
.99 .29 .124 r
.45608 .59541 m .44876 .59541 L .47433 .61425 L p F P
0 0 0 r
s
.83 .24 .1 r
.45314 .59437 m
.45317 .59541 L
s
.45338 .60331 m
.4538 .61852 L
s
.99 .29 .124 r
.47433 .61425 m .478 .61425 L .45608 .59541 L p F P
0 0 0 r
s
.313 .46 .84 r
.63282 .53166 m .6341 .52047 L .64717 .49692 L p F P
0 0 0 r
s
.329 .485 .9 r
.6341 .52047 m .63282 .53166 L .61639 .55321 L p F P
0 0 0 r
s
.124 .196 .438 r
.3659 .52047 m .36718 .53166 L .38361 .55321 L p F P
0 0 0 r
s
.092 .138 .333 r
.36718 .53166 m .3659 .52047 L .35283 .49692 L p F P
0 0 0 r
s
.23 .333 .575 r
.65624 .47365 m .65801 .45981 L .66297 .43684 L p F P
0 0 0 r
s
.281 .411 .734 r
.65801 .45981 m .65624 .47365 L .64717 .49692 L p F P
0 0 0 r
s
.068 .1 .244 r
.34199 .45981 m .34376 .47365 L .35283 .49692 L p F P
0 0 0 r
s
.045 .066 .152 r
.34376 .47365 m .34199 .45981 L .33703 .43684 L p F P
0 0 0 r
s
.33 .49 .931 r
.59749 .56557 m .59681 .57341 L .57468 .59165 L p F P
0 0 0 r
s
.33 .49 .931 r
.57468 .59165 m .57509 .58571 L .59749 .56557 L p F P
0 0 0 r
s
.206 .315 .651 r
.42532 .59165 m .42491 .58571 L .40251 .56557 L p F P
0 0 0 r
s
.206 .315 .651 r
.40251 .56557 m .40319 .57341 L .42532 .59165 L p F P
0 0 0 r
s
.322 .48 .92 r
.57549 .57971 m .57509 .58571 L .55086 .60343 L p F P
0 0 0 r
s
.322 .48 .92 r
.55086 .60343 m .55105 .59943 L .57549 .57971 L p F P
0 0 0 r
s
.235 .358 .725 r
.44914 .60343 m .44895 .59943 L .42451 .57971 L p F P
0 0 0 r
s
.235 .358 .725 r
.42451 .57971 m .42491 .58571 L .44914 .60343 L p F P
0 0 0 r
s
.329 .485 .9 r
.61639 .55321 m .61737 .54359 L .6341 .52047 L p F P
0 0 0 r
s
.24 .35 .67 r
.63234 .5229 m
.63257 .52087 L
s
.333 .493 .926 r
.61737 .54359 m .61639 .55321 L .59681 .57341 L p F P
0 0 0 r
s
.169 .262 .556 r
.38263 .54359 m .38361 .55321 L .40319 .57341 L p F P
0 0 0 r
s
.124 .196 .438 r
.38361 .55321 m .38263 .54359 L .3659 .52047 L p F P
0 0 0 r
s
.24 .35 .67 r
.36743 .52087 m
.36766 .5229 L
s
.333 .493 .926 r
.59681 .57341 m .59749 .56557 L .61737 .54359 L p F P
0 0 0 r
s
.169 .262 .556 r
.40319 .57341 m .40251 .56557 L .38263 .54359 L p F P
0 0 0 r
s
.24 .35 .67 r
.44941 .20704 m
.48293 .20215 L
s
.48252 .16632 m
.48293 .20215 L
s
.48293 .20215 m
.51707 .20215 L
s
.51748 .16632 m
.51707 .20215 L
s
.51707 .20215 m
.55059 .20704 L
s
.028 .041 .084 r
.66297 .43684 m .6649 .42195 L .6655 .4007 L p F P
0 0 0 r
s
.23 .333 .575 r
.6649 .42195 m .66297 .43684 L .65801 .45981 L p F P
0 0 0 r
s
.24 .35 .67 r
.65843 .4575 m
.6603 .44298 L
s
.203 .284 .476 r
.33703 .43684 m .3351 .42195 L .3345 .4007 L p F P
0 0 0 r
s
.045 .066 .152 r
.3351 .42195 m .33703 .43684 L .34199 .45981 L p F P
0 0 0 r
s
.24 .35 .67 r
.3397 .44298 m
.34157 .4575 L
s
.281 .411 .734 r
.64717 .49692 m .64875 .48413 L .65801 .45981 L p F P
0 0 0 r
s
.313 .46 .84 r
.64875 .48413 m .64717 .49692 L .6341 .52047 L p F P
0 0 0 r
s
.24 .35 .67 r
.63257 .52087 m
.63614 .51541 L
s
.092 .138 .333 r
.35125 .48413 m .35283 .49692 L .3659 .52047 L p F P
0 0 0 r
s
.24 .35 .67 r
.36386 .51541 m
.36743 .52087 L
s
.068 .1 .244 r
.35283 .49692 m .35125 .48413 L .34199 .45981 L p F P
0 0 0 r
s
.24 .35 .67 r
.66381 .3286 m
.65995 .36067 L
s
.65995 .36067 m
.66566 .38641 L
s
.33434 .38641 m
.34005 .36067 L
s
.33619 .3286 m
.34005 .36067 L
s
.34891 .30442 m
.36769 .28292 L
s
.3645 .24898 m
.36769 .28292 L
s
.6355 .24898 m
.63231 .28292 L
s
.63231 .28292 m
.65109 .30442 L
s
.322 .48 .92 r
.57591 .57364 m .57549 .57971 L .55105 .59943 L p F P
0 0 0 r
s
.322 .48 .92 r
.55105 .59943 m .55124 .59541 L .57591 .57364 L p F P
0 0 0 r
s
.235 .358 .725 r
.44895 .59943 m .44876 .59541 L .42409 .57364 L p F P
0 0 0 r
s
.235 .358 .725 r
.42409 .57364 m .42451 .57971 L .44895 .59943 L p F P
0 0 0 r
s
.24 .35 .67 r
.51716 .60245 m
.53834 .59867 L
s
.46166 .59867 m
.48284 .60245 L
s
.83 .24 .1 r
.21936 .40178 m
.17259 .40178 L
s
.26614 .40178 m
.21936 .40178 L
s
.31291 .40178 m
.26614 .40178 L
s
.33464 .40178 m
.35968 .40178 L
s
.31291 .40178 m
.33453 .40178 L
s
.40645 .40178 m
.35968 .40178 L
s
.45323 .40178 m
.40645 .40178 L
s
.5 .40178 m
.45323 .40178 L
s
.54677 .40178 m
.5 .40178 L
s
.59355 .40178 m
.54677 .40178 L
s
.64032 .40178 m
.59355 .40178 L
s
.64032 .40178 m
.66536 .40178 L
s
.66547 .40178 m
.68709 .40178 L
s
.73386 .40178 m
.68709 .40178 L
s
.78064 .40178 m
.73386 .40178 L
s
.82741 .40178 m
.78064 .40178 L
s
.21936 .40178 m
.21623 .43038 L
s
.16893 .43038 m
.17259 .40178 L
s
.26614 .40178 m
.26352 .43038 L
s
.31291 .40178 m
.31082 .43038 L
s
.68709 .40178 m
.68918 .43038 L
s
.73386 .40178 m
.73648 .43038 L
s
.78064 .40178 m
.78377 .43038 L
s
.82741 .40178 m
.83107 .43038 L
s
.24 .35 .67 r
.41771 .21669 m
.44941 .20704 L
s
.44819 .17123 m
.44941 .20704 L
s
.55181 .17123 m
.55059 .20704 L
s
.55059 .20704 m
.58229 .21669 L
s
.33 .49 .931 r
.59818 .55761 m .59749 .56557 L .57509 .58571 L p F P
0 0 0 r
s
.33 .49 .931 r
.57509 .58571 m .57549 .57971 L .59818 .55761 L p F P
0 0 0 r
s
.206 .315 .651 r
.42491 .58571 m .42451 .57971 L .40182 .55761 L p F P
0 0 0 r
s
.206 .315 .651 r
.40182 .55761 m .40251 .56557 L .42491 .58571 L p F P
0 0 0 r
s
.729 .199 .084 r
.6655 .4007 m .64185 .4007 L .64134 .42195 L p F P
0 0 0 r
s
.24 .35 .67 r
.6618 .41679 m
.66363 .40234 L
s
.729 .199 .084 r
.64134 .42195 m .6649 .42195 L .6655 .4007 L p F P
0 0 0 r
s
.24 .35 .67 r
.66384 .4007 m
.66566 .38641 L
s
.6603 .44298 m
.6615 .42195 L
s
.729 .199 .084 r
.64185 .4007 m .61821 .4007 L .61779 .42195 L p F P
0 0 0 r
s
.729 .199 .084 r
.61779 .42195 m .64134 .42195 L .64185 .4007 L p F P
0 0 0 r
s
.729 .199 .084 r
.61821 .4007 m .59457 .4007 L .59423 .42195 L p F P
0 0 0 r
s
.729 .199 .084 r
.59423 .42195 m .61779 .42195 L .61821 .4007 L p F P
0 0 0 r
s
.729 .199 .084 r
.59457 .4007 m .57093 .4007 L .57067 .42195 L p F P
0 0 0 r
s
.729 .199 .084 r
.57067 .42195 m .59423 .42195 L .59457 .4007 L p F P
0 0 0 r
s
.729 .199 .084 r
.57093 .4007 m .54728 .4007 L .54711 .42195 L p F P
0 0 0 r
s
.729 .199 .084 r
.54711 .42195 m .57067 .42195 L .57093 .4007 L p F P
0 0 0 r
s
.729 .199 .084 r
.54728 .4007 m .52364 .4007 L .52356 .42195 L p F P
0 0 0 r
s
.729 .199 .084 r
.52356 .42195 m .54711 .42195 L .54728 .4007 L p F P
0 0 0 r
s
.729 .199 .084 r
.52364 .4007 m .5 .4007 L .5 .42195 L p F P
0 0 0 r
s
.729 .199 .084 r
.5 .42195 m .52356 .42195 L .52364 .4007 L p F P
0 0 0 r
s
.729 .199 .084 r
.5 .4007 m .47636 .4007 L .47644 .42195 L p F P
0 0 0 r
s
.729 .199 .084 r
.47644 .42195 m .5 .42195 L .5 .4007 L p F P
0 0 0 r
s
.729 .199 .084 r
.47636 .4007 m .45272 .4007 L .45289 .42195 L p F P
0 0 0 r
s
.729 .199 .084 r
.45289 .42195 m .47644 .42195 L .47636 .4007 L p F P
0 0 0 r
s
.729 .199 .084 r
.45272 .4007 m .42907 .4007 L .42933 .42195 L p F P
0 0 0 r
s
.729 .199 .084 r
.42933 .42195 m .45289 .42195 L .45272 .4007 L p F P
0 0 0 r
s
.729 .199 .084 r
.42907 .4007 m .40543 .4007 L .40577 .42195 L p F P
0 0 0 r
s
.729 .199 .084 r
.40577 .42195 m .42933 .42195 L .42907 .4007 L p F P
0 0 0 r
s
.729 .199 .084 r
.40543 .4007 m .38179 .4007 L .38221 .42195 L p F P
0 0 0 r
s
.729 .199 .084 r
.38221 .42195 m .40577 .42195 L .40543 .4007 L p F P
0 0 0 r
s
.729 .199 .084 r
.38179 .4007 m .35815 .4007 L .35866 .42195 L p F P
0 0 0 r
s
.729 .199 .084 r
.35866 .42195 m .38221 .42195 L .38179 .4007 L p F P
0 0 0 r
s
.729 .199 .084 r
.35815 .4007 m .3345 .4007 L .3351 .42195 L p F P
0 0 0 r
s
.729 .199 .084 r
.3351 .42195 m .35866 .42195 L .35815 .4007 L p F P
0 0 0 r
s
.24 .35 .67 r
.3385 .42195 m
.3397 .44298 L
s
.33434 .38641 m
.33616 .4007 L
s
.83 .24 .1 r
.21586 .56511 m
.21885 .59437 L
s
.17199 .59437 m
.1685 .56511 L
s
.21885 .59437 m
.17199 .59437 L
s
.26322 .56511 m
.26571 .59437 L
s
.26571 .59437 m
.21885 .59437 L
s
.31057 .56511 m
.31256 .59437 L
s
.31256 .59437 m
.26571 .59437 L
s
.35793 .56511 m
.35942 .59437 L
s
.35942 .59437 m
.31256 .59437 L
s
.40628 .59437 m
.35942 .59437 L
s
.40628 .59437 m
.445 .59437 L
s
.44759 .59437 m
.45314 .59437 L
s
.5 .59437 m
.45314 .59437 L
s
.54686 .59437 m
.5 .59437 L
s
.555 .59437 m
.59372 .59437 L
s
.54686 .59437 m
.55241 .59437 L
s
.64207 .56511 m
.64058 .59437 L
s
.64058 .59437 m
.59372 .59437 L
s
.68943 .56511 m
.68744 .59437 L
s
.68744 .59437 m
.64058 .59437 L
s
.73678 .56511 m
.73429 .59437 L
s
.73429 .59437 m
.68744 .59437 L
s
.78414 .56511 m
.78115 .59437 L
s
.78115 .59437 m
.73429 .59437 L
s
.8315 .56511 m
.82801 .59437 L
s
.82801 .59437 m
.78115 .59437 L
s
.313 .46 .84 r
.6341 .52047 m .6354 .50907 L .64875 .48413 L p F P
0 0 0 r
s
.329 .485 .9 r
.6354 .50907 m .6341 .52047 L .61737 .54359 L p F P
0 0 0 r
s
.124 .196 .438 r
.3646 .50907 m .3659 .52047 L .38263 .54359 L p F P
0 0 0 r
s
.092 .138 .333 r
.3659 .52047 m .3646 .50907 L .35125 .48413 L p F P
0 0 0 r
s
.24 .35 .67 r
.48284 .60245 m
.51716 .60245 L
s
.971 .282 .12 r
.57591 .57364 m .56506 .57364 L .54392 .59541 L p F P
0 0 0 r
s
.83 .24 .1 r
.54686 .59437 m
.54688 .5934 L
s
.971 .282 .12 r
.54392 .59541 m .55124 .59541 L .57591 .57364 L p F P
0 0 0 r
s
.971 .282 .12 r
.56506 .57364 m .55422 .57364 L .5366 .59541 L p F P
0 0 0 r
s
.971 .282 .12 r
.5366 .59541 m .54392 .59541 L .56506 .57364 L p F P
0 0 0 r
s
.971 .282 .12 r
.55422 .57364 m .54338 .57364 L .52928 .59541 L p F P
0 0 0 r
s
.971 .282 .12 r
.52928 .59541 m .5366 .59541 L .55422 .57364 L p F P
0 0 0 r
s
.24 .35 .67 r
.55079 .59199 m
.55086 .59045 L
s
.971 .282 .12 r
.54338 .57364 m .53253 .57364 L .52196 .59541 L p F P
0 0 0 r
s
.971 .282 .12 r
.52196 .59541 m .52928 .59541 L .54338 .57364 L p F P
0 0 0 r
s
.971 .282 .12 r
.53253 .57364 m .52169 .57364 L .51464 .59541 L p F P
0 0 0 r
s
.971 .282 .12 r
.51464 .59541 m .52196 .59541 L .53253 .57364 L p F P
0 0 0 r
s
.971 .282 .12 r
.52169 .57364 m .51084 .57364 L .50732 .59541 L p F P
0 0 0 r
s
.971 .282 .12 r
.50732 .59541 m .51464 .59541 L .52169 .57364 L p F P
0 0 0 r
s
.24 .35 .67 r
.51716 .60245 m
.51757 .57611 L
s
.971 .282 .12 r
.51084 .57364 m .5 .57364 L .5 .59541 L p F P
0 0 0 r
s
.971 .282 .12 r
.5 .59541 m .50732 .59541 L .51084 .57364 L p F P
0 0 0 r
s
.971 .282 .12 r
.5 .57364 m .48916 .57364 L .49268 .59541 L p F P
0 0 0 r
s
.971 .282 .12 r
.49268 .59541 m .5 .59541 L .5 .57364 L p F P
0 0 0 r
s
.971 .282 .12 r
.48916 .57364 m .47831 .57364 L .48536 .59541 L p F P
0 0 0 r
s
.971 .282 .12 r
.48536 .59541 m .49268 .59541 L .48916 .57364 L p F P
0 0 0 r
s
.971 .282 .12 r
.47831 .57364 m .46747 .57364 L .47804 .59541 L p F P
0 0 0 r
s
.971 .282 .12 r
.47804 .59541 m .48536 .59541 L .47831 .57364 L p F P
0 0 0 r
s
.24 .35 .67 r
.48243 .57611 m
.48284 .60245 L
s
.971 .282 .12 r
.46747 .57364 m .45662 .57364 L .47072 .59541 L p F P
0 0 0 r
s
.971 .282 .12 r
.47072 .59541 m .47804 .59541 L .46747 .57364 L p F P
0 0 0 r
s
.971 .282 .12 r
.45662 .57364 m .44578 .57364 L .4634 .59541 L p F P
0 0 0 r
s
.971 .282 .12 r
.4634 .59541 m .47072 .59541 L .45662 .57364 L p F P
0 0 0 r
s
.971 .282 .12 r
.44578 .57364 m .43494 .57364 L .45608 .59541 L p F P
0 0 0 r
s
.83 .24 .1 r
.45311 .59234 m
.45314 .59437 L
s
.971 .282 .12 r
.45608 .59541 m .4634 .59541 L .44578 .57364 L p F P
0 0 0 r
s
.971 .282 .12 r
.43494 .57364 m .42409 .57364 L .44876 .59541 L p F P
0 0 0 r
s
.971 .282 .12 r
.44876 .59541 m .45608 .59541 L .43494 .57364 L p F P
0 0 0 r
s
.24 .35 .67 r
.44914 .59045 m
.44921 .59199 L
s
.333 .493 .926 r
.61837 .53382 m .61737 .54359 L .59749 .56557 L p F P
0 0 0 r
s
.333 .493 .926 r
.59749 .56557 m .59818 .55761 L .61837 .53382 L p F P
0 0 0 r
s
.169 .262 .556 r
.40251 .56557 m .40182 .55761 L .38163 .53382 L p F P
0 0 0 r
s
.169 .262 .556 r
.38163 .53382 m .38263 .54359 L .40251 .56557 L p F P
0 0 0 r
s
.329 .485 .9 r
.61737 .54359 m .61837 .53382 L .6354 .50907 L p F P
0 0 0 r
s
.124 .196 .438 r
.38263 .54359 m .38163 .53382 L .3646 .50907 L p F P
0 0 0 r
s
.23 .333 .575 r
.65801 .45981 m .65983 .44565 L .6649 .42195 L p F P
0 0 0 r
s
.281 .411 .734 r
.65983 .44565 m .65801 .45981 L .64875 .48413 L p F P
0 0 0 r
s
.068 .1 .244 r
.34017 .44565 m .34199 .45981 L .35125 .48413 L p F P
0 0 0 r
s
.045 .066 .152 r
.34199 .45981 m .34017 .44565 L .3351 .42195 L p F P
0 0 0 r
s
.24 .35 .67 r
.38902 .23081 m
.41771 .21669 L
s
.41571 .18091 m
.41771 .21669 L
s
.58429 .18091 m
.58229 .21669 L
s
.58229 .21669 m
.61098 .23081 L
s
.33 .49 .931 r
.59888 .54955 m .59818 .55761 L .57549 .57971 L p F P
0 0 0 r
s
.33 .49 .931 r
.57549 .57971 m .57591 .57364 L .59888 .54955 L p F P
0 0 0 r
s
.206 .315 .651 r
.42451 .57971 m .42409 .57364 L .40112 .54955 L p F P
0 0 0 r
s
.206 .315 .651 r
.40112 .54955 m .40182 .55761 L .42451 .57971 L p F P
0 0 0 r
s
.281 .411 .734 r
.64875 .48413 m .65036 .47107 L .65983 .44565 L p F P
0 0 0 r
s
.24 .35 .67 r
.65487 .45898 m
.6603 .44298 L
s
.313 .46 .84 r
.65036 .47107 m .64875 .48413 L .6354 .50907 L p F P
0 0 0 r
s
.092 .138 .333 r
.34964 .47107 m .35125 .48413 L .3646 .50907 L p F P
0 0 0 r
s
.068 .1 .244 r
.35125 .48413 m .34964 .47107 L .34017 .44565 L p F P
0 0 0 r
s
.24 .35 .67 r
.3397 .44298 m
.34513 .45898 L
s
.784 .216 .092 r
.6649 .42195 m .64134 .42195 L .637 .44565 L p F P
0 0 0 r
s
.784 .216 .092 r
.637 .44565 m .65983 .44565 L .6649 .42195 L p F P
0 0 0 r
s
.24 .35 .67 r
.66202 .42959 m
.66213 .42874 L
s
.66213 .42874 m
.66417 .41283 L
s
.784 .216 .092 r
.64134 .42195 m .61779 .42195 L .61417 .44565 L p F P
0 0 0 r
s
.784 .216 .092 r
.61417 .44565 m .637 .44565 L .64134 .42195 L p F P
0 0 0 r
s
.784 .216 .092 r
.61779 .42195 m .59423 .42195 L .59133 .44565 L p F P
0 0 0 r
s
.784 .216 .092 r
.59133 .44565 m .61417 .44565 L .61779 .42195 L p F P
0 0 0 r
s
.784 .216 .092 r
.59423 .42195 m .57067 .42195 L .5685 .44565 L p F P
0 0 0 r
s
.784 .216 .092 r
.5685 .44565 m .59133 .44565 L .59423 .42195 L p F P
0 0 0 r
s
.784 .216 .092 r
.57067 .42195 m .54711 .42195 L .54567 .44565 L p F P
0 0 0 r
s
.784 .216 .092 r
.54567 .44565 m .5685 .44565 L .57067 .42195 L p F P
0 0 0 r
s
.784 .216 .092 r
.54711 .42195 m .52356 .42195 L .52283 .44565 L p F P
0 0 0 r
s
.784 .216 .092 r
.52283 .44565 m .54567 .44565 L .54711 .42195 L p F P
0 0 0 r
s
.784 .216 .092 r
.52356 .42195 m .5 .42195 L .5 .44565 L p F P
0 0 0 r
s
.784 .216 .092 r
.5 .44565 m .52283 .44565 L .52356 .42195 L p F P
0 0 0 r
s
.784 .216 .092 r
.5 .42195 m .47644 .42195 L .47717 .44565 L p F P
0 0 0 r
s
.784 .216 .092 r
.47717 .44565 m .5 .44565 L .5 .42195 L p F P
0 0 0 r
s
.784 .216 .092 r
.47644 .42195 m .45289 .42195 L .45433 .44565 L p F P
0 0 0 r
s
.784 .216 .092 r
.45433 .44565 m .47717 .44565 L .47644 .42195 L p F P
0 0 0 r
s
.784 .216 .092 r
.45289 .42195 m .42933 .42195 L .4315 .44565 L p F P
0 0 0 r
s
.784 .216 .092 r
.4315 .44565 m .45433 .44565 L .45289 .42195 L p F P
0 0 0 r
s
.784 .216 .092 r
.42933 .42195 m .40577 .42195 L .40867 .44565 L p F P
0 0 0 r
s
.784 .216 .092 r
.40867 .44565 m .4315 .44565 L .42933 .42195 L p F P
0 0 0 r
s
.784 .216 .092 r
.40577 .42195 m .38221 .42195 L .38583 .44565 L p F P
0 0 0 r
s
.784 .216 .092 r
.38583 .44565 m .40867 .44565 L .40577 .42195 L p F P
0 0 0 r
s
.784 .216 .092 r
.38221 .42195 m .35866 .42195 L .363 .44565 L p F P
0 0 0 r
s
.784 .216 .092 r
.363 .44565 m .38583 .44565 L .38221 .42195 L p F P
0 0 0 r
s
.784 .216 .092 r
.35866 .42195 m .3351 .42195 L .34017 .44565 L p F P
0 0 0 r
s
.24 .35 .67 r
.33583 .41283 m
.33787 .42874 L
s
.33787 .42874 m
.33798 .42959 L
s
.784 .216 .092 r
.34017 .44565 m .363 .44565 L .35866 .42195 L p F P
0 0 0 r
s
.333 .493 .926 r
.61939 .52388 m .61837 .53382 L .59818 .55761 L p F P
0 0 0 r
s
.333 .493 .926 r
.59818 .55761 m .59888 .54955 L .61939 .52388 L p F P
0 0 0 r
s
.169 .262 .556 r
.40182 .55761 m .40112 .54955 L .38061 .52388 L p F P
0 0 0 r
s
.169 .262 .556 r
.38061 .52388 m .38163 .53382 L .40182 .55761 L p F P
0 0 0 r
s
.24 .35 .67 r
.33619 .3286 m
.34891 .30442 L
s
.34522 .27061 m
.34891 .30442 L
s
.65478 .27061 m
.65109 .30442 L
s
.65109 .30442 m
.66381 .3286 L
s
.949 .273 .117 r
.59888 .54955 m .58475 .54955 L .56506 .57364 L p F P
0 0 0 r
s
.949 .273 .117 r
.56506 .57364 m .57591 .57364 L .59888 .54955 L p F P
0 0 0 r
s
.83 .24 .1 r
.59372 .59437 m
.59471 .56511 L
s
.24 .35 .67 r
.59778 .54955 m
.59993 .54823 L
s
.949 .273 .117 r
.58475 .54955 m .57063 .54955 L .55422 .57364 L p F P
0 0 0 r
s
.949 .273 .117 r
.55422 .57364 m .56506 .57364 L .58475 .54955 L p F P
0 0 0 r
s
.24 .35 .67 r
.58297 .56379 m
.58337 .55835 L
s
.58337 .55835 m
.59124 .55354 L
s
.949 .273 .117 r
.57063 .54955 m .5565 .54955 L .54338 .57364 L p F P
0 0 0 r
s
.83 .24 .1 r
.54721 .57364 m
.54727 .57019 L
s
.24 .35 .67 r
.55086 .59045 m
.55096 .58834 L
s
.949 .273 .117 r
.54338 .57364 m .55422 .57364 L .57063 .54955 L p F P
0 0 0 r
s
.949 .273 .117 r
.5565 .54955 m .54238 .54955 L .53253 .57364 L p F P
0 0 0 r
s
.949 .273 .117 r
.53253 .57364 m .54338 .57364 L .5565 .54955 L p F P
0 0 0 r
s
.24 .35 .67 r
.55096 .58834 m
.5518 .57007 L
s
.949 .273 .117 r
.54238 .54955 m .52825 .54955 L .52169 .57364 L p F P
0 0 0 r
s
.949 .273 .117 r
.52169 .57364 m .53253 .57364 L .54238 .54955 L p F P
0 0 0 r
s
.949 .273 .117 r
.52825 .54955 m .51413 .54955 L .51084 .57364 L p F P
0 0 0 r
s
.949 .273 .117 r
.51084 .57364 m .52169 .57364 L .52825 .54955 L p F P
0 0 0 r
s
.949 .273 .117 r
.51413 .54955 m .5 .54955 L .5 .57364 L p F P
0 0 0 r
s
.949 .273 .117 r
.5 .57364 m .51084 .57364 L .51413 .54955 L p F P
0 0 0 r
s
.949 .273 .117 r
.5 .54955 m .48587 .54955 L .48916 .57364 L p F P
0 0 0 r
s
.949 .273 .117 r
.48916 .57364 m .5 .57364 L .5 .54955 L p F P
0 0 0 r
s
.949 .273 .117 r
.48587 .54955 m .47175 .54955 L .47831 .57364 L p F P
0 0 0 r
s
.949 .273 .117 r
.47831 .57364 m .48916 .57364 L .48587 .54955 L p F P
0 0 0 r
s
.949 .273 .117 r
.47175 .54955 m .45762 .54955 L .46747 .57364 L p F P
0 0 0 r
s
.949 .273 .117 r
.46747 .57364 m .47831 .57364 L .47175 .54955 L p F P
0 0 0 r
s
.949 .273 .117 r
.45762 .54955 m .4435 .54955 L .45662 .57364 L p F P
0 0 0 r
s
.24 .35 .67 r
.44904 .58834 m
.44914 .59045 L
s
.949 .273 .117 r
.45662 .57364 m .46747 .57364 L .45762 .54955 L p F P
0 0 0 r
s
.949 .273 .117 r
.4435 .54955 m .42937 .54955 L .44578 .57364 L p F P
0 0 0 r
s
.949 .273 .117 r
.44578 .57364 m .45662 .57364 L .4435 .54955 L p F P
0 0 0 r
s
.24 .35 .67 r
.4482 .57007 m
.44904 .58834 L
s
.949 .273 .117 r
.42937 .54955 m .41525 .54955 L .43494 .57364 L p F P
0 0 0 r
s
.949 .273 .117 r
.43494 .57364 m .44578 .57364 L .42937 .54955 L p F P
0 0 0 r
s
.949 .273 .117 r
.41525 .54955 m .40112 .54955 L .42409 .57364 L p F P
0 0 0 r
s
.24 .35 .67 r
.40007 .54823 m
.40222 .54955 L
s
.83 .24 .1 r
.40529 .56511 m
.40628 .59437 L
s
.949 .273 .117 r
.42409 .57364 m .43494 .57364 L .41525 .54955 L p F P
0 0 0 r
s
.24 .35 .67 r
.40876 .55354 m
.41663 .55835 L
s
.41663 .55835 m
.41703 .56379 L
s
.83 .24 .1 r
.21623 .43038 m
.16893 .43038 L
s
.26352 .43038 m
.21623 .43038 L
s
.31082 .43038 m
.26352 .43038 L
s
.31082 .43038 m
.33683 .43038 L
s
.66317 .43038 m
.68918 .43038 L
s
.73648 .43038 m
.68918 .43038 L
s
.78377 .43038 m
.73648 .43038 L
s
.83107 .43038 m
.78377 .43038 L
s
.21623 .43038 m
.21421 .46287 L
s
.16658 .46287 m
.16893 .43038 L
s
.26352 .43038 m
.26184 .46287 L
s
.31082 .43038 m
.30947 .46287 L
s
.68918 .43038 m
.69053 .46287 L
s
.73648 .43038 m
.73816 .46287 L
s
.78377 .43038 m
.78579 .46287 L
s
.83107 .43038 m
.83342 .46287 L
s
.24 .35 .67 r
.33434 .38641 m
.3303 .35454 L
s
.33583 .41283 m
.33434 .38641 L
s
.6697 .35454 m
.66566 .38641 L
s
.66566 .38641 m
.66417 .41283 L
s
.313 .46 .84 r
.6354 .50907 m .63674 .49743 L .65036 .47107 L p F P
0 0 0 r
s
.329 .485 .9 r
.63674 .49743 m .6354 .50907 L .61837 .53382 L p F P
0 0 0 r
s
.124 .196 .438 r
.36326 .49743 m .3646 .50907 L .38163 .53382 L p F P
0 0 0 r
s
.092 .138 .333 r
.3646 .50907 m .36326 .49743 L .34964 .47107 L p F P
0 0 0 r
s
.329 .485 .9 r
.61837 .53382 m .61939 .52388 L .63674 .49743 L p F P
0 0 0 r
s
.124 .196 .438 r
.38163 .53382 m .38061 .52388 L .36326 .49743 L p F P
0 0 0 r
s
.83 .24 .1 r
.21402 .5322 m
.21586 .56511 L
s
.1685 .56511 m
.16636 .5322 L
s
.21586 .56511 m
.1685 .56511 L
s
.26169 .5322 m
.26322 .56511 L
s
.26322 .56511 m
.21586 .56511 L
s
.30935 .5322 m
.31057 .56511 L
s
.31057 .56511 m
.26322 .56511 L
s
.35701 .5322 m
.35793 .56511 L
s
.35793 .56511 m
.31057 .56511 L
s
.40511 .55573 m
.40529 .56511 L
s
.35793 .56511 m
.40529 .56511 L
s
.40529 .56511 m
.4148 .56511 L
s
.59471 .56511 m
.59489 .55573 L
s
.5852 .56511 m
.59471 .56511 L
s
.64299 .5322 m
.64207 .56511 L
s
.59471 .56511 m
.64207 .56511 L
s
.69065 .5322 m
.68943 .56511 L
s
.68943 .56511 m
.64207 .56511 L
s
.73831 .5322 m
.73678 .56511 L
s
.73678 .56511 m
.68943 .56511 L
s
.78598 .5322 m
.78414 .56511 L
s
.78414 .56511 m
.73678 .56511 L
s
.83364 .5322 m
.8315 .56511 L
s
.8315 .56511 m
.78414 .56511 L
s
.24 .35 .67 r
.3645 .24898 m
.38902 .23081 L
s
.38631 .1951 m
.38902 .23081 L
s
.61369 .1951 m
.61098 .23081 L
s
.61098 .23081 m
.6355 .24898 L
s
.827 .231 .098 r
.65983 .44565 m .637 .44565 L .62888 .47107 L p F P
0 0 0 r
s
.827 .231 .098 r
.62888 .47107 m .65036 .47107 L .65983 .44565 L p F P
0 0 0 r
s
.24 .35 .67 r
.65261 .46034 m
.65529 .43875 L
s
.6524 .46205 m
.65261 .46034 L
s
.827 .231 .098 r
.637 .44565 m .61417 .44565 L .6074 .47107 L p F P
0 0 0 r
s
.827 .231 .098 r
.6074 .47107 m .62888 .47107 L .637 .44565 L p F P
0 0 0 r
s
.827 .231 .098 r
.61417 .44565 m .59133 .44565 L .58592 .47107 L p F P
0 0 0 r
s
.827 .231 .098 r
.58592 .47107 m .6074 .47107 L .61417 .44565 L p F P
0 0 0 r
s
.827 .231 .098 r
.59133 .44565 m .5685 .44565 L .56444 .47107 L p F P
0 0 0 r
s
.827 .231 .098 r
.56444 .47107 m .58592 .47107 L .59133 .44565 L p F P
0 0 0 r
s
.827 .231 .098 r
.5685 .44565 m .54567 .44565 L .54296 .47107 L p F P
0 0 0 r
s
.827 .231 .098 r
.54296 .47107 m .56444 .47107 L .5685 .44565 L p F P
0 0 0 r
s
.827 .231 .098 r
.54567 .44565 m .52283 .44565 L .52148 .47107 L p F P
0 0 0 r
s
.827 .231 .098 r
.52148 .47107 m .54296 .47107 L .54567 .44565 L p F P
0 0 0 r
s
.827 .231 .098 r
.52283 .44565 m .5 .44565 L .5 .47107 L p F P
0 0 0 r
s
.827 .231 .098 r
.5 .47107 m .52148 .47107 L .52283 .44565 L p F P
0 0 0 r
s
.827 .231 .098 r
.5 .44565 m .47717 .44565 L .47852 .47107 L p F P
0 0 0 r
s
.827 .231 .098 r
.47852 .47107 m .5 .47107 L .5 .44565 L p F P
0 0 0 r
s
.827 .231 .098 r
.47717 .44565 m .45433 .44565 L .45704 .47107 L p F P
0 0 0 r
s
.827 .231 .098 r
.45704 .47107 m .47852 .47107 L .47717 .44565 L p F P
0 0 0 r
s
.827 .231 .098 r
.45433 .44565 m .4315 .44565 L .43556 .47107 L p F P
0 0 0 r
s
.827 .231 .098 r
.43556 .47107 m .45704 .47107 L .45433 .44565 L p F P
0 0 0 r
s
.827 .231 .098 r
.4315 .44565 m .40867 .44565 L .41408 .47107 L p F P
0 0 0 r
s
.827 .231 .098 r
.41408 .47107 m .43556 .47107 L .4315 .44565 L p F P
0 0 0 r
s
.827 .231 .098 r
.40867 .44565 m .38583 .44565 L .3926 .47107 L p F P
0 0 0 r
s
.827 .231 .098 r
.3926 .47107 m .41408 .47107 L .40867 .44565 L p F P
0 0 0 r
s
.827 .231 .098 r
.38583 .44565 m .363 .44565 L .37112 .47107 L p F P
0 0 0 r
s
.827 .231 .098 r
.37112 .47107 m .3926 .47107 L .38583 .44565 L p F P
0 0 0 r
s
.827 .231 .098 r
.363 .44565 m .34017 .44565 L .34964 .47107 L p F P
0 0 0 r
s
.24 .35 .67 r
.34739 .46034 m
.3476 .46205 L
s
.34471 .43875 m
.34739 .46034 L
s
.827 .231 .098 r
.34964 .47107 m .37112 .47107 L .363 .44565 L p F P
0 0 0 r
s
.923 .264 .112 r
.61939 .52388 m .60233 .52388 L .58475 .54955 L p F P
0 0 0 r
s
.83 .24 .1 r
.595 .54955 m
.59515 .54185 L
s
.923 .264 .112 r
.58475 .54955 m .59888 .54955 L .61939 .52388 L p F P
0 0 0 r
s
.923 .264 .112 r
.60233 .52388 m .58528 .52388 L .57063 .54955 L p F P
0 0 0 r
s
.923 .264 .112 r
.57063 .54955 m .58475 .54955 L .60233 .52388 L p F P
0 0 0 r
s
.923 .264 .112 r
.58528 .52388 m .56822 .52388 L .5565 .54955 L p F P
0 0 0 r
s
.923 .264 .112 r
.5565 .54955 m .57063 .54955 L .58528 .52388 L p F P
0 0 0 r
s
.923 .264 .112 r
.56822 .52388 m .55117 .52388 L .54238 .54955 L p F P
0 0 0 r
s
.83 .24 .1 r
.5475 .54955 m
.54755 .54441 L
s
.923 .264 .112 r
.54238 .54955 m .5565 .54955 L .56822 .52388 L p F P
0 0 0 r
s
.923 .264 .112 r
.55117 .52388 m .53411 .52388 L .52825 .54955 L p F P
0 0 0 r
s
.923 .264 .112 r
.52825 .54955 m .54238 .54955 L .55117 .52388 L p F P
0 0 0 r
s
.923 .264 .112 r
.53411 .52388 m .51706 .52388 L .51413 .54955 L p F P
0 0 0 r
s
.923 .264 .112 r
.51413 .54955 m .52825 .54955 L .53411 .52388 L p F P
0 0 0 r
s
.923 .264 .112 r
.51706 .52388 m .5 .52388 L .5 .54955 L p F P
0 0 0 r
s
.923 .264 .112 r
.5 .54955 m .51413 .54955 L .51706 .52388 L p F P
0 0 0 r
s
.923 .264 .112 r
.5 .52388 m .48294 .52388 L .48587 .54955 L p F P
0 0 0 r
s
.923 .264 .112 r
.48587 .54955 m .5 .54955 L .5 .52388 L p F P
0 0 0 r
s
.923 .264 .112 r
.48294 .52388 m .46589 .52388 L .47175 .54955 L p F P
0 0 0 r
s
.923 .264 .112 r
.47175 .54955 m .48587 .54955 L .48294 .52388 L p F P
0 0 0 r
s
.923 .264 .112 r
.46589 .52388 m .44883 .52388 L .45762 .54955 L p F P
0 0 0 r
s
.923 .264 .112 r
.45762 .54955 m .47175 .54955 L .46589 .52388 L p F P
0 0 0 r
s
.923 .264 .112 r
.44883 .52388 m .43178 .52388 L .4435 .54955 L p F P
0 0 0 r
s
.923 .264 .112 r
.4435 .54955 m .45762 .54955 L .44883 .52388 L p F P
0 0 0 r
s
.923 .264 .112 r
.43178 .52388 m .41472 .52388 L .42937 .54955 L p F P
0 0 0 r
s
.923 .264 .112 r
.42937 .54955 m .4435 .54955 L .43178 .52388 L p F P
0 0 0 r
s
.923 .264 .112 r
.41472 .52388 m .39767 .52388 L .41525 .54955 L p F P
0 0 0 r
s
.923 .264 .112 r
.41525 .54955 m .42937 .54955 L .41472 .52388 L p F P
0 0 0 r
s
.923 .264 .112 r
.39767 .52388 m .38061 .52388 L .40112 .54955 L p F P
0 0 0 r
s
.923 .264 .112 r
.40112 .54955 m .41525 .54955 L .39767 .52388 L p F P
0 0 0 r
s
.83 .24 .1 r
.21421 .46287 m
.16658 .46287 L
s
.26184 .46287 m
.21421 .46287 L
s
.30947 .46287 m
.26184 .46287 L
s
.30947 .46287 m
.34638 .46287 L
s
.65362 .46287 m
.69053 .46287 L
s
.73816 .46287 m
.69053 .46287 L
s
.78579 .46287 m
.73816 .46287 L
s
.83342 .46287 m
.78579 .46287 L
s
.21421 .46287 m
.21346 .49746 L
s
.1657 .49746 m
.16658 .46287 L
s
.26184 .46287 m
.26122 .49746 L
s
.30947 .46287 m
.30897 .49746 L
s
.35686 .48505 m
.35702 .47107 L
s
.64298 .47107 m
.64314 .48505 L
s
.69053 .46287 m
.69103 .49746 L
s
.73816 .46287 m
.73878 .49746 L
s
.78579 .46287 m
.78654 .49746 L
s
.83342 .46287 m
.8343 .49746 L
s
.24 .35 .67 r
.58337 .55835 m
.58542 .5305 L
s
.58337 .55835 m
.5518 .57007 L
s
.4482 .57007 m
.41663 .55835 L
s
.41458 .5305 m
.41663 .55835 L
s
.83 .24 .1 r
.21346 .49746 m
.21402 .5322 L
s
.16636 .5322 m
.1657 .49746 L
s
.21402 .5322 m
.16636 .5322 L
s
.26122 .49746 m
.26169 .5322 L
s
.26169 .5322 m
.21402 .5322 L
s
.30897 .49746 m
.30935 .5322 L
s
.30935 .5322 m
.26169 .5322 L
s
.35673 .49746 m
.35701 .5322 L
s
.35701 .5322 m
.30935 .5322 L
s
.40449 .49746 m
.40463 .52388 L
s
.35701 .5322 m
.38497 .5322 L
s
.38497 .5322 m
.38649 .5322 L
s
.45224 .49746 m
.45231 .52388 L
s
.5 .49746 m
.5 .52388 L
s
.54769 .52388 m
.54776 .49746 L
s
.59537 .52388 m
.59551 .49746 L
s
.64299 .5322 m
.64327 .49746 L
s
.61503 .5322 m
.64299 .5322 L
s
.61351 .5322 m
.61503 .5322 L
s
.69103 .49746 m
.69065 .5322 L
s
.69065 .5322 m
.64299 .5322 L
s
.73878 .49746 m
.73831 .5322 L
s
.73831 .5322 m
.69065 .5322 L
s
.78654 .49746 m
.78598 .5322 L
s
.78598 .5322 m
.73831 .5322 L
s
.8343 .49746 m
.83364 .5322 L
s
.83364 .5322 m
.78598 .5322 L
s
.864 .243 .104 r
.65036 .47107 m .62888 .47107 L .6172 .49743 L p F P
0 0 0 r
s
.864 .243 .104 r
.6172 .49743 m .63674 .49743 L .65036 .47107 L p F P
0 0 0 r
s
.24 .35 .67 r
.63536 .49627 m
.63578 .49261 L
s
.63578 .49261 m
.63804 .48917 L
s
.63804 .48917 m
.64099 .48471 L
s
.83 .24 .1 r
.64315 .48612 m
.64327 .49746 L
s
.864 .243 .104 r
.62888 .47107 m .6074 .47107 L .59767 .49743 L p F P
0 0 0 r
s
.864 .243 .104 r
.59767 .49743 m .6172 .49743 L .62888 .47107 L p F P
0 0 0 r
s
.864 .243 .104 r
.6074 .47107 m .58592 .47107 L .57814 .49743 L p F P
0 0 0 r
s
.864 .243 .104 r
.57814 .49743 m .59767 .49743 L .6074 .47107 L p F P
0 0 0 r
s
.83 .24 .1 r
.59551 .49743 m
.59551 .49746 L
s
.864 .243 .104 r
.58592 .47107 m .56444 .47107 L .5586 .49743 L p F P
0 0 0 r
s
.864 .243 .104 r
.5586 .49743 m .57814 .49743 L .58592 .47107 L p F P
0 0 0 r
s
.864 .243 .104 r
.56444 .47107 m .54296 .47107 L .53907 .49743 L p F P
0 0 0 r
s
.864 .243 .104 r
.53907 .49743 m .5586 .49743 L .56444 .47107 L p F P
0 0 0 r
s
.83 .24 .1 r
.54776 .49743 m
.54776 .49746 L
s
.864 .243 .104 r
.54296 .47107 m .52148 .47107 L .51953 .49743 L p F P
0 0 0 r
s
.864 .243 .104 r
.51953 .49743 m .53907 .49743 L .54296 .47107 L p F P
0 0 0 r
s
.864 .243 .104 r
.52148 .47107 m .5 .47107 L .5 .49743 L p F P
0 0 0 r
s
.864 .243 .104 r
.5 .49743 m .51953 .49743 L .52148 .47107 L p F P
0 0 0 r
s
.864 .243 .104 r
.5 .47107 m .47852 .47107 L .48047 .49743 L p F P
0 0 0 r
s
.864 .243 .104 r
.48047 .49743 m .5 .49743 L .5 .47107 L p F P
0 0 0 r
s
.83 .24 .1 r
.5 .49743 m
.5 .49746 L
s
.864 .243 .104 r
.47852 .47107 m .45704 .47107 L .46093 .49743 L p F P
0 0 0 r
s
.864 .243 .104 r
.46093 .49743 m .48047 .49743 L .47852 .47107 L p F P
0 0 0 r
s
.864 .243 .104 r
.45704 .47107 m .43556 .47107 L .4414 .49743 L p F P
0 0 0 r
s
.864 .243 .104 r
.4414 .49743 m .46093 .49743 L .45704 .47107 L p F P
0 0 0 r
s
.83 .24 .1 r
.45224 .49746 m
.45224 .49743 L
s
.864 .243 .104 r
.43556 .47107 m .41408 .47107 L .42186 .49743 L p F P
0 0 0 r
s
.864 .243 .104 r
.42186 .49743 m .4414 .49743 L .43556 .47107 L p F P
0 0 0 r
s
.864 .243 .104 r
.41408 .47107 m .3926 .47107 L .40233 .49743 L p F P
0 0 0 r
s
.864 .243 .104 r
.40233 .49743 m .42186 .49743 L .41408 .47107 L p F P
0 0 0 r
s
.83 .24 .1 r
.40449 .49746 m
.40449 .49743 L
s
.864 .243 .104 r
.3926 .47107 m .37112 .47107 L .3828 .49743 L p F P
0 0 0 r
s
.864 .243 .104 r
.3828 .49743 m .40233 .49743 L .3926 .47107 L p F P
0 0 0 r
s
.864 .243 .104 r
.37112 .47107 m .34964 .47107 L .36326 .49743 L p F P
0 0 0 r
s
.83 .24 .1 r
.35673 .49746 m
.35685 .48612 L
s
.24 .35 .67 r
.35901 .48471 m
.36196 .48917 L
s
.864 .243 .104 r
.36326 .49743 m .3828 .49743 L .37112 .47107 L p F P
0 0 0 r
s
.24 .35 .67 r
.36422 .49261 m
.36464 .49627 L
s
.36196 .48917 m
.36422 .49261 L
s
.83 .24 .1 r
.21346 .49746 m
.1657 .49746 L
s
.26122 .49746 m
.21346 .49746 L
s
.30897 .49746 m
.26122 .49746 L
s
.30897 .49746 m
.35673 .49746 L
s
.35673 .49746 m
.36256 .49746 L
s
.36256 .49746 m
.3628 .49746 L
s
.36328 .49746 m
.40449 .49746 L
s
.45224 .49746 m
.40449 .49746 L
s
.5 .49746 m
.45224 .49746 L
s
.54776 .49746 m
.5 .49746 L
s
.59551 .49746 m
.54776 .49746 L
s
.6372 .49746 m
.64327 .49746 L
s
.59551 .49746 m
.63672 .49746 L
s
.64327 .49746 m
.69103 .49746 L
s
.73878 .49746 m
.69103 .49746 L
s
.78654 .49746 m
.73878 .49746 L
s
.8343 .49746 m
.78654 .49746 L
s
.895 .254 .108 r
.63674 .49743 m .6172 .49743 L .60233 .52388 L p F P
0 0 0 r
s
.24 .35 .67 r
.63491 .50021 m
.63509 .4987 L
s
.61173 .5311 m
.61182 .53021 L
s
.895 .254 .108 r
.60233 .52388 m .61939 .52388 L .63674 .49743 L p F P
0 0 0 r
s
.895 .254 .108 r
.6172 .49743 m .59767 .49743 L .58528 .52388 L p F P
0 0 0 r
s
.895 .254 .108 r
.58528 .52388 m .60233 .52388 L .6172 .49743 L p F P
0 0 0 r
s
.24 .35 .67 r
.61182 .53021 m
.61342 .5136 L
s
.895 .254 .108 r
.59767 .49743 m .57814 .49743 L .56822 .52388 L p F P
0 0 0 r
s
.895 .254 .108 r
.56822 .52388 m .58528 .52388 L .59767 .49743 L p F P
0 0 0 r
s
.895 .254 .108 r
.57814 .49743 m .5586 .49743 L .55117 .52388 L p F P
0 0 0 r
s
.895 .254 .108 r
.55117 .52388 m .56822 .52388 L .57814 .49743 L p F P
0 0 0 r
s
.895 .254 .108 r
.5586 .49743 m .53907 .49743 L .53411 .52388 L p F P
0 0 0 r
s
.895 .254 .108 r
.53411 .52388 m .55117 .52388 L .5586 .49743 L p F P
0 0 0 r
s
.895 .254 .108 r
.53907 .49743 m .51953 .49743 L .51706 .52388 L p F P
0 0 0 r
s
.895 .254 .108 r
.51706 .52388 m .53411 .52388 L .53907 .49743 L p F P
0 0 0 r
s
.895 .254 .108 r
.51953 .49743 m .5 .49743 L .5 .52388 L p F P
0 0 0 r
s
.895 .254 .108 r
.5 .52388 m .51706 .52388 L .51953 .49743 L p F P
0 0 0 r
s
.895 .254 .108 r
.5 .49743 m .48047 .49743 L .48294 .52388 L p F P
0 0 0 r
s
.895 .254 .108 r
.48294 .52388 m .5 .52388 L .5 .49743 L p F P
0 0 0 r
s
.895 .254 .108 r
.48047 .49743 m .46093 .49743 L .46589 .52388 L p F P
0 0 0 r
s
.895 .254 .108 r
.46589 .52388 m .48294 .52388 L .48047 .49743 L p F P
0 0 0 r
s
.895 .254 .108 r
.46093 .49743 m .4414 .49743 L .44883 .52388 L p F P
0 0 0 r
s
.895 .254 .108 r
.44883 .52388 m .46589 .52388 L .46093 .49743 L p F P
0 0 0 r
s
.895 .254 .108 r
.4414 .49743 m .42186 .49743 L .43178 .52388 L p F P
0 0 0 r
s
.895 .254 .108 r
.43178 .52388 m .44883 .52388 L .4414 .49743 L p F P
0 0 0 r
s
.895 .254 .108 r
.42186 .49743 m .40233 .49743 L .41472 .52388 L p F P
0 0 0 r
s
.895 .254 .108 r
.41472 .52388 m .43178 .52388 L .42186 .49743 L p F P
0 0 0 r
s
.895 .254 .108 r
.40233 .49743 m .3828 .49743 L .39767 .52388 L p F P
0 0 0 r
s
.24 .35 .67 r
.38818 .53021 m
.38827 .5311 L
s
.895 .254 .108 r
.39767 .52388 m .41472 .52388 L .40233 .49743 L p F P
0 0 0 r
s
.895 .254 .108 r
.3828 .49743 m .36326 .49743 L .38061 .52388 L p F P
0 0 0 r
s
.895 .254 .108 r
.38061 .52388 m .39767 .52388 L .3828 .49743 L p F P
0 0 0 r
s
.24 .35 .67 r
.38658 .5136 m
.38818 .53021 L
s
.44819 .17123 m
.48252 .16632 L
s
.48252 .16632 m
.51748 .16632 L
s
.51748 .16632 m
.55181 .17123 L
s
.66786 .29495 m
.66381 .3286 L
s
.66381 .3286 m
.6697 .35454 L
s
.3303 .35454 m
.33619 .3286 L
s
.33214 .29495 m
.33619 .3286 L
s
.34522 .27061 m
.3645 .24898 L
s
.36116 .21336 m
.3645 .24898 L
s
.63884 .21336 m
.6355 .24898 L
s
.6355 .24898 m
.65478 .27061 L
s
.55308 .54236 m
.5518 .57007 L
s
.5518 .57007 m
.51757 .57611 L
s
.48243 .57611 m
.4482 .57007 L
s
.44692 .54236 m
.4482 .57007 L
s
.41571 .18091 m
.44819 .17123 L
s
.55181 .17123 m
.58429 .18091 L
s
.63914 .46294 m
.63578 .49261 L
s
.63578 .49261 m
.61342 .5136 L
s
.38658 .5136 m
.36422 .49261 L
s
.36086 .46294 m
.36422 .49261 L
s
.34471 .43875 m
.33583 .41283 L
s
.33176 .38118 m
.33583 .41283 L
s
.66824 .38118 m
.66417 .41283 L
s
.66417 .41283 m
.65529 .43875 L
s
.51801 .54847 m
.51757 .57611 L
s
.51757 .57611 m
.48243 .57611 L
s
.48199 .54847 m
.48243 .57611 L
s
.38631 .1951 m
.41571 .18091 L
s
.58429 .18091 m
.61369 .1951 L
s
.33214 .29495 m
.34522 .27061 L
s
.34136 .2351 m
.34522 .27061 L
s
.65864 .2351 m
.65478 .27061 L
s
.65478 .27061 m
.66786 .29495 L
s
.61625 .48416 m
.61342 .5136 L
s
.61342 .5136 m
.58542 .5305 L
s
.41458 .5305 m
.38658 .5136 L
s
.38375 .48416 m
.38658 .5136 L
s
.3303 .35454 m
.32605 .32108 L
s
.33176 .38118 m
.3303 .35454 L
s
.67395 .32108 m
.6697 .35454 L
s
.6697 .35454 m
.66824 .38118 L
s
.36116 .21336 m
.38631 .1951 L
s
.61369 .1951 m
.63884 .21336 L
s
.65918 .40734 m
.65529 .43875 L
s
.65529 .43875 m
.63914 .46294 L
s
.36086 .46294 m
.34471 .43875 L
s
.34082 .40734 m
.34471 .43875 L
s
.58758 .50124 m
.58542 .5305 L
s
.58542 .5305 m
.55308 .54236 L
s
.44692 .54236 m
.41458 .5305 L
s
.41242 .50124 m
.41458 .5305 L
s
.67211 .25959 m
.66786 .29495 L
s
.66786 .29495 m
.67395 .32108 L
s
.32605 .32108 m
.33214 .29495 L
s
.32789 .25959 m
.33214 .29495 L
s
.34136 .2351 m
.36116 .21336 L
s
.63884 .21336 m
.65864 .2351 L
s
.55443 .51323 m
.55308 .54236 L
s
.55308 .54236 m
.51801 .54847 L
s
.48199 .54847 m
.44692 .54236 L
s
.44557 .51323 m
.44692 .54236 L
s
.38375 .48416 m
.36086 .46294 L
s
.35733 .43177 m
.36086 .46294 L
s
.64267 .43177 m
.63914 .46294 L
s
.63914 .46294 m
.61625 .48416 L
s
.34082 .40734 m
.33176 .38118 L
s
.32749 .34793 m
.33176 .38118 L
s
.67251 .34793 m
.66824 .38118 L
s
.66824 .38118 m
.65918 .40734 L
s
.51847 .51941 m
.51801 .54847 L
s
.51801 .54847 m
.48199 .54847 L
s
.48153 .51941 m
.48199 .54847 L
s
.65864 .2351 m
.67211 .25959 L
s
.32789 .25959 m
.34136 .2351 L
s
.61923 .4532 m
.61625 .48416 L
s
.61625 .48416 m
.58758 .50124 L
s
.41242 .50124 m
.38375 .48416 L
s
.38077 .4532 m
.38375 .48416 L
s
.32605 .32108 m
.32158 .2859 L
s
.32749 .34793 m
.32605 .32108 L
s
.67842 .2859 m
.67395 .32108 L
s
.67395 .32108 m
.67251 .34793 L
s
.35733 .43177 m
.34082 .40734 L
s
.33672 .37432 m
.34082 .40734 L
s
.66328 .37432 m
.65918 .40734 L
s
.65918 .40734 m
.64267 .43177 L
s
.58984 .47047 m
.58758 .50124 L
s
.58758 .50124 m
.55443 .51323 L
s
.44557 .51323 m
.41242 .50124 L
s
.41016 .47047 m
.41242 .50124 L
s
.67211 .25959 m
.67842 .2859 L
s
.32158 .2859 m
.32789 .25959 L
s
.55585 .4826 m
.55443 .51323 L
s
.55443 .51323 m
.51847 .51941 L
s
.48153 .51941 m
.44557 .51323 L
s
.44415 .4826 m
.44557 .51323 L
s
.64639 .39897 m
.64267 .43177 L
s
.64267 .43177 m
.61923 .4532 L
s
.38077 .4532 m
.35733 .43177 L
s
.35361 .39897 m
.35733 .43177 L
s
.33672 .37432 m
.32749 .34793 L
s
.323 .31295 m
.32749 .34793 L
s
.677 .31295 m
.67251 .34793 L
s
.67251 .34793 m
.66328 .37432 L
s
.51895 .48885 m
.51847 .51941 L
s
.51847 .51941 m
.48153 .51941 L
s
.48105 .48885 m
.48153 .51941 L
s
.41016 .47047 m
.38077 .4532 L
s
.37763 .42062 m
.38077 .4532 L
s
.62237 .42062 m
.61923 .4532 L
s
.61923 .4532 m
.58984 .47047 L
s
.323 .31295 m
.32158 .2859 L
s
.67842 .2859 m
.677 .31295 L
s
.35361 .39897 m
.33672 .37432 L
s
.33241 .33955 m
.33672 .37432 L
s
.66759 .33955 m
.66328 .37432 L
s
.66328 .37432 m
.64639 .39897 L
s
.59223 .43807 m
.58984 .47047 L
s
.58984 .47047 m
.55585 .4826 L
s
.44415 .4826 m
.41016 .47047 L
s
.40777 .43807 m
.41016 .47047 L
s
.55734 .45032 m
.55585 .4826 L
s
.55585 .4826 m
.51895 .48885 L
s
.48105 .48885 m
.44415 .4826 L
s
.44266 .45032 m
.44415 .4826 L
s
.37763 .42062 m
.35361 .39897 L
s
.3497 .36442 m
.35361 .39897 L
s
.6503 .36442 m
.64639 .39897 L
s
.64639 .39897 m
.62237 .42062 L
s
.33241 .33955 m
.323 .31295 L
s
.677 .31295 m
.66759 .33955 L
s
.51945 .45664 m
.51895 .48885 L
s
.51895 .48885 m
.48105 .48885 L
s
.48055 .45664 m
.48105 .48885 L
s
.62568 .38627 m
.62237 .42062 L
s
.62237 .42062 m
.59223 .43807 L
s
.40777 .43807 m
.37763 .42062 L
s
.37432 .38627 m
.37763 .42062 L
s
.66759 .33955 m
.6503 .36442 L
s
.3497 .36442 m
.33241 .33955 L
s
.59474 .4039 m
.59223 .43807 L
s
.59223 .43807 m
.55734 .45032 L
s
.44266 .45032 m
.40777 .43807 L
s
.40526 .4039 m
.40777 .43807 L
s
.55891 .41628 m
.55734 .45032 L
s
.55734 .45032 m
.51945 .45664 L
s
.48055 .45664 m
.44266 .45032 L
s
.44109 .41628 m
.44266 .45032 L
s
.6503 .36442 m
.62568 .38627 L
s
.37432 .38627 m
.3497 .36442 L
s
.51999 .42267 m
.51945 .45664 L
s
.51945 .45664 m
.48055 .45664 L
s
.48001 .42267 m
.48055 .45664 L
s
.62568 .38627 m
.59474 .4039 L
s
.40526 .4039 m
.37432 .38627 L
s
.59474 .4039 m
.55891 .41628 L
s
.44109 .41628 m
.40526 .4039 L
s
.55891 .41628 m
.51999 .42267 L
s
.48001 .42267 m
.44109 .41628 L
s
.51999 .42267 m
.48001 .42267 L
s
0 0 0 r
.25 Mabswid
.85264 .14594 m
.90748 .42015 L
s
.90748 .42015 m
.09252 .42015 L
s
.09252 .42015 m
.14736 .14594 L
s
.14736 .14594 m
.85264 .14594 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{500, 500},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40007d0001m2000`400?l00000o`00003oo`3ooooe
0?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3o
m^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40
oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?of
k_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3o
ool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^
m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?oo
o`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd
0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo
003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0
ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool0
0?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03o
m^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00
o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?of
kP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o
0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^
0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0
ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h1
0?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3o
m^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40
oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?of
k_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00B@3om^ko000006800000B@3om^h10?ooo`00B@3o
m^h00`000000ooK^0?ofkP3o0?ofkUh0ooK^00<000000?ofkP3om^h0A`3om^h10?ooo`00B@3om^h0
0`000000ooK^0?ofkP3o0?ofkUh0ooK^00<000000?ofkP3om^h0A`3om^h10?ooo`00B03om^h00`00
0000ooK^0000003o0?ofkUh0ooK^00<000000?ofkP000000B03om^h10?ooo`00B03om^h00`000000
ooK^0000003o0?ofkUh0ooK^00<000000?ofkP000000B03om^h10?ooo`00B03om^h00`000000ooK^
0000003o0?ofkUh0ooK^00<000000?ofkP000000B03om^h10?ooo`00B03om^h00`000000ooK^0000
003o0?ofkUh0ooK^00<000000?ofkP000000B03om^h10?ooo`00B03om^h010000000ooK^0?ofkP00
003o0?ofkU`0ooK^00@000000?ofkP3om^h00000B03om^h10?ooo`00A`3om^h01@000000ooK^0?of
kP3om^h000000?l0ooK^G03om^h01@000000ooK^0?ofkP3om^h0000004L0ooK^0@3oool004L0ooK^
00D000000?ofkP3om^h0ooK^0000003o0?ofkU`0ooK^00D000000?ofkP3om^h0ooK^000000170?of
kP40oooo00170?ofkP050000003om^h0ooK^0?ofkP000000XP3om^hG03eIZj80ooK^00D000000?of
kP3om^h0ooK^000000170?ofkP40oooo00170?ofkP030000003om^h0ooK^0080ooK^00<000000?of
kP3om^h0V@3om^h603eIZ`80ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP0603eI
Zi/0ooK^00<000000?ofkP3om^h00P3om^h00`000000ooK^0?ofkP150?ofkP40oooo00170?ofkP03
0000003om^h0ooK^0080ooK^00<000000?ofkP3om^h0T`3om^h603eIZ`P0ooK^00<0?EV[0?ofkP3o
m^h03`3om^h00`0mFJ/0ooK^0?ofkP060?ofkPH0?EV[U@3om^h00`000000ooK^0?ofkP020?ofkP03
0000003om^h0ooK^04D0ooK^0@3oool004H0ooK^00<000000?ofkP3om^h00`3om^h00`000000ooK^
0?ofkP2?0?ofkP@0?EV[3P3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00`0ooK^
100mFJ^A0?ofkP030000003om^h0ooK^00<0ooK^00<000000?ofkP3om^h0A03om^h10?ooo`00AP3o
m^h00`000000ooK^0?ofkP030?ofkP030000003om^h0ooK^08`0ooK^0`0mFJ/00`3om^h0?EV[0?of
kP0?0?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^03eI
Z`0203eIZhh0ooK^00<000000?ofkP3om^h00`3om^h00`000000ooK^0?ofkP140?ofkP40oooo0016
0?ofkP030000003om^h0ooK^00<0ooK^00<000000?ofkP3om^h0R@3om^h303eIZ`@0ooK^00<0?EV[
0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[
0?ofkP3om^h00P3om^h303eIZh/0ooK^00<000000?ofkP3om^h00`3om^h00`000000ooK^0?ofkP14
0?ofkP40oooo00160?ofkP030000003om^h0ooK^00@0ooK^00<000000?ofkP3om^h0Q03om^h403eI
Z`L0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^
00h0ooK^00<0?EV[0?ofkP3om^h01@3om^h403eIZhH0ooK^00<000000?ofkP3om^h0103om^h00`00
0000ooK^0?ofkP140?ofkP40oooo00160?ofkP030000003om^h0ooK^00@0ooK^00<000000?ofkP3o
m^h0P@3om^h303eIZ`/0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP03
03eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h02@3om^h303eIZh<0ooK^00<000000?ofkP3o
m^h0103om^h00`000000ooK^0?ofkP140?ofkP40oooo00150?ofkP030000003om^h0ooK^00D0ooK^
00<000000?ofkP3om^h0OP3om^h303eIZ`h0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^
0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h0303om^h303eIZh00ooK^
00<000000?ofkP3om^h01@3om^h00`000000ooK^0?ofkP130?ofkP40oooo00150?ofkP030000003o
m^h0ooK^00D0ooK^00<000000?ofkP3om^h0O03om^h203eIZ`030?ofkP0mFJ/0ooK^00h0ooK^00<0
?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0
?EV[0?ofkP3om^h03@3om^h0100mFJ/0ooK^03eIZ`0mFJ]n0?ofkP030000003om^h0ooK^00D0ooK^
00<000000?ofkP3om^h0@`3om^h10?ooo`00A@3om^h00`000000ooK^0?ofkP060?ofkP030000003o
m^h0ooK^07T0ooK^0P0mFJ/30?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h03P3o
m^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h03@3o
m^h0100mFJ/0ooK^0?ofkP3om^h203eIZg/0ooK^00<000000?ofkP3om^h01P3om^h00`000000ooK^
0?ofkP130?ofkP40oooo00150?ofkP030000003om^h0ooK^00H0ooK^00<000000?ofkP3om^h0M`3o
m^h203eIZ`D0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3o
m^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3o
m^h0ooK^00<0ooK^0P0mFJ]i0?ofkP030000003om^h0ooK^00H0ooK^00<000000?ofkP3om^h0@`3o
m^h10?ooo`00A@3om^h00`000000ooK^0?ofkP060?ofkP030000003om^h0ooK^07D0ooK^0P0mFJ/7
0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0?
0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP05
0?ofkP80?EV[M`3om^h00`000000ooK^0?ofkP060?ofkP030000003om^h0ooK^04<0ooK^0@3oool0
04@0ooK^00<000000?ofkP3om^h01`3om^h00`000000ooK^0?ofkP1c0?ofkP80?EV[2@3om^h00`0m
FJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0m
FJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h01`3om^h203eI
ZgD0ooK^00<000000?ofkP3om^h01`3om^h00`000000ooK^0?ofkP120?ofkP40oooo00140?ofkP03
0000003om^h0ooK^00L0ooK^00<000000?ofkP3om^h0L@3om^h203eIZ`/0ooK^00<0?EV[0?ofkP3o
m^h03P3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3o
m^h03@3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00T0ooK^0P0mFJ]c0?ofkP03
0000003om^h0ooK^00L0ooK^00<000000?ofkP3om^h0@P3om^h10?ooo`00A03om^h00`000000ooK^
0?ofkP080?ofkP030000003om^h0ooK^06h0ooK^0P0mFJ/=0?ofkP0303eIZ`3om^h0ooK^00h0ooK^
00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00d0ooK^
00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP80?EV[L03om^h00`000000ooK^
0?ofkP080?ofkP030000003om^h0ooK^0480ooK^0@3oool004@0ooK^00<000000?ofkP3om^h0203o
m^h00`000000ooK^0?ofkP1]0?ofkP80?EV[3P3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3o
m^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3o
m^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h0303om^h203eIZfl0ooK^00<000000?ofkP3om^h0203o
m^h00`000000ooK^0?ofkP120?ofkP40oooo00140?ofkP030000003om^h0ooK^00P0ooK^00<00000
0?ofkP3om^h0J`3om^h203eIZ`030?ofkP0mFJ/0ooK^00d0ooK^00<0?EV[0?ofkP3om^h03P3om^h0
0`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h03@3om^h0
0`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00@0?EV[0?ofkP0mFJ/0?EV[K@3o
m^h00`000000ooK^0?ofkP080?ofkP030000003om^h0ooK^0480ooK^0@3oool004<0ooK^00<00000
0?ofkP3om^h02@3om^h00`000000ooK^0?ofkP1Z0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/03`3o
m^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00/0ooK^5`0mFJ/=0?ofkP0303eIZ`3o
m^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h03@3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[06`0ooK^
00<000000?ofkP3om^h02@3om^h00`000000ooK^0?ofkP110?ofkP40oooo00130?ofkP030000003o
m^h0ooK^00X0ooK^00<000000?ofkP3om^h0J03om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3o
m^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP060?ofkPD0?EV[0P3o
m^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00D0?EV[203om^h00`0mFJ/0ooK^0?of
kP0=0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?of
kP1X0?ofkP030000003om^h0ooK^00X0ooK^00<000000?ofkP3om^h0@@3om^h10?ooo`00@`3om^h0
0`000000ooK^0?ofkP0:0?ofkP030000003om^h0ooK^06H0ooK^0P0mFJ/60?ofkP0303eIZ`3om^h0
ooK^00`0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0603eIZ`L0ooK^00<0?EV[
0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP050?ofkPH0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP0=
0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h0103om^h203eIZfP0ooK^00<00000
0?ofkP3om^h02P3om^h00`000000ooK^0?ofkP110?ofkP40oooo00130?ofkP030000003om^h0ooK^
00X0ooK^00<000000?ofkP3om^h0I@3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^
00`0ooK^00<0?EV[0?ofkP3om^h0303om^h403eIZ`d0ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0m
FJ/0ooK^0?ofkP0;0?ofkP@0?EV[3P3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^
00H0ooK^00<0?EV[0?ofkP3om^h0I@3om^h00`000000ooK^0?ofkP0:0?ofkP030000003om^h0ooK^
0440ooK^0@3oool004<0ooK^00<000000?ofkP3om^h02P3om^h00`000000ooK^0?ofkP1T0?ofkP03
03eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP090?ofkP<0
?EV[00<0ooK^03eIZ`3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00d0
ooK^00<0?EV[0?ofkP0mFJ/00P0mFJ/;0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3o
m^h01`3om^h00`0mFJ/0ooK^0?ofkP1T0?ofkP030000003om^h0ooK^00X0ooK^00<000000?ofkP3o
m^h0@@3om^h10?ooo`00@P3om^h00`000000ooK^0?ofkP0<0?ofkP030000003om^h0ooK^0640ooK^
0P0mFJ/:0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h01P3om^h303eIZ`@0ooK^
00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00d0ooK^
00<0?EV[0?ofkP3om^h00P3om^h303eIZ`P0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^
0?ofkP080?ofkP80?EV[H`3om^h00`000000ooK^0?ofkP0<0?ofkP030000003om^h0ooK^0400ooK^
0@3oool00480ooK^00<000000?ofkP3om^h0303om^h00`000000ooK^0?ofkP1P0?ofkP0303eIZ`3o
m^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP020?ofkP@0?EV[1`3o
m^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h03@3o
m^h00`0mFJ/0ooK^0?ofkP050?ofkP@0?EV[103om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3o
m^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h0H03om^h00`000000ooK^0?ofkP0<0?ofkP030000003o
m^h0ooK^0400ooK^0@3oool00480ooK^00<000000?ofkP3om^h0303om^h00`000000ooK^0?ofkP1O
0?ofkP80?EV[303om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0?EV[0080?EV[2`3om^h0
0`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h03@3om^h0
0`0mFJ/0ooK^0?ofkP090?ofkP<0?EV[00<0ooK^03eIZ`3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0:
0?ofkP80?EV[H@3om^h00`000000ooK^0?ofkP0<0?ofkP030000003om^h0ooK^0400ooK^0@3oool0
0480ooK^00<000000?ofkP3om^h0303om^h00`000000ooK^0?ofkP1N0?ofkP0303eIZ`3om^h0?EV[
00`0ooK^00<0?EV[0?ofkP3om^h0303om^h203eIZ`h0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0m
FJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h0303om^h203eI
Z`h0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^03eIZ`1P0?ofkP030000003om^h0ooK^
00`0ooK^00<000000?ofkP3om^h0@03om^h10?ooo`00@P3om^h00`000000ooK^0?ofkP0<0?ofkP03
0000003om^h0ooK^05d0ooK^00@0?EV[0?ofkP3om^h0?EV[303om^h00`0mFJ/0ooK^0?ofkP0:0?of
kP<0?EV[3`3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?of
kP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP<0?EV[303om^h00`0mFJ/0ooK^0?ofkP0:0?of
kP0403eIZ`3om^h0ooK^03eIZel0ooK^00<000000?ofkP3om^h0303om^h00`000000ooK^0?ofkP10
0?ofkP40oooo00120?ofkP030000003om^h0ooK^00d0ooK^00<000000?ofkP3om^h0F`3om^h01@0m
FJ/0ooK^0?ofkP3om^h0?EV[00`0ooK^00<0?EV[0?ofkP3om^h0203om^h203eIZ`80ooK^00<0?EV[
0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[
0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^0080?EV[2P3om^h0
0`0mFJ/0ooK^0?ofkP0:0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/0G@3om^h00`000000ooK^0?of
kP0=0?ofkP030000003om^h0ooK^0400ooK^0@3oool00440ooK^00<000000?ofkP3om^h03P3om^h0
0`000000ooK^0?ofkP1J0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h02`3om^h0
0`0mFJ/0ooK^0?ofkP050?ofkP80?EV[103om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0
ooK^00h0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0
ooK^00d0ooK^00<0?EV[0?ofkP3om^h00P3om^h203eIZ`L0ooK^00<0?EV[0?ofkP3om^h02`3om^h0
0`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^05X0ooK^00<000000?ofkP3om^h03P3om^h0
0`000000ooK^0?ofkP0o0?ofkP40oooo00110?ofkP030000003om^h0ooK^00h0ooK^00<000000?of
kP3om^h0FP3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?of
kP3om^h00`3om^h203eIZ`H0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0>0?of
kP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0=0?of
kP0303eIZ`3om^h0ooK^00@0ooK^0P0mFJ/50?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?of
kP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP1J0?ofkP030000003om^h0ooK^00h0ooK^00<000000?of
kP3om^h0?`3om^h10?ooo`00@@3om^h00`000000ooK^0?ofkP0>0?ofkP030000003om^h0ooK^05T0
ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0403eIZ`3om^h0ooK^0?of
kP80?EV[203om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?of
kP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?of
kP3om^h01P3om^h203eIZ`<0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP030?of
kP0303eIZ`3om^h0ooK^05T0ooK^00<000000?ofkP3om^h03P3om^h00`000000ooK^0?ofkP0o0?of
kP40oooo00110?ofkP030000003om^h0ooK^00l0ooK^00<000000?ofkP3om^h0E`3om^h00`0mFJ/0
ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00/0ooK^00@0?EV[0?ofkP0mFJ/0?EV[2P3om^h00`0m
FJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0m
FJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h0203om^h203eI
Z`030?ofkP0mFJ/0ooK^00`0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP1G0?of
kP030000003om^h0ooK^00l0ooK^00<000000?ofkP3om^h0?`3om^h10?ooo`00@@3om^h00`000000
ooK^0?ofkP0?0?ofkP030000003om^h0ooK^05H0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0
ooK^0?ofkP0;0?ofkP80?EV[303om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00h0
ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00d0
ooK^00<0?EV[0?ofkP3om^h02P3om^h203eIZ``0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0
ooK^0?ofkP1F0?ofkP030000003om^h0ooK^00l0ooK^00<000000?ofkP3om^h0?`3om^h10?ooo`00
@03om^h00`000000ooK^0?ofkP0@0?ofkP030000003om^h0ooK^05D0ooK^00<0?EV[0?ofkP3om^h0
1`3om^h00`0mFJ/0ooK^0?ofkP080?ofkP<0?EV[3@3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eI
Z`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eI
Z`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h02`3om^h303eIZ`X0ooK^00<0?EV[0?ofkP3om^h0
1`3om^h00`0mFJ/0ooK^0?ofkP1E0?ofkP030000003om^h0ooK^0100ooK^00<000000?ofkP3om^h0
?P3om^h10?ooo`00@03om^h00`000000ooK^0?ofkP0@0?ofkP030000003om^h0ooK^05@0ooK^00<0
?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP070?ofkP0403eIZ`3om^h0ooK^03eIZ`h0ooK^
00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0<0?ofkQD0?EV[3P3om^h00`0mFJ/0ooK^
0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00@0?EV[0?ofkP3om^h0?EV[2@3om^h00`0mFJ/0
ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^05@0ooK^00<000000?ofkP3om^h0403om^h00`000000
ooK^0?ofkP0n0?ofkP40oooo00100?ofkP030000003om^h0ooK^0100ooK^00<000000?ofkP3om^h0
D`3om^h203eIZ`X0ooK^00<0?EV[0?ofkP3om^h01@3om^h203eIZ`<0ooK^00<0?EV[0?ofkP3om^h0
303om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00H0ooK^1P0mFJ/20?ofkP0303eI
Z`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h01P0mFJ/80?ofkP0303eIZ`3om^h0ooK^00`0ooK^
00<0?EV[0?ofkP3om^h0303om^h0100mFJ/0ooK^0?ofkP3om^h203eIZ`L0ooK^00<0?EV[0?ofkP3o
m^h0203om^h203eIZeD0ooK^00<000000?ofkP3om^h0403om^h00`000000ooK^0?ofkP0n0?ofkP40
oooo00100?ofkP030000003om^h0ooK^0140ooK^00<000000?ofkP3om^h0DP3om^h203eIZ`X0ooK^
00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00`0ooK^
00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0603eIZ`P0ooK^00<0?EV[0?ofkP3om^h0
3@3om^h00`0mFJ/0ooK^0?ofkP060?ofkPH0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eI
Z`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eI
Z`3om^h0ooK^00P0ooK^0P0mFJ]D0?ofkP030000003om^h0ooK^0140ooK^00<000000?ofkP3om^h0
?P3om^h10?ooo`00@03om^h00`000000ooK^0?ofkP0A0?ofkP030000003om^h0ooK^0540ooK^00<0
?EV[0?ofkP0mFJ/02P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0
?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP@0?EV[3P3om^h00`0mFJ/0ooK^0?of
kP0=0?ofkP0303eIZ`3om^h0ooK^00`0ooK^100mFJ/=0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0
?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0
?EV[0?ofkP0mFJ/0D`3om^h00`000000ooK^0?ofkP0A0?ofkP030000003om^h0ooK^03h0ooK^0@3o
ool003l0ooK^00<000000?ofkP3om^h04P3om^h00`000000ooK^0?ofkP1A0?ofkP0303eIZ`3om^h0
?EV[00X0ooK^00@0?EV[0?ofkP3om^h0ooK^0P0mFJ/70?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0
?EV[0?ofkP3om^h0203om^h303eIZ`030?ofkP0mFJ/0ooK^00l0ooK^00<0?EV[0?ofkP3om^h03@3o
m^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0?EV[0080?EV[2P3om^h00`0mFJ/0ooK^0?of
kP0<0?ofkP0303eIZ`3om^h0ooK^00D0ooK^0P0mFJ/30?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0
?EV[0?ofkP0mFJ/0D`3om^h00`000000ooK^0?ofkP0B0?ofkP030000003om^h0ooK^03d0ooK^0@3o
ool003l0ooK^00<000000?ofkP3om^h04P3om^h00`000000ooK^0?ofkP1@0?ofkP0503eIZ`3om^h0
ooK^0?ofkP0mFJ/02@3om^h0100mFJ/0ooK^0?ofkP0mFJ/90?ofkP0303eIZ`3om^h0ooK^00`0ooK^
00<0?EV[0?ofkP3om^h01@3om^h303eIZ`@0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^
0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h00P3om^h303eIZ`L0ooK^
00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP070?ofkP0403eIZ`3om^h0ooK^03eIZ`T0
ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`1B0?ofkP030000003om^h0ooK^0180ooK^00<000000?of
kP3om^h0?@3om^h10?ooo`00?`3om^h00`000000ooK^0?ofkP0C0?ofkP030000003om^h0ooK^04h0
ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP070?ofkP<0?EV[2P3om^h00`0mFJ/0
ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^0080ooK^0`0mFJ/70?ofkP0303eIZ`3om^h0ooK^00h0
ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00D0
ooK^0`0mFJ/40?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h0203om^h303eIZ`T0
ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`1A0?ofkP030000003om^h0ooK^01<0ooK^00<000000?of
kP3om^h0?@3om^h10?ooo`00?`3om^h00`000000ooK^0?ofkP0C0?ofkP030000003om^h0ooK^04h0
ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00/0
ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^03eIZ`0203eIZ`X0ooK^00<0?EV[0?ofkP3o
m^h03P3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3o
m^h0203om^h303eIZ`030?ofkP0mFJ/0ooK^00`0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0
ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h0CP3om^h00`000000
ooK^0?ofkP0C0?ofkP030000003om^h0ooK^03d0ooK^0@3oool003l0ooK^00<000000?ofkP3om^h0
4`3om^h00`000000ooK^0?ofkP1=0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h0
1P3om^h203eIZ`d0ooK^00<0?EV[0?ofkP3om^h02`3om^h203eIZ`d0ooK^00<0?EV[0?ofkP3om^h0
3P3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h0
2`3om^h203eIZ`d0ooK^00<0?EV[0?ofkP3om^h02`3om^h203eIZ`P0ooK^00<0?EV[0?ofkP3om^h0
0`3om^h00`0mFJ/0ooK^0?ofkP1=0?ofkP030000003om^h0ooK^01<0ooK^00<000000?ofkP3om^h0
?@3om^h10?ooo`00?P3om^h00`000000ooK^0?ofkP0D0?ofkP030000003om^h0ooK^04d0ooK^00<0
?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0?EV[00d0ooK^00<0
?EV[0?ofkP3om^h02@3om^h303eIZ`h0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?of
kP0=0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h0303om^h303eIZ`/0ooK^00<0
?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^03eIZ`070?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0
?EV[0?ofkP3om^h0C@3om^h00`000000ooK^0?ofkP0D0?ofkP030000003om^h0ooK^03`0ooK^0@3o
ool003h0ooK^00<000000?ofkP3om^h05@3om^h00`000000ooK^0?ofkP1;0?ofkP0303eIZ`3om^h0
ooK^00@0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^03eIZ`0=0?ofkP0303eIZ`3om^h0
ooK^00L0ooK^0P0mFJ/20?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h03P3om^h0
0`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h0303om^h0
0`0mFJ/0ooK^0?ofkP0203eIZ`T0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^03eIZ`07
0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h0B`3om^h00`000000ooK^0?ofkP0E
0?ofkP030000003om^h0ooK^03`0ooK^0@3oool003h0ooK^00<000000?ofkP3om^h05@3om^h00`00
0000ooK^0?ofkP1;0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h0103om^h0100m
FJ/0ooK^0?ofkP0mFJ/=0?ofkP0303eIZ`3om^h0ooK^00D0ooK^0P0mFJ/40?ofkP0303eIZ`3om^h0
ooK^00`0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0
ooK^00d0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP020?ofkP80?EV[1`3om^h0
0`0mFJ/0ooK^0?ofkP0;0?ofkP0403eIZ`3om^h0ooK^03eIZ`H0ooK^00<0?EV[0?ofkP3om^h0103o
m^h00`0mFJ/0ooK^0?ofkP1;0?ofkP030000003om^h0ooK^01D0ooK^00<000000?ofkP3om^h0?03o
m^h10?ooo`00?P3om^h00`000000ooK^0?ofkP0E0?ofkP030000003om^h0ooK^04X0ooK^00<0?EV[
0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[
0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP80?EV[1P3om^h00`0mFJ/0ooK^0?ofkP0=
0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0=
0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h0103om^h203eIZ`D0ooK^00<0?EV[
0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[
0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP1:0?ofkP030000003om^h0ooK^01D0ooK^00<00000
0?ofkP3om^h0?03om^h10?ooo`00?P3om^h00`000000ooK^0?ofkP0E0?ofkP030000003om^h0ooK^
04X0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^
00<0ooK^00<0?EV[0?ofkP3om^h02P3om^h0100mFJ/0ooK^0?ofkP3om^h203eIZ`P0ooK^00<0?EV[
0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[
0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00H0ooK^0P0mFJ/3
0?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP02
0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h0BP3om^h00`000000ooK^0?ofkP0E
0?ofkP030000003om^h0ooK^03`0ooK^0@3oool003d0ooK^00<000000?ofkP3om^h05P3om^h00`00
0000ooK^0?ofkP1:0?ofkP0303eIZ`3om^h0ooK^00H0ooK^00@0?EV[0?ofkP3om^h0?EV[1P3om^h0
0`0mFJ/0ooK^0?ofkP0:0?ofkP0403eIZ`3om^h0?EV[03eIZ`X0ooK^00<0?EV[0?ofkP3om^h03@3o
m^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h03@3o
m^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00P0ooK^0P0mFJ/00`3om^h0?EV[0?of
kP0;0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00@0?EV[0?ofkP3om^h0?EV[203om^h00`0mFJ/0ooK^
0?ofkP1:0?ofkP030000003om^h0ooK^01H0ooK^00<000000?ofkP3om^h0>`3om^h10?ooo`00?@3o
m^h00`000000ooK^0?ofkP0G0?ofkP030000003om^h0ooK^04P0ooK^0P0mFJ/80?ofkP0303eIZ`3o
m^h0?EV[00L0ooK^00<0?EV[0?ofkP3om^h02P3om^h203eIZ``0ooK^00<0?EV[0?ofkP3om^h03@3o
m^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h03@3o
m^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00X0ooK^0P0mFJ/<0?ofkP0303eIZ`3o
m^h0ooK^00D0ooK^00<0?EV[0?ofkP0mFJ/0203om^h203eIZdX0ooK^00<000000?ofkP3om^h05`3o
m^h00`000000ooK^0?ofkP0k0?ofkP40oooo000m0?ofkP030000003om^h0ooK^01L0ooK^00<00000
0?ofkP3om^h0B03om^h203eIZ`P0ooK^00<0?EV[0?ofkP0mFJ/01`3om^h00`0mFJ/0ooK^0?ofkP09
0?ofkP80?EV[3@3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[
0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[
0?ofkP3om^h0303om^h203eIZ`/0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^03eIZ`08
0?ofkP80?EV[BP3om^h00`000000ooK^0?ofkP0G0?ofkP030000003om^h0ooK^03/0ooK^0@3oool0
03d0ooK^00<000000?ofkP3om^h05`3om^h00`000000ooK^0?ofkP180?ofkP0303eIZ`3om^h0?EV[
00L0ooK^0P0mFJ/80?ofkP0303eIZ`3om^h0ooK^00L0ooK^0P0mFJ/00`3om^h0?EV[0?ofkP0=0?of
kP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h02P3om^hG03eIZ``0ooK^00<0?EV[0?of
kP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0403eIZ`3om^h0?EV[03eIZ`T0ooK^00<0?EV[
0?ofkP3om^h01P3om^h203eIZ`L0ooK^00<0?EV[0?ofkP0mFJ/0BP3om^h00`000000ooK^0?ofkP0G
0?ofkP030000003om^h0ooK^03/0ooK^0@3oool003d0ooK^00<000000?ofkP3om^h05`3om^h00`00
0000ooK^0?ofkP180?ofkP0303eIZ`3om^h0?EV[00L0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0m
FJ/0ooK^0?ofkP060?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/03P3om^h00`0mFJ/0ooK^0?ofkP0<
0?ofkP0303eIZ`3om^h0ooK^0080ooK^200mFJ/30?ofkP0303eIZ`3om^h0ooK^00d0ooK^00@0?EV[
0?ofkP3om^h0ooK^200mFJ/40?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h0303o
m^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00P0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^
0?ofkP050?ofkP0303eIZ`3om^h0?EV[04X0ooK^00<000000?ofkP3om^h05`3om^h00`000000ooK^
0?ofkP0k0?ofkP40oooo000l0?ofkP030000003om^h0ooK^01T0ooK^00<000000?ofkP3om^h0AP3o
m^h0100mFJ/0ooK^0?ofkP0mFJ/60?ofkP80?EV[2@3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eI
Z`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0;0?ofkPH0?EV[
2`3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00T0ooK^1P0mFJ/=0?ofkP0303eI
Z`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eI
Z`3om^h0ooK^00L0ooK^0P0mFJ/60?ofkP0403eIZ`3om^h0ooK^03eIZdP0ooK^00<000000?ofkP3o
m^h06@3om^h00`000000ooK^0?ofkP0j0?ofkP40oooo000l0?ofkP030000003om^h0ooK^01T0ooK^
00<000000?ofkP3om^h0AP3om^h0100mFJ/0ooK^0?ofkP0mFJ/60?ofkP80?EV[2P3om^h00`0mFJ/0
ooK^0?ofkP020?ofkP80?EV[1@3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00P0
ooK^0`0mFJ/00`3om^h0?EV[0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3o
m^h03@3om^h00`0mFJ/0ooK^03eIZ`0203eIZ`X0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0
ooK^0?ofkP030?ofkP80?EV[103om^h00`0mFJ/0ooK^0?ofkP080?ofkP80?EV[1P3om^h0100mFJ/0
ooK^0?ofkP0mFJ]80?ofkP030000003om^h0ooK^01T0ooK^00<000000?ofkP3om^h0>P3om^h10?oo
o`00?03om^h00`000000ooK^0?ofkP0I0?ofkP030000003om^h0ooK^04H0ooK^00@0?EV[0?ofkP3o
m^h0?EV[1@3om^h00`0mFJ/0ooK^03eIZ`0:0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/01`3om^h0
0`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00D0ooK^0`0mFJ/40?ofkP0303eIZ`3om^h0
ooK^00d0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0
ooK^0080ooK^0`0mFJ/70?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h01@3om^h0
1@0mFJ/0ooK^0?ofkP3om^h0?EV[00X0ooK^00<0?EV[0?ofkP0mFJ/01@3om^h0100mFJ/0ooK^0?of
kP0mFJ]80?ofkP030000003om^h0ooK^01T0ooK^00<000000?ofkP3om^h0>P3om^h10?ooo`00?03o
m^h00`000000ooK^0?ofkP0I0?ofkP030000003om^h0ooK^04H0ooK^00@0?EV[0?ofkP3om^h0?EV[
1@3om^h00`0mFJ/0ooK^03eIZ`0:0?ofkP0403eIZ`3om^h0ooK^03eIZ`P0ooK^00<0?EV[0?ofkP3o
m^h0303om^h00`0mFJ/0ooK^0?ofkP020?ofkP<0?EV[1`3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP03
03eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP050?ofkP<0
?EV[103om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00H0ooK^00@0?EV[0?ofkP3o
m^h0?EV[2@3om^h0100mFJ/0ooK^0?ofkP0mFJ/50?ofkP0403eIZ`3om^h0ooK^03eIZdP0ooK^00<0
00000?ofkP3om^h06@3om^h00`000000ooK^0?ofkP0j0?ofkP40oooo000l0?ofkP030000003om^h0
ooK^01T0ooK^00<000000?ofkP3om^h0A@3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00@0ooK^00D0
?EV[0?ofkP3om^h0ooK^03eIZ`090?ofkP<0?EV[2@3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eI
Z`3om^h0?EV[0080?EV[2P3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00d0ooK^
00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP080?ofkP<0?EV[00<0ooK^03eIZ`3om^h0
303om^h00`0mFJ/0ooK^0?ofkP080?ofkP<0?EV[2@3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00@0
ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`170?ofkP030000003om^h0ooK^01T0ooK^00<000000?of
kP3om^h0>P3om^h10?ooo`00>`3om^h00`000000ooK^0?ofkP0K0?ofkP030000003om^h0ooK^04@0
ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`030?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?of
kP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00/0ooK^0P0mFJ/=0?of
kP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0=0?of
kP0303eIZ`3om^h0ooK^00/0ooK^0P0mFJ/=0?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?of
kP3om^h01`3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00@0ooK^00D0?EV[0?ofkP3om^h0ooK^03eI
Z`160?ofkP030000003om^h0ooK^01/0ooK^00<000000?ofkP3om^h0>@3om^h10?ooo`00>`3om^h0
0`000000ooK^0?ofkP0K0?ofkP030000003om^h0ooK^04@0ooK^00D0?EV[0?ofkP3om^h0ooK^03eI
Z`030?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h01P3om^h203eIZ``0ooK^00<0
?EV[0?ofkP3om^h02@3om^h303eIZ`h0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?of
kP0=0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h0303om^h303eIZ`/0ooK^00<0
?EV[0?ofkP3om^h02P3om^h203eIZ`P0ooK^00<0?EV[0?ofkP3om^h00P3om^h01@0mFJ/0ooK^0?of
kP3om^h0?EV[00<0ooK^00<0?EV[0?ofkP3om^h0A03om^h00`000000ooK^0?ofkP0K0?ofkP030000
003om^h0ooK^03T0ooK^0@3oool003/0ooK^00<000000?ofkP3om^h06`3om^h00`000000ooK^0?of
kP140?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP0mFJ/01@3om^h00`0mFJ/0ooK^0?of
kP050?ofkP0303eIZ`3om^h0?EV[00`0ooK^00<0?EV[0?ofkP3om^h01`3om^h203eIZ`80ooK^00<0
?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0
?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^0080?EV[2@3o
m^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0?EV[00L0ooK^00<0?EV[0?ofkP3om^h00`3o
m^h00`0mFJ/0ooK^03eIZ`040?ofkP0303eIZ`3om^h0ooK^04@0ooK^00<000000?ofkP3om^h06`3o
m^h00`000000ooK^0?ofkP0i0?ofkP40oooo000k0?ofkP030000003om^h0ooK^01/0ooK^00<00000
0?ofkP3om^h0A03om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0?EV[00D0ooK^00<0?EV[
0?ofkP3om^h0103om^h0100mFJ/0ooK^0?ofkP0mFJ/<0?ofkP0303eIZ`3om^h0ooK^00D0ooK^0P0m
FJ/40?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?of
kP0=0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?of
kP020?ofkP80?EV[1`3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0403eIZ`3om^h0ooK^03eIZ`H0ooK^
00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^03eIZ`040?ofkP0303eIZ`3om^h0ooK^04@0ooK^
00<000000?ofkP3om^h06`3om^h00`000000ooK^0?ofkP0i0?ofkP40oooo000k0?ofkP030000003o
m^h0ooK^01`0ooK^00<000000?ofkP3om^h0@`3om^h00`0mFJ/0ooK^0?ofkP020?ofkP80?EV[1P3o
m^h00`0mFJ/0ooK^0?ofkP030?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/0303om^h00`0mFJ/0ooK^
0?ofkP030?ofkP80?EV[1P3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00d0ooK^
00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00`0ooK^
00<0?EV[0?ofkP3om^h0103om^h203eIZ`D0ooK^00<0?EV[0?ofkP3om^h02P3om^h01@0mFJ/0ooK^
0?ofkP3om^h0?EV[00D0ooK^00<0?EV[0?ofkP3om^h0103om^h203eIZ`@0ooK^00<0?EV[0?ofkP3o
m^h0@`3om^h00`000000ooK^0?ofkP0L0?ofkP030000003om^h0ooK^03T0ooK^0@3oool003X0ooK^
00<000000?ofkP3om^h07@3om^h00`000000ooK^0?ofkP130?ofkP0303eIZ`3om^h0ooK^0080ooK^
0P0mFJ/60?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^
0?ofkP090?ofkP0403eIZ`3om^h0ooK^0?ofkP80?EV[203om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP03
03eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP03
03eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h01P3om^h203eIZ`<0ooK^00<0?EV[0?ofkP3o
m^h02P3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00D0ooK^00<0?EV[0?ofkP3om^h0103om^h203eI
Z`@0ooK^00<0?EV[0?ofkP3om^h0@`3om^h00`000000ooK^0?ofkP0M0?ofkP030000003om^h0ooK^
03P0ooK^0@3oool003X0ooK^00<000000?ofkP3om^h07@3om^h00`000000ooK^0?ofkP130?ofkP80
?EV[0`3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3o
m^h00`3om^h00`0mFJ/0ooK^0?ofkP090?ofkP0403eIZ`3om^h0?EV[03eIZ`X0ooK^00<0?EV[0?of
kP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?of
kP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00P0ooK^0P0mFJ/00`3o
m^h0?EV[0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^0080ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`08
0?ofkP0403eIZ`3om^h0ooK^0?ofkP80?EV[A@3om^h00`000000ooK^0?ofkP0M0?ofkP030000003o
m^h0ooK^03P0ooK^0@3oool003X0ooK^00<000000?ofkP3om^h07@3om^h00`000000ooK^0?ofkP13
0?ofkP80?EV[0`3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0403eIZ`3om^h0ooK^03eIZ`H0ooK^00<0
?EV[0?ofkP3om^h02@3om^h203eIZ``0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?of
kP0=0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?of
kP0<0?ofkP0303eIZ`3om^h0ooK^00X0ooK^0P0mFJ/<0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00@0
?EV[0?ofkP3om^h0?EV[203om^h0100mFJ/0ooK^0?ofkP3om^h203eIZdD0ooK^00<000000?ofkP3o
m^h07@3om^h00`000000ooK^0?ofkP0h0?ofkP40oooo000j0?ofkP030000003om^h0ooK^01h0ooK^
00<000000?ofkP3om^h0@P3om^h203eIZ`<0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^
03eIZ`070?ofkP0303eIZ`3om^h0ooK^00P0ooK^0P0mFJ/>0?ofkP0303eIZ`3om^h0ooK^00/0ooK^
00<0?EV[0?ofkP3om^h02`3om^hE03eIZ`d0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^
0?ofkP0<0?ofkP80?EV[2P3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0?EV[00P0ooK^
00D0?EV[0?ofkP3om^h0ooK^03eIZ`150?ofkP030000003om^h0ooK^01h0ooK^00<000000?ofkP3o
m^h0>03om^h10?ooo`00>P3om^h00`000000ooK^0?ofkP0N0?ofkP030000003om^h0ooK^04<0ooK^
00<0?EV[0?ofkP3om^h00P0mFJ/80?ofkP80?EV[203om^h00`0mFJ/0ooK^0?ofkP060?ofkP80?EV[
00<0ooK^03eIZ`3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00H0ooK^
1@0mFJ/20?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h01@0mFJ/80?ofkP0303eI
Z`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h0303om^h0100mFJ/0ooK^03eIZ`0mFJ/80?ofkP03
03eIZ`3om^h0ooK^00H0ooK^0P0mFJ/80?ofkP80?EV[0P3om^h00`0mFJ/0ooK^0?ofkP130?ofkP03
0000003om^h0ooK^01h0ooK^00<000000?ofkP3om^h0>03om^h10?ooo`00>@3om^h00`000000ooK^
0?ofkP0O0?ofkP030000003om^h0ooK^04<0ooK^00<0?EV[0?ofkP3om^h00P0mFJ/80?ofkP0303eI
Z`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h01@3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00h0
ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP0603eIZ`L0ooK^00<0?EV[0?ofkP3o
m^h03@3om^h00`0mFJ/0ooK^0?ofkP050?ofkPH0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP03
03eIZ`3om^h0ooK^00`0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`070?ofkP0303eIZ`3om^h0ooK^
00L0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^03eIZ`020?ofkP0303eIZ`3om^h0ooK^
04<0ooK^00<000000?ofkP3om^h07`3om^h00`000000ooK^0?ofkP0g0?ofkP40oooo000i0?ofkP03
0000003om^h0ooK^01l0ooK^00<000000?ofkP3om^h0@`3om^h01P0mFJ/0ooK^0?ofkP0mFJ/0ooK^
03eIZ`H0ooK^0P0mFJ/90?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h00P3om^h0
0`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00X0ooK^100mFJ/=0?ofkP0303eIZ`3om^h0
ooK^00d0ooK^00<0?EV[0?ofkP3om^h02`3om^h403eIZ``0ooK^00<0?EV[0?ofkP3om^h0303om^h0
0`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h01`3om^h2
03eIZ`H0ooK^00<0?EV[0?ofkP0mFJ/00P3om^h00`0mFJ/0ooK^0?ofkP130?ofkP030000003om^h0
ooK^01l0ooK^00<000000?ofkP3om^h0=`3om^h10?ooo`00>@3om^h00`000000ooK^0?ofkP0O0?of
kP030000003om^h0ooK^04<0ooK^00H0?EV[0?ofkP3om^h0?EV[0?ofkP0mFJ/60?ofkP80?EV[2@3o
m^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h0303o
m^h00`0mFJ/0ooK^0?ofkP060?ofkP@0?EV[00<0ooK^03eIZ`3om^h03P3om^h00`0mFJ/0ooK^0?of
kP0=0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP0mFJ/00`0mFJ/80?ofkP0303eIZ`3o
m^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h00`3om^h203eIZ`@0ooK^00<0?EV[0?ofkP3om^h01`3o
m^h203eIZ`H0ooK^00<0?EV[0?ofkP0mFJ/00P3om^h00`0mFJ/0ooK^0?ofkP130?ofkP030000003o
m^h0ooK^01l0ooK^00<000000?ofkP3om^h0=`3om^h10?ooo`00>@3om^h00`000000ooK^0?ofkP0P
0?ofkP030000003om^h0ooK^0480ooK^00<0?EV[0?ofkP0mFJ/00P3om^h00`0mFJ/0ooK^0?ofkP03
0?ofkP0303eIZ`3om^h0?EV[00X0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`060?ofkP0303eIZ`3o
m^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h00`3om^h303eIZ`D0ooK^00<0?EV[0?ofkP3om^h03@3o
m^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h00`3o
m^h303eIZ`D0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP050?ofkP0503eIZ`3o
m^h0ooK^0?ofkP0mFJ/02@3om^h00`0mFJ/0ooK^03eIZ`050?ofkP0603eIZ`3om^h0ooK^03eIZ`3o
m^h0?EV[A03om^h00`000000ooK^0?ofkP0P0?ofkP030000003om^h0ooK^03L0ooK^0@3oool003T0
ooK^00<000000?ofkP3om^h0803om^h00`000000ooK^0?ofkP120?ofkP0303eIZ`3om^h0?EV[0080
ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^03eIZ`0:0?ofkP0403eIZ`3om^h0?EV[03eI
Z`L0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^03eIZ`0303eIZ`P0ooK^00<0?EV[0?of
kP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?of
kP3om^h01P3om^h403eIZ`030?ofkP0mFJ/0ooK^00d0ooK^00<0?EV[0?ofkP3om^h01P3om^h0100m
FJ/0ooK^0?ofkP0mFJ/90?ofkP0303eIZ`3om^h0?EV[00D0ooK^00H0?EV[0?ofkP3om^h0?EV[0?of
kP0mFJ]40?ofkP030000003om^h0ooK^0200ooK^00<000000?ofkP3om^h0=`3om^h10?ooo`00>03o
m^h00`000000ooK^0?ofkP0Q0?ofkP030000003om^h0ooK^0480ooK^0`0mFJ/20?ofkP0303eIZ`3o
m^h0ooK^0080ooK^00@0?EV[0?ofkP3om^h0?EV[2P3om^h203eIZ`X0ooK^00<0?EV[0?ofkP3om^h0
2`3om^h203eIZ``0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eI
Z`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h02P3om^h203eIZ`d0ooK^00<0?EV[0?ofkP3om^h0
203om^h303eIZ`T0ooK^00@0?EV[0?ofkP3om^h0?EV[103om^h00`0mFJ/0ooK^0?ofkP0303eIZd@0
ooK^00<000000?ofkP3om^h08@3om^h00`000000ooK^0?ofkP0f0?ofkP40oooo000h0?ofkP030000
003om^h0ooK^0240ooK^00<000000?ofkP3om^h0@P3om^h303eIZ`80ooK^00D0?EV[0?ofkP3om^h0
ooK^03eIZ`030?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0
ooK^0?ofkP090?ofkP<0?EV[3@3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00d0
ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP<0?EV[2`3om^h00`0mFJ/0
ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00L0ooK^00@0?EV[0?ofkP3om^h0?EV[103om^h00`0m
FJ/0ooK^0?ofkP0303eIZd@0ooK^00<000000?ofkP3om^h08@3om^h00`000000ooK^0?ofkP0f0?of
kP40oooo000h0?ofkP030000003om^h0ooK^0280ooK^00<000000?ofkP3om^h0@@3om^h203eIZ`<0
ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`030?ofkP0303eIZ`3om^h0ooK^00L0ooK^0P0mFJ/;0?of
kP0303eIZ`3om^h0ooK^00L0ooK^0P0mFJ/20?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?of
kP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?of
kP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP0203eIZ`T0ooK^00<0?EV[0?ofkP3om^h02P3om^h203eI
Z`P0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`030?ofkP0403eIZ`3om^h0ooK^0?ofkP80?EV[@`3o
m^h00`000000ooK^0?ofkP0R0?ofkP030000003om^h0ooK^03H0ooK^0@3oool003P0ooK^00<00000
0?ofkP3om^h08P3om^h00`000000ooK^0?ofkP110?ofkP80?EV[0`3om^h0100mFJ/0ooK^0?ofkP0m
FJ/40?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP0mFJ/02`3om^h00`0mFJ/0ooK^0?of
kP050?ofkP80?EV[103om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0
?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0
?EV[0?ofkP3om^h00P3om^h203eIZ`L0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^03eI
Z`060?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP0mFJ/0103om^h203eIZd<0ooK^00<0
00000?ofkP3om^h08P3om^h00`000000ooK^0?ofkP0f0?ofkP40oooo000h0?ofkP030000003om^h0
ooK^0280ooK^00<000000?ofkP3om^h0@@3om^h203eIZ`@0ooK^00<0?EV[0?ofkP0mFJ/01@3om^h0
0`0mFJ/0ooK^0?ofkP040?ofkP0403eIZ`3om^h0ooK^03eIZ`/0ooK^00<0?EV[0?ofkP3om^h00`3o
m^h203eIZ`H0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3o
m^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3o
m^h0ooK^00@0ooK^0P0mFJ/50?ofkP0303eIZ`3om^h0ooK^00X0ooK^00@0?EV[0?ofkP3om^h0?EV[
1@3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0?EV[00@0ooK^0P0mFJ]30?ofkP030000
003om^h0ooK^0280ooK^00<000000?ofkP3om^h0=P3om^h10?ooo`00=`3om^h00`000000ooK^0?of
kP0S0?ofkP030000003om^h0ooK^0480ooK^0P0mFJ/30?ofkP80?EV[1P3om^h00`0mFJ/0ooK^0?of
kP030?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/02`3om^h0100mFJ/0ooK^0?ofkP3om^h203eIZ`P0
ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00d0
ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00H0
ooK^0P0mFJ/30?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0
ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00@0ooK^0P0mFJ/30?ofkP80?EV[A03om^h00`000000
ooK^0?ofkP0S0?ofkP030000003om^h0ooK^03D0ooK^0@3oool003L0ooK^00<000000?ofkP3om^h0
8`3om^h00`000000ooK^0?ofkP120?ofkP80?EV[0`3om^h203eIZ`H0ooK^00<0?EV[0?ofkP3om^h0
0P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00T0ooK^00@0?EV[0?ofkP0mFJ/0
?EV[2P3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3o
m^h03@3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3o
m^h0203om^h203eIZ`030?ofkP0mFJ/0ooK^00X0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0
ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00@0ooK^0P0mFJ/30?ofkP80?EV[A03om^h00`000000
ooK^0?ofkP0S0?ofkP030000003om^h0ooK^03D0ooK^0@3oool003L0ooK^00<000000?ofkP3om^h0
903om^h00`000000ooK^0?ofkP110?ofkP80?EV[0`3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0503eI
Z`3om^h0ooK^0?ofkP0mFJ/01@3om^h00`0mFJ/0ooK^0?ofkP090?ofkP80?EV[303om^h00`0mFJ/0
ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0
ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h02P3om^h203eIZ`/0
ooK^00<0?EV[0?ofkP3om^h00`3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00L0ooK^00@0?EV[0?of
kP3om^h0ooK^0P0mFJ]30?ofkP030000003om^h0ooK^02@0ooK^00<000000?ofkP3om^h0=@3om^h1
0?ooo`00=`3om^h00`000000ooK^0?ofkP0T0?ofkP030000003om^h0ooK^0440ooK^0P0mFJ/30?of
kP0303eIZ`3om^h0ooK^00D0ooK^00@0?EV[0?ofkP3om^h0?EV[1P3om^h00`0mFJ/0ooK^0?ofkP08
0?ofkP80?EV[3@3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00X0ooK^5@0mFJ/<
0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h02`3om^h203eIZ`X0ooK^00<0?EV[
0?ofkP3om^h0103om^h0100mFJ/0ooK^0?ofkP0mFJ/70?ofkP0403eIZ`3om^h0ooK^0?ofkP80?EV[
@`3om^h00`000000ooK^0?ofkP0T0?ofkP030000003om^h0ooK^03D0ooK^0@3oool003L0ooK^00<0
00000?ofkP3om^h0903om^h00`000000ooK^0?ofkP110?ofkP<0?EV[0P3om^h00`0mFJ/0ooK^0?of
kP050?ofkP0303eIZ`3om^h0?EV[00P0ooK^00<0?EV[0?ofkP3om^h01@3om^h203eIZ`030?ofkP0m
FJ/0ooK^00`0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP050?ofkPD0?EV[0P3o
m^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00D0?EV[1`3om^h00`0mFJ/0ooK^0?of
kP0<0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00@0?EV[0?ofkP0mFJ/0?EV[203om^h00`0mFJ/0ooK^
0?ofkP050?ofkP0303eIZ`3om^h0?EV[00L0ooK^00<0?EV[0?ofkP3om^h00`0mFJ]30?ofkP030000
003om^h0ooK^02@0ooK^00<000000?ofkP3om^h0=@3om^h10?ooo`00=P3om^h00`000000ooK^0?of
kP0U0?ofkP030000003om^h0ooK^0440ooK^0`0mFJ/00`3om^h0?EV[03eIZ`070?ofkP80?EV[2@3o
m^h00`0mFJ/0ooK^0?ofkP040?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/03@3om^h00`0mFJ/0ooK^
0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00D0?EV[1`3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eI
Z`3om^h0ooK^00D0ooK^1@0mFJ/20?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h0
2`3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00L0ooK^00<0?EV[0?ofkP3om^h01P3om^h203eIZ`L0
ooK^0P0mFJ/0103om^h0?EV[03eIZ`0mFJ]30?ofkP030000003om^h0ooK^02D0ooK^00<000000?of
kP3om^h0=03om^h10?ooo`00=P3om^h00`000000ooK^0?ofkP0V0?ofkP030000003om^h0ooK^0400
ooK^0`0mFJ/00`3om^h0?EV[03eIZ`070?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3o
m^h00`3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3o
m^h02`3om^h403eIZ``0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP@0
?EV[3@3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3o
m^h0103om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00@0ooK^00@0?EV[0?ofkP0m
FJ/0ooK^0`0mFJ]20?ofkP030000003om^h0ooK^02H0ooK^00<000000?ofkP3om^h0=03om^h10?oo
o`00=P3om^h00`000000ooK^0?ofkP0V0?ofkP030000003om^h0ooK^0400ooK^0P0mFJ/01@3om^h0
?EV[03eIZ`3om^h0?EV[00D0ooK^0P0mFJ/:0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?of
kP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00L0ooK^100mFJ/00`3o
m^h0?EV[0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0m
FJ/0ooK^03eIZ`0303eIZ`T0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP040?of
kP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP040?of
kP0503eIZ`3om^h0?EV[03eIZ`3om^h00P0mFJ]20?ofkP030000003om^h0ooK^02H0ooK^00<00000
0?ofkP3om^h0=03om^h10?ooo`00=P3om^h00`000000ooK^0?ofkP0V0?ofkP030000003om^h0ooK^
0440ooK^00H0?EV[0?ofkP0mFJ/0?EV[0?ofkP0mFJ/50?ofkP80?EV[2P3om^h01@0mFJ/0ooK^0?of
kP3om^h0?EV[00L0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP@0?EV[
1@3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h0
303om^h00`0mFJ/0ooK^0?ofkP030?ofkP@0?EV[1@3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eI
Z`3om^h0ooK^00D0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0:0?ofkP80?EV[1@3om^h01P0mFJ/0
ooK^03eIZ`0mFJ/0ooK^03eIZd<0ooK^00<000000?ofkP3om^h09P3om^h00`000000ooK^0?ofkP0d
0?ofkP40oooo000f0?ofkP030000003om^h0ooK^02H0ooK^00<000000?ofkP3om^h0@@3om^h01P0m
FJ/0ooK^03eIZ`0mFJ/0ooK^03eIZ`@0ooK^00<0?EV[0?ofkP0mFJ/02P3om^h0100mFJ/0ooK^03eI
Z`0mFJ/80?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP0mFJ/00`0mFJ/90?ofkP0303eI
Z`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eI
Z`3om^h0ooK^00L0ooK^100mFJ/00`3om^h0?EV[0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00H0ooK^
0P0mFJ/00`3om^h0?EV[0?ofkP080?ofkP0303eIZ`3om^h0?EV[00D0ooK^00H0?EV[0?ofkP0mFJ/0
?EV[0?ofkP0mFJ]30?ofkP030000003om^h0ooK^02H0ooK^00<000000?ofkP3om^h0=03om^h10?oo
o`00=@3om^h00`000000ooK^0?ofkP0X0?ofkP030000003om^h0ooK^0400ooK^00H0?EV[0?ofkP0m
FJ/0?EV[0?ofkP0mFJ/40?ofkP0403eIZ`3om^h0ooK^03eIZ`T0ooK^0P0mFJ/:0?ofkP0303eIZ`3o
m^h0ooK^00X0ooK^0P0mFJ/=0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h03@3o
m^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00/0ooK^0P0mFJ/<0?ofkP0303eIZ`3o
m^h0ooK^00P0ooK^0P0mFJ/90?ofkP0403eIZ`3om^h0ooK^03eIZ`@0ooK^0P0mFJ/0103om^h0?EV[
0?ofkP0mFJ]20?ofkP030000003om^h0ooK^02P0ooK^00<000000?ofkP3om^h0<`3om^h10?ooo`00
=@3om^h00`000000ooK^0?ofkP0X0?ofkP030000003om^h0ooK^0400ooK^00<0?EV[0?ofkP0mFJ/0
0`0mFJ/30?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/02@3om^h00`0mFJ/0ooK^0?ofkP040?ofkV/0
000000<0?EV[0000000000000`0000060?ofkP0303eIZ`3om^h0ooK^00L0ooK^00@0?EV[0?ofkP3o
m^h0?EV[103om^h603eIZd80ooK^00<000000?ofkP3om^h0:03om^h00`000000ooK^0?ofkP0c0?of
kP40oooo000e0?ofkP030000003om^h0ooK^02P0ooK^00<000000=@m6@3D?AT0@03D?AT403eIZ`03
0=@m6@0mFJ/0e3dI0080e3dI00D0?EV[0=@m6@3D?AT0e3dI03eIZ`080=@m6@80?EV[0P3D?AT40000
00@0<0/410000005030;10<000001P0`2`@2000000L0<0/40P000006030;10030000000`2`@0<0/4
00D0<0/400<00000030;100`2`@01P0`2`@00`000000<0/4030;1005030;10030000000`2`@0<0/4
00H0<0/400<00000030;100`2`@0100`2`@2000000L0<0/40P000006030;10<000001@0`2`@40000
00@0<0/4100000020=@m6@80?EV[203D?AT01@0mFJ/0e3dI0=@m6@3D?AT0?EV[00<0e3dI00<0?EV[
0=@m6@0mFJ/00`0mFJ]20=@m6@030000003om^h0ooK^02P0ooK^00<000000?ofkP3om^h0<`3om^h1
0?ooo`00=@3om^h00`000000ooK^0?ofkP0W0?ofkP80e3dI00<0ooK^0=@m6@3D?AT04@3om^h20=@m
6@030?ofkP3D?AT0ooK^0140ooK^00<0e3dI0?ofkP3D?AT04`3om^h01`3D?AT0ooK^03eIZ`0mFJ/0
ooK^03eIZ`3om^h00P0mFJ/00`3om^h0?EV[0?ofkP030?ofkP0303eIZ`3om^h0ooK^00@0ooK^00@0
e3dI03eIZ`3om^h0?EV[O@00000203eIZ`030?ofkP3D?AT0ooK^00D0ooK^00D0?EV[0?ofkP3om^h0
ooK^03eIZ`020?ofkP80?EV[00<0ooK^03eIZ`3om^h00P0mFJ/00`3om^h0e3dI0?ofkP0B0?ofkP03
0=@m6@3om^h0e3dI0180ooK^00@0e3dI0?ofkP3D?AT0e3dI4@3om^h20=@m6@030?ofkP3D?AT0e3dI
02T0ooK^00<000000?ofkP3om^h0<`3om^h10?ooo`00=@3om^h00`000000ooK^0?ofkP0V0?ofkTD0
e3dI0P0mFJ/00`3D?AT0?EV[0=@m6@0203eIZ`030=@m6@0mFJ/0e3dI00<0e3dI00<0?EV[0=@m6@3D
?AT01@3D?AT00`0mFJ/0000004X@1`0604X@1`8000001`1:40L2000000P0BQ0700<0000004X@1`1:
40L01P1:40L00`000000BQ0704X@1`0604X@1`030000001:40L0BQ0700L0BQ0700<0000004X@1`1:
40L01P1:40L00`000000BQ0704X@1`0604X@1`030000001:40L0BQ0700H0BQ0700<0000004X@1`1:
40L01`1:40L00`000000BQ0704X@1`0604X@1`030000001:40L0BQ0700H0BQ070P00000704X@1`80
00001`1:40L00`000000?EV[0=@m6@060=@m6@0303eIZ`3D?AT0e3dI0080e3dI0`0mFJ/20=@m6@04
03eIZ`3D?AT0?EV[03eIZdD0e3dI:03om^h00`000000ooK^0?ofkP0c0?ofkP40oooo000e0?ofkP03
0000003om^h0ooK^02D0ooK^00D0e3dI0?ofkP3om^h0ooK^000000030?ofkP030=@m6@3om^h0ooK^
00/0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP050=@m6@3om^h0ooK^
0?ofkP3D?AT04@3om^h00`3D?AT0ooK^0?ofkP0203eIZ`040?ofkP0mFJ/0ooK^0?ofkP80?EV[1@3o
m^h00`0mFJ/0ooK^0?ofkP030?ofkP050=@m6@0mFJ/0BQ0704X@1`0mFJ/0101:40L2000000P0BQ07
00<0000004X@1`1:40L01P1:40L2000000P0BQ0700<0000004X@1`1:40L01`1:40L00`000000BQ07
04X@1`0604X@1`030000001:40L0BQ0700L0BQ0700<0000004X@1`1:40L01P1:40L00`000000BQ07
04X@1`0704X@1`030000001:40L0BQ0700H0BQ0700<0000004X@1`1:40L01`1:40L2000000P0BQ07
00<0000004X@1`1:40L01P1:40L2000000L0BQ0700<0?EV[0=@m6@3om^h00`3om^h00`0mFJ/0ooK^
0?ofkP030?ofkP<0?EV[0P3om^h0100mFJ/0ooK^03eIZ`0mFJ/20?ofkP030=@m6@3om^h0ooK^00l0
ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0@0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?of
kP3om^h02`3om^h01@3D?AT0ooK^0?ofkP3om^h0000000<0ooK^00<0e3dI0?ofkP3om^h09@3om^h0
0`000000ooK^0?ofkP0c0?ofkP40oooo000d0?ofkP030000003om^h0ooK^02H0ooK^00D0e3dI0?of
kP3om^h0ooK^000000030?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h0103om^h0
0`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h03P3om^h0
0`3D?AT0ooK^0?ofkP0403eIZ`80ooK^0`0mFJ/50?ofkP0303eIZ`3om^h0ooK^008000001`1:40L2
000000P0BQ070P00000804X@1`030000001:40L0BQ0700P0BQ0700<0000004X@1`1:40L01P1:40L0
0`000000BQ0704X@1`0704X@1`030000001:40L0BQ0700L0BQ0700<0000004X@1`1:40L01`1:40L0
0`000000BQ0704X@1`0604X@1`030000001:40L0BQ0700L0BQ0700<0000004X@1`1:40L0201:40L0
0`000000BQ0704X@1`0604X@1`800000201:40L2000000L0BQ070P0000020?ofkP0303eIZ`3om^h0
ooK^00<0ooK^0`0mFJ/20?ofkP@0?EV[0P3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0
ooK^00<0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0
ooK^00/0ooK^00D0e3dI0?ofkP3om^h0ooK^000000030?ofkP030=@m6@3om^h0ooK^02H0ooK^00<0
00000?ofkP3om^h0<P3om^h10?ooo`00=03om^h00`000000ooK^0?ofkP0U0?ofkP030=@m6@3om^h0
ooK^0080ooK^00<000000?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0
ooK^00D0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0
ooK^00d0ooK^00<0e3dI0?ofkP3om^h00P3om^h203eIZ`040?ofkP0mFJ/0ooK^03eIZ`80ooK^00<0
?EV[0?ofkP3om^h00P3om^h00`0mFJ/000000000002=0000000303eIZ`3om^h0ooK^0080ooK^00L0
?EV[0?ofkP0mFJ/0?EV[0?ofkP0mFJ/0ooK^0080?EV[103om^h00`3D?AT0ooK^0?ofkP0=0?ofkP03
0=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP050?ofkP03
0=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`000000ooK^0?ofkP020?ofkP03
0=@m6@3om^h0ooK^02D0ooK^00<000000?ofkP3om^h0<P3om^h10?ooo`00=03om^h00`000000ooK^
0?ofkP0U0?ofkP030=@m6@3om^h0ooK^0080ooK^00<000000?ofkP3om^h00P3om^h00`3D?AT0ooK^
0?ofkP090?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^
0?ofkP050?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h00P3om^h203eIZ`040?of
kP0mFJ/0ooK^03eIZ`80ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0JAT:06TI2P0706TI2P03
0000001Y6@X0JAT:00L0JAT:00<0000006TI2P1Y6@X01`1Y6@X00`000000JAT:06TI2P0806TI2P03
0000001Y6@X0JAT:00P0JAT:00<0000006TI2P1Y6@X01`1Y6@X00`000000JAT:06TI2P0706TI2P03
0000001Y6@X0JAT:00L0JAT:00<0000006TI2P1Y6@X01`1Y6@X00`000000JAT:06TI2P0806TI2P03
0000001Y6@X0JAT:00P0JAT:00<0000006TI2P1Y6@X01`1Y6@X00`000000JAT:06TI2P0706TI2P03
0000001Y6@X0JAT:00L0JAT:00D0?EV[0?ofkP3om^h0ooK^03eIZ`030?ofkP0403eIZ`3om^h0?EV[
0?ofkP80?EV[103om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI
0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI
0?ofkP3om^h00P3om^h00`000000ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^02D0ooK^00<00000
0?ofkP3om^h0<P3om^h10?ooo`00=03om^h00`000000ooK^0?ofkP0T0?ofkTT0e3dI00H0?EV[0=@m
6@0mFJ/0?EV[0=@m6@0mFJ/30=@m6@0403eIZ`3D?AT0e3dI0=@m6@T0JAT:00<0000006TI2P1Y6@X0
1`1Y6@X00`000000JAT:06TI2P0806TI2P030000001Y6@X0JAT:00P0JAT:00<0000006TI2P1Y6@X0
1`1Y6@X00`000000JAT:06TI2P0806TI2P030000001Y6@X0JAT:00L0JAT:00<0000006TI2P1Y6@X0
1`1Y6@X00`000000JAT:06TI2P0806TI2P030000001Y6@X0JAT:00L0JAT:00<0000006TI2P1Y6@X0
201Y6@X00`000000JAT:06TI2P0806TI2P030000001Y6@X0JAT:00L0JAT:00<0000006TI2P1Y6@X0
1`1Y6@X30=@m6@0603eIZ`3D?AT0e3dI0=@m6@0mFJ/0e3dI100mFJ]90=@m6BH0ooK^00<000000?of
kP3om^h0<P3om^h10?ooo`00=03om^h00`000000ooK^0?ofkP0T0?ofkP030=@m6@3om^h0ooK^00@0
ooK^00<000000?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00L0
ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00`0
ooK^00<0e3dI0?ofkP3om^h00P3om^h403eIZ`030?ofkP0mFJ/0ooK^00<0ooK^00<0?EV[0000001Y
6@X0201Y6@X00`000000JAT:06TI2P0806TI2P030000001Y6@X0JAT:00L0JAT:00<0000006TI2P1Y
6@X0201Y6@X00`000000JAT:06TI2P0806TI2P030000001Y6@X0JAT:00L0JAT:00<0000006TI2P1Y
6@X0201Y6@X00`000000JAT:06TI2P0806TI2P030000001Y6@X0JAT:00L0JAT:00<0000006TI2P1Y
6@X0201Y6@X00`000000JAT:06TI2P0806TI2P030000001Y6@X0JAT:00L0JAT:00<0000006TI2P1Y
6@X0201Y6@X00`000000JAT:06TI2P0706TI2P030000000mFJ/0ooK^00<0ooK^00<0?EV[0?ofkP0m
FJ/00`0mFJ/40?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0
ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0
ooK^0?ofkP020?ofkP030000003om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h0903om^h00`000000
ooK^0?ofkP0b0?ofkP40oooo000c0?ofkP030000003om^h0ooK^02@0ooK^00<0e3dI0?ofkP3om^h0
1@3om^h00`000000ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h0
2@3om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h0
2P3om^h00`3D?AT0ooK^0?ofkP030?ofkPH0?EV[0`3om^h00`000000?EV[03eIZ`0806TI2P030000
001Y6@X0JAT:00P0JAT:00<0000006TI2P1Y6@X0201Y6@X00`000000JAT:06TI2P0806TI2P030000
001Y6@X0JAT:00L0JAT:00<0000006TI2P1Y6@X0201Y6@X00`000000JAT:06TI2P0806TI2P030000
001Y6@X0JAT:00P0JAT:00<0000006TI2P1Y6@X0201Y6@X00`000000JAT:06TI2P0706TI2P030000
001Y6@X0JAT:00P0JAT:00<0000006TI2P1Y6@X0201Y6@X00`000000JAT:06TI2P0806TI2P030000
001Y6@X0JAT:00H0JAT:0P0mFJ/010000000ooK^0?ofkP3om^h603eIZ`@0ooK^00<0e3dI0?ofkP3o
m^h02`3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3o
m^h0203om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00<0ooK^00<000000?ofkP3o
m^h01@3om^h00`3D?AT0ooK^0?ofkP0T0?ofkP030000003om^h0ooK^0340ooK^0@3oool003<0ooK^
00<000000?ofkP3om^h0903om^h00`3D?AT0ooK^0?ofkP050?ofkP030000003om^h0ooK^00<0ooK^
00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^00P0ooK^
00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00<0ooK^
0P0mFJ/0103D?AT0?EV[03eIZ`0mFJ/20?ofkP80000000<0?EV[0000000mFJ/0T@0000000`0mFJ/0
000003eIZ`0200000080ooK^0`0mFJ/00`3D?AT0?EV[03eIZ`050?ofkP030=@m6@3om^h0ooK^00X0
ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00T0
ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP030?ofkP030000003om^h0ooK^00D0
ooK^00<0e3dI0?ofkP3om^h0903om^h00`000000ooK^0?ofkP0a0?ofkP40oooo000c0?ofkP030000
003om^h0ooK^02<0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`000000ooK^0?ofkP020?ofkP030=@m
6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m
6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP030?ofkP80?EV[
00H0e3dI03eIZ`0mFJ/0ooK^03eIZ`00000208hT3`0403eIZ`2>90l0SR@?03eIZ`D0SR@?00<00000
08hT3`2>90l0202>90l00`000000SR@?08hT3`0808hT3`030000002>90l0SR@?00P0SR@?00<00000
08hT3`2>90l0202>90l00`000000SR@?08hT3`0808hT3`030000002>90l0SR@?00P0SR@?00<00000
08hT3`2>90l0202>90l00`000000SR@?08hT3`0808hT3`030000002>90l0SR@?00P0SR@?00<00000
08hT3`2>90l0202>90l00`000000SR@?08hT3`0808hT3`030000002>90l0SR@?00P0SR@?00<00000
08hT3`2>90l00`2>90l0100mFJ/0SR@?08hT3`0mFJ/208hT3`030000000mFJ/0ooK^0080?EV[00<0
e3dI03eIZ`0mFJ/01@3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0
e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0
e3dI0?ofkP3om^h00P3om^h00`000000ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^02@0ooK^00<0
00000?ofkP3om^h0<@3om^h10?ooo`00<`3om^h00`000000ooK^0?ofkP0S0?ofkP030=@m6@3om^h0
ooK^00L0ooK^00<000000?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0
ooK^00X0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0
ooK^00X0ooK^00<0e3dI0?ofkP3om^h00`3om^h203eIZ`060=@m6@3om^h0?EV[0?ofkP0mFJ/00000
0P2>90l01@0mFJ/0SR@?08hT3`2>90l0?EV[00<0SR@?00<0000008hT3`2>90l0202>90l00`000000
SR@?08hT3`0808hT3`030000002>90l0SR@?00P0SR@?00<0000008hT3`2>90l02@2>90l00`000000
SR@?08hT3`0808hT3`030000002>90l0SR@?00P0SR@?00<0000008hT3`2>90l0202>90l00`000000
SR@?08hT3`0808hT3`030000002>90l0SR@?00T0SR@?00<0000008hT3`2>90l0202>90l00`000000
SR@?08hT3`0808hT3`030000002>90l0SR@?00P0SR@?00D0000008hT3`2>90l0SR@?03eIZ`0308hT
3`0903eIZ`2>90l0SR@?0000000mFJ/0ooK^03eIZ`3om^h0e3dI0080?EV[1@3om^h00`3D?AT0ooK^
0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^
0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`000000ooK^
0?ofkP070?ofkP030=@m6@3om^h0ooK^02<0ooK^00<000000?ofkP3om^h0<@3om^h10?ooo`00<`3o
m^h00`000000ooK^0?ofkP0S0?ofkP030=@m6@3om^h0ooK^00L0ooK^00<000000?ofkP3om^h00`3o
m^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h01@3o
m^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h01@3o
m^h01P0mFJ/0ooK^03eIZ`0mFJ/0ooK^03eIZ`@0SR@?00D0?EV[08hT3`2>90l0SR@?03eIZ`0208hT
3`030000002>90l0SR@?00P0SR@?00<0000008hT3`2>90l0202>90l00`000000SR@?08hT3`0808hT
3`030000002>90l0SR@?00T0SR@?00<0000008hT3`2>90l0202>90l00`000000SR@?08hT3`0808hT
3`030000002>90l0SR@?00P0SR@?00<0000008hT3`2>90l0202>90l00`000000SR@?08hT3`0908hT
3`030000002>90l0SR@?00P0SR@?00<0000008hT3`2>90l0202>90l00`000000SR@?08hT3`0808hT
3`040000002>90l0SR@?03eIZ`<0SR@?00<0?EV[08hT3`2>90l00P2>90l01P0mFJ/0ooK^03eIZ`0m
FJ/0ooK^03eIZ`H0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m
6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m
6@3om^h0ooK^00<0ooK^00<000000?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP0S0?ofkP030000
003om^h0ooK^0340ooK^0@3oool00380ooK^00<000000?ofkP3om^h08`3om^h00`3D?AT0ooK^0?of
kP080?ofkP030000003om^h0ooK^00<0ooK^?03D?AT00`0mFJ/0e3dI03eIZ`0303eIZ`@0SR@?00<0
?EV[08hT3`2>90l00P2>90l203eIZ`X0SR@?00<0000008hT3`2>90l02@2>90l00`000000SR@?08hT
3`0808hT3`030000002>90l0SR@?00P0SR@?00<0000008hT3`2>90l0202>90l00`000000SR@?08hT
3`0908hT3`030000002>90l0SR@?00T0SR@?00<0000008hT3`2>90l0202>90l00`000000SR@?08hT
3`0808hT3`030000002>90l0SR@?00P0SR@?00<0000008hT3`2>90l02@2>90l00`000000SR@?08hT
3`0808hT3`80?EV[102>90l00`0mFJ/0SR@?08hT3`0208hT3`@0?EV[00<0e3dI03eIZ`3D?AT0>`3D
?AT50?ofkP030000003om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h08`3om^h00`000000ooK^0?of
kP0`0?ofkP40oooo000b0?ofkP030000003om^h0ooK^02<0ooK^C@3D?AT00`0mFJ/0e3dI03eIZ`03
03eIZ`@0SR@?00<0?EV[08hT3`2>90l00`2>90l00`000000?EV[08hT3`0808hT3`030000002>90l0
SR@?00T0SR@?00<0000008hT3`2>90l0202>90l00`000000SR@?08hT3`0808hT3`030000002>90l0
SR@?00P0SR@?00<0000008hT3`2>90l02@2>90l00`000000SR@?08hT3`0908hT3`030000002>90l0
SR@?00P0SR@?00<0000008hT3`2>90l0202>90l00`000000SR@?08hT3`0808hT3`030000002>90l0
SR@?00T0SR@?00<0000008hT3`2>90l01`2>90l00`0mFJ/0000008hT3`0408hT3`0303eIZ`2>90l0
SR@?0080SR@?1P0mFJ]=0=@m6BD0ooK^00<000000?ofkP3om^h0<03om^h10?ooo`00<P3om^h00`00
0000ooK^0?ofkP0S0?ofkP030=@m6@3om^h0ooK^00T0ooK^00<000000?ofkP3om^h00P3om^h00`3D
?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D
?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h01@3om^h403eI
Z`030000000mFJ/0SR@?00<0SR@?00<0?EV[08hT3`2>90l00P2>90l010000000SR@?08hT3`0mFJ/7
08hT3`030000002>90l0SR@?00T0SR@?00<0000008hT3`2>90l0202>90l00`000000SR@?08hT3`09
08hT3`030000002>90l0SR@?00P0SR@?00<0000008hT3`2>90l02@2>90l00`000000SR@?08hT3`09
08hT3`030000002>90l0SR@?00P0SR@?00<0000008hT3`2>90l02@2>90l00`000000SR@?08hT3`08
08hT3`030000002>90l0SR@?00T0SR@?00<0000008hT3`2>90l01@2>90l0100mFJ/0SR@?08hT3`00
000408hT3`0303eIZ`2>90l0SR@?0080SR@?00<0?EV[0000000mFJ/00`0mFJ/70?ofkP030=@m6@3o
m^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3o
m^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP020?ofkP030000003o
m^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h08`3om^h00`000000ooK^0?ofkP0`0?ofkP40oooo000b
0?ofkP030000003om^h0ooK^02<0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`000000ooK^0?ofkP03
0?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP04
0?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP05
0?ofkP80?EV[00@0e3dI03eIZ`000000?EV[100000000`0mFJ/00000000000060000000303eIZ`00
0000000007l0000000<0?EV[0000000000001P0000000`0mFJ/00000000000020000000403eIZ`00
0000?EV[0=@m6@80?EV[1`3om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00X0ooK^
00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^0080ooK^
00<0e3dI0?ofkP3om^h00`3om^h00`000000ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^02<0ooK^
00<000000?ofkP3om^h0<03om^h10?ooo`00<P3om^h00`000000ooK^0?ofkP0R0?ofkP030=@m6@3o
m^h0ooK^00X0ooK^00<000000?ofkP3om^h00`3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI0100ooK^
00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00L0ooK^
00<0e3dI0?ofkP3om^h01@3om^h203eIZ`050=@m6@000000?EV[0:P/4P0mFJ/00`2X;1800`0mFJ/0
Z2`B0:P/4P020:P/4P030000002X;180Z2`B0080Z2`B00<0?EV[0:P/4P2X;1800`2X;1800`000000
Z2`B0:P/4P090:P/4P030000002X;180Z2`B00P0Z2`B00<000000:P/4P2X;1802@2X;1800`000000
Z2`B0:P/4P080:P/4P030000002X;180Z2`B00T0Z2`B00<000000:P/4P2X;1802@2X;1800`000000
Z2`B0:P/4P080:P/4P030000002X;180Z2`B00T0Z2`B00<000000:P/4P2X;180202X;1800`000000
Z2`B0:P/4P090:P/4P030000002X;180Z2`B00<0Z2`B00<0?EV[0:P/4P2X;1800P2X;1800`000000
Z2`B0:P/4P020:P/4P0903eIZ`2X;180Z2`B0:P/4P0mFJ/0Z2`B03eIZ`000000e3dI0080?EV[1`3o
m^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h0103o
m^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h00`3o
m^h00`000000ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^02<0ooK^00<000000?ofkP3om^h0<03o
m^h10?ooo`00<@3om^h00`000000ooK^0?ofkP0S0?ofkP030=@m6@3om^h0ooK^00X0ooK^00<00000
0?ofkP3om^h00`3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI0100ooK^00<0e3dI0?ofkP3om^h00`3o
m^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h01@3o
m^h203eIZ`030=@m6@000000?EV[0080Z2`B00@0?EV[0:P/4P2X;180?EV[102X;1800`000000Z2`B
0:P/4P030:P/4P0303eIZ`2X;180Z2`B0080Z2`B00<000000:P/4P2X;1802@2X;1800`000000Z2`B
0:P/4P080:P/4P030000002X;180Z2`B00T0Z2`B00<000000:P/4P2X;180202X;1800`000000Z2`B
0:P/4P090:P/4P030000002X;180Z2`B00T0Z2`B00<000000:P/4P2X;180202X;1800`000000Z2`B
0:P/4P090:P/4P030000002X;180Z2`B00P0Z2`B00<000000:P/4P2X;1802@2X;1800`000000Z2`B
0:P/4P020:P/4P0303eIZ`2X;180Z2`B00<0Z2`B00<000000:P/4P2X;1800P2X;180100mFJ/0Z2`B
0:P/4P0mFJ/20:P/4P0303eIZ`000000ooK^0080?EV[1`3om^h00`3D?AT0ooK^0?ofkP070?ofkP03
0=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP05
0=@m6@3om^h0ooK^0?ofkP3D?AT01@3om^h00`000000ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^
02<0ooK^00<000000?ofkP3om^h0;`3om^h10?ooo`00<@3om^h00`000000ooK^0?ofkP0S0?ofkP03
0=@m6@3om^h0ooK^00/0ooK^00<000000?ofkP3om^h00P3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI
0100ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^
00L0ooK^00<0e3dI0?ofkP3om^h01@3om^h203eIZ`030000002X;180?EV[0080Z2`B00@0?EV[0:P/
4P2X;180?EV[0`2X;1800`000000Z2`B0:P/4P040:P/4P<0?EV[0P2X;1800`000000Z2`B0:P/4P09
0:P/4P030000002X;180Z2`B00P0Z2`B00<000000:P/4P2X;1802@2X;1800`000000Z2`B0:P/4P08
0:P/4P030000002X;180Z2`B00T0Z2`B00<000000:P/4P2X;1802@2X;1800`000000Z2`B0:P/4P08
0:P/4P030000002X;180Z2`B00T0Z2`B00<000000:P/4P2X;180202X;1800`000000Z2`B0:P/4P09
0:P/4P030000002X;180Z2`B00<0?EV[1P2X;1801@000000Z2`B0:P/4P2X;180?EV[0080Z2`B00H0
?EV[0:P/4P2X;180?EV[0:P/4P00000203eIZ`L0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0
ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h03P3om^h01@3D?AT0
ooK^0?ofkP3om^h0e3dI00@0ooK^00<000000?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP0S0?of
kP030000003om^h0ooK^02l0ooK^0@3oool00340ooK^00<000000?ofkP3om^h08`3om^h00`3D?AT0
ooK^0?ofkP0;0?ofkP030000003om^h0ooK^0080ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0@0?of
kP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP060?of
kP030=@m6@3om^h0ooK^00H0ooK^0`0mFJ/00`2X;180?EV[0:P/4P020:P/4P0303eIZ`2X;180?EV[
00<0Z2`B00<000000:P/4P2X;180102X;1800`0mFJ/0Z2`B0:P/4P0203eIZ`030000002X;180Z2`B
00T0Z2`B00<000000:P/4P2X;180202X;1800`000000Z2`B0:P/4P090:P/4P030000002X;180Z2`B
00P0Z2`B00<000000:P/4P2X;1802@2X;1800`000000Z2`B0:P/4P090:P/4P030000002X;180Z2`B
00P0Z2`B00<000000:P/4P2X;1802@2X;1800`000000Z2`B0:P/4P080:P/4P030000002X;180Z2`B
00T0Z2`B00<0000003eIZ`0mFJ/00P2X;1800`0mFJ/0Z2`B0:P/4P040:P/4P070000002X;180Z2`B
0:P/4P0mFJ/0Z2`B03eIZ`030:P/4P0403eIZ`2X;180?EV[03eIZ`P0ooK^00<0e3dI0?ofkP3om^h0
1`3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h0
3P3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00@0ooK^00<000000?ofkP3om^h02`3om^h00`3D?AT0
ooK^0?ofkP0S0?ofkP030000003om^h0ooK^02l0ooK^0@3oool00340ooK^00<000000?ofkP3om^h0
8`3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030000003om^h0ooK^00<0ooK^00@0e3dI0?ofkP3om^h0
e3dI4@3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3o
m^h01@3om^h00`3D?AT0ooK^0?ofkP070?ofkP80?EV[00<0Z2`B03eIZ`2X;1800`2X;1800`0mFJ/0
Z2`B03eIZ`020:P/4P030000002X;180Z2`B00@0Z2`B00D0?EV[0:P/4P2X;180Z2`B0000000203eI
Z`T0Z2`B00<000000:P/4P2X;1802@2X;1800`000000Z2`B0:P/4P080:P/4P030000002X;180Z2`B
00T0Z2`B00<000000:P/4P2X;1802@2X;1800`000000Z2`B0:P/4P090:P/4P030000002X;180Z2`B
00T0Z2`B00<000000:P/4P2X;180202X;1800`000000Z2`B0:P/4P090:P/4P030000002X;180Z2`B
00L0Z2`B0P0mFJ/01@000000Z2`B0:P/4P2X;180?EV[00H0Z2`B00H000000:P/4P2X;180?EV[0:P/
4P0mFJ/40:P/4P0403eIZ`2X;180?EV[03eIZ`T0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0
ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h03`3om^h0103D?AT0
ooK^0?ofkP3D?AT50?ofkP030000003om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h08`3om^h00`00
0000ooK^0?ofkP0_0?ofkP40oooo000a0?ofkP030000003om^h0ooK^02<0ooK^00<0e3dI0?ofkP3o
m^h02`3om^h00`000000ooK^0?ofkP030?ofkP040=@m6@3om^h0ooK^0=@m6A40ooK^00<0e3dI0?of
kP3om^h00P3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?of
kP3om^h01`3om^h203eIZ`030:P/4P0mFJ/0Z2`B00<0Z2`B00<0?EV[0:P/4P0mFJ/00P2X;1800`00
0000Z2`B0:P/4P040:P/4P0503eIZ`2X;180Z2`B0:P/4P0000000P2X;1800`0mFJ/0Z2`B0:P/4P06
0:P/4P030000002X;180Z2`B00T0Z2`B00<000000:P/4P2X;180202X;1800`000000Z2`B0:P/4P09
0:P/4P030000002X;180Z2`B00T0Z2`B00<000000:P/4P2X;1802@2X;1800`000000Z2`B0:P/4P09
0:P/4P030000002X;180Z2`B00P0Z2`B00<000000:P/4P2X;1802@2X;1800`000000Z2`B0:P/4P06
0:P/4P0403eIZ`2X;180Z2`B000000<0Z2`B00<0?EV[0:P/4P2X;180102X;1801P000000Z2`B0:P/
4P0mFJ/0Z2`B03eIZ`@0Z2`B00@0?EV[0:P/4P0mFJ/0?EV[2@3om^h00`3D?AT0ooK^0?ofkP050?of
kP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP0?0?of
kP040=@m6@3om^h0ooK^0=@m6@D0ooK^00<000000?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP0S
0?ofkP030000003om^h0ooK^02l0ooK^0@3oool00300ooK^00<000000?ofkP3om^h08`3om^h00`3D
?AT0ooK^0?ofkP0<0?ofkP030000003om^h0ooK^00<0ooK^>`3D?AT403eIZ`D0Z2`B0P0mFJ/00`2X
;18000000:P/4P070:P/4P0403eIZ`2X;180Z2`B000000<0Z2`B0P0mFJ/60:P/4P030000002X;180
Z2`B00T0Z2`B00<000000:P/4P2X;180202X;1800`000000Z2`B0:P/4P090:P/4P030000002X;180
Z2`B00T0Z2`B00<000000:P/4P2X;1802@2X;1800`000000Z2`B0:P/4P090:P/4P030000002X;180
Z2`B00P0Z2`B00<000000:P/4P2X;1802@2X;1800`000000Z2`B0:P/4P040:P/4P80?EV[0`2X;180
10000000Z2`B0:P/4P0mFJ/80:P/4P040000002X;180?EV[03eIZ`D0Z2`B100mFJ/k0=@m6@D0ooK^
00<000000?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP0T0?ofkP030000003om^h0ooK^02h0ooK^
0@3oool00300ooK^00<000000?ofkP3om^h08`3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030000003o
m^h0ooK^0080ooK^00<0e3dI0?ofkP3D?AT04P3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00l0ooK^
00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP070?ofkP@0?EV[1@2X;18203eIZ`030:P/
4P000000Z2`B00L0Z2`B00@0?EV[0:P/4P2X;18000001@2X;18203eIZ`@0Z2`B00<000000:P/4P2X
;1802@2X;1800`000000Z2`B0:P/4P080:P/4P030000002X;180Z2`B00T0Z2`B00<000000:P/4P2X
;1802@2X;1800`000000Z2`B0:P/4P090:P/4P030000002X;180Z2`B00T0Z2`B00<000000:P/4P2X
;180202X;1800`000000Z2`B0:P/4P090:P/4P030000002X;180Z2`B0080Z2`B0P0mFJ/50:P/4P04
0000002X;180Z2`B03eIZ`P0Z2`B00@000000:P/4P0mFJ/0?EV[1@2X;18403eIZ`T0ooK^00<0e3dI
0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT04P3o
m^h00`3D?AT0ooK^0=@m6@040?ofkP030000003om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h08`3o
m^h00`000000ooK^0?ofkP0^0?ofkP40oooo000`0?ofkP030000003om^h0ooK^02<0ooK^00<0e3dI
0?ofkP3om^h03@3om^h00`000000ooK^0?ofkP020?ofkP030=@m6@3om^h0e3dI0180ooK^00D0e3dI
0?ofkP3om^h0ooK^0=@m6@0?0?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h01`3o
m^h303eIZ`030000000mFJ/0000000@0000000<0?EV[000000000000200000000`0mFJ/000000000
000800000080?EV[H`00000203eIZ`X0000000<0?EV[000000000000200000000`0mFJ/000000000
00030000000303eIZ`000000?EV[0080?EV[2@3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3o
m^h0ooK^00d0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0B0?ofkP030=@m6@3om^h0e3dI00@0ooK^
00<000000?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0S0?ofkP030000003om^h0ooK^02h0ooK^
0@3oool00300ooK^00<000000?ofkP3om^h08`3om^i@0=@m6@80?EV[00<0^S8E03eIZ`0mFJ/01@2j
<QD203eIZ`030000002j<QD0^S8E00H0^S8E00@0?EV[0;Xb5@2j<QD000002@2j<QD203eIZ`030000
002j<QD0^S8E00T0^S8E00<000000;Xb5@2j<QD0202j<QD00`000000^S8E0;Xb5@090;Xb5@030000
002j<QD0^S8E00T0^S8E00<000000;Xb5@2j<QD02@2j<QD00`000000^S8E0;Xb5@090;Xb5@030000
002j<QD0^S8E00P0^S8E00<000000;Xb5@2j<QD02@2j<QD00`000000?EV[03eIZ`090;Xb5@040000
002j<QD0^S8E03eIZ`P0^S8E00<0000003eIZ`0mFJ/01@2j<QD203eIZ`030;Xb5@0mFJ/0?EV[0500
e3dI9@3om^h00`000000ooK^0?ofkP0^0?ofkP40oooo000`0?ofkP030000003om^h0ooK^02<0ooK^
00<0e3dI0?ofkP3om^h03@3om^h00`000000ooK^0?ofkP030?ofkP80e3dI4P3om^h01@3D?AT0ooK^
0?ofkP3om^h0e3dI00l0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP070?ofkP80
?EV[00<0^S8E03eIZ`0mFJ/01@2j<QD00`0mFJ/0^S8E03eIZ`080;Xb5@0403eIZ`2j<QD0^S8E0000
00/0^S8E0P0mFJ/:0;Xb5@030000002j<QD0^S8E00P0^S8E00<000000;Xb5@2j<QD02@2j<QD00`00
0000^S8E0;Xb5@090;Xb5@030000002j<QD0^S8E00T0^S8E00<000000;Xb5@2j<QD02@2j<QD00`00
0000^S8E0;Xb5@080;Xb5@030000002j<QD0^S8E00P0^S8E0P0mFJ/;0;Xb5@040000002j<QD0^S8E
03eIZ`P0^S8E00<0?EV[0;Xb5@0mFJ/01@2j<QD203eIZ`030;Xb5@0mFJ/0?EV[00T0ooK^00<0e3dI
0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT04P3o
m^h20=@m6@D0ooK^00<000000?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0S0?ofkP030000003o
m^h0ooK^02h0ooK^0@3oool002l0ooK^00<000000?ofkP3om^h0903om^h00`3D?AT0ooK^0?ofkP0>
0?ofkP030000003om^h0ooK^0080ooK^0P3D?ATB0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT03`3o
m^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00L0ooK^0P0mFJ/20;Xb5@0303eIZ`2j
<QD0^S8E00<0^S8E00<0?EV[0;Xb5@0000000P0mFJ/60;Xb5@0403eIZ`2j<QD0^S8E000000/0^S8E
00<0?EV[0;Xb5@0mFJ/00P0mFJ/70;Xb5@030000002j<QD0^S8E00P0^S8E00<000000;Xb5@2j<QD0
2@2j<QD00`000000^S8E0;Xb5@090;Xb5@030000002j<QD0^S8E00T0^S8E00<000000;Xb5@2j<QD0
2@2j<QD00`000000^S8E0;Xb5@080;Xb5@030000002j<QD0^S8E00D0^S8E0`0mFJ/00`2j<QD0?EV[
0;Xb5@0:0;Xb5@040000002j<QD0^S8E03eIZ`H0^S8E0P0mFJ/00`000000^S8E03eIZ`050;Xb5@05
03eIZ`2j<QD0^S8E03eIZ`0000002@3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^
00d0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0B0?ofkP80e3dI103om^h00`000000ooK^0?ofkP0>
0?ofkP030=@m6@3om^h0ooK^02@0ooK^00<000000?ofkP3om^h0;@3om^h10?ooo`00;`3om^h00`00
0000ooK^0?ofkP0T0?ofkP030=@m6@3om^h0ooK^00h0ooK^00<000000?ofkP3om^h00P3om^h20=@m
6A80ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0?0?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI
0?ofkP3om^h01`3om^h01@000000?EV[0;Xb5@2j<QD0?EV[00D0^S8E00<0?EV[0;Xb5@0000000P2j
<QD00`0mFJ/0^S8E0;Xb5@030;Xb5@0403eIZ`2j<QD0^S8E000000/0^S8E00<0?EV[0;Xb5@2j<QD0
0P2j<QD303eIZ`@0^S8E00<000000;Xb5@2j<QD0202j<QD00`000000^S8E0;Xb5@090;Xb5@030000
002j<QD0^S8E00T0^S8E00<000000;Xb5@2j<QD02@2j<QD00`000000^S8E0;Xb5@090;Xb5@030000
002j<QD0^S8E00P0^S8E00<000000;Xb5@2j<QD00P2j<QD303eIZ`@0^S8E00<0?EV[0;Xb5@2j<QD0
2@2j<QD010000000^S8E0;Xb5@0mFJ/50;Xb5@0503eIZ`2j<QD0^S8E0000000mFJ/01P2j<QD01@0m
FJ/0^S8E0;Xb5@0mFJ/0000000T0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP0>
0?ofkP040=@m6@3om^h0ooK^0=@m6A<0ooK^0P3D?AT40?ofkP030000003om^h0ooK^00h0ooK^00<0
e3dI0?ofkP3om^h0903om^h00`000000ooK^0?ofkP0]0?ofkP40oooo000_0?ofkP030000003om^h0
ooK^02<0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`000000ooK^0?ofkP020?ofkP030=@m6@3om^h0
ooK^0180ooK^00@0e3dI0?ofkP3om^h0e3dI403om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3o
m^h0ooK^00L0ooK^00@0000003eIZ`2j<QD0^S8E0P0mFJ/50;Xb5@0303eIZ`000000^S8E0080^S8E
00<0?EV[0;Xb5@2j<QD00P2j<QD0100mFJ/0^S8E0;Xb5@00000;0;Xb5@0303eIZ`2j<QD0^S8E00D0
^S8E0`0mFJ/00`2j<QD000000;Xb5@090;Xb5@030000002j<QD0^S8E00T0^S8E00<000000;Xb5@2j
<QD02@2j<QD00`000000^S8E0;Xb5@090;Xb5@030000002j<QD0^S8E00T0^S8E00<000000;Xb5@2j
<QD0202j<QD00`000000^S8E03eIZ`0203eIZ`L0^S8E00<0?EV[0;Xb5@2j<QD02@2j<QD010000000
^S8E0;Xb5@0mFJ/40;Xb5@0603eIZ`2j<QD0^S8E0;Xb5@000000?EV[1@2j<QD203eIZ`80^S8E00<0
?EV[0000003om^h0203om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00h0ooK^00@0
e3dI0?ofkP3om^h0e3dI503om^h00`3D?AT0ooK^0?ofkP020?ofkP030000003om^h0ooK^00l0ooK^
00<0e3dI0?ofkP3om^h08`3om^h00`000000ooK^0?ofkP0]0?ofkP40oooo000_0?ofkP030000003o
m^h0ooK^02<0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`000000ooK^0?ofkP020?ofkP030=@m6@3o
m^h0ooK^0180ooK^00@0e3dI0?ofkP3om^h0e3dI403om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m
6@3om^h0ooK^00P0ooK^00<0?EV[0;Xb5@2j<QD00P0mFJ/50;Xb5@0303eIZ`000000^S8E00<0^S8E
00<0?EV[0;Xb5@2j<QD00P2j<QD00`0mFJ/0^S8E0000000;0;Xb5@0303eIZ`2j<QD0^S8E00P0^S8E
0`0mFJ/90;Xb5@030000002j<QD0^S8E00T0^S8E00<000000;Xb5@2j<QD02@2j<QD00`000000^S8E
0;Xb5@090;Xb5@030000002j<QD0^S8E00T0^S8E00<000000;Xb5@2j<QD01`2j<QD303eIZ`X0^S8E
00<0?EV[0;Xb5@2j<QD02@2j<QD00`000000^S8E03eIZ`040;Xb5@0303eIZ`2j<QD0^S8E0080^S8E
00<0000003eIZ`2j<QD0102j<QD203eIZ`80^S8E00<0?EV[0?ofkP3om^h0203om^h00`3D?AT0ooK^
0?ofkP040?ofkP030=@m6@3om^h0ooK^00h0ooK^00@0e3dI0?ofkP3om^h0e3dI503om^h00`3D?AT0
ooK^0?ofkP020?ofkP030000003om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h08`3om^h00`000000
ooK^0?ofkP0]0?ofkP40oooo000_0?ofkP030000003om^h0ooK^02<0ooK^00<0e3dI0?ofkP3om^h0
403om^h01@000000ooK^0?ofkP3om^h0e3dI01@0ooK^00@0e3dI0?ofkP3om^h0e3dI403om^h00`3D
?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00P0ooK^00H0?EV[0;Xb5@2j<QD0?EV[0;Xb5@0m
FJ/40;Xb5@0303eIZ`000000^S8E00@0^S8E00L0?EV[0;Xb5@2j<QD0^S8E03eIZ`2j<QD0000000/0
^S8E00<0?EV[0;Xb5@2j<QD02@2j<QD00`000000^S8E03eIZ`0203eIZ`H0^S8E00<000000;Xb5@2j
<QD02@2j<QD00`000000^S8E0;Xb5@090;Xb5@030000002j<QD0^S8E00T0^S8E00<000000;Xb5@2j
<QD02@2j<QD00`000000^S8E0;Xb5@040;Xb5@<0?EV[00<0^S8E0000002j<QD02P2j<QD00`0mFJ/0
^S8E0;Xb5@090;Xb5@030000002j<QD0?EV[00<0^S8E00<0?EV[0;Xb5@2j<QD00`2j<QD00`000000
?EV[0;Xb5@030;Xb5@0303eIZ`2j<QD0?EV[0080^S8E00<0?EV[0?ofkP3om^h0203om^h00`3D?AT0
ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00h0ooK^00@0e3dI0?ofkP3om^h0e3dI4`3om^h20=@m
6@<0ooK^00<000000?ofkP3om^h0403om^h00`3D?AT0ooK^0?ofkP0S0?ofkP030000003om^h0ooK^
02d0ooK^0@3oool002h0ooK^00<000000?ofkP3om^h0903om^h00`3D?AT0ooK^0?ofkP0@0?ofkP04
0000003om^h0ooK^0?ofkP80e3dI4`3om^h00`3D?AT0ooK^0=@m6@0A0?ofkP030=@m6@3om^h0ooK^
00<0ooK^00<0e3dI0?ofkP3om^h02@3om^h01`0mFJ/0^S8E0;Xb5@2j<QD0?EV[0;Xb5@0mFJ/00`2j
<QD00`0mFJ/000000;Xb5@050;Xb5@80?EV[00@0^S8E03eIZ`2j<QD000002`2j<QD00`0mFJ/0^S8E
0;Xb5@090;Xb5@030000002j<QD0^S8E0080^S8E1@0mFJ/00`2j<QD000000;Xb5@0:0;Xb5@030000
002j<QD0^S8E00T0^S8E00<000000;Xb5@2j<QD02@2j<QD00`000000^S8E0;Xb5@090;Xb5@030000
002j<QD0?EV[00@0?EV[102j<QD00`000000^S8E0;Xb5@090;Xb5@0303eIZ`2j<QD0^S8E00T0^S8E
00@000000;Xb5@0mFJ/0^S8E0P0mFJ/60;Xb5@030000000mFJ/0^S8E0080^S8E00<0?EV[0;Xb5@0m
FJ/00`2j<QD00`0mFJ/0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3o
m^h03P3om^h0103D?AT0ooK^0?ofkP3D?ATC0?ofkP80e3dI0`3om^h00`000000ooK^0?ofkP0@0?of
kP030=@m6@3om^h0ooK^02@0ooK^00<000000?ofkP3om^h0;03om^h10?ooo`00;P3om^h00`000000
ooK^0?ofkP0T0?ofkP030=@m6@3om^h0ooK^0100ooK^00@000000?ofkP3om^h0ooK^0P3D?ATC0?of
kP030=@m6@3om^h0e3dI0140ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP090?of
kP80?EV[0P2j<QD00`0mFJ/0^S8E03eIZ`030;Xb5@0303eIZ`000000^S8E00L0^S8E0P0mFJ/00`2j
<QD000000;Xb5@0:0;Xb5@0303eIZ`2j<QD0^S8E00T0^S8E00<000000;Xb5@2j<QD00`2j<QD0100m
FJ/0^S8E0;Xb5@2j<QD603eIZ`L0^S8E00<000000;Xb5@2j<QD02@2j<QD00`000000^S8E0;Xb5@09
0;Xb5@030000002j<QD0^S8E00D0^S8E1P0mFJ/30;Xb5@0303eIZ`2j<QD0^S8E00<0^S8E00<00000
0;Xb5@2j<QD02@2j<QD00`0mFJ/0^S8E0;Xb5@090;Xb5@040000002j<QD0?EV[03eIZ`P0^S8E00<0
000003eIZ`2j<QD00P2j<QD00`0mFJ/0^S8E03eIZ`020;Xb5@80?EV[2`3om^h00`3D?AT0ooK^0?of
kP030?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3D?AT04`3om^h20=@m6@<0ooK^00<0
00000?ofkP3om^h0403om^h00`3D?AT0ooK^0?ofkP0T0?ofkP030000003om^h0ooK^02`0ooK^0@3o
ool002h0ooK^o`00002H000002h0ooK^0@3oool002h0ooK^00<000000?ofkP3om^h0903om^h00`3D
?AT0ooK^0?ofkP0@0?ofkP040000003om^h0ooK^0?ofkP80e3dI4`3om^h00`3D?AT0ooK^0=@m6@0A
0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h02@3om^h01@000000?EV[03eIZ`00
0000?EV[00<0000000<0?EV[0000000mFJ/02P00000303eIZ``0000000<0?EV[0000000000003P00
00000`0mFJ/000000000000=000001/0?EV[3`0000000`0mFJ/000000000000>0000000303eIZ`00
0000000000X000000`0mFJ/:0000000303eIZ`000000?EV[00<0000000D0?EV[0000000mFJ/0?EV[
0000000;0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^
0=@m6@0C0?ofkP80e3dI0`3om^h00`000000ooK^0?ofkP0@0?ofkP030=@m6@3om^h0ooK^02@0ooK^
00<000000?ofkP3om^h0;03om^h10?ooo`00;`3om^h00`000000ooK^0?ofkP0R0?ofkP030=@m6@3o
m^h0ooK^0180ooK^00D000000?ofkP3D?AT0ooK^0=@m6@0C0?ofkP030=@m6@3om^h0e3dI0140ooK^
00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP090?ofkP050000000mFJ/0?EV[0<Pg5`0m
FJ/00`38=aL0100mFJ/0b3LG03eIZ`0000090<Pg5`0303eIZ`38=aL000000080?EV[2@38=aL00`00
0000?EV[0<Pg5`090<Pg5`0300000038=aL0b3LG00<0b3LG00<0?EV[0<Pg5`38=aL00P38=aL00`00
0000b3LG0<Pg5`090<Pg5`0300000038=aL0?EV[00T0b3LG00<000000<Pg5`38=aL01`38=aL00`0m
FJ/0b3LG0000000;0<Pg5`0300000038=aL0b3LG0080b3LG00<0?EV[0<Pg5`38=aL00`38=aL00`00
0000b3LG0<Pg5`080<Pg5`0303eIZ`000000b3LG00P0b3LG0P0mFJ/00`000000b3LG03eIZ`090<Pg
5`0403eIZ`38=aL0b3LG03eIZ`<0b3LG00D0?EV[0<Pg5`0mFJ/0?EV[0000000;0?ofkP030=@m6@3o
m^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0=@m6@0C0?ofkP050=@m6@3o
m^h0e3dI0?ofkP000000503om^h00`3D?AT0ooK^0?ofkP0R0?ofkP030000003om^h0ooK^02d0ooK^
0@3oool002l0ooK^00<000000?ofkP3om^h08P3om^h00`3D?AT0ooK^0?ofkP0B0?ofkP050000003o
m^h0e3dI0?ofkP3D?AT04`3om^h00`3D?AT0ooK^0=@m6@0A0?ofkP030=@m6@3om^h0ooK^00<0ooK^
00<0e3dI0?ofkP3om^h02@3om^h01@000000?EV[03eIZ`38=aL0?EV[00@0b3LG00<0?EV[0<Pg5`0m
FJ/02@38=aL00`0mFJ/0b3LG000000020<Pg5`0303eIZ`38=aL0b3LG00H0b3LG00<0000003eIZ`38
=aL02@38=aL00`000000b3LG0<Pg5`030<Pg5`0303eIZ`38=aL0b3LG0080b3LG00<000000<Pg5`38
=aL02@38=aL00`000000b3LG03eIZ`090<Pg5`0300000038=aL0b3LG00L0b3LG00<0?EV[0<Pg5`00
00002`38=aL00`000000b3LG0<Pg5`020<Pg5`0303eIZ`38=aL0b3LG00<0b3LG00<000000<Pg5`38
=aL02038=aL00`0mFJ/000000<Pg5`070<Pg5`0603eIZ`38=aL0b3LG00000038=aL0?EV[2038=aL0
10000000?EV[0<Pg5`0mFJ/40<Pg5`80?EV[00<0b3LG03eIZ`0000002`3om^h00`3D?AT0ooK^0?of
kP030?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3D?AT04`3om^h01@3D?AT0ooK^0=@m
6@3om^h0000001@0ooK^00<0e3dI0?ofkP3om^h08P3om^h00`000000ooK^0?ofkP0]0?ofkP40oooo
000_0?ofkP030000003om^h0ooK^0280ooK^00<0e3dI0?ofkP3om^h04P3om^h01@000000ooK^0=@m
6@3om^h0e3dI01<0ooK^00<0e3dI0?ofkP3D?AT04@3om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m
6@3om^h0ooK^00T0ooK^00<0000003eIZ`38=aL00P0mFJ/50<Pg5`80?EV[00<000000<Pg5`38=aL0
1P38=aL00`0mFJ/0b3LG000000030<Pg5`80?EV[1P38=aL00`000000?EV[0<Pg5`090<Pg5`030000
0038=aL0b3LG00<0b3LG00<0?EV[0<Pg5`38=aL00P38=aL00`000000b3LG0<Pg5`090<Pg5`030000
0038=aL0?EV[00T0b3LG00<000000<Pg5`38=aL01`38=aL00`0mFJ/0b3LG0000000;0<Pg5`030000
0038=aL0b3LG0080b3LG00<0?EV[0<Pg5`38=aL00`38=aL00`000000b3LG0<Pg5`080<Pg5`0303eI
Z`000000b3LG00D0b3LG0P0mFJ/20<Pg5`0400000038=aL0b3LG03eIZ`P0b3LG00<0000003eIZ`0m
FJ/01@38=aL203eIZ`030<Pg5`0mFJ/0000000/0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0
ooK^0?ofkP0?0?ofkP030=@m6@3om^h0e3dI01<0ooK^00D0e3dI0?ofkP3D?AT0ooK^0000000D0?of
kP030=@m6@3om^h0ooK^0280ooK^00<000000?ofkP3om^h0;@3om^h10?ooo`00<03om^h00`000000
ooK^0?ofkP0Q0?ofkUD0e3dI00<0b3LG03eIZ`0mFJ/01@38=aL203eIZ`0300000038=aL0b3LG00L0
b3LG00<0?EV[0<Pg5`0000001038=aL203eIZ`@0b3LG00<0000003eIZ`38=aL02@38=aL00`000000
b3LG0<Pg5`030<Pg5`0303eIZ`38=aL0b3LG0080b3LG00<000000<Pg5`38=aL02@38=aL00`000000
b3LG03eIZ`090<Pg5`0300000038=aL0b3LG00L0b3LG00<0?EV[0<Pg5`0000002`38=aL00`000000
b3LG0<Pg5`020<Pg5`0303eIZ`38=aL0b3LG00<0b3LG00<000000<Pg5`38=aL02038=aL00`0mFJ/0
00000<Pg5`030<Pg5`80?EV[1038=aL00`000000b3LG03eIZ`090<Pg5`030000000mFJ/0?EV[00D0
b3LG0P0mFJ/00`38=aL0e3dI0=@m6@1C0=@m6B<0ooK^00<000000?ofkP3om^h0;P3om^h10?ooo`00
<03om^h00`000000ooK^0?ofkP0Q0?ofkP030=@m6@3om^h0ooK^01<0ooK^00@000000=@m6@3om^h0
e3dI4`3om^h00`3D?AT0ooK^0=@m6@0A0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3o
m^h02P3om^h00`000000b3LG0<Pg5`0203eIZ`D0b3LG00<0?EV[00000038=aL02038=aL00`0mFJ/0
b3LG000000060<Pg5`0603eIZ`38=aL0b3LG0<Pg5`000000?EV[2P38=aL00`000000b3LG0<Pg5`03
0<Pg5`0303eIZ`38=aL0b3LG0080b3LG00<000000<Pg5`38=aL02@38=aL00`000000b3LG03eIZ`09
0<Pg5`0300000038=aL0b3LG00L0b3LG00<0?EV[0<Pg5`0000002`38=aL00`000000b3LG0<Pg5`02
0<Pg5`0303eIZ`38=aL0b3LG00<0b3LG00<000000<Pg5`38=aL02038=aL00`0mFJ/000000<Pg5`02
0<Pg5`0303eIZ`38=aL0b3LG00@0b3LG00<000000<Pg5`0mFJ/02@38=aL00`000000?EV[0<Pg5`04
0<Pg5`80?EV[0P38=aL00`000000ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI
0?ofkP3om^h03`3om^h00`3D?AT0ooK^0=@m6@0C0?ofkP040=@m6@3om^h0e3dI000001D0ooK^00<0
e3dI0?ofkP3om^h08@3om^h00`000000ooK^0?ofkP0^0?ofkP40oooo000`0?ofkP030000003om^h0
ooK^0240ooK^00<0e3dI0?ofkP3om^h04`3om^h01@000000e3dI0?ofkP3om^h0e3dI01<0ooK^0P3D
?ATB0?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h02P3om^h00`000000b3LG0<Pg
5`0203eIZ`D0b3LG0P0mFJ/90<Pg5`0303eIZ`38=aL0000000L0b3LG0P0mFJ/00`38=aL0000003eI
Z`0:0<Pg5`0300000038=aL0b3LG00<0b3LG00<0?EV[0<Pg5`38=aL00P38=aL00`000000b3LG0<Pg
5`090<Pg5`0300000038=aL0?EV[00T0b3LG00<000000<Pg5`38=aL01`38=aL00`0mFJ/000000<Pg
5`0:0<Pg5`0300000038=aL0b3LG00<0b3LG00<0?EV[0<Pg5`38=aL00P38=aL00`000000b3LG0<Pg
5`090<Pg5`0303eIZ`38=aL0b3LG0080?EV[1`38=aL00`000000b3LG03eIZ`080<Pg5`030000000m
FJ/0?EV[00D0b3LG0P0mFJ/20<Pg5`030000003om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h00P3o
m^h00`3D?AT0ooK^0?ofkP0@0?ofkP80e3dI4`3om^h01@3D?AT0ooK^0?ofkP3D?AT0000001D0ooK^
00<0e3dI0?ofkP3om^h08@3om^h00`000000ooK^0?ofkP0^0?ofkP40oooo000a0?ofkP030000003o
m^h0ooK^0200ooK^00<0e3dI0?ofkP3om^h04`3om^h01@000000e3dI0?ofkP3om^h0e3dI01<0ooK^
0P3D?ATB0?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h02P3om^h01@000000b3LG
0<Pg5`38=aL0?EV[00D0b3LG00<0?EV[0<Pg5`0mFJ/02038=aL00`0mFJ/0b3LG000000090<Pg5`<0
?EV[2`38=aL00`000000b3LG0<Pg5`020<Pg5`0303eIZ`38=aL0b3LG00<0b3LG00<000000<Pg5`38
=aL02@38=aL00`000000?EV[0<Pg5`080<Pg5`0300000038=aL0b3LG00L0b3LG00<0?EV[00000038
=aL02P38=aL00`000000b3LG0<Pg5`030<Pg5`0303eIZ`38=aL0b3LG0080b3LG00<000000<Pg5`38
=aL02@38=aL303eIZ`T0b3LG00<000000<Pg5`0mFJ/02038=aL00`0mFJ/0b3LG03eIZ`050<Pg5`05
03eIZ`38=aL0b3LG0<Pg5`000000303om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^
0100ooK^0P3D?ATC0?ofkP050=@m6@3om^h0ooK^0=@m6@0000005@3om^h00`3D?AT0ooK^0?ofkP0P
0?ofkP030000003om^h0ooK^02l0ooK^0@3oool00340ooK^00<000000?ofkP3om^h0803om^h00`3D
?AT0ooK^0?ofkP0C0?ofkP050000003D?AT0ooK^0?ofkP3D?AT04`3om^h20=@m6A80ooK^00<0e3dI
0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP0500000038=aL0b3LG0<Pg5`0mFJ/01@38
=aL0100mFJ/0b3LG0000000mFJ/70<Pg5`0303eIZ`38=aL0000000/0b3LG0P0mFJ/:0<Pg5`030000
0038=aL0b3LG0080b3LG00<0?EV[0<Pg5`38=aL00`38=aL00`000000b3LG0<Pg5`090<Pg5`030000
000mFJ/0b3LG00P0b3LG00<000000<Pg5`38=aL01`38=aL00`0mFJ/000000<Pg5`0:0<Pg5`030000
0038=aL0b3LG00<0b3LG00<0?EV[0<Pg5`38=aL00P38=aL00`000000b3LG0<Pg5`080<Pg5`80?EV[
2`38=aL00`000000b3LG03eIZ`070<Pg5`0403eIZ`000000b3LG03eIZ`D0b3LG00D0?EV[0<Pg5`38
=aL0b3LG0000000<0?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h0403om^h20=@m
6A<0ooK^00D0e3dI0?ofkP3om^h0e3dI0000000E0?ofkP030=@m6@3om^h0ooK^0200ooK^00<00000
0?ofkP3om^h0;`3om^h10?ooo`00<@3om^h00`000000ooK^0?ofkP0P0?ofkP030=@m6@3om^h0ooK^
01<0ooK^00D000000=@m6@3om^h0ooK^0=@m6@0C0?ofkP80e3dI4P3om^h00`3D?AT0ooK^0?ofkP02
0?ofkP030=@m6@3om^h0ooK^00X0ooK^00@000000<Pg5`38=aL0b3LG0P0mFJ/40<Pg5`0503eIZ`38
=aL000000<Pg5`0mFJ/01P38=aL00`0mFJ/0b3LG0000000;0<Pg5`0303eIZ`38=aL0?EV[0080?EV[
1`38=aL00`000000b3LG0<Pg5`020<Pg5`0303eIZ`38=aL0b3LG00<0b3LG00<000000<Pg5`38=aL0
2@38=aL00`000000?EV[0<Pg5`080<Pg5`0300000038=aL0b3LG00L0b3LG00<0?EV[00000038=aL0
2P38=aL00`000000b3LG0<Pg5`030<Pg5`0303eIZ`38=aL0b3LG0080b3LG00<000000<Pg5`38=aL0
1@38=aL303eIZ`030<Pg5`0mFJ/0b3LG00T0b3LG00@000000<Pg5`38=aL0?EV[1P38=aL0100mFJ/0
b3LG0000000mFJ/50<Pg5`80?EV[0P38=aL2000000`0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D
?AT0ooK^0?ofkP0@0?ofkP80e3dI4`3om^h01@3D?AT0ooK^0?ofkP3D?AT0000001D0ooK^00<0e3dI
0?ofkP3om^h0803om^h00`000000ooK^0?ofkP0_0?ofkP40oooo000b0?ofkP030000003om^h0ooK^
01l0ooK^00<0e3dI0?ofkP3om^h0503om^h0103D?AT0ooK^0?ofkP3D?ATC0?ofkP80e3dI4P3om^h0
0`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00X0ooK^0P0000020<Pg5`80?EV[1@38=aL0
1@0mFJ/000000<Pg5`38=aL0?EV[00D0b3LG00@0?EV[0<Pg5`38=aL000002P38=aL00`0mFJ/0b3LG
0<Pg5`020<Pg5`<0?EV[1038=aL00`000000b3LG0<Pg5`020<Pg5`0303eIZ`38=aL0b3LG00<0b3LG
00<000000<Pg5`38=aL02@38=aL00`000000?EV[0<Pg5`080<Pg5`0300000038=aL0b3LG00L0b3LG
00<0?EV[00000038=aL02P38=aL00`000000b3LG0<Pg5`030<Pg5`0303eIZ`38=aL0b3LG0080b3LG
00<000000<Pg5`38=aL00P38=aL303eIZ`@0b3LG00<0?EV[0<Pg5`38=aL02038=aL010000000b3LG
0<Pg5`0mFJ/50<Pg5`0503eIZ`38=aL000000<Pg5`0mFJ/01@38=aL203eIZ`80b3LG0P00000<0?of
kP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h0403om^h20=@m6A<0ooK^00@0e3dI0?of
kP3om^h0e3dI5P3om^h00`3D?AT0ooK^0?ofkP0O0?ofkP030000003om^h0ooK^0300ooK^0@3oool0
0380ooK^00<000000?ofkP3om^h07`3om^h00`3D?AT0ooK^0?ofkP0D0?ofkP040=@m6@3om^h0ooK^
0=@m6A<0ooK^0P3D?ATB0?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h02P3om^h2
00000080b3LG00<0?EV[0<Pg5`0mFJ/01038=aL00`0mFJ/0b3LG000000020<Pg5`80?EV[0`38=aL0
100mFJ/0b3LG0<Pg5`00000:0<Pg5`0303eIZ`38=aL0b3LG00D0b3LG0P0mFJ/20<Pg5`0300000038
=aL0b3LG0080b3LG00<0?EV[0<Pg5`38=aL00`38=aL00`000000b3LG0<Pg5`090<Pg5`030000000m
FJ/0b3LG00P0b3LG00<000000<Pg5`38=aL01`38=aL00`0mFJ/000000<Pg5`0:0<Pg5`0300000038
=aL0b3LG00<0b3LG00<0?EV[0<Pg5`38=aL00P38=aL00`000000b3LG0<Pg5`0203eIZ`L0b3LG00<0
?EV[0<Pg5`38=aL02038=aL010000000b3LG0<Pg5`0mFJ/30<Pg5`80?EV[0P38=aL00`000000b3LG
03eIZ`040<Pg5`0303eIZ`38=aL0?EV[0080b3LG00<000000?ofkP3om^h02`3om^h00`3D?AT0ooK^
0?ofkP020?ofkP030=@m6@3om^h0ooK^0100ooK^0P3D?ATC0?ofkP040=@m6@3om^h0ooK^0=@m6AH0
ooK^00<0e3dI0?ofkP3om^h07`3om^h00`000000ooK^0?ofkP0`0?ofkP40oooo000b0?ofkP030000
003om^h0ooK^01h0ooK^00<0e3dI0?ofkP3om^h0503om^h0103D?AT000000?ofkP3om^hk0=@m6@<0
000000<0?EV[0000000mFJ/0100000000`0mFJ/00000000000040000000503eIZ`00000000000000
000mFJ/0300000000`0mFJ/0000000000007000000<0?EV[100000000`0mFJ/000000000000@0000
000303eIZ`00000000000140000000<0?EV[000000000000400000000`0mFJ/00000000000020000
00<0?EV[2@0000000`0mFJ/000000000000:0000000503eIZ`00000000000000000mFJ/01P000000
0`0mFJ/00000000000020000000303eIZ`000000?EV[00<00000>`3D?AT20?ofkP030=@m6@3om^h0
ooK^01@0ooK^00<0e3dI0?ofkP3om^h07`3om^h00`000000ooK^0?ofkP0`0?ofkP40oooo000b0?of
kP030000003om^h0ooK^01h0ooK^00<0e3dI0?ofkP3om^h0503om^h01@3D?AT000000?ofkP3om^h0
e3dI01<0ooK^00<0e3dI0?ofkP3om^h04@3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00h0ooK^00@0
00000=<k6@3C>aT0?EV[0P3C>aT01`0mFJ/0dc/I0=<k6@3C>aT0?EV[0=<k6@0000001@3C>aT01P0m
FJ/0dc/I0=<k6@0mFJ/0dc/I000000X0dc/I00<0?EV[0=<k6@3C>aT02@3C>aT01P000000?EV[03eI
Z`0mFJ/0dc/I03eIZ`D0dc/I00<000000=<k6@3C>aT02@3C>aT00`000000?EV[0=<k6@080=<k6@03
0000003C>aT0dc/I00L0dc/I00<0?EV[0000003C>aT02P3C>aT00`000000dc/I0=<k6@030=<k6@03
03eIZ`3C>aT0?EV[0080?EV[00<000000=<k6@3C>aT02@3C>aT00`0mFJ/0dc/I0=<k6@080=<k6@03
0000003C>aT0?EV[0080dc/I00<0?EV[0=<k6@3C>aT00`3C>aT00`000000dc/I03eIZ`030=<k6@04
03eIZ`3C>aT0dc/I03eIZ`80dc/I00<000000?ofkP3om^h0303om^h01@3D?AT0ooK^0?ofkP3om^h0
e3dI01<0ooK^00<0e3dI0?ofkP3om^h04@3om^h01@3D?AT0ooK^0?ofkP000000e3dI01H0ooK^00<0
e3dI0?ofkP3om^h07P3om^h00`000000ooK^0?ofkP0`0?ofkP40oooo000c0?ofkP030000003om^h0
ooK^01d0ooK^00<0e3dI0?ofkP3om^h0503om^h01@3D?AT0ooK^0000003om^h0e3dI01<0ooK^00<0
e3dI0?ofkP3om^h04@3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00h0ooK^0P0000020=<k6@0403eI
Z`3C>aT0dc/I03eIZ`80dc/I00@0?EV[0=<k6@3C>aT000001@3C>aT01@0mFJ/0dc/I03eIZ`3C>aT0
000000X0dc/I00<0?EV[0=<k6@3C>aT02@3C>aT010000000dc/I0=<k6@3C>aT503eIZ`80dc/I00<0
00000=<k6@3C>aT02@3C>aT00`000000?EV[0=<k6@080=<k6@030000003C>aT0dc/I00L0dc/I00<0
?EV[0000003C>aT02P3C>aT00`000000dc/I0=<k6@0503eIZ`<0dc/I00<000000=<k6@3C>aT02@3C
>aT00`0mFJ/0dc/I0=<k6@080=<k6@050000003C>aT0?EV[0=<k6@0mFJ/01@3C>aT010000000dc/I
0=<k6@0mFJ/20=<k6@0403eIZ`3C>aT0dc/I03eIZ`80dc/I0P00000>0?ofkP050=@m6@3om^h0ooK^
0?ofkP3D?AT04`3om^h00`3D?AT0ooK^0?ofkP0A0?ofkP050=@m6@3om^h000000?ofkP3D?AT05P3o
m^h00`3D?AT0ooK^0?ofkP0M0?ofkP030000003om^h0ooK^0340ooK^0@3oool003<0ooK^00<00000
0?ofkP3om^h07@3om^h00`3D?AT0ooK^0?ofkP0D0?ofkP050=@m6@3om^h000000?ofkP3D?AT04`3o
m^h00`3D?AT0ooK^0?ofkP0A0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT03P3om^h200000080dc/I
00@0?EV[0=<k6@3C>aT0?EV[0P3C>aT0100mFJ/0dc/I0=<k6@0000060=<k6@80?EV[0P3C>aT00`00
0000dc/I0=<k6@070=<k6@0303eIZ`000000dc/I00T0dc/I00<000000=<k6@3C>aT00P3C>aT0100m
FJ/0dc/I0=<k6@3C>aT603eIZ`P0dc/I00<0000003eIZ`3C>aT0203C>aT00`000000dc/I0=<k6@07
0=<k6@0303eIZ`000000dc/I00L0dc/I1P0mFJ/30=<k6@0303eIZ`3C>aT0dc/I0080dc/I00<00000
0=<k6@3C>aT0203C>aT00`000000?EV[0=<k6@080=<k6@030000003C>aT0dc/I0080?EV[1P3C>aT0
10000000dc/I0=<k6@0mFJ/20=<k6@0403eIZ`3C>aT0dc/I03eIZ`80dc/I0P00000>0?ofkP050=@m
6@3om^h0ooK^0?ofkP3D?AT04`3om^h00`3D?AT0ooK^0?ofkP0A0?ofkP050=@m6@3om^h000000?of
kP3D?AT05P3om^h00`3D?AT0ooK^0?ofkP0M0?ofkP030000003om^h0ooK^0340ooK^0@3oool003<0
ooK^00<000000?ofkP3om^h07@3om^h00`3D?AT0ooK^0?ofkP0D0?ofkP050=@m6@3om^h000000?of
kP3D?AT04`3om^h00`3D?AT0ooK^0?ofkP0A0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT03P3om^h3
000000030=<k6@0mFJ/0dc/I0080dc/I00<0?EV[0=<k6@0mFJ/00P3C>aT00`000000dc/I0=<k6@05
0=<k6@0403eIZ`3C>aT0dc/I000000T0dc/I00<0?EV[0000003C>aT02P3C>aT01@000000dc/I0=<k
6@3C>aT0?EV[00H0dc/I00<000000=<k6@3C>aT01P0mFJ/20=<k6@030000000mFJ/0dc/I00P0dc/I
00<000000=<k6@3C>aT01`3C>aT0100mFJ/000000=<k6@3C>aT603eIZ`80dc/I00<000000=<k6@3C
>aT0103C>aT01@0mFJ/0dc/I0=<k6@3C>aT0000000/0dc/I00<0?EV[0=<k6@3C>aT0203C>aT01000
0000dc/I0=<k6@0mFJ/70=<k6@060000003C>aT0dc/I03eIZ`3C>aT0?EV[0`3C>aT00`0mFJ/0dc/I
00000002000000h0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0C0?ofkP030=@m6@3om^h0ooK^0140
ooK^00D0e3dI0?ofkP000000ooK^0=@m6@0F0?ofkP030=@m6@3om^h0ooK^01d0ooK^00<000000?of
kP3om^h0<@3om^h10?ooo`00=03om^h00`000000ooK^0?ofkP0L0?ofkP030=@m6@3om^h0ooK^01@0
ooK^00D0e3dI0?ofkP000000ooK^0=@m6@0C0?ofkP030=@m6@3om^h0ooK^0140ooK^00D0e3dI0?of
kP3om^h0ooK^0=@m6@0>0?ofkP<0000000<0dc/I03eIZ`3C>aT00`3C>aT203eIZ`<0dc/I00<00000
0=<k6@3C>aT0103C>aT303eIZ`030000003C>aT0dc/I00P0dc/I00<0?EV[0=<k6@3C>aT02@3C>aT0
1@000000dc/I0=<k6@3C>aT0?EV[00H0dc/I00<000000=<k6@3C>aT01P3C>aTK03eIZ`P0dc/I00<0
00000=<k6@3C>aT0103C>aT01@0mFJ/0dc/I0=<k6@3C>aT0000000/0dc/I00<0?EV[0=<k6@3C>aT0
203C>aT010000000?EV[03eIZ`0mFJ/60=<k6@060000003C>aT0dc/I03eIZ`3C>aT0?EV[103C>aT0
0`0mFJ/0dc/I00000002000000h0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0C0?ofkP030=@m6@3o
m^h0ooK^0140ooK^00D0e3dI0?ofkP000000ooK^0=@m6@0F0?ofkP030=@m6@3om^h0ooK^01`0ooK^
00<000000?ofkP3om^h0<P3om^h10?ooo`00=03om^h00`000000ooK^0?ofkP0L0?ofkP030=@m6@3o
m^h0ooK^01@0ooK^00D0e3dI0?ofkP3om^h000000=@m6@0C0?ofkP030=@m6@3om^h0ooK^0140ooK^
00D0e3dI0?ofkP3om^h0ooK^0=@m6@0>0?ofkP<0000000<0dc/I03eIZ`3C>aT00`3C>aT00`0mFJ/0
dc/I03eIZ`020=<k6@030000003C>aT0dc/I00@0dc/I00<0?EV[0=<k6@3C>aT00P0mFJ/90=<k6@03
03eIZ`3C>aT0dc/I00T0dc/I00D000000=<k6@3C>aT0dc/I03eIZ`060=<k6@030000003C>aT0dc/I
00P0dc/I00<0000003eIZ`3C>aT0203C>aT00`000000dc/I0=<k6@070=<k6@0303eIZ`000000dc/I
00T0dc/I00<000000=<k6@3C>aT0103C>aT01@0mFJ/0dc/I0=<k6@3C>aT0000000/0dc/I00<0?EV[
0=<k6@3C>aT01`3C>aT203eIZ`80dc/I00<0?EV[0=<k6@3C>aT0103C>aT01P000000dc/I0=<k6@0m
FJ/0dc/I03eIZ`@0dc/I00<0?EV[0=<k6@0000000P00000>0?ofkP050=@m6@3om^h0ooK^0?ofkP3D
?AT04`3om^h00`3D?AT0ooK^0?ofkP0A0?ofkP050=@m6@000000ooK^0?ofkP3D?AT05P3om^h00`3D
?AT0ooK^0?ofkP0L0?ofkP030000003om^h0ooK^0380ooK^0@3oool003@0ooK^00<000000?ofkP3o
m^h0703om^h00`3D?AT0ooK^0?ofkP0D0?ofkP050=@m6@3om^h0ooK^0000003D?AT04`3om^h00`3D
?AT0ooK^0?ofkP0A0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT03`3om^h0100000004ATn0000000m
FJ/50=<k6@80?EV[0P3C>aT00`000000dc/I0=<k6@040=<k6@0503eIZ`3C>aT0dc/I0=<k6@000000
0P0mFJ/70=<k6@0303eIZ`000000dc/I00T0dc/I00D000000=<k6@3C>aT0dc/I03eIZ`060=<k6@03
0000003C>aT0dc/I00P0dc/I00<0000003eIZ`3C>aT0203C>aT00`000000dc/I0=<k6@070=<k6@03
03eIZ`000000dc/I00T0dc/I00<000000=<k6@3C>aT0103C>aT01@0mFJ/0dc/I0=<k6@3C>aT00000
00X0dc/I00<0000003eIZ`3C>aT01P3C>aT203eIZ`050000003C>aT0dc/I0=<k6@0mFJ/01P3C>aT0
0`000000dc/I0=<k6@0203eIZ`D0dc/I00@0?EV[00000017JK/000003`3om^h01@3D?AT0ooK^0?of
kP3om^h0e3dI0180ooK^0P3D?ATB0?ofkP030=@m6@3om^h000000080ooK^00<0e3dI0?ofkP3om^h0
503om^h00`3D?AT0ooK^0?ofkP0L0?ofkP030000003om^h0ooK^0380ooK^0@3oool003D0ooK^00<0
00000?ofkP3om^h06`3om^iJ0=@m6@0303eIZ`3C>aT0dc/I00<0dc/I0P0mFJ/20=<k6@030000003C
>aT0dc/I00@0dc/I00D0?EV[0=<k6@3C>aT0dc/I000000020=<k6@0303eIZ`3C>aT0dc/I00@0dc/I
00<0?EV[0000003C>aT02@3C>aT01@000000dc/I0=<k6@3C>aT0?EV[00H0dc/I00<000000=<k6@3C
>aT0203C>aT00`000000?EV[0=<k6@080=<k6@030000003C>aT0dc/I00L0dc/I00<0?EV[0000003C
>aT02@3C>aT00`000000dc/I0=<k6@040=<k6@0503eIZ`3C>aT0dc/I0=<k6@0000002P3C>aT00`00
0000?EV[0=<k6@050=<k6@0403eIZ`3C>aT0dc/I000000<0dc/I00<0?EV[0=<k6@3C>aT0103C>aT0
0`000000dc/I0=<k6@0203eIZ`D0dc/I00<0?EV[0=@m6@3D?AT0F03D?ATM0?ofkP030000003om^h0
ooK^03<0ooK^0@3oool003D0ooK^00<000000?ofkP3om^h06`3om^h00`3D?AT0ooK^0?ofkP0D0?of
kP060=@m6@3om^h0ooK^0000003om^h0e3dI4P3om^h20=@m6A80ooK^00D0e3dI0?ofkP3om^h0ooK^
0=@m6@0?0?ofkP<000001`3C>aT01@0mFJ/0dc/I0=<k6@3C>aT0000000D0dc/I00D0?EV[0=<k6@3C
>aT0dc/I000000030=<k6@80?EV[103C>aT00`0mFJ/000000=<k6@090=<k6@050000003C>aT0dc/I
0=<k6@0mFJ/01P3C>aT00`000000dc/I0=<k6@080=<k6@030000000mFJ/0dc/I00P0dc/I00<00000
0=<k6@3C>aT01`3C>aT00`0mFJ/000000=<k6@090=<k6@030000003C>aT0dc/I00@0dc/I00D0?EV[
0=<k6@3C>aT0dc/I0000000:0=<k6@030000000mFJ/0dc/I00<0dc/I0P0mFJ/30=<k6@050000003C
>aT0dc/I0=<k6@0mFJ/01@3C>aT01@000000dc/I0=<k6@3C>aT0?EV[00L0dc/I0`00000?0?ofkP05
0=@m6@3om^h0ooK^0?ofkP3D?AT04P3om^h20=@m6A80ooK^00<0e3dI0?ofkP0000000P3om^h00`3D
?AT0ooK^0?ofkP0D0?ofkP030=@m6@3om^h0ooK^01/0ooK^00<000000?ofkP3om^h0<`3om^h10?oo
o`00=@3om^h00`000000ooK^0?ofkP0K0?ofkP030=@m6@3om^h0ooK^01@0ooK^00H0e3dI0?ofkP3o
m^h000000?ofkP3D?ATB0?ofkP80e3dI4P3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00l0ooK^0P00
00000`0A6Ch000000=<k6@050=<k6@80?EV[0P3C>aT00`000000dc/I0=<k6@030=<k6@0503eIZ`3C
>aT0dc/I0=<k6@0000001@3C>aT203eIZ`80dc/I00<0?EV[0000003C>aT02P3C>aT010000000dc/I
0=<k6@0mFJ/70=<k6@030000003C>aT0dc/I00L0dc/I00<0000003eIZ`3C>aT0203C>aT00`000000
dc/I0=<k6@070=<k6@0303eIZ`000000dc/I00P0dc/I00<000000=<k6@3C>aT0103C>aT01@0mFJ/0
dc/I0=<k6@3C>aT0000000/0dc/I00@0000003eIZ`3C>aT0dc/I0P0mFJ/50=<k6@050000003C>aT0
dc/I0=<k6@0mFJ/01@3C>aT00`000000dc/I0=<k6@0203eIZ`H0dc/I00@0000004MY^`0000000000
3`3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI0180ooK^0P3D?ATB0?ofkP030=@m6@3om^h000000080
ooK^00<0e3dI0?ofkP3om^h0503om^h00`3D?AT0ooK^0?ofkP0K0?ofkP030000003om^h0ooK^03<0
ooK^0@3oool003H0ooK^00<000000?ofkP3om^h06P3om^h00`3D?AT0ooK^0?ofkP0D0?ofkP060=@m
6@3om^h0ooK^0?ofkP000000e3dI4P3om^h20=@m6A80ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0?
0?ofkP@000001P3C>aT01@0mFJ/0dc/I03eIZ`3C>aT0000000D0dc/I00<0?EV[0=<k6@3C>aT00P3C
>aT00`000000dc/I0=<k6@040=<k6@<0?EV[00<0dc/I0000003C>aT02@3C>aT01@000000dc/I0=<k
6@3C>aT0?EV[00H0dc/I00<000000=<k6@3C>aT01`3C>aT00`000000?EV[0=<k6@080=<k6@030000
003C>aT0dc/I00L0dc/I00<0?EV[0000003C>aT0203C>aT00`000000dc/I0=<k6@040=<k6@0503eI
Z`3C>aT0dc/I0=<k6@0000002P3C>aT00`000000dc/I03eIZ`0203eIZ`H0dc/I00<000000=<k6@3C
>aT00P3C>aT00`0mFJ/0dc/I0=<k6@030=<k6@050000003C>aT0?EV[0=<k6@0mFJ/01P3C>aT40000
00l0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0B0?ofkP80e3dI4P3om^h00`3D?AT000000?ofkP02
0?ofkP030=@m6@3om^h0ooK^01@0ooK^00<0e3dI0?ofkP3om^h06P3om^h00`000000ooK^0?ofkP0d
0?ofkP40oooo000f0?ofkP030000003om^h0ooK^01X0ooK^00<0e3dI0?ofkP3om^h0503om^h01P3D
?AT0ooK^0?ofkP3om^h000000=@m6A80ooK^0P3D?ATB0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT0
3`3om^h300000003014I?P000000dc/I00@0dc/I00H0?EV[0=<k6@3C>aT0?EV[0=<k6@0000050=<k
6@0503eIZ`3C>aT0dc/I0=<k6@000000203C>aT203eIZ`030000003C>aT0dc/I00P0dc/I00D00000
0=<k6@3C>aT0dc/I03eIZ`060=<k6@030000003C>aT0dc/I00L0dc/I00<0000003eIZ`3C>aT0203C
>aT00`000000dc/I0=<k6@070=<k6@0303eIZ`000000dc/I00P0dc/I00<000000=<k6@3C>aT0103C
>aT01@0mFJ/0dc/I0=<k6@3C>aT0000000X0dc/I00<0000003eIZ`0mFJ/0203C>aT01@000000dc/I
0=<k6@3C>aT0?EV[00D0dc/I00<000000=<k6@0mFJ/00P3C>aT00`0mFJ/0dc/I0=<k6@030=<k6@03
00000017JK/00000008000003`3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI0180ooK^0P3D?ATB0?of
kP030=@m6@000000ooK^0080ooK^00<0e3dI0?ofkP3om^h0503om^h00`3D?AT0ooK^0?ofkP0J0?of
kP030000003om^h0ooK^03@0ooK^0@3oool003H0ooK^00<000000?ofkP3om^h06P3om^h00`3D?AT0
ooK^0?ofkP0D0?ofkP060=@m6@3om^h0ooK^0?ofkP000000e3dI4P3om^h20=@m6A80ooK^00D0e3dI
0?ofkP3om^h0ooK^0=@m6@0?0?ofkP<0000000<04ATn000000000000100000001@0mFJ/000000000
00000000?EV[00H0000000<0?EV[0000000000002P0000000`0mFJ/0000003eIZ`0203eIZ``00000
00<0?EV[0000000000003`0000000`0mFJ/000000000000@0000000303eIZ`000000000001000000
00<0?EV[0000000000002P00000303eIZ`030000000mFJ/0000000/0000000<0?EV[000000000000
100000001@0mFJ/00000000000000000?EV[00L0000000<0AfVk0000000000003`3om^h01@3D?AT0
ooK^0?ofkP3om^h0e3dI0180ooK^0P3D?ATB0?ofkP030=@m6@000000ooK^0080ooK^00<0e3dI0?of
kP3om^h0503om^h00`3D?AT0ooK^0?ofkP0J0?ofkP030000003om^h0ooK^03@0ooK^0@3oool003L0
ooK^00<000000?ofkP3om^h06@3om^h00`3D?AT0ooK^0?ofkP0D0?ofkP050=@m6@3om^h0ooK^0?of
kP000000>`3D?AT200000004014I?P0000000000000000@0gChJ00<0?EV[0=dn6P3M?QX00P3M?QX2
03eIZ`@0gChJ00D0?EV[0=dn6P3M?QX0gChJ000000080=dn6P0303eIZ`3M?QX000000080gChJ0`0m
FJ/50=dn6P050000003M?QX0gChJ0=dn6P0mFJ/01P3M?QX00`000000gChJ0=dn6P070=dn6P030000
003M?QX0?EV[00P0gChJ00<000000=dn6P3M?QX01P3M?QX00`0mFJ/0gChJ000000090=dn6P030000
003M?QX0gChJ00@0gChJ00D0?EV[0=dn6P3M?QX0gChJ000000050=dn6P<0?EV[0P3M?QX00`000000
gChJ03eIZ`080=dn6P050000003M?QX0gChJ0=dn6P0mFJ/0103M?QX203eIZ`@0gChJ00<0?EV[0=dn
6P3M?QX00P3M?QX30000000304MY^`000000000003/0e3dI00D000000?ofkP3om^h0ooK^0=@m6@0F
0?ofkP030=@m6@3om^h0ooK^01T0ooK^00<000000?ofkP3om^h0=@3om^h10?ooo`00=`3om^h00`00
0000ooK^0?ofkP0I0?ofkP030=@m6@3om^h0ooK^01@0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D
?AT0ooK^0?ofkP0@0?ofkP80e3dI4P3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00l0ooK^0P000000
100A6Ch000000000000000040=dn6P0303eIZ`3M?QX0gChJ00<0gChJ00<0000003eIZ`3M?QX00P3M
?QX00`0mFJ/0gChJ0=dn6P020=dn6P030000003M?QX0gChJ00D0gChJ00@0?EV[0=dn6P3M?QX00000
103M?QX203eIZ`<0gChJ00D000000=dn6P3M?QX0gChJ03eIZ`060=dn6P030000003M?QX0gChJ00L0
gChJ00<000000=dn6P0mFJ/0203M?QX00`000000gChJ0=dn6P060=dn6P0303eIZ`3M?QX0000000T0
gChJ00<000000=dn6P3M?QX0103M?QX01@0mFJ/0gChJ0=dn6P3M?QX0000000<0gChJ0P0mFJ/40=dn
6P040000003M?QX0gChJ03eIZ`L0gChJ00<000000=dn6P3M?QX00P3M?QX01P0mFJ/0gChJ0=dn6P3M
?QX0?EV[000000D0gChJ00<0?EV[0=dn6P3M?QX00P3M?QX30000000304MY^`000000000000l0ooK^
00D0e3dI0?ofkP3om^h0ooK^0=@m6@0B0?ofkP80e3dI4P3om^h00`3D?AT0ooK^0?ofkP020?ofkP03
0=@m6@3om^h0ooK^01@0ooK^00<0e3dI0?ofkP3om^h06@3om^h00`000000ooK^0?ofkP0e0?ofkP40
oooo000g0?ofkP030000003om^h0ooK^01T0ooK^00<0e3dI0?ofkP3om^h0503om^h00`3D?AT0ooK^
0?ofkP020?ofkP030=@m6@3om^h0ooK^0100ooK^0P3D?ATB0?ofkP050=@m6@3om^h0ooK^0?ofkP3D
?AT03`3om^h300000004014I?P0000005b=E000000<0gChJ00<0?EV[0=dn6P3M?QX00`3M?QX00`00
0000gChJ03eIZ`020=dn6P0303eIZ`3M?QX0gChJ0080gChJ00<000000=dn6P3M?QX01@3M?QX0100m
FJ/0gChJ0=dn6P0000060=dn6P<0?EV[00D0gChJ0000003M?QX0gChJ03eIZ`060=dn6P030000003M
?QX0gChJ00L0gChJ00<000000=dn6P0mFJ/0203M?QX00`000000gChJ0=dn6P060=dn6P0303eIZ`3M
?QX0000000T0gChJ00<000000=dn6P3M?QX0103M?QX01@0mFJ/0gChJ0=dn6P000000gChJ00<0?EV[
1P3M?QX010000000gChJ0=dn6P0mFJ/70=dn6P030000003M?QX0gChJ0080gChJ00H0?EV[0=dn6P3M
?QX0?EV[0=dn6P0000040=dn6P0303eIZ`3M?QX0gChJ0080gChJ0`0000001017JK/0000000000000
000?0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT04P3om^h20=@m6A80ooK^00<0e3dI0?ofkP3om^h0
0P3om^h00`3D?AT0ooK^0?ofkP0D0?ofkP030=@m6@3om^h0ooK^01T0ooK^00<000000?ofkP3om^h0
=@3om^h10?ooo`00>03om^h00`000000ooK^0?ofkP0G0?ofkP030=@m6@3om^h0ooK^01D0ooK^00<0
e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP0@0?ofkP80e3dI4P3om^h01@3D?AT0ooK^0?of
kP3om^h0e3dI00l0ooK^0`000000100A6Ch000000000000000040=dn6P0303eIZ`3M?QX0gChJ00<0
gChJ00D000000=dn6P0mFJ/0gChJ03eIZ`050=dn6P030000003M?QX0gChJ00@0gChJ00@0?EV[0=dn
6P3M?QX000002@3M?QX303eIZ`030=dn6P0mFJ/0gChJ00H0gChJ00<000000=dn6P3M?QX01P3M?QX0
0`000000gChJ03eIZ`080=dn6P030000003M?QX0gChJ00H0gChJ00<0?EV[0=dn6P000000203M?QX0
0`000000gChJ0=dn6P050=dn6P0303eIZ`3M?QX0?EV[0080?EV[2@3M?QX010000000gChJ0=dn6P0m
FJ/60=dn6P030000003M?QX0gChJ00<0gChJ00D0?EV[0=dn6P0mFJ/0gChJ000000050=dn6P0303eI
Z`3M?QX0gChJ0080gChJ0`0000001017JK/0000000000000000?0?ofkP050=@m6@3om^h0ooK^0?of
kP3D?AT04P3om^h20=@m6A80ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP0D0?of
kP030=@m6@3om^h0ooK^01P0ooK^00<000000?ofkP3om^h0=P3om^h10?ooo`00>03om^h00`000000
ooK^0?ofkP0G0?ofkP030=@m6@3om^h0ooK^01D0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0
ooK^0?ofkP0@0?ofkP80e3dI4P3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00l0ooK^10000000100A
6Ch0000001LSE@0000030=dn6P0303eIZ`3M?QX0gChJ00<0gChJ00<000000=dn6P3M?QX00P0mFJ/5
0=dn6P030000003M?QX0gChJ00@0gChJ00D0?EV[0=dn6P3M?QX0gChJ000000090=dn6P030000003M
?QX0?EV[00@0?EV[103M?QX00`000000gChJ0=dn6P060=dn6P030000003M?QX0?EV[00P0gChJ00<0
00000=dn6P3M?QX01P3M?QX00`0mFJ/0gChJ000000080=dn6P030000003M?QX0gChJ0080gChJ1@0m
FJ/00`3M?QX000000=dn6P080=dn6P050000003M?QX0gChJ0=dn6P0mFJ/01P3M?QX00`000000gChJ
0=dn6P030=dn6P80?EV[0P3M?QX00`000000gChJ0=dn6P030=dn6P0803eIZ`3M?QX0gChJ0=dn6P00
0000D7GG00000017JK/4000000l0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0B0?ofkP80e3dI4P3o
m^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^01D0ooK^00<0e3dI0?ofkP3om^h05`3o
m^h00`000000ooK^0?ofkP0f0?ofkP40oooo000h0?ofkP030000003om^h0ooK^01L0ooK^00<0e3dI
0?ofkP3om^h05@3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^0100ooK^0P3D?ATB
0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT03`3om^h400000008014I?P0000005b=E0000003M?QX0
?EV[0=dn6P0mFJ/60=dn6P040000003M?QX0gChJ03eIZ`D0gChJ00<000000=dn6P3M?QX0103M?QX0
1@0mFJ/0gChJ0=dn6P3M?QX0000000T0gChJ00@000000=dn6P3M?QX0?EV[0`3M?QX603eIZ`L0gChJ
00<000000=dn6P0mFJ/0203M?QX00`000000gChJ0=dn6P060=dn6P0303eIZ`3M?QX0000000L0gChJ
1P0mFJ/30=dn6P0403eIZ`3M?QX0gChJ000000T0gChJ00D000000=dn6P3M?QX0gChJ03eIZ`060=dn
6P030000003M?QX0gChJ00<0gChJ00@0?EV[0=dn6P3M?QX000001P3M?QX0200mFJ/0gChJ03eIZ`3M
?QX00000051ee`000000AfVk1000000?0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT04P3om^h20=@m
6A80ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP0E0?ofkP030=@m6@3om^h0ooK^
01L0ooK^00<000000?ofkP3om^h0=P3om^h10?ooo`00>@3om^h00`000000ooK^0?ofkP0F0?ofkP03
0=@m6@3om^h0ooK^01D0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT000000?ofkP0@0?ofkP80
e3dI4P3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00l0ooK^0`0000000`0A6Ch000000000000201LS
E@040=@m6@0mFJ/0gChJ03eIZ`H0gChJ00<000000=dn6P3M?QX00`0mFJ/40=dn6P030000003M?QX0
gChJ00<0gChJ00D0?EV[0=dn6P3M?QX0gChJ0000000:0=dn6P030000003M?QX0?EV[00L0gChJ00<0
00000=dn6P0mFJ/01@0mFJ/20=dn6P030000000mFJ/0gChJ00L0gChJ00<000000=dn6P3M?QX01P3M
?QX0100mFJ/000000=dn6P3M?QX603eIZ`030=dn6P000000gChJ00H0gChJ00<0?EV[0=dn6P000000
2P3M?QX010000000gChJ0=dn6P0mFJ/60=dn6P030000003M?QX0gChJ0080gChJ0`0mFJ/20=dn6P03
0000003M?QX0gChJ00@0gChJ00@0?EV[0=dn6P0mFJ/0e3dI0P1@MML20000000404MY^`0000000000
000000l0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0B0?ofkP80e3dI4@3om^h00`000000e3dI0?of
kP030?ofkP030=@m6@3om^h0ooK^01D0ooK^00<0e3dI0?ofkP3om^h05P3om^h00`000000ooK^0?of
kP0g0?ofkP40oooo000i0?ofkP030000003om^h0ooK^01H0ooK^00<0e3dI0?ofkP3om^h05@3om^h0
0`3D?AT0ooK^0?ofkP020?ofkP030=@m6@000000ooK^0100ooK^0P3D?ATB0?ofkP050=@m6@3om^h0
ooK^0?ofkP3D?AT03`3om^h0103D?AT000000000000A6Ch30000000301LSE@3D?AT0gChJ0080?EV[
1`3M?QX00`000000gChJ03eIZ`020=dn6P0503eIZ`3M?QX0gChJ0=dn6P0000001P3M?QX0100mFJ/0
gChJ0=dn6P00000:0=dn6P030000003M?QX0?EV[00L0gChJ00<000000=dn6P3M?QX01@3M?QXI03eI
Z`L0gChJ00<000000=dn6P3M?QX01@3M?QX00`0mFJ/0gChJ0000000:0=dn6P040000003M?QX0gChJ
03eIZ`H0gChJ00D000000=dn6P3M?QX0gChJ03eIZ`020=dn6P0303eIZ`3M?QX0000000L0gChJ0P0m
FJ/00`3M?QX0e3dI051ee`030000000404MY^`00000000000=@m6@l0ooK^00@0e3dI0?ofkP3om^h0
e3dI4`3om^h20=@m6A40ooK^00<000000=@m6@3om^h00`3om^h00`3D?AT0ooK^0?ofkP0E0?ofkP03
0=@m6@3om^h0ooK^01H0ooK^00<000000?ofkP3om^h0=`3om^h10?ooo`00>@3om^h00`000000ooK^
0?ofkP0F0?ofkP030=@m6@3om^h0ooK^01D0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT00000
0?ofkP0@0?ofkP80e3dI4`3om^h0103D?AT0ooK^0?ofkP3D?AT?0?ofkP030=@m6@00000000000080
4ATn0P0000000`0G8eD0e3dI0000000203eIZ`L0gChJ00<000000=dn6P0mFJ/00`3M?QX203eIZ`03
0=dn6P000000gChJ00D0gChJ00D0?EV[0=dn6P3M?QX0gChJ000000090=dn6P030000003M?QX0?EV[
00L0gChJ00<000000=dn6P3M?QX01`3M?QX00`000000?EV[0=dn6P070=dn6P030000003M?QX0gChJ
00H0gChJ00<0?EV[0000003M?QX0203M?QX00`000000gChJ0=dn6P050=dn6P0303eIZ`3M?QX00000
00T0gChJ00D000000=dn6P3M?QX0gChJ03eIZ`060=dn6P040000003M?QX0?EV[03eIZ`<0gChJ00<0
?EV[0=dn6P0000001`3M?QX203eIZ`030000003D?AT0D7GG008000000P17JK/2000000030=@m6@3o
m^h0ooK^00d0ooK^00@0e3dI0?ofkP3om^h0e3dI4`3om^h20=@m6A40ooK^00<000000=@m6@3om^h0
0`3om^h00`3D?AT0ooK^0?ofkP0E0?ofkP030=@m6@3om^h0ooK^01H0ooK^00<000000?ofkP3om^h0
=`3om^h10?ooo`00>@3om^h00`000000ooK^0?ofkP0F0?ofkP030=@m6@3om^h0ooK^01D0ooK^00<0
e3dI0?ofkP3om^h00P3om^h00`3D?AT000000?ofkP0@0?ofkP80e3dI4`3om^h0103D?AT0ooK^0?of
kP3D?AT?0?ofkP050=@m6@00000000000000000A6Ch00`000000103D?AT000000=dn6P0mFJ/80=dn
6P030000000mFJ/0gChJ00@0gChJ00<0?EV[0=dn6P0000001@3M?QX01@0mFJ/0gChJ0=dn6P3M?QX0
000000T0gChJ00<000000=dn6P0mFJ/0203M?QX00`000000gChJ0=dn6P060=dn6P030000000mFJ/0
gChJ00L0gChJ00<000000=dn6P3M?QX01P3M?QX00`0mFJ/000000=dn6P070=dn6P030000003M?QX0
gChJ00H0gChJ00<0?EV[0=dn6P0000002@3M?QX01@000000gChJ0=dn6P3M?QX0?EV[00D0gChJ00<0
00000=dn6P0mFJ/01@3M?QX00`0mFJ/000000=dn6P070=dn6P0403eIZ`3M?QX000000=@m6@<00000
00D0AfVk00000000000000000=@m6@0?0?ofkP040=@m6@3om^h0ooK^0=@m6A<0ooK^0P3D?ATA0?of
kP030000003D?AT0ooK^00<0ooK^00<0e3dI0?ofkP3om^h05@3om^h00`3D?AT0ooK^0?ofkP0F0?of
kP030000003om^h0ooK^03L0ooK^0@3oool003X0ooK^00<000000?ofkP3om^h05@3om^h00`3D?AT0
ooK^0?ofkP0E0?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP000000403om^h20=@m6A<0
ooK^00@0e3dI0?ofkP3om^h0e3dI3`3om^h0103D?AT00000000000000002014I?P80000000<0e3dI
01LSE@0000000P0mFJ/70=dn6P030000000mFJ/0gChJ00D0gChJ0P0mFJ/50=dn6P0503eIZ`3M?QX0
gChJ0=dn6P0000002P3M?QX00`000000?EV[0=dn6P070=dn6P030000003M?QX0gChJ00H0gChJ00<0
000003eIZ`3M?QX01`3M?QX00`000000gChJ0=dn6P060=dn6P0303eIZ`000000gChJ00L0gChJ00<0
00000=dn6P3M?QX01P3M?QX00`0mFJ/000000=dn6P090=dn6P050000003M?QX0gChJ0=dn6P0mFJ/0
1@3M?QX203eIZ`H0gChJ00<0?EV[0000003M?QX01P3M?QX203eIZ`030000001@MML0e3dI00800000
0P17JK/3000000030=@m6@3om^h0ooK^00d0ooK^00@0e3dI0?ofkP3om^h0e3dI4`3om^h20=@m6A00
ooK^00<000000?ofkP3D?AT0103om^h00`3D?AT0ooK^0?ofkP0E0?ofkP030=@m6@3om^h0ooK^01D0
ooK^00<000000?ofkP3om^h0>03om^h10?ooo`00>P3om^h00`000000ooK^0?ofkP0E0?ofkP030=@m
6@3om^h0ooK^01D0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0000000@0?ofkP80e3dI
4`3om^h0103D?AT0ooK^0?ofkP3D?AT?0?ofkP040=@m6@0000000000000000804ATn00P0000001LS
E@3D?AT05b=E0000000mFJ/0gChJ03eIZ`L0gChJ00<0?EV[0=dn6P3M?QX01P3M?QX203eIZ`040=@m
6@3M?QX0gChJ03eIZ`@0gChJ00<000000=dn6P3M?QX01`3M?QX00`000000?EV[0=dn6P020=dn6P03
0=@m6@3M?QX0gChJ0080gChJ00<000000=dn6P3M?QX01P3M?QX00`000000?EV[0=dn6P070=dn6P03
0=@m6@3M?QX0gChJ00H0gChJ00<0?EV[0000003M?QX01`3M?QX00`000000gChJ0=dn6P020=dn6P06
0=@m6@3M?QX0gChJ0=dn6P0mFJ/000002@3M?QX00`000000gChJ0=dn6P020=dn6P0403eIZ`3M?QX0
gChJ0=dn6P80?EV[203M?QX00`0mFJ/0gChJ0=dn6P050=dn6P0803eIZ`3M?QX0?EV[0000001@MML0
e3dI051ee`00000204MY^`<0000000<0e3dI0?ofkP3om^h03@3om^h0103D?AT0ooK^0?ofkP3D?ATC
0?ofkP80e3dI403om^h00`000000ooK^0=@m6@040?ofkP030=@m6@3om^h0ooK^01D0ooK^00<0e3dI
0?ofkP3om^h05@3om^h00`000000ooK^0?ofkP0h0?ofkP40oooo000j0?ofkP030000003om^h0ooK^
01D0ooK^H`3D?AT30000000303eIZ`000000000000@0000000<0?EV[00000000000020000000100m
FJ/000000000000mFJ/?0000000303eIZ`00000000000100000000<0?EV[0000000000003`000000
0`0mFJ/000000000000?0000000303eIZ`000000000000h0000000@0?EV[000000000000?EV[2P00
00000`0mFJ/00000000000040000000403eIZ`000000?EV[000006<0e3dI5`3om^h00`000000ooK^
0?ofkP0h0?ofkP40oooo000k0?ofkP030000003om^h0ooK^01@0ooK^00<0e3dI0?ofkP3om^h05@3o
m^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h000000100ooK^0P3D?ATC0?ofkP040=@m6@3o
m^h0ooK^0=@m6@l0ooK^00<0e3dI0000000000000P0000001P0A6Ch000000000003D?AT0000001LS
E@8000000P3U@A/00`0mFJ/0iD4K0>E16`040>E16`0303eIZ`3U@A/0iD4K00D0iD4K00<000000>E1
6`3U@A/00`0mFJ/40>E16`030000003U@A/0iD4K00L0iD4K00<000000>E16`0mFJ/01`3U@A/00`00
0000iD4K0>E16`060>E16`030000000mFJ/0iD4K00L0iD4K00<000000>E16`3U@A/01P3U@A/00`0m
FJ/000000>E16`070>E16`030000003U@A/0iD4K00D0iD4K00<0?EV[0>E16`0000002@3U@A/00`00
0000iD4K0>E16`020>E16`<0?EV[0P3U@A/00`000000iD4K0>E16`050>E16`0303eIZ`3U@A/0iD4K
00@0iD4K00<0?EV[0>E16`3U@A/00P0000000`1@MML000000=@m6@020000000604MY^`0000000000
0000003om^h0e3dI3`3om^h0103D?AT0ooK^0?ofkP3D?ATC0?ofkP80e3dI403om^h00`000000ooK^
0=@m6@040?ofkP030=@m6@3om^h0ooK^01D0ooK^00<0e3dI0?ofkP3om^h0503om^h00`000000ooK^
0?ofkP0i0?ofkP40oooo000k0?ofkP030000003om^h0ooK^01@0ooK^00<0e3dI0?ofkP3om^h05@3o
m^h00`3D?AT0ooK^0?ofkP020?ofkSd0e3dI0P000002014I?P80000000<0e3dI0000000G8eD00P00
00030>E16`0303eIZ`3U@A/0iD4K00<0iD4K00<0?EV[0>E16`3U@A/01P3U@A/010000000iD4K0>E1
6`3U@A/203eIZ`@0iD4K00<000000>E16`3U@A/01P3U@A/00`000000iD4K03eIZ`070>E16`030000
003U@A/0iD4K00H0iD4K00<0000003eIZ`3U@A/01`3U@A/00`000000iD4K0>E16`060>E16`0303eI
Z`000000iD4K00L0iD4K00<000000>E16`3U@A/01@3U@A/00`0mFJ/0iD4K000000080>E16`030000
003U@A/0iD4K0080iD4K0P0mFJ/30>E16`030000003U@A/0iD4K00H0iD4K00<0?EV[0>E16`3U@A/0
0`3U@A/0100mFJ/0iD4K0>E16`3U@A/200000005051ee`000000e3dI051ee`0000000P17JK/20000
03d0e3dI103om^h00`3D?AT0ooK^0?ofkP0E0?ofkP030=@m6@3om^h0ooK^01@0ooK^00<000000?of
kP3om^h0>@3om^h10?ooo`00>`3om^h00`000000ooK^0?ofkP0D0?ofkP030=@m6@3om^h0ooK^01D0
ooK^00<0e3dI0?ofkP3om^h00P3om^h0103D?AT0ooK^0?ofkP00000?0?ofkP80e3dI4`3om^h0103D
?AT0ooK^0?ofkP3D?AT?0?ofkP030=@m6@3om^h0000000@0000000L05b=E0=@m6@0G8eD05b=E0000
000O<W00000000<0iD4K00<0?EV[0>E16`3U@A/00P3U@A/00`0mFJ/000000>E16`060>E16`060000
003U@A/0iD4K0>E16`0mFJ/0iD4K0`0mFJ/00`3U@A/000000>E16`080>E16`030000000mFJ/0iD4K
00H0iD4K00<000000>E16`3U@A/01P3U@A/00`000000?EV[0>E16`070>E16`030000003U@A/0iD4K
00H0iD4K00<0?EV[0000003U@A/01`3U@A/00`000000iD4K0>E16`050>E16`0303eIZ`000000iD4K
00P0iD4K00<000000>E16`0mFJ/00P0mFJ/00`3U@A/0?EV[0>E16`020>E16`030000003U@A/0iD4K
00D0iD4K00<0000003eIZ`3U@A/00`3U@A/01`0mFJ/0iD4K0>E16`3U@A/0000005AliP0000000P1@
MML00`3D?AT0D7GG000000030000000303YET`3om^h0e3dI00l0ooK^00@0e3dI0?ofkP3om^h0e3dI
4`3om^h20=@m6@l0ooK^00@000000?ofkP3om^h0e3dI103om^h00`3D?AT0ooK^0?ofkP0E0?ofkP03
0=@m6@3om^h0ooK^01@0ooK^00<000000?ofkP3om^h0>@3om^h10?ooo`00?03om^h00`000000ooK^
0?ofkP0C0?ofkP030=@m6@3om^h0ooK^01D0ooK^00<0e3dI0?ofkP3om^h00P3om^h0103D?AT0ooK^
0?ofkP00000?0?ofkP80e3dI4`3om^h0103D?AT0ooK^0?ofkP3D?AT?0?ofkP030=@m6@3om^h00000
00@0000000<05b=E0=@m6@0G8eD00P0000000`0O<W0000000>E16`030>E16`0603eIZ`3U@A/0iD4K
0>E16`0mFJ/00000203U@A/010000000iD4K0>E16`0mFJ/40>E16`<0?EV[203U@A/00`000000?EV[
0>E16`070>E16`030000003U@A/0iD4K00D0iD4K00<0000003eIZ`3U@A/01`3U@A/00`000000iD4K
0>E16`060>E16`0303eIZ`000000iD4K00H0iD4K00<000000>E16`3U@A/01P3U@A/00`0mFJ/00000
0>E16`070>E16`<0?EV[103U@A/0100mFJ/0iD4K0>E16`0000080>E16`030000000mFJ/0iD4K0080
iD4K00<0?EV[0>E16`3U@A/00P3U@A/00`000000E7cV00000002000000030=@m6@1@MML0000000@0
000000<0ooK^0=@m6@3om^h03P3om^h0103D?AT0ooK^0?ofkP3D?ATC0?ofkP80e3dI3`3om^h01000
0000ooK^0?ofkP3D?AT40?ofkP030=@m6@3om^h0ooK^01D0ooK^00<0e3dI0?ofkP3om^h04`3om^h0
0`000000ooK^0?ofkP0j0?ofkP40oooo000l0?ofkP030000003om^h0ooK^01<0ooK^00<0e3dI0?of
kP3om^h05@3om^h00`3D?AT0ooK^0?ofkP020?ofkP040=@m6@3om^h0ooK^000000l0ooK^0P3D?ATC
0?ofkP040=@m6@3om^h0ooK^0=@m6@l0ooK^00`0e3dI0?ofkP000000?EV[0000000A6Ch0000001LS
E@3D?AT0000001LSE@00000201lbL0030000003U@A/0iD4K0080iD4K00H0?EV[0>E16`3U@A/0?EV[
0>E16`0000070>E16`040000003U@A/0iD4K03eIZ`H0iD4K00<0000003eIZ`0mFJ/01P3U@A/00`00
0000?EV[0>E16`070>E16`030000003U@A/0iD4K00D0iD4K00<0000003eIZ`3U@A/01`3U@A/00`00
0000iD4K0>E16`060>E16`0303eIZ`000000iD4K00H0iD4K00<000000>E16`3U@A/01P3U@A/00`0m
FJ/000000>E16`050>E16`80?EV[00<000000>E16`3U@A/0103U@A/0100mFJ/0iD4K0>E16`000007
0>E16`030000003U@A/0?EV[0080iD4K00<0?EV[0>E16`3U@A/00P3U@A/03`000000E7cV05AliP00
0000D7GG0000003D?AT0D7GG00000017JK/0000003eIZ`000000ooK^0=@m6@0?0?ofkP040=@m6@3o
m^h0ooK^0=@m6A<0ooK^0P3D?AT?0?ofkP040000003om^h0ooK^0=@m6@@0ooK^00<0e3dI0?ofkP3o
m^h05@3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030000003om^h0ooK^03X0ooK^0@3oool003`0ooK^
00<000000?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP0E0?ofkP030=@m6@3om^h0ooK^0080ooK^
00@0e3dI0?ofkP3om^h000003`3om^h20=@m6A<0ooK^00@0e3dI0?ofkP3om^h0e3dI3`3om^h0103D
?AT0ooK^0000000mFJ/30000000501LSE@3D?AT0000001LSE@0000000`0O<W000`000000iD4K0>E1
6`020>E16`0503eIZ`3U@A/0?EV[0>E16`000000203U@A/00`000000iD4K03eIZ`060>E16`030000
003U@A/0iD4K00<0?EV[0`3U@A/00`000000?EV[0>E16`070>E16`030000003U@A/0iD4K00D0iD4K
00<0000003eIZ`3U@A/01`3U@A/00`000000iD4K0>E16`060>E16`0303eIZ`000000iD4K00H0iD4K
00<000000>E16`3U@A/01P3U@A/00`0mFJ/000000>E16`020>E16`<0?EV[0P3U@A/00`000000iD4K
0>E16`040>E16`0303eIZ`3U@A/0000000P0iD4K00D000000>E16`0mFJ/0iD4K03eIZ`040>E16`04
0000001DO>H0E7cV05AliP80000000<0D7GG0=@m6@1@MML00`000000100mFJ/000000?ofkP3D?AT?
0?ofkP040=@m6@3om^h0ooK^0=@m6A<0ooK^0P3D?AT?0?ofkP040000003om^h0ooK^0=@m6@@0ooK^
00<0e3dI0?ofkP3om^h05@3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030000003om^h0ooK^03X0ooK^
0@3oool003d0ooK^00<000000?ofkP3om^h04P3om^h00`3D?AT0ooK^0?ofkP0E0?ofkP030=@m6@3o
m^h0ooK^0080ooK^00D0e3dI0?ofkP3om^h0ooK^0000000>0?ofkP80e3dI4`3om^h0103D?AT0ooK^
0?ofkP3D?AT?0?ofkP040=@m6@3om^h0000003eIZ`@0000000<0e3dI01LSE@0000000P00000201lb
L0030000003U@A/0iD4K00<0iD4K0P0mFJ/20>E16`030000003U@A/0iD4K00D0iD4K00<000000>E1
6`0mFJ/01`3U@A/00`000000iD4K0>E16`020>E16`<0?EV[00<0iD4K03eIZ`3U@A/01`3U@A/00`00
0000iD4K0>E16`060>E16`0303eIZ`3U@A/0iD4K00H0iD4K00<000000>E16`3U@A/01P3U@A/00`0m
FJ/0iD4K0>E16`060>E16`030000003U@A/0iD4K00H0iD4K00<0?EV[0>E16`0mFJ/00P0mFJ/40>E1
6`030000003U@A/0iD4K00D0iD4K00<0?EV[0>E16`0000001`3U@A/00`000000iD4K0>E16`0203eI
Z`D0iD4K00<0000005AliP1DO>H00`0000000`1@MML0e3dI000000030000000403eIZ`000000ooK^
0=@m6@l0ooK^00@0e3dI0?ofkP3om^h0e3dI4`3om^h20=@m6@h0ooK^00D000000?ofkP3om^h0ooK^
0=@m6@040?ofkP030=@m6@3om^h0ooK^01D0ooK^00<0e3dI0?ofkP3om^h04P3om^h00`000000ooK^
0?ofkP0k0?ofkP40oooo000m0?ofkP030000003om^h0ooK^0180ooK^00<0e3dI0?ofkP3om^h05@3o
m^h00`3D?AT0ooK^0?ofkP020?ofkP050=@m6@3om^h0ooK^0?ofkP0000003P3om^h20=@m6A<0ooK^
00@0e3dI0?ofkP3om^h0e3dI3`3om^h01P3D?AT0ooK^0?ofkP0;42H0000003eIZ`80000000<0e3dI
01LSE@0000000P00000301lbL0030000003U@A/0iD4K00<0iD4K00@0?EV[0>E16`3U@A/00000203U
@A/00`000000?EV[0>E16`060>E16`030000003U@A/0iD4K00D0iD4K100mFJ/60>E16`030000003U
@A/0iD4K00H0iD4K00<0?EV[0>E16`3U@A/01P3U@A/00`000000iD4K0>E16`060>E16`0303eIZ`3U
@A/0iD4K00H0iD4K00<000000>E16`3U@A/0103U@A/403eIZ`L0iD4K00<000000>E16`3U@A/01@3U
@A/00`0mFJ/000000>E16`070>E16`040000003U@A/0iD4K03eIZ`D0iD4K00H0000005AliP1DO>H0
000005AliP000002051ee`060=@m6@000000000003eIZ`000000>UFC0P3om^h00`3D?AT0ooK^0?of
kP0=0?ofkP040=@m6@3om^h0ooK^0=@m6A<0ooK^0P3D?AT>0?ofkP050000003om^h0ooK^0?ofkP3D
?AT0103om^h00`3D?AT0ooK^0?ofkP0E0?ofkP030=@m6@3om^h0ooK^0180ooK^00<000000?ofkP3o
m^h0>`3om^h10?ooo`00?@3om^h00`000000ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^01@0ooK^
00<0e3dI0?ofkP3om^h00P3om^h01@3D?AT0ooK^0?ofkP3om^h0000000h0ooK^0P3D?ATB0?ofkP05
0=@m6@3om^h0ooK^0?ofkP3D?AT03`3om^h00`3D?AT0ooK^0?ofkP0200000004014I?P0000005b=E
0=@m6@805b=E00<0?EV[0000000000000`0O<W000`000000iD4K0>E16`020>E16`<0?EV[00<0iD4K
0000003U@A/01P3U@A/00`000000?EV[0>E16`060>E16`030000003U@A/0iD4K00H0iD4K00<0?EV[
0>E16`3U@A/01P0mFJ/00`000000iD4K0>E16`060>E16`0303eIZ`3U@A/0iD4K00H0iD4K00<00000
0>E16`3U@A/01P3U@A/00`0mFJ/0iD4K0>E16`060>E16`030000000mFJ/0?EV[00@0?EV[0P3U@A/0
0`0mFJ/0iD4K0>E16`060>E16`030000003U@A/0iD4K00@0iD4K00<0?EV[0>E16`0000001`3U@A/0
0`000000iD4K03eIZ`0203eIZ`@0iD4K00@0000005AliP1DO>H0E7cV0P000000100mFJ/0D7GG051e
e`3D?AT20000000304MY^`00000000000080ooK^00<0e3dI0?ofkP3om^h03@3om^h0103D?AT0ooK^
0?ofkP3D?ATC0?ofkP80e3dI3P3om^h01@000000ooK^0?ofkP3om^h0e3dI00@0ooK^00<0e3dI0?of
kP3om^h0503om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030000003om^h0ooK^03/0ooK^0@3oool003h0
ooK^00<000000?ofkP3om^h04P3om^h00`3D?AT0ooK^0?ofkP0D0?ofkP030=@m6@3om^h0ooK^0080
ooK^00D0e3dI0?ofkP3om^h0ooK^0000000>0?ofkP80e3dI4P3om^h01@3D?AT0ooK^0?ofkP3om^h0
e3dI00l0ooK^00<0e3dI0?ofkP3om^h01@0000000`3D?AT0000001LSE@020000000501lbL0000000
7c9`01lbL0000000103U@A/00`0mFJ/0iD4K0>E16`0203eIZ`P0iD4K00<0000003eIZ`3U@A/01P3U
@A/00`000000iD4K0>E16`050>E16`0303eIZ`3U@A/0iD4K00H0iD4K1P0mFJ/30>E16`0303eIZ`3U
@A/0iD4K00H0iD4K00<000000>E16`3U@A/01P3U@A/0100mFJ/0iD4K0>E16`3U@A/603eIZ`P0iD4K
00<0?EV[0>E16`3U@A/01@3U@A/00`000000iD4K0>E16`050>E16`0303eIZ`000000iD4K00L0iD4K
0P0mFJ/20>E16`0303eIZ`3U@A/0iD4K0080iD4K00H0000005AliP1DO>H0000005AliP000002051e
e`030000003D?AT0000000@000000P3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP050=@m6@3om^h0ooK^
0?ofkP3D?AT04P3om^h20=@m6@h0ooK^00D000000?ofkP3om^h0ooK^0=@m6@040?ofkP030=@m6@3o
m^h0ooK^01@0ooK^00<0e3dI0?ofkP3om^h04P3om^h00`000000ooK^0?ofkP0l0?ofkP40oooo000n
0?ofkP030000003om^h0ooK^0180ooK^00<0e3dI0?ofkP3om^h0503om^h00`3D?AT0ooK^0?ofkP02
0?ofkP030=@m6@3om^h0ooK^0080ooK^00<000000?ofkP3om^h02`3om^h20=@m6A80ooK^00D0e3dI
0?ofkP3om^h0ooK^0=@m6@0?0?ofkP030=@m6@3om^h0ooK^00<0000000@04ATn0000003D?AT00000
0P0G8eD0100000007c9`01lbL000000201lbL0050000003U@A/0iD4K0>E16`0mFJ/0103U@A/203eI
Z`H0iD4K00<0000003eIZ`3U@A/01P3U@A/00`000000iD4K0>E16`050>E16`0303eIZ`000000iD4K
00L0iD4K00<000000>E16`3U@A/00P3U@A/I03eIZ`@0iD4K00<000000>E16`3U@A/01P3U@A/00`00
0000?EV[0>E16`060>E16`030000003U@A/0iD4K00D0iD4K00<0?EV[0000003U@A/01@3U@A/203eI
Z`@0iD4K00D0?EV[0>E16`3U@A/0iD4K0000000205AliP040000001DO>H0E7cV00000080D7GG00@0
00000=@m6@000000AfVk0`0000020?ofkP030=@m6@3om^h0ooK^00d0ooK^00D0e3dI0?ofkP3om^h0
ooK^0=@m6@0B0?ofkP80e3dI3@3om^h00`000000ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^0080
ooK^00<0e3dI0?ofkP3om^h0503om^h00`3D?AT0ooK^0?ofkP0B0?ofkP030000003om^h0ooK^03`0
ooK^0@3oool003h0ooK^00<000000?ofkP3om^h04P3om^h00`3D?AT0ooK^0?ofkP0D0?ofkP030=@m
6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h00P3om^h00`000000ooK^0?ofkP0;0?ofkP80e3dI
4P3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00l0ooK^00<0e3dI0?ofkP3om^h00P0000001`0A6Ch0
00000000003D?AT05b=E0000000G8eD00P0000001@0O<W00000001lbL00O<W00000000<0iD4K00<0
?EV[0>E16`3U@A/00P3U@A/00`000000iD4K03eIZ`060>E16`0303eIZ`3U@A/0iD4K00H0iD4K00<0
00000>E16`3U@A/0103U@A/00`0mFJ/000000>E16`070>E16`030000003U@A/0iD4K00D0iD4K00<0
?EV[0>E16`3U@A/01P3U@A/00`000000iD4K0>E16`060>E16`0303eIZ`3U@A/0iD4K00D0iD4K00<0
00000>E16`3U@A/01P3U@A/00`000000?EV[0>E16`050>E16`030000003U@A/0iD4K00H0iD4K00<0
?EV[0>E16`3U@A/0103U@A/00`0mFJ/0iD4K000000030>E16`0303eIZ`3U@A/0iD4K0080iD4K00<0
000005AliP0000000P1DO>H200000004051ee`000000D7GG0=@m6@80000000<0AfVk000000000000
0P3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT04P3om^h20=@m6@d0
ooK^00<000000?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^01@0
ooK^00<0e3dI0?ofkP3om^h04P3om^h00`000000ooK^0?ofkP0l0?ofkP40oooo000o0?ofkP030000
003om^h0ooK^0140ooK^00<0e3dI0?ofkP3om^h0503om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m
6@3om^h0ooK^0080ooK^00<000000?ofkP3om^h02`3om^h20=@m6A80ooK^00D0e3dI0?ofkP3om^h0
ooK^0=@m6@0?0?ofkP030=@m6@3om^h0ooK^0080000000L04ATn000000000000e3dI01LSE@000000
5b=E008000000P0O<W000`0000007c9`01lbL0040000000303eIZ`000000000000@000000P0mFJ/4
0000000303eIZ`000000000000d0000000<0?EV[0000000000003`0000000`0mFJ/000000000000?
0000000303eIZ`000000000000l0000000<0?EV[0000000000003@0000000`0mFJ/0000000000002
00000080?EV[1P0000000`0mFJ/000000000000200000080E7cV00<0000005AliP1DO>H00P000000
101@MML00000051ee`3D?AT20000000304MY^`00000000000080ooK^00<0e3dI0?ofkP3om^h03@3o
m^h01@3D?AT0ooK^0?ofkP3om^h0e3dI0180ooK^0P3D?AT=0?ofkP030000003om^h0ooK^0080ooK^
00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP0D0?ofkP030=@m6@3om^h0ooK^0140ooK^
00<000000?ofkP3om^h0?@3om^h10?ooo`00?`3om^h00`000000ooK^0?ofkP0A0?ofkP030=@m6@3o
m^h0ooK^01@0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP020?ofkP030000003o
m^h0ooK^00/0ooK^0P3D?ATB0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT03`3om^h00`3D?AT0ooK^
0?ofkP0200000004014I?P00000000000=@m6@805b=E0P0000001P0O<W00000001lbL00O<W000000
01lbL08000000P3/@a`00`0mFJ/0k4<L0>a370030>a370030000003/@a`0k4<L0080?EV[0P3/@a`0
0`0mFJ/000000>a370060>a370030000003/@a`0k4<L00@0k4<L00<0?EV[0000003/@a`01`3/@a`0
0`000000k4<L0>a370050>a3700303eIZ`3/@a`0k4<L00H0k4<L00<000000>a3703/@a`01P3/@a`0
0`0mFJ/0k4<L0>a370050>a370030000003/@a`0k4<L00H0k4<L00<0000003eIZ`3/@a`01@3/@a`0
0`000000k4<L0>a370050>a370040000000mFJ/0k4<L0>a37080?EV[0P3/@a`00`000000k4<L0>a3
70030>a3700303eIZ`3/@a`0k4<L0080000000@0E7cV0000001DO>H0E7cV0P0000001@1@MML00000
051ee`1@MML0e3dI0080000000<0AfVk0000003om^h00P3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP05
0=@m6@3om^h0ooK^0?ofkP3D?AT04P3om^h20=@m6@d0ooK^00<000000?ofkP3om^h00P3om^h00`3D
?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^01@0ooK^00<0e3dI0?ofkP3om^h04@3om^h00`00
0000ooK^0?ofkP0m0?ofkP40oooo000o0?ofkP030000003om^h0ooK^0140ooK^00<0e3dI0?ofkP3o
m^h0503om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^0080ooK^00<000000?ofkP3o
m^h02`3om^h20=@m6A80ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0?0?ofkP050=@m6@3om^h0ooK^
0?ofkP0000000P0A6Ch00`000000e3dI0000000201LSE@80000000@07c9`0000000O<W007c9`0P00
0000100[@hh000000>a3700mFJ/50>a370030000003/@a`0k4<L0080k4<L0`0mFJ/00`000000k4<L
0>a370060>a370030000003/@a`0k4<L00<0k4<L00<0?EV[0>a3700000001`3/@a`00`000000k4<L
0>a370050>a3700303eIZ`3/@a`0k4<L00H0k4<L00<000000>a3703/@a`01P3/@a`00`0mFJ/0k4<L
0>a370050>a370030000003/@a`0k4<L00D0k4<L00<0000003eIZ`3/@a`01@3/@a`00`000000k4<L
0>a370060>a370040000000mFJ/0?EV[03eIZ`@0k4<L00<000000>a3703/@a`00`3/@a`0100mFJ/0
k4<L0000001EO^d200000080E7cV00@0000005AliP00000000000P1@MML01P000000e3dI03eIZ`17
JK/0000003eIZ`<0ooK^00<0e3dI0?ofkP3om^h03@3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI0180
ooK^0P3D?AT=0?ofkP030000003om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0
ooK^0?ofkP0D0?ofkP030=@m6@3om^h0ooK^0140ooK^00<000000?ofkP3om^h0?@3om^h10?ooo`00
@03om^h00`000000ooK^0?ofkP0@0?ofkP030=@m6@3om^h0ooK^01@0ooK^00<0e3dI0?ofkP3om^h0
0P3om^ho0=@m6@80000000@04ATn0000003D?AT000000P0G8eD20000000:01lbL00000007c9`01lb
L00000007c9`0000000[@hh0000003eIZ`H0k4<L00<000000>a3703/@a`00`3/@a`203eIZ`030000
003/@a`0k4<L00D0k4<L00<000000>a3703/@a`0103/@a`00`0mFJ/000000>a370070>a370030000
003/@a`0k4<L00@0k4<L00<0?EV[0>a3703/@a`01P3/@a`00`000000k4<L0>a370060>a3700303eI
Z`3/@a`0k4<L00@0k4<L00<000000>a3703/@a`01P3/@a`00`000000?EV[0>a370050>a370030000
003/@a`0k4<L00D0k4<L00<0000003eIZ`0mFJ/01@3/@a`00`000000k4<L0>a370040>a3700303eI
Z`000000EGk]008000000`1DO>H010000000E7cV000000000002051ee`040000003D?AT0000004MY
^`800000?`3D?AT40?ofkP030=@m6@3om^h0ooK^01@0ooK^00<0e3dI0?ofkP3om^h0403om^h00`00
0000ooK^0?ofkP0n0?ofkP40oooo00100?ofkP030000003om^h0ooK^0100ooK^KP3D?AT00`0mFJ/0
k4<L0>a370050>a370030000003/@a`0k4<L0080k4<L00<0?EV[0>a3700mFJ/00P0mFJ/60>a37003
0000003/@a`0k4<L00<0k4<L00<0?EV[0>a3700000001`3/@a`00`000000k4<L0>a370040>a37003
03eIZ`000000k4<L00H0k4<L00<000000>a3703/@a`01@3/@a`00`000000?EV[0>a370050>a37003
0000003/@a`0k4<L00D0k4<L00<000000>a3700mFJ/01@3/@a`00`000000k4<L0>a370040>a370<0
?EV[00<0k4<L03eIZ`3/@a`00`3/@a`00`000000k4<L0>a370050>a3700303eIZ`3D?AT0e3dI06`0
e3dI4P3om^h00`000000ooK^0?ofkP0n0?ofkP40oooo00100?ofkP030000003om^h0ooK^0100ooK^
00<0e3dI0?ofkP3om^h0503om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00<0ooK^
00<000000?ofkP3om^h02P3om^h20=@m6A80ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0?0?ofkP09
0=@m6@3om^h0ooK^0?ofkP000000?EV[0000000A6Ch0e3dI00805b=E00@0000001LSE@0000000000
0P0O<W00100000007c9`01lbL000000202]3SP030000003/@a`0k4<L00D0k4<L00<000000>a3703/
@a`00P3/@a`01@0mFJ/0k4<L0>a370000000k4<L00<0?EV[0`3/@a`00`000000k4<L0>a370030>a3
700303eIZ`3/@a`0000000L0k4<L00<000000>a3703/@a`0103/@a`00`0mFJ/000000>a370060>a3
70030000003/@a`0k4<L00D0k4<L00<0000003eIZ`3/@a`01@3/@a`00`000000k4<L0>a370050>a3
70030000003/@a`0?EV[00D0k4<L00@000000>a3703/@a`0k4<L0`0mFJ/01@3/@a`000000>a3703/
@a`0?EV[00@0k4<L00<000000>a3703/@a`01@3/@a`010000000EGk]05Enk@00000205AliP030000
001DO>H0E7cV0080000000T0D7GG0000001@MML0D7GG0=@m6@17JK/0000003eIZ`0000000`3om^h0
0`3D?AT0ooK^0?ofkP0=0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT04P3om^h20=@m6@`0ooK^00<0
00000?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^01@0ooK^00<0
e3dI0?ofkP3om^h0403om^h00`000000ooK^0?ofkP0n0?ofkP40oooo00100?ofkP030000003om^h0
ooK^0100ooK^00<0e3dI0?ofkP3om^h0503om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0
ooK^00<0ooK^00<000000?ofkP3om^h02P3om^h20=@m6A80ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m
6@0?0?ofkP040=@m6@3om^h0ooK^0?ofkP<0000000H04ATn0=@m6@0000005b=E0000000G8eD20000
00807c9`00<0000001lbL00O<W000P00000202]3SP030000003/@a`0k4<L00D0k4<L00D000000>a3
703/@a`0k4<L03eIZ`030>a370040000003/@a`0k4<L0>a37080?EV[0P3/@a`00`000000k4<L0>a3
70020>a3700303eIZ`3/@a`0000000L0k4<L00<000000>a3703/@a`0103/@a`00`0mFJ/000000>a3
70060>a370030000003/@a`0k4<L00D0k4<L00<0000003eIZ`3/@a`01@3/@a`00`000000k4<L0>a3
70050>a370030000003/@a`0?EV[00@0k4<L00<000000>a3703/@a`00P0mFJ/30>a370050000003/
@a`0k4<L0>a3700mFJ/00`3/@a`00`000000k4<L0>a370050>a370030000001EO^d0EGk]00800000
0P1DO>H00`000000E7cV05AliP0200000007051ee`000000D7GG0000003D?AT0000004MY^`020000
00<0ooK^00<0e3dI0?ofkP3om^h03@3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI0180ooK^0P3D?AT<
0?ofkP030000003om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP0D
0?ofkP030=@m6@3om^h0ooK^0100ooK^00<000000?ofkP3om^h0?P3om^h10?ooo`00@@3om^h00`00
0000ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^01@0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D
?AT0ooK^0?ofkP040?ofkP030000003om^h0ooK^00T0ooK^0P3D?ATB0?ofkP050=@m6@3om^h0ooK^
0?ofkP3D?AT03`3om^h0103D?AT0ooK^0?ofkP3om^h200000004014I?P000000e3dI000000805b=E
0P0000002@0O<W00000001lbL00O<W00000001lbL0000000:d>>0000000202]3SP030000003/@a`0
k4<L00D0k4<L00@000000>a3703/@a`0?EV[0`3/@a`00`000000k4<L0>a370030>a370<0?EV[103/
@a`0100mFJ/0k4<L0>a3700000070>a370030000003/@a`0k4<L00<0k4<L00<0?EV[0000003/@a`0
1P3/@a`00`000000k4<L0>a370050>a370030000000mFJ/0k4<L00@0k4<L00<000000>a3703/@a`0
1@3/@a`010000000k4<L0>a3700mFJ/40>a370<0?EV[1@3/@a`01@000000k4<L0>a3703/@a`0?EV[
0080k4<L00<000000>a3703/@a`01@3/@a`020000000EGk]05Enk@000000EGk]0000001DO>H00000
0P1DO>H010000000E7cV000000000002051ee`050000003D?AT0000003eIZ`000000103om^h00`3D
?AT0ooK^0?ofkP0=0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT04P3om^h20=@m6@/0ooK^00<00000
0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^01@0ooK^00<0e3dI
0?ofkP3om^h03`3om^h00`000000ooK^0?ofkP0o0?ofkP40oooo00110?ofkP030000003om^h0ooK^
00l0ooK^00<0e3dI0?ofkP3om^h0503om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^
00@0ooK^00<000000?ofkP3om^h02@3om^h20=@m6A80ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0?
0?ofkP030=@m6@3om^h0ooK^0080ooK^00L0000003eIZ`000000e3dI01LSE@0000005b=E00800000
0P0O<W001`0000007c9`01lbL00O<W00000002]3SP0000000`0[@hh00`000000k4<L0>a370050>a3
70030000003/@a`0?EV[00@0k4<L00<000000>a3703/@a`01@3/@a`303eIZ`050>a3700mFJ/0k4<L
0>a3700000001`3/@a`00`000000k4<L0>a370030>a3700303eIZ`000000k4<L00H0k4<L00<00000
0>a3703/@a`01@3/@a`00`000000?EV[0>a370040>a370030000003/@a`0k4<L00D0k4<L00D00000
0>a3703/@a`0?EV[0>a3700303eIZ`L0k4<L00<000000>a3703/@a`00P3/@a`00`0mFJ/0k4<L0000
00070>a370040000001EO^d0EGk]00000080EGk]00D0000005AliP1DO>H0E7cV0000000205AliP80
000000L0D7GG000000000000e3dI04MY^`0mFJ/0000000@0ooK^00<0e3dI0?ofkP3om^h03@3om^h0
1@3D?AT0ooK^0?ofkP3om^h0e3dI0180ooK^0P3D?AT;0?ofkP030000003om^h0ooK^00@0ooK^00<0
e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP0D0?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0
00000?ofkP3om^h0?`3om^h10?ooo`00@@3om^h00`000000ooK^0?ofkP0?0?ofkP030=@m6@3om^h0
ooK^01@0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP040?ofkP030000003om^h0
ooK^00T0ooK^0P3D?ATB0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT03`3om^h00`3D?AT0ooK^0?of
kP020?ofkP80000000@04ATn0=@m6@00000000000P0G8eD01P0000007c9`01lbL00O<W00000001lb
L08000000P0[@hh01@000000:d>>02]3SP0[@hh0000000H0k4<L00<000000>a3700mFJ/01@3/@a`0
0`000000k4<L0>a370040>a370030000003/@a`0k4<L00@0?EV[00<000000>a3703/@a`01@3/@a`0
0`000000k4<L0>a370030>a3700303eIZ`000000k4<L00H0k4<L00<000000>a3703/@a`01@3/@a`0
0`000000?EV[0>a370040>a370030000003/@a`0k4<L00D0k4<L00<0000003eIZ`0mFJ/00P0mFJ/2
0>a370030000003/@a`0k4<L00@0k4<L00<000000>a3703/@a`00`3/@a`01@0mFJ/0k4<L0000003/
@a`0e3dI00@0k4<L00D0000005Enk@1EO^d0EGk]0000000205Enk@80000000<0E7cV0000001DO>H0
0P1DO>H00`000000D7GG051ee`02000000040=@m6@17JK/00000000000@0ooK^00<0e3dI0?ofkP3o
m^h03@3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI0180ooK^0P3D?AT;0?ofkP030000003om^h0ooK^
00@0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP0D0?ofkP030=@m6@3om^h0ooK^
00l0ooK^00<000000?ofkP3om^h0?`3om^h10?ooo`00@P3om^h00`000000ooK^0?ofkP0>0?ofkP03
0=@m6@3om^h0ooK^01@0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@070?ofkP030000003om^h0ooK^
00T0ooK^00<0e3dI0?ofkP3om^h04@3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00l0ooK^00<0e3dI
0?ofkP3om^h00P3om^h200000006014I?P3D?AT0000001LSE@0000005b=E0P00000201lbL0040000
000O<W007c9`000000<0:d>>00@0000002]3SP0[@hh000001`3/@a`00`000000?EV[0>a370040>a3
70030000003/@a`0k4<L00D0k4<L00@000000>a3703/@a`0?EV[0P3/@a`603eIZ`80k4<L00<00000
0>a3703/@a`00`3/@a`00`0mFJ/0k4<L000000060>a370030000003/@a`0k4<L00@0k4<L00<00000
0>a3700mFJ/01@3/@a`00`000000k4<L0>a3700603eIZ`80k4<L00@0?EV[0>a3703/@a`000001`3/
@a`00`000000k4<L0>a370020>a3700303eIZ`3/@a`0000000L0k4<L00@0000005Enk@1EO^d00000
0`1EO^d010000000E7cV05AliP00000205AliP80000000H0D7GG0000001@MML000000=@m6@0mFJ/2
000000@0ooK^00<0e3dI0?ofkP3om^h03@3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI0180ooK^0P3D
?AT;0?ofkP030000003om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?of
kP0D0?ofkP030=@m6@3om^h0ooK^00h0ooK^00<000000?ofkP3om^h0@03om^h10?ooo`00@P3om^h0
0`000000ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^01@0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m
6@080?ofkP030000003om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h04@3om^h01@3D?AT0ooK^0?of
kP3om^h0e3dI00l0ooK^00<0e3dI0?ofkP3om^h00P3om^h20000000303eIZ`3D?AT0000000805b=E
0P0000001P0O<W00000001lbL00O<W00000001lbL08000000`0[@hh010000000:d>>02]3SP000007
0>a370030000000mFJ/0k4<L00@0k4<L00<000000>a3703/@a`0103/@a`010000000k4<L0>a3700m
FJ/30>a370030000003/@a`0k4<L0080k4<L1P0mFJ/20>a3700303eIZ`3/@a`0000000H0k4<L00<0
00000>a3703/@a`0103/@a`00`000000k4<L03eIZ`020>a370H0?EV[103/@a`01@000000k4<L0>a3
703/@a`0?EV[0080k4<L00<000000>a3703/@a`0103/@a`00`000000k4<L0>a370030>a3700303eI
Z`000000k4<L00H0k4<L00@0000005Enk@1EO^d000000`1EO^d20000000605AliP000000E7cV05Al
iP000000E7cV0P000002051ee`030000003D?AT0?EV[00800000103om^h00`3D?AT0ooK^0?ofkP0=
0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT04`3om^h00`3D?AT0ooK^0?ofkP080?ofkP030000003o
m^h0ooK^00H0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0F0?ofkP030=@m6@3om^h0ooK^00h0ooK^
00<000000?ofkP3om^h0@03om^h10?ooo`00@P3om^h00`000000ooK^0?ofkP0>0?ofkP030=@m6@3o
m^h0ooK^01@0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@080?ofkP030000003om^h0ooK^00P0ooK^
00<0e3dI0?ofkP3om^h04@3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00l0ooK^00<0e3dI0?ofkP3o
m^h00P3om^h3000000040=@m6@000000000001LSE@80000000<07c9`0000000O<W000P0O<W020000
000302]3SP000000:d>>0080:d>>00@0000002]3SP0[@hh000001P3/@a`00`000000?EV[0>a37004
0>a370030000003/@a`0k4<L00D0k4<L00<000000>a3700mFJ/0103/@a`00`000000k4<L0>a37004
0>a370030000003/@a`0k4<L01L0?EV[0P3/@a`00`000000k4<L0>a370040>a370030000003/@a`0
k4<L0080k4<L00<0?EV[0>a3700000001`3/@a`00`000000k4<L0>a370030>a3700303eIZ`000000
k4<L00D0k4<L00@0000005Enk@1EO^d000000`1EO^d010000000EGk]00000000000305AliP800000
00<0D7GG0000001@MML00P000000103D?AT000000000000000040?ofkP030=@m6@3om^h0ooK^00d0
ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0B0?ofkP80e3dI2P3om^h00`000000ooK^0?ofkP060?of
kP040=@m6@3om^h0ooK^0=@m6AH0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`000000ooK^0?ofkP10
0?ofkP40oooo00130?ofkP030000003om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h0503om^h0103D
?AT0ooK^0?ofkP3D?AT80?ofkP/000000P3D?ATB000000050=@m6@00000000000000003D?AT03`00
00000`3D?AT000000000000400000004014I?P3D?AT00000000000805b=E0P0000000`0O<W000000
01lbL00301lbL0030000000[@hh0000000<0:d>>00<0000002]3SP0[@hh01`0000000`0mFJ/00000
0000000=0000000303eIZ`000000000000h0000000<0?EV[0000000000003`0000000`0mFJ/00000
0000000>0000000303eIZ`000000000000d0000000<0?EV[0000000000001@00000205Enk@070000
001EO^d0EGk]05Enk@000000EGk]0000000405AliP040000001DO>H0000000000080D7GG0P000000
0`3D?AT0AfVk00000005000000030=@m6@000000000000d0000000D0e3dI00000000000000000=@m
6@0B00000080e3dI2`0000080?ofkP040=@m6@3om^h0ooK^0=@m6AH0ooK^00<0e3dI0?ofkP3om^h0
3P3om^h00`000000ooK^0?ofkP110?ofkP40oooo00130?ofkP030000003om^h0ooK^00h0ooK^00<0
e3dI0?ofkP3om^h0503om^h0103D?AT0ooK^0?ofkP3D?AT80?ofkP030000003om^h0ooK^00P0ooK^
0P3D?ATB0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT03`3om^h00`3D?AT0ooK^0?ofkP020?ofkP80
000000H04ATn0=@m6@0000005b=E0000000G8eD2000000807c9`00<0000001lbL00O<W000P000002
02]3SP040000000[@hh0:d>>00000080:d>>0P0000050?957@0303eIZ`000000lTDM00D0lTDM00<0
00000?957@3bAAd00`3bAAd00`000000lTDM03eIZ`040?957@030000003bAAd0lTDM00@0lTDM00<0
00000?957@3bAAd00P3bAAd00`0mFJ/0lTDM000000060?957@030000003bAAd0lTDM00@0lTDM00<0
00000?957@0mFJ/0103bAAd00`000000lTDM0?957@040?957@030000003bAAd0lTDM0080lTDM00<0
?EV[0000003bAAd01@3bAAd00`000000lTDM0?957@040?957@030000000mFJ/0lTDM00@0lTDM0P00
00000`1EO^d0000005Enk@0205Enk@030000001EO^d0EGk]008000000P1DO>H00`000000E7cV05Al
iP0200000006051ee`000000D7GG0000003D?AT0AfVk0P0000040?ofkP030=@m6@3om^h0ooK^00d0
ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0B0?ofkP80e3dI2P3om^h00`000000ooK^0?ofkP060?of
kP040=@m6@3om^h0ooK^0=@m6AH0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`000000ooK^0?ofkP11
0?ofkP40oooo00130?ofkP030000003om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h0503om^h0103D
?AT0ooK^0?ofkP3D?AT80?ofkP030000003om^h0ooK^00P0ooK^0P3D?ATB0?ofkP050=@m6@3om^h0
ooK^0?ofkP3D?AT03`3om^h00`3D?AT0ooK^0?ofkP020?ofkP<0000000L0e3dI0000000G8eD05b=E
0000000G8eD0000000<07c9`00@0000001lbL00O<W0000000`0[@hh02@000000:d>>02]3SP000000
:d>>0000000dD:H0000003eIZ`030?957@0303eIZ`3bAAd0000000D0lTDM00<000000?957@3bAAd0
103bAAd00`000000?EV[0?957@040?957@030000003bAAd0lTDM00<0lTDM00<000000?957@3bAAd0
0P3bAAd00`0mFJ/0lTDM000000060?957@030000003bAAd0lTDM00@0lTDM00<000000?957@0mFJ/0
0`3bAAd00`000000lTDM0?957@040?957@030000003bAAd0lTDM00<0lTDM00<0?EV[0000003bAAd0
1@3bAAd00`000000lTDM0?957@030?957@030000003bAAd0?EV[00<0lTDM00H0?EV[0000001DONh0
000005Enk@00000205Enk@050000001EO^d0EGk]05Enk@0000000P1DO>H01`000000E7cV05AliP1D
O>H00000051ee`0000000P1@MML00`000000e3dI00000002000000@0ooK^00<0e3dI0?ofkP3om^h0
3@3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI0180ooK^0P3D?AT:0?ofkP030000003om^h0ooK^00H0
ooK^00@0e3dI0?ofkP3om^h0e3dI5P3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030000003om^h0ooK^
0440ooK^0@3oool004@0ooK^00<000000?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0D0?ofkP04
0=@m6@3om^h0ooK^0=@m6@P0ooK^00<000000?ofkP3om^h0203om^h20=@m6A80ooK^00D0e3dI0?of
kP3om^h0ooK^0=@m6@0?0?ofkP030=@m6@3om^h0ooK^0080ooK^0`0000001P3D?AT0000001LSE@0G
8eD0000001LSE@8000000`0O<W00100000007c9`00000000000202]3SP040000000[@hh0:d>>02]3
SP80000000<0=52V0=@m6@0000000P0mFJ/0103bAAd0?EV[0?957@0000060?957@030000003bAAd0
lTDM00<0lTDM00<0000003eIZ`3bAAd0103bAAd00`000000lTDM0?957@040?957@070000003bAAd0
lTDM0?957@0mFJ/0lTDM000000060?957@030000003bAAd0lTDM00<0lTDM00@000000?957@3bAAd0
?EV[0`3bAAd00`000000lTDM0?957@040?957@030000003bAAd0lTDM00<0lTDM00<0?EV[0?957@3b
AAd0103bAAd00`000000lTDM0?957@030?957@050000003bAAd0lTDM03eIZ`3bAAd00P0mFJ/00`00
0000e3dI05AmkP02000000<0EGk]00<0000005Enk@1EO^d00P0000000`1DO>H0000005AliP0205Al
iP80000000H0D7GG0000001@MML0D7GG0000003D?AT3000000@0ooK^00<0e3dI0?ofkP3om^h03@3o
m^h01@3D?AT0ooK^0?ofkP3om^h0e3dI0180ooK^0P3D?AT:0?ofkP030000003om^h0ooK^00H0ooK^
00@0e3dI0?ofkP3om^h0e3dI5P3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030000003om^h0ooK^0480
ooK^0@3oool004@0ooK^00<000000?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0D0?ofkP030=@m
6@3om^h0ooK^0440e3dI00@0000000/@9P000000e3dI0P00000201LSE@80000000T07c9`0000000O
<W007c9`0000000O<W00000002]3SP0000000P0[@hh02P000000:d>>02]3SP0[@hh0000003A@YP3D
?AT0=52V0000003bAAd303eIZ`030?957@000000lTDM00D0lTDM00<000000?957@3bAAd00`3bAAd0
0`0mFJ/0lTDM0?957@040?957@030000003bAAd0lTDM00<0lTDM00D000000?957@3bAAd0lTDM03eI
Z`020?957@030000003bAAd0lTDM00<0lTDM00<000000?957@3bAAd00`3bAAd010000000lTDM0?95
7@0mFJ/30?957@030000003bAAd0lTDM00<0lTDM00<000000?957@3bAAd0103bAAd00`0mFJ/0lTDM
0?957@030?957@030000003bAAd0lTDM00@0lTDM00<000000?957@0mFJ/00P0mFJ/01P3bAAd00000
05AmkP3D?AT0E7g^000000<0EGk]00P0000005Enk@1EO^d0000005Enk@000000E7cV00000080E7cV
00@0000005AliP00000000000P1@MML2000000040=@m6@000000>UFC00000440e3dI0P3om^h00`3D
?AT0ooK^0?ofkP0D0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<000000?ofkP3om^h0@P3om^h10?oo
o`00A03om^h00`000000ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^01@0ooK^00@0e3dI0?ofkP3o
m^h0e3dI1`3om^h00`000000ooK^0?ofkP090?ofkP80e3dI4P3om^h01@3D?AT0ooK^0?ofkP3om^h0
e3dI00l0ooK^00<0e3dI0?ofkP3om^h00P3om^h0100000002a0V0000003D?AT2000000<05b=E0P00
0000100O<W00000001lbL00O<W0200000080:d>>00@0000002]3SP0[@hh000000P0[@hh200000007
0=@m6@0dD:H0=52V0000003bAAd0?EV[0?957@0203eIZ`030000003bAAd0lTDM00<0lTDM00<00000
0?957@3bAAd00`3bAAd00`0mFJ/0lTDM0?957@040?957@030000003bAAd0lTDM00<0lTDM00D00000
0?957@3bAAd0lTDM03eIZ`020?957@030000003bAAd0lTDM00<0lTDM00<000000?957@3bAAd00`3b
AAd010000000lTDM0?957@0mFJ/30?957@030000003bAAd0lTDM00<0lTDM00<000000?957@3bAAd0
0`3bAAd00`000000?EV[0?957@040?957@030000003bAAd0lTDM00<0lTDM00L0000003eIZ`0mFJ/0
lTDM03eIZ`3bAAd000000080E7g^00<0e3dI0000000000000P1EO^d010000000EGk]05Enk@000002
05Enk@8000000P1DO>H010000000E7cV000000000003051ee`80000000@0e3dI0000000jEI<00000
103om^h00`3D?AT0ooK^0?ofkP0=0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT04P3om^h20=@m6@/0
ooK^00<000000?ofkP3om^h01@3om^h0103D?AT0ooK^0?ofkP3D?ATF0?ofkP030=@m6@3om^h0ooK^
00d0ooK^00<000000?ofkP3om^h0@P3om^h10?ooo`00A@3om^h00`000000ooK^0?ofkP0<0?ofkP03
0=@m6@3om^h0ooK^01@0ooK^00@0e3dI0?ofkP3om^h0e3dI1`3om^h00`000000ooK^0?ofkP090?of
kP80e3dI4P3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00l0ooK^00<0e3dI0?ofkP3om^h00P3om^h3
000000040=@m6@0000005b=E000000805b=E0P00000201lbL0040000000O<W007c9`000000<0:d>>
00P0000002]3SP0[@hh0000002]3SP000000=52V0=@m6@80=52V00@000000?957@3bAAd0?EV[0P3b
AAd303eIZ`@0lTDM00<000000?957@3bAAd00P3bAAd00`0mFJ/000000?957@040?957@030000003b
AAd0lTDM00<0lTDM00D000000?957@3bAAd0lTDM03eIZ`020?957@030000003bAAd0lTDM00<0lTDM
00<000000?957@3bAAd00`3bAAd010000000lTDM0?957@0mFJ/20?957@030000003bAAd0lTDM00<0
lTDM00<000000?957@3bAAd0103bAAd00`000000?EV[0?957@030?957@030000003bAAd0lTDM0080
lTDM0`0mFJ/20?957@0303eIZ`3bAAd0000000<0E7g^00D0e3dI05AmkP000000EGk]0000000205En
k@050000001EO^d0EGk]05Enk@0000000P1DO>H00`000000E7cV05AliP0200000080D7GG0`000000
0`3D?AT00000000000050?ofkP030=@m6@3om^h0ooK^00d0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m
6@0B0?ofkP80e3dI2`3om^h00`000000ooK^0?ofkP050?ofkP040=@m6@3om^h0ooK^0=@m6AH0ooK^
00<0e3dI0?ofkP3om^h0303om^h00`000000ooK^0?ofkP130?ofkP40oooo00150?ofkP030000003o
m^h0ooK^00`0ooK^N`3D?AT00`3bAAd0?EV[0?957@030?957@040000000mFJ/0?EV[03eIZ`80lTDM
00H000000?957@3bAAd0lTDM03eIZ`0000060?957@030000003bAAd0lTDM00<0lTDM00@000000?95
7@3bAAd0?EV[0P3bAAd00`000000lTDM0?957@030?957@030000003bAAd0lTDM00<0lTDM00@00000
0?957@3bAAd0?EV[0P3bAAd00`000000lTDM0?957@030?957@030000003bAAd0lTDM00<0lTDM00<0
00000?957@0mFJ/00`3bAAd00`000000lTDM0?957@0303eIZ`030000003bAAd0lTDM0080lTDM00<0
?EV[0?957@3D?AT0NP3D?AT>0?ofkP030000003om^h0ooK^04<0ooK^0@3oool004D0ooK^00<00000
0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP0D0?ofkP040=@m6@3om^h0ooK^0=@m6@L0ooK^00<0
00000?ofkP3om^h02@3om^h20=@m6A80ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0?0?ofkP030=@m
6@3om^h0ooK^00<0ooK^0P0000001@3D?AT04ATn0000000G8eD0000000805b=E0P00000201lbL005
0000000O<W00000002]3SP0000000`0[@hh020000000:d>>02]3SP000000=52V0=@m6@0dD:H00000
0P0dD:H00`000000lTDM0?957@040?957@030000003bAAd0lTDM0080?EV[00L000000?957@3bAAd0
lTDM03eIZ`3bAAd0000000D0lTDM00<000000?957@3bAAd00`3bAAd010000000lTDM0?957@0mFJ/2
0?957@030000003bAAd0lTDM00<0lTDM00<000000?957@3bAAd00`3bAAd010000000lTDM0?957@0m
FJ/20?957@030000003bAAd0lTDM00<0lTDM00<000000?957@3bAAd00`3bAAd00`000000lTDM03eI
Z`030?957@030000000mFJ/0?EV[0080lTDM00<000000?957@3bAAd0103bAAd020000000E7g^05Am
kP000000E7g^0=@m6@1DONh000000P1EO^d02@000000EGk]05Enk@1EO^d0000005Enk@000000E7cV
0000000205AliP8000000P1@MML01@000000D7GG00000017JK/0e3dI008000001@3om^h00`3D?AT0
ooK^0?ofkP0=0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT04P3om^h20=@m6@/0ooK^00<000000?of
kP3om^h01@3om^h0103D?AT0ooK^0?ofkP3D?ATF0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<00000
0?ofkP3om^h0@`3om^h10?ooo`00AP3om^h00`000000ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^
01@0ooK^00@0e3dI0?ofkP3om^h0e3dI1`3om^h00`000000ooK^0?ofkP090?ofkP80e3dI4P3om^h0
1@3D?AT0ooK^0?ofkP3om^h0e3dI00l0ooK^00<0e3dI0?ofkP3om^h00`3om^h2000000030=@m6@0A
6Ch0000000805b=E00D0000001LSE@0000007c9`0000000201lbL0050000000O<W00000002]3SP00
00000`0[@hh01@000000:d>>000000000000e3dI0080=52V00@0000003A@YP0dD:H000001@3bAAd0
0`000000lTDM0?957@020?957@<0?EV[00@0lTDM03eIZ`3bAAd000001P3bAAd00`000000lTDM0?95
7@020?957@040000003bAAd0lTDM03eIZ`80lTDM00<000000?957@3bAAd00`3bAAd00`000000lTDM
0?957@020?957@050000003bAAd0lTDM0?957@0mFJ/00P3bAAd00`000000lTDM0?957@020?957@03
0000003bAAd0lTDM00<0lTDM00D000000?957@3bAAd0?EV[0?957@0303eIZ`<0lTDM00<000000?95
7@3bAAd0103bAAd010000000E7g^05AmkP00000205AmkP050=@m6@000000000005Enk@0000000`1E
O^d01@000000EGk]0000001DO>H000000080E7cV00D0000005AliP000000D7GG00000002051ee`03
00000017JK/0e3dI008000001@3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP050=@m6@3om^h0ooK^0?of
kP3D?AT04P3om^h20=@m6@/0ooK^00<000000?ofkP3om^h01@3om^h0103D?AT0ooK^0?ofkP3D?ATF
0?ofkP030=@m6@3om^h0ooK^00/0ooK^00<000000?ofkP3om^h0A03om^h10?ooo`00AP3om^h00`00
0000ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^01@0ooK^00@0e3dI0?ofkP3om^h0e3dI1`3om^h0
0`000000ooK^0?ofkP090?ofkP80e3dI4P3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00l0ooK^00<0
e3dI0?ofkP3om^h00`3om^h2000000040=@m6@0000000000000000805b=E0P00000201lbL0030000
000O<W007c9`008000000P0[@hh010000000:d>>02]3SP0[@hh20000000303A@YP3D?AT0=52V0080
=52V00@0000003A@YP0dD:H000001@3bAAd00`000000lTDM0?957@030?957@030000000mFJ/0?EV[
0080?EV[00<000000?957@3bAAd00`3bAAd00`000000lTDM0?957@020?957@040000003bAAd0lTDM
03eIZ`<0lTDM00<000000?957@3bAAd00P3bAAd00`000000lTDM0?957@020?957@070000003bAAd0
lTDM0?957@0mFJ/0lTDM000000050?957@030000003bAAd0lTDM00<0lTDM00<0000003eIZ`0mFJ/0
0P0mFJ/00`000000lTDM0?957@030?957@030000003bAAd0lTDM00<0lTDM00@0000005AmkP1DONh0
00000`1DONh0103D?AT0000005Enk@00000305Enk@030000001EO^d0EGk]008000000P1DO>H00`00
0000E7cV05AliP0200000080D7GG0`0000000`3D?AT00000000000050?ofkP030=@m6@3om^h0ooK^
00d0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0B0?ofkP80e3dI2`3om^h00`000000ooK^0?ofkP05
0?ofkP040=@m6@3om^h0ooK^0=@m6AH0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`000000ooK^0?of
kP140?ofkP40oooo00160?ofkP030000003om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h05@3om^h2
0=@m6@P0ooK^00<000000?ofkP3om^h0203om^h00`3D?AT0ooK^0=@m6@0A0?ofkP030=@m6@3om^h0
ooK^0080ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP040?ofkP80000000@0e3dI
00000000000000000P0G8eD2000000807c9`00D0000001lbL00O<W007c9`0000000302]3SP800000
0P0[@hh2000000030=@m6@00000000000080=52V00@0000003A@YP0dD:H000001@3bAAd00`000000
lTDM0?957@020?957@030000003bAAd0?EV[0080lTDM1P0mFJ/00`3bAAd000000?957@030?957@03
0000003bAAd0?EV[00<0lTDM00<000000?957@3bAAd00P3bAAd00`000000lTDM0?957@020?957@07
0000003bAAd0lTDM0?957@0mFJ/0lTDM000000040?957@030000003bAAd0?EV[00D0?EV[0P3bAAd0
0`0mFJ/0lTDM000000040?957@030000003bAAd0lTDM00<0lTDM00@0000005AmkP1DONh000000P1D
ONh2000000030=@m6@00000000000080EGk]0P00000305Enk@040000001DO>H0E7cV000000<0E7cV
0P0000000`1@MML00000051ee`02000000030=@m6@000000000000H0ooK^00<0e3dI0?ofkP3om^h0
303om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3D?AT0
2P3om^h00`000000ooK^0?ofkP060?ofkP80e3dI5`3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030000
003om^h0ooK^04@0ooK^0@3oool004L0ooK^00<000000?ofkP3om^h02P3om^h00`3D?AT0ooK^0?of
kP0E0?ofkP80e3dI203om^h00`000000ooK^0?ofkP080?ofkP030=@m6@3om^h0e3dI0140ooK^00<0
e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00@0ooK^0P00
00001@3D?AT04ATn0000000G8eD0000000805b=E00D0000001lbL00O<W007c9`0000000201lbL080
0000100[@hh01@000000:d>>02]3SP000000e3dI0080=52V00@0000003A@YP0dD:H000000P0dD:H<
0000000303eIZ`000000000000H000001P0mFJ/20000000303eIZ`000000000000l0000000<0?EV[
0000000000001P0mFJ/80000000303eIZ`000000000000X000000P1DONh010000000E7g^05AmkP00
000205AmkP050=@m6@000000EGk]05Enk@000000101EO^d200000080E7cV00D0000005AliP1DO>H0
E7cV00000002051ee`<0000000<0AfVk0=@m6@0000001`3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP03
0=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0=@m6@0:0?ofkP03
0000003om^h0ooK^00H0ooK^0P3D?ATG0?ofkP030=@m6@3om^h0ooK^00X0ooK^00<000000?ofkP3o
m^h0A@3om^h10?ooo`00A`3om^h00`000000ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^01D0ooK^
0P3D?AT70?ofkP030000003om^h0ooK^00T0ooK^00<0e3dI0?ofkP3D?AT04@3om^h00`3D?AT0ooK^
0?ofkP020?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h01@3om^h020000000e3dI
014I?P0mFJ/0000001LSE@0000005b=E0P00000301lbL0050000000O<W00000002]3SP000000100[
@hh010000000:d>>0000003D?AT303A@YP050000000dD:H0=52V0000000dD:H00P0000050?Q87P03
0000003hB1h0n4PN0080n4PN00<0?EV[0?Q87P3hB1h00P3hB1h00`000000n4PN0?Q87P020?Q87P03
0000003hB1h0n4PN0080n4PN5`0mFJ/40?Q87P030000003hB1h0n4PN0080n4PN00<000000?Q87P3h
B1h00P3hB1h00`0mFJ/0n4PN0?Q87P020?Q87P030000003hB1h0n4PN00<0n4PN0P0000001@1DONh0
000005AmkP1DONh0000000<0E7g^00@0e3dI0000001EO^d00000101EO^d01@000000EGk]0000001D
O>H0000000<0E7cV0P0000000`1@MML00000051ee`020000000304MY^`3D?AT0000000L0ooK^00<0
e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0
e3dI0?ofkP3D?AT02`3om^h00`000000ooK^0?ofkP050?ofkP80e3dI5`3om^h00`3D?AT0ooK^0?of
kP0:0?ofkP030000003om^h0ooK^04D0ooK^0@3oool004L0ooK^00<000000?ofkP3om^h02P3om^h0
0`3D?AT0ooK^0?ofkP0E0?ofkP80e3dI1`3om^h00`000000ooK^0?ofkP090?ofkP030=@m6@3om^h0
e3dI0140ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0
ooK^00D0ooK^00D000000=@m6@0A6Ch04ATn0000000201LSE@80000000<07c9`0000000O<W000P0O
<W0200000080:d>>00<0000002]3SP0[@hh00P0[@hh2000000030=@m6@00000000000080=52V00<0
000003A@YP0dD:H00P0000000`0lFkT000000?Q87P040?Q87P060000003hB1h0n4PN0?Q87P0mFJ/0
00000`3hB1h00`000000n4PN0?Q87P030?Q87P030000003hB1h0n4PN0080n4PN00<0000003eIZ`3h
B1h00P3hB1h00`000000n4PN0?Q87P020?Q87P030000003hB1h0n4PN0080n4PN00H000000?Q87P3h
B1h0n4PN03eIZ`0000040?Q87P030000003hB1h0n4PN00<0n4PN00H000000?Q87P3hB1h0n4PN0000
000mFJ/30?Q87P030000003hB1h0n4PN00<0n4PN00@00000059jj`00000000000P1DONh00`000000
E7g^05AmkP02000000030=@m6@000000000000@0EGk]00<0000005Enk@1EO^d00P00000305AliP04
0000001DO>H0000000000080D7GG00D0000004MY^`17JK/0e3dI000000070?ofkP030=@m6@3om^h0
ooK^00`0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0
e3dI00/0ooK^00<000000?ofkP3om^h01@3om^h20=@m6AL0ooK^00<0e3dI0?ofkP3om^h02P3om^h0
0`000000ooK^0?ofkP150?ofkP40oooo00180?ofkP030000003om^h0ooK^00X0ooK^00<0e3dI0?of
kP3om^h0503om^h20=@m6@L0ooK^00<000000?ofkP3om^h02@3om^h0103D?AT0ooK^0?ofkP3D?AT@
0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP05
0?ofkP80000000<0e3dI014I?P0000000P0G8eD01@0000005b=E0000000O<W00000000<07c9`00@0
000002]3SP0[@hh0:d>>0P00000302]3SP050000003D?AT0=52V03A@YP0000000P0dD:H010000000
=52V03A@YP00000203aK^@030000003hB1h0n4PN00<0n4PN00D000000?Q87P3hB1h0n4PN03eIZ`04
0?Q87P030000003hB1h0n4PN0080n4PN00<000000?Q87P3hB1h00P3hB1h00`000000?EV[0?Q87P02
0?Q87P030000003hB1h0n4PN0080n4PN00<000000?Q87P3hB1h00P3hB1h01P000000n4PN0?Q87P3h
B1h0?EV[000000@0n4PN00<000000?Q87P3hB1h00P3hB1h00`000000n4PN0?Q87P020?Q87P0503eI
Z`3hB1h0n4PN0?Q87P0000001@3hB1h010000000DW[[059jj`00000205AmkP040000001DONh0E7g^
00000080E7g^00<0e3dI0000001EO^d00P1EO^d2000000<0EGk]00H0000005AliP1DO>H0E7cV0000
001DO>H2000000<0D7GG00<0000004MY^`3D?AT00P0000070?ofkP030=@m6@3om^h0ooK^00/0ooK^
00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP040=@m6@3om^h0ooK^0=@m6@/0
ooK^00<000000?ofkP3om^h01@3om^h20=@m6AH0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`000000
ooK^0?ofkP160?ofkP40oooo00180?ofkP030000003om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h0
503om^h20=@m6@L0ooK^00<000000?ofkP3om^h02@3om^h0103D?AT0ooK^0?ofkP3D?AT@0?ofkP03
0=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP050?ofkP80
000000@0e3dI014I?P00000000000P0G8eD2000000807c9`00<0000003eIZ`0O<W000P00000402]3
SP050000000[@hh0:d>>0000003D?AT00P0dD:H0100mFJ/0000003A@YP0dD:H400000080?5^i00<0
00000?Q87P3hB1h00`3hB1h01@000000n4PN0?Q87P0mFJ/0000000@0n4PN00<000000?Q87P3hB1h0
0P3hB1h01P000000n4PN0?Q87P3hB1h0000003eIZ`<0n4PN00<000000?Q87P3hB1h00P3hB1h00`00
0000n4PN0?Q87P020?Q87P060000003hB1h0n4PN0?Q87P0mFJ/000000`3hB1h00`000000n4PN0?Q8
7P020?Q87P030000003hB1h0n4PN0080n4PN00D0000003eIZ`3hB1h0n4PN000000050?Q87P030000
001BN^/0DW[[00@000000P1DONh01P000000?EV[05AmkP1DONh0e3dI00000080EGk]00<0000005En
k@1EO^d00P1EO^d200000080E7cV00<0000005AliP1DO>H00P000002051ee`80000000@0AfVk0=@m
6@00000000001`3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI
0?ofkP3om^h03P3om^h0103D?AT0ooK^0?ofkP3D?AT;0?ofkP030000003om^h0ooK^00D0ooK^0P3D
?ATF0?ofkP030=@m6@3om^h0ooK^00X0ooK^00<000000?ofkP3om^h0AP3om^h10?ooo`00B03om^h0
0`000000ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^01@0ooK^A@3D?AT2000000040=@m6@0A6Ch0
0000000000<05b=E00P0000001lbL00O<W007c9`0000000mFJ/0000002]3SP8000000`0[@hh01000
0000:d>>0000003D?AT200000080=52V00@0000003A@YP0dD:H0=52V100000000`0lFkT000000?Q8
7P040?Q87P050000003hB1h0?EV[0?Q87P0000000`3hB1h00`000000n4PN0?Q87P020?Q87P030000
003hB1h0n4PN0080n4PN00D0?EV[0?Q87P3hB1h0n4PN000000040?Q87P030000003hB1h0n4PN0080
n4PN00D000000?Q87P3hB1h0n4PN03eIZ`040?Q87P030000003hB1h0n4PN0080n4PN00T000000?Q8
7P3hB1h0n4PN0000003hB1h0?EV[0?Q87P0000001@3hB1h00`000000DW[[00000003000000<0E7g^
00<0000005AmkP1DONh00P000000103D?AT0000005Enk@00000305Enk@80000000@0EGk]0000001D
O>H000000`1DO>H010000000D7GG051ee`1@MML3000000030=@m6@000000000004D0e3dI5P3om^h0
0`3D?AT0ooK^0?ofkP0:0?ofkP030000003om^h0ooK^04H0ooK^0@3oool004P0ooK^00<000000?of
kP3om^h02P3om^h00`3D?AT0ooK^0?ofkP0D0?ofkP80e3dI1`3om^h00`000000ooK^0?ofkP090?of
kP040=@m6@3om^h0ooK^0=@m6A00ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP0;
0?ofkP030=@m6@3om^h0ooK^00D0ooK^0P0000001@3D?AT000000000000G8eD0000000805b=E0P00
000301lbL0030000000O<W0000000080:d>>00@0000002]3SP0[@hh0:d>>0P000000103D?AT0=52V
03A@YP00000203A@YP050000000dD:H0=52V03A@YP0000000P0lFkT010000000?5^i000000000003
0?Q87P030000003hB1h0?EV[0080n4PN00D000000?Q87P3hB1h0n4PN000000040?Q87P050000003h
B1h0n4PN0?Q87P0mFJ/0103hB1h01@000000n4PN0?Q87P3hB1h0000000<0n4PN00<000000?Q87P3h
B1h00P3hB1h01@0mFJ/0n4PN0?Q87P3hB1h0000000@0n4PN00D000000?Q87P3hB1h0n4PN00000002
0?Q87P0303eIZ`3hB1h0000000<0n4PN0P0000001@1BN^/00000059jj`1BN^/0000000<0E7g^00@0
000005AmkP1DONh000000P1DONh00`3D?AT000000000000305Enk@060000001EO^d0EGk]0000001D
O>H000000`1DO>H200000080D7GG00H00000051ee`00000000000=@m6@0000080?ofkP030=@m6@3o
m^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP040=@m6@3o
m^h0ooK^0=@m6@/0ooK^00<000000?ofkP3om^h01@3om^h20=@m6AH0ooK^00<0e3dI0?ofkP3om^h0
2P3om^h00`000000ooK^0?ofkP160?ofkP40oooo00190?ofkP030000003om^h0ooK^00T0ooK^00<0
e3dI0?ofkP3om^h05@3om^h00`3D?AT0ooK^0?ofkP050?ofkP030000003om^h0ooK^00T0ooK^00@0
e3dI0?ofkP3om^h0e3dI403om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00/0ooK^
00<0e3dI0?ofkP3om^h01P3om^h010000000e3dI00000000000201LSE@050000000G8eD0000001lb
L00000000`0O<W02000000<0:d>>00H0000002]3SP0[@hh0:d>>0000003D?AT303A@YP030000000d
D:H0=52V0080000000<0=52V0000000000000P0lFkT010000000?5^i03aK^@0000030?Q87P030000
000mFJ/0n4PN0080n4PN00@000000?Q87P3hB1h00000103hB1h01P000000n4PN0?Q87P3hB1h0?EV[
000000<0n4PN00D000000?Q87P3hB1h0n4PN000000030?Q87P060000003hB1h0n4PN0?Q87P000000
?EV[0`3hB1h00`000000n4PN0?Q87P020?Q87P040000003hB1h0n4PN000000<0n4PN00<0?EV[0000
003hB1h00P3hB1h010000000DW[[059jj`000002059jj`80000000<0E7g^0000000000000P1DONh0
1P000000E7g^05AmkP1DONh0e3dI000000<0EGk]00@0000005Enk@1EO^d0EGk]0P00000305AliP05
0000001DO>H00000051ee`0000000P1@MML010000000AfVk0=@m6@0000080?ofkP030=@m6@3om^h0
ooK^00/0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP040=@m6@3om^h0
ooK^0=@m6@/0ooK^00<000000?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP0E0?ofkP030=@m6@3o
m^h0ooK^00T0ooK^00<000000?ofkP3om^h0A`3om^h10?ooo`00B@3om^h00`000000ooK^0?ofkP09
0?ofkP030=@m6@3om^h0ooK^01@0ooK^0P3D?AT70?ofkP030000003om^h0ooK^00P0ooK^00D0e3dI
0?ofkP3om^h0ooK^0=@m6@0@0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h02`3o
m^h00`3D?AT0ooK^0?ofkP060?ofkP040000003D?AT04ATn000000<05b=E0P00000201lbL0050000
000O<W007c9`01lbL0000000100[@hh01P000000:d>>02]3SP000000e3dI000000<0=52V00@00000
03A@YP0dD:H0=52V0P000000100lFkT000000000000lFkT20000000303aK^@000000n4PN0080n4PN
00<0?EV[0?Q87P3hB1h00P3hB1h010000000n4PN0?Q87P0000040?Q87P050000003hB1h0n4PN03eI
Z`0000000`3hB1h01@000000n4PN0?Q87P3hB1h0000000<0n4PN00H000000?Q87P3hB1h0n4PN0000
000mFJ/20?Q87P030000003hB1h0n4PN0080n4PN00@000000?Q87P3hB1h00000103hB1h01P0mFJ/0
n4PN0?Q87P3hB1h00000059jj`80000000@0DW[[000000000000DW[[0P00000305AmkP070000001D
ONh0E7g^05AmkP000000e3dI0000000205Enk@030000001EO^d0EGk]0080EGk]00D0000005AliP1D
O>H0E7cV0000000205AliP8000000`1@MML010000000AfVk0=@m6@0000080?ofkP030=@m6@3om^h0
ooK^00/0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP050=@m6@3om^h0
ooK^0?ofkP3D?AT02P3om^h00`000000ooK^0?ofkP050?ofkP80e3dI5P3om^h00`3D?AT0ooK^0?of
kP090?ofkP030000003om^h0ooK^04L0ooK^0@3oool004T0ooK^00<000000?ofkP3om^h02@3om^h0
0`3D?AT0ooK^0?ofkP0D0?ofkP80e3dI1`3om^h00`000000ooK^0?ofkP080?ofkP050=@m6@3om^h0
ooK^0?ofkP3D?AT0403om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0
e3dI0?ofkP3om^h01P3om^h00`000000e3dI00000002000000805b=E0P00000301lbL0030000000O
<W007c9`00800000100[@hh3000000030=@m6@0dD:H0000000<0=52V00D0000003A@YP0dD:H0=52V
0000000303aK^@060000000lFkT0?5^i0000000lFkT000000P3hB1h00`0mFJ/000000=@m6@020?Q8
7P050000003hB1h0n4PN0?Q87P0000000`3hB1h01@000000n4PN0?Q87P0mFJ/0000000<0n4PN00D0
00000?Q87P3hB1h0n4PN000000030?Q87P060000003hB1h0n4PN0?Q87P000000?EV[0P3hB1h01@00
0000n4PN0?Q87P3hB1h0000000<0n4PN00H000000?Q87P3hB1h0n4PN0000000mFJ/20?Q87P030000
001BN^/000000080DW[[00D00000059jj`1BN^/0DW[[0000000305AmkP080000001DONh0E7g^05Am
kP000000E7g^0=@m6@1EO^d2000000@0EGk]0P00000205AliP040000001DO>H0E7cV05AliP800000
0P1@MML3000000030=@m6@000000ooK^00L0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^
0?ofkP030?ofkP030=@m6@3om^h0ooK^00h0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0:0?ofkP03
0000003om^h0ooK^00D0ooK^0P3D?ATF0?ofkP030=@m6@3om^h0ooK^00T0ooK^00<000000?ofkP3o
m^h0A`3om^h10?ooo`00BP3om^h00`000000ooK^0?ofkP080?ofkXT0e3dI00D000000?Q87P3hB1h0
n4PN000000030?Q87P040000003hB1h0n4PN000000@0n4PN00D000000?Q87P0mFJ/0n4PN00000002
0?Q87P050000003hB1h0n4PN0?Q87P0000000`3hB1h020000000n4PN0?Q87P000000n4PN03eIZ`3h
B1h00000103hB1h010000000n4PN0?Q87P0000030?Q87P050000003hB1h0n4PN0?Q87P000000R@3D
?AT:0?ofkP030000003om^h0ooK^04P0ooK^0@3oool004X0ooK^00<000000?ofkP3om^h0203om^h0
0`3D?AT0ooK^0?ofkP0D0?ofkP80e3dI1P3om^h00`000000ooK^0?ofkP090?ofkP050=@m6@3om^h0
ooK^0?ofkP3D?AT03`3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0
e3dI0?ofkP3om^h01`3om^h00`000000e3dI014I?P020000000301LSE@0000005b=E00800000100O
<W02000000<0:d>>00<0000002]3SP0[@hh00P0[@hh0103D?AT0=52V03A@YP0dD:H2000000<0=52V
0P00000203aK^@030000000lFkT0?5^i0080000000<0?5^i0000000000004@0000000`0mFJ/00000
0000000?0000000303eIZ`00000000000140000000<0DW[[0000000000000P1BN^/00`000000DW[[
059jj`02000000<0E7g^0P00000305AmkP030=@m6@1EO^d0EGk]0080EGk]00@0000005Enk@1EO^d0
EGk]0P00000405AliP80000000<0D7GG0000001@MML00P0000000`17JK/0e3dI000000090?ofkP03
0=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP0=0?ofkP05
0=@m6@3om^h0ooK^0?ofkP3D?AT02`3om^h00`000000ooK^0?ofkP040?ofkP80e3dI5P3om^h00`3D
?AT0ooK^0?ofkP080?ofkP030000003om^h0ooK^04P0ooK^0@3oool004X0ooK^00<000000?ofkP3o
m^h0203om^h00`3D?AT0ooK^0?ofkP0D0?ofkP80e3dI1P3om^h00`000000ooK^0?ofkP090?ofkP05
0=@m6@3om^h0ooK^0?ofkP3D?AT03`3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^
00X0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`000000e3dI014I?P020000000601LSE@0000005b=E
0000000O<W000000100O<W000`000000:d>>02]3SP0202]3SP050000000[@hh0:d>>02]3SP3D?AT0
0P00000303A@YP050000000dD:H0=52V03A@YP0000000`0lFkT200000080?5^i00<0000003aK^@0l
FkT00`0000020?e:7`030000003mBQl0?EV[0080?EV[0P3mBQl020000000oDXO0?e:7`3mBQl00000
03eIZ`3mBQl000000P3mBQl01@000000oDXO0?e:7`3mBQl0000000<0oDXO00L000000?e:7`3mBQl0
00000?e:7`0mFJ/0000000<0oDXO00<000000?e:7`3mBQl00`0mFJ/0103mBQl000000?e:7`3mBQl3
00000080DW[[00<00000059jj`1BN^/00P000003059jj`050000001DONh0E7g^05AmkP0000000`1D
ONh2000000050=@m6@1EO^d0EGk]05Enk@000000101EO^d00`000000E7cV05AliP0205AliP060000
001DO>H00000051ee`000000D7GG0`0000000`3D?AT000000?ofkP080?ofkP030=@m6@3om^h0ooK^
00X0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP0=0?ofkP050=@m6@3om^h0ooK^
0?ofkP3D?AT02`3om^h00`000000ooK^0?ofkP040?ofkP80e3dI5@3om^h00`3D?AT0ooK^0?ofkP09
0?ofkP030000003om^h0ooK^04P0ooK^0@3oool004/0ooK^00<000000?ofkP3om^h0203om^h00`3D
?AT0ooK^0?ofkP0C0?ofkP80e3dI1P3om^h00`000000ooK^0?ofkP090?ofkP050=@m6@3om^h0ooK^
0?ofkP3D?AT03`3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI
0?ofkP3om^h01`3om^h01@000000e3dI0000000A6Ch0000000805b=E00D0000001LSE@0000007c9`
0000000301lbL0<000000`0[@hh20000000402]3SP3D?AT0=52V03A@YP8000000P0dD:H00`000000
=52V03A@YP03000000<0?5^i00@0000003aK^@0lFkT000000P0lFkT00`000000@VC8000000020?e:
7`8000000P3mBQl503eIZ`030?e:7`000000?EV[0080oDXO00<000000?e:7`0000000`3mBQl01`00
0000oDXO0?e:7`3mBQl000000?e:7`0000000P3mBQl00`0mFJ/000000?e:7`0503eIZ`80oDXO0P00
00020?e:7`030000001?M^H000000080DW[[00@00000059jj`1BN^/000000`1BN^/300000080E7g^
00<0000005AmkP1DONh00P00000205AmkP040=@m6@1EO^d00000000000<0EGk]0`00000305AliP05
0000001DO>H00000051ee`0000000P1@MML01@000000AfVk0000003D?AT0000000T0ooK^00<0e3dI
0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI
0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP090?ofkP030000003om^h0ooK^00<0ooK^00<0e3dI
0?ofkP3D?AT05@3om^h00`3D?AT0ooK^0?ofkP080?ofkP030000003om^h0ooK^04T0ooK^0@3oool0
04/0ooK^00<000000?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP0B0?ofkP040=@m6@3om^h0ooK^
0=@m6@D0ooK^00<000000?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0
ooK^00`0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0
ooK^00L0ooK^00H000000=@m6@0000004ATn03eIZ`00000201LSE@8000000P0O<W020000000501lb
L0000000:d>>02]3SP000000100[@hh00`000000e3dI03A@YP0303A@YP030000000dD:H0=52V00<0
00000P0lFkT200000080?5^i0P0000000`0lFkT000000000000500000080oDXO00@000000?e:7`3m
BQl000000P3mBQl00`000000?EV[03eIZ`0E03eIZ`040000003mBQl0oDXO00000080oDXO00<00000
0?e:7`3mBQl01@0000000`1BN^/00000059jj`0200000080DW[[0P000002059jj`<000000P1DONh0
0`000000E7g^05AmkP0205AmkP030=@m6@000000EGk]00<0EGk]00D0000005Enk@1EO^d0000005Al
iP0200000080E7cV0P000002051ee`<0000000<0AfVk0=@m6@0000002@3om^h00`3D?AT0ooK^0?of
kP090?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?of
kP030?ofkP030=@m6@3om^h0ooK^00P0ooK^00<000000?ofkP3om^h00`3om^h0103D?AT0ooK^0?of
kP3D?ATD0?ofkP030=@m6@3om^h0ooK^00P0ooK^00<000000?ofkP3om^h0B@3om^h10?ooo`00B`3o
m^h00`000000ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^0180ooK^00@0e3dI0?ofkP3om^h0e3dI
1@3om^h00`000000ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h0
303om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h0
1`3om^h00`000000e3dI00000003000000<05b=E00<0000001lbL00O<W000P0O<W000`0000007c9`
0000000202]3SP8000000`0[@hh00`3D?AT0000003A@YP0303A@YP8000000P0dD:H00`000000?5^i
03aK^@0203aK^@050000000lFkT0?5^i03aK^@0000000P0lFkT01P000000@VC80=@m6@000000@VC8
00000080oDXO00@000000?e:7`3mBQl000000P3mBQl01P000000oDXO03eIZ`000000oDXO00000080
oDXO00@000000?e:7`3mBQl000000P3mBQl02@000000oDXO0?e:7`000000oDXO0000000mFJ/0oDXO
000000020?e:7`040000003mBQl0oDXO00000080oDXO00H0000004mfiP000000e3dI04mfiP000002
059jj`050000001BN^/0DW[[059jj`000000101BN^/00`000000E7g^05AmkP02000000@0E7g^00<0
00000=@m6@1EO^d00P1EO^d200000080EGk]00<0000005AliP000000101DO>H010000000D7GG051e
e`1@MML4000000030=@m6@000000ooK^00P0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^
0?ofkP050?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^
0?ofkP080?ofkP030000003om^h0ooK^00<0ooK^00@0e3dI0?ofkP3om^h0e3dI503om^h00`3D?AT0
ooK^0?ofkP080?ofkP030000003om^h0ooK^04T0ooK^0@3oool004`0ooK^00<000000?ofkP3om^h0
1`3om^h00`3D?AT0ooK^0?ofkP0B0?ofkTT0e3dI0`000000100G8eD0000001LSE@0G8eD2000000@0
7c9`0P00000402]3SP050000000[@hh0:d>>0=@m6@0dD:H00P00000403A@YP030000000dD:H00000
008000000`0lFkT200000080?5^i100000000`3D?AT0@VC80000000200000080oDXO00T000000?e:
7`3mBQl000000?e:7`000000oDXO03eIZ`0000000P3mBQl00`000000oDXO000000020?e:7`060000
003mBQl0oDXO0000003mBQl000000P3mBQl01P0mFJ/0oDXO0?e:7`000000oDXO00000080oDXO00<0
00000?e:7`3mBQl00`0000001P1?M^H0e3dI000000000000DW[[00000080DW[[0P000003059jj`<0
000000<0E7g^0000001DONh00`1DONh2000000050=@m6@000000EGk]05Enk@000000101EO^d20000
00@0E7cV0P000002051ee`8000000P17JK/00`3D?AT0?EV[0=@m6@170=@m6A<0ooK^00<0e3dI0?of
kP3om^h0203om^h00`000000ooK^0?ofkP1:0?ofkP40oooo001<0?ofkP030000003om^h0ooK^00P0
ooK^00<0e3dI0?ofkP3om^h04@3om^h0103D?AT0ooK^0?ofkP3D?AT50?ofkP030000003om^h0ooK^
00P0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^
00D0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP080?ofkP030000003D?AT04ATn
0080000000H05b=E0000000G8eD0000001lbL000000401lbL0030000000[@hh0:d>>00<0:d>>0`00
00000`3D?AT0=52V03A@YP02000000@0=52V0P0000000`0lFkT000000000000303aK^@8000000P0l
FkT00`000000@VC80=@m6@0200000006049Tb000000000000000003mBQl000000P3mBQl02P000000
oDXO0000003mBQl0?EV[0000003mBQl000000?e:7`0000020?e:7`0=0000003mBQl0oDXO0000003m
BQl000000?e:7`000000?EV[0?e:7`000000oDXO000000020?e:7`030000003mBQl0000000800000
00H0CgKV000000000000e3dI04mfiP000002059jj`8000000`1BN^/200000003059jj`0000000000
00@0E7g^0P00000205AmkP040=@m6@0000000000000000D0EGk]00<0000005AliP1DO>H00P1DO>H0
1P000000E7cV0000001@MML00000051ee`80000000<0AfVk0=@m6@0000002P3om^h00`3D?AT0ooK^
0?ofkP090?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^
0?ofkP030?ofkP030=@m6@3om^h0ooK^00P0ooK^00<000000?ofkP3om^h00`3om^h0103D?AT0ooK^
0?ofkP3D?ATC0?ofkP030=@m6@3om^h0ooK^00P0ooK^00<000000?ofkP3om^h0BP3om^h10?ooo`00
C03om^h00`000000ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^0140ooK^00@0e3dI0?ofkP3om^h0
e3dI103om^h00`000000ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3o
m^h0303om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3o
m^h0203om^h00`000000e3dI014I?P02000000<05b=E00<0000001lbL00O<W000P00000201lbL0<0
00001@0[@hh00`000000e3dI03A@YP0303A@YP80000000@0?EV[03A@YP000000?5^i0P0000000`0l
FkT000000000000303aK^@@0000000D0e3dI049Tb012I<P00000049Tb003000000090?e:7`000000
00000?e:7`000000oDXO0000000mFJ/0oDXO008000000P3mBQl01@000000oDXO0000003mBQl00000
0080oDXO0P0000001P3mBQl0?EV[0000003mBQl000000?e:7`80000000H0oDXO0000000000000000
04mfiP00000204mfiP050=@m6@0000000000059jj`0000000`1BN^/200000005059jj`0000000000
059jj`0000000P1DONh2000000@0E7g^00<0e3dI0000001EO^d0101EO^d300000080E7cV0P000002
05AliP8000000P1@MML01@000000AfVk04MY^`3D?AT0000000X0ooK^00<0e3dI0?ofkP3om^h02@3o
m^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h00`3o
m^h00`3D?AT0ooK^0?ofkP080?ofkP030000003om^h0ooK^00<0ooK^00@0e3dI0?ofkP3om^h0e3dI
4`3om^h00`3D?AT0ooK^0?ofkP080?ofkP030000003om^h0ooK^04X0ooK^0@3oool004d0ooK^00<0
00000?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP0@0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT0
103om^h00`000000ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h0
2`3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h0
203om^h01@000000e3dI0000000A6Ch0000000805b=E0P00000401lbL0030000000O<W0000000080
:d>>0P00000302]3SP040000003D?AT00000000000@0=52V00@0000003eIZ`0dD:H000000P0lFkT2
0000000303aK^@000000000000<0?5^i0P000000103D?AT0000000000012I<P200000003049Tb000
000000000080oDXO01X000000?e:7`000000oDXO03eIZ`3mBQl000000?e:7`000000oDXO0000003m
BQl000000?e:7`000000oDXO0000003mBQl000000?e:7`0mFJ/0oDXO0000003mBQl000000?e:7`<0
000000@0CgKV000000000000CgKV0P0000000`3D?AT0000000000003059jj`80000000<0DW[[0000
000000000P1BN^/010000000E7g^00000000000405AmkP80000000<0e3dI0000001EO^d00P1EO^d2
00000080EGk]00<0000005AliP000000101DO>H200000080D7GG00D0000004MY^`000000e3dI0000
000:0?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?of
kP0:0?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h0203om^h01@000000ooK^0?of
kP3om^h0e3dI00@0ooK^00<0e3dI0?ofkP3om^h0403om^h00`3D?AT0ooK^0?ofkP070?ofkP030000
003om^h0ooK^04/0ooK^0@3oool004d0ooK^00<000000?ofkP3om^h01`3om^h00`3D?AT0ooK^0?of
kP0@0?ofkP030=@m6@3om^h0ooK^0080ooK^00D0e3dI0?ofkP3om^h0ooK^0000000:0?ofkP030=@m
6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m
6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h0203om^h010000000e3dI0000000A6Ch200000080
5b=E00<0000001lbL00O<W000`0O<W02000000@0:d>>0P0000000`0[@hh000000=@m6@0203A@YP80
0000100dD:H3000000<0?5^i1@0000001P0lFkT00000049Tb03D?AT00000049Tb080000000<0@VC8
0000000000007@0000001@1?M^H00000000000000000CgKV0080000000H0CgKV0000003D?AT0CgKV
0000001BN^/5000000<0DW[[0`00000405AmkP8000000P1DONh00`3D?AT0EGk]05Enk@02000000@0
EGk]0P00000405AliP0403eIZ`000000D7GG051ee`80000000<0AfVk0000003D?AT02`3om^h00`3D
?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D
?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00P0ooK^00D000000?ofkP3om^h0ooK^0=@m6@04
0?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h0203om^h00`000000ooK^0?ofkP1;
0?ofkP40oooo001=0?ofkP030000003om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D
?AT0ooK^0?ofkP020?ofkP050=@m6@3om^h0ooK^0?ofkP0000002P3om^h00`3D?AT0ooK^0?ofkP05
0?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP07
0?ofkP030=@m6@3om^h0ooK^00X0ooK^00L0e3dI014I?P000000000001LSE@0000005b=E00<00000
100O<W000`000000:d>>02]3SP0402]3SP030000000[@hh0e3dI00@0=52V0P00000303A@YP030000
000lFkT00000008000000`0lFkT5000000050=@m6@12I<P0000000000012I<P00P0000000`12I<P0
000000000006000000090?m;80000000od/P0000003oBb0000000?m;80000000od/P00<0000000<0
od/P0000003oBb001P0000000`1?M^H0000004mfiP020000000504mfiP000000000004mfiP3D?AT0
1@000003059jj`<0000000<0DW[[0000001DONh00P1DONh2000000@0E7g^00<0e3dI000000000000
1P1EO^d00`000000E7cV05AliP0205AliP<0000000<0D7GG0000001@MML00P0000000`17JK/0e3dI
0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^
0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h0203om^h01@000000ooK^
0?ofkP3om^h0e3dI00@0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP080?ofkP03
0000003om^h0ooK^04/0ooK^0@3oool004h0ooK^00<000000?ofkP3om^h01`3om^jD0=@m6@L00000
00<0od/P0000000000000P000000103oBb0000000000003oBb03000000030?m;80000000000000D0
0000U03D?AT90?ofkP030000003om^h0ooK^04`0ooK^0@3oool004h0ooK^00<000000?ofkP3om^h0
1`3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^0080ooK^00D0e3dI0?ofkP3om^h0
ooK^0000000:0?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0
ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h02P3om^h0103D?AT0
0000014I?P00000201LSE@030000000G8eD0000000807c9`0P000000100O<W00000002]3SP0[@hh2
000000@0:d>>00@0e3dI03A@YP00000000001@0dD:H3000000D0?5^i0P0000001@0mFJ/0?5^i0000
0012I<P0e3dI00D0000000<0@VC80000000000002@000000103oBb0000000000003oBb0600000003
0?m;80000000000000T0000000<0CgKV0000000000000`0000001@3D?AT0CgKV0000001BN^/0?EV[
008000001@1BN^/3000000D0E7g^0P0000000`1DONh0e3dI05Enk@0305Enk@80000000@0EGk]0000
001DO>H0E7cV0P00000205AliP030000001@MML000000080D7GG00@0000004MY^`000000e3dI303o
m^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h02P3o
m^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00P0ooK^00D000000?ofkP3om^h0ooK^
0=@m6@040?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`000000ooK^
0?ofkP1<0?ofkP40oooo001>0?ofkP030000003om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h03P3o
m^h00`3D?AT0ooK^0?ofkP030?ofkP050=@m6@3om^h0ooK^0?ofkP0000002@3om^h00`3D?AT0ooK^
0?ofkP060?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^
0?ofkP070?ofkP030=@m6@3om^h0ooK^00X0ooK^00@0e3dI0000000A6Ch000000`0G8eD2000000@0
7c9`0`00000302]3SP8000000P0[@hh0103D?AT0=52V03A@YP0dD:H3000000<0=52V00<0000003aK
^@0000000`00000403aK^@<0000000<0e3dI049Tb012I<P0:@00000204mfiP040=@m6@0000000000
000000@0DW[[100000000`1BN^/0000005AmkP0205AmkP<000000`1DONh00`3D?AT0EGk]05Enk@02
000000<0EGk]0`00000405AliP8000000`1@MML010000000AfVk0000003D?AT<0?ofkP030=@m6@3o
m^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3o
m^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h01`3om^h01@000000ooK^0?ofkP3om^h0e3dI00D0ooK^
00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP070?ofkP030000003om^h0ooK^04`0ooK^
0@3oool004l0ooK^00<000000?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3o
m^h0ooK^00@0ooK^00@0e3dI0?ofkP3om^h000002@3om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m
6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m
6@3om^h0ooK^00X0ooK^00<0e3dI03eIZ`0000000P00000301LSE@030000000O<W007c9`00@07c9`
00<0000002]3SP0[@hh00`0[@hh00`000000:d>>0=@m6@0603A@YP80000000<0=52V0000000lFkT0
100lFkT40000000403aK^@000000@VC80=@m6@<0000000D0@VC803eIZ`0000000000049Tb00M0000
000504mfiP000000000003eIZ`1?M^H00`000000103D?AT0CgKV0000001BN^/4000000D0DW[[00@0
000005AmkP00000000001P1DONh00`3D?AT000000000000505Enk@030000001DO>H0E7cV00<0E7cV
00<0?EV[0000001@MML00P1@MML30000000303eIZ`3D?AT0ooK^00/0ooK^00<0e3dI0?ofkP3om^h0
1`3om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h0
1`3om^h00`3D?AT0ooK^0?ofkP070?ofkP040000003om^h0ooK^0=@m6@H0ooK^00<0e3dI0?ofkP3o
m^h03@3om^h00`3D?AT0ooK^0?ofkP070?ofkP030000003om^h0ooK^04d0ooK^0@3oool004l0ooK^
00<000000?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP0=0?ofkTh0e3dI00<0000001LSE@000000
0P0G8eD3000000@07c9`0`00000502]3SP030=@m6@000000=52V00H0=52V1000000703aK^@<00000
00@0e3dI049Tb012I<P0@VC8100000000`12I<P000000000000K0000000304mfiP00000000000080
00000`1?M^H0103D?AT00000000000000007059jj`@000001`1DONh00`000000e3dI05Enk@0405En
k@<00000101DO>H300000080D7GG00<00000051ee`000000CP3D?AT?0?ofkP030=@m6@3om^h0ooK^
00L0ooK^00<000000?ofkP3om^h0C@3om^h10?ooo`00C`3om^h00`000000ooK^0?ofkP070?ofkP03
0=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0000000:0?ofkP03
0=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP090?ofkP03
0=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h02`3om^h01@3D?AT0?EV[0000000000005b=E
00<000000P0O<W02000000807c9`00<0000002]3SP0[@hh00P00000302]3SP030000003D?AT00000
008000001@0dD:H00`000000?5^i03aK^@0600000080?5^i00<00000049Tb03D?AT01P0000000`12
I<P000000000000M0000000304mfiP000000000000@0000000<0e3dI04mfiP0000000P1BN^/60000
0080DW[[00<0000005AmkP1DONh00`1DONh3000000030=@m6@000000EGk]0080EGk]0P00000205En
k@030000001DO>H0E7cV0080000000<0E7cV0000001@MML00P0000001@1@MML000000000000mFJ/0
e3dI00d0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0
ooK^00P0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP080?ofkP030000003om^h0
e3dI00H0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP070?ofkP030000003om^h0
ooK^04d0ooK^0@3oool004l0ooK^00<000000?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP0<0?of
kP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP0000002@3om^h00`3D?AT0ooK^0?ofkP080?of
kP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP050?of
kP030=@m6@3om^h0ooK^00`0ooK^00@0e3dI03eIZ`0mFJ/000000`0G8eD2000000<07c9`0`000004
02]3SP80000000<0:d>>0000003D?AT00`0dD:H40000000303A@YP000000?5^i00L0?5^i10000000
103D?AT00000000000000003049Tb24000000`1?M^H3000000030=@m6@000000000000800000201B
N^/00`000000E7g^00000003000000<0E7g^00<0e3dI0000001EO^d00P00000405Enk@<000000`1D
O>H2000000<0D7GG00@0000003eIZ`0mFJ/0e3dI3P3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m
6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m
6@3om^h0ooK^00L0ooK^00<000000?ofkP3D?AT01`3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m
6@3om^h0ooK^00L0ooK^00<000000?ofkP3om^h0C@3om^h10?ooo`00D03om^h00`000000ooK^0?of
kP070?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT000000?of
kP080?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?of
kP0:0?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h0303om^h0103D?AT0?EV[03eI
Z`00000401LSE@030000000O<W007c9`00<07c9`0P00000502]3SP80000000<0e3dI0000000dD:H0
1@0dD:H7000000D0?5^i00<00000049Tb03D?AT00`12I<PW000000<0CgKV00<0e3dI04mfiP000000
1@1BN^/7000000H0E7g^00@000000=@m6@00000000001@1EO^d2000000D0E7cV00<00000051ee`1@
MML00P1@MML010000000?EV[03eIZ`3D?AT>0?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?of
kP3om^h02P3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?of
kP3om^h01`3om^h00`000000e3dI0?ofkP070?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?of
kP3om^h01`3om^h00`000000ooK^0?ofkP1>0?ofkP40oooo001@0?ofkP030000003om^h0ooK^00L0
ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@000000ooK^00P0
ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00X0
ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP050=@m6@0mFJ/0?EV[0?of
kP0000000`0G8eD3000000<07c9`00@0000002]3SP0000000000100[@hh00`000000e3dI03A@YP05
00000080=52V00<0000003aK^@0lFkT00`0lFkT7000000030=@m6@000000000002/0000000<0e3dI
0000000000001@000005059jj`030000001DONh0E7g^00D0000000<0E7g^0=@m6@000000101EO^d2
0000000305Enk@000000E7cV0080E7cV0P0000001P0mFJ/0D7GG051ee`1@MML000000?ofkP80?EV[
00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00X0ooK^
00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^00L0ooK^
00<000000=@m6@3om^h0203om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00L0ooK^
00<000000?ofkP3om^h0CP3om^h10?ooo`00D03om^h00`000000ooK^0?ofkP070?ofkY80e3dI6`00
002B0=@m6@T0ooK^00<000000?ofkP3om^h0CP3om^h10?ooo`00D@3om^h00`000000ooK^0?ofkP06
0?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT000000?ofkP07
0?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP0;
0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h03@3om^h02@3D?AT0?EV[03eIZ`0m
FJ/0ooK^0=@m6@0000005b=E0000000301lbL0<000001@0[@hh20000000302]3SP3D?AT0=52V00L0
=52V00<0000003aK^@0lFkT00`0lFkT7000000030=@m6@0000000000008000001@12I<P400000003
04M[e000000000000080000000<0oD`P0000003mC2000`0000000`3mC20000000?e<800400000003
04aagP0000000000008000001@1?M^H4000000030=@m6@000000000000D000001@1BN^/00`000000
E7g^05AmkP0605AmkP040=@m6@1EO^d00000000000D0EGk]0`00000305AliP050000001@MML00000
0=@m6@3om^h00`0mFJ/00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI
0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI
0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI
0?ofkP3om^h01`3om^h00`000000ooK^0?ofkP1?0?ofkP40oooo001A0?ofkP030000003om^h0ooK^
00L0ooK^00<0e3dI0?ofkP3om^h0203om^iH0=@m6@807c9`00<0e3dI01lbL00O<W000P00000602]3
SP030000003D?AT0000000<00000100dD:H00`000000?5^i03aK^@0803aK^@0400000012I<P0e3dI
049Tb0H000000P12I<P20000000304M[e0000000000000<0000000L0oD`P00000000000000000?e<
80000000oD`P00<0000000<0oD`P0000000000000`0000000`1<LMh000000000000204mfiPH00000
00<0e3dI04mfiP0mFJ/02`1BN^/00`000000E7g^05AmkP0205AmkP@0000000<0e3dI0000001EO^d0
1@1EO^d200000080E7cV00<0e3dI05AliP1DO>H0F03D?AT:0?ofkP030=@m6@3om^h0ooK^00L0ooK^
00<000000?ofkP3om^h0C`3om^h10?ooo`00D@3om^h00`000000ooK^0?ofkP070?ofkP030=@m6@3o
m^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3o
m^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3o
m^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0?EV[0?ofkP0203eIZ`030=@m6@3o
m^h0ooK^00800000100O<W000`000000:d>>00000002000000@0:d>>00<0e3dI03A@YP0dD:H00P0d
D:HB000000040=@m6@12I<P0@VC8049Tb0@000000P12I<PI00000080CgKV1000000304mfiP030=@m
6@0000000000010000000`1DONh00`3D?AT0000005Enk@0305Enk@<0000000<0EGk]0000001DO>H0
0`1DO>H200000080ooK^00D0e3dI03eIZ`0mFJ/0ooK^0=@m6@0@0?ofkP030=@m6@3om^h0ooK^00<0
ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00/0
ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT000000?ofkP0;0?ofkP030=@m6@3om^h0ooK^00H0
ooK^00<0e3dI0?ofkP3om^h0203om^h00`000000ooK^0?ofkP1?0?ofkP40oooo001B0?ofkP030000
003om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030000
003D?AT0ooK^00D0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m
6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP050=@m
6@0mFJ/0?EV[03eIZ`3D?AT00`3om^h00`0mFJ/000000000000201lbL0030000000[@hh0:d>>0080
:d>>0`0000000`0[@hh000000=@m6@0703A@YP030000000lFkT0?5^i00T0?5^i00<00000049Tb03D
?AT00`0000000`12I<P00000000000070000000403eIZ`000000000000000080kdTO00D000000>m9
7`000000kdTO000000020>m97`<0000000<0?EV[0000000000001`000000201?M^H0000000000000
0000e3dI04mfiP000000?EV[2P1BN^/00`000000E7g^05AmkP0505AmkP030=@m6@000000EGk]00<0
00000`1EO^d010000000E7cV05AliP1DO>H20000000503eIZ`3om^h0ooK^0?ofkP3D?AT00`0mFJ/0
0`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h03@3om^h0
0`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h0103om^h0
0`3D?AT000000?ofkP0;0?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h01`3om^h0
0`000000ooK^0?ofkP1@0?ofkP40oooo001B0?ofkP030000003om^h0ooK^00L0ooK^00<0e3dI0?of
kP3om^h01@3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030000003om^h0e3dI00H0ooK^00<0e3dI0?of
kP3om^h03@3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00h0ooK^00D0e3dI0?of
kP3om^h0ooK^0=@m6@0A0?ofkP040=@m6@0mFJ/0?EV[0=@m6@@0ooK^0P0mFJ/01@3om^h000000000
000O<W00000000H0:d>>0P000000103D?AT0000000000000000503A@YP030000000lFkT0?5^i00<0
?5^i1`0000000`12I<P0000000000009000000050>m97`000000?EV[0>m97`0000000P3_BAl01000
0000kdTO0>m97`0000020>m97`080000003_BAl0kdTO0000003_BAl0?EV[0000003_BAl;00000003
04mfiP000000000000D000001@1BN^/00`000000E7g^05AmkP0305AmkP<0000000<0e3dI00000000
00001P1EO^d01@000000E7cV000000000000ooK^0080?EV[103om^h0103D?AT0?EV[03eIZ`3D?ATA
0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT0403om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3o
m^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h00`3om^h0103D?AT0ooK^0?ofkP00000<0?ofkP030=@m
6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h0203om^h00`000000ooK^0?ofkP1@0?ofkP40oooo
001B0?ofkP030000003om^h0ooK^00P0ooK^P`3D?AT00`0lFkT0000000000004000000<0?EV[1`00
00000`0mFJ/000000000000=0000000303eIZ`000000000000D000000`0mFJ/600000003059jj`3D
?AT0e3dI0840e3dI2P3om^h00`000000ooK^0?ofkP1@0?ofkP40oooo001C0?ofkP030000003om^h0
ooK^00P0ooK^0P3D?AT20?ofkVD0e3dI00H0?EV[0000003D?AT0e3dI02]3SP0000020=@m6@L0=52V
00<0000003aK^@0lFkT0200000000`0mFJ/0bSlK00000006000000D0?EV[00<0bSlK0000000mFJ/0
0`3:?a/01@000000bSlK0<Xo6`3:?a/0000000<0bSlK00L000000<Xo6`3:?a/0bSlK03eIZ`000000
bSlK00D0?EV[1`0000000`3:?a/0?EV[0000000700000080DW[[00<0000005AmkP1DONh01@1DONh2
0=@m6@060000001EO^d0e3dI0=@m6@000000?EV[I@3D?AT20?ofkP80e3dI2P3om^h00`000000ooK^
0?ofkP1A0?ofkP40oooo001C0?ofkP030000003om^h0ooK^00X0ooK^L`3D?AT00`0mFJ/000000000
000;0000000303eIZ`000000000000/000005@0mFJ/=0000000303eIZ`000000000000/0000000<0
?EV[0=@m6@3D?AT0L@3D?AT<0?ofkP030000003om^h0ooK^0540ooK^0@3oool005<0ooK^00<00000
0?ofkP3om^h06`3om^h00`000000ooK^0?ofkP130?ofkP80?EV[0P3om^h0100mFJ/0ooK^0?ofkP0m
FJ/40?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/0203om^h0100mFJ/0ooK^0?ofkP0mFJ/=0?ofkP03
03eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP03
03eIZ`3om^h0ooK^00/0ooK^00@0?EV[0?ofkP3om^h0?EV[203om^h01@0mFJ/0ooK^0?ofkP3om^h0
?EV[00@0ooK^00D0?EV[0?ofkP3om^h0?EV[0?ofkP0303eIZdD0ooK^00<000000?ofkP3om^h06`3o
m^h00`000000ooK^0?ofkP1A0?ofkP40oooo001D0?ofkP030000003om^h0ooK^01X0ooK^00<00000
0?ofkP3om^h0@`3om^h303eIZ`80ooK^00@0?EV[0?ofkP3om^h0?EV[103om^h0100mFJ/0ooK^0?of
kP0mFJ/90?ofkP<0?EV[3@3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00d0ooK^
00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP<0?EV[2@3om^h0100mFJ/0ooK^
0?ofkP0mFJ/40?ofkP0403eIZ`3om^h0ooK^03eIZ`80ooK^0`0mFJ]50?ofkP030000003om^h0ooK^
01X0ooK^00<000000?ofkP3om^h0DP3om^h10?ooo`00E03om^h00`000000ooK^0?ofkP0J0?ofkP03
0000003om^h0ooK^04<0ooK^0`0mFJ/20?ofkP0403eIZ`3om^h0ooK^03eIZ`D0ooK^00@0?EV[0?of
kP3om^h0?EV[2P3om^h203eIZ``0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0=
0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h02P3om^h203eIZ`X0ooK^00@0?EV[
0?ofkP3om^h0?EV[1@3om^h0100mFJ/0ooK^0?ofkP0mFJ/20?ofkP<0?EV[A@3om^h00`000000ooK^
0?ofkP0J0?ofkP030000003om^h0ooK^0580ooK^0@3oool005@0ooK^00<000000?ofkP3om^h06P3o
m^h00`000000ooK^0?ofkP130?ofkP<0?EV[0`3om^h00`0mFJ/0ooK^03eIZ`060?ofkP0303eIZ`3o
m^h0?EV[00X0ooK^00<0?EV[0?ofkP0mFJ/00P0mFJ/90?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0
?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00L0ooK^0`0m
FJ/00`3om^h0?EV[0?ofkP090?ofkP0303eIZ`3om^h0?EV[00H0ooK^00<0?EV[0?ofkP0mFJ/00`3o
m^h303eIZdD0ooK^00<000000?ofkP3om^h06P3om^h00`000000ooK^0?ofkP1B0?ofkP40oooo001E
0?ofkP030000003om^h0ooK^01P0ooK^00<000000?ofkP3om^h0A03om^h303eIZ`@0ooK^0P0mFJ/7
0?ofkP80?EV[2P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP80?EV[1`3om^h00`0mFJ/0ooK^0?ofkP0=
0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP05
0?ofkP80?EV[103om^h00`0mFJ/0ooK^0?ofkP080?ofkP80?EV[1`3om^h203eIZ`@0ooK^0`0mFJ]6
0?ofkP030000003om^h0ooK^01P0ooK^00<000000?ofkP3om^h0D`3om^h10?ooo`00E@3om^h00`00
0000ooK^0?ofkP0H0?ofkP030000003om^h0ooK^04@0ooK^0`0mFJ/40?ofkP80?EV[203om^h00`0m
FJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00@0ooK^0`0mFJ/40?ofkP0303eIZ`3om^h0ooK^
00d0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^
0080ooK^0`0mFJ/60?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h01P3om^h203eI
Z`@0ooK^0`0mFJ]60?ofkP030000003om^h0ooK^01P0ooK^00<000000?ofkP3om^h0D`3om^h10?oo
o`00E@3om^h00`000000ooK^0?ofkP0H0?ofkP030000003om^h0ooK^04@0ooK^100mFJ/40?ofkP03
03eIZ`3om^h0ooK^00H0ooK^0`0mFJ/80?ofkP0303eIZ`3om^h0ooK^00L0ooK^0`0mFJ/00`3om^h0
?EV[0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0
ooK^03eIZ`0203eIZ`T0ooK^00<0?EV[0?ofkP3om^h01P3om^h303eIZ`P0ooK^00<0?EV[0?ofkP3o
m^h00P3om^h403eIZdH0ooK^00<000000?ofkP3om^h0603om^h00`000000ooK^0?ofkP1C0?ofkP40
oooo001F0?ofkP030000003om^h0ooK^01L0ooK^00<000000?ofkP3om^h0A03om^h403eIZ`@0ooK^
0P0mFJ/70?ofkP0403eIZ`3om^h0ooK^03eIZ`L0ooK^00<0?EV[0?ofkP3om^h02P3om^h403eIZ`d0
ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP@0?EV[303om^h00`0mFJ/0
ooK^0?ofkP050?ofkP0403eIZ`3om^h0ooK^03eIZ`L0ooK^0P0mFJ/40?ofkP@0?EV[AP3om^h00`00
0000ooK^0?ofkP0G0?ofkP030000003om^h0ooK^05@0ooK^0@3oool005H0ooK^00<000000?ofkP3o
m^h05`3om^h00`000000ooK^0?ofkP140?ofkP80?EV[00<0ooK^03eIZ`0mFJ/00`3om^h00`0mFJ/0
ooK^03eIZ`060?ofkP0403eIZ`3om^h0ooK^0?ofkP80?EV[1P3om^h00`0mFJ/0ooK^0?ofkP0:0?of
kP0303eIZ`3om^h0ooK^00D0?EV[203om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^
00H0ooK^1@0mFJ/20?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h0103om^h203eI
Z`<0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^03eIZ`030?ofkP80?EV[00<0ooK^03eI
Z`0mFJ/0AP3om^h00`000000ooK^0?ofkP0G0?ofkP030000003om^h0ooK^05@0ooK^0@3oool005H0
ooK^00<000000?ofkP3om^h05`3om^h00`000000ooK^0?ofkP150?ofkP<0?EV[00D0ooK^03eIZ`3o
m^h0ooK^03eIZ`020?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0m
FJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h01@3om^h603eI
Z`80ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0603eIZ`L0ooK^00<0?EV[0?of
kP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?of
kP3om^h00`3om^h0100mFJ/0ooK^0?ofkP0mFJ/20?ofkP0303eIZ`3om^h0?EV[0080?EV[A`3om^h0
0`000000ooK^0?ofkP0G0?ofkP030000003om^h0ooK^05@0ooK^0@3oool005L0ooK^00<000000?of
kP3om^h05P3om^h00`000000ooK^0?ofkP150?ofkP<0?EV[00D0ooK^03eIZ`3om^h0ooK^03eIZ`03
0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h0103om^h203eIZ`<0ooK^00<0?EV[
0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkQD0?EV[3@3om^h00`0mFJ/0ooK^0?ofkP0:
0?ofkP0403eIZ`3om^h0ooK^0?ofkP80?EV[1@3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0503eIZ`3o
m^h0ooK^0?ofkP0mFJ/00P3om^h00`0mFJ/0ooK^03eIZ`0203eIZdL0ooK^00<000000?ofkP3om^h0
5P3om^h00`000000ooK^0?ofkP1E0?ofkP40oooo001G0?ofkP030000003om^h0ooK^01H0ooK^00<0
00000?ofkP3om^h0A@3om^h00`0mFJ/0ooK^03eIZ`020?ofkP0303eIZ`3om^h0?EV[00@0ooK^0P0m
FJ/30?ofkP0303eIZ`3om^h0ooK^00D0ooK^00@0?EV[0?ofkP3om^h0?EV[303om^h00`0mFJ/0ooK^
0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^
0?ofkP0:0?ofkP0403eIZ`3om^h0ooK^03eIZ`L0ooK^00@0?EV[0?ofkP3om^h0ooK^0P0mFJ/30?of
kP0403eIZ`3om^h0ooK^03eIZ`80ooK^00<0?EV[0?ofkP0mFJ/0A`3om^h00`000000ooK^0?ofkP0F
0?ofkP030000003om^h0ooK^05D0ooK^0@3oool005L0ooK^00<000000?ofkP3om^h05P3om^h00`00
0000ooK^0?ofkP150?ofkP0303eIZ`3om^h0?EV[0080ooK^00@0?EV[0?ofkP3om^h0?EV[1@3om^h0
100mFJ/0ooK^0?ofkP0mFJ/80?ofkP<0?EV[303om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3o
m^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP<0?EV[203o
m^h0100mFJ/0ooK^0?ofkP0mFJ/50?ofkP0403eIZ`3om^h0ooK^03eIZ`80ooK^00<0?EV[0?ofkP0m
FJ/0A`3om^h00`000000ooK^0?ofkP0F0?ofkP030000003om^h0ooK^05D0ooK^0@3oool005L0ooK^
00<000000?ofkP3om^h05@3om^h00`000000ooK^0?ofkP160?ofkP0403eIZ`3om^h0?EV[03eIZ`80
ooK^00<0?EV[0?ofkP0mFJ/01P3om^h00`0mFJ/0ooK^03eIZ`0:0?ofkP80?EV[303om^h00`0mFJ/0
ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0
ooK^0?ofkP0:0?ofkP80?EV[2P3om^h00`0mFJ/0ooK^03eIZ`060?ofkP0303eIZ`3om^h0?EV[0080
ooK^0P0mFJ/00`3om^h0?EV[0?ofkP170?ofkP030000003om^h0ooK^01D0ooK^00<000000?ofkP3o
m^h0E@3om^h10?ooo`00F03om^h00`000000ooK^0?ofkP0D0?ofkP030000003om^h0ooK^04H0ooK^
00@0?EV[0?ofkP3om^h0?EV[0`3om^h203eIZ`L0ooK^0P0mFJ/:0?ofkP0303eIZ`3om^h0?EV[0080
?EV[2@3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3o
m^h0303om^h00`0mFJ/0ooK^0?ofkP070?ofkP<0?EV[00<0ooK^03eIZ`3om^h02@3om^h203eIZ`L0
ooK^0P0mFJ/30?ofkP0403eIZ`3om^h0ooK^03eIZdP0ooK^00<000000?ofkP3om^h0503om^h00`00
0000ooK^0?ofkP1F0?ofkP40oooo001H0?ofkP030000003om^h0ooK^01@0ooK^00<000000?ofkP3o
m^h0A`3om^h00`0mFJ/0ooK^03eIZ`030?ofkP80?EV[203om^h00`0mFJ/0ooK^0?ofkP080?ofkP03
03eIZ`3om^h0ooK^0080ooK^0P0mFJ/70?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3o
m^h03@3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00D0ooK^0P0mFJ/40?ofkP03
03eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h01P3om^h203eIZ`<0ooK^00<0?EV[0?ofkP0m
FJ/0B@3om^h00`000000ooK^0?ofkP0D0?ofkP030000003om^h0ooK^05H0ooK^0@3oool005P0ooK^
00<000000?ofkP3om^h0503om^h00`000000ooK^0?ofkP170?ofkP0403eIZ`3om^h0?EV[03eIZ`<0
ooK^00<0?EV[0?ofkP3om^h01P3om^h303eIZ`P0ooK^00<0?EV[0?ofkP3om^h0103om^h303eIZ`@0
ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00`0
ooK^00<0?EV[0?ofkP3om^h00P3om^h303eIZ`H0ooK^00<0?EV[0?ofkP3om^h01P3om^h303eIZ`P0
ooK^00@0?EV[0?ofkP3om^h0ooK^0P0mFJ/00`3om^h0?EV[0?ofkP180?ofkP030000003om^h0ooK^
01@0ooK^00<000000?ofkP3om^h0EP3om^h10?ooo`00F@3om^h00`000000ooK^0?ofkP0C0?ofkP03
0000003om^h0ooK^04L0ooK^00@0?EV[0?ofkP0mFJ/0?EV[0`3om^h203eIZ`L0ooK^00@0?EV[0?of
kP3om^h0?EV[1`3om^h00`0mFJ/0ooK^0?ofkP070?ofkP<0?EV[00<0ooK^03eIZ`3om^h03@3om^h0
0`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP0mFJ/00P0mFJ/9
0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00@0?EV[0?ofkP3om^h0?EV[1`3om^h203eIZ`<0ooK^0P0m
FJ/00`3om^h0?EV[0?ofkP180?ofkP030000003om^h0ooK^01<0ooK^00<000000?ofkP3om^h0E`3o
m^h10?ooo`00F@3om^h00`000000ooK^0?ofkP0C0?ofkP030000003om^h0ooK^04P0ooK^0P0mFJ/0
1`3om^h0?EV[0?ofkP3om^h0?EV[0?ofkP0mFJ/01P3om^h0100mFJ/0ooK^0?ofkP3om^h203eIZ`D0
ooK^00<0?EV[0?ofkP3om^h02P3om^h403eIZ``0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0
ooK^0?ofkP0:0?ofkP@0?EV[2`3om^h00`0mFJ/0ooK^0?ofkP040?ofkP80?EV[0`3om^h00`0mFJ/0
ooK^0?ofkP040?ofkP0303eIZ`3om^h0?EV[0080ooK^00@0?EV[0?ofkP0mFJ/0?EV[BP3om^h00`00
0000ooK^0?ofkP0C0?ofkP030000003om^h0ooK^05L0ooK^0@3oool005T0ooK^00<000000?ofkP3o
m^h04`3om^h00`000000ooK^0?ofkP180?ofkP80?EV[00D0ooK^03eIZ`3om^h0ooK^03eIZ`020?of
kP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP030?of
kP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h01@0mFJ/70?ofkP0303eIZ`3om^h0ooK^
00d0ooK^00<0?EV[0?ofkP3om^h01@3om^h503eIZ`80ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0m
FJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h00`3om^h0100m
FJ/0ooK^0?ofkP0mFJ/20?ofkP0403eIZ`3om^h0?EV[03eIZdX0ooK^00<000000?ofkP3om^h04`3o
m^h00`000000ooK^0?ofkP1G0?ofkP40oooo001J0?ofkP030000003om^h0ooK^0180ooK^00<00000
0?ofkP3om^h0B03om^h203eIZ`80ooK^00<0?EV[0?ofkP0mFJ/00`3om^h00`0mFJ/0ooK^0?ofkP02
0?ofkP0303eIZ`3om^h0ooK^00@0ooK^0P0mFJ/30?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[
0?ofkP3om^h01@3om^h503eIZ`80ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP05
03eIZ`L0ooK^00<0?EV[0?ofkP3om^h02P3om^h0100mFJ/0ooK^0?ofkP3om^h203eIZ`H0ooK^00<0
?EV[0?ofkP3om^h00P3om^h02`0mFJ/0ooK^0?ofkP3om^h0?EV[0?ofkP0mFJ/0ooK^03eIZ`3om^h0
?EV[04X0ooK^00<000000?ofkP3om^h04P3om^h00`000000ooK^0?ofkP1H0?ofkP40oooo001J0?of
kP030000003om^h0ooK^0140ooK^00<000000?ofkP3om^h0BP3om^h203eIZ`040?ofkP0mFJ/0ooK^
03eIZ`@0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0403eIZ`3om^h0
ooK^03eIZ``0ooK^00<0?EV[0?ofkP3om^h02P3om^hE03eIZ``0ooK^00<0?EV[0?ofkP3om^h02P3o
m^h0100mFJ/0ooK^0?ofkP0mFJ/70?ofkP0303eIZ`3om^h0ooK^0080ooK^00D0?EV[0?ofkP3om^h0
ooK^03eIZ`020?ofkP0403eIZ`3om^h0?EV[03eIZd`0ooK^00<000000?ofkP3om^h04@3om^h00`00
0000ooK^0?ofkP1H0?ofkP40oooo001J0?ofkP030000003om^h0ooK^0140ooK^00<000000?ofkP3o
m^h0BP3om^h203eIZ`80ooK^00<0?EV[0?ofkP0mFJ/0103om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[
00P0ooK^0`0mFJ/<0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0m
FJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00X0ooK^0`0mFJ/80?ofkP0503eIZ`3om^h0ooK^
0?ofkP0mFJ/0103om^h00`0mFJ/0ooK^03eIZ`020?ofkP80?EV[C03om^h00`000000ooK^0?ofkP0A
0?ofkP030000003om^h0ooK^05P0ooK^0@3oool005/0ooK^00<000000?ofkP3om^h0403om^h00`00
0000ooK^0?ofkP1:0?ofkP80?EV[0P3om^h00`0mFJ/0ooK^03eIZ`050?ofkP0403eIZ`3om^h0ooK^
03eIZ`X0ooK^0P0mFJ/;0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h03@3om^h0
0`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00T0ooK^0P0mFJ/:0?ofkP0403eIZ`3om^h0
ooK^03eIZ`D0ooK^00<0?EV[0?ofkP0mFJ/00P3om^h203eIZd`0ooK^00<000000?ofkP3om^h0403o
m^h00`000000ooK^0?ofkP1I0?ofkP40oooo001K0?ofkP030000003om^h0ooK^0100ooK^00<00000
0?ofkP3om^h0B`3om^h0100mFJ/0ooK^0?ofkP3om^h203eIZ`H0ooK^00<0?EV[0?ofkP0mFJ/02P3o
m^h0100mFJ/0ooK^03eIZ`0mFJ/90?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h0
3@3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00L0ooK^0P0mFJ/00`3om^h0?EV[
0?ofkP090?ofkP0303eIZ`3om^h0?EV[00H0ooK^0P0mFJ/30?ofkP0303eIZ`3om^h0ooK^04/0ooK^
00<000000?ofkP3om^h0403om^h00`000000ooK^0?ofkP1I0?ofkP40oooo001K0?ofkP030000003o
m^h0ooK^0100ooK^00<000000?ofkP3om^h0B`3om^h0100mFJ/0ooK^0?ofkP3om^h203eIZ`L0ooK^
0P0mFJ/:0?ofkP0403eIZ`3om^h0ooK^0?ofkP80?EV[1`3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP03
03eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP050?ofkP80
?EV[0`3om^h00`0mFJ/0ooK^0?ofkP080?ofkP80?EV[1`3om^h203eIZ`<0ooK^00<0?EV[0?ofkP3o
m^h0B`3om^h00`000000ooK^0?ofkP0@0?ofkP030000003om^h0ooK^05T0ooK^0@3oool005`0ooK^
00<000000?ofkP3om^h03`3om^h00`000000ooK^0?ofkP1<0?ofkP0503eIZ`3om^h0ooK^0?ofkP0m
FJ/0203om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00<0ooK^0P0mFJ/50?ofkP03
03eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP03
03eIZ`3om^h0ooK^00<0ooK^0P0mFJ/50?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3o
m^h01P3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[04h0ooK^00<000000?ofkP3om^h03`3om^h00`00
0000ooK^0?ofkP1J0?ofkP40oooo001L0?ofkP030000003om^h0ooK^00l0ooK^00<000000?ofkP3o
m^h0C03om^h0100mFJ/0ooK^0?ofkP3om^h203eIZ`L0ooK^0`0mFJ/80?ofkP0303eIZ`3om^h0ooK^
00D0ooK^0P0mFJ/30?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0m
FJ/0ooK^0?ofkP0<0?ofkP0403eIZ`3om^h0ooK^0?ofkP80?EV[1`3om^h00`0mFJ/0ooK^0?ofkP06
0?ofkP<0?EV[1`3om^h203eIZ`<0ooK^00<0?EV[0?ofkP3om^h0C03om^h00`000000ooK^0?ofkP0?
0?ofkP030000003om^h0ooK^05X0ooK^0@3oool005`0ooK^00<000000?ofkP3om^h03`3om^h00`00
0000ooK^0?ofkP1=0?ofkP0603eIZ`3om^h0ooK^03eIZ`3om^h0?EV[1P3om^h0100mFJ/0ooK^0?of
kP0mFJ/70?ofkP0303eIZ`3om^h0ooK^00L0ooK^0P0mFJ/00`3om^h0?EV[0?ofkP0=0?ofkP0303eI
Z`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h0303om^h0100mFJ/0ooK^03eIZ`0mFJ/90?ofkP03
03eIZ`3om^h0ooK^00D0ooK^00@0?EV[0?ofkP3om^h0?EV[1P3om^h00`0mFJ/0ooK^03eIZ`020?of
kP0303eIZ`3om^h0ooK^04d0ooK^00<000000?ofkP3om^h03`3om^h00`000000ooK^0?ofkP1J0?of
kP40oooo001M0?ofkP030000003om^h0ooK^00h0ooK^00<000000?ofkP3om^h0C@3om^h0100mFJ/0
ooK^0?ofkP0mFJ/20?ofkP0303eIZ`3om^h0ooK^00<0ooK^00@0?EV[0?ofkP3om^h0ooK^0P0mFJ/5
0?ofkP0303eIZ`3om^h0ooK^00T0ooK^100mFJ/<0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[
0?ofkP3om^h02P3om^h403eIZ`/0ooK^00<0?EV[0?ofkP3om^h00`3om^h203eIZ`<0ooK^00<0?EV[
0?ofkP3om^h00`3om^h0100mFJ/0ooK^0?ofkP0mFJ/20?ofkP0303eIZ`3om^h0ooK^04d0ooK^00<0
00000?ofkP3om^h03P3om^h00`000000ooK^0?ofkP1K0?ofkP40oooo001M0?ofkP030000003om^h0
ooK^00d0ooK^00<000000?ofkP3om^h0C`3om^h00`0mFJ/0ooK^03eIZ`030?ofkP0303eIZ`3om^h0
ooK^0080ooK^00<0?EV[0?ofkP3om^h00`3om^h203eIZ`<0ooK^00<0?EV[0?ofkP3om^h02P3om^h0
0`0mFJ/0ooK^0?ofkP0503eIZ`L0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP05
0?ofkPD0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0403eIZ`3om^h0ooK^0?ofkP80?EV[1@3o
m^h00`0mFJ/0ooK^0?ofkP020?ofkP0703eIZ`3om^h0ooK^0?ofkP0mFJ/0ooK^03eIZ`1A0?ofkP03
0000003om^h0ooK^00d0ooK^00<000000?ofkP3om^h0F`3om^h10?ooo`00G@3om^h00`000000ooK^
0?ofkP0=0?ofkP030000003om^h0ooK^04l0ooK^00<0?EV[0?ofkP0mFJ/0103om^h01@0mFJ/0ooK^
0?ofkP3om^h0?EV[00L0ooK^00@0?EV[0?ofkP3om^h0?EV[303om^h00`0mFJ/0ooK^0?ofkP050?of
kPD0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00D0?EV[1`3om^h00`0m
FJ/0ooK^0?ofkP0:0?ofkP0403eIZ`3om^h0ooK^03eIZ`H0ooK^00<0?EV[0?ofkP3om^h00P3om^h0
1@0mFJ/0ooK^0?ofkP3om^h0?EV[0080ooK^00<0?EV[0?ofkP3om^h0C`3om^h00`000000ooK^0?of
kP0=0?ofkP030000003om^h0ooK^05/0ooK^0@3oool005h0ooK^00<000000?ofkP3om^h0303om^h0
0`000000ooK^0?ofkP1@0?ofkP0303eIZ`3om^h0?EV[00@0ooK^00D0?EV[0?ofkP3om^h0ooK^03eI
Z`070?ofkP<0?EV[303om^h00`0mFJ/0ooK^0?ofkP0:0?ofkQD0?EV[303om^h00`0mFJ/0ooK^0?of
kP0:0?ofkP<0?EV[1`3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00@0ooK^00<0?EV[0?ofkP0mFJ/0
DP3om^h00`000000ooK^0?ofkP0<0?ofkP030000003om^h0ooK^05`0ooK^0@3oool005h0ooK^00<0
00000?ofkP3om^h0303om^h00`000000ooK^0?ofkP1@0?ofkP0303eIZ`3om^h0?EV[00D0ooK^00@0
?EV[0?ofkP3om^h0?EV[2@3om^h203eIZ`/0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^
0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h02@3om^h203eIZ`T0ooK^
00@0?EV[0?ofkP3om^h0?EV[1@3om^h00`0mFJ/0ooK^03eIZ`1B0?ofkP030000003om^h0ooK^00`0
ooK^00<000000?ofkP3om^h0G03om^h10?ooo`00GP3om^h00`000000ooK^0?ofkP0<0?ofkP030000
003om^h0ooK^0540ooK^0P0mFJ/60?ofkP0303eIZ`3om^h0?EV[00T0ooK^00@0?EV[0?ofkP0mFJ/0
?EV[2@3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3o
m^h02`3om^h00`0mFJ/0ooK^0?ofkP080?ofkP80?EV[00<0ooK^03eIZ`3om^h0203om^h00`0mFJ/0
ooK^03eIZ`060?ofkP80?EV[D`3om^h00`000000ooK^0?ofkP0<0?ofkP030000003om^h0ooK^05`0
ooK^0@3oool005h0ooK^00<000000?ofkP3om^h0303om^h00`000000ooK^0?ofkP1A0?ofkP80?EV[
1`3om^h203eIZ`T0ooK^00@0?EV[0?ofkP3om^h0ooK^0P0mFJ/80?ofkP0303eIZ`3om^h0ooK^00/0
ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00H0
ooK^0P0mFJ/30?ofkP0303eIZ`3om^h0ooK^00L0ooK^0P0mFJ/70?ofkP80?EV[D`3om^h00`000000
ooK^0?ofkP0<0?ofkP030000003om^h0ooK^05`0ooK^0@3oool005l0ooK^00<000000?ofkP3om^h0
2`3om^h00`000000ooK^0?ofkP1B0?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h0
1`3om^h00`0mFJ/0ooK^0?ofkP030?ofkP<0?EV[1@3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eI
Z`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP030?ofkP<0?EV[
1@3om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h0
DP3om^h00`000000ooK^0?ofkP0;0?ofkP030000003om^h0ooK^05d0ooK^0@3oool005l0ooK^00<0
00000?ofkP3om^h02`3om^h00`000000ooK^0?ofkP1C0?ofkP0303eIZ`3om^h0ooK^00D0ooK^0`0m
FJ/70?ofkP0303eIZ`3om^h0ooK^00H0ooK^0P0mFJ/30?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0
?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0403eIZ`3om^h0ooK^0?ofkP80?EV[
203om^h00`0mFJ/0ooK^0?ofkP050?ofkP<0?EV[1`3om^h00`0mFJ/0ooK^0?ofkP1C0?ofkP030000
003om^h0ooK^00/0ooK^00<000000?ofkP3om^h0G@3om^h10?ooo`00G`3om^h00`000000ooK^0?of
kP0:0?ofkP030000003om^h0ooK^05D0ooK^00<0?EV[0?ofkP3om^h0103om^h0100mFJ/0ooK^0?of
kP0mFJ/60?ofkP0303eIZ`3om^h0ooK^00P0ooK^0P0mFJ/00`3om^h0?EV[0?ofkP0=0?ofkP0303eI
Z`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h02`3om^h0100mFJ/0ooK^03eIZ`0mFJ/90?ofkP03
03eIZ`3om^h0ooK^00D0ooK^00@0?EV[0?ofkP3om^h0?EV[1P3om^h00`0mFJ/0ooK^0?ofkP1D0?of
kP030000003om^h0ooK^00/0ooK^00<000000?ofkP3om^h0G@3om^h10?ooo`00H03om^h00`000000
ooK^0?ofkP090?ofkP030000003om^h0ooK^05H0ooK^00<0?EV[0?ofkP3om^h00`3om^h0100mFJ/0
ooK^0?ofkP3om^h203eIZ`D0ooK^00<0?EV[0?ofkP3om^h02@3om^h403eIZ``0ooK^00<0?EV[0?of
kP3om^h0303om^h00`0mFJ/0ooK^0?ofkP090?ofkP@0?EV[2`3om^h00`0mFJ/0ooK^0?ofkP030?of
kP80?EV[0`3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^05H0ooK^00<000000?of
kP3om^h02@3om^h00`000000ooK^0?ofkP1N0?ofkP40oooo001P0?ofkP030000003om^h0ooK^00T0
ooK^00<000000?ofkP3om^h0E`3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00<0
ooK^0P0mFJ/30?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h01@0mFJ/70?ofkP03
03eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h01@3om^h403eIZ`80ooK^00<0?EV[0?ofkP3o
m^h02P3om^h0100mFJ/0ooK^0?ofkP3om^h203eIZ`D0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0m
FJ/0ooK^0?ofkP1G0?ofkP030000003om^h0ooK^00T0ooK^00<000000?ofkP3om^h0GP3om^h10?oo
o`00H03om^h00`000000ooK^0?ofkP090?ofkP030000003om^h0ooK^05P0ooK^0P0mFJ/30?ofkP03
03eIZ`3om^h0ooK^00@0ooK^00@0?EV[0?ofkP3om^h0?EV[303om^h00`0mFJ/0ooK^0?ofkP050?of
kPD0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00D0?EV[1P3om^h00`0m
FJ/0ooK^0?ofkP0:0?ofkP0403eIZ`3om^h0ooK^03eIZ`H0ooK^00@0?EV[0?ofkP3om^h0ooK^0P0m
FJ]J0?ofkP030000003om^h0ooK^00T0ooK^00<000000?ofkP3om^h0GP3om^h10?ooo`00H@3om^h0
0`000000ooK^0?ofkP080?ofkP030000003om^h0ooK^05X0ooK^00@0?EV[0?ofkP3om^h0?EV[1`3o
m^h303eIZ``0ooK^00<0?EV[0?ofkP3om^h02P3om^hD03eIZ`/0ooK^00<0?EV[0?ofkP3om^h02P3o
m^h303eIZ`L0ooK^00@0?EV[0?ofkP3om^h0?EV[G03om^h00`000000ooK^0?ofkP080?ofkP030000
003om^h0ooK^05l0ooK^0@3oool00640ooK^00<000000?ofkP3om^h0203om^h00`000000ooK^0?of
kP1K0?ofkP0303eIZ`3om^h0?EV[00T0ooK^0P0mFJ/;0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0
?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00T0ooK^0P0m
FJ/90?ofkP0303eIZ`3om^h0?EV[05d0ooK^00<000000?ofkP3om^h0203om^h00`000000ooK^0?of
kP1O0?ofkP40oooo001Q0?ofkP030000003om^h0ooK^00P0ooK^00<000000?ofkP3om^h0G03om^h2
03eIZ`T0ooK^00@0?EV[0?ofkP0mFJ/0?EV[2@3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3o
m^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP070?ofkP80?EV[00<0
ooK^03eIZ`3om^h0203om^h203eIZeh0ooK^00<000000?ofkP3om^h0203om^h00`000000ooK^0?of
kP1O0?ofkP40oooo001R0?ofkP030000003om^h0ooK^00L0ooK^00<000000?ofkP3om^h0G@3om^h0
0`0mFJ/0ooK^0?ofkP070?ofkP0403eIZ`3om^h0ooK^0?ofkP<0?EV[1P3om^h00`0mFJ/0ooK^0?of
kP0<0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?of
kP040?ofkP<0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^05d0ooK^00<0
00000?ofkP3om^h01`3om^h00`000000ooK^0?ofkP1P0?ofkP40oooo001R0?ofkP030000003om^h0
ooK^00L0ooK^00<000000?ofkP3om^h0GP3om^h203eIZ`L0ooK^00<0?EV[0?ofkP3om^h0103om^h3
03eIZ`<0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0
ooK^00/0ooK^00@0?EV[0?ofkP3om^h0ooK^0`0mFJ/60?ofkP0303eIZ`3om^h0ooK^00D0ooK^0P0m
FJ]P0?ofkP030000003om^h0ooK^00L0ooK^00<000000?ofkP3om^h0H03om^h10?ooo`00HP3om^h0
0`000000ooK^0?ofkP060?ofkP030000003om^h0ooK^0640ooK^00<0?EV[0?ofkP3om^h0103om^h0
0`0mFJ/0ooK^0?ofkP070?ofkP80?EV[00<0ooK^03eIZ`3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0;
0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00@0?EV[0?ofkP0mFJ/0?EV[2@3om^h00`0mFJ/0ooK^0?of
kP040?ofkP0303eIZ`3om^h0ooK^0640ooK^00<000000?ofkP3om^h01P3om^h00`000000ooK^0?of
kP1P0?ofkP40oooo001S0?ofkP030000003om^h0ooK^00D0ooK^00<000000?ofkP3om^h0HP3om^h0
0`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00T0ooK^100mFJ/<0?ofkP0303eIZ`3om^h0
ooK^00/0ooK^00<0?EV[0?ofkP3om^h02P3om^h403eIZ`X0ooK^00<0?EV[0?ofkP3om^h0103om^h0
0`0mFJ/0ooK^0?ofkP1R0?ofkP030000003om^h0ooK^00D0ooK^00<000000?ofkP3om^h0H@3om^h1
0?ooo`00H`3om^h00`000000ooK^0?ofkP050?ofkP030000003om^h0ooK^06<0ooK^0P0mFJ/40?of
kP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h01@0mFJ/70?ofkP0303eIZ`3om^h0ooK^
00/0ooK^00<0?EV[0?ofkP3om^h01@3om^h503eIZ`80ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0m
FJ/0ooK^0?ofkP020?ofkP80?EV[I@3om^h00`000000ooK^0?ofkP050?ofkP030000003om^h0ooK^
0640ooK^0@3oool006<0ooK^00<000000?ofkP3om^h01@3om^h00`000000ooK^0?ofkP1U0?ofkP05
03eIZ`3om^h0ooK^0?ofkP0mFJ/02`3om^h00`0mFJ/0ooK^0?ofkP050?ofkPD0?EV[0P3om^h00`0m
FJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00D0?EV[1`3om^h00`0mFJ/0ooK^0?ofkP090?of
kP0503eIZ`3om^h0ooK^0?ofkP0mFJ/0I`3om^h00`000000ooK^0?ofkP050?ofkP030000003om^h0
ooK^0640ooK^0@3oool006@0ooK^00<000000?ofkP3om^h0103om^h00`000000ooK^0?ofkP1V0?of
kP0403eIZ`3om^h0ooK^03eIZ`/0ooK^00<0?EV[0?ofkP3om^h02P3om^hC03eIZ``0ooK^00<0?EV[
0?ofkP3om^h02@3om^h0100mFJ/0ooK^0?ofkP0mFJ]X0?ofkP030000003om^h0ooK^00@0ooK^00<0
00000?ofkP3om^h0HP3om^h10?ooo`00I03om^h00`000000ooK^0?ofkP040?ofkP030000003om^h0
ooK^06L0ooK^0`0mFJ/;0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h02`3om^h0
0`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00T0ooK^0`0mFJ]Y0?ofkP030000003om^h0
ooK^00@0ooK^00<000000?ofkP3om^h0HP3om^h10?ooo`00I03om^h00`000000ooK^0?ofkP040?of
kP030000003om^h0ooK^06T0ooK^0P0mFJ/:0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?of
kP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00T0ooK^0P0mFJ][0?of
kP030000003om^h0ooK^00@0ooK^00<000000?ofkP3om^h0HP3om^h10?ooo`00I@3om^h00`000000
ooK^0?ofkP030?ofkP030000003om^h0ooK^06/0ooK^0P0mFJ/90?ofkP0303eIZ`3om^h0ooK^00/0
ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00L0
ooK^0P0mFJ]]0?ofkP030000003om^h0ooK^00<0ooK^00<000000?ofkP3om^h0H`3om^h10?ooo`00
I@3om^h00`000000ooK^0?ofkP030?ofkP030000003om^h0ooK^06d0ooK^0`0mFJ/60?ofkP0303eI
Z`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eI
Z`3om^h0ooK^00@0ooK^0`0mFJ]_0?ofkP030000003om^h0ooK^00<0ooK^00<000000?ofkP3om^h0
H`3om^h10?ooo`00I@3om^h00`000000ooK^0?ofkP020?ofkP030000003om^h0ooK^0740ooK^0`0m
FJ/30?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?of
kP0;0?ofkP0403eIZ`3om^h0ooK^0?ofkP<0?EV[L`3om^h00`000000ooK^0?ofkP020?ofkP030000
003om^h0ooK^06<0ooK^0@3oool006D0ooK^00<000000?ofkP3om^h00P3om^h00`000000ooK^0?of
kP1d0?ofkP80?EV[00<0ooK^03eIZ`3om^h0303om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3o
m^h0ooK^00/0ooK^00@0?EV[0?ofkP0mFJ/0?EV[MP3om^h00`000000ooK^0?ofkP020?ofkP030000
003om^h0ooK^06<0ooK^0@3oool006H0ooK^00D000000?ofkP3om^h0ooK^0000001h0?ofkPD0?EV[
2P3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00P0ooK^1@0mFJ]h0?ofkP050000
003om^h0ooK^0?ofkP000000IP3om^h10?ooo`00IP3om^h01@000000ooK^0?ofkP3om^h0000007d0
ooK^1`0mFJ/30?ofkP0303eIZ`3om^h0ooK^00/0ooK^00@0?EV[0?ofkP3om^h0ooK^1`0mFJ]m0?of
kP050000003om^h0ooK^0?ofkP000000IP3om^h10?ooo`00IP3om^h01@000000ooK^0?ofkP3om^h0
000008@0ooK^5@0mFJ^40?ofkP050000003om^h0ooK^0?ofkP000000IP3om^h10?ooo`00I`3om^h0
10000000ooK^0?ofkP00003o0?ofkQh0ooK^00@000000?ofkP3om^h00000I`3om^h10?ooo`00I`3o
m^h010000000ooK^0?ofkP00003o0?ofkQh0ooK^00@000000?ofkP3om^h00000I`3om^h10?ooo`00
I`3om^h010000000ooK^0?ofkP00003o0?ofkQh0ooK^00@000000?ofkP3om^h00000I`3om^h10?oo
o`00J03om^h200000?l0ooK^803om^h2000006P0ooK^0@3oool006P0ooK^0P00003o0?ofkR00ooK^
0P00001X0?ofkP40oooo001X0?ofkP800000o`3om^hP0?ofkP800000J03om^h10?ooo`00J@3om^h0
0`000000ooK^0?ofkP3o0?ofkQh0ooK^00<000000?ofkP3om^h0I`3om^h10?ooo`00J@3om^ko0000
02800000J@3om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03o
m^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00
o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?of
kP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o
0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^
0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0
ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h1
0?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3o
m^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40
oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?of
k_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3o
ool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^
m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?oo
o`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd
0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo
003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0
ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool0
0?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03o
m^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00
o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?of
kP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o
0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^
0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0
ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h1
0?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3o
m^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40
oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?of
k_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3o
ool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^
m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00001\
\>"],
  ImageRangeCache->{{{0, 499}, {499, 0}} -> {-5.00005*^-06, -5.00005*^-06, \
0.00200403, 0.00200403}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
%%ImageSize: 500 500 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics3D
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Background color
1 .961 .933 r
MFill
% Scaling calculations
0 1 0 1 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 0 r
.25 Mabswid
[ ] 0 setdash
.91053 .22236 m
.97075 .49223 L
s
.97075 .49223 m
.19793 .35868 L
s
.19793 .35868 m
.24028 .08168 L
s
.24028 .08168 m
.91053 .22236 L
s
.67872 .58361 m
.16861 .50547 L
s
.16861 .50547 m
.13045 .74993 L
s
.13045 .74993 m
.6978 .81857 L
s
.6978 .81857 m
.67872 .58361 L
s
.91053 .22236 m
.97075 .49223 L
s
.97075 .49223 m
.6978 .81857 L
s
.6978 .81857 m
.67872 .58361 L
s
.67872 .58361 m
.91053 .22236 L
s
.24028 .08168 m
.16861 .50547 L
s
.16861 .50547 m
.13045 .74993 L
s
.13045 .74993 m
.19793 .35868 L
s
.19793 .35868 m
.24028 .08168 L
s
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
.24 .35 .67 r
.5 Mabswid
.47256 .55588 m
.44775 .54761 L
s
.48149 .53577 m
.47256 .55588 L
s
.49565 .56818 m
.47256 .55588 L
s
.50501 .54826 m
.49565 .56818 L
s
.51618 .58405 m
.49565 .56818 L
s
.44775 .54761 m
.42217 .54369 L
s
.45626 .52733 m
.44775 .54761 L
s
.52593 .56436 m
.51618 .58405 L
s
.53334 .60293 m
.51618 .58405 L
s
.42217 .54369 m
.39675 .54431 L
s
.43025 .52327 m
.42217 .54369 L
s
.54345 .58347 m
.53334 .60293 L
s
.54642 .62415 m
.53334 .60293 L
s
.39675 .54431 m
.3725 .54952 L
s
.40443 .52378 m
.39675 .54431 L
s
.55683 .60493 m
.54642 .62415 L
s
.55482 .64691 m
.54642 .62415 L
s
.3725 .54952 m
.35037 .55922 L
s
.37979 .52894 m
.3725 .54952 L
s
.45626 .52733 m
.48149 .53577 L
s
.49075 .51493 m
.48149 .53577 L
s
.48149 .53577 m
.50501 .54826 L
s
.5147 .52763 m
.50501 .54826 L
s
.50501 .54826 m
.52593 .56436 L
s
.43025 .52327 m
.45626 .52733 L
s
.46508 .50631 m
.45626 .52733 L
s
.53603 .54395 m
.52593 .56436 L
s
.52593 .56436 m
.54345 .58347 L
s
.40443 .52378 m
.43025 .52327 L
s
.43863 .5021 m
.43025 .52327 L
s
.56548 .62794 m
.55482 .64691 L
s
.5581 .67035 m
.55482 .64691 L
s
.35037 .55922 m
.33134 .57313 L
s
.35733 .53862 m
.35037 .55922 L
s
.55392 .5633 m
.54345 .58347 L
s
.54345 .58347 m
.55683 .60493 L
s
.37979 .52894 m
.40443 .52378 L
s
.41238 .5025 m
.40443 .52378 L
s
.56763 .58501 m
.55683 .60493 L
s
.55683 .60493 m
.56548 .62794 L
s
.56892 .65162 m
.5581 .67035 L
s
.55595 .6935 m
.5581 .67035 L
s
.35733 .53862 m
.37979 .52894 L
s
.38735 .50759 m
.37979 .52894 L
s
.46508 .50631 m
.49075 .51493 L
s
.50036 .49333 m
.49075 .51493 L
s
.49075 .51493 m
.5147 .52763 L
s
.33134 .57313 m
.31627 .59079 L
s
.33801 .55258 m
.33134 .57313 L
s
.52475 .50624 m
.5147 .52763 L
s
.5147 .52763 m
.53603 .54395 L
s
.43863 .5021 m
.46508 .50631 L
s
.47422 .48451 m
.46508 .50631 L
s
.54651 .52279 m
.53603 .54395 L
s
.53603 .54395 m
.55392 .5633 L
s
.41238 .5025 m
.43863 .5021 L
s
.44731 .48015 m
.43863 .5021 L
s
.57654 .60827 m
.56548 .62794 L
s
.56548 .62794 m
.56892 .65162 L
s
.33801 .55258 m
.35733 .53862 L
s
.36454 .51727 m
.35733 .53862 L
s
.56479 .54239 m
.55392 .5633 L
s
.55392 .5633 m
.56763 .58501 L
s
.56686 .675 m
.55595 .6935 L
s
.54831 .71538 m
.55595 .6935 L
s
.38735 .50759 m
.41238 .5025 L
s
.42063 .48044 m
.41238 .5025 L
s
.31627 .59079 m
.30595 .61157 L
s
.32274 .57035 m
.31627 .59079 L
s
.57883 .56435 m
.56763 .58501 L
s
.56763 .58501 m
.57654 .60827 L
s
.58015 .63219 m
.56892 .65162 L
s
.56892 .65162 m
.56686 .675 L
s
.36454 .51727 m
.38735 .50759 L
s
.3952 .48545 m
.38735 .50759 L
s
.47422 .48451 m
.50036 .49333 L
s
.51032 .47091 m
.50036 .49333 L
s
.50036 .49333 m
.52475 .50624 L
s
.32274 .57035 m
.33801 .55258 L
s
.34494 .53126 m
.33801 .55258 L
s
.53518 .48405 m
.52475 .50624 L
s
.52475 .50624 m
.54651 .52279 L
s
.44731 .48015 m
.47422 .48451 L
s
.48371 .4619 m
.47422 .48451 L
s
.55919 .69708 m
.54831 .71538 L
s
.53532 .73497 m
.54831 .71538 L
s
.30595 .61157 m
.301 .63465 L
s
.3123 .59129 m
.30595 .61157 L
s
.55738 .50083 m
.54651 .52279 L
s
.54651 .52279 m
.56479 .54239 L
s
.42063 .48044 m
.44731 .48015 L
s
.45633 .45737 m
.44731 .48015 L
s
.58801 .58786 m
.57654 .60827 L
s
.57654 .60827 m
.58015 .63219 L
s
.34494 .53126 m
.36454 .51727 L
s
.37203 .4951 m
.36454 .51727 L
s
.57606 .52068 m
.56479 .54239 L
s
.56479 .54239 m
.57883 .56435 L
s
.57817 .6558 m
.56686 .675 L
s
.56686 .675 m
.55919 .69708 L
s
.83 .24 .1 r
.72692 .56888 m
.73 .54129 L
s
.73 .54129 m
.69411 .53554 L
s
.73 .54129 m
.73513 .51389 L
s
.24 .35 .67 r
.3952 .48545 m
.42063 .48044 L
s
.42919 .45753 m
.42063 .48044 L
s
.3123 .59129 m
.32274 .57035 L
s
.32946 .54912 m
.32274 .57035 L
s
.83 .24 .1 r
.73513 .51389 m
.69922 .50799 L
s
.73513 .51389 m
.74214 .48758 L
s
.726 .59574 m
.72692 .56888 L
s
.72692 .56888 m
.69093 .56326 L
s
.24 .35 .67 r
.54608 .71683 m
.53532 .73497 L
s
.51741 .75129 m
.53532 .73497 L
s
.301 .63465 m
.30733 .61457 L
s
.301 .63465 m
.30182 .65903 L
s
.83 .24 .1 r
.69093 .56326 m
.69411 .53554 L
s
.69411 .53554 m
.65787 .52974 L
s
.69411 .53554 m
.69922 .50799 L
s
.74214 .48758 m
.7061 .48153 L
s
.74214 .48758 m
.75083 .46327 L
s
.69922 .50799 m
.66296 .50204 L
s
.69922 .50799 m
.7061 .48153 L
s
.24 .35 .67 r
.57883 .56435 m
.58801 .58786 L
s
.59181 .61202 m
.58015 .63219 L
s
.58015 .63219 m
.57817 .6558 L
s
.83 .24 .1 r
.6898 .59022 m
.69093 .56326 L
s
.69093 .56326 m
.65459 .55758 L
s
.24 .35 .67 r
.37203 .4951 m
.3952 .48545 L
s
.40334 .46246 m
.3952 .48545 L
s
.48371 .4619 m
.51032 .47091 L
s
.52066 .44764 m
.51032 .47091 L
s
.51032 .47091 m
.53518 .48405 L
s
.83 .24 .1 r
.72732 .62095 m
.726 .59574 L
s
.726 .59574 m
.6898 .59022 L
s
.24 .35 .67 r
.32946 .54912 m
.34494 .53126 L
s
.35213 .50913 m
.34494 .53126 L
s
.53518 .48405 m
.55738 .50083 L
s
.45633 .45737 m
.48371 .4619 L
s
.49355 .43843 m
.48371 .4619 L
s
.83 .24 .1 r
.65459 .55758 m
.65787 .52974 L
s
.65787 .52974 m
.62126 .52387 L
s
.65787 .52974 m
.66296 .50204 L
s
.24 .35 .67 r
.57049 .67808 m
.55919 .69708 L
s
.55919 .69708 m
.54608 .71683 L
s
.83 .24 .1 r
.7061 .48153 m
.66969 .47541 L
s
.7061 .48153 m
.71453 .45704 L
s
.66296 .50204 m
.62632 .49603 L
s
.66296 .50204 m
.66969 .47541 L
s
.24 .35 .67 r
.30733 .61457 m
.3123 .59129 L
s
.3189 .57022 m
.3123 .59129 L
s
.55738 .50083 m
.57606 .52068 L
s
.83 .24 .1 r
.65323 .58464 m
.65459 .55758 L
s
.65459 .55758 m
.61787 .55184 L
s
.24 .35 .67 r
.52794 .73327 m
.51741 .75129 L
s
.49527 .76347 m
.51741 .75129 L
s
.42919 .45753 m
.45633 .45737 L
s
.46569 .43372 m
.45633 .45737 L
s
.83 .24 .1 r
.69079 .6155 m
.6898 .59022 L
s
.6898 .59022 m
.65323 .58464 L
s
.75083 .46327 m
.71453 .45704 L
s
.75083 .46327 m
.76094 .44185 L
s
.24 .35 .67 r
.30182 .65903 m
.30855 .6836 L
s
.30823 .63921 m
.30182 .65903 L
s
.83 .24 .1 r
.61787 .55184 m
.62126 .52387 L
s
.62126 .52387 m
.62632 .49603 L
s
.24 .35 .67 r
.58801 .58786 m
.59181 .61202 L
s
.83 .24 .1 r
.66969 .47541 m
.63291 .46924 L
s
.66969 .47541 m
.67787 .45075 L
s
.62632 .49603 m
.58932 .48996 L
s
.62632 .49603 m
.63291 .46924 L
s
.24 .35 .67 r
.35213 .50913 m
.37203 .4951 L
s
.3798 .47208 m
.37203 .4951 L
s
.83 .24 .1 r
.69079 .6155 m
.72732 .62095 L
s
.73089 .64356 m
.72732 .62095 L
s
.61629 .57901 m
.61787 .55184 L
s
.24 .35 .67 r
.58992 .63586 m
.57817 .6558 L
s
.57817 .6558 m
.57049 .67808 L
s
.83 .24 .1 r
.65388 .61 m
.65323 .58464 L
s
.65323 .58464 m
.61629 .57901 L
s
.24 .35 .67 r
.40334 .46246 m
.42919 .45753 L
s
.43808 .43375 m
.42919 .45753 L
s
.83 .24 .1 r
.71453 .45704 m
.67787 .45075 L
s
.71453 .45704 m
.72428 .43545 L
s
.24 .35 .67 r
.3189 .57022 m
.32946 .54912 L
s
.33643 .52708 m
.32946 .54912 L
s
.888 .248 .105 r
.57484 .55954 m .59276 .5623 L .58669 .54012 L p F P
0 0 0 r
s
.24 .35 .67 r
.57606 .52068 m
.5781 .52382 L
s
.57883 .56435 m
.58093 .56048 L
s
.888 .248 .105 r
.58669 .54012 m .56993 .53748 L .57484 .55954 L p F P
0 0 0 r
s
.913 .257 .109 r
.56993 .53748 m .58669 .54012 L .57871 .5171 L p F P
0 0 0 r
s
.167 .247 .522 r
.58348 .50795 m .57871 .5171 L .58669 .54012 L p F P
0 0 0 r
s
.167 .247 .522 r
.58669 .54012 m .59201 .53023 L .58348 .50795 L p F P
0 0 0 r
s
.83 .24 .1 r
.58751 .51847 m
.62126 .52387 L
s
.136 .2 .437 r
.59201 .53023 m .58669 .54012 L .59276 .5623 L p F P
0 0 0 r
s
.24 .35 .67 r
.58075 .52792 m
.59046 .5429 L
s
.83 .24 .1 r
.58078 .54605 m
.58916 .54736 L
s
.59242 .54787 m
.61787 .55184 L
s
.24 .35 .67 r
.5878 .5478 m
.59046 .5429 L
s
.913 .257 .109 r
.57871 .5171 m .56349 .51466 L .56993 .53748 L p F P
0 0 0 r
s
.934 .265 .112 r
.56349 .51466 m .57871 .5171 L .56897 .49365 L p F P
0 0 0 r
s
.193 .286 .592 r
.57307 .48547 m .56897 .49365 L .57871 .5171 L p F P
0 0 0 r
s
.193 .286 .592 r
.57871 .5171 m .58348 .50795 L .57307 .48547 L p F P
0 0 0 r
s
.83 .24 .1 r
.58078 .54605 m
.58313 .52713 L
s
.58524 .51256 m
.58932 .48996 L
s
.63291 .46924 m
.59576 .463 L
s
.63291 .46924 m
.64082 .4444 L
s
.57398 .48744 m
.58932 .48996 L
s
.58932 .48996 m
.59576 .463 L
s
.24 .35 .67 r
.55725 .698 m
.54608 .71683 L
s
.54608 .71683 m
.52794 .73327 L
s
.913 .257 .109 r
.5531 .53484 m .56993 .53748 L .56349 .51466 L p F P
0 0 0 r
s
.913 .257 .109 r
.56349 .51466 m .54819 .51221 L .5531 .53484 L p F P
0 0 0 r
s
.934 .265 .112 r
.54819 .51221 m .56349 .51466 L .55561 .49147 L p F P
0 0 0 r
s
.934 .265 .112 r
.56897 .49365 m .55561 .49147 L .56349 .51466 L p F P
0 0 0 r
s
.888 .248 .105 r
.55683 .55676 m .57484 .55954 L .56993 .53748 L p F P
0 0 0 r
s
.888 .248 .105 r
.56993 .53748 m .5531 .53484 L .55683 .55676 L p F P
0 0 0 r
s
.24 .35 .67 r
.50547 .74552 m
.49527 .76347 L
s
.46984 .77082 m
.49527 .76347 L
s
.858 .238 .1 r
.57811 .58042 m .5968 .58325 L .59276 .5623 L p F P
0 0 0 r
s
.24 .35 .67 r
.58801 .58786 m
.59108 .58239 L
s
.858 .238 .1 r
.59276 .5623 m .57484 .55954 L .57811 .58042 L p F P
0 0 0 r
s
.136 .2 .437 r
.59276 .5623 m .59851 .55191 L .59201 .53023 L p F P
0 0 0 r
s
.098 .143 .332 r
.59851 .55191 m .59276 .5623 L .5968 .58325 L p F P
0 0 0 r
s
.215 .319 .651 r
.56097 .46321 m .55761 .47016 L .56897 .49365 L p F P
0 0 0 r
s
.215 .319 .651 r
.56897 .49365 m .57307 .48547 L .56097 .46321 L p F P
0 0 0 r
s
.952 .272 .115 r
.55561 .49147 m .56897 .49365 L .55761 .47016 L p F P
0 0 0 r
s
.83 .24 .1 r
.65388 .61 m
.69079 .6155 L
s
.69392 .63817 m
.69079 .6155 L
s
.57897 .57332 m
.58078 .54605 L
s
.24 .35 .67 r
.30733 .61457 m
.3139 .59372 L
s
.30823 .63921 m
.30733 .61457 L
s
.83 .24 .1 r
.6166 .60445 m
.61629 .57901 L
s
.57897 .57332 m
.5958 .57589 L
s
.59719 .5761 m
.61629 .57901 L
s
.24 .35 .67 r
.30855 .6836 m
.32101 .70718 L
s
.31515 .66408 m
.30855 .6836 L
s
.913 .257 .109 r
.53619 .53218 m .5531 .53484 L .54819 .51221 L p F P
0 0 0 r
s
.913 .257 .109 r
.54819 .51221 m .53284 .50975 L .53619 .53218 L p F P
0 0 0 r
s
.934 .265 .112 r
.53284 .50975 m .54819 .51221 L .5422 .48928 L p F P
0 0 0 r
s
.934 .265 .112 r
.55561 .49147 m .5422 .48928 L .54819 .51221 L p F P
0 0 0 r
s
.83 .24 .1 r
.54691 .51197 m
.57954 .51719 L
s
.952 .272 .115 r
.5422 .48928 m .55561 .49147 L .54644 .4683 L p F P
0 0 0 r
s
.952 .272 .115 r
.55761 .47016 m .54644 .4683 L .55561 .49147 L p F P
0 0 0 r
s
.83 .24 .1 r
.55193 .48382 m
.56624 .48617 L
s
.67787 .45075 m
.64082 .4444 L
s
.67787 .45075 m
.68724 .42897 L
s
.888 .248 .105 r
.53874 .55397 m .55683 .55676 L .5531 .53484 L p F P
0 0 0 r
s
.888 .248 .105 r
.5531 .53484 m .53619 .53218 L .53874 .55397 L p F P
0 0 0 r
s
.83 .24 .1 r
.54331 .54019 m
.58078 .54605 L
s
.858 .238 .1 r
.55932 .57757 m .57811 .58042 L .57484 .55954 L p F P
0 0 0 r
s
.858 .238 .1 r
.57484 .55954 m .55683 .55676 L .55932 .57757 L p F P
0 0 0 r
s
.83 .24 .1 r
.54331 .54019 m
.54691 .51197 L
s
.54691 .51197 m
.55193 .48382 L
s
.76094 .44185 m
.72428 .43545 L
s
.76094 .44185 m
.77214 .4242 L
s
.934 .265 .112 r
.5422 .48928 m .52875 .48708 L .53284 .50975 L p F P
0 0 0 r
s
.952 .272 .115 r
.52875 .48708 m .5422 .48928 L .53523 .46644 L p F P
0 0 0 r
s
.952 .272 .115 r
.54644 .4683 m .53523 .46644 L .5422 .48928 L p F P
0 0 0 r
s
.913 .257 .109 r
.5192 .52951 m .53619 .53218 L .53284 .50975 L p F P
0 0 0 r
s
.913 .257 .109 r
.53284 .50975 m .51742 .50728 L .5192 .52951 L p F P
0 0 0 r
s
.934 .265 .112 r
.51742 .50728 m .53284 .50975 L .52875 .48708 L p F P
0 0 0 r
s
.83 .24 .1 r
.59576 .463 m
.6034 .43798 L
s
.24 .35 .67 r
.3798 .47208 m
.40334 .46246 L
s
.888 .248 .105 r
.52055 .55116 m .53874 .55397 L .53619 .53218 L p F P
0 0 0 r
s
.888 .248 .105 r
.53619 .53218 m .5192 .52951 L .52055 .55116 L p F P
0 0 0 r
s
.24 .35 .67 r
.49355 .43843 m
.52066 .44764 L
s
.821 .226 .095 r
.57966 .59975 m .59871 .60259 L .5968 .58325 L p F P
0 0 0 r
s
.821 .226 .095 r
.5968 .58325 m .57811 .58042 L .57966 .59975 L p F P
0 0 0 r
s
.098 .143 .332 r
.5968 .58325 m .60284 .57261 L .59851 .55191 L p F P
0 0 0 r
s
.067 .097 .237 r
.60284 .57261 m .5968 .58325 L .59871 .60259 L p F P
0 0 0 r
s
.234 .348 .702 r
.54737 .44156 m .54482 .44706 L .55761 .47016 L p F P
0 0 0 r
s
.234 .348 .702 r
.55761 .47016 m .56097 .46321 L .54737 .44156 L p F P
0 0 0 r
s
.83 .24 .1 r
.55786 .45826 m
.55822 .45669 L
s
.969 .278 .118 r
.54644 .4683 m .55761 .47016 L .54482 .44706 L p F P
0 0 0 r
s
.83 .24 .1 r
.55193 .48382 m
.55642 .46449 L
s
.24 .35 .67 r
.54286 .46771 m
.5459 .46124 L
s
.52066 .44764 m
.54587 .46093 L
s
.858 .238 .1 r
.54044 .57471 m .55932 .57757 L .55683 .55676 L p F P
0 0 0 r
s
.858 .238 .1 r
.55683 .55676 m .53874 .55397 L .54044 .57471 L p F P
0 0 0 r
s
.83 .24 .1 r
.6166 .60445 m
.65388 .61 L
s
.65658 .63272 m
.65388 .61 L
s
.54126 .56757 m
.54331 .54019 L
s
.24 .35 .67 r
.33643 .52708 m
.35213 .50913 L
s
.3596 .48613 m
.35213 .50913 L
s
.193 .286 .592 r
.57723 .47719 m .57307 .48547 L .58348 .50795 L p F P
0 0 0 r
s
.193 .286 .592 r
.58348 .50795 m .58831 .49865 L .57723 .47719 L p F P
0 0 0 r
s
.167 .247 .522 r
.58831 .49865 m .58348 .50795 L .59201 .53023 L p F P
0 0 0 r
s
.934 .265 .112 r
.52875 .48708 m .51524 .48488 L .51742 .50728 L p F P
0 0 0 r
s
.952 .272 .115 r
.51524 .48488 m .52875 .48708 L .52399 .46458 L p F P
0 0 0 r
s
.952 .272 .115 r
.53523 .46644 m .52399 .46458 L .52875 .48708 L p F P
0 0 0 r
s
.913 .257 .109 r
.50213 .52683 m .5192 .52951 L .51742 .50728 L p F P
0 0 0 r
s
.913 .257 .109 r
.51742 .50728 m .50193 .5048 L .50213 .52683 L p F P
0 0 0 r
s
.934 .265 .112 r
.50193 .5048 m .51742 .50728 L .51524 .48488 L p F P
0 0 0 r
s
.83 .24 .1 r
.50917 .50592 m
.54691 .51197 L
s
.24 .35 .67 r
.46569 .43372 m
.49355 .43843 L
s
.83 .24 .1 r
.54126 .56757 m
.57897 .57332 L
s
.167 .247 .522 r
.59201 .53023 m .59742 .52016 L .58831 .49865 L p F P
0 0 0 r
s
.136 .2 .437 r
.59742 .52016 m .59201 .53023 L .59851 .55191 L p F P
0 0 0 r
s
.969 .278 .118 r
.53523 .46644 m .54644 .4683 L .53611 .44559 L p F P
0 0 0 r
s
.969 .278 .118 r
.54482 .44706 m .53611 .44559 L .54644 .4683 L p F P
0 0 0 r
s
.888 .248 .105 r
.50228 .54834 m .52055 .55116 L .5192 .52951 L p F P
0 0 0 r
s
.888 .248 .105 r
.5192 .52951 m .50213 .52683 L .50228 .54834 L p F P
0 0 0 r
s
.83 .24 .1 r
.50545 .53428 m
.54331 .54019 L
s
.215 .319 .651 r
.56436 .45617 m .56097 .46321 L .57307 .48547 L p F P
0 0 0 r
s
.83 .24 .1 r
.55822 .45669 m
.56367 .45761 L
s
.215 .319 .651 r
.57307 .48547 m .57723 .47719 L .56436 .45617 L p F P
0 0 0 r
s
.24 .35 .67 r
.56431 .48683 m
.56867 .47804 L
s
.83 .24 .1 r
.56542 .4579 m
.59576 .463 L
s
.24 .35 .67 r
.55248 .46587 m
.56867 .47804 L
s
.58223 .65834 m
.57049 .67808 L
s
.57049 .67808 m
.55725 .698 L
s
.83 .24 .1 r
.64082 .4444 m
.6034 .43798 L
s
.64082 .4444 m
.64981 .42243 L
s
.73666 .66268 m
.73089 .64356 L
s
.73089 .64356 m
.69392 .63817 L
s
.934 .265 .112 r
.51524 .48488 m .50169 .48267 L .50193 .5048 L p F P
0 0 0 r
s
.952 .272 .115 r
.50169 .48267 m .51524 .48488 L .51272 .4627 L p F P
0 0 0 r
s
.952 .272 .115 r
.52399 .46458 m .51272 .4627 L .51524 .48488 L p F P
0 0 0 r
s
.83 .24 .1 r
.51417 .47763 m
.55193 .48382 L
s
.858 .238 .1 r
.52146 .57184 m .54044 .57471 L .53874 .55397 L p F P
0 0 0 r
s
.858 .238 .1 r
.53874 .55397 m .52055 .55116 L .52146 .57184 L p F P
0 0 0 r
s
.821 .226 .095 r
.5605 .5969 m .57966 .59975 L .57811 .58042 L p F P
0 0 0 r
s
.821 .226 .095 r
.57811 .58042 m .55932 .57757 L .5605 .5969 L p F P
0 0 0 r
s
.24 .35 .67 r
.47963 .75287 m
.46984 .77082 L
s
.44232 .77285 m
.46984 .77082 L
s
.83 .24 .1 r
.50545 .53428 m
.50917 .50592 L
s
.969 .278 .118 r
.52399 .46458 m .53523 .46644 L .52739 .44412 L p F P
0 0 0 r
s
.969 .278 .118 r
.53611 .44559 m .52739 .44412 L .53523 .46644 L p F P
0 0 0 r
s
.913 .257 .109 r
.48498 .52413 m .50213 .52683 L .50193 .5048 L p F P
0 0 0 r
s
.913 .257 .109 r
.50193 .5048 m .48638 .50231 L .48498 .52413 L p F P
0 0 0 r
s
.934 .265 .112 r
.48638 .50231 m .50193 .5048 L .50169 .48267 L p F P
0 0 0 r
s
.83 .24 .1 r
.72428 .43545 m
.68724 .42897 L
s
.72428 .43545 m
.73502 .41761 L
s
.24 .35 .67 r
.3139 .59372 m
.3189 .57022 L
s
.32575 .54833 m
.3189 .57022 L
s
.32101 .70718 m
.33873 .72857 L
s
.32791 .68796 m
.32101 .70718 L
s
.83 .24 .1 r
.55672 .45644 m
.55822 .45669 L
s
.888 .248 .105 r
.48391 .54551 m .50228 .54834 L .50213 .52683 L p F P
0 0 0 r
s
.888 .248 .105 r
.50213 .52683 m .48498 .52413 L .48391 .54551 L p F P
0 0 0 r
s
.934 .265 .112 r
.50169 .48267 m .48808 .48045 L .48638 .50231 L p F P
0 0 0 r
s
.952 .272 .115 r
.48808 .48045 m .50169 .48267 L .50141 .46083 L p F P
0 0 0 r
s
.952 .272 .115 r
.51272 .4627 m .50141 .46083 L .50169 .48267 L p F P
0 0 0 r
s
.83 .24 .1 r
.50917 .50592 m
.51417 .47763 L
s
.136 .2 .437 r
.59851 .55191 m .60436 .54133 L .59742 .52016 L p F P
0 0 0 r
s
.098 .143 .332 r
.60436 .54133 m .59851 .55191 L .60284 .57261 L p F P
0 0 0 r
s
.24 .35 .67 r
.59046 .5429 m
.59992 .56666 L
s
.969 .278 .118 r
.51272 .4627 m .52399 .46458 L .51865 .44264 L p F P
0 0 0 r
s
.969 .278 .118 r
.52739 .44412 m .51865 .44264 L .52399 .46458 L p F P
0 0 0 r
s
.24 .35 .67 r
.53888 .71456 m
.52794 .73327 L
s
.52794 .73327 m
.50547 .74552 L
s
.43808 .43375 m
.46569 .43372 L
s
.858 .238 .1 r
.50238 .56895 m .52146 .57184 L .52055 .55116 L p F P
0 0 0 r
s
.858 .238 .1 r
.52055 .55116 m .50228 .54834 L .50238 .56895 L p F P
0 0 0 r
s
.821 .226 .095 r
.54124 .59403 m .5605 .5969 L .55932 .57757 L p F P
0 0 0 r
s
.821 .226 .095 r
.55932 .57757 m .54044 .57471 L .54124 .59403 L p F P
0 0 0 r
s
.913 .257 .109 r
.46775 .52142 m .48498 .52413 L .48638 .50231 L p F P
0 0 0 r
s
.913 .257 .109 r
.48638 .50231 m .47076 .49981 L .46775 .52142 L p F P
0 0 0 r
s
.934 .265 .112 r
.47076 .49981 m .48638 .50231 L .48808 .48045 L p F P
0 0 0 r
s
.83 .24 .1 r
.47103 .49981 m
.50917 .50592 L
s
.61884 .62721 m
.6166 .60445 L
s
.50317 .56176 m
.50545 .53428 L
s
.234 .348 .702 r
.54994 .436 m .54737 .44156 L .56097 .46321 L p F P
0 0 0 r
s
.234 .348 .702 r
.56097 .46321 m .56436 .45617 L .54994 .436 L p F P
0 0 0 r
s
.83 .24 .1 r
.5203 .45032 m
.55064 .45542 L
s
.969 .278 .118 r
.50141 .46083 m .51272 .4627 L .50988 .44116 L p F P
0 0 0 r
s
.969 .278 .118 r
.51865 .44264 m .50988 .44116 L .51272 .4627 L p F P
0 0 0 r
s
.83 .24 .1 r
.51417 .47763 m
.5203 .45032 L
s
.934 .265 .112 r
.48808 .48045 m .47443 .47822 L .47076 .49981 L p F P
0 0 0 r
s
.952 .272 .115 r
.47443 .47822 m .48808 .48045 L .49007 .45894 L p F P
0 0 0 r
s
.952 .272 .115 r
.50141 .46083 m .49007 .45894 L .48808 .48045 L p F P
0 0 0 r
s
.83 .24 .1 r
.50317 .56176 m
.54126 .56757 L
s
.24 .35 .67 r
.31515 .66408 m
.30823 .63921 L
s
.31489 .61862 m
.30823 .63921 L
s
.888 .248 .105 r
.46546 .54266 m .48391 .54551 L .48498 .52413 L p F P
0 0 0 r
s
.888 .248 .105 r
.48498 .52413 m .46775 .52142 L .46546 .54266 L p F P
0 0 0 r
s
.774 .211 .088 r
.57941 .61713 m .59841 .61991 L .59871 .60259 L p F P
0 0 0 r
s
.24 .35 .67 r
.58992 .63586 m
.59127 .61886 L
s
.774 .211 .088 r
.59871 .60259 m .57966 .59975 L .57941 .61713 L p F P
0 0 0 r
s
.067 .097 .237 r
.59871 .60259 m .60489 .59192 L .60284 .57261 L p F P
0 0 0 r
s
.24 .35 .67 r
.5945 .5763 m
.59992 .56666 L
s
.049 .072 .169 r
.60489 .59192 m .59871 .60259 L .59841 .61991 L p F P
0 0 0 r
s
.83 .24 .1 r
.60248 .60234 m
.6166 .60445 L
s
.251 .373 .747 r
.5325 .42094 m .53079 .42478 L .54482 .44706 L p F P
0 0 0 r
s
.251 .373 .747 r
.54482 .44706 m .54737 .44156 L .5325 .42094 L p F P
0 0 0 r
s
.982 .284 .121 r
.53611 .44559 m .54482 .44706 L .53079 .42478 L p F P
0 0 0 r
s
.913 .257 .109 r
.45045 .5187 m .46775 .52142 L .47076 .49981 L p F P
0 0 0 r
s
.913 .257 .109 r
.47076 .49981 m .45508 .4973 L .45045 .5187 L p F P
0 0 0 r
s
.934 .265 .112 r
.45508 .4973 m .47076 .49981 L .47443 .47822 L p F P
0 0 0 r
s
.83 .24 .1 r
.6034 .43798 m
.612 .41582 L
s
.858 .238 .1 r
.4832 .56604 m .50238 .56895 L .50228 .54834 L p F P
0 0 0 r
s
.858 .238 .1 r
.50228 .54834 m .48391 .54551 L .4832 .56604 L p F P
0 0 0 r
s
.83 .24 .1 r
.69917 .6573 m
.69392 .63817 L
s
.69392 .63817 m
.65658 .63272 L
s
.969 .278 .118 r
.49007 .45894 m .50141 .46083 L .50109 .43968 L p F P
0 0 0 r
s
.969 .278 .118 r
.50988 .44116 m .50109 .43968 L .50141 .46083 L p F P
0 0 0 r
s
.821 .226 .095 r
.52189 .59115 m .54124 .59403 L .54044 .57471 L p F P
0 0 0 r
s
.821 .226 .095 r
.54044 .57471 m .52146 .57184 L .52189 .59115 L p F P
0 0 0 r
s
.934 .265 .112 r
.47443 .47822 m .46073 .47599 L .45508 .4973 L p F P
0 0 0 r
s
.952 .272 .115 r
.46073 .47599 m .47443 .47822 L .47869 .45705 L p F P
0 0 0 r
s
.952 .272 .115 r
.49007 .45894 m .47869 .45705 L .47443 .47822 L p F P
0 0 0 r
s
.83 .24 .1 r
.47601 .47136 m
.51417 .47763 L
s
.47103 .49981 m
.47601 .47136 L
s
.193 .286 .592 r
.58144 .46878 m .57723 .47719 L .58831 .49865 L p F P
0 0 0 r
s
.193 .286 .592 r
.58831 .49865 m .59323 .4892 L .58144 .46878 L p F P
0 0 0 r
s
.24 .35 .67 r
.57753 .51787 m
.58777 .49814 L
s
.56867 .47804 m
.58777 .49814 L
s
.167 .247 .522 r
.59323 .4892 m .58831 .49865 L .59742 .52016 L p F P
0 0 0 r
s
.982 .284 .121 r
.52739 .44412 m .53611 .44559 L .5248 .42375 L p F P
0 0 0 r
s
.982 .284 .121 r
.53079 .42478 m .5248 .42375 L .53611 .44559 L p F P
0 0 0 r
s
.83 .24 .1 r
.68724 .42897 m
.64981 .42243 L
s
.68724 .42897 m
.69751 .41095 L
s
.215 .319 .651 r
.5678 .44906 m .56436 .45617 L .57723 .47719 L p F P
0 0 0 r
s
.215 .319 .651 r
.57723 .47719 m .58144 .46878 L .5678 .44906 L p F P
0 0 0 r
s
.888 .248 .105 r
.44691 .5398 m .46546 .54266 L .46775 .52142 L p F P
0 0 0 r
s
.888 .248 .105 r
.46775 .52142 m .45045 .5187 L .44691 .5398 L p F P
0 0 0 r
s
.83 .24 .1 r
.46721 .5283 m
.50545 .53428 L
s
.46721 .5283 m
.47103 .49981 L
s
.24 .35 .67 r
.45162 .75484 m
.44232 .77285 L
s
.41404 .76938 m
.44232 .77285 L
s
.969 .278 .118 r
.47869 .45705 m .49007 .45894 L .49229 .43819 L p F P
0 0 0 r
s
.969 .278 .118 r
.50109 .43968 m .49229 .43819 L .49007 .45894 L p F P
0 0 0 r
s
.913 .257 .109 r
.43306 .51597 m .45045 .5187 L .45508 .4973 L p F P
0 0 0 r
s
.913 .257 .109 r
.45508 .4973 m .43933 .49478 L .43306 .51597 L p F P
0 0 0 r
s
.934 .265 .112 r
.43933 .49478 m .45508 .4973 L .46073 .47599 L p F P
0 0 0 r
s
.982 .284 .121 r
.51865 .44264 m .52739 .44412 L .5188 .42272 L p F P
0 0 0 r
s
.982 .284 .121 r
.5248 .42375 m .5188 .42272 L .52739 .44412 L p F P
0 0 0 r
s
.83 .24 .1 r
.5203 .45032 m
.52738 .42494 L
s
.098 .143 .332 r
.60284 .57261 m .609 .56176 L .60436 .54133 L p F P
0 0 0 r
s
.067 .097 .237 r
.609 .56176 m .60284 .57261 L .60489 .59192 L p F P
0 0 0 r
s
.24 .35 .67 r
.59992 .56666 m
.60392 .59107 L
s
.33873 .72857 m
.3609 .74666 L
s
.34601 .70967 m
.33873 .72857 L
s
.58992 .63586 m
.58223 .65834 L
s
.774 .211 .088 r
.56032 .61433 m .57941 .61713 L .57966 .59975 L p F P
0 0 0 r
s
.774 .211 .088 r
.57966 .59975 m .5605 .5969 L .56032 .61433 L p F P
0 0 0 r
s
.83 .24 .1 r
.57893 .59883 m
.59914 .60185 L
s
.57893 .59883 m
.57897 .57332 L
s
.934 .265 .112 r
.46073 .47599 m .44697 .47374 L .43933 .49478 L p F P
0 0 0 r
s
.952 .272 .115 r
.44697 .47374 m .46073 .47599 L .46727 .45516 L p F P
0 0 0 r
s
.952 .272 .115 r
.47869 .45705 m .46727 .45516 L .46073 .47599 L p F P
0 0 0 r
s
.167 .247 .522 r
.59742 .52016 m .60292 .50992 L .59323 .4892 L p F P
0 0 0 r
s
.136 .2 .437 r
.60292 .50992 m .59742 .52016 L .60436 .54133 L p F P
0 0 0 r
s
.24 .35 .67 r
.59046 .5429 m
.60254 .52061 L
s
.858 .238 .1 r
.46392 .56312 m .4832 .56604 L .48391 .54551 L p F P
0 0 0 r
s
.858 .238 .1 r
.48391 .54551 m .46546 .54266 L .46392 .56312 L p F P
0 0 0 r
s
.821 .226 .095 r
.50243 .58825 m .52189 .59115 L .52146 .57184 L p F P
0 0 0 r
s
.821 .226 .095 r
.52146 .57184 m .50238 .56895 L .50243 .58825 L p F P
0 0 0 r
s
.969 .278 .118 r
.46727 .45516 m .47869 .45705 L .48346 .4367 L p F P
0 0 0 r
s
.969 .278 .118 r
.49229 .43819 m .48346 .4367 L .47869 .45705 L p F P
0 0 0 r
s
.982 .284 .121 r
.50988 .44116 m .51865 .44264 L .5128 .42169 L p F P
0 0 0 r
s
.982 .284 .121 r
.5188 .42272 m .5128 .42169 L .51865 .44264 L p F P
0 0 0 r
s
.888 .248 .105 r
.42827 .53692 m .44691 .5398 L .45045 .5187 L p F P
0 0 0 r
s
.888 .248 .105 r
.45045 .5187 m .43306 .51597 L .42827 .53692 L p F P
0 0 0 r
s
.234 .348 .702 r
.55254 .4304 m .54994 .436 L .56436 .45617 L p F P
0 0 0 r
s
.234 .348 .702 r
.56436 .45617 m .5678 .44906 L .55254 .4304 L p F P
0 0 0 r
s
.83 .24 .1 r
.56239 .44244 m
.56558 .43149 L
s
.56558 .43149 m
.6034 .43798 L
s
.913 .257 .109 r
.41559 .51322 m .43306 .51597 L .43933 .49478 L p F P
0 0 0 r
s
.913 .257 .109 r
.43933 .49478 m .42352 .49224 L .41559 .51322 L p F P
0 0 0 r
s
.934 .265 .112 r
.42352 .49224 m .43933 .49478 L .44697 .47374 L p F P
0 0 0 r
s
.83 .24 .1 r
.4325 .49364 m
.47103 .49981 L
s
.251 .373 .747 r
.53422 .41707 m .5325 .42094 L .54737 .44156 L p F P
0 0 0 r
s
.251 .373 .747 r
.54737 .44156 m .54994 .436 L .53422 .41707 L p F P
0 0 0 r
s
.934 .265 .112 r
.44697 .47374 m .43317 .47149 L .42352 .49224 L p F P
0 0 0 r
s
.952 .272 .115 r
.43317 .47149 m .44697 .47374 L .45583 .45326 L p F P
0 0 0 r
s
.952 .272 .115 r
.46727 .45516 m .45583 .45326 L .44697 .47374 L p F P
0 0 0 r
s
.24 .35 .67 r
.32575 .54833 m
.33643 .52708 L
s
.982 .284 .121 r
.50109 .43968 m .50988 .44116 L .50678 .42066 L p F P
0 0 0 r
s
.982 .284 .121 r
.5128 .42169 m .50678 .42066 L .50988 .44116 L p F P
0 0 0 r
s
.969 .278 .118 r
.45583 .45326 m .46727 .45516 L .47461 .4352 L p F P
0 0 0 r
s
.969 .278 .118 r
.48346 .4367 m .47461 .4352 L .46727 .45516 L p F P
0 0 0 r
s
.83 .24 .1 r
.47601 .47136 m
.48198 .44389 L
s
.48198 .44389 m
.5203 .45032 L
s
.77214 .4242 m
.73502 .41761 L
s
.77214 .4242 m
.78407 .41113 L
s
.774 .211 .088 r
.54112 .61151 m .56032 .61433 L .5605 .5969 L p F P
0 0 0 r
s
.774 .211 .088 r
.5605 .5969 m .54124 .59403 L .54112 .61151 L p F P
0 0 0 r
s
.858 .238 .1 r
.44455 .56018 m .46392 .56312 L .46546 .54266 L p F P
0 0 0 r
s
.858 .238 .1 r
.46546 .54266 m .44691 .5398 L .44455 .56018 L p F P
0 0 0 r
s
.83 .24 .1 r
.46468 .55589 m
.46721 .5283 L
s
.46468 .55589 m
.50317 .56176 L
s
.52738 .42494 m
.53404 .42608 L
s
.54298 .42762 m
.56558 .43149 L
s
.24 .35 .67 r
.42282 .75122 m
.41404 .76938 L
s
.38643 .7605 m
.41404 .76938 L
s
.83 .24 .1 r
.66129 .65187 m
.65658 .63272 L
s
.65658 .63272 m
.61884 .62721 L
s
.821 .226 .095 r
.48286 .58533 m .50243 .58825 L .50238 .56895 L p F P
0 0 0 r
s
.821 .226 .095 r
.50238 .56895 m .4832 .56604 L .48286 .58533 L p F P
0 0 0 r
s
.24 .35 .67 r
.3609 .74666 m
.38643 .7605 L
s
.36864 .72805 m
.3609 .74666 L
s
.982 .284 .121 r
.49229 .43819 m .50109 .43968 L .50075 .41963 L p F P
0 0 0 r
s
.982 .284 .121 r
.50678 .42066 m .50075 .41963 L .50109 .43968 L p F P
0 0 0 r
s
.24 .35 .67 r
.5014 .41974 m
.5031 .41566 L
s
.56887 .67842 m
.55725 .698 L
s
.55725 .698 m
.53888 .71456 L
s
.888 .248 .105 r
.40953 .53403 m .42827 .53692 L .43306 .51597 L p F P
0 0 0 r
s
.888 .248 .105 r
.43306 .51597 m .41559 .51322 L .40953 .53403 L p F P
0 0 0 r
s
.83 .24 .1 r
.42857 .52226 m
.46721 .5283 L
s
.42857 .52226 m
.4325 .49364 L
s
.934 .265 .112 r
.40764 .4897 m .42352 .49224 L .43317 .47149 L p F P
0 0 0 r
s
.934 .265 .112 r
.43317 .47149 m .41931 .46923 L .40764 .4897 L p F P
0 0 0 r
s
.952 .272 .115 r
.41931 .46923 m .43317 .47149 L .44434 .45135 L p F P
0 0 0 r
s
.952 .272 .115 r
.45583 .45326 m .44434 .45135 L .43317 .47149 L p F P
0 0 0 r
s
.83 .24 .1 r
.43746 .46504 m
.47601 .47136 L
s
.4325 .49364 m
.43746 .46504 L
s
.136 .2 .437 r
.60436 .54133 m .61033 .53055 L .60292 .50992 L p F P
0 0 0 r
s
.098 .143 .332 r
.61033 .53055 m .60436 .54133 L .609 .56176 L p F P
0 0 0 r
s
.913 .257 .109 r
.39804 .51046 m .41559 .51322 L .42352 .49224 L p F P
0 0 0 r
s
.913 .257 .109 r
.42352 .49224 m .40764 .4897 L .39804 .51046 L p F P
0 0 0 r
s
.83 .24 .1 r
.64981 .42243 m
.612 .41582 L
s
.64981 .42243 m
.6596 .40422 L
s
.969 .278 .118 r
.44434 .45135 m .45583 .45326 L .46574 .4337 L p F P
0 0 0 r
s
.969 .278 .118 r
.47461 .4352 m .46574 .4337 L .45583 .45326 L p F P
0 0 0 r
s
.24 .35 .67 r
.39468 .74214 m
.38643 .7605 L
s
.51607 .72687 m
.50547 .74552 L
s
.50547 .74552 m
.47963 .75287 L
s
.982 .284 .121 r
.48346 .4367 m .49229 .43819 L .49471 .41859 L p F P
0 0 0 r
s
.982 .284 .121 r
.50075 .41963 m .49471 .41859 L .49229 .43819 L p F P
0 0 0 r
s
.858 .238 .1 r
.42507 .55723 m .44455 .56018 L .44691 .5398 L p F P
0 0 0 r
s
.858 .238 .1 r
.44691 .5398 m .42827 .53692 L .42507 .55723 L p F P
0 0 0 r
s
.774 .211 .088 r
.52182 .60869 m .54112 .61151 L .54124 .59403 L p F P
0 0 0 r
s
.774 .211 .088 r
.54124 .59403 m .52189 .59115 L .52182 .60869 L p F P
0 0 0 r
s
.83 .24 .1 r
.54086 .59316 m
.57893 .59883 L
s
.54086 .59316 m
.54126 .56757 L
s
.24 .35 .67 r
.3139 .59372 m
.32073 .57204 L
s
.31489 .61862 m
.3139 .59372 L
s
.952 .272 .115 r
.44434 .45135 m .43282 .44943 L .41931 .46923 L p F P
0 0 0 r
s
.969 .278 .118 r
.43282 .44943 m .44434 .45135 L .45685 .4322 L p F P
0 0 0 r
s
.969 .278 .118 r
.46574 .4337 m .45685 .4322 L .44434 .45135 L p F P
0 0 0 r
s
.934 .265 .112 r
.39169 .48715 m .40764 .4897 L .41931 .46923 L p F P
0 0 0 r
s
.934 .265 .112 r
.41931 .46923 m .4054 .46696 L .39169 .48715 L p F P
0 0 0 r
s
.952 .272 .115 r
.4054 .46696 m .41931 .46923 L .43282 .44943 L p F P
0 0 0 r
s
.821 .226 .095 r
.4632 .58241 m .48286 .58533 L .4832 .56604 L p F P
0 0 0 r
s
.821 .226 .095 r
.4832 .56604 m .46392 .56312 L .4632 .58241 L p F P
0 0 0 r
s
.982 .284 .121 r
.47461 .4352 m .48346 .4367 L .48867 .41755 L p F P
0 0 0 r
s
.982 .284 .121 r
.49471 .41859 m .48867 .41755 L .48346 .4367 L p F P
0 0 0 r
s
.215 .319 .651 r
.57127 .44186 m .5678 .44906 L .58144 .46878 L p F P
0 0 0 r
s
.215 .319 .651 r
.58144 .46878 m .58572 .46027 L .57127 .44186 L p F P
0 0 0 r
s
.193 .286 .592 r
.58572 .46027 m .58144 .46878 L .59323 .4892 L p F P
0 0 0 r
s
.24 .35 .67 r
.32791 .68796 m
.31515 .66408 L
s
.322 .64378 m
.31515 .66408 L
s
.913 .257 .109 r
.3804 .50769 m .39804 .51046 L .40764 .4897 L p F P
0 0 0 r
s
.913 .257 .109 r
.40764 .4897 m .39169 .48715 L .3804 .50769 L p F P
0 0 0 r
s
.83 .24 .1 r
.39357 .48741 m
.4325 .49364 L
s
.888 .248 .105 r
.3907 .53112 m .40953 .53403 L .41559 .51322 L p F P
0 0 0 r
s
.888 .248 .105 r
.41559 .51322 m .39804 .51046 L .3907 .53112 L p F P
0 0 0 r
s
.251 .373 .747 r
.53595 .41318 m .53422 .41707 L .54994 .436 L p F P
0 0 0 r
s
.251 .373 .747 r
.54994 .436 m .55254 .4304 L .53595 .41318 L p F P
0 0 0 r
s
.193 .286 .592 r
.59323 .4892 m .59822 .4796 L .58572 .46027 L p F P
0 0 0 r
s
.167 .247 .522 r
.59822 .4796 m .59323 .4892 L .60292 .50992 L p F P
0 0 0 r
s
.24 .35 .67 r
.58777 .49814 m
.60254 .52061 L
s
.712 .19 .079 r
.57734 .63217 m .59585 .63484 L .59841 .61991 L p F P
0 0 0 r
s
.24 .35 .67 r
.58992 .63586 m
.59094 .63413 L
s
.712 .19 .079 r
.59841 .61991 m .57941 .61713 L .57734 .63217 L p F P
0 0 0 r
s
.049 .072 .169 r
.59841 .61991 m .60457 .60945 L .60489 .59192 L p F P
0 0 0 r
s
.24 .35 .67 r
.59738 .60239 m
.60392 .59107 L
s
.028 .04 .082 r
.60457 .60945 m .59841 .61991 L .59585 .63484 L p F P
0 0 0 r
s
.267 .397 .787 r
.51662 .40176 m .51577 .40376 L .53079 .42478 L p F P
0 0 0 r
s
.267 .397 .787 r
.53079 .42478 m .5325 .42094 L .51662 .40176 L p F P
0 0 0 r
s
.992 .289 .123 r
.5248 .42375 m .53079 .42478 L .51577 .40376 L p F P
0 0 0 r
s
.24 .35 .67 r
.5295 .42774 m
.5314 .42347 L
s
.982 .284 .121 r
.46574 .4337 m .47461 .4352 L .48261 .41651 L p F P
0 0 0 r
s
.982 .284 .121 r
.48867 .41755 m .48261 .41651 L .47461 .4352 L p F P
0 0 0 r
s
.952 .272 .115 r
.43282 .44943 m .42127 .44752 L .4054 .46696 L p F P
0 0 0 r
s
.969 .278 .118 r
.42127 .44752 m .43282 .44943 L .44794 .4307 L p F P
0 0 0 r
s
.969 .278 .118 r
.45685 .4322 m .44794 .4307 L .43282 .44943 L p F P
0 0 0 r
s
.067 .097 .237 r
.60489 .59192 m .61119 .58104 L .609 .56176 L p F P
0 0 0 r
s
.049 .072 .169 r
.61119 .58104 m .60489 .59192 L .60457 .60945 L p F P
0 0 0 r
s
.83 .24 .1 r
.7445 .67739 m
.73666 .66268 L
s
.73666 .66268 m
.69917 .6573 L
s
.234 .348 .702 r
.55516 .42475 m .55254 .4304 L .5678 .44906 L p F P
0 0 0 r
s
.234 .348 .702 r
.5678 .44906 m .57127 .44186 L .55516 .42475 L p F P
0 0 0 r
s
.24 .35 .67 r
.54823 .45627 m
.55725 .43707 L
s
.934 .265 .112 r
.37567 .48458 m .39169 .48715 L .4054 .46696 L p F P
0 0 0 r
s
.934 .265 .112 r
.4054 .46696 m .39144 .46468 L .37567 .48458 L p F P
0 0 0 r
s
.952 .272 .115 r
.39144 .46468 m .4054 .46696 L .42127 .44752 L p F P
0 0 0 r
s
.992 .289 .123 r
.5188 .42272 m .5248 .42375 L .51269 .40323 L p F P
0 0 0 r
s
.992 .289 .123 r
.51577 .40376 m .51269 .40323 L .5248 .42375 L p F P
0 0 0 r
s
.858 .238 .1 r
.40549 .55427 m .42507 .55723 L .42827 .53692 L p F P
0 0 0 r
s
.858 .238 .1 r
.42827 .53692 m .40953 .53403 L .40549 .55427 L p F P
0 0 0 r
s
.83 .24 .1 r
.42578 .54996 m
.42857 .52226 L
s
.42578 .54996 m
.46468 .55589 L
s
.73502 .41761 m
.69751 .41095 L
s
.73502 .41761 m
.7464 .40437 L
s
.774 .211 .088 r
.50242 .60584 m .52182 .60869 L .52189 .59115 L p F P
0 0 0 r
s
.774 .211 .088 r
.52189 .59115 m .50243 .58825 L .50242 .60584 L p F P
0 0 0 r
s
.83 .24 .1 r
.62301 .64638 m
.61884 .62721 L
s
.58071 .62165 m
.59791 .62416 L
s
.59944 .62438 m
.61884 .62721 L
s
.982 .284 .121 r
.45685 .4322 m .46574 .4337 L .47654 .41547 L p F P
0 0 0 r
s
.982 .284 .121 r
.48261 .41651 m .47654 .41547 L .46574 .4337 L p F P
0 0 0 r
s
.913 .257 .109 r
.36269 .50491 m .3804 .50769 L .39169 .48715 L p F P
0 0 0 r
s
.913 .257 .109 r
.39169 .48715 m .37567 .48458 L .36269 .50491 L p F P
0 0 0 r
s
.821 .226 .095 r
.44343 .57946 m .4632 .58241 L .46392 .56312 L p F P
0 0 0 r
s
.821 .226 .095 r
.46392 .56312 m .44455 .56018 L .44343 .57946 L p F P
0 0 0 r
s
.83 .24 .1 r
.46354 .58164 m
.46468 .55589 L
s
.888 .248 .105 r
.37178 .5282 m .3907 .53112 L .39804 .51046 L p F P
0 0 0 r
s
.888 .248 .105 r
.39804 .51046 m .3804 .50769 L .37178 .5282 L p F P
0 0 0 r
s
.83 .24 .1 r
.38952 .51616 m
.42857 .52226 L
s
.992 .289 .123 r
.5128 .42169 m .5188 .42272 L .50962 .40269 L p F P
0 0 0 r
s
.992 .289 .123 r
.51269 .40323 m .50962 .40269 L .5188 .42272 L p F P
0 0 0 r
s
.952 .272 .115 r
.42127 .44752 m .40968 .44559 L .39144 .46468 L p F P
0 0 0 r
s
.969 .278 .118 r
.40968 .44559 m .42127 .44752 L .439 .42919 L p F P
0 0 0 r
s
.24 .35 .67 r
.4091 .44619 m
.4118 .43858 L
s
.43384 .43453 m
.43808 .43375 L
s
.969 .278 .118 r
.44794 .4307 m .439 .42919 L .42127 .44752 L p F P
0 0 0 r
s
.83 .24 .1 r
.43746 .46504 m
.44327 .43739 L
s
.24 .35 .67 r
.4118 .43858 m
.42731 .43573 L
s
.83 .24 .1 r
.44327 .43739 m
.48198 .44389 L
s
.38952 .51616 m
.39357 .48741 L
s
.167 .247 .522 r
.60292 .50992 m .60852 .4995 L .59822 .4796 L p F P
0 0 0 r
s
.136 .2 .437 r
.60852 .4995 m .60292 .50992 L .61033 .53055 L p F P
0 0 0 r
s
.24 .35 .67 r
.52127 .42001 m
.5314 .42347 L
s
.5314 .42347 m
.55725 .43707 L
s
.83 .24 .1 r
.612 .41582 m
.57379 .40915 L
s
.612 .41582 m
.62129 .39742 L
s
.992 .289 .123 r
.50678 .42066 m .5128 .42169 L .50654 .40216 L p F P
0 0 0 r
s
.992 .289 .123 r
.50962 .40269 m .50654 .40216 L .5128 .42169 L p F P
0 0 0 r
s
.934 .265 .112 r
.35959 .482 m .37567 .48458 L .39144 .46468 L p F P
0 0 0 r
s
.24 .35 .67 r
.3596 .48613 m
.36442 .48278 L
s
.934 .265 .112 r
.39144 .46468 m .37743 .4624 L .35959 .482 L p F P
0 0 0 r
s
.952 .272 .115 r
.37743 .4624 m .39144 .46468 L .40968 .44559 L p F P
0 0 0 r
s
.83 .24 .1 r
.39357 .48741 m
.3985 .45864 L
s
.3985 .45864 m
.43746 .46504 L
s
.982 .284 .121 r
.44794 .4307 m .45685 .4322 L .47046 .41443 L p F P
0 0 0 r
s
.982 .284 .121 r
.47654 .41547 m .47046 .41443 L .45685 .4322 L p F P
0 0 0 r
s
.24 .35 .67 r
.47314 .41489 m
.47477 .41078 L
s
.712 .19 .079 r
.55874 .62948 m .57734 .63217 L .57941 .61713 L p F P
0 0 0 r
s
.712 .19 .079 r
.57941 .61713 m .56032 .61433 L .55874 .62948 L p F P
0 0 0 r
s
.83 .24 .1 r
.57893 .59883 m
.58071 .62165 L
s
.098 .143 .332 r
.609 .56176 m .61528 .5507 L .61033 .53055 L p F P
0 0 0 r
s
.067 .097 .237 r
.61528 .5507 m .609 .56176 L .61119 .58104 L p F P
0 0 0 r
s
.267 .397 .787 r
.51747 .39976 m .51662 .40176 L .5325 .42094 L p F P
0 0 0 r
s
.267 .397 .787 r
.5325 .42094 m .53422 .41707 L .51747 .39976 L p F P
0 0 0 r
s
.83 .24 .1 r
.52738 .42494 m
.53022 .41673 L
s
.992 .289 .123 r
.50075 .41963 m .50678 .42066 L .50347 .40162 L p F P
0 0 0 r
s
.992 .289 .123 r
.50654 .40216 m .50347 .40162 L .50678 .42066 L p F P
0 0 0 r
s
.858 .238 .1 r
.3858 .55128 m .40549 .55427 L .40953 .53403 L p F P
0 0 0 r
s
.858 .238 .1 r
.40953 .53403 m .3907 .53112 L .3858 .55128 L p F P
0 0 0 r
s
.952 .272 .115 r
.40968 .44559 m .39805 .44366 L .37743 .4624 L p F P
0 0 0 r
s
.969 .278 .118 r
.39805 .44366 m .40968 .44559 L .43005 .42767 L p F P
0 0 0 r
s
.969 .278 .118 r
.439 .42919 m .43005 .42767 L .40968 .44559 L p F P
0 0 0 r
s
.913 .257 .109 r
.34489 .50211 m .36269 .50491 L .37567 .48458 L p F P
0 0 0 r
s
.913 .257 .109 r
.37567 .48458 m .35959 .482 L .34489 .50211 L p F P
0 0 0 r
s
.774 .211 .088 r
.48292 .60299 m .50242 .60584 L .50243 .58825 L p F P
0 0 0 r
s
.774 .211 .088 r
.50243 .58825 m .48286 .58533 L .48292 .60299 L p F P
0 0 0 r
s
.83 .24 .1 r
.5024 .58743 m
.54086 .59316 L
s
.5024 .58743 m
.50317 .56176 L
s
.982 .284 .121 r
.439 .42919 m .44794 .4307 L .46438 .41338 L p F P
0 0 0 r
s
.982 .284 .121 r
.47046 .41443 m .46438 .41338 L .44794 .4307 L p F P
0 0 0 r
s
.888 .248 .105 r
.35276 .52527 m .37178 .5282 L .3804 .50769 L p F P
0 0 0 r
s
.888 .248 .105 r
.3804 .50769 m .36269 .50491 L .35276 .52527 L p F P
0 0 0 r
s
.251 .373 .747 r
.53769 .40926 m .53595 .41318 L .55254 .4304 L p F P
0 0 0 r
s
.251 .373 .747 r
.55254 .4304 m .55516 .42475 L .53769 .40926 L p F P
0 0 0 r
s
.821 .226 .095 r
.42355 .5765 m .44343 .57946 L .44455 .56018 L p F P
0 0 0 r
s
.821 .226 .095 r
.44455 .56018 m .42507 .55723 L .42355 .5765 L p F P
0 0 0 r
s
.992 .289 .123 r
.49471 .41859 m .50075 .41963 L .50038 .40108 L p F P
0 0 0 r
s
.992 .289 .123 r
.50347 .40162 m .50038 .40108 L .50075 .41963 L p F P
0 0 0 r
s
.33 .49 .916 r
.38029 .45379 m .37743 .4624 L .35959 .482 L p F P
0 0 0 r
s
.332 .492 .931 r
.37743 .4624 m .38029 .45379 L .40055 .4364 L p F P
0 0 0 r
s
.332 .492 .931 r
.40055 .4364 m .39805 .44366 L .37743 .4624 L p F P
0 0 0 r
s
.83 .24 .1 r
.38353 .45619 m
.3985 .45864 L
s
.24 .35 .67 r
.58223 .65834 m
.56887 .67842 L
s
.992 .289 .123 r
.48867 .41755 m .49471 .41859 L .4973 .40055 L p F P
0 0 0 r
s
.83 .24 .1 r
.48198 .44389 m
.48877 .41832 L
s
.992 .289 .123 r
.50038 .40108 m .4973 .40055 L .49471 .41859 L p F P
0 0 0 r
s
.83 .24 .1 r
.48877 .41832 m
.52738 .42494 L
s
.982 .284 .121 r
.43005 .42767 m .439 .42919 L .45828 .41234 L p F P
0 0 0 r
s
.24 .35 .67 r
.44003 .42855 m
.44017 .42817 L
s
.982 .284 .121 r
.46438 .41338 m .45828 .41234 L .439 .42919 L p F P
0 0 0 r
s
.969 .278 .118 r
.43005 .42767 m .42107 .42616 L .39805 .44366 L p F P
0 0 0 r
s
.327 .485 .926 r
.39805 .44366 m .40055 .4364 L .42311 .42047 L p F P
0 0 0 r
s
.327 .485 .926 r
.42311 .42047 m .42107 .42616 L .39805 .44366 L p F P
0 0 0 r
s
.83 .24 .1 r
.3985 .45864 m
.40252 .43881 L
s
.40343 .43437 m
.40415 .43082 L
s
.40415 .43082 m
.40763 .4314 L
s
.41204 .43214 m
.44327 .43739 L
s
.712 .19 .079 r
.54004 .62678 m .55874 .62948 L .56032 .61433 L p F P
0 0 0 r
s
.712 .19 .079 r
.56032 .61433 m .54112 .61151 L .54004 .62678 L p F P
0 0 0 r
s
.318 .471 .867 r
.36273 .47229 m .35959 .482 L .34489 .50211 L p F P
0 0 0 r
s
.83 .24 .1 r
.35423 .4811 m
.35717 .48158 L
s
.33 .49 .916 r
.35959 .482 m .36273 .47229 L .38029 .45379 L p F P
0 0 0 r
s
.83 .24 .1 r
.35926 .48191 m
.39357 .48741 L
s
.35914 .45218 m
.37876 .4554 L
s
.24 .35 .67 r
.4898 .73421 m
.47963 .75287 L
s
.47963 .75287 m
.45162 .75484 L
s
.992 .289 .123 r
.48261 .41651 m .48867 .41755 L .49421 .40001 L p F P
0 0 0 r
s
.24 .35 .67 r
.4905 .41175 m
.49152 .41193 L
s
.992 .289 .123 r
.4973 .40055 m .49421 .40001 L .48867 .41755 L p F P
0 0 0 r
s
.83 .24 .1 r
.70642 .672 m
.69917 .6573 L
s
.69917 .6573 m
.66129 .65187 L
s
.858 .238 .1 r
.36602 .54829 m .3858 .55128 L .3907 .53112 L p F P
0 0 0 r
s
.858 .238 .1 r
.3907 .53112 m .37178 .5282 L .36602 .54829 L p F P
0 0 0 r
s
.83 .24 .1 r
.38648 .54397 m
.38952 .51616 L
s
.38648 .54397 m
.42578 .54996 L
s
.267 .397 .787 r
.51832 .39775 m .51747 .39976 L .53422 .41707 L p F P
0 0 0 r
s
.267 .397 .787 r
.53422 .41707 m .53595 .41318 L .51832 .39775 L p F P
0 0 0 r
s
.215 .319 .651 r
.57479 .43458 m .57127 .44186 L .58572 .46027 L p F P
0 0 0 r
s
.215 .319 .651 r
.58572 .46027 m .59005 .45163 L .57479 .43458 L p F P
0 0 0 r
s
.24 .35 .67 r
.56867 .47804 m
.5804 .45435 L
s
.193 .286 .592 r
.59005 .45163 m .58572 .46027 L .59822 .4796 L p F P
0 0 0 r
s
.982 .284 .121 r
.42107 .42616 m .43005 .42767 L .45217 .41129 L p F P
0 0 0 r
s
.982 .284 .121 r
.45828 .41234 m .45217 .41129 L .43005 .42767 L p F P
0 0 0 r
s
.83 .24 .1 r
.69751 .41095 m
.6596 .40422 L
s
.69751 .41095 m
.70833 .39753 L
s
.888 .248 .105 r
.33364 .52232 m .35276 .52527 L .36269 .50491 L p F P
0 0 0 r
s
.24 .35 .67 r
.33643 .52708 m
.33774 .52295 L
s
.888 .248 .105 r
.36269 .50491 m .34489 .50211 L .33364 .52232 L p F P
0 0 0 r
s
.83 .24 .1 r
.35006 .51 m
.38952 .51616 L
s
.774 .211 .088 r
.46331 .60011 m .48292 .60299 L .48286 .58533 L p F P
0 0 0 r
s
.774 .211 .088 r
.48286 .58533 m .4632 .58241 L .46331 .60011 L p F P
0 0 0 r
s
.83 .24 .1 r
.46354 .58164 m
.5024 .58743 L
s
.136 .2 .437 r
.61033 .53055 m .61641 .51957 L .60852 .4995 L p F P
0 0 0 r
s
.098 .143 .332 r
.61641 .51957 m .61033 .53055 L .61528 .5507 L p F P
0 0 0 r
s
.24 .35 .67 r
.60254 .52061 m
.6123 .54463 L
s
.59992 .56666 m
.6123 .54463 L
s
.234 .348 .702 r
.55781 .41904 m .55516 .42475 L .57127 .44186 L p F P
0 0 0 r
s
.234 .348 .702 r
.57127 .44186 m .57479 .43458 L .55781 .41904 L p F P
0 0 0 r
s
.83 .24 .1 r
.56705 .4275 m
.57379 .40915 L
s
.24 .35 .67 r
.55725 .43707 m
.5804 .45435 L
s
.83 .24 .1 r
.54218 .61602 m
.58071 .62165 L
s
.992 .289 .123 r
.47654 .41547 m .48261 .41651 L .49112 .39947 L p F P
0 0 0 r
s
.24 .35 .67 r
.48542 .41088 m
.48645 .41105 L
s
.992 .289 .123 r
.49421 .40001 m .49112 .39947 L .48261 .41651 L p F P
0 0 0 r
s
.821 .226 .095 r
.40357 .57353 m .42355 .5765 L .42507 .55723 L p F P
0 0 0 r
s
.821 .226 .095 r
.42507 .55723 m .40549 .55427 L .40357 .57353 L p F P
0 0 0 r
s
.83 .24 .1 r
.42427 .57579 m
.42578 .54996 L
s
.24 .35 .67 r
.34601 .70967 m
.32791 .68796 L
s
.33507 .66798 m
.32791 .68796 L
s
.83 .24 .1 r
.35321 .4882 m
.35423 .4811 L
s
.35423 .4811 m
.35914 .45218 L
s
.982 .284 .121 r
.45217 .41129 m .44605 .41024 L .42107 .42616 L p F P
0 0 0 r
s
.318 .472 .909 r
.42107 .42616 m .42311 .42047 L .44752 .4063 L p F P
0 0 0 r
s
.318 .472 .909 r
.44752 .4063 m .44605 .41024 L .42107 .42616 L p F P
0 0 0 r
s
.83 .24 .1 r
.44327 .43739 m
.44976 .41163 L
s
.992 .289 .123 r
.47046 .41443 m .47654 .41547 L .48803 .39893 L p F P
0 0 0 r
s
.24 .35 .67 r
.47541 .40915 m
.47628 .4093 L
s
.48034 .41 m
.48137 .41018 L
s
.47486 .41055 m
.47541 .40915 L
s
.992 .289 .123 r
.49112 .39947 m .48803 .39893 L .47654 .41547 L p F P
0 0 0 r
s
.24 .35 .67 r
.55026 .69509 m
.53888 .71456 L
s
.53888 .71456 m
.51607 .72687 L
s
.193 .286 .592 r
.59822 .4796 m .60329 .46985 L .59005 .45163 L p F P
0 0 0 r
s
.167 .247 .522 r
.60329 .46985 m .59822 .4796 L .60852 .4995 L p F P
0 0 0 r
s
.24 .35 .67 r
.58777 .49814 m
.59994 .47471 L
s
.5804 .45435 m
.59994 .47471 L
s
.712 .19 .079 r
.52124 .62407 m .54004 .62678 L .54112 .61151 L p F P
0 0 0 r
s
.712 .19 .079 r
.54112 .61151 m .52182 .60869 L .52124 .62407 L p F P
0 0 0 r
s
.83 .24 .1 r
.54086 .59316 m
.54218 .61602 L
s
.992 .289 .123 r
.46438 .41338 m .47046 .41443 L .48494 .39839 L p F P
0 0 0 r
s
.24 .35 .67 r
.47541 .40915 m
.47555 .40879 L
s
.47523 .40915 m
.47541 .40915 L
s
.992 .289 .123 r
.48803 .39893 m .48494 .39839 L .47046 .41443 L p F P
0 0 0 r
s
.858 .238 .1 r
.34612 .54527 m .36602 .54829 L .37178 .5282 L p F P
0 0 0 r
s
.858 .238 .1 r
.37178 .5282 m .35276 .52527 L .34612 .54527 L p F P
0 0 0 r
s
.251 .373 .747 r
.53944 .40532 m .53769 .40926 L .55516 .42475 L p F P
0 0 0 r
s
.251 .373 .747 r
.55516 .42475 m .55781 .41904 L .53944 .40532 L p F P
0 0 0 r
s
.83 .24 .1 r
.35914 .45218 m
.31936 .44566 L
s
.288 .426 .769 r
.34823 .49155 m .34489 .50211 L .33364 .52232 L p F P
0 0 0 r
s
.318 .471 .867 r
.34489 .50211 m .34823 .49155 L .36273 .47229 L p F P
0 0 0 r
s
.83 .24 .1 r
.31448 .47474 m
.35423 .4811 L
s
.35006 .51 m
.35287 .49055 L
s
.992 .289 .123 r
.45828 .41234 m .46438 .41338 L .48184 .39786 L p F P
0 0 0 r
s
.992 .289 .123 r
.48494 .39839 m .48184 .39786 L .46438 .41338 L p F P
0 0 0 r
s
.774 .211 .088 r
.4436 .59723 m .46331 .60011 L .4632 .58241 L p F P
0 0 0 r
s
.774 .211 .088 r
.4632 .58241 m .44343 .57946 L .4436 .59723 L p F P
0 0 0 r
s
.267 .397 .787 r
.51918 .39573 m .51832 .39775 L .53595 .41318 L p F P
0 0 0 r
s
.267 .397 .787 r
.53595 .41318 m .53769 .40926 L .51918 .39573 L p F P
0 0 0 r
s
.821 .226 .095 r
.38348 .57054 m .40357 .57353 L .40549 .55427 L p F P
0 0 0 r
s
.821 .226 .095 r
.40549 .55427 m .3858 .55128 L .38348 .57054 L p F P
0 0 0 r
s
.24 .35 .67 r
.322 .64378 m
.31489 .61862 L
s
.32181 .5972 m
.31489 .61862 L
s
.049 .072 .169 r
.60457 .60945 m .61085 .59877 L .61119 .58104 L p F P
0 0 0 r
s
.028 .04 .082 r
.61085 .59877 m .60457 .60945 L .60182 .6248 L p F P
0 0 0 r
s
.028 .04 .082 r
.59585 .63484 m .60182 .6248 L .60457 .60945 L p F P
0 0 0 r
s
.24 .35 .67 r
.59658 .62456 m
.60214 .61514 L
s
.60214 .61514 m
.60392 .59107 L
s
.83 .24 .1 r
.34112 .5086 m
.35006 .51 L
s
.992 .289 .123 r
.45217 .41129 m .45828 .41234 L .47874 .39732 L p F P
0 0 0 r
s
.992 .289 .123 r
.48184 .39786 m .47874 .39732 L .45828 .41234 L p F P
0 0 0 r
s
.83 .24 .1 r
.44976 .41163 m
.48877 .41832 L
s
.067 .097 .237 r
.61119 .58104 m .61762 .56995 L .61528 .5507 L p F P
0 0 0 r
s
.049 .072 .169 r
.61762 .56995 m .61119 .58104 L .61085 .59877 L p F P
0 0 0 r
s
.712 .19 .079 r
.50236 .62134 m .52124 .62407 L .52182 .60869 L p F P
0 0 0 r
s
.712 .19 .079 r
.52182 .60869 m .50242 .60584 L .50236 .62134 L p F P
0 0 0 r
s
.992 .289 .123 r
.44605 .41024 m .45217 .41129 L .47564 .39678 L p F P
0 0 0 r
s
.992 .289 .123 r
.47874 .39732 m .47564 .39678 L .45217 .41129 L p F P
0 0 0 r
s
.332 .492 .931 r
.40309 .42906 m .40055 .4364 L .38029 .45379 L p F P
0 0 0 r
s
.83 .24 .1 r
.40257 .43055 m
.40415 .43082 L
s
.327 .485 .926 r
.40055 .4364 m .40309 .42906 L .42517 .41472 L p F P
0 0 0 r
s
.327 .485 .926 r
.42517 .41472 m .42311 .42047 L .40055 .4364 L p F P
0 0 0 r
s
.167 .247 .522 r
.60852 .4995 m .61422 .48889 L .60329 .46985 L p F P
0 0 0 r
s
.136 .2 .437 r
.61422 .48889 m .60852 .4995 L .61641 .51957 L p F P
0 0 0 r
s
.858 .238 .1 r
.32613 .54224 m .34612 .54527 L .35276 .52527 L p F P
0 0 0 r
s
.24 .35 .67 r
.32575 .54833 m
.32758 .54246 L
s
.858 .238 .1 r
.35276 .52527 m .33364 .52232 L .32613 .54224 L p F P
0 0 0 r
s
.83 .24 .1 r
.34676 .53791 m
.38648 .54397 L
s
.66793 .66656 m
.66129 .65187 L
s
.66129 .65187 m
.62301 .64638 L
s
.624 .162 .067 r
.57341 .6445 m .59099 .64701 L .59585 .63484 L p F P
0 0 0 r
s
.24 .35 .67 r
.58223 .65834 m
.58913 .64674 L
s
.624 .162 .067 r
.59585 .63484 m .57734 .63217 L .57341 .6445 L p F P
0 0 0 r
s
.83 .24 .1 r
.58071 .62165 m
.58432 .64083 L
s
.024 .035 .067 r
.60182 .6248 m .59585 .63484 L .59099 .64701 L p F P
0 0 0 r
s
.33 .49 .916 r
.3832 .44506 m .38029 .45379 L .36273 .47229 L p F P
0 0 0 r
s
.83 .24 .1 r
.35914 .45218 m
.36461 .42418 L
s
.332 .492 .931 r
.38029 .45379 m .3832 .44506 L .40309 .42906 L p F P
0 0 0 r
s
.83 .24 .1 r
.36461 .42418 m
.40146 .43037 L
s
.24 .35 .67 r
.38477 .45739 m
.38788 .44816 L
s
.38788 .44816 m
.405 .4413 L
s
.281 .418 .824 r
.51577 .40376 m .51662 .40176 L .5 .38446 L closepath p F P
0 0 0 r
s
.997 .292 .125 r
.5 .38446 m .51269 .40323 L .51577 .40376 L closepath p F P
0 0 0 r
s
.992 .289 .123 r
.47564 .39678 m .47253 .39623 L .44605 .41024 L p F P
0 0 0 r
s
.307 .456 .885 r
.44605 .41024 m .44752 .4063 L .47332 .39421 L p F P
0 0 0 r
s
.307 .456 .885 r
.47332 .39421 m .47253 .39623 L .44605 .41024 L p F P
0 0 0 r
s
.83 .24 .1 r
.6596 .40422 m
.62129 .39742 L
s
.6596 .40422 m
.66985 .39061 L
s
.774 .211 .088 r
.42379 .59432 m .4436 .59723 L .44343 .57946 L p F P
0 0 0 r
s
.774 .211 .088 r
.44343 .57946 m .42355 .5765 L .42379 .59432 L p F P
0 0 0 r
s
.83 .24 .1 r
.42427 .57579 m
.46354 .58164 L
s
.24 .35 .67 r
.4613 .7361 m
.45162 .75484 L
s
.45162 .75484 m
.42282 .75122 L
s
.83 .24 .1 r
.50324 .61034 m
.54218 .61602 L
s
.318 .472 .909 r
.42311 .42047 m .42517 .41472 L .449 .40235 L p F P
0 0 0 r
s
.318 .472 .909 r
.449 .40235 m .44752 .4063 L .42311 .42047 L p F P
0 0 0 r
s
.24 .35 .67 r
.44733 .40902 m
.45767 .40907 L
s
.44569 .41339 m
.44733 .40902 L
s
.83 .24 .1 r
.44294 .41046 m
.44976 .41163 L
s
.997 .292 .125 r
.5 .38446 m .50962 .40269 L .51269 .40323 L closepath p F P
0 0 0 r
s
.821 .226 .095 r
.36329 .56753 m .38348 .57054 L .3858 .55128 L p F P
0 0 0 r
s
.821 .226 .095 r
.3858 .55128 m .36602 .54829 L .36329 .56753 L p F P
0 0 0 r
s
.83 .24 .1 r
.38458 .56987 m
.38648 .54397 L
s
.78407 .41113 m
.7464 .40437 L
s
.78407 .41113 m
.79628 .40341 L
s
.267 .397 .787 r
.52004 .39371 m .51918 .39573 L .53769 .40926 L p F P
0 0 0 r
s
.267 .397 .787 r
.53769 .40926 m .53944 .40532 L .52004 .39371 L p F P
0 0 0 r
s
.83 .24 .1 r
.53507 .40271 m
.53518 .4024 L
s
.53518 .4024 m
.57379 .40915 L
s
.234 .348 .702 r
.56048 .41329 m .55781 .41904 L .57479 .43458 L p F P
0 0 0 r
s
.234 .348 .702 r
.57479 .43458 m .57835 .42722 L .56048 .41329 L p F P
0 0 0 r
s
.215 .319 .651 r
.57835 .42722 m .57479 .43458 L .59005 .45163 L p F P
0 0 0 r
s
.997 .292 .125 r
.5 .38446 m .50654 .40216 L .50962 .40269 L closepath p F P
0 0 0 r
s
.098 .143 .332 r
.61528 .5507 m .62168 .53942 L .61641 .51957 L p F P
0 0 0 r
s
.067 .097 .237 r
.62168 .53942 m .61528 .5507 L .61762 .56995 L p F P
0 0 0 r
s
.24 .35 .67 r
.6123 .54463 m
.61651 .56929 L
s
.83 .24 .1 r
.31019 .50376 m
.31448 .47474 L
s
.31448 .47474 m
.27431 .4683 L
s
.31448 .47474 m
.31936 .44566 L
s
.24 .35 .67 r
.36864 .72805 m
.34601 .70967 L
s
.35358 .69 m
.34601 .70967 L
s
.997 .292 .125 r
.5 .38446 m .50347 .40162 L .50654 .40216 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.5343 .40224 m
.53518 .4024 L
s
.251 .373 .747 r
.5412 .40136 m .53944 .40532 L .55781 .41904 L p F P
0 0 0 r
s
.251 .373 .747 r
.55781 .41904 m .56048 .41329 L .5412 .40136 L p F P
0 0 0 r
s
.281 .418 .824 r
.51662 .40176 m .51747 .39976 L .5 .38446 L closepath p F P
0 0 0 r
s
.712 .19 .079 r
.48337 .6186 m .50236 .62134 L .50242 .60584 L p F P
0 0 0 r
s
.712 .19 .079 r
.50242 .60584 m .48292 .60299 L .48337 .6186 L p F P
0 0 0 r
s
.83 .24 .1 r
.5024 .58743 m
.50324 .61034 L
s
.997 .292 .125 r
.5 .38446 m .50038 .40108 L .50347 .40162 L closepath p F P
0 0 0 r
s
.215 .319 .651 r
.59005 .45163 m .59445 .44287 L .57835 .42722 L p F P
0 0 0 r
s
.193 .286 .592 r
.59445 .44287 m .59005 .45163 L .60329 .46985 L p F P
0 0 0 r
s
.238 .35 .612 r
.33713 .51118 m .33364 .52232 L .32613 .54224 L p F P
0 0 0 r
s
.288 .426 .769 r
.33364 .52232 m .33713 .51118 L .34823 .49155 L p F P
0 0 0 r
s
.83 .24 .1 r
.34676 .53791 m
.35006 .51 L
s
.31019 .50376 m
.33879 .50823 L
s
.24 .35 .67 r
.34368 .50418 m
.35443 .49199 L
s
.34202 .50941 m
.34368 .50418 L
s
.997 .292 .125 r
.5 .38446 m .4973 .40055 L .50038 .40108 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.36461 .42418 m
.32466 .41747 L
s
.36461 .42418 m
.37049 .39803 L
s
.318 .471 .867 r
.36593 .46242 m .36273 .47229 L .34823 .49155 L p F P
0 0 0 r
s
.33 .49 .916 r
.36273 .47229 m .36593 .46242 L .3832 .44506 L p F P
0 0 0 r
s
.83 .24 .1 r
.31936 .44566 m
.27916 .43906 L
s
.31936 .44566 m
.32466 .41747 L
s
.624 .162 .067 r
.55574 .64198 m .57341 .6445 L .57734 .63217 L p F P
0 0 0 r
s
.624 .162 .067 r
.57734 .63217 m .55874 .62948 L .55574 .64198 L p F P
0 0 0 r
s
.997 .292 .125 r
.5 .38446 m .49421 .40001 L .4973 .40055 L closepath p F P
0 0 0 r
s
.774 .211 .088 r
.40387 .5914 m .42379 .59432 L .42355 .5765 L p F P
0 0 0 r
s
.774 .211 .088 r
.42355 .5765 m .40357 .57353 L .40387 .5914 L p F P
0 0 0 r
s
.997 .292 .125 r
.5 .38446 m .49112 .39947 L .49421 .40001 L closepath p F P
0 0 0 r
s
.281 .418 .824 r
.51747 .39976 m .51832 .39775 L .5 .38446 L closepath p F P
0 0 0 r
s
.307 .456 .885 r
.44752 .4063 m .449 .40235 L .47411 .39218 L p F P
0 0 0 r
s
.307 .456 .885 r
.47411 .39218 m .47332 .39421 L .44752 .4063 L p F P
0 0 0 r
s
.83 .24 .1 r
.44976 .41163 m
.45229 .40327 L
s
.821 .226 .095 r
.34298 .56451 m .36329 .56753 L .36602 .54829 L p F P
0 0 0 r
s
.821 .226 .095 r
.36602 .54829 m .34612 .54527 L .34298 .56451 L p F P
0 0 0 r
s
.997 .292 .125 r
.5 .38446 m .48803 .39893 L .49112 .39947 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.30663 .53179 m
.31019 .50376 L
s
.31019 .50376 m
.2699 .49747 L
s
.997 .292 .125 r
.5 .38446 m .48494 .39839 L .48803 .39893 L closepath p F P
0 0 0 r
s
.267 .397 .787 r
.52091 .39168 m .52004 .39371 L .53944 .40532 L p F P
0 0 0 r
s
.267 .397 .787 r
.53944 .40532 m .5412 .40136 L .52091 .39168 L p F P
0 0 0 r
s
.997 .292 .125 r
.5 .38446 m .48184 .39786 L .48494 .39839 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.43196 .73233 m
.42282 .75122 L
s
.42282 .75122 m
.39468 .74214 L
s
.193 .286 .592 r
.60329 .46985 m .60845 .45994 L .59445 .44287 L p F P
0 0 0 r
s
.167 .247 .522 r
.60845 .45994 m .60329 .46985 L .61422 .48889 L p F P
0 0 0 r
s
.712 .19 .079 r
.46429 .61584 m .48337 .6186 L .48292 .60299 L p F P
0 0 0 r
s
.712 .19 .079 r
.48292 .60299 m .46331 .60011 L .46429 .61584 L p F P
0 0 0 r
s
.136 .2 .437 r
.61641 .51957 m .6226 .50838 L .61422 .48889 L p F P
0 0 0 r
s
.098 .143 .332 r
.6226 .50838 m .61641 .51957 L .62168 .53942 L p F P
0 0 0 r
s
.83 .24 .1 r
.32876 .53516 m
.34676 .53791 L
s
.997 .292 .125 r
.5 .38446 m .47874 .39732 L .48184 .39786 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.39468 .74214 m
.36864 .72805 L
s
.37669 .70869 m
.36864 .72805 L
s
.281 .418 .824 r
.51832 .39775 m .51918 .39573 L .5 .38446 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.62902 .66105 m
.62301 .64638 L
s
.59336 .64213 m
.62301 .64638 L
s
.327 .485 .926 r
.42724 .40893 m .42517 .41472 L .40309 .42906 L p F P
0 0 0 r
s
.318 .472 .909 r
.42517 .41472 m .42724 .40893 L .45049 .39836 L p F P
0 0 0 r
s
.83 .24 .1 r
.43411 .40894 m
.43576 .40922 L
s
.318 .472 .909 r
.45049 .39836 m .449 .40235 L .42517 .41472 L p F P
0 0 0 r
s
.83 .24 .1 r
.41033 .40486 m
.4291 .40808 L
s
.24 .35 .67 r
.58095 .65806 m
.56887 .67842 L
s
.56887 .67842 m
.55026 .69509 L
s
.997 .292 .125 r
.5 .38446 m .47564 .39678 L .47874 .39732 L closepath p F P
0 0 0 r
s
.624 .162 .067 r
.53799 .63945 m .55574 .64198 L .55874 .62948 L p F P
0 0 0 r
s
.624 .162 .067 r
.55874 .62948 m .54004 .62678 L .53799 .63945 L p F P
0 0 0 r
s
.83 .24 .1 r
.54218 .61602 m
.54522 .63523 L
s
.332 .492 .931 r
.40565 .42162 m .40309 .42906 L .3832 .44506 L p F P
0 0 0 r
s
.327 .485 .926 r
.40309 .42906 m .40565 .42162 L .42724 .40893 L p F P
0 0 0 r
s
.83 .24 .1 r
.40645 .42115 m
.41033 .40486 L
s
.62129 .39742 m
.58258 .39055 L
s
.62129 .39742 m
.63095 .38363 L
s
.997 .292 .125 r
.5 .38446 m .47253 .39623 L .47564 .39678 L closepath p F P
0 0 0 r
s
.774 .211 .088 r
.38385 .58847 m .40387 .5914 L .40357 .57353 L p F P
0 0 0 r
s
.774 .211 .088 r
.40357 .57353 m .38348 .57054 L .38385 .58847 L p F P
0 0 0 r
s
.83 .24 .1 r
.38458 .56987 m
.42427 .57579 L
s
.24 .35 .67 r
.40327 .72305 m
.39468 .74214 L
s
.821 .226 .095 r
.32256 .56147 m .34298 .56451 L .34612 .54527 L p F P
0 0 0 r
s
.24 .35 .67 r
.32073 .57204 m
.32296 .56152 L
s
.32304 .56114 m
.32575 .54833 L
s
.821 .226 .095 r
.34612 .54527 m .32613 .54224 L .32256 .56147 L p F P
0 0 0 r
s
.83 .24 .1 r
.34447 .56389 m
.34676 .53791 L
s
.295 .438 .856 r
.5 .38446 m .47253 .39623 L .47332 .39421 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.48877 .41832 m
.49616 .39558 L
s
.24 .35 .67 r
.5271 .70746 m
.51607 .72687 L
s
.51607 .72687 m
.4898 .73421 L
s
.83 .24 .1 r
.7464 .40437 m
.70833 .39753 L
s
.7464 .40437 m
.758 .39647 L
s
.75422 .68689 m
.7445 .67739 L
s
.7445 .67739 m
.70642 .672 L
s
.251 .373 .747 r
.54297 .39737 m .5412 .40136 L .56048 .41329 L p F P
0 0 0 r
s
.251 .373 .747 r
.56048 .41329 m .56317 .40748 L .54297 .39737 L p F P
0 0 0 r
s
.234 .348 .702 r
.56317 .40748 m .56048 .41329 L .57835 .42722 L p F P
0 0 0 r
s
.288 .426 .769 r
.35164 .4808 m .34823 .49155 L .33713 .51118 L p F P
0 0 0 r
s
.318 .471 .867 r
.34823 .49155 m .35164 .4808 L .36593 .46242 L p F P
0 0 0 r
s
.307 .456 .885 r
.449 .40235 m .45049 .39836 L .4749 .39015 L p F P
0 0 0 r
s
.83 .24 .1 r
.45307 .4007 m
.45317 .40038 L
s
.307 .456 .885 r
.4749 .39015 m .47411 .39218 L .449 .40235 L p F P
0 0 0 r
s
.281 .418 .824 r
.51918 .39573 m .52004 .39371 L .5 .38446 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.49616 .39558 m
.51957 .39967 L
s
.2699 .49747 m
.27431 .4683 L
s
.27431 .4683 m
.23371 .4618 L
s
.27431 .4683 m
.27916 .43906 L
s
.234 .348 .702 r
.57835 .42722 m .58194 .41976 L .56317 .40748 L p F P
0 0 0 r
s
.215 .319 .651 r
.58194 .41976 m .57835 .42722 L .59445 .44287 L p F P
0 0 0 r
s
.712 .19 .079 r
.4451 .61307 m .46429 .61584 L .46331 .60011 L p F P
0 0 0 r
s
.83 .24 .1 r
.46388 .6046 m
.50324 .61034 L
s
.46354 .58164 m
.46388 .6046 L
s
.712 .19 .079 r
.46331 .60011 m .4436 .59723 L .4451 .61307 L p F P
0 0 0 r
s
.24 .35 .67 r
.32181 .5972 m
.32073 .57204 L
s
.267 .397 .787 r
.52177 .38964 m .52091 .39168 L .5412 .40136 L p F P
0 0 0 r
s
.267 .397 .787 r
.5412 .40136 m .54297 .39737 L .52177 .38964 L p F P
0 0 0 r
s
.24 .35 .67 r
.5314 .42347 m
.54257 .39834 L
s
.33 .49 .916 r
.38615 .43621 m .3832 .44506 L .36593 .46242 L p F P
0 0 0 r
s
.332 .492 .931 r
.3832 .44506 m .38615 .43621 L .40565 .42162 L p F P
0 0 0 r
s
.24 .35 .67 r
.33507 .66798 m
.322 .64378 L
s
.32914 .62267 m
.322 .64378 L
s
.295 .438 .856 r
.5 .38446 m .47332 .39421 L .47411 .39218 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.32466 .41747 m
.28428 .41069 L
s
.32466 .41747 m
.33022 .39112 L
s
.624 .162 .067 r
.52016 .6369 m .53799 .63945 L .54004 .62678 L p F P
0 0 0 r
s
.624 .162 .067 r
.54004 .62678 m .52124 .62407 L .52016 .6369 L p F P
0 0 0 r
s
.83 .24 .1 r
.27916 .43906 m
.23853 .43239 L
s
.27916 .43906 m
.28428 .41069 L
s
.281 .418 .824 r
.52004 .39371 m .52091 .39168 L .5 .38446 L closepath p F P
0 0 0 r
s
.049 .072 .169 r
.61085 .59877 m .61726 .58789 L .61762 .56995 L p F P
0 0 0 r
s
.028 .04 .082 r
.61726 .58789 m .61085 .59877 L .60791 .61456 L p F P
0 0 0 r
s
.24 .35 .67 r
.60392 .59107 m
.61651 .56929 L
s
.028 .04 .082 r
.60182 .6248 m .60791 .61456 L .61085 .59877 L p F P
0 0 0 r
s
.774 .211 .088 r
.36371 .58552 m .38385 .58847 L .38348 .57054 L p F P
0 0 0 r
s
.774 .211 .088 r
.38348 .57054 m .36329 .56753 L .36371 .58552 L p F P
0 0 0 r
s
.167 .247 .522 r
.61422 .48889 m .62003 .47809 L .60845 .45994 L p F P
0 0 0 r
s
.136 .2 .437 r
.62003 .47809 m .61422 .48889 L .6226 .50838 L p F P
0 0 0 r
s
.24 .35 .67 r
.59994 .47471 m
.6151 .49745 L
s
.60254 .52061 m
.6151 .49745 L
s
.238 .35 .612 r
.32613 .54224 m .3297 .53079 L .33713 .51118 L p F P
0 0 0 r
s
.024 .035 .067 r
.3297 .53079 m .32613 .54224 L .32256 .56147 L p F P
0 0 0 r
s
.83 .24 .1 r
.30663 .53179 m
.32763 .53499 L
s
.32763 .53499 m
.32835 .5351 L
s
.215 .319 .651 r
.59445 .44287 m .59891 .43398 L .58194 .41976 L p F P
0 0 0 r
s
.193 .286 .592 r
.59891 .43398 m .59445 .44287 L .60845 .45994 L p F P
0 0 0 r
s
.067 .097 .237 r
.61762 .56995 m .62418 .55863 L .62168 .53942 L p F P
0 0 0 r
s
.049 .072 .169 r
.62418 .55863 m .61762 .56995 L .61726 .58789 L p F P
0 0 0 r
s
.83 .24 .1 r
.26606 .5256 m
.2699 .49747 L
s
.2699 .49747 m
.22917 .4911 L
s
.295 .438 .856 r
.5 .38446 m .47411 .39218 L .4749 .39015 L closepath p F P
0 0 0 r
s
.318 .472 .909 r
.45198 .39436 m .45049 .39836 L .42724 .40893 L p F P
0 0 0 r
s
.307 .456 .885 r
.45049 .39836 m .45198 .39436 L .4757 .38811 L p F P
0 0 0 r
s
.83 .24 .1 r
.45416 .39713 m
.45425 .39683 L
s
.307 .456 .885 r
.4757 .38811 m .4749 .39015 L .45049 .39836 L p F P
0 0 0 r
s
.83 .24 .1 r
.45526 .39349 m
.45672 .38868 L
s
.45672 .38868 m
.46682 .39045 L
s
.47259 .39146 m
.49616 .39558 L
s
.281 .418 .824 r
.52091 .39168 m .52177 .38964 L .5 .38446 L closepath p F P
0 0 0 r
s
.024 .035 .067 r
.60791 .61456 m .60182 .6248 L .59661 .63758 L p F P
0 0 0 r
s
.024 .035 .067 r
.59099 .64701 m .59661 .63758 L .60182 .6248 L p F P
0 0 0 r
s
.24 .35 .67 r
.59444 .63782 m
.60214 .61514 L
s
.83 .24 .1 r
.58432 .64083 m
.59307 .64209 L
s
.24 .35 .67 r
.59165 .64251 m
.59444 .63782 L
s
.327 .485 .926 r
.42934 .40308 m .42724 .40893 L .40565 .42162 L p F P
0 0 0 r
s
.83 .24 .1 r
.37049 .39803 m
.41033 .40486 L
s
.24 .35 .67 r
.41354 .43367 m
.42059 .41375 L
s
.42059 .41375 m
.44733 .40902 L
s
.318 .472 .909 r
.42724 .40893 m .42934 .40308 L .45198 .39436 L p F P
0 0 0 r
s
.712 .19 .079 r
.42582 .61028 m .4451 .61307 L .4436 .59723 L p F P
0 0 0 r
s
.712 .19 .079 r
.4436 .59723 m .42379 .59432 L .42582 .61028 L p F P
0 0 0 r
s
.83 .24 .1 r
.30392 .55785 m
.30663 .53179 L
s
.30663 .53179 m
.26606 .5256 L
s
.267 .397 .787 r
.52264 .3876 m .52177 .38964 L .54297 .39737 L p F P
0 0 0 r
s
.267 .397 .787 r
.54297 .39737 m .54476 .39336 L .52264 .3876 L p F P
0 0 0 r
s
.251 .373 .747 r
.54476 .39336 m .54297 .39737 L .56317 .40748 L p F P
0 0 0 r
s
.624 .162 .067 r
.50223 .63434 m .52016 .6369 L .52124 .62407 L p F P
0 0 0 r
s
.624 .162 .067 r
.52124 .62407 m .50236 .62134 L .50223 .63434 L p F P
0 0 0 r
s
.83 .24 .1 r
.50324 .61034 m
.5057 .62956 L
s
.318 .471 .867 r
.36917 .45239 m .36593 .46242 L .35164 .4808 L p F P
0 0 0 r
s
.33 .49 .916 r
.36593 .46242 m .36917 .45239 L .38615 .43621 L p F P
0 0 0 r
s
.24 .35 .67 r
.36057 .48315 m
.36737 .46223 L
s
.36737 .46223 m
.38788 .44816 L
s
.295 .438 .856 r
.5 .38446 m .4749 .39015 L .4757 .38811 L closepath p F P
0 0 0 r
s
.251 .373 .747 r
.56317 .40748 m .56589 .40162 L .54476 .39336 L p F P
0 0 0 r
s
.234 .348 .702 r
.56589 .40162 m .56317 .40748 L .58194 .41976 L p F P
0 0 0 r
s
.24 .35 .67 r
.55725 .43707 m
.56895 .41218 L
s
.83 .24 .1 r
.57379 .40915 m
.58258 .39055 L
s
.24 .35 .67 r
.54257 .39834 m
.56895 .41218 L
s
.83 .24 .1 r
.37049 .39803 m
.33022 .39112 L
s
.37049 .39803 m
.37658 .37468 L
s
.098 .143 .332 r
.62168 .53942 m .62821 .52791 L .6226 .50838 L p F P
0 0 0 r
s
.067 .097 .237 r
.62821 .52791 m .62168 .53942 L .62418 .55863 L p F P
0 0 0 r
s
.281 .418 .824 r
.52177 .38964 m .52264 .3876 L .5 .38446 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.51442 .38869 m
.54257 .39834 L
s
.508 .40399 m
.51442 .38869 L
s
.774 .211 .088 r
.34347 .58255 m .36371 .58552 L .36329 .56753 L p F P
0 0 0 r
s
.774 .211 .088 r
.36329 .56753 m .34298 .56451 L .34347 .58255 L p F P
0 0 0 r
s
.83 .24 .1 r
.34447 .56389 m
.38458 .56987 L
s
.332 .492 .931 r
.40824 .4141 m .40565 .42162 L .38615 .43621 L p F P
0 0 0 r
s
.327 .485 .926 r
.40565 .42162 m .40824 .4141 L .42934 .40308 L p F P
0 0 0 r
s
.83 .24 .1 r
.70833 .39753 m
.66985 .39061 L
s
.70833 .39753 m
.71929 .38947 L
s
.71548 .68145 m
.70642 .672 L
s
.70642 .672 m
.66793 .66656 L
s
.238 .35 .612 r
.34068 .49983 m .33713 .51118 L .3297 .53079 L p F P
0 0 0 r
s
.24 .35 .67 r
.32963 .53593 m
.33287 .52558 L
s
.288 .426 .769 r
.33713 .51118 m .34068 .49983 L .35164 .4808 L p F P
0 0 0 r
s
.24 .35 .67 r
.33287 .52558 m
.34368 .50418 L
s
.83 .24 .1 r
.22917 .4911 m
.23371 .4618 L
s
.23371 .4618 m
.19268 .45523 L
s
.23371 .4618 m
.23853 .43239 L
s
.307 .456 .885 r
.4765 .38606 m .4757 .38811 L .45198 .39436 L p F P
0 0 0 r
s
.295 .438 .856 r
.5 .38446 m .4757 .38811 L .4765 .38606 L closepath p F P
0 0 0 r
s
.712 .19 .079 r
.40644 .60749 m .42582 .61028 L .42379 .59432 L p F P
0 0 0 r
s
.83 .24 .1 r
.42411 .59879 m
.46388 .6046 L
s
.42411 .59879 m
.42427 .57579 L
s
.712 .19 .079 r
.42379 .59432 m .40387 .5914 L .40644 .60749 L p F P
0 0 0 r
s
.193 .286 .592 r
.60845 .45994 m .61368 .44987 L .59891 .43398 L p F P
0 0 0 r
s
.167 .247 .522 r
.61368 .44987 m .60845 .45994 L .62003 .47809 L p F P
0 0 0 r
s
.24 .35 .67 r
.59994 .47471 m
.6126 .45035 L
s
.318 .472 .909 r
.45348 .39033 m .45198 .39436 L .42934 .40308 L p F P
0 0 0 r
s
.307 .456 .885 r
.45198 .39436 m .45348 .39033 L .4765 .38606 L p F P
0 0 0 r
s
.281 .418 .824 r
.52264 .3876 m .52351 .38555 L .5 .38446 L closepath p F P
0 0 0 r
s
.267 .397 .787 r
.52351 .38555 m .52264 .3876 L .54476 .39336 L p F P
0 0 0 r
s
.234 .348 .702 r
.58194 .41976 m .58559 .41222 L .56589 .40162 L p F P
0 0 0 r
s
.215 .319 .651 r
.58559 .41222 m .58194 .41976 L .59891 .43398 L p F P
0 0 0 r
s
.24 .35 .67 r
.56895 .41218 m
.59259 .42972 L
s
.5804 .45435 m
.59259 .42972 L
s
.624 .162 .067 r
.48423 .63177 m .50223 .63434 L .50236 .62134 L p F P
0 0 0 r
s
.624 .162 .067 r
.50236 .62134 m .48337 .6186 L .48423 .63177 L p F P
0 0 0 r
s
.83 .24 .1 r
.28428 .41069 m
.24347 .40383 L
s
.28428 .41069 m
.28952 .38414 L
s
.23853 .43239 m
.19747 .42565 L
s
.23853 .43239 m
.24347 .40383 L
s
.495 .122 .05 r
.56763 .65375 m .58384 .65604 L .59099 .64701 L p F P
0 0 0 r
s
.24 .35 .67 r
.58095 .65806 m
.58243 .65584 L
s
.495 .122 .05 r
.59099 .64701 m .57341 .6445 L .56763 .65375 L p F P
0 0 0 r
s
.252 .38 .679 r
.59661 .63758 m .59099 .64701 L .58384 .65604 L p F P
0 0 0 r
s
.24 .35 .67 r
.5854 .65138 m
.59444 .63782 L
s
.83 .24 .1 r
.58432 .64083 m
.5878 .65032 L
s
.54522 .63523 m
.58432 .64083 L
s
.267 .397 .787 r
.54476 .39336 m .54655 .38932 L .52351 .38555 L p F P
0 0 0 r
s
.251 .373 .747 r
.54655 .38932 m .54476 .39336 L .56589 .40162 L p F P
0 0 0 r
s
.295 .438 .856 r
.5 .38446 m .48133 .37364 L .48215 .37155 L closepath p F P
0 0 0 r
s
.295 .438 .856 r
.5 .38446 m .48215 .37155 L .48297 .36945 L closepath p F P
0 0 0 r
s
.295 .438 .856 r
.5 .38446 m .48297 .36945 L .48379 .36734 L closepath p F P
0 0 0 r
s
.295 .438 .856 r
.5 .38446 m .4781 .38195 L .4789 .37988 L closepath p F P
0 0 0 r
s
.295 .438 .856 r
.5 .38446 m .4789 .37988 L .47971 .37781 L closepath p F P
0 0 0 r
s
.295 .438 .856 r
.5 .38446 m .47971 .37781 L .48052 .37573 L closepath p F P
0 0 0 r
s
.295 .438 .856 r
.5 .38446 m .48052 .37573 L .48133 .37364 L closepath p F P
0 0 0 r
s
.993 .294 .126 r
.52478 .37465 m .52791 .37521 L .5 .38446 L closepath p F P
0 0 0 r
s
.993 .294 .126 r
.52164 .37409 m .52478 .37465 L .5 .38446 L closepath p F P
0 0 0 r
s
.993 .294 .126 r
.5185 .37353 m .52164 .37409 L .5 .38446 L closepath p F P
0 0 0 r
s
.993 .294 .126 r
.51536 .37297 m .5185 .37353 L .5 .38446 L closepath p F P
0 0 0 r
s
.993 .294 .126 r
.51221 .37241 m .51536 .37297 L .5 .38446 L closepath p F P
0 0 0 r
s
.993 .294 .126 r
.50907 .37185 m .51221 .37241 L .5 .38446 L closepath p F P
0 0 0 r
s
.295 .438 .856 r
.5 .38446 m .4765 .38606 L .4773 .38401 L closepath p F P
0 0 0 r
s
.295 .438 .856 r
.5 .38446 m .4773 .38401 L .4781 .38195 L closepath p F P
0 0 0 r
s
.281 .418 .824 r
.52703 .37729 m .52791 .37521 L .5 .38446 L closepath p F P
0 0 0 r
s
.281 .418 .824 r
.52615 .37937 m .52703 .37729 L .5 .38446 L closepath p F P
0 0 0 r
s
.281 .418 .824 r
.52527 .38144 m .52615 .37937 L .5 .38446 L closepath p F P
0 0 0 r
s
.281 .418 .824 r
.52439 .3835 m .52527 .38144 L .5 .38446 L closepath p F P
0 0 0 r
s
.281 .418 .824 r
.52351 .38555 m .52439 .3835 L .5 .38446 L closepath p F P
0 0 0 r
s
.993 .294 .126 r
.50592 .37129 m .50907 .37185 L .5 .38446 L closepath p F P
0 0 0 r
s
.993 .294 .126 r
.50276 .37073 m .50592 .37129 L .5 .38446 L closepath p F P
0 0 0 r
s
.993 .294 .126 r
.49961 .37016 m .50276 .37073 L .5 .38446 L closepath p F P
0 0 0 r
s
.993 .294 .126 r
.49645 .3696 m .49961 .37016 L .5 .38446 L closepath p F P
0 0 0 r
s
.993 .294 .126 r
.49329 .36904 m .49645 .3696 L .5 .38446 L closepath p F P
0 0 0 r
s
.993 .294 .126 r
.49012 .36847 m .49329 .36904 L .5 .38446 L closepath p F P
0 0 0 r
s
.993 .294 .126 r
.48696 .36791 m .49012 .36847 L .5 .38446 L closepath p F P
0 0 0 r
s
.993 .294 .126 r
.48379 .36734 m .48696 .36791 L .5 .38446 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.49616 .39558 m
.5039 .37658 L
s
.24 .35 .67 r
.48552 .3836 m
.51442 .38869 L
s
.47942 .39902 m
.48552 .3836 L
s
.774 .211 .088 r
.32312 .57957 m .34347 .58255 L .34298 .56451 L p F P
0 0 0 r
s
.774 .211 .088 r
.34298 .56451 m .32256 .56147 L .32312 .57957 L p F P
0 0 0 r
s
.24 .35 .67 r
.32073 .57204 m
.3227 .5658 L
s
.307 .456 .885 r
.4773 .38401 m .4765 .38606 L .45348 .39033 L p F P
0 0 0 r
s
.136 .2 .437 r
.6226 .50838 m .62892 .49697 L .62003 .47809 L p F P
0 0 0 r
s
.098 .143 .332 r
.62892 .49697 m .6226 .50838 L .62821 .52791 L p F P
0 0 0 r
s
.24 .35 .67 r
.6151 .49745 m
.62517 .52173 L
s
.6123 .54463 m
.62517 .52173 L
s
.50039 .71479 m
.4898 .73421 L
s
.4898 .73421 m
.4613 .7361 L
s
.327 .485 .926 r
.43145 .39718 m .42934 .40308 L .40824 .4141 L p F P
0 0 0 r
s
.318 .472 .909 r
.42934 .40308 m .43145 .39718 L .45348 .39033 L p F P
0 0 0 r
s
.267 .397 .787 r
.52439 .3835 m .52351 .38555 L .54655 .38932 L p F P
0 0 0 r
s
.33 .49 .916 r
.38914 .42723 m .38615 .43621 L .36917 .45239 L p F P
0 0 0 r
s
.332 .492 .931 r
.38615 .43621 m .38914 .42723 L .40824 .4141 L p F P
0 0 0 r
s
.83 .24 .1 r
.22506 .51935 m
.22917 .4911 L
s
.22917 .4911 m
.18801 .48467 L
s
.712 .19 .079 r
.38696 .60467 m .40644 .60749 L .40387 .5914 L p F P
0 0 0 r
s
.712 .19 .079 r
.40387 .5914 m .38385 .58847 L .38696 .60467 L p F P
0 0 0 r
s
.288 .426 .769 r
.35511 .46985 m .35164 .4808 L .34068 .49983 L p F P
0 0 0 r
s
.318 .471 .867 r
.35164 .4808 m .35511 .46985 L .36917 .45239 L p F P
0 0 0 r
s
.83 .24 .1 r
.26294 .55175 m
.26606 .5256 L
s
.26606 .5256 m
.22506 .51935 L
s
.251 .373 .747 r
.56589 .40162 m .56863 .3957 L .54655 .38932 L p F P
0 0 0 r
s
.234 .348 .702 r
.56863 .3957 m .56589 .40162 L .58559 .41222 L p F P
0 0 0 r
s
.24 .35 .67 r
.35358 .69 m
.33507 .66798 L
s
.34253 .64719 m
.33507 .66798 L
s
.624 .162 .067 r
.46613 .62919 m .48423 .63177 L .48337 .6186 L p F P
0 0 0 r
s
.624 .162 .067 r
.48337 .6186 m .46429 .61584 L .46613 .62919 L p F P
0 0 0 r
s
.307 .456 .885 r
.45348 .39033 m .455 .38627 L .4773 .38401 L p F P
0 0 0 r
s
.307 .456 .885 r
.4781 .38195 m .4773 .38401 L .455 .38627 L p F P
0 0 0 r
s
.318 .472 .909 r
.455 .38627 m .45348 .39033 L .43145 .39718 L p F P
0 0 0 r
s
.83 .24 .1 r
.41686 .38172 m
.45168 .3878 L
s
.5057 .62956 m
.54522 .63523 L
s
.495 .122 .05 r
.55134 .65145 m .56763 .65375 L .57341 .6445 L p F P
0 0 0 r
s
.495 .122 .05 r
.57341 .6445 m .55574 .64198 L .55134 .65145 L p F P
0 0 0 r
s
.267 .397 .787 r
.52527 .38144 m .52439 .3835 L .54836 .38526 L p F P
0 0 0 r
s
.83 .24 .1 r
.54151 .388 m
.5429 .38485 L
s
.267 .397 .787 r
.54655 .38932 m .54836 .38526 L .52439 .3835 L p F P
0 0 0 r
s
.83 .24 .1 r
.5431 .38439 m
.54345 .3836 L
s
.54345 .3836 m
.58258 .39055 L
s
.215 .319 .651 r
.59891 .43398 m .60343 .42497 L .58559 .41222 L p F P
0 0 0 r
s
.193 .286 .592 r
.60343 .42497 m .59891 .43398 L .61368 .44987 L p F P
0 0 0 r
s
.24 .35 .67 r
.5621 .67484 m
.55026 .69509 L
s
.55026 .69509 m
.5271 .70746 L
s
.83 .24 .1 r
.33022 .39112 m
.28952 .38414 L
s
.33022 .39112 m
.33585 .36756 L
s
.251 .373 .747 r
.54836 .38526 m .54655 .38932 L .56863 .3957 L p F P
0 0 0 r
s
.024 .035 .067 r
.32256 .56147 m .32617 .54997 L .3297 .53079 L p F P
0 0 0 r
s
.045 .065 .149 r
.32617 .54997 m .32256 .56147 L .32312 .57957 L p F P
0 0 0 r
s
.83 .24 .1 r
.30392 .55785 m
.32281 .56067 L
s
.32504 .561 m
.34447 .56389 L
s
.66985 .39061 m
.63095 .38363 L
s
.66985 .39061 m
.68017 .38238 L
s
.67633 .67596 m
.66793 .66656 L
s
.66793 .66656 m
.62902 .66105 L
s
.307 .456 .885 r
.455 .38627 m .45652 .38219 L .4781 .38195 L p F P
0 0 0 r
s
.307 .456 .885 r
.4789 .37988 m .4781 .38195 L .45652 .38219 L p F P
0 0 0 r
s
.332 .492 .931 r
.41086 .4065 m .40824 .4141 L .38914 .42723 L p F P
0 0 0 r
s
.327 .485 .926 r
.40824 .4141 m .41086 .4065 L .43145 .39718 L p F P
0 0 0 r
s
.24 .35 .67 r
.39629 .42328 m
.42059 .41375 L
s
.83 .24 .1 r
.41033 .40486 m
.41686 .38172 L
s
.19268 .45523 m
.18801 .48467 L
s
.19747 .42565 m
.19268 .45523 L
s
.267 .397 .787 r
.52615 .37937 m .52527 .38144 L .55017 .38117 L p F P
0 0 0 r
s
.267 .397 .787 r
.54836 .38526 m .55017 .38117 L .52527 .38144 L p F P
0 0 0 r
s
.167 .247 .522 r
.62003 .47809 m .62594 .4671 L .61368 .44987 L p F P
0 0 0 r
s
.136 .2 .437 r
.62594 .4671 m .62003 .47809 L .62892 .49697 L p F P
0 0 0 r
s
.83 .24 .1 r
.41686 .38172 m
.37658 .37468 L
s
.712 .19 .079 r
.36738 .60184 m .38696 .60467 L .38385 .58847 L p F P
0 0 0 r
s
.83 .24 .1 r
.38391 .59293 m
.42411 .59879 L
s
.38391 .59293 m
.38458 .56987 L
s
.712 .19 .079 r
.38385 .58847 m .36371 .58552 L .36738 .60184 L p F P
0 0 0 r
s
.624 .162 .067 r
.44794 .6266 m .46613 .62919 L .46429 .61584 L p F P
0 0 0 r
s
.624 .162 .067 r
.46429 .61584 m .4451 .61307 L .44794 .6266 L p F P
0 0 0 r
s
.83 .24 .1 r
.46388 .6046 m
.46575 .62383 L
s
.495 .122 .05 r
.53499 .64914 m .55134 .65145 L .55574 .64198 L p F P
0 0 0 r
s
.495 .122 .05 r
.55574 .64198 m .53799 .63945 L .53499 .64914 L p F P
0 0 0 r
s
.049 .072 .169 r
.61726 .58789 m .62379 .57679 L .62418 .55863 L p F P
0 0 0 r
s
.028 .04 .082 r
.62379 .57679 m .61726 .58789 L .61411 .60412 L p F P
0 0 0 r
s
.028 .04 .082 r
.60791 .61456 m .61411 .60412 L .61726 .58789 L p F P
0 0 0 r
s
.24 .35 .67 r
.61484 .59358 m
.61651 .56929 L
s
.83 .24 .1 r
.24347 .40383 m
.20222 .39691 L
s
.24347 .40383 m
.24838 .37708 L
s
.238 .35 .612 r
.3297 .53079 m .33334 .51911 L .34068 .49983 L p F P
0 0 0 r
s
.024 .035 .067 r
.33334 .51911 m .3297 .53079 L .32617 .54997 L p F P
0 0 0 r
s
.83 .24 .1 r
.20222 .39691 m
.19747 .42565 L
s
.307 .456 .885 r
.45652 .38219 m .45806 .37808 L .4789 .37988 L p F P
0 0 0 r
s
.307 .456 .885 r
.47971 .37781 m .4789 .37988 L .45806 .37808 L p F P
0 0 0 r
s
.318 .471 .867 r
.37248 .44219 m .36917 .45239 L .35511 .46985 L p F P
0 0 0 r
s
.33 .49 .916 r
.36917 .45239 m .37248 .44219 L .38914 .42723 L p F P
0 0 0 r
s
.24 .35 .67 r
.38788 .44816 m
.39629 .42328 L
s
.234 .348 .702 r
.58559 .41222 m .58927 .40459 L .56863 .3957 L p F P
0 0 0 r
s
.215 .319 .651 r
.58927 .40459 m .58559 .41222 L .60343 .42497 L p F P
0 0 0 r
s
.83 .24 .1 r
.79628 .40341 m
.758 .39647 L
s
.79628 .40341 m
.80828 .40163 L
s
.327 .485 .926 r
.43358 .39122 m .43145 .39718 L .41086 .4065 L p F P
0 0 0 r
s
.318 .472 .909 r
.43145 .39718 m .43358 .39122 L .455 .38627 L p F P
0 0 0 r
s
.318 .472 .909 r
.45652 .38219 m .455 .38627 L .43358 .39122 L p F P
0 0 0 r
s
.267 .397 .787 r
.52703 .37729 m .52615 .37937 L .552 .37705 L p F P
0 0 0 r
s
.267 .397 .787 r
.55017 .38117 m .552 .37705 L .52615 .37937 L p F P
0 0 0 r
s
.067 .097 .237 r
.62418 .55863 m .63087 .54708 L .62821 .52791 L p F P
0 0 0 r
s
.049 .072 .169 r
.63087 .54708 m .62418 .55863 L .62379 .57679 L p F P
0 0 0 r
s
.024 .035 .067 r
.61411 .60412 m .60791 .61456 L .60233 .62799 L p F P
0 0 0 r
s
.024 .035 .067 r
.59661 .63758 m .60233 .62799 L .60791 .61456 L p F P
0 0 0 r
s
.24 .35 .67 r
.60214 .61514 m
.61484 .59358 L
s
.251 .373 .747 r
.55017 .38117 m .54836 .38526 L .5714 .38973 L p F P
0 0 0 r
s
.251 .373 .747 r
.56863 .3957 m .5714 .38973 L .54836 .38526 L p F P
0 0 0 r
s
.83 .24 .1 r
.26294 .55175 m
.30392 .55785 L
s
.3022 .581 m
.30392 .55785 L
s
.18801 .48467 m
.18361 .51303 L
s
.234 .348 .702 r
.5714 .38973 m .56863 .3957 L .58927 .40459 L p F P
0 0 0 r
s
.307 .456 .885 r
.45806 .37808 m .4596 .37394 L .47971 .37781 L p F P
0 0 0 r
s
.307 .456 .885 r
.48052 .37573 m .47971 .37781 L .4596 .37394 L p F P
0 0 0 r
s
.24 .35 .67 r
.47138 .71659 m
.4613 .7361 L
s
.4613 .7361 m
.43196 .73233 L
s
.712 .19 .079 r
.34769 .599 m .36738 .60184 L .36371 .58552 L p F P
0 0 0 r
s
.712 .19 .079 r
.36371 .58552 m .34347 .58255 L .34769 .599 L p F P
0 0 0 r
s
.495 .122 .05 r
.51856 .64682 m .53499 .64914 L .53799 .63945 L p F P
0 0 0 r
s
.495 .122 .05 r
.53799 .63945 m .52016 .6369 L .51856 .64682 L p F P
0 0 0 r
s
.267 .397 .787 r
.52791 .37521 m .52703 .37729 L .55384 .37291 L p F P
0 0 0 r
s
.267 .397 .787 r
.552 .37705 m .55384 .37291 L .52703 .37729 L p F P
0 0 0 r
s
.83 .24 .1 r
.5039 .37658 m
.52764 .38079 L
s
.624 .162 .067 r
.42967 .62399 m .44794 .6266 L .4451 .61307 L p F P
0 0 0 r
s
.624 .162 .067 r
.4451 .61307 m .42582 .61028 L .42967 .62399 L p F P
0 0 0 r
s
.83 .24 .1 r
.22152 .54557 m
.22506 .51935 L
s
.22506 .51935 m
.18361 .51303 L
s
.193 .286 .592 r
.61368 .44987 m .61901 .43963 L .60343 .42497 L p F P
0 0 0 r
s
.24 .35 .67 r
.59259 .42972 m
.6126 .45035 L
s
.167 .247 .522 r
.61901 .43963 m .61368 .44987 L .62594 .4671 L p F P
0 0 0 r
s
.098 .143 .332 r
.62821 .52791 m .63487 .51617 L .62892 .49697 L p F P
0 0 0 r
s
.067 .097 .237 r
.63487 .51617 m .62821 .52791 L .63087 .54708 L p F P
0 0 0 r
s
.24 .35 .67 r
.62517 .52173 m
.62961 .54663 L
s
.83 .24 .1 r
.46575 .62383 m
.5057 .62956 L
s
.24 .35 .67 r
.37669 .70869 m
.35358 .69 L
s
.36146 .66954 m
.35358 .69 L
s
.238 .35 .612 r
.3443 .48825 m .34068 .49983 L .33334 .51911 L p F P
0 0 0 r
s
.288 .426 .769 r
.34068 .49983 m .3443 .48825 L .35511 .46985 L p F P
0 0 0 r
s
.24 .35 .67 r
.34368 .50418 m
.35122 .48035 L
s
.35122 .48035 m
.36737 .46223 L
s
.33 .49 .916 r
.39218 .41812 m .38914 .42723 L .37248 .44219 L p F P
0 0 0 r
s
.332 .492 .931 r
.38914 .42723 m .39218 .41812 L .41086 .4065 L p F P
0 0 0 r
s
.83 .24 .1 r
.28952 .38414 m
.24838 .37708 L
s
.28952 .38414 m
.29469 .36037 L
s
.307 .456 .885 r
.4596 .37394 m .46115 .36978 L .48052 .37573 L p F P
0 0 0 r
s
.307 .456 .885 r
.48133 .37364 m .48052 .37573 L .46115 .36978 L p F P
0 0 0 r
s
.318 .472 .909 r
.43358 .39122 m .43574 .38521 L .45652 .38219 L p F P
0 0 0 r
s
.318 .472 .909 r
.45806 .37808 m .45652 .38219 L .43574 .38521 L p F P
0 0 0 r
s
.24 .35 .67 r
.44733 .40902 m
.45694 .38331 L
s
.45694 .38331 m
.48552 .3836 L
s
.83 .24 .1 r
.63095 .38363 m
.59164 .37656 L
s
.63095 .38363 m
.64062 .37522 L
s
.267 .397 .787 r
.55384 .37291 m .55569 .36874 L .52791 .37521 L p F P
0 0 0 r
s
.971 .291 .125 r
.52791 .37521 m .52478 .37465 L .54946 .36762 L p F P
0 0 0 r
s
.971 .291 .125 r
.54946 .36762 m .55569 .36874 L .52791 .37521 L p F P
0 0 0 r
s
.83 .24 .1 r
.63675 .6704 m
.62902 .66105 L
s
.252 .38 .679 r
.60233 .62799 m .59661 .63758 L .58896 .64744 L p F P
0 0 0 r
s
.252 .38 .679 r
.58384 .65604 m .58896 .64744 L .59661 .63758 L p F P
0 0 0 r
s
.83 .24 .1 r
.5897 .65549 m
.62902 .66105 L
s
.58792 .65064 m
.5897 .65549 L
s
.971 .291 .125 r
.52478 .37465 m .52164 .37409 L .54322 .3665 L p F P
0 0 0 r
s
.971 .291 .125 r
.54322 .3665 m .54946 .36762 L .52478 .37465 L p F P
0 0 0 r
s
.83 .24 .1 r
.54877 .37468 m
.5519 .36942 L
s
.251 .373 .747 r
.552 .37705 m .55017 .38117 L .57419 .3837 L p F P
0 0 0 r
s
.251 .373 .747 r
.5714 .38973 m .57419 .3837 L .55017 .38117 L p F P
0 0 0 r
s
.495 .122 .05 r
.50206 .64449 m .51856 .64682 L .52016 .6369 L p F P
0 0 0 r
s
.495 .122 .05 r
.52016 .6369 m .50223 .63434 L .50206 .64449 L p F P
0 0 0 r
s
.83 .24 .1 r
.5057 .62956 m
.50976 .64418 L
s
.37658 .37468 m
.33585 .36756 L
s
.37658 .37468 m
.38266 .35506 L
s
.971 .291 .125 r
.52164 .37409 m .5185 .37353 L .53696 .36538 L p F P
0 0 0 r
s
.971 .291 .125 r
.53696 .36538 m .54322 .3665 L .52164 .37409 L p F P
0 0 0 r
s
.712 .19 .079 r
.3279 .59614 m .34769 .599 L .34347 .58255 L p F P
0 0 0 r
s
.24 .35 .67 r
.32181 .5972 m
.32914 .62267 L
s
.712 .19 .079 r
.34347 .58255 m .32312 .57957 L .3279 .59614 L p F P
0 0 0 r
s
.83 .24 .1 r
.34327 .587 m
.34447 .56389 L
s
.34327 .587 m
.38391 .59293 L
s
.332 .492 .931 r
.41352 .3988 m .41086 .4065 L .39218 .41812 L p F P
0 0 0 r
s
.327 .485 .926 r
.41086 .4065 m .41352 .3988 L .43358 .39122 L p F P
0 0 0 r
s
.624 .162 .067 r
.4113 .62137 m .42967 .62399 L .42582 .61028 L p F P
0 0 0 r
s
.624 .162 .067 r
.42582 .61028 m .40644 .60749 L .4113 .62137 L p F P
0 0 0 r
s
.83 .24 .1 r
.42411 .59879 m
.42537 .61804 L
s
.215 .319 .651 r
.60343 .42497 m .60802 .41583 L .58927 .40459 L p F P
0 0 0 r
s
.193 .286 .592 r
.60802 .41583 m .60343 .42497 L .61901 .43963 L p F P
0 0 0 r
s
.307 .456 .885 r
.46115 .36978 m .46271 .3656 L .48133 .37364 L p F P
0 0 0 r
s
.307 .456 .885 r
.48215 .37155 m .48133 .37364 L .46271 .3656 L p F P
0 0 0 r
s
.83 .24 .1 r
.48001 .37234 m
.5039 .37658 L
s
.327 .485 .926 r
.43574 .38521 m .43358 .39122 L .41352 .3988 L p F P
0 0 0 r
s
.971 .291 .125 r
.5185 .37353 m .51536 .37297 L .5307 .36425 L p F P
0 0 0 r
s
.971 .291 .125 r
.5307 .36425 m .53696 .36538 L .5185 .37353 L p F P
0 0 0 r
s
.24 .35 .67 r
.51442 .38869 m
.52099 .37301 L
s
.136 .2 .437 r
.62892 .49697 m .63535 .48534 L .62594 .4671 L p F P
0 0 0 r
s
.098 .143 .332 r
.63535 .48534 m .62892 .49697 L .63487 .51617 L p F P
0 0 0 r
s
.83 .24 .1 r
.20679 .36995 m
.20222 .39691 L
s
.971 .291 .125 r
.51536 .37297 m .51221 .37241 L .52442 .36312 L p F P
0 0 0 r
s
.971 .291 .125 r
.52442 .36312 m .5307 .36425 L .51536 .37297 L p F P
0 0 0 r
s
.24 .35 .67 r
.52509 .36324 m
.52549 .3623 L
s
.83 .24 .1 r
.758 .39647 m
.71929 .38947 L
s
.758 .39647 m
.76933 .39455 L
s
.288 .426 .769 r
.35864 .45871 m .35511 .46985 L .3443 .48825 L p F P
0 0 0 r
s
.318 .471 .867 r
.35511 .46985 m .35864 .45871 L .37248 .44219 L p F P
0 0 0 r
s
.971 .291 .125 r
.51221 .37241 m .50907 .37185 L .51814 .36199 L p F P
0 0 0 r
s
.971 .291 .125 r
.51814 .36199 m .52442 .36312 L .51221 .37241 L p F P
0 0 0 r
s
.24 .35 .67 r
.44147 .71267 m
.43196 .73233 L
s
.43196 .73233 m
.40327 .72305 L
s
.83 .24 .1 r
.76548 .69047 m
.75422 .68689 L
s
.75422 .68689 m
.71548 .68145 L
s
.234 .348 .702 r
.57419 .3837 m .5714 .38973 L .593 .39687 L p F P
0 0 0 r
s
.234 .348 .702 r
.58927 .40459 m .593 .39687 L .5714 .38973 L p F P
0 0 0 r
s
.83 .24 .1 r
.58301 .38988 m
.59164 .37656 L
s
.215 .319 .651 r
.593 .39687 m .58927 .40459 L .60802 .41583 L p F P
0 0 0 r
s
.971 .291 .125 r
.50907 .37185 m .50592 .37129 L .51184 .36086 L p F P
0 0 0 r
s
.971 .291 .125 r
.51184 .36086 m .51814 .36199 L .50907 .37185 L p F P
0 0 0 r
s
.24 .35 .67 r
.40327 .72305 m
.37669 .70869 L
s
.38507 .68853 m
.37669 .70869 L
s
.307 .456 .885 r
.46271 .3656 m .46428 .36138 L .48215 .37155 L p F P
0 0 0 r
s
.307 .456 .885 r
.48297 .36945 m .48215 .37155 L .46428 .36138 L p F P
0 0 0 r
s
.318 .472 .909 r
.43574 .38521 m .43791 .37914 L .45806 .37808 L p F P
0 0 0 r
s
.318 .472 .909 r
.4596 .37394 m .45806 .37808 L .43791 .37914 L p F P
0 0 0 r
s
.24 .35 .67 r
.58095 .65806 m
.58228 .65582 L
s
.83 .24 .1 r
.22152 .54557 m
.26294 .55175 L
s
.26067 .57494 m
.26294 .55175 L
s
.971 .291 .125 r
.50592 .37129 m .50276 .37073 L .50553 .35972 L p F P
0 0 0 r
s
.971 .291 .125 r
.50553 .35972 m .51184 .36086 L .50592 .37129 L p F P
0 0 0 r
s
.495 .122 .05 r
.48548 .64214 m .50206 .64449 L .50223 .63434 L p F P
0 0 0 r
s
.495 .122 .05 r
.50223 .63434 m .48423 .63177 L .48548 .64214 L p F P
0 0 0 r
s
.971 .291 .125 r
.50276 .37073 m .49961 .37016 L .49921 .35859 L p F P
0 0 0 r
s
.971 .291 .125 r
.49921 .35859 m .50553 .35972 L .50276 .37073 L p F P
0 0 0 r
s
.83 .24 .1 r
.5039 .37658 m
.51172 .36221 L
s
.624 .162 .067 r
.39285 .61874 m .4113 .62137 L .40644 .60749 L p F P
0 0 0 r
s
.624 .162 .067 r
.40644 .60749 m .38696 .60467 L .39285 .61874 L p F P
0 0 0 r
s
.065 .095 .231 r
.32672 .5683 m .32312 .57957 L .3279 .59614 L p F P
0 0 0 r
s
.24 .35 .67 r
.32181 .5972 m
.32519 .58675 L
s
.045 .065 .149 r
.32312 .57957 m .32672 .5683 L .32617 .54997 L p F P
0 0 0 r
s
.24 .35 .67 r
.4122 .70317 m
.40327 .72305 L
s
.251 .373 .747 r
.55384 .37291 m .552 .37705 L .57701 .37762 L p F P
0 0 0 r
s
.251 .373 .747 r
.57419 .3837 m .57701 .37762 L .552 .37705 L p F P
0 0 0 r
s
.971 .291 .125 r
.49961 .37016 m .49645 .3696 L .49288 .35745 L p F P
0 0 0 r
s
.971 .291 .125 r
.49288 .35745 m .49921 .35859 L .49961 .37016 L p F P
0 0 0 r
s
.24 .35 .67 r
.53858 .68725 m
.5271 .70746 L
s
.5271 .70746 m
.50039 .71479 L
s
.83 .24 .1 r
.18361 .51303 m
.17964 .53933 L
s
.971 .291 .125 r
.49645 .3696 m .49329 .36904 L .48654 .35631 L p F P
0 0 0 r
s
.971 .291 .125 r
.48654 .35631 m .49288 .35745 L .49645 .3696 L p F P
0 0 0 r
s
.24 .35 .67 r
.49567 .35795 m
.49605 .35701 L
s
.83 .24 .1 r
.42537 .61804 m
.46575 .62383 L
s
.167 .247 .522 r
.62594 .4671 m .63195 .45591 L .61901 .43963 L p F P
0 0 0 r
s
.136 .2 .437 r
.63195 .45591 m .62594 .4671 L .63535 .48534 L p F P
0 0 0 r
s
.24 .35 .67 r
.6151 .49745 m
.62816 .47335 L
s
.307 .456 .885 r
.46428 .36138 m .46587 .35714 L .48297 .36945 L p F P
0 0 0 r
s
.307 .456 .885 r
.48379 .36734 m .48297 .36945 L .46587 .35714 L p F P
0 0 0 r
s
.024 .035 .067 r
.32617 .54997 m .32985 .53825 L .33334 .51911 L p F P
0 0 0 r
s
.045 .065 .149 r
.32985 .53825 m .32617 .54997 L .32672 .5683 L p F P
0 0 0 r
s
.24 .35 .67 r
.32951 .54156 m
.33287 .52558 L
s
.971 .291 .125 r
.49329 .36904 m .49012 .36847 L .48019 .35517 L p F P
0 0 0 r
s
.971 .291 .125 r
.48019 .35517 m .48654 .35631 L .49329 .36904 L p F P
0 0 0 r
s
.318 .471 .867 r
.37583 .43183 m .37248 .44219 L .35864 .45871 L p F P
0 0 0 r
s
.33 .49 .916 r
.37248 .44219 m .37583 .43183 L .39218 .41812 L p F P
0 0 0 r
s
.24 .35 .67 r
.36737 .46223 m
.37545 .43735 L
s
.83 .24 .1 r
.24838 .37708 m
.20679 .36995 L
s
.24838 .37708 m
.25307 .35309 L
s
.3022 .581 m
.32485 .58431 L
s
.32742 .58468 m
.34327 .587 L
s
.971 .291 .125 r
.49012 .36847 m .48696 .36791 L .47383 .35402 L p F P
0 0 0 r
s
.971 .291 .125 r
.47383 .35402 m .48019 .35517 L .49012 .36847 L p F P
0 0 0 r
s
.83 .24 .1 r
.5897 .65549 m
.59673 .66478 L
s
.24 .35 .67 r
.34253 .64719 m
.32914 .62267 L
s
.971 .291 .125 r
.48696 .36791 m .48379 .36734 L .46746 .35288 L p F P
0 0 0 r
s
.971 .291 .125 r
.46746 .35288 m .47383 .35402 L .48696 .36791 L p F P
0 0 0 r
s
.24 .35 .67 r
.48552 .3836 m
.49177 .3678 L
s
.495 .122 .05 r
.46883 .63979 m .48548 .64214 L .48423 .63177 L p F P
0 0 0 r
s
.495 .122 .05 r
.48423 .63177 m .46613 .62919 L .46883 .63979 L p F P
0 0 0 r
s
.327 .485 .926 r
.41352 .3988 m .4162 .391 L .43574 .38521 L p F P
0 0 0 r
s
.327 .485 .926 r
.43791 .37914 m .43574 .38521 L .4162 .391 L p F P
0 0 0 r
s
.24 .35 .67 r
.42059 .41375 m
.42974 .38792 L
s
.42974 .38792 m
.45694 .38331 L
s
.83 .24 .1 r
.41686 .38172 m
.42351 .36231 L
s
.351 .078 .033 r
.56004 .65959 m .57446 .66161 L .58384 .65604 L p F P
0 0 0 r
s
.351 .078 .033 r
.58384 .65604 m .56763 .65375 L .56004 .65959 L p F P
0 0 0 r
s
.295 .444 .814 r
.58896 .64744 m .58384 .65604 L .57446 .66161 L p F P
0 0 0 r
s
.83 .24 .1 r
.58487 .6548 m
.5897 .65549 L
s
.58467 .65478 m
.58487 .6548 L
s
.307 .456 .885 r
.46587 .35714 m .46746 .35288 L .48379 .36734 L p F P
0 0 0 r
s
.318 .472 .909 r
.43791 .37914 m .4401 .37302 L .4596 .37394 L p F P
0 0 0 r
s
.318 .472 .909 r
.46115 .36978 m .4596 .37394 L .4401 .37302 L p F P
0 0 0 r
s
.049 .072 .169 r
.62379 .57679 m .63045 .56546 L .63087 .54708 L p F P
0 0 0 r
s
.028 .04 .082 r
.63045 .56546 m .62379 .57679 L .62043 .59347 L p F P
0 0 0 r
s
.24 .35 .67 r
.61651 .56929 m
.62961 .54663 L
s
.028 .04 .082 r
.61411 .60412 m .62043 .59347 L .62379 .57679 L p F P
0 0 0 r
s
.624 .162 .067 r
.3743 .61609 m .39285 .61874 L .38696 .60467 L p F P
0 0 0 r
s
.624 .162 .067 r
.38696 .60467 m .36738 .60184 L .3743 .61609 L p F P
0 0 0 r
s
.83 .24 .1 r
.38391 .59293 m
.38455 .61219 L
s
.33585 .36756 m
.29469 .36037 L
s
.33585 .36756 m
.34136 .34773 L
s
.238 .35 .612 r
.33334 .51911 m .33705 .50719 L .3443 .48825 L p F P
0 0 0 r
s
.024 .035 .067 r
.33705 .50719 m .33334 .51911 L .32985 .53825 L p F P
0 0 0 r
s
.33 .49 .916 r
.39526 .40888 m .39218 .41812 L .37583 .43183 L p F P
0 0 0 r
s
.24 .35 .67 r
.37545 .43735 m
.39629 .42328 L
s
.332 .492 .931 r
.39218 .41812 m .39526 .40888 L .41352 .3988 L p F P
0 0 0 r
s
.024 .035 .067 r
.62043 .59347 m .61411 .60412 L .60816 .61822 L p F P
0 0 0 r
s
.024 .035 .067 r
.60233 .62799 m .60816 .61822 L .61411 .60412 L p F P
0 0 0 r
s
.24 .35 .67 r
.60714 .61646 m
.61484 .59358 L
s
.193 .286 .592 r
.61901 .43963 m .62442 .42922 L .60802 .41583 L p F P
0 0 0 r
s
.167 .247 .522 r
.62442 .42922 m .61901 .43963 L .63195 .45591 L p F P
0 0 0 r
s
.24 .35 .67 r
.6126 .45035 m
.62816 .47335 L
s
.251 .373 .747 r
.55569 .36874 m .55384 .37291 L .57985 .37149 L p F P
0 0 0 r
s
.251 .373 .747 r
.57701 .37762 m .57985 .37149 L .55384 .37291 L p F P
0 0 0 r
s
.24 .35 .67 r
.54257 .39834 m
.55419 .37219 L
s
.83 .24 .1 r
.57859 .37422 m
.59164 .37656 L
s
.332 .492 .931 r
.4162 .391 m .41352 .3988 L .39526 .40888 L p F P
0 0 0 r
s
.234 .348 .702 r
.57701 .37762 m .57419 .3837 L .59677 .38905 L p F P
0 0 0 r
s
.234 .348 .702 r
.593 .39687 m .59677 .38905 L .57419 .3837 L p F P
0 0 0 r
s
.24 .35 .67 r
.56895 .41218 m
.58111 .38628 L
s
.067 .097 .237 r
.63087 .54708 m .6377 .53529 L .63487 .51617 L p F P
0 0 0 r
s
.049 .072 .169 r
.6377 .53529 m .63087 .54708 L .63045 .56546 L p F P
0 0 0 r
s
.83 .24 .1 r
.71929 .38947 m
.68017 .38238 L
s
.71929 .38947 m
.72996 .3874 L
s
.72608 .68495 m
.71548 .68145 L
s
.71548 .68145 m
.67633 .67596 L
s
.495 .122 .05 r
.45211 .63743 m .46883 .63979 L .46613 .62919 L p F P
0 0 0 r
s
.495 .122 .05 r
.46613 .62919 m .44794 .6266 L .45211 .63743 L p F P
0 0 0 r
s
.351 .078 .033 r
.54558 .65756 m .56004 .65959 L .56763 .65375 L p F P
0 0 0 r
s
.24 .35 .67 r
.5621 .67484 m
.58095 .65806 L
s
.351 .078 .033 r
.56763 .65375 m .55134 .65145 L .54558 .65756 L p F P
0 0 0 r
s
.215 .319 .651 r
.60802 .41583 m .61267 .40656 L .593 .39687 L p F P
0 0 0 r
s
.193 .286 .592 r
.61267 .40656 m .60802 .41583 L .62442 .42922 L p F P
0 0 0 r
s
.83 .24 .1 r
.17964 .53933 m
.22152 .54557 L
s
.21869 .56882 m
.22152 .54557 L
s
.215 .319 .651 r
.59677 .38905 m .593 .39687 L .61267 .40656 L p F P
0 0 0 r
s
.24 .35 .67 r
.59259 .42972 m
.60528 .40408 L
s
.54367 .36856 m
.55419 .37219 L
s
.52549 .3623 m
.53161 .36441 L
s
.55419 .37219 m
.58111 .38628 L
s
.624 .162 .067 r
.35566 .61343 m .3743 .61609 L .36738 .60184 L p F P
0 0 0 r
s
.624 .162 .067 r
.36738 .60184 m .34769 .599 L .35566 .61343 L p F P
0 0 0 r
s
.238 .35 .612 r
.34799 .47645 m .3443 .48825 L .33705 .50719 L p F P
0 0 0 r
s
.24 .35 .67 r
.33287 .52558 m
.34028 .50189 L
s
.288 .426 .769 r
.3443 .48825 m .34799 .47645 L .35864 .45871 L p F P
0 0 0 r
s
.24 .35 .67 r
.34028 .50189 m
.35122 .48035 L
s
.098 .143 .332 r
.63487 .51617 m .64167 .50419 L .63535 .48534 L p F P
0 0 0 r
s
.067 .097 .237 r
.64167 .50419 m .63487 .51617 L .6377 .53529 L p F P
0 0 0 r
s
.318 .472 .909 r
.4401 .37302 m .44232 .36684 L .46115 .36978 L p F P
0 0 0 r
s
.318 .472 .909 r
.46271 .3656 m .46115 .36978 L .44232 .36684 L p F P
0 0 0 r
s
.83 .24 .1 r
.42351 .36231 m
.4473 .36653 L
s
.252 .38 .679 r
.60816 .61822 m .60233 .62799 L .59416 .6387 L p F P
0 0 0 r
s
.252 .38 .679 r
.58896 .64744 m .59416 .6387 L .60233 .62799 L p F P
0 0 0 r
s
.24 .35 .67 r
.59444 .63782 m
.60714 .61646 L
s
.83 .24 .1 r
.38455 .61219 m
.42537 .61804 L
s
.251 .373 .747 r
.57985 .37149 m .58273 .36529 L .55569 .36874 L p F P
0 0 0 r
s
.83 .24 .1 r
.5519 .36942 m
.55883 .37067 L
s
.91 .278 .12 r
.55569 .36874 m .54946 .36762 L .5735 .36362 L p F P
0 0 0 r
s
.91 .278 .12 r
.5735 .36362 m .58273 .36529 L .55569 .36874 L p F P
0 0 0 r
s
.83 .24 .1 r
.42351 .36231 m
.38266 .35506 L
s
.351 .078 .033 r
.53105 .65552 m .54558 .65756 L .55134 .65145 L p F P
0 0 0 r
s
.351 .078 .033 r
.55134 .65145 m .53499 .64914 L .53105 .65552 L p F P
0 0 0 r
s
.83 .24 .1 r
.54995 .64986 m
.58186 .65438 L
s
.54522 .63523 m
.54995 .64986 L
s
.211 .34574 m
.20679 .36995 L
s
.30155 .60029 m
.3022 .581 L
s
.3022 .581 m
.26067 .57494 L
s
.327 .485 .926 r
.4162 .391 m .41892 .38311 L .43791 .37914 L p F P
0 0 0 r
s
.327 .485 .926 r
.4401 .37302 m .43791 .37914 L .41892 .38311 L p F P
0 0 0 r
s
.495 .122 .05 r
.43531 .63505 m .45211 .63743 L .44794 .6266 L p F P
0 0 0 r
s
.495 .122 .05 r
.44794 .6266 m .42967 .62399 L .43531 .63505 L p F P
0 0 0 r
s
.91 .278 .12 r
.54946 .36762 m .54322 .3665 L .56425 .36194 L p F P
0 0 0 r
s
.91 .278 .12 r
.56425 .36194 m .5735 .36362 L .54946 .36762 L p F P
0 0 0 r
s
.24 .35 .67 r
.55419 .37219 m
.55625 .36754 L
s
.288 .426 .769 r
.36224 .44736 m .35864 .45871 L .34799 .47645 L p F P
0 0 0 r
s
.318 .471 .867 r
.35864 .45871 m .36224 .44736 L .37583 .43183 L p F P
0 0 0 r
s
.136 .2 .437 r
.63535 .48534 m .64192 .47348 L .63195 .45591 L p F P
0 0 0 r
s
.098 .143 .332 r
.64192 .47348 m .63535 .48534 L .64167 .50419 L p F P
0 0 0 r
s
.24 .35 .67 r
.62517 .52173 m
.63857 .49788 L
s
.624 .162 .067 r
.33693 .61076 m .35566 .61343 L .34769 .599 L p F P
0 0 0 r
s
.624 .162 .067 r
.34769 .599 m .3279 .59614 L .33693 .61076 L p F P
0 0 0 r
s
.83 .24 .1 r
.34327 .587 m
.34328 .60627 L
s
.234 .348 .702 r
.57985 .37149 m .57701 .37762 L .60059 .38114 L p F P
0 0 0 r
s
.234 .348 .702 r
.59677 .38905 m .60059 .38114 L .57701 .37762 L p F P
0 0 0 r
s
.24 .35 .67 r
.58111 .38628 m
.60528 .40408 L
s
.83 .24 .1 r
.29469 .36037 m
.25307 .35309 L
s
.29469 .36037 m
.29961 .34031 L
s
.91 .278 .12 r
.54322 .3665 m .53696 .36538 L .55497 .36027 L p F P
0 0 0 r
s
.91 .278 .12 r
.55497 .36027 m .56425 .36194 L .54322 .3665 L p F P
0 0 0 r
s
.24 .35 .67 r
.51142 .69456 m
.50039 .71479 L
s
.50039 .71479 m
.47138 .71659 L
s
.318 .472 .909 r
.44232 .36684 m .44455 .3606 L .46271 .3656 L p F P
0 0 0 r
s
.318 .472 .909 r
.46428 .36138 m .46271 .3656 L .44455 .3606 L p F P
0 0 0 r
s
.91 .278 .12 r
.53696 .36538 m .5307 .36425 L .54567 .35858 L p F P
0 0 0 r
s
.91 .278 .12 r
.54567 .35858 m .55497 .36027 L .53696 .36538 L p F P
0 0 0 r
s
.351 .078 .033 r
.51647 .65347 m .53105 .65552 L .53499 .64914 L p F P
0 0 0 r
s
.351 .078 .033 r
.53499 .64914 m .51856 .64682 L .51647 .65347 L p F P
0 0 0 r
s
.83 .24 .1 r
.68017 .38238 m
.64062 .37522 L
s
.68017 .38238 m
.69014 .38017 L
s
.318 .471 .867 r
.37925 .42129 m .37583 .43183 L .36224 .44736 L p F P
0 0 0 r
s
.33 .49 .916 r
.37583 .43183 m .37925 .42129 L .39526 .40888 L p F P
0 0 0 r
s
.332 .492 .931 r
.39526 .40888 m .39838 .3995 L .4162 .391 L p F P
0 0 0 r
s
.332 .492 .931 r
.41892 .38311 m .4162 .391 L .39838 .3995 L p F P
0 0 0 r
s
.24 .35 .67 r
.40503 .39738 m
.42974 .38792 L
s
.495 .122 .05 r
.41843 .63267 m .43531 .63505 L .42967 .62399 L p F P
0 0 0 r
s
.495 .122 .05 r
.42967 .62399 m .4113 .62137 L .41843 .63267 L p F P
0 0 0 r
s
.83 .24 .1 r
.42537 .61804 m
.42806 .63262 L
s
.68623 .67937 m
.67633 .67596 L
s
.67633 .67596 m
.63675 .6704 L
s
.24 .35 .67 r
.36146 .66954 m
.34253 .64719 L
s
.3503 .62554 m
.34253 .64719 L
s
.91 .278 .12 r
.5307 .36425 m .52442 .36312 L .53635 .3569 L p F P
0 0 0 r
s
.24 .35 .67 r
.49605 .35701 m
.52549 .3623 L
s
.91 .278 .12 r
.53635 .3569 m .54567 .35858 L .5307 .36425 L p F P
0 0 0 r
s
.167 .247 .522 r
.63195 .45591 m .63808 .44451 L .62442 .42922 L p F P
0 0 0 r
s
.136 .2 .437 r
.63808 .44451 m .63195 .45591 L .64192 .47348 L p F P
0 0 0 r
s
.24 .35 .67 r
.62816 .47335 m
.63857 .49788 L
s
.33 .49 .916 r
.39838 .3995 m .39526 .40888 L .37925 .42129 L p F P
0 0 0 r
s
.24 .35 .67 r
.39629 .42328 m
.40503 .39738 L
s
.065 .095 .231 r
.3279 .59614 m .33145 .58534 L .32672 .5683 L p F P
0 0 0 r
s
.065 .095 .231 r
.3304 .5568 m .32672 .5683 L .33145 .58534 L p F P
0 0 0 r
s
.24 .35 .67 r
.3281 .55509 m
.32846 .56286 L
s
.045 .065 .149 r
.32672 .5683 m .3304 .5568 L .32985 .53825 L p F P
0 0 0 r
s
.83 .24 .1 r
.17964 .53933 m
.17625 .56262 L
s
.085 .126 .306 r
.33145 .58534 m .3279 .59614 L .33693 .61076 L p F P
0 0 0 r
s
.24 .35 .67 r
.32914 .62267 m
.3345 .60681 L
s
.5621 .67484 m
.53858 .68725 L
s
.48987 .35691 m
.49605 .35701 L
s
.295 .444 .814 r
.59416 .6387 m .58896 .64744 L .57893 .65402 L p F P
0 0 0 r
s
.24 .35 .67 r
.58489 .65141 m
.58616 .64928 L
s
.295 .444 .814 r
.57446 .66161 m .57893 .65402 L .58896 .64744 L p F P
0 0 0 r
s
.91 .278 .12 r
.52442 .36312 m .51814 .36199 L .52701 .35521 L p F P
0 0 0 r
s
.91 .278 .12 r
.52701 .35521 m .53635 .3569 L .52442 .36312 L p F P
0 0 0 r
s
.83 .24 .1 r
.51172 .36221 m
.5519 .36942 L
s
.215 .319 .651 r
.60059 .38114 m .59677 .38905 L .61739 .39715 L p F P
0 0 0 r
s
.215 .319 .651 r
.61267 .40656 m .61739 .39715 L .59677 .38905 L p F P
0 0 0 r
s
.024 .035 .067 r
.32985 .53825 m .33361 .52627 L .33705 .50719 L p F P
0 0 0 r
s
.045 .065 .149 r
.33361 .52627 m .32985 .53825 L .3304 .5568 L p F P
0 0 0 r
s
.351 .078 .033 r
.50182 .65142 m .51647 .65347 L .51856 .64682 L p F P
0 0 0 r
s
.351 .078 .033 r
.51856 .64682 m .50206 .64449 L .50182 .65142 L p F P
0 0 0 r
s
.83 .24 .1 r
.50976 .64418 m
.54995 .64986 L
s
.193 .286 .592 r
.62442 .42922 m .62993 .41864 L .61267 .40656 L p F P
0 0 0 r
s
.167 .247 .522 r
.62993 .41864 m .62442 .42922 L .63808 .44451 L p F P
0 0 0 r
s
.24 .35 .67 r
.6126 .45035 m
.62578 .42498 L
s
.91 .278 .12 r
.51814 .36199 m .51184 .36086 L .51764 .35351 L p F P
0 0 0 r
s
.91 .278 .12 r
.51764 .35351 m .52701 .35521 L .51814 .36199 L p F P
0 0 0 r
s
.327 .485 .926 r
.41892 .38311 m .42167 .37513 L .4401 .37302 L p F P
0 0 0 r
s
.327 .485 .926 r
.44232 .36684 m .4401 .37302 L .42167 .37513 L p F P
0 0 0 r
s
.83 .24 .1 r
.34328 .60627 m
.38455 .61219 L
s
.80828 .40163 m
.76933 .39455 L
s
.80828 .40163 m
.81951 .40621 L
s
.495 .122 .05 r
.40148 .63027 m .41843 .63267 L .4113 .62137 L p F P
0 0 0 r
s
.495 .122 .05 r
.4113 .62137 m .39285 .61874 L .40148 .63027 L p F P
0 0 0 r
s
.193 .286 .592 r
.61739 .39715 m .61267 .40656 L .62993 .41864 L p F P
0 0 0 r
s
.24 .35 .67 r
.60528 .40408 m
.62578 .42498 L
s
.318 .472 .909 r
.44455 .3606 m .44681 .3543 L .46428 .36138 L p F P
0 0 0 r
s
.318 .472 .909 r
.46587 .35714 m .46428 .36138 L .44681 .3543 L p F P
0 0 0 r
s
.83 .24 .1 r
.38266 .35506 m
.34136 .34773 L
s
.38266 .35506 m
.38852 .34007 L
s
.25937 .59424 m
.26067 .57494 L
s
.26067 .57494 m
.21869 .56882 L
s
.91 .278 .12 r
.51184 .36086 m .50553 .35972 L .50824 .35181 L p F P
0 0 0 r
s
.91 .278 .12 r
.50824 .35181 m .51764 .35351 L .51184 .36086 L p F P
0 0 0 r
s
.049 .072 .169 r
.63045 .56546 m .63726 .5539 L .6377 .53529 L p F P
0 0 0 r
s
.028 .04 .082 r
.63726 .5539 m .63045 .56546 L .62689 .58262 L p F P
0 0 0 r
s
.028 .04 .082 r
.62043 .59347 m .62689 .58262 L .63045 .56546 L p F P
0 0 0 r
s
.24 .35 .67 r
.62806 .57115 m
.62961 .54663 L
s
.234 .348 .702 r
.58273 .36529 m .57985 .37149 L .60446 .37313 L p F P
0 0 0 r
s
.83 .24 .1 r
.59164 .37656 m
.59584 .37255 L
s
.234 .348 .702 r
.60059 .38114 m .60446 .37313 L .57985 .37149 L p F P
0 0 0 r
s
.024 .035 .067 r
.62689 .58262 m .62043 .59347 L .6141 .60827 L p F P
0 0 0 r
s
.024 .035 .067 r
.60816 .61822 m .6141 .60827 L .62043 .59347 L p F P
0 0 0 r
s
.24 .35 .67 r
.61484 .59358 m
.62806 .57115 L
s
.238 .35 .612 r
.33705 .50719 m .34084 .49503 L .34799 .47645 L p F P
0 0 0 r
s
.024 .035 .067 r
.34084 .49503 m .33705 .50719 L .33361 .52627 L p F P
0 0 0 r
s
.91 .278 .12 r
.50553 .35972 m .49921 .35859 L .49883 .35011 L p F P
0 0 0 r
s
.91 .278 .12 r
.49883 .35011 m .50824 .35181 L .50553 .35972 L p F P
0 0 0 r
s
.351 .078 .033 r
.48713 .64936 m .50182 .65142 L .50206 .64449 L p F P
0 0 0 r
s
.351 .078 .033 r
.50206 .64449 m .48548 .64214 L .48713 .64936 L p F P
0 0 0 r
s
.83 .24 .1 r
.25307 .35309 m
.211 .34574 L
s
.25307 .35309 m
.25739 .33282 L
s
.067 .097 .237 r
.6377 .53529 m .64467 .52326 L .64167 .50419 L p F P
0 0 0 r
s
.049 .072 .169 r
.64467 .52326 m .6377 .53529 L .63726 .5539 L p F P
0 0 0 r
s
.91 .278 .12 r
.49921 .35859 m .49288 .35745 L .48939 .3484 L p F P
0 0 0 r
s
.91 .278 .12 r
.48939 .3484 m .49883 .35011 L .49921 .35859 L p F P
0 0 0 r
s
.495 .122 .05 r
.38445 .62787 m .40148 .63027 L .39285 .61874 L p F P
0 0 0 r
s
.495 .122 .05 r
.39285 .61874 m .3743 .61609 L .38445 .62787 L p F P
0 0 0 r
s
.83 .24 .1 r
.38455 .61219 m
.38653 .62674 L
s
.64062 .37522 m
.64988 .37286 L
s
.252 .38 .679 r
.6141 .60827 m .60816 .61822 L .59945 .6298 L p F P
0 0 0 r
s
.252 .38 .679 r
.59416 .6387 m .59945 .6298 L .60816 .61822 L p F P
0 0 0 r
s
.24 .35 .67 r
.48187 .69627 m
.47138 .71659 L
s
.47138 .71659 m
.44147 .71267 L
s
.83 .24 .1 r
.64594 .67373 m
.63675 .6704 L
s
.63675 .6704 m
.59673 .66478 L
s
.91 .278 .12 r
.49288 .35745 m .48654 .35631 L .47992 .34668 L p F P
0 0 0 r
s
.91 .278 .12 r
.47992 .34668 m .48939 .3484 L .49288 .35745 L p F P
0 0 0 r
s
.238 .35 .612 r
.35175 .46441 m .34799 .47645 L .34084 .49503 L p F P
0 0 0 r
s
.288 .426 .769 r
.34799 .47645 m .35175 .46441 L .36224 .44736 L p F P
0 0 0 r
s
.318 .472 .909 r
.44681 .3543 m .44908 .34794 L .46587 .35714 L p F P
0 0 0 r
s
.318 .472 .909 r
.46746 .35288 m .46587 .35714 L .44908 .34794 L p F P
0 0 0 r
s
.24 .35 .67 r
.45694 .38331 m
.46694 .35654 L
s
.46694 .35654 m
.47767 .35671 L
s
.332 .492 .931 r
.39838 .3995 m .40155 .38998 L .41892 .38311 L p F P
0 0 0 r
s
.332 .492 .931 r
.42167 .37513 m .41892 .38311 L .40155 .38998 L p F P
0 0 0 r
s
.098 .143 .332 r
.64167 .50419 m .64861 .49197 L .64192 .47348 L p F P
0 0 0 r
s
.067 .097 .237 r
.64861 .49197 m .64167 .50419 L .64467 .52326 L p F P
0 0 0 r
s
.24 .35 .67 r
.63857 .49788 m
.64325 .52303 L
s
.351 .078 .033 r
.47237 .64728 m .48713 .64936 L .48548 .64214 L p F P
0 0 0 r
s
.351 .078 .033 r
.48548 .64214 m .46883 .63979 L .47237 .64728 L p F P
0 0 0 r
s
.24 .35 .67 r
.38507 .68853 m
.36146 .66954 L
s
.36967 .64822 m
.36146 .66954 L
s
.91 .278 .12 r
.48654 .35631 m .48019 .35517 L .47043 .34497 L p F P
0 0 0 r
s
.91 .278 .12 r
.47043 .34497 m .47992 .34668 L .48654 .35631 L p F P
0 0 0 r
s
.327 .485 .926 r
.42167 .37513 m .42446 .36705 L .44232 .36684 L p F P
0 0 0 r
s
.327 .485 .926 r
.44455 .3606 m .44232 .36684 L .42446 .36705 L p F P
0 0 0 r
s
.91 .278 .12 r
.48019 .35517 m .47383 .35402 L .46092 .34324 L p F P
0 0 0 r
s
.91 .278 .12 r
.46092 .34324 m .47043 .34497 L .48019 .35517 L p F P
0 0 0 r
s
.83 .24 .1 r
.46844 .36032 m
.47111 .35491 L
s
.47111 .35491 m
.51172 .36221 L
s
.288 .426 .769 r
.3659 .4358 m .36224 .44736 L .35175 .46441 L p F P
0 0 0 r
s
.24 .35 .67 r
.35122 .48035 m
.35907 .45555 L
s
.318 .471 .867 r
.36224 .44736 m .3659 .4358 L .37925 .42129 L p F P
0 0 0 r
s
.24 .35 .67 r
.35907 .45555 m
.37545 .43735 L
s
.495 .122 .05 r
.36734 .62545 m .38445 .62787 L .3743 .61609 L p F P
0 0 0 r
s
.495 .122 .05 r
.3743 .61609 m .35566 .61343 L .36734 .62545 L p F P
0 0 0 r
s
.215 .319 .651 r
.60446 .37313 m .60059 .38114 L .62219 .3876 L p F P
0 0 0 r
s
.215 .319 .651 r
.61739 .39715 m .62219 .3876 L .60059 .38114 L p F P
0 0 0 r
s
.83 .24 .1 r
.33573 .60519 m
.34328 .60627 L
s
.76933 .39455 m
.72996 .3874 L
s
.76933 .39455 m
.77989 .39903 L
s
.77788 .68765 m
.76548 .69047 L
s
.76548 .69047 m
.72608 .68495 L
s
.33 .49 .916 r
.37925 .42129 m .38272 .41057 L .39838 .3995 L p F P
0 0 0 r
s
.33 .49 .916 r
.40155 .38998 m .39838 .3995 L .38272 .41057 L p F P
0 0 0 r
s
.234 .348 .702 r
.60446 .37313 m .60838 .36502 L .58273 .36529 L p F P
0 0 0 r
s
.83 .24 .1 r
.60644 .36903 m
.64062 .37522 L
s
.776 .244 .106 r
.58273 .36529 m .5735 .36362 L .59632 .36283 L p F P
0 0 0 r
s
.776 .244 .106 r
.59632 .36283 m .60838 .36502 L .58273 .36529 L p F P
0 0 0 r
s
.24 .35 .67 r
.58111 .38628 m
.5912 .36482 L
s
.136 .2 .437 r
.64192 .47348 m .64861 .46138 L .63808 .44451 L p F P
0 0 0 r
s
.098 .143 .332 r
.64861 .46138 m .64192 .47348 L .64861 .49197 L p F P
0 0 0 r
s
.91 .278 .12 r
.47383 .35402 m .46746 .35288 L .45138 .34152 L p F P
0 0 0 r
s
.91 .278 .12 r
.45138 .34152 m .46092 .34324 L .47383 .35402 L p F P
0 0 0 r
s
.83 .24 .1 r
.34136 .34773 m
.29961 .34031 L
s
.34136 .34773 m
.34654 .33253 L
s
.318 .471 .867 r
.38272 .41057 m .37925 .42129 L .3659 .4358 L p F P
0 0 0 r
s
.83 .24 .1 r
.21671 .58812 m
.21869 .56882 L
s
.21869 .56882 m
.17625 .56262 L
s
.351 .078 .033 r
.45755 .64521 m .47237 .64728 L .46883 .63979 L p F P
0 0 0 r
s
.83 .24 .1 r
.46913 .63843 m
.50976 .64418 L
s
.351 .078 .033 r
.46883 .63979 m .45211 .63743 L .45755 .64521 L p F P
0 0 0 r
s
.83 .24 .1 r
.46575 .62383 m
.46913 .63843 L
s
.46401 .35363 m
.47111 .35491 L
s
.43004 .34753 m
.44807 .35077 L
s
.256 .059 .025 r
.55074 .66172 m .56294 .66343 L .57446 .66161 L p F P
0 0 0 r
s
.256 .059 .025 r
.57446 .66161 m .56004 .65959 L .55074 .66172 L p F P
0 0 0 r
s
.317 .477 .891 r
.57893 .65402 m .57446 .66161 L .56294 .66343 L p F P
0 0 0 r
s
.24 .35 .67 r
.56927 .66257 m
.56936 .66242 L
s
.5621 .67484 m
.56927 .66257 L
s
.318 .472 .909 r
.44908 .34794 m .45138 .34152 L .46746 .35288 L p F P
0 0 0 r
s
.24 .35 .67 r
.46694 .35654 m
.46872 .35178 L
s
.776 .244 .106 r
.5735 .36362 m .56425 .36194 L .58423 .36064 L p F P
0 0 0 r
s
.776 .244 .106 r
.58423 .36064 m .59632 .36283 L .5735 .36362 L p F P
0 0 0 r
s
.24 .35 .67 r
.59246 .36213 m
.59378 .35932 L
s
.45138 .69219 m
.44147 .71267 L
s
.44147 .71267 m
.4122 .70317 L
s
.295 .444 .814 r
.59945 .6298 m .59416 .6387 L .58346 .64632 L p F P
0 0 0 r
s
.24 .35 .67 r
.59554 .63385 m
.60714 .61646 L
s
.58989 .643 m
.59118 .64082 L
s
.295 .444 .814 r
.57893 .65402 m .58346 .64632 L .59416 .6387 L p F P
0 0 0 r
s
.83 .24 .1 r
.2147 .32524 m
.211 .34574 L
s
.167 .247 .522 r
.63808 .44451 m .64432 .43289 L .62993 .41864 L p F P
0 0 0 r
s
.136 .2 .437 r
.64432 .43289 m .63808 .44451 L .64861 .46138 L p F P
0 0 0 r
s
.24 .35 .67 r
.62816 .47335 m
.64176 .44825 L
s
.193 .286 .592 r
.62219 .3876 m .61739 .39715 L .63553 .40788 L p F P
0 0 0 r
s
.193 .286 .592 r
.62993 .41864 m .63553 .40788 L .61739 .39715 L p F P
0 0 0 r
s
.495 .122 .05 r
.35015 .62302 m .36734 .62545 L .35566 .61343 L p F P
0 0 0 r
s
.495 .122 .05 r
.35566 .61343 m .33693 .61076 L .35015 .62302 L p F P
0 0 0 r
s
.24 .35 .67 r
.4122 .70317 m
.38507 .68853 L
s
.39381 .66753 m
.38507 .68853 L
s
.167 .247 .522 r
.63553 .40788 m .62993 .41864 L .64432 .43289 L p F P
0 0 0 r
s
.24 .35 .67 r
.62578 .42498 m
.64176 .44825 L
s
.776 .244 .106 r
.56425 .36194 m .55497 .36027 L .5721 .35843 L p F P
0 0 0 r
s
.83 .24 .1 r
.5519 .36942 m
.5602 .36066 L
s
.776 .244 .106 r
.5721 .35843 m .58423 .36064 L .56425 .36194 L p F P
0 0 0 r
s
.83 .24 .1 r
.5602 .36066 m
.59255 .36652 L
s
.351 .078 .033 r
.44268 .64312 m .45755 .64521 L .45211 .63743 L p F P
0 0 0 r
s
.351 .078 .033 r
.45211 .63743 m .43531 .63505 L .44268 .64312 L p F P
0 0 0 r
s
.256 .059 .025 r
.5385 .66001 m .55074 .66172 L .56004 .65959 L p F P
0 0 0 r
s
.256 .059 .025 r
.56004 .65959 m .54558 .65756 L .5385 .66001 L p F P
0 0 0 r
s
.83 .24 .1 r
.54995 .64986 m
.55627 .65911 L
s
.085 .126 .306 r
.33693 .61076 m .34038 .60067 L .33145 .58534 L p F P
0 0 0 r
s
.24 .35 .67 r
.33136 .58291 m
.3327 .58749 L
s
.085 .126 .306 r
.33507 .57433 m .33145 .58534 L .34038 .60067 L p F P
0 0 0 r
s
.83 .24 .1 r
.30155 .60029 m
.33392 .60493 L
s
.065 .095 .231 r
.33145 .58534 m .33507 .57433 L .3304 .5568 L p F P
0 0 0 r
s
.065 .095 .231 r
.33415 .54506 m .3304 .5568 L .33507 .57433 L p F P
0 0 0 r
s
.045 .065 .149 r
.3304 .5568 m .33415 .54506 L .33361 .52627 L p F P
0 0 0 r
s
.83 .24 .1 r
.6052 .66802 m
.59673 .66478 L
s
.57305 .66146 m
.59673 .66478 L
s
.57175 .66128 m
.57305 .66146 L
s
.24 .35 .67 r
.42152 .68245 m
.4122 .70317 L
s
.55055 .6662 m
.53858 .68725 L
s
.53858 .68725 m
.51142 .69456 L
s
.327 .485 .926 r
.42446 .36705 m .42728 .35887 L .44455 .3606 L p F P
0 0 0 r
s
.24 .35 .67 r
.42974 .38792 m
.43927 .36102 L
s
.327 .485 .926 r
.44681 .3543 m .44455 .3606 L .42728 .35887 L p F P
0 0 0 r
s
.83 .24 .1 r
.42351 .36231 m
.43004 .34753 L
s
.24 .35 .67 r
.43927 .36102 m
.46694 .35654 L
s
.776 .244 .106 r
.55497 .36027 m .54567 .35858 L .55993 .35622 L p F P
0 0 0 r
s
.776 .244 .106 r
.55993 .35622 m .5721 .35843 L .55497 .36027 L p F P
0 0 0 r
s
.24 .35 .67 r
.56118 .35645 m
.56629 .34496 L
s
.024 .035 .067 r
.33361 .52627 m .33744 .51405 L .34084 .49503 L p F P
0 0 0 r
s
.045 .065 .149 r
.33744 .51405 m .33361 .52627 L .33415 .54506 L p F P
0 0 0 r
s
.24 .35 .67 r
.33714 .51692 m
.34028 .50189 L
s
.332 .492 .931 r
.40155 .38998 m .40477 .38033 L .42167 .37513 L p F P
0 0 0 r
s
.332 .492 .931 r
.42446 .36705 m .42167 .37513 L .40477 .38033 L p F P
0 0 0 r
s
.125 .189 .421 r
.34038 .60067 m .33693 .61076 L .35015 .62302 L p F P
0 0 0 r
s
.83 .24 .1 r
.34328 .60627 m
.34339 .60755 L
s
.24 .35 .67 r
.3476 .62065 m
.3503 .62554 L
s
.256 .059 .025 r
.52622 .65829 m .5385 .66001 L .54558 .65756 L p F P
0 0 0 r
s
.256 .059 .025 r
.54558 .65756 m .53105 .65552 L .52622 .65829 L p F P
0 0 0 r
s
.351 .078 .033 r
.42774 .64102 m .44268 .64312 L .43531 .63505 L p F P
0 0 0 r
s
.351 .078 .033 r
.43531 .63505 m .41843 .63267 L .42774 .64102 L p F P
0 0 0 r
s
.83 .24 .1 r
.42806 .63262 m
.46913 .63843 L
s
.776 .244 .106 r
.54567 .35858 m .53635 .3569 L .54772 .354 L p F P
0 0 0 r
s
.776 .244 .106 r
.54772 .354 m .55993 .35622 L .54567 .35858 L p F P
0 0 0 r
s
.83 .24 .1 r
.30206 .61479 m
.30155 .60029 L
s
.30155 .60029 m
.25937 .59424 L
s
.72996 .3874 m
.69014 .38017 L
s
.72996 .3874 m
.73982 .39177 L
s
.028 .04 .082 r
.62689 .58262 m .63346 .57155 L .63726 .5539 L p F P
0 0 0 r
s
.024 .035 .067 r
.63346 .57155 m .62689 .58262 L .62015 .59813 L p F P
0 0 0 r
s
.024 .035 .067 r
.6141 .60827 m .62015 .59813 L .62689 .58262 L p F P
0 0 0 r
s
.24 .35 .67 r
.62036 .59422 m
.62806 .57115 L
s
.049 .072 .169 r
.63726 .5539 m .6442 .5421 L .64467 .52326 L p F P
0 0 0 r
s
.028 .04 .082 r
.6442 .5421 m .63726 .5539 L .63346 .57155 L p F P
0 0 0 r
s
.24 .35 .67 r
.62961 .54663 m
.64325 .52303 L
s
.83 .24 .1 r
.7378 .68201 m
.72608 .68495 L
s
.72608 .68495 m
.68623 .67937 L
s
.29961 .34031 m
.25739 .33282 L
s
.29961 .34031 m
.30408 .3249 L
s
.215 .319 .651 r
.60838 .36502 m .60446 .37313 L .62705 .3779 L p F P
0 0 0 r
s
.215 .319 .651 r
.62219 .3876 m .62705 .3779 L .60446 .37313 L p F P
0 0 0 r
s
.238 .35 .612 r
.34084 .49503 m .34471 .48262 L .35175 .46441 L p F P
0 0 0 r
s
.024 .035 .067 r
.34471 .48262 m .34084 .49503 L .33744 .51405 L p F P
0 0 0 r
s
.83 .24 .1 r
.17625 .56262 m
.17357 .58194 L
s
.43004 .34753 m
.38852 .34007 L
s
.776 .244 .106 r
.53635 .3569 m .52701 .35521 L .53546 .35178 L p F P
0 0 0 r
s
.776 .244 .106 r
.53546 .35178 m .54772 .354 L .53635 .3569 L p F P
0 0 0 r
s
.252 .38 .679 r
.62015 .59813 m .6141 .60827 L .60483 .62076 L p F P
0 0 0 r
s
.252 .38 .679 r
.59945 .6298 m .60483 .62076 L .6141 .60827 L p F P
0 0 0 r
s
.24 .35 .67 r
.60714 .61646 m
.62036 .59422 L
s
.067 .097 .237 r
.64467 .52326 m .65179 .51097 L .64861 .49197 L p F P
0 0 0 r
s
.049 .072 .169 r
.65179 .51097 m .64467 .52326 L .6442 .5421 L p F P
0 0 0 r
s
.256 .059 .025 r
.5139 .65657 m .52622 .65829 L .53105 .65552 L p F P
0 0 0 r
s
.256 .059 .025 r
.53105 .65552 m .51647 .65347 L .5139 .65657 L p F P
0 0 0 r
s
.351 .078 .033 r
.41275 .63892 m .42774 .64102 L .41843 .63267 L p F P
0 0 0 r
s
.351 .078 .033 r
.41843 .63267 m .40148 .63027 L .41275 .63892 L p F P
0 0 0 r
s
.33 .49 .916 r
.38272 .41057 m .38624 .39967 L .40155 .38998 L p F P
0 0 0 r
s
.33 .49 .916 r
.40477 .38033 m .40155 .38998 L .38624 .39967 L p F P
0 0 0 r
s
.238 .35 .612 r
.35559 .45213 m .35175 .46441 L .34471 .48262 L p F P
0 0 0 r
s
.24 .35 .67 r
.34028 .50189 m
.348 .47723 L
s
.288 .426 .769 r
.35175 .46441 m .35559 .45213 L .3659 .4358 L p F P
0 0 0 r
s
.24 .35 .67 r
.348 .47723 m
.35907 .45555 L
s
.776 .244 .106 r
.52701 .35521 m .51764 .35351 L .52317 .34955 L p F P
0 0 0 r
s
.776 .244 .106 r
.52317 .34955 m .53546 .35178 L .52701 .35521 L p F P
0 0 0 r
s
.24 .35 .67 r
.5303 .35084 m
.53701 .33483 L
s
.53701 .33483 m
.56629 .34496 L
s
.5789 .31658 m
.56629 .34496 L
s
.56629 .34496 m
.59378 .35932 L
s
.317 .477 .891 r
.58346 .64632 m .57893 .65402 L .56665 .65703 L p F P
0 0 0 r
s
.24 .35 .67 r
.58117 .64778 m
.58727 .64239 L
s
.317 .477 .891 r
.56294 .66343 m .56665 .65703 L .57893 .65402 L p F P
0 0 0 r
s
.83 .24 .1 r
.55627 .65911 m
.56475 .6603 L
s
.327 .485 .926 r
.42728 .35887 m .43013 .35058 L .44681 .3543 L p F P
0 0 0 r
s
.327 .485 .926 r
.44908 .34794 m .44681 .3543 L .43013 .35058 L p F P
0 0 0 r
s
.098 .143 .332 r
.64861 .49197 m .65569 .47949 L .64861 .46138 L p F P
0 0 0 r
s
.067 .097 .237 r
.65569 .47949 m .64861 .49197 L .65179 .51097 L p F P
0 0 0 r
s
.288 .426 .769 r
.36963 .42402 m .3659 .4358 L .35559 .45213 L p F P
0 0 0 r
s
.318 .471 .867 r
.3659 .4358 m .36963 .42402 L .38272 .41057 L p F P
0 0 0 r
s
.318 .471 .867 r
.38624 .39967 m .38272 .41057 L .36963 .42402 L p F P
0 0 0 r
s
.24 .35 .67 r
.37545 .43735 m
.38387 .41145 L
s
.38387 .41145 m
.40503 .39738 L
s
.256 .059 .025 r
.50154 .65484 m .5139 .65657 L .51647 .65347 L p F P
0 0 0 r
s
.256 .059 .025 r
.51647 .65347 m .50182 .65142 L .50154 .65484 L p F P
0 0 0 r
s
.83 .24 .1 r
.51536 .65336 m
.55627 .65911 L
s
.50976 .64418 m
.51536 .65336 L
s
.776 .244 .106 r
.51764 .35351 m .50824 .35181 L .51083 .34731 L p F P
0 0 0 r
s
.776 .244 .106 r
.51083 .34731 m .52317 .34955 L .51764 .35351 L p F P
0 0 0 r
s
.83 .24 .1 r
.51172 .36221 m
.51933 .35326 L
s
.51933 .35326 m
.5602 .36066 L
s
.193 .286 .592 r
.62705 .3779 m .62219 .3876 L .64122 .39693 L p F P
0 0 0 r
s
.193 .286 .592 r
.63553 .40788 m .64122 .39693 L .62219 .3876 L p F P
0 0 0 r
s
.24 .35 .67 r
.60699 .33121 m
.59378 .35932 L
s
.59378 .35932 m
.59935 .36338 L
s
.351 .078 .033 r
.39769 .6368 m .41275 .63892 L .40148 .63027 L p F P
0 0 0 r
s
.351 .078 .033 r
.40148 .63027 m .38445 .62787 L .39769 .6368 L p F P
0 0 0 r
s
.24 .35 .67 r
.50701 .32931 m
.53701 .33483 L
s
.54902 .30619 m
.53701 .33483 L
s
.136 .2 .437 r
.64861 .46138 m .65544 .44904 L .64432 .43289 L p F P
0 0 0 r
s
.098 .143 .332 r
.65544 .44904 m .64861 .46138 L .65569 .47949 L p F P
0 0 0 r
s
.24 .35 .67 r
.63857 .49788 m
.65252 .47305 L
s
.295 .444 .814 r
.60483 .62076 m .59945 .6298 L .58807 .6385 L p F P
0 0 0 r
s
.24 .35 .67 r
.59496 .63444 m
.59627 .63223 L
s
.295 .444 .814 r
.58346 .64632 m .58807 .6385 L .59945 .6298 L p F P
0 0 0 r
s
.776 .244 .106 r
.50824 .35181 m .49883 .35011 L .49846 .34506 L p F P
0 0 0 r
s
.24 .35 .67 r
.49878 .3501 m
.49882 .35 L
s
.776 .244 .106 r
.49846 .34506 m .51083 .34731 L .50824 .35181 L p F P
0 0 0 r
s
.24 .35 .67 r
.50062 .34545 m
.50701 .32931 L
s
.332 .492 .931 r
.40477 .38033 m .40803 .37053 L .42446 .36705 L p F P
0 0 0 r
s
.332 .492 .931 r
.42728 .35887 m .42446 .36705 L .40803 .37053 L p F P
0 0 0 r
s
.83 .24 .1 r
.25912 .60871 m
.25937 .59424 L
s
.25937 .59424 m
.21671 .58812 L
s
.256 .059 .025 r
.48914 .6531 m .50154 .65484 L .50182 .65142 L p F P
0 0 0 r
s
.256 .059 .025 r
.50182 .65142 m .48713 .64936 L .48914 .6531 L p F P
0 0 0 r
s
.83 .24 .1 r
.69014 .38017 m
.64988 .37286 L
s
.69014 .38017 m
.69929 .38442 L
s
.167 .247 .522 r
.64122 .39693 m .63553 .40788 L .65068 .42106 L p F P
0 0 0 r
s
.167 .247 .522 r
.64432 .43289 m .65068 .42106 L .63553 .40788 L p F P
0 0 0 r
s
.24 .35 .67 r
.62578 .42498 m
.6395 .39856 L
s
.136 .2 .437 r
.65068 .42106 m .64432 .43289 L .65544 .44904 L p F P
0 0 0 r
s
.24 .35 .67 r
.64176 .44825 m
.65252 .47305 L
s
.83 .24 .1 r
.69727 .6763 m
.68623 .67937 L
s
.68623 .67937 m
.64594 .67373 L
s
.25739 .33282 m
.2147 .32524 L
s
.25739 .33282 m
.26115 .31719 L
s
.776 .244 .106 r
.49883 .35011 m .48939 .3484 L .48604 .3428 L p F P
0 0 0 r
s
.776 .244 .106 r
.48604 .3428 m .49846 .34506 L .49883 .35011 L p F P
0 0 0 r
s
.24 .35 .67 r
.52292 .67348 m
.51142 .69456 L
s
.51142 .69456 m
.48187 .69627 L
s
.215 .319 .651 r
.62705 .3779 m .63199 .36807 L .60838 .36502 L p F P
0 0 0 r
s
.24 .35 .67 r
.60528 .40408 m
.6185 .37739 L
s
.543 .18 .079 r
.60838 .36502 m .59632 .36283 L .61735 .36541 L p F P
0 0 0 r
s
.543 .18 .079 r
.61735 .36541 m .63199 .36807 L .60838 .36502 L p F P
0 0 0 r
s
.24 .35 .67 r
.60084 .36448 m
.6185 .37739 L
s
.83 .24 .1 r
.60304 .36727 m
.60917 .36547 L
s
.351 .078 .033 r
.38257 .63468 m .39769 .6368 L .38445 .62787 L p F P
0 0 0 r
s
.83 .24 .1 r
.38653 .62674 m
.42806 .63262 L
s
.351 .078 .033 r
.38445 .62787 m .36734 .62545 L .38257 .63468 L p F P
0 0 0 r
s
.83 .24 .1 r
.38852 .34007 m
.34654 .33253 L
s
.38852 .34007 m
.39391 .33056 L
s
.776 .244 .106 r
.48939 .3484 m .47992 .34668 L .47358 .34054 L p F P
0 0 0 r
s
.776 .244 .106 r
.47358 .34054 m .48604 .3428 L .48939 .3484 L p F P
0 0 0 r
s
.256 .059 .025 r
.47669 .65136 m .48914 .6531 L .48713 .64936 L p F P
0 0 0 r
s
.256 .059 .025 r
.48713 .64936 m .47237 .64728 L .47669 .65136 L p F P
0 0 0 r
s
.085 .126 .306 r
.34038 .60067 m .34389 .59039 L .33507 .57433 L p F P
0 0 0 r
s
.085 .126 .306 r
.33876 .56309 m .33507 .57433 L .34389 .59039 L p F P
0 0 0 r
s
.065 .095 .231 r
.33507 .57433 m .33876 .56309 L .33415 .54506 L p F P
0 0 0 r
s
.24 .35 .67 r
.6185 .37739 m
.62369 .36691 L
s
.83 .24 .1 r
.81951 .40621 m
.77989 .39903 L
s
.81951 .40621 m
.82941 .41731 L
s
.327 .485 .926 r
.43013 .35058 m .43302 .3422 L .44908 .34794 L p F P
0 0 0 r
s
.83 .24 .1 r
.43004 .34753 m
.43244 .3439 L
s
.327 .485 .926 r
.45138 .34152 m .44908 .34794 L .43302 .3422 L p F P
0 0 0 r
s
.065 .095 .231 r
.33797 .53307 m .33415 .54506 L .33876 .56309 L p F P
0 0 0 r
s
.24 .35 .67 r
.33554 .53199 m
.33591 .53952 L
s
.045 .065 .149 r
.33415 .54506 m .33797 .53307 L .33744 .51405 L p F P
0 0 0 r
s
.543 .18 .079 r
.59632 .36283 m .58423 .36064 L .60266 .36273 L p F P
0 0 0 r
s
.543 .18 .079 r
.60266 .36273 m .61735 .36541 L .59632 .36283 L p F P
0 0 0 r
s
.125 .189 .421 r
.35015 .62302 m .35343 .61386 L .34038 .60067 L p F P
0 0 0 r
s
.83 .24 .1 r
.34453 .6208 m
.34989 .62156 L
s
.34412 .61599 m
.34453 .6208 L
s
.125 .189 .421 r
.34389 .59039 m .34038 .60067 L .35343 .61386 L p F P
0 0 0 r
s
.24 .35 .67 r
.47737 .32866 m
.50701 .32931 L
s
.51843 .30044 m
.50701 .32931 L
s
.776 .244 .106 r
.47992 .34668 m .47043 .34497 L .46108 .33827 L p F P
0 0 0 r
s
.776 .244 .106 r
.46108 .33827 m .47358 .34054 L .47992 .34668 L p F P
0 0 0 r
s
.24 .35 .67 r
.47297 .34043 m
.47737 .32866 L
s
.83 .24 .1 r
.47111 .35491 m
.47799 .34578 L
s
.47799 .34578 m
.51933 .35326 L
s
.351 .078 .033 r
.3674 .63255 m .38257 .63468 L .36734 .62545 L p F P
0 0 0 r
s
.351 .078 .033 r
.36734 .62545 m .35015 .62302 L .3674 .63255 L p F P
0 0 0 r
s
.24 .35 .67 r
.3503 .62554 m
.35103 .6235 L
s
.024 .035 .067 r
.33744 .51405 m .34136 .50157 L .34471 .48262 L p F P
0 0 0 r
s
.045 .065 .149 r
.34136 .50157 m .33744 .51405 L .33797 .53307 L p F P
0 0 0 r
s
.256 .059 .025 r
.4642 .64961 m .47669 .65136 L .47237 .64728 L p F P
0 0 0 r
s
.83 .24 .1 r
.47399 .64756 m
.51536 .65336 L
s
.256 .059 .025 r
.47237 .64728 m .45755 .64521 L .4642 .64961 L p F P
0 0 0 r
s
.83 .24 .1 r
.46913 .63843 m
.47399 .64756 L
s
.33 .49 .916 r
.38624 .39967 m .38983 .38858 L .40477 .38033 L p F P
0 0 0 r
s
.33 .49 .916 r
.40803 .37053 m .40477 .38033 L .38983 .38858 L p F P
0 0 0 r
s
.543 .18 .079 r
.58423 .36064 m .5721 .35843 L .5879 .36005 L p F P
0 0 0 r
s
.543 .18 .079 r
.5879 .36005 m .60266 .36273 L .58423 .36064 L p F P
0 0 0 r
s
.776 .244 .106 r
.47043 .34497 m .46092 .34324 L .44854 .33599 L p F P
0 0 0 r
s
.776 .244 .106 r
.44854 .33599 m .46108 .33827 L .47043 .34497 L p F P
0 0 0 r
s
.028 .04 .082 r
.63346 .57155 m .64018 .56026 L .6442 .5421 L p F P
0 0 0 r
s
.024 .035 .067 r
.64018 .56026 m .63346 .57155 L .62631 .5878 L p F P
0 0 0 r
s
.024 .035 .067 r
.62015 .59813 m .62631 .5878 L .63346 .57155 L p F P
0 0 0 r
s
.317 .477 .891 r
.58807 .6385 m .58346 .64632 L .5704 .65055 L p F P
0 0 0 r
s
.317 .477 .891 r
.56665 .65703 m .5704 .65055 L .58346 .64632 L p F P
0 0 0 r
s
.049 .072 .169 r
.6442 .5421 m .65129 .53005 L .65179 .51097 L p F P
0 0 0 r
s
.028 .04 .082 r
.65129 .53005 m .6442 .5421 L .64018 .56026 L p F P
0 0 0 r
s
.24 .35 .67 r
.62806 .57115 m
.64184 .54777 L
s
.64184 .54777 m
.64325 .52303 L
s
.252 .38 .679 r
.62631 .5878 m .62015 .59813 L .6103 .61156 L p F P
0 0 0 r
s
.252 .38 .679 r
.60483 .62076 m .6103 .61156 L .62015 .59813 L p F P
0 0 0 r
s
.238 .35 .612 r
.34471 .48262 m .34866 .46994 L .35559 .45213 L p F P
0 0 0 r
s
.024 .035 .067 r
.34866 .46994 m .34471 .48262 L .34136 .50157 L p F P
0 0 0 r
s
.83 .24 .1 r
.21568 .60257 m
.21671 .58812 L
s
.21671 .58812 m
.17357 .58194 L
s
.60917 .36547 m
.62476 .3683 L
s
.163 .246 .524 r
.35343 .61386 m .35015 .62302 L .3674 .63255 L p F P
0 0 0 r
s
.83 .24 .1 r
.36028 .62303 m
.38653 .62674 L
s
.24 .35 .67 r
.3503 .62554 m
.36967 .64822 L
s
.332 .492 .931 r
.40803 .37053 m .41135 .36058 L .42728 .35887 L p F P
0 0 0 r
s
.24 .35 .67 r
.40503 .39738 m
.41415 .3704 L
s
.41415 .3704 m
.43927 .36102 L
s
.332 .492 .931 r
.43013 .35058 m .42728 .35887 L .41135 .36058 L p F P
0 0 0 r
s
.776 .244 .106 r
.46092 .34324 m .45138 .34152 L .43595 .3337 L p F P
0 0 0 r
s
.776 .244 .106 r
.43595 .3337 m .44854 .33599 L .46092 .34324 L p F P
0 0 0 r
s
.83 .24 .1 r
.65627 .67053 m
.64594 .67373 L
s
.64594 .67373 m
.6052 .66802 L
s
.193 .286 .592 r
.63199 .36807 m .62705 .3779 L .64701 .3858 L p F P
0 0 0 r
s
.83 .24 .1 r
.63353 .36989 m
.64988 .37286 L
s
.193 .286 .592 r
.64122 .39693 m .64701 .3858 L .62705 .3779 L p F P
0 0 0 r
s
.24 .35 .67 r
.6185 .37739 m
.6395 .39856 L
s
.256 .059 .025 r
.45167 .64786 m .4642 .64961 L .45755 .64521 L p F P
0 0 0 r
s
.256 .059 .025 r
.45755 .64521 m .44268 .64312 L .45167 .64786 L p F P
0 0 0 r
s
.83 .24 .1 r
.21773 .30939 m
.2147 .32524 L
s
.543 .18 .079 r
.5721 .35843 m .55993 .35622 L .57309 .35736 L p F P
0 0 0 r
s
.83 .24 .1 r
.5602 .36066 m
.56801 .35799 L
s
.543 .18 .079 r
.57309 .35736 m .5879 .36005 L .5721 .35843 L p F P
0 0 0 r
s
.067 .097 .237 r
.65179 .51097 m .65906 .49843 L .65569 .47949 L p F P
0 0 0 r
s
.049 .072 .169 r
.65906 .49843 m .65179 .51097 L .65129 .53005 L p F P
0 0 0 r
s
.318 .471 .867 r
.36963 .42402 m .37343 .41202 L .38624 .39967 L p F P
0 0 0 r
s
.318 .471 .867 r
.38983 .38858 m .38624 .39967 L .37343 .41202 L p F P
0 0 0 r
s
.83 .24 .1 r
.34654 .33253 m
.30408 .3249 L
s
.34654 .33253 m
.35116 .32282 L
s
.34453 .6208 m
.34705 .62974 L
s
.30206 .61479 m
.34453 .6208 L
s
.238 .35 .612 r
.35951 .43961 m .35559 .45213 L .34866 .46994 L p F P
0 0 0 r
s
.288 .426 .769 r
.35559 .45213 m .35951 .43961 L .36963 .42402 L p F P
0 0 0 r
s
.512 .17 .075 r
.53986 .6599 m .54947 .66124 L .56294 .66343 L p F P
0 0 0 r
s
.512 .17 .075 r
.56294 .66343 m .55074 .66172 L .53986 .6599 L p F P
0 0 0 r
s
.323 .486 .92 r
.56665 .65703 m .56294 .66343 L .54947 .66124 L p F P
0 0 0 r
s
.24 .35 .67 r
.55055 .6662 m
.55638 .66316 L
s
.55638 .66316 m
.55744 .66261 L
s
.83 .24 .1 r
.56175 .66134 m
.56209 .66148 L
s
.55627 .65911 m
.55699 .6594 L
s
.56209 .66148 m
.56399 .66225 L
s
.327 .485 .926 r
.43302 .3422 m .43595 .3337 L .45138 .34152 L p F P
0 0 0 r
s
.24 .35 .67 r
.44817 .33592 m
.4492 .33299 L
s
.43927 .36102 m
.44718 .33872 L
s
.288 .426 .769 r
.37343 .41202 m .36963 .42402 L .35951 .43961 L p F P
0 0 0 r
s
.24 .35 .67 r
.36724 .4297 m
.38387 .41145 L
s
.35907 .45555 m
.36724 .4297 L
s
.49281 .67509 m
.48187 .69627 L
s
.48187 .69627 m
.45138 .69219 L
s
.543 .18 .079 r
.55993 .35622 m .54772 .354 L .55822 .35465 L p F P
0 0 0 r
s
.543 .18 .079 r
.55822 .35465 m .57309 .35736 L .55993 .35622 L p F P
0 0 0 r
s
.295 .444 .814 r
.6103 .61156 m .60483 .62076 L .59274 .63057 L p F P
0 0 0 r
s
.24 .35 .67 r
.60012 .62574 m
.60145 .6235 L
s
.60537 .6169 m
.60663 .61477 L
s
.60663 .61477 m
.62036 .59422 L
s
.295 .444 .814 r
.58807 .6385 m .59274 .63057 L .60483 .62076 L p F P
0 0 0 r
s
.83 .24 .1 r
.77989 .39903 m
.73982 .39177 L
s
.77989 .39903 m
.78912 .41007 L
s
.79089 .67818 m
.77788 .68765 L
s
.77788 .68765 m
.7378 .68201 L
s
.256 .059 .025 r
.4391 .6461 m .45167 .64786 L .44268 .64312 L p F P
0 0 0 r
s
.256 .059 .025 r
.44268 .64312 m .42774 .64102 L .4391 .6461 L p F P
0 0 0 r
s
.098 .143 .332 r
.65569 .47949 m .66292 .46675 L .65544 .44904 L p F P
0 0 0 r
s
.067 .097 .237 r
.66292 .46675 m .65569 .47949 L .65906 .49843 L p F P
0 0 0 r
s
.24 .35 .67 r
.39381 .66753 m
.36967 .64822 L
s
.167 .247 .522 r
.64701 .3858 m .64122 .39693 L .65716 .40901 L p F P
0 0 0 r
s
.167 .247 .522 r
.65068 .42106 m .65716 .40901 L .64122 .39693 L p F P
0 0 0 r
s
.83 .24 .1 r
.44462 .33974 m
.47799 .34578 L
s
.512 .17 .075 r
.53024 .65855 m .53986 .6599 L .55074 .66172 L p F P
0 0 0 r
s
.512 .17 .075 r
.55074 .66172 m .5385 .66001 L .53024 .65855 L p F P
0 0 0 r
s
.136 .2 .437 r
.65544 .44904 m .66241 .43645 L .65068 .42106 L p F P
0 0 0 r
s
.098 .143 .332 r
.66241 .43645 m .65544 .44904 L .66292 .46675 L p F P
0 0 0 r
s
.543 .18 .079 r
.54772 .354 m .53546 .35178 L .54328 .35194 L p F P
0 0 0 r
s
.543 .18 .079 r
.54328 .35194 m .55822 .35465 L .54772 .354 L p F P
0 0 0 r
s
.24 .35 .67 r
.4492 .33299 m
.47737 .32866 L
s
.48823 .29958 m
.47737 .32866 L
s
.136 .2 .437 r
.65716 .40901 m .65068 .42106 L .66241 .43645 L p F P
0 0 0 r
s
.24 .35 .67 r
.64176 .44825 m
.65594 .4221 L
s
.6395 .39856 m
.65594 .4221 L
s
.256 .059 .025 r
.42649 .64434 m .4391 .6461 L .42774 .64102 L p F P
0 0 0 r
s
.83 .24 .1 r
.43215 .64168 m
.47399 .64756 L
s
.42806 .63262 m
.43215 .64168 L
s
.256 .059 .025 r
.42774 .64102 m .41275 .63892 L .42649 .64434 L p F P
0 0 0 r
s
.512 .17 .075 r
.52059 .6572 m .53024 .65855 L .5385 .66001 L p F P
0 0 0 r
s
.512 .17 .075 r
.5385 .66001 m .52622 .65829 L .52059 .6572 L p F P
0 0 0 r
s
.543 .18 .079 r
.53546 .35178 m .52317 .34955 L .52829 .34921 L p F P
0 0 0 r
s
.83 .24 .1 r
.51933 .35326 m
.52637 .35043 L
s
.543 .18 .079 r
.52829 .34921 m .54328 .35194 L .53546 .35178 L p F P
0 0 0 r
s
.83 .24 .1 r
.17357 .58194 m
.17175 .59635 L
s
.6148 .6647 m
.6052 .66802 L
s
.56399 .66225 m
.6052 .66802 L
s
.33 .49 .916 r
.38983 .38858 m .39349 .3773 L .40803 .37053 L p F P
0 0 0 r
s
.33 .49 .916 r
.41135 .36058 m .40803 .37053 L .39349 .3773 L p F P
0 0 0 r
s
.24 .35 .67 r
.46172 .67083 m
.45138 .69219 L
s
.45138 .69219 m
.42152 .68245 L
s
.332 .492 .931 r
.41135 .36058 m .41471 .35048 L .43013 .35058 L p F P
0 0 0 r
s
.332 .492 .931 r
.43302 .3422 m .43013 .35058 L .41471 .35048 L p F P
0 0 0 r
s
.24 .35 .67 r
.42152 .68245 m
.39381 .66753 L
s
.40292 .64564 m
.39381 .66753 L
s
.256 .059 .025 r
.41383 .64257 m .42649 .64434 L .41275 .63892 L p F P
0 0 0 r
s
.256 .059 .025 r
.41275 .63892 m .39769 .6368 L .41383 .64257 L p F P
0 0 0 r
s
.512 .17 .075 r
.51091 .65585 m .52059 .6572 L .52622 .65829 L p F P
0 0 0 r
s
.512 .17 .075 r
.52622 .65829 m .5139 .65657 L .51091 .65585 L p F P
0 0 0 r
s
.83 .24 .1 r
.51536 .65336 m
.52232 .65641 L
s
.085 .126 .306 r
.34389 .59039 m .34747 .57991 L .33876 .56309 L p F P
0 0 0 r
s
.24 .35 .67 r
.33865 .55883 m
.34151 .56839 L
s
.085 .126 .306 r
.34253 .55162 m .33876 .56309 L .34747 .57991 L p F P
0 0 0 r
s
.065 .095 .231 r
.33876 .56309 m .34253 .55162 L .33797 .53307 L p F P
0 0 0 r
s
.83 .24 .1 r
.30408 .3249 m
.26115 .31719 L
s
.30408 .3249 m
.30791 .31499 L
s
.30377 .62367 m
.30206 .61479 L
s
.30206 .61479 m
.25912 .60871 L
s
.125 .189 .421 r
.35343 .61386 m .35676 .60454 L .34389 .59039 L p F P
0 0 0 r
s
.125 .189 .421 r
.34747 .57991 m .34389 .59039 L .35676 .60454 L p F P
0 0 0 r
s
.317 .477 .891 r
.59274 .63057 m .58807 .6385 L .57419 .64399 L p F P
0 0 0 r
s
.317 .477 .891 r
.5704 .65055 m .57419 .64399 L .58807 .6385 L p F P
0 0 0 r
s
.543 .18 .079 r
.52317 .34955 m .51083 .34731 L .51323 .34648 L p F P
0 0 0 r
s
.543 .18 .079 r
.51323 .34648 m .52829 .34921 L .52317 .34955 L p F P
0 0 0 r
s
.065 .095 .231 r
.34188 .52083 m .33797 .53307 L .34253 .55162 L p F P
0 0 0 r
s
.045 .065 .149 r
.33797 .53307 m .34188 .52083 L .34136 .50157 L p F P
0 0 0 r
s
.24 .35 .67 r
.43123 .66085 m
.42152 .68245 L
s
.323 .486 .92 r
.5704 .65055 m .56665 .65703 L .55231 .65621 L p F P
0 0 0 r
s
.323 .486 .92 r
.54947 .66124 m .55231 .65621 L .56665 .65703 L p F P
0 0 0 r
s
.24 .35 .67 r
.55055 .6662 m
.55301 .66186 L
s
.55055 .6662 m
.52292 .67348 L
s
.193 .286 .592 r
.64701 .3858 m .6529 .37447 L .63199 .36807 L p F P
0 0 0 r
s
.24 .056 .023 r
.63199 .36807 m .61735 .36541 L .63599 .3714 L p F P
0 0 0 r
s
.24 .35 .67 r
.62385 .36659 m
.62413 .36602 L
s
.24 .056 .023 r
.63599 .3714 m .6529 .37447 L .63199 .36807 L p F P
0 0 0 r
s
.83 .24 .1 r
.73982 .39177 m
.69929 .38442 L
s
.73982 .39177 m
.74837 .40273 L
s
.75016 .67239 m
.7378 .68201 L
s
.7378 .68201 m
.69727 .6763 L
s
.512 .17 .075 r
.50121 .65449 m .51091 .65585 L .5139 .65657 L p F P
0 0 0 r
s
.512 .17 .075 r
.5139 .65657 m .50154 .65484 L .50121 .65449 L p F P
0 0 0 r
s
.256 .059 .025 r
.40113 .64079 m .41383 .64257 L .39769 .6368 L p F P
0 0 0 r
s
.256 .059 .025 r
.39769 .6368 m .38257 .63468 L .40113 .64079 L p F P
0 0 0 r
s
.163 .246 .524 r
.3674 .63255 m .37043 .62452 L .35343 .61386 L p F P
0 0 0 r
s
.163 .246 .524 r
.35676 .60454 m .35343 .61386 L .37043 .62452 L p F P
0 0 0 r
s
.543 .18 .079 r
.51083 .34731 m .49846 .34506 L .49812 .34373 L p F P
0 0 0 r
s
.543 .18 .079 r
.49812 .34373 m .51323 .34648 L .51083 .34731 L p F P
0 0 0 r
s
.024 .035 .067 r
.34136 .50157 m .34536 .48882 L .34866 .46994 L p F P
0 0 0 r
s
.045 .065 .149 r
.34536 .48882 m .34136 .50157 L .34188 .52083 L p F P
0 0 0 r
s
.24 .35 .67 r
.34511 .49114 m
.348 .47723 L
s
.028 .04 .082 r
.64018 .56026 m .64703 .54874 L .65129 .53005 L p F P
0 0 0 r
s
.024 .035 .067 r
.64703 .54874 m .64018 .56026 L .63259 .57727 L p F P
0 0 0 r
s
.024 .035 .067 r
.62631 .5878 m .63259 .57727 L .64018 .56026 L p F P
0 0 0 r
s
.24 .35 .67 r
.63415 .57104 m
.64184 .54777 L
s
.252 .38 .679 r
.63259 .57727 m .62631 .5878 L .61587 .6022 L p F P
0 0 0 r
s
.252 .38 .679 r
.6103 .61156 m .61587 .6022 L .62631 .5878 L p F P
0 0 0 r
s
.24 .35 .67 r
.62036 .59422 m
.63415 .57104 L
s
.318 .471 .867 r
.37343 .41202 m .37731 .3998 L .38983 .38858 L p F P
0 0 0 r
s
.318 .471 .867 r
.39349 .3773 m .38983 .38858 L .37731 .3998 L p F P
0 0 0 r
s
.24 .35 .67 r
.38387 .41145 m
.39264 .38445 L
s
.512 .17 .075 r
.49148 .65313 m .50121 .65449 L .50154 .65484 L p F P
0 0 0 r
s
.512 .17 .075 r
.50154 .65484 m .48914 .6531 L .49148 .65313 L p F P
0 0 0 r
s
.24 .056 .023 r
.61735 .36541 m .60266 .36273 L .619 .36832 L p F P
0 0 0 r
s
.83 .24 .1 r
.56801 .35799 m
.60917 .36547 L
s
.24 .056 .023 r
.619 .36832 m .63599 .3714 L .61735 .36541 L p F P
0 0 0 r
s
.24 .35 .67 r
.62413 .36602 m
.63228 .34956 L
s
.049 .072 .169 r
.65129 .53005 m .65853 .51775 L .65906 .49843 L p F P
0 0 0 r
s
.24 .35 .67 r
.65252 .47305 m
.65747 .49844 L
s
.028 .04 .082 r
.65853 .51775 m .65129 .53005 L .64703 .54874 L p F P
0 0 0 r
s
.24 .35 .67 r
.64325 .52303 m
.65747 .49844 L
s
.238 .35 .612 r
.34866 .46994 m .35269 .45699 L .35951 .43961 L p F P
0 0 0 r
s
.024 .035 .067 r
.35269 .45699 m .34866 .46994 L .34536 .48882 L p F P
0 0 0 r
s
.256 .059 .025 r
.38839 .63901 m .40113 .64079 L .38257 .63468 L p F P
0 0 0 r
s
.83 .24 .1 r
.38984 .63575 m
.43215 .64168 L
s
.256 .059 .025 r
.38257 .63468 m .3674 .63255 L .38839 .63901 L p F P
0 0 0 r
s
.543 .18 .079 r
.49846 .34506 m .48604 .3428 L .48294 .34097 L p F P
0 0 0 r
s
.543 .18 .079 r
.48294 .34097 m .49812 .34373 L .49846 .34506 L p F P
0 0 0 r
s
.295 .444 .814 r
.61587 .6022 m .6103 .61156 L .59749 .62251 L p F P
0 0 0 r
s
.24 .35 .67 r
.60663 .61477 m
.60672 .61462 L
s
.295 .444 .814 r
.59274 .63057 m .59749 .62251 L .6103 .61156 L p F P
0 0 0 r
s
.288 .426 .769 r
.35951 .43961 m .36351 .42683 L .37343 .41202 L p F P
0 0 0 r
s
.288 .426 .769 r
.37731 .3998 m .37343 .41202 L .36351 .42683 L p F P
0 0 0 r
s
.238 .35 .612 r
.36351 .42683 m .35951 .43961 L .35269 .45699 L p F P
0 0 0 r
s
.24 .35 .67 r
.35605 .45151 m
.36724 .4297 L
s
.34812 .47684 m
.35605 .45151 L
s
.067 .097 .237 r
.65906 .49843 m .66649 .48561 L .66292 .46675 L p F P
0 0 0 r
s
.049 .072 .169 r
.66649 .48561 m .65906 .49843 L .65853 .51775 L p F P
0 0 0 r
s
.512 .17 .075 r
.48173 .65176 m .49148 .65313 L .48914 .6531 L p F P
0 0 0 r
s
.512 .17 .075 r
.48914 .6531 m .47669 .65136 L .48173 .65176 L p F P
0 0 0 r
s
.83 .24 .1 r
.56399 .66225 m
.57286 .6588 L
s
.55566 .66108 m
.56399 .66225 L
s
.52232 .65641 m
.55 .66029 L
s
.167 .247 .522 r
.6529 .37447 m .64701 .3858 L .66377 .39672 L p F P
0 0 0 r
s
.83 .24 .1 r
.64988 .37286 m
.65831 .377 L
s
.167 .247 .522 r
.65716 .40901 m .66377 .39672 L .64701 .3858 L p F P
0 0 0 r
s
.24 .056 .023 r
.60266 .36273 m .5879 .36005 L .60193 .36522 L p F P
0 0 0 r
s
.24 .056 .023 r
.60193 .36522 m .619 .36832 L .60266 .36273 L p F P
0 0 0 r
s
.83 .24 .1 r
.6123 .3671 m
.61686 .36948 L
s
.543 .18 .079 r
.48604 .3428 m .47358 .34054 L .4677 .3382 L p F P
0 0 0 r
s
.543 .18 .079 r
.4677 .3382 m .48294 .34097 L .48604 .3428 L p F P
0 0 0 r
s
.83 .24 .1 r
.47799 .34578 m
.48426 .34278 L
s
.26115 .31719 m
.21773 .30939 L
s
.26115 .31719 m
.26417 .30707 L
s
.25999 .61752 m
.25912 .60871 L
s
.25912 .60871 m
.21568 .60257 L
s
.194 .292 .608 r
.37043 .62452 m .3674 .63255 L .38839 .63901 L p F P
0 0 0 r
s
.24 .35 .67 r
.37465 .6353 m
.37483 .63484 L
s
.36967 .64822 m
.37465 .6353 L
s
.83 .24 .1 r
.38653 .62674 m
.38984 .63575 L
s
.24 .35 .67 r
.44348 .33507 m
.4492 .33299 L
s
.332 .492 .931 r
.41471 .35048 m .41813 .34023 L .43302 .3422 L p F P
0 0 0 r
s
.332 .492 .931 r
.43595 .3337 m .43302 .3422 L .41813 .34023 L p F P
0 0 0 r
s
.83 .24 .1 r
.39391 .33056 m
.42779 .33669 L
s
.24 .35 .67 r
.54902 .30619 m
.5789 .31658 L
s
.59205 .28698 m
.5789 .31658 L
s
.5789 .31658 m
.60699 .33121 L
s
.098 .143 .332 r
.66292 .46675 m .67031 .45373 L .66241 .43645 L p F P
0 0 0 r
s
.067 .097 .237 r
.67031 .45373 m .66292 .46675 L .66649 .48561 L p F P
0 0 0 r
s
.512 .17 .075 r
.47195 .6504 m .48173 .65176 L .47669 .65136 L p F P
0 0 0 r
s
.512 .17 .075 r
.47669 .65136 m .4642 .64961 L .47195 .6504 L p F P
0 0 0 r
s
.83 .24 .1 r
.47399 .64756 m
.48018 .65051 L
s
.33 .49 .916 r
.39349 .3773 m .3972 .36583 L .41135 .36058 L p F P
0 0 0 r
s
.24 .35 .67 r
.39264 .38445 m
.41415 .3704 L
s
.33 .49 .916 r
.41471 .35048 m .41135 .36058 L .3972 .36583 L p F P
0 0 0 r
s
.136 .2 .437 r
.66377 .39672 m .65716 .40901 L .66952 .42361 L p F P
0 0 0 r
s
.136 .2 .437 r
.66241 .43645 m .66952 .42361 L .65716 .40901 L p F P
0 0 0 r
s
.83 .24 .1 r
.65831 .377 m
.69929 .38442 L
s
.69929 .38442 m
.70715 .39532 L
s
.70897 .66653 m
.69727 .6763 L
s
.69727 .6763 m
.65627 .67053 L
s
.098 .143 .332 r
.66952 .42361 m .66241 .43645 L .67031 .45373 L p F P
0 0 0 r
s
.24 .35 .67 r
.65594 .4221 m
.66707 .44716 L
s
.65252 .47305 m
.66707 .44716 L
s
.543 .18 .079 r
.47358 .34054 m .46108 .33827 L .45239 .33541 L p F P
0 0 0 r
s
.543 .18 .079 r
.45239 .33541 m .4677 .3382 L .47358 .34054 L p F P
0 0 0 r
s
.24 .056 .023 r
.5879 .36005 m .57309 .35736 L .58478 .36211 L p F P
0 0 0 r
s
.24 .056 .023 r
.58478 .36211 m .60193 .36522 L .5879 .36005 L p F P
0 0 0 r
s
.24 .35 .67 r
.62076 .30189 m
.60699 .33121 L
s
.60699 .33121 m
.63228 .34956 L
s
.323 .486 .92 r
.57419 .64399 m .5704 .65055 L .55518 .65113 L p F P
0 0 0 r
s
.323 .486 .92 r
.55231 .65621 m .55518 .65113 L .5704 .65055 L p F P
0 0 0 r
s
.24 .35 .67 r
.51843 .30044 m
.54902 .30619 L
s
.56155 .27632 m
.54902 .30619 L
s
.317 .477 .891 r
.59749 .62251 m .59274 .63057 L .57804 .63735 L p F P
0 0 0 r
s
.317 .477 .891 r
.57419 .64399 m .57804 .63735 L .59274 .63057 L p F P
0 0 0 r
s
.83 .24 .1 r
.39391 .33056 m
.35116 .32282 L
s
.39391 .33056 m
.39858 .32722 L
s
.37221 .63327 m
.37358 .63346 L
s
.38319 .63481 m
.38984 .63575 L
s
.82941 .41731 m
.78912 .41007 L
s
.82941 .41731 m
.83742 .43474 L
s
.512 .17 .075 r
.46214 .64902 m .47195 .6504 L .4642 .64961 L p F P
0 0 0 r
s
.512 .17 .075 r
.4642 .64961 m .45167 .64786 L .46214 .64902 L p F P
0 0 0 r
s
.543 .18 .079 r
.46108 .33827 m .44854 .33599 L .43703 .33262 L p F P
0 0 0 r
s
.543 .18 .079 r
.43703 .33262 m .45239 .33541 L .46108 .33827 L p F P
0 0 0 r
s
.24 .056 .023 r
.57309 .35736 m .55822 .35465 L .56755 .35898 L p F P
0 0 0 r
s
.83 .24 .1 r
.52637 .35043 m
.56375 .35722 L
s
.24 .056 .023 r
.56755 .35898 m .58478 .36211 L .57309 .35736 L p F P
0 0 0 r
s
.125 .189 .421 r
.35676 .60454 m .36016 .59506 L .34747 .57991 L p F P
0 0 0 r
s
.125 .189 .421 r
.35111 .56923 m .34747 .57991 L .36016 .59506 L p F P
0 0 0 r
s
.085 .126 .306 r
.34747 .57991 m .35111 .56923 L .34253 .55162 L p F P
0 0 0 r
s
.24 .35 .67 r
.52292 .67348 m
.49281 .67509 L
s
.512 .17 .075 r
.45231 .64765 m .46214 .64902 L .45167 .64786 L p F P
0 0 0 r
s
.512 .17 .075 r
.45167 .64786 m .4391 .6461 L .45231 .64765 L p F P
0 0 0 r
s
.085 .126 .306 r
.34638 .53992 m .34253 .55162 L .35111 .56923 L p F P
0 0 0 r
s
.065 .095 .231 r
.34253 .55162 m .34638 .53992 L .34188 .52083 L p F P
0 0 0 r
s
.543 .18 .079 r
.44854 .33599 m .43595 .3337 L .42159 .32981 L p F P
0 0 0 r
s
.543 .18 .079 r
.42159 .32981 m .43703 .33262 L .44854 .33599 L p F P
0 0 0 r
s
.83 .24 .1 r
.43773 .33732 m
.44166 .33505 L
s
.163 .246 .524 r
.37043 .62452 m .3735 .61637 L .35676 .60454 L p F P
0 0 0 r
s
.163 .246 .524 r
.36016 .59506 m .35676 .60454 L .3735 .61637 L p F P
0 0 0 r
s
.24 .35 .67 r
.64665 .32053 m
.63228 .34956 L
s
.065 .095 .231 r
.34588 .50833 m .34188 .52083 L .34638 .53992 L p F P
0 0 0 r
s
.24 .35 .67 r
.34329 .5079 m
.34368 .5152 L
s
.045 .065 .149 r
.34188 .52083 m .34588 .50833 L .34536 .48882 L p F P
0 0 0 r
s
.24 .056 .023 r
.55822 .35465 m .54328 .35194 L .55024 .35584 L p F P
0 0 0 r
s
.24 .056 .023 r
.55024 .35584 m .56755 .35898 L .55822 .35465 L p F P
0 0 0 r
s
.83 .24 .1 r
.21992 .29906 m
.21773 .30939 L
s
.21571 .61131 m
.21568 .60257 L
s
.21568 .60257 m
.17175 .59635 L
s
.318 .471 .867 r
.37731 .3998 m .38126 .38733 L .39349 .3773 L p F P
0 0 0 r
s
.318 .471 .867 r
.3972 .36583 m .39349 .3773 L .38126 .38733 L p F P
0 0 0 r
s
.512 .17 .075 r
.44246 .64627 m .45231 .64765 L .4391 .6461 L p F P
0 0 0 r
s
.512 .17 .075 r
.4391 .6461 m .42649 .64434 L .44246 .64627 L p F P
0 0 0 r
s
.24 .35 .67 r
.48823 .29958 m
.51843 .30044 L
s
.53035 .27032 m
.51843 .30044 L
s
.024 .035 .067 r
.63259 .57727 m .63899 .56654 L .64703 .54874 L p F P
0 0 0 r
s
.252 .38 .679 r
.63899 .56654 m .63259 .57727 L .62154 .59267 L p F P
0 0 0 r
s
.252 .38 .679 r
.61587 .6022 m .62154 .59267 L .63259 .57727 L p F P
0 0 0 r
s
.24 .35 .67 r
.6203 .59173 m
.63415 .57104 L
s
.752 .239 .103 r
.5276 .65397 m .53426 .65491 L .54947 .66124 L p F P
0 0 0 r
s
.752 .239 .103 r
.54947 .66124 m .53986 .6599 L .5276 .65397 L p F P
0 0 0 r
s
.319 .48 .919 r
.55231 .65621 m .54947 .66124 L .53426 .65491 L p F P
0 0 0 r
s
.332 .492 .931 r
.41813 .34023 m .42159 .32981 L .43595 .3337 L p F P
0 0 0 r
s
.24 .35 .67 r
.42364 .34228 m
.44194 .33563 L
s
.028 .04 .082 r
.64703 .54874 m .65402 .53697 L .65853 .51775 L p F P
0 0 0 r
s
.024 .035 .067 r
.65402 .53697 m .64703 .54874 L .63899 .56654 L p F P
0 0 0 r
s
.83 .24 .1 r
.65373 .37617 m
.65831 .377 L
s
.66731 .6606 m
.65627 .67053 L
s
.65627 .67053 m
.6148 .6647 L
s
.295 .444 .814 r
.62154 .59267 m .61587 .6022 L .60231 .61433 L p F P
0 0 0 r
s
.24 .35 .67 r
.6107 .60791 m
.61208 .60559 L
s
.61612 .59877 m
.6203 .59173 L
s
.295 .444 .814 r
.59749 .62251 m .60231 .61433 L .61587 .6022 L p F P
0 0 0 r
s
.024 .035 .067 r
.34536 .48882 m .34945 .4758 L .35269 .45699 L p F P
0 0 0 r
s
.045 .065 .149 r
.34945 .4758 m .34536 .48882 L .34588 .50833 L p F P
0 0 0 r
s
.512 .17 .075 r
.43257 .64489 m .44246 .64627 L .42649 .64434 L p F P
0 0 0 r
s
.512 .17 .075 r
.42649 .64434 m .41383 .64257 L .43257 .64489 L p F P
0 0 0 r
s
.83 .24 .1 r
.80387 .6622 m
.79089 .67818 L
s
.79089 .67818 m
.75016 .67239 L
s
.24 .056 .023 r
.54328 .35194 m .52829 .34921 L .53285 .35268 L p F P
0 0 0 r
s
.24 .056 .023 r
.53285 .35268 m .55024 .35584 L .54328 .35194 L p F P
0 0 0 r
s
.194 .292 .608 r
.38839 .63901 m .39107 .6323 L .37043 .62452 L p F P
0 0 0 r
s
.194 .292 .608 r
.3735 .61637 m .37043 .62452 L .39107 .6323 L p F P
0 0 0 r
s
.83 .24 .1 r
.34705 .62974 m
.37221 .63327 L
s
.35116 .32282 m
.30791 .31499 L
s
.35116 .32282 m
.35499 .31931 L
s
.752 .239 .103 r
.52093 .65303 m .5276 .65397 L .53986 .6599 L p F P
0 0 0 r
s
.752 .239 .103 r
.53986 .6599 m .53024 .65855 L .52093 .65303 L p F P
0 0 0 r
s
.24 .35 .67 r
.53109 .65848 m
.53279 .65537 L
s
.323 .486 .92 r
.57804 .63735 m .57419 .64399 L .55807 .646 L p F P
0 0 0 r
s
.323 .486 .92 r
.55518 .65113 m .55807 .646 L .57419 .64399 L p F P
0 0 0 r
s
.167 .247 .522 r
.66377 .39672 m .6705 .38419 L .6529 .37447 L p F P
0 0 0 r
s
.347 .077 .032 r
.6529 .37447 m .63599 .3714 L .65168 .38079 L p F P
0 0 0 r
s
.83 .24 .1 r
.65262 .37596 m
.65307 .37605 L
s
.24 .35 .67 r
.6395 .39856 m
.64943 .37945 L
s
.65203 .37444 m
.65381 .37101 L
s
.347 .077 .032 r
.65168 .38079 m .6705 .38419 L .6529 .37447 L p F P
0 0 0 r
s
.24 .35 .67 r
.65196 .37458 m
.65203 .37444 L
s
.83 .24 .1 r
.65831 .377 m
.65879 .37772 L
s
.3508 .63239 m
.34705 .62974 L
s
.34705 .62974 m
.30377 .62367 L
s
.78912 .41007 m
.74837 .40273 L
s
.78912 .41007 m
.7965 .42747 L
s
.049 .072 .169 r
.65853 .51775 m .66593 .50518 L .66649 .48561 L p F P
0 0 0 r
s
.028 .04 .082 r
.66593 .50518 m .65853 .51775 L .65402 .53697 L p F P
0 0 0 r
s
.24 .35 .67 r
.64184 .54777 m
.6562 .5234 L
s
.6562 .5234 m
.65747 .49844 L
s
.288 .426 .769 r
.36351 .42683 m .36759 .41378 L .37731 .3998 L p F P
0 0 0 r
s
.288 .426 .769 r
.38126 .38733 m .37731 .3998 L .36759 .41378 L p F P
0 0 0 r
s
.24 .35 .67 r
.37577 .40276 m
.39264 .38445 L
s
.238 .35 .612 r
.35269 .45699 m .35682 .44377 L .36351 .42683 L p F P
0 0 0 r
s
.024 .035 .067 r
.35682 .44377 m .35269 .45699 L .34945 .4758 L p F P
0 0 0 r
s
.24 .35 .67 r
.35098 .47604 m
.35605 .45151 L
s
.33 .49 .916 r
.3972 .36583 m .40098 .35415 L .41471 .35048 L p F P
0 0 0 r
s
.33 .49 .916 r
.41813 .34023 m .41471 .35048 L .40098 .35415 L p F P
0 0 0 r
s
.24 .35 .67 r
.41415 .3704 m
.42364 .34228 L
s
.238 .35 .612 r
.36759 .41378 m .36351 .42683 L .35682 .44377 L p F P
0 0 0 r
s
.24 .35 .67 r
.36724 .4297 m
.37577 .40276 L
s
.752 .239 .103 r
.51424 .65209 m .52093 .65303 L .53024 .65855 L p F P
0 0 0 r
s
.83 .24 .1 r
.52232 .65641 m
.52357 .65586 L
s
.752 .239 .103 r
.53024 .65855 m .52059 .6572 L .51424 .65209 L p F P
0 0 0 r
s
.24 .35 .67 r
.52292 .67348 m
.53109 .65848 L
s
.512 .17 .075 r
.42267 .6435 m .43257 .64489 L .41383 .64257 L p F P
0 0 0 r
s
.83 .24 .1 r
.43215 .64168 m
.43755 .64454 L
s
.512 .17 .075 r
.41383 .64257 m .40113 .64079 L .42267 .6435 L p F P
0 0 0 r
s
.317 .477 .891 r
.60231 .61433 m .59749 .62251 L .58193 .63062 L p F P
0 0 0 r
s
.317 .477 .891 r
.57804 .63735 m .58193 .63062 L .59749 .62251 L p F P
0 0 0 r
s
.24 .056 .023 r
.52829 .34921 m .51323 .34648 L .51537 .34951 L p F P
0 0 0 r
s
.83 .24 .1 r
.48426 .34278 m
.5145 .34827 L
s
.52064 .34939 m
.52637 .35043 L
s
.24 .056 .023 r
.51537 .34951 m .53285 .35268 L .52829 .34921 L p F P
0 0 0 r
s
.83 .24 .1 r
.52887 .35196 m
.53251 .35419 L
s
.067 .097 .237 r
.66649 .48561 m .67407 .47251 L .67031 .45373 L p F P
0 0 0 r
s
.049 .072 .169 r
.67407 .47251 m .66649 .48561 L .66593 .50518 L p F P
0 0 0 r
s
.347 .077 .032 r
.63599 .3714 m .619 .36832 L .63277 .37738 L p F P
0 0 0 r
s
.83 .24 .1 r
.61686 .36948 m
.62226 .37046 L
s
.63523 .37281 m
.63971 .37362 L
s
.24 .35 .67 r
.63228 .34956 m
.65381 .37101 L
s
.347 .077 .032 r
.63277 .37738 m .65168 .38079 L .63599 .3714 L p F P
0 0 0 r
s
.752 .239 .103 r
.50754 .65115 m .51424 .65209 L .52059 .6572 L p F P
0 0 0 r
s
.752 .239 .103 r
.52059 .6572 m .51091 .65585 L .50754 .65115 L p F P
0 0 0 r
s
.83 .24 .1 r
.48018 .65051 m
.51009 .6547 L
s
.24 .35 .67 r
.49281 .67509 m
.46172 .67083 L
s
.42364 .34228 m
.42738 .33123 L
s
.136 .2 .437 r
.6705 .38419 m .66377 .39672 L .67677 .41049 L p F P
0 0 0 r
s
.136 .2 .437 r
.66952 .42361 m .67677 .41049 L .66377 .39672 L p F P
0 0 0 r
s
.512 .17 .075 r
.41273 .64211 m .42267 .6435 L .40113 .64079 L p F P
0 0 0 r
s
.512 .17 .075 r
.40113 .64079 m .38839 .63901 L .41273 .64211 L p F P
0 0 0 r
s
.098 .143 .332 r
.67031 .45373 m .67785 .44044 L .66952 .42361 L p F P
0 0 0 r
s
.067 .097 .237 r
.67785 .44044 m .67031 .45373 L .67407 .47251 L p F P
0 0 0 r
s
.319 .48 .919 r
.55518 .65113 m .55231 .65621 L .53618 .6514 L p F P
0 0 0 r
s
.319 .48 .919 r
.53426 .65491 m .53618 .6514 L .55231 .65621 L p F P
0 0 0 r
s
.83 .24 .1 r
.17175 .59635 m
.1709 .60502 L
s
.24 .35 .67 r
.66875 .34227 m
.65381 .37101 L
s
.65381 .37101 m
.65932 .37876 L
s
.6621 .38267 m
.67073 .39482 L
s
.098 .143 .332 r
.67677 .41049 m .66952 .42361 L .67785 .44044 L p F P
0 0 0 r
s
.24 .35 .67 r
.65594 .4221 m
.67073 .39482 L
s
.24 .056 .023 r
.51323 .34648 m .49812 .34373 L .49781 .34632 L p F P
0 0 0 r
s
.24 .056 .023 r
.49781 .34632 m .51537 .34951 L .51323 .34648 L p F P
0 0 0 r
s
.752 .239 .103 r
.50084 .65021 m .50754 .65115 L .51091 .65585 L p F P
0 0 0 r
s
.752 .239 .103 r
.51091 .65585 m .50121 .65449 L .50084 .65021 L p F P
0 0 0 r
s
.24 .35 .67 r
.50347 .65445 m
.50423 .65298 L
s
.83 .24 .1 r
.62515 .6546 m
.6148 .6647 L
s
.6148 .6647 m
.57286 .6588 L
s
.347 .077 .032 r
.619 .36832 m .60193 .36522 L .61375 .37395 L p F P
0 0 0 r
s
.347 .077 .032 r
.61375 .37395 m .63277 .37738 L .619 .36832 L p F P
0 0 0 r
s
.22 .332 .677 r
.39107 .6323 m .38839 .63901 L .41273 .64211 L p F P
0 0 0 r
s
.24 .35 .67 r
.39691 .64086 m
.40292 .64564 L
s
.39583 .64 m
.39691 .64086 L
s
.83 .24 .1 r
.3931 .6377 m
.3933 .63782 L
s
.24 .35 .67 r
.45956 .30375 m
.48823 .29958 L
s
.49958 .26924 m
.48823 .29958 L
s
.752 .239 .103 r
.49411 .64927 m .50084 .65021 L .50121 .65449 L p F P
0 0 0 r
s
.752 .239 .103 r
.50121 .65449 m .49148 .65313 L .49411 .64927 L p F P
0 0 0 r
s
.24 .35 .67 r
.49281 .67509 m
.50347 .65445 L
s
.83 .24 .1 r
.76258 .65622 m
.75016 .67239 L
s
.75016 .67239 m
.70897 .66653 L
s
.30791 .31499 m
.26417 .30707 L
s
.30791 .31499 m
.3109 .3113 L
s
.125 .189 .421 r
.36016 .59506 m .36361 .58541 L .35111 .56923 L p F P
0 0 0 r
s
.125 .189 .421 r
.35483 .55834 m .35111 .56923 L .36361 .58541 L p F P
0 0 0 r
s
.085 .126 .306 r
.35111 .56923 m .35483 .55834 L .34638 .53992 L p F P
0 0 0 r
s
.163 .246 .524 r
.3735 .61637 m .37662 .6081 L .36016 .59506 L p F P
0 0 0 r
s
.163 .246 .524 r
.36361 .58541 m .36016 .59506 L .37662 .6081 L p F P
0 0 0 r
s
.83 .24 .1 r
.30667 .62621 m
.30377 .62367 L
s
.30377 .62367 m
.25999 .61752 L
s
.24 .056 .023 r
.49812 .34373 m .48294 .34097 L .48017 .34312 L p F P
0 0 0 r
s
.24 .056 .023 r
.48017 .34312 m .49781 .34632 L .49812 .34373 L p F P
0 0 0 r
s
.83 .24 .1 r
.74837 .40273 m
.70715 .39532 L
s
.74837 .40273 m
.75512 .42011 L
s
.323 .486 .92 r
.58193 .63062 m .57804 .63735 L .561 .64081 L p F P
0 0 0 r
s
.323 .486 .92 r
.55807 .646 m .561 .64081 L .57804 .63735 L p F P
0 0 0 r
s
.752 .239 .103 r
.48738 .64832 m .49411 .64927 L .49148 .65313 L p F P
0 0 0 r
s
.752 .239 .103 r
.49148 .65313 m .48173 .65176 L .48738 .64832 L p F P
0 0 0 r
s
.318 .471 .867 r
.38126 .38733 m .38529 .37462 L .3972 .36583 L p F P
0 0 0 r
s
.318 .471 .867 r
.40098 .35415 m .3972 .36583 L .38529 .37462 L p F P
0 0 0 r
s
.24 .35 .67 r
.39264 .38445 m
.40179 .35629 L
s
.085 .126 .306 r
.3503 .52798 m .34638 .53992 L .35483 .55834 L p F P
0 0 0 r
s
.24 .35 .67 r
.34628 .53384 m
.34729 .53715 L
s
.065 .095 .231 r
.34638 .53992 m .3503 .52798 L .34588 .50833 L p F P
0 0 0 r
s
.24 .35 .67 r
.46172 .67083 m
.43123 .66085 L
s
.347 .077 .032 r
.60193 .36522 m .58478 .36211 L .59464 .3705 L p F P
0 0 0 r
s
.83 .24 .1 r
.60021 .36647 m
.60473 .36728 L
s
.347 .077 .032 r
.59464 .3705 m .61375 .37395 L .60193 .36522 L p F P
0 0 0 r
s
.24 .35 .67 r
.40292 .64564 m
.43123 .66085 L
s
.194 .292 .608 r
.39107 .6323 m .39378 .62551 L .3735 .61637 L p F P
0 0 0 r
s
.194 .292 .608 r
.37662 .6081 m .3735 .61637 L .39378 .62551 L p F P
0 0 0 r
s
.752 .239 .103 r
.48063 .64737 m .48738 .64832 L .48173 .65176 L p F P
0 0 0 r
s
.83 .24 .1 r
.48018 .65051 m
.48128 .64995 L
s
.752 .239 .103 r
.48173 .65176 m .47195 .6504 L .48063 .64737 L p F P
0 0 0 r
s
.83 .24 .1 r
.43755 .64454 m
.47407 .64965 L
s
.24 .056 .023 r
.48294 .34097 m .4677 .3382 L .46244 .33991 L p F P
0 0 0 r
s
.83 .24 .1 r
.44166 .33505 m
.46459 .33921 L
s
.47081 .34034 m
.4813 .34224 L
s
.24 .056 .023 r
.46244 .33991 m .48017 .34312 L .48294 .34097 L p F P
0 0 0 r
s
.252 .38 .679 r
.62154 .59267 m .6273 .58298 L .63899 .56654 L p F P
0 0 0 r
s
.295 .444 .814 r
.6273 .58298 m .62154 .59267 L .6072 .60602 L p F P
0 0 0 r
s
.295 .444 .814 r
.60231 .61433 m .6072 .60602 L .62154 .59267 L p F P
0 0 0 r
s
.024 .035 .067 r
.63899 .56654 m .64552 .5556 L .65402 .53697 L p F P
0 0 0 r
s
.252 .38 .679 r
.64552 .5556 m .63899 .56654 L .6273 .58298 L p F P
0 0 0 r
s
.83 .24 .1 r
.42529 .33207 m
.44166 .33505 L
s
.065 .095 .231 r
.34996 .49556 m .34588 .50833 L .3503 .52798 L p F P
0 0 0 r
s
.045 .065 .149 r
.34588 .50833 m .34996 .49556 L .34945 .4758 L p F P
0 0 0 r
s
.24 .35 .67 r
.34957 .48053 m
.35098 .47604 L
s
.319 .48 .919 r
.55807 .646 m .55518 .65113 L .5381 .64788 L p F P
0 0 0 r
s
.319 .48 .919 r
.53618 .6514 m .5381 .64788 L .55518 .65113 L p F P
0 0 0 r
s
.33 .49 .916 r
.40098 .35415 m .40483 .34226 L .41813 .34023 L p F P
0 0 0 r
s
.24 .35 .67 r
.40179 .35629 m
.42364 .34228 L
s
.33 .49 .916 r
.42159 .32981 m .41813 .34023 L .40483 .34226 L p F P
0 0 0 r
s
.83 .24 .1 r
.39858 .32722 m
.41988 .33109 L
s
.24 .35 .67 r
.55515 .64627 m
.55839 .64544 L
s
.752 .239 .103 r
.47387 .64642 m .48063 .64737 L .47195 .6504 L p F P
0 0 0 r
s
.752 .239 .103 r
.47195 .6504 m .46214 .64902 L .47387 .64642 L p F P
0 0 0 r
s
.24 .35 .67 r
.46172 .67083 m
.47179 .65002 L
s
.028 .04 .082 r
.65402 .53697 m .66115 .52497 L .66593 .50518 L p F P
0 0 0 r
s
.024 .035 .067 r
.66115 .52497 m .65402 .53697 L .64552 .5556 L p F P
0 0 0 r
s
.24 .35 .67 r
.64853 .54685 m
.6562 .5234 L
s
.63415 .57104 m
.64853 .54685 L
s
.317 .477 .891 r
.6072 .60602 m .60231 .61433 L .58588 .6238 L p F P
0 0 0 r
s
.317 .477 .891 r
.58193 .63062 m .58588 .6238 L .60231 .61433 L p F P
0 0 0 r
s
.347 .077 .032 r
.58478 .36211 m .56755 .35898 L .57543 .36703 L p F P
0 0 0 r
s
.83 .24 .1 r
.58257 .36327 m
.58712 .36409 L
s
.347 .077 .032 r
.57543 .36703 m .59464 .3705 L .58478 .36211 L p F P
0 0 0 r
s
.24 .056 .023 r
.4677 .3382 m .45239 .33541 L .44463 .33667 L p F P
0 0 0 r
s
.24 .056 .023 r
.44463 .33667 m .46244 .33991 L .4677 .3382 L p F P
0 0 0 r
s
.024 .035 .067 r
.34945 .4758 m .35362 .46248 L .35682 .44377 L p F P
0 0 0 r
s
.045 .065 .149 r
.35362 .46248 m .34945 .4758 L .34996 .49556 L p F P
0 0 0 r
s
.288 .426 .769 r
.36759 .41378 m .37176 .40046 L .38126 .38733 L p F P
0 0 0 r
s
.288 .426 .769 r
.38529 .37462 m .38126 .38733 L .37176 .40046 L p F P
0 0 0 r
s
.752 .239 .103 r
.4671 .64547 m .47387 .64642 L .46214 .64902 L p F P
0 0 0 r
s
.24 .35 .67 r
.47179 .65002 m
.47251 .64853 L
s
.752 .239 .103 r
.46214 .64902 m .45231 .64765 L .4671 .64547 L p F P
0 0 0 r
s
.83 .24 .1 r
.57286 .6588 m
.58251 .64853 L
s
.53783 .65387 m
.57286 .6588 L
s
.83742 .43474 m
.7965 .42747 L
s
.83742 .43474 m
.84301 .45788 L
s
.049 .072 .169 r
.66593 .50518 m .67348 .49234 L .67407 .47251 L p F P
0 0 0 r
s
.24 .35 .67 r
.66707 .44716 m
.67229 .47279 L
s
.028 .04 .082 r
.67348 .49234 m .66593 .50518 L .66115 .52497 L p F P
0 0 0 r
s
.24 .35 .67 r
.65747 .49844 m
.67229 .47279 L
s
.22 .332 .677 r
.41273 .64211 m .41494 .63689 L .39107 .6323 L p F P
0 0 0 r
s
.83 .24 .1 r
.41315 .64112 m
.43755 .64454 L
s
.39443 .6385 m
.40313 .63972 L
s
.24 .35 .67 r
.40292 .64564 m
.40479 .64112 L
s
.83 .24 .1 r
.3933 .63782 m
.39443 .6385 L
s
.22 .332 .677 r
.39378 .62551 m .39107 .6323 L .41494 .63689 L p F P
0 0 0 r
s
.83 .24 .1 r
.7208 .65017 m
.70897 .66653 L
s
.70897 .66653 m
.66731 .6606 L
s
.26417 .30707 m
.21992 .29906 L
s
.26417 .30707 m
.26629 .3032 L
s
.238 .35 .612 r
.35682 .44377 m .36103 .43026 L .36759 .41378 L p F P
0 0 0 r
s
.024 .035 .067 r
.36103 .43026 m .35682 .44377 L .35362 .46248 L p F P
0 0 0 r
s
.238 .35 .612 r
.37176 .40046 m .36759 .41378 L .36103 .43026 L p F P
0 0 0 r
s
.24 .35 .67 r
.36444 .42469 m
.37577 .40276 L
s
.35641 .45036 m
.36444 .42469 L
s
.83 .24 .1 r
.26202 .61995 m
.25999 .61752 L
s
.25999 .61752 m
.21571 .61131 L
s
.70715 .39532 m
.71324 .41267 L
s
.752 .239 .103 r
.46032 .64452 m .4671 .64547 L .45231 .64765 L p F P
0 0 0 r
s
.752 .239 .103 r
.45231 .64765 m .44246 .64627 L .46032 .64452 L p F P
0 0 0 r
s
.347 .077 .032 r
.56755 .35898 m .55024 .35584 L .55611 .36354 L p F P
0 0 0 r
s
.347 .077 .032 r
.55611 .36354 m .57543 .36703 L .56755 .35898 L p F P
0 0 0 r
s
.24 .056 .023 r
.45239 .33541 m .43703 .33262 L .42673 .33343 L p F P
0 0 0 r
s
.24 .35 .67 r
.44967 .33167 m
.45956 .30375 L
s
.4492 .33299 m
.44967 .33167 L
s
.24 .056 .023 r
.42673 .33343 m .44463 .33667 L .45239 .33541 L p F P
0 0 0 r
s
.136 .2 .437 r
.67677 .41049 m .68418 .39711 L .6705 .38419 L p F P
0 0 0 r
s
.49 .12 .049 r
.6705 .38419 m .65168 .38079 L .66389 .39347 L p F P
0 0 0 r
s
.49 .12 .049 r
.66389 .39347 m .68418 .39711 L .6705 .38419 L p F P
0 0 0 r
s
.83 .24 .1 r
.67643 .38979 m
.70715 .39532 L
s
.24 .35 .67 r
.67414 .38852 m
.68616 .36635 L
s
.67073 .39482 m
.67079 .39471 L
s
.323 .486 .92 r
.58588 .6238 m .58193 .63062 L .56395 .63558 L p F P
0 0 0 r
s
.323 .486 .92 r
.561 .64081 m .56395 .63558 L .58193 .63062 L p F P
0 0 0 r
s
.067 .097 .237 r
.67407 .47251 m .68183 .45913 L .67785 .44044 L p F P
0 0 0 r
s
.049 .072 .169 r
.68183 .45913 m .67407 .47251 L .67348 .49234 L p F P
0 0 0 r
s
.752 .239 .103 r
.45353 .64356 m .46032 .64452 L .44246 .64627 L p F P
0 0 0 r
s
.752 .239 .103 r
.44246 .64627 m .43257 .64489 L .45353 .64356 L p F P
0 0 0 r
s
.24 .35 .67 r
.43123 .66085 m
.43814 .64547 L
s
.319 .48 .919 r
.561 .64081 m .55807 .646 L .54004 .64433 L p F P
0 0 0 r
s
.319 .48 .919 r
.5381 .64788 m .54004 .64433 L .55807 .646 L p F P
0 0 0 r
s
.24 .35 .67 r
.43356 .31292 m
.45956 .30375 L
s
.47038 .27323 m
.45956 .30375 L
s
.56155 .27632 m
.59205 .28698 L
s
.60579 .25608 m
.59205 .28698 L
s
.59205 .28698 m
.62076 .30189 L
s
.83 .24 .1 r
.39858 .32722 m
.35499 .31931 L
s
.098 .143 .332 r
.67785 .44044 m .68556 .42686 L .67677 .41049 L p F P
0 0 0 r
s
.067 .097 .237 r
.68556 .42686 m .67785 .44044 L .68183 .45913 L p F P
0 0 0 r
s
.098 .143 .332 r
.68418 .39711 m .67677 .41049 L .68556 .42686 L p F P
0 0 0 r
s
.24 .35 .67 r
.66707 .44716 m
.68225 .42014 L
s
.67073 .39482 m
.68225 .42014 L
s
.33 .49 .916 r
.40483 .34226 m .40875 .33016 L .42159 .32981 L p F P
0 0 0 r
s
.24 .056 .023 r
.43703 .33262 m .42159 .32981 L .40875 .33016 L p F P
0 0 0 r
s
.24 .35 .67 r
.42749 .33089 m
.42769 .33029 L
s
.24 .056 .023 r
.40875 .33016 m .42673 .33343 L .43703 .33262 L p F P
0 0 0 r
s
.24 .35 .67 r
.42769 .33029 m
.43356 .31292 L
s
.347 .077 .032 r
.55024 .35584 m .53285 .35268 L .5367 .36003 L p F P
0 0 0 r
s
.83 .24 .1 r
.53251 .35419 m
.53376 .35442 L
s
.347 .077 .032 r
.5367 .36003 m .55611 .36354 L .55024 .35584 L p F P
0 0 0 r
s
.752 .239 .103 r
.44672 .64261 m .45353 .64356 L .43257 .64489 L p F P
0 0 0 r
s
.752 .239 .103 r
.43257 .64489 m .42267 .6435 L .44672 .64261 L p F P
0 0 0 r
s
.163 .246 .524 r
.37662 .6081 m .37979 .5997 L .36361 .58541 L p F P
0 0 0 r
s
.163 .246 .524 r
.36712 .57559 m .36361 .58541 L .37979 .5997 L p F P
0 0 0 r
s
.125 .189 .421 r
.36361 .58541 m .36712 .57559 L .35483 .55834 L p F P
0 0 0 r
s
.24 .35 .67 r
.3548 .55816 m
.35519 .55885 L
s
.63514 .27128 m
.62076 .30189 L
s
.62076 .30189 m
.64665 .32053 L
s
.49 .12 .049 r
.65168 .38079 m .63277 .37738 L .64348 .38982 L p F P
0 0 0 r
s
.49 .12 .049 r
.64348 .38982 m .66389 .39347 L .65168 .38079 L p F P
0 0 0 r
s
.194 .292 .608 r
.39378 .62551 m .39653 .61863 L .37662 .6081 L p F P
0 0 0 r
s
.194 .292 .608 r
.37979 .5997 m .37662 .6081 L .39653 .61863 L p F P
0 0 0 r
s
.125 .189 .421 r
.35862 .54724 m .35483 .55834 L .36712 .57559 L p F P
0 0 0 r
s
.085 .126 .306 r
.35483 .55834 m .35862 .54724 L .3503 .52798 L p F P
0 0 0 r
s
.83 .24 .1 r
.81616 .64023 m
.80387 .6622 L
s
.80387 .6622 m
.76258 .65622 L
s
.318 .471 .867 r
.38529 .37462 m .38939 .36166 L .40098 .35415 L p F P
0 0 0 r
s
.318 .471 .867 r
.40483 .34226 m .40098 .35415 L .38939 .36166 L p F P
0 0 0 r
s
.24 .35 .67 r
.53035 .27032 m
.56155 .27632 L
s
.57464 .24514 m
.56155 .27632 L
s
.752 .239 .103 r
.4399 .64165 m .44672 .64261 L .42267 .6435 L p F P
0 0 0 r
s
.752 .239 .103 r
.42267 .6435 m .41273 .64211 L .4399 .64165 L p F P
0 0 0 r
s
.24 .35 .67 r
.43814 .64547 m
.43957 .64229 L
s
.911 .279 .12 r
.51421 .64388 m .51764 .64436 L .53426 .65491 L p F P
0 0 0 r
s
.24 .35 .67 r
.53313 .65475 m
.53332 .65439 L
s
.911 .279 .12 r
.53426 .65491 m .5276 .65397 L .51421 .64388 L p F P
0 0 0 r
s
.309 .465 .9 r
.53618 .6514 m .53426 .65491 L .51764 .64436 L p F P
0 0 0 r
s
.24 .35 .67 r
.53579 .65126 m
.53633 .65112 L
s
.347 .077 .032 r
.53285 .35268 m .51537 .34951 L .51718 .35651 L p F P
0 0 0 r
s
.347 .077 .032 r
.51718 .35651 m .5367 .36003 L .53285 .35268 L p F P
0 0 0 r
s
.83 .24 .1 r
.7965 .42747 m
.75512 .42011 L
s
.7965 .42747 m
.80156 .45065 L
s
.252 .38 .679 r
.6273 .58298 m .63317 .57312 L .64552 .5556 L p F P
0 0 0 r
s
.295 .444 .814 r
.63317 .57312 m .6273 .58298 L .61217 .59759 L p F P
0 0 0 r
s
.24 .35 .67 r
.62164 .58947 m
.62306 .58707 L
s
.295 .444 .814 r
.6072 .60602 m .61217 .59759 L .6273 .58298 L p F P
0 0 0 r
s
.83 .24 .1 r
.67853 .64405 m
.66731 .6606 L
s
.66731 .6606 m
.62515 .6546 L
s
.911 .279 .12 r
.51077 .64339 m .51421 .64388 L .5276 .65397 L p F P
0 0 0 r
s
.911 .279 .12 r
.5276 .65397 m .52093 .65303 L .51077 .64339 L p F P
0 0 0 r
s
.085 .126 .306 r
.35431 .51578 m .3503 .52798 L .35862 .54724 L p F P
0 0 0 r
s
.065 .095 .231 r
.3503 .52798 m .35431 .51578 L .34996 .49556 L p F P
0 0 0 r
s
.243 .365 .736 r
.41494 .63689 m .41273 .64211 L .4399 .64165 L p F P
0 0 0 r
s
.317 .477 .891 r
.61217 .59759 m .6072 .60602 L .58987 .6169 L p F P
0 0 0 r
s
.317 .477 .891 r
.58588 .6238 m .58987 .6169 L .6072 .60602 L p F P
0 0 0 r
s
.83 .24 .1 r
.22115 .295 m
.21992 .29906 L
s
.21684 .61362 m
.21571 .61131 L
s
.21571 .61131 m
.1709 .60502 L
s
.22 .332 .677 r
.41494 .63689 m .41718 .63161 L .39378 .62551 L p F P
0 0 0 r
s
.83 .24 .1 r
.3508 .63239 m
.39443 .6385 L
s
.39443 .6385 m
.40015 .63449 L
s
.22 .332 .677 r
.39653 .61863 m .39378 .62551 L .41718 .63161 L p F P
0 0 0 r
s
.49 .12 .049 r
.63277 .37738 m .61375 .37395 L .62296 .38614 L p F P
0 0 0 r
s
.49 .12 .049 r
.62296 .38614 m .64348 .38982 L .63277 .37738 L p F P
0 0 0 r
s
.024 .035 .067 r
.64552 .5556 m .65218 .54445 L .66115 .52497 L p F P
0 0 0 r
s
.252 .38 .679 r
.65218 .54445 m .64552 .5556 L .63317 .57312 L p F P
0 0 0 r
s
.911 .279 .12 r
.50732 .6429 m .51077 .64339 L .52093 .65303 L p F P
0 0 0 r
s
.911 .279 .12 r
.52093 .65303 m .51424 .65209 L .50732 .6429 L p F P
0 0 0 r
s
.24 .35 .67 r
.50423 .65298 m
.52045 .65219 L
s
.52045 .65219 m
.5237 .65203 L
s
.319 .48 .919 r
.56395 .63558 m .561 .64081 L .54199 .64076 L p F P
0 0 0 r
s
.319 .48 .919 r
.54004 .64433 m .54199 .64076 L .561 .64081 L p F P
0 0 0 r
s
.911 .279 .12 r
.50388 .64242 m .50732 .6429 L .51424 .65209 L p F P
0 0 0 r
s
.911 .279 .12 r
.51424 .65209 m .50754 .65115 L .50388 .64242 L p F P
0 0 0 r
s
.24 .35 .67 r
.66166 .29022 m
.64665 .32053 L
s
.64665 .32053 m
.66875 .34227 L
s
.347 .077 .032 r
.51537 .34951 m .49781 .34632 L .49755 .35297 L p F P
0 0 0 r
s
.347 .077 .032 r
.49755 .35297 m .51718 .35651 L .51537 .34951 L p F P
0 0 0 r
s
.065 .095 .231 r
.35412 .48251 m .34996 .49556 L .35431 .51578 L p F P
0 0 0 r
s
.24 .35 .67 r
.35138 .48276 m
.35179 .48982 L
s
.045 .065 .149 r
.34996 .49556 m .35412 .48251 L .35362 .46248 L p F P
0 0 0 r
s
.323 .486 .92 r
.58987 .6169 m .58588 .6238 L .56694 .63029 L p F P
0 0 0 r
s
.323 .486 .92 r
.56395 .63558 m .56694 .63029 L .58588 .6238 L p F P
0 0 0 r
s
.309 .465 .9 r
.5381 .64788 m .53618 .6514 L .5186 .64255 L p F P
0 0 0 r
s
.24 .35 .67 r
.53516 .65102 m
.53522 .65092 L
s
.309 .465 .9 r
.51764 .64436 m .5186 .64255 L .53618 .6514 L p F P
0 0 0 r
s
.83 .24 .1 r
.53367 .64904 m
.53461 .64794 L
s
.028 .04 .082 r
.66115 .52497 m .66844 .51271 L .67348 .49234 L p F P
0 0 0 r
s
.024 .035 .067 r
.66844 .51271 m .66115 .52497 L .65218 .54445 L p F P
0 0 0 r
s
.911 .279 .12 r
.50043 .64193 m .50388 .64242 L .50754 .65115 L p F P
0 0 0 r
s
.911 .279 .12 r
.50754 .65115 m .50084 .65021 L .50043 .64193 L p F P
0 0 0 r
s
.83 .24 .1 r
.35499 .31931 m
.3109 .3113 L
s
.35499 .31931 m
.35783 .32253 L
s
.24 .35 .67 r
.49958 .26924 m
.53035 .27032 L
s
.5428 .23886 m
.53035 .27032 L
s
.288 .426 .769 r
.37176 .40046 m .37601 .38686 L .38529 .37462 L p F P
0 0 0 r
s
.288 .426 .769 r
.38939 .36166 m .38529 .37462 L .37601 .38686 L p F P
0 0 0 r
s
.83 .24 .1 r
.35569 .62824 m
.3508 .63239 L
s
.3508 .63239 m
.30667 .62621 L
s
.49 .12 .049 r
.61375 .37395 m .59464 .3705 L .60232 .38245 L p F P
0 0 0 r
s
.49 .12 .049 r
.60232 .38245 m .62296 .38614 L .61375 .37395 L p F P
0 0 0 r
s
.911 .279 .12 r
.49698 .64144 m .50043 .64193 L .50084 .65021 L p F P
0 0 0 r
s
.911 .279 .12 r
.50084 .65021 m .49411 .64927 L .49698 .64144 L p F P
0 0 0 r
s
.024 .035 .067 r
.35362 .46248 m .35789 .44888 L .36103 .43026 L p F P
0 0 0 r
s
.045 .065 .149 r
.35789 .44888 m .35362 .46248 L .35412 .48251 L p F P
0 0 0 r
s
.83 .24 .1 r
.77439 .63404 m
.76258 .65622 L
s
.76258 .65622 m
.7208 .65017 L
s
.347 .077 .032 r
.49781 .34632 m .48017 .34312 L .47783 .3494 L p F P
0 0 0 r
s
.347 .077 .032 r
.47783 .3494 m .49755 .35297 L .49781 .34632 L p F P
0 0 0 r
s
.911 .279 .12 r
.49352 .64095 m .49698 .64144 L .49411 .64927 L p F P
0 0 0 r
s
.911 .279 .12 r
.49411 .64927 m .48738 .64832 L .49352 .64095 L p F P
0 0 0 r
s
.83 .24 .1 r
.48751 .64679 m
.48854 .64693 L
s
.48512 .648 m
.48751 .64679 L
s
.049 .072 .169 r
.67348 .49234 m .6812 .47922 L .68183 .45913 L p F P
0 0 0 r
s
.028 .04 .082 r
.6812 .47922 m .67348 .49234 L .66844 .51271 L p F P
0 0 0 r
s
.24 .35 .67 r
.6562 .5234 m
.67118 .49797 L
s
.67118 .49797 m
.67229 .47279 L
s
.238 .35 .612 r
.36103 .43026 m .36533 .41646 L .37176 .40046 L p F P
0 0 0 r
s
.238 .35 .612 r
.37601 .38686 m .37176 .40046 L .36533 .41646 L p F P
0 0 0 r
s
.24 .35 .67 r
.37577 .40276 m
.38467 .37464 L
s
.243 .365 .736 r
.4399 .64165 m .44151 .63806 L .41494 .63689 L p F P
0 0 0 r
s
.243 .365 .736 r
.41718 .63161 m .41494 .63689 L .44151 .63806 L p F P
0 0 0 r
s
.024 .035 .067 r
.36533 .41646 m .36103 .43026 L .35789 .44888 L p F P
0 0 0 r
s
.24 .35 .67 r
.35937 .44941 m
.36444 .42469 L
s
.911 .279 .12 r
.49006 .64046 m .49352 .64095 L .48738 .64832 L p F P
0 0 0 r
s
.911 .279 .12 r
.48738 .64832 m .48063 .64737 L .49006 .64046 L p F P
0 0 0 r
s
.83 .24 .1 r
.75512 .42011 m
.71324 .41267 L
s
.75512 .42011 m
.75962 .44333 L
s
.63577 .63786 m
.62515 .6546 L
s
.62515 .6546 m
.58251 .64853 L
s
.309 .465 .9 r
.54004 .64433 m .5381 .64788 L .51956 .64072 L p F P
0 0 0 r
s
.24 .35 .67 r
.53703 .64759 m
.53709 .64749 L
s
.309 .465 .9 r
.5186 .64255 m .51956 .64072 L .5381 .64788 L p F P
0 0 0 r
s
.194 .292 .608 r
.39653 .61863 m .39932 .61166 L .37979 .5997 L p F P
0 0 0 r
s
.194 .292 .608 r
.38301 .59116 m .37979 .5997 L .39932 .61166 L p F P
0 0 0 r
s
.163 .246 .524 r
.37979 .5997 m .38301 .59116 L .36712 .57559 L p F P
0 0 0 r
s
.49 .12 .049 r
.59464 .3705 m .57543 .36703 L .58157 .37873 L p F P
0 0 0 r
s
.49 .12 .049 r
.58157 .37873 m .60232 .38245 L .59464 .3705 L p F P
0 0 0 r
s
.83 .24 .1 r
.1709 .60502 m
.17113 .60722 L
s
.319 .48 .919 r
.56694 .63029 m .56395 .63558 L .54396 .63716 L p F P
0 0 0 r
s
.319 .48 .919 r
.54199 .64076 m .54396 .63716 L .56395 .63558 L p F P
0 0 0 r
s
.911 .279 .12 r
.4866 .63997 m .49006 .64046 L .48063 .64737 L p F P
0 0 0 r
s
.911 .279 .12 r
.48063 .64737 m .47387 .64642 L .4866 .63997 L p F P
0 0 0 r
s
.163 .246 .524 r
.3707 .56559 m .36712 .57559 L .38301 .59116 L p F P
0 0 0 r
s
.125 .189 .421 r
.36712 .57559 m .3707 .56559 L .35862 .54724 L p F P
0 0 0 r
s
.347 .077 .032 r
.48017 .34312 m .46244 .33991 L .45799 .34582 L p F P
0 0 0 r
s
.347 .077 .032 r
.45799 .34582 m .47783 .3494 L .48017 .34312 L p F P
0 0 0 r
s
.067 .097 .237 r
.68183 .45913 m .68975 .44545 L .68556 .42686 L p F P
0 0 0 r
s
.049 .072 .169 r
.68975 .44545 m .68183 .45913 L .6812 .47922 L p F P
0 0 0 r
s
.22 .332 .677 r
.41718 .63161 m .41944 .62629 L .39653 .61863 L p F P
0 0 0 r
s
.22 .332 .677 r
.39932 .61166 m .39653 .61863 L .41944 .62629 L p F P
0 0 0 r
s
.911 .279 .12 r
.48313 .63948 m .4866 .63997 L .47387 .64642 L p F P
0 0 0 r
s
.911 .279 .12 r
.47387 .64642 m .4671 .64547 L .48313 .63948 L p F P
0 0 0 r
s
.318 .471 .867 r
.38939 .36166 m .39358 .34845 L .40483 .34226 L p F P
0 0 0 r
s
.24 .35 .67 r
.38467 .37464 m
.40179 .35629 L
s
.318 .471 .867 r
.40875 .33016 m .40483 .34226 L .39358 .34845 L p F P
0 0 0 r
s
.24 .35 .67 r
.50423 .65298 m
.50895 .64384 L
s
.47251 .64853 m
.50423 .65298 L
s
.41134 .32689 m
.43356 .31292 L
s
.44391 .28227 m
.43356 .31292 L
s
.098 .143 .332 r
.68556 .42686 m .69344 .41298 L .68418 .39711 L p F P
0 0 0 r
s
.635 .165 .068 r
.68418 .39711 m .66389 .39347 L .67215 .40921 L p F P
0 0 0 r
s
.635 .165 .068 r
.67215 .40921 m .69344 .41298 L .68418 .39711 L p F P
0 0 0 r
s
.24 .35 .67 r
.6893 .4076 m
.69031 .40581 L
s
.69031 .40581 m
.69811 .39193 L
s
.83 .24 .1 r
.84301 .45788 m
.80156 .45065 L
s
.84301 .45788 m
.84581 .48576 L
s
.067 .097 .237 r
.69344 .41298 m .68556 .42686 L .68975 .44545 L p F P
0 0 0 r
s
.24 .35 .67 r
.68225 .42014 m
.68693 .41183 L
s
.295 .444 .814 r
.61217 .59759 m .61722 .58902 L .63317 .57312 L p F P
0 0 0 r
s
.317 .477 .891 r
.61722 .58902 m .61217 .59759 L .59392 .60991 L p F P
0 0 0 r
s
.317 .477 .891 r
.58987 .6169 m .59392 .60991 L .61217 .59759 L p F P
0 0 0 r
s
.125 .189 .421 r
.36248 .53592 m .35862 .54724 L .3707 .56559 L p F P
0 0 0 r
s
.085 .126 .306 r
.35862 .54724 m .36248 .53592 L .35431 .51578 L p F P
0 0 0 r
s
.911 .279 .12 r
.47967 .63899 m .48313 .63948 L .4671 .64547 L p F P
0 0 0 r
s
.911 .279 .12 r
.4671 .64547 m .46032 .64452 L .47967 .63899 L p F P
0 0 0 r
s
.24 .35 .67 r
.68434 .31224 m
.66875 .34227 L
s
.66875 .34227 m
.68616 .36635 L
s
.83 .24 .1 r
.3109 .3113 m
.26629 .3032 L
s
.3109 .3113 m
.31285 .31438 L
s
.49 .12 .049 r
.57543 .36703 m .55611 .36354 L .56069 .37499 L p F P
0 0 0 r
s
.49 .12 .049 r
.56069 .37499 m .58157 .37873 L .57543 .36703 L p F P
0 0 0 r
s
.323 .486 .92 r
.59392 .60991 m .58987 .6169 L .56995 .62495 L p F P
0 0 0 r
s
.323 .486 .92 r
.56694 .63029 m .56995 .62495 L .58987 .6169 L p F P
0 0 0 r
s
.252 .38 .679 r
.63317 .57312 m .63915 .56308 L .65218 .54445 L p F P
0 0 0 r
s
.295 .444 .814 r
.63915 .56308 m .63317 .57312 L .61722 .58902 L p F P
0 0 0 r
s
.24 .35 .67 r
.63296 .5704 m
.63457 .56769 L
s
.83 .24 .1 r
.31071 .62191 m
.30667 .62621 L
s
.30667 .62621 m
.26202 .61995 L
s
.347 .077 .032 r
.46244 .33991 m .44463 .33667 L .43805 .34222 L p F P
0 0 0 r
s
.83 .24 .1 r
.4435 .33647 m
.44422 .33702 L
s
.347 .077 .032 r
.43805 .34222 m .45799 .34582 L .46244 .33991 L p F P
0 0 0 r
s
.911 .279 .12 r
.47619 .63849 m .47967 .63899 L .46032 .64452 L p F P
0 0 0 r
s
.911 .279 .12 r
.46032 .64452 m .45353 .64356 L .47619 .63849 L p F P
0 0 0 r
s
.309 .465 .9 r
.54199 .64076 m .54004 .64433 L .52052 .63889 L p F P
0 0 0 r
s
.24 .35 .67 r
.53892 .64413 m
.53897 .64403 L
s
.309 .465 .9 r
.51956 .64072 m .52052 .63889 L .54004 .64433 L p F P
0 0 0 r
s
.83 .24 .1 r
.53461 .64794 m
.53936 .64239 L
s
.24 .35 .67 r
.47038 .27323 m
.49958 .26924 L
s
.51143 .23754 m
.49958 .26924 L
s
.911 .279 .12 r
.47272 .638 m .47619 .63849 L .45353 .64356 L p F P
0 0 0 r
s
.911 .279 .12 r
.45353 .64356 m .44672 .64261 L .47272 .638 L p F P
0 0 0 r
s
.83 .24 .1 r
.73213 .62778 m
.7208 .65017 L
s
.7208 .65017 m
.67853 .64405 L
s
.243 .365 .736 r
.44151 .63806 m .44314 .63444 L .41718 .63161 L p F P
0 0 0 r
s
.243 .365 .736 r
.41944 .62629 m .41718 .63161 L .44314 .63444 L p F P
0 0 0 r
s
.635 .165 .068 r
.66389 .39347 m .64348 .38982 L .65074 .40541 L p F P
0 0 0 r
s
.635 .165 .068 r
.65074 .40541 m .67215 .40921 L .66389 .39347 L p F P
0 0 0 r
s
.085 .126 .306 r
.3584 .50333 m .35431 .51578 L .36248 .53592 L p F P
0 0 0 r
s
.24 .35 .67 r
.35427 .50788 m
.35555 .51201 L
s
.065 .095 .231 r
.35431 .51578 m .3584 .50333 L .35412 .48251 L p F P
0 0 0 r
s
.024 .035 .067 r
.65218 .54445 m .65896 .53307 L .66844 .51271 L p F P
0 0 0 r
s
.252 .38 .679 r
.65896 .53307 m .65218 .54445 L .63915 .56308 L p F P
0 0 0 r
s
.24 .35 .67 r
.63457 .56769 m
.64853 .54685 L
s
.911 .279 .12 r
.46924 .63751 m .47272 .638 L .44672 .64261 L p F P
0 0 0 r
s
.911 .279 .12 r
.44672 .64261 m .4399 .64165 L .46924 .63751 L p F P
0 0 0 r
s
.83 .24 .1 r
.44409 .64068 m
.44543 .64087 L
s
.44324 .64118 m
.44409 .64068 L
s
.40015 .63449 m
.43649 .63961 L
s
.44056 .64018 m
.44409 .64068 L
s
.49 .12 .049 r
.55611 .36354 m .5367 .36003 L .5397 .37123 L p F P
0 0 0 r
s
.49 .12 .049 r
.5397 .37123 m .56069 .37499 L .55611 .36354 L p F P
0 0 0 r
s
.319 .48 .919 r
.56995 .62495 m .56694 .63029 L .54594 .63354 L p F P
0 0 0 r
s
.319 .48 .919 r
.54396 .63716 m .54594 .63354 L .56694 .63029 L p F P
0 0 0 r
s
.83 .24 .1 r
.69095 .40871 m
.71324 .41267 L
s
.71324 .41267 m
.71718 .43592 L
s
.82705 .61323 m
.81616 .64023 L
s
.81616 .64023 m
.77439 .63404 L
s
.347 .077 .032 r
.44463 .33667 m .42673 .33343 L .41801 .3386 L p F P
0 0 0 r
s
.347 .077 .032 r
.41801 .3386 m .43805 .34222 L .44463 .33667 L p F P
0 0 0 r
s
.24 .35 .67 r
.47251 .64853 m
.47697 .63931 L
s
.4561 .64314 m
.47251 .64853 L
s
.4528 .64206 m
.4561 .64314 L
s
.83 .24 .1 r
.59249 .63159 m
.58251 .64853 L
s
.53936 .64239 m
.58251 .64853 L
s
.263 .395 .787 r
.44151 .63806 m .4399 .64165 L .46924 .63751 L p F P
0 0 0 r
s
.288 .426 .769 r
.37601 .38686 m .38035 .37298 L .38939 .36166 L p F P
0 0 0 r
s
.288 .426 .769 r
.39358 .34845 m .38939 .36166 L .38035 .37298 L p F P
0 0 0 r
s
.309 .465 .9 r
.54396 .63716 m .54199 .64076 L .52148 .63705 L p F P
0 0 0 r
s
.24 .35 .67 r
.54081 .64065 m
.54087 .64055 L
s
.309 .465 .9 r
.52052 .63889 m .52148 .63705 L .54199 .64076 L p F P
0 0 0 r
s
.065 .095 .231 r
.35838 .46917 m .35412 .48251 L .3584 .50333 L p F P
0 0 0 r
s
.045 .065 .149 r
.35412 .48251 m .35838 .46917 L .35789 .44888 L p F P
0 0 0 r
s
.24 .35 .67 r
.35801 .45374 m
.35937 .44941 L
s
.028 .04 .082 r
.66844 .51271 m .67588 .50019 L .6812 .47922 L p F P
0 0 0 r
s
.024 .035 .067 r
.67588 .50019 m .66844 .51271 L .65896 .53307 L p F P
0 0 0 r
s
.635 .165 .068 r
.64348 .38982 m .62296 .38614 L .6292 .4016 L p F P
0 0 0 r
s
.635 .165 .068 r
.6292 .4016 m .65074 .40541 L .64348 .38982 L p F P
0 0 0 r
s
.22 .332 .677 r
.41944 .62629 m .42172 .62091 L .39932 .61166 L p F P
0 0 0 r
s
.22 .332 .677 r
.40214 .6046 m .39932 .61166 L .42172 .62091 L p F P
0 0 0 r
s
.194 .292 .608 r
.39932 .61166 m .40214 .6046 L .38301 .59116 L p F P
0 0 0 r
s
.83 .24 .1 r
.80156 .45065 m
.75962 .44333 L
s
.80156 .45065 m
.80392 .47861 L
s
.194 .292 .608 r
.38628 .58249 m .38301 .59116 L .40214 .6046 L p F P
0 0 0 r
s
.163 .246 .524 r
.38301 .59116 m .38628 .58249 L .3707 .56559 L p F P
0 0 0 r
s
.318 .471 .867 r
.39358 .34845 m .39785 .33496 L .40875 .33016 L p F P
0 0 0 r
s
.347 .077 .032 r
.42673 .33343 m .40875 .33016 L .39785 .33496 L p F P
0 0 0 r
s
.83 .24 .1 r
.40227 .33059 m
.40618 .3313 L
s
.39858 .32722 m
.40227 .33059 L
s
.24 .35 .67 r
.4101 .3307 m
.41015 .33055 L
s
.41015 .33055 m
.41134 .32689 L
s
.347 .077 .032 r
.39785 .33496 m .41801 .3386 L .42673 .33343 L p F P
0 0 0 r
s
.24 .35 .67 r
.40179 .35629 m
.40812 .33682 L
s
.49 .12 .049 r
.5367 .36003 m .51718 .35651 L .51859 .36745 L p F P
0 0 0 r
s
.49 .12 .049 r
.51859 .36745 m .5397 .37123 L .5367 .36003 L p F P
0 0 0 r
s
.83 .24 .1 r
.26629 .3032 m
.22115 .295 L
s
.26629 .3032 m
.26734 .30613 L
s
.26519 .6155 m
.26202 .61995 L
s
.26202 .61995 m
.21684 .61362 L
s
.024 .035 .067 r
.35789 .44888 m .36226 .43497 L .36533 .41646 L p F P
0 0 0 r
s
.045 .065 .149 r
.36226 .43497 m .35789 .44888 L .35838 .46917 L p F P
0 0 0 r
s
.243 .365 .736 r
.44314 .63444 m .44478 .6308 L .41944 .62629 L p F P
0 0 0 r
s
.243 .365 .736 r
.42172 .62091 m .41944 .62629 L .44478 .6308 L p F P
0 0 0 r
s
.317 .477 .891 r
.59392 .60991 m .59802 .60282 L .61722 .58902 L p F P
0 0 0 r
s
.323 .486 .92 r
.59802 .60282 m .59392 .60991 L .573 .61956 L p F P
0 0 0 r
s
.323 .486 .92 r
.56995 .62495 m .573 .61956 L .59392 .60991 L p F P
0 0 0 r
s
.263 .395 .787 r
.46924 .63751 m .47012 .63567 L .44151 .63806 L p F P
0 0 0 r
s
.263 .395 .787 r
.44314 .63444 m .44151 .63806 L .47012 .63567 L p F P
0 0 0 r
s
.163 .246 .524 r
.37434 .55541 m .3707 .56559 L .38628 .58249 L p F P
0 0 0 r
s
.125 .189 .421 r
.3707 .56559 m .37434 .55541 L .36248 .53592 L p F P
0 0 0 r
s
.238 .35 .612 r
.36533 .41646 m .36972 .40235 L .37601 .38686 L p F P
0 0 0 r
s
.238 .35 .612 r
.38035 .37298 m .37601 .38686 L .36972 .40235 L p F P
0 0 0 r
s
.24 .35 .67 r
.37321 .39668 m
.38467 .37464 L
s
.295 .444 .814 r
.61722 .58902 m .62234 .58031 L .63915 .56308 L p F P
0 0 0 r
s
.317 .477 .891 r
.62234 .58031 m .61722 .58902 L .59802 .60282 L p F P
0 0 0 r
s
.049 .072 .169 r
.6812 .47922 m .6891 .46581 L .68975 .44545 L p F P
0 0 0 r
s
.24 .35 .67 r
.68225 .42014 m
.68777 .44602 L
s
.028 .04 .082 r
.6891 .46581 m .6812 .47922 L .67588 .50019 L p F P
0 0 0 r
s
.24 .35 .67 r
.67229 .47279 m
.68777 .44602 L
s
.83 .24 .1 r
.68937 .62144 m
.67853 .64405 L
s
.67853 .64405 m
.63577 .63786 L
s
.635 .165 .068 r
.62296 .38614 m .60232 .38245 L .60753 .39776 L p F P
0 0 0 r
s
.635 .165 .068 r
.60753 .39776 m .6292 .4016 L .62296 .38614 L p F P
0 0 0 r
s
.024 .035 .067 r
.36972 .40235 m .36533 .41646 L .36226 .43497 L p F P
0 0 0 r
s
.24 .35 .67 r
.36507 .42269 m
.37321 .39668 L
s
.309 .465 .9 r
.54594 .63354 m .54396 .63716 L .52245 .63521 L p F P
0 0 0 r
s
.24 .35 .67 r
.54272 .63715 m
.54278 .63705 L
s
.309 .465 .9 r
.52148 .63705 m .52245 .63521 L .54396 .63716 L p F P
0 0 0 r
s
.982 .295 .126 r
.51764 .64436 m .51421 .64388 L .5 .62969 L closepath p F P
0 0 0 r
s
.296 .445 .87 r
.5 .62969 m .5186 .64255 L .51764 .64436 L closepath p F P
0 0 0 r
s
.319 .48 .919 r
.573 .61956 m .56995 .62495 L .54793 .62989 L p F P
0 0 0 r
s
.319 .48 .919 r
.54594 .63354 m .54793 .62989 L .56995 .62495 L p F P
0 0 0 r
s
.49 .12 .049 r
.51718 .35651 m .49755 .35297 L .49735 .36364 L p F P
0 0 0 r
s
.49 .12 .049 r
.49735 .36364 m .51859 .36745 L .51718 .35651 L p F P
0 0 0 r
s
.982 .295 .126 r
.51421 .64388 m .51077 .64339 L .5 .62969 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.70229 .3366 m
.68616 .36635 L
s
.68616 .36635 m
.69811 .39193 L
s
.83 .24 .1 r
.35783 .32253 m
.40227 .33059 L
s
.40227 .33059 m
.4028 .33279 L
s
.40015 .63449 m
.40681 .62353 L
s
.40015 .63449 m
.35569 .62824 L
s
.982 .295 .126 r
.51077 .64339 m .50732 .6429 L .5 .62969 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.78494 .60682 m
.77439 .63404 L
s
.77439 .63404 m
.73213 .62778 L
s
.52191 .6399 m
.53936 .64239 L
s
.252 .38 .679 r
.63915 .56308 m .64523 .55285 L .65896 .53307 L p F P
0 0 0 r
s
.295 .444 .814 r
.64523 .55285 m .63915 .56308 L .62234 .58031 L p F P
0 0 0 r
s
.982 .295 .126 r
.50732 .6429 m .50388 .64242 L .5 .62969 L closepath p F P
0 0 0 r
s
.067 .097 .237 r
.68975 .44545 m .69786 .43146 L .69344 .41298 L p F P
0 0 0 r
s
.049 .072 .169 r
.69786 .43146 m .68975 .44545 L .6891 .46581 L p F P
0 0 0 r
s
.296 .445 .87 r
.5 .62969 m .51956 .64072 L .5186 .64255 L closepath p F P
0 0 0 r
s
.125 .189 .421 r
.36643 .52438 m .36248 .53592 L .37434 .55541 L p F P
0 0 0 r
s
.24 .35 .67 r
.36183 .53074 m
.36335 .53338 L
s
.37301 .55022 m
.37566 .55483 L
s
.085 .126 .306 r
.36248 .53592 m .36643 .52438 L .3584 .50333 L p F P
0 0 0 r
s
.982 .295 .126 r
.50388 .64242 m .50043 .64193 L .5 .62969 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.84581 .48576 m
.80392 .47861 L
s
.84581 .48576 m
.84555 .51698 L
s
.24 .35 .67 r
.44391 .28227 m
.47038 .27323 L
s
.48168 .24133 m
.47038 .27323 L
s
.982 .295 .126 r
.50043 .64193 m .49698 .64144 L .5 .62969 L closepath p F P
0 0 0 r
s
.263 .395 .787 r
.47012 .63567 m .471 .63382 L .44314 .63444 L p F P
0 0 0 r
s
.263 .395 .787 r
.44478 .6308 m .44314 .63444 L .471 .63382 L p F P
0 0 0 r
s
.24 .35 .67 r
.57464 .24514 m
.60579 .25608 L
s
.62014 .22379 m
.60579 .25608 L
s
.60579 .25608 m
.63514 .27128 L
s
.731 .196 .081 r
.69344 .41298 m .67215 .40921 L .6761 .42766 L p F P
0 0 0 r
s
.731 .196 .081 r
.6761 .42766 m .69786 .43146 L .69344 .41298 L p F P
0 0 0 r
s
.635 .165 .068 r
.60232 .38245 m .58157 .37873 L .58573 .3939 L p F P
0 0 0 r
s
.635 .165 .068 r
.58573 .3939 m .60753 .39776 L .60232 .38245 L p F P
0 0 0 r
s
.982 .295 .126 r
.49698 .64144 m .49352 .64095 L .5 .62969 L closepath p F P
0 0 0 r
s
.49 .12 .049 r
.49755 .35297 m .47783 .3494 L .476 .35982 L p F P
0 0 0 r
s
.49 .12 .049 r
.476 .35982 m .49735 .36364 L .49755 .35297 L p F P
0 0 0 r
s
.982 .295 .126 r
.49352 .64095 m .49006 .64046 L .5 .62969 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.75962 .44333 m
.71718 .43592 L
s
.75962 .44333 m
.76154 .47138 L
s
.24 .35 .67 r
.4057 .33285 m
.41134 .32689 L
s
.42132 .29617 m
.41134 .32689 L
s
.309 .465 .9 r
.54793 .62989 m .54594 .63354 L .52342 .63336 L p F P
0 0 0 r
s
.24 .35 .67 r
.54465 .63363 m
.5447 .63353 L
s
.54658 .63008 m
.54743 .62852 L
s
.309 .465 .9 r
.52245 .63521 m .52342 .63336 L .54594 .63354 L p F P
0 0 0 r
s
.296 .445 .87 r
.5 .62969 m .52052 .63889 L .51956 .64072 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.65017 .2393 m
.63514 .27128 L
s
.63514 .27128 m
.66166 .29022 L
s
.982 .295 .126 r
.49006 .64046 m .4866 .63997 L .5 .62969 L closepath p F P
0 0 0 r
s
.22 .332 .677 r
.42172 .62091 m .42402 .61547 L .40214 .6046 L p F P
0 0 0 r
s
.22 .332 .677 r
.40499 .59744 m .40214 .6046 L .42402 .61547 L p F P
0 0 0 r
s
.194 .292 .608 r
.40214 .6046 m .40499 .59744 L .38628 .58249 L p F P
0 0 0 r
s
.243 .365 .736 r
.44478 .6308 m .44642 .62713 L .42172 .62091 L p F P
0 0 0 r
s
.243 .365 .736 r
.42402 .61547 m .42172 .62091 L .44642 .62713 L p F P
0 0 0 r
s
.83 .24 .1 r
.22128 .29779 m
.22115 .295 L
s
.24 .35 .67 r
.5428 .23886 m
.57464 .24514 L
s
.58831 .21254 m
.57464 .24514 L
s
.982 .295 .126 r
.4866 .63997 m .48313 .63948 L .5 .62969 L closepath p F P
0 0 0 r
s
.024 .035 .067 r
.65896 .53307 m .66589 .52147 L .67588 .50019 L p F P
0 0 0 r
s
.252 .38 .679 r
.66589 .52147 m .65896 .53307 L .64523 .55285 L p F P
0 0 0 r
s
.24 .35 .67 r
.66355 .5216 m
.67118 .49797 L
s
.64853 .54685 m
.66355 .5216 L
s
.83 .24 .1 r
.21911 .60902 m
.21684 .61362 L
s
.21684 .61362 m
.17113 .60722 L
s
.982 .295 .126 r
.48313 .63948 m .47967 .63899 L .5 .62969 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.83591 .58255 m
.82705 .61323 L
s
.82705 .61323 m
.78494 .60682 L
s
.085 .126 .306 r
.36258 .49061 m .3584 .50333 L .36643 .52438 L p F P
0 0 0 r
s
.065 .095 .231 r
.3584 .50333 m .36258 .49061 L .35838 .46917 L p F P
0 0 0 r
s
.982 .295 .126 r
.47967 .63899 m .47619 .63849 L .5 .62969 L closepath p F P
0 0 0 r
s
.323 .486 .92 r
.573 .61956 m .57607 .61411 L .59802 .60282 L p F P
0 0 0 r
s
.319 .48 .919 r
.57607 .61411 m .573 .61956 L .54994 .62621 L p F P
0 0 0 r
s
.319 .48 .919 r
.54793 .62989 m .54994 .62621 L .573 .61956 L p F P
0 0 0 r
s
.24 .35 .67 r
.54743 .62852 m
.54888 .62816 L
s
.296 .445 .87 r
.5 .62969 m .52148 .63705 L .52052 .63889 L closepath p F P
0 0 0 r
s
.194 .292 .608 r
.3896 .57368 m .38628 .58249 L .40499 .59744 L p F P
0 0 0 r
s
.163 .246 .524 r
.38628 .58249 m .3896 .57368 L .37434 .55541 L p F P
0 0 0 r
s
.24 .35 .67 r
.37512 .55635 m
.37566 .55483 L
s
.635 .165 .068 r
.58157 .37873 m .56069 .37499 L .5638 .39001 L p F P
0 0 0 r
s
.635 .165 .068 r
.5638 .39001 m .58573 .3939 L .58157 .37873 L p F P
0 0 0 r
s
.317 .477 .891 r
.59802 .60282 m .60218 .59565 L .62234 .58031 L p F P
0 0 0 r
s
.323 .486 .92 r
.60218 .59565 m .59802 .60282 L .57607 .61411 L p F P
0 0 0 r
s
.731 .196 .081 r
.67215 .40921 m .65074 .40541 L .6542 .42383 L p F P
0 0 0 r
s
.731 .196 .081 r
.6542 .42383 m .6761 .42766 L .67215 .40921 L p F P
0 0 0 r
s
.83 .24 .1 r
.67407 .4273 m
.67423 .42843 L
s
.982 .295 .126 r
.47619 .63849 m .47272 .638 L .5 .62969 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.6461 .61503 m
.63577 .63786 L
s
.63577 .63786 m
.59249 .63159 L
s
.49 .12 .049 r
.47783 .3494 m .45799 .34582 L .45452 .35597 L p F P
0 0 0 r
s
.49 .12 .049 r
.45452 .35597 m .476 .35982 L .47783 .3494 L p F P
0 0 0 r
s
.263 .395 .787 r
.471 .63382 m .47188 .63196 L .44478 .6308 L p F P
0 0 0 r
s
.263 .395 .787 r
.44642 .62713 m .44478 .6308 L .47188 .63196 L p F P
0 0 0 r
s
.982 .295 .126 r
.47272 .638 m .46924 .63751 L .5 .62969 L closepath p F P
0 0 0 r
s
.288 .426 .769 r
.38035 .37298 m .38479 .35879 L .39358 .34845 L p F P
0 0 0 r
s
.288 .426 .769 r
.39785 .33496 m .39358 .34845 L .38479 .35879 L p F P
0 0 0 r
s
.83 .24 .1 r
.35783 .32253 m
.31285 .31438 L
s
.35783 .32253 m
.35946 .33276 L
s
.281 .421 .832 r
.47012 .63567 m .46924 .63751 L .5 .62969 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.36156 .61709 m
.35569 .62824 L
s
.35569 .62824 m
.31071 .62191 L
s
.309 .465 .9 r
.54994 .62621 m .54793 .62989 L .5244 .6315 L p F P
0 0 0 r
s
.309 .465 .9 r
.52342 .63336 m .5244 .6315 L .54793 .62989 L p F P
0 0 0 r
s
.296 .445 .87 r
.5 .62969 m .52245 .63521 L .52148 .63705 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.74234 .60033 m
.73213 .62778 L
s
.73213 .62778 m
.68937 .62144 L
s
.295 .444 .814 r
.62234 .58031 m .62755 .57147 L .64523 .55285 L p F P
0 0 0 r
s
.317 .477 .891 r
.62755 .57147 m .62234 .58031 L .60218 .59565 L p F P
0 0 0 r
s
.028 .04 .082 r
.67588 .50019 m .68348 .48741 L .6891 .46581 L p F P
0 0 0 r
s
.024 .035 .067 r
.68348 .48741 m .67588 .50019 L .66589 .52147 L p F P
0 0 0 r
s
.24 .35 .67 r
.67735 .25853 m
.66166 .29022 L
s
.66166 .29022 m
.68434 .31224 L
s
.065 .095 .231 r
.36274 .45554 m .35838 .46917 L .36258 .49061 L p F P
0 0 0 r
s
.24 .35 .67 r
.35982 .45649 m
.36025 .46332 L
s
.045 .065 .149 r
.35838 .46917 m .36274 .45554 L .36226 .43497 L p F P
0 0 0 r
s
.163 .246 .524 r
.37805 .54505 m .37434 .55541 L .3896 .57368 L p F P
0 0 0 r
s
.125 .189 .421 r
.37434 .55541 m .37805 .54505 L .36643 .52438 L p F P
0 0 0 r
s
.83 .24 .1 r
.80392 .47861 m
.76154 .47138 L
s
.80392 .47861 m
.80337 .50996 L
s
.635 .165 .068 r
.56069 .37499 m .5397 .37123 L .54174 .38611 L p F P
0 0 0 r
s
.635 .165 .068 r
.54174 .38611 m .5638 .39001 L .56069 .37499 L p F P
0 0 0 r
s
.281 .421 .832 r
.471 .63382 m .47012 .63567 L .5 .62969 L closepath p F P
0 0 0 r
s
.49 .12 .049 r
.45799 .34582 m .43805 .34222 L .43291 .3521 L p F P
0 0 0 r
s
.49 .12 .049 r
.43291 .3521 m .45452 .35597 L .45799 .34582 L p F P
0 0 0 r
s
.731 .196 .081 r
.65074 .40541 m .6292 .4016 L .63217 .41999 L p F P
0 0 0 r
s
.731 .196 .081 r
.63217 .41999 m .6542 .42383 L .65074 .40541 L p F P
0 0 0 r
s
.24 .35 .67 r
.51143 .23754 m
.5428 .23886 L
s
.55582 .20598 m
.5428 .23886 L
s
.296 .445 .87 r
.5 .62969 m .52342 .63336 L .52245 .63521 L closepath p F P
0 0 0 r
s
.243 .365 .736 r
.44642 .62713 m .44808 .62344 L .42402 .61547 L p F P
0 0 0 r
s
.243 .365 .736 r
.42635 .60998 m .42402 .61547 L .44808 .62344 L p F P
0 0 0 r
s
.22 .332 .677 r
.42402 .61547 m .42635 .60998 L .40499 .59744 L p F P
0 0 0 r
s
.83 .24 .1 r
.84555 .51698 m
.80337 .50996 L
s
.84555 .51698 m
.84219 .54985 L
s
.71718 .43592 m
.71864 .46406 L
s
.263 .395 .787 r
.47188 .63196 m .47277 .6301 L .44642 .62713 L p F P
0 0 0 r
s
.83 .24 .1 r
.46514 .63183 m
.4693 .63242 L
s
.263 .395 .787 r
.44808 .62344 m .44642 .62713 L .47277 .6301 L p F P
0 0 0 r
s
.238 .35 .612 r
.36972 .40235 m .37422 .38792 L .38035 .37298 L p F P
0 0 0 r
s
.238 .35 .612 r
.38479 .35879 m .38035 .37298 L .37422 .38792 L p F P
0 0 0 r
s
.024 .035 .067 r
.36226 .43497 m .36672 .42074 L .36972 .40235 L p F P
0 0 0 r
s
.045 .065 .149 r
.36672 .42074 m .36226 .43497 L .36274 .45554 L p F P
0 0 0 r
s
.281 .421 .832 r
.47188 .63196 m .471 .63382 L .5 .62969 L closepath p F P
0 0 0 r
s
.319 .48 .919 r
.54994 .62621 m .55196 .62252 L .57607 .61411 L p F P
0 0 0 r
s
.309 .465 .9 r
.55196 .62252 m .54994 .62621 L .52538 .62964 L p F P
0 0 0 r
s
.24 .35 .67 r
.54853 .62651 m
.54858 .6264 L
s
.309 .465 .9 r
.5244 .6315 m .52538 .62964 L .54994 .62621 L p F P
0 0 0 r
s
.323 .486 .92 r
.57607 .61411 m .57918 .60861 L .60218 .59565 L p F P
0 0 0 r
s
.319 .48 .919 r
.57918 .60861 m .57607 .61411 L .55196 .62252 L p F P
0 0 0 r
s
.83 .24 .1 r
.17113 .60722 m
.17248 .60246 L
s
.22 .332 .677 r
.40789 .59019 m .40499 .59744 L .42635 .60998 L p F P
0 0 0 r
s
.194 .292 .608 r
.40499 .59744 m .40789 .59019 L .3896 .57368 L p F P
0 0 0 r
s
.252 .38 .679 r
.64523 .55285 m .65142 .54244 L .66589 .52147 L p F P
0 0 0 r
s
.295 .444 .814 r
.65142 .54244 m .64523 .55285 L .62755 .57147 L p F P
0 0 0 r
s
.296 .445 .87 r
.5 .62969 m .5244 .6315 L .52342 .63336 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.84219 .54985 m
.83591 .58255 L
s
.83591 .58255 m
.79361 .57592 L
s
.049 .072 .169 r
.6891 .46581 m .69717 .4521 L .69786 .43146 L p F P
0 0 0 r
s
.83 .24 .1 r
.69782 .43254 m
.71718 .43592 L
s
.028 .04 .082 r
.69717 .4521 m .6891 .46581 L .68348 .48741 L p F P
0 0 0 r
s
.24 .35 .67 r
.67118 .49797 m
.68684 .47141 L
s
.83 .24 .1 r
.79361 .57592 m
.78494 .60682 L
s
.78494 .60682 m
.74234 .60033 L
s
.024 .035 .067 r
.37422 .38792 m .36972 .40235 L .36672 .42074 L p F P
0 0 0 r
s
.24 .35 .67 r
.36814 .42159 m
.37321 .39668 L
s
.49 .12 .049 r
.43805 .34222 m .41801 .3386 L .41118 .34821 L p F P
0 0 0 r
s
.49 .12 .049 r
.41118 .34821 m .43291 .3521 L .43805 .34222 L p F P
0 0 0 r
s
.635 .165 .068 r
.5397 .37123 m .51859 .36745 L .51954 .38217 L p F P
0 0 0 r
s
.635 .165 .068 r
.51954 .38217 m .54174 .38611 L .5397 .37123 L p F P
0 0 0 r
s
.24 .35 .67 r
.71468 .36243 m
.69811 .39193 L
s
.69811 .39193 m
.70394 .41804 L
s
.731 .196 .081 r
.6292 .4016 m .60753 .39776 L .61001 .41611 L p F P
0 0 0 r
s
.731 .196 .081 r
.61001 .41611 m .63217 .41999 L .6292 .4016 L p F P
0 0 0 r
s
.83 .24 .1 r
.63063 .41972 m
.63077 .42084 L
s
.125 .189 .421 r
.37045 .5126 m .36643 .52438 L .37805 .54505 L p F P
0 0 0 r
s
.085 .126 .306 r
.36643 .52438 m .37045 .5126 L .36258 .49061 L p F P
0 0 0 r
s
.281 .421 .832 r
.47277 .6301 m .47188 .63196 L .5 .62969 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.84219 .54985 m
.79988 .54302 L
s
.317 .477 .891 r
.60218 .59565 m .60639 .58837 L .62755 .57147 L p F P
0 0 0 r
s
.323 .486 .92 r
.60639 .58837 m .60218 .59565 L .57918 .60861 L p F P
0 0 0 r
s
.296 .445 .87 r
.5 .62969 m .52538 .62964 L .5244 .6315 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.52178 .62965 m
.52604 .62946 L
s
.83 .24 .1 r
.31285 .31438 m
.26734 .30613 L
s
.31285 .31438 m
.31363 .32451 L
s
.31576 .61057 m
.31071 .62191 L
s
.31071 .62191 m
.26519 .6155 L
s
.799 .218 .091 r
.69786 .43146 m .6761 .42766 L .67548 .44837 L p F P
0 0 0 r
s
.24 .35 .67 r
.68777 .44602 m
.69489 .4337 L
s
.83 .24 .1 r
.67423 .42843 m
.67606 .42875 L
s
.69669 .43234 m
.69728 .43245 L
s
.24 .35 .67 r
.69634 .43119 m
.70394 .41804 L
s
.799 .218 .091 r
.67548 .44837 m .69717 .4521 L .69786 .43146 L p F P
0 0 0 r
s
.24 .35 .67 r
.68684 .47141 m
.68761 .45046 L
s
.263 .395 .787 r
.47277 .6301 m .47365 .62823 L .44808 .62344 L p F P
0 0 0 r
s
.83 .24 .1 r
.45152 .62989 m
.46514 .63183 L
s
.44678 .63676 m
.45152 .62989 L
s
.263 .395 .787 r
.44976 .61972 m .44808 .62344 L .47365 .62823 L p F P
0 0 0 r
s
.243 .365 .736 r
.44808 .62344 m .44976 .61972 L .42635 .60998 L p F P
0 0 0 r
s
.83 .24 .1 r
.69922 .59377 m
.68937 .62144 L
s
.68937 .62144 m
.6461 .61503 L
s
.24 .35 .67 r
.42132 .29617 m
.44391 .28227 L
s
.45474 .25022 m
.44391 .28227 L
s
.194 .292 .608 r
.39298 .56474 m .3896 .57368 L .40789 .59019 L p F P
0 0 0 r
s
.24 .35 .67 r
.38739 .56819 m
.39039 .57161 L
s
.163 .246 .524 r
.3896 .57368 m .39298 .56474 L .37805 .54505 L p F P
0 0 0 r
s
.281 .421 .832 r
.47365 .62823 m .47277 .6301 L .5 .62969 L closepath p F P
0 0 0 r
s
.288 .426 .769 r
.38479 .35879 m .38932 .34429 L .39785 .33496 L p F P
0 0 0 r
s
.49 .12 .049 r
.41801 .3386 m .39785 .33496 L .38932 .34429 L p F P
0 0 0 r
s
.49 .12 .049 r
.38932 .34429 m .41118 .34821 L .41801 .3386 L p F P
0 0 0 r
s
.24 .35 .67 r
.39397 .34526 m
.39407 .34515 L
s
.38467 .37464 m
.39397 .34526 L
s
.319 .48 .919 r
.55196 .62252 m .554 .61879 L .57918 .60861 L p F P
0 0 0 r
s
.309 .465 .9 r
.554 .61879 m .55196 .62252 L .52636 .62777 L p F P
0 0 0 r
s
.24 .35 .67 r
.55049 .62291 m
.55055 .62281 L
s
.309 .465 .9 r
.52538 .62964 m .52636 .62777 L .55196 .62252 L p F P
0 0 0 r
s
.296 .445 .87 r
.5 .62969 m .52636 .62777 L .52538 .62964 L closepath p F P
0 0 0 r
s
.635 .165 .068 r
.51859 .36745 m .49735 .36364 L .49722 .37822 L p F P
0 0 0 r
s
.635 .165 .068 r
.49722 .37822 m .51954 .38217 L .51859 .36745 L p F P
0 0 0 r
s
.24 .35 .67 r
.70065 .28084 m
.68434 .31224 L
s
.68434 .31224 m
.70229 .3366 L
s
.243 .365 .736 r
.4287 .60443 m .42635 .60998 L .44976 .61972 L p F P
0 0 0 r
s
.22 .332 .677 r
.42635 .60998 m .4287 .60443 L .40789 .59019 L p F P
0 0 0 r
s
.83 .24 .1 r
.76154 .47138 m
.71864 .46406 L
s
.76154 .47138 m
.76068 .50287 L
s
.024 .035 .067 r
.66589 .52147 m .67295 .50963 L .68348 .48741 L p F P
0 0 0 r
s
.252 .38 .679 r
.67295 .50963 m .66589 .52147 L .65142 .54244 L p F P
0 0 0 r
s
.731 .196 .081 r
.60753 .39776 m .58573 .3939 L .58772 .41222 L p F P
0 0 0 r
s
.731 .196 .081 r
.58772 .41222 m .61001 .41611 L .60753 .39776 L p F P
0 0 0 r
s
.83 .24 .1 r
.80337 .50996 m
.76068 .50287 L
s
.80337 .50996 m
.79988 .54302 L
s
.295 .444 .814 r
.62755 .57147 m .63284 .56249 L .65142 .54244 L p F P
0 0 0 r
s
.24 .35 .67 r
.64947 .54257 m
.66355 .5216 L
s
.6462 .54808 m
.64947 .54257 L
s
.317 .477 .891 r
.63284 .56249 m .62755 .57147 L .60639 .58837 L p F P
0 0 0 r
s
.281 .421 .832 r
.47455 .62636 m .47365 .62823 L .5 .62969 L closepath p F P
0 0 0 r
s
.263 .395 .787 r
.47365 .62823 m .47455 .62636 L .44976 .61972 L p F P
0 0 0 r
s
.323 .486 .92 r
.57918 .60861 m .58232 .60304 L .60639 .58837 L p F P
0 0 0 r
s
.83 .24 .1 r
.59249 .63159 m
.6023 .60854 L
s
.319 .48 .919 r
.58232 .60304 m .57918 .60861 L .554 .61879 L p F P
0 0 0 r
s
.24 .35 .67 r
.48168 .24133 m
.51143 .23754 L
s
.52381 .2044 m
.51143 .23754 L
s
.085 .126 .306 r
.36685 .47762 m .36258 .49061 L .37045 .5126 L p F P
0 0 0 r
s
.24 .35 .67 r
.36263 .48087 m
.36418 .48576 L
s
.36937 .50213 m
.36961 .50289 L
s
.36949 .50326 m
.36961 .50289 L
s
.065 .095 .231 r
.36258 .49061 m .36685 .47762 L .36274 .45554 L p F P
0 0 0 r
s
.309 .465 .9 r
.52636 .62777 m .52734 .62589 L .554 .61879 L p F P
0 0 0 r
s
.296 .445 .87 r
.5 .62969 m .52734 .62589 L .52636 .62777 L closepath p F P
0 0 0 r
s
.799 .218 .091 r
.6761 .42766 m .6542 .42383 L .65366 .44462 L p F P
0 0 0 r
s
.799 .218 .091 r
.65366 .44462 m .67548 .44837 L .6761 .42766 L p F P
0 0 0 r
s
1 .298 .127 r
.5 .62969 m .53132 .61832 L .5278 .61781 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.50418 .62817 m
.5075 .62865 L
s
1 .298 .127 r
.5 .62969 m .5278 .61781 L .52429 .61729 L closepath p F P
0 0 0 r
s
1 .298 .127 r
.5 .62969 m .52429 .61729 L .52076 .61678 L closepath p F P
0 0 0 r
s
1 .298 .127 r
.5 .62969 m .52076 .61678 L .51724 .61627 L closepath p F P
0 0 0 r
s
1 .298 .127 r
.5 .62969 m .51724 .61627 L .51371 .61576 L closepath p F P
0 0 0 r
s
1 .298 .127 r
.5 .62969 m .51371 .61576 L .51018 .61524 L closepath p F P
0 0 0 r
s
1 .298 .127 r
.5 .62969 m .51018 .61524 L .50664 .61473 L closepath p F P
0 0 0 r
s
1 .298 .127 r
.5 .62969 m .50664 .61473 L .5031 .61421 L closepath p F P
0 0 0 r
s
1 .298 .127 r
.5 .62969 m .5031 .61421 L .49956 .6137 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.499 .62956 m
.49994 .62768 L
s
1 .298 .127 r
.5 .62969 m .49956 .6137 L .49601 .61318 L closepath p F P
0 0 0 r
s
1 .298 .127 r
.5 .62969 m .49601 .61318 L .49246 .61267 L closepath p F P
0 0 0 r
s
1 .298 .127 r
.5 .62969 m .49246 .61267 L .48891 .61215 L closepath p F P
0 0 0 r
s
1 .298 .127 r
.5 .62969 m .48891 .61215 L .48536 .61163 L closepath p F P
0 0 0 r
s
1 .298 .127 r
.5 .62969 m .48536 .61163 L .4818 .61112 L closepath p F P
0 0 0 r
s
.296 .445 .87 r
.5 .62969 m .53132 .61832 L .53032 .62022 L closepath p F P
0 0 0 r
s
.296 .445 .87 r
.5 .62969 m .53032 .62022 L .52932 .62212 L closepath p F P
0 0 0 r
s
.296 .445 .87 r
.5 .62969 m .52932 .62212 L .52833 .62401 L closepath p F P
0 0 0 r
s
.296 .445 .87 r
.5 .62969 m .52833 .62401 L .52734 .62589 L closepath p F P
0 0 0 r
s
.281 .421 .832 r
.47544 .62448 m .47455 .62636 L .5 .62969 L closepath p F P
0 0 0 r
s
.281 .421 .832 r
.47634 .62259 m .47544 .62448 L .5 .62969 L closepath p F P
0 0 0 r
s
.281 .421 .832 r
.47724 .62069 m .47634 .62259 L .5 .62969 L closepath p F P
0 0 0 r
s
.281 .421 .832 r
.47815 .61879 m .47724 .62069 L .5 .62969 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.49403 .62672 m
.49758 .62723 L
s
.281 .421 .832 r
.47905 .61688 m .47815 .61879 L .5 .62969 L closepath p F P
0 0 0 r
s
.281 .421 .832 r
.47996 .61497 m .47905 .61688 L .5 .62969 L closepath p F P
0 0 0 r
s
.281 .421 .832 r
.48088 .61304 m .47996 .61497 L .5 .62969 L closepath p F P
0 0 0 r
s
.281 .421 .832 r
.4818 .61112 m .48088 .61304 L .5 .62969 L closepath p F P
0 0 0 r
s
.263 .395 .787 r
.45144 .61598 m .44976 .61972 L .47455 .62636 L p F P
0 0 0 r
s
.243 .365 .736 r
.44976 .61972 m .45144 .61598 L .4287 .60443 L p F P
0 0 0 r
s
.24 .35 .67 r
.39612 .33846 m
.40369 .31454 L
s
.39397 .34526 m
.39401 .34513 L
s
.83 .24 .1 r
.79988 .54302 m
.79361 .57592 L
s
.79361 .57592 m
.75081 .56921 L
s
.75081 .56921 m
.74234 .60033 L
s
.74234 .60033 m
.69922 .59377 L
s
.635 .165 .068 r
.49735 .36364 m .476 .35982 L .47475 .37424 L p F P
0 0 0 r
s
.635 .165 .068 r
.47475 .37424 m .49722 .37822 L .49735 .36364 L p F P
0 0 0 r
s
.22 .332 .677 r
.41082 .58285 m .40789 .59019 L .4287 .60443 L p F P
0 0 0 r
s
.24 .35 .67 r
.405 .58526 m
.4087 .58817 L
s
.194 .292 .608 r
.40789 .59019 m .41082 .58285 L .39298 .56474 L p F P
0 0 0 r
s
.263 .395 .787 r
.47455 .62636 m .47544 .62448 L .45144 .61598 L p F P
0 0 0 r
s
.319 .48 .919 r
.554 .61879 m .55605 .61504 L .58232 .60304 L p F P
0 0 0 r
s
.309 .465 .9 r
.55605 .61504 m .554 .61879 L .52734 .62589 L p F P
0 0 0 r
s
.163 .246 .524 r
.38182 .53449 m .37805 .54505 L .39298 .56474 L p F P
0 0 0 r
s
.125 .189 .421 r
.37805 .54505 m .38182 .53449 L .37045 .5126 L p F P
0 0 0 r
s
.731 .196 .081 r
.58573 .3939 m .5638 .39001 L .56528 .4083 L p F P
0 0 0 r
s
.731 .196 .081 r
.56528 .4083 m .58772 .41222 L .58573 .3939 L p F P
0 0 0 r
s
.83 .24 .1 r
.58667 .41204 m
.58678 .41316 L
s
.309 .465 .9 r
.52734 .62589 m .52833 .62401 L .55605 .61504 L p F P
0 0 0 r
s
.83 .24 .1 r
.5487 .62525 m
.59249 .63159 L
s
.53936 .64239 m
.5487 .62525 L
s
.79988 .54302 m
.75705 .5361 L
s
.028 .04 .082 r
.68348 .48741 m .69124 .47434 L .69717 .4521 L p F P
0 0 0 r
s
.024 .035 .067 r
.69124 .47434 m .68348 .48741 L .67295 .50963 L p F P
0 0 0 r
s
.83 .24 .1 r
.26734 .30613 m
.22128 .29779 L
s
.26734 .30613 m
.26723 .31616 L
s
.2694 .60397 m
.26519 .6155 L
s
.26519 .6155 m
.21911 .60902 L
s
.317 .477 .891 r
.60639 .58837 m .61065 .581 L .63284 .56249 L p F P
0 0 0 r
s
.323 .486 .92 r
.61065 .581 m .60639 .58837 L .58232 .60304 L p F P
0 0 0 r
s
.799 .218 .091 r
.6542 .42383 m .63217 .41999 L .63171 .44085 L p F P
0 0 0 r
s
.83 .24 .1 r
.63077 .42084 m
.63215 .42108 L
s
.65302 .42472 m
.65417 .42492 L
s
.799 .218 .091 r
.63171 .44085 m .65366 .44462 L .6542 .42383 L p F P
0 0 0 r
s
.263 .395 .787 r
.47544 .62448 m .47634 .62259 L .45313 .61221 L p F P
0 0 0 r
s
.263 .395 .787 r
.45313 .61221 m .45144 .61598 L .47544 .62448 L p F P
0 0 0 r
s
.24 .35 .67 r
.45196 .61474 m
.45199 .61475 L
s
.42553 .6006 m
.45196 .61474 L
s
.83 .24 .1 r
.40681 .62353 m
.45152 .62989 L
s
.24 .35 .67 r
.45141 .61596 m
.45196 .61474 L
s
.065 .095 .231 r
.36719 .44159 m .36274 .45554 L .36685 .47762 L p F P
0 0 0 r
s
.045 .065 .149 r
.36274 .45554 m .36719 .44159 L .36672 .42074 L p F P
0 0 0 r
s
.24 .35 .67 r
.36684 .42574 m
.36814 .42159 L
s
.83 .24 .1 r
.65557 .58713 m
.6461 .61503 L
s
.6023 .60854 m
.6461 .61503 L
s
.40681 .62353 m
.41411 .60576 L
s
.40681 .62353 m
.36156 .61709 L
s
.243 .365 .736 r
.43108 .59883 m .4287 .60443 L .45144 .61598 L p F P
0 0 0 r
s
.22 .332 .677 r
.4287 .60443 m .43108 .59883 L .41082 .58285 L p F P
0 0 0 r
s
.309 .465 .9 r
.55811 .61126 m .55605 .61504 L .52833 .62401 L p F P
0 0 0 r
s
.309 .465 .9 r
.52833 .62401 m .52932 .62212 L .55811 .61126 L p F P
0 0 0 r
s
.83 .24 .1 r
.53514 .62328 m
.5487 .62525 L
s
.53098 .62268 m
.53514 .62328 L
s
.252 .38 .679 r
.65142 .54244 m .65773 .53184 L .67295 .50963 L p F P
0 0 0 r
s
.295 .444 .814 r
.65773 .53184 m .65142 .54244 L .63284 .56249 L p F P
0 0 0 r
s
.83 .24 .1 r
.35946 .33276 m
.39416 .339 L
s
.635 .165 .068 r
.476 .35982 m .45452 .35597 L .45215 .37024 L p F P
0 0 0 r
s
.635 .165 .068 r
.45215 .37024 m .47475 .37424 L .476 .35982 L p F P
0 0 0 r
s
.243 .365 .736 r
.45144 .61598 m .45313 .61221 L .43108 .59883 L p F P
0 0 0 r
s
.83 .24 .1 r
.71864 .46406 m
.71748 .49569 L
s
.731 .196 .081 r
.5638 .39001 m .54174 .38611 L .54271 .40436 L p F P
0 0 0 r
s
.731 .196 .081 r
.54271 .40436 m .56528 .4083 L .5638 .39001 L p F P
0 0 0 r
s
.323 .486 .92 r
.58232 .60304 m .58549 .59743 L .61065 .581 L p F P
0 0 0 r
s
.319 .48 .919 r
.58549 .59743 m .58232 .60304 L .55605 .61504 L p F P
0 0 0 r
s
.238 .35 .612 r
.37422 .38792 m .37882 .37317 L .38479 .35879 L p F P
0 0 0 r
s
.238 .35 .612 r
.38932 .34429 m .38479 .35879 L .37882 .37317 L p F P
0 0 0 r
s
.263 .395 .787 r
.47634 .62259 m .47724 .62069 L .45484 .60841 L p F P
0 0 0 r
s
.263 .395 .787 r
.45484 .60841 m .45313 .61221 L .47634 .62259 L p F P
0 0 0 r
s
.319 .48 .919 r
.55605 .61504 m .55811 .61126 L .58549 .59743 L p F P
0 0 0 r
s
.309 .465 .9 r
.56019 .60746 m .55811 .61126 L .52932 .62212 L p F P
0 0 0 r
s
.309 .465 .9 r
.52932 .62212 m .53032 .62022 L .56019 .60746 L p F P
0 0 0 r
s
.83 .24 .1 r
.76068 .50287 m
.71748 .49569 L
s
.76068 .50287 m
.75705 .5361 L
s
.024 .035 .067 r
.36672 .42074 m .37129 .40619 L .37422 .38792 L p F P
0 0 0 r
s
.045 .065 .149 r
.37129 .40619 m .36672 .42074 L .36719 .44159 L p F P
0 0 0 r
s
.194 .292 .608 r
.39641 .55564 m .39298 .56474 L .41082 .58285 L p F P
0 0 0 r
s
.163 .246 .524 r
.39298 .56474 m .39641 .55564 L .38182 .53449 L p F P
0 0 0 r
s
.848 .235 .098 r
.69717 .4521 m .67548 .44837 L .67019 .47079 L p F P
0 0 0 r
s
.83 .24 .1 r
.67493 .44828 m
.67501 .45036 L
s
.848 .235 .098 r
.67019 .47079 m .69124 .47434 L .69717 .4521 L p F P
0 0 0 r
s
.24 .35 .67 r
.69411 .45907 m
.69457 .45829 L
s
.69457 .45829 m
.70321 .44363 L
s
.83 .24 .1 r
.69505 .46003 m
.69605 .4602 L
s
.69605 .4602 m
.71864 .46406 L
s
.125 .189 .421 r
.37455 .50058 m .37045 .5126 L .38182 .53449 L p F P
0 0 0 r
s
.085 .126 .306 r
.37045 .5126 m .37455 .50058 L .36685 .47762 L p F P
0 0 0 r
s
.799 .218 .091 r
.63217 .41999 m .61001 .41611 L .60962 .43706 L p F P
0 0 0 r
s
.799 .218 .091 r
.60962 .43706 m .63171 .44085 L .63217 .41999 L p F P
0 0 0 r
s
.024 .035 .067 r
.37882 .37317 m .37422 .38792 L .37129 .40619 L p F P
0 0 0 r
s
.24 .35 .67 r
.37412 .39376 m
.38237 .3674 L
s
.263 .395 .787 r
.47724 .62069 m .47815 .61879 L .45656 .60459 L p F P
0 0 0 r
s
.263 .395 .787 r
.45656 .60459 m .45484 .60841 L .47724 .62069 L p F P
0 0 0 r
s
.83 .24 .1 r
.75705 .5361 m
.75081 .56921 L
s
.75081 .56921 m
.70749 .56242 L
s
.635 .165 .068 r
.45452 .35597 m .43291 .3521 L .42942 .36621 L p F P
0 0 0 r
s
.635 .165 .068 r
.42942 .36621 m .45215 .37024 L .45452 .35597 L p F P
0 0 0 r
s
.83 .24 .1 r
.70749 .56242 m
.69922 .59377 L
s
.69922 .59377 m
.65557 .58713 L
s
.309 .465 .9 r
.56228 .60363 m .56019 .60746 L .53032 .62022 L p F P
0 0 0 r
s
.309 .465 .9 r
.53032 .62022 m .53132 .61832 L .56228 .60363 L p F P
0 0 0 r
s
.83 .24 .1 r
.5487 .62525 m
.55356 .61306 L
s
.24 .35 .67 r
.71916 .30548 m
.70229 .3366 L
s
.70229 .3366 m
.71468 .36243 L
s
.295 .444 .814 r
.63284 .56249 m .63822 .55336 L .65773 .53184 L p F P
0 0 0 r
s
.317 .477 .891 r
.63822 .55336 m .63284 .56249 L .61065 .581 L p F P
0 0 0 r
s
.243 .365 .736 r
.45313 .61221 m .45484 .60841 L .43348 .59317 L p F P
0 0 0 r
s
.24 .35 .67 r
.4531 .61219 m
.45311 .61218 L
s
.243 .365 .736 r
.43348 .59317 m .43108 .59883 L .45313 .61221 L p F P
0 0 0 r
s
.24 .35 .67 r
.72086 .38877 m
.70394 .41804 L
s
.70394 .41804 m
.70321 .44363 L
s
.731 .196 .081 r
.54174 .38611 m .51954 .38217 L .52 .40039 L p F P
0 0 0 r
s
.731 .196 .081 r
.52 .40039 m .54271 .40436 L .54174 .38611 L p F P
0 0 0 r
s
.83 .24 .1 r
.54218 .40426 m
.54225 .40539 L
s
.22 .332 .677 r
.4138 .5754 m .41082 .58285 L .43108 .59883 L p F P
0 0 0 r
s
.194 .292 .608 r
.41082 .58285 m .4138 .5754 L .39641 .55564 L p F P
0 0 0 r
s
.83 .24 .1 r
.75705 .5361 m
.7137 .5291 L
s
.263 .395 .787 r
.47815 .61879 m .47905 .61688 L .45829 .60073 L p F P
0 0 0 r
s
.263 .395 .787 r
.45829 .60073 m .45656 .60459 L .47815 .61879 L p F P
0 0 0 r
s
.319 .48 .919 r
.5887 .59175 m .58549 .59743 L .55811 .61126 L p F P
0 0 0 r
s
.319 .48 .919 r
.55811 .61126 m .56019 .60746 L .5887 .59175 L p F P
0 0 0 r
s
.024 .035 .067 r
.67295 .50963 m .68016 .49755 L .69124 .47434 L p F P
0 0 0 r
s
.24 .35 .67 r
.67924 .49521 m
.68618 .47349 L
s
.252 .38 .679 r
.68016 .49755 m .67295 .50963 L .65773 .53184 L p F P
0 0 0 r
s
.24 .35 .67 r
.66355 .5216 m
.67924 .49521 L
s
.22 .332 .677 r
.43108 .59883 m .43348 .59317 L .4138 .5754 L p F P
0 0 0 r
s
.83 .24 .1 r
.22026 .30771 m
.22128 .29779 L
s
.22247 .59729 m
.21911 .60902 L
s
.21911 .60902 m
.17248 .60246 L
s
.24 .35 .67 r
.45474 .25022 m
.48168 .24133 L
s
.4935 .20796 m
.48168 .24133 L
s
1 .295 .126 r
.5278 .61781 m .53132 .61832 L .56228 .60363 L p F P
0 0 0 r
s
.848 .235 .098 r
.67548 .44837 m .65366 .44462 L .64902 .46722 L p F P
0 0 0 r
s
.848 .235 .098 r
.64902 .46722 m .67019 .47079 L .67548 .44837 L p F P
0 0 0 r
s
.24 .35 .67 r
.58831 .21254 m
.62014 .22379 L
s
.63515 .19001 m
.62014 .22379 L
s
.62014 .22379 m
.65017 .2393 L
s
.799 .218 .091 r
.61001 .41611 m .58772 .41222 L .5874 .43324 L p F P
0 0 0 r
s
.83 .24 .1 r
.58678 .41316 m
.5877 .41332 L
s
.60883 .41701 m
.60999 .41721 L
s
.799 .218 .091 r
.5874 .43324 m .60962 .43706 L .61001 .41611 L p F P
0 0 0 r
s
1 .295 .126 r
.56228 .60363 m .55532 .6026 L .5278 .61781 L p F P
0 0 0 r
s
.83 .24 .1 r
.55759 .60294 m
.55797 .60198 L
s
1 .295 .126 r
.52429 .61729 m .5278 .61781 L .55532 .6026 L p F P
0 0 0 r
s
.83 .24 .1 r
.36815 .5991 m
.36156 .61709 L
s
.36156 .61709 m
.31576 .61057 L
s
.317 .477 .891 r
.61065 .581 m .61498 .57353 L .63822 .55336 L p F P
0 0 0 r
s
.24 .35 .67 r
.62784 .56237 m
.62934 .55981 L
s
.323 .486 .92 r
.61498 .57353 m .61065 .581 L .58549 .59743 L p F P
0 0 0 r
s
.635 .165 .068 r
.43291 .3521 m .41118 .34821 L .40654 .36216 L p F P
0 0 0 r
s
.635 .165 .068 r
.40654 .36216 m .42942 .36621 L .43291 .3521 L p F P
0 0 0 r
s
1 .295 .126 r
.55532 .6026 m .54834 .60157 L .52429 .61729 L p F P
0 0 0 r
s
.83 .24 .1 r
.55356 .61306 m
.55454 .61059 L
s
1 .295 .126 r
.52076 .61678 m .52429 .61729 L .54834 .60157 L p F P
0 0 0 r
s
.24 .35 .67 r
.40369 .31454 m
.42132 .29617 L
s
.43177 .26403 m
.42132 .29617 L
s
.323 .486 .92 r
.58549 .59743 m .5887 .59175 L .61498 .57353 L p F P
0 0 0 r
s
.83 .24 .1 r
.35946 .33276 m
.31363 .32451 L
s
.35946 .33276 m
.35975 .34987 L
s
.263 .395 .787 r
.47905 .61688 m .47996 .61497 L .46003 .59686 L p F P
0 0 0 r
s
.263 .395 .787 r
.46003 .59686 m .45829 .60073 L .47905 .61688 L p F P
0 0 0 r
s
.83 .24 .1 r
.47335 .61434 m
.47757 .61495 L
s
.45152 .62989 m
.45951 .61233 L
s
.24 .35 .67 r
.66589 .20583 m
.65017 .2393 L
s
.65017 .2393 m
.67735 .25853 L
s
1 .295 .126 r
.54834 .60157 m .54135 .60053 L .52076 .61678 L p F P
0 0 0 r
s
1 .295 .126 r
.51724 .61627 m .52076 .61678 L .54135 .60053 L p F P
0 0 0 r
s
.085 .126 .306 r
.37121 .46434 m .36685 .47762 L .37455 .50058 L p F P
0 0 0 r
s
.065 .095 .231 r
.36685 .47762 m .37121 .46434 L .36719 .44159 L p F P
0 0 0 r
s
.731 .196 .081 r
.51954 .38217 m .49722 .37822 L .49715 .3964 L p F P
0 0 0 r
s
.731 .196 .081 r
.49715 .3964 m .52 .40039 L .51954 .38217 L p F P
0 0 0 r
s
.163 .246 .524 r
.38567 .52374 m .38182 .53449 L .39641 .55564 L p F P
0 0 0 r
s
.125 .189 .421 r
.38182 .53449 m .38567 .52374 L .37455 .50058 L p F P
0 0 0 r
s
.24 .35 .67 r
.55582 .20598 m
.58831 .21254 L
s
.60261 .17845 m
.58831 .21254 L
s
1 .295 .126 r
.54135 .60053 m .53434 .59949 L .51724 .61627 L p F P
0 0 0 r
s
1 .295 .126 r
.51371 .61576 m .51724 .61627 L .53434 .59949 L p F P
0 0 0 r
s
.243 .365 .736 r
.45484 .60841 m .45656 .60459 L .4359 .58745 L p F P
0 0 0 r
s
.24 .35 .67 r
.45481 .60839 m
.45482 .60838 L
s
.243 .365 .736 r
.4359 .58745 m .43348 .59317 L .45484 .60841 L p F P
0 0 0 r
s
1 .295 .126 r
.53434 .59949 m .52732 .59846 L .51371 .61576 L p F P
0 0 0 r
s
1 .295 .126 r
.51018 .61524 m .51371 .61576 L .52732 .59846 L p F P
0 0 0 r
s
.83 .24 .1 r
.71748 .49569 m
.7137 .5291 L
s
1 .295 .126 r
.52732 .59846 m .52029 .59741 L .51018 .61524 L p F P
0 0 0 r
s
.24 .35 .67 r
.52355 .61556 m
.52473 .61328 L
s
.52473 .61328 m
.52862 .60575 L
s
1 .295 .126 r
.50664 .61473 m .51018 .61524 L .52029 .59741 L p F P
0 0 0 r
s
.848 .235 .098 r
.65366 .44462 m .63171 .44085 L .62772 .46363 L p F P
0 0 0 r
s
.83 .24 .1 r
.63114 .44075 m
.63119 .4438 L
s
.848 .235 .098 r
.62772 .46363 m .64902 .46722 L .65366 .44462 L p F P
0 0 0 r
s
.319 .48 .919 r
.59194 .58601 m .5887 .59175 L .56019 .60746 L p F P
0 0 0 r
s
.319 .48 .919 r
.56019 .60746 m .56228 .60363 L .59194 .58601 L p F P
0 0 0 r
s
.83 .24 .1 r
.57193 .60404 m
.6023 .60854 L
s
.56833 .60351 m
.57193 .60404 L
s
.56571 .60312 m
.56833 .60351 L
s
.55797 .60198 m
.56365 .60282 L
s
.263 .395 .787 r
.47996 .61497 m .48088 .61304 L .46179 .59295 L p F P
0 0 0 r
s
.263 .395 .787 r
.46179 .59295 m .46003 .59686 L .47996 .61497 L p F P
0 0 0 r
s
1 .295 .126 r
.52029 .59741 m .51325 .59637 L .50664 .61473 L p F P
0 0 0 r
s
1 .295 .126 r
.5031 .61421 m .50664 .61473 L .51325 .59637 L p F P
0 0 0 r
s
.799 .218 .091 r
.58772 .41222 m .56528 .4083 L .56505 .4294 L p F P
0 0 0 r
s
.83 .24 .1 r
.58653 .41312 m
.58678 .41316 L
s
.799 .218 .091 r
.56505 .4294 m .5874 .43324 L .58772 .41222 L p F P
0 0 0 r
s
1 .295 .126 r
.51325 .59637 m .50619 .59533 L .5031 .61421 L p F P
0 0 0 r
s
.83 .24 .1 r
.51275 .5963 m
.51311 .59533 L
s
1 .295 .126 r
.49956 .6137 m .5031 .61421 L .50619 .59533 L p F P
0 0 0 r
s
.238 .35 .612 r
.37882 .37317 m .38352 .35808 L .38932 .34429 L p F P
0 0 0 r
s
.635 .165 .068 r
.41118 .34821 m .38932 .34429 L .38352 .35808 L p F P
0 0 0 r
s
.635 .165 .068 r
.38352 .35808 m .40654 .36216 L .41118 .34821 L p F P
0 0 0 r
s
.24 .35 .67 r
.38237 .3674 m
.38694 .35868 L
s
.83 .24 .1 r
.7137 .5291 m
.70749 .56242 L
s
.70749 .56242 m
.66364 .55555 L
s
.24 .35 .67 r
.52862 .60575 m
.54886 .60497 L
s
.252 .38 .679 r
.65773 .53184 m .66416 .52104 L .68016 .49755 L p F P
0 0 0 r
s
.295 .444 .814 r
.66416 .52104 m .65773 .53184 L .63822 .55336 L p F P
0 0 0 r
s
.24 .35 .67 r
.62934 .55981 m
.6412 .54965 L
s
.83 .24 .1 r
.65557 .58713 m
.66364 .55555 L
s
1 .295 .126 r
.50619 .59533 m .49912 .59428 L .49956 .6137 L p F P
0 0 0 r
s
1 .295 .126 r
.49601 .61318 m .49956 .6137 L .49912 .59428 L p F P
0 0 0 r
s
.887 .248 .104 r
.69124 .47434 m .67019 .47079 L .6603 .49427 L p F P
0 0 0 r
s
.887 .248 .104 r
.6603 .49427 m .68016 .49755 L .69124 .47434 L p F P
0 0 0 r
s
.83 .24 .1 r
.68373 .49008 m
.71748 .49569 L
s
.24 .35 .67 r
.68381 .48753 m
.69566 .4676 L
s
.68288 .4891 m
.68381 .48753 L
s
.194 .292 .608 r
.39989 .5464 m .39641 .55564 L .4138 .5754 L p F P
0 0 0 r
s
.163 .246 .524 r
.39641 .55564 m .39989 .5464 L .38567 .52374 L p F P
0 0 0 r
s
1 .295 .126 r
.49912 .59428 m .49203 .59323 L .49601 .61318 L p F P
0 0 0 r
s
1 .295 .126 r
.49246 .61267 m .49601 .61318 L .49203 .59323 L p F P
0 0 0 r
s
.731 .196 .081 r
.49722 .37822 m .47475 .37424 L .47416 .39238 L p F P
0 0 0 r
s
.731 .196 .081 r
.47416 .39238 m .49715 .3964 L .49722 .37822 L p F P
0 0 0 r
s
.263 .395 .787 r
.48088 .61304 m .4818 .61112 L .46356 .58902 L p F P
0 0 0 r
s
.263 .395 .787 r
.46356 .58902 m .46179 .59295 L .48088 .61304 L p F P
0 0 0 r
s
.83 .24 .1 r
.45951 .61233 m
.47335 .61434 L
s
.22 .332 .677 r
.43348 .59317 m .4359 .58745 L .41681 .56786 L p F P
0 0 0 r
s
.22 .332 .677 r
.41681 .56786 m .4138 .5754 L .43348 .59317 L p F P
0 0 0 r
s
.83 .24 .1 r
.41411 .60576 m
.45951 .61233 L
s
1 .295 .126 r
.49203 .59323 m .48494 .59218 L .49246 .61267 L p F P
0 0 0 r
s
1 .295 .126 r
.48891 .61215 m .49246 .61267 L .48494 .59218 L p F P
0 0 0 r
s
.24 .35 .67 r
.49077 .61079 m
.49188 .60849 L
s
.49188 .60849 m
.49556 .60089 L
s
.38724 .35185 m
.39196 .33677 L
s
.38663 .35379 m
.38724 .35185 L
s
.69376 .22537 m
.67735 .25853 L
s
.67735 .25853 m
.70065 .28084 L
s
.83 .24 .1 r
.66982 .52201 m
.7137 .5291 L
s
.065 .095 .231 r
.37175 .42733 m .36719 .44159 L .37121 .46434 L p F P
0 0 0 r
s
.24 .35 .67 r
.36865 .42902 m
.3691 .43563 L
s
.045 .065 .149 r
.36719 .44159 m .37175 .42733 L .37129 .40619 L p F P
0 0 0 r
s
1 .295 .126 r
.48494 .59218 m .47782 .59113 L .48891 .61215 L p F P
0 0 0 r
s
1 .295 .126 r
.48536 .61163 m .48891 .61215 L .47782 .59113 L p F P
0 0 0 r
s
.194 .292 .608 r
.4138 .5754 m .41681 .56786 L .39989 .5464 L p F P
0 0 0 r
s
.24 .35 .67 r
.40593 .55406 m
.40625 .55324 L
s
.243 .365 .736 r
.45656 .60459 m .45829 .60073 L .43835 .58166 L p F P
0 0 0 r
s
.24 .35 .67 r
.45653 .60456 m
.45654 .60455 L
s
.243 .365 .736 r
.43835 .58166 m .4359 .58745 L .45656 .60459 L p F P
0 0 0 r
s
.83 .24 .1 r
.17248 .60246 m
.17496 .59053 L
s
.848 .235 .098 r
.63171 .44085 m .60962 .43706 L .60629 .46002 L p F P
0 0 0 r
s
.848 .235 .098 r
.60629 .46002 m .62772 .46363 L .63171 .44085 L p F P
0 0 0 r
s
1 .295 .126 r
.47782 .59113 m .4707 .59007 L .48536 .61163 L p F P
0 0 0 r
s
1 .295 .126 r
.4818 .61112 m .48536 .61163 L .4707 .59007 L p F P
0 0 0 r
s
.323 .486 .92 r
.61936 .56596 m .61498 .57353 L .5887 .59175 L p F P
0 0 0 r
s
.323 .486 .92 r
.5887 .59175 m .59194 .58601 L .61936 .56596 L p F P
0 0 0 r
s
.83 .24 .1 r
.6023 .60854 m
.6114 .5804 L
s
.6114 .5804 m
.65557 .58713 L
s
.24 .35 .67 r
.52381 .2044 m
.55582 .20598 L
s
.56943 .17158 m
.55582 .20598 L
s
.799 .218 .091 r
.56528 .4083 m .54271 .40436 L .54256 .42554 L p F P
0 0 0 r
s
.83 .24 .1 r
.54225 .40539 m
.5427 .40547 L
s
.56409 .4092 m
.56527 .40941 L
s
.799 .218 .091 r
.54256 .42554 m .56505 .4294 L .56528 .4083 L p F P
0 0 0 r
s
.83 .24 .1 r
.32161 .59236 m
.31576 .61057 L
s
.31576 .61057 m
.2694 .60397 L
s
1 .29 .123 r
.55532 .6026 m .56228 .60363 L .59194 .58601 L p F P
0 0 0 r
s
1 .295 .126 r
.4707 .59007 m .46356 .58902 L .4818 .61112 L p F P
0 0 0 r
s
.295 .444 .814 r
.63822 .55336 m .64369 .54408 L .66416 .52104 L p F P
0 0 0 r
s
.317 .477 .891 r
.64369 .54408 m .63822 .55336 L .61498 .57353 L p F P
0 0 0 r
s
.83 .24 .1 r
.31363 .32451 m
.26723 .31616 L
s
.31363 .32451 m
.3131 .34158 L
s
.887 .248 .104 r
.67019 .47079 m .64902 .46722 L .64033 .49098 L p F P
0 0 0 r
s
.887 .248 .104 r
.64033 .49098 m .6603 .49427 L .67019 .47079 L p F P
0 0 0 r
s
.125 .189 .421 r
.37874 .48831 m .37455 .50058 L .38567 .52374 L p F P
0 0 0 r
s
.085 .126 .306 r
.37455 .50058 m .37874 .48831 L .37121 .46434 L p F P
0 0 0 r
s
.317 .477 .891 r
.61498 .57353 m .61936 .56596 L .64369 .54408 L p F P
0 0 0 r
s
1 .29 .123 r
.59194 .58601 m .58169 .58447 L .55532 .6026 L p F P
0 0 0 r
s
1 .29 .123 r
.54834 .60157 m .55532 .6026 L .58169 .58447 L p F P
0 0 0 r
s
.731 .196 .081 r
.47475 .37424 m .45215 .37024 L .45102 .38834 L p F P
0 0 0 r
s
.731 .196 .081 r
.45102 .38834 m .47416 .39238 L .47475 .37424 L p F P
0 0 0 r
s
.024 .035 .067 r
.37129 .40619 m .37596 .3913 L .37882 .37317 L p F P
0 0 0 r
s
.045 .065 .149 r
.37596 .3913 m .37129 .40619 L .37175 .42733 L p F P
0 0 0 r
s
1 .29 .123 r
.58169 .58447 m .57142 .58291 L .54834 .60157 L p F P
0 0 0 r
s
1 .29 .123 r
.54135 .60053 m .54834 .60157 L .57142 .58291 L p F P
0 0 0 r
s
.24 .35 .67 r
.56285 .60024 m
.56365 .59878 L
s
.024 .035 .067 r
.38352 .35808 m .37882 .37317 L .37596 .3913 L p F P
0 0 0 r
s
.24 .35 .67 r
.38237 .3674 m
.3852 .35838 L
s
.73203 .33157 m
.71468 .36243 L
s
.71468 .36243 m
.72086 .38877 L
s
.848 .235 .098 r
.60962 .43706 m .5874 .43324 L .58474 .45639 L p F P
0 0 0 r
s
.848 .235 .098 r
.58474 .45639 m .60629 .46002 L .60962 .43706 L p F P
0 0 0 r
s
.243 .365 .736 r
.45829 .60073 m .46003 .59686 L .44083 .57582 L p F P
0 0 0 r
s
.83 .24 .1 r
.45951 .61233 m
.46379 .5999 L
s
.46379 .5999 m
.46466 .59738 L
s
.24 .35 .67 r
.45826 .60071 m
.45827 .6007 L
s
.243 .365 .736 r
.44083 .57582 m .43835 .58166 L .45829 .60073 L p F P
0 0 0 r
s
.799 .218 .091 r
.54271 .40436 m .52 .40039 L .51993 .42165 L p F P
0 0 0 r
s
.83 .24 .1 r
.54152 .40526 m
.54225 .40539 L
s
.799 .218 .091 r
.51993 .42165 m .54256 .42554 L .54271 .40436 L p F P
0 0 0 r
s
1 .29 .123 r
.57142 .58291 m .56112 .58136 L .54135 .60053 L p F P
0 0 0 r
s
1 .29 .123 r
.53434 .59949 m .54135 .60053 L .56112 .58136 L p F P
0 0 0 r
s
.918 .259 .109 r
.68016 .49755 m .6603 .49427 L .64603 .51811 L p F P
0 0 0 r
s
.918 .259 .109 r
.64603 .51811 m .66416 .52104 L .68016 .49755 L p F P
0 0 0 r
s
.24 .35 .67 r
.66505 .5163 m
.66709 .51327 L
s
.66709 .51327 m
.66974 .50934 L
s
.65839 .52753 m
.66241 .52076 L
s
.83 .24 .1 r
.67038 .51723 m
.67111 .511 L
s
.66982 .52201 m
.67038 .51723 L
s
.66364 .55555 m
.66982 .52201 L
s
.63768 .55148 m
.66364 .55555 L
s
.63625 .55125 m
.63768 .55148 L
s
.22 .332 .677 r
.4359 .58745 m .43835 .58166 L .41987 .56021 L p F P
0 0 0 r
s
.22 .332 .677 r
.41987 .56021 m .41681 .56786 L .4359 .58745 L p F P
0 0 0 r
s
.887 .248 .104 r
.64902 .46722 m .62772 .46363 L .62025 .48766 L p F P
0 0 0 r
s
.887 .248 .104 r
.62025 .48766 m .64033 .49098 L .64902 .46722 L p F P
0 0 0 r
s
1 .29 .123 r
.56112 .58136 m .55079 .5798 L .53434 .59949 L p F P
0 0 0 r
s
1 .29 .123 r
.52732 .59846 m .53434 .59949 L .55079 .5798 L p F P
0 0 0 r
s
.731 .196 .081 r
.45215 .37024 m .42942 .36621 L .42774 .38427 L p F P
0 0 0 r
s
.731 .196 .081 r
.42774 .38427 m .45102 .38834 L .45215 .37024 L p F P
0 0 0 r
s
.83 .24 .1 r
.41411 .60576 m
.4217 .58179 L
s
.41411 .60576 m
.36815 .5991 L
s
.24 .35 .67 r
.49556 .60089 m
.52862 .60575 L
s
.163 .246 .524 r
.38958 .51279 m .38567 .52374 L .39989 .5464 L p F P
0 0 0 r
s
.24 .35 .67 r
.39974 .54589 m
.40625 .55324 L
s
.125 .189 .421 r
.38567 .52374 m .38958 .51279 L .37874 .48831 L p F P
0 0 0 r
s
.24 .35 .67 r
.43177 .26403 m
.45474 .25022 L
s
.46607 .21667 m
.45474 .25022 L
s
1 .29 .123 r
.55079 .5798 m .54043 .57823 L .52732 .59846 L p F P
0 0 0 r
s
1 .29 .123 r
.52029 .59741 m .52732 .59846 L .54043 .57823 L p F P
0 0 0 r
s
.985 .284 .12 r
.58169 .58447 m .59194 .58601 L .61936 .56596 L p F P
0 0 0 r
s
.83 .24 .1 r
.60246 .57904 m
.6114 .5804 L
s
.6114 .5804 m
.61364 .57134 L
s
.66421 .52111 m
.66982 .52201 L
s
.24 .35 .67 r
.71772 .24798 m
.70065 .28084 L
s
.70065 .28084 m
.71916 .30548 L
s
.72034 .41457 m
.70321 .44363 L
s
.70321 .44363 m
.69566 .4676 L
s
.848 .235 .098 r
.5874 .43324 m .56505 .4294 L .56306 .45273 L p F P
0 0 0 r
s
.848 .235 .098 r
.56306 .45273 m .58474 .45639 L .5874 .43324 L p F P
0 0 0 r
s
1 .29 .123 r
.54043 .57823 m .53004 .57666 L .52029 .59741 L p F P
0 0 0 r
s
1 .29 .123 r
.51325 .59637 m .52029 .59741 L .53004 .57666 L p F P
0 0 0 r
s
.83 .24 .1 r
.51311 .59533 m
.51402 .59546 L
s
.35975 .34987 m
.38508 .35437 L
s
.194 .292 .608 r
.41681 .56786 m .41987 .56021 L .40344 .53701 L p F P
0 0 0 r
s
.194 .292 .608 r
.40344 .53701 m .39989 .5464 L .41681 .56786 L p F P
0 0 0 r
s
.085 .126 .306 r
.37568 .45076 m .37121 .46434 L .37874 .48831 L p F P
0 0 0 r
s
.24 .35 .67 r
.37138 .45271 m
.3732 .4583 L
s
.065 .095 .231 r
.37121 .46434 m .37568 .45076 L .37175 .42733 L p F P
0 0 0 r
s
.799 .218 .091 r
.52 .40039 m .49715 .3964 L .49716 .41774 L p F P
0 0 0 r
s
.83 .24 .1 r
.51881 .4013 m
.52 .40151 L
s
.49714 .3964 m
.49715 .3967 L
s
.799 .218 .091 r
.49716 .41774 m .51993 .42165 L .52 .40039 L p F P
0 0 0 r
s
.918 .259 .109 r
.6603 .49427 m .64033 .49098 L .6278 .51517 L p F P
0 0 0 r
s
.918 .259 .109 r
.6278 .51517 m .64603 .51811 L .6603 .49427 L p F P
0 0 0 r
s
.83 .24 .1 r
.27451 .58554 m
.2694 .60397 L
s
.2694 .60397 m
.22247 .59729 L
s
.985 .284 .12 r
.61936 .56596 m .60611 .56392 L .58169 .58447 L p F P
0 0 0 r
s
.24 .35 .67 r
.61744 .56567 m
.62241 .56322 L
s
.985 .284 .12 r
.57142 .58291 m .58169 .58447 L .60611 .56392 L p F P
0 0 0 r
s
.24 .35 .67 r
.56365 .59878 m
.56474 .59677 L
s
.163 .246 .524 r
.39989 .5464 m .40344 .53701 L .38958 .51279 L p F P
0 0 0 r
s
.243 .365 .736 r
.46003 .59686 m .46179 .59295 L .44333 .56992 L p F P
0 0 0 r
s
.24 .35 .67 r
.46001 .59683 m
.46001 .59682 L
s
.243 .365 .736 r
.44333 .56992 m .44083 .57582 L .46003 .59686 L p F P
0 0 0 r
s
.887 .248 .104 r
.62772 .46363 m .60629 .46002 L .60006 .48433 L p F P
0 0 0 r
s
.887 .248 .104 r
.60006 .48433 m .62025 .48766 L .62772 .46363 L p F P
0 0 0 r
s
.83 .24 .1 r
.26723 .31616 m
.22026 .30771 L
s
.26723 .31616 m
.26588 .33319 L
s
1 .29 .123 r
.53004 .57666 m .51962 .57509 L .51325 .59637 L p F P
0 0 0 r
s
.24 .35 .67 r
.52862 .60575 m
.54167 .58049 L
s
1 .29 .123 r
.50619 .59533 m .51325 .59637 L .51962 .57509 L p F P
0 0 0 r
s
.24 .35 .67 r
.4935 .20796 m
.52381 .2044 L
s
.53678 .16971 m
.52381 .2044 L
s
.944 .268 .113 r
.66416 .52104 m .64603 .51811 L .62778 .54157 L p F P
0 0 0 r
s
.83 .24 .1 r
.66407 .52109 m
.66411 .52109 L
s
.24 .35 .67 r
.66311 .51957 m
.66505 .5163 L
s
.66303 .51971 m
.66311 .51957 L
s
.944 .268 .113 r
.62778 .54157 m .64369 .54408 L .66416 .52104 L p F P
0 0 0 r
s
.731 .196 .081 r
.42942 .36621 m .40654 .36216 L .40432 .38018 L p F P
0 0 0 r
s
.731 .196 .081 r
.40432 .38018 m .42774 .38427 L .42942 .36621 L p F P
0 0 0 r
s
.966 .276 .117 r
.60611 .56392 m .61936 .56596 L .64369 .54408 L p F P
0 0 0 r
s
.985 .284 .12 r
.60611 .56392 m .5928 .56186 L .57142 .58291 L p F P
0 0 0 r
s
.24 .35 .67 r
.60098 .57747 m
.60389 .57234 L
s
.60389 .57234 m
.61123 .56873 L
s
.985 .284 .12 r
.56112 .58136 m .57142 .58291 L .5928 .56186 L p F P
0 0 0 r
s
1 .29 .123 r
.51962 .57509 m .50917 .57351 L .50619 .59533 L p F P
0 0 0 r
s
1 .29 .123 r
.49912 .59428 m .50619 .59533 L .50917 .57351 L p F P
0 0 0 r
s
.24 .35 .67 r
.39196 .33677 m
.40369 .31454 L
s
.41386 .28238 m
.40369 .31454 L
s
.966 .276 .117 r
.64369 .54408 m .62778 .54157 L .60611 .56392 L p F P
0 0 0 r
s
.24 .35 .67 r
.6351 .54995 m
.63559 .54912 L
s
1 .29 .123 r
.50917 .57351 m .4987 .57193 L .49912 .59428 L p F P
0 0 0 r
s
1 .29 .123 r
.49203 .59323 m .49912 .59428 L .4987 .57193 L p F P
0 0 0 r
s
.848 .235 .098 r
.56505 .4294 m .54256 .42554 L .54125 .44905 L p F P
0 0 0 r
s
.848 .235 .098 r
.54125 .44905 m .56306 .45273 L .56505 .4294 L p F P
0 0 0 r
s
.22 .332 .677 r
.43835 .58166 m .44083 .57582 L .42297 .55245 L p F P
0 0 0 r
s
.22 .332 .677 r
.42297 .55245 m .41987 .56021 L .43835 .58166 L p F P
0 0 0 r
s
.918 .259 .109 r
.64033 .49098 m .62025 .48766 L .60949 .51221 L p F P
0 0 0 r
s
.918 .259 .109 r
.60949 .51221 m .6278 .51517 L .64033 .49098 L p F P
0 0 0 r
s
.83 .24 .1 r
.62541 .51484 m
.62541 .51478 L
s
.24 .35 .67 r
.47842 .59521 m
.49556 .60089 L
s
.47498 .59407 m
.47842 .59521 L
s
.985 .284 .12 r
.5928 .56186 m .57945 .5598 L .56112 .58136 L p F P
0 0 0 r
s
.985 .284 .12 r
.55079 .5798 m .56112 .58136 L .57945 .5598 L p F P
0 0 0 r
s
.799 .218 .091 r
.49715 .3964 m .47416 .39238 L .47425 .4138 L p F P
0 0 0 r
s
.83 .24 .1 r
.49595 .39731 m
.49715 .39752 L
s
.799 .218 .091 r
.47425 .4138 m .49716 .41774 L .49715 .3964 L p F P
0 0 0 r
s
.944 .268 .113 r
.64603 .51811 m .6278 .51517 L .6118 .53905 L p F P
0 0 0 r
s
.83 .24 .1 r
.62541 .51484 m
.62777 .51522 L
s
.64595 .51816 m
.64598 .51816 L
s
.944 .268 .113 r
.6118 .53905 m .62778 .54157 L .64603 .51811 L p F P
0 0 0 r
s
.24 .35 .67 r
.63559 .54912 m
.64465 .5336 L
s
.966 .276 .117 r
.5928 .56186 m .60611 .56392 L .62778 .54157 L p F P
0 0 0 r
s
.887 .248 .104 r
.60629 .46002 m .58474 .45639 L .57976 .48097 L p F P
0 0 0 r
s
.887 .248 .104 r
.57976 .48097 m .60006 .48433 L .60629 .46002 L p F P
0 0 0 r
s
.83 .24 .1 r
.61968 .54627 m
.62074 .54046 L
s
.62443 .5202 m
.62541 .51484 L
s
1 .29 .123 r
.4987 .57193 m .48819 .57034 L .49203 .59323 L p F P
0 0 0 r
s
.24 .35 .67 r
.49556 .60089 m
.50789 .57539 L
s
1 .29 .123 r
.48494 .59218 m .49203 .59323 L .48819 .57034 L p F P
0 0 0 r
s
.24 .35 .67 r
.68137 .48881 m
.66505 .5163 L
s
.64465 .5336 m
.66505 .5163 L
s
.243 .365 .736 r
.46179 .59295 m .46356 .58902 L .44586 .56395 L p F P
0 0 0 r
s
.24 .35 .67 r
.46177 .59292 m
.46177 .59291 L
s
.243 .365 .736 r
.44586 .56395 m .44333 .56992 L .46179 .59295 L p F P
0 0 0 r
s
.065 .095 .231 r
.37641 .41274 m .37175 .42733 L .37568 .45076 L p F P
0 0 0 r
s
.045 .065 .149 r
.37175 .42733 m .37641 .41274 L .37596 .3913 L p F P
0 0 0 r
s
.24 .35 .67 r
.37607 .39644 m
.37731 .39249 L
s
.731 .196 .081 r
.40654 .36216 m .38352 .35808 L .38074 .37606 L p F P
0 0 0 r
s
.731 .196 .081 r
.38074 .37606 m .40432 .38018 L .40654 .36216 L p F P
0 0 0 r
s
.24 .35 .67 r
.37731 .39249 m
.38113 .37358 L
s
.985 .284 .12 r
.57945 .5598 m .56605 .55773 L .55079 .5798 L p F P
0 0 0 r
s
.985 .284 .12 r
.54043 .57823 m .55079 .5798 L .56605 .55773 L p F P
0 0 0 r
s
.24 .35 .67 r
.56474 .59677 m
.57421 .57941 L
s
.966 .276 .117 r
.62778 .54157 m .6118 .53905 L .5928 .56186 L p F P
0 0 0 r
s
1 .29 .123 r
.48819 .57034 m .47765 .56875 L .48494 .59218 L p F P
0 0 0 r
s
1 .29 .123 r
.47782 .59113 m .48494 .59218 L .47765 .56875 L p F P
0 0 0 r
s
.83 .24 .1 r
.37515 .57489 m
.36815 .5991 L
s
.36815 .5991 m
.32161 .59236 L
s
.24 .35 .67 r
.57421 .57941 m
.60389 .57234 L
s
.125 .189 .421 r
.38301 .47579 m .37874 .48831 L .38958 .51279 L p F P
0 0 0 r
s
.085 .126 .306 r
.37874 .48831 m .38301 .47579 L .37568 .45076 L p F P
0 0 0 r
s
.966 .276 .117 r
.57945 .5598 m .5928 .56186 L .6118 .53905 L p F P
0 0 0 r
s
1 .29 .123 r
.47765 .56875 m .46708 .56716 L .47782 .59113 L p F P
0 0 0 r
s
1 .29 .123 r
.4707 .59007 m .47782 .59113 L .46708 .56716 L p F P
0 0 0 r
s
.83 .24 .1 r
.46735 .58958 m
.46769 .5886 L
s
.46769 .5886 m
.47053 .58902 L
s
.918 .259 .109 r
.62025 .48766 m .60006 .48433 L .59109 .50924 L p F P
0 0 0 r
s
.918 .259 .109 r
.59109 .50924 m .60949 .51221 L .62025 .48766 L p F P
0 0 0 r
s
.848 .235 .098 r
.54256 .42554 m .51993 .42165 L .51932 .44536 L p F P
0 0 0 r
s
.848 .235 .098 r
.51932 .44536 m .54125 .44905 L .54256 .42554 L p F P
0 0 0 r
s
.944 .268 .113 r
.6278 .51517 m .60949 .51221 L .59575 .53651 L p F P
0 0 0 r
s
.944 .268 .113 r
.59575 .53651 m .6118 .53905 L .6278 .51517 L p F P
0 0 0 r
s
.985 .284 .12 r
.56605 .55773 m .5526 .55566 L .54043 .57823 L p F P
0 0 0 r
s
.985 .284 .12 r
.53004 .57666 m .54043 .57823 L .5526 .55566 L p F P
0 0 0 r
s
.83 .24 .1 r
.35975 .34987 m
.3131 .34158 L
s
.35975 .34987 m
.3586 .37334 L
s
.799 .218 .091 r
.47416 .39238 m .45102 .38834 L .4512 .40984 L p F P
0 0 0 r
s
.83 .24 .1 r
.47296 .3933 m
.47416 .39351 L
s
.799 .218 .091 r
.4512 .40984 m .47425 .4138 L .47416 .39238 L p F P
0 0 0 r
s
.83 .24 .1 r
.22681 .57863 m
.22247 .59729 L
s
.22247 .59729 m
.17496 .59053 L
s
.887 .248 .104 r
.58474 .45639 m .56306 .45273 L .55934 .4776 L p F P
0 0 0 r
s
.887 .248 .104 r
.55934 .4776 m .57976 .48097 L .58474 .45639 L p F P
0 0 0 r
s
1 .29 .123 r
.46708 .56716 m .45649 .56556 L .4707 .59007 L p F P
0 0 0 r
s
1 .29 .123 r
.46356 .58902 m .4707 .59007 L .45649 .56556 L p F P
0 0 0 r
s
.24 .35 .67 r
.46354 .58898 m
.46354 .58896 L
s
.46501 .58571 m
.46568 .58421 L
s
.83 .24 .1 r
.46275 .58787 m
.46323 .58794 L
s
.966 .276 .117 r
.6118 .53905 m .59575 .53651 L .57945 .5598 L p F P
0 0 0 r
s
.24 .35 .67 r
.60389 .57234 m
.61879 .54613 L
s
.194 .292 .608 r
.41987 .56021 m .42297 .55245 L .40704 .52746 L p F P
0 0 0 r
s
.194 .292 .608 r
.40704 .52746 m .40344 .53701 L .41987 .56021 L p F P
0 0 0 r
s
.83 .24 .1 r
.21806 .32469 m
.22026 .30771 L
s
.024 .035 .067 r
.37596 .3913 m .38074 .37606 L .38352 .35808 L p F P
0 0 0 r
s
.24 .35 .67 r
.38326 .37362 m
.38691 .36202 L
s
.045 .065 .149 r
.38074 .37606 m .37596 .3913 L .37641 .41274 L p F P
0 0 0 r
s
.966 .276 .117 r
.56605 .55773 m .57945 .5598 L .59575 .53651 L p F P
0 0 0 r
s
.985 .284 .12 r
.5526 .55566 m .5391 .55357 L .53004 .57666 L p F P
0 0 0 r
s
.985 .284 .12 r
.51962 .57509 m .53004 .57666 L .5391 .55357 L p F P
0 0 0 r
s
1 .29 .123 r
.45649 .56556 m .44586 .56395 L .46356 .58902 L p F P
0 0 0 r
s
.83 .24 .1 r
.4217 .58179 m
.45974 .58742 L
s
.163 .246 .524 r
.39358 .50163 m .38958 .51279 L .40344 .53701 L p F P
0 0 0 r
s
.125 .189 .421 r
.38958 .51279 m .39358 .50163 L .38301 .47579 L p F P
0 0 0 r
s
.22 .332 .677 r
.44083 .57582 m .44333 .56992 L .42611 .54459 L p F P
0 0 0 r
s
.22 .332 .677 r
.42611 .54459 m .42297 .55245 L .44083 .57582 L p F P
0 0 0 r
s
.918 .259 .109 r
.60006 .48433 m .57976 .48097 L .57259 .50625 L p F P
0 0 0 r
s
.918 .259 .109 r
.57259 .50625 m .59109 .50924 L .60006 .48433 L p F P
0 0 0 r
s
.944 .268 .113 r
.60949 .51221 m .59109 .50924 L .57963 .53397 L p F P
0 0 0 r
s
.83 .24 .1 r
.60942 .51226 m
.60946 .51226 L
s
.944 .268 .113 r
.57963 .53397 m .59575 .53651 L .60949 .51221 L p F P
0 0 0 r
s
.24 .35 .67 r
.73682 .27289 m
.71916 .30548 L
s
.71916 .30548 m
.73203 .33157 L
s
.163 .246 .524 r
.40344 .53701 m .40704 .52746 L .39358 .50163 L p F P
0 0 0 r
s
.24 .35 .67 r
.39427 .50296 m
.39453 .50223 L
s
.985 .284 .12 r
.5391 .55357 m .52555 .55148 L .51962 .57509 L p F P
0 0 0 r
s
.985 .284 .12 r
.50917 .57351 m .51962 .57509 L .52555 .55148 L p F P
0 0 0 r
s
.848 .235 .098 r
.51993 .42165 m .49716 .41774 L .49725 .44164 L p F P
0 0 0 r
s
.848 .235 .098 r
.49725 .44164 m .51932 .44536 L .51993 .42165 L p F P
0 0 0 r
s
.966 .276 .117 r
.59575 .53651 m .57963 .53397 L .56605 .55773 L p F P
0 0 0 r
s
.966 .276 .117 r
.5526 .55566 m .56605 .55773 L .57963 .53397 L p F P
0 0 0 r
s
.24 .35 .67 r
.73857 .35813 m
.72086 .38877 L
s
.72086 .38877 m
.72034 .41457 L
s
.799 .218 .091 r
.45102 .38834 m .42774 .38427 L .428 .40585 L p F P
0 0 0 r
s
.83 .24 .1 r
.44982 .38926 m
.45103 .38947 L
s
.799 .218 .091 r
.428 .40585 m .4512 .40984 L .45102 .38834 L p F P
0 0 0 r
s
.887 .248 .104 r
.56306 .45273 m .54125 .44905 L .53882 .47421 L p F P
0 0 0 r
s
.887 .248 .104 r
.53882 .47421 m .55934 .4776 L .56306 .45273 L p F P
0 0 0 r
s
.985 .284 .12 r
.52555 .55148 m .51195 .54938 L .50917 .57351 L p F P
0 0 0 r
s
.985 .284 .12 r
.4987 .57193 m .50917 .57351 L .51195 .54938 L p F P
0 0 0 r
s
.24 .35 .67 r
.46607 .21667 m
.4935 .20796 L
s
.50588 .17302 m
.4935 .20796 L
s
.60261 .17845 m
.63515 .19001 L
s
.63515 .19001 m
.66589 .20583 L
s
.966 .276 .117 r
.57963 .53397 m .56344 .53141 L .5526 .55566 L p F P
0 0 0 r
s
.966 .276 .117 r
.5391 .55357 m .5526 .55566 L .56344 .53141 L p F P
0 0 0 r
s
.83 .24 .1 r
.32801 .5679 m
.32161 .59236 L
s
.32161 .59236 m
.27451 .58554 L
s
.944 .268 .113 r
.59109 .50924 m .57259 .50625 L .56344 .53141 L p F P
0 0 0 r
s
.83 .24 .1 r
.5758 .53336 m
.5783 .51949 L
s
.59102 .50929 m
.59106 .50929 L
s
.944 .268 .113 r
.56344 .53141 m .57963 .53397 L .59109 .50924 L p F P
0 0 0 r
s
.085 .126 .306 r
.38024 .43689 m .37568 .45076 L .38301 .47579 L p F P
0 0 0 r
s
.065 .095 .231 r
.37568 .45076 m .38024 .43689 L .37641 .41274 L p F P
0 0 0 r
s
.918 .259 .109 r
.57976 .48097 m .55934 .4776 L .55399 .50325 L p F P
0 0 0 r
s
.918 .259 .109 r
.55399 .50325 m .57259 .50625 L .57976 .48097 L p F P
0 0 0 r
s
.24 .35 .67 r
.41386 .28238 m
.43177 .26403 L
s
.4427 .23037 m
.43177 .26403 L
s
.985 .284 .12 r
.51195 .54938 m .4983 .54728 L .4987 .57193 L p F P
0 0 0 r
s
.985 .284 .12 r
.48819 .57034 m .4987 .57193 L .4983 .54728 L p F P
0 0 0 r
s
.24 .35 .67 r
.66589 .20583 m
.69376 .22537 L
s
.848 .235 .098 r
.49716 .41774 m .47425 .4138 L .47505 .43789 L p F P
0 0 0 r
s
.848 .235 .098 r
.47505 .43789 m .49725 .44164 L .49716 .41774 L p F P
0 0 0 r
s
.83 .24 .1 r
.3131 .34158 m
.26588 .33319 L
s
.3131 .34158 m
.31125 .36507 L
s
.24 .35 .67 r
.56943 .17158 m
.60261 .17845 L
s
.83 .24 .1 r
.37515 .57489 m
.4217 .58179 L
s
.887 .248 .104 r
.54125 .44905 m .51932 .44536 L .51817 .47081 L p F P
0 0 0 r
s
.887 .248 .104 r
.51817 .47081 m .53882 .47421 L .54125 .44905 L p F P
0 0 0 r
s
.799 .218 .091 r
.42774 .38427 m .40432 .38018 L .40466 .40184 L p F P
0 0 0 r
s
.83 .24 .1 r
.42653 .38519 m
.42776 .38541 L
s
.799 .218 .091 r
.40466 .40184 m .428 .40585 L .42774 .38427 L p F P
0 0 0 r
s
.83 .24 .1 r
.17496 .59053 m
.17851 .57164 L
s
.966 .276 .117 r
.56344 .53141 m .54717 .52884 L .5391 .55357 L p F P
0 0 0 r
s
.966 .276 .117 r
.52555 .55148 m .5391 .55357 L .54717 .52884 L p F P
0 0 0 r
s
.985 .284 .12 r
.4983 .54728 m .4846 .54516 L .48819 .57034 L p F P
0 0 0 r
s
.985 .284 .12 r
.47765 .56875 m .48819 .57034 L .4846 .54516 L p F P
0 0 0 r
s
.24 .35 .67 r
.71286 .43869 m
.69566 .4676 L
s
.69566 .4676 m
.68137 .48881 L
s
.944 .268 .113 r
.54717 .52884 m .56344 .53141 L .57259 .50625 L p F P
0 0 0 r
s
.22 .332 .677 r
.44333 .56992 m .44586 .56395 L .42929 .53663 L p F P
0 0 0 r
s
.22 .332 .677 r
.42929 .53663 m .42611 .54459 L .44333 .56992 L p F P
0 0 0 r
s
.83 .24 .1 r
.4217 .58179 m
.42919 .55267 L
s
.944 .268 .113 r
.57259 .50625 m .55399 .50325 L .54717 .52884 L p F P
0 0 0 r
s
.194 .292 .608 r
.42297 .55245 m .42611 .54459 L .4107 .51776 L p F P
0 0 0 r
s
.194 .292 .608 r
.4107 .51776 m .40704 .52746 L .42297 .55245 L p F P
0 0 0 r
s
.918 .259 .109 r
.55934 .4776 m .53882 .47421 L .53531 .50023 L p F P
0 0 0 r
s
.918 .259 .109 r
.53531 .50023 m .55399 .50325 L .55934 .4776 L p F P
0 0 0 r
s
.24 .35 .67 r
.58855 .55311 m
.57421 .57941 L
s
.57421 .57941 m
.54167 .58049 L
s
.985 .284 .12 r
.4846 .54516 m .47085 .54304 L .47765 .56875 L p F P
0 0 0 r
s
.24 .35 .67 r
.46568 .58421 m
.46661 .58215 L
s
.985 .284 .12 r
.46708 .56716 m .47765 .56875 L .47085 .54304 L p F P
0 0 0 r
s
.966 .276 .117 r
.54717 .52884 m .53084 .52626 L .52555 .55148 L p F P
0 0 0 r
s
.966 .276 .117 r
.51195 .54938 m .52555 .55148 L .53084 .52626 L p F P
0 0 0 r
s
.848 .235 .098 r
.47425 .4138 m .4512 .40984 L .45271 .43413 L p F P
0 0 0 r
s
.848 .235 .098 r
.45271 .43413 m .47505 .43789 L .47425 .4138 L p F P
0 0 0 r
s
.887 .248 .104 r
.51932 .44536 m .49725 .44164 L .49741 .46738 L p F P
0 0 0 r
s
.887 .248 .104 r
.49741 .46738 m .51817 .47081 L .51932 .44536 L p F P
0 0 0 r
s
.125 .189 .421 r
.38738 .463 m .38301 .47579 L .39358 .50163 L p F P
0 0 0 r
s
.24 .35 .67 r
.39335 .50025 m
.39453 .50223 L
s
.085 .126 .306 r
.38301 .47579 m .38738 .463 L .38024 .43689 L p F P
0 0 0 r
s
.944 .268 .113 r
.53084 .52626 m .54717 .52884 L .55399 .50325 L p F P
0 0 0 r
s
.799 .218 .091 r
.40432 .38018 m .38074 .37606 L .38118 .39781 L p F P
0 0 0 r
s
.83 .24 .1 r
.4031 .3811 m
.40433 .38132 L
s
.24 .35 .67 r
.37969 .38493 m
.38085 .38127 L
s
.3824 .37635 m
.38326 .37362 L
s
.799 .218 .091 r
.38118 .39781 m .40466 .40184 L .40432 .38018 L p F P
0 0 0 r
s
.24 .35 .67 r
.38691 .36202 m
.39196 .33677 L
s
.402 .30468 m
.39196 .33677 L
s
.69376 .22537 m
.71772 .24798 L
s
.065 .095 .231 r
.38118 .39781 m .37641 .41274 L .38024 .43689 L p F P
0 0 0 r
s
.24 .35 .67 r
.37788 .40027 m
.37835 .40666 L
s
.045 .065 .149 r
.37641 .41274 m .38118 .39781 L .38074 .37606 L p F P
0 0 0 r
s
.83 .24 .1 r
.3586 .37334 m
.3804 .37714 L
s
.985 .284 .12 r
.47085 .54304 m .45705 .54091 L .46708 .56716 L p F P
0 0 0 r
s
.985 .284 .12 r
.45649 .56556 m .46708 .56716 L .45705 .54091 L p F P
0 0 0 r
s
.24 .35 .67 r
.46661 .58215 m
.47463 .56431 L
s
.944 .268 .113 r
.55399 .50325 m .53531 .50023 L .53084 .52626 L p F P
0 0 0 r
s
.966 .276 .117 r
.53084 .52626 m .51443 .52367 L .51195 .54938 L p F P
0 0 0 r
s
.966 .276 .117 r
.4983 .54728 m .51195 .54938 L .51443 .52367 L p F P
0 0 0 r
s
.24 .35 .67 r
.6607 .50615 m
.64465 .5336 L
s
.64465 .5336 m
.61879 .54613 L
s
.53678 .16971 m
.56943 .17158 L
s
.918 .259 .109 r
.53882 .47421 m .51817 .47081 L .51653 .4972 L p F P
0 0 0 r
s
.918 .259 .109 r
.51653 .4972 m .53531 .50023 L .53882 .47421 L p F P
0 0 0 r
s
.83 .24 .1 r
.53492 .50023 m
.53493 .50017 L
s
.5303 .52618 m
.53492 .50023 L
s
.53492 .50023 m
.5353 .50029 L
s
.163 .246 .524 r
.40704 .52746 m .4107 .51776 L .39764 .49026 L p F P
0 0 0 r
s
.163 .246 .524 r
.39764 .49026 m .39358 .50163 L .40704 .52746 L p F P
0 0 0 r
s
.83 .24 .1 r
.28028 .56083 m
.27451 .58554 L
s
.27451 .58554 m
.22681 .57863 L
s
.985 .284 .12 r
.45705 .54091 m .44319 .53877 L .45649 .56556 L p F P
0 0 0 r
s
.985 .284 .12 r
.44586 .56395 m .45649 .56556 L .44319 .53877 L p F P
0 0 0 r
s
.125 .189 .421 r
.39358 .50163 m .39764 .49026 L .38738 .463 L p F P
0 0 0 r
s
.944 .268 .113 r
.51443 .52367 m .53084 .52626 L .53531 .50023 L p F P
0 0 0 r
s
.848 .235 .098 r
.4512 .40984 m .428 .40585 L .43024 .43034 L p F P
0 0 0 r
s
.848 .235 .098 r
.43024 .43034 m .45271 .43413 L .4512 .40984 L p F P
0 0 0 r
s
.966 .276 .117 r
.51443 .52367 m .49795 .52107 L .4983 .54728 L p F P
0 0 0 r
s
.966 .276 .117 r
.4846 .54516 m .4983 .54728 L .49795 .52107 L p F P
0 0 0 r
s
.83 .24 .1 r
.26588 .33319 m
.21806 .32469 L
s
.26588 .33319 m
.2633 .3567 L
s
.887 .248 .104 r
.49725 .44164 m .47505 .43789 L .47654 .46393 L p F P
0 0 0 r
s
.887 .248 .104 r
.47654 .46393 m .49741 .46738 L .49725 .44164 L p F P
0 0 0 r
s
.83 .24 .1 r
.38221 .54552 m
.37515 .57489 L
s
.37515 .57489 m
.32801 .5679 L
s
.944 .268 .113 r
.53531 .50023 m .51653 .4972 L .51443 .52367 L p F P
0 0 0 r
s
.985 .284 .12 r
.44319 .53877 m .42929 .53663 L .44586 .56395 L p F P
0 0 0 r
s
.24 .35 .67 r
.44138 .55315 m
.44361 .5478 L
s
.83 .24 .1 r
.42919 .55267 m
.43856 .5541 L
s
.918 .259 .109 r
.51817 .47081 m .49741 .46738 L .49765 .49415 L p F P
0 0 0 r
s
.918 .259 .109 r
.49765 .49415 m .51653 .4972 L .51817 .47081 L p F P
0 0 0 r
s
.24 .35 .67 r
.7502 .29923 m
.73203 .33157 L
s
.73203 .33157 m
.73857 .35813 L
s
.944 .268 .113 r
.49795 .52107 m .51443 .52367 L .51653 .4972 L p F P
0 0 0 r
s
.966 .276 .117 r
.49795 .52107 m .48139 .51846 L .4846 .54516 L p F P
0 0 0 r
s
.966 .276 .117 r
.47085 .54304 m .4846 .54516 L .48139 .51846 L p F P
0 0 0 r
s
.194 .292 .608 r
.42611 .54459 m .42929 .53663 L .41442 .50788 L p F P
0 0 0 r
s
.194 .292 .608 r
.41442 .50788 m .4107 .51776 L .42611 .54459 L p F P
0 0 0 r
s
.83 .24 .1 r
.3586 .37334 m
.31125 .36507 L
s
.3586 .37334 m
.35602 .40217 L
s
.944 .268 .113 r
.51653 .4972 m .49765 .49415 L .49795 .52107 L p F P
0 0 0 r
s
.848 .235 .098 r
.428 .40585 m .40466 .40184 L .40764 .42653 L p F P
0 0 0 r
s
.848 .235 .098 r
.40764 .42653 m .43024 .43034 L .428 .40585 L p F P
0 0 0 r
s
.887 .248 .104 r
.47505 .43789 m .45271 .43413 L .45554 .46046 L p F P
0 0 0 r
s
.887 .248 .104 r
.45554 .46046 m .47654 .46393 L .47505 .43789 L p F P
0 0 0 r
s
.24 .35 .67 r
.55534 .55402 m
.54167 .58049 L
s
.54167 .58049 m
.50789 .57539 L
s
.4427 .23037 m
.46607 .21667 L
s
.47794 .18153 m
.46607 .21667 L
s
.966 .276 .117 r
.48139 .51846 m .46476 .51583 L .47085 .54304 L p F P
0 0 0 r
s
.966 .276 .117 r
.45705 .54091 m .47085 .54304 L .46476 .51583 L p F P
0 0 0 r
s
.085 .126 .306 r
.3849 .42269 m .38024 .43689 L .38738 .463 L p F P
0 0 0 r
s
.065 .095 .231 r
.38024 .43689 m .3849 .42269 L .38118 .39781 L p F P
0 0 0 r
s
.944 .268 .113 r
.48139 .51846 m .49795 .52107 L .49765 .49415 L p F P
0 0 0 r
s
.918 .259 .109 r
.49741 .46738 m .47654 .46393 L .47867 .49108 L p F P
0 0 0 r
s
.918 .259 .109 r
.47867 .49108 m .49765 .49415 L .49741 .46738 L p F P
0 0 0 r
s
.83 .24 .1 r
.42919 .55267 m
.43087 .54476 L
s
.43087 .54476 m
.43117 .54333 L
s
.38221 .54552 m
.42919 .55267 L
s
.24 .35 .67 r
.71772 .24798 m
.73682 .27289 L
s
.43581 .54175 m
.44361 .5478 L
s
.73828 .38411 m
.72034 .41457 L
s
.72034 .41457 m
.71286 .43869 L
s
.83 .24 .1 r
.23195 .55367 m
.22681 .57863 L
s
.22681 .57863 m
.17851 .57164 L
s
.944 .268 .113 r
.49765 .49415 m .47867 .49108 L .48139 .51846 L p F P
0 0 0 r
s
.966 .276 .117 r
.46476 .51583 m .44806 .5132 L .45705 .54091 L p F P
0 0 0 r
s
.966 .276 .117 r
.44319 .53877 m .45705 .54091 L .44806 .5132 L p F P
0 0 0 r
s
.24 .35 .67 r
.50588 .17302 m
.53678 .16971 L
s
.848 .235 .098 r
.40466 .40184 m .38118 .39781 L .3849 .42269 L p F P
0 0 0 r
s
.24 .35 .67 r
.38363 .40605 m
.3839 .4052 L
s
.848 .235 .098 r
.3849 .42269 m .40764 .42653 L .40466 .40184 L p F P
0 0 0 r
s
.24 .35 .67 r
.3839 .4052 m
.38906 .38925 L
s
.887 .248 .104 r
.45271 .43413 m .43024 .43034 L .43443 .45698 L p F P
0 0 0 r
s
.887 .248 .104 r
.43443 .45698 m .45554 .46046 L .45271 .43413 L p F P
0 0 0 r
s
.944 .268 .113 r
.46476 .51583 m .48139 .51846 L .47867 .49108 L p F P
0 0 0 r
s
.83 .24 .1 r
.21474 .34823 m
.21806 .32469 L
s
.33463 .53828 m
.32801 .5679 L
s
.32801 .5679 m
.28028 .56083 L
s
.24 .35 .67 r
.402 .30468 m
.41386 .28238 L
s
.42452 .24869 m
.41386 .28238 L
s
.163 .246 .524 r
.4107 .51776 m .41442 .50788 L .40179 .47867 L p F P
0 0 0 r
s
.163 .246 .524 r
.40179 .47867 m .39764 .49026 L .4107 .51776 L p F P
0 0 0 r
s
.918 .259 .109 r
.47654 .46393 m .45554 .46046 L .4596 .488 L p F P
0 0 0 r
s
.918 .259 .109 r
.4596 .488 m .47867 .49108 L .47654 .46393 L p F P
0 0 0 r
s
.966 .276 .117 r
.44806 .5132 m .43128 .51055 L .44319 .53877 L p F P
0 0 0 r
s
.966 .276 .117 r
.42929 .53663 m .44319 .53877 L .43128 .51055 L p F P
0 0 0 r
s
.125 .189 .421 r
.39184 .44995 m .38738 .463 L .39764 .49026 L p F P
0 0 0 r
s
.085 .126 .306 r
.38738 .463 m .39184 .44995 L .3849 .42269 L p F P
0 0 0 r
s
.83 .24 .1 r
.35602 .40217 m
.38212 .40663 L
s
.24 .35 .67 r
.52082 .54868 m
.50789 .57539 L
s
.50789 .57539 m
.47463 .56431 L
s
.944 .268 .113 r
.47867 .49108 m .4596 .488 L .46476 .51583 L p F P
0 0 0 r
s
.24 .35 .67 r
.44361 .5478 m
.47463 .56431 L
s
.44361 .5478 m
.455 .52041 L
s
.944 .268 .113 r
.44806 .5132 m .46476 .51583 L .4596 .488 L p F P
0 0 0 r
s
.125 .189 .421 r
.39764 .49026 m .40179 .47867 L .39184 .44995 L p F P
0 0 0 r
s
.24 .35 .67 r
.69846 .45999 m
.68137 .48881 L
s
.68137 .48881 m
.6607 .50615 L
s
.83 .24 .1 r
.31125 .36507 m
.2633 .3567 L
s
.31125 .36507 m
.3081 .394 L
s
.887 .248 .104 r
.43024 .43034 m .40764 .42653 L .41319 .45347 L p F P
0 0 0 r
s
.887 .248 .104 r
.41319 .45347 m .43443 .45698 L .43024 .43034 L p F P
0 0 0 r
s
.966 .276 .117 r
.43128 .51055 m .41442 .50788 L .42929 .53663 L p F P
0 0 0 r
s
.24 .35 .67 r
.48678 .53729 m
.47463 .56431 L
s
.918 .259 .109 r
.45554 .46046 m .43443 .45698 L .44043 .48491 L p F P
0 0 0 r
s
.918 .259 .109 r
.44043 .48491 m .4596 .488 L .45554 .46046 L p F P
0 0 0 r
s
.24 .35 .67 r
.6344 .51866 m
.61879 .54613 L
s
.61879 .54613 m
.58855 .55311 L
s
.83 .24 .1 r
.38892 .51249 m
.41669 .51684 L
s
.41669 .51684 m
.4182 .51708 L
s
.38892 .51249 m
.38221 .54552 L
s
.38221 .54552 m
.33463 .53828 L
s
.944 .268 .113 r
.4596 .488 m .44043 .48491 L .44806 .5132 L p F P
0 0 0 r
s
.944 .268 .113 r
.43128 .51055 m .44806 .5132 L .44043 .48491 L p F P
0 0 0 r
s
.24 .35 .67 r
.38691 .36202 m
.39698 .33009 L
s
.38906 .38925 m
.38691 .36202 L
s
.83 .24 .1 r
.17851 .57164 m
.183 .54642 L
s
.887 .248 .104 r
.40764 .42653 m .3849 .42269 L .39184 .44995 L p F P
0 0 0 r
s
.24 .35 .67 r
.3907 .4405 m
.39127 .4388 L
s
.887 .248 .104 r
.39184 .44995 m .41319 .45347 L .40764 .42653 L p F P
0 0 0 r
s
.24 .35 .67 r
.39127 .4388 m
.39857 .41721 L
s
.918 .259 .109 r
.43443 .45698 m .41319 .45347 L .42116 .48179 L p F P
0 0 0 r
s
.918 .259 .109 r
.42116 .48179 m .44043 .48491 L .43443 .45698 L p F P
0 0 0 r
s
.83 .24 .1 r
.28644 .53094 m
.28028 .56083 L
s
.28028 .56083 m
.23195 .55367 L
s
.944 .268 .113 r
.44043 .48491 m .42116 .48179 L .43128 .51055 L p F P
0 0 0 r
s
.24 .35 .67 r
.42048 .51628 m
.42082 .51539 L
s
.944 .268 .113 r
.41442 .50788 m .43128 .51055 L .42116 .48179 L p F P
0 0 0 r
s
.24 .35 .67 r
.73682 .27289 m
.7502 .29923 L
s
.83 .24 .1 r
.35602 .40217 m
.3081 .394 L
s
.35602 .40217 m
.3521 .43495 L
s
.24 .35 .67 r
.75714 .32601 m
.73857 .35813 L
s
.73857 .35813 m
.73828 .38411 L
s
.83 .24 .1 r
.3521 .43495 m
.3891 .4411 L
s
.2633 .3567 m
.21474 .34823 L
s
.2633 .3567 m
.25957 .38571 L
s
.944 .268 .113 r
.42116 .48179 m .40179 .47867 L .41442 .50788 L p F P
0 0 0 r
s
.24 .35 .67 r
.42082 .51539 m
.42715 .49894 L
s
.47794 .18153 m
.50588 .17302 L
s
.918 .259 .109 r
.41319 .45347 m .39184 .44995 L .40179 .47867 L p F P
0 0 0 r
s
.83 .24 .1 r
.39489 .47761 m
.3965 .46622 L
s
.40069 .47855 m
.40093 .47859 L
s
.39489 .47761 m
.40069 .47855 L
s
.918 .259 .109 r
.40179 .47867 m .42116 .48179 L .41319 .45347 L p F P
0 0 0 r
s
.24 .35 .67 r
.3993 .46519 m
.40463 .47407 L
s
.40337 .47758 m
.40463 .47407 L
s
.40332 .47772 m
.40337 .47758 L
s
.42452 .24869 m
.4427 .23037 L
s
.45417 .19509 m
.4427 .23037 L
s
.83 .24 .1 r
.38892 .51249 m
.39489 .47761 L
s
.38892 .51249 m
.34109 .50499 L
s
.34109 .50499 m
.33463 .53828 L
s
.33463 .53828 m
.28644 .53094 L
s
.34703 .46988 m
.39489 .47761 L
s
.24 .35 .67 r
.73088 .40837 m
.71286 .43869 L
s
.71286 .43869 m
.69846 .45999 L
s
.83 .24 .1 r
.23764 .52352 m
.23195 .55367 L
s
.23195 .55367 m
.183 .54642 L
s
.24 .35 .67 r
.60358 .52553 m
.58855 .55311 L
s
.58855 .55311 m
.55534 .55402 L
s
.83 .24 .1 r
.3081 .394 m
.25957 .38571 L
s
.3081 .394 m
.3038 .42692 L
s
.24 .35 .67 r
.39698 .33009 m
.402 .30468 L
s
.41253 .27104 m
.402 .30468 L
s
.42715 .49894 m
.40463 .47407 L
s
.41522 .44453 m
.40463 .47407 L
s
.83 .24 .1 r
.3521 .43495 m
.3038 .42692 L
s
.3521 .43495 m
.34703 .46988 L
s
.21042 .37733 m
.21474 .34823 L
s
.24 .35 .67 r
.67752 .47737 m
.6607 .50615 L
s
.6607 .50615 m
.6344 .51866 L
s
.83 .24 .1 r
.34703 .46988 m
.34109 .50499 L
s
.34109 .50499 m
.29265 .4974 L
s
.29265 .4974 m
.28644 .53094 L
s
.28644 .53094 m
.23764 .52352 L
s
.24 .35 .67 r
.39857 .41721 m
.38906 .38925 L
s
.39931 .35756 m
.38906 .38925 L
s
.83 .24 .1 r
.34703 .46988 m
.29855 .46205 L
s
.24 .35 .67 r
.7502 .29923 m
.75714 .32601 L
s
.83 .24 .1 r
.183 .54642 m
.18822 .51599 L
s
.25957 .38571 m
.21042 .37733 L
s
.25957 .38571 m
.25487 .41879 L
s
.24 .35 .67 r
.56968 .52626 m
.55534 .55402 L
s
.55534 .55402 m
.52082 .54868 L
s
.45417 .19509 m
.47794 .18153 L
s
.83 .24 .1 r
.3038 .42692 m
.25487 .41879 L
s
.3038 .42692 m
.29855 .46205 L
s
.24 .35 .67 r
.455 .52041 m
.42715 .49894 L
s
.43837 .46981 m
.42715 .49894 L
s
.75711 .35217 m
.73828 .38411 L
s
.73828 .38411 m
.73088 .40837 L
s
.83 .24 .1 r
.29855 .46205 m
.29265 .4974 L
s
.29265 .4974 m
.24359 .48971 L
s
.24359 .48971 m
.23764 .52352 L
s
.23764 .52352 m
.18822 .51599 L
s
.24 .35 .67 r
.41253 .27104 m
.42452 .24869 L
s
.43571 .21335 m
.42452 .24869 L
s
.83 .24 .1 r
.29855 .46205 m
.24944 .45412 L
s
.24 .35 .67 r
.53438 .52065 m
.52082 .54868 L
s
.52082 .54868 m
.48678 .53729 L
s
.48678 .53729 m
.455 .52041 L
s
.46695 .49167 m
.455 .52041 L
s
.7164 .42976 m
.69846 .45999 L
s
.69846 .45999 m
.67752 .47737 L
s
.83 .24 .1 r
.20532 .41055 m
.21042 .37733 L
s
.24 .35 .67 r
.49952 .50893 m
.48678 .53729 L
s
.65078 .48984 m
.6344 .51866 L
s
.6344 .51866 m
.60358 .52553 L
s
.83 .24 .1 r
.25487 .41879 m
.20532 .41055 L
s
.25487 .41879 m
.24944 .45412 L
s
.24 .35 .67 r
.39698 .33009 m
.40753 .29659 L
s
.39931 .35756 m
.39698 .33009 L
s
.41522 .44453 m
.39857 .41721 L
s
.40917 .38583 m
.39857 .41721 L
s
.83 .24 .1 r
.24944 .45412 m
.24359 .48971 L
s
.24359 .48971 m
.19389 .48192 L
s
.18822 .51599 m
.19389 .48192 L
s
.24944 .45412 m
.1997 .44609 L
s
.24 .35 .67 r
.75714 .32601 m
.75711 .35217 L
s
.43571 .21335 m
.45417 .19509 L
s
.83 .24 .1 r
.1997 .44609 m
.20532 .41055 L
s
.19389 .48192 m
.1997 .44609 L
s
.24 .35 .67 r
.74981 .37655 m
.73088 .40837 L
s
.73088 .40837 m
.7164 .42976 L
s
.61937 .49659 m
.60358 .52553 L
s
.60358 .52553 m
.56968 .52626 L
s
.40753 .29659 m
.41253 .27104 L
s
.42358 .23572 m
.41253 .27104 L
s
.43837 .46981 m
.41522 .44453 L
s
.42634 .41353 m
.41522 .44453 L
s
.69518 .44716 m
.67752 .47737 L
s
.67752 .47737 m
.65078 .48984 L
s
.40917 .38583 m
.39931 .35756 L
s
.41006 .32428 m
.39931 .35756 L
s
.58474 .4971 m
.56968 .52626 L
s
.56968 .52626 m
.53438 .52065 L
s
.46695 .49167 m
.43837 .46981 L
s
.45016 .43921 m
.43837 .46981 L
s
.75711 .35217 m
.74981 .37655 L
s
.42358 .23572 m
.43571 .21335 L
s
.54862 .49122 m
.53438 .52065 L
s
.53438 .52065 m
.49952 .50893 L
s
.49952 .50893 m
.46695 .49167 L
s
.47951 .46149 m
.46695 .49167 L
s
.73524 .39801 m
.7164 .42976 L
s
.7164 .42976 m
.69518 .44716 L
s
.51291 .47914 m
.49952 .50893 L
s
.66799 .45956 m
.65078 .48984 L
s
.65078 .48984 m
.61937 .49659 L
s
.40753 .29659 m
.41862 .2614 L
s
.41006 .32428 m
.40753 .29659 L
s
.42634 .41353 m
.40917 .38583 L
s
.42031 .35287 m
.40917 .38583 L
s
.74981 .37655 m
.73524 .39801 L
s
.63595 .46617 m
.61937 .49659 L
s
.61937 .49659 m
.58474 .4971 L
s
.41862 .2614 m
.42358 .23572 L
s
.45016 .43921 m
.42634 .41353 L
s
.43803 .38094 m
.42634 .41353 L
s
.71375 .4154 m
.69518 .44716 L
s
.69518 .44716 m
.66799 .45956 L
s
.42031 .35287 m
.41006 .32428 L
s
.42137 .28931 m
.41006 .32428 L
s
.60056 .46646 m
.58474 .4971 L
s
.58474 .4971 m
.54862 .49122 L
s
.47951 .46149 m
.45016 .43921 L
s
.46254 .40704 m
.45016 .43921 L
s
.5636 .46026 m
.54862 .49122 L
s
.54862 .49122 m
.51291 .47914 L
s
.51291 .47914 m
.47951 .46149 L
s
.49271 .42975 m
.47951 .46149 L
s
.73524 .39801 m
.71375 .4154 L
s
.527 .44782 m
.51291 .47914 L
s
.68609 .42772 m
.66799 .45956 L
s
.66799 .45956 m
.63595 .46617 L
s
.42137 .28931 m
.41862 .2614 L
s
.43803 .38094 m
.42031 .35287 L
s
.43202 .3182 m
.42031 .35287 L
s
.65341 .43416 m
.63595 .46617 L
s
.63595 .46617 m
.60056 .46646 L
s
.46254 .40704 m
.43803 .38094 L
s
.45033 .34665 m
.43803 .38094 L
s
.71375 .4154 m
.68609 .42772 L
s
.43202 .3182 m
.42137 .28931 L
s
.61723 .43419 m
.60056 .46646 L
s
.60056 .46646 m
.5636 .46026 L
s
.49271 .42975 m
.46254 .40704 L
s
.47559 .37317 m
.46254 .40704 L
s
.57937 .42767 m
.5636 .46026 L
s
.5636 .46026 m
.527 .44782 L
s
.527 .44782 m
.49271 .42975 L
s
.50661 .39633 m
.49271 .42975 L
s
.54183 .41483 m
.527 .44782 L
s
.68609 .42772 m
.65341 .43416 L
s
.45033 .34665 m
.43202 .3182 L
s
.65341 .43416 m
.61723 .43419 L
s
.47559 .37317 m
.45033 .34665 L
s
.61723 .43419 m
.57937 .42767 L
s
.50661 .39633 m
.47559 .37317 L
s
.57937 .42767 m
.54183 .41483 L
s
.54183 .41483 m
.50661 .39633 L
s
0 0 0 r
.25 Mabswid
.91053 .22236 m
.97075 .49223 L
s
.97075 .49223 m
.19793 .35868 L
s
.19793 .35868 m
.24028 .08168 L
s
.24028 .08168 m
.91053 .22236 L
s
.24028 .08168 m
.16861 .50547 L
s
.16861 .50547 m
.13045 .74993 L
s
.13045 .74993 m
.19793 .35868 L
s
.19793 .35868 m
.24028 .08168 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{500, 500},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40007d0001m2000`400?l00000o`00003oo`3ooooe
0?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3o
m^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40
oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?of
k_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3o
ool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^
m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?oo
o`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd
0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo
003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0
ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool0
0?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03o
m^h10?ooo`00o`3om^kd0?ofkP40oooo001g0?ofkP<00000o`3om^ij0?ofkP40oooo001g0?ofkP03
0000003om^h0ooK^00D00000o`3om^ie0?ofkP40oooo001g0?ofkP030000003om^h0ooK^00D0ooK^
1000003o0?ofkW40ooK^0@3oool007L0ooK^00<000000?ofkP3om^h02@3om^h500000?l0ooK^K03o
m^h10?ooo`00MP3om^h00`000000ooK^0?ofkP0?0?ofkPD00000o`3om^iW0?ofkP40oooo001f0?of
kP030000003om^h0ooK^01@0ooK^1@00003o0?ofkV80ooK^0@3oool007H0ooK^00<000000?ofkP3o
m^h06@3om^h500000?l0ooK^G@3om^h10?ooo`00MP3om^h00`000000ooK^0?ofkP0N0?ofkP@00000
o`3om^iI0?ofkP40oooo001f0?ofkP030000003om^h0ooK^0280ooK^1@00003o0?ofkU@0ooK^0@3o
ool007H0ooK^00<000000?ofkP3om^h09`3om^h500000?l0ooK^C`3om^h10?ooo`00M@3om^h00`00
0000ooK^0?ofkP0]0?ofkPD00000o`3om^i:0?ofkP40oooo001e0?ofkP030000003om^h0ooK^0380
ooK^1@00003o0?ofkTD0ooK^0@3oool007D0ooK^00<000000?ofkP3om^h0=`3om^h400000?l0ooK^
@@3om^h10?ooo`00M@3om^h00`000000ooK^0?ofkP0k0?ofkPD00000o`3om^hl0?ofkP40oooo001e
0?ofkP030000003om^h0ooK^0400ooK^1@00003o0?ofkSL0ooK^0@3oool007D0ooK^00<000000?of
kP3om^h0A@3om^h500000?l0ooK^<P3om^h10?ooo`00M03om^h2000004`0ooK^1000003o0?ofkRh0
ooK^0@3oool007@0ooK^00<000000?ofkP3om^h0C`3om^h500000?l0ooK^:@3om^h10?ooo`00M03o
m^h00`000000ooK^0?ofkP1D0?ofkPD00000o`3om^hT0?ofkP40oooo001d0?ofkP030000003om^h0
ooK^05T0ooK^1@00003o0?ofkQl0ooK^0@3oool007@0ooK^00<000000?ofkP3om^h0GP3om^h50000
0?l0ooK^6P3om^h10?ooo`00M03om^h00`000000ooK^0?ofkP1S0?ofkP@00000o`3om^hF0?ofkP40
oooo001c0?ofkP800000J@3om^h500000?l0ooK^4@3om^h10?ooo`00L`3om^h00`000000ooK^0?of
kP1]0?ofkPD00000o`3om^h<0?ofkP40oooo001c0?ofkP030000003om^h0ooK^0780ooK^1@00003o
0?ofkPL0ooK^0@3oool007<0ooK^00<000000?ofkP3om^h0M`3om^h500000?l0ooK^0P3om^h10?oo
o`00L`3om^h00`000000ooK^0?ofkP1l0?ofkP@00000o@3om^h10?ooo`00L`3om^h00`000000ooK^
0?ofkP200?ofkPD00000n03om^h10?ooo`00LP3om^h2000008L0ooK^1@00003c0?ofkP40oooo001b
0?ofkP800000S03om^h500000>h0ooK^0@3oool00780ooK^00<000000?ofkP3om^h0T03om^h40000
0>X0ooK^0@3oool00780ooK^00<000000?ofkP3om^h0U03om^h500000>D0ooK^0@3oool00780ooK^
00<000000?ofkP3om^h0V@3om^h500000>00ooK^0@3oool00780ooK^00<000000?ofkP3om^h0WP3o
m^h500000=/0ooK^0@3oool00740ooK^0P00002U0?ofkPD00000eP3om^h10?ooo`00L@3om^h20000
0:X0ooK^1000003B0?ofkP40oooo001a0?ofkP800000[P3om^h500000<d0ooK^0@3oool00740ooK^
00<000000?ofkP3om^h0/P3om^h500000<P0ooK^0@3oool00740ooK^00<000000?ofkP3om^h0]`3o
m^h500000<<0ooK^0@3oool00740ooK^00<000000?ofkP3om^h0_03om^h500000;h0ooK^0@3oool0
0700ooK^0P0000330?ofkP@00000^P3om^h10?ooo`00L03om^h200000<L0ooK^1@00002e0?ofkP40
oooo001`0?ofkP800000c03om^h500000;00ooK^0@3oool00700ooK^00<000000?ofkP3om^h0d03o
m^h500000:/0ooK^0@3oool00700ooK^00<000000?ofkP3om^h0U@3om^h<03eIZc@0ooK^1000002W
0?ofkP40oooo001`0?ofkP030000003om^h0ooK^08d0ooK^200mFJ/30?ofkP0303eIZ`3om^h0ooK^
00H0ooK^2P0mFJ/^0?ofkPD00000XP3om^h10?ooo`00K`3om^h2000008X0ooK^1@0mFJ/:0?ofkP03
03eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP0mFJ/00`0mFJ/_0?ofkPD00000W@3om^h10?ooo`00
K`3om^h2000008H0ooK^100mFJ/00`3om^h0?EV[0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00h0ooK^
00<0?EV[0?ofkP3om^h0103om^h403eIZc00ooK^1@00002H0?ofkP40oooo001_0?ofkP800000P`3o
m^h303eIZ`@0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3o
m^h0ooK^00P0ooK^100mFJ/a0?ofkPD00000T`3om^h10?ooo`00K`3om^h2000007l0ooK^100mFJ/7
0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0=
0?ofkP@0?EV[<P3om^h4000008l0ooK^0@3oool006l0ooK^00<000000?ofkP3om^h0O03om^h203eI
Z`/0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^
00l0ooK^00<0?EV[0?ofkP0mFJ/00P0mFJ/c0?ofkPD00000RP3om^h10?ooo`00K`3om^h00`000000
ooK^0?ofkP1j0?ofkP<0?EV[2`3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00h0
ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP<0?EV[=@3om^h5000008D0
ooK^0@3oool006h0ooK^0P00001j0?ofkP80?EV[00<0ooK^03eIZ`3om^h02`3om^h00`0mFJ/0ooK^
0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^
0?ofkP060?ofkP@0?EV[=P3om^h500000800ooK^0@3oool006h0ooK^0P00001i0?ofkP0503eIZ`3o
m^h0ooK^0?ofkP0mFJ/0303om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00h0ooK^
00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP<0?EV[>03om^h5000007/0ooK^
0@3oool006h0ooK^0P00001g0?ofkP80?EV[103om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3o
m^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3o
m^h0ooK^00h0ooK^0P0mFJ/k0?ofkP@00000M`3om^h10?ooo`00KP3om^h2000007D0ooK^0P0mFJ/5
0?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP0>
0?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h03`3om^h303eIZcd0ooK^1@00001b
0?ofkP40oooo001^0?ofkP030000003om^h0ooK^0780ooK^0P0mFJ/70?ofkP0303eIZ`3om^h0ooK^
00T0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^
00l0ooK^00<0?EV[0?ofkP3om^h03`3om^h0100mFJ/0ooK^0?ofkP3om^h203eIZd00ooK^1@00001]
0?ofkP40oooo001^0?ofkP030000003om^h0ooK^0740ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0m
FJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0m
FJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h00`3om^h203eI
Zd<0ooK^1@00001X0?ofkP40oooo001]0?ofkP800000LP3om^h203eIZ`P0ooK^00<0?EV[0?ofkP3o
m^h02P3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3o
m^h03P3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00H0ooK^0P0mFJ]60?ofkP@0
0000I03om^h10?ooo`00K@3om^h200000740ooK^0P0mFJ/90?ofkP0303eIZ`3om^h0ooK^00T0ooK^
00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00l0ooK^
00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP080?ofkP80?EV[B03om^h5000005l0ooK^
0@3oool006d0ooK^0P00001`0?ofkP0303eIZ`3om^h0?EV[00T0ooK^00<0?EV[0?ofkP3om^h02@3o
m^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h03P3o
m^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0303eIZ`3om^h0ooK^00X0ooK^0P0mFJ];0?ofkPD00000FP3o
m^h10?ooo`00K@3om^h2000006l0ooK^00@0?EV[0?ofkP3om^h0?EV[203om^h00`0mFJ/0ooK^0?of
kP0:0?ofkP0303eIZ`3om^h0ooK^00P0ooK^2`0mFJ/80?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0
?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP80?EV[CP3om^h5000005D0ooK^0@3o
ool006d0ooK^0P00001^0?ofkP0403eIZ`3om^h0ooK^03eIZ`T0ooK^00<0?EV[0?ofkP3om^h02@3o
m^h0100mFJ/0ooK^0?ofkP3om^h803eIZ`<0ooK^00<0?EV[0?ofkP3om^h01@3om^h:03eIZa00ooK^
00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP80?EV[D@3om^h500000500ooK^
0@3oool006d0ooK^00<000000?ofkP3om^h0K03om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00T0ooK^
00<0?EV[0?ofkP3om^h0203om^h503eIZ`X0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^
03eIZ`0303eIZ`/0ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP<0?EV[
E03om^h4000004`0ooK^0@3oool006`0ooK^0P00001]0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0
?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP060?ofkP<0?EV[00<0ooK^03eIZ`3om^h0303o
m^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00@0ooK^100mFJ/70?ofkP0303eIZ`3o
m^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h0403om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[05L0ooK^
1@0000170?ofkP40oooo001/0?ofkP800000K03om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3o
m^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h0103om^h203eIZ`<0ooK^00<0?EV[0?ofkP3om^h0303o
m^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00P0ooK^100mFJ/20?ofkP0303eIZ`3o
m^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h04@3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3o
m^h0ooK^05T0ooK^1@0000120?ofkP40oooo001/0?ofkP800000J`3om^h00`0mFJ/0ooK^0?ofkP03
0?ofkP0303eIZ`3om^h0ooK^00L0ooK^00@0?EV[0?ofkP3om^h0ooK^0`0mFJ/50?ofkP0303eIZ`3o
m^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP@0?EV[403o
m^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0303eIZ`3om^h0ooK^00@0ooK^0P0mFJ]N0?ofkPD00000?@3o
m^h10?ooo`00K03om^h2000006X0ooK^0P0mFJ/40?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[
0?ofkP0mFJ/00P0mFJ/80?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h03@3om^h0
0`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0?EV[0080?EV[3@3om^h00`0mFJ/0ooK^0?ofkP0@
0?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h0H03om^h5000003P0ooK^0@3oool0
06`0ooK^0P00001Z0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h01`3om^h203eI
Z`X0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^
00h0ooK^00<0?EV[0?ofkP3om^h00`3om^h303eIZ`T0ooK^00<0?EV[0?ofkP3om^h0403om^h00`0m
FJ/0ooK^0?ofkP080?ofkP80?EV[I@3om^h4000003@0ooK^0@3oool006`0ooK^00<000000?ofkP3o
m^h0J03om^h203eIZ`D0ooK^00<0?EV[0?ofkP3om^h01@3om^h303eIZ`/0ooK^00<0?EV[0?ofkP3o
m^h02`3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3o
m^h01P3om^h403eIZ`D0ooK^00<0?EV[0?ofkP3om^h0403om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP03
03eIZ`3om^h0ooK^06H0ooK^1@00000_0?ofkP40oooo001[0?ofkP800000JP3om^h203eIZ`@0ooK^
00<0?EV[0?ofkP3om^h0103om^h203eIZ`030?ofkP0mFJ/0ooK^00/0ooK^00<0?EV[0?ofkP3om^h0
2`3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h0
2`3om^h303eIZ`030?ofkP0mFJ/0ooK^0140ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^
0?ofkP1Z0?ofkP<00000;03om^h10?ooo`00J`3om^h2000006T0ooK^0P0mFJ/50?ofkP0303eIZ`3o
m^h0ooK^0080ooK^0P0mFJ/30?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h02`3o
m^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h03P3o
m^h203eIZa80ooK^00<0?EV[0?ofkP3om^h03@3om^h203eIZf/0ooK^0P00000/0?ofkP40oooo001[
0?ofkP800000J@3om^h203eIZ`D0ooK^00<0?EV[0?ofkP3om^h00P0mFJ/40?ofkP0303eIZ`3om^h0
ooK^00X0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0
ooK^00h0ooK^00<0?EV[0?ofkP3om^h0403om^h303eIZ`l0ooK^00<0?EV[0?ofkP3om^h0403om^h0
0`0mFJ/0ooK^0?ofkP1X0?ofkP800000;03om^h10?ooo`00J`3om^h2000006P0ooK^00<0?EV[0?of
kP0mFJ/0103om^h0100mFJ/0ooK^03eIZ`0mFJ/60?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[
0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[
0?ofkP3om^h03`3om^h0100mFJ/0ooK^0?ofkP3om^h203eIZ`d0ooK^00<0?EV[0?ofkP3om^h03`3o
m^h00`0mFJ/0ooK^03eIZ`1X0?ofkP040000003om^h0ooK^000002/0ooK^0@3oool006/0ooK^0P00
001X0?ofkP80?EV[1@3om^h203eIZ`P0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?of
kP0;0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?of
kP0@0?ofkP0303eIZ`3om^h0ooK^00<0ooK^0P0mFJ/:0?ofkP0303eIZ`3om^h0ooK^0100ooK^00@0
?EV[0?ofkP3om^h0?EV[IP3om^h01@000000ooK^0?ofkP3om^h0000002/0ooK^0@3oool006/0ooK^
0P00001W0?ofkP0303eIZ`3om^h0?EV[00@0ooK^0P0mFJ/80?ofkP0303eIZ`3om^h0ooK^00X0ooK^
00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00h0ooK^
00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP060?ofkP80?EV[203om^h00`0mFJ/0ooK^
0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h0H`3om^h01@000000ooK^
0?ofkP3om^h0000002/0ooK^0@3oool006X0ooK^0P00001X0?ofkP0303eIZ`3om^h0?EV[00<0ooK^
0P0mFJ/90?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^
0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^
0?ofkP080?ofkP80?EV[1@3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0303eIZ`3om^h0ooK^00<0ooK^
00<0?EV[0?ofkP3om^h0H@3om^h00`000000ooK^0?ofkP020?ofkP030000003om^h0ooK^02T0ooK^
0@3oool006X0ooK^0P00001W0?ofkP0303eIZ`3om^h0?EV[00<0ooK^00<0?EV[0?ofkP0mFJ/02@3o
m^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h03@3o
m^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h02`3o
m^h203eIZ`<0ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3o
m^h0ooK^0600ooK^00<000000?ofkP3om^h00`3om^h00`000000ooK^0?ofkP0X0?ofkP40oooo001Z
0?ofkP800000I`3om^h00`0mFJ/0ooK^03eIZ`020?ofkP0403eIZ`3om^h0ooK^03eIZ`P0ooK^00<0
?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP080?ofkP/0?EV[1`3om^h00`0mFJ/0ooK^0?of
kP0?0?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h03@3om^h303eIZa80ooK^00<0
?EV[0?ofkP3om^h01P3om^h203eIZel0ooK^00<000000?ofkP3om^h0103om^h00`000000ooK^0?of
kP0X0?ofkP40oooo001Z0?ofkP800000IP3om^h203eIZ`040?ofkP0mFJ/0ooK^03eIZ`<0ooK^00<0
?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP090?ofkP0403eIZ`3om^h0ooK^0?ofkPP0?EV[
0`3om^h00`0mFJ/0ooK^0?ofkP050?ofkPX0?EV[3P3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eI
Z`3om^h0ooK^0100ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eI
Z`3om^h0ooK^05/0ooK^00<000000?ofkP3om^h01@3om^h00`000000ooK^0?ofkP0X0?ofkP40oooo
001Z0?ofkP800000IP3om^h00`0mFJ/0ooK^03eIZ`020?ofkP0403eIZ`3om^h0ooK^03eIZ`P0ooK^
00<0?EV[0?ofkP3om^h02@3om^h503eIZ`X0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^
0?ofkP0503eIZ`T0ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eI
Z`3om^h0?EV[0100ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP1J0?ofkP030000
003om^h0ooK^00D0ooK^00<000000?ofkP3om^h0:03om^h10?ooo`00JP3om^h2000006H0ooK^00D0
?EV[0?ofkP0mFJ/0ooK^03eIZ`030?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h0
1@3om^h403eIZ`030?ofkP0mFJ/0ooK^00`0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^
0?ofkP060?ofkPH0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0303eIZ`3om^h0ooK^00l0ooK^
00<0?EV[0?ofkP3om^h00P0mFJ/=0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h0
F03om^h00`000000ooK^0?ofkP060?ofkP030000003om^h0ooK^02P0ooK^0@3oool006T0ooK^00<0
00000?ofkP000000I@3om^h203eIZ`030?ofkP0mFJ/0?EV[00@0ooK^00<0?EV[0?ofkP3om^h01P3o
m^h00`0mFJ/0ooK^0?ofkP020?ofkP<0?EV[103om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3o
m^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h0303om^h403eIZa00ooK^00<0?EV[0?ofkP3om^h03`3o
m^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h03@3o
m^h00`0mFJ/0ooK^0?ofkP1F0?ofkP030000003om^h0ooK^00P0ooK^00<000000?ofkP3om^h09`3o
m^h10?ooo`00J@3om^h2000006H0ooK^100mFJ/40?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[
0?ofkP0mFJ/00`0mFJ/70?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h0303om^h0
0`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0?EV[0080?EV[3@3om^h00`0mFJ/0ooK^0?ofkP0?
0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP0?
0?ofkP0303eIZ`3om^h0ooK^05D0ooK^00<000000?ofkP3om^h0203om^h00`000000ooK^0?ofkP0W
0?ofkP40oooo001Y0?ofkP800000IP3om^h00`0mFJ/0ooK^03eIZ`050?ofkP0303eIZ`3om^h0ooK^
00H0ooK^0P0mFJ/:0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0m
FJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00<0ooK^0`0mFJ/90?ofkP0303eIZ`3om^h0ooK^
00l0ooK^00<0?EV[0?ofkP3om^h01P3om^h203eIZ`P0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0m
FJ/0ooK^03eIZ`1E0?ofkP030000003om^h0ooK^00T0ooK^00<000000?ofkP3om^h09`3om^h10?oo
o`00J@3om^h2000006D0ooK^100mFJ/50?ofkP0303eIZ`3om^h0ooK^00@0ooK^0`0mFJ/;0?ofkP03
03eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP03
03eIZ`3om^h0ooK^00H0ooK^100mFJ/50?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3o
m^h0203om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP0m
FJ/0E03om^h00`000000ooK^0?ofkP0:0?ofkP030000003om^h0ooK^02L0ooK^0@3oool006T0ooK^
0P00001U0?ofkP<0?EV[1@3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0?EV[00`0ooK^
00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00h0ooK^
00<0?EV[0?ofkP3om^h02`3om^h303eIZ`030?ofkP0mFJ/0ooK^0100ooK^00<0?EV[0?ofkP3om^h0
2P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00h0ooK^00D0?EV[0?ofkP3om^h0
ooK^03eIZ`1C0?ofkP030000003om^h0ooK^00/0ooK^00<000000?ofkP3om^h09P3om^h10?ooo`00
J@3om^h2000006D0ooK^0`0mFJ/50?ofkP0303eIZ`3om^h0ooK^0080ooK^0P0mFJ/20?ofkP0303eI
Z`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eI
Z`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h03P3om^h203eIZa40ooK^00<0?EV[0?ofkP3om^h0
2`3om^h203eIZ`80ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eI
Z`3om^h0ooK^04l0ooK^00<000000?ofkP3om^h0303om^h00`000000ooK^0?ofkP0V0?ofkP40oooo
001X0?ofkP030000003om^h0000006@0ooK^100mFJ/50?ofkP0303eIZ`3om^h0ooK^0080?EV[103o
m^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h0303o
m^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00l0ooK^0`0mFJ/>0?ofkP0303eIZ`3o
m^h0ooK^00h0ooK^00<0?EV[0?ofkP0mFJ/0403om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3o
m^h0ooK^04h0ooK^00<000000?ofkP3om^h03@3om^h00`000000ooK^0?ofkP0V0?ofkP40oooo001X
0?ofkP800000I@3om^h303eIZ`H0ooK^00<0?EV[0?ofkP0mFJ/01@3om^h00`0mFJ/0ooK^0?ofkP0:
0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0>
0?ofkP0303eIZ`3om^h0ooK^00l0ooK^00@0?EV[0?ofkP3om^h0ooK^0P0mFJ/<0?ofkP0303eIZ`3o
m^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3o
m^h0ooK^04d0ooK^00<000000?ofkP3om^h03@3om^h00`000000ooK^0?ofkP0V0?ofkP40oooo001X
0?ofkP800000I@3om^h303eIZ`D0ooK^0`0mFJ/60?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[
0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[
0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP030?ofkP80?EV[2@3om^h00`0mFJ/0ooK^0?ofkP0@
0?ofkP80?EV[3`3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^04/0ooK^00<00000
0?ofkP3om^h03P3om^h00`000000ooK^0?ofkP0V0?ofkP40oooo001X0?ofkP800000I03om^h403eI
Z`D0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^
00/0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^
00l0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^
00l0ooK^00@0?EV[0?ofkP3om^h0?EV[3P3om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0
ooK^04X0ooK^00<000000?ofkP3om^h03`3om^h00`000000ooK^0?ofkP0U0?ofkP40oooo001X0?of
kP800000I03om^h303eIZ`D0ooK^0P0mFJ/70?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?of
kP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?of
kP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP070?ofkP80?EV[1@3om^h00`0mFJ/0ooK^0?ofkP0@0?of
kP0503eIZ`3om^h0ooK^0?ofkP0mFJ/0303om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0
ooK^04T0ooK^00<000000?ofkP3om^h0403om^h00`000000ooK^0?ofkP0U0?ofkP40oooo001X0?of
kP800000I03om^h303eIZ`@0ooK^0P0mFJ/80?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?of
kP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?of
kP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP80?EV[0`3om^h00`0mFJ/0ooK^0?ofkP0?0?of
kP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP090?of
kP0303eIZ`3om^h0ooK^04L0ooK^00<000000?ofkP3om^h04@3om^h00`000000ooK^0?ofkP0U0?of
kP40oooo001W0?ofkP030000003om^h0000006<0ooK^1@0mFJ/20?ofkP0303eIZ`3om^h0?EV[00P0
ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP080?ofkQD0?EV[3P3om^h00`0mFJ/0
ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00`0ooK^0`0mFJ/B0?ofkP0303eIZ`3om^h0ooK^00@0
ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^04H0
ooK^00<000000?ofkP3om^h04@3om^h00`000000ooK^0?ofkP0U0?ofkP40oooo001W0?ofkP030000
003om^h0000006<0ooK^00<0?EV[0?ofkP0mFJ/00P0mFJ/01@3om^h0?EV[0?ofkP3om^h0?EV[00P0
ooK^00<0?EV[0?ofkP3om^h0203om^h0100mFJ/0ooK^0?ofkP3om^h803eIZ`<0ooK^00<0?EV[0?of
kP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0503eIZ`T0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0m
FJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h01P3om^h203eI
Z`L0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP150?ofkP030000003om^h0ooK^
01<0ooK^00<000000?ofkP3om^h0903om^h10?ooo`00I`3om^h2000006@0ooK^0`0mFJ/00`3om^h0
?EV[03eIZ`020?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h0203om^h503eIZ`X0
ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP060?ofkPH0?EV[0P3om^h00`0mFJ/0
ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00l0ooK^0`0mFJ/?0?ofkP0303eIZ`3om^h0ooK^00P0
ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^04<0
ooK^00<000000?ofkP3om^h0503om^h00`000000ooK^0?ofkP0T0?ofkP40oooo001W0?ofkP800000
H`3om^h403eIZ`030?ofkP0mFJ/0ooK^0080ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^
0?ofkP050?ofkP<0?EV[00<0ooK^03eIZ`3om^h0303om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eI
Z`3om^h0ooK^00`0ooK^100mFJ/@0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00D0?EV[0?ofkP3om^h0
ooK^03eIZ`0=0?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0
ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0?EV[04@0ooK^00<000000?ofkP3om^h0503om^h00`000000
ooK^0?ofkP0T0?ofkP40oooo001W0?ofkP800000H`3om^h00`0mFJ/0ooK^03eIZ`0303eIZ`<0ooK^
00<0?EV[0?ofkP3om^h01P3om^h0100mFJ/0ooK^0?ofkP3om^h403eIZ`<0ooK^00<0?EV[0?ofkP3o
m^h02`3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00l0ooK^00@0?EV[0?ofkP0m
FJ/0?EV[3@3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^0080ooK^0P0mFJ/;0?of
kP0303eIZ`3om^h0ooK^00/0ooK^00@0?EV[0?ofkP3om^h0?EV[3`3om^h00`0mFJ/0ooK^03eIZ`13
0?ofkP030000003om^h0ooK^01D0ooK^00<000000?ofkP3om^h0903om^h10?ooo`00I`3om^h20000
06<0ooK^100mFJ/01@3om^h0?EV[0?ofkP3om^h0?EV[00P0ooK^00<0?EV[0?ofkP0mFJ/00P0mFJ/7
0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0>
0?ofkP0303eIZ`3om^h0ooK^0080ooK^0`0mFJ/:0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[
0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[
0?ofkP0mFJ/03P3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[0440ooK^00<000000?ofkP3om^h05P3o
m^h00`000000ooK^0?ofkP0T0?ofkP40oooo001V0?ofkP030000003om^h0000006<0ooK^0`0mFJ/2
0?ofkP0403eIZ`3om^h0ooK^03eIZ`P0ooK^0P0mFJ/:0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0
?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00D0ooK^0P0m
FJ/70?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h01P3om^h203eIZ`L0ooK^00<0
?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/0
@@3om^h00`000000ooK^0?ofkP0G0?ofkP030000003om^h0ooK^02<0ooK^0@3oool006H0ooK^00<0
00000?ofkP000000HP3om^h403eIZ`<0ooK^00<0?EV[0?ofkP0mFJ/01P3om^h303eIZ`X0ooK^00<0
?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0
?EV[0?ofkP3om^h0203om^h303eIZ`@0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?of
kP090?ofkP80?EV[103om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0?EV[00d0ooK^00<0
?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP0m0?ofkP030000003om^h0ooK^01P0ooK^00<0
00000?ofkP3om^h08`3om^h10?ooo`00IP3om^h2000006<0ooK^0`0mFJ/40?ofkP0303eIZ`3om^h0
?EV[00D0ooK^00<0?EV[0?ofkP0mFJ/02`3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0
ooK^00`0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP80?EV[00<0ooK^
03eIZ`3om^h0403om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/0403o
m^h00`0mFJ/0ooK^03eIZ`0=0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h0?03o
m^h00`000000ooK^0?ofkP0I0?ofkP030000003om^h0ooK^02<0ooK^0@3oool006H0ooK^0P00001S
0?ofkP<0?EV[103om^h203eIZ`@0ooK^0P0mFJ/20?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[
0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[
0?ofkP3om^h03P3om^h203eIZa00ooK^00<0?EV[0?ofkP3om^h03@3om^h303eIZa00ooK^00D0?EV[
0?ofkP3om^h0ooK^03eIZ`0;0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h0>`3o
m^h00`000000ooK^0?ofkP0I0?ofkP030000003om^h0ooK^02<0ooK^0@3oool006H0ooK^0P00001R
0?ofkP@0?EV[103om^h203eIZ`80ooK^0P0mFJ/40?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[
0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[
0?ofkP3om^h03P3om^h0100mFJ/0ooK^03eIZ`0mFJ/>0?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0
?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0
?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP0j0?ofkP030000003om^h0ooK^01/0ooK^00<0
00000?ofkP3om^h08P3om^h10?ooo`00IP3om^h200000680ooK^0`0mFJ/50?ofkP80?EV[00<0ooK^
03eIZ`3om^h0103om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[
0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00l0ooK^00@0?EV[
0?ofkP3om^h0ooK^0P0mFJ/;0?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP0mFJ/03P3o
m^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h01`3o
m^h00`0mFJ/0ooK^0?ofkP0i0?ofkP030000003om^h0ooK^01/0ooK^00<000000?ofkP3om^h08P3o
m^h10?ooo`00I@3om^h00`000000ooK^0000001R0?ofkP<0?EV[103om^h403eIZ`H0ooK^00<0?EV[
0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[
0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00@0ooK^0P0mFJ/9
0?ofkP0303eIZ`3om^h0ooK^00l0ooK^00@0?EV[0?ofkP3om^h0?EV[3@3om^h00`0mFJ/0ooK^0?of
kP040?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?of
kP0h0?ofkP030000003om^h0ooK^01`0ooK^00<000000?ofkP3om^h08P3om^h10?ooo`00I@3om^h0
0`000000ooK^000000060?ofkP<0e3dIF03om^h403eIZ`@0ooK^0`0mFJ/70?ofkP0303eIZ`3om^h0
ooK^00P0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0
ooK^00d0ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP060?ofkP80?EV[1P3om^h0
0`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h02@3om^h0
0`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h02@3om^h0
0`0mFJ/0ooK^0?ofkP0f0?ofkP030000003om^h0ooK^01d0ooK^00<000000?ofkP3om^h08P3om^h1
0?ooo`00I@3om^h00`000000ooK^000000050?ofkPX0e3dIDP3om^h303eIZ`D0ooK^0`0mFJ/60?of
kP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP0<0?of
kP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP090?of
kP80?EV[103om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?of
kP3om^h0203om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?of
kP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP0f0?ofkP030000003om^h0ooK^01d0ooK^00<000000?of
kP3om^h08P3om^h10?ooo`00I@3om^h2000000H0ooK^0`3D?AT00`3om^h0e3dI0=@m6@090=@m6Dd0
ooK^0`0mFJ/40?ofkP80?EV[0P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00T0
ooK^00<0?EV[0?ofkP3om^h01`3om^hE03eIZ`d0ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0
ooK^0?ofkP0;0?ofkP80?EV[00<0ooK^03eIZ`3om^h0403om^h00`0mFJ/0ooK^0?ofkP050?ofkP03
03eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h02@3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[
00d0ooK^00<0?EV[0?ofkP3om^h0=03om^h00`000000ooK^0?ofkP0O0?ofkP030000003om^h0ooK^
0240ooK^0@3oool006D0ooK^0P0000060?ofkP80e3dI00<0ooK^0=@m6@3D?AT0103D?AT00`3om^h0
e3dI0=@m6@090=@m6DL0ooK^0`0mFJ/30?ofkP<0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP03
03eIZ`3om^h0ooK^00P0ooK^00@0?EV[0?ofkP3om^h0ooK^1`0mFJ/30?ofkP0303eIZ`3om^h0ooK^
00`0ooK^00<0?EV[0?ofkP3om^h01@0mFJ/80?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?of
kP3om^h03P3om^h203eIZa40ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP050?of
kP0303eIZ`3om^h0ooK^00T0ooK^00@0?EV[0?ofkP3om^h0?EV[3@3om^h203eIZcD0ooK^00<00000
0?ofkP3om^h0803om^h00`000000ooK^0?ofkP0Q0?ofkP40oooo001U0?ofkP8000001P3om^h00`3D
?AT0ooK^0?ofkP060?ofkPD0e3dI0P3om^h:0=@m6D40ooK^00@0?EV[0?ofkP0mFJ/0?EV[0P3om^h0
100mFJ/0ooK^03eIZ`0mFJ/20?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h01`3o
m^h503eIZ`T0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP060?ofkPD0?EV[0P3o
m^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00l0ooK^0`0mFJ/>0?ofkP0303eIZ`3o
m^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3o
m^h0?EV[00d0ooK^0P0mFJ/e0?ofkP030000003om^h0ooK^0200ooK^00<000000?ofkP3om^h08@3o
m^h10?ooo`00I@3om^h2000000D0ooK^0P3D?AT=0?ofkPH0e3dI0P3om^h:0=@m6C/0ooK^00L0?EV[
0?ofkP0mFJ/0?EV[0?ofkP0mFJ/0ooK^0080?EV[103om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00P0
ooK^0P0mFJ/00`3om^h0?EV[0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3o
m^h02`3om^h403eIZ`l0ooK^00<0?EV[0?ofkP3om^h03`3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[
00d0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^
00`0ooK^00<0?EV[0?ofkP3om^h02`3om^h0100mFJ/0ooK^0?ofkP0mFJ/c0?ofkP030000003om^h0
ooK^0240ooK^00<000000?ofkP3om^h08@3om^h10?ooo`00I03om^h00`000000ooK^000000050?of
kP@0e3dI4@3om^h50=@m6@80ooK^2`3D?ATe0?ofkPD0?EV[0P3om^h203eIZ`@0ooK^00D0?EV[0?of
kP3om^h0ooK^03eIZ`050?ofkP<0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0
ooK^00/0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^03eIZ`0203eIZ``0ooK^00<0?EV[
0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP020?ofkP80?EV[2P3om^h00`0mFJ/0ooK^0?ofkP0;
0?ofkP0403eIZ`3om^h0ooK^03eIZ`h0ooK^00<0?EV[0?ofkP0mFJ/0303om^h0100mFJ/0ooK^0?of
kP0mFJ/b0?ofkP030000003om^h0ooK^02<0ooK^00<000000?ofkP3om^h0803om^h10?ooo`00I03o
m^h00`000000ooK^000000050?ofkP<0e3dI00<0ooK^0=@m6@3D?AT0103D?AT=0?ofkP030=@m6@3o
m^h0e3dI00H0e3dI0P3om^h;0=@m6Bh0ooK^1@0mFJ/20?ofkP0303eIZ`3om^h0?EV[00D0ooK^00@0
?EV[0?ofkP3om^h0?EV[0P3om^h303eIZ`D0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^
0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h00`3om^h303eIZ`P0ooK^
00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00L0ooK^
00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^03eIZ`0>0?ofkP0303eIZ`3om^h0?EV[00/0ooK^
00D0?EV[0?ofkP3om^h0ooK^03eIZ`0b0?ofkP030000003om^h0ooK^02<0ooK^00<000000?ofkP3o
m^h0803om^h10?ooo`00I03om^h2000000H0ooK^0P3D?AT00`3om^h0e3dI0=@m6@040=@m6@030?of
kP3D?AT0e3dI00@0e3dI1`3om^h00`3D?AT0ooK^0=@m6@060?ofkPD0e3dI0`3om^h:0=@m6BT0ooK^
00L0?EV[0?ofkP0mFJ/0?EV[0?ofkP0mFJ/0ooK^0080?EV[1P3om^h0100mFJ/0ooK^03eIZ`3om^h2
03eIZ`P0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0
ooK^00d0ooK^00<0?EV[0?ofkP3om^h01P3om^h303eIZ`D0ooK^00<0?EV[0?ofkP3om^h03`3om^h0
0`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h03P3om^h0
0`0mFJ/0ooK^0?ofkP0<0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/02P3om^h01@0mFJ/0ooK^0?of
kP3om^h0?EV[0340ooK^00<000000?ofkP3om^h0903om^h00`000000ooK^0?ofkP0P0?ofkP40oooo
001T0?ofkP8000001P3om^h20=@m6@L0ooK^1@3D?AT20?ofkPL0e3dI0P3om^h00`3D?AT0ooK^0?of
kP090?ofkPH0e3dI0`3om^h:0=@m6B<0ooK^0`0mFJ/20?ofkP0403eIZ`3om^h0?EV[03eIZ`H0ooK^
00@0?EV[0?ofkP0mFJ/0?EV[2@3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00/0
ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP<0?EV[00<0ooK^03eIZ`3o
m^h0403om^h00`0mFJ/0ooK^0?ofkP080?ofkP80?EV[1@3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP03
03eIZ`3om^h0?EV[00d0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`090?ofkP0303eIZ`3om^h0ooK^
00<0ooK^00<0?EV[0?ofkP3om^h0;P3om^h00`000000ooK^0?ofkP0T0?ofkP030000003om^h0ooK^
0200ooK^0@3oool006@0ooK^0P0000060?ofkP80e3dI303om^h60=@m6@80ooK^1P3D?AT?0?ofkPH0
e3dI0P3om^h:0=@m6Ad0ooK^100mFJ/20?ofkP80?EV[00<0ooK^03eIZ`3om^h01@3om^h303eIZ`X0
ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00d0
ooK^00<0?EV[0?ofkP3om^h03@3om^h203eIZa40ooK^00<0?EV[0?ofkP3om^h02P3om^h01@0mFJ/0
ooK^0?ofkP3om^h0?EV[0100ooK^00<0?EV[0?ofkP0mFJ/0303om^h00`0mFJ/0ooK^0?ofkP030?of
kP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0]0?of
kP030000003om^h0ooK^02D0ooK^00<000000?ofkP3om^h0803om^h10?ooo`00I03om^h2000000D0
ooK^0P3D?ATC0?ofkPH0e3dI0P3om^h60=@m6@/0ooK^00<0e3dI0?ofkP3om^h01P3D?AT30?ofkPX0
e3dI5`3om^h303eIZ`<0ooK^0P0mFJ/00`3om^h0?EV[0?ofkP040?ofkP0303eIZ`3om^h0?EV[00X0
ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00h0
ooK^00<0?EV[0?ofkP3om^h03P3om^h303eIZ`h0ooK^00<0?EV[0?ofkP3om^h0303om^h203eIZ`03
0?ofkP0mFJ/0ooK^00h0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0;0?ofkP0303eIZ`3om^h0ooK^
00<0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^
02`0ooK^00<000000?ofkP3om^h09`3om^h00`000000ooK^0?ofkP0O0?ofkP40oooo001S0?ofkP03
0000003om^h0000000D0ooK^0P3D?ATE0?ofkP030=@m6@3om^h0ooK^00D0e3dI103om^h60=@m6@@0
ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@050?ofkPD0e3dI0`3om^h:0=@m6A80ooK^0`0mFJ/30?of
kP<0?EV[103om^h203eIZ`80ooK^0P0mFJ/90?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?of
kP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00@0?EV[0?of
kP3om^h0ooK^0P0mFJ/<0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h03P3om^h0
0`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h01@3om^h0
0`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h0;03om^h0
0`000000ooK^0?ofkP0W0?ofkP030000003om^h0ooK^01l0ooK^0@3oool006<0ooK^00<000000?of
kP0000001@3om^h20=@m6A@0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@040?ofkPH0e3dI103om^h6
0=@m6@80ooK^00<0e3dI0?ofkP3om^h0203om^h60=@m6@<0ooK^2@3D?AT<0?ofkP0403eIZ`3om^h0
?EV[03eIZ`<0ooK^00<0?EV[0?ofkP0mFJ/00P3om^h203eIZ`<0ooK^00<0?EV[0?ofkP0mFJ/02@3o
m^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h03@3o
m^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00<0ooK^0P0mFJ/90?ofkP0303eIZ`3o
m^h0ooK^00l0ooK^0P0mFJ/>0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h01P3o
m^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h01P3o
m^h00`0mFJ/0ooK^0?ofkP0Z0?ofkP030000003om^h0ooK^02P0ooK^00<000000?ofkP3om^h07`3o
m^h10?ooo`00H`3om^h00`000000ooK^000000050?ofkP80e3dI503om^h01@3D?AT0ooK^0?ofkP3o
m^h0e3dI00X0ooK^1@3D?AT20?ofkP030=@m6@3om^h0ooK^00D0e3dI3P3om^h60=@m6@80ooK^2P3D
?AT60?ofkP<0?EV[103om^h01@0mFJ/0ooK^03eIZ`3om^h0?EV[00D0ooK^00@0?EV[0?ofkP3om^h0
?EV[1`3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3o
m^h03@3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3o
m^h01P3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0403eIZ`3om^h0ooK^03eIZ`d0ooK^00<0?EV[0?of
kP3om^h0103om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00L0ooK^00D0?EV[0?of
kP3om^h0ooK^03eIZ`090?ofkP0303eIZ`3om^h0ooK^02T0ooK^00<000000?ofkP3om^h0:@3om^h0
0`000000ooK^0?ofkP0O0?ofkP40oooo001S0?ofkP8000001P3om^h40=@m6A80ooK^00@0e3dI0?of
kP3om^h0e3dI403om^h60=@m6@040?ofkP3D?AT0ooK^0?ofkP@0e3dI2`3om^h0103D?AT0ooK^0?of
kP3om^h80=@m6@030?ofkP3D?AT0e3dI00L0e3dI00@0ooK^03eIZ`0mFJ/0?EV[103om^h403eIZ`H0
ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`060?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?of
kP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?of
kP3om^h01`3om^h203eIZ`D0ooK^00<0?EV[0?ofkP3om^h03`3om^h01@0mFJ/0ooK^0?ofkP3om^h0
?EV[00/0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0
ooK^00L0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`090?ofkP0303eIZ`3om^h0ooK^02T0ooK^00<0
00000?ofkP3om^h0:P3om^h00`000000ooK^0?ofkP0N0?ofkP40oooo001S0?ofkP8000001P3om^h2
0=@m6@030?ofkP3D?AT0e3dI00D0e3dI303om^h0103D?AT0ooK^0?ofkP3D?ATB0?ofkP040=@m6@3o
m^h0ooK^0?ofkPL0e3dI00<0ooK^0=@m6@3D?AT00`3D?AT50?ofkP030=@m6@3om^h0ooK^0080ooK^
00<0e3dI0?ofkP3om^h01@3om^h;0=@m6@<0?EV[00H0e3dI0?ofkP3om^h0?EV[0?ofkP0mFJ/70?of
kP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0:0?of
kP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0>0?of
kP0303eIZ`3om^h0ooK^00T0ooK^0P0mFJ/30?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?of
kP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?of
kP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0?EV[00T0ooK^0P0mFJ/Z0?of
kP030000003om^h0ooK^02/0ooK^00<000000?ofkP3om^h07P3om^h10?ooo`00H`3om^h2000000H0
ooK^0P3D?AT60?ofkPP0e3dI1@3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI0140ooK^00<0e3dI0?of
kP3om^h00`3om^h00`3D?AT0ooK^0?ofkP030?ofkP`0e3dI1@3om^h00`3D?AT0ooK^0?ofkP0;0?of
kP<0e3dI0`0mFJ/40=@m6@<0?EV[1`0000000`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^
0080ooK^00<0?EV[0?ofkP3om^h0203om^hD03eIZ`d0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0m
FJ/0ooK^0?ofkP0<0?ofkP<0?EV[4@3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^
00H0ooK^00<0?EV[0?ofkP3om^h02@3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00/0ooK^00<0?EV[
0?ofkP0mFJ/02@3om^h203eIZbT0ooK^00<000000?ofkP3om^h0;03om^h00`000000ooK^0?ofkP0N
0?ofkP40oooo001R0?ofkP030000003om^h0000000D0ooK^00<0e3dI0?ofkP3D?AT0303om^h80=@m
6@<0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^
00X0ooK^203D?AT20?ofkP030=@m6@3om^h0ooK^00d0ooK^00@0e3dI03eIZ`3om^h0?EV[103D?AT3
03eIZ`@000000`0m3PD00`0mFJ/0?@h503d>1@030000000303eIZ`3om^h0ooK^0080ooK^00@0?EV[
0?ofkP3om^h0ooK^1`0mFJ/30?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h01@0m
FJ/80?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?of
kP0>0?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?of
kP090?ofkP0403eIZ`3om^h0ooK^03eIZ`d0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^
03eIZ`0Y0?ofkP030000003om^h0ooK^02`0ooK^00<000000?ofkP3om^h07P3om^h10?ooo`00HP3o
m^h00`000000ooK^000000050?ofkP030=@m6@3om^h0e3dI0140ooK^2@3D?AT?0?ofkP030=@m6@3o
m^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP070=@m6@d0ooK^00L0
e3dI03eIZ`0mFJ/0?EV[0000003D?AT0F1<80080?EV[0P1H4`P0100mFJ/0F1<805PC201H4`P20000
000303eIZ`0000000000008000000`0m3PD0100mFJ/0000000000000000403eIZ`T0ooK^00<0?EV[
0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP060?ofkPD0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP0>
0?ofkP0303eIZ`3om^h0ooK^00l0ooK^0`0mFJ/>0?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[
0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0?EV[00`0ooK^0P0mFJ/9
0?ofkP0303eIZ`3om^h0?EV[02P0ooK^00<000000?ofkP3om^h0;@3om^h00`000000ooK^0?ofkP0N
0?ofkP40oooo001R0?ofkP030000003om^h0000000D0ooK^00<0e3dI0?ofkP3D?AT04`3om^h0103D
?AT0ooK^0?ofkP3om^h90=@m6@T0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP0<
0?ofkP030=@m6@3om^h0ooK^00D0ooK^2@3D?AT60?ofkP030=@m6@0mFJ/0ooK^0080?EV[0`000000
1@0mFJ/0F1<805PC201H4`P0?EV[00<0F1<80P0000000`0mFJ/0F1<805PC200205PC20@0000000<0
?EV[0000000000001@0000080?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h02`3o
m^h403eIZ`l0ooK^00<0?EV[0?ofkP3om^h03P3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00`0ooK^
00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00`0ooK^
00<0?EV[0?ofkP3om^h02`3om^h203eIZ`P0ooK^00@0?EV[0?ofkP3om^h0?EV[9`3om^h00`000000
ooK^0?ofkP0_0?ofkP030000003om^h0ooK^01d0ooK^0@3oool00680ooK^00<000000?ofkP000000
1@3om^h20=@m6A@0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@060?ofkPP0e3dI0P3om^h00`3D?AT0
ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0
ooK^0?ofkP040?ofkPT0e3dI00@0?EV[0?ofkP0mFJ/0?EV[0`1m7P`01@0mFJ/00000000000000000
?EV[00@0000000<0F1<803eIZ`1H4`P01P1H4`P010000000?EV[05PC201H4`P4000000@0?@h50`00
00000`3om^h0?EV[0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP0mFJ/00P0m
FJ/<0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h00P3om^h203eIZ`X0ooK^00<0
?EV[0?ofkP3om^h02P3om^h0100mFJ/0ooK^0?ofkP0mFJ/>0?ofkP80?EV[303om^h0100mFJ/0ooK^
0?ofkP0mFJ/70?ofkP0403eIZ`3om^h0ooK^03eIZbL0ooK^00<000000?ofkP3om^h0;`3om^h00`00
0000ooK^0?ofkP0M0?ofkP40oooo001R0?ofkP8000001P3om^h20=@m6A<0ooK^00<0e3dI0?ofkP3o
m^h00P3om^h00`3D?AT0ooK^0?ofkP0;0?ofkPL0e3dI0`3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP03
0=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h02@3om^h40=@m6@80?EV[00<0OAh<03eIZ`1m
7P`00P1m7P`00`0mFJ/0OAh<07dN300207dN300503eIZ`1m7P`0OAh<07dN300mFJ/01000000305PC
20040000001H4`P0F1<803eIZ`D0F1<81@000000100m3PD0e3dI0=@m6@3D?AT2000000/0ooK^00<0
?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP030?ofkP<0?EV[203om^h00`0mFJ/0ooK^0?of
kP0>0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?of
kP0<0?ofkP0303eIZ`3om^h0?EV[00h0ooK^00<0?EV[0?ofkP0mFJ/02`3om^h0100mFJ/0ooK^0?of
kP0mFJ/60?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/09P3om^h00`000000ooK^0?ofkP0`0?ofkP03
0000003om^h0ooK^01d0ooK^0@3oool00680ooK^0P0000050?ofkP030=@m6@3om^h0e3dI01<0ooK^
00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00L0e3dI
303om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00/0ooK^00H0e3dI03eIZ`0mFJ/0
?EV[07dN300mFJ/207dN300303eIZ`1m7P`0OAh<00<0OAh<00D0?EV[07dN301m7P`0OAh<03eIZ`04
07dN30D000000P1H4`P00`0mFJ/0F1<805PC200305PC20040000001H4`P0F1<805PC20@000000`0m
3PD4000000H0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP060?ofkP<0?EV[1@3o
m^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h01@3o
m^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00@0?EV[0?ofkP3om^h0?EV[
2P3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00D0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0
ooK^0?ofkP0T0?ofkP030000003om^h0ooK^0300ooK^00<000000?ofkP3om^h07@3om^h10?ooo`00
H@3om^h00`000000ooK^000000050?ofkP030=@m6@3om^h0e3dI01<0ooK^00<0e3dI0?ofkP3om^h0
0P3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00@0ooK^2@3D?AT50?ofkP030=@m
6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h02P3om^h01`3D?AT0ooK^03eIZ`000000?EV[07dN
300mFJ/00P1m7P`00`0mFJ/0OAh<07dN300207dN30030000000mFJ/0OAh<0080OAh<00<0?EV[07dN
301m7P`0101m7P`00`000000OAh<07dN30020000000303eIZ`000000000000<0F1<800<0000005PC
201H4`P01@1H4`P?000000d0ooK^00<0?EV[0?ofkP3om^h02P3om^h303eIZ`030?ofkP0mFJ/0ooK^
00l0ooK^00<0?EV[0?ofkP3om^h0203om^h203eIZ`@0ooK^00<0?EV[0?ofkP3om^h03P3om^h203eI
Z`d0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`080?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[
0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^02<0ooK^00<00000
0?ofkP3om^h0<P3om^h00`000000ooK^0?ofkP0L0?ofkP40oooo001Q0?ofkP030000003om^h00000
00D0ooK^0`3D?ATC0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT0403om^h00`3D?AT0ooK^0?ofkP05
0?ofkP030=@m6@3om^h0ooK^00@0ooK^203D?AT80?ofkP030=@m6@3om^h0ooK^00X0ooK^00D0e3dI
0?ofkP0mFJ/0?EV[0:8Z4@020000000403eIZ`000000?EV[000000<0OAh<00D0000007dN300mFJ/0
OAh<03eIZ`0607dN30030000001m7P`0OAh<00@0OAh<00<0?EV[07dN300000001000000805PC2003
0000001H4`P0F1<80080F1<81`0000000`0m3PD0000000000004000000L0ooK^00<0?EV[0?ofkP3o
m^h03@3om^h203eIZa00ooK^00<0?EV[0?ofkP3om^h02P3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[
00l0ooK^00<0?EV[0?ofkP0mFJ/0303om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^
00H0ooK^00<0?EV[0?ofkP3om^h00`3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00D0ooK^00<0?EV[
0?ofkP3om^h08P3om^h00`000000ooK^0?ofkP0c0?ofkP030000003om^h0ooK^01`0ooK^0@3oool0
0640ooK^00<000000?ofkP0000001@3om^h00`3D?AT0ooK^0=@m6@050=@m6@h0ooK^00D0e3dI0?of
kP3om^h0ooK^0=@m6@0@0?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h02@3om^h9
0=@m6@80ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0000000203eIZ`<0XRXA0P0mFJ/2
0:8Z4@D0000000<0?EV[07dN300mFJ/01P1m7P`00`000000OAh<07dN300407dN3080?EV[0P1m7P`0
0`000000OAh<07dN300500000080F1<800<0000005PC201H4`P01`1H4`P00`000000F1<805PC2004
0000000303d>1@000000?@h500@000000`3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP<0?EV[3P3om^h0
0`0mFJ/0ooK^0?ofkP0;0?ofkP<0?EV[403om^h0100mFJ/0ooK^0?ofkP0mFJ/;0?ofkP0303eIZ`3o
m^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP040?ofkP0503eIZ`3o
m^h0ooK^0?ofkP0mFJ/01@3om^h00`0mFJ/0ooK^0?ofkP0R0?ofkP030000003om^h0ooK^03<0ooK^
00<000000?ofkP3om^h0703om^h10?ooo`00H@3om^h00`000000ooK^000000050?ofkP030=@m6@3o
m^h0e3dI0080ooK^2@3D?AT70?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h03P3o
m^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h02P3D
?AT80?ofkP030=@m6@3om^h0?EV[0080?EV[0`2R:Q4203eIZ`@0XRXA00H000000:8Z4@2R:Q40?EV[
0000000mFJ/300000080OAh<00<0000007dN301m7P`0101m7P`01@0mFJ/0OAh<07dN300mFJ/00000
00P0OAh<1@00000705PC20030000001H4`P0F1<800@0F1<81P0000020=@m6@@000003P3om^h0100m
FJ/0ooK^0?ofkP3om^h203eIZ`/0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0=
0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP04
0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h0103om^h0100mFJ/0ooK^0?ofkP0m
FJ/60?ofkP0303eIZ`3om^h0ooK^0240ooK^00<000000?ofkP3om^h0=03om^h00`000000ooK^0?of
kP0L0?ofkP40oooo001Q0?ofkP8000001@3om^h0103D?AT0ooK^0?ofkP3D?AT80?ofkPP0e3dI0P3o
m^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h01@3o
m^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00H0ooK^2`3D?AT20?ofkP030=@m6@00
0000?EV[0080?EV[0`2R:Q4203eIZ`<0XRXA00<000000:8Z4@2R:Q400P2R:Q400`0mFJ/0XRXA0:8Z
4@020:8Z4@D00000101m7P`01@0mFJ/0OAh<07dN301m7P`0?EV[00X0OAh<00<0000007dN301m7P`0
1@00000205PC20030000001H4`P0F1<800H0F1<800@0000005PC201H4`P0F1<83P0000060?ofkP03
03eIZ`3om^h0ooK^00<0ooK^0P0mFJ/90?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP0m
FJ/03P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3o
m^h01@3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00D0ooK^00@0?EV[0?ofkP3o
m^h0?EV[1P3om^h00`0mFJ/0ooK^0?ofkP0P0?ofkP030000003om^h0ooK^03D0ooK^00<000000?of
kP3om^h0703om^h10?ooo`00H@3om^h2000000D0ooK^00@0e3dI0?ofkP3om^h0e3dI3P3om^h80=@m
6@030?ofkP3D?AT0ooK^00l0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP0;0?of
kP030=@m6@3om^h0ooK^00L0ooK^00@0e3dI0?ofkP3om^h0ooK^1@3D?AT00`3om^h0e3dI0=@m6@02
0=@m6@030:8Z4@0mFJ/0XRXA00<0XRXA0P0mFJ/30:8Z4@030000002R:Q40XRXA0080XRXA00<0?EV[
0:8Z4@2R:Q40102R:Q400`000000XRXA0:8Z4@040000000603eIZ`1m7P`0OAh<0000001m7P`0?EV[
2@1m7P`00`000000OAh<07dN300507dN30L000001@1H4`P00`000000F1<805PC200405PC20030000
003D?AT0F1<800H0000000<0?@h50000000000000`0000000`0mFJ/0ooK^0?ofkP060?ofkP80?EV[
1P3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0403eIZ`3om^h0ooK^03eIZ``0ooK^00<0?EV[0?ofkP3o
m^h0103om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00H0ooK^00D0?EV[0?ofkP3o
m^h0ooK^03eIZ`090?ofkP80?EV[1P3om^h203eIZb80ooK^00<000000?ofkP3om^h0=P3om^h00`00
0000ooK^0?ofkP0K0?ofkP40oooo001P0?ofkP030000003om^h0000000D0ooK^00<0e3dI0?ofkP3D
?AT04`3om^h00`3D?AT0ooK^0=@m6@080=@m6@X0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0
ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h01P3om^h30=@m6@04
0000002R:Q40?EV[03eIZ`@0XRXA00D0?EV[0:8Z4@2R:Q40XRXA000000050:8Z4@80?EV[102R:Q40
0`000000XRXA0:8Z4@040:8Z4@0303eIZ`2R:Q40000000@0000000<0?EV[07dN301m7P`01@1m7P`0
0`000000OAh<07dN300807dN30030000001m7P`0OAh<0080OAh<2000000505PC20030000001H4`P0
F1<800<0F1<81@00000203d>1@D000001`3om^h203eIZ`@0ooK^00<0?EV[0?ofkP3om^h03@3om^h0
0`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h01@3om^h0
0`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00L0ooK^00@0?EV[0?ofkP3om^h0?EV[2@3o
m^h203eIZ`H0ooK^00<0?EV[0?ofkP3om^h0803om^h00`000000ooK^0?ofkP0g0?ofkP030000003o
m^h0ooK^01/0ooK^0@3oool00600ooK^00<000000?ofkP0000000P0000030?ofkP030=@m6@3om^h0
e3dI0180ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP0:0=@m6@<0ooK^00<0e3dI
0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI
0?ofkP3om^h0203om^h00`3D?AT000000000000203eIZ`@0XRXA00D0?EV[0:8Z4@2R:Q40XRXA0000
00040:8Z4@0303eIZ`2R:Q40?EV[00@0XRXA00<000000:8Z4@2R:Q40102R:Q401@0mFJ/0XRXA0:8Z
4@2R:Q4000000080XRXA00<0000003eIZ`0000000`00000207dN30030000001m7P`0OAh<00P0OAh<
00<0000007dN301m7P`01`1m7P`00`000000OAh<07dN30040000000305PC20000000F1<800L0F1<8
00<0000005PC200000001@0000000`0m3PD0000000000003000000@0ooK^0P0mFJ/00`3om^h0?EV[
0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^
0?ofkP070?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^
03eIZ`0:0?ofkP0303eIZ`3om^h0ooK^00@0ooK^0P0mFJ/Q0?ofkP030000003om^h0ooK^03P0ooK^
00<000000?ofkP3om^h06`3om^h10?ooo`00H03om^h00`000000ooK^000000020?ofkPH000004P3o
m^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00D0ooK^103D?AT00`3om^h0e3dI0=@m
6@040=@m6@D0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3o
m^h0ooK^00L0ooK^00D0e3dI0?ofkP000000^c8D03eIZ`050000000403eIZ`2R:Q40XRXA000000D0
XRXA00@0?EV[0:8Z4@2R:Q40?EV[0`2R:Q400`000000XRXA0:8Z4@040:8Z4@0503eIZ`2R:Q40XRXA
0:8Z4@0000000`2R:Q400`0mFJ/0XRXA0:8Z4@020:8Z4@D00000201m7P`00`000000OAh<07dN3007
07dN30030000001m7P`0OAh<00@0OAh<1@00000505PC20030000001H4`P0F1<800<0F1<83P000002
03eIZ`l0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0
ooK^00P0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0;0?ofkP80?EV[2@3om^h203eIZ`H0ooK^0P0m
FJ/Q0?ofkP030000003om^h0ooK^03P0ooK^00<000000?ofkP3om^h06`3om^h10?ooo`00H03om^h0
0`000000ooK^000000050?ofkP030=@m6@3om^h0e3dI00H00000303om^h00`3D?AT0ooK^0?ofkP03
0?ofkP030=@m6@3om^h0ooK^00T0ooK^1@3D?AT20?ofkPH0e3dI303om^h00`3D?AT0ooK^0?ofkP07
0?ofkP030=@m6@3om^h0ooK^00P0ooK^00D0e3dI000000000000^c8D03eIZ`040;/b500303eIZ`2k
<Q@0?EV[00@000000`2R:Q401@0mFJ/0XRXA0:8Z4@2R:Q40?EV[0080XRXA00<000000:8Z4@2R:Q40
0`2R:Q400`0mFJ/0XRXA0:8Z4@020:8Z4@030000002R:Q40XRXA0080XRXA00<0?EV[0:8Z4@2R:Q40
0`2R:Q400`000000XRXA0:8Z4@0600000080OAh<00<0000007dN301m7P`01`1m7P`00`000000OAh<
07dN300607dN30030000001m7P`0OAh<00D0000000<0F1<80000001H4`P01P1H4`P00`000000F1<8
05PC20070000000303d>1@0000000000008000003@3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eI
Z`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h02@3om^h0100mFJ/0ooK^0?ofkP0mFJ/<0?ofkP03
03eIZ`3om^h0ooK^00P0ooK^0P0mFJ/50?ofkP0303eIZ`3om^h0?EV[0200ooK^00<000000?ofkP3o
m^h0>P3om^h00`000000ooK^0?ofkP0J0?ofkP40oooo001P0?ofkP8000001@3om^h0103D?AT0ooK^
0?ofkP3D?AT60?ofkPH000001P3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00d0
ooK^00<0e3dI0?ofkP3D?AT0103D?AT20?ofkPD0e3dI203om^h00`3D?AT0ooK^0?ofkP070?ofkP03
0=@m6@3om^h0ooK^00P0ooK^00D0e3dI0000002k<Q@0^c8D03eIZ`040;/b500503eIZ`2k<Q@0?EV[
0;/b500000000P2k<Q@20000000803eIZ`00000000000000002R:Q40?EV[0:8Z4@0000060:8Z4@05
03eIZ`2R:Q40XRXA0:8Z4@0000001P2R:Q400`0mFJ/0XRXA0:8Z4@020:8Z4@030000002R:Q40XRXA
00H0XRXA1@00000707dN30030000001m7P`0OAh<00L0OAh<00<0000007dN301m7P`0101m7P`50000
00D0F1<800<0000005PC201H4`P0101H4`P00`000000F1<800000009000000L0ooK^00<0?EV[0?of
kP3om^h0203om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?of
kP0mFJ/02`3om^h203eIZ`T0ooK^00<0?EV[0?ofkP0mFJ/01@3om^h203eIZb00ooK^00<000000?of
kP3om^h0>`3om^h00`000000ooK^0?ofkP0J0?ofkP40oooo001P0?ofkP8000001@3om^h0103D?AT0
ooK^0?ofkP3D?AT<0?ofkPD0000000<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP0=0?of
kP030=@m6@3om^h0ooK^00@0ooK^1@3D?AT20?ofkPD0e3dI0P3om^h00`3D?AT0ooK^0?ofkP080?of
kP030=@m6@3om^h0ooK^00L0ooK^00@0e3dI0?ofkP000000^c8D0P0mFJ/40;/b500503eIZ`2k<Q@0
?EV[0;/b50000000102k<Q@0100mFJ/0^c8D0;/b502k<Q@20000000403eIZ`0000000000000000@0
XRXA00D0?EV[0:8Z4@2R:Q40XRXA000000070:8Z4@0503eIZ`2R:Q40XRXA0:8Z4@0000002P2R:Q40
0`000000XRXA0:8Z4@0500000080OAh<00<0000007dN301m7P`01`1m7P`00`000000OAh<07dN3006
07dN30030000001m7P`0OAh<00D0000000<0F1<80000001H4`P01@1H4`P2000000<0F1<800<00000
0=@m6@0000002P0000000`0mFJ/0ooK^0?ofkP090?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/03P3o
m^h00`0mFJ/0ooK^0?ofkP0:0?ofkP80?EV[2@3om^h00`0mFJ/0ooK^03eIZ`040?ofkP0303eIZ`3o
m^h0?EV[0200ooK^00<000000?ofkP3om^h0>`3om^h00`000000ooK^0?ofkP0J0?ofkP40oooo001O
0?ofkP030000003om^h0000000D0ooK^00@0e3dI0?ofkP3om^h0e3dI4@3om^h6000000030=@m6@3o
m^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP060=@m6@030?ofkP3D
?AT0e3dI00@0e3dI1`3om^h00`3D?AT0ooK^0?ofkP070?ofkP040=@m6@3om^h000000;/b5080?EV[
0`2k<Q@01P0mFJ/0^c8D0;/b502k<Q@0?EV[000000@0^c8D00<0?EV[0;/b502k<Q@00`2k<Q@0100m
FJ/000000;/b502k<Q@30000000303eIZ`00000000000080XRXA00<000000:8Z4@2R:Q401P2R:Q40
0`0mFJ/0XRXA0000000;0:8Z4@030000002R:Q40XRXA00D0XRXA1@00000707dN30030000001m7P`0
OAh<00L0OAh<00<0000007dN301m7P`0101m7P`7000000<0F1<800<0000005PC201H4`P00`1H4`P2
0000000305PC20000000000000/000001`3om^h0100mFJ/0ooK^0?ofkP0mFJ/=0?ofkP80?EV[2`3o
m^h0100mFJ/0ooK^0?ofkP0mFJ/70?ofkP0403eIZ`3om^h0ooK^03eIZ`<0ooK^00@0?EV[0?ofkP3o
m^h0?EV[7`3om^h00`000000ooK^0?ofkP0l0?ofkP030000003om^h0ooK^01X0ooK^0@3oool005l0
ooK^00<000000?ofkP0000001@3om^h40=@m6A40ooK^00<0e3dI0?ofkP3om^h00`3om^h6000000X0
ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP060?ofkPH0e3dI00<0ooK^0=@m6@3D
?AT0103D?AT00`3om^h0e3dI0?ofkP080?ofkP040=@m6@00000000000;/b5080?EV[0`2k<Q@01P0m
FJ/0^c8D0;/b502k<Q@0?EV[000000<0^c8D00<0?EV[0;/b502k<Q@01@2k<Q@00`0mFJ/0^c8D0;/b
50030;/b500303eIZ`2k<Q@0^c8D00D000001`2R:Q400`0mFJ/000000:8Z4@0:0:8Z4@030000002R
:Q40XRXA00L0XRXA00<000000:8Z4@2R:Q401P00000207dN30030000001m7P`0OAh<00H0OAh<00<0
000007dN301m7P`01`1m7P`010000000OAh<07dN301m7P`7000000@0F1<800<0000005PC201H4`P0
0`1H4`P70000000403d>1@0000000000000000D0ooK^0P0mFJ/>0?ofkP0303eIZ`3om^h0?EV[00X0
ooK^00@0?EV[0?ofkP3om^h0?EV[1P3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00<0ooK^00@0?EV[
0?ofkP3om^h0?EV[7`3om^h00`000000ooK^0?ofkP0l0?ofkP030000003om^h0ooK^01X0ooK^0@3o
ool005l0ooK^00<000000?ofkP0000001@3om^h00`3D?AT0ooK^0=@m6@050=@m6@d0ooK^00<0e3dI
0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP030?ofkPH000000`3om^h00`3D?AT0ooK^0?ofkP07
0?ofkP030=@m6@3om^h0ooK^00P0ooK^00@0e3dI0?ofkP3om^h0ooK^1P3D?AT00`3om^h0e3dI0=@m
6@050=@m6@<0ooK^00L0e3dI0?ofkP000000^c8D03eIZ`2k<Q@0?EV[00<0^c8D00D0?EV[0;/b502k
<Q@0^c8D03eIZ`040;/b500303eIZ`2k<Q@0^c8D00D0^c8D00<0000003eIZ`2k<Q@00`2k<Q@00`0m
FJ/0^c8D0;/b50020;/b50030000002k<Q@0^c8D00H000000P2R:Q400`0mFJ/0XRXA0:8Z4@090:8Z
4@030000002R:Q40XRXA00L0XRXA00<000000:8Z4@2R:Q401P2R:Q45000000H0OAh<00<0000007dN
301m7P`01`1m7P`00`000000OAh<07dN300607dN30030000001m7P`0000000H000001@1H4`P01000
0000F1<805PC201H4`P900000080ooK^00<0?EV[0?ofkP3om^h02`3om^h0100mFJ/0ooK^0?ofkP0m
FJ/90?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/01P3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[0080
ooK^00@0?EV[0?ofkP3om^h0?EV[7`3om^h00`000000ooK^0?ofkP0n0?ofkP030000003om^h0ooK^
01T0ooK^0@3oool005l0ooK^00<000000?ofkP0000001@3om^h00`3D?AT0ooK^0=@m6@050?ofkPD0
e3dI1`3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00T0ooK^1@0000070?ofkP03
0=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h01`3om^h50=@m6@<0ooK^1@3D?AT01@000000
?EV[03eIZ`2k<Q@0?EV[0080^c8D00<0?EV[0;/b502k<Q@00P2k<Q@00`000000?EV[0;/b50020;/b
500303eIZ`2k<Q@0^c8D00D0^c8D00<0000003eIZ`2k<Q@00P2k<Q@00`0mFJ/0^c8D0;/b50030;/b
50030000002k<Q@0^c8D00H0^c8D0`0000000`0mFJ/000000:8Z4@080:8Z4@030000002R:Q40XRXA
00L0XRXA00<000000:8Z4@2R:Q40202R:Q400`000000XRXA0:8Z4@0500000080OAh<00<0000007dN
301m7P`01`1m7P`00`000000OAh<07dN300507dN30030000001m7P`0OAh<00@0OAh<1@00000305PC
20060000001H4`P0F1<805PC203D?AT0F1<80P0000000`1H4`P00000000000020000000303eIZ`3D
?AT0?EV[00`0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`080?ofkP0503eIZ`3om^h0ooK^0?ofkP0m
FJ/01@3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0403eIZ`3om^h0ooK^03eIZ`80ooK^00<0?EV[0?of
kP3om^h0703om^h00`000000ooK^0?ofkP0o0?ofkP030000003om^h0ooK^01T0ooK^0@3oool005l0
ooK^0P0000050?ofkP040=@m6@3om^h0ooK^0=@m6@X0ooK^1@3D?AT20?ofkP030=@m6@3om^h0ooK^
00@0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^00000005000000030?ofkP3D?AT0ooK^
00X0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP070=@m6@060?ofkP000000?EV[
0000002k<Q@0?EV[0P2k<Q@00`0mFJ/0^c8D0;/b50020;/b50030000000mFJ/0^c8D0080^c8D00<0
?EV[0;/b502k<Q@0102k<Q@010000000^c8D0;/b500mFJ/20;/b500303eIZ`2k<Q@0^c8D00<0^c8D
00<000000;/b502k<Q@0202k<Q@010000000?EV[03eIZ`0mFJ/5000000<0XRXA00<000000:8Z4@2R
:Q40202R:Q400`000000XRXA0:8Z4@070:8Z4@030000002R:Q40XRXA00D0XRXA2000000407dN3003
0000001m7P`0OAh<00H0OAh<00<0000007dN301m7P`01P1m7P`00`000000OAh<00000005000000D0
F1<800<0000005PC201H4`P00`1H4`P20000000303eIZ`3D?AT0e3dI00<0e3dI1@3om^h00`0mFJ/0
ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0
ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP0mFJ/00`3om^h00`0mFJ/0
ooK^0?ofkP0L0?ofkP030000003om^h0ooK^03l0ooK^00<000000?ofkP3om^h06@3om^h10?ooo`00
G`3om^h2000000D0ooK^00<0e3dI0?ofkP3om^h00`3D?AT=0?ofkPH0e3dI0`3om^h00`3D?AT0ooK^
0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00D0ooK^1P0000070?ofkP030=@m6@3om^h0ooK^00T0ooK^
00<0e3dI0?ofkP3om^h01@3om^h40=@m6@80c3LG0P000000100mFJ/0000003eIZ`0000030;/b5005
0000002k<Q@0?EV[0;/b500mFJ/01`2k<Q@01`000000^c8D0;/b502k<Q@0?EV[0;/b500mFJ/01@2k
<Q@00`000000^c8D0;/b50080;/b500503eIZ`2k<Q@0^c8D0;/b500mFJ/0102k<Q@6000000P0XRXA
00<000000:8Z4@2R:Q401`2R:Q400`000000XRXA0:8Z4@070:8Z4@030000002R:Q40XRXA00<0XRXA
2000000607dN30030000001m7P`0OAh<00D0OAh<00<0000007dN301m7P`00`1m7P`5000000<0F1<8
0P00000505PC20040=@m6@0mFJ/0e3dI0=@m6@80ooK^1@3D?AT00`0mFJ/0e3dI0?ofkP030?ofkP03
03eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h00`3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[
00D0ooK^00<0?EV[0?ofkP0mFJ/00P3om^h00`0mFJ/0ooK^0?ofkP0L0?ofkP030000003om^h0ooK^
0400ooK^00<000000?ofkP3om^h06@3om^h10?ooo`00GP3om^h00`000000ooK^000000050?ofkP04
0=@m6@3om^h0ooK^0=@m6@80ooK^1P3D?AT90?ofkP040=@m6@3om^h0ooK^0?ofkPL0e3dI2P3om^h0
0`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^0080ooK^1P0000000`3D?AT0ooK^0?ofkP0:
0?ofkP030=@m6@3om^h0ooK^00D0ooK^00@0e3dI0?ofkP0000000000103<=aL0100mFJ/0c3LG03eI
Z`3<=aL50000000303eIZ`2k<Q@0?EV[00L0^c8D00@000000;/b502k<Q@0^c8D0P0mFJ/60;/b5003
0000002k<Q@0^c8D00P0^c8D00<0?EV[0;/b502k<Q@00P2k<Q@00`0mFJ/0^c8D0;/b50040;/b5003
0000002k<Q@0^c8D00H000000P2R:Q400`000000XRXA0:8Z4@080:8Z4@030000002R:Q40XRXA00L0
XRXA00<000000:8Z4@2R:Q401`2R:Q400`000000XRXA0:8Z4@050000000307dN30000000OAh<00L0
OAh<00<0000007dN301m7P`01@1m7P`00`000000OAh<00000006000000D0F1<80P0000060=@m6@03
03eIZ`3om^h0ooK^00@0e3dI00<0?EV[0=@m6@3om^h00`3om^h00`0mFJ/0ooK^0?ofkP040?ofkP04
03eIZ`3om^h0ooK^03eIZ`H0ooK^0P0mFJ/30?ofkP0303eIZ`3om^h0ooK^01/0ooK^00<000000?of
kP3om^h0@P3om^h00`000000ooK^0?ofkP0H0?ofkP40oooo001N0?ofkP030000003om^h0000000D0
ooK^00@0e3dI0?ofkP3om^h0e3dI203om^h60=@m6@<0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D
?AT0ooK^0?ofkP020?ofkPL0e3dI0`3om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^
00P0ooK^1P0000070?ofkP030=@m6@3om^h0ooK^00D0ooK^00D0e3dI000000000000000003eIZ`03
0<`g5`80?EV[1@3<=aL01@000000c3LG03eIZ`000000?EV[00@000000`2k<Q@00`000000^c8D0;/b
50020;/b500303eIZ`2k<Q@0^c8D00@0^c8D00<000000;/b502k<Q@01`2k<Q@00`0mFJ/000000;/b
50040;/b5080?EV[102k<Q@00`000000^c8D0;/b50060;/b50D00000202R:Q400`000000XRXA0:8Z
4@070:8Z4@030000002R:Q40XRXA00L0XRXA00<000000:8Z4@2R:Q401@2R:Q45000000H0OAh<00<0
000007dN301m7P`01@1m7P`00`000000OAh<07dN300307dN30L0000000@0?EV[05PC200000000000
0P3om^h20=@m6@0303eIZ`3D?AT0e3dI00D0e3dI00<0?EV[0=@m6@3D?AT00P3D?AT00`0mFJ/0ooK^
0?ofkP040?ofkP0403eIZ`3om^h0ooK^03eIZ`H0ooK^0P0mFJ/20?ofkP0303eIZ`3om^h0ooK^01`0
ooK^00<000000?ofkP3om^h0@P3om^h00`000000ooK^0?ofkP0H0?ofkP40oooo001N0?ofkP030000
003om^h0000000@0ooK^00@0e3dI0?ofkP3om^h0e3dI3`3om^h60=@m6@<0ooK^00<0e3dI0?ofkP3o
m^h02@3om^h60=@m6@L0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP030?ofkPD0
00000P3om^h00`3D?AT0ooK^0?ofkP050?ofkP040=@m6@0000000000000000@0c3LG0P0mFJ/50<`g
5`040000003<=aL0c3LG03eIZ`D0c3LG1P0000020;/b5080?EV[1@2k<Q@00`000000^c8D0;/b5007
0;/b500303eIZ`000000^c8D00H0^c8D00D0?EV[0;/b502k<Q@0^c8D0000000:0;/b50030000002k
<Q@0^c8D00H000000P2R:Q400`000000XRXA0:8Z4@070:8Z4@030000002R:Q40XRXA00P0XRXA00<0
00000:8Z4@2R:Q401P2R:Q400`000000XRXA0:8Z4@050000000307dN30000000OAh<00L0OAh<00<0
000007dN301m7P`01@1m7P`010000000OAh<07dN301m7P`500000080ooK^00<0?EV[0=@m6@3om^h0
0P3om^h40=@m6@0603eIZ`3D?AT0e3dI0=@m6@0mFJ/0ooK^1@3D?AT20?ofkP80?EV[1`3om^h0100m
FJ/0ooK^0?ofkP0mFJ/N0?ofkP030000003om^h0ooK^04<0ooK^00<000000?ofkP3om^h0603om^h1
0?ooo`00GP3om^h00`000000ooK^000000040?ofkP040=@m6@3om^h0ooK^0=@m6A40ooK^00@0e3dI
0?ofkP3om^h0ooK^1P3D?AT<0?ofkP030=@m6@3om^h0ooK^00D0e3dI0P3om^h00`3D?AT0ooK^0?of
kP080?ofkP030=@m6@3om^h0ooK^00P0ooK^1P0000030?ofkP030=@m6@000000?EV[00800000103<
=aL203eIZ`D0c3LG00@000000<`g5`3<=aL0?EV[203<=aL01@000000c3LG0<`g5`000000?EV[0080
000000<0?EV[0000002k<Q@00P2k<Q@00`000000^c8D0;/b50070;/b500303eIZ`000000^c8D00L0
^c8D00@0?EV[0;/b502k<Q@000002P2k<Q@00`000000^c8D0;/b50060;/b50D000001`2R:Q400`00
0000XRXA0:8Z4@080:8Z4@030000002R:Q40XRXA00L0XRXA00<000000:8Z4@2R:Q40102R:Q450000
00H0OAh<00<0000007dN301m7P`01@1m7P`00`000000OAh<07dN300507dN30030000003D?AT0?EV[
00T0ooK^00@0?EV[0=@m6@3D?AT0?EV[1@3D?AT00`3om^h0e3dI0=@m6@0203eIZ`030=@m6@3om^h0
ooK^00<0ooK^0P0mFJ/00`3om^h0?EV[03eIZ`0M0?ofkP030000003om^h0ooK^04@0ooK^00<00000
0?ofkP3om^h0603om^h10?ooo`00GP3om^h2000000D0ooK^00@0e3dI0?ofkP3om^h0e3dI4@3om^h0
0`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00H0e3dI1P3om^h00`3D?AT0ooK^0?ofkP05
0?ofkPD0e3dI1`3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^0080ooK^1P000002
00/@9P050000003<=aL0c3LG0<`g5`0mFJ/01P3<=aL00`000000c3LG0<`g5`0203eIZ`L0c3LG00D0
00000<`g5`3<=aL0c3LG03eIZ`030<`g5`0303eIZ`000000000000@000001P2k<Q@00`0mFJ/0^c8D
000000090;/b5080?EV[00<000000;/b502k<Q@0202k<Q@00`000000^c8D0;/b50080;/b50030000
002k<Q@0^c8D00H000000P2R:Q400`000000XRXA0:8Z4@070:8Z4@030000002R:Q40XRXA00L0XRXA
00<000000:8Z4@2R:Q401P2R:Q400`000000XRXA0:8Z4@060000000307dN30000000OAh<00H0OAh<
00<0000007dN301m7P`01@1m7P`00`0mFJ/0ooK^0?ofkP080?ofkP0403eIZ`3om^h0?EV[0?ofkPP0
e3dI00<0?EV[0=@m6@3D?AT01@3D?AT0100mFJ/0ooK^0?ofkP0mFJ/N0?ofkP030000003om^h0ooK^
04@0ooK^00<000000?ofkP3om^h0603om^h10?ooo`00GP3om^h2000000D0ooK^00@0e3dI0?ofkP3o
m^h0e3dI4@3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00H0ooK^1P3D?AT90?of
kP040=@m6@3om^h0ooK^0?ofkPD0e3dI0P3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0
ooK^00D0ooK^00<0e3dI0000000000001P0000000`0mFJ/0c3LG0<`g5`040<`g5`050000003<=aL0
?EV[0<`g5`0mFJ/01`3<=aL010000000c3LG0<`g5`0mFJ/50<`g5`0403eIZ`3<=aL0c3LG00000080
c3LG1P0000000`0mFJ/0^c8D0000000;0;/b500303eIZ`2k<Q@0^c8D00P0^c8D00<000000;/b502k
<Q@0202k<Q@00`000000^c8D0;/b50060;/b50D000001`2R:Q400`000000XRXA0:8Z4@070:8Z4@03
0000002R:Q40XRXA00L0XRXA00<000000:8Z4@2R:Q401@2R:Q45000000D0OAh<00<0000007dN301m
7P`01@1m7P`30=@m6@P0ooK^0P0mFJ/00`3D?AT0ooK^0?ofkP030?ofkP80e3dI0P0mFJ/60=@m6@80
?EV[00<0e3dI03eIZ`0mFJ/00`3D?ATJ0?ofkP030000003om^h0ooK^04H0ooK^00<000000?ofkP3o
m^h05`3om^h10?ooo`00G@3om^h00`000000ooK^000000050?ofkP040=@m6@3om^h0ooK^0=@m6A40
ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP0;0?ofkPL0e3dI0`3om^h00`3D?AT0
ooK^0?ofkP060?ofkPH0e3dI2@3om^h00`3D?AT0ooK^0?ofkP050?ofkP030000000mFJ/000000080
2a0V00@000000<`g5`3<=aL0c3LG1@0000020<`g5`030000003<=aL0?EV[0080c3LG00<0?EV[0<`g
5`3<=aL0103<=aL010000000c3LG0<`g5`0mFJ/60<`g5`0303eIZ`3<=aL0000000L0c3LG00<0?EV[
0000000000000`0000090;/b50030000000mFJ/0^c8D00P0^c8D00<000000;/b502k<Q@0202k<Q@0
0`000000^c8D0;/b50080;/b50030000002k<Q@0^c8D00H000000P2R:Q400`000000XRXA0:8Z4@07
0:8Z4@030000002R:Q40XRXA00H0XRXA00<000000:8Z4@2R:Q401`2R:Q400`000000XRXA0:8Z4@05
0000000307dN30000000OAh<00H0OAh<00<000000=@m6@3D?AT0103D?AT30?ofkP0403eIZ`3om^h0
ooK^0=@m6@D0ooK^00<0e3dI03eIZ`0mFJ/00P3om^h40=@m6@@0?EV[0P3D?AT20?ofkPH0e3dI503o
m^h00`000000ooK^0?ofkP160?ofkP030000003om^h0ooK^01L0ooK^0@3oool005d0ooK^00<00000
0?ofkP000000103om^h0103D?AT0ooK^0?ofkP3D?ATB0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0
e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP040?ofkPH0e3dI203om^h0103D?AT0ooK^0?of
kP3om^h60=@m6@<0ooK^00<0e3dI0?ofkP3om^h0103om^h0103D?AT0000003eIZ`00000200/@9P06
0000003<=aL0c3LG03eIZ`3<=aL0?EV[0`3<=aL6000000030<`g5`0mFJ/0c3LG00D0c3LG00@00000
0<`g5`3<=aL0?EV[1`3<=aL00`0mFJ/000000<`g5`060<`g5`0403eIZ`3<=aL0c3LG00000080c3LG
1P0000030;/b50040000002k<Q@0?EV[03eIZ`L0^c8D00<000000;/b502k<Q@0202k<Q@00`000000
^c8D0;/b50080;/b50030000002k<Q@0^c8D00H0^c8D1@0000070:8Z4@030000002R:Q40XRXA00H0
XRXA00<000000:8Z4@2R:Q40202R:Q400`000000XRXA0:8Z4@040:8Z4@D0000000<0?EV[07dN301m
7P`00P1m7P`00`000000ooK^0?ofkP050=@m6@80?EV[00<0e3dI0?ofkP3D?AT00`3om^h20=@m6@03
03eIZ`3om^h0?EV[00D0ooK^100mFJ/80=@m6@<0ooK^1P3D?AT=0?ofkP030000003om^h0ooK^04L0
ooK^00<000000?ofkP3om^h05`3om^h10?ooo`00G@3om^h00`000000ooK^000000040?ofkP040=@m
6@3om^h0ooK^0=@m6A80ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP03
0=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h01P3D?AT20?ofkP030=@m6@3om^h0ooK^00L0
ooK^1`3D?AT30?ofkP040=@m6@0621400000000000802a0V00H000000<`g5`3<=aL0?EV[0<`g5`0m
FJ/50<`g5`040000000mFJ/0c3LG0<`g5`H000000P3<=aL00`000000c3LG03eIZ`080<`g5`0303eI
Z`000000c3LG00D0c3LG00D0?EV[0<`g5`3<=aL0c3LG000000080<`g5`H0000000<0^c8D03eIZ`2k
<Q@01@2k<Q@00`000000^c8D0;/b50080;/b50030000002k<Q@0^c8D00P0^c8D00<000000;/b502k
<Q@0202k<Q@00`000000^c8D0;/b500600000080XRXA00<000000:8Z4@2R:Q401P2R:Q400`000000
XRXA0:8Z4@070:8Z4@030000002R:Q40XRXA00H0XRXA00<000000:8Z4@2R:Q401@0000000`1m7P`0
00000?ofkP040?ofkP030=@m6@0mFJ/0?EV[00L0e3dI00@0ooK^03eIZ`3om^h0?EV[103om^h00`0m
FJ/0ooK^03eIZ`0203eIZ`80ooK^00@0e3dI0?ofkP3om^h0ooK^1`3D?AT20?ofkPL0e3dI1`3om^h0
0`000000ooK^0?ofkP180?ofkP030000003om^h0ooK^01L0ooK^0@3oool005d0ooK^00<000000?of
kP000000103om^h40=@m6A40ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP0;0?of
kP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h01P3om^h60=@m6@T0ooK^00@0e3dI0?of
kP3om^h0ooK^103D?AT3000000802a0V0P000000100mFJ/0c3LG0<`g5`0mFJ/50<`g5`030000000m
FJ/0c3LG00<0c3LG00@0?EV[0<`g5`3<=aL0c3LG1P0000080<`g5`0303eIZ`3<=aL0c3LG00@0c3LG
00D0?EV[0<`g5`3<=aL0c3LG0000000;0<`g5`040000003<=aL0c3LG000000<0?EV[0P0000020;/b
50030000002k<Q@0^c8D00P0^c8D00<000000;/b502k<Q@0202k<Q@00`000000^c8D0;/b50080;/b
50030000002k<Q@0^c8D00H0^c8D1@0000060:8Z4@030000002R:Q40XRXA00L0XRXA00<000000:8Z
4@2R:Q401`2R:Q400`000000XRXA0:8Z4@040:8Z4@<00000103om^h01@0mFJ/0ooK^0?ofkP0mFJ/0
ooK^00D0e3dI00@0?EV[0=@m6@3D?AT0?EV[0`3D?AT00`3om^h0?EV[0?ofkP0203eIZ`<0ooK^00<0
e3dI0?ofkP3om^h00P3om^h20=@m6@<0ooK^1`3D?AT30?ofkPD0e3dI0P3om^h00`000000ooK^0?of
kP190?ofkP030000003om^h0ooK^01H0ooK^0@3oool005d0ooK^0P0000050?ofkP030=@m6@3om^h0
ooK^00P0e3dI2P3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI
0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^0080ooK^1P3D?AT3
0?ofkP030=@m6@3om^h0ooK^00@0ooK^1000000200/@9P030000003I?1T0?EV[0080000000@0?EV[
00000000000000000P3<=aL00`0mFJ/0c3LG0<`g5`040<`g5`0303eIZ`3<=aL0c3LG0080c3LG00@0
00000<`g5`0mFJ/0c3LG1@0000030<`g5`030000000mFJ/0c3LG00@0c3LG00D0?EV[0<`g5`3<=aL0
c3LG0000000;0<`g5`040000003<=aL0c3LG03eIZ`<0c3LG0P0mFJ/5000000P0^c8D00<000000;/b
502k<Q@02@2k<Q@00`000000^c8D0;/b50070;/b50030000002k<Q@0^c8D00P0^c8D00<000000;/b
502k<Q@01@0000020:8Z4@030000002R:Q40XRXA00L0XRXA00<000000:8Z4@2R:Q401P2R:Q400`00
0000XRXA0:8Z4@070:8Z4@050000003om^h0ooK^0?ofkP0mFJ/00P3om^h00`0mFJ/0ooK^0?ofkP02
0=@m6@80ooK^00@0?EV[0=@m6@3D?AT0?EV[0`3D?AT0100mFJ/0e3dI03eIZ`0mFJ/30=@m6@80ooK^
00@0e3dI0?ofkP3om^h0e3dI2P3om^h70=@m6@<0ooK^1@3D?AU90?ofkP030000003om^h0ooK^01H0
ooK^0@3oool005d0ooK^0P0000050?ofkP040=@m6@3om^h0ooK^0=@m6@L0ooK^1`3D?AT30?ofkP03
0=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP080?ofkP03
0=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h0203om^h70=@m6@<0ooK^100000001@0;42H0
00000000003I?1T0?EV[00<0fC`I00<0?EV[0=Tl6@3I?1T00P0000000`0mFJ/00000000000050<`g
5`0603eIZ`3<=aL0c3LG0<`g5`000000?EV[1`3<=aL6000000<0c3LG00<0?EV[0<`g5`3<=aL00P3<
=aL00`000000c3LG0<`g5`090<`g5`040000003<=aL0c3LG03eIZ`D0c3LG0P0mFJ/00`000000c3LG
0<`g5`0600000080^c8D00<000000;/b502k<Q@02@2k<Q@00`000000^c8D0;/b50070;/b50030000
002k<Q@0^c8D00P0^c8D00<000000;/b502k<Q@01@2k<Q@5000000L0XRXA00<000000:8Z4@2R:Q40
1`2R:Q400`000000XRXA0:8Z4@060:8Z4@040000003om^h0ooK^03eIZ`<0ooK^00<0?EV[0?ofkP3o
m^h00P3D?AT00`3om^h0?EV[0?ofkP020?ofkP0403eIZ`3om^h0ooK^0?ofkP@0?EV[0P3D?AT00`3o
m^h0e3dI0=@m6@040=@m6@h0ooK^2@3D?AT20?ofkP@0e3dIA@3om^h00`000000ooK^0?ofkP0F0?of
kP40oooo001L0?ofkP030000003om^h0000000D0ooK^00@0e3dI0?ofkP3om^h0e3dI3P3om^h70=@m
6@<0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^
00P0ooK^00<0e3dI0?ofkP3om^h02`3om^h0103D?AT0ooK^0?ofkP3om^h60=@m6@050000000;42H0
00000000000mFJ/0103I?1T00`0mFJ/0fC`I0=Tl6@020=Tl6@0303eIZ`3I?1T0fC`I00D0000000H0
?EV[0<`g5`3<=aL0c3LG0000000mFJ/:0<`g5`030000003<=aL0c3LG00H000000P3<=aL00`000000
c3LG0<`g5`090<`g5`030000003<=aL0?EV[00P0c3LG0P0mFJ/70<`g5`D000002@2k<Q@00`000000
^c8D0;/b50080;/b50030000002k<Q@0^c8D00L0^c8D00<000000;/b502k<Q@01`2k<Q@00`000000
^c8D0;/b500600000080XRXA00<000000:8Z4@2R:Q401P2R:Q400`000000XRXA0:8Z4@070:8Z4@03
0000003om^h0?EV[00<0ooK^00L0?EV[0?ofkP3D?AT0ooK^0=@m6@3om^h0?EV[00<0ooK^00<0?EV[
0?ofkP3om^h0100mFJ/30?ofkPH0e3dI00<0ooK^0=@m6@3D?AT00`3D?AT:0?ofkP040=@m6@3om^h0
ooK^0?ofkP`0e3dI@`3om^h00`000000ooK^0?ofkP0F0?ofkP40oooo001L0?ofkP030000003om^h0
000000@0ooK^00@0e3dI0?ofkP3om^h0e3dI4P3om^h0103D?AT0ooK^0?ofkP3om^h60=@m6@X0ooK^
00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00/0ooK^
00<0e3dI0?ofkP3om^h00`3om^h0100000001PPA0000000;42H40=@m6@0303eIZ`3I?1T0fC`I0080
fC`I00H0?EV[0=Tl6@3I?1T0fC`I03eIZ`0000080=Tl6@0403eIZ`000000000003eIZ`8000002@3<
=aL010000000c3LG0<`g5`3<=aL203eIZ`<0c3LG1P0000080<`g5`030000003<=aL0?EV[00P0c3LG
00@000000<`g5`0mFJ/0?EV[1`3<=aL00`000000c3LG0<`g5`06000000<0^c8D00<000000;/b502k
<Q@0202k<Q@00`000000^c8D0;/b50070;/b50030000002k<Q@0^c8D00L0^c8D00<000000;/b502k
<Q@01P2k<Q@5000000L0XRXA00<000000:8Z4@2R:Q401P2R:Q400`000000?EV[0?ofkP040?ofkP05
03eIZ`3om^h0ooK^0?ofkP0mFJ/0103om^h01@0mFJ/0ooK^03eIZ`0mFJ/0ooK^0080?EV[1@3om^h0
0`3D?AT0ooK^0?ofkP060=@m6@030?ofkP3D?AT0e3dI00<0e3dI1@3om^h0103D?AT0ooK^0?ofkP3o
m^h20=@m6@P0ooK^103D?AU10?ofkP030000003om^h0ooK^01H0ooK^0@3oool005`0ooK^00<00000
0?ofkP000000103om^h0103D?AT0ooK^0?ofkP3D?ATB0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0
e3dI0?ofkP3om^h01`3D?AT30?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h0203o
m^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00<0ooK^00@0000000H84@0000002a0V
0P000002010H>`030000003I?1T0fC`I00<0fC`I00D0?EV[0=Tl6@3I?1T0?EV[000000080=Tl6@04
03eIZ`3I?1T0fC`I03eIZ`80fC`I1P0000030<`g5`030000003<=aL0c3LG0080c3LG00<0?EV[0<`g
5`3<=aL00`3<=aL010000000c3LG0<`g5`3<=aL5000000<0c3LG00<000000<`g5`0mFJ/0203<=aL0
10000000c3LG0<`g5`3<=aL203eIZ`D0c3LG00<000000<`g5`3<=aL01P3<=aL6000000P0^c8D00<0
00000;/b502k<Q@0202k<Q@00`000000^c8D0;/b50070;/b50030000002k<Q@0^c8D00L0^c8D00<0
00000;/b502k<Q@01P0000000`2R:Q4000000:8Z4@070:8Z4@0403eIZ`3D?AT0e3dI0=@m6@80ooK^
00<0e3dI03eIZ`3om^h00P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP<0?EV[00<0ooK^03eIZ`0mFJ/0
1@3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00D0ooK^103D?AT20?ofkPD0e3dI00@0ooK^0=@m6@3o
m^h0e3dI3P3om^h00`3D?AT0ooK^0?ofkP0o0?ofkP030000003om^h0ooK^01D0ooK^0@3oool005`0
ooK^00<000000?ofkP000000103om^h00`3D?AT0ooK^0?ofkP040=@m6@l0ooK^00<0e3dI0?ofkP3o
m^h00`3om^h00`3D?AT0ooK^0?ofkP080?ofkPH0e3dI203om^h00`3D?AT0ooK^0?ofkP080?ofkP03
0=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h00`3om^h30000000300/@9P00000041Pk0080
41Pk00<000000=Tl6@3I?1T00`3I?1T00`0mFJ/0fC`I03eIZ`020=Tl6@030000003I?1T0fC`I00H0
fC`I00<0?EV[0=Tl6@0mFJ/0203I?1T600000080c3LG0`0mFJ/30<`g5`030000003<=aL0c3LG00H0
c3LG1P0000080<`g5`030000003<=aL0c3LG00<0c3LG0P0mFJ/30<`g5`030000003<=aL0c3LG00T0
c3LG00<000000<`g5`3<=aL01P0000020;/b50030000002k<Q@0^c8D00P0^c8D00<000000;/b502k
<Q@01`2k<Q@00`000000^c8D0;/b50070;/b50030000002k<Q@0^c8D00H0^c8D1@0000070:8Z4@03
0000003om^h0e3dI0080e3dI00H0?EV[0=@m6@3D?AT0?EV[0?ofkP3D?AT30?ofkP80?EV[0P3om^h0
0`0mFJ/0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h01`3om^h5
0=@m6@80ooK^1@3D?AT>0?ofkP030=@m6@3om^h0ooK^03h0ooK^00<000000?ofkP3om^h05@3om^h1
0?ooo`00G03om^h2000000D0ooK^00@0e3dI0?ofkP3om^h0e3dI0`3om^h60=@m6@P0ooK^00<0e3dI
0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00D0e3dI0`3om^h0
0`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h00`3om^h0
1P3D?AT01PPA0000000000002a0V000000<041Pk00<000000=Tl6@3I?1T00`3I?1T00`0mFJ/0fC`I
03eIZ`020=Tl6@030000003I?1T0fC`I00H0fC`I0P0mFJ/00`000000fC`I0=Tl6@090=Tl6@050000
003I?1T0fC`I0000000mFJ/00`000000100mFJ/0c3LG0<`g5`00000;0<`g5`030000000mFJ/0c3LG
00H000000P3<=aL00`000000c3LG0<`g5`050<`g5`80?EV[00<0c3LG0000003<=aL02P3<=aL00`00
0000c3LG0<`g5`060<`g5`D00000202k<Q@00`000000^c8D0;/b50070;/b50030000002k<Q@0^c8D
00P0^c8D00<000000;/b502k<Q@01`2k<Q@00`000000^c8D0;/b5006000000030:8Z4@000000e3dI
00<0e3dI00@0?EV[0?ofkP3om^h0?EV[103D?AT303eIZ`030?ofkP0mFJ/0?EV[00D0ooK^00<0e3dI
0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP<0e3dI00@0ooK^0=@m6@3om^h0ooK^1@3D
?AT90?ofkP030=@m6@3om^h0ooK^03h0ooK^00<000000?ofkP3om^h05@3om^h10?ooo`00G03om^h2
000000D0ooK^00@0e3dI0?ofkP3om^h0e3dI2@3om^h60=@m6@80ooK^00<0e3dI0?ofkP3om^h0103o
m^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00D0ooK^1P3D?AT70?ofkP030=@m6@3o
m^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h00`3om^h20000000400/@9P0000002a0V000000<041Pk
00<000000=Tl6@3I?1T00`3I?1T00`0mFJ/0fC`I03eIZ`020=Tl6@030000003I?1T0fC`I00L0fC`I
00<0?EV[0000003I?1T02P3I?1T01@000000fC`I0=Tl6@3I?1T0?EV[00@0fC`I00<0?EV[00000000
00000P0000090<`g5`0303eIZ`3<=aL0c3LG00H0c3LG1P0000060<`g5`<0?EV[2P3<=aL00`000000
c3LG0<`g5`080<`g5`030000003<=aL0c3LG00H000000P2k<Q@00`000000^c8D0;/b50070;/b5003
0000002k<Q@0^c8D00P0^c8D00<000000;/b502k<Q@01`2k<Q@00`000000^c8D0;/b50060;/b50<0
000000@0e3dI0?ofkP3om^h0ooK^0P0mFJ/40=@m6@0403eIZ`3D?AT0?EV[0=@m6@80?EV[1@3om^h0
0`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00`0ooK^00D0e3dI0?ofkP000000ooK^0=@m
6@060?ofkPD0e3dI1@3om^h00`3D?AT0ooK^0?ofkP0m0?ofkP030000003om^h0ooK^01D0ooK^0@3o
ool005/0ooK^00<000000?ofkP0000001@3om^h00`3D?AT0ooK^0=@m6@0@0?ofkPH0e3dI0`3om^h0
0`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h01@3D?AT2
0?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h00`3om^h20000000400/@9P000000
0000000000<041Pk00<000000=Tl6@3I?1T0103I?1T01@0mFJ/0fC`I0=Tl6@3I?1T0000000T0fC`I
0P0mFJ/;0=Tl6@040000003I?1T0fC`I03eIZ`H0fC`I0P0mFJ/20=Tl6@H000000`3<=aL00`0mFJ/0
c3LG0<`g5`080<`g5`040000003<=aL0c3LG0<`g5`D000000P3<=aL00`0mFJ/0c3LG03eIZ`0203eI
Z`L0c3LG00<000000<`g5`3<=aL0203<=aL00`000000c3LG0<`g5`060<`g5`D00000202k<Q@00`00
0000^c8D0;/b50070;/b50030000002k<Q@0^c8D00P0^c8D00<000000;/b502k<Q@01`2k<Q@00`00
0000e3dI0?ofkP020?ofkP80?EV[0P3om^h203eIZ`040=@m6@0mFJ/0?EV[0=@m6@80?EV[1P3D?AT6
0?ofkP030=@m6@3om^h0ooK^00/0ooK^00H0e3dI0?ofkP3om^h000000?ofkP3D?AT;0?ofkPD0e3dI
00<0ooK^0=@m6@3om^h0?P3om^h00`000000ooK^0?ofkP0D0?ofkP40oooo001K0?ofkP030000003o
m^h0000000D0ooK^00<0e3dI0?ofkP3D?AT04P3om^h0103D?AT0ooK^0?ofkP3om^h60=@m6@X0ooK^
00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP050?ofkPH0e3dI2P3om^h00`3D?AT0ooK^
0?ofkP030?ofkP030000000;42H02a0V00<00000100@63/00`000000fC`I0=Tl6@030=Tl6@0503eI
Z`3I?1T0fC`I0=Tl6@000000203I?1T0100mFJ/0fC`I0000000mFJ/:0=Tl6@040000003I?1T0fC`I
03eIZ`L0fC`I00<0000003eIZ`3I?1T01P3I?1T20000000403eIZ`0000000000000000P0c3LG00<0
00000<`g5`3<=aL01P3<=aL6000000030<`g5`0mFJ/0?EV[00D0c3LG00<000000<`g5`3<=aL0203<
=aL00`000000c3LG0<`g5`080<`g5`030000003<=aL0c3LG00H000000P2k<Q@00`000000^c8D0;/b
50070;/b50030000002k<Q@0^c8D00P0^c8D00<000000;/b502k<Q@01`2k<Q@00`000000ooK^0?of
kP020?ofkP0303eIZ`3om^h0?EV[0080?EV[0P3om^h01@0mFJ/0ooK^03eIZ`0mFJ/0ooK^00/0e3dI
0P3om^h00`3D?AT0ooK^0?ofkP090?ofkP040=@m6@3om^h0ooK^000000<0ooK^00<0e3dI0?ofkP3o
m^h03@3om^h30=@m6Ch0ooK^00<000000?ofkP3om^h0503om^h10?ooo`00F`3om^h00`000000ooK^
000000040?ofkP040=@m6@3om^h0ooK^0=@m6A80ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0
ooK^0?ofkP050=@m6@D0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP080?ofkP04
0=@m6@3om^h0ooK^0?ofkPH0e3dI103om^h00`3D?AT0ooK^0?ofkP020?ofkP8000000P0;42H20000
0003010H>`00000041Pk008041Pk00<000000=Tl6@3I?1T00`3I?1T203eIZ`80fC`I00<000000=Tl
6@3I?1T01P3I?1T01@0mFJ/0fC`I0=Tl6@000000?EV[00T0fC`I00@000000=Tl6@3I?1T0?EV[1`3I
?1T00`000000fC`I03eIZ`080=Tl6@0403eIZ`000000fC`I0=Tl6@H000000P3<=aL00`000000c3LG
0<`g5`070<`g5`0303eIZ`000000c3LG0080c3LG1P0000000`3<=aL000000<`g5`0:0<`g5`030000
003<=aL0c3LG00P0c3LG00<000000<`g5`3<=aL01P3<=aL5000000P0^c8D00<000000;/b502k<Q@0
1`2k<Q@00`000000^c8D0;/b50080;/b50030000003om^h0ooK^00<0?EV[0P3om^h01P0mFJ/0e3dI
03eIZ`0mFJ/0ooK^03eIZ`@0ooK^00<0e3dI0?ofkP3om^h00P3om^h90=@m6@P0ooK^00D0e3dI0?of
kP3om^h0ooK^000000030?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h0?03om^h0
0`000000ooK^0?ofkP0D0?ofkP40oooo001K0?ofkP030000003om^h0000000@0ooK^00@0e3dI0?of
kP3om^h0e3dI4P3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00D0ooK^103D?AT0
0`3om^h0e3dI0?ofkP090?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h01`3om^h6
0=@m6@<0ooK^0P00000200/@9P80000000<041Pk0000000@63/00P0@63/300000080fC`I00<0?EV[
0=Tl6@0mFJ/00`3I?1T00`000000fC`I0=Tl6@050=Tl6@0603eIZ`3I?1T0fC`I0000003I?1T0?EV[
203I?1T00`000000fC`I03eIZ`080=Tl6@030000003I?1T0fC`I0080?EV[1P3I?1T00`0mFJ/00000
0=Tl6@070=Tl6@D000001P3<=aL00`0mFJ/0c3LG000000090<`g5`H000001`3<=aL00`000000c3LG
0<`g5`080<`g5`030000003<=aL0c3LG00P0c3LG00<000000<`g5`3<=aL01P0000020;/b50030000
002k<Q@0^c8D00L0^c8D00<000000;/b502k<Q@0202k<Q@00`000000?EV[03eIZ`0203eIZ`80ooK^
00<0?EV[0?ofkP3D?AT0100mFJ/40?ofkP030=@m6@3om^h0ooK^00P0ooK^203D?AT20?ofkP050=@m
6@3om^h0ooK^0?ofkP0000001@3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^03/0
ooK^00<000000?ofkP3om^h0503om^h10?ooo`00F`3om^h2000000D0ooK^00@0e3dI0?ofkP3om^h0
e3dI4P3om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00X0ooK^1@3D?AT70?ofkP03
0=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0=@m6@020=@m6@80
00000P0;42H01000000041Pk010H>`000003010H>`030000003S?aX0hclJ0080000000@0?EV[0000
00000000?EV[0P3I?1T00`000000fC`I0=Tl6@040=Tl6@0503eIZ`3I?1T0fC`I0=Tl6@0000000P3I
?1T00`0mFJ/0fC`I0=Tl6@050=Tl6@030000003I?1T0?EV[00P0fC`I00<000000=Tl6@3I?1T00P3I
?1T00`0mFJ/0fC`I0=Tl6@020=Tl6@0303eIZ`3I?1T0000000X0fC`I00<000000=Tl6@3I?1T01P00
00000`0mFJ/0c3LG0000000:0<`g5`050000003<=aL0?EV[03eIZ`3<=aL01@0000020<`g5`030000
003<=aL0c3LG00P0c3LG00<000000<`g5`3<=aL0203<=aL00`000000c3LG0<`g5`060<`g5`030000
003D?AT0000000800000202k<Q@00`000000^c8D0;/b50060;/b5080?EV[00H0ooK^03eIZ`3om^h0
?EV[0?ofkP0mFJ/20?ofkP80?EV[00<0ooK^03eIZ`3om^h00`3om^h00`3D?AT0ooK^0?ofkP090?of
kP030=@m6@3om^h0ooK^00<0ooK^203D?AT60?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?of
kP3om^h0>`3om^h00`000000ooK^0?ofkP0D0?ofkP40oooo001K0?ofkP8000001@3om^h40=@m6A40
ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP0;0?ofkP040=@m6@3om^h0ooK^0?of
kPD0e3dI0P3om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?of
kP3om^h00P3om^h2000000802a0V00@00000010H>`0@63/000000P0@63/2000000@0hclJ00D0?EV[
0><o6P3S?aX0hclJ03eIZ`04000000@0fC`I00D0?EV[0=Tl6@3I?1T0fC`I000000030=Tl6@0303eI
Z`3I?1T0fC`I00@0fC`I00<000000=Tl6@0mFJ/0203I?1T00`000000fC`I0=Tl6@030=Tl6@0703eI
Z`3I?1T0fC`I0=Tl6@0mFJ/0fC`I0000000:0=Tl6@030000003I?1T0fC`I00D0fC`I00<0?EV[0000
000000000`0000080<`g5`040000003<=aL0c3LG0<`g5`<0?EV[0`3<=aL6000000L0c3LG00<00000
0<`g5`3<=aL0203<=aL00`000000c3LG0<`g5`080<`g5`030000003<=aL0c3LG00H000000P2k<Q@0
0`000000^c8D0;/b50040;/b5080?EV[00/0^c8D0000003om^h0?EV[0?ofkP0mFJ/0ooK^03eIZ`3o
m^h0?EV[0=@m6@0303eIZ`@0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP040?of
kP030=@m6@3om^h0ooK^0080ooK^00<000000=@m6@3D?AT00`3D?AT20?ofkP030=@m6@3om^h0ooK^
00l0ooK^00<0e3dI0?ofkP3om^h0>`3om^h00`000000ooK^0?ofkP0C0?ofkP40oooo001J0?ofkP03
0000003om^h0000000D0ooK^00@0e3dI0?ofkP3D?AT0ooK^1`3D?AT:0?ofkP030=@m6@3om^h0ooK^
00@0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP060?ofkPD0e3dI1`3om^h00`3D
?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^0080ooK^0`00000200/@9P040000000@63/041Pk
0000008041Pk00<0000001DPCP0000000P3S?aX00`0mFJ/0hclJ0><o6P020><o6P0303eIZ`3S?aX0
00000080hclJ100000001@0mFJ/000000=Tl6@3I?1T0000000<0fC`I00<0?EV[0=Tl6@3I?1T0103I
?1T00`000000?EV[0=Tl6@090=Tl6@030000003I?1T0fC`I00<0fC`I0`0mFJ/20=Tl6@030000003I
?1T0fC`I00P0fC`I00<000000=Tl6@3I?1T01@3I?1T0100mFJ/0fC`I0=Tl6@0000020=Tl6@H00000
0P3<=aL00`000000c3LG0<`g5`040<`g5`@0?EV[00<0c3LG0000003<=aL00P3<=aL6000000030<`g
5`000000c3LG00T0c3LG00<000000<`g5`3<=aL0203<=aL00`000000c3LG0<`g5`060<`g5`D00000
100mFJ/40;/b500303eIZ`3om^h0ooK^0080?EV[0P3om^h0100mFJ/0e3dI03eIZ`0mFJ/40?ofkP03
0=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h0103om^h01@3D?AT0ooK^0?ofkP3om^h00000
00H0ooK^1P3D?AT>0?ofkP030=@m6@3om^h0ooK^03/0ooK^00<000000?ofkP3om^h04`3om^h10?oo
o`00FP3om^h00`000000ooK^000000050?ofkP030=@m6@3om^h0e3dI00P0ooK^1`3D?AT30?ofkP03
0=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP080?ofkP03
0=@m6@3om^h0ooK^00H0e3dI00<0ooK^0=@m6@3om^h0303om^h00`3D?AT0ooK^0?ofkP020?ofkP<0
000000<0?EV[00/@9P0000000P0@63/00`00000041Pk0000000201DPCP040000003S?aX0hclJ03eI
Z`D0hclJ00<0?EV[0000003S?aX0103S?aX00`0mFJ/0hclJ0><o6P0500000080fC`I00<0?EV[0=Tl
6@3I?1T00`3I?1T00`000000?EV[0=Tl6@090=Tl6@030000003I?1T0fC`I00D0fC`I00@0?EV[0=Tl
6@3I?1T000002P3I?1T00`000000fC`I0=Tl6@040=Tl6@0503eIZ`3I?1T0fC`I0=Tl6@000000203I
?1T5000000@0c3LG00@0?EV[0<`g5`3<=aL0c3LG1P0mFJ/50<`g5`H000001P3<=aL00`000000c3LG
0<`g5`080<`g5`030000003<=aL0c3LG00H0c3LG1@0mFJ/00`000000?EV[0000000300000080^c8D
00<0?EV[0?ofkP3om^h00P0mFJ/00`3om^h0?EV[0?ofkP0203eIZ`D0ooK^00<0e3dI0?ofkP3om^h0
2`3om^h00`3D?AT0ooK^0?ofkP030?ofkP050=@m6@3om^h0ooK^0?ofkP0000002@3om^h0103D?AT0
ooK^0?ofkP3om^h60=@m6@T0ooK^00<0e3dI0?ofkP3om^h0>P3om^h00`000000ooK^0?ofkP0C0?of
kP40oooo001J0?ofkP030000003om^h0000000D0ooK^00<0e3dI0?ofkP3D?AT03`3om^h60=@m6@@0
ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00H0
ooK^1P3D?AT90?ofkP030=@m6@3om^h0ooK^0080ooK^00@0000000/@9P0;42H0?EV[0P000003010H
>`8000000P0E84h010000000hclJ0><o6P0mFJ/60><o6P0303eIZ`000000hclJ00<0hclJ00<0?EV[
0><o6P3S?aX00P3S?aX00`000000hclJ0><o6P030000000303eIZ`00000000000080fC`I00<0?EV[
0=Tl6@3I?1T02@3I?1T00`000000fC`I0=Tl6@050=Tl6@<0?EV[00<000000=Tl6@3I?1T0203I?1T0
0`000000fC`I0=Tl6@040=Tl6@0503eIZ`3I?1T0fC`I0=Tl6@0000002P3I?1T00`000000fC`I0=Tl
6@040000000303eIZ`000000c3LG0080c3LG00<000000<`g5`3<=aL00P3<=aL603eIZ`030000003<
=aL0c3LG0080c3LG1`00000:0<`g5`030000003<=aL0c3LG00H0?EV[0P3<=aL01@000000c3LG0<`g
5`3<=aL0?EV[00@0c3LG00@0000003eIZ`000000e3dI0P0mFJ/20?ofkP0403eIZ`3om^h0?EV[03eI
Z`@0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^
0080ooK^00<000000?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP070?ofkPL0e3dI0P3om^h00`3D
?AT0ooK^0?ofkP0j0?ofkP030000003om^h0ooK^01<0ooK^0@3oool005X0ooK^00<000000?ofkP00
0000103om^h0103D?AT0ooK^0?ofkP3D?ATB0?ofkP030=@m6@3om^h0ooK^00D0e3dI303om^h00`3D
?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h00`3om^h60=@m
6@<0ooK^00H0e3dI0?ofkP3om^h0ooK^03eIZ`00000200/@9P80000000@041Pk0000000@63/041Pk
0P00000201DPCP040000003S?aX0hclJ03eIZ`L0hclJ00<0?EV[0><o6P3S?aX00P3S?aX00`0mFJ/0
hclJ0><o6P020><o6P030000003S?aX0hclJ00@0hclJ00D0?EV[0><o6P000000000003eIZ`020000
00T0fC`I00<000000=Tl6@3I?1T0103I?1T0100mFJ/0fC`I0=Tl6@3I?1T203eIZ`T0fC`I00<00000
0=Tl6@3I?1T00`3I?1T00`0mFJ/0fC`I0=Tl6@020=Tl6@030000003I?1T0fC`I00P0fC`I00<00000
0=Tl6@3I?1T00`3I?1T00`0mFJ/0fC`I0=Tl6@06000000P0c3LG2`0mFJ/5000000T0?EV[203<=aL0
10000000c3LG0<`g5`0mFJ/50<`g5`0503eIZ`3<=aL000000?ofkP0mFJ/00P3D?AT403eIZ`030=@m
6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h03@3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00<0
ooK^00<000000?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP@0e3dI?03om^h00`000000
ooK^0?ofkP0B0?ofkP40oooo001J0?ofkP8000001@3om^h0103D?AT0ooK^0?ofkP3D?ATB0?ofkP03
0=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3D?AT0103D?AT70?ofkP030=@m6@3om^h0ooK^00P0
ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP090?ofkPL0e3dI0P00000200/@9P80
000000D041Pk0000000@63/041Pk0000000301DPCP030000003S?aX0?EV[00P0hclJ00D0?EV[0><o
6P3S?aX0hclJ03eIZ`050><o6P030000003S?aX0hclJ00D0hclJ00@0?EV[0><o6P3S?aX0?EV[0P3S
?aX6000000<0fC`I00<000000=Tl6@3I?1T0103I?1T01P0mFJ/0fC`I0=Tl6@3I?1T000000=Tl6@80
?EV[1`3I?1T00`000000fC`I0=Tl6@030=Tl6@0303eIZ`3I?1T0fC`I0080fC`I00<000000=Tl6@3I
?1T0203I?1T00`000000fC`I0=Tl6@030=Tl6@0303eIZ`3I?1T0fC`I00<0fC`I00<000000=Tl6@3I
?1T01P0000020<`g5`030000003<=aL0?EV[00P0c3LG00<000000<`g5`3<=aL00P3<=aL7000000X0
c3LG00@000000<`g5`3<=aL0?EV[103<=aL01`0mFJ/0c3LG0<`g5`000000ooK^03eIZ`3om^h00P0m
FJ/00`3om^h0?EV[03eIZ`070=@m6@h0ooK^00@0e3dI0?ofkP3om^h0e3dI0`3om^h00`000000ooK^
0?ofkP0:0?ofkP030=@m6@3om^h0ooK^0100ooK^00<0e3dI0?ofkP3om^h0>P3om^h00`000000ooK^
0?ofkP0B0?ofkP40oooo001J0?ofkP8000001@3om^h0103D?AT0ooK^0?ofkP3D?ATA0?ofkP030=@m
6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h0103om^h50=@m6@80ooK^00<0e3dI0?ofkP3om^h0
203om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00`0ooK^00@0e3dI0?ofkP3om^h0
ooK^1P3D?AT01@0@63/00000010H>`0@63/0000000@05B1>00<0000003eIZ`3S?aX01`3S?aX01@00
0000?EV[0><o6P3S?aX0?EV[00H0hclJ00<000000><o6P3S?aX01@3S?aX203eIZ`030000003S?aX0
hclJ00H0hclJ1P0000030=Tl6@0303eIZ`3I?1T0fC`I0080fC`I00@000000=Tl6@3I?1T0fC`I0P0m
FJ/50=Tl6@030000003I?1T0fC`I0080fC`I00<0?EV[0=Tl6@3I?1T00`3I?1T00`000000fC`I0=Tl
6@080=Tl6@030000003I?1T0fC`I0080fC`I00<0?EV[0=Tl6@3I?1T0103I?1T00`000000fC`I0=Tl
6@060=Tl6@@0000000@0?EV[00000000000000001@3<=aL00`000000c3LG0<`g5`070<`g5`0303eI
Z`000000000000@000001@3<=aL00`000000c3LG03eIZ`080<`g5`050000000mFJ/0?EV[0?ofkP0m
FJ/00P3om^h00`0mFJ/0ooK^0=@m6@020?ofkPX0e3dI203om^h00`3D?AT0ooK^0=@m6@040?ofkP03
0000003om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h0403om^h00`3D?AT0ooK^0?ofkP0j0?ofkP03
0000003om^h0ooK^0180ooK^0@3oool005T0ooK^00<000000?ofkP0000001@3om^h00`3D?AT0ooK^
0=@m6@0B0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h02@3om^h60=@m6@L0ooK^
00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP040=@m6@3om^h0ooK^0?ofkP80
00000P0;42H00`00000041Pk0=@m6@050=@m6@<05B1>00<0?EV[0><o6P3S?aX01`3S?aX01@000000
hclJ03eIZ`3S?aX0?EV[00H0hclJ00<000000><o6P3S?aX01P3S?aX00`0mFJ/000000><o6P0:0><o
6P030000003S?aX0hclJ00<0000000<0?EV[0000000000000P3I?1T00`000000fC`I0=Tl6@030=Tl
6@80?EV[0`3I?1T00`000000fC`I0=Tl6@020=Tl6@0303eIZ`3I?1T0fC`I00<0fC`I00<000000=Tl
6@3I?1T0203I?1T00`000000fC`I0=Tl6@020=Tl6@0303eIZ`3I?1T0fC`I00<0fC`I00<000000=Tl
6@3I?1T02@3I?1T00`000000?EV[0=Tl6@030=Tl6@P000001P3<=aL00`0mFJ/0c3LG000000050<`g
5`H0000000<0c3LG03eIZ`3<=aL01`3<=aL0100mFJ/0ooK^03eIZ`0mFJ/20?ofkP0403eIZ`3om^h0
ooK^0=@m6@80ooK^00<0e3dI0?ofkP3om^h00`3om^h:0=@m6@80ooK^00<0e3dI0?ofkP3D?AT00`3o
m^h00`000000ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^0140ooK^00<0e3dI0?ofkP3om^h0>@3o
m^h00`000000ooK^0?ofkP0B0?ofkP40oooo001I0?ofkP030000003om^h0000000D0ooK^00<0e3dI
0?ofkP3D?AT04P3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00/0ooK^00@0e3dI
0?ofkP3om^h0ooK^1P3D?AT00`3om^h0e3dI0?ofkP070?ofkP030=@m6@3om^h0ooK^00d0ooK^00@0
e3dI0?ofkP3om^h0?EV[0P00000200/@9P080000000@63/041Pk0000000@63/0000001DPCP000004
0=@m6@X0hclJ00<0000003eIZ`0mFJ/01`3S?aX00`000000hclJ0><o6P060><o6P<0?EV[2P3S?aX0
0`000000hclJ0><o6P030><o6P0303eIZ`3S?aX0hclJ00D000001@3I?1T203eIZ`030=Tl6@000000
fC`I0080fC`I00<0?EV[0=Tl6@3I?1T0103I?1T00`000000fC`I0=Tl6@070=Tl6@030000003I?1T0
fC`I0080fC`I00<0?EV[0=Tl6@3I?1T0103I?1T00`000000fC`I0=Tl6@090=Tl6@030000000mFJ/0
fC`I00P0fC`I00<000000=Tl6@3I?1T01P0000000`0mFJ/0c3LG0000000:0<`g5`H00000103<=aL0
0`000000?EV[0?ofkP0203eIZ`030?ofkP0mFJ/0?EV[0080ooK^00@0e3dI0?ofkP3om^h0e3dI2P3o
m^h90=@m6@@0ooK^00<000000?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP0A0?ofkP030=@m6@3o
m^h0ooK^03T0ooK^00<000000?ofkP3om^h04P3om^h10?ooo`00F@3om^h00`000000ooK^00000005
0?ofkP030=@m6@3om^h0e3dI0180ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP0;
0?ofkP030=@m6@3om^h0ooK^00L0ooK^1`3D?AT30?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI
0?ofkP3om^h00`00000200/@9P080000000@63/041Pk0000000@63/0000001DPCP00000301DPCP03
0000003S?aX0hclJ00P0hclJ00<000000><o6P0mFJ/01`3S?aX00`000000hclJ0><o6P050><o6P05
03eIZ`3S?aX0hclJ0000000mFJ/02@3S?aX00`000000hclJ0><o6P020><o6P0303eIZ`3S?aX0hclJ
00<0hclJ00<000000><o6P3S?aX01P0000000`3I?1T0?EV[03eIZ`030=Tl6@0303eIZ`3I?1T0fC`I
00@0fC`I00<000000=Tl6@3I?1T01`3I?1T00`000000fC`I0=Tl6@020=Tl6@0303eIZ`3I?1T0fC`I
00@0fC`I00<000000=Tl6@3I?1T0203I?1T00`000000?EV[0=Tl6@090=Tl6@030000003I?1T0fC`I
00D0fC`I00<0?EV[0000000000000`0000080<`g5`0303eIZ`3<=aL0c3LG00<0c3LG1P00000203eI
Z`80ooK^00L0?EV[0?ofkP3om^h0ooK^0=@m6@3om^h0e3dI0140ooK^1P3D?AT00`000000ooK^0?of
kP0<0?ofkP030=@m6@3om^h0ooK^0140ooK^00<0e3dI0?ofkP3om^h0>P3om^h00`000000ooK^0?of
kP0A0?ofkP40oooo001I0?ofkP030000003om^h0000000D0ooK^00<0e3dI0?ofkP3D?AT00`3D?AT?
0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP08
0?ofkP030=@m6@3om^h0ooK^00@0ooK^1`3D?AT;0?ofkP080=@m6@3om^h0ooK^0?ofkP0000002a0V
0000000;42H2000000@041Pk00<0000001DPCP000000100E84h00`000000hclJ0><o6P070><o6P04
0000003S?aX0?EV[03eIZ`H0hclJ00<000000><o6P3S?aX01@3S?aX01P0mFJ/0hclJ0><o6P000000
hclJ03eIZ`P0hclJ00<000000><o6P3S?aX00P3S?aX00`0mFJ/0hclJ0><o6P030><o6P030000003S
?aX0hclJ00H0hclJ0`00000303eIZ`L0fC`I00<000000=Tl6@3I?1T01`3I?1T01@000000fC`I0=Tl
6@3I?1T0?EV[00L0fC`I00<000000=Tl6@3I?1T0203I?1T00`000000?EV[0=Tl6@080=Tl6@030000
003I?1T0fC`I00H0fC`I00@0?EV[0=Tl6@3I?1T000000P3I?1T600000080c3LG00<0?EV[0<`g5`3<
=aL01`3<=aL00`0mFJ/0ooK^0000000500000080ooK^00<0e3dI0?ofkP3D?AT04P3om^h20=@m6@80
ooK^00<000000=@m6@3D?AT0103D?AT:0?ofkP030=@m6@3om^h0ooK^0100ooK^00<0e3dI0?ofkP3o
m^h0>P3om^h00`000000ooK^0?ofkP0A0?ofkP40oooo001I0?ofkP8000001P3om^h00`3D?AT0ooK^
0=@m6@030?ofkPH0e3dI203om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00/0ooK^
00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP070?ofkP040=@m6@3om^h0ooK^0?ofkPH0
e3dI1@3om^h01@3D?AT0ooK^0?ofkP0mFJ/0000000802a0V0P0000001@0@63/00000010H>`0@63/0
000000<05B1>00D0000001DPCP0E84h05B1>000000090><o6P050000000mFJ/0hclJ0><o6P0mFJ/0
1@3S?aX00`000000hclJ0><o6P040><o6P0503eIZ`3S?aX0hclJ0><o6P0000000P3S?aX203eIZ`H0
hclJ00<000000><o6P3S?aX00P3S?aX00`0mFJ/0hclJ0><o6P030><o6P030000003S?aX0hclJ00P0
hclJ00<000000><o6P3S?aX00P0mFJ/400000080fC`I00<000000=Tl6@3I?1T01`3I?1T01@000000
fC`I0=Tl6@3I?1T0?EV[00L0fC`I00<000000=Tl6@3I?1T0203I?1T00`0mFJ/0fC`I0=Tl6@080=Tl
6@030000003I?1T0fC`I00D0fC`I00@0?EV[0=Tl6@3I?1T000002@3I?1T00`000000?EV[00000002
000000D0c3LG0P0mFJ/00`000000ooK^03eIZ`020?ofkP0303eIZ`3om^h0ooK^00H000004@3om^h2
0=@m6@80ooK^00<000000?ofkP3om^h0103om^h70=@m6@<0ooK^00<0e3dI0?ofkP3om^h04@3om^h0
0`3D?AT0ooK^0?ofkP0i0?ofkP030000003om^h0ooK^0140ooK^0@3oool005T0ooK^0P0000050?of
kP040=@m6@3om^h0ooK^0=@m6@T0ooK^1P3D?AT20?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI
0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI
0?ofkP3om^h01`3om^h70=@m6@030?ofkP0mFJ/0000000802a0V0P0000001@0@63/00000010H>`0@
63/0000000<05B1>00@0000001DPCP0E84h05B1>0`0000080><o6P0503eIZ`3S?aX0hclJ0><o6P0m
FJ/0103S?aX00`000000hclJ0><o6P040><o6P0503eIZ`3S?aX0hclJ0><o6P000000103S?aX00`0m
FJ/0hclJ0><o6P030><o6P050000003S?aX0hclJ0><o6P0mFJ/01P3S?aX00`000000hclJ0><o6P08
0><o6P050000003S?aX0hclJ03eIZ`3S?aX00`0mFJ/00`3S?aX0000000000005000000D0fC`I00@0
00000=Tl6@3I?1T0?EV[203I?1T00`000000fC`I0=Tl6@080=Tl6@0303eIZ`3I?1T0fC`I00P0fC`I
00<000000=Tl6@3I?1T0103I?1T01@0mFJ/0fC`I0=Tl6@3I?1T0000000X0fC`I00@0?EV[0000003I
?1T0fC`I0`00000303eIZ`050<`g5`000000?EV[03eIZ`3om^h00P0mFJ/40?ofkP80e3dI0P3om^h5
000000/0ooK^00D0e3dI0?ofkP3D?AT0ooK^0000000>0?ofkPH0e3dI4@3om^h00`3D?AT0ooK^0?of
kP0i0?ofkP030000003om^h0ooK^0140ooK^0@3oool005P0ooK^00<000000?ofkP0000001@3om^h0
0`3D?AT0ooK^0=@m6@0@0?ofkPH0e3dI0`3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0
ooK^00P0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0
0000008000000P0;42H200000005010H>`00000041Pk010H>`0000000`0E84h01@0000005B1>01DP
CP0E84h000000080jd8K1P0000000`3S?aX0?EV[000000030><o6P0303eIZ`3S?aX0hclJ00<0hclJ
00<000000><o6P3S?aX00`3S?aX01@0mFJ/0hclJ0><o6P3S?aX0000000D0hclJ00<0?EV[0><o6P3S
?aX00P3S?aX01@000000hclJ0><o6P3S?aX0?EV[00H0hclJ00<000000><o6P3S?aX0203S?aX00`00
0000hclJ03eIZ`050><o6P<0?EV[00<000000><o6P3S?aX00P3S?aX80000000303eIZ`3I?1T0fC`I
00D0fC`I00<000000=Tl6@3I?1T0203I?1T00`0mFJ/000000=Tl6@090=Tl6@030000003I?1T0fC`I
00@0fC`I00D0?EV[0=Tl6@3I?1T0fC`I000000090=Tl6@0303eIZ`000000fC`I00<0fC`I0P0mFJ/2
0=Tl6@0303eIZ`000000000000@0?EV[1@3om^h20=@m6@L0ooK^1P0000050?ofkP040=@m6@3om^h0
e3dI00000180ooK^00<0e3dI0?ofkP3om^h01@3D?AT<0?ofkP030=@m6@3om^h0ooK^03X0ooK^00<0
00000?ofkP3om^h0403om^h10?ooo`00F03om^h00`000000ooK^000000050?ofkP030=@m6@3om^h0
e3dI0180ooK^00@0e3dI0?ofkP3om^h0ooK^1P3D?AT:0?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0
e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h00000008000000P0;
42H02000000041Pk010H>`00000041Pk0000000E84h000000P0E84h01P0000005B1>01DPCP000000
7c1[000000L0jd8K00<0000003eIZ`0000000P0000020><o6P0303eIZ`3S?aX0hclJ0080hclJ00<0
00000><o6P3S?aX00P3S?aX00`0mFJ/0hclJ0><o6P030><o6P030000003S?aX0hclJ00<0hclJ0P0m
FJ/20><o6P040000003S?aX0hclJ03eIZ`L0hclJ00<000000><o6P3S?aX0203S?aX00`000000hclJ
03eIZ`080><o6P@0?EV[1P3S?aX00`000000hclJ03eIZ`0600000080fC`I00<000000=Tl6@3I?1T0
203I?1T00`0mFJ/000000=Tl6@090=Tl6@030000003I?1T0fC`I00<0fC`I00<0?EV[0=Tl6@3I?1T0
0P3I?1T00`000000fC`I0=Tl6@070=Tl6@0403eIZ`000000fC`I0=Tl6@80?EV[0`3I?1T01@0mFJ/0
fC`I0=Tl6@0mFJ/0e3dI00<0?EV[1@3om^h20=@m6@d0ooK^1P0000000`3om^h0e3dI0000000B0?of
kP030=@m6@3om^h0ooK^00D0ooK^1P3D?AT60?ofkP030=@m6@3om^h0ooK^03X0ooK^00<000000?of
kP3om^h0403om^h10?ooo`00F03om^h00`000000ooK^000000050?ofkP@0e3dI4@3om^h00`3D?AT0
ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00H0e3dI103om^h00`3D?AT0ooK^0?ofkP090?ofkP03
0=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0000000H84@0200000080
2a0V00P00000010H>`0@63/00000010H>`0000005B1>000000<05B1>00D0000001DPCP0000007c1[
000000080>]26`0403eIZ`000000jd8K0>]26`<0000000D0?EV[0000003S?aX0hclJ000000040><o
6P0303eIZ`3S?aX0hclJ00<0hclJ00<000000><o6P3S?aX01@3S?aX00`0mFJ/0hclJ000000020><o
6P0303eIZ`3S?aX0hclJ00D0hclJ00<000000><o6P3S?aX0203S?aX00`000000?EV[0><o6P070><o
6P030000003S?aX0hclJ0080hclJ0`0mFJ/30><o6P030000003S?aX0?EV[00H0hclJ1@0000070=Tl
6@0303eIZ`000000fC`I00X0fC`I00<000000=Tl6@3I?1T00`3I?1T01@0mFJ/0fC`I0=Tl6@3I?1T0
000000T0fC`I00<0?EV[0=Tl6@0000000P0mFJ/50=Tl6@0303eIZ`3I?1T0000000@0?EV[0`3D?AT2
0?ofkP030=@m6@3om^h0e3dI0140ooK^00<0e3dI0?ofkP0000001@00000?0?ofkP030=@m6@3om^h0
ooK^00/0ooK^1@3D?AT20?ofkP030=@m6@3om^h0ooK^03T0ooK^00<000000?ofkP3om^h0403om^h1
0?ooo`00F03om^h00`000000ooK^000000050?ofkP040=@m6@3om^h0e3dI0?ofkPH0e3dI2P3om^h0
0`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00H0ooK^1P3D?AT90?ofkP030=@m6@3om^h0
ooK^00L0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0000000000002000000802a0V00P00000
010H>`0@63/00000010H>`0000005B1>000000<05B1>00D0000001DPCP0000007c1[000000070>]2
6`0403eIZ`3[@Q/0jd8K000000D0jd8K00<0?EV[000000000000100000000`0mFJ/000000><o6P04
0><o6P030000003S?aX0hclJ00H0hclJ00D0?EV[0000003S?aX0hclJ03eIZ`070><o6P030000003S
?aX0hclJ00L0hclJ00<000000><o6P0mFJ/0203S?aX00`000000hclJ0><o6P050><o6P<0?EV[00<0
000003eIZ`3S?aX0203S?aX00`000000hclJ0><o6P06000000030=Tl6@0mFJ/0000000X0fC`I00<0
00000=Tl6@3I?1T00`3I?1T00`0mFJ/0fC`I0=Tl6@020=Tl6@030000003I?1T0fC`I00L0fC`I0`0m
FJ/60=Tl6@0503eIZ`3I?1T0fC`I03eIZ`3om^h00`0mFJ/30?ofkPD0e3dI403om^h01@3D?AT0ooK^
0?ofkP000000e3dI00@0ooK^1@00000;0?ofkP030=@m6@3om^h0ooK^00l0ooK^0`3D?ATk0?ofkP03
0000003om^h0ooK^0100ooK^0@3oool005P0ooK^0P0000060?ofkP030=@m6@3om^h0e3dI00L0ooK^
1`3D?AT30?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^
0=@m6@050=@m6@<0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP060=@m
6@000000000000/@9P0000002a0V0P000004010H>`040000000E84h05B1>000000805B1>00<00000
01DPCP0000000P0O<6/00`000000jd8K0>]26`040>]26`0403eIZ`3[@Q/0jd8K000000H0jd8K00<0
?EV[0>]26`0000000`3[@Q/00`0mFJ/0jd8K00000007000000L0hclJ0`0mFJ/80><o6P030000003S
?aX0hclJ00L0hclJ00<0000003eIZ`3S?aX0203S?aX00`000000hclJ0><o6P080><o6P@0?EV[1`3S
?aX00`000000hclJ0><o6P060><o6P0303eIZ`000000000000800000203I?1T00`000000fC`I0=Tl
6@030=Tl6@0303eIZ`3I?1T0fC`I0080fC`I00<000000=Tl6@3I?1T0103I?1T403eIZ`030000003I
?1T0fC`I00D0fC`I00<0?EV[0=Tl6@3I?1T00P3D?AT203eIZ`H0ooK^00<0e3dI0?ofkP3D?AT01P3D
?AT:0?ofkP060=@m6@3om^h0ooK^0000003om^h0e3dI203om^h6000000D0ooK^00<0e3dI0?ofkP3o
m^h04@3om^h00`3D?AT0ooK^0?ofkP0i0?ofkP030000003om^h0ooK^0100ooK^0@3oool005P0ooK^
0P0000050?ofkP040=@m6@3om^h0ooK^0=@m6@h0ooK^1`3D?AT30?ofkP030=@m6@3om^h0ooK^00/0
ooK^00<0e3dI0?ofkP3om^h01@3om^h70=@m6@D0ooK^00<0e3dI0?ofkP3om^h03@3om^h02P3D?AT0
00000000000000002a0V0000000;42H00000010H>`000002010H>`050000000E84h05B1>01DPCP00
00000`0E84h01@0000007c1[01l`J`0O<6/0000000D0jd8K00D0?EV[0>]26`3[@Q/0jd8K00000007
0>]26`0303eIZ`000000jd8K0080jd8K00<0?EV[0>]26`3[@Q/0103[@Q/00`000000jd8K0>]26`05
00000080hclJ00<000000><o6P0mFJ/0203S?aX00`000000hclJ0><o6P070><o6P030000000mFJ/0
hclJ00P0hclJ00<000000><o6P3S?aX0203S?aX0100mFJ/0hclJ0><o6P3S?aX603eIZ`030><o6P00
0000hclJ00L0hclJ00<0?EV[0><o6P0000000P3S?aX600000080fC`I00<000000=Tl6@3I?1T00P3I
?1T00`0mFJ/0fC`I0=Tl6@030=Tl6@030000003I?1T0?EV[00@0?EV[00D0fC`I03eIZ`3I?1T0fC`I
000000060=Tl6@0503eIZ`3I?1T0fC`I0=Tl6@0000000`0mFJ/60=@m6@80ooK^00<0e3dI0?ofkP3o
m^h0103om^h60=@m6@<0ooK^00@0e3dI0?ofkP3om^h000000P3om^h00`3D?AT0ooK^0?ofkP0<0?of
kPH000004`3om^h00`3D?AT0ooK^0?ofkP0j0?ofkP030000003om^h0ooK^00l0ooK^0@3oool005L0
ooK^00<000000?ofkP0000001@3om^h00`3D?AT0ooK^0=@m6@0B0?ofkP040=@m6@3om^h0ooK^0?of
kPH0e3dI2P3om^h00`3D?AT0ooK^0?ofkP090?ofkP040=@m6@3om^h0ooK^0?ofkPH0e3dI3`3om^h0
1@3D?AT000000000000000002a0V008000000P0@63/01000000041Pk010H>`00000301DPCP050000
000E84h05B1>01DPCP0000000`0O<6/00`000000jd8K0>]26`030>]26`0503eIZ`3[@Q/0jd8K0>]2
6`0000001`3[@Q/01@0mFJ/0jd8K0000003[@Q/0?EV[00L0jd8K00<000000>]26`3[@Q/01@3[@Q/4
000000<0?EV[1P3S?aX00`000000hclJ0><o6P070><o6P0303eIZ`3S?aX0hclJ00P0hclJ00<00000
0><o6P3S?aX0203S?aX00`0mFJ/0hclJ0><o6P070><o6PH0?EV[0`3S?aX00`0mFJ/0hclJ00000009
0><o6PD000000P3I?1T00`0mFJ/0fC`I03eIZ`0503eIZ`H0fC`I00@0?EV[0=Tl6@3I?1T000001P3I
?1T0100mFJ/0fC`I0=Tl6@00000303eIZ`H0ooK^1P3D?AT:0?ofkP@0e3dI00<0ooK^0000003om^h0
0P3om^h00`3D?AT0ooK^0?ofkP0A0?ofkP030=@m6@000000000000@000003@3om^h00`3D?AT0ooK^
0?ofkP0j0?ofkP030000003om^h0ooK^00l0ooK^0@3oool005L0ooK^00<000000?ofkP0000001@3o
m^h00`3D?AT0ooK^0=@m6@0B0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h01`3D
?AT30?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h01P3om^h70=@m6@T0ooK^00D0
e3dI000000000000000000/@9P020000008041Pk00@00000010H>`0@63/000000`0E84h01@000000
5B1>01DPCP0E84h0000000<07c1[00<0e3dI0000000mFJ/00`3[@Q/00`0mFJ/0jd8K0>]26`020>]2
6`030000003[@Q/0jd8K00D0jd8K00@0?EV[0000003[@Q/0?EV[1`3[@Q/00`000000jd8K0>]26`07
0>]26`030000000mFJ/0jd8K008000000P0mFJ/200000080hclJ00<000000><o6P3S?aX01`3S?aX0
0`0mFJ/0hclJ0><o6P080><o6P030000003S?aX0hclJ00L0hclJ00<0?EV[0><o6P3S?aX0203S?aX0
0`000000hclJ0><o6P030><o6QP0?EV[00@000000=Tl6@3I?1T000001`3I?1T01@0mFJ/0fC`I0=Tl
6@3I?1T0000000D0fC`I00@0?EV[0=Tl6@3I?1T0fC`I100mFJ/60?ofkP040=@m6@3om^h0ooK^0=@m
6@80ooK^1P3D?AT70?ofkP030=@m6@3om^h0000000<0ooK^00<0e3dI0?ofkP3om^h04@3om^h00`3D
?AT0ooK^0?ofkP040?ofkPD000002@3om^h00`3D?AT0ooK^0?ofkP0i0?ofkP030000003om^h0ooK^
00l0ooK^0@3oool005L0ooK^00<000000?ofkP0000001@3om^h00`3D?AT0ooK^0=@m6@0B0?ofkP03
0=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h01`3om^h70=@m6@P0ooK^00<0e3dI0?ofkP3o
m^h01P3om^h00`3D?AT0ooK^0?ofkP040?ofkPH0e3dI0`3om^h01P3D?AT000000000000000002a0V
000000<041Pk00@00000010H>`0000000000100E84h01@0000005B1>0000000O<6/0000000807c1[
00<0e3dI0000000mFJ/00P3[@Q/00`0mFJ/0jd8K0>]26`030>]26`030000003[@Q/0jd8K00H0jd8K
0P0mFJ/90>]26`030000003[@Q/0jd8K00H0jd8K00<0000003eIZ`3[@Q/0103[@Q/203eIZ`L00000
1@3S?aX00`0mFJ/0hclJ0><o6P070><o6P030000003S?aX0hclJ00P0hclJ00<0?EV[0><o6P3S?aX0
203S?aX00`000000hclJ0><o6P050><o6P0403eIZ`3S?aX0hclJ000000X0hclJ00D000000><o6P3S
?aX0hclJ03eIZ`040><o6PP000000P3I?1T0100mFJ/0fC`I0=Tl6@0000060=Tl6@0503eIZ`3I?1T0
fC`I03eIZ`0000000P0mFJ/60?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT0203om^h50=@m6@040?of
kP3D?AT0ooK^000000@0ooK^00<0e3dI0?ofkP3om^h04@3om^h00`3D?AT0ooK^0?ofkP090?ofkPH0
00000`3om^h00`3D?AT0ooK^0?ofkP0i0?ofkP030000003om^h0ooK^00l0ooK^0@3oool005L0ooK^
00<000000?ofkP000000103om^h0103D?AT0ooK^0?ofkP3D?ATA0?ofkP030=@m6@3om^h0ooK^00D0
ooK^00<0e3dI0?ofkP3om^h02P3om^h0103D?AT0ooK^0?ofkP3om^h60=@m6@80ooK^00<0e3dI0?of
kP3om^h01@3om^h00`3D?AT0ooK^0?ofkP0;0?ofkPH0e3dI00<0000000/@9P0000000`0@63/01@00
000041Pk0000000E84h0000000<05B1>00D0000001DPCP0000007c1[0000000201l`J`060=@m6@0O
<6/0000003eIZ`3[@Q/0?EV[1@3[@Q/00`000000jd8K0>]26`060>]26`030000000mFJ/0jd8K00P0
jd8K00<000000>]26`3[@Q/01P3[@Q/00`0mFJ/0jd8K0>]26`060>]26`0303eIZ`3[@Q/0000000@0
jd8K10000000100mFJ/000000000000000070><o6P030000003S?aX0hclJ00L0hclJ00<0?EV[0000
003S?aX02@3S?aX00`000000hclJ0><o6P050><o6P0403eIZ`3S?aX0hclJ000000X0hclJ00D00000
0><o6P3S?aX0hclJ03eIZ`060><o6P030000003S?aX0hclJ00<0hclJ00<0000003eIZ`0000001@00
00030=Tl6@0503eIZ`3I?1T0?EV[03eIZ`3I?1T00P0mFJ/70?ofkP050=@m6@3om^h0ooK^0?ofkP3D
?AT03@3om^h60=@m6@80ooK^00<0e3dI0?ofkP3om^h04@3om^h00`3D?AT0ooK^0?ofkP0?0?ofkPH0
0000>P3om^h00`000000ooK^0?ofkP0>0?ofkP40oooo001G0?ofkP8000001@3om^h0103D?AT0ooK^
0?ofkP3D?ATA0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0
ooK^0?ofkP070?ofkPL0e3dI0`3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@000000000000H0
e3dI00D00000010H>`0000005B1>0000000301DPCP030000000E84h0000000807c1[00D0000001l`
J`3D?AT07c1[0000000203eIZ`L0jd8K00<000000>]26`3[@Q/01P3[@Q/303eIZ`L0jd8K00<00000
0>]26`3[@Q/01P3[@Q/00`0mFJ/0jd8K0>]26`070>]26`80?EV[203[@Q/0100mFJ/000000>]26`3[
@Q/500000080hclJ00<000000><o6P3S?aX01`3S?aX00`0mFJ/000000><o6P090><o6P030000003S
?aX0hclJ00@0hclJ00@0?EV[0><o6P3S?aX000002`3S?aX010000000hclJ0><o6P0mFJ/60><o6P03
0000003S?aX0hclJ00@0hclJ00<0?EV[0><o6P3S?aX00P3S?aX00`000000hclJ0><o6P0300000080
?EV[0P3I?1T00`000000?EV[03eIZ`070?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT03P3om^h00`3D
?AT000000?ofkP020?ofkPH0e3dI4@3om^h00`3D?AT0ooK^0?ofkP0A0?ofkP030=@m6@3om^h0ooK^
00H00000=03om^h00`000000ooK^0?ofkP0>0?ofkP40oooo001G0?ofkP8000001@3om^h0103D?AT0
ooK^0?ofkP3D?ATA0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D
?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00<0ooK^1P3D?AT>0?ofkP030=@m6@0000002a0V
00<000000`0@63/60=@m6@<05B1>00/0000001l`J`0O<6/07c1[0000000O<6/0e3dI01l`J`000000
jd8K03eIZ`070>]26`030000003[@Q/0jd8K00D0jd8K00D0?EV[0000003[@Q/0jd8K03eIZ`060>]2
6`030000003[@Q/0jd8K00H0jd8K00<0?EV[0>]26`3[@Q/0203[@Q/00`000000?EV[03eIZ`050>]2
6`0303eIZ`3[@Q/0000000L0jd8K1@0000060><o6P0303eIZ`3S?aX0000000X0hclJ00<000000><o
6P3S?aX0103S?aX0100mFJ/0hclJ0><o6P00000:0><o6P050000003S?aX0hclJ0><o6P0mFJ/01P3S
?aX00`000000hclJ0><o6P040><o6P0503eIZ`3S?aX0hclJ0><o6P0000001@3S?aX203eIZ`030><o
6P00000000000080?EV[1`3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00/0ooK^
00<0e3dI0000003om^h01@3om^h0103D?AT0ooK^0?ofkP3om^h70=@m6@X0ooK^00<0e3dI0?ofkP3o
m^h04@3om^h00`3D?AT0ooK^0?ofkP060?ofkPH00000;P3om^h00`000000ooK^0?ofkP0>0?ofkP40
oooo001F0?ofkP030000003om^h0000000D0ooK^00<0e3dI0?ofkP3D?AT04P3om^h00`3D?AT0ooK^
0?ofkP040?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^
0?ofkP060?ofkP030=@m6@3om^h0ooK^00D0e3dI203om^h0103D?AT0?EV[0000000;42H200000003
010H>`00000041Pk008041Pk00D0000001DPCP0E84h0000001DPCP060=@m6@0401l`J`0000007c1[
0=@m6@807c1[00<0000003eIZ`0mFJ/01P3[@Q/00`000000jd8K0>]26`050>]26`0303eIZ`000000
jd8K0080jd8K00<0?EV[0>]26`3[@Q/00`3[@Q/00`000000jd8K0>]26`050>]26`0303eIZ`000000
jd8K00T0jd8K00<000000>]26`3[@Q/00P0mFJ/30>]26`0303eIZ`3[@Q/0000000T0jd8K00<00000
0>]26`3[@Q/01P0000000`0mFJ/0hclJ000000090><o6P030000003S?aX0hclJ00@0hclJ00D0?EV[
0><o6P3S?aX0hclJ0000000:0><o6P040000003S?aX0hclJ03eIZ`L0hclJ00<000000><o6P3S?aX0
0`3S?aX00`0mFJ/0hclJ0><o6P020><o6P030000003S?aX0hclJ00<0hclJ00@0?EV[0><o6P3S?aX0
hclJ0`0mFJ/70?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0
00000?ofkP050?ofkP030=@m6@3om^h0ooK^00P0ooK^1`3D?AT30?ofkP030=@m6@3om^h0ooK^0140
ooK^00<0e3dI0?ofkP3om^h0303om^h5000002T0ooK^00<000000?ofkP3om^h03P3om^h10?ooo`00
EP3om^h00`000000ooK^000000050?ofkP030=@m6@3om^h0e3dI0180ooK^00<0e3dI0?ofkP3om^h0
103om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h0
1P3om^h00`3D?AT0ooK^0?ofkP050?ofkPD0e3dI0`3om^h0103D?AT01PPA0000000;42H200000003
010H>`00000041Pk008041Pk00D0000001DPCP0E84h05B1>0000000201DPCP8000000P0O<6/60=@m
6@040000000mFJ/0000003eIZ`D0jd8K00<000000>]26`3[@Q/01@3[@Q/00`0mFJ/000000>]26`03
0>]26`80?EV[0`3[@Q/00`000000jd8K0>]26`050>]26`0303eIZ`000000jd8K00T0jd8K00<00000
0>]26`3[@Q/00P3[@Q/303eIZ`80jd8K00<000000>]26`3[@Q/01`3[@Q/00`000000jd8K0>]26`05
0>]26`0303eIZ`000000000000<000001`3S?aX00`000000hclJ0><o6P040><o6P0503eIZ`3S?aX0
hclJ0><o6P0000002P3S?aX010000000hclJ0><o6P0mFJ/60><o6P030000003S?aX0hclJ00@0hclJ
00D0?EV[0><o6P3S?aX0hclJ000000040><o6P80?EV[103S?aX203eIZ`P0ooK^00<0e3dI0?ofkP3o
m^h00P3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3o
m^h03`3om^h60=@m6A40ooK^00<0e3dI0?ofkP3om^h04@3om^h6000002<0ooK^00<000000?ofkP3o
m^h03P3om^h10?ooo`00EP3om^h00`000000ooK^000000040?ofkP040=@m6@3om^h0ooK^0=@m6A80
ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00T0
ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP@0e3dI0P0000001`0;42H0
0000010H>`0@63/0000003eIZ`0@63/00P00000301DPCP060000000E84h05B1>0000000O<6/00000
0`0O<6/01@000000e3dI01l`J`0O<6/000000080lD@L00<0000003eIZ`0000000P0000020>]26`03
0000003[@Q/0jd8K00<0jd8K00@0?EV[0>]26`3[@Q/000001@3[@Q/0100mFJ/0jd8K0>]26`000006
0>]26`0403eIZ`3[@Q/0jd8K000000T0jd8K00<000000>]26`3[@Q/0103[@Q/203eIZ`030>]26`00
0000jd8K00P0jd8K00<000000>]26`3[@Q/01@3[@Q/0100mFJ/0jd8K0>]26`0000020>]26`D00000
0P3S?aX00`000000hclJ0><o6P030><o6P0503eIZ`3S?aX0hclJ0><o6P0000002P3S?aX010000000
hclJ0><o6P0mFJ/70><o6P030000003S?aX0hclJ00<0hclJ00<0?EV[0><o6P3S?aX00P3S?aX00`00
0000hclJ0><o6P0303eIZ`@0hclJ0P0mFJ/50=@m6@<0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D
?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h04P3om^h00`3D
?AT0ooK^0?ofkP050=@m6@d0ooK^00<0e3dI0?ofkP3om^h05P3om^h6000001h0ooK^00<000000?of
kP3om^h03@3om^h10?ooo`00EP3om^h00`000000ooK^000000040?ofkP030=@m6@3om^h0ooK^00@0
e3dI3`3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3o
m^h02@3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00h0ooK^00D0e3dI00000000
00002a0V00000002010H>`060000000mFJ/041Pk0000000E84h000000P0E84h00`0000005B1>0000
000201l`J`0:0000000O<6/07c1[01l`J`000000e3dI01l`J`000000:Cj6000000<0lD@L00<0?EV[
0?54703aA1`01`0000001@3[@Q/0?EV[0>]26`3[@Q/0000000H0jd8K00@0?EV[0>]26`3[@Q/00000
1@3[@Q/0100mFJ/0jd8K0>]26`0000090>]26`030000003[@Q/0jd8K00@0jd8K00<0?EV[0>]26`0m
FJ/00P0mFJ/80>]26`030000003[@Q/0jd8K00@0jd8K00D0?EV[0>]26`3[@Q/0jd8K000000070>]2
6`L0000000<0hclJ03eIZ`3S?aX00P3S?aX00`000000hclJ0><o6P080><o6P040000003S?aX0hclJ
03eIZ`H0hclJ00<000000><o6P3S?aX00`3S?aX00`0mFJ/0hclJ0><o6P020><o6P040000003S?aX0
?EV[03eIZ`80hclJ00<0?EV[0><o6P3S?aX00P3S?aX203eIZ`D0ooK^1P3D?AT30?ofkP030=@m6@3o
m^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP0B0?ofkP030=@m6@3o
m^h0ooK^00D0ooK^1P3D?AT70?ofkP030=@m6@3om^h0ooK^01`0ooK^1P00000H0?ofkP030000003o
m^h0ooK^00d0ooK^0@3oool005H0ooK^0P0000050?ofkP@0e3dI0`3om^h60=@m6@T0ooK^00<0e3dI
0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI
0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP050=@m6@000000000000/@9P0000000P0@
63/00`00000041Pk0000000201DPCP060000000E84h05B1>0000000E84h000000`0O<6/02@000000
7c1[01l`J`3D?AT0000001l`J`000000:Cj6000000040?54700503eIZ`3aA1`0lD@L0?5470000000
103aA1`00`0mFJ/0000000000004000000D0jd8K0P0mFJ/00`000000jd8K0>]26`030>]26`0403eI
Z`3[@Q/0jd8K000000T0jd8K00<000000>]26`3[@Q/00`3[@Q/0100mFJ/0jd8K0>]26`0000020>]2
6`<0?EV[1@3[@Q/00`000000jd8K0>]26`040>]26`0403eIZ`3[@Q/0jd8K000000X0jd8K00<00000
0>]26`3[@Q/00P3[@Q/00`0mFJ/0000000000005000000P0hclJ00<000000><o6P0mFJ/01`3S?aX0
0`000000hclJ0><o6P030><o6P0403eIZ`3S?aX0hclJ0><o6P<0?EV[0`3S?aX00`0mFJ/0hclJ0><o
6P020><o6P80?EV[2@3om^h00`3D?AT0ooK^0?ofkP060=@m6@T0ooK^00<000000=@m6@3om^h01`3o
m^h00`3D?AT0ooK^0?ofkP0B0?ofkP030=@m6@3om^h0ooK^00/0ooK^1@3D?AT20?ofkP030=@m6@3o
m^h0ooK^0280ooK^1@00000C0?ofkP030000003om^h0ooK^00d0ooK^0@3oool005H0ooK^0P000005
0?ofkP030=@m6@3om^h0ooK^00D0e3dI1@3om^h60=@m6@80ooK^00<0e3dI0?ofkP3om^h0103om^h0
0`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h01@3om^h0
0`3D?AT0ooK^0?ofkP0=0?ofkP030000003D?AT02a0V00<000000`0@63/2000000805B1>00D00000
01DPCP0E84h05B1>0000000401l`J`070000000O<6/07c1[0=@m6@0000007c1[0000000202TnQP03
0000003aA1`0lD@L0080lD@L00D0?EV[0?54703aA1`0lD@L000000030?54700503eIZ`3aA1`0lD@L
0?54700000000P3aA1`500000080jd8K00<0?EV[0>]26`3[@Q/00P3[@Q/01@0mFJ/0jd8K0>]26`3[
@Q/0000000T0jd8K00<000000>]26`3[@Q/00`3[@Q/0100mFJ/0jd8K0>]26`0000050>]26`<0?EV[
0P3[@Q/00`000000jd8K0>]26`030>]26`0503eIZ`3[@Q/0jd8K0>]26`0000002@3[@Q/00`000000
jd8K0>]26`030>]26`0303eIZ`3[@Q/0jd8K0080jd8K00<000000>]26`3[@Q/01@0000020><o6P04
0000003S?aX0hclJ03eIZ`L0hclJ00<000000><o6P3S?aX00P3S?aX00`0mFJ/0hclJ0><o6P0203eI
Z`030><o6P000000hclJ0080hclJ00<0?EV[0><o6P3S?aX00`3S?aX203eIZ`P0ooK^00<0e3dI0?of
kP3om^h0103om^h00`3D?AT0ooK^0?ofkP060=@m6@80ooK^00<000000=@m6@3om^h0203om^h00`3D
?AT0ooK^0?ofkP0B0?ofkP030=@m6@3om^h0ooK^0100ooK^0`3D?ATY0?ofkPH000003@3om^h00`00
0000ooK^0?ofkP0=0?ofkP40oooo001E0?ofkP030000003om^h0000000D0ooK^00<0e3dI0?ofkP3D
?AT01@3om^h60=@m6@D0ooK^1P3D?AT30?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3o
m^h02@3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0000000;
42H00P0000001@0@63/00000010H>`0@63/0000000<05B1>00D0000001DPCP0E84h05B1>00000004
01l`J`060000000O<6/07c1[0=@m6@0O<6/000000`0Y?XH00`000000lD@L0?5470030?54700403eI
Z`3aA1`0lD@L000000<0lD@L00<0?EV[0?54703aA1`00P3aA1`00`000000lD@L0?5470040?5470<0
000000D0?EV[0000003[@Q/0jd8K03eIZ`030>]26`030000003[@Q/0jd8K00L0jd8K00<000000>]2
6`3[@Q/00P3[@Q/01@0mFJ/0jd8K0>]26`3[@Q/0000000P0jd8K0`0mFJ/50>]26`0503eIZ`3[@Q/0
jd8K0>]26`0000002@3[@Q/00`000000jd8K0>]26`020>]26`0303eIZ`3[@Q/0jd8K0080jd8K00<0
00000>]26`3[@Q/01P3[@Q/40000000303eIZ`000000000000D0hclJ00<000000><o6P3S?aX00`3S
?aX303eIZ`80hclJ00<000000><o6P3S?aX00P3S?aX00`0mFJ/0hclJ0><o6P020><o6P80?EV[2@3o
m^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00H0ooK^103D?AT80?ofkP030=@m6@3o
m^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h04P3om^h00`3D?AT0ooK^0?ofkP0]0?ofkPH00000203o
m^h00`000000ooK^0?ofkP0<0?ofkP40oooo001E0?ofkP030000003om^h0000000D0ooK^00<0e3dI
0?ofkP3D?AT02`3om^h50=@m6@80ooK^00@0e3dI0?ofkP3om^h0ooK^1`3D?AT:0?ofkP030=@m6@3o
m^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@00
00002a0V0080000000D041Pk0000000@63/041Pk0000000401DPCP040000000E84h05B1>000000D0
7c1[00D0000001l`J`3D?AT07c1[0000000302TnQP030000003aA1`0lD@L00@0lD@L00<0?EV[0?54
700000000P3aA1`00`0mFJ/0lD@L0?5470030?5470030000003aA1`0lD@L00H0lD@L00<000000?54
700mFJ/00P0mFJ/200000080jd8K00<000000>]26`3[@Q/01`3[@Q/00`000000jd8K0>]26`020>]2
6`0503eIZ`3[@Q/0jd8K0>]26`0000002@3[@Q/00`000000jd8K03eIZ`0203eIZ`030>]26`0mFJ/0
jd8K00<0jd8K00<000000>]26`3[@Q/01`3[@Q/00`000000jd8K0>]26`020>]26`0303eIZ`3[@Q/0
jd8K0080jd8K00<000000>]26`3[@Q/0203[@Q/00`000000jd8K03eIZ`020>]26`P00000100mFJ/4
0><o6P050000003S?aX0hclJ0><o6P0mFJ/0103S?aX203eIZ`<0e3dI1`3om^h00`3D?AT0ooK^0?of
kP040?ofkP030=@m6@3om^h0ooK^00L0ooK^00<000000?ofkP3D?AT0203om^h00`3D?AT0ooK^0?of
kP0C0?ofkP030=@m6@3om^h0ooK^0180ooK^00<0e3dI0?ofkP3om^h0<`3om^h600000080ooK^00<0
00000?ofkP3om^h0303om^h10?ooo`00E@3om^h00`000000ooK^000000040?ofkP040=@m6@3om^h0
ooK^0=@m6A00ooK^1P3D?AT30?ofkP040=@m6@3om^h0ooK^0?ofkPH0e3dI0`3om^h00`3D?AT0ooK^
0?ofkP090?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h0303om^h010000000e3dI
0000000;42H200000005010H>`00000041Pk010H>`000000100E84h01@0000005B1>0000000O<6/0
000000@07c1[00D0000001l`J`3D?AT07c1[0000000402TnQP030000003aA1`0lD@L00@0lD@L00D0
?EV[0?5470000000lD@L03eIZ`050?5470030000003aA1`0lD@L00H0lD@L00D000000?54703aA1`0
lD@L03eIZ`020?5470L000001@3[@Q/01@000000jd8K0>]26`3[@Q/0?EV[00@0jd8K00<000000>]2
6`3[@Q/01`3[@Q/00`000000jd8K0>]26`020>]26`@0?EV[00<0jd8K0000003[@Q/0203[@Q/00`00
0000jd8K0>]26`020>]26`0303eIZ`3[@Q/0jd8K0080jd8K00<000000>]26`3[@Q/0203[@Q/00`00
0000jd8K03eIZ`060>]26`D0?EV[00<0000003eIZ`0000000P0000020><o6P050000003S?aX0hclJ
0><o6P0mFJ/00`3S?aX303eIZ`040000003om^h0ooK^0?ofkPL0e3dI1`3om^h00`3D?AT0ooK^0?of
kP060?ofkP030000003om^h0e3dI00T0ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?of
kP0B0?ofkP030=@m6@3om^h0ooK^03T0ooK^0`00000>0?ofkP40oooo001E0?ofkP030000003om^h0
000000@0ooK^00@0e3dI0?ofkP3om^h0e3dI4P3om^h0103D?AT0ooK^0?ofkP3om^h60=@m6@L0ooK^
1P3D?AT90?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h0303om^h01@0mFJ/0e3dI
0000000;42H00000008041Pk00D00000010H>`0000005B1>0000000301DPCP050000000E84h00000
01l`J`000000100O<6/01P0000007c1[0=@m6@000000:Cj6000000<0:Cj600<000000?54703aA1`0
1@3aA1`0100mFJ/000000?54700mFJ/50?5470030000003aA1`0lD@L00H0lD@L00@000000?54703a
A1`0lD@L0`0mFJ/20?5470030000003aA1`0lD@L0080lD@L200000000`3[@Q/0?EV[0>]26`030>]2
6`030000003[@Q/0jd8K00L0jd8K00<000000>]26`3[@Q/00P3[@Q/0100mFJ/0jd8K0>]26`3[@Q/6
03eIZ`D0jd8K00<000000>]26`3[@Q/00P3[@Q/00`0mFJ/0jd8K0>]26`020>]26`030000003[@Q/0
jd8K00P0jd8K00@000000>]26`0mFJ/0jd8K1@0mFJ/00`3[@Q/000000>]26`030>]26`0403eIZ`3[
@Q/0jd8K0>]26`D0000000T0hclJ03eIZ`3S?aX0hclJ03eIZ`3S?aX0?EV[0><o6P0000002@3om^h6
0=@m6@80ooK^00<0e3dI0?ofkP3om^h01P3om^h00`000000ooK^0=@m6@090?ofkP030=@m6@3om^h0
ooK^0180ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP0j0?ofkP030000003om^h0
ooK^00d0ooK^0@3oool005D0ooK^0P0000050?ofkP040=@m6@3om^h0ooK^0=@m6A80ooK^00<0e3dI
0?ofkP3om^h00`3om^h0103D?AT0ooK^0?ofkP3om^h70=@m6@<0ooK^00<0e3dI0?ofkP3om^h01P3D
?AT30?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h0303om^h01@0mFJ/0e3dI0000
000;42H00000008041Pk00D00000010H>`0000005B1>0000000301DPCP030000000E84h000000080
7c1[00<0000001l`J`0O<6/00P0O<6/01@3D?AT07c1[0000000Y?XH0000000@0:Cj600<000000?54
703aA1`01@3aA1`203eIZ`L0lD@L00<000000?54703aA1`01P3aA1`00`000000lD@L03eIZ`030?54
7080?EV[00<000000?54703aA1`01`3aA1`01@000000lD@L0?5470000000?EV[008000000P3[@Q/0
0`000000jd8K0>]26`070>]26`030000003[@Q/0jd8K0080jd8K00<0?EV[0>]26`3[@Q/00P3[@Q/0
0`000000jd8K0>]26`020>]26`H0?EV[0`3[@Q/00`0mFJ/0jd8K0>]26`030>]26`040000003[@Q/0
jd8K0>]26`/0?EV[1P3[@Q/01@000000jd8K0>]26`3[@Q/0?EV[00D0jd8K00D000000>]26`3[@Q/0
jd8K03eIZ`020000000503eIZ`000000?EV[0><o6P0000002P3om^h00`3D?AT0ooK^0?ofkP030?of
kPH0e3dI103om^h010000000ooK^0?ofkP3D?AT90?ofkP030=@m6@3om^h0ooK^0180ooK^00<0e3dI
0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP0i0?ofkP030000003om^h0ooK^00h0ooK^0@3oool0
05D0ooK^0P0000050?ofkP040=@m6@3om^h0ooK^0=@m6A80ooK^00<0e3dI0?ofkP3om^h00`3om^h0
0`3D?AT0ooK^0?ofkP080?ofkPL0e3dI1@3om^h70=@m6@@0ooK^00<0e3dI0?ofkP3om^h0303om^h2
000000040=@m6@0000002a0V0000008041Pk00D00000010H>`0000005B1>0000000401DPCP050000
000O<6/07c1[01l`J`000000100O<6/00`3D?AT07c1[0000000202TnQP050000000Y?XH0:Cj602Tn
QP000000203aA1`00`0mFJ/0lD@L0?5470050?5470030000003aA1`0lD@L00H0lD@L00<000000?54
700mFJ/01@3aA1`203eIZ`P0lD@L00@000000?54703aA1`0?EV[0`3aA1`7000000D0jd8K00D00000
0>]26`3[@Q/0jd8K03eIZ`050>]26`030000003[@Q/0jd8K00H0jd8K00<000000>]26`0mFJ/0300m
FJ/60>]26`030000000mFJ/0jd8K00L0jd8K00<000000>]26`3[@Q/00P3[@Q/00`0mFJ/0jd8K0>]2
6`030>]26`070000003[@Q/0jd8K0>]26`0mFJ/0jd8K03eIZ`020>]26`0303eIZ`000000000000X0
ooK^00<0e3dI0?ofkP3om^h01@3om^h0103D?AT0ooK^0?ofkP3om^h70=@m6@X0ooK^00<0e3dI0?of
kP3om^h04P3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^03P0ooK^00<000000?of
kP3om^h03`3om^h10?ooo`00E03om^h00`000000ooK^000000050?ofkP030=@m6@3om^h0e3dI0180
ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP0;0?ofkP040=@m6@3om^h0ooK^0?of
kPH0e3dI0P3om^h0103D?AT0ooK^0?ofkP3om^h80=@m6@/0ooK^00<0?EV[0=@m6@0;42H00`000004
010H>`040000000E84h05B1>000000<05B1>00<0000001l`J`0O<6/00P0O<6/01P0000007c1[01l`
J`0O<6/0e3dI000000<0:Cj600D0000002TnQP0Y?XH0:Cj6000000080?547080?EV[1P3aA1`00`00
0000lD@L0?5470060?5470030000000mFJ/0lD@L00H0lD@L00<0000003eIZ`0mFJ/01P3aA1`01000
0000lD@L0?54700mFJ/50?5470030000003aA1`0lD@L0080lD@L200000000`3[@Q/0?EV[0>]26`03
0>]26`030000003[@Q/0jd8K00L0jd8K00D000000>]26`3[@Q/0jd8K03eIZ`050>]26`030000003[
@Q/0jd8K00L0jd8K00<000000>]26`0mFJ/0203[@Q/01@000000jd8K0>]26`3[@Q/0?EV[00D0jd8K
00L000000>]26`3[@Q/0jd8K03eIZ`3[@Q/0?EV[0080jd8K00<0?EV[0>]26`0000002P3om^h00`3D
?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00@0ooK^00<000000?ofkP3om^h0203D?AT30?of
kP030=@m6@3om^h0ooK^0180ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP0h0?of
kP030000003om^h0ooK^00l0ooK^0@3oool005@0ooK^00<000000?ofkP0000001@3om^h00`3D?AT0
ooK^0=@m6@0B0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0
ooK^0?ofkP070?ofkPL0e3dI0`3om^h0103D?AT0ooK^0?ofkP3om^h80=@m6@<0ooK^00<0?EV[0=@m
6@0;42H00P0000001@0@63/00000010H>`0@63/0000000<05B1>00D0000001DPCP0E84h05B1>0000
000401l`J`060000000O<6/07c1[01l`J`3D?AT00000100Y?XH01@000000:Cj602TnQP0Y?XH00000
00H0lD@L00<0?EV[0?54700000000P0mFJ/40?5470030000003aA1`0lD@L00H0lD@L00<0000003eI
Z`3aA1`01P3aA1`00`000000lD@L0?54700203eIZ`@0lD@L00<000000?54700mFJ/01P3aA1`00`00
0000lD@L0?5470070?5470040000003aA1`0lD@L03eIZ`<000000P3[@Q/00`000000jd8K0>]26`07
0>]26`050000003[@Q/0jd8K0>]26`0mFJ/01@3[@Q/00`000000jd8K0>]26`070>]26`030000000m
FJ/0jd8K00L0jd8K00<000000>]26`3[@Q/00P3[@Q/00`0mFJ/0jd8K0>]26`030>]26`030000003[
@Q/0jd8K00<0?EV[0P3[@Q/0100mFJ/0jd8K0>]26`00000:0?ofkP030=@m6@3om^h0ooK^00H0ooK^
00<0e3dI0?ofkP3om^h00`3om^h01@000000ooK^0?ofkP3om^h0e3dI00L0ooK^1P3D?ATB0?ofkP03
0=@m6@3om^h0ooK^0180ooK^00<0e3dI0?ofkP3om^h0>03om^h00`000000ooK^0?ofkP0@0?ofkP40
oooo001D0?ofkP030000003om^h0000000D0ooK^00<0e3dI0?ofkP3D?AT04P3om^h00`3D?AT0ooK^
0?ofkP040?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^
0?ofkP030?ofkPL0e3dI203om^h70=@m6@030000000@63/00000008041Pk00<0000001DPCP0E84h0
0P0E84h01@0000005B1>0000000O<6/0000000@07c1[00@0000001l`J`0O<6/0e3dI0P00000302Tn
QP050000000Y?XH0:Cj602TnQP0000001P3aA1`00`0mFJ/0lD@L000000020?54700303eIZ`3aA1`0
lD@L0080lD@L00<000000?54703aA1`01@3aA1`00`0mFJ/0lD@L0?5470060?5470030000003aA1`0
lD@L0080lD@L0P0mFJ/20?5470030000003aA1`0?EV[00H0lD@L00<000000?54703aA1`01`3aA1`0
10000000lD@L0?54700mFJ/30?5470L00000103[@Q/01@000000jd8K0>]26`3[@Q/0?EV[00D0jd8K
00<000000>]26`3[@Q/0203[@Q/00`000000?EV[0>]26`070>]26`050000003[@Q/0jd8K0>]26`0m
FJ/01@3[@Q/01@000000jd8K0>]26`3[@Q/0?EV[00@0jd8K00@0?EV[0>]26`000000e3dI2P3om^h0
0`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00<0ooK^00D000000?ofkP3om^h0ooK^0=@m
6@0:0?ofkP030=@m6@3om^h0ooK^00D0e3dI3@3om^h00`3D?AT0ooK^0?ofkP0B0?ofkP030=@m6@3o
m^h0ooK^03L0ooK^00<000000?ofkP3om^h04@3om^h10?ooo`00E03om^h4000000<0ooK^00@0e3dI
0?ofkP3om^h0e3dI4P3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0
e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP060?ofkP040=@m6@3om^h0ooK^0?ofkPP0e3dI
0P3om^h2000000030=@m6@0;42H0000000H0e3dI100E84h01@0000005B1>0000000O<6/0000000@0
7c1[00H0000001l`J`0O<6/0e3dI02TnQP00000302TnQP030000000Y?XH0:Cj60080:Cj600<00000
0?54703aA1`00P3aA1`0100mFJ/0lD@L0?54700000030?54700503eIZ`3aA1`0lD@L0?5470000000
1`3aA1`00`0mFJ/0lD@L0?5470060?5470030000003aA1`0lD@L00@0lD@L0P0mFJ/00`000000?EV[
0?5470060?5470030000003aA1`0lD@L00H0lD@L00@000000?54703aA1`0?EV[1P3aA1`00`000000
lD@L0?5470020?5470L0000000<0jd8K03eIZ`3[@Q/0103[@Q/00`000000jd8K0>]26`070>]26`03
0000000mFJ/0jd8K00L0jd8K00D000000>]26`3[@Q/0jd8K03eIZ`050>]26`030000003[@Q/0jd8K
0080?EV[103[@Q/00`0mFJ/0jd8K000000020?ofkPH0e3dI0`3om^h00`3D?AT0ooK^0?ofkP060?of
kP030=@m6@3om^h0ooK^00<0ooK^00D000000?ofkP3om^h0ooK^0=@m6@0;0?ofkP030=@m6@3om^h0
ooK^00D0ooK^1P3D?AT70?ofkP030=@m6@3om^h0ooK^0180ooK^00<0e3dI0?ofkP3om^h0=P3om^h0
0`000000ooK^0?ofkP0B0?ofkP40oooo001D0?ofkP8000000P3om^h3000000040=@m6@0000000000
0=@m6A80ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0
ooK^00T0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP090?ofkP80e3dI0P000000
0`3D?AT02a0V00000002010H>`040000000@63/0000001DPCPH0e3dI00@0000001l`J`0O<6/00000
100O<6/00`000000e3dI0000000202TnQP050000000Y?XH0:Cj602TnQP0000000`0Y?XH500000005
03eIZ`3aA1`0lD@L0?54700000000`3aA1`0100mFJ/0lD@L0?54700000070?54700303eIZ`3aA1`0
lD@L00H0lD@L00<000000?54703aA1`01P3aA1`303eIZ`H0lD@L00<000000?54703aA1`01P3aA1`0
10000000lD@L0?54700mFJ/50?5470030000003aA1`0lD@L00L0lD@L00@000000?54703aA1`0?EV[
0`0000020>]26`030000003[@Q/0jd8K00P0jd8K00<0000003eIZ`3[@Q/01`3[@Q/01@000000jd8K
0>]26`3[@Q/0?EV[00D0jd8K00@0000003eIZ`0mFJ/0?EV[1@3[@Q/00`0mFJ/00000000000080?of
kPH0e3dI1P3om^h00`3D?AT0ooK^0?ofkP020?ofkP030000003om^h0ooK^0080ooK^00<0e3dI0?of
kP3om^h02@3om^h00`3D?AT0ooK^0?ofkP0;0?ofkPD0e3dI0P3om^h00`3D?AT0ooK^0?ofkP0B0?of
kP030=@m6@3om^h0ooK^03D0ooK^00<000000?ofkP3om^h04`3om^h10?ooo`00E03om^h2000000D0
ooK^00@0e3dI0?ofkP3om^h0e3dI1P00000<0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?of
kP3om^h02`3om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?of
kP3om^h02`3om^h01@000000e3dI0000000;42H00000008041Pk00D00000010H>`0000005B1>0000
000401DPCP030000003D?AT0e3dI00@0e3dI0P0O<6/00`000000e3dI02TnQP0202TnQP050000000Y
?XH0:Cj602TnQP0000000`0Y?XH200000080mdHM00<0?EV[000000000000100000030?547080?EV[
00<000000?54703aA1`0103aA1`00`0mFJ/0lD@L000000070?5470030000003aA1`0lD@L00H0lD@L
00<0000003eIZ`3aA1`00`0mFJ/30?5470030000003aA1`0lD@L00H0lD@L00<000000?54700mFJ/0
1P3aA1`00`000000lD@L0?5470060?5470050000003aA1`0lD@L0?54700mFJ/00`3aA1`7000000D0
jd8K00<0000003eIZ`3[@Q/01`3[@Q/01@000000jd8K0>]26`3[@Q/0?EV[00D0jd8K0P0mFJ/20>]2
6`0303eIZ`3[@Q/0jd8K0080jd8K00<0?EV[0=@m6@000000303om^h00`3D?AT0ooK^0?ofkP070=@m
6@@0ooK^00<000000?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^
0100ooK^1P3D?ATA0?ofkP030=@m6@3om^h0ooK^03@0ooK^00<000000?ofkP3om^h0503om^h10?oo
o`00E03om^h2000000D0ooK^0`3D?AT70?ofkPH000001P3om^h00`3D?AT0ooK^0?ofkP030?ofkP03
0=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP070?ofkP03
0=@m6@3om^h0ooK^00X0ooK^0P000000103D?AT00000000000000004010H>`040000000E84h05B1>
000000<05B1>00<0000001l`J`0O<6/00P0O<6/00`0000007c1[0=@m6@060=@m6@0302TnQP000000
:Cj60080:Cj600D0000002TnQP000000<DZK000000020?M67@0303eIZ`3gAQd0mdHM0080mdHM00<0
00000?M67@0000000`0000000`3aA1`0?EV[000000050?54700303eIZ`3aA1`0000000P0lD@L00<0
00000?54703aA1`01@3aA1`00`0mFJ/0lD@L0?5470030?5470<0?EV[2@3aA1`00`000000lD@L03eI
Z`060?5470030000003aA1`0lD@L00H0lD@L00@000000?54703aA1`0?EV[1P3aA1`00`000000lD@L
0?5470020?5470H0000000<0?EV[0000003[@Q/01P3[@Q/01@000000jd8K0>]26`3[@Q/0?EV[00<0
jd8K0P0mFJ/010000000jd8K0>]26`0mFJ/40>]26`80?EV[00<0e3dI0?ofkP3om^h02`3om^h00`3D
?AT0ooK^0?ofkP060?ofkPH0e3dI0`3om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^
01<0ooK^00@0e3dI0?ofkP3om^h0ooK^1`3D?AT:0?ofkP030=@m6@3om^h0ooK^03@0ooK^00<00000
0?ofkP3om^h0503om^h10?ooo`00D`3om^h00`000000ooK^000000050?ofkP030=@m6@3om^h0e3dI
00D0e3dI203om^h5000000030=@m6@000000ooK^00@0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D
?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h02P3om^h20000
00050=@m6@0000000000010H>`0000000P0@63/01@0000005B1>01DPCP0E84h0000000<05B1>0P00
000301l`J`030000000O<6/07c1[00807c1[00@0e3dI0000000Y?XH0:Cj61P3D?AT01P0Y?XH00000
035:V`0aBY/0000003eIZ`H0mdHM00<000000?M67@3gAQd00P3gAQd20000000603eIZ`0000000000
0000003aA1`0?EV[0P3aA1`00`000000lD@L0?5470060?5470030000003aA1`0lD@L00D0lD@L00<0
?EV[0?54703aA1`01@3aA1`00`000000?EV[03eIZ`060?5470030000003aA1`0?EV[00L0lD@L00<0
00000?54703aA1`01P3aA1`010000000lD@L0?54700mFJ/50?5470030000003aA1`0lD@L00L0lD@L
00@0000003eIZ`3aA1`0lD@L100000000`3[@Q/0e3dI000000030>]26`0303eIZ`3[@Q/0jd8K0080
?EV[00<0jd8K0000003[@Q/00P3[@Q/00`0mFJ/0jd8K0>]26`020>]26`0303eIZ`000000e3dI00d0
ooK^00<0e3dI0?ofkP3om^h01P3om^h0103D?AT0ooK^0?ofkP0000020?ofkP@0e3dI2`3om^h00`3D
?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^00P0ooK^1`3D?AT30?ofkP030=@m6@3om^h0ooK^
03<0ooK^00<000000?ofkP3om^h05@3om^h10?ooo`00D`3om^h00`000000ooK^000000050?ofkP03
0=@m6@3om^h0e3dI00<0e3dI0P3om^h60=@m6@L0ooK^00<0e3dI0?ofkP000000100000000`3D?AT0
ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0
ooK^0?ofkP0:0?ofkP80000000D0e3dI00000000000041Pk00000002010H>`050000000E84h05B1>
01DPCP0000000P0E84h00`0000007c1[0000000401l`J`060000000O<6/07c1[0000003D?AT00000
100Y?XH010000000:Cj602TnQP0Y?XH40=@m6@030000000mFJ/0mdHM00D0mdHM00<000000?M67@3g
AQd0103gAQd01P000000?EV[03eIZ`3gAQd0000003eIZ`L00000103aA1`00`000000lD@L0?547004
0?54700303eIZ`000000lD@L00H0lD@L00<000000?54703aA1`00`0mFJ/30?5470030000003aA1`0
?EV[00H0lD@L00<000000?54703aA1`01P3aA1`010000000lD@L0?54700mFJ/60?5470030000003a
A1`0lD@L00L0lD@L00<0000003eIZ`3aA1`01@3aA1`6000000<0?EV[0`3[@Q/010000000jd8K0>]2
6`0mFJ/40>]26`0403eIZ`000000@66]0=@m6@`0ooK^00<0e3dI0?ofkP3om^h01`3om^h0103D?AT0
ooK^0?ofkP0000050?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D
?AT0ooK^0?ofkP0?0?ofkP@0e3dI=03om^h00`000000ooK^0?ofkP0F0?ofkP40oooo001C0?ofkP03
0000003om^h0000000D0ooK^00<0e3dI0?ofkP3D?AT00`3om^h60=@m6@80ooK^1@3D?AT20?ofkP03
0=@m6@3om^h0ooK^00@0ooK^00<0e3dI0000000000001@0000060?ofkP030=@m6@3om^h0ooK^00L0
ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP80000000<0e3dI00/@9P00
00000P0@63/01000000041Pk010H>`00000401DPCP030000000E84h0000000807c1[00D0000001l`
J`0O<6/07c1[0000000201l`J`040=@m6@0Y?XH0:Cj6000000<0:Cj600D0000002TnQP0Y?XH0:Cj6
00000003035:V`030=@m6@000000mdHM00H0mdHM00<000000?M67@3gAQd0103gAQd010000000mdHM
03eIZ`0mFJ/30?M67@030000003gAQd0mdHM0080mdHM1P0000050?54700303eIZ`000000lD@L00H0
lD@L00<000000?54703aA1`00`3aA1`303eIZ`030000000mFJ/0lD@L00H0lD@L00<000000?54703a
A1`01P3aA1`010000000lD@L0?54700mFJ/50?5470030000003aA1`0lD@L00L0lD@L00<0000003eI
Z`3aA1`01`3aA1`00`000000lD@L0?54700303eIZ`P0000000H0?EV[0>]26`3[@Q/0jd8K03eIZ`3[
@Q/2000000030=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0000
00060?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?of
kP0B0?ofkP030=@m6@3om^h0ooK^0340ooK^00<000000?ofkP3om^h05`3om^h10?ooo`00D`3om^h2
000000D0ooK^00@0e3dI0?ofkP3om^h0e3dI2@3om^h60=@m6@030?ofkP3D?AT0e3dI00@0e3dI0P3o
m^h00`3D?AT0ooK^0?ofkP060?ofkPD0000000<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?of
kP070?ofkP030=@m6@3om^h0ooK^00X0ooK^0P0000000`3D?AT02a0V00000002010H>`050000000@
63/0000001DPCP0000000`0E84h00`0000005B1>0000000201l`J`030000000O<6/07c1[00807c1[
00<0000001l`J`3D?AT00P0Y?XH00`000000:Cj602TnQP0202TnQP030000000Y?XH0:Cj600800000
0`0aBY/00`000000mdHM0?M67@050?M67@030000003gAQd0mdHM00@0mdHM00@000000?M67@3gAQd0
?EV[0`3gAQd00`000000mdHM0?M67@060?M67@030000003gAQd0000000<0000000<0?EV[0?547000
00001`3aA1`00`000000lD@L0?5470060?5470@0?EV[1@3aA1`00`000000lD@L0?5470060?547003
0000003aA1`0?EV[0080lD@L00D0e3dI0?54703aA1`0lD@L000000090?5470030000000mFJ/0lD@L
00H0lD@L1@0mFJ/50?5470060000003aA1`0lD@L0?54700mFJ/0lD@L0P00000203eIZ`040000000m
FJ/0ooK^0=@m6@`0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^000000060?ofkP030=@m
6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP0B0?ofkP030=@m
6@3om^h0ooK^0300ooK^00<000000?ofkP3om^h0603om^h10?ooo`00D`3om^h2000000D0ooK^00@0
e3dI0?ofkP3om^h0e3dI3`3om^h60=@m6@030?ofkP3D?AT0e3dI00@0e3dI2P3om^h00`3D?AT00000
00000005000000<0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP800000
00<0e3dI00/@9P0000000P0@63/01@00000041Pk0000000E84h0000000@05B1>00<0000001l`J`0O
<6/00P0O<6/0100000007c1[01l`J`0O<6/2000000050=@m6@0Y?XH0:Cj602TnQP0000000`0Y?XH0
0`000000:Cj602TnQP02000000@0<DZK00<000000?M67@3gAQd01@3gAQd00`000000mdHM0?M67@04
0?M67@030000003gAQd0?EV[0080?EV[0P3gAQd00`000000mdHM0?M67@050?M67@030000003gAQd0
mdHM00<0mdHM00<0?EV[0000000000000`0000040?5470030000003aA1`0lD@L00D0lD@L00<00000
03eIZ`3aA1`00P3aA1`603eIZ`P0lD@L00<000000?54700mFJ/01@3aA1`00`000000lD@L0?547007
0?5470030000000mFJ/0lD@L00<0lD@L100mFJ/01@000000lD@L0?54703aA1`0?EV[00@0lD@L00D0
00000?54703aA1`0lD@L03eIZ`030?54700303eIZ`3aA1`0000000H0e3dI2P3om^h00`3D?AT0ooK^
0?ofkP060?ofkP030=@m6@3om^h0000000H0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^
0?ofkP0C0?ofkP030=@m6@3om^h0ooK^0180ooK^00<0e3dI0?ofkP3om^h0;`3om^h00`000000ooK^
0?ofkP0I0?ofkP40oooo001C0?ofkP8000001@3om^h00`3D?AT0ooK^0=@m6@0C0?ofkP030=@m6@3o
m^h0ooK^00h0e3dI0`3om^h00`3D?AT0ooK^0?ofkP050?ofkP<0000000<0e3dI0000000000001`3o
m^h00`3D?AT0ooK^0?ofkP090?ofkP80000000@02a0V0=@m6@0000000000100@63/0100000005B1>
01DPCP00000301DPCP030000000O<6/07c1[00807c1[00<0000001l`J`0O<6/00P0O<6/00`000000
e3dI02TnQP0202TnQP030000000Y?XH0:Cj60080:Cj60P000002035:V`030000000aBY/0<DZK0080
<DZK00<000000?M67@3gAQd0103gAQd00`000000mdHM0?M67@040?M67@030000000mFJ/0mdHM0080
mdHM0P0mFJ/00`000000mdHM0?M67@050?M67@030000003gAQd0mdHM0080mdHM00@0?EV[0?M67@3g
AQd000000`3gAQd8000000@0lD@L00<0000003eIZ`3aA1`01P3aA1`00`000000lD@L03eIZ`0503eI
Z`040?5470000000lD@L03eIZ`H0lD@L00<000000?54703aA1`01P3aA1`00`000000lD@L03eIZ`04
03eIZ`<0lD@L00D000000?54703aA1`0lD@L03eIZ`050?5470050000003aA1`0lD@L0?54700mFJ/0
0P3aA1`00`0mFJ/0lD@L0000000200000080ooK^00<0e3dI0?ofkP3om^h01P3D?AT40?ofkP030=@m
6@3om^h0ooK^00H0ooK^00<0e3dI0000003om^h01P3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m
6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h04P3om^h00`3D?AT0ooK^0?ofkP0_0?ofkP030000
003om^h0ooK^01T0ooK^0@3oool00580ooK^00<000000?ofkP0000001@3om^h00`3D?AT0ooK^0=@m
6@0C0?ofkP030=@m6@3om^h0ooK^00<0ooK^00@0e3dI0?ofkP3om^h0ooK^3P3D?AT60?ofkP040=@m
6@3om^h0ooK^0?ofkPL0000000<0e3dI0?ofkP3om^h02@3om^h2000000050=@m6@0000000000010H
>`0000000P0@63/01@0000005B1>01DPCP0E84h0000000<05B1>0P00000401l`J`060000000O<6/0
7c1[01l`J`3D?AT00000100Y?XH010000000:Cj602TnQP0Y?XH200000080<DZK00<00000035:V`0a
BY/00P0aBY/00`000000mdHM0?M67@040?M67@030000003gAQd0mdHM00@0mdHM00<0000003eIZ`3g
AQd0103gAQd00`0mFJ/0mdHM0?M67@050?M67@030000003gAQd0mdHM0080mdHM00@0?EV[0?M67@3g
AQd000001`3gAQd010000000mdHM0?M67@3gAQd40000000303eIZ`000000000000800000103aA1`0
0`000000lD@L0?5470050?5471H0?EV[1P3aA1`00`000000lD@L0?5470020?54700303eIZ`3aA1`0
lD@L0080lD@L00H000000?54703aA1`0lD@L03eIZ`3aA1`203eIZ`030?5470000000000000800000
0P3om^h00`3D?AT0ooK^0?ofkP060?ofkPD0e3dI203om^h00`3D?AT000000?ofkP060?ofkP030=@m
6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h04P3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m
6@3om^h0ooK^02h0ooK^00<000000?ofkP3om^h06P3om^h10?ooo`00DP3om^h00`000000ooK^0000
00050?ofkP030=@m6@3om^h0e3dI0180ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?of
kP090?ofkPd0e3dI2P3om^h00`3D?AT0000000000003000000D0ooK^0`0000001@3D?AT000000000
000@63/00000008041Pk00D0000001DPCP0E84h05B1>0000000201DPCP030000000O<6/0000000@0
7c1[00H0000001l`J`0O<6/000000=@m6@00000502TnQP050000000Y?XH0:Cj602TnQP0000000`0a
BY/00`000000<DZK035:V`02035:V`030000003gAQd0mdHM00@0mdHM00<000000?M67@3gAQd00`3g
AQd00`0mFJ/000000?M67@040?M67@030000000mFJ/0?EV[00D0mdHM00D000000?M67@3gAQd0mdHM
03eIZ`030?M67@030000003gAQd0mdHM00D0mdHM00<000000?M67@3gAQd01@3gAQd00`0mFJ/0mdHM
0?M67@020?M67@H000001`3aA1`00`000000?EV[0?5470050?5470030000003aA1`0lD@L00H0lD@L
00<0000003eIZ`3aA1`01`3aA1`01@000000lD@L0?54703aA1`0?EV[00@0lD@L00<000000?54703a
A1`00P3aA1`203eIZ`<0lD@L0`0000020?ofkP030=@m6@3om^h0ooK^00/0ooK^1`3D?AT20?ofkP03
0=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP03
0=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h0;@3om^h00`000000ooK^0?ofkP0K0?ofkP40
oooo001B0?ofkP030000003om^h0000000D0ooK^00<0e3dI0?ofkP3D?AT04P3om^h00`3D?AT0ooK^
0?ofkP030?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h00`3om^h<0=@m6@<0ooK^
00<0e3dI0?ofkP3om^h00`3om^h8000000050=@m6@00000041Pk010H>`0000000P0@63/00`000000
5B1>01DPCP0201DPCP030000000E84h0000000807c1[00<0000001l`J`0O<6/00P0O<6/01P000000
7c1[0000003D?AT0:Cj6000000@0:Cj600H0000002TnQP0Y?XH00000035:V`000003035:V`050000
000aBY/0<DZK035:V`0000001P3gAQd00`000000mdHM0?M67@030?M67@0303eIZ`000000mdHM00D0
mdHM00@000000?M67@0mFJ/0?EV[0`3gAQd01@000000mdHM0?M67@3gAQd0?EV[00<0mdHM00<00000
0?M67@3gAQd01@3gAQd00`000000mdHM0?M67@040?M67@0303eIZ`000000mdHM00L0mdHM00<00000
0?M67@0000000`0000020?5470030000003aA1`0?EV[00H0lD@L00<000000?54703aA1`01P3aA1`0
0`000000?EV[0?5470060?5470030000003aA1`0lD@L0080lD@L00D0?EV[0?54703aA1`0lD@L0000
00040?547080?EV[0`3aA1`3000000040=@m6@3om^h0ooK^0=@m6@`0ooK^00<0e3dI0?ofkP3om^h0
1@3om^h60=@m6@D0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m
6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h0;03om^h00`000000ooK^0?ofkP0L0?ofkP40oooo
001B0?ofkP8000001P3om^h00`3D?AT0ooK^0=@m6@0B0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0
e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00d0e3dI1P3o
m^h3000000090=@m6@00000041Pk010H>`00000041Pk0000000E84h0000000<05B1>00<0000001DP
CP0000000P0O<6/00`0000007c1[01l`J`0201l`J`80000000D0:Cj60=@m6@0Y?XH0:Cj600000004
02TnQP050000000Y?XH00000035:V`0000000`0aBY/00`000000<DZK035:V`02035:V`030000003g
AQd0mdHM00@0mdHM00L000000?M67@3gAQd0mdHM03eIZ`3gAQd0000000H0mdHM00D000000?M67@3g
AQd0mdHM03eIZ`020?M67@040000003gAQd0mdHM03eIZ`@0mdHM00<000000?M67@3gAQd01@3gAQd0
0`000000mdHM0?M67@040?M67@0303eIZ`000000mdHM00H0mdHM00<000000?M67@3gAQd0103gAQd3
0000000303eIZ`000000000000@0lD@L00<000000?54703aA1`01P3aA1`00`000000?EV[0?547006
0?5470030000003aA1`0lD@L0080lD@L00<0?EV[0?54703aA1`00P3aA1`00`000000lD@L0?547002
0?54700703eIZ`3aA1`0lD@L0?5470000000Bg7@000000020?ofkPH0e3dI2@3om^h00`3D?AT0ooK^
0?ofkP060?ofkP030000003D?AT0ooK^0080ooK^1`3D?AT:0?ofkP030=@m6@3om^h0ooK^01<0ooK^
00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP0[0?ofkP030000003om^h0ooK^01d0ooK^
0@3oool00580ooK^0P0000050?ofkP040=@m6@3om^h0ooK^0=@m6A80ooK^00<0e3dI0?ofkP3om^h0
0`3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h0
1P3om^h60=@m6@030?ofkP3D?AT0e3dI00@0e3dI0P0000000`3D?AT02a0V00000002010H>`050000
000@63/0000001DPCP000000100E84h00`000000?EV[01l`J`0201l`J`030000000O<6/07c1[0080
7c1[00<000000=@m6@0Y?XH00P0Y?XH00`000000:Cj602TnQP0202TnQP8000000`0aBY/01@000000
<DZK035:V`0aBY/0000000<0<DZK00<000000?M67@3gAQd0103gAQd01@000000mdHM0?M67@3gAQd0
?EV[0080mdHM00<000000?M67@3gAQd00`3gAQd00`000000mdHM0?M67@020?M67@80?EV[00@0mdHM
0000003gAQd0?EV[103gAQd00`000000mdHM0?M67@050?M67@030000003gAQd0mdHM00<0mdHM00<0
?EV[0000003gAQd01`3gAQd00`000000mdHM0?M67@050?M67@030000003gAQd0?EV[0080mdHM2000
00050?5470030000000mFJ/0lD@L00D0lD@L00<000000?54703aA1`00P3aA1`00`0mFJ/0lD@L0?54
70020?5470040000003aA1`0lD@L0?547080?EV[0`3aA1`010000000Bg7@0000000000040?ofkP04
0=@m6@3om^h0ooK^0?ofkPH0e3dI0`3om^h00`3D?AT0ooK^0?ofkP050?ofkP030000003om^h0e3dI
00P0ooK^00<0e3dI0?ofkP3D?AT01P3D?AT30?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?of
kP3om^h04P3om^h00`3D?AT0ooK^0?ofkP0[0?ofkP030000003om^h0ooK^01h0ooK^0@3oool00580
ooK^0P0000050?ofkP040=@m6@3om^h0ooK^0=@m6A80ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D
?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h02@3om^h0103D
?AT0ooK^0?ofkP3om^h60=@m6@80000000@02a0V0=@m6@0000000000100@63/0100000005B1>01DP
CP00000301DPCP030000000O<6/07c1[00<07c1[00H0000001l`J`0O<6/07c1[0000003D?AT402Tn
QP030000000Y?XH0:Cj60080:Cj600<00000035:V`0aBY/00P0aBY/01@000000<DZK035:V`0aBY/0
000000<0<DZK100000030?M67@040000003gAQd0mdHM03eIZ`80mdHM00<000000?M67@3gAQd00`3g
AQd00`000000mdHM0?M67@040?M67@<0?EV[1@3gAQd00`000000mdHM0?M67@050?M67@030000003g
AQd0mdHM00<0mdHM00<0?EV[0000003gAQd01`3gAQd00`000000mdHM0?M67@050?M67@030000000m
FJ/0mdHM00D0mdHM00<000000?M67@3gAQd00P3gAQd50000000303eIZ`000000000000D0lD@L00<0
00000?54703aA1`00P3aA1`01@0mFJ/0lD@L0?54703aA1`000000080lD@L0`0mFJ/30?5470050000
001;LM0000000000003D?AT0103om^h00`3D?AT0ooK^0?ofkP070?ofkPH0e3dI103om^h00`000000
ooK^0=@m6@080?ofkP030=@m6@3om^h0ooK^00L0ooK^1`3D?ATB0?ofkP030=@m6@3om^h0ooK^0180
ooK^00<0e3dI0?ofkP3om^h0:`3om^h00`000000ooK^0?ofkP0N0?ofkP40oooo001B0?ofkP800000
1@3om^h0103D?AT0ooK^0?ofkP3D?ATB0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3o
m^h0303om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3o
m^h01`3om^h60=@m6@050000000@63/041Pk0000000mFJ/00P0E84h0100000005B1>01DPCP0E84h2
000000@07c1[00H0000001l`J`0O<6/0000002TnQP3D?AT402TnQP030000000Y?XH0:Cj60080:Cj6
0P000003035:V`050000000aBY/0<DZK035:V`0000000P0aBY/00`000000>5B]000000020?a87PD0
000000<0?EV[0000003gAQd00P3gAQd00`000000mdHM0?M67@030?M67@030000003gAQd0mdHM00@0
mdHM00<0000003eIZ`0mFJ/0103gAQd00`000000mdHM0?M67@040?M67@030000003gAQd0mdHM00<0
mdHM00<0?EV[0?M67@0000001`3gAQd00`000000mdHM0?M67@050?M67@030000003gAQd0?EV[00H0
mdHM00<000000?M67@3gAQd01@3gAQd00`000000?EV[0?M67@020?M67@H000000`3aA1`01P0mFJ/0
lD@L0?54703aA1`000000?547080?EV[0P3aA1`01@0mFJ/0lD@L0?5470000000Bg7@0080000000<0
e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00L0e3dI203o
m^h00`3D?AT0ooK^0?ofkP0:0?ofkP040=@m6@3om^h0ooK^0?ofkPL0e3dI2`3om^h00`3D?AT0ooK^
0?ofkP0B0?ofkP030=@m6@3om^h0ooK^02X0ooK^00<000000?ofkP3om^h07`3om^h10?ooo`00D@3o
m^h00`000000ooK^000000050?ofkP@0e3dI4@3om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3o
m^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3o
m^h0ooK^00L0ooK^0`000000100;42H0e3dI0000000@63/60=@m6@0701DPCP0000005B1>01DPCP00
00007c1[0000000501l`J`060000000O<6/0000002TnQP3D?AT00000100Y?XH01P000000:Cj602Tn
QP000000<DZK000000@0<DZK00T00000035:V`0aBY/0<DZK0000000aBY/0000003QD[@0000001`3l
B1h00`0mFJ/0o4PN00000005000000<0mdHM00<000000?M67@3gAQd0103gAQd00`000000?EV[0?M6
7@0403eIZ`030000003gAQd0mdHM00@0mdHM00<000000?M67@3gAQd00`3gAQd00`0mFJ/0mdHM0000
00070?M67@030000003gAQd0mdHM00D0mdHM00<0000003eIZ`3gAQd01@3gAQd00`000000mdHM0?M6
7@060?M67@030000000mFJ/0mdHM00D0mdHM00<000000?M67@3gAQd00`000000100mFJ/0lD@L0?54
703aA1`203eIZ`<0lD@L00@0?EV[0?54703aA1`0lD@L0P0000000`1;LM0000000=@m6@040?ofkP03
0=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`000000ooK^0?ofkP060=@m6@<0
ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP080?ofkPP0e3dI0`3om^h00`3D?AT0
ooK^0?ofkP0B0?ofkP030=@m6@3om^h0ooK^02T0ooK^00<000000?ofkP3om^h0803om^h10?ooo`00
D@3om^h00`000000ooK^000000050?ofkP040=@m6@3om^h0e3dI0?ofkPL0e3dI2P3om^h00`3D?AT0
ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0
ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00L0ooK^0`0000001@0;42H0e3dI010H>`0@63/00000
008041Pk0P0000000`0E84h0e3dI0=@m6@040=@m6@0301l`J`0000007c1[00<07c1[0P0000001@0Y
?XH0e3dI02TnQP0Y?XH0000000@0:Cj600<0000002TnQP0000000P0aBY/00`000000<DZK035:V`02
035:V`030000000aBY/0<DZK008000000`0hE:d00`000000?EV[0?a87P030?a87P0303eIZ`3lB1h0
o4PN00<0o4PN00<000000?a87P3lB1h01@0000050?M67@0303eIZ`3gAQd0mdHM00@0mdHM0`0mFJ/4
0?M67@030000003gAQd0mdHM0080mdHM00@0?EV[0?M67@3gAQd000001`3gAQd00`000000mdHM0?M6
7@040?M67@030000003gAQd0?EV[00H0mdHM00<000000?M67@3gAQd01@3gAQd00`000000?EV[0?M6
7@050?M67@030000003gAQd0mdHM00<0mdHM00<0?EV[0?M67@0000000P0mFJ/300000080lD@L00<0
?EV[0?54703aA1`00P000000101;LM0000000?ofkP3D?AT40?ofkP030=@m6@3om^h0ooK^00/0ooK^
00<0e3dI0?ofkP3om^h00P3om^h01@000000ooK^0?ofkP3om^h0e3dI00D0ooK^103D?AT;0?ofkP03
0=@m6@3om^h0ooK^0140ooK^1P3D?ATB0?ofkP030=@m6@3om^h0ooK^02P0ooK^00<000000?ofkP3o
m^h08@3om^h10?ooo`00D@3om^h2000000H0ooK^00<0e3dI0?ofkP3D?AT0203om^h70=@m6@<0ooK^
00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00L0ooK^
00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP070?ofkP<0000000T0e3dI0000000@63/0
41Pk0000000@63/0000001DPCP0000000`0E84h0100000005B1>0000000O<6/60=@m6@0401l`J`00
0000:Cj60=@m6@80:Cj600<0000002TnQP0Y?XH00P0Y?XH2000000@0<DZK00D00000035:V`0aBY/0
<DZK00000003035:V`070000000hE:d0>5B]0=@m6@000000o4PN03eIZ`030?a87P0303eIZ`3lB1h0
o4PN00@0o4PN00<000000?a87P3lB1h00P3lB1h00`000000o4PN00000003000000030?M67@0mFJ/0
mdHM00D0mdHM00<000000?M67@3gAQd00`0mFJ/00`3gAQd000000?M67@030?M67@0403eIZ`3gAQd0
mdHM000000L0mdHM00<000000?M67@3gAQd0103gAQd00`000000?EV[0?M67@050?M67@030000003g
AQd0mdHM00D0mdHM00<0000003eIZ`3gAQd01@3gAQd00`000000mdHM0?M67@040?M67@<0?EV[00<0
00000?M67@3gAQd00P3gAQd00`000000?EV[000000020000000604]ad000000000000000003om^h0
e3dI103om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00<0ooK^00D000000?ofkP3o
m^h0ooK^0=@m6@080?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h0503om^h00`3D
?AT0ooK^0?ofkP050=@m6@d0ooK^00<0e3dI0?ofkP3om^h09`3om^h00`000000ooK^0?ofkP0R0?of
kP40oooo001A0?ofkP8000001@3om^h00`3D?AT0ooK^0?ofkP030=@m6@d0ooK^1`3D?AT20?ofkP03
0=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP090?ofkP03
0=@m6@3om^h0ooK^00L0ooK^0`0000001`3D?AT00000010H>`0@63/00000010H>`0000000P0E84h0
1@0000005B1>01DPCP0E84h0000000@07c1[00@0000001l`J`0O<6/07c1[1`3D?AT00`000000:Cj6
02TnQP0202TnQP030000000aBY/0<DZK0080<DZK00<00000035:V`0aBY/00P0aBY/00`000000<DZK
035:V`020000000503QD[@3D?AT0>5B]0000003lB1h00`0mFJ/00`3lB1h000000?a87P040?a87P03
0000003lB1h0o4PN00<0o4PN00<000000?a87P3lB1h00P3lB1h00`0mFJ/0000000000002000000<0
mdHM00<000000?M67@3gAQd00`3gAQd403eIZ`050?M67@0mFJ/0mdHM0?M67@0000001`3gAQd00`00
0000mdHM0?M67@040?M67@030000003gAQd0?EV[00D0mdHM00<000000?M67@3gAQd01P3gAQd00`00
0000?EV[0?M67@050?M67@040000003gAQd0mdHM0?M67@@0?EV[00<0mdHM0000003gAQd01@3gAQd0
100mFJ/0mdHM0000001;LM0300000080ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?of
kP0:0?ofkP030=@m6@3om^h0ooK^0080ooK^00D000000?ofkP3om^h0ooK^0=@m6@090?ofkP030=@m
6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h0503om^h00`3D?AT0ooK^0?ofkP050?ofkPH0e3dI
1`3om^h00`3D?AT0ooK^0?ofkP0V0?ofkP030000003om^h0ooK^02<0ooK^0@3oool00540ooK^0P00
00050?ofkP040=@m6@3om^h0ooK^0=@m6@80ooK^1P3D?AT:0?ofkP040=@m6@3om^h0ooK^0?ofkPL0
e3dI2P3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3o
m^h01P3om^h20000000500/@9P000000e3dI010H>`0000000`0@63/0100000005B1>01DPCP000003
01DPCP030000000O<6/07c1[00<07c1[00@0000001l`J`0O<6/000000P0Y?XH0103D?AT0:Cj602Tn
QP0Y?XH80=@m6@<0<DZK00<00000035:V`0aBY/00P0aBY/20000000303QD[@000000e3dI0080>5B]
00L000000?a87P3lB1h0o4PN03eIZ`3lB1h0000000D0o4PN00<000000?a87P3lB1h00`3lB1h00`00
0000o4PN0?a87P020?a87P0303eIZ`000000o4PN0080o4PN1`0000030?M67@030000003gAQd0mdHM
00@0?EV[00<000000?M67@3gAQd01@3gAQd00`000000mdHM0?M67@040?M67@030000000mFJ/0mdHM
00D0mdHM00<000000?M67@3gAQd01@3gAQd00`000000?EV[0?M67@050?M67@D0?EV[00D0mdHM03eI
Z`3gAQd0mdHM000000060?M67@0303eIZ`3gAQd0000000D000000P3om^h00`3D?AT0ooK^0?ofkP02
0?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h00P3om^h01@000000ooK^0?ofkP3o
m^h0e3dI00T0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3o
m^h0ooK^00`0ooK^1@3D?AT20?ofkP030=@m6@3om^h0ooK^02H0ooK^00<000000?ofkP3om^h08`3o
m^h10?ooo`00D@3om^h2000000D0ooK^00@0e3dI0?ofkP3om^h0e3dI203om^h60=@m6@@0ooK^00<0
e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP030?ofkPL0e3dI0`3om^h00`3D?AT0ooK^0?of
kP060?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h01P3om^h20000000500/@9P00
0000e3dI010H>`0000000P0@63/00`0000005B1>01DPCP0201DPCP030000000E84h05B1>00800000
100O<6/0100000007c1[01l`J`00000202TnQP030=@m6@0Y?XH0:Cj60080:Cj600L0000002TnQP0Y
?XH00000035:V`000000<DZK00P0e3dI0P00000203QD[@050=@m6@0hE:d0>5B]03QD[@0000000P3l
B1h303eIZ`030000003lB1h0o4PN00<0o4PN00<000000?a87P3lB1h00P3lB1h01`000000o4PN0?a8
7P3lB1h0?EV[0?a87P0000001P3lB1h010000000o4PN0?a87P3lB1h70000000303eIZ`3gAQd0mdHM
00H0?EV[0P3gAQd00`000000mdHM0?M67@030?M67@030000003gAQd0?EV[00D0mdHM00<000000?M6
7@3gAQd01@3gAQd010000000mdHM03eIZ`3gAQd503eIZ`H0mdHM00<0?EV[0?M67@0000001P3gAQd2
03eIZ`H000000`3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00X0ooK^00D0e3dI
0?ofkP3om^h0ooK^000000040?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h02P3o
m^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^0140ooK^0`3D?ATW0?ofkP030000003o
m^h0ooK^02@0ooK^0@3oool00500ooK^00<000000?ofkP0000001@3om^h0103D?AT0ooK^0?ofkP3D
?AT>0?ofkPH0e3dI0`3om^h00`3D?AT0ooK^0?ofkP0:0?ofkPL0e3dI1@3om^h00`3D?AT0ooK^0?of
kP080?ofkP030=@m6@3om^h0ooK^00L0ooK^0P0000001@0;42H000000=@m6@0@63/00000008041Pk
00<0000001DPCP0E84h00P0E84h00`0000005B1>01DPCP02000000D07c1[00L0000001l`J`000000
:Cj60=@m6@0Y?XH0000000@0:Cj600<0000002TnQP0000000P0aBY/00`000000<DZK035:V`02035:
V`040000000aBY/0<DZK035:V`H0e3dI0`0hE:d00`000000?EV[0?a87P020?a87P80?EV[103lB1h0
0`000000o4PN0?a87P030?a87P060000003lB1h0o4PN03eIZ`3lB1h000001P3lB1h00`000000o4PN
0?a87P040?a87P040000003lB1h0o4PN03eIZ`L000000P3gAQd603eIZ`80mdHM00<0000003eIZ`3g
AQd01@3gAQd00`000000mdHM03eIZ`0903eIZ`<0mdHM00<000000?M67@3gAQd0103gAQd00`0mFJ/0
mdHM000000080?M67@030000003D?AT0e3dI0080e3dI0P0000020?ofkP030=@m6@3om^h0ooK^0080
ooK^00<0e3dI0?ofkP3om^h02`3om^h0103D?AT0ooK^0?ofkP0000050?ofkP030=@m6@3om^h0ooK^
00H0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^
01<0ooK^00<0e3dI0?ofkP3om^h0903om^h00`000000ooK^0?ofkP0U0?ofkP40oooo001@0?ofkP80
00001P3om^h00`3D?AT0ooK^0=@m6@0C0?ofkP030=@m6@3om^h0e3dI00H0e3dI303om^h0103D?AT0
ooK^0?ofkP3om^h60=@m6@X0ooK^00<0e3dI0?ofkP3om^h01`3om^h20000000303eIZ`3D?AT041Pk
008041Pk00@00000010H>`0000000000100E84h2000000807c1[00<0000001l`J`0O<6/00P0O<6/2
00000080:Cj600@0e3dI02TnQP0Y?XH000000`0Y?XH2000000@0<DZK00<00000035:V`0aBY/00P0a
BY/02@000000<DZK035:V`000000>5B]0000000hE:d0e3dI000000030=@m6@030000000mFJ/0o4PN
0080o4PN00@000000?a87P0mFJ/0?EV[0P3lB1h00`000000o4PN0?a87P030?a87P030000003lB1h0
?EV[00<0o4PN00<000000?a87P3lB1h00`3lB1h00`000000o4PN0?a87P040?a87P040000003lB1h0
o4PN03eIZ`<0o4PN00@000000?a87P3lB1h0o4PN1P0000020?M67@`0?EV[1@3gAQd00`000000?EV[
0?M67@040?M67@030000003gAQd0mdHM00D0mdHM00<0?EV[0000003gAQd01`3gAQd01P000000DG[T
000000000000Bg7@000000H0e3dI0`3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP040=@m6@3om^h0ooK^
000000D0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0
ooK^01@0ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP0S0?ofkP030000003om^h0
ooK^02H0ooK^0@3oool00500ooK^0P0000060?ofkP030=@m6@3om^h0e3dI01<0ooK^00<0e3dI0?of
kP3om^h00P3om^h0103D?AT0ooK^0?ofkP3om^h80=@m6@@0ooK^00<0e3dI0?ofkP3om^h01@3om^h0
0`3D?AT0ooK^0=@m6@060=@m6@<0ooK^00<0e3dI0?ofkP3om^h01`3om^h20000000303eIZ`3D?AT0
41Pk008041Pk00@00000010H>`0000000000100E84h2000000<07c1[00<0000001l`J`0O<6/00P0O
<6/010000000:Cj602TnQP3D?AT302TnQP050000000Y?XH0:Cj602TnQP0000001@0aBY/00`000000
<DZK035:V`02035:V`060000000aBY/0000003QD[@000000e3dI0P0hE:d01@000000>5B]03QD[@0h
E:d0000000@0o4PN00<000000?a87P3lB1h00P0mFJ/00`3lB1h000000?a87P030?a87P030000003l
B1h0?EV[00<0o4PN00<000000?a87P3lB1h00`3lB1h00`000000o4PN0?a87P040?a87P030000003l
B1h0?EV[00<0o4PN00<000000?a87P3lB1h01@3lB1h00`000000o4PN0?a87P040000000303eIZ`00
0000000000@0mdHM00<000000?M67@3gAQd0103gAQd00`000000mdHM03eIZ`040?M67@030000003g
AQd0mdHM00D0mdHM00<0?EV[0000003gAQd01P3gAQd200000007055ji0000000000004]ad0000000
@66]000000030?ofkP030=@m6@3om^h0e3dI00H0e3dI2P3om^h00`3D?AT0ooK^000000060?ofkP03
0=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP0D0?ofkP03
0=@m6@3om^h0ooK^0180ooK^00<0e3dI0?ofkP3om^h08`3om^h00`000000ooK^0?ofkP0W0?ofkP40
oooo001@0?ofkP8000001@3om^h0103D?AT0ooK^0?ofkP3D?ATB0?ofkP030=@m6@3om^h0ooK^00<0
ooK^00<0e3dI0?ofkP3om^h02@3om^h80=@m6@@0ooK^00<0e3dI0?ofkP3om^h01P3om^h80=@m6@@0
ooK^0`0000000`0mFJ/0e3dI010H>`02010H>`0503eIZ`0000005B1>01DPCP000000100E84h01@00
00007c1[01l`J`0O<6/0000000@07c1[0P0000000`0Y?XH0e3dI02TnQP0302TnQP030000000Y?XH0
:Cj600800000100aBY/00`000000<DZK035:V`02035:V`8000000`0hE:d01@3D?AT0>5B]03QD[@0h
E:d000000080>5B]00<000000?a87P3lB1h00P3lB1h00`000000o4PN0?a87P020?a87P80?EV[103l
B1h00`000000?EV[0?a87P030?a87P030000003lB1h0o4PN00<0o4PN00<000000?a87P3lB1h0103l
B1h00`000000o4PN03eIZ`030?a87P030000003lB1h0o4PN00@0o4PN00<000000?a87P3lB1h00`3l
B1h00`000000o4PN03eIZ`020?a87PL00000103gAQd00`000000?EV[0?M67@040?M67@030000003g
AQd0mdHM00D0mdHM00<0?EV[0?M67@3gAQd01@3gAQd00`000000DG[T055ji0020000000504]ad000
000000000000003om^h01P3D?AT20?ofkP040=@m6@3om^h0ooK^0?ofkPL0e3dI0P3om^h00`3D?AT0
ooK^000000060?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0
ooK^0?ofkP0D0?ofkP030=@m6@3om^h0ooK^0180ooK^00<0e3dI0?ofkP3om^h08P3om^h00`000000
ooK^0?ofkP0X0?ofkP40oooo001@0?ofkP8000001@3om^h0103D?AT0ooK^0?ofkP3D?ATB0?ofkP03
0=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h03P3om^h0103D?AT0ooK^0?ofkP3om^h70=@m
6@T0ooK^00<0e3dI0?ofkP3om^h00P3om^h60=@m6@0400/@9P0mFJ/0e3dI0000008041Pk00D0?EV[
0000000E84h05B1>0000000401DPCP8000000`0O<6/0100000007c1[01l`J`00000202TnQP030=@m
6@0Y?XH0:Cj600<0:Cj600<0000002TnQP0000000P0aBY/00`000000<DZK035:V`02035:V`030000
000aBY/0<DZK0080<DZK00H0000003QD[@0hE:d0>5B]0=@m6@00000303QD[@040000000hE:d0>5B]
000000@0o4PN00<000000?a87P3lB1h00`3lB1h203eIZ`<0o4PN00<0?EV[0?a87P3lB1h00P3lB1h0
0`000000o4PN0?a87P030?a87P030000003lB1h0o4PN00@0o4PN00<0000003eIZ`3lB1h00`3lB1h0
0`000000o4PN0?a87P040?a87P030000003lB1h0o4PN00<0o4PN00<0000003eIZ`3lB1h0103lB1h0
0`000000o4PN0?a87P020?a87PD0000000<0?EV[0?M67@3gAQd00P3gAQd00`000000mdHM0?M67@05
0?M67@0303eIZ`3gAQd0mdHM00D0mdHM00<00000055ji00000000P000000101;LM00000000000000
00050?ofkP030=@m6@3om^h0ooK^00H0e3dI1`3om^h80=@m6@<0ooK^00<0e3dI0?ofkP3om^h01`3o
m^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h04`3o
m^h00`3D?AT0ooK^0?ofkP0R0?ofkP030000003om^h0ooK^02P0ooK^0@3oool00500ooK^0P000005
0?ofkP@0e3dI4P3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI
0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP060=@m6@<0ooK^00<0e3dI0?ofkP3om^h01P3om^h0
1P0000002a0V00/@9P000000e3dI000000<041Pk00D0000001DPCP0E84h05B1>0000000201DPCP03
0000000O<6/0000000@07c1[00<0000001l`J`0000000P0Y?XH00`3D?AT0000002TnQP0402TnQP80
00000`0aBY/00`000000<DZK035:V`02035:V`060000000aBY/0<DZK0000000hE:d000000P0hE:d0
0`3D?AT0000003QD[@0203QD[@040000000hE:d0>5B]000000@0o4PN00<000000?a87P3lB1h00`3l
B1h00`000000o4PN03eIZ`0203eIZ`030000003lB1h0o4PN0080o4PN00<000000?a87P3lB1h00`3l
B1h00`000000o4PN0?a87P030?a87P030000003lB1h0?EV[00@0o4PN00<000000?a87P3lB1h00`3l
B1h00`000000o4PN0?a87P030?a87P030000003lB1h0?EV[00D0o4PN00<000000?a87P3lB1h0103l
B1h010000000o4PN03eIZ`3lB1h7000000@0mdHM00<0000003eIZ`3gAQd01@3gAQd01P000000DG[T
0000001AN^@0000004]ad0@000001@3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00@0ooK^1P3D?AT3
0?ofkP030=@m6@000000ooK^00<0ooK^1P3D?AT60?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI
0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^0240ooK^00<00000
0?ofkP3om^h0:@3om^h10?ooo`00C`3om^h00`000000ooK^000000050?ofkP030=@m6@3om^h0ooK^
00P0e3dI2`3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?of
kP3om^h01P3om^h00`3D?AT0ooK^0?ofkP060?ofkPH0e3dI1P3om^h01P0000002a0V00/@9P3D?AT0
41Pk000000<041Pk00D0000001DPCP0E84h05B1>0000000201DPCP040000000O<6/07c1[000000<0
7c1[0P00000302TnQP030=@m6@0Y?XH0000000D0:Cj600<00000035:V`0aBY/00P0aBY/00`000000
<DZK035:V`02035:V`030000000aBY/000000080>5B]00D000000=@m6@0hE:d0>5B]0000000303QD
[@030000000hE:d0>5B]00<000000P3lB1h00`000000o4PN0?a87P020?a87P040000003lB1h0o4PN
0?a87P80?EV[103lB1h00`000000o4PN0?a87P030?a87P030000003lB1h0o4PN00<0o4PN00<00000
0?a87P0mFJ/00`3lB1h00`000000o4PN0?a87P040?a87P030000003lB1h0o4PN00<0o4PN00<00000
03eIZ`3lB1h0103lB1h00`000000o4PN0?a87P040?a87P040000003lB1h0o4PN03eIZ`<0o4PN00<0
00000?a87P3lB1h00P3lB1h40000000303eIZ`000000000000@0mdHM00@00000055ji0000000DG[T
0P000000101;LM00000000000010HJd60?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT02P3om^h80=@m
6@@0ooK^00<0e3dI0?ofkP3om^h01@3D?AT00`3om^h0e3dI0?ofkP0;0?ofkP030=@m6@3om^h0ooK^
01<0ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP0P0?ofkP030000003om^h0ooK^
02X0ooK^0@3oool004l0ooK^0P0000060?ofkP030=@m6@3om^h0e3dI00P0ooK^203D?AT30?ofkP03
0=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP050?ofkP03
0=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h01P3D?AT0100000002a0V00/@9P3D?AT2010H
>`050000000@63/0000001DPCP0000000`0E84h00`0000005B1>0000000301l`J`050000000O<6/0
7c1[01l`J`0000000`0Y?XH00`3D?AT0:Cj60000000502TnQP8000000`0aBY/00`000000<DZK035:
V`02035:V`8000000`0hE:d00`000000e3dI03QD[@0203QD[@060000000hE:d0>5B]03QD[@000000
>5B]0P0000000`3oBQl0000000000003000000<0o4PN00D000000?a87P3lB1h0?EV[0?a87P0303eI
Z`80o4PN00<000000?a87P3lB1h00P3lB1h00`000000o4PN0?a87P030?a87P030000000mFJ/0o4PN
00<0o4PN00<000000?a87P3lB1h00`3lB1h00`000000o4PN0?a87P030?a87P030000003lB1h0?EV[
00@0o4PN00<000000?a87P3lB1h01@3lB1h00`000000o4PN03eIZ`030?a87P030000003lB1h0o4PN
00D0o4PN00<000000?a87P0mFJ/00P3lB1h400000003055ji000000000000080000000@0Bg7@0000
000mFJ/000001`3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00d0ooK^00<0e3dI0?ofkP3om^h00P3o
m^h90=@m6@<0ooK^1P3D?AT70?ofkP030=@m6@3om^h0ooK^01@0ooK^00<0e3dI0?ofkP3om^h04P3o
m^h00`3D?AT0ooK^0?ofkP0P0?ofkP030000003om^h0ooK^02/0ooK^0@3oool004l0ooK^0P000006
0?ofkP030=@m6@3om^h0e3dI0100ooK^1`3D?AT00`3om^h0e3dI0?ofkP0>0?ofkP030=@m6@3om^h0
ooK^00D0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP050?ofkP0303eIZ`3D?AT0
e3dI00D0e3dI00@041Pk0000000E84h000000`0E84h2000000@07c1[00@0000001l`J`0O<6/07c1[
0P00000202TnQP040=@m6@0Y?XH0:Cj6000000<0:Cj600@00000035:V`0aBY/000000`0aBY/00`00
0000<DZK035:V`02035:V`030000000hE:d0>5B]0080>5B]00D0e3dI03QD[@0hE:d0>5B]00000003
03QD[@80000000<0?Ufl0000003oBQl00`3oBQl00`000000odXO000000040000000303eIZ`000000
000000<000000`0mFJ/40?a87P030000003lB1h0o4PN00<0o4PN00<0000003eIZ`3lB1h00`3lB1h0
0`000000o4PN0?a87P030?a87P030000003lB1h0o4PN00<0o4PN00<0000003eIZ`3lB1h00`3lB1h0
0`000000o4PN0?a87P050?a87P040000003lB1h0o4PN03eIZ`80o4PN00<000000?a87P3lB1h01@3l
B1h00`000000o4PN03eIZ`020?a87P0503eIZ`3lB1h000000000001AN^@00P000002055ji0800000
00<0?EV[0000003om^h01`3om^h0103D?AT0ooK^0?ofkP3D?AT=0?ofkP030000003D?AT0ooK^00H0
ooK^00<0e3dI0?ofkP3om^h00`3om^h50=@m6@@0ooK^1@3D?AT20?ofkP030=@m6@3om^h0ooK^01@0
ooK^00<0e3dI0?ofkP3om^h04P3om^h00`3D?AT0ooK^0?ofkP0O0?ofkP030000003om^h0ooK^02`0
ooK^0@3oool004l0ooK^0P0000060?ofkP030=@m6@3om^h0e3dI01<0ooK^00@0e3dI0?ofkP3om^h0
ooK^1`3D?AT:0?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0
ooK^0?ofkP060?ofkP0503eIZ`0000002a0V00/@9P3D?AT00P0@63/00`000000e3dI0=@m6@060=@m
6@030000000O<6/07c1[00<07c1[00L0000001l`J`0O<6/0000002TnQP000000e3dI00@0:Cj600@0
000003eIZ`0Y?XH000000`0aBY/01@000000<DZK035:V`0aBY/0000000<0<DZK0P00000303QD[@03
0=@m6@000000>5B]0080>5B]00D0000003QD[@0hE:d0>5B]0000000203iM_0050000003oBQl0odXO
0?m:7`0000001P3oBQl0100mFJ/0odXO0?m:7`0000020?m:7`<000000P0mFJ/20?a87P030000003l
B1h0o4PN00<0o4PN00<0?EV[0?a87P3lB1h00`3lB1h00`000000o4PN0?a87P020?a87P030000003l
B1h0o4PN00<0o4PN00<000000?a87P0mFJ/0103lB1h00`000000o4PN0?a87P040?a87P040000003l
B1h0o4PN03eIZ`80o4PN00<000000?a87P3lB1h0103lB1h200000080o4PN0`0mFJ/00`3lB1h00000
0000000300000080DG[T0P0000000`0mFJ/00000041Q[@080?ofkP040=@m6@3om^h0ooK^0=@m6@`0
ooK^00<000000?ofkP3D?AT01`3om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00L0
ooK^1P3D?ATC0?ofkP030=@m6@3om^h0ooK^0180ooK^00<0e3dI0?ofkP3om^h07P3om^h00`000000
ooK^0?ofkP0]0?ofkP40oooo001?0?ofkP8000001@3om^h00`3D?AT0ooK^0?ofkP040=@m6A00ooK^
00D0e3dI0?ofkP3om^h0ooK^0=@m6@060?ofkPL0e3dI0`3om^h00`3D?AT0ooK^0?ofkP050?ofkP03
0=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h01P3om^h203eIZ`030000003D?AT0000000<0
41Pk00D0000001DPCP0E84h05B1>0000000301DPCPP0e3dI00D0000002TnQP0Y?XH0:Cj60=@m6@05
02TnQP8000001@0aBY/01`000000<DZK035:V`0aBY/00000035:V`0000000P0hE:d00`000000>5B]
0=@m6@0203QD[@090000000hE:d0>5B]03QD[@000000>5B]0000000nGK`000000080?Ufl00D00000
0?m:7`3oBQl0odXO000000040?m:7`0503eIZ`3oBQl0odXO0?m:7`000000103oBQl00`000000odXO
0?m:7`0303eIZ`8000000`3lB1h00`0mFJ/0o4PN0?a87P020?a87P030000003lB1h0o4PN00<0o4PN
00<000000?a87P3lB1h00`3lB1h00`000000?EV[0?a87P030?a87P030000003lB1h0o4PN00@0o4PN
00L000000?a87P3lB1h0o4PN03eIZ`3lB1h0000000H0o4PN00<000000?a87P3lB1h00`0mFJ/20?a8
7P050000003D?AT00000055ji00000000`1AN^@300000003041Q[@3om^h0ooK^00H0ooK^00D0e3dI
0?ofkP3om^h0ooK^0=@m6@0<0?ofkP030000003om^h0e3dI00H0ooK^00<0e3dI0?ofkP3om^h0203o
m^h00`3D?AT0ooK^0?ofkP090?ofkP040=@m6@3om^h0ooK^0?ofkPL0e3dI2`3om^h00`3D?AT0ooK^
0?ofkP0C0?ofkP030=@m6@3om^h0ooK^01h0ooK^00<000000?ofkP3om^h0;@3om^h10?ooo`00C`3o
m^h2000000D0ooK^00@0e3dI0?ofkP3om^h0e3dI0`3om^h80=@m6@P0ooK^00D0e3dI0?ofkP3om^h0
ooK^0=@m6@0=0?ofkPL0e3dI0`3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00D0
ooK^00L0?EV[0?ofkP0mFJ/000000=@m6@0@63/00000008041Pk00<0000001DPCP0E84h00P0E84h0
1@0000005B1>0000000O<6/0000000D07c1[00<000000=@m6@3D?AT01@3D?AT402TnQP030000000a
BY/0<DZK00@0<DZK00@00000035:V`0aBY/0<DZK0P00000303QD[@030000003D?AT0>5B]0080>5B]
00H0000003QD[@0hE:d0000003QD[@00000203iM_0040000000nGK`0?Ufl00000080odXO00<00000
0?m:7`3oBQl00P3oBQl00`0mFJ/0odXO0?m:7`020?m:7`050000003oBQl0odXO0?m:7`000000103o
BQl01P000000?EV[03eIZ`0mFJ/0000003eIZ`P000000P3lB1h00`000000o4PN0?a87P030?a87P03
0000003lB1h0?EV[00<0o4PN00<000000?a87P3lB1h0103lB1h01`000000o4PN0?a87P3lB1h0?EV[
0?a87P0000001P3lB1h503eIZ`80o4PN0P000000101BO>/0e3dI055ji0000002055ji0H00000203o
m^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00/0ooK^00@000000?ofkP3om^h0e3dI1P3om^h00`3D?AT0
ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h02@3om^h80=@m6@<0
ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP0M0?ofkP030000003om^h0ooK^02h0
ooK^0@3oool004l0ooK^0P0000050?ofkP040=@m6@3om^h0ooK^0=@m6@/0ooK^2@3D?AT30?ofkP03
0=@m6@3om^h0ooK^00h0ooK^00@0e3dI0?ofkP3om^h0ooK^1P3D?AT:0?ofkP030=@m6@3om^h0ooK^
00D0ooK^0`0mFJ/010000000e3dI010H>`000002010H>`030000000E84h05B1>00805B1>00<00000
01DPCP0000000P0O<6/00`0000007c1[01l`J`0301l`J`070000000Y?XH0:Cj602TnQP3D?AT0:Cj6
000000060=@m6@H0<DZK00D00000035:V`0aBY/0<DZK0000000403QD[@030=@m6@0hE:d0>5B]0080
>5B]00@0000003QD[@0hE:d000000`0nGK`010000000?Ufl03iM_00000030?m:7`060000003oBQl0
odXO03eIZ`3oBQl000000`3oBQl01@000000odXO0?m:7`3oBQl0000000@0odXO00@000000?m:7`3o
BQl0odXO1P0mFJ/0103oBQl000000?m:7`3oBQl5000000<0o4PN00<0000003eIZ`3lB1h00P3lB1h0
0`000000o4PN0?a87P040?a87P030000003lB1h0o4PN0080o4PN00<0?EV[0000003lB1h00P3lB1h4
03eIZ`@0o4PN00P0?EV[0?a87P000000DWc[0000003D?AT0DG[T00000080DG[T1@0000000`10HJd0
ooK^0?ofkP070?ofkP040=@m6@3om^h0ooK^0=@m6@`0ooK^00@000000?ofkP3om^h0e3dI1P3om^h0
0`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h04@3om^h7
0=@m6A80ooK^00<0e3dI0?ofkP3om^h0703om^h00`000000ooK^0?ofkP0_0?ofkP40oooo001>0?of
kP8000001P3om^h00`3D?AT0ooK^0=@m6@0C0?ofkPP0e3dI3P3om^h00`3D?AT0ooK^0?ofkP040?of
kP030=@m6@3om^h0ooK^00L0e3dI0`3om^h00`3D?AT0ooK^0?ofkP050?ofkP<0?EV[00P000000=@m
6@0@63/00000010H>`0000005B1>000000@05B1>00<0000001l`J`0O<6/00P0O<6/00`0000007c1[
01l`J`0201l`J`80000000<0:Cj60=@m6@0Y?XH00P0Y?XH010000000:Cj602TnQP000002035:V`H0
e3dI00@0<DZK0000000aBY/0<DZK0P00000303QD[@030=@m6@000000>5B]0080>5B]00<0000003QD
[@0hE:d00P00000303iM_0040000000nGK`0?Ufl00000080odXO00H000000?m:7`3oBQl0?EV[0?m:
7`0000030?m:7`030000003oBQl0odXO0080odXO00D000000?m:7`3oBQl0odXO000000030?m:7`03
03eIZ`3oBQl0000000<0odXO200mFJ/00`3oBQl00000000000020000000503eIZ`3lB1h0o4PN0?a8
7P0000001P3lB1h01P000000o4PN0?a87P3lB1h0?EV[000000@0?EV[0P3lB1h00`000000o4PN0?a8
7P020?a87P0703eIZ`3D?AT0e3dI0=@m6@000000DWc[0=@m6@03055ji0050000001AN^@000000000
001;LM00200000030?ofkP040=@m6@3om^h0ooK^0=@m6@/0ooK^00D000000?ofkP3om^h0ooK^0=@m
6@050?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?of
kP0D0?ofkP040=@m6@3om^h0ooK^0?ofkPL0e3dI2P3om^h00`3D?AT0ooK^0?ofkP0L0?ofkP030000
003om^h0ooK^0300ooK^0@3oool004h0ooK^0P0000060?ofkP030=@m6@3om^h0e3dI01<0ooK^00<0
e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP060=@m6@P0ooK^00<0e3dI0?ofkP3om^h0103o
m^h00`3D?AT0ooK^0?ofkP070?ofkPH0e3dI103om^h403eIZ`080=@m6@0@63/041Pk0000000@63/0
000001DPCP00000401DPCP030000000O<6/07c1[00<07c1[00@0000001l`J`0O<6/000000P0Y?XH0
0`000000e3dI02TnQP0302TnQP800000100aBY/00`000000<DZK035:V`02035:V`H0e3dI0P000000
103D?AT0>5B]03QD[@00000303QD[@8000000P0nGK`01@000000?Ufl03iM_00nGK`000000080?Ufl
00D000000?m:7`3oBQl0000003eIZ`030?m:7`040000003oBQl0odXO000000@0odXO00D000000?m:
7`3oBQl0odXO000000030?m:7`0303eIZ`000000odXO00<0odXO00<000000?m:7`3oBQl00P3oBQl0
0`000000odXO0?m:7`0F03eIZ`@0o4PN0P0000050?a87P040000001BO>/00000000000H0e3dI00@0
DG[T000000000000Bg7@0P0000000`3D?AT0ooK^0?ofkP040?ofkP<0000000@0e3dI000000000000
e3dI2P3om^h00`000000ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3o
m^h02@3om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3o
m^h02@3om^h70=@m6@<0ooK^00<0e3dI0?ofkP3om^h06`3om^h00`000000ooK^0?ofkP0a0?ofkP40
oooo001>0?ofkP8000001P3om^h40=@m6A80ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^
0?ofkP060?ofkPH0e3dI0P3om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00/0ooK^
00<0e3dI0?ofkP3om^h01P3D?AT203eIZ`030=@m6@0@63/041Pk008041Pk00@0000001DPCP0E84h0
00000`0E84h2000000@07c1[00@0000001l`J`0O<6/000000`0Y?XH00`3D?AT0:Cj602TnQP0302Tn
QP030000000aBY/0<DZK00<0<DZK0P000005035:V`030000000hE:d0>5B]00H0e3dI00D0000003QD
[@0hE:d0>5B]0000000303iM_0050000000nGK`0?Ufl03iM_00000000P0nGK`010000000odXO0?m:
7`0mFJ/30?m:7`050000003oBQl0odXO0?m:7`0000000`3oBQl01@000000odXO0?m:7`3oBQl00000
0080odXO00<0?EV[0?m:7`000000103oBQl00`000000odXO0?m:7`020?m:7`030000003oBQl0odXO
0080odXO00<0000003eIZ`3oBQl00P3oBQl010000000odXO0?m:7`3oBQl80000000303eIZ`000000
000000<0o4PN00<000000?a87P3lB1h0103lB1h00`000000DWc[00000002059lj`040000001AN^@0
e3dI00000080DG[T3@3D?AT30?ofkP040=@m6@3om^h0ooK^0=@m6@H00000103om^h00`000000ooK^
0?ofkP020?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^
0?ofkP070?ofkP030=@m6@3om^h0ooK^01@0ooK^00<0e3dI0?ofkP3om^h0403om^h40=@m6A`0ooK^
00<000000?ofkP3om^h0<P3om^h10?ooo`00CP3om^h2000000H0ooK^00@0e3dI0?ofkP3D?AT0ooK^
1`3D?AT;0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT03`3om^h60=@m6@80ooK^00<0e3dI0?ofkP3o
m^h02`3om^h00`3D?AT0ooK^0?ofkP030?ofkP<0?EV[103D?AT2010H>`050000000E84h05B1>01DP
CP0000000P0E84h0100000007c1[01l`J`00000401l`J`8000000`0Y?XH0103D?AT0:Cj600000000
000302TnQP8000001P0aBY/01`000000<DZK035:V`0aBY/0000003QD[@0000000`0hE:d0103D?AT0
000003QD[@0hE:d60=@m6@<0?Ufl00L0000003iM_00nGK`0?Ufl0000000nGK`000000080odXO00<0
?EV[0?m:7`3oBQl00P3oBQl010000000odXO0?m:7`0000030?m:7`030000003oBQl0odXO0080odXO
00D000000?m:7`0mFJ/0odXO000000040?m:7`050000003oBQl0odXO0?m:7`000000103oBQl00`00
0000odXO03eIZ`020?m:7`030000003oBQl0odXO00@0odXO00<000000?m:7`3oBQl00P3oBQl01000
0000?EV[0?m:7`3oBQl5000000<0o4PN0P0000000`1BO>/00000059lj`03000000030=@m6@000000
DG[T00<000000P1;LM0200000080ooK^3@3D?AT60?ofkP@000001@3om^h00`3D?AT0ooK^0?ofkP03
0?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP0D
0?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h06P3om^h00`000000ooK^0?ofkP0b
0?ofkP40oooo001>0?ofkP8000001P3om^h20=@m6@T0ooK^203D?AT30?ofkP050=@m6@3om^h0ooK^
0?ofkP3D?AT0403om^h00`3D?AT0ooK^0?ofkP020?ofkPH0e3dI2P3om^h00`3D?AT0ooK^0?ofkP03
0?ofkPD0?EV[00D0e3dI03eIZ`0@63/041Pk0000000401DPCP030000000E84h0000000<07c1[00<0
000001l`J`0O<6/00P0O<6/01@000000:Cj602TnQP0Y?XH0e3dI00<0:Cj600<0000002TnQP000000
0P0aBY/2000000D0<DZK00@00000035:V`0aBY/000000P0hE:d2000000040=@m6@0hE:d0>5B]0000
00<0>5B]0P00000203iM_0H0e3dI0P0nGK`01P000000?Ufl0000003oBQl0?EV[000000<0odXO00@0
00000?m:7`3oBQl000000`3oBQl00`000000odXO0?m:7`020?m:7`050000000mFJ/0odXO0?m:7`00
00000`3oBQl00`000000odXO0?m:7`020?m:7`030000003oBQl0odXO0080odXO00<0000003eIZ`3o
BQl00P3oBQl00`000000odXO0?m:7`030?m:7`030000003oBQl0odXO0080odXO00<0000003eIZ`3o
BQl00`3oBQl010000000odXO0?m:7`3oBQl300000006059lj`0000000000059lj`000000DWc[0P00
00001`3D?AT0DG[T0000001AN^@0000004]ad00mFJ/00`00000:0?ofkP/0e3dI0`3om^h00`000000
ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0
ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0
ooK^0?ofkP0J0?ofkP030000003om^h0ooK^03<0ooK^0@3oool004h0ooK^0P0000060?ofkP80e3dI
4@3om^h80=@m6A00ooK^00<0e3dI0?ofkP3om^h0103om^h0103D?AT0ooK^0?ofkP3om^h80=@m6@80
ooK^00<0e3dI0?ofkP3om^h00`3om^h303eIZ`040?ofkP3D?AT0ooK^03eIZ`8041Pk0P00000301DP
CP800000100O<6/01`0000007c1[01l`J`0O<6/0000002TnQP0000000P0Y?XH00`3D?AT0:Cj602Tn
QP0202TnQP800000100aBY/00`000000<DZK035:V`03035:V`8000001@0hE:d0103D?AT0>5B]03QD
[@0hE:d200000080>5B]00D0000003iM_00nGK`0?Ufl0000000303iM_0030000003D?AT0e3dI00<0
e3dI0`0000001`3D?AT0odXO0?m:7`3oBQl000000?m:7`0000000`3oBQl00`000000odXO0?m:7`02
0?m:7`050000000mFJ/0odXO0?m:7`0000000`3oBQl01@000000odXO0?m:7`3oBQl0000000@0odXO
00<000000?m:7`0mFJ/00P3oBQl00`000000odXO0?m:7`030?m:7`040000003oBQl0odXO0?m:7`80
000000D0?EV[0?m:7`3oBQl0odXO000000050?m:7`80000000D0DWc[0000001BO>/0DWc[00000002
059lj`060000001AN^@0e3dI0000001AN^@000000P1;LM03000000`0ooK^00<0e3dI0?ofkP3D?AT0
0P3om^h;0=@m6@<0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m
6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m
6@3om^h0ooK^01T0ooK^00<000000?ofkP3om^h0=03om^h10?ooo`00C@3om^h2000000H0ooK^00<0
e3dI0?ofkP3D?AT00P3D?ATB0?ofkP040=@m6@3om^h0ooK^0?ofkPL0e3dI2P3om^h00`3D?AT0ooK^
0?ofkP040?ofkP030=@m6@3om^h0ooK^00T0ooK^203D?AT203eIZ`80ooK^00L0e3dI03eIZ`000000
41Pk0000000E84h0000000@05B1>00<0000001l`J`0O<6/00`0O<6/0100000007c1[01l`J`000002
02TnQP030000003D?AT0:Cj600D0:Cj600<00000035:V`0aBY/00`0aBY/00`000000<DZK035:V`03
035:V`030000000hE:d0>5B]00<0>5B]00<0e3dI0000000hE:d00`0hE:d20000000303iM_0000000
?Ufl0080?Ufl00D0000003iM_00nGK`0?Ufl0000000203iM_080000000<0@fG90000000000001P00
00000`3oBQl000000?m:7`020?m:7`050000003oBQl0odXO0?m:7`0mFJ/00`3oBQl01@000000odXO
0?m:7`3oBQl0000000<0odXO00L000000?m:7`3oBQl0odXO0000003oBQl0?EV[0080odXO00<00000
0?m:7`3oBQl00`3oBQl01@000000odXO0?m:7`3oBQl000000080odXO00@0?EV[0?m:7`0000000000
103oBQl200000004055jj`0000000000059lj`80000000L0DWc[000000000000DG[T0=@m6@000000
DG[T0080000000@0Bg7@0000000mFJ/000003@3om^h20=@m6@P0ooK^303D?AT20?ofkP030=@m6@3o
m^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP0D0?ofkP030=@m6@3o
m^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h0603om^h00`000000ooK^0?ofkP0e0?ofkP40oooo001=
0?ofkP8000001P3om^h00`3D?AT0ooK^0=@m6@020?ofkPH0e3dI303om^h01@3D?AT0ooK^0?ofkP3o
m^h0e3dI00H0ooK^1`3D?AT30?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h0303o
m^h00`3D?AT0ooK^0?ofkP020?ofkP0303eIZ`3D?AT0e3dI00H0e3dI00@0000001DPCP0E84h00000
0`0E84h2000000D07c1[0P00000402TnQP030=@m6@0Y?XH0:Cj600@0:Cj60P000005035:V`030000
000aBY/0<DZK0080<DZK0`00000203QD[@040=@m6@0hE:d0>5B]000000@0>5B]00<0000003iM_00n
GK`00P00000203iM_08000000P0nGK`010000000?Ufl03iM_000000204=Ub@030000003oBb000000
00@0od/P0`0000020?m:7`050000003oBQl0odXO0?m:7`0mFJ/00P3oBQl00`000000odXO0?m:7`02
0?m:7`040000003oBQl0odXO000000@0odXO00D000000?m:7`0mFJ/0odXO000000040?m:7`800000
0`3oBQl01P000000odXO0?m:7`0mFJ/0odXO000000D0odXO00@00000055jj`1AN^/000000P1BO>/0
20000000DWc[000000000000DWc[0000001AN^@0e3dI0`0000000`1;LM00000004]ad002000000d0
ooK^0P3D?AT;0?ofkP030000003om^h0ooK^00D0e3dI00<0ooK^0=@m6@3D?AT0103D?AT90?ofkP03
0=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP03
0=@m6@3om^h0ooK^01P0ooK^00<000000?ofkP3om^h0=P3om^h10?ooo`00C@3om^h2000000H0ooK^
00<0e3dI0?ofkP3D?AT0203om^h60=@m6@H0ooK^00@0e3dI0?ofkP3om^h0e3dI3P3om^h70=@m6@80
ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP020?ofkP80?EV[0`3om^h0103D?AT0
?EV[0?ofkP0000080=@m6@0301l`J`0000007c1[00@07c1[00<0000002TnQP0Y?XH00P0Y?XH00`3D
?AT000000000000302TnQP030000000aBY/0<DZK00800000100aBY/200000003035:V`000000>5B]
0080>5B]00<0000003QD[@3D?AT00`0hE:d200000080>5B]0P00000303iM_0050000000nGK`0?Ufl
03iM_00000000P0nGK`20000000404=Ub@000000@fG9000000<0od/P00<0?EV[0?m;800000000`3o
Bb050000000503eIZ`00000000000?m:7`0000000`3oBQl01@000000odXO0?m:7`3oBQl0000000<0
odXO00D000000?m:7`0mFJ/0odXO000000040?m:7`030000003oBQl0odXO0080odXO00H000000?m:
7`3oBQl0odXO03eIZ`0000040?m:7`80000000P0DG[[0000000000000000059lj`000000DWc[0000
0080DWc[00@00000055ji03D?AT000000P1AN^@20000000304]ad0000000000000h0ooK^0P3D?AT;
0?ofkP030000003om^h0ooK^00<0ooK^00<0e3dI0?ofkP3D?AT01@3D?AT00`3om^h0e3dI0=@m6@04
0=@m6@<0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0
ooK^01<0ooK^00<0e3dI0?ofkP3om^h05`3om^h00`000000ooK^0?ofkP0g0?ofkP40oooo001=0?of
kP8000001P3om^h40=@m6@d0ooK^1P3D?AT30?ofkP030=@m6@3om^h0ooK^00l0ooK^00@0e3dI0?of
kP3om^h0ooK^1`3D?AT:0?ofkP040=@m6@3om^h0ooK^0?ofkP<0?EV[0P3om^h01@3D?AT0?EV[0?of
kP3om^h0000000@05B1>00@0000001DPCP0000007c1[203D?AT010000000:Cj602TnQP3D?AT302Tn
QP040000000Y?XH0:Cj6000000@0<DZK00<00000035:V`0aBY/00`0aBY/2000000@0>5B]00<00000
0=@m6@0hE:d0100hE:d200000080?Ufl0P00000203iM_0050000000nGK`0?Ufl03iM_00000000P0n
GK`02@000000@fG904=Ub@000000@fG90000003oBb0000000?m;800303eIZ`050?m;80000000od/P
0?m;800000000P3oBb000`0mFJ/000000?m;8007000000030?m:7`000000odXO00<0odXO00D00000
0?m:7`0mFJ/0odXO000000030?m:7`030000003oBQl0odXO0080odXO00H000000?m:7`3oBQl0odXO
03eIZ`0000030?m:7`80000000H0DG[[000000000000DG[[0000001BO>/3000000<0DWc[00<00000
055ji03D?AT00P1AN^@20000000404]ad00000000000000000h0ooK^00<0e3dI0?ofkP3om^h02`3o
m^h00`000000ooK^0?ofkP020?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT00`3om^h;0=@m6@P0ooK^
00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^01L0ooK^
00<000000?ofkP3om^h0=`3om^h10?ooo`00C@3om^h2000000H0ooK^0P3D?AT20?ofkPL0e3dI2`3o
m^h80=@m6@h0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP020?ofkPL0e3dI0`3o
m^h0103D?AT0ooK^0?ofkP3om^h303eIZ`80ooK^00<0e3dI03eIZ`3om^h00P3om^h0100000005B1>
01DPCP0E84h2000000D07c1[00D0000001l`J`0O<6/07c1[000000060=@m6@80:Cj60P000006035:
V`030000000aBY/0<DZK00<0<DZK00<0000003QD[@0hE:d00P0hE:d00`3D?AT000000000000503QD
[@030000000nGK`0?Ufl0080?Ufl00@0000003iM_00nGK`000000`0nGK`20000000904=Ub@000000
e3dI04=Ub@000000@fG90000003oBb0000000080od/P00<0000003eIZ`0mFJ/00P0mFJ/01@000000
od/P03eIZ`3oBb0000000080od/P00H000000?m;803oBb00od/P0000003oBb070000000303eIZ`3o
BQl0000000<0odXO00@000000?m:7`3oBQl0odXO0P0000030?m:7`030000000mFJ/0odXO0080odXO
00@00000055jj`00000000000`1AN^/3000000<0DWc[0P0000000`1AN^@000000=@m6@02055ji003
0000001;LM000000008000003`3om^h20=@m6@`0ooK^00<000000?ofkP3om^h00P3om^h0103D?AT0
ooK^0?ofkP3D?AT;0?ofkPP0e3dI0`3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^
01<0ooK^00<0e3dI0?ofkP3om^h05`3om^h00`000000ooK^0?ofkP0h0?ofkP40oooo001=0?ofkP80
00001P3om^h20=@m6@T0ooK^203D?AT30?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT00`3om^h80=@m
6@H0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP0:0?ofkPL0e3dI0`0mFJ/20?of
kP030=@m6@0mFJ/0ooK^0080ooK^00<0000001DPCP0E84h00P0E84h00`0000007c1[01l`J`0401l`
J`030000000O<6/0000000<0:Cj600@000000=@m6@0Y?XH0:Cj61P3D?AT5035:V`8000000P0aBY/0
10000000>5B]00000000000203QD[@040=@m6@0hE:d0>5B]000000<0>5B]00@0000003iM_0000000
00000`0nGK`00`000000?Ufl03iM_00200000080?Ufl00@0000004=Ub@13ILT0e3dI0P13ILT01`00
0000@fG90000003oBb0000000?m;800000000P3oBb000`000000od/P03eIZ`0403eIZ`80od/P00@0
00000?m;803oBb0000001P3oBb0010000000od/P0?m;800mFJ/600000080odXO00@000000?m:7`3o
BQl0odXO0P0000000`0mFJ/0odXO0?m:7`0200000003055jj`000000DG[[0080DG[[0`000003059l
j`80000000D0DWc[0000001AN^@0e3dI055ji0040000000304]ad0000000ooK^00h0ooK^00<0e3dI
0?ofkP3D?AT0303om^h00`000000ooK^0?ofkP020?ofkP040=@m6@3om^h0ooK^0=@m6@h0ooK^00<0
e3dI0?ofkP3om^h00P3om^h70=@m6A80ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?of
kP0F0?ofkP030000003om^h0ooK^03T0ooK^0@3oool004d0ooK^00<000000?ofkP3om^h01@3om^h5
0=@m6@h0ooK^1`3D?AT<0?ofkPP0e3dI0`3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP040=@m6@3om^h0
ooK^03eIZ`P0e3dI0`3om^h0100000005B1>01DPCP0E84h2000000H07c1[0P00000302TnQP030=@m
6@000000000000<0:Cj600@00000035:V`00000000001P3D?AT0100aBY/00000035:V`00000303QD
[@80000000@0e3dI03QD[@0hE:d0>5B]0P0000000`0hE:d0000003iM_00203iM_0050000000nGK`0
?Ufl03iM_00000000`0nGK`20000000704=Ub@00000000000=@m6@000000@fG90000000204=Ub@80
00000P3oBb000`000000od/P000000020?m;800403eIZ`3oBb00od/P000000D0?EV[00@000000?m;
803oBb0000000P3oBb001@000000od/P0?m;800mFJ/0000000<0od/P00<000000?m;803oBb001`00
00020?m:7`80000000<0DG[[0000000000000P1AN^/3000000<0DWc[0P000002059lj`040000001A
N^@0DG[T0=@m6@<000000P1;LM02000000l0ooK^00<0e3dI0?ofkP3D?AT0303om^h00`000000ooK^
0?ofkP020?ofkP040=@m6@3om^h0ooK^0=@m6@h0ooK^00<0e3dI0?ofkP3om^h01@3om^h0103D?AT0
ooK^0?ofkP3om^h70=@m6@/0ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP0E0?of
kP030000003om^h0ooK^03X0ooK^0@3oool004`0ooK^0P0000070?ofkP<0e3dI0P3om^h80=@m6@T0
ooK^00<0e3dI0?ofkP3om^h0203D?AT;0?ofkP030=@m6@3om^h0e3dI00H0e3dI303om^h00`3D?AT0
ooK^0?ofkP0203eIZ`070?ofkP0mFJ/0ooK^0=@m6@0mFJ/0ooK^03eIZ`060=@m6@0401DPCP000000
7c1[000000H07c1[00D0000002TnQP0Y?XH0:Cj60=@m6@0202TnQP040000000Y?XH0:Cj6000000<0
<DZK0P000004035:V`H0e3dI0P0hE:d00`3D?AT0000003QD[@0403QD[@030000000nGK`0?Ufl00<0
?Ufl0P00000203iM_08000000P0nGK`02@000000@fG904=Ub@3D?AT0000004=Ub@000000@fG90000
000204=Ub@80000000@0od/P0000003oBb0000000P3oBb00100mFJ/0od/P0?m;800000020?m;8003
0000003oBb00000000H0?EV[00@000000?m;803oBb00?EV[0P3oBb000`000000od/P03eIZ`0403eI
Z`030?m;8000000000000080od/P0P0000000`1AN^/000000=@m6@050=@m6@03055jj`000000DWc[
008000000P1BO>/200000080DG[T00@000000=@m6@1AN^@000000P1;LM02000000<0e3dI3@3om^h0
0`3D?AT0ooK^0=@m6@0<0?ofkP030000003om^h0ooK^0080ooK^00<0e3dI0?ofkP3D?AT03`3om^h0
0`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00T0ooK^1`3D?AT30?ofkP030=@m6@3om^h0
ooK^01<0ooK^00<0e3dI0?ofkP3om^h05@3om^h00`000000ooK^0?ofkP0k0?ofkP40oooo001<0?of
kP8000001`3om^h00`3D?AT0ooK^0?ofkP060=@m6@@0ooK^203D?AT0103om^h0e3dI0?ofkP3D?AT8
0?ofkPP0e3dI0`3om^h00`3D?AT0ooK^0?ofkP020?ofkP040=@m6@3om^h0ooK^0?ofkPP0e3dI103o
m^h00`3D?AT0ooK^0?ofkP0203eIZ`070?ofkP0mFJ/0ooK^0=@m6@0mFJ/0ooK^03eIZ`040?ofkP03
03eIZ`000000000000<07c1[00<0000001l`J`0O<6/00`0O<6/200000080:Cj600@0e3dI02TnQP0Y
?XH0:Cj60P000006035:V`030000000aBY/0<DZK00<0<DZK0`0000000`0hE:d0e3dI0=@m6@040=@m
6@<0>5B]0`00000503iM_08000000P0nGK`20000000704=Ub@00000000000=@m6@13ILT0000004=U
b@030000000:04=Ub@000000od/P0000003oBb0000000?m;80000000?EV[00000080od/P00<00000
0?m;800000000P3oBb0010000000od/P0?m;800000020?m;80030000000mFJ/0?EV[00H0?EV[00@0
od/P0000003oBb00od/P0P0000030?m;8080000000@0DG[[0000001AN^/0DG[[0`000002055jj`P0
e3dI00H00000055ji0000000e3dI055ji000000204]ad0<000000`3om^h60=@m6@H0ooK^00@0e3dI
0?ofkP3om^h0e3dI303om^h00`000000ooK^0?ofkP020?ofkP030=@m6@3om^h0e3dI00l0ooK^00<0
e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP0@0?ofkPL0e3dI4P3om^h00`3D?AT0ooK^0?of
kP0D0?ofkP030000003om^h0ooK^03`0ooK^0@3oool004`0ooK^0P0000070?ofkP@0e3dI1@3om^h5
0=@m6@L0ooK^1P3D?AT>0?ofkPP0e3dI303om^h80=@m6@0503eIZ`3om^h0ooK^0=@m6@0mFJ/00`3o
m^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00800000100O<6/01@0000007c1[01l`J`0O<6/000000080
:Cj600<000000=@m6@0Y?XH0100Y?XH00`000000<DZK035:V`05035:V`8000000P0aBY/010000000
>5B]03QD[@0hE:d20000000303QD[@3D?AT0>5B]0080>5B]203D?AT503iM_0050000000nGK`0?Ufl
0000000mFJ/00P13ILT00`3D?AT0@fG904=Ub@020000000604=Ub@000000000004=Ub@000000od/P
0P0000002`3oBb00000003eIZ`3oBb0000000?m;80000000od/P0000003oBb0000000080od/P00@0
00000?m;803oBb0000000P3oBb00100mFJ/0od/P0000000000020?m;8080000000<0od/P00000000
00000`3oBb0010000000CgOV000000000002055jj`<000000`1AN^/200000080DWc[0P000002059l
j`030000003D?AT0e3dI00D0e3dI0`0000000`3D?AT0ooK^0?ofkP070?ofkPL0e3dI0P3om^h00`3D
?AT0ooK^0?ofkP0:0?ofkP030000003om^h0ooK^0080ooK^0P3D?AT@0?ofkP030=@m6@3om^h0ooK^
00@0ooK^00<0e3dI0?ofkP3om^h04`3om^h0103D?AT0ooK^0?ofkP3om^h70=@m6@/0ooK^00<0e3dI
0?ofkP3om^h0503om^h00`000000ooK^0?ofkP0l0?ofkP40oooo001<0?ofkP8000002`3om^h80=@m
6@80ooK^1P3D?AT20?ofkP030=@m6@3om^h0e3dI0080ooK^1P3D?AT;0?ofkP040=@m6@3om^h0ooK^
0?ofkPL0e3dI2P3om^h0103D?AT0ooK^03eIZ`0mFJ/70=@m6@050?ofkP0mFJ/0ooK^0?ofkP0mFJ/0
0P3om^h00`0000007c1[01l`J`0301l`J`040000000O<6/07c1[000000<0:Cj600<0e3dI0000000Y
?XH00`0Y?XH3000000L0<DZK0`00000503QD[@030=@m6@000000>5B]00@0>5B]0P00000403iM_0P0
e3dI0`000000103D?AT0@fG900000000000204=Ub@0500000013ILT0000000000013ILT00P000000
303oBb00000003eIZ`000000od/P0000003oBb0000000?m;80000000od/P00000080od/P00<00000
0?m;800000000P3oBb000`000000?EV[000000030?m;80040000003oBb00od/P00000080od/P0P00
00001@1?MnH0e3dI000000000000DG[[00<000000`1AN^/300000003059lj`000000000000<0DWc[
0P000002055ji0050000003D?AT000000000001;LM001`3D?AT<0?ofkPH0e3dI2P3om^h00`000000
ooK^0?ofkP020?ofkP80e3dI403om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^01<0
ooK^00<0e3dI0?ofkP3om^h02@3om^h70=@m6@<0ooK^00<0e3dI0?ofkP3om^h0503om^h00`000000
ooK^0?ofkP0m0?ofkP40oooo001<0?ofkP8000004`3om^h>0=@m6@L0ooK^1P3D?AT50?ofkP050=@m
6@3om^h0ooK^0?ofkP3D?AT01P3om^h70=@m6@<0ooK^00@0e3dI0?ofkP0mFJ/0?EV[0`3om^h0103D
?AT0?EV[0?ofkP3om^h80=@m6@030000000O<6/07c1[00<07c1[0P00000402TnQP030=@m6@0Y?XH0
00000080:Cj600@00000035:V`0aBY/0<DZK0P000007035:V`800000100hE:d0103D?AT0>5B]0000
0000000303QD[@040000000nGK`00000000000@0?Ufl0P00000403iM_0L0e3dI0P0000000`13ILT0
000004=Ub@020000000304M[e0000000000000D0000000<0od/P0000003oBb000P0000020?m;8008
0000003oBb00od/P0000003oBb00000003eIZ`0000020?m;8080000000@0od/P000000000000od/P
1@0000000`3D?AT000000000000200000080DG[[0`000002055jj`8000000`1BO>/300000004055j
i000000000000=@m6@8000000P1;LM02000000030?ofkP3D?AT0ooK^0080ooK^203D?AT30?ofkP05
0=@m6@3om^h0ooK^0?ofkP3D?AT00P3om^h60=@m6@@0ooK^00<000000?ofkP3om^h00P3om^h20=@m
6A00ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^
0100ooK^103D?ATE0?ofkP030000003om^h0ooK^03h0ooK^0@3oool004`0ooK^00<000000?ofkP3o
m^h06P3om^h=0=@m6@H0ooK^1P3D?AT20?ofkP030=@m6@3om^h0ooK^00`0ooK^1`3D?AT20?ofkP03
0=@m6@0mFJ/0?EV[00@0ooK^00<0?EV[0?ofkP0mFJ/00`3om^h80=@m6@<0:Cj600@0e3dI02TnQP0Y
?XH0:Cj60`000005035:V`800000100aBY/00`000000>5B]03QD[@030000000303QD[@3D?AT0>5B]
0080>5B]00<0000003QD[@000000100nGK`2000000@0?Ufl0P0000001`0nGK`0000004=Ub@13ILT0
00000=@m6@13ILT00P0000060=@m6@80000000<0Af_D0000000000000P0000000`3oC20000000000
000400000080od/P00@000000?m;80000000od/P0P0000001@0mFJ/0od/P0?m;80000000od/P0080
000000<0od/P0000000000000P0000000`1?MnH000000=@m6@0300000004055jj`00000000000000
00<0DG[[0P000003059lj`8000000P1BO>/200000080DG[T00H0e3dI0000001;LM00?EV[00000010
HJd20?ofkP030=@m6@3om^h0ooK^00T0ooK^1P3D?AT00`3om^h0e3dI0?ofkP070?ofkPH0e3dI0`3o
m^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h0503o
m^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^0180ooK^00<000000?ofkP3om^h0?`3o
m^h10?ooo`00B`3om^h2000002<0ooK^3P3D?AT30?ofkPL0e3dI3P3om^h0103D?AT0ooK^03eIZ`0m
FJ/70=@m6@80ooK^00<0?EV[0?ofkP0mFJ/01@3om^h01P3D?AT07c1[01l`J`0O<6/0000002TnQPH0
e3dI0`0Y?XH00`000000<DZK035:V`05035:V`8000000P0aBY/00`000000>5B]03QD[@0303QD[@03
0=@m6@000000>5B]00@0>5B]0P00000503iM_0<000000`0nGK`30000000304=Ub@3D?AT0@fG90080
000000@0@fG9000000000000@fG90P0000001@13ILT00000000000000000Af_D0080000000H0od`P
000000000000od`P0000003oC209000000030?m;800mFJ/0000000<0000000<0od/P000000000000
0P0000001`1?MnH00000000000000000e3dI0000001AN^/00P000003055jj`@000000P1BO>/20000
0080DWc[0P000003055ji0040=@m6@000000Bg7@04]ad0<000000`3om^h00`3D?AT0ooK^0?ofkP0;
0?ofkP030=@m6@3om^h0ooK^00D0e3dI2@3om^h00`000000ooK^0=@m6@070=@m6@d0ooK^00<0e3dI
0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI
0?ofkP3om^h04P3om^h00`000000ooK^0?ofkP100?ofkP40oooo001;0?ofkP800000:P3om^h>0=@m
6@<0ooK^203D?AT60?ofkP040=@m6@0mFJ/0?EV[03eIZ`80ooK^00<0e3dI03eIZ`3om^h00P3om^h7
0=@m6@<0ooK^00D0e3dI0000000O<6/07c1[0000000302TnQP040=@m6@0Y?XH0:Cj602TnQPH0e3dI
1`0aBY/3000000D0>5B]00<0e3dI03QD[@0000000P000000100hE:d0000003iM_00nGK`3000000D0
?Ufl0P0000001`0nGK`0000004=Ub@13ILT000000=@m6@0000000P13ILT20000000604=Ub@000000
000004=Ub@000000Af_D0`0000001@17Jm@00000000000000000od`P00@0000000D0od`P0000003o
C20000000?m<8002000000030?m<80000000000000H0000000<0CgOV0000000000000P0000000`1?
MnH0e3dI0000000200000080DG[[0`000003055jj`<000000P1BO>/3000000<0DG[T00<000000=@m
6@000000100000040?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h00P3om^h0103D
?AT0ooK^0?ofkP3om^h60=@m6@<0ooK^00<000000?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP02
0?ofkPT0e3dI103om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI
0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP0A0?ofkP030000003om^h0ooK^0440ooK^0@3oool0
04/0ooK^0P00000b0?ofkPd0e3dI103om^h80=@m6@80?EV[00@0ooK^0=@m6@3om^h0?EV[1P3om^h0
100mFJ/0ooK^0?ofkP3om^h50=@m6@0303eIZ`000000:Cj600<0:Cj600<0e3dI0000000000000`0Y
?XH010000000<DZK035:V`0aBY/60=@m6@80<DZK00<0000003QD[@0000000P00000203QD[@030=@m
6@0hE:d0>5B]0080>5B]0`00000403iM_0<00000100nGK`30000000404=Ub@3D?AT0@fG904=Ub@<0
000000@0@fG9000000000000@fG9100000000`17Jm@0000000000008000000030?m<800000000000
008000000P3oC2070000000304mgiP00000000000080000000H0CgOV000000000000e3dI0000001A
N^/3000000@0DG[[0`000000101BO>/00000000000000002059lj`050000001AN^@000000000003D
?AT00P0000000`1;LM000000041Q[@050?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3o
m^h00P3om^h00`3D?AT0ooK^0?ofkP070?ofkPD0e3dI0P3om^h20=@m6@d0ooK^1@3D?AT30?ofkP03
0=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h0503om^h00`3D?AT0ooK^0?ofkP0A0?ofkP03
0000003om^h0ooK^0440ooK^0@3oool004/0ooK^0P00000i0?ofkPh0e3dI0`3om^h80=@m6@D0ooK^
00<0?EV[0?ofkP3om^h0103om^h0103D?AT0ooK^0=@m6@00000302TnQP80e3dI0P0Y?XH3000000H0
<DZK0P000002035:V`H0e3dI00@0>5B]0000003D?AT000001@0hE:d00`000000?Ufl000000030000
00<0?Ufl0`0000001P0nGK`0000004=Ub@13ILT000000=@m6@8000000`13ILT60000000304M[e000
0000000000T0000000<0od`P0000000000000P0000000`3oC20000000000000=0000000304mgiP3D
?AT00000008000000`1AN^/500000003059lj`000000000000@0DWc[00<00000055ji00000000P1A
N^@00`3D?AT0000004]ad003000000D0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?of
kP040?ofkP030=@m6@3om^h0ooK^00X0ooK^00<000000=@m6@3D?AT0103D?AT?0?ofkP050=@m6@3o
m^h0ooK^0?ofkP3D?AT05@3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^0140ooK^
00<000000?ofkP3om^h0@P3om^h10?ooo`00B`3om^h200000440ooK^3@3D?AT0103om^h0?EV[0?of
kP0mFJ/70=@m6@H0ooK^00<0e3dI0?ofkP0mFJ/00P0000000`0Y?XH0e3dI02TnQP0402TnQP800000
1`0aBY/200000003035:V`000000>5B]00<0>5B]1P3D?AT00`000000>5B]0000000603iM_0@00000
0P0nGK`4000000040=@m6@13ILT0@fG904=Ub@@000000P13ILTM0000000304mgiP3D?AT0e3dI00P0
e3dI00@0DG[[00000000000000000`1AN^/3000000D0DWc[0P000003055ji0060000003D?AT0Bg7@
0000000mFJ/000000P3D?AT40?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h0103o
m^h00`3D?AT0ooK^0?ofkP0:0?ofkP070000003om^h0ooK^0=@m6@3om^h0e3dI0?ofkP070=@m6@P0
ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0E0?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?of
kP3om^h0403om^h00`000000ooK^0?ofkP130?ofkP40oooo001;0?ofkP030000003om^h0ooK^04P0
ooK^303D?AT0103om^h0?EV[0?ofkP0mFJ/80=@m6@0503eIZ`3om^h0ooK^0=@m6@0000001@0Y?XH0
0`000000<DZK00000002000000H0<DZK0`00000403QD[@030=@m6@0hE:d0>5B]0080>5B]1`3D?AT6
03iM_0H0000000<0e3dI000000000000100000000`13ILT000000000000<0000000303eIZ`000000
0000018000000`1?MnH010000000e3dI0000000000060=@m6@800000101BO>/400000080DG[T0P00
0000103D?AT000000000000mFJ/200000080ooK^203D?AT70?ofkP030=@m6@3om^h0ooK^00D0ooK^
00<0e3dI0?ofkP3om^h02P3om^h00`000000ooK^0=@m6@020?ofkP030=@m6@3om^h0ooK^00H0ooK^
2@3D?AT20?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^
0?ofkP0@0?ofkP030000003om^h0ooK^04@0ooK^0@3oool004X0ooK^0P00001;0?ofkP0603eIZ`3o
m^h0?EV[0?ofkP0mFJ/0ooK^3@3D?AT30?ofkPP0e3dI0P0Y?XH00`000000<DZK035:V`03035:V`80
00001@0aBY/00`000000>5B]00000002000000030=@m6@0hE:d0>5B]00D0>5B]00<0000003iM_00n
GK`00P0000080=@m6@<0@fG900<0e3dI0000000000000`00000204=UbB00000000<0CgOV00000000
000010000000103D?AT00000055jj`1AN^/3000000<0DG[[1@3D?AT010000000DWc[059lj`1BO>/3
00000080DG[T00<0e3dI04]ad01;LM000P0000070?ofkP040=@m6@3om^h0ooK^0?ofkPH0e3dI00<0
ooK^0=@m6@3om^h01P3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030000003om^h0e3dI0080ooK^00<0
e3dI0?ofkP3om^h03P3om^h70=@m6A80ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?of
kP0?0?ofkP030000003om^h0ooK^04D0ooK^0@3oool004X0ooK^0P00001:0?ofkP80?EV[00@0ooK^
03eIZ`3om^h0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3D?AT0e3dI00d0e3dI0P3o
m^h70=@m6@<0<DZK0`0000000`0aBY/0000003QD[@0403QD[@030=@m6@0000000000008000000P0h
E:d00`000000?Ufl03iM_00703iM_0@000001`3D?AT304=UbB8000000P1?MnH4000000030=@m6@00
0000000000D0DG[[10000003059lj`H0e3dI0P1AN^@01@3D?AT0Bg7@04]ad01;LM00000000P0ooK^
00<0e3dI0?ofkP3om^h01`3om^h60=@m6@<0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`000000e3dI
0?ofkP020?ofkP030=@m6@3om^h0ooK^00l0ooK^0P3D?AT40?ofkPL0e3dI2`3om^h00`3D?AT0ooK^
0?ofkP0C0?ofkP030=@m6@3om^h0ooK^00h0ooK^00<000000?ofkP3om^h0AP3om^h10?ooo`00BP3o
m^h2000004X0ooK^00<0?EV[0?ofkP3om^h00P0mFJ/40?ofkP0403eIZ`3om^h0ooK^03eIZ`<0ooK^
00<0?EV[0?ofkP3om^h00`3om^h>0=@m6@80<DZK203D?AT200000080>5B]00<0e3dI03QD[@0hE:d0
0`0hE:d9000000H0?Ufl00@0000004=Ub@13ILT0e3dI0`13ILT00`000000e3dI0=@m6@040=@m6B40
00000`1?MnH0103D?AT0?EV[055jj`1AN^/500000080DG[[00@00000059lj`1BO>/0DWc[10000003
055ji0H0e3dI00<000000?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0
ooK^00<0ooK^1`3D?AT90?ofkP030000003D?AT0ooK^0080ooK^00<0e3dI0?ofkP3om^h03`3om^h2
0=@m6@/0ooK^1`3D?AT30?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h03`3om^h0
0`000000ooK^0?ofkP160?ofkP40oooo001:0?ofkP800000BP3om^h00`0mFJ/0ooK^0?ofkP0203eI
Z`@0ooK^00@0?EV[0?ofkP3om^h0?EV[103om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0
ooK^00<0ooK^00<0?EV[0=@m6@3D?AT01P3D?AT00`0mFJ/0<DZK035:V`04035:V`030000000hE:d0
e3dI00D0e3dI0P00000303QD[@030000000nGK`0?Ufl00D0?Ufl200000000`3D?AT000000000000]
000000040=@m6@0000000000000000H0DG[[00<00000059lj`0000000P000003059lj`0:0000001A
N^@000000000001AN^@0e3dI04]ad0000000?EV[000000L0e3dI0`3om^h00`3D?AT0ooK^0?ofkP06
0?ofkP030=@m6@3om^h0ooK^00H0ooK^00@0e3dI0?ofkP3om^h0ooK^1P3D?AT30?ofkP030=@m6@3o
m^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0A0?ofkPL0e3dI4P3o
m^h00`3D?AT0ooK^0?ofkP0>0?ofkP030000003om^h0ooK^04L0ooK^0@3oool004X0ooK^0P00001:
0?ofkP0403eIZ`3om^h0ooK^03eIZ`D0ooK^00<0?EV[0?ofkP0mFJ/01@3om^h00`0mFJ/0ooK^0?of
kP020?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h0103om^h70=@m6@04035:V`00
0000>5B]03QD[@80e3dI0`0hE:d60=@m6@H000001P0nGK`00`000000@fG90=@m6@0504=Ub@l00000
00<0nd/P000000000000300000000`1;LMh000000000000504mgiP@0000000<0e3dI000000000000
2P000005059lj`030000001AN^@000000080DG[T00@000000=@m6@000000Bg7@0P0000070?ofkPP0
e3dI0`3om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00L0ooK^1P3D?AT30?ofkP03
0=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP020?ofkPL0
e3dI2`3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030000003om^h0ooK^04P0ooK^0@3oool004X0ooK^
00<000000?ofkP3om^h0B@3om^h0100mFJ/0ooK^0?ofkP0mFJ/50?ofkP0303eIZ`3om^h0?EV[00H0
ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`060?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?of
kP3om^h00`3om^h00`000000e3dI0=@m6@040=@m6@L0>5B]00<0000003iM_03D?AT01@3D?AT>0000
00H0@fG91`0000000`3kBb00000000000002000000030?];8000000000000080000000<0nd/P0000
000000001P00000304mgiPD000000P1?MnH00`3D?AT0DG[[055jj`07055jj`040000001BO>/0DWc[
059lj`D000000`1AN^@010000000e3dI04]ad01;LM02000000/0ooK^00<0e3dI0?ofkP3om^h00P3o
m^h70=@m6@L0ooK^00<0e3dI0?ofkP3om^h0203om^h0103D?AT000000?ofkP3om^h60=@m6@d0ooK^
0P3D?ATE0?ofkP030=@m6@3om^h0ooK^00T0ooK^1`3D?AT30?ofkP030=@m6@3om^h0ooK^00d0ooK^
00<000000?ofkP3om^h0B@3om^h10?ooo`00BP3om^h00`000000ooK^0?ofkP190?ofkP0403eIZ`3o
m^h0ooK^03eIZ`H0ooK^0P0mFJ/60?ofkP0403eIZ`3om^h0ooK^03eIZ`P0ooK^00<0?EV[0?ofkP3o
m^h00P3om^h00`0mFJ/0ooK^0?ofkP080?ofkP030000000mFJ/0?EV[0080e3dI00<0?EV[03QD[@0h
E:d00P0hE:d00`000000?Ufl03iM_00503iM_0@0e3dI00<0?Ufl00000013ILT00P13ILT?00000003
03eIZ`3YAah0000000L0000000<0nd/P0000003kBb002@0000050=@m6@<0CgOV00<000000=@m6@00
00003@000003059lj`030000001AN^@0DG[T0080000000<0e3dI04]ad01;LM000P00000<0?ofkP03
0=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h00P3om^h80=@m6@X0ooK^00<0e3dI0000003o
m^h0103om^h00`3D?AT0ooK^0?ofkP060=@m6@L0ooK^00<0e3dI0?ofkP3D?AT04`3om^h00`3D?AT0
ooK^0?ofkP0A0?ofkP@0e3dI3P3om^h00`000000ooK^0?ofkP1:0?ofkP40oooo00190?ofkP800000
B`3om^h01@0mFJ/0ooK^03eIZ`3om^h0?EV[00D0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0
ooK^03eIZ`090?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/03@3om^h00`0mFJ/0ooK^03eIZ`0G0000
00@0?EV[1P0000020>U77P0303eIZ`00000000000080000000D0jDLN0000003YAah000000>U77P07
000000030?];80000000nd/P008000000P1?MnH20000000304mgiP000000e3dI00L0e3dI1P1AN^/0
0`000000DWc[059lj`05059lj`<000000P1AN^@0103D?AT0?EV[0000000000040=@m6@X0ooK^00<0
e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP0:0?ofkPL0e3dI0`3om^h00`3D?AT0ooK^0000
00050?ofkP030=@m6@3om^h0ooK^00H0ooK^1`3D?AT20?ofkP030=@m6@3om^h0ooK^0140ooK^00<0
e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030000003om^h0ooK^04/0ooK^0@3o
ool004T0ooK^0P00001;0?ofkP0503eIZ`3om^h0?EV[0?ofkP0mFJ/01@3om^h00`0mFJ/0ooK^0?of
kP060?ofkP80?EV[2`3om^h0100mFJ/0ooK^0?ofkP0mFJ/>0?ofkP80?EV[1P3om^h:0000000303eI
Z`000000000000P000000P0mFJ/40>U77P030000000mFJ/000000080000000D0jDLN000000000000
jDLN000000020>U77P070000003YAah000000>U77P000000jDLN03eIZ`0700000080CgOV0P000003
04mgiP030=@m6@0000000000008000001`3D?AT3059lj`D000000`1AN^@00`3D?AT0?EV[04]ad002
000000@0ooK^1`3D?AT30?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h02P3om^h0
0`3D?AT0ooK^0?ofkP040?ofkPL0e3dI1@3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP@0e3dI4P3om^h0
0`3D?AT0ooK^0?ofkP0D0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<000000?ofkP3om^h0B`3om^h1
0?ooo`00B@3om^h2000004/0ooK^00D0?EV[0?ofkP0mFJ/0ooK^03eIZ`050?ofkP80?EV[203om^h0
0`0mFJ/0ooK^0?ofkP0:0?ofkP80?EV[403om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP80000000<0?EV[
000000000000100000050<0m6P040000000mFJ/0?EV[03eIZ`80000000D0?EV[0000003YAah0jDLN
000000030>U77P030000003YAah000000080jDLN00H000000>U77P3YAah0?EV[0>U77P0000020>U7
7PH000000P1?MnH2000000030=@m6@000000DG[[00@0DG[[1P0000070=@m6@<0DG[T00D000000=@m
6@1;LM00Bg7@0000000<0?ofkPP0e3dI3@3om^h00`3D?AT0ooK^0?ofkP060?ofkP050=@m6@3om^h0
ooK^0?ofkP0000001`3D?AT;0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT04P3om^h00`3D?AT0ooK^
0?ofkP0C0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<000000?ofkP3om^h0C03om^h10?ooo`00B@3o
m^h2000004/0ooK^0P0mFJ/30?ofkP0703eIZ`3om^h0ooK^0?ofkP0mFJ/0ooK^03eIZ`080?ofkP80
?EV[303om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP<0?EV[3P3om^h0100mFJ/0ooK^0?ofkP3om^h<0000
00D0?EV[2@0000001@3YAah000000>U77P3YAah0?EV[0080jDLN00P000000>U77P000000jDLN0000
003YAah0000004mgiP80000000<0CgOV0=@m6@0000001@000004055jj`030000001BO>/0DWc[00D0
DWc[0P0000070=@m6A00ooK^00<0e3dI0?ofkP3om^h01`3D?AT90?ofkP030=@m6@3om^h0ooK^00@0
ooK^00<0e3dI0?ofkP3om^h00P3om^h00`000000ooK^0?ofkP030?ofkP030=@m6@3om^h0e3dI00H0
e3dI103om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3o
m^h0503om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030000003om^h0ooK^04d0ooK^0@3oool004T0ooK^
00<000000?ofkP3om^h0BP3om^h203eIZ`<0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`020?ofkP03
03eIZ`3om^h0ooK^00@0ooK^00@0?EV[0?ofkP3om^h0?EV[2`3om^h203eIZ`h0ooK^00@0?EV[0?of
kP3om^h0ooK^0P0mFJ/;0?ofkP0303eIZ`3om^h0ooK^00P0ooK^1`000000100mFJ/0000000000030
?AX803eIZ`050<0m6P00000000000000000mFJ/0100000020>U77P040000003YAah000000>U77P80
000000@0CgOV000000000000?EV[1@1AN^/=000000<0DG[T00@0e3dI04]ad00000000000203D?AT:
0?ofkP80e3dI1`3om^h60=@m6@<0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP02
0?ofkP030000003om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h01P3om^h70=@m6@80ooK^00<0e3dI
0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^00/0ooK^00<00000
0?ofkP3om^h0CP3om^h10?ooo`00B@3om^h00`000000ooK^0?ofkP1:0?ofkP80?EV[0`3om^h01@0m
FJ/0ooK^0?ofkP3om^h0?EV[0080ooK^00<0?EV[0?ofkP3om^h0103om^h0100mFJ/0ooK^0?ofkP0m
FJ/:0?ofkP0403eIZ`3om^h0ooK^03eIZ`d0ooK^00<0?EV[0?ofkP3om^h00`3om^h203eIZ`T0ooK^
00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/000000000000:000000P0?EV[0P00000503eIZ`050000
003YAah000000000001?MnH00P000007055jj`030000001BO>/0DWc[00@0DWc[00<00000055ji01A
N^@00P1AN^@01P3D?AT000000000000mFJ/000000=@m6@L0ooK^1`3D?AT30?ofkP80e3dI3@3om^h8
0=@m6@030?ofkP3D?AT0ooK^00@0ooK^00<000000?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP07
0?ofkP030=@m6@3om^h0ooK^0080ooK^1`3D?AT;0?ofkP030=@m6@3om^h0ooK^01@0ooK^00<0e3dI
0?ofkP3om^h02P3om^h00`000000ooK^0?ofkP1?0?ofkP40oooo00180?ofkP800000C03om^h203eI
Z`<0ooK^00@0?EV[0?ofkP3om^h0?EV[103om^h00`0mFJ/0ooK^0?ofkP030?ofkP0503eIZ`3om^h0
ooK^0?ofkP0mFJ/02@3om^h0100mFJ/0ooK^0?ofkP3om^h203eIZ`X0ooK^00<0?EV[0?ofkP3om^h0
1P3om^h203eIZ`H0ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP@00000
00@0?EV[0<0m6P30?AX000000P30?AX2000000030<0m6P000000000000D0000000<0DG[[0=@m6@3D
?AT00`3D?AT3055jj`030000001BO>/0DWc[00@0DWc[00L00000055ji01AN^@000000=@m6@000000
Bg7@00<0e3dI00<0ooK^0=@m6@3om^h0303om^h70=@m6@l0ooK^00@0e3dI0?ofkP3om^h0ooK^2P3D
?AT40?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h01P3om^h0103D?AT0ooK^0?of
kP3om^h70=@m6@@0ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030000
003om^h0ooK^0500ooK^0@3oool004P0ooK^0P00001<0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0
?EV[0?ofkP0mFJ/0103om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0
?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0
?EV[0?ofkP3om^h0203om^h203eIZ`@0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?of
kP0>0?ofkP0303eIZ`3om^h0000000`0000000<0?EV[0<0m6P30?AX00P000003055jj`P0e3dI1@00
00000`3D?AT0000004]ad00204]ad0030000003om^h0e3dI00D0e3dI2`3om^h00`3D?AT0ooK^0=@m
6@020?ofkPL0e3dI203om^h0103D?AT0ooK^0?ofkP3D?AT70?ofkP030000003om^h0ooK^00P0e3dI
1@3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00P0ooK^1`3D?ATC0?ofkP030=@m
6@3om^h0ooK^00X0ooK^00<000000?ofkP3om^h0D03om^h10?ooo`00B03om^h2000004`0ooK^00<0
?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^03eIZ`050?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/0
1P3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h0
1@3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP80?EV[00<0ooK^03eIZ`3om^h0403om^h00`0mFJ/0ooK^
0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00H0ooK^1P0000000`0mFJ/00000000000020<0m6P<00000
00<0DG[[0000001BO>/01@1BO>/80=@m6@0303eIZ`000000ooK^00<0ooK^00@0e3dI0?ofkP3om^h0
ooK^2`3D?AT30?ofkP030=@m6@3om^h0ooK^00H0ooK^1`3D?AT20?ofkP030=@m6@3om^h0e3dI00L0
ooK^00<000000?ofkP3om^h0103om^h0103D?AT0ooK^0?ofkP3om^h60=@m6@P0ooK^00<0e3dI0?of
kP3om^h02P3om^h00`3D?AT0ooK^0?ofkP020?ofkPL0e3dI2`3om^h00`3D?AT0ooK^0?ofkP0:0?of
kP030000003om^h0ooK^0540ooK^0@3oool004P0ooK^0P00001<0?ofkP0303eIZ`3om^h0ooK^00<0
ooK^00<0?EV[0?ofkP0mFJ/01P3om^h0100mFJ/0ooK^0?ofkP0mFJ/70?ofkP0303eIZ`3om^h0ooK^
00<0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^
00d0ooK^0`0mFJ/?0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0m
FJ/000000000000900000003059lj`3D?AT0e3dI0080DWc[00<00000055ji03D?AT00P3D?AT20000
000303eIZ`3D?AT0e3dI00D0e3dI303om^h90=@m6@`0ooK^1`3D?AT50?ofkP030000003om^h0ooK^
00D0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP060=@m6@<0ooK^00<0e3dI0?of
kP3om^h0203om^h00`3D?AT0ooK^0?ofkP0:0?ofkPL0e3dI103om^h00`3D?AT0ooK^0?ofkP090?of
kP030000003om^h0ooK^0580ooK^0@3oool004P0ooK^00<000000?ofkP3om^h0B`3om^h00`0mFJ/0
ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00D0ooK^00@0?EV[0?ofkP3om^h0?EV[203om^h01@0m
FJ/0ooK^0?ofkP3om^h0?EV[00X0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP0?
0?ofkP0303eIZ`3om^h0?EV[0080?EV[303om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0
ooK^00`0ooK^00<0?EV[0?ofkP3om^h0103om^h40000000403eIZ`000000?EV[03eIZ``0e3dI1@3o
m^h70=@m6@@0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP060=@m6@P0ooK^0P3D
?AT30?ofkPL0e3dI1P3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00L0ooK^103D
?AT:0?ofkP030=@m6@3om^h0ooK^0140ooK^103D?AT;0?ofkP030000003om^h0ooK^05<0ooK^0@3o
ool004P0ooK^00<000000?ofkP3om^h0C03om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0
ooK^00H0ooK^00<0?EV[0?ofkP0mFJ/0203om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00/0ooK^0P0m
FJ/20?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h00`3om^h303eIZ`P0ooK^00<0
?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00P0ooK^0`0m
FJ/60000000303eIZ`3om^h0e3dI00l0e3dI0P3om^h70=@m6@D0ooK^00<0e3dI0?ofkP3om^h01@3o
m^h80=@m6@030?ofkP3D?AT0ooK^00L0ooK^00<000000?ofkP3D?AT01`3D?AT30?ofkP030=@m6@3o
m^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP0D0?ofkP030=@m6@3o
m^h0ooK^00T0ooK^00<000000?ofkP3om^h0E03om^h10?ooo`00B03om^h00`000000ooK^0?ofkP1<
0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h01P3om^h203eIZ`X0ooK^00@0?EV[
0?ofkP3om^h0?EV[3@3om^h203eIZa40ooK^00<0?EV[0?ofkP3om^h01P3om^h303eIZ`D0ooK^00<0
?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00P0ooK^0P0m
FJ/30?ofkP80?EV[0P3om^h703eIZ`80ooK^2@3D?AT00`3om^h0e3dI0=@m6@040=@m6@<0ooK^1`3D
?AT<0?ofkPP0e3dI1@3om^h00`000000ooK^0?ofkP050?ofkPL0e3dI2`3om^h00`3D?AT0ooK^0?of
kP050?ofkP030=@m6@3om^h0ooK^01@0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`000000ooK^0?of
kP1E0?ofkP40oooo00170?ofkP800000CP3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0
?EV[00P0ooK^00<0?EV[0?ofkP3om^h02@3om^h203eIZ`l0ooK^00<0?EV[0?ofkP3om^h03P3om^h0
0`0mFJ/0ooK^0?ofkP0:0?ofkP<0?EV[00<0ooK^03eIZ`3om^h03`3om^h00`0mFJ/0ooK^0?ofkP0<
0?ofkP0303eIZ`3om^h0ooK^00@0ooK^1@0mFJ/40?ofkP80?EV[0P3om^h303eIZ`030?ofkP0mFJ/0
?EV[00X0ooK^1`3D?AT20?ofkPL0e3dI0P3om^h80=@m6@@0ooK^00<0e3dI0?ofkP3om^h00`3om^h0
0`3D?AT0ooK^0?ofkP060=@m6@P0ooK^0P3D?AT40?ofkPL0e3dI103om^h00`3D?AT0ooK^0?ofkP04
0?ofkP030=@m6@3om^h0ooK^01@0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`000000ooK^0?ofkP1E
0?ofkP40oooo00170?ofkP800000CP3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0?EV[
00P0ooK^0P0mFJ/;0?ofkP0303eIZ`3om^h0ooK^00d0ooK^0`0mFJ/>0?ofkP0303eIZ`3om^h0ooK^
00d0ooK^1@0mFJ/<0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h00P3om^h303eI
Z`@0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP0303eIZ`030?ofkP0mFJ/0?EV[
0180ooK^1`3D?AT20?ofkPL0e3dI0`3om^h70=@m6@@0ooK^00<0e3dI0?ofkP3om^h0103om^h00`00
0000e3dI0=@m6@040=@m6@80ooK^00<0e3dI0?ofkP3om^h02P3om^h70=@m6@@0ooK^00<0e3dI0?of
kP3om^h04`3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030000003om^h0ooK^05H0ooK^0@3oool004L0
ooK^0P00001?0?ofkP0403eIZ`3om^h0ooK^03eIZ`<0ooK^00<0?EV[0?ofkP3om^h0103om^h0100m
FJ/0ooK^0?ofkP0mFJ/:0?ofkP80?EV[3@3om^h0100mFJ/0ooK^0?ofkP3om^h203eIZ`/0ooK^00<0
?EV[0?ofkP3om^h03`3om^h0100mFJ/0ooK^0?ofkP3om^h803eIZ`@0ooK^00<0?EV[0?ofkP3om^h0
303om^h503eIZ`H0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP0303eIZ`030?of
kP0mFJ/0?EV[01T0ooK^3`3D?AT40?ofkPH0e3dI1@3om^h00`000000ooK^0?ofkP040?ofkPL0e3dI
3@3om^h00`3D?AT0ooK^0=@m6@060=@m6A<0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`000000ooK^
0?ofkP1G0?ofkP40oooo00170?ofkP030000003om^h0ooK^04h0ooK^00@0?EV[0?ofkP3om^h0?EV[
0`3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0403eIZ`3om^h0ooK^03eIZ`T0ooK^00<0?EV[0?ofkP3o
m^h00P0mFJ/;0?ofkP0303eIZ`3om^h0ooK^00<0ooK^0P0mFJ/90?ofkP0303eIZ`3om^h0ooK^00h0
ooK^00<0?EV[0?ofkP3om^h02P3om^hD03eIZ`X0ooK^00<0?EV[0?ofkP3om^h00`3om^h01P0mFJ/0
ooK^03eIZ`3om^h0?EV[0?ofkP80?EV[8@3om^h70=@m6@030?ofkP3D?AT0e3dI00D0e3dI0P3om^h8
0=@m6@@0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP060=@m6@P0ooK^00@0e3dI
0?ofkP3om^h0e3dI103om^h60=@m6@`0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`000000ooK^0?of
kP1H0?ofkP40oooo00170?ofkP030000003om^h0ooK^04h0ooK^00@0?EV[0?ofkP3om^h0?EV[103o
m^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h01P3o
m^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h01P3o
m^h203eIZ`H0ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3o
m^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP040?ofkP80?EV[00@0
ooK^03eIZ`0mFJ/0ooK^0P0mFJ/X0?ofkPH0e3dI0P3om^h70=@m6@030?ofkP000000ooK^00L0e3dI
0`3om^h00`3D?AT0ooK^0?ofkP050?ofkPH0e3dI0P3om^h00`3D?AT0ooK^0=@m6@0;0?ofkPL0e3dI
103om^h00`3D?AT0ooK^0?ofkP090?ofkP030000003om^h0ooK^05T0ooK^0@3oool004L0ooK^00<0
00000?ofkP3om^h0CP3om^h00`0mFJ/0ooK^03eIZ`050?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0
?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0
?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP080?ofkP80?EV[103om^h00`0mFJ/0ooK^0?of
kP0>0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?of
kP080?ofkP0303eIZ`3om^h0ooK^00<0ooK^100mFJ/00`3om^h0?EV[0?ofkP0203eIZbl0ooK^3`3D
?AT40?ofkPL0e3dI2P3om^h40=@m6A<0ooK^103D?AT;0?ofkP030000003om^h0ooK^05X0ooK^0@3o
ool004H0ooK^0P00001A0?ofkP80?EV[1P3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00H0ooK^00<0
?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP050?ofkP80?EV[1P3om^h00`0mFJ/0ooK^0?of
kP0:0?ofkP80?EV[00<0ooK^03eIZ`3om^h0403om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3o
m^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h02@3om^h0100mFJ/0ooK^0?ofkP3om^h203eIZ`80ooK^
00<0?EV[0?ofkP0mFJ/00`0mFJ/g0?ofkPl0e3dI0P3om^h00`3D?AT0ooK^0=@m6@060=@m6@@0ooK^
00@0e3dI0?ofkP3om^h0e3dI503om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030000003om^h0ooK^05X0
ooK^0@3oool004H0ooK^0P00001A0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00@0?EV[0?ofkP3om^h0
?EV[203om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3o
m^h00P3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP<0?EV[3`3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP03
03eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP0203eIZ`<0
ooK^0P0mFJ/00`3om^h0?EV[03eIZ`0203eIZcX0ooK^00<000000?ofkP3om^h00P3om^h?0=@m6@<0
ooK^1`3D?AT00`3om^h0e3dI0=@m6@0A0?ofkP030=@m6@3om^h0ooK^00X0ooK^00<000000?ofkP3o
m^h0F`3om^h10?ooo`00AP3om^h200000540ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^
03eIZ`090?ofkP0403eIZ`3om^h0ooK^03eIZ`/0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0?0?of
kP0303eIZ`3om^h0ooK^00<0?EV[303om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^
00/0ooK^00<0?EV[0?ofkP3om^h02@3om^h303eIZ`D0ooK^00<0?EV[0?ofkP0mFJ/00`0mFJ/k0?of
kP030000003om^h0ooK^00`0ooK^5@3D?AT<0?ofkP80e3dI303om^h00`000000ooK^0?ofkP1L0?of
kP40oooo00160?ofkP030000003om^h0ooK^0540ooK^00<0?EV[0?ofkP3om^h01@3om^h203eIZ`X0
ooK^00@0?EV[0?ofkP3om^h0?EV[303om^h303eIZa00ooK^00<0?EV[0?ofkP3om^h00`3om^h303eI
Z`P0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^
00L0ooK^0`0mFJ/60?ofkPL0?EV[>`3om^h00`000000ooK^0?ofkP0E0?ofkQ<0e3dI103om^h00`3D
?AT0ooK^0?ofkP0;0?ofkP030000003om^h0ooK^05d0ooK^0@3oool004H0ooK^00<000000?ofkP3o
m^h0D@3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00T0ooK^0P0mFJ/?0?ofkP03
03eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h01`3om^h303eIZ`D0ooK^00<0?EV[0?ofkP3o
m^h03@3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00D0ooK^0`0mFJ/00`3om^h0
?EV[0?ofkP060?ofkP<0?EV[00<0ooK^03eIZ`0mFJ/0?03om^h00`000000ooK^0?ofkP0K0?ofkPP0
e3dI1@3om^h40=@m6@d0ooK^00<000000?ofkP3om^h0GP3om^h10?ooo`00AP3om^h00`000000ooK^
0?ofkP1B0?ofkP0303eIZ`3om^h0ooK^00D0ooK^0P0mFJ/;0?ofkP0303eIZ`3om^h0ooK^00`0ooK^
00@0?EV[0?ofkP0mFJ/0?EV[3@3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP<0?EV[00<0ooK^03eIZ`3o
m^h03P3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0403eIZ`3om^h0ooK^0?ofkP@0?EV[0`3om^h00`0m
FJ/0ooK^0?ofkP050?ofkP@0?EV[00<0ooK^03eIZ`0mFJ/0?@3om^h00`000000ooK^0?ofkP0P0?of
kPL0e3dI403om^h00`000000ooK^0?ofkP1O0?ofkP40oooo00160?ofkP030000003om^h0ooK^05<0
ooK^00<0?EV[0?ofkP3om^h00`3om^h0100mFJ/0ooK^0?ofkP0mFJ/:0?ofkP80?EV[3@3om^h0100m
FJ/0ooK^0?ofkP3om^h203eIZ`X0ooK^00<0?EV[0?ofkP3om^h03P3om^h503eIZ``0ooK^00<0?EV[
0?ofkP3om^h02`3om^h00`0mFJ/0ooK^03eIZ`0203eIZ`L0ooK^00<0?EV[0?ofkP3om^h01@3om^h0
100mFJ/0ooK^03eIZ`3om^h203eIZch0ooK^00<000000?ofkP3om^h0=`3om^h00`000000ooK^0?of
kP1O0?ofkP40oooo00150?ofkP800000E@3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0403eIZ`3om^h0
ooK^03eIZ`T0ooK^00<0?EV[0?ofkP3om^h00P0mFJ/:0?ofkP0303eIZ`3om^h0ooK^00@0ooK^0P0m
FJ/80?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h00P3om^h803eIZ`<0ooK^00<0
?EV[0?ofkP3om^h01@3om^h903eIZ`T0ooK^00<0?EV[0?ofkP3om^h01@3om^h01@0mFJ/0ooK^0?of
kP0mFJ/0ooK^0080?EV[?P3om^h00`000000ooK^0?ofkP0f0?ofkP030000003om^h0ooK^0600ooK^
0@3oool004D0ooK^0P00001F0?ofkP0303eIZ`3om^h0ooK^0080ooK^00D0?EV[0?ofkP3om^h0ooK^
03eIZ`080?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^
0?ofkP060?ofkP80?EV[1@3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00X0ooK^
2`0mFJ/60?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h00`3om^h203eIZ`<0ooK^
0`0mFJ/o0?ofkP030000003om^h0ooK^03D0ooK^00<000000?ofkP3om^h0H@3om^h10?ooo`00A@3o
m^h00`000000ooK^0?ofkP1E0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/01@3om^h00`0mFJ/0ooK^
0?ofkP040?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^
0?ofkP090?ofkP80?EV[0`3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00d0ooK^
00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00<0ooK^
00<0?EV[0?ofkP0mFJ/00P3om^h00`0mFJ/0ooK^03eIZ`100?ofkP030000003om^h0ooK^03@0ooK^
00<000000?ofkP3om^h0HP3om^h10?ooo`00A@3om^h00`000000ooK^0?ofkP1F0?ofkP0403eIZ`3o
m^h0ooK^03eIZ`H0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eI
Z`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h02`3om^h303eIZa40ooK^00<0?EV[0?ofkP3om^h0
3@3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00T0ooK^00@0?EV[0?ofkP3om^h0
ooK^0P0mFJ/00`3om^h0?EV[0?ofkP020?ofkP<0?EV[@03om^h00`000000ooK^0?ofkP0c0?ofkP03
0000003om^h0ooK^06<0ooK^0@3oool004D0ooK^00<000000?ofkP3om^h0E`3om^h00`0mFJ/0ooK^
03eIZ`070?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^
0?ofkP020?ofkP0303eIZ`3om^h0ooK^00h0ooK^0P0mFJ/?0?ofkP0303eIZ`3om^h0ooK^00d0ooK^
00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^0080?EV[
0`3om^h00`0mFJ/0ooK^0?ofkP0303eIZd40ooK^00<000000?ofkP3om^h0<P3om^h00`000000ooK^
0?ofkP1T0?ofkP40oooo00150?ofkP030000003om^h0ooK^05L0ooK^0P0mFJ/90?ofkP0403eIZ`3o
m^h0ooK^03eIZ`X0ooK^0P0mFJ/20?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP0mFJ/0
0P0mFJ/<0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^
0?ofkP090?ofkP0303eIZ`3om^h0?EV[00@0ooK^00<0?EV[0?ofkP3om^h00`0mFJ]20?ofkP030000
003om^h0ooK^0380ooK^00<000000?ofkP3om^h0I03om^h10?ooo`00A03om^h2000005X0ooK^00<0
?EV[0?ofkP3om^h01`3om^h0100mFJ/0ooK^0?ofkP0mFJ/<0?ofkP80?EV[403om^h00`0mFJ/0ooK^
0?ofkP030?ofkP<0?EV[203om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00/0ooK^
00<0?EV[0?ofkP3om^h02@3om^h303eIZ`@0ooK^00D0?EV[0?ofkP3om^h0?EV[0?ofkP0203eIZd80
ooK^00<000000?ofkP3om^h0<@3om^h00`000000ooK^0?ofkP1U0?ofkP40oooo00140?ofkP800000
F`3om^h00`0mFJ/0ooK^0?ofkP070?ofkP80?EV[3P3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eI
Z`3om^h0ooK^00H0ooK^0`0mFJ/50?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h0
2`3om^h00`0mFJ/0ooK^0?ofkP070?ofkP<0?EV[1P3om^h0100mFJ/0ooK^03eIZ`3om^h203eIZd<0
ooK^00<000000?ofkP3om^h0<03om^h00`000000ooK^0?ofkP1V0?ofkP40oooo00140?ofkP030000
003om^h0ooK^05/0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP<0?EV[
3@3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP<0?EV[00<0ooK^03eIZ`3om^h03P3om^h00`0mFJ/0ooK^
0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00@0ooK^100mFJ/00`3om^h0?EV[0?ofkP050?ofkP<0?EV[
0P3om^h00`0mFJ/0ooK^0?ofkP120?ofkP030000003om^h0ooK^02l0ooK^00<000000?ofkP3om^h0
I`3om^h10?ooo`00A03om^h00`000000ooK^0?ofkP1K0?ofkP0303eIZ`3om^h0ooK^00L0ooK^0P0m
FJ/<0?ofkP0403eIZ`3om^h0ooK^0?ofkP80?EV[2`3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkPD0?EV[
303om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0?EV[00@0?EV[1@3om^h00`0mFJ/0ooK^
0?ofkP040?ofkP0403eIZ`3om^h0ooK^0?ofkP80?EV[A03om^h00`000000ooK^0?ofkP0^0?ofkP03
0000003om^h0ooK^06P0ooK^0@3oool004@0ooK^00<000000?ofkP3om^h0G03om^h00`0mFJ/0ooK^
0?ofkP050?ofkP0303eIZ`3om^h0ooK^0080?EV[2P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP80?EV[
2@3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^0080ooK^200mFJ/30?ofkP0303eI
Z`3om^h0ooK^00D0ooK^2@0mFJ/90?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h0
0P3om^h00`0mFJ/0ooK^0?ofkP140?ofkP030000003om^h0ooK^02`0ooK^00<000000?ofkP3om^h0
J@3om^h10?ooo`00A03om^h00`000000ooK^0?ofkP1M0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0
?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00H0ooK^0P0m
FJ/60?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h02P3om^h;03eIZ`D0ooK^00<0
?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP030?ofkP80?EV[103om^h00`0mFJ/0ooK^0?of
kP150?ofkP030000003om^h0ooK^02`0ooK^00<000000?ofkP3om^h0J@3om^h10?ooo`00@`3om^h2
00000600ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0
ooK^00D0ooK^00<0?EV[0?ofkP3om^h0203om^h203eIZ`@0ooK^00<0?EV[0?ofkP3om^h03@3om^h0
0`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h02@3om^h0
100mFJ/0ooK^0?ofkP3om^h203eIZ`030?ofkP0mFJ/0ooK^0080ooK^0P0mFJ]70?ofkP030000003o
m^h0ooK^02/0ooK^00<000000?ofkP3om^h0JP3om^h10?ooo`00@`3om^h200000640ooK^00D0?EV[
0?ofkP3om^h0ooK^03eIZ`070?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h02P3o
m^h203eIZ`030?ofkP0mFJ/0ooK^00l0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?of
kP0:0?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h00P0mFJ/20?ofkP0403eIZ`3o
m^h0ooK^0?ofkP80?EV[B03om^h00`000000ooK^0?ofkP0Z0?ofkP030000003om^h0ooK^06/0ooK^
0@3oool004<0ooK^00<000000?ofkP3om^h0H@3om^h0100mFJ/0ooK^0?ofkP0mFJ/80?ofkP0303eI
Z`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h03@3om^h303eIZ`h0ooK^00<0?EV[0?ofkP3om^h0
3@3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00P0ooK^00@0?EV[0?ofkP0mFJ/0
?EV[103om^h00`0mFJ/0ooK^0?ofkP0303eIZdP0ooK^00<000000?ofkP3om^h0:@3om^h00`000000
ooK^0?ofkP1/0?ofkP40oooo00130?ofkP030000003om^h0ooK^0640ooK^00@0?EV[0?ofkP3om^h0
?EV[2@3om^h203eIZ`80ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0303eIZ`/0
ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00T0
ooK^0P0mFJ/50?ofkP0603eIZ`3om^h0?EV[03eIZ`3om^h0?EV[B@3om^h00`000000ooK^0?ofkP0X
0?ofkP030000003om^h0ooK^06d0ooK^0@3oool004<0ooK^00<000000?ofkP3om^h0HP3om^h203eI
Z``0ooK^0P0mFJ/@0?ofkP0303eIZ`3om^h0ooK^00<0ooK^0P0mFJ/80?ofkP0303eIZ`3om^h0ooK^
00d0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP070?ofkP80?EV[1`3om^h203eI
Z`80ooK^00<0?EV[0?ofkP3om^h0B03om^h00`000000ooK^0?ofkP0W0?ofkP030000003om^h0ooK^
06h0ooK^0@3oool004<0ooK^00<000000?ofkP3om^h0H`3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP03
03eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h01P3om^h303eIZ`D0ooK^00<0?EV[0?ofkP3o
m^h03@3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00D0ooK^100mFJ/70?ofkP80
?EV[0`3om^h00`0mFJ/0ooK^0?ofkP180?ofkP030000003om^h0ooK^02L0ooK^00<000000?ofkP3o
m^h0KP3om^h10?ooo`00@`3om^h00`000000ooK^0?ofkP1T0?ofkP0303eIZ`3om^h0ooK^00X0ooK^
0`0mFJ/=0?ofkP0303eIZ`3om^h0ooK^00T0ooK^0`0mFJ/00`3om^h0?EV[0?ofkP0>0?ofkP0303eI
Z`3om^h0ooK^00/0ooK^00@0?EV[0?ofkP3om^h0ooK^100mFJ/30?ofkP0303eIZ`3om^h0ooK^00D0
ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`1;0?ofkP030000003om^h0ooK^02H0ooK^00<000000?of
kP3om^h0K`3om^h10?ooo`00@P3om^h2000006L0ooK^0P0mFJ/90?ofkP0403eIZ`3om^h0ooK^0?of
kP80?EV[2P3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkPD0?EV[303om^h00`0mFJ/0ooK^0?ofkP0:0?of
kP0303eIZ`3om^h0?EV[0080?EV[1P3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^
0080ooK^00<0?EV[0?ofkP3om^h0B@3om^h00`000000ooK^0?ofkP0U0?ofkP030000003om^h0ooK^
0700ooK^0@3oool00480ooK^00<000000?ofkP3om^h0J03om^h00`0mFJ/0ooK^0?ofkP060?ofkP03
03eIZ`3om^h0ooK^00<0ooK^0P0mFJ/80?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3o
m^h00P3om^h803eIZ`<0ooK^00<0?EV[0?ofkP3om^h01@3om^h803eIZ`T0ooK^00<0?EV[0?ofkP3o
m^h00`3om^h203eIZ`@0ooK^00<0?EV[0?ofkP3om^h0BP3om^h00`000000ooK^0?ofkP0T0?ofkP03
0000003om^h0ooK^0740ooK^0@3oool00480ooK^00<000000?ofkP3om^h0J@3om^h00`0mFJ/0ooK^
0?ofkP050?ofkP0303eIZ`3om^h0ooK^00D0ooK^0P0mFJ/50?ofkP0303eIZ`3om^h0ooK^00h0ooK^
00<0?EV[0?ofkP3om^h02P3om^h;03eIZ`D0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^
0?ofkP030?ofkP0303eIZ`3om^h0?EV[00<0ooK^00<0?EV[0?ofkP3om^h0B`3om^h00`000000ooK^
0?ofkP0S0?ofkP030000003om^h0ooK^0780ooK^0@3oool00480ooK^00<000000?ofkP3om^h0JP3o
m^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00P0ooK^0P0mFJ/30?ofkP0303eIZ`3o
m^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3o
m^h0ooK^00P0ooK^00@0?EV[0?ofkP3om^h0ooK^0P0mFJ/00`3om^h0?EV[0?ofkP020?ofkP0303eI
Z`3om^h0ooK^04d0ooK^00<000000?ofkP3om^h08@3om^h00`000000ooK^0?ofkP1c0?ofkP40oooo
00120?ofkP030000003om^h0ooK^06/0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?of
kP0:0?ofkP<0?EV[403om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0
?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP0203eIZ`<0ooK^00@0?EV[0?ofkP3om^h0?EV[
D03om^h00`000000ooK^0?ofkP0Q0?ofkP030000003om^h0ooK^07<0ooK^0@3oool00480ooK^00<0
00000?ofkP3om^h0K03om^h203eIZ`80ooK^00<0?EV[0?ofkP3om^h0303om^h203eIZ`h0ooK^00<0
?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0
?EV[0?ofkP0mFJ/0103om^h0100mFJ/0ooK^03eIZ`0mFJ]A0?ofkP030000003om^h0ooK^0200ooK^
00<000000?ofkP3om^h0M03om^h10?ooo`00@@3om^h200000700ooK^0P0mFJ/?0?ofkP0303eIZ`3o
m^h0?EV[00<0?EV[2P3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0
?EV[0?ofkP3om^h0203om^h303eIZ`D0ooK^0P0mFJ]C0?ofkP030000003om^h0ooK^01l0ooK^00<0
00000?ofkP3om^h0M@3om^h10?ooo`00@@3om^h00`000000ooK^0?ofkP1`0?ofkP0303eIZ`3om^h0
ooK^00`0ooK^00<0?EV[0?ofkP3om^h0103om^h303eIZ`H0ooK^00<0?EV[0?ofkP3om^h03@3om^h0
0`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00H0ooK^0`0mFJ/60?ofkP80?EV[E03om^h0
0`000000ooK^0?ofkP0N0?ofkP030000003om^h0ooK^07H0ooK^0@3oool00440ooK^00<000000?of
kP3om^h0L@3om^h203eIZ``0ooK^00<0?EV[0?ofkP3om^h01`3om^h403eIZ`80ooK^00<0?EV[0?of
kP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00<0ooK^100mFJ/00`3o
m^h0?EV[0?ofkP060?ofkP0303eIZ`3om^h0ooK^05<0ooK^00<000000?ofkP3om^h07@3om^h00`00
0000ooK^0?ofkP1g0?ofkP40oooo00110?ofkPD00000L@3om^h203eIZ`T0ooK^00<0?EV[0?ofkP3o
m^h0303om^h503eIZ``0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^03eIZ`0303eIZ`D0
ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP1D0?ofkP030000003om^h0ooK^01`0
ooK^00<000000?ofkP3om^h0N03om^h10?ooo`00AP3om^h8000006/0ooK^00<0?EV[0?ofkP3om^h0
1P3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0403eIZ`3om^h0ooK^0?ofkPP0?EV[103om^h00`0mFJ/0
ooK^0?ofkP040?ofkPT0?EV[203om^h00`0mFJ/0ooK^0?ofkP030?ofkP80?EV[E`3om^h00`000000
ooK^0?ofkP0L0?ofkP030000003om^h0ooK^07P0ooK^0@3oool004h0ooK^2000001T0?ofkP80?EV[
1@3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00X0ooK^2`0mFJ/50?ofkP0303eI
Z`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h00P3om^h203eIZeT0ooK^00<000000?ofkP3om^h0
6`3om^h00`000000ooK^0?ofkP1i0?ofkP40oooo001F0?ofkPT00000G@3om^h203eIZ`<0ooK^00<0
?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0
?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP0203eIZe/0ooK^00<000000?ofkP3om^h06P3o
m^h00`000000ooK^0?ofkP1j0?ofkP40oooo001O0?ofkPP00000E`3om^h303eIZ`l0ooK^00<0?EV[
0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00P0ooK^00@0?EV[
0?ofkP0mFJ/0?EV[G@3om^h00`000000ooK^0?ofkP0I0?ofkP030000003om^h0ooK^07/0ooK^0@3o
ool006L0ooK^2000001A0?ofkP80?EV[3P3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0
ooK^00/0ooK^00<0?EV[0?ofkP3om^h0203om^h203eIZf00ooK^00<000000?ofkP3om^h05`3om^h0
0`000000ooK^0?ofkP1l0?ofkP40oooo001_0?ofkPT00000BP3om^h403eIZ`T0ooK^00<0?EV[0?of
kP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00L0ooK^0P0mFJ]R0?of
kP030000003om^h0ooK^01H0ooK^00<000000?ofkP3om^h0O@3om^h10?ooo`00N03om^h8000004H0
ooK^0`0mFJ/60?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0
ooK^0?ofkP040?ofkP<0?EV[I03om^h00`000000ooK^0?ofkP0F0?ofkP030000003om^h0ooK^07d0
ooK^0@3oool00800ooK^200000110?ofkP@0?EV[00<0ooK^03eIZ`3om^h03P3om^h00`0mFJ/0ooK^
0?ofkP0:0?ofkP0403eIZ`3om^h0ooK^0?ofkP@0?EV[I`3om^h00`000000ooK^0?ofkP0E0?ofkP03
0000003om^h0ooK^07h0ooK^0@3oool008P0ooK^2@00000l0?ofkPD0?EV[2`3om^h00`0mFJ/0ooK^
0?ofkP0;0?ofkP@0?EV[J`3om^h00`000000ooK^0?ofkP0D0?ofkP030000003om^h0ooK^07l0ooK^
0@3oool00940ooK^2000000i0?ofkPL0?EV[103om^h00`0mFJ/0ooK^0?ofkP040?ofkPP0?EV[KP3o
m^h00`000000ooK^0?ofkP0C0?ofkP030000003om^h0ooK^0800ooK^0@3oool009T0ooK^2000000h
0?ofkP/0?EV[MP3om^h00`000000ooK^0?ofkP0B0?ofkP030000003om^h0ooK^0840ooK^0@3oool0
0:40ooK^2@00002`0?ofkP030000003om^h0ooK^0140ooK^00<000000?ofkP3om^h0PP3om^h10?oo
o`00ZP3om^h800000:P0ooK^00<000000?ofkP3om^h04@3om^h00`000000ooK^0?ofkP220?ofkP40
oooo002b0?ofkPP00000X03om^h00`000000ooK^0?ofkP0@0?ofkP030000003om^h0ooK^08<0ooK^
0@3oool00;X0ooK^2@00002G0?ofkP030000003om^h0ooK^00l0ooK^00<000000?ofkP3om^h0Q03o
m^h10?ooo`00``3om^h8000008l0ooK^00<000000?ofkP3om^h03P3om^h00`000000ooK^0?ofkP25
0?ofkP40oooo003;0?ofkPP00000R03om^h00`000000ooK^0?ofkP0<0?ofkP030000003om^h0ooK^
08H0ooK^0@3oool00=<0ooK^200000200?ofkP030000003om^h0ooK^00/0ooK^00<000000?ofkP3o
m^h0Q`3om^h10?ooo`00f`3om^h9000007L0ooK^00<000000?ofkP3om^h02`3om^h00`000000ooK^
0?ofkP270?ofkP40oooo003T0?ofkPP00000K`3om^h00`000000ooK^0?ofkP0:0?ofkP030000003o
m^h0ooK^08P0ooK^0@3oool00>`0ooK^2000001W0?ofkP030000003om^h0ooK^00T0ooK^00<00000
0?ofkP3om^h0R@3om^h10?ooo`00m03om^h9000005h0ooK^00<000000?ofkP3om^h0203om^h00`00
0000ooK^0?ofkP2:0?ofkP40oooo003m0?ofkPP00000EP3om^h00`000000ooK^0?ofkP070?ofkP03
0000003om^h0ooK^08/0ooK^0@3oool00?l0ooK^1P3om^h8000004h0ooK^00<000000?ofkP3om^h0
1P3om^h00`000000ooK^0?ofkP2<0?ofkP40oooo003o0?ofkPh0ooK^2@0000150?ofkP030000003o
m^h0ooK^00H0ooK^00<000000?ofkP3om^h0S03om^h10?ooo`00o`3om^hG0?ofkPP00000?@3om^h0
0`000000ooK^0?ofkP050?ofkP030000003om^h0ooK^08d0ooK^0@3oool00?l0ooK^7`3om^h80000
03D0ooK^00<000000?ofkP3om^h0103om^h00`000000ooK^0?ofkP2>0?ofkP40oooo003o0?ofkRL0
ooK^2@00000/0?ofkP030000003om^h0ooK^00<0ooK^00<000000?ofkP3om^h0S`3om^h10?ooo`00
o`3om^h`0?ofkPP000009@3om^h01@000000ooK^0?ofkP3om^h000000980ooK^0@3oool00?l0ooK^
>03om^h8000001d0ooK^00@000000?ofkP3om^h00000T`3om^h10?ooo`00o`3om^i00?ofkPT00000
503om^h010000000ooK^0?ofkP00002C0?ofkP40oooo003o0?ofkTT0ooK^2000000<0?ofkP030000
003om^h0000009@0ooK^0@3oool00?l0ooK^D@3om^h8000000@0ooK^0P00002E0?ofkP40oooo003o
0?ofkUT0ooK^1@00002F0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00
o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?of
kP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o
0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^
0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0
ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h1
0?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3o
m^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40
oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?of
k_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3o
ool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^
m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?oo
o`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd
0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo
003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0
ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool0
0?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03o
m^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00
o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?of
kP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o
0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^
0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0
ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h1
0?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3o
m^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40
oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo0000\
\>"],
  ImageRangeCache->{{{0, 499}, {499, 0}} -> {-5.00005*^-06, -5.00005*^-06, \
0.00200403, 0.00200403}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
%%ImageSize: 500 500 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics3D
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Background color
1 .961 .933 r
MFill
% Scaling calculations
0 1 0 1 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 0 r
.25 Mabswid
[ ] 0 setdash
.93295 .30234 m
.99253 .5665 L
s
.99253 .5665 m
.33874 .3169 L
s
.33874 .3169 m
.36195 .03848 L
s
.36195 .03848 m
.93295 .30234 L
s
.59088 .60318 m
.11236 .44767 L
s
.11236 .44767 m
.06528 .69847 L
s
.06528 .69847 m
.60039 .8356 L
s
.60039 .8356 m
.59088 .60318 L
s
.93295 .30234 m
.99253 .5665 L
s
.99253 .5665 m
.60039 .8356 L
s
.60039 .8356 m
.59088 .60318 L
s
.59088 .60318 m
.93295 .30234 L
s
.36195 .03848 m
.11236 .44767 L
s
.11236 .44767 m
.06528 .69847 L
s
.06528 .69847 m
.33874 .3169 L
s
.33874 .3169 m
.36195 .03848 L
s
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
.24 .35 .67 r
.5 Mabswid
.42857 .56253 m
.40755 .54684 L
s
.44572 .54453 m
.42857 .56253 L
s
.447 .58135 m
.42857 .56253 L
s
.46445 .56364 m
.447 .58135 L
s
.46216 .60261 m
.447 .58135 L
s
.40755 .54684 m
.38469 .53486 L
s
.4244 .52855 m
.40755 .54684 L
s
.4799 .58518 m
.46216 .60261 L
s
.47346 .62555 m
.46216 .60261 L
s
.38469 .53486 m
.3608 .52709 L
s
.40124 .5163 m
.38469 .53486 L
s
.49148 .6084 m
.47346 .62555 L
s
.48042 .64934 m
.47346 .62555 L
s
.3608 .52709 m
.33678 .52391 L
s
.37708 .50827 m
.3608 .52709 L
s
.4244 .52855 m
.44572 .54453 L
s
.46342 .52595 m
.44572 .54453 L
s
.44572 .54453 m
.46445 .56364 L
s
.49869 .63245 m
.48042 .64934 L
s
.48268 .6731 m
.48042 .64934 L
s
.48246 .54535 m
.46445 .56364 L
s
.46445 .56364 m
.4799 .58518 L
s
.40124 .5163 m
.4244 .52855 L
s
.44179 .50967 m
.4244 .52855 L
s
.49822 .56719 m
.4799 .58518 L
s
.4799 .58518 m
.49148 .6084 L
s
.33678 .52391 m
.31356 .52555 L
s
.35282 .50487 m
.33678 .52391 L
s
.37708 .50827 m
.40124 .5163 L
s
.41833 .49713 m
.40124 .5163 L
s
.51009 .59069 m
.49148 .6084 L
s
.49148 .6084 m
.49869 .63245 L
s
.50117 .65643 m
.48268 .6731 L
s
.48002 .69588 m
.48268 .6731 L
s
.35282 .50487 m
.37708 .50827 L
s
.3939 .48884 m
.37708 .50827 L
s
.83 .24 .1 r
.6663 .59771 m
.6726 .57153 L
s
.6726 .57153 m
.64176 .56096 L
s
.6726 .57153 m
.68175 .54593 L
s
.68175 .54593 m
.65099 .53511 L
s
.68175 .54593 m
.69344 .5218 L
s
.24 .35 .67 r
.44179 .50967 m
.46342 .52595 L
s
.4817 .50675 m
.46342 .52595 L
s
.46342 .52595 m
.48246 .54535 L
s
.31356 .52555 m
.2921 .53211 L
s
.32938 .50634 m
.31356 .52555 L
s
.51757 .61499 m
.49869 .63245 L
s
.49869 .63245 m
.50117 .65643 L
s
.50107 .52646 m
.48246 .54535 L
s
.48246 .54535 m
.49822 .56719 L
s
.41833 .49713 m
.44179 .50967 L
s
.45975 .49016 m
.44179 .50967 L
s
.83 .24 .1 r
.66309 .62359 m
.6663 .59771 L
s
.6663 .59771 m
.63531 .58735 L
s
.69344 .5218 m
.66267 .51071 L
s
.69344 .5218 m
.70729 .49996 L
s
.24 .35 .67 r
.51714 .5486 m
.49822 .56719 L
s
.49822 .56719 m
.51009 .59069 L
s
.49867 .6794 m
.48002 .69588 L
s
.47238 .71672 m
.48002 .69588 L
s
.32938 .50634 m
.35282 .50487 L
s
.36938 .4852 m
.35282 .50487 L
s
.3939 .48884 m
.41833 .49713 L
s
.43599 .47732 m
.41833 .49713 L
s
.83 .24 .1 r
.66313 .64824 m
.66309 .62359 L
s
.66309 .62359 m
.63187 .61341 L
s
.24 .35 .67 r
.52932 .57239 m
.51009 .59069 L
s
.51009 .59069 m
.51757 .61499 L
s
.83 .24 .1 r
.63531 .58735 m
.64176 .56096 L
s
.64176 .56096 m
.61033 .55018 L
s
.64176 .56096 m
.65099 .53511 L
s
.65099 .53511 m
.61963 .52409 L
s
.65099 .53511 m
.66267 .51071 L
s
.24 .35 .67 r
.52027 .63921 m
.50117 .65643 L
s
.50117 .65643 m
.49867 .6794 L
s
.83 .24 .1 r
.70729 .49996 m
.67644 .48859 L
s
.70729 .49996 m
.72286 .48125 L
s
.24 .35 .67 r
.2921 .53211 m
.27335 .54349 L
s
.30775 .51278 m
.2921 .53211 L
s
.83 .24 .1 r
.63187 .61341 m
.63531 .58735 L
s
.63531 .58735 m
.60372 .5768 L
s
.66267 .51071 m
.63132 .49941 L
s
.66267 .51071 m
.67644 .48859 L
s
.24 .35 .67 r
.36938 .4852 m
.3939 .48884 L
s
.41127 .46875 m
.3939 .48884 L
s
.45975 .49016 m
.4817 .50675 L
s
.5006 .4869 m
.4817 .50675 L
s
.4817 .50675 m
.50107 .52646 L
s
.30775 .51278 m
.32938 .50634 L
s
.34573 .48648 m
.32938 .50634 L
s
.49113 .70039 m
.47238 .71672 L
s
.45991 .73466 m
.47238 .71672 L
s
.53707 .59696 m
.51757 .61499 L
s
.51757 .61499 m
.52027 .63921 L
s
.5203 .50694 m
.50107 .52646 L
s
.50107 .52646 m
.51714 .5486 L
s
.83 .24 .1 r
.63162 .63821 m
.66313 .64824 L
s
.66652 .67076 m
.66313 .64824 L
s
.63162 .63821 m
.63187 .61341 L
s
.63187 .61341 m
.60005 .60304 L
s
.24 .35 .67 r
.43599 .47732 m
.45975 .49016 L
s
.47832 .46999 m
.45975 .49016 L
s
.83 .24 .1 r
.60372 .5768 m
.61033 .55018 L
s
.61033 .55018 m
.57829 .5392 L
s
.61033 .55018 m
.61963 .52409 L
s
.61963 .52409 m
.58767 .51285 L
s
.61963 .52409 m
.63132 .49941 L
s
.67644 .48859 m
.64501 .477 L
s
.67644 .48859 m
.69186 .46959 L
s
.72286 .48125 m
.69186 .46959 L
s
.72286 .48125 m
.73962 .46644 L
s
.24 .35 .67 r
.5367 .52939 m
.51714 .5486 L
s
.51714 .5486 m
.52932 .57239 L
s
.51794 .66237 m
.49867 .6794 L
s
.49867 .6794 m
.49113 .70039 L
s
.83 .24 .1 r
.60005 .60304 m
.60372 .5768 L
s
.60372 .5768 m
.57152 .56604 L
s
.63132 .49941 m
.59935 .48789 L
s
.63132 .49941 m
.64501 .477 L
s
.24 .35 .67 r
.34573 .48648 m
.36938 .4852 L
s
.3865 .46487 m
.36938 .4852 L
s
.41127 .46875 m
.43599 .47732 L
s
.45425 .45684 m
.43599 .47732 L
s
.27335 .54349 m
.25823 .55936 L
s
.28888 .5241 m
.27335 .54349 L
s
.52932 .57239 m
.53707 .59696 L
s
.54001 .6214 m
.52027 .63921 L
s
.52027 .63921 m
.51794 .66237 L
s
.83 .24 .1 r
.5995 .62799 m
.63162 .63821 L
s
.63467 .66082 m
.63162 .63821 L
s
.5995 .62799 m
.60005 .60304 L
s
.60005 .60304 m
.56761 .59247 L
s
.57152 .56604 m
.57829 .5392 L
s
.57829 .5392 m
.58767 .51285 L
s
.58767 .51285 m
.55509 .50139 L
s
.58767 .51285 m
.59935 .48789 L
s
.24 .35 .67 r
.28888 .5241 m
.30775 .51278 L
s
.32393 .49279 m
.30775 .51278 L
s
.47868 .71843 m
.45991 .73466 L
s
.44296 .74882 m
.45991 .73466 L
s
.83 .24 .1 r
.64501 .477 m
.61295 .46519 L
s
.64501 .477 m
.66026 .4577 L
s
.69186 .46959 m
.66026 .4577 L
s
.69186 .46959 m
.70841 .45448 L
s
.67325 .6902 m
.66652 .67076 L
s
.66652 .67076 m
.63467 .66082 L
s
.24 .35 .67 r
.3865 .46487 m
.41127 .46875 L
s
.42924 .44798 m
.41127 .46875 L
s
.83 .24 .1 r
.56761 .59247 m
.57152 .56604 L
s
.73962 .46644 m
.70841 .45448 L
s
.73962 .46644 m
.757 .45621 L
s
.59935 .48789 m
.56677 .47615 L
s
.59935 .48789 m
.61295 .46519 L
s
.24 .35 .67 r
.47832 .46999 m
.5006 .4869 L
s
.5006 .4869 m
.5203 .50694 L
s
.32393 .49279 m
.34573 .48648 L
s
.36264 .46595 m
.34573 .48648 L
s
.51051 .6835 m
.49113 .70039 L
s
.49113 .70039 m
.47868 .71843 L
s
.53707 .59696 m
.54001 .6214 L
s
.5203 .50694 m
.5367 .52939 L
s
.45425 .45684 m
.47832 .46999 L
s
.49752 .44914 m
.47832 .46999 L
s
.25823 .55936 m
.24757 .57919 L
s
.27371 .53999 m
.25823 .55936 L
s
.83 .24 .1 r
.56675 .61756 m
.5995 .62799 L
s
.60219 .6507 m
.5995 .62799 L
s
.56675 .61756 m
.56761 .59247 L
s
.939 .263 .11 r
.53164 .56749 m .54757 .57274 L .54449 .55007 L p F P
0 0 0 r
s
.24 .35 .67 r
.5367 .52939 m
.53847 .5328 L
s
.52932 .57239 m
.53374 .56818 L
s
.939 .263 .11 r
.54449 .55007 m .52958 .54506 L .53164 .56749 L p F P
0 0 0 r
s
.96 .271 .113 r
.52958 .54506 m .54449 .55007 L .54043 .52633 L p F P
0 0 0 r
s
.19 .276 .57 r
.54865 .51826 m .54043 .52633 L .54449 .55007 L p F P
0 0 0 r
s
.83 .24 .1 r
.5473 .52857 m
.57829 .5392 L
s
.19 .276 .57 r
.54449 .55007 m .55357 .54137 L .54865 .51826 L p F P
0 0 0 r
s
.169 .243 .509 r
.55357 .54137 m .54449 .55007 L .54757 .57274 L p F P
0 0 0 r
s
.83 .24 .1 r
.53869 .55507 m
.54614 .55756 L
s
.55022 .55892 m
.57152 .56604 L
s
.24 .35 .67 r
.53787 .64475 m
.51794 .66237 L
s
.51794 .66237 m
.51051 .6835 L
s
.83 .24 .1 r
.54882 .51904 m
.55509 .50139 L
s
.55509 .50139 m
.56677 .47615 L
s
.96 .271 .113 r
.54043 .52633 m .52687 .52168 L .52958 .54506 L p F P
0 0 0 r
s
.83 .24 .1 r
.53869 .55507 m
.54336 .53684 L
s
.977 .277 .116 r
.52687 .52168 m .54043 .52633 L .53545 .5019 L p F P
0 0 0 r
s
.209 .305 .622 r
.54263 .49468 m .53545 .5019 L .54043 .52633 L p F P
0 0 0 r
s
.209 .305 .622 r
.54043 .52633 m .54865 .51826 L .54263 .49468 L p F P
0 0 0 r
s
.83 .24 .1 r
.54329 .49724 m
.55509 .50139 L
s
.61295 .46519 m
.58027 .45314 L
s
.61295 .46519 m
.62804 .44558 L
s
.66026 .4577 m
.62804 .44558 L
s
.66026 .4577 m
.67658 .4423 L
s
.24 .35 .67 r
.36264 .46595 m
.3865 .46487 L
s
.40421 .44384 m
.3865 .46487 L
s
.83 .24 .1 r
.64101 .68032 m
.63467 .66082 L
s
.63467 .66082 m
.60219 .6507 L
s
.912 .254 .105 r
.53301 .58856 m .54962 .59394 L .54757 .57274 L p F P
0 0 0 r
s
.24 .35 .67 r
.53707 .59696 m
.54274 .59171 L
s
.912 .254 .105 r
.54757 .57274 m .53164 .56749 L .53301 .58856 L p F P
0 0 0 r
s
.169 .243 .509 r
.54757 .57274 m .55732 .56361 L .55357 .54137 L p F P
0 0 0 r
s
.24 .35 .67 r
.54466 .55778 m
.5492 .55347 L
s
.54078 .53724 m
.5492 .55347 L
s
.144 .204 .437 r
.55732 .56361 m .54757 .57274 L .54962 .59394 L p F P
0 0 0 r
s
.83 .24 .1 r
.53453 .58169 m
.54949 .58656 L
s
.55134 .58717 m
.56761 .59247 L
s
.24 .35 .67 r
.42924 .44798 m
.45425 .45684 L
s
.47313 .43566 m
.45425 .45684 L
s
.83 .24 .1 r
.53453 .58169 m
.53869 .55507 L
s
.24 .35 .67 r
.27371 .53999 m
.28888 .5241 L
s
.30495 .50405 m
.28888 .5241 L
s
.83 .24 .1 r
.70841 .45448 m
.67658 .4423 L
s
.70841 .45448 m
.7255 .44399 L
s
.977 .277 .116 r
.53545 .5019 m .52355 .49774 L .52687 .52168 L p F P
0 0 0 r
s
.24 .35 .67 r
.5203 .50694 m
.52427 .50291 L
s
.99 .283 .119 r
.52355 .49774 m .53545 .5019 L .52965 .4772 L p F P
0 0 0 r
s
.226 .331 .669 r
.53561 .47104 m .52965 .4772 L .53545 .5019 L p F P
0 0 0 r
s
.226 .331 .669 r
.53545 .5019 m .54263 .49468 L .53561 .47104 L p F P
0 0 0 r
s
.83 .24 .1 r
.56677 .47615 m
.58027 .45314 L
s
.24 .35 .67 r
.46169 .73262 m
.44296 .74882 L
s
.42216 .75839 m
.44296 .74882 L
s
.939 .263 .11 r
.51556 .56218 m .53164 .56749 L .52958 .54506 L p F P
0 0 0 r
s
.939 .263 .11 r
.52958 .54506 m .51454 .54001 L .51556 .56218 L p F P
0 0 0 r
s
.96 .271 .113 r
.51454 .54001 m .52958 .54506 L .52687 .52168 L p F P
0 0 0 r
s
.96 .271 .113 r
.52687 .52168 m .5132 .517 L .51454 .54001 L p F P
0 0 0 r
s
.977 .277 .116 r
.5132 .517 m .52687 .52168 L .52355 .49774 L p F P
0 0 0 r
s
.83 .24 .1 r
.68318 .70568 m
.67325 .6902 L
s
.67325 .6902 m
.64101 .68032 L
s
.877 .242 .1 r
.53366 .60791 m .55059 .61329 L .54962 .59394 L p F P
0 0 0 r
s
.877 .242 .1 r
.54962 .59394 m .53301 .58856 L .53366 .60791 L p F P
0 0 0 r
s
.144 .204 .437 r
.54962 .59394 m .55981 .58459 L .55732 .56361 L p F P
0 0 0 r
s
.113 .157 .348 r
.55981 .58459 m .54962 .59394 L .55059 .61329 L p F P
0 0 0 r
s
.24 .35 .67 r
.54808 .58677 m
.55724 .5783 L
s
.912 .254 .105 r
.51624 .58313 m .53301 .58856 L .53164 .56749 L p F P
0 0 0 r
s
.912 .254 .105 r
.53164 .56749 m .51556 .56218 L .51624 .58313 L p F P
0 0 0 r
s
.19 .276 .57 r
.55699 .51007 m .54865 .51826 L .55357 .54137 L p F P
0 0 0 r
s
.19 .276 .57 r
.55357 .54137 m .5628 .53252 L .55699 .51007 L p F P
0 0 0 r
s
.169 .243 .509 r
.5628 .53252 m .55357 .54137 L .55732 .56361 L p F P
0 0 0 r
s
.24 .35 .67 r
.5492 .55347 m
.55724 .5783 L
s
.209 .305 .622 r
.54989 .48737 m .54263 .49468 L .54865 .51826 L p F P
0 0 0 r
s
.209 .305 .622 r
.54865 .51826 m .55699 .51007 L .54989 .48737 L p F P
0 0 0 r
s
.977 .277 .116 r
.52355 .49774 m .51157 .49355 L .5132 .517 L p F P
0 0 0 r
s
.99 .283 .119 r
.51157 .49355 m .52355 .49774 L .51968 .47365 L p F P
0 0 0 r
s
.99 .283 .119 r
.52965 .4772 m .51968 .47365 L .52355 .49774 L p F P
0 0 0 r
s
.83 .24 .1 r
.52187 .48971 m
.53462 .4942 L
s
.24 .35 .67 r
.30495 .50405 m
.32393 .49279 L
s
.34067 .47212 m
.32393 .49279 L
s
.49811 .70163 m
.47868 .71843 L
s
.47868 .71843 m
.46169 .73262 L
s
.83 .24 .1 r
.757 .45621 m
.7255 .44399 L
s
.757 .45621 m
.77432 .4512 L
s
.96 .271 .113 r
.49937 .53491 m .51454 .54001 L .5132 .517 L p F P
0 0 0 r
s
.96 .271 .113 r
.5132 .517 m .49943 .51227 L .49937 .53491 L p F P
0 0 0 r
s
.977 .277 .116 r
.49943 .51227 m .5132 .517 L .51157 .49355 L p F P
0 0 0 r
s
.83 .24 .1 r
.51233 .51658 m
.54143 .52656 L
s
.939 .263 .11 r
.49932 .55683 m .51556 .56218 L .51454 .54001 L p F P
0 0 0 r
s
.939 .263 .11 r
.51454 .54001 m .49937 .53491 L .49932 .55683 L p F P
0 0 0 r
s
.83 .24 .1 r
.50521 .54388 m
.53869 .55507 L
s
.56907 .64037 m
.56675 .61756 L
s
.24 .35 .67 r
.40421 .44384 m
.42924 .44798 L
s
.44783 .4265 m
.42924 .44798 L
s
.169 .243 .509 r
.55732 .56361 m .56723 .55433 L .5628 .53252 L p F P
0 0 0 r
s
.144 .204 .437 r
.56723 .55433 m .55732 .56361 L .55981 .58459 L p F P
0 0 0 r
s
.83 .24 .1 r
.50521 .54388 m
.51233 .51658 L
s
.51233 .51658 m
.52187 .48971 L
s
.241 .354 .711 r
.52771 .44776 m .52309 .45265 L .52965 .4772 L p F P
0 0 0 r
s
.241 .354 .711 r
.52965 .4772 m .53561 .47104 L .52771 .44776 L p F P
0 0 0 r
s
1 .287 .121 r
.51968 .47365 m .52965 .4772 L .52309 .45265 L p F P
0 0 0 r
s
.226 .331 .669 r
.54164 .46482 m .53561 .47104 L .54263 .49468 L p F P
0 0 0 r
s
.83 .24 .1 r
.53354 .46417 m
.54001 .46651 L
s
.24 .35 .67 r
.53252 .49453 m
.54018 .48675 L
s
.226 .331 .669 r
.54263 .49468 m .54989 .48737 L .54164 .46482 L p F P
0 0 0 r
s
.83 .24 .1 r
.5426 .46744 m
.56677 .47615 L
s
.52187 .48971 m
.53019 .4715 L
s
.53339 .46449 m
.53354 .46417 L
s
.877 .242 .1 r
.51656 .60246 m .53366 .60791 L .53301 .58856 L p F P
0 0 0 r
s
.877 .242 .1 r
.53301 .58856 m .51624 .58313 L .51656 .60246 L p F P
0 0 0 r
s
.83 .24 .1 r
.58027 .45314 m
.59518 .43322 L
s
.977 .277 .116 r
.51157 .49355 m .4995 .48933 L .49943 .51227 L p F P
0 0 0 r
s
.99 .283 .119 r
.4995 .48933 m .51157 .49355 L .50966 .47008 L p F P
0 0 0 r
s
.24 .35 .67 r
.5006 .4869 m
.50101 .48647 L
s
.99 .283 .119 r
.51968 .47365 m .50966 .47008 L .51157 .49355 L p F P
0 0 0 r
s
.24 .35 .67 r
.51485 .47193 m
.52014 .46638 L
s
.912 .254 .105 r
.49929 .57765 m .51624 .58313 L .51556 .56218 L p F P
0 0 0 r
s
.912 .254 .105 r
.51556 .56218 m .49932 .55683 L .49929 .57765 L p F P
0 0 0 r
s
.83 .24 .1 r
.62804 .44558 m
.59518 .43322 L
s
.62804 .44558 m
.64411 .42987 L
s
.60813 .67024 m
.60219 .6507 L
s
.60219 .6507 m
.56907 .64037 L
s
.24 .35 .67 r
.24757 .57919 m
.24202 .6022 L
s
.26305 .55992 m
.24757 .57919 L
s
.52014 .46638 m
.52101 .46546 L
s
.52587 .47221 m
.54018 .48675 L
s
.52014 .46638 m
.52076 .46702 L
s
.34067 .47212 m
.36264 .46595 L
s
.38013 .44471 m
.36264 .46595 L
s
.53057 .66603 m
.51051 .6835 L
s
.51051 .6835 m
.49811 .70163 L
s
.96 .271 .113 r
.48406 .52976 m .49937 .53491 L .49943 .51227 L p F P
0 0 0 r
s
.96 .271 .113 r
.49943 .51227 m .48554 .50751 L .48406 .52976 L p F P
0 0 0 r
s
.977 .277 .116 r
.48554 .50751 m .49943 .51227 L .4995 .48933 L p F P
0 0 0 r
s
.83 .24 .1 r
.5008 .57069 m
.50521 .54388 L
s
1 .287 .121 r
.50966 .47008 m .51968 .47365 L .51532 .44983 L p F P
0 0 0 r
s
.24 .35 .67 r
.49752 .44914 m
.51235 .46045 L
s
.51806 .4648 m
.52014 .46638 L
s
1 .287 .121 r
.52309 .45265 m .51532 .44983 L .51968 .47365 L p F P
0 0 0 r
s
.939 .263 .11 r
.48293 .55142 m .49932 .55683 L .49937 .53491 L p F P
0 0 0 r
s
.939 .263 .11 r
.49937 .53491 m .48406 .52976 L .48293 .55142 L p F P
0 0 0 r
s
.83 .226 .093 r
.53356 .62513 m .55044 .63042 L .55059 .61329 L p F P
0 0 0 r
s
.24 .35 .67 r
.53787 .64475 m
.5395 .62699 L
s
.83 .226 .093 r
.55059 .61329 m .53366 .60791 L .53356 .62513 L p F P
0 0 0 r
s
.113 .157 .348 r
.55059 .61329 m .56099 .60393 L .55981 .58459 L p F P
0 0 0 r
s
.079 .107 .249 r
.56099 .60393 m .55059 .61329 L .55044 .63042 L p F P
0 0 0 r
s
.83 .24 .1 r
.55682 .6144 m
.56675 .61756 L
s
.67658 .4423 m
.64411 .42987 L
s
.67658 .4423 m
.69338 .43152 L
s
.53325 .46407 m
.53354 .46417 L
s
.209 .305 .622 r
.55725 .47997 m .54989 .48737 L .55699 .51007 L p F P
0 0 0 r
s
.24 .35 .67 r
.54018 .48675 m
.55693 .50952 L
s
.53924 .5269 m
.55693 .50952 L
s
.209 .305 .622 r
.55699 .51007 m .56544 .50177 L .55725 .47997 L p F P
0 0 0 r
s
.19 .276 .57 r
.56544 .50177 m .55699 .51007 L .5628 .53252 L p F P
0 0 0 r
s
.977 .277 .116 r
.4995 .48933 m .48734 .48509 L .48554 .50751 L p F P
0 0 0 r
s
.99 .283 .119 r
.48734 .48509 m .4995 .48933 L .49958 .46649 L p F P
0 0 0 r
s
.99 .283 .119 r
.50966 .47008 m .49958 .46649 L .4995 .48933 L p F P
0 0 0 r
s
.144 .204 .437 r
.55981 .58459 m .57018 .57508 L .56723 .55433 L p F P
0 0 0 r
s
.113 .157 .348 r
.57018 .57508 m .55981 .58459 L .56099 .60393 L p F P
0 0 0 r
s
.24 .35 .67 r
.55724 .5783 m
.56044 .60298 L
s
.19 .276 .57 r
.5628 .53252 m .57217 .52354 L .56544 .50177 L p F P
0 0 0 r
s
.169 .243 .509 r
.57217 .52354 m .5628 .53252 L .56723 .55433 L p F P
0 0 0 r
s
.241 .354 .711 r
.53236 .44283 m .52771 .44776 L .53561 .47104 L p F P
0 0 0 r
s
.241 .354 .711 r
.53561 .47104 m .54164 .46482 L .53236 .44283 L p F P
0 0 0 r
s
.83 .24 .1 r
.65054 .6958 m
.64101 .68032 L
s
.64101 .68032 m
.60813 .67024 L
s
.912 .254 .105 r
.48218 .57211 m .49929 .57765 L .49932 .55683 L p F P
0 0 0 r
s
.912 .254 .105 r
.49932 .55683 m .48293 .55142 L .48218 .57211 L p F P
0 0 0 r
s
1 .287 .121 r
.49958 .46649 m .50966 .47008 L .50752 .447 L p F P
0 0 0 r
s
1 .287 .121 r
.51532 .44983 m .50752 .447 L .50966 .47008 L p F P
0 0 0 r
s
.877 .242 .1 r
.49928 .59697 m .51656 .60246 L .51624 .58313 L p F P
0 0 0 r
s
.877 .242 .1 r
.51624 .58313 m .49929 .57765 L .49928 .59697 L p F P
0 0 0 r
s
.83 .24 .1 r
.5008 .57069 m
.53453 .58169 L
s
.226 .331 .669 r
.54773 .45853 m .54164 .46482 L .54989 .48737 L p F P
0 0 0 r
s
.226 .331 .669 r
.54989 .48737 m .55725 .47997 L .54773 .45853 L p F P
0 0 0 r
s
.24 .35 .67 r
.26305 .55992 m
.27371 .53999 L
s
.28972 .51995 m
.27371 .53999 L
s
.44076 .74215 m
.42216 .75839 L
s
.39833 .76276 m
.42216 .75839 L
s
.96 .271 .113 r
.46862 .52457 m .48406 .52976 L .48554 .50751 L p F P
0 0 0 r
s
.96 .271 .113 r
.48554 .50751 m .47154 .50272 L .46862 .52457 L p F P
0 0 0 r
s
.977 .277 .116 r
.47154 .50272 m .48554 .50751 L .48734 .48509 L p F P
0 0 0 r
s
.83 .24 .1 r
.47836 .50494 m
.51233 .51658 L
s
.939 .263 .11 r
.46639 .54597 m .48293 .55142 L .48406 .52976 L p F P
0 0 0 r
s
.939 .263 .11 r
.48406 .52976 m .46862 .52457 L .46639 .54597 L p F P
0 0 0 r
s
.83 .24 .1 r
.47107 .53248 m
.50521 .54388 L
s
.169 .243 .509 r
.56723 .55433 m .5773 .54489 L .57217 .52354 L p F P
0 0 0 r
s
.144 .204 .437 r
.5773 .54489 m .56723 .55433 L .57018 .57508 L p F P
0 0 0 r
s
.24 .35 .67 r
.5492 .55347 m
.56976 .5339 L
s
.83 .226 .093 r
.51651 .61979 m .53356 .62513 L .53366 .60791 L p F P
0 0 0 r
s
.83 .226 .093 r
.53366 .60791 m .51656 .60246 L .51651 .61979 L p F P
0 0 0 r
s
.83 .24 .1 r
.53335 .60692 m
.55132 .61264 L
s
.53335 .60692 m
.53453 .58169 L
s
.977 .277 .116 r
.48734 .48509 m .4751 .48081 L .47154 .50272 L p F P
0 0 0 r
s
.99 .283 .119 r
.4751 .48081 m .48734 .48509 L .48944 .46288 L p F P
0 0 0 r
s
.99 .283 .119 r
.49958 .46649 m .48944 .46288 L .48734 .48509 L p F P
0 0 0 r
s
.83 .24 .1 r
.48799 .4778 m
.52187 .48971 L
s
.7255 .44399 m
.69338 .43152 L
s
.7255 .44399 m
.74249 .43872 L
s
.255 .376 .751 r
.51904 .42527 m .51589 .42869 L .52309 .45265 L p F P
0 0 0 r
s
.255 .376 .751 r
.52309 .45265 m .52771 .44776 L .51904 .42527 L p F P
0 0 0 r
s
1 .291 .123 r
.51532 .44983 m .52309 .45265 L .51589 .42869 L p F P
0 0 0 r
s
.24 .35 .67 r
.38013 .44471 m
.40421 .44384 L
s
.42254 .42208 m
.40421 .44384 L
s
1 .287 .121 r
.48944 .46288 m .49958 .46649 L .49967 .44416 L p F P
0 0 0 r
s
.24 .35 .67 r
.47313 .43566 m
.49708 .4489 L
s
1 .287 .121 r
.50752 .447 m .49967 .44416 L .49958 .46649 L p F P
0 0 0 r
s
.24 .35 .67 r
.44783 .4265 m
.47313 .43566 L
s
.83 .24 .1 r
.47836 .50494 m
.48799 .4778 L
s
.241 .354 .711 r
.53705 .43787 m .53236 .44283 L .54164 .46482 L p F P
0 0 0 r
s
.241 .354 .711 r
.54164 .46482 m .54773 .45853 L .53705 .43787 L p F P
0 0 0 r
s
.83 .24 .1 r
.54255 .4485 m
.54694 .44085 L
s
.54694 .44085 m
.58027 .45314 L
s
.24 .35 .67 r
.28972 .51995 m
.30495 .50405 L
s
.32157 .4833 m
.30495 .50405 L
s
.912 .254 .105 r
.4649 .56651 m .48218 .57211 L .48293 .55142 L p F P
0 0 0 r
s
.912 .254 .105 r
.48293 .55142 m .46639 .54597 L .4649 .56651 L p F P
0 0 0 r
s
.96 .271 .113 r
.45303 .51933 m .46862 .52457 L .47154 .50272 L p F P
0 0 0 r
s
.96 .271 .113 r
.47154 .50272 m .45743 .49788 L .45303 .51933 L p F P
0 0 0 r
s
.83 .24 .1 r
.47107 .53248 m
.47836 .50494 L
s
.977 .277 .116 r
.45743 .49788 m .47154 .50272 L .4751 .48081 L p F P
0 0 0 r
s
1 .291 .123 r
.50752 .447 m .51532 .44983 L .51054 .42672 L p F P
0 0 0 r
s
1 .291 .123 r
.51589 .42869 m .51054 .42672 L .51532 .44983 L p F P
0 0 0 r
s
.877 .242 .1 r
.48183 .59142 m .49928 .59697 L .49929 .57765 L p F P
0 0 0 r
s
.877 .242 .1 r
.49929 .57765 m .48218 .57211 L .48183 .59142 L p F P
0 0 0 r
s
.83 .24 .1 r
.49929 .59608 m
.5008 .57069 L
s
.59518 .43322 m
.56166 .4206 L
s
.59518 .43322 m
.611 .41719 L
s
.57459 .65996 m
.56907 .64037 L
s
.24 .35 .67 r
.48108 .71585 m
.46169 .73262 L
s
.46169 .73262 m
.44076 .74215 L
s
.83 .24 .1 r
.69607 .71638 m
.68318 .70568 L
s
.68318 .70568 m
.65054 .6958 L
s
.209 .305 .622 r
.56469 .47247 m .55725 .47997 L .56544 .50177 L p F P
0 0 0 r
s
.209 .305 .622 r
.56544 .50177 m .57402 .49335 L .56469 .47247 L p F P
0 0 0 r
s
.19 .276 .57 r
.57402 .49335 m .56544 .50177 L .57217 .52354 L p F P
0 0 0 r
s
.24 .35 .67 r
.55693 .50952 m
.56976 .5339 L
s
.977 .277 .116 r
.4751 .48081 m .46277 .4765 L .45743 .49788 L p F P
0 0 0 r
s
.99 .283 .119 r
.46277 .4765 m .4751 .48081 L .47924 .45925 L p F P
0 0 0 r
s
.99 .283 .119 r
.48944 .46288 m .47924 .45925 L .4751 .48081 L p F P
0 0 0 r
s
.113 .157 .348 r
.56099 .60393 m .57157 .5944 L .57018 .57508 L p F P
0 0 0 r
s
.079 .107 .249 r
.57157 .5944 m .56099 .60393 L .56081 .62123 L p F P
0 0 0 r
s
.079 .107 .249 r
.55044 .63042 m .56081 .62123 L .56099 .60393 L p F P
0 0 0 r
s
.24 .35 .67 r
.54941 .61292 m
.56044 .60298 L
s
1 .287 .121 r
.47924 .45925 m .48944 .46288 L .4918 .4413 L p F P
0 0 0 r
s
1 .287 .121 r
.49967 .44416 m .4918 .4413 L .48944 .46288 L p F P
0 0 0 r
s
.83 .24 .1 r
.48799 .4778 m
.49965 .45196 L
s
.49965 .45196 m
.52678 .46174 L
s
.939 .263 .11 r
.44968 .54046 m .46639 .54597 L .46862 .52457 L p F P
0 0 0 r
s
.939 .263 .11 r
.46862 .52457 m .45303 .51933 L .44968 .54046 L p F P
0 0 0 r
s
.226 .331 .669 r
.55388 .45218 m .54773 .45853 L .55725 .47997 L p F P
0 0 0 r
s
.226 .331 .669 r
.55725 .47997 m .56469 .47247 L .55388 .45218 L p F P
0 0 0 r
s
.255 .376 .751 r
.52221 .42183 m .51904 .42527 L .52771 .44776 L p F P
0 0 0 r
s
.255 .376 .751 r
.52771 .44776 m .53236 .44283 L .52221 .42183 L p F P
0 0 0 r
s
.765 .205 .084 r
.53269 .63986 m .54914 .64493 L .55044 .63042 L p F P
0 0 0 r
s
.24 .35 .67 r
.53057 .66603 m
.53787 .64475 L
s
.53787 .64475 m
.54064 .64231 L
s
.765 .205 .084 r
.55044 .63042 m .53356 .62513 L .53269 .63986 L p F P
0 0 0 r
s
.047 .067 .154 r
.56081 .62123 m .55044 .63042 L .54914 .64493 L p F P
0 0 0 r
s
.83 .24 .1 r
.55374 .63559 m
.56907 .64037 L
s
.19 .276 .57 r
.57217 .52354 m .58169 .51442 L .57402 .49335 L p F P
0 0 0 r
s
.169 .243 .509 r
.58169 .51442 m .57217 .52354 L .5773 .54489 L p F P
0 0 0 r
s
.83 .24 .1 r
.46639 .55948 m
.47107 .53248 L
s
1 .291 .123 r
.49967 .44416 m .50752 .447 L .50516 .42474 L p F P
0 0 0 r
s
1 .291 .123 r
.51054 .42672 m .50516 .42474 L .50752 .447 L p F P
0 0 0 r
s
.83 .226 .093 r
.49928 .6144 m .51651 .61979 L .51656 .60246 L p F P
0 0 0 r
s
.83 .226 .093 r
.51656 .60246 m .49928 .59697 L .49928 .6144 L p F P
0 0 0 r
s
.83 .24 .1 r
.49929 .59608 m
.53335 .60692 L
s
.144 .204 .437 r
.57018 .57508 m .58072 .56541 L .5773 .54489 L p F P
0 0 0 r
s
.113 .157 .348 r
.58072 .56541 m .57018 .57508 L .57157 .5944 L p F P
0 0 0 r
s
.24 .35 .67 r
.24202 .6022 m
.25759 .58311 L
s
.24202 .6022 m
.24203 .62739 L
s
.83 .24 .1 r
.64411 .42987 m
.611 .41719 L
s
.64411 .42987 m
.6606 .4188 L
s
.77432 .4512 m
.74249 .43872 L
s
.77432 .4512 m
.79087 .45184 L
s
.24 .35 .67 r
.32157 .4833 m
.34067 .47212 L
s
.35799 .45071 m
.34067 .47212 L
s
.99 .283 .119 r
.47924 .45925 m .46898 .45559 L .46277 .4765 L p F P
0 0 0 r
s
1 .287 .121 r
.46898 .45559 m .47924 .45925 L .48388 .43843 L p F P
0 0 0 r
s
1 .287 .121 r
.4918 .4413 m .48388 .43843 L .47924 .45925 L p F P
0 0 0 r
s
.96 .271 .113 r
.43731 .51404 m .45303 .51933 L .45743 .49788 L p F P
0 0 0 r
s
.96 .271 .113 r
.45743 .49788 m .4432 .493 L .43731 .51404 L p F P
0 0 0 r
s
.977 .277 .116 r
.4432 .493 m .45743 .49788 L .46277 .4765 L p F P
0 0 0 r
s
.83 .24 .1 r
.44372 .49306 m
.47836 .50494 L
s
.977 .277 .116 r
.46277 .4765 m .45036 .47216 L .4432 .493 L p F P
0 0 0 r
s
.99 .283 .119 r
.45036 .47216 m .46277 .4765 L .46898 .45559 L p F P
0 0 0 r
s
.241 .354 .711 r
.54178 .43286 m .53705 .43787 L .54773 .45853 L p F P
0 0 0 r
s
.83 .24 .1 r
.54332 .43952 m
.54694 .44085 L
s
.24 .35 .67 r
.52414 .46218 m
.54035 .44515 L
s
.241 .354 .711 r
.54773 .45853 m .55388 .45218 L .54178 .43286 L p F P
0 0 0 r
s
.912 .254 .105 r
.44745 .56086 m .4649 .56651 L .46639 .54597 L p F P
0 0 0 r
s
.912 .254 .105 r
.46639 .54597 m .44968 .54046 L .44745 .56086 L p F P
0 0 0 r
s
1 .291 .123 r
.4918 .4413 m .49967 .44416 L .49978 .42275 L p F P
0 0 0 r
s
1 .291 .123 r
.50516 .42474 m .49978 .42275 L .49967 .44416 L p F P
0 0 0 r
s
.24 .35 .67 r
.51822 .68424 m
.49811 .70163 L
s
.49811 .70163 m
.48108 .71585 L
s
.83 .24 .1 r
.61723 .68572 m
.60813 .67024 L
s
.60813 .67024 m
.57459 .65996 L
s
.877 .242 .1 r
.4642 .58581 m .48183 .59142 L .48218 .57211 L p F P
0 0 0 r
s
.877 .242 .1 r
.48218 .57211 m .4649 .56651 L .4642 .58581 L p F P
0 0 0 r
s
.83 .24 .1 r
.46639 .55948 m
.5008 .57069 L
s
.169 .243 .509 r
.5773 .54489 m .58754 .53529 L .58169 .51442 L p F P
0 0 0 r
s
.144 .204 .437 r
.58754 .53529 m .5773 .54489 L .58072 .56541 L p F P
0 0 0 r
s
.24 .35 .67 r
.56976 .5339 m
.57812 .559 L
s
.55724 .5783 m
.57812 .559 L
s
.42254 .42208 m
.44783 .4265 L
s
.255 .376 .751 r
.5254 .41836 m .52221 .42183 L .53236 .44283 L p F P
0 0 0 r
s
.83 .24 .1 r
.53002 .43462 m
.53751 .43738 L
s
.255 .376 .751 r
.53236 .44283 m .53705 .43787 L .5254 .41836 L p F P
0 0 0 r
s
.939 .263 .11 r
.43282 .53489 m .44968 .54046 L .45303 .51933 L p F P
0 0 0 r
s
.939 .263 .11 r
.45303 .51933 m .43731 .51404 L .43282 .53489 L p F P
0 0 0 r
s
.24 .35 .67 r
.41672 .74641 m
.39833 .76276 L
s
.37254 .76154 m
.39833 .76276 L
s
.765 .205 .084 r
.51608 .63473 m .53269 .63986 L .53356 .62513 L p F P
0 0 0 r
s
.765 .205 .084 r
.53356 .62513 m .51651 .61979 L .51608 .63473 L p F P
0 0 0 r
s
.83 .24 .1 r
.53335 .60692 m
.53529 .62983 L
s
1 .291 .123 r
.48388 .43843 m .4918 .4413 L .49437 .42076 L p F P
0 0 0 r
s
1 .291 .123 r
.49978 .42275 m .49437 .42076 L .4918 .4413 L p F P
0 0 0 r
s
.99 .283 .119 r
.46898 .45559 m .45866 .45192 L .45036 .47216 L p F P
0 0 0 r
s
1 .287 .121 r
.45866 .45192 m .46898 .45559 L .47593 .43555 L p F P
0 0 0 r
s
1 .287 .121 r
.48388 .43843 m .47593 .43555 L .46898 .45559 L p F P
0 0 0 r
s
.83 .226 .093 r
.48188 .60895 m .49928 .6144 L .49928 .59697 L p F P
0 0 0 r
s
.83 .226 .093 r
.49928 .59697 m .48183 .59142 L .48188 .60895 L p F P
0 0 0 r
s
.83 .24 .1 r
.69338 .43152 m
.6606 .4188 L
s
.69338 .43152 m
.71001 .42599 L
s
.226 .331 .669 r
.56009 .44577 m .55388 .45218 L .56469 .47247 L p F P
0 0 0 r
s
.226 .331 .669 r
.56469 .47247 m .57223 .46489 L .56009 .44577 L p F P
0 0 0 r
s
.24 .35 .67 r
.54018 .48675 m
.56076 .46586 L
s
.209 .305 .622 r
.57223 .46489 m .56469 .47247 L .57402 .49335 L p F P
0 0 0 r
s
.209 .305 .622 r
.57402 .49335 m .58272 .48481 L .57223 .46489 L p F P
0 0 0 r
s
.19 .276 .57 r
.58272 .48481 m .57402 .49335 L .58169 .51442 L p F P
0 0 0 r
s
.24 .35 .67 r
.55693 .50952 m
.57787 .48896 L
s
.977 .277 .116 r
.42885 .48808 m .4432 .493 L .45036 .47216 L p F P
0 0 0 r
s
.977 .277 .116 r
.45036 .47216 m .43785 .46779 L .42885 .48808 L p F P
0 0 0 r
s
.99 .283 .119 r
.43785 .46779 m .45036 .47216 L .45866 .45192 L p F P
0 0 0 r
s
.83 .24 .1 r
.45344 .46565 m
.48799 .4778 L
s
.96 .271 .113 r
.42144 .50871 m .43731 .51404 L .4432 .493 L p F P
0 0 0 r
s
.96 .271 .113 r
.4432 .493 m .42885 .48808 L .42144 .50871 L p F P
0 0 0 r
s
.24 .35 .67 r
.25759 .58311 m
.26305 .55992 L
s
.27909 .53997 m
.26305 .55992 L
s
.54035 .44515 m
.56076 .46586 L
s
.269 .398 .788 r
.50975 .40402 m .50815 .4058 L .51589 .42869 L p F P
0 0 0 r
s
.269 .398 .788 r
.51589 .42869 m .51904 .42527 L .50975 .40402 L p F P
0 0 0 r
s
1 .293 .125 r
.51054 .42672 m .51589 .42869 L .50815 .4058 L p F P
0 0 0 r
s
.83 .24 .1 r
.49965 .45196 m
.51295 .42832 L
s
.51295 .42832 m
.5189 .43051 L
s
.24 .35 .67 r
.51389 .43136 m
.51739 .42756 L
s
.35799 .45071 m
.38013 .44471 L
s
.83 .24 .1 r
.44372 .49306 m
.45344 .46565 L
s
.24 .35 .67 r
.53057 .66603 m
.51822 .68424 L
s
.56076 .46586 m
.57787 .48896 L
s
1 .291 .123 r
.47593 .43555 m .48388 .43843 L .48895 .41876 L p F P
0 0 0 r
s
1 .291 .123 r
.49437 .42076 m .48895 .41876 L .48388 .43843 L p F P
0 0 0 r
s
.912 .254 .105 r
.42981 .55515 m .44745 .56086 L .44968 .54046 L p F P
0 0 0 r
s
.912 .254 .105 r
.44968 .54046 m .43282 .53489 L .42981 .55515 L p F P
0 0 0 r
s
.255 .376 .751 r
.5286 .41488 m .5254 .41836 L .53705 .43787 L p F P
0 0 0 r
s
.255 .376 .751 r
.53705 .43787 m .54178 .43286 L .5286 .41488 L p F P
0 0 0 r
s
.24 .35 .67 r
.51739 .42756 m
.54035 .44515 L
s
.241 .354 .711 r
.54654 .42781 m .54178 .43286 L .55388 .45218 L p F P
0 0 0 r
s
.241 .354 .711 r
.55388 .45218 m .56009 .44577 L .54654 .42781 L p F P
0 0 0 r
s
.83 .24 .1 r
.55158 .43448 m
.56166 .4206 L
s
.113 .157 .348 r
.57157 .5944 m .58234 .5847 L .58072 .56541 L p F P
0 0 0 r
s
.079 .107 .249 r
.58234 .5847 m .57157 .5944 L .57136 .61188 L p F P
0 0 0 r
s
.079 .107 .249 r
.56081 .62123 m .57136 .61188 L .57157 .5944 L p F P
0 0 0 r
s
.19 .276 .57 r
.58169 .51442 m .59135 .50516 L .58272 .48481 L p F P
0 0 0 r
s
.169 .243 .509 r
.59135 .50516 m .58169 .51442 L .58754 .53529 L p F P
0 0 0 r
s
.99 .283 .119 r
.45866 .45192 m .44827 .44822 L .43785 .46779 L p F P
0 0 0 r
s
1 .287 .121 r
.44827 .44822 m .45866 .45192 L .46794 .43265 L p F P
0 0 0 r
s
1 .287 .121 r
.47593 .43555 m .46794 .43265 L .45866 .45192 L p F P
0 0 0 r
s
.877 .242 .1 r
.44639 .58014 m .4642 .58581 L .4649 .56651 L p F P
0 0 0 r
s
.877 .242 .1 r
.4649 .56651 m .44745 .56086 L .44639 .58014 L p F P
0 0 0 r
s
.83 .24 .1 r
.46453 .58501 m
.46639 .55948 L
s
1 .293 .125 r
.50516 .42474 m .51054 .42672 L .5054 .40477 L p F P
0 0 0 r
s
1 .293 .125 r
.50815 .4058 m .5054 .40477 L .51054 .42672 L p F P
0 0 0 r
s
.939 .263 .11 r
.41578 .52928 m .43282 .53489 L .43731 .51404 L p F P
0 0 0 r
s
.939 .263 .11 r
.43731 .51404 m .42144 .50871 L .41578 .52928 L p F P
0 0 0 r
s
.83 .24 .1 r
.43625 .52084 m
.47107 .53248 L
s
.43625 .52084 m
.44372 .49306 L
s
.047 .067 .154 r
.57136 .61188 m .56081 .62123 L .55923 .63611 L p F P
0 0 0 r
s
.047 .067 .154 r
.54914 .64493 m .55923 .63611 L .56081 .62123 L p F P
0 0 0 r
s
.24 .35 .67 r
.5585 .62652 m
.56044 .60298 L
s
.83 .24 .1 r
.53529 .62983 m
.55057 .6346 L
s
.24 .35 .67 r
.54913 .6348 m
.5585 .62652 L
s
.83 .24 .1 r
.663 .70644 m
.65054 .6958 L
s
.65054 .6958 m
.61723 .68572 L
s
.144 .204 .437 r
.58072 .56541 m .59145 .55556 L .58754 .53529 L p F P
0 0 0 r
s
.113 .157 .348 r
.59145 .55556 m .58072 .56541 L .58234 .5847 L p F P
0 0 0 r
s
.24 .35 .67 r
.57812 .559 m
.58158 .58391 L
s
.269 .398 .788 r
.51136 .40223 m .50975 .40402 L .51904 .42527 L p F P
0 0 0 r
s
.269 .398 .788 r
.51904 .42527 m .52221 .42183 L .51136 .40223 L p F P
0 0 0 r
s
.83 .24 .1 r
.51295 .42832 m
.51824 .42082 L
s
.24 .35 .67 r
.50835 .42251 m
.51739 .42756 L
s
1 .291 .123 r
.46794 .43265 m .47593 .43555 L .48351 .41675 L p F P
0 0 0 r
s
1 .291 .123 r
.48895 .41876 m .48351 .41675 L .47593 .43555 L p F P
0 0 0 r
s
.24 .35 .67 r
.48838 .41855 m
.49137 .4152 L
s
.977 .277 .116 r
.41439 .48312 m .42885 .48808 L .43785 .46779 L p F P
0 0 0 r
s
.977 .277 .116 r
.43785 .46779 m .42526 .46339 L .41439 .48312 L p F P
0 0 0 r
s
.99 .283 .119 r
.42526 .46339 m .43785 .46779 L .44827 .44822 L p F P
0 0 0 r
s
1 .293 .125 r
.49978 .42275 m .50516 .42474 L .50264 .40374 L p F P
0 0 0 r
s
1 .293 .125 r
.5054 .40477 m .50264 .40374 L .50516 .42474 L p F P
0 0 0 r
s
.765 .205 .084 r
.4993 .62955 m .51608 .63473 L .51651 .61979 L p F P
0 0 0 r
s
.765 .205 .084 r
.51651 .61979 m .49928 .6144 L .4993 .62955 L p F P
0 0 0 r
s
.83 .24 .1 r
.50082 .61908 m
.53529 .62983 L
s
.96 .271 .113 r
.40543 .50333 m .42144 .50871 L .42885 .48808 L p F P
0 0 0 r
s
.96 .271 .113 r
.42885 .48808 m .41439 .48312 L .40543 .50333 L p F P
0 0 0 r
s
.83 .226 .093 r
.46431 .60345 m .48188 .60895 L .48183 .59142 L p F P
0 0 0 r
s
.83 .226 .093 r
.48183 .59142 m .4642 .58581 L .46431 .60345 L p F P
0 0 0 r
s
.83 .24 .1 r
.46453 .58501 m
.49929 .59608 L
s
.24 .35 .67 r
.24203 .62739 m
.24777 .65357 L
s
.25776 .60854 m
.24203 .62739 L
s
.27909 .53997 m
.28972 .51995 L
s
.3063 .4992 m
.28972 .51995 L
s
.46001 .72534 m
.44076 .74215 L
s
.44076 .74215 m
.41672 .74641 L
s
.99 .283 .119 r
.44827 .44822 m .43783 .4445 L .42526 .46339 L p F P
0 0 0 r
s
1 .287 .121 r
.43783 .4445 m .44827 .44822 L .45992 .42974 L p F P
0 0 0 r
s
1 .287 .121 r
.46794 .43265 m .45992 .42974 L .44827 .44822 L p F P
0 0 0 r
s
.83 .24 .1 r
.45344 .46565 m
.46507 .4395 L
s
.46507 .4395 m
.49965 .45196 L
s
.611 .41719 m
.57721 .40425 L
s
.611 .41719 m
.62716 .40581 L
s
1 .293 .125 r
.49437 .42076 m .49978 .42275 L .49989 .40271 L p F P
0 0 0 r
s
1 .293 .125 r
.50264 .40374 m .49989 .40271 L .49978 .42275 L p F P
0 0 0 r
s
.67 .175 .071 r
.53104 .65171 m .54667 .65648 L .54914 .64493 L p F P
0 0 0 r
s
.24 .35 .67 r
.53057 .66603 m
.54286 .65532 L
s
.67 .175 .071 r
.54914 .64493 m .53269 .63986 L .53104 .65171 L p F P
0 0 0 r
s
.83 .24 .1 r
.53529 .62983 m
.54037 .64947 L
s
.024 .036 .069 r
.55923 .63611 m .54914 .64493 L .54667 .65648 L p F P
0 0 0 r
s
.255 .376 .751 r
.53182 .41138 m .5286 .41488 L .54178 .43286 L p F P
0 0 0 r
s
.255 .376 .751 r
.54178 .43286 m .54654 .42781 L .53182 .41138 L p F P
0 0 0 r
s
.83 .24 .1 r
.74249 .43872 m
.71001 .42599 L
s
.74249 .43872 m
.75866 .43916 L
s
1 .291 .123 r
.45992 .42974 m .46794 .43265 L .47805 .41474 L p F P
0 0 0 r
s
1 .291 .123 r
.48351 .41675 m .47805 .41474 L .46794 .43265 L p F P
0 0 0 r
s
.169 .243 .509 r
.58754 .53529 m .59796 .52554 L .59135 .50516 L p F P
0 0 0 r
s
.144 .204 .437 r
.59796 .52554 m .58754 .53529 L .59145 .55556 L p F P
0 0 0 r
s
.24 .35 .67 r
.56976 .5339 m
.59104 .51364 L
s
.269 .398 .788 r
.51297 .40043 m .51136 .40223 L .52221 .42183 L p F P
0 0 0 r
s
.269 .398 .788 r
.52221 .42183 m .5254 .41836 L .51297 .40043 L p F P
0 0 0 r
s
.226 .331 .669 r
.56637 .43928 m .56009 .44577 L .57223 .46489 L p F P
0 0 0 r
s
.226 .331 .669 r
.57223 .46489 m .57986 .45721 L .56637 .43928 L p F P
0 0 0 r
s
.209 .305 .622 r
.57986 .45721 m .57223 .46489 L .58272 .48481 L p F P
0 0 0 r
s
.912 .254 .105 r
.412 .54939 m .42981 .55515 L .43282 .53489 L p F P
0 0 0 r
s
.912 .254 .105 r
.43282 .53489 m .41578 .52928 L .412 .54939 L p F P
0 0 0 r
s
.83 .24 .1 r
.43129 .54804 m
.43625 .52084 L
s
.939 .263 .11 r
.39859 .5236 m .41578 .52928 L .42144 .50871 L p F P
0 0 0 r
s
.939 .263 .11 r
.42144 .50871 m .40543 .50333 L .39859 .5236 L p F P
0 0 0 r
s
1 .293 .125 r
.48895 .41876 m .49437 .42076 L .49712 .40167 L p F P
0 0 0 r
s
1 .293 .125 r
.49989 .40271 m .49712 .40167 L .49437 .42076 L p F P
0 0 0 r
s
.83 .24 .1 r
.58323 .67543 m
.57459 .65996 L
s
.241 .354 .711 r
.55135 .42272 m .54654 .42781 L .56009 .44577 L p F P
0 0 0 r
s
.241 .354 .711 r
.56009 .44577 m .56637 .43928 L .55135 .42272 L p F P
0 0 0 r
s
.209 .305 .622 r
.58272 .48481 m .59154 .47615 L .57986 .45721 L p F P
0 0 0 r
s
.19 .276 .57 r
.59154 .47615 m .58272 .48481 L .59135 .50516 L p F P
0 0 0 r
s
.24 .35 .67 r
.57787 .48896 m
.59104 .51364 L
s
.877 .242 .1 r
.42839 .57442 m .44639 .58014 L .44745 .56086 L p F P
0 0 0 r
s
.877 .242 .1 r
.44745 .56086 m .42981 .55515 L .42839 .57442 L p F P
0 0 0 r
s
.83 .24 .1 r
.43129 .54804 m
.46639 .55948 L
s
.977 .277 .116 r
.3998 .47813 m .41439 .48312 L .42526 .46339 L p F P
0 0 0 r
s
.977 .277 .116 r
.42526 .46339 m .41257 .45896 L .3998 .47813 L p F P
0 0 0 r
s
.99 .283 .119 r
.41257 .45896 m .42526 .46339 L .43783 .4445 L p F P
0 0 0 r
s
.99 .283 .119 r
.43783 .4445 m .42732 .44076 L .41257 .45896 L p F P
0 0 0 r
s
1 .287 .121 r
.42732 .44076 m .43783 .4445 L .45186 .42682 L p F P
0 0 0 r
s
1 .287 .121 r
.45992 .42974 m .45186 .42682 L .43783 .4445 L p F P
0 0 0 r
s
1 .291 .123 r
.45186 .42682 m .45992 .42974 L .47258 .41272 L p F P
0 0 0 r
s
1 .291 .123 r
.47805 .41474 m .47258 .41272 L .45992 .42974 L p F P
0 0 0 r
s
.24 .35 .67 r
.39065 .74501 m
.37254 .76154 L
s
.34603 .75463 m
.37254 .76154 L
s
.96 .271 .113 r
.38928 .49789 m .40543 .50333 L .41439 .48312 L p F P
0 0 0 r
s
.96 .271 .113 r
.41439 .48312 m .3998 .47813 L .38928 .49789 L p F P
0 0 0 r
s
.83 .24 .1 r
.40838 .48095 m
.44372 .49306 L
s
1 .293 .125 r
.48351 .41675 m .48895 .41876 L .49435 .40063 L p F P
0 0 0 r
s
.24 .35 .67 r
.49067 .413 m
.49155 .41333 L
s
1 .293 .125 r
.49712 .40167 m .49435 .40063 L .48895 .41876 L p F P
0 0 0 r
s
.269 .398 .788 r
.51459 .39863 m .51297 .40043 L .5254 .41836 L p F P
0 0 0 r
s
.269 .398 .788 r
.5254 .41836 m .5286 .41488 L .51459 .39863 L p F P
0 0 0 r
s
.765 .205 .084 r
.48236 .62432 m .4993 .62955 L .49928 .6144 L p F P
0 0 0 r
s
.83 .24 .1 r
.49929 .59608 m
.50082 .61908 L
s
.765 .205 .084 r
.49928 .6144 m .48188 .60895 L .48236 .62432 L p F P
0 0 0 r
s
.24 .35 .67 r
.3063 .4992 m
.32157 .4833 L
s
.83 .24 .1 r
.71151 .72158 m
.69607 .71638 L
s
.69607 .71638 m
.663 .70644 L
s
.83 .226 .093 r
.44655 .59789 m .46431 .60345 L .4642 .58581 L p F P
0 0 0 r
s
.83 .226 .093 r
.4642 .58581 m .44639 .58014 L .44655 .59789 L p F P
0 0 0 r
s
.255 .376 .751 r
.53506 .40786 m .53182 .41138 L .54654 .42781 L p F P
0 0 0 r
s
.83 .24 .1 r
.53707 .41135 m
.56166 .4206 L
s
.255 .376 .751 r
.54654 .42781 m .55135 .42272 L .53506 .40786 L p F P
0 0 0 r
s
.83 .24 .1 r
.6606 .4188 m
.62716 .40581 L
s
.6606 .4188 m
.67687 .41301 L
s
.19 .276 .57 r
.59135 .50516 m .60117 .49575 L .59154 .47615 L p F P
0 0 0 r
s
.169 .243 .509 r
.60117 .49575 m .59135 .50516 L .59796 .52554 L p F P
0 0 0 r
s
.24 .35 .67 r
.50115 .69848 m
.48108 .71585 L
s
.48108 .71585 m
.46001 .72534 L
s
1 .293 .125 r
.47805 .41474 m .48351 .41675 L .49158 .3996 L p F P
0 0 0 r
s
.24 .35 .67 r
.48608 .4113 m
.48696 .41163 L
s
1 .293 .125 r
.49435 .40063 m .49158 .3996 L .48351 .41675 L p F P
0 0 0 r
s
.83 .24 .1 r
.47826 .41553 m
.51295 .42832 L
s
.67 .175 .071 r
.51526 .6469 m .53104 .65171 L .53269 .63986 L p F P
0 0 0 r
s
.67 .175 .071 r
.53269 .63986 m .51608 .63473 L .51526 .6469 L p F P
0 0 0 r
s
1 .287 .121 r
.45186 .42682 m .44376 .42388 L .42732 .44076 L p F P
0 0 0 r
s
1 .291 .123 r
.44376 .42388 m .45186 .42682 L .46709 .41069 L p F P
0 0 0 r
s
1 .291 .123 r
.47258 .41272 m .46709 .41069 L .45186 .42682 L p F P
0 0 0 r
s
.83 .24 .1 r
.46507 .4395 m
.47826 .41553 L
s
.113 .157 .348 r
.58234 .5847 m .5933 .57483 L .59145 .55556 L p F P
0 0 0 r
s
.079 .107 .249 r
.5933 .57483 m .58234 .5847 L .58209 .60236 L p F P
0 0 0 r
s
.079 .107 .249 r
.57136 .61188 m .58209 .60236 L .58234 .5847 L p F P
0 0 0 r
s
.977 .277 .116 r
.3851 .47308 m .3998 .47813 L .41257 .45896 L p F P
0 0 0 r
s
.977 .277 .116 r
.41257 .45896 m .39979 .45449 L .3851 .47308 L p F P
0 0 0 r
s
.99 .283 .119 r
.39979 .45449 m .41257 .45896 L .42732 .44076 L p F P
0 0 0 r
s
.99 .283 .119 r
.42732 .44076 m .41674 .43699 L .39979 .45449 L p F P
0 0 0 r
s
.83 .24 .1 r
.41818 .45325 m
.45344 .46565 L
s
1 .287 .121 r
.41674 .43699 m .42732 .44076 L .44376 .42388 L p F P
0 0 0 r
s
.83 .24 .1 r
.40838 .48095 m
.41818 .45325 L
s
.047 .067 .154 r
.58209 .60236 m .57136 .61188 L .56948 .62713 L p F P
0 0 0 r
s
.24 .35 .67 r
.56044 .60298 m
.58158 .58391 L
s
.047 .067 .154 r
.55923 .63611 m .56948 .62713 L .57136 .61188 L p F P
0 0 0 r
s
.912 .254 .105 r
.39401 .54356 m .412 .54939 L .41578 .52928 L p F P
0 0 0 r
s
.912 .254 .105 r
.41578 .52928 m .39859 .5236 L .39401 .54356 L p F P
0 0 0 r
s
.939 .263 .11 r
.38122 .51788 m .39859 .5236 L .40543 .50333 L p F P
0 0 0 r
s
.939 .263 .11 r
.40543 .50333 m .38928 .49789 L .38122 .51788 L p F P
0 0 0 r
s
.83 .24 .1 r
.40071 .50897 m
.43625 .52084 L
s
.40071 .50897 m
.40838 .48095 L
s
.269 .398 .788 r
.51621 .39682 m .51459 .39863 L .5286 .41488 L p F P
0 0 0 r
s
.269 .398 .788 r
.5286 .41488 m .53182 .41138 L .51621 .39682 L p F P
0 0 0 r
s
.83 .24 .1 r
.52822 .40802 m
.5332 .40989 L
s
1 .293 .125 r
.47258 .41272 m .47805 .41474 L .48881 .39856 L p F P
0 0 0 r
s
.24 .35 .67 r
.48147 .40959 m
.48236 .40992 L
s
1 .293 .125 r
.49158 .3996 m .48881 .39856 L .47805 .41474 L p F P
0 0 0 r
s
.144 .204 .437 r
.59145 .55556 m .60237 .54555 L .59796 .52554 L p F P
0 0 0 r
s
.113 .157 .348 r
.60237 .54555 m .59145 .55556 L .5933 .57483 L p F P
0 0 0 r
s
.24 .35 .67 r
.25759 .58311 m
.27372 .56333 L
s
.25776 .60854 m
.25759 .58311 L
s
.241 .354 .711 r
.55619 .4176 m .55135 .42272 L .56637 .43928 L p F P
0 0 0 r
s
.241 .354 .711 r
.56637 .43928 m .57272 .43273 L .55619 .4176 L p F P
0 0 0 r
s
.83 .24 .1 r
.56166 .4206 m
.57721 .40425 L
s
.226 .331 .669 r
.57272 .43273 m .56637 .43928 L .57986 .45721 L p F P
0 0 0 r
s
.877 .242 .1 r
.41021 .56863 m .42839 .57442 L .42981 .55515 L p F P
0 0 0 r
s
.877 .242 .1 r
.42981 .55515 m .412 .54939 L .41021 .56863 L p F P
0 0 0 r
s
.83 .24 .1 r
.42906 .57372 m
.43129 .54804 L
s
.226 .331 .669 r
.57986 .45721 m .58759 .44943 L .57272 .43273 L p F P
0 0 0 r
s
.209 .305 .622 r
.58759 .44943 m .57986 .45721 L .59154 .47615 L p F P
0 0 0 r
s
.96 .271 .113 r
.37297 .49241 m .38928 .49789 L .3998 .47813 L p F P
0 0 0 r
s
.96 .271 .113 r
.3998 .47813 m .3851 .47308 L .37297 .49241 L p F P
0 0 0 r
s
.83 .24 .1 r
.79087 .45184 m
.75866 .43916 L
s
.79087 .45184 m
.80587 .4584 L
s
.62925 .69629 m
.61723 .68572 L
s
.61723 .68572 m
.58323 .67543 L
s
1 .287 .121 r
.44376 .42388 m .43562 .42093 L .41674 .43699 L p F P
0 0 0 r
s
1 .291 .123 r
.43562 .42093 m .44376 .42388 L .46158 .40866 L p F P
0 0 0 r
s
1 .291 .123 r
.46709 .41069 m .46158 .40866 L .44376 .42388 L p F P
0 0 0 r
s
.24 .35 .67 r
.46285 .40913 m
.46579 .40573 L
s
.24777 .65357 m
.25909 .67945 L
s
.26374 .63504 m
.24777 .65357 L
s
1 .293 .125 r
.46709 .41069 m .47258 .41272 L .48603 .39751 L p F P
0 0 0 r
s
.24 .35 .67 r
.47686 .40788 m
.47775 .40821 L
s
1 .293 .125 r
.48881 .39856 m .48603 .39751 L .47258 .41272 L p F P
0 0 0 r
s
.282 .418 .823 r
.50815 .4058 m .50975 .40402 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .294 .125 r
.5 .38446 m .5054 .40477 L .50815 .4058 L closepath p F P
0 0 0 r
s
.255 .376 .751 r
.53832 .40433 m .53506 .40786 L .55135 .42272 L p F P
0 0 0 r
s
.255 .376 .751 r
.55135 .42272 m .55619 .4176 L .53832 .40433 L p F P
0 0 0 r
s
.024 .036 .069 r
.56948 .62713 m .55923 .63611 L .55623 .64819 L p F P
0 0 0 r
s
.024 .036 .069 r
.54667 .65648 m .55623 .64819 L .55923 .63611 L p F P
0 0 0 r
s
.24 .35 .67 r
.55134 .64794 m
.5585 .62652 L
s
.83 .24 .1 r
.551 .65273 m
.57459 .65996 L
s
.54037 .64947 m
.54814 .65185 L
s
.24 .35 .67 r
.5466 .65206 m
.55134 .64794 L
s
.765 .205 .084 r
.46525 .61904 m .48236 .62432 L .48188 .60895 L p F P
0 0 0 r
s
.765 .205 .084 r
.48188 .60895 m .46431 .60345 L .46525 .61904 L p F P
0 0 0 r
s
.83 .24 .1 r
.46564 .60811 m
.50082 .61908 L
s
.99 .283 .119 r
.38692 .44999 m .39979 .45449 L .41674 .43699 L p F P
0 0 0 r
s
.99 .283 .119 r
.41674 .43699 m .40611 .4332 L .38692 .44999 L p F P
0 0 0 r
s
1 .287 .121 r
.40611 .4332 m .41674 .43699 L .43562 .42093 L p F P
0 0 0 r
s
.209 .305 .622 r
.59154 .47615 m .60049 .46737 L .58759 .44943 L p F P
0 0 0 r
s
.19 .276 .57 r
.60049 .46737 m .59154 .47615 L .60117 .49575 L p F P
0 0 0 r
s
.24 .35 .67 r
.57787 .48896 m
.59955 .46767 L
s
.269 .398 .788 r
.51784 .39501 m .51621 .39682 L .53182 .41138 L p F P
0 0 0 r
s
.269 .398 .788 r
.53182 .41138 m .53506 .40786 L .51784 .39501 L p F P
0 0 0 r
s
.24 .35 .67 r
.53904 .66623 m
.51822 .68424 L
s
.51822 .68424 m
.50115 .69848 L
s
1 .294 .125 r
.5 .38446 m .50264 .40374 L .5054 .40477 L closepath p F P
0 0 0 r
s
.169 .243 .509 r
.59796 .52554 m .60855 .51561 L .60117 .49575 L p F P
0 0 0 r
s
.144 .204 .437 r
.60855 .51561 m .59796 .52554 L .60237 .54555 L p F P
0 0 0 r
s
.24 .35 .67 r
.59104 .51364 m
.59972 .53902 L
s
.57812 .559 m
.59972 .53902 L
s
.977 .277 .116 r
.37027 .468 m .3851 .47308 L .39979 .45449 L p F P
0 0 0 r
s
.977 .277 .116 r
.39979 .45449 m .38692 .44999 L .37027 .468 L p F P
0 0 0 r
s
.83 .226 .093 r
.42862 .59227 m .44655 .59789 L .44639 .58014 L p F P
0 0 0 r
s
.83 .226 .093 r
.44639 .58014 m .42839 .57442 L .42862 .59227 L p F P
0 0 0 r
s
.83 .24 .1 r
.42906 .57372 m
.46453 .58501 L
s
1 .293 .125 r
.46158 .40866 m .46709 .41069 L .48324 .39647 L p F P
0 0 0 r
s
.24 .35 .67 r
.47223 .40617 m
.47312 .4065 L
s
.46579 .40573 m
.46707 .40425 L
s
1 .293 .125 r
.48603 .39751 m .48324 .39647 L .46709 .41069 L p F P
0 0 0 r
s
.24 .35 .67 r
.46707 .40425 m
.46848 .40478 L
s
.282 .418 .823 r
.50975 .40402 m .51136 .40223 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .294 .125 r
.5 .38446 m .49989 .40271 L .50264 .40374 L closepath p F P
0 0 0 r
s
1 .287 .121 r
.43562 .42093 m .42745 .41797 L .40611 .4332 L p F P
0 0 0 r
s
.83 .24 .1 r
.41818 .45325 m
.4298 .42679 L
s
.4298 .42679 m
.46507 .4395 L
s
1 .291 .123 r
.42745 .41797 m .43562 .42093 L .45606 .40662 L p F P
0 0 0 r
s
1 .291 .123 r
.46158 .40866 m .45606 .40662 L .43562 .42093 L p F P
0 0 0 r
s
.67 .175 .071 r
.49934 .64204 m .51526 .6469 L .51608 .63473 L p F P
0 0 0 r
s
.67 .175 .071 r
.51608 .63473 m .4993 .62955 L .49934 .64204 L p F P
0 0 0 r
s
.83 .24 .1 r
.50082 .61908 m
.50544 .63876 L
s
.24 .35 .67 r
.36381 .73785 m
.34603 .75463 L
s
.32014 .74226 m
.34603 .75463 L
s
.83 .24 .1 r
.71001 .42599 m
.67687 .41301 L
s
.71001 .42599 m
.72579 .42621 L
s
.939 .263 .11 r
.36368 .51209 m .38122 .51788 L .38928 .49789 L p F P
0 0 0 r
s
.939 .263 .11 r
.38928 .49789 m .37297 .49241 L .36368 .51209 L p F P
0 0 0 r
s
1 .294 .125 r
.5 .38446 m .49712 .40167 L .49989 .40271 L closepath p F P
0 0 0 r
s
.912 .254 .105 r
.37583 .53768 m .39401 .54356 L .39859 .5236 L p F P
0 0 0 r
s
.912 .254 .105 r
.39859 .5236 m .38122 .51788 L .37583 .53768 L p F P
0 0 0 r
s
.83 .24 .1 r
.39547 .53636 m
.40071 .50897 L
s
.24 .35 .67 r
.43577 .72948 m
.41672 .74641 L
s
.41672 .74641 m
.39065 .74501 L
s
.282 .418 .823 r
.51136 .40223 m .51297 .40043 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .293 .125 r
.45606 .40662 m .46158 .40866 L .48045 .39542 L p F P
0 0 0 r
s
1 .293 .125 r
.48324 .39647 m .48045 .39542 L .46158 .40866 L p F P
0 0 0 r
s
.96 .271 .113 r
.35652 .48688 m .37297 .49241 L .3851 .47308 L p F P
0 0 0 r
s
.96 .271 .113 r
.3851 .47308 m .37027 .468 L .35652 .48688 L p F P
0 0 0 r
s
.83 .24 .1 r
.37231 .46858 m
.40838 .48095 L
s
1 .294 .125 r
.5 .38446 m .49435 .40063 L .49712 .40167 L closepath p F P
0 0 0 r
s
.269 .398 .788 r
.51947 .3932 m .51784 .39501 L .53506 .40786 L p F P
0 0 0 r
s
.269 .398 .788 r
.53506 .40786 m .53832 .40433 L .51947 .3932 L p F P
0 0 0 r
s
.24 .35 .67 r
.51739 .42756 m
.53796 .40522 L
s
.99 .283 .119 r
.37395 .44546 m .38692 .44999 L .40611 .4332 L p F P
0 0 0 r
s
.99 .283 .119 r
.40611 .4332 m .39541 .42939 L .37395 .44546 L p F P
0 0 0 r
s
1 .287 .121 r
.39541 .42939 m .40611 .4332 L .42745 .41797 L p F P
0 0 0 r
s
.877 .242 .1 r
.39184 .56279 m .41021 .56863 L .412 .54939 L p F P
0 0 0 r
s
.877 .242 .1 r
.412 .54939 m .39401 .54356 L .39184 .56279 L p F P
0 0 0 r
s
.83 .24 .1 r
.39547 .53636 m
.43129 .54804 L
s
.241 .354 .711 r
.56107 .41243 m .55619 .4176 L .57272 .43273 L p F P
0 0 0 r
s
.241 .354 .711 r
.57272 .43273 m .57913 .42611 L .56107 .41243 L p F P
0 0 0 r
s
.24 .35 .67 r
.54035 .44515 m
.56129 .42317 L
s
.226 .331 .669 r
.57913 .42611 m .57272 .43273 L .58759 .44943 L p F P
0 0 0 r
s
1 .287 .121 r
.42745 .41797 m .41923 .41499 L .39541 .42939 L p F P
0 0 0 r
s
.24 .35 .67 r
.39824 .42271 m
.40683 .42249 L
s
.38844 .43461 m
.39824 .42271 L
s
1 .291 .123 r
.41923 .41499 m .42745 .41797 L .45051 .40458 L p F P
0 0 0 r
s
1 .291 .123 r
.45606 .40662 m .45051 .40458 L .42745 .41797 L p F P
0 0 0 r
s
.24 .35 .67 r
.43212 .4107 m
.4355 .40669 L
s
1 .294 .125 r
.5 .38446 m .49158 .3996 L .49435 .40063 L closepath p F P
0 0 0 r
s
.282 .418 .823 r
.51297 .40043 m .51459 .39863 L .5 .38446 L closepath p F P
0 0 0 r
s
.19 .276 .57 r
.60117 .49575 m .61115 .48619 L .60049 .46737 L p F P
0 0 0 r
s
.169 .243 .509 r
.61115 .48619 m .60117 .49575 L .60855 .51561 L p F P
0 0 0 r
s
.255 .376 .751 r
.5416 .40077 m .53832 .40433 L .55619 .4176 L p F P
0 0 0 r
s
.255 .376 .751 r
.55619 .4176 m .56107 .41243 L .5416 .40077 L p F P
0 0 0 r
s
.24 .35 .67 r
.27372 .56333 m
.27909 .53997 L
s
.29569 .51931 m
.27909 .53997 L
s
1 .293 .125 r
.45051 .40458 m .45606 .40662 L .47766 .39438 L p F P
0 0 0 r
s
.24 .35 .67 r
.46192 .4033 m
.4629 .40348 L
s
1 .293 .125 r
.48045 .39542 m .47766 .39438 L .45606 .40662 L p F P
0 0 0 r
s
.24 .35 .67 r
.53796 .40522 m
.56129 .42317 L
s
.977 .277 .116 r
.35532 .46288 m .37027 .468 L .38692 .44999 L p F P
0 0 0 r
s
.977 .277 .116 r
.38692 .44999 m .37395 .44546 L .35532 .46288 L p F P
0 0 0 r
s
1 .294 .125 r
.5 .38446 m .48881 .39856 L .49158 .3996 L closepath p F P
0 0 0 r
s
.226 .331 .669 r
.58759 .44943 m .59541 .44156 L .57913 .42611 L p F P
0 0 0 r
s
.24 .35 .67 r
.56129 .42317 m
.58206 .44424 L
s
.56076 .46586 m
.58206 .44424 L
s
.209 .305 .622 r
.59541 .44156 m .58759 .44943 L .60049 .46737 L p F P
0 0 0 r
s
.765 .205 .084 r
.44797 .61371 m .46525 .61904 L .46431 .60345 L p F P
0 0 0 r
s
.83 .24 .1 r
.46453 .58501 m
.46564 .60811 L
s
.765 .205 .084 r
.46431 .60345 m .44655 .59789 L .44797 .61371 L p F P
0 0 0 r
s
.24 .35 .67 r
.25909 .67945 m
.2755 .70368 L
s
.27536 .66127 m
.25909 .67945 L
s
.282 .418 .823 r
.51459 .39863 m .51621 .39682 L .5 .38446 L closepath p F P
0 0 0 r
s
.528 .131 .051 r
.52861 .66034 m .54304 .6647 L .54667 .65648 L p F P
0 0 0 r
s
.24 .35 .67 r
.53904 .66623 m
.54057 .66396 L
s
.528 .131 .051 r
.54667 .65648 m .53104 .65171 L .52861 .66034 L p F P
0 0 0 r
s
.024 .035 .067 r
.55623 .64819 m .54667 .65648 L .54304 .6647 L p F P
0 0 0 r
s
1 .294 .125 r
.5 .38446 m .48603 .39751 L .48881 .39856 L closepath p F P
0 0 0 r
s
.113 .157 .348 r
.5933 .57483 m .60446 .56478 L .60237 .54555 L p F P
0 0 0 r
s
.079 .107 .249 r
.60446 .56478 m .5933 .57483 L .59301 .59268 L p F P
0 0 0 r
s
.079 .107 .249 r
.58209 .60236 m .59301 .59268 L .5933 .57483 L p F P
0 0 0 r
s
1 .291 .123 r
.45051 .40458 m .44495 .40253 L .41923 .41499 L p F P
0 0 0 r
s
1 .293 .125 r
.44495 .40253 m .45051 .40458 L .47486 .39333 L p F P
0 0 0 r
s
.24 .35 .67 r
.45574 .40216 m
.45655 .40231 L
s
1 .293 .125 r
.47766 .39438 m .47486 .39333 L .45051 .40458 L p F P
0 0 0 r
s
.83 .24 .1 r
.67802 .71152 m
.663 .70644 L
s
.663 .70644 m
.62925 .69629 L
s
.269 .398 .788 r
.5211 .39138 m .51947 .3932 L .53832 .40433 L p F P
0 0 0 r
s
.269 .398 .788 r
.53832 .40433 m .5416 .40077 L .5211 .39138 L p F P
0 0 0 r
s
1 .287 .121 r
.38464 .42556 m .39541 .42939 L .41923 .41499 L p F P
0 0 0 r
s
1 .287 .121 r
.41923 .41499 m .41098 .41199 L .38464 .42556 L p F P
0 0 0 r
s
1 .291 .123 r
.41098 .41199 m .41923 .41499 L .44495 .40253 L p F P
0 0 0 r
s
.83 .226 .093 r
.41049 .5866 m .42862 .59227 L .42839 .57442 L p F P
0 0 0 r
s
.83 .226 .093 r
.42839 .57442 m .41021 .56863 L .41049 .5866 L p F P
0 0 0 r
s
.83 .24 .1 r
.62716 .40581 m
.59302 .39257 L
s
.62716 .40581 m
.64304 .39975 L
s
.047 .067 .154 r
.59301 .59268 m .58209 .60236 L .57992 .618 L p F P
0 0 0 r
s
.047 .067 .154 r
.56948 .62713 m .57992 .618 L .58209 .60236 L p F P
0 0 0 r
s
.24 .35 .67 r
.57986 .60765 m
.58158 .58391 L
s
1 .294 .125 r
.5 .38446 m .48324 .39647 L .48603 .39751 L closepath p F P
0 0 0 r
s
.99 .283 .119 r
.36089 .4409 m .37395 .44546 L .39541 .42939 L p F P
0 0 0 r
s
.24 .35 .67 r
.35799 .45071 m
.36483 .44227 L
s
.99 .283 .119 r
.39541 .42939 m .38464 .42556 L .36089 .4409 L p F P
0 0 0 r
s
.83 .24 .1 r
.3822 .4406 m
.41818 .45325 L
s
.67 .175 .071 r
.48326 .63714 m .49934 .64204 L .4993 .62955 L p F P
0 0 0 r
s
.67 .175 .071 r
.4993 .62955 m .48236 .62432 L .48326 .63714 L p F P
0 0 0 r
s
.282 .418 .823 r
.51621 .39682 m .51784 .39501 L .5 .38446 L closepath p F P
0 0 0 r
s
.939 .263 .11 r
.34597 .50625 m .36368 .51209 L .37297 .49241 L p F P
0 0 0 r
s
.939 .263 .11 r
.37297 .49241 m .35652 .48688 L .34597 .50625 L p F P
0 0 0 r
s
.83 .24 .1 r
.36445 .49685 m
.40071 .50897 L
s
.24 .35 .67 r
.33754 .72517 m
.32014 .74226 L
s
.29621 .72498 m
.32014 .74226 L
s
.144 .204 .437 r
.60237 .54555 m .61348 .53535 L .60855 .51561 L p F P
0 0 0 r
s
.113 .157 .348 r
.61348 .53535 m .60237 .54555 L .60446 .56478 L p F P
0 0 0 r
s
.24 .35 .67 r
.59972 .53902 m
.60347 .56417 L
s
1 .294 .125 r
.5 .38446 m .48045 .39542 L .48324 .39647 L closepath p F P
0 0 0 r
s
.96 .271 .113 r
.33991 .4813 m .35652 .48688 L .37027 .468 L p F P
0 0 0 r
s
.96 .271 .113 r
.37027 .468 m .35532 .46288 L .33991 .4813 L p F P
0 0 0 r
s
.912 .254 .105 r
.35747 .53173 m .37583 .53768 L .38122 .51788 L p F P
0 0 0 r
s
.912 .254 .105 r
.38122 .51788 m .36368 .51209 L .35747 .53173 L p F P
0 0 0 r
s
1 .291 .123 r
.44495 .40253 m .43937 .40047 L .41098 .41199 L p F P
0 0 0 r
s
1 .293 .125 r
.43937 .40047 m .44495 .40253 L .47205 .39228 L p F P
0 0 0 r
s
1 .293 .125 r
.47486 .39333 m .47205 .39228 L .44495 .40253 L p F P
0 0 0 r
s
.83 .24 .1 r
.44286 .40248 m
.47826 .41553 L
s
.36445 .49685 m
.37231 .46858 L
s
.37231 .46858 m
.3822 .4406 L
s
.209 .305 .622 r
.60049 .46737 m .60957 .45845 L .59541 .44156 L p F P
0 0 0 r
s
.24 .35 .67 r
.58206 .44424 m
.59955 .46767 L
s
.19 .276 .57 r
.60957 .45845 m .60049 .46737 L .61115 .48619 L p F P
0 0 0 r
s
1 .294 .125 r
.5 .38446 m .47766 .39438 L .48045 .39542 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.47826 .41553 m
.49257 .39461 L
s
.977 .277 .116 r
.34024 .45771 m .35532 .46288 L .37395 .44546 L p F P
0 0 0 r
s
.24 .35 .67 r
.35544 .45219 m
.35799 .45071 L
s
.977 .277 .116 r
.37395 .44546 m .36089 .4409 L .34024 .45771 L p F P
0 0 0 r
s
.255 .376 .751 r
.54489 .39719 m .5416 .40077 L .56107 .41243 L p F P
0 0 0 r
s
.255 .376 .751 r
.56107 .41243 m .56599 .40721 L .54489 .39719 L p F P
0 0 0 r
s
.241 .354 .711 r
.56599 .40721 m .56107 .41243 L .57913 .42611 L p F P
0 0 0 r
s
.282 .418 .823 r
.51784 .39501 m .51947 .3932 L .5 .38446 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.49257 .39461 m
.51355 .4025 L
s
.322 .484 .924 r
.41529 .40678 m .41098 .41199 L .38464 .42556 L p F P
0 0 0 r
s
.316 .473 .911 r
.41098 .41199 m .41529 .40678 L .44238 .39689 L p F P
0 0 0 r
s
.316 .473 .911 r
.44238 .39689 m .43937 .40047 L .41098 .41199 L p F P
0 0 0 r
s
.83 .24 .1 r
.4298 .42679 m
.44286 .40248 L
s
.024 .036 .069 r
.57992 .618 m .56948 .62713 L .56593 .63977 L p F P
0 0 0 r
s
.24 .35 .67 r
.5585 .62652 m
.57986 .60765 L
s
.024 .036 .069 r
.55623 .64819 m .56593 .63977 L .56948 .62713 L p F P
0 0 0 r
s
.24 .35 .67 r
.2755 .70368 m
.29621 .72498 L
s
.29212 .68587 m
.2755 .70368 L
s
.877 .242 .1 r
.37328 .55688 m .39184 .56279 L .39401 .54356 L p F P
0 0 0 r
s
.877 .242 .1 r
.39401 .54356 m .37583 .53768 L .37328 .55688 L p F P
0 0 0 r
s
.83 .24 .1 r
.39287 .56219 m
.39547 .53636 L
s
1 .294 .125 r
.5 .38446 m .47486 .39333 L .47766 .39438 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.26374 .63504 m
.25776 .60854 L
s
.27406 .58902 m
.25776 .60854 L
s
.29569 .51931 m
.3063 .4992 L
s
.269 .398 .788 r
.52274 .38955 m .5211 .39138 L .5416 .40077 L p F P
0 0 0 r
s
.269 .398 .788 r
.5416 .40077 m .54489 .39719 L .52274 .38955 L p F P
0 0 0 r
s
.24 .35 .67 r
.47997 .70792 m
.46001 .72534 L
s
.46001 .72534 m
.43577 .72948 L
s
.241 .354 .711 r
.57913 .42611 m .58561 .41942 L .56599 .40721 L p F P
0 0 0 r
s
.226 .331 .669 r
.58561 .41942 m .57913 .42611 L .59541 .44156 L p F P
0 0 0 r
s
.83 .24 .1 r
.75866 .43916 m
.72579 .42621 L
s
.75866 .43916 m
.77326 .44557 L
s
1 .293 .125 r
.47205 .39228 m .46925 .39123 L .43937 .40047 L p F P
0 0 0 r
s
.306 .457 .887 r
.43937 .40047 m .44238 .39689 L .47081 .3894 L p F P
0 0 0 r
s
.306 .457 .887 r
.47081 .3894 m .46925 .39123 L .43937 .40047 L p F P
0 0 0 r
s
.83 .24 .1 r
.43664 .40019 m
.44286 .40248 L
s
.24 .35 .67 r
.44152 .39954 m
.45095 .40128 L
s
.43817 .40351 m
.44152 .39954 L
s
.169 .243 .509 r
.60855 .51561 m .61932 .50552 L .61115 .48619 L p F P
0 0 0 r
s
.144 .204 .437 r
.61932 .50552 m .60855 .51561 L .61348 .53535 L p F P
0 0 0 r
s
.24 .35 .67 r
.31321 .70755 m
.29621 .72498 L
s
.83 .24 .1 r
.5948 .68593 m
.58323 .67543 L
s
.58323 .67543 m
.54854 .66493 L
s
.321 .483 .913 r
.3901 .41886 m .38464 .42556 L .36089 .4409 L p F P
0 0 0 r
s
.322 .484 .924 r
.38464 .42556 m .3901 .41886 L .41529 .40678 L p F P
0 0 0 r
s
.83 .24 .1 r
.3822 .4406 m
.39047 .42151 L
s
.3938 .41382 m
.39769 .41522 L
s
.40109 .41645 m
.4298 .42679 L
s
.39201 .41794 m
.3938 .41382 L
s
1 .294 .125 r
.5 .38446 m .47205 .39228 L .47486 .39333 L closepath p F P
0 0 0 r
s
.282 .418 .823 r
.51947 .3932 m .5211 .39138 L .5 .38446 L closepath p F P
0 0 0 r
s
.528 .131 .051 r
.51406 .65595 m .52861 .66034 L .53104 .65171 L p F P
0 0 0 r
s
.528 .131 .051 r
.53104 .65171 m .51526 .6469 L .51406 .65595 L p F P
0 0 0 r
s
.83 .24 .1 r
.50544 .63876 m
.54037 .64947 L
s
1 .294 .125 r
.5 .38446 m .46925 .39123 L .47205 .39228 L closepath p F P
0 0 0 r
s
.765 .205 .084 r
.43052 .60832 m .44797 .61371 L .44655 .59789 L p F P
0 0 0 r
s
.765 .205 .084 r
.44655 .59789 m .42862 .59227 L .43052 .60832 L p F P
0 0 0 r
s
.282 .418 .823 r
.5211 .39138 m .52274 .38955 L .5 .38446 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.5007 .40473 m
.51291 .39105 L
s
.294 .438 .857 r
.5 .38446 m .46925 .39123 L .47081 .3894 L closepath p F P
0 0 0 r
s
.226 .331 .669 r
.59541 .44156 m .60334 .43358 L .58561 .41942 L p F P
0 0 0 r
s
.209 .305 .622 r
.60334 .43358 m .59541 .44156 L .60957 .45845 L p F P
0 0 0 r
s
.67 .175 .071 r
.46704 .63219 m .48326 .63714 L .48236 .62432 L p F P
0 0 0 r
s
.67 .175 .071 r
.48236 .62432 m .46525 .61904 L .46704 .63219 L p F P
0 0 0 r
s
.96 .271 .113 r
.32314 .47566 m .33991 .4813 L .35532 .46288 L p F P
0 0 0 r
s
.24 .35 .67 r
.32157 .4833 m
.32673 .47686 L
s
.96 .271 .113 r
.35532 .46288 m .34024 .45771 L .32314 .47566 L p F P
0 0 0 r
s
.83 .226 .093 r
.39218 .58087 m .41049 .5866 L .41021 .56863 L p F P
0 0 0 r
s
.83 .226 .093 r
.41021 .56863 m .39184 .56279 L .39218 .58087 L p F P
0 0 0 r
s
.83 .24 .1 r
.39287 .56219 m
.42906 .57372 L
s
.939 .263 .11 r
.32809 .50035 m .34597 .50625 L .35652 .48688 L p F P
0 0 0 r
s
.939 .263 .11 r
.35652 .48688 m .33991 .4813 L .32809 .50035 L p F P
0 0 0 r
s
.269 .398 .788 r
.52439 .38772 m .52274 .38955 L .54489 .39719 L p F P
0 0 0 r
s
.269 .398 .788 r
.54489 .39719 m .5482 .39359 L .52439 .38772 L p F P
0 0 0 r
s
.83 .24 .1 r
.54184 .39202 m
.54273 .39105 L
s
.24 .35 .67 r
.51291 .39105 m
.53796 .40522 L
s
.255 .376 .751 r
.5482 .39359 m .54489 .39719 L .56599 .40721 L p F P
0 0 0 r
s
.83 .24 .1 r
.54273 .39105 m
.57721 .40425 L
s
.305 .461 .857 r
.36733 .43291 m .36089 .4409 L .34024 .45771 L p F P
0 0 0 r
s
.321 .483 .913 r
.36089 .4409 m .36733 .43291 L .3901 .41886 L p F P
0 0 0 r
s
.83 .24 .1 r
.36828 .4357 m
.3822 .4406 L
s
.316 .473 .911 r
.44541 .39329 m .44238 .39689 L .41529 .40678 L p F P
0 0 0 r
s
.306 .457 .887 r
.44238 .39689 m .44541 .39329 L .47238 .38757 L p F P
0 0 0 r
s
.306 .457 .887 r
.47238 .38757 m .47081 .3894 L .44238 .39689 L p F P
0 0 0 r
s
.19 .276 .57 r
.61115 .48619 m .62129 .47647 L .60957 .45845 L p F P
0 0 0 r
s
.169 .243 .509 r
.62129 .47647 m .61115 .48619 L .61932 .50552 L p F P
0 0 0 r
s
.24 .35 .67 r
.59955 .46767 m
.61308 .49266 L
s
.59104 .51364 m
.61308 .49266 L
s
.912 .254 .105 r
.33891 .52572 m .35747 .53173 L .36368 .51209 L p F P
0 0 0 r
s
.912 .254 .105 r
.36368 .51209 m .34597 .50625 L .33891 .52572 L p F P
0 0 0 r
s
.83 .24 .1 r
.35891 .52445 m
.36445 .49685 L
s
.24 .35 .67 r
.40942 .72789 m
.39065 .74501 L
s
.39065 .74501 m
.36381 .73785 L
s
.255 .376 .751 r
.56599 .40721 m .57095 .40196 L .5482 .39359 L p F P
0 0 0 r
s
.241 .354 .711 r
.57095 .40196 m .56599 .40721 L .58561 .41942 L p F P
0 0 0 r
s
.282 .418 .823 r
.52274 .38955 m .52439 .38772 L .5 .38446 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.67687 .41301 m
.64304 .39975 L
s
.67687 .41301 m
.69223 .413 L
s
.294 .438 .857 r
.5 .38446 m .47081 .3894 L .47238 .38757 L closepath p F P
0 0 0 r
s
.322 .484 .924 r
.41964 .40152 m .41529 .40678 L .3901 .41886 L p F P
0 0 0 r
s
.316 .473 .911 r
.41529 .40678 m .41964 .40152 L .44541 .39329 L p F P
0 0 0 r
s
.83 .24 .1 r
.44286 .40248 m
.448 .39473 L
s
.72891 .72076 m
.71151 .72158 L
s
.71151 .72158 m
.67802 .71152 L
s
.024 .035 .067 r
.56593 .63977 m .55623 .64819 L .55181 .65713 L p F P
0 0 0 r
s
.024 .035 .067 r
.54304 .6647 m .55181 .65713 L .55623 .64819 L p F P
0 0 0 r
s
.83 .24 .1 r
.54736 .6627 m
.54854 .66493 L
s
.54673 .66151 m
.54736 .6627 L
s
.54037 .64947 m
.54584 .65981 L
s
.24 .35 .67 r
.5431 .66019 m
.55134 .64794 L
s
.877 .242 .1 r
.35452 .55091 m .37328 .55688 L .37583 .53768 L p F P
0 0 0 r
s
.877 .242 .1 r
.37583 .53768 m .35747 .53173 L .35452 .55091 L p F P
0 0 0 r
s
.83 .24 .1 r
.35891 .52445 m
.39547 .53636 L
s
.282 .418 .823 r
.52439 .38772 m .52604 .38588 L .5 .38446 L closepath p F P
0 0 0 r
s
.269 .398 .788 r
.52604 .38588 m .52439 .38772 L .5482 .39359 L p F P
0 0 0 r
s
.306 .457 .887 r
.47396 .38573 m .47238 .38757 L .44541 .39329 L p F P
0 0 0 r
s
.294 .438 .857 r
.5 .38446 m .47238 .38757 L .47396 .38573 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.52195 .68048 m
.50115 .69848 L
s
.50115 .69848 m
.47997 .70792 L
s
.241 .354 .711 r
.58561 .41942 m .59216 .41266 L .57095 .40196 L p F P
0 0 0 r
s
.226 .331 .669 r
.59216 .41266 m .58561 .41942 L .60334 .43358 L p F P
0 0 0 r
s
.269 .398 .788 r
.5482 .39359 m .55153 .38997 L .52604 .38588 L p F P
0 0 0 r
s
.255 .376 .751 r
.55153 .38997 m .5482 .39359 L .57095 .40196 L p F P
0 0 0 r
s
.294 .438 .857 r
.5 .38446 m .47713 .38204 L .47871 .38019 L closepath p F P
0 0 0 r
s
.294 .438 .857 r
.5 .38446 m .47396 .38573 L .47554 .38389 L closepath p F P
0 0 0 r
s
.294 .438 .857 r
.5 .38446 m .47554 .38389 L .47713 .38204 L closepath p F P
0 0 0 r
s
.294 .438 .857 r
.5 .38446 m .47871 .38019 L .48031 .37833 L closepath p F P
0 0 0 r
s
.294 .438 .857 r
.5 .38446 m .48031 .37833 L .48191 .37647 L closepath p F P
0 0 0 r
s
.294 .438 .857 r
.5 .38446 m .48191 .37647 L .48351 .3746 L closepath p F P
0 0 0 r
s
.294 .438 .857 r
.5 .38446 m .48351 .3746 L .48512 .37273 L closepath p F P
0 0 0 r
s
.294 .438 .857 r
.5 .38446 m .48512 .37273 L .48673 .37085 L closepath p F P
0 0 0 r
s
.294 .438 .857 r
.5 .38446 m .48673 .37085 L .48835 .36896 L closepath p F P
0 0 0 r
s
.294 .438 .857 r
.5 .38446 m .48835 .36896 L .48997 .36707 L closepath p F P
0 0 0 r
s
.294 .438 .857 r
.5 .38446 m .48997 .36707 L .49159 .36518 L closepath p F P
0 0 0 r
s
.282 .418 .823 r
.52769 .38404 m .52935 .3822 L .5 .38446 L closepath p F P
0 0 0 r
s
.282 .418 .823 r
.52604 .38588 m .52769 .38404 L .5 .38446 L closepath p F P
0 0 0 r
s
.987 .292 .125 r
.52823 .37927 m .53101 .38034 L .5 .38446 L closepath p F P
0 0 0 r
s
.987 .292 .125 r
.52544 .3782 m .52823 .37927 L .5 .38446 L closepath p F P
0 0 0 r
s
.987 .292 .125 r
.52264 .37712 m .52544 .3782 L .5 .38446 L closepath p F P
0 0 0 r
s
.987 .292 .125 r
.51984 .37605 m .52264 .37712 L .5 .38446 L closepath p F P
0 0 0 r
s
.987 .292 .125 r
.51704 .37497 m .51984 .37605 L .5 .38446 L closepath p F P
0 0 0 r
s
.987 .292 .125 r
.51423 .37389 m .51704 .37497 L .5 .38446 L closepath p F P
0 0 0 r
s
.987 .292 .125 r
.51142 .37281 m .51423 .37389 L .5 .38446 L closepath p F P
0 0 0 r
s
.987 .292 .125 r
.5086 .37172 m .51142 .37281 L .5 .38446 L closepath p F P
0 0 0 r
s
.282 .418 .823 r
.52935 .3822 m .53101 .38034 L .5 .38446 L closepath p F P
0 0 0 r
s
.987 .292 .125 r
.50578 .37064 m .5086 .37172 L .5 .38446 L closepath p F P
0 0 0 r
s
.987 .292 .125 r
.50295 .36955 m .50578 .37064 L .5 .38446 L closepath p F P
0 0 0 r
s
.987 .292 .125 r
.50012 .36846 m .50295 .36955 L .5 .38446 L closepath p F P
0 0 0 r
s
.987 .292 .125 r
.49728 .36737 m .50012 .36846 L .5 .38446 L closepath p F P
0 0 0 r
s
.987 .292 .125 r
.49444 .36627 m .49728 .36737 L .5 .38446 L closepath p F P
0 0 0 r
s
.987 .292 .125 r
.49159 .36518 m .49444 .36627 L .5 .38446 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.49257 .39461 m
.50753 .37758 L
s
.24 .35 .67 r
.487 .38121 m
.51291 .39105 L
s
.316 .473 .911 r
.44846 .38967 m .44541 .39329 L .41964 .40152 L p F P
0 0 0 r
s
.306 .457 .887 r
.44541 .39329 m .44846 .38967 L .47396 .38573 L p F P
0 0 0 r
s
.83 .24 .1 r
.47133 .38662 m
.49257 .39461 L
s
.528 .131 .051 r
.49939 .65151 m .51406 .65595 L .51526 .6469 L p F P
0 0 0 r
s
.528 .131 .051 r
.51526 .6469 m .49934 .64204 L .49939 .65151 L p F P
0 0 0 r
s
.321 .483 .913 r
.39561 .4121 m .3901 .41886 L .36733 .43291 L p F P
0 0 0 r
s
.24 .35 .67 r
.36902 .43709 m
.37594 .42854 L
s
.37594 .42854 m
.39191 .42436 L
s
.322 .484 .924 r
.3901 .41886 m .39561 .4121 L .41964 .40152 L p F P
0 0 0 r
s
.113 .157 .348 r
.60446 .56478 m .61582 .55455 L .61348 .53535 L p F P
0 0 0 r
s
.079 .107 .249 r
.61582 .55455 m .60446 .56478 L .60413 .58282 L p F P
0 0 0 r
s
.079 .107 .249 r
.59301 .59268 m .60413 .58282 L .60446 .56478 L p F P
0 0 0 r
s
.209 .305 .622 r
.60957 .45845 m .61878 .44941 L .60334 .43358 L p F P
0 0 0 r
s
.19 .276 .57 r
.61878 .44941 m .60957 .45845 L .62129 .47647 L p F P
0 0 0 r
s
.047 .067 .154 r
.60413 .58282 m .59301 .59268 L .59053 .60871 L p F P
0 0 0 r
s
.24 .35 .67 r
.58158 .58391 m
.60347 .56417 L
s
.047 .067 .154 r
.57992 .618 m .59053 .60871 L .59301 .59268 L p F P
0 0 0 r
s
.269 .398 .788 r
.52769 .38404 m .52604 .38588 L .55153 .38997 L p F P
0 0 0 r
s
.306 .457 .887 r
.47554 .38389 m .47396 .38573 L .44846 .38967 L p F P
0 0 0 r
s
.83 .24 .1 r
.46797 .38535 m
.46823 .38545 L
s
.765 .205 .084 r
.4129 .60288 m .43052 .60832 L .42862 .59227 L p F P
0 0 0 r
s
.83 .24 .1 r
.42906 .57372 m
.42974 .59692 L
s
.42974 .59692 m
.46564 .60811 L
s
.765 .205 .084 r
.42862 .59227 m .41049 .5866 L .4129 .60288 L p F P
0 0 0 r
s
.266 .404 .736 r
.34748 .44865 m .34024 .45771 L .32314 .47566 L p F P
0 0 0 r
s
.83 .24 .1 r
.3355 .45596 m
.33962 .45738 L
s
.305 .461 .857 r
.34024 .45771 m .34748 .44865 L .36733 .43291 L p F P
0 0 0 r
s
.83 .24 .1 r
.34022 .45758 m
.37231 .46858 L
s
.144 .204 .437 r
.61348 .53535 m .62479 .52497 L .61932 .50552 L p F P
0 0 0 r
s
.113 .157 .348 r
.62479 .52497 m .61348 .53535 L .61582 .55455 L p F P
0 0 0 r
s
.83 .24 .1 r
.80587 .4584 m
.77326 .44557 L
s
.80587 .4584 m
.81855 .47088 L
s
.939 .263 .11 r
.31002 .49439 m .32809 .50035 L .33991 .4813 L p F P
0 0 0 r
s
.24 .35 .67 r
.3063 .4992 m
.31012 .49443 L
s
.939 .263 .11 r
.33991 .4813 m .32314 .47566 L .31002 .49439 L p F P
0 0 0 r
s
.24 .35 .67 r
.27372 .56333 m
.29043 .54284 L
s
.27406 .58902 m
.27372 .56333 L
s
.83 .24 .1 r
.64384 .70125 m
.62925 .69629 L
s
.62925 .69629 m
.5948 .68593 L
s
.67 .175 .071 r
.45066 .6272 m .46704 .63219 L .46525 .61904 L p F P
0 0 0 r
s
.83 .24 .1 r
.46564 .60811 m
.46979 .62783 L
s
.67 .175 .071 r
.46525 .61904 m .44797 .61371 L .45066 .6272 L p F P
0 0 0 r
s
.255 .376 .751 r
.57095 .40196 m .57595 .39666 L .55153 .38997 L p F P
0 0 0 r
s
.241 .354 .711 r
.57595 .39666 m .57095 .40196 L .59216 .41266 L p F P
0 0 0 r
s
.83 .24 .1 r
.58089 .40153 m
.59302 .39257 L
s
.83 .226 .093 r
.37368 .57508 m .39218 .58087 L .39184 .56279 L p F P
0 0 0 r
s
.83 .226 .093 r
.39184 .56279 m .37328 .55688 L .37368 .57508 L p F P
0 0 0 r
s
.269 .398 .788 r
.52935 .3822 m .52769 .38404 L .55488 .38633 L p F P
0 0 0 r
s
.269 .398 .788 r
.55153 .38997 m .55488 .38633 L .52769 .38404 L p F P
0 0 0 r
s
.322 .484 .924 r
.42402 .39622 m .41964 .40152 L .39561 .4121 L p F P
0 0 0 r
s
.316 .473 .911 r
.41964 .40152 m .42402 .39622 L .44846 .38967 L p F P
0 0 0 r
s
.306 .457 .887 r
.44846 .38967 m .45152 .38603 L .47554 .38389 L p F P
0 0 0 r
s
.306 .457 .887 r
.47713 .38204 m .47554 .38389 L .45152 .38603 L p F P
0 0 0 r
s
.912 .254 .105 r
.32017 .51965 m .33891 .52572 L .34597 .50625 L p F P
0 0 0 r
s
.912 .254 .105 r
.34597 .50625 m .32809 .50035 L .32017 .51965 L p F P
0 0 0 r
s
.24 .35 .67 r
.27536 .66127 m
.26374 .63504 L
s
.28029 .61583 m
.26374 .63504 L
s
.255 .376 .751 r
.55488 .38633 m .55153 .38997 L .57595 .39666 L p F P
0 0 0 r
s
.024 .036 .069 r
.59053 .60871 m .57992 .618 L .5758 .63121 L p F P
0 0 0 r
s
.024 .036 .069 r
.56593 .63977 m .5758 .63121 L .57992 .618 L p F P
0 0 0 r
s
.24 .35 .67 r
.57285 .6292 m
.57986 .60765 L
s
.316 .473 .911 r
.45152 .38603 m .44846 .38967 L .42402 .39622 L p F P
0 0 0 r
s
.83 .24 .1 r
.40673 .38916 m
.42494 .39588 L
s
.226 .331 .669 r
.60334 .43358 m .61137 .4255 L .59216 .41266 L p F P
0 0 0 r
s
.209 .305 .622 r
.61137 .4255 m .60334 .43358 L .61878 .44941 L p F P
0 0 0 r
s
.169 .243 .509 r
.61932 .50552 m .63028 .49525 L .62129 .47647 L p F P
0 0 0 r
s
.144 .204 .437 r
.63028 .49525 m .61932 .50552 L .62479 .52497 L p F P
0 0 0 r
s
.24 .35 .67 r
.59972 .53902 m
.62211 .51832 L
s
.83 .24 .1 r
.33304 .46468 m
.3355 .45596 L
s
.3355 .45596 m
.34548 .42769 L
s
.269 .398 .788 r
.53101 .38034 m .52935 .3822 L .55825 .38268 L p F P
0 0 0 r
s
.269 .398 .788 r
.55488 .38633 m .55825 .38268 L .52935 .3822 L p F P
0 0 0 r
s
.305 .461 .857 r
.37384 .42483 m .36733 .43291 L .34748 .44865 L p F P
0 0 0 r
s
.83 .24 .1 r
.34548 .42769 m
.36362 .43406 L
s
.321 .483 .913 r
.36733 .43291 m .37384 .42483 L .39561 .4121 L p F P
0 0 0 r
s
.83 .24 .1 r
.3943 .41286 m
.40673 .38916 L
s
.306 .457 .887 r
.45152 .38603 m .4546 .38237 L .47713 .38204 L p F P
0 0 0 r
s
.306 .457 .887 r
.47871 .38019 m .47713 .38204 L .4546 .38237 L p F P
0 0 0 r
s
.83 .24 .1 r
.45628 .38222 m
.45695 .38121 L
s
.24 .35 .67 r
.47498 .39511 m
.487 .38121 L
s
.83 .24 .1 r
.45695 .38121 m
.45899 .38197 L
s
.34548 .42769 m
.30799 .4145 L
s
.34548 .42769 m
.35705 .40058 L
s
.24 .35 .67 r
.53904 .66623 m
.54139 .66421 L
s
.877 .242 .1 r
.33557 .54488 m .35452 .55091 L .35747 .53173 L p F P
0 0 0 r
s
.877 .242 .1 r
.35747 .53173 m .33891 .52572 L .33557 .54488 L p F P
0 0 0 r
s
.83 .24 .1 r
.35591 .55043 m
.35891 .52445 L
s
.40673 .38916 m
.36985 .37557 L
s
.528 .131 .051 r
.48459 .64704 m .49939 .65151 L .49934 .64204 L p F P
0 0 0 r
s
.528 .131 .051 r
.49934 .64204 m .48326 .63714 L .48459 .64704 L p F P
0 0 0 r
s
.83 .24 .1 r
.46979 .62783 m
.50544 .63876 L
s
.72579 .42621 m
.69223 .413 L
s
.72579 .42621 m
.73997 .43246 L
s
.269 .398 .788 r
.55825 .38268 m .56164 .379 L .53101 .38034 L p F P
0 0 0 r
s
.952 .285 .123 r
.53101 .38034 m .52823 .37927 L .55615 .37686 L p F P
0 0 0 r
s
.952 .285 .123 r
.55615 .37686 m .56164 .379 L .53101 .38034 L p F P
0 0 0 r
s
.241 .354 .711 r
.59216 .41266 m .59878 .40583 L .57595 .39666 L p F P
0 0 0 r
s
.226 .331 .669 r
.59878 .40583 m .59216 .41266 L .61137 .4255 L p F P
0 0 0 r
s
.24 .35 .67 r
.58206 .44424 m
.60413 .42183 L
s
.306 .457 .887 r
.4546 .38237 m .45769 .37869 L .47871 .38019 L p F P
0 0 0 r
s
.306 .457 .887 r
.48031 .37833 m .47871 .38019 L .45769 .37869 L p F P
0 0 0 r
s
.24 .35 .67 r
.38223 .72047 m
.36381 .73785 L
s
.36381 .73785 m
.33754 .72517 L
s
.255 .376 .751 r
.55825 .38268 m .55488 .38633 L .581 .39132 L p F P
0 0 0 r
s
.255 .376 .751 r
.57595 .39666 m .581 .39132 L .55488 .38633 L p F P
0 0 0 r
s
.321 .483 .913 r
.40118 .40526 m .39561 .4121 L .37384 .42483 L p F P
0 0 0 r
s
.83 .24 .1 r
.35705 .40058 m
.39075 .41272 L
s
.322 .484 .924 r
.39561 .4121 m .40118 .40526 L .42402 .39622 L p F P
0 0 0 r
s
.19 .276 .57 r
.62129 .47647 m .63159 .4666 L .61878 .44941 L p F P
0 0 0 r
s
.169 .243 .509 r
.63159 .4666 m .62129 .47647 L .63028 .49525 L p F P
0 0 0 r
s
.24 .35 .67 r
.61308 .49266 m
.62211 .51832 L
s
.316 .473 .911 r
.42402 .39622 m .42844 .39087 L .45152 .38603 L p F P
0 0 0 r
s
.316 .473 .911 r
.4546 .38237 m .45152 .38603 L .42844 .39087 L p F P
0 0 0 r
s
.952 .285 .123 r
.52823 .37927 m .52544 .3782 L .55064 .37472 L p F P
0 0 0 r
s
.952 .285 .123 r
.55064 .37472 m .55615 .37686 L .52823 .37927 L p F P
0 0 0 r
s
.83 .24 .1 r
.55245 .38349 m
.55818 .37904 L
s
.24 .35 .67 r
.45551 .71193 m
.43577 .72948 L
s
.43577 .72948 m
.40942 .72789 L
s
.241 .354 .711 r
.581 .39132 m .57595 .39666 L .59878 .40583 L p F P
0 0 0 r
s
.24 .35 .67 r
.56129 .42317 m
.58297 .4004 L
s
.765 .205 .084 r
.39509 .59738 m .4129 .60288 L .41049 .5866 L p F P
0 0 0 r
s
.765 .205 .084 r
.41049 .5866 m .39218 .58087 L .39509 .59738 L p F P
0 0 0 r
s
.266 .404 .736 r
.32314 .47566 m .33103 .46577 L .34748 .44865 L p F P
0 0 0 r
s
.024 .035 .067 r
.33103 .46577 m .32314 .47566 L .31002 .49439 L p F P
0 0 0 r
s
.83 .24 .1 r
.32744 .48448 m
.33287 .46528 L
s
.24 .35 .67 r
.32348 .4777 m
.33383 .46696 L
s
.83 .24 .1 r
.32744 .48448 m
.36445 .49685 L
s
.24 .35 .67 r
.31956 .48261 m
.32348 .4777 L
s
.322 .484 .924 r
.42844 .39087 m .42402 .39622 L .40118 .40526 L p F P
0 0 0 r
s
.24 .35 .67 r
.40196 .4182 m
.417 .39992 L
s
.417 .39992 m
.44152 .39954 L
s
.386 .087 .036 r
.52542 .66541 m .53825 .66927 L .54304 .6647 L p F P
0 0 0 r
s
.24 .35 .67 r
.52195 .68048 m
.53616 .66864 L
s
.386 .087 .036 r
.54304 .6647 m .52861 .66034 L .52542 .66541 L p F P
0 0 0 r
s
.024 .035 .067 r
.55181 .65713 m .54304 .6647 L .53825 .66927 L p F P
0 0 0 r
s
.83 .24 .1 r
.54448 .6637 m
.54854 .66493 L
s
.306 .457 .887 r
.45769 .37869 m .4608 .37499 L .48031 .37833 L p F P
0 0 0 r
s
.306 .457 .887 r
.48191 .37647 m .48031 .37833 L .4608 .37499 L p F P
0 0 0 r
s
.952 .285 .123 r
.52544 .3782 m .52264 .37712 L .54511 .37257 L p F P
0 0 0 r
s
.952 .285 .123 r
.54511 .37257 m .55064 .37472 L .52544 .3782 L p F P
0 0 0 r
s
.83 .24 .1 r
.50753 .37758 m
.52869 .38568 L
s
.31764 .48121 m
.319 .48166 L
s
.31929 .48176 m
.32744 .48448 L
s
.67 .175 .071 r
.43413 .62215 m .45066 .6272 L .44797 .61371 L p F P
0 0 0 r
s
.67 .175 .071 r
.44797 .61371 m .43052 .60832 L .43413 .62215 L p F P
0 0 0 r
s
.024 .035 .067 r
.5758 .63121 m .56593 .63977 L .56072 .64944 L p F P
0 0 0 r
s
.024 .035 .067 r
.55181 .65713 m .56072 .64944 L .56593 .63977 L p F P
0 0 0 r
s
.24 .35 .67 r
.55134 .64794 m
.57285 .6292 L
s
.83 .226 .093 r
.35498 .56922 m .37368 .57508 L .37328 .55688 L p F P
0 0 0 r
s
.83 .226 .093 r
.37328 .55688 m .35452 .55091 L .35498 .56922 L p F P
0 0 0 r
s
.83 .24 .1 r
.35591 .55043 m
.39287 .56219 L
s
.24 .35 .67 r
.29043 .54284 m
.29569 .51931 L
s
.952 .285 .123 r
.52264 .37712 m .51984 .37605 L .53956 .37042 L p F P
0 0 0 r
s
.952 .285 .123 r
.53956 .37042 m .54511 .37257 L .52264 .37712 L p F P
0 0 0 r
s
.24 .35 .67 r
.51291 .39105 m
.52537 .37706 L
s
.912 .254 .105 r
.30122 .51352 m .32017 .51965 L .32809 .50035 L p F P
0 0 0 r
s
.912 .254 .105 r
.32809 .50035 m .31002 .49439 L .30122 .51352 L p F P
0 0 0 r
s
.83 .24 .1 r
.35705 .40058 m
.31954 .38706 L
s
.35705 .40058 m
.36985 .37557 L
s
.24 .35 .67 r
.58297 .4004 m
.60413 .42183 L
s
.209 .305 .622 r
.61878 .44941 m .62813 .44023 L .61137 .4255 L p F P
0 0 0 r
s
.19 .276 .57 r
.62813 .44023 m .61878 .44941 L .63159 .4666 L p F P
0 0 0 r
s
.24 .35 .67 r
.59955 .46767 m
.622 .44562 L
s
.306 .457 .887 r
.4608 .37499 m .46394 .37127 L .48191 .37647 L p F P
0 0 0 r
s
.306 .457 .887 r
.48351 .3746 m .48191 .37647 L .46394 .37127 L p F P
0 0 0 r
s
.24 .35 .67 r
.46118 .37619 m
.487 .38121 L
s
.952 .285 .123 r
.51984 .37605 m .51704 .37497 L .534 .36826 L p F P
0 0 0 r
s
.952 .285 .123 r
.534 .36826 m .53956 .37042 L .51984 .37605 L p F P
0 0 0 r
s
.83 .24 .1 r
.64304 .39975 m
.65797 .39951 L
s
.255 .376 .751 r
.56164 .379 m .55825 .38268 L .58608 .38593 L p F P
0 0 0 r
s
.255 .376 .751 r
.581 .39132 m .58608 .38593 L .55825 .38268 L p F P
0 0 0 r
s
.24 .35 .67 r
.53796 .40522 m
.55927 .38208 L
s
.83 .24 .1 r
.58336 .38881 m
.59302 .39257 L
s
.266 .404 .736 r
.35483 .43946 m .34748 .44865 L .33103 .46577 L p F P
0 0 0 r
s
.83 .24 .1 r
.29792 .44308 m
.3355 .45596 L
s
.305 .461 .857 r
.34748 .44865 m .35483 .43946 L .37384 .42483 L p F P
0 0 0 r
s
.316 .473 .911 r
.42844 .39087 m .43289 .38548 L .4546 .38237 L p F P
0 0 0 r
s
.316 .473 .911 r
.45769 .37869 m .4546 .38237 L .43289 .38548 L p F P
0 0 0 r
s
.83 .24 .1 r
.69504 .71052 m
.67802 .71152 L
s
.67802 .71152 m
.64384 .70125 L
s
.24 .35 .67 r
.29212 .68587 m
.27536 .66127 L
s
.29222 .64242 m
.27536 .66127 L
s
.952 .285 .123 r
.51704 .37497 m .51423 .37389 L .52842 .36609 L p F P
0 0 0 r
s
.952 .285 .123 r
.52842 .36609 m .534 .36826 L .51704 .37497 L p F P
0 0 0 r
s
.24 .35 .67 r
.53342 .36803 m
.53387 .36753 L
s
.306 .457 .887 r
.46394 .37127 m .46708 .36752 L .48351 .3746 L p F P
0 0 0 r
s
.306 .457 .887 r
.48512 .37273 m .48351 .3746 L .46708 .36752 L p F P
0 0 0 r
s
.113 .157 .348 r
.61582 .55455 m .62739 .54413 L .62479 .52497 L p F P
0 0 0 r
s
.079 .107 .249 r
.62739 .54413 m .61582 .55455 L .61546 .57279 L p F P
0 0 0 r
s
.079 .107 .249 r
.60413 .58282 m .61546 .57279 L .61582 .55455 L p F P
0 0 0 r
s
.528 .131 .051 r
.46966 .64252 m .48459 .64704 L .48326 .63714 L p F P
0 0 0 r
s
.528 .131 .051 r
.48326 .63714 m .46704 .63219 L .46966 .64252 L p F P
0 0 0 r
s
.226 .331 .669 r
.61137 .4255 m .6195 .41732 L .59878 .40583 L p F P
0 0 0 r
s
.209 .305 .622 r
.6195 .41732 m .61137 .4255 L .62813 .44023 L p F P
0 0 0 r
s
.24 .35 .67 r
.60413 .42183 m
.622 .44562 L
s
.047 .067 .154 r
.61546 .57279 m .60413 .58282 L .60133 .59926 L p F P
0 0 0 r
s
.047 .067 .154 r
.59053 .60871 m .60133 .59926 L .60413 .58282 L p F P
0 0 0 r
s
.24 .35 .67 r
.60199 .58809 m
.60347 .56417 L
s
.877 .242 .1 r
.31641 .53879 m .33557 .54488 L .33891 .52572 L p F P
0 0 0 r
s
.877 .242 .1 r
.33891 .52572 m .32017 .51965 L .31641 .53879 L p F P
0 0 0 r
s
.83 .24 .1 r
.32159 .51228 m
.35891 .52445 L
s
.952 .285 .123 r
.51423 .37389 m .51142 .37281 L .52282 .36391 L p F P
0 0 0 r
s
.952 .285 .123 r
.52282 .36391 m .52842 .36609 L .51423 .37389 L p F P
0 0 0 r
s
.241 .354 .711 r
.58608 .38593 m .581 .39132 L .60547 .39892 L p F P
0 0 0 r
s
.241 .354 .711 r
.59878 .40583 m .60547 .39892 L .581 .39132 L p F P
0 0 0 r
s
.24 .35 .67 r
.55927 .38208 m
.58297 .4004 L
s
.305 .461 .857 r
.38044 .41663 m .37384 .42483 L .35483 .43946 L p F P
0 0 0 r
s
.321 .483 .913 r
.37384 .42483 m .38044 .41663 L .40118 .40526 L p F P
0 0 0 r
s
.24 .35 .67 r
.53387 .36753 m
.53757 .36965 L
s
.144 .204 .437 r
.62479 .52497 m .63631 .5144 L .63028 .49525 L p F P
0 0 0 r
s
.113 .157 .348 r
.63631 .5144 m .62479 .52497 L .62739 .54413 L p F P
0 0 0 r
s
.24 .35 .67 r
.62211 .51832 m
.62616 .5437 L
s
.35557 .70747 m
.33754 .72517 L
s
.33754 .72517 m
.31321 .70755 L
s
.226 .331 .669 r
.60547 .39892 m .59878 .40583 L .6195 .41732 L p F P
0 0 0 r
s
.322 .484 .924 r
.40118 .40526 m .40681 .39835 L .42844 .39087 L p F P
0 0 0 r
s
.322 .484 .924 r
.43289 .38548 m .42844 .39087 L .40681 .39835 L p F P
0 0 0 r
s
.386 .087 .036 r
.51249 .66153 m .52542 .66541 L .52861 .66034 L p F P
0 0 0 r
s
.386 .087 .036 r
.52861 .66034 m .51406 .65595 L .51249 .66153 L p F P
0 0 0 r
s
.952 .285 .123 r
.51142 .37281 m .5086 .37172 L .5172 .36173 L p F P
0 0 0 r
s
.952 .285 .123 r
.5172 .36173 m .52282 .36391 L .51142 .37281 L p F P
0 0 0 r
s
.306 .457 .887 r
.46708 .36752 m .47025 .36376 L .48512 .37273 L p F P
0 0 0 r
s
.306 .457 .887 r
.48673 .37085 m .48512 .37273 L .47025 .36376 L p F P
0 0 0 r
s
.321 .483 .913 r
.40681 .39835 m .40118 .40526 L .38044 .41663 L p F P
0 0 0 r
s
.255 .376 .751 r
.58608 .38593 m .59121 .3805 L .56164 .379 L p F P
0 0 0 r
s
.882 .269 .117 r
.56164 .379 m .55615 .37686 L .58315 .37734 L p F P
0 0 0 r
s
.24 .35 .67 r
.54998 .37676 m
.55927 .38208 L
s
.882 .269 .117 r
.58315 .37734 m .59121 .3805 L .56164 .379 L p F P
0 0 0 r
s
.24 .35 .67 r
.55927 .38208 m
.56305 .37797 L
s
.83 .24 .1 r
.55818 .37904 m
.56428 .38141 L
s
.316 .473 .911 r
.43289 .38548 m .43738 .38005 L .45769 .37869 L p F P
0 0 0 r
s
.316 .473 .911 r
.4608 .37499 m .45769 .37869 L .43738 .38005 L p F P
0 0 0 r
s
.765 .205 .084 r
.37711 .59183 m .39509 .59738 L .39218 .58087 L p F P
0 0 0 r
s
.83 .24 .1 r
.39287 .56219 m
.39308 .58549 L
s
.39308 .58549 m
.42974 .59692 L
s
.765 .205 .084 r
.39218 .58087 m .37368 .57508 L .37711 .59183 L p F P
0 0 0 r
s
.024 .036 .069 r
.60133 .59926 m .59053 .60871 L .58583 .62252 L p F P
0 0 0 r
s
.24 .35 .67 r
.57986 .60765 m
.60199 .58809 L
s
.024 .036 .069 r
.5758 .63121 m .58583 .62252 L .59053 .60871 L p F P
0 0 0 r
s
.952 .285 .123 r
.5086 .37172 m .50578 .37064 L .51156 .35954 L p F P
0 0 0 r
s
.952 .285 .123 r
.51156 .35954 m .5172 .36173 L .5086 .37172 L p F P
0 0 0 r
s
.67 .175 .071 r
.41744 .61706 m .43413 .62215 L .43052 .60832 L p F P
0 0 0 r
s
.67 .175 .071 r
.43052 .60832 m .4129 .60288 L .41744 .61706 L p F P
0 0 0 r
s
.83 .24 .1 r
.42974 .59692 m
.43339 .61668 L
s
.77326 .44557 m
.73997 .43246 L
s
.77326 .44557 m
.78553 .45797 L
s
.169 .243 .509 r
.63028 .49525 m .64144 .4848 L .63159 .4666 L p F P
0 0 0 r
s
.144 .204 .437 r
.64144 .4848 m .63028 .49525 L .63631 .5144 L p F P
0 0 0 r
s
.83 .24 .1 r
.60893 .69076 m
.5948 .68593 L
s
.5948 .68593 m
.55962 .67536 L
s
.24 .35 .67 r
.31321 .70755 m
.29212 .68587 L
s
.30936 .66741 m
.29212 .68587 L
s
.28029 .61583 m
.27406 .58902 L
s
.29096 .56878 m
.27406 .58902 L
s
.306 .457 .887 r
.47025 .36376 m .47344 .35997 L .48673 .37085 L p F P
0 0 0 r
s
.306 .457 .887 r
.48835 .36896 m .48673 .37085 L .47344 .35997 L p F P
0 0 0 r
s
.24 .35 .67 r
.50065 .68986 m
.47997 .70792 L
s
.47997 .70792 m
.45551 .71193 L
s
.952 .285 .123 r
.50578 .37064 m .50295 .36955 L .50591 .35734 L p F P
0 0 0 r
s
.952 .285 .123 r
.50591 .35734 m .51156 .35954 L .50578 .37064 L p F P
0 0 0 r
s
.24 .35 .67 r
.50721 .35785 m
.50765 .35733 L
s
.83 .24 .1 r
.50753 .37758 m
.5226 .36523 L
s
.83 .226 .093 r
.33609 .56331 m .35498 .56922 L .35452 .55091 L p F P
0 0 0 r
s
.83 .226 .093 r
.35452 .55091 m .33557 .54488 L .33609 .56331 L p F P
0 0 0 r
s
.024 .035 .067 r
.31838 .48393 m .31002 .49439 L .30122 .51352 L p F P
0 0 0 r
s
.24 .35 .67 r
.29569 .51931 m
.30239 .51098 L
s
.024 .035 .067 r
.31002 .49439 m .31838 .48393 L .33103 .46577 L p F P
0 0 0 r
s
.83 .24 .1 r
.32159 .51228 m
.32744 .48448 L
s
.28965 .47185 m
.31764 .48121 L
s
.24 .35 .67 r
.33084 .68948 m
.31321 .70755 L
s
.882 .269 .117 r
.55615 .37686 m .55064 .37472 L .57505 .37417 L p F P
0 0 0 r
s
.882 .269 .117 r
.57505 .37417 m .58315 .37734 L .55615 .37686 L p F P
0 0 0 r
s
.952 .285 .123 r
.50295 .36955 m .50012 .36846 L .50024 .35514 L p F P
0 0 0 r
s
.952 .285 .123 r
.50024 .35514 m .50591 .35734 L .50295 .36955 L p F P
0 0 0 r
s
.83 .24 .1 r
.4861 .36937 m
.50753 .37758 L
s
.30506 .5069 m
.32159 .51228 L
s
.306 .457 .887 r
.47344 .35997 m .47664 .35616 L .48835 .36896 L p F P
0 0 0 r
s
.306 .457 .887 r
.48997 .36707 m .48835 .36896 L .47664 .35616 L p F P
0 0 0 r
s
.19 .276 .57 r
.63159 .4666 m .64206 .45656 L .62813 .44023 L p F P
0 0 0 r
s
.169 .243 .509 r
.64206 .45656 m .63159 .4666 L .64144 .4848 L p F P
0 0 0 r
s
.24 .35 .67 r
.61308 .49266 m
.63592 .47093 L
s
.83 .24 .1 r
.28965 .47185 m
.29792 .44308 L
s
.29792 .44308 m
.25955 .42993 L
s
.29792 .44308 m
.30799 .4145 L
s
.024 .035 .067 r
.56072 .64944 m .55181 .65713 L .54602 .66257 L p F P
0 0 0 r
s
.024 .035 .067 r
.53825 .66927 m .54602 .66257 L .55181 .65713 L p F P
0 0 0 r
s
.83 .24 .1 r
.54854 .66493 m
.55962 .67536 L
s
.952 .285 .123 r
.50012 .36846 m .49728 .36737 L .49454 .35293 L p F P
0 0 0 r
s
.952 .285 .123 r
.49454 .35293 m .50024 .35514 L .50012 .36846 L p F P
0 0 0 r
s
.83 .24 .1 r
.30799 .4145 m
.26972 .40104 L
s
.30799 .4145 m
.31954 .38706 L
s
.316 .473 .911 r
.43738 .38005 m .44191 .37457 L .4608 .37499 L p F P
0 0 0 r
s
.83 .24 .1 r
.42059 .36752 m
.44129 .37532 L
s
.24 .35 .67 r
.44152 .39954 m
.46118 .37619 L
s
.316 .473 .911 r
.46394 .37127 m .4608 .37499 L .44191 .37457 L p F P
0 0 0 r
s
.528 .131 .051 r
.45461 .63797 m .46966 .64252 L .46704 .63219 L p F P
0 0 0 r
s
.528 .131 .051 r
.46704 .63219 m .45066 .6272 L .45461 .63797 L p F P
0 0 0 r
s
.241 .354 .711 r
.59121 .3805 m .58608 .38593 L .61223 .39194 L p F P
0 0 0 r
s
.83 .24 .1 r
.59486 .39181 m
.60089 .38933 L
s
.241 .354 .711 r
.60547 .39892 m .61223 .39194 L .58608 .38593 L p F P
0 0 0 r
s
.266 .404 .736 r
.33103 .46577 m .33904 .45572 L .35483 .43946 L p F P
0 0 0 r
s
.024 .035 .067 r
.33904 .45572 m .33103 .46577 L .31838 .48393 L p F P
0 0 0 r
s
.882 .269 .117 r
.55064 .37472 m .54511 .37257 L .56691 .37098 L p F P
0 0 0 r
s
.882 .269 .117 r
.56691 .37098 m .57505 .37417 L .55064 .37472 L p F P
0 0 0 r
s
.322 .484 .924 r
.40681 .39835 m .4125 .39136 L .43289 .38548 L p F P
0 0 0 r
s
.322 .484 .924 r
.43738 .38005 m .43289 .38548 L .4125 .39136 L p F P
0 0 0 r
s
.83 .24 .1 r
.40673 .38916 m
.42059 .36752 L
s
.952 .285 .123 r
.49728 .36737 m .49444 .36627 L .48883 .35071 L p F P
0 0 0 r
s
.952 .285 .123 r
.48883 .35071 m .49454 .35293 L .49728 .36737 L p F P
0 0 0 r
s
.877 .242 .1 r
.29704 .53263 m .31641 .53879 L .32017 .51965 L p F P
0 0 0 r
s
.877 .242 .1 r
.32017 .51965 m .30122 .51352 L .29704 .53263 L p F P
0 0 0 r
s
.83 .24 .1 r
.74754 .71367 m
.72891 .72076 L
s
.72891 .72076 m
.69504 .71052 L
s
.386 .087 .036 r
.49946 .65761 m .51249 .66153 L .51406 .65595 L p F P
0 0 0 r
s
.386 .087 .036 r
.51406 .65595 m .49939 .65151 L .49946 .65761 L p F P
0 0 0 r
s
.83 .24 .1 r
.51312 .6542 m
.54408 .66358 L
s
.50544 .63876 m
.51312 .6542 L
s
.36985 .37557 m
.33219 .36168 L
s
.36985 .37557 m
.38346 .35355 L
s
.306 .457 .887 r
.47664 .35616 m .47986 .35233 L .48997 .36707 L p F P
0 0 0 r
s
.306 .457 .887 r
.49159 .36518 m .48997 .36707 L .47986 .35233 L p F P
0 0 0 r
s
.24 .35 .67 r
.487 .38121 m
.49928 .36702 L
s
.024 .035 .067 r
.58583 .62252 m .5758 .63121 L .56976 .64163 L p F P
0 0 0 r
s
.024 .035 .067 r
.56072 .64944 m .56976 .64163 L .5758 .63121 L p F P
0 0 0 r
s
.83 .24 .1 r
.42059 .36752 m
.38346 .35355 L
s
.209 .305 .622 r
.62813 .44023 m .63762 .43091 L .6195 .41732 L p F P
0 0 0 r
s
.19 .276 .57 r
.63762 .43091 m .62813 .44023 L .64206 .45656 L p F P
0 0 0 r
s
.24 .35 .67 r
.622 .44562 m
.63592 .47093 L
s
.83 .24 .1 r
.69223 .413 m
.65797 .39951 L
s
.69223 .413 m
.70596 .41908 L
s
.952 .285 .123 r
.49444 .36627 m .49159 .36518 L .4831 .34848 L p F P
0 0 0 r
s
.952 .285 .123 r
.4831 .34848 m .48883 .35071 L .49444 .36627 L p F P
0 0 0 r
s
.24 .35 .67 r
.42888 .71013 m
.40942 .72789 L
s
.40942 .72789 m
.38223 .72047 L
s
.226 .331 .669 r
.61223 .39194 m .60547 .39892 L .62773 .40903 L p F P
0 0 0 r
s
.226 .331 .669 r
.6195 .41732 m .62773 .40903 L .60547 .39892 L p F P
0 0 0 r
s
.266 .404 .736 r
.36229 .43014 m .35483 .43946 L .33904 .45572 L p F P
0 0 0 r
s
.24 .35 .67 r
.34103 .45902 m
.35664 .43953 L
s
.305 .461 .857 r
.35483 .43946 m .36229 .43014 L .38044 .41663 L p F P
0 0 0 r
s
.882 .269 .117 r
.54511 .37257 m .53956 .37042 L .55873 .36778 L p F P
0 0 0 r
s
.882 .269 .117 r
.55873 .36778 m .56691 .37098 L .54511 .37257 L p F P
0 0 0 r
s
.209 .305 .622 r
.62773 .40903 m .6195 .41732 L .63762 .43091 L p F P
0 0 0 r
s
.321 .483 .913 r
.38044 .41663 m .38712 .40833 L .40681 .39835 L p F P
0 0 0 r
s
.321 .483 .913 r
.4125 .39136 m .40681 .39835 L .38712 .40833 L p F P
0 0 0 r
s
.24 .35 .67 r
.39454 .40557 m
.417 .39992 L
s
.306 .457 .887 r
.47986 .35233 m .4831 .34848 L .49159 .36518 L p F P
0 0 0 r
s
.305 .461 .857 r
.38712 .40833 m .38044 .41663 L .36229 .43014 L p F P
0 0 0 r
s
.24 .35 .67 r
.37594 .42854 m
.39454 .40557 L
s
.35664 .43953 m
.37594 .42854 L
s
.765 .205 .084 r
.35894 .58623 m .37711 .59183 L .37368 .57508 L p F P
0 0 0 r
s
.765 .205 .084 r
.37368 .57508 m .35498 .56922 L .35894 .58623 L p F P
0 0 0 r
s
.67 .175 .071 r
.40059 .61192 m .41744 .61706 L .4129 .60288 L p F P
0 0 0 r
s
.67 .175 .071 r
.4129 .60288 m .39509 .59738 L .40059 .61192 L p F P
0 0 0 r
s
.316 .473 .911 r
.44191 .37457 m .44648 .36904 L .46394 .37127 L p F P
0 0 0 r
s
.316 .473 .911 r
.46708 .36752 m .46394 .37127 L .44648 .36904 L p F P
0 0 0 r
s
.83 .24 .1 r
.28348 .49986 m
.28965 .47185 L
s
.28965 .47185 m
.25106 .45896 L
s
.24 .35 .67 r
.52195 .68048 m
.50065 .68986 L
s
.882 .269 .117 r
.53956 .37042 m .534 .36826 L .55051 .36456 L p F P
0 0 0 r
s
.882 .269 .117 r
.55051 .36456 m .55873 .36778 L .53956 .37042 L p F P
0 0 0 r
s
.83 .226 .093 r
.317 .55733 m .33609 .56331 L .33557 .54488 L p F P
0 0 0 r
s
.83 .226 .093 r
.33557 .54488 m .31641 .53879 L .317 .55733 L p F P
0 0 0 r
s
.83 .24 .1 r
.31818 .53841 m
.35591 .55043 L
s
.81855 .47088 m
.78553 .45797 L
s
.81855 .47088 m
.82818 .48898 L
s
.31954 .38706 m
.28123 .37326 L
s
.31954 .38706 m
.33219 .36168 L
s
.241 .354 .711 r
.61223 .39194 m .61907 .38488 L .59121 .3805 L p F P
0 0 0 r
s
.83 .24 .1 r
.61522 .38885 m
.64304 .39975 L
s
.748 .235 .103 r
.59121 .3805 m .58315 .37734 L .60862 .38077 L p F P
0 0 0 r
s
.748 .235 .103 r
.60862 .38077 m .61907 .38488 L .59121 .3805 L p F P
0 0 0 r
s
.24 .35 .67 r
.58297 .4004 m
.60086 .38161 L
s
.113 .157 .348 r
.62739 .54413 m .63917 .53352 L .63631 .5144 L p F P
0 0 0 r
s
.079 .107 .249 r
.63917 .53352 m .62739 .54413 L .62698 .56257 L p F P
0 0 0 r
s
.079 .107 .249 r
.61546 .57279 m .62698 .56257 L .62739 .54413 L p F P
0 0 0 r
s
.047 .067 .154 r
.62698 .56257 m .61546 .57279 L .61232 .58964 L p F P
0 0 0 r
s
.24 .35 .67 r
.60347 .56417 m
.62616 .5437 L
s
.047 .067 .154 r
.60133 .59926 m .61232 .58964 L .61546 .57279 L p F P
0 0 0 r
s
.322 .484 .924 r
.4125 .39136 m .41825 .38429 L .43738 .38005 L p F P
0 0 0 r
s
.322 .484 .924 r
.44191 .37457 m .43738 .38005 L .41825 .38429 L p F P
0 0 0 r
s
.528 .131 .051 r
.43942 .63338 m .45461 .63797 L .45066 .6272 L p F P
0 0 0 r
s
.528 .131 .051 r
.45066 .6272 m .43413 .62215 L .43942 .63338 L p F P
0 0 0 r
s
.83 .24 .1 r
.43339 .61668 m
.46979 .62783 L
s
.66045 .70007 m
.64384 .70125 L
s
.64384 .70125 m
.60893 .69076 L
s
.386 .087 .036 r
.48633 .65367 m .49946 .65761 L .49939 .65151 L p F P
0 0 0 r
s
.386 .087 .036 r
.49939 .65151 m .48459 .64704 L .48633 .65367 L p F P
0 0 0 r
s
.882 .269 .117 r
.534 .36826 m .52842 .36609 L .54226 .36133 L p F P
0 0 0 r
s
.882 .269 .117 r
.54226 .36133 m .55051 .36456 L .534 .36826 L p F P
0 0 0 r
s
.144 .204 .437 r
.63631 .5144 m .64804 .50364 L .64144 .4848 L p F P
0 0 0 r
s
.113 .157 .348 r
.64804 .50364 m .63631 .5144 L .63917 .53352 L p F P
0 0 0 r
s
.24 .35 .67 r
.29096 .56878 m
.29043 .54284 L
s
.316 .473 .911 r
.44648 .36904 m .45109 .36347 L .46708 .36752 L p F P
0 0 0 r
s
.316 .473 .911 r
.47025 .36376 m .46708 .36752 L .45109 .36347 L p F P
0 0 0 r
s
.024 .036 .069 r
.61232 .58964 m .60133 .59926 L .59602 .61367 L p F P
0 0 0 r
s
.024 .036 .069 r
.58583 .62252 m .59602 .61367 L .60133 .59926 L p F P
0 0 0 r
s
.24 .35 .67 r
.59515 .60977 m
.60199 .58809 L
s
.041 .06 .137 r
.30989 .50274 m .30122 .51352 L .29704 .53263 L p F P
0 0 0 r
s
.83 .24 .1 r
.30347 .50638 m
.30454 .50673 L
s
.024 .035 .067 r
.30122 .51352 m .30989 .50274 L .31838 .48393 L p F P
0 0 0 r
s
.83 .24 .1 r
.28348 .49986 m
.30347 .50638 L
s
.31818 .53841 m
.32159 .51228 L
s
.169 .243 .509 r
.64144 .4848 m .65278 .47417 L .64206 .45656 L p F P
0 0 0 r
s
.144 .204 .437 r
.65278 .47417 m .64144 .4848 L .64804 .50364 L p F P
0 0 0 r
s
.24 .35 .67 r
.62211 .51832 m
.64531 .49687 L
s
.29222 .64242 m
.28029 .61583 L
s
.29745 .5959 m
.28029 .61583 L
s
.748 .235 .103 r
.58315 .37734 m .57505 .37417 L .59811 .37664 L p F P
0 0 0 r
s
.748 .235 .103 r
.59811 .37664 m .60862 .38077 L .58315 .37734 L p F P
0 0 0 r
s
.24 .35 .67 r
.60356 .37878 m
.60544 .3768 L
s
.882 .269 .117 r
.52842 .36609 m .52282 .36391 L .53396 .35808 L p F P
0 0 0 r
s
.24 .35 .67 r
.52879 .36555 m
.52935 .36577 L
s
.882 .269 .117 r
.53396 .35808 m .54226 .36133 L .52842 .36609 L p F P
0 0 0 r
s
.83 .24 .1 r
.5226 .36523 m
.55818 .37904 L
s
.226 .331 .669 r
.61907 .38488 m .61223 .39194 L .63608 .40063 L p F P
0 0 0 r
s
.226 .331 .669 r
.62773 .40903 m .63608 .40063 L .61223 .39194 L p F P
0 0 0 r
s
.24 .35 .67 r
.60413 .42183 m
.627 .39861 L
s
.024 .035 .067 r
.56976 .64163 m .56072 .64944 L .55389 .65578 L p F P
0 0 0 r
s
.24 .35 .67 r
.56063 .64757 m
.57285 .6292 L
s
.024 .035 .067 r
.54602 .66257 m .55389 .65578 L .56072 .64944 L p F P
0 0 0 r
s
.24 .35 .67 r
.54174 .6639 m
.56063 .64757 L
s
.024 .035 .067 r
.32689 .47328 m .31838 .48393 L .30989 .50274 L p F P
0 0 0 r
s
.24 .35 .67 r
.31291 .49789 m
.31508 .49375 L
s
.31213 .49886 m
.31291 .49789 L
s
.024 .035 .067 r
.31838 .48393 m .32689 .47328 L .33904 .45572 L p F P
0 0 0 r
s
.321 .483 .913 r
.38712 .40833 m .3939 .39993 L .4125 .39136 L p F P
0 0 0 r
s
.321 .483 .913 r
.41825 .38429 m .4125 .39136 L .3939 .39993 L p F P
0 0 0 r
s
.67 .175 .071 r
.38358 .60673 m .40059 .61192 L .39509 .59738 L p F P
0 0 0 r
s
.67 .175 .071 r
.39509 .59738 m .37711 .59183 L .38358 .60673 L p F P
0 0 0 r
s
.83 .24 .1 r
.39308 .58549 m
.39622 .60528 L
s
.765 .205 .084 r
.34058 .58056 m .35894 .58623 L .35498 .56922 L p F P
0 0 0 r
s
.83 .24 .1 r
.35566 .57381 m
.35591 .55043 L
s
.35566 .57381 m
.39308 .58549 L
s
.765 .205 .084 r
.35498 .56922 m .33609 .56331 L .34058 .58056 L p F P
0 0 0 r
s
.19 .276 .57 r
.64206 .45656 m .65271 .44636 L .63762 .43091 L p F P
0 0 0 r
s
.169 .243 .509 r
.65271 .44636 m .64206 .45656 L .65278 .47417 L p F P
0 0 0 r
s
.24 .35 .67 r
.63592 .47093 m
.64531 .49687 L
s
.83 .24 .1 r
.73997 .43246 m
.70596 .41908 L
s
.73997 .43246 m
.7518 .44478 L
s
.209 .305 .622 r
.63608 .40063 m .62773 .40903 L .64726 .42146 L p F P
0 0 0 r
s
.209 .305 .622 r
.63762 .43091 m .64726 .42146 L .62773 .40903 L p F P
0 0 0 r
s
.83 .24 .1 r
.57327 .68005 m
.55962 .67536 L
s
.266 .404 .736 r
.33904 .45572 m .34719 .44551 L .36229 .43014 L p F P
0 0 0 r
s
.024 .035 .067 r
.34719 .44551 m .33904 .45572 L .32689 .47328 L p F P
0 0 0 r
s
.882 .269 .117 r
.52282 .36391 m .5172 .36173 L .52562 .35482 L p F P
0 0 0 r
s
.24 .35 .67 r
.50765 .35733 m
.51777 .36126 L
s
.52301 .3633 m
.52357 .36352 L
s
.882 .269 .117 r
.52562 .35482 m .53396 .35808 L .52282 .36391 L p F P
0 0 0 r
s
.19 .276 .57 r
.64726 .42146 m .63762 .43091 L .65271 .44636 L p F P
0 0 0 r
s
.24 .35 .67 r
.622 .44562 m
.64529 .42275 L
s
.316 .473 .911 r
.45109 .36347 m .45573 .35785 L .47025 .36376 L p F P
0 0 0 r
s
.316 .473 .911 r
.47344 .35997 m .47025 .36376 L .45573 .35785 L p F P
0 0 0 r
s
.24 .35 .67 r
.5039 .35656 m
.50765 .35733 L
s
.322 .484 .924 r
.41825 .38429 m .42407 .37715 L .44191 .37457 L p F P
0 0 0 r
s
.322 .484 .924 r
.44648 .36904 m .44191 .37457 L .42407 .37715 L p F P
0 0 0 r
s
.24 .35 .67 r
.43645 .3763 m
.46118 .37619 L
s
.417 .39992 m
.43645 .3763 L
s
.305 .461 .857 r
.36229 .43014 m .36986 .42067 L .38712 .40833 L p F P
0 0 0 r
s
.305 .461 .857 r
.3939 .39993 m .38712 .40833 L .36986 .42067 L p F P
0 0 0 r
s
.83 .226 .093 r
.2977 .55129 m .317 .55733 L .31641 .53879 L p F P
0 0 0 r
s
.83 .226 .093 r
.31641 .53879 m .29704 .53263 L .2977 .55129 L p F P
0 0 0 r
s
.24 .35 .67 r
.29043 .54284 m
.29711 .53465 L
s
.748 .235 .103 r
.57505 .37417 m .56691 .37098 L .58754 .37248 L p F P
0 0 0 r
s
.748 .235 .103 r
.58754 .37248 m .59811 .37664 L .57505 .37417 L p F P
0 0 0 r
s
.266 .404 .736 r
.36986 .42067 m .36229 .43014 L .34719 .44551 L p F P
0 0 0 r
s
.024 .035 .067 r
.59602 .61367 m .58583 .62252 L .57894 .63371 L p F P
0 0 0 r
s
.024 .035 .067 r
.56976 .64163 m .57894 .63371 L .58583 .62252 L p F P
0 0 0 r
s
.24 .35 .67 r
.57285 .6292 m
.59515 .60977 L
s
.272 .062 .026 r
.5215 .66664 m .53238 .6699 L .53825 .66927 L p F P
0 0 0 r
s
.272 .062 .026 r
.53825 .66927 m .52542 .66541 L .5215 .66664 L p F P
0 0 0 r
s
.273 .421 .783 r
.54602 .66257 m .53825 .66927 L .53238 .6699 L p F P
0 0 0 r
s
.83 .24 .1 r
.53748 .6687 m
.53864 .66905 L
s
.24 .35 .67 r
.52195 .68048 m
.53444 .66968 L
s
.83 .24 .1 r
.53864 .66905 m
.55962 .67536 L
s
.24 .35 .67 r
.40133 .70243 m
.38223 .72047 L
s
.38223 .72047 m
.35557 .70747 L
s
.386 .087 .036 r
.4731 .64969 m .48633 .65367 L .48459 .64704 L p F P
0 0 0 r
s
.386 .087 .036 r
.48459 .64704 m .46966 .64252 L .4731 .64969 L p F P
0 0 0 r
s
.83 .24 .1 r
.47695 .64326 m
.51312 .6542 L
s
.46979 .62783 m
.47695 .64326 L
s
.528 .131 .051 r
.4241 .62875 m .43942 .63338 L .43413 .62215 L p F P
0 0 0 r
s
.528 .131 .051 r
.43413 .62215 m .41744 .61706 L .4241 .62875 L p F P
0 0 0 r
s
.83 .24 .1 r
.27965 .52614 m
.28348 .49986 L
s
.28348 .49986 m
.24456 .48718 L
s
.24 .35 .67 r
.47599 .69373 m
.45551 .71193 L
s
.45551 .71193 m
.42888 .71013 L
s
.882 .269 .117 r
.5172 .36173 m .51156 .35954 L .51724 .35153 L p F P
0 0 0 r
s
.882 .269 .117 r
.51724 .35153 m .52562 .35482 L .5172 .36173 L p F P
0 0 0 r
s
.83 .24 .1 r
.25106 .45896 m
.25955 .42993 L
s
.25955 .42993 m
.22036 .41649 L
s
.25955 .42993 m
.26972 .40104 L
s
.26972 .40104 m
.23062 .3873 L
s
.26972 .40104 m
.28123 .37326 L
s
.71334 .70319 m
.69504 .71052 L
s
.69504 .71052 m
.66045 .70007 L
s
.316 .473 .911 r
.45573 .35785 m .46041 .35218 L .47344 .35997 L p F P
0 0 0 r
s
.83 .24 .1 r
.4349 .34977 m
.45579 .35777 L
s
.316 .473 .911 r
.47664 .35616 m .47344 .35997 L .46041 .35218 L p F P
0 0 0 r
s
.83 .24 .1 r
.33219 .36168 m
.29372 .3475 L
s
.33219 .36168 m
.34553 .33929 L
s
.748 .235 .103 r
.56691 .37098 m .55873 .36778 L .5769 .36829 L p F P
0 0 0 r
s
.24 .35 .67 r
.56933 .37116 m
.57034 .37006 L
s
.748 .235 .103 r
.5769 .36829 m .58754 .37248 L .56691 .37098 L p F P
0 0 0 r
s
.83 .24 .1 r
.57322 .37239 m
.60147 .38346 L
s
.55818 .37904 m
.57322 .37239 L
s
.38346 .35355 m
.34553 .33929 L
s
.38346 .35355 m
.39742 .33542 L
s
.882 .269 .117 r
.51156 .35954 m .50591 .35734 L .50882 .34824 L p F P
0 0 0 r
s
.882 .269 .117 r
.50882 .34824 m .51724 .35153 L .51156 .35954 L p F P
0 0 0 r
s
.24 .35 .67 r
.58137 .35808 m
.60544 .3768 L
s
.61161 .38304 m
.627 .39861 L
s
.60544 .3768 m
.60984 .38125 L
s
.226 .331 .669 r
.63608 .40063 m .64453 .39212 L .61907 .38488 L p F P
0 0 0 r
s
.541 .178 .08 r
.61907 .38488 m .60862 .38077 L .63195 .38715 L p F P
0 0 0 r
s
.541 .178 .08 r
.63195 .38715 m .64453 .39212 L .61907 .38488 L p F P
0 0 0 r
s
.24 .35 .67 r
.627 .39861 m
.63595 .38953 L
s
.67 .175 .071 r
.3664 .60149 m .38358 .60673 L .37711 .59183 L p F P
0 0 0 r
s
.67 .175 .071 r
.37711 .59183 m .35894 .58623 L .3664 .60149 L p F P
0 0 0 r
s
.24 .35 .67 r
.30936 .66741 m
.29222 .64242 L
s
.30972 .62287 m
.29222 .64242 L
s
.321 .483 .913 r
.3939 .39993 m .40076 .39141 L .41825 .38429 L p F P
0 0 0 r
s
.321 .483 .913 r
.42407 .37715 m .41825 .38429 L .40076 .39141 L p F P
0 0 0 r
s
.765 .205 .084 r
.32204 .57484 m .34058 .58056 L .33609 .56331 L p F P
0 0 0 r
s
.765 .205 .084 r
.33609 .56331 m .317 .55733 L .32204 .57484 L p F P
0 0 0 r
s
.322 .484 .924 r
.42407 .37715 m .42995 .36993 L .44648 .36904 L p F P
0 0 0 r
s
.322 .484 .924 r
.45109 .36347 m .44648 .36904 L .42995 .36993 L p F P
0 0 0 r
s
.83 .24 .1 r
.42059 .36752 m
.4349 .34977 L
s
.272 .062 .026 r
.51056 .66335 m .5215 .66664 L .52542 .66541 L p F P
0 0 0 r
s
.272 .062 .026 r
.52542 .66541 m .51249 .66153 L .51056 .66335 L p F P
0 0 0 r
s
.83 .24 .1 r
.51312 .6542 m
.52369 .66456 L
s
.882 .269 .117 r
.50591 .35734 m .50024 .35514 L .50035 .34492 L p F P
0 0 0 r
s
.882 .269 .117 r
.50035 .34492 m .50882 .34824 L .50591 .35734 L p F P
0 0 0 r
s
.83 .24 .1 r
.24456 .48718 m
.25106 .45896 L
s
.25106 .45896 m
.21165 .44579 L
s
.079 .107 .249 r
.62698 .56257 m .63873 .55216 L .63917 .53352 L p F P
0 0 0 r
s
.047 .067 .154 r
.63873 .55216 m .62698 .56257 L .6235 .57985 L p F P
0 0 0 r
s
.047 .067 .154 r
.61232 .58964 m .6235 .57985 L .62698 .56257 L p F P
0 0 0 r
s
.24 .35 .67 r
.62494 .56781 m
.62616 .5437 L
s
.113 .157 .348 r
.63917 .53352 m .65118 .52271 L .64804 .50364 L p F P
0 0 0 r
s
.079 .107 .249 r
.65118 .52271 m .63917 .53352 L .63873 .55216 L p F P
0 0 0 r
s
.386 .087 .036 r
.45977 .64568 m .4731 .64969 L .46966 .64252 L p F P
0 0 0 r
s
.386 .087 .036 r
.46966 .64252 m .45461 .63797 L .45977 .64568 L p F P
0 0 0 r
s
.748 .235 .103 r
.55873 .36778 m .55051 .36456 L .56619 .36407 L p F P
0 0 0 r
s
.748 .235 .103 r
.56619 .36407 m .5769 .36829 L .55873 .36778 L p F P
0 0 0 r
s
.24 .35 .67 r
.57328 .36687 m
.58137 .35808 L
s
.55561 .34314 m
.58137 .35808 L
s
.60429 .33319 m
.58137 .35808 L
s
.316 .473 .911 r
.46041 .35218 m .46514 .34646 L .47664 .35616 L p F P
0 0 0 r
s
.316 .473 .911 r
.47986 .35233 m .47664 .35616 L .46514 .34646 L p F P
0 0 0 r
s
.528 .131 .051 r
.40864 .62408 m .4241 .62875 L .41744 .61706 L p F P
0 0 0 r
s
.528 .131 .051 r
.41744 .61706 m .40059 .61192 L .40864 .62408 L p F P
0 0 0 r
s
.83 .24 .1 r
.39622 .60528 m
.43339 .61668 L
s
.78553 .45797 m
.7518 .44478 L
s
.78553 .45797 m
.79476 .47606 L
s
.144 .204 .437 r
.64804 .50364 m .65998 .49268 L .65278 .47417 L p F P
0 0 0 r
s
.113 .157 .348 r
.65998 .49268 m .64804 .50364 L .65118 .52271 L p F P
0 0 0 r
s
.24 .35 .67 r
.64531 .49687 m
.64969 .52248 L
s
.041 .06 .137 r
.29704 .53263 m .30586 .5218 L .30989 .50274 L p F P
0 0 0 r
s
.061 .089 .214 r
.30586 .5218 m .29704 .53263 L .2977 .55129 L p F P
0 0 0 r
s
.83 .24 .1 r
.27965 .52614 m
.29766 .53188 L
s
.30263 .53346 m
.31818 .53841 L
s
.4349 .34977 m
.39742 .33542 L
s
.24 .35 .67 r
.37428 .6891 m
.35557 .70747 L
s
.35557 .70747 m
.33084 .68948 L
s
.83 .24 .1 r
.28123 .37326 m
.2421 .35916 L
s
.28123 .37326 m
.29372 .3475 L
s
.024 .035 .067 r
.57894 .63371 m .56976 .64163 L .56186 .64891 L p F P
0 0 0 r
s
.024 .035 .067 r
.55389 .65578 m .56186 .64891 L .56976 .64163 L p F P
0 0 0 r
s
.024 .036 .069 r
.6235 .57985 m .61232 .58964 L .60639 .60468 L p F P
0 0 0 r
s
.24 .35 .67 r
.60199 .58809 m
.62494 .56781 L
s
.024 .036 .069 r
.59602 .61367 m .60639 .60468 L .61232 .58964 L p F P
0 0 0 r
s
.209 .305 .622 r
.64453 .39212 m .63608 .40063 L .65703 .41186 L p F P
0 0 0 r
s
.83 .24 .1 r
.64631 .39492 m
.65797 .39951 L
s
.209 .305 .622 r
.64726 .42146 m .65703 .41186 L .63608 .40063 L p F P
0 0 0 r
s
.24 .35 .67 r
.627 .39861 m
.64529 .42275 L
s
.882 .269 .117 r
.50024 .35514 m .49454 .35293 L .49185 .34159 L p F P
0 0 0 r
s
.882 .269 .117 r
.49185 .34159 m .50035 .34492 L .50024 .35514 L p F P
0 0 0 r
s
.041 .06 .137 r
.31872 .49177 m .30989 .50274 L .30586 .5218 L p F P
0 0 0 r
s
.24 .35 .67 r
.31258 .4994 m
.31291 .49789 L
s
.024 .035 .067 r
.30989 .50274 m .31872 .49177 L .32689 .47328 L p F P
0 0 0 r
s
.169 .243 .509 r
.65278 .47417 m .66433 .46335 L .65271 .44636 L p F P
0 0 0 r
s
.144 .204 .437 r
.66433 .46335 m .65278 .47417 L .65998 .49268 L p F P
0 0 0 r
s
.305 .461 .857 r
.36986 .42067 m .37755 .41106 L .3939 .39993 L p F P
0 0 0 r
s
.305 .461 .857 r
.40076 .39141 m .3939 .39993 L .37755 .41106 L p F P
0 0 0 r
s
.83 .24 .1 r
.62512 .68938 m
.60893 .69076 L
s
.60893 .69076 m
.57327 .68005 L
s
.541 .178 .08 r
.60862 .38077 m .59811 .37664 L .61926 .38215 L p F P
0 0 0 r
s
.541 .178 .08 r
.61926 .38215 m .63195 .38715 L .60862 .38077 L p F P
0 0 0 r
s
.83 .24 .1 r
.61259 .38608 m
.62297 .38573 L
s
.273 .421 .783 r
.55389 .65578 m .54602 .66257 L .53891 .66424 L p F P
0 0 0 r
s
.24 .35 .67 r
.54422 .66124 m
.56063 .64757 L
s
.273 .421 .783 r
.53238 .6699 m .53891 .66424 L .54602 .66257 L p F P
0 0 0 r
s
.83 .24 .1 r
.52369 .66456 m
.53471 .66787 L
s
.19 .276 .57 r
.65271 .44636 m .66353 .43599 L .64726 .42146 L p F P
0 0 0 r
s
.169 .243 .509 r
.66353 .43599 m .65271 .44636 L .66433 .46335 L p F P
0 0 0 r
s
.24 .35 .67 r
.63592 .47093 m
.65961 .44838 L
s
.19 .276 .57 r
.65703 .41186 m .64726 .42146 L .66353 .43599 L p F P
0 0 0 r
s
.24 .35 .67 r
.64529 .42275 m
.65961 .44838 L
s
.024 .035 .067 r
.33554 .46244 m .32689 .47328 L .31872 .49177 L p F P
0 0 0 r
s
.024 .035 .067 r
.32689 .47328 m .33554 .46244 L .34719 .44551 L p F P
0 0 0 r
s
.24 .35 .67 r
.33521 .46303 m
.34129 .45541 L
s
.34129 .45541 m
.35664 .43953 L
s
.33084 .68948 m
.30936 .66741 L
s
.32723 .64825 m
.30936 .66741 L
s
.29745 .5959 m
.29096 .56878 L
s
.83 .24 .1 r
.76652 .70035 m
.74754 .71367 L
s
.74754 .71367 m
.71334 .70319 L
s
.748 .235 .103 r
.55051 .36456 m .54226 .36133 L .55541 .35983 L p F P
0 0 0 r
s
.748 .235 .103 r
.55541 .35983 m .56619 .36407 L .55051 .36456 L p F P
0 0 0 r
s
.24 .35 .67 r
.52212 .67112 m
.50065 .68986 L
s
.50065 .68986 m
.47599 .69373 L
s
.266 .404 .736 r
.34719 .44551 m .35547 .43512 L .36986 .42067 L p F P
0 0 0 r
s
.266 .404 .736 r
.37755 .41106 m .36986 .42067 L .35547 .43512 L p F P
0 0 0 r
s
.24 .35 .67 r
.35664 .43953 m
.37514 .41644 L
s
.37514 .41644 m
.39454 .40557 L
s
.024 .035 .067 r
.35547 .43512 m .34719 .44551 L .33554 .46244 L p F P
0 0 0 r
s
.882 .269 .117 r
.49454 .35293 m .48883 .35071 L .4833 .33825 L p F P
0 0 0 r
s
.882 .269 .117 r
.4833 .33825 m .49185 .34159 L .49454 .35293 L p F P
0 0 0 r
s
.83 .24 .1 r
.48626 .35113 m
.5226 .36523 L
s
.272 .062 .026 r
.49954 .66005 m .51056 .66335 L .51249 .66153 L p F P
0 0 0 r
s
.272 .062 .026 r
.51249 .66153 m .49946 .65761 L .49954 .66005 L p F P
0 0 0 r
s
.24 .35 .67 r
.34913 .67073 m
.33084 .68948 L
s
.316 .473 .911 r
.46514 .34646 m .4699 .3407 L .47986 .35233 L p F P
0 0 0 r
s
.316 .473 .911 r
.4831 .34848 m .47986 .35233 L .4699 .3407 L p F P
0 0 0 r
s
.24 .35 .67 r
.46118 .37619 m
.48157 .35198 L
s
.48157 .35198 m
.4912 .35395 L
s
.83 .24 .1 r
.48083 .35583 m
.48626 .35113 L
s
.322 .484 .924 r
.42995 .36993 m .43589 .36264 L .45109 .36347 L p F P
0 0 0 r
s
.322 .484 .924 r
.45573 .35785 m .45109 .36347 L .43589 .36264 L p F P
0 0 0 r
s
.024 .035 .067 r
.60639 .60468 m .59602 .61367 L .58826 .62567 L p F P
0 0 0 r
s
.024 .035 .067 r
.57894 .63371 m .58826 .62567 L .59602 .61367 L p F P
0 0 0 r
s
.67 .175 .071 r
.34906 .5962 m .3664 .60149 L .35894 .58623 L p F P
0 0 0 r
s
.67 .175 .071 r
.35894 .58623 m .34058 .58056 L .34906 .5962 L p F P
0 0 0 r
s
.83 .24 .1 r
.35566 .57381 m
.35825 .59364 L
s
.386 .087 .036 r
.44633 .64165 m .45977 .64568 L .45461 .63797 L p F P
0 0 0 r
s
.386 .087 .036 r
.45461 .63797 m .43942 .63338 L .44633 .64165 L p F P
0 0 0 r
s
.765 .205 .084 r
.3033 .56905 m .32204 .57484 L .317 .55733 L p F P
0 0 0 r
s
.83 .24 .1 r
.31743 .56189 m
.31818 .53841 L
s
.31743 .56189 m
.35566 .57381 L
s
.765 .205 .084 r
.317 .55733 m .2977 .55129 L .3033 .56905 L p F P
0 0 0 r
s
.882 .269 .117 r
.48883 .35071 m .4831 .34848 L .47471 .33488 L p F P
0 0 0 r
s
.882 .269 .117 r
.47471 .33488 m .4833 .33825 L .48883 .35071 L p F P
0 0 0 r
s
.321 .483 .913 r
.40076 .39141 m .40771 .38278 L .42407 .37715 L p F P
0 0 0 r
s
.321 .483 .913 r
.42995 .36993 m .42407 .37715 L .40771 .38278 L p F P
0 0 0 r
s
.83 .24 .1 r
.70596 .41908 m
.71735 .4313 L
s
.541 .178 .08 r
.59811 .37664 m .58754 .37248 L .60648 .37711 L p F P
0 0 0 r
s
.541 .178 .08 r
.60648 .37711 m .61926 .38215 L .59811 .37664 L p F P
0 0 0 r
s
.748 .235 .103 r
.54226 .36133 m .53396 .35808 L .54456 .35556 L p F P
0 0 0 r
s
.83 .24 .1 r
.5226 .36523 m
.53719 .35827 L
s
.748 .235 .103 r
.54456 .35556 m .55541 .35983 L .54226 .36133 L p F P
0 0 0 r
s
.24 .35 .67 r
.54453 .35557 m
.55561 .34314 L
s
.83 .24 .1 r
.82818 .48898 m
.79476 .47606 L
s
.82818 .48898 m
.83415 .51203 L
s
.528 .131 .051 r
.39305 .61936 m .40864 .62408 L .40059 .61192 L p F P
0 0 0 r
s
.528 .131 .051 r
.40059 .61192 m .38358 .60673 L .39305 .61936 L p F P
0 0 0 r
s
.24 .35 .67 r
.52908 .33257 m
.55561 .34314 L
s
.57817 .31784 m
.55561 .34314 L
s
.83 .24 .1 r
.47987 .34865 m
.48626 .35113 L
s
.24 .35 .67 r
.44907 .69171 m
.42888 .71013 L
s
.42888 .71013 m
.40133 .70243 L
s
.83 .24 .1 r
.24029 .51361 m
.27965 .52614 L
s
.27838 .54971 m
.27965 .52614 L
s
.316 .473 .911 r
.4699 .3407 m .47471 .33488 L .4831 .34848 L p F P
0 0 0 r
s
.24 .35 .67 r
.48157 .35198 m
.48519 .34768 L
s
.83 .24 .1 r
.24029 .51361 m
.24456 .48718 L
s
.24456 .48718 m
.2048 .47422 L
s
.272 .062 .026 r
.48846 .65673 m .49954 .66005 L .49946 .65761 L p F P
0 0 0 r
s
.272 .062 .026 r
.49946 .65761 m .48633 .65367 L .48846 .65673 L p F P
0 0 0 r
s
.83 .24 .1 r
.21165 .44579 m
.22036 .41649 L
s
.22036 .41649 m
.18033 .40277 L
s
.22036 .41649 m
.23062 .3873 L
s
.23062 .3873 m
.19069 .37325 L
s
.23062 .3873 m
.2421 .35916 L
s
.748 .235 .103 r
.53396 .35808 m .52562 .35482 L .53364 .35127 L p F P
0 0 0 r
s
.748 .235 .103 r
.53364 .35127 m .54456 .35556 L .53396 .35808 L p F P
0 0 0 r
s
.322 .484 .924 r
.43589 .36264 m .4419 .35525 L .45573 .35785 L p F P
0 0 0 r
s
.322 .484 .924 r
.46041 .35218 m .45573 .35785 L .4419 .35525 L p F P
0 0 0 r
s
.209 .305 .622 r
.65703 .41186 m .66696 .40212 L .64453 .39212 L p F P
0 0 0 r
s
.254 .059 .024 r
.64453 .39212 m .63195 .38715 L .65251 .39642 L p F P
0 0 0 r
s
.83 .24 .1 r
.62297 .38573 m
.63641 .39102 L
s
.24 .35 .67 r
.63651 .38896 m
.63671 .38876 L
s
.254 .059 .024 r
.65251 .39642 m .66696 .40212 L .64453 .39212 L p F P
0 0 0 r
s
.83 .24 .1 r
.6784 .69249 m
.66045 .70007 L
s
.66045 .70007 m
.62512 .68938 L
s
.541 .178 .08 r
.58754 .37248 m .5769 .36829 L .5936 .37203 L p F P
0 0 0 r
s
.541 .178 .08 r
.5936 .37203 m .60648 .37711 L .58754 .37248 L p F P
0 0 0 r
s
.24 .35 .67 r
.60551 .37673 m
.62876 .35232 L
s
.305 .461 .857 r
.37755 .41106 m .38535 .4013 L .40076 .39141 L p F P
0 0 0 r
s
.305 .461 .857 r
.40771 .38278 m .40076 .39141 L .38535 .4013 L p F P
0 0 0 r
s
.83 .24 .1 r
.29372 .3475 m
.25443 .33302 L
s
.29372 .3475 m
.30679 .32471 L
s
.024 .035 .067 r
.58826 .62567 m .57894 .63371 L .56994 .64194 L p F P
0 0 0 r
s
.024 .035 .067 r
.56186 .64891 m .56994 .64194 L .57894 .63371 L p F P
0 0 0 r
s
.24 .35 .67 r
.56063 .64757 m
.58302 .62821 L
s
.83 .24 .1 r
.34553 .33929 m
.30679 .32471 L
s
.34553 .33929 m
.35912 .32076 L
s
.273 .421 .783 r
.56186 .64891 m .55389 .65578 L .54551 .65851 L p F P
0 0 0 r
s
.273 .421 .783 r
.53891 .66424 m .54551 .65851 L .55389 .65578 L p F P
0 0 0 r
s
.386 .087 .036 r
.43279 .63758 m .44633 .64165 L .43942 .63338 L p F P
0 0 0 r
s
.83 .24 .1 r
.44001 .63207 m
.47695 .64326 L
s
.386 .087 .036 r
.43942 .63338 m .4241 .62875 L .43279 .63758 L p F P
0 0 0 r
s
.83 .24 .1 r
.43339 .61668 m
.44001 .63207 L
s
.079 .107 .249 r
.63873 .55216 m .65069 .54156 L .65118 .52271 L p F P
0 0 0 r
s
.047 .067 .154 r
.65069 .54156 m .63873 .55216 L .63489 .56989 L p F P
0 0 0 r
s
.24 .35 .67 r
.62616 .5437 m
.64969 .52248 L
s
.047 .067 .154 r
.6235 .57985 m .63489 .56989 L .63873 .55216 L p F P
0 0 0 r
s
.113 .157 .348 r
.65118 .52271 m .66341 .51169 L .65998 .49268 L p F P
0 0 0 r
s
.079 .107 .249 r
.66341 .51169 m .65118 .52271 L .65069 .54156 L p F P
0 0 0 r
s
.67 .175 .071 r
.33155 .59086 m .34906 .5962 L .34058 .58056 L p F P
0 0 0 r
s
.67 .175 .071 r
.34058 .58056 m .32204 .57484 L .33155 .59086 L p F P
0 0 0 r
s
.19 .276 .57 r
.66696 .40212 m .65703 .41186 L .67453 .42545 L p F P
0 0 0 r
s
.83 .24 .1 r
.66749 .40375 m
.67123 .40542 L
s
.19 .276 .57 r
.66353 .43599 m .67453 .42545 L .65703 .41186 L p F P
0 0 0 r
s
.83 .24 .1 r
.67123 .40542 m
.70596 .41908 L
s
.144 .204 .437 r
.65998 .49268 m .67215 .48152 L .66433 .46335 L p F P
0 0 0 r
s
.113 .157 .348 r
.67215 .48152 m .65998 .49268 L .66341 .51169 L p F P
0 0 0 r
s
.098 .139 .32 r
.30649 .54067 m .2977 .55129 L .3033 .56905 L p F P
0 0 0 r
s
.83 .24 .1 r
.29886 .5561 m
.29996 .55645 L
s
.30456 .55788 m
.31743 .56189 L
s
.24 .35 .67 r
.29096 .56878 m
.29986 .55813 L
s
.061 .089 .214 r
.2977 .55129 m .30649 .54067 L .30586 .5218 L p F P
0 0 0 r
s
.83 .24 .1 r
.27838 .54971 m
.29886 .5561 L
s
.024 .036 .069 r
.63489 .56989 m .6235 .57985 L .61693 .59554 L p F P
0 0 0 r
s
.024 .036 .069 r
.60639 .60468 m .61693 .59554 L .6235 .57985 L p F P
0 0 0 r
s
.24 .35 .67 r
.61828 .58962 m
.62494 .56781 L
s
.748 .235 .103 r
.52562 .35482 m .51724 .35153 L .52265 .34694 L p F P
0 0 0 r
s
.748 .235 .103 r
.52265 .34694 m .53364 .35127 L .52562 .35482 L p F P
0 0 0 r
s
.041 .06 .137 r
.30586 .5218 m .31484 .51077 L .31872 .49177 L p F P
0 0 0 r
s
.061 .089 .214 r
.31484 .51077 m .30586 .5218 L .30649 .54067 L p F P
0 0 0 r
s
.528 .131 .051 r
.37732 .61461 m .39305 .61936 L .38358 .60673 L p F P
0 0 0 r
s
.528 .131 .051 r
.38358 .60673 m .3664 .60149 L .37732 .61461 L p F P
0 0 0 r
s
.83 .24 .1 r
.35825 .59364 m
.39622 .60528 L
s
.321 .483 .913 r
.40771 .38278 m .41476 .37403 L .42995 .36993 L p F P
0 0 0 r
s
.24 .35 .67 r
.39454 .40557 m
.41383 .38174 L
s
.41383 .38174 m
.43645 .3763 L
s
.321 .483 .913 r
.43589 .36264 m .42995 .36993 L .41476 .37403 L p F P
0 0 0 r
s
.83 .24 .1 r
.2048 .47422 m
.21165 .44579 L
s
.21165 .44579 m
.17139 .43234 L
s
.169 .243 .509 r
.66433 .46335 m .67609 .45233 L .66353 .43599 L p F P
0 0 0 r
s
.144 .204 .437 r
.67609 .45233 m .66433 .46335 L .67215 .48152 L p F P
0 0 0 r
s
.24 .35 .67 r
.64531 .49687 m
.66938 .47461 L
s
.266 .404 .736 r
.35547 .43512 m .36389 .42456 L .37755 .41106 L p F P
0 0 0 r
s
.266 .404 .736 r
.38535 .4013 m .37755 .41106 L .36389 .42456 L p F P
0 0 0 r
s
.169 .243 .509 r
.67453 .42545 m .66353 .43599 L .67609 .45233 L p F P
0 0 0 r
s
.24 .35 .67 r
.65961 .44838 m
.66938 .47461 L
s
.041 .06 .137 r
.32772 .48059 m .31872 .49177 L .31484 .51077 L p F P
0 0 0 r
s
.024 .035 .067 r
.31872 .49177 m .32772 .48059 L .33554 .46244 L p F P
0 0 0 r
s
.272 .062 .026 r
.4773 .65338 m .48846 .65673 L .48633 .65367 L p F P
0 0 0 r
s
.272 .062 .026 r
.48633 .65367 m .4731 .64969 L .4773 .65338 L p F P
0 0 0 r
s
.024 .035 .067 r
.34436 .45141 m .33554 .46244 L .32772 .48059 L p F P
0 0 0 r
s
.24 .35 .67 r
.33077 .47567 m
.33331 .47079 L
s
.32991 .47674 m
.33077 .47567 L
s
.024 .035 .067 r
.33554 .46244 m .34436 .45141 L .35547 .43512 L p F P
0 0 0 r
s
.83 .24 .1 r
.7518 .44478 m
.71735 .4313 L
s
.7518 .44478 m
.7606 .46286 L
s
.024 .035 .067 r
.36389 .42456 m .35547 .43512 L .34436 .45141 L p F P
0 0 0 r
s
.24 .35 .67 r
.30972 .62287 m
.29745 .5959 L
s
.83 .24 .1 r
.39742 .33542 m
.35912 .32076 L
s
.39742 .33542 m
.41122 .322 L
s
.541 .178 .08 r
.5769 .36829 m .56619 .36407 L .58062 .36691 L p F P
0 0 0 r
s
.83 .24 .1 r
.53719 .35827 m
.57322 .37239 L
s
.541 .178 .08 r
.58062 .36691 m .5936 .37203 L .5769 .36829 L p F P
0 0 0 r
s
.83 .24 .1 r
.57322 .37239 m
.58721 .37165 L
s
.2421 .35916 m
.20212 .34475 L
s
.2421 .35916 m
.25443 .33302 L
s
.254 .059 .024 r
.63195 .38715 m .61926 .38215 L .63793 .39068 L p F P
0 0 0 r
s
.254 .059 .024 r
.63793 .39068 m .65251 .39642 L .63195 .38715 L p F P
0 0 0 r
s
.322 .484 .924 r
.4419 .35525 m .44798 .34779 L .46041 .35218 L p F P
0 0 0 r
s
.322 .484 .924 r
.46514 .34646 m .46041 .35218 L .44798 .34779 L p F P
0 0 0 r
s
.24 .35 .67 r
.45662 .3518 m
.48157 .35198 L
s
.024 .035 .067 r
.61693 .59554 m .60639 .60468 L .59772 .6175 L p F P
0 0 0 r
s
.024 .035 .067 r
.58826 .62567 m .59772 .6175 L .60639 .60468 L p F P
0 0 0 r
s
.24 .35 .67 r
.59515 .60977 m
.61828 .58962 L
s
.58302 .62821 m
.59515 .60977 L
s
.748 .235 .103 r
.51724 .35153 m .50882 .34824 L .51159 .34259 L p F P
0 0 0 r
s
.748 .235 .103 r
.51159 .34259 m .52265 .34694 L .51724 .35153 L p F P
0 0 0 r
s
.24 .35 .67 r
.51817 .34518 m
.52908 .33257 L
s
.83 .24 .1 r
.58901 .67847 m
.57327 .68005 L
s
.386 .087 .036 r
.41915 .63348 m .43279 .63758 L .4241 .62875 L p F P
0 0 0 r
s
.386 .087 .036 r
.4241 .62875 m .40864 .62408 L .41915 .63348 L p F P
0 0 0 r
s
.83 .24 .1 r
.73206 .68959 m
.71334 .70319 L
s
.71334 .70319 m
.6784 .69249 L
s
.24 .35 .67 r
.50272 .32686 m
.52908 .33257 L
s
.55131 .30686 m
.52908 .33257 L
s
.518 .171 .076 r
.51691 .66377 m .52548 .66634 L .53238 .6699 L p F P
0 0 0 r
s
.518 .171 .076 r
.53238 .6699 m .5215 .66664 L .51691 .66377 L p F P
0 0 0 r
s
.83 .24 .1 r
.48699 .65352 m
.52369 .66456 L
s
.301 .46 .871 r
.53891 .66424 m .53238 .6699 L .52548 .66634 L p F P
0 0 0 r
s
.24 .35 .67 r
.52736 .66884 m
.5283 .66843 L
s
.53743 .66447 m
.53986 .66341 L
s
.52212 .67112 m
.52736 .66884 L
s
.83 .24 .1 r
.53303 .66778 m
.53361 .66798 L
s
.52369 .66456 m
.5278 .66598 L
s
.53684 .6691 m
.57327 .68005 L
s
.53361 .66798 m
.53684 .6691 L
s
.24 .35 .67 r
.42116 .68372 m
.40133 .70243 L
s
.40133 .70243 m
.37428 .6891 L
s
.67 .175 .071 r
.31387 .58547 m .33155 .59086 L .32204 .57484 L p F P
0 0 0 r
s
.67 .175 .071 r
.32204 .57484 m .3033 .56905 L .31387 .58547 L p F P
0 0 0 r
s
.83 .24 .1 r
.31743 .56189 m
.31945 .58175 L
s
.272 .062 .026 r
.46607 .65002 m .4773 .65338 L .4731 .64969 L p F P
0 0 0 r
s
.83 .24 .1 r
.47695 .64326 m
.48699 .65352 L
s
.272 .062 .026 r
.4731 .64969 m .45977 .64568 L .46607 .65002 L p F P
0 0 0 r
s
.541 .178 .08 r
.56619 .36407 m .55541 .35983 L .56754 .36175 L p F P
0 0 0 r
s
.541 .178 .08 r
.56754 .36175 m .58062 .36691 L .56619 .36407 L p F P
0 0 0 r
s
.24 .35 .67 r
.49725 .67484 m
.47599 .69373 L
s
.47599 .69373 m
.44907 .69171 L
s
.748 .235 .103 r
.50882 .34824 m .50035 .34492 L .50046 .33821 L p F P
0 0 0 r
s
.748 .235 .103 r
.50046 .33821 m .51159 .34259 L .50882 .34824 L p F P
0 0 0 r
s
.305 .461 .857 r
.38535 .4013 m .39327 .3914 L .40771 .38278 L p F P
0 0 0 r
s
.305 .461 .857 r
.41476 .37403 m .40771 .38278 L .39327 .3914 L p F P
0 0 0 r
s
.528 .131 .051 r
.36145 .60981 m .37732 .61461 L .3664 .60149 L p F P
0 0 0 r
s
.528 .131 .051 r
.3664 .60149 m .34906 .5962 L .36145 .60981 L p F P
0 0 0 r
s
.273 .421 .783 r
.56994 .64194 m .56186 .64891 L .55219 .65272 L p F P
0 0 0 r
s
.273 .421 .783 r
.54551 .65851 m .55219 .65272 L .56186 .64891 L p F P
0 0 0 r
s
.254 .059 .024 r
.61926 .38215 m .60648 .37711 L .62322 .38488 L p F P
0 0 0 r
s
.254 .059 .024 r
.62322 .38488 m .63793 .39068 L .61926 .38215 L p F P
0 0 0 r
s
.24 .35 .67 r
.63671 .38876 m
.65073 .37452 L
s
.321 .483 .913 r
.41476 .37403 m .4219 .36516 L .43589 .36264 L p F P
0 0 0 r
s
.321 .483 .913 r
.4419 .35525 m .43589 .36264 L .4219 .36516 L p F P
0 0 0 r
s
.24 .35 .67 r
.43645 .3763 m
.45662 .3518 L
s
.83 .24 .1 r
.66756 .40397 m
.67123 .40542 L
s
.79476 .47606 m
.7606 .46286 L
s
.79476 .47606 m
.80034 .49919 L
s
.024 .035 .067 r
.59772 .6175 m .58826 .62567 L .57813 .63487 L p F P
0 0 0 r
s
.024 .035 .067 r
.56994 .64194 m .57813 .63487 L .58826 .62567 L p F P
0 0 0 r
s
.83 .24 .1 r
.78489 .68126 m
.76652 .70035 L
s
.76652 .70035 m
.73206 .68959 L
s
.322 .484 .924 r
.44798 .34779 m .45413 .34025 L .46514 .34646 L p F P
0 0 0 r
s
.83 .24 .1 r
.4349 .34977 m
.44915 .33672 L
s
.322 .484 .924 r
.4699 .3407 m .46514 .34646 L .45413 .34025 L p F P
0 0 0 r
s
.83 .24 .1 r
.44915 .33672 m
.45856 .34037 L
s
.44915 .33672 m
.41122 .322 L
s
.24 .35 .67 r
.60429 .33319 m
.62876 .35232 L
s
.65295 .32691 m
.62876 .35232 L
s
.62876 .35232 m
.65073 .37452 L
s
.518 .171 .076 r
.5083 .66119 m .51691 .66377 L .5215 .66664 L p F P
0 0 0 r
s
.518 .171 .076 r
.5215 .66664 m .51056 .66335 L .5083 .66119 L p F P
0 0 0 r
s
.83 .24 .1 r
.20007 .50081 m
.24029 .51361 L
s
.23848 .53727 m
.24029 .51361 L
s
.24 .35 .67 r
.67536 .34952 m
.65073 .37452 L
s
.748 .235 .103 r
.50035 .34492 m .49185 .34159 L .48926 .3338 L p F P
0 0 0 r
s
.24 .35 .67 r
.49069 .34114 m
.49141 .34029 L
s
.748 .235 .103 r
.48926 .3338 m .50046 .33821 L .50035 .34492 L p F P
0 0 0 r
s
.83 .24 .1 r
.48626 .35113 m
.50039 .34385 L
s
.24 .35 .67 r
.49498 .33605 m
.50272 .32686 L
s
.19 .276 .57 r
.67453 .42545 m .68572 .41472 L .66696 .40212 L p F P
0 0 0 r
s
.378 .084 .035 r
.66696 .40212 m .65251 .39642 L .66973 .40845 L p F P
0 0 0 r
s
.24 .35 .67 r
.65073 .37452 m
.66944 .39903 L
s
.66632 .40209 m
.66644 .40197 L
s
.64529 .42275 m
.66396 .40441 L
s
.66644 .40197 m
.66944 .39903 L
s
.378 .084 .035 r
.66973 .40845 m .68572 .41472 L .66696 .40212 L p F P
0 0 0 r
s
.83 .24 .1 r
.20007 .50081 m
.2048 .47422 L
s
.2048 .47422 m
.16417 .46098 L
s
.386 .087 .036 r
.40539 .62934 m .41915 .63348 L .40864 .62408 L p F P
0 0 0 r
s
.386 .087 .036 r
.40864 .62408 m .39305 .61936 L .40539 .62934 L p F P
0 0 0 r
s
.83 .24 .1 r
.40228 .62065 m
.44001 .63207 L
s
.39622 .60528 m
.40228 .62065 L
s
.24 .35 .67 r
.32723 .64825 m
.30972 .62287 L
s
.32788 .60257 m
.30972 .62287 L
s
.83 .24 .1 r
.18033 .40277 m
.17139 .43234 L
s
.19069 .37325 m
.18033 .40277 L
s
.541 .178 .08 r
.55541 .35983 m .54456 .35556 L .55435 .35655 L p F P
0 0 0 r
s
.83 .24 .1 r
.53719 .35827 m
.55068 .35727 L
s
.541 .178 .08 r
.55435 .35655 m .56754 .36175 L .55541 .35983 L p F P
0 0 0 r
s
.266 .404 .736 r
.36389 .42456 m .37245 .41382 L .38535 .4013 L p F P
0 0 0 r
s
.266 .404 .736 r
.39327 .3914 m .38535 .4013 L .37245 .41382 L p F P
0 0 0 r
s
.83 .24 .1 r
.20212 .34475 m
.19069 .37325 L
s
.83415 .51203 m
.80034 .49919 L
s
.83415 .51203 m
.83598 .53904 L
s
.272 .062 .026 r
.45477 .64663 m .46607 .65002 L .45977 .64568 L p F P
0 0 0 r
s
.272 .062 .026 r
.45977 .64568 m .44633 .64165 L .45477 .64663 L p F P
0 0 0 r
s
.079 .107 .249 r
.65069 .54156 m .66287 .53076 L .66341 .51169 L p F P
0 0 0 r
s
.047 .067 .154 r
.66287 .53076 m .65069 .54156 L .64648 .55974 L p F P
0 0 0 r
s
.047 .067 .154 r
.63489 .56989 m .64648 .55974 L .65069 .54156 L p F P
0 0 0 r
s
.24 .35 .67 r
.64874 .54677 m
.64969 .52248 L
s
.113 .157 .348 r
.66341 .51169 m .67587 .50047 L .67215 .48152 L p F P
0 0 0 r
s
.079 .107 .249 r
.67587 .50047 m .66341 .51169 L .66287 .53076 L p F P
0 0 0 r
s
.024 .036 .069 r
.64648 .55974 m .63489 .56989 L .62765 .58624 L p F P
0 0 0 r
s
.24 .35 .67 r
.62494 .56781 m
.64874 .54677 L
s
.024 .036 .069 r
.61693 .59554 m .62765 .58624 L .63489 .56989 L p F P
0 0 0 r
s
.169 .243 .509 r
.68572 .41472 m .67453 .42545 L .68806 .44112 L p F P
0 0 0 r
s
.169 .243 .509 r
.67609 .45233 m .68806 .44112 L .67453 .42545 L p F P
0 0 0 r
s
.83 .24 .1 r
.64269 .68155 m
.62512 .68938 L
s
.62512 .68938 m
.58901 .67847 L
s
.24 .35 .67 r
.57817 .31784 m
.60429 .33319 L
s
.62808 .30736 m
.60429 .33319 L
s
.301 .46 .871 r
.54551 .65851 m .53891 .66424 L .53058 .66188 L p F P
0 0 0 r
s
.301 .46 .871 r
.52548 .66634 m .53058 .66188 L .53891 .66424 L p F P
0 0 0 r
s
.83 .24 .1 r
.25443 .33302 m
.21428 .31822 L
s
.25443 .33302 m
.26721 .30982 L
s
.144 .204 .437 r
.67215 .48152 m .68455 .47015 L .67609 .45233 L p F P
0 0 0 r
s
.113 .157 .348 r
.68455 .47015 m .67215 .48152 L .67587 .50047 L p F P
0 0 0 r
s
.24 .35 .67 r
.66938 .47461 m
.67411 .50047 L
s
.098 .139 .32 r
.3033 .56905 m .3119 .55889 L .30649 .54067 L p F P
0 0 0 r
s
.098 .139 .32 r
.31545 .52985 m .30649 .54067 L .3119 .55889 L p F P
0 0 0 r
s
.24 .35 .67 r
.30813 .53478 m
.30824 .53856 L
s
.061 .089 .214 r
.30649 .54067 m .31545 .52985 L .31484 .51077 L p F P
0 0 0 r
s
.83 .24 .1 r
.30679 .32471 m
.26721 .30982 L
s
.30679 .32471 m
.32 .30578 L
s
.24 .35 .67 r
.3937 .67003 m
.37428 .6891 L
s
.37428 .6891 m
.34913 .67073 L
s
.254 .059 .024 r
.60648 .37711 m .5936 .37203 L .60838 .37904 L p F P
0 0 0 r
s
.254 .059 .024 r
.60838 .37904 m .62322 .38488 L .60648 .37711 L p F P
0 0 0 r
s
.83 .24 .1 r
.58721 .37165 m
.62297 .38573 L
s
.144 .204 .437 r
.68806 .44112 m .67609 .45233 L .68455 .47015 L p F P
0 0 0 r
s
.24 .35 .67 r
.65961 .44838 m
.68419 .42499 L
s
.041 .06 .137 r
.31484 .51077 m .32399 .49953 L .32772 .48059 L p F P
0 0 0 r
s
.061 .089 .214 r
.32399 .49953 m .31484 .51077 L .31545 .52985 L p F P
0 0 0 r
s
.83 .24 .1 r
.27981 .5696 m
.27838 .54971 L
s
.27838 .54971 m
.23848 .53727 L
s
.136 .196 .427 r
.3119 .55889 m .3033 .56905 L .31387 .58547 L p F P
0 0 0 r
s
.24 .35 .67 r
.29745 .5959 m
.31069 .58054 L
s
.024 .035 .067 r
.34436 .45141 m .35333 .44018 L .36389 .42456 L p F P
0 0 0 r
s
.024 .035 .067 r
.37245 .41382 m .36389 .42456 L .35333 .44018 L p F P
0 0 0 r
s
.24 .35 .67 r
.35977 .43229 m
.37514 .41644 L
s
.748 .235 .103 r
.49185 .34159 m .4833 .33825 L .47798 .32936 L p F P
0 0 0 r
s
.748 .235 .103 r
.47798 .32936 m .48926 .3338 L .49185 .34159 L p F P
0 0 0 r
s
.528 .131 .051 r
.34544 .60497 m .36145 .60981 L .34906 .5962 L p F P
0 0 0 r
s
.83 .24 .1 r
.35825 .59364 m
.36372 .60898 L
s
.528 .131 .051 r
.34906 .5962 m .33155 .59086 L .34544 .60497 L p F P
0 0 0 r
s
.83 .24 .1 r
.31945 .58175 m
.35825 .59364 L
s
.041 .06 .137 r
.33688 .46919 m .32772 .48059 L .32399 .49953 L p F P
0 0 0 r
s
.24 .35 .67 r
.32575 .49953 m
.32748 .49132 L
s
.33045 .47719 m
.33077 .47567 L
s
.024 .035 .067 r
.32772 .48059 m .33688 .46919 L .34436 .45141 L p F P
0 0 0 r
s
.518 .171 .076 r
.49964 .65859 m .5083 .66119 L .51056 .66335 L p F P
0 0 0 r
s
.518 .171 .076 r
.51056 .66335 m .49954 .66005 L .49964 .65859 L p F P
0 0 0 r
s
.024 .035 .067 r
.35333 .44018 m .34436 .45141 L .33688 .46919 L p F P
0 0 0 r
s
.24 .35 .67 r
.35301 .44076 m
.35977 .43229 L
s
.024 .035 .067 r
.62765 .58624 m .61693 .59554 L .60733 .60921 L p F P
0 0 0 r
s
.024 .035 .067 r
.59772 .6175 m .60733 .60921 L .61693 .59554 L p F P
0 0 0 r
s
.322 .484 .924 r
.45413 .34025 m .46034 .33261 L .4699 .3407 L p F P
0 0 0 r
s
.322 .484 .924 r
.47471 .33488 m .4699 .3407 L .46034 .33261 L p F P
0 0 0 r
s
.24 .35 .67 r
.67624 .411 m
.68419 .42499 L
s
.541 .178 .08 r
.54456 .35556 m .53364 .35127 L .54106 .35131 L p F P
0 0 0 r
s
.83 .24 .1 r
.50039 .34385 m
.53719 .35827 L
s
.541 .178 .08 r
.54106 .35131 m .55435 .35655 L .54456 .35556 L p F P
0 0 0 r
s
.24 .35 .67 r
.34913 .67073 m
.32723 .64825 L
s
.34579 .62837 m
.32723 .64825 L
s
.83 .24 .1 r
.17139 .43234 m
.16417 .46098 L
s
.321 .483 .913 r
.4219 .36516 m .42913 .35618 L .4419 .35525 L p F P
0 0 0 r
s
.321 .483 .913 r
.44798 .34779 m .4419 .35525 L .42913 .35618 L p F P
0 0 0 r
s
.24 .35 .67 r
.52212 .67112 m
.52652 .66727 L
s
.52212 .67112 m
.49725 .67484 L
s
.36812 .65126 m
.34913 .67073 L
s
.305 .461 .857 r
.39327 .3914 m .40132 .38134 L .41476 .37403 L p F P
0 0 0 r
s
.305 .461 .857 r
.4219 .36516 m .41476 .37403 L .40132 .38134 L p F P
0 0 0 r
s
.378 .084 .035 r
.65251 .39642 m .63793 .39068 L .65359 .40211 L p F P
0 0 0 r
s
.83 .24 .1 r
.65284 .39818 m
.65785 .40015 L
s
.378 .084 .035 r
.65359 .40211 m .66973 .40845 L .65251 .39642 L p F P
0 0 0 r
s
.24 .35 .67 r
.66944 .39903 m
.67425 .40749 L
s
.66944 .39903 m
.69452 .3744 L
s
.386 .087 .036 r
.39154 .62518 m .40539 .62934 L .39305 .61936 L p F P
0 0 0 r
s
.386 .087 .036 r
.39305 .61936 m .37732 .61461 L .39154 .62518 L p F P
0 0 0 r
s
.273 .421 .783 r
.57813 .63487 m .56994 .64194 L .55895 .64687 L p F P
0 0 0 r
s
.273 .421 .783 r
.55219 .65272 m .55895 .64687 L .56994 .64194 L p F P
0 0 0 r
s
.24 .35 .67 r
.56564 .64269 m
.56591 .64245 L
s
.83 .24 .1 r
.71735 .4313 m
.7257 .44937 L
s
.35912 .32076 m
.32 .30578 L
s
.35912 .32076 m
.37246 .30695 L
s
.272 .062 .026 r
.44339 .64322 m .45477 .64663 L .44633 .64165 L p F P
0 0 0 r
s
.272 .062 .026 r
.44633 .64165 m .43279 .63758 L .44339 .64322 L p F P
0 0 0 r
s
.83 .24 .1 r
.21428 .31822 m
.20212 .34475 L
s
.748 .235 .103 r
.4833 .33825 m .47471 .33488 L .46663 .3249 L p F P
0 0 0 r
s
.748 .235 .103 r
.46663 .3249 m .47798 .32936 L .4833 .33825 L p F P
0 0 0 r
s
.24 .35 .67 r
.4758 .32851 m
.47756 .32637 L
s
.518 .171 .076 r
.49094 .65597 m .49964 .65859 L .49954 .66005 L p F P
0 0 0 r
s
.518 .171 .076 r
.49954 .66005 m .48846 .65673 L .49094 .65597 L p F P
0 0 0 r
s
.254 .059 .024 r
.5936 .37203 m .58062 .36691 L .59341 .37314 L p F P
0 0 0 r
s
.254 .059 .024 r
.59341 .37314 m .60838 .37904 L .5936 .37203 L p F P
0 0 0 r
s
.83 .24 .1 r
.53684 .6691 m
.55211 .66731 L
s
.52942 .66687 m
.53684 .6691 L
s
.024 .035 .067 r
.60733 .60921 m .59772 .6175 L .58642 .62771 L p F P
0 0 0 r
s
.024 .035 .067 r
.57813 .63487 m .58642 .62771 L .59772 .6175 L p F P
0 0 0 r
s
.24 .35 .67 r
.56591 .64245 m
.58302 .62821 L
s
.47756 .32637 m
.50272 .32686 L
s
.52469 .30077 m
.50272 .32686 L
s
.83 .24 .1 r
.69684 .67858 m
.6784 .69249 L
s
.6784 .69249 m
.64269 .68155 L
s
.27981 .5696 m
.3106 .57904 L
s
.31345 .57991 m
.31945 .58175 L
s
.541 .178 .08 r
.53364 .35127 m .52265 .34694 L .52767 .34603 L p F P
0 0 0 r
s
.541 .178 .08 r
.52767 .34603 m .54106 .35131 L .53364 .35127 L p F P
0 0 0 r
s
.24 .35 .67 r
.55131 .30686 m
.57817 .31784 L
s
.60159 .29157 m
.57817 .31784 L
s
.301 .46 .871 r
.55219 .65272 m .54551 .65851 L .53573 .65738 L p F P
0 0 0 r
s
.301 .46 .871 r
.53058 .66188 m .53573 .65738 L .54551 .65851 L p F P
0 0 0 r
s
.528 .131 .051 r
.32928 .60009 m .34544 .60497 L .33155 .59086 L p F P
0 0 0 r
s
.528 .131 .051 r
.33155 .59086 m .31387 .58547 L .32928 .60009 L p F P
0 0 0 r
s
.24 .35 .67 r
.47003 .67258 m
.44907 .69171 L
s
.44907 .69171 m
.42116 .68372 L
s
.322 .484 .924 r
.46034 .33261 m .46663 .3249 L .47471 .33488 L p F P
0 0 0 r
s
.83 .24 .1 r
.46277 .32911 m
.4631 .32923 L
s
.47039 .33209 m
.50039 .34385 L
s
.24 .35 .67 r
.45662 .3518 m
.47329 .33156 L
s
.266 .404 .736 r
.37245 .41382 m .38117 .4029 L .39327 .3914 L p F P
0 0 0 r
s
.266 .404 .736 r
.40132 .38134 m .39327 .3914 L .38117 .4029 L p F P
0 0 0 r
s
.24 .35 .67 r
.37514 .41644 m
.39434 .39248 L
s
.39434 .39248 m
.41383 .38174 L
s
.272 .062 .026 r
.43194 .63978 m .44339 .64322 L .43279 .63758 L p F P
0 0 0 r
s
.83 .24 .1 r
.44001 .63207 m
.44949 .64225 L
s
.272 .062 .026 r
.43279 .63758 m .41915 .63348 L .43194 .63978 L p F P
0 0 0 r
s
.378 .084 .035 r
.63793 .39068 m .62322 .38488 L .63728 .39571 L p F P
0 0 0 r
s
.83 .24 .1 r
.63773 .39223 m
.64278 .39422 L
s
.62297 .38573 m
.6262 .38718 L
s
.378 .084 .035 r
.63728 .39571 m .65359 .40211 L .63793 .39068 L p F P
0 0 0 r
s
.386 .087 .036 r
.37757 .62098 m .39154 .62518 L .37732 .61461 L p F P
0 0 0 r
s
.386 .087 .036 r
.37732 .61461 m .36145 .60981 L .37757 .62098 L p F P
0 0 0 r
s
.83 .24 .1 r
.36372 .60898 m
.40228 .62065 L
s
.518 .171 .076 r
.4822 .65335 m .49094 .65597 L .48846 .65673 L p F P
0 0 0 r
s
.518 .171 .076 r
.48846 .65673 m .4773 .65338 L .4822 .65335 L p F P
0 0 0 r
s
.83 .24 .1 r
.44949 .64225 m
.48699 .65352 L
s
.48699 .65352 m
.49961 .65792 L
s
.7606 .46286 m
.7257 .44937 L
s
.7606 .46286 m
.76579 .48607 L
s
.321 .483 .913 r
.42913 .35618 m .43647 .34707 L .44798 .34779 L p F P
0 0 0 r
s
.24 .35 .67 r
.43384 .35701 m
.45662 .3518 L
s
.321 .483 .913 r
.45413 .34025 m .44798 .34779 L .43647 .34707 L p F P
0 0 0 r
s
.83 .24 .1 r
.75025 .67016 m
.73206 .68959 L
s
.73206 .68959 m
.69684 .67858 L
s
.254 .059 .024 r
.58062 .36691 m .56754 .36175 L .5783 .36718 L p F P
0 0 0 r
s
.254 .059 .024 r
.5783 .36718 m .59341 .37314 L .58062 .36691 L p F P
0 0 0 r
s
.83 .24 .1 r
.55068 .35727 m
.58721 .37165 L
s
.80165 .65721 m
.78489 .68126 L
s
.78489 .68126 m
.75025 .67016 L
s
.41122 .322 m
.37246 .30695 L
s
.41122 .322 m
.42432 .31404 L
s
.169 .243 .509 r
.68806 .44112 m .70025 .4297 L .68572 .41472 L p F P
0 0 0 r
s
.525 .13 .05 r
.68572 .41472 m .66973 .40845 L .68308 .42301 L p F P
0 0 0 r
s
.525 .13 .05 r
.68308 .42301 m .70025 .4297 L .68572 .41472 L p F P
0 0 0 r
s
.24 .35 .67 r
.68419 .42499 m
.68534 .42389 L
s
.68985 .4196 m
.69076 .41874 L
s
.69076 .41874 m
.70971 .40071 L
s
.541 .178 .08 r
.52265 .34694 m .51159 .34259 L .51417 .34071 L p F P
0 0 0 r
s
.541 .178 .08 r
.51417 .34071 m .52767 .34603 L .52265 .34694 L p F P
0 0 0 r
s
.079 .107 .249 r
.66287 .53076 m .67529 .51975 L .67587 .50047 L p F P
0 0 0 r
s
.047 .067 .154 r
.67529 .51975 m .66287 .53076 L .65828 .54941 L p F P
0 0 0 r
s
.24 .35 .67 r
.64969 .52248 m
.67411 .50047 L
s
.047 .067 .154 r
.64648 .55974 m .65828 .54941 L .66287 .53076 L p F P
0 0 0 r
s
.83 .24 .1 r
.15896 .48772 m
.20007 .50081 L
s
.19769 .52455 m
.20007 .50081 L
s
.024 .036 .069 r
.65828 .54941 m .64648 .55974 L .63855 .57679 L p F P
0 0 0 r
s
.024 .036 .069 r
.62765 .58624 m .63855 .57679 L .64648 .55974 L p F P
0 0 0 r
s
.24 .35 .67 r
.64229 .56871 m
.64874 .54677 L
s
.024 .035 .067 r
.35333 .44018 m .36247 .42874 L .37245 .41382 L p F P
0 0 0 r
s
.024 .035 .067 r
.38117 .4029 m .37245 .41382 L .36247 .42874 L p F P
0 0 0 r
s
.113 .157 .348 r
.67587 .50047 m .68857 .48903 L .68455 .47015 L p F P
0 0 0 r
s
.079 .107 .249 r
.68857 .48903 m .67587 .50047 L .67529 .51975 L p F P
0 0 0 r
s
.83 .24 .1 r
.16417 .46098 m
.15896 .48772 L
s
.305 .461 .857 r
.40132 .38134 m .40949 .37112 L .4219 .36516 L p F P
0 0 0 r
s
.305 .461 .857 r
.42913 .35618 m .4219 .36516 L .40949 .37112 L p F P
0 0 0 r
s
.24 .35 .67 r
.41383 .38174 m
.43384 .35701 L
s
.144 .204 .437 r
.70025 .4297 m .68806 .44112 L .69718 .45856 L p F P
0 0 0 r
s
.83 .24 .1 r
.6923 .42151 m
.71735 .4313 L
s
.144 .204 .437 r
.68455 .47015 m .69718 .45856 L .68806 .44112 L p F P
0 0 0 r
s
.24 .35 .67 r
.68419 .42499 m
.69436 .45151 L
s
.113 .157 .348 r
.69718 .45856 m .68455 .47015 L .68857 .48903 L p F P
0 0 0 r
s
.24 .35 .67 r
.66938 .47461 m
.69436 .45151 L
s
.098 .139 .32 r
.3119 .55889 m .32065 .54855 L .31545 .52985 L p F P
0 0 0 r
s
.098 .139 .32 r
.32457 .51883 m .31545 .52985 L .32065 .54855 L p F P
0 0 0 r
s
.061 .089 .214 r
.31545 .52985 m .32457 .51883 L .32399 .49953 L p F P
0 0 0 r
s
.24 .35 .67 r
.32405 .50162 m
.32575 .49953 L
s
.136 .196 .427 r
.31387 .58547 m .32209 .576 L .3119 .55889 L p F P
0 0 0 r
s
.136 .196 .427 r
.32065 .54855 m .3119 .55889 L .32209 .576 L p F P
0 0 0 r
s
.273 .421 .783 r
.58642 .62771 m .57813 .63487 L .56578 .64095 L p F P
0 0 0 r
s
.24 .35 .67 r
.58302 .62821 m
.60625 .60812 L
s
.273 .421 .783 r
.55895 .64687 m .56578 .64095 L .57813 .63487 L p F P
0 0 0 r
s
.83 .24 .1 r
.83598 .53904 m
.80184 .52636 L
s
.83598 .53904 m
.83346 .56866 L
s
.041 .06 .137 r
.32399 .49953 m .33332 .48807 L .33688 .46919 L p F P
0 0 0 r
s
.061 .089 .214 r
.33332 .48807 m .32399 .49953 L .32457 .51883 L p F P
0 0 0 r
s
.024 .035 .067 r
.63855 .57679 m .62765 .58624 L .61708 .60079 L p F P
0 0 0 r
s
.024 .035 .067 r
.60733 .60921 m .61708 .60079 L .62765 .58624 L p F P
0 0 0 r
s
.24 .35 .67 r
.60625 .60812 m
.61828 .58962 L
s
.61828 .58962 m
.64229 .56871 L
s
.024 .035 .067 r
.33688 .46919 m .34622 .45759 L .35333 .44018 L p F P
0 0 0 r
s
.024 .035 .067 r
.36247 .42874 m .35333 .44018 L .34622 .45759 L p F P
0 0 0 r
s
.24 .35 .67 r
.34836 .45378 m
.3493 .45261 L
s
.3493 .45261 m
.3523 .44679 L
s
.83 .24 .1 r
.80034 .49919 m
.76579 .48607 L
s
.80034 .49919 m
.80184 .52636 L
s
.041 .06 .137 r
.34622 .45759 m .33688 .46919 L .33332 .48807 L p F P
0 0 0 r
s
.518 .171 .076 r
.47341 .65071 m .4822 .65335 L .4773 .65338 L p F P
0 0 0 r
s
.518 .171 .076 r
.4773 .65338 m .46607 .65002 L .47341 .65071 L p F P
0 0 0 r
s
.166 .243 .512 r
.32209 .576 m .31387 .58547 L .32928 .60009 L p F P
0 0 0 r
s
.83 .24 .1 r
.60619 .67037 m
.58901 .67847 L
s
.58901 .67847 m
.55211 .66731 L
s
.22675 .29459 m
.21428 .31822 L
s
.272 .062 .026 r
.42041 .63633 m .43194 .63978 L .41915 .63348 L p F P
0 0 0 r
s
.272 .062 .026 r
.41915 .63348 m .40539 .62934 L .42041 .63633 L p F P
0 0 0 r
s
.24 .35 .67 r
.32475 .59579 m
.32788 .60257 L
s
.83 .24 .1 r
.26721 .30982 m
.22675 .29459 L
s
.26721 .30982 m
.28 .29047 L
s
.301 .46 .871 r
.55895 .64687 m .55219 .65272 L .54093 .65283 L p F P
0 0 0 r
s
.301 .46 .871 r
.53573 .65738 m .54093 .65283 L .55219 .65272 L p F P
0 0 0 r
s
.83 .24 .1 r
.23929 .55718 m
.23848 .53727 L
s
.23848 .53727 m
.19769 .52455 L
s
.541 .178 .08 r
.51159 .34259 m .50046 .33821 L .50057 .33534 L p F P
0 0 0 r
s
.541 .178 .08 r
.50057 .33534 m .51417 .34071 L .51159 .34259 L p F P
0 0 0 r
s
.83 .24 .1 r
.50039 .34385 m
.51334 .34257 L
s
.378 .084 .035 r
.62322 .38488 m .60838 .37904 L .62081 .38925 L p F P
0 0 0 r
s
.83 .24 .1 r
.62248 .38623 m
.62757 .38824 L
s
.378 .084 .035 r
.62081 .38925 m .63728 .39571 L .62322 .38488 L p F P
0 0 0 r
s
.386 .087 .036 r
.36349 .61675 m .37757 .62098 L .36145 .60981 L p F P
0 0 0 r
s
.386 .087 .036 r
.36145 .60981 m .34544 .60497 L .36349 .61675 L p F P
0 0 0 r
s
.254 .059 .024 r
.56754 .36175 m .55435 .35655 L .56305 .36118 L p F P
0 0 0 r
s
.254 .059 .024 r
.56305 .36118 m .5783 .36718 L .56754 .36175 L p F P
0 0 0 r
s
.024 .035 .067 r
.61708 .60079 m .60733 .60921 L .59484 .62046 L p F P
0 0 0 r
s
.024 .035 .067 r
.58642 .62771 m .59484 .62046 L .60733 .60921 L p F P
0 0 0 r
s
.736 .233 .102 r
.51172 .65667 m .51767 .65847 L .52548 .66634 L p F P
0 0 0 r
s
.83 .24 .1 r
.52455 .66541 m
.52604 .66586 L
s
.736 .233 .102 r
.52548 .66634 m .51691 .66377 L .51172 .65667 L p F P
0 0 0 r
s
.83 .24 .1 r
.49961 .65792 m
.51629 .66293 L
s
.309 .47 .901 r
.53058 .66188 m .52548 .66634 L .51767 .65847 L p F P
0 0 0 r
s
.24 .35 .67 r
.52469 .30077 m
.55131 .30686 L
s
.57441 .28017 m
.55131 .30686 L
s
.525 .13 .05 r
.66973 .40845 m .65359 .40211 L .66573 .41625 L p F P
0 0 0 r
s
.525 .13 .05 r
.66573 .41625 m .68308 .42301 L .66973 .40845 L p F P
0 0 0 r
s
.321 .483 .913 r
.43647 .34707 m .44391 .33784 L .45413 .34025 L p F P
0 0 0 r
s
.321 .483 .913 r
.46034 .33261 m .45413 .34025 L .44391 .33784 L p F P
0 0 0 r
s
.83 .24 .1 r
.45141 .33545 m
.46277 .32911 L
s
.24 .35 .67 r
.44175 .66428 m
.42116 .68372 L
s
.42116 .68372 m
.3937 .67003 L
s
.518 .171 .076 r
.46457 .64806 m .47341 .65071 L .46607 .65002 L p F P
0 0 0 r
s
.518 .171 .076 r
.46607 .65002 m .45477 .64663 L .46457 .64806 L p F P
0 0 0 r
s
.83 .24 .1 r
.32 .30578 m
.28 .29047 L
s
.32 .30578 m
.33285 .29157 L
s
.24 .35 .67 r
.49725 .67484 m
.47003 .67258 L
s
.266 .404 .736 r
.38117 .4029 m .39003 .39179 L .40132 .38134 L p F P
0 0 0 r
s
.266 .404 .736 r
.40949 .37112 m .40132 .38134 L .39003 .39179 L p F P
0 0 0 r
s
.83 .24 .1 r
.46277 .32911 m
.46325 .32905 L
s
.272 .062 .026 r
.40881 .63285 m .42041 .63633 L .40539 .62934 L p F P
0 0 0 r
s
.83 .24 .1 r
.41117 .63073 m
.44949 .64225 L
s
.272 .062 .026 r
.40539 .62934 m .39154 .62518 L .40881 .63285 L p F P
0 0 0 r
s
.83 .24 .1 r
.40228 .62065 m
.41117 .63073 L
s
.541 .178 .08 r
.50046 .33821 m .48926 .3338 L .48685 .32993 L p F P
0 0 0 r
s
.541 .178 .08 r
.48685 .32993 m .50057 .33534 L .50046 .33821 L p F P
0 0 0 r
s
.736 .233 .102 r
.50575 .65487 m .51172 .65667 L .51691 .66377 L p F P
0 0 0 r
s
.736 .233 .102 r
.51691 .66377 m .5083 .66119 L .50575 .65487 L p F P
0 0 0 r
s
.24 .35 .67 r
.49725 .67484 m
.51232 .66145 L
s
.51232 .66145 m
.51543 .65868 L
s
.83 .24 .1 r
.81583 .62942 m
.80165 .65721 L
s
.80165 .65721 m
.76691 .64576 L
s
.254 .059 .024 r
.55435 .35655 m .54106 .35131 L .54767 .35511 L p F P
0 0 0 r
s
.254 .059 .024 r
.54767 .35511 m .56305 .36118 L .55435 .35655 L p F P
0 0 0 r
s
.83 .24 .1 r
.55068 .35727 m
.56241 .36259 L
s
.66083 .66734 m
.64269 .68155 L
s
.64269 .68155 m
.60619 .67037 L
s
.28402 .58485 m
.27981 .5696 L
s
.27981 .5696 m
.23929 .55718 L
s
.305 .461 .857 r
.40949 .37112 m .41778 .36074 L .42913 .35618 L p F P
0 0 0 r
s
.305 .461 .857 r
.43647 .34707 m .42913 .35618 L .41778 .36074 L p F P
0 0 0 r
s
.378 .084 .035 r
.60838 .37904 m .59341 .37314 L .60417 .38272 L p F P
0 0 0 r
s
.83 .24 .1 r
.60708 .38017 m
.61223 .3822 L
s
.58721 .37165 m
.59638 .37578 L
s
.378 .084 .035 r
.60417 .38272 m .62081 .38925 L .60838 .37904 L p F P
0 0 0 r
s
.386 .087 .036 r
.3493 .61249 m .36349 .61675 L .34544 .60497 L p F P
0 0 0 r
s
.386 .087 .036 r
.34544 .60497 m .32928 .60009 L .3493 .61249 L p F P
0 0 0 r
s
.273 .421 .783 r
.59484 .62046 m .58642 .62771 L .57269 .63496 L p F P
0 0 0 r
s
.273 .421 .783 r
.56578 .64095 m .57269 .63496 L .58642 .62771 L p F P
0 0 0 r
s
.24 .35 .67 r
.62808 .30736 m
.65295 .32691 L
s
.67809 .30052 m
.65295 .32691 L
s
.65295 .32691 m
.67536 .34952 L
s
.301 .46 .871 r
.56578 .64095 m .55895 .64687 L .54617 .64825 L p F P
0 0 0 r
s
.301 .46 .871 r
.54093 .65283 m .54617 .64825 L .55895 .64687 L p F P
0 0 0 r
s
.83 .24 .1 r
.83346 .56866 m
.79905 .55622 L
s
.83346 .56866 m
.82664 .59935 L
s
.24 .35 .67 r
.70094 .32355 m
.67536 .34952 L
s
.67536 .34952 m
.69452 .3744 L
s
.518 .171 .076 r
.4557 .64539 m .46457 .64806 L .45477 .64663 L p F P
0 0 0 r
s
.518 .171 .076 r
.45477 .64663 m .44339 .64322 L .4557 .64539 L p F P
0 0 0 r
s
.24 .35 .67 r
.32788 .60257 m
.32981 .60041 L
s
.309 .47 .901 r
.53573 .65738 m .53058 .66188 L .52119 .65535 L p F P
0 0 0 r
s
.309 .47 .901 r
.51767 .65847 m .52119 .65535 L .53058 .66188 L p F P
0 0 0 r
s
.024 .035 .067 r
.36247 .42874 m .37178 .4171 L .38117 .4029 L p F P
0 0 0 r
s
.024 .035 .067 r
.39003 .39179 m .38117 .4029 L .37178 .4171 L p F P
0 0 0 r
s
.24 .35 .67 r
.37895 .40828 m
.39434 .39248 L
s
.047 .067 .154 r
.65828 .54941 m .6703 .53889 L .67529 .51975 L p F P
0 0 0 r
s
.024 .036 .069 r
.6703 .53889 m .65828 .54941 L .64964 .56717 L p F P
0 0 0 r
s
.024 .036 .069 r
.63855 .57679 m .64964 .56717 L .65828 .54941 L p F P
0 0 0 r
s
.541 .178 .08 r
.48926 .3338 m .47798 .32936 L .47303 .32448 L p F P
0 0 0 r
s
.24 .35 .67 r
.47666 .32657 m
.47756 .32637 L
s
.541 .178 .08 r
.47303 .32448 m .48685 .32993 L .48926 .3338 L p F P
0 0 0 r
s
.24 .35 .67 r
.47293 .32737 m
.47542 .32684 L
s
.079 .107 .249 r
.67529 .51975 m .68794 .50854 L .68857 .48903 L p F P
0 0 0 r
s
.047 .067 .154 r
.68794 .50854 m .67529 .51975 L .6703 .53889 L p F P
0 0 0 r
s
.24 .35 .67 r
.64874 .54677 m
.67345 .52494 L
s
.67345 .52494 m
.67411 .50047 L
s
.525 .13 .05 r
.65359 .40211 m .63728 .39571 L .64819 .40942 L p F P
0 0 0 r
s
.525 .13 .05 r
.64819 .40942 m .66573 .41625 L .65359 .40211 L p F P
0 0 0 r
s
.736 .233 .102 r
.49975 .65306 m .50575 .65487 L .5083 .66119 L p F P
0 0 0 r
s
.736 .233 .102 r
.5083 .66119 m .49964 .65859 L .49975 .65306 L p F P
0 0 0 r
s
.83 .24 .1 r
.49961 .65792 m
.49965 .65791 L
s
.024 .035 .067 r
.64964 .56717 m .63855 .57679 L .62699 .59224 L p F P
0 0 0 r
s
.024 .035 .067 r
.61708 .60079 m .62699 .59224 L .63855 .57679 L p F P
0 0 0 r
s
.144 .204 .437 r
.69718 .45856 m .71005 .44675 L .70025 .4297 L p F P
0 0 0 r
s
.686 .18 .072 r
.70025 .4297 m .68308 .42301 L .69209 .43982 L p F P
0 0 0 r
s
.686 .18 .072 r
.69209 .43982 m .71005 .44675 L .70025 .4297 L p F P
0 0 0 r
s
.24 .35 .67 r
.70591 .44083 m
.70756 .4393 L
s
.70756 .4393 m
.72031 .42751 L
s
.83 .24 .1 r
.7257 .44937 m
.73047 .47265 L
s
.113 .157 .348 r
.68857 .48903 m .70152 .47737 L .69718 .45856 L p F P
0 0 0 r
s
.079 .107 .249 r
.70152 .47737 m .68857 .48903 L .68794 .50854 L p F P
0 0 0 r
s
.136 .196 .427 r
.32209 .576 m .33045 .56637 L .32065 .54855 L p F P
0 0 0 r
s
.136 .196 .427 r
.32957 .53801 m .32065 .54855 L .33045 .56637 L p F P
0 0 0 r
s
.098 .139 .32 r
.32065 .54855 m .32957 .53801 L .32457 .51883 L p F P
0 0 0 r
s
.272 .062 .026 r
.39713 .62935 m .40881 .63285 L .39154 .62518 L p F P
0 0 0 r
s
.272 .062 .026 r
.39154 .62518 m .37757 .62098 L .39713 .62935 L p F P
0 0 0 r
s
.24 .35 .67 r
.60159 .29157 m
.62808 .30736 L
s
.65279 .28052 m
.62808 .30736 L
s
.83 .24 .1 r
.71483 .65882 m
.69684 .67858 L
s
.69684 .67858 m
.66083 .66734 L
s
.113 .157 .348 r
.71005 .44675 m .69718 .45856 L .70152 .47737 L p F P
0 0 0 r
s
.83 .24 .1 r
.70752 .44234 m
.7257 .44937 L
s
.24 .35 .67 r
.69436 .45151 m
.70261 .44388 L
s
.098 .139 .32 r
.33388 .5076 m .32457 .51883 L .32957 .53801 L p F P
0 0 0 r
s
.24 .35 .67 r
.32623 .51299 m
.32637 .51667 L
s
.061 .089 .214 r
.32457 .51883 m .33388 .5076 L .33332 .48807 L p F P
0 0 0 r
s
.83 .24 .1 r
.76691 .64576 m
.75025 .67016 L
s
.75025 .67016 m
.71483 .65882 L
s
.321 .483 .913 r
.44391 .33784 m .45145 .32848 L .46034 .33261 L p F P
0 0 0 r
s
.321 .483 .913 r
.46663 .3249 m .46034 .33261 L .45145 .32848 L p F P
0 0 0 r
s
.24 .35 .67 r
.41387 .65022 m
.3937 .67003 L
s
.3937 .67003 m
.36812 .65126 L
s
.83 .24 .1 r
.37246 .30695 m
.33285 .29157 L
s
.37246 .30695 m
.38502 .29864 L
s
.166 .243 .512 r
.32928 .60009 m .33694 .59152 L .32209 .576 L p F P
0 0 0 r
s
.83 .24 .1 r
.32361 .59484 m
.32431 .59705 L
s
.3227 .59198 m
.32361 .59484 L
s
.166 .243 .512 r
.33045 .56637 m .32209 .576 L .33694 .59152 L p F P
0 0 0 r
s
.024 .035 .067 r
.34622 .45759 m .35573 .44576 L .36247 .42874 L p F P
0 0 0 r
s
.024 .035 .067 r
.37178 .4171 m .36247 .42874 L .35573 .44576 L p F P
0 0 0 r
s
.24 .35 .67 r
.37146 .41766 m
.37895 .40828 L
s
.041 .06 .137 r
.33332 .48807 m .34283 .47639 L .34622 .45759 L p F P
0 0 0 r
s
.061 .089 .214 r
.34283 .47639 m .33332 .48807 L .33388 .5076 L p F P
0 0 0 r
s
.041 .06 .137 r
.35573 .44576 m .34622 .45759 L .34283 .47639 L p F P
0 0 0 r
s
.24 .35 .67 r
.34443 .47663 m
.34601 .46883 L
s
.254 .059 .024 r
.54106 .35131 m .52767 .34603 L .53214 .349 L p F P
0 0 0 r
s
.254 .059 .024 r
.53214 .349 m .54767 .35511 L .54106 .35131 L p F P
0 0 0 r
s
.83 .24 .1 r
.51334 .34257 m
.55068 .35727 L
s
.15896 .48772 m
.156 .51155 L
s
.82664 .59935 m
.81583 .62942 L
s
.81583 .62942 m
.78111 .61761 L
s
.024 .035 .067 r
.62699 .59224 m .61708 .60079 L .60336 .6131 L p F P
0 0 0 r
s
.024 .035 .067 r
.59484 .62046 m .60336 .6131 L .61708 .60079 L p F P
0 0 0 r
s
.518 .171 .076 r
.44677 .64271 m .4557 .64539 L .44339 .64322 L p F P
0 0 0 r
s
.83 .24 .1 r
.44949 .64225 m
.46156 .64648 L
s
.518 .171 .076 r
.44339 .64322 m .43194 .63978 L .44677 .64271 L p F P
0 0 0 r
s
.83 .24 .1 r
.82664 .59935 m
.79202 .5872 L
s
.24 .35 .67 r
.72056 .34882 m
.69452 .3744 L
s
.69452 .3744 m
.70971 .40071 L
s
.378 .084 .035 r
.59341 .37314 m .5783 .36718 L .58736 .37612 L p F P
0 0 0 r
s
.378 .084 .035 r
.58736 .37612 m .60417 .38272 L .59341 .37314 L p F P
0 0 0 r
s
.83 .24 .1 r
.80184 .52636 m
.76694 .5134 L
s
.80184 .52636 m
.79905 .55622 L
s
.192 .282 .584 r
.33694 .59152 m .32928 .60009 L .3493 .61249 L p F P
0 0 0 r
s
.83 .24 .1 r
.32431 .59705 m
.32916 .59852 L
s
.32916 .59852 m
.32936 .59858 L
s
.34365 .6029 m
.36372 .60898 L
s
.24 .35 .67 r
.32788 .60257 m
.34579 .62837 L
s
.736 .233 .102 r
.49373 .65124 m .49975 .65306 L .49964 .65859 L p F P
0 0 0 r
s
.736 .233 .102 r
.49964 .65859 m .49094 .65597 L .49373 .65124 L p F P
0 0 0 r
s
.24 .35 .67 r
.36812 .65126 m
.34579 .62837 L
s
.83 .24 .1 r
.76579 .48607 m
.73047 .47265 L
s
.76579 .48607 m
.76694 .5134 L
s
.541 .178 .08 r
.47798 .32936 m .46663 .3249 L .45909 .31899 L p F P
0 0 0 r
s
.541 .178 .08 r
.45909 .31899 m .47303 .32448 L .47798 .32936 L p F P
0 0 0 r
s
.83 .24 .1 r
.56888 .65894 m
.55211 .66731 L
s
.5263 .65951 m
.55211 .66731 L
s
.521 .65791 m
.5263 .65951 L
s
.309 .47 .901 r
.54093 .65283 m .53573 .65738 L .52472 .65221 L p F P
0 0 0 r
s
.24 .35 .67 r
.53719 .65269 m
.54184 .65203 L
s
.309 .47 .901 r
.52119 .65535 m .52472 .65221 L .53573 .65738 L p F P
0 0 0 r
s
.83 .24 .1 r
.23911 .27481 m
.22675 .29459 L
s
.266 .404 .736 r
.39003 .39179 m .39904 .38049 L .40949 .37112 L p F P
0 0 0 r
s
.266 .404 .736 r
.41778 .36074 m .40949 .37112 L .39904 .38049 L p F P
0 0 0 r
s
.24 .35 .67 r
.39434 .39248 m
.41427 .3676 L
s
.83 .24 .1 r
.19786 .54448 m
.19769 .52455 L
s
.19769 .52455 m
.156 .51155 L
s
.32431 .59705 m
.33194 .60691 L
s
.28402 .58485 m
.32431 .59705 L
s
.301 .46 .871 r
.57269 .63496 m .56578 .64095 L .55146 .64362 L p F P
0 0 0 r
s
.301 .46 .871 r
.54617 .64825 m .55146 .64362 L .56578 .64095 L p F P
0 0 0 r
s
.272 .062 .026 r
.38537 .62582 m .39713 .62935 L .37757 .62098 L p F P
0 0 0 r
s
.272 .062 .026 r
.37757 .62098 m .36349 .61675 L .38537 .62582 L p F P
0 0 0 r
s
.305 .461 .857 r
.41778 .36074 m .42622 .3502 L .43647 .34707 L p F P
0 0 0 r
s
.24 .35 .67 r
.41427 .3676 m
.43384 .35701 L
s
.305 .461 .857 r
.44391 .33784 m .43647 .34707 L .42622 .3502 L p F P
0 0 0 r
s
.525 .13 .05 r
.63728 .39571 m .62081 .38925 L .63046 .40251 L p F P
0 0 0 r
s
.525 .13 .05 r
.63046 .40251 m .64819 .40942 L .63728 .39571 L p F P
0 0 0 r
s
.273 .421 .783 r
.60336 .6131 m .59484 .62046 L .57968 .62891 L p F P
0 0 0 r
s
.273 .421 .783 r
.57269 .63496 m .57968 .62891 L .59484 .62046 L p F P
0 0 0 r
s
.24 .35 .67 r
.58792 .62341 m
.58915 .62234 L
s
.58915 .62234 m
.60625 .60812 L
s
.736 .233 .102 r
.4877 .64942 m .49373 .65124 L .49094 .65597 L p F P
0 0 0 r
s
.736 .233 .102 r
.49094 .65597 m .4822 .65335 L .4877 .64942 L p F P
0 0 0 r
s
.24 .35 .67 r
.49931 .29996 m
.52469 .30077 L
s
.54751 .27368 m
.52469 .30077 L
s
.518 .171 .076 r
.4378 .64002 m .44677 .64271 L .43194 .63978 L p F P
0 0 0 r
s
.518 .171 .076 r
.43194 .63978 m .42041 .63633 L .4378 .64002 L p F P
0 0 0 r
s
.254 .059 .024 r
.52767 .34603 m .51417 .34071 L .51647 .34282 L p F P
0 0 0 r
s
.254 .059 .024 r
.51647 .34282 m .53214 .349 L .52767 .34603 L p F P
0 0 0 r
s
.686 .18 .072 r
.68308 .42301 m .66573 .41625 L .67393 .43282 L p F P
0 0 0 r
s
.686 .18 .072 r
.67393 .43282 m .69209 .43982 L .68308 .42301 L p F P
0 0 0 r
s
.24 .35 .67 r
.57441 .28017 m
.60159 .29157 L
s
.62592 .26427 m
.60159 .29157 L
s
.321 .483 .913 r
.45145 .32848 m .45909 .31899 L .46663 .3249 L p F P
0 0 0 r
s
.83 .24 .1 r
.46628 .32866 m
.47517 .32754 L
s
.24 .35 .67 r
.45463 .33133 m
.47106 .32778 L
s
.83 .24 .1 r
.42432 .31404 m
.45378 .32558 L
s
.24 .35 .67 r
.47003 .67258 m
.49036 .65403 L
s
.49036 .65403 m
.49181 .65271 L
s
.47003 .67258 m
.44175 .66428 L
s
.83 .24 .1 r
.28 .29047 m
.23911 .27481 L
s
.28 .29047 m
.29234 .27585 L
s
.378 .084 .035 r
.5783 .36718 m .56305 .36118 L .57039 .36946 L p F P
0 0 0 r
s
.83 .24 .1 r
.56241 .36259 m
.56532 .36374 L
s
.378 .084 .035 r
.57039 .36946 m .58736 .37612 L .5783 .36718 L p F P
0 0 0 r
s
.83 .24 .1 r
.42432 .31404 m
.38502 .29864 L
s
.42432 .31404 m
.43614 .31217 L
s
.736 .233 .102 r
.48164 .64759 m .4877 .64942 L .4822 .65335 L p F P
0 0 0 r
s
.736 .233 .102 r
.4822 .65335 m .47341 .65071 L .48164 .64759 L p F P
0 0 0 r
s
.83 .24 .1 r
.46156 .64648 m
.47439 .65034 L
s
.024 .035 .067 r
.37178 .4171 m .38126 .40523 L .39003 .39179 L p F P
0 0 0 r
s
.024 .035 .067 r
.39904 .38049 m .39003 .39179 L .38126 .40523 L p F P
0 0 0 r
s
.309 .47 .901 r
.54617 .64825 m .54093 .65283 L .52828 .64906 L p F P
0 0 0 r
s
.309 .47 .901 r
.52472 .65221 m .52828 .64906 L .54093 .65283 L p F P
0 0 0 r
s
.272 .062 .026 r
.37353 .62227 m .38537 .62582 L .36349 .61675 L p F P
0 0 0 r
s
.272 .062 .026 r
.36349 .61675 m .3493 .61249 L .37353 .62227 L p F P
0 0 0 r
s
.83 .24 .1 r
.37199 .61895 m
.41117 .63073 L
s
.36372 .60898 m
.37199 .61895 L
s
.78111 .61761 m
.76691 .64576 L
s
.76691 .64576 m
.7314 .63406 L
s
.518 .171 .076 r
.42879 .63731 m .4378 .64002 L .42041 .63633 L p F P
0 0 0 r
s
.518 .171 .076 r
.42041 .63633 m .40881 .63285 L .42879 .63731 L p F P
0 0 0 r
s
.83 .24 .1 r
.62402 .65584 m
.60619 .67037 L
s
.60619 .67037 m
.56888 .65894 L
s
.24 .35 .67 r
.73623 .37547 m
.70971 .40071 L
s
.70971 .40071 m
.72031 .42751 L
s
.024 .036 .069 r
.64964 .56717 m .66092 .55738 L .6703 .53889 L p F P
0 0 0 r
s
.024 .035 .067 r
.66092 .55738 m .64964 .56717 L .63706 .58355 L p F P
0 0 0 r
s
.024 .035 .067 r
.62699 .59224 m .63706 .58355 L .64964 .56717 L p F P
0 0 0 r
s
.83 .24 .1 r
.24282 .57238 m
.23929 .55718 L
s
.23929 .55718 m
.19786 .54448 L
s
.047 .067 .154 r
.6703 .53889 m .68255 .52817 L .68794 .50854 L p F P
0 0 0 r
s
.024 .036 .069 r
.68255 .52817 m .6703 .53889 L .66092 .55738 L p F P
0 0 0 r
s
.254 .059 .024 r
.51417 .34071 m .50057 .33534 L .50066 .33659 L p F P
0 0 0 r
s
.254 .059 .024 r
.50066 .33659 m .51647 .34282 L .51417 .34071 L p F P
0 0 0 r
s
.079 .107 .249 r
.68794 .50854 m .70084 .4971 L .70152 .47737 L p F P
0 0 0 r
s
.24 .35 .67 r
.69436 .45151 m
.69947 .4776 L
s
.047 .067 .154 r
.70084 .4971 m .68794 .50854 L .68255 .52817 L p F P
0 0 0 r
s
.24 .35 .67 r
.67411 .50047 m
.69947 .4776 L
s
.166 .243 .512 r
.33694 .59152 m .34471 .58282 L .33045 .56637 L p F P
0 0 0 r
s
.166 .243 .512 r
.33896 .55656 m .33045 .56637 L .34471 .58282 L p F P
0 0 0 r
s
.136 .196 .427 r
.33045 .56637 m .33896 .55656 L .32957 .53801 L p F P
0 0 0 r
s
.24 .35 .67 r
.32964 .53753 m
.32995 .53876 L
s
.024 .035 .067 r
.63706 .58355 m .62699 .59224 L .61201 .60564 L p F P
0 0 0 r
s
.24 .35 .67 r
.63038 .58725 m
.64229 .56871 L
s
.024 .035 .067 r
.60336 .6131 m .61201 .60564 L .62699 .59224 L p F P
0 0 0 r
s
.136 .196 .427 r
.33865 .52728 m .32957 .53801 L .33896 .55656 L p F P
0 0 0 r
s
.098 .139 .32 r
.32957 .53801 m .33865 .52728 L .33388 .5076 L p F P
0 0 0 r
s
.83 .24 .1 r
.79905 .55622 m
.76386 .5435 L
s
.79905 .55622 m
.79202 .5872 L
s
.301 .46 .871 r
.57968 .62891 m .57269 .63496 L .55679 .63896 L p F P
0 0 0 r
s
.301 .46 .871 r
.55146 .64362 m .55679 .63896 L .57269 .63496 L p F P
0 0 0 r
s
.525 .13 .05 r
.62081 .38925 m .60417 .38272 L .61254 .39553 L p F P
0 0 0 r
s
.83 .24 .1 r
.60404 .38267 m
.60448 .3832 L
s
.525 .13 .05 r
.61254 .39553 m .63046 .40251 L .62081 .38925 L p F P
0 0 0 r
s
.113 .157 .348 r
.70152 .47737 m .71472 .46548 L .71005 .44675 L p F P
0 0 0 r
s
.079 .107 .249 r
.71472 .46548 m .70152 .47737 L .70084 .4971 L p F P
0 0 0 r
s
.736 .233 .102 r
.47556 .64575 m .48164 .64759 L .47341 .65071 L p F P
0 0 0 r
s
.736 .233 .102 r
.47341 .65071 m .46457 .64806 L .47556 .64575 L p F P
0 0 0 r
s
.024 .035 .067 r
.35573 .44576 m .36544 .4337 L .37178 .4171 L p F P
0 0 0 r
s
.024 .035 .067 r
.38126 .40523 m .37178 .4171 L .36544 .4337 L p F P
0 0 0 r
s
.24 .35 .67 r
.36753 .42994 m
.36856 .42866 L
s
.36856 .42866 m
.37213 .42165 L
s
.791 .213 .087 r
.71005 .44675 m .69209 .43982 L .69639 .45851 L p F P
0 0 0 r
s
.791 .213 .087 r
.69639 .45851 m .71472 .46548 L .71005 .44675 L p F P
0 0 0 r
s
.098 .139 .32 r
.34336 .49614 m .33388 .5076 L .33865 .52728 L p F P
0 0 0 r
s
.061 .089 .214 r
.33388 .5076 m .34336 .49614 L .34283 .47639 L p F P
0 0 0 r
s
.24 .35 .67 r
.34289 .47853 m
.34443 .47663 L
s
.192 .282 .584 r
.3493 .61249 m .35619 .60502 L .33694 .59152 L p F P
0 0 0 r
s
.192 .282 .584 r
.34471 .58282 m .33694 .59152 L .35619 .60502 L p F P
0 0 0 r
s
.686 .18 .072 r
.66573 .41625 m .64819 .40942 L .65556 .42574 L p F P
0 0 0 r
s
.686 .18 .072 r
.65556 .42574 m .67393 .43282 L .66573 .41625 L p F P
0 0 0 r
s
.041 .06 .137 r
.34283 .47639 m .35252 .46448 L .35573 .44576 L p F P
0 0 0 r
s
.061 .089 .214 r
.35252 .46448 m .34283 .47639 L .34336 .49614 L p F P
0 0 0 r
s
.041 .06 .137 r
.36544 .4337 m .35573 .44576 L .35252 .46448 L p F P
0 0 0 r
s
.378 .084 .035 r
.56305 .36118 m .54767 .35511 L .55324 .36273 L p F P
0 0 0 r
s
.378 .084 .035 r
.55324 .36273 m .57039 .36946 L .56305 .36118 L p F P
0 0 0 r
s
.305 .461 .857 r
.42622 .3502 m .43478 .33949 L .44391 .33784 L p F P
0 0 0 r
s
.305 .461 .857 r
.45145 .32848 m .44391 .33784 L .43478 .33949 L p F P
0 0 0 r
s
.24 .35 .67 r
.43384 .35701 m
.45463 .33133 L
s
.83 .24 .1 r
.67862 .64722 m
.66083 .66734 L
s
.66083 .66734 m
.62402 .65584 L
s
.266 .404 .736 r
.39904 .38049 m .40821 .36898 L .41778 .36074 L p F P
0 0 0 r
s
.266 .404 .736 r
.42622 .3502 m .41778 .36074 L .40821 .36898 L p F P
0 0 0 r
s
.83 .24 .1 r
.7314 .63406 m
.71483 .65882 L
s
.71483 .65882 m
.67862 .64722 L
s
.273 .421 .783 r
.61201 .60564 m .60336 .6131 L .58675 .62278 L p F P
0 0 0 r
s
.24 .35 .67 r
.60625 .60812 m
.63038 .58725 L
s
.58915 .62234 m
.59255 .6194 L
s
.273 .421 .783 r
.57968 .62891 m .58675 .62278 L .60336 .6131 L p F P
0 0 0 r
s
.518 .171 .076 r
.41972 .63459 m .42879 .63731 L .40881 .63285 L p F P
0 0 0 r
s
.518 .171 .076 r
.40881 .63285 m .39713 .62935 L .41972 .63459 L p F P
0 0 0 r
s
.83 .24 .1 r
.33285 .29157 m
.29234 .27585 L
s
.33285 .29157 m
.34482 .28288 L
s
.213 .315 .645 r
.35619 .60502 m .3493 .61249 L .37353 .62227 L p F P
0 0 0 r
s
.83 .24 .1 r
.35554 .61401 m
.35682 .61439 L
s
.36942 .61818 m
.37199 .61895 L
s
.33194 .60691 m
.35554 .61401 L
s
.24 .35 .67 r
.35701 .61635 m
.35752 .61581 L
s
.34579 .62837 m
.35701 .61635 L
s
.309 .47 .901 r
.55146 .64362 m .54617 .64825 L .53185 .64589 L p F P
0 0 0 r
s
.309 .47 .901 r
.52828 .64906 m .53185 .64589 L .54617 .64825 L p F P
0 0 0 r
s
.736 .233 .102 r
.46946 .64391 m .47556 .64575 L .46457 .64806 L p F P
0 0 0 r
s
.736 .233 .102 r
.46457 .64806 m .4557 .64539 L .46946 .64391 L p F P
0 0 0 r
s
.83 .24 .1 r
.79202 .5872 m
.78111 .61761 L
s
.78111 .61761 m
.7456 .60554 L
s
.79202 .5872 m
.75663 .57479 L
s
.254 .059 .024 r
.50057 .33534 m .48685 .32993 L .4847 .3303 L p F P
0 0 0 r
s
.254 .059 .024 r
.4847 .3303 m .50066 .33659 L .50057 .33534 L p F P
0 0 0 r
s
.83 .24 .1 r
.47517 .32754 m
.51334 .34257 L
s
.76694 .5134 m
.73125 .50014 L
s
.76694 .5134 m
.76386 .5435 L
s
.895 .274 .118 r
.50604 .64528 m .50912 .64622 L .51767 .65847 L p F P
0 0 0 r
s
.24 .35 .67 r
.51618 .65802 m
.51679 .65747 L
s
.895 .274 .118 r
.51767 .65847 m .51172 .65667 L .50604 .64528 L p F P
0 0 0 r
s
.83 .24 .1 r
.51081 .65639 m
.51153 .65629 L
s
.305 .461 .894 r
.52119 .65535 m .51767 .65847 L .50912 .64622 L p F P
0 0 0 r
s
.24 .35 .67 r
.52075 .65502 m
.52172 .65488 L
s
.83 .24 .1 r
.71427 .4665 m
.73047 .47265 L
s
.73047 .47265 m
.73125 .50014 L
s
.24 .35 .67 r
.54751 .27368 m
.57441 .28017 L
s
.59841 .25242 m
.57441 .28017 L
s
.44175 .66428 m
.46174 .64542 L
s
.44175 .66428 m
.41387 .65022 L
s
.525 .13 .05 r
.60417 .38272 m .58736 .37612 L .59442 .38847 L p F P
0 0 0 r
s
.525 .13 .05 r
.59442 .38847 m .61254 .39553 L .60417 .38272 L p F P
0 0 0 r
s
.83 .24 .1 r
.156 .51155 m
.15549 .53149 L
s
.736 .233 .102 r
.46334 .64206 m .46946 .64391 L .4557 .64539 L p F P
0 0 0 r
s
.736 .233 .102 r
.4557 .64539 m .44677 .64271 L .46334 .64206 L p F P
0 0 0 r
s
.24 .35 .67 r
.46174 .64542 m
.46316 .64408 L
s
.518 .171 .076 r
.41061 .63186 m .41972 .63459 L .39713 .62935 L p F P
0 0 0 r
s
.83 .24 .1 r
.41117 .63073 m
.42265 .6348 L
s
.518 .171 .076 r
.39713 .62935 m .38537 .62582 L .41061 .63186 L p F P
0 0 0 r
s
.83 .24 .1 r
.29097 .5946 m
.28402 .58485 L
s
.28402 .58485 m
.24282 .57238 L
s
.301 .46 .871 r
.58675 .62278 m .57968 .62891 L .56217 .63425 L p F P
0 0 0 r
s
.301 .46 .871 r
.55679 .63896 m .56217 .63425 L .57968 .62891 L p F P
0 0 0 r
s
.895 .274 .118 r
.50296 .64434 m .50604 .64528 L .51172 .65667 L p F P
0 0 0 r
s
.895 .274 .118 r
.51172 .65667 m .50575 .65487 L .50296 .64434 L p F P
0 0 0 r
s
.791 .213 .087 r
.69209 .43982 m .67393 .43282 L .67784 .45146 L p F P
0 0 0 r
s
.791 .213 .087 r
.67784 .45146 m .69639 .45851 L .69209 .43982 L p F P
0 0 0 r
s
.83 .24 .1 r
.69411 .45764 m
.69435 .45894 L
s
.378 .084 .035 r
.54767 .35511 m .53214 .349 L .53592 .35594 L p F P
0 0 0 r
s
.378 .084 .035 r
.53592 .35594 m .55324 .36273 L .54767 .35511 L p F P
0 0 0 r
s
.686 .18 .072 r
.64819 .40942 m .63046 .40251 L .63699 .41858 L p F P
0 0 0 r
s
.686 .18 .072 r
.63699 .41858 m .65556 .42574 L .64819 .40942 L p F P
0 0 0 r
s
.024 .035 .067 r
.38126 .40523 m .39091 .39314 L .39904 .38049 L p F P
0 0 0 r
s
.024 .035 .067 r
.40821 .36898 m .39904 .38049 L .39091 .39314 L p F P
0 0 0 r
s
.309 .47 .901 r
.55679 .63896 m .55146 .64362 L .53545 .64269 L p F P
0 0 0 r
s
.309 .47 .901 r
.53185 .64589 m .53545 .64269 L .55146 .64362 L p F P
0 0 0 r
s
.305 .461 .894 r
.52472 .65221 m .52119 .65535 L .51091 .6446 L p F P
0 0 0 r
s
.24 .35 .67 r
.5201 .65453 m
.52026 .65438 L
s
.305 .461 .894 r
.50912 .64622 m .51091 .6446 L .52119 .65535 L p F P
0 0 0 r
s
.24 .35 .67 r
.50639 .65404 m
.50929 .6543 L
s
.65279 .28052 m
.67809 .30052 L
s
.70422 .27308 m
.67809 .30052 L
s
.67809 .30052 m
.70094 .32355 L
s
.254 .059 .024 r
.48685 .32993 m .47303 .32448 L .46859 .32396 L p F P
0 0 0 r
s
.24 .35 .67 r
.47763 .32629 m
.47855 .32518 L
s
.254 .059 .024 r
.46859 .32396 m .4847 .3303 L .48685 .32993 L p F P
0 0 0 r
s
.24 .35 .67 r
.47855 .32518 m
.49931 .29996 L
s
.83 .24 .1 r
.46039 .32172 m
.47517 .32754 L
s
.895 .274 .118 r
.49987 .6434 m .50296 .64434 L .50575 .65487 L p F P
0 0 0 r
s
.895 .274 .118 r
.50575 .65487 m .49975 .65306 L .49987 .6434 L p F P
0 0 0 r
s
.024 .036 .069 r
.66092 .55738 m .6724 .54742 L .68255 .52817 L p F P
0 0 0 r
s
.24 .35 .67 r
.66723 .54698 m
.67345 .52494 L
s
.024 .035 .067 r
.6724 .54742 m .66092 .55738 L .64729 .57472 L p F P
0 0 0 r
s
.024 .035 .067 r
.63706 .58355 m .64729 .57472 L .66092 .55738 L p F P
0 0 0 r
s
.24 .35 .67 r
.64229 .56871 m
.66723 .54698 L
s
.024 .035 .067 r
.64729 .57472 m .63706 .58355 L .62077 .59808 L p F P
0 0 0 r
s
.024 .035 .067 r
.61201 .60564 m .62077 .59808 L .63706 .58355 L p F P
0 0 0 r
s
.24 .35 .67 r
.47624 .30464 m
.49931 .29996 L
s
.52192 .2725 m
.49931 .29996 L
s
.736 .233 .102 r
.45719 .64021 m .46334 .64206 L .44677 .64271 L p F P
0 0 0 r
s
.736 .233 .102 r
.44677 .64271 m .4378 .64002 L .45719 .64021 L p F P
0 0 0 r
s
.83 .24 .1 r
.42265 .6348 m
.44012 .64004 L
s
.25091 .25977 m
.23911 .27481 L
s
.24 .35 .67 r
.74729 .40257 m
.72031 .42751 L
s
.72031 .42751 m
.72581 .45384 L
s
.72754 .29655 m
.70094 .32355 L
s
.70094 .32355 m
.72056 .34882 L
s
.047 .067 .154 r
.68255 .52817 m .69502 .51726 L .70084 .4971 L p F P
0 0 0 r
s
.024 .036 .069 r
.69502 .51726 m .68255 .52817 L .6724 .54742 L p F P
0 0 0 r
s
.192 .282 .584 r
.35619 .60502 m .36318 .59745 L .34471 .58282 L p F P
0 0 0 r
s
.192 .282 .584 r
.35262 .57399 m .34471 .58282 L .36318 .59745 L p F P
0 0 0 r
s
.166 .243 .512 r
.34471 .58282 m .35262 .57399 L .33896 .55656 L p F P
0 0 0 r
s
.166 .243 .512 r
.34762 .54659 m .33896 .55656 L .35262 .57399 L p F P
0 0 0 r
s
.136 .196 .427 r
.33896 .55656 m .34762 .54659 L .33865 .52728 L p F P
0 0 0 r
s
.305 .461 .857 r
.43478 .33949 m .44348 .32861 L .45145 .32848 L p F P
0 0 0 r
s
.24 .35 .67 r
.43498 .34175 m
.45463 .33133 L
s
.305 .461 .857 r
.45909 .31899 m .45145 .32848 L .44348 .32861 L p F P
0 0 0 r
s
.24 .35 .67 r
.45463 .33133 m
.46277 .32127 L
s
.518 .171 .076 r
.40146 .62911 m .41061 .63186 L .38537 .62582 L p F P
0 0 0 r
s
.24 .35 .67 r
.36812 .65126 m
.38785 .63104 L
s
.518 .171 .076 r
.38537 .62582 m .37353 .62227 L .40146 .62911 L p F P
0 0 0 r
s
.83 .24 .1 r
.38502 .29864 m
.34482 .28288 L
s
.38502 .29864 m
.39622 .29645 L
s
.273 .421 .783 r
.62077 .59808 m .61201 .60564 L .5939 .61659 L p F P
0 0 0 r
s
.24 .35 .67 r
.59553 .61682 m
.60022 .61277 L
s
.273 .421 .783 r
.58675 .62278 m .5939 .61659 L .61201 .60564 L p F P
0 0 0 r
s
.136 .196 .427 r
.3479 .51634 m .33865 .52728 L .34762 .54659 L p F P
0 0 0 r
s
.098 .139 .32 r
.33865 .52728 m .3479 .51634 L .34336 .49614 L p F P
0 0 0 r
s
.079 .107 .249 r
.70084 .4971 m .71399 .48545 L .71472 .46548 L p F P
0 0 0 r
s
.047 .067 .154 r
.71399 .48545 m .70084 .4971 L .69502 .51726 L p F P
0 0 0 r
s
.24 .35 .67 r
.67345 .52494 m
.69913 .50225 L
s
.895 .274 .118 r
.49678 .64246 m .49987 .6434 L .49975 .65306 L p F P
0 0 0 r
s
.895 .274 .118 r
.49975 .65306 m .49373 .65124 L .49678 .64246 L p F P
0 0 0 r
s
.24 .35 .67 r
.49181 .65271 m
.50639 .65404 L
s
.213 .315 .645 r
.37353 .62227 m .37945 .61607 L .35619 .60502 L p F P
0 0 0 r
s
.213 .315 .645 r
.36318 .59745 m .35619 .60502 L .37945 .61607 L p F P
0 0 0 r
s
.024 .035 .067 r
.36544 .4337 m .37533 .4214 L .38126 .40523 L p F P
0 0 0 r
s
.024 .035 .067 r
.39091 .39314 m .38126 .40523 L .37533 .4214 L p F P
0 0 0 r
s
.24 .35 .67 r
.39061 .3937 m
.39888 .38334 L
s
.266 .404 .736 r
.40821 .36898 m .41755 .35728 L .42622 .3502 L p F P
0 0 0 r
s
.24 .35 .67 r
.39888 .38334 m
.41427 .3676 L
s
.266 .404 .736 r
.43478 .33949 m .42622 .3502 L .41755 .35728 L p F P
0 0 0 r
s
.83 .24 .1 r
.7456 .60554 m
.7314 .63406 L
s
.7314 .63406 m
.69509 .62209 L
s
.24 .35 .67 r
.62592 .26427 m
.65279 .28052 L
s
.67849 .25262 m
.65279 .28052 L
s
.83 .24 .1 r
.58637 .64408 m
.56888 .65894 L
s
.862 .236 .097 r
.71472 .46548 m .69639 .45851 L .69571 .47861 L p F P
0 0 0 r
s
.24 .35 .67 r
.69947 .4776 m
.70696 .47084 L
s
.83 .24 .1 r
.69435 .45894 m
.69635 .45969 L
s
.71361 .46625 m
.71379 .46632 L
s
.24 .35 .67 r
.71344 .46499 m
.72581 .45384 L
s
.862 .236 .097 r
.69571 .47861 m .71399 .48545 L .71472 .46548 L p F P
0 0 0 r
s
.24 .35 .67 r
.69913 .50225 m
.69943 .48 L
s
.098 .139 .32 r
.35303 .48447 m .34336 .49614 L .3479 .51634 L p F P
0 0 0 r
s
.24 .35 .67 r
.34504 .49035 m
.3452 .49393 L
s
.061 .089 .214 r
.34336 .49614 m .35303 .48447 L .35252 .46448 L p F P
0 0 0 r
s
.83 .24 .1 r
.20068 .55963 m
.19786 .54448 L
s
.19786 .54448 m
.15549 .53149 L
s
.525 .13 .05 r
.58736 .37612 m .57039 .36946 L .57611 .38134 L p F P
0 0 0 r
s
.525 .13 .05 r
.57611 .38134 m .59442 .38847 L .58736 .37612 L p F P
0 0 0 r
s
.305 .461 .894 r
.52828 .64906 m .52472 .65221 L .51271 .64297 L p F P
0 0 0 r
s
.24 .35 .67 r
.52348 .65153 m
.52364 .65138 L
s
.305 .461 .894 r
.51091 .6446 m .51271 .64297 L .52472 .65221 L p F P
0 0 0 r
s
.83 .24 .1 r
.52032 .65276 m
.52204 .65185 L
s
.24 .35 .67 r
.38785 .63104 m
.41387 .65022 L
s
.736 .233 .102 r
.45102 .63835 m .45719 .64021 L .4378 .64002 L p F P
0 0 0 r
s
.736 .233 .102 r
.4378 .64002 m .42879 .63731 L .45102 .63835 L p F P
0 0 0 r
s
.378 .084 .035 r
.53214 .349 m .51647 .34282 L .51842 .34907 L p F P
0 0 0 r
s
.83 .24 .1 r
.51334 .34257 m
.5169 .34419 L
s
.378 .084 .035 r
.51842 .34907 m .53592 .35594 L .53214 .349 L p F P
0 0 0 r
s
.041 .06 .137 r
.35252 .46448 m .36241 .45234 L .36544 .4337 L p F P
0 0 0 r
s
.061 .089 .214 r
.36241 .45234 m .35252 .46448 L .35303 .48447 L p F P
0 0 0 r
s
.041 .06 .137 r
.37533 .4214 m .36544 .4337 L .36241 .45234 L p F P
0 0 0 r
s
.24 .35 .67 r
.36384 .45283 m
.36528 .44548 L
s
.83 .24 .1 r
.76386 .5435 m
.72787 .53049 L
s
.76386 .5435 m
.75663 .57479 L
s
.895 .274 .118 r
.49368 .64152 m .49678 .64246 L .49373 .65124 L p F P
0 0 0 r
s
.895 .274 .118 r
.49373 .65124 m .4877 .64942 L .49368 .64152 L p F P
0 0 0 r
s
.305 .461 .857 r
.44348 .32861 m .45233 .31755 L .45909 .31899 L p F P
0 0 0 r
s
.254 .059 .024 r
.47303 .32448 m .45909 .31899 L .45233 .31755 L p F P
0 0 0 r
s
.83 .24 .1 r
.43614 .31217 m
.45172 .3183 L
s
.24 .35 .67 r
.46329 .32064 m
.46346 .32042 L
s
.254 .059 .024 r
.45233 .31755 m .46859 .32396 L .47303 .32448 L p F P
0 0 0 r
s
.24 .35 .67 r
.46346 .32042 m
.47624 .30464 L
s
.309 .47 .901 r
.56217 .63425 m .55679 .63896 L .53907 .63948 L p F P
0 0 0 r
s
.309 .47 .901 r
.53545 .64269 m .53907 .63948 L .55679 .63896 L p F P
0 0 0 r
s
.791 .213 .087 r
.67393 .43282 m .65556 .42574 L .65908 .44432 L p F P
0 0 0 r
s
.791 .213 .087 r
.65908 .44432 m .67784 .45146 L .67393 .43282 L p F P
0 0 0 r
s
.301 .46 .871 r
.5939 .61659 m .58675 .62278 L .5676 .6295 L p F P
0 0 0 r
s
.301 .46 .871 r
.56217 .63425 m .5676 .6295 L .58675 .62278 L p F P
0 0 0 r
s
.24 .35 .67 r
.74765 .32222 m
.72056 .34882 L
s
.72056 .34882 m
.73623 .37547 L
s
.686 .18 .072 r
.63046 .40251 m .61254 .39553 L .6182 .41134 L p F P
0 0 0 r
s
.686 .18 .072 r
.6182 .41134 m .63699 .41858 L .63046 .40251 L p F P
0 0 0 r
s
.233 .345 .699 r
.37945 .61607 m .37353 .62227 L .40146 .62911 L p F P
0 0 0 r
s
.83 .24 .1 r
.37971 .62171 m
.38019 .62189 L
s
.24 .35 .67 r
.38133 .62436 m
.38785 .63104 L
s
.38785 .63104 m
.3919 .62688 L
s
.895 .274 .118 r
.49058 .64057 m .49368 .64152 L .4877 .64942 L p F P
0 0 0 r
s
.895 .274 .118 r
.4877 .64942 m .48164 .64759 L .49058 .64057 L p F P
0 0 0 r
s
.83 .24 .1 r
.34217 .61062 m
.33194 .60691 L
s
.33194 .60691 m
.29097 .5946 L
s
.64159 .63537 m
.62402 .65584 L
s
.62402 .65584 m
.58637 .64408 L
s
.736 .233 .102 r
.44484 .63648 m .45102 .63835 L .42879 .63731 L p F P
0 0 0 r
s
.736 .233 .102 r
.42879 .63731 m .41972 .63459 L .44484 .63648 L p F P
0 0 0 r
s
.83 .24 .1 r
.69509 .62209 m
.67862 .64722 L
s
.67862 .64722 m
.64159 .63537 L
s
.305 .461 .894 r
.53185 .64589 m .52828 .64906 L .51452 .64133 L p F P
0 0 0 r
s
.24 .35 .67 r
.52687 .64851 m
.52704 .64836 L
s
.83 .24 .1 r
.53072 .64725 m
.56888 .65894 L
s
.305 .461 .894 r
.51271 .64297 m .51452 .64133 L .52828 .64906 L p F P
0 0 0 r
s
.83 .24 .1 r
.52204 .65185 m
.53072 .64725 L
s
.29234 .27585 m
.25091 .25977 L
s
.29234 .27585 m
.30371 .26677 L
s
.75663 .57479 m
.7456 .60554 L
s
.7456 .60554 m
.70929 .59319 L
s
.75663 .57479 m
.72043 .56209 L
s
.895 .274 .118 r
.48747 .63962 m .49058 .64057 L .48164 .64759 L p F P
0 0 0 r
s
.895 .274 .118 r
.48164 .64759 m .47556 .64575 L .48747 .63962 L p F P
0 0 0 r
s
.83 .24 .1 r
.47581 .64425 m
.4775 .64476 L
s
.47236 .64479 m
.47581 .64425 L
s
.24 .35 .67 r
.52192 .2725 m
.54751 .27368 L
s
.57123 .2455 m
.54751 .27368 L
s
.83 .24 .1 r
.73125 .50014 m
.72787 .53049 L
s
.525 .13 .05 r
.57039 .36946 m .55324 .36273 L .55759 .37413 L p F P
0 0 0 r
s
.525 .13 .05 r
.55759 .37413 m .57611 .38134 L .57039 .36946 L p F P
0 0 0 r
s
.378 .084 .035 r
.51647 .34282 m .50066 .33659 L .50074 .34213 L p F P
0 0 0 r
s
.378 .084 .035 r
.50074 .34213 m .51842 .34907 L .51647 .34282 L p F P
0 0 0 r
s
.24 .35 .67 r
.59841 .25242 m
.62592 .26427 L
s
.65123 .23589 m
.62592 .26427 L
s
.024 .035 .067 r
.39091 .39314 m .40076 .38082 L .40821 .36898 L p F P
0 0 0 r
s
.024 .035 .067 r
.41755 .35728 m .40821 .36898 L .40076 .38082 L p F P
0 0 0 r
s
.24 .35 .67 r
.41427 .3676 m
.43498 .34175 L
s
.024 .035 .067 r
.64729 .57472 m .65768 .56575 L .6724 .54742 L p F P
0 0 0 r
s
.024 .035 .067 r
.65768 .56575 m .64729 .57472 L .62966 .59041 L p F P
0 0 0 r
s
.024 .035 .067 r
.62077 .59808 m .62966 .59041 L .64729 .57472 L p F P
0 0 0 r
s
.24 .35 .67 r
.63038 .58725 m
.65546 .56557 L
s
.736 .233 .102 r
.43863 .6346 m .44484 .63648 L .41972 .63459 L p F P
0 0 0 r
s
.24 .35 .67 r
.41387 .65022 m
.42818 .63616 L
s
.736 .233 .102 r
.41972 .63459 m .41061 .63186 L .43863 .6346 L p F P
0 0 0 r
s
.83 .24 .1 r
.39913 .62773 m
.41397 .63219 L
s
.862 .236 .097 r
.69639 .45851 m .67784 .45146 L .67723 .4717 L p F P
0 0 0 r
s
.862 .236 .097 r
.67723 .4717 m .69571 .47861 L .69639 .45851 L p F P
0 0 0 r
s
.273 .421 .783 r
.62966 .59041 m .62077 .59808 L .60113 .61032 L p F P
0 0 0 r
s
.24 .35 .67 r
.60324 .61016 m
.60798 .60605 L
s
.273 .421 .783 r
.5939 .61659 m .60113 .61032 L .62077 .59808 L p F P
0 0 0 r
s
.24 .35 .67 r
.61104 .60341 m
.6133 .60145 L
s
.6133 .60145 m
.63038 .58725 L
s
.309 .47 .901 r
.5676 .6295 m .56217 .63425 L .54272 .63625 L p F P
0 0 0 r
s
.309 .47 .901 r
.53907 .63948 m .54272 .63625 L .56217 .63425 L p F P
0 0 0 r
s
.305 .461 .894 r
.53545 .64269 m .53185 .64589 L .51633 .63969 L p F P
0 0 0 r
s
.24 .35 .67 r
.53029 .64547 m
.53045 .64533 L
s
.305 .461 .894 r
.51452 .64133 m .51633 .63969 L .53185 .64589 L p F P
0 0 0 r
s
.192 .282 .584 r
.36318 .59745 m .37026 .58977 L .35262 .57399 L p F P
0 0 0 r
s
.192 .282 .584 r
.36064 .565 m .35262 .57399 L .37026 .58977 L p F P
0 0 0 r
s
.166 .243 .512 r
.35262 .57399 m .36064 .565 L .34762 .54659 L p F P
0 0 0 r
s
.895 .274 .118 r
.48435 .63867 m .48747 .63962 L .47556 .64575 L p F P
0 0 0 r
s
.895 .274 .118 r
.47556 .64575 m .46946 .64391 L .48435 .63867 L p F P
0 0 0 r
s
.24 .35 .67 r
.46316 .64408 m
.49181 .65271 L
s
.024 .036 .069 r
.6724 .54742 m .68409 .53729 L .69502 .51726 L p F P
0 0 0 r
s
.024 .035 .067 r
.68409 .53729 m .6724 .54742 L .65768 .56575 L p F P
0 0 0 r
s
.24 .35 .67 r
.65546 .56557 m
.66723 .54698 L
s
.83 .24 .1 r
.43614 .31217 m
.39622 .29645 L
s
.43614 .31217 m
.44609 .31682 L
s
.213 .315 .645 r
.37945 .61607 m .38544 .60979 L .36318 .59745 L p F P
0 0 0 r
s
.213 .315 .645 r
.37026 .58977 m .36318 .59745 L .38544 .60979 L p F P
0 0 0 r
s
.83 .24 .1 r
.24907 .582 m
.24282 .57238 L
s
.24282 .57238 m
.20068 .55963 L
s
.166 .243 .512 r
.35643 .53644 m .34762 .54659 L .36064 .565 L p F P
0 0 0 r
s
.136 .196 .427 r
.34762 .54659 m .35643 .53644 L .3479 .51634 L p F P
0 0 0 r
s
.791 .213 .087 r
.65556 .42574 m .63699 .41858 L .6401 .43711 L p F P
0 0 0 r
s
.791 .213 .087 r
.6401 .43711 m .65908 .44432 L .65556 .42574 L p F P
0 0 0 r
s
.83 .24 .1 r
.6572 .44361 m
.65742 .44491 L
s
.686 .18 .072 r
.61254 .39553 m .59442 .38847 L .5992 .40402 L p F P
0 0 0 r
s
.686 .18 .072 r
.5992 .40402 m .6182 .41134 L .61254 .39553 L p F P
0 0 0 r
s
.301 .46 .871 r
.60113 .61032 m .5939 .61659 L .57308 .62471 L p F P
0 0 0 r
s
.301 .46 .871 r
.5676 .6295 m .57308 .62471 L .5939 .61659 L p F P
0 0 0 r
s
.047 .067 .154 r
.69502 .51726 m .70773 .50613 L .71399 .48545 L p F P
0 0 0 r
s
.024 .036 .069 r
.70773 .50613 m .69502 .51726 L .68409 .53729 L p F P
0 0 0 r
s
.266 .404 .736 r
.41755 .35728 m .42705 .34536 L .43478 .33949 L p F P
0 0 0 r
s
.266 .404 .736 r
.44348 .32861 m .43478 .33949 L .42705 .34536 L p F P
0 0 0 r
s
.233 .345 .699 r
.40146 .62911 m .40619 .62431 L .37945 .61607 L p F P
0 0 0 r
s
.233 .345 .699 r
.38544 .60979 m .37945 .61607 L .40619 .62431 L p F P
0 0 0 r
s
.83 .24 .1 r
.38287 .62284 m
.39093 .62527 L
s
.38019 .62189 m
.38287 .62284 L
s
.895 .274 .118 r
.48123 .63772 m .48435 .63867 L .46946 .64391 L p F P
0 0 0 r
s
.895 .274 .118 r
.46946 .64391 m .46334 .64206 L .48123 .63772 L p F P
0 0 0 r
s
.736 .233 .102 r
.43239 .63272 m .43863 .6346 L .41061 .63186 L p F P
0 0 0 r
s
.24 .35 .67 r
.42818 .63616 m
.43114 .63326 L
s
.736 .233 .102 r
.41061 .63186 m .40146 .62911 L .43239 .63272 L p F P
0 0 0 r
s
.24 .35 .67 r
.7638 .34922 m
.73623 .37547 L
s
.73623 .37547 m
.74729 .40257 L
s
.136 .196 .427 r
.35733 .5052 m .3479 .51634 L .35643 .53644 L p F P
0 0 0 r
s
.24 .35 .67 r
.34833 .51369 m
.34876 .51533 L
s
.098 .139 .32 r
.3479 .51634 m .35733 .5052 L .35303 .48447 L p F P
0 0 0 r
s
.911 .252 .104 r
.71399 .48545 m .69571 .47861 L .68996 .49961 L p F P
0 0 0 r
s
.83 .24 .1 r
.69463 .47821 m
.69469 .48235 L
s
.911 .252 .104 r
.68996 .49961 m .70773 .50613 L .71399 .48545 L p F P
0 0 0 r
s
.83 .24 .1 r
.7123 .49311 m
.73125 .50014 L
s
.71173 .4929 m
.7123 .49311 L
s
.24 .35 .67 r
.71101 .49175 m
.71176 .49108 L
s
.71176 .49108 m
.72582 .47866 L
s
.024 .035 .067 r
.37533 .4214 m .38541 .40886 L .39091 .39314 L p F P
0 0 0 r
s
.024 .035 .067 r
.40076 .38082 m .39091 .39314 L .38541 .40886 L p F P
0 0 0 r
s
.24 .35 .67 r
.38744 .40516 m
.38857 .40376 L
s
.38857 .40376 m
.3929 .39517 L
s
.305 .461 .894 r
.53907 .63948 m .53545 .64269 L .51815 .63805 L p F P
0 0 0 r
s
.24 .35 .67 r
.53372 .64242 m
.53389 .64227 L
s
.305 .461 .894 r
.51633 .63969 m .51815 .63805 L .53545 .64269 L p F P
0 0 0 r
s
.24 .35 .67 r
.75321 .42913 m
.72581 .45384 L
s
.72581 .45384 m
.72582 .47866 L
s
.098 .139 .32 r
.36289 .47256 m .35303 .48447 L .35733 .5052 L p F P
0 0 0 r
s
.061 .089 .214 r
.35303 .48447 m .36289 .47256 L .36241 .45234 L p F P
0 0 0 r
s
.24 .35 .67 r
.36246 .45452 m
.36384 .45283 L
s
.895 .274 .118 r
.47811 .63677 m .48123 .63772 L .46334 .64206 L p F P
0 0 0 r
s
.895 .274 .118 r
.46334 .64206 m .45719 .64021 L .47811 .63677 L p F P
0 0 0 r
s
.378 .084 .035 r
.50066 .33659 m .4847 .3303 L .48287 .33512 L p F P
0 0 0 r
s
.83 .24 .1 r
.47517 .32754 m
.48417 .3317 L
s
.378 .084 .035 r
.48287 .33512 m .50074 .34213 L .50066 .33659 L p F P
0 0 0 r
s
.83 .24 .1 r
.34482 .28288 m
.30371 .26677 L
s
.34482 .28288 m
.35538 .28037 L
s
.525 .13 .05 r
.55324 .36273 m .53592 .35594 L .53887 .36683 L p F P
0 0 0 r
s
.525 .13 .05 r
.53887 .36683 m .55759 .37413 L .55324 .36273 L p F P
0 0 0 r
s
.83 .24 .1 r
.34217 .61062 m
.38287 .62284 L
s
.309 .47 .901 r
.57308 .62471 m .5676 .6295 L .54638 .63299 L p F P
0 0 0 r
s
.309 .47 .901 r
.54272 .63625 m .54638 .63299 L .5676 .6295 L p F P
0 0 0 r
s
.24 .35 .67 r
.54227 .63482 m
.54468 .6345 L
s
.041 .06 .137 r
.36241 .45234 m .3725 .43995 L .37533 .4214 L p F P
0 0 0 r
s
.041 .06 .137 r
.38541 .40886 m .37533 .4214 L .3725 .43995 L p F P
0 0 0 r
s
.061 .089 .214 r
.3725 .43995 m .36241 .45234 L .36289 .47256 L p F P
0 0 0 r
s
.25 .373 .748 r
.40619 .62431 m .40146 .62911 L .43239 .63272 L p F P
0 0 0 r
s
.83 .24 .1 r
.70929 .59319 m
.69509 .62209 L
s
.69509 .62209 m
.65794 .60985 L
s
.51516 .64249 m
.53072 .64725 L
s
.15549 .53149 m
.15757 .54658 L
s
.862 .236 .097 r
.67784 .45146 m .65908 .44432 L .65853 .46471 L p F P
0 0 0 r
s
.83 .24 .1 r
.65742 .44491 m
.65905 .44553 L
s
.67671 .45223 m
.6778 .45265 L
s
.862 .236 .097 r
.65853 .46471 m .67723 .4717 L .67784 .45146 L p F P
0 0 0 r
s
.895 .274 .118 r
.47497 .63582 m .47811 .63677 L .45719 .64021 L p F P
0 0 0 r
s
.895 .274 .118 r
.45719 .64021 m .45102 .63835 L .47497 .63582 L p F P
0 0 0 r
s
.24 .35 .67 r
.45652 .31487 m
.47624 .30464 L
s
.49871 .27689 m
.47624 .30464 L
s
.83 .24 .1 r
.72787 .53049 m
.72043 .56209 L
s
.305 .461 .894 r
.54272 .63625 m .53907 .63948 L .51998 .6364 L p F P
0 0 0 r
s
.24 .35 .67 r
.53718 .63935 m
.53735 .6392 L
s
.54066 .63626 m
.54227 .63482 L
s
.305 .461 .894 r
.51815 .63805 m .51998 .6364 L .53907 .63948 L p F P
0 0 0 r
s
.686 .18 .072 r
.59442 .38847 m .57611 .38134 L .57998 .39661 L p F P
0 0 0 r
s
.686 .18 .072 r
.57998 .39661 m .5992 .40402 L .59442 .38847 L p F P
0 0 0 r
s
.791 .213 .087 r
.63699 .41858 m .6182 .41134 L .62091 .42981 L p F P
0 0 0 r
s
.791 .213 .087 r
.62091 .42981 m .6401 .43711 L .63699 .41858 L p F P
0 0 0 r
s
.024 .035 .067 r
.62966 .59041 m .63868 .58263 L .65768 .56575 L p F P
0 0 0 r
s
.273 .421 .783 r
.63868 .58263 m .62966 .59041 L .60845 .60398 L p F P
0 0 0 r
s
.24 .35 .67 r
.6133 .60145 m
.61585 .59925 L
s
.61074 .60251 m
.6133 .60145 L
s
.273 .421 .783 r
.60113 .61032 m .60845 .60398 L .62966 .59041 L p F P
0 0 0 r
s
.976 .293 .126 r
.50912 .64622 m .50604 .64528 L .5 .62969 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.49181 .65271 m
.49867 .64645 L
s
.295 .444 .868 r
.5 .62969 m .51091 .6446 L .50912 .64622 L closepath p F P
0 0 0 r
s
.301 .46 .871 r
.60845 .60398 m .60113 .61032 L .57861 .61987 L p F P
0 0 0 r
s
.301 .46 .871 r
.57308 .62471 m .57861 .61987 L .60113 .61032 L p F P
0 0 0 r
s
.213 .315 .645 r
.38544 .60979 m .39149 .60345 L .37026 .58977 L p F P
0 0 0 r
s
.213 .315 .645 r
.37745 .58198 m .37026 .58977 L .39149 .60345 L p F P
0 0 0 r
s
.192 .282 .584 r
.37026 .58977 m .37745 .58198 L .36064 .565 L p F P
0 0 0 r
s
.895 .274 .118 r
.47184 .63486 m .47497 .63582 L .45102 .63835 L p F P
0 0 0 r
s
.895 .274 .118 r
.45102 .63835 m .44484 .63648 L .47184 .63486 L p F P
0 0 0 r
s
.024 .035 .067 r
.65768 .56575 m .66824 .55664 L .68409 .53729 L p F P
0 0 0 r
s
.024 .035 .067 r
.66824 .55664 m .65768 .56575 L .63868 .58263 L p F P
0 0 0 r
s
.233 .345 .699 r
.40619 .62431 m .41096 .61947 L .38544 .60979 L p F P
0 0 0 r
s
.83 .24 .1 r
.38287 .62284 m
.396 .62012 L
s
.233 .345 .699 r
.39149 .60345 m .38544 .60979 L .41096 .61947 L p F P
0 0 0 r
s
.24 .35 .67 r
.57123 .2455 m
.59841 .25242 L
s
.62337 .22356 m
.59841 .25242 L
s
.976 .293 .126 r
.50604 .64528 m .50296 .64434 L .5 .62969 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.49867 .64645 m
.50078 .64452 L
s
.83 .24 .1 r
.30054 .59811 m
.29097 .5946 L
s
.29097 .5946 m
.24907 .582 L
s
.192 .282 .584 r
.3688 .55588 m .36064 .565 L .37745 .58198 L p F P
0 0 0 r
s
.166 .243 .512 r
.36064 .565 m .3688 .55588 L .35643 .53644 L p F P
0 0 0 r
s
.83 .24 .1 r
.58637 .64408 m
.6037 .62323 L
s
.024 .035 .067 r
.40076 .38082 m .41079 .36827 L .41755 .35728 L p F P
0 0 0 r
s
.024 .035 .067 r
.42705 .34536 m .41755 .35728 L .41079 .36827 L p F P
0 0 0 r
s
.295 .444 .868 r
.5 .62969 m .51271 .64297 L .51091 .6446 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.65794 .60985 m
.64159 .63537 L
s
.64159 .63537 m
.6037 .62323 L
s
.378 .084 .035 r
.4847 .3303 m .46859 .32396 L .46482 .32804 L p F P
0 0 0 r
s
.378 .084 .035 r
.46482 .32804 m .48287 .33512 L .4847 .3303 L p F P
0 0 0 r
s
.83 .24 .1 r
.26164 .25029 m
.25091 .25977 L
s
.911 .252 .104 r
.69571 .47861 m .67723 .4717 L .67199 .49302 L p F P
0 0 0 r
s
.911 .252 .104 r
.67199 .49302 m .68996 .49961 L .69571 .47861 L p F P
0 0 0 r
s
.976 .293 .126 r
.50296 .64434 m .49987 .6434 L .5 .62969 L closepath p F P
0 0 0 r
s
.309 .47 .901 r
.57861 .61987 m .57308 .62471 L .55007 .62972 L p F P
0 0 0 r
s
.309 .47 .901 r
.54638 .63299 m .55007 .62972 L .57308 .62471 L p F P
0 0 0 r
s
.895 .274 .118 r
.46869 .6339 m .47184 .63486 L .44484 .63648 L p F P
0 0 0 r
s
.895 .274 .118 r
.44484 .63648 m .43863 .6346 L .46869 .6339 L p F P
0 0 0 r
s
.24 .35 .67 r
.46316 .64408 m
.47198 .63575 L
s
.44827 .63648 m
.46316 .64408 L
s
.44527 .63495 m
.44827 .63648 L
s
.024 .036 .069 r
.68409 .53729 m .69598 .52697 L .70773 .50613 L p F P
0 0 0 r
s
.024 .035 .067 r
.69598 .52697 m .68409 .53729 L .66824 .55664 L p F P
0 0 0 r
s
.25 .373 .748 r
.43239 .63272 m .43573 .62945 L .40619 .62431 L p F P
0 0 0 r
s
.25 .373 .748 r
.41096 .61947 m .40619 .62431 L .43573 .62945 L p F P
0 0 0 r
s
.525 .13 .05 r
.53592 .35594 m .51842 .34907 L .51994 .35946 L p F P
0 0 0 r
s
.525 .13 .05 r
.51994 .35946 m .53887 .36683 L .53592 .35594 L p F P
0 0 0 r
s
.305 .461 .894 r
.54638 .63299 m .54272 .63625 L .52181 .63474 L p F P
0 0 0 r
s
.305 .461 .894 r
.51998 .6364 m .52181 .63474 L .54272 .63625 L p F P
0 0 0 r
s
.83 .24 .1 r
.72043 .56209 m
.70929 .59319 L
s
.70929 .59319 m
.67215 .58056 L
s
.976 .293 .126 r
.49987 .6434 m .49678 .64246 L .5 .62969 L closepath p F P
0 0 0 r
s
.266 .404 .736 r
.42705 .34536 m .43673 .33323 L .44348 .32861 L p F P
0 0 0 r
s
.24 .35 .67 r
.4196 .35742 m
.43498 .34175 L
s
.266 .404 .736 r
.45233 .31755 m .44348 .32861 L .43673 .33323 L p F P
0 0 0 r
s
.166 .243 .512 r
.3654 .52611 m .35643 .53644 L .3688 .55588 L p F P
0 0 0 r
s
.136 .196 .427 r
.35643 .53644 m .3654 .52611 L .35733 .5052 L p F P
0 0 0 r
s
.295 .444 .868 r
.5 .62969 m .51452 .64133 L .51271 .64297 L closepath p F P
0 0 0 r
s
.976 .293 .126 r
.49678 .64246 m .49368 .64152 L .5 .62969 L closepath p F P
0 0 0 r
s
.895 .274 .118 r
.46554 .63294 m .46869 .6339 L .43863 .6346 L p F P
0 0 0 r
s
.895 .274 .118 r
.43863 .6346 m .43239 .63272 L .46554 .63294 L p F P
0 0 0 r
s
.83 .24 .1 r
.43636 .63232 m
.43782 .63276 L
s
.43405 .63273 m
.43636 .63232 L
s
.24 .35 .67 r
.67849 .25262 m
.70422 .27308 L
s
.73139 .24454 m
.70422 .27308 L
s
.70422 .27308 m
.72754 .29655 L
s
.947 .265 .11 r
.70773 .50613 m .68996 .49961 L .67916 .52093 L p F P
0 0 0 r
s
.947 .265 .11 r
.67916 .52093 m .69598 .52697 L .70773 .50613 L p F P
0 0 0 r
s
.83 .24 .1 r
.69973 .52032 m
.72787 .53049 L
s
.24 .35 .67 r
.66723 .54698 m
.69189 .5255 L
s
.862 .236 .097 r
.65908 .44432 m .6401 .43711 L .63962 .45764 L p F P
0 0 0 r
s
.862 .236 .097 r
.63962 .45764 m .65853 .46471 L .65908 .44432 L p F P
0 0 0 r
s
.83 .24 .1 r
.43364 .6315 m
.43636 .63232 L
s
.976 .293 .126 r
.49368 .64152 m .49058 .64057 L .5 .62969 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.49871 .27689 m
.52192 .2725 L
s
.54544 .24394 m
.52192 .2725 L
s
.70067 .51785 m
.72012 .50091 L
s
.69913 .51919 m
.70067 .51785 L
s
.295 .444 .868 r
.5 .62969 m .51633 .63969 L .51452 .64133 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.77535 .37662 m
.74729 .40257 L
s
.74729 .40257 m
.75321 .42913 L
s
.7552 .26846 m
.72754 .29655 L
s
.72754 .29655 m
.74765 .32222 L
s
.83 .24 .1 r
.39622 .29645 m
.35538 .28037 L
s
.39622 .29645 m
.40551 .30085 L
s
.136 .196 .427 r
.36694 .49384 m .35733 .5052 L .3654 .52611 L p F P
0 0 0 r
s
.098 .139 .32 r
.35733 .5052 m .36694 .49384 L .36289 .47256 L p F P
0 0 0 r
s
.83 .24 .1 r
.20619 .56911 m
.20068 .55963 L
s
.20068 .55963 m
.15757 .54658 L
s
.686 .18 .072 r
.57611 .38134 m .55759 .37413 L .56054 .38912 L p F P
0 0 0 r
s
.686 .18 .072 r
.56054 .38912 m .57998 .39661 L .57611 .38134 L p F P
0 0 0 r
s
.976 .293 .126 r
.49058 .64057 m .48747 .63962 L .5 .62969 L closepath p F P
0 0 0 r
s
.024 .035 .067 r
.38541 .40886 m .3957 .39608 L .40076 .38082 L p F P
0 0 0 r
s
.024 .035 .067 r
.41079 .36827 m .40076 .38082 L .3957 .39608 L p F P
0 0 0 r
s
.24 .35 .67 r
.41049 .36882 m
.4196 .35742 L
s
.791 .213 .087 r
.6182 .41134 m .5992 .40402 L .60148 .42243 L p F P
0 0 0 r
s
.791 .213 .087 r
.60148 .42243 m .62091 .42981 L .6182 .41134 L p F P
0 0 0 r
s
.83 .24 .1 r
.61944 .42925 m
.61963 .43055 L
s
.305 .461 .894 r
.55007 .62972 m .54638 .63299 L .52364 .63308 L p F P
0 0 0 r
s
.24 .35 .67 r
.54415 .63315 m
.54432 .633 L
s
.305 .461 .894 r
.52181 .63474 m .52364 .63308 L .54638 .63299 L p F P
0 0 0 r
s
.267 .399 .792 r
.43573 .62945 m .43239 .63272 L .46554 .63294 L p F P
0 0 0 r
s
.273 .421 .783 r
.60845 .60398 m .61586 .59756 L .63868 .58263 L p F P
0 0 0 r
s
.301 .46 .871 r
.61586 .59756 m .60845 .60398 L .58419 .61499 L p F P
0 0 0 r
s
.301 .46 .871 r
.57861 .61987 m .58419 .61499 L .60845 .60398 L p F P
0 0 0 r
s
.24 .35 .67 r
.59018 .61169 m
.59161 .61045 L
s
.59161 .61045 m
.59498 .60905 L
s
.295 .444 .868 r
.5 .62969 m .51815 .63805 L .51633 .63969 L closepath p F P
0 0 0 r
s
.976 .293 .126 r
.48747 .63962 m .48435 .63867 L .5 .62969 L closepath p F P
0 0 0 r
s
.266 .404 .736 r
.43673 .33323 m .44658 .32088 L .45233 .31755 L p F P
0 0 0 r
s
.378 .084 .035 r
.46859 .32396 m .45233 .31755 L .44658 .32088 L p F P
0 0 0 r
s
.83 .24 .1 r
.44609 .31682 m
.45055 .31857 L
s
.24 .35 .67 r
.45373 .31834 m
.45384 .31821 L
s
.45384 .31821 m
.45652 .31487 L
s
.378 .084 .035 r
.44658 .32088 m .46482 .32804 L .46859 .32396 L p F P
0 0 0 r
s
.24 .35 .67 r
.43498 .34175 m
.45048 .32241 L
s
.309 .47 .901 r
.58419 .61499 m .57861 .61987 L .55378 .62643 L p F P
0 0 0 r
s
.309 .47 .901 r
.55007 .62972 m .55378 .62643 L .57861 .61987 L p F P
0 0 0 r
s
.233 .345 .699 r
.41096 .61947 m .41578 .61459 L .39149 .60345 L p F P
0 0 0 r
s
.233 .345 .699 r
.39762 .59702 m .39149 .60345 L .41578 .61459 L p F P
0 0 0 r
s
.213 .315 .645 r
.39149 .60345 m .39762 .59702 L .37745 .58198 L p F P
0 0 0 r
s
.24 .35 .67 r
.65123 .23589 m
.67849 .25262 L
s
.70522 .22359 m
.67849 .25262 L
s
.098 .139 .32 r
.37294 .46042 m .36289 .47256 L .36694 .49384 L p F P
0 0 0 r
s
.24 .35 .67 r
.36458 .46681 m
.36477 .47029 L
s
.061 .089 .214 r
.36289 .47256 m .37294 .46042 L .3725 .43995 L p F P
0 0 0 r
s
.024 .035 .067 r
.63868 .58263 m .64782 .57475 L .66824 .55664 L p F P
0 0 0 r
s
.273 .421 .783 r
.64782 .57475 m .63868 .58263 L .61586 .59756 L p F P
0 0 0 r
s
.25 .373 .748 r
.43573 .62945 m .43909 .62615 L .41096 .61947 L p F P
0 0 0 r
s
.83 .24 .1 r
.42381 .62852 m
.42942 .63022 L
s
.25 .373 .748 r
.41578 .61459 m .41096 .61947 L .43909 .62615 L p F P
0 0 0 r
s
.976 .293 .126 r
.48435 .63867 m .48123 .63772 L .5 .62969 L closepath p F P
0 0 0 r
s
.911 .252 .104 r
.67723 .4717 m .65853 .46471 L .65381 .48636 L p F P
0 0 0 r
s
.911 .252 .104 r
.65381 .48636 m .67199 .49302 L .67723 .4717 L p F P
0 0 0 r
s
.041 .06 .137 r
.3725 .43995 m .38279 .42731 L .38541 .40886 L p F P
0 0 0 r
s
.041 .06 .137 r
.3957 .39608 m .38541 .40886 L .38279 .42731 L p F P
0 0 0 r
s
.24 .35 .67 r
.38403 .42808 m
.38531 .4212 L
s
.213 .315 .645 r
.38473 .57409 m .37745 .58198 L .39762 .59702 L p F P
0 0 0 r
s
.192 .282 .584 r
.37745 .58198 m .38473 .57409 L .3688 .55588 L p F P
0 0 0 r
s
.525 .13 .05 r
.51842 .34907 m .50074 .34213 L .5008 .352 L p F P
0 0 0 r
s
.525 .13 .05 r
.5008 .352 m .51994 .35946 L .51842 .34907 L p F P
0 0 0 r
s
.061 .089 .214 r
.38279 .42731 m .3725 .43995 L .37294 .46042 L p F P
0 0 0 r
s
.295 .444 .868 r
.5 .62969 m .51998 .6364 L .51815 .63805 L closepath p F P
0 0 0 r
s
.976 .293 .126 r
.48123 .63772 m .47811 .63677 L .5 .62969 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.77582 .29455 m
.74765 .32222 L
s
.74765 .32222 m
.7638 .34922 L
s
.83 .24 .1 r
.30371 .26677 m
.26164 .25029 L
s
.30371 .26677 m
.31359 .26392 L
s
.305 .461 .894 r
.55378 .62643 m .55007 .62972 L .52548 .63142 L p F P
0 0 0 r
s
.24 .35 .67 r
.54767 .63003 m
.54784 .62988 L
s
.305 .461 .894 r
.52364 .63308 m .52548 .63142 L .55007 .62972 L p F P
0 0 0 r
s
.83 .24 .1 r
.53072 .64725 m
.54785 .63205 L
s
.54785 .63205 m
.58637 .64408 L
s
.024 .035 .067 r
.66824 .55664 m .67897 .54738 L .69598 .52697 L p F P
0 0 0 r
s
.83 .24 .1 r
.6834 .54909 m
.72043 .56209 L
s
.024 .035 .067 r
.67897 .54738 m .66824 .55664 L .64782 .57475 L p F P
0 0 0 r
s
.267 .399 .792 r
.46554 .63294 m .46729 .63128 L .43573 .62945 L p F P
0 0 0 r
s
.267 .399 .792 r
.43909 .62615 m .43573 .62945 L .46729 .63128 L p F P
0 0 0 r
s
.83 .24 .1 r
.35469 .60763 m
.34217 .61062 L
s
.34217 .61062 m
.30054 .59811 L
s
.976 .293 .126 r
.47811 .63677 m .47497 .63582 L .5 .62969 L closepath p F P
0 0 0 r
s
.295 .444 .868 r
.5 .62969 m .52181 .63474 L .51998 .6364 L closepath p F P
0 0 0 r
s
.192 .282 .584 r
.3771 .5466 m .3688 .55588 L .38473 .57409 L p F P
0 0 0 r
s
.166 .243 .512 r
.3688 .55588 m .3771 .5466 L .3654 .52611 L p F P
0 0 0 r
s
.83 .24 .1 r
.65794 .60985 m
.67215 .58056 L
s
.947 .265 .11 r
.68996 .49961 m .67199 .49302 L .66216 .51483 L p F P
0 0 0 r
s
.947 .265 .11 r
.66216 .51483 m .67916 .52093 L .68996 .49961 L p F P
0 0 0 r
s
.976 .293 .126 r
.47497 .63582 m .47184 .63486 L .5 .62969 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.7536 .45411 m
.72582 .47866 L
s
.72582 .47866 m
.72012 .50091 L
s
.862 .236 .097 r
.6401 .43711 m .62091 .42981 L .62048 .45048 L p F P
0 0 0 r
s
.83 .24 .1 r
.61963 .43055 m
.62088 .43103 L
s
.63895 .43789 m
.64008 .43832 L
s
.862 .236 .097 r
.62048 .45048 m .63962 .45764 L .6401 .43711 L p F P
0 0 0 r
s
.024 .035 .067 r
.41079 .36827 m .42101 .35547 L .42705 .34536 L p F P
0 0 0 r
s
.024 .035 .067 r
.43673 .33323 m .42705 .34536 L .42101 .35547 L p F P
0 0 0 r
s
.686 .18 .072 r
.55759 .37413 m .53887 .36683 L .54087 .38154 L p F P
0 0 0 r
s
.686 .18 .072 r
.54087 .38154 m .56054 .38912 L .55759 .37413 L p F P
0 0 0 r
s
.976 .293 .126 r
.47184 .63486 m .46869 .6339 L .5 .62969 L closepath p F P
0 0 0 r
s
.295 .444 .868 r
.5 .62969 m .52364 .63308 L .52181 .63474 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.52087 .63268 m
.52376 .63297 L
s
.301 .46 .871 r
.58419 .61499 m .58982 .61007 L .61586 .59756 L p F P
0 0 0 r
s
.309 .47 .901 r
.58982 .61007 m .58419 .61499 L .55752 .62311 L p F P
0 0 0 r
s
.309 .47 .901 r
.55378 .62643 m .55752 .62311 L .58419 .61499 L p F P
0 0 0 r
s
.974 .275 .115 r
.69598 .52697 m .67916 .52093 L .66353 .54196 L p F P
0 0 0 r
s
.974 .275 .115 r
.66353 .54196 m .67897 .54738 L .69598 .52697 L p F P
0 0 0 r
s
.24 .35 .67 r
.68321 .54033 m
.68538 .53686 L
s
.68154 .54301 m
.68321 .54033 L
s
.83 .24 .1 r
.68449 .54455 m
.68576 .53923 L
s
.6834 .54909 m
.68449 .54455 L
s
.791 .213 .087 r
.5992 .40402 m .57998 .39661 L .58183 .41496 L p F P
0 0 0 r
s
.791 .213 .087 r
.58183 .41496 m .60148 .42243 L .5992 .40402 L p F P
0 0 0 r
s
.25 .373 .748 r
.43909 .62615 m .44247 .62284 L .41578 .61459 L p F P
0 0 0 r
s
.25 .373 .748 r
.42064 .60966 m .41578 .61459 L .44247 .62284 L p F P
0 0 0 r
s
.233 .345 .699 r
.41578 .61459 m .42064 .60966 L .39762 .59702 L p F P
0 0 0 r
s
.24 .35 .67 r
.54544 .24394 m
.57123 .2455 L
s
.59592 .21618 m
.57123 .2455 L
s
.976 .293 .126 r
.46869 .6339 m .46554 .63294 L .5 .62969 L closepath p F P
0 0 0 r
s
.305 .461 .894 r
.55752 .62311 m .55378 .62643 L .52733 .62975 L p F P
0 0 0 r
s
.24 .35 .67 r
.55121 .62688 m
.55138 .62673 L
s
.305 .461 .894 r
.52548 .63142 m .52733 .62975 L .55378 .62643 L p F P
0 0 0 r
s
.166 .243 .512 r
.37454 .51559 m .3654 .52611 L .3771 .5466 L p F P
0 0 0 r
s
.136 .196 .427 r
.3654 .52611 m .37454 .51559 L .36694 .49384 L p F P
0 0 0 r
s
.273 .421 .783 r
.61586 .59756 m .62335 .59106 L .64782 .57475 L p F P
0 0 0 r
s
.301 .46 .871 r
.62335 .59106 m .61586 .59756 L .58982 .61007 L p F P
0 0 0 r
s
.267 .399 .792 r
.46729 .63128 m .46905 .62961 L .43909 .62615 L p F P
0 0 0 r
s
.267 .399 .792 r
.44247 .62284 m .43909 .62615 L .46905 .62961 L p F P
0 0 0 r
s
.83 .24 .1 r
.44194 .62896 m
.44357 .62798 L
s
.24 .35 .67 r
.62337 .22356 m
.65123 .23589 L
s
.67756 .20636 m
.65123 .23589 L
s
.83 .24 .1 r
.44609 .31682 m
.40551 .30085 L
s
.44609 .31682 m
.44817 .31996 L
s
.295 .444 .868 r
.5 .62969 m .52548 .63142 L .52364 .63308 L closepath p F P
0 0 0 r
s
.233 .345 .699 r
.40382 .59052 m .39762 .59702 L .42064 .60966 L p F P
0 0 0 r
s
.213 .315 .645 r
.39762 .59702 m .40382 .59052 L .38473 .57409 L p F P
0 0 0 r
s
.282 .422 .833 r
.46729 .63128 m .46554 .63294 L .5 .62969 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.25792 .5853 m
.24907 .582 L
s
.24907 .582 m
.20619 .56911 L
s
.525 .13 .05 r
.50074 .34213 m .48287 .33512 L .48144 .34446 L p F P
0 0 0 r
s
.525 .13 .05 r
.48144 .34446 m .5008 .352 L .50074 .34213 L p F P
0 0 0 r
s
.911 .252 .104 r
.65853 .46471 m .63962 .45764 L .63544 .47962 L p F P
0 0 0 r
s
.911 .252 .104 r
.63544 .47962 m .65381 .48636 L .65853 .46471 L p F P
0 0 0 r
s
.24 .35 .67 r
.45154 .31991 m
.45652 .31487 L
s
.47893 .28689 m
.45652 .31487 L
s
.295 .444 .868 r
.5 .62969 m .52733 .62975 L .52548 .63142 L closepath p F P
0 0 0 r
s
.024 .035 .067 r
.64782 .57475 m .65709 .56675 L .67897 .54738 L p F P
0 0 0 r
s
.83 .24 .1 r
.67215 .58056 m
.6834 .54909 L
s
.24 .35 .67 r
.65546 .56557 m
.67721 .54676 L
s
.273 .421 .783 r
.65709 .56675 m .64782 .57475 L .62335 .59106 L p F P
0 0 0 r
s
.24 .35 .67 r
.63841 .57972 m
.65546 .56557 L
s
.63504 .58264 m
.63841 .57972 L
s
.282 .422 .833 r
.46905 .62961 m .46729 .63128 L .5 .62969 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.67884 .54749 m
.6834 .54909 L
s
.136 .196 .427 r
.37673 .48227 m .36694 .49384 L .37454 .51559 L p F P
0 0 0 r
s
.24 .35 .67 r
.36779 .48909 m
.36856 .49193 L
s
.098 .139 .32 r
.36694 .49384 m .37673 .48227 L .37294 .46042 L p F P
0 0 0 r
s
.213 .315 .645 r
.39213 .56608 m .38473 .57409 L .40382 .59052 L p F P
0 0 0 r
s
.192 .282 .584 r
.38473 .57409 m .39213 .56608 L .3771 .5466 L p F P
0 0 0 r
s
.309 .47 .901 r
.55752 .62311 m .56128 .61978 L .58982 .61007 L p F P
0 0 0 r
s
.305 .461 .894 r
.56128 .61978 m .55752 .62311 L .52918 .62807 L p F P
0 0 0 r
s
.24 .35 .67 r
.55477 .62372 m
.55494 .62357 L
s
.305 .461 .894 r
.52733 .62975 m .52918 .62807 L .55752 .62311 L p F P
0 0 0 r
s
.83 .24 .1 r
.53584 .6283 m
.54785 .63205 L
s
.024 .035 .067 r
.3957 .39608 m .4062 .38303 L .41079 .36827 L p F P
0 0 0 r
s
.024 .035 .067 r
.42101 .35547 m .41079 .36827 L .4062 .38303 L p F P
0 0 0 r
s
.24 .35 .67 r
.40816 .37939 m
.40938 .37786 L
s
.40938 .37786 m
.41477 .36709 L
s
.267 .399 .792 r
.46905 .62961 m .47081 .62793 L .44247 .62284 L p F P
0 0 0 r
s
.267 .399 .792 r
.44587 .6195 m .44247 .62284 L .47081 .62793 L p F P
0 0 0 r
s
.25 .373 .748 r
.44247 .62284 m .44587 .6195 L .42064 .60966 L p F P
0 0 0 r
s
.83 .24 .1 r
.396 .62012 m
.42381 .62852 L
s
.24 .35 .67 r
.7925 .32191 m
.7638 .34922 L
s
.7638 .34922 m
.77535 .37662 L
s
.947 .265 .11 r
.67199 .49302 m .65381 .48636 L .64498 .50866 L p F P
0 0 0 r
s
.947 .265 .11 r
.64498 .50866 m .66216 .51483 L .67199 .49302 L p F P
0 0 0 r
s
.295 .444 .868 r
.5 .62969 m .52918 .62807 L .52733 .62975 L closepath p F P
0 0 0 r
s
.301 .46 .871 r
.58982 .61007 m .5955 .6051 L .62335 .59106 L p F P
0 0 0 r
s
.309 .47 .901 r
.5955 .6051 m .58982 .61007 L .56128 .61978 L p F P
0 0 0 r
s
.282 .422 .833 r
.47081 .62793 m .46905 .62961 L .5 .62969 L closepath p F P
0 0 0 r
s
.862 .236 .097 r
.62091 .42981 m .60148 .42243 L .60113 .44324 L p F P
0 0 0 r
s
.862 .236 .097 r
.60113 .44324 m .62048 .45048 L .62091 .42981 L p F P
0 0 0 r
s
.83 .24 .1 r
.396 .62012 m
.41086 .61054 L
s
.396 .62012 m
.35469 .60763 L
s
.25 .373 .748 r
.42555 .60469 m .42064 .60966 L .44587 .6195 L p F P
0 0 0 r
s
.233 .345 .699 r
.42064 .60966 m .42555 .60469 L .40382 .59052 L p F P
0 0 0 r
s
.686 .18 .072 r
.53887 .36683 m .51994 .35946 L .52097 .37387 L p F P
0 0 0 r
s
.686 .18 .072 r
.52097 .37387 m .54087 .38154 L .53887 .36683 L p F P
0 0 0 r
s
.83 .24 .1 r
.35538 .28037 m
.31359 .26392 L
s
.35538 .28037 m
.36398 .28451 L
s
.24 .35 .67 r
.78173 .40341 m
.75321 .42913 L
s
.75321 .42913 m
.7536 .45411 L
s
.974 .275 .115 r
.67916 .52093 m .66216 .51483 L .64795 .53649 L p F P
0 0 0 r
s
.974 .275 .115 r
.64795 .53649 m .66353 .54196 L .67916 .52093 L p F P
0 0 0 r
s
.83 .24 .1 r
.15757 .54658 m
.1623 .55592 L
s
.098 .139 .32 r
.3832 .44803 m .37294 .46042 L .37673 .48227 L p F P
0 0 0 r
s
.061 .089 .214 r
.37294 .46042 m .3832 .44803 L .38279 .42731 L p F P
0 0 0 r
s
.24 .35 .67 r
.38283 .42955 m
.38403 .42808 L
s
.995 .283 .118 r
.67897 .54738 m .66353 .54196 L .64346 .56207 L p F P
0 0 0 r
s
.24 .35 .67 r
.6783 .54582 m
.68154 .54301 L
s
.67817 .54593 m
.6783 .54582 L
s
.995 .283 .118 r
.64346 .56207 m .65709 .56675 L .67897 .54738 L p F P
0 0 0 r
s
.791 .213 .087 r
.57998 .39661 m .56054 .38912 L .56195 .4074 L p F P
0 0 0 r
s
.791 .213 .087 r
.56195 .4074 m .58183 .41496 L .57998 .39661 L p F P
0 0 0 r
s
.83 .24 .1 r
.5808 .41456 m
.58096 .41587 L
s
.305 .461 .894 r
.52918 .62807 m .53104 .62639 L .56128 .61978 L p F P
0 0 0 r
s
.83 .24 .1 r
.53215 .62715 m
.53584 .6283 L
s
.295 .444 .868 r
.5 .62969 m .53104 .62639 L .52918 .62807 L closepath p F P
0 0 0 r
s
.282 .422 .833 r
.47258 .62625 m .47081 .62793 L .5 .62969 L closepath p F P
0 0 0 r
s
.267 .399 .792 r
.47081 .62793 m .47258 .62625 L .44587 .6195 L p F P
0 0 0 r
s
.041 .06 .137 r
.38279 .42731 m .39329 .41442 L .3957 .39608 L p F P
0 0 0 r
s
.041 .06 .137 r
.4062 .38303 m .3957 .39608 L .39329 .41442 L p F P
0 0 0 r
s
.192 .282 .584 r
.38552 .53717 m .3771 .5466 L .39213 .56608 L p F P
0 0 0 r
s
.166 .243 .512 r
.3771 .5466 m .38552 .53717 L .37454 .51559 L p F P
0 0 0 r
s
.061 .089 .214 r
.39329 .41442 m .38279 .42731 L .3832 .44803 L p F P
0 0 0 r
s
.273 .421 .783 r
.62335 .59106 m .63094 .58449 L .65709 .56675 L p F P
0 0 0 r
s
.83 .24 .1 r
.64996 .57302 m
.67215 .58056 L
s
.64874 .5726 m
.64996 .57302 L
s
.301 .46 .871 r
.63094 .58449 m .62335 .59106 L .5955 .6051 L p F P
0 0 0 r
s
.525 .13 .05 r
.48287 .33512 m .46482 .32804 L .46186 .33684 L p F P
0 0 0 r
s
.525 .13 .05 r
.46186 .33684 m .48144 .34446 L .48287 .33512 L p F P
0 0 0 r
s
.309 .47 .901 r
.56128 .61978 m .56506 .61643 L .5955 .6051 L p F P
0 0 0 r
s
.305 .461 .894 r
.56506 .61643 m .56128 .61978 L .53104 .62639 L p F P
0 0 0 r
s
1 .3 .128 r
.5 .62969 m .51281 .61612 L .50965 .61512 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.50155 .62805 m
.5051 .62915 L
s
1 .3 .128 r
.5 .62969 m .50965 .61512 L .50648 .61413 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.5 .62969 m .50648 .61413 L .50331 .61313 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.49799 .62944 m
.50052 .62709 L
s
1 .3 .128 r
.5 .62969 m .50331 .61313 L .50013 .61214 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.5 .62969 m .50013 .61214 L .49695 .61114 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.5 .62969 m .49695 .61114 L .49376 .61014 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.5 .62969 m .49376 .61014 L .49056 .60913 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.5 .62969 m .53478 .62301 L .53166 .62203 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.5 .62969 m .53166 .62203 L .52853 .62105 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.5 .62969 m .52853 .62105 L .5254 .62007 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.5 .62969 m .5254 .62007 L .52226 .61908 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.5 .62969 m .52226 .61908 L .51912 .61809 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.5 .62969 m .51912 .61809 L .51597 .61711 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.5 .62969 m .51597 .61711 L .51281 .61612 L closepath p F P
0 0 0 r
s
.295 .444 .868 r
.5 .62969 m .53478 .62301 L .53291 .6247 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.51928 .62764 m
.52042 .6266 L
s
.295 .444 .868 r
.5 .62969 m .53291 .6247 L .53104 .62639 L closepath p F P
0 0 0 r
s
.282 .422 .833 r
.47435 .62456 m .47258 .62625 L .5 .62969 L closepath p F P
0 0 0 r
s
.282 .422 .833 r
.47613 .62287 m .47435 .62456 L .5 .62969 L closepath p F P
0 0 0 r
s
.282 .422 .833 r
.47791 .62117 m .47613 .62287 L .5 .62969 L closepath p F P
0 0 0 r
s
.282 .422 .833 r
.4797 .61947 m .47791 .62117 L .5 .62969 L closepath p F P
0 0 0 r
s
.282 .422 .833 r
.4815 .61776 m .4797 .61947 L .5 .62969 L closepath p F P
0 0 0 r
s
.282 .422 .833 r
.4833 .61604 m .4815 .61776 L .5 .62969 L closepath p F P
0 0 0 r
s
.282 .422 .833 r
.4851 .61433 m .4833 .61604 L .5 .62969 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.49706 .62666 m
.49887 .62722 L
s
.282 .422 .833 r
.48692 .6126 m .4851 .61433 L .5 .62969 L closepath p F P
0 0 0 r
s
.282 .422 .833 r
.48874 .61087 m .48692 .6126 L .5 .62969 L closepath p F P
0 0 0 r
s
.282 .422 .833 r
.49056 .60913 m .48874 .61087 L .5 .62969 L closepath p F P
0 0 0 r
s
.267 .399 .792 r
.44929 .61615 m .44587 .6195 L .47258 .62625 L p F P
0 0 0 r
s
.25 .373 .748 r
.44587 .6195 m .44929 .61615 L .42555 .60469 L p F P
0 0 0 r
s
.233 .345 .699 r
.4101 .58394 m .40382 .59052 L .42555 .60469 L p F P
0 0 0 r
s
.213 .315 .645 r
.40382 .59052 m .4101 .58394 L .39213 .56608 L p F P
0 0 0 r
s
.24 .35 .67 r
.47893 .28689 m
.49871 .27689 L
s
.52209 .248 m
.49871 .27689 L
s
.305 .461 .894 r
.53104 .62639 m .53291 .6247 L .56506 .61643 L p F P
0 0 0 r
s
.83 .24 .1 r
.54785 .63205 m
.55681 .62092 L
s
.55681 .62092 m
.55862 .61867 L
s
.267 .399 .792 r
.47258 .62625 m .47435 .62456 L .44929 .61615 L p F P
0 0 0 r
s
.911 .252 .104 r
.63962 .45764 m .62048 .45048 L .61686 .4728 L p F P
0 0 0 r
s
.911 .252 .104 r
.61686 .4728 m .63544 .47962 L .63962 .45764 L p F P
0 0 0 r
s
.024 .035 .067 r
.42101 .35547 m .43143 .34243 L .43673 .33323 L p F P
0 0 0 r
s
.024 .035 .067 r
.44658 .32088 m .43673 .33323 L .43143 .34243 L p F P
0 0 0 r
s
.24 .35 .67 r
.68154 .54301 m
.70869 .51954 L
s
.66455 .55711 m
.68154 .54301 L
s
.83 .24 .1 r
.27081 .24707 m
.26164 .25029 L
s
.301 .46 .871 r
.5955 .6051 m .60124 .60008 L .63094 .58449 L p F P
0 0 0 r
s
.83 .24 .1 r
.6037 .62323 m
.61993 .59732 L
s
.61993 .59732 m
.65794 .60985 L
s
.309 .47 .901 r
.60124 .60008 m .5955 .6051 L .56506 .61643 L p F P
0 0 0 r
s
.83 .24 .1 r
.57718 .61474 m
.6037 .62323 L
s
.305 .461 .894 r
.56886 .61305 m .56506 .61643 L .53291 .6247 L p F P
0 0 0 r
s
.305 .461 .894 r
.53291 .6247 m .53478 .62301 L .56886 .61305 L p F P
0 0 0 r
s
.24 .35 .67 r
.56857 .61331 m
.57324 .61273 L
s
.83 .24 .1 r
.31242 .59485 m
.30054 .59811 L
s
.30054 .59811 m
.25792 .5853 L
s
.267 .399 .792 r
.47435 .62456 m .47613 .62287 L .45273 .61277 L p F P
0 0 0 r
s
.267 .399 .792 r
.45273 .61277 m .44929 .61615 L .47435 .62456 L p F P
0 0 0 r
s
.83 .24 .1 r
.45174 .62306 m
.46787 .628 L
s
.44357 .62798 m
.45174 .62306 L
s
.25 .373 .748 r
.4305 .59967 m .42555 .60469 L .44929 .61615 L p F P
0 0 0 r
s
.233 .345 .699 r
.42555 .60469 m .4305 .59967 L .4101 .58394 L p F P
0 0 0 r
s
.24 .35 .67 r
.59592 .21618 m
.62337 .22356 L
s
.64936 .19352 m
.62337 .22356 L
s
.947 .265 .11 r
.65381 .48636 m .63544 .47962 L .62762 .50243 L p F P
0 0 0 r
s
.947 .265 .11 r
.62762 .50243 m .64498 .50866 L .65381 .48636 L p F P
0 0 0 r
s
.166 .243 .512 r
.38384 .50488 m .37454 .51559 L .38552 .53717 L p F P
0 0 0 r
s
.24 .35 .67 r
.37478 .51196 m
.37582 .51412 L
s
.38535 .53388 m
.38675 .53678 L
s
.136 .196 .427 r
.37454 .51559 m .38384 .50488 L .37673 .48227 L p F P
0 0 0 r
s
.309 .47 .901 r
.56506 .61643 m .56886 .61305 L .60124 .60008 L p F P
0 0 0 r
s
.83 .24 .1 r
.57173 .613 m
.57718 .61474 L
s
.61993 .59732 m
.62336 .59015 L
s
.62336 .59015 m
.62398 .58885 L
s
.61219 .59477 m
.61993 .59732 L
s
1 .289 .122 r
.65709 .56675 m .64346 .56207 L .61949 .58066 L p F P
0 0 0 r
s
1 .289 .122 r
.61949 .58066 m .63094 .58449 L .65709 .56675 L p F P
0 0 0 r
s
.24 .35 .67 r
.64826 .5712 m
.64909 .57048 L
s
.83 .24 .1 r
.62443 .58791 m
.62674 .58309 L
s
.25 .373 .748 r
.44929 .61615 m .45273 .61277 L .4305 .59967 L p F P
0 0 0 r
s
.974 .275 .115 r
.66216 .51483 m .64498 .50866 L .63221 .53097 L p F P
0 0 0 r
s
.974 .275 .115 r
.63221 .53097 m .64795 .53649 L .66216 .51483 L p F P
0 0 0 r
s
.862 .236 .097 r
.60148 .42243 m .58183 .41496 L .58154 .43592 L p F P
0 0 0 r
s
.83 .24 .1 r
.58096 .41587 m
.58182 .41619 L
s
.60031 .42322 m
.60146 .42366 L
s
.862 .236 .097 r
.58154 .43592 m .60113 .44324 L .60148 .42243 L p F P
0 0 0 r
s
.995 .283 .118 r
.66353 .54196 m .64795 .53649 L .62971 .55736 L p F P
0 0 0 r
s
.83 .24 .1 r
.6455 .5358 m
.64784 .53662 L
s
.66333 .54205 m
.66341 .54208 L
s
.995 .283 .118 r
.62971 .55736 m .64346 .56207 L .66353 .54196 L p F P
0 0 0 r
s
.24 .35 .67 r
.64909 .57048 m
.66455 .55711 L
s
.686 .18 .072 r
.51994 .35946 m .5008 .352 L .50084 .36611 L p F P
0 0 0 r
s
.686 .18 .072 r
.50084 .36611 m .52097 .37387 L .51994 .35946 L p F P
0 0 0 r
s
.213 .315 .645 r
.39963 .55795 m .39213 .56608 L .4101 .58394 L p F P
0 0 0 r
s
.192 .282 .584 r
.39213 .56608 m .39963 .55795 L .38552 .53717 L p F P
0 0 0 r
s
.24 .35 .67 r
.3859 .53773 m
.38675 .53678 L
s
1 .301 .128 r
.53166 .62203 m .53478 .62301 L .56886 .61305 L p F P
0 0 0 r
s
.24 .35 .67 r
.56599 .61374 m
.56614 .61361 L
s
.56614 .61361 m
.56696 .61351 L
s
.267 .399 .792 r
.47613 .62287 m .47791 .62117 L .45619 .60937 L p F P
0 0 0 r
s
.267 .399 .792 r
.45619 .60937 m .45273 .61277 L .47613 .62287 L p F P
0 0 0 r
s
.83 .24 .1 r
.6455 .5358 m
.64554 .53565 L
s
.791 .213 .087 r
.56054 .38912 m .54087 .38154 L .54183 .39975 L p F P
0 0 0 r
s
.791 .213 .087 r
.54183 .39975 m .56195 .4074 L .56054 .38912 L p F P
0 0 0 r
s
1 .301 .128 r
.56886 .61305 m .56274 .61109 L .53166 .62203 L p F P
0 0 0 r
s
1 .301 .128 r
.52853 .62105 m .53166 .62203 L .56274 .61109 L p F P
0 0 0 r
s
.525 .13 .05 r
.46482 .32804 m .44658 .32088 L .44206 .32912 L p F P
0 0 0 r
s
.525 .13 .05 r
.44206 .32912 m .46186 .33684 L .46482 .32804 L p F P
0 0 0 r
s
.267 .399 .792 r
.47791 .62117 m .4797 .61947 L .45968 .60595 L p F P
0 0 0 r
s
.267 .399 .792 r
.45968 .60595 m .45619 .60937 L .47791 .62117 L p F P
0 0 0 r
s
.24 .35 .67 r
.45666 .6082 m
.45714 .60844 L
s
1 .301 .128 r
.56274 .61109 m .55659 .60912 L .52853 .62105 L p F P
0 0 0 r
s
1 .301 .128 r
.5254 .62007 m .52853 .62105 L .55659 .60912 L p F P
0 0 0 r
s
1 .295 .124 r
.63094 .58449 m .61949 .58066 L .59231 .59717 L p F P
0 0 0 r
s
1 .295 .124 r
.59231 .59717 m .60124 .60008 L .63094 .58449 L p F P
0 0 0 r
s
.24 .35 .67 r
.62198 .58642 m
.62294 .58603 L
s
.83 .24 .1 r
.40551 .30085 m
.36398 .28451 L
s
.40551 .30085 m
.41233 .312 L
s
.24 .35 .67 r
.70522 .22359 m
.73139 .24454 L
s
.73139 .24454 m
.7552 .26846 L
s
.136 .196 .427 r
.38672 .47047 m .37673 .48227 L .38384 .50488 L p F P
0 0 0 r
s
.098 .139 .32 r
.37673 .48227 m .38672 .47047 L .3832 .44803 L p F P
0 0 0 r
s
1 .299 .126 r
.56274 .61109 m .56886 .61305 L .60124 .60008 L p F P
0 0 0 r
s
.83 .24 .1 r
.2143 .5722 m
.20619 .56911 L
s
.20619 .56911 m
.1623 .55592 L
s
.233 .345 .699 r
.41645 .57729 m .4101 .58394 L .4305 .59967 L p F P
0 0 0 r
s
.213 .315 .645 r
.4101 .58394 m .41645 .57729 L .39963 .55795 L p F P
0 0 0 r
s
.24 .35 .67 r
.40536 .56455 m
.40597 .56389 L
s
.52209 .248 m
.54544 .24394 L
s
.56992 .2142 m
.54544 .24394 L
s
.25 .373 .748 r
.45273 .61277 m .45619 .60937 L .4355 .5946 L p F P
0 0 0 r
s
.24 .35 .67 r
.45228 .6125 m
.45238 .6124 L
s
.45577 .60907 m
.45666 .6082 L
s
.25 .373 .748 r
.4355 .5946 m .4305 .59967 L .45273 .61277 L p F P
0 0 0 r
s
.83 .24 .1 r
.41086 .61054 m
.45174 .62306 L
s
.24 .35 .67 r
.7482 .47645 m
.72012 .50091 L
s
.72012 .50091 m
.70869 .51954 L
s
.80456 .3496 m
.77535 .37662 L
s
.77535 .37662 m
.78173 .40341 L
s
1 .301 .128 r
.55659 .60912 m .55043 .60715 L .5254 .62007 L p F P
0 0 0 r
s
1 .301 .128 r
.52226 .61908 m .5254 .62007 L .55043 .60715 L p F P
0 0 0 r
s
.911 .252 .104 r
.62048 .45048 m .60113 .44324 L .59807 .46591 L p F P
0 0 0 r
s
.911 .252 .104 r
.59807 .46591 m .61686 .4728 L .62048 .45048 L p F P
0 0 0 r
s
.24 .35 .67 r
.7552 .26846 m
.77582 .29455 L
s
.024 .035 .067 r
.4062 .38303 m .41691 .36972 L .42101 .35547 L p F P
0 0 0 r
s
.024 .035 .067 r
.43143 .34243 m .42101 .35547 L .41691 .36972 L p F P
0 0 0 r
s
1 .299 .126 r
.60124 .60008 m .59231 .59717 L .56274 .61109 L p F P
0 0 0 r
s
.267 .399 .792 r
.4797 .61947 m .4815 .61776 L .46319 .60251 L p F P
0 0 0 r
s
.267 .399 .792 r
.46319 .60251 m .45968 .60595 L .4797 .61947 L p F P
0 0 0 r
s
.233 .345 .699 r
.4305 .59967 m .4355 .5946 L .41645 .57729 L p F P
0 0 0 r
s
.24 .35 .67 r
.42908 .58877 m
.4297 .58813 L
s
1 .289 .122 r
.64346 .56207 m .62971 .55736 L .60796 .57681 L p F P
0 0 0 r
s
1 .289 .122 r
.60796 .57681 m .61949 .58066 L .64346 .56207 L p F P
0 0 0 r
s
.83 .24 .1 r
.64339 .5417 m
.6455 .5358 L
s
1 .301 .128 r
.55043 .60715 m .54424 .60517 L .52226 .61908 L p F P
0 0 0 r
s
1 .301 .128 r
.51912 .61809 m .52226 .61908 L .54424 .60517 L p F P
0 0 0 r
s
.192 .282 .584 r
.39409 .52759 m .38552 .53717 L .39963 .55795 L p F P
0 0 0 r
s
.24 .35 .67 r
.39889 .5539 m
.40597 .56389 L
s
.166 .243 .512 r
.38552 .53717 m .39409 .52759 L .38384 .50488 L p F P
0 0 0 r
s
1 .299 .126 r
.55659 .60912 m .56274 .61109 L .59231 .59717 L p F P
0 0 0 r
s
.24 .35 .67 r
.57038 .60984 m
.57183 .60855 L
s
.947 .265 .11 r
.63544 .47962 m .61686 .4728 L .61008 .49613 L p F P
0 0 0 r
s
.947 .265 .11 r
.61008 .49613 m .62762 .50243 L .63544 .47962 L p F P
0 0 0 r
s
.995 .283 .118 r
.64795 .53649 m .63221 .53097 L .61585 .55261 L p F P
0 0 0 r
s
.995 .283 .118 r
.61585 .55261 m .62971 .55736 L .64795 .53649 L p F P
0 0 0 r
s
1 .301 .128 r
.54424 .60517 m .53802 .60318 L .51912 .61809 L p F P
0 0 0 r
s
1 .301 .128 r
.51597 .61711 m .51912 .61809 L .53802 .60318 L p F P
0 0 0 r
s
.24 .35 .67 r
.52845 .61927 m
.53068 .61724 L
s
.098 .139 .32 r
.39367 .43539 m .3832 .44803 L .38672 .47047 L p F P
0 0 0 r
s
.24 .35 .67 r
.38492 .44231 m
.38513 .4457 L
s
.061 .089 .214 r
.3832 .44803 m .39367 .43539 L .39329 .41442 L p F P
0 0 0 r
s
.24 .35 .67 r
.67756 .20636 m
.70522 .22359 L
s
.974 .275 .115 r
.64498 .50866 m .62762 .50243 L .61633 .5254 L p F P
0 0 0 r
s
.974 .275 .115 r
.61633 .5254 m .63221 .53097 L .64498 .50866 L p F P
0 0 0 r
s
.267 .399 .792 r
.4815 .61776 m .4833 .61604 L .46672 .59904 L p F P
0 0 0 r
s
.267 .399 .792 r
.46672 .59904 m .46319 .60251 L .4815 .61776 L p F P
0 0 0 r
s
.686 .18 .072 r
.5008 .352 m .48144 .34446 L .48047 .35825 L p F P
0 0 0 r
s
.686 .18 .072 r
.48047 .35825 m .50084 .36611 L .5008 .352 L p F P
0 0 0 r
s
1 .295 .124 r
.61949 .58066 m .60796 .57681 L .58334 .59423 L p F P
0 0 0 r
s
1 .295 .124 r
.58334 .59423 m .59231 .59717 L .61949 .58066 L p F P
0 0 0 r
s
.24 .35 .67 r
.61153 .59306 m
.61664 .58859 L
s
.61664 .58859 m
.62198 .58642 L
s
1 .301 .128 r
.53802 .60318 m .53179 .60119 L .51597 .61711 L p F P
0 0 0 r
s
.24 .35 .67 r
.53802 .61054 m
.55589 .61249 L
s
1 .301 .128 r
.51281 .61612 m .51597 .61711 L .53179 .60119 L p F P
0 0 0 r
s
.041 .06 .137 r
.39329 .41442 m .404 .40125 L .4062 .38303 L p F P
0 0 0 r
s
.041 .06 .137 r
.41691 .36972 m .4062 .38303 L .404 .40125 L p F P
0 0 0 r
s
.24 .35 .67 r
.40504 .40232 m
.40617 .39595 L
s
.83 .24 .1 r
.36902 .59772 m
.35469 .60763 L
s
.35469 .60763 m
.31242 .59485 L
s
.862 .236 .097 r
.58183 .41496 m .56195 .4074 L .56173 .42851 L p F P
0 0 0 r
s
.83 .24 .1 r
.58065 .41575 m
.58096 .41587 L
s
.862 .236 .097 r
.56173 .42851 m .58154 .43592 L .58183 .41496 L p F P
0 0 0 r
s
1 .299 .126 r
.59231 .59717 m .58334 .59423 L .55659 .60912 L p F P
0 0 0 r
s
.25 .373 .748 r
.45619 .60937 m .45968 .60595 L .44054 .58949 L p F P
0 0 0 r
s
.25 .373 .748 r
.44054 .58949 m .4355 .5946 L .45619 .60937 L p F P
0 0 0 r
s
.24 .35 .67 r
.4297 .58813 m
.43672 .59336 L
s
.83 .24 .1 r
.31359 .26392 m
.27081 .24707 L
s
.31359 .26392 m
.32146 .26777 L
s
1 .299 .126 r
.55043 .60715 m .55659 .60912 L .58334 .59423 L p F P
0 0 0 r
s
.24 .35 .67 r
.57183 .60855 m
.57382 .60678 L
s
.061 .089 .214 r
.404 .40125 m .39329 .41442 L .39367 .43539 L p F P
0 0 0 r
s
1 .301 .128 r
.53179 .60119 m .52553 .59919 L .51281 .61612 L p F P
0 0 0 r
s
.24 .35 .67 r
.53068 .61724 m
.53802 .61054 L
s
1 .301 .128 r
.50965 .61512 m .51281 .61612 L .52553 .59919 L p F P
0 0 0 r
s
.024 .035 .067 r
.43143 .34243 m .44206 .32912 L .44658 .32088 L p F P
0 0 0 r
s
.24 .35 .67 r
.43115 .34297 m
.44116 .33044 L
s
.44116 .33044 m
.44235 .32923 L
s
.267 .399 .792 r
.4833 .61604 m .4851 .61433 L .47027 .59555 L p F P
0 0 0 r
s
.267 .399 .792 r
.47027 .59555 m .46672 .59904 L .4833 .61604 L p F P
0 0 0 r
s
.83 .24 .1 r
.45174 .62306 m
.4681 .60714 L
s
.24 .35 .67 r
.77582 .29455 m
.7925 .32191 L
s
.791 .213 .087 r
.54087 .38154 m .52097 .37387 L .52147 .392 L p F P
0 0 0 r
s
.791 .213 .087 r
.52147 .392 m .54183 .39975 L .54087 .38154 L p F P
0 0 0 r
s
.83 .24 .1 r
.54125 .39952 m
.54138 .40083 L
s
.213 .315 .645 r
.40724 .54971 m .39963 .55795 L .41645 .57729 L p F P
0 0 0 r
s
.24 .35 .67 r
.41508 .5732 m
.4297 .58813 L
s
.192 .282 .584 r
.39963 .55795 m .40724 .54971 L .39409 .52759 L p F P
0 0 0 r
s
.24 .35 .67 r
.44613 .32421 m
.46361 .30235 L
s
.44116 .33044 m
.44217 .32917 L
s
1 .301 .128 r
.52553 .59919 m .51925 .59718 L .50965 .61512 L p F P
0 0 0 r
s
.83 .24 .1 r
.52464 .5989 m
.52525 .59811 L
s
1 .301 .128 r
.50648 .61413 m .50965 .61512 L .51925 .59718 L p F P
0 0 0 r
s
1 .289 .122 r
.62971 .55736 m .61585 .55261 L .59636 .57292 L p F P
0 0 0 r
s
1 .289 .122 r
.59636 .57292 m .60796 .57681 L .62971 .55736 L p F P
0 0 0 r
s
.24 .35 .67 r
.61664 .58859 m
.64271 .56583 L
s
1 .299 .126 r
.58334 .59423 m .57432 .59129 L .55043 .60715 L p F P
0 0 0 r
s
1 .299 .126 r
.54424 .60517 m .55043 .60715 L .57432 .59129 L p F P
0 0 0 r
s
.24 .35 .67 r
.78252 .42855 m
.7536 .45411 L
s
.7536 .45411 m
.7482 .47645 L
s
.233 .345 .699 r
.4355 .5946 m .44054 .58949 L .42288 .57055 L p F P
0 0 0 r
s
.233 .345 .699 r
.42288 .57055 m .41645 .57729 L .4355 .5946 L p F P
0 0 0 r
s
.166 .243 .512 r
.39331 .49397 m .38384 .50488 L .39409 .52759 L p F P
0 0 0 r
s
.136 .196 .427 r
.38384 .50488 m .39331 .49397 L .38672 .47047 L p F P
0 0 0 r
s
.267 .399 .792 r
.4851 .61433 m .48692 .6126 L .47385 .59205 L p F P
0 0 0 r
s
.267 .399 .792 r
.47385 .59205 m .47027 .59555 L .4851 .61433 L p F P
0 0 0 r
s
1 .301 .128 r
.51925 .59718 m .51294 .59516 L .50648 .61413 L p F P
0 0 0 r
s
1 .301 .128 r
.50331 .61313 m .50648 .61413 L .51294 .59516 L p F P
0 0 0 r
s
1 .295 .124 r
.57432 .59129 m .58334 .59423 L .60796 .57681 L p F P
0 0 0 r
s
.213 .315 .645 r
.41645 .57729 m .42288 .57055 L .40724 .54971 L p F P
0 0 0 r
s
.911 .252 .104 r
.60113 .44324 m .58154 .43592 L .57906 .45894 L p F P
0 0 0 r
s
.911 .252 .104 r
.57906 .45894 m .59807 .46591 L .60113 .44324 L p F P
0 0 0 r
s
.83 .24 .1 r
.41233 .312 m
.44438 .32454 L
s
1 .295 .124 r
.60796 .57681 m .59636 .57292 L .57432 .59129 L p F P
0 0 0 r
s
.83 .24 .1 r
.58103 .5845 m
.58206 .58484 L
s
.57953 .58695 m
.58103 .5845 L
s
.25 .373 .748 r
.45968 .60595 m .46319 .60251 L .44563 .58433 L p F P
0 0 0 r
s
.24 .35 .67 r
.45929 .60562 m
.4594 .60551 L
s
.25 .373 .748 r
.44563 .58433 m .44054 .58949 L .45968 .60595 L p F P
0 0 0 r
s
1 .301 .128 r
.51294 .59516 m .50662 .59313 L .50331 .61313 L p F P
0 0 0 r
s
1 .301 .128 r
.50013 .61214 m .50331 .61313 L .50662 .59313 L p F P
0 0 0 r
s
.995 .283 .118 r
.63221 .53097 m .61633 .5254 L .60187 .54782 L p F P
0 0 0 r
s
.83 .24 .1 r
.63203 .53107 m
.63211 .5311 L
s
.995 .283 .118 r
.60187 .54782 m .61585 .55261 L .63221 .53097 L p F P
0 0 0 r
s
1 .299 .126 r
.57432 .59129 m .56526 .58832 L .54424 .60517 L p F P
0 0 0 r
s
.24 .35 .67 r
.57382 .60678 m
.59099 .59153 L
s
1 .299 .126 r
.53802 .60318 m .54424 .60517 L .56526 .58832 L p F P
0 0 0 r
s
.267 .399 .792 r
.48692 .6126 m .48874 .61087 L .47745 .58851 L p F P
0 0 0 r
s
.267 .399 .792 r
.47745 .58851 m .47385 .59205 L .48692 .6126 L p F P
0 0 0 r
s
.83 .24 .1 r
.4806 .61104 m
.4844 .61223 L
s
.24 .35 .67 r
.56992 .2142 m
.59592 .21618 L
s
.62163 .18565 m
.59592 .21618 L
s
.947 .265 .11 r
.61686 .4728 m .59807 .46591 L .59235 .48976 L p F P
0 0 0 r
s
.947 .265 .11 r
.59235 .48976 m .61008 .49613 L .61686 .4728 L p F P
0 0 0 r
s
1 .301 .128 r
.50662 .59313 m .50026 .5911 L .50013 .61214 L p F P
0 0 0 r
s
.24 .35 .67 r
.50138 .608 m
.5086 .60119 L
s
1 .301 .128 r
.49695 .61114 m .50013 .61214 L .50026 .5911 L p F P
0 0 0 r
s
.974 .275 .115 r
.62762 .50243 m .61008 .49613 L .60029 .51977 L p F P
0 0 0 r
s
.974 .275 .115 r
.60029 .51977 m .61633 .5254 L .62762 .50243 L p F P
0 0 0 r
s
.83 .24 .1 r
.26913 .58176 m
.25792 .5853 L
s
.25792 .5853 m
.2143 .5722 L
s
.24 .35 .67 r
.64936 .19352 m
.67756 .20636 L
s
.686 .18 .072 r
.48144 .34446 m .46186 .33684 L .45985 .35031 L p F P
0 0 0 r
s
.686 .18 .072 r
.45985 .35031 m .48047 .35825 L .48144 .34446 L p F P
0 0 0 r
s
.83 .24 .1 r
.41086 .61054 m
.42681 .59424 L
s
.41086 .61054 m
.36902 .59772 L
s
1 .295 .124 r
.56526 .58832 m .57432 .59129 L .59636 .57292 L p F P
0 0 0 r
s
.24 .35 .67 r
.59099 .59153 m
.61664 .58859 L
s
1 .301 .128 r
.50026 .5911 m .49389 .58906 L .49695 .61114 L p F P
0 0 0 r
s
.24 .35 .67 r
.49919 .61007 m
.50138 .608 L
s
1 .301 .128 r
.49376 .61014 m .49695 .61114 L .49389 .58906 L p F P
0 0 0 r
s
.267 .399 .792 r
.48874 .61087 m .49056 .60913 L .48107 .58496 L p F P
0 0 0 r
s
.267 .399 .792 r
.48107 .58496 m .47745 .58851 L .48874 .61087 L p F P
0 0 0 r
s
.83 .24 .1 r
.4681 .60714 m
.4806 .61104 L
s
1 .299 .126 r
.56526 .58832 m .55614 .58534 L .53802 .60318 L p F P
0 0 0 r
s
1 .299 .126 r
.53179 .60119 m .53802 .60318 L .55614 .58534 L p F P
0 0 0 r
s
.24 .35 .67 r
.5086 .60119 m
.53802 .61054 L
s
.862 .236 .097 r
.56195 .4074 m .54183 .39975 L .54168 .42102 L p F P
0 0 0 r
s
.83 .24 .1 r
.54138 .40083 m
.54182 .401 L
s
.56076 .4082 m
.56194 .40864 L
s
.862 .236 .097 r
.54168 .42102 m .56173 .42851 L .56195 .4074 L p F P
0 0 0 r
s
1 .289 .122 r
.61585 .55261 m .60187 .54782 L .58467 .56901 L p F P
0 0 0 r
s
1 .289 .122 r
.58467 .56901 m .59636 .57292 L .61585 .55261 L p F P
0 0 0 r
s
.83 .24 .1 r
.59523 .55441 m
.59624 .55476 L
s
.59343 .55822 m
.59523 .55441 L
s
.136 .196 .427 r
.3969 .45843 m .38672 .47047 L .39331 .49397 L p F P
0 0 0 r
s
.24 .35 .67 r
.38807 .46365 m
.38917 .46757 L
s
.098 .139 .32 r
.38672 .47047 m .3969 .45843 L .39367 .43539 L p F P
0 0 0 r
s
1 .301 .128 r
.49389 .58906 m .48749 .58701 L .49376 .61014 L p F P
0 0 0 r
s
1 .301 .128 r
.49056 .60913 m .49376 .61014 L .48749 .58701 L p F P
0 0 0 r
s
.24 .35 .67 r
.46361 .30235 m
.47893 .28689 L
s
.50227 .25776 m
.47893 .28689 L
s
.25 .373 .748 r
.46319 .60251 m .46672 .59904 L .45077 .57912 L p F P
0 0 0 r
s
.24 .35 .67 r
.46283 .60214 m
.46294 .60204 L
s
.25 .373 .748 r
.45077 .57912 m .44563 .58433 L .46319 .60251 L p F P
0 0 0 r
s
.192 .282 .584 r
.40281 .51784 m .39409 .52759 L .40724 .54971 L p F P
0 0 0 r
s
.166 .243 .512 r
.39409 .52759 m .40281 .51784 L .39331 .49397 L p F P
0 0 0 r
s
1 .295 .124 r
.59636 .57292 m .58467 .56901 L .56526 .58832 L p F P
0 0 0 r
s
.791 .213 .087 r
.52097 .37387 m .50084 .36611 L .50086 .38417 L p F P
0 0 0 r
s
.791 .213 .087 r
.50086 .38417 m .52147 .392 L .52097 .37387 L p F P
0 0 0 r
s
.024 .035 .067 r
.41691 .36972 m .42783 .35613 L .43143 .34243 L p F P
0 0 0 r
s
.024 .035 .067 r
.44206 .32912 m .43143 .34243 L .42783 .35613 L p F P
0 0 0 r
s
.24 .35 .67 r
.42972 .35256 m
.43106 .35089 L
s
.43106 .35089 m
.43797 .3369 L
s
.233 .345 .699 r
.44054 .58949 m .44563 .58433 L .42938 .56373 L p F P
0 0 0 r
s
.233 .345 .699 r
.42938 .56373 m .42288 .57055 L .44054 .58949 L p F P
0 0 0 r
s
1 .301 .128 r
.48749 .58701 m .48107 .58496 L .49056 .60913 L p F P
0 0 0 r
s
.24 .35 .67 r
.69177 .53356 m
.66455 .55711 L
s
.66455 .55711 m
.64271 .56583 L
s
1 .299 .126 r
.55614 .58534 m .54698 .58234 L .53179 .60119 L p F P
0 0 0 r
s
1 .299 .126 r
.52553 .59919 m .53179 .60119 L .54698 .58234 L p F P
0 0 0 r
s
.83 .24 .1 r
.52525 .59811 m
.52642 .59849 L
s
.24 .35 .67 r
.7925 .32191 m
.80456 .3496 L
s
1 .295 .124 r
.55614 .58534 m .56526 .58832 L .58467 .56901 L p F P
0 0 0 r
s
.24 .35 .67 r
.53802 .61054 m
.53959 .60911 L
s
.83 .24 .1 r
.36398 .28451 m
.32146 .26777 L
s
.36398 .28451 m
.3701 .29548 L
s
.1623 .55592 m
.16963 .55878 L
s
.995 .283 .118 r
.61633 .5254 m .60029 .51977 L .58777 .54299 L p F P
0 0 0 r
s
.83 .24 .1 r
.61616 .5255 m
.61624 .52553 L
s
.995 .283 .118 r
.58777 .54299 m .60187 .54782 L .61633 .5254 L p F P
0 0 0 r
s
.83 .24 .1 r
.48403 .58591 m
.48463 .5851 L
s
.46544 .60631 m
.4681 .60714 L
s
.213 .315 .645 r
.41496 .54134 m .40724 .54971 L .42288 .57055 L p F P
0 0 0 r
s
.192 .282 .584 r
.40724 .54971 m .41496 .54134 L .40281 .51784 L p F P
0 0 0 r
s
.911 .252 .104 r
.58154 .43592 m .56173 .42851 L .55984 .45189 L p F P
0 0 0 r
s
.911 .252 .104 r
.55984 .45189 m .57906 .45894 L .58154 .43592 L p F P
0 0 0 r
s
.213 .315 .645 r
.42288 .57055 m .42938 .56373 L .41496 .54134 L p F P
0 0 0 r
s
.24 .35 .67 r
.81144 .37662 m
.78173 .40341 L
s
.78173 .40341 m
.78252 .42855 L
s
.098 .139 .32 r
.40435 .42249 m .39367 .43539 L .3969 .45843 L p F P
0 0 0 r
s
.061 .089 .214 r
.39367 .43539 m .40435 .42249 L .404 .40125 L p F P
0 0 0 r
s
.24 .35 .67 r
.40404 .40355 m
.40504 .40232 L
s
1 .299 .126 r
.54698 .58234 m .53776 .57933 L .52553 .59919 L p F P
0 0 0 r
s
.24 .35 .67 r
.53959 .60911 m
.56256 .58814 L
s
1 .299 .126 r
.51925 .59718 m .52553 .59919 L .53776 .57933 L p F P
0 0 0 r
s
.25 .373 .748 r
.46672 .59904 m .47027 .59555 L .45596 .57386 L p F P
0 0 0 r
s
.83 .24 .1 r
.4681 .60714 m
.47677 .59559 L
s
.47677 .59559 m
.47852 .59325 L
s
.24 .35 .67 r
.4664 .59864 m
.4665 .59854 L
s
.25 .373 .748 r
.45596 .57386 m .45077 .57912 L .46672 .59904 L p F P
0 0 0 r
s
.83 .24 .1 r
.59523 .55441 m
.59804 .54651 L
s
.974 .275 .115 r
.61008 .49613 m .59235 .48976 L .5841 .51409 L p F P
0 0 0 r
s
.974 .275 .115 r
.5841 .51409 m .60029 .51977 L .61008 .49613 L p F P
0 0 0 r
s
.947 .265 .11 r
.59807 .46591 m .57906 .45894 L .57442 .48333 L p F P
0 0 0 r
s
.947 .265 .11 r
.57442 .48333 m .59235 .48976 L .59807 .46591 L p F P
0 0 0 r
s
.041 .06 .137 r
.404 .40125 m .41494 .38782 L .41691 .36972 L p F P
0 0 0 r
s
.041 .06 .137 r
.42783 .35613 m .41691 .36972 L .41494 .38782 L p F P
0 0 0 r
s
1 .289 .122 r
.5729 .56508 m .58467 .56901 L .60187 .54782 L p F P
0 0 0 r
s
1 .295 .124 r
.58467 .56901 m .5729 .56508 L .55614 .58534 L p F P
0 0 0 r
s
1 .289 .122 r
.60187 .54782 m .58777 .54299 L .5729 .56508 L p F P
0 0 0 r
s
.061 .089 .214 r
.41494 .38782 m .404 .40125 L .40435 .42249 L p F P
0 0 0 r
s
1 .295 .124 r
.54698 .58234 m .55614 .58534 L .5729 .56508 L p F P
0 0 0 r
s
.686 .18 .072 r
.46186 .33684 m .44206 .32912 L .43899 .34227 L p F P
0 0 0 r
s
.686 .18 .072 r
.43899 .34227 m .45985 .35031 L .46186 .33684 L p F P
0 0 0 r
s
1 .299 .126 r
.53776 .57933 m .52849 .5763 L .51925 .59718 L p F P
0 0 0 r
s
1 .299 .126 r
.51294 .59516 m .51925 .59718 L .52849 .5763 L p F P
0 0 0 r
s
.24 .35 .67 r
.50227 .25776 m
.52209 .248 L
s
.54646 .2179 m
.52209 .248 L
s
.166 .243 .512 r
.40295 .48287 m .39331 .49397 L .40281 .51784 L p F P
0 0 0 r
s
.136 .196 .427 r
.39331 .49397 m .40295 .48287 L .3969 .45843 L p F P
0 0 0 r
s
.83 .24 .1 r
.32617 .58459 m
.31242 .59485 L
s
.31242 .59485 m
.26913 .58176 L
s
.233 .345 .699 r
.44563 .58433 m .45077 .57912 L .43597 .55683 L p F P
0 0 0 r
s
.233 .345 .699 r
.43597 .55683 m .42938 .56373 L .44563 .58433 L p F P
0 0 0 r
s
.862 .236 .097 r
.54183 .39975 m .52147 .392 L .52139 .41343 L p F P
0 0 0 r
s
.83 .24 .1 r
.54063 .40055 m
.54138 .40083 L
s
.862 .236 .097 r
.52139 .41343 m .54168 .42102 L .54183 .39975 L p F P
0 0 0 r
s
.83 .24 .1 r
.27792 .25064 m
.27081 .24707 L
s
.24 .35 .67 r
.73697 .49508 m
.70869 .51954 L
s
.70869 .51954 m
.69177 .53356 L
s
.791 .213 .087 r
.50084 .36611 m .48047 .35825 L .48 .37624 L p F P
0 0 0 r
s
.791 .213 .087 r
.48 .37624 m .50086 .38417 L .50084 .36611 L p F P
0 0 0 r
s
.83 .24 .1 r
.50075 .38413 m
.50085 .38544 L
s
.25 .373 .748 r
.47027 .59555 m .47385 .59205 L .4612 .56855 L p F P
0 0 0 r
s
.24 .35 .67 r
.46998 .59512 m
.47009 .59501 L
s
.25 .373 .748 r
.4612 .56855 m .45596 .57386 L .47027 .59555 L p F P
0 0 0 r
s
.83 .24 .1 r
.42681 .59424 m
.46544 .60631 L
s
1 .299 .126 r
.52849 .5763 m .51918 .57326 L .51294 .59516 L p F P
0 0 0 r
s
1 .299 .126 r
.50662 .59313 m .51294 .59516 L .51918 .57326 L p F P
0 0 0 r
s
.995 .283 .118 r
.60029 .51977 m .5841 .51409 L .57355 .53812 L p F P
0 0 0 r
s
.83 .24 .1 r
.60013 .51988 m
.60021 .51991 L
s
.995 .283 .118 r
.57355 .53812 m .58777 .54299 L .60029 .51977 L p F P
0 0 0 r
s
.24 .35 .67 r
.62163 .18565 m
.64936 .19352 L
s
1 .295 .124 r
.5729 .56508 m .56105 .56111 L .54698 .58234 L p F P
0 0 0 r
s
1 .295 .124 r
.53776 .57933 m .54698 .58234 L .56105 .56111 L p F P
0 0 0 r
s
1 .289 .122 r
.56105 .56111 m .5729 .56508 L .58777 .54299 L p F P
0 0 0 r
s
.24 .35 .67 r
.49324 .59315 m
.5086 .60119 L
s
.49014 .59152 m
.49324 .59315 L
s
1 .289 .122 r
.58777 .54299 m .57355 .53812 L .56105 .56111 L p F P
0 0 0 r
s
.24 .35 .67 r
.61687 .56852 m
.59099 .59153 L
s
.59099 .59153 m
.56256 .58814 L
s
.911 .252 .104 r
.56173 .42851 m .54168 .42102 L .5404 .44476 L p F P
0 0 0 r
s
.911 .252 .104 r
.5404 .44476 m .55984 .45189 L .56173 .42851 L p F P
0 0 0 r
s
.192 .282 .584 r
.41167 .50793 m .40281 .51784 L .41496 .54134 L p F P
0 0 0 r
s
.166 .243 .512 r
.40281 .51784 m .41167 .50793 L .40295 .48287 L p F P
0 0 0 r
s
.213 .315 .645 r
.42938 .56373 m .43597 .55683 L .42279 .53285 L p F P
0 0 0 r
s
.213 .315 .645 r
.42279 .53285 m .41496 .54134 L .42938 .56373 L p F P
0 0 0 r
s
.83 .24 .1 r
.41233 .312 m
.3701 .29548 L
s
.41233 .312 m
.41622 .32975 L
s
1 .299 .126 r
.51918 .57326 m .50981 .57019 L .50662 .59313 L p F P
0 0 0 r
s
1 .299 .126 r
.50026 .5911 m .50662 .59313 L .50981 .57019 L p F P
0 0 0 r
s
.974 .275 .115 r
.59235 .48976 m .57442 .48333 L .56774 .50835 L p F P
0 0 0 r
s
.974 .275 .115 r
.56774 .50835 m .5841 .51409 L .59235 .48976 L p F P
0 0 0 r
s
.947 .265 .11 r
.57906 .45894 m .55984 .45189 L .55631 .47683 L p F P
0 0 0 r
s
.947 .265 .11 r
.55631 .47683 m .57442 .48333 L .57906 .45894 L p F P
0 0 0 r
s
.192 .282 .584 r
.41496 .54134 m .42279 .53285 L .41167 .50793 L p F P
0 0 0 r
s
.25 .373 .748 r
.47385 .59205 m .47745 .58851 L .46648 .56319 L p F P
0 0 0 r
s
.24 .35 .67 r
.47359 .59157 m
.4737 .59147 L
s
.25 .373 .748 r
.46648 .56319 m .4612 .56855 L .47385 .59205 L p F P
0 0 0 r
s
.136 .196 .427 r
.40729 .44616 m .3969 .45843 L .40295 .48287 L p F P
0 0 0 r
s
.098 .139 .32 r
.3969 .45843 m .40729 .44616 L .40435 .42249 L p F P
0 0 0 r
s
1 .295 .124 r
.56105 .56111 m .54911 .55712 L .53776 .57933 L p F P
0 0 0 r
s
1 .295 .124 r
.52849 .5763 m .53776 .57933 L .54911 .55712 L p F P
0 0 0 r
s
.24 .35 .67 r
.51014 .59973 m
.53274 .5784 L
s
.5086 .60119 m
.51014 .59973 L
s
.83 .24 .1 r
.2248 .56836 m
.2143 .5722 L
s
.2143 .5722 m
.16963 .55878 L
s
.233 .345 .699 r
.45077 .57912 m .45596 .57386 L .44263 .54984 L p F P
0 0 0 r
s
.233 .345 .699 r
.44263 .54984 m .43597 .55683 L .45077 .57912 L p F P
0 0 0 r
s
.24 .35 .67 r
.44253 .33662 m
.45364 .3228 L
s
.024 .035 .067 r
.42783 .35613 m .43899 .34227 L .44206 .32912 L p F P
0 0 0 r
s
.24 .35 .67 r
.4411 .3384 m
.44253 .33662 L
s
1 .299 .126 r
.50981 .57019 m .50039 .56712 L .50026 .5911 L p F P
0 0 0 r
s
1 .299 .126 r
.49389 .58906 m .50026 .5911 L .50039 .56712 L p F P
0 0 0 r
s
.83 .24 .1 r
.38451 .58103 m
.36902 .59772 L
s
.36902 .59772 m
.32617 .58459 L
s
1 .289 .122 r
.54911 .55712 m .56105 .56111 L .57355 .53812 L p F P
0 0 0 r
s
.24 .35 .67 r
.54646 .2179 m
.56992 .2142 L
s
.59544 .18321 m
.56992 .2142 L
s
.77745 .45096 m
.7482 .47645 L
s
.7482 .47645 m
.73697 .49508 L
s
.80456 .3496 m
.81144 .37662 L
s
.862 .236 .097 r
.52147 .392 m .50086 .38417 L .50086 .40575 L p F P
0 0 0 r
s
.83 .24 .1 r
.50085 .38544 m
.50086 .38544 L
s
.52026 .39281 m
.52146 .39327 L
s
.862 .236 .097 r
.50086 .40575 m .52139 .41343 L .52147 .392 L p F P
0 0 0 r
s
.995 .283 .118 r
.5841 .51409 m .56774 .50835 L .55922 .53321 L p F P
0 0 0 r
s
.83 .24 .1 r
.58395 .5142 m
.58403 .51423 L
s
.995 .283 .118 r
.55922 .53321 m .57355 .53812 L .5841 .51409 L p F P
0 0 0 r
s
.791 .213 .087 r
.48047 .35825 m .45985 .35031 L .45889 .36821 L p F P
0 0 0 r
s
.791 .213 .087 r
.45889 .36821 m .48 .37624 L .48047 .35825 L p F P
0 0 0 r
s
1 .299 .126 r
.50039 .56712 m .49092 .56402 L .49389 .58906 L p F P
0 0 0 r
s
1 .299 .126 r
.48749 .58701 m .49389 .58906 L .49092 .56402 L p F P
0 0 0 r
s
.83 .24 .1 r
.48463 .5851 m
.48763 .58607 L
s
1 .289 .122 r
.57355 .53812 m .55922 .53321 L .54911 .55712 L p F P
0 0 0 r
s
1 .295 .124 r
.54911 .55712 m .53709 .55309 L .52849 .5763 L p F P
0 0 0 r
s
1 .295 .124 r
.51918 .57326 m .52849 .5763 L .53709 .55309 L p F P
0 0 0 r
s
.25 .373 .748 r
.47745 .58851 m .48107 .58496 L .47182 .55777 L p F P
0 0 0 r
s
.24 .35 .67 r
.47723 .58801 m
.47733 .5879 L
s
.25 .373 .748 r
.47182 .55777 m .46648 .56319 L .47745 .58851 L p F P
0 0 0 r
s
.098 .139 .32 r
.41525 .40933 m .40435 .42249 L .40729 .44616 L p F P
0 0 0 r
s
.24 .35 .67 r
.40609 .41679 m
.40633 .4201 L
s
.061 .089 .214 r
.40435 .42249 m .41525 .40933 L .41494 .38782 L p F P
0 0 0 r
s
.83 .24 .1 r
.32146 .26777 m
.27792 .25064 L
s
.32146 .26777 m
.32684 .27856 L
s
.41622 .32975 m
.4394 .33871 L
s
.041 .06 .137 r
.41494 .38782 m .42611 .3741 L .42783 .35613 L p F P
0 0 0 r
s
.041 .06 .137 r
.43899 .34227 m .42783 .35613 L .42611 .3741 L p F P
0 0 0 r
s
.24 .35 .67 r
.42693 .37549 m
.4279 .36966 L
s
.83 .24 .1 r
.42681 .59424 m
.38451 .58103 L
s
.974 .275 .115 r
.57442 .48333 m .55631 .47683 L .55123 .50255 L p F P
0 0 0 r
s
.974 .275 .115 r
.55123 .50255 m .56774 .50835 L .57442 .48333 L p F P
0 0 0 r
s
.83 .24 .1 r
.567 .50826 m
.56704 .5081 L
s
.567 .50826 m
.56769 .5085 L
s
1 .299 .126 r
.49092 .56402 m .4814 .56091 L .48749 .58701 L p F P
0 0 0 r
s
1 .299 .126 r
.48107 .58496 m .48749 .58701 L .4814 .56091 L p F P
0 0 0 r
s
.24 .35 .67 r
.48088 .58442 m
.48108 .58422 L
s
.48342 .58192 m
.4848 .58057 L
s
.83 .24 .1 r
.48069 .58384 m
.48108 .58397 L
s
.911 .252 .104 r
.54168 .42102 m .52139 .41343 L .52073 .43754 L p F P
0 0 0 r
s
.911 .252 .104 r
.52073 .43754 m .5404 .44476 L .54168 .42102 L p F P
0 0 0 r
s
1 .289 .122 r
.53709 .55309 m .54911 .55712 L .55922 .53321 L p F P
0 0 0 r
s
.166 .243 .512 r
.41278 .47155 m .40295 .48287 L .41167 .50793 L p F P
0 0 0 r
s
.136 .196 .427 r
.40295 .48287 m .41278 .47155 L .40729 .44616 L p F P
0 0 0 r
s
.061 .089 .214 r
.42611 .3741 m .41494 .38782 L .41525 .40933 L p F P
0 0 0 r
s
.213 .315 .645 r
.43597 .55683 m .44263 .54984 L .43074 .52424 L p F P
0 0 0 r
s
.213 .315 .645 r
.43074 .52424 m .42279 .53285 L .43597 .55683 L p F P
0 0 0 r
s
.233 .345 .699 r
.45596 .57386 m .4612 .56855 L .44938 .54277 L p F P
0 0 0 r
s
.233 .345 .699 r
.44938 .54277 m .44263 .54984 L .45596 .57386 L p F P
0 0 0 r
s
.83 .24 .1 r
.44303 .57178 m
.4717 .58096 L
s
.42681 .59424 m
.44303 .57178 L
s
.947 .265 .11 r
.55984 .45189 m .5404 .44476 L .538 .47025 L p F P
0 0 0 r
s
.947 .265 .11 r
.538 .47025 m .55631 .47683 L .55984 .45189 L p F P
0 0 0 r
s
.83 .24 .1 r
.55761 .53465 m
.567 .50826 L
s
1 .295 .124 r
.53709 .55309 m .52498 .54904 L .51918 .57326 L p F P
0 0 0 r
s
1 .295 .124 r
.50981 .57019 m .51918 .57326 L .52498 .54904 L p F P
0 0 0 r
s
.24 .35 .67 r
.45364 .3228 m
.46361 .30235 L
s
.487 .27307 m
.46361 .30235 L
s
.66989 .54211 m
.64271 .56583 L
s
.64271 .56583 m
.61687 .56852 L
s
1 .299 .126 r
.4814 .56091 m .47182 .55777 L .48107 .58496 L p F P
0 0 0 r
s
.83 .24 .1 r
.47505 .58204 m
.47748 .58281 L
s
.4717 .58096 m
.47505 .58204 L
s
.24 .35 .67 r
.81266 .40191 m
.78252 .42855 L
s
.78252 .42855 m
.77745 .45096 L
s
.995 .283 .118 r
.56774 .50835 m .55123 .50255 L .54475 .52825 L p F P
0 0 0 r
s
.995 .283 .118 r
.54475 .52825 m .55922 .53321 L .56774 .50835 L p F P
0 0 0 r
s
1 .289 .122 r
.55922 .53321 m .54475 .52825 L .53709 .55309 L p F P
0 0 0 r
s
.192 .282 .584 r
.42068 .49786 m .41167 .50793 L .42279 .53285 L p F P
0 0 0 r
s
.166 .243 .512 r
.41167 .50793 m .42068 .49786 L .41278 .47155 L p F P
0 0 0 r
s
.192 .282 .584 r
.42279 .53285 m .43074 .52424 L .42068 .49786 L p F P
0 0 0 r
s
.83 .24 .1 r
.28227 .57115 m
.26913 .58176 L
s
.26913 .58176 m
.2248 .56836 L
s
.862 .236 .097 r
.50086 .38417 m .48 .37624 L .48007 .39798 L p F P
0 0 0 r
s
.83 .24 .1 r
.49964 .38498 m
.50085 .38544 L
s
.862 .236 .097 r
.48007 .39798 m .50086 .40575 L .50086 .38417 L p F P
0 0 0 r
s
1 .289 .122 r
.52498 .54904 m .53709 .55309 L .54475 .52825 L p F P
0 0 0 r
s
1 .295 .124 r
.52498 .54904 m .51279 .54496 L .50981 .57019 L p F P
0 0 0 r
s
1 .295 .124 r
.50039 .56712 m .50981 .57019 L .51279 .54496 L p F P
0 0 0 r
s
.24 .35 .67 r
.4848 .58057 m
.4867 .57871 L
s
.791 .213 .087 r
.45985 .35031 m .43899 .34227 L .43752 .36009 L p F P
0 0 0 r
s
.791 .213 .087 r
.43752 .36009 m .45889 .36821 L .45985 .35031 L p F P
0 0 0 r
s
.24 .35 .67 r
.59544 .18321 m
.62163 .18565 L
s
.974 .275 .115 r
.55631 .47683 m .538 .47025 L .53456 .4967 L p F P
0 0 0 r
s
.974 .275 .115 r
.53456 .4967 m .55123 .50255 L .55631 .47683 L p F P
0 0 0 r
s
.233 .345 .699 r
.4612 .56855 m .46648 .56319 L .45622 .5356 L p F P
0 0 0 r
s
.233 .345 .699 r
.45622 .5356 m .44938 .54277 L .4612 .56855 L p F P
0 0 0 r
s
.24 .35 .67 r
.58815 .5648 m
.56256 .58814 L
s
.56256 .58814 m
.53274 .5784 L
s
.136 .196 .427 r
.41788 .43364 m .40729 .44616 L .41278 .47155 L p F P
0 0 0 r
s
.098 .139 .32 r
.40729 .44616 m .41788 .43364 L .41525 .40933 L p F P
0 0 0 r
s
.911 .252 .104 r
.52139 .41343 m .50086 .40575 L .50083 .43024 L p F P
0 0 0 r
s
.911 .252 .104 r
.50083 .43024 m .52073 .43754 L .52139 .41343 L p F P
0 0 0 r
s
.83 .24 .1 r
.3701 .29548 m
.32684 .27856 L
s
.3701 .29548 m
.3733 .31316 L
s
.24 .35 .67 r
.487 .27307 m
.50227 .25776 L
s
.52661 .22739 m
.50227 .25776 L
s
1 .295 .124 r
.51279 .54496 m .50051 .54086 L .50039 .56712 L p F P
0 0 0 r
s
1 .295 .124 r
.49092 .56402 m .50039 .56712 L .50051 .54086 L p F P
0 0 0 r
s
.947 .265 .11 r
.5404 .44476 m .52073 .43754 L .51949 .46361 L p F P
0 0 0 r
s
.947 .265 .11 r
.51949 .46361 m .538 .47025 L .5404 .44476 L p F P
0 0 0 r
s
.213 .315 .645 r
.44263 .54984 m .44938 .54277 L .43881 .51549 L p F P
0 0 0 r
s
.213 .315 .645 r
.43881 .51549 m .43074 .52424 L .44263 .54984 L p F P
0 0 0 r
s
.995 .283 .118 r
.53017 .52325 m .54475 .52825 L .55123 .50255 L p F P
0 0 0 r
s
1 .289 .122 r
.54475 .52825 m .53017 .52325 L .52498 .54904 L p F P
0 0 0 r
s
.995 .283 .118 r
.55123 .50255 m .53456 .4967 L .53017 .52325 L p F P
0 0 0 r
s
1 .289 .122 r
.51279 .54496 m .52498 .54904 L .53017 .52325 L p F P
0 0 0 r
s
.24 .35 .67 r
.72015 .50901 m
.69177 .53356 L
s
.69177 .53356 m
.66989 .54211 L
s
.83 .24 .1 r
.16963 .55878 m
.17938 .55462 L
s
.34119 .5675 m
.32617 .58459 L
s
.32617 .58459 m
.28227 .57115 L
s
.24 .35 .67 r
.81144 .37662 m
.81266 .40191 L
s
.098 .139 .32 r
.42638 .39588 m .41525 .40933 L .41788 .43364 L p F P
0 0 0 r
s
.061 .089 .214 r
.41525 .40933 m .42638 .39588 L .42611 .3741 L p F P
0 0 0 r
s
.24 .35 .67 r
.42614 .37645 m
.42693 .37549 L
s
.862 .236 .097 r
.48 .37624 m .45889 .36821 L .45904 .39012 L p F P
0 0 0 r
s
.83 .24 .1 r
.47877 .37705 m
.48001 .37752 L
s
.862 .236 .097 r
.45904 .39012 m .48007 .39798 L .48 .37624 L p F P
0 0 0 r
s
1 .295 .124 r
.50051 .54086 m .48814 .53672 L .49092 .56402 L p F P
0 0 0 r
s
1 .295 .124 r
.4814 .56091 m .49092 .56402 L .48814 .53672 L p F P
0 0 0 r
s
.24 .35 .67 r
.4867 .57871 m
.50305 .56264 L
s
.166 .243 .512 r
.42279 .46002 m .41278 .47155 L .42068 .49786 L p F P
0 0 0 r
s
.136 .196 .427 r
.41278 .47155 m .42279 .46002 L .41788 .43364 L p F P
0 0 0 r
s
.24 .35 .67 r
.44107 .35815 m
.44974 .34751 L
s
.041 .06 .137 r
.42611 .3741 m .43752 .36009 L .43899 .34227 L p F P
0 0 0 r
s
.233 .345 .699 r
.46648 .56319 m .47182 .55777 L .46314 .52835 L p F P
0 0 0 r
s
.233 .345 .699 r
.46314 .52835 m .45622 .5356 L .46648 .56319 L p F P
0 0 0 r
s
.192 .282 .584 r
.43074 .52424 m .43881 .51549 L .42984 .4876 L p F P
0 0 0 r
s
.192 .282 .584 r
.42984 .4876 m .42068 .49786 L .43074 .52424 L p F P
0 0 0 r
s
.974 .275 .115 r
.538 .47025 m .51949 .46361 L .51772 .49079 L p F P
0 0 0 r
s
.974 .275 .115 r
.51772 .49079 m .53456 .4967 L .538 .47025 L p F P
0 0 0 r
s
1 .289 .122 r
.53017 .52325 m .51546 .51821 L .51279 .54496 L p F P
0 0 0 r
s
1 .289 .122 r
.50051 .54086 m .51279 .54496 L .51546 .51821 L p F P
0 0 0 r
s
.061 .089 .214 r
.43752 .36009 m .42611 .3741 L .42638 .39588 L p F P
0 0 0 r
s
.995 .283 .118 r
.51546 .51821 m .53017 .52325 L .53456 .4967 L p F P
0 0 0 r
s
.166 .243 .512 r
.42068 .49786 m .42984 .4876 L .42279 .46002 L p F P
0 0 0 r
s
.83 .24 .1 r
.28251 .26123 m
.27792 .25064 L
s
.24 .35 .67 r
.52661 .22739 m
.54646 .2179 L
s
.57186 .18652 m
.54646 .2179 L
s
.83 .24 .1 r
.41622 .32975 m
.3733 .31316 L
s
.41622 .32975 m
.41683 .35352 L
s
.40041 .55814 m
.38451 .58103 L
s
.38451 .58103 m
.34119 .5675 L
s
.44303 .57178 m
.45866 .54416 L
s
.40041 .55814 m
.44303 .57178 L
s
.911 .252 .104 r
.50086 .40575 m .48007 .39798 L .4807 .42286 L p F P
0 0 0 r
s
.911 .252 .104 r
.4807 .42286 m .50083 .43024 L .50086 .40575 L p F P
0 0 0 r
s
1 .295 .124 r
.48814 .53672 m .47568 .53255 L .4814 .56091 L p F P
0 0 0 r
s
1 .295 .124 r
.47182 .55777 m .4814 .56091 L .47568 .53255 L p F P
0 0 0 r
s
.995 .283 .118 r
.53456 .4967 m .51772 .49079 L .51546 .51821 L p F P
0 0 0 r
s
.947 .265 .11 r
.52073 .43754 m .50083 .43024 L .50078 .45689 L p F P
0 0 0 r
s
.947 .265 .11 r
.50078 .45689 m .51949 .46361 L .52073 .43754 L p F P
0 0 0 r
s
.24 .35 .67 r
.76646 .46958 m
.73697 .49508 L
s
.73697 .49508 m
.72015 .50901 L
s
.213 .315 .645 r
.44938 .54277 m .45622 .5356 L .447 .50662 L p F P
0 0 0 r
s
.213 .315 .645 r
.447 .50662 m .43881 .51549 L .44938 .54277 L p F P
0 0 0 r
s
.24 .35 .67 r
.55792 .55464 m
.53274 .5784 L
s
.50305 .56264 m
.53274 .5784 L
s
1 .289 .122 r
.51546 .51821 m .50062 .51313 L .50051 .54086 L p F P
0 0 0 r
s
1 .289 .122 r
.48814 .53672 m .50051 .54086 L .50062 .51313 L p F P
0 0 0 r
s
.24 .35 .67 r
.64386 .54453 m
.61687 .56852 L
s
.61687 .56852 m
.58815 .5648 L
s
1 .295 .124 r
.47568 .53255 m .46314 .52835 L .47182 .55777 L p F P
0 0 0 r
s
.24 .35 .67 r
.47253 .54422 m
.47508 .54161 L
s
.47035 .54646 m
.47253 .54422 L
s
.83 .24 .1 r
.46321 .54566 m
.46713 .54696 L
s
.45866 .54416 m
.46321 .54566 L
s
.2373 .55737 m
.2248 .56836 L
s
.2248 .56836 m
.17938 .55462 L
s
.995 .283 .118 r
.50062 .51313 m .51546 .51821 L .51772 .49079 L p F P
0 0 0 r
s
.862 .236 .097 r
.45889 .36821 m .43752 .36009 L .43775 .38215 L p F P
0 0 0 r
s
.83 .24 .1 r
.45765 .36903 m
.4589 .36951 L
s
.24 .35 .67 r
.43902 .36066 m
.44107 .35815 L
s
.862 .236 .097 r
.43775 .38215 m .45904 .39012 L .45889 .36821 L p F P
0 0 0 r
s
.136 .196 .427 r
.42869 .42087 m .41788 .43364 L .42279 .46002 L p F P
0 0 0 r
s
.098 .139 .32 r
.41788 .43364 m .42869 .42087 L .42638 .39588 L p F P
0 0 0 r
s
.974 .275 .115 r
.51949 .46361 m .50078 .45689 L .50071 .48483 L p F P
0 0 0 r
s
.974 .275 .115 r
.50071 .48483 m .51772 .49079 L .51949 .46361 L p F P
0 0 0 r
s
.24 .35 .67 r
.44974 .34751 m
.45364 .3228 L
s
.47718 .2935 m
.45364 .3228 L
s
.995 .283 .118 r
.51772 .49079 m .50071 .48483 L .50062 .51313 L p F P
0 0 0 r
s
.24 .35 .67 r
.57186 .18652 m
.59544 .18321 L
s
.80796 .42439 m
.77745 .45096 L
s
.77745 .45096 m
.76646 .46958 L
s
.192 .282 .584 r
.43881 .51549 m .447 .50662 L .43917 .47717 L p F P
0 0 0 r
s
.192 .282 .584 r
.43917 .47717 m .42984 .4876 L .43881 .51549 L p F P
0 0 0 r
s
.911 .252 .104 r
.48007 .39798 m .45904 .39012 L .46033 .41539 L p F P
0 0 0 r
s
.911 .252 .104 r
.46033 .41539 m .4807 .42286 L .48007 .39798 L p F P
0 0 0 r
s
1 .289 .122 r
.50062 .51313 m .48565 .508 L .48814 .53672 L p F P
0 0 0 r
s
1 .289 .122 r
.47568 .53255 m .48814 .53672 L .48565 .508 L p F P
0 0 0 r
s
.947 .265 .11 r
.50083 .43024 m .4807 .42286 L .48186 .4501 L p F P
0 0 0 r
s
.947 .265 .11 r
.48186 .4501 m .50078 .45689 L .50083 .43024 L p F P
0 0 0 r
s
.83 .24 .1 r
.32684 .27856 m
.28251 .26123 L
s
.32684 .27856 m
.32931 .29616 L
s
.213 .315 .645 r
.45622 .5356 m .46314 .52835 L .45532 .49761 L p F P
0 0 0 r
s
.213 .315 .645 r
.45532 .49761 m .447 .50662 L .45622 .5356 L p F P
0 0 0 r
s
.166 .243 .512 r
.43299 .44826 m .42279 .46002 L .42984 .4876 L p F P
0 0 0 r
s
.136 .196 .427 r
.42279 .46002 m .43299 .44826 L .42869 .42087 L p F P
0 0 0 r
s
.098 .139 .32 r
.43775 .38215 m .42638 .39588 L .42869 .42087 L p F P
0 0 0 r
s
.24 .35 .67 r
.42815 .39021 m
.42841 .39343 L
s
.061 .089 .214 r
.42638 .39588 m .43775 .38215 L .43752 .36009 L p F P
0 0 0 r
s
.83 .24 .1 r
.41683 .35352 m
.43671 .36108 L
s
.995 .283 .118 r
.48565 .508 m .50062 .51313 L .50071 .48483 L p F P
0 0 0 r
s
.166 .243 .512 r
.42984 .4876 m .43917 .47717 L .43299 .44826 L p F P
0 0 0 r
s
.24 .35 .67 r
.52775 .5384 m
.50305 .56264 L
s
.47508 .54161 m
.50305 .56264 L
s
.83 .24 .1 r
.45866 .54416 m
.46208 .53658 L
s
.46208 .53658 m
.4627 .53521 L
s
.41586 .53006 m
.45866 .54416 L
s
.2968 .55363 m
.28227 .57115 L
s
.28227 .57115 m
.2373 .55737 L
s
.974 .275 .115 r
.50078 .45689 m .48186 .4501 L .48353 .4788 L p F P
0 0 0 r
s
.974 .275 .115 r
.48353 .4788 m .50071 .48483 L .50078 .45689 L p F P
0 0 0 r
s
1 .289 .122 r
.48565 .508 m .47055 .50282 L .47568 .53255 L p F P
0 0 0 r
s
1 .289 .122 r
.46314 .52835 m .47568 .53255 L .47055 .50282 L p F P
0 0 0 r
s
.995 .283 .118 r
.50071 .48483 m .48353 .4788 L .48565 .508 L p F P
0 0 0 r
s
.24 .35 .67 r
.46799 .53438 m
.47508 .54161 L
s
.47718 .2935 m
.487 .27307 L
s
.5114 .24253 m
.487 .27307 L
s
.69823 .51737 m
.66989 .54211 L
s
.66989 .54211 m
.64386 .54453 L
s
.47508 .54161 m
.49923 .51684 L
s
.81266 .40191 m
.80796 .42439 L
s
.83 .24 .1 r
.3733 .31316 m
.32931 .29616 L
s
.3733 .31316 m
.37325 .33698 L
s
.35674 .54415 m
.34119 .5675 L
s
.34119 .5675 m
.2968 .55363 L
s
.947 .265 .11 r
.4807 .42286 m .46033 .41539 L .46274 .44323 L p F P
0 0 0 r
s
.947 .265 .11 r
.46274 .44323 m .48186 .4501 L .4807 .42286 L p F P
0 0 0 r
s
.995 .283 .118 r
.47055 .50282 m .48565 .508 L .48353 .4788 L p F P
0 0 0 r
s
.83 .24 .1 r
.41586 .53006 m
.40041 .55814 L
s
.40041 .55814 m
.35674 .54415 L
s
.911 .252 .104 r
.45904 .39012 m .43775 .38215 L .43972 .40783 L p F P
0 0 0 r
s
.24 .35 .67 r
.44017 .39008 m
.45238 .37546 L
s
.911 .252 .104 r
.43972 .40783 m .46033 .41539 L .45904 .39012 L p F P
0 0 0 r
s
.192 .282 .584 r
.447 .50662 m .45532 .49761 L .44866 .46656 L p F P
0 0 0 r
s
.192 .282 .584 r
.44866 .46656 m .43917 .47717 L .447 .50662 L p F P
0 0 0 r
s
.83 .24 .1 r
.42999 .49823 m
.45523 .50681 L
s
1 .289 .122 r
.47055 .50282 m .45532 .49761 L .46314 .52835 L p F P
0 0 0 r
s
.83 .24 .1 r
.45523 .50681 m
.4566 .50728 L
s
.24 .35 .67 r
.45921 .50686 m
.45996 .50605 L
s
.136 .196 .427 r
.43972 .40783 m .42869 .42087 L .43299 .44826 L p F P
0 0 0 r
s
.098 .139 .32 r
.42869 .42087 m .43972 .40783 L .43775 .38215 L p F P
0 0 0 r
s
.24 .35 .67 r
.43952 .39086 m
.44017 .39008 L
s
.83 .24 .1 r
.41396 .38232 m
.43778 .39117 L
s
.24 .35 .67 r
.61484 .54044 m
.58815 .5648 L
s
.58815 .5648 m
.55792 .55464 L
s
.83 .24 .1 r
.41683 .35352 m
.37325 .33698 L
s
.41683 .35352 m
.41396 .38232 L
s
.974 .275 .115 r
.48186 .4501 m .46274 .44323 L .46618 .47271 L p F P
0 0 0 r
s
.974 .275 .115 r
.46618 .47271 m .48353 .4788 L .48186 .4501 L p F P
0 0 0 r
s
.995 .283 .118 r
.48353 .4788 m .46618 .47271 L .47055 .50282 L p F P
0 0 0 r
s
.83 .24 .1 r
.17938 .55462 m
.19121 .54325 L
s
.24 .35 .67 r
.5114 .24253 m
.52661 .22739 L
s
.55199 .1957 m
.52661 .22739 L
s
.74975 .4834 m
.72015 .50901 L
s
.72015 .50901 m
.69823 .51737 L
s
.995 .283 .118 r
.45532 .49761 m .47055 .50282 L .46618 .47271 L p F P
0 0 0 r
s
.166 .243 .512 r
.43917 .47717 m .44866 .46656 L .44339 .43629 L p F P
0 0 0 r
s
.166 .243 .512 r
.44339 .43629 m .43299 .44826 L .43917 .47717 L p F P
0 0 0 r
s
.136 .196 .427 r
.43299 .44826 m .44339 .43629 L .43972 .40783 L p F P
0 0 0 r
s
.947 .265 .11 r
.46033 .41539 m .43972 .40783 L .44339 .43629 L p F P
0 0 0 r
s
.947 .265 .11 r
.44339 .43629 m .46274 .44323 L .46033 .41539 L p F P
0 0 0 r
s
.83 .24 .1 r
.28422 .27873 m
.28251 .26123 L
s
.24 .35 .67 r
.44974 .34751 m
.47355 .31832 L
s
.45238 .37546 m
.44974 .34751 L
s
.974 .275 .115 r
.44866 .46656 m .46618 .47271 L .46274 .44323 L p F P
0 0 0 r
s
.995 .283 .118 r
.46618 .47271 m .44866 .46656 L .45532 .49761 L p F P
0 0 0 r
s
.24 .35 .67 r
.45996 .50605 m
.47393 .49109 L
s
.44329 .42663 m
.46165 .40532 L
s
.974 .275 .115 r
.46274 .44323 m .44339 .43629 L .44866 .46656 L p F P
0 0 0 r
s
.24 .35 .67 r
.44822 .45271 m
.45319 .46252 L
s
.45021 .46586 m
.45319 .46252 L
s
.83 .24 .1 r
.44197 .46439 m
.44724 .46624 L
s
.44724 .46624 m
.44746 .46632 L
s
.24 .35 .67 r
.55199 .1957 m
.57186 .18652 L
s
.83 .24 .1 r
.42999 .49823 m
.41586 .53006 L
s
.41586 .53006 m
.372 .5156 L
s
.25129 .53942 m
.2373 .55737 L
s
.2373 .55737 m
.19121 .54325 L
s
.24 .35 .67 r
.79724 .44297 m
.76646 .46958 L
s
.76646 .46958 m
.74975 .4834 L
s
.83 .24 .1 r
.40767 .41474 m
.44145 .42695 L
s
.44197 .46439 m
.44498 .45325 L
s
.24 .35 .67 r
.5842 .52984 m
.55792 .55464 L
s
.55792 .55464 m
.52775 .5384 L
s
.83 .24 .1 r
.32931 .29616 m
.28422 .27873 L
s
.32931 .29616 m
.32859 .32001 L
s
.24 .35 .67 r
.67204 .51949 m
.64386 .54453 L
s
.64386 .54453 m
.61484 .54044 L
s
.83 .24 .1 r
.31198 .52982 m
.2968 .55363 L
s
.2968 .55363 m
.25129 .53942 L
s
.372 .5156 m
.35674 .54415 L
s
.35674 .54415 m
.31198 .52982 L
s
.42999 .49823 m
.44197 .46439 L
s
.42999 .49823 m
.38609 .4833 L
s
.39821 .44904 m
.44197 .46439 L
s
.24 .35 .67 r
.47355 .31832 m
.47718 .2935 L
s
.50176 .26292 m
.47718 .2935 L
s
.83 .24 .1 r
.41396 .38232 m
.36983 .36593 L
s
.41396 .38232 m
.40767 .41474 L
s
.37325 .33698 m
.32859 .32001 L
s
.37325 .33698 m
.36983 .36593 L
s
.24 .35 .67 r
.80796 .42439 m
.79724 .44297 L
s
.47393 .49109 m
.45319 .46252 L
s
.47728 .4356 m
.45319 .46252 L
s
.55352 .51309 m
.52775 .5384 L
s
.52775 .5384 m
.49923 .51684 L
s
.49923 .51684 m
.47393 .49109 L
s
.49858 .46468 m
.47393 .49109 L
s
.46165 .40532 m
.45238 .37546 L
s
.47655 .3465 m
.45238 .37546 L
s
.50176 .26292 m
.5114 .24253 L
s
.53688 .21065 m
.5114 .24253 L
s
.72782 .49153 m
.69823 .51737 L
s
.69823 .51737 m
.67204 .51949 L
s
.52445 .49099 m
.49923 .51684 L
s
.83 .24 .1 r
.38609 .4833 m
.372 .5156 L
s
.372 .5156 m
.32703 .50078 L
s
.19121 .54325 m
.20464 .52485 L
s
.40767 .41474 m
.36309 .39862 L
s
.40767 .41474 m
.39821 .44904 L
s
.24 .35 .67 r
.64271 .51501 m
.61484 .54044 L
s
.61484 .54044 m
.5842 .52984 L
s
.83 .24 .1 r
.28279 .30262 m
.28422 .27873 L
s
.26609 .51512 m
.25129 .53942 L
s
.25129 .53942 m
.20464 .52485 L
s
.32703 .50078 m
.31198 .52982 L
s
.31198 .52982 m
.26609 .51512 L
s
.24 .35 .67 r
.53688 .21065 m
.55199 .1957 L
s
.78067 .45665 m
.74975 .4834 L
s
.74975 .4834 m
.72782 .49153 L
s
.83 .24 .1 r
.39821 .44904 m
.38609 .4833 L
s
.38609 .4833 m
.34108 .468 L
s
.39821 .44904 m
.35334 .43329 L
s
.36983 .36593 m
.32458 .34913 L
s
.36983 .36593 m
.36309 .39862 L
s
.32859 .32001 m
.28279 .30262 L
s
.32859 .32001 m
.32458 .34913 L
s
.24 .35 .67 r
.47355 .31832 m
.49842 .28784 L
s
.47655 .3465 m
.47355 .31832 L
s
.47728 .4356 m
.46165 .40532 L
s
.48629 .37673 m
.46165 .40532 L
s
.79724 .44297 m
.78067 .45665 L
s
.61165 .50393 m
.5842 .52984 L
s
.5842 .52984 m
.55352 .51309 L
s
.70146 .49333 m
.67204 .51949 L
s
.67204 .51949 m
.64271 .51501 L
s
.83 .24 .1 r
.34108 .468 m
.32703 .50078 L
s
.32703 .50078 m
.28091 .48558 L
s
.36309 .39862 m
.31738 .3821 L
s
.36309 .39862 m
.35334 .43329 L
s
.24 .35 .67 r
.49842 .28784 m
.50176 .26292 L
s
.52744 .23097 m
.50176 .26292 L
s
.49858 .46468 m
.47728 .4356 L
s
.50245 .40747 m
.47728 .4356 L
s
.83 .24 .1 r
.20464 .52485 m
.21902 .50005 L
s
.28091 .48558 m
.26609 .51512 L
s
.26609 .51512 m
.21902 .50005 L
s
.35334 .43329 m
.34108 .468 L
s
.34108 .468 m
.29492 .45231 L
s
.35334 .43329 m
.30731 .41715 L
s
.24 .35 .67 r
.58045 .48664 m
.55352 .51309 L
s
.55352 .51309 m
.52445 .49099 L
s
.83 .24 .1 r
.32458 .34913 m
.27817 .3319 L
s
.32458 .34913 m
.31738 .3821 L
s
.27817 .3319 m
.28279 .30262 L
s
.24 .35 .67 r
.52445 .49099 m
.49858 .46468 L
s
.52433 .43709 m
.49858 .46468 L
s
.48629 .37673 m
.47655 .3465 L
s
.50181 .31625 m
.47655 .3465 L
s
.52744 .23097 m
.53688 .21065 L
s
.75874 .46454 m
.72782 .49153 L
s
.72782 .49153 m
.70146 .49333 L
s
.55081 .46396 m
.52445 .49099 L
s
.67184 .48843 m
.64271 .51501 L
s
.64271 .51501 m
.61165 .50393 L
s
.83 .24 .1 r
.29492 .45231 m
.28091 .48558 L
s
.28091 .48558 m
.2336 .46998 L
s
.31738 .3821 m
.27048 .36514 L
s
.31738 .3821 m
.30731 .41715 L
s
.24 .35 .67 r
.78067 .45665 m
.75874 .46454 L
s
.83 .24 .1 r
.21902 .50005 m
.2336 .46998 L
s
.24 .35 .67 r
.49842 .28784 m
.52441 .25597 L
s
.50181 .31625 m
.49842 .28784 L
s
.83 .24 .1 r
.30731 .41715 m
.29492 .45231 L
s
.29492 .45231 m
.24756 .4362 L
s
.30731 .41715 m
.26009 .40058 L
s
.24 .35 .67 r
.50245 .40747 m
.48629 .37673 L
s
.51204 .34683 m
.48629 .37673 L
s
.83 .24 .1 r
.27048 .36514 m
.27817 .3319 L
s
.24 .35 .67 r
.64035 .47684 m
.61165 .50393 L
s
.61165 .50393 m
.58045 .48664 L
s
.73224 .46598 m
.70146 .49333 L
s
.70146 .49333 m
.67184 .48843 L
s
.52441 .25597 m
.52744 .23097 L
s
.52433 .43709 m
.50245 .40747 L
s
.52878 .37805 m
.50245 .40747 L
s
.83 .24 .1 r
.2336 .46998 m
.24756 .4362 L
s
.26009 .40058 m
.27048 .36514 L
s
.24 .35 .67 r
.60862 .45898 m
.58045 .48664 L
s
.58045 .48664 m
.55081 .46396 L
s
.55081 .46396 m
.52433 .43709 L
s
.55128 .40822 m
.52433 .43709 L
s
.51204 .34683 m
.50181 .31625 L
s
.52824 .2846 m
.50181 .31625 L
s
.75874 .46454 m
.73224 .46598 L
s
.57838 .4357 m
.55081 .46396 L
s
.83 .24 .1 r
.24756 .4362 m
.26009 .40058 L
s
.24 .35 .67 r
.70231 .46062 m
.67184 .48843 L
s
.67184 .48843 m
.64035 .47684 L
s
.52824 .2846 m
.52441 .25597 L
s
.52878 .37805 m
.51204 .34683 L
s
.53899 .31555 m
.51204 .34683 L
s
.67039 .44848 m
.64035 .47684 L
s
.64035 .47684 m
.60862 .45898 L
s
.73224 .46598 m
.70231 .46062 L
s
.55128 .40822 m
.52878 .37805 L
s
.55634 .34725 m
.52878 .37805 L
s
.63812 .43002 m
.60862 .45898 L
s
.60862 .45898 m
.57838 .4357 L
s
.57838 .4357 m
.55128 .40822 L
s
.57949 .378 m
.55128 .40822 L
s
.53899 .31555 m
.52824 .2846 L
s
.60725 .4061 m
.57838 .4357 L
s
.70231 .46062 m
.67039 .44848 L
s
.55634 .34725 m
.53899 .31555 L
s
.67039 .44848 m
.63812 .43002 L
s
.57949 .378 m
.55634 .34725 L
s
.63812 .43002 m
.60725 .4061 L
s
.60725 .4061 m
.57949 .378 L
s
0 0 0 r
.25 Mabswid
.93295 .30234 m
.99253 .5665 L
s
.99253 .5665 m
.33874 .3169 L
s
.33874 .3169 m
.36195 .03848 L
s
.36195 .03848 m
.93295 .30234 L
s
.36195 .03848 m
.11236 .44767 L
s
.11236 .44767 m
.06528 .69847 L
s
.06528 .69847 m
.33874 .3169 L
s
.33874 .3169 m
.36195 .03848 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{500, 500},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40007d0001m2000`400?l00000o`00003oo`3ooooe
0?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3o
m^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40
oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?of
k_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3o
ool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^
m03om^h10?ooo`00o`3om^kd0?ofkP40oooo002d0?ofkP800000o`3om^hn0?ofkP40oooo002c0?of
kP80000000<0ooK^000000000000o`3om^hl0?ofkP40oooo002c0?ofkP8000000`3om^h200000?l0
ooK^>P3om^h10?ooo`00/P3om^h00`000000ooK^000000050?ofkP800000o`3om^hh0?ofkP40oooo
002b0?ofkP030000003om^h0000000L0ooK^0P00003o0?ofkSH0ooK^0@3oool00;40ooK^00@00000
0?ofkP3om^h000002@3om^h200000?l0ooK^=03om^h10?ooo`00/03om^h01@000000ooK^0?ofkP3o
m^h0000000/0ooK^0`00003o0?ofkS40ooK^0@3oool00;00ooK^00@000000?ofkP3om^h000003`3o
m^h200000?l0ooK^;`3om^h10?ooo`00[`3om^h01@000000ooK^0?ofkP3om^h000000140ooK^0P00
003o0?ofkRd0ooK^0@3oool00:l0ooK^00D000000?ofkP3om^h0ooK^0000000C0?ofkP800000o`3o
m^h[0?ofkP40oooo002^0?ofkP030000003om^h0ooK^0080ooK^00<000000?ofkP3om^h04`3om^h2
00000?l0ooK^:@3om^h10?ooo`00[@3om^h00`000000ooK^0?ofkP030?ofkP030000003om^h0ooK^
01D0ooK^0`00003o0?ofkRH0ooK^0@3oool00:d0ooK^00<000000?ofkP3om^h00`3om^h00`000000
ooK^0?ofkP0H0?ofkP800000o`3om^hT0?ofkP40oooo002/0?ofkP030000003om^h0ooK^00@0ooK^
00<000000?ofkP3om^h06P3om^h200000?l0ooK^8P3om^h10?ooo`00Z`3om^h00`000000ooK^0?of
kP050?ofkP030000003om^h0ooK^01`0ooK^0P00003o0?ofkR00ooK^0@3oool00:/0ooK^00<00000
0?ofkP3om^h01@3om^h00`000000ooK^0?ofkP0N0?ofkP800000o`3om^hN0?ofkP40oooo002Z0?of
kP030000003om^h0ooK^00H0ooK^00<000000?ofkP3om^h0803om^h200000?l0ooK^703om^h10?oo
o`00ZP3om^h00`000000ooK^0?ofkP060?ofkP030000003om^h0ooK^0280ooK^0`00003o0?ofkQT0
ooK^0@3oool00:T0ooK^00<000000?ofkP3om^h01`3om^h00`000000ooK^0?ofkP0U0?ofkP800000
o`3om^hG0?ofkP40oooo002X0?ofkP030000003om^h0ooK^00L0ooK^00<000000?ofkP3om^h0:03o
m^h200000?l0ooK^5@3om^h10?ooo`00Z03om^h00`000000ooK^0?ofkP070?ofkP030000003om^h0
ooK^02X0ooK^0P00003o0?ofkQ<0ooK^0@3oool00:L0ooK^00<000000?ofkP3om^h0203om^h00`00
0000ooK^0?ofkP0/0?ofkP800000o`3om^hA0?ofkP40oooo002W0?ofkP030000003om^h0ooK^00P0
ooK^00<000000?ofkP3om^h0;P3om^h200000?l0ooK^3`3om^h10?ooo`00YP3om^h00`000000ooK^
0?ofkP090?ofkP030000003om^h0ooK^0300ooK^0`00003o0?ofkP`0ooK^0@3oool00:D0ooK^00<0
00000?ofkP3om^h02P3om^h00`000000ooK^0?ofkP0c0?ofkP800000o`3om^h:0?ofkP40oooo002U
0?ofkP030000003om^h0ooK^00X0ooK^00<000000?ofkP3om^h0=@3om^h200000?l0ooK^203om^h1
0?ooo`00Y03om^h00`000000ooK^0?ofkP0;0?ofkP030000003om^h0ooK^03L0ooK^0P00003o0?of
kPH0ooK^0@3oool00:@0ooK^00<000000?ofkP3om^h02`3om^h00`000000ooK^0?ofkP0i0?ofkP80
0000o`3om^h40?ofkP40oooo002S0?ofkP030000003om^h0ooK^00`0ooK^00<000000?ofkP3om^h0
>`3om^h300000?l0ooK^0@3om^h10?ooo`00XP3om^h00`000000ooK^0?ofkP0=0?ofkP030000003o
m^h0ooK^03h0ooK^0P00003n0?ofkP40oooo002R0?ofkP030000003om^h0ooK^00d0ooK^00<00000
0?ofkP3om^h0@03om^h200000?`0ooK^0@3oool00:40ooK^00<000000?ofkP3om^h03P3om^h00`00
0000ooK^0?ofkP120?ofkP800000nP3om^h10?ooo`00X@3om^h00`000000ooK^0?ofkP0=0?ofkP03
0000003om^h0ooK^04D0ooK^0P00003h0?ofkP40oooo002P0?ofkP030000003om^h0ooK^00h0ooK^
00<000000?ofkP3om^h0A`3om^h200000?H0ooK^0@3oool009l0ooK^00<000000?ofkP3om^h03`3o
m^h00`000000ooK^0?ofkP190?ofkP<00000l`3om^h10?ooo`00W`3om^h00`000000ooK^0?ofkP0?
0?ofkP030000003om^h0ooK^04`0ooK^0P00003a0?ofkP40oooo002N0?ofkP030000003om^h0ooK^
0100ooK^00<000000?ofkP3om^h0CP3om^h200000>l0ooK^0@3oool009h0ooK^00<000000?ofkP3o
m^h0403om^h00`000000ooK^0?ofkP1@0?ofkP800000k@3om^h10?ooo`00W@3om^h00`000000ooK^
0?ofkP0A0?ofkP030000003om^h0ooK^0580ooK^0P00003[0?ofkP40oooo002L0?ofkP030000003o
m^h0ooK^0180ooK^00<000000?ofkP3om^h0E03om^h200000>T0ooK^0@3oool009`0ooK^00<00000
0?ofkP3om^h04P3om^h00`000000ooK^0?ofkP1F0?ofkP<00000iP3om^h10?ooo`00V`3om^h00`00
0000ooK^0?ofkP0C0?ofkP030000003om^h0ooK^05T0ooK^0P00003T0?ofkP40oooo002J0?ofkP03
0000003om^h0ooK^01@0ooK^00<000000?ofkP3om^h0F`3om^h200000>80ooK^0@3oool009X0ooK^
00<000000?ofkP3om^h0503om^h00`000000ooK^0?ofkP1M0?ofkP800000h03om^h10?ooo`00V@3o
m^h00`000000ooK^0?ofkP0E0?ofkP030000003om^h0ooK^05l0ooK^0P00003N0?ofkP40oooo002I
0?ofkP030000003om^h0ooK^01@0ooK^00<000000?ofkP3om^h0HP3om^h200000=`0ooK^0@3oool0
09P0ooK^00<000000?ofkP3om^h05@3om^h00`000000ooK^0?ofkP1T0?ofkP<00000f@3om^h10?oo
o`00U`3om^h00`000000ooK^0?ofkP0F0?ofkP030000003om^h0ooK^06L0ooK^0P00003G0?ofkP40
oooo002G0?ofkP030000003om^h0ooK^01H0ooK^00<000000?ofkP3om^h0J@3om^h200000=D0ooK^
0@3oool009H0ooK^00<000000?ofkP3om^h05`3om^h00`000000ooK^0?ofkP1[0?ofkP800000d`3o
m^h10?ooo`00UP3om^h00`000000ooK^0?ofkP0G0?ofkP030000003om^h0ooK^06d0ooK^0P00003A
0?ofkP40oooo002E0?ofkP030000003om^h0ooK^01P0ooK^00<000000?ofkP3om^h0K`3om^h30000
0<h0ooK^0@3oool009@0ooK^00<000000?ofkP3om^h06@3om^h00`000000ooK^0?ofkP1b0?ofkP80
0000c03om^h10?ooo`00U03om^h00`000000ooK^0?ofkP0I0?ofkP030000003om^h0ooK^07@0ooK^
0P00003:0?ofkP40oooo002C0?ofkP030000003om^h0ooK^01X0ooK^00<000000?ofkP3om^h0MP3o
m^h200000<P0ooK^0@3oool009<0ooK^00<000000?ofkP3om^h06P3om^h00`000000ooK^0?ofkP1h
0?ofkP800000aP3om^h10?ooo`00TP3om^h00`000000ooK^0?ofkP0K0?ofkP030000003om^h0ooK^
07X0ooK^0P0000340?ofkP40oooo002A0?ofkP030000003om^h0ooK^01/0ooK^00<000000?ofkP3o
m^h0O@3om^h300000<40ooK^0@3oool00940ooK^00<000000?ofkP3om^h06`3om^h00`000000ooK^
0?ofkP200?ofkP800000_`3om^h10?ooo`00T03om^h00`000000ooK^0?ofkP0L0?ofkP030000003o
m^h0ooK^0880ooK^0P00002m0?ofkP40oooo002@0?ofkP030000003om^h0ooK^01`0ooK^00<00000
0?ofkP3om^h0Q03om^h200000;/0ooK^0@3oool008l0ooK^00<000000?ofkP3om^h07@3om^h00`00
0000ooK^0?ofkP260?ofkP800000^@3om^h10?ooo`00SP3om^h00`000000ooK^0?ofkP0N0?ofkP03
0000003om^h0ooK^08P0ooK^0P00002g0?ofkP40oooo002>0?ofkP030000003om^h0ooK^01h0ooK^
00<000000?ofkP3om^h0RP3om^h300000;@0ooK^0@3oool008d0ooK^00<000000?ofkP3om^h07`3o
m^h00`000000ooK^0?ofkP2=0?ofkP800000/P3om^h10?ooo`00S03om^h00`000000ooK^0?ofkP0P
0?ofkP030000003om^h0ooK^08l0ooK^0P00002`0?ofkP40oooo002<0?ofkP030000003om^h0ooK^
0200ooK^00<000000?ofkP3om^h0T@3om^h200000:h0ooK^0@3oool008/0ooK^00<000000?ofkP3o
m^h08@3om^h00`000000ooK^0?ofkP2C0?ofkP800000[03om^h10?ooo`00R`3om^h00`000000ooK^
0?ofkP0Q0?ofkP030000003om^h0ooK^09D0ooK^0`00002Y0?ofkP40oooo002:0?ofkP030000003o
m^h0ooK^0280ooK^00<000000?ofkP3om^h0V03om^h200000:L0ooK^0@3oool008T0ooK^00<00000
0?ofkP3om^h08P3om^h00`000000ooK^0?ofkP2K0?ofkP800000Y@3om^h10?ooo`00R@3om^h00`00
0000ooK^0?ofkP0R0?ofkP030000003om^h0ooK^09d0ooK^0P00002S0?ofkP40oooo00280?ofkP03
0000003om^h0ooK^02<0ooK^00<000000?ofkP3om^h0MP3om^h903eIZb00ooK^0P00002Q0?ofkP40
oooo00280?ofkP030000003om^h0ooK^02<0ooK^00<000000?ofkP3om^h0L03om^h603eIZ`030?of
kP0mFJ/0ooK^00H0ooK^200mFJ/J0?ofkP800000W`3om^h10?ooo`00Q`3om^h00`000000ooK^0?of
kP0T0?ofkP030000003om^h0ooK^06/0ooK^1@0mFJ/60?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0
?EV[0?ofkP3om^h0100mFJ/H0?ofkP<00000W03om^h10?ooo`00QP3om^h00`000000ooK^0?ofkP0U
0?ofkP030000003om^h0ooK^06T0ooK^0`0mFJ/90?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[
0?ofkP3om^h01@3om^h303eIZaP0ooK^0P00002J0?ofkP40oooo00260?ofkP030000003om^h0ooK^
02D0ooK^00<000000?ofkP3om^h0IP3om^h303eIZ`030?ofkP0mFJ/0ooK^00T0ooK^00<0?EV[0?of
kP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP090?ofkP@0?EV[5P3om^h2000009P0ooK^0@3oool008D0
ooK^00<000000?ofkP3om^h09P3om^h00`000000ooK^0?ofkP1T0?ofkP80?EV[0`3om^h00`0mFJ/0
ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h03@3om^h303eIZaD0
ooK^0P00002F0?ofkP40oooo00250?ofkP030000003om^h0ooK^02H0ooK^00<000000?ofkP3om^h0
HP3om^h203eIZ`D0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eI
Z`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h00P0mFJ/E0?ofkP800000U03om^h10?ooo`00Q03o
m^h00`000000ooK^0?ofkP0W0?ofkP030000003om^h0ooK^0640ooK^00<0?EV[0?ofkP3om^h0103o
m^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h03P3o
m^h00`0mFJ/0ooK^0?ofkP030?ofkP80?EV[5@3om^h200000980ooK^0@3oool008<0ooK^00<00000
0?ofkP3om^h0:03om^h00`000000ooK^0?ofkP1P0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[
0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[
0?ofkP3om^h01P3om^h303eIZa@0ooK^0`00002?0?ofkP40oooo00230?ofkP030000003om^h0ooK^
02P0ooK^00<000000?ofkP3om^h0G`3om^h203eIZ`D0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0m
FJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h02@3om^h203eI
ZaD0ooK^0P00002=0?ofkP40oooo00220?ofkP030000003om^h0ooK^02T0ooK^00<000000?ofkP3o
m^h0GP3om^h203eIZ`D0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP03
03eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h0303om^h203eIZaD0ooK^0P00002;0?ofkP40
oooo00220?ofkP030000003om^h0ooK^02P0ooK^00<000000?ofkP3om^h0GP3om^h203eIZ`D0ooK^
00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00l0ooK^
00<0?EV[0?ofkP3om^h03`3om^h203eIZaD0ooK^0P0000290?ofkP40oooo00210?ofkP030000003o
m^h0ooK^02T0ooK^00<000000?ofkP3om^h0G@3om^h203eIZ`D0ooK^00<0?EV[0?ofkP3om^h0203o
m^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h0403o
m^h0100mFJ/0ooK^03eIZ`0mFJ/E0?ofkP800000Q`3om^h10?ooo`00P03om^h00`000000ooK^0?of
kP0Z0?ofkP030000003om^h0ooK^05`0ooK^0P0mFJ/50?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0
?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^0100ooK^00<0
?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP<00000Q03om^h10?ooo`00P03om^h0
0`000000ooK^0?ofkP0Z0?ofkP030000003om^h0ooK^05/0ooK^0P0mFJ/60?ofkP0303eIZ`3om^h0
ooK^00L0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0
ooK^0100ooK^00<0?EV[0?ofkP3om^h0103om^h203eIZaL0ooK^0P0000220?ofkP40oooo001o0?of
kP030000003om^h0ooK^02/0ooK^00<000000?ofkP3om^h0FP3om^h303eIZ`D0ooK^00<0?EV[0?of
kP3om^h01@3om^h903eIZ`L0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0@0?of
kP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h05P3om^h200000800ooK^0@3oool007l0
ooK^00<000000?ofkP3om^h0:`3om^h00`000000ooK^0?ofkP1I0?ofkP<0?EV[1@3om^h00`0mFJ/0
ooK^0?ofkP0603eIZ`030?ofkP0mFJ/0ooK^00H0ooK^200mFJ/?0?ofkP0303eIZ`3om^h0ooK^0100
ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP0G0?ofkP800000OP3om^h10?ooo`00
OP3om^h00`000000ooK^0?ofkP0/0?ofkP030000003om^h0ooK^05T0ooK^0P0mFJ/50?ofkP@0?EV[
1P3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00@0?EV[2`3om^h00`0mFJ/0ooK^
0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00/0ooK^0P0mFJ/I0?ofkP800000O03om^h10?ooo`00O@3o
m^h00`000000ooK^0?ofkP0]0?ofkP030000003om^h0ooK^05P0ooK^0P0mFJ/40?ofkP80?EV[2P3o
m^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00D0ooK^0`0mFJ/70?ofkP0303eIZ`3o
m^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0H0?ofkP800000NP3o
m^h10?ooo`00O@3om^h00`000000ooK^0?ofkP0]0?ofkP030000003om^h0ooK^05L0ooK^0`0mFJ/2
0?ofkP<0?EV[2P3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00P0ooK^100mFJ/2
0?ofkP0303eIZ`3om^h0ooK^0100ooK^00<0?EV[0?ofkP3om^h03`3om^h203eIZaX0ooK^0`00001g
0?ofkP40oooo001l0?ofkP030000003om^h0ooK^02h0ooK^00<000000?ofkP3om^h0EP3om^h00`0m
FJ/0ooK^03eIZ`0303eIZ`80ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP0;0?of
kP0303eIZ`3om^h0ooK^00d0ooK^0`0mFJ/A0?ofkP0303eIZ`3om^h0ooK^0180ooK^00<0?EV[0?of
kP3om^h06P3om^h2000007D0ooK^0@3oool007/0ooK^00<000000?ofkP3om^h0;`3om^h00`000000
ooK^0?ofkP1F0?ofkP@0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00/0
ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0203eIZ`h0ooK^00<0?EV[0?ofkP3o
m^h04P3om^h00`0mFJ/0ooK^03eIZ`0M0?ofkP800000L`3om^h10?ooo`00N`3om^h00`000000ooK^
0?ofkP0_0?ofkP030000003om^h0ooK^05D0ooK^100mFJ/30?ofkP0303eIZ`3om^h0ooK^00L0ooK^
00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00<0ooK^
0P0mFJ/;0?ofkP0303eIZ`3om^h0ooK^0180ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0N0?ofkP80
0000L@3om^h10?ooo`00NP3om^h00`000000ooK^0?ofkP0_0?ofkP030000003om^h0ooK^05D0ooK^
0P0mFJ/00`3om^h0?EV[0?ofkP020?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h0
2P3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00H0ooK^0P0mFJ/80?ofkP0303eI
Z`3om^h0ooK^0180ooK^00<0?EV[0?ofkP3om^h00`3om^h203eIZah0ooK^0P00001_0?ofkP40oooo
001j0?ofkP030000003om^h0ooK^02l0ooK^00<000000?ofkP3om^h0E03om^h203eIZ`80ooK^00@0
?EV[0?ofkP3om^h0?EV[2P3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00d0ooK^
00<0?EV[0?ofkP3om^h02@3om^h203eIZ`D0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^
0?ofkP050?ofkP0303eIZ`3om^h0ooK^01d0ooK^0P00001]0?ofkP40oooo001i0?ofkP030000003o
m^h0ooK^0300ooK^00<000000?ofkP3om^h0E03om^h203eIZ`030?ofkP0mFJ/0?EV[0080ooK^00<0
?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0
?EV[0?ofkP3om^h0303om^h203eIZ`80ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?of
kP070?ofkP0303eIZ`3om^h0ooK^01h0ooK^0`00001Z0?ofkP40oooo001h0?ofkP030000003om^h0
ooK^0340ooK^00<000000?ofkP3om^h0D`3om^h203eIZ`060?ofkP0mFJ/0ooK^03eIZ`3om^h0?EV[
2@3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h0
3`3om^h203eIZaD0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP0P0?ofkP800000
J03om^h10?ooo`00N03om^h00`000000ooK^0?ofkP0a0?ofkP030000003om^h0ooK^0580ooK^0P0m
FJ/20?ofkP80?EV[00<0ooK^03eIZ`3om^h0203om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3o
m^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h0403om^h0100mFJ/0ooK^03eIZ`0mFJ/B0?ofkP0303eI
Z`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h08@3om^h2000006H0ooK^0@3oool007L0ooK^00<0
00000?ofkP3om^h0<P3om^h00`000000ooK^0?ofkP1A0?ofkP80?EV[0P3om^h0100mFJ/0ooK^03eI
Z`0mFJ/:0?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^
0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^
0?ofkP0=0?ofkP80?EV[8`3om^h2000006@0ooK^0@3oool007L0ooK^00<000000?ofkP3om^h0<P3o
m^h00`000000ooK^0?ofkP1A0?ofkP0403eIZ`3om^h0ooK^03eIZ`80ooK^00<0?EV[0?ofkP3om^h0
203om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h0
3`3om^h00`0mFJ/0ooK^0?ofkP040?ofkP80?EV[3@3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0303eI
Z`3om^h0ooK^0280ooK^0P00001R0?ofkP40oooo001f0?ofkP030000003om^h0ooK^03<0ooK^00<0
00000?ofkP3om^h0D03om^h203eIZ`030?ofkP0mFJ/0ooK^0080ooK^00<0?EV[0?ofkP3om^h01@3o
m^h903eIZ`L0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0303eIZ`3o
m^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP0303eIZ`3o
m^h0ooK^02<0ooK^0P00001P0?ofkP40oooo001e0?ofkP030000003om^h0ooK^03@0ooK^00<00000
0?ofkP3om^h0C`3om^h203eIZ`030?ofkP0mFJ/0ooK^0080ooK^0P0mFJ/00`3om^h0?EV[03eIZ`04
03eIZ`030?ofkP0mFJ/0ooK^00H0ooK^2@0mFJ/=0?ofkP0303eIZ`3om^h0ooK^0100ooK^00<0?EV[
0?ofkP3om^h0203om^h203eIZ`P0ooK^00<0?EV[0?ofkP3om^h0503om^h00`0mFJ/0ooK^0?ofkP0T
0?ofkP<00000G@3om^h10?ooo`00M@3om^h00`000000ooK^0?ofkP0=0?ofkP@0e3dI8`3om^h00`00
0000ooK^0?ofkP1>0?ofkP80?EV[00<0ooK^03eIZ`3om^h00P3om^h403eIZ`H0ooK^00<0?EV[0?of
kP3om^h02`3om^h0100mFJ/0ooK^0?ofkP3om^h403eIZ`P0ooK^00<0?EV[0?ofkP3om^h0403om^h0
0`0mFJ/0ooK^0?ofkP0;0?ofkP80?EV[1P3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0
?EV[02P0ooK^0P00001K0?ofkP40oooo001d0?ofkP030000003om^h0ooK^00/0ooK^0`3D?AT30?of
kP<0e3dI8@3om^h00`000000ooK^0?ofkP1>0?ofkP0503eIZ`3om^h0ooK^03eIZ`3om^h00P0mFJ/0
0`3om^h0?EV[0?ofkP060?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h01P3om^h4
03eIZ`<0ooK^00<0?EV[0?ofkP3om^h0403om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0
ooK^0080ooK^00<0?EV[0?ofkP3om^h04`3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[02T0ooK^0P00
001I0?ofkP40oooo001d0?ofkP030000003om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h00P3D?AT4
0?ofkP@0e3dI7P3om^h00`000000ooK^0?ofkP1=0?ofkP80?EV[00<0ooK^03eIZ`0mFJ/00P0mFJ/2
0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP0;
0?ofkP@0?EV[4@3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP80?EV[00<0ooK^03eIZ`3om^h0503om^h0
0`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^02P0ooK^0P00001G0?ofkP40oooo001c0?of
kP030000003om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h00`3om^h20=@m6@80ooK^00<0e3dI0?of
kP3D?AT0103D?ATK0?ofkP030000003om^h0ooK^04`0ooK^0P0mFJ/00`3om^h0?EV[03eIZ`020?of
kP0403eIZ`3om^h0ooK^03eIZ`H0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP0<
0?ofkP0303eIZ`3om^h0ooK^0080?EV[3P3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0
ooK^01<0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP0Y0?ofkP800000E@3om^h1
0?ooo`00LP3om^h00`000000ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00H0ooK^103D?AT30?of
kP@0e3dI603om^h00`000000ooK^0?ofkP1<0?ofkP@0?EV[0`3om^h01@0mFJ/0ooK^0?ofkP3om^h0
?EV[00D0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0
ooK^00<0ooK^0P0mFJ/;0?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP0mFJ/04`3om^h0
0`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^02X0ooK^0`00001B0?ofkP40oooo001b0?of
kP030000003om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h02P3om^h20=@m6@@0ooK^1@3D?ATE0?of
kP030000003om^h0ooK^04/0ooK^100mFJ/30?ofkP0403eIZ`3om^h0ooK^0?ofkP80?EV[103om^h0
0`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h01P3om^h3
03eIZ`P0ooK^00<0?EV[0?ofkP3om^h04P3om^h0100mFJ/0ooK^0?ofkP3om^h203eIZa00ooK^00<0
?EV[0?ofkP3om^h02@3om^h203eIZbd0ooK^0P00001@0?ofkP40oooo001a0?ofkP030000003om^h0
ooK^00T0ooK^0P3D?AT=0?ofkP<0e3dI1@3om^h50=@m6A80ooK^00<000000?ofkP3om^h0B`3om^h0
100mFJ/0ooK^03eIZ`0mFJ/20?ofkP0703eIZ`3om^h0ooK^0?ofkP0mFJ/0ooK^03eIZ`030?ofkP03
03eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP090?ofkP80
?EV[1@3om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3o
m^h0303om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^02`0ooK^0P00001>0?ofkP40
oooo001a0?ofkP030000003om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h00P3D?AT;0?ofkP80e3dI
00@0ooK^0=@m6@3D?AT0e3dI1@3om^h40=@m6A00ooK^00<000000?ofkP3om^h0BP3om^h0100mFJ/0
ooK^03eIZ`0mFJ/20?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP0mFJ/00P3om^h00`0m
FJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h0303om^h203eI
Z`80ooK^00<0?EV[0?ofkP3om^h04P3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^
00/0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0]0?ofkP800000C03om^h10?oo
o`00L03om^h00`000000ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00<0ooK^0`3D?AT80?ofkP04
0=@m6@3om^h0e3dI0=@m6@80ooK^0P3D?AT60?ofkP@0e3dI3@3om^h00`000000ooK^0?ofkP190?of
kP80?EV[00<0ooK^03eIZ`3om^h00P3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00<0ooK^0P0mFJ/=
0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h03`3om^h203eIZa@0ooK^00<0?EV[
0?ofkP3om^h0203om^h203eIZ`X0ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP0^
0?ofkP800000BP3om^h10?ooo`00K`3om^h00`000000ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^
00H0ooK^0P3D?AT60?ofkP040=@m6@3om^h0ooK^0?ofkP<0e3dI00<0ooK^0=@m6@3D?AT00`3om^h2
0=@m6@030?ofkP3D?AT0e3dI0080e3dI2`3om^h00`000000ooK^0?ofkP180?ofkP80?EV[00<0ooK^
03eIZ`0mFJ/00P3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00@0ooK^0P0mFJ/<0?ofkP0303eIZ`3o
m^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h0403om^h0100mFJ/0ooK^03eIZ`0mFJ/A0?ofkP0303eI
Z`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP0303eI
Z`3om^h0ooK^02l0ooK^0P0000180?ofkP40oooo001_0?ofkP030000003om^h0ooK^00P0ooK^00<0
e3dI0?ofkP3om^h02@3om^h30=@m6@<0ooK^00<0e3dI0?ofkP3om^h0103om^h20=@m6@040?ofkP3D
?AT0e3dI0=@m6@H0ooK^103D?AT80?ofkP030000003om^h0ooK^04L0ooK^0P0mFJ/01P3om^h0?EV[
0?ofkP0mFJ/0ooK^03eIZ`<0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP0;0?of
kP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h0403om^h00`0mFJ/0ooK^0?ofkP020?of
kP80?EV[3P3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?of
kP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP0`0?ofkP<00000A@3om^h10?ooo`00KP3om^h00`000000
ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00d0ooK^0P3D?AT00`3om^h0e3dI0?ofkP070?ofkP<0
e3dI00<0ooK^0=@m6@3D?AT01@3om^h00`3D?AT0ooK^0=@m6@030=@m6@D0ooK^00<000000?ofkP3o
m^h0A`3om^h00`0mFJ/0ooK^0?ofkP0203eIZ`030?ofkP0mFJ/0ooK^0080ooK^00<0?EV[0?ofkP3o
m^h00`3om^h203eIZ``0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP03
03eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP80
?EV[0`3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0?EV[03@0ooK^0P0000130?ofkP40
oooo001]0?ofkP030000003om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h0403om^h30=@m6@H0ooK^
00@0e3dI0?ofkP3om^h0ooK^1P3D?AT30?ofkP030=@m6@3om^h0ooK^00@0e3dI0`3om^h00`000000
ooK^0?ofkP160?ofkP0503eIZ`3om^h0ooK^03eIZ`3om^h00P0mFJ/30?ofkP0303eIZ`3om^h0ooK^
0080ooK^200mFJ/70?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h04@3om^h00`0m
FJ/0ooK^0?ofkP060?ofkP80?EV[2@3om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP0303eIZ`3om^h0?EV[
01D0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0e0?ofkP800000@@3om^h10?ooo`00K@3om^h00`00
0000ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^0180ooK^0`3D?AT20?ofkP80e3dI1`3om^h20=@m
6@030?ofkP3D?AT0e3dI0080e3dI1@3om^h40=@m6@030000003om^h0ooK^04D0ooK^0P0mFJ/0103o
m^h0?EV[0?ofkP3om^h203eIZ`<0ooK^1P0mFJ/20?ofkP0303eIZ`3om^h0ooK^0080ooK^2@0mFJ/=
0?ofkP0303eIZ`3om^h0ooK^0100ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP05
0?ofkP0303eIZ`3om^h0ooK^01@0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP03
0?ofkP0303eIZ`3om^h0ooK^03@0ooK^0P00000o0?ofkP40oooo001/0?ofkP030000003om^h0ooK^
00P0ooK^0P3D?ATD0?ofkP030=@m6@3om^h0ooK^00<0e3dI2P3om^h30=@m6@030?ofkP3D?AT0e3dI
00L0ooK^00@0e3dI0000003D?AT0e3dIA03om^h203eIZ`030?ofkP0mFJ/0ooK^0080ooK^00<0?EV[
0?ofkP0mFJ/00`0mFJ/30?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/02@3om^h0100mFJ/0ooK^0?of
kP3om^h403eIZ`P0ooK^00<0?EV[0?ofkP3om^h0403om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP80?EV[
103om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP0303eIZ`3om^h0?EV[01<0ooK^00<0?EV[0?ofkP3om^h0
103om^h00`0mFJ/0ooK^0?ofkP0f0?ofkP800000?@3om^h10?ooo`00K03om^h00`000000ooK^0?of
kP070?ofkP030=@m6@3om^h0ooK^00<0e3dI4@3om^h0103D?AT0ooK^0?ofkP3D?AT20?ofkP80e3dI
2`3om^h60=@m6@D0ooK^00<000000=@m6@3D?AT00P3D?AU10?ofkP80?EV[00<0ooK^03eIZ`3om^h0
0P3om^h303eIZ`030?ofkP0mFJ/0ooK^00@0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`080?ofkP03
03eIZ`3om^h0ooK^00H0ooK^100mFJ/30?ofkP0303eIZ`3om^h0ooK^0100ooK^00<0?EV[0?ofkP3o
m^h03P3om^h203eIZ`030?ofkP0mFJ/0ooK^01D0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0A0?of
kP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h0=`3om^h2000003/0ooK^0@3oool006/0
ooK^00<000000?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP030?ofkP<0e3dI3P3om^h30=@m6@D0
ooK^0`3D?AT:0?ofkP<0e3dI00@0ooK^0=@m6@3D?AT0e3dI0P3om^h010000000ooK^0?ofkP3om^h4
0=@m6Cd0ooK^0P0mFJ/20?ofkP0803eIZ`3om^h0?EV[03eIZ`3om^h0?EV[0?ofkP0mFJ/50?ofkP03
03eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP@0
?EV[4@3om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP0303eIZ`3om^h0ooK^01@0ooK^00<0?EV[0?ofkP3o
m^h00`3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3o
m^h0>03om^h3000003P0ooK^0@3oool006X0ooK^00<000000?ofkP3om^h0203om^h00`3D?AT0ooK^
0?ofkP070?ofkP80e3dI303om^h50=@m6@H0ooK^0`3D?AT80?ofkP040=@m6@3om^h0e3dI0=@m6@80
ooK^00<0e3dI0000003om^h00P3om^h20=@m6@80ooK^0`3D?ATk0?ofkP80?EV[00<0ooK^03eIZ`0m
FJ/00P0mFJ/0103om^h0?EV[0?ofkP0mFJ/50?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?of
kP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^0080?EV[3P3om^h00`0m
FJ/0ooK^0?ofkP0A0?ofkP0303eIZ`3om^h0?EV[01@0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0m
FJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h0>P3om^h20000
03H0ooK^0@3oool006X0ooK^00<000000?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP<0
e3dI2@3om^h20=@m6@<0ooK^0`3D?AT60?ofkP80e3dI1P3om^h0103D?AT0ooK^0?ofkP3om^h30=@m
6@040000003D?AT0e3dI0=@m6@H0ooK^103D?ATg0?ofkP80?EV[00<0ooK^03eIZ`0mFJ/00P3om^h0
1@0mFJ/0ooK^03eIZ`3om^h0?EV[00@0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?of
kP030?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h00`3om^h203eIZ`/0ooK^00<0
?EV[0?ofkP3om^h04@3om^h0100mFJ/0ooK^0?ofkP3om^h203eIZa40ooK^00<0?EV[0?ofkP3om^h0
1`3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h0
>`3om^h2000003@0ooK^0@3oool006T0ooK^00<000000?ofkP3om^h0203om^h00`3D?AT0ooK^0?of
kP0=0?ofkP<0e3dI1P3om^h00`3D?AT0ooK^0?ofkP050?ofkP<0e3dI1@3om^h30=@m6@<0ooK^00<0
e3dI0?ofkP3om^h0103om^h010000000e3dI0=@m6@3om^h20=@m6@D0ooK^00<0e3dI0?ofkP3D?AT0
0P3D?ATd0?ofkP@0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP0203eIZ`@0ooK^00<0?EV[0?ofkP3om^h0
1P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h0
1@3om^h303eIZ`P0ooK^00<0?EV[0?ofkP3om^h0403om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eI
Z`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h02@3om^h203eIZ`T0ooK^00<0?EV[0?ofkP3om^h0
3@3om^h00`0mFJ/0ooK^0?ofkP0l0?ofkP800000<P3om^h10?ooo`00J@3om^h00`000000ooK^0?of
kP070?ofkP030=@m6@3om^h0ooK^0140ooK^0`3D?AT20?ofkP80e3dI2P3om^h20=@m6@H0ooK^103D
?AT50?ofkP040=@m6@000000ooK^0?ofkP80e3dI00@0ooK^0=@m6@3D?AT0e3dI0`3om^h00`3D?AT0
ooK^0?ofkP040=@m6C00ooK^100mFJ/30?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/01@3om^h00`0m
FJ/0ooK^0?ofkP050?ofkP80?EV[0`3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^
00T0ooK^0P0mFJ/50?ofkP0303eIZ`3om^h0ooK^0140ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0m
FJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0m
FJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^03h0ooK^0P00000`0?ofkP40oooo001X0?ofkP03
0000003om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h05@3om^h40=@m6@`0ooK^0`3D?AT60?ofkP80
e3dI0P3om^h20=@m6@030?ofkP000000ooK^00<0ooK^0`3D?AT01@3om^h0e3dI0=@m6@3om^h0e3dI
00@0ooK^103D?AT]0?ofkP80?EV[00<0ooK^03eIZ`0mFJ/00P3om^h0100mFJ/0ooK^0?ofkP3om^h2
03eIZ`@0ooK^00<0?EV[0?ofkP3om^h01@3om^h01P0mFJ/0ooK^0?ofkP0mFJ/0ooK^03eIZ`l0ooK^
00<0?EV[0?ofkP3om^h0303om^h203eIZ`80ooK^00<0?EV[0?ofkP3om^h04@3om^h00`0mFJ/0ooK^
0?ofkP070?ofkP80?EV[2P3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00<0ooK^
00<0?EV[0?ofkP3om^h0403om^h00`0mFJ/0ooK^0?ofkP0o0?ofkP<00000;@3om^h10?ooo`00I`3o
m^h00`000000ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^01D0ooK^00<0e3dI0?ofkP3om^h00P3D
?AT>0?ofkP<0e3dI103om^h40=@m6@80ooK^00<000000?ofkP3om^h01@3om^h60=@m6@H0ooK^103D
?ATY0?ofkP80?EV[00<0ooK^03eIZ`0mFJ/00P3om^h01`0mFJ/0ooK^0?ofkP3om^h0?EV[0?ofkP0m
FJ/00`3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0403eIZ`3om^h0ooK^0?ofkP80?EV[3`3om^h00`0m
FJ/0ooK^0?ofkP0?0?ofkP80?EV[4`3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^
00H0ooK^00<0?EV[0?ofkP3om^h0403om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[01@0ooK^00<0?EV[
0?ofkP3om^h0@@3om^h2000002/0ooK^0@3oool006L0ooK^00<000000?ofkP3om^h01`3om^h20=@m
6AL0ooK^00D0e3dI0?ofkP3om^h0e3dI0?ofkP030=@m6@h0ooK^0`3D?AT00`3om^h0e3dI0=@m6@02
0?ofkP80e3dI00<000000?ofkP3om^h0203om^h50=@m6@H0ooK^103D?ATV0?ofkP<0?EV[00<0ooK^
03eIZ`3om^h00P3om^h01`0mFJ/0ooK^0?ofkP3om^h0?EV[0?ofkP0mFJ/00P3om^h00`0mFJ/0ooK^
0?ofkP060?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/03`3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP04
03eIZ`3om^h0?EV[03eIZa00ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP040?of
kP0303eIZ`3om^h0ooK^0180ooK^00<0?EV[0?ofkP0mFJ/05P3om^h00`0mFJ/0ooK^0?ofkP120?of
kP800000:@3om^h10?ooo`00IP3om^h00`000000ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^0080
e3dI503om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00@0ooK^0P3D?AT?0?ofkP<0e3dI103om^h00`00
0000e3dI0?ofkP0:0?ofkPH0e3dI1@3om^h50=@m6B<0ooK^0P0mFJ/00`3om^h0?EV[03eIZ`020?of
kP0503eIZ`3om^h0ooK^0?ofkP0mFJ/00`3om^h00`0mFJ/0ooK^03eIZ`070?ofkP0303eIZ`3om^h0
ooK^0080ooK^0P0mFJ/>0?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h00P3om^h2
03eIZ`d0ooK^00<0?EV[0?ofkP3om^h03P3om^h203eIZ`<0ooK^00<0?EV[0?ofkP3om^h0503om^h0
0`0mFJ/0ooK^0?ofkP0D0?ofkP0303eIZ`3om^h0?EV[04D0ooK^0P00000W0?ofkP40oooo001V0?of
kP030000003om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h00P3om^h30=@m6A40ooK^00D0e3dI0?of
kP3om^h0ooK^0=@m6@060?ofkP<0e3dI303om^h20=@m6@030?ofkP3D?AT0e3dI0080ooK^00<00000
0?ofkP3D?AT00P3D?AT90?ofkP050=@m6@3om^h0e3dI0=@m6@3om^h00P3D?AT30?ofkP80e3dI00<0
ooK^0=@m6@3D?AT00P3D?ATP0?ofkP80?EV[00H0ooK^03eIZ`3om^h0?EV[0?ofkP0mFJ/30?ofkP03
03eIZ`3om^h0ooK^0080ooK^0P0mFJ/70?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP0m
FJ/03@3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3o
m^h02@3om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP0303eIZ`3om^h0?EV[01H0ooK^00<0?EV[0?ofkP0m
FJ/0503om^h0100mFJ/0ooK^0?ofkP0mFJ]70?ofkP8000009@3om^h10?ooo`00I@3om^h00`000000
ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00H0ooK^0P3D?AT>0?ofkP030=@m6@3om^h0ooK^0080
ooK^00<0e3dI0?ofkP3om^h01`3om^h20=@m6@T0ooK^00<0e3dI0?ofkP3D?AT00`3om^h20=@m6@03
0000003om^h0ooK^0080ooK^0P3D?AT70?ofkP040=@m6@3om^h0ooK^0?ofkPH0e3dI1@3om^h50=@m
6A`0ooK^0P0mFJ/20?ofkP80?EV[00<0ooK^03eIZ`3om^h00P3om^h00`0mFJ/0ooK^0?ofkP020?of
kPL0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0403eIZ`3om^h0ooK^03eIZ``0ooK^00<0?EV[
0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP070?ofkP80?EV[203om^h00`0mFJ/0ooK^0?ofkP0C
0?ofkP0303eIZ`3om^h0ooK^01@0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0B0?ofkP0303eIZ`3o
m^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h0AP3om^h2000002<0ooK^0@3oool006@0ooK^00<00000
0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP080?ofkP<0e3dI2P3om^h00`3D?AT0ooK^0?ofkP03
0?ofkP030=@m6@3om^h0ooK^00T0ooK^0`3D?AT50?ofkP040=@m6@3om^h0ooK^0=@m6@D0ooK^00<0
00000=@m6@3D?AT0103om^h30=@m6@D0ooK^00<0e3dI0?ofkP3om^h00P3om^h70=@m6@@0ooK^1@3D
?ATI0?ofkP80?EV[0P3om^h01@0mFJ/0ooK^03eIZ`3om^h0?EV[0080ooK^00<0?EV[0?ofkP0mFJ/0
1@0mFJ/50?ofkPT0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00l0ooK^
00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^0180ooK^
00<0?EV[0?ofkP0mFJ/0503om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00l0ooK^
00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP180?ofkP8000008@3om^h10?ooo`00I03o
m^h00`000000ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00`0ooK^0P3D?AT80?ofkP030=@m6@3o
m^h0ooK^00<0ooK^0P3D?AT=0?ofkP80e3dI0P3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00D0ooK^
00<000000?ofkP3om^h00P3D?AT50?ofkP80e3dI0`3om^h00`3D?AT0ooK^0?ofkP020=@m6@@0ooK^
0P3D?AT00`3om^h0e3dI0=@m6@040?ofkPH0e3dI5@3om^h303eIZ`040?ofkP0mFJ/0ooK^0?ofkP80
?EV[00<0ooK^03eIZ`0mFJ/00P0mFJ/30?ofkP0303eIZ`3om^h0?EV[00D0ooK^00<0?EV[0?ofkP3o
m^h00P3om^h0100mFJ/0ooK^0?ofkP3om^h403eIZ`T0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0m
FJ/0ooK^0?ofkP0<0?ofkP80?EV[103om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP0503eIZ`3om^h0ooK^
0?ofkP0mFJ/04P3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[
0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP170?ofkP8000008@3om^h10?ooo`00H`3om^h00`00
0000ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00l0ooK^0`3D?AT40?ofkP030=@m6@3om^h0ooK^
00@0ooK^00<0e3dI0?ofkP3D?AT00P3D?AT<0?ofkP<0e3dI0`3om^h00`3D?AT0ooK^0?ofkP020?of
kP030000003om^h0ooK^00<0ooK^0`3D?AT40?ofkP80e3dI00@0ooK^0=@m6@3D?AT0e3dI203om^h6
0=@m6@040?ofkP3D?AT0ooK^0?ofkPD0e3dI4P3om^h303eIZ`030?ofkP0mFJ/0ooK^0080ooK^0`0m
FJ/00`3om^h0?EV[0?ofkP030?ofkP0403eIZ`3om^h0ooK^03eIZ`@0ooK^00<0?EV[0?ofkP3om^h0
0P3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0?EV[00@0?EV[0`3om^h00`0mFJ/0ooK^
0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00h0ooK^0P0mFJ/00`3om^h0?EV[0?ofkP0C0?ofkP0303eI
Z`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eI
Z`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP160?ofkP030000
003om^h000000240ooK^0@3oool006<0ooK^00<000000?ofkP3om^h01`3om^h00`3D?AT0ooK^0?of
kP0B0?ofkP80e3dI0P3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^0080ooK^0P3D
?AT:0?ofkP030=@m6@3om^h0ooK^00<0e3dI1@3om^h00`000000ooK^0?ofkP060?ofkP80e3dI103o
m^h30=@m6@`0ooK^1P3D?AT40?ofkPD0e3dI3`3om^h203eIZ`040?ofkP0mFJ/0ooK^0?ofkP<0?EV[
0P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0403eIZ`3om^h0ooK^03eIZ`<0ooK^00<0?EV[0?ofkP3o
m^h00P3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00<0ooK^100mFJ/@0?ofkP03
03eIZ`3om^h0ooK^0140ooK^00<0?EV[0?ofkP3om^h04P3om^h00`0mFJ/0ooK^0?ofkP050?ofkP03
03eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP090?ofkP03
03eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h0A03om^h01@000000ooK^0?ofkP3om^h00000
0200ooK^0@3oool00680ooK^00<000000?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP0E0?ofkP<0
e3dI1@3om^h00`3D?AT0ooK^0?ofkP050?ofkP<0e3dI1`3om^h00`3D?AT0ooK^0?ofkP020?ofkP<0
e3dI0`3om^h00`000000ooK^0?ofkP080?ofkP<0e3dI00<0ooK^0=@m6@3om^h0103D?AT<0?ofkPD0
e3dI103om^h50=@m6@`0ooK^0P0mFJ/20?ofkP@0?EV[00@0ooK^03eIZ`3om^h0?EV[1@3om^h00`0m
FJ/0ooK^0?ofkP020?ofkP0403eIZ`3om^h0ooK^03eIZ`@0ooK^00<0?EV[0?ofkP3om^h01P3om^h0
0`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^0080?EV[3@3om^h00`0mFJ/0ooK^0?ofkP0A
0?ofkP0303eIZ`3om^h0?EV[0180ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP0:
0?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP0:
0?ofkP0303eIZ`3om^h0ooK^0440ooK^0P0000040?ofkP030000003om^h0ooK^01h0ooK^0@3oool0
0640ooK^00<000000?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP0E0?ofkP030=@m6@3om^h0ooK^
0080e3dI0`3om^h00`3D?AT0ooK^0?ofkP080?ofkP<0e3dI0`3om^h00`3D?AT0ooK^0?ofkP030?of
kP030=@m6@3om^h0ooK^0080e3dI00<0ooK^0000003om^h0303om^h20=@m6@030?ofkP3D?AT0ooK^
0080ooK^0`3D?AT;0?ofkPH0e3dI103om^h50=@m6@P0ooK^00@0?EV[0?ofkP0mFJ/0ooK^0P0mFJ/0
1P3om^h0?EV[0?ofkP0mFJ/0ooK^03eIZ`D0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^
03eIZ`040?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^
0?ofkP030?ofkP<0?EV[2@3om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP0503eIZ`3om^h0ooK^0?ofkP0m
FJ/0403om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3o
m^h02`3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3o
m^h0@03om^h00`000000ooK^0?ofkP040?ofkP030000003om^h0ooK^01h0ooK^0@3oool00640ooK^
00<000000?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP0F0?ofkP030=@m6@3om^h0ooK^0080ooK^
103D?AT=0?ofkP@0e3dI1@3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@000000e3dI00/0ooK^
00<0e3dI0?ofkP3om^h00`3D?AT50?ofkP80e3dI2P3om^h01@3D?AT0ooK^0=@m6@3D?AT0ooK^00D0
e3dI00<0ooK^0=@m6@3D?AT00`3D?AT50?ofkP0303eIZ`3om^h0?EV[0080?EV[0`3om^h01@0mFJ/0
ooK^03eIZ`3om^h0?EV[00@0ooK^00<0?EV[0?ofkP3om^h0103om^h203eIZ`@0ooK^00<0?EV[0?of
kP3om^h02@3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00T0ooK^0`0mFJ/50?ofkP0303eIZ`3om^h0
ooK^0140ooK^00<0?EV[0?ofkP3om^h00`3om^h203eIZ`d0ooK^00<0?EV[0?ofkP3om^h02P3om^h0
0`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h0103om^h0
0`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^03h0ooK^00<000000?ofkP3om^h01@3om^h0
0`000000ooK^0?ofkP0N0?ofkP40oooo001P0?ofkP030000003om^h0ooK^00P0ooK^00<0e3dI0?of
kP3om^h05@3om^h00`3D?AT0ooK^0?ofkP060?ofkP80e3dI3P3om^h30=@m6@@0ooK^00<0e3dI0?of
kP3om^h00`3om^h010000000ooK^0=@m6@3D?AT90?ofkP060=@m6@3om^h0ooK^0?ofkP3D?AT0ooK^
0P3D?AT50?ofkP<0e3dI1`3om^h0103D?AT0ooK^0?ofkP3om^h30=@m6@030?ofkP3D?AT0e3dI00@0
ooK^1@3D?AT00`3om^h0?EV[0?ofkP0303eIZ`<0ooK^00<0?EV[0?ofkP3om^h00P0mFJ/40?ofkP03
03eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP04
03eIZ`3om^h0ooK^03eIZ`d0ooK^0P0mFJ/20?ofkP0303eIZ`3om^h0ooK^0140ooK^00<0?EV[0?of
kP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?of
kP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?of
kP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0m0?ofkP030000003om^h0ooK^00L0ooK^00<000000?of
kP3om^h07@3om^h10?ooo`00H03om^h00`000000ooK^0?ofkP070?ofkP80e3dI5`3om^h00`3D?AT0
ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00<0e3dI2P3om^h0103D?AT0ooK^0?ofkP3om^h30=@m
6@030?ofkP3D?AT0ooK^00@0ooK^0P0000020?ofkP<0e3dI1@3om^h00`3D?AT0ooK^0?ofkP020?of
kP040=@m6@3om^h0ooK^0?ofkP<0e3dI1@3om^h30=@m6@D0ooK^00<0e3dI0?ofkP3D?AT00`3om^h6
0=@m6@<0ooK^0`3D?AT00`0mFJ/0000003eIZ`0203eIZ`<0ooK^00D0?EV[0?ofkP3om^h0ooK^03eI
Z`040?ofkP0303eIZ`3om^h0ooK^00D0ooK^0P0mFJ/30?ofkP0303eIZ`3om^h0ooK^00X0ooK^00@0
?EV[0?ofkP0mFJ/0?EV[403om^h203eIZa<0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^
0?ofkP080?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^
0?ofkP0@0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/04P3om^h00`0mFJ/0ooK^0?ofkP0k0?ofkP03
0000003om^h0ooK^00P0ooK^00<000000?ofkP3om^h07@3om^h10?ooo`00G`3om^h00`000000ooK^
0?ofkP080?ofkP040=@m6@3om^h0e3dI0=@m6A@0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0
ooK^0?ofkP030?ofkP80e3dI203om^h00`3D?AT0ooK^0?ofkP040?ofkP<0e3dI0`3om^h00`000000
ooK^0?ofkP02000000<0ooK^0P3D?AT20?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3o
m^h0103om^h30=@m6@D0ooK^0`3D?AT20?ofkP80e3dI1`3om^h20=@m6@030?ofkP3D?AT0e3dI00<0
ooK^00@0e3dI03eIZ`0mFJ/0H1D80P0mFJ/20000000403eIZ`3om^h0ooK^0?ofkP80?EV[103om^h0
0`0mFJ/0ooK^0?ofkP040?ofkP0603eIZ`3om^h0ooK^03eIZ`3om^h0?EV[303om^h0100mFJ/0ooK^
0?ofkP0mFJ/A0?ofkP0403eIZ`3om^h0?EV[03eIZa00ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0m
FJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00l0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0D
0?ofkP0303eIZ`3om^h0?EV[01<0ooK^00<0?EV[0?ofkP3om^h0>P3om^h00`000000ooK^0?ofkP09
0?ofkP030000003om^h0ooK^01d0ooK^0@3oool005h0ooK^00<000000?ofkP3om^h0203om^h00`3D
?AT0ooK^0?ofkP020?ofkP<0e3dI403om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^
00D0ooK^0`3D?AT40?ofkP030=@m6@3om^h0ooK^00H0ooK^00H0e3dI0?ofkP3D?AT0e3dI0?ofkP00
00040?ofkP<000000P3om^h30=@m6@D0ooK^00<0e3dI0?ofkP3om^h01`3om^h20=@m6@H0ooK^0`3D
?AT:0?ofkPD0e3dI00@0000003eIZ`0mFJ/0H1D80P0mFJ/02@1P5@P00000000000000000@@l60000
000mFJ/0ooK^03eIZ`030?ofkP0303eIZ`3om^h0ooK^00@0ooK^00L0?EV[0?ofkP3om^h0ooK^03eI
Z`3om^h0?EV[00`0ooK^00<0?EV[0?ofkP3om^h00P0mFJ/?0?ofkP0303eIZ`3om^h0ooK^0080ooK^
0P0mFJ/>0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^
0?ofkP0A0?ofkP0303eIZ`3om^h0?EV[01H0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^
0?ofkP0h0?ofkP030000003om^h0ooK^00X0ooK^00<000000?ofkP3om^h07@3om^h10?ooo`00GP3o
m^h00`000000ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00D0ooK^0P3D?AT>0?ofkP030=@m6@3o
m^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h0203om^h20=@m6@80ooK^00<0e3dI0?ofkP3om^h01P3o
m^h01@3D?AT0ooK^0?ofkP3om^h000000080e3dI1P3om^h300000080ooK^0`3D?AT20?ofkP030=@m
6@3om^h0ooK^00T0ooK^0`3D?AT30?ofkP030=@m6@3om^h0e3dI0080e3dI2`3om^h20=@m6@0503eI
Z`268@`000000000000mFJ/01P1P5@P010000000?EV[0000000mFJ/20?ofkP0303eIZ`3om^h0ooK^
00D0ooK^00@0?EV[0?ofkP3om^h0ooK^0P0mFJ/<0?ofkP0603eIZ`3om^h0ooK^03eIZ`3om^h0?EV[
3P3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h0
3@3om^h203eIZ`<0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP0303eI
Z`3om^h0?EV[01<0ooK^0P0mFJ/h0?ofkP8000003@3om^h00`000000ooK^0?ofkP0M0?ofkP40oooo
001M0?ofkP030000003om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h0203om^h30=@m6@X0ooK^00<0
e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP0:0?ofkP<0e3dI203om^h0103D?AT0ooK^0?of
kP0000030?ofkP80e3dI1@3om^h0103D?AT0ooK^0000000000030?ofkP<0e3dI3P3om^h30=@m6@<0
ooK^00@0e3dI0?ofkP3D?AT0e3dI2@3om^h2000000<0QR4<0P0mFJ/300000080H1D800H0000003eI
Z`1P5@P0000003eIZ`00000603eIZ`80ooK^00<0?EV[0?ofkP3om^h00P3om^h203eIZ`/0ooK^00@0
?EV[0?ofkP3om^h0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00H0ooK^
0P0mFJ/90?ofkP0303eIZ`3om^h0ooK^0100ooK^00<0?EV[0?ofkP0mFJ/05@3om^h00`0mFJ/0ooK^
03eIZ`0D0?ofkP0403eIZ`3om^h0ooK^03eIZa80ooK^00@0?EV[0?ofkP3om^h0?EV[=P3om^h00`00
0000ooK^0?ofkP0>0?ofkP030000003om^h0ooK^01`0ooK^0@3oool005`0ooK^00<000000?ofkP3o
m^h02@3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP80e3dI203om^h00`3D?AT0ooK^0?ofkP070?ofkP03
0=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h00`3D?AT40?ofkP040=@m6@3om^h0ooK^0000
00H0ooK^0`3D?AT20?ofkP040=@m6@3om^h0ooK^0?ofkP<000000P3om^h30=@m6@d0ooK^00H0e3dI
0?ofkP3D?AT0e3dI0?ofkP3D?AT30?ofkP<0e3dI1@3om^h2000000<0QR4<00<0?EV[08HQ300mFJ/0
0`268@`20000000503eIZ`1P5@P0H1D8060E200mFJ/0100000030?ofkPX0?EV[2@3om^h0100mFJ/0
ooK^0?ofkP0mFJ/40?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0m
FJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^0180ooK^00<0?EV[0?ofkP3om^h04`3om^h01@0m
FJ/0ooK^0?ofkP3om^h0?EV[0180ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP0>
0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/0=@3om^h00`000000ooK^0?ofkP0?0?ofkP030000003o
m^h0ooK^01`0ooK^0@3oool005`0ooK^00<000000?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP0>
0?ofkP<0e3dI103om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI
0?ofkP3om^h00`3om^h20=@m6@80ooK^00@0e3dI0?ofkP3om^h000002@3om^h30=@m6@H0ooK^0`00
00020?ofkP<0e3dI2@3om^h00`3D?AT0ooK^0?ofkP020?ofkP<0e3dI1@3om^h20=@m6@<0ooK^0`00
000010268@`0?EV[08HQ300mFJ/508HQ300603eIZ`268@`000000000001P5@P0?EV[101P5@P30000
000303eIZ`3om^h0ooK^0080ooK^00D0?EV[0?ofkP3om^h0?EV[0?ofkP0703eIZ`050?ofkP0mFJ/0
ooK^0?ofkP0mFJ/01P3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00/0ooK^0P0m
FJ/40?ofkP0303eIZ`3om^h0ooK^0180ooK^00<0?EV[0?ofkP0mFJ/04`3om^h00`0mFJ/0ooK^0?of
kP020?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?of
kP0=0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h0<@3om^h00`000000ooK^0?of
kP0@0?ofkP030000003om^h0ooK^01`0ooK^0@3oool005/0ooK^00<000000?ofkP3om^h02@3om^h0
0`3D?AT0ooK^0?ofkP0A0?ofkP80e3dI0P3om^h00`3D?AT0ooK^0?ofkP080?ofkP80e3dI2`3om^h0
0`3D?AT0ooK^0?ofkP060?ofkP<0e3dI00<0ooK^0000003om^h02@3om^h00`3D?AT0ooK^0?ofkP02
0=@m6@H0ooK^00<0e3dI0000000000000`3om^h20=@m6@H0ooK^00<0e3dI0?ofkP3om^h0103om^h0
103D?AT0ooK^0=@m6@3D?AT50?ofkP80e3dI0`0000001@2_;Q80?EV[000000268@`0?EV[00@0QR4<
00<0?EV[000000268@`00P268@`00`000000?EV[060E2003060E20030000001P5@P0?EV[00800000
0P3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00P0ooK^1@0mFJ/60?ofkP0303eIZ`3om^h0ooK^00L0
ooK^00<0?EV[0?ofkP3om^h03P3om^h203eIZ`030?ofkP0mFJ/0ooK^01<0ooK^00D0?EV[0?ofkP3o
m^h0ooK^03eIZ`0A0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0m
FJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0m
FJ/0ooK^0?ofkP0`0?ofkP030000003om^h0ooK^0140ooK^00<000000?ofkP3om^h0703om^h10?oo
o`00F`3om^h00`000000ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^01<0ooK^0`3D?AT:0?ofkP04
0=@m6@3om^h0e3dI0=@m6@P0ooK^00<0e3dI0?ofkP3om^h02@3om^h0103D?AT000000=@m6@3D?AT8
0?ofkP030=@m6@3om^h0ooK^00<0ooK^0`3D?AT30?ofkP030=@m6@3om^h0ooK^00<000000P3om^h3
0=@m6@80ooK^00<0e3dI0?ofkP3om^h01@3om^h0103D?AT0ooK^0?ofkP3om^h20=@m6@@0ooK^0P00
00000`062140000003eIZ`020:l^4P030000000mFJ/0000000<0QR4<00<0?EV[08HQ30268@`01026
8@`01P0mFJ/00000060E20000000H1D803eIZ`80H1D80`0000050?ofkP0303eIZ`3om^h0ooK^00D0
ooK^00<0?EV[0?ofkP0mFJ/00P3om^h203eIZ`D0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0
ooK^0?ofkP0A0?ofkP0303eIZ`3om^h0ooK^0180ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0
ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0
ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0
ooK^0?ofkP0^0?ofkP030000003om^h0ooK^01<0ooK^00<000000?ofkP3om^h06`3om^h10?ooo`00
FP3om^h00`000000ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^01D0ooK^00<0e3dI0?ofkP3D?AT0
0P3D?AT70?ofkP040=@m6@3om^h0ooK^0?ofkP<0e3dI1@3om^h00`3D?AT0ooK^0?ofkP090?ofkP04
0=@m6@000000ooK^0?ofkP80e3dI1P3om^h00`3D?AT0ooK^0?ofkP060?ofkP80e3dI00<0ooK^0=@m
6@3om^h0103om^h2000000<0ooK^0`3D?AT70?ofkP030=@m6@3om^h0ooK^00<0ooK^0`3D?AT20000
000300H84@000000?EV[00@0[bhB00H0?EV[0:l^4P000000000003eIZ`00000608HQ300503eIZ`26
8@`000000000000mFJ/01P1P5@P300000080ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^
03eIZ`050?ofkP80?EV[103om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^0140ooK^
00<0?EV[0?ofkP0mFJ/04P3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00/0ooK^
00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^00P0ooK^
00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^02d0ooK^
00<000000?ofkP3om^h0503om^h00`000000ooK^0?ofkP0K0?ofkP40oooo001I0?ofkP030000003o
m^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h0503om^h00`3D?AT0ooK^0?ofkP030?ofkP<0e3dI0`3o
m^h00`3D?AT0ooK^0?ofkP050?ofkP80e3dI0P3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030000003o
m^h0ooK^00<0ooK^0`3D?AT20?ofkP030=@m6@3om^h0ooK^00T0ooK^0`3D?AT60?ofkP<0000000<0
e3dI0?ofkP3om^h00`3D?AT40?ofkP030=@m6@3om^h0ooK^00H0ooK^0P3D?AT00`062140000003eI
Z`040:l^4P0403eIZ`2_;Q80[bhB03eIZ`<000001@268@`01@0mFJ/0QR4<08HQ300mFJ/0QR4<00<0
0000101P5@P40000000303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP0mFJ/0203om^h203eIZ`80
ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0403eIZ`3om^h0ooK^0?of
kP80?EV[3`3om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?of
kP3om^h0203om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?of
kP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^02/0ooK^0P00000G0?of
kP030000003om^h0ooK^01/0ooK^0@3oool005T0ooK^00<000000?ofkP3om^h02@3om^h00`3D?AT0
ooK^0?ofkP0E0?ofkP030=@m6@3om^h0ooK^00H0ooK^0P3D?AT00`3om^h0e3dI0?ofkP080?ofkP<0
e3dI2`3om^h00`000000e3dI0?ofkP070?ofkP<0e3dI303om^h00`3D?AT0ooK^0=@m6@020=@m6@D0
ooK^00@0e3dI00000000000000000`3om^h20=@m6@80ooK^00<0e3dI0?ofkP3om^h01@3om^h20000
000300H84@3D?AT0e3dI00D0[bhB00<0?EV[0:l^4P0mFJ/00P2_;Q800`000000[bhB000000020000
0080QR4<00@0?EV[08HQ30268@`0?EV[10268@`300000004060E20000000H1D8060E2080000000D0
?EV[0?ofkP3om^h0ooK^03eIZ`020?ofkP0303eIZ`3om^h0ooK^00P0ooK^0P0mFJ/00`3om^h0?EV[
0?ofkP020?ofkP0303eIZ`3om^h0ooK^0100ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^
0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00T0ooK^0P0mFJ/90?ofkP0303eIZ`3om^h0ooK^00X0ooK^
00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00D0ooK^
00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP0Y0?ofkP030000003om^h0ooK^01L0ooK^
00<000000?ofkP3om^h06`3om^h10?ooo`00F03om^h00`000000ooK^0?ofkP0:0?ofkP030=@m6@3o
m^h0ooK^01@0ooK^00<0e3dI0?ofkP3om^h02@3om^h30=@m6@T0ooK^00<0e3dI0?ofkP3D?AT00P3D
?AT70?ofkP030000003om^h0e3dI00P0ooK^00<0e3dI0?ofkP3om^h00`3D?AT90?ofkP030=@m6@3o
m^h0ooK^0080ooK^0P3D?AT30?ofkP040=@m6@3om^h0ooK^0?ofkP8000000`3om^h30=@m6@H0ooK^
0P00000300H84@8000000`2_;Q800`0mFJ/0[bhB03eIZ`030:l^4P030000002_;Q80[bhB0080[bhB
0P000000100mFJ/0000003eIZ`00000708HQ30<000000`1P5@P0100mFJ/000000=@m6@0mFJ/20?of
kP0303eIZ`3om^h0ooK^00/0ooK^0P0mFJ/20?ofkP0303eIZ`3om^h0ooK^0100ooK^00<0?EV[0?of
kP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?of
kP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?of
kP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?of
kP3om^h0:03om^h00`000000ooK^0?ofkP0I0?ofkP030000003om^h0ooK^01X0ooK^0@3oool005P0
ooK^00<000000?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP0E0?ofkP030=@m6@3om^h0ooK^00X0
ooK^00<0e3dI0?ofkP3D?AT00P3D?AT50?ofkP030=@m6@3om^h0ooK^00<0ooK^0P3D?AT50?ofkP03
0000003D?AT0ooK^00P0ooK^00<0e3dI0?ofkP3om^h00`3om^h20=@m6@L0ooK^00<0e3dI0?ofkP3o
m^h0103om^h30=@m6@H0ooK^0`0000030?ofkP<0e3dI0`3om^h2000000801PPA0P0000001`3:=QH0
00000000002_;Q80?EV[0:l^4P0mFJ/00P2_;Q800`000000[bhB0:l^4P050:l^4P80?EV[0`000007
08HQ3006000000268@`000000000001P5@P0?EV[0P1P5@P00`0mFJ/0000000000002000000h0ooK^
0P0mFJ/B0?ofkP0303eIZ`3om^h0ooK^00P0ooK^0P0mFJ/80?ofkP0303eIZ`3om^h0ooK^00h0ooK^
00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^0080ooK^
00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00d0ooK^
00<0?EV[0?ofkP3om^h09P3om^h00`000000ooK^0?ofkP0J0?ofkP030000003om^h0ooK^01X0ooK^
0@3oool005L0ooK^00<000000?ofkP3om^h02P3om^h20=@m6AD0ooK^00<0e3dI0?ofkP3om^h02P3o
m^h00`3D?AT0ooK^0?ofkP030?ofkP<0e3dI0P3om^h00`3D?AT0ooK^0?ofkP050?ofkP<0e3dI00@0
ooK^0000003om^h0e3dI203om^h00`3D?AT0ooK^0?ofkP060?ofkP<0e3dI0`3om^h00`3D?AT0ooK^
0?ofkP060?ofkP030=@m6@3om^h0e3dI0080e3dI1P3om^h3000000030=@m6@3om^h0ooK^0080e3dI
0P00000200H84@030000000:3b<0000000<0bSHF00<0000003eIZ`0mFJ/00`2_;Q800`000000[bhB
0:l^4P050:l^4P0503eIZ`2_;Q80[bhB0000002_;Q800P00000508HQ3004000000268@`0QR4<08HQ
308000000P0mFJ/010000000H1D8000000000002044?1P030000003om^h0ooK^00X0ooK^00@0?EV[
0?ofkP0mFJ/0?EV[3`3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0
?EV[0?ofkP3om^h0403om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[0140ooK^00D0?EV[0?ofkP3om^h0
ooK^03eIZ`0B0?ofkP0403eIZ`3om^h0ooK^03eIZa00ooK^00<0?EV[0?ofkP3om^h09@3om^h00`00
0000ooK^0?ofkP0K0?ofkP030000003om^h0ooK^01X0ooK^0@3oool005H0ooK^00<000000?ofkP3o
m^h02`3om^h00`3D?AT0ooK^0=@m6@020=@m6A80ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0
ooK^0?ofkP060?ofkP<0e3dI2P3om^h010000000e3dI0?ofkP3D?AT70?ofkP030=@m6@3om^h0ooK^
00X0ooK^103D?AT70?ofkP030=@m6@3om^h0ooK^00<0ooK^0`3D?AT60?ofkP8000000P3om^h30000
000500H84@0000002PlS00X?8`000000103:=QH01P0mFJ/0bSHF000000000000[bhB000000H0[bhB
0P0mFJ/20:l^4P040000002_;Q80[bhB0:l^4P8000000`268@`00`000000QR4<08HQ300308HQ3004
03eIZ`000000H1D800000080H1D81@0000090?ofkP0303eIZ`3om^h0?EV[0080ooK^0P0mFJ/=0?of
kP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP0B0?of
kP0303eIZ`3om^h0?EV[01<0ooK^00<0?EV[0?ofkP0mFJ/04`3om^h00`0mFJ/0ooK^03eIZ`0B0?of
kP0303eIZ`3om^h0ooK^02<0ooK^00<000000?ofkP3om^h0703om^h00`000000ooK^0?ofkP0J0?of
kP40oooo001F0?ofkP030000003om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h00`3om^h30=@m6@h0
ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0e3dI0080
e3dI1P3om^h00`000000ooK^0?ofkP030=@m6@H0ooK^00<0e3dI0?ofkP3om^h03@3om^h20=@m6@H0
ooK^00<0e3dI0?ofkP3om^h01P3om^h20=@m6@@0ooK^00<0e3dI0?ofkP0000000P00000010062140
000000H84@00000200X?8`040000003:=QH0bSHF0<Xf5P80?EV[0`3:=QH3000000@0[bhB00H0?EV[
0:l^4P2_;Q80?EV[0:l^4P0000050:l^4P80000000<0QR4<000000268@`00`268@`00`0mFJ/0QR4<
03eIZ`03000000@0H1D8100000060?ofkP0503eIZ`3om^h0?EV[0?ofkP0mFJ/00`3om^h203eIZ`X0
ooK^00<0?EV[0?ofkP3om^h03P3om^h203eIZ`030?ofkP0mFJ/0ooK^01D0ooK^00<0?EV[0?ofkP3o
m^h04`3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^0140ooK^00<0?EV[0?ofkP3o
m^h08P3om^h00`000000ooK^0?ofkP0M0?ofkP030000003om^h0ooK^01X0ooK^0@3oool005D0ooK^
00<000000?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP060?ofkP80e3dI303om^h00`3D?AT0ooK^
0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h00`3om^h20=@m6@@0ooK^
00H000000?ofkP3om^h0ooK^0=@m6@3om^h30=@m6@80ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D
?AT0ooK^0=@m6@020=@m6@80ooK^00<0e3dI0?ofkP3om^h02@3om^h30=@m6@030?ofkP3D?AT0ooK^
0080000000@01PPA00000000000000000P0:3b<01`000000bSHF0<Xf5P3:=QH0?EV[0<Xf5P0mFJ/0
103:=QH010000000bSHF0000000000020:l^4P0503eIZ`2_;Q80[bhB03eIZ`000000202_;Q830000
0080QR4<00L0?EV[08HQ30268@`0?EV[08HQ30000000QR4<00<000000`1P5@P500000080ooK^00<0
?EV[0?ofkP0mFJ/00`3om^h00`0mFJ/0ooK^0?ofkP020?ofkP80?EV[1`3om^h00`0mFJ/0ooK^0?of
kP0A0?ofkP0303eIZ`3om^h0ooK^01@0ooK^00<0?EV[0?ofkP0mFJ/04`3om^h00`0mFJ/0ooK^03eI
Z`0C0?ofkP80?EV[4P3om^h203eIZb80ooK^0P00000Q0?ofkP030000003om^h0ooK^01T0ooK^0@3o
ool005D0ooK^00<000000?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP080?ofkP<0e3dI203om^h0
0`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h01@3om^h3
0=@m6@030000003om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h00P3om^h30=@m6A00ooK^00<0e3dI
0?ofkP3om^h00P3om^h30=@m6@h0ooK^0`3D?AT00`062140000000H84@020000000400X?8`000000
0000000000<0bSHF00<0?EV[0<Xf5P0mFJ/0103:=QH01`000000bSHF0<Xf5P3:=QH0000003eIZ`00
00000P2_;Q800`0mFJ/000000:l^4P080:l^4P040000002_;Q80000003eIZ`@0QR4<00<0?EV[0000
00268@`00`268@`400000080H1D81@0000000`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^
00@0ooK^0P0mFJ/40?ofkP0303eIZ`3om^h0ooK^0140ooK^00<0?EV[0?ofkP0mFJ/0503om^h0100m
FJ/0ooK^0?ofkP0mFJ/B0?ofkP0403eIZ`3om^h0ooK^03eIZa80ooK^00@0?EV[0?ofkP3om^h0?EV[
403om^h00`0mFJ/0ooK^03eIZ`0Q0?ofkP030000003om^h0ooK^0240ooK^00<000000?ofkP3om^h0
6@3om^h10?ooo`00E03om^h00`000000ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00`0ooK^0`3D
?AT50?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?of
kP080?ofkP060000003D?AT0e3dI0=@m6@3om^h0e3dI1P3om^h00`3D?AT0ooK^0=@m6@020=@m6@d0
ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP020=@m6@d0ooK^00H0e3dI00H84@3D
?AT0e3dI00H84@00000400X?8`<0000000@0?EV[0<Xf5P3:=QH0?EV[103:=QH01@000000bSHF0<Xf
5P3:=QH0?EV[0080bSHF0P0000000`2_;Q80?EV[0:l^4P080:l^4P040000002_;Q80?EV[0:l^4P<0
000000@0QR4<03eIZ`268@`000001P268@`3000000<0H1D800<0000003eIZ`0000000`0000020?of
kP0303eIZ`3om^h0ooK^00D0ooK^0P0mFJ/00`3om^h0?EV[0?ofkP0B0?ofkP0503eIZ`3om^h0ooK^
0?ofkP0mFJ/04P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[
0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/03P3o
m^h203eIZ`<0ooK^00<0?EV[0?ofkP3om^h07@3om^h00`000000ooK^0?ofkP0R0?ofkP030000003o
m^h0ooK^01T0ooK^0@3oool005<0ooK^00<000000?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP0?
0?ofkP<0e3dI00<0ooK^0=@m6@3om^h03@3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0
ooK^00P0ooK^00@000000?ofkP3om^h0ooK^0P3D?AT50?ofkP030=@m6@3om^h0ooK^00<0ooK^0P3D
?AT;0?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h00P3om^h30=@m6@X0ooK^00@0
e3dI0000000000001PPA0P3D?AT400X?8`030000003:=QH0?EV[0080000000<0bSHF03eIZ`3:=QH0
0`3:=QH010000000bSHF0<Xf5P0mFJ/50<Xf5P030000000mFJ/0000000P0[bhB00<0000003eIZ`2_
;Q80102_;Q820000000303eIZ`000000QR4<00H0QR4<00L0000008HQ300000000000060E200mFJ/0
H1D800H0000000<0ooK^03eIZ`3om^h01`3om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP0303eIZ`3om^h0
ooK^00<0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0
ooK^00`0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0
ooK^00<0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0
ooK^01`0ooK^00<000000?ofkP3om^h08`3om^h00`000000ooK^0?ofkP0I0?ofkP40oooo001C0?of
kP030000003om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h04`3om^h30=@m6@d0ooK^00<0e3dI0?of
kP3om^h01@3om^h00`3D?AT0ooK^0?ofkP080?ofkP030000003om^h0ooK^00<0ooK^103D?AT20?of
kP030=@m6@3om^h0ooK^00D0ooK^0`3D?AT70?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?of
kP3om^h01P3om^h20=@m6@L0ooK^00<000000=@m6@0000000P06214200000080e3dI0P0:3b<00`00
0000?EV[0<Xf5P020<Xf5P<000000P3:=QH010000000bSHF0<Xf5P0mFJ/70<Xf5P0403eIZ`3:=QH0
0000000000H0[bhB00<0?EV[0:l^4P2_;Q801P2_;Q800`0mFJ/000000000000608HQ300800000026
8@`0QR4<08HQ300mFJ/00000060E20000002060E20D0000000<0?EV[0?ofkP3om^h0103om^h00`0m
FJ/0ooK^03eIZ`0A0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0m
FJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0m
FJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0m
FJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^01/0ooK^00<000000?ofkP3om^h09@3om^h00`00
0000ooK^0?ofkP0H0?ofkP40oooo001B0?ofkP030000003om^h0ooK^00`0ooK^00<0e3dI0?ofkP3o
m^h0503om^h00`3D?AT0ooK^0=@m6@020=@m6@T0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0
ooK^0?ofkP070?ofkP030000003om^h0ooK^00@0ooK^00@0e3dI0?ofkP3om^h0ooK^0`3D?AT:0?of
kP<0e3dI103om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00/0ooK^0`3D?AT30?ofkP080000003D?AT0
1PPA000000062140000000X?8`00000200X?8`80e3dI00@000000=`l6000000000000P3:=QH00`0m
FJ/0bSHF0000000200000080bSHF00<0?EV[0<Xf5P3:=QH01@3:=QH010000000?EV[0<Xf5P3:=QH3
00000080[bhB00<0?EV[0000002_;Q80202_;Q80100mFJ/0[bhB00000000000408HQ300400000026
8@`0QR4<03eIZ`80QR4<0`000003060E20@0000000<0?EV[0?ofkP3om^h00P3om^h01@0mFJ/0ooK^
0?ofkP3om^h0?EV[00l0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP090?ofkP80
?EV[2@3om^h00`0mFJ/0ooK^0?ofkP080?ofkP80?EV[2@3om^h00`0mFJ/0ooK^0?ofkP090?ofkP03
03eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP050?ofkP03
03eIZ`3om^h0ooK^01X0ooK^00<000000?ofkP3om^h09P3om^h00`000000ooK^0?ofkP0H0?ofkP40
oooo001B0?ofkP030000003om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^
0?ofkP030?ofkP<0e3dI1P3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00L0ooK^
00<000000?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0e3dI0080e3dI
2P3om^h30=@m6@030?ofkP3D?AT0ooK^0080ooK^00<0e3dI0?ofkP3om^h0303om^h20=@m6@800000
00@0e3dI00H84@00000000000P0:3b<01P0000002PlS00X?8`0000003aHf000000<0g3`H0`000000
0`0mFJ/0bSHF0<Xf5P03000000P0bSHF00<0000003eIZ`3:=QH0103:=QH20000000303eIZ`000000
[bhB00P0[bhB00@0?EV[0:l^4P2_;Q80[bhB0P00000308HQ3003000000268@`0?EV[00@0QR4<0`00
0003060E20030000003D?AT0?EV[008000000P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP80?EV[303o
m^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h02P3o
m^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h01`3o
m^h203eIZ`T0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3o
m^h0ooK^01P0ooK^00<000000?ofkP3om^h09`3om^h00`000000ooK^0?ofkP0H0?ofkP40oooo001A
0?ofkP030000003om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h0503om^h00`3D?AT0ooK^0?ofkP06
0?ofkP80e3dI103om^h20=@m6@H0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`000000ooK^0?ofkP04
0?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h00`3om^h20=@m6@/0ooK^0`3D?AT0
0`3om^h0e3dI0?ofkP0@0?ofkP05000000062140e3dI00H84@0000000P0:3b<0100000002PlS00X?
8`00000200lF=P030000003L?1P0g3`H00@0g3`H00H0?EV[0000003:=QH0000003eIZ`3:=QH30000
00D0bSHF00<0000003eIZ`3:=QH01@3:=QH0100mFJ/000000000000000080:l^4P030000000mFJ/0
[bhB00<0[bhB0P0000000`268@`0000003eIZ`0608HQ3004000000268@`0000000000080H1D800<0
0000060E200mFJ/00`0000070?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h02P3o
m^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h0103o
m^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h02@3o
m^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h05P3o
m^h2000002X0ooK^00<000000?ofkP3om^h0603om^h10?ooo`00D03om^h00`000000ooK^0?ofkP0=
0?ofkP030=@m6@3om^h0ooK^01@0ooK^00<0e3dI0?ofkP3om^h0203om^h30=@m6@030?ofkP3D?AT0
ooK^00<0e3dI0P3om^h00`3D?AT0ooK^0?ofkP070?ofkP030000003om^h0ooK^00D0ooK^00<0e3dI
0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP050?ofkP<0e3dI2@3om^h00`3D?AT0ooK^0=@m6@02
0=@m6@l0ooK^00@0000000H84@0mFJ/0e3dI0P00000200X?8`040000000:3b<02PlS000000803aHf
00<000000=`l603L?1P0103L?1P01@0mFJ/0g3`H0000000mFJ/0000000@0bSHF0`0000020<Xf5P03
0000003:=QH0?EV[00@0bSHF00D0?EV[0<Xf5P3:=QH000000<Xf5P02000000H0[bhB00<0000003eI
Z`2_;Q801@2_;Q800`000000?EV[0000000708HQ3003000000268@`0QR4<00@0000000<0H1D803eI
Z`1P5@P0100000050?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0m
FJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0m
FJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0m
FJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h05@3om^h00`00
0000ooK^0?ofkP0Z0?ofkP030000003om^h0ooK^01P0ooK^0@3oool00500ooK^00<000000?ofkP3o
m^h03@3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^00`0ooK^0`3D?AT30?ofkP<0
e3dI203om^h00`000000ooK^0?ofkP060?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT02`3om^h30=@m
6@H0ooK^00<0e3dI0?ofkP3D?AT00P3om^h20=@m6@`0ooK^0P00000200H84@030=@m6@0000002PlS
00802PlS00<0000000X?8`0000000`0?5SH00`000000g3`H0=`l60040=`l600503eIZ`3L?1P0?EV[
0000003L?1P00`0000040<Xf5P<0000000<0bSHF03eIZ`3:=QH00P3:=QH01@0mFJ/0bSHF0<Xf5P3:
=QH0000000<0bSHF0`0000030:l^4P030000002_;Q80?EV[00D0[bhB00<0?EV[0000002_;Q800`00
000408HQ3003000000268@`0QR4<00<0QR4<0`0000000`0mFJ/0H1D8060E200600000080ooK^00<0
?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/0
4@3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[0100ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0
ooK^0?ofkP0<0?ofkP0403eIZ`3om^h0ooK^0?ofkP80?EV[303om^h00`0mFJ/0ooK^0?ofkP0D0?of
kP030000003om^h0ooK^02`0ooK^00<000000?ofkP3om^h05`3om^h10?ooo`00C`3om^h00`000000
ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^01@0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0
ooK^0?ofkP030=@m6@030?ofkP3D?AT0ooK^00<0e3dI1@3om^h00`000000ooK^0?ofkP060?ofkP05
0=@m6@3om^h0ooK^0?ofkP3D?AT03P3om^h20=@m6@<0ooK^00<0e3dI0?ofkP3D?AT01@3om^h30=@m
6@P0ooK^0P0000001@062140?EV[00H84@3D?AT0000000<02PlS0P00000400lF=P030000003L?1P0
g3`H00@0g3`H00@0?EV[0=`l600mFJ/00000103L?1P2000000@0bSHF0`0000020<Xf5P0303eIZ`3:
=QH0bSHF0080bSHF00<000000<Xf5P3:=QH0103:=QH2000000040:l^4P000000[bhB03eIZ`@0[bhB
00<0?EV[0:l^4P000000102_;Q840000000308HQ30000000QR4<00@0QR4<00H0000008HQ30000000
?EV[0000001P5@P7000000030?ofkP0mFJ/0ooK^00@0ooK^00<0?EV[0?ofkP3om^h0403om^h00`0m
FJ/0ooK^03eIZ`0C0?ofkP0303eIZ`3om^h0?EV[0180ooK^00@0?EV[0?ofkP3om^h0?EV[3`3om^h0
100mFJ/0ooK^0?ofkP0mFJ/?0?ofkP0303eIZ`3om^h0ooK^0180ooK^00<000000?ofkP3om^h0;@3o
m^h00`000000ooK^0?ofkP0G0?ofkP40oooo001>0?ofkP030000003om^h0ooK^00h0ooK^0P3D?ATD
0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h00`3om^h30=@m6@<0ooK^0`3D?AT0
0`3om^h000000?ofkP080?ofkP040=@m6@3om^h0ooK^0=@m6A40ooK^103D?AT00`3om^h0e3dI0?of
kP070?ofkP<0e3dI103om^h3000000801PPA00<000000=@m6@0000000`0:3b<00`0000003aHf00lF
=P0300lF=P030000003L?1P0g3`H00@0g3`H0P0mFJ/00`3L?1P000000=`l60050=`l60<0000000@0
bSHF0000003:=QH0bSHF0P0000050<Xf5P030000003:=QH0bSHF00H0bSHF0`0000001@2_;Q80?EV[
0:l^4P2_;Q80?EV[0080[bhB00<000000:l^4P2_;Q801P2_;Q83000000D0QR4<00@0000008HQ300m
FJ/0QR4<10000002060E20@000000P0mFJ/20?ofkP0303eIZ`3om^h0ooK^0180ooK^00<0?EV[0?of
kP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP0303eIZ`3om^h0?EV[0140ooK^0P0mFJ/@0?of
kP0303eIZ`3om^h0ooK^0140ooK^00<000000?ofkP3om^h0;P3om^h00`000000ooK^0?ofkP0G0?of
kP40oooo001>0?ofkP030000003om^h0ooK^00h0ooK^00<0e3dI0?ofkP3D?AT00P3D?ATA0?ofkP03
0=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0=@m6@020=@m6@<0
ooK^00<000000=@m6@3D?AT0203om^h0103D?AT0ooK^0?ofkP3D?ATD0?ofkP<0e3dI2`3om^h30=@m
6@090?ofkP0000001PPA0000000mFJ/000000=@m6@0:3b<0000000802PlS0P00000500lF=P030000
003L?1P0g3`H00@0g3`H00@0?EV[0=`l603L?1P000002@3L?1P3000000030<Xf5P0mFJ/0bSHF00<0
00000P3:=QH00`000000bSHF0<Xf5P070<Xf5P060000003:=QH0000003eIZ`2_;Q80?EV[102_;Q80
0`000000[bhB0:l^4P060:l^4P040000002_;Q800000000000<0QR4<00@0000008HQ30268@`0?EV[
0`268@`300000080H1D81000000203eIZa@0ooK^00<0?EV[0?ofkP0mFJ/04`3om^h00`0mFJ/0ooK^
03eIZ`0C0?ofkP0303eIZ`3om^h0ooK^0100ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^
0?ofkP0@0?ofkP030000003om^h0ooK^02l0ooK^00<000000?ofkP3om^h05`3om^h10?ooo`00C@3o
m^h00`000000ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00<0ooK^0`3D?AT>0?ofkP030=@m6@3o
m^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP030?ofkP80e3dI00@0
00000?ofkP3om^h0ooK^0`3D?AT40?ofkP040=@m6@3om^h0ooK^0=@m6AD0ooK^00<0e3dI0?ofkP3o
m^h00P3D?AT<0?ofkP80e3dI00L01PPA00000006214000000=@m6@0:3b<0000000802PlS0P000005
00lF=P030000003L?1P0g3`H00<0g3`H0P0mFJ/20=`l60030000003L?1P0g3`H00P0g3`H00@00000
0=`l600mFJ/0?EV[103:=QH3000000T0bSHF00D000000<Xf5P3:=QH0bSHF03eIZ`02000000<0[bhB
00<000000:l^4P2_;Q801P2_;Q8010000000[bhB0:l^4P2_;Q8200000080QR4<00@0000008HQ3026
8@`0?EV[0`268@`01@000000QR4<000000000000H1D800H000004P3om^h01@0mFJ/0ooK^0?ofkP3o
m^h0?EV[0140ooK^00@0?EV[0?ofkP3om^h0?EV[4P3om^h203eIZa40ooK^0P0mFJ/@0?ofkP80?EV[
4@3om^h00`000000ooK^0?ofkP0a0?ofkP030000003om^h0ooK^01H0ooK^0@3oool004d0ooK^00<0
00000?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP060?ofkP80e3dI2`3om^h00`3D?AT0ooK^0?of
kP0=0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`000000e3dI0=@m
6@040?ofkP<0e3dI00D0ooK^0=@m6@3om^h0ooK^0=@m6@0E0?ofkP030=@m6@3om^h0ooK^0080ooK^
0`3D?AT80?ofkP80000000L01PPA0=@m6@3D?AT0e3dI00X?8`3D?AT0000000802PlS00<0000000lF
=P0000001@0?5SH00`000000g3`H0=`l60020=`l600403eIZ`3L?1P0g3`H03eIZ`80g3`H00<00000
0=`l603L?1P01`3L?1P01@000000?EV[0=`l603L?1P0?EV[008000000`3:=QH3000000L0bSHF00L0
00000<Xf5P3:=QH0?EV[0<Xf5P0mFJ/0bSHF0080000000<0[bhB0000002_;Q801`2_;Q800`000000
[bhB0:l^4P030:l^4P<0000000@0QR4<03eIZ`268@`0?EV[0`268@`00`000000QR4<08HQ30040000
0003060E203D?AT0000000@000003@3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^
00h0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0403eIZ`3om^h0ooK^
03eIZ`l0ooK^00@0?EV[0?ofkP3om^h0?EV[3P3om^h00`0mFJ/0ooK^03eIZ`0?0?ofkP800000=03o
m^h00`000000ooK^0?ofkP0F0?ofkP40oooo001<0?ofkP030000003om^h0ooK^00h0ooK^00<0e3dI
0?ofkP3om^h02@3om^h30=@m6@P0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP03
0?ofkP030=@m6@3om^h0ooK^00D0ooK^00@000000?ofkP3om^h0ooK^0`3D?AT40?ofkP@0e3dI5@3o
m^h00`3D?AT0ooK^0?ofkP060?ofkP80e3dI1@3om^h2000000801PPA0P0000001P0:3b<0e3dI0=@m
6@3D?AT02PlS000000803aHf00<0000000lF=P0?5SH00`0?5SH200000080g3`H00D0?EV[0=`l603L
?1P0g3`H03eIZ`020=`l60030000003L?1P0g3`H00L0g3`H00D0000003eIZ`3L?1P0g3`H03eIZ`02
0=`l6080000000@0bSHF0000003:=QH0bSHF0`0000040<Xf5P030000003:=QH0?EV[00<0bSHF00<0
?EV[0<Xf5P3:=QH00`0000070:l^4P030000002_;Q80[bhB00D0[bhB00<0000003eIZ`0000000P26
8@`0100mFJ/0QR4<08HQ3000000508HQ308000000P1P5@P010000000e3dI000000113`H3000000T0
ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00<0
ooK^00<0?EV[0?ofkP3om^h03@3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00h0ooK^00D0?EV[0?of
kP3om^h0ooK^03eIZ`0=0?ofkP0403eIZ`3om^h0ooK^03eIZ`h0ooK^00<000000?ofkP3om^h0=03o
m^h00`000000ooK^0?ofkP0F0?ofkP40oooo001;0?ofkP030000003om^h0ooK^00l0ooK^00<0e3dI
0?ofkP3om^h0303om^h30=@m6@D0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP04
0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<000000?ofkP3om^h01@3om^h20=@m6@<0ooK^00<0e3dI
0?ofkP3D?AT00P3D?ATC0?ofkP030=@m6@3om^h0ooK^00P0ooK^0`3D?AT0103om^h0000000000000
000200H84@060000000:3b<02PlS00X?8`3D?AT000000P3D?AT200lF=P030000000?5SH03aHf0080
3aHf0P000000103Y@1X000000000000mFJ/30=`l600403eIZ`3L?1P0g3`H000000T0g3`H00<0?EV[
0=`l603L?1P00P3L?1P0100mFJ/0g3`H0=`l603L?1P3000000@0bSHF0`0000020<Xf5P0303eIZ`3:
=QH0bSHF0080bSHF00H0?EV[0<Xf5P3:=QH0bSHF0000003:=QH2000000H0[bhB00<000000:l^4P2_
;Q80102_;Q800`0mFJ/000000:l^4P030000000403eIZ`268@`0QR4<000000H0QR4<0P0000000`1P
5@P00000060E200200000080@@l60P0000060?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?of
kP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?of
kP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?of
kP3om^h02P3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00d0ooK^00<000000?ofkP3om^h0=@3om^h0
0`000000ooK^0?ofkP0F0?ofkP40oooo001;0?ofkP030000003om^h0ooK^00h0ooK^00<0e3dI0?of
kP3om^h0403om^h30=@m6@030?ofkP3D?AT0ooK^00h0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D
?AT0ooK^0?ofkP040?ofkP030000003om^h0ooK^00P0ooK^0`3D?AT00`3om^h0e3dI0?ofkP020?of
kP<0e3dI3`3om^h20=@m6@d0ooK^0`00000200H84@8000000`0:3b<0103D?AT000000000000?5SH2
0=@m6@070000000?5SH03aHf00lF=P0000006B=A000000020>U06P0403eIZ`3Y@1X0000000000080
g3`H00<0?EV[0=`l60000000203L?1P00`0mFJ/000000=`l60030=`l600303eIZ`3L?1P0g3`H0080
g3`H00<000000=@m6@0000000P0000040<Xf5P80000000<0?EV[0<Xf5P3:=QH00`3:=QH0100mFJ/0
bSHF0<Xf5P0000030<Xf5P<000000`2_;Q800`000000[bhB0:l^4P030:l^4P0403eIZ`2_;Q80[bhB
000000<0[bhB00@0000003eIZ`00000000001P268@`00`000000QR4<0000000300000005060E2000
000000000=@m6@113`H00P0000030?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h0
203om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h0
103om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h0
2@3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<000000?ofkP3om^h0
=`3om^h00`000000ooK^0?ofkP0E0?ofkP40oooo001:0?ofkP030000003om^h0ooK^00l0ooK^00<0
e3dI0?ofkP3om^h04`3om^h30=@m6@h0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?of
kP040?ofkP030000003om^h0ooK^00X0ooK^103D?AT50?ofkP<0e3dI303om^h20=@m6@d0ooK^0`00
000010062140000000X?8`00000200X?8`030=@m6@0:3b<0000000@03aHf0`3D?AT01P0000006B=A
01TSD@000000jD0J03eIZ`@0jD0J0P0000000`0mFJ/0g3`H000000070=`l600303eIZ`3L?1P00000
00D0g3`H00D0?EV[0=`l603L?1P0g3`H000000040=`l608000000`3:=QH0100mFJ/0000000000000
00040<Xf5P0303eIZ`3:=QH0000000H0bSHF0P0000000`2_;Q8000000:l^4P030:l^4P0503eIZ`2_
;Q80[bhB0:l^4P0000001@2_;Q80100mFJ/0000000000000000508HQ3003000000268@`0QR4<00<0
00000P1P5@P2000000050=@m6@00000000000000000mFJ/02`3om^h00`0mFJ/0ooK^0?ofkP080?of
kP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h01`3om^h203eIZ`L0ooK^00<0?EV[0?of
kP3om^h0203om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?of
kP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP090?ofkP030000003om^h0ooK^03P0ooK^00<000000?of
kP3om^h05@3om^h10?ooo`00BP3om^h00`000000ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^01@0
ooK^00<0e3dI0?ofkP3D?AT00P3D?AT:0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3o
m^h00`3om^h00`000000ooK^0?ofkP0;0?ofkP040=@m6@3om^h0e3dI0?ofkP<0e3dI1@3om^h20=@m
6@T0ooK^00<0e3dI0?ofkP3D?AT0303om^h20000000300H84@000000000000802PlS00@0000000X?
8`0:3b<0e3dI0P00000400lF=P030000000?5SH03aHf0080e3dI00<06B=A0000000mFJ/01`3Y@1X0
100mFJ/000000000000000050=`l600403eIZ`3L?1P0g3`H000000D0g3`H00D0?EV[0=`l603L?1P0
g3`H000000060=`l6080000000<0?EV[0<Xf5P0000000P3:=QH2000000<0bSHF00<0?EV[0000003:
=QH01`3:=QH300000080[bhB00<0?EV[0:l^4P2_;Q800P2_;Q800`000000[bhB0:l^4P040:l^4P03
03eIZ`000000[bhB008000000`268@`00`000000QR4<08HQ300208HQ30<000000P1P5@P00`000000
H1D8060E2004000000X0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP090?ofkP03
03eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP050?ofkP80
?EV[203om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3o
m^h01`3om^h00`000000ooK^0?ofkP0i0?ofkP030000003om^h0ooK^01D0ooK^0@3oool004T0ooK^
00<000000?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP0D0?ofkP030=@m6@3om^h0ooK^00<0ooK^
0P3D?AT80?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`000000ooK^
0?ofkP0<0?ofkP80e3dI1@3om^h30=@m6@@0ooK^0`3D?AT60?ofkP030=@m6@3om^h0e3dI00/0ooK^
00<0000003eIZ`0000000P062140100000002PlS00X?8`00000200X?8`030=@m6@0?5SH0000000@0
3aHf00<0000000lF=P0000000P0I8e420=@m6@0303eIZ`3Y@1X0jD0J00H0jD0J00<0?EV[0000003Y
@1X00P0000030=`l600403eIZ`3L?1P0g3`H000000H0g3`H00@0?EV[0=`l603L?1P000001`3L?1P0
0`0mFJ/0g3`H00000002000000<0bSHF0`0000000`3:=QH0?EV[000000080<Xf5P050000003:=QH0
000003eIZ`000000102_;Q800`000000[bhB0:l^4P050:l^4P0403eIZ`000000[bhB0:l^4P800000
0P268@`00`000000QR4<08HQ300308HQ30H000000`1P5@P4000000P0ooK^00<0?EV[0?ofkP3om^h0
103om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h0
2@3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h0
1@3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<000000?ofkP3om^h0
>P3om^h00`000000ooK^0?ofkP0E0?ofkP40oooo00180?ofkP030000003om^h0ooK^0100ooK^00<0
e3dI0?ofkP3om^h0503om^h00`3D?AT0ooK^0?ofkP050?ofkP<0e3dI1@3om^h00`3D?AT0ooK^0?of
kP030?ofkP030=@m6@3om^h0ooK^00<0ooK^00<000000?ofkP3om^h02`3om^h00`3D?AT0ooK^0=@m
6@080?ofkP@0e3dI0`3om^h30=@m6@80ooK^00<0e3dI0?ofkP3D?AT02`3om^h010000000?EV[0000
00062142000000802PlS00L0000000X?8`0:3b<000000=@m6@0?5SH0000000@03aHf0P00000401TS
D@030000003Y@1X0jD0J00L0jD0J00<0?EV[0000003Y@1X00P3Y@1X20000000503eIZ`3L?1P0g3`H
0=`l600000001P3L?1P0100mFJ/0g3`H0=`l600000060=`l600603eIZ`3L?1P0g3`H0=`l60000000
g3`H0P0000040<Xf5P<00000203:=QH01@000000bSHF0<Xf5P0mFJ/0bSHF00@0000000<0[bhB0000
002_;Q801P2_;Q800`0mFJ/0[bhB0:l^4P020:l^4P<000001P268@`00`000000QR4<08HQ30040000
0080H1D81@0000070?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h0303om^h00`0m
FJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0m
FJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0m
FJ/0ooK^0?ofkP040?ofkP800000?@3om^h00`000000ooK^0?ofkP0E0?ofkP40oooo00180?ofkP03
0000003om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h0503om^h00`3D?AT0ooK^0?ofkP090?ofkP<0
e3dI0P3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00<0ooK^00<000000?ofkP3o
m^h0303om^h20=@m6@d0ooK^0`3D?AT30?ofkP<0e3dI00<0ooK^0=@m6@3om^h02P3om^h300000003
00H84@0000002PlS00802PlS00L0000003eIZ`0:3b<000000=@m6@0?5SH0000000@03aHf00<00000
01TSD@0I8e40100I8e400`000000jD0J0>U06P060>U06P0303eIZ`000000jD0J00<0jD0J00H0?EV[
0>U06P00000000000=`l600000070=`l600303eIZ`3L?1P0000000D0g3`H00<0?EV[0=`l603L?1P0
0P3L?1P010000000g3`H0=`l603L?1P3000000<0bSHF00<0?EV[0000000000001P3:=QH00`000000
bSHF03eIZ`060<Xf5P<000001P2_;Q800`000000?EV[0:l^4P040:l^4P<0000010268@`00`000000
QR4<08HQ300308HQ30<000000P1P5@P00`000000H1D800000002000000D0ooK^00D0?EV[0?ofkP3o
m^h0ooK^03eIZ`0@0?ofkP0403eIZ`3om^h0ooK^03eIZ`h0ooK^00D0?EV[0?ofkP3om^h0ooK^03eI
Z`0=0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?of
kP030?ofkP030000003om^h0ooK^03h0ooK^00<000000?ofkP3om^h0503om^h10?ooo`00A`3om^h0
0`000000ooK^0?ofkP0@0?ofkP030=@m6@3om^h0ooK^01@0ooK^00<0e3dI0?ofkP3om^h0303om^h2
0=@m6@D0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`000000ooK^0?ofkP0=0?ofkP80e3dI403om^h3
0=@m6@030?ofkP3D?AT0ooK^00<0e3dI2@3om^h30000000300H84@000000000000<02PlS00@00000
00X?8`000000e3dI0P0?5SH0100000003aHf00lF=P0?5SH2000000H06B=A00<000000>U06P3Y@1X0
1`3Y@1X01@0mFJ/0jD0J0>U06P3Y@1X0?EV[00@0jD0J0`0000060=`l600303eIZ`3L?1P0000000@0
g3`H00<0?EV[0=`l603L?1P00`3L?1P00`000000g3`H0=`l60040=`l6080000000@0bSHF0000000m
FJ/0bSHF0`0000030<Xf5P030000000mFJ/0bSHF00L0bSHF00@000000<Xf5P00000000001@2_;Q80
0`000000?EV[0:l^4P040:l^4P030000002_;Q800000008000000P268@`00`000000QR4<08HQ3004
08HQ30<0000000@0H1D80000001P5@P0e3dI0`0000040?ofkP0303eIZ`3om^h0?EV[0140ooK^00<0
?EV[0?ofkP0mFJ/03`3om^h0100mFJ/0ooK^0?ofkP0mFJ/>0?ofkP0503eIZ`3om^h0ooK^0?ofkP0m
FJ/02`3om^h00`0mFJ/0ooK^0?ofkP020?ofkP030000003om^h0ooK^03l0ooK^00<000000?ofkP3o
m^h0503om^h10?ooo`00A`3om^h00`000000ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^01@0ooK^
00<0e3dI0?ofkP3om^h03P3om^h40=@m6@030?ofkP3D?AT0ooK^00<0ooK^00<000000?ofkP3om^h0
3@3om^h20=@m6A@0ooK^0`3D?AT00`3om^h0e3dI0?ofkP030=@m6@D0ooK^0P0000000`062140?EV[
00H84@02000000<02PlS0P0000001@0?5SH0e3dI00lF=P0?5SH0000000<03aHf0P00000601TSD@03
0000003Y@1X0jD0J00L0jD0J00@0?EV[0>U06P3Y@1X0?EV[1P3Y@1X010000000jD0J000000000005
0=`l600303eIZ`000000g3`H0080g3`H00<0?EV[0=`l603L?1P0103L?1P00`000000g3`H0=`l6006
0=`l60040=@m6@000000000003eIZ`<0bSHF0`0000000`0mFJ/000000<Xf5P070<Xf5P040000003:
=QH0bSHF0<Xf5P<000000P2_;Q800`000000[bhB03eIZ`050:l^4P040000002_;Q80[bhB0:l^4P@0
00001@268@`00`000000QR4<08HQ300400000080H1D80`0000030?ofkP0303eIZ`3om^h0ooK^0140
ooK^00<0?EV[0?ofkP3om^h03`3om^h203eIZ`l0ooK^00@0?EV[0?ofkP3om^h0?EV[303om^h01@0m
FJ/0ooK^0?ofkP3om^h000000480ooK^00<000000?ofkP3om^h0503om^h10?ooo`00AP3om^h00`00
0000ooK^0?ofkP0@0?ofkP80e3dI5@3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0e3dI
00@0e3dI0`3om^h00`000000ooK^0?ofkP0=0?ofkP80e3dI5@3om^h0103D?AT0ooK^0=@m6@3D?AT4
0?ofkP80e3dI0`3om^h30000000400H84@0000002PlS000000<02PlS00@0000000lF=P0?5SH0e3dI
0P0?5SH01P0000003aHf00lF=P0000006B=A000000H06B=A00<000000>U06P3Y@1X01`3Y@1X0100m
FJ/0jD0J0>U06P0mFJ/60>U06P040000003Y@1X0jD0J0>U06P<000000P3L?1P00`0mFJ/000000=`l
60020=`l600303eIZ`3L?1P0g3`H00@0g3`H00<000000=`l603L?1P01`3L?1P010000000g3`H0000
000mFJ/40<Xf5P0303eIZ`000000000000P0bSHF00<000000<Xf5P3:=QH0103:=QH2000000040:l^
4P000000[bhB03eIZ`@0[bhB00<000000:l^4P2_;Q80102_;Q83000000@0QR4<00<0000008HQ3026
8@`00P268@`300000003060E200000000000008000000P0mFJ/B0?ofkP80?EV[4@3om^h00`0mFJ/0
ooK^0?ofkP0?0?ofkP80?EV[3@3om^h0100mFJ/0ooK^0?ofkP0000130?ofkP030000003om^h0ooK^
01@0ooK^0@3oool004D0ooK^00<000000?ofkP3om^h04@3om^h00`3D?AT0ooK^0=@m6@020=@m6A80
ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP020?ofkPD0e3dI00<000000?ofkP3o
m^h03P3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP050=@m6@3om^h0ooK^0=@m6@3om^h00`3D?AT30?of
kP<0e3dI00@0000000H84@0mFJ/000000P0:3b<00`0000002PlS00X?8`02000000803aHf00H0e3dI
00lF=P0?5SH0000000lF=P00000201TSD@030000000I8e406B=A00@06B=A00<000000>U06P3Y@1X0
1`3Y@1X00`000000?EV[03eIZ`070>U06P030000003Y@1X0jD0J00@0jD0J0P0000001@3L?1P0?EV[
0=`l603L?1P0?EV[00L0g3`H00<000000=`l603L?1P01`3L?1P010000000g3`H0=`l600mFJ/30000
000303eIZ`3:=QH0bSHF00@000001@3:=QH00`000000bSHF0<Xf5P060<Xf5P<0000000<0[bhB03eI
Z`2_;Q800P2_;Q800`000000[bhB0:l^4P050:l^4P040000002_;Q800000000000<0QR4<00<00000
08HQ30268@`00`268@`300000003060E20000000H1D80080000000<0?EV[0?ofkP3om^h03P3om^h0
100mFJ/0ooK^0?ofkP0mFJ/?0?ofkP80?EV[4@3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP80?EV[00<0
ooK^0000003om^h0A03om^h00`000000ooK^0?ofkP0C0?ofkP40oooo00150?ofkP030000003om^h0
ooK^0100ooK^00<0e3dI0?ofkP3om^h00`3om^h30=@m6@h0ooK^00<0e3dI0?ofkP3om^h03P3om^h0
0`3D?AT0ooK^0?ofkP020?ofkP050=@m6@3om^h0ooK^0=@m6@000000103D?AT=0?ofkP030=@m6@3o
m^h0ooK^01<0ooK^00@0e3dI0?ofkP3om^h0e3dI103om^h30=@m6@030?ofkP000000000000<0e3dI
0P0:3b<01P0000002PlS00X?8`0000003aHf000000803aHf00<0e3dI00lF=P0?5SH00P00000301TS
D@030000000I8e406B=A00@06B=A00<000000>U06P3Y@1X01`3Y@1X00`000000?EV[0>U06P070>U0
6P030000003Y@1X0jD0J00H0jD0J00@0000003eIZ`000000?EV[203L?1P00`000000g3`H0=`l6007
0=`l60070000003L?1P0g3`H0=`l600mFJ/0g3`H03eIZ`02000000030<Xf5P000000bSHF0080bSHF
0P0000030<Xf5P030000003:=QH0bSHF00L0bSHF00D000000<Xf5P000000000003eIZ`030:l^4P03
0000002_;Q80[bhB00D0[bhB00<000000:l^4P2_;Q800P00000208HQ3003000000268@`0QR4<00<0
QR4<00<0000008HQ300000000`0000000`1P5@P0?EV[0000000>0?ofkP0503eIZ`3om^h0ooK^0?of
kP0mFJ/03P3om^h00`0mFJ/0ooK^03eIZ`0@0?ofkP80?EV[303om^h0100mFJ/0ooK^03eIZ`000016
0?ofkP030000003om^h0ooK^01<0ooK^0@3oool004@0ooK^00<000000?ofkP3om^h04@3om^h00`3D
?AT0ooK^0?ofkP060?ofkP80e3dI303om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^
0080ooK^00H0e3dI0?ofkP3om^h0ooK^0000003om^h20=@m6@030?ofkP3D?AT0e3dI0080e3dI203o
m^h00`3D?AT0ooK^0?ofkP0C0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT01`3om^h30000000300H8
4@000000000000<0e3dI00D02PlS0000000?5SH03aHf0000000200lF=P030=@m6@0?5SH03aHf0080
00000`0I8e400`0000006B=A01TSD@0401TSD@800000203Y@1X00`0mFJ/0jD0J03eIZ`070>U06P03
0000003Y@1X0jD0J00L0jD0J00<0000003eIZ`0000000P0000060=`l60030000003L?1P0g3`H00L0
g3`H00<000000=`l603L?1P00P3L?1P01@0mFJ/0g3`H0=`l603L?1P0e3dI00800000103:=QH30000
00030<Xf5P000000bSHF00L0bSHF00H000000<Xf5P3:=QH0?EV[0000000mFJ/20:l^4P030000002_
;Q80[bhB00D0[bhB00<000000:l^4P2_;Q800P2_;Q83000000H0QR4<00@0000008HQ30268@`0QR4<
0`0000000`0mFJ/000000=@m6@0;0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h0
2`3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00h0ooK^00<0?EV[0?ofkP0mFJ/02P3om^h203eIZ`03
0?ofkP0mFJ/0000004L0ooK^00<000000?ofkP3om^h04`3om^h10?ooo`00A03om^h00`000000ooK^
0?ofkP0A0?ofkP030=@m6@3om^h0ooK^00P0ooK^0`3D?AT80?ofkP030=@m6@3om^h0ooK^00h0ooK^
00<0e3dI0?ofkP3om^h00`3om^h0103D?AT0ooK^0?ofkP0000040?ofkP<0e3dI0P3om^h30=@m6@D0
ooK^00<0e3dI0?ofkP3om^h04`3om^h0103D?AT0ooK^0?ofkP3D?AT70?ofkP<000000P0621401@00
00002PlS00X?8`0:3b<000000080e3dI0P0?5SH00`0000003aHf0=@m6@0300lF=P030000000I8e40
6B=A00<06B=A00<0000001TSD@0I8e400P0I8e42000000030?9370000000000000D0jD0J00@0?EV[
0000003Y@1X0?EV[1`3Y@1X00`000000jD0J0>U06P070>U06P0303eIZ`3Y@1X0?EV[0080jD0J0P00
00040=`l60030000003L?1P0g3`H00L0g3`H00L000000=`l603L?1P0g3`H03eIZ`3L?1P0?EV[00<0
g3`H00@000000=`l6000000000001@3:=QH3000000L0bSHF00<000000<Xf5P0mFJ/00`3:=QH203eI
Z`030:l^4P000000[bhB00D0[bhB00<000000:l^4P2_;Q80102_;Q83000000@0QR4<00<0000008HQ
30268@`00`268@`500000080e3dI1P3om^h203eIZ`H0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0m
FJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00X0ooK^0P0mFJ/20?ofkP0303eIZ`3om^h0ooK^
00L0ooK^00D0?EV[0?ofkP3om^h0000003eIZ`180?ofkP030000003om^h0ooK^01<0ooK^0@3oool0
04<0ooK^00<000000?ofkP3om^h04P3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP<0e3dI1@3om^h00`3D
?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^0080ooK^00@0e3dI0?ofkP3om^h00000203om^h3
0=@m6@80ooK^0`3D?AT00`3om^h0e3dI0=@m6@0D0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT01P3o
m^h20000000300H84@0000001PPA008000000`0:3b<20000000600lF=P3D?AT0e3dI0=@m6@0?5SH0
e3dI0P0?5SH2000000D06B=A00L0000001TSD@0I8e406B=A0000000R<Vd0000000<0lT<L0`000000
103Y@1X0?EV[0>U06P0000020>U06P0303eIZ`3Y@1X0jD0J00@0jD0J00<000000>U06P3Y@1X01P3Y
@1X0100mFJ/000000>U06P0mFJ/40>U06P<0000000<0g3`H0000003L?1P0203L?1P010000000g3`H
0=`l600mFJ/30=`l600403eIZ`3L?1P0g3`H000000<0g3`H0`0000030<Xf5P040000003:=QH00000
000000D0bSHF00<0000003eIZ`3:=QH01@3:=QH00`0mFJ/00000000000060:l^4P030000002_;Q80
[bhB00@0[bhB00<000000:l^4P0000000P00000208HQ3003000000268@`0QR4<0080QR4<00<00000
08HQ30268@`0100000020=@m6@<0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP08
0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP02
0?ofkP0303eIZ`3om^h0ooK^00H0ooK^00H0?EV[0?ofkP3om^h000000?ofkP0mFJ]80?ofkP030000
003om^h0ooK^01<0ooK^0@3oool00480ooK^00<000000?ofkP3om^h04P3om^h00`3D?AT0ooK^0?of
kP0?0?ofkP<0e3dI00<0ooK^0=@m6@3om^h0403om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3o
m^h0000000`0ooK^0P3D?AT30?ofkP<0e3dI503om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00D0ooK^
1000000010062140000000X?8`00000300X?8`030000000?5SH03aHf00803aHf00L000000=@m6@3D
?AT0e3dI0000000I8e40000000D06B=A00@0000001TSD@0I8e4000000P0R<Vd00`000000lT<L0?93
70040?93700403eIZ`000000jD0J00000080jD0J00<0?EV[0>U06P3Y@1X0103Y@1X00`000000jD0J
0>U06P050>U06P0303eIZ`3Y@1X000000080jD0J00<0?EV[0>U06P3Y@1X0103Y@1X3000000P0g3`H
00<000000=`l600mFJ/01@3L?1P00`0mFJ/0g3`H000000060=`l6080000000<0e3dI0000003:=QH0
0P3:=QH300000080bSHF00<0?EV[0000003:=QH01P3:=QH00`0mFJ/0bSHF00000002000000<0[bhB
00<000000:l^4P2_;Q801@2_;Q8010000000[bhB0:l^4P2_;Q84000000@0QR4<00<0000008HQ3026
8@`00P268@`2000000<0e3dI00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP070?ofkP03
03eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP030?ofkP03
03eIZ`3om^h0ooK^00D0ooK^00@0?EV[0?ofkP3om^h000000P3om^h00`0mFJ/0ooK^0?ofkP170?of
kP030000003om^h0ooK^0180ooK^0@3oool00480ooK^00<000000?ofkP3om^h04P3om^h00`3D?AT0
ooK^0?ofkP0B0?ofkP<0e3dI3`3om^h00`3D?AT0ooK^0?ofkP020?ofkP040=@m6@3om^h0ooK^0000
00h0ooK^0`3D?AT00`3om^h0e3dI0?ofkP030=@m6A40ooK^00@0e3dI0?ofkP3om^h0e3dI1@3om^h0
100000001PPA000000062142000000802PlS00<0000000X?8`0:3b<00P00000400lF=P040000000m
FJ/0e3dI00000080e3dI00<0000001TSD@0I8e400`0I8e40100000006B=A01TSD@000003028bK@03
0000003b@a`0lT<L0080lT<L00<0?EV[0?93703b@a`00`0000020>U06P0303eIZ`3Y@1X0jD0J00<0
jD0J00<000000>U06P3Y@1X01@3Y@1X00`0mFJ/0jD0J000000030>U06P0303eIZ`3Y@1X0jD0J00@0
jD0J00@000000>U06P00000000001P3L?1P00`000000?EV[0=`l60060=`l600303eIZ`000000g3`H
00L0g3`H00<0e3dI0000000000001@3:=QH4000000L0bSHF00<0000003eIZ`3:=QH00P3:=QH30000
00030:l^4P000000[bhB00D0[bhB00<000000:l^4P2_;Q80102_;Q82000000@0QR4<00<0000008HQ
30268@`00`268@`00`000000ooK^03eIZ`040=@m6@L0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0m
FJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0m
FJ/0ooK^0?ofkP040?ofkP0403eIZ`3om^h0ooK^000000<0ooK^00<0?EV[0?ofkP3om^h0A`3om^h0
0`000000ooK^0?ofkP0B0?ofkP40oooo00110?ofkP030000003om^h0ooK^01<0ooK^00<0e3dI0?of
kP3om^h04`3om^h00`3D?AT0ooK^0=@m6@020=@m6@`0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D
?AT0ooK^0000000B0?ofkP<0e3dI0`3om^h20=@m6@h0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@04
0?ofkP<000000P062142000000802PlS00<0000000X?8`0:3b<00P00000400lF=P030000003D?AT0
000000<06B=A0`3D?AT301TSD@030000000I8e40000000@08S9]00<000000?93703b@a`00P3b@a`0
1P0mFJ/0lT<L0?93703b@a`000000?937080000000<0?EV[0>U06P3Y@1X00`3Y@1X00`000000jD0J
0>U06P040>U06P0403eIZ`3Y@1X0jD0J000000@0jD0J00<0?EV[0>U06P3Y@1X00`3Y@1X010000000
jD0J0>U06P3Y@1X3000000<0g3`H00<0?EV[0=`l603L?1P01`3L?1P00`0mFJ/0g3`H0=`l60070=`l
60030000003L?1P00000008000000P3:=QH00`0mFJ/0bSHF0<Xf5P02000000H0bSHF00@000000<Xf
5P0mFJ/0?EV[103:=QH3000000H0[bhB00<000000:l^4P2_;Q80102_;Q83000000<0QR4<00<00000
08HQ30268@`00`268@`00`0mFJ/0ooK^0?ofkP020?ofkP@0e3dI103om^h00`0mFJ/0ooK^0?ofkP04
0?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP05
0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00@0?EV[0?ofkP3om^h00000103om^h00`0mFJ/0ooK^0?of
kP170?ofkP030000003om^h0ooK^0180ooK^0@3oool00440ooK^00<000000?ofkP3om^h04`3om^h0
0`3D?AT0ooK^0?ofkP0B0?ofkP030=@m6@3om^h0ooK^00<0ooK^0`3D?AT90?ofkP030=@m6@3om^h0
ooK^0080ooK^00<0e3dI0000003om^h04P3om^h20=@m6@040?ofkP3D?AT0e3dI0=@m6@80ooK^0`3D
?AT;0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT0103om^h30000000300H84@000000000000802PlS
00H0000000X?8`0:3b<0000000lF=P00000400lF=P030000003D?AT06B=A00<06B=A00<0000001TS
D@0I8e400P3D?AT00`0I8e40000000000005028bK@050000003b@a`0lT<L0?93700mFJ/0103b@a`0
1`000000lT<L0?93703b@a`0000003eIZ`0000000`3Y@1X00`000000jD0J0>U06P030>U06P0503eI
Z`3Y@1X0jD0J0>U06P000000103Y@1X00`0mFJ/0jD0J0>U06P030>U06P030000003Y@1X0jD0J00@0
jD0J0P0000000`0mFJ/000000=`l60080=`l60030000000mFJ/0g3`H00L0g3`H00<000000=`l603L
?1P00P3L?1P01`000000?EV[000000000000bSHF0000003:=QH00`0000030<Xf5P050000003:=QH0
bSHF0<Xf5P0mFJ/0103:=QH010000000bSHF0000000000040:l^4P030000002_;Q80[bhB00D0[bhB
00H000000:l^4P000000000008HQ3000000508HQ300303eIZ`000000e3dI00@0ooK^103D?AT30?of
kP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP040?of
kP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h00P3om^h0100mFJ/0ooK^0?ofkP000004
0?ofkP0303eIZ`3om^h0ooK^04P0ooK^00<000000?ofkP3om^h04P3om^h10?ooo`00@03om^h00`00
0000ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h01P3om^h20=@m
6@H0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0000000C0?ofkP030=@m6@3om^h0ooK^
00<0ooK^0`3D?AT20?ofkP<0e3dI1`3om^h00`3D?AT0ooK^0?ofkP020?ofkP040=@m6@3om^h0ooK^
0?ofkP<0000000<0?EV[00H84@0000000`0:3b<00`000000?EV[0000000200lF=P030000000?5SH0
3aHf00803aHf00<000000=@m6@0I8e400`0I8e400`0000006B=A01TSD@0201TSD@80e3dI1P0R<Vd0
10000000lT<L0?93700mFJ/50?9370030000003b@a`0lT<L0080lT<L00H0?EV[0?93700000000000
0>U06P0000040>U06P0303eIZ`3Y@1X0jD0J0080jD0J00<000000>U06P3Y@1X00`3Y@1X00`0mFJ/0
jD0J0>U06P020>U06P030000003Y@1X0jD0J00D0jD0J00@0?EV[0000000000000000203L?1P00`00
0000?EV[0=`l60070=`l60030000003L?1P0g3`H0080g3`H00@0?EV[0=`l603L?1P0g3`H0`000003
0<Xf5P<0000000<0bSHF0000003:=QH00P3:=QH01@0mFJ/0bSHF0<Xf5P3:=QH0000000<0bSHF0`00
00020:l^4P030000002_;Q80[bhB00@0[bhB00@000000:l^4P2_;Q80[bhB0`00000508HQ30D0e3dI
0`3om^h50=@m6@0503eIZ`3om^h0ooK^0?ofkP0mFJ/02`3om^h00`0mFJ/0ooK^0?ofkP030?ofkP03
03eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h00P0mFJ/20?ofkP030000003om^h0ooK^00<0
ooK^00<0?EV[0?ofkP3om^h0B@3om^h00`000000ooK^0?ofkP0A0?ofkP40oooo000o0?ofkP030000
003om^h0ooK^01@0ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP080?ofkP<0e3dI
0`3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@000000ooK^0180ooK^0P3D?AT80?ofkP<0e3dI
0P3om^h20=@m6@D0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@030?ofkP80000000<01PPA03eIZ`06
21400P00000300X?8`8000000`0?5SH0100000003aHf00lF=P0?5SH2000000030=@m6@0I8e406B=A
00<06B=A00@0000001TSD@0I8e406B=A0P0000030=@m6@<08S9]00<000000?93700mFJ/01P3b@a`0
0`000000lT<L0?9370030?93700303eIZ`3b@a`0lT<L00<000000P3Y@1X00`0mFJ/0jD0J0>U06P03
0>U06P030000003Y@1X0jD0J00@0jD0J00D0?EV[0>U06P3Y@1X0jD0J000000070>U06P0403eIZ`3Y
@1X000000>U06P<000001@3L?1P00`000000g3`H03eIZ`070=`l60050000003L?1P0g3`H0=`l600m
FJ/01@3L?1P010000000g3`H0000000000040<Xf5P800000103:=QH01@0mFJ/0bSHF0<Xf5P3:=QH0
000000D0bSHF0`0000070:l^4P030000002_;Q80[bhB0080[bhB0`00000408HQ30040000003D?AT0
e3dI0?ofkP<0e3dI00H0ooK^0=@m6@3om^h0ooK^0=@m6@0mFJ/20=@m6@0303eIZ`3om^h0ooK^00X0
ooK^00@0?EV[0?ofkP3om^h0ooK^0P0mFJ/:0?ofkP0303eIZ`3om^h0?EV[0080ooK^0P0000060?of
kP0303eIZ`3om^h0ooK^04T0ooK^00<000000?ofkP3om^h04@3om^h10?ooo`00?`3om^h00`000000
ooK^0?ofkP0D0?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h02`3om^h40=@m6@@0
ooK^00<000000?ofkP3om^h04P3om^h20=@m6@/0ooK^0P3D?AT20?ofkP<0e3dI00<0ooK^0=@m6@3o
m^h00`3om^h00`3D?AT0ooK^0?ofkP020000000600H84@000000?EV[0000000:3b<000000`0:3b<0
0`0mFJ/0000000lF=P0200lF=P060000000?5SH03aHf00lF=P000000e3dI1P0I8e401P0000006B=A
01TSD@0000008S9]000000<08S9]0P3D?AT00`0R<Vd0000003eIZ`070?9370030000003b@a`0lT<L
00<0lT<L00T0?EV[0?93703b@a`0lT<L0000003b@a`0000003eIZ`0000001@3Y@1X00`000000jD0J
0>U06P050>U06P0303eIZ`3Y@1X0000000L0jD0J00@0?EV[0>U06P3Y@1X00000103Y@1X400000005
0=`l60000000g3`H0=`l600mFJ/01P3L?1P010000000g3`H0=`l600mFJ/60=`l60040000003L?1P0
g3`H0=`l608000000`3:=QH400000080bSHF0P0mFJ/00`3:=QH000000<Xf5P060<Xf5P<000001@2_
;Q800`000000[bhB0:l^4P040:l^4P@000000P268@`010000000ooK^0=@m6@3D?AT20?ofkPH0e3dI
0P0mFJ/30=@m6@/0ooK^00<0?EV[0?ofkP0mFJ/0303om^h203eIZ`80ooK^00<000000?ofkP3om^h0
1@3om^h00`0mFJ/0ooK^0?ofkP1:0?ofkP030000003om^h0ooK^0140ooK^0@3oool003h0ooK^00<0
00000?ofkP3om^h05@3om^h00`3D?AT0ooK^0?ofkP0B0?ofkP030=@m6@3om^h0ooK^00h0ooK^103D
?AT00`3om^h000000?ofkP0D0?ofkP030=@m6@3om^h0ooK^00`0ooK^0`3D?AT20?ofkP<0e3dI0`3o
m^h0103D?AT0ooK^0?ofkP00000200H84@0403eIZ`0000002PlS000000@02PlS00<0000000lF=P0?
5SH00P0?5SH01P0000003aHf00lF=P0000006B=A0=@m6@H06B=A00<0000001TSD@0000000`0R<Vd0
0`0000008S9]028bK@02028bK@80e3dI203b@a`00`000000lT<L0?9370040?93700603eIZ`3b@a`0
lT<L0000003b@a`0?EV[0P3b@a`4000000030>U06P000000jD0J00H0jD0J00<0?EV[0>U06P000000
1P3Y@1X01@0mFJ/0jD0J0>U06P3Y@1X0000000P0jD0J0`0000020=`l600303eIZ`3L?1P0g3`H00<0
g3`H00<000000=`l600mFJ/01`3L?1P00`000000g3`H0=`l60030=`l6080000000<0bSHF0000003:
=QH00P3:=QH200000080bSHF00<0?EV[0000003:=QH01`3:=QH00`000000bSHF00000002000000<0
[bhB00<000000:l^4P2_;Q800`2_;Q8010000000[bhB0:l^4P2_;Q84000000030?ofkP3D?AT0e3dI
0080e3dI00H0ooK^0=@m6@3D?AT0e3dI0?ofkP0mFJ/20?ofkP@0e3dI2@3om^h203eIZ`d0ooK^00@0
?EV[0?ofkP3om^h000001`3om^h203eIZd`0ooK^00<000000?ofkP3om^h04@3om^h10?ooo`00?@3o
m^h00`000000ooK^0?ofkP0E0?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h03P3o
m^h01`3D?AT0ooK^0?ofkP3om^h0e3dI0000003D?AT04`3om^h20=@m6A40ooK^103D?AT00`3om^h0
e3dI0=@m6@020=@m6@030?ofkP000000000000801PPA00@0?EV[0000000:3b<000000`0:3b<20000
00@03aHf00<0000000lF=P0000000P0I8e400`3D?AT0000001TSD@0401TSD@030000000I8e400000
00<08S9]00<00000028bK@0R<Vd0100R<Vd00`000000lT<L0?9370050?9370030000003b@a`0lT<L
00@0lT<L00H0?EV[0?93703b@a`000000?93700mFJ/60?9370<000001`3Y@1X00`0mFJ/000000>U0
6P040>U06P0303eIZ`3Y@1X0jD0J0080jD0J00<000000>U06P3Y@1X01`3Y@1X01P000000jD0J0000
00000000g3`H03eIZ`@0g3`H00<0000003eIZ`3L?1P01`3L?1P00`000000g3`H0=`l60050=`l60<0
0000103:=QH30000000303eIZ`3:=QH0bSHF00H0bSHF00<000000<Xf5P3:=QH00P3:=QH4000000H0
[bhB00<000000:l^4P2_;Q800`2_;Q82000000@0ooK^0`3D?AT0103om^h0?EV[03eIZ`3D?AT40?of
kP<0e3dI1`3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP80?EV[00<0ooK^0000003om^h01P3om^h203eI
Zdh0ooK^00<000000?ofkP3om^h0403om^h10?ooo`00?@3om^h00`000000ooK^0?ofkP0E0?ofkP80
e3dI503om^h00`3D?AT0ooK^0?ofkP0>0?ofkP070=@m6@3om^h0ooK^0?ofkP000000e3dI0?ofkP03
0=@m6A00ooK^0P3D?ATC0?ofkP@0e3dI00<0ooK^0=@m6@3D?AT00P00000200H84@8000000P0:3b<0
1P0000002PlS00X?8`0000003aHf000000@03aHf0P00000201TSD@030=@m6@0I8e40000000D06B=A
0P000004028bK@030000000R<Vd08S9]00@08S9]00<000000?93703b@a`01P3b@a`00`000000lT<L
0?9370040?93700403eIZ`3b@a`0000003eIZ`P0lT<L00@000000?937000000000001P3Y@1X00`0m
FJ/0jD0J0>U06P020>U06P0303eIZ`3Y@1X0jD0J00<0jD0J00<000000>U06P3Y@1X01`3Y@1X01000
0000jD0J0>U06P3Y@1X20000000503eIZ`3L?1P0g3`H0=`l600mFJ/02@3L?1P00`000000g3`H0=`l
60060=`l60040000003L?1P00000000000@0bSHF00@0?EV[00000000000000001P3:=QH00`000000
bSHF0<Xf5P050<Xf5P<00000102_;Q800`000000[bhB0:l^4P050:l^4P030000003om^h0ooK^00<0
ooK^00D0e3dI03eIZ`3D?AT0?EV[0?ofkP030=@m6@@0ooK^0`3D?AT30?ofkP80?EV[303om^h203eI
Z`030?ofkP000000ooK^00D0ooK^0P0mFJ/00`3om^h0?EV[0?ofkP1=0?ofkP030000003om^h0ooK^
0100ooK^0@3oool003`0ooK^00<000000?ofkP3om^h05P3om^h00`3D?AT0ooK^0=@m6@020=@m6A40
ooK^00<0e3dI0?ofkP3om^h03@3om^h01P3D?AT0ooK^0?ofkP3om^h000000=@m6@D0ooK^0P3D?AT>
0?ofkP030=@m6@3om^h0ooK^0180ooK^00@0e3dI0?ofkP3om^h0ooK^0`3D?AT2000000801PPA00L0
000000X?8`0:3b<02PlS0000000:3b<0000000803aHf00<0000000lF=P0?5SH00P0?5SH200000080
6B=A00<0e3dI01TSD@0000001@0I8e400`0000008S9]028bK@03028bK@030000000R<Vd08S9]00@0
8S9]00<000000?93703b@a`01P3b@a`00`000000lT<L0?9370040?93700303eIZ`3b@a`0?EV[00T0
lT<L00@000000?93703b@a`0lT<L0`0000030>U06P050000000mFJ/0jD0J0>U06P0mFJ/01@3Y@1X0
0`000000jD0J0>U06P080>U06P030000003Y@1X0jD0J00@0jD0J00@0?EV[0000000mFJ/00000203L
?1P00`000000g3`H0=`l60070=`l60040000003L?1P0g3`H0=`l60<0000000D0?EV[0<Xf5P3:=QH0
00000<Xf5P02000000@0bSHF00<000000<Xf5P3:=QH01P3:=QH010000000bSHF0000000000030:l^
4P030000002_;Q80[bhB00@0[bhB00<000000?ofkP3om^h00`3om^h01P0mFJ/0ooK^0=@m6@3D?AT0
?EV[0=@m6@80ooK^0P3D?AT40?ofkP<0e3dI00<0?EV[0?ofkP0mFJ/02`3om^h0100mFJ/0ooK^03eI
Z`0000060?ofkP0403eIZ`3om^h0ooK^03eIZdl0ooK^00<000000?ofkP3om^h0403om^h10?ooo`00
?03om^h00`000000ooK^0?ofkP0E0?ofkP030=@m6@3om^h0ooK^00<0ooK^0`3D?AT=0?ofkP030=@m
6@3om^h0ooK^00h0ooK^0P3D?AT0103om^h000000?ofkP3D?AT70?ofkP<0e3dI2P3om^h20=@m6A@0
ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT000000=@m6@020=@m6@8000000P0:3b<00`000000
2PlS0000000300lF=P030000000?5SH03aHf00803aHf00L0000001TSD@0I8e406B=A0=@m6@0I8e40
000000@06B=A0P000006028bK@030000000R<Vd08S9]00<08S9]0P0000070?9370030000003b@a`0
lT<L00D0lT<L00<0?EV[0000003b@a`0203b@a`00`000000lT<L0?9370040?937080000000D0jD0J
0000000mFJ/0jD0J03eIZ`060>U06P030000003Y@1X0jD0J00P0jD0J00<000000>U06P3Y@1X01@3Y
@1X0100mFJ/000000000000000070=`l60030000003L?1P0g3`H00L0g3`H00<000000=`l603L?1P0
0`3L?1P01@0mFJ/000000000003:=QH0000000<0bSHF0`0000020<Xf5P030000003:=QH0bSHF00D0
bSHF00@000000<Xf5P3:=QH0bSHF0P0000020:l^4P030000002_;Q80[bhB00@0[bhB00D000000=@m
6@3om^h0ooK^03eIZ`020?ofkP040=@m6@3om^h0?EV[0?ofkP<0e3dI00@0ooK^0=@m6@3D?AT0e3dI
0P3om^h01@3D?AT0?EV[0=@m6@3D?AT0?EV[00X0ooK^00@0?EV[0?ofkP3om^h0?EV[1P3om^h0100m
FJ/0ooK^0?ofkP0mFJ]@0?ofkP030000003om^h0ooK^0100ooK^0@3oool003/0ooK^00<000000?of
kP3om^h05P3om^h00`3D?AT0ooK^0?ofkP060?ofkP80e3dI2`3om^h00`3D?AT0ooK^0?ofkP0>0?of
kP040=@m6@3om^h0e3dI00000080e3dI2P3om^h30=@m6@L0ooK^00<0e3dI0?ofkP3om^h04P3om^h0
0`3D?AT0ooK^0?ofkP020?ofkP060=@m6@062140000000000006214000000P3D?AT200X?8`800000
100?5SH0100000003aHf00lF=P0?5SH2000000<06B=A00<0e3dI01TSD@0000000`0I8e400`000000
8S9]00000006028bK@030000000R<Vd08S9]00808S9]0P0000000`3iAQd00000000000050?937003
0000003b@a`0lT<L00@0lT<L00@0?EV[0?93700mFJ/00000203b@a`00`000000lT<L0?9370060?93
70<0000000<0?EV[0>U06P3Y@1X01@3Y@1X00`000000jD0J0>U06P080>U06P030000003Y@1X0jD0J
00@0jD0J00D0?EV[0>U06P0mFJ/000000>U06P02000000D0g3`H00<000000=`l603L?1P01`3L?1P0
0`000000g3`H0=`l60020=`l600503eIZ`3L?1P0g3`H0=`l603D?AT00P0000040<Xf5P0403eIZ`00
00000000000000P0bSHF00<000000<Xf5P3:=QH00P3:=QH3000000H0[bhB00@000000?ofkP3D?AT0
?EV[103om^h00`3D?AT0?EV[0?ofkP030?ofkP<0e3dI00@0ooK^0=@m6@3D?AT0?EV[0P3D?AT00`3o
m^h0?EV[0=@m6@080?ofkP0503eIZ`3om^h000000000000mFJ/01@3om^h01@0mFJ/0ooK^0?ofkP3o
m^h0?EV[0500ooK^00<000000?ofkP3om^h0403om^h10?ooo`00>P3om^h00`000000ooK^0?ofkP0G
0?ofkP030=@m6@3om^h0ooK^00P0ooK^0`3D?AT80?ofkP030=@m6@3om^h0ooK^00d0ooK^00@0e3dI
0?ofkP3om^h000000P3om^h30=@m6@/0ooK^0P3D?AT50?ofkP030=@m6@3om^h0ooK^0180ooK^00<0
e3dI0?ofkP3om^h00P3om^h00`3D?AT0000000H84@020000000300X?8`0000002PlS00<0e3dI1@0?
5SH01P0000003aHf00lF=P0000006B=A000000806B=A00@0e3dI01TSD@0I8e4000000P0I8e401000
00008S9]028bK@000006028bK@070000000R<Vd08S9]028bK@000000:Sj3000000030?U67@800000
0`3b@a`00`000000lT<L0?9370030?93700503eIZ`3b@a`0lT<L03eIZ`000000203b@a`00`000000
lT<L0?9370070?9370050000000mFJ/0000003eIZ`0000001@3Y@1X00`000000jD0J0>U06P070>U0
6P030000003Y@1X0jD0J00@0jD0J00@0?EV[0>U06P3Y@1X0jD0J0P0mFJ/20>U06P8000000`3L?1P0
0`000000g3`H0=`l60070=`l60050000003L?1P0g3`H0=`l600mFJ/01@3L?1P00`000000g3`H0000
000200000080bSHF0P0mFJ/3000000H0bSHF00<000000<Xf5P3:=QH0103:=QH3000000D0[bhB0P0m
FJ/01`3om^h0e3dI0=@m6@3D?AT0ooK^0=@m6@0mFJ/01P3om^h30=@m6@0303eIZ`3om^h0e3dI0080
e3dI00<0?EV[0=@m6@3D?AT00P3D?AT40?ofkP0503eIZ`3om^h000000?ofkP0mFJ/01@3om^h01@0m
FJ/0ooK^0?ofkP3om^h0?EV[0580ooK^00<000000?ofkP3om^h03`3om^h10?ooo`00>P3om^h00`00
0000ooK^0?ofkP0G0?ofkP030=@m6@3om^h0ooK^00/0ooK^0`3D?AT50?ofkP030=@m6@3om^h0ooK^
00d0ooK^00<0e3dI0?ofkP0000000P3om^h0103D?AT0ooK^0?ofkP3om^h30=@m6@X0ooK^0`3D?AT0
0`3om^h0e3dI0=@m6@0C0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0000000621400P000000
100:3b<0000000X?8`0:3b<2000000<0e3dI0P0?5SH00`0000003aHf0000000301TSD@030000000I
8e40e3dI00<06B=A00<0000001TSD@0000000`0R<Vd00`0000008S9]028bK@03028bK@040000000R
<Vd08S9]00000080:Sj300<000000?U67@3iAQd00`3iAQd2000000030?9370000000lT<L00<0lT<L
00<0?EV[0?93703b@a`00P3b@a`00`0mFJ/0lT<L0?9370060?9370030000003b@a`0lT<L00L0lT<L
00D0?EV[0?93703b@a`0lT<L03eIZ`04000000030>U06P000000jD0J00P0jD0J00<000000>U06P3Y
@1X00`3Y@1X01@0mFJ/0jD0J0>U06P3Y@1X000000080jD0J00@0?EV[0>U06P3Y@1X0jD0J0P000000
0`3L?1P000000=`l60080=`l60040000003L?1P0g3`H03eIZ`H0g3`H00<000000=`l603L?1P00P3L
?1P3000000040<Xf5P0mFJ/0?EV[0<Xf5P<000000`3:=QH00`000000bSHF0<Xf5P050<Xf5P030000
003:=QH00000008000000`2_;Q820=@m6@<0ooK^0`3D?AT00`0mFJ/0ooK^0?ofkP030=@m6@040?of
kP0mFJ/0?EV[0?ofkP@0e3dI00<0?EV[0?ofkP3om^h00P3om^h20=@m6@80?EV[00D0ooK^0000003o
m^h0ooK^03eIZ`040?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h0D03om^h00`00
0000ooK^0?ofkP0?0?ofkP40oooo000i0?ofkP030000003om^h0ooK^01L0ooK^00<0e3dI0?ofkP3o
m^h03`3om^h30=@m6@030?ofkP3D?AT0ooK^00h0ooK^00@0e3dI0?ofkP3om^h000000P3om^h00`3D
?AT0ooK^0?ofkP040?ofkP<0e3dI2P3om^h30=@m6A<0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D
?AT0000000H84@02000000802PlS00D0000000X?8`0000003aHf0000000300lF=P<0e3dI00<03aHf
0000000I8e400P0I8e400`0000006B=A0=@m6@0301TSD@800000100R<Vd00`0000008S9]028bK@04
028bK@030000000R<Vd0000000<0:Sj300<000000?U67@3iAQd0103iAQd300000080lT<L00<0?EV[
0?93703b@a`00`3b@a`00`000000?EV[0?9370060?9370030000003b@a`0lT<L00H0lT<L00<0?EV[
0000003b@a`00`3b@a`0100mFJ/0lT<L0?93703b@a`3000000P0jD0J00<000000>U06P3Y@1X00P3Y
@1X00`0mFJ/0jD0J0>U06P020>U06P050000003Y@1X0jD0J0>U06P0mFJ/0103Y@1X3000000P0g3`H
00<000000=`l600mFJ/01`3L?1P00`000000g3`H0=`l60050=`l60<000000P0mFJ/20<Xf5P800000
00<0bSHF0000003:=QH01P3:=QH00`000000bSHF0<Xf5P020<Xf5P@0000000<0ooK^0=@m6@3D?AT0
0`3om^h0103D?AT0?EV[0=@m6@3D?AT30?ofkP0303eIZ`3om^h0ooK^00@0ooK^0P3D?AT00`0mFJ/0
e3dI0?ofkP020?ofkP0403eIZ`3D?AT0e3dI0=@m6@<0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`04
0?ofkP0303eIZ`3om^h0ooK^0540ooK^00<000000?ofkP3om^h03`3om^h10?ooo`00>@3om^h00`00
0000ooK^0?ofkP0G0?ofkP030=@m6@3om^h0ooK^0180ooK^0`3D?AT>0?ofkP030=@m6@3om^h00000
00<0ooK^00<0e3dI0?ofkP3om^h01`3om^h30=@m6@P0ooK^00<0e3dI0?ofkP3D?AT00P3D?AT@0?of
kP090=@m6@3om^h0ooK^0?ofkP000000e3dI03eIZ`062140000000<02PlS0P00000200lF=P030000
000?5SH03aHf00<03aHf00<000000=@m6@3D?AT00`0I8e400`0000006B=A0=@m6@0301TSD@030000
000R<Vd08S9]00<08S9]00<00000028bK@0R<Vd0100R<Vd2000000@0:Sj300<000000?U67@3iAQd0
1@3iAQd01@000000nDHM0000000mFJ/0000000D0lT<L00<000000?93700mFJ/01P3b@a`00`000000
lT<L0?9370050?93700303eIZ`3b@a`0000000D0lT<L00H0?EV[0?93703b@a`0lT<L0000003b@a`2
000000H0jD0J00D000000>U06P3Y@1X0jD0J03eIZ`050>U06P030000003Y@1X0jD0J0080jD0J00<0
?EV[0>U06P3Y@1X00P3Y@1X00`000000jD0J00000002000000D0g3`H00<0000003eIZ`3L?1P01`3L
?1P00`000000g3`H0=`l60060=`l60040000003L?1P0000000000080?EV[0P3:=QH3000000L0bSHF
00<000000<Xf5P3:=QH0103:=QH200000080ooK^0P3D?AT00`3om^h0e3dI03eIZ`020?ofkP80e3dI
00<0?EV[0?ofkP3om^h01P3om^h00`3D?AT0?EV[0=@m6@020=@m6@0403eIZ`3om^h0ooK^000000@0
e3dI00@0?EV[0?ofkP0mFJ/0?EV[103om^h00`0mFJ/0ooK^0?ofkP1B0?ofkP030000003om^h0ooK^
00l0ooK^0@3oool003P0ooK^0P00000I0?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3D
?AT00P3D?AT;0?ofkP030=@m6@000000ooK^00<0ooK^00<0e3dI0?ofkP3om^h02P3om^h30=@m6@@0
ooK^0P3D?AT40?ofkP<0e3dI303om^h0103D?AT0ooK^0?ofkP3om^h2000000040=@m6@0621400000
000000802PlS00<0000000X?8`0000000P0?5SH00`0000003aHf00lF=P0300lF=P030000000I8e40
6B=A00<0e3dI00<000000=@m6@0I8e400P0I8e42000000D08S9]00<00000028bK@0R<Vd0100R<Vd0
0`000000:Sj302XnP`0302XnP`030000003iAQd0nDHM00D0nDHM00<000000?U67@0mFJ/00P3iAQd4
000000040?9370000000lT<L03eIZ`H0lT<L00<000000?93703b@a`0103b@a`0100mFJ/0lT<L0?93
700000060?93700403eIZ`3b@a`0lT<L000000<0lT<L0`0000030>U06P040000003Y@1X0jD0J03eI
Z`H0jD0J00<000000>U06P3Y@1X00`3Y@1X203eIZ`80jD0J00<000000>U06P3Y@1X00P3Y@1X40000
00030=`l600mFJ/0g3`H00P0g3`H00<000000=`l603L?1P01P3L?1P010000000g3`H0=`l603L?1P2
00000080?EV[0P3:=QH4000000@0bSHF00<000000<Xf5P3:=QH01@3:=QH010000000ooK^0?ofkP3o
m^h30=@m6@0503eIZ`3om^h0ooK^0?ofkP0mFJ/00`3D?AT70?ofkP0403eIZ`3om^h0ooK^03eIZ`<0
e3dI0`3om^h0103D?AT0?EV[0=@m6@0mFJ/40?ofkP80?EV[EP3om^h00`000000ooK^0?ofkP0>0?of
kP40oooo000h0?ofkP030000003om^h00000008000005P3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP03
0=@m6@3om^h0ooK^0080ooK^0`3D?AT70?ofkP030=@m6@000000ooK^00<0ooK^00<0e3dI0?ofkP3o
m^h03P3om^h30=@m6@030?ofkP3D?AT0ooK^00L0ooK^103D?AT80?ofkP030=@m6@3om^h0ooK^0080
000000D0e3dI03eIZ`0000002PlS0000000200X?8`8000000`0?5SH00`0000003aHf00lF=P0200lF
=P8000001@0I8e430=@m6@0401TSD@0000008S9]000000D08S9]00<00000028bK@0R<Vd00`0R<Vd2
000000D0:Sj300<000000?U67@3iAQd01@3iAQd00`000000nDHM03eIZ`060?U67@<0000000<0lT<L
03eIZ`3b@a`0103b@a`00`000000lT<L0?9370030?93700503eIZ`3b@a`0lT<L0?93700000001`3b
@a`00`0mFJ/0lT<L000000060?937080000000@0jD0J0000003Y@1X0?EV[1`3Y@1X00`000000jD0J
0>U06P050>U06P0303eIZ`3Y@1X0000000P0jD0J00<0?EV[000000000000203L?1P00`000000g3`H
0=`l60060=`l60030000003L?1P0g3`H0080g3`H00<0?EV[0=`l600000000P0mFJ/010000000bSHF
0<Xf5P3:=QH200000080bSHF00<000000<Xf5P3:=QH01@3:=QH010000000ooK^0=@m6@3D?AT30?of
kP040=@m6@0mFJ/0e3dI03eIZ`@0ooK^0P3D?AT50?ofkP0303eIZ`3om^h0?EV[0080ooK^103D?AT2
0?ofkP80?EV[00@0ooK^0=@m6@3D?AT0e3dI0P0mFJ]G0?ofkP030000003om^h0ooK^00h0ooK^0@3o
ool003P0ooK^00<000000?ofkP3om^h00P3om^h300000180ooK^00<0e3dI0?ofkP3om^h04`3om^h0
0`3D?AT0ooK^0?ofkP060?ofkP80e3dI1@3om^h00`3D?AT000000?ofkP030?ofkP030=@m6@3om^h0
ooK^0140ooK^0`3D?AT;0?ofkP<0e3dI1@3om^h02@3D?AT0ooK^0?ofkP0000001PPA0=@m6@000000
2PlS0000000300X?8`030000000?5SH03aHf00<03aHf00H0000000lF=P0?5SH0000001TSD@000005
01TSD@030000003D?AT06B=A00<0e3dI00<00000028bK@0R<Vd00`0R<Vd00`0000008S9]028bK@02
028bK@030000000Z?X<0000000D0:Sj300<0000003eIZ`3iAQd01P3iAQd00`0mFJ/0nDHM0?U67@06
0?U67@050000003iAQd000000000000mFJ/0103b@a`00`000000lT<L0?9370020?93700303eIZ`3b
@a`0lT<L0080lT<L00<000000?93703b@a`01P3b@a`00`0mFJ/000000?9370070?937080000000<0
?EV[0>U06P3Y@1X01P3Y@1X00`000000jD0J0>U06P060>U06P0303eIZ`000000jD0J00H0jD0J00@0
?EV[0>U06P000000jD0J0P0000060=`l60030000003L?1P0g3`H00H0g3`H00D000000=`l603L?1P0
g3`H03eIZ`040=`l60040=@m6@0mFJ/0?EV[03eIZ`<0bSHF0`0000080<Xf5P030000003om^h0ooK^
00@0ooK^0P0mFJ/30=@m6@@0ooK^0`3D?AT20?ofkP80?EV[00<0ooK^0000000000000P3om^h40=@m
6@0303eIZ`3D?AT0e3dI0080e3dI00@0?EV[0=@m6@3D?AT0e3dIEP3om^h00`000000ooK^0?ofkP0>
0?ofkP40oooo000g0?ofkP030000003om^h0ooK^00H0ooK^0`00000?0?ofkP030=@m6@3om^h0ooK^
01<0ooK^00<0e3dI0?ofkP3om^h0203om^h30=@m6@030?ofkP3D?AT0000000D0ooK^00<0e3dI0?of
kP3om^h04P3om^h00`3D?AT0ooK^0=@m6@020=@m6@/0ooK^0`3D?AT0103om^h0e3dI0?ofkP3om^h2
000000050=@m6@0mFJ/0000000X?8`0000000P0:3b<2000000D03aHf00<0000000lF=P0000000P0I
8e400`0000006B=A01TSD@0301TSD@040=@m6@0000006B=A000000808S9]0`3D?AT4028bK@040000
000R<Vd08S9]000000<0:Sj300<0000002XnP`0Z?X<00P0Z?X<00`3D?AT0nDHM03eIZ`050?U67@03
03eIZ`000000nDHM00L0nDHM00D000000?U67@3iAQd0nDHM03eIZ`03000000030?9370000000lT<L
0080lT<L00<0?EV[0?93703b@a`00`3b@a`00`000000lT<L0?9370070?93700303eIZ`3b@a`0lT<L
00L0lT<L00@0?EV[0?937000000000001@3Y@1X00`000000jD0J0>U06P080>U06P0303eIZ`3Y@1X0
jD0J00@0jD0J00@0?EV[0>U06P3Y@1X000000`3Y@1X3000000<0g3`H00<000000=`l603L?1P01P3L
?1P010000000g3`H0=`l600mFJ/60=`l60030000003L?1P0000000<0?EV[0`3:=QH3000000D0bSHF
00<000000?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP020?ofkP<0e3dI103om^h20=@m6@0403eI
Z`3D?AT000000?ofkP@0e3dI0P3om^h0100mFJ/0e3dI0?ofkP3D?AT203eIZ`<0ooK^0`3D?AUD0?of
kP030000003om^h0ooK^00h0ooK^0@3oool003L0ooK^00<000000?ofkP3om^h02@3om^h3000000`0
ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@000000e3dI00D0
ooK^00<0e3dI0?ofkP3om^h04@3om^h00`3D?AT0ooK^0?ofkP030?ofkP<0e3dI2`3om^h20=@m6@06
0?ofkP000000000000H84@3D?AT000000P0:3b<01@0000002PlS0000000?5SH0000000D03aHf00<0
000000lF=P0000000P0I8e400`0000006B=A01TSD@0301TSD@030=@m6@000000000000@08S9]00<0
0000028bK@3D?AT00P3D?AT0100R<Vd00000028bK@00000402XnP`030000000Z?X<0:Sj30080:Sj3
00<0e3dI0?U67@0mFJ/0103iAQd00`0mFJ/0nDHM000000080?U67@030000003iAQd0nDHM0080nDHM
00<0?EV[0?U67@3iAQd00`0000000`3b@a`0?EV[0?9370050?9370030000003b@a`0lT<L00L0lT<L
00<0000003eIZ`3b@a`01P3b@a`00`0mFJ/000000?9370020?93708000000`3Y@1X00`000000jD0J
0>U06P070>U06P040000003Y@1X0?EV[03eIZ`<0jD0J00@0?EV[0>U06P3Y@1X000001`3Y@1X20000
00030=`l60000000g3`H00L0g3`H00<000000=`l600mFJ/01`3L?1P00`000000g3`H0=`l60020=`l
60050000000mFJ/0?EV[0<Xf5P0000000P3:=QH2000000<0bSHF00<000000=@m6@3om^h00`3om^h2
03eIZ`030=@m6@3om^h0ooK^00@0ooK^0P3D?AT30?ofkP80?EV[0`3D?AT50?ofkP80?EV[00@0ooK^
03eIZ`0mFJ/0?EV[1`3om^h30=@m6E40ooK^00<000000?ofkP3om^h03P3om^h10?ooo`00=`3om^h0
0`000000ooK^0?ofkP0<0?ofkP<000002@3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0
ooK^00/0ooK^00<0e3dI0000003om^h00`3D?AT00`3om^h0e3dI0?ofkP0C0?ofkP030=@m6@3om^h0
ooK^00H0ooK^0`3D?AT90?ofkP060=@m6@0000000000000000062140e3dI0`0:3b<2000000803aHf
00<0000000lF=P0?5SH00`0?5SH2000000<06B=A00<0000001TSD@0I8e400`0I8e400`3D?AT00000
028bK@04028bK@030000000R<Vd08S9]00808S9]103D?AT402XnP`060000000Z?X<0:Sj302XnP`3D
?AT000000P3iAQd0100mFJ/0nDHM0?U67@0mFJ/20?U67@030000003iAQd0nDHM00H0nDHM00<00000
0?U67@3iAQd00`3iAQd01`0mFJ/0nDHM0?U67@000000nDHM03eIZ`0000001P3b@a`00`000000lT<L
0?9370060?9370040000003b@a`0lT<L03eIZ`D0lT<L00<0?EV[0000003b@a`01@3b@a`200000003
0>U06P000000jD0J00P0jD0J00L000000>U06P3Y@1X0jD0J03eIZ`3Y@1X0?EV[00<0jD0J00<00000
0>U06P3Y@1X01`3Y@1X3000000L0g3`H00<0000003eIZ`3L?1P01`3L?1P00`000000g3`H0=`l6005
0=`l60<0?EV[0`3:=QH4000000080?ofkP3D?AT0e3dI0=@m6@0mFJ/0ooK^03eIZ`3D?AT80?ofkP80
e3dI0P0mFJ/00`3D?AT0ooK^0=@m6@040?ofkPL0?EV[0`3D?AT80?ofkP80e3dID03om^h00`000000
ooK^0?ofkP0=0?ofkP40oooo000g0?ofkP030000003om^h0ooK^00l0ooK^100000040?ofkP030=@m
6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h0303om^h00`000000ooK^0?ofkP030?ofkP<0e3dI
4P3om^h20=@m6@/0ooK^0P3D?AT60?ofkP070=@m6@000000000000H84@000000e3dI0000000200X?
8`030000000:3b<0000000803aHf00<0000000lF=P0?5SH00`0?5SH00`0000006B=A01TSD@0301TS
D@050000000I8e406B=A01TSD@3D?AT00P000005028bK@030000000R<Vd08S9]00<08S9]00<00000
02XnP`0Z?X<00`3D?AT00`0Z?X<0000002XnP`0202XnP`070=@m6@0Z?X<000000?U67@0mFJ/0nDHM
03eIZ`030?U67@030000003iAQd0nDHM00H0nDHM00<000000?U67@3iAQd0103iAQd0100mFJ/0nDHM
0000000mFJ/20?U67@<000000`3b@a`00`000000lT<L0?9370060?9370050000003b@a`0lT<L0?93
700mFJ/00`3b@a`00`0mFJ/0lT<L000000080?9370<00000203Y@1X00`000000jD0J0>U06P020>U0
6P0303eIZ`3Y@1X0jD0J0080jD0J00<000000>U06P3Y@1X0203Y@1X00`000000jD0J000000020000
00@0g3`H00<0?EV[0=`l603L?1P01`3L?1P00`000000g3`H0=`l60060=`l60030000003L?1P0?EV[
00<0?EV[0P3:=QH200000080ooK^00D0?EV[0=@m6@3D?AT0?EV[0=@m6@080?ofkP80?EV[00H0e3dI
03eIZ`3D?AT0e3dI0?ofkP3D?AT20?ofkP@0?EV[00<0ooK^03eIZ`0mFJ/00`3om^h40=@m6@L0ooK^
00<0e3dI0?ofkP3om^h0C@3om^h00`000000ooK^0?ofkP0=0?ofkP40oooo000g0?ofkP030000003o
m^h0ooK^01<0ooK^0`0000000`3om^h0e3dI0=@m6@0D0?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0
00000=@m6@3om^h01@3om^h00`3D?AT0ooK^0=@m6@020=@m6@l0ooK^00<0e3dI0?ofkP3om^h0303o
m^h30=@m6@<0ooK^00L0e3dI000000062140000000H84@3D?AT0000000802PlS0P00000300lF=P03
0000000?5SH03aHf00803aHf0P00000501TSD@070000000I8e406B=A01TSD@3D?AT08S9]00000005
028bK@030000000R<Vd08S9]00808S9]0P00000502XnP`<0e3dI00D0:Sj30=@m6@0Z?X<0:Sj30000
00020?U67@0303eIZ`3iAQd0nDHM0080nDHM00<000000?U67@3iAQd01P3iAQd00`000000nDHM0?U6
7@040?U67@0303eIZ`3iAQd0?EV[00H0nDHM0P0000000`3b@a`000000?9370070?9370030000003b
@a`0lT<L0080lT<L00<0?EV[0?93700mFJ/00P3b@a`00`000000lT<L0?9370070?9370030000003b
@a`00000008000001@3Y@1X01P000000jD0J0>U06P3Y@1X0?EV[0>U06P80?EV[0P3Y@1X00`000000
jD0J0>U06P080>U06P030000003Y@1X0jD0J0080jD0J0P00000203eIZ`030000003L?1P0g3`H00H0
g3`H00<000000=`l603L?1P01`3L?1P010000000g3`H03eIZ`3L?1P2000000@0?EV[0`0000020?of
kP0303eIZ`3D?AT0e3dI00H0ooK^00D0?EV[0=@m6@3D?AT0000003eIZ`020?ofkP80e3dI0`0mFJ/0
0`3om^h0?EV[0?ofkP0203eIZ`@0ooK^00@0e3dI0?ofkP3om^h0ooK^0`3D?AT50?ofkP030=@m6@3o
m^h0ooK^04`0ooK^00<000000?ofkP3om^h03@3om^h10?ooo`00=P3om^h00`000000ooK^0?ofkP0G
0?ofkP030000003D?AT0000000@0e3dI403om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030000003D?AT0
ooK^00H0ooK^00<0e3dI0?ofkP3om^h00P3om^h30=@m6@`0ooK^00<0e3dI0?ofkP3om^h03`3om^h3
0=@m6@80000000D01PPA000000000000e3dI0000000200X?8`030000000?5SH03aHf00<03aHf00H0
000000lF=P0?5SH0000001TSD@00000501TSD@050000000I8e406B=A0000003D?AT00P0R<Vd00`00
00008S9]028bK@02028bK@050000000R<Vd08S9]028bK@0000000P0Z?X<00`000000:Sj302XnP`04
02XnP`0:0000003D?AT0e3dI0=@m6@0Z?X<000000?U67@0mFJ/0nDHM03eIZ`<0nDHM00<000000?U6
7@3iAQd01P3iAQd00`000000nDHM0?U67@050?U67@0303eIZ`000000nDHM00L0nDHM0`0000070?93
70030000003b@a`0lT<L00<0lT<L00D0?EV[0?93703b@a`0lT<L000000090?9370030000003b@a`0
lT<L0080lT<L100000001@3Y@1X000000>U06P3Y@1X0?EV[00@0jD0J0P0mFJ/00`000000jD0J0>U0
6P070>U06P030000003Y@1X0jD0J00@0jD0J00<0?EV[0>U06P0000000P0000070=`l60030000003L
?1P0g3`H00L0g3`H00<0000003eIZ`3L?1P00`3L?1P2000000030<Xf5P000000?EV[0080?EV[0`00
00000`3D?AT0ooK^0=@m6@020=@m6@80ooK^00<0?EV[0=@m6@0mFJ/0200mFJ/20=@m6@040?ofkP0m
FJ/0?EV[03eIZ`H0ooK^00<0e3dI0?ofkP3om^h00`3om^h20=@m6@@0ooK^00<0e3dI0?ofkP3om^h0
B`3om^h00`000000ooK^0?ofkP0=0?ofkP40oooo000f0?ofkP030000003om^h0ooK^01P0ooK^00<0
e3dI0?ofkP0000000P000000103om^h0e3dI0=@m6@3D?AT=0?ofkP030=@m6@3om^h0ooK^00X0ooK^
00<000000=@m6@3om^h01@3om^h00`3D?AT0ooK^0?ofkP060?ofkP@0e3dI1`3om^h20=@m6A<0ooK^
00T000000=@m6@3D?AT0e3dI0000003D?AT02PlS0000000:3b<00P00000500lF=P0303eIZ`0?5SH0
000000806B=A00<0000001TSD@0I8e400`0I8e40100000006B=A0000003D?AT3028bK@030000000R
<Vd08S9]00<08S9]00<00000028bK@0000000`0Z?X<00`000000:Sj302XnP`0402XnP`040000000Z
?X<0e3dI02XnP`80e3dI00@0?EV[0?U67@3iAQd0?EV[103iAQd00`000000nDHM0?U67@060?U67@03
0000003iAQd0nDHM00<0nDHM00<0?EV[0?U67@0mFJ/02@3iAQd00`000000nDHM00000002000000@0
lT<L00<000000?93703b@a`00P3b@a`01P0mFJ/0lT<L03eIZ`0mFJ/0lT<L000000P0lT<L00<00000
0?93703b@a`01`3b@a`30000000303eIZ`3Y@1X0jD0J00D0jD0J0P0mFJ/80>U06P030000003Y@1X0
jD0J00<0jD0J00H0?EV[0>U06P3Y@1X0jD0J0000003Y@1X2000000D0g3`H00<000000=`l603L?1P0
1`3L?1P00`0mFJ/0g3`H0=`l60050=`l6080000000<0e3dI0?ofkP3om^h00P3om^h00`0mFJ/00000
0000000703eIZ`030000003om^h0?EV[0080ooK^00<0?EV[0?ofkP0mFJ/00`3om^h203eIZ`030=@m
6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h01@3om^h30=@m6@80ooK^00<0e3dI0?ofkP3om^h0
B`3om^h00`000000ooK^0?ofkP0<0?ofkP40oooo000f0?ofkP030000003om^h0ooK^01P0ooK^00<0
e3dI0?ofkP3om^h00P3om^h3000000030?ofkP3D?AT0e3dI0080e3dI2@3om^h00`3D?AT0ooK^0?of
kP090?ofkP030000003D?AT0ooK^00H0ooK^00<0e3dI0?ofkP3om^h02P3om^h30=@m6@@0ooK^0P3D
?ATB0?ofkP<0000000<01PPA0000003D?AT00P3D?AT0100mFJ/02PlS00000000000500lF=P0303eI
Z`0?5SH0000000806B=A00<0000001TSD@0I8e400`0I8e420000000303eIZ`3D?AT08S9]00808S9]
00<00000028bK@0R<Vd00`0R<Vd00`0000008S9]0000000302XnP`030000000Z?X<0:Sj300@0:Sj3
00@000000=@m6@0Z?X<0:Sj30P0000001@3nB1h00000000000000000?EV[00<0nDHM00<000000?U6
7@3iAQd01P3iAQd00`000000nDHM0?U67@020?U67@0503eIZ`3iAQd0nDHM0000000mFJ/0203iAQd0
0`000000nDHM0?U67@020?U67@<0000000<0lT<L0000003b@a`00P3b@a`00`0mFJ/0lT<L0?937002
0?93700303eIZ`000000lT<L00L0lT<L00<000000?93703b@a`0203b@a`00`000000?EV[00000002
000000@0jD0J00<000000>U06P3Y@1X00P0mFJ/60>U06P030000003Y@1X0jD0J0080jD0J00<0?EV[
0>U06P3Y@1X00P3Y@1X010000000jD0J0>U06P3Y@1X2000000<0g3`H00<000000=`l603L?1P01P3L
?1P00`0mFJ/000000=`l60070=`l60040000003om^h0e3dI0=@m6@80ooK^00<0?EV[0?ofkP0mFJ/0
0`0000000`0mFJ/0ooK^000000030?ofkP0703eIZ`3om^h0?EV[0?ofkP0mFJ/0ooK^0=@m6@020?of
kP0303eIZ`3om^h0ooK^0080e3dI1P3om^h00`3D?AT0ooK^0?ofkP070?ofkP@0e3dIC03om^h00`00
0000ooK^0?ofkP0<0?ofkP40oooo000f0?ofkP030000003om^h0ooK^01L0ooK^00<0e3dI0?ofkP3o
m^h01P3om^h300000080ooK^0`3D?AT50?ofkP030=@m6@3om^h0ooK^00T0ooK^00@000000?ofkP3D
?AT0e3dI1P3om^h00`3D?AT0ooK^0?ofkP0=0?ofkPD0e3dI4P3om^h3000000801PPA00@0000000X?
8`3D?AT000000`3D?AT00`0000003aHf00lF=P0300lF=P8000000`0I8e400`0000006B=A01TSD@03
01TSD@030000000R<Vd0e3dI00@08S9]00<00000028bK@0R<Vd00`0R<Vd2000000@0:Sj300<00000
02XnP`0Z?X<0100Z?X<010000000e3dI02XnP`0Z?X<2000000@0oTPN00D0000003eIZ`000000nDHM
000000080?U67@050000003iAQd0nDHM0?U67@0mFJ/00`3iAQd00`000000nDHM03eIZ`070?U67@03
0000003iAQd0nDHM00D0nDHM0`0000000`3b@a`0?EV[0?9370040?9370030000000mFJ/0lT<L00L0
lT<L00<000000?93703b@a`01`3b@a`00`000000?EV[0?9370030?9370<0000000<0jD0J0000003Y
@1X00`3Y@1X203eIZ`@0jD0J00D000000>U06P3Y@1X0jD0J03eIZ`040>U06P030000003Y@1X0jD0J
00@0jD0J0P0000000`3L?1P000000=`l60060=`l600303eIZ`3L?1P0000000@0g3`H00D0?EV[0=`l
603L?1P0g3`H000000030?ofkP80e3dI0P0mFJ/0103D?AT0ooK^0?ofkP0mFJ/3000000<0ooK^100m
FJ/20?ofkP030=@m6@0mFJ/0?EV[00D0ooK^0P3D?AT40?ofkP030=@m6@3om^h0ooK^00X0ooK^0P3D
?AU;0?ofkP030000003om^h0ooK^00`0ooK^0@3oool003H0ooK^00<000000?ofkP3om^h05`3om^h0
0`3D?AT0ooK^0?ofkP090?ofkP<000000P3om^h40=@m6@030?ofkP3D?AT0ooK^00T0ooK^00D00000
0?ofkP3om^h0e3dI0?ofkP030=@m6@<0ooK^00<0e3dI0?ofkP3om^h0403om^h30=@m6A40ooK^00@0
1PPA0000000000001PPA0P000000103D?AT02PlS03eIZ`00000200lF=P80e3dI100?5SH00`000000
6B=A01TSD@0301TSD@040000000I8e406B=A01TSD@80000000<08S9]0=@m6@0R<Vd0100R<Vd00`00
00008S9]028bK@02028bK@030000000Z?X<0:Sj300@0:Sj300<0000002XnP`0Z?X<00`0Z?X<01000
0000e3dI02XnP`0000020358U@030000003nB1h0oTPN0080oTPN00<0?EV[0?i87P0000000P000007
0?U67@050000003iAQd0nDHM0?U67@0mFJ/00`3iAQd010000000nDHM0?U67@0mFJ/60?U67@030000
003iAQd0nDHM00H0nDHM00<000000?U67@0mFJ/00P0000040?9370040000003b@a`0?EV[03eIZ`H0
lT<L00<000000?93703b@a`01`3b@a`00`0mFJ/0lT<L0?9370060?9370<000001@3Y@1X203eIZ`80
jD0J00@000000>U06P3Y@1X0?EV[1@3Y@1X00`000000jD0J0>U06P060>U06P<000001@3L?1P0100m
FJ/0g3`H0=`l600000030=`l600303eIZ`3L?1P0g3`H0080g3`H00<000000?ofkP3om^h00`3om^h0
0`0mFJ/0e3dI0=@m6@0203eIZ`040?ofkP000000ooK^0?ofkP80000000<0ooK^03eIZ`0mFJ/0103o
m^h203eIZ`P0ooK^0`3D?AT20?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h0B03o
m^h00`000000ooK^0?ofkP0<0?ofkP40oooo000f0?ofkP030000003om^h0ooK^01L0ooK^00<0e3dI
0?ofkP3om^h0303om^h3000000<0ooK^0`3D?AT90?ofkP030000003om^h0e3dI00D0ooK^0`3D?ATB
0?ofkP040=@m6@3om^h0e3dI0?ofkP<0e3dI3@3om^h02`0621400000000000062140000000X?8`00
0000e3dI00X?8`0mFJ/0000000803aHf00<0000000lF=P3D?AT00P3D?AT2000000D06B=A00@00000
01TSD@0I8e4000000P0R<Vd00`000000e3dI028bK@04028bK@040000000R<Vd08S9]028bK@800000
1P0Z?X<00`000000:Sj302XnP`0302XnP`030=@m6@000000000000<0<DRE00<000000?i87P3nB1h0
0`3nB1h0100mFJ/0oTPN0000003nB1h3000000@0nDHM00@000000?U67@3iAQd0?EV[103iAQd01@00
0000nDHM0?U67@3iAQd0?EV[00D0nDHM00<000000?U67@3iAQd01P3iAQd00`000000?EV[0?U67@02
0?U67@<0000000<0lT<L0000003b@a`00P3b@a`00`0mFJ/0lT<L0?9370030?9370030000003b@a`0
lT<L00D0lT<L0P0mFJ/00`000000lT<L0?9370070?9370040000003b@a`00000000000D0jD0J0P0m
FJ/00`000000jD0J03eIZ`060>U06P030000003Y@1X0jD0J00L0jD0J00<000000>U06P0000000P00
000203eIZ`<0g3`H00<000000=`l603L?1P01P3L?1P00`000000ooK^0?ofkP020?ofkP80?EV[00<0
ooK^03eIZ`3D?AT00P3D?AT50?ofkP<000000`3om^h203eIZ``0ooK^0`3D?AT=0?ofkP030=@m6@3o
m^h0ooK^04T0ooK^00<000000?ofkP3om^h02`3om^h10?ooo`00=@3om^h00`000000ooK^0?ofkP0H
0?ofkP030=@m6@3om^h0ooK^00l0ooK^0`0000000`3om^h0e3dI0?ofkP030=@m6@D0ooK^00@00000
0?ofkP3om^h0e3dI1`3om^h40=@m6@l0ooK^00<0e3dI0?ofkP3D?AT0103om^h20=@m6@X0ooK^0`00
00001@0mFJ/0000000X?8`000000e3dI00802PlS00<0000000lF=P0?5SH00P0?5SH0100000003aHf
00lF=P0000030=@m6@@06B=A00<0000001TSD@0000000`0R<Vd00`3D?AT08S9]028bK@04028bK@04
0000000R<Vd08S9]00000080:Sj300<0000002XnP`0Z?X<00`0Z?X<00`000000:Sj302XnP`0302Xn
P`030=@m6@000000000000<0<DRE00<000000?i87P3nB1h0103nB1h00`0mFJ/000000?i87P030?i8
7P<0000000@0nDHM0000003iAQd0?EV[1@3iAQd00`000000nDHM0?U67@020?U67@0303eIZ`3iAQd0
nDHM0080nDHM00<000000?U67@3iAQd01P3iAQd00`0mFJ/0nDHM0?U67@050?U67@<000000`3b@a`0
0`0mFJ/0lT<L0?9370020?9370030000003b@a`0lT<L00@0lT<L00@0?EV[0?93703b@a`00000203b
@a`00`000000lT<L0?9370020?9370<000000`3Y@1X010000000?EV[03eIZ`0mFJ/60>U06P030000
003Y@1X0jD0J00L0jD0J00D000000>U06P3Y@1X0jD0J03eIZ`04000000030=`l60000000g3`H00L0
g3`H00H000000?ofkP3om^h0ooK^03eIZ`3om^h203eIZ`040=@m6@3om^h000000?ofkP<0e3dI00<0
ooK^03eIZ`0mFJ/00P3om^h30000000303eIZ`3om^h0e3dI00d0ooK^0`3D?AT<0?ofkP030=@m6@3o
m^h0ooK^04P0ooK^00<000000?ofkP3om^h02`3om^h10?ooo`00=@3om^h00`000000ooK^0?ofkP0H
0?ofkP030=@m6@3om^h0ooK^0180ooK^00<000000=@m6@0000000`3om^h30=@m6@050?ofkP000000
ooK^0?ofkP3D?AT0203om^h0103D?AT0ooK^0?ofkP3om^h30=@m6@`0ooK^0P3D?AT70?ofkP<0e3dI
1P3om^h5000000802PlS00<000000=@m6@0:3b<00P00000400lF=P030000000?5SH0000000<06B=A
00P000000=@m6@3D?AT0e3dI01TSD@0000006B=A000000<08S9]00<0e3dI028bK@0R<Vd0100R<Vd0
100000008S9]028bK@00000202XnP`030000000Z?X<0:Sj300@0:Sj300<0000002XnP`0Z?X<00P0Z
?X<00`3D?AT000000358U@030358U@030000003nB1h0oTPN00@0oTPN00<0?EV[0000003nB1h01P3n
B1h20000000303eIZ`3iAQd0nDHM00@0nDHM00<000000?U67@3iAQd00P3iAQd01@0mFJ/0nDHM0?U6
7@3iAQd0000000P0nDHM00<0?EV[0?U67@3iAQd01`3iAQd010000000nDHM0000000000020?937080
?EV[00<0lT<L0000003b@a`01@3b@a`0100mFJ/0lT<L0?93700000090?9370030000003b@a`0lT<L
00D0lT<L0P0000000`3Y@1X0000003eIZ`020>U06P80?EV[103Y@1X00`000000jD0J0>U06P060>U0
6P050000003Y@1X0jD0J0>U06P0mFJ/01@3Y@1X3000000L0g3`H00@000000?ofkP3om^h0?EV[0P3o
m^h0100mFJ/0ooK^0=@m6@0000040?ofkP<0?EV[103om^h203eIZ`80000000<0e3dI0?ofkP3om^h0
303om^h00`3D?AT0ooK^0=@m6@020=@m6@T0ooK^00<0e3dI0?ofkP3om^h0B03om^h00`000000ooK^
0?ofkP0;0?ofkP40oooo000e0?ofkP030000003om^h0ooK^01P0ooK^00<0e3dI0?ofkP3om^h04P3o
m^h00`3D?AT0ooK^0?ofkP03000000<0ooK^00D0e3dI0000003om^h0ooK^0=@m6@080?ofkP030=@m
6@3om^h0ooK^00@0ooK^0`3D?AT80?ofkP030=@m6@3om^h0e3dI00X0ooK^0`3D?AT20?ofkP800000
00<01PPA0000000000000`0:3b<01@3D?AT02PlS0000000?5SH0000000@03aHf00<0000000lF=P00
00000`0I8e40100000006B=A01TSD@0I8e420=@m6@030000000R<Vd08S9]00808S9]00<0e3dI0000
000R<Vd01@0R<Vd2000000<0:Sj300<0000002XnP`0Z?X<0100Z?X<01@000000:Sj302XnP`0Z?X<0
e3dI008000001@0aB9D00`000000oTPN0?i87P040?i87P0303eIZ`000000oTPN00H0oTPN00@0?EV[
0?i87P0000000000103iAQd00`000000nDHM0?U67@030?U67@0403eIZ`3iAQd0nDHM000000P0nDHM
00<0?EV[0?U67@3iAQd01`3iAQd010000000nDHM0?U67@3iAQd200000080lT<L00<0?EV[0000003b
@a`0103b@a`01@0mFJ/0lT<L0?93703b@a`0000000T0lT<L00<000000?93703b@a`01`3b@a`00`00
0000?EV[000000040>U06P<0?EV[00<0jD0J0000003Y@1X01`3Y@1X010000000jD0J0>U06P0mFJ/7
0>U06P040000003Y@1X00000000000D0g3`H00<0000003eIZ`0mFJ/00P3om^h203eIZ`030000003D
?AT0ooK^00<0ooK^00@0?EV[0?ofkP0mFJ/0?EV[0`3D?AT00`0mFJ/0ooK^0?ofkP020?ofkP<00000
303om^h00`3D?AT0ooK^0?ofkP020?ofkP<0e3dI1`3om^h00`3D?AT0ooK^0?ofkP170?ofkP030000
003om^h0ooK^00/0ooK^0@3oool003D0ooK^00<000000?ofkP3om^h05`3om^h00`3D?AT0ooK^0?of
kP0C0?ofkP030=@m6@3om^h0ooK^00<0ooK^10000000103om^h0e3dI0=@m6@3D?AT80?ofkP030=@m
6@3om^h0ooK^00L0ooK^0`3D?AT50?ofkP030=@m6@3om^h0e3dI00d0ooK^0P3D?AT00`0000001PPA
00000002000000<02PlS00D0e3dI0000000?5SH03aHf0000000400lF=P800000100I8e400`000000
6B=A01TSD@0201TSD@080000003D?AT0e3dI0=@m6@0R<Vd0e3dI028bK@000006028bK@030000000Z
?X<0:Sj300<0:Sj300<0000002XnP`0Z?X<00`0Z?X<01@000000:Sj302XnP`0Z?X<0e3dI0080<DRE
00<000000358U@0aB9D00P0aB9D00`000000oTPN0?i87P050?i87P0303eIZ`3nB1h0oTPN00@0oTPN
00<0?EV[0000003nB1h00P3nB1h3000000030?U67@000000nDHM00D0nDHM00<0?EV[0?U67@000000
1`3iAQd00`0mFJ/000000?U67@080?U67@030000003iAQd0nDHM00<0nDHM0P0000000`3b@a`0?EV[
0?9370030?93700303eIZ`3b@a`0lT<L0080lT<L00<000000?93703b@a`01`3b@a`00`000000lT<L
0?9370070?93700303eIZ`000000lT<L00<00000103Y@1X303eIZ`L0jD0J00<000000>U06P0mFJ/0
1`3Y@1X00`000000jD0J0>U06P020>U06P8000000`3L?1P0100mFJ/0ooK^0?ofkP3D?AT203eIZ`03
0000003om^h0e3dI00<0ooK^100mFJ/30?ofkP0403eIZ`3D?AT0e3dI0=@m6@80ooK^00<0e3dI0?of
kP3om^h00P00000;0?ofkP030=@m6@3om^h0ooK^00@0ooK^0P3D?AT50?ofkP030=@m6@3om^h0ooK^
04L0ooK^00<000000?ofkP3om^h02`3om^h10?ooo`00=@3om^h00`000000ooK^0?ofkP0G0?ofkP03
0=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h01@3om^h01P000000ooK^000000000000e3dI
0?ofkP<0e3dI103om^h00`3D?AT0ooK^0?ofkP0;0?ofkP<0e3dI00D0ooK^0=@m6@3om^h0ooK^0=@m
6@0>0?ofkP030000000621401PPA00<000000P0:3b<00`3D?AT02PlS0000000200lF=P030000000?
5SH03aHf00803aHf00<0000001TSD@0I8e400`0I8e40100000006B=A01TSD@0I8e42000000<08S9]
0`3D?AT00`0000008S9]028bK@03028bK@8000001@0Z?X<00`000000:Sj302XnP`0302XnP`040000
000Z?X<0:Sj30=@m6@<0<DRE00<000000358U@0aB9D00P0aB9D00`000000oTPN0?i87P050?i87P03
03eIZ`3nB1h0oTPN00<0oTPN00<0?EV[0?i87P0000001P3nB1h3000000H0nDHM00<0?EV[0000003i
AQd01@3iAQd00`0mFJ/0nDHM000000080?U67@030000003iAQd0nDHM00H0nDHM0P00000203eIZ`03
0?93700mFJ/0lT<L00@0lT<L00<000000?93703b@a`01P3b@a`00`000000lT<L0?9370070?937003
03eIZ`000000lT<L00@0lT<L0`000000103Y@1X000000>U06P3Y@1X203eIZ`D0jD0J00<0000003eI
Z`3Y@1X01`3Y@1X00`000000jD0J0>U06P040>U06P80000000L0?EV[0000003om^h0ooK^03eIZ`3o
m^h0?EV[0080ooK^00<0e3dI0?ofkP3om^h00P0mFJ/20?ofkP0403eIZ`3om^h0?EV[03eIZ`@0ooK^
0P3D?AT00`3om^h0e3dI0?ofkP020?ofkP<00000203om^h00`3D?AT0ooK^0?ofkP060?ofkP<0e3dI
0`3om^h00`3D?AT0ooK^0?ofkP170?ofkP030000003om^h0ooK^00X0ooK^0@3oool003@0ooK^00<0
00000?ofkP3om^h0603om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^00@0ooK^00H0
00000?ofkP3om^h0ooK^0=@m6@3om^h3000000060?ofkP3D?AT0e3dI0=@m6@3om^h0e3dI403om^h4
0=@m6@h0ooK^0P00000010062140000000000000000300X?8`030=@m6@0000003aHf00803aHf00@0
000000lF=P0?5SH03aHf0P00000501TSD@070000000I8e406B=A01TSD@0000008S9]00000003028b
K@030=@m6@0R<Vd0e3dI0080e3dI0P0R<Vd010000000:Sj302XnP`00000402XnP`030000000Z?X<0
:Sj300@0:Sj30P0000001@3D?AT0<DRE0358U@0aB9D0000000@0<DRE00<000000?i87P3nB1h01@3n
B1h00`000000?EV[0?i87P030?i87P0303eIZ`3nB1h0000000L0oTPN00<000000?i87P0000000P00
00040?U67@0303eIZ`3iAQd0nDHM00<0nDHM00@0?EV[0?U67@3iAQd00000203iAQd00`000000nDHM
0?U67@070?U67@050000003iAQd0000003eIZ`000000103b@a`00`000000lT<L0?9370070?937003
0000003b@a`0lT<L00H0lT<L00<0?EV[0?9370000000203b@a`3000000<0jD0J0`0mFJ/20>U06P03
03eIZ`3Y@1X0jD0J00L0jD0J00<000000>U06P3Y@1X01@3Y@1X0200mFJ/000000000003om^h0?EV[
0?ofkP000000?EV[0P3om^h0103D?AT0ooK^03eIZ`0mFJ/20?ofkP@0?EV[1`3om^h30=@m6@D0ooK^
0`0000050?ofkP030=@m6@3om^h0ooK^00T0ooK^103D?AU90?ofkP030000003om^h0ooK^00X0ooK^
0@3oool003@0ooK^00<000000?ofkP3om^h0603om^h20=@m6A<0ooK^00<0e3dI0?ofkP3om^h01@3o
m^h01@000000ooK^0?ofkP3om^h0e3dI00@0ooK^0`000000103om^h0e3dI0=@m6@3D?AT?0?ofkP03
0=@m6@3om^h0ooK^00<0e3dI2`3om^h2000000801PPA00<0000000X?8`0000000`0:3b<00`3D?AT0
3aHf00lF=P0200lF=P060000000?5SH03aHf0000000I8e4000001@0I8e40100000006B=A01TSD@00
0002028bK@040000000R<Vd08S9]0=@m6@<08S9]00<00000028bK@3D?AT00P3D?AT202XnP`030000
000Z?X<0:Sj30080:Sj300<0000002XnP`0Z?X<0100Z?X<00`000000<DRE0=@m6@030358U@030000
000aB9D0<DRE00<0<DRE00<000000?i87P3nB1h0103nB1h00`000000oTPN03eIZ`020?i87P0403eI
Z`3nB1h0oTPN000000L0oTPN00<000000?i87P3nB1h00P3nB1h3000000030?U67@000000?EV[00<0
nDHM00D0?EV[0?U67@3iAQd0nDHM000000080?U67@030000003iAQd0nDHM00H0nDHM00D000000?U6
7@3iAQd0?EV[0?U67@0203eIZ`80000000<0lT<L0000003b@a`0203b@a`00`000000lT<L0?937005
0?93700403eIZ`3b@a`0lT<L000000T0lT<L00@000000?93700000000000103Y@1X403eIZ`P0jD0J
00<000000>U06P3Y@1X0103Y@1X02@0mFJ/0jD0J0>U06P000000?EV[0?ofkP000000ooK^03eIZ`02
0?ofkP040=@m6@0mFJ/0?EV[0?ofkP80?EV[00<0ooK^03eIZ`0mFJ/02@3om^h0103D?AT0ooK^0=@m
6@3D?AT60?ofkP8000000`3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP80e3dIB03om^h00`000000ooK^
0?ofkP0:0?ofkP40oooo000d0?ofkP030000003om^h0ooK^01P0ooK^00<0e3dI0?ofkP3D?AT00P3D
?AT@0?ofkP030=@m6@3om^h0ooK^00@0ooK^00D000000?ofkP3om^h0ooK^0=@m6@080?ofkP800000
00<0e3dI0?ofkP3D?AT00P3D?AT<0?ofkP040=@m6@3om^h0ooK^0=@m6@80ooK^103D?AT70?ofkP80
000000D01PPA0000000000002PlS0000000200X?8`030=@m6@0000003aHf00<03aHf00<0000000lF
=P0000000`0I8e400`0000006B=A01TSD@0301TSD@0303eIZ`0000008S9]00808S9]00@00000028b
K@0R<Vd0e3dI0`0R<Vd01@0000008S9]028bK@000000:Sj300<0e3dI1@0Z?X<00`000000:Sj302Xn
P`0202XnP`80000000<0e3dI0358U@0aB9D00`0aB9D00`000000<DRE0358U@020358U@030000003n
B1h0oTPN00@0oTPN00D000000?i87P0mFJ/0oTPN03eIZ`030?i87P030000003nB1h0oTPN00D0oTPN
00<000000?i87P3nB1h01@3nB1h30000000303eIZ`3iAQd0?EV[00<0nDHM00<000000?U67@3iAQd0
1`3iAQd00`000000nDHM0?U67@060?U67@030000003iAQd0?EV[00@0nDHM0P0mFJ/3000000P0lT<L
00<000000?93703b@a`0103b@a`0100mFJ/0lT<L0?93700000090?9370030000003b@a`0lT<L0080
lT<L0P0000020>U06P0403eIZ`000000jD0J0>U06PD0?EV[0P3Y@1X00`000000jD0J0>U06P040>U0
6P0903eIZ`3Y@1X0jD0J0000000mFJ/0ooK^0000003om^h0?EV[00<0ooK^100mFJ/0103om^h0?EV[
03eIZ`0mFJ/:0?ofkP040=@m6@3om^h0ooK^0?ofkP<0e3dI1@3om^h3000000030?ofkP3D?AT0ooK^
00d0ooK^00<0e3dI0?ofkP3om^h0AP3om^h00`000000ooK^0?ofkP0:0?ofkP40oooo000d0?ofkP03
0000003om^h0ooK^01P0ooK^00<0e3dI0?ofkP3om^h00P3om^h40=@m6@`0ooK^00<0e3dI0?ofkP3o
m^h00`3om^h00`000000ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00P0ooK^00D0e3dI00000000
000000000?ofkP030=@m6@P0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@060?ofkP<0e3dI0`3om^h2
000000801PPA00P0000000X?8`0:3b<0000000X?8`000000e3dI000000@03aHf00<0000000lF=P00
00000`0I8e400`0000006B=A01TSD@0301TSD@0303eIZ`0000008S9]00<08S9]00<000000=@m6@0R
<Vd0100R<Vd2000000D0:Sj3103D?AT00`0Z?X<0000002XnP`0202XnP`040000000aB9D0<DRE0=@m
6@D0<DRE00<000000358U@0aB9D00P0aB9D00`000000oTPN0?i87P040?i87P040000003nB1h0oTPN
03eIZ`@0oTPN00<000000?i87P3nB1h01@3nB1h00`000000oTPN0?i87P060?i87P040000003nB1h0
000003eIZ`@0nDHM00<000000?U67@3iAQd01`3iAQd00`000000nDHM0?U67@060?U67@030000000m
FJ/0nDHM00H0nDHM0P0mFJ/0103iAQd000000000000000040?9370030000003b@a`0lT<L00@0lT<L
00D0?EV[0?93703b@a`0lT<L000000090?9370030000003b@a`0lT<L00@0lT<L00@0000003eIZ`3Y
@1X000001`3Y@1X503eIZ`<0jD0J00<0?EV[0>U06P3Y@1X00P0mFJ/00`3D?AT0?EV[03eIZ`0603eI
Z`<0ooK^0P0mFJ/<0?ofkP030=@m6@3om^h0ooK^00@0ooK^0P3D?AT60?ofkP<000003@3om^h00`3D
?AT0ooK^0?ofkP170?ofkP030000003om^h0ooK^00T0ooK^0@3oool003@0ooK^00<000000?ofkP3o
m^h05`3om^h00`3D?AT0ooK^0?ofkP070?ofkP<0e3dI2@3om^h00`3D?AT0ooK^0?ofkP030?ofkP05
0000003om^h0ooK^0?ofkP3D?AT02P3om^h00`3D?AT0ooK^0?ofkP020?ofkP<0000000<0ooK^0=@m
6@3D?AT00P3D?AT40?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT02@3om^h30=@m6@0300H84@000000
1PPA008000000P0:3b<2000000030=@m6@0?5SH0000000@03aHf0P00000401TSD@030000000I8e40
6B=A00<06B=A00<00000028bK@0R<Vd00`0R<Vd00`000000e3dI028bK@04028bK@030000000Z?X<0
:Sj300@0:Sj300@0000002XnP`0Z?X<0:Sj30`3D?AT00`0Z?X<000000358U@020358U@030=@m6@0a
B9D0<DRE00<0<DRE00<000000358U@0aB9D00P0aB9D00`000000oTPN0?i87P040?i87P050000003n
B1h0?EV[0?i87P0mFJ/0103nB1h00`000000oTPN0?i87P040?i87P030000003nB1h0oTPN00H0oTPN
00@000000?i87P0mFJ/0oTPN0P0mFJ/00`000000nDHM000000090?U67@030000003iAQd0nDHM00H0
nDHM00<0?EV[0?U67@3iAQd01P3iAQd00`000000nDHM03eIZ`030?U67@<0000000<0lT<L0000003b
@a`0103b@a`01@0mFJ/0lT<L0?93703b@a`0000000T0lT<L00<000000?93703b@a`0103b@a`203eI
Z`040?93700000000000000000P0jD0J00<000000>U06P3Y@1X02@0mFJ/30?ofkP0503eIZ`3om^h0
?EV[03eIZ`3D?AT00`3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00H0ooK^0P3D
?AT50?ofkP040=@m6@3om^h00000000000`0ooK^00<0e3dI0?ofkP3om^h0AP3om^h00`000000ooK^
0?ofkP090?ofkP40oooo000c0?ofkP030000003om^h0ooK^01P0ooK^00<0e3dI0?ofkP3om^h02P3o
m^h30=@m6@D0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`000000ooK^0?ofkP020?ofkP030=@m6@3o
m^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h01@3om^h300000080ooK^103D?AT30?ofkP030=@m6@3o
m^h0ooK^00T0ooK^00<0?EV[0000003D?AT00`3D?AT0200000002PlS0000000:3b<000000=@m6@0?
5SH00000100?5SH00`0000006B=A01TSD@0301TSD@030000000I8e406B=A00806B=A0P000005028b
K@030=@m6@0000008S9]00<08S9]0P00000602XnP`030000000Z?X<0:Sj300<0:Sj300L000000=@m
6@3D?AT0e3dI0358U@3D?AT0000000H0<DRE00<000000358U@0aB9D00P0aB9D00`000000oTPN0?i8
7P040?i87P0503eIZ`3nB1h0oTPN0?i87P0mFJ/00`3nB1h00`000000oTPN0?i87P040?i87P030000
003nB1h0oTPN00H0oTPN00<0000003eIZ`3nB1h00`3nB1h0100mFJ/000000000000000070?U67@03
0000003iAQd0nDHM00H0nDHM00<0?EV[0?U67@3iAQd01`3iAQd00`000000nDHM0?U67@0203eIZ`@0
nDHM0`0000030?93700303eIZ`3b@a`0lT<L0080lT<L00<000000?93703b@a`01`3b@a`00`000000
lT<L0?9370030?93700503eIZ`3b@a`0lT<L0?93700000000P3b@a`3000000D0jD0J00D000000>U0
6P3Y@1X0jD0J03eIZ`040>U06P030000003om^h0ooK^00<0e3dI0P0mFJ/20?ofkP040=@m6@3om^h0
?EV[03eIZ`h0ooK^00<0e3dI0?ofkP3om^h0203om^h30=@m6@80ooK^00@0e3dI0?ofkP3om^h0ooK^
0`0000090?ofkP030=@m6@3om^h0ooK^04H0ooK^00<000000?ofkP3om^h02@3om^h10?ooo`00<`3o
m^h00`000000ooK^0?ofkP0H0?ofkP030=@m6@3om^h0ooK^00d0ooK^103D?AT00`3om^h0e3dI0?of
kP030?ofkP030000003om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?of
kP080?ofkP<000000P3om^h30=@m6@030?ofkP3D?AT0ooK^00X0ooK^00H0000000H84@0mFJ/00000
00X?8`0000030=@m6@050000003D?AT03aHf00lF=P0000000`0?5SH2000000D06B=A00D0000001TS
D@0I8e406B=A00000002028bK@030000000R<Vd08S9]00808S9]00<0e3dI0000000R<Vd00P0R<Vd0
10000000:Sj302XnP`00000502XnP`030000000Z?X<0:Sj300<0:Sj300@000000358U@0aB9D0<DRE
0`3D?AT60358U@030000000aB9D0<DRE0080<DRE0P0000040?i87P0303eIZ`000000oTPN00<0oTPN
00@0?EV[0?i87P3nB1h000001P3nB1h00`000000oTPN0?i87P060?i87P0303eIZ`3nB1h0oTPN00@0
oTPN00<0?EV[0000003nB1h00`0000040?U67@030000003iAQd0nDHM00D0nDHM00<0?EV[0000003i
AQd0203iAQd00`000000nDHM0?U67@020?U67@80?EV[0`3iAQd01@000000nDHM000000000000?EV[
00D0lT<L00<000000?93703b@a`01P3b@a`00`000000lT<L0?9370030?93700303eIZ`3b@a`0lT<L
0080lT<L00<000000?93703b@a`00`3b@a`3000000030>U06P000000jD0J0080jD0J00<0?EV[0>U0
6P3Y@1X00`3Y@1X00`000000ooK^0?ofkP020?ofkP80?EV[0P3D?AT0103om^h0e3dI03eIZ`0mFJ/?
0?ofkP030=@m6@3om^h0ooK^00/0ooK^0P3D?AT00`3om^h0e3dI0?ofkP040?ofkP8000001`3om^h0
0`3D?AT0ooK^0?ofkP160?ofkP030000003om^h0ooK^00T0ooK^0@3oool003<0ooK^00<000000?of
kP3om^h0603om^h00`3D?AT0ooK^0?ofkP0A0?ofkP<0e3dI0P3om^h00`000000ooK^0?ofkP030?of
kP80e3dI2P3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030000003D?AT000000080ooK^0`3D?AT90?of
kP0403eIZ`0000000000000000802PlS00@0000000X?8`0:3b<000000`3D?AT01`0?5SH0000000lF
=P0?5SH0000001TSD@0000001@0I8e40100000006B=A01TSD@000003028bK@070000000R<Vd08S9]
028bK@3D?AT08S9]00000002028bK@050000000Z?X<0:Sj302XnP`0000001P0Z?X<010000000:Sj3
02XnP`0Z?X<2000000@0<DRE00<0e3dI0358U@3D?AT00P3D?AT30358U@040000000aB9D0<DRE0358
U@80000000L0odTO000000000000000003eIZ`3nB1h0000000D0oTPN00<0?EV[0?i87P0000001P3n
B1h00`000000oTPN0?i87P050?i87P0303eIZ`000000oTPN00H0oTPN0P0mFJ/30?i87P<0000000<0
nDHM0000003iAQd01@3iAQd00`0mFJ/0nDHM000000080?U67@030000003iAQd0nDHM00D0nDHM0P0m
FJ/01P000000nDHM0?U67@3iAQd0?EV[0?U67@<0000000<0lT<L0000003b@a`0203b@a`00`000000
lT<L0?9370020?93700303eIZ`3b@a`0lT<L0080lT<L00<000000?93703b@a`01`3b@a`300000080
?EV[1P3Y@1X010000000ooK^0?ofkP3om^h203eIZ`<0ooK^00<0e3dI03eIZ`0mFJ/0403om^h00`3D
?AT0ooK^0?ofkP0=0?ofkP<0e3dI1P3om^h3000000@0ooK^00<0e3dI0?ofkP3om^h0AP3om^h00`00
0000ooK^0?ofkP090?ofkP40oooo000c0?ofkP030000003om^h0ooK^01P0ooK^00<0e3dI0?ofkP3o
m^h04P3om^h01@3D?AT0ooK^0=@m6@3D?AT0000000@0ooK^00<0e3dI0?ofkP3om^h00`3D?AT60?of
kP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP0000000P0000000`3D?AT0ooK^0=@m6@020=@m
6@D0ooK^00@0?EV[00000006214000000`0:3b<01@0000002PlS000000000000e3dI00803aHf0`3D
?AT01@0000006B=A01TSD@0I8e40000000D06B=A00<0000001TSD@0000000`0R<Vd01@0000008S9]
028bK@0R<Vd0e3dI00808S9]0P00000502XnP`030000000Z?X<0:Sj300<0:Sj300@0000002XnP`0Z
?X<000000P0aB9D010000000<DRE0358U@3D?AT20358U@030000000aB9D0<DRE00@0e3dI0P0aB9D0
10000000=U2U03I@Y@0000020?m97`0303eIZ`3oBAl00000008000001@3nB1h00`0mFJ/000000?i8
7P050?i87P030000003nB1h0oTPN00@0oTPN00<0?EV[0?i87P0000001`3nB1h00`000000oTPN03eI
Z`050?i87P<000001@3iAQd00`0mFJ/0nDHM000000080?U67@030000003iAQd0nDHM00L0nDHM0P0m
FJ/00`3iAQd0?EV[0?U67@040?U67@<000001`3b@a`00`000000lT<L0?9370020?93700303eIZ`3b
@a`0lT<L00<0lT<L00<000000?93703b@a`01`3b@a`00`000000lT<L03eIZ`03000000D0jD0J00<0
00000?ofkP3om^h00P0mFJ/40?ofkP80?EV[00<0ooK^0=@m6@3D?AT03P3om^h00`3D?AT0ooK^0?of
kP0>0?ofkP030=@m6@3om^h0e3dI0080e3dI1P3om^h300000080ooK^00<0e3dI0?ofkP3om^h0AP3o
m^h00`000000ooK^0?ofkP080?ofkP40oooo000c0?ofkP030000003om^h0ooK^01P0ooK^00<0e3dI
0?ofkP3om^h04P3om^h01@3D?AT0ooK^0?ofkP000000ooK^00<0e3dI00<0ooK^0=@m6@3om^h0103o
m^h30=@m6@<0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP030?ofkP050=@m6@00
000000000000003om^h0103D?AT203eIZ`<000000`0:3b<20000000300lF=P000000e3dI00<03aHf
00@0000000lF=P3D?AT0e3dI0P0I8e400`0000006B=A01TSD@0301TSD@800000100R<Vd01@000000
8S9]028bK@0R<Vd0e3dI00808S9]00<0000002XnP`0Z?X<0100Z?X<00`000000:Sj302XnP`0302Xn
P`040000000Z?X<0:Sj300000080<DRE00@000000358U@0aB9D0e3dI0P0aB9D00`000000<DRE0358
U@040358U@<0e3dI0P0fD:D00`000000odTO03eIZ`030?m97`040000003oBAl00000000000@0oTPN
0P0mFJ/50?i87P030000003nB1h0oTPN00<0oTPN00<0?EV[0?i87P0000001`3nB1h01@000000oTPN
0?i87P3nB1h0?EV[00D0oTPN00@000000?i87P00000000000P3iAQd00`0mFJ/0nDHM000000090?U6
7@030000003iAQd0nDHM00H0nDHM00<000000?U67@3iAQd00P0mFJ/50?U67@030000003iAQd0nDHM
008000001@3b@a`01@000000lT<L0?93703b@a`0?EV[00D0lT<L00<000000?93703b@a`0203b@a`0
0`000000?EV[0?9370030?9370<0000000@0jD0J0000003om^h0ooK^0`0mFJ/20?ofkP80?EV[00<0
ooK^0=@m6@3om^h00P3om^h30=@m6@/0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?of
kP020?ofkP<0e3dI1P3om^h2000000030=@m6@3om^h0ooK^04H0ooK^00<000000?ofkP3om^h0203o
m^h10?ooo`00<P3om^h00`000000ooK^0?ofkP0H0?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI
0?ofkP0000001@3om^h20=@m6@P0ooK^103D?AT>0?ofkP030=@m6@3om^h0ooK^00<0ooK^00@0e3dI
0?ofkP3om^h0ooK^0`0000020?ofkP<0e3dI0P00000200X?8`050000000:3b<0000000lF=P3D?AT0
100?5SH2000000806B=A0`3D?AT501TSD@030000000R<Vd08S9]00@08S9]00<00000028bK@3D?AT0
0P0R<Vd2000000H0:Sj300<0000002XnP`0Z?X<01@0Z?X<00`000000<DRE0358U@020358U@030000
003D?AT0<DRE00<0<DRE00<000000358U@0aB9D00`0aB9D00`000000=U2U03I@Y@020=@m6@030000
000mFJ/0odTO00<0odTO00@000000?m97`3oBAl0odTO0`000000103nB1h000000?i87P0mFJ/40?i8
7P030000003nB1h0oTPN0080oTPN00@0?EV[0?i87P3nB1h000001`3nB1h00`000000oTPN0?i87P02
0?i87P80?EV[0P3nB1h00`000000oTPN0?i87P020?i87P050000000mFJ/000000?U67@000000203i
AQd00`000000nDHM0?U67@070?U67@030000003iAQd0?EV[0080nDHM0`0mFJ/20?U67@030000003i
AQd0nDHM0080nDHM0`0000000`3b@a`000000?9370020?93700303eIZ`3b@a`0lT<L00@0lT<L00<0
00000?93703b@a`01`3b@a`00`000000?EV[0?9370070?937080000000@0ooK^03eIZ`0mFJ/0?EV[
0P3om^h203eIZ`80ooK^00<0e3dI0?ofkP3om^h0103om^h20=@m6@T0ooK^00<0e3dI0?ofkP3om^h0
3P3om^h00`3D?AT0ooK^0?ofkP050?ofkP80e3dI1P3om^h3000004H0ooK^00<000000?ofkP3om^h0
203om^h10?ooo`00<P3om^h00`000000ooK^0?ofkP0H0?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0
e3dI0000003om^h01@3om^h00`3D?AT0ooK^0=@m6@020=@m6@P0ooK^0P3D?AT<0?ofkP030=@m6@3o
m^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`000000?EV[03eIZ`03000000<02PlS0P00
000200lF=P030=@m6@0?5SH03aHf00803aHf00<0000001TSD@0I8e400`0I8e401@000000e3dI0=@m
6@3D?AT06B=A008000001P0R<Vd01@0000008S9]0=@m6@0R<Vd000000080:Sj300<0000002XnP`0Z
?X<0100Z?X<00`000000:Sj302XnP`0302XnP`030000000aB9D0<DRE00<0<DRE00<000000=@m6@0a
B9D00`0aB9D00`000000<DRE0358U@020358U@8000000`0fD:D00`3D?AT000000?m97`050?m97`03
0000003oBAl0odTO00<0odTO0`0000000`3nB1h0?EV[0?i87P020?i87P050000003nB1h0oTPN0?i8
7P0mFJ/00`3nB1h00`000000oTPN0?i87P050?i87P030000003nB1h0oTPN00@0oTPN00<0?EV[0?i8
7P000000103nB1h00`0mFJ/0oTPN0?i87P03000000L0nDHM00<000000?U67@3iAQd01P3iAQd00`00
0000nDHM03eIZ`060?U67@<0?EV[1`3iAQd300000080?EV[1P3b@a`00`000000lT<L0?9370080?93
700303eIZ`3b@a`0lT<L00L0lT<L00D000000?ofkP0mFJ/0?EV[0?ofkP0403eIZ`<0ooK^00<0e3dI
0?ofkP3om^h01P3om^h30=@m6@H0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP07
0?ofkP<0e3dI0`3om^h00`3D?AT0ooK^0?ofkP03000004<0ooK^00<000000?ofkP3om^h0203om^h1
0?ooo`00<P3om^h00`000000ooK^0?ofkP0H0?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0000
003om^h0103om^h00`3D?AT0ooK^0?ofkP030?ofkP<0e3dI103om^h00`3D?AT0ooK^0?ofkP030=@m
6@T0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP050?ofkP<0?EV[00<0000000X?
8`0000000`0:3b<01@0000003aHf00lF=P3D?AT0000000<03aHf0P00000501TSD@040000000I8e40
6B=A01TSD@<0e3dI00<00000028bK@0R<Vd00`0R<Vd010000000e3dI028bK@00000302XnP`030000
000Z?X<0:Sj300@0:Sj300<0000002XnP`0Z?X<00P0Z?X<2000000D0<DRE00<0e3dI0358U@0aB9D0
0`0aB9D01@000000<DRE0358U@0aB9D000000080=U2U00<0000003I@Y@0fD:D00P0fD:D00`000000
odTO0?m97`030?m97`030000003oBAl0odTO00@0odTO00D000000?m97`000000000003eIZ`020?i8
7P040000003nB1h0oTPN03eIZ`@0oTPN00<000000?i87P3nB1h01@3nB1h00`000000oTPN0?i87P05
0?i87P0303eIZ`000000oTPN0080oTPN00<0?EV[0?i87P3nB1h00P3nB1h010000000oTPN00000000
00050?U67@030000003iAQd0nDHM00H0nDHM00<0000003eIZ`3iAQd01`3iAQd00`000000nDHM03eI
Z`0203eIZ`@0nDHM00<000000?U67@0mFJ/00`0000050?9370030000003b@a`0lT<L00L0lT<L00<0
?EV[0?93703b@a`0203b@a`010000000?EV[03eIZ`3om^h403eIZ`@0ooK^00<0e3dI0?ofkP3om^h0
2@3om^h30=@m6@<0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP<0e3dI
00<0ooK^0=@m6@3om^h00`3om^h200000480ooK^00<000000?ofkP3om^h01`3om^h10?ooo`00<P3o
m^h00`000000ooK^0?ofkP0H0?ofkP80e3dI4`3om^h00`3D?AT000000?ofkP040?ofkP030=@m6@3o
m^h0ooK^00L0ooK^0`3D?AT00`3om^h0e3dI0?ofkP040?ofkP<0e3dI1@3om^h00`3D?AT0ooK^0?of
kP040?ofkP030=@m6@3om^h0ooK^00@0ooK^0`0mFJ/20000000400X?8`0000002PlS00X?8`800000
0P0?5SH01`3D?AT0000000lF=P0?5SH0000001TSD@0000001P0I8e400`0000006B=A00000003028b
K@80e3dI100R<Vd010000000e3dI028bK@00000402XnP`030000000Z?X<0:Sj300@0:Sj300@00000
02XnP`0Z?X<000000P0aB9D00`000000<DRE0358U@020358U@030=@m6@000000<DRE00<0<DRE00@0
00000358U@0aB9D000000`0fD:D00`000000=U2U03I@Y@0203I@Y@030000003oBAl0odTO00<0odTO
00<000000?m97`3oBAl0103oBAl02P000000odTO0?m97`3oBAl0000003eIZ`3nB1h000000?i87P0m
FJ/50?i87P030000003nB1h0oTPN00D0oTPN00<000000?i87P3nB1h01@3nB1h01@000000?EV[03eI
Z`3nB1h0?EV[00@0oTPN00<000000?i87P3nB1h00P3nB1h3000000030?U67@000000nDHM00P0nDHM
00<0?EV[0?U67@3iAQd01P3iAQd00`000000nDHM0?U67@030?U67@<0?EV[00<0nDHM0000000mFJ/0
103iAQd3000000030?9370000000lT<L00P0lT<L00<0?EV[0?93703b@a`0203b@a`203eIZ`040?of
kP0mFJ/0?EV[0?ofkP80?EV[1@3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP80e3dI00<0ooK^0=@m6@3o
m^h03`3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP80e3dI1P3om^h3000003l0ooK^00<000000?ofkP3o
m^h01`3om^h10?ooo`00<P3om^h00`000000ooK^0?ofkP0H0?ofkP030=@m6@3om^h0e3dI00<0e3dI
3`3om^h00`000000ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00X0ooK^0`3D?AT70?ofkP<0e3dI
0P3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00<0ooK^100mFJ/03P0000002PlS
00X?8`0000002PlS0000000?5SH0000000lF=P3D?AT03aHf0000000?5SH000000`0I8e400`000000
6B=A01TSD@0301TSD@0303eIZ`0000008S9]00@08S9]00H000000=@m6@3D?AT0e3dI028bK@3D?AT2
000000D0:Sj300<0000002XnP`0Z?X<0100Z?X<010000000:Sj302XnP`0000020358U@070000000a
B9D0<DRE0358U@3D?AT0<DRE000000050358U@800000100fD:D00`000000=U2U03I@Y@0203I@Y@03
0000003oBAl0odTO00<0odTO00<000000?m97`3oBAl0103oBAl00`000000odTO0?m97`030?m97`03
03eIZ`000000?EV[00H0oTPN00<000000?i87P3nB1h01@3nB1h00`000000oTPN0?i87P050?i87P04
0000003nB1h0oTPN03eIZ`D0oTPN00<000000?i87P3nB1h01@3nB1h3000000L0nDHM00<0?EV[0?U6
7@3iAQd01`3iAQd00`000000nDHM0?U67@060?U67@@0?EV[1P3iAQd3000000H0lT<L0P0mFJ/00`00
0000lT<L0?9370070?9370@0?EV[00@0ooK^03eIZ`0mFJ/0?EV[1P3om^h00`3D?AT0ooK^0?ofkP0>
0?ofkP<0e3dI403om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00L0ooK^0P00000m
0?ofkP030000003om^h0ooK^00L0ooK^0@3oool00340ooK^00<000000?ofkP3om^h06@3om^h00`3D
?AT0ooK^0?ofkP030?ofkP<0e3dI303om^h00`000000ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^
00`0ooK^00<0e3dI0?ofkP3D?AT00P3D?AT70?ofkP<0e3dI1P3om^h00`3D?AT0ooK^0?ofkP030?of
kP<0?EV[00@0ooK^0000000:3b<02PlS0P00000200lF=P040000000?5SH0e3dI00lF=P800000100I
8e400`0000006B=A01TSD@0301TSD@030000000mFJ/08S9]00@08S9]00@00000028bK@0R<Vd08S9]
0`3D?AT602XnP`030000000Z?X<0:Sj300H0:Sj300<000000358U@0aB9D00P0aB9D01P000000<DRE
0358U@3D?AT0<DRE000000D0<DRE00<0000003I@Y@0fD:D00`0fD:D00`000000=U2U03I@Y@0203I@
Y@030000003oBAl0odTO00<0odTO00<000000?m97`3oBAl0103oBAl00`000000odTO0?m97`040?m9
7`0303eIZ`3oBAl0000000<000000P3nB1h00`000000oTPN0?i87P050?i87P030000003nB1h0oTPN
00D0oTPN00@000000?i87P0mFJ/0oTPN0P0mFJ/30?i87P030000003nB1h0oTPN00H0oTPN00@00000
0?i87P0000000000103iAQd00`0mFJ/000000?U67@070?U67@030000003iAQd0nDHM00L0nDHM00@0
?EV[0?U67@3iAQd0nDHM1@0mFJ/0103iAQd000000?U67@3iAQd2000000<0lT<L00<0?EV[0?937000
00002@3b@a`303eIZ`80ooK^0P0mFJ/70?ofkP030=@m6@3om^h0ooK^0100ooK^00<0e3dI0?ofkP3D
?AT00P3D?AT=0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h02@3om^h3000003X0
ooK^00<000000?ofkP3om^h01`3om^h10?ooo`00<@3om^h00`000000ooK^0?ofkP0I0?ofkP030=@m
6@3om^h0ooK^00H0ooK^103D?AT70?ofkP030000003D?AT0ooK^00@0ooK^00<0e3dI0?ofkP3om^h0
303om^h00`3D?AT0ooK^0?ofkP020?ofkP@0e3dI0`3om^h00`3D?AT0ooK^0?ofkP030=@m6@<0ooK^
00<0e3dI0?ofkP3om^h00P3om^h503eIZ`050000000:3b<0000000X?8`0000000P0?5SH01@000000
e3dI00lF=P0?5SH0000000D06B=A00<0000001TSD@0I8e400P0I8e42000000H08S9]00L00000028b
K@0R<Vd08S9]0=@m6@000000:Sj300<0e3dI100Z?X<00`000000:Sj302XnP`0402XnP`030000000a
B9D0<DRE00<0<DRE00@000000358U@0aB9D0e3dI0P0aB9D010000000<DRE0358U@0aB9D2000000H0
=U2U00<0000003I@Y@0fD:D00P0fD:D00`000000odTO0?m97`030?m97`030000003oBAl0odTO00<0
odTO00<000000?m97`3oBAl00`3oBAl00`0mFJ/0000003eIZ`040?m97`@000001@3nB1h00`000000
oTPN0?i87P060?i87P030000000mFJ/0oTPN00<0oTPN0P0mFJ/00`000000oTPN0?i87P060?i87P03
0000003nB1h0oTPN0080oTPN0P00000203eIZ`030000003iAQd0nDHM00L0nDHM00<000000?U67@3i
AQd01P3iAQd00`0mFJ/0nDHM0?U67@070?U67@D0?EV[00@0nDHM000000000000?EV[0P3b@a`00`00
0000lT<L0?93700803eIZ`@0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP0@0?of
kP030=@m6@3om^h0ooK^0080ooK^0`3D?AT:0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?of
kP3om^h0303om^h3000003P0ooK^00<000000?ofkP3om^h01P3om^h10?ooo`00<@3om^h00`000000
ooK^0?ofkP0I0?ofkP030=@m6@3om^h0ooK^00X0ooK^0`3D?AT30?ofkP030000003om^h0e3dI00@0
ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP060?ofkP@0e3dI1@3om^h40=@m6@<0
ooK^00H0?EV[0?ofkP0mFJ/0?EV[0?ofkP00000200X?8`8000000`0?5SH00`000000e3dI00lF=P02
000000D06B=A00D0000001TSD@0I8e406B=A00000002028bK@030000000R<Vd08S9]00@08S9]00@0
0000028bK@0R<Vd0e3dI0P0Z?X<00`000000:Sj302XnP`030=@m6@0302XnP`000000:Sj300@0:Sj3
0P0000050358U@030000000aB9D0e3dI00<0<DRE00@000000358U@0aB9D000000P0fD:D00`000000
=U2U03I@Y@0303I@Y@030000000fD:D0=U2U0080=U2U00<000000?m97`3oBAl00`3oBAl00`000000
odTO0?m97`030?m97`030000003oBAl0odTO0080odTO00@0?EV[0?m97`000000odTO0P0mFJ/40?m9
7`040000003oBAl00000000000<0oTPN00<000000?i87P3nB1h01@3nB1h00`000000?EV[0?i87P06
0?i87P80?EV[1`3nB1h00`000000oTPN0?i87P030?i87P0303eIZ`3nB1h00000008000001`3iAQd0
0`000000nDHM0?U67@060?U67@0303eIZ`000000nDHM00P0nDHM00<000000?U67@3iAQd00P3iAQd9
03eIZ`D0lT<L0P0mFJ/20=@m6@80ooK^00<0?EV[0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP0@
0?ofkP030=@m6@3om^h0ooK^00D0ooK^0`3D?AT70?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI
0?ofkP3om^h03`3om^h2000003H0ooK^00<000000?ofkP3om^h01P3om^h10?ooo`00<@3om^h00`00
0000ooK^0?ofkP0I0?ofkP030=@m6@3om^h0ooK^00d0ooK^0P3D?AT010000000e3dI0?ofkP3D?AT4
0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h0203om^h40=@m6@D0ooK^00<0e3dI
0?ofkP3D?AT00P3D?AT01P3om^h0?EV[03eIZ`0mFJ/0ooK^000000802PlS00<0000000lF=P0?5SH0
0P0?5SH01P3D?AT03aHf00lF=P0000006B=A000000@06B=A00@0000001TSD@0I8e4000000`0R<Vd0
0`0000008S9]028bK@04028bK@040000000R<Vd0e3dI000000<0:Sj300<0000002XnP`0Z?X<00P0Z
?X<30=@m6@<0:Sj300@000000358U@0aB9D000001@0aB9D00`000000e3dI0358U@030358U@800000
0`0fD:D00`000000=U2U03I@Y@0303I@Y@030000000fD:D0=U2U0080=U2U00<000000?m97`3oBAl0
0`3oBAl00`000000odTO0?m97`030?m97`050000003oBAl0odTO0?m97`0mFJ/00P3oBAl01@000000
odTO0?m97`3oBAl0?EV[00<0odTO00@000000?m97`3oBAl0odTO0P0000000`3nB1h000000?i87P06
0?i87P0303eIZ`3nB1h0oTPN00H0oTPN00@000000?i87P0mFJ/0?EV[103nB1h00`000000oTPN0?i8
7P030?i87P0403eIZ`3nB1h0oTPN00000080oTPN0P0000050?U67@030000003iAQd0nDHM00D0nDHM
00<0?EV[0000003iAQd0203iAQd00`000000nDHM0?U67@040?U67@0403eIZ`3iAQd0nDHM00000080
nDHM0`0000030?93700303eIZ`3b@a`000000080ooK^0P0mFJ/00`3D?AT0ooK^0?ofkP070?ofkP03
0=@m6@3om^h0ooK^0100ooK^00<0e3dI0?ofkP3om^h0203om^h30=@m6@@0ooK^00<0e3dI0?ofkP3o
m^h03@3om^h00`3D?AT0ooK^0?ofkP0A0?ofkP<00000<`3om^h00`000000ooK^0?ofkP060?ofkP40
oooo000a0?ofkP030000003om^h0ooK^01T0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`000000ooK^
0=@m6@020=@m6@80ooK^0P3D?AT?0?ofkP030=@m6@3om^h0ooK^00P0ooK^00@0e3dI0?ofkP3om^h0
ooK^103D?AT0103om^h0e3dI0?ofkP3om^h203eIZ`<0e3dI00@0ooK^03eIZ`0000002PlS0P000004
00lF=P030=@m6@0?5SH0000000806B=A00<0000001TSD@0I8e400`0I8e400`0000006B=A00000004
028bK@030000000R<Vd08S9]00@08S9]00<000000=@m6@0Z?X<00`0Z?X<00`000000:Sj302XnP`04
02XnP`030000003D?AT0e3dI0080e3dI0P0aB9D00`000000<DRE0358U@030358U@030=@m6@0aB9D0
<DRE00<0<DRE00<0000003I@Y@0fD:D00`0fD:D00`000000=U2U03I@Y@0203I@Y@030000000fD:D0
=U2U0080=U2U00<000000?m97`3oBAl00`3oBAl00`000000odTO0?m97`040?m97`030000003oBAl0
?EV[00<0odTO00<000000?m97`3oBAl00P3oBAl0100mFJ/0odTO0?m97`0000050?m97`<000001@3n
B1h00`0mFJ/000000?i87P070?i87P040000003nB1h0oTPN0?i87P80?EV[0P3nB1h00`000000oTPN
0?i87P020?i87P0503eIZ`3nB1h0oTPN0?i87P000000103nB1h3000000030?U67@000000nDHM00H0
nDHM00<0?EV[0?U67@0000002@3iAQd00`000000nDHM0?U67@030?U67@0503eIZ`3iAQd0nDHM0?U6
7@0000001@3iAQd00`000000?EV[03eIZ`020?9370040000003om^h0?EV[03eIZ`80ooK^0P3D?AT7
0?ofkP030=@m6@3om^h0ooK^0100ooK^00<0e3dI0?ofkP3om^h02`3om^h30=@m6@030?ofkP3D?AT0
ooK^00h0ooK^00<0e3dI0?ofkP3om^h0503om^h300000300ooK^00<000000?ofkP3om^h01P3om^h1
0?ooo`00<@3om^h00`000000ooK^0?ofkP0I0?ofkP030=@m6@3om^h0ooK^00h0ooK^00H000000?of
kP3om^h0ooK^0=@m6@3om^h30=@m6@040?ofkP3D?AT0e3dI0=@m6@`0ooK^00<0e3dI0?ofkP3om^h0
1`3om^h00`3D?AT0ooK^0?ofkP060?ofkP<0e3dI00@0ooK^03eIZ`0mFJ/0ooK^0P0mFJ/40=@m6@03
00lF=P0000003aHf00803aHf00<0e3dI0000000000000`0I8e400`0000006B=A01TSD@0301TSD@80
00001@0R<Vd00`0000008S9]028bK@04028bK@030=@m6@0Z?X<0:Sj300@0:Sj300<0000002XnP`0Z
?X<01@0Z?X<00`000000<DRE0358U@030=@m6@030000000aB9D0<DRE0080<DRE00<0e3dI0000000a
B9D00P0aB9D2000000D0=U2U00<0000003I@Y@0fD:D00`0fD:D00`000000=U2U03I@Y@0203I@Y@03
0000003oBAl0odTO0080odTO00<000000?m97`3oBAl0103oBAl00`000000?EV[0?m97`030?m97`03
0000003oBAl0odTO00<0odTO00<0?EV[0000003oBAl01P3oBAl00`000000odTO0000000200000080
?EV[00<000000?i87P3nB1h01P3nB1h00`000000oTPN0?i87P040?i87P80?EV[103nB1h01@0mFJ/0
oTPN0?i87P3nB1h0000000P0oTPN0`0000050?U67@0303eIZ`3iAQd0000000T0nDHM00<000000?U6
7@3iAQd00P3iAQd203eIZ`<0nDHM00<000000?U67@3iAQd0103iAQd00`0mFJ/0nDHM0?U67@020000
00030?ofkP0mFJ/0?EV[00D0ooK^0`3D?AT40?ofkP030=@m6@3om^h0ooK^0100ooK^00<0e3dI0?of
kP3om^h03P3om^h30=@m6@l0ooK^00<0e3dI0?ofkP3om^h05P3om^h2000002h0ooK^00<000000?of
kP3om^h01P3om^h10?ooo`00<03om^h00`000000ooK^0?ofkP0J0?ofkP030=@m6@3om^h0ooK^00d0
ooK^00<000000?ofkP3om^h00P3om^h01@3D?AT0ooK^0?ofkP3D?AT0ooK^00<0e3dI00@0ooK^0=@m
6@3D?AT0e3dI2@3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI
0?ofkP3D?AT00P3D?AT01`0mFJ/0ooK^03eIZ`0mFJ/0000000X?8`0000000`3D?AT200lF=P030=@m
6@000000000000<06B=A00<0000001TSD@0I8e400`0I8e400`0000008S9]028bK@04028bK@030000
000R<Vd08S9]00<08S9]00<000000=@m6@0000001@0Z?X<00`000000:Sj302XnP`0402XnP`030000
000aB9D0<DRE00@0<DRE0`3D?AT0100aB9D0e3dI0358U@0000020358U@040000000fD:D0=U2U0000
00D0=U2U00<0000003I@Y@0fD:D00P0fD:D00`000000=U2U03I@Y@0203I@Y@800000103oBAl00`00
0000odTO0?m97`030?m97`0303eIZ`3oBAl0odTO00<0odTO00<000000?m97`3oBAl0103oBAl203eI
Z`D0odTO00<000000?m97`3oBAl00P3oBAl00`0mFJ/0odTO00000002000000L0oTPN00<000000?i8
7P3nB1h01@3nB1h01@000000?EV[03eIZ`3nB1h0?EV[00@0oTPN00<000000?i87P3nB1h01P3nB1h0
0`000000oTPN0?i87P0300000080?EV[0P3iAQd00`000000nDHM0?U67@070?U67@050000003iAQd0
nDHM0?U67@0mFJ/0103iAQd00`000000nDHM0?U67@040?U67@0603eIZ`3iAQd0nDHM0?U67@000000
ooK^0P0mFJ/90?ofkP<0e3dI00<0ooK^0=@m6@3om^h04@3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP03
0=@m6@3om^h0e3dI0080e3dI303om^h00`3D?AT0ooK^0?ofkP0H0?ofkP<00000;03om^h00`000000
ooK^0?ofkP050?ofkP40oooo000`0?ofkP030000003om^h0ooK^01X0ooK^00<0e3dI0?ofkP3om^h0
3@3om^h00`000000ooK^0?ofkP020?ofkP030=@m6@3om^h0e3dI00D0ooK^0`3D?AT0103om^h0e3dI
0=@m6@3D?AT60?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0
?EV[03eIZ`0203eIZ`<0e3dI00<0?EV[0000000000000P0?5SH00`0000003aHf0=@m6@020=@m6@03
0000000I8e406B=A00<06B=A00L0000001TSD@0I8e406B=A0000000R<Vd0000000H08S9]00P00000
028bK@0R<Vd08S9]0000003D?AT0:Sj3000000H0:Sj300<0000002XnP`0Z?X<00P0Z?X<00`000000
<DRE000000060358U@030000000aB9D0e3dI0080e3dI0P0aB9D01@000000=U2U03I@Y@0fD:D00000
00D0=U2U00<0000003I@Y@0fD:D00P0fD:D010000000=U2U03I@Y@0fD:D2000000060?m;7`000000
00000000003oBAl000001@3oBAl00`0mFJ/0odTO0?m97`030?m97`030000003oBAl0odTO00@0odTO
00<000000?m97`0mFJ/0103oBAl01@000000odTO0?m97`3oBAl0?EV[00<0odTO00@000000?m97`00
000000001@3nB1h00`000000oTPN0?i87P050?i87P030000003nB1h0oTPN0080?EV[0`3nB1h00`00
0000oTPN0?i87P070?i87P030000003nB1h0oTPN0080oTPN00<0?EV[0?i87P0000000`0000080?U6
7@050000003iAQd0nDHM0?U67@0mFJ/01@3iAQd00`000000nDHM0?U67@030?U67@0703eIZ`3iAQd0
nDHM0?U67@000000ooK^03eIZ`0>0?ofkP<0e3dI403om^h00`3D?AT0ooK^0?ofkP0@0?ofkP030=@m
6@3om^h0ooK^0080ooK^0`3D?AT90?ofkP030=@m6@3om^h0ooK^01/0ooK^0P00000Z0?ofkP030000
003om^h0ooK^00D0ooK^0@3oool00300ooK^00<000000?ofkP3om^h06P3om^h20=@m6@d0ooK^00<0
00000?ofkP3om^h00`3om^h20=@m6@T0ooK^0`3D?AT00`3om^h0e3dI0=@m6@040?ofkP030=@m6@3o
m^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h02@3om^h0103D?AT0?EV[03eIZ`0mFJ/20?ofkP80?EV[
0P3D?AT300lF=P050000000?5SH0e3dI00lF=P0000000`3D?AT301TSD@040000000I8e406B=A0000
00808S9]00<00000028bK@0R<Vd0100R<Vd01P0000008S9]028bK@000000:Sj30=@m6@80:Sj300<0
000002XnP`0Z?X<00`0Z?X<01@000000:Sj302XnP`0Z?X<000000080<DRE00<000000358U@0aB9D0
100aB9D00`000000<DRE0=@m6@020358U@<0e3dI100fD:D00`000000=U2U03I@Y@0303I@Y@050000
000fD:D0=U2U03I@Y@0000000P0fD:D010000000>eRb03]H/P0000030?m;7`<000000`3oBAl00`0m
FJ/000000?m97`040?m97`030000003oBAl0odTO00@0odTO00@000000?m97`3oBAl0?EV[0`3oBAl0
10000000odTO0?m97`0mFJ/30?m97`030000003oBAl0odTO0080odTO0`0000000`3nB1h000000?i8
7P060?i87P040000003nB1h0oTPN03eIZ`80oTPN0`0mFJ/00`000000oTPN0?i87P060?i87P030000
003nB1h0oTPN0080oTPN00D0?EV[0?i87P3nB1h0oTPN000000020?i87P8000001@3iAQd01@000000
nDHM0?U67@3iAQd0?EV[00D0nDHM00<000000?U67@3iAQd00`3iAQd00`0mFJ/0nDHM0?U67@020?U6
7@030000000mFJ/0ooK^00l0ooK^00@0e3dI0?ofkP3D?AT0e3dI3P3om^h00`3D?AT0ooK^0?ofkP0@
0?ofkP030=@m6@3om^h0ooK^00D0ooK^0P3D?AT70?ofkP030=@m6@3om^h0ooK^01d0ooK^0`00000W
0?ofkP030000003om^h0ooK^00D0ooK^0@3oool00300ooK^00<000000?ofkP3om^h06P3om^h00`3D
?AT0ooK^0=@m6@030=@m6@P0ooK^00<000000?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP0;0?of
kPH0e3dI00<0ooK^0=@m6@3om^h01P3om^h00`3D?AT0ooK^0?ofkP080?ofkP0503eIZ`3D?AT0?EV[
03eIZ`3om^h00`0mFJ/20?ofkP080000000?5SH03aHf00lF=P0000003aHf0=@m6@00000201TSD@03
0000000I8e40e3dI00<0e3dI0P0I8e401@0000008S9]028bK@0R<Vd0000000H08S9]0P0000000`0Z
?X<0e3dI02XnP`0202XnP`030000000Z?X<0:Sj300@0:Sj300@0000002XnP`0Z?X<000000`0aB9D0
0`000000<DRE0358U@040358U@070000003D?AT0<DRE0358U@000000=U2U000000030=@m6@0303I@
Y@000000=U2U00@0=U2U00<0000003I@Y@0fD:D00P0fD:D2000000<0>eRb00<0000003eIZ`3oBal0
0P3oBal01`000000od/O000000000000?EV[0?m97`0000001@3oBAl00`000000odTO0?m97`040?m9
7`040000003oBAl0odTO0?m97`80?EV[00@0odTO0000003oBAl0?EV[103oBAl00`000000odTO0?m9
7`050?m97`<000001P3nB1h00`000000oTPN03eIZ`050?i87P040000000mFJ/0?EV[03eIZ`D0oTPN
00<000000?i87P3nB1h00P3nB1h00`0mFJ/0oTPN0?i87P020?i87P030000003nB1h0oTPN0080oTPN
0`0000020?U67@040000003iAQd0nDHM03eIZ`H0nDHM00<000000?U67@3iAQd00P3iAQd00`0mFJ/0
nDHM0?U67@020?U67@80?EV[403om^h00`3D?AT0ooK^0?ofkP020?ofkP<0e3dI2`3om^h00`3D?AT0
ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00P0ooK^0`3D?AT40?ofkP030=@m6@3om^h0ooK^0200
ooK^0`00000T0?ofkP030000003om^h0ooK^00D0ooK^0@3oool00300ooK^00<000000?ofkP3om^h0
6P3om^h00`3D?AT0ooK^0?ofkP030?ofkP<0e3dI103om^h00`000000ooK^0?ofkP050?ofkP030=@m
6@3om^h0ooK^00h0ooK^1P3D?AT50?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0?EV[0=@m6@0mFJ/0
0P0mFJ/20?ofkP0403eIZ`3om^h0?EV[000000<03aHf00<000000=@m6@0000000`0I8e400`000000
6B=A01TSD@0301TSD@<0e3dI0`0R<Vd00`0000008S9]028bK@04028bK@040000000Z?X<0:Sj30=@m
6@@0:Sj300<0000002XnP`0Z?X<00`0Z?X<00`000000:Sj3000000050358U@030000000aB9D0<DRE
00<0<DRE00L0e3dI0358U@0aB9D0<DRE0000000fD:D0000000<0=U2U0`3D?AT503I@Y@050000000f
D:D0=U2U03I@Y@0000000P0kF;801@3D?AT0>eRb0000003oBal0?EV[0080od/O00D000000?m;7`3o
Bal0?EV[0?m;7`03000000@0odTO00<000000?m97`3oBAl0103oBAl00`000000odTO0?m97`030?m9
7`0303eIZ`3oBAl0?EV[00D0odTO00<000000?m97`3oBAl01P3oBAl00`000000odTO000000030000
00040?i87P000000oTPN03eIZ`H0oTPN00@000000?i87P3nB1h0oTPN0`0mFJ/20?i87P050000003n
B1h0oTPN0?i87P0mFJ/0103nB1h00`000000oTPN0?i87P060?i87P<0000000<0nDHM03eIZ`3iAQd0
1@3iAQd010000000nDHM0?U67@3iAQd203eIZ`80nDHM100mFJ/A0?ofkP030=@m6@3om^h0ooK^00D0
ooK^0P3D?AT90?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h02`3om^h30=@m6@03
0?ofkP3D?AT0ooK^02@0ooK^0P00000S0?ofkP030000003om^h0ooK^00@0ooK^0@3oool002l0ooK^
00<000000?ofkP3om^h06`3om^h00`3D?AT0ooK^0?ofkP060?ofkP@0e3dI00<000000?ofkP3om^h0
103om^h20=@m6A<0ooK^1P3D?AT20?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0?EV[0=@m6@0mFJ/0
0P0mFJ/30?ofkP80?EV[00<0ooK^0000000?5SH00P0?5SH00`000000e3dI01TSD@0301TSD@030000
000I8e406B=A00<06B=A00<00000028bK@0R<Vd00`3D?AT00`0R<Vd00000028bK@03028bK@040000
000Z?X<000000=@m6@H0:Sj300<0000002XnP`0Z?X<00`0Z?X<00`000000<DRE0358U@040358U@03
0000000aB9D0<DRE00<0<DRE00@0e3dI0000000aB9D000000`0fD:D00`000000=U2U03I@Y@0203I@
Y@040000003D?AT0e3dI0=@m6@80=U2U00<0000003I@Y@0fD:D00P0000001@0kF;80e3dI03]H/P0k
F;8000000080od/O00D0?EV[0?m;7`3oBal0000003eIZ`030?m;7`030000003oBal0000000800000
00<0odTO0000003oBAl0103oBAl00`000000odTO0?m97`040?m97`030000000mFJ/0odTO00D0odTO
00<000000?m97`3oBAl01@3oBAl00`000000odTO0?m97`040?m97`80000000<0?EV[0?i87P3nB1h0
103nB1h00`000000oTPN0?i87P050?i87P<0?EV[0P3nB1h00`0mFJ/0oTPN0?i87P020?i87P030000
003nB1h0oTPN00L0oTPN00D000000?i87P0mFJ/0?EV[000000050?U67@050000003iAQd0nDHM0?U6
7@0mFJ/00P3iAQd503eIZa80ooK^00<0e3dI0?ofkP3om^h01`3om^h30=@m6@H0ooK^00<0e3dI0?of
kP3om^h03`3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP80e3dI9`3om^h300000200ooK^00<000000?of
kP3om^h0103om^h10?ooo`00;`3om^h00`000000ooK^0?ofkP0L0?ofkP030=@m6@3om^h0ooK^00P0
ooK^00@000000=@m6@3D?AT0e3dI0`3om^h00`3D?AT0ooK^0=@m6@0D0?ofkP030=@m6@3om^h0e3dI
00D0e3dI2@3om^h0100mFJ/0ooK^0=@m6@0mFJ/40?ofkP80?EV[0P3om^h01@0000003aHf00lF=P0?
5SH0e3dI00H06B=A00L0000001TSD@0I8e406B=A0000000R<Vd0000000@08S9]103D?AT01P0R<Vd0
000002XnP`0Z?X<000000=@m6@H0:Sj300<0000002XnP`0Z?X<00P0Z?X<00`000000<DRE00000006
0358U@090000000aB9D0<DRE0358U@3D?AT0<DRE0000000aB9D0000000<0=U2U00<0000003I@Y@0f
D:D00`0fD:D00`000000=U2U03I@Y@030=@m6@8000000P0kF;800`000000e3dI03]H/P0203]H/P06
0000003oBal0od/O03eIZ`3oBal0?EV[103oBal00`000000od/O0?m;7`020?m;7`<00000103oBAl0
0`000000odTO0?m97`040?m97`0403eIZ`3oBAl0?EV[03eIZ`<0odTO00<000000?m97`3oBAl01P3o
BAl00`000000odTO0?m97`040?m97`030000000mFJ/0odTO00@000000P3nB1h00`000000oTPN0?i8
7P060?i87P030000003nB1h0?EV[00@0?EV[00<0oTPN0000003nB1h0203nB1h00`000000oTPN03eI
Z`030?i87P<000000P3iAQd00`000000nDHM0?U67@0403eIZ`040?U67@0mFJ/0?EV[0=@m6A<0ooK^
00<0e3dI0?ofkP3om^h02P3om^h30=@m6@<0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^
0?ofkP0?0?ofkP030=@m6@3om^h0ooK^02P0ooK^0`00000M0?ofkP030000003om^h0ooK^00@0ooK^
0@3oool002l0ooK^00<000000?ofkP3om^h0703om^h00`3D?AT0ooK^0?ofkP070?ofkP030000003o
m^h0ooK^0080ooK^103D?AT00`3om^h0e3dI0?ofkP0C0?ofkP030=@m6@3om^h0ooK^0080ooK^1P3D
?AT50?ofkP0503eIZ`3om^h0?EV[0=@m6@0mFJ/0103om^h01@0mFJ/0ooK^0?ofkP3om^h000000080
3aHf00<0e3dI0000000I8e401@0I8e40100000006B=A01TSD@000002028bK@030000000R<Vd08S9]
00@08S9]00<00000028bK@3D?AT00P3D?AT00`0Z?X<0e3dI0000000702XnP`040000000Z?X<0:Sj3
00000080<DRE00<000000358U@0aB9D0100aB9D01@000000<DRE0358U@0aB9D0e3dI0080<DRE00<0
000003I@Y@0fD:D00`0fD:D00`000000=U2U03I@Y@0203I@Y@030000000fD:D0=U2U00<0=U2U0`3D
?AT00`0kF;80e3dI03]H/P0303]H/P060000003oBal0od/O0?m;7`0mFJ/00000103oBal00`000000
od/O0?m;7`030?m;7`030000003oBal000000080000000<0odTO0000003oBAl0103oBAl00`0mFJ/0
00000?m97`020?m97`80?EV[00<0odTO0000003oBAl01P3oBAl00`000000odTO0?m97`040?m97`80
?EV[1P3oBAl3000000L0oTPN00@000000?i87P3nB1h0?EV[103nB1h803eIZ`<0oTPN00<0000003eI
Z`3nB1h0103nB1h803eIZ`@0nDHM00<0?EV[0=@m6@3om^h04P3om^h00`3D?AT0ooK^0?ofkP0>0?of
kP80e3dI00<0ooK^0=@m6@3om^h0403om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^
02/0ooK^0P00000K0?ofkP030000003om^h0ooK^00@0ooK^0@3oool002l0ooK^00<000000?ofkP3o
m^h0703om^h00`3D?AT0ooK^0?ofkP070?ofkP030000003om^h0ooK^00@0ooK^1@3D?ATC0?ofkP05
0=@m6@3om^h0ooK^0?ofkP3D?AT00`3om^h70=@m6@@0?EV[00<0e3dI0?ofkP3om^h00P3om^h203eI
Z`<0ooK^00H0000000lF=P0?5SH0e3dI01TSD@00000501TSD@040000000I8e406B=A000000<08S9]
00<00000028bK@0R<Vd00`0R<Vd00`0000008S9]0000000202XnP`<0e3dI00<0000002XnP`0Z?X<0
100Z?X<00`000000:Sj3000000040358U@030000000aB9D0<DRE00@0<DRE00<000000358U@3D?AT0
0P0aB9D00`000000=U2U0000000403I@Y@030000000fD:D0=U2U00<0=U2U00@0000003I@Y@0fD:D0
=U2U0P00000203]H/P<0e3dI0`0kF;801@000000od/O03eIZ`0mFJ/0od/O0080?EV[0`3oBal00`00
0000od/O0?m;7`030?m;7`030000003oBal0od/O0080od/O0`0000030?m97`0303eIZ`000000odTO
00D0odTO0P0mFJ/70?m97`030000003oBAl0odTO00<0odTO00<0?EV[0000003oBAl01P3oBAl00`00
0000odTO0?m97`02000000@0oTPN00@000000?i87P3nB1h0?EV[1@3nB1h00`000000oTPN0?i87P05
0?i87PX0?EV[0P3nB1h01@000000oTPN0?i87P0mFJ/0000000@0nDHM00<0?EV[0000003D?AT04`3o
m^h00`3D?AT0ooK^0?ofkP0@0?ofkP<0e3dI403om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3o
m^h0ooK^02d0ooK^0`00000H0?ofkP030000003om^h0ooK^00@0ooK^0@3oool002l0ooK^00<00000
0?ofkP3om^h0703om^h20=@m6@L0ooK^00<000000?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP06
0=@m6A00ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@070?ofkPH0e3dI00<0?EV[0=@m6@3om^h00`3o
m^h203eIZ`<0ooK^00<0000000lF=P3D?AT00P0I8e400`0000006B=A01TSD@0401TSD@800000100R
<Vd00`0000008S9]028bK@04028bK@050000000Z?X<0:Sj302XnP`3D?AT00P0Z?X<30=@m6@D0:Sj3
00<000000358U@0aB9D0100aB9D00`000000<DRE0358U@040358U@040=@m6@0aB9D0<DRE00000080
=U2U00<0000003I@Y@0fD:D00`0fD:D00`000000=U2U03I@Y@0203I@Y@040000000fD:D0=U2U0000
0080>eRb00D0000003]H/P3D?AT0>eRb000000040=@m6@0703eIZ`3oBal0od/O0?m;7`000000od/O
03eIZ`020?m;7`030000003oBal0od/O00<0od/O00<000000?m;7`3oBal00`3oBal01`000000od/O
000000000000?EV[0?m97`0000001`3oBAl00`000000?EV[03eIZ`040?m97`030000003oBAl0odTO
00<0odTO00<0?EV[0000003oBAl01`3oBAl00`000000odTO0?m97`020?m97`8000000P3nB1h00`00
0000oTPN03eIZ`050?i87P030000003nB1h0oTPN00L0oTPN00<0000003eIZ`3nB1h01`3nB1h01000
0000oTPN0?i87P0mFJ/20?i87P8000000P0mFJ/00`000000e3dI0=@m6@0C0?ofkP030=@m6@3om^h0
ooK^0140ooK^00<0e3dI0?ofkP3D?AT00P3D?AT=0?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI
0?ofkP3om^h0<@3om^h3000001H0ooK^00<000000?ofkP3om^h00`3om^h10?ooo`00;P3om^h00`00
0000ooK^0?ofkP0M0?ofkP030=@m6@3om^h0e3dI0080e3dI0`3om^h00`000000ooK^0?ofkP040?of
kP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3D?AT01@3D?AT=0?ofkP040=@m6@3om^h0ooK^
0=@m6@X0ooK^00<0?EV[0=@m6@3D?AT0103D?AT20?ofkP0303eIZ`3om^h0?EV[00<0ooK^0P000000
103D?AT06B=A01TSD@00000601TSD@030000000R<Vd08S9]00@08S9]00<00000028bK@0R<Vd00P0R
<Vd00`000000:Sj30000000202XnP`060=@m6@0Z?X<0:Sj302XnP`000000:Sj30`3D?AT0100Z?X<0
00000358U@0000050358U@030000000aB9D0<DRE00@0<DRE00<0e3dI0358U@000000100fD:D00`00
0000=U2U03I@Y@0303I@Y@030000000fD:D0=U2U0080=U2U0P00000303]H/P050000000kF;80e3dI
03]H/P000000100kF;800`000000od/O0?m;7`020?m;7`050000003oBal0?EV[0?m;7`0000001@3o
Bal00`000000od/O0?m;7`030?m;7`050000003oBal0od/O03eIZ`3oBal00`0000050?m97`040000
003oBAl0odTO0?m97`80?EV[0P3oBAl00`000000odTO0?m97`020?m97`0303eIZ`3oBAl0000000L0
odTO00<000000?m97`3oBAl01@3oBAl30000000303eIZ`3nB1h0oTPN00<0oTPN00<000000?i87P3n
B1h01`3nB1h00`000000?EV[0?i87P070?i87P040000003nB1h0?EV[03eIZ`@0oTPN00<0?EV[0000
00000000103D?ATB0?ofkP030=@m6@3om^h0ooK^0100ooK^00<0e3dI0?ofkP3om^h00`3om^h30=@m
6@X0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0d0?ofkP800000503om^h00`00
0000ooK^0?ofkP030?ofkP40oooo000^0?ofkP030000003om^h0ooK^01h0ooK^00@0e3dI0?ofkP3o
m^h0ooK^0P3D?AT00`000000ooK^0?ofkP030?ofkP80e3dI1P3om^h00`3D?AT0ooK^0?ofkP020?of
kPD0e3dI2P3om^h00`3D?AT0ooK^0=@m6@0:0?ofkP80?EV[00<0ooK^03eIZ`3om^h01`3D?AT01P0m
FJ/0ooK^0?ofkP3om^h000000=@m6@@06B=A00<0000001TSD@0I8e400P0I8e42000000H08S9]00D0
0000028bK@0R<Vd08S9]0000000202XnP`030000000Z?X<0e3dI00D0:Sj300@0000002XnP`0Z?X<0
:Sj30`3D?AT00`000000<DRE0358U@040358U@030000000aB9D0<DRE0080<DRE00<0e3dI0358U@00
00001P0fD:D00`000000=U2U03I@Y@0203I@Y@030000000fD:D0=U2U0080=U2U00<0000003]H/P0k
F;800`0kF;80103D?AT0>eRb03]H/P00000403]H/P030000003oBal0od/O0080od/O00<000000?m;
7`3oBal00P0mFJ/50?m;7`030000003oBal0od/O00<0od/O00<000000?m;7`0mFJ/00`3oBal00`00
0000od/O00000003000000030?m97`000000odTO00@0odTO0P0mFJ/01`000000odTO0?m97`3oBAl0
?EV[0?m97`0000001`3oBAl00`000000odTO0?m97`060?m97`030000003oBAl0?EV[00@000000P3n
B1h00`000000oTPN0?i87P060?i87P80?EV[203nB1h00`000000oTPN03eIZ`050?i87P0803eIZ`3n
B1h000000?ofkP3D?AT0ooK^0=@m6@3om^h20=@m6@l0ooK^00<0e3dI0?ofkP3om^h04@3om^h00`3D
?AT0ooK^0?ofkP060?ofkP80e3dI1`3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^
03H0ooK^0`00000A0?ofkP030000003om^h0ooK^00<0ooK^0@3oool002h0ooK^00<000000?ofkP3o
m^h07P3om^h00`3D?AT0ooK^0?ofkP030?ofkP060000003D?AT0e3dI0=@m6@3om^h0e3dI203om^h0
0`3D?AT0ooK^0?ofkP050?ofkPD0e3dI1`3om^h20=@m6@X0ooK^100mFJ/20?ofkP0303eIZ`3D?AT0
ooK^00L0e3dI00<0ooK^0000003D?AT0100I8e401@0000006B=A01TSD@0I8e40000000808S9]00<0
0000028bK@0R<Vd0100R<Vd0100000008S9]028bK@00000302XnP`030=@m6@0Z?X<0:Sj300D0:Sj3
00@0000002XnP`0Z?X<000000P0aB9D30=@m6@D0<DRE00P000000358U@0aB9D0<DRE0=@m6@000000
=U2U000000D0=U2U00<0000003I@Y@0fD:D00`0fD:D01P000000=U2U03I@Y@000000>eRb000000@0
>eRb00D0e3dI03]H/P0kF;80>eRb0000000303]H/P030000003oBal0od/O0080od/O00<000000?m;
7`3oBal00P3oBal00`0mFJ/0od/O0?m;7`020?m;7`030000003oBal0od/O00<0od/O00<0000003eI
Z`3oBal00`3oBal00`000000od/O0?m;7`030?m;7`8000001P3oBAl01@000000?EV[03eIZ`3oBAl0
?EV[0080odTO00<000000?m97`3oBAl0103oBAl00`000000odTO0?m97`060?m97`030000000mFJ/0
?EV[00D0odTO0`0000070?i87P0303eIZ`3nB1h0oTPN00L0oTPN00<000000?i87P0mFJ/0103nB1h2
03eIZ`8000000P3om^h20=@m6@@0ooK^0`3D?AT<0?ofkP030=@m6@3om^h0ooK^0140ooK^00<0e3dI
0?ofkP3om^h0203om^h30=@m6@@0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP0i
0?ofkP8000003`3om^h00`000000ooK^0?ofkP030?ofkP40oooo000^0?ofkP030000003om^h0ooK^
01l0ooK^00D0e3dI0?ofkP3om^h0ooK^000000030?ofkPD0e3dI1P3om^h00`3D?AT0ooK^0?ofkP08
0?ofkPD0e3dI103om^h20=@m6@T0ooK^100mFJ/30?ofkP0403eIZ`3D?AT0ooK^03eIZ`<0ooK^1P3D
?AT401TSD@040000000I8e406B=A000000<08S9]00<00000028bK@0R<Vd0100R<Vd00`0000008S9]
0000000402XnP`030=@m6@000000:Sj300D0:Sj300<0000002XnP`0000001@0aB9D010000000e3dI
0=@m6@3D?AT30358U@040000000aB9D0e3dI000000<0=U2U00<0000003I@Y@0fD:D00`0fD:D00`00
0000=U2U03I@Y@0203I@Y@030000000fD:D000000080>eRb00L0000003]H/P0kF;80>eRb0=@m6@0k
F;8000000080>eRb00D0000003]H/P0kF;80>eRb000000040?m;7`030000003oBal0od/O0080od/O
00<0000003eIZ`0mFJ/00P3oBal00`000000od/O0?m;7`030?m;7`0303eIZ`3oBal0od/O00<0od/O
00<000000?m;7`3oBal0103oBal3000000@0odTO00<000000?m97`3oBAl00P0mFJ/00`3oBAl00000
0?m97`060?m97`030000003oBAl0odTO00D0odTO00<0000003eIZ`3oBAl01P3oBAl00`000000odTO
0?m97`02000000@0oTPN00<0?EV[0000003nB1h01`3nB1h00`000000oTPN03eIZ`040?i87P0303eI
Z`3nB1h0000000<0ooK^00<0e3dI0?ofkP3D?AT01`3om^h20=@m6@X0ooK^00<0e3dI0?ofkP3om^h0
4@3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP<0e3dI00<0ooK^0=@m6@3om^h0403om^h00`3D?AT0ooK^
0?ofkP0k0?ofkP<000003@3om^h00`000000ooK^0?ofkP020?ofkP40oooo000^0?ofkP030000003o
m^h0ooK^01l0ooK^0P3D?AT0103om^h000000?ofkP3om^h20=@m6@<0ooK^1@3D?AT30?ofkP030=@m
6@3om^h0ooK^00`0ooK^103D?AT00`3om^h0e3dI0?ofkP090?ofkP0403eIZ`3om^h0?EV[03eIZ`<0
ooK^00<0?EV[0=@m6@0mFJ/01@3om^h00`0mFJ/0ooK^0=@m6@050=@m6@806B=A0P000005028bK@03
0000000R<Vd08S9]00@08S9]00<0000002XnP`0Z?X<00P0Z?X<00`3D?AT0:Sj30000000702XnP`03
0000000aB9D0<DRE00@0<DRE00@000000358U@0aB9D0<DRE0`3D?AT00`000000<DRE0=@m6@0403I@
Y@030000000fD:D0=U2U00<0=U2U00<0000003I@Y@0fD:D00`0fD:D00`000000>eRb03]H/P0203]H
/P060000000kF;80>eRb0=@m6@0kF;8000000`0kF;801@000000>eRb03]H/P0kF;80000000@0od/O
00D000000?m;7`3oBal0od/O000000020?m;7`0303eIZ`3oBal0000000@0od/O00<0?EV[0000003o
Bal00`3oBal00`000000od/O0?m;7`040?m;7`040000003oBal0od/O0?m;7`80000000D0odTO0000
003oBAl0odTO03eIZ`020?m97`<0?EV[1@3oBAl00`000000odTO0?m97`050?m97`030000000mFJ/0
odTO00H0odTO00<000000?m97`3oBAl00`3oBAl2000000030?i87P0mFJ/0000000P0oTPN00<00000
0?i87P0mFJ/00`3nB1h203eIZ`030?i87P000000ooK^00<0ooK^0P3D?AT:0?ofkP<0e3dI1`3om^h0
0`3D?AT0ooK^0?ofkP0@0?ofkP030=@m6@3om^h0ooK^00l0ooK^0`3D?AT@0?ofkP030=@m6@3om^h0
ooK^03h0ooK^0`00000:0?ofkP030000003om^h0ooK^0080ooK^0@3oool002d0ooK^00<000000?of
kP3om^h08P3om^h010000000e3dI0=@m6@3D?AT80?ofkPD0e3dI00<0ooK^0=@m6@3om^h03`3om^h4
0=@m6@P0ooK^00@0?EV[0?ofkP0mFJ/0?EV[103om^h00`0mFJ/0e3dI0?ofkP050?ofkP0803eIZ`3D
?AT0ooK^0?ofkP0mFJ/06B=A0=@m6@0I8e430=@m6@H08S9]00<00000028bK@0R<Vd00`0R<Vd00`00
0000:Sj30000000202XnP`050=@m6@0Z?X<0:Sj302XnP`0000001@0Z?X<00`000000<DRE00000006
0358U@030000000aB9D0<DRE00<0<DRE0`3D?AT503I@Y@030000000fD:D0=U2U00<0=U2U00L00000
03I@Y@0fD:D0=U2U0000000kF;80000000<0>eRb00<0000003]H/P3D?AT00`0kF;8010000000>eRb
03]H/P00000303]H/P<000000P3oBal01@000000od/O0?m;7`3oBal0000000<0od/O00<0?EV[0000
003oBal00P3oBal00`0mFJ/000000?m;7`040?m;7`030000003oBal0od/O00@0od/O00<000000?m;
7`3oBal00`3oBal30000000503eIZ`3oBAl0odTO0?m97`0000000P3oBAl303eIZ`030?m97`000000
odTO00H0odTO00<0000003eIZ`3oBAl01P3oBAl00`000000odTO0?m97`060?m97`0303eIZ`000000
000000L0oTPN00<000000?i87P0mFJ/00P3nB1h303eIZ`030?i87P000000ooK^00@0ooK^0P3D?AT=
0?ofkP<0e3dI0`3om^h00`3D?AT0ooK^0?ofkP0A0?ofkP030=@m6@3om^h0ooK^0100ooK^00<0e3dI
0?ofkP3D?AT00P3D?AT=0?ofkP030=@m6@3om^h0ooK^0440ooK^0P0000080?ofkP030000003om^h0
ooK^0080ooK^0@3oool002d0ooK^00<000000?ofkP3om^h08P3om^h010000000ooK^0?ofkP3om^h4
0=@m6@P0ooK^103D?AT?0?ofkP030=@m6@3om^h0e3dI00@0e3dI103om^h0100mFJ/0ooK^0?ofkP0m
FJ/40?ofkP80?EV[00<0e3dI0?ofkP3om^h0103om^h01@3D?AT0ooK^0?ofkP0mFJ/0000000@06B=A
00<00000028bK@3D?AT00P3D?AT4028bK@050000000R<Vd08S9]028bK@0000000P0Z?X<010000000
:Sj302XnP`3D?AT402XnP`030000000Z?X<0:Sj3008000000`0aB9D00`000000<DRE0358U@040358
U@030000000aB9D0<DRE0080<DRE00<0e3dI03I@Y@0000000`3D?AT303I@Y@030000000fD:D0=U2U
00<0=U2U00<0000003I@Y@0000000P0kF;800`000000>eRb03]H/P0203]H/P030000003D?AT0>eRb
0080>eRb00@0000003]H/P0kF;8000000P0kF;8200000080od`P0`0000030?m;7`030000003oBal0
od/O0080od/O0P0mFJ/0103oBal0?EV[0?m;7`0000050?m;7`030000003oBal0od/O00<0od/O00<0
00000?m;7`3oBal0103oBal010000000od/O03eIZ`3oBal4000000D0odTO0`0mFJ/60?m97`0303eI
Z`3oBAl0odTO00D0odTO00<000000?m97`3oBAl01P3oBAl0100mFJ/000000?m97`3oBAl400000080
oTPN00@0000003eIZ`0mFJ/0oTPN0P0mFJ/0103nB1h0?EV[0?i87P0000050?ofkP030=@m6@3om^h0
e3dI0100ooK^0P3D?AT00`3om^h0e3dI0?ofkP0B0?ofkP030=@m6@3om^h0ooK^0100ooK^00<0e3dI
0?ofkP3om^h00P3om^h30=@m6@X0ooK^00<0e3dI0?ofkP3om^h0@`3om^h3000000D0ooK^00<00000
0?ofkP3om^h00P3om^h10?ooo`00;@3om^h00`000000ooK^0?ofkP0Q0?ofkP030000003om^h0ooK^
00D0ooK^103D?AT70?ofkPH0e3dI2P3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI0080ooK^1@3D?AT2
0?ofkP80?EV[103om^h203eIZ`030?ofkP3D?AT0ooK^00<0ooK^00@0e3dI03eIZ`3om^h0?EV[0P3o
m^h0100000006B=A01TSD@000002028bK@030000000R<Vd08S9]00@0e3dI00@00000028bK@0R<Vd0
0000100Z?X<00`000000e3dI02XnP`0402XnP`030000000Z?X<0000000D0<DRE00<000000358U@0a
B9D01@0aB9D01@000000<DRE0358U@000000e3dI0080=U2U00<0000003I@Y@0fD:D00`3D?AT00`0f
D:D0000003I@Y@0303I@Y@030000000fD:D0000000<0>eRb00D0000003]H/P0kF;80>eRb0=@m6@05
03]H/P030000000kF;80>eRb008000000P0oGkl010000000od`P0?m<803oC203000000030?m;7`00
0000od/O00<0od/O00<000000?m;7`0mFJ/00P3oBal00`000000od/O0?m;7`030?m;7`030000003o
Bal0od/O00<0od/O00<000000?m;7`3oBal0103oBal00`000000?EV[0?m;7`020?m;7`030000003o
Bal0od/O00<000000P3oBAl00`000000odTO0?m97`0303eIZ`80odTO00<0?EV[0?m97`3oBAl01@3o
BAl00`000000odTO0?m97`050?m97`80?EV[00<000000?m97`3oBAl01@3oBAl20000000403eIZ`3n
B1h0?EV[03eIZ`80oTPN00<0?EV[0000000000001P3om^h20=@m6A<0ooK^0`3D?ATB0?ofkP030=@m
6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h01P3om^h20=@m6@L0ooK^00<0e3dI0?ofkP3om^h0
A`3om^h3000000<0ooK^00@000000?ofkP3om^h0ooK^0@3oool002d0ooK^00<000000?ofkP3om^h0
803om^h00`000000ooK^0?ofkP090?ofkPD0e3dI103om^h00`3D?AT0ooK^0?ofkP050=@m6@D0ooK^
0P3D?AT40?ofkP030=@m6@3om^h0ooK^00<0ooK^1@3D?AT50?ofkP0403eIZ`3om^h0ooK^0=@m6@@0
ooK^00@0e3dI03eIZ`3om^h0?EV[0P3om^h0100000006B=A01TSD@000003028bK@030000000R<Vd0
8S9]00<08S9]0`3D?AT502XnP`030=@m6@000000:Sj300D0:Sj300<000000358U@0aB9D01@0aB9D0
0`000000<DRE0358U@040358U@040000000aB9D000000=@m6@<0=U2U00<0000003I@Y@0fD:D00`0f
D:D30=@m6@@0=U2U00<0000003]H/P0kF;800`0kF;801@000000>eRb03]H/P3D?AT0000000@0>eRb
00@0000003]H/P0kF;8000000`0oGkl01@000000od`P0?m<803oC20000000080od`P100000020?m;
7`030000000mFJ/0od/O0080?EV[00<000000?m;7`3oBal00`3oBal00`000000od/O0?m;7`020?m;
7`030000003oBal0od/O00@0od/O00<0000003eIZ`3oBal00`3oBal00`000000od/O0?m;7`030?m;
7`<000001@3oBAl503eIZ`@0odTO00<000000?m97`3oBAl01@3oBAl00`0mFJ/000000?m97`080?m9
7`040000000mFJ/0?EV[03eIZ`8000000P0mFJ/2000000L0ooK^0P3D?ATD0?ofkP030=@m6@3om^h0
e3dI0080e3dI3P3om^h00`3D?AT0ooK^0?ofkP0@0?ofkP030=@m6@3om^h0ooK^00P0ooK^0`3D?AT4
0?ofkP030=@m6@3om^h0ooK^04X0ooK^0P0000000`3om^h000000?ofkP020?ofkP40oooo000]0?of
kP030000003om^h0ooK^0200ooK^00<000000?ofkP3om^h0303om^h70=@m6@H0ooK^1P3D?AT60?of
kP030=@m6@3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h01@3D?AT00`3om^h0?EV[03eIZ`020?of
kP060=@m6@3om^h0ooK^0?ofkP3D?AT0ooK^0P0mFJ/40?ofkP800000100R<Vd00`0000008S9]028b
K@04028bK@030000000Z?X<0e3dI0080e3dI0P0Z?X<00`3D?AT0000002XnP`0402XnP`030000000a
B9D0000000L0<DRE00<000000358U@0aB9D0100aB9D00`000000e3dI03I@Y@0403I@Y@030000000f
D:D0=U2U00@0=U2U00<000000=@m6@3D?AT00P3D?AT00`0kF;80000003]H/P0303]H/P030000000k
F;80e3dI0080>eRb00<0000003]H/P0kF;800P0kF;83000000@0?eno00D000000?m<803oC200od`P
000000020?m<80030000003oC200od`P0080000000<0?EV[0000003oBal00P3oBal203eIZ`@0od/O
00<000000?m;7`3oBal00P3oBal00`000000od/O0?m;7`030?m;7`80?EV[103oBal00`000000od/O
0?m;7`040?m;7`030000003oBal0od/O00<000000P3oBAl00`0mFJ/0odTO0?m97`020?m97`L0?EV[
103oBAl00`0mFJ/000000?m97`030?m97`P0?EV[0`3oBAl0100mFJ/000000000000000070?ofkP03
0=@m6@3om^h0e3dI01<0ooK^00<0e3dI0?ofkP3om^h00`3om^h30=@m6@/0ooK^00<0e3dI0?ofkP3o
m^h0403om^h00`3D?AT0ooK^0?ofkP0;0?ofkP<0e3dI00<0ooK^0=@m6@3om^h0C@3om^h2000000<0
ooK^0@3oool002`0ooK^00<000000?ofkP3om^h0803om^h00`000000ooK^0?ofkP0A0?ofkPD0e3dI
1`3om^h50=@m6@@0ooK^00<0e3dI0?ofkP3om^h00`3om^h01@0mFJ/0ooK^03eIZ`3om^h0?EV[0080
ooK^1@3D?AT01@3om^h0e3dI0?ofkP3om^h0e3dI0080ooK^00<0?EV[0?ofkP3om^h00`3om^h00`00
00008S9]028bK@04028bK@030000000R<Vd08S9]00808S9]00<0000002XnP`0000000`0Z?X<30=@m
6@0302XnP`000000:Sj30080:Sj300D000000358U@0aB9D0<DRE000000070358U@030000000aB9D0
<DRE0080<DRE00<000000=@m6@0000001P0fD:D00`000000=U2U03I@Y@0403I@Y@040000000fD:D0
000003]H/P<0e3dI100kF;801@000000e3dI03]H/P0kF;80000000@0>eRb00@0000003mO_`0oGkl0
00000`0oGkl01@000000od`P0?m<803oC20000000080od`P00L000000?m<803oC200od`P03eIZ`00
0000od`P0080000000<0od/O0000003oBal00P0mFJ/00`3oBal000000?m;7`040?m;7`030000003o
Bal0od/O0080od/O00<0?EV[0000003oBal00`3oBal00`000000od/O0?m;7`050?m;7`030000003o
Bal0od/O00<0od/O00<0000003eIZ`0000001P3oBAl00`000000odTO0?m97`020?m97`X0?EV[0`3o
BAl00`000000odTO03eIZ`040?m97`0503eIZ`00000000000000003om^h00`3D?AT40?ofkP80e3dI
503om^h00`3D?AT0ooK^0?ofkP060?ofkP<0e3dI203om^h00`3D?AT0ooK^0?ofkP0@0?ofkP030=@m
6@3om^h0ooK^00h0ooK^0P3D?AU=0?ofkP800000103om^h10?ooo`00;03om^h00`000000ooK^0?of
kP0O0?ofkP030000003om^h0ooK^01D0ooK^1@3D?AT0103om^h0e3dI0=@m6@3D?AT30?ofkPH0e3dI
00<0ooK^0=@m6@3om^h00P3om^h00`0mFJ/0ooK^03eIZ`020?ofkP0403eIZ`3om^h0ooK^03eIZ`80
ooK^1P3D?AT20?ofkP80?EV[1P3om^h00`0000008S9]028bK@03028bK@050000000R<Vd08S9]028b
K@0000000`0Z?X<010000000:Sj302XnP`3D?AT202XnP`@0e3dI00<0:Sj30000000aB9D00`0aB9D0
0`000000<DRE0358U@040358U@090000000aB9D0<DRE0358U@000000=U2U0=@m6@0fD:D0000000H0
=U2U00<0000003I@Y@0fD:D0100fD:D00`000000>eRb03]H/P0203]H/P060000003D?AT0e3dI0=@m
6@0kF;80e3dI100kF;800`000000>eRb03]H/P0200000080?eno00D0000003mO_`0oGkl0?eno0000
00030?m<80050000003oC200od`P0000003oC2000P0mFJ/00`3oC20000000?m<80020?m<80<00000
0P3oBal00`0mFJ/000000?m;7`030?m;7`030000003oBal0od/O0080od/O00<0?EV[0?m;7`000000
103oBal00`000000od/O0?m;7`040?m;7`030000003oBal0od/O00@0od/O00<0?EV[0?m;7`3oBal0
0`0000020?m97`030000003oBAl0odTO00D0odTO00<0?EV[0000003oBAl01`3oBAl00`000000odTO
03eIZ`040?m97`0403eIZ`000000?EV[000000D0ooK^0P3D?AT0103om^h0e3dI0?ofkP3D?ATC0?of
kP030=@m6@3om^h0ooK^00X0ooK^0`3D?AT50?ofkP030=@m6@3om^h0ooK^0100ooK^00<0e3dI0?of
kP3om^h03`3om^h00`3D?AT0ooK^0?ofkP1:0?ofkP030000003om^h0ooK^00@0ooK^0@3oool002`0
ooK^00<000000?ofkP3om^h07P3om^h00`000000ooK^0?ofkP0I0?ofkPD0e3dI1`3om^h60=@m6@80
ooK^0P0mFJ/20?ofkP0403eIZ`3om^h0ooK^03eIZ`<0ooK^00<0?EV[0?ofkP3om^h01P3D?AT00`0m
FJ/0ooK^0?ofkP040?ofkP030000000R<Vd08S9]00@08S9]00@00000028bK@0R<Vd00000100Z?X<0
0`000000e3dI02XnP`0402XnP`030000000Z?X<0e3dI0080e3dI100aB9D00`000000<DRE0358U@04
0358U@050000000aB9D0000003I@Y@3D?AT00`0fD:D00`000000=U2U03I@Y@0403I@Y@030000000f
D:D0=U2U0080=U2U00<0000003]H/P000000100kF;800`000000>eRb03]H/P030=@m6@<0>eRb00<0
000003]H/P0000000P0oGkl010000000?eno03mO_`00000303mO_`040000003oC200od`P000000<0
od`P00D0?EV[0?m<803oC200od`P000000040?m<80050000003oC20000000000003oBal00P0mFJ/3
0?m;7`070000003oBal0od/O0?m;7`0mFJ/0od/O000000040?m;7`030000003oBal0od/O00@0od/O
00<000000?m;7`3oBal0103oBal00`0mFJ/0od/O0?m;7`040?m;7`<000001P3oBAl00`0mFJ/00000
0?m97`060?m97`8000000P0mFJ/40?m97`040000000mFJ/0e3dI0=@m6@P0ooK^0`3D?ATD0?ofkP03
0=@m6@3om^h0ooK^00d0ooK^0`3D?AT00`3om^h0e3dI0?ofkP0A0?ofkP030=@m6@3om^h0ooK^0100
ooK^00<0e3dI0?ofkP3om^h0B03om^h2000000L0ooK^0@3oool002`0ooK^00<000000?ofkP3om^h0
7P3om^h00`000000ooK^0?ofkP0L0?ofkPD0e3dI1`3om^h60=@m6@<0ooK^00@0?EV[0?ofkP3om^h0
?EV[0`3om^h00`0mFJ/0ooK^0?ofkP020=@m6@030?ofkP3D?AT0e3dI00D0e3dI103om^h00`000000
8S9]028bK@03028bK@030000000R<Vd0000000D0:Sj300<0e3dI0000000Z?X<01@0Z?X<010000000
<DRE0358U@0aB9D40=@m6@030358U@000000<DRE00D0<DRE00<0000003I@Y@3D?AT01@0fD:D00`00
0000=U2U03I@Y@0303I@Y@050000000fD:D0=U2U03I@Y@0000000`0kF;800`000000>eRb03]H/P02
03]H/P030000000kF;80e3dI0080>eRb103D?AT01@000000?eno03mO_`0oGkl000000080?eno00D0
000003mO_`0oGkl0?eno000000030?m<80040000003oC200?EV[000000<0od`P00<000000?m<803o
C2000P3oC20010000000od`P0?m<803oC20300000080?EV[00D000000?m;7`3oBal0od/O03eIZ`02
0?m;7`030000003oBal0od/O0080od/O00<000000?m;7`3oBal00`3oBal00`000000od/O0?m;7`04
0?m;7`0303eIZ`3oBal0od/O00D0od/O00<000000?m;7`3oBal00`0000020?m97`0303eIZ`3oBAl0
odTO00H0odTO00<000000?m97`0mFJ/01@3oBAl00`000000?EV[000000020?ofkP<0e3dI1P3om^h2
0=@m6A@0ooK^00<0e3dI0?ofkP3om^h0403om^h30=@m6A40ooK^00<0e3dI0?ofkP3om^h03`3om^h0
0`3D?AT0ooK^0?ofkP180?ofkP030000003om^h0ooK^00L0ooK^0@3oool002`0ooK^00<000000?of
kP3om^h07@3om^h00`000000ooK^0?ofkP0P0?ofkPH0e3dI1@3om^h80=@m6@030?ofkP0mFJ/0ooK^
00<0ooK^00H0?EV[0?ofkP3D?AT0ooK^0=@m6@0mFJ/40?ofkPL0e3dI00<00000028bK@0R<Vd0100R
<Vd00`000000:Sj302XnP`0302XnP`040=@m6@0Z?X<0:Sj3000000@0:Sj300<000000358U@000000
1P0aB9D30=@m6@@0<DRE00<0000003I@Y@3D?AT01`0fD:D00`000000=U2U03I@Y@0303I@Y@030000
000fD:D0000000@0>eRb00<0000003]H/P0kF;800`0kF;801P3D?AT0>eRb03]H/P0kF;80000003]H
/P8000000`3D?AT203mO_`040000000oGkl0?eno00000080?eno00P000000?m<803oC200od`P0000
000mFJ/0od`P000000<0od`P00D000000?m<803oC200od`P000000050?m<80040000003oC2000000
00000080?EV[00D0od/O03eIZ`3oBal0od/O000000040?m;7`030000003oBal0od/O00@0od/O00<0
00000?m;7`3oBal00P3oBal203eIZ`L0od/O00<000000?m;7`3oBal0103oBal00`000000?EV[0000
00070?m97`030000003oBAl0?EV[00D0odTO00<0000003eIZ`0000001P3om^h20=@m6@@0ooK^0P3D
?ATC0?ofkP030=@m6@3om^h0ooK^0180ooK^00@0e3dI0?ofkP3D?AT0e3dI3`3om^h00`3D?AT0ooK^
0?ofkP0?0?ofkP030=@m6@3om^h0ooK^04H0ooK^0P00000:0?ofkP40oooo000/0?ofkP030000003o
m^h0ooK^01`0ooK^00<000000?ofkP3om^h0903om^h60=@m6@<0ooK^00@0e3dI03eIZ`3om^h0ooK^
1P3D?AT30?ofkP80e3dI0P3om^h00`3D?AT0ooK^0?ofkP030?ofkP0403eIZ`3om^h0ooK^0?ofkPD0
e3dI100R<Vd00`000000:Sj30000000302XnP`030=@m6@0Z?X<0:Sj30080:Sj300@0000002XnP`0Z
?X<000000`0aB9D00`000000<DRE0358U@060358U@@0e3dI0P0fD:D00`3D?AT000000000000603I@
Y@030000000fD:D0=U2U00<0=U2U00<0000003]H/P0kF;80100kF;800`000000>eRb03]H/P0203]H
/P030=@m6@000000>eRb0080>eRb00H0000003mO_`0oGkl0?eno0000000oGkl40=@m6@0303mO_`00
0000?eno0080?eno00@000000?m<803oC200?EV[0P3oC2001@000000od`P0?m<803oC200000000<0
od`P00<000000?m<803oC2000P3oC2000`000000od`P0?m<80020?m<80040000003oC200?EV[03eI
Z`80od/O00D000000?m;7`3oBal0od/O000000060?m;7`030000003oBal0od/O0080od/O00<0?EV[
0000003oBal01P3oBal00`000000od/O0?m;7`050?m;7`0303eIZ`3oBal0od/O00<000000P3oBAl2
000000030?m97`0mFJ/0odTO00<0odTO100000090?ofkPD0e3dI503om^h00`3D?AT0ooK^0?ofkP0A
0?ofkP030=@m6@3om^h0ooK^0080ooK^0`3D?AT<0?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI
0?ofkP3om^h0A@3om^h00`000000ooK^0?ofkP0:0?ofkP40oooo000[0?ofkP030000003om^h0ooK^
01d0ooK^00<000000?ofkP3om^h09`3om^h70=@m6@@0ooK^0P0mFJ/60=@m6@0503eIZ`3om^h0ooK^
0?ofkP3D?AT01@3om^h00`0mFJ/0ooK^0?ofkP040?ofkP@0e3dI00<08S9]0000000Z?X<00P0Z?X<0
0`000000:Sj30=@m6@0602XnP`030000000Z?X<0000000@0<DRE00<000000358U@0aB9D01P0aB9D0
0`000000<DRE000000030=@m6@80=U2U00<0000003I@Y@0fD:D0100fD:D01`000000=U2U03I@Y@0f
D:D0000003]H/P0000001P0kF;801P000000>eRb03]H/P3D?AT0>eRb00000080>eRb00<0000003mO
_`0000000`0oGkl01@000000?eno03mO_`0oGkl000000080e3dI00L0000003mO_`0oGkl000000?m<
800mFJ/000000080od`P00D000000?m<803oC200od`P000000030?m<80030000003oC200od`P0080
od`P00L000000?m<803oC200od`P0000003oC200?EV[0080od`P0`0mFJ/30?m;7`030000003oBal0
od/O00<0od/O00<000000?m;7`3oBal00P3oBal00`0mFJ/0od/O000000060?m;7`030000003oBal0
od/O00@0od/O0P0mFJ/60?m;7`<0000000<0odTO03eIZ`3oBAl00`3oBAl00`000000?EV[0000000>
0?ofkP<0e3dI4P3om^h00`3D?AT0ooK^0?ofkP0B0?ofkP030=@m6@3om^h0ooK^00D0ooK^0P3D?AT:
0?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h0A03om^h00`000000ooK^0?ofkP0;
0?ofkP40oooo000[0?ofkP030000003om^h0ooK^01`0ooK^00<000000?ofkP3om^h0;03om^h50=@m
6@80ooK^00<0?EV[0?ofkP3om^h00P3om^h70=@m6@030?ofkP3D?AT0ooK^00<0ooK^00<0?EV[0?of
kP3om^h01@3om^h00`0mFJ/00000028bK@040=@m6@80:Sj300<0e3dI02XnP`0Z?X<01P0Z?X<00`00
0000<DRE0358U@040358U@8000001`0aB9D00`000000=U2U0=@m6@0203I@Y@<0e3dI00<0000003I@
Y@0fD:D0100fD:D00`000000=U2U0000000303]H/P8000001@0kF;800`000000e3dI03]H/P0203]H
/P030000000kF;8000000080?eno00D0000003mO_`0oGkl0?eno0000000203mO_`030000000oGkl0
?eno00<0e3dI00L0?eno0000000mFJ/0od`P0000003oC200000000<0od`P00D000000?m<803oC200
od`P000000030?m<80030000003oC200od`P0080od`P00<0000003eIZ`3oC2000P3oC2000`000000
od`P0?m<800303eIZ`030000003oBal0od/O0080od/O00<000000?m;7`3oBal00P3oBal00`0mFJ/0
od/O000000050?m;7`8000001P3oBal00`0mFJ/0od/O0?m;7`050?m;7`80000000@0od/O03eIZ`0m
FJ/000000P3oBAl20000000303eIZ`000000ooK^00h0ooK^0P3D?AT0103om^h0e3dI0=@m6@3D?AT?
0?ofkP030=@m6@3om^h0ooK^0180ooK^00<0e3dI0?ofkP3om^h01`3om^h30=@m6@L0ooK^00<0e3dI
0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP120?ofkP8000003P3om^h10?ooo`00:`3om^h00`00
0000ooK^0?ofkP0K0?ofkP030000003om^h0ooK^02h0ooK^00<0?EV[0?ofkP3D?AT0203D?AT30?of
kPL0e3dI103om^h00`0mFJ/0ooK^0?ofkP030?ofkP0503eIZ`3om^h00000028bK@0000000`0Z?X<3
0=@m6@030000000Z?X<0:Sj300@0:Sj300<000000358U@0000001`0aB9D00`000000<DRE0358U@03
0358U@040000000fD:D0e3dI000000D0=U2U0`3D?AT503I@Y@030000000kF;80>eRb00@0>eRb00<0
000003]H/P0kF;800P0kF;800`3D?AT0000003]H/P0303]H/P050000000oGkl0?eno03mO_`000000
0`0oGkl01@000000?eno03mO_`0oGkl000000080?eno00<0000003mO_`3D?AT00P0000001@3oC200
00000?m<803oC20000000080od`P00D000000?m<803oC200od`P000000030?m<80060000003oC200
od`P0?m<80000000?EV[103oC2001P000000od`P0?m<803oC20000000?m<80<0?EV[0P3oBal01`00
0000od/O0?m;7`3oBal0?EV[0?m;7`0000001@3oBal00`000000od/O0?m;7`050?m;7`0303eIZ`3o
Bal0od/O00@0od/O0P0000020?m;7`0403eIZ`3oBal0od/O0?m;7`D00000403om^h00`3D?AT0ooK^
0?ofkP030?ofkP<0e3dI303om^h00`3D?AT0ooK^0?ofkP0A0?ofkP030=@m6@3om^h0ooK^00/0ooK^
0`3D?AT30?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h0@P3om^h00`000000ooK^
0?ofkP0>0?ofkP40oooo000[0?ofkP030000003om^h0ooK^01X0ooK^00<000000?ofkP3om^h0;`3o
m^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00H0e3dI0`3om^h203eIZ`80ooK^1P3D?AT00`3om^h0?EV[
0?ofkP030?ofkP0503eIZ`3om^h0ooK^0?ofkP0000000`0Z?X<20=@m6@80:Sj30`3D?AT302XnP`05
0000000aB9D0<DRE0358U@0000001`0aB9D01@000000<DRE0358U@0aB9D000000080=U2U00<0e3dI
03I@Y@0000001P0fD:D020000000e3dI0=@m6@3D?AT0=U2U0000000kF;8000001P0kF;801P000000
>eRb03]H/P3D?AT0>eRb000000<0>eRb00<0000003mO_`0000000`0oGkl01@000000?eno03mO_`0o
Gkl000000080?eno00D0000003mO_`0oGkl0000003mO_`02000000060=@m6@00000000000000003o
C20000000P3oC2001@000000od`P0?m<803oC200000000<0od`P00D000000?m<803oC200od`P03eI
Z`040?m<80050000003oC200od`P0?m<800000001@3oC20303eIZ`050000003oBal0?EV[0?m;7`00
00001@3oBal00`000000od/O0?m;7`040?m;7`030000000mFJ/0od/O00@0od/O0P0000030?m;7`<0
?EV[00<0od/O0000000000000`0000000`3D?AT0ooK^0?ofkP0=0?ofkP80e3dI203om^h30=@m6@P0
ooK^00<0e3dI0?ofkP3om^h04P3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP80e3dI00<0ooK^0=@m6@3o
m^h0403om^h00`3D?AT0ooK^0?ofkP100?ofkP8000004@3om^h10?ooo`00:`3om^h00`000000ooK^
0?ofkP0J0?ofkP030000003om^h0ooK^02l0ooK^00P0?EV[0?ofkP3om^h0ooK^03eIZ`3om^h0?EV[
0?ofkPL0e3dI1P3om^h70=@m6@030?ofkP0mFJ/0ooK^00@0ooK^00<0000002XnP`3D?AT01P0Z?X<0
1@000000e3dI0=@m6@3D?AT0000000@0<DRE00<000000358U@0aB9D01@0aB9D00`000000<DRE0000
000203I@Y@050=@m6@0fD:D0=U2U03I@Y@0000001`0fD:D00`000000=U2U0=@m6@020=@m6@0303]H
/P000000000000D0>eRb00<000000=@m6@0kF;800P0kF;800`000000>eRb0000000303mO_`050000
000oGkl0?eno03mO_`0000000P0oGkl01@000000?eno03mO_`0oGkl000000080?eno00@0000004AV
bP14I/X000000`3oCB03000000050?m<80000000od`P0?m<800000000`3oC2001P000000od`P0?m<
803oC200?EV[000000<0od`P00<000000?m<803oC2000P3oC2000`000000od`P0?m<80030?m<8003
0000003oC200od`P00D0?EV[103oBal00`000000od/O0?m;7`040?m;7`030000000mFJ/0od/O00@0
od/O00<000000?m;7`0mFJ/0100mFJ/00`3oBal0000000000004000000<0e3dI3P3om^h00`3D?AT0
ooK^0?ofkP0:0?ofkP<0e3dI1@3om^h00`3D?AT0ooK^0?ofkP0B0?ofkP030=@m6@3om^h0ooK^0100
ooK^0`3D?AT@0?ofkP030=@m6@3om^h0ooK^03l0ooK^00<000000?ofkP3om^h04@3om^h10?ooo`00
:P3om^h00`000000ooK^0?ofkP0J0?ofkP030000003om^h0ooK^0300ooK^00@0?EV[0?ofkP3om^h0
?EV[0P3om^h00`0mFJ/0ooK^0?ofkP030?ofkPH0e3dI0`3om^h0103D?AT0ooK^0?ofkP3om^h60=@m
6@D0ooK^00<0e3dI02XnP`0Z?X<01P0Z?X<00`000000:Sj3000000030=@m6@<0<DRE0P0000060358
U@040000000fD:D0=U2U0=@m6@D0=U2U0P00000603I@Y@040000000kF;80>eRb03]H/P<0e3dI00<0
000003]H/P0kF;800`0kF;800`3D?AT0000003]H/P0203]H/P030000000oGkl0?eno00<0?eno00D0
000003mO_`0oGkl0?eno0000000203mO_`050000000oGkl0?eno0000000oGkl00P00000204AVbP03
0000003oCB00oddP0080oddP00<000000?m=800000000P0000000`3oC20000000?m<80020?m<8005
0000003oC200od`P03eIZ`000000103oC2001@000000od`P0?m<803oC200000000D0od`P00D00000
0?m<803oC200od`P03eIZ`02000000030?m<80000000?EV[00H0?EV[0`3oBal010000000?EV[0?m;
7`3oBal603eIZ`80od/O00L0?EV[0?m;7`000000000004eegP3D?AT0AF_8008000000P3om^h00`3D
?AT0ooK^0=@m6@020=@m6@/0ooK^00<0e3dI0?ofkP3om^h03@3om^h30=@m6@030?ofkP3D?AT0ooK^
01<0ooK^00<0e3dI0?ofkP3om^h04P3om^h00`3D?AT0ooK^0=@m6@020=@m6@d0ooK^00<0e3dI0?of
kP3om^h0?@3om^h2000001@0ooK^0@3oool002X0ooK^00<000000?ofkP3om^h06@3om^h00`000000
ooK^0?ofkP0`0?ofkP0403eIZ`3om^h0ooK^03eIZ`<0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0m
FJ/0ooK^03eIZ`080=@m6@<0ooK^00<0?EV[0?ofkP3D?AT01`3D?AT0103om^h0000002XnP`3D?AT6
02XnP`030000000aB9D0<DRE0080<DRE103D?AT00`0aB9D000000358U@030358U@040000000fD:D0
00000=@m6@P0=U2U00<0000003I@Y@0fD:D00P0fD:D010000000>eRb00000000000403]H/P<0e3dI
0P0kF;80203D?AT0>eRb03]H/P000000>eRb0000000oGkl000001@0oGkl01@000000?eno03mO_`0o
Gkl000000080?eno00@0000003mO_`0oGkl000000P14I/X00`000000A6K:000000020?m=80<0?EV[
0P3oCB000`000000oddP00000002000000070?m<80000000od`P0?m<800mFJ/0od`P000000030?m<
80050000003oC200od`P0?m<800000001@3oC2001P000000od`P0?m<803oC200?EV[000000D0od`P
100000020?m;7`L0?EV[0P0000050?m;7`0603eIZ`3oBal0000004eegP000000e3dI0`0000030?of
kP030=@m6@3om^h0ooK^0080ooK^0`3D?AT70?ofkP80e3dI4P3om^h30=@m6A<0ooK^00<0e3dI0?of
kP3om^h04@3om^h00`3D?AT0ooK^0?ofkP030?ofkP<0e3dI2P3om^h00`3D?AT0ooK^0?ofkP0l0?of
kP030000003om^h0ooK^01@0ooK^0@3oool002X0ooK^00<000000?ofkP3om^h0603om^h00`000000
ooK^0?ofkP0a0?ofkP0303eIZ`3om^h0?EV[00@0ooK^00<0?EV[0?ofkP3om^h00`3om^h0100mFJ/0
ooK^0?ofkP0mFJ/30?ofkPH0e3dI00<0ooK^03eIZ`0mFJ/0103om^h60=@m6@030000003D?AT0:Sj3
00@0:Sj300@000000358U@00000000001P0aB9D30=@m6@80<DRE00H0000003I@Y@0fD:D0=U2U0=@m
6@00000803I@Y@80000000<0=U2U0000000kF;800`0kF;800`000000>eRb03]H/P0303]H/P040000
003D?AT0e3dI0=@m6@<0>eRb00@0000003mO_`0oGkl0?eno0P00000403mO_`040000000oGkl0?eno
00000080?eno00L0000003eIZ`000000A6K:0000003D?AT000000080A6K:00D000000?m=80000000
oddP0000000203eIZ`050000003oCB00oddP0000003oCB000`0000000`0mFJ/0od`P000000030?m<
80050000003oC200od`P0?m<80000000103oC202000000<0od`P00<0?EV[0000003oC200103oC202
000000<0od`P100000000`0mFJ/0od/O0?m;7`02000000L0od/O1@0000000`3D?AT0000000000004
0?ofkP030=@m6@3om^h0ooK^00D0ooK^0`3D?AT40?ofkP030=@m6@3om^h0ooK^0180ooK^00<0e3dI
0?ofkP3D?AT00P3D?AT@0?ofkP030=@m6@3om^h0ooK^0140ooK^00<0e3dI0?ofkP3om^h01P3om^h2
0=@m6@P0ooK^00<0e3dI0?ofkP3om^h0>P3om^h2000001L0ooK^0@3oool002X0ooK^00<000000?of
kP3om^h0603om^h00`000000ooK^0?ofkP0a0?ofkP80?EV[1@3om^h00`0mFJ/0ooK^0?ofkP020?of
kP0503eIZ`3om^h0ooK^0?ofkP0mFJ/01P3om^h60=@m6@040?ofkP3D?AT0e3dI0=@m6@<0ooK^1P3D
?AT302XnP`030000000aB9D0<DRE0080<DRE00<000000358U@0aB9D01P0aB9D30=@m6@80=U2U00<0
e3dI03I@Y@0fD:D00P00000803I@Y@030000000kF;80>eRb00@0>eRb0P00000403]H/P030=@m6@00
0000>eRb00<0e3dI00<0?eno0000000oGkl00`0oGkl00`000000?eno03mO_`0203mO_`040000000o
Gkl0?eno00000080?eno00@0000004AVbP14I/X0e3dI0P14I/X01`000000A6K:0000003oCB000000
0?m=800000000P3oCB0203eIZ`060?m=80000000oddP0?m=80000000?EV[100000020?m<80050000
003oC200od`P0?m<800000000`3oC2000`000000od`P0?m<80020?m<800303eIZ`000000od`P00<0
od`P0P0000050?m<8080000000<0od`P03eIZ`0000000`0000060?m;7`<000000P3D?AT00`000000
e3dI000000050?ofkP030=@m6@3om^h0ooK^00T0ooK^1@3D?ATC0?ofkP030=@m6@3om^h0ooK^00<0
ooK^0P3D?AT>0?ofkP030=@m6@3om^h0ooK^0100ooK^00<0e3dI0?ofkP3om^h02@3om^h30=@m6@@0
ooK^00<0e3dI0?ofkP3om^h0>P3om^h00`000000ooK^0?ofkP0G0?ofkP40oooo000Z0?ofkP030000
003om^h0ooK^01L0ooK^00<000000?ofkP3om^h0<P3om^h203eIZ`D0ooK^00D0?EV[0?ofkP3om^h0
ooK^03eIZ`040?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0=@m6@3D?AT0103D?AT60?ofkPD0
e3dI00<000000358U@0aB9D0100aB9D2000000L0<DRE00<0000003I@Y@3D?AT00P3D?AT403I@Y@80
00001@0fD:D010000000>eRb00000000000603]H/P80000000P0>eRb0=@m6@0kF;80>eRb0000000k
F;80000003mO_`@0e3dI0`0oGkl00`000000?eno03mO_`0203mO_`030000000oGkl0?eno00800000
00d0A6K:0000003D?AT0A6K:00000014I/X0000004AVbP000000oddP0000003oCB0000000080oddP
00@000000?m=800mFJ/0?EV[0P3oCB000`0mFJ/0oddP0?m=80030?m=80<000000P3oC2001@000000
od`P0?m<803oC200000000<0od`P0P0mFJ/50?m<80030000003oC200od`P00<0od`P0P0000020?m<
800303eIZ`000000000000<0od`P0P0000020?m;7`@0000000<0CGGN0000000000000`3D?AT50?of
kP030=@m6@3om^h0ooK^00`0ooK^0P3D?ATC0?ofkP030=@m6@3om^h0ooK^00D0ooK^0`3D?AT:0?of
kP030=@m6@3om^h0ooK^0140ooK^00<0e3dI0?ofkP3om^h0303om^h30=@m6@030?ofkP3D?AT0ooK^
03T0ooK^0P00000J0?ofkP40oooo000Y0?ofkP030000003om^h0ooK^01L0ooK^00<000000?ofkP3o
m^h0<P3om^h203eIZ`H0ooK^00@0?EV[0?ofkP3om^h0?EV[1@3om^h00`0mFJ/0ooK^0?ofkP060?of
kP0503eIZ`3om^h0ooK^03eIZ`3om^h01P3D?AT60?ofkP<0e3dI200aB9D00`000000<DRE0358U@03
0358U@040000000fD:D0e3dI0=@m6@80=U2U103D?AT203I@Y@050000000fD:D0=U2U03I@Y@000000
100kF;800`000000>eRb03]H/P0503]H/P030=@m6@0kF;80>eRb0080>eRb00<0000003mO_`0oGkl0
100oGkl30=@m6@0303mO_`000000?eno00<0?eno0P0000001`14I/X0000004AVbP3D?AT0000004AV
bP0000000P14I/X02@000000A6K:0000003oCB0000000?m=80000000oddP000000020?m=80030000
000mFJ/0?EV[00<0oddP00@000000?m=803oCB0000000P3oCB0300000080od`P00H000000?m<803o
C200od`P03eIZ`0000040?m<80800000103oC20200000080od`P0P0mFJ/00`000000od`P0?m<8005
0?m<80@0000000H0CGGN000000000000000003eIZ`3D?AT20?ofkP<0e3dI0P3om^h00`3D?AT0ooK^
0?ofkP0;0?ofkP030=@m6@3om^h0e3dI0180ooK^00<0e3dI0?ofkP3om^h02@3om^h30=@m6@L0ooK^
00<0e3dI0?ofkP3om^h04@3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP80e3dI>@3om^h00`000000ooK^
0?ofkP0J0?ofkP40oooo000Y0?ofkP030000003om^h0ooK^01L0ooK^00<000000?ofkP3om^h0<P3o
m^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0?EV[00H0ooK^00<0?EV[0?ofkP3om^h01@3o
m^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00D0ooK^1@3D?AT30?ofkP030=@m6@3om^h0000000<0e3dI
1P0aB9D2000000050358U@000000000003I@Y@3D?AT00P0fD:D2000000@0=U2U0`3D?AT200000003
03I@Y@000000>eRb00@0>eRb0P00000403]H/P070=@m6@0kF;8000000000000kF;80000003mO_`02
000000D0?eno00<0000003mO_`3D?AT00P3D?AT01@000000?eno03mO_`0mFJ/000000080A6K:01D0
00000=@m6@14I/X0000004AVbP000000A6K:00000014I/X000000?m=80000000oddP0000003oCB00
00000?m=80000000?EV[0?m=800000000`0mFJ/20?m=80050000003oCB00oddP0?m=800000000P3o
CB0300000080od`P00<0?EV[0000003oC2000P3oC202000000@0od`P0P0000030?m<800303eIZ`00
0000od`P00D0od`P1@0000000`1=MMh00000000000020000000303eIZ`000000e3dI00D0ooK^0`3D
?AT=0?ofkP030=@m6@3om^h0e3dI0180ooK^00<0e3dI0?ofkP3om^h0303om^h20=@m6@D0ooK^00<0
e3dI0?ofkP3om^h0403om^h00`3D?AT0ooK^0?ofkP0A0?ofkP030=@m6@3om^h0ooK^03D0ooK^0P00
000M0?ofkP40oooo000Y0?ofkP030000003om^h0ooK^01H0ooK^00<000000?ofkP3om^h0<`3om^h0
0`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0?EV[00L0ooK^00<0?EV[0?ofkP3om^h00`3om^h0
0`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00D0ooK^1`3D?AT20?ofkP8000000`3D?AT5
0358U@040000000fD:D0e3dI0=@m6@D0=U2U0P00000503I@Y@@0e3dI1`0kF;8200000080>eRb00D0
e3dI03]H/P0kF;80>eRb0000000403mO_`800000100oGkl010000000?eno03mO_`0oGkl40=@m6@05
04AVbP000000A6K:0=@m6@0000000P14I/X010000000A6K:00000014I/X20000000:0?m=80000000
oddP0000003oCB0000000?m=800mFJ/0oddP000000<0oddP00@0000003eIZ`0mFJ/0?EV[0P3oCB00
1@000000oddP0?m=803oCB0000000080oddP00<0000003eIZ`0000000P3oC202000000@0od`P0P00
00030?m<80030000000mFJ/0od`P00@0od`P1P0000000`1=MMh000000000000200000080?EV[00<0
00000=@m6@3om^h01`3om^h50=@m6@P0ooK^00@0e3dI0?ofkP3om^h0e3dI4@3om^h00`3D?AT0ooK^
0?ofkP0?0?ofkP<0e3dI00<0ooK^0=@m6@3om^h04P3om^h00`3D?AT0ooK^0?ofkP0@0?ofkP030=@m
6@3om^h0ooK^03D0ooK^00<000000?ofkP3om^h07@3om^h10?ooo`00:@3om^h00`000000ooK^0?of
kP0E0?ofkP030000003om^h0ooK^03@0ooK^00<0?EV[0?ofkP3om^h01@3om^h203eIZ`P0ooK^00<0
?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0
?EV[0=@m6@3D?AT00`3D?AT20?ofkP030000000aB9D0<DRE00<0e3dI00D0<DRE0000003D?AT0e3dI
0000000803I@Y@800000100fD:D00`000000>eRb03]H/P030=@m6@H0>eRb00<000000=@m6@0kF;80
0P0kF;8010000000?eno00000000000403mO_`8000000`0oGkl2000000<0?eno00<0000004AVbP3D
?AT00`3D?AT02@14I/X0000004AVbP000000A6K:00000014I/X0000004AVbP02000000080?m=8000
0000oddP0000003oCB00?EV[0?m=800000020?m=80050000003oCB00oddP0000003oCB000`0mFJ/2
0?m=80050000003oCB00oddP0?m=800mFJ/00P3oCB03000000<0od`P0P0000030?m<8080000000<0
?EV[0?m<803oC2000P3oC2020000000504mhiP00000000000000001=MMh01P0000000`15JlP00000
0=@m6@090?ofkP030=@m6@3om^h0ooK^0080ooK^0`3D?AT50?ofkP030=@m6@3om^h0e3dI0180ooK^
00<0e3dI0?ofkP3om^h04P3om^h30=@m6A40ooK^00<0e3dI0?ofkP3om^h04@3om^h00`3D?AT0ooK^
0?ofkP0d0?ofkP030000003om^h0ooK^01h0ooK^0@3oool002T0ooK^00<000000?ofkP3om^h0503o
m^h00`000000ooK^0?ofkP0e0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h01`3o
m^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h01P3o
m^h00`0mFJ/0ooK^0?ofkP020?ofkPD0e3dI0P0000020358U@@0e3dI0P0fD:D2000000P0=U2U0P00
00000`0fD:D0000003]H/P0403]H/P030000003D?AT0e3dI0080e3dI0P0kF;801@3D?AT000000000
000kF;80000000@0?eno0P00000403mO_`8000000`0oGkl010000000?eno00000014I/X200000003
0=@m6@14I/X0000000<0e3dI00D0A6K:00000014I/X0000004AVbP02000000090?m=800000000000
0?m=80000000?EV[0000003oCB0000000080oddP00<000000?m=800000000P3oCB000`000000oddP
0?m=800303eIZ`030?m=80000000?EV[0080oddP0P0000020?m=80<000000`3oC202000000040?m<
800mFJ/0od`P0?m<80H0000000<0CgSV0000000000001@000000100mFJ/000000000003om^h30=@m
6@H0ooK^00<0e3dI0?ofkP3om^h01P3om^h30=@m6@050?ofkP3D?AT0ooK^0?ofkP3D?AT04@3om^h0
0`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^00<0e3dI3P3om^h00`3D?AT0ooK^0?ofkP0A
0?ofkP030=@m6@3om^h0ooK^0380ooK^0P00000Q0?ofkP40oooo000X0?ofkP030000003om^h0ooK^
01D0ooK^00<000000?ofkP3om^h0=@3om^h00`0mFJ/0ooK^0?ofkP040?ofkP80?EV[2@3om^h01@0m
FJ/0ooK^0?ofkP3om^h0?EV[00P0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP04
0?ofkP0303eIZ`3om^h0ooK^00D0e3dI00@0<DRE0000000fD:D0=U2U103D?AT2000000P0=U2U0P00
000703]H/P<000000`3D?AT203]H/P8000001P0oGkl2000000@0?eno0P00000203mO_`8000000P14
I/X0103D?AT0000004AVbP14I/X20000000304AVbP3D?AT0e3dI0080000000<0A6K:000000000000
0`0000002P3oCB00?EV[0?m=80000000oddP0000003oCB0000000?m=800000020?m=80030000003o
CB00oddP0080000000<0oddP0000000mFJ/01@0mFJ/20?m=80040000003oCB00oddP0?m=80<00000
0P3oC2001@0mFJ/00000000000000000CgSV008000000P1?N>H70000000604E[b00mFJ/000000000
003om^h0e3dI0`3om^h20=@m6@@0ooK^00<0e3dI0?ofkP3om^h02@3om^h30=@m6@030?ofkP3D?AT0
ooK^0100ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP030?ofkP<0e3dI2`3om^h0
0`3D?AT0ooK^0?ofkP0@0?ofkP030=@m6@3om^h0ooK^0380ooK^00<000000?ofkP3om^h08@3om^h1
0?ooo`00:03om^h00`000000ooK^0?ofkP0D0?ofkP030000003om^h0ooK^03H0ooK^00<0?EV[0?of
kP3om^h00`3om^h00`0mFJ/0ooK^03eIZ`0:0?ofkP0303eIZ`3om^h0?EV[00X0ooK^00<0?EV[0?of
kP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00<0ooK^103D?AT603I@
Y@<0e3dI00<0000003I@Y@0fD:D00`0fD:D00`000000>eRb03]H/P02000000L0>eRb0P3D?AT00`00
0000>eRb0=@m6@020=@m6@0303mO_`000000000000H0?eno0P00000403mO_`8000000P14I/X01@00
0000e3dI04AVbP14I/X0000000<0A6K:00<0000004AVbP0000000P3D?AT00`000000B6cE00000008
00000080oddP00D000000?m=80000000oddP000000020?m=80080000003oCB00oddP0000003oCB00
?EV[0?m=800000020?m=80030000000mFJ/0?EV[00<0?EV[00@000000?m=803oCB00oddP0`000002
0=@m6@030000001?N>H0CgSV00@0000000<0?EV[04eegP0000001@0000020?ofkP030=@m6@3om^h0
ooK^00@0ooK^0`3D?AT00`3om^h0e3dI0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00<0e3dI3`3om^h0
0`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^00L0ooK^0P3D?AT80?ofkP030=@m6@3om^h0
ooK^0140ooK^00<0e3dI0?ofkP3om^h0<03om^h2000002@0ooK^0@3oool002P0ooK^00<000000?of
kP3om^h04`3om^h00`000000ooK^0?ofkP0g0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00@0?EV[0?of
kP3om^h0?EV[2@3om^h203eIZ`/0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP06
0?ofkP0303eIZ`3om^h0ooK^00H0ooK^0`3D?AT603I@Y@@0e3dI00<0=U2U0000000kF;80100kF;83
000000<0>eRb00@0e3dI03]H/P0kF;80>eRb0`0000000`0oGkl0e3dI0=@m6@020=@m6@8000001@0o
Gkl20000000403mO_`000000A6K:04AVbP80000000D0e3dI04AVbP000000000004AVbP0200000080
A6K:00@0000004AVbP000000A6K:100000001@3oC20000000?m<80000000od`P00@0000000@0oddP
0000003oCB0000000P3oCB000`000000oddP000000020?m=800403eIZ`00000000000?m=80800000
0P3oCB03000000<0oddP0P0000001@0mFJ/0CgSV03eIZ`000000CgSV00<0e3dI0`000000101=MMh0
00000000001=MMh4000000<0ooK^00<0e3dI0?ofkP3om^h01`3om^h30=@m6@X0ooK^00H0e3dI0?of
kP3om^h0ooK^0=@m6@3om^h30=@m6@`0ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?of
kP090?ofkP<0e3dI1@3om^h00`3D?AT0ooK^0?ofkP0A0?ofkP030=@m6@3om^h0ooK^02l0ooK^00<0
00000?ofkP3om^h0903om^h10?ooo`00:03om^h00`000000ooK^0?ofkP0C0?ofkP030000003om^h0
ooK^03L0ooK^00<0?EV[0?ofkP3om^h00P3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00T0ooK^00<0
?EV[0?ofkP3om^h02`3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00X0ooK^00<0?EV[0?ofkP3om^h0
1`3om^h00`0mFJ/0e3dI0=@m6@020=@m6@D0=U2U00@000000=@m6@3D?AT0e3dI1`0kF;800`000000
e3dI0=@m6@0403]H/P030000000oGkl0?eno00<000000P0oGkl30=@m6@800000100oGkl300000080
A6K:00<0e3dI0000000000000P14I/X20000000804AVbP000000A6K:04AVbP000000A6K:00000018
K=D7000000050?m<8000000000000000003oC2000`0000020?m=80<000000P3oCB00100mFJ/00000
0000000000030?m=808000000P3oCB0200000080CWKT0`00000204mhiPD000000`3D?AT01@000000
CGGN000000000000?EV[008000000`3om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0e3dI
0080e3dI1P3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^0080ooK^0`3D?AT80?of
kP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h03@3om^h30=@m6@030?ofkP3D?AT0ooK^
0180ooK^00<0e3dI0?ofkP3om^h0;P3om^h2000002L0ooK^0@3oool002P0ooK^00<000000?ofkP3o
m^h04P3om^h00`000000ooK^0?ofkP0h0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/0103om^h00`0m
FJ/0ooK^0?ofkP060?ofkP80?EV[3@3om^h0100mFJ/0ooK^0?ofkP0mFJ/<0?ofkP0303eIZ`3om^h0
ooK^00D0ooK^00<0?EV[0?ofkP3om^h00`0000030=@m6@80=U2U00@0000003]H/P0kF;800000103D
?AT203]H/P80e3dI0P0kF;8200000080>eRb00<0000003mO_`0oGkl00`0oGkl40000000503mO_`3D
?AT0e3dI0=@m6@0000000P0oGkl01P000000A6K:04AVbP000000e3dI00000080A6K:0`0000000`14
I/X00000000000020000000504AVbP000000B6cE00000018K=D0200000001P3oC20000000000003o
C20000000?m<80<000000P3oCB0010000000?EV[0000000000020?m=80<0000000@0oddP00000000
0000CWKT1@00000204mhiP@000000P1?N>H4000000@0e3dI0P000000103D?AT0ooK^0?ofkP3D?AT<
0?ofkP030=@m6@3om^h0ooK^0080ooK^0`3D?AT30?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT0203o
m^h30=@m6@D0ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP0@0?ofkP<0e3dI4P3o
m^h00`3D?AT0ooK^0?ofkP0]0?ofkP030000003om^h0ooK^02L0ooK^0@3oool002L0ooK^00<00000
0?ofkP3om^h04P3om^h00`000000ooK^0?ofkP0i0?ofkP0403eIZ`3om^h0ooK^03eIZ`D0ooK^00<0
?EV[0?ofkP3om^h01@3om^h0100mFJ/0ooK^0?ofkP0mFJ/=0?ofkP80?EV[3@3om^h00`0mFJ/0ooK^
0?ofkP040?ofkP0303eIZ`3om^h0ooK^00@0ooK^0P0000000`0fD:D0e3dI0=@m6@020=@m6@@0>eRb
00<000000=@m6@3D?AT00P3D?AT503]H/P@00000200oGkl30000000303mO_`3D?AT0e3dI0080e3dI
00<0000004AVbP3D?AT00P14I/X300000080A6K:0P0000001@14I/X00000000000000000B6cE00<0
000000<0B6cE0000000000001`0000000`3oC20000000?m<8003000000050?m<80000000000003eI
Z`0000000P3oCB090000000304ifi03D?AT0000000@00000101?N>H50000000504eegP0000000000
03eIZ`0000000`3D?AT20?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h01@3om^h3
0=@m6@@0ooK^00<0e3dI0?ofkP3om^h02@3om^h30=@m6@030?ofkP3D?AT0ooK^01@0ooK^00<0e3dI
0?ofkP3om^h04@3om^h00`3D?AT0ooK^0?ofkP030=@m6@l0ooK^00<0e3dI0?ofkP3om^h0:`3om^h2
000002X0ooK^0@3oool002L0ooK^00<000000?ofkP3om^h04@3om^h00`000000ooK^0?ofkP0j0?of
kP0303eIZ`3om^h0?EV[00L0ooK^00<0?EV[0?ofkP3om^h00`3om^h01@0mFJ/0ooK^0?ofkP3om^h0
?EV[00d0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0
ooK^00L0ooK^100000060=@m6@<0>eRb00<000000=@m6@3D?AT00P3D?AT2000000<0?eno10000007
03mO_`@0000000@0A6K:0=@m6@3D?AT0e3dI0P00000304AVbP<0000000D0A6K:0000000000000000
04Q/e@020000000304Q/e@000000000000P0000000<0od`P0000000000000P000000103oC2000000
0000000000020?m<80P0000000D0CWKT00000000000000000=@m6@03000000<0CgSV1`0000001@1=
MMh0000000000015JlP0?EV[008000000P3om^h40=@m6@`0ooK^00<0e3dI0?ofkP3om^h01P3om^h0
0`3D?AT0ooK^0=@m6@020=@m6@030?ofkP3D?AT0ooK^00d0ooK^0`3D?ATC0?ofkP030=@m6@3om^h0
ooK^0180ooK^00<0e3dI0?ofkP3om^h00`3om^h30=@m6@/0ooK^00<0e3dI0?ofkP3om^h0:`3om^h0
0`000000ooK^0?ofkP0Z0?ofkP40oooo000W0?ofkP030000003om^h0ooK^0140ooK^00<000000?of
kP3om^h0>P3om^h00`0mFJ/0ooK^03eIZ`070?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?of
kP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0?EV[00l0ooK^00@0?EV[0?of
kP3om^h0?EV[3@3om^h20000000403eIZ`000000e3dI0=@m6@L0>eRb0P0000030=@m6@H0?eno1@00
000203mO_`0600000014I/X0A6K:04AVbP000000e3dI0P0000020=@m6@@000000P14I/XH00000003
0?m<80000000000000h0000000<0e3dI0000001?N>H010000000101?N>H0000000000000000204ee
gP@0000000<0?EV[0000000000000`3om^h20=@m6@80ooK^0`3D?AT90?ofkP030=@m6@3om^h0ooK^
00H0ooK^00<0e3dI0?ofkP3om^h00P3om^h20=@m6@h0ooK^00<0e3dI0?ofkP3om^h00`3D?AT@0?of
kP030=@m6@3om^h0ooK^0140ooK^00<0e3dI0?ofkP3om^h01`3om^h30=@m6@P0ooK^00<0e3dI0?of
kP3om^h0:@3om^h2000002d0ooK^0@3oool002L0ooK^00<000000?ofkP3om^h0403om^h00`000000
ooK^0?ofkP0k0?ofkP80?EV[203om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00<0
ooK^00<0?EV[0?ofkP3om^h0203om^h0100mFJ/0ooK^0?ofkP0mFJ/?0?ofkP0303eIZ`3om^h0?EV[
0140ooK^00<0?EV[0000000000000P3D?AT2000000<0>eRb00D0000003mO_`0oGkl0?eno00000004
0=@m6@L0?eno1@0000020=@m6@<0A6K:0P0000030=@m6@0304AVbP00000000000200000000<0CWKT
0000000000000P000000101>M^@000000000003D?AT30000000304mhiP000000000000<000000P1=
MMh20000000504eegP000000000004E[b0000000103D?AT00`3om^h0e3dI0?ofkP050?ofkP80e3dI
1`3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h0
303om^h00`3D?AT0ooK^0?ofkP030?ofkP<0e3dI303om^h00`3D?AT0ooK^0?ofkP0B0?ofkP030=@m
6@3om^h0ooK^00X0ooK^0`3D?AT50?ofkP030=@m6@3om^h0ooK^02P0ooK^00<000000?ofkP3om^h0
;@3om^h10?ooo`009`3om^h00`000000ooK^0?ofkP0?0?ofkP030000003om^h0ooK^03`0ooK^00<0
?EV[0?ofkP3om^h01`3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00L0ooK^00<0?EV[0?ofkP3om^h0
1P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h0
4@3om^h00`0mFJ/0ooK^03eIZ`04000000030=@m6@0000000000008000001P0oGkl30=@m6@800000
0`0oGkl01@000000A6K:0=@m6@3D?AT0A6K:00P0000000<0A6K:0=@m6@3D?AT0800000030=@m6@@0
000000@0CWKT0=@m6@000000CgSV0`00000404mhiP<0000000@0CGGN000000000000AF_80P000002
0?ofkP030000003om^h0ooK^00<0e3dI1`3om^h30=@m6@@0ooK^00<0e3dI0?ofkP3om^h0103om^h0
0`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h01`3om^h3
0=@m6@T0ooK^00<0e3dI0?ofkP3om^h04@3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP<0e3dI00<0ooK^
0=@m6@3om^h0:03om^h200000300ooK^0@3oool002L0ooK^00<000000?ofkP3om^h03`3om^h00`00
0000ooK^0?ofkP0l0?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP0mFJ/0203om^h00`0m
FJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0m
FJ/0ooK^03eIZ`0C0?ofkP0403eIZ`3om^h0ooK^0?ofkPH0000000<0_3/J0000000000001P000000
0`0oGkl0e3dI0=@m6@0:000000H0A6K:9000000204ifi0<0e3dI0P000000103D?AT0000004mhiP1?
N>H>000000<0ooK^00<000000?ofkP3om^h00P3D?AT0103om^h0e3dI0=@m6@3D?AT70?ofkP<0e3dI
00<0ooK^0=@m6@3om^h01@3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00X0ooK^
00<0e3dI0?ofkP3om^h02`3om^h30=@m6@D0ooK^00<0e3dI0?ofkP3om^h04P3om^h00`3D?AT0ooK^
0?ofkP0A0?ofkP80e3dI:03om^h00`000000ooK^0?ofkP0`0?ofkP40oooo000V0?ofkP030000003o
m^h0ooK^00l0ooK^00<000000?ofkP3om^h0?@3om^h00`0mFJ/0ooK^0?ofkP080?ofkP80?EV[2P3o
m^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h02P3o
m^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[0140ooK^00<0?EV[0?ofkP0mFJ/01P3om^h4000000L0_3/J
?00000030=@m6@<000000`1?N>H40000000304eegP000000000000<00000103om^h01@000000ooK^
0=@m6@3om^h0e3dI00@0ooK^0`3D?AT70?ofkP80e3dI1@3om^h00`3D?AT0ooK^0?ofkP060?ofkP03
0=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h03P3om^h30=@m6@80ooK^00<0e3dI0?ofkP3o
m^h04@3om^h00`3D?AT0ooK^0?ofkP0B0?ofkP030=@m6@3om^h0ooK^02H0ooK^00<000000?ofkP3o
m^h0<@3om^h10?ooo`009P3om^h00`000000ooK^0?ofkP0>0?ofkP030000003om^h0ooK^03l0ooK^
00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^00<0ooK^
00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00<0ooK^
00<0?EV[0?ofkP3om^h03@3om^h0100mFJ/0ooK^0?ofkP3om^h203eIZ`P0ooK^1@0000001@2l>aX0
0000000000000000?EV[01P0000000<0nD/P0000000000005`00000604ifi0040000003D?AT0CgSV
04mhiP<0e3dI1000000204eegP<0000000<0AF_80000003om^h01@3om^h01@000000e3dI0?ofkP3o
m^h0e3dI00L0ooK^103D?AT40?ofkP@0e3dI0P3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3o
m^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h04P3om^h30=@m6A<0ooK^00<0e3dI0?ofkP3om^h04P3o
m^h00`3D?AT0ooK^0?ofkP0T0?ofkP800000=03om^h10?ooo`009P3om^h00`000000ooK^0?ofkP0=
0?ofkP030000003om^h0ooK^0400ooK^00<0?EV[0?ofkP3om^h01P3om^h203eIZ``0ooK^00D0?EV[
0?ofkP3om^h0ooK^03eIZ`0:0?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h01@3o
m^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h0203o
m^h4000000030;`k6P0mFJ/0_3/J00P0000000<0?EV[0000000000000`0000030>E67P<0000000<0
?EV[0000000000000P0000020?U;80l0000000<0Bg7N0000000000001@1>M^@500000080e3dI1000
000204mhiP<0e3dI100000000`15JlP00000000000070?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT0
2`3om^h30=@m6@030?ofkP3D?AT0ooK^0080ooK^0`3D?AT80?ofkP030=@m6@3om^h0ooK^00P0ooK^
00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP030=@m6@l0ooK^00<0e3dI0?ofkP3om^h0
4P3om^h00`3D?AT0ooK^0?ofkP0T0?ofkP030000003om^h0ooK^03@0ooK^0@3oool002H0ooK^00<0
00000?ofkP3om^h03@3om^h00`000000ooK^0?ofkP100?ofkP0303eIZ`3om^h0ooK^00D0ooK^00@0
?EV[0?ofkP3om^h0?EV[2`3om^h0100mFJ/0ooK^0?ofkP0mFJ/<0?ofkP0303eIZ`3om^h0ooK^00@0
ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^00H0
ooK^00<0?EV[0?ofkP3om^h02P3om^h00`000000?EV[0000000:00000080?EV[1P000000103UAQh0
000003eIZ`0000020>E67PD0000000@0nD/P000000000000nD/P3000000304ifi0@000000P1>M^@0
0`0mFJ/0e3dI04mhiP0204mhiPL0000000<0CGGN0=@m6@3D?AT00P3D?AT2000000L0ooK^00<0e3dI
0000003om^h00P3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP<0e3dI0P3om^h00`3D?AT0ooK^0?ofkP04
0=@m6@@0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0
ooK^00<0ooK^0`3D?AT<0?ofkP030=@m6@3om^h0ooK^0180ooK^00<0e3dI0?ofkP3om^h08P3om^h2
000003L0ooK^0@3oool002H0ooK^00<000000?ofkP3om^h0303om^h00`000000ooK^0?ofkP110?of
kP0303eIZ`3om^h0ooK^00D0ooK^00@0?EV[0?ofkP3om^h0?EV[303om^h203eIZ`d0ooK^00<0?EV[
0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[
0?ofkP3om^h0203om^h203eIZ`X0ooK^00<0?EV[0?ofkP3om^h03000000203eIZ`<000000P3UAQh0
0`0mFJ/000000000000400000080iDHN0`000000103iBb0000000000003iBb070000000304]agP00
0000CWKT0080CWKT10000000101>M^@000000000003D?AT4000000<0CgSV00<0000004eegP1=MMh0
0P1=MMh30000000404E[b03D?AT0e3dI0=@m6@H0ooK^00<0e3dI0000003om^h00`3om^h00`3D?AT0
ooK^0?ofkP0<0?ofkP030=@m6@3om^h0e3dI0080e3dI1P3om^h30=@m6@030?ofkP3D?AT0ooK^00P0
ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP070?ofkP<0e3dI203om^h00`3D?AT0
ooK^0?ofkP0B0?ofkP030=@m6@3om^h0ooK^0280ooK^00<000000?ofkP3om^h0=`3om^h10?ooo`00
9@3om^h00`000000ooK^0?ofkP0<0?ofkP030000003om^h0ooK^04<0ooK^00<0?EV[0?ofkP3om^h0
0`3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h0
3@3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h0
1@3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h0
1@3om^h:00000080?EV[0P000000100mFJ/000000>E67P3UAQh2000000<0iDHN0`0000001@3UAQh0
0000000000000000nD/P0080000000@0nD/P000000000000Bg7N0P0000020=@m6@800000101>M^@0
0`000000e3dI0=@m6@03000000D0CgSV1P0000000`0mFJ/00000000000060=@m6@80ooK^00<0e3dI
0?ofkP000000103om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0e3dI0080ooK^0`3D?AT6
0?ofkP@0e3dI1P3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^00/0ooK^0`3D?AT5
0?ofkP030=@m6@3om^h0ooK^0180ooK^00<0e3dI0?ofkP3om^h0803om^h2000003X0ooK^0@3oool0
02D0ooK^00<000000?ofkP3om^h02`3om^h00`000000ooK^0?ofkP140?ofkP0303eIZ`3om^h0ooK^
0080ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0?EV[
00l0ooK^00@0?EV[0?ofkP3om^h0?EV[3P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0
ooK^00d0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP<00000102l>aX3
03eIZ`<000000`3UAQh2000000060>E67P000000iDHN0>E67P000000iDHN20000000101>M^@00000
04ifi00000040=@m6@040000001>M^@0e3dI000000@0CgSV1P00000204eegPD0000000<0e3dI0?of
kP3om^h00P3om^h50=@m6@030?ofkP000000ooK^00<0ooK^00<0e3dI0?ofkP3om^h0303om^h20=@m
6@H0ooK^0`3D?AT40?ofkP030=@m6@3om^h0ooK^00@0e3dI0P3om^h00`3D?AT0ooK^0?ofkP0C0?of
kP030=@m6@3om^h0ooK^00h0ooK^0`3D?AT00`3om^h0e3dI0?ofkP0C0?ofkP030=@m6@3om^h0ooK^
0200ooK^00<000000?ofkP3om^h0>P3om^h10?ooo`009@3om^h00`000000ooK^0?ofkP0;0?ofkP03
0000003om^h0ooK^04@0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`070?ofkP0303eIZ`3om^h0ooK^
00H0ooK^00@0?EV[0?ofkP3om^h0?EV[3`3om^h00`0mFJ/0ooK^03eIZ`0@0?ofkP0503eIZ`3om^h0
ooK^0?ofkP0mFJ/04@3om^h203eIZ`<0ooK^00<0?EV[0?ofkP3om^h03P3om^h50000000303eIZ`2l
>aX0_3/J00@0?EV[0P0000020>E67P080000003UAQh0iDHN0000003UAQh000000>E67P0mFJ/20000
00030>E67P00000000000080000000@0CWKT0000001>M^@0CWKT0P0000000`1>M^@0e3dI0=@m6@04
000000@0CgSV0P0000000`1=MMh00000000000020000000504E[b000000000000?ofkP3D?AT01P3o
m^h60=@m6@<0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP080?ofkP<0e3dI00<0
ooK^0=@m6@3om^h01@3om^h30=@m6A@0ooK^00<0e3dI0?ofkP3om^h04P3om^h30=@m6A<0ooK^00<0
e3dI0?ofkP3om^h07P3om^h2000003d0ooK^0@3oool002D0ooK^00<000000?ofkP3om^h02P3om^h0
0`000000ooK^0?ofkP150?ofkP0403eIZ`3om^h0ooK^03eIZ`P0ooK^00<0?EV[0?ofkP3om^h01@3o
m^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h0403o
m^h00`0mFJ/0ooK^03eIZ`0D0?ofkP0303eIZ`3om^h0?EV[01@0ooK^00<0000003eIZ`0000001000
00020;`k6P<0?EV[0P0000020>E67P0;0000003UAQh0000003eIZ`3UAQh000000>E67P000000iDHN
0000003UAQh00P0000000`1>M^@000000000000204ifi0040000003D?AT0000004mhiP<0e3dI1`00
00000`1=MMh0000004E[b002000000<0ooK^00<0e3dI0?ofkP3om^h00P3om^h20=@m6@@0ooK^1P3D
?AT>0?ofkP030=@m6@3om^h0ooK^00/0ooK^0P3D?AT60?ofkP030=@m6@3om^h0ooK^00<0e3dI403o
m^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^00@0e3dI3P3om^h00`3D?AT0ooK^0?of
kP0N0?ofkP030000003om^h0ooK^03d0ooK^0@3oool002D0ooK^00<000000?ofkP3om^h02@3om^h0
0`000000ooK^0?ofkP170?ofkP0303eIZ`3om^h0?EV[00T0ooK^00<0?EV[0?ofkP3om^h00`3om^h0
0`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP0mFJ/04P3om^h0
0`0mFJ/0ooK^0?ofkP0D0?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h020000000
0`2l>aX0?EV[03eIZ`0203eIZ`80000000`0?EV[0000003UAQh000000>E67P000000iDHN0000003U
AQh0000004ifi000000204ifi0030000003D?AT0e3dI0080CgSV0`000000101?N>H0e3dI0=@m6@3D
?AT404eegP@00000103om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00H0ooK^00@000000?ofkP3om^h0
ooK^1@3D?AT:0?ofkP030=@m6@3om^h0e3dI00d0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0
ooK^0?ofkP040?ofkP<0e3dI3@3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^00@0
ooK^0`3D?AT;0?ofkP030=@m6@3om^h0ooK^01`0ooK^0P0000100?ofkP40oooo000T0?ofkP030000
003om^h0ooK^00X0ooK^00<000000?ofkP3om^h0A`3om^h203eIZ`X0ooK^00<0?EV[0?ofkP3om^h0
0`3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00X0ooK^00D0?EV[0?ofkP3om^h0
ooK^03eIZ`0@0?ofkP0303eIZ`3om^h0?EV[01@0ooK^00@0?EV[0?ofkP0mFJ/0?EV[4P3om^h00`0m
FJ/0ooK^0?ofkP040?ofkPD000000P2l>aX2000000030;`k6P0mFJ/0?EV[00<0?EV[0P000000203U
AQh000000>E67P000000iDHN0000001>M^@000000P3D?AT00`000000CgSV04mhiP0404mhiP800000
00<0?EV[0000003D?AT00`3D?AT00`000000AF_8000000060?ofkP030=@m6@3om^h0e3dI00L0ooK^
00<000000?ofkP3om^h00P3om^h00`3D?AT0ooK^0=@m6@040=@m6@H0ooK^00@0e3dI0?ofkP3om^h0
e3dI3@3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00P0ooK^0`3D?AT90?ofkP03
0=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h0203om^h40=@m6@H0ooK^00<0e3dI0?ofkP3o
m^h0703om^h00`000000ooK^0?ofkP100?ofkP40oooo000T0?ofkP030000003om^h0ooK^00T0ooK^
00<000000?ofkP3om^h0B03om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0503eIZ`3om^h0ooK^0?ofkP0m
FJ/0203om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3o
m^h0303om^h0100mFJ/0ooK^0?ofkP3om^h203eIZa40ooK^00<0?EV[0?ofkP3om^h00P3om^h203eI
Z`l0ooK^00<0?EV[0?ofkP3om^h0203om^h500000080_3/J00<0?EV[0000002l>aX00P2l>aX603eI
Z`80iDHN00D0000004ifi0000000000004mhiP02000000@0CgSV00<0000004eegP1=MMh00`1=MMh0
0`000000AF_80=@m6@020=@m6@H0ooK^0P3D?AT80?ofkP030000003om^h0ooK^00<0ooK^00@0e3dI
0?ofkP3om^h0ooK^1@3D?AT20?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT03P3om^h0103D?AT0ooK^
0?ofkP3D?AT>0?ofkP<0e3dI1@3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^00d0
ooK^103D?AT20?ofkP030=@m6@3om^h0ooK^01X0ooK^0P0000130?ofkP40oooo000T0?ofkP030000
003om^h0ooK^00P0ooK^00<000000?ofkP3om^h0B@3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0403eI
Z`3om^h0ooK^03eIZ`X0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP050?ofkP03
03eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP03
03eIZ`3om^h0ooK^00D0ooK^0P0mFJ/;0?ofkP80?EV[3@3om^h01@0mFJ/0ooK^000000000000?EV[
00<000000P2l>aX01@000000_3/J0;`k6P000000_3/J00@000000P1>M^@010000000CgSV04mhiP1?
N>H200000080CgSV00<0000004eegP1=MMh00P1=MMh010000000AF_80000000000020?ofkP<0e3dI
0P3om^h20=@m6@T0ooK^00<000000?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP040?ofkPD0e3dI
0`3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0e3dI0180ooK^0`3D?AT20?ofkP030=@m
6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h04@3om^h20=@m6A`0ooK^00<000000?ofkP3om^h0
@`3om^h10?ooo`00903om^h00`000000ooK^0?ofkP070?ofkP030000003om^h0ooK^04/0ooK^00<0
?EV[0?ofkP3om^h02P3om^h203eIZ``0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?of
kP070?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?of
kP0;0?ofkP0303eIZ`3om^h0ooK^00P0ooK^0P0mFJ/80?ofkP0303eIZ`3om^h0ooK^00d0ooK^00@0
?EV[0?ofkP3om^h0?EV[0P3om^h600000080_3/J00@000000;`k6P000000_3/J0`0000000`3D?AT0
000004mhiP0304mhiPX000001P3om^h30=@m6@030?ofkP3D?AT0ooK^00L0ooK^00<000000?ofkP3o
m^h00`3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0e3dI00@0e3dI3P3om^h00`3D?AT0
ooK^0=@m6@0E0?ofkP<0e3dI503om^h00`3D?AT0ooK^0?ofkP0B0?ofkP030=@m6@3om^h0ooK^01T0
ooK^0P0000160?ofkP40oooo000T0?ofkP030000003om^h0ooK^00L0ooK^00<000000?ofkP3om^h0
B`3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h0
103om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h0
203om^h203eIZ`X0ooK^00<0?EV[0?ofkP3om^h02`3om^h203eIZ`D0ooK^00<0?EV[0?ofkP3om^h0
3P3om^h00`0mFJ/0ooK^03eIZ`050?ofkP0303eIZ`000000000000@000000P2l>aX01@0mFJ/0_3/J
0;`k6P000000CgSV00@0e3dI0P00000404eegP0400000015JlP00000000000H0ooK^0P3D?AT20?of
kP<0e3dI1`3om^h00`000000ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00@0ooK^0P3D?AT50?of
kPD0e3dI2`3om^h20=@m6AH0ooK^00<0e3dI0?ofkP3om^h00`3D?AT@0?ofkP030=@m6@3om^h0ooK^
0180ooK^00<0e3dI0?ofkP3om^h06@3om^h00`000000ooK^0?ofkP160?ofkP40oooo000S0?ofkP03
0000003om^h0ooK^00L0ooK^00<000000?ofkP3om^h0C@3om^h00`0mFJ/0ooK^0?ofkP080?ofkP03
03eIZ`3om^h0?EV[00d0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP03
03eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP060?ofkP03
03eIZ`3om^h0ooK^00h0ooK^0P0mFJ/20?ofkP0303eIZ`3om^h0ooK^0100ooK^00<0?EV[0?ofkP3o
m^h00`3om^h01@0mFJ/0ooK^0?ofkP0mFJ/0ooK^00@0000000<0?EV[0000003D?AT00P2l>aX01@00
0000CgSV04mhiP1?N>H0000000@0e3dI100000000`3D?AT0ooK^0?ofkP030?ofkP80e3dI1P3om^h5
0=@m6@<0ooK^00<000000?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0
ooK^00H0ooK^00<0e3dI0?ofkP3D?AT01@3D?AT70?ofkP030=@m6@3om^h0ooK^01@0ooK^00<0e3dI
0?ofkP3om^h0103om^h30=@m6@d0ooK^00<0e3dI0?ofkP3om^h04P3om^h00`3D?AT0ooK^0?ofkP0H
0?ofkP030000003om^h0ooK^04L0ooK^0@3oool002<0ooK^00<000000?ofkP3om^h01P3om^h00`00
0000ooK^0?ofkP1>0?ofkP0303eIZ`3om^h0ooK^00L0ooK^00@0?EV[0?ofkP3om^h0?EV[3P3om^h0
100mFJ/0ooK^0?ofkP0mFJ/>0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h0303o
m^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^0140ooK^0`0mFJ/@0?ofkP<0?EV[103o
m^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00<0ooK^00<0000003eIZ`00000010000000102l>aX00000
04mhiP00000204eegP<000001P3D?AT20?ofkP80e3dI203om^h0103D?AT0ooK^0?ofkP3om^h40=@m
6@030000003om^h0ooK^00@0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0:0?ofkP040=@m6@3om^h0
ooK^0?ofkPL0e3dI0P3om^h20=@m6AD0ooK^00<0e3dI0?ofkP3om^h0203om^h30=@m6@T0ooK^00<0
e3dI0?ofkP3om^h04P3om^h00`3D?AT0ooK^0?ofkP0G0?ofkP800000BP3om^h10?ooo`008`3om^h0
0`000000ooK^0?ofkP060?ofkP030000003om^h0ooK^04l0ooK^00<0?EV[0?ofkP3om^h01P3om^h0
1@0mFJ/0ooK^0?ofkP3om^h0?EV[00d0ooK^00<0?EV[0?ofkP0mFJ/0403om^h01@0mFJ/0ooK^0?of
kP3om^h0?EV[0100ooK^0P0mFJ/30?ofkP0303eIZ`3om^h0ooK^0180ooK^00<0?EV[0?ofkP3om^h0
100mFJ/;0?ofkP0403eIZ`3om^h0ooK^03eIZ`<0ooK^00<0?EV[0?ofkP3om^h00P3om^h01@0mFJ/0
ooK^0?ofkP3om^h0?EV[0080ooK^00<0?EV[000000000000100000030=@m6@0304eegP000000AF_8
0080000000<0ooK^0=@m6@3D?AT0103D?AT:0?ofkP030=@m6@3om^h0ooK^00@0ooK^0`3D?AT40?of
kP040=@m6@3om^h0e3dI0=@m6@/0ooK^00<0e3dI0?ofkP3om^h0103om^h70=@m6@030?ofkP3D?AT0
ooK^0180ooK^00<0e3dI0?ofkP3om^h0303om^h30=@m6@D0ooK^00<0e3dI0?ofkP3om^h04P3om^h0
0`3D?AT0ooK^0?ofkP0G0?ofkP030000003om^h0ooK^04X0ooK^0@3oool002<0ooK^00<000000?of
kP3om^h01@3om^h00`000000ooK^0?ofkP1@0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?of
kP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^0100ooK^00<0?EV[0?of
kP0mFJ/04`3om^h00`0mFJ/0ooK^03eIZ`0D0?ofkP0303eIZ`3om^h0ooK^00D0ooK^0`0mFJ/70?of
kP0603eIZ`3om^h0ooK^0?ofkP0mFJ/0ooK^0P0mFJ/50?ofkP0403eIZ`3om^h0?EV[03eIZ`80ooK^
00<0?EV[0?ofkP0mFJ/00`3om^h303eIZ`030000003D?AT0e3dI00D0e3dI0`3om^h00`3D?AT0ooK^
0=@m6@030=@m6@L0ooK^00<0e3dI0?ofkP3om^h0103om^h00`000000ooK^0?ofkP040=@m6@030?of
kP3D?AT0ooK^00`0ooK^00<0e3dI0?ofkP3om^h0203om^h60=@m6A40ooK^00<0e3dI0?ofkP3om^h0
403om^h30=@m6@80ooK^00<0e3dI0?ofkP3om^h04@3om^h00`3D?AT0ooK^0?ofkP0F0?ofkP800000
C@3om^h10?ooo`008`3om^h00`000000ooK^0?ofkP040?ofkP030000003om^h0ooK^0580ooK^00<0
?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0
?EV[0?ofkP0mFJ/04P3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^0180ooK^00<0
?EV[0?ofkP3om^h02@3om^h403eIZ`80ooK^00<0?EV[0?ofkP3om^h00P3om^h203eIZ`L0ooK^0P0m
FJ/30?ofkP0303eIZ`3om^h0ooK^00L0?EV[0P0000000`0mFJ/0ooK^0?ofkP040=@m6@<0ooK^00@0
e3dI0?ofkP3om^h0ooK^103D?AT50?ofkP030=@m6@3om^h0ooK^00<0ooK^00<000000?ofkP3om^h0
0`3om^h40=@m6@`0ooK^00<0e3dI0?ofkP3om^h01`3om^h0103D?AT0ooK^0?ofkP3om^h20=@m6@04
0?ofkP3D?AT0e3dI0=@m6@h0ooK^00<0e3dI0?ofkP3om^h04`3om^h30=@m6A<0ooK^00<0e3dI0?of
kP3om^h05@3om^h00`000000ooK^0?ofkP1=0?ofkP40oooo000R0?ofkP030000003om^h0ooK^00@0
ooK^00<000000?ofkP3om^h0D`3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00H0
ooK^00<0?EV[0?ofkP3om^h0203om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[0100ooK^00<0?EV[0?of
kP0mFJ/04`3om^h0100mFJ/0ooK^03eIZ`0mFJ/A0?ofkP0303eIZ`3om^h0ooK^00h0ooK^200mFJ/8
0?ofkP0303eIZ`3om^h0ooK^00H0?EV[00<0ooK^03eIZ`3om^h00P0mFJ/20?ofkP0303eIZ`3om^h0
ooK^00@0ooK^0`3D?AT20?ofkP030=@m6@3om^h0ooK^00<0ooK^103D?AT30?ofkP030=@m6@3om^h0
ooK^00<0ooK^00<000000?ofkP3om^h00P3D?AT20?ofkPD0e3dI2P3om^h00`3D?AT0ooK^0?ofkP05
0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h00P3om^h30=@m6@X0ooK^00<0e3dI
0?ofkP3om^h0503om^h00`3D?AT0ooK^0?ofkP040=@m6@h0ooK^00<0e3dI0?ofkP3om^h0503om^h2
00000500ooK^0@3oool00280ooK^00<000000?ofkP3om^h0103om^h00`000000ooK^0?ofkP1D0?of
kP0403eIZ`3om^h0ooK^03eIZ`T0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP03
0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00@0?EV[0?ofkP3om^h0ooK^0P0mFJ/@0?ofkP0303eIZ`3o
m^h0ooK^0080ooK^0P0mFJ/>0?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h0103o
m^h<03eIZ`@0ooK^00@0?EV[0?ofkP0mFJ/0ooK^0P0mFJ/00`3om^h0?EV[03eIZ`0:0?ofkP@0e3dI
1`3om^h50=@m6@D0ooK^00<000000=@m6@3D?AT01@3om^h00`3D?AT0ooK^0?ofkP040=@m6@L0ooK^
00<0e3dI0?ofkP3om^h00`3om^h20=@m6@L0ooK^00<0e3dI0?ofkP3om^h0103om^h30=@m6@H0ooK^
00<0e3dI0?ofkP3om^h0503om^h00`3D?AT0ooK^0?ofkP050?ofkP<0e3dI2P3om^h00`3D?AT0ooK^
0?ofkP0D0?ofkP030000003om^h0ooK^0500ooK^0@3oool00280ooK^00<000000?ofkP3om^h00`3o
m^h00`000000ooK^0?ofkP1E0?ofkP0403eIZ`3om^h0ooK^03eIZ`X0ooK^00<0?EV[0?ofkP3om^h0
1@3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h0
103om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00D0ooK^0P0mFJ/;0?ofkP0303eI
Z`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP040?ofkP80?EV[
00<0ooK^03eIZ`3om^h00`3om^h00`0mFJ/0ooK^03eIZ`0203eIZ`040?ofkP0mFJ/0?EV[03eIZ`h0
ooK^103D?AT70?ofkP@0e3dI0P3om^h20=@m6@L0ooK^00<0e3dI0?ofkP3om^h00`3om^h50=@m6@<0
ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00L0
ooK^0`3D?AT20?ofkP030=@m6@3om^h0ooK^01@0ooK^00<0e3dI0?ofkP3om^h02@3om^h30=@m6@H0
ooK^00<0e3dI0?ofkP3om^h04`3om^h2000005<0ooK^0@3oool00280ooK^00<000000?ofkP3om^h0
0P3om^h00`000000ooK^0?ofkP1G0?ofkP80?EV[303om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eI
Z`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eI
Z`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h0203om^h203eIZ`P0ooK^00<0?EV[0?ofkP3om^h0
3`3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00<0ooK^00@0?EV[0?ofkP0mFJ/0
?EV[1@3om^h303eIZ`80ooK^0P0mFJ/C0?ofkP@0e3dI1@3om^h60=@m6@030000003om^h0ooK^00H0
ooK^00<0e3dI0?ofkP3om^h01@3om^h50=@m6@050?ofkP3D?AT0ooK^0?ofkP3D?AT02P3om^h00`3D
?AT0ooK^0?ofkP0:0?ofkP<0e3dI5@3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP@0e3dI0P3om^h00`3D
?AT0ooK^0?ofkP0B0?ofkP030000003om^h0ooK^05<0ooK^0@3oool00280ooK^00D000000?ofkP3o
m^h0ooK^0000001J0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0m
FJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h0203om^h203eI
Z`P0ooK^0P0mFJ/=0?ofkP80?EV[1@3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^
00L0ooK^00<0?EV[0?ofkP3om^h00P3om^h0100mFJ/0ooK^0?ofkP0mFJ/50?ofkP<0?EV[0P3om^h2
03eIZaP0ooK^1@3D?AT30?ofkP030=@m6@3om^h0e3dI00<0e3dI1P3om^h00`3D?AT0ooK^0?ofkP08
0?ofkPH0e3dI2`3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00<0e3dI4@3om^h0
0`3D?AT0ooK^0?ofkP0B0?ofkP80e3dI4`3om^h2000005H0ooK^0@3oool00280ooK^00D000000?of
kP3om^h0ooK^0000001K0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00@0?EV[0?ofkP3om^h0?EV[3@3o
m^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h0103o
m^h00`0mFJ/0ooK^0?ofkP0?0?ofkP80?EV[0P3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3o
m^h0ooK^00P0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`020?ofkP80?EV[103om^h303eIZ`040?of
kP0mFJ/0?EV[03eIZa`0ooK^103D?AT20?ofkP030=@m6@3om^h000000080ooK^103D?AT30?ofkP03
0=@m6@3om^h0ooK^00X0ooK^1@3D?AT:0?ofkP030=@m6@3om^h0ooK^00L0ooK^0P3D?AT60?ofkP<0
e3dI3P3om^h00`3D?AT0ooK^0?ofkP0B0?ofkP030=@m6@3om^h0ooK^0140ooK^00<000000?ofkP3o
m^h0EP3om^h10?ooo`008@3om^h01@000000ooK^0?ofkP3om^h0000005`0ooK^00<0?EV[0?ofkP3o
m^h02`3om^h00`0mFJ/0ooK^03eIZ`0?0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3o
m^h0303om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^0180ooK^0`0mFJ/@0?ofkP03
03eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h00P0mFJ/20?ofkP80?EV[103om^h00`0mFJ/0
ooK^03eIZ`0203eIZ`030?ofkP0mFJ/0ooK^01l0ooK^1@3D?AT00`000000ooK^0?ofkP030?ofkPD0
e3dI2@3om^h30=@m6@030?ofkP3D?AT0ooK^00D0e3dI1`3om^h00`3D?AT0ooK^0?ofkP060?ofkP03
0=@m6@3om^h0ooK^00T0ooK^0`3D?AT:0?ofkP030=@m6@3om^h0ooK^0180ooK^00<0e3dI0?ofkP3o
m^h0403om^h2000005T0ooK^0@3oool00240ooK^00@000000?ofkP3om^h00000GP3om^h00`0mFJ/0
ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00l0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0@0?of
kP80?EV[00<0ooK^03eIZ`3om^h0503om^h00`0mFJ/0ooK^0?ofkP0403eIZ`/0ooK^00<0?EV[0?of
kP3om^h02@3om^h00`0mFJ/0ooK^03eIZ`030?ofkP0303eIZ`3om^h0?EV[00<0ooK^00@0?EV[0?of
kP0mFJ/0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP0S0?ofkP<0e3dI203om^h40=@m6@<0ooK^0`3D?AT5
0?ofkP030=@m6@3om^h0ooK^0080ooK^1@3D?AT30?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI
0?ofkP3om^h03@3om^h30=@m6@H0ooK^00<0e3dI0?ofkP3om^h04P3om^h00`3D?AT0ooK^0?ofkP0@
0?ofkP030000003om^h0ooK^05T0ooK^0@3oool00240ooK^00@000000?ofkP3om^h00000G`3om^h0
0`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0?EV[0140ooK^00<0?EV[0?ofkP0mFJ/04`3om^h0
0`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^00D0ooK^0`0mFJ/70?ofkP0303eIZ`3om^h0
ooK^00X0ooK^0P0mFJ/20?ofkP80?EV[0P3om^h00`0mFJ/0ooK^0?ofkP0403eIZ`80ooK^00<0?EV[
0?ofkP3om^h09@3om^h00`000000ooK^0=@m6@030=@m6@H0ooK^1@3D?AT80?ofkP030=@m6@3om^h0
ooK^00D0ooK^1@3D?AT00`3om^h0e3dI0?ofkP030?ofkP80e3dI4`3om^h30=@m6@80ooK^00<0e3dI
0?ofkP3om^h04P3om^h00`3D?AT0ooK^0?ofkP0@0?ofkP030000003om^h0ooK^05X0ooK^0@3oool0
0240ooK^00<000000?ofkP000000H03om^h00`0mFJ/0ooK^0?ofkP080?ofkP0503eIZ`3om^h0ooK^
0?ofkP0mFJ/04@3om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP0403eIZ`3om^h0?EV[03eIZa80ooK^00<0
?EV[0?ofkP3om^h02@3om^h403eIZ`80ooK^00<0?EV[0?ofkP3om^h02`3om^h0100mFJ/0ooK^0?of
kP0mFJ/30?ofkPL0?EV[00<0ooK^03eIZ`0mFJ/0:03om^h00`000000ooK^0?ofkP030?ofkPH0e3dI
00<0ooK^0=@m6@3om^h00P3om^h30=@m6@H0ooK^00<0e3dI0?ofkP3om^h0203om^h40=@m6@80ooK^
00<0e3dI0?ofkP3om^h05P3om^h30=@m6A<0ooK^00<0e3dI0?ofkP3om^h03`3om^h2000005d0ooK^
0@3oool00240ooK^0P00001R0?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h00`3o
m^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0?EV[0140ooK^00<0?EV[0?ofkP3om^h00P3o
m^h203eIZ`l0ooK^00<0?EV[0?ofkP3om^h03P3om^h803eIZ`L0ooK^0P0mFJ/00`3om^h0?EV[03eI
Z`0403eIZ`030?ofkP0mFJ/0?EV[0080?EV[00<0ooK^03eIZ`0mFJ/0:@3om^h00`000000ooK^0?of
kP060?ofkP@0e3dI00<0ooK^0=@m6@3D?AT0103om^h30=@m6@@0ooK^00<0e3dI0?ofkP3om^h02P3o
m^h40=@m6AL0ooK^0P3D?AT20?ofkP@0e3dI3`3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030000003o
m^h0ooK^05d0ooK^0@3oool00200ooK^0P00001T0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[
0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0403eIZ`3om^h0ooK^0?ofkP80?EV[3P3o
m^h00`0mFJ/0ooK^0?ofkP050?ofkP80?EV[2`3om^h203eIZa40ooK^00<0?EV[0?ofkP3om^h01@3o
m^h:03eIZ`D0ooK^0`0mFJ/20?ofkP<0?EV[:P3om^h00`000000ooK^0?ofkP090?ofkPD0e3dI1P3o
m^h50=@m6@/0ooK^0P3D?AT30?ofkP@0e3dI4@3om^h20=@m6@P0ooK^0`3D?AT;0?ofkP030=@m6@3o
m^h0ooK^00d0ooK^0P00001P0?ofkP40oooo000P0?ofkP800000I03om^h00`0mFJ/0ooK^0?ofkP04
0?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP04
0?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h0203om^h203eIZ`P0ooK^00<0?EV[
0?ofkP3om^h0403om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0403eIZ`3om^h0ooK^03eIZ`H0ooK^0P0m
FJ/20?ofkP80?EV[;03om^h00`000000ooK^0?ofkP0=0?ofkP@0e3dI1P3om^h40=@m6@L0ooK^0P3D
?AT20?ofkP030=@m6@3om^h0ooK^00@0ooK^0`3D?AT=0?ofkP030=@m6@3om^h0ooK^00/0ooK^0`3D
?AT70?ofkP030=@m6@3om^h0ooK^00d0ooK^00<000000?ofkP3om^h0H03om^h10?ooo`00803om^h2
000006D0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0
ooK^00L0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0
ooK^00/0ooK^0P0mFJ/50?ofkP0303eIZ`3om^h0ooK^0100ooK^00<0?EV[0?ofkP3om^h02`3om^h0
1@0mFJ/0ooK^0?ofkP3om^h0?EV[00D0ooK^0P0mFJ/20?ofkP80?EV[;@3om^h00`000000ooK^0?of
kP0@0?ofkPD0e3dI1@3om^h40=@m6@80ooK^0P3D?AT40?ofkP030=@m6@3om^h0ooK^00L0ooK^0`3D
?AT80?ofkP80e3dI4@3om^h40=@m6@80ooK^00<0e3dI0?ofkP3om^h0303om^h2000006<0ooK^0@3o
ool00280ooK^1000001R0?ofkP0403eIZ`3om^h0ooK^03eIZ``0ooK^00<0?EV[0?ofkP3om^h01@3o
m^h00`0mFJ/0ooK^0?ofkP080?ofkP80?EV[203om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP80?EV[0P3o
m^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00D0?EV[0?ofkP3om^h0ooK^
03eIZ`040?ofkP<0?EV[00@0ooK^03eIZ`0mFJ/0?EV[;P3om^h00`000000ooK^0?ofkP0D0?ofkPd0
e3dI1P3om^h00`3D?AT0ooK^0?ofkP090?ofkP@0e3dI0P3om^h20=@m6AL0ooK^0P3D?AT>0?ofkP03
0000003om^h0ooK^06<0ooK^0@3oool002H0ooK^1000001N0?ofkP0303eIZ`3om^h0?EV[00h0ooK^
00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00@0ooK^
00<0?EV[0?ofkP3om^h0403om^h303eIZa00ooK^0P0mFJ/=0?ofkP0303eIZ`3om^h0ooK^0080ooK^
00H0?EV[0?ofkP3om^h0ooK^03eIZ`3om^h303eIZ`030?ofkP0mFJ/0ooK^02h0ooK^00<000000?of
kP3om^h05`3om^h40=@m6@030?ofkP3D?AT0e3dI0080ooK^1@3D?AT30?ofkP030=@m6@3om^h0ooK^
00`0ooK^0`3D?ATH0?ofkP030=@m6@3om^h0ooK^00/0ooK^0P00001V0?ofkP40oooo000Z0?ofkP@0
0000F`3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/03`3om^h00`0m
FJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^0140ooK^00<0?EV[0?ofkP3om^h0100mFJ/;0?of
kP0303eIZ`3om^h0ooK^00/0ooK^0P0mFJ/40?ofkP0403eIZ`3om^h0ooK^0?ofkP@0?EV[0P3om^h0
0`0mFJ/0ooK^0?ofkP0^0?ofkP030000003om^h0ooK^01X0ooK^1@3D?AT50?ofkPD0e3dI303om^h2
0=@m6@<0ooK^0`3D?ATC0?ofkP80e3dI3@3om^h00`000000ooK^0?ofkP1V0?ofkP40oooo000^0?of
kP@00000F03om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0?EV[0140ooK^0P0mFJ/00`3o
m^h0?EV[0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^00D0ooK^0`0mFJ/70?ofkP0303eIZ`3om^h0ooK^
00/0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0403eIZ`030?ofkP0mFJ/0?EV[
0340ooK^00<000000?ofkP3om^h07P3om^h30=@m6@H0ooK^0`3D?AT90?ofkP80e3dI203om^h30=@m
6@l0ooK^00<0e3dI0?ofkP3om^h02`3om^h2000006T0ooK^0@3oool00380ooK^1000001E0?ofkP03
03eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h04P3om^h203eIZa80ooK^00<0?EV[0?ofkP3o
m^h02@3om^h403eIZ`80ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP050?ofkP@0
?EV[00<0ooK^03eIZ`3om^h00P0mFJ/b0?ofkP030000003om^h0ooK^0200ooK^1@3D?AT50?ofkP@0
e3dI0`3om^h20=@m6@d0ooK^0`3D?AT;0?ofkP030=@m6@3om^h0ooK^00/0ooK^00<000000?ofkP3o
m^h0J@3om^h10?ooo`00=P3om^h400000580ooK^00<0?EV[0?ofkP3om^h0303om^h0100mFJ/0ooK^
03eIZ`0mFJ/A0?ofkP0303eIZ`3om^h0ooK^0080?EV[3`3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkPP0
?EV[1`3om^h00`0mFJ/0ooK^0?ofkP0603eIZ`060?ofkP0mFJ/0?EV[0?ofkP0mFJ/0ooK^0P0mFJ/c
0?ofkP030000003om^h0ooK^02<0ooK^1@3D?AT40?ofkPD0e3dI4P3om^h30=@m6@H0ooK^0P3D?AT<
0?ofkP800000K03om^h10?ooo`00>P3om^h4000004l0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0m
FJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h00`3om^h203eI
Z`/0ooK^0P0mFJ/A0?ofkP0303eIZ`3om^h0ooK^00D0ooK^2P0mFJ/50?ofkP<0?EV[00@0ooK^03eI
Z`3om^h0?EV[=@3om^h00`000000ooK^0?ofkP0V0?ofkPH0e3dI00<0ooK^0=@m6@3om^h00P3om^h4
0=@m6A40ooK^0`3D?AT20?ofkP030=@m6@3om^h0ooK^00/0ooK^00<000000?ofkP3om^h0K03om^h1
0?ooo`00?P3om^h4000004`0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP040?of
kP80?EV[303om^h00`0mFJ/0ooK^0?ofkP060?ofkP80?EV[203om^h00`0mFJ/0ooK^0?ofkP0@0?of
kP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h01P3om^h203eIZ`<0ooK^0P0mFJ/f0?of
kP030000003om^h0ooK^02T0ooK^1`3D?AT50?ofkP<0e3dI4@3om^h20=@m6@d0ooK^00<000000?of
kP3om^h0K@3om^h10?ooo`00@P3om^h4000004T0ooK^00<0?EV[0?ofkP3om^h01@3om^h203eIZ`T0
ooK^00<0?EV[0?ofkP3om^h01`3om^h203eIZ`/0ooK^0P0mFJ/50?ofkP0303eIZ`3om^h0ooK^0100
ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP060?ofkP80?EV[0`3om^h203eIZcL0
ooK^00<000000?ofkP3om^h0;@3om^h50=@m6@H0ooK^0`3D?AT;0?ofkP<0e3dI3@3om^h200000700
ooK^0@3oool004H0ooK^100000160?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h0
2P3om^h203eIZ`H0ooK^00<0?EV[0?ofkP3om^h03@3om^h203eIZ`80ooK^00<0?EV[0?ofkP3om^h0
403om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00H0ooK^0P0mFJ/00`3om^h0?EV[
03eIZ`0203eIZcP0ooK^00<000000?ofkP3om^h0<03om^h40=@m6@L0ooK^103D?AT30?ofkP@0e3dI
3`3om^h00`000000ooK^0?ofkP1`0?ofkP40oooo001:0?ofkP@00000@`3om^h01@0mFJ/0ooK^0?of
kP3om^h0?EV[00l0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP<0?EV[
403om^h203eIZ`d0ooK^00<0?EV[0?ofkP3om^h01@3om^h203eIZ`040?ofkP0mFJ/0?EV[0?ofkP80
?EV[>P3om^h00`000000ooK^0?ofkP0b0?ofkP@0e3dI1P3om^h50=@m6A40ooK^0P00001c0?ofkP40
oooo001>0?ofkP@00000@03om^h00`0mFJ/0ooK^03eIZ`0A0?ofkP80?EV[00<0ooK^03eIZ`3om^h0
4P3om^h00`0mFJ/0ooK^0?ofkP0403eIZ`/0ooK^00<0?EV[0?ofkP3om^h02`3om^h203eIZ`L0ooK^
100mFJ/20?ofkP0303eIZ`3om^h0ooK^03X0ooK^00<000000?ofkP3om^h0=P3om^h60=@m6AD0ooK^
00<000000?ofkP3om^h0L`3om^h10?ooo`00DP3om^h4000003d0ooK^00<0?EV[0?ofkP3om^h04P3o
m^h00`0mFJ/0ooK^0?ofkP0A0?ofkP0303eIZ`3om^h0ooK^00D0ooK^0`0mFJ/70?ofkP0303eIZ`3o
m^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h01@3om^h303eIZ`050?ofkP0mFJ/0ooK^0?ofkP0mFJ/0
?@3om^h00`000000ooK^0?ofkP1?0?ofkP800000MP3om^h10?ooo`00EP3om^h3000003/0ooK^00<0
?EV[0?ofkP3om^h0403om^h0100mFJ/0ooK^03eIZ`0mFJ/@0?ofkP0303eIZ`3om^h0ooK^00T0ooK^
100mFJ/20?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h00P3om^h503eIZ`<0ooK^
0`0mFJ/n0?ofkP030000003om^h0ooK^04h0ooK^00<000000?ofkP3om^h0MP3om^h10?ooo`00F@3o
m^h4000003P0ooK^0P0mFJ/?0?ofkP0303eIZ`3om^h0ooK^0080ooK^0P0mFJ/=0?ofkP0303eIZ`3o
m^h0ooK^00h0ooK^200mFJ/70?ofkP0303eIZ`3om^h0?EV[00<0?EV[0`3om^h0100mFJ/0ooK^0?of
kP3om^h303eIZcl0ooK^00<000000?ofkP3om^h0C03om^h2000007T0ooK^0@3oool005d0ooK^1000
000f0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h01@3om^h203eIZ`X0ooK^00<0
?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP050?ofkPT0?EV[1P3om^h0100mFJ/0ooK^0?of
kP3om^h203eIZd40ooK^00<000000?ofkP3om^h0B`3om^h00`000000ooK^0?ofkP1i0?ofkP40oooo
001Q0?ofkP@00000<`3om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^00P0ooK^0P0m
FJ/70?ofkP0303eIZ`3om^h0ooK^00h0ooK^0P0mFJ/=0?ofkP0303eIZ`3om^h0ooK^00H0ooK^00@0
?EV[0?ofkP3om^h0ooK^0P0mFJ]20?ofkP030000003om^h0ooK^04T0ooK^0P00001l0?ofkP40oooo
001U0?ofkP@00000<03om^h203eIZ`P0ooK^00<0?EV[0?ofkP3om^h02`3om^h203eIZ`@0ooK^00<0
?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP80?EV[1`3om^h203eIZ`80ooK^0`0m
FJ]30?ofkP030000003om^h0ooK^04P0ooK^00<000000?ofkP3om^h0O03om^h10?ooo`00J@3om^h4
000002h0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP80?EV[00<0ooK^
03eIZ`3om^h03`3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[
0?ofkP3om^h00P0mFJ/00`3om^h0?EV[0?ofkP130?ofkP030000003om^h0ooK^04H0ooK^0P00001o
0?ofkP40oooo001]0?ofkP@00000:`3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^
0140ooK^0`0mFJ/>0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h01P3om^h0100m
FJ/0ooK^03eIZ`0mFJ/20?ofkP0303eIZ`3om^h0ooK^04<0ooK^00<000000?ofkP3om^h0A@3om^h0
0`000000ooK^0?ofkP1o0?ofkP40oooo001a0?ofkP@00000:03om^h203eIZ`030?ofkP0mFJ/0ooK^
0180ooK^00@0?EV[0?ofkP3om^h0ooK^100mFJ/80?ofkP80?EV[3@3om^h00`0mFJ/0ooK^0?ofkP06
0?ofkP<0?EV[0P3om^h203eIZdH0ooK^00<000000?ofkP3om^h0A03om^h00`000000ooK^0?ofkP20
0?ofkP40oooo001e0?ofkP@000009P3om^h203eIZa80ooK^00<0?EV[0?ofkP3om^h01P3om^h403eI
Z`<0ooK^00<0?EV[0?ofkP3om^h02`3om^h203eIZ`H0ooK^100mFJ/30?ofkP80?EV[A`3om^h00`00
0000ooK^0?ofkP120?ofkP800000P`3om^h10?ooo`00N@3om^h4000002@0ooK^0P0mFJ/?0?ofkP03
03eIZ`3om^h0ooK^00/0ooK^2@0mFJ/70?ofkP0303eIZ`3om^h0ooK^00H0?EV[00<0ooK^03eIZ`3o
m^h00`3om^h00`0mFJ/0ooK^0?ofkP170?ofkP030000003om^h0ooK^0440ooK^00<000000?ofkP3o
m^h0P`3om^h10?ooo`00O@3om^h400000280ooK^0P0mFJ/;0?ofkP80?EV[3`3om^h00`0mFJ/0ooK^
0?ofkP050?ofkPX0?EV[1P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^04P0ooK^
00<000000?ofkP3om^h0?`3om^h2000008H0ooK^0@3oool00840ooK^1000000P0?ofkP80?EV[203o
m^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h01`3o
m^h0100mFJ/0ooK^0?ofkP3om^h203eIZd/0ooK^00<000000?ofkP3om^h0?P3om^h00`000000ooK^
0?ofkP260?ofkP40oooo00250?ofkP@000007P3om^h203eIZ`D0ooK^00<0?EV[0?ofkP3om^h03P3o
m^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00H0ooK^0P0mFJ/20?ofkP80?EV[C@3o
m^h00`000000ooK^0?ofkP0l0?ofkP800000R@3om^h10?ooo`00R@3om^h3000001d0ooK^0P0mFJ/2
0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP06
0?ofkP0303eIZ`3om^h0ooK^0080?EV[C`3om^h00`000000ooK^0?ofkP0k0?ofkP030000003om^h0
ooK^08T0ooK^0@3oool008`0ooK^1000000K0?ofkP<0?EV[3`3om^h00`0mFJ/0ooK^0?ofkP0:0?of
kP80?EV[203om^h0100mFJ/0ooK^03eIZ`0mFJ]A0?ofkP030000003om^h0ooK^03T0ooK^0P00002<
0?ofkP40oooo002@0?ofkP@000006P3om^h303eIZ`/0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0m
FJ/0ooK^0?ofkP070?ofkP<0?EV[D`3om^h00`000000ooK^0?ofkP0h0?ofkP030000003om^h0ooK^
08`0ooK^0@3oool009@0ooK^1000000I0?ofkP@0?EV[1P3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP03
03eIZ`3om^h0ooK^00D0ooK^100mFJ]E0?ofkP030000003om^h0ooK^03H0ooK^0P00002?0?ofkP40
oooo002H0?ofkP@000006@3om^h303eIZ`80ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^
0?ofkP0603eIZeT0ooK^00<000000?ofkP3om^h0=@3om^h00`000000ooK^0?ofkP2?0?ofkP40oooo
002L0?ofkP@00000603om^hB03eIZel0ooK^00<000000?ofkP3om^h0<`3om^h200000980ooK^0@3o
ool00:00ooK^100000250?ofkP030000003om^h0ooK^0380ooK^00<000000?ofkP3om^h0TP3om^h1
0?ooo`00Y03om^h400000880ooK^00<000000?ofkP3om^h0<03om^h00`000000ooK^0?ofkP2C0?of
kP40oooo002X0?ofkP@00000OP3om^h00`000000ooK^0?ofkP0^0?ofkP800000UP3om^h10?ooo`00
[03om^h4000007X0ooK^00<000000?ofkP3om^h0;@3om^h00`000000ooK^0?ofkP2F0?ofkP40oooo
002`0?ofkP@00000MP3om^h00`000000ooK^0?ofkP0[0?ofkP800000V@3om^h10?ooo`00]03om^h4
00000780ooK^00<000000?ofkP3om^h0:P3om^h00`000000ooK^0?ofkP2I0?ofkP40oooo002h0?of
kP@00000KP3om^h00`000000ooK^0?ofkP0X0?ofkP800000W03om^h10?ooo`00_03om^h4000006X0
ooK^00<000000?ofkP3om^h09`3om^h00`000000ooK^0?ofkP2L0?ofkP40oooo00300?ofkP<00000
I`3om^h00`000000ooK^0?ofkP0U0?ofkP800000W`3om^h10?ooo`00``3om^h4000006<0ooK^00<0
00000?ofkP3om^h0903om^h00`000000ooK^0?ofkP2O0?ofkP40oooo00370?ofkP@00000G`3om^h0
0`000000ooK^0?ofkP0R0?ofkP800000XP3om^h10?ooo`00b`3om^h4000005/0ooK^00<000000?of
kP3om^h08@3om^h00`000000ooK^0?ofkP2R0?ofkP40oooo003?0?ofkP@00000E`3om^h00`000000
ooK^0?ofkP0O0?ofkP800000Y@3om^h10?ooo`00d`3om^h4000005<0ooK^00<000000?ofkP3om^h0
7P3om^h00`000000ooK^0?ofkP2U0?ofkP40oooo003G0?ofkP@00000C`3om^h00`000000ooK^0?of
kP0L0?ofkP800000Z03om^h10?ooo`00f`3om^h4000004/0ooK^00<000000?ofkP3om^h06`3om^h0
0`000000ooK^0?ofkP2X0?ofkP40oooo003O0?ofkP@00000A`3om^h00`000000ooK^0?ofkP0J0?of
kP030000003om^h0ooK^0:T0ooK^0@3oool00><0ooK^100000130?ofkP030000003om^h0ooK^01P0
ooK^0P00002/0?ofkP40oooo003W0?ofkP@00000?`3om^h00`000000ooK^0?ofkP0G0?ofkP030000
003om^h0ooK^0:`0ooK^0@3oool00>/0ooK^1000000k0?ofkP030000003om^h0ooK^01D0ooK^0P00
002_0?ofkP40oooo003_0?ofkP@00000=`3om^h00`000000ooK^0?ofkP0D0?ofkP030000003om^h0
ooK^0:l0ooK^0@3oool00?<0ooK^0`00000d0?ofkP030000003om^h0ooK^0180ooK^0P00002b0?of
kP40oooo003f0?ofkP@00000<03om^h00`000000ooK^0?ofkP0A0?ofkP030000003om^h0ooK^0;80
ooK^0@3oool00?X0ooK^1000000/0?ofkP030000003om^h0ooK^00l0ooK^0P00002e0?ofkP40oooo
003n0?ofkP@00000:@3om^h00`000000ooK^0?ofkP0=0?ofkP030000003om^h0ooK^0;D0ooK^0@3o
ool00?l0ooK^0`3om^h4000002D0ooK^00<000000?ofkP3om^h02`3om^h200000;P0ooK^0@3oool0
0?l0ooK^1`3om^h400000240ooK^00<000000?ofkP3om^h02P3om^h00`000000ooK^0?ofkP2h0?of
kP40oooo003o0?ofkP/0ooK^1000000M0?ofkP030000003om^h0ooK^00P0ooK^0P00002k0?ofkP40
oooo003o0?ofkPl0ooK^1000000I0?ofkP030000003om^h0ooK^00L0ooK^00<000000?ofkP3om^h0
^`3om^h10?ooo`00o`3om^hC0?ofkP@000005@3om^h00`000000ooK^0?ofkP060?ofkP030000003o
m^h0ooK^0;`0ooK^0@3oool00?l0ooK^5`3om^h400000140ooK^00<000000?ofkP3om^h0103om^h2
00000;l0ooK^0@3oool00?l0ooK^6`3om^h4000000d0ooK^00<000000?ofkP3om^h00`3om^h00`00
0000ooK^0?ofkP2o0?ofkP40oooo003o0?ofkQl0ooK^100000090?ofkP040000003om^h0ooK^0?of
kP800000`P3om^h10?ooo`00o`3om^hS0?ofkP@000001@3om^h010000000ooK^0?ofkP0000340?of
kP40oooo003o0?ofkRL0ooK^10000000103om^h000000000000000350?ofkP40oooo003o0?ofkR/0
ooK^0P0000370?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd
0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo
003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0
ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool0
0?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03o
m^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00
o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?of
kP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o
0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^
0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0
ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h1
0?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3o
m^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40
oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?of
k_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3o
ool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^
m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?oo
o`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd
0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo
003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0
ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool0
0?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03o
m^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00
o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00001\
\>"],
  ImageRangeCache->{{{0, 499}, {499, 0}} -> {-5.00005*^-06, -5.00005*^-06, \
0.00200403, 0.00200403}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
%%ImageSize: 500 500 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics3D
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Background color
1 .961 .933 r
MFill
% Scaling calculations
0 1 0 1 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 0 r
.25 Mabswid
[ ] 0 setdash
.92347 .37901 m
.97811 .6366 L
s
.97811 .6366 m
.5 .30205 L
s
.5 .30205 m
.5 .02321 L
s
.5 .02321 m
.92347 .37901 L
s
.5 .60969 m
.07653 .37901 L
s
.07653 .37901 m
.02189 .6366 L
s
.02189 .6366 m
.5 .84126 L
s
.5 .84126 m
.5 .60969 L
s
.92347 .37901 m
.97811 .6366 L
s
.97811 .6366 m
.5 .84126 L
s
.5 .84126 m
.5 .60969 L
s
.5 .60969 m
.92347 .37901 L
s
.5 .02321 m
.07653 .37901 L
s
.07653 .37901 m
.02189 .6366 L
s
.02189 .6366 m
.5 .30205 L
s
.5 .30205 m
.5 .02321 L
s
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
.83 .24 .1 r
.5 Mabswid
.60748 .59209 m
.61997 .56857 L
s
.61997 .56857 m
.59546 .55382 L
s
.61997 .56857 m
.63546 .54698 L
s
.24 .35 .67 r
.38003 .56857 m
.36454 .54698 L
s
.40454 .55382 m
.38003 .56857 L
s
.39252 .59209 m
.38003 .56857 L
s
.83 .24 .1 r
.59844 .6167 m
.60748 .59209 L
s
.60748 .59209 m
.58277 .57763 L
s
.24 .35 .67 r
.41723 .57763 m
.39252 .59209 L
s
.40156 .6167 m
.39252 .59209 L
s
.83 .24 .1 r
.63546 .54698 m
.6111 .53191 L
s
.63546 .54698 m
.65341 .52807 L
s
.24 .35 .67 r
.36454 .54698 m
.34659 .52807 L
s
.3889 .53191 m
.36454 .54698 L
s
.83 .24 .1 r
.59321 .64154 m
.59844 .6167 L
s
.59844 .6167 m
.57351 .6025 L
s
.24 .35 .67 r
.42649 .6025 m
.40156 .6167 L
s
.40679 .64154 m
.40156 .6167 L
s
.83 .24 .1 r
.65341 .52807 m
.62917 .51268 L
s
.65341 .52807 m
.67321 .51257 L
s
.24 .35 .67 r
.34659 .52807 m
.32679 .51257 L
s
.37083 .51268 m
.34659 .52807 L
s
.83 .24 .1 r
.59206 .6657 m
.59321 .64154 L
s
.59321 .64154 m
.56804 .62758 L
s
.24 .35 .67 r
.43196 .62758 m
.40679 .64154 L
s
.40794 .6657 m
.40679 .64154 L
s
.83 .24 .1 r
.58277 .57763 m
.59546 .55382 L
s
.59546 .55382 m
.57028 .53867 L
s
.59546 .55382 m
.6111 .53191 L
s
.24 .35 .67 r
.3889 .53191 m
.40454 .55382 L
s
.42972 .53867 m
.40454 .55382 L
s
.40454 .55382 m
.41723 .57763 L
s
.83 .24 .1 r
.67321 .51257 m
.64906 .49686 L
s
.67321 .51257 m
.69419 .50112 L
s
.24 .35 .67 r
.32679 .51257 m
.30581 .50112 L
s
.35094 .49686 m
.32679 .51257 L
s
.83 .24 .1 r
.57351 .6025 m
.58277 .57763 L
s
.58277 .57763 m
.5574 .56278 L
s
.24 .35 .67 r
.4426 .56278 m
.41723 .57763 L
s
.41723 .57763 m
.42649 .6025 L
s
.37083 .51268 m
.3889 .53191 L
s
.41391 .51644 m
.3889 .53191 L
s
.83 .24 .1 r
.6111 .53191 m
.58609 .51644 L
s
.6111 .53191 m
.62917 .51268 L
s
.56804 .62758 m
.57351 .6025 L
s
.57351 .6025 m
.54792 .58793 L
s
.24 .35 .67 r
.45208 .58793 m
.42649 .6025 L
s
.42649 .6025 m
.43196 .62758 L
s
.83 .24 .1 r
.62917 .51268 m
.60429 .49688 L
s
.62917 .51268 m
.64906 .49686 L
s
.24 .35 .67 r
.35094 .49686 m
.37083 .51268 L
s
.39571 .49688 m
.37083 .51268 L
s
.83 .24 .1 r
.56664 .65194 m
.59206 .6657 L
s
.59514 .68827 m
.59206 .6657 L
s
.24 .35 .67 r
.43336 .65194 m
.40794 .6657 L
s
.40486 .68827 m
.40794 .6657 L
s
.30581 .50112 m
.28443 .49427 L
s
.32992 .4851 m
.30581 .50112 L
s
.83 .24 .1 r
.69419 .50112 m
.67008 .4851 L
s
.69419 .50112 m
.71557 .49427 L
s
.56664 .65194 m
.56804 .62758 L
s
.56804 .62758 m
.54219 .61324 L
s
.24 .35 .67 r
.45781 .61324 m
.43196 .62758 L
s
.43196 .62758 m
.43336 .65194 L
s
.83 .24 .1 r
.5574 .56278 m
.57028 .53867 L
s
.57028 .53867 m
.54443 .52311 L
s
.57028 .53867 m
.58609 .51644 L
s
.24 .35 .67 r
.41391 .51644 m
.42972 .53867 L
s
.45557 .52311 m
.42972 .53867 L
s
.42972 .53867 m
.4426 .56278 L
s
.83 .24 .1 r
.64906 .49686 m
.62426 .48073 L
s
.64906 .49686 m
.67008 .4851 L
s
.24 .35 .67 r
.32992 .4851 m
.35094 .49686 L
s
.37574 .48073 m
.35094 .49686 L
s
.83 .24 .1 r
.54792 .58793 m
.5574 .56278 L
s
.5574 .56278 m
.53135 .54753 L
s
.24 .35 .67 r
.46865 .54753 m
.4426 .56278 L
s
.4426 .56278 m
.45208 .58793 L
s
.83 .24 .1 r
.58609 .51644 m
.56041 .50056 L
s
.58609 .51644 m
.60429 .49688 L
s
.24 .35 .67 r
.39571 .49688 m
.41391 .51644 L
s
.43959 .50056 m
.41391 .51644 L
s
.83 .24 .1 r
.54219 .61324 m
.54792 .58793 L
s
.54792 .58793 m
.52162 .57296 L
s
.24 .35 .67 r
.47838 .57296 m
.45208 .58793 L
s
.45208 .58793 m
.45781 .61324 L
s
.83 .24 .1 r
.60248 .70829 m
.59514 .68827 L
s
.59514 .68827 m
.56947 .67465 L
s
.24 .35 .67 r
.43053 .67465 m
.40486 .68827 L
s
.39752 .70829 m
.40486 .68827 L
s
.83 .24 .1 r
.60429 .49688 m
.57873 .48066 L
s
.60429 .49688 m
.62426 .48073 L
s
.24 .35 .67 r
.37574 .48073 m
.39571 .49688 L
s
.42127 .48066 m
.39571 .49688 L
s
.83 .24 .1 r
.54053 .63779 m
.56664 .65194 L
s
.56947 .67465 m
.56664 .65194 L
s
.24 .35 .67 r
.45947 .63779 m
.43336 .65194 L
s
.43336 .65194 m
.43053 .67465 L
s
.28443 .49427 m
.26348 .49245 L
s
.30854 .47797 m
.28443 .49427 L
s
.83 .24 .1 r
.71557 .49427 m
.69146 .47797 L
s
.71557 .49427 m
.73652 .49245 L
s
.67008 .4851 m
.64532 .46865 L
s
.67008 .4851 m
.69146 .47797 L
s
.24 .35 .67 r
.30854 .47797 m
.32992 .4851 L
s
.35468 .46865 m
.32992 .4851 L
s
.83 .24 .1 r
.54053 .63779 m
.54219 .61324 L
s
.54219 .61324 m
.51564 .59851 L
s
.24 .35 .67 r
.48436 .59851 m
.45781 .61324 L
s
.45781 .61324 m
.45947 .63779 L
s
.83 .24 .1 r
.53135 .54753 m
.54443 .52311 L
s
.54443 .52311 m
.51788 .50713 L
s
.54443 .52311 m
.56041 .50056 L
s
.24 .35 .67 r
.43959 .50056 m
.45557 .52311 L
s
.48212 .50713 m
.45557 .52311 L
s
.45557 .52311 m
.46865 .54753 L
s
.83 .24 .1 r
.62426 .48073 m
.59878 .46416 L
s
.62426 .48073 m
.64532 .46865 L
s
.24 .35 .67 r
.35468 .46865 m
.37574 .48073 L
s
.40122 .46416 m
.37574 .48073 L
s
.83 .24 .1 r
.52162 .57296 m
.53135 .54753 L
s
.53135 .54753 m
.50458 .53186 L
s
.24 .35 .67 r
.49542 .53186 m
.46865 .54753 L
s
.46865 .54753 m
.47838 .57296 L
s
.83 .24 .1 r
.56041 .50056 m
.53402 .48423 L
s
.56041 .50056 m
.57873 .48066 L
s
.24 .35 .67 r
.42127 .48066 m
.43959 .50056 L
s
.46598 .48423 m
.43959 .50056 L
s
.83 .24 .1 r
.51564 .59851 m
.52162 .57296 L
s
.24 .35 .67 r
.47838 .57296 m
.48436 .59851 L
s
.83 .24 .1 r
.61394 .72487 m
.60248 .70829 L
s
.60248 .70829 m
.57657 .69477 L
s
.24 .35 .67 r
.42343 .69477 m
.39752 .70829 L
s
.38606 .72487 m
.39752 .70829 L
s
.83 .24 .1 r
.57657 .69477 m
.56947 .67465 L
s
.56947 .67465 m
.54309 .66065 L
s
.24 .35 .67 r
.45691 .66065 m
.43053 .67465 L
s
.43053 .67465 m
.42343 .69477 L
s
.83 .24 .1 r
.57873 .48066 m
.55247 .46398 L
s
.57873 .48066 m
.59878 .46416 L
s
.24 .35 .67 r
.40122 .46416 m
.42127 .48066 L
s
.44753 .46398 m
.42127 .48066 L
s
.83 .24 .1 r
.5137 .62326 m
.54053 .63779 L
s
.54309 .66065 m
.54053 .63779 L
s
.24 .35 .67 r
.4863 .62326 m
.45947 .63779 L
s
.45947 .63779 m
.45691 .66065 L
s
.26348 .49245 m
.24382 .49594 L
s
.28762 .4759 m
.26348 .49245 L
s
.83 .24 .1 r
.73652 .49245 m
.71238 .4759 L
s
.73652 .49245 m
.75618 .49594 L
s
.24 .35 .67 r
.28762 .4759 m
.30854 .47797 L
s
.3333 .46122 m
.30854 .47797 L
s
.83 .24 .1 r
.69146 .47797 m
.6667 .46122 L
s
.69146 .47797 m
.71238 .4759 L
s
.64532 .46865 m
.61987 .45174 L
s
.64532 .46865 m
.6667 .46122 L
s
.24 .35 .67 r
.3333 .46122 m
.35468 .46865 L
s
.38013 .45174 m
.35468 .46865 L
s
.83 .24 .1 r
.50458 .53186 m
.51788 .50713 L
s
.51788 .50713 m
.53402 .48423 L
s
.24 .35 .67 r
.46598 .48423 m
.48212 .50713 L
s
.48212 .50713 m
.49542 .53186 L
s
.38013 .45174 m
.40122 .46416 L
s
.4274 .44712 m
.40122 .46416 L
s
.83 .24 .1 r
.59878 .46416 m
.5726 .44712 L
s
.59878 .46416 m
.61987 .45174 L
s
.992 .279 .115 r
.48683 .56886 m .5 .57626 L .5 .55343 L p F P
0 0 0 r
s
.24 .35 .67 r
.47838 .57296 m
.48801 .56747 L
s
.992 .279 .115 r
.5 .55343 m .48768 .54637 L .48683 .56886 L p F P
0 0 0 r
s
1 .286 .119 r
.48768 .54637 m .5 .55343 L .5 .52944 L p F P
0 0 0 r
s
.24 .35 .67 r
.49542 .53186 m
.4964 .53439 L
s
.209 .299 .607 r
.51119 .52289 m .5 .52944 L .5 .55343 L p F P
0 0 0 r
s
.209 .299 .607 r
.5 .55343 m .51232 .54637 L .51119 .52289 L p F P
0 0 0 r
s
.193 .274 .56 r
.51232 .54637 m .5 .55343 L .5 .57626 L p F P
0 0 0 r
s
.83 .24 .1 r
.50521 .56361 m
.52162 .57296 L
s
.53402 .48423 m
.55247 .46398 L
s
.24 .35 .67 r
.44753 .46398 m
.46598 .48423 L
s
1 .286 .119 r
.5 .52944 m .48881 .52289 L .48768 .54637 L p F P
0 0 0 r
s
1 .291 .121 r
.48881 .52289 m .5 .52944 L .5 .50469 L p F P
0 0 0 r
s
.223 .322 .648 r
.50981 .49883 m .5 .50469 L .5 .52944 L p F P
0 0 0 r
s
.223 .322 .648 r
.5 .52944 m .51119 .52289 L .50981 .49883 L p F P
0 0 0 r
s
.83 .24 .1 r
.51001 .5024 m
.51788 .50713 L
s
.967 .27 .111 r
.48626 .58997 m .5 .59754 L .5 .57626 L p F P
0 0 0 r
s
.24 .35 .67 r
.48436 .59851 m
.49303 .5937 L
s
.967 .27 .111 r
.5 .57626 m .48683 .56886 L .48626 .58997 L p F P
0 0 0 r
s
.193 .274 .56 r
.5 .57626 m .51317 .56886 L .51232 .54637 L p F P
0 0 0 r
s
.83 .24 .1 r
.49461 .55757 m
.50133 .54025 L
s
.24 .35 .67 r
.49867 .54025 m
.50539 .55757 L
s
.83 .24 .1 r
.49461 .55757 m
.50076 .56107 L
s
.24 .35 .67 r
.49924 .56107 m
.50539 .55757 L
s
.175 .246 .506 r
.51317 .56886 m .5 .57626 L .5 .59754 L p F P
0 0 0 r
s
.83 .24 .1 r
.50282 .5914 m
.51564 .59851 L
s
.48835 .58337 m
.49461 .55757 L
s
.58782 .71138 m
.57657 .69477 L
s
.57657 .69477 m
.54993 .68087 L
s
.24 .35 .67 r
.45007 .68087 m
.42343 .69477 L
s
.42343 .69477 m
.41218 .71138 L
s
.83 .24 .1 r
.54993 .68087 m
.54309 .66065 L
s
.54309 .66065 m
.51598 .64627 L
s
.24 .35 .67 r
.48402 .64627 m
.45691 .66065 L
s
.45691 .66065 m
.45007 .68087 L
s
.236 .343 .687 r
.5082 .47458 m .5 .47958 L .5 .50469 L p F P
0 0 0 r
s
.236 .343 .687 r
.5 .50469 m .50981 .49883 L .5082 .47458 L p F P
0 0 0 r
s
1 .291 .121 r
.5 .50469 m .49019 .49883 L .48881 .52289 L p F P
0 0 0 r
s
.24 .35 .67 r
.48212 .50713 m
.48999 .5024 L
s
1 .295 .123 r
.49019 .49883 m .5 .50469 L .5 .47958 L p F P
0 0 0 r
s
.83 .24 .1 r
.62922 .73714 m
.61394 .72487 L
s
.61394 .72487 m
.58782 .71138 L
s
.24 .35 .67 r
.41218 .71138 m
.38606 .72487 L
s
.37078 .73714 m
.38606 .72487 L
s
.83 .24 .1 r
.55247 .46398 m
.52547 .44684 L
s
.55247 .46398 m
.5726 .44712 L
s
.24 .35 .67 r
.4274 .44712 m
.44753 .46398 L
s
.47453 .44684 m
.44753 .46398 L
s
.931 .257 .105 r
.48599 .60931 m .5 .6169 L .5 .59754 L p F P
0 0 0 r
s
.931 .257 .105 r
.5 .59754 m .48626 .58997 L .48599 .60931 L p F P
0 0 0 r
s
.24 .35 .67 r
.48436 .59851 m
.4863 .62326 L
s
.175 .246 .506 r
.5 .59754 m .51374 .58997 L .51317 .56886 L p F P
0 0 0 r
s
.24 .35 .67 r
.50539 .55757 m
.51165 .58337 L
s
.153 .212 .442 r
.51374 .58997 m .5 .59754 L .5 .6169 L p F P
0 0 0 r
s
.83 .24 .1 r
.48835 .58337 m
.50072 .59023 L
s
.24 .35 .67 r
.49928 .59023 m
.51165 .58337 L
s
.83 .24 .1 r
.5137 .62326 m
.51564 .59851 L
s
.992 .279 .115 r
.47348 .56136 m .48683 .56886 L .48768 .54637 L p F P
0 0 0 r
s
.992 .279 .115 r
.48768 .54637 m .47521 .53922 L .47348 .56136 L p F P
0 0 0 r
s
1 .286 .119 r
.47521 .53922 m .48768 .54637 L .48881 .52289 L p F P
0 0 0 r
s
.209 .299 .607 r
.52251 .51627 m .51119 .52289 L .51232 .54637 L p F P
0 0 0 r
s
.209 .299 .607 r
.51232 .54637 m .52479 .53922 L .52251 .51627 L p F P
0 0 0 r
s
.193 .274 .56 r
.52479 .53922 m .51232 .54637 L .51317 .56886 L p F P
0 0 0 r
s
.223 .322 .648 r
.51972 .49291 m .50981 .49883 L .51119 .52289 L p F P
0 0 0 r
s
.223 .322 .648 r
.51119 .52289 m .52251 .51627 L .51972 .49291 L p F P
0 0 0 r
s
1 .286 .119 r
.48881 .52289 m .47749 .51627 L .47521 .53922 L p F P
0 0 0 r
s
1 .291 .121 r
.47749 .51627 m .48881 .52289 L .49019 .49883 L p F P
0 0 0 r
s
.24 .35 .67 r
.26804 .4792 m
.28762 .4759 L
s
.31243 .45889 m
.28762 .4759 L
s
.83 .24 .1 r
.71238 .4759 m
.68757 .45889 L
s
.71238 .4759 m
.73196 .4792 L
s
.24 .35 .67 r
.31243 .45889 m
.3333 .46122 L
s
.35876 .444 m
.3333 .46122 L
s
.83 .24 .1 r
.6667 .46122 m
.64124 .444 L
s
.6667 .46122 m
.68757 .45889 L
s
.24 .35 .67 r
.24382 .49594 m
.22636 .50483 L
s
.26804 .4792 m
.24382 .49594 L
s
.83 .24 .1 r
.75618 .49594 m
.73196 .4792 L
s
.75618 .49594 m
.77364 .50483 L
s
.967 .27 .111 r
.47232 .58229 m .48626 .58997 L .48683 .56886 L p F P
0 0 0 r
s
.967 .27 .111 r
.48683 .56886 m .47348 .56136 L .47232 .58229 L p F P
0 0 0 r
s
.193 .274 .56 r
.51317 .56886 m .52652 .56136 L .52479 .53922 L p F P
0 0 0 r
s
.175 .246 .506 r
.52652 .56136 m .51317 .56886 L .51374 .58997 L p F P
0 0 0 r
s
.24 .35 .67 r
.35876 .444 m
.38013 .45174 L
s
.40629 .43436 m
.38013 .45174 L
s
.83 .24 .1 r
.61987 .45174 m
.59371 .43436 L
s
.61987 .45174 m
.64124 .444 L
s
1 .291 .121 r
.49019 .49883 m .48028 .49291 L .47749 .51627 L p F P
0 0 0 r
s
1 .295 .123 r
.48028 .49291 m .49019 .49883 L .4918 .47458 L p F P
0 0 0 r
s
1 .295 .123 r
.5 .47958 m .4918 .47458 L .49019 .49883 L p F P
0 0 0 r
s
.83 .24 .1 r
.49058 .4907 m
.50108 .49702 L
s
.236 .343 .687 r
.51647 .46953 m .5082 .47458 L .50981 .49883 L p F P
0 0 0 r
s
.24 .35 .67 r
.49892 .49702 m
.50942 .4907 L
s
.236 .343 .687 r
.50981 .49883 m .51972 .49291 L .51647 .46953 L p F P
0 0 0 r
s
.83 .24 .1 r
.51705 .47374 m
.53402 .48423 L
s
.248 .362 .723 r
.50638 .45057 m .5 .45454 L .5 .47958 L p F P
0 0 0 r
s
.248 .362 .723 r
.5 .47958 m .5082 .47458 L .50638 .45057 L p F P
0 0 0 r
s
.83 .24 .1 r
.5077 .46795 m
.51334 .47144 L
s
1 .297 .125 r
.4918 .47458 m .5 .47958 L .5 .45454 L p F P
0 0 0 r
s
.24 .35 .67 r
.46598 .48423 m
.4931 .46746 L
s
1 .286 .119 r
.46258 .53199 m .47521 .53922 L .47749 .51627 L p F P
0 0 0 r
s
1 .286 .119 r
.47749 .51627 m .46605 .50958 L .46258 .53199 L p F P
0 0 0 r
s
1 .291 .121 r
.46605 .50958 m .47749 .51627 L .48028 .49291 L p F P
0 0 0 r
s
.83 .24 .1 r
.47707 .51576 m
.50113 .52984 L
s
.223 .322 .648 r
.52972 .48693 m .51972 .49291 L .52251 .51627 L p F P
0 0 0 r
s
.223 .322 .648 r
.52251 .51627 m .53395 .50958 L .52972 .48693 L p F P
0 0 0 r
s
.209 .299 .607 r
.53395 .50958 m .52251 .51627 L .52479 .53922 L p F P
0 0 0 r
s
.24 .35 .67 r
.49887 .52984 m
.52293 .51576 L
s
.992 .279 .115 r
.45994 .55376 m .47348 .56136 L .47521 .53922 L p F P
0 0 0 r
s
.992 .279 .115 r
.47521 .53922 m .46258 .53199 L .45994 .55376 L p F P
0 0 0 r
s
.209 .299 .607 r
.52479 .53922 m .53742 .53199 L .53395 .50958 L p F P
0 0 0 r
s
.193 .274 .56 r
.53742 .53199 m .52479 .53922 L .52652 .56136 L p F P
0 0 0 r
s
.83 .24 .1 r
.47707 .51576 m
.49058 .4907 L
s
.49058 .4907 m
.50222 .47412 L
s
.24 .35 .67 r
.49778 .47412 m
.50942 .4907 L
s
.4931 .46746 m
.49412 .46891 L
s
.50942 .4907 m
.52293 .51576 L
s
.931 .257 .105 r
.47177 .60162 m .48599 .60931 L .48626 .58997 L p F P
0 0 0 r
s
.931 .257 .105 r
.48626 .58997 m .47232 .58229 L .47177 .60162 L p F P
0 0 0 r
s
.83 .24 .1 r
.48611 .60832 m
.48835 .58337 L
s
.175 .246 .506 r
.51374 .58997 m .52768 .58229 L .52652 .56136 L p F P
0 0 0 r
s
.153 .212 .442 r
.52768 .58229 m .51374 .58997 L .51401 .60931 L p F P
0 0 0 r
s
.153 .212 .442 r
.5 .6169 m .51401 .60931 L .51374 .58997 L p F P
0 0 0 r
s
.24 .35 .67 r
.51165 .58337 m
.51389 .60832 L
s
.88 .24 .097 r
.48603 .62651 m .5 .63395 L .5 .6169 L p F P
0 0 0 r
s
.88 .24 .097 r
.5 .6169 m .48599 .60931 L .48603 .62651 L p F P
0 0 0 r
s
.24 .35 .67 r
.48402 .64627 m
.48603 .62606 L
s
.126 .17 .362 r
.51401 .60931 m .5 .6169 L .5 .63395 L p F P
0 0 0 r
s
.83 .24 .1 r
.50787 .62011 m
.5137 .62326 L
s
.5137 .62326 m
.51598 .64627 L
s
.24 .35 .67 r
.40629 .43436 m
.4274 .44712 L
s
.45433 .42961 m
.4274 .44712 L
s
.83 .24 .1 r
.5726 .44712 m
.54567 .42961 L
s
.5726 .44712 m
.59371 .43436 L
s
.46684 .54176 m
.47707 .51576 L
s
.236 .343 .687 r
.52481 .46444 m .51647 .46953 L .51972 .49291 L p F P
0 0 0 r
s
.236 .343 .687 r
.51972 .49291 m .52972 .48693 L .52481 .46444 L p F P
0 0 0 r
s
1 .291 .121 r
.48028 .49291 m .47028 .48693 L .46605 .50958 L p F P
0 0 0 r
s
1 .295 .123 r
.47028 .48693 m .48028 .49291 L .48353 .46953 L p F P
0 0 0 r
s
1 .295 .123 r
.4918 .47458 m .48353 .46953 L .48028 .49291 L p F P
0 0 0 r
s
.967 .27 .111 r
.45819 .57451 m .47232 .58229 L .47348 .56136 L p F P
0 0 0 r
s
.967 .27 .111 r
.47348 .56136 m .45994 .55376 L .45819 .57451 L p F P
0 0 0 r
s
.83 .24 .1 r
.46684 .54176 m
.49461 .55757 L
s
.193 .274 .56 r
.52652 .56136 m .54006 .55376 L .53742 .53199 L p F P
0 0 0 r
s
.24 .35 .67 r
.52293 .51576 m
.53316 .54176 L
s
.175 .246 .506 r
.54006 .55376 m .52652 .56136 L .52768 .58229 L p F P
0 0 0 r
s
.24 .35 .67 r
.50539 .55757 m
.53316 .54176 L
s
.248 .362 .723 r
.51281 .44656 m .50638 .45057 L .5082 .47458 L p F P
0 0 0 r
s
.248 .362 .723 r
.5082 .47458 m .51647 .46953 L .51281 .44656 L p F P
0 0 0 r
s
.83 .24 .1 r
.51475 .45874 m
.52547 .44684 L
s
1 .297 .125 r
.48353 .46953 m .4918 .47458 L .49362 .45057 L p F P
0 0 0 r
s
.24 .35 .67 r
.47453 .44684 m
.48778 .46155 L
s
.4924 .46668 m
.4931 .46746 L
s
1 .297 .125 r
.5 .45454 m .49362 .45057 L .4918 .47458 L p F P
0 0 0 r
s
1 .286 .119 r
.4498 .52466 m .46258 .53199 L .46605 .50958 L p F P
0 0 0 r
s
1 .286 .119 r
.46605 .50958 m .45447 .5028 L .4498 .52466 L p F P
0 0 0 r
s
1 .291 .121 r
.45447 .5028 m .46605 .50958 L .47028 .48693 L p F P
0 0 0 r
s
.223 .322 .648 r
.53983 .48089 m .52972 .48693 L .53395 .50958 L p F P
0 0 0 r
s
.223 .322 .648 r
.53395 .50958 m .54553 .5028 L .53983 .48089 L p F P
0 0 0 r
s
.209 .299 .607 r
.54553 .5028 m .53395 .50958 L .53742 .53199 L p F P
0 0 0 r
s
.83 .24 .1 r
.56095 .69751 m
.54993 .68087 L
s
.54993 .68087 m
.52255 .66657 L
s
.24 .35 .67 r
.47745 .66657 m
.45007 .68087 L
s
.45007 .68087 m
.43905 .69751 L
s
.992 .279 .115 r
.44623 .54606 m .45994 .55376 L .46258 .53199 L p F P
0 0 0 r
s
.992 .279 .115 r
.46258 .53199 m .4498 .52466 L .44623 .54606 L p F P
0 0 0 r
s
.83 .24 .1 r
.46029 .5678 m
.46684 .54176 L
s
.209 .299 .607 r
.53742 .53199 m .5502 .52466 L .54553 .5028 L p F P
0 0 0 r
s
.193 .274 .56 r
.5502 .52466 m .53742 .53199 L .54006 .55376 L p F P
0 0 0 r
s
.83 .24 .1 r
.52255 .66657 m
.51598 .64627 L
s
.24 .35 .67 r
.48402 .64627 m
.47745 .66657 L
s
.83 .24 .1 r
.60292 .72362 m
.58782 .71138 L
s
.58782 .71138 m
.56095 .69751 L
s
.24 .35 .67 r
.43905 .69751 m
.41218 .71138 L
s
.41218 .71138 m
.39708 .72362 L
s
.248 .362 .723 r
.51928 .44254 m .51281 .44656 L .51647 .46953 L p F P
0 0 0 r
s
.248 .362 .723 r
.51647 .46953 m .52481 .46444 L .51928 .44254 L p F P
0 0 0 r
s
.83 .24 .1 r
.51939 .44298 m
.52547 .44684 L
s
1 .295 .123 r
.48353 .46953 m .47519 .46444 L .47028 .48693 L p F P
0 0 0 r
s
1 .297 .125 r
.47519 .46444 m .48353 .46953 L .48719 .44656 L p F P
0 0 0 r
s
1 .297 .125 r
.49362 .45057 m .48719 .44656 L .48353 .46953 L p F P
0 0 0 r
s
.83 .24 .1 r
.64781 .74436 m
.62922 .73714 L
s
.62922 .73714 m
.60292 .72362 L
s
.24 .35 .67 r
.39708 .72362 m
.37078 .73714 L
s
.35219 .74436 m
.37078 .73714 L
s
.236 .343 .687 r
.53321 .45931 m .52481 .46444 L .52972 .48693 L p F P
0 0 0 r
s
.236 .343 .687 r
.52972 .48693 m .53983 .48089 L .53321 .45931 L p F P
0 0 0 r
s
1 .291 .121 r
.47028 .48693 m .46017 .48089 L .45447 .5028 L p F P
0 0 0 r
s
1 .295 .123 r
.46017 .48089 m .47028 .48693 L .47519 .46444 L p F P
0 0 0 r
s
.931 .257 .105 r
.45735 .59382 m .47177 .60162 L .47232 .58229 L p F P
0 0 0 r
s
.931 .257 .105 r
.47232 .58229 m .45819 .57451 L .45735 .59382 L p F P
0 0 0 r
s
.83 .24 .1 r
.46029 .5678 m
.48835 .58337 L
s
.175 .246 .506 r
.52768 .58229 m .54181 .57451 L .54006 .55376 L p F P
0 0 0 r
s
.24 .35 .67 r
.53316 .54176 m
.53971 .5678 L
s
.153 .212 .442 r
.54181 .57451 m .52768 .58229 L .52823 .60162 L p F P
0 0 0 r
s
.153 .212 .442 r
.51401 .60931 m .52823 .60162 L .52768 .58229 L p F P
0 0 0 r
s
.24 .35 .67 r
.51165 .58337 m
.53971 .5678 L
s
.88 .24 .097 r
.47186 .61897 m .48603 .62651 L .48599 .60931 L p F P
0 0 0 r
s
.88 .24 .097 r
.48599 .60931 m .47177 .60162 L .47186 .61897 L p F P
0 0 0 r
s
.126 .17 .362 r
.52823 .60162 m .51401 .60931 L .51397 .62651 L p F P
0 0 0 r
s
.126 .17 .362 r
.5 .63395 m .51397 .62651 L .51401 .60931 L p F P
0 0 0 r
s
.83 .24 .1 r
.48611 .60832 m
.50097 .61637 L
s
.24 .35 .67 r
.49903 .61637 m
.51389 .60832 L
s
.26 .381 .757 r
.50439 .42723 m .5 .43002 L .5 .45454 L p F P
0 0 0 r
s
.26 .381 .757 r
.5 .45454 m .50638 .45057 L .50439 .42723 L p F P
0 0 0 r
s
1 .298 .126 r
.49362 .45057 m .5 .45454 L .5 .43002 L p F P
0 0 0 r
s
.24 .35 .67 r
.29294 .46199 m
.31243 .45889 L
s
.33795 .4414 m
.31243 .45889 L
s
.83 .24 .1 r
.68757 .45889 m
.66205 .4414 L
s
.68757 .45889 m
.70706 .46199 L
s
.24 .35 .67 r
.33795 .4414 m
.35876 .444 L
s
.38494 .42629 m
.35876 .444 L
s
.83 .24 .1 r
.64124 .444 m
.61506 .42629 L
s
.64124 .444 m
.66205 .4414 L
s
.193 .274 .56 r
.54006 .55376 m .55377 .54606 L .5502 .52466 L p F P
0 0 0 r
s
.175 .246 .506 r
.55377 .54606 m .54006 .55376 L .54181 .57451 L p F P
0 0 0 r
s
.967 .27 .111 r
.44385 .56661 m .45819 .57451 L .45994 .55376 L p F P
0 0 0 r
s
.967 .27 .111 r
.45994 .55376 m .44623 .54606 L .44385 .56661 L p F P
0 0 0 r
s
.83 .24 .1 r
.73196 .4792 m
.70706 .46199 L
s
.73196 .4792 m
.7493 .48796 L
s
.24 .35 .67 r
.2507 .48796 m
.26804 .4792 L
s
.29294 .46199 m
.26804 .4792 L
s
.804 .216 .086 r
.48639 .64118 m .5 .64833 L .5 .63395 L p F P
0 0 0 r
s
.24 .35 .67 r
.48402 .64627 m
.49001 .64309 L
s
.804 .216 .086 r
.5 .63395 m .48603 .62651 L .48639 .64118 L p F P
0 0 0 r
s
.092 .118 .262 r
.51397 .62651 m .5 .63395 L .5 .64833 L p F P
0 0 0 r
s
.83 .24 .1 r
.50504 .64046 m
.51598 .64627 L
s
.77364 .50483 m
.7493 .48796 L
s
.77364 .50483 m
.78801 .51895 L
s
.24 .35 .67 r
.22636 .50483 m
.21199 .51895 L
s
.2507 .48796 m
.22636 .50483 L
s
.38494 .42629 m
.40629 .43436 L
s
.43319 .41648 m
.40629 .43436 L
s
.83 .24 .1 r
.59371 .43436 m
.56681 .41648 L
s
.59371 .43436 m
.61506 .42629 L
s
.26 .381 .757 r
.5088 .42443 m .50439 .42723 L .50638 .45057 L p F P
0 0 0 r
s
.26 .381 .757 r
.50638 .45057 m .51281 .44656 L .5088 .42443 L p F P
0 0 0 r
s
.83 .24 .1 r
.51122 .43779 m
.51898 .44272 L
s
1 .298 .126 r
.48719 .44656 m .49362 .45057 L .49561 .42723 L p F P
0 0 0 r
s
1 .298 .126 r
.5 .43002 m .49561 .42723 L .49362 .45057 L p F P
0 0 0 r
s
.248 .362 .723 r
.52579 .43848 m .51928 .44254 L .52481 .46444 L p F P
0 0 0 r
s
.24 .35 .67 r
.49864 .46403 m
.52099 .45021 L
s
.248 .362 .723 r
.52481 .46444 m .53321 .45931 L .52579 .43848 L p F P
0 0 0 r
s
.83 .24 .1 r
.528 .44468 m
.54567 .42961 L
s
1 .295 .123 r
.47519 .46444 m .46679 .45931 L .46017 .48089 L p F P
0 0 0 r
s
1 .297 .125 r
.46679 .45931 m .47519 .46444 L .48072 .44254 L p F P
0 0 0 r
s
.24 .35 .67 r
.47453 .44684 m
.48007 .44332 L
s
.45433 .42961 m
.47453 .44684 L
s
1 .297 .125 r
.48719 .44656 m .48072 .44254 L .47519 .46444 L p F P
0 0 0 r
s
1 .286 .119 r
.43685 .51724 m .4498 .52466 L .45447 .5028 L p F P
0 0 0 r
s
1 .286 .119 r
.45447 .5028 m .44276 .49595 L .43685 .51724 L p F P
0 0 0 r
s
1 .291 .121 r
.44276 .49595 m .45447 .5028 L .46017 .48089 L p F P
0 0 0 r
s
.83 .24 .1 r
.44878 .4992 m
.47707 .51576 L
s
.223 .322 .648 r
.55004 .47478 m .53983 .48089 L .54553 .5028 L p F P
0 0 0 r
s
.223 .322 .648 r
.54553 .5028 m .55724 .49595 L .55004 .47478 L p F P
0 0 0 r
s
.209 .299 .607 r
.55724 .49595 m .54553 .5028 L .5502 .52466 L p F P
0 0 0 r
s
.236 .343 .687 r
.54169 .45414 m .53321 .45931 L .53983 .48089 L p F P
0 0 0 r
s
.24 .35 .67 r
.50942 .4907 m
.53748 .47381 L
s
.236 .343 .687 r
.53983 .48089 m .55004 .47478 L .54169 .45414 L p F P
0 0 0 r
s
1 .291 .121 r
.46017 .48089 m .44996 .47478 L .44276 .49595 L p F P
0 0 0 r
s
1 .295 .123 r
.44996 .47478 m .46017 .48089 L .46679 .45931 L p F P
0 0 0 r
s
.83 .24 .1 r
.46252 .47381 m
.49058 .4907 L
s
.992 .279 .115 r
.43233 .53826 m .44623 .54606 L .4498 .52466 L p F P
0 0 0 r
s
.992 .279 .115 r
.4498 .52466 m .43685 .51724 L .43233 .53826 L p F P
0 0 0 r
s
.209 .299 .607 r
.5502 .52466 m .56315 .51724 L .55724 .49595 L p F P
0 0 0 r
s
.24 .35 .67 r
.52293 .51576 m
.55122 .4992 L
s
.193 .274 .56 r
.56315 .51724 m .5502 .52466 L .55377 .54606 L p F P
0 0 0 r
s
.83 .24 .1 r
.44878 .4992 m
.46252 .47381 L
s
.24 .35 .67 r
.53748 .47381 m
.55122 .4992 L
s
.26 .381 .757 r
.51323 .42162 m .5088 .42443 L .51281 .44656 L p F P
0 0 0 r
s
.26 .381 .757 r
.51281 .44656 m .51928 .44254 L .51323 .42162 L p F P
0 0 0 r
s
1 .298 .126 r
.48072 .44254 m .48719 .44656 L .4912 .42443 L p F P
0 0 0 r
s
1 .298 .126 r
.49561 .42723 m .4912 .42443 L .48719 .44656 L p F P
0 0 0 r
s
.931 .257 .105 r
.44273 .58591 m .45735 .59382 L .45819 .57451 L p F P
0 0 0 r
s
.931 .257 .105 r
.45819 .57451 m .44385 .56661 L .44273 .58591 L p F P
0 0 0 r
s
.83 .24 .1 r
.45775 .59296 m
.46029 .5678 L
s
.175 .246 .506 r
.54181 .57451 m .55615 .56661 L .55377 .54606 L p F P
0 0 0 r
s
.153 .212 .442 r
.55615 .56661 m .54181 .57451 L .54265 .59382 L p F P
0 0 0 r
s
.153 .212 .442 r
.52823 .60162 m .54265 .59382 L .54181 .57451 L p F P
0 0 0 r
s
.24 .35 .67 r
.53971 .5678 m
.54225 .59296 L
s
.88 .24 .097 r
.45748 .61131 m .47186 .61897 L .47177 .60162 L p F P
0 0 0 r
s
.88 .24 .097 r
.47177 .60162 m .45735 .59382 L .45748 .61131 L p F P
0 0 0 r
s
.83 .24 .1 r
.45775 .59296 m
.48611 .60832 L
s
.126 .17 .362 r
.54265 .59382 m .52823 .60162 L .52814 .61897 L p F P
0 0 0 r
s
.126 .17 .362 r
.51397 .62651 m .52814 .61897 L .52823 .60162 L p F P
0 0 0 r
s
.24 .35 .67 r
.43319 .41648 m
.45433 .42961 L
s
.248 .362 .723 r
.53234 .4344 m .52579 .43848 L .53321 .45931 L p F P
0 0 0 r
s
.248 .362 .723 r
.53321 .45931 m .54169 .45414 L .53234 .4344 L p F P
0 0 0 r
s
.24 .35 .67 r
.52099 .45021 m
.53748 .47381 L
s
1 .295 .123 r
.46679 .45931 m .45831 .45414 L .44996 .47478 L p F P
0 0 0 r
s
1 .297 .125 r
.45831 .45414 m .46679 .45931 L .47421 .43848 L p F P
0 0 0 r
s
1 .297 .125 r
.48072 .44254 m .47421 .43848 L .46679 .45931 L p F P
0 0 0 r
s
.83 .24 .1 r
.46252 .47381 m
.47901 .45021 L
s
.47901 .45021 m
.50136 .46403 L
s
.967 .27 .111 r
.42932 .5586 m .44385 .56661 L .44623 .54606 L p F P
0 0 0 r
s
.967 .27 .111 r
.44623 .54606 m .43233 .53826 L .42932 .5586 L p F P
0 0 0 r
s
.83 .24 .1 r
.43828 .5255 m
.46684 .54176 L
s
.193 .274 .56 r
.55377 .54606 m .56767 .53826 L .56315 .51724 L p F P
0 0 0 r
s
.175 .246 .506 r
.56767 .53826 m .55377 .54606 L .55615 .56661 L p F P
0 0 0 r
s
.24 .35 .67 r
.53316 .54176 m
.56172 .5255 L
s
.804 .216 .086 r
.47259 .63394 m .48639 .64118 L .48603 .62651 L p F P
0 0 0 r
s
.83 .24 .1 r
.48611 .60832 m
.4881 .63147 L
s
.804 .216 .086 r
.48603 .62651 m .47186 .61897 L .47259 .63394 L p F P
0 0 0 r
s
.092 .118 .262 r
.52814 .61897 m .51397 .62651 L .51361 .64118 L p F P
0 0 0 r
s
.092 .118 .262 r
.5 .64833 m .51361 .64118 L .51397 .62651 L p F P
0 0 0 r
s
.24 .35 .67 r
.5119 .63147 m
.51389 .60832 L
s
.49926 .63818 m
.5119 .63147 L
s
.83 .24 .1 r
.4881 .63147 m
.50074 .63818 L
s
1 .286 .119 r
.42373 .50972 m .43685 .51724 L .44276 .49595 L p F P
0 0 0 r
s
1 .286 .119 r
.44276 .49595 m .43092 .48902 L .42373 .50972 L p F P
0 0 0 r
s
.83 .24 .1 r
.43828 .5255 m
.44878 .4992 L
s
1 .291 .121 r
.43092 .48902 m .44276 .49595 L .44996 .47478 L p F P
0 0 0 r
s
.223 .322 .648 r
.56035 .46862 m .55004 .47478 L .55724 .49595 L p F P
0 0 0 r
s
.223 .322 .648 r
.55724 .49595 m .56908 .48902 L .56035 .46862 L p F P
0 0 0 r
s
.209 .299 .607 r
.56908 .48902 m .55724 .49595 L .56315 .51724 L p F P
0 0 0 r
s
.24 .35 .67 r
.55122 .4992 m
.56172 .5255 L
s
.236 .343 .687 r
.55024 .44892 m .54169 .45414 L .55004 .47478 L p F P
0 0 0 r
s
.236 .343 .687 r
.55004 .47478 m .56035 .46862 L .55024 .44892 L p F P
0 0 0 r
s
1 .291 .121 r
.44996 .47478 m .43965 .46862 L .43092 .48902 L p F P
0 0 0 r
s
1 .295 .123 r
.43965 .46862 m .44996 .47478 L .45831 .45414 L p F P
0 0 0 r
s
.26 .381 .757 r
.51768 .41879 m .51323 .42162 L .51928 .44254 L p F P
0 0 0 r
s
.26 .381 .757 r
.51928 .44254 m .52579 .43848 L .51768 .41879 L p F P
0 0 0 r
s
1 .298 .126 r
.47421 .43848 m .48072 .44254 L .48677 .42162 L p F P
0 0 0 r
s
1 .298 .126 r
.4912 .42443 m .48677 .42162 L .48072 .44254 L p F P
0 0 0 r
s
.992 .279 .115 r
.41824 .53034 m .43233 .53826 L .43685 .51724 L p F P
0 0 0 r
s
.992 .279 .115 r
.43685 .51724 m .42373 .50972 L .41824 .53034 L p F P
0 0 0 r
s
.209 .299 .607 r
.56315 .51724 m .57627 .50972 L .56908 .48902 L p F P
0 0 0 r
s
.193 .274 .56 r
.57627 .50972 m .56315 .51724 L .56767 .53826 L p F P
0 0 0 r
s
.271 .4 .791 r
.50225 .40504 m .5 .4065 L .5 .43002 L p F P
0 0 0 r
s
.271 .4 .791 r
.5 .43002 m .50439 .42723 L .50225 .40504 L p F P
0 0 0 r
s
1 .298 .126 r
.49561 .42723 m .5 .43002 L .5 .4065 L p F P
0 0 0 r
s
.24 .35 .67 r
.49742 .43231 m
.50229 .42921 L
s
.83 .24 .1 r
.49771 .42921 m
.50258 .43231 L
s
1 .295 .123 r
.45831 .45414 m .44976 .44892 L .43965 .46862 L p F P
0 0 0 r
s
1 .297 .125 r
.44976 .44892 m .45831 .45414 L .46766 .4344 L p F P
0 0 0 r
s
1 .297 .125 r
.47421 .43848 m .46766 .4344 L .45831 .45414 L p F P
0 0 0 r
s
.248 .362 .723 r
.53893 .43029 m .53234 .4344 L .54169 .45414 L p F P
0 0 0 r
s
.248 .362 .723 r
.54169 .45414 m .55024 .44892 L .53893 .43029 L p F P
0 0 0 r
s
.83 .24 .1 r
.53332 .68324 m
.52255 .66657 L
s
.24 .35 .67 r
.47745 .66657 m
.46668 .68324 L
s
.83 .24 .1 r
.57586 .70971 m
.56095 .69751 L
s
.56095 .69751 m
.53332 .68324 L
s
.24 .35 .67 r
.46668 .68324 m
.43905 .69751 L
s
.43905 .69751 m
.42414 .70971 L
s
.26 .381 .757 r
.52215 .41595 m .51768 .41879 L .52579 .43848 L p F P
0 0 0 r
s
.24 .35 .67 r
.50229 .42921 m
.52099 .45021 L
s
.26 .381 .757 r
.52579 .43848 m .53234 .4344 L .52215 .41595 L p F P
0 0 0 r
s
1 .298 .126 r
.46766 .4344 m .47421 .43848 L .48232 .41879 L p F P
0 0 0 r
s
1 .298 .126 r
.48677 .42162 m .48232 .41879 L .47421 .43848 L p F P
0 0 0 r
s
.83 .24 .1 r
.47901 .45021 m
.49771 .42921 L
s
.271 .4 .791 r
.50451 .40358 m .50225 .40504 L .50439 .42723 L p F P
0 0 0 r
s
.271 .4 .791 r
.50439 .42723 m .5088 .42443 L .50451 .40358 L p F P
0 0 0 r
s
1 .298 .126 r
.4912 .42443 m .49561 .42723 L .49775 .40504 L p F P
0 0 0 r
s
1 .298 .126 r
.5 .4065 m .49775 .40504 L .49561 .42723 L p F P
0 0 0 r
s
.83 .24 .1 r
.62138 .73074 m
.60292 .72362 L
s
.60292 .72362 m
.57586 .70971 L
s
.24 .35 .67 r
.42414 .70971 m
.39708 .72362 L
s
.39708 .72362 m
.37862 .73074 L
s
.931 .257 .105 r
.42789 .57788 m .44273 .58591 L .44385 .56661 L p F P
0 0 0 r
s
.931 .257 .105 r
.44385 .56661 m .42932 .5586 L .42789 .57788 L p F P
0 0 0 r
s
.175 .246 .506 r
.55615 .56661 m .57068 .5586 L .56767 .53826 L p F P
0 0 0 r
s
.153 .212 .442 r
.57068 .5586 m .55615 .56661 L .55727 .58591 L p F P
0 0 0 r
s
.153 .212 .442 r
.54265 .59382 m .55727 .58591 L .55615 .56661 L p F P
0 0 0 r
s
.689 .18 .07 r
.48708 .65296 m .5 .65967 L .5 .64833 L p F P
0 0 0 r
s
.24 .35 .67 r
.47745 .66657 m
.49532 .65724 L
s
.689 .18 .07 r
.5 .64833 m .48639 .64118 L .48708 .65296 L p F P
0 0 0 r
s
.83 .24 .1 r
.4881 .63147 m
.49437 .65186 L
s
.062 .08 .171 r
.51361 .64118 m .5 .64833 L .5 .65967 L p F P
0 0 0 r
s
.88 .24 .097 r
.4429 .60355 m .45748 .61131 L .45735 .59382 L p F P
0 0 0 r
s
.88 .24 .097 r
.45735 .59382 m .44273 .58591 L .4429 .60355 L p F P
0 0 0 r
s
.126 .17 .362 r
.55727 .58591 m .54265 .59382 L .54252 .61131 L p F P
0 0 0 r
s
.126 .17 .362 r
.52814 .61897 m .54252 .61131 L .54265 .59382 L p F P
0 0 0 r
s
.24 .35 .67 r
.51389 .60832 m
.54225 .59296 L
s
.83 .24 .1 r
.66899 .74598 m
.64781 .74436 L
s
.64781 .74436 m
.62138 .73074 L
s
.24 .35 .67 r
.37862 .73074 m
.35219 .74436 L
s
.33101 .74598 m
.35219 .74436 L
s
1 .291 .121 r
.41893 .482 m .43092 .48902 L .43965 .46862 L p F P
0 0 0 r
s
1 .291 .121 r
.43965 .46862 m .42923 .4624 L .41893 .482 L p F P
0 0 0 r
s
1 .295 .123 r
.42923 .4624 m .43965 .46862 L .44976 .44892 L p F P
0 0 0 r
s
.236 .343 .687 r
.55886 .44366 m .55024 .44892 L .56035 .46862 L p F P
0 0 0 r
s
.236 .343 .687 r
.56035 .46862 m .57077 .4624 L .55886 .44366 L p F P
0 0 0 r
s
.223 .322 .648 r
.57077 .4624 m .56035 .46862 L .56908 .48902 L p F P
0 0 0 r
s
.967 .27 .111 r
.41457 .55048 m .42932 .5586 L .43233 .53826 L p F P
0 0 0 r
s
.83 .24 .1 r
.43144 .5518 m
.46029 .5678 L
s
.967 .27 .111 r
.43233 .53826 m .41824 .53034 L .41457 .55048 L p F P
0 0 0 r
s
.83 .24 .1 r
.43144 .5518 m
.43828 .5255 L
s
.193 .274 .56 r
.56767 .53826 m .58176 .53034 L .57627 .50972 L p F P
0 0 0 r
s
.175 .246 .506 r
.58176 .53034 m .56767 .53826 L .57068 .5586 L p F P
0 0 0 r
s
.24 .35 .67 r
.56172 .5255 m
.56856 .5518 L
s
.53971 .5678 m
.56856 .5518 L
s
1 .286 .119 r
.41045 .50211 m .42373 .50972 L .43092 .48902 L p F P
0 0 0 r
s
1 .286 .119 r
.43092 .48902 m .41893 .482 L .41045 .50211 L p F P
0 0 0 r
s
.83 .24 .1 r
.41968 .48217 m
.44878 .4992 L
s
.223 .322 .648 r
.56908 .48902 m .58107 .482 L .57077 .4624 L p F P
0 0 0 r
s
.209 .299 .607 r
.58107 .482 m .56908 .48902 L .57627 .50972 L p F P
0 0 0 r
s
.24 .35 .67 r
.31857 .44427 m
.33795 .4414 L
s
.3642 .4234 m
.33795 .4414 L
s
.83 .24 .1 r
.66205 .4414 m
.6358 .4234 L
s
.66205 .4414 m
.68143 .44427 L
s
.24 .35 .67 r
.3642 .4234 m
.38494 .42629 L
s
.41188 .40807 m
.38494 .42629 L
s
.83 .24 .1 r
.61506 .42629 m
.58812 .40807 L
s
.61506 .42629 m
.6358 .4234 L
s
.271 .4 .791 r
.50677 .40212 m .50451 .40358 L .5088 .42443 L p F P
0 0 0 r
s
.271 .4 .791 r
.5088 .42443 m .51323 .42162 L .50677 .40212 L p F P
0 0 0 r
s
1 .298 .126 r
.48677 .42162 m .4912 .42443 L .49549 .40358 L p F P
0 0 0 r
s
1 .298 .126 r
.49775 .40504 m .49549 .40358 L .4912 .42443 L p F P
0 0 0 r
s
.24 .35 .67 r
.49489 .42278 m
.50229 .42921 L
s
.83 .24 .1 r
.49771 .42921 m
.50511 .42278 L
s
.24 .35 .67 r
.27574 .47061 m
.29294 .46199 L
s
.31857 .44427 m
.29294 .46199 L
s
.83 .24 .1 r
.70706 .46199 m
.68143 .44427 L
s
.70706 .46199 m
.72426 .47061 L
s
.248 .362 .723 r
.54557 .42616 m .53893 .43029 L .55024 .44892 L p F P
0 0 0 r
s
.248 .362 .723 r
.55024 .44892 m .55886 .44366 L .54557 .42616 L p F P
0 0 0 r
s
.83 .24 .1 r
.54738 .42855 m
.56681 .41648 L
s
1 .295 .123 r
.44976 .44892 m .44114 .44366 L .42923 .4624 L p F P
0 0 0 r
s
1 .297 .125 r
.44114 .44366 m .44976 .44892 L .46107 .43029 L p F P
0 0 0 r
s
1 .297 .125 r
.46766 .4344 m .46107 .43029 L .44976 .44892 L p F P
0 0 0 r
s
.26 .381 .757 r
.52664 .4131 m .52215 .41595 L .53234 .4344 L p F P
0 0 0 r
s
.83 .24 .1 r
.52797 .4181 m
.54291 .42782 L
s
.26 .381 .757 r
.53234 .4344 m .53893 .43029 L .52664 .4131 L p F P
0 0 0 r
s
1 .298 .126 r
.46107 .43029 m .46766 .4344 L .47785 .41595 L p F P
0 0 0 r
s
1 .298 .126 r
.48232 .41879 m .47785 .41595 L .46766 .4344 L p F P
0 0 0 r
s
.804 .216 .086 r
.4586 .62659 m .47259 .63394 L .47186 .61897 L p F P
0 0 0 r
s
.804 .216 .086 r
.47186 .61897 m .45748 .61131 L .4586 .62659 L p F P
0 0 0 r
s
.83 .24 .1 r
.45941 .61625 m
.4881 .63147 L
s
.092 .118 .262 r
.54252 .61131 m .52814 .61897 L .52741 .63394 L p F P
0 0 0 r
s
.092 .118 .262 r
.51361 .64118 m .52741 .63394 L .52814 .61897 L p F P
0 0 0 r
s
.83 .24 .1 r
.7493 .48796 m
.72426 .47061 L
s
.7493 .48796 m
.76352 .50203 L
s
.24 .35 .67 r
.23648 .50203 m
.2507 .48796 L
s
.27574 .47061 m
.2507 .48796 L
s
.83 .24 .1 r
.78801 .51895 m
.76352 .50203 L
s
.78801 .51895 m
.79849 .53787 L
s
.24 .35 .67 r
.21199 .51895 m
.20151 .53787 L
s
.23648 .50203 m
.21199 .51895 L
s
.992 .279 .115 r
.40395 .52232 m .41824 .53034 L .42373 .50972 L p F P
0 0 0 r
s
.992 .279 .115 r
.42373 .50972 m .41045 .50211 L .40395 .52232 L p F P
0 0 0 r
s
.209 .299 .607 r
.57627 .50972 m .58955 .50211 L .58107 .482 L p F P
0 0 0 r
s
.24 .35 .67 r
.55122 .4992 m
.58032 .48217 L
s
.193 .274 .56 r
.58955 .50211 m .57627 .50972 L .58176 .53034 L p F P
0 0 0 r
s
.271 .4 .791 r
.50903 .40065 m .50677 .40212 L .51323 .42162 L p F P
0 0 0 r
s
.271 .4 .791 r
.51323 .42162 m .51768 .41879 L .50903 .40065 L p F P
0 0 0 r
s
1 .298 .126 r
.48232 .41879 m .48677 .42162 L .49323 .40212 L p F P
0 0 0 r
s
1 .298 .126 r
.49549 .40358 m .49323 .40212 L .48677 .42162 L p F P
0 0 0 r
s
1 .297 .125 r
.46107 .43029 m .45443 .42616 L .44114 .44366 L p F P
0 0 0 r
s
1 .298 .126 r
.45443 .42616 m .46107 .43029 L .47336 .4131 L p F P
0 0 0 r
s
1 .298 .126 r
.47785 .41595 m .47336 .4131 L .46107 .43029 L p F P
0 0 0 r
s
.26 .381 .757 r
.53115 .41024 m .52664 .4131 L .53893 .43029 L p F P
0 0 0 r
s
.26 .381 .757 r
.53893 .43029 m .54557 .42616 L .53115 .41024 L p F P
0 0 0 r
s
1 .291 .121 r
.40681 .47491 m .41893 .482 L .42923 .4624 L p F P
0 0 0 r
s
1 .291 .121 r
.42923 .4624 m .41871 .45611 L .40681 .47491 L p F P
0 0 0 r
s
1 .295 .123 r
.41871 .45611 m .42923 .4624 L .44114 .44366 L p F P
0 0 0 r
s
.83 .24 .1 r
.43365 .45644 m
.46252 .47381 L
s
.236 .343 .687 r
.56755 .43835 m .55886 .44366 L .57077 .4624 L p F P
0 0 0 r
s
.24 .35 .67 r
.53748 .47381 m
.56635 .45644 L
s
.236 .343 .687 r
.57077 .4624 m .58129 .45611 L .56755 .43835 L p F P
0 0 0 r
s
.223 .322 .648 r
.58129 .45611 m .57077 .4624 L .58107 .482 L p F P
0 0 0 r
s
.271 .4 .791 r
.5113 .39918 m .50903 .40065 L .51768 .41879 L p F P
0 0 0 r
s
.271 .4 .791 r
.51768 .41879 m .52215 .41595 L .5113 .39918 L p F P
0 0 0 r
s
.83 .24 .1 r
.52031 .41312 m
.52342 .41514 L
s
1 .298 .126 r
.47785 .41595 m .48232 .41879 L .49097 .40065 L p F P
0 0 0 r
s
.24 .35 .67 r
.47658 .41514 m
.48019 .41279 L
s
.48019 .41279 m
.48103 .41224 L
s
.48466 .41389 m
.48522 .41437 L
s
1 .298 .126 r
.49323 .40212 m .49097 .40065 L .48232 .41879 L p F P
0 0 0 r
s
1 .295 .123 r
.44114 .44366 m .43245 .43835 L .41871 .45611 L p F P
0 0 0 r
s
1 .297 .125 r
.43245 .43835 m .44114 .44366 L .45443 .42616 L p F P
0 0 0 r
s
.83 .24 .1 r
.45033 .43247 m
.47901 .45021 L
s
.248 .362 .723 r
.55225 .422 m .54557 .42616 L .55886 .44366 L p F P
0 0 0 r
s
.24 .35 .67 r
.52099 .45021 m
.54967 .43247 L
s
.248 .362 .723 r
.55886 .44366 m .56755 .43835 L .55225 .422 L p F P
0 0 0 r
s
.83 .24 .1 r
.41968 .48217 m
.43365 .45644 L
s
.43365 .45644 m
.45033 .43247 L
s
.24 .35 .67 r
.54967 .43247 m
.56635 .45644 L
s
.56635 .45644 m
.58032 .48217 L
s
.689 .18 .07 r
.47398 .64616 m .48708 .65296 L .48639 .64118 L p F P
0 0 0 r
s
.689 .18 .07 r
.48639 .64118 m .47259 .63394 L .47398 .64616 L p F P
0 0 0 r
s
.062 .08 .171 r
.52741 .63394 m .51361 .64118 L .51292 .65296 L p F P
0 0 0 r
s
.062 .08 .171 r
.5 .65967 m .51292 .65296 L .51361 .64118 L p F P
0 0 0 r
s
.24 .35 .67 r
.50563 .65186 m
.5119 .63147 L
s
.83 .24 .1 r
.50468 .65724 m
.52255 .66657 L
s
.49437 .65186 m
.50079 .65521 L
s
.24 .35 .67 r
.49921 .65521 m
.50563 .65186 L
s
.931 .257 .105 r
.41284 .56973 m .42789 .57788 L .42932 .5586 L p F P
0 0 0 r
s
.931 .257 .105 r
.42932 .5586 m .41457 .55048 L .41284 .56973 L p F P
0 0 0 r
s
.83 .24 .1 r
.42856 .57715 m
.43144 .5518 L
s
.175 .246 .506 r
.57068 .5586 m .58543 .55048 L .58176 .53034 L p F P
0 0 0 r
s
.153 .212 .442 r
.58543 .55048 m .57068 .5586 L .57211 .57788 L p F P
0 0 0 r
s
.153 .212 .442 r
.55727 .58591 m .57211 .57788 L .57068 .5586 L p F P
0 0 0 r
s
.24 .35 .67 r
.56856 .5518 m
.57144 .57715 L
s
1 .286 .119 r
.39699 .4944 m .41045 .50211 L .41893 .482 L p F P
0 0 0 r
s
1 .286 .119 r
.41893 .482 m .40681 .47491 L .39699 .4944 L p F P
0 0 0 r
s
.223 .322 .648 r
.58107 .482 m .59319 .47491 L .58129 .45611 L p F P
0 0 0 r
s
.209 .299 .607 r
.59319 .47491 m .58107 .482 L .58955 .50211 L p F P
0 0 0 r
s
.88 .24 .097 r
.42811 .59567 m .4429 .60355 L .44273 .58591 L p F P
0 0 0 r
s
.88 .24 .097 r
.44273 .58591 m .42789 .57788 L .42811 .59567 L p F P
0 0 0 r
s
.83 .24 .1 r
.42856 .57715 m
.45775 .59296 L
s
.126 .17 .362 r
.57211 .57788 m .55727 .58591 L .5571 .60355 L p F P
0 0 0 r
s
.126 .17 .362 r
.54252 .61131 m .5571 .60355 L .55727 .58591 L p F P
0 0 0 r
s
.967 .27 .111 r
.39961 .54224 m .41457 .55048 L .41824 .53034 L p F P
0 0 0 r
s
.967 .27 .111 r
.41824 .53034 m .40395 .52232 L .39961 .54224 L p F P
0 0 0 r
s
.193 .274 .56 r
.58176 .53034 m .59605 .52232 L .58955 .50211 L p F P
0 0 0 r
s
.175 .246 .506 r
.59605 .52232 m .58176 .53034 L .58543 .55048 L p F P
0 0 0 r
s
.271 .4 .791 r
.51358 .39771 m .5113 .39918 L .52215 .41595 L p F P
0 0 0 r
s
.271 .4 .791 r
.52215 .41595 m .52664 .4131 L .51358 .39771 L p F P
0 0 0 r
s
1 .298 .126 r
.47336 .4131 m .47785 .41595 L .4887 .39918 L p F P
0 0 0 r
s
.24 .35 .67 r
.48107 .41099 m
.48174 .41142 L
s
1 .298 .126 r
.49097 .40065 m .4887 .39918 L .47785 .41595 L p F P
0 0 0 r
s
1 .297 .125 r
.45443 .42616 m .44775 .422 L .43245 .43835 L p F P
0 0 0 r
s
1 .298 .126 r
.44775 .422 m .45443 .42616 L .46885 .41024 L p F P
0 0 0 r
s
1 .298 .126 r
.47336 .4131 m .46885 .41024 L .45443 .42616 L p F P
0 0 0 r
s
.26 .381 .757 r
.53567 .40736 m .53115 .41024 L .54557 .42616 L p F P
0 0 0 r
s
.26 .381 .757 r
.54557 .42616 m .55225 .422 L .53567 .40736 L p F P
0 0 0 r
s
.804 .216 .086 r
.44442 .61914 m .4586 .62659 L .45748 .61131 L p F P
0 0 0 r
s
.83 .24 .1 r
.45775 .59296 m
.45941 .61625 L
s
.804 .216 .086 r
.45748 .61131 m .4429 .60355 L .44442 .61914 L p F P
0 0 0 r
s
.092 .118 .262 r
.5571 .60355 m .54252 .61131 L .5414 .62659 L p F P
0 0 0 r
s
.092 .118 .262 r
.52741 .63394 m .5414 .62659 L .54252 .61131 L p F P
0 0 0 r
s
.24 .35 .67 r
.54059 .61625 m
.54225 .59296 L
s
.5119 .63147 m
.54059 .61625 L
s
.992 .279 .115 r
.38947 .51419 m .40395 .52232 L .41045 .50211 L p F P
0 0 0 r
s
.992 .279 .115 r
.41045 .50211 m .39699 .4944 L .38947 .51419 L p F P
0 0 0 r
s
.83 .24 .1 r
.40891 .50877 m
.41968 .48217 L
s
.40891 .50877 m
.43828 .5255 L
s
.209 .299 .607 r
.58955 .50211 m .60301 .4944 L .59319 .47491 L p F P
0 0 0 r
s
.193 .274 .56 r
.60301 .4944 m .58955 .50211 L .59605 .52232 L p F P
0 0 0 r
s
.24 .35 .67 r
.58032 .48217 m
.59109 .50877 L
s
.56172 .5255 m
.59109 .50877 L
s
.271 .4 .791 r
.51586 .39623 m .51358 .39771 L .52664 .4131 L p F P
0 0 0 r
s
.271 .4 .791 r
.52664 .4131 m .53115 .41024 L .51586 .39623 L p F P
0 0 0 r
s
.24 .35 .67 r
.50229 .42921 m
.53085 .41108 L
s
1 .298 .126 r
.46885 .41024 m .47336 .4131 L .48642 .39771 L p F P
0 0 0 r
s
.24 .35 .67 r
.47723 .40854 m
.47791 .40897 L
s
1 .298 .126 r
.4887 .39918 m .48642 .39771 L .47336 .4131 L p F P
0 0 0 r
s
.83 .24 .1 r
.46915 .41108 m
.49771 .42921 L
s
1 .295 .123 r
.40808 .44975 m .41871 .45611 L .43245 .43835 L p F P
0 0 0 r
s
1 .295 .123 r
.43245 .43835 m .42368 .433 L .40808 .44975 L p F P
0 0 0 r
s
1 .297 .125 r
.42368 .433 m .43245 .43835 L .44775 .422 L p F P
0 0 0 r
s
.248 .362 .723 r
.55898 .41781 m .55225 .422 L .56755 .43835 L p F P
0 0 0 r
s
.248 .362 .723 r
.56755 .43835 m .57632 .433 L .55898 .41781 L p F P
0 0 0 r
s
.236 .343 .687 r
.57632 .433 m .56755 .43835 L .58129 .45611 L p F P
0 0 0 r
s
.283 .419 .824 r
.5 .4065 m .50225 .40504 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .296 .126 r
.5 .38446 m .49775 .40504 L .5 .4065 L closepath p F P
0 0 0 r
s
1 .291 .121 r
.39454 .46773 m .40681 .47491 L .41871 .45611 L p F P
0 0 0 r
s
1 .291 .121 r
.41871 .45611 m .40808 .44975 L .39454 .46773 L p F P
0 0 0 r
s
.236 .343 .687 r
.58129 .45611 m .59192 .44975 L .57632 .433 L p F P
0 0 0 r
s
.223 .322 .648 r
.59192 .44975 m .58129 .45611 L .59319 .47491 L p F P
0 0 0 r
s
.283 .419 .824 r
.50225 .40504 m .50451 .40358 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .296 .126 r
.5 .38446 m .49549 .40358 L .49775 .40504 L closepath p F P
0 0 0 r
s
.26 .381 .757 r
.54022 .40447 m .53567 .40736 L .55225 .422 L p F P
0 0 0 r
s
.26 .381 .757 r
.55225 .422 m .55898 .41781 L .54022 .40447 L p F P
0 0 0 r
s
.24 .35 .67 r
.53085 .41108 m
.54967 .43247 L
s
1 .297 .125 r
.44775 .422 m .44102 .41781 L .42368 .433 L p F P
0 0 0 r
s
1 .298 .126 r
.44102 .41781 m .44775 .422 L .46433 .40736 L p F P
0 0 0 r
s
1 .298 .126 r
.46885 .41024 m .46433 .40736 L .44775 .422 L p F P
0 0 0 r
s
.83 .24 .1 r
.45033 .43247 m
.46915 .41108 L
s
.271 .4 .791 r
.51814 .39476 m .51586 .39623 L .53115 .41024 L p F P
0 0 0 r
s
.271 .4 .791 r
.53115 .41024 m .53567 .40736 L .51814 .39476 L p F P
0 0 0 r
s
1 .298 .126 r
.46433 .40736 m .46885 .41024 L .48414 .39623 L p F P
0 0 0 r
s
.24 .35 .67 r
.47339 .40608 m
.47407 .40652 L
s
1 .298 .126 r
.48642 .39771 m .48414 .39623 L .46885 .41024 L p F P
0 0 0 r
s
1 .286 .119 r
.38335 .48658 m .39699 .4944 L .40681 .47491 L p F P
0 0 0 r
s
1 .286 .119 r
.40681 .47491 m .39454 .46773 L .38335 .48658 L p F P
0 0 0 r
s
.223 .322 .648 r
.59319 .47491 m .60546 .46773 L .59192 .44975 L p F P
0 0 0 r
s
.209 .299 .607 r
.60546 .46773 m .59319 .47491 L .60301 .4944 L p F P
0 0 0 r
s
.283 .419 .824 r
.50451 .40358 m .50677 .40212 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .296 .126 r
.5 .38446 m .49323 .40212 L .49549 .40358 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.54801 .69539 m
.53332 .68324 L
s
.53332 .68324 m
.50487 .66855 L
s
.24 .35 .67 r
.49513 .66855 m
.46668 .68324 L
s
.46668 .68324 m
.45199 .69539 L
s
.689 .18 .07 r
.46072 .63926 m .47398 .64616 L .47259 .63394 L p F P
0 0 0 r
s
.689 .18 .07 r
.47259 .63394 m .4586 .62659 L .46072 .63926 L p F P
0 0 0 r
s
.062 .08 .171 r
.5414 .62659 m .52741 .63394 L .52602 .64616 L p F P
0 0 0 r
s
.062 .08 .171 r
.51292 .65296 m .52602 .64616 L .52741 .63394 L p F P
0 0 0 r
s
.54 .134 .052 r
.48809 .66148 m .5 .66762 L .5 .65967 L p F P
0 0 0 r
s
.24 .35 .67 r
.49513 .66855 m
.49664 .66615 L
s
.49664 .66615 m
.49676 .66595 L
s
.54 .134 .052 r
.5 .65967 m .48708 .65296 L .48809 .66148 L p F P
0 0 0 r
s
.029 .04 .077 r
.51292 .65296 m .5 .65967 L .5 .66762 L p F P
0 0 0 r
s
.83 .24 .1 r
.59417 .71672 m
.57586 .70971 L
s
.57586 .70971 m
.54801 .69539 L
s
.24 .35 .67 r
.45199 .69539 m
.42414 .70971 L
s
.42414 .70971 m
.40583 .71672 L
s
.931 .257 .105 r
.39756 .56147 m .41284 .56973 L .41457 .55048 L p F P
0 0 0 r
s
.931 .257 .105 r
.41457 .55048 m .39961 .54224 L .39756 .56147 L p F P
0 0 0 r
s
.175 .246 .506 r
.58543 .55048 m .60039 .54224 L .59605 .52232 L p F P
0 0 0 r
s
.153 .212 .442 r
.60039 .54224 m .58543 .55048 L .58716 .56973 L p F P
0 0 0 r
s
.153 .212 .442 r
.57211 .57788 m .58716 .56973 L .58543 .55048 L p F P
0 0 0 r
s
.283 .419 .824 r
.50677 .40212 m .50903 .40065 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .296 .126 r
.5 .38446 m .49097 .40065 L .49323 .40212 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.69185 .74169 m
.66899 .74598 L
s
.66899 .74598 m
.64249 .73219 L
s
.24 .35 .67 r
.35751 .73219 m
.33101 .74598 L
s
.30815 .74169 m
.33101 .74598 L
s
.126 .17 .362 r
.58716 .56973 m .57211 .57788 L .57189 .59567 L p F P
0 0 0 r
s
.126 .17 .362 r
.5571 .60355 m .57189 .59567 L .57211 .57788 L p F P
0 0 0 r
s
.24 .35 .67 r
.54225 .59296 m
.57144 .57715 L
s
.88 .24 .097 r
.41311 .58768 m .42811 .59567 L .42789 .57788 L p F P
0 0 0 r
s
.88 .24 .097 r
.42789 .57788 m .41284 .56973 L .41311 .58768 L p F P
0 0 0 r
s
.83 .24 .1 r
.64249 .73219 m
.62138 .73074 L
s
.62138 .73074 m
.59417 .71672 L
s
.24 .35 .67 r
.40583 .71672 m
.37862 .73074 L
s
.37862 .73074 m
.35751 .73219 L
s
.967 .27 .111 r
.38444 .53388 m .39961 .54224 L .40395 .52232 L p F P
0 0 0 r
s
.83 .24 .1 r
.40175 .53532 m
.43144 .5518 L
s
.967 .27 .111 r
.40395 .52232 m .38947 .51419 L .38444 .53388 L p F P
0 0 0 r
s
.83 .24 .1 r
.40175 .53532 m
.40891 .50877 L
s
.193 .274 .56 r
.59605 .52232 m .61053 .51419 L .60301 .4944 L p F P
0 0 0 r
s
.175 .246 .506 r
.61053 .51419 m .59605 .52232 L .60039 .54224 L p F P
0 0 0 r
s
.24 .35 .67 r
.59109 .50877 m
.59825 .53532 L
s
.56856 .5518 m
.59825 .53532 L
s
1 .295 .123 r
.39733 .44333 m .40808 .44975 L .42368 .433 L p F P
0 0 0 r
s
1 .295 .123 r
.42368 .433 m .41483 .4276 L .39733 .44333 L p F P
0 0 0 r
s
1 .297 .125 r
.41483 .4276 m .42368 .433 L .44102 .41781 L p F P
0 0 0 r
s
.248 .362 .723 r
.56575 .41359 m .55898 .41781 L .57632 .433 L p F P
0 0 0 r
s
.248 .362 .723 r
.57632 .433 m .58517 .4276 L .56575 .41359 L p F P
0 0 0 r
s
.83 .24 .1 r
.56871 .41573 m
.58812 .40807 L
s
.236 .343 .687 r
.58517 .4276 m .57632 .433 L .59192 .44975 L p F P
0 0 0 r
s
.271 .4 .791 r
.52044 .39327 m .51814 .39476 L .53567 .40736 L p F P
0 0 0 r
s
.271 .4 .791 r
.53567 .40736 m .54022 .40447 L .52044 .39327 L p F P
0 0 0 r
s
1 .298 .126 r
.46433 .40736 m .45978 .40447 L .44102 .41781 L p F P
0 0 0 r
s
1 .298 .126 r
.45978 .40447 m .46433 .40736 L .48186 .39476 L p F P
0 0 0 r
s
.24 .35 .67 r
.46953 .40362 m
.47021 .40405 L
s
1 .298 .126 r
.48414 .39623 m .48186 .39476 L .46433 .40736 L p F P
0 0 0 r
s
.283 .419 .824 r
.50903 .40065 m .5113 .39918 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .296 .126 r
.5 .38446 m .4887 .39918 L .49097 .40065 L closepath p F P
0 0 0 r
s
1 .297 .125 r
.44102 .41781 m .43425 .41359 L .41483 .4276 L p F P
0 0 0 r
s
.24 .35 .67 r
.41188 .40807 m
.43129 .41573 L
s
1 .298 .126 r
.43425 .41359 m .44102 .41781 L .45978 .40447 L p F P
0 0 0 r
s
.24 .35 .67 r
.44137 .41105 m
.45905 .3993 L
s
.26 .381 .757 r
.54479 .40157 m .54022 .40447 L .55898 .41781 L p F P
0 0 0 r
s
.83 .24 .1 r
.54095 .3993 m
.54457 .40171 L
s
.54539 .40225 m
.56405 .41465 L
s
.26 .381 .757 r
.55898 .41781 m .56575 .41359 L .54479 .40157 L p F P
0 0 0 r
s
.24 .35 .67 r
.34494 .42604 m
.3642 .4234 L
s
.83 .24 .1 r
.6358 .4234 m
.65506 .42604 L
s
1 .291 .121 r
.38213 .46047 m .39454 .46773 L .40808 .44975 L p F P
0 0 0 r
s
1 .291 .121 r
.40808 .44975 m .39733 .44333 L .38213 .46047 L p F P
0 0 0 r
s
.236 .343 .687 r
.59192 .44975 m .60267 .44333 L .58517 .4276 L p F P
0 0 0 r
s
.223 .322 .648 r
.60267 .44333 m .59192 .44975 L .60546 .46773 L p F P
0 0 0 r
s
.24 .35 .67 r
.30151 .45274 m
.31857 .44427 L
s
.34494 .42604 m
.31857 .44427 L
s
.83 .24 .1 r
.68143 .44427 m
.65506 .42604 L
s
.68143 .44427 m
.69849 .45274 L
s
.283 .419 .824 r
.5113 .39918 m .51358 .39771 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .296 .126 r
.5 .38446 m .48642 .39771 L .4887 .39918 L closepath p F P
0 0 0 r
s
.992 .279 .115 r
.37478 .50594 m .38947 .51419 L .39699 .4944 L p F P
0 0 0 r
s
.992 .279 .115 r
.39699 .4944 m .38335 .48658 L .37478 .50594 L p F P
0 0 0 r
s
.209 .299 .607 r
.60301 .4944 m .61665 .48658 L .60546 .46773 L p F P
0 0 0 r
s
.193 .274 .56 r
.61665 .48658 m .60301 .4944 L .61053 .51419 L p F P
0 0 0 r
s
.804 .216 .086 r
.43003 .61158 m .44442 .61914 L .4429 .60355 L p F P
0 0 0 r
s
.804 .216 .086 r
.4429 .60355 m .42811 .59567 L .43003 .61158 L p F P
0 0 0 r
s
.092 .118 .262 r
.57189 .59567 m .5571 .60355 L .55558 .61914 L p F P
0 0 0 r
s
.092 .118 .262 r
.5414 .62659 m .55558 .61914 L .5571 .60355 L p F P
0 0 0 r
s
.83 .24 .1 r
.72426 .47061 m
.69849 .45274 L
s
.72426 .47061 m
.73831 .48462 L
s
.24 .35 .67 r
.26169 .48462 m
.27574 .47061 L
s
.30151 .45274 m
.27574 .47061 L
s
.83 .24 .1 r
.79849 .53787 m
.77381 .521 L
s
.79849 .53787 m
.80441 .56088 L
s
.24 .35 .67 r
.20151 .53787 m
.19559 .56088 L
s
.22619 .521 m
.20151 .53787 L
s
1 .298 .126 r
.45978 .40447 m .45521 .40157 L .43425 .41359 L p F P
0 0 0 r
s
1 .298 .126 r
.45521 .40157 m .45978 .40447 L .47956 .39327 L p F P
0 0 0 r
s
.24 .35 .67 r
.46566 .40114 m
.46634 .40158 L
s
1 .298 .126 r
.48186 .39476 m .47956 .39327 L .45978 .40447 L p F P
0 0 0 r
s
.24 .35 .67 r
.46087 .39809 m
.46245 .3991 L
s
.45905 .3993 m
.46087 .39809 L
s
.271 .4 .791 r
.52273 .39179 m .52044 .39327 L .54022 .40447 L p F P
0 0 0 r
s
.271 .4 .791 r
.54022 .40447 m .54479 .40157 L .52273 .39179 L p F P
0 0 0 r
s
.83 .24 .1 r
.53823 .39866 m
.53913 .39809 L
s
.53913 .39809 m
.54095 .3993 L
s
.283 .419 .824 r
.51358 .39771 m .51586 .39623 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .296 .126 r
.5 .38446 m .48414 .39623 L .48642 .39771 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.76352 .50203 m
.73831 .48462 L
s
.76352 .50203 m
.77381 .521 L
s
.24 .35 .67 r
.22619 .521 m
.23648 .50203 L
s
.26169 .48462 m
.23648 .50203 L
s
1 .297 .125 r
.40591 .42216 m .41483 .4276 L .43425 .41359 L p F P
0 0 0 r
s
1 .297 .125 r
.43425 .41359 m .42744 .40934 L .40591 .42216 L p F P
0 0 0 r
s
1 .298 .126 r
.42744 .40934 m .43425 .41359 L .45521 .40157 L p F P
0 0 0 r
s
.26 .381 .757 r
.54939 .39865 m .54479 .40157 L .56575 .41359 L p F P
0 0 0 r
s
.26 .381 .757 r
.56575 .41359 m .57256 .40934 L .54939 .39865 L p F P
0 0 0 r
s
.248 .362 .723 r
.57256 .40934 m .56575 .41359 L .58517 .4276 L p F P
0 0 0 r
s
.283 .419 .824 r
.51586 .39623 m .51814 .39476 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .296 .126 r
.5 .38446 m .48186 .39476 L .48414 .39623 L closepath p F P
0 0 0 r
s
1 .286 .119 r
.36954 .47867 m .38335 .48658 L .39454 .46773 L p F P
0 0 0 r
s
1 .286 .119 r
.39454 .46773 m .38213 .46047 L .36954 .47867 L p F P
0 0 0 r
s
.83 .24 .1 r
.38974 .46465 m
.41968 .48217 L
s
.223 .322 .648 r
.60546 .46773 m .61787 .46047 L .60267 .44333 L p F P
0 0 0 r
s
.209 .299 .607 r
.61787 .46047 m .60546 .46773 L .61665 .48658 L p F P
0 0 0 r
s
.24 .35 .67 r
.58032 .48217 m
.61026 .46465 L
s
1 .295 .123 r
.38648 .43685 m .39733 .44333 L .41483 .4276 L p F P
0 0 0 r
s
.83 .24 .1 r
.40395 .43857 m
.43365 .45644 L
s
1 .295 .123 r
.41483 .4276 m .40591 .42216 L .38648 .43685 L p F P
0 0 0 r
s
.248 .362 .723 r
.58517 .4276 m .59409 .42216 L .57256 .40934 L p F P
0 0 0 r
s
.236 .343 .687 r
.59409 .42216 m .58517 .4276 L .60267 .44333 L p F P
0 0 0 r
s
.24 .35 .67 r
.56635 .45644 m
.59605 .43857 L
s
1 .298 .126 r
.45521 .40157 m .45061 .39865 L .42744 .40934 L p F P
0 0 0 r
s
1 .298 .126 r
.45061 .39865 m .45521 .40157 L .47727 .39179 L p F P
0 0 0 r
s
1 .298 .126 r
.47956 .39327 m .47727 .39179 L .45521 .40157 L p F P
0 0 0 r
s
.271 .4 .791 r
.52503 .3903 m .52273 .39179 L .54479 .40157 L p F P
0 0 0 r
s
.271 .4 .791 r
.54479 .40157 m .54939 .39865 L .52503 .3903 L p F P
0 0 0 r
s
1 .296 .126 r
.5 .38446 m .47956 .39327 L .48186 .39476 L closepath p F P
0 0 0 r
s
.283 .419 .824 r
.51814 .39476 m .52044 .39327 L .5 .38446 L closepath p F P
0 0 0 r
s
.54 .134 .052 r
.47603 .65527 m .48809 .66148 L .48708 .65296 L p F P
0 0 0 r
s
.54 .134 .052 r
.48708 .65296 m .47398 .64616 L .47603 .65527 L p F P
0 0 0 r
s
.029 .04 .077 r
.52602 .64616 m .51292 .65296 L .51191 .66148 L p F P
0 0 0 r
s
.029 .04 .077 r
.5 .66762 m .51191 .66148 L .51292 .65296 L p F P
0 0 0 r
s
.83 .24 .1 r
.50336 .66615 m
.50487 .66855 L
s
.50324 .66595 m
.50336 .66615 L
s
.49437 .65186 m
.5014 .66303 L
s
.24 .35 .67 r
.4986 .66303 m
.50563 .65186 L
s
.689 .18 .07 r
.44727 .63228 m .46072 .63926 L .4586 .62659 L p F P
0 0 0 r
s
.83 .24 .1 r
.45941 .61625 m
.46538 .63673 L
s
.689 .18 .07 r
.4586 .62659 m .44442 .61914 L .44727 .63228 L p F P
0 0 0 r
s
.062 .08 .171 r
.55558 .61914 m .5414 .62659 L .53928 .63926 L p F P
0 0 0 r
s
.062 .08 .171 r
.52602 .64616 m .53928 .63926 L .5414 .62659 L p F P
0 0 0 r
s
.24 .35 .67 r
.53462 .63673 m
.54059 .61625 L
s
1 .296 .126 r
.5 .38446 m .47727 .39179 L .47956 .39327 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.46915 .41108 m
.48948 .39306 L
s
.283 .419 .824 r
.52044 .39327 m .52273 .39179 L .5 .38446 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.49336 .40423 m
.51052 .39306 L
s
.83 .24 .1 r
.48948 .39306 m
.50664 .40423 L
s
.24 .35 .67 r
.51052 .39306 m
.53085 .41108 L
s
1 .291 .121 r
.36956 .45311 m .38213 .46047 L .39733 .44333 L p F P
0 0 0 r
s
1 .291 .121 r
.39733 .44333 m .38648 .43685 L .36956 .45311 L p F P
0 0 0 r
s
.83 .24 .1 r
.38974 .46465 m
.40395 .43857 L
s
.236 .343 .687 r
.60267 .44333 m .61352 .43685 L .59409 .42216 L p F P
0 0 0 r
s
.223 .322 .648 r
.61352 .43685 m .60267 .44333 L .61787 .46047 L p F P
0 0 0 r
s
.24 .35 .67 r
.59605 .43857 m
.61026 .46465 L
s
.931 .257 .105 r
.38205 .55308 m .39756 .56147 L .39961 .54224 L p F P
0 0 0 r
s
.931 .257 .105 r
.39961 .54224 m .38444 .53388 L .38205 .55308 L p F P
0 0 0 r
s
.83 .24 .1 r
.39853 .56088 m
.40175 .53532 L
s
.175 .246 .506 r
.60039 .54224 m .61556 .53388 L .61053 .51419 L p F P
0 0 0 r
s
.153 .212 .442 r
.61556 .53388 m .60039 .54224 L .60244 .56147 L p F P
0 0 0 r
s
.153 .212 .442 r
.58716 .56973 m .60244 .56147 L .60039 .54224 L p F P
0 0 0 r
s
.24 .35 .67 r
.59825 .53532 m
.60147 .56088 L
s
.967 .27 .111 r
.36904 .5254 m .38444 .53388 L .38947 .51419 L p F P
0 0 0 r
s
.967 .27 .111 r
.38947 .51419 m .37478 .50594 L .36904 .5254 L p F P
0 0 0 r
s
.193 .274 .56 r
.61053 .51419 m .62522 .50594 L .61665 .48658 L p F P
0 0 0 r
s
.175 .246 .506 r
.62522 .50594 m .61053 .51419 L .61556 .53388 L p F P
0 0 0 r
s
.88 .24 .097 r
.39788 .57957 m .41311 .58768 L .41284 .56973 L p F P
0 0 0 r
s
.88 .24 .097 r
.41284 .56973 m .39756 .56147 L .39788 .57957 L p F P
0 0 0 r
s
.83 .24 .1 r
.39853 .56088 m
.42856 .57715 L
s
.126 .17 .362 r
.60244 .56147 m .58716 .56973 L .58689 .58768 L p F P
0 0 0 r
s
.126 .17 .362 r
.57189 .59567 m .58689 .58768 L .58716 .56973 L p F P
0 0 0 r
s
1 .298 .126 r
.42058 .40507 m .42744 .40934 L .45061 .39865 L p F P
0 0 0 r
s
1 .298 .126 r
.45061 .39865 m .446 .39572 L .42058 .40507 L p F P
0 0 0 r
s
1 .298 .126 r
.446 .39572 m .45061 .39865 L .47497 .3903 L p F P
0 0 0 r
s
.24 .35 .67 r
.45696 .39647 m
.45777 .39681 L
s
1 .298 .126 r
.47727 .39179 m .47497 .3903 L .45061 .39865 L p F P
0 0 0 r
s
.271 .4 .791 r
.52734 .3888 m .52503 .3903 L .54939 .39865 L p F P
0 0 0 r
s
.271 .4 .791 r
.54939 .39865 m .554 .39572 L .52734 .3888 L p F P
0 0 0 r
s
.26 .381 .757 r
.554 .39572 m .54939 .39865 L .57256 .40934 L p F P
0 0 0 r
s
1 .297 .125 r
.39691 .41667 m .40591 .42216 L .42744 .40934 L p F P
0 0 0 r
s
1 .297 .125 r
.42744 .40934 m .42058 .40507 L .39691 .41667 L p F P
0 0 0 r
s
.83 .24 .1 r
.42081 .41421 m
.45033 .43247 L
s
.40395 .43857 m
.42081 .41421 L
s
.26 .381 .757 r
.57256 .40934 m .57942 .40507 L .554 .39572 L p F P
0 0 0 r
s
.248 .362 .723 r
.57942 .40507 m .57256 .40934 L .59409 .42216 L p F P
0 0 0 r
s
.24 .35 .67 r
.57919 .41421 m
.59605 .43857 L
s
.54967 .43247 m
.57919 .41421 L
s
.283 .419 .824 r
.52273 .39179 m .52503 .3903 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .296 .126 r
.5 .38446 m .47497 .3903 L .47727 .39179 L closepath p F P
0 0 0 r
s
.992 .279 .115 r
.35989 .49757 m .37478 .50594 L .38335 .48658 L p F P
0 0 0 r
s
.992 .279 .115 r
.38335 .48658 m .36954 .47867 L .35989 .49757 L p F P
0 0 0 r
s
.83 .24 .1 r
.37868 .49156 m
.40891 .50877 L
s
.209 .299 .607 r
.61665 .48658 m .63046 .47867 L .61787 .46047 L p F P
0 0 0 r
s
.193 .274 .56 r
.63046 .47867 m .61665 .48658 L .62522 .50594 L p F P
0 0 0 r
s
.24 .35 .67 r
.59109 .50877 m
.62132 .49156 L
s
1 .298 .126 r
.47497 .3903 m .47266 .3888 L .446 .39572 L p F P
0 0 0 r
s
1 .296 .126 r
.5 .38446 m .47266 .3888 L .47497 .3903 L closepath p F P
0 0 0 r
s
.283 .419 .824 r
.52503 .3903 m .52734 .3888 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .295 .123 r
.37551 .43029 m .38648 .43685 L .40591 .42216 L p F P
0 0 0 r
s
1 .295 .123 r
.40591 .42216 m .39691 .41667 L .37551 .43029 L p F P
0 0 0 r
s
.248 .362 .723 r
.59409 .42216 m .60309 .41667 L .57942 .40507 L p F P
0 0 0 r
s
.236 .343 .687 r
.60309 .41667 m .59409 .42216 L .61352 .43685 L p F P
0 0 0 r
s
.804 .216 .086 r
.41544 .60391 m .43003 .61158 L .42811 .59567 L p F P
0 0 0 r
s
.83 .24 .1 r
.42856 .57715 m
.42989 .60059 L
s
.42989 .60059 m
.45941 .61625 L
s
.804 .216 .086 r
.42811 .59567 m .41311 .58768 L .41544 .60391 L p F P
0 0 0 r
s
.092 .118 .262 r
.58689 .58768 m .57189 .59567 L .56997 .61158 L p F P
0 0 0 r
s
.092 .118 .262 r
.55558 .61914 m .56997 .61158 L .57189 .59567 L p F P
0 0 0 r
s
.24 .35 .67 r
.57011 .60059 m
.57144 .57715 L
s
.54059 .61625 m
.57011 .60059 L
s
1 .298 .126 r
.41367 .40077 m .42058 .40507 L .446 .39572 L p F P
0 0 0 r
s
.24 .35 .67 r
.41188 .40807 m
.41836 .40369 L
s
1 .298 .126 r
.446 .39572 m .44137 .39278 L .41367 .40077 L p F P
0 0 0 r
s
.24 .35 .67 r
.42937 .39624 m
.43083 .39525 L
s
1 .298 .126 r
.44137 .39278 m .446 .39572 L .47266 .3888 L p F P
0 0 0 r
s
.271 .4 .791 r
.52965 .38731 m .52734 .3888 L .554 .39572 L p F P
0 0 0 r
s
.271 .4 .791 r
.554 .39572 m .55863 .39278 L .52965 .38731 L p F P
0 0 0 r
s
.26 .381 .757 r
.55863 .39278 m .554 .39572 L .57942 .40507 L p F P
0 0 0 r
s
1 .298 .126 r
.47266 .3888 m .47035 .38731 L .44137 .39278 L p F P
0 0 0 r
s
1 .296 .126 r
.5 .38446 m .47035 .38731 L .47266 .3888 L closepath p F P
0 0 0 r
s
.283 .419 .824 r
.52734 .3888 m .52965 .38731 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .286 .119 r
.35555 .47065 m .36954 .47867 L .38213 .46047 L p F P
0 0 0 r
s
1 .286 .119 r
.38213 .46047 m .36956 .45311 L .35555 .47065 L p F P
0 0 0 r
s
.83 .24 .1 r
.37868 .49156 m
.38974 .46465 L
s
.223 .322 .648 r
.61787 .46047 m .63044 .45311 L .61352 .43685 L p F P
0 0 0 r
s
.209 .299 .607 r
.63044 .45311 m .61787 .46047 L .63046 .47867 L p F P
0 0 0 r
s
.24 .35 .67 r
.61026 .46465 m
.62132 .49156 L
s
1 .297 .125 r
.38784 .41113 m .39691 .41667 L .42058 .40507 L p F P
0 0 0 r
s
1 .297 .125 r
.42058 .40507 m .41367 .40077 L .38784 .41113 L p F P
0 0 0 r
s
.26 .381 .757 r
.57942 .40507 m .58633 .40077 L .55863 .39278 L p F P
0 0 0 r
s
.83 .24 .1 r
.56917 .39525 m
.57063 .39624 L
s
.58164 .40369 m
.58812 .40807 L
s
.248 .362 .723 r
.58633 .40077 m .57942 .40507 L .60309 .41667 L p F P
0 0 0 r
s
1 .298 .126 r
.43672 .38982 m .44137 .39278 L .47035 .38731 L p F P
0 0 0 r
s
1 .298 .126 r
.47035 .38731 m .46803 .38581 L .43672 .38982 L p F P
0 0 0 r
s
1 .296 .126 r
.5 .38446 m .46803 .38581 L .47035 .38731 L closepath p F P
0 0 0 r
s
.283 .419 .824 r
.52965 .38731 m .53197 .38581 L .5 .38446 L closepath p F P
0 0 0 r
s
.271 .4 .791 r
.53197 .38581 m .52965 .38731 L .55863 .39278 L p F P
0 0 0 r
s
.294 .437 .856 r
.5 .38446 m .48846 .37215 L .49076 .37062 L closepath p F P
0 0 0 r
s
.294 .437 .856 r
.5 .38446 m .49076 .37062 L .49306 .36908 L closepath p F P
0 0 0 r
s
.294 .437 .856 r
.5 .38446 m .49306 .36908 L .49537 .36754 L closepath p F P
0 0 0 r
s
.294 .437 .856 r
.5 .38446 m .49537 .36754 L .49768 .36599 L closepath p F P
0 0 0 r
s
.294 .437 .856 r
.5 .38446 m .49768 .36599 L .5 .36444 L closepath p F P
0 0 0 r
s
.294 .437 .856 r
.5 .38446 m .47479 .38129 L .47706 .37977 L closepath p F P
0 0 0 r
s
.294 .437 .856 r
.5 .38446 m .47706 .37977 L .47933 .37826 L closepath p F P
0 0 0 r
s
.294 .437 .856 r
.5 .38446 m .47933 .37826 L .4816 .37673 L closepath p F P
0 0 0 r
s
.294 .437 .856 r
.5 .38446 m .4816 .37673 L .48388 .37521 L closepath p F P
0 0 0 r
s
.294 .437 .856 r
.5 .38446 m .48388 .37521 L .48617 .37368 L closepath p F P
0 0 0 r
s
.294 .437 .856 r
.5 .38446 m .48617 .37368 L .48846 .37215 L closepath p F P
0 0 0 r
s
.982 .29 .124 r
.52972 .3843 m .53197 .38581 L .5 .38446 L closepath p F P
0 0 0 r
s
.982 .29 .124 r
.52747 .3828 m .52972 .3843 L .5 .38446 L closepath p F P
0 0 0 r
s
.982 .29 .124 r
.52521 .38129 m .52747 .3828 L .5 .38446 L closepath p F P
0 0 0 r
s
.982 .29 .124 r
.52294 .37977 m .52521 .38129 L .5 .38446 L closepath p F P
0 0 0 r
s
.982 .29 .124 r
.52067 .37826 m .52294 .37977 L .5 .38446 L closepath p F P
0 0 0 r
s
.982 .29 .124 r
.5184 .37673 m .52067 .37826 L .5 .38446 L closepath p F P
0 0 0 r
s
.982 .29 .124 r
.51612 .37521 m .5184 .37673 L .5 .38446 L closepath p F P
0 0 0 r
s
.982 .29 .124 r
.51383 .37368 m .51612 .37521 L .5 .38446 L closepath p F P
0 0 0 r
s
.982 .29 .124 r
.51154 .37215 m .51383 .37368 L .5 .38446 L closepath p F P
0 0 0 r
s
.982 .29 .124 r
.50924 .37062 m .51154 .37215 L .5 .38446 L closepath p F P
0 0 0 r
s
.294 .437 .856 r
.5 .38446 m .46803 .38581 L .47028 .3843 L closepath p F P
0 0 0 r
s
.294 .437 .856 r
.5 .38446 m .47028 .3843 L .47253 .3828 L closepath p F P
0 0 0 r
s
.294 .437 .856 r
.5 .38446 m .47253 .3828 L .47479 .38129 L closepath p F P
0 0 0 r
s
.982 .29 .124 r
.50694 .36908 m .50924 .37062 L .5 .38446 L closepath p F P
0 0 0 r
s
.982 .29 .124 r
.50463 .36754 m .50694 .36908 L .5 .38446 L closepath p F P
0 0 0 r
s
.982 .29 .124 r
.50232 .36599 m .50463 .36754 L .5 .38446 L closepath p F P
0 0 0 r
s
.982 .29 .124 r
.5 .36444 m .50232 .36599 L .5 .38446 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.48937 .37916 m
.51052 .39306 L
s
.83 .24 .1 r
.48948 .39306 m
.51063 .37916 L
s
1 .291 .121 r
.35685 .44568 m .36956 .45311 L .38648 .43685 L p F P
0 0 0 r
s
1 .291 .121 r
.38648 .43685 m .37551 .43029 L .35685 .44568 L p F P
0 0 0 r
s
.236 .343 .687 r
.61352 .43685 m .62449 .43029 L .60309 .41667 L p F P
0 0 0 r
s
.223 .322 .648 r
.62449 .43029 m .61352 .43685 L .63044 .45311 L p F P
0 0 0 r
s
1 .298 .126 r
.40672 .39644 m .41367 .40077 L .44137 .39278 L p F P
0 0 0 r
s
1 .298 .126 r
.44137 .39278 m .43672 .38982 L .40672 .39644 L p F P
0 0 0 r
s
.83 .24 .1 r
.43975 .39241 m
.46915 .41108 L
s
.42081 .41421 m
.43975 .39241 L
s
.271 .4 .791 r
.55863 .39278 m .56328 .38982 L .53197 .38581 L p F P
0 0 0 r
s
.26 .381 .757 r
.56328 .38982 m .55863 .39278 L .58633 .40077 L p F P
0 0 0 r
s
.24 .35 .67 r
.56025 .39241 m
.57919 .41421 L
s
.53085 .41108 m
.56025 .39241 L
s
.303 .454 .884 r
.47028 .3843 m .46803 .38581 L .43672 .38982 L p F P
0 0 0 r
s
.937 .28 .121 r
.53197 .38581 m .52972 .3843 L .5589 .38685 L p F P
0 0 0 r
s
.937 .28 .121 r
.5589 .38685 m .56328 .38982 L .53197 .38581 L p F P
0 0 0 r
s
.54 .134 .052 r
.46382 .64897 m .47603 .65527 L .47398 .64616 L p F P
0 0 0 r
s
.54 .134 .052 r
.47398 .64616 m .46072 .63926 L .46382 .64897 L p F P
0 0 0 r
s
.83 .24 .1 r
.46538 .63673 m
.49437 .65186 L
s
.029 .04 .077 r
.53928 .63926 m .52602 .64616 L .52397 .65527 L p F P
0 0 0 r
s
.029 .04 .077 r
.51191 .66148 m .52397 .65527 L .52602 .64616 L p F P
0 0 0 r
s
.24 .35 .67 r
.50563 .65186 m
.53462 .63673 L
s
.83 .24 .1 r
.7153 .73146 m
.69185 .74169 L
s
.69185 .74169 m
.66534 .72765 L
s
.24 .35 .67 r
.33466 .72765 m
.30815 .74169 L
s
.2847 .73146 m
.30815 .74169 L
s
.83 .24 .1 r
.50154 .66683 m
.50487 .66855 L
s
.24 .35 .67 r
.49513 .66855 m
.49846 .66683 L
s
.689 .18 .07 r
.43365 .6252 m .44727 .63228 L .44442 .61914 L p F P
0 0 0 r
s
.689 .18 .07 r
.44442 .61914 m .43003 .61158 L .43365 .6252 L p F P
0 0 0 r
s
.062 .08 .171 r
.56997 .61158 m .55558 .61914 L .55273 .63228 L p F P
0 0 0 r
s
.062 .08 .171 r
.53928 .63926 m .55273 .63228 L .55558 .61914 L p F P
0 0 0 r
s
1 .295 .123 r
.36443 .42367 m .37551 .43029 L .39691 .41667 L p F P
0 0 0 r
s
1 .295 .123 r
.39691 .41667 m .38784 .41113 L .36443 .42367 L p F P
0 0 0 r
s
.248 .362 .723 r
.60309 .41667 m .61216 .41113 L .58633 .40077 L p F P
0 0 0 r
s
.236 .343 .687 r
.61216 .41113 m .60309 .41667 L .62449 .43029 L p F P
0 0 0 r
s
.303 .454 .884 r
.43672 .38982 m .4411 .38685 L .47028 .3843 L p F P
0 0 0 r
s
.303 .454 .884 r
.47253 .3828 m .47028 .3843 L .4411 .38685 L p F P
0 0 0 r
s
.937 .28 .121 r
.52972 .3843 m .52747 .3828 L .55449 .38387 L p F P
0 0 0 r
s
.937 .28 .121 r
.55449 .38387 m .5589 .38685 L .52972 .3843 L p F P
0 0 0 r
s
.83 .24 .1 r
.56616 .70229 m
.54801 .69539 L
s
.54801 .69539 m
.51934 .68066 L
s
.24 .35 .67 r
.48066 .68066 m
.45199 .69539 L
s
.45199 .69539 m
.43384 .70229 L
s
.931 .257 .105 r
.36632 .54456 m .38205 .55308 L .38444 .53388 L p F P
0 0 0 r
s
.931 .257 .105 r
.38444 .53388 m .36904 .5254 L .36632 .54456 L p F P
0 0 0 r
s
.175 .246 .506 r
.61556 .53388 m .63096 .5254 L .62522 .50594 L p F P
0 0 0 r
s
.153 .212 .442 r
.63096 .5254 m .61556 .53388 L .61795 .55308 L p F P
0 0 0 r
s
.153 .212 .442 r
.60244 .56147 m .61795 .55308 L .61556 .53388 L p F P
0 0 0 r
s
1 .297 .125 r
.37868 .40554 m .38784 .41113 L .41367 .40077 L p F P
0 0 0 r
s
.24 .35 .67 r
.3642 .4234 m
.38481 .40928 L
s
1 .297 .125 r
.41367 .40077 m .40672 .39644 L .37868 .40554 L p F P
0 0 0 r
s
.26 .381 .757 r
.58633 .40077 m .59328 .39644 L .56328 .38982 L p F P
0 0 0 r
s
.248 .362 .723 r
.59328 .39644 m .58633 .40077 L .61216 .41113 L p F P
0 0 0 r
s
.83 .24 .1 r
.60877 .40488 m
.6358 .4234 L
s
.6049 .40548 m
.60877 .40488 L
s
.31 .467 .903 r
.4411 .38685 m .43672 .38982 L .40672 .39644 L p F P
0 0 0 r
s
.83 .24 .1 r
.43456 .38912 m
.43975 .39241 L
s
.24 .35 .67 r
.43473 .39261 m
.43961 .38932 L
s
.43961 .38932 m
.44747 .39256 L
s
.864 .262 .114 r
.56328 .38982 m .5589 .38685 L .58691 .39208 L p F P
0 0 0 r
s
.83 .24 .1 r
.55253 .39256 m
.56039 .38932 L
s
.864 .262 .114 r
.58691 .39208 m .59328 .39644 L .56328 .38982 L p F P
0 0 0 r
s
.24 .35 .67 r
.56025 .39241 m
.56544 .38912 L
s
.83 .24 .1 r
.56039 .38932 m
.56527 .39261 L
s
.967 .27 .111 r
.35342 .51679 m .36904 .5254 L .37478 .50594 L p F P
0 0 0 r
s
.83 .24 .1 r
.37118 .51837 m
.40175 .53532 L
s
.967 .27 .111 r
.37478 .50594 m .35989 .49757 L .35342 .51679 L p F P
0 0 0 r
s
.83 .24 .1 r
.37118 .51837 m
.37868 .49156 L
s
.193 .274 .56 r
.62522 .50594 m .64011 .49757 L .63046 .47867 L p F P
0 0 0 r
s
.175 .246 .506 r
.64011 .49757 m .62522 .50594 L .63096 .5254 L p F P
0 0 0 r
s
.24 .35 .67 r
.62132 .49156 m
.62882 .51837 L
s
.59825 .53532 m
.62882 .51837 L
s
.83 .24 .1 r
.66534 .72765 m
.64249 .73219 L
s
.64249 .73219 m
.6152 .71799 L
s
.24 .35 .67 r
.3848 .71799 m
.35751 .73219 L
s
.35751 .73219 m
.33466 .72765 L
s
.303 .454 .884 r
.4411 .38685 m .44551 .38387 L .47253 .3828 L p F P
0 0 0 r
s
.303 .454 .884 r
.47479 .38129 m .47253 .3828 L .44551 .38387 L p F P
0 0 0 r
s
.937 .28 .121 r
.52747 .3828 m .52521 .38129 L .55007 .38087 L p F P
0 0 0 r
s
.937 .28 .121 r
.55007 .38087 m .55449 .38387 L .52747 .3828 L p F P
0 0 0 r
s
.24 .35 .67 r
.51052 .39306 m
.52799 .3817 L
s
.88 .24 .097 r
.38243 .57134 m .39788 .57957 L .39756 .56147 L p F P
0 0 0 r
s
.88 .24 .097 r
.39756 .56147 m .38205 .55308 L .38243 .57134 L p F P
0 0 0 r
s
.126 .17 .362 r
.61795 .55308 m .60244 .56147 L .60212 .57957 L p F P
0 0 0 r
s
.126 .17 .362 r
.58689 .58768 m .60212 .57957 L .60244 .56147 L p F P
0 0 0 r
s
.24 .35 .67 r
.57144 .57715 m
.60147 .56088 L
s
.83 .24 .1 r
.6152 .71799 m
.59417 .71672 L
s
.59417 .71672 m
.56616 .70229 L
s
.24 .35 .67 r
.43384 .70229 m
.40583 .71672 L
s
.40583 .71672 m
.3848 .71799 L
s
.383 .086 .036 r
.48941 .66642 m .5 .67186 L .5 .66762 L p F P
0 0 0 r
s
.24 .35 .67 r
.48066 .68066 m
.49453 .66905 L
s
.383 .086 .036 r
.5 .66762 m .48809 .66148 L .48941 .66642 L p F P
0 0 0 r
s
.024 .035 .067 r
.51191 .66148 m .5 .66762 L .5 .67186 L p F P
0 0 0 r
s
.992 .279 .115 r
.34478 .48909 m .35989 .49757 L .36954 .47867 L p F P
0 0 0 r
s
.992 .279 .115 r
.36954 .47867 m .35555 .47065 L .34478 .48909 L p F P
0 0 0 r
s
.209 .299 .607 r
.63046 .47867 m .64445 .47065 L .63044 .45311 L p F P
0 0 0 r
s
.193 .274 .56 r
.64445 .47065 m .63046 .47867 L .64011 .49757 L p F P
0 0 0 r
s
.83 .24 .1 r
.80441 .56088 m
.7795 .54413 L
s
.80441 .56088 m
.80529 .58696 L
s
.24 .35 .67 r
.19559 .56088 m
.2205 .54413 L
s
.19559 .56088 m
.19471 .58696 L
s
.303 .454 .884 r
.44551 .38387 m .44993 .38087 L .47479 .38129 L p F P
0 0 0 r
s
.83 .24 .1 r
.47201 .3817 m
.48948 .39306 L
s
.303 .454 .884 r
.47706 .37977 m .47479 .38129 L .44993 .38087 L p F P
0 0 0 r
s
.937 .28 .121 r
.52521 .38129 m .52294 .37977 L .54562 .37786 L p F P
0 0 0 r
s
.937 .28 .121 r
.54562 .37786 m .55007 .38087 L .52521 .38129 L p F P
0 0 0 r
s
1 .286 .119 r
.34137 .46252 m .35555 .47065 L .36956 .45311 L p F P
0 0 0 r
s
1 .286 .119 r
.36956 .45311 m .35685 .44568 L .34137 .46252 L p F P
0 0 0 r
s
.83 .24 .1 r
.35892 .44661 m
.38974 .46465 L
s
.223 .322 .648 r
.63044 .45311 m .64315 .44568 L .62449 .43029 L p F P
0 0 0 r
s
.209 .299 .607 r
.64315 .44568 m .63044 .45311 L .64445 .47065 L p F P
0 0 0 r
s
.24 .35 .67 r
.61026 .46465 m
.64108 .44661 L
s
.31 .467 .903 r
.40672 .39644 m .41309 .39208 L .4411 .38685 L p F P
0 0 0 r
s
.31 .467 .903 r
.44551 .38387 m .4411 .38685 L .41309 .39208 L p F P
0 0 0 r
s
.83 .24 .1 r
.43975 .39241 m
.4472 .38568 L
s
.864 .262 .114 r
.5589 .38685 m .55449 .38387 L .58049 .38769 L p F P
0 0 0 r
s
.864 .262 .114 r
.58049 .38769 m .58691 .39208 L .5589 .38685 L p F P
0 0 0 r
s
.24 .35 .67 r
.5528 .38568 m
.56025 .39241 L
s
.804 .216 .086 r
.40064 .59614 m .41544 .60391 L .41311 .58768 L p F P
0 0 0 r
s
.804 .216 .086 r
.41311 .58768 m .39788 .57957 L .40064 .59614 L p F P
0 0 0 r
s
.092 .118 .262 r
.60212 .57957 m .58689 .58768 L .58456 .60391 L p F P
0 0 0 r
s
.092 .118 .262 r
.56997 .61158 m .58456 .60391 L .58689 .58768 L p F P
0 0 0 r
s
.303 .454 .884 r
.44993 .38087 m .45438 .37786 L .47706 .37977 L p F P
0 0 0 r
s
.303 .454 .884 r
.47933 .37826 m .47706 .37977 L .45438 .37786 L p F P
0 0 0 r
s
.24 .35 .67 r
.4722 .39056 m
.48937 .37916 L
s
.937 .28 .121 r
.52294 .37977 m .52067 .37826 L .54115 .37484 L p F P
0 0 0 r
s
.937 .28 .121 r
.54115 .37484 m .54562 .37786 L .52294 .37977 L p F P
0 0 0 r
s
.83 .24 .1 r
.51063 .37916 m
.5278 .39056 L
s
1 .291 .121 r
.34398 .43815 m .35685 .44568 L .37551 .43029 L p F P
0 0 0 r
s
1 .291 .121 r
.37551 .43029 m .36443 .42367 L .34398 .43815 L p F P
0 0 0 r
s
.236 .343 .687 r
.62449 .43029 m .63557 .42367 L .61216 .41113 L p F P
0 0 0 r
s
.223 .322 .648 r
.63557 .42367 m .62449 .43029 L .64315 .44568 L p F P
0 0 0 r
s
.83 .24 .1 r
.69849 .45274 m
.71235 .46669 L
s
.24 .35 .67 r
.28765 .46669 m
.30151 .45274 L
s
.83 .24 .1 r
.77381 .521 m
.74839 .50362 L
s
.77381 .521 m
.7795 .54413 L
s
.24 .35 .67 r
.2205 .54413 m
.22619 .521 L
s
.25161 .50362 m
.22619 .521 L
s
.248 .362 .723 r
.61216 .41113 m .62132 .40554 L .59328 .39644 L p F P
0 0 0 r
s
.309 .47 .9 r
.41309 .39208 m .40672 .39644 L .37868 .40554 L p F P
0 0 0 r
s
.83 .24 .1 r
.3966 .39923 m
.42081 .41421 L
s
.742 .231 .102 r
.59328 .39644 m .58691 .39208 L .61315 .39991 L p F P
0 0 0 r
s
.742 .231 .102 r
.61315 .39991 m .62132 .40554 L .59328 .39644 L p F P
0 0 0 r
s
.24 .35 .67 r
.57919 .41421 m
.6034 .39923 L
s
1 .295 .123 r
.35323 .41697 m .36443 .42367 L .38784 .41113 L p F P
0 0 0 r
s
.24 .35 .67 r
.34494 .42604 m
.35582 .41852 L
s
.83 .24 .1 r
.37338 .42017 m
.40395 .43857 L
s
1 .295 .123 r
.38784 .41113 m .37868 .40554 L .35323 .41697 L p F P
0 0 0 r
s
.236 .343 .687 r
.62132 .40554 m .61216 .41113 L .63557 .42367 L p F P
0 0 0 r
s
.24 .35 .67 r
.59605 .43857 m
.62662 .42017 L
s
.83 .24 .1 r
.73831 .48462 m
.71235 .46669 L
s
.73831 .48462 m
.74839 .50362 L
s
.24 .35 .67 r
.25161 .50362 m
.26169 .48462 L
s
.28765 .46669 m
.26169 .48462 L
s
.303 .454 .884 r
.45438 .37786 m .45885 .37484 L .47933 .37826 L p F P
0 0 0 r
s
.303 .454 .884 r
.4816 .37673 m .47933 .37826 L .45885 .37484 L p F P
0 0 0 r
s
.937 .28 .121 r
.52067 .37826 m .5184 .37673 L .53666 .3718 L p F P
0 0 0 r
s
.937 .28 .121 r
.53666 .3718 m .54115 .37484 L .52067 .37826 L p F P
0 0 0 r
s
.31 .467 .903 r
.41309 .39208 m .41951 .38769 L .44551 .38387 L p F P
0 0 0 r
s
.31 .467 .903 r
.44993 .38087 m .44551 .38387 L .41951 .38769 L p F P
0 0 0 r
s
.864 .262 .114 r
.55449 .38387 m .55007 .38087 L .57404 .38327 L p F P
0 0 0 r
s
.864 .262 .114 r
.57404 .38327 m .58049 .38769 L .55449 .38387 L p F P
0 0 0 r
s
.54 .134 .052 r
.45147 .6426 m .46382 .64897 L .46072 .63926 L p F P
0 0 0 r
s
.54 .134 .052 r
.46072 .63926 m .44727 .63228 L .45147 .6426 L p F P
0 0 0 r
s
.029 .04 .077 r
.55273 .63228 m .53928 .63926 L .53618 .64897 L p F P
0 0 0 r
s
.029 .04 .077 r
.52397 .65527 m .53618 .64897 L .53928 .63926 L p F P
0 0 0 r
s
.303 .454 .884 r
.45885 .37484 m .46334 .3718 L .4816 .37673 L p F P
0 0 0 r
s
.303 .454 .884 r
.48388 .37521 m .4816 .37673 L .46334 .3718 L p F P
0 0 0 r
s
.937 .28 .121 r
.5184 .37673 m .51612 .37521 L .53215 .36874 L p F P
0 0 0 r
s
.937 .28 .121 r
.53215 .36874 m .53666 .3718 L .5184 .37673 L p F P
0 0 0 r
s
.689 .18 .07 r
.41985 .61803 m .43365 .6252 L .43003 .61158 L p F P
0 0 0 r
s
.689 .18 .07 r
.43003 .61158 m .41544 .60391 L .41985 .61803 L p F P
0 0 0 r
s
.83 .24 .1 r
.42989 .60059 m
.43553 .62114 L
s
.062 .08 .171 r
.58456 .60391 m .56997 .61158 L .56635 .6252 L p F P
0 0 0 r
s
.062 .08 .171 r
.55273 .63228 m .56635 .6252 L .56997 .61158 L p F P
0 0 0 r
s
.24 .35 .67 r
.56447 .62114 m
.57011 .60059 L
s
.303 .454 .884 r
.46334 .3718 m .46785 .36874 L .48388 .37521 L p F P
0 0 0 r
s
.303 .454 .884 r
.48617 .37368 m .48388 .37521 L .46785 .36874 L p F P
0 0 0 r
s
.937 .28 .121 r
.51612 .37521 m .51383 .37368 L .52763 .36568 L p F P
0 0 0 r
s
.937 .28 .121 r
.52763 .36568 m .53215 .36874 L .51612 .37521 L p F P
0 0 0 r
s
.742 .231 .102 r
.58691 .39208 m .58049 .38769 L .6049 .39422 L p F P
0 0 0 r
s
.742 .231 .102 r
.6049 .39422 m .61315 .39991 L .58691 .39208 L p F P
0 0 0 r
s
.24 .35 .67 r
.60802 .39637 m
.60957 .39541 L
s
.309 .47 .9 r
.37868 .40554 m .38685 .39991 L .41309 .39208 L p F P
0 0 0 r
s
.309 .47 .9 r
.41951 .38769 m .41309 .39208 L .38685 .39991 L p F P
0 0 0 r
s
.83 .24 .1 r
.39043 .39541 m
.39361 .39738 L
s
.383 .086 .036 r
.47871 .66093 m .48941 .66642 L .48809 .66148 L p F P
0 0 0 r
s
.383 .086 .036 r
.48809 .66148 m .47603 .65527 L .47871 .66093 L p F P
0 0 0 r
s
.024 .035 .067 r
.52397 .65527 m .51191 .66148 L .51059 .66642 L p F P
0 0 0 r
s
.024 .035 .067 r
.5 .67186 m .51059 .66642 L .51191 .66148 L p F P
0 0 0 r
s
.83 .24 .1 r
.50547 .66905 m
.51934 .68066 L
s
.35892 .44661 m
.37338 .42017 L
s
.3875 .39967 m
.39043 .39541 L
s
.24 .35 .67 r
.60957 .39541 m
.61224 .39928 L
s
.31 .467 .903 r
.41951 .38769 m .42596 .38327 L .44993 .38087 L p F P
0 0 0 r
s
.31 .467 .903 r
.45438 .37786 m .44993 .38087 L .42596 .38327 L p F P
0 0 0 r
s
.864 .262 .114 r
.55007 .38087 m .54562 .37786 L .56754 .37882 L p F P
0 0 0 r
s
.864 .262 .114 r
.56754 .37882 m .57404 .38327 L .55007 .38087 L p F P
0 0 0 r
s
.931 .257 .105 r
.35034 .53592 m .36632 .54456 L .36904 .5254 L p F P
0 0 0 r
s
.931 .257 .105 r
.36904 .5254 m .35342 .51679 L .35034 .53592 L p F P
0 0 0 r
s
.83 .24 .1 r
.3676 .54413 m
.37118 .51837 L
s
.175 .246 .506 r
.63096 .5254 m .64658 .51679 L .64011 .49757 L p F P
0 0 0 r
s
.153 .212 .442 r
.64658 .51679 m .63096 .5254 L .63368 .54456 L p F P
0 0 0 r
s
.153 .212 .442 r
.61795 .55308 m .63368 .54456 L .63096 .5254 L p F P
0 0 0 r
s
.24 .35 .67 r
.62882 .51837 m
.6324 .54413 L
s
.967 .27 .111 r
.33756 .50806 m .35342 .51679 L .35989 .49757 L p F P
0 0 0 r
s
.967 .27 .111 r
.35989 .49757 m .34478 .48909 L .33756 .50806 L p F P
0 0 0 r
s
.193 .274 .56 r
.64011 .49757 m .65522 .48909 L .64445 .47065 L p F P
0 0 0 r
s
.175 .246 .506 r
.65522 .48909 m .64011 .49757 L .64658 .51679 L p F P
0 0 0 r
s
.303 .454 .884 r
.46785 .36874 m .47237 .36568 L .48617 .37368 L p F P
0 0 0 r
s
.303 .454 .884 r
.48846 .37215 m .48617 .37368 L .47237 .36568 L p F P
0 0 0 r
s
.937 .28 .121 r
.51383 .37368 m .51154 .37215 L .52307 .3626 L p F P
0 0 0 r
s
.937 .28 .121 r
.52307 .3626 m .52763 .36568 L .51383 .37368 L p F P
0 0 0 r
s
.992 .279 .115 r
.32945 .48048 m .34478 .48909 L .35555 .47065 L p F P
0 0 0 r
s
.992 .279 .115 r
.35555 .47065 m .34137 .46252 L .32945 .48048 L p F P
0 0 0 r
s
.83 .24 .1 r
.34755 .47383 m
.37868 .49156 L
s
.209 .299 .607 r
.64445 .47065 m .65863 .46252 L .64315 .44568 L p F P
0 0 0 r
s
.193 .274 .56 r
.65863 .46252 m .64445 .47065 L .65522 .48909 L p F P
0 0 0 r
s
.24 .35 .67 r
.62132 .49156 m
.65245 .47383 L
s
.236 .343 .687 r
.63557 .42367 m .64677 .41697 L .62132 .40554 L p F P
0 0 0 r
s
.292 .449 .849 r
.38685 .39991 m .37868 .40554 L .35323 .41697 L p F P
0 0 0 r
s
.83 .24 .1 r
.37338 .42017 m
.38554 .40251 L
s
.549 .179 .082 r
.62132 .40554 m .61315 .39991 L .63701 .41021 L p F P
0 0 0 r
s
.549 .179 .082 r
.63701 .41021 m .64677 .41697 L .62132 .40554 L p F P
0 0 0 r
s
.24 .35 .67 r
.61446 .40251 m
.62662 .42017 L
s
.88 .24 .097 r
.36674 .56299 m .38243 .57134 L .38205 .55308 L p F P
0 0 0 r
s
.88 .24 .097 r
.38205 .55308 m .36632 .54456 L .36674 .56299 L p F P
0 0 0 r
s
.83 .24 .1 r
.3676 .54413 m
.39853 .56088 L
s
.126 .17 .362 r
.63368 .54456 m .61795 .55308 L .61757 .57134 L p F P
0 0 0 r
s
.126 .17 .362 r
.60212 .57957 m .61757 .57134 L .61795 .55308 L p F P
0 0 0 r
s
1 .286 .119 r
.32699 .45428 m .34137 .46252 L .35685 .44568 L p F P
0 0 0 r
s
1 .286 .119 r
.35685 .44568 m .34398 .43815 L .32699 .45428 L p F P
0 0 0 r
s
.223 .322 .648 r
.64315 .44568 m .65602 .43815 L .63557 .42367 L p F P
0 0 0 r
s
.83 .24 .1 r
.64418 .41852 m
.65506 .42604 L
s
.24 .35 .67 r
.62662 .42017 m
.64108 .44661 L
s
.209 .299 .607 r
.65602 .43815 m .64315 .44568 L .65863 .46252 L p F P
0 0 0 r
s
.83 .24 .1 r
.34755 .47383 m
.35892 .44661 L
s
.24 .35 .67 r
.64108 .44661 m
.65245 .47383 L
s
1 .291 .121 r
.33096 .43053 m .34398 .43815 L .36443 .42367 L p F P
0 0 0 r
s
.24 .35 .67 r
.3393 .42882 m
.34494 .42604 L
s
1 .291 .121 r
.36443 .42367 m .35323 .41697 L .33096 .43053 L p F P
0 0 0 r
s
.223 .322 .648 r
.64677 .41697 m .63557 .42367 L .65602 .43815 L p F P
0 0 0 r
s
.24 .35 .67 r
.62662 .42017 m
.63852 .41301 L
s
.303 .454 .884 r
.47237 .36568 m .47693 .3626 L .48846 .37215 L p F P
0 0 0 r
s
.303 .454 .884 r
.49076 .37062 m .48846 .37215 L .47693 .3626 L p F P
0 0 0 r
s
.937 .28 .121 r
.51154 .37215 m .50924 .37062 L .5185 .3595 L p F P
0 0 0 r
s
.937 .28 .121 r
.5185 .3595 m .52307 .3626 L .51154 .37215 L p F P
0 0 0 r
s
.83 .24 .1 r
.73817 .71564 m
.7153 .73146 L
s
.7153 .73146 m
.68885 .71712 L
s
.24 .35 .67 r
.31115 .71712 m
.2847 .73146 L
s
.26183 .71564 m
.2847 .73146 L
s
.31 .467 .903 r
.42596 .38327 m .43246 .37882 L .45438 .37786 L p F P
0 0 0 r
s
.31 .467 .903 r
.45885 .37484 m .45438 .37786 L .43246 .37882 L p F P
0 0 0 r
s
.864 .262 .114 r
.54562 .37786 m .54115 .37484 L .56099 .37434 L p F P
0 0 0 r
s
.864 .262 .114 r
.56099 .37434 m .56754 .37882 L .54562 .37786 L p F P
0 0 0 r
s
.303 .454 .884 r
.47693 .3626 m .4815 .3595 L .49076 .37062 L p F P
0 0 0 r
s
.303 .454 .884 r
.49306 .36908 m .49076 .37062 L .4815 .3595 L p F P
0 0 0 r
s
.24 .35 .67 r
.46816 .37001 m
.48937 .37916 L
s
.937 .28 .121 r
.50924 .37062 m .50694 .36908 L .51391 .35639 L p F P
0 0 0 r
s
.937 .28 .121 r
.51391 .35639 m .5185 .3595 L .50924 .37062 L p F P
0 0 0 r
s
.83 .24 .1 r
.51063 .37916 m
.53184 .37001 L
s
.804 .216 .086 r
.38563 .58826 m .40064 .59614 L .39788 .57957 L p F P
0 0 0 r
s
.83 .24 .1 r
.39853 .56088 m
.3995 .58447 L
s
.804 .216 .086 r
.39788 .57957 m .38243 .57134 L .38563 .58826 L p F P
0 0 0 r
s
.092 .118 .262 r
.61757 .57134 m .60212 .57957 L .59936 .59614 L p F P
0 0 0 r
s
.092 .118 .262 r
.58456 .60391 m .59936 .59614 L .60212 .57957 L p F P
0 0 0 r
s
.24 .35 .67 r
.6005 .58447 m
.60147 .56088 L
s
.309 .47 .9 r
.38685 .39991 m .3951 .39422 L .41951 .38769 L p F P
0 0 0 r
s
.309 .47 .9 r
.42596 .38327 m .41951 .38769 L .3951 .39422 L p F P
0 0 0 r
s
.742 .231 .102 r
.58049 .38769 m .57404 .38327 L .59659 .38848 L p F P
0 0 0 r
s
.742 .231 .102 r
.59659 .38848 m .6049 .39422 L .58049 .38769 L p F P
0 0 0 r
s
.303 .454 .884 r
.4815 .3595 m .48609 .35639 L .49306 .36908 L p F P
0 0 0 r
s
.303 .454 .884 r
.49537 .36754 m .49306 .36908 L .48609 .35639 L p F P
0 0 0 r
s
.937 .28 .121 r
.50694 .36908 m .50463 .36754 L .50929 .35327 L p F P
0 0 0 r
s
.24 .35 .67 r
.48937 .37916 m
.50683 .36755 L
s
.937 .28 .121 r
.50929 .35327 m .51391 .35639 L .50694 .36908 L p F P
0 0 0 r
s
.83 .24 .1 r
.49317 .36755 m
.51063 .37916 L
s
.80529 .58696 m
.78014 .57043 L
s
.80529 .58696 m
.80094 .61486 L
s
.24 .35 .67 r
.19471 .58696 m
.19906 .61486 L
s
.21986 .57043 m
.19471 .58696 L
s
.54 .134 .052 r
.43896 .63616 m .45147 .6426 L .44727 .63228 L p F P
0 0 0 r
s
.54 .134 .052 r
.44727 .63228 m .43365 .6252 L .43896 .63616 L p F P
0 0 0 r
s
.83 .24 .1 r
.43553 .62114 m
.46538 .63673 L
s
.029 .04 .077 r
.56635 .6252 m .55273 .63228 L .54853 .6426 L p F P
0 0 0 r
s
.029 .04 .077 r
.53618 .64897 m .54853 .6426 L .55273 .63228 L p F P
0 0 0 r
s
.24 .35 .67 r
.53462 .63673 m
.56447 .62114 L
s
.31 .467 .903 r
.43246 .37882 m .43901 .37434 L .45885 .37484 L p F P
0 0 0 r
s
.31 .467 .903 r
.46334 .3718 m .45885 .37484 L .43901 .37434 L p F P
0 0 0 r
s
.864 .262 .114 r
.54115 .37484 m .53666 .3718 L .5544 .36983 L p F P
0 0 0 r
s
.864 .262 .114 r
.5544 .36983 m .56099 .37434 L .54115 .37484 L p F P
0 0 0 r
s
.303 .454 .884 r
.48609 .35639 m .49071 .35327 L .49537 .36754 L p F P
0 0 0 r
s
.303 .454 .884 r
.49768 .36599 m .49537 .36754 L .49071 .35327 L p F P
0 0 0 r
s
.937 .28 .121 r
.50463 .36754 m .50232 .36599 L .50466 .35013 L p F P
0 0 0 r
s
.937 .28 .121 r
.50466 .35013 m .50929 .35327 L .50463 .36754 L p F P
0 0 0 r
s
.292 .449 .849 r
.35323 .41697 m .36299 .41021 L .38685 .39991 L p F P
0 0 0 r
s
.83 .24 .1 r
.36148 .41301 m
.37338 .42017 L
s
.292 .449 .849 r
.3951 .39422 m .38685 .39991 L .36299 .41021 L p F P
0 0 0 r
s
.549 .179 .082 r
.61315 .39991 m .6049 .39422 L .62714 .40337 L p F P
0 0 0 r
s
.549 .179 .082 r
.62714 .40337 m .63701 .41021 L .61315 .39991 L p F P
0 0 0 r
s
.83 .24 .1 r
.61419 .40556 m
.6279 .40727 L
s
.383 .086 .036 r
.4679 .65537 m .47871 .66093 L .47603 .65527 L p F P
0 0 0 r
s
.383 .086 .036 r
.47603 .65527 m .46382 .64897 L .4679 .65537 L p F P
0 0 0 r
s
.83 .24 .1 r
.47559 .65343 m
.5012 .66665 L
s
.46538 .63673 m
.47559 .65343 L
s
.024 .035 .067 r
.53618 .64897 m .52397 .65527 L .52129 .66093 L p F P
0 0 0 r
s
.24 .35 .67 r
.52441 .65343 m
.53462 .63673 L
s
.024 .035 .067 r
.51059 .66642 m .52129 .66093 L .52397 .65527 L p F P
0 0 0 r
s
.24 .35 .67 r
.4988 .66665 m
.52441 .65343 L
s
.689 .18 .07 r
.40585 .61076 m .41985 .61803 L .41544 .60391 L p F P
0 0 0 r
s
.689 .18 .07 r
.41544 .60391 m .40064 .59614 L .40585 .61076 L p F P
0 0 0 r
s
.83 .24 .1 r
.3995 .58447 m
.42989 .60059 L
s
.062 .08 .171 r
.59936 .59614 m .58456 .60391 L .58015 .61803 L p F P
0 0 0 r
s
.24 .35 .67 r
.57011 .60059 m
.6005 .58447 L
s
.062 .08 .171 r
.56635 .6252 m .58015 .61803 L .58456 .60391 L p F P
0 0 0 r
s
.303 .454 .884 r
.49071 .35327 m .49534 .35013 L .49768 .36599 L p F P
0 0 0 r
s
.303 .454 .884 r
.5 .36444 m .49768 .36599 L .49534 .35013 L p F P
0 0 0 r
s
.937 .28 .121 r
.50232 .36599 m .5 .36444 L .5 .34697 L p F P
0 0 0 r
s
.937 .28 .121 r
.5 .34697 m .50466 .35013 L .50232 .36599 L p F P
0 0 0 r
s
.83 .24 .1 r
.68885 .71712 m
.66534 .72765 L
s
.66534 .72765 m
.63803 .7132 L
s
.24 .35 .67 r
.36197 .7132 m
.33466 .72765 L
s
.33466 .72765 m
.31115 .71712 L
s
.309 .47 .9 r
.3951 .39422 m .40341 .38848 L .42596 .38327 L p F P
0 0 0 r
s
.309 .47 .9 r
.43246 .37882 m .42596 .38327 L .40341 .38848 L p F P
0 0 0 r
s
.24 .35 .67 r
.39675 .40109 m
.41905 .38581 L
s
.41905 .38581 m
.43961 .38932 L
s
.83 .24 .1 r
.40949 .3732 m
.4232 .3819 L
s
.39043 .39541 m
.40949 .3732 L
s
.742 .231 .102 r
.57404 .38327 m .56754 .37882 L .58819 .3827 L p F P
0 0 0 r
s
.24 .35 .67 r
.57449 .38337 m
.57469 .38324 L
s
.57844 .38087 m
.59051 .3732 L
s
.742 .231 .102 r
.58819 .3827 m .59659 .38848 L .57404 .38327 L p F P
0 0 0 r
s
.24 .35 .67 r
.59051 .3732 m
.60957 .39541 L
s
.83 .24 .1 r
.58095 .38581 m
.60325 .40109 L
s
.56039 .38932 m
.58095 .38581 L
s
.223 .322 .648 r
.65602 .43815 m .66904 .43053 L .64677 .41697 L p F P
0 0 0 r
s
.249 .388 .721 r
.36299 .41021 m .35323 .41697 L .33096 .43053 L p F P
0 0 0 r
s
.411 .13 .062 r
.64677 .41697 m .63701 .41021 L .65793 .42281 L p F P
0 0 0 r
s
.83 .24 .1 r
.6279 .40727 m
.63836 .4145 L
s
.411 .13 .062 r
.65793 .42281 m .66904 .43053 L .64677 .41697 L p F P
0 0 0 r
s
.31 .467 .903 r
.43901 .37434 m .4456 .36983 L .46334 .3718 L p F P
0 0 0 r
s
.31 .467 .903 r
.46785 .36874 m .46334 .3718 L .4456 .36983 L p F P
0 0 0 r
s
.24 .35 .67 r
.43961 .38932 m
.46816 .37001 L
s
.864 .262 .114 r
.53666 .3718 m .53215 .36874 L .54776 .36529 L p F P
0 0 0 r
s
.864 .262 .114 r
.54776 .36529 m .5544 .36983 L .53666 .3718 L p F P
0 0 0 r
s
.24 .35 .67 r
.55042 .36711 m
.57007 .35433 L
s
.83 .24 .1 r
.53184 .37001 m
.56039 .38932 L
s
1 .286 .119 r
.31243 .44594 m .32699 .45428 L .34398 .43815 L p F P
0 0 0 r
s
1 .286 .119 r
.34398 .43815 m .33096 .43053 L .31243 .44594 L p F P
0 0 0 r
s
.24 .35 .67 r
.30151 .45274 m
.31791 .44137 L
s
.209 .299 .607 r
.66904 .43053 m .65602 .43815 L .67301 .45428 L p F P
0 0 0 r
s
.83 .24 .1 r
.66948 .43313 m
.67195 .43435 L
s
.209 .299 .607 r
.65863 .46252 m .67301 .45428 L .65602 .43815 L p F P
0 0 0 r
s
.83 .24 .1 r
.67195 .43435 m
.69849 .45274 L
s
.40949 .3732 m
.37831 .35341 L
s
.24 .35 .67 r
.62169 .35341 m
.59051 .3732 L
s
.992 .279 .115 r
.31391 .47175 m .32945 .48048 L .34137 .46252 L p F P
0 0 0 r
s
.992 .279 .115 r
.34137 .46252 m .32699 .45428 L .31391 .47175 L p F P
0 0 0 r
s
.193 .274 .56 r
.67301 .45428 m .65863 .46252 L .67055 .48048 L p F P
0 0 0 r
s
.193 .274 .56 r
.65522 .48909 m .67055 .48048 L .65863 .46252 L p F P
0 0 0 r
s
.967 .27 .111 r
.32146 .49919 m .33756 .50806 L .34478 .48909 L p F P
0 0 0 r
s
.967 .27 .111 r
.34478 .48909 m .32945 .48048 L .32146 .49919 L p F P
0 0 0 r
s
.83 .24 .1 r
.33971 .50091 m
.34755 .47383 L
s
.175 .246 .506 r
.67055 .48048 m .65522 .48909 L .66244 .50806 L p F P
0 0 0 r
s
.175 .246 .506 r
.64658 .51679 m .66244 .50806 L .65522 .48909 L p F P
0 0 0 r
s
.24 .35 .67 r
.65245 .47383 m
.66029 .50091 L
s
.303 .454 .884 r
.49534 .35013 m .5 .34697 L .5 .36444 L p F P
0 0 0 r
s
.83 .24 .1 r
.53731 .68742 m
.51934 .68066 L
s
.24 .35 .67 r
.48066 .68066 m
.46269 .68742 L
s
.931 .257 .105 r
.33413 .52714 m .35034 .53592 L .35342 .51679 L p F P
0 0 0 r
s
.931 .257 .105 r
.35342 .51679 m .33756 .50806 L .33413 .52714 L p F P
0 0 0 r
s
.83 .24 .1 r
.33971 .50091 m
.37118 .51837 L
s
.153 .212 .442 r
.66244 .50806 m .64658 .51679 L .64966 .53592 L p F P
0 0 0 r
s
.153 .212 .442 r
.63368 .54456 m .64966 .53592 L .64658 .51679 L p F P
0 0 0 r
s
.24 .35 .67 r
.62882 .51837 m
.66029 .50091 L
s
.83 .24 .1 r
.63803 .7132 m
.6152 .71799 L
s
.6152 .71799 m
.58709 .70336 L
s
.24 .35 .67 r
.41291 .70336 m
.3848 .71799 L
s
.3848 .71799 m
.36197 .7132 L
s
.83 .24 .1 r
.58709 .70336 m
.56616 .70229 L
s
.56616 .70229 m
.53731 .68742 L
s
.24 .35 .67 r
.46269 .68742 m
.43384 .70229 L
s
.43384 .70229 m
.41291 .70336 L
s
.88 .24 .097 r
.35082 .55451 m .36674 .56299 L .36632 .54456 L p F P
0 0 0 r
s
.88 .24 .097 r
.36632 .54456 m .35034 .53592 L .35082 .55451 L p F P
0 0 0 r
s
.126 .17 .362 r
.64966 .53592 m .63368 .54456 L .63326 .56299 L p F P
0 0 0 r
s
.126 .17 .362 r
.61757 .57134 m .63326 .56299 L .63368 .54456 L p F P
0 0 0 r
s
.24 .35 .67 r
.60147 .56088 m
.6324 .54413 L
s
.83 .24 .1 r
.7795 .54413 m
.75384 .52688 L
s
.7795 .54413 m
.78014 .57043 L
s
.24 .35 .67 r
.2205 .54413 m
.24616 .52688 L
s
.21986 .57043 m
.2205 .54413 L
s
.31 .467 .903 r
.4456 .36983 m .45224 .36529 L .46785 .36874 L p F P
0 0 0 r
s
.83 .24 .1 r
.42993 .35433 m
.44958 .36711 L
s
.31 .467 .903 r
.47237 .36568 m .46785 .36874 L .45224 .36529 L p F P
0 0 0 r
s
.864 .262 .114 r
.53215 .36874 m .52763 .36568 L .54108 .36072 L p F P
0 0 0 r
s
.864 .262 .114 r
.54108 .36072 m .54776 .36529 L .53215 .36874 L p F P
0 0 0 r
s
.292 .449 .849 r
.36299 .41021 m .37286 .40337 L .3951 .39422 L p F P
0 0 0 r
s
.24 .35 .67 r
.36164 .4145 m
.3721 .40727 L
s
.3721 .40727 m
.38581 .40556 L
s
.292 .449 .849 r
.40341 .38848 m .3951 .39422 L .37286 .40337 L p F P
0 0 0 r
s
.549 .179 .082 r
.6049 .39422 m .59659 .38848 L .61718 .39646 L p F P
0 0 0 r
s
.24 .35 .67 r
.60957 .39541 m
.61 .39515 L
s
.549 .179 .082 r
.61718 .39646 m .62714 .40337 L .6049 .39422 L p F P
0 0 0 r
s
.309 .47 .9 r
.40341 .38848 m .41181 .3827 L .43246 .37882 L p F P
0 0 0 r
s
.309 .47 .9 r
.43901 .37434 m .43246 .37882 L .41181 .3827 L p F P
0 0 0 r
s
.742 .231 .102 r
.56754 .37882 m .56099 .37434 L .57973 .37686 L p F P
0 0 0 r
s
.742 .231 .102 r
.57973 .37686 m .58819 .3827 L .56754 .37882 L p F P
0 0 0 r
s
.804 .216 .086 r
.3704 .58026 m .38563 .58826 L .38243 .57134 L p F P
0 0 0 r
s
.804 .216 .086 r
.38243 .57134 m .36674 .56299 L .3704 .58026 L p F P
0 0 0 r
s
.092 .118 .262 r
.63326 .56299 m .61757 .57134 L .61437 .58826 L p F P
0 0 0 r
s
.092 .118 .262 r
.59936 .59614 m .61437 .58826 L .61757 .57134 L p F P
0 0 0 r
s
.83 .24 .1 r
.75922 .69491 m
.73817 .71564 L
s
.73817 .71564 m
.71184 .70094 L
s
.24 .35 .67 r
.28816 .70094 m
.26183 .71564 L
s
.24078 .69491 m
.26183 .71564 L
s
.83 .24 .1 r
.66938 .43257 m
.67195 .43435 L
s
.74839 .50362 m
.7222 .48571 L
s
.74839 .50362 m
.75384 .52688 L
s
.24 .35 .67 r
.24616 .52688 m
.25161 .50362 L
s
.2778 .48571 m
.25161 .50362 L
s
.252 .058 .024 r
.49104 .66749 m .5 .67208 L .5 .67186 L p F P
0 0 0 r
s
.252 .058 .024 r
.5 .67186 m .48941 .66642 L .49104 .66749 L p F P
0 0 0 r
s
.24 .35 .67 r
.49788 .67181 m
.49867 .6714 L
s
.48066 .68066 m
.49788 .67181 L
s
.024 .035 .067 r
.51059 .66642 m .5 .67186 L .5 .67208 L p F P
0 0 0 r
s
.83 .24 .1 r
.50212 .67181 m
.51934 .68066 L
s
.54 .134 .052 r
.4263 .62963 m .43896 .63616 L .43365 .6252 L p F P
0 0 0 r
s
.54 .134 .052 r
.43365 .6252 m .41985 .61803 L .4263 .62963 L p F P
0 0 0 r
s
.029 .04 .077 r
.58015 .61803 m .56635 .6252 L .56104 .63616 L p F P
0 0 0 r
s
.029 .04 .077 r
.54853 .6426 m .56104 .63616 L .56635 .6252 L p F P
0 0 0 r
s
.31 .467 .903 r
.45224 .36529 m .45892 .36072 L .47237 .36568 L p F P
0 0 0 r
s
.31 .467 .903 r
.47693 .3626 m .47237 .36568 L .45892 .36072 L p F P
0 0 0 r
s
.864 .262 .114 r
.52763 .36568 m .52307 .3626 L .53435 .35611 L p F P
0 0 0 r
s
.864 .262 .114 r
.53435 .35611 m .54108 .36072 L .52763 .36568 L p F P
0 0 0 r
s
.83 .24 .1 r
.71235 .46669 m
.7222 .48571 L
s
.24 .35 .67 r
.2778 .48571 m
.28765 .46669 L
s
.249 .388 .721 r
.33096 .43053 m .34207 .42281 L .36299 .41021 L p F P
0 0 0 r
s
.249 .388 .721 r
.37286 .40337 m .36299 .41021 L .34207 .42281 L p F P
0 0 0 r
s
.83 .24 .1 r
.3419 .40122 m
.35949 .41181 L
s
.411 .13 .062 r
.63701 .41021 m .62714 .40337 L .64668 .415 L p F P
0 0 0 r
s
.24 .35 .67 r
.64009 .41206 m
.64039 .41188 L
s
.411 .13 .062 r
.64668 .415 m .65793 .42281 L .63701 .41021 L p F P
0 0 0 r
s
.24 .35 .67 r
.64091 .41157 m
.6581 .40122 L
s
.83 .24 .1 r
.80094 .61486 m
.77553 .59862 L
s
.80094 .61486 m
.79148 .64315 L
s
.24 .35 .67 r
.19906 .61486 m
.20852 .64315 L
s
.22447 .59862 m
.19906 .61486 L
s
.383 .086 .036 r
.45696 .64976 m .4679 .65537 L .46382 .64897 L p F P
0 0 0 r
s
.383 .086 .036 r
.46382 .64897 m .45147 .6426 L .45696 .64976 L p F P
0 0 0 r
s
.024 .035 .067 r
.54853 .6426 m .53618 .64897 L .5321 .65537 L p F P
0 0 0 r
s
.024 .035 .067 r
.52129 .66093 m .5321 .65537 L .53618 .64897 L p F P
0 0 0 r
s
.209 .299 .607 r
.67301 .45428 m .68757 .44594 L .66904 .43053 L p F P
0 0 0 r
s
.024 .035 .067 r
.34207 .42281 m .33096 .43053 L .31243 .44594 L p F P
0 0 0 r
s
.83 .24 .1 r
.32718 .42803 m
.33111 .43033 L
s
.33111 .43033 m
.33127 .43042 L
s
.33187 .43077 m
.35892 .44661 L
s
.36 .08 .033 r
.66904 .43053 m .65793 .42281 L .67536 .43747 L p F P
0 0 0 r
s
.24 .35 .67 r
.66873 .43042 m
.66889 .43033 L
s
.64108 .44661 m
.66769 .43103 L
s
.66889 .43033 m
.67282 .42803 L
s
.36 .08 .033 r
.67536 .43747 m .68757 .44594 L .66904 .43053 L p F P
0 0 0 r
s
.689 .18 .07 r
.39167 .60339 m .40585 .61076 L .40064 .59614 L p F P
0 0 0 r
s
.689 .18 .07 r
.40064 .59614 m .38563 .58826 L .39167 .60339 L p F P
0 0 0 r
s
.83 .24 .1 r
.3995 .58447 m
.40478 .60509 L
s
.062 .08 .171 r
.61437 .58826 m .59936 .59614 L .59415 .61076 L p F P
0 0 0 r
s
.062 .08 .171 r
.58015 .61803 m .59415 .61076 L .59936 .59614 L p F P
0 0 0 r
s
.309 .47 .9 r
.41181 .3827 m .42027 .37686 L .43901 .37434 L p F P
0 0 0 r
s
.309 .47 .9 r
.4456 .36983 m .43901 .37434 L .42027 .37686 L p F P
0 0 0 r
s
.83 .24 .1 r
.40949 .3732 m
.42993 .35433 L
s
.742 .231 .102 r
.56099 .37434 m .5544 .36983 L .57119 .37097 L p F P
0 0 0 r
s
.742 .231 .102 r
.57119 .37097 m .57973 .37686 L .56099 .37434 L p F P
0 0 0 r
s
.24 .35 .67 r
.57007 .35433 m
.59051 .3732 L
s
.31 .467 .903 r
.45892 .36072 m .46565 .35611 L .47693 .3626 L p F P
0 0 0 r
s
.31 .467 .903 r
.4815 .3595 m .47693 .3626 L .46565 .35611 L p F P
0 0 0 r
s
.864 .262 .114 r
.52307 .3626 m .5185 .3595 L .52758 .35148 L p F P
0 0 0 r
s
.864 .262 .114 r
.52758 .35148 m .53435 .35611 L .52307 .3626 L p F P
0 0 0 r
s
.24 .35 .67 r
.52928 .35264 m
.54893 .33958 L
s
.992 .279 .115 r
.29814 .4629 m .31391 .47175 L .32699 .45428 L p F P
0 0 0 r
s
.992 .279 .115 r
.32699 .45428 m .31243 .44594 L .29814 .4629 L p F P
0 0 0 r
s
.193 .274 .56 r
.68757 .44594 m .67301 .45428 L .68609 .47175 L p F P
0 0 0 r
s
.193 .274 .56 r
.67055 .48048 m .68609 .47175 L .67301 .45428 L p F P
0 0 0 r
s
.292 .449 .849 r
.37286 .40337 m .38282 .39646 L .40341 .38848 L p F P
0 0 0 r
s
.292 .449 .849 r
.41181 .3827 m .40341 .38848 L .38282 .39646 L p F P
0 0 0 r
s
.83 .24 .1 r
.35913 .37606 m
.38808 .39397 L
s
.549 .179 .082 r
.59659 .38848 m .58819 .3827 L .6071 .38948 L p F P
0 0 0 r
s
.549 .179 .082 r
.6071 .38948 m .61718 .39646 L .59659 .38848 L p F P
0 0 0 r
s
.24 .35 .67 r
.61279 .39342 m
.64087 .37606 L
s
.967 .27 .111 r
.30512 .49019 m .32146 .49919 L .32945 .48048 L p F P
0 0 0 r
s
.967 .27 .111 r
.32945 .48048 m .31391 .47175 L .30512 .49019 L p F P
0 0 0 r
s
.83 .24 .1 r
.3155 .45558 m
.34755 .47383 L
s
.175 .246 .506 r
.68609 .47175 m .67055 .48048 L .67854 .49919 L p F P
0 0 0 r
s
.24 .35 .67 r
.65245 .47383 m
.6845 .45558 L
s
.175 .246 .506 r
.66244 .50806 m .67854 .49919 L .67055 .48048 L p F P
0 0 0 r
s
.83 .24 .1 r
.32718 .42803 m
.3419 .40122 L
s
.3419 .40122 m
.30946 .3817 L
s
.3419 .40122 m
.35913 .37606 L
s
.24 .35 .67 r
.64087 .37606 m
.6581 .40122 L
s
.69054 .3817 m
.6581 .40122 L
s
.6581 .40122 m
.67282 .42803 L
s
.931 .257 .105 r
.31766 .51823 m .33413 .52714 L .33756 .50806 L p F P
0 0 0 r
s
.931 .257 .105 r
.33756 .50806 m .32146 .49919 L .31766 .51823 L p F P
0 0 0 r
s
.83 .24 .1 r
.33575 .52688 m
.33971 .50091 L
s
.153 .212 .442 r
.67854 .49919 m .66244 .50806 L .66587 .52714 L p F P
0 0 0 r
s
.153 .212 .442 r
.64966 .53592 m .66587 .52714 L .66244 .50806 L p F P
0 0 0 r
s
.24 .35 .67 r
.66029 .50091 m
.66425 .52688 L
s
.60119 .33409 m
.57007 .35433 L
s
.83 .24 .1 r
.42993 .35433 m
.39881 .33409 L
s
.42993 .35433 m
.45107 .33958 L
s
.77732 .67032 m
.75922 .69491 L
s
.75922 .69491 m
.73308 .67982 L
s
.24 .35 .67 r
.26692 .67982 m
.24078 .69491 L
s
.22268 .67032 m
.24078 .69491 L
s
.88 .24 .097 r
.33466 .54591 m .35082 .55451 L .35034 .53592 L p F P
0 0 0 r
s
.88 .24 .097 r
.35034 .53592 m .33413 .52714 L .33466 .54591 L p F P
0 0 0 r
s
.83 .24 .1 r
.33575 .52688 m
.3676 .54413 L
s
.126 .17 .362 r
.66587 .52714 m .64966 .53592 L .64918 .55451 L p F P
0 0 0 r
s
.126 .17 .362 r
.63326 .56299 m .64918 .55451 L .64966 .53592 L p F P
0 0 0 r
s
.83 .24 .1 r
.32337 .43702 m
.32718 .42803 L
s
.24 .35 .67 r
.67282 .42803 m
.67663 .43702 L
s
.67743 .43891 m
.6845 .45558 L
s
.31 .467 .903 r
.46565 .35611 m .47242 .35148 L .4815 .3595 L p F P
0 0 0 r
s
.83 .24 .1 r
.45107 .33958 m
.47072 .35264 L
s
.31 .467 .903 r
.48609 .35639 m .4815 .3595 L .47242 .35148 L p F P
0 0 0 r
s
.864 .262 .114 r
.5185 .3595 m .51391 .35639 L .52075 .34681 L p F P
0 0 0 r
s
.864 .262 .114 r
.52075 .34681 m .52758 .35148 L .5185 .3595 L p F P
0 0 0 r
s
.252 .058 .024 r
.48201 .66285 m .49104 .66749 L .48941 .66642 L p F P
0 0 0 r
s
.252 .058 .024 r
.48941 .66642 m .47871 .66093 L .48201 .66285 L p F P
0 0 0 r
s
.024 .035 .067 r
.52129 .66093 m .51059 .66642 L .50896 .66749 L p F P
0 0 0 r
s
.024 .035 .067 r
.5 .67208 m .50896 .66749 L .51059 .66642 L p F P
0 0 0 r
s
.83 .24 .1 r
.4898 .66547 m
.50117 .67132 L
s
.50133 .6714 m
.50212 .67181 L
s
.79148 .64315 m
.7658 .62726 L
s
.79148 .64315 m
.77732 .67032 L
s
.24 .35 .67 r
.20852 .64315 m
.22268 .67032 L
s
.2342 .62726 m
.20852 .64315 L
s
.309 .47 .9 r
.42027 .37686 m .42881 .37097 L .4456 .36983 L p F P
0 0 0 r
s
.309 .47 .9 r
.45224 .36529 m .4456 .36983 L .42881 .37097 L p F P
0 0 0 r
s
.742 .231 .102 r
.5544 .36983 m .54776 .36529 L .56257 .36502 L p F P
0 0 0 r
s
.83 .24 .1 r
.53184 .37001 m
.55229 .36616 L
s
.742 .231 .102 r
.56257 .36502 m .57119 .37097 L .5544 .36983 L p F P
0 0 0 r
s
.83 .24 .1 r
.35913 .37606 m
.32689 .35611 L
s
.35913 .37606 m
.37831 .35341 L
s
.24 .35 .67 r
.62169 .35341 m
.64087 .37606 L
s
.67311 .35611 m
.64087 .37606 L
s
.83 .24 .1 r
.71184 .70094 m
.68885 .71712 L
s
.68885 .71712 m
.6616 .70234 L
s
.24 .35 .67 r
.3384 .70234 m
.31115 .71712 L
s
.31115 .71712 m
.28816 .70094 L
s
.249 .388 .721 r
.34207 .42281 m .35332 .415 L .37286 .40337 L p F P
0 0 0 r
s
.249 .388 .721 r
.38282 .39646 m .37286 .40337 L .35332 .415 L p F P
0 0 0 r
s
.411 .13 .062 r
.62714 .40337 m .61718 .39646 L .63529 .4071 L p F P
0 0 0 r
s
.411 .13 .062 r
.63529 .4071 m .64668 .415 L .62714 .40337 L p F P
0 0 0 r
s
.804 .216 .086 r
.35495 .57214 m .3704 .58026 L .36674 .56299 L p F P
0 0 0 r
s
.83 .24 .1 r
.3676 .54413 m
.3682 .56786 L
s
.804 .216 .086 r
.36674 .56299 m .35082 .55451 L .35495 .57214 L p F P
0 0 0 r
s
.092 .118 .262 r
.64918 .55451 m .63326 .56299 L .6296 .58026 L p F P
0 0 0 r
s
.092 .118 .262 r
.61437 .58826 m .6296 .58026 L .63326 .56299 L p F P
0 0 0 r
s
.24 .35 .67 r
.6318 .56786 m
.6324 .54413 L
s
.83 .24 .1 r
.77732 .67032 m
.7514 .65483 L
s
.24 .35 .67 r
.2486 .65483 m
.22268 .67032 L
s
.54 .134 .052 r
.41349 .62302 m .4263 .62963 L .41985 .61803 L p F P
0 0 0 r
s
.54 .134 .052 r
.41985 .61803 m .40585 .61076 L .41349 .62302 L p F P
0 0 0 r
s
.83 .24 .1 r
.40478 .60509 m
.43553 .62114 L
s
.029 .04 .077 r
.59415 .61076 m .58015 .61803 L .5737 .62963 L p F P
0 0 0 r
s
.029 .04 .077 r
.56104 .63616 m .5737 .62963 L .58015 .61803 L p F P
0 0 0 r
s
.383 .086 .036 r
.44591 .64409 m .45696 .64976 L .45147 .6426 L p F P
0 0 0 r
s
.383 .086 .036 r
.45147 .6426 m .43896 .63616 L .44591 .64409 L p F P
0 0 0 r
s
.83 .24 .1 r
.44543 .63785 m
.47559 .65343 L
s
.43553 .62114 m
.44543 .63785 L
s
.024 .035 .067 r
.56104 .63616 m .54853 .6426 L .54304 .64976 L p F P
0 0 0 r
s
.24 .35 .67 r
.55457 .63785 m
.56447 .62114 L
s
.024 .035 .067 r
.5321 .65537 m .54304 .64976 L .54853 .6426 L p F P
0 0 0 r
s
.24 .35 .67 r
.52441 .65343 m
.55457 .63785 L
s
.31 .467 .903 r
.47242 .35148 m .47925 .34681 L .48609 .35639 L p F P
0 0 0 r
s
.31 .467 .903 r
.49071 .35327 m .48609 .35639 L .47925 .34681 L p F P
0 0 0 r
s
.864 .262 .114 r
.51391 .35639 m .50929 .35327 L .51389 .34211 L p F P
0 0 0 r
s
.864 .262 .114 r
.51389 .34211 m .52075 .34681 L .51391 .35639 L p F P
0 0 0 r
s
.292 .449 .849 r
.38282 .39646 m .3929 .38948 L .41181 .3827 L p F P
0 0 0 r
s
.292 .449 .849 r
.42027 .37686 m .41181 .3827 L .3929 .38948 L p F P
0 0 0 r
s
.549 .179 .082 r
.58819 .3827 m .57973 .37686 L .59691 .38242 L p F P
0 0 0 r
s
.549 .179 .082 r
.59691 .38242 m .6071 .38948 L .58819 .3827 L p F P
0 0 0 r
s
.83 .24 .1 r
.58095 .38581 m
.59993 .38793 L
s
.78014 .57043 m
.75422 .55339 L
s
.78014 .57043 m
.77553 .59862 L
s
.24 .35 .67 r
.22447 .59862 m
.21986 .57043 L
s
.24578 .55339 m
.21986 .57043 L
s
.024 .035 .067 r
.31243 .44594 m .32464 .43747 L .34207 .42281 L p F P
0 0 0 r
s
.83 .24 .1 r
.3155 .45558 m
.32257 .43891 L
s
.024 .035 .067 r
.35332 .415 m .34207 .42281 L .32464 .43747 L p F P
0 0 0 r
s
.36 .08 .033 r
.65793 .42281 m .64668 .415 L .66298 .4289 L p F P
0 0 0 r
s
.83 .24 .1 r
.66147 .42709 m
.66852 .43197 L
s
.36 .08 .033 r
.66298 .4289 m .67536 .43747 L .65793 .42281 L p F P
0 0 0 r
s
.24 .35 .67 r
.67282 .42803 m
.70552 .40889 L
s
.309 .47 .9 r
.42881 .37097 m .43743 .36502 L .45224 .36529 L p F P
0 0 0 r
s
.24 .35 .67 r
.44771 .36616 m
.46816 .37001 L
s
.309 .47 .9 r
.45892 .36072 m .45224 .36529 L .43743 .36502 L p F P
0 0 0 r
s
.742 .231 .102 r
.54776 .36529 m .54108 .36072 L .55387 .35903 L p F P
0 0 0 r
s
.742 .231 .102 r
.55387 .35903 m .56257 .36502 L .54776 .36529 L p F P
0 0 0 r
s
.689 .18 .07 r
.37729 .59592 m .39167 .60339 L .38563 .58826 L p F P
0 0 0 r
s
.689 .18 .07 r
.38563 .58826 m .3704 .58026 L .37729 .59592 L p F P
0 0 0 r
s
.83 .24 .1 r
.3682 .56786 m
.3995 .58447 L
s
.062 .08 .171 r
.6296 .58026 m .61437 .58826 L .60833 .60339 L p F P
0 0 0 r
s
.24 .35 .67 r
.6005 .58447 m
.6318 .56786 L
s
.062 .08 .171 r
.59415 .61076 m .60833 .60339 L .61437 .58826 L p F P
0 0 0 r
s
.24 .35 .67 r
.56447 .62114 m
.59522 .60509 L
s
.59522 .60509 m
.6005 .58447 L
s
.193 .274 .56 r
.68609 .47175 m .70186 .4629 L .68757 .44594 L p F P
0 0 0 r
s
.024 .035 .067 r
.32464 .43747 m .31243 .44594 L .29814 .4629 L p F P
0 0 0 r
s
.83 .24 .1 r
.30696 .45072 m
.30815 .45139 L
s
.30939 .4521 m
.3155 .45558 L
s
.24 .35 .67 r
.3144 .44822 m
.32363 .43884 L
s
.31099 .45057 m
.3144 .44822 L
s
.28765 .46669 m
.30509 .45465 L
s
.542 .135 .052 r
.68757 .44594 m .67536 .43747 L .68881 .45391 L p F P
0 0 0 r
s
.83 .24 .1 r
.67637 .43884 m
.67699 .43947 L
s
.542 .135 .052 r
.68881 .45391 m .70186 .4629 L .68757 .44594 L p F P
0 0 0 r
s
.24 .35 .67 r
.6845 .45558 m
.68837 .45337 L
s
.69185 .45139 m
.69304 .45072 L
s
.83 .24 .1 r
.69491 .45465 m
.71235 .46669 L
s
.24 .35 .67 r
.69304 .45072 m
.71754 .43677 L
s
.31 .467 .903 r
.47925 .34681 m .48611 .34211 L .49071 .35327 L p F P
0 0 0 r
s
.31 .467 .903 r
.49534 .35013 m .49071 .35327 L .48611 .34211 L p F P
0 0 0 r
s
.864 .262 .114 r
.50929 .35327 m .50466 .35013 L .50697 .33737 L p F P
0 0 0 r
s
.864 .262 .114 r
.50697 .33737 m .51389 .34211 L .50929 .35327 L p F P
0 0 0 r
s
.83 .24 .1 r
.6616 .70234 m
.63803 .7132 L
s
.63803 .7132 m
.6099 .6983 L
s
.24 .35 .67 r
.3901 .6983 m
.36197 .7132 L
s
.36197 .7132 m
.3384 .70234 L
s
.967 .27 .111 r
.28854 .48105 m .30512 .49019 L .31391 .47175 L p F P
0 0 0 r
s
.967 .27 .111 r
.31391 .47175 m .29814 .4629 L .28854 .48105 L p F P
0 0 0 r
s
.175 .246 .506 r
.70186 .4629 m .68609 .47175 L .69488 .49019 L p F P
0 0 0 r
s
.175 .246 .506 r
.67854 .49919 m .69488 .49019 L .68609 .47175 L p F P
0 0 0 r
s
.24 .35 .67 r
.6845 .45558 m
.69271 .48292 L
s
.252 .058 .024 r
.47289 .65817 m .48201 .66285 L .47871 .66093 L p F P
0 0 0 r
s
.252 .058 .024 r
.47871 .66093 m .4679 .65537 L .47289 .65817 L p F P
0 0 0 r
s
.83 .24 .1 r
.47559 .65343 m
.4898 .66547 L
s
.024 .035 .067 r
.5321 .65537 m .52129 .66093 L .51799 .66285 L p F P
0 0 0 r
s
.024 .035 .067 r
.50896 .66749 m .51799 .66285 L .52129 .66093 L p F P
0 0 0 r
s
.24 .35 .67 r
.5102 .66547 m
.52441 .65343 L
s
.49883 .67132 m
.5102 .66547 L
s
.83 .24 .1 r
.37831 .35341 m
.34619 .33301 L
s
.37831 .35341 m
.39881 .33409 L
s
.24 .35 .67 r
.60119 .33409 m
.62169 .35341 L
s
.65381 .33301 m
.62169 .35341 L
s
.931 .257 .105 r
.30094 .50919 m .31766 .51823 L .32146 .49919 L p F P
0 0 0 r
s
.931 .257 .105 r
.32146 .49919 m .30512 .49019 L .30094 .50919 L p F P
0 0 0 r
s
.83 .24 .1 r
.30729 .48292 m
.33971 .50091 L
s
.153 .212 .442 r
.69488 .49019 m .67854 .49919 L .68234 .51823 L p F P
0 0 0 r
s
.153 .212 .442 r
.66587 .52714 m .68234 .51823 L .67854 .49919 L p F P
0 0 0 r
s
.24 .35 .67 r
.66029 .50091 m
.69271 .48292 L
s
.249 .388 .721 r
.35332 .415 m .36471 .4071 L .38282 .39646 L p F P
0 0 0 r
s
.249 .388 .721 r
.3929 .38948 m .38282 .39646 L .36471 .4071 L p F P
0 0 0 r
s
.411 .13 .062 r
.61718 .39646 m .6071 .38948 L .62375 .39909 L p F P
0 0 0 r
s
.411 .13 .062 r
.62375 .39909 m .63529 .4071 L .61718 .39646 L p F P
0 0 0 r
s
.83 .24 .1 r
.59993 .38793 m
.6279 .40727 L
s
.6099 .6983 m
.58709 .70336 L
s
.58709 .70336 m
.55812 .68829 L
s
.24 .35 .67 r
.44188 .68829 m
.41291 .70336 L
s
.41291 .70336 m
.3901 .6983 L
s
.292 .449 .849 r
.3929 .38948 m .40309 .38242 L .42027 .37686 L p F P
0 0 0 r
s
.24 .35 .67 r
.3721 .40727 m
.40007 .38793 L
s
.40007 .38793 m
.41905 .38581 L
s
.292 .449 .849 r
.42881 .37097 m .42027 .37686 L .40309 .38242 L p F P
0 0 0 r
s
.24 .35 .67 r
.41905 .38581 m
.44771 .36616 L
s
.549 .179 .082 r
.57973 .37686 m .57119 .37097 L .58661 .37528 L p F P
0 0 0 r
s
.549 .179 .082 r
.58661 .37528 m .59691 .38242 L .57973 .37686 L p F P
0 0 0 r
s
.83 .24 .1 r
.55229 .36616 m
.58095 .38581 L
s
.31 .467 .903 r
.48611 .34211 m .49303 .33737 L .49534 .35013 L p F P
0 0 0 r
s
.31 .467 .903 r
.5 .34697 m .49534 .35013 L .49303 .33737 L p F P
0 0 0 r
s
.24 .35 .67 r
.46816 .37001 m
.49756 .35012 L
s
.864 .262 .114 r
.50466 .35013 m .5 .34697 L .5 .3326 L p F P
0 0 0 r
s
.864 .262 .114 r
.5 .3326 m .50697 .33737 L .50466 .35013 L p F P
0 0 0 r
s
.83 .24 .1 r
.50244 .35012 m
.53184 .37001 L
s
.49461 .35365 m
.50244 .35012 L
s
.24 .35 .67 r
.49756 .35012 m
.50539 .35365 L
s
.83 .24 .1 r
.55812 .68829 m
.53731 .68742 L
s
.53731 .68742 m
.50758 .6721 L
s
.24 .35 .67 r
.49242 .6721 m
.46269 .68742 L
s
.46269 .68742 m
.44188 .68829 L
s
.88 .24 .097 r
.31826 .53717 m .33466 .54591 L .33413 .52714 L p F P
0 0 0 r
s
.88 .24 .097 r
.33413 .52714 m .31766 .51823 L .31826 .53717 L p F P
0 0 0 r
s
.126 .17 .362 r
.68234 .51823 m .66587 .52714 L .66534 .54591 L p F P
0 0 0 r
s
.126 .17 .362 r
.64918 .55451 m .66534 .54591 L .66587 .52714 L p F P
0 0 0 r
s
.24 .35 .67 r
.6324 .54413 m
.66425 .52688 L
s
.309 .47 .9 r
.43743 .36502 m .44613 .35903 L .45892 .36072 L p F P
0 0 0 r
s
.309 .47 .9 r
.46565 .35611 m .45892 .36072 L .44613 .35903 L p F P
0 0 0 r
s
.742 .231 .102 r
.54108 .36072 m .53435 .35611 L .5451 .35297 L p F P
0 0 0 r
s
.742 .231 .102 r
.5451 .35297 m .55387 .35903 L .54108 .36072 L p F P
0 0 0 r
s
.24 .35 .67 r
.54893 .33958 m
.57007 .35433 L
s
.83 .24 .1 r
.75384 .52688 m
.7274 .5091 L
s
.75384 .52688 m
.75422 .55339 L
s
.24 .35 .67 r
.24616 .52688 m
.2726 .5091 L
s
.24578 .55339 m
.24616 .52688 L
s
.383 .086 .036 r
.43474 .63835 m .44591 .64409 L .43896 .63616 L p F P
0 0 0 r
s
.383 .086 .036 r
.43896 .63616 m .4263 .62963 L .43474 .63835 L p F P
0 0 0 r
s
.024 .035 .067 r
.5737 .62963 m .56104 .63616 L .55409 .64409 L p F P
0 0 0 r
s
.024 .035 .067 r
.54304 .64976 m .55409 .64409 L .56104 .63616 L p F P
0 0 0 r
s
.54 .134 .052 r
.40051 .61633 m .41349 .62302 L .40585 .61076 L p F P
0 0 0 r
s
.54 .134 .052 r
.40585 .61076 m .39167 .60339 L .40051 .61633 L p F P
0 0 0 r
s
.029 .04 .077 r
.60833 .60339 m .59415 .61076 L .58651 .62302 L p F P
0 0 0 r
s
.029 .04 .077 r
.5737 .62963 m .58651 .62302 L .59415 .61076 L p F P
0 0 0 r
s
.804 .216 .086 r
.33927 .5639 m .35495 .57214 L .35082 .55451 L p F P
0 0 0 r
s
.804 .216 .086 r
.35082 .55451 m .33466 .54591 L .33927 .5639 L p F P
0 0 0 r
s
.092 .118 .262 r
.66534 .54591 m .64918 .55451 L .64505 .57214 L p F P
0 0 0 r
s
.092 .118 .262 r
.6296 .58026 m .64505 .57214 L .64918 .55451 L p F P
0 0 0 r
s
.83 .24 .1 r
.73308 .67982 m
.71184 .70094 L
s
.71184 .70094 m
.68471 .68579 L
s
.24 .35 .67 r
.31529 .68579 m
.28816 .70094 L
s
.28816 .70094 m
.26692 .67982 L
s
.024 .035 .067 r
.32464 .43747 m .33702 .4289 L .35332 .415 L p F P
0 0 0 r
s
.83 .24 .1 r
.29448 .40889 m
.32718 .42803 L
s
.024 .035 .067 r
.36471 .4071 m .35332 .415 L .33702 .4289 L p F P
0 0 0 r
s
.24 .35 .67 r
.34519 .42247 m
.35539 .4154 L
s
.35539 .4154 m
.3721 .40727 L
s
.36 .08 .033 r
.64668 .415 m .63529 .4071 L .65042 .4202 L p F P
0 0 0 r
s
.83 .24 .1 r
.64461 .4154 m
.64594 .41632 L
s
.64931 .41865 m
.65815 .42478 L
s
.6279 .40727 m
.64461 .4154 L
s
.36 .08 .033 r
.65042 .4202 m .66298 .4289 L .64668 .415 L p F P
0 0 0 r
s
.31 .467 .903 r
.49303 .33737 m .5 .3326 L .5 .34697 L p F P
0 0 0 r
s
.83 .24 .1 r
.49724 .3466 m
.50244 .35012 L
s
.24 .35 .67 r
.49756 .35012 m
.50276 .3466 L
s
.83 .24 .1 r
.7222 .48571 m
.7274 .5091 L
s
.24 .35 .67 r
.2726 .5091 m
.2778 .48571 L
s
.52787 .32962 m
.54893 .33958 L
s
.58008 .31888 m
.54893 .33958 L
s
.83 .24 .1 r
.45107 .33958 m
.41992 .31888 L
s
.45107 .33958 m
.47213 .32962 L
s
.77553 .59862 m
.74934 .58189 L
s
.77553 .59862 m
.7658 .62726 L
s
.24 .35 .67 r
.2342 .62726 m
.22447 .59862 L
s
.25066 .58189 m
.22447 .59862 L
s
.309 .47 .9 r
.44613 .35903 m .4549 .35297 L .46565 .35611 L p F P
0 0 0 r
s
.309 .47 .9 r
.47242 .35148 m .46565 .35611 L .4549 .35297 L p F P
0 0 0 r
s
.742 .231 .102 r
.53435 .35611 m .52758 .35148 L .53624 .34686 L p F P
0 0 0 r
s
.742 .231 .102 r
.53624 .34686 m .5451 .35297 L .53435 .35611 L p F P
0 0 0 r
s
.252 .058 .024 r
.46368 .65344 m .47289 .65817 L .4679 .65537 L p F P
0 0 0 r
s
.252 .058 .024 r
.4679 .65537 m .45696 .64976 L .46368 .65344 L p F P
0 0 0 r
s
.024 .035 .067 r
.54304 .64976 m .5321 .65537 L .52711 .65817 L p F P
0 0 0 r
s
.024 .035 .067 r
.51799 .66285 m .52711 .65817 L .5321 .65537 L p F P
0 0 0 r
s
.292 .449 .849 r
.40309 .38242 m .41339 .37528 L .42881 .37097 L p F P
0 0 0 r
s
.292 .449 .849 r
.43743 .36502 m .42881 .37097 L .41339 .37528 L p F P
0 0 0 r
s
.549 .179 .082 r
.57119 .37097 m .56257 .36502 L .5762 .36807 L p F P
0 0 0 r
s
.549 .179 .082 r
.5762 .36807 m .58661 .37528 L .57119 .37097 L p F P
0 0 0 r
s
.024 .035 .067 r
.29814 .4629 m .31119 .45391 L .32464 .43747 L p F P
0 0 0 r
s
.83 .24 .1 r
.30729 .48292 m
.3155 .45558 L
s
.28246 .43677 m
.30696 .45072 L
s
.024 .035 .067 r
.33702 .4289 m .32464 .43747 L .31119 .45391 L p F P
0 0 0 r
s
.542 .135 .052 r
.67536 .43747 m .66298 .4289 L .67557 .44479 L p F P
0 0 0 r
s
.542 .135 .052 r
.67557 .44479 m .68881 .45391 L .67536 .43747 L p F P
0 0 0 r
s
.689 .18 .07 r
.36272 .58835 m .37729 .59592 L .3704 .58026 L p F P
0 0 0 r
s
.689 .18 .07 r
.3704 .58026 m .35495 .57214 L .36272 .58835 L p F P
0 0 0 r
s
.83 .24 .1 r
.3682 .56786 m
.3731 .58855 L
s
.062 .08 .171 r
.64505 .57214 m .6296 .58026 L .62271 .59592 L p F P
0 0 0 r
s
.062 .08 .171 r
.60833 .60339 m .62271 .59592 L .6296 .58026 L p F P
0 0 0 r
s
.249 .388 .721 r
.36471 .4071 m .37625 .39909 L .3929 .38948 L p F P
0 0 0 r
s
.249 .388 .721 r
.40309 .38242 m .3929 .38948 L .37625 .39909 L p F P
0 0 0 r
s
.411 .13 .062 r
.6071 .38948 m .59691 .38242 L .61208 .39099 L p F P
0 0 0 r
s
.411 .13 .062 r
.61208 .39099 m .62375 .39909 L .6071 .38948 L p F P
0 0 0 r
s
.175 .246 .506 r
.69488 .49019 m .71146 .48105 L .70186 .4629 L p F P
0 0 0 r
s
.043 .059 .127 r
.31119 .45391 m .29814 .4629 L .28854 .48105 L p F P
0 0 0 r
s
.698 .183 .07 r
.70186 .4629 m .68881 .45391 L .69787 .47178 L p F P
0 0 0 r
s
.698 .183 .07 r
.69787 .47178 m .71146 .48105 L .70186 .4629 L p F P
0 0 0 r
s
.538 .176 .08 r
.49296 .66444 m .5 .66807 L .5 .67208 L p F P
0 0 0 r
s
.83 .24 .1 r
.4898 .66547 m
.49606 .66781 L
s
.538 .176 .08 r
.5 .67208 m .49104 .66749 L .49296 .66444 L p F P
0 0 0 r
s
.24 .35 .67 r
.49679 .67048 m
.49757 .67018 L
s
.49242 .6721 m
.49679 .67048 L
s
.264 .412 .783 r
.50896 .66749 m .5 .67208 L .5 .66807 L p F P
0 0 0 r
s
.24 .35 .67 r
.50392 .66782 m
.5102 .66547 L
s
.83 .24 .1 r
.50243 .67018 m
.50321 .67048 L
s
.50321 .67048 m
.50758 .6721 L
s
.29448 .40889 m
.30946 .3817 L
s
.30946 .3817 m
.27603 .36158 L
s
.30946 .3817 m
.32689 .35611 L
s
.24 .35 .67 r
.67311 .35611 m
.69054 .3817 L
s
.72397 .36158 m
.69054 .3817 L
s
.69054 .3817 m
.70552 .40889 L
s
.931 .257 .105 r
.28397 .5 m .30094 .50919 L .30512 .49019 L p F P
0 0 0 r
s
.931 .257 .105 r
.30512 .49019 m .28854 .48105 L .28397 .5 L p F P
0 0 0 r
s
.83 .24 .1 r
.30292 .5091 m
.30729 .48292 L
s
.24 .35 .67 r
.2778 .48571 m
.29076 .47685 L
s
.83 .24 .1 r
.2934 .47522 m
.30729 .48292 L
s
.153 .212 .442 r
.71146 .48105 m .69488 .49019 L .69906 .50919 L p F P
0 0 0 r
s
.83 .24 .1 r
.70924 .47685 m
.7222 .48571 L
s
.24 .35 .67 r
.69271 .48292 m
.70457 .47635 L
s
.153 .212 .442 r
.68234 .51823 m .69906 .50919 L .69488 .49019 L p F P
0 0 0 r
s
.24 .35 .67 r
.69271 .48292 m
.69708 .5091 L
s
.383 .086 .036 r
.42344 .63255 m .43474 .63835 L .4263 .62963 L p F P
0 0 0 r
s
.383 .086 .036 r
.4263 .62963 m .41349 .62302 L .42344 .63255 L p F P
0 0 0 r
s
.024 .035 .067 r
.58651 .62302 m .5737 .62963 L .56526 .63835 L p F P
0 0 0 r
s
.024 .035 .067 r
.55409 .64409 m .56526 .63835 L .5737 .62963 L p F P
0 0 0 r
s
.24 .35 .67 r
.58008 .31888 m
.60119 .33409 L
s
.63327 .31322 m
.60119 .33409 L
s
.83 .24 .1 r
.39881 .33409 m
.36673 .31322 L
s
.39881 .33409 m
.41992 .31888 L
s
.309 .47 .9 r
.4549 .35297 m .46376 .34686 L .47242 .35148 L p F P
0 0 0 r
s
.309 .47 .9 r
.47925 .34681 m .47242 .35148 L .46376 .34686 L p F P
0 0 0 r
s
.742 .231 .102 r
.52758 .35148 m .52075 .34681 L .52731 .3407 L p F P
0 0 0 r
s
.742 .231 .102 r
.52731 .3407 m .53624 .34686 L .52758 .35148 L p F P
0 0 0 r
s
.83 .24 .1 r
.7514 .65483 m
.73308 .67982 L
s
.73308 .67982 m
.70612 .66427 L
s
.24 .35 .67 r
.29388 .66427 m
.26692 .67982 L
s
.26692 .67982 m
.2486 .65483 L
s
.83 .24 .1 r
.28246 .43677 m
.29448 .40889 L
s
.29448 .40889 m
.26077 .38916 L
s
.24 .35 .67 r
.73923 .38916 m
.70552 .40889 L
s
.70552 .40889 m
.71754 .43677 L
s
.88 .24 .097 r
.3016 .5283 m .31826 .53717 L .31766 .51823 L p F P
0 0 0 r
s
.88 .24 .097 r
.31766 .51823 m .30094 .50919 L .3016 .5283 L p F P
0 0 0 r
s
.83 .24 .1 r
.30292 .5091 m
.33575 .52688 L
s
.126 .17 .362 r
.69906 .50919 m .68234 .51823 L .68174 .53717 L p F P
0 0 0 r
s
.126 .17 .362 r
.66534 .54591 m .68174 .53717 L .68234 .51823 L p F P
0 0 0 r
s
.54 .134 .052 r
.38737 .60956 m .40051 .61633 L .39167 .60339 L p F P
0 0 0 r
s
.54 .134 .052 r
.39167 .60339 m .37729 .59592 L .38737 .60956 L p F P
0 0 0 r
s
.83 .24 .1 r
.3731 .58855 m
.40478 .60509 L
s
.029 .04 .077 r
.62271 .59592 m .60833 .60339 L .59949 .61633 L p F P
0 0 0 r
s
.029 .04 .077 r
.58651 .62302 m .59949 .61633 L .60833 .60339 L p F P
0 0 0 r
s
.83 .24 .1 r
.7658 .62726 m
.73933 .61089 L
s
.7658 .62726 m
.7514 .65483 L
s
.24 .35 .67 r
.2486 .65483 m
.2342 .62726 L
s
.26067 .61089 m
.2342 .62726 L
s
.024 .035 .067 r
.33702 .4289 m .34958 .4202 L .36471 .4071 L p F P
0 0 0 r
s
.024 .035 .067 r
.37625 .39909 m .36471 .4071 L .34958 .4202 L p F P
0 0 0 r
s
.36 .08 .033 r
.63529 .4071 m .62375 .39909 L .6377 .41139 L p F P
0 0 0 r
s
.83 .24 .1 r
.63698 .41011 m
.64461 .4154 L
s
.36 .08 .033 r
.6377 .41139 m .65042 .4202 L .63529 .4071 L p F P
0 0 0 r
s
.83 .24 .1 r
.32689 .35611 m
.29365 .33556 L
s
.32689 .35611 m
.34619 .33301 L
s
.24 .35 .67 r
.65381 .33301 m
.67311 .35611 L
s
.70635 .33556 m
.67311 .35611 L
s
.292 .449 .849 r
.41339 .37528 m .4238 .36807 L .43743 .36502 L p F P
0 0 0 r
s
.292 .449 .849 r
.44613 .35903 m .43743 .36502 L .4238 .36807 L p F P
0 0 0 r
s
.549 .179 .082 r
.56257 .36502 m .55387 .35903 L .56568 .36077 L p F P
0 0 0 r
s
.549 .179 .082 r
.56568 .36077 m .5762 .36807 L .56257 .36502 L p F P
0 0 0 r
s
.83 .24 .1 r
.55229 .36616 m
.5711 .368 L
s
.68471 .68579 m
.6616 .70234 L
s
.6616 .70234 m
.63351 .68711 L
s
.24 .35 .67 r
.36649 .68711 m
.3384 .70234 L
s
.3384 .70234 m
.31529 .68579 L
s
.252 .058 .024 r
.4544 .64867 m .46368 .65344 L .45696 .64976 L p F P
0 0 0 r
s
.252 .058 .024 r
.45696 .64976 m .44591 .64409 L .4544 .64867 L p F P
0 0 0 r
s
.83 .24 .1 r
.44543 .63785 m
.45936 .64983 L
s
.024 .035 .067 r
.55409 .64409 m .54304 .64976 L .53632 .65344 L p F P
0 0 0 r
s
.024 .035 .067 r
.52711 .65817 m .53632 .65344 L .54304 .64976 L p F P
0 0 0 r
s
.24 .35 .67 r
.54064 .64983 m
.55457 .63785 L
s
.804 .216 .086 r
.32335 .55554 m .33927 .5639 L .33466 .54591 L p F P
0 0 0 r
s
.83 .24 .1 r
.33575 .52688 m
.33594 .55074 L
s
.804 .216 .086 r
.33466 .54591 m .31826 .53717 L .32335 .55554 L p F P
0 0 0 r
s
.092 .118 .262 r
.68174 .53717 m .66534 .54591 L .66073 .5639 L p F P
0 0 0 r
s
.092 .118 .262 r
.64505 .57214 m .66073 .5639 L .66534 .54591 L p F P
0 0 0 r
s
.24 .35 .67 r
.66406 .55074 m
.66425 .52688 L
s
.83 .24 .1 r
.7514 .65483 m
.72467 .63885 L
s
.24 .35 .67 r
.27533 .63885 m
.2486 .65483 L
s
.249 .388 .721 r
.37625 .39909 m .38792 .39099 L .40309 .38242 L p F P
0 0 0 r
s
.249 .388 .721 r
.41339 .37528 m .40309 .38242 L .38792 .39099 L p F P
0 0 0 r
s
.411 .13 .062 r
.59691 .38242 m .58661 .37528 L .60025 .38278 L p F P
0 0 0 r
s
.411 .13 .062 r
.60025 .38278 m .61208 .39099 L .59691 .38242 L p F P
0 0 0 r
s
.538 .176 .08 r
.48586 .66079 m .49296 .66444 L .49104 .66749 L p F P
0 0 0 r
s
.538 .176 .08 r
.49104 .66749 m .48201 .66285 L .48586 .66079 L p F P
0 0 0 r
s
.83 .24 .1 r
.45936 .64983 m
.48332 .66214 L
s
.264 .412 .783 r
.51799 .66285 m .50896 .66749 L .50704 .66444 L p F P
0 0 0 r
s
.24 .35 .67 r
.51425 .66339 m
.54064 .64983 L
s
.264 .412 .783 r
.5 .66807 m .50704 .66444 L .50896 .66749 L p F P
0 0 0 r
s
.309 .47 .9 r
.46376 .34686 m .47269 .3407 L .47925 .34681 L p F P
0 0 0 r
s
.309 .47 .9 r
.48611 .34211 m .47925 .34681 L .47269 .3407 L p F P
0 0 0 r
s
.24 .35 .67 r
.47725 .34591 m
.49756 .35012 L
s
.742 .231 .102 r
.52075 .34681 m .51389 .34211 L .51829 .33448 L p F P
0 0 0 r
s
.24 .35 .67 r
.51166 .34058 m
.51675 .33714 L
s
.742 .231 .102 r
.51829 .33448 m .52731 .3407 L .52075 .34681 L p F P
0 0 0 r
s
.24 .35 .67 r
.51948 .3353 m
.52787 .32962 L
s
.83 .24 .1 r
.50244 .35012 m
.52275 .34591 L
s
.75422 .55339 m
.7275 .53583 L
s
.75422 .55339 m
.74934 .58189 L
s
.24 .35 .67 r
.25066 .58189 m
.24578 .55339 L
s
.2725 .53583 m
.24578 .55339 L
s
.024 .035 .067 r
.31119 .45391 m .32443 .44479 L .33702 .4289 L p F P
0 0 0 r
s
.024 .035 .067 r
.34958 .4202 m .33702 .4289 L .32443 .44479 L p F P
0 0 0 r
s
.542 .135 .052 r
.66298 .4289 m .65042 .4202 L .66214 .43554 L p F P
0 0 0 r
s
.83 .24 .1 r
.64694 .41779 m
.65453 .42558 L
s
.542 .135 .052 r
.66214 .43554 m .67557 .44479 L .66298 .4289 L p F P
0 0 0 r
s
.689 .18 .07 r
.34793 .58067 m .36272 .58835 L .35495 .57214 L p F P
0 0 0 r
s
.689 .18 .07 r
.35495 .57214 m .33927 .5639 L .34793 .58067 L p F P
0 0 0 r
s
.83 .24 .1 r
.33594 .55074 m
.3682 .56786 L
s
.062 .08 .171 r
.66073 .5639 m .64505 .57214 L .63728 .58835 L p F P
0 0 0 r
s
.24 .35 .67 r
.6318 .56786 m
.66406 .55074 L
s
.062 .08 .171 r
.62271 .59592 m .63728 .58835 L .64505 .57214 L p F P
0 0 0 r
s
.24 .35 .67 r
.59522 .60509 m
.6269 .58855 L
s
.6269 .58855 m
.6318 .56786 L
s
.83 .24 .1 r
.27387 .46438 m
.28246 .43677 L
s
.28246 .43677 m
.24841 .41737 L
s
.24 .35 .67 r
.75159 .41737 m
.71754 .43677 L
s
.71754 .43677 m
.72613 .46438 L
s
.043 .059 .127 r
.28854 .48105 m .30213 .47178 L .31119 .45391 L p F P
0 0 0 r
s
.043 .059 .127 r
.32443 .44479 m .31119 .45391 L .30213 .47178 L p F P
0 0 0 r
s
.698 .183 .07 r
.68881 .45391 m .67557 .44479 L .68406 .46236 L p F P
0 0 0 r
s
.698 .183 .07 r
.68406 .46236 m .69787 .47178 L .68881 .45391 L p F P
0 0 0 r
s
.83 .24 .1 r
.63351 .68711 m
.6099 .6983 L
s
.6099 .6983 m
.58089 .68294 L
s
.24 .35 .67 r
.41911 .68294 m
.3901 .6983 L
s
.3901 .6983 m
.36649 .68711 L
s
.292 .449 .849 r
.4238 .36807 m .43432 .36077 L .44613 .35903 L p F P
0 0 0 r
s
.24 .35 .67 r
.4289 .368 m
.44771 .36616 L
s
.292 .449 .849 r
.4549 .35297 m .44613 .35903 L .43432 .36077 L p F P
0 0 0 r
s
.24 .35 .67 r
.44771 .36616 m
.47725 .34591 L
s
.549 .179 .082 r
.55387 .35903 m .5451 .35297 L .55503 .3534 L p F P
0 0 0 r
s
.83 .24 .1 r
.52275 .34591 m
.55229 .36616 L
s
.549 .179 .082 r
.55503 .3534 m .56568 .36077 L .55387 .35903 L p F P
0 0 0 r
s
.383 .086 .036 r
.41202 .62669 m .42344 .63255 L .41349 .62302 L p F P
0 0 0 r
s
.83 .24 .1 r
.41434 .6218 m
.44543 .63785 L
s
.383 .086 .036 r
.41349 .62302 m .40051 .61633 L .41202 .62669 L p F P
0 0 0 r
s
.83 .24 .1 r
.40478 .60509 m
.41434 .6218 L
s
.024 .035 .067 r
.59949 .61633 m .58651 .62302 L .57656 .63255 L p F P
0 0 0 r
s
.24 .35 .67 r
.58566 .6218 m
.59522 .60509 L
s
.024 .035 .067 r
.56526 .63835 m .57656 .63255 L .58651 .62302 L p F P
0 0 0 r
s
.24 .35 .67 r
.55457 .63785 m
.58566 .6218 L
s
.83 .24 .1 r
.34619 .33301 m
.31307 .31198 L
s
.34619 .33301 m
.36673 .31322 L
s
.24 .35 .67 r
.63327 .31322 m
.65381 .33301 L
s
.68693 .31198 m
.65381 .33301 L
s
.309 .47 .9 r
.47269 .3407 m .48171 .33448 L .48611 .34211 L p F P
0 0 0 r
s
.83 .24 .1 r
.47213 .32962 m
.48052 .3353 L
s
.48325 .33714 m
.48834 .34058 L
s
.309 .47 .9 r
.49303 .33737 m .48611 .34211 L .48171 .33448 L p F P
0 0 0 r
s
.742 .231 .102 r
.51389 .34211 m .50697 .33737 L .50919 .3282 L p F P
0 0 0 r
s
.742 .231 .102 r
.50919 .3282 m .51829 .33448 L .51389 .34211 L p F P
0 0 0 r
s
.153 .212 .442 r
.69906 .50919 m .71603 .5 L .71146 .48105 L p F P
0 0 0 r
s
.08 .105 .237 r
.30213 .47178 m .28854 .48105 L .28397 .5 L p F P
0 0 0 r
s
.83 .24 .1 r
.27387 .46438 m
.29144 .47413 L
s
.29144 .47413 m
.29238 .47465 L
s
.831 .224 .089 r
.71146 .48105 m .69787 .47178 L .70217 .49067 L p F P
0 0 0 r
s
.24 .35 .67 r
.70856 .47413 m
.72613 .46438 L
s
.70762 .47465 m
.70856 .47413 L
s
.831 .224 .089 r
.70217 .49067 m .71603 .5 L .71146 .48105 L p F P
0 0 0 r
s
.024 .035 .067 r
.34958 .4202 m .3623 .41139 L .37625 .39909 L p F P
0 0 0 r
s
.024 .035 .067 r
.38792 .39099 m .37625 .39909 L .3623 .41139 L p F P
0 0 0 r
s
.24 .35 .67 r
.36987 .40536 m
.38356 .39587 L
s
.36 .08 .033 r
.62375 .39909 m .61208 .39099 L .62479 .40245 L p F P
0 0 0 r
s
.83 .24 .1 r
.59993 .38793 m
.61644 .39587 L
s
.61644 .39587 m
.62102 .39905 L
s
.62448 .40145 m
.63356 .40774 L
s
.36 .08 .033 r
.62479 .40245 m .6377 .41139 L .62375 .39909 L p F P
0 0 0 r
s
.252 .058 .024 r
.44502 .64386 m .4544 .64867 L .44591 .64409 L p F P
0 0 0 r
s
.252 .058 .024 r
.44591 .64409 m .43474 .63835 L .44502 .64386 L p F P
0 0 0 r
s
.024 .035 .067 r
.56526 .63835 m .55409 .64409 L .5456 .64867 L p F P
0 0 0 r
s
.024 .035 .067 r
.53632 .65344 m .5456 .64867 L .55409 .64409 L p F P
0 0 0 r
s
.83 .24 .1 r
.58089 .68294 m
.55812 .68829 L
s
.55812 .68829 m
.52826 .67275 L
s
.24 .35 .67 r
.47174 .67275 m
.44188 .68829 L
s
.44188 .68829 m
.41911 .68294 L
s
.54 .134 .052 r
.37406 .60269 m .38737 .60956 L .37729 .59592 L p F P
0 0 0 r
s
.54 .134 .052 r
.37729 .59592 m .36272 .58835 L .37406 .60269 L p F P
0 0 0 r
s
.029 .04 .077 r
.63728 .58835 m .62271 .59592 L .61263 .60956 L p F P
0 0 0 r
s
.029 .04 .077 r
.59949 .61633 m .61263 .60956 L .62271 .59592 L p F P
0 0 0 r
s
.83 .24 .1 r
.52826 .67275 m
.50758 .6721 L
s
.50149 .66897 m
.50758 .6721 L
s
.24 .35 .67 r
.49242 .6721 m
.49851 .66897 L
s
.49242 .6721 m
.47174 .67275 L
s
.538 .176 .08 r
.47872 .6571 m .48586 .66079 L .48201 .66285 L p F P
0 0 0 r
s
.538 .176 .08 r
.48201 .66285 m .47289 .65817 L .47872 .6571 L p F P
0 0 0 r
s
.264 .412 .783 r
.52711 .65817 m .51799 .66285 L .51414 .66079 L p F P
0 0 0 r
s
.264 .412 .783 r
.50704 .66444 m .51414 .66079 L .51799 .66285 L p F P
0 0 0 r
s
.249 .388 .721 r
.38792 .39099 m .39975 .38278 L .41339 .37528 L p F P
0 0 0 r
s
.24 .35 .67 r
.38356 .39587 m
.40007 .38793 L
s
.249 .388 .721 r
.4238 .36807 m .41339 .37528 L .39975 .38278 L p F P
0 0 0 r
s
.24 .35 .67 r
.40007 .38793 m
.4289 .368 L
s
.411 .13 .062 r
.58661 .37528 m .5762 .36807 L .58828 .37447 L p F P
0 0 0 r
s
.411 .13 .062 r
.58828 .37447 m .60025 .38278 L .58661 .37528 L p F P
0 0 0 r
s
.83 .24 .1 r
.5711 .368 m
.59993 .38793 L
s
.88 .24 .097 r
.28468 .51929 m .3016 .5283 L .30094 .50919 L p F P
0 0 0 r
s
.88 .24 .097 r
.30094 .50919 m .28397 .5 L .28468 .51929 L p F P
0 0 0 r
s
.126 .17 .362 r
.71603 .5 m .69906 .50919 L .6984 .5283 L p F P
0 0 0 r
s
.126 .17 .362 r
.68174 .53717 m .6984 .5283 L .69906 .50919 L p F P
0 0 0 r
s
.24 .35 .67 r
.66425 .52688 m
.69708 .5091 L
s
.83 .24 .1 r
.7154 .50102 m
.7274 .5091 L
s
.7274 .5091 m
.7275 .53583 L
s
.24 .35 .67 r
.2726 .5091 m
.28402 .50142 L
s
.2725 .53583 m
.2726 .5091 L
s
.55912 .30849 m
.52787 .32962 L
s
.83 .24 .1 r
.47213 .32962 m
.44088 .30849 L
s
.804 .216 .086 r
.3072 .54706 m .32335 .55554 L .31826 .53717 L p F P
0 0 0 r
s
.804 .216 .086 r
.31826 .53717 m .3016 .5283 L .3072 .54706 L p F P
0 0 0 r
s
.092 .118 .262 r
.6984 .5283 m .68174 .53717 L .67665 .55554 L p F P
0 0 0 r
s
.092 .118 .262 r
.66073 .5639 m .67665 .55554 L .68174 .53717 L p F P
0 0 0 r
s
.83 .24 .1 r
.70612 .66427 m
.68471 .68579 L
s
.68471 .68579 m
.65674 .67017 L
s
.24 .35 .67 r
.34326 .67017 m
.31529 .68579 L
s
.31529 .68579 m
.29388 .66427 L
s
.292 .449 .849 r
.43432 .36077 m .44497 .3534 L .4549 .35297 L p F P
0 0 0 r
s
.292 .449 .849 r
.46376 .34686 m .4549 .35297 L .44497 .3534 L p F P
0 0 0 r
s
.549 .179 .082 r
.5451 .35297 m .53624 .34686 L .54427 .34594 L p F P
0 0 0 r
s
.549 .179 .082 r
.54427 .34594 m .55503 .3534 L .5451 .35297 L p F P
0 0 0 r
s
.309 .47 .9 r
.48171 .33448 m .49081 .3282 L .49303 .33737 L p F P
0 0 0 r
s
.309 .47 .9 r
.5 .3326 m .49303 .33737 L .49081 .3282 L p F P
0 0 0 r
s
.742 .231 .102 r
.50697 .33737 m .5 .3326 L .5 .32187 L p F P
0 0 0 r
s
.742 .231 .102 r
.5 .32187 m .50919 .3282 L .50697 .33737 L p F P
0 0 0 r
s
.24 .35 .67 r
.50615 .3261 m
.5077 .32504 L
s
.024 .035 .067 r
.32443 .44479 m .33786 .43554 L .34958 .4202 L p F P
0 0 0 r
s
.24 .35 .67 r
.34547 .42558 m
.35306 .41779 L
s
.024 .035 .067 r
.3623 .41139 m .34958 .4202 L .33786 .43554 L p F P
0 0 0 r
s
.542 .135 .052 r
.65042 .4202 m .6377 .41139 L .6485 .42615 L p F P
0 0 0 r
s
.542 .135 .052 r
.6485 .42615 m .66214 .43554 L .65042 .4202 L p F P
0 0 0 r
s
.24 .35 .67 r
.55912 .30849 m
.58008 .31888 L
s
.6122 .29754 m
.58008 .31888 L
s
.83 .24 .1 r
.41992 .31888 m
.3878 .29754 L
s
.41992 .31888 m
.44088 .30849 L
s
.74934 .58189 m
.72233 .56463 L
s
.74934 .58189 m
.73933 .61089 L
s
.24 .35 .67 r
.26067 .61089 m
.25066 .58189 L
s
.27767 .56463 m
.25066 .58189 L
s
.689 .18 .07 r
.33295 .57288 m .34793 .58067 L .33927 .5639 L p F P
0 0 0 r
s
.689 .18 .07 r
.33927 .5639 m .32335 .55554 L .33295 .57288 L p F P
0 0 0 r
s
.83 .24 .1 r
.33594 .55074 m
.34043 .5715 L
s
.062 .08 .171 r
.67665 .55554 m .66073 .5639 L .65207 .58067 L p F P
0 0 0 r
s
.062 .08 .171 r
.63728 .58835 m .65207 .58067 L .66073 .5639 L p F P
0 0 0 r
s
.383 .086 .036 r
.40047 .62076 m .41202 .62669 L .40051 .61633 L p F P
0 0 0 r
s
.383 .086 .036 r
.40051 .61633 m .38737 .60956 L .40047 .62076 L p F P
0 0 0 r
s
.024 .035 .067 r
.61263 .60956 m .59949 .61633 L .58798 .62669 L p F P
0 0 0 r
s
.024 .035 .067 r
.57656 .63255 m .58798 .62669 L .59949 .61633 L p F P
0 0 0 r
s
.538 .176 .08 r
.47152 .6534 m .47872 .6571 L .47289 .65817 L p F P
0 0 0 r
s
.538 .176 .08 r
.47289 .65817 m .46368 .65344 L .47152 .6534 L p F P
0 0 0 r
s
.83 .24 .1 r
.45936 .64983 m
.46907 .65341 L
s
.264 .412 .783 r
.53632 .65344 m .52711 .65817 L .52128 .6571 L p F P
0 0 0 r
s
.264 .412 .783 r
.51414 .66079 m .52128 .6571 L .52711 .65817 L p F P
0 0 0 r
s
.252 .058 .024 r
.43556 .63901 m .44502 .64386 L .43474 .63835 L p F P
0 0 0 r
s
.252 .058 .024 r
.43474 .63835 m .42344 .63255 L .43556 .63901 L p F P
0 0 0 r
s
.024 .035 .067 r
.57656 .63255 m .56526 .63835 L .55498 .64386 L p F P
0 0 0 r
s
.024 .035 .067 r
.5456 .64867 m .55498 .64386 L .56526 .63835 L p F P
0 0 0 r
s
.043 .059 .127 r
.30213 .47178 m .31594 .46236 L .32443 .44479 L p F P
0 0 0 r
s
.043 .059 .127 r
.33786 .43554 m .32443 .44479 L .31594 .46236 L p F P
0 0 0 r
s
.698 .183 .07 r
.67557 .44479 m .66214 .43554 L .67003 .45279 L p F P
0 0 0 r
s
.698 .183 .07 r
.67003 .45279 m .68406 .46236 L .67557 .44479 L p F P
0 0 0 r
s
.83 .24 .1 r
.26907 .49076 m
.27387 .46438 L
s
.27387 .46438 m
.23941 .44527 L
s
.24 .35 .67 r
.76059 .44527 m
.72613 .46438 L
s
.72613 .46438 m
.73093 .49076 L
s
.024 .035 .067 r
.3623 .41139 m .37521 .40245 L .38792 .39099 L p F P
0 0 0 r
s
.024 .035 .067 r
.39975 .38278 m .38792 .39099 L .37521 .40245 L p F P
0 0 0 r
s
.36 .08 .033 r
.61208 .39099 m .60025 .38278 L .61171 .39338 L p F P
0 0 0 r
s
.83 .24 .1 r
.61182 .39267 m
.61644 .39587 L
s
.36 .08 .033 r
.61171 .39338 m .62479 .40245 L .61208 .39099 L p F P
0 0 0 r
s
.249 .388 .721 r
.39975 .38278 m .41172 .37447 L .4238 .36807 L p F P
0 0 0 r
s
.249 .388 .721 r
.43432 .36077 m .4238 .36807 L .41172 .37447 L p F P
0 0 0 r
s
.411 .13 .062 r
.5762 .36807 m .56568 .36077 L .57615 .36605 L p F P
0 0 0 r
s
.411 .13 .062 r
.57615 .36605 m .58828 .37447 L .5762 .36807 L p F P
0 0 0 r
s
.83 .24 .1 r
.5711 .368 m
.58739 .37574 L
s
.309 .47 .9 r
.49081 .3282 m .5 .32187 L .5 .3326 L p F P
0 0 0 r
s
.83 .24 .1 r
.4923 .32504 m
.49385 .3261 L
s
.26077 .38916 m
.27603 .36158 L
s
.27603 .36158 m
.24155 .34083 L
s
.27603 .36158 m
.29365 .33556 L
s
.24 .35 .67 r
.70635 .33556 m
.72397 .36158 L
s
.75845 .34083 m
.72397 .36158 L
s
.72397 .36158 m
.73923 .38916 L
s
.54 .134 .052 r
.36058 .59574 m .37406 .60269 L .36272 .58835 L p F P
0 0 0 r
s
.54 .134 .052 r
.36272 .58835 m .34793 .58067 L .36058 .59574 L p F P
0 0 0 r
s
.83 .24 .1 r
.34043 .5715 m
.3731 .58855 L
s
.029 .04 .077 r
.65207 .58067 m .63728 .58835 L .62594 .60269 L p F P
0 0 0 r
s
.029 .04 .077 r
.61263 .60956 m .62594 .60269 L .63728 .58835 L p F P
0 0 0 r
s
.08 .105 .237 r
.28397 .5 m .29783 .49067 L .30213 .47178 L p F P
0 0 0 r
s
.08 .105 .237 r
.31594 .46236 m .30213 .47178 L .29783 .49067 L p F P
0 0 0 r
s
.831 .224 .089 r
.69787 .47178 m .68406 .46236 L .6881 .48119 L p F P
0 0 0 r
s
.831 .224 .089 r
.6881 .48119 m .70217 .49067 L .69787 .47178 L p F P
0 0 0 r
s
.83 .24 .1 r
.69978 .48906 m
.70014 .49076 L
s
.292 .449 .849 r
.44497 .3534 m .45573 .34594 L .46376 .34686 L p F P
0 0 0 r
s
.292 .449 .849 r
.47269 .3407 m .46376 .34686 L .45573 .34594 L p F P
0 0 0 r
s
.549 .179 .082 r
.53624 .34686 m .52731 .3407 L .53339 .3384 L p F P
0 0 0 r
s
.549 .179 .082 r
.53339 .3384 m .54427 .34594 L .53624 .34686 L p F P
0 0 0 r
s
.83 .24 .1 r
.52275 .34591 m
.54137 .34746 L
s
.24 .35 .67 r
.6122 .29754 m
.63327 .31322 L
s
.66636 .2917 m
.63327 .31322 L
s
.83 .24 .1 r
.36673 .31322 m
.33364 .2917 L
s
.36673 .31322 m
.3878 .29754 L
s
.72467 .63885 m
.70612 .66427 L
s
.70612 .66427 m
.67833 .64822 L
s
.24 .35 .67 r
.32167 .64822 m
.29388 .66427 L
s
.29388 .66427 m
.27533 .63885 L
s
.83 .24 .1 r
.24841 .41737 m
.26077 .38916 L
s
.26077 .38916 m
.22601 .36881 L
s
.24 .35 .67 r
.77399 .36881 m
.73923 .38916 L
s
.73923 .38916 m
.75159 .41737 L
s
.126 .17 .362 r
.6984 .5283 m .71532 .51929 L .71603 .5 L p F P
0 0 0 r
s
.116 .157 .342 r
.29783 .49067 m .28397 .5 L .28468 .51929 L p F P
0 0 0 r
s
.83 .24 .1 r
.26907 .49076 m
.28493 .49935 L
s
.29206 .50322 m
.30292 .5091 L
s
.24 .35 .67 r
.29685 .49279 m
.29986 .49076 L
s
.916 .251 .101 r
.71603 .5 m .70217 .49067 L .7015 .51014 L p F P
0 0 0 r
s
.83 .24 .1 r
.70014 .49076 m
.70213 .4921 L
s
.24 .35 .67 r
.69708 .5091 m
.70162 .50664 L
s
.71507 .49935 m
.73093 .49076 L
s
.916 .251 .101 r
.7015 .51014 m .71532 .51929 L .71603 .5 L p F P
0 0 0 r
s
.83 .24 .1 r
.73933 .61089 m
.71204 .594 L
s
.73933 .61089 m
.72467 .63885 L
s
.24 .35 .67 r
.27533 .63885 m
.26067 .61089 L
s
.28796 .594 m
.26067 .61089 L
s
.83 .24 .1 r
.29365 .33556 m
.25938 .31435 L
s
.29365 .33556 m
.31307 .31198 L
s
.24 .35 .67 r
.68693 .31198 m
.70635 .33556 L
s
.74062 .31435 m
.70635 .33556 L
s
.83 .24 .1 r
.65674 .67017 m
.63351 .68711 L
s
.63351 .68711 m
.60454 .6714 L
s
.24 .35 .67 r
.39546 .6714 m
.36649 .68711 L
s
.36649 .68711 m
.34326 .67017 L
s
.538 .176 .08 r
.46427 .64966 m .47152 .6534 L .46368 .65344 L p F P
0 0 0 r
s
.538 .176 .08 r
.46368 .65344 m .4544 .64867 L .46427 .64966 L p F P
0 0 0 r
s
.264 .412 .783 r
.5456 .64867 m .53632 .65344 L .52848 .6534 L p F P
0 0 0 r
s
.24 .35 .67 r
.53833 .65068 m
.54064 .64983 L
s
.264 .412 .783 r
.52128 .6571 m .52848 .6534 L .53632 .65344 L p F P
0 0 0 r
s
.804 .216 .086 r
.29081 .53845 m .3072 .54706 L .3016 .5283 L p F P
0 0 0 r
s
.83 .24 .1 r
.30268 .5331 m
.30292 .5091 L
s
.804 .216 .086 r
.3016 .5283 m .28468 .51929 L .29081 .53845 L p F P
0 0 0 r
s
.092 .118 .262 r
.71532 .51929 m .6984 .5283 L .6928 .54706 L p F P
0 0 0 r
s
.092 .118 .262 r
.67665 .55554 m .6928 .54706 L .6984 .5283 L p F P
0 0 0 r
s
.24 .35 .67 r
.69708 .5091 m
.69732 .5331 L
s
.024 .035 .067 r
.33786 .43554 m .3515 .42615 L .3623 .41139 L p F P
0 0 0 r
s
.024 .035 .067 r
.37521 .40245 m .3623 .41139 L .3515 .42615 L p F P
0 0 0 r
s
.542 .135 .052 r
.6377 .41139 m .62479 .40245 L .63466 .41661 L p F P
0 0 0 r
s
.542 .135 .052 r
.63466 .41661 m .6485 .42615 L .6377 .41139 L p F P
0 0 0 r
s
.83 .24 .1 r
.72467 .63885 m
.69711 .62238 L
s
.24 .35 .67 r
.30289 .62238 m
.27533 .63885 L
s
.742 .233 .103 r
.49512 .65714 m .5 .65968 L .5 .66807 L p F P
0 0 0 r
s
.742 .233 .103 r
.5 .66807 m .49296 .66444 L .49512 .65714 L p F P
0 0 0 r
s
.292 .449 .863 r
.50704 .66444 m .5 .66807 L .5 .65968 L p F P
0 0 0 r
s
.252 .058 .024 r
.42601 .63411 m .43556 .63901 L .42344 .63255 L p F P
0 0 0 r
s
.252 .058 .024 r
.42344 .63255 m .41202 .62669 L .42601 .63411 L p F P
0 0 0 r
s
.83 .24 .1 r
.41434 .6218 m
.42798 .6337 L
s
.024 .035 .067 r
.58798 .62669 m .57656 .63255 L .56444 .63901 L p F P
0 0 0 r
s
.024 .035 .067 r
.55498 .64386 m .56444 .63901 L .57656 .63255 L p F P
0 0 0 r
s
.24 .35 .67 r
.57202 .6337 m
.58566 .6218 L
s
.383 .086 .036 r
.38879 .61476 m .40047 .62076 L .38737 .60956 L p F P
0 0 0 r
s
.383 .086 .036 r
.38737 .60956 m .37406 .60269 L .38879 .61476 L p F P
0 0 0 r
s
.83 .24 .1 r
.3823 .60526 m
.41434 .6218 L
s
.3731 .58855 m
.3823 .60526 L
s
.024 .035 .067 r
.62594 .60269 m .61263 .60956 L .59953 .62076 L p F P
0 0 0 r
s
.24 .35 .67 r
.6177 .60526 m
.6269 .58855 L
s
.024 .035 .067 r
.58798 .62669 m .59953 .62076 L .61263 .60956 L p F P
0 0 0 r
s
.24 .35 .67 r
.58566 .6218 m
.6177 .60526 L
s
.83 .24 .1 r
.7275 .53583 m
.72233 .56463 L
s
.24 .35 .67 r
.27767 .56463 m
.2725 .53583 L
s
.689 .18 .07 r
.31775 .56498 m .33295 .57288 L .32335 .55554 L p F P
0 0 0 r
s
.689 .18 .07 r
.32335 .55554 m .3072 .54706 L .31775 .56498 L p F P
0 0 0 r
s
.83 .24 .1 r
.30268 .5331 m
.33594 .55074 L
s
.062 .08 .171 r
.6928 .54706 m .67665 .55554 L .66705 .57288 L p F P
0 0 0 r
s
.24 .35 .67 r
.66406 .55074 m
.69732 .5331 L
s
.062 .08 .171 r
.65207 .58067 m .66705 .57288 L .67665 .55554 L p F P
0 0 0 r
s
.24 .35 .67 r
.6269 .58855 m
.65957 .5715 L
s
.65957 .5715 m
.66406 .55074 L
s
.249 .388 .721 r
.41172 .37447 m .42385 .36605 L .43432 .36077 L p F P
0 0 0 r
s
.24 .35 .67 r
.41261 .37574 m
.4289 .368 L
s
.249 .388 .721 r
.44497 .3534 m .43432 .36077 L .42385 .36605 L p F P
0 0 0 r
s
.411 .13 .062 r
.56568 .36077 m .55503 .3534 L .56387 .35752 L p F P
0 0 0 r
s
.411 .13 .062 r
.56387 .35752 m .57615 .36605 L .56568 .36077 L p F P
0 0 0 r
s
.292 .449 .849 r
.45573 .34594 m .46661 .3384 L .47269 .3407 L p F P
0 0 0 r
s
.24 .35 .67 r
.45863 .34746 m
.47725 .34591 L
s
.292 .449 .849 r
.48171 .33448 m .47269 .3407 L .46661 .3384 L p F P
0 0 0 r
s
.24 .35 .67 r
.47725 .34591 m
.50151 .32928 L
s
.549 .179 .082 r
.52731 .3407 m .51829 .33448 L .52239 .33077 L p F P
0 0 0 r
s
.549 .179 .082 r
.52239 .33077 m .53339 .3384 L .52731 .3407 L p F P
0 0 0 r
s
.83 .24 .1 r
.49849 .32928 m
.52275 .34591 L
s
.024 .035 .067 r
.37521 .40245 m .38829 .39338 L .39975 .38278 L p F P
0 0 0 r
s
.024 .035 .067 r
.41172 .37447 m .39975 .38278 L .38829 .39338 L p F P
0 0 0 r
s
.24 .35 .67 r
.39522 .38779 m
.41261 .37574 L
s
.36 .08 .033 r
.60025 .38278 m .58828 .37447 L .59844 .38419 L p F P
0 0 0 r
s
.83 .24 .1 r
.58739 .37574 m
.59542 .3813 L
s
.36 .08 .033 r
.59844 .38419 m .61171 .39338 L .60025 .38278 L p F P
0 0 0 r
s
.043 .059 .127 r
.31594 .46236 m .32997 .45279 L .33786 .43554 L p F P
0 0 0 r
s
.043 .059 .127 r
.3515 .42615 m .33786 .43554 L .32997 .45279 L p F P
0 0 0 r
s
.698 .183 .07 r
.66214 .43554 m .6485 .42615 L .65579 .44307 L p F P
0 0 0 r
s
.698 .183 .07 r
.65579 .44307 m .67003 .45279 L .66214 .43554 L p F P
0 0 0 r
s
.83 .24 .1 r
.23941 .44527 m
.24841 .41737 L
s
.24841 .41737 m
.21328 .39737 L
s
.24 .35 .67 r
.78672 .39737 m
.75159 .41737 L
s
.75159 .41737 m
.76059 .44527 L
s
.83 .24 .1 r
.60454 .6714 m
.58089 .68294 L
s
.58089 .68294 m
.55097 .6671 L
s
.24 .35 .67 r
.44903 .6671 m
.41911 .68294 L
s
.41911 .68294 m
.39546 .6714 L
s
.54 .134 .052 r
.34692 .58871 m .36058 .59574 L .34793 .58067 L p F P
0 0 0 r
s
.54 .134 .052 r
.34793 .58067 m .33295 .57288 L .34692 .58871 L p F P
0 0 0 r
s
.029 .04 .077 r
.66705 .57288 m .65207 .58067 L .63942 .59574 L p F P
0 0 0 r
s
.029 .04 .077 r
.62594 .60269 m .63942 .59574 L .65207 .58067 L p F P
0 0 0 r
s
.742 .233 .103 r
.49021 .65459 m .49512 .65714 L .49296 .66444 L p F P
0 0 0 r
s
.742 .233 .103 r
.49296 .66444 m .48586 .66079 L .49021 .65459 L p F P
0 0 0 r
s
.292 .449 .863 r
.51414 .66079 m .50704 .66444 L .50488 .65714 L p F P
0 0 0 r
s
.292 .449 .863 r
.5 .65968 m .50488 .65714 L .50704 .66444 L p F P
0 0 0 r
s
.538 .176 .08 r
.45697 .6459 m .46427 .64966 L .4544 .64867 L p F P
0 0 0 r
s
.538 .176 .08 r
.4544 .64867 m .44502 .64386 L .45697 .6459 L p F P
0 0 0 r
s
.83 .24 .1 r
.42798 .6337 m
.44911 .64456 L
s
.264 .412 .783 r
.55498 .64386 m .5456 .64867 L .53573 .64966 L p F P
0 0 0 r
s
.24 .35 .67 r
.54064 .64983 m
.54223 .64901 L
s
.54837 .64585 m
.57202 .6337 L
s
.264 .412 .783 r
.52848 .6534 m .53573 .64966 L .5456 .64867 L p F P
0 0 0 r
s
.83 .24 .1 r
.31307 .31198 m
.27891 .29029 L
s
.31307 .31198 m
.33364 .2917 L
s
.24 .35 .67 r
.66636 .2917 m
.68693 .31198 L
s
.72109 .29029 m
.68693 .31198 L
s
.08 .105 .237 r
.29783 .49067 m .3119 .48119 L .31594 .46236 L p F P
0 0 0 r
s
.24 .35 .67 r
.29986 .49076 m
.30022 .48906 L
s
.08 .105 .237 r
.32997 .45279 m .31594 .46236 L .3119 .48119 L p F P
0 0 0 r
s
.831 .224 .089 r
.68406 .46236 m .67003 .45279 L .67379 .47156 L p F P
0 0 0 r
s
.831 .224 .089 r
.67379 .47156 m .6881 .48119 L .68406 .46236 L p F P
0 0 0 r
s
.83 .24 .1 r
.55097 .6671 m
.52826 .67275 L
s
.50721 .6618 m
.52826 .67275 L
s
.24 .35 .67 r
.47174 .67275 m
.49279 .6618 L
s
.49279 .6618 m
.49713 .65954 L
s
.47174 .67275 m
.44903 .6671 L
s
.83 .24 .1 r
.23416 .47185 m
.26907 .49076 L
s
.26838 .5149 m
.26907 .49076 L
s
.24 .35 .67 r
.76584 .47185 m
.73093 .49076 L
s
.73093 .49076 m
.73162 .5149 L
s
.116 .157 .342 r
.28468 .51929 m .2985 .51014 L .29783 .49067 L p F P
0 0 0 r
s
.116 .157 .342 r
.3119 .48119 m .29783 .49067 L .2985 .51014 L p F P
0 0 0 r
s
.916 .251 .101 r
.70217 .49067 m .6881 .48119 L .68746 .50085 L p F P
0 0 0 r
s
.916 .251 .101 r
.68746 .50085 m .7015 .51014 L .70217 .49067 L p F P
0 0 0 r
s
.252 .058 .024 r
.41637 .62916 m .42601 .63411 L .41202 .62669 L p F P
0 0 0 r
s
.252 .058 .024 r
.41202 .62669 m .40047 .62076 L .41637 .62916 L p F P
0 0 0 r
s
.024 .035 .067 r
.59953 .62076 m .58798 .62669 L .57399 .63411 L p F P
0 0 0 r
s
.024 .035 .067 r
.56444 .63901 m .57399 .63411 L .58798 .62669 L p F P
0 0 0 r
s
.292 .449 .849 r
.46661 .3384 m .47761 .33077 L .48171 .33448 L p F P
0 0 0 r
s
.292 .449 .849 r
.49081 .3282 m .48171 .33448 L .47761 .33077 L p F P
0 0 0 r
s
.83 .24 .1 r
.47213 .32962 m
.4923 .32504 L
s
.549 .179 .082 r
.51829 .33448 m .50919 .3282 L .51126 .32305 L p F P
0 0 0 r
s
.24 .35 .67 r
.5077 .32504 m
.51023 .32561 L
s
.51325 .3263 m
.52787 .32962 L
s
.549 .179 .082 r
.51126 .32305 m .52239 .33077 L .51829 .33448 L p F P
0 0 0 r
s
.24 .35 .67 r
.50487 .32523 m
.5077 .32504 L
s
.83 .24 .1 r
.4923 .32504 m
.49513 .32523 L
s
.024 .035 .067 r
.3515 .42615 m .36534 .41661 L .37521 .40245 L p F P
0 0 0 r
s
.024 .035 .067 r
.38829 .39338 m .37521 .40245 L .36534 .41661 L p F P
0 0 0 r
s
.542 .135 .052 r
.62479 .40245 m .61171 .39338 L .62061 .40693 L p F P
0 0 0 r
s
.542 .135 .052 r
.62061 .40693 m .63466 .41661 L .62479 .40245 L p F P
0 0 0 r
s
.24 .35 .67 r
.53912 .3035 m
.55912 .30849 L
s
.59135 .28669 m
.55912 .30849 L
s
.83 .24 .1 r
.44088 .30849 m
.40865 .28669 L
s
.44088 .30849 m
.46088 .3035 L
s
.249 .388 .721 r
.42385 .36605 m .43613 .35752 L .44497 .3534 L p F P
0 0 0 r
s
.249 .388 .721 r
.45573 .34594 m .44497 .3534 L .43613 .35752 L p F P
0 0 0 r
s
.24 .35 .67 r
.4289 .368 m
.45863 .34746 L
s
.411 .13 .062 r
.55503 .3534 m .54427 .34594 L .55143 .34889 L p F P
0 0 0 r
s
.411 .13 .062 r
.55143 .34889 m .56387 .35752 L .55503 .3534 L p F P
0 0 0 r
s
.83 .24 .1 r
.54137 .34746 m
.5711 .368 L
s
.383 .086 .036 r
.37698 .6087 m .38879 .61476 L .37406 .60269 L p F P
0 0 0 r
s
.383 .086 .036 r
.37406 .60269 m .36058 .59574 L .37698 .6087 L p F P
0 0 0 r
s
.024 .035 .067 r
.63942 .59574 m .62594 .60269 L .61121 .61476 L p F P
0 0 0 r
s
.024 .035 .067 r
.59953 .62076 m .61121 .61476 L .62594 .60269 L p F P
0 0 0 r
s
.092 .118 .262 r
.6928 .54706 m .70919 .53845 L .71532 .51929 L p F P
0 0 0 r
s
.148 .206 .436 r
.2985 .51014 m .28468 .51929 L .29081 .53845 L p F P
0 0 0 r
s
.83 .24 .1 r
.26838 .5149 m
.28642 .52447 L
s
.28642 .52447 m
.28738 .52498 L
s
.29358 .52826 m
.30268 .5331 L
s
.24 .35 .67 r
.2725 .53583 m
.28678 .52645 L
s
.28678 .52645 m
.28694 .52634 L
s
.971 .27 .11 r
.71532 .51929 m .7015 .51014 L .69572 .52971 L p F P
0 0 0 r
s
.971 .27 .11 r
.69572 .52971 m .70919 .53845 L .71532 .51929 L p F P
0 0 0 r
s
.24 .35 .67 r
.69732 .5331 m
.69931 .53204 L
s
.71262 .52498 m
.71358 .52447 L
s
.71358 .52447 m
.73162 .5149 L
s
.83 .24 .1 r
.71322 .52645 m
.7275 .53583 L
s
.71306 .52634 m
.71322 .52645 L
s
.742 .233 .103 r
.48528 .65203 m .49021 .65459 L .48586 .66079 L p F P
0 0 0 r
s
.742 .233 .103 r
.48586 .66079 m .47872 .6571 L .48528 .65203 L p F P
0 0 0 r
s
.83 .24 .1 r
.47718 .65631 m
.47967 .65636 L
s
.292 .449 .863 r
.52128 .6571 m .51414 .66079 L .50979 .65459 L p F P
0 0 0 r
s
.24 .35 .67 r
.5181 .65641 m
.52282 .65631 L
s
.292 .449 .863 r
.50488 .65714 m .50979 .65459 L .51414 .66079 L p F P
0 0 0 r
s
.83 .24 .1 r
.50287 .65954 m
.50721 .6618 L
s
.67833 .64822 m
.65674 .67017 L
s
.65674 .67017 m
.62788 .65406 L
s
.24 .35 .67 r
.37212 .65406 m
.34326 .67017 L
s
.34326 .67017 m
.32167 .64822 L
s
.024 .035 .067 r
.38829 .39338 m .40156 .38419 L .41172 .37447 L p F P
0 0 0 r
s
.024 .035 .067 r
.42385 .36605 m .41172 .37447 L .40156 .38419 L p F P
0 0 0 r
s
.36 .08 .033 r
.58828 .37447 m .57615 .36605 L .58498 .37487 L p F P
0 0 0 r
s
.36 .08 .033 r
.58498 .37487 m .59844 .38419 L .58828 .37447 L p F P
0 0 0 r
s
.538 .176 .08 r
.44961 .64211 m .45697 .6459 L .44502 .64386 L p F P
0 0 0 r
s
.538 .176 .08 r
.44502 .64386 m .43556 .63901 L .44961 .64211 L p F P
0 0 0 r
s
.264 .412 .783 r
.56444 .63901 m .55498 .64386 L .54303 .6459 L p F P
0 0 0 r
s
.264 .412 .783 r
.53573 .64966 m .54303 .6459 L .55498 .64386 L p F P
0 0 0 r
s
.24 .35 .67 r
.59135 .28669 m
.6122 .29754 L
s
.64533 .27553 m
.6122 .29754 L
s
.83 .24 .1 r
.3878 .29754 m
.35467 .27553 L
s
.3878 .29754 m
.40865 .28669 L
s
.689 .18 .07 r
.30233 .55697 m .31775 .56498 L .3072 .54706 L p F P
0 0 0 r
s
.689 .18 .07 r
.3072 .54706 m .29081 .53845 L .30233 .55697 L p F P
0 0 0 r
s
.062 .08 .171 r
.70919 .53845 m .6928 .54706 L .68225 .56498 L p F P
0 0 0 r
s
.062 .08 .171 r
.66705 .57288 m .68225 .56498 L .6928 .54706 L p F P
0 0 0 r
s
.83 .24 .1 r
.72233 .56463 m
.71204 .594 L
s
.24 .35 .67 r
.28796 .594 m
.27767 .56463 L
s
.043 .059 .127 r
.32997 .45279 m .34421 .44307 L .3515 .42615 L p F P
0 0 0 r
s
.043 .059 .127 r
.36534 .41661 m .3515 .42615 L .34421 .44307 L p F P
0 0 0 r
s
.698 .183 .07 r
.6485 .42615 m .63466 .41661 L .64132 .4332 L p F P
0 0 0 r
s
.698 .183 .07 r
.64132 .4332 m .65579 .44307 L .6485 .42615 L p F P
0 0 0 r
s
.54 .134 .052 r
.3331 .58158 m .34692 .58871 L .33295 .57288 L p F P
0 0 0 r
s
.83 .24 .1 r
.34043 .5715 m
.34925 .58819 L
s
.54 .134 .052 r
.33295 .57288 m .31775 .56498 L .3331 .58158 L p F P
0 0 0 r
s
.029 .04 .077 r
.68225 .56498 m .66705 .57288 L .65308 .58871 L p F P
0 0 0 r
s
.029 .04 .077 r
.63942 .59574 m .65308 .58871 L .66705 .57288 L p F P
0 0 0 r
s
.83 .24 .1 r
.23416 .47185 m
.23941 .44527 L
s
.23941 .44527 m
.20385 .42555 L
s
.24 .35 .67 r
.79615 .42555 m
.76059 .44527 L
s
.76059 .44527 m
.76584 .47185 L
s
.742 .233 .103 r
.48032 .64945 m .48528 .65203 L .47872 .6571 L p F P
0 0 0 r
s
.742 .233 .103 r
.47872 .6571 m .47152 .6534 L .48032 .64945 L p F P
0 0 0 r
s
.292 .449 .863 r
.52848 .6534 m .52128 .6571 L .51472 .65203 L p F P
0 0 0 r
s
.292 .449 .863 r
.50979 .65459 m .51472 .65203 L .52128 .6571 L p F P
0 0 0 r
s
.292 .449 .849 r
.47761 .33077 m .48874 .32305 L .49081 .3282 L p F P
0 0 0 r
s
.292 .449 .849 r
.5 .32187 m .49081 .3282 L .48874 .32305 L p F P
0 0 0 r
s
.549 .179 .082 r
.50919 .3282 m .5 .32187 L .5 .31525 L p F P
0 0 0 r
s
.549 .179 .082 r
.5 .31525 m .51126 .32305 L .50919 .3282 L p F P
0 0 0 r
s
.24 .35 .67 r
.51093 .32283 m
.53912 .3035 L
s
.48929 .32626 m
.50249 .32538 L
s
.83 .24 .1 r
.49751 .32538 m
.51071 .32626 L
s
.252 .058 .024 r
.40665 .62416 m .41637 .62916 L .40047 .62076 L p F P
0 0 0 r
s
.252 .058 .024 r
.40047 .62076 m .38879 .61476 L .40665 .62416 L p F P
0 0 0 r
s
.024 .035 .067 r
.61121 .61476 m .59953 .62076 L .58363 .62916 L p F P
0 0 0 r
s
.024 .035 .067 r
.57399 .63411 m .58363 .62916 L .59953 .62076 L p F P
0 0 0 r
s
.83 .24 .1 r
.22601 .36881 m
.24155 .34083 L
s
.24155 .34083 m
.20598 .31942 L
s
.24155 .34083 m
.25938 .31435 L
s
.24 .35 .67 r
.74062 .31435 m
.75845 .34083 L
s
.79402 .31942 m
.75845 .34083 L
s
.75845 .34083 m
.77399 .36881 L
s
.08 .105 .237 r
.3119 .48119 m .32621 .47156 L .32997 .45279 L p F P
0 0 0 r
s
.08 .105 .237 r
.34421 .44307 m .32997 .45279 L .32621 .47156 L p F P
0 0 0 r
s
.831 .224 .089 r
.67003 .45279 m .65579 .44307 L .65926 .46178 L p F P
0 0 0 r
s
.831 .224 .089 r
.65926 .46178 m .67379 .47156 L .67003 .45279 L p F P
0 0 0 r
s
.83 .24 .1 r
.67168 .47014 m
.67202 .47185 L
s
.249 .388 .721 r
.43613 .35752 m .44857 .34889 L .45573 .34594 L p F P
0 0 0 r
s
.249 .388 .721 r
.46661 .3384 m .45573 .34594 L .44857 .34889 L p F P
0 0 0 r
s
.411 .13 .062 r
.54427 .34594 m .53339 .3384 L .53882 .34014 L p F P
0 0 0 r
s
.411 .13 .062 r
.53882 .34014 m .55143 .34889 L .54427 .34594 L p F P
0 0 0 r
s
.24 .35 .67 r
.64533 .27553 m
.66636 .2917 L
s
.70049 .2695 m
.66636 .2917 L
s
.83 .24 .1 r
.33364 .2917 m
.29951 .2695 L
s
.33364 .2917 m
.35467 .27553 L
s
.538 .176 .08 r
.44221 .63829 m .44961 .64211 L .43556 .63901 L p F P
0 0 0 r
s
.538 .176 .08 r
.43556 .63901 m .42601 .63411 L .44221 .63829 L p F P
0 0 0 r
s
.83 .24 .1 r
.42798 .6337 m
.43659 .63684 L
s
.264 .412 .783 r
.57399 .63411 m .56444 .63901 L .55039 .64211 L p F P
0 0 0 r
s
.264 .412 .783 r
.54303 .6459 m .55039 .64211 L .56444 .63901 L p F P
0 0 0 r
s
.83 .24 .1 r
.69711 .62238 m
.67833 .64822 L
s
.67833 .64822 m
.64966 .63167 L
s
.24 .35 .67 r
.35034 .63167 m
.32167 .64822 L
s
.32167 .64822 m
.30289 .62238 L
s
.383 .086 .036 r
.36504 .60257 m .37698 .6087 L .36058 .59574 L p F P
0 0 0 r
s
.383 .086 .036 r
.36058 .59574 m .34692 .58871 L .36504 .60257 L p F P
0 0 0 r
s
.83 .24 .1 r
.34925 .58819 m
.3823 .60526 L
s
.024 .035 .067 r
.65308 .58871 m .63942 .59574 L .62302 .6087 L p F P
0 0 0 r
s
.024 .035 .067 r
.61121 .61476 m .62302 .6087 L .63942 .59574 L p F P
0 0 0 r
s
.24 .35 .67 r
.6177 .60526 m
.65075 .58819 L
s
.83 .24 .1 r
.21328 .39737 m
.22601 .36881 L
s
.22601 .36881 m
.19014 .34782 L
s
.24 .35 .67 r
.80986 .34782 m
.77399 .36881 L
s
.77399 .36881 m
.78672 .39737 L
s
.024 .035 .067 r
.36534 .41661 m .37939 .40693 L .38829 .39338 L p F P
0 0 0 r
s
.024 .035 .067 r
.40156 .38419 m .38829 .39338 L .37939 .40693 L p F P
0 0 0 r
s
.542 .135 .052 r
.61171 .39338 m .59844 .38419 L .60634 .39711 L p F P
0 0 0 r
s
.542 .135 .052 r
.60634 .39711 m .62061 .40693 L .61171 .39338 L p F P
0 0 0 r
s
.116 .157 .342 r
.2985 .51014 m .31254 .50085 L .3119 .48119 L p F P
0 0 0 r
s
.116 .157 .342 r
.32621 .47156 m .3119 .48119 L .31254 .50085 L p F P
0 0 0 r
s
.24 .35 .67 r
.32519 .47373 m
.32798 .47185 L
s
.916 .251 .101 r
.6881 .48119 m .67379 .47156 L .6732 .49141 L p F P
0 0 0 r
s
.83 .24 .1 r
.67202 .47185 m
.67375 .47302 L
s
.68701 .48194 m
.68805 .48263 L
s
.916 .251 .101 r
.6732 .49141 m .68746 .50085 L .6881 .48119 L p F P
0 0 0 r
s
.83 .24 .1 r
.71204 .594 m
.69711 .62238 L
s
.24 .35 .67 r
.30289 .62238 m
.28796 .594 L
s
.31613 .57657 m
.28796 .594 L
s
.83 .24 .1 r
.25938 .31435 m
.22401 .29248 L
s
.25938 .31435 m
.27891 .29029 L
s
.24 .35 .67 r
.72109 .29029 m
.74062 .31435 L
s
.77599 .29248 m
.74062 .31435 L
s
.742 .233 .103 r
.47534 .64686 m .48032 .64945 L .47152 .6534 L p F P
0 0 0 r
s
.742 .233 .103 r
.47152 .6534 m .46427 .64966 L .47534 .64686 L p F P
0 0 0 r
s
.292 .449 .863 r
.53573 .64966 m .52848 .6534 L .51968 .64945 L p F P
0 0 0 r
s
.292 .449 .863 r
.51472 .65203 m .51968 .64945 L .52848 .6534 L p F P
0 0 0 r
s
.83 .24 .1 r
.62788 .65406 m
.60454 .6714 L
s
.60454 .6714 m
.57465 .6552 L
s
.24 .35 .67 r
.42535 .6552 m
.39546 .6714 L
s
.39546 .6714 m
.37212 .65406 L
s
.024 .035 .067 r
.40156 .38419 m .41502 .37487 L .42385 .36605 L p F P
0 0 0 r
s
.024 .035 .067 r
.43613 .35752 m .42385 .36605 L .41502 .37487 L p F P
0 0 0 r
s
.36 .08 .033 r
.57615 .36605 m .56387 .35752 L .57132 .36541 L p F P
0 0 0 r
s
.36 .08 .033 r
.57132 .36541 m .58498 .37487 L .57615 .36605 L p F P
0 0 0 r
s
.148 .206 .436 r
.29081 .53845 m .30428 .52971 L .2985 .51014 L p F P
0 0 0 r
s
.148 .206 .436 r
.31254 .50085 m .2985 .51014 L .30428 .52971 L p F P
0 0 0 r
s
.971 .27 .11 r
.7015 .51014 m .68746 .50085 L .68205 .52083 L p F P
0 0 0 r
s
.971 .27 .11 r
.68205 .52083 m .69572 .52971 L .7015 .51014 L p F P
0 0 0 r
s
.83 .24 .1 r
.69711 .62238 m
.66867 .60538 L
s
.24 .35 .67 r
.33133 .60538 m
.30289 .62238 L
s
.292 .449 .849 r
.48874 .32305 m .5 .31525 L .5 .32187 L p F P
0 0 0 r
s
.83 .24 .1 r
.46088 .3035 m
.48907 .32283 L
s
.062 .08 .171 r
.68225 .56498 m .69767 .55697 L .70919 .53845 L p F P
0 0 0 r
s
.173 .246 .511 r
.30428 .52971 m .29081 .53845 L .30233 .55697 L p F P
0 0 0 r
s
.83 .24 .1 r
.30367 .53818 m
.30674 .55392 L
s
.24 .35 .67 r
.27767 .56463 m
.29757 .55191 L
s
.29757 .55191 m
.29872 .55117 L
s
1 .283 .116 r
.70919 .53845 m .69572 .52971 L .68486 .54885 L p F P
0 0 0 r
s
1 .283 .116 r
.68486 .54885 m .69767 .55697 L .70919 .53845 L p F P
0 0 0 r
s
.83 .24 .1 r
.70128 .55117 m
.70243 .55191 L
s
.70243 .55191 m
.72233 .56463 L
s
.252 .058 .024 r
.39683 .61912 m .40665 .62416 L .38879 .61476 L p F P
0 0 0 r
s
.252 .058 .024 r
.38879 .61476 m .37698 .6087 L .39683 .61912 L p F P
0 0 0 r
s
.83 .24 .1 r
.3823 .60526 m
.39562 .61706 L
s
.024 .035 .067 r
.62302 .6087 m .61121 .61476 L .59335 .62416 L p F P
0 0 0 r
s
.024 .035 .067 r
.58363 .62916 m .59335 .62416 L .61121 .61476 L p F P
0 0 0 r
s
.24 .35 .67 r
.60438 .61706 m
.6177 .60526 L
s
.043 .059 .127 r
.34421 .44307 m .35868 .4332 L .36534 .41661 L p F P
0 0 0 r
s
.043 .059 .127 r
.37939 .40693 m .36534 .41661 L .35868 .4332 L p F P
0 0 0 r
s
.698 .183 .07 r
.63466 .41661 m .62061 .40693 L .62662 .42317 L p F P
0 0 0 r
s
.698 .183 .07 r
.62662 .42317 m .64132 .4332 L .63466 .41661 L p F P
0 0 0 r
s
.54 .134 .052 r
.31909 .57435 m .3331 .58158 L .31775 .56498 L p F P
0 0 0 r
s
.54 .134 .052 r
.31775 .56498 m .30233 .55697 L .31909 .57435 L p F P
0 0 0 r
s
.83 .24 .1 r
.30674 .55392 m
.34043 .5715 L
s
.029 .04 .077 r
.69767 .55697 m .68225 .56498 L .6669 .58158 L p F P
0 0 0 r
s
.029 .04 .077 r
.65308 .58871 m .6669 .58158 L .68225 .56498 L p F P
0 0 0 r
s
.24 .35 .67 r
.65957 .5715 m
.69303 .55403 L
s
.65075 .58819 m
.65957 .5715 L
s
.538 .176 .08 r
.43475 .63445 m .44221 .63829 L .42601 .63411 L p F P
0 0 0 r
s
.538 .176 .08 r
.42601 .63411 m .41637 .62916 L .43475 .63445 L p F P
0 0 0 r
s
.83 .24 .1 r
.39562 .61706 m
.42267 .63097 L
s
.264 .412 .783 r
.58363 .62916 m .57399 .63411 L .55779 .63829 L p F P
0 0 0 r
s
.24 .35 .67 r
.57475 .6323 m
.60438 .61706 L
s
.264 .412 .783 r
.55039 .64211 m .55779 .63829 L .57399 .63411 L p F P
0 0 0 r
s
.249 .388 .721 r
.44857 .34889 m .46118 .34014 L .46661 .3384 L p F P
0 0 0 r
s
.249 .388 .721 r
.47761 .33077 m .46661 .3384 L .46118 .34014 L p F P
0 0 0 r
s
.24 .35 .67 r
.45863 .34746 m
.48929 .32626 L
s
.411 .13 .062 r
.53339 .3384 m .52239 .33077 L .52605 .33127 L p F P
0 0 0 r
s
.411 .13 .062 r
.52605 .33127 m .53882 .34014 L .53339 .3384 L p F P
0 0 0 r
s
.83 .24 .1 r
.51071 .32626 m
.54137 .34746 L
s
.742 .233 .103 r
.47033 .64426 m .47534 .64686 L .46427 .64966 L p F P
0 0 0 r
s
.742 .233 .103 r
.46427 .64966 m .45697 .6459 L .47033 .64426 L p F P
0 0 0 r
s
.292 .449 .863 r
.54303 .6459 m .53573 .64966 L .52466 .64686 L p F P
0 0 0 r
s
.292 .449 .863 r
.51968 .64945 m .52466 .64686 L .53573 .64966 L p F P
0 0 0 r
s
.83 .24 .1 r
.20385 .42555 m
.21328 .39737 L
s
.21328 .39737 m
.17704 .37673 L
s
.24 .35 .67 r
.82296 .37673 m
.78672 .39737 L
s
.78672 .39737 m
.79615 .42555 L
s
.83 .24 .1 r
.27198 .53577 m
.29702 .54884 L
s
.29702 .54884 m
.29901 .54988 L
s
.3027 .55181 m
.30674 .55392 L
s
.24 .35 .67 r
.70298 .54884 m
.72802 .53577 L
s
.70099 .54988 m
.70298 .54884 L
s
.83 .24 .1 r
.57465 .6552 m
.55097 .6671 L
s
.52009 .65076 m
.55097 .6671 L
s
.24 .35 .67 r
.44903 .6671 m
.47991 .65076 L
s
.44903 .6671 m
.42535 .6552 L
s
.83 .24 .1 r
.27198 .53577 m
.26838 .5149 L
s
.26838 .5149 m
.23298 .49611 L
s
.24 .35 .67 r
.76702 .49611 m
.73162 .5149 L
s
.73162 .5149 m
.72802 .53577 L
s
.887 .271 .117 r
.49748 .64553 m .5 .64685 L .5 .65968 L p F P
0 0 0 r
s
.24 .35 .67 r
.49843 .65886 m
.49973 .65818 L
s
.83 .24 .1 r
.5 .65804 m
.50157 .65886 L
s
.887 .271 .117 r
.5 .65968 m .49512 .65714 L .49748 .64553 L p F P
0 0 0 r
s
.83 .24 .1 r
.49418 .65665 m
.49521 .65667 L
s
.298 .454 .881 r
.50488 .65714 m .5 .65968 L .5 .64685 L p F P
0 0 0 r
s
.24 .35 .67 r
.50466 .65668 m
.50582 .65665 L
s
.383 .086 .036 r
.35296 .59636 m .36504 .60257 L .34692 .58871 L p F P
0 0 0 r
s
.383 .086 .036 r
.34692 .58871 m .3331 .58158 L .35296 .59636 L p F P
0 0 0 r
s
.024 .035 .067 r
.6669 .58158 m .65308 .58871 L .63496 .60257 L p F P
0 0 0 r
s
.024 .035 .067 r
.62302 .6087 m .63496 .60257 L .65308 .58871 L p F P
0 0 0 r
s
.83 .24 .1 r
.27891 .29029 m
.24366 .26791 L
s
.27891 .29029 m
.29951 .2695 L
s
.24 .35 .67 r
.70049 .2695 m
.72109 .29029 L
s
.75634 .26791 m
.72109 .29029 L
s
.08 .105 .237 r
.32621 .47156 m .34074 .46178 L .34421 .44307 L p F P
0 0 0 r
s
.24 .35 .67 r
.32798 .47185 m
.32832 .47014 L
s
.08 .105 .237 r
.35868 .4332 m .34421 .44307 L .34074 .46178 L p F P
0 0 0 r
s
.831 .224 .089 r
.65579 .44307 m .64132 .4332 L .6445 .45183 L p F P
0 0 0 r
s
.831 .224 .089 r
.6445 .45183 m .65926 .46178 L .65579 .44307 L p F P
0 0 0 r
s
.024 .035 .067 r
.37939 .40693 m .39366 .39711 L .40156 .38419 L p F P
0 0 0 r
s
.024 .035 .067 r
.41502 .37487 m .40156 .38419 L .39366 .39711 L p F P
0 0 0 r
s
.542 .135 .052 r
.59844 .38419 m .58498 .37487 L .59185 .38713 L p F P
0 0 0 r
s
.542 .135 .052 r
.59185 .38713 m .60634 .39711 L .59844 .38419 L p F P
0 0 0 r
s
.024 .035 .067 r
.41502 .37487 m .42868 .36541 L .43613 .35752 L p F P
0 0 0 r
s
.024 .035 .067 r
.44857 .34889 m .43613 .35752 L .42868 .36541 L p F P
0 0 0 r
s
.24 .35 .67 r
.43457 .36052 m
.44258 .35496 L
s
.44258 .35496 m
.45863 .34746 L
s
.36 .08 .033 r
.56387 .35752 m .55143 .34889 L .55747 .35582 L p F P
0 0 0 r
s
.83 .24 .1 r
.54137 .34746 m
.55625 .35442 L
s
.36 .08 .033 r
.55747 .35582 m .57132 .36541 L .56387 .35752 L p F P
0 0 0 r
s
.83 .24 .1 r
.19813 .45234 m
.23416 .47185 L
s
.23298 .49611 m
.23416 .47185 L
s
.24 .35 .67 r
.80187 .45234 m
.76584 .47185 L
s
.76584 .47185 m
.76702 .49611 L
s
.742 .233 .103 r
.4653 .64165 m .47033 .64426 L .45697 .6459 L p F P
0 0 0 r
s
.742 .233 .103 r
.45697 .6459 m .44961 .64211 L .4653 .64165 L p F P
0 0 0 r
s
.292 .449 .863 r
.55039 .64211 m .54303 .6459 L .52967 .64426 L p F P
0 0 0 r
s
.292 .449 .863 r
.52466 .64686 m .52967 .64426 L .54303 .6459 L p F P
0 0 0 r
s
.116 .157 .342 r
.31254 .50085 m .3268 .49141 L .32621 .47156 L p F P
0 0 0 r
s
.116 .157 .342 r
.34074 .46178 m .32621 .47156 L .3268 .49141 L p F P
0 0 0 r
s
.916 .251 .101 r
.67379 .47156 m .65926 .46178 L .65872 .48182 L p F P
0 0 0 r
s
.916 .251 .101 r
.65872 .48182 m .6732 .49141 L .67379 .47156 L p F P
0 0 0 r
s
.24 .35 .67 r
.52094 .30438 m
.53912 .3035 L
s
.57154 .28128 m
.53912 .3035 L
s
.83 .24 .1 r
.46088 .3035 m
.42846 .28128 L
s
.46088 .3035 m
.47906 .30438 L
s
.887 .271 .117 r
.49496 .6442 m .49748 .64553 L .49512 .65714 L p F P
0 0 0 r
s
.887 .271 .117 r
.49512 .65714 m .49021 .65459 L .49496 .6442 L p F P
0 0 0 r
s
.298 .454 .881 r
.50979 .65459 m .50488 .65714 L .50252 .64553 L p F P
0 0 0 r
s
.24 .35 .67 r
.50426 .65583 m
.50458 .65566 L
s
.298 .454 .881 r
.5 .64685 m .50252 .64553 L .50488 .65714 L p F P
0 0 0 r
s
.538 .176 .08 r
.42723 .63057 m .43475 .63445 L .41637 .62916 L p F P
0 0 0 r
s
.538 .176 .08 r
.41637 .62916 m .40665 .62416 L .42723 .63057 L p F P
0 0 0 r
s
.264 .412 .783 r
.59335 .62416 m .58363 .62916 L .56525 .63445 L p F P
0 0 0 r
s
.264 .412 .783 r
.55779 .63829 m .56525 .63445 L .58363 .62916 L p F P
0 0 0 r
s
.24 .35 .67 r
.57154 .28128 m
.59135 .28669 L
s
.62461 .26419 m
.59135 .28669 L
s
.83 .24 .1 r
.40865 .28669 m
.37539 .26419 L
s
.40865 .28669 m
.42846 .28128 L
s
.252 .058 .024 r
.38691 .61403 m .39683 .61912 L .37698 .6087 L p F P
0 0 0 r
s
.252 .058 .024 r
.37698 .6087 m .36504 .60257 L .38691 .61403 L p F P
0 0 0 r
s
.024 .035 .067 r
.63496 .60257 m .62302 .6087 L .60317 .61912 L p F P
0 0 0 r
s
.024 .035 .067 r
.59335 .62416 m .60317 .61912 L .62302 .6087 L p F P
0 0 0 r
s
.24 .35 .67 r
.48929 .32626 m
.50124 .318 L
s
.83 .24 .1 r
.49876 .318 m
.51071 .32626 L
s
.148 .206 .436 r
.30428 .52971 m .31795 .52083 L .31254 .50085 L p F P
0 0 0 r
s
.148 .206 .436 r
.3268 .49141 m .31254 .50085 L .31795 .52083 L p F P
0 0 0 r
s
.971 .27 .11 r
.68746 .50085 m .6732 .49141 L .66816 .51182 L p F P
0 0 0 r
s
.971 .27 .11 r
.66816 .51182 m .68205 .52083 L .68746 .50085 L p F P
0 0 0 r
s
.83 .24 .1 r
.64966 .63167 m
.62788 .65406 L
s
.62788 .65406 m
.5981 .63743 L
s
.24 .35 .67 r
.4019 .63743 m
.37212 .65406 L
s
.37212 .65406 m
.35034 .63167 L
s
.249 .388 .721 r
.46118 .34014 m .47395 .33127 L .47761 .33077 L p F P
0 0 0 r
s
.249 .388 .721 r
.48874 .32305 m .47761 .33077 L .47395 .33127 L p F P
0 0 0 r
s
.411 .13 .062 r
.52239 .33077 m .51126 .32305 L .51311 .32229 L p F P
0 0 0 r
s
.411 .13 .062 r
.51311 .32229 m .52605 .33127 L .52239 .33077 L p F P
0 0 0 r
s
.173 .246 .511 r
.30233 .55697 m .31514 .54885 L .30428 .52971 L p F P
0 0 0 r
s
.173 .246 .511 r
.31795 .52083 m .30428 .52971 L .31514 .54885 L p F P
0 0 0 r
s
1 .283 .116 r
.69572 .52971 m .68205 .52083 L .67187 .54061 L p F P
0 0 0 r
s
1 .283 .116 r
.67187 .54061 m .68486 .54885 L .69572 .52971 L p F P
0 0 0 r
s
.24 .35 .67 r
.62461 .26419 m
.64533 .27553 L
s
.67953 .2528 m
.64533 .27553 L
s
.83 .24 .1 r
.35467 .27553 m
.32047 .2528 L
s
.35467 .27553 m
.37539 .26419 L
s
.887 .271 .117 r
.49243 .64287 m .49496 .6442 L .49021 .65459 L p F P
0 0 0 r
s
.887 .271 .117 r
.49021 .65459 m .48528 .65203 L .49243 .64287 L p F P
0 0 0 r
s
.24 .35 .67 r
.49192 .65392 m
.49431 .65455 L
s
.298 .454 .881 r
.51472 .65203 m .50979 .65459 L .50504 .6442 L p F P
0 0 0 r
s
.24 .35 .67 r
.50886 .65343 m
.50919 .65326 L
s
.298 .454 .881 r
.50252 .64553 m .50504 .6442 L .50979 .65459 L p F P
0 0 0 r
s
.83 .24 .1 r
.50569 .65455 m
.50808 .65392 L
s
.029 .04 .077 r
.6669 .58158 m .68091 .57435 L .69767 .55697 L p F P
0 0 0 r
s
.83 .24 .1 r
.68387 .57657 m
.71204 .594 L
s
.194 .28 .573 r
.31514 .54885 m .30233 .55697 L .31909 .57435 L p F P
0 0 0 r
s
.83 .24 .1 r
.31236 .56506 m
.31393 .56818 L
s
1 .292 .121 r
.69767 .55697 m .68486 .54885 L .66909 .56704 L p F P
0 0 0 r
s
1 .292 .121 r
.66909 .56704 m .68091 .57435 L .69767 .55697 L p F P
0 0 0 r
s
.24 .35 .67 r
.68607 .56818 m
.68764 .56506 L
s
.68486 .57058 m
.68607 .56818 L
s
.83 .24 .1 r
.68387 .57657 m
.68686 .56819 L
s
.24 .35 .67 r
.31314 .56819 m
.31613 .57657 L
s
.043 .059 .127 r
.35868 .4332 m .37338 .42317 L .37939 .40693 L p F P
0 0 0 r
s
.043 .059 .127 r
.39366 .39711 m .37939 .40693 L .37338 .42317 L p F P
0 0 0 r
s
.698 .183 .07 r
.62061 .40693 m .60634 .39711 L .61168 .41298 L p F P
0 0 0 r
s
.698 .183 .07 r
.61168 .41298 m .62662 .42317 L .62061 .40693 L p F P
0 0 0 r
s
.742 .233 .103 r
.46024 .63902 m .4653 .64165 L .44961 .64211 L p F P
0 0 0 r
s
.742 .233 .103 r
.44961 .64211 m .44221 .63829 L .46024 .63902 L p F P
0 0 0 r
s
.292 .449 .863 r
.55779 .63829 m .55039 .64211 L .5347 .64165 L p F P
0 0 0 r
s
.292 .449 .863 r
.52967 .64426 m .5347 .64165 L .55039 .64211 L p F P
0 0 0 r
s
.383 .086 .036 r
.34074 .59009 m .35296 .59636 L .3331 .58158 L p F P
0 0 0 r
s
.383 .086 .036 r
.3331 .58158 m .31909 .57435 L .34074 .59009 L p F P
0 0 0 r
s
.024 .035 .067 r
.68091 .57435 m .6669 .58158 L .64704 .59636 L p F P
0 0 0 r
s
.024 .035 .067 r
.63496 .60257 m .64704 .59636 L .6669 .58158 L p F P
0 0 0 r
s
.24 .35 .67 r
.65075 .58819 m
.67938 .57341 L
s
.83 .24 .1 r
.19813 .45234 m
.20385 .42555 L
s
.20385 .42555 m
.16716 .40519 L
s
.24 .35 .67 r
.83284 .40519 m
.79615 .42555 L
s
.79615 .42555 m
.80187 .45234 L
s
.538 .176 .08 r
.41966 .62667 m .42723 .63057 L .40665 .62416 L p F P
0 0 0 r
s
.538 .176 .08 r
.40665 .62416 m .39683 .61912 L .41966 .62667 L p F P
0 0 0 r
s
.264 .412 .783 r
.60317 .61912 m .59335 .62416 L .57277 .63057 L p F P
0 0 0 r
s
.264 .412 .783 r
.56525 .63445 m .57277 .63057 L .59335 .62416 L p F P
0 0 0 r
s
.887 .271 .117 r
.48989 .64153 m .49243 .64287 L .48528 .65203 L p F P
0 0 0 r
s
.887 .271 .117 r
.48528 .65203 m .48032 .64945 L .48989 .64153 L p F P
0 0 0 r
s
.24 .35 .67 r
.47991 .65076 m
.49192 .65392 L
s
.298 .454 .881 r
.51968 .64945 m .51472 .65203 L .50757 .64287 L p F P
0 0 0 r
s
.24 .35 .67 r
.51349 .65103 m
.51381 .65086 L
s
.298 .454 .881 r
.50504 .6442 m .50757 .64287 L .51472 .65203 L p F P
0 0 0 r
s
.83 .24 .1 r
.50808 .65392 m
.52009 .65076 L
s
.024 .035 .067 r
.42868 .36541 m .44253 .35582 L .44857 .34889 L p F P
0 0 0 r
s
.024 .035 .067 r
.46118 .34014 m .44857 .34889 L .44253 .35582 L p F P
0 0 0 r
s
.36 .08 .033 r
.55143 .34889 m .53882 .34014 L .54342 .34608 L p F P
0 0 0 r
s
.36 .08 .033 r
.54342 .34608 m .55747 .35582 L .55143 .34889 L p F P
0 0 0 r
s
.024 .035 .067 r
.39366 .39711 m .40815 .38713 L .41502 .37487 L p F P
0 0 0 r
s
.024 .035 .067 r
.42868 .36541 m .41502 .37487 L .40815 .38713 L p F P
0 0 0 r
s
.542 .135 .052 r
.58498 .37487 m .57132 .36541 L .57714 .377 L p F P
0 0 0 r
s
.542 .135 .052 r
.57714 .377 m .59185 .38713 L .58498 .37487 L p F P
0 0 0 r
s
.83 .24 .1 r
.20598 .31942 m
.19014 .34782 L
s
.22401 .29248 m
.20598 .31942 L
s
.24 .35 .67 r
.77599 .29248 m
.79402 .31942 L
s
.79402 .31942 m
.80986 .34782 L
s
.08 .105 .237 r
.34074 .46178 m .3555 .45183 L .35868 .4332 L p F P
0 0 0 r
s
.08 .105 .237 r
.37338 .42317 m .35868 .4332 L .3555 .45183 L p F P
0 0 0 r
s
.831 .224 .089 r
.64132 .4332 m .62662 .42317 L .62949 .44173 L p F P
0 0 0 r
s
.831 .224 .089 r
.62949 .44173 m .6445 .45183 L .64132 .4332 L p F P
0 0 0 r
s
.83 .24 .1 r
.64268 .45061 m
.64299 .45234 L
s
.252 .058 .024 r
.3769 .6089 m .38691 .61403 L .36504 .60257 L p F P
0 0 0 r
s
.252 .058 .024 r
.36504 .60257 m .35296 .59636 L .3769 .6089 L p F P
0 0 0 r
s
.024 .035 .067 r
.64704 .59636 m .63496 .60257 L .61309 .61403 L p F P
0 0 0 r
s
.024 .035 .067 r
.60317 .61912 m .61309 .61403 L .63496 .60257 L p F P
0 0 0 r
s
.24 .35 .67 r
.67953 .2528 m
.70049 .2695 L
s
.73573 .24658 m
.70049 .2695 L
s
.83 .24 .1 r
.29951 .2695 m
.26427 .24658 L
s
.29951 .2695 m
.32047 .2528 L
s
.66867 .60538 m
.64966 .63167 L
s
.24 .35 .67 r
.35034 .63167 m
.33133 .60538 L
s
.742 .233 .103 r
.45516 .63638 m .46024 .63902 L .44221 .63829 L p F P
0 0 0 r
s
.742 .233 .103 r
.44221 .63829 m .43475 .63445 L .45516 .63638 L p F P
0 0 0 r
s
.292 .449 .863 r
.56525 .63445 m .55779 .63829 L .53976 .63902 L p F P
0 0 0 r
s
.292 .449 .863 r
.5347 .64165 m .53976 .63902 L .55779 .63829 L p F P
0 0 0 r
s
.83 .24 .1 r
.19014 .34782 m
.17704 .37673 L
s
.24 .35 .67 r
.80986 .34782 m
.82296 .37673 L
s
.249 .388 .721 r
.47395 .33127 m .48689 .32229 L .48874 .32305 L p F P
0 0 0 r
s
.249 .388 .721 r
.5 .31525 m .48874 .32305 L .48689 .32229 L p F P
0 0 0 r
s
.411 .13 .062 r
.51126 .32305 m .5 .31525 L .5 .31319 L p F P
0 0 0 r
s
.411 .13 .062 r
.5 .31319 m .51311 .32229 L .51126 .32305 L p F P
0 0 0 r
s
.24 .35 .67 r
.50409 .31603 m
.52094 .30438 L
s
.887 .271 .117 r
.48735 .6402 m .48989 .64153 L .48032 .64945 L p F P
0 0 0 r
s
.887 .271 .117 r
.48032 .64945 m .47534 .64686 L .48735 .6402 L p F P
0 0 0 r
s
.298 .454 .881 r
.52466 .64686 m .51968 .64945 L .51011 .64153 L p F P
0 0 0 r
s
.24 .35 .67 r
.51813 .64861 m
.51846 .64844 L
s
.298 .454 .881 r
.50757 .64287 m .51011 .64153 L .51968 .64945 L p F P
0 0 0 r
s
.83 .24 .1 r
.68061 .57455 m
.68387 .57657 L
s
.66867 .60538 m
.68387 .57657 L
s
.24 .35 .67 r
.31613 .57657 m
.33133 .60538 L
s
.31613 .57657 m
.31938 .57456 L
s
.916 .251 .101 r
.65926 .46178 m .6445 .45183 L .644 .47207 L p F P
0 0 0 r
s
.83 .24 .1 r
.64299 .45234 m
.64446 .45332 L
s
.65815 .46253 m
.65922 .46325 L
s
.916 .251 .101 r
.644 .47207 m .65872 .48182 L .65926 .46178 L p F P
0 0 0 r
s
.116 .157 .342 r
.3268 .49141 m .34128 .48182 L .34074 .46178 L p F P
0 0 0 r
s
.116 .157 .342 r
.3555 .45183 m .34074 .46178 L .34128 .48182 L p F P
0 0 0 r
s
.24 .35 .67 r
.35445 .45405 m
.35701 .45234 L
s
.83 .24 .1 r
.24366 .26791 m
.22401 .29248 L
s
.24 .35 .67 r
.75634 .26791 m
.77599 .29248 L
s
.83 .24 .1 r
.57465 .6552 m
.5981 .63743 L
s
.24 .35 .67 r
.42535 .6552 m
.4019 .63743 L
s
.148 .206 .436 r
.31795 .52083 m .33184 .51182 L .3268 .49141 L p F P
0 0 0 r
s
.148 .206 .436 r
.34128 .48182 m .3268 .49141 L .33184 .51182 L p F P
0 0 0 r
s
.971 .27 .11 r
.6732 .49141 m .65872 .48182 L .65406 .50267 L p F P
0 0 0 r
s
.971 .27 .11 r
.65406 .50267 m .66816 .51182 L .6732 .49141 L p F P
0 0 0 r
s
.173 .246 .511 r
.31514 .54885 m .32813 .54061 L .31795 .52083 L p F P
0 0 0 r
s
.173 .246 .511 r
.33184 .51182 m .31795 .52083 L .32813 .54061 L p F P
0 0 0 r
s
1 .283 .116 r
.68205 .52083 m .66816 .51182 L .6587 .53225 L p F P
0 0 0 r
s
1 .283 .116 r
.6587 .53225 m .67187 .54061 L .68205 .52083 L p F P
0 0 0 r
s
.538 .176 .08 r
.41203 .62274 m .41966 .62667 L .39683 .61912 L p F P
0 0 0 r
s
.538 .176 .08 r
.39683 .61912 m .38691 .61403 L .41203 .62274 L p F P
0 0 0 r
s
.264 .412 .783 r
.61309 .61403 m .60317 .61912 L .58034 .62667 L p F P
0 0 0 r
s
.264 .412 .783 r
.57277 .63057 m .58034 .62667 L .60317 .61912 L p F P
0 0 0 r
s
.194 .28 .573 r
.31909 .57435 m .33091 .56704 L .31514 .54885 L p F P
0 0 0 r
s
.83 .24 .1 r
.32062 .57341 m
.34925 .58819 L
s
.31393 .56818 m
.31514 .57058 L
s
.194 .28 .573 r
.32813 .54061 m .31514 .54885 L .33091 .56704 L p F P
0 0 0 r
s
1 .292 .121 r
.68486 .54885 m .67187 .54061 L .65711 .55962 L p F P
0 0 0 r
s
1 .292 .121 r
.65711 .55962 m .66909 .56704 L .68486 .54885 L p F P
0 0 0 r
s
.887 .271 .117 r
.4848 .63885 m .48735 .6402 L .47534 .64686 L p F P
0 0 0 r
s
.887 .271 .117 r
.47534 .64686 m .47033 .64426 L .4848 .63885 L p F P
0 0 0 r
s
.298 .454 .881 r
.52967 .64426 m .52466 .64686 L .51265 .6402 L p F P
0 0 0 r
s
.24 .35 .67 r
.5228 .64618 m
.52313 .64601 L
s
.298 .454 .881 r
.51011 .64153 m .51265 .6402 L .52466 .64686 L p F P
0 0 0 r
s
.742 .233 .103 r
.45005 .63373 m .45516 .63638 L .43475 .63445 L p F P
0 0 0 r
s
.742 .233 .103 r
.43475 .63445 m .42723 .63057 L .45005 .63373 L p F P
0 0 0 r
s
.292 .449 .863 r
.57277 .63057 m .56525 .63445 L .54484 .63638 L p F P
0 0 0 r
s
.292 .449 .863 r
.53976 .63902 m .54484 .63638 L .56525 .63445 L p F P
0 0 0 r
s
.043 .059 .127 r
.37338 .42317 m .38832 .41298 L .39366 .39711 L p F P
0 0 0 r
s
.043 .059 .127 r
.40815 .38713 m .39366 .39711 L .38832 .41298 L p F P
0 0 0 r
s
.698 .183 .07 r
.60634 .39711 m .59185 .38713 L .5965 .40262 L p F P
0 0 0 r
s
.698 .183 .07 r
.5965 .40262 m .61168 .41298 L .60634 .39711 L p F P
0 0 0 r
s
.024 .035 .067 r
.64704 .59636 m .65926 .59009 L .68091 .57435 L p F P
0 0 0 r
s
.213 .308 .627 r
.33091 .56704 m .31909 .57435 L .34074 .59009 L p F P
0 0 0 r
s
.83 .24 .1 r
.31514 .57058 m
.31936 .57276 L
s
.31936 .57276 m
.31953 .57285 L
s
1 .299 .124 r
.68091 .57435 m .66909 .56704 L .64874 .58375 L p F P
0 0 0 r
s
.24 .35 .67 r
.68064 .57276 m
.68486 .57058 L
s
.68047 .57285 m
.68064 .57276 L
s
1 .299 .124 r
.64874 .58375 m .65926 .59009 L .68091 .57435 L p F P
0 0 0 r
s
.024 .035 .067 r
.44253 .35582 m .45658 .34608 L .46118 .34014 L p F P
0 0 0 r
s
.024 .035 .067 r
.47395 .33127 m .46118 .34014 L .45658 .34608 L p F P
0 0 0 r
s
.24 .35 .67 r
.46173 .34169 m
.47351 .33352 L
s
.47351 .33352 m
.48929 .32626 L
s
.36 .08 .033 r
.53882 .34014 m .52605 .33127 L .52916 .3362 L p F P
0 0 0 r
s
.83 .24 .1 r
.52649 .33352 m
.52823 .33473 L
s
.51071 .32626 m
.52649 .33352 L
s
.36 .08 .033 r
.52916 .3362 m .54342 .34608 L .53882 .34014 L p F P
0 0 0 r
s
.83 .24 .1 r
.17704 .37673 m
.16716 .40519 L
s
.24 .35 .67 r
.82296 .37673 m
.83284 .40519 L
s
.252 .058 .024 r
.3668 .60371 m .3769 .6089 L .35296 .59636 L p F P
0 0 0 r
s
.252 .058 .024 r
.35296 .59636 m .34074 .59009 L .3668 .60371 L p F P
0 0 0 r
s
.83 .24 .1 r
.34925 .58819 m
.36221 .59989 L
s
.36221 .59989 m
.39554 .61703 L
s
.024 .035 .067 r
.65926 .59009 m .64704 .59636 L .6231 .6089 L p F P
0 0 0 r
s
.024 .035 .067 r
.61309 .61403 m .6231 .6089 L .64704 .59636 L p F P
0 0 0 r
s
.24 .35 .67 r
.60438 .61706 m
.63779 .59989 L
s
.63779 .59989 m
.65075 .58819 L
s
.83 .24 .1 r
.27992 .5524 m
.27198 .53577 L
s
.27198 .53577 m
.23608 .51703 L
s
.24 .35 .67 r
.76392 .51703 m
.72802 .53577 L
s
.72802 .53577 m
.72008 .5524 L
s
.887 .271 .117 r
.48224 .63751 m .4848 .63885 L .47033 .64426 L p F P
0 0 0 r
s
.887 .271 .117 r
.47033 .64426 m .4653 .64165 L .48224 .63751 L p F P
0 0 0 r
s
.83 .24 .1 r
.46566 .64018 m
.46747 .64112 L
s
.46242 .64015 m
.46566 .64018 L
s
.298 .454 .881 r
.5347 .64165 m .52967 .64426 L .5152 .63885 L p F P
0 0 0 r
s
.24 .35 .67 r
.52749 .64374 m
.52782 .64357 L
s
.5322 .64129 m
.53434 .64018 L
s
.53434 .64018 m
.53758 .64015 L
s
.298 .454 .881 r
.51265 .6402 m .5152 .63885 L .52967 .64426 L p F P
0 0 0 r
s
.83 .24 .1 r
.50743 .64406 m
.52009 .65076 L
s
.24 .35 .67 r
.47991 .65076 m
.49257 .64406 L
s
.024 .035 .067 r
.40815 .38713 m .42286 .377 L .42868 .36541 L p F P
0 0 0 r
s
.024 .035 .067 r
.44253 .35582 m .42868 .36541 L .42286 .377 L p F P
0 0 0 r
s
.542 .135 .052 r
.57132 .36541 m .55747 .35582 L .56219 .3667 L p F P
0 0 0 r
s
.542 .135 .052 r
.56219 .3667 m .57714 .377 L .57132 .36541 L p F P
0 0 0 r
s
.249 .388 .721 r
.48689 .32229 m .5 .31319 L .5 .31525 L p F P
0 0 0 r
s
.83 .24 .1 r
.47906 .30438 m
.49591 .31603 L
s
.23608 .51703 m
.23298 .49611 L
s
.23298 .49611 m
.19643 .47672 L
s
.24 .35 .67 r
.80357 .47672 m
.76702 .49611 L
s
.76702 .49611 m
.76392 .51703 L
s
.83 .24 .1 r
.31514 .57058 m
.32772 .58217 L
s
.27992 .5524 m
.31514 .57058 L
s
.24 .35 .67 r
.68486 .57058 m
.72008 .5524 L
s
.67228 .58217 m
.68486 .57058 L
s
.83 .24 .1 r
.26427 .24658 m
.24366 .26791 L
s
.24 .35 .67 r
.73573 .24658 m
.75634 .26791 L
s
.08 .105 .237 r
.3555 .45183 m .37051 .44173 L .37338 .42317 L p F P
0 0 0 r
s
.24 .35 .67 r
.35701 .45234 m
.35732 .45061 L
s
.08 .105 .237 r
.38832 .41298 m .37338 .42317 L .37051 .44173 L p F P
0 0 0 r
s
.831 .224 .089 r
.62662 .42317 m .61168 .41298 L .61423 .43146 L p F P
0 0 0 r
s
.831 .224 .089 r
.61423 .43146 m .62949 .44173 L .62662 .42317 L p F P
0 0 0 r
s
.742 .233 .103 r
.44492 .63106 m .45005 .63373 L .42723 .63057 L p F P
0 0 0 r
s
.742 .233 .103 r
.42723 .63057 m .41966 .62667 L .44492 .63106 L p F P
0 0 0 r
s
.292 .449 .863 r
.58034 .62667 m .57277 .63057 L .54995 .63373 L p F P
0 0 0 r
s
.292 .449 .863 r
.54484 .63638 m .54995 .63373 L .57277 .63057 L p F P
0 0 0 r
s
.538 .176 .08 r
.40435 .61878 m .41203 .62274 L .38691 .61403 L p F P
0 0 0 r
s
.538 .176 .08 r
.38691 .61403 m .3769 .6089 L .40435 .61878 L p F P
0 0 0 r
s
.264 .412 .783 r
.6231 .6089 m .61309 .61403 L .58797 .62274 L p F P
0 0 0 r
s
.264 .412 .783 r
.58034 .62667 m .58797 .62274 L .61309 .61403 L p F P
0 0 0 r
s
.887 .271 .117 r
.47968 .63616 m .48224 .63751 L .4653 .64165 L p F P
0 0 0 r
s
.887 .271 .117 r
.4653 .64165 m .46024 .63902 L .47968 .63616 L p F P
0 0 0 r
s
.298 .454 .881 r
.53976 .63902 m .5347 .64165 L .51776 .63751 L p F P
0 0 0 r
s
.298 .454 .881 r
.5152 .63885 m .51776 .63751 L .5347 .64165 L p F P
0 0 0 r
s
.83 .24 .1 r
.16092 .43218 m
.19813 .45234 L
s
.19643 .47672 m
.19813 .45234 L
s
.24 .35 .67 r
.83908 .43218 m
.80187 .45234 L
s
.80187 .45234 m
.80357 .47672 L
s
.116 .157 .342 r
.34128 .48182 m .356 .47207 L .3555 .45183 L p F P
0 0 0 r
s
.116 .157 .342 r
.37051 .44173 m .3555 .45183 L .356 .47207 L p F P
0 0 0 r
s
.916 .251 .101 r
.6445 .45183 m .62949 .44173 L .62904 .46217 L p F P
0 0 0 r
s
.916 .251 .101 r
.62904 .46217 m .644 .47207 L .6445 .45183 L p F P
0 0 0 r
s
.24 .35 .67 r
.55362 .28179 m
.57154 .28128 L
s
.60501 .25833 m
.57154 .28128 L
s
.83 .24 .1 r
.42846 .28128 m
.39499 .25833 L
s
.42846 .28128 m
.44638 .28179 L
s
.24 .35 .67 r
.60501 .25833 m
.62461 .26419 L
s
.65896 .24096 m
.62461 .26419 L
s
.83 .24 .1 r
.37539 .26419 m
.34104 .24096 L
s
.37539 .26419 m
.39499 .25833 L
s
.971 .27 .11 r
.65872 .48182 m .644 .47207 L .63974 .49337 L p F P
0 0 0 r
s
.971 .27 .11 r
.63974 .49337 m .65406 .50267 L .65872 .48182 L p F P
0 0 0 r
s
.148 .206 .436 r
.33184 .51182 m .34594 .50267 L .34128 .48182 L p F P
0 0 0 r
s
.148 .206 .436 r
.356 .47207 m .34128 .48182 L .34594 .50267 L p F P
0 0 0 r
s
.24 .35 .67 r
.50545 .31139 m
.52094 .30438 L
s
.55362 .28179 m
.52094 .30438 L
s
.83 .24 .1 r
.47906 .30438 m
.44638 .28179 L
s
.47906 .30438 m
.49455 .31139 L
s
.971 .291 .125 r
.5 .64685 m .49748 .64553 L .5 .62969 L closepath p F P
0 0 0 r
s
.293 .442 .866 r
.5 .62969 m .50252 .64553 L .5 .64685 L closepath p F P
0 0 0 r
s
.173 .246 .511 r
.32813 .54061 m .3413 .53225 L .33184 .51182 L p F P
0 0 0 r
s
.173 .246 .511 r
.34594 .50267 m .33184 .51182 L .3413 .53225 L p F P
0 0 0 r
s
1 .283 .116 r
.66816 .51182 m .65406 .50267 L .64533 .52376 L p F P
0 0 0 r
s
1 .283 .116 r
.64533 .52376 m .6587 .53225 L .66816 .51182 L p F P
0 0 0 r
s
1 .292 .121 r
.67187 .54061 m .6587 .53225 L .64498 .55211 L p F P
0 0 0 r
s
1 .292 .121 r
.64498 .55211 m .65711 .55962 L .67187 .54061 L p F P
0 0 0 r
s
.194 .28 .573 r
.33091 .56704 m .34289 .55962 L .32813 .54061 L p F P
0 0 0 r
s
.194 .28 .573 r
.3413 .53225 m .32813 .54061 L .34289 .55962 L p F P
0 0 0 r
s
1 .299 .124 r
.66909 .56704 m .65711 .55962 L .63809 .57733 L p F P
0 0 0 r
s
.83 .24 .1 r
.6548 .55859 m
.65686 .55986 L
s
.66868 .56717 m
.66882 .56726 L
s
1 .299 .124 r
.63809 .57733 m .64874 .58375 L .66909 .56704 L p F P
0 0 0 r
s
.213 .308 .627 r
.34074 .59009 m .35126 .58375 L .33091 .56704 L p F P
0 0 0 r
s
.213 .308 .627 r
.34289 .55962 m .33091 .56704 L .35126 .58375 L p F P
0 0 0 r
s
.887 .271 .117 r
.47711 .63481 m .47968 .63616 L .46024 .63902 L p F P
0 0 0 r
s
.887 .271 .117 r
.46024 .63902 m .45516 .63638 L .47711 .63481 L p F P
0 0 0 r
s
.24 .35 .67 r
.45621 .63847 m
.47991 .65076 L
s
.42535 .6552 m
.45621 .63847 L
s
.298 .454 .881 r
.54484 .63638 m .53976 .63902 L .52032 .63616 L p F P
0 0 0 r
s
.24 .35 .67 r
.53693 .63883 m
.53726 .63865 L
s
.83 .24 .1 r
.54379 .63847 m
.57465 .6552 L
s
.298 .454 .881 r
.51776 .63751 m .52032 .63616 L .53976 .63902 L p F P
0 0 0 r
s
.83 .24 .1 r
.52009 .65076 m
.54379 .63847 L
s
.024 .035 .067 r
.6231 .6089 m .6332 .60371 L .65926 .59009 L p F P
0 0 0 r
s
.229 .334 .674 r
.35126 .58375 m .34074 .59009 L .3668 .60371 L p F P
0 0 0 r
s
.83 .24 .1 r
.34809 .59263 m
.34919 .5932 L
s
.24 .35 .67 r
.34844 .59516 m
.34937 .5946 L
s
.33133 .60538 m
.34844 .59516 L
s
1 .304 .127 r
.65926 .59009 m .64874 .58375 L .62428 .59847 L p F P
0 0 0 r
s
1 .304 .127 r
.62428 .59847 m .6332 .60371 L .65926 .59009 L p F P
0 0 0 r
s
.24 .35 .67 r
.65191 .59263 m
.67228 .58217 L
s
.65081 .5932 m
.65191 .59263 L
s
.83 .24 .1 r
.65156 .59516 m
.66867 .60538 L
s
.65063 .5946 m
.65156 .59516 L
s
.742 .233 .103 r
.43976 .62838 m .44492 .63106 L .41966 .62667 L p F P
0 0 0 r
s
.742 .233 .103 r
.41966 .62667 m .41203 .62274 L .43976 .62838 L p F P
0 0 0 r
s
.292 .449 .863 r
.58797 .62274 m .58034 .62667 L .55508 .63106 L p F P
0 0 0 r
s
.292 .449 .863 r
.54995 .63373 m .55508 .63106 L .58034 .62667 L p F P
0 0 0 r
s
.24 .35 .67 r
.65896 .24096 m
.67953 .2528 L
s
.71485 .22934 m
.67953 .2528 L
s
.83 .24 .1 r
.32047 .2528 m
.28515 .22934 L
s
.32047 .2528 m
.34104 .24096 L
s
.971 .291 .125 r
.49748 .64553 m .49496 .6442 L .5 .62969 L closepath p F P
0 0 0 r
s
.293 .442 .866 r
.5 .62969 m .50504 .6442 L .50252 .64553 L closepath p F P
0 0 0 r
s
.043 .059 .127 r
.38832 .41298 m .4035 .40262 L .40815 .38713 L p F P
0 0 0 r
s
.043 .059 .127 r
.42286 .377 m .40815 .38713 L .4035 .40262 L p F P
0 0 0 r
s
.698 .183 .07 r
.59185 .38713 m .57714 .377 L .58108 .3921 L p F P
0 0 0 r
s
.698 .183 .07 r
.58108 .3921 m .5965 .40262 L .59185 .38713 L p F P
0 0 0 r
s
.024 .035 .067 r
.45658 .34608 m .47084 .3362 L .47395 .33127 L p F P
0 0 0 r
s
.024 .035 .067 r
.48689 .32229 m .47395 .33127 L .47084 .3362 L p F P
0 0 0 r
s
.36 .08 .033 r
.52605 .33127 m .51311 .32229 L .51469 .32618 L p F P
0 0 0 r
s
.36 .08 .033 r
.51469 .32618 m .52916 .3362 L .52605 .33127 L p F P
0 0 0 r
s
.83 .24 .1 r
.6548 .55859 m
.65492 .55826 L
s
.24 .35 .67 r
.34237 .55078 m
.3452 .55859 L
s
.538 .176 .08 r
.39661 .61479 m .40435 .61878 L .3769 .6089 L p F P
0 0 0 r
s
.538 .176 .08 r
.3769 .6089 m .3668 .60371 L .39661 .61479 L p F P
0 0 0 r
s
.24 .35 .67 r
.35034 .63167 m
.37995 .61459 L
s
.37995 .61459 m
.4019 .63743 L
s
.264 .412 .783 r
.6332 .60371 m .6231 .6089 L .59565 .61878 L p F P
0 0 0 r
s
.264 .412 .783 r
.58797 .62274 m .59565 .61878 L .6231 .6089 L p F P
0 0 0 r
s
.83 .24 .1 r
.62005 .61459 m
.64966 .63167 L
s
.5981 .63743 m
.62005 .61459 L
s
.971 .291 .125 r
.49496 .6442 m .49243 .64287 L .5 .62969 L closepath p F P
0 0 0 r
s
.293 .442 .866 r
.5 .62969 m .50757 .64287 L .50504 .6442 L closepath p F P
0 0 0 r
s
.887 .271 .117 r
.47453 .63346 m .47711 .63481 L .45516 .63638 L p F P
0 0 0 r
s
.887 .271 .117 r
.45516 .63638 m .45005 .63373 L .47453 .63346 L p F P
0 0 0 r
s
.298 .454 .881 r
.54995 .63373 m .54484 .63638 L .52289 .63481 L p F P
0 0 0 r
s
.24 .35 .67 r
.54169 .63635 m
.54202 .63618 L
s
.298 .454 .881 r
.52032 .63616 m .52289 .63481 L .54484 .63638 L p F P
0 0 0 r
s
.024 .035 .067 r
.42286 .377 m .43781 .3667 L .44253 .35582 L p F P
0 0 0 r
s
.024 .035 .067 r
.45658 .34608 m .44253 .35582 L .43781 .3667 L p F P
0 0 0 r
s
.542 .135 .052 r
.55747 .35582 m .54342 .34608 L .54701 .35625 L p F P
0 0 0 r
s
.542 .135 .052 r
.54701 .35625 m .56219 .3667 L .55747 .35582 L p F P
0 0 0 r
s
.83 .24 .1 r
.16716 .40519 m
.16092 .43218 L
s
.24 .35 .67 r
.83284 .40519 m
.83908 .43218 L
s
.971 .291 .125 r
.49243 .64287 m .48989 .64153 L .5 .62969 L closepath p F P
0 0 0 r
s
.293 .442 .866 r
.5 .62969 m .51011 .64153 L .50757 .64287 L closepath p F P
0 0 0 r
s
.742 .233 .103 r
.43458 .62568 m .43976 .62838 L .41203 .62274 L p F P
0 0 0 r
s
.24 .35 .67 r
.4019 .63743 m
.42291 .6257 L
s
.742 .233 .103 r
.41203 .62274 m .40435 .61878 L .43458 .62568 L p F P
0 0 0 r
s
.292 .449 .863 r
.59565 .61878 m .58797 .62274 L .56024 .62838 L p F P
0 0 0 r
s
.24 .35 .67 r
.58575 .62319 m
.58618 .62319 L
s
.292 .449 .863 r
.55508 .63106 m .56024 .62838 L .58797 .62274 L p F P
0 0 0 r
s
.08 .105 .237 r
.37051 .44173 m .38577 .43146 L .38832 .41298 L p F P
0 0 0 r
s
.08 .105 .237 r
.4035 .40262 m .38832 .41298 L .38577 .43146 L p F P
0 0 0 r
s
.831 .224 .089 r
.61168 .41298 m .5965 .40262 L .59873 .42102 L p F P
0 0 0 r
s
.831 .224 .089 r
.59873 .42102 m .61423 .43146 L .61168 .41298 L p F P
0 0 0 r
s
.83 .24 .1 r
.61274 .43045 m
.61303 .43218 L
s
.971 .291 .125 r
.48989 .64153 m .48735 .6402 L .5 .62969 L closepath p F P
0 0 0 r
s
.293 .442 .866 r
.5 .62969 m .51265 .6402 L .51011 .64153 L closepath p F P
0 0 0 r
s
.887 .271 .117 r
.47195 .6321 m .47453 .63346 L .45005 .63373 L p F P
0 0 0 r
s
.887 .271 .117 r
.45005 .63373 m .44492 .63106 L .47195 .6321 L p F P
0 0 0 r
s
.298 .454 .881 r
.55508 .63106 m .54995 .63373 L .52547 .63346 L p F P
0 0 0 r
s
.24 .35 .67 r
.54646 .63387 m
.5468 .63369 L
s
.298 .454 .881 r
.52289 .63481 m .52547 .63346 L .54995 .63373 L p F P
0 0 0 r
s
.24 .35 .67 r
.71485 .22934 m
.73573 .24658 L
s
.83 .24 .1 r
.28515 .22934 m
.26427 .24658 L
s
.62472 .60811 m
.62556 .60694 L
s
.62572 .60671 m
.62946 .60152 L
s
.62005 .61459 m
.62472 .60811 L
s
.24 .35 .67 r
.37444 .60694 m
.37528 .60811 L
s
.37528 .60811 m
.37995 .61459 L
s
.971 .291 .125 r
.48735 .6402 m .4848 .63885 L .5 .62969 L closepath p F P
0 0 0 r
s
.293 .442 .866 r
.5 .62969 m .5152 .63885 L .51265 .6402 L closepath p F P
0 0 0 r
s
.229 .334 .674 r
.3668 .60371 m .37572 .59847 L .35126 .58375 L p F P
0 0 0 r
s
.24 .35 .67 r
.37054 .60152 m
.37406 .60641 L
s
.229 .334 .674 r
.36191 .57733 m .35126 .58375 L .37572 .59847 L p F P
0 0 0 r
s
.213 .308 .627 r
.35126 .58375 m .36191 .57733 L .34289 .55962 L p F P
0 0 0 r
s
.83 .24 .1 r
.32772 .58217 m
.34809 .59263 L
s
.24 .35 .67 r
.34314 .55986 m
.3452 .55859 L
s
1 .304 .127 r
.64874 .58375 m .63809 .57733 L .61528 .59319 L p F P
0 0 0 r
s
1 .304 .127 r
.61528 .59319 m .62428 .59847 L .64874 .58375 L p F P
0 0 0 r
s
1 .299 .124 r
.65711 .55962 m .64498 .55211 L .62732 .57083 L p F P
0 0 0 r
s
1 .299 .124 r
.62732 .57083 m .63809 .57733 L .65711 .55962 L p F P
0 0 0 r
s
.213 .308 .627 r
.35502 .55211 m .34289 .55962 L .36191 .57733 L p F P
0 0 0 r
s
.194 .28 .573 r
.34289 .55962 m .35502 .55211 L .3413 .53225 L p F P
0 0 0 r
s
.116 .157 .342 r
.356 .47207 m .37096 .46217 L .37051 .44173 L p F P
0 0 0 r
s
.116 .157 .342 r
.38577 .43146 m .37051 .44173 L .37096 .46217 L p F P
0 0 0 r
s
.24 .35 .67 r
.38467 .43373 m
.38697 .43218 L
s
.916 .251 .101 r
.62949 .44173 m .61423 .43146 L .61383 .4521 L p F P
0 0 0 r
s
.83 .24 .1 r
.61303 .43218 m
.6142 .43298 L
s
.62835 .44249 m
.62945 .44323 L
s
.916 .251 .101 r
.61383 .4521 m .62904 .46217 L .62949 .44173 L p F P
0 0 0 r
s
.264 .412 .783 r
.59565 .61878 m .60339 .61479 L .6332 .60371 L p F P
0 0 0 r
s
1 .307 .128 r
.6332 .60371 m .62428 .59847 L .59637 .61077 L p F P
0 0 0 r
s
1 .307 .128 r
.59637 .61077 m .60339 .61479 L .6332 .60371 L p F P
0 0 0 r
s
.24 .35 .67 r
.62515 .60438 m
.62589 .60412 L
s
.83 .24 .1 r
.61399 .61109 m
.62005 .61459 L
s
.244 .358 .718 r
.37572 .59847 m .3668 .60371 L .39661 .61479 L p F P
0 0 0 r
s
.83 .24 .1 r
.37411 .60412 m
.37485 .60438 L
s
.24 .35 .67 r
.37995 .61459 m
.38601 .61109 L
s
.194 .28 .573 r
.35467 .52376 m .3413 .53225 L .35502 .55211 L p F P
0 0 0 r
s
.173 .246 .511 r
.3413 .53225 m .35467 .52376 L .34594 .50267 L p F P
0 0 0 r
s
1 .292 .121 r
.6587 .53225 m .64533 .52376 L .63268 .5445 L p F P
0 0 0 r
s
1 .292 .121 r
.63268 .5445 m .64498 .55211 L .6587 .53225 L p F P
0 0 0 r
s
.971 .291 .125 r
.4848 .63885 m .48224 .63751 L .5 .62969 L closepath p F P
0 0 0 r
s
.293 .442 .866 r
.5 .62969 m .51776 .63751 L .5152 .63885 L closepath p F P
0 0 0 r
s
.173 .246 .511 r
.36026 .49337 m .34594 .50267 L .35467 .52376 L p F P
0 0 0 r
s
.148 .206 .436 r
.34594 .50267 m .36026 .49337 L .356 .47207 L p F P
0 0 0 r
s
1 .283 .116 r
.65406 .50267 m .63974 .49337 L .63176 .51516 L p F P
0 0 0 r
s
1 .283 .116 r
.63176 .51516 m .64533 .52376 L .65406 .50267 L p F P
0 0 0 r
s
.971 .27 .11 r
.644 .47207 m .62904 .46217 L .62519 .48393 L p F P
0 0 0 r
s
.971 .27 .11 r
.62519 .48393 m .63974 .49337 L .644 .47207 L p F P
0 0 0 r
s
.148 .206 .436 r
.37096 .46217 m .356 .47207 L .36026 .49337 L p F P
0 0 0 r
s
.887 .271 .117 r
.46936 .63073 m .47195 .6321 L .44492 .63106 L p F P
0 0 0 r
s
.24 .35 .67 r
.45621 .63847 m
.46887 .6316 L
s
.887 .271 .117 r
.44492 .63106 m .43976 .62838 L .46936 .63073 L p F P
0 0 0 r
s
.298 .454 .881 r
.56024 .62838 m .55508 .63106 L .52805 .6321 L p F P
0 0 0 r
s
.24 .35 .67 r
.55126 .63137 m
.5516 .63119 L
s
.298 .454 .881 r
.52547 .63346 m .52805 .6321 L .55508 .63106 L p F P
0 0 0 r
s
.024 .035 .067 r
.47084 .3362 m .48531 .32618 L .48689 .32229 L p F P
0 0 0 r
s
.024 .035 .067 r
.5 .31319 m .48689 .32229 L .48531 .32618 L p F P
0 0 0 r
s
.36 .08 .033 r
.51311 .32229 m .5 .31319 L .5 .316 L p F P
0 0 0 r
s
.24 .35 .67 r
.50134 .31424 m
.5015 .31413 L
s
.5015 .31413 m
.50545 .31139 L
s
.36 .08 .033 r
.5 .316 m .51469 .32618 L .51311 .32229 L p F P
0 0 0 r
s
.24 .35 .67 r
.48967 .32233 m
.5 .31517 L
s
.742 .233 .103 r
.42936 .62298 m .43458 .62568 L .40435 .61878 L p F P
0 0 0 r
s
.24 .35 .67 r
.42291 .6257 m
.42724 .62328 L
s
.742 .233 .103 r
.40435 .61878 m .39661 .61479 L .42936 .62298 L p F P
0 0 0 r
s
.292 .449 .863 r
.60339 .61479 m .59565 .61878 L .56542 .62568 L p F P
0 0 0 r
s
.24 .35 .67 r
.57655 .62314 m
.5795 .62316 L
s
.292 .449 .863 r
.56024 .62838 m .56542 .62568 L .59565 .61878 L p F P
0 0 0 r
s
.83 .24 .1 r
.57709 .6257 m
.5981 .63743 L
s
.971 .291 .125 r
.48224 .63751 m .47968 .63616 L .5 .62969 L closepath p F P
0 0 0 r
s
.293 .442 .866 r
.5 .62969 m .52032 .63616 L .51776 .63751 L closepath p F P
0 0 0 r
s
.043 .059 .127 r
.4035 .40262 m .41892 .3921 L .42286 .377 L p F P
0 0 0 r
s
.043 .059 .127 r
.43781 .3667 m .42286 .377 L .41892 .3921 L p F P
0 0 0 r
s
.698 .183 .07 r
.57714 .377 m .56219 .3667 L .56539 .3814 L p F P
0 0 0 r
s
.698 .183 .07 r
.56539 .3814 m .58108 .3921 L .57714 .377 L p F P
0 0 0 r
s
.83 .24 .1 r
.6388 .49595 m
.63938 .49314 L
s
.971 .291 .125 r
.47968 .63616 m .47711 .63481 L .5 .62969 L closepath p F P
0 0 0 r
s
.293 .442 .866 r
.5 .62969 m .52289 .63481 L .52032 .63616 L closepath p F P
0 0 0 r
s
.024 .035 .067 r
.43781 .3667 m .45299 .35625 L .45658 .34608 L p F P
0 0 0 r
s
.024 .035 .067 r
.47084 .3362 m .45658 .34608 L .45299 .35625 L p F P
0 0 0 r
s
.24 .35 .67 r
.46588 .34178 m
.47138 .33583 L
s
.542 .135 .052 r
.54342 .34608 m .52916 .3362 L .53159 .34563 L p F P
0 0 0 r
s
.83 .24 .1 r
.52862 .33583 m
.52923 .33649 L
s
.542 .135 .052 r
.53159 .34563 m .54701 .35625 L .54342 .34608 L p F P
0 0 0 r
s
.887 .271 .117 r
.46676 .62937 m .46936 .63073 L .43976 .62838 L p F P
0 0 0 r
s
.887 .271 .117 r
.43976 .62838 m .43458 .62568 L .46676 .62937 L p F P
0 0 0 r
s
.24 .35 .67 r
.44385 .62891 m
.45621 .63847 L
s
.44135 .62698 m
.44385 .62891 L
s
.298 .454 .881 r
.56542 .62568 m .56024 .62838 L .53064 .63073 L p F P
0 0 0 r
s
.24 .35 .67 r
.55609 .62886 m
.55643 .62868 L
s
.298 .454 .881 r
.52805 .6321 m .53064 .63073 L .56024 .62838 L p F P
0 0 0 r
s
.83 .24 .1 r
.55615 .62891 m
.55865 .62698 L
s
.54379 .63847 m
.55615 .62891 L
s
.53113 .6316 m
.54379 .63847 L
s
.971 .291 .125 r
.47711 .63481 m .47453 .63346 L .5 .62969 L closepath p F P
0 0 0 r
s
.293 .442 .866 r
.5 .62969 m .52547 .63346 L .52289 .63481 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.24355 .53361 m
.23608 .51703 L
s
.23608 .51703 m
.19901 .49768 L
s
.24 .35 .67 r
.80099 .49768 m
.76392 .51703 L
s
.76392 .51703 m
.75645 .53361 L
s
1 .307 .128 r
.62428 .59847 m .61528 .59319 L .58929 .60672 L p F P
0 0 0 r
s
1 .307 .128 r
.58929 .60672 m .59637 .61077 L .62428 .59847 L p F P
0 0 0 r
s
.24 .35 .67 r
.61417 .60937 m
.62103 .60584 L
s
.62103 .60584 m
.62515 .60438 L
s
.244 .358 .718 r
.39661 .61479 m .40363 .61077 L .37572 .59847 L p F P
0 0 0 r
s
.244 .358 .718 r
.38472 .59319 m .37572 .59847 L .40363 .61077 L p F P
0 0 0 r
s
.83 .24 .1 r
.37485 .60438 m
.37897 .60584 L
s
.37897 .60584 m
.38583 .60937 L
s
.229 .334 .674 r
.37572 .59847 m .38472 .59319 L .36191 .57733 L p F P
0 0 0 r
s
.292 .449 .863 r
.56542 .62568 m .57064 .62298 L .60339 .61479 L p F P
0 0 0 r
s
.83 .24 .1 r
.57276 .62328 m
.57709 .6257 L
s
1 .308 .13 r
.60339 .61479 m .59637 .61077 L .56576 .62026 L p F P
0 0 0 r
s
1 .308 .13 r
.56576 .62026 m .57064 .62298 L .60339 .61479 L p F P
0 0 0 r
s
.258 .381 .76 r
.40363 .61077 m .39661 .61479 L .42936 .62298 L p F P
0 0 0 r
s
.83 .24 .1 r
.19901 .49768 m
.19643 .47672 L
s
.19643 .47672 m
.15868 .45669 L
s
.24 .35 .67 r
.84132 .45669 m
.80357 .47672 L
s
.80357 .47672 m
.80099 .49768 L
s
.83 .24 .1 r
.2921 .56386 m
.27992 .5524 L
s
.27992 .5524 m
.24355 .53361 L
s
.24 .35 .67 r
.75645 .53361 m
.72008 .5524 L
s
.72008 .5524 m
.7079 .56386 L
s
.229 .334 .674 r
.37268 .57083 m .36191 .57733 L .38472 .59319 L p F P
0 0 0 r
s
.213 .308 .627 r
.36191 .57733 m .37268 .57083 L .35502 .55211 L p F P
0 0 0 r
s
1 .304 .127 r
.63809 .57733 m .62732 .57083 L .60619 .58785 L p F P
0 0 0 r
s
1 .304 .127 r
.60619 .58785 m .61528 .59319 L .63809 .57733 L p F P
0 0 0 r
s
.971 .291 .125 r
.47453 .63346 m .47195 .6321 L .5 .62969 L closepath p F P
0 0 0 r
s
.293 .442 .866 r
.5 .62969 m .52805 .6321 L .52547 .63346 L closepath p F P
0 0 0 r
s
.08 .105 .237 r
.38577 .43146 m .40127 .42102 L .4035 .40262 L p F P
0 0 0 r
s
.24 .35 .67 r
.38697 .43218 m
.38726 .43045 L
s
.08 .105 .237 r
.41892 .3921 m .4035 .40262 L .40127 .42102 L p F P
0 0 0 r
s
.831 .224 .089 r
.5965 .40262 m .58108 .3921 L .58296 .4104 L p F P
0 0 0 r
s
.831 .224 .089 r
.58296 .4104 m .59873 .42102 L .5965 .40262 L p F P
0 0 0 r
s
.887 .271 .117 r
.46416 .628 m .46676 .62937 L .43458 .62568 L p F P
0 0 0 r
s
.887 .271 .117 r
.43458 .62568 m .42936 .62298 L .46416 .628 L p F P
0 0 0 r
s
.83 .24 .1 r
.43284 .62309 m
.43386 .62363 L
s
.43027 .62311 m
.43284 .62309 L
s
.298 .454 .881 r
.57064 .62298 m .56542 .62568 L .53324 .62937 L p F P
0 0 0 r
s
.24 .35 .67 r
.56716 .62309 m
.56987 .62311 L
s
.56093 .62634 m
.56127 .62616 L
s
.5658 .6238 m
.56716 .62309 L
s
.298 .454 .881 r
.53064 .63073 m .53324 .62937 L .56542 .62568 L p F P
0 0 0 r
s
.83 .24 .1 r
.34416 .5879 m
.32772 .58217 L
s
.32772 .58217 m
.2921 .56386 L
s
.24 .35 .67 r
.7079 .56386 m
.67228 .58217 L
s
.67228 .58217 m
.65584 .5879 L
s
1 .299 .124 r
.64498 .55211 m .63268 .5445 L .61643 .56426 L p F P
0 0 0 r
s
.83 .24 .1 r
.6446 .55227 m
.64474 .55236 L
s
1 .299 .124 r
.61643 .56426 m .62732 .57083 L .64498 .55211 L p F P
0 0 0 r
s
.213 .308 .627 r
.36732 .5445 m .35502 .55211 L .37268 .57083 L p F P
0 0 0 r
s
.194 .28 .573 r
.35502 .55211 m .36732 .5445 L .35467 .52376 L p F P
0 0 0 r
s
.24 .35 .67 r
.56716 .62309 m
.56907 .6221 L
s
.62103 .60584 m
.65584 .5879 L
s
.971 .291 .125 r
.47195 .6321 m .46936 .63073 L .5 .62969 L closepath p F P
0 0 0 r
s
.293 .442 .866 r
.5 .62969 m .53064 .63073 L .52805 .6321 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.16092 .43218 m
.15868 .45669 L
s
.24 .35 .67 r
.83908 .43218 m
.84132 .45669 L
s
1 .292 .121 r
.64533 .52376 m .63176 .51516 L .62021 .53678 L p F P
0 0 0 r
s
1 .292 .121 r
.62021 .53678 m .63268 .5445 L .64533 .52376 L p F P
0 0 0 r
s
.194 .28 .573 r
.36824 .51516 m .35467 .52376 L .36732 .5445 L p F P
0 0 0 r
s
.173 .246 .511 r
.35467 .52376 m .36824 .51516 L .36026 .49337 L p F P
0 0 0 r
s
.24 .35 .67 r
.36052 .49262 m
.3612 .49595 L
s
.024 .035 .067 r
.48531 .32618 m .5 .316 L .5 .31319 L p F P
0 0 0 r
s
.83 .24 .1 r
.49455 .31139 m
.4985 .31413 L
s
.4985 .31413 m
.49866 .31424 L
s
.24 .35 .67 r
.58738 .25846 m
.60501 .25833 L
s
.6396 .23463 m
.60501 .25833 L
s
.83 .24 .1 r
.39499 .25833 m
.3604 .23463 L
s
.39499 .25833 m
.41262 .25846 L
s
.116 .157 .342 r
.37096 .46217 m .38617 .4521 L .38577 .43146 L p F P
0 0 0 r
s
.116 .157 .342 r
.40127 .42102 m .38577 .43146 L .38617 .4521 L p F P
0 0 0 r
s
.916 .251 .101 r
.61423 .43146 m .59873 .42102 L .59838 .44186 L p F P
0 0 0 r
s
.916 .251 .101 r
.59838 .44186 m .61383 .4521 L .61423 .43146 L p F P
0 0 0 r
s
.971 .291 .125 r
.46936 .63073 m .46676 .62937 L .5 .62969 L closepath p F P
0 0 0 r
s
.293 .442 .866 r
.5 .62969 m .53324 .62937 L .53064 .63073 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.6396 .23463 m
.65896 .24096 L
s
.69445 .21696 m
.65896 .24096 L
s
.83 .24 .1 r
.34104 .24096 m
.30555 .21696 L
s
.34104 .24096 m
.3604 .23463 L
s
.173 .246 .511 r
.37481 .48393 m .36026 .49337 L .36824 .51516 L p F P
0 0 0 r
s
.148 .206 .436 r
.36026 .49337 m .37481 .48393 L .37096 .46217 L p F P
0 0 0 r
s
1 .283 .116 r
.63974 .49337 m .62519 .48393 L .61799 .50642 L p F P
0 0 0 r
s
1 .283 .116 r
.61799 .50642 m .63176 .51516 L .63974 .49337 L p F P
0 0 0 r
s
.298 .454 .881 r
.53324 .62937 m .53584 .628 L .57064 .62298 L p F P
0 0 0 r
s
.271 .403 .799 r
.43424 .62026 m .42936 .62298 L .46416 .628 L p F P
0 0 0 r
s
.258 .381 .76 r
.42936 .62298 m .43424 .62026 L .40363 .61077 L p F P
0 0 0 r
s
1 .306 .13 r
.57064 .62298 m .56576 .62026 L .53332 .62663 L p F P
0 0 0 r
s
.83 .24 .1 r
.56226 .62419 m
.56284 .62374 L
s
1 .306 .13 r
.53332 .62663 m .53584 .628 L .57064 .62298 L p F P
0 0 0 r
s
.258 .381 .76 r
.41071 .60672 m .40363 .61077 L .43424 .62026 L p F P
0 0 0 r
s
.244 .358 .718 r
.40363 .61077 m .41071 .60672 L .38472 .59319 L p F P
0 0 0 r
s
1 .308 .13 r
.59637 .61077 m .58929 .60672 L .56085 .61752 L p F P
0 0 0 r
s
1 .308 .13 r
.56085 .61752 m .56576 .62026 L .59637 .61077 L p F P
0 0 0 r
s
.24 .35 .67 r
.57297 .62007 m
.57767 .61763 L
s
.971 .27 .11 r
.62904 .46217 m .61383 .4521 L .61041 .47434 L p F P
0 0 0 r
s
.971 .27 .11 r
.61041 .47434 m .62519 .48393 L .62904 .46217 L p F P
0 0 0 r
s
.148 .206 .436 r
.38617 .4521 m .37096 .46217 L .37481 .48393 L p F P
0 0 0 r
s
.24 .35 .67 r
.53845 .28851 m
.55362 .28179 L
s
.58738 .25846 m
.55362 .28179 L
s
.83 .24 .1 r
.44638 .28179 m
.41262 .25846 L
s
.44638 .28179 m
.46155 .28851 L
s
.971 .291 .125 r
.46676 .62937 m .46416 .628 L .5 .62969 L closepath p F P
0 0 0 r
s
.293 .442 .866 r
.5 .62969 m .53584 .628 L .53324 .62937 L closepath p F P
0 0 0 r
s
1 .307 .128 r
.61528 .59319 m .60619 .58785 L .58216 .60264 L p F P
0 0 0 r
s
1 .307 .128 r
.58216 .60264 m .58929 .60672 L .61528 .59319 L p F P
0 0 0 r
s
.24 .35 .67 r
.60107 .60545 m
.62103 .60584 L
s
.244 .358 .718 r
.39381 .58785 m .38472 .59319 L .41071 .60672 L p F P
0 0 0 r
s
.229 .334 .674 r
.38472 .59319 m .39381 .58785 L .37268 .57083 L p F P
0 0 0 r
s
.83 .24 .1 r
.34416 .5879 m
.37897 .60584 L
s
.043 .059 .127 r
.41892 .3921 m .43461 .3814 L .43781 .3667 L p F P
0 0 0 r
s
.043 .059 .127 r
.45299 .35625 m .43781 .3667 L .43461 .3814 L p F P
0 0 0 r
s
.698 .183 .07 r
.56219 .3667 m .54701 .35625 L .54945 .37053 L p F P
0 0 0 r
s
.698 .183 .07 r
.54945 .37053 m .56539 .3814 L .56219 .3667 L p F P
0 0 0 r
s
.83 .24 .1 r
.49455 .31139 m
.46155 .28851 L
s
.49455 .31139 m
.49842 .31564 L
s
.24 .35 .67 r
.50158 .31564 m
.50545 .31139 L
s
.53845 .28851 m
.50545 .31139 L
s
.69445 .21696 m
.71485 .22934 L
s
.83 .24 .1 r
.30555 .21696 m
.28515 .22934 L
s
.024 .035 .067 r
.45299 .35625 m .46841 .34563 L .47084 .3362 L p F P
0 0 0 r
s
.024 .035 .067 r
.48531 .32618 m .47084 .3362 L .46841 .34563 L p F P
0 0 0 r
s
.542 .135 .052 r
.52916 .3362 m .51469 .32618 L .51592 .33484 L p F P
0 0 0 r
s
.542 .135 .052 r
.51592 .33484 m .53159 .34563 L .52916 .3362 L p F P
0 0 0 r
s
1 .302 .128 r
.5 .62969 m .53584 .628 L .53332 .62663 L closepath p F P
0 0 0 r
s
.283 .424 .835 r
.46668 .62663 m .46416 .628 L .5 .62969 L closepath p F P
0 0 0 r
s
.271 .403 .799 r
.46416 .628 m .46668 .62663 L .43424 .62026 L p F P
0 0 0 r
s
.271 .403 .799 r
.43915 .61752 m .43424 .62026 L .46668 .62663 L p F P
0 0 0 r
s
.258 .381 .76 r
.43424 .62026 m .43915 .61752 L .41071 .60672 L p F P
0 0 0 r
s
.83 .24 .1 r
.42233 .61763 m
.42703 .62007 L
s
1 .306 .13 r
.56576 .62026 m .56085 .61752 L .5308 .62525 L p F P
0 0 0 r
s
1 .306 .13 r
.5308 .62525 m .53332 .62663 L .56576 .62026 L p F P
0 0 0 r
s
.229 .334 .674 r
.38357 .56426 m .37268 .57083 L .39381 .58785 L p F P
0 0 0 r
s
.213 .308 .627 r
.37268 .57083 m .38357 .56426 L .36732 .5445 L p F P
0 0 0 r
s
1 .304 .127 r
.62732 .57083 m .61643 .56426 L .597 .58246 L p F P
0 0 0 r
s
1 .304 .127 r
.597 .58246 m .60619 .58785 L .62732 .57083 L p F P
0 0 0 r
s
1 .302 .128 r
.5 .62969 m .51295 .61552 L .51037 .61411 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.5013 .62827 m
.50338 .62938 L
s
1 .302 .128 r
.5 .62969 m .51037 .61411 L .50779 .6127 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.49662 .62938 m
.50129 .62688 L
s
1 .302 .128 r
.5 .62969 m .50779 .6127 L .5052 .61129 L closepath p F P
0 0 0 r
s
1 .302 .128 r
.5 .62969 m .5052 .61129 L .5026 .60988 L closepath p F P
0 0 0 r
s
1 .302 .128 r
.5 .62969 m .5026 .60988 L .5 .60846 L closepath p F P
0 0 0 r
s
1 .302 .128 r
.5 .62969 m .53332 .62663 L .5308 .62525 L closepath p F P
0 0 0 r
s
1 .302 .128 r
.5 .62969 m .5308 .62525 L .52827 .62387 L closepath p F P
0 0 0 r
s
1 .302 .128 r
.5 .62969 m .52827 .62387 L .52573 .62249 L closepath p F P
0 0 0 r
s
1 .302 .128 r
.5 .62969 m .52573 .62249 L .52319 .6211 L closepath p F P
0 0 0 r
s
1 .302 .128 r
.5 .62969 m .52319 .6211 L .52064 .61971 L closepath p F P
0 0 0 r
s
1 .302 .128 r
.5 .62969 m .52064 .61971 L .51808 .61832 L closepath p F P
0 0 0 r
s
1 .302 .128 r
.5 .62969 m .51808 .61832 L .51552 .61692 L closepath p F P
0 0 0 r
s
1 .302 .128 r
.5 .62969 m .51552 .61692 L .51295 .61552 L closepath p F P
0 0 0 r
s
.283 .424 .835 r
.4692 .62525 m .46668 .62663 L .5 .62969 L closepath p F P
0 0 0 r
s
.283 .424 .835 r
.47173 .62387 m .4692 .62525 L .5 .62969 L closepath p F P
0 0 0 r
s
.283 .424 .835 r
.47427 .62249 m .47173 .62387 L .5 .62969 L closepath p F P
0 0 0 r
s
.283 .424 .835 r
.47681 .6211 m .47427 .62249 L .5 .62969 L closepath p F P
0 0 0 r
s
.283 .424 .835 r
.47936 .61971 m .47681 .6211 L .5 .62969 L closepath p F P
0 0 0 r
s
.283 .424 .835 r
.48192 .61832 m .47936 .61971 L .5 .62969 L closepath p F P
0 0 0 r
s
.283 .424 .835 r
.48448 .61692 m .48192 .61832 L .5 .62969 L closepath p F P
0 0 0 r
s
.283 .424 .835 r
.48705 .61552 m .48448 .61692 L .5 .62969 L closepath p F P
0 0 0 r
s
.283 .424 .835 r
.48963 .61411 m .48705 .61552 L .5 .62969 L closepath p F P
0 0 0 r
s
.283 .424 .835 r
.49221 .6127 m .48963 .61411 L .5 .62969 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.49871 .62688 m
.5 .62757 L
s
.283 .424 .835 r
.4948 .61129 m .49221 .6127 L .5 .62969 L closepath p F P
0 0 0 r
s
.283 .424 .835 r
.4974 .60988 m .4948 .61129 L .5 .62969 L closepath p F P
0 0 0 r
s
.283 .424 .835 r
.5 .60846 m .4974 .60988 L .5 .62969 L closepath p F P
0 0 0 r
s
.271 .403 .799 r
.46668 .62663 m .4692 .62525 L .43915 .61752 L p F P
0 0 0 r
s
.258 .381 .76 r
.41784 .60264 m .41071 .60672 L .43915 .61752 L p F P
0 0 0 r
s
.244 .358 .718 r
.41071 .60672 m .41784 .60264 L .39381 .58785 L p F P
0 0 0 r
s
.83 .24 .1 r
.37897 .60584 m
.39893 .60545 L
s
1 .308 .13 r
.58929 .60672 m .58216 .60264 L .55593 .61477 L p F P
0 0 0 r
s
.83 .24 .1 r
.57507 .61212 m
.57749 .60957 L
s
1 .308 .13 r
.55593 .61477 m .56085 .61752 L .58929 .60672 L p F P
0 0 0 r
s
1 .299 .124 r
.63268 .5445 m .62021 .53678 L .6054 .55761 L p F P
0 0 0 r
s
.83 .24 .1 r
.63232 .54467 m
.63246 .54476 L
s
1 .299 .124 r
.6054 .55761 m .61643 .56426 L .63268 .5445 L p F P
0 0 0 r
s
.213 .308 .627 r
.37979 .53678 m .36732 .5445 L .38357 .56426 L p F P
0 0 0 r
s
.194 .28 .573 r
.36732 .5445 m .37979 .53678 L .36824 .51516 L p F P
0 0 0 r
s
1 .306 .13 r
.52827 .62387 m .5308 .62525 L .56085 .61752 L p F P
0 0 0 r
s
.24 .35 .67 r
.55663 .61998 m
.559 .62068 L
s
.271 .403 .799 r
.4692 .62525 m .47173 .62387 L .44407 .61477 L p F P
0 0 0 r
s
.271 .403 .799 r
.44407 .61477 m .43915 .61752 L .4692 .62525 L p F P
0 0 0 r
s
.258 .381 .76 r
.43915 .61752 m .44407 .61477 L .41784 .60264 L p F P
0 0 0 r
s
.83 .24 .1 r
.441 .62068 m
.44337 .61998 L
s
1 .306 .13 r
.56085 .61752 m .55593 .61477 L .52827 .62387 L p F P
0 0 0 r
s
.08 .105 .237 r
.40127 .42102 m .41704 .4104 L .41892 .3921 L p F P
0 0 0 r
s
.08 .105 .237 r
.43461 .3814 m .41892 .3921 L .41704 .4104 L p F P
0 0 0 r
s
.831 .224 .089 r
.58108 .3921 m .56539 .3814 L .56693 .39961 L p F P
0 0 0 r
s
.831 .224 .089 r
.56693 .39961 m .58296 .4104 L .58108 .3921 L p F P
0 0 0 r
s
.83 .24 .1 r
.58181 .40963 m
.58207 .41137 L
s
1 .307 .128 r
.60619 .58785 m .597 .58246 L .57497 .59853 L p F P
0 0 0 r
s
1 .307 .128 r
.57497 .59853 m .58216 .60264 L .60619 .58785 L p F P
0 0 0 r
s
.244 .358 .718 r
.403 .58246 m .39381 .58785 L .41784 .60264 L p F P
0 0 0 r
s
.229 .334 .674 r
.39381 .58785 m .403 .58246 L .38357 .56426 L p F P
0 0 0 r
s
1 .306 .13 r
.52573 .62249 m .52827 .62387 L .55593 .61477 L p F P
0 0 0 r
s
.271 .403 .799 r
.47173 .62387 m .47427 .62249 L .44903 .61201 L p F P
0 0 0 r
s
.271 .403 .799 r
.44903 .61201 m .44407 .61477 L .47173 .62387 L p F P
0 0 0 r
s
1 .292 .121 r
.63176 .51516 m .61799 .50642 L .60758 .52897 L p F P
0 0 0 r
s
1 .292 .121 r
.60758 .52897 m .62021 .53678 L .63176 .51516 L p F P
0 0 0 r
s
.194 .28 .573 r
.38201 .50642 m .36824 .51516 L .37979 .53678 L p F P
0 0 0 r
s
.173 .246 .511 r
.36824 .51516 m .38201 .50642 L .37481 .48393 L p F P
0 0 0 r
s
1 .306 .13 r
.55593 .61477 m .55097 .61201 L .52573 .62249 L p F P
0 0 0 r
s
1 .306 .13 r
.52319 .6211 m .52573 .62249 L .55097 .61201 L p F P
0 0 0 r
s
.271 .403 .799 r
.47427 .62249 m .47681 .6211 L .45401 .60923 L p F P
0 0 0 r
s
.271 .403 .799 r
.45401 .60923 m .44903 .61201 L .47427 .62249 L p F P
0 0 0 r
s
1 .308 .13 r
.58216 .60264 m .57497 .59853 L .55097 .61201 L p F P
0 0 0 r
s
1 .308 .13 r
.55097 .61201 m .55593 .61477 L .58216 .60264 L p F P
0 0 0 r
s
.24 .35 .67 r
.57767 .61763 m
.60107 .60545 L
s
.258 .381 .76 r
.42503 .59853 m .41784 .60264 L .44407 .61477 L p F P
0 0 0 r
s
.83 .24 .1 r
.39893 .60545 m
.42233 .61763 L
s
.244 .358 .718 r
.41784 .60264 m .42503 .59853 L .403 .58246 L p F P
0 0 0 r
s
.258 .381 .76 r
.44407 .61477 m .44903 .61201 L .42503 .59853 L p F P
0 0 0 r
s
.116 .157 .342 r
.38617 .4521 m .40162 .44186 L .40127 .42102 L p F P
0 0 0 r
s
.116 .157 .342 r
.41704 .4104 m .40127 .42102 L .40162 .44186 L p F P
0 0 0 r
s
.24 .35 .67 r
.4159 .41273 m
.41793 .41137 L
s
.916 .251 .101 r
.59873 .42102 m .58296 .4104 L .58266 .43146 L p F P
0 0 0 r
s
.83 .24 .1 r
.58207 .41137 m
.58294 .41195 L
s
.59755 .42178 m
.5987 .42255 L
s
.916 .251 .101 r
.58266 .43146 m .59838 .44186 L .59873 .42102 L p F P
0 0 0 r
s
.173 .246 .511 r
.38959 .47434 m .37481 .48393 L .38201 .50642 L p F P
0 0 0 r
s
.148 .206 .436 r
.37481 .48393 m .38959 .47434 L .38617 .4521 L p F P
0 0 0 r
s
1 .283 .116 r
.62519 .48393 m .61041 .47434 L .60401 .49755 L p F P
0 0 0 r
s
1 .283 .116 r
.60401 .49755 m .61799 .50642 L .62519 .48393 L p F P
0 0 0 r
s
.971 .27 .11 r
.61383 .4521 m .59838 .44186 L .5954 .46459 L p F P
0 0 0 r
s
.971 .27 .11 r
.5954 .46459 m .61041 .47434 L .61383 .4521 L p F P
0 0 0 r
s
.148 .206 .436 r
.40162 .44186 m .38617 .4521 L .38959 .47434 L p F P
0 0 0 r
s
1 .304 .127 r
.61643 .56426 m .6054 .55761 L .58773 .57701 L p F P
0 0 0 r
s
1 .304 .127 r
.58773 .57701 m .597 .58246 L .61643 .56426 L p F P
0 0 0 r
s
.229 .334 .674 r
.3946 .55761 m .38357 .56426 L .403 .58246 L p F P
0 0 0 r
s
.24 .35 .67 r
.38198 .55272 m
.38701 .56219 L
s
.213 .308 .627 r
.38357 .56426 m .3946 .55761 L .37979 .53678 L p F P
0 0 0 r
s
1 .306 .13 r
.55097 .61201 m .54599 .60923 L .52319 .6211 L p F P
0 0 0 r
s
1 .306 .13 r
.52064 .61971 m .52319 .6211 L .54599 .60923 L p F P
0 0 0 r
s
.271 .403 .799 r
.47681 .6211 m .47936 .61971 L .45901 .60644 L p F P
0 0 0 r
s
.271 .403 .799 r
.45901 .60644 m .45401 .60923 L .47681 .6211 L p F P
0 0 0 r
s
.83 .24 .1 r
.44337 .61998 m
.45529 .61645 L
s
.043 .059 .127 r
.43461 .3814 m .45055 .37053 L .45299 .35625 L p F P
0 0 0 r
s
.043 .059 .127 r
.46841 .34563 m .45299 .35625 L .45055 .37053 L p F P
0 0 0 r
s
.698 .183 .07 r
.54701 .35625 m .53159 .34563 L .53325 .35947 L p F P
0 0 0 r
s
.698 .183 .07 r
.53325 .35947 m .54945 .37053 L .54701 .35625 L p F P
0 0 0 r
s
.024 .035 .067 r
.46841 .34563 m .48408 .33484 L .48531 .32618 L p F P
0 0 0 r
s
.024 .035 .067 r
.5 .316 m .48531 .32618 L .48408 .33484 L p F P
0 0 0 r
s
.542 .135 .052 r
.51469 .32618 m .5 .316 L .5 .32387 L p F P
0 0 0 r
s
.83 .24 .1 r
.4994 .31672 m
.5 .31738 L
s
.542 .135 .052 r
.5 .32387 m .51592 .33484 L .51469 .32618 L p F P
0 0 0 r
s
1 .306 .13 r
.54599 .60923 m .54099 .60644 L .52064 .61971 L p F P
0 0 0 r
s
.24 .35 .67 r
.54471 .61645 m
.55663 .61998 L
s
1 .306 .13 r
.51808 .61832 m .52064 .61971 L .54099 .60644 L p F P
0 0 0 r
s
.271 .403 .799 r
.47936 .61971 m .48192 .61832 L .46404 .60363 L p F P
0 0 0 r
s
.271 .403 .799 r
.46404 .60363 m .45901 .60644 L .47936 .61971 L p F P
0 0 0 r
s
.258 .381 .76 r
.44903 .61201 m .45401 .60923 L .43227 .59439 L p F P
0 0 0 r
s
.24 .35 .67 r
.44823 .61156 m
.44847 .61142 L
s
.258 .381 .76 r
.43227 .59439 m .42503 .59853 L .44903 .61201 L p F P
0 0 0 r
s
1 .308 .13 r
.54599 .60923 m .55097 .61201 L .57497 .59853 L p F P
0 0 0 r
s
1 .307 .128 r
.597 .58246 m .58773 .57701 L .56773 .59439 L p F P
0 0 0 r
s
1 .307 .128 r
.56773 .59439 m .57497 .59853 L .597 .58246 L p F P
0 0 0 r
s
.244 .358 .718 r
.41227 .57701 m .403 .58246 L .42503 .59853 L p F P
0 0 0 r
s
.229 .334 .674 r
.403 .58246 m .41227 .57701 L .3946 .55761 L p F P
0 0 0 r
s
1 .299 .124 r
.62021 .53678 m .60758 .52897 L .59425 .55089 L p F P
0 0 0 r
s
.83 .24 .1 r
.61987 .53697 m
.62002 .53706 L
s
1 .299 .124 r
.59425 .55089 m .6054 .55761 L .62021 .53678 L p F P
0 0 0 r
s
.213 .308 .627 r
.39242 .52897 m .37979 .53678 L .3946 .55761 L p F P
0 0 0 r
s
.194 .28 .573 r
.37979 .53678 m .39242 .52897 L .38201 .50642 L p F P
0 0 0 r
s
1 .306 .13 r
.54099 .60644 m .53596 .60363 L .51808 .61832 L p F P
0 0 0 r
s
1 .306 .13 r
.51552 .61692 m .51808 .61832 L .53596 .60363 L p F P
0 0 0 r
s
.24 .35 .67 r
.53137 .62351 m
.54471 .61645 L
s
.271 .403 .799 r
.48192 .61832 m .48448 .61692 L .4691 .60081 L p F P
0 0 0 r
s
.271 .403 .799 r
.4691 .60081 m .46404 .60363 L .48192 .61832 L p F P
0 0 0 r
s
.24 .35 .67 r
.46443 .60251 m
.4651 .60304 L
s
.83 .24 .1 r
.45529 .61645 m
.46863 .62351 L
s
.244 .358 .718 r
.42503 .59853 m .43227 .59439 L .41227 .57701 L p F P
0 0 0 r
s
1 .308 .13 r
.57497 .59853 m .56773 .59439 L .54599 .60923 L p F P
0 0 0 r
s
.83 .24 .1 r
.20595 .5142 m
.19901 .49768 L
s
.19901 .49768 m
.16069 .47767 L
s
.24 .35 .67 r
.83931 .47767 m
.80099 .49768 L
s
.80099 .49768 m
.79405 .5142 L
s
.83 .24 .1 r
.45311 .6153 m
.45529 .61645 L
s
.24 .35 .67 r
.54471 .61645 m
.54689 .6153 L
s
1 .306 .13 r
.53596 .60363 m .5309 .60081 L .51552 .61692 L p F P
0 0 0 r
s
.83 .24 .1 r
.5349 .60304 m
.53557 .60251 L
s
1 .306 .13 r
.51295 .61552 m .51552 .61692 L .5309 .60081 L p F P
0 0 0 r
s
.271 .403 .799 r
.48448 .61692 m .48705 .61552 L .47418 .59797 L p F P
0 0 0 r
s
.271 .403 .799 r
.47418 .59797 m .4691 .60081 L .48448 .61692 L p F P
0 0 0 r
s
1 .308 .13 r
.54099 .60644 m .54599 .60923 L .56773 .59439 L p F P
0 0 0 r
s
.258 .381 .76 r
.45401 .60923 m .45901 .60644 L .43957 .59022 L p F P
0 0 0 r
s
.24 .35 .67 r
.45329 .60874 m
.45353 .6086 L
s
.258 .381 .76 r
.43957 .59022 m .43227 .59439 L .45401 .60923 L p F P
0 0 0 r
s
.83 .24 .1 r
.15868 .45669 m
.16069 .47767 L
s
.24 .35 .67 r
.84132 .45669 m
.83931 .47767 L
s
.83 .24 .1 r
.25527 .54493 m
.24355 .53361 L
s
.24355 .53361 m
.20595 .5142 L
s
.24 .35 .67 r
.79405 .5142 m
.75645 .53361 L
s
.75645 .53361 m
.74473 .54493 L
s
.08 .105 .237 r
.41704 .4104 m .43307 .39961 L .43461 .3814 L p F P
0 0 0 r
s
.24 .35 .67 r
.41793 .41137 m
.41819 .40963 L
s
.08 .105 .237 r
.45055 .37053 m .43461 .3814 L .43307 .39961 L p F P
0 0 0 r
s
.831 .224 .089 r
.56539 .3814 m .54945 .37053 L .55062 .38863 L p F P
0 0 0 r
s
.831 .224 .089 r
.55062 .38863 m .56693 .39961 L .56539 .3814 L p F P
0 0 0 r
s
1 .292 .121 r
.61799 .50642 m .60401 .49755 L .59478 .52104 L p F P
0 0 0 r
s
1 .292 .121 r
.59478 .52104 m .60758 .52897 L .61799 .50642 L p F P
0 0 0 r
s
.194 .28 .573 r
.39599 .49755 m .38201 .50642 L .39242 .52897 L p F P
0 0 0 r
s
.173 .246 .511 r
.38201 .50642 m .39599 .49755 L .38959 .47434 L p F P
0 0 0 r
s
1 .306 .13 r
.5309 .60081 m .52582 .59797 L .51295 .61552 L p F P
0 0 0 r
s
1 .306 .13 r
.51037 .61411 m .51295 .61552 L .52582 .59797 L p F P
0 0 0 r
s
.271 .403 .799 r
.48705 .61552 m .48963 .61411 L .47929 .59512 L p F P
0 0 0 r
s
.271 .403 .799 r
.47929 .59512 m .47418 .59797 L .48705 .61552 L p F P
0 0 0 r
s
.83 .24 .1 r
.30818 .56936 m
.2921 .56386 L
s
.2921 .56386 m
.25527 .54493 L
s
.24 .35 .67 r
.74473 .54493 m
.7079 .56386 L
s
.7079 .56386 m
.69182 .56936 L
s
1 .304 .127 r
.6054 .55761 m .59425 .55089 L .57837 .57152 L p F P
0 0 0 r
s
1 .304 .127 r
.57837 .57152 m .58773 .57701 L .6054 .55761 L p F P
0 0 0 r
s
.229 .334 .674 r
.40575 .55089 m .3946 .55761 L .41227 .57701 L p F P
0 0 0 r
s
.213 .308 .627 r
.3946 .55761 m .40575 .55089 L .39242 .52897 L p F P
0 0 0 r
s
.83 .24 .1 r
.39893 .60545 m
.42126 .59844 L
s
.39893 .60545 m
.36388 .58721 L
s
.24 .35 .67 r
.63612 .58721 m
.60107 .60545 L
s
.57874 .59844 m
.60107 .60545 L
s
.83 .24 .1 r
.36388 .58721 m
.34416 .5879 L
s
.34416 .5879 m
.30818 .56936 L
s
.24 .35 .67 r
.69182 .56936 m
.65584 .5879 L
s
.65584 .5879 m
.63612 .58721 L
s
1 .307 .128 r
.56043 .59022 m .56773 .59439 L .58773 .57701 L p F P
0 0 0 r
s
1 .308 .13 r
.56773 .59439 m .56043 .59022 L .54099 .60644 L p F P
0 0 0 r
s
.244 .358 .718 r
.43227 .59439 m .43957 .59022 L .42163 .57152 L p F P
0 0 0 r
s
.244 .358 .718 r
.42163 .57152 m .41227 .57701 L .43227 .59439 L p F P
0 0 0 r
s
1 .306 .13 r
.52582 .59797 m .52071 .59512 L .51037 .61411 L p F P
0 0 0 r
s
1 .306 .13 r
.50779 .6127 m .51037 .61411 L .52071 .59512 L p F P
0 0 0 r
s
.271 .403 .799 r
.48963 .61411 m .49221 .6127 L .48443 .59226 L p F P
0 0 0 r
s
.271 .403 .799 r
.48443 .59226 m .47929 .59512 L .48963 .61411 L p F P
0 0 0 r
s
1 .308 .13 r
.53596 .60363 m .54099 .60644 L .56043 .59022 L p F P
0 0 0 r
s
.83 .24 .1 r
.53557 .60251 m
.53677 .60318 L
s
.258 .381 .76 r
.45901 .60644 m .46404 .60363 L .44692 .58601 L p F P
0 0 0 r
s
.24 .35 .67 r
.45837 .6059 m
.45861 .60576 L
s
.46348 .60305 m
.46443 .60251 L
s
.258 .381 .76 r
.44692 .58601 m .43957 .59022 L .45901 .60644 L p F P
0 0 0 r
s
1 .307 .128 r
.58773 .57701 m .57837 .57152 L .56043 .59022 L p F P
0 0 0 r
s
.229 .334 .674 r
.41227 .57701 m .42163 .57152 L .40575 .55089 L p F P
0 0 0 r
s
.173 .246 .511 r
.4046 .46459 m .38959 .47434 L .39599 .49755 L p F P
0 0 0 r
s
.24 .35 .67 r
.39068 .47138 m
.39111 .47335 L
s
.148 .206 .436 r
.38959 .47434 m .4046 .46459 L .40162 .44186 L p F P
0 0 0 r
s
1 .283 .116 r
.61041 .47434 m .5954 .46459 L .58983 .48855 L p F P
0 0 0 r
s
1 .283 .116 r
.58983 .48855 m .60401 .49755 L .61041 .47434 L p F P
0 0 0 r
s
.24 .35 .67 r
.62227 .23433 m
.6396 .23463 L
s
.67534 .21012 m
.6396 .23463 L
s
.83 .24 .1 r
.3604 .23463 m
.32466 .21012 L
s
.3604 .23463 m
.37773 .23433 L
s
.116 .157 .342 r
.40162 .44186 m .41734 .43146 L .41704 .4104 L p F P
0 0 0 r
s
.116 .157 .342 r
.43307 .39961 m .41704 .4104 L .41734 .43146 L p F P
0 0 0 r
s
.916 .251 .101 r
.58296 .4104 m .56693 .39961 L .56669 .42088 L p F P
0 0 0 r
s
.83 .24 .1 r
.58177 .41117 m
.58207 .41137 L
s
.916 .251 .101 r
.56669 .42088 m .58266 .43146 L .58296 .4104 L p F P
0 0 0 r
s
.24 .35 .67 r
.67534 .21012 m
.69445 .21696 L
s
.83 .24 .1 r
.32466 .21012 m
.30555 .21696 L
s
1 .306 .13 r
.52071 .59512 m .51557 .59226 L .50779 .6127 L p F P
0 0 0 r
s
1 .306 .13 r
.5052 .61129 m .50779 .6127 L .51557 .59226 L p F P
0 0 0 r
s
.271 .403 .799 r
.49221 .6127 m .4948 .61129 L .48959 .58938 L p F P
0 0 0 r
s
.271 .403 .799 r
.48959 .58938 m .48443 .59226 L .49221 .6127 L p F P
0 0 0 r
s
.83 .24 .1 r
.47899 .60333 m
.48922 .60888 L
s
.971 .27 .11 r
.59838 .44186 m .58266 .43146 L .58014 .45469 L p F P
0 0 0 r
s
.971 .27 .11 r
.58014 .45469 m .5954 .46459 L .59838 .44186 L p F P
0 0 0 r
s
.148 .206 .436 r
.41734 .43146 m .40162 .44186 L .4046 .46459 L p F P
0 0 0 r
s
.24 .35 .67 r
.57256 .26487 m
.58738 .25846 L
s
.62227 .23433 m
.58738 .25846 L
s
.83 .24 .1 r
.41262 .25846 m
.37773 .23433 L
s
.41262 .25846 m
.42744 .26487 L
s
.024 .035 .067 r
.48408 .33484 m .5 .32387 L .5 .316 L p F P
0 0 0 r
s
.043 .059 .127 r
.45055 .37053 m .46675 .35947 L .46841 .34563 L p F P
0 0 0 r
s
.043 .059 .127 r
.48408 .33484 m .46841 .34563 L .46675 .35947 L p F P
0 0 0 r
s
.698 .183 .07 r
.53159 .34563 m .51592 .33484 L .51676 .34822 L p F P
0 0 0 r
s
.698 .183 .07 r
.51676 .34822 m .53325 .35947 L .53159 .34563 L p F P
0 0 0 r
s
.83 .24 .1 r
.46155 .28851 m
.42744 .26487 L
s
.46155 .28851 m
.47313 .30147 L
s
.24 .35 .67 r
.52687 .30147 m
.53845 .28851 L
s
.57256 .26487 m
.53845 .28851 L
s
1 .306 .13 r
.51557 .59226 m .51041 .58938 L .5052 .61129 L p F P
0 0 0 r
s
.24 .35 .67 r
.51078 .60888 m
.52101 .60333 L
s
1 .306 .13 r
.5026 .60988 m .5052 .61129 L .51041 .58938 L p F P
0 0 0 r
s
.271 .403 .799 r
.4948 .61129 m .4974 .60988 L .49478 .58648 L p F P
0 0 0 r
s
.271 .403 .799 r
.49478 .58648 m .48959 .58938 L .4948 .61129 L p F P
0 0 0 r
s
.83 .24 .1 r
.48922 .60888 m
.49233 .61056 L
s
1 .299 .124 r
.60758 .52897 m .59478 .52104 L .58296 .54408 L p F P
0 0 0 r
s
.83 .24 .1 r
.60725 .52917 m
.6074 .52926 L
s
1 .299 .124 r
.58296 .54408 m .59425 .55089 L .60758 .52897 L p F P
0 0 0 r
s
.213 .308 .627 r
.40522 .52104 m .39242 .52897 L .40575 .55089 L p F P
0 0 0 r
s
.194 .28 .573 r
.39242 .52897 m .40522 .52104 L .39599 .49755 L p F P
0 0 0 r
s
1 .308 .13 r
.56043 .59022 m .55308 .58601 L .53596 .60363 L p F P
0 0 0 r
s
1 .308 .13 r
.5309 .60081 m .53596 .60363 L .55308 .58601 L p F P
0 0 0 r
s
.24 .35 .67 r
.52101 .60333 m
.54471 .61645 L
s
.258 .381 .76 r
.46404 .60363 m .4691 .60081 L .45433 .58178 L p F P
0 0 0 r
s
.258 .381 .76 r
.45433 .58178 m .44692 .58601 L .46404 .60363 L p F P
0 0 0 r
s
.83 .24 .1 r
.45529 .61645 m
.47899 .60333 L
s
.42126 .59844 m
.45311 .6153 L
s
.47313 .30147 m
.49908 .31939 L
s
.24 .35 .67 r
.50092 .31939 m
.52687 .30147 L
s
1 .307 .128 r
.55308 .58601 m .56043 .59022 L .57837 .57152 L p F P
0 0 0 r
s
.244 .358 .718 r
.43957 .59022 m .44692 .58601 L .43109 .56596 L p F P
0 0 0 r
s
.244 .358 .718 r
.43109 .56596 m .42163 .57152 L .43957 .59022 L p F P
0 0 0 r
s
1 .306 .13 r
.51041 .58938 m .50522 .58648 L .5026 .60988 L p F P
0 0 0 r
s
.24 .35 .67 r
.50767 .61056 m
.51078 .60888 L
s
1 .306 .13 r
.5 .60846 m .5026 .60988 L .50522 .58648 L p F P
0 0 0 r
s
.271 .403 .799 r
.4974 .60988 m .5 .60846 L .5 .58357 L p F P
0 0 0 r
s
.271 .403 .799 r
.5 .58357 m .49478 .58648 L .4974 .60988 L p F P
0 0 0 r
s
1 .304 .127 r
.59425 .55089 m .58296 .54408 L .56891 .56596 L p F P
0 0 0 r
s
1 .304 .127 r
.56891 .56596 m .57837 .57152 L .59425 .55089 L p F P
0 0 0 r
s
.83 .24 .1 r
.57765 .55098 m
.57829 .55136 L
s
.229 .334 .674 r
.41704 .54408 m .40575 .55089 L .42163 .57152 L p F P
0 0 0 r
s
.213 .308 .627 r
.40575 .55089 m .41704 .54408 L .40522 .52104 L p F P
0 0 0 r
s
1 .306 .13 r
.50522 .58648 m .5 .58357 L .5 .60846 L p F P
0 0 0 r
s
1 .307 .128 r
.57837 .57152 m .56891 .56596 L .55308 .58601 L p F P
0 0 0 r
s
.229 .334 .674 r
.42163 .57152 m .43109 .56596 L .41704 .54408 L p F P
0 0 0 r
s
.24 .35 .67 r
.42171 .55136 m
.42235 .55098 L
s
1 .308 .13 r
.55308 .58601 m .54567 .58178 L .5309 .60081 L p F P
0 0 0 r
s
.24 .35 .67 r
.54689 .6153 m
.57874 .59844 L
s
1 .308 .13 r
.52582 .59797 m .5309 .60081 L .54567 .58178 L p F P
0 0 0 r
s
.258 .381 .76 r
.4691 .60081 m .47418 .59797 L .46179 .57751 L p F P
0 0 0 r
s
.24 .35 .67 r
.46861 .60018 m
.46886 .60004 L
s
.258 .381 .76 r
.46179 .57751 m .45433 .58178 L .4691 .60081 L p F P
0 0 0 r
s
1 .292 .121 r
.60401 .49755 m .58983 .48855 L .58179 .513 L p F P
0 0 0 r
s
1 .292 .121 r
.58179 .513 m .59478 .52104 L .60401 .49755 L p F P
0 0 0 r
s
.83 .24 .1 r
.59375 .52081 m
.59387 .52048 L
s
.59375 .52081 m
.59462 .52135 L
s
.194 .28 .573 r
.41017 .48855 m .39599 .49755 L .40522 .52104 L p F P
0 0 0 r
s
.24 .35 .67 r
.40538 .52135 m
.40625 .52081 L
s
.39663 .49509 m
.39725 .49675 L
s
.40555 .51893 m
.40625 .52081 L
s
.173 .246 .511 r
.39599 .49755 m .41017 .48855 L .4046 .46459 L p F P
0 0 0 r
s
.08 .105 .237 r
.43307 .39961 m .44938 .38863 L .45055 .37053 L p F P
0 0 0 r
s
.08 .105 .237 r
.46675 .35947 m .45055 .37053 L .44938 .38863 L p F P
0 0 0 r
s
.831 .224 .089 r
.54945 .37053 m .53325 .35947 L .53404 .37747 L p F P
0 0 0 r
s
.831 .224 .089 r
.53404 .37747 m .55062 .38863 L .54945 .37053 L p F P
0 0 0 r
s
.83 .24 .1 r
.54983 .3881 m
.55007 .38985 L
s
1 .307 .128 r
.54567 .58178 m .55308 .58601 L .56891 .56596 L p F P
0 0 0 r
s
.244 .358 .718 r
.44692 .58601 m .45433 .58178 L .44064 .56036 L p F P
0 0 0 r
s
.244 .358 .718 r
.44064 .56036 m .43109 .56596 L .44692 .58601 L p F P
0 0 0 r
s
.83 .24 .1 r
.56515 .56852 m
.57765 .55098 L
s
.24 .35 .67 r
.42235 .55098 m
.43245 .56516 L
s
1 .308 .13 r
.54567 .58178 m .53821 .57751 L .52582 .59797 L p F P
0 0 0 r
s
1 .308 .13 r
.52071 .59512 m .52582 .59797 L .53821 .57751 L p F P
0 0 0 r
s
.258 .381 .76 r
.47418 .59797 m .47929 .59512 L .46932 .5732 L p F P
0 0 0 r
s
.24 .35 .67 r
.47377 .5973 m
.47402 .59716 L
s
.258 .381 .76 r
.46932 .5732 m .46179 .57751 L .47418 .59797 L p F P
0 0 0 r
s
.173 .246 .511 r
.41986 .45469 m .4046 .46459 L .41017 .48855 L p F P
0 0 0 r
s
.148 .206 .436 r
.4046 .46459 m .41986 .45469 L .41734 .43146 L p F P
0 0 0 r
s
1 .283 .116 r
.5954 .46459 m .58014 .45469 L .57542 .47941 L p F P
0 0 0 r
s
1 .283 .116 r
.57542 .47941 m .58983 .48855 L .5954 .46459 L p F P
0 0 0 r
s
.116 .157 .342 r
.41734 .43146 m .43331 .42088 L .43307 .39961 L p F P
0 0 0 r
s
.116 .157 .342 r
.44938 .38863 m .43307 .39961 L .43331 .42088 L p F P
0 0 0 r
s
.24 .35 .67 r
.44819 .39102 m
.44993 .38985 L
s
.916 .251 .101 r
.56693 .39961 m .55062 .38863 L .55044 .41012 L p F P
0 0 0 r
s
.83 .24 .1 r
.55007 .38985 m
.55061 .39021 L
s
.56572 .40038 m
.56691 .40117 L
s
.916 .251 .101 r
.55044 .41012 m .56669 .42088 L .56693 .39961 L p F P
0 0 0 r
s
.83 .24 .1 r
.49145 .59328 m
.49396 .59125 L
s
.4768 .60214 m
.47899 .60333 L
s
.24 .35 .67 r
.52101 .60333 m
.5232 .60214 L
s
.50604 .59125 m
.50855 .59328 L
s
1 .299 .124 r
.59478 .52104 m .58179 .513 L .57153 .53719 L p F P
0 0 0 r
s
1 .299 .124 r
.57153 .53719 m .58296 .54408 L .59478 .52104 L p F P
0 0 0 r
s
.83 .24 .1 r
.57765 .55098 m
.58173 .54334 L
s
.213 .308 .627 r
.41821 .513 m .40522 .52104 L .41704 .54408 L p F P
0 0 0 r
s
.24 .35 .67 r
.41715 .54123 m
.42235 .55098 L
s
.194 .28 .573 r
.40522 .52104 m .41821 .513 L .41017 .48855 L p F P
0 0 0 r
s
.971 .27 .11 r
.58266 .43146 m .56669 .42088 L .56463 .44463 L p F P
0 0 0 r
s
.971 .27 .11 r
.56463 .44463 m .58014 .45469 L .58266 .43146 L p F P
0 0 0 r
s
.148 .206 .436 r
.43331 .42088 m .41734 .43146 L .41986 .45469 L p F P
0 0 0 r
s
.043 .059 .127 r
.46675 .35947 m .48324 .34822 L .48408 .33484 L p F P
0 0 0 r
s
.043 .059 .127 r
.5 .32387 m .48408 .33484 L .48324 .34822 L p F P
0 0 0 r
s
.698 .183 .07 r
.51592 .33484 m .5 .32387 L .5 .33679 L p F P
0 0 0 r
s
.698 .183 .07 r
.5 .33679 m .51676 .34822 L .51592 .33484 L p F P
0 0 0 r
s
1 .304 .127 r
.55936 .56036 m .56891 .56596 L .58296 .54408 L p F P
0 0 0 r
s
1 .307 .128 r
.56891 .56596 m .55936 .56036 L .54567 .58178 L p F P
0 0 0 r
s
.229 .334 .674 r
.43109 .56596 m .44064 .56036 L .42847 .53719 L p F P
0 0 0 r
s
.229 .334 .674 r
.42847 .53719 m .41704 .54408 L .43109 .56596 L p F P
0 0 0 r
s
1 .308 .13 r
.53821 .57751 m .53068 .5732 L .52071 .59512 L p F P
0 0 0 r
s
1 .308 .13 r
.51557 .59226 m .52071 .59512 L .53068 .5732 L p F P
0 0 0 r
s
.24 .35 .67 r
.50855 .59328 m
.52101 .60333 L
s
.258 .381 .76 r
.47929 .59512 m .48443 .59226 L .4769 .56887 L p F P
0 0 0 r
s
.24 .35 .67 r
.47896 .5944 m
.47921 .59426 L
s
.258 .381 .76 r
.4769 .56887 m .46932 .5732 L .47929 .59512 L p F P
0 0 0 r
s
.83 .24 .1 r
.47899 .60333 m
.49145 .59328 L
s
.44494 .58487 m
.4768 .60214 L
s
1 .304 .127 r
.58296 .54408 m .57153 .53719 L .55936 .56036 L p F P
0 0 0 r
s
.213 .308 .627 r
.41704 .54408 m .42847 .53719 L .41821 .513 L p F P
0 0 0 r
s
1 .307 .128 r
.53821 .57751 m .54567 .58178 L .55936 .56036 L p F P
0 0 0 r
s
.244 .358 .718 r
.45433 .58178 m .46179 .57751 L .45028 .55469 L p F P
0 0 0 r
s
.244 .358 .718 r
.45028 .55469 m .44064 .56036 L .45433 .58178 L p F P
0 0 0 r
s
1 .308 .13 r
.53068 .5732 m .5231 .56887 L .51557 .59226 L p F P
0 0 0 r
s
.24 .35 .67 r
.5232 .60214 m
.55506 .58487 L
s
1 .308 .13 r
.51041 .58938 m .51557 .59226 L .5231 .56887 L p F P
0 0 0 r
s
.258 .381 .76 r
.48443 .59226 m .48959 .58938 L .48454 .5645 L p F P
0 0 0 r
s
.24 .35 .67 r
.48418 .59149 m
.48443 .59135 L
s
.258 .381 .76 r
.48454 .5645 m .4769 .56887 L .48443 .59226 L p F P
0 0 0 r
s
1 .292 .121 r
.58983 .48855 m .57542 .47941 L .56863 .50486 L p F P
0 0 0 r
s
1 .292 .121 r
.56863 .50486 m .58179 .513 L .58983 .48855 L p F P
0 0 0 r
s
.194 .28 .573 r
.42458 .47941 m .41017 .48855 L .41821 .513 L p F P
0 0 0 r
s
.173 .246 .511 r
.41017 .48855 m .42458 .47941 L .41986 .45469 L p F P
0 0 0 r
s
.83 .24 .1 r
.16069 .47767 m
.16707 .49412 L
s
.24 .35 .67 r
.83931 .47767 m
.83293 .49412 L
s
.83 .24 .1 r
.42126 .59844 m
.44494 .58487 L
s
.42126 .59844 m
.38607 .5798 L
s
.24 .35 .67 r
.61393 .5798 m
.57874 .59844 L
s
.57874 .59844 m
.55506 .58487 L
s
.83 .24 .1 r
.21719 .52535 m
.20595 .5142 L
s
.20595 .5142 m
.16707 .49412 L
s
.24 .35 .67 r
.83293 .49412 m
.79405 .5142 L
s
.79405 .5142 m
.78281 .52535 L
s
.08 .105 .237 r
.44938 .38863 m .46596 .37747 L .46675 .35947 L p F P
0 0 0 r
s
.24 .35 .67 r
.44993 .38985 m
.45017 .3881 L
s
.08 .105 .237 r
.48324 .34822 m .46675 .35947 L .46596 .37747 L p F P
0 0 0 r
s
.831 .224 .089 r
.53325 .35947 m .51676 .34822 L .51717 .36611 L p F P
0 0 0 r
s
.831 .224 .089 r
.51717 .36611 m .53404 .37747 L .53325 .35947 L p F P
0 0 0 r
s
1 .307 .128 r
.55936 .56036 m .54972 .55469 L .53821 .57751 L p F P
0 0 0 r
s
1 .307 .128 r
.53068 .5732 m .53821 .57751 L .54972 .55469 L p F P
0 0 0 r
s
.244 .358 .718 r
.46179 .57751 m .46932 .5732 L .46003 .54897 L p F P
0 0 0 r
s
.244 .358 .718 r
.46003 .54897 m .45028 .55469 L .46179 .57751 L p F P
0 0 0 r
s
1 .304 .127 r
.54972 .55469 m .55936 .56036 L .57153 .53719 L p F P
0 0 0 r
s
.229 .334 .674 r
.44064 .56036 m .45028 .55469 L .44003 .53022 L p F P
0 0 0 r
s
.229 .334 .674 r
.44003 .53022 m .42847 .53719 L .44064 .56036 L p F P
0 0 0 r
s
.83 .24 .1 r
.27097 .55019 m
.25527 .54493 L
s
.25527 .54493 m
.21719 .52535 L
s
.24 .35 .67 r
.78281 .52535 m
.74473 .54493 L
s
.74473 .54493 m
.72903 .55019 L
s
1 .308 .13 r
.5231 .56887 m .51546 .5645 L .51041 .58938 L p F P
0 0 0 r
s
1 .308 .13 r
.50522 .58648 m .51041 .58938 L .51546 .5645 L p F P
0 0 0 r
s
.258 .381 .76 r
.48959 .58938 m .49478 .58648 L .49224 .56009 L p F P
0 0 0 r
s
.24 .35 .67 r
.48943 .58856 m
.48968 .58842 L
s
.258 .381 .76 r
.49224 .56009 m .48454 .5645 L .48959 .58938 L p F P
0 0 0 r
s
.83 .24 .1 r
.38607 .5798 m
.36388 .58721 L
s
.36388 .58721 m
.32763 .56835 L
s
.24 .35 .67 r
.67237 .56835 m
.63612 .58721 L
s
.63612 .58721 m
.61393 .5798 L
s
.83 .24 .1 r
.32763 .56835 m
.30818 .56936 L
s
.30818 .56936 m
.27097 .55019 L
s
.24 .35 .67 r
.72903 .55019 m
.69182 .56936 L
s
.69182 .56936 m
.67237 .56835 L
s
1 .299 .124 r
.58179 .513 m .56863 .50486 L .55997 .53022 L p F P
0 0 0 r
s
.83 .24 .1 r
.5815 .51323 m
.58166 .51333 L
s
1 .299 .124 r
.55997 .53022 m .57153 .53719 L .58179 .513 L p F P
0 0 0 r
s
.213 .308 .627 r
.43137 .50486 m .41821 .513 L .42847 .53719 L p F P
0 0 0 r
s
.194 .28 .573 r
.41821 .513 m .43137 .50486 L .42458 .47941 L p F P
0 0 0 r
s
1 .283 .116 r
.58014 .45469 m .56463 .44463 L .5608 .47013 L p F P
0 0 0 r
s
1 .283 .116 r
.5608 .47013 m .57542 .47941 L .58014 .45469 L p F P
0 0 0 r
s
.173 .246 .511 r
.43537 .44463 m .41986 .45469 L .42458 .47941 L p F P
0 0 0 r
s
.24 .35 .67 r
.42188 .44962 m
.42262 .4529 L
s
.148 .206 .436 r
.41986 .45469 m .43537 .44463 L .43331 .42088 L p F P
0 0 0 r
s
1 .304 .127 r
.57153 .53719 m .55997 .53022 L .54972 .55469 L p F P
0 0 0 r
s
.213 .308 .627 r
.42847 .53719 m .44003 .53022 L .43137 .50486 L p F P
0 0 0 r
s
.24 .35 .67 r
.65837 .20938 m
.67534 .21012 L
s
.83 .24 .1 r
.34163 .20938 m
.32466 .21012 L
s
.116 .157 .342 r
.43331 .42088 m .44956 .41012 L .44938 .38863 L p F P
0 0 0 r
s
.116 .157 .342 r
.46596 .37747 m .44938 .38863 L .44956 .41012 L p F P
0 0 0 r
s
.916 .251 .101 r
.55062 .38863 m .53404 .37747 L .53391 .39918 L p F P
0 0 0 r
s
.83 .24 .1 r
.5494 .3894 m
.55007 .38985 L
s
.916 .251 .101 r
.53391 .39918 m .55044 .41012 L .55062 .38863 L p F P
0 0 0 r
s
.043 .059 .127 r
.48324 .34822 m .5 .33679 L .5 .32387 L p F P
0 0 0 r
s
.971 .27 .11 r
.56669 .42088 m .55044 .41012 L .54887 .4344 L p F P
0 0 0 r
s
.971 .27 .11 r
.54887 .4344 m .56463 .44463 L .56669 .42088 L p F P
0 0 0 r
s
.148 .206 .436 r
.44956 .41012 m .43331 .42088 L .43537 .44463 L p F P
0 0 0 r
s
.24 .35 .67 r
.60785 .24042 m
.62227 .23433 L
s
.65837 .20938 m
.62227 .23433 L
s
.83 .24 .1 r
.37773 .23433 m
.34163 .20938 L
s
.37773 .23433 m
.39215 .24042 L
s
1 .308 .13 r
.51546 .5645 m .50776 .56009 L .50522 .58648 L p F P
0 0 0 r
s
1 .308 .13 r
.5 .58357 m .50522 .58648 L .50776 .56009 L p F P
0 0 0 r
s
.258 .381 .76 r
.49478 .58648 m .5 .58357 L .5 .55565 L p F P
0 0 0 r
s
.24 .35 .67 r
.4947 .58561 m
.49495 .58547 L
s
.258 .381 .76 r
.5 .55565 m .49224 .56009 L .49478 .58648 L p F P
0 0 0 r
s
.83 .24 .1 r
.4922 .5783 m
.49493 .57982 L
s
.49493 .57982 m
.49691 .58093 L
s
.5 .58265 m
.50026 .5828 L
s
.24 .35 .67 r
.5 .58265 m
.50037 .58245 L
s
1 .307 .128 r
.54972 .55469 m .53997 .54897 L .53068 .5732 L p F P
0 0 0 r
s
1 .307 .128 r
.5231 .56887 m .53068 .5732 L .53997 .54897 L p F P
0 0 0 r
s
.244 .358 .718 r
.46932 .5732 m .4769 .56887 L .46987 .54319 L p F P
0 0 0 r
s
.244 .358 .718 r
.46987 .54319 m .46003 .54897 L .46932 .5732 L p F P
0 0 0 r
s
.83 .24 .1 r
.42744 .26487 m
.39215 .24042 L
s
.42744 .26487 m
.4386 .27762 L
s
.24 .35 .67 r
.5614 .27762 m
.57256 .26487 L
s
.60785 .24042 m
.57256 .26487 L
s
.83 .24 .1 r
.48038 .32037 m
.49911 .33317 L
s
.24 .35 .67 r
.50089 .33317 m
.51962 .32037 L
s
.83 .24 .1 r
.47313 .30147 m
.4386 .27762 L
s
.47313 .30147 m
.48038 .32037 L
s
.24 .35 .67 r
.51962 .32037 m
.52687 .30147 L
s
.5614 .27762 m
.52687 .30147 L
s
1 .304 .127 r
.53997 .54897 m .54972 .55469 L .55997 .53022 L p F P
0 0 0 r
s
.229 .334 .674 r
.45028 .55469 m .46003 .54897 L .45173 .52316 L p F P
0 0 0 r
s
.229 .334 .674 r
.45173 .52316 m .44003 .53022 L .45028 .55469 L p F P
0 0 0 r
s
1 .308 .13 r
.50776 .56009 m .5 .55565 L .5 .58357 L p F P
0 0 0 r
s
.24 .35 .67 r
.50507 .57982 m
.5078 .5783 L
s
.50309 .58093 m
.50507 .57982 L
s
1 .292 .121 r
.57542 .47941 m .5608 .47013 L .55529 .4966 L p F P
0 0 0 r
s
1 .292 .121 r
.55529 .4966 m .56863 .50486 L .57542 .47941 L p F P
0 0 0 r
s
.194 .28 .573 r
.4392 .47013 m .42458 .47941 L .43137 .50486 L p F P
0 0 0 r
s
.173 .246 .511 r
.42458 .47941 m .4392 .47013 L .43537 .44463 L p F P
0 0 0 r
s
1 .307 .128 r
.53997 .54897 m .53013 .54319 L .5231 .56887 L p F P
0 0 0 r
s
1 .307 .128 r
.51546 .5645 m .5231 .56887 L .53013 .54319 L p F P
0 0 0 r
s
.24 .35 .67 r
.5078 .5783 m
.53124 .56521 L
s
.244 .358 .718 r
.4769 .56887 m .48454 .5645 L .47981 .53736 L p F P
0 0 0 r
s
.244 .358 .718 r
.47981 .53736 m .46987 .54319 L .4769 .56887 L p F P
0 0 0 r
s
.83 .24 .1 r
.46876 .56521 m
.4922 .5783 L
s
1 .299 .124 r
.54827 .52316 m .55997 .53022 L .56863 .50486 L p F P
0 0 0 r
s
1 .304 .127 r
.55997 .53022 m .54827 .52316 L .53997 .54897 L p F P
0 0 0 r
s
.213 .308 .627 r
.44003 .53022 m .45173 .52316 L .44471 .4966 L p F P
0 0 0 r
s
.213 .308 .627 r
.44471 .4966 m .43137 .50486 L .44003 .53022 L p F P
0 0 0 r
s
1 .299 .124 r
.56863 .50486 m .55529 .4966 L .54827 .52316 L p F P
0 0 0 r
s
.194 .28 .573 r
.43137 .50486 m .44471 .4966 L .4392 .47013 L p F P
0 0 0 r
s
.08 .105 .237 r
.46596 .37747 m .48283 .36611 L .48324 .34822 L p F P
0 0 0 r
s
.08 .105 .237 r
.5 .33679 m .48324 .34822 L .48283 .36611 L p F P
0 0 0 r
s
.831 .224 .089 r
.51676 .34822 m .5 .33679 L .5 .35455 L p F P
0 0 0 r
s
.831 .224 .089 r
.5 .35455 m .51717 .36611 L .51676 .34822 L p F P
0 0 0 r
s
.83 .24 .1 r
.51677 .36584 m
.51698 .36759 L
s
1 .283 .116 r
.56463 .44463 m .54887 .4344 L .54595 .46071 L p F P
0 0 0 r
s
1 .283 .116 r
.54595 .46071 m .5608 .47013 L .56463 .44463 L p F P
0 0 0 r
s
.173 .246 .511 r
.45113 .4344 m .43537 .44463 L .4392 .47013 L p F P
0 0 0 r
s
.148 .206 .436 r
.43537 .44463 m .45113 .4344 L .44956 .41012 L p F P
0 0 0 r
s
1 .304 .127 r
.53013 .54319 m .53997 .54897 L .54827 .52316 L p F P
0 0 0 r
s
.229 .334 .674 r
.46003 .54897 m .46987 .54319 L .46358 .51602 L p F P
0 0 0 r
s
.229 .334 .674 r
.46358 .51602 m .45173 .52316 L .46003 .54897 L p F P
0 0 0 r
s
.83 .24 .1 r
.44494 .58487 m
.46876 .56521 L
s
.44494 .58487 m
.40971 .56576 L
s
.24 .35 .67 r
.59029 .56576 m
.55506 .58487 L
s
.53124 .56521 m
.55506 .58487 L
s
.916 .251 .101 r
.53404 .37747 m .51717 .36611 L .5171 .38805 L p F P
0 0 0 r
s
.83 .24 .1 r
.51698 .36759 m
.51716 .36772 L
s
.5328 .37824 m
.53403 .37906 L
s
.916 .251 .101 r
.5171 .38805 m .53391 .39918 L .53404 .37747 L p F P
0 0 0 r
s
.116 .157 .342 r
.44956 .41012 m .46609 .39918 L .46596 .37747 L p F P
0 0 0 r
s
.116 .157 .342 r
.48283 .36611 m .46596 .37747 L .46609 .39918 L p F P
0 0 0 r
s
.24 .35 .67 r
.48159 .36856 m
.48302 .36759 L
s
.971 .27 .11 r
.55044 .41012 m .53391 .39918 L .53285 .424 L p F P
0 0 0 r
s
.971 .27 .11 r
.53285 .424 m .54887 .4344 L .55044 .41012 L p F P
0 0 0 r
s
.148 .206 .436 r
.46609 .39918 m .44956 .41012 L .45113 .4344 L p F P
0 0 0 r
s
1 .307 .128 r
.53013 .54319 m .52019 .53736 L .51546 .5645 L p F P
0 0 0 r
s
1 .307 .128 r
.50776 .56009 m .51546 .5645 L .52019 .53736 L p F P
0 0 0 r
s
.244 .358 .718 r
.48454 .5645 m .49224 .56009 L .48985 .53146 L p F P
0 0 0 r
s
.244 .358 .718 r
.48985 .53146 m .47981 .53736 L .48454 .5645 L p F P
0 0 0 r
s
1 .292 .121 r
.5608 .47013 m .54595 .46071 L .54176 .48822 L p F P
0 0 0 r
s
1 .292 .121 r
.54176 .48822 m .55529 .4966 L .5608 .47013 L p F P
0 0 0 r
s
.194 .28 .573 r
.45405 .46071 m .4392 .47013 L .44471 .4966 L p F P
0 0 0 r
s
.173 .246 .511 r
.4392 .47013 m .45405 .46071 L .45113 .4344 L p F P
0 0 0 r
s
1 .299 .124 r
.53642 .51602 m .54827 .52316 L .55529 .4966 L p F P
0 0 0 r
s
1 .304 .127 r
.54827 .52316 m .53642 .51602 L .53013 .54319 L p F P
0 0 0 r
s
.213 .308 .627 r
.45173 .52316 m .46358 .51602 L .45824 .48822 L p F P
0 0 0 r
s
.213 .308 .627 r
.45824 .48822 m .44471 .4966 L .45173 .52316 L p F P
0 0 0 r
s
1 .299 .124 r
.55529 .4966 m .54176 .48822 L .53642 .51602 L p F P
0 0 0 r
s
.194 .28 .573 r
.44471 .4966 m .45824 .48822 L .45405 .46071 L p F P
0 0 0 r
s
1 .304 .127 r
.52019 .53736 m .53013 .54319 L .53642 .51602 L p F P
0 0 0 r
s
.229 .334 .674 r
.46987 .54319 m .47981 .53736 L .47557 .50879 L p F P
0 0 0 r
s
.229 .334 .674 r
.47557 .50879 m .46358 .51602 L .46987 .54319 L p F P
0 0 0 r
s
1 .307 .128 r
.52019 .53736 m .51015 .53146 L .50776 .56009 L p F P
0 0 0 r
s
1 .307 .128 r
.5 .55565 m .50776 .56009 L .51015 .53146 L p F P
0 0 0 r
s
.244 .358 .718 r
.49224 .56009 m .5 .55565 L .5 .5255 L p F P
0 0 0 r
s
.244 .358 .718 r
.5 .5255 m .48985 .53146 L .49224 .56009 L p F P
0 0 0 r
s
.83 .24 .1 r
.49144 .54036 m
.49514 .54249 L
s
.49514 .54249 m
.49833 .54433 L
s
.40971 .56576 m
.38607 .5798 L
s
.38607 .5798 m
.34965 .56053 L
s
.24 .35 .67 r
.65035 .56053 m
.61393 .5798 L
s
.61393 .5798 m
.59029 .56576 L
s
.83 .24 .1 r
.16707 .49412 m
.17779 .5051 L
s
.24 .35 .67 r
.83293 .49412 m
.82221 .5051 L
s
.08 .105 .237 r
.48283 .36611 m .5 .35455 L .5 .33679 L p F P
0 0 0 r
s
.24 .35 .67 r
.48302 .36759 m
.48323 .36584 L
s
.83 .24 .1 r
.23247 .53035 m
.21719 .52535 L
s
.21719 .52535 m
.17779 .5051 L
s
.24 .35 .67 r
.82221 .5051 m
.78281 .52535 L
s
.78281 .52535 m
.76753 .53035 L
s
.173 .246 .511 r
.46715 .424 m .45113 .4344 L .45405 .46071 L p F P
0 0 0 r
s
.24 .35 .67 r
.45415 .42729 m
.4552 .43175 L
s
.148 .206 .436 r
.45113 .4344 m .46715 .424 L .46609 .39918 L p F P
0 0 0 r
s
1 .283 .116 r
.54887 .4344 m .53285 .424 L .53087 .45115 L p F P
0 0 0 r
s
1 .283 .116 r
.53087 .45115 m .54595 .46071 L .54887 .4344 L p F P
0 0 0 r
s
.83 .24 .1 r
.34965 .56053 m
.32763 .56835 L
s
.32763 .56835 m
.29012 .54883 L
s
.24 .35 .67 r
.70988 .54883 m
.67237 .56835 L
s
.67237 .56835 m
.65035 .56053 L
s
.83 .24 .1 r
.29012 .54883 m
.27097 .55019 L
s
.27097 .55019 m
.23247 .53035 L
s
.24 .35 .67 r
.76753 .53035 m
.72903 .55019 L
s
.72903 .55019 m
.70988 .54883 L
s
1 .307 .128 r
.51015 .53146 m .5 .5255 L .5 .55565 L p F P
0 0 0 r
s
.24 .35 .67 r
.50167 .54433 m
.50486 .54249 L
s
.50486 .54249 m
.50856 .54036 L
s
.116 .157 .342 r
.46609 .39918 m .4829 .38805 L .48283 .36611 L p F P
0 0 0 r
s
.116 .157 .342 r
.5 .35455 m .48283 .36611 L .4829 .38805 L p F P
0 0 0 r
s
.916 .251 .101 r
.51717 .36611 m .5 .35455 L .5 .37673 L p F P
0 0 0 r
s
.83 .24 .1 r
.49938 .35576 m
.5 .35618 L
s
.51591 .36688 m
.51698 .36759 L
s
.24 .35 .67 r
.49873 .35703 m
.5 .35618 L
s
.50121 .35536 m
.51727 .34457 L
s
.916 .251 .101 r
.5 .37673 m .5171 .38805 L .51717 .36611 L p F P
0 0 0 r
s
.971 .27 .11 r
.53391 .39918 m .5171 .38805 L .51656 .41343 L p F P
0 0 0 r
s
.971 .27 .11 r
.51656 .41343 m .53285 .424 L .53391 .39918 L p F P
0 0 0 r
s
.148 .206 .436 r
.4829 .38805 m .46609 .39918 L .46715 .424 L p F P
0 0 0 r
s
1 .299 .124 r
.52443 .50879 m .53642 .51602 L .54176 .48822 L p F P
0 0 0 r
s
1 .304 .127 r
.53642 .51602 m .52443 .50879 L .52019 .53736 L p F P
0 0 0 r
s
.213 .308 .627 r
.46358 .51602 m .47557 .50879 L .47197 .47973 L p F P
0 0 0 r
s
.213 .308 .627 r
.47197 .47973 m .45824 .48822 L .46358 .51602 L p F P
0 0 0 r
s
.24 .35 .67 r
.64436 .21511 m
.65837 .20938 L
s
.83 .24 .1 r
.35564 .21511 m
.34163 .20938 L
s
1 .304 .127 r
.51015 .53146 m .52019 .53736 L .52443 .50879 L p F P
0 0 0 r
s
.229 .334 .674 r
.47981 .53736 m .48985 .53146 L .48771 .50147 L p F P
0 0 0 r
s
.229 .334 .674 r
.48771 .50147 m .47557 .50879 L .47981 .53736 L p F P
0 0 0 r
s
.83 .24 .1 r
.46876 .56521 m
.49144 .54036 L
s
.46876 .56521 m
.43361 .54558 L
s
.24 .35 .67 r
.56639 .54558 m
.53124 .56521 L
s
.50856 .54036 m
.53124 .56521 L
s
.83 .24 .1 r
.39215 .24042 m
.35564 .21511 L
s
.39215 .24042 m
.40288 .25295 L
s
.24 .35 .67 r
.59712 .25295 m
.60785 .24042 L
s
.64436 .21511 m
.60785 .24042 L
s
.83 .24 .1 r
.48038 .32037 m
.4454 .29645 L
s
.48038 .32037 m
.48273 .34457 L
s
.24 .35 .67 r
.51727 .34457 m
.51962 .32037 L
s
.5546 .29645 m
.51962 .32037 L
s
1 .292 .121 r
.54595 .46071 m .53087 .45115 L .52803 .47973 L p F P
0 0 0 r
s
1 .292 .121 r
.52803 .47973 m .54176 .48822 L .54595 .46071 L p F P
0 0 0 r
s
.194 .28 .573 r
.46913 .45115 m .45405 .46071 L .45824 .48822 L p F P
0 0 0 r
s
.173 .246 .511 r
.45405 .46071 m .46913 .45115 L .46715 .424 L p F P
0 0 0 r
s
.83 .24 .1 r
.4386 .27762 m
.40288 .25295 L
s
.4386 .27762 m
.4454 .29645 L
s
.24 .35 .67 r
.5546 .29645 m
.5614 .27762 L
s
.59712 .25295 m
.5614 .27762 L
s
1 .299 .124 r
.54176 .48822 m .52803 .47973 L .52443 .50879 L p F P
0 0 0 r
s
.194 .28 .573 r
.45824 .48822 m .47197 .47973 L .46913 .45115 L p F P
0 0 0 r
s
1 .304 .127 r
.52443 .50879 m .51229 .50147 L .51015 .53146 L p F P
0 0 0 r
s
1 .304 .127 r
.5 .5255 m .51015 .53146 L .51229 .50147 L p F P
0 0 0 r
s
.229 .334 .674 r
.48985 .53146 m .5 .5255 L .5 .49406 L p F P
0 0 0 r
s
.229 .334 .674 r
.5 .49406 m .48771 .50147 L .48985 .53146 L p F P
0 0 0 r
s
1 .283 .116 r
.53285 .424 m .51656 .41343 L .51556 .44143 L p F P
0 0 0 r
s
1 .283 .116 r
.51556 .44143 m .53087 .45115 L .53285 .424 L p F P
0 0 0 r
s
.173 .246 .511 r
.48344 .41343 m .46715 .424 L .46913 .45115 L p F P
0 0 0 r
s
.148 .206 .436 r
.46715 .424 m .48344 .41343 L .4829 .38805 L p F P
0 0 0 r
s
1 .299 .124 r
.51229 .50147 m .52443 .50879 L .52803 .47973 L p F P
0 0 0 r
s
.213 .308 .627 r
.47557 .50879 m .48771 .50147 L .48588 .47112 L p F P
0 0 0 r
s
.213 .308 .627 r
.48588 .47112 m .47197 .47973 L .47557 .50879 L p F P
0 0 0 r
s
.83 .24 .1 r
.49144 .54036 m
.49724 .53213 L
s
.45647 .52017 m
.49144 .54036 L
s
.24 .35 .67 r
.50276 .53213 m
.50856 .54036 L
s
.83 .24 .1 r
.43361 .54558 m
.40971 .56576 L
s
.40971 .56576 m
.37324 .54599 L
s
.24 .35 .67 r
.62676 .54599 m
.59029 .56576 L
s
.59029 .56576 m
.56639 .54558 L
s
.116 .157 .342 r
.4829 .38805 m .5 .37673 L .5 .35455 L p F P
0 0 0 r
s
.83 .24 .1 r
.48273 .34457 m
.49879 .35536 L
s
.971 .27 .11 r
.5171 .38805 m .5 .37673 L .5 .40268 L p F P
0 0 0 r
s
.971 .27 .11 r
.5 .40268 m .51656 .41343 L .5171 .38805 L p F P
0 0 0 r
s
.148 .206 .436 r
.5 .37673 m .4829 .38805 L .48344 .41343 L p F P
0 0 0 r
s
.83 .24 .1 r
.49753 .50309 m
.49864 .50375 L
s
1 .292 .121 r
.53087 .45115 m .51556 .44143 L .51412 .47112 L p F P
0 0 0 r
s
1 .292 .121 r
.51412 .47112 m .52803 .47973 L .53087 .45115 L p F P
0 0 0 r
s
.194 .28 .573 r
.48444 .44143 m .46913 .45115 L .47197 .47973 L p F P
0 0 0 r
s
.173 .246 .511 r
.46913 .45115 m .48444 .44143 L .48344 .41343 L p F P
0 0 0 r
s
1 .299 .124 r
.52803 .47973 m .51412 .47112 L .51229 .50147 L p F P
0 0 0 r
s
.194 .28 .573 r
.47197 .47973 m .48588 .47112 L .48444 .44143 L p F P
0 0 0 r
s
1 .304 .127 r
.51229 .50147 m .5 .49406 L .5 .5255 L p F P
0 0 0 r
s
.24 .35 .67 r
.50136 .50375 m
.50247 .50309 L
s
.50856 .54036 m
.54353 .52017 L
s
.50189 .38506 m
.52016 .37305 L
s
.50091 .3857 m
.50189 .38506 L
s
1 .299 .124 r
.5 .49406 m .51229 .50147 L .51412 .47112 L p F P
0 0 0 r
s
.213 .308 .627 r
.48771 .50147 m .5 .49406 L .5 .46238 L p F P
0 0 0 r
s
.213 .308 .627 r
.5 .46238 m .48588 .47112 L .48771 .50147 L p F P
0 0 0 r
s
.83 .24 .1 r
.47703 .49084 m
.49753 .50309 L
s
.37324 .54599 m
.34965 .56053 L
s
.34965 .56053 m
.31195 .54057 L
s
.24 .35 .67 r
.68805 .54057 m
.65035 .56053 L
s
.65035 .56053 m
.62676 .54599 L
s
.173 .246 .511 r
.5 .40268 m .48344 .41343 L .48444 .44143 L p F P
0 0 0 r
s
.148 .206 .436 r
.48344 .41343 m .5 .40268 L .5 .37673 L p F P
0 0 0 r
s
.83 .24 .1 r
.47984 .37305 m
.49909 .3857 L
s
1 .283 .116 r
.51656 .41343 m .5 .40268 L .5 .43156 L p F P
0 0 0 r
s
1 .283 .116 r
.5 .43156 m .51556 .44143 L .51656 .41343 L p F P
0 0 0 r
s
.83 .24 .1 r
.17779 .5051 m
.1926 .50981 L
s
.24 .35 .67 r
.82221 .5051 m
.8074 .50981 L
s
.83 .24 .1 r
.31195 .54057 m
.29012 .54883 L
s
.29012 .54883 m
.25129 .52862 L
s
.24 .35 .67 r
.74871 .52862 m
.70988 .54883 L
s
.70988 .54883 m
.68805 .54057 L
s
.83 .24 .1 r
.25129 .52862 m
.23247 .53035 L
s
.23247 .53035 m
.1926 .50981 L
s
.24 .35 .67 r
.8074 .50981 m
.76753 .53035 L
s
.76753 .53035 m
.74871 .52862 L
s
.83 .24 .1 r
.48273 .34457 m
.44727 .32072 L
s
.48273 .34457 m
.47984 .37305 L
s
.24 .35 .67 r
.51727 .34457 m
.55273 .32072 L
s
.52016 .37305 m
.51727 .34457 L
s
1 .292 .121 r
.5 .46238 m .51412 .47112 L .51556 .44143 L p F P
0 0 0 r
s
1 .299 .124 r
.51412 .47112 m .5 .46238 L .5 .49406 L p F P
0 0 0 r
s
.24 .35 .67 r
.50247 .50309 m
.52297 .49084 L
s
.194 .28 .573 r
.48588 .47112 m .5 .46238 L .5 .43156 L p F P
0 0 0 r
s
.194 .28 .573 r
.5 .43156 m .48444 .44143 L .48588 .47112 L p F P
0 0 0 r
s
.83 .24 .1 r
.49413 .45917 m
.49839 .46181 L
s
.49839 .46181 m
.49856 .46192 L
s
1 .292 .121 r
.51556 .44143 m .5 .43156 L .5 .46238 L p F P
0 0 0 r
s
.24 .35 .67 r
.50161 .46181 m
.50587 .45917 L
s
.50144 .46192 m
.50161 .46181 L
s
.173 .246 .511 r
.48444 .44143 m .5 .43156 L .5 .40268 L p F P
0 0 0 r
s
.83 .24 .1 r
.45647 .52017 m
.43361 .54558 L
s
.43361 .54558 m
.3972 .52526 L
s
.24 .35 .67 r
.6028 .52526 m
.56639 .54558 L
s
.56639 .54558 m
.54353 .52017 L
s
.83 .24 .1 r
.36588 .2274 m
.35564 .21511 L
s
.24 .35 .67 r
.63412 .2274 m
.64436 .21511 L
s
.83 .24 .1 r
.4454 .29645 m
.40919 .27169 L
s
.4454 .29645 m
.44727 .32072 L
s
.24 .35 .67 r
.55273 .32072 m
.5546 .29645 L
s
.59081 .27169 m
.5546 .29645 L
s
.83 .24 .1 r
.40288 .25295 m
.36588 .2274 L
s
.40288 .25295 m
.40919 .27169 L
s
.24 .35 .67 r
.59081 .27169 m
.59712 .25295 L
s
.63412 .2274 m
.59712 .25295 L
s
.83 .24 .1 r
.47168 .40446 m
.49903 .42194 L
s
.49413 .45917 m
.49594 .45457 L
s
.49594 .45457 m
.49831 .44858 L
s
.24 .35 .67 r
.50406 .45457 m
.50587 .45917 L
s
.50169 .44858 m
.50406 .45457 L
s
.50298 .42065 m
.52832 .40446 L
s
.50097 .42194 m
.50298 .42065 L
s
.83 .24 .1 r
.47703 .49084 m
.45647 .52017 L
s
.45647 .52017 m
.42025 .49927 L
s
.24 .35 .67 r
.57975 .49927 m
.54353 .52017 L
s
.54353 .52017 m
.52297 .49084 L
s
.83 .24 .1 r
.49413 .45917 m
.45855 .43716 L
s
.49413 .45917 m
.47703 .49084 L
s
.24 .35 .67 r
.52297 .49084 m
.50587 .45917 L
s
.54145 .43716 m
.50587 .45917 L
s
.83 .24 .1 r
.3972 .52526 m
.37324 .54599 L
s
.37324 .54599 m
.33547 .52551 L
s
.24 .35 .67 r
.66453 .52551 m
.62676 .54599 L
s
.62676 .54599 m
.6028 .52526 L
s
.83 .24 .1 r
.47703 .49084 m
.44109 .46936 L
s
.24 .35 .67 r
.55891 .46936 m
.52297 .49084 L
s
.83 .24 .1 r
.47984 .37305 m
.44389 .34942 L
s
.47984 .37305 m
.47168 .40446 L
s
.24 .35 .67 r
.52832 .40446 m
.52016 .37305 L
s
.55611 .34942 m
.52016 .37305 L
s
.83 .24 .1 r
.33547 .52551 m
.31195 .54057 L
s
.31195 .54057 m
.2729 .51989 L
s
.24 .35 .67 r
.7271 .51989 m
.68805 .54057 L
s
.68805 .54057 m
.66453 .52551 L
s
.83 .24 .1 r
.2729 .51989 m
.25129 .52862 L
s
.25129 .52862 m
.21105 .50768 L
s
.24 .35 .67 r
.78895 .50768 m
.74871 .52862 L
s
.74871 .52862 m
.7271 .51989 L
s
.83 .24 .1 r
.1926 .50981 m
.21105 .50768 L
s
.24 .35 .67 r
.8074 .50981 m
.78895 .50768 L
s
.83 .24 .1 r
.44727 .32072 m
.41053 .29602 L
s
.44727 .32072 m
.44389 .34942 L
s
.24 .35 .67 r
.55273 .32072 m
.58947 .29602 L
s
.55611 .34942 m
.55273 .32072 L
s
.83 .24 .1 r
.42025 .49927 m
.3972 .52526 L
s
.3972 .52526 m
.35949 .5042 L
s
.24 .35 .67 r
.64051 .5042 m
.6028 .52526 L
s
.6028 .52526 m
.57975 .49927 L
s
.83 .24 .1 r
.40919 .27169 m
.37166 .24603 L
s
.40919 .27169 m
.41053 .29602 L
s
.24 .35 .67 r
.58947 .29602 m
.59081 .27169 L
s
.62834 .24603 m
.59081 .27169 L
s
.83 .24 .1 r
.37166 .24603 m
.36588 .2274 L
s
.24 .35 .67 r
.62834 .24603 m
.63412 .2274 L
s
.83 .24 .1 r
.47168 .40446 m
.43525 .38118 L
s
.47168 .40446 m
.45855 .43716 L
s
.24 .35 .67 r
.54145 .43716 m
.52832 .40446 L
s
.56475 .38118 m
.52832 .40446 L
s
.83 .24 .1 r
.44109 .46936 m
.42025 .49927 L
s
.42025 .49927 m
.38271 .4776 L
s
.24 .35 .67 r
.61729 .4776 m
.57975 .49927 L
s
.57975 .49927 m
.55891 .46936 L
s
.83 .24 .1 r
.45855 .43716 m
.42167 .41434 L
s
.45855 .43716 m
.44109 .46936 L
s
.24 .35 .67 r
.55891 .46936 m
.54145 .43716 L
s
.57833 .41434 m
.54145 .43716 L
s
.83 .24 .1 r
.35949 .5042 m
.33547 .52551 L
s
.33547 .52551 m
.29633 .50429 L
s
.24 .35 .67 r
.70367 .50429 m
.66453 .52551 L
s
.66453 .52551 m
.64051 .5042 L
s
.83 .24 .1 r
.44109 .46936 m
.40384 .44709 L
s
.24 .35 .67 r
.59616 .44709 m
.55891 .46936 L
s
.83 .24 .1 r
.44389 .34942 m
.40663 .32493 L
s
.44389 .34942 m
.43525 .38118 L
s
.24 .35 .67 r
.56475 .38118 m
.55611 .34942 L
s
.59337 .32493 m
.55611 .34942 L
s
.83 .24 .1 r
.29633 .50429 m
.2729 .51989 L
s
.2729 .51989 m
.23242 .49846 L
s
.24 .35 .67 r
.76758 .49846 m
.7271 .51989 L
s
.7271 .51989 m
.70367 .50429 L
s
.83 .24 .1 r
.21105 .50768 m
.23242 .49846 L
s
.24 .35 .67 r
.78895 .50768 m
.76758 .49846 L
s
.83 .24 .1 r
.41053 .29602 m
.37245 .27041 L
s
.41053 .29602 m
.40663 .32493 L
s
.24 .35 .67 r
.58947 .29602 m
.62755 .27041 L
s
.59337 .32493 m
.58947 .29602 L
s
.83 .24 .1 r
.38271 .4776 m
.35949 .5042 L
s
.35949 .5042 m
.32038 .48236 L
s
.24 .35 .67 r
.67962 .48236 m
.64051 .5042 L
s
.64051 .5042 m
.61729 .4776 L
s
.83 .24 .1 r
.37245 .27041 m
.37166 .24603 L
s
.24 .35 .67 r
.62755 .27041 m
.62834 .24603 L
s
.83 .24 .1 r
.43525 .38118 m
.39747 .35704 L
s
.43525 .38118 m
.42167 .41434 L
s
.24 .35 .67 r
.57833 .41434 m
.56475 .38118 L
s
.60253 .35704 m
.56475 .38118 L
s
.83 .24 .1 r
.40384 .44709 m
.38271 .4776 L
s
.38271 .4776 m
.34378 .45513 L
s
.24 .35 .67 r
.65622 .45513 m
.61729 .4776 L
s
.61729 .4776 m
.59616 .44709 L
s
.83 .24 .1 r
.42167 .41434 m
.38343 .39068 L
s
.42167 .41434 m
.40384 .44709 L
s
.24 .35 .67 r
.59616 .44709 m
.57833 .41434 L
s
.61657 .39068 m
.57833 .41434 L
s
.83 .24 .1 r
.32038 .48236 m
.29633 .50429 L
s
.29633 .50429 m
.25573 .48227 L
s
.24 .35 .67 r
.74427 .48227 m
.70367 .50429 L
s
.70367 .50429 m
.67962 .48236 L
s
.83 .24 .1 r
.40384 .44709 m
.3652 .424 L
s
.24 .35 .67 r
.6348 .424 m
.59616 .44709 L
s
.83 .24 .1 r
.40663 .32493 m
.36797 .29952 L
s
.40663 .32493 m
.39747 .35704 L
s
.24 .35 .67 r
.60253 .35704 m
.59337 .32493 L
s
.63203 .29952 m
.59337 .32493 L
s
.83 .24 .1 r
.23242 .49846 m
.25573 .48227 L
s
.24 .35 .67 r
.76758 .49846 m
.74427 .48227 L
s
.83 .24 .1 r
.36797 .29952 m
.37245 .27041 L
s
.24 .35 .67 r
.63203 .29952 m
.62755 .27041 L
s
.83 .24 .1 r
.34378 .45513 m
.32038 .48236 L
s
.32038 .48236 m
.27981 .45971 L
s
.24 .35 .67 r
.72019 .45971 m
.67962 .48236 L
s
.67962 .48236 m
.65622 .45513 L
s
.83 .24 .1 r
.39747 .35704 m
.35828 .33199 L
s
.39747 .35704 m
.38343 .39068 L
s
.24 .35 .67 r
.61657 .39068 m
.60253 .35704 L
s
.64172 .33199 m
.60253 .35704 L
s
.83 .24 .1 r
.3652 .424 m
.34378 .45513 L
s
.34378 .45513 m
.30338 .43181 L
s
.24 .35 .67 r
.69662 .43181 m
.65622 .45513 L
s
.65622 .45513 m
.6348 .424 L
s
.83 .24 .1 r
.38343 .39068 m
.34374 .36612 L
s
.38343 .39068 m
.3652 .424 L
s
.24 .35 .67 r
.6348 .424 m
.61657 .39068 L
s
.65626 .36612 m
.61657 .39068 L
s
.83 .24 .1 r
.25573 .48227 m
.27981 .45971 L
s
.24 .35 .67 r
.74427 .48227 m
.72019 .45971 L
s
.83 .24 .1 r
.3652 .424 m
.3251 .40003 L
s
.24 .35 .67 r
.6749 .40003 m
.6348 .424 L
s
.83 .24 .1 r
.35828 .33199 m
.36797 .29952 L
s
.24 .35 .67 r
.64172 .33199 m
.63203 .29952 L
s
.83 .24 .1 r
.27981 .45971 m
.30338 .43181 L
s
.24 .35 .67 r
.72019 .45971 m
.69662 .43181 L
s
.83 .24 .1 r
.34374 .36612 m
.35828 .33199 L
s
.24 .35 .67 r
.65626 .36612 m
.64172 .33199 L
s
.83 .24 .1 r
.30338 .43181 m
.3251 .40003 L
s
.24 .35 .67 r
.69662 .43181 m
.6749 .40003 L
s
.83 .24 .1 r
.3251 .40003 m
.34374 .36612 L
s
.24 .35 .67 r
.6749 .40003 m
.65626 .36612 L
s
0 0 0 r
.25 Mabswid
.92347 .37901 m
.97811 .6366 L
s
.97811 .6366 m
.5 .30205 L
s
.5 .30205 m
.5 .02321 L
s
.5 .02321 m
.92347 .37901 L
s
.5 .02321 m
.07653 .37901 L
s
.07653 .37901 m
.02189 .6366 L
s
.02189 .6366 m
.5 .30205 L
s
.5 .30205 m
.5 .02321 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{500, 500},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40007d0001m2000`400?l00000o`00003oo`3ooooe
0?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3o
m^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40
oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?of
k_@0ooK^0@3oool00?T0ooK^00<000000?ofkP3om^h0m`3om^h10?ooo`00n03om^h300000?P0ooK^
0@3oool00?L0ooK^00D000000?ofkP000000ooK^0000003g0?ofkP40oooo003e0?ofkP8000000P3o
m^h00`000000ooK^0?ofkP0200000?D0ooK^0@3oool00?@0ooK^00<000000?ofkP3om^h00P3om^h0
0`000000ooK^0?ofkP020?ofkP030000003om^h0ooK^0?80ooK^0@3oool00?<0ooK^00<000000?of
kP3om^h00`3om^h00`000000ooK^0?ofkP030?ofkP030000003om^h0ooK^0?40ooK^0@3oool00?80
ooK^00<000000?ofkP3om^h0103om^h00`000000ooK^0?ofkP040?ofkP030000003om^h0ooK^0?00
ooK^0@3oool00?40ooK^00<000000?ofkP3om^h01@3om^h00`000000ooK^0?ofkP050?ofkP030000
003om^h0ooK^0>l0ooK^0@3oool00>l0ooK^0P0000080?ofkP030000003om^h0ooK^00H0ooK^0P00
003_0?ofkP40oooo003^0?ofkP030000003om^h0ooK^00P0ooK^00<000000?ofkP3om^h0203om^h0
0`000000ooK^0?ofkP3/0?ofkP40oooo003]0?ofkP030000003om^h0ooK^00T0ooK^00<000000?of
kP3om^h02@3om^h00`000000ooK^0?ofkP3[0?ofkP40oooo003/0?ofkP030000003om^h0ooK^00X0
ooK^00<000000?ofkP3om^h02P3om^h00`000000ooK^0?ofkP3Z0?ofkP40oooo003[0?ofkP030000
003om^h0ooK^00/0ooK^00<000000?ofkP3om^h02`3om^h00`000000ooK^0?ofkP3Y0?ofkP40oooo
003Y0?ofkP8000003P3om^h00`000000ooK^0?ofkP0<0?ofkP800000j@3om^h10?ooo`00j03om^h0
0`000000ooK^0?ofkP0>0?ofkP030000003om^h0ooK^00h0ooK^00<000000?ofkP3om^h0iP3om^h1
0?ooo`00i`3om^h00`000000ooK^0?ofkP0?0?ofkP030000003om^h0ooK^00l0ooK^00<000000?of
kP3om^h0i@3om^h10?ooo`00iP3om^h00`000000ooK^0?ofkP0@0?ofkP030000003om^h0ooK^0100
ooK^00<000000?ofkP3om^h0i03om^h10?ooo`00i@3om^h00`000000ooK^0?ofkP0A0?ofkP030000
003om^h0ooK^0140ooK^00<000000?ofkP3om^h0h`3om^h10?ooo`00i03om^h00`000000ooK^0?of
kP0B0?ofkP030000003om^h0ooK^0180ooK^00<000000?ofkP3om^h0hP3om^h10?ooo`00hP3om^h2
000001D0ooK^00<000000?ofkP3om^h04`3om^h200000>80ooK^0@3oool00>40ooK^00<000000?of
kP3om^h05@3om^h00`000000ooK^0?ofkP0E0?ofkP030000003om^h0ooK^0=l0ooK^0@3oool00>00
ooK^00<000000?ofkP3om^h05P3om^h00`000000ooK^0?ofkP0F0?ofkP030000003om^h0ooK^0=h0
ooK^0@3oool00=l0ooK^00<000000?ofkP3om^h05`3om^h00`000000ooK^0?ofkP0G0?ofkP030000
003om^h0ooK^0=d0ooK^0@3oool00=h0ooK^00<000000?ofkP3om^h0603om^h00`000000ooK^0?of
kP0H0?ofkP030000003om^h0ooK^0=`0ooK^0@3oool00=`0ooK^0P00000K0?ofkP030000003om^h0
ooK^01T0ooK^0P00003L0?ofkP40oooo003K0?ofkP030000003om^h0ooK^01/0ooK^00<000000?of
kP3om^h06`3om^h00`000000ooK^0?ofkP3I0?ofkP40oooo003J0?ofkP030000003om^h0ooK^01`0
ooK^00<000000?ofkP3om^h0703om^h00`000000ooK^0?ofkP3H0?ofkP40oooo003I0?ofkP030000
003om^h0ooK^01d0ooK^00<000000?ofkP3om^h07@3om^h00`000000ooK^0?ofkP3G0?ofkP40oooo
003H0?ofkP030000003om^h0ooK^01h0ooK^00<000000?ofkP3om^h07P3om^h00`000000ooK^0?of
kP3F0?ofkP40oooo003G0?ofkP030000003om^h0ooK^01l0ooK^00<000000?ofkP3om^h07`3om^h0
0`000000ooK^0?ofkP3E0?ofkP40oooo003E0?ofkP8000008P3om^h00`000000ooK^0?ofkP0P0?of
kP800000e@3om^h10?ooo`00e03om^h00`000000ooK^0?ofkP0R0?ofkP030000003om^h0ooK^0280
ooK^00<000000?ofkP3om^h0dP3om^h10?ooo`00d`3om^h00`000000ooK^0?ofkP0S0?ofkP030000
003om^h0ooK^02<0ooK^00<000000?ofkP3om^h0d@3om^h10?ooo`00dP3om^h00`000000ooK^0?of
kP0T0?ofkP030000003om^h0ooK^02@0ooK^00<000000?ofkP3om^h0d03om^h10?ooo`00d@3om^h0
0`000000ooK^0?ofkP0U0?ofkP030000003om^h0ooK^02D0ooK^00<000000?ofkP3om^h0c`3om^h1
0?ooo`00c`3om^h2000002P0ooK^00<000000?ofkP3om^h09P3om^h200000<l0ooK^0@3oool00<h0
ooK^00<000000?ofkP3om^h0:03om^h00`000000ooK^0?ofkP0X0?ofkP030000003om^h0ooK^0<`0
ooK^0@3oool00<d0ooK^00<000000?ofkP3om^h0:@3om^h00`000000ooK^0?ofkP0Y0?ofkP030000
003om^h0ooK^0</0ooK^0@3oool00<`0ooK^00<000000?ofkP3om^h0:P3om^h00`000000ooK^0?of
kP0Z0?ofkP030000003om^h0ooK^0<X0ooK^0@3oool00</0ooK^00<000000?ofkP3om^h0:`3om^h0
0`000000ooK^0?ofkP0[0?ofkP030000003om^h0ooK^0<T0ooK^0@3oool00<T0ooK^0P00000^0?of
kP030000003om^h0ooK^02`0ooK^0P0000390?ofkP40oooo00380?ofkP030000003om^h0ooK^02h0
ooK^00<000000?ofkP3om^h0;P3om^h00`000000ooK^0?ofkP360?ofkP40oooo00370?ofkP030000
003om^h0ooK^02l0ooK^00<000000?ofkP3om^h0;`3om^h00`000000ooK^0?ofkP350?ofkP40oooo
00360?ofkP030000003om^h0ooK^0300ooK^00<000000?ofkP3om^h0<03om^h00`000000ooK^0?of
kP340?ofkP40oooo00350?ofkP030000003om^h0ooK^0340ooK^00<000000?ofkP3om^h0<@3om^h0
0`000000ooK^0?ofkP330?ofkP40oooo00340?ofkP030000003om^h0ooK^0380ooK^00<000000?of
kP3om^h0<P3om^h00`000000ooK^0?ofkP320?ofkP40oooo00320?ofkP800000=@3om^h00`000000
ooK^0?ofkP0c0?ofkP800000`P3om^h10?ooo`00`@3om^h00`000000ooK^0?ofkP0e0?ofkP030000
003om^h0ooK^03D0ooK^00<000000?ofkP3om^h0_`3om^h10?ooo`00`03om^h00`000000ooK^0?of
kP0f0?ofkP030000003om^h0ooK^03H0ooK^00<000000?ofkP3om^h0_P3om^h10?ooo`00_`3om^h0
0`000000ooK^0?ofkP0g0?ofkP030000003om^h0ooK^03L0ooK^00<000000?ofkP3om^h0_@3om^h1
0?ooo`00_P3om^h00`000000ooK^0?ofkP0h0?ofkP030000003om^h0ooK^03P0ooK^00<000000?of
kP3om^h0_03om^h10?ooo`00_03om^h2000003/0ooK^00<000000?ofkP3om^h0>@3om^h200000;`0
ooK^0@3oool00;/0ooK^00<000000?ofkP3om^h0>`3om^h00`000000ooK^0?ofkP0k0?ofkP030000
003om^h0ooK^0;T0ooK^0@3oool00;X0ooK^00<000000?ofkP3om^h0?03om^h00`000000ooK^0?of
kP0l0?ofkP030000003om^h0ooK^0;P0ooK^0@3oool00;T0ooK^00<000000?ofkP3om^h0?@3om^h0
0`000000ooK^0?ofkP0m0?ofkP030000003om^h0ooK^0;L0ooK^0@3oool00;P0ooK^00<000000?of
kP3om^h0?P3om^h00`000000ooK^0?ofkP0n0?ofkP030000003om^h0ooK^0;H0ooK^0@3oool00;L0
ooK^00<000000?ofkP3om^h0?`3om^h00`000000ooK^0?ofkP0o0?ofkP030000003om^h0ooK^0;D0
ooK^0@3oool00;D0ooK^0P0000120?ofkP030000003om^h0ooK^0400ooK^0P00002e0?ofkP40oooo
002d0?ofkP030000003om^h0ooK^0480ooK^00<000000?ofkP3om^h0@P3om^h00`000000ooK^0?of
kP2b0?ofkP40oooo002c0?ofkP030000003om^h0ooK^04<0ooK^00<000000?ofkP3om^h0@`3om^h0
0`000000ooK^0?ofkP2a0?ofkP40oooo002b0?ofkP030000003om^h0ooK^04@0ooK^00<000000?of
kP3om^h0A03om^h00`000000ooK^0?ofkP2`0?ofkP40oooo002a0?ofkP030000003om^h0ooK^04D0
ooK^00<000000?ofkP3om^h0A@3om^h00`000000ooK^0?ofkP2_0?ofkP40oooo002_0?ofkP800000
B03om^h00`000000ooK^0?ofkP160?ofkP800000[`3om^h10?ooo`00[P3om^h00`000000ooK^0?of
kP180?ofkP030000003om^h0ooK^04P0ooK^00<000000?ofkP3om^h0[03om^h10?ooo`00[@3om^h0
0`000000ooK^0?ofkP190?ofkP030000003om^h0ooK^04T0ooK^00<000000?ofkP3om^h0Z`3om^h1
0?ooo`00[03om^h00`000000ooK^0?ofkP1:0?ofkP030000003om^h0ooK^04X0ooK^00<000000?of
kP3om^h0ZP3om^h10?ooo`00Z`3om^h00`000000ooK^0?ofkP1;0?ofkP030000003om^h0ooK^04/0
ooK^00<000000?ofkP3om^h0Z@3om^h10?ooo`00Z@3om^h2000004h0ooK^00<000000?ofkP3om^h0
C03om^h200000:T0ooK^0@3oool00:P0ooK^00<000000?ofkP3om^h0CP3om^h00`000000ooK^0?of
kP1>0?ofkP030000003om^h0ooK^0:H0ooK^0@3oool00:L0ooK^00<000000?ofkP3om^h0C`3om^h0
0`000000ooK^0?ofkP1?0?ofkP030000003om^h0ooK^0:D0ooK^0@3oool00:H0ooK^00<000000?of
kP3om^h0D03om^h00`000000ooK^0?ofkP1@0?ofkP030000003om^h0ooK^0:@0ooK^0@3oool00:D0
ooK^00<000000?ofkP3om^h0D@3om^h00`000000ooK^0?ofkP1A0?ofkP030000003om^h0ooK^0:<0
ooK^0@3oool00:@0ooK^00<000000?ofkP3om^h0DP3om^h00`000000ooK^0?ofkP1B0?ofkP030000
003om^h0ooK^0:80ooK^0@3oool00:80ooK^0P00001E0?ofkP030000003om^h0ooK^05<0ooK^0P00
002R0?ofkP40oooo002Q0?ofkP030000003om^h0ooK^05D0ooK^00<000000?ofkP3om^h0E@3om^h0
0`000000ooK^0?ofkP2O0?ofkP40oooo002P0?ofkP030000003om^h0ooK^05H0ooK^00<000000?of
kP3om^h0EP3om^h00`000000ooK^0?ofkP2N0?ofkP40oooo002O0?ofkP030000003om^h0ooK^05L0
ooK^00<000000?ofkP3om^h0E`3om^h00`000000ooK^0?ofkP2M0?ofkP40oooo002N0?ofkP030000
003om^h0ooK^05P0ooK^00<000000?ofkP3om^h0F03om^h00`000000ooK^0?ofkP2L0?ofkP40oooo
002L0?ofkP800000F`3om^h00`000000ooK^0?ofkP1I0?ofkP800000W03om^h10?ooo`00V`3om^h0
0`000000ooK^0?ofkP1K0?ofkP030000003om^h0ooK^05/0ooK^00<000000?ofkP3om^h0V@3om^h1
0?ooo`00VP3om^h00`000000ooK^0?ofkP1L0?ofkP030000003om^h0ooK^05`0ooK^00<000000?of
kP3om^h0V03om^h10?ooo`00V@3om^h00`000000ooK^0?ofkP1M0?ofkP030000003om^h0ooK^05d0
ooK^00<000000?ofkP3om^h0U`3om^h10?ooo`00V03om^h00`000000ooK^0?ofkP1N0?ofkP030000
003om^h0ooK^05h0ooK^00<000000?ofkP3om^h0UP3om^h10?ooo`00U`3om^h00`000000ooK^0?of
kP1O0?ofkP030000003om^h0ooK^05l0ooK^00<000000?ofkP3om^h0U@3om^h10?ooo`00U@3om^h2
00000680ooK^00<000000?ofkP3om^h0H03om^h2000009D0ooK^0@3oool009@0ooK^00<000000?of
kP3om^h0HP3om^h00`000000ooK^0?ofkP1R0?ofkP030000003om^h0ooK^0980ooK^0@3oool009<0
ooK^00<000000?ofkP3om^h0H`3om^h00`000000ooK^0?ofkP1S0?ofkP030000003om^h0ooK^0940
ooK^0@3oool00980ooK^00<000000?ofkP3om^h0I03om^h00`000000ooK^0?ofkP1T0?ofkP030000
003om^h0ooK^0900ooK^0@3oool00940ooK^00<000000?ofkP3om^h0I@3om^h00`000000ooK^0?of
kP1U0?ofkP030000003om^h0ooK^08l0ooK^0@3oool008l0ooK^0P00001X0?ofkP030000003om^h0
ooK^06H0ooK^0P00002?0?ofkP40oooo002>0?ofkP030000003om^h0ooK^06P0ooK^00<000000?of
kP3om^h0J03om^h00`000000ooK^0?ofkP2<0?ofkP40oooo002=0?ofkP030000003om^h0ooK^06T0
ooK^00<000000?ofkP3om^h0J@3om^h00`000000ooK^0?ofkP2;0?ofkP40oooo002<0?ofkP030000
003om^h0ooK^06X0ooK^00<000000?ofkP3om^h0JP3om^h00`000000ooK^0?ofkP2:0?ofkP40oooo
002;0?ofkP030000003om^h0ooK^01<0ooK^2`3D?AU=0?ofkP030000003om^h0ooK^04/0ooK^2`0m
FJ/E0?ofkP030000003om^h0ooK^08T0ooK^0@3oool008T0ooK^0P00000D0?ofkP80e3dI0P3om^h0
0`3D?AT0ooK^0?ofkP050?ofkP<0e3dIB`3om^h00`000000ooK^0?ofkP190?ofkP<0?EV[1`3om^h0
0`0mFJ/0ooK^0?ofkP0203eIZa@0ooK^0P0000290?ofkP40oooo00280?ofkP030000003om^h0ooK^
0140ooK^0`3D?AT50?ofkP80e3dI1`3om^h30=@m6DT0ooK^00<000000?ofkP3om^h0A`3om^h303eI
Z`L0ooK^0P0mFJ/50?ofkP<0?EV[4`3om^h00`000000ooK^0?ofkP260?ofkP40oooo00270?ofkP03
0000003om^h0ooK^0100ooK^0P3D?AT:0?ofkP030=@m6@3om^h0ooK^00D0ooK^103D?AU70?ofkP03
0000003om^h0ooK^04D0ooK^100mFJ/70?ofkP0303eIZ`3om^h0ooK^00P0ooK^0P0mFJ/B0?ofkP03
0000003om^h0ooK^08D0ooK^0@3oool008H0ooK^00<000000?ofkP3om^h03`3om^h20=@m6@d0ooK^
00<0e3dI0?ofkP3om^h01P3om^h0103D?AT0ooK^0=@m6@3D?AU50?ofkP030000003om^h0ooK^04<0
ooK^0P0mFJ/00`3om^h0?EV[0?ofkP070?ofkP0303eIZ`3om^h0ooK^00/0ooK^0P0mFJ/A0?ofkP03
0000003om^h0ooK^08@0ooK^0@3oool008D0ooK^00<000000?ofkP3om^h03P3om^h20=@m6@030?of
kP3D?AT0e3dI00d0ooK^0P3D?AT70?ofkP@0e3dIA03om^h00`000000ooK^0?ofkP120?ofkP@0?EV[
1`3om^h203eIZ`d0ooK^0P0mFJ/00`3om^h0?EV[03eIZ`0@0?ofkP030000003om^h0ooK^08<0ooK^
0@3oool008@0ooK^00<000000?ofkP3om^h03@3om^h20=@m6@D0ooK^00<0e3dI0?ofkP3om^h0303o
m^h00`3D?AT0ooK^0?ofkP060?ofkP040=@m6@3om^h0e3dI0=@m6D80ooK^00<000000?ofkP3om^h0
@03om^h403eIZ`P0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP030?ofkP80?EV[
3`3om^h00`000000ooK^0?ofkP220?ofkP40oooo00220?ofkP8000003`3om^h00`3D?AT0ooK^0?of
kP060?ofkP80e3dI3@3om^h00`3D?AT0ooK^0?ofkP060?ofkP80e3dI00<0ooK^0=@m6@3om^h0@03o
m^h00`000000ooK^0?ofkP0o0?ofkP0403eIZ`3om^h0?EV[03eIZ`P0ooK^00<0?EV[0?ofkP3om^h0
2`3om^h203eIZ`P0ooK^00<0?EV[0?ofkP3om^h03@3om^h200000880ooK^0@3oool00840ooK^00<0
00000?ofkP3om^h03@3om^h20=@m6@/0ooK^00<0e3dI0?ofkP3om^h02`3om^h20=@m6@L0ooK^0P3D
?AT00`3om^h0e3dI0=@m6@0o0?ofkP030000003om^h0ooK^03d0ooK^0P0mFJ/00`3om^h0?EV[03eI
Z`070?ofkP80?EV[3@3om^h00`0mFJ/0ooK^0?ofkP090?ofkP80?EV[3`3om^h00`000000ooK^0?of
kP1o0?ofkP40oooo00200?ofkP030000003om^h0ooK^00`0ooK^0P3D?AT>0?ofkP80e3dI3@3om^h0
0`3D?AT0ooK^0?ofkP050?ofkP<0e3dI00<0ooK^0=@m6@3om^h0?@3om^h00`000000ooK^0?ofkP0l
0?ofkP0303eIZ`3om^h0?EV[0080?EV[1`3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP80?EV[3P3om^h2
03eIZ`h0ooK^00<000000?ofkP3om^h0OP3om^h10?ooo`00O`3om^h00`000000ooK^0?ofkP0<0?of
kP030=@m6@3om^h0ooK^0100ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP040?of
kP@0e3dI00<0ooK^0=@m6@3D?AT0?03om^h00`000000ooK^0?ofkP0j0?ofkP80?EV[00<0ooK^03eI
Z`0mFJ/00P0mFJ/60?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h0403om^h00`0m
FJ/0ooK^0?ofkP0<0?ofkP030000003om^h0ooK^07d0ooK^0@3oool007h0ooK^00<000000?ofkP3o
m^h0303om^h0103D?AT0ooK^0=@m6@3D?ATA0?ofkP80e3dI303om^h20=@m6@D0ooK^00<0e3dI0?of
kP3D?AT00P3D?AT00`3om^h0e3dI0?ofkP0j0?ofkP030000003om^h0ooK^03T0ooK^00<0?EV[0?of
kP0mFJ/00P0mFJ/00`3om^h0?EV[0?ofkP040?ofkP80?EV[303om^h203eIZa40ooK^0P0mFJ/00`3o
m^h0?EV[0?ofkP0=0?ofkP030000003om^h0ooK^07`0ooK^0@3oool007`0ooK^0P00000=0?ofkP80
e3dI103om^h00`3D?AT0ooK^0?ofkP0@0?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3o
m^h00P3om^h90=@m6CT0ooK^00<000000?ofkP3om^h0=`3om^h903eIZ`@0ooK^00<0?EV[0?ofkP3o
m^h02`3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0303eIZ`3om^h0ooK^0080ooK^0P0mFJ/=0?ofkP80
0000O03om^h10?ooo`00N`3om^h00`000000ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00D0ooK^
00<0e3dI0?ofkP3om^h0403om^h20=@m6@/0ooK^1P3D?AT40?ofkPD0e3dI>03om^h00`000000ooK^
0?ofkP0f0?ofkPD0?EV[103om^h603eIZ`/0ooK^0P0mFJ/B0?ofkP0303eIZ`3om^h0ooK^00D0ooK^
00<0?EV[0?ofkP3om^h0303om^h00`000000ooK^0?ofkP1i0?ofkP40oooo001j0?ofkP030000003o
m^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h01`3om^h20=@m6A80ooK^00<0e3dI0?ofkP3om^h01@3o
m^h30=@m6@80ooK^0P3D?AT20?ofkP030=@m6@3om^h0ooK^0080ooK^1P3D?ATf0?ofkP030000003o
m^h0ooK^03@0ooK^1P0mFJ/40?ofkP0303eIZ`3om^h0ooK^0080?EV[0P3om^h303eIZ`L0ooK^00<0
?EV[0?ofkP3om^h0403om^h203eIZ`T0ooK^00<0?EV[0?ofkP3om^h0303om^h00`000000ooK^0?of
kP1h0?ofkP40oooo001i0?ofkP030000003om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h02P3om^h0
0`3D?AT0ooK^0?ofkP0@0?ofkP80e3dI0P3om^h30=@m6@L0ooK^0`3D?AT60?ofkP80e3dI00<0ooK^
0=@m6@3D?AT0=@3om^h00`000000ooK^0?ofkP0c0?ofkP80?EV[00<0ooK^03eIZ`0mFJ/01P3om^h3
03eIZ`L0ooK^0`0mFJ/20?ofkP80?EV[4P3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0
ooK^00`0ooK^00<000000?ofkP3om^h0M`3om^h10?ooo`00N03om^h00`000000ooK^0?ofkP0<0?of
kP030=@m6@3om^h0ooK^00`0ooK^0P3D?ATB0?ofkP80e3dI303om^h00`3D?AT0ooK^0?ofkP050?of
kP<0e3dI00<0ooK^0=@m6@3D?AT0<`3om^h00`000000ooK^0?ofkP0a0?ofkP80?EV[00@0ooK^03eI
Z`0mFJ/0?EV[1`3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP80?EV[4P3om^h203eIZ`h0ooK^00<0?EV[
0?ofkP3om^h0303om^h00`000000ooK^0?ofkP1f0?ofkP40oooo001g0?ofkP030000003om^h0ooK^
00/0ooK^0P3D?ATA0?ofkP030=@m6@3om^h0ooK^00d0ooK^0P3D?AT00`3om^h0e3dI0=@m6@0<0?of
kP80e3dI1P3om^h30=@m6@030?ofkP3D?AT0e3dI0380ooK^00<000000?ofkP3om^h0<03om^h203eI
Z`040?ofkP0mFJ/0?EV[03eIZ`H0ooK^0P0mFJ/<0?ofkP80?EV[00<0ooK^03eIZ`0mFJ/03`3om^h0
0`0mFJ/0ooK^0?ofkP0?0?ofkP80?EV[3@3om^h00`000000ooK^0?ofkP1e0?ofkP40oooo001e0?of
kP8000003@3om^h00`3D?AT0ooK^0?ofkP0B0?ofkP80e3dI2`3om^h20=@m6@D0ooK^00<0e3dI0?of
kP3om^h02@3om^h00`3D?AT0ooK^0=@m6@070?ofkPD0e3dI<@3om^h00`000000ooK^0?ofkP0_0?of
kPD0?EV[1`3om^h00`0mFJ/0ooK^03eIZ`0;0?ofkP0303eIZ`3om^h0ooK^00<0ooK^0P0mFJ/;0?of
kP80?EV[503om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP800000M@3om^h10?ooo`00M03om^h00`000000
ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^01D0ooK^00<0e3dI0?ofkP3om^h01P3om^h20=@m6@P0
ooK^0P3D?AT90?ofkPD0e3dI1P3om^h30=@m6@030?ofkP3D?AT0e3dI02l0ooK^00<000000?ofkP3o
m^h0;@3om^h203eIZ`040?ofkP0mFJ/0?EV[03eIZ`H0ooK^1@0mFJ/90?ofkP80?EV[203om^h203eI
Z`P0ooK^00<0?EV[0?ofkP3om^h05@3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP030000003om^h0ooK^
0780ooK^0@3oool007<0ooK^00<000000?ofkP3om^h0303om^h0103D?AT0ooK^0=@m6@3D?ATF0?of
kP030=@m6@3om^h0ooK^00<0ooK^0P3D?AT<0?ofkP030=@m6@3om^h0ooK^00H0ooK^00D0e3dI0?of
kP3om^h0e3dI0?ofkP020=@m6@H0ooK^0`3D?AT00`3om^h0e3dI0?ofkP0]0?ofkP030000003om^h0
ooK^02`0ooK^00<0?EV[0?ofkP0mFJ/00P0mFJ/60?ofkP80?EV[00D0ooK^03eIZ`3om^h0ooK^03eI
Z`080?ofkP0303eIZ`3om^h0ooK^00X0ooK^0P0mFJ/50?ofkP0303eIZ`3om^h0ooK^01@0ooK^0P0m
FJ/00`3om^h0?EV[0?ofkP0=0?ofkP030000003om^h0ooK^0740ooK^0@3oool00780ooK^00<00000
0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP020?ofkP80e3dI5@3om^h20=@m6@030?ofkP3D?AT0
e3dI00l0ooK^0P3D?AT60?ofkP040=@m6@3om^h0ooK^0?ofkP80e3dI00<0ooK^0=@m6@3om^h01@3o
m^h30=@m6@030?ofkP3D?AT0ooK^02`0ooK^00<000000?ofkP3om^h0:`3om^h00`0mFJ/0ooK^03eI
Z`0203eIZ`H0ooK^00@0?EV[0?ofkP0mFJ/0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP040?ofkP80?EV[
3`3om^h203eIZ`030?ofkP0mFJ/0?EV[01D0ooK^0P0mFJ/40?ofkP0303eIZ`3om^h0ooK^00`0ooK^
00<000000?ofkP3om^h0L03om^h10?ooo`00L@3om^h00`000000ooK^0?ofkP0<0?ofkP030=@m6@3o
m^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h0503om^h00`3D?AT0ooK^0?ofkP0A0?ofkP80e3dI103o
m^h00`3D?AT0ooK^0?ofkP030?ofkP040=@m6@3om^h0e3dI0=@m6@H0ooK^0P3D?AT00`3om^h0e3dI
0=@m6@0[0?ofkP030000003om^h0ooK^02T0ooK^0P0mFJ/00`3om^h0?EV[03eIZ`060?ofkP80?EV[
00<0ooK^03eIZ`3om^h0103om^h00`0mFJ/0ooK^0?ofkP020?ofkP80?EV[4`3om^h00`0mFJ/0ooK^
0?ofkP0D0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h0303om^h00`000000ooK^
0?ofkP1_0?ofkP40oooo001_0?ofkP8000003P3om^h00`3D?AT0ooK^0?ofkP070?ofkP80e3dI4`3o
m^h0103D?AT0ooK^0=@m6@3D?ATC0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT01P3om^h20=@m6@03
0?ofkP3D?AT0e3dI00@0ooK^103D?AT00`3om^h0e3dI0?ofkP0Y0?ofkP030000003om^h0ooK^02P0
ooK^00<0?EV[0?ofkP0mFJ/00`0mFJ/40?ofkP80?EV[00<0ooK^03eIZ`0mFJ/01P3om^h01@0mFJ/0
ooK^0?ofkP3om^h0?EV[01<0ooK^0P0mFJ/00`3om^h0?EV[0?ofkP0B0?ofkP80?EV[2@3om^h00`0m
FJ/0ooK^0?ofkP0<0?ofkP800000K`3om^h10?ooo`00KP3om^h00`000000ooK^0?ofkP0=0?ofkP03
0=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h03P3om^h20=@m6@@0ooK^00<0e3dI0?ofkP3o
m^h04@3om^h20=@m6@030?ofkP3D?AT0ooK^00L0ooK^00<0e3dI0?ofkP3D?AT02@3D?AT00`3om^h0
e3dI0=@m6@0X0?ofkP030000003om^h0ooK^02H0ooK^0P0mFJ/00`3om^h0?EV[03eIZ`0803eIZ`03
0?ofkP0mFJ/0ooK^00L0ooK^00@0?EV[0?ofkP0mFJ/0?EV[4`3om^h00`0mFJ/0ooK^0?ofkP020?of
kP80?EV[403om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<000000?of
kP3om^h0K03om^h10?ooo`00K@3om^h00`000000ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00`0
ooK^0P3D?AT=0?ofkP030=@m6@3om^h0ooK^00D0ooK^0P3D?ATC0?ofkP80e3dI1`3om^h30=@m6@80
ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@020?ofkP<0e3dI00<0ooK^0=@m6@3om^h09P3om^h00`00
0000ooK^0?ofkP0U0?ofkP0303eIZ`3om^h0?EV[0080?EV[0P3om^h01@0mFJ/0ooK^0?ofkP3om^h0
?EV[0080ooK^0`0mFJ/70?ofkP80?EV[4`3om^h203eIZ`L0ooK^00<0?EV[0?ofkP3om^h02`3om^h2
03eIZ`h0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`000000ooK^0?ofkP1[0?ofkP40oooo001/0?of
kP030000003om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h03`3om^h20=@m6@X0ooK^00<0e3dI0?of
kP3om^h0203om^h00`3D?AT0ooK^0?ofkP0A0?ofkP80e3dI0P3om^h40=@m6@<0ooK^0P3D?AT01@3o
m^h0e3dI0=@m6@3om^h0e3dI00<0ooK^1@3D?ATV0?ofkP030000003om^h0ooK^02@0ooK^1@0mFJ/3
0?ofkP0503eIZ`3om^h0?EV[03eIZ`3om^h00P0mFJ/30?ofkP@0?EV[0P3om^h203eIZa<0ooK^00<0
?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP080?ofkP80?EV[4@3om^h00`0mFJ/0ooK^0?of
kP0=0?ofkP030000003om^h0ooK^06X0ooK^0@3oool006/0ooK^00<000000?ofkP3om^h03@3om^h0
0`3D?AT0ooK^0?ofkP0B0?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h02P3om^h2
0=@m6A40ooK^00@0e3dI0?ofkP3D?AT0e3dI2@3om^h01P3D?AT0ooK^0?ofkP3D?AT0ooK^0=@m6@@0
ooK^1@3D?ATT0?ofkP030000003om^h0ooK^0280ooK^1@0mFJ/40?ofkP0303eIZ`3om^h0?EV[0080
ooK^00<0?EV[0?ofkP3om^h01`3om^h203eIZ`030?ofkP0mFJ/0ooK^0100ooK^0P0mFJ/<0?ofkP03
03eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h04P3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP03
0000003om^h0ooK^06T0ooK^0@3oool006T0ooK^0P00000?0?ofkP030=@m6@3om^h0ooK^01@0ooK^
0P3D?AT40?ofkP80e3dI3`3om^h20=@m6@l0ooK^0P3D?AT00`3om^h0e3dI0?ofkP090?ofkP80e3dI
00<0ooK^0=@m6@3D?AT01@3om^h50=@m6B<0ooK^00<000000?ofkP3om^h08@3om^h503eIZ`D0ooK^
0P0mFJ/00`3om^h0?EV[03eIZ`0:0?ofkP0403eIZ`3om^h0?EV[03eIZ`l0ooK^0P0mFJ/?0?ofkP80
?EV[103om^h203eIZaH0ooK^00<0?EV[0?ofkP3om^h03@3om^h2000006T0ooK^0@3oool006P0ooK^
00<000000?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0G0?ofkP80e3dI00<0ooK^0=@m6@3om^h0
4P3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP<0e3dI0`3om^h20=@m6@X0ooK^00@0e3dI0?ofkP3D?AT0
e3dI1P3om^h20=@m6@030?ofkP3D?AT0e3dI0240ooK^00<000000?ofkP3om^h07`3om^h203eIZ`03
0?ofkP0mFJ/0?EV[00H0ooK^0P0mFJ/00`3om^h0?EV[0?ofkP090?ofkP80?EV[0`3om^h303eIZ``0
ooK^00<0?EV[0?ofkP3om^h04@3om^h0100mFJ/0ooK^03eIZ`0mFJ/I0?ofkP0303eIZ`3om^h0ooK^
00h0ooK^00<000000?ofkP3om^h0IP3om^h10?ooo`00I`3om^h00`000000ooK^0?ofkP0>0?ofkP04
0=@m6@3om^h0e3dI0=@m6AT0ooK^00<0e3dI0?ofkP3om^h04`3om^h20=@m6@P0ooK^0P3D?AT20?of
kP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h0203om^h40=@m6@H0ooK^1@3D?ATP0?of
kP030000003om^h0ooK^01h0ooK^1@0mFJ/60?ofkP@0?EV[2P3om^h00`0mFJ/0ooK^0?ofkP030?of
kP0303eIZ`3om^h0ooK^0080?EV[203om^h203eIZaD0ooK^00<0?EV[0?ofkP3om^h05`3om^h203eI
Z`030?ofkP0mFJ/0ooK^00l0ooK^00<000000?ofkP3om^h0I@3om^h10?ooo`00IP3om^h00`000000
ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^0080ooK^0P3D?ATF0?ofkP040=@m6@3om^h0e3dI0=@m
6AD0ooK^00<0e3dI0?ofkP3om^h00`3om^h20=@m6@@0ooK^0`3D?AT40?ofkP030=@m6@3om^h0ooK^
00T0ooK^00<0e3dI0?ofkP3D?AT01`3om^h20=@m6@030?ofkP3D?AT0e3dI01h0ooK^00<000000?of
kP3om^h0703om^h503eIZ`L0ooK^00<0?EV[0?ofkP0mFJ/02`3om^h00`0mFJ/0ooK^0?ofkP020?of
kP<0?EV[103om^h203eIZ`D0ooK^00<0?EV[0?ofkP3om^h04`3om^h203eIZ`030?ofkP0mFJ/0ooK^
01D0ooK^0P0mFJ/40?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<000000?ofkP3om^h0I03om^h10?oo
o`00I@3om^h00`000000ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3o
m^h04P3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^01<0ooK^0P3D?AT00`3om^h0
e3dI0=@m6@060?ofkP040=@m6@3om^h0ooK^0=@m6@@0ooK^0P3D?AT90?ofkPD0e3dI1P3om^h30=@m
6@030?ofkP3D?AT0ooK^01`0ooK^00<000000?ofkP3om^h06`3om^h00`0mFJ/0ooK^03eIZ`0203eI
Z`H0ooK^1@0mFJ/90?ofkP80?EV[103om^h0100mFJ/0ooK^0?ofkP0mFJ/60?ofkP80?EV[00<0ooK^
03eIZ`0mFJ/05@3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^0180ooK^00<0?EV[
0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP030000003om^h0ooK^06<0ooK^0@3oool0
06@0ooK^00<000000?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP060?ofkP80e3dI4@3om^h00`3D
?AT0ooK^0?ofkP040?ofkP80e3dI5@3om^h00`3D?AT0ooK^0?ofkP060?ofkP040=@m6@3om^h0ooK^
0?ofkP80e3dI103om^h00`3D?AT0ooK^0?ofkP060?ofkP060=@m6@3om^h0ooK^0=@m6@3om^h0e3dI
1P3om^h30=@m6@030?ofkP3D?AT0e3dI01/0ooK^00<000000?ofkP3om^h06@3om^h203eIZ`040?of
kP0mFJ/0?EV[03eIZ`H0ooK^00<0?EV[0?ofkP0mFJ/00P3om^h00`0mFJ/0ooK^0?ofkP060?ofkP03
03eIZ`3om^h0ooK^0080ooK^0P0mFJ/30?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3o
m^h04`3om^h203eIZ`H0ooK^00<0?EV[0?ofkP3om^h03`3om^h203eIZ`P0ooK^00<0?EV[0?ofkP3o
m^h03`3om^h00`000000ooK^0?ofkP1R0?ofkP40oooo001R0?ofkP8000004@3om^h00`3D?AT0ooK^
0?ofkP090?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^
0?ofkP0A0?ofkP040=@m6@3om^h0e3dI0=@m6@D0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0
ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00D0ooK^00@0e3dI0?ofkP3om^h0ooK^0`3D?AT70?of
kP80e3dI0P3om^h20=@m6AT0ooK^00<000000?ofkP3om^h05`3om^h203eIZ`80ooK^0P0mFJ/70?of
kP<0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?of
kP3om^h0103om^h00`0mFJ/0ooK^0?ofkP030?ofkP80?EV[00<0ooK^03eIZ`3om^h04P3om^h00`0m
FJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0m
FJ/0ooK^0?ofkP0?0?ofkP800000HP3om^h10?ooo`00H@3om^h00`000000ooK^0?ofkP0@0?ofkP03
0=@m6@3om^h0ooK^00/0ooK^0P3D?AT<0?ofkP030=@m6@3om^h0ooK^00T0ooK^0P3D?AT?0?ofkP80
e3dI103om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00D0ooK^0P3D?AT30?ofkP80
e3dI1@3om^h00`3D?AT0ooK^0?ofkP030?ofkP<0e3dI1@3om^h40=@m6@80ooK^00<0e3dI0?ofkP3o
m^h05P3om^h00`000000ooK^0?ofkP0F0?ofkP0303eIZ`3om^h0ooK^00@0?EV[1@3om^h303eIZ`D0
ooK^00<0?EV[0?ofkP3om^h00`3om^h203eIZ`<0ooK^0P0mFJ/70?ofkP0303eIZ`3om^h0ooK^0080
ooK^00<0?EV[0?ofkP3om^h00P3om^h203eIZ`l0ooK^0P0mFJ/;0?ofkP0303eIZ`3om^h0ooK^00X0
ooK^0P0mFJ/=0?ofkP0303eIZ`3om^h0ooK^0100ooK^00<000000?ofkP3om^h0G`3om^h10?ooo`00
H03om^h00`000000ooK^0?ofkP0@0?ofkP030=@m6@3om^h0ooK^00h0ooK^0P3D?AT90?ofkP030=@m
6@3om^h0ooK^00`0ooK^0P3D?AT<0?ofkP030=@m6@3om^h0ooK^00D0ooK^0P3D?AT20?ofkP030=@m
6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m
6@3om^h0ooK^00@0ooK^3@3D?AT00`3om^h0e3dI0=@m6@0F0?ofkP030000003om^h0ooK^01@0ooK^
0P0mFJ/00`3om^h0?EV[03eIZ`0;03eIZ`H0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^
0?ofkP020?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h00P0mFJ/70?ofkP0303eI
Z`3om^h0ooK^00X0ooK^0P0mFJ/>0?ofkP0303eIZ`3om^h0ooK^00L0ooK^0P0mFJ/@0?ofkP0303eI
Z`3om^h0ooK^0100ooK^00<000000?ofkP3om^h0GP3om^h10?ooo`00G`3om^h00`000000ooK^0?of
kP0@0?ofkP030=@m6@3om^h0ooK^0140ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?of
kP0?0?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0=@m
6@0:0?ofkP030=@m6@3om^h0ooK^0080ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@040?ofkP<0e3dI
00@0ooK^0=@m6@3D?AT0e3dI0`3om^h00`3D?AT0ooK^0?ofkP040=@m6@030?ofkP3D?AT0ooK^01@0
ooK^00<000000?ofkP3om^h04`3om^h00`0mFJ/0ooK^03eIZ`0303eIZ`80ooK^00@0?EV[0?ofkP3o
m^h0ooK^0`0mFJ/0103om^h0?EV[03eIZ`0mFJ/40?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/0103o
m^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0?EV[00X0ooK^00<0?EV[0?ofkP3om^h0203o
m^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h04@3o
m^h00`0mFJ/0ooK^0?ofkP0@0?ofkP030000003om^h0ooK^05d0ooK^0@3oool005h0ooK^00<00000
0?ofkP3om^h0403om^h00`3D?AT0ooK^0?ofkP0C0?ofkP80e3dI103om^h00`3D?AT0ooK^0?ofkP0A
0?ofkP80e3dI1`3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP80e3dI2`3om^h20=@m6@<0ooK^0P3D?AT0
0`3om^h0e3dI0=@m6@030=@m6@D0ooK^0`3D?AT30?ofkP040=@m6@3om^h0ooK^0?ofkPH0e3dI4`3o
m^h00`000000ooK^0?ofkP0A0?ofkPH0?EV[0`3om^h0100mFJ/0ooK^0?ofkP3om^h303eIZ`D0ooK^
1@0mFJ/00`3om^h0?EV[03eIZ`030?ofkP80?EV[2`3om^h203eIZ``0ooK^00<0?EV[0?ofkP3om^h0
1@3om^h203eIZa<0ooK^00<0?EV[0?ofkP3om^h00P3om^h203eIZa@0ooK^00<0?EV[0?ofkP3om^h0
4@3om^h00`000000ooK^0?ofkP1L0?ofkP40oooo001L0?ofkP8000004`3om^h00`3D?AT0ooK^0?of
kP0E0?ofkP80e3dI00<0ooK^0=@m6@3om^h05@3om^h00`3D?AT0ooK^0?ofkP020?ofkP80e3dI3P3o
m^h30=@m6@/0ooK^00<0e3dI0?ofkP3om^h00P3om^h20=@m6@/0ooK^0`3D?AT00`3om^h0e3dI0?of
kP030?ofkP<0e3dI00<0ooK^0=@m6@3D?AT04P3om^h00`000000ooK^0?ofkP0@0?ofkP80?EV[00@0
ooK^03eIZ`0mFJ/0?EV[103om^h00`0mFJ/0ooK^03eIZ`0203eIZ`/0ooK^0P0mFJ/40?ofkP0303eI
Z`3om^h0ooK^00T0ooK^0`0mFJ/>0?ofkP80?EV[103om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP0403eI
Z`3om^h0?EV[03eIZaL0ooK^00<0?EV[0?ofkP3om^h04@3om^h2000005`0ooK^0@3oool005/0ooK^
00<000000?ofkP3om^h04P3om^h00`3D?AT0ooK^0?ofkP0H0?ofkP030=@m6@3om^h0ooK^01H0ooK^
0P3D?AT00`3om^h0e3dI0?ofkP0?0?ofkP040=@m6@3om^h0ooK^0=@m6@/0ooK^103D?AT00`3om^h0
e3dI0=@m6@0;0?ofkP<0e3dI00<0ooK^0=@m6@3om^h0103om^h20=@m6@80ooK^00<0e3dI0?ofkP3o
m^h03`3om^h00`000000ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^0080?EV[1@3om^h00`0mFJ/0
ooK^03eIZ`0203eIZ`/0ooK^0P0mFJ/00`3om^h0?EV[03eIZ`0203eIZ`/0ooK^00@0?EV[0?ofkP3o
m^h0?EV[403om^h0100mFJ/0ooK^03eIZ`0mFJ/H0?ofkP0303eIZ`3om^h0ooK^01P0ooK^00<0?EV[
0?ofkP3om^h04P3om^h00`000000ooK^0?ofkP1I0?ofkP40oooo001J0?ofkP030000003om^h0ooK^
0180ooK^00<0e3dI0?ofkP3om^h0603om^h0103D?AT0ooK^0=@m6@3D?ATH0?ofkP030=@m6@3om^h0
ooK^00l0ooK^00@0e3dI0?ofkP3om^h0ooK^0P3D?AT90?ofkP<0e3dI0P3om^h0103D?AT0ooK^0=@m
6@3D?AT;0?ofkP<0e3dI1P3om^h30=@m6@030?ofkP3D?AT0e3dI00l0ooK^00<000000?ofkP3om^h0
3@3om^h203eIZ`040?ofkP0mFJ/0?EV[03eIZ`H0ooK^0`0mFJ/<0?ofkP0303eIZ`3om^h0?EV[0080
ooK^0`0mFJ/90?ofkP80?EV[0`3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^01H0
ooK^0P0mFJ/00`3om^h0?EV[0?ofkP0I0?ofkP0303eIZ`3om^h0ooK^0180ooK^00<000000?ofkP3o
m^h0F03om^h10?ooo`00F@3om^h00`000000ooK^0?ofkP0B0?ofkP040=@m6@3om^h0e3dI0=@m6AL0
ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP0D0?ofkP040=@m6@3om^h0e3dI0=@m
6@h0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP040?ofkP80e3dI0`3om^h30=@m
6@<0ooK^00<0e3dI0?ofkP3om^h02@3om^h30=@m6@L0ooK^1@3D?AT>0?ofkP030000003om^h0ooK^
00`0ooK^1@0mFJ/70?ofkP<0?EV[2`3om^h203eIZ`80ooK^0`0mFJ/30?ofkP80?EV[1P3om^h00`0m
FJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00`0ooK^0P0mFJ/00`3om^h0?EV[0?ofkP0E0?of
kP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h05@3om^h203eIZ`030?ofkP0mFJ/0ooK^
01<0ooK^00<000000?ofkP3om^h0E`3om^h10?ooo`00F03om^h00`000000ooK^0?ofkP0C0?ofkP04
0=@m6@3om^h0ooK^0?ofkP80e3dI503om^h00`3D?AT0ooK^0?ofkP040?ofkP80e3dI4`3om^h00`3D
?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h01@3om^h20=@m
6@80ooK^0P3D?AT70?ofkP030=@m6@3om^h0ooK^0080ooK^0P3D?AT;0?ofkP80e3dI1`3om^h30=@m
6@030?ofkP3D?AT0ooK^00`0ooK^00<000000?ofkP3om^h02`3om^h00`0mFJ/0ooK^03eIZ`0203eI
Z`L0ooK^0P0mFJ/;0?ofkP80?EV[103om^h00`0mFJ/0ooK^0?ofkP050?ofkP80?EV[0P3om^h203eI
Z`L0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^
0140ooK^0P0mFJ/50?ofkP0303eIZ`3om^h0ooK^01<0ooK^0P0mFJ/30?ofkP0303eIZ`3om^h0ooK^
01<0ooK^00<000000?ofkP3om^h0EP3om^h10?ooo`00E`3om^h00`000000ooK^0?ofkP0C0?ofkP03
0=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h04@3om^h00`3D?AT0ooK^0?ofkP060?ofkP03
0=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h0103om^h20=@m6@/0ooK^00<0e3dI0?ofkP3o
m^h01`3om^h20=@m6@T0ooK^0`3D?AT40?ofkP80e3dI2@3om^h40=@m6@L0ooK^1@3D?AT;0?ofkP03
0000003om^h0ooK^00T0ooK^1@0mFJ/70?ofkP@0?EV[2P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP<0
?EV[2@3om^h203eIZ`T0ooK^00<0?EV[0?ofkP3om^h02@3om^h203eIZ`H0ooK^00<0?EV[0?ofkP3o
m^h03`3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^0140ooK^00<0?EV[0?ofkP3o
m^h0103om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP030000003om^h0ooK^05D0ooK^0@3oool005D0ooK^
0P00000E0?ofkP030=@m6@3om^h0ooK^00H0ooK^0P3D?AT@0?ofkP030=@m6@3om^h0ooK^00P0ooK^
0P3D?AT>0?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^
0?ofkP060?ofkP040=@m6@3om^h0e3dI0=@m6@P0ooK^00@0e3dI0?ofkP3om^h0e3dI1@3om^h20=@m
6@L0ooK^00<0e3dI0?ofkP3om^h00P3D?AT70?ofkP<0e3dI00<0ooK^0=@m6@3om^h02@3om^h00`00
0000ooK^0?ofkP080?ofkP0303eIZ`3om^h0?EV[0080?EV[1`3om^h203eIZ`80ooK^00<0?EV[0?of
kP3om^h01P3om^h203eIZ`@0ooK^00@0?EV[0?ofkP3om^h0?EV[203om^h203eIZ`030?ofkP0mFJ/0
?EV[00L0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0
ooK^00`0ooK^0P0mFJ/:0?ofkP0303eIZ`3om^h0ooK^00h0ooK^0P0mFJ/80?ofkP0303eIZ`3om^h0
ooK^01<0ooK^0P00001E0?ofkP40oooo001D0?ofkP030000003om^h0ooK^01D0ooK^00<0e3dI0?of
kP3om^h0203om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00/0ooK^0P3D?AT;0?of
kP030=@m6@3om^h0ooK^00T0ooK^0P3D?AT80?ofkP<0e3dI103om^h20=@m6@@0ooK^00<0e3dI0?of
kP3om^h01@3om^h0103D?AT0ooK^0?ofkP3om^h20=@m6@D0ooK^00<0e3dI0?ofkP3om^h0103om^h0
103D?AT0ooK^0?ofkP3om^h30=@m6@L0ooK^103D?AT90?ofkP030000003om^h0ooK^00L0ooK^100m
FJ/70?ofkP<0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^0080ooK^0P0m
FJ/30?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?of
kP020?ofkP<0?EV[2@3om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^00T0ooK^0P0m
FJ/=0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?of
kP0E0?ofkP030000003om^h0ooK^0580ooK^0@3oool005<0ooK^00<000000?ofkP3om^h05@3om^h0
0`3D?AT0ooK^0?ofkP0:0?ofkP80e3dI2`3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0
ooK^00L0ooK^00<0e3dI0?ofkP3om^h0303om^h20=@m6@D0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m
6@020?ofkP030=@m6@3om^h0ooK^00D0ooK^0P3D?AT40?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0
e3dI0?ofkP3om^h00`3om^h20=@m6@@0ooK^00<0e3dI0?ofkP3om^h00P3om^h?0=@m6@D0ooK^0P00
00000`3om^h00000000000050?ofkPl0?EV[103om^h00`0mFJ/0ooK^0?ofkP030?ofkP80?EV[103o
m^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^0080ooK^0P0mFJ/70?ofkP0403eIZ`3o
m^h0ooK^03eIZ`<0ooK^00<0?EV[0?ofkP3om^h0103om^h203eIZ`d0ooK^00<0?EV[0?ofkP3om^h0
1`3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00T0ooK^0P0mFJ/<0?ofkP0303eI
Z`3om^h0ooK^01D0ooK^00<000000?ofkP3om^h0D@3om^h10?ooo`00DP3om^h00`000000ooK^0?of
kP0E0?ofkP030=@m6@3om^h0ooK^00d0ooK^0P3D?AT80?ofkP030=@m6@3om^h0ooK^0100ooK^0P3D
?AT60?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?of
kP020?ofkP80e3dI2P3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00L0ooK^0P3D?AT50?ofkP80e3dI
0P3om^h50=@m6@80ooK^0`3D?AT50?ofkP030=@m6@3om^h0e3dI00<0e3dI0`3om^h00`000000ooK^
0?ofkP030?ofkP040000003om^h0ooK^0?ofkP@0?EV[00<0ooK^03eIZ`3om^h0103om^h303eIZ`80
ooK^1@0mFJ/30?ofkP80?EV[103om^h203eIZ`L0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0:0?of
kP80?EV[103om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?of
kP3om^h0103om^h203eIZa80ooK^00<0?EV[0?ofkP3om^h01P3om^h203eIZ`h0ooK^00<0?EV[0?of
kP3om^h05P3om^h00`000000ooK^0?ofkP1@0?ofkP40oooo001A0?ofkP030000003om^h0ooK^01H0
ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^01<0
ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP0A0?ofkP80e3dI0P3om^h00`3D?AT0
ooK^0?ofkP020?ofkP030=@m6@3om^h0e3dI00X0ooK^00@0e3dI0?ofkP3om^h0e3dI2@3om^h00`3D
?AT0ooK^0?ofkP040?ofkP<0e3dI1`3om^h30=@m6@@0ooK^00<0e3dI0?ofkP3om^h0103D?AT20000
00L0ooK^0P00000403eIZ`80ooK^00<0?EV[0?ofkP3om^h00P3om^h303eIZ`L0ooK^100mFJ/50?of
kP0303eIZ`3om^h0ooK^00L0ooK^00@0?EV[0?ofkP3om^h0?EV[2P3om^h0100mFJ/0ooK^0?ofkP0m
FJ/30?ofkP0403eIZ`3om^h0ooK^0?ofkP80?EV[4P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eI
Z`3om^h0ooK^0180ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eI
Z`3om^h0ooK^01H0ooK^00<000000?ofkP3om^h0C`3om^h10?ooo`00C`3om^h2000001P0ooK^00<0
e3dI0?ofkP3om^h04@3om^h20=@m6@@0ooK^00<0e3dI0?ofkP3om^h0503om^h20=@m6@030?ofkP3D
?AT0ooK^01D0ooK^0P3D?AT30?ofkP80e3dI0`3om^h20=@m6@T0ooK^0`3D?AT:0?ofkP040=@m6@3o
m^h0ooK^0?ofkP80e3dI00@0ooK^0=@m6@3D?AT0e3dI203om^h30=@m6@80ooK^00<0e3dI0?ofkP3o
m^h00P3om^h0103D?AT000000=@m6@3D?AT70?ofkP80?EV[00<0000003eIZ`3om^h00`3om^h00`0m
FJ/0ooK^0?ofkP0303eIZ`P0ooK^00D0?EV[0?ofkP0mFJ/0?EV[0?ofkP0203eIZ`80ooK^00<0?EV[
0?ofkP3om^h0203om^h303eIZ`T0ooK^0P0mFJ/40?ofkP0703eIZ`3om^h0ooK^0?ofkP0mFJ/0ooK^
03eIZ`0E0?ofkP0403eIZ`3om^h0?EV[03eIZaH0ooK^00<0?EV[0?ofkP3om^h00P3om^h203eIZa<0
ooK^00<0?EV[0?ofkP3om^h05P3om^h2000004l0ooK^0@3oool004h0ooK^00<000000?ofkP3om^h0
603om^h00`3D?AT0ooK^0?ofkP0C0?ofkP80e3dI00<0ooK^0=@m6@3om^h0603om^h00`3D?AT0ooK^
0?ofkP0F0?ofkP80e3dI00<0ooK^0=@m6@3om^h01P3om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m
6@3om^h0ooK^00T0ooK^0`3D?AT50?ofkP030=@m6@3om^h0ooK^00L0ooK^0`3D?AT20?ofkP050=@m
6@3om^h0ooK^0?ofkP0000000P3D?AT00`3om^h0e3dI0?ofkP040?ofkP0503eIZ`3om^h0?EV[03eI
Z`0000000`3om^h00`0mFJ/0ooK^0?ofkP0303eIZ`T0ooK^0P0mFJ/50?ofkP80?EV[2`3om^h00`0m
FJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00D0ooK^0P0mFJ/00`3om^h0?EV[03eIZ`0G0?of
kP0303eIZ`3om^h0ooK^01L0ooK^00@0?EV[0?ofkP0mFJ/0?EV[5@3om^h00`0mFJ/0ooK^0?ofkP0H
0?ofkP030000003om^h0ooK^04`0ooK^0@3oool004d0ooK^00<000000?ofkP3om^h0603om^h00`3D
?AT0ooK^0?ofkP0F0?ofkP030=@m6@3om^h0ooK^01L0ooK^00@0e3dI0?ofkP3D?AT0e3dI5P3om^h0
0`3D?AT0ooK^0=@m6@090?ofkP030=@m6@3om^h0ooK^00L0ooK^0`3D?AT80?ofkP80e3dI00<0ooK^
0=@m6@3om^h0103om^h20=@m6@X0ooK^103D?AT00`3om^h00000000000020?ofkPD0e3dI00<00000
03eIZ`0mFJ/00`0mFJ/20?ofkP80000000<0ooK^03eIZ`0mFJ/00P0mFJ/:0?ofkP80?EV[1@3om^h0
100mFJ/0ooK^0?ofkP0mFJ/80?ofkP<0?EV[2@3om^h00`0mFJ/0ooK^0?ofkP080?ofkP80?EV[5P3o
m^h203eIZ`030?ofkP0mFJ/0ooK^01P0ooK^00<0?EV[0?ofkP3om^h05P3om^h00`0mFJ/0ooK^0?of
kP0H0?ofkP030000003om^h0ooK^04/0ooK^0@3oool004`0ooK^00<000000?ofkP3om^h0603om^h0
0`3D?AT0ooK^0?ofkP0F0?ofkP040=@m6@3om^h0e3dI0=@m6AH0ooK^00<0e3dI0?ofkP3om^h00P3o
m^h00`3D?AT0ooK^0?ofkP0B0?ofkP040=@m6@3om^h0e3dI0?ofkP80e3dI203om^h20=@m6@L0ooK^
00@0e3dI0?ofkP3om^h0e3dI1@3om^h20=@m6@@0ooK^0P3D?AT30?ofkP040=@m6@3om^h0e3dI0=@m
6@T0ooK^00@0e3dI0?ofkP3D?AT000001P3om^h01`3D?AT000000=@m6@000000?EV[0000000mFJ/0
1P3om^h010000000?EV[0?ofkP0mFJ/:0?ofkP0303eIZ`3om^h0?EV[00<0ooK^0P0mFJ/40?ofkP80
?EV[1@3om^h0100mFJ/0ooK^0?ofkP0mFJ/70?ofkP80?EV[2@3om^h203eIZ`030?ofkP0mFJ/0ooK^
01@0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP80?EV[00<0ooK^03eI
Z`3om^h05`3om^h00`0mFJ/0ooK^0?ofkP0H0?ofkP030000003om^h0ooK^04X0ooK^0@3oool004/0
ooK^00<000000?ofkP3om^h06@3om^h00`3D?AT0ooK^0?ofkP0F0?ofkP050=@m6@3om^h0ooK^0?of
kP3D?AT0503om^h00`3D?AT0ooK^0?ofkP040?ofkP80e3dI4P3om^h20=@m6@@0ooK^00<0e3dI0?of
kP3om^h01`3om^h00`3D?AT0ooK^0?ofkP040?ofkP040=@m6@3om^h0ooK^0?ofkP80e3dI00<0ooK^
0=@m6@3D?AT0203om^h0103D?AT0ooK^0?ofkP3D?AT30?ofkP030=@m6@3om^h0ooK^00L0ooK^0P00
00020=@m6@@0ooK^0P0000020=@m6@030000000mFJ/0?EV[00800000103om^h203eIZ`8000002P3o
m^h0100mFJ/0ooK^0?ofkP0mFJ/20?ofkP0303eIZ`3om^h0ooK^00H0ooK^0P0mFJ/00`3om^h0?EV[
03eIZ`030?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h01`3om^h203eIZ`@0ooK^
00<0?EV[0?ofkP3om^h0403om^h203eIZ`D0ooK^00<0?EV[0?ofkP3om^h04`3om^h01@0mFJ/0ooK^
0?ofkP3om^h0?EV[01P0ooK^00<0?EV[0?ofkP3om^h06@3om^h00`000000ooK^0?ofkP190?ofkP40
oooo00190?ofkP8000006`3om^h00`3D?AT0ooK^0?ofkP0F0?ofkP030=@m6@3om^h0ooK^00<0ooK^
0P3D?ATB0?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^
0?ofkP040?ofkP80e3dI203om^h20=@m6@<0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^
0?ofkP090?ofkP<0e3dI103om^h00`3D?AT0ooK^0?ofkP050?ofkP070000003om^h0ooK^0=@m6@3o
m^h0e3dI0?ofkP020000000503eIZ`0000001PPA00H84@0mFJ/00P2:8Pd020000000G1@800000000
0000ooK^03eIZ`3om^h0?EV[0P3om^h00`000000ooK^0?ofkP050?ofkP80?EV[0`3om^h303eIZ`/0
ooK^00<0?EV[0?ofkP3om^h0103om^h0100mFJ/0ooK^0?ofkP3om^h203eIZ`T0ooK^00<0?EV[0?of
kP3om^h0103om^h203eIZa00ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP0@0?of
kP80?EV[1@3om^h00`0mFJ/0ooK^0?ofkP0F0?ofkP0303eIZ`3om^h0ooK^01T0ooK^0P0000190?of
kP40oooo00180?ofkP030000003om^h0ooK^01X0ooK^00@0e3dI0?ofkP3D?AT0e3dI5@3om^h00`3D
?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D
?AT0ooK^0?ofkP0=0?ofkP80e3dI203om^h20=@m6@P0ooK^00@0e3dI0?ofkP3om^h0e3dI103om^h2
0=@m6@030?ofkP3D?AT0e3dI00/0ooK^00<0e3dI0?ofkP3om^h00`3om^h20=@m6@<0ooK^0P000003
0?ofkP<0e3dI00@0000000H84@0mFJ/000000`0621401@000000RR8=08XR3@2:8Pd000000080G1@8
00@0000003eIZ`0mFJ/0?EV[0`3om^h2000000@0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0
ooK^0?ofkP090?ofkP80?EV[00<0ooK^03eIZ`0mFJ/0103om^h0100mFJ/0ooK^0?ofkP0mFJ/90?of
kP80?EV[1`3om^h00`0mFJ/0ooK^03eIZ`0>0?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?of
kP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^01<0ooK^0P0mFJ/00`3o
m^h0?EV[0?ofkP0K0?ofkP030000003om^h0ooK^04H0ooK^0@3oool004L0ooK^00<000000?ofkP3o
m^h06`3om^h0103D?AT0ooK^0?ofkP3om^h20=@m6A<0ooK^00<0e3dI0?ofkP3om^h01`3om^h20=@m
6@d0ooK^00<0e3dI0?ofkP3om^h02P3om^h20=@m6@/0ooK^0`3D?AT;0?ofkP030=@m6@3om^h0ooK^
00H0ooK^0`3D?AT30?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h0203om^h30=@m
6@D0ooK^00<0e3dI0?ofkP0000001@3om^h0103D?AT0ooK^00H84@3D?AT2000000@01PPA00<00000
08XR3@2:8Pd00P2:8Pd20000000403eIZ`000000ooK^03eIZ`D0ooK^00@000000?ofkP0mFJ/0?EV[
103om^h303eIZ`X0ooK^00<0?EV[0?ofkP3om^h00`3om^h0100mFJ/0ooK^0?ofkP3om^h303eIZ`P0
ooK^0P0mFJ/:0?ofkP0303eIZ`3om^h0?EV[00/0ooK^0P0mFJ/<0?ofkP0303eIZ`3om^h0ooK^00/0
ooK^0P0mFJ/90?ofkP0303eIZ`3om^h0ooK^0140ooK^0P0mFJ/30?ofkP0303eIZ`3om^h0ooK^01/0
ooK^00<000000?ofkP3om^h0A@3om^h10?ooo`00AP3om^h00`000000ooK^0?ofkP0K0?ofkP030=@m
6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP80e3dI
2P3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00L0ooK^00@0e3dI0?ofkP3om^h0
e3dI303om^h20=@m6@P0ooK^00@0e3dI0?ofkP3om^h0e3dI1`3om^h20=@m6@P0ooK^00@0e3dI0?of
kP3om^h0e3dI1@3om^h00`000000ooK^0?ofkP040?ofkP050=@m6@0621401PPA0000003D?AT01006
2143000000@0RR8=00D0?EV[0000001L50P0000003eIZ`060?ofkP030000003om^h0ooK^00<0ooK^
00@0?EV[0?ofkP3om^h0?EV[203om^h203eIZ`L0ooK^00@0?EV[0?ofkP3om^h0?EV[203om^h203eI
Z``0ooK^00@0?EV[0?ofkP3om^h0?EV[2@3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0
ooK^00P0ooK^0P0mFJ/<0?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h0103om^h0
0`0mFJ/0ooK^0?ofkP0K0?ofkP030000003om^h0ooK^04@0ooK^0@3oool004D0ooK^00<000000?of
kP3om^h0703om^h00`3D?AT0ooK^0?ofkP050?ofkP80e3dI3P3om^h00`3D?AT0ooK^0?ofkP0=0?of
kP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h03`3om^h20=@m6@H0ooK^00D0e3dI0?of
kP3om^h0ooK^0=@m6@0>0?ofkP030=@m6@3om^h0ooK^00D0ooK^0`3D?AT:0?ofkP80e3dI1P3om^h0
103D?AT0ooK^0?ofkP3om^h20=@m6@040?ofkP00000000000?ofkP80e3dI0`3om^h00`000000e3dI
000000020000000300H84@3D?AT0e3dI0080000000<02`lP0000002b;Q400P00000203eIZ`0708XR
3@00000000000000000mFJ/0000003eIZ`020?ofkP80?EV[00@0ooK^000000000000ooK^0P0mFJ/3
0?ofkP0303eIZ`3om^h0ooK^00@0ooK^0P0mFJ/:0?ofkP<0?EV[1`3om^h00`0mFJ/0ooK^0?ofkP0<
0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/01P3om^h203eIZa40ooK^00<0?EV[0?ofkP3om^h01P3o
m^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00d0ooK^0P0mFJ/70?ofkP0303eIZ`3o
m^h0ooK^01`0ooK^00<000000?ofkP3om^h0@`3om^h10?ooo`00A03om^h00`000000ooK^0?ofkP0L
0?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP0>
0?ofkP80e3dI1@3om^h00`3D?AT0ooK^0?ofkP0B0?ofkP030=@m6@3om^h0ooK^0080ooK^00D0e3dI
0?ofkP3om^h0ooK^0=@m6@0@0?ofkP80e3dI103om^h20=@m6@80ooK^00<0e3dI0?ofkP3om^h02@3o
m^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00@0ooK^00<000000?ofkP3om^h00`3o
m^h20=@m6@03000000062140e3dI00801PPA00D0000000H84@06214000000=@m6@0200/?80050000
002b;Q40/RhA03eIZ`0000000P2:8Pd01P000000RR8=08XR3@0mFJ/0G1@800000080?EV[1@3om^h0
0`000000ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h02@3om^h0
100mFJ/0ooK^0?ofkP0mFJ/50?ofkP80?EV[403om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00@0ooK^
00<0?EV[0?ofkP3om^h04@3om^h00`0mFJ/0ooK^0?ofkP040?ofkP80?EV[403om^h00`0mFJ/0ooK^
0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h0703om^h00`000000ooK^
0?ofkP120?ofkP40oooo00120?ofkP8000007`3om^h00`3D?AT0ooK^0?ofkP090?ofkP80e3dI2P3o
m^h00`3D?AT0ooK^0?ofkP0A0?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h04`3o
m^h20=@m6@030?ofkP3D?AT0ooK^00<0ooK^00<0e3dI0?ofkP3om^h0403om^h20=@m6@030?ofkP3D
?AT0e3dI00@0ooK^0P3D?AT:0?ofkP80e3dI0P3om^h00`3D?AT0ooK^0?ofkP020?ofkP80000000@0
ooK^0=@m6@3D?AT0ooK^0P3D?AT01`3om^h00000000000000000e3dI00H84@0000000P0621400`00
00002`lP00/?80020=@m6@030000000mFJ/0?EV[0080/RhA00H0000008XR3@2:8Pd0000003eIZ`2:
8Pd3000000040?ofkP0mFJ/0?EV[0?ofkP80?EV[00<0ooK^000000000000103om^h00`0mFJ/0ooK^
0?ofkP0203eIZ`X0ooK^0P0mFJ/40?ofkP80?EV[00<0ooK^03eIZ`0mFJ/04P3om^h00`0mFJ/0ooK^
0?ofkP020?ofkP0403eIZ`3om^h0?EV[03eIZaD0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0
ooK^0?ofkP0A0?ofkP0303eIZ`3om^h0ooK^00P0ooK^0P0mFJ/;0?ofkP0303eIZ`3om^h0ooK^01d0
ooK^0P0000120?ofkP40oooo00110?ofkP030000003om^h0ooK^01h0ooK^00<0e3dI0?ofkP3om^h0
303om^h20=@m6@P0ooK^00<0e3dI0?ofkP3om^h04P3om^h20=@m6@030?ofkP3D?AT0ooK^01L0ooK^
00<0e3dI0?ofkP3om^h00`3om^h30=@m6A80ooK^00<0e3dI0?ofkP3D?AT01P3om^h20=@m6@X0ooK^
00<0e3dI0?ofkP3D?AT00`3om^h00`000000ooK^0?ofkP020?ofkP<0e3dI0`00000300H84@040=@m
6@0000000000000000D02`lP00<0?EV[0;8^4@2b;Q400`2b;Q430000000403eIZ`2:8Pd0RR8=08XR
3@<000000`0mFJ/40?ofkP070000003om^h0ooK^0?ofkP0mFJ/0ooK^03eIZ`0:0?ofkP80?EV[1P3o
m^h00`0mFJ/0ooK^03eIZ`0B0?ofkP<0?EV[1@3om^h00`0mFJ/0ooK^0?ofkP0F0?ofkP0403eIZ`3o
m^h0?EV[03eIZa@0ooK^00<0?EV[0?ofkP3om^h01P3om^h203eIZ`h0ooK^00<0?EV[0?ofkP3om^h0
7P3om^h00`000000ooK^0?ofkP0o0?ofkP40oooo00100?ofkP030000003om^h0ooK^01h0ooK^00<0
e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^01D0ooK^00<0
e3dI0?ofkP3om^h05P3om^h0103D?AT0ooK^0=@m6@3D?AT20?ofkP050=@m6@3om^h0ooK^0?ofkP3D
?AT0403om^h0103D?AT0ooK^0=@m6@3D?AT80?ofkP030=@m6@3om^h0ooK^00P0ooK^0P3D?AT00`3o
m^h00000000000030?ofkP80e3dI0P3om^h00`000000e3dI00H84@0400H84@030=@m6@0000002`lP
00H02`lP00<000000;8^4@2b;Q401@2b;Q400`000000?EV[08XR3@0408XR3@0403eIZ`000000ooK^
0?ofkP80?EV[0`3om^h2000000030?ofkP0mFJ/0?EV[00X0ooK^00<0?EV[0?ofkP3om^h01P3om^h2
03eIZ`030?ofkP0mFJ/0ooK^00l0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`020?ofkP80?EV[00<0
ooK^03eIZ`3om^h05`3om^h00`0mFJ/0ooK^0?ofkP0E0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0
?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP0N0?ofkP030000003om^h0ooK^03h0ooK^0@3o
ool003l0ooK^00<000000?ofkP3om^h07`3om^h00`3D?AT0ooK^0?ofkP0@0?ofkP80e3dI0`3om^h0
0`3D?AT0ooK^0?ofkP0E0?ofkP040=@m6@3om^h0e3dI0=@m6AD0ooK^00<0e3dI0?ofkP3om^h00P3o
m^h00`3D?AT0ooK^0=@m6@040?ofkP80e3dI3@3om^h01P3D?AT0ooK^0?ofkP3D?AT0ooK^0=@m6@P0
ooK^0P3D?AT90?ofkP030=@m6@000000e3dI0080ooK^0P3D?AT20?ofkP@000000P3D?AT200H84@03
0000003D?AT0000000L02`lP00<000000;8^4@2b;Q401@2b;Q400`000000?EV[0000000208XR3@80
?EV[100000020?ofkP80?EV[0P3om^h00`0mFJ/0000003eIZ`090?ofkP80?EV[203om^h203eIZ`<0
ooK^00<0?EV[0?ofkP3om^h02`3om^h203eIZ`@0ooK^00<0?EV[0?ofkP0mFJ/0103om^h00`0mFJ/0
ooK^0?ofkP0C0?ofkP80?EV[00<0ooK^03eIZ`3om^h05P3om^h0100mFJ/0ooK^0?ofkP3om^h203eI
Za80ooK^00<0?EV[0?ofkP3om^h07`3om^h00`000000ooK^0?ofkP0m0?ofkP40oooo000n0?ofkP03
0000003om^h0ooK^01l0ooK^00<0e3dI0?ofkP3om^h04`3om^h20=@m6@030?ofkP3D?AT0ooK^01H0
ooK^00@0e3dI0?ofkP3om^h0ooK^0P3D?ATC0?ofkP030=@m6@3om^h0ooK^00<0ooK^0P3D?AT60?of
kP030=@m6@3om^h0ooK^00T0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@020?ofkP80e3dI203om^h0
0`3D?AT0ooK^0?ofkP060?ofkP030000003om^h0ooK^0080e3dI0`3om^h2000000801PPA00P00000
00H84@062140e3dI0000000;3b00e3dI000000D02`lP1@0000050;8^4@050000000mFJ/0/RhA0000
000mFJ/00P2:8Pd00`000000RR8=08XR3@02000000<0ooK^0P0mFJ/20?ofkP030000003om^h0ooK^
00H0ooK^00<0?EV[0?ofkP3om^h01P3om^h203eIZ`80ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0;
0?ofkP0303eIZ`3om^h0ooK^00@0ooK^0P0mFJ/50?ofkP0303eIZ`3om^h0ooK^0140ooK^0P0mFJ/3
0?ofkP0303eIZ`3om^h0ooK^01D0ooK^00@0?EV[0?ofkP0mFJ/0?EV[5@3om^h00`0mFJ/0ooK^0?of
kP0O0?ofkP030000003om^h0ooK^03`0ooK^0@3oool003`0ooK^0P00000R0?ofkP030=@m6@3om^h0
ooK^01D0ooK^00<0e3dI0?ofkP3om^h05@3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0
ooK^00l0ooK^00<0e3dI0?ofkP3om^h0103om^h0103D?AT0ooK^0=@m6@3D?AT50?ofkP80e3dI203o
m^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h01P3o
m^h20=@m6@@0ooK^0P0000030=@m6@030?ofkP3D?AT0e3dI00<000000P0621400`0000001PPA00H8
4@02000000<0e3dI00<0000000/?800;3b000P0;3b001000000051Xl01@J?00000020=@i5P030000
002b;Q40/RhA0080/RhA00@0000003eIZ`0mFJ/0?EV[0P00000208XR3@030000002:8Pd0RR8=00<0
00000P0mFJ/0103om^h0?EV[03eIZ`0mFJ/2000000@0ooK^0P0mFJ/80?ofkP0303eIZ`3om^h0ooK^
0080ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP060?ofkP80?EV[1@3om^h203eI
Z`030?ofkP0mFJ/0ooK^00D0ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP040?of
kP0303eIZ`3om^h0ooK^01D0ooK^00<0?EV[0?ofkP3om^h05@3om^h00`0mFJ/0ooK^0?ofkP0P0?of
kP800000?03om^h10?ooo`00>`3om^h00`000000ooK^0?ofkP0Q0?ofkP030=@m6@3om^h0ooK^01D0
ooK^00@0e3dI0?ofkP3D?AT0e3dI503om^h00`3D?AT0ooK^0?ofkP060?ofkP80e3dI3P3om^h00`3D
?AT0ooK^0?ofkP050?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT01P3om^h00`3D?AT0ooK^0?ofkP03
0?ofkP80e3dI1@3om^h00`3D?AT0ooK^0?ofkP030?ofkP80e3dI203om^h20=@m6@030?ofkP000000
ooK^0080e3dI103om^h3000000<01PPA0`00000400/?80040=@m6@0000002`lP00/?808000000`0D
6S`010000000e3TF0=@i5P3D>AH200000080/RhA00<0000003eIZ`2b;Q400`2b;Q43000000<0RR8=
0`0000040?ofkP80?EV[00<0ooK^0000003om^h00P0mFJ/80?ofkP80?EV[1@3om^h00`0mFJ/0ooK^
0?ofkP030?ofkP80?EV[1@3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0503eIZ`3om^h0ooK^0?ofkP0m
FJ/01`3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP80?EV[203om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP80
?EV[00<0ooK^03eIZ`3om^h05P3om^h00`0mFJ/0ooK^0?ofkP0Q0?ofkP030000003om^h0ooK^03T0
ooK^0@3oool003X0ooK^00<000000?ofkP3om^h08P3om^h00`3D?AT0ooK^0?ofkP0E0?ofkP040=@m
6@3om^h0ooK^0?ofkP80e3dI4P3om^h00`3D?AT0ooK^0?ofkP080?ofkP80e3dI2`3om^h00`3D?AT0
ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00<0ooK^0P3D?AT50?ofkP80e3dI0P3om^h00`3D?AT0
ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h01P3om^h200000003
0?ofkP3D?AT0e3dI00@0ooK^0P00000500H84@030000000;3b002`lP00@02`lP0P3D?AT2000000D0
51Xl00<000000=@i5P3D>AH00`3D>AH200000080?EV[1P2b;Q400`000000RR8=08XR3@0308XR3@80
0000103om^h203eIZ`030?ofkP000000000000P0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0
ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^0080?EV[1@3om^h203eIZ`D0ooK^00<0?EV[0?ofkP3o
m^h01@3om^h00`0mFJ/0ooK^0?ofkP090?ofkP80?EV[2P3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP80
?EV[0`3om^h00`0mFJ/0ooK^0?ofkP0E0?ofkP0303eIZ`3om^h0ooK^0280ooK^00<000000?ofkP3o
m^h0>03om^h10?ooo`00>@3om^h00`000000ooK^0?ofkP0R0?ofkP030=@m6@3om^h0ooK^01D0ooK^
00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00/0ooK^
0P3D?AT80?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^
0?ofkP040?ofkP80e3dI1`3om^h00`3D?AT0ooK^0?ofkP070?ofkP80e3dI1@3om^h00`000000ooK^
0=@m6@030=@m6@80ooK^1000000300H84@<000001P0;3b00103D?AT000000=@m6@3D?AT501@J?003
0000003D>AH0e3TF00<0e3TF0P0mFJ/00`000000?EV[0;8^4@050;8^4@<000000`2:8Pd400000080
ooK^100mFJ/00`3om^h000000?ofkP040?ofkP80?EV[2@3om^h00`0mFJ/0ooK^0?ofkP050?ofkP80
?EV[1P3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3o
m^h01P3om^h203eIZ`d0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP040?ofkP03
03eIZ`3om^h0ooK^01D0ooK^00<0?EV[0?ofkP3om^h08P3om^h00`000000ooK^0?ofkP0g0?ofkP40
oooo000h0?ofkP030000003om^h0ooK^02<0ooK^0`3D?ATE0?ofkP030=@m6@3om^h0ooK^00D0ooK^
0P3D?AT=0?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^
0?ofkP060?ofkP030=@m6@3om^h0ooK^00L0ooK^0P3D?AT40?ofkP030=@m6@3om^h0e3dI00H0ooK^
00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP02000000030?ofkP3D?AT0ooK^0080ooK^
00@0e3dI0?ofkP00000000000P062140100000001PPA00H84@00000200/?80030000000;3b002`lP
00<02`lP00<000000=@m6@0000000P0D6S`00`3D?AT051Xl01@J?00201@J?0030000003D>AH0e3TF
0080e3TF00H0?EV[0=@i5P3D>AH0000003eIZ`0000050;8^4@040000002b;Q40/RhA00000080RR8=
00<0000008XR3@2:8Pd00P0000000`3om^h0?EV[0?ofkP020?ofkP0403eIZ`3om^h0000000000080
ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0?EV[00@0
ooK^0P0mFJ/90?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0
ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00/0ooK^0P0mFJ/70?ofkP0303eIZ`3om^h0ooK^01<0
ooK^0`0mFJ/U0?ofkP030000003om^h0ooK^03H0ooK^0@3oool003L0ooK^00<000000?ofkP3om^h0
8`3om^h0103D?AT0ooK^0?ofkP3om^h20=@m6A80ooK^00<0e3dI0?ofkP3om^h0203om^h20=@m6@X0
ooK^00<0e3dI0?ofkP3om^h0403om^h20=@m6@@0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0
ooK^0?ofkP090?ofkP80e3dI00<0ooK^0=@m6@3om^h00P3om^h20=@m6@@0ooK^00<0e3dI0?ofkP3o
m^h02P3om^h00`3D?AT000000?ofkP020=@m6@@0ooK^0`3D?AT200H84@040000000621401PPA0000
00<02`lP00<0000000/?800;3b000P0;3b001000000051Xl0=@m6@00000301@J?0050=@m6@0D6S`0
51Xl01@J?00000000`3D>AH0200mFJ/0e3TF0=@i5P3D>AH0000003eIZ`3D>AH00000102b;Q401@00
0000/RhA0;8^4@2b;Q4000000080RR8=00<0000008XR3@2:8Pd00`0mFJ/40?ofkP80?EV[00<0ooK^
0000000mFJ/0303om^h00`0mFJ/0ooK^0?ofkP020?ofkP80?EV[0`3om^h0100mFJ/0ooK^03eIZ`0m
FJ/;0?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h00P3om^h203eIZa80ooK^00<0
?EV[0?ofkP3om^h0203om^h203eIZ`X0ooK^00<0?EV[0?ofkP3om^h0403om^h203eIZ`<0ooK^00<0
?EV[0?ofkP3om^h08`3om^h00`000000ooK^0?ofkP0e0?ofkP40oooo000e0?ofkP8000009P3om^h0
0`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h02P3om^h2
0=@m6@P0ooK^00<0e3dI0?ofkP3om^h04P3om^h20=@m6@030?ofkP3D?AT0ooK^00L0ooK^00<0e3dI
0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP040?ofkP040=@m6@3om^h0ooK^0=@m6@d0ooK^00<0
00000?ofkP3D?AT01@3om^h01P3D?AT00000000000062140e3dI00H84@<000000`0;3b0010000000
2`lP00/?800;3b020000008051Xl00<0e3dI0000000D6S`00`0D6S`20=@m6@0301@J?0000000e3TF
0080?EV[103D>AH010000000?EV[0=@i5P3D>AH2000000<0/RhA00@000000;8^4@2b;Q40/RhA0`00
00001P2:8Pd0?EV[08XR3@000000?EV[000000D0ooK^00<0?EV[0?ofkP000000303om^h01@0mFJ/0
ooK^0?ofkP3om^h0?EV[00H0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP060?of
kP0403eIZ`3om^h0?EV[03eIZa@0ooK^00<0?EV[0?ofkP3om^h01P3om^h203eIZ``0ooK^00<0?EV[
0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^02@0ooK^0P00000e
0?ofkP40oooo000d0?ofkP030000003om^h0ooK^02D0ooK^00<0e3dI0?ofkP3om^h01@3om^h20=@m
6@h0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^
01D0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP040=@m6@3om^h0e3dI
0=@m6@D0ooK^0`3D?AT;0?ofkP80000000<0ooK^0=@m6@3om^h00P3D?AT0103om^h000000000003D
?AT400H84@80e3dI1@0;3b00100000002`lP00/?8000000401@J?0030=@m6@00000051Xl00@051Xl
00D000000=@m6@000000?EV[000000050=@i5P030000000mFJ/0e3TF00<0e3TF00@000000;8^4@2b
;Q4000001@2b;Q4203eIZ`@0RR8=00@0?EV[000000000000ooK^0P0mFJ/00`3om^h0?EV[0?ofkP02
000000/0ooK^0`0mFJ/50?ofkP80?EV[00<0ooK^03eIZ`3om^h0303om^h00`0mFJ/0ooK^0?ofkP07
0?ofkP0303eIZ`3om^h0ooK^01D0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0=
0?ofkP0303eIZ`3om^h0ooK^00`0ooK^0P0mFJ/70?ofkP0303eIZ`3om^h0ooK^02D0ooK^00<00000
0?ofkP3om^h0<P3om^h10?ooo`00<`3om^h00`000000ooK^0?ofkP0V0?ofkP030=@m6@3om^h0ooK^
00L0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP80e3dI0`3om^h00`3D
?AT0ooK^0?ofkP0E0?ofkP040=@m6@3om^h0e3dI0=@m6@L0ooK^00<0e3dI0?ofkP3om^h02P3om^h0
0`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h0203om^h0
10000000ooK^0?ofkP3D?AT40?ofkP<0000000@0e3dI00H84@0621401PPA0`0000000`3D?AT02`lP
00/?800200/?80<000001@0D6S`00`3D?AT051Xl01@J?00301@J?0040000000M:5L07BQG00000080
jT0I00<000000=@i5P3D>AH00`3D>AH00`0mFJ/0e3TF0=@i5P030=@i5P<00000102b;Q40100mFJ/0
000000000000000308XR3@0403eIZ`0000000000000000@0ooK^00@0?EV[0?ofkP3om^h000002P3o
m^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h02P3o
m^h00`0mFJ/0ooK^0?ofkP050?ofkP80?EV[00<0ooK^03eIZ`3om^h05P3om^h0100mFJ/0ooK^0?of
kP3om^h203eIZa40ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eI
Z`3om^h0ooK^02H0ooK^00<000000?ofkP3om^h0<@3om^h10?ooo`00<P3om^h00`000000ooK^0?of
kP0V0?ofkP030=@m6@3om^h0ooK^00T0ooK^0P3D?AT:0?ofkP030=@m6@3om^h0ooK^0140ooK^0P3D
?AT00`3om^h0e3dI0?ofkP0F0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT01@3om^h00`3D?AT0ooK^
0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00<0ooK^0P3D?AT40?ofkP<0e3dI1P3om^h200000080ooK^
00X0e3dI0?ofkP3om^h0ooK^0000000mFJ/0000000H84@000000e3dI0P0621400`0000002`lP0000
000200/?8080e3dI0P0;3b000`00000051Xl01@J?00401@J?0030=@m6@00000051Xl008051Xl0P00
000301dXE`040000003Z@1T0jT0I0>Y06@8000000`3D>AH00`000000?EV[0=@i5P050=@i5P030000
002b;Q40/RhA0080?EV[0P2b;Q400`000000/RhA0000000208XR3@0303eIZ`000000RR8=00<00000
0`3om^h00`0mFJ/0ooK^0?ofkP02000000H0ooK^0`0mFJ/40?ofkP80?EV[1@3om^h00`0mFJ/0ooK^
0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0G0?ofkP04
03eIZ`3om^h0?EV[03eIZa<0ooK^00<0?EV[0?ofkP3om^h0203om^h203eIZ`/0ooK^00<0?EV[0?of
kP3om^h09P3om^h00`000000ooK^0?ofkP0`0?ofkP40oooo000a0?ofkP030000003om^h0ooK^02L0
ooK^00<0e3dI0?ofkP3om^h02`3om^h20=@m6@L0ooK^00<0e3dI0?ofkP3om^h0503om^h00`3D?AT0
ooK^0?ofkP0E0?ofkP030=@m6@3om^h0ooK^00<0ooK^0P3D?AT30?ofkP030=@m6@3om^h0ooK^00X0
ooK^00<0e3dI0?ofkP3om^h01P3om^h20=@m6@030?ofkP3D?AT0ooK^0080ooK^00<0e3dI0?ofkP3o
m^h00P3om^h01@000000ooK^0?ofkP3om^h0e3dI00<0ooK^0`00000200H84@040=@m6@0621400000
000000802`lP00<0000000/?800;3b000P0;3b000`3D?AT000000000000601@J?0050=@m6@000000
51Xl01@J?00000001@0M:5L00`000000jT0I0>Y06@030>Y06@050000003D>AH0e3TF0000000mFJ/0
1P3D>AH20000000303eIZ`2b;Q40/RhA0080/RhA00<000000;8^4@2b;Q400P000000100mFJ/00000
08XR3@2:8Pd3000000<0ooK^00D0?EV[0?ofkP3om^h0ooK^000000040?ofkP0603eIZ`3om^h0ooK^
0?ofkP0mFJ/0ooK^0P0mFJ/80?ofkP0303eIZ`3om^h0ooK^00X0ooK^00@0?EV[0?ofkP3om^h0ooK^
0P0mFJ/50?ofkP0303eIZ`3om^h0ooK^01D0ooK^00<0?EV[0?ofkP3om^h0503om^h00`0mFJ/0ooK^
0?ofkP050?ofkP80?EV[3@3om^h00`0mFJ/0ooK^0?ofkP0W0?ofkP030000003om^h0ooK^02l0ooK^
0@3oool002l0ooK^0P00000Z0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h0103o
m^h00`3D?AT0ooK^0?ofkP0C0?ofkP040=@m6@3om^h0e3dI0=@m6A@0ooK^00<0e3dI0?ofkP3om^h0
1P3om^h30=@m6@`0ooK^00<0e3dI0?ofkP3om^h02@3om^h20=@m6@@0ooK^0P3D?AT2000000<0ooK^
00<0e3dI0?ofkP3om^h01000000200H84@030000003D?AT0000000@02`lP00H0000000/?800;3b00
2`lP0000000D6S`20=@m6@H051Xl00@0e3dI00000000000000001P0M:5L00`000000jT0I0>Y06@04
0>Y06@<0000000<0?EV[0=@i5P3D>AH0103D>AH203eIZ`030=@i5P000000/RhA0080/RhA00<00000
0;8^4@2b;Q400P2b;Q400`000000?EV[0000000208XR3@@000000P3om^h0100mFJ/0ooK^0?ofkP3o
m^h200000080?EV[103om^h203eIZ`/0ooK^00<0?EV[0?ofkP3om^h02P3om^h303eIZ`P0ooK^00<0
?EV[0?ofkP3om^h04P3om^h303eIZaH0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?of
kP0=0?ofkP0303eIZ`3om^h0ooK^02P0ooK^0P00000_0?ofkP40oooo000^0?ofkP030000003om^h0
ooK^02T0ooK^00<0e3dI0?ofkP3om^h03`3om^h20=@m6@<0ooK^00<0e3dI0?ofkP3om^h0503om^h0
103D?AT0ooK^0?ofkP3om^h20=@m6A80ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?of
kP090?ofkP030=@m6@3om^h0ooK^00X0ooK^0`3D?AT40?ofkP030000003D?AT0e3dI0080ooK^00H0
e3dI0?ofkP3om^h0000000H84@00000400H84@030000003D?AT02`lP00@02`lP00@0000000/?8000
000000000`0D6S`00`000000e3dI01@J?00401@J?0030=@m6@0000007BQG00L07BQG00<000000>Y0
6@3Z@1T01P3Z@1T00`000000?EV[0=@i5P040=@i5P0303eIZ`000000e3TF0080e3TF0P0000000`2b
;Q4000000;8^4@040;8^4@0303eIZ`000000RR8=00<0RR8=00<0000005`D200000000P3om^h00`0m
FJ/0ooK^0?ofkP0203eIZ`030000003om^h0ooK^0080ooK^0`0mFJ/<0?ofkP0303eIZ`3om^h0ooK^
00T0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP80?EV[0`3om^h00`0m
FJ/0ooK^0?ofkP0D0?ofkP0403eIZ`3om^h0ooK^0?ofkP80?EV[4@3om^h00`0mFJ/0ooK^0?ofkP0Y
0?ofkP030000003om^h0ooK^02`0ooK^0@3oool002d0ooK^00<000000?ofkP3om^h0:P3om^h00`3D
?AT0ooK^0?ofkP0A0?ofkP80e3dI00<0ooK^0=@m6@3om^h0503om^h00`3D?AT0ooK^0?ofkP040?of
kP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h0203om^h0103D?AT0ooK^0=@m6@3D?AT8
0?ofkP030=@m6@3om^h0ooK^00/0ooK^00@0e3dI0?ofkP3om^h0e3dI0P3om^h010000000ooK^0?of
kP3om^h20=@m6@040?ofkP000000000000H84@8000000`062142000000030=@m6@0;3b002`lP0080
2`lP0`00000501@J?0040000000D6S`0e3dI0=@m6@<051Xl00<0e3dI0000000M:5L01`0M:5L00`00
0000jT0I0>Y06@060>Y06@030000000mFJ/0e3TF0080e3TF0P0mFJ/00`3D>AH000000=@i5P040=@i
5P<00000102b;Q400`0mFJ/000000000000308XR3@80000000@0G1@8000000000000ooK^0P0mFJ/3
0?ofkP040000003om^h0ooK^03eIZ`80ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?of
kP060?ofkP80?EV[00<0ooK^03eIZ`3om^h02@3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3o
m^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h0503om^h0100mFJ/0ooK^03eIZ`0mFJ/C0?ofkP0303eI
Z`3om^h0ooK^02X0ooK^00<000000?ofkP3om^h0:`3om^h10?ooo`00;03om^h00`000000ooK^0?of
kP0Z0?ofkP030=@m6@3om^h0ooK^01@0ooK^00<0e3dI0?ofkP3om^h0503om^h00`3D?AT0ooK^0?of
kP050?ofkP80e3dI3@3om^h00`3D?AT0ooK^0?ofkP090?ofkP040=@m6@3om^h0ooK^0?ofkP80e3dI
1@3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^0080ooK^0P0000040?ofkP<0e3dI
00@0000000H84@00000000000`062142000000030=@m6@0;3b002`lP00<02`lP00<0000001@J?00D
6S`01@0D6S`01@00000051Xl01@J?00D6S`0e3dI0080000000<0e3dI0000000M:5L01`0M:5L00`00
0000jT0I0>Y06@060>Y06@050000000mFJ/000000000000mFJ/00`3D>AH00`000000e3TF0=@i5P05
0=@i5P030000002b;Q40/RhA0080/RhA00@0?EV[0000002b;Q4000000`2:8Pd20000000305`D2000
0000?EV[0080?EV[103om^h2000000@0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?of
kP030?ofkP80?EV[0`3om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^00/0ooK^0P0m
FJ/70?ofkP0303eIZ`3om^h0ooK^01@0ooK^00<0?EV[0?ofkP3om^h0503om^h00`0mFJ/0ooK^0?of
kP0Z0?ofkP030000003om^h0ooK^02X0ooK^0@3oool002/0ooK^00<000000?ofkP3om^h0:`3om^h0
0`3D?AT0ooK^0?ofkP0D0?ofkP<0e3dI4`3om^h00`3D?AT0ooK^0?ofkP080?ofkP80e3dI2P3om^h0
0`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^00<0ooK^0P3D?AT40?ofkP030=@m6@3om^h0
ooK^00/0ooK^00D0e3dI0?ofkP3om^h0ooK^000000020?ofkP80e3dI00X0ooK^0=@m6@0000000000
00H84@3D?AT0000000H84@0000001PPA0P0000000`0;3b0000000=@m6@0400/?808000001`0D6S`0
1@00000051Xl01@J?00D6S`0000000<0e3dI00<0000001dXE`0M:5L01P0M:5L00`000000jT0I0>Y0
6@060>Y06@050000000mFJ/0?EV[03eIZ`0000000`3D>AH00`000000e3TF0=@i5P050=@i5P800000
102b;Q400`0mFJ/000000;8^4@020000000608XR3@000000RR8=0000000mFJ/0G1@80P000000100m
FJ/0ooK^03eIZ`0mFJ/20?ofkP050000003om^h0ooK^0?ofkP0mFJ/03@3om^h00`0mFJ/0ooK^0?of
kP020?ofkP80?EV[1@3om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^00P0ooK^0P0m
FJ/90?ofkP0303eIZ`3om^h0ooK^0180ooK^0`0mFJ/F0?ofkP0303eIZ`3om^h0ooK^02/0ooK^00<0
00000?ofkP3om^h0:@3om^h10?ooo`00:@3om^h2000002d0ooK^00<0e3dI0?ofkP3om^h0503om^h0
103D?AT0ooK^0?ofkP3om^h20=@m6A40ooK^00<0e3dI0?ofkP3om^h02P3om^h20=@m6@P0ooK^00<0
e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP050?ofkP80e3dI00<0ooK^0=@m6@3om^h0303o
m^h00`3D?AT0ooK^0?ofkP02000000D0ooK^00H0e3dI0000000621401PPA0000000621420=@m6@80
00000`0;3b0010000000e3dI00/?800;3b020000000301@J?000000051Xl00H051Xl00@0000001@J
?00D6S`000000`0M:5L00`3D?AT0000001dXE`0701dXE`030000003Z@1T0jT0I00H0jT0I00<00000
03eIZ`3Z@1T00P3Z@1T010000000e3TF0=@i5P0000070=@i5P040000003D>AH0000000000080/RhA
00<0?EV[0000002b;Q400P2b;Q4200000080?EV[00H0RR8=0000001L50P0G1@80000000mFJ/50?of
kP80000000<0ooK^03eIZ`3om^h03@3om^h0100mFJ/0ooK^03eIZ`0mFJ/70?ofkP0303eIZ`3om^h0
ooK^00T0ooK^00<0?EV[0?ofkP3om^h01P3om^h203eIZ``0ooK^00<0?EV[0?ofkP3om^h03`3om^h2
03eIZ`<0ooK^00<0?EV[0?ofkP3om^h0503om^h00`0mFJ/0ooK^0?ofkP0[0?ofkP800000:@3om^h1
0?ooo`00:03om^h00`000000ooK^0?ofkP0]0?ofkP030=@m6@3om^h0ooK^01@0ooK^00<0e3dI0?of
kP3om^h00`3om^h20=@m6@h0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP040?of
kP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h0203om^h20=@m6@d0ooK^00<0e3dI0?of
kP0000001P3om^h01@3D?AT0000000H84@062140000000<01PPA00<000000=@m6@3D?AT00`0;3b00
10000000e3dI00/?8000000301@J?0030000000D6S`051Xl00D051Xl0`00000401dXE`<0e3dI1`0M
:5L00`000000jT0I0>Y06@050>Y06@<0?EV[103Z@1T3000000L0e3TF00P000000=@i5P3D>AH0e3TF
0000002b;Q40?EV[000000<0/RhA0P0mFJ/01@000000RR8=08XR3@2:8Pd000000080G1@800<00000
03eIZ`3om^h01@3om^h00`000000ooK^03eIZ`0=0?ofkP80?EV[2P3om^h00`0mFJ/0ooK^0?ofkP09
0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0=
0?ofkP80?EV[1@3om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP0303eIZ`3om^h0ooK^02d0ooK^00<00000
0?ofkP3om^h09P3om^h10?ooo`009`3om^h00`000000ooK^0?ofkP0^0?ofkP<0e3dI4`3om^h00`3D
?AT0ooK^0?ofkP060?ofkP80e3dI303om^h00`3D?AT0ooK^0?ofkP0>0?ofkP80e3dI0`3om^h00`3D
?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00L0ooK^00@0e3dI0?ofkP3D?AT0e3dI303om^h2
000000H0ooK^00<0e3dI0000000621400P00000400H84@090000000;3b002`lP0=@m6@0;3b000000
0=@m6@0;3b00000000@051Xl00<0000001@J?00D6S`01@0D6S`00`0000007BQG01dXE`0301dXE`04
0=@m6@0M:5L0000001dXE`80e3dI0`0M:5L5000000@0jT0I00D0?EV[0>Y06@000000jT0I03eIZ`04
0>Y06@030=@m6@000000e3TF00H0e3TF00<000000=@i5P3D>AH00P3D>AH00`000000?EV[00000002
0;8^4@0403eIZ`2b;Q40/RhA000000@0RR8=0P0000000`1L50P0000003eIZ`060?ofkP800000303o
m^h203eIZ`030?ofkP0mFJ/0ooK^00P0ooK^00<0?EV[0?ofkP3om^h02P3om^h0100mFJ/0ooK^0?of
kP3om^h203eIZa00ooK^00<0?EV[0?ofkP3om^h02P3om^h203eIZ`P0ooK^00<0?EV[0?ofkP3om^h0
4@3om^h303eIZc00ooK^00<000000?ofkP3om^h09@3om^h10?ooo`009P3om^h00`000000ooK^0?of
kP0^0?ofkP040=@m6@3om^h0ooK^0?ofkP80e3dI4@3om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m
6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h04@3om^h20=@m6@030?ofkP3D?AT0ooK^00X0ooK^
00<0e3dI0?ofkP3om^h0203om^h0103D?AT0ooK^0?ofkP3om^h20=@m6@T0ooK^00<000000?ofkP3o
m^h01@3om^h40000000400H84@0000001PPA00H84@<000000`0;3b030=@m6@030000000D6S`051Xl
00<051Xl00<0000001@J?00D6S`00`0D6S`3000000D07BQG00<0e3dI01dXE`0000000`0M:5L00`3D
?AT07BQG0000000202DdK`050000003hAA`0n4DL0000003Z@1T00P0mFJ/20>Y06@030000003Z@1T0
?EV[00D0jT0I0`0000050=@i5P030000003D>AH0e3TF00<0e3TF00@0000003eIZ`0mFJ/0?EV[0`2b
;Q4300000080RR8=00<0000008XR3@0000000`0000070?ofkP030000003om^h0ooK^00L0ooK^0P0m
FJ/30?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h02@3om^h0100mFJ/0ooK^03eI
Z`0mFJ/B0?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^
0?ofkP0?0?ofkP80?EV[0`3om^h00`0mFJ/0ooK^0?ofkP0^0?ofkP030000003om^h0ooK^02@0ooK^
0@3oool002H0ooK^0`00000^0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h03@3o
m^h00`3D?AT0ooK^0?ofkP0:0?ofkP80e3dI203om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3o
m^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP030?ofkP<0e3dI1P3o
m^h00`000000e3dI0?ofkP050?ofkP<000000P0621401P0000001PPA00H84@0000002`lP000000D0
2`lP00<000000=@m6@0D6S`01@0D6S`00`00000051Xl01@J?00201@J?0040000000M:5L07BQG0000
00D07BQG00<0e3dI01dXE`0000000`0M:5L00`000000e3dI0=@m6@0202DdK`060000003hAA`0n4DL
0?Q5700mFJ/000000`3Z@1T00`000000jT0I03eIZ`050>Y06@040000003Z@1T0jT0I000000@0e3TF
00<000000=@i5P3D>AH0103D>AH00`0mFJ/000000;8^4@040;8^4@030000002b;Q4000000080RR8=
00<0000008XR3@2:8Pd00`0000060?ofkP0303eIZ`000000ooK^00D0ooK^0`0mFJ/50?ofkP0303eI
Z`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eI
Z`3om^h0ooK^00H0ooK^0P0mFJ/<0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h0
0`3om^h00`0mFJ/0ooK^0?ofkP0/0?ofkP<000009P3om^h10?ooo`009P3om^h00`000000ooK^0?of
kP02000002`0ooK^00<0e3dI0?ofkP3om^h0103om^h20=@m6@d0ooK^00<0e3dI0?ofkP3om^h0303o
m^h20=@m6@D0ooK^00<0e3dI0?ofkP3om^h04`3om^h0103D?AT0ooK^0=@m6@3D?AT90?ofkP030=@m
6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h01P3om^h20=@m6@<0ooK^0P0000000`3D?AT0ooK^
0?ofkP040?ofkP0300H84@0000001PPA00801PPA00@0000000H84@00000000000P0;3b0010000000
2`lP00/?800;3b03000000<0e3dI100D6S`00`00000051Xl01@J?002000000<07BQG00<0000001dX
E`0M:5L00`0M:5L00`3D?AT07BQG0000000201dXE`040000000U=6l09CA_02DdK`80e3dI00@00000
0?Q5700mFJ/0?EV[0P3hAA`01P000000jT0I0>Y06@000000jT0I03eIZ`D0jT0I00@000000>Y06@3Z
@1T0jT0I0P0000020=@i5P030000003D>AH0e3TF0080e3TF0`0mFJ/3000000<0/RhA00<000000;8^
4@2b;Q400P0000000`2:8Pd0000008XR3@0208XR3@8000001P3om^h00`0mFJ/00000000000030?of
kP80?EV[203om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00L0ooK^0P0mFJ/00`3o
m^h0?EV[0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^00@0ooK^0P0mFJ/>0?ofkP0303eIZ`3om^h0ooK^
00/0ooK^0P0mFJ/60?ofkP0303eIZ`3om^h0ooK^02X0ooK^0P0000020?ofkP030000003om^h0ooK^
02@0ooK^0@3oool002D0ooK^00<000000?ofkP3om^h00`3om^h2000002T0ooK^00<0e3dI0?ofkP3o
m^h01`3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00h0ooK^0P3D?AT30?ofkP03
0=@m6@3om^h0ooK^01<0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@080?ofkP030=@m6@3om^h0ooK^
00L0ooK^00<0e3dI0?ofkP3om^h01`3om^h30=@m6@040000003om^h0ooK^0=@m6@@0ooK^0`000004
00H84@800000100;3b00100000002`lP00/?8000000201@J?0040=@m6@0D6S`051Xl01@J?080e3dI
0P0D6S`3000000D07BQG00<0000001dXE`0M:5L00P0M:5L00`3D?AT07BQG01dXE`03000000H09CA_
00<0e3dI03eIZ`3hAA`0103hAA`300000080jT0I00<0?EV[0>Y06@3Z@1T00P3Z@1T00`000000jT0I
0>Y06@030>Y06@<000000P3D>AH203eIZ`<0e3TF00@0?EV[0=@i5P3D>AH000000P2b;Q400`000000
/RhA0;8^4@020;8^4@800000102:8Pd3000000@0ooK^00@0?EV[0?ofkP3om^h000000`0mFJ/90?of
kP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h01P3om^h01@0mFJ/0ooK^0?ofkP3om^h0
?EV[01D0ooK^00@0?EV[0?ofkP3om^h0ooK^0P0mFJ/@0?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0
?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP0W0?ofkP8000001@3om^h00`000000ooK^0?of
kP0S0?ofkP40oooo000U0?ofkP030000003om^h0ooK^00D0ooK^0P00000W0?ofkP030=@m6@3om^h0
ooK^00P0ooK^0P3D?AT90?ofkP030=@m6@3om^h0ooK^0140ooK^0`3D?ATE0?ofkP030=@m6@3om^h0
ooK^00<0ooK^0P3D?AT50?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h02@3om^h2
000000<0e3dI103om^h20000000300H84@0000001PPA00801PPA00<0000000/?800;3b00100;3b00
0`0000002`lP0000000301@J?0030=@m6@0D6S`051Xl00<051Xl00<0e3dI01@J?00000001`0M:5L0
0`0000007BQG01dXE`0201dXE`040=@m6@0M:5L07BQG000000P09CA_00<000000?Q5703hAA`01P3h
AA`010000000jT0I0>Y06@0mFJ/40>Y06@030000003Z@1T0jT0I00D0jT0I00<000000=@i5P0mFJ/0
1@3D>AH01`0mFJ/0e3TF0=@i5P3D>AH000000;8^4@0000001P2b;Q401P000000RR8=08XR3@2:8Pd0
000008XR3@800000103om^h303eIZ`8000002`3om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3o
m^h0ooK^00<0ooK^0P0mFJ/50?ofkP0303eIZ`3om^h0ooK^0180ooK^00@0?EV[0?ofkP0mFJ/0?EV[
4`3om^h00`0mFJ/0ooK^0?ofkP070?ofkP80?EV[2P3om^h00`0mFJ/0ooK^0?ofkP0U0?ofkP800000
1`3om^h00`000000ooK^0?ofkP0S0?ofkP40oooo000U0?ofkP030000003om^h0ooK^00L0ooK^0P00
000U0?ofkP030=@m6@3om^h0ooK^00X0ooK^0P3D?AT70?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0
e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP050?ofkP80e3dI0`3om^h00`3D?AT0ooK^0?of
kP060?ofkP030=@m6@3om^h0ooK^00T0ooK^00@000000?ofkP3om^h0ooK^0P3D?AT20?ofkP<00000
00@01PPA0000000621401PPA0`00000500/?80<000000`0D6S`00`3D?AT0000001@J?00501@J?080
e3dI1`0M:5L00`0000007BQG01dXE`0201dXE`040=@m6@0M:5L00000000000P09CA_00<000000?Q5
703hAA`01P3hAA`2000000030>Y06@0mFJ/0jT0I00<0jT0I00<000000>Y06@3Z@1T01@3Z@1T203eI
Z`H0e3TF00<0000003eIZ`3D>AH00P3D>AH3000000D0/RhA0`00000208XR3@030000002:8Pd00000
008000000P3om^h203eIZ`<0ooK^00<000000?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP060?of
kP0403eIZ`3om^h0ooK^0?ofkP80?EV[1`3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0
ooK^01<0ooK^00<0?EV[0?ofkP3om^h01@3om^h203eIZ``0ooK^00<0?EV[0?ofkP3om^h08`3om^h2
000000T0ooK^00<000000?ofkP3om^h08`3om^h10?ooo`009@3om^h00`000000ooK^0?ofkP090?of
kP030000003om^h0ooK^0240ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP030?of
kP030=@m6@3om^h0ooK^01<0ooK^00@0e3dI0?ofkP3D?AT0e3dI4P3om^h00`3D?AT0ooK^0?ofkP08
0?ofkP030=@m6@3om^h0e3dI00P0ooK^00<0e3dI0?ofkP3om^h0203om^h2000000@0ooK^103D?AT2
000000801PPA00D0000000H84@0000002`lP0000000600/?80030000000D6S`051Xl00<051Xl00<0
e3dI0000000D6S`00`0D6S`20000000303eIZ`000000e3dI00H07BQG00<0000001dXE`0M:5L00P0M
:5L0103D?AT0000002DdK`00000802DdK`030000003hAA`0n4DL00H0n4DL00@000000?Q570000000
?EV[103Z@1T00`000000jT0I0>Y06@040>Y06@0303eIZ`000000jT0I00800000103D>AH00`000000
?EV[0=@i5P040=@i5P030000002b;Q40/RhA00@0/RhA00D000000;8^4@000000RR8=0000000208XR
3@800000100mFJ/40?ofkP8000002P3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0?EV[
00X0ooK^00<0?EV[0?ofkP3om^h0403om^h303eIZaH0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0m
FJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^0240ooK^00<000000?ofkP3om^h02@3om^h00`00
0000ooK^0?ofkP0S0?ofkP40oooo000T0?ofkP030000003om^h0ooK^00/0ooK^0P00000Q0?ofkP03
0=@m6@3om^h0ooK^00h0ooK^0P3D?AT30?ofkP030=@m6@3om^h0ooK^01<0ooK^00D0e3dI0?ofkP3o
m^h0ooK^0=@m6@0A0?ofkP030=@m6@3om^h0ooK^00T0ooK^0P3D?AT80?ofkP030=@m6@3om^h0ooK^
00L0ooK^00<000000?ofkP3om^h0103om^h01@3D?AT00000000000000000e3dI00801PPA00<00000
00H84@0000000P0;3b000`0000002`lP00/?800200/?80<00000100D6S`00`3D?AT051Xl00000003
01@J?0060000000M:5L07BQG01dXE`0000007BQG0P3D?AT401dXE`050000000M:5L07BQG01dXE`3D
?AT00`0U=6l00`0000009CA_02DdK`0602DdK`030000003hAA`0n4DL00H0n4DL00D000000?Q5703h
AA`0n4DL03eIZ`030>Y06@030000003Z@1T0jT0I0080jT0I0P0mFJ/00`3Z@1T000000>Y06@020>Y0
6@070000003D>AH0e3TF0=@i5P000000e3TF03eIZ`040=@i5P<00000102b;Q401P000000/RhA0;8^
4@000000RR8=00000080RR8=00D0?EV[000000000000000003eIZ`060?ofkP030000003om^h0ooK^
00L0ooK^00<0?EV[0?ofkP3om^h01P3om^h203eIZ`/0ooK^00<0?EV[0?ofkP3om^h03`3om^h01@0m
FJ/0ooK^0?ofkP3om^h0?EV[01D0ooK^00@0?EV[0?ofkP3om^h0ooK^0P0mFJ/@0?ofkP0303eIZ`3o
m^h0ooK^01l0ooK^0P00000=0?ofkP030000003om^h0ooK^0280ooK^0@3oool002@0ooK^00<00000
0?ofkP3om^h03@3om^h2000001l0ooK^00<0e3dI0?ofkP3om^h0403om^h30=@m6AD0ooK^00<0e3dI
0?ofkP3om^h00`3om^h20=@m6@h0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0=@m6@06
0?ofkP030=@m6@3om^h0ooK^00L0ooK^00<000000?ofkP3om^h0103om^h0103D?AT0000000000000
000200H84@80e3dI0P00000300/?80050000000;3b002`lP00/?800000000P0D6S`00`00000051Xl
01@J?00201@J?0030=@m6@0D6S`00000008051Xl00<0000001dXE`0M:5L00P0M:5L0100000007BQG
01dXE`0M:5L20=@m6@807BQG00D0000001dXE`0M:5L000000=@m6@0302DdK`030000000U=6l09CA_
00H09CA_00<000000?Q5703hAA`01P3hAA`01P000000n4DL0?Q5703hAA`0?EV[00000080jT0I00<0
00000>Y06@3Z@1T00P0mFJ/30>Y06@030000003Z@1T0jT0I0080jT0I00H000000=@i5P3D>AH00000
0=@i5P0mFJ/40=@i5P040000003D>AH0e3TF000000<0/RhA00@000000;8^4@2b;Q40/RhA0P000002
03eIZ`80RR8=0`0000000`0mFJ/0ooK^0?ofkP040?ofkP030000003om^h0ooK^00L0ooK^00<0?EV[
0?ofkP3om^h0103om^h00`0mFJ/0ooK^03eIZ`0<0?ofkP0303eIZ`3om^h0ooK^00`0ooK^0P0mFJ/4
0?ofkP0303eIZ`3om^h0ooK^01@0ooK^0`0mFJ/B0?ofkP0303eIZ`3om^h0ooK^01d0ooK^0P00000?
0?ofkP030000003om^h0ooK^0280ooK^0@3oool002@0ooK^00<000000?ofkP3om^h03`3om^h20000
01`0ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^
00D0ooK^0P3D?AT;0?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h00P3D?AT30?of
kP030=@m6@3om^h0ooK^00H0ooK^0P0000060?ofkP050000003D?AT0000000H84@0000000`062140
0`000000e3dI0=@m6@0300/?80040000000;3b000000000000<051Xl00D0000001@J?00D6S`051Xl
0=@m6@0201@J?0<000001@0M:5L00`0000007BQG01dXE`0301dXE`030=@m6@0M:5L0000000800000
00<09CA_0=@m6@0U=6l00P0U=6l00`0000009CA_02DdK`0602DdK`030000003hAA`0n4DL00H0n4DL
00H000000?Q5703hAA`0n4DL03eIZ`3hAA`3000000030>Y06@0mFJ/0jT0I00@0jT0I00<000000>Y0
6@3Z@1T00`3Z@1T3000000030=@i5P0mFJ/0e3TF00<0e3TF00@000000=@i5P3D>AH0e3TF0P000000
0`2b;Q4000000;8^4@020;8^4@80?EV[00T0000008XR3@2:8Pd0RR8=0000002:8Pd0000003eIZ`00
00001P3om^h2000000P0ooK^00@0?EV[0?ofkP3om^h0ooK^0P0mFJ/20?ofkP0303eIZ`3om^h0ooK^
00/0ooK^00<0?EV[0?ofkP3om^h02@3om^h203eIZ`L0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0m
FJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^01X0ooK^0P00000A0?ofkP030000003om^h0ooK^
0280ooK^0@3oool002@0ooK^00<000000?ofkP3om^h04@3om^h2000001X0ooK^00<0e3dI0?ofkP3o
m^h04`3om^h30=@m6A80ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP080?ofkP03
0=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h00`3om^h20=@m6@030?ofkP3D?AT0ooK^00H0
ooK^00<000000?ofkP3om^h01@3om^h01@000000e3dI000000062140000000801PPA0`00000200/?
80030=@m6@0;3b000000008000001@0D6S`01@00000051Xl01@J?00D6S`0e3dI008051Xl00<00000
01dXE`0M:5L01@0M:5L00`0000007BQG01dXE`0401dXE`80e3dI0`0U=6l01@3D?AT09CA_02DdK`0U
=6l0000000P09CA_00<000000?Q5703hAA`01P3hAA`01@000000n4DL0?Q5703hAA`0?EV[00<0n4DL
0P0mFJ/60>Y06@030000003Z@1T0jT0I00D0jT0I00@000000=@i5P3D>AH0?EV[0`3D>AH00`000000
e3TF0=@i5P030=@i5P<0000000@0/RhA03eIZ`2b;Q40/RhA0`00000208XR3@050000002:8Pd00000
03eIZ`0000001`3om^h00`000000ooK^0?ofkP050?ofkP0403eIZ`3om^h0?EV[03eIZ`D0ooK^00<0
?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0
?EV[0?ofkP3om^h04@3om^h303eIZaD0ooK^00<0?EV[0?ofkP3om^h0603om^h2000001<0ooK^00<0
00000?ofkP3om^h08P3om^h10?ooo`00903om^h00`000000ooK^0?ofkP0C0?ofkP800000603om^h0
0`3D?AT0ooK^0?ofkP0B0?ofkP040=@m6@3om^h0ooK^0?ofkP80e3dI403om^h00`3D?AT0ooK^0?of
kP090?ofkP80e3dI1`3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP040=@m6@3om^h0e3dI0=@m6@D0ooK^
00<0e3dI0?ofkP3om^h0103om^h2000000H0ooK^0`000000203D?AT01PPA00H84@0000001PPA0000
000;3b000000100;3b020=@m6@H051Xl00<0000001@J?00D6S`00P0D6S`0103D?AT0000000000000
000701dXE`030000000M:5L07BQG00<07BQG0`0000030=@m6@D09CA_00<0000002DdK`0U=6l01@0U
=6l00`000000n4DL0?Q570050?Q570030000003hAA`0n4DL00<0n4DL0`0mFJ/3000000D0jT0I00<0
00000>Y06@3Z@1T01@3Z@1T30000000303eIZ`3D>AH0e3TF0080e3TF00<000000=@i5P3D>AH0103D
>AH203eIZ`@0/RhA00D000000;8^4@000000RR8=0000000208XR3@0403eIZ`0000000000000000H0
ooK^0P0000060?ofkP0303eIZ`3om^h0ooK^00<0ooK^0P0mFJ/00`3om^h0?EV[0?ofkP0;0?ofkP03
03eIZ`3om^h0ooK^00D0ooK^0P0mFJ/;0?ofkP0303eIZ`3om^h0ooK^00h0ooK^0P0mFJ/30?ofkP03
03eIZ`3om^h0ooK^0180ooK^00<0?EV[0?ofkP3om^h05P3om^h2000001D0ooK^00<000000?ofkP3o
m^h08P3om^h10?ooo`008`3om^h00`000000ooK^0?ofkP0F0?ofkP030000003om^h0ooK^01@0ooK^
00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00`0ooK^
00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00X0ooK^
00@0e3dI0?ofkP3om^h0ooK^0P3D?AT20?ofkP040=@m6@3om^h0e3dI0=@m6@<0ooK^00<000000?of
kP3om^h01@3om^h3000000060=@m6@0621401PPA00000006214000000P0;3b000`0000002`lP00/?
800200/?8080000000<0e3dI01@J?00D6S`00`0D6S`01P00000051Xl01@J?00D6S`0e3dI00000080
7BQG00<0000001dXE`0M:5L01@0M:5L00`0000007BQG01dXE`0201dXE`040000000U=6l09CA_0000
00809CA_00<0e3dI02DdK`0U=6l00`0U=6l00`0000009CA_02DdK`0402DdK`<000001P3hAA`00`00
0000n4DL0?Q570030?Q5700403eIZ`3hAA`0n4DL00000080n4DL00<000000>Y06@3Z@1T00P3Z@1T0
0`000000jT0I0>Y06@050>Y06@050000003Z@1T0jT0I0000000mFJ/00`3D>AH00`000000e3TF0=@i
5P030=@i5P0303eIZ`000000000000@0/RhA00H000000;8^4@2b;Q40000008XR3@00000208XR3@04
03eIZ`0000000000000000L0ooK^00@000000?ofkP3om^h0ooK^0P0mFJ/0103om^h0?EV[0?ofkP3o
m^h203eIZ`<0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3o
m^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3o
m^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h0503om^h00`000000ooK^0?ofkP0F0?ofkP030000003o
m^h0ooK^0240ooK^0@3oool002<0ooK^00<000000?ofkP3om^h05`3om^h2000001@0ooK^00<0e3dI
0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP040?ofkP80e3dI303om^h00`3D?AT0ooK^0?ofkP0=
0?ofkP80e3dI0`3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI
0?ofkP3D?AT00`3om^h00`3D?AT00000000000060?ofkP<0000000<01PPA0000003D?AT00P062142
000000802`lP00@0000000/?800;3b002`lP0P0000000`0D6S`0000001@J?0020=@m6@<051Xl00D0
000001@J?00D6S`000000=@m6@0301dXE`030000000M:5L07BQG00D07BQG00<0000001dXE`0M:5L0
0P00000302DdK`030000000U=6l09CA_00<0e3dI0`0U=6l00`0000009CA_02DdK`0202DdK`800000
00<0;3j20000003oB1d00P0000040?Q570040000003hAA`0n4DL0?Q570<0?EV[0P3hAA`010000000
n4DL0?Q5703hAA`200000080jT0I00<000000>Y06@3Z@1T01@3Z@1T01P000000jT0I0>Y06@3Z@1T0
?EV[00000080e3TF00@000000=@i5P3D>AH0e3TF0P0mFJ/00`3D>AH000000=@i5P0200000080/RhA
00@000000;8^4@2b;Q40/RhA0P00000208XR3@0303eIZ`000000RR8=00<000001P3om^h200000007
03eIZ`3om^h0ooK^0?ofkP0mFJ/0ooK^03eIZ`060?ofkP0303eIZ`3om^h0ooK^00X0ooK^00@0?EV[
0?ofkP3om^h0ooK^0P0mFJ/?0?ofkP0303eIZ`3om^h0ooK^00X0ooK^0P0mFJ/60?ofkP0303eIZ`3o
m^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h04P3om^h2000001T0ooK^00<000000?ofkP3om^h08@3o
m^h10?ooo`008`3om^h00`000000ooK^0?ofkP0I0?ofkP8000004P3om^h30=@m6A80ooK^00<0e3dI
0?ofkP3om^h01`3om^h20=@m6@T0ooK^00<0e3dI0?ofkP3om^h0403om^h20=@m6@030?ofkP3D?AT0
ooK^00X0ooK^00<0e3dI0?ofkP3om^h01P3om^h20=@m6@<0ooK^00@000000?ofkP3D?AT0e3dI103o
m^h30000000300H84@000000e3dI00801PPA00<0000000/?800;3b000P0;3b00100000002`lP00/?
8000000301@J?0040000000D6S`051Xl01@J?080e3dI00D051Xl00000000000000000=@m6@0401dX
E`030000000M:5L07BQG00D07BQG0`00000502DdK`030000000U=6l0e3dI00<09CA_00@0e3dI02Dd
K`0U=6l000000`0U=6l01@000000;3j202`nPP0/?X80000000<0odPM00H000000?Q5703hAA`0n4DL
0000003hAA`203eIZ`<0n4DL00<0?EV[0?Q5700000001@3hAA`3000000L0jT0I00<000000>Y06@3Z
@1T00P3Z@1T01@0mFJ/00000000000000000e3TF0080?EV[0`3D>AH01@000000e3TF0=@i5P3D>AH0
00000080/RhA00<000000;8^4@2b;Q400P2b;Q401P000000RR8=08XR3@0mFJ/0000008XR3@<00000
103om^h203eIZ`030?ofkP000000ooK^0080ooK^0P0mFJ/80?ofkP0303eIZ`3om^h0ooK^00T0ooK^
00@0?EV[0?ofkP0mFJ/0?EV[4@3om^h00`0mFJ/0ooK^0?ofkP080?ofkP80?EV[2@3om^h00`0mFJ/0
ooK^0?ofkP0@0?ofkP<0?EV[4P3om^h2000001/0ooK^00<000000?ofkP3om^h08@3om^h10?ooo`00
8`3om^h00`000000ooK^0?ofkP0K0?ofkP800000403om^h00`3D?AT0ooK^0?ofkP020=@m6A00ooK^
00<0e3dI0?ofkP3om^h02@3om^h20=@m6@L0ooK^00<0e3dI0?ofkP3om^h04P3om^h00`3D?AT0ooK^
0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00H0ooK^00D0e3dI0?ofkP3D?AT0e3dI000000040?ofkP80
e3dI00P0ooK^000000000000000000H84@0000001PPA0=@m6@<00000100;3b000`0000002`lP0000
000401@J?0030000000D6S`051Xl00<051Xl00D0e3dI0000000M:5L07BQG0=@m6@0401dXE`030000
000M:5L07BQG00D07BQG00<0000002DdK`0U=6l01@0U=6l00`0000009CA_0=@m6@0402DdK`80e3dI
00@0000002DdK`0U=6l00000100/?X800`000000odPM0?m87@020?m87@050000003hAA`0n4DL0000
000mFJ/01@3hAA`00`0mFJ/0n4DL000000070?Q570030000003Z@1T0jT0I00D0jT0I00<000000>Y0
6@3Z@1T00P3Z@1T01@0mFJ/0jT0I0>Y06@000000?EV[00D0e3TF00<000000=@i5P3D>AH00P3D>AH0
0`000000/RhA000000040;8^4@<0000000@0?EV[08XR3@000000RR8=0`0000000`3om^h0?EV[03eI
Z`040?ofkP050000000mFJ/0?EV[0?ofkP0mFJ/0203om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eI
Z`3om^h0ooK^0180ooK^00<0?EV[0?ofkP3om^h01@3om^h203eIZ`/0ooK^00<0?EV[0?ofkP3om^h0
3P3om^h203eIZ`80ooK^00<0?EV[0?ofkP3om^h03P3om^h2000001d0ooK^00<000000?ofkP3om^h0
8@3om^h10?ooo`008P3om^h00`000000ooK^0?ofkP0N0?ofkP8000003@3om^h00`3D?AT0ooK^0?of
kP030?ofkP80e3dI3@3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0
e3dI0?ofkP3om^h04`3om^h30=@m6@T0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?of
kP02000000030=@m6@3om^h0ooK^00<0ooK^0`00000200H84@06000000062140e3dI0000000;3b00
0000100;3b03000000@051Xl00<0000001@J?00D6S`0100D6S`0100mFJ/0e3dI0=@m6@3D?AT501dX
E`030000000M:5L07BQG00@07BQG0P00000702DdK`030000003D?AT09CA_00H09CA_00<0e3dI0000
000000001@0/?X800`000000odPM0?m87@030?m87@030000000mFJ/0?EV[00L0n4DL00<0?EV[0?Q5
703hAA`01P3hAA`2000000H0jT0I00<000000>Y06@3Z@1T00`3Z@1T303eIZ`030000003D>AH0e3TF
00<0e3TF00<000000=@i5P3D>AH00`3D>AH3000000@0/RhA00H000000;8^4@000000?EV[08XR3@00
000208XR3@<000001@3om^h00`0mFJ/00000000000020?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0
?EV[0?ofkP3om^h01`3om^h303eIZa@0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?of
kP0;0?ofkP0303eIZ`3om^h0ooK^00`0ooK^0P0mFJ/50?ofkP0303eIZ`3om^h0ooK^00/0ooK^0P00
000O0?ofkP030000003om^h0ooK^0240ooK^0@3oool00280ooK^00<000000?ofkP3om^h0803om^h2
000000/0ooK^00<0e3dI0?ofkP3om^h01@3om^h20=@m6@/0ooK^00<0e3dI0?ofkP3om^h03@3om^h2
0=@m6@<0ooK^00<0e3dI0?ofkP3om^h04P3om^h0103D?AT0ooK^0?ofkP3om^h20=@m6@H0ooK^00<0
e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^000000030?ofkP80e3dI0P3om^h3000000<01PPA0P00
0000103D?AT02`lP00/?8000000400/?80030000000D6S`051Xl00@051Xl00<0000001@J?00D6S`0
0P0D6S`20000000401dXE`0000007BQG0=@m6@D07BQG00<0000001dXE`0M:5L00P0M:5L200000003
02DdK`0000009CA_00L09CA_00<0e3dI02DdK`0U=6l01@0U=6l00`000000e3dI0=@m6@0502`nPP03
0000003oB1d0odPM00<0odPM00<0?EV[0?m87@0000001`3hAA`00`0mFJ/0n4DL0?Q570060?Q57004
0000003hAA`00000000000@0jT0I00<000000>Y06@3Z@1T00`3Z@1T0100mFJ/0jT0I0000003Z@1T2
000000@0e3TF00<000000=@i5P3D>AH0103D>AH00`000000/RhA0;8^4@020;8^4@040000002b;Q40
/RhA03eIZ`8000000`2:8Pd300000080ooK^0P0mFJ/30?ofkP030000003om^h0?EV[00T0ooK^00<0
?EV[0?ofkP3om^h0103om^h203eIZ`<0ooK^00<0?EV[0?ofkP3om^h04P3om^h0100mFJ/0ooK^0?of
kP3om^h203eIZ`l0ooK^00<0?EV[0?ofkP3om^h02@3om^h203eIZ`L0ooK^00<0?EV[0?ofkP3om^h0
2@3om^h200000280ooK^00<000000?ofkP3om^h0803om^h10?ooo`008P3om^h00`000000ooK^0?of
kP0R0?ofkP030000003om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?of
kP080?ofkP030=@m6@3om^h0ooK^00l0ooK^0`3D?ATE0?ofkP030=@m6@3om^h0ooK^00<0ooK^0P3D
?AT30?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0000000000001P3om^h20=@m6@0300000006
2140000000801PPA00<0000000/?803D?AT00P0;3b00100000002`lP00/?800;3b03000000H051Xl
00D0000001@J?00D6S`051Xl0000000301dXE`030000003D?AT07BQG0080e3dI0`0M:5L01@000000
7BQG01dXE`0M:5L0000000<09CA_00<0000002DdK`0U=6l01P0U=6l00`3D?AT09CA_02DdK`0302Dd
K`<000000P0/?X820=@m6@<0;3j200@000000?m87@3oB1d0odPM0P0mFJ/20?m87@<000001@3hAA`0
0`0mFJ/0n4DL0?Q570060?Q570050000003hAA`0n4DL0?Q5700000000`3Z@1T010000000jT0I0>Y0
6@3Z@1T203eIZ`030>Y06@0mFJ/0000000<0jT0I00D000000=@i5P3D>AH0e3TF000000060=@i5P<0
00000P2b;Q401`000000/RhA0;8^4@2b;Q40?EV[0;8^4@0000000P2:8Pd00`000000RR8=00000002
03eIZ`H0ooK^0P0000000`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^0080ooK^0P0mFJ/5
0?ofkP0303eIZ`3om^h0ooK^0180ooK^00@0?EV[0?ofkP0mFJ/0?EV[4@3om^h00`0mFJ/0ooK^0?of
kP080?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h0203om^h00`000000ooK^0?of
kP0R0?ofkP030000003om^h0ooK^0200ooK^0@3oool00280ooK^00<000000?ofkP3om^h08`3om^h2
000000P0ooK^00<0e3dI0?ofkP3om^h0203om^h20=@m6@L0ooK^00<0e3dI0?ofkP3om^h04P3om^h0
0`3D?AT0ooK^0?ofkP0B0?ofkP030=@m6@3om^h0ooK^00H0ooK^0P3D?AT00`3om^h0e3dI0?ofkP08
0?ofkP030000003om^h0ooK^00@0ooK^100000000`3D?AT0000000H84@030000000500/?803D?AT0
2`lP00/?800000000P0;3b001000000051Xl01@J?000000601@J?0040000000D6S`051Xl000000@0
7BQG00<000000=@m6@0M:5L00P0M:5L0103D?AT07BQG01dXE`00000201dXE`030000000U=6l09CA_
00809CA_00<0000002DdK`0U=6l01@0U=6l00`3D?AT0000002DdK`0302DdK`040000000/?X80;3j2
000000@0;3j200D0e3dI02`nPP0/?X8000000?m87@0203eIZ`@0odPM00@000000?m87@3oB1d00000
103hAA`00`000000?EV[0?Q570060?Q570030000003hAA`0n4DL0080n4DL00@000000>Y06@3Z@1T0
00000P3Z@1T01P0mFJ/0jT0I0>Y06@3Z@1T0?EV[000000@0jT0I00@000000=@i5P3D>AH000001P3D
>AH010000000e3TF0=@i5P0000020;8^4@050000002b;Q40/RhA03eIZ`2b;Q400`0000000`2:8Pd0
000003eIZ`02000000030=@m6@000000ooK^00D0ooK^00<000000?ofkP3om^h01`3om^h0100mFJ/0
ooK^03eIZ`0mFJ/80?ofkP0303eIZ`3om^h0ooK^0180ooK^00<0?EV[0?ofkP3om^h04P3om^h00`0m
FJ/0ooK^0?ofkP050?ofkP80?EV[2P3om^h00`0mFJ/0ooK^0?ofkP060?ofkP8000009@3om^h00`00
0000ooK^0?ofkP0P0?ofkP40oooo000R0?ofkP030000003om^h0ooK^02D0ooK^0P0000050?ofkP03
0=@m6@3om^h0ooK^00/0ooK^0P3D?AT50?ofkP030=@m6@3om^h0ooK^0180ooK^0`3D?ATB0?ofkP03
0=@m6@3om^h0ooK^00P0ooK^0P3D?AT70?ofkP8000001@3om^h20000000503eIZ`0000001PPA00H8
4@0000000P3D?AT0100;3b00000000/?803D?AT300/?80030000000;3b00000000<051Xl00<00000
01@J?00D6S`0100D6S`3000000D07BQG00<0e3dI01dXE`0M:5L00`0M:5L20=@m6@<000001@0U=6l0
0`0000009CA_02DdK`0502DdK`040=@m6@0000009CA_02DdK`8000000`0/?X800`000000;3j202`n
PP0302`nPP80e3dI00<0000003eIZ`3oB1d01@3oB1d010000000odPM0?m87@3oB1d200000080n4DL
00<0000003eIZ`3hAA`01P3hAA`00`000000n4DL0?Q570030?Q570<000000P0mFJ/50>Y06@0303eI
Z`3Z@1T0jT0I00<0jT0I0`0000060=@i5P070000003D>AH0e3TF0=@i5P000000/RhA000000030;8^
4@0403eIZ`2b;Q4000000;8^4@80?EV[00D0000008XR3@2:8Pd000000=@m6@02000000D0ooK^0P00
00070?ofkP80?EV[2P3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP<0?EV[503om^h00`0mFJ/0ooK^0?of
kP030?ofkP80?EV[3@3om^h00`0mFJ/0ooK^0?ofkP030?ofkP8000009`3om^h00`000000ooK^0?of
kP0P0?ofkP40oooo000Q0?ofkP030000003om^h0ooK^02P0ooK^0P0000030?ofkP030=@m6@3om^h0
ooK^00d0ooK^0P3D?AT30?ofkP030=@m6@3om^h0ooK^0140ooK^00@0e3dI0?ofkP3om^h0ooK^0P3D
?AT?0?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h00P3D?AT40?ofkP030000003o
m^h0e3dI00@0ooK^0P000000200mFJ/0000000H84@062140000000H84@0000002`lP0P3D?AT0100;
3b00e3dI00/?800;3b03000000@051Xl00<0000001@J?00D6S`0100D6S`00`0000007BQG01dXE`05
01dXE`030=@m6@0M:5L07BQG00D07BQG00<0e3dI02DdK`0U=6l01@0U=6l00`0000009CA_02DdK`04
02DdK`030=@m6@0U=6l00000008000001@0/?X800`000000;3j202`nPP0502`nPP0303eIZ`3oB1d0
odPM00D0odPM00<000000?m87@3oB1d00`3oB1d3000000030?Q5700mFJ/0n4DL00@0n4DL00<00000
0?Q5703hAA`01P3hAA`00`0mFJ/0jT0I0>Y06@050>Y06@0303eIZ`3Z@1T0jT0I00D0jT0I00<00000
0=@i5P3D>AH0103D>AH00`000000e3TF0=@i5P020=@i5P<000000P2b;Q40200mFJ/0/RhA03eIZ`0m
FJ/0/RhA0000002:8Pd000000P2:8Pd010000000e3dI0=@m6@0000040?ofkP0303eIZ`3om^h00000
00@0ooK^0P0mFJ/20?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h03@3om^h203eI
Z`<0ooK^00<0?EV[0?ofkP3om^h04@3om^h0100mFJ/0ooK^0?ofkP3om^h203eIZ`l0ooK^00@0?EV[
0?ofkP3om^h0ooK^0P00000Z0?ofkP030000003om^h0ooK^01l0ooK^0@3oool00240ooK^00<00000
0?ofkP3om^h0:P3om^h2000000030?ofkP3D?AT0ooK^0100ooK^0`3D?ATD0?ofkP030=@m6@3om^h0
ooK^00<0ooK^0P3D?AT=0?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h00P3om^h2
0=@m6@80000000<0ooK^0=@m6@3om^h00`3om^h0100000001PPA00000000000300H84@8000000P0;
3b000`0000002`lP0=@m6@0300/?80030000000D6S`051Xl00<051Xl00<0000001@J?00D6S`00`0D
6S`3000000H07BQG00<0e3dI0000000M:5L0100M:5L300000080e3dI1P0U=6l00`0000009CA_02Dd
K`0302DdK`030=@m6@0U=6l0000000L0;3j200<0000002`nPP0/?X801@0/?X800`000000odPM0?m8
7@050?m87@030000003oB1d0odPM00D0odPM00<000000?Q5700mFJ/01@3hAA`00`000000n4DL0?Q5
70040?Q57080?EV[0`0000050>Y06@030000000mFJ/0jT0I00D0jT0I0`0000050=@i5P030000003D
>AH0e3TF00<0e3TF00L000000;8^4@2b;Q40/RhA03eIZ`2b;Q4000000080/RhA0P00000208XR3@<0
000000<0e3dI0000003om^h00`3om^h0100mFJ/0ooK^00000000000203eIZ`@0ooK^00<0?EV[0?of
kP3om^h0203om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP80?EV[1@3om^h00`0mFJ/0ooK^0?ofkP0B0?of
kP<0?EV[4@3om^h0100mFJ/0ooK^00000000000/0?ofkP030000003om^h0ooK^01l0ooK^0@3oool0
0240ooK^00<000000?ofkP3om^h0;03om^h00`000000e3dI0?ofkP0B0?ofkP030=@m6@3om^h0ooK^
0180ooK^00<0e3dI0?ofkP3om^h01@3om^h20=@m6@X0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D
?AT0ooK^0?ofkP040?ofkP050000003D?AT0e3dI0?ofkP3D?AT00P3om^h20000000400H84@000000
1PPA000000801PPA00<0000000/?800;3b000P0;3b000`000000e3dI00/?80020=@m6@8000001@0D
6S`00`00000051Xl01@J?00201@J?0040000000M:5L07BQG000000H07BQG00<0e3dI0000000M:5L0
0`0M:5L0100000009CA_02DdK`00000202DdK`030=@m6@0U=6l09CA_00<09CA_00<0000002DdK`0U
=6l00P0U=6l0103D?AT0000000000000000702`nPP030000000/?X80;3j200D0;3j200<000000?m8
7@3oB1d01@3oB1d00`000000odPM0?m87@050?m87@<0000000<0?EV[0?Q5703hAA`00P3hAA`00`00
0000n4DL0?Q570030?Q5700403eIZ`3hAA`0n4DL00000080n4DL00<000000>Y06@3Z@1T00P3Z@1T0
0`000000?EV[0>Y06@050>Y06@040000003Z@1T0jT0I000000@0e3TF00<000000=@i5P3D>AH00`3D
>AH200000080?EV[00<0/RhA03eIZ`000000102b;Q400`000000RR8=08XR3@030000000305`D2000
000000000080ooK^00D0?EV[0?ofkP0mFJ/0?EV[000000060?ofkP0303eIZ`3om^h0ooK^00P0ooK^
00<0?EV[0?ofkP3om^h0203om^h203eIZ`L0ooK^00<0?EV[0?ofkP3om^h04P3om^h00`0mFJ/0ooK^
0?ofkP0A0?ofkP0303eIZ`000000ooK^02d0ooK^00<000000?ofkP3om^h07`3om^h10?ooo`008@3o
m^h00`000000ooK^0?ofkP0/0?ofkP030=@m6@3om^h000000180ooK^0`3D?ATB0?ofkP030=@m6@3o
m^h0ooK^00L0ooK^0P3D?AT80?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h0103o
m^h01@000000ooK^0?ofkP3om^h0e3dI0080ooK^0P0000001@062140000000H84@0000001PPA00<0
00000`0;3b00200000002`lP0=@m6@0;3b00000001@J?03D?AT000001@0D6S`00`00000051Xl01@J
?002000000<07BQG00<0000001dXE`0M:5L00`0M:5L00`3D?AT07BQG0000000201dXE`8000000`0U
=6l0100000009CA_02DdK`0U=6l20=@m6@<09CA_00<0000003eIZ`0U=6l00P0U=6l0103D?AT0;3j2
02`nPP00000702`nPP030000000/?X80;3j200D0;3j200<000000?m87@3oB1d01@3oB1d00`000000
odPM0?m87@050?m87@040000003oB1d0odPM03eIZ`@0n4DL00@000000?Q5703hAA`0n4DL0P0mFJ/3
0?Q570040000003hAA`0n4DL0?Q5708000000P3Z@1T00`000000jT0I03eIZ`050>Y06@040000003Z
@1T0jT0I0>Y06@8000000P3D>AH00`000000e3TF0=@i5P030=@i5P080000000mFJ/0e3TF0000002b
;Q40?EV[0;8^4@0000030;8^4@<0000000D0RR8=0000002:8Pd0000005`D200200000080ooK^00D0
?EV[0?ofkP3om^h0ooK^000000060?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h0
1P3om^h203eIZ`T0ooK^00<0?EV[0?ofkP3om^h0403om^h303eIZa80ooK^00<000000?ofkP0mFJ/0
;P3om^h00`000000ooK^0?ofkP0O0?ofkP40oooo000Q0?ofkP030000003om^h0ooK^02`0ooK^00<0
e3dI0?ofkP3om^h00P00000@0?ofkP030=@m6@3om^h0ooK^0080e3dI3`3om^h00`3D?AT0ooK^0?of
kP0:0?ofkP80e3dI1@3om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^0080ooK^0P00
00040?ofkP80e3dI0P00000020062140000000H84@0000001PPA0000000;3b000000100;3b001000
0000e3dI00000000000201@J?0030000003D?AT0e3dI00@051Xl0`00000501dXE`030000000M:5L0
7BQG00<07BQG00<0e3dI01dXE`0000000P00000502DdK`030000000U=6l09CA_00<09CA_00@0e3dI
02DdK`0U=6l000000P0U=6l2000000040=@m6@0/?X80;3j2000000L0;3j200<0000002`nPP0/?X80
1@0/?X800`000000odPM0?m87@050?m87@030000003oB1d0odPM00D0odPM00@000000?m87@3oB1d0
?EV[0P0000020?Q570040000003hAA`0n4DL03eIZ`D0n4DL00<000000?Q5703hAA`00`3hAA`30000
00030>Y06@0mFJ/0jT0I00@0jT0I00<000000>Y06@3Z@1T00`3Z@1T3000000@0e3TF0P0mFJ/00`00
0000e3TF0=@i5P020000000303eIZ`000000/RhA00<0/RhA00P000000;8^4@000000RR8=0000002:
8Pd0000005`D208000000P0mFJ/40?ofkP800000103om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eI
Z`3om^h0ooK^00<0ooK^0P0mFJ/<0?ofkP0303eIZ`3om^h0ooK^00d0ooK^0P0mFJ/20?ofkP0303eI
Z`3om^h0ooK^00h0ooK^0P0000020?ofkP0303eIZ`3om^h0ooK^02`0ooK^00<000000?ofkP3om^h0
7`3om^h10?ooo`00803om^h00`000000ooK^0?ofkP0]0?ofkP030=@m6@3om^h0ooK^0080ooK^0P00
000=0?ofkP030=@m6@3om^h0ooK^00<0ooK^0P3D?AT=0?ofkP030=@m6@3om^h0ooK^00`0ooK^0P3D
?AT30?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`000000ooK^0?of
kP030?ofkP040=@m6@3om^h0000000H84@80000000@01PPA00000006214000000P0;3b001`000000
2`lP00/?800;3b0000000=@m6@000000100D6S`00`00000051Xl01@J?0020=@m6@8051Xl00<00000
01dXE`0M:5L01@0M:5L00`0000007BQG01dXE`0201dXE`040=@m6@0M:5L07BQG000000L09CA_00<0
000002DdK`0U=6l0100U=6l20=@m6@<0000000<0;3j20=@m6@0/?X800P0/?X800`000000;3j202`n
PP0502`nPP030000000/?X80;3j200D0;3j200<000000?m87@3oB1d01@3oB1d00`000000odPM0?m8
7@050?m87@060000003oB1d0odPM0?m87@0mFJ/0odPM0`00000203eIZ`H0n4DL00<000000?Q5703h
AA`01@3hAA`010000000jT0I0>Y06@0mFJ/40>Y06@030000003Z@1T0jT0I00D0jT0I00<000000=@i
5P3D>AH00P0mFJ/20=@i5P030000003D>AH0e3TF0080e3TF00<0000003eIZ`0000000`2b;Q400`00
0000/RhA0;8^4@0200000080RR8=0P000000101L50P000000?ofkP0mFJ/50?ofkP030000003om^h0
ooK^0080ooK^00<0?EV[0?ofkP3om^h01`3om^h0100mFJ/0ooK^0?ofkP3om^h203eIZ`h0ooK^00<0
?EV[0?ofkP3om^h02`3om^h203eIZ`D0ooK^00<0?EV[0?ofkP3om^h02`3om^h2000000@0ooK^00<0
?EV[0?ofkP3om^h0;@3om^h00`000000ooK^0?ofkP0N0?ofkP40oooo000P0?ofkP030000003om^h0
ooK^02d0ooK^0`3D?AT40?ofkP8000002`3om^h00`3D?AT0ooK^0?ofkP050?ofkP80e3dI2`3om^h0
0`3D?AT0ooK^0?ofkP0>0?ofkP<0e3dI2@3om^h0103D?AT0ooK^0=@m6@3D?AT2000000H0ooK^00<0
e3dI0000000000000P00000200H84@8000000P0;3b000`0000002`lP00/?800200/?80030000003D
?AT051Xl00@051Xl00<0000001@J?00D6S`00P0D6S`00`3D?AT0?EV[0000000701dXE`030000000M
:5L07BQG00807BQG00@0e3dI0000000000000000200U=6l00`0000009CA_02DdK`0502DdK`050=@m
6@0/?X80;3j202`nPP3D?AT00`0/?X800`000000;3j202`nPP0502`nPP030000000/?X80;3j200<0
;3j21@0000050?m87@030000003oB1d0odPM00D0odPM00D000000?m87@3oB1d0odPM03eIZ`030?m8
7@0303eIZ`3hAA`0n4DL00D0n4DL00<000000?Q5703hAA`01P3hAA`30000000303eIZ`3Z@1T0jT0I
0080jT0I00<000000>Y06@3Z@1T01@3Z@1T20000000303eIZ`3D>AH0e3TF0080e3TF00<000000=@i
5P3D>AH00`3D>AH00`0mFJ/000000;8^4@030;8^4@030000002b;Q40/RhA008000000P2:8Pd40000
000303eIZ`3om^h0ooK^00@0ooK^0P00000203eIZ`030?ofkP0mFJ/0ooK^00P0ooK^0`0mFJ/@0?of
kP0303eIZ`3om^h0ooK^00T0ooK^0P0mFJ/70?ofkP0303eIZ`3om^h0ooK^00T0ooK^0P0000040?of
kP<0?EV[;`3om^h00`000000ooK^0?ofkP0N0?ofkP40oooo000P0?ofkP030000003om^h0ooK^02d0
ooK^00<0e3dI0?ofkP3om^h00P3D?AT40?ofkP8000002@3om^h00`3D?AT0ooK^0?ofkP070?ofkP03
0=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h04@3om^h00`3D?AT0ooK^0?ofkP060?ofkP05
0=@m6@3om^h0ooK^0?ofkP0000000P3D?AT50?ofkP050=@m6@000000000000H84@0000000P062140
0`0000002`lP00/?800200/?80030000000;3b002`lP0080000000<0e3dI01@J?00D6S`0100D6S`0
1P00000051Xl01@J?00D6S`0000001dXE`80e3dI1`0M:5L01P0000007BQG01dXE`0M:5L0e3dI0000
00809CA_00<0000002DdK`0U=6l01P0U=6l00`0000009CA_02DdK`0302DdK`<000000`3D?AT402`n
PP030000000/?X80;3j200D0;3j200<0000002`nPP0/?X800P0/?X8010000000<DNB0357TP000002
0?m:7P030000003oB1d0odPM0080odPM00<000000?m87@3oB1d01@3oB1d00`000000odPM0?m87@02
0?m87@<0?EV[0`0000050?Q570030000003hAA`0n4DL00H0n4DL00D000000?Q5703hAA`0000003eI
Z`030>Y06@030000003Z@1T0jT0I00D0jT0I0P0mFJ/00`3Z@1T000000=@i5P020=@i5P030000003D
>AH0e3TF00@0e3TF00<0?EV[0000000000000P2b;Q400`000000/RhA0;8^4@020;8^4@050000002:
8Pd0RR8=0000002:8Pd00P0000000`0mFJ/0ooK^0?ofkP030?ofkP80?EV[00D000000?ofkP3om^h0
ooK^03eIZ`080?ofkP0303eIZ`3om^h0ooK^0140ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0
ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00L0ooK^0P0000040?ofkP80?EV[0P3om^h00`0mFJ/0
ooK^0?ofkP0]0?ofkP030000003om^h0ooK^01h0ooK^0@3oool00200ooK^00<000000?ofkP3om^h0
;@3om^h00`3D?AT0ooK^0?ofkP020?ofkP80e3dI103om^h2000000L0ooK^00<0e3dI0?ofkP3om^h0
203om^h20=@m6@L0ooK^00<0e3dI0?ofkP3om^h04@3om^h30=@m6@D0ooK^00<0e3dI0?ofkP3om^h0
0P0000030?ofkP060=@m6@3om^h0ooK^0?ofkP06214000000P062140100000001PPA000000000004
00/?80070000000;3b002`lP0000000D6S`0e3dI0000000501@J?0030000000D6S`051Xl00800000
0`0M:5L00`000000e3dI01dXE`0501dXE`050000000M:5L07BQG0000003D?AT00`0U=6l00`000000
9CA_02DdK`0602DdK`030000000U=6l09CA_00809CA_00@0000002`nPP0/?X8000000P0/?X800`3D
?AT0;3j202`nPP0202`nPP030000000/?X80;3j200D0;3j200<0000002`nPP0/?X800P0000030357
TP040000003oBQh0odXN0?m:7P8000000P3oB1d00`000000odPM0?m87@040?m87@030000003oB1d0
odPM00<0odPM00@0?EV[0?m87@3oB1d000000P3oB1d00`000000n4DL0?Q570020?Q570030000003h
AA`0n4DL00H0n4DL00H000000?Q5703hAA`0n4DL03eIZ`0000020>Y06@030000003Z@1T0jT0I00@0
jT0I00<0?EV[0000003Z@1T00P3Z@1T200000080e3TF00<000000=@i5P3D>AH00`3D>AH010000000
?EV[0=@i5P0000020;8^4@040000002b;Q40/RhA0;8^4@<0000000@0RR8=0000002:8Pd0RR8=0P00
00030?ofkP0403eIZ`3om^h0ooK^0?ofkP8000000P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP<0?EV[
4`3om^h00`0mFJ/0ooK^0?ofkP050?ofkP80?EV[2P3om^h00`0mFJ/0ooK^0?ofkP050?ofkP800000
103om^h203eIZ`@0ooK^00<0?EV[0?ofkP3om^h0;@3om^h00`000000ooK^0?ofkP0N0?ofkP40oooo
000O0?ofkP030000003om^h0ooK^02h0ooK^00<0e3dI0?ofkP3om^h0103om^h20=@m6@@0ooK^00<0
00000?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP80e3dI1@3om^h00`3D?AT0ooK^0?of
kP0@0?ofkP040=@m6@3om^h0ooK^0?ofkP80e3dI0`3om^h00`3D?AT0ooK^000000060?ofkP80e3dI
0P00000200H84@<0000000<02`lP0000000;3b000`0;3b001`0000002`lP0000000D6S`0e3dI01@J
?00000001@0D6S`3000000D07BQG00@0000001dXE`3D?AT0e3dI100M:5L3000000030=@m6@0U=6l0
9CA_00809CA_00<0000002DdK`0U=6l01P0U=6l00`0000009CA_02DdK`02000000<0;3j200@00000
02`nPP3D?AT0;3j20P3D?AT302`nPP030000000/?X80;3j200@0;3j20`0000050357TP030000003o
BQh0odXN00<0odXN0`0000060?m87@040000003oB1d0odPM0?m87@<0?EV[0P3oB1d010000000odPM
0?m87@3oB1d200000080n4DL00<000000?Q5703hAA`01P3hAA`00`000000n4DL0?Q570020?Q57004
03eIZ`0000000000000000@0jT0I0P0mFJ/00`3Z@1T000000>Y06@040>Y06@<000001@3D>AH01`00
0000?EV[0=@i5P3D>AH000000;8^4@000000102b;Q400`000000/RhA0000000200000080RR8=0P00
000203eIZ`H0ooK^00<000000?ofkP0mFJ/00`3om^h203eIZ`<0ooK^00<0?EV[0?ofkP3om^h0403o
m^h00`0mFJ/0ooK^0?ofkP030?ofkP80?EV[3@3om^h00`0mFJ/0ooK^0?ofkP030?ofkP030000003o
m^h0ooK^0080ooK^0P0mFJ/60?ofkP0303eIZ`3om^h0ooK^02h0ooK^00<000000?ofkP3om^h07@3o
m^h10?ooo`007`3om^h00`000000ooK^0?ofkP0^0?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI
0?ofkP3om^h00P3om^h2000000<0ooK^00<0e3dI0?ofkP3om^h03@3om^h20=@m6@<0ooK^00<0e3dI
0?ofkP3om^h0403om^h00`3D?AT0ooK^0?ofkP030?ofkP<0e3dI00<0ooK^0000003om^h01P3om^h2
00000080e3dI00<01PPA0000000000000P0;3b000`0000002`lP00/?800200/?80<000000P0D6S`0
0`3D?AT051Xl0000000501@J?0030000000M:5L07BQG00D07BQG00@0000001dXE`0M:5L07BQG0P3D
?AT201dXE`040000000U=6l09CA_0=@m6@@09CA_00<0000002DdK`0U=6l01P0U=6l3000000D0;3j2
00<0000002`nPP3D?AT00`0/?X820=@m6@0302`nPP000000;3j200D0;3j200<000000357TP0aAi80
1@0aAi800`000000odXN0?m:7P050?m:7P030000003oB1d0odPM00@0odPM00@000000?m87@0mFJ/0
?EV[0`3oB1d00`0mFJ/0odPM000000050?m87@<00000203hAA`00`000000n4DL0?Q570020?Q57004
03eIZ`3hAA`0n4DL00000080jT0I0P0mFJ/30>Y06@030000003Z@1T0jT0I00@0jT0I00<0e3dI0000
003D>AH0103D>AH00`000000e3TF03eIZ`020=@i5P<000000`2b;Q4010000000/RhA0;8^4@2b;Q42
0000000308XR3@0mFJ/0?EV[008000001`3om^h00`000000ooK^03eIZ`0203eIZ`D0ooK^00<0?EV[
0?ofkP3om^h0403om^h0100mFJ/0ooK^0?ofkP3om^h203eIZ`l0ooK^00@0?EV[0?ofkP3om^h0ooK^
0P0000040?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h0;P3om^h00`000000ooK^
0?ofkP0M0?ofkP40oooo000O0?ofkP030000003om^h0ooK^02d0ooK^00<0e3dI0?ofkP3om^h0203o
m^h20=@m6@@0ooK^0P0000000`3om^h0e3dI0?ofkP0@0?ofkP<0e3dI4`3om^h00`3D?AT0ooK^0?of
kP040?ofkP030=@m6@000000000000L0ooK^0P00000010062140000000H84@3D?AT400/?80030000
000;3b002`lP00802`lP00L0000001@J?00D6S`051Xl0=@m6@0D6S`0000000@051Xl0`00000701dX
E`030000000M:5L07BQG00<07BQG00D0e3dI0000000000009CA_0=@m6@0602DdK`030000000U=6l0
9CA_00D09CA_00<0000002`nPP0/?X801@0/?X800`000000e3dI02`nPP0502`nPP030=@m6@000000
;3j200<0;3j20`0000070357TP030000003oBQh0odXN00D0odXN0`0000040?m87@030000000mFJ/0
odPM00@0odPM00<0?EV[0?m87@0000001`3oB1d00`000000n4DL0?Q570050?Q570030000003hAA`0
n4DL00@0n4DL00D0?EV[0?Q570000000000003eIZ`050>Y06@030000003Z@1T0jT0I00D0jT0I0`00
00040=@i5P030000003D>AH0?EV[00<0e3TF00<000000;8^4@2b;Q400P2b;Q400`000000/RhA0;8^
4@020;8^4@0403eIZ`2:8Pd0000008XR3@8000001`3om^h20000000303eIZ`3om^h0ooK^00@0ooK^
00<0?EV[0?ofkP3om^h04@3om^h303eIZa40ooK^00@0?EV[0?ofkP0000000000103om^h203eIZ`T0
ooK^00<0?EV[0?ofkP3om^h0;P3om^h00`000000ooK^0?ofkP0M0?ofkP40oooo000O0?ofkP030000
003om^h0ooK^02d0ooK^00<0e3dI0?ofkP3om^h02P3om^h20=@m6@@0ooK^00<000000=@m6@3om^h0
4P3om^h00`3D?AT0ooK^0?ofkP0A0?ofkP030=@m6@3om^h0ooK^00<0ooK^00@0e3dI0000003om^h0
ooK^0P3D?AT40?ofkP050000000621401PPA0000000621400P0000020=@m6@0300/?800000002`lP
00802`lP0`00000201@J?0040=@m6@0D6S`051Xl000000<051Xl00@0000001dXE`0M:5L000001`0M
:5L00`0000007BQG01dXE`0201dXE`060000000U=6l0e3dI0=@m6@0U=6l0e3dI1P0U=6l00`000000
9CA_02DdK`0302DdK`<000001`0/?X800`000000e3dI02`nPP0602`nPP80e3dI0P0/?X8010000000
<DNB0357TP0000070357TP030000003oBQh0odXN00D0odXN00@000000?m:7P3oBQh000000P3oB1d2
03eIZ`L0odPM00<0?EV[0000003oB1d01P3oB1d3000000D0n4DL00<000000?Q5703hAA`0103hAA`0
1P0mFJ/0n4DL03eIZ`0mFJ/0n4DL000000@0jT0I00<000000>Y06@3Z@1T01@3Z@1T010000000jT0I
0>Y06@0000030=@i5P040000003D>AH0e3TF03eIZ`80e3TF0`0000020;8^4@030000002b;Q40/RhA
0080?EV[0P0000001P2:8Pd0000008XR3@2:8Pd000000=@m6@<0ooK^0P0mFJ/20?ofkP030000000m
FJ/0ooK^00@0ooK^00<0?EV[0?ofkP3om^h04@3om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP0303eIZ`00
0000ooK^00<0ooK^0P0mFJ/<0?ofkP0303eIZ`3om^h0ooK^02d0ooK^00<000000?ofkP3om^h07@3o
m^h10?ooo`007`3om^h00`000000ooK^0?ofkP0]0?ofkP030=@m6@3om^h0ooK^00`0ooK^0P3D?AT2
0?ofkP040=@m6@3om^h0000000000140ooK^0`3D?AT@0?ofkP030=@m6@3om^h0ooK^00<0ooK^0P00
00050?ofkP80e3dI00H0?EV[0000000621401PPA000000062142000000<02`lP0P3D?AT00`0;3b00
00000000000201@J?0040000000D6S`051Xl0=@m6@8051Xl00@0000001@J?00D6S`000000`0M:5L0
0`0000007BQG01dXE`0501dXE`030000000M:5L07BQG008000000`0U=6l00`000000e3dI02DdK`06
02DdK`030000000U=6l09CA_00809CA_00@0000002`nPP0/?X8000001`0/?X800`3D?AT0000002`n
PP0602`nPP040000000/?X80e3dI000000<0<DNB00<000000357TP0aAi80100aAi800`3D?AT00000
03eIZ`060?m:7P080000003oBQh0odXN0?m:7P000000?EV[0?m87@0000070?m87@0303eIZ`3oB1d0
odPM00H0odPM00@000000?m87@3oB1d00000103hAA`00`000000n4DL0?Q570050?Q5700303eIZ`00
0000n4DL0080n4DL0P0000020>Y06@030000003Z@1T0jT0I00D0jT0I00D000000>Y06@3Z@1T0jT0I
000000020=@i5P040000003D>AH0e3TF03eIZ`80e3TF00<000000=@i5P3D>AH00P0000000`2b;Q40
?EV[03eIZ`030;8^4@80000000H0RR8=0000002:8Pd0RR8=0000003D?AT203eIZ`D0ooK^0P000005
0?ofkP0303eIZ`3om^h0ooK^00h0ooK^0`0mFJ/A0?ofkP80000000@0ooK^03eIZ`3om^h0ooK^0P0m
FJ/>0?ofkP0303eIZ`3om^h0ooK^02d0ooK^00<000000?ofkP3om^h07@3om^h10?ooo`007P3om^h0
0`000000ooK^0?ofkP0^0?ofkP030=@m6@3om^h0ooK^00h0ooK^0`3D?AT30?ofkP8000003`3om^h0
0`3D?AT0ooK^0?ofkP020=@m6@h0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`000000ooK^0?ofkP05
0?ofkP80?EV[00<0e3dI00H84@0621400`0000000`0;3b00000000/?800200/?8080000000<0e3dI
01@J?00D6S`00P0D6S`00`00000051Xl0=@m6@0301@J?0<00000100M:5L00`0000007BQG01dXE`05
01dXE`<000001@0U=6l0103D?AT09CA_0=@m6@3D?AT502DdK`030000000U=6l09CA_008000000`0/
?X800`000000;3j202`nPP0502`nPP030=@m6@000000;3j200H0;3j20`0000020=@m6@80<DNB00<0
00000357TP0aAi80100aAi800`3D?AT0000003eIZ`060?m:7P030000003oBQh0odXN0080?EV[0`00
00070?m87@030000000mFJ/0odPM00H0odPM00@000000?m87@3oB1d0odPM0P0000020?Q570030000
003hAA`0n4DL00<0n4DL0P0mFJ/00`3hAA`0?EV[0?Q570040?Q570<000001`3Z@1T00`000000jT0I
0>Y06@020>Y06@<000000`3D>AH00`0mFJ/0e3TF000000040=@i5P0303eIZ`000000/RhA00<0/RhA
00@000000;8^4@00000000000`2:8Pd00`0mFJ/0e3dI0=@m6@070?ofkP030000003om^h0ooK^0080
ooK^00<0?EV[0?ofkP3om^h0303om^h203eIZ`80ooK^00<0?EV[0?ofkP3om^h03@3om^h2000000<0
ooK^0`0mFJ/@0?ofkP0303eIZ`3om^h0ooK^02h0ooK^00<000000?ofkP3om^h0703om^h10?ooo`00
7P3om^h00`000000ooK^0?ofkP0^0?ofkP030=@m6@3om^h0ooK^0100ooK^00<0e3dI0?ofkP3om^h0
0`3om^h00`000000ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00<0ooK^0P3D?AT<0?ofkP030=@m
6@3om^h0ooK^008000001`3om^h203eIZ`050000003D?AT01PPA00H84@0000000P0;3b000`000000
2`lP00/?800200/?80030000000D6S`051Xl0080e3dI0P0D6S`00`000000e3dI01@J?00301@J?003
0000000M:5L07BQG00@07BQG00<0000001dXE`0M:5L01@0M:5L00`0000009CA_02DdK`0502DdK`04
0=@m6@0U=6l09CA_02DdK`80e3dI0`0U=6l3000000H0;3j200<0000002`nPP0/?X800`0/?X800`3D
?AT0;3j20000000702`nPP030000000aAi80<DNB0080<DNB0P3D?AT00`000000<DNB0357TP030357
TP050=@m6@0aAi8000000?m:7P0mFJ/01@3oBQh00`000000?EV[03eIZ`040?m:7P030000003oB1d0
odPM00D0odPM00<0000003eIZ`3oB1d01@3oB1d00`000000odPM0?m87@040?m87@<000000`3hAA`2
03eIZ`<0n4DL00<0?EV[0?Q5703hAA`01@3hAA`00`000000jT0I0>Y06@040>Y06@030000003Z@1T0
jT0I00D0jT0I00<000000=@i5P3D>AH00P3D>AH0100mFJ/000000=@i5P3D>AH203eIZ`80e3TF00<0
00000;8^4@2b;Q400P2b;Q4010000000/RhA0;8^4@00000208XR3@0403eIZ`000000e3dI0=@m6@L0
ooK^0P0000020?ofkP0303eIZ`3om^h0ooK^00X0ooK^0P0mFJ/50?ofkP0303eIZ`3om^h0ooK^00/0
ooK^00<000000?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0303eIZ`3om^h0ooK^02h0
ooK^00<000000?ofkP3om^h0703om^h10?ooo`007P3om^h00`000000ooK^0?ofkP0^0?ofkP030=@m
6@3om^h0ooK^0100ooK^0`3D?AT40?ofkP8000002`3om^h00`3D?AT0ooK^0?ofkP050?ofkP80e3dI
2@3om^h01P3D?AT0ooK^0?ofkP000000ooK^0=@m6@D0ooK^0P0mFJ/00`3om^h0000003eIZ`0200H8
4@050000000;3b002`lP00/?800000000P0;3b03000000@051Xl0P3D?AT01`0D6S`0e3dI01@J?00D
6S`0000003eIZ`0000001`0M:5L00`0000007BQG01dXE`0201dXE`<000001P0U=6l00`3D?AT09CA_
0000000402DdK`80e3dI00<09CA_0000000/?X801`0/?X800`000000;3j202`nPP0302`nPP030=@m
6@0/?X80000000D0;3j20`0000060357TP030=@m6@0aAi80<DNB00<0<DNB00D0e3dI0357TP000000
odXN03eIZ`050?m:7P0303eIZ`3oBQh0odXN00@0odXN0`0000050?m87@030000003oB1d0?EV[00D0
odPM00<000000?m87@3oB1d01P3oB1d010000000n4DL03eIZ`0mFJ/40?Q570030000003hAA`0?EV[
00H0n4DL0`0000040>Y06@030000003Z@1T0jT0I00D0jT0I0`0000020=@i5P0403eIZ`3D>AH0?EV[
03eIZ`@0e3TF0`0000020;8^4@050000002b;Q40/RhA0;8^4@0000000P2:8Pd20=@m6@030?ofkP3D
?AT0e3dI00D0ooK^00<0?EV[0?ofkP0000000P3om^h00`0mFJ/0ooK^0?ofkP070?ofkP80?EV[1`3o
m^h00`0mFJ/0ooK^0?ofkP090?ofkP800000103om^h303eIZa80ooK^00<0?EV[0?ofkP3om^h0;P3o
m^h00`000000ooK^0?ofkP0L0?ofkP40oooo000N0?ofkP030000003om^h0ooK^02h0ooK^00<0e3dI
0?ofkP3om^h0403om^h00`3D?AT0ooK^0?ofkP020=@m6@@0ooK^0P0000090?ofkP030=@m6@3om^h0
ooK^00L0ooK^0P3D?AT70?ofkP050=@m6@3om^h000000?ofkP3D?AT01@3om^h203eIZ`040?ofkP0m
FJ/0?EV[00H84@8000000`0;3b00100000002`lP00/?8000000201@J?0030000000D6S`051Xl00<0
51Xl00D000000=@m6@0D6S`051Xl0000000201dXE`030000000M:5L07BQG00D07BQG00D0000001dX
E`0M:5L07BQG0000000202DdK`030000000U=6l09CA_00<09CA_00@0e3dI02DdK`0U=6l000001@0U
=6l00`000000e3dI0000000802`nPP030000000/?X80;3j20080;3j200@0e3dI02`nPP0/?X800000
0`0/?X8200000080<DNB00<000000357TP0aAi80100aAi800`000000e3dI0=@m6@030357TP050=@m
6@0aAi8000000?m:7P0mFJ/00`3oBQh203eIZ`030000003oBQh0odXN00@0odXN00<000000?m:7P3o
BQh00P0000030?m87@030000003oB1d0?EV[00D0odPM00<000000?m87@3oB1d01P3oB1d00`000000
?EV[000000050?Q570040000003hAA`0n4DL03eIZ`D0n4DL00@000000?Q5703hAA`000000`3Z@1T0
0`000000jT0I0>Y06@050>Y06@040000003Z@1T0jT0I00000080e3TF00<0?EV[0000003D>AH0103D
>AH010000000e3TF0=@i5P0000020;8^4@040000002b;Q40/RhA0;8^4@80000000@0RR8=0=@m6@3D
?AT0ooK^0P3D?AT50?ofkP0503eIZ`3om^h000000?ofkP0mFJ/01`3om^h203eIZ`T0ooK^00<0?EV[
0?ofkP3om^h01`3om^h2000000@0ooK^0P0mFJ/20?ofkP0303eIZ`3om^h0ooK^0100ooK^00<0?EV[
0?ofkP3om^h0;P3om^h00`000000ooK^0?ofkP0L0?ofkP40oooo000M0?ofkP030000003om^h0ooK^
02l0ooK^0`3D?AT@0?ofkP030=@m6@3om^h0ooK^0080ooK^0P3D?AT40?ofkP8000001`3om^h00`3D
?AT0ooK^0?ofkP090?ofkP80e3dI1@3om^h2000000030?ofkP3D?AT0ooK^00<0ooK^0`0mFJ/00`3o
m^h0?EV[000000020000000300/?800000002`lP00802`lP00<0000000/?800000000P0D6S`00`00
000051Xl01@J?00401@J?0040=@m6@0D6S`0e3dI0=@m6@<07BQG00<0000001dXE`0M:5L01@0M:5L0
100000007BQG01dXE`00000402DdK`050000000U=6l09CA_02DdK`3D?AT00`0U=6l00`0000009CA_
02DdK`0202DdK`030000000/?X80;3j20080e3dI1`0/?X800`000000;3j202`nPP0202`nPP050=@m
6@0/?X80;3j20000000/?X800P0000040357TP030000000aAi80<DNB00D0<DNB00<000000357TP3D
?AT00P3D?AT20357TP030000003oBQh0odXN00<0?EV[00<0odXN0000003oBQh01P3oBQh00`000000
odXN0?m:7P020?m:7P80000000D0odPM0000003oB1d0odPM03eIZ`040?m87@030000003oB1d0odPM
00D0odPM0P0mFJ/20?m87@030000003hAA`0n4DL0080n4DL00D000000?Q5703hAA`0n4DL03eIZ`03
0?Q570030000003hAA`0n4DL0080n4DL00@000000>Y06@3Z@1T000001`3Z@1T010000000jT0I0>Y0
6@3Z@1T203eIZ`030=@i5P0mFJ/0e3TF00D0e3TF00H000000=@i5P3D>AH000000;8^4@0000030;8^
4@030000002b;Q4000000080000000<0e3dI0?ofkP3D?AT00P3D?AT40?ofkP0403eIZ`3om^h00000
000000D0ooK^0P0mFJ/;0?ofkP0303eIZ`3om^h0ooK^00D0ooK^0P0000040?ofkP80?EV[103om^h0
0`0mFJ/0ooK^0?ofkP0>0?ofkP<0?EV[<@3om^h00`000000ooK^0?ofkP0K0?ofkP40oooo000M0?of
kP030000003om^h0ooK^02l0ooK^00<0e3dI0?ofkP3om^h00P3D?AT>0?ofkP030=@m6@3om^h0ooK^
00@0ooK^0P3D?AT40?ofkP800000103om^h00`3D?AT0ooK^0?ofkP0<0?ofkP80e3dI0P3om^h01000
0000e3dI0?ofkP3D?AT40?ofkP0303eIZ`3om^h0?EV[0080?EV[0P00000200/?80040000000;3b00
2`lP00/?80<000000`0D6S`00`00000051Xl01@J?00301@J?0050=@m6@00000000000000000M:5L0
0P3D?AT00`0M:5L0000001dXE`0601dXE`<000001@0U=6l01@0000009CA_02DdK`0U=6l0e3dI00<0
9CA_00<0000002DdK`0U=6l00P00000302`nPP040000000/?X80e3dI0=@m6@D0;3j200D0000002`n
PP0/?X80;3j20=@m6@0302`nPP8000001P0aAi800`000000<DNB0357TP050357TP050000000aAi80
<DNB0357TP3D?AT00P0aAi8010000000odXN0?m:7P0mFJ/30?m:7P030000003oBQh0odXN00D0odXN
00<000000?m:7P3oBQh0103oBQh200000080odPM00<0?EV[0?m87@3oB1d00P3oB1d00`000000odPM
0?m87@030?m87@80?EV[00<0odPM0000003oB1d00P3oB1d200000080n4DL00D000000?Q5703hAA`0
n4DL03eIZ`030?Q570030000003hAA`0n4DL00<0n4DL0`0000070>Y06@050000003Z@1T0?EV[03eI
Z`3Z@1T00`0000000`0mFJ/0e3TF0=@i5P030=@i5P040000003D>AH0e3TF0=@i5P<000000`2b;Q40
0`000000/RhA0;8^4@02000000<0e3dI00<0ooK^0=@m6@3om^h00`3om^h0100mFJ/0ooK^03eIZ`00
00020?ofkP80?EV[3P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP800000103om^h203eIZ`H0ooK^00<0
?EV[0?ofkP3om^h0303om^h203eIZ`80ooK^00<0?EV[0?ofkP3om^h0;`3om^h00`000000ooK^0?of
kP0K0?ofkP40oooo000M0?ofkP030000003om^h0ooK^02l0ooK^00<0e3dI0?ofkP3om^h00P3om^h2
0=@m6@`0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP030?ofkP8000000P3om^h0
0`3D?AT0ooK^0?ofkP0>0?ofkP80000000@0e3dI0?ofkP3D?AT0ooK^0P3D?AT00`3om^h0?EV[0?of
kP0303eIZ`030000000;3b002`lP00802`lP00D0000000/?800;3b002`lP0000000501@J?0030000
000D6S`051Xl008051Xl00<0e3dI01@J?00000001@0M:5L20=@m6@L07BQG00<0000002DdK`0U=6l0
1@0U=6l0100000009CA_02DdK`3D?AT402DdK`<000001P0/?X8010000000;3j202`nPP3D?AT402`n
PP060000000/?X80;3j202`nPP3D?AT0;3j20`0000070357TP030000000aAi80<DNB00D0<DNB00D0
00000357TP0aAi80e3dI0357TP020=@m6@050000000mFJ/0?EV[0?m:7P0mFJ/00P3oBQh00`000000
odXN0?m:7P050?m:7P030000003oBQh0odXN00D0odXN0`0000000`3oB1d0?EV[0?m87@020?m87@03
0000003oB1d0odPM0080odPM00@0?EV[0?m87@3oB1d000001P3oB1d3000000@0n4DL00@0?EV[0?Q5
703hAA`000001`3hAA`00`000000jT0I0>Y06@050>Y06@80?EV[1@3Z@1T00`000000e3TF03eIZ`04
0=@i5P030000003D>AH0e3TF00<0e3TF00D000000;8^4@2b;Q40/RhA000000040;8^4@070000003D
?AT0e3dI0=@m6@3om^h0e3dI0?ofkP0203eIZ`040?ofkP0mFJ/0ooK^03eIZ`800000403om^h00`0m
FJ/0ooK^0?ofkP02000000D0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP0:0?of
kP80?EV[103om^h00`0mFJ/0ooK^0?ofkP0_0?ofkP030000003om^h0ooK^01/0ooK^0@3oool001d0
ooK^00<000000?ofkP3om^h0;`3om^h00`3D?AT0ooK^0?ofkP040?ofkP80e3dI2P3om^h00`3D?AT0
ooK^0?ofkP070?ofkP80e3dI1@3om^h00`000000ooK^0=@m6@0?0?ofkP030000003om^h0ooK^0080
e3dI0`3om^h00`0mFJ/0e3dI0=@m6@0203eIZ`030?ofkP0000002`lP00<02`lP00<0000000/?800;
3b000`00000501@J?0050000000D6S`051Xl01@J?03D?AT00`00000601dXE`030000003D?AT07BQG
00<07BQG0`00000702DdK`030000000U=6l0e3dI00D09CA_00<0000002`nPP0/?X801P0/?X801000
0000;3j202`nPP0/?X820=@m6@<0;3j200D0000002`nPP3D?AT0;3j2000000020357TP030000000a
Ai80<DNB00D0<DNB00<000000357TP0aAi801@0aAi801@000000<DNB0357TP3D?AT0<DNB00D00000
00D0odXN03eIZ`3oBQh0odXN000000070?m:7P030000003oBQh0odXN00D0odXN00D000000?m:7P3o
BQh0000003eIZ`020?m87@040000003oB1d0odPM0?m87@80?EV[0`3oB1d00`000000odPM0?m87@06
0?m87@030000003hAA`0n4DL00<0n4DL00<0?EV[0?Q5700000001`3hAA`3000000@0jT0I00<0?EV[
0000003Z@1T01@3Z@1T30000000503eIZ`3D>AH0e3TF0=@i5P0000001@3D>AH300000080/RhA00D0
00000;8^4@2b;Q40/RhA000000020?ofkP80e3dI0P0mFJ/0103D?AT0ooK^0?ofkP3om^h203eIZ`80
ooK^00<000000?ofkP3om^h03@3om^h00`0mFJ/0ooK^000000050?ofkP80?EV[2@3om^h00`0mFJ/0
ooK^0?ofkP080?ofkP80?EV[1P3om^h00`0mFJ/0ooK^0?ofkP0_0?ofkP030000003om^h0ooK^01/0
ooK^0@3oool001d0ooK^00<000000?ofkP3om^h0;`3om^h00`3D?AT0ooK^0?ofkP060?ofkP80e3dI
203om^h00`3D?AT0ooK^0?ofkP090?ofkP80e3dI103om^h00`000000e3dI0?ofkP0<0?ofkP800000
0`3om^h30=@m6@030?ofkP0mFJ/0?EV[0080?EV[0P3D?AT00`3om^h0000000/?800300/?80030000
000;3b000000008051Xl00<0000001@J?00D6S`00`0D6S`01@00000051Xl01@J?03D?AT000000080
7BQG00<0000001dXE`0M:5L0100M:5L01P0000007BQG0=@m6@3D?AT07BQG000000809CA_00<00000
02DdK`0U=6l01@0U=6l00`000000e3dI02DdK`0302DdK`<00000200/?X800`000000;3j202`nPP03
02`nPP80e3dI00D0;3j20000000/?X80e3dI000000030357TP030000000aAi80<DNB00D0<DNB00<0
00000357TP0aAi801@0aAi801@000000<DNB0=@m6@0aAi8000000080=TjP00P000000?m<7`3oC1l0
00000?m:7P0mFJ/0odXN000000H0odXN00<000000?m:7P3oBQh01P3oBQh02@000000odXN0?m:7P3o
BQh0000003eIZ`3oB1d000000?m87@0203eIZ`D0odPM00<000000?m87@3oB1d01P3oB1d3000000@0
n4DL00<0?EV[0000003hAA`01P3hAA`01@000000n4DL0?Q570000000jT0I0080?EV[00<0jT0I0000
003Z@1T01@3Z@1T01@000000jT0I0>Y06@000000?EV[0080e3TF00<000000=@i5P3D>AH00`3D>AH0
1P000000e3TF0=@i5P000000/RhA000000@0/RhA00@000000?ofkP0mFJ/0?EV[103D?AT0103om^h0
?EV[03eIZ`0mFJ/30?ofkP8000003@3om^h00`0mFJ/000000?ofkP030?ofkP80?EV[2`3om^h00`0m
FJ/0ooK^0?ofkP060?ofkP80?EV[203om^h00`0mFJ/0ooK^0?ofkP0_0?ofkP030000003om^h0ooK^
01/0ooK^0@3oool001`0ooK^00<000000?ofkP3om^h0<@3om^h00`3D?AT0ooK^0?ofkP070?ofkP80
e3dI1P3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP80e3dI0P3om^h0103D?AT0ooK^00000000000:0?of
kP030000003om^h0ooK^0080ooK^0P3D?AT0103om^h0?EV[0=@m6@3D?AT203eIZ`<0ooK^0P3D?AT3
00/?80030000000;3b000000008051Xl00<0000001@J?00D6S`00`0D6S`01@00000051Xl01@J?03D
?AT0000000<07BQG00<0000001dXE`0M:5L0100M:5L0100000007BQG01dXE`0000020=@m6@<09CA_
00<0000002DdK`0U=6l0100U=6l00`000000e3dI02DdK`0202DdK`040000000/?X80;3j2000000P0
;3j200<0000002`nPP0/?X801@0/?X830=@m6@030000000aAi80<DNB00<0<DNB00<000000357TP0a
Ai801@0aAi800`000000<DNB0357TP040357TP040000000aAi80e3dI000000<0=TjP00P000000?m<
7`3oC1l0od`O0000000mFJ/0odXN000000H0odXN00<000000?m:7P3oBQh01@3oBQh00`000000odXN
0?m:7P030?m:7P0403eIZ`000000?EV[03eIZ`L0odPM00<000000?m87@3oB1d01@3oB1d01@000000
odPM0?m87@3oB1d0000000<0n4DL00<0?EV[0000003hAA`01@3hAA`010000000n4DL0?Q5703hAA`2
03eIZ`040000003Z@1T0jT0I000000H0jT0I00H000000>Y06@3Z@1T0jT0I0000000mFJ/20=@i5P03
0000003D>AH0e3TF00<0e3TF00H000000=@i5P3D>AH000000;8^4@0000030;8^4@80?EV[0P3om^h3
0=@m6@80?EV[00@0e3dI0?ofkP0mFJ/0?EV[103om^h00`000000ooK^0?ofkP080?ofkP80000000@0
ooK^03eIZ`3om^h0ooK^0P0mFJ/=0?ofkP0303eIZ`3om^h0ooK^00@0ooK^0P0mFJ/90?ofkP0303eI
Z`3om^h0ooK^0340ooK^00<000000?ofkP3om^h06P3om^h10?ooo`00703om^h00`000000ooK^0?of
kP0a0?ofkP030=@m6@3om^h0ooK^00T0ooK^0P3D?AT40?ofkP030=@m6@3om^h0ooK^00d0ooK^0`3D
?AT30?ofkP8000001`3om^h00`000000ooK^0?ofkP020?ofkP030=@m6@3om^h0e3dI0080?EV[00@0
ooK^03eIZ`3D?AT0e3dI0`3om^h00`0000002`lP0=@m6@0200/?808000000`0D6S`00`00000051Xl
01@J?00301@J?0<0000000<0e3dI01dXE`0M:5L00P0M:5L00`0000007BQG01dXE`0401dXE`<00000
0`0U=6l0103D?AT09CA_02DdK`00000602DdK`050=@m6@0000009CA_02DdK`000000100/?X800`00
0000;3j202`nPP0502`nPP030000000/?X80;3j200H0;3j200<000000=@m6@0aAi801@0aAi800`00
0000<DNB0357TP050357TP030000000aAi80<DNB00@0<DNB00<000000=@m6@000000100fCZ000`00
0000od`O0?m<7`020?m<7`030000000mFJ/0000000H0odXN00<000000?m:7P3oBQh01@3oBQh00`00
0000odXN0?m:7P040?m:7P0303eIZ`000000odPM00L0odPM00<000000?m87@3oB1d01@3oB1d00`00
0000odPM0?m87@020?m87@050000003hAA`0n4DL0000000mFJ/01P3hAA`010000000n4DL0?Q5700m
FJ/30?Q570<000001P3Z@1T00`000000jT0I0>Y06@020>Y06@0403eIZ`0000000000000000D0e3TF
00@000000=@i5P3D>AH0e3TF0P0000020;8^4@0303eIZ`2b;Q40000000<0ooK^0P0mFJ/01`3D?AT0
ooK^0=@m6@3D?AT0?EV[0?ofkP0mFJ/0103om^h00`000000ooK^0?ofkP050?ofkP8000000`3om^h3
03eIZ`l0ooK^00<0?EV[0?ofkP3om^h00P3om^h203eIZ`/0ooK^00<0?EV[0?ofkP3om^h0<@3om^h0
0`000000ooK^0?ofkP0J0?ofkP40oooo000L0?ofkP030000003om^h0ooK^0340ooK^00<0e3dI0?of
kP3om^h02`3om^h20=@m6@80ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP030?of
kP8000000`3om^h2000000<0ooK^0P3D?AT0103om^h0e3dI03eIZ`3om^h203eIZ`030?ofkP0mFJ/0
ooK^0080e3dI00@0000000/?800;3b002`lP0P3D?AT501@J?0030000000D6S`051Xl00<051Xl00<0
000001dXE`3D?AT01@0M:5L00`0000007BQG01dXE`0401dXE`030000000U=6l09CA_00@09CA_0P3D
?AT00`0000009CA_02DdK`0302DdK`030=@m6@0U=6l0?EV[008000001@0/?X800`000000;3j202`n
PP0502`nPP030000000/?X80;3j200@0;3j20P000000103D?AT0<DNB0=@m6@3D?AT40357TP030000
000aAi80<DNB00D0<DNB00<000000357TP0aAi80100aAi800`000000e3dI03I>X00403I>X0030000
003oC1l0od`O00<0od`O00<0?EV[0000003oBQh01@3oBQh00`000000odXN0?m:7P050?m:7P030000
003oBQh0odXN0080odXN0P0mFJ/0103oBQh0?EV[0000000000060?m87@030000003oB1d0odPM00D0
odPM00<000000?m87@3oB1d00`3oB1d3000000030?Q5700mFJ/0n4DL00@0n4DL00<0000003eIZ`0m
FJ/01P3hAA`00`000000jT0I0>Y06@040>Y06@030000003Z@1T0jT0I00<0jT0I00<0?EV[0>Y06@00
00001@3D>AH00`000000e3TF0=@i5P030=@i5P80?EV[0P2b;Q401@000000ooK^03eIZ`0mFJ/0e3dI
0080ooK^0P3D?AT0103om^h0e3dI03eIZ`3om^h203eIZ`<0ooK^0P0000030?ofkP8000001@3om^h0
0`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^0080?EV[3@3om^h00`0mFJ/0ooK^0?ofkP0a
0?ofkP030000003om^h0ooK^01X0ooK^0@3oool001`0ooK^00<000000?ofkP3om^h0<@3om^h00`3D
?AT0ooK^0?ofkP0=0?ofkP<0e3dI4@3om^h30=@m6@D0ooK^0`0000040?ofkP060=@m6@3om^h0ooK^
03eIZ`3D?AT0ooK^0P0mFJ/20?ofkP0503eIZ`3om^h0ooK^03eIZ`3D?AT00P0;3b0300000080e3dI
0`0D6S`01000000051Xl01@J?00D6S`3000000030=@m6@0M:5L07BQG00@07BQG00<0000001dXE`0M
:5L00P0M:5L3000000P09CA_0P3D?AT302DdK`050=@m6@0U=6l09CA_0000000mFJ/01P0/?X800`00
0000;3j202`nPP0602`nPP030000000/?X80;3j20080;3j200@000000357TP0aAi80e3dI0`0aAi82
0=@m6@80<DNB00<000000357TP0aAi801@0aAi800`000000<DNB0357TP020357TP80000000<0e3dI
03I>X00fCZ00100fCZ000`000000od`O0?m<7`040?m<7`0303eIZ`000000000000@0odXN00<00000
0?m:7P3oBQh01@3oBQh00`000000odXN0?m:7P0203eIZ`<0odXN00@0?EV[0?m:7P3oBQh00000103o
B1d00`000000odPM0?m87@060?m87@030000003oB1d0odPM00D0odPM00@000000?Q5703hAA`0?EV[
0`3hAA`203eIZ`P0n4DL0`0000040>Y06@030000003Z@1T0jT0I00@0jT0I00@0?EV[000000000000
00000`3D>AH010000000e3TF0=@i5P3D>AH203eIZ`<000000P2b;Q401@0mFJ/0e3dI0?ofkP3om^h0
e3dI0080ooK^0P3D?AT00`3om^h0?EV[0=@m6@020?ofkP0303eIZ`3om^h0ooK^0080ooK^0`000005
0?ofkP<0?EV[4@3om^h303eIZ`l0ooK^00<0?EV[0?ofkP3om^h0<@3om^h00`000000ooK^0?ofkP0J
0?ofkP40oooo000K0?ofkP030000003om^h0ooK^0380ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D
?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^0080e3dI0`3om^h3000000<0ooK^00<0e3dI0?of
kP3om^h00P0mFJ/00`3D?AT0?EV[0?ofkP020?ofkP@0?EV[00@0000003eIZ`0;3b0000000P0D6S`0
0`00000051Xl01@J?0020=@m6@0501@J?000000051Xl01@J?00000000P0M:5L00`3D?AT07BQG01dX
E`0501dXE`050000000M:5L07BQG01dXE`0000000P0U=6l00`0000009CA_02DdK`0602DdK`060000
000U=6l0e3dI0=@m6@0U=6l0e3dI0`00000702`nPP030000000/?X80;3j200H0;3j200<0000002`n
PP0/?X800P0000020357TP030=@m6@000000<DNB00@0<DNB0P3D?AT00`000000<DNB0357TP050357
TP030000000aAi80<DNB008000000P0fCZ000`3D?AT0=TjP03I>X00403I>X0030000003oC1l0od`O
00@0od`O00<0?EV[0?m<7`3oC1l00P0000020?m:7P030000003oBQh0odXN00D0odXN00<0000003eI
Z`0mFJ/01@3oBQh010000000?EV[0?m:7P3oBQh200000080odPM00<000000?m87@3oB1d01@3oB1d0
0`000000odPM0?m87@060?m87@<0000000H0?EV[0?Q5700mFJ/0?EV[0?Q5700000080?Q570040000
003hAA`0n4DL000000<0jT0I00<000000>Y06@3Z@1T01@3Z@1T0100mFJ/0jT0I0>Y06@0000020=@i
5P040000003D>AH0?EV[03eIZ`80e3TF00D000000=@i5P3D>AH000000;8^4@050=@m6@@0ooK^00@0
e3dI03eIZ`3D?AT0e3dI0P3om^h0100mFJ/0ooK^0?ofkP3om^h3000000<0ooK^0P0mFJ/20?ofkP03
03eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP0a0?ofkP03
0000003om^h0ooK^01X0ooK^0@3oool001/0ooK^00<000000?ofkP3om^h0<P3om^h00`3D?AT0ooK^
0?ofkP0?0?ofkP<0e3dI3`3om^h00`3D?AT0ooK^0?ofkP020?ofkP80e3dI00@000000?ofkP3om^h0
ooK^0P0000000`3D?AT0ooK^0?ofkP0303eIZ`030=@m6@0mFJ/0?EV[00L0?EV[00D02`lP0000000D
6S`051Xl0000000501@J?080e3dI00H051Xl0000000M:5L07BQG0=@m6@00000701dXE`040000000M
:5L07BQG000000@09CA_00<0000002DdK`0U=6l01@0U=6l01P0000009CA_02DdK`0U=6l0e3dI0000
0080;3j200<0000002`nPP0/?X801P0/?X800`000000;3j202`nPP0502`nPP<000000`0aAi80103D
?AT0<DNB0357TP0000060357TP80e3dI1P0aAi83000000<0=TjP00<0e3dI0000000fCZ001@0fCZ00
0`000000od`O0?m<7`040?m<7`030000000mFJ/0od`O0080od`O0`0000060?m:7P80?EV[1P3oBQh0
10000000odXN0?m:7P0mFJ/30?m:7P<000001`3oB1d00`000000odPM0?m87@050?m87@060000003o
B1d0odPM0?m87@000000?EV[0`3hAA`00`000000n4DL0?Q570050?Q570030000003hAA`0n4DL0080
n4DL00@000000>Y06@3Z@1T000001`3Z@1T01P000000?EV[0>Y06@3Z@1T000000=@i5P80?EV[1@3D
>AH01@000000e3TF0=@i5P000000/RhA00T0e3dI00@0?EV[0=@m6@3D?AT0e3dI0P3om^h00`0mFJ/0
0000000000030?ofkP030000000mFJ/0?EV[00@0ooK^00<0?EV[0?ofkP3om^h03@3om^h303eIZa40
ooK^00<0?EV[0?ofkP3om^h0<P3om^h00`000000ooK^0?ofkP0I0?ofkP40oooo000K0?ofkP030000
003om^h0ooK^0380ooK^0`3D?AT?0?ofkP030=@m6@3om^h0ooK^0080e3dI3@3om^h00`3D?AT0ooK^
0?ofkP020?ofkP8000000P3D?AT30?ofkP030=@m6@000000?EV[00@0?EV[00@0e3dI0?ofkP3om^h0
ooK^0P0mFJ/00`3om^h0?EV[00000002000000<051Xl00<0000001@J?00D6S`00`0D6S`200000080
e3dI00@07BQG0=@m6@0M:5L000001`0M:5L3000000D09CA_00<0000002DdK`0U=6l01P0U=6l01000
00009CA_0=@m6@0000020=@m6@80;3j200<0000002`nPP0/?X801@0/?X800`000000;3j202`nPP05
02`nPP030000000aAi80<DNB0080<DNB00D0e3dI0357TP0aAi80<DNB000000060357TP030000000a
Ai80e3dI00D0<DNB00<0000003I>X00fCZ000`0fCZ000`3D?AT0000003I>X00503I>X0030000003o
C1l0od`O00@0od`O00<0000003eIZ`3oC1l0103oC1l00`000000odXN0?m:7P030?m:7P0303eIZ`3o
BQh0000000H0odXN00D000000?m:7P3oBQh0odXN03eIZ`040?m:7P030000003oB1d0odPM00D0odPM
00<000000?m87@3oB1d01@3oB1d00`000000odPM0?m87@0203eIZ`040000000mFJ/0n4DL000000P0
n4DL00<000000?Q5703hAA`00`3hAA`3000000L0jT0I00@000000>Y06@0mFJ/0jT0I0P0mFJ/20000
00D0e3TF00@000000=@i5P3D>AH0e3TF0P000000103om^h0e3dI0?ofkP3D?AT40?ofkP0303eIZ`3D
?AT0e3dI00<0e3dI00<0000003eIZ`3om^h00P3om^h203eIZ`800000103om^h00`0mFJ/0ooK^0?of
kP0;0?ofkP80?EV[0P3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP<0?EV[=03om^h00`000000ooK^0?of
kP0I0?ofkP40oooo000K0?ofkP030000003om^h0ooK^03<0ooK^00@0e3dI0?ofkP3D?AT0e3dI3@3o
m^h00`3D?AT0ooK^0?ofkP020?ofkP80e3dI2`3om^h01@3D?AT0ooK^0?ofkP3om^h0000000@0ooK^
0`3D?AT00`3om^h0?EV[0?ofkP0203eIZ`80ooK^00<0e3dI0?ofkP3om^h00P0mFJ/0103om^h0?EV[
0?ofkP00000501@J?0030000000D6S`051Xl00<051Xl00D0000001dXE`0M:5L07BQG0=@m6@0201dX
E`030000000M:5L07BQG00D07BQG00<0000002DdK`0U=6l01@0U=6l00`0000009CA_02DdK`0602Dd
K`030000003D?AT0000000<0;3j20P3D?AT00`000000;3j202`nPP0502`nPP030000000/?X80;3j2
00<0;3j20`0000040357TP050=@m6@0aAi80<DNB0357TP0000001`0aAi801@000000<DNB0=@m6@3D
?AT0<DNB00<00000100fCZ000`3D?AT0=TjP0000000603I>X0030000003oC1l0od`O00@0od`O00<0
00000?m<7`0mFJ/0103oC1l3000000050?m:7P0mFJ/0?EV[0?m:7P0000001`3oBQh01@000000odXN
0?m:7P3oBQh0?EV[00@0odXN0`0000050?m87@030000003oB1d0odPM00D0odPM00<0000003eIZ`0m
FJ/00`3oB1d00`000000?EV[000000080?Q570030000003hAA`0n4DL00D0n4DL00<000000>Y06@3Z
@1T0103Z@1T01@000000jT0I0>Y06@3Z@1T0?EV[0080jT0I00<0e3dI0000003D>AH0103D>AH00`00
0000e3TF0=@i5P030=@i5P040000003om^h0e3dI0?ofkP80e3dI0P3om^h00`0mFJ/0ooK^0?ofkP02
0=@m6@030?ofkP3D?AT0ooK^00<0?EV[103om^h01@000000ooK^0?ofkP3om^h0?EV[00/0ooK^0P0m
FJ/40?ofkP0303eIZ`3om^h0ooK^00/0ooK^0P0mFJ/00`3om^h0?EV[0?ofkP0d0?ofkP030000003o
m^h0ooK^01T0ooK^0@3oool001/0ooK^00<000000?ofkP3om^h0<`3om^h0103D?AT0ooK^0?ofkP3o
m^h20=@m6@/0ooK^00<0e3dI0?ofkP3om^h0103om^h20=@m6@T0ooK^00@0e3dI0?ofkP3om^h00000
1@3om^h50=@m6@0503eIZ`3om^h0ooK^0000003D?AT00P3om^h403eIZ`80ooK^00<0000001@J?00D
6S`00`0D6S`01000000051Xl01@J?00D6S`3000000807BQG00H0e3dI01dXE`3D?AT0e3dI01dXE`00
000401dXE`<000001`0U=6l00`0000009CA_02DdK`0602DdK`030=@m6@0/?X80;3j200D0;3j20P3D
?AT602`nPP040000000/?X80;3j202`nPP8000000`0aAi8010000000<DNB0357TP3D?AT40357TP03
0000000aAi80<DNB00D0<DNB00@000000357TP0aAi8000000P3D?AT00`0fCZ00000003I>X00303I>
X0030=@m6@0fCZ00000000H0=TjP00<000000?m<7`3oC1l0103oC1l00`000000od`O03eIZ`040?m<
7`050000003oC1l0?EV[03eIZ`0000000P3oBQh00`000000odXN0?m:7P050?m:7P030000003oBQh0
odXN0080odXN00@0?EV[0?m:7P3oBQh000000`3oBQh200000080odPM00<000000?m87@3oB1d01@3o
B1d203eIZ`L0odPM00<0?EV[0?Q5703hAA`01P3hAA`00`000000n4DL0?Q570050?Q570<00000103Z
@1T01P000000jT0I03eIZ`0mFJ/0jT0I03eIZ`80jT0I0`0000030=@i5P030000003D>AH0e3TF00<0
e3TF00<000000?ofkP3om^h00P3D?AT01P3om^h0e3dI0?ofkP3om^h0?EV[00000080ooK^00<0e3dI
03eIZ`0mFJ/00`0mFJ/50?ofkP040000003om^h0ooK^03eIZ`T0ooK^0P0mFJ/60?ofkP0303eIZ`3o
m^h0ooK^00T0ooK^0P0mFJ/30?ofkP0303eIZ`3om^h0ooK^03<0ooK^00<000000?ofkP3om^h06@3o
m^h10?ooo`006P3om^h00`000000ooK^0?ofkP0d0?ofkP030=@m6@3om^h0ooK^00<0ooK^0P3D?AT9
0?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0000000000005
0?ofkP030=@m6@3om^h0?EV[0080?EV[0`3D?AT20?ofkP050=@m6@0mFJ/0?EV[0?ofkP0mFJ/0103o
m^h00`00000051Xl01@J?00201@J?0030000000D6S`051Xl008000000P0M:5L00`0000007BQG0=@m
6@0401dXE`80e3dI0`0M:5L0100000009CA_02DdK`00000702DdK`030000000U=6l09CA_00@09CA_
0P0000000`3D?AT0;3j202`nPP0502`nPP030000000/?X80e3dI00H0;3j20`0000050357TP030000
000aAi80e3dI00D0<DNB00<000000357TP0aAi801@0aAi83000000<0=TjP0P3D?AT303I>X0040=@m
6@0fCZ00=TjP000000H0=TjP00<000000?m<7`3oC1l0103oC1l010000000od`O0?m<7`0mFJ/30?m<
7`80?EV[0`3oC1l3000000L0odXN00<000000?m:7P3oBQh00`3oBQh00`0mFJ/0odXN000000050?m:
7P<000001P3oB1d00`0mFJ/000000?m87@070?m87@0303eIZ`000000000000H0n4DL00<000000?Q5
703hAA`01@3hAA`010000000n4DL0?Q5700000030>Y06@80?EV[103Z@1T00`0mFJ/0jT0I00000002
0>Y06@8000000P3D>AH00`000000e3TF0=@i5P020=@i5P030000003om^h0ooK^0080ooK^00D0e3dI
0?ofkP3D?AT0e3dI03eIZ`020?ofkP<0?EV[0`3D?AT00`3om^h0?EV[0?ofkP040?ofkP80000000<0
?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00L0ooK^0P0m
FJ/40?ofkP0303eIZ`3om^h0ooK^03D0ooK^00<000000?ofkP3om^h0603om^h10?ooo`006P3om^h0
0`000000ooK^0?ofkP0e0?ofkP030=@m6@3om^h0ooK^00@0ooK^0P3D?AT80?ofkP030=@m6@3om^h0
ooK^00H0ooK^0P3D?AT60?ofkP030000003om^h0ooK^00<0ooK^0P3D?AT00`3om^h0?EV[03eIZ`03
03eIZ`030?ofkP3D?AT0e3dI0080e3dI00@0ooK^03eIZ`0mFJ/0?EV[0`3om^h00`00000051Xl01@J
?00301@J?0<00000100M:5L00`000000e3dI01dXE`0501dXE`040000003D?AT0e3dI000000@09CA_
00<0000002DdK`0U=6l0100U=6l00`0000009CA_02DdK`0302DdK`050000000/?X80e3dI02`nPP00
00001`0/?X8010000000;3j20=@m6@3D?AT402`nPP030000000aAi80<DNB00D0<DNB00<000000=@m
6@0aAi801@0aAi800`000000<DNB0357TP050357TP030000000fCZ00=TjP00D0=TjP0P3D?AT00`0f
CZ00e3dI03I>X00203I>X0030000000fCZ00=TjP00<0=TjP00<000000?m<7`3oC1l00`3oC1l01P00
0000od`O0?m<7`3oC1l0?EV[0?m<7`80?EV[1`3oC1l00`000000odXN0?m:7P050?m:7P030000003o
BQh0odXN00@0odXN00<0?EV[0000003oBQh01P3oBQh00`000000odPM0?m87@020?m87@80?EV[00<0
odPM0000003oB1d01P3oB1d01@000000odPM03eIZ`3oB1d0000000D0n4DL00<000000?Q5703hAA`0
103hAA`00`000000n4DL0?Q570020?Q570040000000mFJ/0?EV[000000H0jT0I00<0?EV[0000003Z
@1T00`3Z@1T3000000D0e3TF00@000000?ofkP3om^h0ooK^0`3D?AT00`3om^h0?EV[03eIZ`0203eI
Z`030?ofkP3D?AT0e3dI00<0e3dI00<0ooK^03eIZ`0mFJ/01@3om^h00`000000ooK^0?ofkP040?of
kP80?EV[203om^h00`0mFJ/0ooK^0?ofkP060?ofkP80?EV[1P3om^h00`0mFJ/0ooK^0?ofkP0e0?of
kP030000003om^h0ooK^01P0ooK^0@3oool001X0ooK^00<000000?ofkP3om^h0=@3om^h00`3D?AT0
ooK^0?ofkP060?ofkP80e3dI1P3om^h00`3D?AT0ooK^0?ofkP080?ofkP80e3dI0P3om^h200000003
0=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP0mFJ/00`0mFJ/00`3om^h0?EV[0?ofkP020?ofkP04
03eIZ`3D?AT0e3dI0=@m6@80ooK^00D0?EV[0000003om^h0ooK^0000000501@J?0030000000M:5L0
7BQG00@07BQG00<0e3dI01dXE`0M:5L01@0M:5L300000080e3dI0`0U=6l00`0000009CA_02DdK`05
02DdK`030000000U=6l09CA_0080000000D0;3j20=@m6@0/?X80;3j20000000702`nPP040000000/
?X80;3j202`nPP80e3dI0`0000080357TP030=@m6@0aAi80<DNB00D0<DNB00<000000357TP0aAi80
0P0aAi83000000L0=TjP00<0000003I>X03D?AT0100fCZ000`000000=TjP03I>X00303I>X0030000
003oC1l0od`O00<0od`O00<000000?m<7`3oC1l00P3oC1l00`0mFJ/0od`O000000070?m<7`<00000
103oBQh00`000000odXN0?m:7P050?m:7P0303eIZ`3oBQh0odXN00H0odXN0`00000203eIZ`<0odPM
00<000000?m87@3oB1d01@3oB1d01@000000odPM0?m87@0mFJ/0odPM008000000P3hAA`00`000000
n4DL0?Q570050?Q570040000003hAA`0n4DL0?Q57080?EV[0`0000070>Y06@0303eIZ`3Z@1T0jT0I
00@0jT0I00<000000=@i5P3D>AH00`3D>AH01@000000ooK^0?ofkP000000e3dI0080ooK^0`0mFJ/0
103D?AT0ooK^0?ofkP3D?AT20?ofkP@0e3dI00<0ooK^03eIZ`3om^h00`3om^h00`0mFJ/000000000
00020?ofkP80?EV[2P3om^h00`0mFJ/0ooK^0?ofkP040?ofkP80?EV[203om^h00`0mFJ/0ooK^0?of
kP0e0?ofkP030000003om^h0ooK^01P0ooK^0@3oool001X0ooK^00<000000?ofkP3om^h0=P3om^h0
0`3D?AT0ooK^0?ofkP070?ofkP80e3dI103om^h00`3D?AT0ooK^0?ofkP0:0?ofkP050=@m6@000000
ooK^0?ofkP3D?AT00P3om^h20=@m6@D0?EV[0P3om^h603eIZ`<0e3dI00<0?EV[0?ofkP3om^h00`00
000301@J?0<000001@0M:5L00`3D?AT0000001dXE`0601dXE`030000000U=6l09CA_00809CA_00@0
e3dI02DdK`0U=6l000001`0U=6l00`0mFJ/000000000000202`nPP050=@m6@0/?X80;3j202`nPP00
00001`0/?X800`000000;3j202`nPP0202`nPP050000003D?AT0<DNB0357TP0000001P0aAi800`3D
?AT000000357TP060357TP030000000aAi80<DNB008000000P0fCZ000`000000=TjP03I>X00503I>
X0030000003D?AT0=TjP0080e3dI0P0fCZ000`000000=TjP03I>X00303I>X0030000003oC1l0od`O
00<0od`O00<000000?m<7`3oC1l00P0mFJ/00`3oC1l0?EV[000000070?m<7`030000003oC1l0od`O
008000000P3oBQh00`000000odXN0?m:7P050?m:7P030000000mFJ/0odXN00D0odXN00D000000?m:
7P3oBQh0?EV[000000040?m87@030000003oB1d0odPM00D0odPM00D000000?m87@3oB1d0odPM03eI
Z`020?m87@<000001`3hAA`010000000n4DL0?Q5700mFJ/40?Q570030000003Z@1T0jT0I00D0jT0I
00<0000003eIZ`3Z@1T0103Z@1T3000000<0e3TF0`0000000`3om^h0e3dI0?ofkP0303eIZ`H0e3dI
0P3om^h50=@m6@80?EV[0P3om^h01@0mFJ/0ooK^0?ofkP000000?EV[00`0ooK^00<0?EV[0?ofkP3o
m^h00P3om^h203eIZ`T0ooK^00<0?EV[0?ofkP3om^h0=P3om^h00`000000ooK^0?ofkP0H0?ofkP40
oooo000J0?ofkP030000003om^h0ooK^03H0ooK^00<0e3dI0?ofkP3om^h02@3om^h20=@m6@80ooK^
00<0e3dI0?ofkP3om^h02@3om^h2000000090?ofkP3D?AT0e3dI0=@m6@3om^h0e3dI0?ofkP0mFJ/0
ooK^00L0?EV[0`3om^h01@0mFJ/0ooK^0=@m6@3om^h0?EV[0080e3dI0`0mFJ/01000000051Xl01@J
?000000201dXE`040000000M:5L07BQG01dXE`80e3dI00<07BQG0000000M:5L0100M:5L3000000D0
9CA_0P3D?AT00`0000009CA_02DdK`0502DdK`050000000/?X80;3j202`nPP3D?AT0100/?X800`00
0000;3j202`nPP0502`nPP050000000/?X80;3j202`nPP0000000P0aAi820=@m6@030000000aAi80
<DNB00<0<DNB00<0e3dI0357TP0000001`0aAi83000000D0=TjP00<0000003I>X00fCZ00100fCZ00
0`000000e3dI03I>X00203I>X0030=@m6@0fCZ00000000D0=TjP00<000000?m<7`3oC1l00`3oC1l0
0`000000od`O03eIZ`030?m<7`0303eIZ`000000od`O00D0od`O00<000000?m<7`3oC1l00`3oC1l3
000000L0odXN00<000000?m:7P0mFJ/01@3oBQh00`000000?EV[03eIZ`020?m:7P040000003oB1d0
odPM000000P0odPM00<000000?m87@3oB1d00P3oB1d01@0mFJ/0odPM0?m87@3oB1d0000000L0n4DL
00<0000003eIZ`0mFJ/01@3hAA`3000000D0jT0I00@000000>Y06@0mFJ/0?EV[0`3Z@1T010000000
jT0I0>Y06@0000020=@i5P040000003D?AT0e3dI0=@m6@80?EV[00D0e3dI0?ofkP0mFJ/0ooK^0=@m
6@030?ofkPL0e3dI00D0ooK^0=@m6@3om^h0?EV[0?ofkP0303eIZ`030?ofkP000000000000/0ooK^
00<0?EV[0?ofkP3om^h00P0mFJ/;0?ofkP0303eIZ`3om^h0ooK^03H0ooK^00<000000?ofkP3om^h0
603om^h10?ooo`006@3om^h00`000000ooK^0?ofkP0h0?ofkP80e3dI2`3om^h30=@m6@X0ooK^00<0
00000?ofkP3om^h00`3om^h20=@m6@H0?EV[0`3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[0080ooK^
00@0e3dI0?ofkP3om^h0?EV[0`3D?AT01000000051Xl01@J?000000301dXE`040000000M:5L07BQG
0=@m6@<07BQG00@0000001dXE`0M:5L07BQG0P00000202DdK`030000000U=6l09CA_00D09CA_0P3D
?AT402DdK`<000000P0/?X800`3D?AT0;3j202`nPP0402`nPP030000000/?X80;3j200D0;3j200<0
?EV[0000000000001@0aAi820=@m6@<0<DNB00D0e3dI0357TP0aAi80<DNB000000060357TP030000
000fCZ00=TjP00D0=TjP00<0000003I>X00fCZ00100fCZ000`3D?AT0=TjP03I>X00303I>X0030=@m
6@000000=TjP0080=TjP1@0000030?m<7`030000000mFJ/0od`O00@0od`O00<0?EV[0?m<7`3oC1l0
103oC1l00`000000od`O0?m<7`050?m<7`030000003oBQh0odXN00@0odXN00D000000?m:7P3oBQh0
odXN03eIZ`030?m:7P80?EV[1@3oBQh3000000L0odPM00<000000?m87@3oB1d0103oB1d00`0mFJ/0
odPM0?m87@03000000@0n4DL0P0mFJ/70?Q570030000003hAA`0n4DL008000000`3Z@1T01@000000
jT0I0>Y06@3Z@1T0?EV[0080jT0I00D000000>Y06@3Z@1T0jT0I000000020=@i5P050000000mFJ/0
?EV[03eIZ`3D?AT00P3om^h0100mFJ/0ooK^0?ofkP3D?AT30?ofkP040=@m6@3om^h0ooK^0?ofkPH0
e3dI0P0mFJ/50?ofkP030000003om^h0ooK^00P0ooK^0`0mFJ/;0?ofkP80?EV[>P3om^h00`000000
ooK^0?ofkP0G0?ofkP40oooo000I0?ofkP030000003om^h0ooK^03T0ooK^0`3D?AT;0?ofkP030=@m
6@3om^h0ooK^00L0ooK^00<000000?ofkP3om^h00`3om^h40=@m6@<0?EV[103om^h00`0mFJ/0ooK^
0?ofkP0203eIZ`<0ooK^00@0e3dI0?ofkP3om^h0?EV[0P3om^h30=@m6@030000000M:5L07BQG0080
7BQG00<0000001dXE`3D?AT0100M:5L0100000007BQG00000000000502DdK`030000000U=6l09CA_
00D09CA_00<000000=@m6@3D?AT00P00000302`nPP030000000/?X80e3dI00H0;3j200<0000002`n
PP0/?X801@0/?X800`000000<DNB0357TP060357TP050000003D?AT0e3dI0357TP3D?AT00`0aAi80
0`000000<DNB0357TP020357TP<000001`0fCZ000`000000=TjP03I>X00303I>X0030=@m6@000000
=TjP00D0=TjP0P3D?AT01@0fCZ00000003YE[00jEJ`000000080oddP00@000000?m<7`0mFJ/0?EV[
1P3oC1l00`000000?EV[0?m<7`040?m<7`030000003oC1l0od`O00D0od`O0`0000040?m:7P060000
003oBQh0odXN0?m:7P0mFJ/0odXN0P0mFJ/00`000000odXN0?m:7P060?m:7P030000003oB1d0odPM
00D0odPM00<000000?m87@3oB1d0103oB1d00`0mFJ/0odPM000000030?m87@8000000P0mFJ/00`00
0000n4DL0?Q570050?Q570030000003hAA`0n4DL00<0n4DL0P0000000`3Z@1T000000>Y06@030>Y0
6@0303eIZ`3Z@1T0000000@0jT0I00@0000003eIZ`0mFJ/0?EV[0P3om^h0103D?AT0ooK^0?ofkP0m
FJ/30?ofkP80e3dI00<0ooK^0=@m6@3om^h0103om^h30=@m6@@0?EV[1@3om^h00`000000ooK^0?of
kP070?ofkP0303eIZ`3om^h0ooK^00T0ooK^0`0mFJ/k0?ofkP030000003om^h0ooK^01L0ooK^0@3o
ool001T0ooK^00<000000?ofkP3om^h0>@3om^h00`3D?AT0ooK^0?ofkP020=@m6@T0ooK^0`3D?AT5
0?ofkP800000103om^h20=@m6@0403eIZ`3D?AT0e3dI0?ofkP80e3dI1@3om^h00`0mFJ/0ooK^03eI
Z`050?ofkP040=@m6@3om^h0ooK^03eIZ`<0ooK^00@000000=@m6@3D?AT0e3dI0`0M:5L00`000000
e3dI01dXE`0401dXE`8000001`0U=6l00`0000009CA_02DdK`0502DdK`<000000P3D?AT302`nPP03
0000003D?AT0;3j200H0;3j200<0000002`nPP0/?X800`0/?X83000000P0<DNB00@000000357TP0a
Ai80e3dI100aAi801@000000<DNB0357TP0aAi80000000<0=TjP00<0000003I>X00fCZ00100fCZ00
0`000000=TjP03I>X00203I>X0030=@m6@0fCZ00000000H0=TjP0P0000001@3D?AT0>UF/03YE[00j
EJ`0000000<0oddP00<0?EV[0000000000001P3oC1l00`000000od`O03eIZ`040?m<7`030000003o
C1l0od`O00@0od`O00D000000?m<7`3oC1l0od`O000000030?m:7P030000003oBQh0odXN0080odXN
00@0?EV[0?m:7P3oBQh00000203oBQh3000000D0odPM00<000000?m87@3oB1d01@3oB1d00`0mFJ/0
00000?m87@020?m87@80?EV[0`0000070?Q570030000003hAA`0n4DL00D0n4DL0P0000050>Y06@03
03eIZ`000000jT0I0080jT0I0`0mFJ/01@000000ooK^0?ofkP3om^h0e3dI0080ooK^00<0?EV[0?of
kP3om^h00`3om^h00`3D?AT0ooK^0=@m6@050?ofkP80?EV[00@0ooK^03eIZ`0mFJ/0e3dI0P0mFJ/4
0?ofkP8000001@3om^h303eIZ`T0ooK^0P0mFJ/00`3om^h0?EV[0?ofkP0k0?ofkP030000003om^h0
ooK^01L0ooK^0@3oool001T0ooK^00<000000?ofkP3om^h0>P3om^h0103D?AT0ooK^0?ofkP3om^h2
0=@m6@P0ooK^00@0e3dI0?ofkP3D?AT0e3dI0P3om^h00`000000ooK^0?ofkP020?ofkP80e3dI0`0m
FJ/01@3D?AT0ooK^0=@m6@3D?AT0ooK^0080e3dI0P3om^h303eIZ`D0ooK^00D0e3dI0?ofkP3om^h0
ooK^03eIZ`030?ofkP040000000M:5L07BQG01dXE`80e3dI00<07BQG0=@m6@0M:5L00`0M:5L30000
00P09CA_00<0000002DdK`0U=6l01@0U=6l00`000000;3j202`nPP0202`nPP80e3dI00<0;3j20=@m
6@0/?X801`0/?X8010000000;3j202`nPP0/?X82000000<0<DNB00<000000357TP0aAi801@0aAi80
10000000<DNB0=@m6@0aAi820=@m6@<0<DNB0`00000403I>X0030000000fCZ00=TjP00@0=TjP00<0
000003I>X00fCZ000P0fCZ00103D?AT0=TjP03I>X000000503I>X0030000000jEJ`0>UF/0080e3dI
00<0>UF/0000003oCB000P0mFJ/20?m=80030000003oC1l0od`O00<0od`O00@000000?m<7`3oC1l0
?EV[0`3oC1l00`000000od`O0?m<7`050?m<7`030000003oC1l0od`O0080od`O0`0000030?m:7P80
?EV[00@0odXN03eIZ`3oBQh000001`3oBQh010000000odXN0?m:7P3oBQh2000000<0odPM00<00000
0?m87@3oB1d01P3oB1d0100mFJ/0odPM03eIZ`0mFJ/40?m87@030000003hAA`0n4DL00D0n4DL00<0
00000?Q5703hAA`01P3hAA`3000000@0jT0I00@0?EV[0>Y06@0mFJ/0?EV[0`3Z@1T01@000000ooK^
0?ofkP3om^h0e3dI0080ooK^00<0?EV[0?ofkP3om^h0103om^h20=@m6@<0ooK^0P0mFJ/01@3om^h0
?EV[03eIZ`3om^h0?EV[00<0e3dI0P0mFJ/40?ofkP030000003om^h0ooK^0080?EV[00<0ooK^03eI
Z`3om^h01`3om^h203eIZ`<0ooK^00<0?EV[0?ofkP3om^h0>P3om^h00`000000ooK^0?ofkP0G0?of
kP40oooo000H0?ofkP030000003om^h0ooK^03`0ooK^00<0e3dI0?ofkP3om^h00P3om^h20=@m6@H0
ooK^00@0e3dI0?ofkP3om^h0ooK^0P0000030?ofkP80e3dI00<0ooK^03eIZ`0mFJ/00P3om^h0103D
?AT0?EV[0?ofkP3om^h20=@m6@040?ofkP3D?AT0e3dI03eIZ`L0ooK^00@0e3dI0?ofkP3om^h0?EV[
0`3om^h00`0mFJ/0000001dXE`0201dXE`040=@m6@0M:5L0e3dI000000<07BQG00D0000002DdK`0U
=6l09CA_0000000702DdK`030000000U=6l09CA_00<09CA_0`00000602`nPP030=@m6@0/?X800000
00P0;3j20`0000050357TP030000000aAi80<DNB00H0<DNB00<0e3dI0357TP0aAi800P0aAi820=@m
6@030357TP000000=TjP00D0=TjP00<0000003I>X00fCZ001@0fCZ0010000000=TjP03I>X03D?AT3
03I>X0040000000fCZ00=TjP03I>X0<00000100jEJ`00`3D?AT0000003eIZ`040?m=80<000000`3o
C1l01@000000od`O0?m<7`3oC1l0?EV[0080od`O00<000000?m<7`3oC1l01@3oC1l00`000000od`O
0?m<7`040?m<7`040000003oBQh0?EV[03eIZ`@0odXN00<0?EV[0?m:7P3oBQh01P3oBQh00`000000
odXN0?m:7P030?m:7P<00000203oB1d00`000000odPM03eIZ`060?m87@<000001@3hAA`00`000000
n4DL0?Q570050?Q570050000003hAA`0n4DL0?Q5700000000`3Z@1T00`000000?EV[0>Y06@040>Y0
6@050000003D?AT0ooK^0?ofkP3D?AT00`3om^h00`0mFJ/0ooK^0?ofkP050?ofkP040=@m6@0mFJ/0
?EV[0?ofkP80?EV[0P3om^h0103D?AT0?EV[0?ofkP3om^h20=@m6@030?ofkP0mFJ/0?EV[00<0ooK^
0P0000030?ofkP0303eIZ`3om^h0ooK^00@0ooK^0P0mFJ/40?ofkP0303eIZ`3om^h0ooK^03`0ooK^
00<000000?ofkP3om^h05P3om^h10?ooo`00603om^h00`000000ooK^0?ofkP0m0?ofkP80e3dI103o
m^h20=@m6@@0ooK^00@0e3dI0?ofkP3om^h000000P3om^h30=@m6@80ooK^00<0?EV[0?ofkP3om^h0
0P0mFJ/00`3D?AT0?EV[0?ofkP030?ofkP80e3dI00<0?EV[0=@m6@3D?AT01P3om^h01@3D?AT0ooK^
0?ofkP0mFJ/0ooK^0080?EV[00<0ooK^0000000M:5L00P0M:5L20=@m6@0501dXE`3D?AT0e3dI01dX
E`000000100U=6l00`0000009CA_02DdK`0502DdK`030000000U=6l09CA_00809CA_00D0000002`n
PP0/?X80;3j20000000402`nPP040=@m6@0/?X80e3dI0=@m6@P0;3j200<000000357TP0aAi801P0a
Ai800`000000<DNB0357TP040357TP030=@m6@000000<DNB00@0<DNB00<000000=@m6@3D?AT01P0f
CZ000`000000=TjP03I>X00503I>X0030000000fCZ00e3dI00@0=TjP00@0000003I>X00000000000
0P0jEJ`00`000000>UF/03YE[00303YE[0030000003oCB00oddP00<0oddP00<000000?m=803oCB00
0P0000000`3oC1l000000?m<7`030?m<7`0303eIZ`3oC1l0000000L0od`O00<000000?m<7`3oC1l0
103oC1l203eIZ`030000003oBQh0odXN00<0odXN00<0000003eIZ`3oBQh01@3oBQh00`000000odXN
0?m:7P060?m:7P030000003oB1d0odPM00H0odPM0P0mFJ/00`3oB1d0?EV[0?m87@030?m87@050000
003oB1d0odPM0?m87@000000103hAA`00`000000n4DL0?Q570050?Q570030000003hAA`0n4DL0080
n4DL00D000000>Y06@0mFJ/0?EV[0>Y06@0203eIZ`<0jT0I00<000000?ofkP3D?AT00P3om^h0103D
?AT0ooK^0?ofkP0mFJ/60?ofkP80?EV[00<0e3dI03eIZ`0mFJ/0103om^h0100mFJ/0ooK^0=@m6@3D
?AT20?ofkP030=@m6@3om^h0ooK^00<0?EV[0P3om^h00`000000ooK^03eIZ`050?ofkP80?EV[103o
m^h203eIZcl0ooK^00<000000?ofkP3om^h05P3om^h10?ooo`00603om^h00`000000ooK^0?ofkP0n
0?ofkPD0e3dI0P3om^h20=@m6@<0ooK^0P0000040=@m6@040?ofkP3D?AT0e3dI03eIZ`80ooK^00D0
?EV[0?ofkP3om^h0?EV[0=@m6@030?ofkP80?EV[00@0ooK^0=@m6@3D?AT0ooK^0P3D?AT40?ofkP03
0=@m6@3om^h0ooK^0080?EV[0`3om^h0100000007BQG01dXE`3D?AT301dXE`8000000P3D?AT402Dd
K`030000000U=6l09CA_00H09CA_00@0000002DdK`0U=6l00000100/?X801@000000;3j202`nPP0/
?X80e3dI00@0;3j20P3D?AT402`nPP<00000200aAi800`000000<DNB0357TP040357TP030=@m6@00
0000<DNB0080<DNB0P00000303I>X080e3dI1@0fCZ000`000000=TjP03I>X00403I>X0030000003D
?AT0=TjP00@0=TjP0P00000403YE[0030000000jEJ`0>UF/00<0>UF/00<000000?m=803oCB000`3o
CB000`000000oddP0?m=80020?m=808000001@3oC1l00`0mFJ/000000?m<7`050?m<7`030000003o
C1l0od`O00<0od`O0P0mFJ/30?m<7`8000000`3oBQh00`000000?EV[0?m:7P050?m:7P030000003o
BQh0odXN00H0odXN0`0000040?m87@80?EV[103oB1d01@0mFJ/0odPM0?m87@3oB1d0000000@0odPM
00@000000?Q5703hAA`00000203hAA`00`000000n4DL0?Q570020?Q57080?EV[0P0000030>Y06@04
03eIZ`3Z@1T0jT0I00000080ooK^0`3D?AT20?ofkP0303eIZ`3om^h0ooK^0080ooK^0P0mFJ/0103o
m^h0?EV[03eIZ`3om^h20=@m6@<0ooK^00D0?EV[0=@m6@3om^h0ooK^0=@m6@020?ofkP040=@m6@0m
FJ/0?EV[0?ofkP@0?EV[0P0000030?ofkP80?EV[0P3om^h503eIZd00ooK^00<000000?ofkP3om^h0
5P3om^h10?ooo`00603om^h00`000000ooK^0?ofkP100?ofkP80e3dI00<0ooK^0=@m6@3D?AT0103D
?AT00`000000e3dI0?ofkP030?ofkP80e3dI00D0ooK^03eIZ`3D?AT0e3dI03eIZ`020?ofkP0303eI
Z`3om^h0e3dI0080ooK^00H0?EV[0?ofkP3om^h0ooK^03eIZ`3om^h20=@m6@030?ofkP3D?AT0e3dI
0080ooK^00@0e3dI0?ofkP3om^h0?EV[103om^h00`0000007BQG0=@m6@0401dXE`040000000U=6l0
9CA_02DdK`80e3dI0P0U=6l00`0000009CA_02DdK`0602DdK`<000001@0/?X8010000000;3j202`n
PP3D?AT502`nPP060000000/?X80e3dI0=@m6@0/?X8000000`0aAi800`000000<DNB0357TP060357
TP030000000aAi80<DNB0080<DNB00<0e3dI0357TP0aAi800`00000503I>X0030000000fCZ00e3dI
00@0=TjP00<0000003I>X00fCZ00100fCZ000`000000e3dI03I>X00203I>X0<000001@0jEJ`00`00
0000>UF/03YE[00303YE[0030000003oCB00oddP00<0oddP00<000000?m=803oCB000`3oCB030000
00<0od`O00<0?EV[0000003oC1l01@3oC1l00`000000od`O0?m<7`020?m<7`0303eIZ`3oC1l00000
00D0od`O0`0000020?m:7P0303eIZ`3oBQh0odXN0080odXN00<000000?m:7P3oBQh01P3oBQh01P00
0000odXN0?m:7P3oBQh000000?m87@80?EV[00<0odPM0000003oB1d0103oB1d0100mFJ/0odPM0?m8
7@0000050?m87@<000001`3hAA`010000000n4DL0?Q5703hAA`203eIZ`<0n4DL00<000000>Y06@3Z
@1T00P3Z@1T00`0mFJ/000000?ofkP040?ofkP040=@m6@3om^h0ooK^03eIZ`80ooK^0P0mFJ/01@3o
m^h0?EV[03eIZ`3om^h0e3dI00<0ooK^00H0e3dI0?ofkP3om^h0?EV[0?ofkP3D?AT20?ofkP050=@m
6@0mFJ/0?EV[0=@m6@3om^h00P0mFJ/40?ofkP0303eIZ`000000?EV[00D0?EV[00<0ooK^03eIZ`0m
FJ/0@P3om^h00`000000ooK^0?ofkP0F0?ofkP40oooo000H0?ofkP030000003om^h0ooK^0480ooK^
0P3D?AT20?ofkP80e3dI00@000000=@m6@3D?AT0e3dI1@3om^h20=@m6@0803eIZ`3om^h0e3dI0=@m
6@3om^h0?EV[0?ofkP3D?AT203eIZ`@0ooK^00@0?EV[0?ofkP3om^h0ooK^0P3D?AT0103om^h0e3dI
0=@m6@3D?AT303eIZ`@0ooK^0P3D?AT401dXE`8000001@0U=6l20=@m6@0302DdK`0000009CA_00H0
9CA_00<0000002`nPP0/?X801P0/?X800`000000e3dI02`nPP0502`nPP050000000/?X80;3j202`n
PP3D?AT0100aAi800`000000<DNB0357TP060357TP050000000aAi80<DNB0357TP3D?AT00`0aAi80
0`000000=TjP03I>X00503I>X0030000000fCZ00=TjP0080e3dI0P0fCZ000`000000=TjP03I>X004
03I>X0050=@m6@000000=TjP03I>X00000000P0jEJ`00`000000>UF/03YE[00303YE[0030000000j
EJ`0>UF/00<0>UF/00<000000?m=803oCB000`3oCB000`000000oddP0?m=80030?m=80040000003o
CB00oddP00000080od`O00<0000003eIZ`3oC1l01@3oC1l00`000000od`O0?m<7`0203eIZ`80od`O
00<000000?m<7`3oC1l01@3oC1l01@000000odXN0?m:7P3oBQh0?EV[00<0odXN00<000000?m:7P3o
BQh01P3oBQh00`000000odXN0?m:7P020?m:7P0503eIZ`3oB1d0odPM0?m87@0000001P3oB1d00`0m
FJ/000000?m87@070?m87@030000003hAA`0n4DL00D0n4DL00@000000?Q5700mFJ/0?EV[1@3hAA`2
000000@0jT0I0P0mFJ/40?ofkP<0e3dI0`0mFJ/00`3om^h0?EV[03eIZ`030?ofkP030=@m6@3om^h0
ooK^0080ooK^0P3D?AT0100mFJ/0ooK^0=@m6@3om^h203eIZ`040?ofkP3D?AT0?EV[03eIZ`D0ooK^
0`0mFJ/00`000000?EV[03eIZ`020?ofkP80?EV[A03om^h00`000000ooK^0?ofkP0F0?ofkP40oooo
000G0?ofkP030000003om^h0ooK^04D0ooK^0P3D?AT200000080e3dI00<0ooK^0=@m6@3om^h00`3o
m^h303eIZ`80e3dI0P3om^h20=@m6@030?ofkP3D?AT0ooK^00D0ooK^00<0?EV[0?ofkP3om^h00`3o
m^h20=@m6@0503eIZ`3D?AT0ooK^0?ofkP0mFJ/00`3om^h00`3D?AT0ooK^0000000301dXE`040000
000U=6l09CA_000000H09CA_00<0e3dI0000000U=6l0100U=6l3000000P0;3j200<0e3dI02`nPP0/
?X801P0/?X83000000030357TP3D?AT0e3dI00<0<DNB00<000000357TP0aAi801P0aAi800`000000
<DNB0=@m6@020357TP<00000200fCZ0010000000=TjP03I>X00fCZ020=@m6@0303I>X0000000=TjP
00<0=TjP00<0e3dI03I>X00000000P00000303YE[0030000000jEJ`0>UF/00<0>UF/00<0000003YE
[00jEJ`00`0jEJ`00`000000oddP0?m=80030?m=80030000003oCB00oddP00<0oddP00@000000?m=
803oCB00oddP0`0000000`3oC1l0?EV[0?m<7`030?m<7`040000003oC1l0?EV[03eIZ`<0od`O00<0
00000?m<7`3oC1l01P3oC1l300000080odXN00<0?EV[0?m:7P000000203oBQh010000000odXN0?m:
7P3oBQh203eIZ`040?m:7P0000000000000000P0odPM00<0?EV[0?m87@3oB1d01@3oB1d010000000
odPM0000000000050?Q570030000000mFJ/0n4DL00D0n4DL00@000000?Q5703hAA`000000`3Z@1T0
0`000000ooK^03eIZ`030?ofkP050=@m6@3om^h0ooK^03eIZ`3D?AT00P0mFJ/50?ofkP030=@m6@3o
m^h0ooK^00@0ooK^00@0?EV[0?ofkP0mFJ/0?EV[0P3om^h203eIZ`<0e3dI103om^h0100mFJ/0ooK^
03eIZ`0mFJ/200000080?EV[A`3om^h00`000000ooK^0?ofkP0E0?ofkP40oooo000G0?ofkP030000
003om^h0ooK^04H0ooK^00<000000=@m6@3D?AT00P3om^h40=@m6@030?ofkP0mFJ/0?EV[00@0ooK^
0P3D?AT0103om^h0?EV[0=@m6@3D?AT50?ofkP0303eIZ`3om^h0ooK^00@0ooK^0P0mFJ/40=@m6@04
03eIZ`3om^h0ooK^0=@m6@80ooK^00@0000001dXE`00000000000`0U=6l00`0000009CA_02DdK`05
02DdK`80e3dI0P0U=6l2000000<0;3j200<0000002`nPP0/?X800`0/?X820=@m6@0302`nPP000000
;3j200H0;3j200<000000357TP0aAi800`0aAi820=@m6@030357TP000000<DNB00L0<DNB00D00000
0=@m6@0aAi80<DNB0000000303I>X0030000000fCZ00=TjP00D0=TjP00<0000003I>X00fCZ000`0f
CZ020=@m6@<0=TjP00@0e3dI03I>X00fCZ0000001P0jEJ`00`000000>UF/03YE[00203YE[0030000
000jEJ`0>UF/00<0>UF/00<000000?m=803oCB000`3oCB000`000000oddP0?m=80020?m=80030000
003oCB00oddP00@0oddP00@000000?m<7`3oC1l0?EV[0`3oC1l203eIZ`D0od`O00<000000?m<7`3o
C1l01@3oC1l01@000000od`O0?m<7`3oC1l000000080odXN00<0?EV[0000003oBQh01`3oBQh01000
0000odXN03eIZ`0mFJ/50?m:7P030000003oB1d0odPM00D0odPM00@000000?m87@0mFJ/0?EV[1@3o
B1d010000000odPM0?m87@3oB1d200000080n4DL0P0mFJ/70?Q570040000003hAA`0n4DL0?Q57080
000000D0jT0I0000003om^h0ooK^03eIZ`020?ofkP030=@m6@0mFJ/0?EV[0080?EV[0P3D?AT60?of
kP030=@m6@3om^h0ooK^00<0ooK^0P0mFJ/0103D?AT0ooK^03eIZ`0mFJ/40?ofkP80e3dI00<0ooK^
03eIZ`0mFJ/00P0mFJ/20?ofkP80?EV[00<000000?ofkP3om^h0AP3om^h00`000000ooK^0?ofkP0E
0?ofkP40oooo000G0?ofkP030000003om^h0ooK^04@0ooK^0P0000030?ofkP80e3dI0P3om^h40=@m
6@H0ooK^00@0?EV[0=@m6@3D?AT0ooK^0`3D?AT30?ofkP0303eIZ`3om^h0ooK^00<0ooK^00@0?EV[
0?ofkP3om^h0ooK^1P3D?AT30?ofkP8000001@0U=6l00`0000009CA_02DdK`0602DdK`030000003D
?AT0e3dI00D0;3j200<0000002`nPP0/?X800P0/?X801@3D?AT0;3j202`nPP0/?X80000000D0;3j2
0P0000000`0aAi8000000357TP050357TP030=@m6@0aAi80000000L0<DNB00@0e3dI03eIZ`000000
0000100fCZ000`000000=TjP03I>X00503I>X0030000000fCZ00=TjP00@0=TjP00D000000=@m6@3D
?AT0=TjP0=@m6@03000000H0>UF/00<0000003YE[00jEJ`00`0jEJ`00`000000>UF/03YE[00203YE
[0030000003oCB00oddP0080oddP00<000000?m=803oCB000`3oCB000`000000oddP0?m=80040?m=
80<0000000D0?EV[0?m<7`0mFJ/0?EV[000000060?m<7`030000003oC1l0od`O00D0od`O00<00000
0?m<7`3oC1l00P3oC1l30000000303eIZ`3oBQh0odXN00D0odXN00<000000?m:7P0mFJ/01P3oBQh0
10000000odXN0000000000050?m87@050000003oB1d0odPM0?m87@0mFJ/00`3oB1d00`000000odPM
0?m87@040?m87@80?EV[00<000000?Q5703hAA`01P3hAA`00`000000n4DL0?Q570030?Q570800000
0`3om^h603eIZ`<0ooK^00<0e3dI0?ofkP3om^h00`3om^h0103D?AT0ooK^0?ofkP3om^h303eIZ`04
0?ofkP0mFJ/0?EV[0=@m6@H0ooK^100mFJ/20?ofkP80?EV[0`3om^h2000004H0ooK^00<000000?of
kP3om^h05@3om^h10?ooo`005`3om^h00`000000ooK^0?ofkP130?ofkP030000003om^h0ooK^00D0
ooK^0P3D?AT00`3om^h0?EV[0=@m6@030=@m6@<0ooK^00@0?EV[0?ofkP3om^h0ooK^0`3D?AT01@3o
m^h0e3dI0=@m6@3om^h0?EV[00<0ooK^0P0mFJ/50?ofkP<0e3dI00<0ooK^0=@m6@3D?AT00P3om^h0
0`0000009CA_02DdK`0402DdK`030000000U=6l09CA_00H09CA_00<0000002`nPP0/?X800P3D?AT4
02`nPP040000000/?X80;3j20=@m6@@0;3j200@0000002`nPP0/?X80;3j20P0000030357TP030000
000aAi80<DNB00D0<DNB0P3D?AT70357TP030=@m6@000000=TjP00H0=TjP00<0000003I>X00fCZ00
100fCZ000`000000=TjP03I>X00403I>X0050000000fCZ00=TjP0=@m6@0000000P0jEJ`00`000000
>UF/03YE[00403YE[0030000000jEJ`0>UF/00<0>UF/00<0000003YE[00jEJ`00P0jEJ`00`000000
oddP0?m=80020?m=80030000003oCB00oddP00<0oddP00<000000?m=803oCB00103oCB001@000000
oddP0?m=80000000?EV[0080od`O00<000000?m<7`3oC1l0103oC1l00`000000od`O0?m<7`040?m<
7`030000003oC1l0od`O00D0od`O00<0000003eIZ`3oBQh01P3oBQh203eIZ`L0odXN00@000000?m:
7P3oBQh0odXN0P0000030?m87@030000003oB1d0odPM0080odPM00@0?EV[0?m87@3oB1d00000103o
B1d203eIZ`80odPM00<000000?Q5703hAA`01@3hAA`00`000000n4DL0?Q570050?Q570030000003o
m^h0ooK^0080?EV[00@0ooK^03eIZ`0mFJ/0?EV[1@3om^h20=@m6@<0ooK^00D0e3dI0?ofkP0mFJ/0
?EV[0?ofkP0303eIZ`<0ooK^00@0e3dI0?ofkP3om^h0ooK^100mFJ/20?ofkP80?EV[1`3om^h00`00
0000ooK^0?ofkP130?ofkP030000003om^h0ooK^01D0ooK^0@3oool001H0ooK^00<000000?ofkP3o
m^h0@P3om^h2000000X0ooK^0P3D?AT00`3om^h0e3dI0=@m6@030=@m6@80?EV[1@3om^h20=@m6@80
ooK^0P3D?AT00`3om^h0?EV[03eIZ`050?ofkP<0e3dI00D0ooK^03eIZ`3D?AT0e3dI0?ofkP020=@m
6@030000000U=6l09CA_00D09CA_00<0000002DdK`0U=6l00`0U=6l3000000@0;3j20P3D?AT202`n
PP030000000/?X80e3dI00H0;3j20`0000060357TP030000000aAi80<DNB00H0<DNB0P3D?AT40357
TP030=@m6@000000000000L0=TjP00<0000003I>X00fCZ001@0fCZ000`000000=TjP03I>X00403I>
X0030000003D?AT000000080e3dI0P0jEJ`00`000000>UF/03YE[00303YE[0030000000jEJ`0>UF/
00<0>UF/00<0000003YE[00jEJ`00P0jEJ`00`000000oddP0?m=80020?m=80030000003oCB00oddP
00<0oddP00<000000?m=803oCB000`3oCB000`000000oddP0?m=800203eIZ`030000000mFJ/00000
00H0od`O00<000000?m<7`3oC1l01@3oC1l00`000000od`O0?m<7`040?m<7`040000003D?AT00000
03eIZ`@0odXN0P0mFJ/80?m:7P030000003oBQh0odXN00@0odXN0`0000060?m87@0303eIZ`000000
odPM0080odPM0P0mFJ/30?m87@040000003oB1d00000000000D0n4DL00<000000?Q5703hAA`01@3h
AA`010000000?EV[03eIZ`3om^h203eIZ`030=@m6@3om^h0?EV[0080?EV[1@3om^h20=@m6@030?of
kP0mFJ/0?EV[0080ooK^0P0mFJ/50?ofkP80e3dI1@0mFJ/00`3om^h0?EV[03eIZ`0:0?ofkP800000
A03om^h00`000000ooK^0?ofkP0D0?ofkP40oooo000F0?ofkP030000003om^h0ooK^0440ooK^00<0
00000?ofkP3om^h02P3om^h00`0mFJ/0ooK^0=@m6@020=@m6@030?ofkP3D?AT0e3dI0080e3dI1P3o
m^h30=@m6@80?EV[0P3D?AT40?ofkP80e3dI0P3om^h00`3D?AT0?EV[0?ofkP020?ofkP80e3dI00<0
ooK^0=@m6@3D?AT01P0U=6l00`0000009CA_02DdK`0202DdK`050000000/?X80;3j202`nPP000000
1@0/?X820=@m6@0302`nPP3D?AT0;3j200H0;3j200<000000357TP0aAi801P0aAi800`000000<DNB
0357TP060357TP060000000aAi80e3dI0=@m6@000000e3dI0`0fCZ000`000000=TjP03I>X00403I>
X0030000000fCZ00=TjP00D0=TjP00<0000003I>X00fCZ00100fCZ000`3D?AT0>UF/03YE[00203YE
[080e3dI00<0000003YE[00jEJ`00`0jEJ`00`000000>UF/03YE[00303YE[0030000000jEJ`0>UF/
0080>UF/00<000000?m=803oCB000P3oCB000`000000oddP0?m=80030?m=80030000003oCB00oddP
00<0oddP00<0000003eIZ`0mFJ/0103oCB000`0mFJ/0od`O0?m<7`040?m<7`030000003oC1l0od`O
00D0od`O00<000000?m<7`3oC1l0103oC1l01P000000od`O0?m<7`3oC1l0?EV[00000080?EV[00<0
odXN0000003oBQh01`3oBQh00`000000odXN0?m:7P060?m:7P030000003oB1d0odPM00D0odPM00@0
?EV[0?m87@0mFJ/0?EV[1@3oB1d01@000000odPM0?m87@3oB1d0000000@0n4DL00<000000?Q5703h
AA`0103hAA`203eIZ`030?ofkP0mFJ/0?EV[00<0ooK^00@0e3dI03eIZ`3om^h0ooK^0P0mFJ/40?of
kP80?EV[0P3D?AT303eIZ`H0ooK^100mFJ/01@3om^h0?EV[03eIZ`0mFJ/0e3dI00d0ooK^00<00000
0?ofkP3om^h0@@3om^h00`000000ooK^0?ofkP0D0?ofkP40oooo000F0?ofkP030000003om^h0ooK^
03l0ooK^0P00000=0?ofkP0403eIZ`3om^h0ooK^0?ofkP<0e3dI00<0ooK^0=@m6@3D?AT00P3D?AT4
0?ofkP030=@m6@3om^h0ooK^0080e3dI0P3om^h40=@m6@@0ooK^00<0e3dI03eIZ`3om^h0103om^h2
0=@m6@0303eIZ`0U=6l09CA_00@09CA_00D0000002DdK`0U=6l09CA_0000000402`nPP030000000/
?X80;3j200D0;3j200<0e3dI0000000/?X80100/?X82000000030357TP000000<DNB00L0<DNB00<0
00000357TP0aAi801P0aAi83000000030=@m6@0fCZ00=TjP0080=TjP00<0000003I>X00fCZ001@0f
CZ000`000000=TjP03I>X00403I>X0030000000fCZ00=TjP0080=TjP00<000000=@m6@0000001P0j
EJ`20=@m6@@0>UF/00<0000003YE[00jEJ`00`0jEJ`00`000000>UF/03YE[00203YE[0030000003o
CB00oddP0080oddP00<000000?m=803oCB000`3oCB000`000000oddP0?m=80020?m=8080?EV[1P3o
CB000`000000?EV[000000040?m<7`030000003oC1l0od`O00@0od`O00<000000?m<7`3oC1l0103o
C1l00`000000od`O0?m<7`030?m<7`0403eIZ`0000000000000000P0odXN00<000000?m:7P3oBQh0
1P3oBQh010000000odXN0000000000040?m87@030000003oB1d0?EV[00H0odPM00<000000?m87@3o
B1d00`3oB1d01@000000n4DL0?Q5703hAA`0000000H0n4DL00<0e3dI03eIZ`0mFJ/01@3om^h00`3D
?AT0?EV[0?ofkP030?ofkP@0?EV[0P3om^h203eIZ`80ooK^00<0?EV[0?ofkP3om^h00P3om^h403eI
Z`040?ofkP0mFJ/0?EV[03eIZ`<0ooK^00<0e3dI0?ofkP3om^h02`3om^h200000440ooK^00<00000
0?ofkP3om^h0503om^h10?ooo`005P3om^h00`000000ooK^0?ofkP0n0?ofkP030000003om^h0ooK^
00`0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP070=@m6@<0ooK^2@3D?AT50?of
kP030=@m6@0mFJ/0ooK^00@0ooK^0P0mFJ/20=@m6@0302DdK`3D?AT09CA_00<09CA_0`00000602`n
PP030000000/?X80;3j20080;3j20P3D?AT00`0/?X80e3dI0=@m6@0302`nPP050000000aAi80<DNB
0357TP0000002@0aAi800`000000<DNB0357TP050357TP040000000fCZ00e3dI03I>X080e3dI0`0f
CZ000`000000=TjP03I>X00403I>X0030000000fCZ00=TjP00D0=TjP00P0000003I>X00000000000
03YE[03D?AT0>UF/000000D0>UF/00@0000003YE[03D?AT0e3dI0P0jEJ`00`000000>UF/03YE[003
03YE[0030000000jEJ`0>UF/00D000000P3oCB000`000000oddP0?m=80030?m=80030000003oCB00
oddP0080?EV[00<0oddP0000003oCB00103oCB0010000000oddP03eIZ`3oCB02000000030?m<7`00
0000od`O00H0od`O00<000000?m<7`3oC1l0103oC1l010000000od`O0?m<7`3oC1l203eIZ`040?m<
7`0mFJ/0od`O000000L0odXN00<000000?m:7P3oBQh01`3oBQh01@000000odXN0?m:7P3oBQh00000
00<0odPM0P0mFJ/00`3oB1d0?EV[03eIZ`040?m87@030000003oB1d0odPM00@0odPM0`0000060?Q5
7080?EV[0P3D?AT50?ofkP030=@m6@0mFJ/0ooK^00@0ooK^2@0mFJ/30?ofkPL0?EV[0P3om^h01@3D
?AT0ooK^0?ofkP3om^h0e3dI00l0ooK^00<000000?ofkP3om^h0?P3om^h00`000000ooK^0?ofkP0D
0?ofkP40oooo000F0?ofkP030000003om^h0ooK^03d0ooK^00<000000?ofkP3om^h03@3om^h00`0m
FJ/0ooK^0?ofkP0203eIZ`@0ooK^00<0?EV[0=@m6@3D?AT01`3D?AT00`3om^h0?EV[0?ofkP020?of
kP80e3dI00<0ooK^0=@m6@3D?AT00`3om^h00`3D?AT0?EV[0?ofkP030?ofkP0503eIZ`3om^h0ooK^
0?ofkP0000000P3D?AT402DdK`030000000/?X80;3j200H0;3j200<0000002`nPP0/?X800P3D?AT4
02`nPP040000003D?AT0e3dI000000D0<DNB00<000000357TP0aAi801P0aAi800`000000<DNB0357
TP030357TP80000000<0=TjP0=@m6@0fCZ000`0fCZ020=@m6@0303I>X0000000=TjP00D0=TjP00<0
000003I>X00fCZ001@0fCZ0200000080>UF/00@0e3dI03YE[00jEJ`000001@0jEJ`01`000000>UF/
03YE[00jEJ`0e3dI03YE[00000001@0jEJ`300000080?U^g00<000000?m>803oCR000`0000050?m=
80030000003oCB00?EV[0080oddP00<000000?m=803oCB00103oCB0010000000oddP0?m=800mFJ/2
0?m=808000001`3oC1l00`000000od`O0?m<7`030?m<7`030000003oC1l0od`O0080?EV[103oC1l0
100mFJ/0e3dI0000000000050?m:7P030000003oBQh0odXN00H0odXN00<000000?m:7P3oBQh00`3o
BQh00`000000?EV[03eIZ`050?m87@80?EV[00<0odPM0000003oB1d0203oB1d00`000000n4DL0?Q5
70020?Q57080?EV[00D000000?ofkP3om^h0ooK^0=@m6@040?ofkP030=@m6@0mFJ/0ooK^0080ooK^
0P0mFJ/00`3om^h0?EV[03eIZ`030?ofkP030=@m6@3om^h0?EV[00P0?EV[00<0e3dI0?ofkP3om^h0
0P3om^h20=@m6@80ooK^00<0e3dI0?ofkP3om^h03@3om^h00`000000ooK^0?ofkP0m0?ofkP030000
003om^h0ooK^01@0ooK^0@3oool001D0ooK^00<000000?ofkP3om^h0?03om^h2000000l0ooK^00@0
?EV[0?ofkP3om^h0?EV[1P3om^h00`0mFJ/0ooK^0?ofkP020=@m6@030?ofkP3D?AT0e3dI00<0e3dI
00<0?EV[0?ofkP3om^h00`3om^h20=@m6@030?ofkP3D?AT0e3dI0080ooK^00<0e3dI0?ofkP3om^h0
0P0mFJ/40?ofkP030000000U=6l09CA_0080e3dI0P0000000`0/?X80000002`nPP0702`nPP030000
003D?AT0;3j200H0;3j200@000000357TP3D?AT0e3dI1@0aAi800`000000<DNB0357TP060357TP06
0000000aAi80<DNB0357TP000000=TjP0P3D?AT00`000000=TjP03I>X00403I>X080e3dI00<00000
03I>X00fCZ00100fCZ000`000000=TjP03I>X00203I>X0<000000P0jEJ`01@3D?AT0>UF/03YE[00j
EJ`0000000H0>UF/00@0000003YE[00jEJ`0>UF/0P3D?AT00`000000>UF/03YE[00203YE[0070000
000nFkL0?U^g03iK]`3D?AT0000003eIZ`030?m>80030000003oCB00oddP0080oddP00<0000003eI
Z`0mFJ/00`3oCB000`000000oddP0?m=80040?m=80050000003oCB00oddP0?m=800mFJ/00P3oCB03
000000@0od`O00<000000?m<7`3oC1l0103oC1l00`000000?EV[03eIZ`060?m<7`050000000mFJ/0
?EV[0?m<7`0000000`3oBQh00`000000odXN0?m:7P060?m:7P030000003oBQh0odXN00<0odXN0P0m
FJ/00`3oBQh000000?m87@060?m87@0303eIZ`000000odPM00L0odPM00@000000?m87@0000000000
0P0mFJ/20?Q570030000003om^h0ooK^0080ooK^0P3D?AT20?ofkP0303eIZ`3om^h0ooK^0080?EV[
00<0ooK^03eIZ`0mFJ/01@3om^h00`3D?AT0?EV[03eIZ`0303eIZ`030?ofkP0mFJ/0?EV[0080ooK^
00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0=@m6@0@0?ofkP800000?P3om^h00`000000ooK^
0?ofkP0C0?ofkP40oooo000E0?ofkP030000003om^h0ooK^03/0ooK^00<000000?ofkP3om^h03`3o
m^h00`0mFJ/0ooK^03eIZ`070?ofkP0303eIZ`3om^h0ooK^0080ooK^0P3D?AT01@3om^h0e3dI0=@m
6@3D?AT0?EV[00L0ooK^0P3D?AT0103om^h0e3dI0=@m6@3D?AT203eIZ`H0ooK^00D0000002DdK`0U
=6l09CA_000000020=@m6@0302`nPP000000;3j200H0;3j20P3D?AT602`nPP80000000@0<DNB0000
000aAi80<DNB0P3D?AT30357TP030000000aAi80<DNB00H0<DNB00H000000357TP000000000003I>
X03D?AT303I>X0030000000fCZ00=TjP00D0=TjP0P3D?AT503I>X0050000000fCZ00=TjP03I>X000
00000`0jEJ`00`000000e3dI03YE[00403YE[0030000000jEJ`0>UF/00<0>UF/00<0000003YE[00j
EJ`00`0jEJ`20=@m6@0403YE[0000000000000000080?U^g00D0e3dI03iK]`000000odhP03eIZ`02
0?m>80<0000000<0oddP03eIZ`0mFJ/01@3oCB000`000000oddP0?m=80030?m=80030000003oCB00
oddP00<0oddP00<0?EV[0000003oCB000P3oCB001@000000od`O0?m<7`3oC1l0000000D0od`O0P0m
FJ/70?m<7`060000003oC1l0od`O0?m<7`0mFJ/0od`O0P0000000`3oBQh000000?m:7P060?m:7P03
0000003oBQh0odXN0080odXN0P0mFJ/20?m:7P040000003oBQh00000000000D0odPM00<0000003eI
Z`0mFJ/01`3oB1d01@000000odPM03eIZ`0mFJ/0000000<0n4DL00<000000?ofkP3om^h0103om^h2
0=@m6@<0?EV[00<0ooK^03eIZ`0mFJ/01`3om^h01@3D?AT0?EV[03eIZ`0mFJ/0ooK^0080?EV[103o
m^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0e3dI0140ooK^00<000000?ofkP3om^h0>`3o
m^h00`000000ooK^0?ofkP0C0?ofkP40oooo000E0?ofkP030000003om^h0ooK^03T0ooK^0P00000A
0?ofkP<0?EV[203om^h0100mFJ/0ooK^0?ofkP3om^h203eIZ`040?ofkP3D?AT0e3dI0?ofkP<0e3dI
203om^h20=@m6@030?ofkP3D?AT0e3dI00P0ooK^0`00000302`nPP80e3dI00<0000002`nPP0/?X80
0P0/?X820=@m6@80;3j200@0000002`nPP0/?X80;3j20P0000030357TP030000000aAi80<DNB0080
<DNB0P3D?AT20357TP030000000aAi80<DNB00H0<DNB00@0000003I>X00fCZ00e3dI1@0fCZ000`00
0000=TjP03I>X00503I>X0030000003D?AT0=TjP00@0=TjP0`00000403YE[0030=@m6@0jEJ`0>UF/
00@0>UF/00<0000003YE[00jEJ`00`0jEJ`00`000000>UF/03YE[00303YE[08000000P3D?AT0100n
FkL0000003iK]`3D?AT203iK]`030000003oCR00?EV[0080odhP00@000000?m>800mFJ/0?EV[0P00
00050?m=80030000003oCB00oddP00<0oddP00<000000?m=803oCB00103oCB000`0mFJ/0oddP0?m=
80020?m=80<000001@3oC1l00`0mFJ/000000?m<7`060?m<7`030000003oC1l0od`O00<0od`O00@0
?EV[0?m<7`3oC1l00000203oBQh00`000000odXN0?m:7P0203eIZ`@0odXN00@000000?m:7P3oBQh0
odXN0P0000030?m87@030000003oB1d0odPM0080?EV[103oB1d00`000000?EV[03eIZ`030?m87@<0
0000203om^h203eIZ`030?ofkP0mFJ/0?EV[00P0ooK^0`0mFJ/0103om^h0?EV[03eIZ`3om^h20=@m
6@<0ooK^00<0e3dI0?ofkP3om^h01P3om^h20=@m6A80ooK^0P00000k0?ofkP030000003om^h0ooK^
01<0ooK^0@3oool001D0ooK^00<000000?ofkP3om^h0>03om^h00`000000ooK^0?ofkP0A0?ofkP03
03eIZ`3om^h0ooK^00L0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`050?ofkP80e3dI00@0?EV[0=@m
6@3D?AT0e3dI1`3om^h0100mFJ/0e3dI0=@m6@3om^h20=@m6@H0ooK^00<0000002`nPP0/?X801@0/
?X820=@m6@0302`nPP3D?AT0e3dI00@0;3j200@0000002`nPP00000000001P0aAi800`000000<DNB
0357TP030357TP80e3dI00<0<DNB0000000aAi80100aAi820000000303I>X0000000e3dI00H0=TjP
00<0000003I>X00fCZ001@0fCZ0010000000=TjP0=@m6@3D?AT303I>X0030000000jEJ`0>UF/00<0
>UF/00<0e3dI03YE[00000001@0jEJ`00`000000>UF/03YE[00303YE[0030000000jEJ`0>UF/00<0
>UF/00@0000003iK]`0nFkL0?U^g0P3D?AT01@0nFkL0e3dI03iK]`0nFkL000000080odhP00@0?EV[
0?m>800mFJ/0?EV[0`3oCR000`000000oddP0?m=80030?m=80030000003oCB00oddP00<0oddP00<0
00000?m=803oCB000`3oCB000`000000oddP03eIZ`050?m=80040000003oC1l0od`O0?m<7`80?EV[
00<000000?m<7`3oC1l01P3oC1l00`000000od`O0?m<7`040?m<7`0303eIZ`000000od`O00800000
1@3oBQh010000000odXN03eIZ`0mFJ/50?m:7P030000003oBQh0odXN00@0odXN0`0000050?m87@80
?EV[00<0odPM03eIZ`0mFJ/01`3oB1d00`000000ooK^0?ofkP040?ofkPD0?EV[00<0e3dI0?ofkP3o
m^h01@3om^h303eIZ`030=@m6@0mFJ/0?EV[00D0ooK^00@0e3dI0?ofkP3om^h0e3dI2P3om^h00`3D
?AT0ooK^0?ofkP0A0?ofkP030000003om^h0ooK^03P0ooK^00<000000?ofkP3om^h04`3om^h10?oo
o`00503om^h00`000000ooK^0?ofkP0g0?ofkP800000503om^h00`0mFJ/0ooK^0?ofkP070?ofkP04
03eIZ`3om^h0ooK^03eIZ`P0ooK^1P3D?AT40?ofkP0403eIZ`3om^h0ooK^03eIZ`80e3dI00<0ooK^
0=@m6@3D?AT01@3om^h00`000000;3j202`nPP0502`nPP80e3dI1`0/?X800`000000<DNB0357TP07
0357TP030000000aAi80<DNB00@0<DNB0P3D?AT01@000000<DNB0357TP0aAi80000000<0=TjP00<0
e3dI03I>X00fCZ001P0fCZ000`000000=TjP03I>X00503I>X0030000000fCZ00=TjP0080e3dI00<0
000003YE[0000000100jEJ`00`3D?AT0>UF/0000000603YE[0030000000jEJ`0>UF/00<0>UF/00<0
000003YE[00jEJ`00`00000403iK]`030000003D?AT0?U^g0080?U^g00H000000?m>803oCR00odhP
03eIZ`0000040?m>80<000000P3oCB000`000000oddP0?m=80030?m=80030000003oCB00oddP00@0
oddP00<000000?m=800mFJ/0103oCB000`000000oddP0000000203eIZ`80od`O00<000000?m<7`3o
C1l01@3oC1l00`000000od`O0?m<7`060?m<7`0503eIZ`3oC1l0od`O0?m<7`0000000`3oBQh00`00
0000?EV[03eIZ`060?m:7P030000003oBQh0odXN00L0odXN00<000000?m87@3oB1d01@3oB1d203eI
Z`L0odPM00<000000?ofkP3om^h00`3om^h203eIZ`040?ofkP0mFJ/0?EV[0=@m6@80ooK^00<0e3dI
0?ofkP3om^h00P3om^h603eIZ`P0ooK^00@0e3dI0?ofkP3om^h0e3dI2@3om^h00`3D?AT0ooK^0?of
kP0B0?ofkP800000>03om^h00`000000ooK^0?ofkP0C0?ofkP40oooo000D0?ofkP030000003om^h0
ooK^03H0ooK^00<000000?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP080?ofkP<0?EV[2@3om^h0
0`0mFJ/0ooK^0=@m6@050=@m6@80?EV[103om^h01@3D?AT0ooK^0=@m6@3D?AT0ooK^0080e3dI0`3o
m^h00`000000;3j202`nPP0202`nPP<0e3dI00@0;3j20000003D?AT0e3dI0`0/?X82000000030357
TP000000<DNB00L0<DNB00<000000357TP0aAi801P0aAi820=@m6@8000000P0fCZ020=@m6@0303I>
X0000000=TjP00H0=TjP00<0000003I>X00fCZ001@0fCZ001@000000=TjP000000000000>UF/0080
e3dI00D0000003YE[00jEJ`0>UF/0=@m6@0203YE[0030000000jEJ`0>UF/00@0>UF/00<0000003YE
[00jEJ`00`0jEJ`300000080?U^g00<0000003iK]`0nFkL00P0nFkL01`3D?AT0?U^g0=@m6@3D?AT0
?U^g0000003oCR000P0mFJ/00`3oCR00?EV[0?m>80030?m>80030000003oCR00odhP00<000001@3o
CB000`000000oddP0?m=80030?m=80050000003oCB00oddP0?m=800mFJ/00`3oCB0010000000?EV[
03eIZ`3oCB03000000P0od`O00<000000?m<7`3oC1l01@3oC1l010000000od`O03eIZ`0mFJ/20?m<
7`8000000P0mFJ/70?m:7P030000003oBQh0odXN00L0odXN00@000000?m:7P00000000000`3oB1d2
03eIZ`030000003oB1d0?EV[0080?EV[103oB1d010000000ooK^0?ofkP3om^h203eIZ`050?ofkP0m
FJ/0?EV[03eIZ`3D?AT0103om^h20=@m6@H0?EV[00<0ooK^0=@m6@3om^h0203om^h30=@m6@X0ooK^
00<0e3dI0?ofkP3om^h04`3om^h00`000000ooK^0?ofkP0f0?ofkP030000003om^h0ooK^0180ooK^
0@3oool001@0ooK^00<000000?ofkP3om^h0=@3om^h00`000000ooK^0?ofkP0D0?ofkP0303eIZ`3o
m^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h02@3om^h0100mFJ/0ooK^0?ofkP3om^h60=@m6@@0ooK^
00@0?EV[0=@m6@3om^h0ooK^0P3D?AT00`3om^h0e3dI0=@m6@020?ofkP040000000/?X80e3dI0=@m
6@D0;3j200D0000002`nPP3D?AT0e3dI000000040357TP030000000aAi80<DNB00H0<DNB00<00000
0357TP0aAi801P0aAi801@000000e3dI0=@m6@0fCZ00e3dI00@0=TjP00<0000003I>X00fCZ001@0f
CZ000`000000=TjP03I>X00503I>X0030000000jEJ`0>UF/00<0>UF/0P3D?AT00`0jEJ`0e3dI03YE
[00303YE[0030000000jEJ`0>UF/00<0>UF/00<0000003YE[00jEJ`00P0jEJ`2000000@0?U^g00H0
000003iK]`0nFkL0?U^g0=@m6@00000303iK]`030=@m6@000000?EV[00<0odhP00<0000003eIZ`3o
CR000P3oCR000`000000odhP0?m>80020?m>80800000103oCB000`000000oddP0?m=80030?m=8003
0000003oCB00oddP0080oddP00@0?EV[0?m=800mFJ/0?EV[1@3oCB000`000000od`O0?m<7`050?m<
7`030000003oC1l0od`O00D0od`O00<000000?m<7`3oC1l00P3oC1l01@0mFJ/0od`O03eIZ`0mFJ/0
000000P0odXN00<000000?m:7P3oBQh01P3oBQh00`000000odXN0?m:7P020?m:7P050000000mFJ/0
?EV[0?m87@0000001@3oB1d203eIZ`040?m87@000000ooK^0?ofkP80?EV[00<0ooK^03eIZ`0mFJ/0
0P3om^h00`0mFJ/0e3dI0?ofkP030?ofkPH0?EV[0`3om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m
6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h0503om^h00`000000ooK^0?ofkP0e0?ofkP030000
003om^h0ooK^0180ooK^0@3oool001@0ooK^00<000000?ofkP3om^h0<`3om^h2000001L0ooK^00<0
?EV[0?ofkP3om^h01P3om^h303eIZ`/0ooK^00<0?EV[0?ofkP3om^h00`3om^h60=@m6@80ooK^00<0
?EV[0=@m6@3om^h00`3om^h20=@m6@030?ofkP3D?AT0e3dI0080e3dI1`0/?X8010000000;3j20000
000000020=@m6@<0<DNB00<000000357TP0aAi801`0aAi800`000000<DNB0357TP030357TP800000
00@0=TjP0000000fCZ00e3dI1@0fCZ000`000000=TjP03I>X00603I>X0030000000fCZ00=TjP0080
=TjP0P0000000`0jEJ`0000003YE[00403YE[0030000003D?AT0>UF/00@0>UF/00<0000003YE[00j
EJ`0100jEJ`01P000000>UF/000000000000?U^g000000D0?U^g00D0000003iK]`3D?AT0?U^g0000
000403iK]`050000003oCR00odhP0?m>800000000P3oCR000`0mFJ/0odhP000000050?m>80060000
003oCR0000000000003oCB0000001P3oCB000`000000oddP0?m=80030?m=800303eIZ`000000oddP
00@0oddP00@000000?m=800000000000103oC1l00`000000od`O0?m<7`060?m<7`030000003oC1l0
od`O00<0od`O00@0?EV[0?m<7`000000od`O0P0000050?m:7P030000003oBQh0odXN00L0odXN00@0
00000?m:7P3oBQh0odXN0P0mFJ/2000000030?m87@000000odPM00H0odPM100mFJ/00`3om^h0?EV[
03eIZ`030?ofkP0303eIZ`3om^h0e3dI0080ooK^1P0mFJ/50?ofkP030=@m6@3om^h0ooK^00T0ooK^
0`3D?AT80?ofkP030=@m6@3om^h0ooK^01D0ooK^0P00000e0?ofkP030000003om^h0ooK^0180ooK^
0@3oool001@0ooK^00<000000?ofkP3om^h0<P3om^h00`000000ooK^0?ofkP0G0?ofkP0303eIZ`3o
m^h0ooK^00@0ooK^0P0mFJ/20?ofkP0303eIZ`3om^h0ooK^00T0ooK^00@0?EV[0?ofkP3om^h0ooK^
0P0mFJ/20?ofkPH0e3dI00@0?EV[0?ofkP3D?AT0ooK^1P3D?AT00`3om^h0e3dI0=@m6@0802`nPP03
0000000aAi80<DNB0080<DNB0P3D?AT20357TP030000000aAi80<DNB00L0<DNB00D000000357TP0a
Ai80<DNB0000000303I>X080e3dI00<0=TjP0=@m6@3D?AT0100fCZ000`000000=TjP03I>X00503I>
X0030000000fCZ00=TjP008000000`0jEJ`00`000000>UF/03YE[00303YE[0040=@m6@000000e3dI
0=@m6@@0>UF/00<0000003YE[00jEJ`00`0jEJ`2000000<0?U^g00<0000003iK]`0nFkL00`0nFkL0
0`000000e3dI03iK]`0203iK]`050000000nFkL0?U^g03iK]`0000000`3oCR001P000000odhP0?m>
803oCR00?EV[000000@0odhP00<000000?m>803oCR000P3oCR02000000D0oddP00<000000?m=803o
CB000P3oCB0203eIZ`030000000mFJ/0oddP00@0oddP00@000000?m=803oCB00oddP0P0000020?m<
7`030000003oC1l0od`O00D0od`O00<000000?m<7`3oC1l00P3oC1l203eIZ`030?m<7`0mFJ/0?EV[
00<0od`O00D000000?m:7P3oBQh0odXN000000090?m:7P030000003oBQh0odXN0080?EV[103oBQh0
0`000000odPM0?m87@060?m87@80?EV[00<0ooK^03eIZ`0mFJ/0100mFJ/0103om^h0?EV[0?ofkP3D
?AT603eIZ`80ooK^0P3D?AT30?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h00P3D
?AT60?ofkP030=@m6@3om^h0ooK^01L0ooK^00<000000?ofkP3om^h0<P3om^h00`000000ooK^0?of
kP0B0?ofkP40oooo000C0?ofkP030000003om^h0ooK^0340ooK^0P00000I0?ofkP0303eIZ`3om^h0
ooK^00@0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP090?ofkP0403eIZ`3om^h0
ooK^03eIZ`H0ooK^203D?AT50?ofkP80e3dI00<0ooK^0000003D?AT01@0/?X82000000030357TP00
0000<DNB00@0<DNB0P3D?AT01@0aAi8000000357TP0aAi80?EV[00D0<DNB00@000000357TP000000
00000P0fCZ020=@m6@0303I>X0000000=TjP0080=TjP0P3D?AT203I>X0030000000fCZ00=TjP00H0
=TjP0P00000603YE[0070000000jEJ`0>UF/03YE[03D?AT0>UF/0000000203YE[080e3dI0P0jEJ`0
10000000>UF/03YE[00jEJ`3000000D0?U^g00<0000003iK]`0nFkL00P0nFkL00`3D?AT0?U^g03iK
]`0203iK]`050000000nFkL0?U^g03iK]`0000000`3oCR000`000000odhP0?m>80020?m>800303eI
Z`3oCR00odhP0080odhP00<000000?m>803oCR000`3oCR03000000<0oddP00<000000?m=803oCB00
0P0mFJ/20?m=80030000003oCB00?EV[00<0oddP00<000000?m=803oCB00103oCB02000000P0od`O
00<000000?m<7`3oC1l00P0mFJ/30?m<7`040000003oC1l0?EV[03eIZ`80od`O0P0000000`3oBQh0
00000?m:7P070?m:7P040000003oBQh0?EV[03eIZ`D0odXN00@000000?m:7P00000000001@3oB1d0
0`0mFJ/000000?ofkP0203eIZ`D0ooK^200mFJ/60?ofkP040=@m6@3om^h0ooK^0=@m6@/0ooK^00<0
e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^01L0ooK^0P00
000c0?ofkP030000003om^h0ooK^0140ooK^0@3oool001<0ooK^00<000000?ofkP3om^h0<03om^h0
0`000000ooK^0?ofkP0I0?ofkP0303eIZ`3om^h0ooK^0080ooK^0P0mFJ/50?ofkP0303eIZ`3om^h0
ooK^00T0ooK^0`0mFJ/90?ofkPH0e3dI1`3om^h20=@m6@0403eIZ`0/?X80;3j202`nPP800000100a
Ai800`000000<DNB0357TP040357TP80e3dI00<000000357TP0mFJ/01P0aAi801@000000=TjP03I>
X00fCZ00e3dI00@0=TjP00D0000003I>X00fCZ00=TjP03eIZ`020=@m6@0303I>X0000000=TjP00@0
=TjP0P0000000`0jEJ`0000003YE[00503YE[00403eIZ`000000e3dI0=@m6@<0>UF/00D0000003YE
[00jEJ`0>UF/0=@m6@0203YE[0<000000`0nFkL00`000000?U^g03iK]`0203iK]`060000000nFkL0
?U^g03iK]`3D?AT00000100nFkL01@000000?U^g03iK]`0nFkL0000000<0odhP00<000000?m>803o
CR000P3oCR000`000000?EV[0?m>80020?m>80030000003oCR00odhP0080odhP00@000000?m>803o
CR00odhP0`0000020?m=800503eIZ`3oCB00oddP0?m=800000000`3oCB0203eIZ`030000003D?AT0
oddP00D0oddP00@000000?m=8000000000001@3oC1l010000000od`O03eIZ`0mFJ/40?m<7`030000
003oC1l0od`O0080od`O00D0?EV[0?m<7`3oC1l0od`O000000080?m:7P030000000mFJ/0?EV[00H0
odXN00<000000?m:7P3oBQh00P3oBQh2000000<0odPM00<0e3dI03eIZ`0mFJ/01`3om^h603eIZ`T0
ooK^0`3D?AT;0?ofkP030=@m6@3om^h0ooK^00<0ooK^0P3D?AT40?ofkP030=@m6@3om^h0ooK^01T0
ooK^00<000000?ofkP3om^h0<03om^h00`000000ooK^0?ofkP0A0?ofkP40oooo000C0?ofkP030000
003om^h0ooK^02h0ooK^0P00000L0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/01`3om^h00`0mFJ/0
ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0e3dI03eIZ`3D?AT00`3D?AT40?ofkP80
?EV[00<0ooK^0=@m6@3D?AT00P0000070357TP030000000aAi80<DNB00D0<DNB0P3D?AT50357TP80
000000@0=TjP0000003D?AT0e3dI1P0fCZ000`000000=TjP03I>X00303I>X080e3dI00D0000003I>
X00fCZ00=TjP0000000303YE[0030000000jEJ`0>UF/00D0>UF/00<0e3dI03YE[00jEJ`00`0jEJ`0
0`000000>UF/03YE[00203YE[080e3dI00<0000003iK]`0nFkL00`0nFkL00`000000?U^g03iK]`02
03iK]`060000000nFkL0?U^g03iK]`3D?AT00000100nFkL01@000000?U^g03iK]`0nFkL0000000<0
odhP00<000000?m>803oCR000P3oCR000`000000?EV[0?m>80020?m>80030000003oCR00odhP0080
odhP00<000000?m>803oCR000`3oCR000`000000?EV[03eIZ`040?m=80030000003oCB00oddP00<0
oddP00<0?EV[0?m=803oCB001@3oCB001@000000oddP0?m=803oCB00000000<0od`O00<0000003eI
Z`0mFJ/01@3oC1l00`000000od`O0?m<7`040?m<7`80?EV[00@000000?m<7`00000000001@3oBQh2
03eIZ`L0odXN00<000000?m:7P3oBQh01@3oBQh200000080?EV[00<0ooK^0=@m6@3D?AT0103om^h4
03eIZ`030=@m6@0mFJ/0ooK^00`0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP05
0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT0703om^h200000300ooK^00<000000?ofkP3om^h04@3o
m^h10?ooo`004`3om^h00`000000ooK^0?ofkP0]0?ofkP030000003om^h0ooK^01`0ooK^00@0?EV[
0?ofkP0mFJ/0?EV[203om^h00`0mFJ/0ooK^0?ofkP070?ofkP<0?EV[3P3om^h20=@m6@030?ofkP3D
?AT0e3dI0080e3dI0P0mFJ/40?ofkP030000003D?AT0e3dI00P0<DNB00<000000357TP0aAi801@0a
Ai800`000000e3dI0=@m6@020357TP030000000fCZ00=TjP0080e3dI00<0000003I>X00fCZ001P0f
CZ000`000000=TjP03I>X00403I>X0040=@m6@0fCZ000000000000D0>UF/00<0000003YE[00jEJ`0
0`0jEJ`00`3D?AT0>UF/0000000503YE[0040000000jEJ`0>UF/03YE[08000000P3D?AT503iK]`05
0000000nFkL0?U^g03iK]`0000000P0nFkL00`3D?AT0?U^g0000000403iK]`050000000nFkL0?U^g
03iK]`0000000`3oCR000`000000odhP0?m>80020?m>80050000003oCR00?EV[0?m>80000000103o
CR000`000000odhP0?m>80030?m>8080?EV[0P0000030?m=80030000003oCB00oddP00<0oddP00<0
00000?m=800mFJ/01@3oCB000`000000oddP0?m=80030?m=8080000000<0od`O03eIZ`3oC1l01@3o
C1l00`000000od`O0?m<7`060?m<7`030000000mFJ/0?EV[0080od`O00<000000?m:7P3oBQh00P0m
FJ/00`000000odXN0?m:7P050?m:7P030000003oBQh0odXN00H0odXN0P0mFJ/00`000000ooK^0?of
kP020?ofkP80e3dI100mFJ/00`3om^h0?EV[03eIZ`0>0?ofkP<0e3dI2@3om^h00`3D?AT0ooK^0?of
kP060?ofkP80e3dI00<0ooK^0=@m6@3om^h07@3om^h00`000000ooK^0?ofkP0]0?ofkP030000003o
m^h0ooK^0140ooK^0@3oool001<0ooK^00<000000?ofkP3om^h0;03om^h00`000000ooK^0?ofkP0L
0?ofkP<0?EV[2@3om^h00`0mFJ/0ooK^0?ofkP060?ofkP80?EV[0P3om^h00`0mFJ/0ooK^0?ofkP0<
0?ofkP0503eIZ`3om^h0e3dI0=@m6@3om^h0103D?AT50?ofkP040000000aAi80e3dI0=@m6@H0<DNB
00<000000357TP0aAi801P0aAi801@000000<DNB0=@m6@3D?AT0=TjP0080e3dI0`0fCZ000`000000
=TjP03I>X00603I>X0030000000fCZ00=TjP00@0=TjP0P3D?AT703YE[0050000000jEJ`0>UF/03YE
[03D?AT00P0jEJ`00`000000>UF/03YE[00303YE[0040000000jEJ`00000000000<0?U^g00<00000
0=@m6@3D?AT00`0nFkL00`000000?U^g03iK]`0203iK]`030000003D?AT0?U^g0080?U^g00H00000
03iK]`0nFkL0?U^g0000000nFkL5000000030?m>80000000odhP0080odhP00H000000?m>803oCR00
odhP03eIZ`0000040?m>80040000003oCR00odhP0?m>8080?EV[00@000000?m>803oCR00odhP0P00
00000`3oCB0000000?m=80040?m=80040000003oCB00oddP03eIZ`<0oddP00<000000?m=803oCB00
1@3oCB0203eIZ`H0od`O00<000000?m<7`3oC1l01P3oC1l010000000od`O0?m<7`3oC1l203eIZ`05
0?m<7`0mFJ/0?EV[0?m:7P000000203oBQh00`000000odXN0?m:7P040?m:7P80?EV[00<0odXN0000
003om^h0103om^h403eIZ`050?ofkP0mFJ/0?EV[0?ofkP3D?AT03P3om^h00`3D?AT0ooK^0?ofkP02
0=@m6@P0ooK^00<0e3dI0?ofkP3om^h01`3om^h30=@m6Ah0ooK^00<000000?ofkP3om^h0;03om^h0
0`000000ooK^0?ofkP0A0?ofkP40oooo000B0?ofkP030000003om^h0ooK^02/0ooK^0P00000O0?of
kP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP030?of
kP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h0103D?AT00`3om^h0e3dI0=@m6@040?of
kP030000000aAi80<DNB0080e3dI1@0aAi800`000000<DNB0357TP060357TP040000000fCZ00e3dI
0=@m6@H0=TjP00<0000003I>X00fCZ001@0fCZ000`000000=TjP03I>X00203I>X080000000@0>UF/
0000003D?AT0e3dI1P0jEJ`00`000000>UF/0=@m6@0403YE[0030000000jEJ`0>UF/00<0>UF/00<0
000003iK]`0nFkL00`0nFkL010000000?U^g03iK]`3D?AT203iK]`030000000nFkL0?U^g0080?U^g
00<0e3dI03iK]`0nFkL00P0nFkL010000000?U^g03iK]`0nFkL200000080@V7200<000000?m>8@3o
CR400P0000030?m>80030000003oCR00odhP0080odhP00<0?EV[0?m>803oCR000P3oCR001P000000
odhP0?m>800mFJ/0odhP000000H0odhP00<000000?m=803oCB000`3oCB000`000000oddP0?m=8002
0?m=800303eIZ`3oCB00000000H0oddP0P0mFJ/010000000oddP0000000000040?m<7`030000003o
C1l0od`O00D0od`O00<000000?m<7`3oC1l0103oC1l203eIZ`030?m<7`000000odXN00L0odXN00<0
00000?m:7P3oBQh00`3oBQh203eIZ`80odXN00<000000?ofkP3om^h00P3om^h203eIZ`030?ofkP0m
FJ/0?EV[0080?EV[0P3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0
e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^01d0ooK^0P00
000]0?ofkP030000003om^h0ooK^0100ooK^0@3oool00180ooK^00<000000?ofkP3om^h0:P3om^h0
0`000000ooK^0?ofkP0O0?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h00`3om^h2
03eIZ`H0ooK^00<0?EV[0?ofkP3om^h0303om^h303eIZ`80ooK^103D?AT00`3om^h0e3dI0=@m6@03
0?ofkP040000000aAi80<DNB0357TP80e3dI100aAi800`000000<DNB0357TP030357TP040000003D
?AT0e3dI0=@m6@80=TjP0P3D?AT403I>X0030000000fCZ00=TjP00H0=TjP00@0000003I>X0000000
0000100jEJ`010000000>UF/0=@m6@3D?AT403YE[080e3dI1P0jEJ`01`000000>UF/03YE[00jEJ`0
000003iK]`0000001@0nFkL00`000000?U^g03iK]`020=@m6@0603iK]`000000?U^g03iK]`3D?AT0
0000100nFkL00`000000?U^g00000002000000<0@V7200@000000?m>8@3oCR40odhQ0`0000000`3o
CR0000000?m>80030?m>80060000000mFJ/0odhP0?m>80000000odhP0P0mFJ/20?m>80030000003o
CR00odhP00<0odhP00<000000?m>800000000`3oCB000`000000oddP0?m=80040?m=8080?EV[103o
CB0203eIZ`030?m=80000000oddP00<0oddP0P0000000`3oC1l000000?m<7`070?m<7`030000003o
C1l0od`O0080od`O0P0mFJ/20?m<7`<0?EV[00<000000?m:7P3oBQh00`3oBQh00`000000odXN0?m:
7P020?m:7P80?EV[0`3oBQh010000000ooK^0?ofkP3om^h203eIZ`030?ofkP0mFJ/0?EV[0080?EV[
0P3om^h30=@m6@h0ooK^00<0e3dI0?ofkP3om^h0103om^h20=@m6@D0ooK^00<0e3dI0?ofkP3om^h0
2@3om^h00`3D?AT0ooK^0?ofkP0O0?ofkP030000003om^h0ooK^02X0ooK^00<000000?ofkP3om^h0
403om^h10?ooo`004P3om^h00`000000ooK^0?ofkP0X0?ofkP8000008P3om^h00`0mFJ/0ooK^0?of
kP090?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?of
kP0<0?ofkP0303eIZ`3om^h0ooK^00@0ooK^103D?AT00`3om^h0e3dI0=@m6@020?ofkP030000003D
?AT0<DNB0080<DNB0P3D?AT30357TP040000000aAi80<DNB00000080e3dI0`0fCZ0010000000=TjP
03I>X00fCZ020=@m6@<0=TjP00<0000003I>X00fCZ001P0fCZ000`000000>UF/03YE[00503YE[003
0000000jEJ`0>UF/0080e3dI00@0>UF/0=@m6@0jEJ`000001P0jEJ`010000000>UF/000000000002
03iK]`030000000nFkL0?U^g00<0?U^g00<0000003iK]`0nFkL00P0nFkL20=@m6@0403iK]`3D?AT0
?U^g000000@0?U^g0P000002049Q`P0500000012HL80@V72049Q`P0000000`3oCR400`000000odhQ
0?m>8@02000000<0odhP00D000000?m>803oCR00?EV[0?m>800203eIZ`<0odhP00<000000?m>803o
CR00103oCR000`000000odhP0?m>8002000000030?m=80000000oddP00D0oddP00@000000?m=800m
FJ/0oddP0P0mFJ/20?m=80030000003oCB00oddP00D0oddP00<000000?m<7`3oC1l01P3oC1l01000
0000od`O0?m<7`3oC1l203eIZ`<0od`O00@000000?m<7`3oC1l0od`O0P0mFJ/010000000odXN0?m:
7P0000030?m:7P80?EV[0`3oBQh0100mFJ/000000?ofkP3om^h203eIZ`030?ofkP0mFJ/0?EV[0080
?EV[1P3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3o
m^h00P3om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^0200ooK^0P00000Z0?ofkP03
0000003om^h0ooK^0100ooK^0@3oool00180ooK^00<000000?ofkP3om^h09`3om^h00`000000ooK^
0?ofkP0R0?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h00P0mFJ/90?ofkP0303eI
Z`3om^h0ooK^00X0ooK^0`0mFJ/70?ofkPD0e3dI00D0ooK^0=@m6@3D?AT0ooK^0=@m6@050357TP80
e3dI0P0aAi830=@m6@H0=TjP00<0000003I>X00fCZ000P0fCZ020=@m6@80=TjP00<0000003I>X00f
CZ000`0fCZ020000000303YE[0000000>UF/00H0>UF/00D0000003YE[00jEJ`0>UF/0=@m6@0303YE
[0030000000jEJ`0>UF/00@0>UF/00<0000003iK]`0nFkL00`0nFkL00`000000?U^g03iK]`0303iK
]`030000000nFkL0?U^g0080?U^g00<000000=@m6@0nFkL00P0nFkL00`000000?U^g000000020000
00<0@V7200D00000049Q`P12HL80@V72000000030?m>8@040000003oCR40odhQ0?m>8@<0000000<0
odhP0000003oCR000P3oCR000`0mFJ/000000?m>80030?m>80030000003oCR00odhP00<0odhP00<0
00000?m>803oCR000`3oCR000`000000oddP0?m=80040?m=80050000003oCB00oddP0?m=800mFJ/0
0`3oCB000`000000oddP0?m=80050?m=80040000003oCB000000000000D0od`O00<000000?m<7`3o
C1l00P0mFJ/40?m<7`030000003oC1l0od`O00@0od`O0`0mFJ/20?m:7P80?EV[103oBQh00`0mFJ/0
00000?ofkP0203eIZ`030?ofkP0mFJ/0?EV[00<0?EV[1`3om^h30=@m6@`0ooK^00<0e3dI0?ofkP3o
m^h01`3om^h20=@m6@80ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP0R0?ofkP03
0000003om^h0ooK^02L0ooK^00<000000?ofkP3om^h0403om^h10?ooo`004@3om^h00`000000ooK^
0?ofkP0V0?ofkP8000009@3om^h00`0mFJ/0ooK^0?ofkP090?ofkP<0?EV[2`3om^h00`0mFJ/0ooK^
0?ofkP090?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/0203om^h50=@m6@040?ofkP3D?AT0e3dI0=@m
6@80<DNB1P3D?AT00`0fCZ00000003I>X00703I>X0030000000fCZ00=TjP00<0=TjP0P3D?AT0100f
CZ00000003I>X00fCZ02000000@0>UF/00<0000003YE[00jEJ`01@0jEJ`010000000e3dI0=@m6@0j
EJ`20=@m6@80>UF/00@0000003YE[00jEJ`0>UF/0P0000000`0nFkL0000003iK]`0403iK]`030000
000nFkL0?U^g0080?U^g00<0000003iK]`0nFkL00P0nFkL01@3D?AT000000=@m6@3D?AT0?U^g0080
00000P12HL801@000000@V72049Q`P12HL80000000<0@V7200D000000?m>8@3oCR40odhQ00000003
0?m>8@030000003oCR40odhQ0080000000D0odhP03eIZ`0mFJ/0000003eIZ`030?m>80030000003o
CR00odhP00<0odhP00<000000?m>803oCR000`3oCR00103D?AT0odhP0000000000030?m=80030000
003oCB00oddP0080?EV[00@0oddP03eIZ`0mFJ/000001`3oCB000`000000oddP0?m=80020?m=8080
00000P3oC1l010000000od`O03eIZ`0mFJ/50?m<7`030000003oC1l0od`O00H0od`O00<000000=@m
6@0mFJ/01@0mFJ/20?m:7P040=@m6@0mFJ/0?EV[0?ofkPD0?EV[203om^h01@3D?AT0ooK^0?ofkP3o
m^h0e3dI00X0ooK^00<0e3dI0?ofkP3om^h02P3om^h30=@m6@/0ooK^00<0e3dI0?ofkP3om^h08`3o
m^h2000002P0ooK^00<000000?ofkP3om^h03`3om^h10?ooo`004@3om^h00`000000ooK^0?ofkP0U
0?ofkP030000003om^h0ooK^02D0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP0<
0?ofkP0303eIZ`3om^h0ooK^00H0ooK^0P0mFJ/40?ofkP0303eIZ`3om^h0ooK^00P0ooK^2@3D?AT3
0357TP060000000fCZ00e3dI0=@m6@0fCZ000000200fCZ000`000000=TjP03I>X00403I>X0040=@m
6@0fCZ000000000000L0>UF/00<0000003YE[00jEJ`00`0jEJ`20=@m6@030000000jEJ`0>UF/0080
>UF/0P3D?AT010000000>UF/00000000000403iK]`030000000nFkL0?U^g0080?U^g00<0000003iK
]`0nFkL00`0nFkL01P000000?U^g0=@m6@3D?AT0?U^g00000080?U^g0P3D?AT4049Q`P0400000012
HL80@V72000000<0@V7200D000000?m>8@3oCR40odhQ000000020?m>8@030000003oCR40odhQ0080
odhQ0P0mFJ/20?m>80060000003oCR00?EV[03eIZ`3oCR0000001@3oCR000`000000odhP0?m>8002
0?m>80030000003oCR00odhP0080odhP0P000000103oCB00000003eIZ`0mFJ/40?m=80030000000m
FJ/0?EV[00D0oddP00<000000?m=803oCB001@3oCB02000000030?m<7`0mFJ/0od`O00D0od`O00<0
00000?m<7`3oC1l01P3oC1l01P000000od`O03eIZ`0mFJ/0od`O000000<0odXN2@0mFJ/:0?ofkP03
0=@m6@3om^h0ooK^0080ooK^0P3D?AT80?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3o
m^h02@3om^h00`3D?AT0ooK^0?ofkP0U0?ofkP030000003om^h0ooK^02D0ooK^00<000000?ofkP3o
m^h03`3om^h10?ooo`004@3om^h00`000000ooK^0?ofkP0T0?ofkP030000003om^h0ooK^02H0ooK^
00<0?EV[0?ofkP3om^h01`3om^h303eIZ`h0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^
0?ofkP040?ofkP0303eIZ`3om^h0ooK^00X0ooK^103D?AT0100mFJ/0ooK^0=@m6@3D?AT2000000@0
=TjP0P3D?AT00`000000=TjP03I>X00603I>X0030000000fCZ00=TjP00@0=TjP0P3D?AT00`000000
>UF/03YE[00603YE[0050000000jEJ`0>UF/03YE[03D?AT00`0jEJ`00`000000>UF/03YE[00303YE
[080e3dI1P0nFkL00`000000?U^g03iK]`0303iK]`030000000nFkL0?U^g0080?U^g00<000000=@m
6@0nFkL00`0nFkL200000080@V720P3D?AT2049Q`P0400000012HL80@V72000000<0@V7200D00000
0?m>8@3oCR40odhQ000000020?m>8@030000003oCR40odhQ0080?EV[0P3oCR42000000@0odhP00<0
?EV[0?m>803oCR000`3oCR000`000000odhP0?m>80030?m>80030000003oCR00odhP00@0odhP0P0m
FJ/50?m=80050000003oCB00oddP0?m=800mFJ/00`3oCB000`000000oddP0?m=80060?m=80030000
000mFJ/0?EV[00H0od`O00<000000?m<7`3oC1l01P3oC1l00`000000?EV[03eIZ`040?m<7`800000
0P0mFJ/00`3D?AT0ooK^03eIZ`0303eIZ``0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^
0?ofkP050?ofkP030=@m6@3om^h0ooK^00`0ooK^0`3D?AT90?ofkP030=@m6@3om^h0ooK^02H0ooK^
00<000000?ofkP3om^h0903om^h00`000000ooK^0?ofkP0?0?ofkP40oooo000A0?ofkP030000003o
m^h0ooK^0280ooK^0P00000Y0?ofkP0303eIZ`3om^h0ooK^00H0ooK^00@0?EV[0?ofkP3om^h0?EV[
3P3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h0
2`3om^h40=@m6@030?ofkP3D?AT0=TjP00L0=TjP0P3D?AT803I>X0040000000fCZ00=TjP03I>X080
00000P0jEJ`20=@m6@030000000jEJ`0>UF/00D0>UF/00<000000=@m6@3D?AT01@0jEJ`00`000000
>UF/03YE[00200000080?U^g0P3D?AT503iK]`030000000nFkL0?U^g0080?U^g00<0000003iK]`0n
FkL00P0nFkL00`3D?AT0000003iK]`0303iK]`0600000012HL80@V72049Q`P000000@V720P3D?AT0
1@000000@V72049Q`P12HL8000000080@V7200@000000?m>8@3oCR4000000`3oCR401@000000?EV[
03eIZ`3oCR40000000<0odhQ00<000000?m>803oCR000P3oCR000`000000?EV[0?m>80030?m>8003
0000003oCR00odhP0080odhP00<000000?m>803oCR000`3oCR0203eIZ`80odhP0P0000020?m=8003
0000003oCB00oddP00<0oddP0P0mFJ/00`000000oddP0?m=80050?m=80030000000mFJ/0?EV[0080
oddP0P0000030?m<7`030000003oC1l0od`O00H0od`O0P0mFJ/80?m<7`0303eIZ`3om^h0?EV[00<0
?EV[3@3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3o
m^h0303om^h0103D?AT0ooK^0?ofkP3D?AT80?ofkP030=@m6@3om^h0ooK^02L0ooK^0P00000T0?of
kP030000003om^h0ooK^00l0ooK^0@3oool00140ooK^00<000000?ofkP3om^h08@3om^h00`000000
ooK^0?ofkP0Y0?ofkP0303eIZ`3om^h0ooK^00@0ooK^0P0mFJ/40?ofkP0303eIZ`3om^h0ooK^00/0
ooK^00<0?EV[0?ofkP3om^h00P3om^h203eIZ`T0ooK^00<0?EV[0?ofkP3om^h03@3om^h50=@m6@03
0000000fCZ00=TjP00H0=TjP0P3D?AT703I>X0030000000fCZ00000000H0>UF/0P3D?AT503YE[080
e3dI00<0>UF/0000000jEJ`01@0jEJ`2000000D0?U^g00<000000=@m6@3D?AT0100nFkL00`000000
?U^g03iK]`0203iK]`060000000nFkL0?U^g0=@m6@0nFkL000000P0nFkL3000000<0@V7200@00000
049Q`P12HL80@V720P3D?AT2049Q`P0400000012HL80@V7200000080odhQ00<000000?m>8@3oCR40
0P0mFJ/30?m>8@030000003oCR40odhQ0080odhQ0P0000001@3oCR0000000?m>803oCR00?EV[0080
odhP00<000000?m>803oCR000P3oCR000`000000odhP0?m>80020?m>8080?EV[00<000000?m>803o
CR000`3oCR02000000H0oddP00@000000?m=800mFJ/0?EV[1@3oCB0203eIZ`H0oddP00<000000?m<
7`0000001`3oC1l203eIZ`P0od`O00<0000003eIZ`0mFJ/00`0mFJ/?0?ofkP030=@m6@3om^h0ooK^
00L0ooK^0P3D?AT40?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h00P3om^h20=@m
6@H0ooK^00<0e3dI0?ofkP3om^h0:@3om^h00`000000ooK^0?ofkP0Q0?ofkP030000003om^h0ooK^
00l0ooK^0@3oool00100ooK^00<000000?ofkP3om^h0803om^h2000002`0ooK^00<0?EV[0?ofkP3o
m^h00`3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00`0ooK^00@0?EV[0?ofkP3o
m^h0?EV[2`3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP80?EV[00<0ooK^0=@m6@3D?AT00P3D?AT00`00
0000=TjP03I>X00703I>X0030=@m6@0fCZ00=TjP00D0=TjP00<0000003YE[00jEJ`01`0jEJ`20=@m
6@0303YE[03D?AT0e3dI00@0>UF/00<0000003YE[00jEJ`00P0jEJ`00`000000?U^g0000000603iK
]`040000000nFkL0e3dI0=@m6@<0?U^g00<0000003iK]`0nFkL00P0nFkL00`000000e3dI03iK]`02
03iK]`8000000`12HL801@000000@V72049Q`P12HL80000000<0@V7200@000000=@m6@3D?AT00000
0P12HL8010000000odhQ0?m>8@00000203eIZ`050000003oCR40odhQ0?m>8@0000000`3oCR401000
0000odhQ0?m>8@3oCR42000000<0odhP00<0?EV[0000003oCR000`3oCR0010000000odhP0?m>803o
CR0203eIZ`030?m>80000000odhP00D0odhP00<000000?m>80000000103oCB000`000000oddP0?m=
80020?m=8080?EV[00<0oddP03eIZ`0mFJ/02@3oCB000`000000od`O0?m<7`050?m<7`0303eIZ`3o
C1l0od`O00L0od`O00<0000003eIZ`0mFJ/00P0mFJ/00`3om^h0e3dI0=@m6@0>0?ofkP030=@m6@3o
m^h0ooK^00T0ooK^00@0e3dI0?ofkP3om^h0e3dI3P3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m
6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h0:P3om^h200000280ooK^00<000000?ofkP3om^h0
3P3om^h10?ooo`00403om^h00`000000ooK^0?ofkP0O0?ofkP030000003om^h0ooK^02`0ooK^00@0
?EV[0?ofkP3om^h0ooK^0P0mFJ/70?ofkP0303eIZ`3om^h0ooK^00`0ooK^0`0mFJ/=0?ofkP0303eI
Z`3om^h0ooK^00X0ooK^00H0?EV[0?ofkP3om^h0ooK^03eIZ`3om^h40=@m6@T0=TjP0P3D?AT303I>
X080000000<0>UF/000000000000200jEJ`20=@m6@L0>UF/00@0000003YE[000000000000`0nFkL0
0`000000?U^g03iK]`0403iK]`030000000nFkL0?U^g0080e3dI0P0nFkL00`000000?U^g03iK]`02
0=@m6@80?U^g0P0000000`12HL800000049Q`P02049Q`P0500000012HL80@V72049Q`P0000000`12
HL800`000000@V72049Q`P020=@m6@03049Q`P000000odhQ0080?EV[0P3oCR401@000000odhQ0?m>
8@3oCR4000000080odhQ00<000000?m>8@3oCR400P3oCR4010000000odhQ0000000000020?m>8080
?EV[0P3oCR000`000000odhP0?m>800203eIZ`80odhP00<000000?m>803oCR00103oCR0010000000
odhP0?m>803oCR02000000030?m=80000000oddP00H0oddP0P0mFJ/80?m=8080000000<0oddP0000
000000000`3oC1l203eIZ`T0od`O100mFJ/00`3om^h0e3dI0?ofkP020?ofkP030=@m6@3om^h0ooK^
00X0ooK^00<0e3dI0?ofkP3om^h02`3om^h30=@m6@h0ooK^00<0e3dI0?ofkP3om^h01@3om^h20=@m
6@<0ooK^00<0e3dI0?ofkP3om^h0;03om^h00`000000ooK^0?ofkP0O0?ofkP030000003om^h0ooK^
00h0ooK^0@3oool00100ooK^00<000000?ofkP3om^h07@3om^h2000002l0ooK^00@0?EV[0?ofkP3o
m^h0?EV[2@3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?of
kP3om^h0203om^h203eIZ`D0ooK^00<0?EV[0?ofkP3om^h0103D?AT803I>X0040000003D?AT0e3dI
000000D0>UF/00<0000003YE[00jEJ`00P0jEJ`30=@m6@0403YE[0000000e3dI0=@m6@H0>UF/00<0
000003iK]`0nFkL0100nFkL00`000000?U^g03iK]`0403iK]`040000000nFkL0?U^g03iK]`80e3dI
00<0000003iK]`3D?AT00P0nFkL2000000<0@V7200<00000049Q`P12HL800P12HL8010000000@V72
049Q`P000003049Q`P0400000012HL80@V7200000080@V7200@000000?m>8@3oCR4000000P3oCR40
1@000000odhQ0?m>8@3oCR4000000080odhQ00<000000?m>8@3oCR400P3oCR4010000000odhQ0?m>
8@3oCR4200000080odhP00<0?EV[0?m>800000000P0mFJ/30?m>80030000003oCR00odhP00@0odhP
00<000000?m>803oCR00103oCR000`000000oddP0?m=80040?m=8080?EV[00<000000?m=800mFJ/0
0P0mFJ/40?m=80030000003oCB00oddP00<0oddP00@0000003eIZ`0mFJ/00000203oC1l403eIZ`80
ooK^00<0e3dI0?ofkP3om^h00`3om^h20=@m6@X0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0
ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00L0ooK^00@0e3dI0?ofkP3om^h0e3dI;`3om^h20000
01l0ooK^00<000000?ofkP3om^h03P3om^h10?ooo`00403om^h00`000000ooK^0?ofkP0L0?ofkP03
0000003om^h0ooK^02l0ooK^0`0mFJ/:0?ofkP0303eIZ`3om^h0ooK^00X0ooK^0`0mFJ/?0?ofkP03
03eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP020?ofkP@0
e3dI1`0fCZ0010000000>UF/0=@m6@3D?AT503YE[08000000P3D?AT503YE[08000000P3D?AT203YE
[080000000<0?U^g0000000000001@0nFkL00`000000?U^g03iK]`0403iK]`030000000nFkL0?U^g
0080?U^g0P3D?AT01@0nFkL0000000000012HL80000000@0@V7200D00000049Q`P12HL80@V720000
0003049Q`P0400000012HL80@V7200000080@V7200<00000049Q`P0000000P0000001@3oCR400000
0?m>8@3oCR4000000080odhQ00@000000?m>8@3oCR400000103oCR400`000000odhQ0?m>8@020?m>
8@050000003oCR4000000000003oCR000P0mFJ/40?m>80030000003oCR00odhP00@0odhP00<00000
0?m>803oCR000`3oCR02000000030?m>8000000000000080oddP0P0mFJ/2000000D0oddP0P0mFJ/2
000000D0oddP0P0mFJ/00`3oCB0000000?m<7`060?m<7`@0?EV[103om^h00`3D?AT0ooK^0?ofkP05
0?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h03@3om^h30=@m6@/0ooK^00<0e3dI
0?ofkP3om^h02@3om^h30=@m6C40ooK^00<000000?ofkP3om^h0703om^h00`000000ooK^0?ofkP0>
0?ofkP40oooo000?0?ofkP030000003om^h0ooK^01`0ooK^00<000000?ofkP3om^h0<03om^h00`0m
FJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00L0ooK^0P0mFJ/30?ofkP0303eIZ`3om^h0ooK^
00d0ooK^00<0?EV[0?ofkP3om^h0103om^h203eIZ`T0ooK^00<0?EV[0?ofkP3om^h00`3om^h40=@m
6@<0=TjP0P000000100jEJ`000000000000jEJ`20=@m6@80>UF/0`3D?AT2000000L0>UF/00@00000
03YE[03D?AT0e3dI1@0nFkL00`000000?U^g03iK]`0303iK]`8000001@0nFkL00`000000?U^g03iK
]`020=@m6@0303iK]`3D?AT0e3dI00<0@V7200D00000049Q`P12HL80@V7200000004049Q`P040000
0012HL80@V72000000<0@V7200L00000049Q`P000000000004EWc0000000odhQ0080000000<0odhQ
0000003oCR400P3oCR4010000000odhQ0?m>8@0000040?m>8@050000003oCR40odhQ0?m>8@000000
0`3oCR4203eIZ`030?m>800mFJ/0?EV[0080odhP00<000000?m>803oCR000`3oCR02000000D0odhP
00<000000?m>803oCR000`3oCR0203eIZ`030?m=80000000oddP00H0oddP0P00000303eIZ`80oddP
0P0mFJ/0103oCB0000000000003oCB02000000<0od`O100mFJ/50?ofkP030=@m6@3om^h0ooK^00L0
ooK^0P3D?AT60?ofkP030=@m6@3om^h0ooK^00d0ooK^00@0e3dI0?ofkP3om^h0ooK^0P3D?AT90?of
kP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h0<03om^h00`000000ooK^0?ofkP0L0?of
kP030000003om^h0ooK^00d0ooK^0@3oool000l0ooK^00<000000?ofkP3om^h06P3om^h2000003<0
ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00<0
ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP020?ofkP80?EV[2`3om^h00`0mFJ/0
ooK^0?ofkP050?ofkPl0e3dI1@0jEJ`00`000000>UF/03YE[00403YE[08000000P0nFkL20=@m6@@0
?U^g00<0000003iK]`0nFkL0100nFkL00`000000?U^g03iK]`0303iK]`80e3dI00D0?U^g00000000
0000@V72000000020=@m6@80@V7200D00000049Q`P12HL80@V7200000003049Q`P0400000012HL80
@V72000000<0@V720`00000204EWc0030000003oCR40odhQ00<000000`3oCR400`000000odhQ0000
00040?m>8@050000003oCR40odhQ0?m>8@0000000P3oCR4203eIZ`050000003oCR4000000000003o
CR000P0mFJ/50?m>80030000003oCR00odhP00@0odhP00<000000?m>803oCR000P3oCR0203eIZ`80
odhP0P0000060?m=80030000003oCB00oddP00<0oddP3`0mFJ/70?ofkP030=@m6@3om^h0ooK^00T0
ooK^0P3D?AT40?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0
ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h0<@3om^h2000001`0
ooK^00<000000?ofkP3om^h03@3om^h10?ooo`003`3om^h00`000000ooK^0?ofkP0I0?ofkP030000
003om^h0ooK^03<0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP040?ofkP80?EV[
1P3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/03P3om^h00`0mFJ/0
ooK^0?ofkP060?ofkP@0e3dI1P0jEJ`010000000>UF/0=@m6@3D?AT503YE[08000000P0jEJ`20000
0080?U^g0P00000203iK]`80e3dI0`0nFkL2000000D0?U^g00H0000003iK]`0nFkL0?U^g0=@m6@0n
FkL2000000@0@V7200<00000049Q`P3D?AT00P12HL801@000000@V72049Q`P12HL80000000<0@V72
00D00000049Q`P12HL800000049Q`P020000000504EWc0000000AFO<04EWc00000000P3oCR401P00
0000odhQ000000000000odhQ00000080odhQ00D000000?m>8@3oCR40odhQ000000030?m>8@060000
003oCR40odhQ03eIZ`3oCR400000103oCR42000000030?m>800mFJ/0odhP0080odhP00<000000?m>
803oCR000`3oCR02000000<0odhP0P0mFJ/20?m>808000000P3oCR0200000080oddP0P0000050?m=
8080?EV[00<0oddP0000003oCB001@3oCB0403eIZ`P0ooK^00<0e3dI0?ofkP3om^h0303om^h01@3D
?AT0ooK^0?ofkP3om^h0e3dI00l0ooK^00<0e3dI0?ofkP3om^h0103om^h20=@m6@H0ooK^00<0e3dI
0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP0c0?ofkP030000003om^h0ooK^01T0ooK^00<00000
0?ofkP3om^h03@3om^h10?ooo`003`3om^h00`000000ooK^0?ofkP0G0?ofkP800000=P3om^h00`0m
FJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0m
FJ/0ooK^0?ofkP0=0?ofkP<0?EV[3`3om^h00`0mFJ/0ooK^0?ofkP070?ofkP030000003D?AT0e3dI
0080e3dI1@0jEJ`20000000303YE[03D?AT0e3dI00D0>UF/0P00000603iK]`8000000P0nFkL20=@m
6@<0?U^g00<0000003iK]`0nFkL00`0nFkL00`000000e3dI0=@m6@0200000003049Q`P000000@V72
00@0@V7200D00000049Q`P3D?AT0e3dI00000003049Q`P0500000012HL80@V72049Q`P0000000P12
HL820000000404EWc0000000AFO<0=@m6@80AFO<00L000000?m>8@3oCR40?EV[0?m>8@000000odhQ
0080000000<0odhQ0000003oCR400`3oCR401@000000odhQ0?m>8@3oCR4000000080?EV[00<0odhQ
0000003oCR40103oCR4010000000odhQ00000000000203eIZ`030000003oCR00odhP00<0odhP00@0
00000?m>803oCR00odhP0P0mFJ/20?m>808000001P3oCR02000000D0oddP0P0mFJ/00`3oCB000000
000000050?m=80@0?EV[00<000000?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP<0e3dI
3`3om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h0
2`3om^h00`3D?AT0ooK^0?ofkP0d0?ofkP8000006@3om^h00`000000ooK^0?ofkP0=0?ofkP40oooo
000?0?ofkP030000003om^h0ooK^01H0ooK^00<000000?ofkP3om^h0=`3om^h00`0mFJ/0ooK^0?of
kP0;0?ofkP0303eIZ`3om^h0ooK^0080?EV[2P3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3o
m^h0ooK^0100ooK^00<0?EV[0?ofkP3om^h0203om^h203eIZ`0303YE[03D?AT0e3dI00D0>UF/0P00
00000`0jEJ`0e3dI0=@m6@0203YE[0040000000nFkL00000000000L0?U^g00@0000003iK]`0nFkL0
?U^g0P3D?AT203iK]`040000000nFkL0?U^g03iK]`80e3dI0P000004049Q`P8000001012HL800`00
0000@V72049Q`P020=@m6@<0@V7200@00000049Q`P12HL80@V720`00000204EWc00;0000003D?AT0
AFO<00000015Il`000000?m>8@000000odhQ03eIZ`0000000P3oCR43000000<0odhQ00@000000?m>
8@3oCR40odhQ0P0mFJ/20?m>8@030000003oCR40odhQ0080odhQ0P0000040?m>8@8000000P0mFJ/3
0?m>80030000003oCR00odhP0080?EV[0`3oCR000`000000odhP0?m>80050?m>8080000000@0odhP
0000003oCB00oddP0P0mFJ/00`3oCB000000000000050?m=8080?EV[00<0oddP0=@m6@3D?AT02P3o
m^h00`3D?AT0ooK^0?ofkP0@0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h0203o
m^h20=@m6@80ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP0g0?ofkP030000003o
m^h0ooK^01H0ooK^00<000000?ofkP3om^h03@3om^h10?ooo`003P3om^h00`000000ooK^0?ofkP0E
0?ofkP800000>P3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP<0?EV[303om^h00`0mFJ/0ooK^0?ofkP0;
0?ofkP80?EV[00<0ooK^03eIZ`3om^h0403om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0
ooK^0080000000<0>UF/0=@m6@3D?AT01@0jEJ`20000000303YE[03D?AT0e3dI00@0?U^g0P000006
03iK]`8000000`0nFkL20=@m6@0403iK]`000000e3dI0=@m6@80000000<0@V720000000000001@12
HL801@000000@V72049Q`P12HL80000000@0@V7200D0e3dI049Q`P12HL80000003eIZ`0300000080
AFO<00l0000004EWc03D?AT0000004EWc0000000AFO<0000003oCR4000000?m>8@000000?EV[0?m>
8@0000000`3oCR42000000050?m>8@000000odhQ0?m>8@0mFJ/0103oCR401@000000odhQ0?m>8@3o
CR40000000D0odhQ0P0000000`3oCR4000000000000203eIZ`040000003oCR00?EV[03eIZ`<0odhP
0P0000060?m>80800000103oCR0203eIZ`030?m=80000000000000D0oddP0P0mFJ/00`3oCB000000
000000020?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h03`3om^h0103D?AT0ooK^
0=@m6@3D?AT<0?ofkP030=@m6@3om^h0ooK^00/0ooK^0`3D?AT=0?ofkP030=@m6@3om^h0ooK^03P0
ooK^0P00000G0?ofkP030000003om^h0ooK^00`0ooK^0@3oool000h0ooK^00<000000?ofkP3om^h0
503om^h00`000000ooK^0?ofkP0j0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h0
3@3om^h00`0mFJ/0ooK^0?ofkP080?ofkP80?EV[0`3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0303eI
Z`3om^h0ooK^00@0ooK^0P0mFJ/50?ofkP80000000<0>UF/0=@m6@3D?AT01@0jEJ`20000000303iK
]`3D?AT0e3dI00@0?U^g0P00000603iK]`8000000`0nFkL20=@m6@0303iK]`000000@V7200@0@V72
00<00000049Q`P12HL800`12HL801@000000@V72049Q`P12HL80000000@0@V720P3D?AT00`12HL80
000004EWc00204EWc00C00000015Il`000000=@m6@15Il`0000004EWc0000000AFO<0000003oCR40
00000?m>8@000000odhQ03eIZ`000000odhQ000000030?m>8@040000003oCR40?EV[03eIZ`@0odhQ
00D000000?m>8@3oCR40odhQ000000050?m>8@030000003oCR40odhQ00<0odhQ00@000000?m>800m
FJ/0?EV[0`3oCR02000000H0odhP0P0000040?m>8080?EV[00<0odhP0000000000001@3oCB0203eI
Z`030?m=80000000000000D0ooK^0P3D?AT60?ofkP030=@m6@3om^h0ooK^0100ooK^00@0e3dI0?of
kP3om^h0ooK^0P3D?AT:0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h02`3om^h0
0`3D?AT0ooK^0?ofkP0j0?ofkP030000003om^h0ooK^01@0ooK^00<000000?ofkP3om^h0303om^h1
0?ooo`003P3om^h00`000000ooK^0?ofkP0C0?ofkP030000003om^h0ooK^03/0ooK^00<0?EV[0?of
kP3om^h02@3om^h303eIZ`l0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP040?of
kP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP070?of
kP80000000<0>UF/0=@m6@3D?AT00P0jEJ`00`000000?U^g03iK]`020000000303iK]`3D?AT0e3dI
00@0?U^g0P00000603iK]`<0e3dI00@0?U^g0000003D?AT0e3dI0P000004049Q`P0300000012HL80
@V7200<0@V7200D00000049Q`P12HL80@V7200000003049Q`P0503eIZ`000000e3dI0=@m6@000000
0P15Il`040000000e3dI0=@m6@000000AFO<00000015Il`0000004EWc0000000odhQ0000003oCR40
00000?m>8@00000203eIZ`<0odhQ00@0000003eIZ`0mFJ/00000103oCR401@000000odhQ0?m>8@3o
CR40000000D0odhQ00<000000?m>8@3oCR400P3oCR4200000080?EV[00<000000?m>800mFJ/00P0m
FJ/60?m>80800000103oCR0203eIZ`030?m>8000000000000080odhP00<000000?m=803oCB000P0m
FJ/00`3oCB000000000000090?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h03`3o
m^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h03@3o
m^h30=@m6@/0ooK^00<0e3dI0?ofkP3om^h0>`3om^h00`000000ooK^0?ofkP0C0?ofkP030000003o
m^h0ooK^00`0ooK^0@3oool000h0ooK^00<000000?ofkP3om^h04@3om^h2000003h0ooK^00<0?EV[
0?ofkP3om^h01`3om^h203eIZ`<0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP04
0?ofkP80?EV[1`3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/0303o
m^h20000000303YE[03D?AT0e3dI00D0?U^g0P0000000`0nFkL0e3dI0=@m6@0403iK]`8000000P0n
FkL20=@m6@80?U^g0P000003049Q`P80e3dI0P000003049Q`P8000001012HL8200000080@V7202<0
0000049Q`P000000000004EWc0000000AFO<0=@m6@000000AFO<0=@m6@000000AFO<00000015Il`0
000004EWc0000000AFO<0000003oCR4000000?m>8@000000odhQ0000003oCR40000003eIZ`3oCR40
000003eIZ`3oCR4000000?m>8@02000000040?m>8@000000odhQ0?m>8@800000103oCR42000000<0
odhQ0P00000203eIZ`<0odhQ0P0000020?m>8080?EV[0P3oCR02000000@0odhP0P0mFJ/00`3oCR00
0000000000050?m>8080?EV[00<0oddP000000000000303om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI
0180ooK^00<0e3dI0?ofkP3om^h01@3om^h20=@m6@H0ooK^00<0e3dI0?ofkP3om^h03@3om^h0103D
?AT0ooK^0?ofkP3om^h20=@m6@T0ooK^00<0e3dI0?ofkP3om^h0?03om^h2000001<0ooK^00<00000
0?ofkP3om^h0303om^h10?ooo`003@3om^h00`000000ooK^0?ofkP0A0?ofkP030000003om^h0ooK^
03h0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^
00d0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^
00l0ooK^00@0?EV[0?ofkP0mFJ/0?EV[3`3om^h20000000303iK]`3D?AT0e3dI00D0?U^g0`000002
0=@m6@<0?U^g0`3D?AT203iK]`8000000P12HL82000000<0@V720P3D?AT00`000000@V72049Q`P02
049Q`P0300000012HL80@V7200<0@V7200@00000049Q`P12HL8000001015Il`00`000000AFO<0=@m
6@020=@m6@0800000015Il`0000004EWc0000000AFO<00000015Il`200000080odhQ00D000000?m>
8@00000000000?m>8@0303eIZ`030?m>8@000000odhQ00<0odhQ00@000000?m>8@3oCR4000001@3o
CR400`000000odhQ0?m>8@020?m>8@030000000mFJ/0?EV[00<0odhQ0P0000020?m>8@8000000P3o
CR0303eIZ`<0odhP0P0mFJ/3000000D0odhP0P0mFJ/00`3oCR0000000000000?0?ofkP80e3dI00<0
ooK^0=@m6@3om^h0403om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0
e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0
e3dI0?ofkP3om^h0?P3om^h00`000000ooK^0?ofkP0@0?ofkP030000003om^h0ooK^00`0ooK^0@3o
ool000d0ooK^00<000000?ofkP3om^h03`3om^h200000440ooK^00<0?EV[0?ofkP3om^h0103om^h2
03eIZ`H0ooK^00<0?EV[0?ofkP3om^h03@3om^h0100mFJ/0ooK^0?ofkP3om^h203eIZ`/0ooK^00<0
?EV[0?ofkP3om^h0403om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP<000003@3D?AT303iK]`8000001P12
HL82000000<0@V7200<0e3dI0000000000000`12HL800`000000@V72049Q`P02049Q`P0503eIZ`00
0000000004EWc00000001015Il`20=@m6@0500000015Il`0e3dI0=@m6@15Il`00P00000204EWc0<0
00000P3oCR42000000050?m>8@0mFJ/0?EV[0?m>8@0000000P0mFJ/40?m>8@040000003oCR400000
000000D0odhQ00@000000?m>8@3oCR40odhQ0P000000100mFJ/0odhQ0?m>8@3oCR42000000H0odhQ
0P0000030?m>80d0?EV[0`00000C0?ofkP030=@m6@3om^h0ooK^0100ooK^00<0e3dI0?ofkP3om^h0
2@3om^h20=@m6@<0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP040?ofkP80e3dI
1P3om^h00`3D?AT0ooK^0?ofkP0o0?ofkP8000004@3om^h00`000000ooK^0?ofkP0;0?ofkP40oooo
000=0?ofkP030000003om^h0ooK^00h0ooK^00<000000?ofkP3om^h0@P3om^h00`0mFJ/0ooK^0?of
kP020?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h03P3om^h303eIZ`h0ooK^00<0
?EV[0?ofkP3om^h03@3om^h203eIZ`030?ofkP0mFJ/0ooK^01<0ooK^00<0?EV[0000000000000P3D
?AT603iK]`8000000P3D?AT200000080@V720P000006049Q`P8000000P12HL820=@m6@8000000P12
HL820000000403eIZ`000000000004EWc080000000<0AFO<0000000000000P3D?AT01P000000AFO<
04EWc0000000AFO<00000080e3dI00<0AFO<00000015Il`00`0000000`3oCR4000000?m>8@0203eI
Z`80odhQ00@000000?m>8@000000odhQ0P0mFJ/200000080odhQ00D000000?m>8@00000000000?m>
8@0200000080odhQ0P00000203eIZ`80odhQ0P0000060?m>8@8000000P3oCR4200000080?EV[0P00
00060?m>8080?EV[0P0000000`3D?AT0ooK^0?ofkP0B0?ofkP040=@m6@3om^h0e3dI0=@m6@l0ooK^
00<0e3dI0?ofkP3om^h0303om^h30=@m6A00ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^
0?ofkP020?ofkP030=@m6@3om^h0ooK^0480ooK^00<000000?ofkP3om^h03P3om^h00`000000ooK^
0?ofkP0;0?ofkP40oooo000=0?ofkP030000003om^h0ooK^00`0ooK^0P0000150?ofkP0303eIZ`3o
m^h0ooK^0080?EV[2P3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0
?EV[0?ofkP3om^h02P3om^h203eIZ`<0ooK^00<0?EV[0?ofkP3om^h04`3om^h01@0mFJ/000000000
00000000e3dI00L0?U^g0P0000020=@m6@@0@V720`000005049Q`P8000000P12HL820=@m6@800000
0P12HL82000000@0AFO<00@000000=@m6@3D?AT000000P15Il`02P000000AFO<04EWc0000000AFO<
00000015Il`0e3dI00000015Il`3000000070?m>8@000000?EV[0?m>8@000000odhQ000000020?m>
8@040000003oCR40odhQ00000080?EV[00<000000?m>8@3oCR400`3oCR400`000000odhQ0?m>8@02
00000080?EV[0P3oCR42000000D0odhQ0`0000040?m>8@80?EV[0P0000070?m>800503eIZ`000000
00000000003D?AT05@3om^h0103D?AT0ooK^0?ofkP3om^h20=@m6@`0ooK^00<0e3dI0?ofkP3om^h0
3`3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00P0ooK^0P3D?AT20?ofkP030=@m
6@3om^h0ooK^04<0ooK^0P00000>0?ofkP030000003om^h0ooK^00/0ooK^0@3oool000d0ooK^00<0
00000?ofkP3om^h02`3om^h00`000000ooK^0?ofkP150?ofkP<0?EV[303om^h00`0mFJ/0ooK^0?of
kP0;0?ofkP<0?EV[4@3om^h00`0mFJ/0ooK^0?ofkP080?ofkP80?EV[1P3om^h00`0mFJ/0ooK^0?of
kP0B0?ofkP0403eIZ`3om^h0?EV[03eIZ`@000000`0nFkL200000080@V7200<000000=@m6@3D?AT0
1@12HL82000000D0@V720P000002049Q`P80e3dI0P00000204EWc080000000@0AFO<0=@m6@3D?AT0
00000P15Il`02@000000AFO<04EWc0000000AFO<00000015Il`0000004EWc00:00000080odhQ00<0
00000?m>8@0000000P3oCR4010000000odhQ0?m>8@00000203eIZ`80odhQ00<000000?m>8@3oCR40
0P00000203eIZ`80odhQ0P0000050?m>8@8000001@3oCR4203eIZ`030000003oCR40odhQ00800000
0`3oCR0400000080e3dI00<0ooK^0=@m6@3om^h04`3om^h00`3D?AT0ooK^0?ofkP040?ofkP80e3dI
2P3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP040=@m6@3om^h0e3dI0=@m6@d0ooK^00<0e3dI0?ofkP3o
m^h02P3om^h30=@m6DL0ooK^00<000000?ofkP3om^h02`3om^h00`000000ooK^0?ofkP0;0?ofkP40
oooo000<0?ofkP030000003om^h0ooK^00/0ooK^00<000000?ofkP3om^h0AP3om^h00`0mFJ/0ooK^
0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00X0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0A0?ofkP03
03eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP06
03eIZ`3om^h0ooK^0?ofkP000000RBdD1@000006049Q`P80e3dI00<00000049Q`P12HL800P12HL83
000000@0@V720`0000000`15Il`0e3dI0=@m6@020000000404EWc03D?AT0e3dI00000080AFO<0P00
00002015Il`0000000000015Il`0000004EWc0000000AFO<0`0000001@18K=D00000000000000000
oddP00<0000000D0odhQ0000003oCR4000000?m>8@02000000030?m>8@00000000000080odhQ00@0
000003eIZ`0mFJ/0odhQ0P00000203eIZ`040?m>8@0000000000000000@0odhQ0`0000040?m>8@03
0000000mFJ/0?EV[00H0odhQ1`0000030?ofkP030=@m6@3om^h0ooK^0180ooK^00<0e3dI0?ofkP3o
m^h01`3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00l0ooK^00D0e3dI0?ofkP3o
m^h0ooK^0=@m6@0<0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h0AP3om^h00`00
0000ooK^0?ofkP0;0?ofkP030000003om^h0ooK^00X0ooK^0@3oool000`0ooK^00<000000?ofkP3o
m^h02@3om^h2000004T0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP080?ofkP80
?EV[103om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00@0ooK^0P0mFJ/:0?ofkP03
03eIZ`3om^h0ooK^0100ooK^0P0mFJ/00`3om^h0?EV[0?ofkP030?ofkP80000000<0RBdD00000000
000010000004049Q`P80e3dI0P000004049Q`P8000000P12HL800`000000AFO<04EWc003000000<0
e3dI00<0000004EWc015Il`00P00000204EWc00500000015Il`0AFO<00000015Il`00`0000000`18
K=D0000000000007000000060?m=8000000000000000003oCR4000000P3oCR400`000000odhQ0?m>
8@0200000080odhQ00D0000003eIZ`0mFJ/0?EV[0?m>8@0200000080odhQ00<000000?m>8@3oCR40
0P0000040?m>8@8000000P0mFJ/40?m>8@T00000103om^h0103D?AT0ooK^0=@m6@3D?ATB0?ofkP03
0=@m6@3om^h0ooK^00P0ooK^0P3D?AT60?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3o
m^h00`3om^h20=@m6@X0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP170?ofkP80
00002`3om^h00`000000ooK^0?ofkP0:0?ofkP40oooo000<0?ofkP030000003om^h0ooK^00P0ooK^
00<000000?ofkP3om^h0BP3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00H0ooK^
00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0403eIZ`3om^h0ooK^0?ofkP80
?EV[3@3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP80?EV[103om^h00`0mFJ/0ooK^0?ofkP030?ofkPD0
00000P2m>aX400000080@V720P3D?AT3000000<0@V72100000001015Il`0e3dI0=@m6@3D?AT20000
0080e3dI0`0000001015Il`0000000000015Il`20000000504EWc0000000B6cE00000018K=D02`00
00001@3oCB0000000?m=80000000odhQ0080000000@0odhQ000000000000odhQ0`00000203eIZ`80
00000`0mFJ/30?m>8@8000000`3oCR4300000080?EV[0P3oCR440000000304Ybg0000000000000@0
00001@3om^h00`3D?AT0ooK^0?ofkP020?ofkP80e3dI3`3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP80
e3dI0`3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3o
m^h01P3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^04X0ooK^00<000000?ofkP3o
m^h0203om^h00`000000ooK^0?ofkP0:0?ofkP40oooo000<0?ofkP030000003om^h0ooK^00H0ooK^
0P00001=0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h0103om^h203eIZ`P0ooK^
00<0?EV[0?ofkP3om^h03`3om^h0100mFJ/0ooK^03eIZ`0mFJ/@0?ofkP0303eIZ`3om^h0ooK^00/0
ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP030?ofkPT0000000<0_C/J00000000
00000P0000020=@m6@03049Q`P00000000000080000000@0AFO<0=@m6@3D?AT0e3dI100000001015
Il`000000000003D?AT204EWc080000000<0AFO<0000000000000P0000001@18K=D0000000000000
0000B6cE00D0000000D0oddP00000000000000000?m=8003000000030?m=80000000000000800000
00<0odhQ0000000000000P3oCR400`0mFJ/00000000000030?m>8@8000000`0mFJ/00`3oCR400000
00000002000000030?m>8@0mFJ/0?EV[00@0000000<0BW;L0000000000001`0000050?ofkP030=@m
6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP80e3dI
00<0ooK^0=@m6@3om^h03`3om^h00`3D?AT0ooK^0?ofkP070?ofkP80e3dI1P3om^h00`3D?AT0ooK^
0?ofkP0<0?ofkP030=@m6@3om^h0ooK^04/0ooK^0P0000080?ofkP030000003om^h0ooK^00X0ooK^
0@3oool000`0ooK^00<000000?ofkP3om^h01@3om^h00`000000ooK^0?ofkP1=0?ofkP0303eIZ`3o
m^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h00P3om^h203eIZ`/0ooK^00<0?EV[0?ofkP3om^h03`3o
m^h00`0mFJ/0ooK^0?ofkP0A0?ofkP0303eIZ`3om^h0ooK^00P0ooK^0P0mFJ/90?ofkP0303eIZ`3o
m^h0ooK^00@0ooK^0P0000001@29;A@00000000000000000_C/J00@0000000<0_C/J000000000000
0`00000204EWc0D000000`15Il`400000080e3dI00<0000004EWc00000000P0000001@18K=D00000
000000000000B6cE0080000000<0B6cE0000000000001@000000103oCB0000000000003oCB030000
00060?m=8000000000000000003oCR4000000P0mFJ/0103oCR4000000000000000030?m>8@D00000
0P3oCR4500000080BW;L1`0000000`13JLP00000000000060?ofkP030=@m6@3om^h0ooK^00L0ooK^
0P3D?AT:0?ofkP030=@m6@3om^h0ooK^0140ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^
0?ofkP090?ofkP80e3dI103om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^04d0ooK^
00<000000?ofkP3om^h01@3om^h00`000000ooK^0?ofkP0:0?ofkP40oooo000;0?ofkP030000003o
m^h0ooK^00@0ooK^0P00001A0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00D0?EV[0?ofkP3om^h0ooK^
03eIZ`0=0?ofkP0303eIZ`3om^h0ooK^00d0ooK^0P0mFJ/00`3om^h0?EV[0?ofkP0A0?ofkP0303eI
Z`3om^h0ooK^00H0ooK^0P0mFJ/<0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00@0?EV[00000029;A@0
RBdD20000000100mFJ/000000000003D?AT60000000304EWc0000000000000<000000`15Il`00`00
0000e3dI0000000N0000000403eIZ`000000odhQ0?m>8@H0000000<0odhQ00000000000010000000
100mFJ/0000004Ybg03D?AT80000000404=Yb000000000000=@m6@H0ooK^00<0e3dI0?ofkP3om^h0
2P3om^h20=@m6@P0ooK^00<0e3dI0?ofkP3om^h0403om^h0103D?AT0ooK^0=@m6@3D?AT>0?ofkP03
0=@m6@3om^h0ooK^00`0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0=0?ofkP030=@m6@3om^h0ooK^
04l0ooK^0P0000060?ofkP030000003om^h0ooK^00T0ooK^0@3oool000/0ooK^00<000000?ofkP3o
m^h00`3om^h00`000000ooK^0?ofkP1A0?ofkP0303eIZ`3om^h0ooK^00`0ooK^0`0mFJ/?0?ofkP03
03eIZ`3om^h0ooK^00X0ooK^0P0mFJ/30?ofkP0303eIZ`3om^h0ooK^0140ooK^00<0?EV[0?ofkP3o
m^h0103om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3o
m^h01P0000000`2m>aX0?EV[03eIZ`04000000H0hdDM1@00000204EWc2L0000000<0odhQ00000000
00001000000304adh@L000000P3D?AT700000080ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0
ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h04@3om^h0103D?AT0
ooK^0?ofkP3om^h20=@m6@`0ooK^00<0e3dI0?ofkP3om^h03@3om^h30=@m6@h0ooK^00<0e3dI0?of
kP3om^h0D@3om^h00`000000ooK^0?ofkP030?ofkP030000003om^h0ooK^00T0ooK^0@3oool000/0
ooK^00<000000?ofkP3om^h00P3om^h00`000000ooK^0?ofkP1B0?ofkP0303eIZ`3om^h0ooK^00`0
ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP080?ofkP80?EV[1P3om^h00`0mFJ/0
ooK^0?ofkP0A0?ofkP0403eIZ`3om^h0ooK^0?ofkP80?EV[403om^h00`0mFJ/0ooK^0?ofkP030?of
kP0303eIZ`3om^h0ooK^0080ooK^0`00000203eIZ`030000002m>aX0000000h0000000<0hdDM0000
000000009`0000000`1<M>4000000000000=0000000404Ybg0000000e3dI0=@m6@<00000103om^h0
0`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00h0ooK^0P3D?AT30?ofkP030=@m6@3om^h0
ooK^0140ooK^00<0e3dI0?ofkP3om^h0103om^h20=@m6@T0ooK^00<0e3dI0?ofkP3om^h0403om^h0
0`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^05<0ooK^00<000000?ofkP3om^h00P3om^h0
0`000000ooK^0?ofkP090?ofkP40oooo000;0?ofkP030000003om^h0ooK^00800000EP3om^h00`0m
FJ/0ooK^0?ofkP090?ofkP80?EV[00<0ooK^03eIZ`3om^h0403om^h00`0mFJ/0ooK^0?ofkP060?of
kP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h0403om^h0100mFJ/0ooK^03eIZ`0mFJ/C
0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h00`3om^h203eIZ`D000001@2m>aX3
0000000303eIZ`3SAAd0hdDM0080hdDM<@000000103D?AT0000000000000000304Ybg0@0000000<0
@fW80000000000000P3D?AT50?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h04@3o
m^h20=@m6@030?ofkP3D?AT0ooK^0140ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?of
kP060?ofkP030=@m6@3om^h0ooK^00l0ooK^00@0e3dI0?ofkP3D?AT0e3dI2`3om^h00`3D?AT0ooK^
0?ofkP1D0?ofkP8000000P3om^h00`000000ooK^0?ofkP090?ofkP40oooo000:0?ofkP040000003o
m^h0ooK^000005P0ooK^00<0?EV[0?ofkP3om^h01`3om^h203eIZ`<0ooK^00<0?EV[0?ofkP3om^h0
3`3om^h00`0mFJ/0ooK^0?ofkP040?ofkP80?EV[2P3om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP0303eI
Z`3om^h0ooK^01@0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`030?ofkP80?EV[0`3om^h<00000003
0;dk6P0mFJ/0hdDM00@0hdDM100000000`0mFJ/000000000000M000000030=@m6@00000000000080
00001@1<M>400`3D?AT0BW;L04Ybg00;000000<0ooK^0P3D?AT30?ofkP050=@m6@3om^h0ooK^0?of
kP3D?AT05P3om^h00`3D?AT0ooK^0?ofkP0A0?ofkP030=@m6@3om^h0ooK^00P0ooK^0P3D?AT50?of
kP030=@m6@3om^h0ooK^0100ooK^00@0e3dI0?ofkP3om^h0ooK^0P3D?AT90?ofkP030=@m6@3om^h0
ooK^05H0ooK^00@000000?ofkP3om^h000002P3om^h10?ooo`002P3om^h3000005X0ooK^00<0?EV[
0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00l0ooK^00@0?EV[
0?ofkP3om^h0ooK^0P0mFJ/=0?ofkP0303eIZ`3om^h0ooK^00h0ooK^0P0mFJ/00`3om^h0?EV[0?of
kP0E0?ofkP0503eIZ`3om^h0ooK^03eIZ`3om^h00P0mFJ/40?ofkP80?EV[00@0ooK^00000029;A@0
RBdD0P0000050;dk6P8000000P0mFJ/500000080?EV[8@0000020=@m6@D000000P3D?AT900000004
04=Yb000000000000?ofkP80e3dI103om^h20=@m6@050?ofkP3D?AT0ooK^0?ofkP3D?AT05P3om^h0
103D?AT0ooK^0=@m6@3D?AT@0?ofkP030=@m6@3om^h0ooK^00/0ooK^0P3D?AT30?ofkP030=@m6@3o
m^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3o
m^h0ooK^05P0ooK^0`00000:0?ofkP40oooo000:0?ofkP800000F`3om^h00`0mFJ/0ooK^0?ofkP03
0?ofkP80?EV[1`3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0403eIZ`3om^h0?EV[03eIZa00ooK^00<0
?EV[0?ofkP3om^h02`3om^h203eIZ`@0ooK^00<0?EV[0?ofkP3om^h0503om^h0100mFJ/0ooK^03eI
Z`0mFJ/40?ofkP80?EV[1@3om^h5000000<0_C/J100000000`0mFJ/000000000000203eIZ`800000
0P3SAAd6000000030?Q:7`000000000000d0000000<0Bg7M0000000000001P1<M>4200000080e3dI
0P0000000`3D?AT0000000000002000000<0BW;L1@0000050?ofkP80e3dI103om^h20=@m6@030?of
kP3D?AT0ooK^01D0ooK^00<0e3dI0?ofkP3om^h00P3om^h20=@m6@d0ooK^00<0e3dI0?ofkP3om^h0
3P3om^h30=@m6A80ooK^00<0e3dI0?ofkP3om^h01@3om^h20=@m6@D0ooK^00<0e3dI0?ofkP3om^h0
F@3om^h2000000X0ooK^0@3oool000`0ooK^0P00001I0?ofkP0403eIZ`3om^h0ooK^0?ofkP80?EV[
2P3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^0140ooK^00<0?EV[0?ofkP3om^h0
203om^h203eIZ`L0ooK^00<0?EV[0?ofkP3om^h0503om^h00`0mFJ/0ooK^03eIZ`020?ofkP80?EV[
203om^h00`0mFJ/000000000000900000080?EV[1P0000040>=57@@0000000<0n4XO0000003hBQl0
100000001P1;LMd000000000001;LMd0000004]ag@<000001@1<M>4600000080e3dI2`0000000`3D
?AT0ooK^0?ofkP060?ofkP80e3dI0P3om^h00`3D?AT0ooK^0=@m6@0F0?ofkP030=@m6@3om^h0ooK^
00D0ooK^0P3D?AT:0?ofkP030=@m6@3om^h0ooK^0140ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D
?AT0ooK^0?ofkP080?ofkP80e3dI0`3om^h00`3D?AT0ooK^0?ofkP1G0?ofkP800000303om^h10?oo
o`003P3om^h2000005P0ooK^0`0mFJ/=0?ofkP0303eIZ`3om^h0ooK^00`0ooK^0P0mFJ/00`3om^h0
?EV[0?ofkP0A0?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0
ooK^0?ofkP0A0?ofkP80?EV[00<0ooK^03eIZ`0mFJ/00P0mFJ/:0?ofkP0303eIZ`3om^h0000000D0
00000P2m>aX203eIZ`030;dk6P0mFJ/0?EV[008000000`3SAAd500000080hdDM0P0000000`3hBQl0
0000000000070000000304]ag@00000000000080C7CQ1@00000304adh@8000000P3D?AT00`1:L]`0
e3dI0=@m6@0204Ybg0H0000000<0e3dI0?ofkP3om^h02@3om^h40=@m6@030?ofkP3D?AT0e3dI01<0
ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^0100
ooK^00@0e3dI0?ofkP3D?AT0e3dI3P3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP<0e3dIF03om^h20000
00h0ooK^0@3oool00100ooK^0`00001E0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3o
m^h02P3om^h203eIZ`<0ooK^00<0?EV[0?ofkP3om^h04@3om^h00`0mFJ/0ooK^0?ofkP040?ofkP80
?EV[303om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP80?EV[103om^h203eIZ``0ooK^00<0?EV[0?ofkP3o
m^h00`0000000`29;A@0?EV[03eIZ`0500000080?EV[0`0000000`3SAAd00000000000030>=57@80
000000D0hdDM00000000000000000?Q:7`030000000504]ag@00000000000000001<M>400P000003
04adh@80000000@0C7CQ00000000000000000P3D?AT500000080e3dI00@0@fW80000000000000000
0P3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP80e3dI103om^h20=@m6A00ooK^00<0e3dI0?ofkP3om^h0
2P3om^h20=@m6@H0ooK^00<0e3dI0?ofkP3om^h04@3om^h0103D?AT0ooK^0?ofkP3om^h20=@m6@`0
ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP1C0?ofkP<00000403om^h10?ooo`00
4`3om^h2000005<0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eI
Z`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h04@3om^h0100mFJ/0ooK^0?ofkP3om^h203eIZ`l0
ooK^00<0?EV[0?ofkP3om^h02`3om^h203eIZ`H0ooK^00@0?EV[0?ofkP0mFJ/0?EV[2P3om^h00`0m
FJ/0ooK^0?ofkP020?ofkP80?EV[100000050;dk6P80?EV[0P0000030>=57@8000000P3SAAd20000
000303eIZ`000000n4XO00<0000000<0Bg7M0000003D?AT00P00000204adh@8000000`1<M>420000
0080e3dI1@1:L]`400000080e3dI103om^h00`3D?AT0ooK^0?ofkP080?ofkP80e3dI00<0ooK^0=@m
6@3om^h01@3om^h20=@m6@d0ooK^00<0e3dI0?ofkP3om^h03@3om^h20=@m6@<0ooK^00<0e3dI0?of
kP3om^h04@3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?of
kP3om^h03@3om^h00`3D?AT0ooK^0?ofkP1B0?ofkP8000004`3om^h10?ooo`005@3om^h200000580
ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP050?ofkP80?EV[203om^h00`0mFJ/0
ooK^0?ofkP0@0?ofkP0403eIZ`3om^h0?EV[03eIZa80ooK^00<0?EV[0?ofkP3om^h0203om^h203eI
Z`P0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`090?ofkP0303eIZ`3om^h0ooK^00@0?EV[2@000002
0;dk6P80?EV[0`0000020>=57@8000000P0mFJ/00`3SAAd00000000000050000000304adh@3D?AT0
e3dI008000000P1<M>4300000080e3dI0P1:L]`70000000303eIZ`000000e3dI00<0e3dI0P3om^h0
0`3D?AT0ooK^0?ofkP070?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT0203om^h20=@m6@X0ooK^00<0
e3dI0?ofkP3om^h0403om^h20=@m6@030?ofkP3D?AT0ooK^0140ooK^00<0e3dI0?ofkP3om^h01P3o
m^h20=@m6@L0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP1@0?ofkP8000005@3o
m^h10?ooo`005`3om^h3000004l0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP04
0?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h04@3om^h00`0mFJ/0ooK^0?ofkP0C
0?ofkP0303eIZ`3om^h0ooK^00D0ooK^0P0mFJ/:0?ofkP0303eIZ`3om^h0ooK^0080ooK^0P0mFJ/7
0?ofkPD0?EV[103om^h600000080_C/J0`00000203eIZ`030000003SAAd000000080?EV[00<00000
0>=57@0000000P3SAAd300000080C7CQ00<0000004adh@0000000P3D?AT00`000000C7CQ00000002
0=@m6@<000000P1:L]`6000000@0ooK^1@3D?AT70?ofkP80e3dI103om^h00`3D?AT0ooK^0?ofkP08
0?ofkP80e3dI1`3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^0140ooK^00<0e3dI
0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI
0?ofkP3om^h0CP3om^h3000001L0ooK^0@3oool001X0ooK^0P00001>0?ofkP0303eIZ`3om^h0ooK^
00h0ooK^00@0?EV[0?ofkP3om^h0ooK^0P0mFJ/<0?ofkP0303eIZ`3om^h0ooK^00h0ooK^0P0mFJ/0
0`3om^h0?EV[0?ofkP0D0?ofkP0303eIZ`3om^h0ooK^0080ooK^0P0mFJ/<0?ofkP0303eIZ`3om^h0
ooK^00@0ooK^00<0?EV[0?ofkP3om^h00`3om^h403eIZ`P0ooK^1P0000050;dk6P<0?EV[0P3SAAd0
0`000000hdDM000000020>=57@<000000P1<M>401@000000C7CQ0000000mFJ/0C7CQ00<0e3dI1@1:
L]`6000000P0ooK^103D?AT50?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h02P3o
m^h20=@m6@@0ooK^00<0e3dI0?ofkP3om^h04`3om^h0103D?AT0ooK^0=@m6@3D?AT@0?ofkP030=@m
6@3om^h0ooK^00X0ooK^0P3D?AT30?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h0
C03om^h2000001X0ooK^0@3oool001`0ooK^0P00001<0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00@0
?EV[0?ofkP0mFJ/0?EV[3`3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP80?EV[103om^h00`0mFJ/0ooK^
0?ofkP0C0?ofkP0403eIZ`3om^h0?EV[03eIZ`h0ooK^00<0?EV[0?ofkP3om^h01@3om^h203eIZ`05
0?ofkP0mFJ/0?EV[0?ofkP0mFJ/02`3om^h0100mFJ/0000000000029;A@2000000<0_C/J0P0mFJ/2
0;dk6P<0?EV[0`3SAAd01@000000hdDM0000001<M>4000000080C7CQ00@000000=@m6@3D?AT0e3dI
0P1:L]`20=@m6@<0BW;L0P0000001013JLP000000000003D?AT;0?ofkP050=@m6@3om^h0e3dI0=@m
6@3om^h00P3D?AT70?ofkP030=@m6@3om^h0ooK^00`0ooK^0P3D?AT00`3om^h0e3dI0?ofkP0D0?of
kP030=@m6@3om^h0ooK^0080ooK^0P3D?AT=0?ofkP030=@m6@3om^h0ooK^00d0ooK^0P3D?AT00`3o
m^h0e3dI0?ofkP0>0?ofkP030=@m6@3om^h0ooK^04/0ooK^0P00000L0?ofkP40oooo000N0?ofkP<0
0000BP3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^0100ooK^00<0?EV[0?ofkP3o
m^h0203om^h203eIZ`L0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP03
03eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP0mFJ/00P0mFJ/;0?ofkP0303eIZ`3om^h0ooK^00@0
00000P0mFJ/30;dk6P80000000<0_C/J0000000mFJ/00P0mFJ/01@000000hdDM0000001<M>400000
00<0e3dI00@0000004Ybg000000000000`1:L]`20=@m6@@000000P3om^h00`3D?AT0ooK^0?ofkP09
0?ofkP<0e3dI00<0ooK^0=@m6@3om^h01`3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0
ooK^01<0ooK^00<0e3dI0?ofkP3om^h01@3om^h20=@m6@X0ooK^00<0e3dI0?ofkP3om^h0403om^h0
0`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^04P0ooK^0`00000N0?ofkP40oooo000Q0?of
kP800000B03om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP80?EV[00<0ooK^03eIZ`3om^h0403om^h00`0m
FJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h0403om^h203eI
Z`030?ofkP0mFJ/0ooK^00l0ooK^00<0?EV[0?ofkP3om^h0103om^h503eIZ`030?ofkP0mFJ/0ooK^
00X0ooK^00D0?EV[0?ofkP3om^h0?EV[0000000203eIZ`80RBdD0`0000030;dk6P030000002m>aX0
_C/J0080000000<0hdDM0000001<M>400P00000204Ybg0040000001:L]`0BW;L03eIZ`<000000P13
JLP20=@m6@030000003D?AT0ooK^0080ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0=@m
6@040=@m6@H0ooK^00<0e3dI0?ofkP3om^h03P3om^h0103D?AT0ooK^0=@m6@3D?ATB0?ofkP030=@m
6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP040=@m
6@3om^h0e3dI0=@m6@d0ooK^00<0e3dI0?ofkP3om^h0A`3om^h200000240ooK^0@3oool002<0ooK^
0P0000170?ofkP0303eIZ`3om^h0ooK^00T0ooK^0P0mFJ/30?ofkP0303eIZ`3om^h0ooK^0100ooK^
00<0?EV[0?ofkP3om^h0103om^h203eIZ``0ooK^00<0?EV[0?ofkP3om^h03@3om^h203eIZ`@0ooK^
0P0mFJ/>0?ofkP0303eIZ`3om^h0ooK^0080ooK^100mFJ/30?ofkP80?EV[2`3om^h503eIZ`040?of
kP000000000000000080RBdD0P0000020;dk6P050000002m>aX0_C/J0000002m>aX01000000304Yb
g0030000001:L]`0BW;L008000000P13JLP3000000030?ofkP3D?AT0e3dI0080e3dI00<0ooK^0=@m
6@3om^h02@3om^h20=@m6@<0ooK^103D?AT40?ofkP030=@m6@3om^h0ooK^00`0ooK^0P3D?AT40?of
kP80e3dI3`3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP80e3dI1P3om^h00`3D?AT0ooK^0?ofkP0@0?of
kP040=@m6@3om^h0ooK^0?ofkP80e3dI2`3om^h00`3D?AT0ooK^0?ofkP150?ofkP8000008`3om^h1
0?ooo`009@3om^h3000004@0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP040?of
kP0303eIZ`3om^h0ooK^0100ooK^00@0?EV[0?ofkP3om^h0ooK^0P0mFJ/?0?ofkP0303eIZ`3om^h0
ooK^00X0ooK^0P0mFJ/80?ofkP0303eIZ`3om^h0ooK^00/0ooK^00@0?EV[0?ofkP3om^h0ooK^0`0m
FJ/50?ofkP0403eIZ`3om^h0?EV[03eIZ`T0ooK^0`0mFJ/60?ofkP8000000P29;A@2000000<0_C/J
00@0000003eIZ`0mFJ/000000P3D?AT010000000BW;L04Ybg01:L]`200000080@fW80P0000060?of
kP@0e3dI203om^h20=@m6@030?ofkP3D?AT0ooK^00@0ooK^0`3D?AT30?ofkP030=@m6@3om^h0ooK^
00/0ooK^00<0e3dI0?ofkP3om^h01P3om^h20=@m6@`0ooK^00<0e3dI0?ofkP3om^h03@3om^h20=@m
6@<0ooK^00<0e3dI0?ofkP3om^h0403om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^
00L0ooK^00<0e3dI0?ofkP3om^h0@`3om^h3000002D0ooK^0@3oool002P0ooK^0P0000130?ofkP03
03eIZ`3om^h0ooK^00D0ooK^0P0mFJ/80?ofkP0303eIZ`3om^h0ooK^00l0ooK^00@0?EV[0?ofkP0m
FJ/0?EV[4P3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?of
kP3om^h02P3om^h00`0mFJ/0ooK^03eIZ`0203eIZ`L0ooK^00@0?EV[0?ofkP3om^h0ooK^0P0mFJ/5
0?ofkP<0?EV[2P3om^h30000000308T]5000000000000080?EV[0P2m>aX00`000000BW;L04Ybg002
0=@m6@80000000@0@fW800000000000000002P3om^h40=@m6@@0ooK^0P3D?AT30?ofkP030=@m6@3o
m^h0ooK^00D0ooK^0`3D?AT00`3om^h0e3dI0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0
e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP0@0?ofkP80e3dI00<0ooK^0=@m6@3om^h0403o
m^h00`3D?AT0ooK^0?ofkP060?ofkP80e3dI1`3om^h00`3D?AT0ooK^0?ofkP110?ofkP800000:03o
m^h10?ooo`00:P3om^h200000440ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP08
0?ofkP0303eIZ`3om^h0ooK^0100ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP05
0?ofkP80?EV[3@3om^h203eIZ`X0ooK^0`0mFJ/90?ofkP0303eIZ`3om^h0ooK^00<0ooK^0P0mFJ/0
0`3om^h0?EV[03eIZ`0203eIZ`X0ooK^0`0mFJ/200000080?EV[00D000000;dk6P2m>aX0_C/J0000
000304Ybg0050000003D?AT0e3dI03eIZ`0000000`3D?AT;0?ofkPH0e3dI1@3om^h00`3D?AT0ooK^
0?ofkP070?ofkP<0e3dI2P3om^h20=@m6@d0ooK^0P3D?AT70?ofkP030=@m6@3om^h0ooK^01<0ooK^
00<0e3dI0?ofkP3om^h0403om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00<0ooK^
00<0e3dI0?ofkP3om^h0@03om^h2000002X0ooK^0@3oool002`0ooK^0`00000o0?ofkP0403eIZ`3o
m^h0ooK^0?ofkP80?EV[303om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP80?EV[00<0ooK^03eIZ`3om^h0
503om^h00`0mFJ/0ooK^0?ofkP020?ofkP80?EV[4@3om^h00`0mFJ/0ooK^0?ofkP060?ofkP80?EV[
2`3om^h00`0mFJ/0ooK^0?ofkP040?ofkP@0?EV[00<0ooK^03eIZ`3om^h02@3om^h00`0mFJ/0ooK^
0?ofkP0203eIZ`D0000000<0_C/J0000001:L]`01@0000020=@m6@80ooK^00<0e3dI0?ofkP3om^h0
2@3om^h60=@m6@D0ooK^00<0e3dI0?ofkP3om^h02@3om^h20=@m6@P0ooK^00<0e3dI0?ofkP3om^h0
3`3om^h20=@m6@@0ooK^00<0e3dI0?ofkP3om^h04`3om^h0103D?AT0ooK^0=@m6@3D?AT?0?ofkP03
0=@m6@3om^h0ooK^00X0ooK^0P3D?AT30?ofkP030=@m6@3om^h0ooK^03d0ooK^0`00000/0?ofkP40
oooo000_0?ofkP800000?@3om^h0100mFJ/0ooK^03eIZ`0mFJ/?0?ofkP0303eIZ`3om^h0ooK^00X0
ooK^0P0mFJ/40?ofkP0303eIZ`3om^h0ooK^01<0ooK^00@0?EV[0?ofkP0mFJ/0?EV[503om^h00`0m
FJ/0ooK^0?ofkP030?ofkP80?EV[00<0ooK^03eIZ`3om^h02P3om^h00`0mFJ/0ooK^0?ofkP020?of
kP@0?EV[0P3om^h403eIZ`H0ooK^0P0mFJ/00`3om^h0?EV[03eIZ`040?ofkP0300000029;A@0e3dI
00<000000P13JLP00`000000ooK^0?ofkP020?ofkP80e3dI00<0ooK^0=@m6@3D?AT01P3om^h40=@m
6@80ooK^0P3D?AT00`3om^h0e3dI0=@m6@030?ofkP030=@m6@3om^h0ooK^00T0ooK^00@0e3dI0?of
kP3D?AT0e3dI1@3om^h00`3D?AT0ooK^0?ofkP0B0?ofkP80e3dI00<0ooK^0=@m6@3om^h0503om^h0
0`3D?AT0ooK^0?ofkP020?ofkP80e3dI303om^h00`3D?AT0ooK^0?ofkP0=0?ofkP<0e3dI?P3om^h2
000002l0ooK^0@3oool00340ooK^0`00000k0?ofkP0303eIZ`3om^h0ooK^0100ooK^00<0?EV[0?of
kP3om^h0203om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?of
kP3om^h05@3om^h203eIZ`030?ofkP0mFJ/0?EV[00<0ooK^00<0?EV[0?ofkP3om^h0203om^h0100m
FJ/0ooK^0?ofkP3om^h403eIZ`@0ooK^00@0?EV[0?ofkP3om^h0ooK^2@0mFJ/50?ofkPD0?EV[00<0
00000=@m6@3D?AT00`3D?AT50?ofkP80e3dI00<0ooK^0=@m6@3D?AT0103D?AT30?ofkP030=@m6@3o
m^h0ooK^0080ooK^0P3D?AT00`3om^h0e3dI0=@m6@020?ofkP030=@m6@3om^h0ooK^00P0ooK^00@0
e3dI0?ofkP3om^h0ooK^0P3D?AT00`3om^h0e3dI0=@m6@0G0?ofkP030=@m6@3om^h0ooK^01<0ooK^
00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^0100ooK^
00<0e3dI0?ofkP3om^h0>@3om^h300000340ooK^0@3oool003@0ooK^0P00000j0?ofkP0303eIZ`3o
m^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h01P3om^h203eIZ`T0ooK^00<0?EV[0?ofkP3om^h0403o
m^h203eIZ`030?ofkP0mFJ/0?EV[01H0ooK^0`0mFJ/40?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0
?EV[0?ofkP0mFJ/00`0mFJ/60?ofkP0303eIZ`3om^h0ooK^00<0ooK^400mFJ/300000100e3dI1P3o
m^h00`3D?AT0ooK^0?ofkP030?ofkP80e3dI00@0ooK^0=@m6@3D?AT0e3dI2P3om^h00`3D?AT0ooK^
0?ofkP020?ofkP<0e3dI5P3om^h20=@m6@030?ofkP3D?AT0e3dI0180ooK^00<0e3dI0?ofkP3om^h0
1`3om^h20=@m6@P0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP0h0?ofkP800000
=03om^h10?ooo`00=P3om^h2000003P0ooK^00<0?EV[0?ofkP3om^h0403om^h00`0mFJ/0ooK^0?of
kP040?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h03@3om^h203eIZ`D0ooK^00<0
?EV[0?ofkP3om^h04@3om^h203eIZ`<0ooK^0P0mFJ/20?ofkP0303eIZ`3om^h0ooK^00P0ooK^100m
FJ/70?ofkP0303eIZ`3om^h0ooK^0080ooK^0P0mFJ/0103om^h0?EV[03eIZ`0mFJ/40?ofkPL0?EV[
0P3om^h00`000000ooK^0?ofkP070=@m6@@0ooK^0`3D?AT00`3om^h0e3dI0=@m6@040?ofkP030=@m
6@3om^h0ooK^00D0ooK^0P3D?AT00`3om^h0e3dI0?ofkP090?ofkP030=@m6@3om^h0ooK^0080e3dI
0`3om^h20=@m6A<0ooK^00<0e3dI0?ofkP3om^h00`3om^h20=@m6@l0ooK^00<0e3dI0?ofkP3om^h0
2P3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h0
=`3om^h2000003H0ooK^0@3oool003P0ooK^0`00000f0?ofkP0303eIZ`3om^h0ooK^0100ooK^00@0
?EV[0?ofkP3om^h0ooK^0P0mFJ/>0?ofkP0303eIZ`3om^h0ooK^00X0ooK^0P0mFJ/80?ofkP0303eI
Z`3om^h0ooK^00h0ooK^0P0mFJ/70?ofkP<0?EV[203om^h403eIZ`T0ooK^00<0?EV[0?ofkP3om^h0
0P0mFJ/01@3om^h0?EV[03eIZ`3om^h0?EV[00<0ooK^0P0mFJ/00`3om^h0?EV[03eIZ`0203eIZ`@0
ooK^00<000000?ofkP3om^h00P3om^h40=@m6@030?ofkP3D?AT0e3dI00<0ooK^00D0e3dI0?ofkP3D
?AT0e3dI0?ofkP020=@m6@80ooK^00<0e3dI0?ofkP3om^h01`3om^h40=@m6@P0ooK^0`3D?AT70?of
kP80e3dI403om^h00`3D?AT0ooK^0?ofkP060?ofkP80e3dI303om^h00`3D?AT0ooK^0?ofkP0<0?of
kP80e3dI0`3om^h00`3D?AT0ooK^0?ofkP0@0?ofkP030=@m6@3om^h0ooK^03@0ooK^0`00000h0?of
kP40oooo000k0?ofkP800000=@3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0403eIZ`3om^h0?EV[03eI
Za40ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP090?ofkP80?EV[303om^h203eI
Z`X0ooK^100mFJ/40?ofkP@0?EV[2P3om^h01@0mFJ/0ooK^03eIZ`0mFJ/0ooK^0080?EV[0P3om^h0
0`0mFJ/0ooK^0?ofkP0203eIZ`030?ofkP0mFJ/0?EV[0080?EV[1P3om^h00`000000ooK^0?ofkP04
0?ofkP@0e3dI00D0ooK^0=@m6@3D?AT0ooK^0=@m6@030?ofkP80e3dI00D0ooK^0=@m6@3D?AT0ooK^
0=@m6@0:0?ofkP@0e3dI103om^h40=@m6@X0ooK^0P3D?AT<0?ofkP80e3dI2`3om^h00`3D?AT0ooK^
0?ofkP080?ofkP030=@m6@3om^h0ooK^00l0ooK^0P3D?AT00`3om^h0e3dI0?ofkP0@0?ofkP030=@m
6@3om^h0ooK^03<0ooK^0P00000k0?ofkP40oooo000m0?ofkP800000=03om^h00`0mFJ/0ooK^0?of
kP0?0?ofkP0303eIZ`3om^h0ooK^0180ooK^00<0?EV[0?ofkP3om^h01@3om^h203eIZ`h0ooK^00<0
?EV[0?ofkP3om^h01`3om^h203eIZ``0ooK^00@0?EV[0?ofkP3om^h0ooK^0P0mFJ/01P3om^h0?EV[
03eIZ`0mFJ/0ooK^03eIZ`X0ooK^0P0mFJ/00`3om^h0?EV[03eIZ`040?ofkP<0?EV[00<0ooK^03eI
Z`0mFJ/00P0mFJ/80?ofkP030000003om^h0ooK^00H0ooK^103D?AT0103om^h0e3dI0=@m6@3D?AT4
0?ofkP80e3dI00<0ooK^0=@m6@3D?AT02P3om^h00`3D?AT0ooK^0=@m6@020=@m6@030?ofkP3D?AT0
e3dI00<0ooK^00<0e3dI0?ofkP3om^h02P3om^h20=@m6@T0ooK^00<0e3dI0?ofkP3om^h0303om^h2
0=@m6@L0ooK^00<0e3dI0?ofkP3om^h04P3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0
ooK^0380ooK^0P00000m0?ofkP40oooo000o0?ofkP<00000<@3om^h00`0mFJ/0ooK^0?ofkP0=0?of
kP80?EV[00<0ooK^03eIZ`3om^h04`3om^h00`0mFJ/0ooK^0?ofkP020?ofkP80?EV[4@3om^h00`0m
FJ/0ooK^0?ofkP040?ofkP80?EV[3P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP@0?EV[0P3om^h00`0m
FJ/0ooK^0?ofkP060?ofkP80?EV[00<0ooK^03eIZ`0mFJ/01@3om^h203eIZ`030?ofkP0mFJ/0?EV[
0080?EV[2P3om^h00`000000ooK^0?ofkP080?ofkP@0e3dI00<0ooK^0=@m6@3D?AT01@3om^h20=@m
6@030?ofkP3D?AT0e3dI00P0ooK^00<0e3dI0?ofkP3om^h0103D?AT40?ofkP030=@m6@3om^h0ooK^
00`0ooK^0P3D?AT60?ofkP030=@m6@3om^h0ooK^00l0ooK^0P3D?AT40?ofkP030=@m6@3om^h0ooK^
0180ooK^00@0e3dI0?ofkP3D?AT0e3dI3P3om^h00`3D?AT0ooK^0?ofkP0`0?ofkP<00000?`3om^h1
0?ooo`00@P3om^h200000300ooK^00<0?EV[0?ofkP3om^h02P3om^h203eIZ`@0ooK^00<0?EV[0?of
kP3om^h04P3om^h0100mFJ/0ooK^03eIZ`0mFJ/D0?ofkP80?EV[0P3om^h203eIZa00ooK^00<0?EV[
0?ofkP3om^h0100mFJ/20?ofkP@0?EV[1@3om^h203eIZ`030?ofkP0mFJ/0?EV[00D0ooK^0P0mFJ/0
0`3om^h0?EV[03eIZ`0203eIZ``0ooK^00<000000?ofkP3om^h02P3om^h40=@m6@030?ofkP3D?AT0
e3dI00D0ooK^0P3D?AT00`3om^h0e3dI0=@m6@050?ofkP@0e3dI0P3om^h40=@m6@80ooK^00<0e3dI
0?ofkP3om^h03P3om^h20=@m6@80ooK^0P3D?ATD0?ofkP80e3dI00<0ooK^0=@m6@3om^h04`3om^h0
0`3D?AT0ooK^0?ofkP020?ofkP80e3dI303om^h00`3D?AT0ooK^0?ofkP0^0?ofkP800000@P3om^h1
0?ooo`00A03om^h2000002l0ooK^00<0?EV[0?ofkP3om^h01`3om^h203eIZ`L0ooK^00<0?EV[0?of
kP3om^h04P3om^h00`0mFJ/0ooK^0?ofkP0F0?ofkP80?EV[4P3om^h503eIZ`D0ooK^00<0?EV[0?of
kP3om^h01@0mFJ/00`3om^h0?EV[03eIZ`050?ofkPL0?EV[3P3om^h00`000000ooK^0?ofkP0<0?of
kPL0e3dI1@3om^h20=@m6@030?ofkP3D?AT0e3dI00<0e3dI0P3om^h00`3D?AT0ooK^0?ofkP030?of
kPD0e3dI4P3om^h20=@m6AP0ooK^00<0e3dI0?ofkP3om^h04P3om^h00`3D?AT0ooK^0?ofkP050?of
kP80e3dI2@3om^h00`3D?AT0ooK^0?ofkP0]0?ofkP800000A03om^h10?ooo`00AP3om^h3000002d0
ooK^00<0?EV[0?ofkP3om^h0103om^h203eIZ`X0ooK^00<0?EV[0?ofkP3om^h03`3om^h203eIZ`03
0?ofkP0mFJ/0?EV[01@0ooK^0P0mFJ/00`3om^h0?EV[03eIZ`0A0?ofkP<0?EV[1`3om^h0100mFJ/0
ooK^0?ofkP3om^h203eIZ`030?ofkP0mFJ/0?EV[00`0?EV[403om^h00`000000ooK^0?ofkP0>0?of
kPh0e3dI00<0ooK^0=@m6@3D?AT00`3om^h00`3D?AT0ooK^0?ofkP050?ofkP<0e3dI4@3om^h20=@m
6@030?ofkP3D?AT0e3dI01@0ooK^0P3D?AT00`3om^h0e3dI0=@m6@0A0?ofkP030=@m6@3om^h0ooK^
00P0ooK^0P3D?AT60?ofkP030=@m6@3om^h0ooK^02/0ooK^0`0000160?ofkP40oooo00190?ofkP80
0000:`3om^h00`0mFJ/0ooK^0?ofkP020?ofkP80?EV[3@3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP80
?EV[1@3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP80?EV[1@3om^h203eIZ`h0ooK^0P0mFJ/90?ofkP04
03eIZ`3om^h0?EV[03eIZ`80ooK^0P0mFJ/00`3om^h0?EV[0?ofkP020?ofkPH0?EV[4P3om^h00`00
0000ooK^0?ofkP0@0?ofkPH0e3dI0`3om^h0103D?AT0ooK^0=@m6@3D?AT20?ofkP80e3dI00<0ooK^
0=@m6@3om^h0203om^h20=@m6@h0ooK^0P3D?AT50?ofkP80e3dI4@3om^h00`3D?AT0ooK^0?ofkP03
0?ofkP80e3dI3P3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP80e3dI0`3om^h00`3D?AT0ooK^0?ofkP0Z
0?ofkP800000B@3om^h10?ooo`00B`3om^h2000002X0ooK^00@0?EV[0?ofkP0mFJ/0?EV[403om^h0
0`0mFJ/0ooK^0?ofkP090?ofkP80?EV[203om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP80?EV[2@3om^h2
03eIZ`X0ooK^0`0mFJ/90?ofkP<0?EV[0P3om^h203eIZ`<0ooK^00D0?EV[0?ofkP3om^h0?EV[0?of
kP0303eIZa@0ooK^00<000000?ofkP3om^h04P3om^h30=@m6@050?ofkP3D?AT0ooK^0?ofkP3D?AT0
0`3om^h20=@m6@80ooK^0`3D?AT90?ofkP<0e3dI2P3om^h20=@m6@T0ooK^0P3D?AT>0?ofkP030=@m
6@3om^h0ooK^00H0ooK^0P3D?AT;0?ofkP030=@m6@3om^h0ooK^00h0ooK^0P3D?AT00`3om^h0e3dI
0?ofkP0Y0?ofkP800000B`3om^h10?ooo`00C@3om^h3000002P0ooK^00<0?EV[0?ofkP3om^h04@3o
m^h00`0mFJ/0ooK^0?ofkP060?ofkP80?EV[2`3om^h203eIZ`/0ooK^00<0?EV[0?ofkP3om^h02`3o
m^h203eIZ`H0ooK^0P0mFJ/20?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h00P0m
FJ/40?ofkP0303eIZ`3om^h0?EV[00@0?EV[5P3om^h00`000000ooK^0?ofkP0D0?ofkPD0e3dI00<0
ooK^0=@m6@3om^h00`3om^h20=@m6@80ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?of
kP020=@m6@H0ooK^0P3D?AT=0?ofkP030=@m6@3om^h0ooK^00T0ooK^0P3D?AT;0?ofkP80e3dI203o
m^h00`3D?AT0ooK^0?ofkP0A0?ofkP030=@m6@3om^h0ooK^02H0ooK^0`00001=0?ofkP40oooo001@
0?ofkP8000009`3om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP0303eIZ`3om^h0ooK^00<0ooK^0P0mFJ/?
0?ofkP0303eIZ`3om^h0ooK^00H0ooK^0P0mFJ/@0?ofkP80?EV[0P3om^h203eIZ`<0ooK^00<0?EV[
0?ofkP3om^h01P3om^h203eIZ`030?ofkP0mFJ/0?EV[00H0ooK^1@0mFJ/H0?ofkP030000003om^h0
ooK^01H0ooK^1@3D?AT60?ofkP80e3dI00<0ooK^0=@m6@3D?AT0203om^h0103D?AT0ooK^0?ofkP3o
m^h20=@m6@80ooK^0P3D?AT@0?ofkP80e3dI203om^h00`3D?AT0ooK^0?ofkP0=0?ofkP80e3dI1@3o
m^h00`3D?AT0ooK^0?ofkP0A0?ofkP030=@m6@3om^h0ooK^02D0ooK^0P00001@0?ofkP40oooo001B
0?ofkP8000009P3om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP0303eIZ`3om^h0ooK^0080?EV[4P3om^h0
0`0mFJ/0ooK^0?ofkP030?ofkP80?EV[503om^h403eIZ`<0ooK^00<0?EV[0?ofkP3om^h0103om^h5
03eIZ`H0ooK^1@0mFJ/J0?ofkP030000003om^h0ooK^01P0ooK^1@3D?AT60?ofkP80e3dI00<0ooK^
0=@m6@3D?AT01P3om^h0103D?AT0ooK^0?ofkP3om^h40=@m6A@0ooK^0P3D?AT50?ofkP030=@m6@3o
m^h0ooK^0100ooK^0P3D?AT20?ofkP030=@m6@3om^h0ooK^0140ooK^00<0e3dI0?ofkP3om^h0903o
m^h200000580ooK^0@3oool005@0ooK^0`00000T0?ofkP0303eIZ`3om^h0ooK^0140ooK^0P0mFJ/E
0?ofkP80?EV[00<0ooK^03eIZ`0mFJ/05@3om^h203eIZ`<0ooK^1P0mFJ/20?ofkP80?EV[00<0ooK^
03eIZ`0mFJ/01P3om^h503eIZa`0ooK^00<000000?ofkP3om^h06P3om^h50=@m6@H0ooK^0P3D?AT0
0`3om^h0e3dI0=@m6@020?ofkPH0e3dI0`3om^h20=@m6AD0ooK^0P3D?AT00`3om^h0e3dI0=@m6@0E
0?ofkP80e3dI4`3om^h00`3D?AT0ooK^0?ofkP0R0?ofkP<00000E03om^h10?ooo`00E`3om^h20000
02<0ooK^00<0?EV[0?ofkP3om^h03P3om^h203eIZ`030?ofkP0mFJ/0?EV[01H0ooK^0P0mFJ/D0?of
kP80?EV[1`3om^h0100mFJ/0ooK^0?ofkP3om^h@03eIZah0ooK^00<000000?ofkP3om^h0703om^h@
0=@m6@<0ooK^00<0e3dI0?ofkP3om^h01@3om^h20=@m6A@0ooK^0P3D?ATF0?ofkP80e3dI00<0ooK^
0=@m6@3D?AT0403om^h00`3D?AT0ooK^0?ofkP0Q0?ofkP800000E`3om^h10?ooo`00F@3om^h20000
0280ooK^00<0?EV[0?ofkP3om^h02`3om^h203eIZ`D0ooK^00<0?EV[0?ofkP3om^h04@3om^h203eI
Z`80ooK^0P0mFJ/@0?ofkP80?EV[2@3om^h01@0mFJ/0ooK^03eIZ`0mFJ/0ooK^0080?EV[00<0ooK^
03eIZ`3om^h00P3om^h703eIZal0ooK^00<000000?ofkP3om^h07@3om^h70=@m6@<0ooK^00D0e3dI
0?ofkP3D?AT0e3dI0?ofkP020=@m6@030?ofkP3D?AT0ooK^00P0ooK^0P3D?AT@0?ofkP80e3dI0P3o
m^h20=@m6A<0ooK^00<0e3dI0?ofkP3om^h00`3om^h20=@m6@d0ooK^00<0e3dI0?ofkP3om^h0803o
m^h2000005T0ooK^0@3oool005/0ooK^0`00000O0?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[
0?ofkP3om^h01P3om^h203eIZ`l0ooK^0P0mFJ/60?ofkP80?EV[303om^h203eIZ`X0ooK^0`0mFJ/0
0`3om^h0?EV[03eIZ`020?ofkP0303eIZ`3om^h0ooK^0080?EV[00<0ooK^03eIZ`0mFJ/00P0mFJ/Q
0?ofkP030000003om^h0ooK^01l0ooK^103D?AT01@3om^h0e3dI0=@m6@3om^h0e3dI00<0ooK^0P3D
?AT0103om^h0e3dI0=@m6@3D?AT:0?ofkP80e3dI303om^h20=@m6@H0ooK^0P3D?AT?0?ofkP80e3dI
203om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^01d0ooK^0`00001K0?ofkP40oooo
001N0?ofkP8000007P3om^h00`0mFJ/0ooK^0?ofkP070?ofkP80?EV[2`3om^h00`0mFJ/0ooK^0?of
kP0:0?ofkP80?EV[2P3om^h303eIZ`L0ooK^0P0mFJ/<0?ofkP0403eIZ`3om^h0?EV[03eIZ`@0ooK^
0`0mFJ/00`3om^h0?EV[03eIZ`0203eIZb<0ooK^00<000000?ofkP3om^h08@3om^h40=@m6@040?of
kP3D?AT0e3dI0=@m6@@0ooK^0P3D?AT00`3om^h0e3dI0?ofkP0;0?ofkP80e3dI1`3om^h30=@m6@X0
ooK^0P3D?AT<0?ofkP030=@m6@3om^h0ooK^00T0ooK^0P3D?AT90?ofkP030=@m6@3om^h0ooK^01`0
ooK^0P00001N0?ofkP40oooo001P0?ofkP8000007@3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eI
Z`3om^h0ooK^00`0ooK^0P0mFJ/80?ofkP80?EV[3`3om^h203eIZ`<0ooK^0P0mFJ/=0?ofkP0303eI
Z`3om^h0?EV[00D0ooK^0P0mFJ/00`3om^h0?EV[03eIZ`0203eIZbD0ooK^00<000000?ofkP3om^h0
8`3om^h40=@m6@030?ofkP3D?AT0e3dI00D0ooK^00<0e3dI0?ofkP3D?AT03@3om^h20=@m6@<0ooK^
0P3D?AT?0?ofkP80e3dI203om^h20=@m6@h0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^
0?ofkP0K0?ofkP800000H03om^h10?ooo`00HP3om^h3000001/0ooK^00<0?EV[0?ofkP3om^h00P3o
m^h203eIZa40ooK^00<0?EV[0?ofkP3om^h00`3om^h203eIZa<0ooK^0`0mFJ/>0?ofkP<0?EV[103o
m^h203eIZ`030?ofkP0mFJ/0?EV[00<0?EV[9P3om^h00`000000ooK^0?ofkP0T0?ofkPD0e3dI00<0
ooK^0=@m6@3D?AT0103om^h20=@m6@l0ooK^0`3D?ATC0?ofkP80e3dI1@3om^h00`3D?AT0ooK^0?of
kP0?0?ofkP80e3dI103om^h00`3D?AT0ooK^0?ofkP0I0?ofkP<00000HP3om^h10?ooo`00I@3om^h2
000001X0ooK^00@0?EV[0?ofkP0mFJ/0?EV[503om^h203eIZ`030?ofkP0mFJ/0?EV[01@0ooK^0P0m
FJ/20?ofkP@0?EV[2@3om^h203eIZ`@0ooK^200mFJ/X0?ofkP030000003om^h0ooK^02H0ooK^203D
?AT40?ofkP80e3dI2@3om^h40=@m6@80ooK^0P3D?ATD0?ofkP80e3dI00<0ooK^0=@m6@3D?AT0503o
m^h20=@m6@030?ofkP3D?AT0ooK^01T0ooK^0P00001U0?ofkP40oooo001W0?ofkP8000006@3om^h0
0`0mFJ/0ooK^0?ofkP0F0?ofkP0303eIZ`3om^h0ooK^0180ooK^0P0mFJ/80?ofkP@0?EV[0`3om^h3
03eIZ`80ooK^1P0mFJ/00`3om^h0?EV[03eIZ`0Z0?ofkP030000003om^h0ooK^02P0ooK^0P3D?AT0
0`3om^h0e3dI0=@m6@040=@m6@80ooK^0`3D?AT30?ofkP@0e3dI203om^h20=@m6A@0ooK^00<0e3dI
0?ofkP3om^h05P3om^h00`3D?AT0ooK^0?ofkP0G0?ofkP800000I`3om^h10?ooo`00J@3om^h30000
01L0ooK^0P0mFJ/D0?ofkP80?EV[00<0ooK^03eIZ`0mFJ/0403om^h203eIZ`h0ooK^2@0mFJ/0103o
m^h0?EV[03eIZ`3om^h203eIZb`0ooK^00<000000?ofkP3om^h0:P3om^h20=@m6@040?ofkP3D?AT0
e3dI0?ofkPT0e3dI3P3om^h20=@m6A00ooK^0P3D?AT00`3om^h0e3dI0=@m6@0D0?ofkP80e3dI5`3o
m^h3000006T0ooK^0@3oool006`0ooK^0P00000G0?ofkP80?EV[403om^h203eIZ`D0ooK^0P0mFJ/=
0?ofkP0303eIZ`3om^h0ooK^00h0ooK^0P0mFJ/00`3om^h0?EV[0?ofkP0203eIZ`030?ofkP0mFJ/0
?EV[00<0?EV[;P3om^h00`000000ooK^0?ofkP0/0?ofkPD0e3dI00@0ooK^0=@m6@3D?AT0e3dI0P3o
m^h20=@m6A00ooK^00<0e3dI0?ofkP3om^h02`3om^h20=@m6@D0ooK^0P3D?AT@0?ofkP80e3dI5`3o
m^h2000006`0ooK^0@3oool006h0ooK^0P00000G0?ofkP0303eIZ`3om^h0ooK^00/0ooK^0P0mFJ/9
0?ofkP80?EV[2@3om^h203eIZ`l0ooK^0P0mFJ/30?ofkP80?EV[00@0ooK^03eIZ`0mFJ/0ooK^0P0m
FJ/`0?ofkP030000003om^h0ooK^02h0ooK^0P3D?AT0103om^h0e3dI0=@m6@3om^h20=@m6@<0ooK^
0P3D?AT?0?ofkP80e3dI2@3om^h20=@m6@T0ooK^0P3D?AT=0?ofkP030=@m6@3om^h0ooK^01D0ooK^
0P00001^0?ofkP40oooo001`0?ofkP<000005@3om^h203eIZ`T0ooK^0P0mFJ/=0?ofkP80?EV[1@3o
m^h203eIZ`l0ooK^0P0mFJ/40?ofkP0503eIZ`3om^h0?EV[03eIZ`3om^h00P0mFJ/b0?ofkP030000
003om^h0ooK^0300ooK^0P3D?AT01@3om^h0e3dI0=@m6@3om^h0e3dI00@0ooK^0P3D?AT?0?ofkP80
e3dI1@3om^h20=@m6@d0ooK^0P3D?AT90?ofkP80e3dI5@3om^h300000700ooK^0@3oool007<0ooK^
0P00000E0?ofkP80?EV[1@3om^h203eIZa40ooK^0P0mFJ/00`3om^h0?EV[03eIZ`0?0?ofkP80?EV[
1@3om^h603eIZc@0ooK^00<000000?ofkP3om^h0<P3om^h60=@m6@D0ooK^0P3D?AT?0?ofkP80e3dI
00<0ooK^0=@m6@3D?AT04@3om^h20=@m6@D0ooK^0P3D?ATE0?ofkP800000L`3om^h10?ooo`00M@3o
m^h2000001D0ooK^0P0mFJ/00`3om^h0?EV[03eIZ`0E0?ofkP<0?EV[3@3om^h203eIZ`H0ooK^1@0m
FJ/f0?ofkP030000003om^h0ooK^03@0ooK^1@3D?AT60?ofkP80e3dI3@3om^h30=@m6AD0ooK^0P3D
?AT00`3om^h0e3dI0=@m6@0E0?ofkP800000M@3om^h10?ooo`00M`3om^h3000001@0ooK^00<0?EV[
0?ofkP3om^h04`3om^h203eIZ`<0ooK^1P0mFJ/50?ofkP80?EV[0P3om^h603eIZ`030?ofkP0mFJ/0
?EV[03P0ooK^00<000000?ofkP3om^h0=P3om^h20=@m6@030?ofkP3D?AT0e3dI00@0e3dI0P3om^h2
0=@m6@D0ooK^1P3D?AT30?ofkP80e3dI5@3om^h00`3D?AT0ooK^0?ofkP0B0?ofkP<00000M`3om^h1
0?ooo`00NP3om^h2000001<0ooK^0P0mFJ/A0?ofkP80?EV[2`3om^h903eIZ`80ooK^0P0mFJ/00`3o
m^h0?EV[03eIZ`0j0?ofkP030000003om^h0ooK^03P0ooK^0P3D?AT00`3om^h0e3dI0=@m6@020?of
kPT0e3dI2`3om^h20=@m6A40ooK^0P3D?ATC0?ofkP800000NP3om^h10?ooo`00O03om^h2000001<0
ooK^0P0mFJ/=0?ofkP80?EV[3P3om^h203eIZ`H0ooK^1@0mFJ/l0?ofkP030000003om^h0ooK^03X0
ooK^1@3D?AT60?ofkP80e3dI3P3om^h20=@m6@d0ooK^0P3D?ATC0?ofkP800000O03om^h10?ooo`00
OP3om^h300000180ooK^0P0mFJ/90?ofkP80?EV[3P3om^h203eIZ`H0ooK^1@0mFJ/n0?ofkP030000
003om^h0ooK^03`0ooK^1@3D?AT60?ofkP80e3dI3P3om^h20=@m6@T0ooK^0P3D?ATB0?ofkP<00000
OP3om^h10?ooo`00P@3om^h200000180ooK^0P0mFJ/50?ofkP80?EV[3P3om^h203eIZ`H0ooK^100m
FJ]10?ofkP030000003om^h0ooK^03l0ooK^103D?AT60?ofkP80e3dI3P3om^h20=@m6@D0ooK^0P3D
?ATB0?ofkP800000P@3om^h10?ooo`00P`3om^h300000140ooK^0P0mFJ/00`3om^h0?EV[03eIZ`0>
0?ofkP80?EV[1P3om^h403eIZd<0ooK^00<000000?ofkP3om^h0@@3om^h40=@m6@H0ooK^0P3D?AT>
0?ofkP80e3dI00<0ooK^0=@m6@3D?AT04@3om^h3000008<0ooK^0@3oool008H0ooK^0P00000A0?of
kP<0?EV[303om^h203eIZ`H0ooK^0`0mFJ]60?ofkP030000003om^h0ooK^04@0ooK^0`3D?AT60?of
kP80e3dI303om^h30=@m6A40ooK^0P0000260?ofkP40oooo00280?ofkP8000004P3om^h603eIZ`@0
ooK^0P0mFJ/30?ofkPH0?EV[B03om^h00`000000ooK^0?ofkP160?ofkPH0e3dI0`3om^h20=@m6@@0
ooK^1P3D?ATB0?ofkP800000R03om^h10?ooo`00RP3om^h3000001D0ooK^2@0mFJ]>0?ofkP030000
003om^h0ooK^04`0ooK^2@3D?ATE0?ofkP<00000RP3om^h10?ooo`00S@3om^h2000006X0ooK^00<0
00000?ofkP3om^h0J03om^h2000008d0ooK^0@3oool008l0ooK^0P00001X0?ofkP030000003om^h0
ooK^06H0ooK^0P00002?0?ofkP40oooo002A0?ofkP<00000I@3om^h00`000000ooK^0?ofkP1S0?of
kP<00000T@3om^h10?ooo`00U03om^h2000006<0ooK^00<000000?ofkP3om^h0H@3om^h2000009@0
ooK^0@3oool009H0ooK^0P00001Q0?ofkP030000003om^h0ooK^05l0ooK^0P00002F0?ofkP40oooo
002H0?ofkP<00000GP3om^h00`000000ooK^0?ofkP1L0?ofkP<00000V03om^h10?ooo`00V`3om^h2
000005`0ooK^00<000000?ofkP3om^h0FP3om^h2000009/0ooK^0@3oool009d0ooK^0P00001J0?of
kP030000003om^h0ooK^05P0ooK^0P00002M0?ofkP40oooo002O0?ofkP<00000E`3om^h00`000000
ooK^0?ofkP1E0?ofkP<00000W`3om^h10?ooo`00XP3om^h2000005D0ooK^00<000000?ofkP3om^h0
D`3om^h200000:80ooK^0@3oool00:@0ooK^0P00001C0?ofkP030000003om^h0ooK^0540ooK^0P00
002T0?ofkP40oooo002V0?ofkP<00000D03om^h00`000000ooK^0?ofkP1>0?ofkP<00000YP3om^h1
0?ooo`00Z@3om^h2000004h0ooK^00<000000?ofkP3om^h0C03om^h200000:T0ooK^0@3oool00:/0
ooK^0P00001<0?ofkP030000003om^h0ooK^04X0ooK^0P00002[0?ofkP40oooo002]0?ofkP<00000
B@3om^h00`000000ooK^0?ofkP170?ofkP<00000[@3om^h10?ooo`00/03om^h2000004L0ooK^00<0
00000?ofkP3om^h0A@3om^h200000;00ooK^0@3oool00;80ooK^0P0000150?ofkP030000003om^h0
ooK^04<0ooK^0P00002b0?ofkP40oooo002d0?ofkP<00000@P3om^h00`000000ooK^0?ofkP100?of
kP<00000]03om^h10?ooo`00]`3om^h200000400ooK^00<000000?ofkP3om^h0?P3om^h200000;L0
ooK^0@3oool00;T0ooK^0P00000n0?ofkP030000003om^h0ooK^03`0ooK^0P00002i0?ofkP40oooo
002k0?ofkP<00000>`3om^h00`000000ooK^0?ofkP0i0?ofkP<00000^`3om^h10?ooo`00_P3om^h2
000003T0ooK^00<000000?ofkP3om^h0=`3om^h200000;h0ooK^0@3oool00<00ooK^0P00000g0?of
kP030000003om^h0ooK^03D0ooK^0P0000300?ofkP40oooo00320?ofkP<00000=03om^h00`000000
ooK^0?ofkP0b0?ofkP<00000`P3om^h10?ooo`00a@3om^h200000380ooK^00<000000?ofkP3om^h0
<03om^h200000<D0ooK^0@3oool00<L0ooK^0P00000`0?ofkP030000003om^h0ooK^02h0ooK^0P00
00370?ofkP40oooo00390?ofkP<00000;@3om^h00`000000ooK^0?ofkP0[0?ofkP<00000b@3om^h1
0?ooo`00c03om^h2000002/0ooK^00<000000?ofkP3om^h0:@3om^h200000<`0ooK^0@3oool00<h0
ooK^0P00000Y0?ofkP030000003om^h0ooK^02L0ooK^0P00003>0?ofkP40oooo003@0?ofkP<00000
9P3om^h00`000000ooK^0?ofkP0T0?ofkP<00000d03om^h10?ooo`00d`3om^h2000002@0ooK^00<0
00000?ofkP3om^h08P3om^h200000=<0ooK^0@3oool00=D0ooK^0`00000Q0?ofkP030000003om^h0
ooK^01l0ooK^0`00003E0?ofkP40oooo003H0?ofkP8000007`3om^h00`000000ooK^0?ofkP0M0?of
kP800000f03om^h10?ooo`00fP3om^h2000001d0ooK^00<000000?ofkP3om^h06`3om^h200000=X0
ooK^0@3oool00=`0ooK^0`00000J0?ofkP030000003om^h0ooK^01P0ooK^0`00003L0?ofkP40oooo
003O0?ofkP800000603om^h00`000000ooK^0?ofkP0F0?ofkP800000g`3om^h10?ooo`00h@3om^h2
000001H0ooK^00<000000?ofkP3om^h0503om^h200000>40ooK^0@3oool00><0ooK^0`00000C0?of
kP030000003om^h0ooK^0140ooK^0`00003S0?ofkP40oooo003V0?ofkP8000004@3om^h00`000000
ooK^0?ofkP0?0?ofkP800000iP3om^h10?ooo`00j03om^h2000000l0ooK^00<000000?ofkP3om^h0
3@3om^h200000>P0ooK^0@3oool00>X0ooK^0`00000<0?ofkP030000003om^h0ooK^00X0ooK^0`00
003Z0?ofkP40oooo003]0?ofkP8000002P3om^h00`000000ooK^0?ofkP080?ofkP800000k@3om^h1
0?ooo`00k`3om^h2000000P0ooK^00<000000?ofkP3om^h01P3om^h200000>l0ooK^0@3oool00?40
ooK^0`0000050?ofkP030000003om^h0ooK^00<0ooK^0`00003a0?ofkP40oooo003d0?ofkP800000
0`3om^h010000000ooK^0?ofkP3om^h200000?@0ooK^0@3oool00?H0ooK^0P0000000`3om^h00000
0?ofkP0200000?H0ooK^0@3oool00?P0ooK^0`00003h0?ofkP40oooo003o0?ofk_@0ooK^0@3oool0
0?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03o
m^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00
o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?of
kP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o
0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^
0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0
ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h1
0?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3o
m^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40
oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?of
k_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3o
ool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^
m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?oo
o`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd
0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo
003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0
ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool0
0?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03o
m^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00
o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?of
kP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o
0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^
0@3oool00001\
\>"],
  ImageRangeCache->{{{0, 499}, {499, 0}} -> {-5.00005*^-06, -5.00005*^-06, \
0.00200403, 0.00200403}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
%%ImageSize: 500 500 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics3D
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Background color
1 .961 .933 r
MFill
% Scaling calculations
0 1 0 1 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 0 r
.25 Mabswid
[ ] 0 setdash
.88764 .44767 m
.93472 .69847 L
s
.93472 .69847 m
.66126 .3169 L
s
.66126 .3169 m
.63805 .03848 L
s
.63805 .03848 m
.88764 .44767 L
s
.40912 .60318 m
.06705 .30234 L
s
.06705 .30234 m
.00747 .5665 L
s
.00747 .5665 m
.39961 .8356 L
s
.39961 .8356 m
.40912 .60318 L
s
.88764 .44767 m
.93472 .69847 L
s
.93472 .69847 m
.39961 .8356 L
s
.39961 .8356 m
.40912 .60318 L
s
.40912 .60318 m
.88764 .44767 L
s
.63805 .03848 m
.06705 .30234 L
s
.06705 .30234 m
.00747 .5665 L
s
.00747 .5665 m
.66126 .3169 L
s
.66126 .3169 m
.63805 .03848 L
s
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
.83 .24 .1 r
.5 Mabswid
.553 .58135 m
.57143 .56253 L
s
.57143 .56253 m
.55428 .54453 L
s
.57143 .56253 m
.59245 .54684 L
s
.53784 .60261 m
.553 .58135 L
s
.553 .58135 m
.53555 .56364 L
s
.59245 .54684 m
.5756 .52855 L
s
.59245 .54684 m
.61531 .53486 L
s
.52654 .62555 m
.53784 .60261 L
s
.53784 .60261 m
.5201 .58518 L
s
.61531 .53486 m
.59876 .5163 L
s
.61531 .53486 m
.6392 .52709 L
s
.51958 .64934 m
.52654 .62555 L
s
.52654 .62555 m
.50852 .6084 L
s
.6392 .52709 m
.62292 .50827 L
s
.6392 .52709 m
.66322 .52391 L
s
.53555 .56364 m
.55428 .54453 L
s
.55428 .54453 m
.53658 .52595 L
s
.55428 .54453 m
.5756 .52855 L
s
.51732 .6731 m
.51958 .64934 L
s
.51958 .64934 m
.50131 .63245 L
s
.5201 .58518 m
.53555 .56364 L
s
.53555 .56364 m
.51754 .54535 L
s
.5756 .52855 m
.55821 .50967 L
s
.5756 .52855 m
.59876 .5163 L
s
.50852 .6084 m
.5201 .58518 L
s
.5201 .58518 m
.50178 .56719 L
s
.66322 .52391 m
.64718 .50487 L
s
.66322 .52391 m
.68644 .52555 L
s
.59876 .5163 m
.58167 .49713 L
s
.59876 .5163 m
.62292 .50827 L
s
.50131 .63245 m
.50852 .6084 L
s
.50852 .6084 m
.48991 .59069 L
s
.49883 .65643 m
.51732 .6731 L
s
.51998 .69588 m
.51732 .6731 L
s
.62292 .50827 m
.6061 .48884 L
s
.62292 .50827 m
.64718 .50487 L
s
.24 .35 .67 r
.3274 .57153 m
.31825 .54593 L
s
.35824 .56096 m
.3274 .57153 L
s
.3337 .59771 m
.3274 .57153 L
s
.31825 .54593 m
.30656 .5218 L
s
.34901 .53511 m
.31825 .54593 L
s
.83 .24 .1 r
.51754 .54535 m
.53658 .52595 L
s
.53658 .52595 m
.5183 .50675 L
s
.53658 .52595 m
.55821 .50967 L
s
.68644 .52555 m
.67062 .50634 L
s
.68644 .52555 m
.7079 .53211 L
s
.49883 .65643 m
.50131 .63245 L
s
.50131 .63245 m
.48243 .61499 L
s
.50178 .56719 m
.51754 .54535 L
s
.51754 .54535 m
.49893 .52646 L
s
.55821 .50967 m
.54025 .49016 L
s
.55821 .50967 m
.58167 .49713 L
s
.24 .35 .67 r
.36469 .58735 m
.3337 .59771 L
s
.33691 .62359 m
.3337 .59771 L
s
.30656 .5218 m
.29271 .49996 L
s
.33733 .51071 m
.30656 .5218 L
s
.83 .24 .1 r
.48991 .59069 m
.50178 .56719 L
s
.50178 .56719 m
.48286 .5486 L
s
.52762 .71672 m
.51998 .69588 L
s
.51998 .69588 m
.50133 .6794 L
s
.64718 .50487 m
.63062 .4852 L
s
.64718 .50487 m
.67062 .50634 L
s
.58167 .49713 m
.56401 .47732 L
s
.58167 .49713 m
.6061 .48884 L
s
.24 .35 .67 r
.36813 .61341 m
.33691 .62359 L
s
.33687 .64824 m
.33691 .62359 L
s
.83 .24 .1 r
.48243 .61499 m
.48991 .59069 L
s
.48991 .59069 m
.47068 .57239 L
s
.24 .35 .67 r
.34901 .53511 m
.35824 .56096 L
s
.38967 .55018 m
.35824 .56096 L
s
.35824 .56096 m
.36469 .58735 L
s
.33733 .51071 m
.34901 .53511 L
s
.38037 .52409 m
.34901 .53511 L
s
.83 .24 .1 r
.47973 .63921 m
.49883 .65643 L
s
.50133 .6794 m
.49883 .65643 L
s
.24 .35 .67 r
.29271 .49996 m
.27714 .48125 L
s
.32356 .48859 m
.29271 .49996 L
s
.83 .24 .1 r
.7079 .53211 m
.69225 .51278 L
s
.7079 .53211 m
.72665 .54349 L
s
.24 .35 .67 r
.39628 .5768 m
.36469 .58735 L
s
.36469 .58735 m
.36813 .61341 L
s
.32356 .48859 m
.33733 .51071 L
s
.36868 .49941 m
.33733 .51071 L
s
.83 .24 .1 r
.6061 .48884 m
.58873 .46875 L
s
.6061 .48884 m
.63062 .4852 L
s
.49893 .52646 m
.5183 .50675 L
s
.5183 .50675 m
.4994 .4869 L
s
.5183 .50675 m
.54025 .49016 L
s
.67062 .50634 m
.65427 .48648 L
s
.67062 .50634 m
.69225 .51278 L
s
.54009 .73466 m
.52762 .71672 L
s
.52762 .71672 m
.50887 .70039 L
s
.47973 .63921 m
.48243 .61499 L
s
.48243 .61499 m
.46293 .59696 L
s
.48286 .5486 m
.49893 .52646 L
s
.49893 .52646 m
.4797 .50694 L
s
.24 .35 .67 r
.36838 .63821 m
.33687 .64824 L
s
.33348 .67076 m
.33687 .64824 L
s
.39995 .60304 m
.36813 .61341 L
s
.36813 .61341 m
.36838 .63821 L
s
.83 .24 .1 r
.54025 .49016 m
.52168 .46999 L
s
.54025 .49016 m
.56401 .47732 L
s
.24 .35 .67 r
.38037 .52409 m
.38967 .55018 L
s
.42171 .5392 m
.38967 .55018 L
s
.38967 .55018 m
.39628 .5768 L
s
.36868 .49941 m
.38037 .52409 L
s
.41233 .51285 m
.38037 .52409 L
s
.30814 .46959 m
.32356 .48859 L
s
.35499 .477 m
.32356 .48859 L
s
.27714 .48125 m
.26038 .46644 L
s
.30814 .46959 m
.27714 .48125 L
s
.83 .24 .1 r
.47068 .57239 m
.48286 .5486 L
s
.48286 .5486 m
.4633 .52939 L
s
.50887 .70039 m
.50133 .6794 L
s
.50133 .6794 m
.48206 .66237 L
s
.24 .35 .67 r
.42848 .56604 m
.39628 .5768 L
s
.39628 .5768 m
.39995 .60304 L
s
.35499 .477 m
.36868 .49941 L
s
.40065 .48789 m
.36868 .49941 L
s
.83 .24 .1 r
.63062 .4852 m
.6135 .46487 L
s
.63062 .4852 m
.65427 .48648 L
s
.56401 .47732 m
.54575 .45684 L
s
.56401 .47732 m
.58873 .46875 L
s
.72665 .54349 m
.71112 .5241 L
s
.72665 .54349 m
.74177 .55936 L
s
.46293 .59696 m
.47068 .57239 L
s
.45999 .6214 m
.47973 .63921 L
s
.48206 .66237 m
.47973 .63921 L
s
.24 .35 .67 r
.4005 .62799 m
.36838 .63821 L
s
.36838 .63821 m
.36533 .66082 L
s
.43239 .59247 m
.39995 .60304 L
s
.39995 .60304 m
.4005 .62799 L
s
.41233 .51285 m
.42171 .5392 L
s
.42171 .5392 m
.42848 .56604 L
s
.40065 .48789 m
.41233 .51285 L
s
.44491 .50139 m
.41233 .51285 L
s
.83 .24 .1 r
.69225 .51278 m
.67607 .49279 L
s
.69225 .51278 m
.71112 .5241 L
s
.55704 .74882 m
.54009 .73466 L
s
.54009 .73466 m
.52132 .71843 L
s
.24 .35 .67 r
.33974 .4577 m
.35499 .477 L
s
.38705 .46519 m
.35499 .477 L
s
.29159 .45448 m
.30814 .46959 L
s
.33974 .4577 m
.30814 .46959 L
s
.36533 .66082 m
.33348 .67076 L
s
.32675 .6902 m
.33348 .67076 L
s
.83 .24 .1 r
.58873 .46875 m
.57076 .44798 L
s
.58873 .46875 m
.6135 .46487 L
s
.24 .35 .67 r
.42848 .56604 m
.43239 .59247 L
s
.26038 .46644 m
.243 .45621 L
s
.29159 .45448 m
.26038 .46644 L
s
.38705 .46519 m
.40065 .48789 L
s
.43323 .47615 m
.40065 .48789 L
s
.83 .24 .1 r
.4797 .50694 m
.4994 .4869 L
s
.4994 .4869 m
.52168 .46999 L
s
.65427 .48648 m
.63736 .46595 L
s
.65427 .48648 m
.67607 .49279 L
s
.52132 .71843 m
.50887 .70039 L
s
.50887 .70039 m
.48949 .6835 L
s
.45999 .6214 m
.46293 .59696 L
s
.4633 .52939 m
.4797 .50694 L
s
.52168 .46999 m
.50248 .44914 L
s
.52168 .46999 m
.54575 .45684 L
s
.74177 .55936 m
.72629 .53999 L
s
.74177 .55936 m
.75243 .57919 L
s
.24 .35 .67 r
.43325 .61756 m
.4005 .62799 L
s
.4005 .62799 m
.39781 .6507 L
s
.43239 .59247 m
.43325 .61756 L
s
1 .296 .121 r
.44268 .56361 m .45243 .57274 L .45551 .55007 L p F P
0 0 0 r
s
.24 .35 .67 r
.42848 .56604 m
.44589 .56022 L
s
1 .296 .121 r
.45551 .55007 m .44643 .54137 L .44268 .56361 L p F P
0 0 0 r
s
1 .302 .124 r
.44643 .54137 m .45551 .55007 L .45957 .52633 L p F P
0 0 0 r
s
.24 .35 .67 r
.42171 .5392 m
.45437 .528 L
s
.224 .319 .638 r
.47313 .52168 m .45957 .52633 L .45551 .55007 L p F P
0 0 0 r
s
.224 .319 .638 r
.45551 .55007 m .47042 .54506 L .47313 .52168 L p F P
0 0 0 r
s
.211 .299 .6 r
.47042 .54506 m .45551 .55007 L .45243 .57274 L p F P
0 0 0 r
s
.83 .24 .1 r
.45955 .56179 m
.47068 .57239 L
s
.48949 .6835 m
.48206 .66237 L
s
.48206 .66237 m
.46213 .64475 L
s
.24 .35 .67 r
.44491 .50139 m
.45437 .528 L
s
.45437 .528 m
.45522 .53131 L
s
.43323 .47615 m
.44491 .50139 L
s
1 .302 .124 r
.45957 .52633 m .45135 .51826 L .44643 .54137 L p F P
0 0 0 r
s
1 .306 .127 r
.45135 .51826 m .45957 .52633 L .46455 .5019 L p F P
0 0 0 r
s
.235 .338 .673 r
.47645 .49774 m .46455 .5019 L .45957 .52633 L p F P
0 0 0 r
s
.83 .24 .1 r
.47427 .50143 m
.4797 .50694 L
s
.235 .338 .673 r
.45957 .52633 m .47313 .52168 L .47645 .49774 L p F P
0 0 0 r
s
.24 .35 .67 r
.37196 .44558 m
.38705 .46519 L
s
.41973 .45314 m
.38705 .46519 L
s
.32342 .4423 m
.33974 .4577 L
s
.37196 .44558 m
.33974 .4577 L
s
.83 .24 .1 r
.6135 .46487 m
.59579 .44384 L
s
.6135 .46487 m
.63736 .46595 L
s
.24 .35 .67 r
.39781 .6507 m
.36533 .66082 L
s
.36533 .66082 m
.35899 .68032 L
s
1 .286 .116 r
.44019 .58459 m .45038 .59394 L .45243 .57274 L p F P
0 0 0 r
s
.24 .35 .67 r
.43239 .59247 m
.44448 .58853 L
s
1 .286 .116 r
.45243 .57274 m .44268 .56361 L .44019 .58459 L p F P
0 0 0 r
s
.211 .299 .6 r
.45243 .57274 m .46836 .56749 L .47042 .54506 L p F P
0 0 0 r
s
.83 .24 .1 r
.4508 .55347 m
.45922 .53724 L
s
.24 .35 .67 r
.45664 .53684 m
.46131 .55507 L
s
.83 .24 .1 r
.4508 .55347 m
.45534 .55778 L
s
.24 .35 .67 r
.45386 .55756 m
.46131 .55507 L
s
.197 .277 .557 r
.46836 .56749 m .45243 .57274 L .45038 .59394 L p F P
0 0 0 r
s
.83 .24 .1 r
.45396 .58867 m
.46293 .59696 L
s
.54575 .45684 m
.52687 .43566 L
s
.54575 .45684 m
.57076 .44798 L
s
.71112 .5241 m
.69505 .50405 L
s
.71112 .5241 m
.72629 .53999 L
s
.24 .35 .67 r
.2745 .44399 m
.29159 .45448 L
s
.32342 .4423 m
.29159 .45448 L
s
1 .306 .127 r
.46455 .5019 m .45737 .49468 L .45135 .51826 L p F P
0 0 0 r
s
.24 .35 .67 r
.44491 .50139 m
.45671 .49724 L
s
1 .308 .128 r
.45737 .49468 m .46455 .5019 L .47035 .4772 L p F P
0 0 0 r
s
.245 .355 .705 r
.48032 .47365 m .47035 .4772 L .46455 .5019 L p F P
0 0 0 r
s
.245 .355 .705 r
.46455 .5019 m .47645 .49774 L .48032 .47365 L p F P
0 0 0 r
s
.24 .35 .67 r
.41973 .45314 m
.43323 .47615 L
s
.83 .24 .1 r
.57784 .75839 m
.55704 .74882 L
s
.55704 .74882 m
.53831 .73262 L
s
.224 .319 .638 r
.4868 .517 m .47313 .52168 L .47042 .54506 L p F P
0 0 0 r
s
.224 .319 .638 r
.47042 .54506 m .48546 .54001 L .4868 .517 L p F P
0 0 0 r
s
.211 .299 .6 r
.48546 .54001 m .47042 .54506 L .46836 .56749 L p F P
0 0 0 r
s
.235 .338 .673 r
.48843 .49355 m .47645 .49774 L .47313 .52168 L p F P
0 0 0 r
s
.235 .338 .673 r
.47313 .52168 m .4868 .517 L .48843 .49355 L p F P
0 0 0 r
s
.24 .35 .67 r
.35899 .68032 m
.32675 .6902 L
s
.31682 .70568 m
.32675 .6902 L
s
.979 .272 .109 r
.43901 .60393 m .44941 .61329 L .45038 .59394 L p F P
0 0 0 r
s
.979 .272 .109 r
.45038 .59394 m .44019 .58459 L .43901 .60393 L p F P
0 0 0 r
s
.197 .277 .557 r
.45038 .59394 m .46699 .58856 L .46836 .56749 L p F P
0 0 0 r
s
.83 .24 .1 r
.44276 .5783 m
.45192 .58677 L
s
.24 .35 .67 r
.46131 .55507 m
.46547 .58169 L
s
.45051 .58656 m
.46547 .58169 L
s
.181 .25 .506 r
.46699 .58856 m .45038 .59394 L .44941 .61329 L p F P
0 0 0 r
s
.211 .299 .6 r
.46836 .56749 m .48444 .56218 L .48546 .54001 L p F P
0 0 0 r
s
.197 .277 .557 r
.48444 .56218 m .46836 .56749 L .46699 .58856 L p F P
0 0 0 r
s
1 .296 .121 r
.43277 .55433 m .44268 .56361 L .44643 .54137 L p F P
0 0 0 r
s
1 .296 .121 r
.44643 .54137 m .4372 .53252 L .43277 .55433 L p F P
0 0 0 r
s
.83 .24 .1 r
.44276 .5783 m
.4508 .55347 L
s
1 .302 .124 r
.4372 .53252 m .44643 .54137 L .45135 .51826 L p F P
0 0 0 r
s
1 .302 .124 r
.45135 .51826 m .44301 .51007 L .4372 .53252 L p F P
0 0 0 r
s
1 .306 .127 r
.44301 .51007 m .45135 .51826 L .45737 .49468 L p F P
0 0 0 r
s
.245 .355 .705 r
.49034 .47008 m .48032 .47365 L .47645 .49774 L p F P
0 0 0 r
s
.83 .24 .1 r
.48794 .47486 m
.4994 .4869 L
s
.245 .355 .705 r
.47645 .49774 m .48843 .49355 L .49034 .47008 L p F P
0 0 0 r
s
.83 .24 .1 r
.67607 .49279 m
.65933 .47212 L
s
.67607 .49279 m
.69505 .50405 L
s
.53831 .73262 m
.52132 .71843 L
s
.52132 .71843 m
.50189 .70163 L
s
.24 .35 .67 r
.243 .45621 m
.22568 .4512 L
s
.2745 .44399 m
.243 .45621 L
s
.235 .338 .673 r
.5005 .48933 m .48843 .49355 L .4868 .517 L p F P
0 0 0 r
s
.235 .338 .673 r
.4868 .517 m .50057 .51227 L .5005 .48933 L p F P
0 0 0 r
s
.224 .319 .638 r
.50057 .51227 m .4868 .517 L .48546 .54001 L p F P
0 0 0 r
s
.224 .319 .638 r
.48546 .54001 m .50063 .53491 L .50057 .51227 L p F P
0 0 0 r
s
.24 .35 .67 r
.45857 .52656 m
.48767 .51658 L
s
.211 .299 .6 r
.50063 .53491 m .48546 .54001 L .48444 .56218 L p F P
0 0 0 r
s
.24 .35 .67 r
.43325 .61756 m
.43093 .64037 L
s
.83 .24 .1 r
.57076 .44798 m
.55217 .4265 L
s
.57076 .44798 m
.59579 .44384 L
s
1 .286 .116 r
.42982 .57508 m .44019 .58459 L .44268 .56361 L p F P
0 0 0 r
s
1 .286 .116 r
.44268 .56361 m .43277 .55433 L .42982 .57508 L p F P
0 0 0 r
s
.24 .35 .67 r
.47813 .48971 m
.48767 .51658 L
s
.255 .371 .736 r
.48468 .44983 m .47691 .45265 L .47035 .4772 L p F P
0 0 0 r
s
.255 .371 .736 r
.47035 .4772 m .48032 .47365 L .48468 .44983 L p F P
0 0 0 r
s
.83 .24 .1 r
.48136 .46795 m
.48515 .47193 L
s
1 .308 .128 r
.47035 .4772 m .46439 .47104 L .45737 .49468 L p F P
0 0 0 r
s
.24 .35 .67 r
.46538 .4942 m
.47813 .48971 L
s
1 .308 .129 r
.46439 .47104 m .47035 .4772 L .47691 .45265 L p F P
0 0 0 r
s
1 .306 .127 r
.45737 .49468 m .45011 .48737 L .44301 .51007 L p F P
0 0 0 r
s
1 .308 .128 r
.45011 .48737 m .45737 .49468 L .46439 .47104 L p F P
0 0 0 r
s
.24 .35 .67 r
.43323 .47615 m
.46646 .46417 L
s
.83 .24 .1 r
.45982 .48675 m
.46748 .49453 L
s
.24 .35 .67 r
.46981 .4715 m
.47813 .48971 L
s
.46646 .46417 m
.46751 .46646 L
s
.197 .277 .557 r
.46699 .58856 m .48376 .58313 L .48444 .56218 L p F P
0 0 0 r
s
.181 .25 .506 r
.48376 .58313 m .46699 .58856 L .46634 .60791 L p F P
0 0 0 r
s
.181 .25 .506 r
.44941 .61329 m .46634 .60791 L .46699 .58856 L p F P
0 0 0 r
s
.24 .35 .67 r
.40482 .43322 m
.41973 .45314 L
s
.245 .355 .705 r
.50042 .46649 m .49034 .47008 L .48843 .49355 L p F P
0 0 0 r
s
.245 .355 .705 r
.48843 .49355 m .5005 .48933 L .50042 .46649 L p F P
0 0 0 r
s
.211 .299 .6 r
.48444 .56218 m .50068 .55683 L .50063 .53491 L p F P
0 0 0 r
s
.24 .35 .67 r
.48767 .51658 m
.49479 .54388 L
s
.46131 .55507 m
.49479 .54388 L
s
.197 .277 .557 r
.50068 .55683 m .48444 .56218 L .48376 .58313 L p F P
0 0 0 r
s
.24 .35 .67 r
.35589 .42987 m
.37196 .44558 L
s
.40482 .43322 m
.37196 .44558 L
s
.43093 .64037 m
.39781 .6507 L
s
.39781 .6507 m
.39187 .67024 L
s
.83 .24 .1 r
.75243 .57919 m
.73695 .55992 L
s
.75243 .57919 m
.75798 .6022 L
s
.45982 .48675 m
.47413 .47221 L
s
.63736 .46595 m
.61987 .44471 L
s
.63736 .46595 m
.65933 .47212 L
s
.50189 .70163 m
.48949 .6835 L
s
.48949 .6835 m
.46943 .66603 L
s
.235 .338 .673 r
.51266 .48509 m .5005 .48933 L .50057 .51227 L p F P
0 0 0 r
s
.235 .338 .673 r
.50057 .51227 m .51446 .50751 L .51266 .48509 L p F P
0 0 0 r
s
.224 .319 .638 r
.51446 .50751 m .50057 .51227 L .50063 .53491 L p F P
0 0 0 r
s
.255 .371 .736 r
.49248 .447 m .48468 .44983 L .48032 .47365 L p F P
0 0 0 r
s
.255 .371 .736 r
.48032 .47365 m .49034 .47008 L .49248 .447 L p F P
0 0 0 r
s
.83 .24 .1 r
.49151 .45751 m
.50248 .44914 L
s
.224 .319 .638 r
.50063 .53491 m .51594 .52976 L .51446 .50751 L p F P
0 0 0 r
s
.211 .299 .6 r
.51594 .52976 m .50063 .53491 L .50068 .55683 L p F P
0 0 0 r
s
.913 .25 .099 r
.43919 .62123 m .44956 .63042 L .44941 .61329 L p F P
0 0 0 r
s
.913 .25 .099 r
.44941 .61329 m .43901 .60393 L .43919 .62123 L p F P
0 0 0 r
s
.24 .35 .67 r
.43325 .61756 m
.43913 .61568 L
s
.16 .218 .444 r
.46634 .60791 m .44941 .61329 L .44956 .63042 L p F P
0 0 0 r
s
.83 .24 .1 r
.45777 .6194 m
.45999 .6214 L
s
.45999 .6214 m
.46213 .64475 L
s
.24 .35 .67 r
.30662 .43152 m
.32342 .4423 L
s
.35589 .42987 m
.32342 .4423 L
s
.46646 .46417 m
.4699 .46294 L
s
1 .302 .124 r
.42783 .52354 m .4372 .53252 L .44301 .51007 L p F P
0 0 0 r
s
1 .302 .124 r
.44301 .51007 m .43456 .50177 L .42783 .52354 L p F P
0 0 0 r
s
1 .306 .127 r
.43456 .50177 m .44301 .51007 L .45011 .48737 L p F P
0 0 0 r
s
.83 .24 .1 r
.44307 .50952 m
.46076 .5269 L
s
.245 .355 .705 r
.51056 .46288 m .50042 .46649 L .5005 .48933 L p F P
0 0 0 r
s
.245 .355 .705 r
.5005 .48933 m .51266 .48509 L .51056 .46288 L p F P
0 0 0 r
s
.979 .272 .109 r
.42843 .5944 m .43901 .60393 L .44019 .58459 L p F P
0 0 0 r
s
.979 .272 .109 r
.44019 .58459 m .42982 .57508 L .42843 .5944 L p F P
0 0 0 r
s
.83 .24 .1 r
.43956 .60298 m
.44276 .5783 L
s
1 .296 .121 r
.4227 .54489 m .43277 .55433 L .4372 .53252 L p F P
0 0 0 r
s
1 .296 .121 r
.4372 .53252 m .42783 .52354 L .4227 .54489 L p F P
0 0 0 r
s
1 .308 .128 r
.46439 .47104 m .45836 .46482 L .45011 .48737 L p F P
0 0 0 r
s
.83 .24 .1 r
.44307 .50952 m
.45982 .48675 L
s
1 .308 .129 r
.45836 .46482 m .46439 .47104 L .47229 .44776 L p F P
0 0 0 r
s
1 .308 .129 r
.47691 .45265 m .47229 .44776 L .46439 .47104 L p F P
0 0 0 r
s
.24 .35 .67 r
.39187 .67024 m
.35899 .68032 L
s
.35899 .68032 m
.34946 .6958 L
s
.211 .299 .6 r
.50068 .55683 m .51707 .55142 L .51594 .52976 L p F P
0 0 0 r
s
.197 .277 .557 r
.51707 .55142 m .50068 .55683 L .50071 .57765 L p F P
0 0 0 r
s
.197 .277 .557 r
.48376 .58313 m .50071 .57765 L .50068 .55683 L p F P
0 0 0 r
s
.24 .35 .67 r
.49479 .54388 m
.4992 .57069 L
s
.255 .371 .736 r
.50033 .44416 m .49248 .447 L .49034 .47008 L p F P
0 0 0 r
s
.255 .371 .736 r
.49034 .47008 m .50042 .46649 L .50033 .44416 L p F P
0 0 0 r
s
.83 .24 .1 r
.50034 .44681 m
.50248 .44914 L
s
.181 .25 .506 r
.50071 .57765 m .48376 .58313 L .48344 .60246 L p F P
0 0 0 r
s
.24 .35 .67 r
.46547 .58169 m
.4992 .57069 L
s
.181 .25 .506 r
.46634 .60791 m .48344 .60246 L .48376 .58313 L p F P
0 0 0 r
s
1 .306 .127 r
.45011 .48737 m .44275 .47997 L .43456 .50177 L p F P
0 0 0 r
s
1 .308 .128 r
.44275 .47997 m .45011 .48737 L .45836 .46482 L p F P
0 0 0 r
s
.83 .24 .1 r
.72629 .53999 m
.71028 .51995 L
s
.72629 .53999 m
.73695 .55992 L
s
.60167 .76276 m
.57784 .75839 L
s
.57784 .75839 m
.55924 .74215 L
s
.235 .338 .673 r
.5249 .48081 m .51266 .48509 L .51446 .50751 L p F P
0 0 0 r
s
.235 .338 .673 r
.51446 .50751 m .52846 .50272 L .5249 .48081 L p F P
0 0 0 r
s
.224 .319 .638 r
.52846 .50272 m .51446 .50751 L .51594 .52976 L p F P
0 0 0 r
s
.224 .319 .638 r
.51594 .52976 m .53138 .52457 L .52846 .50272 L p F P
0 0 0 r
s
.24 .35 .67 r
.48767 .51658 m
.52164 .50494 L
s
.211 .299 .6 r
.53138 .52457 m .51594 .52976 L .51707 .55142 L p F P
0 0 0 r
s
1 .286 .116 r
.41928 .56541 m .42982 .57508 L .43277 .55433 L p F P
0 0 0 r
s
1 .286 .116 r
.43277 .55433 m .4227 .54489 L .41928 .56541 L p F P
0 0 0 r
s
.83 .24 .1 r
.43024 .5339 m
.4508 .55347 L
s
.16 .218 .444 r
.48344 .60246 m .46634 .60791 L .46644 .62513 L p F P
0 0 0 r
s
.24 .35 .67 r
.46547 .58169 m
.46665 .60692 L
s
.16 .218 .444 r
.44956 .63042 m .46644 .62513 L .46634 .60791 L p F P
0 0 0 r
s
.24 .35 .67 r
.44868 .61264 m
.46665 .60692 L
s
.83 .24 .1 r
.43956 .60298 m
.45059 .61292 L
s
.245 .355 .705 r
.52076 .45925 m .51056 .46288 L .51266 .48509 L p F P
0 0 0 r
s
.24 .35 .67 r
.47813 .48971 m
.51201 .4778 L
s
.245 .355 .705 r
.51266 .48509 m .5249 .48081 L .52076 .45925 L p F P
0 0 0 r
s
.24 .35 .67 r
.25751 .43872 m
.2745 .44399 L
s
.30662 .43152 m
.2745 .44399 L
s
.265 .388 .766 r
.48946 .42672 m .48411 .42869 L .47691 .45265 L p F P
0 0 0 r
s
.265 .388 .766 r
.47691 .45265 m .48468 .44983 L .48946 .42672 L p F P
0 0 0 r
s
1 .306 .129 r
.47229 .44776 m .47691 .45265 L .48411 .42869 L p F P
0 0 0 r
s
.83 .24 .1 r
.59579 .44384 m
.57746 .42208 L
s
.59579 .44384 m
.61987 .44471 L
s
.255 .371 .736 r
.5082 .4413 m .50033 .44416 L .50042 .46649 L p F P
0 0 0 r
s
.24 .35 .67 r
.47322 .46174 m
.50035 .45196 L
s
.255 .371 .736 r
.50042 .46649 m .51056 .46288 L .5082 .4413 L p F P
0 0 0 r
s
.83 .24 .1 r
.50869 .44571 m
.52687 .43566 L
s
.24 .35 .67 r
.51201 .4778 m
.52164 .50494 L
s
1 .308 .128 r
.45836 .46482 m .45227 .45853 L .44275 .47997 L p F P
0 0 0 r
s
1 .308 .129 r
.45227 .45853 m .45836 .46482 L .46764 .44283 L p F P
0 0 0 r
s
.24 .35 .67 r
.46195 .45632 m
.46333 .45873 L
s
.41973 .45314 m
.45306 .44085 L
s
1 .308 .129 r
.47229 .44776 m .46764 .44283 L .45836 .46482 L p F P
0 0 0 r
s
.24 .35 .67 r
.45306 .44085 m
.45917 .45148 L
s
.83 .24 .1 r
.69505 .50405 m
.67843 .4833 L
s
.69505 .50405 m
.71028 .51995 L
s
.211 .299 .6 r
.51707 .55142 m .53361 .54597 L .53138 .52457 L p F P
0 0 0 r
s
.24 .35 .67 r
.49479 .54388 m
.52893 .53248 L
s
.197 .277 .557 r
.53361 .54597 m .51707 .55142 L .51782 .57211 L p F P
0 0 0 r
s
.197 .277 .557 r
.50071 .57765 m .51782 .57211 L .51707 .55142 L p F P
0 0 0 r
s
.235 .338 .673 r
.53723 .4765 m .5249 .48081 L .52846 .50272 L p F P
0 0 0 r
s
.235 .338 .673 r
.52846 .50272 m .54257 .49788 L .53723 .4765 L p F P
0 0 0 r
s
.224 .319 .638 r
.54257 .49788 m .52846 .50272 L .53138 .52457 L p F P
0 0 0 r
s
.24 .35 .67 r
.52164 .50494 m
.52893 .53248 L
s
.265 .388 .766 r
.49484 .42474 m .48946 .42672 L .48468 .44983 L p F P
0 0 0 r
s
.265 .388 .766 r
.48468 .44983 m .49248 .447 L .49484 .42474 L p F P
0 0 0 r
s
.83 .24 .1 r
.49331 .43918 m
.4985 .44482 L
s
.181 .25 .506 r
.51782 .57211 m .50071 .57765 L .50072 .59697 L p F P
0 0 0 r
s
.181 .25 .506 r
.48344 .60246 m .50072 .59697 L .50071 .57765 L p F P
0 0 0 r
s
.24 .35 .67 r
.4992 .57069 m
.50071 .59608 L
s
.389 .41719 m
.40482 .43322 L
s
.43834 .4206 m
.40482 .43322 L
s
.43093 .64037 m
.42541 .65996 L
s
.83 .24 .1 r
.55924 .74215 m
.53831 .73262 L
s
.53831 .73262 m
.51892 .71585 L
s
.24 .35 .67 r
.34946 .6958 m
.31682 .70568 L
s
.30393 .71638 m
.31682 .70568 L
s
1 .302 .124 r
.41831 .51442 m .42783 .52354 L .43456 .50177 L p F P
0 0 0 r
s
1 .302 .124 r
.43456 .50177 m .42598 .49335 L .41831 .51442 L p F P
0 0 0 r
s
.83 .24 .1 r
.43024 .5339 m
.44307 .50952 L
s
1 .306 .127 r
.42598 .49335 m .43456 .50177 L .44275 .47997 L p F P
0 0 0 r
s
.245 .355 .705 r
.53102 .45559 m .52076 .45925 L .5249 .48081 L p F P
0 0 0 r
s
.245 .355 .705 r
.5249 .48081 m .53723 .4765 L .53102 .45559 L p F P
0 0 0 r
s
.913 .25 .099 r
.42864 .61188 m .43919 .62123 L .43901 .60393 L p F P
0 0 0 r
s
.913 .25 .099 r
.43901 .60393 m .42843 .5944 L .42864 .61188 L p F P
0 0 0 r
s
.255 .371 .736 r
.51612 .43843 m .5082 .4413 L .51056 .46288 L p F P
0 0 0 r
s
.255 .371 .736 r
.51056 .46288 m .52076 .45925 L .51612 .43843 L p F P
0 0 0 r
s
.24 .35 .67 r
.50035 .45196 m
.51201 .4778 L
s
.224 .319 .638 r
.53138 .52457 m .54697 .51933 L .54257 .49788 L p F P
0 0 0 r
s
.211 .299 .6 r
.54697 .51933 m .53138 .52457 L .53361 .54597 L p F P
0 0 0 r
s
1 .306 .127 r
.44275 .47997 m .43531 .47247 L .42598 .49335 L p F P
0 0 0 r
s
1 .308 .128 r
.43531 .47247 m .44275 .47997 L .45227 .45853 L p F P
0 0 0 r
s
1 .306 .129 r
.46764 .44283 m .47229 .44776 L .48096 .42527 L p F P
0 0 0 r
s
1 .306 .129 r
.48411 .42869 m .48096 .42527 L .47229 .44776 L p F P
0 0 0 r
s
.809 .217 .084 r
.44077 .63611 m .45086 .64493 L .44956 .63042 L p F P
0 0 0 r
s
.24 .35 .67 r
.43093 .64037 m
.44178 .63698 L
s
.809 .217 .084 r
.44956 .63042 m .43919 .62123 L .44077 .63611 L p F P
0 0 0 r
s
.134 .176 .364 r
.46644 .62513 m .44956 .63042 L .45086 .64493 L p F P
0 0 0 r
s
.83 .24 .1 r
.45557 .63895 m
.46213 .64475 L
s
1 .296 .121 r
.41246 .53529 m .4227 .54489 L .42783 .52354 L p F P
0 0 0 r
s
1 .296 .121 r
.42783 .52354 m .41831 .51442 L .41246 .53529 L p F P
0 0 0 r
s
.265 .388 .766 r
.50022 .42275 m .49484 .42474 L .49248 .447 L p F P
0 0 0 r
s
.265 .388 .766 r
.49248 .447 m .50033 .44416 L .50022 .42275 L p F P
0 0 0 r
s
.16 .218 .444 r
.50072 .59697 m .48344 .60246 L .48349 .61979 L p F P
0 0 0 r
s
.16 .218 .444 r
.46644 .62513 m .48349 .61979 L .48344 .60246 L p F P
0 0 0 r
s
.979 .272 .109 r
.41766 .5847 m .42843 .5944 L .42982 .57508 L p F P
0 0 0 r
s
.979 .272 .109 r
.42982 .57508 m .41928 .56541 L .41766 .5847 L p F P
0 0 0 r
s
.83 .24 .1 r
.75798 .6022 m
.74241 .58311 L
s
.75798 .6022 m
.75797 .62739 L
s
.24 .35 .67 r
.3394 .4188 m
.35589 .42987 L
s
.389 .41719 m
.35589 .42987 L
s
.22568 .4512 m
.20913 .45184 L
s
.25751 .43872 m
.22568 .4512 L
s
.83 .24 .1 r
.65933 .47212 m
.64201 .45071 L
s
.65933 .47212 m
.67843 .4833 L
s
.255 .371 .736 r
.52407 .43555 m .51612 .43843 L .52076 .45925 L p F P
0 0 0 r
s
.255 .371 .736 r
.52076 .45925 m .53102 .45559 L .52407 .43555 L p F P
0 0 0 r
s
.83 .24 .1 r
.52687 .43566 m
.55217 .4265 L
s
.235 .338 .673 r
.54964 .47216 m .53723 .4765 L .54257 .49788 L p F P
0 0 0 r
s
.235 .338 .673 r
.54257 .49788 m .5568 .493 L .54964 .47216 L p F P
0 0 0 r
s
.224 .319 .638 r
.5568 .493 m .54257 .49788 L .54697 .51933 L p F P
0 0 0 r
s
.245 .355 .705 r
.54134 .45192 m .53102 .45559 L .53723 .4765 L p F P
0 0 0 r
s
.245 .355 .705 r
.53723 .4765 m .54964 .47216 L .54134 .45192 L p F P
0 0 0 r
s
1 .308 .128 r
.45227 .45853 m .44612 .45218 L .43531 .47247 L p F P
0 0 0 r
s
1 .308 .129 r
.44612 .45218 m .45227 .45853 L .46295 .43787 L p F P
0 0 0 r
s
1 .308 .129 r
.46764 .44283 m .46295 .43787 L .45227 .45853 L p F P
0 0 0 r
s
.83 .24 .1 r
.45965 .44515 m
.47586 .46218 L
s
.211 .299 .6 r
.53361 .54597 m .55032 .54046 L .54697 .51933 L p F P
0 0 0 r
s
.197 .277 .557 r
.55032 .54046 m .53361 .54597 L .5351 .56651 L p F P
0 0 0 r
s
.197 .277 .557 r
.51782 .57211 m .5351 .56651 L .53361 .54597 L p F P
0 0 0 r
s
.24 .35 .67 r
.52893 .53248 m
.53361 .55948 L
s
.265 .388 .766 r
.50563 .42076 m .50022 .42275 L .50033 .44416 L p F P
0 0 0 r
s
.265 .388 .766 r
.50033 .44416 m .5082 .4413 L .50563 .42076 L p F P
0 0 0 r
s
.83 .24 .1 r
.51892 .71585 m
.50189 .70163 L
s
.50189 .70163 m
.48178 .68424 L
s
.24 .35 .67 r
.42541 .65996 m
.39187 .67024 L
s
.39187 .67024 m
.38277 .68572 L
s
.181 .25 .506 r
.5351 .56651 m .51782 .57211 L .51817 .59142 L p F P
0 0 0 r
s
.24 .35 .67 r
.4992 .57069 m
.53361 .55948 L
s
.181 .25 .506 r
.50072 .59697 m .51817 .59142 L .51782 .57211 L p F P
0 0 0 r
s
1 .286 .116 r
.40855 .55556 m .41928 .56541 L .4227 .54489 L p F P
0 0 0 r
s
.83 .24 .1 r
.42188 .559 m
.44276 .5783 L
s
1 .286 .116 r
.4227 .54489 m .41246 .53529 L .40855 .55556 L p F P
0 0 0 r
s
.83 .24 .1 r
.42188 .559 m
.43024 .5339 L
s
.55217 .4265 m
.57746 .42208 L
s
1 .306 .129 r
.46295 .43787 m .46764 .44283 L .47779 .42183 L p F P
0 0 0 r
s
.24 .35 .67 r
.45306 .44085 m
.46387 .43687 L
s
1 .306 .129 r
.48096 .42527 m .47779 .42183 L .46764 .44283 L p F P
0 0 0 r
s
.224 .319 .638 r
.54697 .51933 m .56269 .51404 L .5568 .493 L p F P
0 0 0 r
s
.24 .35 .67 r
.52164 .50494 m
.55628 .49306 L
s
.211 .299 .6 r
.56269 .51404 m .54697 .51933 L .55032 .54046 L p F P
0 0 0 r
s
.83 .24 .1 r
.62746 .76154 m
.60167 .76276 L
s
.60167 .76276 m
.58328 .74641 L
s
.134 .176 .364 r
.48349 .61979 m .46644 .62513 L .46731 .63986 L p F P
0 0 0 r
s
.134 .176 .364 r
.45086 .64493 m .46731 .63986 L .46644 .62513 L p F P
0 0 0 r
s
.24 .35 .67 r
.46471 .62983 m
.46665 .60692 L
s
.83 .24 .1 r
.46213 .64475 m
.46943 .66603 L
s
.4415 .62652 m
.45087 .6348 L
s
.24 .35 .67 r
.44943 .6346 m
.46471 .62983 L
s
.265 .388 .766 r
.51105 .41876 m .50563 .42076 L .5082 .4413 L p F P
0 0 0 r
s
.265 .388 .766 r
.5082 .4413 m .51612 .43843 L .51105 .41876 L p F P
0 0 0 r
s
.255 .371 .736 r
.53206 .43265 m .52407 .43555 L .53102 .45559 L p F P
0 0 0 r
s
.255 .371 .736 r
.53102 .45559 m .54134 .45192 L .53206 .43265 L p F P
0 0 0 r
s
.16 .218 .444 r
.51817 .59142 m .50072 .59697 L .50072 .6144 L p F P
0 0 0 r
s
.16 .218 .444 r
.48349 .61979 m .50072 .6144 L .50072 .59697 L p F P
0 0 0 r
s
.24 .35 .67 r
.46665 .60692 m
.50071 .59608 L
s
.28999 .42599 m
.30662 .43152 L
s
.3394 .4188 m
.30662 .43152 L
s
1 .306 .127 r
.41728 .48481 m .42598 .49335 L .43531 .47247 L p F P
0 0 0 r
s
1 .306 .127 r
.43531 .47247 m .42777 .46489 L .41728 .48481 L p F P
0 0 0 r
s
1 .308 .128 r
.42777 .46489 m .43531 .47247 L .44612 .45218 L p F P
0 0 0 r
s
.83 .24 .1 r
.43924 .46586 m
.45982 .48675 L
s
1 .302 .124 r
.40865 .50516 m .41831 .51442 L .42598 .49335 L p F P
0 0 0 r
s
1 .302 .124 r
.42598 .49335 m .41728 .48481 L .40865 .50516 L p F P
0 0 0 r
s
.83 .24 .1 r
.42213 .48896 m
.44307 .50952 L
s
.245 .355 .705 r
.55173 .44822 m .54134 .45192 L .54964 .47216 L p F P
0 0 0 r
s
.24 .35 .67 r
.51201 .4778 m
.54656 .46565 L
s
.245 .355 .705 r
.54964 .47216 m .56215 .46779 L .55173 .44822 L p F P
0 0 0 r
s
.235 .338 .673 r
.56215 .46779 m .54964 .47216 L .5568 .493 L p F P
0 0 0 r
s
.235 .338 .673 r
.5568 .493 m .57115 .48808 L .56215 .46779 L p F P
0 0 0 r
s
.224 .319 .638 r
.57115 .48808 m .5568 .493 L .56269 .51404 L p F P
0 0 0 r
s
.83 .24 .1 r
.73695 .55992 m
.72091 .53997 L
s
.73695 .55992 m
.74241 .58311 L
s
.43924 .46586 m
.45965 .44515 L
s
.275 .404 .796 r
.4946 .40477 m .49185 .4058 L .48411 .42869 L p F P
0 0 0 r
s
.275 .404 .796 r
.48411 .42869 m .48946 .42672 L .4946 .40477 L p F P
0 0 0 r
s
1 .303 .128 r
.48096 .42527 m .48411 .42869 L .49185 .4058 L p F P
0 0 0 r
s
.24 .35 .67 r
.48705 .42832 m
.50035 .45196 L
s
.83 .24 .1 r
.48261 .42756 m
.48611 .43136 L
s
.24 .35 .67 r
.4811 .43051 m
.48705 .42832 L
s
.83 .24 .1 r
.61987 .44471 m
.64201 .45071 L
s
.24 .35 .67 r
.54656 .46565 m
.55628 .49306 L
s
.83 .24 .1 r
.48178 .68424 m
.46943 .66603 L
s
.42213 .48896 m
.43924 .46586 L
s
.265 .388 .766 r
.51649 .41675 m .51105 .41876 L .51612 .43843 L p F P
0 0 0 r
s
.83 .24 .1 r
.50863 .4152 m
.51162 .41855 L
s
.51637 .42388 m
.52611 .43481 L
s
.265 .388 .766 r
.51612 .43843 m .52407 .43555 L .51649 .41675 L p F P
0 0 0 r
s
.211 .299 .6 r
.55032 .54046 m .56718 .53489 L .56269 .51404 L p F P
0 0 0 r
s
.197 .277 .557 r
.56718 .53489 m .55032 .54046 L .55255 .56086 L p F P
0 0 0 r
s
.197 .277 .557 r
.5351 .56651 m .55255 .56086 L .55032 .54046 L p F P
0 0 0 r
s
1 .308 .129 r
.46295 .43787 m .45822 .43286 L .44612 .45218 L p F P
0 0 0 r
s
1 .306 .129 r
.45822 .43286 m .46295 .43787 L .4746 .41836 L p F P
0 0 0 r
s
1 .306 .129 r
.47779 .42183 m .4746 .41836 L .46295 .43787 L p F P
0 0 0 r
s
.83 .24 .1 r
.45965 .44515 m
.48261 .42756 L
s
1 .308 .128 r
.44612 .45218 m .43991 .44577 L .42777 .46489 L p F P
0 0 0 r
s
1 .308 .129 r
.43991 .44577 m .44612 .45218 L .45822 .43286 L p F P
0 0 0 r
s
.24 .35 .67 r
.43834 .4206 m
.45096 .43797 L
s
.913 .25 .099 r
.41791 .60236 m .42864 .61188 L .42843 .5944 L p F P
0 0 0 r
s
.913 .25 .099 r
.42843 .5944 m .41766 .5847 L .41791 .60236 L p F P
0 0 0 r
s
1 .296 .121 r
.40204 .52554 m .41246 .53529 L .41831 .51442 L p F P
0 0 0 r
s
1 .296 .121 r
.41831 .51442 m .40865 .50516 L .40204 .52554 L p F P
0 0 0 r
s
.255 .371 .736 r
.54008 .42974 m .53206 .43265 L .54134 .45192 L p F P
0 0 0 r
s
.24 .35 .67 r
.50035 .45196 m
.53493 .4395 L
s
.255 .371 .736 r
.54134 .45192 m .55173 .44822 L .54008 .42974 L p F P
0 0 0 r
s
.181 .25 .506 r
.55255 .56086 m .5351 .56651 L .5358 .58581 L p F P
0 0 0 r
s
.181 .25 .506 r
.51817 .59142 m .5358 .58581 L .5351 .56651 L p F P
0 0 0 r
s
.24 .35 .67 r
.53361 .55948 m
.53547 .58501 L
s
.275 .404 .796 r
.49736 .40374 m .4946 .40477 L .48946 .42672 L p F P
0 0 0 r
s
.275 .404 .796 r
.48946 .42672 m .49484 .42474 L .49736 .40374 L p F P
0 0 0 r
s
.224 .319 .638 r
.56269 .51404 m .57856 .50871 L .57115 .48808 L p F P
0 0 0 r
s
.211 .299 .6 r
.57856 .50871 m .56269 .51404 L .56718 .53489 L p F P
0 0 0 r
s
.24 .35 .67 r
.55628 .49306 m
.56375 .52084 L
s
.52893 .53248 m
.56375 .52084 L
s
.809 .217 .084 r
.43052 .62713 m .44077 .63611 L .43919 .62123 L p F P
0 0 0 r
s
.83 .24 .1 r
.43956 .60298 m
.4415 .62652 L
s
.809 .217 .084 r
.43919 .62123 m .42864 .61188 L .43052 .62713 L p F P
0 0 0 r
s
.24 .35 .67 r
.38277 .68572 m
.34946 .6958 L
s
.34946 .6958 m
.337 .70644 L
s
.979 .272 .109 r
.4067 .57483 m .41766 .5847 L .41928 .56541 L p F P
0 0 0 r
s
.979 .272 .109 r
.41928 .56541 m .40855 .55556 L .4067 .57483 L p F P
0 0 0 r
s
.83 .24 .1 r
.41842 .58391 m
.42188 .559 L
s
1 .303 .128 r
.47779 .42183 m .48096 .42527 L .49025 .40402 L p F P
0 0 0 r
s
1 .303 .128 r
.49185 .4058 m .49025 .40402 L .48096 .42527 L p F P
0 0 0 r
s
.24 .35 .67 r
.48176 .42082 m
.48705 .42832 L
s
.83 .24 .1 r
.48261 .42756 m
.49165 .42251 L
s
.265 .388 .766 r
.52195 .41474 m .51649 .41675 L .52407 .43555 L p F P
0 0 0 r
s
.265 .388 .766 r
.52407 .43555 m .53206 .43265 L .52195 .41474 L p F P
0 0 0 r
s
.245 .355 .705 r
.56217 .4445 m .55173 .44822 L .56215 .46779 L p F P
0 0 0 r
s
.245 .355 .705 r
.56215 .46779 m .57474 .46339 L .56217 .4445 L p F P
0 0 0 r
s
.235 .338 .673 r
.57474 .46339 m .56215 .46779 L .57115 .48808 L p F P
0 0 0 r
s
.275 .404 .796 r
.50011 .40271 m .49736 .40374 L .49484 .42474 L p F P
0 0 0 r
s
.275 .404 .796 r
.49484 .42474 m .50022 .42275 L .50011 .40271 L p F P
0 0 0 r
s
.134 .176 .364 r
.50072 .6144 m .48349 .61979 L .48392 .63473 L p F P
0 0 0 r
s
.134 .176 .364 r
.46731 .63986 m .48392 .63473 L .48349 .61979 L p F P
0 0 0 r
s
.235 .338 .673 r
.57115 .48808 m .58561 .48312 L .57474 .46339 L p F P
0 0 0 r
s
.224 .319 .638 r
.58561 .48312 m .57115 .48808 L .57856 .50871 L p F P
0 0 0 r
s
.16 .218 .444 r
.5358 .58581 m .51817 .59142 L .51812 .60895 L p F P
0 0 0 r
s
.16 .218 .444 r
.50072 .6144 m .51812 .60895 L .51817 .59142 L p F P
0 0 0 r
s
.83 .24 .1 r
.75797 .62739 m
.74224 .60854 L
s
.75797 .62739 m
.75223 .65357 L
s
.71028 .51995 m
.6937 .4992 L
s
.71028 .51995 m
.72091 .53997 L
s
.58328 .74641 m
.55924 .74215 L
s
.55924 .74215 m
.53999 .72534 L
s
.255 .371 .736 r
.54814 .42682 m .54008 .42974 L .55173 .44822 L p F P
0 0 0 r
s
.24 .35 .67 r
.53493 .4395 m
.54656 .46565 L
s
.255 .371 .736 r
.55173 .44822 m .56217 .4445 L .54814 .42682 L p F P
0 0 0 r
s
.24 .35 .67 r
.37284 .40581 m
.389 .41719 L
s
.42279 .40425 m
.389 .41719 L
s
.275 .404 .796 r
.50288 .40167 m .50011 .40271 L .50022 .42275 L p F P
0 0 0 r
s
.275 .404 .796 r
.50022 .42275 m .50563 .42076 L .50288 .40167 L p F P
0 0 0 r
s
.65 .169 .063 r
.44377 .64819 m .45333 .65648 L .45086 .64493 L p F P
0 0 0 r
s
.65 .169 .063 r
.45086 .64493 m .44077 .63611 L .44377 .64819 L p F P
0 0 0 r
s
.099 .122 .259 r
.46731 .63986 m .45086 .64493 L .45333 .65648 L p F P
0 0 0 r
s
1 .308 .129 r
.45822 .43286 m .45346 .42781 L .43991 .44577 L p F P
0 0 0 r
s
1 .306 .129 r
.45346 .42781 m .45822 .43286 L .4714 .41488 L p F P
0 0 0 r
s
1 .306 .129 r
.4746 .41836 m .4714 .41488 L .45822 .43286 L p F P
0 0 0 r
s
.24 .35 .67 r
.24134 .43916 m
.25751 .43872 L
s
.28999 .42599 m
.25751 .43872 L
s
.265 .388 .766 r
.52742 .41272 m .52195 .41474 L .53206 .43265 L p F P
0 0 0 r
s
.265 .388 .766 r
.53206 .43265 m .54008 .42974 L .52742 .41272 L p F P
0 0 0 r
s
1 .286 .116 r
.39763 .54555 m .40855 .55556 L .41246 .53529 L p F P
0 0 0 r
s
1 .286 .116 r
.41246 .53529 m .40204 .52554 L .39763 .54555 L p F P
0 0 0 r
s
.83 .24 .1 r
.40896 .51364 m
.43024 .5339 L
s
1 .303 .128 r
.4746 .41836 m .47779 .42183 L .48864 .40223 L p F P
0 0 0 r
s
1 .303 .128 r
.49025 .40402 m .48864 .40223 L .47779 .42183 L p F P
0 0 0 r
s
1 .306 .127 r
.40846 .47615 m .41728 .48481 L .42777 .46489 L p F P
0 0 0 r
s
1 .306 .127 r
.42777 .46489 m .42014 .45721 L .40846 .47615 L p F P
0 0 0 r
s
1 .308 .128 r
.42014 .45721 m .42777 .46489 L .43991 .44577 L p F P
0 0 0 r
s
.211 .299 .6 r
.56718 .53489 m .58422 .52928 L .57856 .50871 L p F P
0 0 0 r
s
.197 .277 .557 r
.58422 .52928 m .56718 .53489 L .57019 .55515 L p F P
0 0 0 r
s
.197 .277 .557 r
.55255 .56086 m .57019 .55515 L .56718 .53489 L p F P
0 0 0 r
s
.24 .35 .67 r
.56375 .52084 m
.56871 .54804 L
s
.224 .319 .638 r
.57856 .50871 m .59457 .50333 L .58561 .48312 L p F P
0 0 0 r
s
.211 .299 .6 r
.59457 .50333 m .57856 .50871 L .58422 .52928 L p F P
0 0 0 r
s
.275 .404 .796 r
.50565 .40063 m .50288 .40167 L .50563 .42076 L p F P
0 0 0 r
s
.275 .404 .796 r
.50563 .42076 m .51105 .41876 L .50565 .40063 L p F P
0 0 0 r
s
.24 .35 .67 r
.42541 .65996 m
.449 .65273 L
s
.42541 .65996 m
.41677 .67543 L
s
1 .308 .128 r
.43991 .44577 m .43363 .43928 L .42014 .45721 L p F P
0 0 0 r
s
1 .308 .129 r
.43363 .43928 m .43991 .44577 L .45346 .42781 L p F P
0 0 0 r
s
1 .302 .124 r
.39883 .49575 m .40865 .50516 L .41728 .48481 L p F P
0 0 0 r
s
1 .302 .124 r
.41728 .48481 m .40846 .47615 L .39883 .49575 L p F P
0 0 0 r
s
.83 .24 .1 r
.40896 .51364 m
.42213 .48896 L
s
.181 .25 .506 r
.57019 .55515 m .55255 .56086 L .55361 .58014 L p F P
0 0 0 r
s
.24 .35 .67 r
.53361 .55948 m
.56871 .54804 L
s
.181 .25 .506 r
.5358 .58581 m .55361 .58014 L .55255 .56086 L p F P
0 0 0 r
s
.245 .355 .705 r
.57268 .44076 m .56217 .4445 L .57474 .46339 L p F P
0 0 0 r
s
.245 .355 .705 r
.57474 .46339 m .58743 .45896 L .57268 .44076 L p F P
0 0 0 r
s
.235 .338 .673 r
.58743 .45896 m .57474 .46339 L .58561 .48312 L p F P
0 0 0 r
s
.255 .371 .736 r
.55624 .42388 m .54814 .42682 L .56217 .4445 L p F P
0 0 0 r
s
.255 .371 .736 r
.56217 .4445 m .57268 .44076 L .55624 .42388 L p F P
0 0 0 r
s
.265 .388 .766 r
.53291 .41069 m .52742 .41272 L .54008 .42974 L p F P
0 0 0 r
s
.265 .388 .766 r
.54008 .42974 m .54814 .42682 L .53291 .41069 L p F P
0 0 0 r
s
.83 .24 .1 r
.65397 .75463 m
.62746 .76154 L
s
.62746 .76154 m
.60935 .74501 L
s
.235 .338 .673 r
.58561 .48312 m .6002 .47813 L .58743 .45896 L p F P
0 0 0 r
s
.224 .319 .638 r
.6002 .47813 m .58561 .48312 L .59457 .50333 L p F P
0 0 0 r
s
.24 .35 .67 r
.55628 .49306 m
.59162 .48095 L
s
.275 .404 .796 r
.50842 .3996 m .50565 .40063 L .51105 .41876 L p F P
0 0 0 r
s
.275 .404 .796 r
.51105 .41876 m .51649 .41675 L .50842 .3996 L p F P
0 0 0 r
s
1 .303 .128 r
.4714 .41488 m .4746 .41836 L .48703 .40043 L p F P
0 0 0 r
s
1 .303 .128 r
.48864 .40223 m .48703 .40043 L .4746 .41836 L p F P
0 0 0 r
s
.134 .176 .364 r
.51812 .60895 m .50072 .6144 L .5007 .62955 L p F P
0 0 0 r
s
.134 .176 .364 r
.48392 .63473 m .5007 .62955 L .50072 .6144 L p F P
0 0 0 r
s
.24 .35 .67 r
.49918 .61908 m
.50071 .59608 L
s
.46471 .62983 m
.49918 .61908 L
s
.83 .24 .1 r
.67843 .4833 m
.66121 .4618 L
s
.67843 .4833 m
.6937 .4992 L
s
.24 .35 .67 r
.337 .70644 m
.30393 .71638 L
s
.28849 .72158 m
.30393 .71638 L
s
.16 .218 .444 r
.55361 .58014 m .5358 .58581 L .53569 .60345 L p F P
0 0 0 r
s
.16 .218 .444 r
.51812 .60895 m .53569 .60345 L .5358 .58581 L p F P
0 0 0 r
s
.24 .35 .67 r
.50071 .59608 m
.53547 .58501 L
s
1 .308 .129 r
.45346 .42781 m .44865 .42272 L .43363 .43928 L p F P
0 0 0 r
s
1 .306 .129 r
.44865 .42272 m .45346 .42781 L .46818 .41138 L p F P
0 0 0 r
s
1 .306 .129 r
.4714 .41488 m .46818 .41138 L .45346 .42781 L p F P
0 0 0 r
s
.24 .35 .67 r
.32313 .41301 m
.3394 .4188 L
s
.37284 .40581 m
.3394 .4188 L
s
1 .296 .121 r
.39145 .51561 m .40204 .52554 L .40865 .50516 L p F P
0 0 0 r
s
1 .296 .121 r
.40865 .50516 m .39883 .49575 L .39145 .51561 L p F P
0 0 0 r
s
.83 .24 .1 r
.53999 .72534 m
.51892 .71585 L
s
.51892 .71585 m
.49885 .69848 L
s
.275 .404 .796 r
.51119 .39856 m .50842 .3996 L .51649 .41675 L p F P
0 0 0 r
s
.275 .404 .796 r
.51649 .41675 m .52195 .41474 L .51119 .39856 L p F P
0 0 0 r
s
.24 .35 .67 r
.48705 .42832 m
.52174 .41553 L
s
.099 .122 .259 r
.48392 .63473 m .46731 .63986 L .46896 .65171 L p F P
0 0 0 r
s
.099 .122 .259 r
.45333 .65648 m .46896 .65171 L .46731 .63986 L p F P
0 0 0 r
s
.24 .35 .67 r
.45186 .65185 m
.45963 .64947 L
s
.45963 .64947 m
.46471 .62983 L
s
.83 .24 .1 r
.45714 .65532 m
.46943 .66603 L
s
.44866 .64794 m
.4534 .65206 L
s
.265 .388 .766 r
.53842 .40866 m .53291 .41069 L .54814 .42682 L p F P
0 0 0 r
s
.24 .35 .67 r
.52174 .41553 m
.53493 .4395 L
s
.83 .24 .1 r
.53421 .40573 m
.53715 .40913 L
s
.54113 .41373 m
.55142 .42563 L
s
.265 .388 .766 r
.54814 .42682 m .55624 .42388 L .53842 .40866 L p F P
0 0 0 r
s
.913 .25 .099 r
.40699 .59268 m .41791 .60236 L .41766 .5847 L p F P
0 0 0 r
s
.913 .25 .099 r
.41766 .5847 m .4067 .57483 L .40699 .59268 L p F P
0 0 0 r
s
.245 .355 .705 r
.58326 .43699 m .57268 .44076 L .58743 .45896 L p F P
0 0 0 r
s
.24 .35 .67 r
.54656 .46565 m
.58182 .45325 L
s
.245 .355 .705 r
.58743 .45896 m .60021 .45449 L .58326 .43699 L p F P
0 0 0 r
s
.235 .338 .673 r
.60021 .45449 m .58743 .45896 L .6002 .47813 L p F P
0 0 0 r
s
.255 .371 .736 r
.56438 .42093 m .55624 .42388 L .57268 .44076 L p F P
0 0 0 r
s
.255 .371 .736 r
.57268 .44076 m .58326 .43699 L .56438 .42093 L p F P
0 0 0 r
s
.24 .35 .67 r
.58182 .45325 m
.59162 .48095 L
s
.809 .217 .084 r
.42008 .618 m .43052 .62713 L .42864 .61188 L p F P
0 0 0 r
s
.809 .217 .084 r
.42864 .61188 m .41791 .60236 L .42008 .618 L p F P
0 0 0 r
s
.83 .24 .1 r
.41842 .58391 m
.43956 .60298 L
s
.211 .299 .6 r
.58422 .52928 m .60141 .5236 L .59457 .50333 L p F P
0 0 0 r
s
.197 .277 .557 r
.60141 .5236 m .58422 .52928 L .588 .54939 L p F P
0 0 0 r
s
.197 .277 .557 r
.57019 .55515 m .588 .54939 L .58422 .52928 L p F P
0 0 0 r
s
.224 .319 .638 r
.59457 .50333 m .61072 .49789 L .6002 .47813 L p F P
0 0 0 r
s
.211 .299 .6 r
.61072 .49789 m .59457 .50333 L .60141 .5236 L p F P
0 0 0 r
s
.24 .35 .67 r
.59162 .48095 m
.59929 .50897 L
s
.56375 .52084 m
.59929 .50897 L
s
1 .303 .128 r
.46818 .41138 m .4714 .41488 L .48541 .39863 L p F P
0 0 0 r
s
.24 .35 .67 r
.47479 .41094 m
.47514 .41143 L
s
1 .303 .128 r
.48703 .40043 m .48541 .39863 L .4714 .41488 L p F P
0 0 0 r
s
.24 .35 .67 r
.47253 .40774 m
.47273 .40801 L
s
.43834 .4206 m
.47253 .40774 L
s
.275 .404 .796 r
.51397 .39751 m .51119 .39856 L .52195 .41474 L p F P
0 0 0 r
s
.275 .404 .796 r
.52195 .41474 m .52742 .41272 L .51397 .39751 L p F P
0 0 0 r
s
.979 .272 .109 r
.39554 .56478 m .4067 .57483 L .40855 .55556 L p F P
0 0 0 r
s
.979 .272 .109 r
.40855 .55556 m .39763 .54555 L .39554 .56478 L p F P
0 0 0 r
s
.83 .24 .1 r
.74241 .58311 m
.72628 .56333 L
s
.74241 .58311 m
.74224 .60854 L
s
1 .308 .128 r
.41241 .44943 m .42014 .45721 L .43363 .43928 L p F P
0 0 0 r
s
1 .308 .128 r
.43363 .43928 m .42728 .43273 L .41241 .44943 L p F P
0 0 0 r
s
1 .308 .129 r
.42728 .43273 m .43363 .43928 L .44865 .42272 L p F P
0 0 0 r
s
.181 .25 .506 r
.588 .54939 m .57019 .55515 L .57161 .57442 L p F P
0 0 0 r
s
.181 .25 .506 r
.55361 .58014 m .57161 .57442 L .57019 .55515 L p F P
0 0 0 r
s
.24 .35 .67 r
.56871 .54804 m
.57094 .57372 L
s
1 .306 .127 r
.39951 .46737 m .40846 .47615 L .42014 .45721 L p F P
0 0 0 r
s
1 .306 .127 r
.42014 .45721 m .41241 .44943 L .39951 .46737 L p F P
0 0 0 r
s
.24 .35 .67 r
.47253 .40774 m
.47369 .4073 L
s
.235 .338 .673 r
.6002 .47813 m .6149 .47308 L .60021 .45449 L p F P
0 0 0 r
s
.224 .319 .638 r
.6149 .47308 m .6002 .47813 L .61072 .49789 L p F P
0 0 0 r
s
.24 .35 .67 r
.20913 .45184 m
.19413 .4584 L
s
.24134 .43916 m
.20913 .45184 L
s
.41677 .67543 m
.38277 .68572 L
s
.38277 .68572 m
.37075 .69629 L
s
.265 .388 .766 r
.54394 .40662 m .53842 .40866 L .55624 .42388 L p F P
0 0 0 r
s
.265 .388 .766 r
.55624 .42388 m .56438 .42093 L .54394 .40662 L p F P
0 0 0 r
s
.83 .24 .1 r
.75223 .65357 m
.73626 .63504 L
s
.75223 .65357 m
.74091 .67945 L
s
.275 .404 .796 r
.51676 .39647 m .51397 .39751 L .52742 .41272 L p F P
0 0 0 r
s
.275 .404 .796 r
.52742 .41272 m .53291 .41069 L .51676 .39647 L p F P
0 0 0 r
s
.284 .42 .826 r
.49185 .4058 m .4946 .40477 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .297 .127 r
.5 .38446 m .49025 .40402 L .49185 .4058 L closepath p F P
0 0 0 r
s
1 .308 .129 r
.44865 .42272 m .44381 .4176 L .42728 .43273 L p F P
0 0 0 r
s
.24 .35 .67 r
.42279 .40425 m
.43834 .4206 L
s
1 .306 .129 r
.44381 .4176 m .44865 .42272 L .46494 .40786 L p F P
0 0 0 r
s
1 .306 .129 r
.46818 .41138 m .46494 .40786 L .44865 .42272 L p F P
0 0 0 r
s
.65 .169 .063 r
.43407 .63977 m .44377 .64819 L .44077 .63611 L p F P
0 0 0 r
s
.83 .24 .1 r
.4415 .62652 m
.44866 .64794 L
s
.65 .169 .063 r
.44077 .63611 m .43052 .62713 L .43407 .63977 L p F P
0 0 0 r
s
.134 .176 .364 r
.53569 .60345 m .51812 .60895 L .51764 .62432 L p F P
0 0 0 r
s
.134 .176 .364 r
.5007 .62955 m .51764 .62432 L .51812 .60895 L p F P
0 0 0 r
s
.255 .371 .736 r
.57255 .41797 m .56438 .42093 L .58326 .43699 L p F P
0 0 0 r
s
.24 .35 .67 r
.53493 .4395 m
.5702 .42679 L
s
.255 .371 .736 r
.58326 .43699 m .59389 .4332 L .57255 .41797 L p F P
0 0 0 r
s
.24 .35 .67 r
.5702 .42679 m
.58182 .45325 L
s
.245 .355 .705 r
.59389 .4332 m .58326 .43699 L .60021 .45449 L p F P
0 0 0 r
s
1 .302 .124 r
.38885 .48619 m .39883 .49575 L .40846 .47615 L p F P
0 0 0 r
s
1 .302 .124 r
.40846 .47615 m .39951 .46737 L .38885 .48619 L p F P
0 0 0 r
s
.83 .24 .1 r
.40045 .46767 m
.42213 .48896 L
s
1 .303 .128 r
.46494 .40786 m .46818 .41138 L .48379 .39682 L p F P
0 0 0 r
s
.24 .35 .67 r
.47233 .40751 m
.47253 .40774 L
s
1 .303 .128 r
.48541 .39863 m .48379 .39682 L .46818 .41138 L p F P
0 0 0 r
s
.83 .24 .1 r
.49885 .69848 m
.48178 .68424 L
s
.48178 .68424 m
.46096 .66623 L
s
.284 .42 .826 r
.4946 .40477 m .49736 .40374 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .286 .116 r
.38652 .53535 m .39763 .54555 L .40204 .52554 L p F P
0 0 0 r
s
.83 .24 .1 r
.40028 .53902 m
.42188 .559 L
s
1 .286 .116 r
.40204 .52554 m .39145 .51561 L .38652 .53535 L p F P
0 0 0 r
s
.83 .24 .1 r
.40028 .53902 m
.40896 .51364 L
s
.245 .355 .705 r
.60021 .45449 m .61308 .44999 L .59389 .4332 L p F P
0 0 0 r
s
.235 .338 .673 r
.61308 .44999 m .60021 .45449 L .6149 .47308 L p F P
0 0 0 r
s
.16 .218 .444 r
.57161 .57442 m .55361 .58014 L .55345 .59789 L p F P
0 0 0 r
s
.16 .218 .444 r
.53569 .60345 m .55345 .59789 L .55361 .58014 L p F P
0 0 0 r
s
.275 .404 .796 r
.51955 .39542 m .51676 .39647 L .53291 .41069 L p F P
0 0 0 r
s
.275 .404 .796 r
.53291 .41069 m .53842 .40866 L .51955 .39542 L p F P
0 0 0 r
s
.83 .24 .1 r
.53241 .40445 m
.53293 .40425 L
s
.53293 .40425 m
.53417 .40568 L
s
1 .297 .127 r
.5 .38446 m .48864 .40223 L .49025 .40402 L closepath p F P
0 0 0 r
s
.284 .42 .826 r
.49736 .40374 m .50011 .40271 L .5 .38446 L closepath p F P
0 0 0 r
s
.265 .388 .766 r
.54949 .40458 m .54394 .40662 L .56438 .42093 L p F P
0 0 0 r
s
.265 .388 .766 r
.56438 .42093 m .57255 .41797 L .54949 .40458 L p F P
0 0 0 r
s
.099 .122 .259 r
.5007 .62955 m .48392 .63473 L .48474 .6469 L p F P
0 0 0 r
s
.099 .122 .259 r
.46896 .65171 m .48474 .6469 L .48392 .63473 L p F P
0 0 0 r
s
.83 .24 .1 r
.67986 .74226 m
.65397 .75463 L
s
.65397 .75463 m
.63619 .73785 L
s
.24 .35 .67 r
.27421 .42621 m
.28999 .42599 L
s
.32313 .41301 m
.28999 .42599 L
s
.224 .319 .638 r
.61072 .49789 m .62703 .49241 L .6149 .47308 L p F P
0 0 0 r
s
.211 .299 .6 r
.62703 .49241 m .61072 .49789 L .61878 .51788 L p F P
0 0 0 r
s
.211 .299 .6 r
.60141 .5236 m .61878 .51788 L .61072 .49789 L p F P
0 0 0 r
s
.284 .42 .826 r
.50011 .40271 m .50288 .40167 L .5 .38446 L closepath p F P
0 0 0 r
s
.197 .277 .557 r
.61878 .51788 m .60141 .5236 L .60599 .54356 L p F P
0 0 0 r
s
.197 .277 .557 r
.588 .54939 m .60599 .54356 L .60141 .5236 L p F P
0 0 0 r
s
.24 .35 .67 r
.59929 .50897 m
.60453 .53636 L
s
.83 .24 .1 r
.60935 .74501 m
.58328 .74641 L
s
.58328 .74641 m
.56423 .72948 L
s
1 .297 .127 r
.5 .38446 m .48703 .40043 L .48864 .40223 L closepath p F P
0 0 0 r
s
.275 .404 .796 r
.52234 .39438 m .51955 .39542 L .53842 .40866 L p F P
0 0 0 r
s
.275 .404 .796 r
.53842 .40866 m .54394 .40662 L .52234 .39438 L p F P
0 0 0 r
s
.235 .338 .673 r
.6149 .47308 m .62973 .468 L .61308 .44999 L p F P
0 0 0 r
s
.224 .319 .638 r
.62973 .468 m .6149 .47308 L .62703 .49241 L p F P
0 0 0 r
s
.284 .42 .826 r
.50288 .40167 m .50565 .40063 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .306 .129 r
.46494 .40786 m .46168 .40433 L .44381 .4176 L p F P
0 0 0 r
s
1 .303 .128 r
.46168 .40433 m .46494 .40786 L .48216 .39501 L p F P
0 0 0 r
s
.24 .35 .67 r
.46952 .40444 m
.46996 .40492 L
s
1 .303 .128 r
.48379 .39682 m .48216 .39501 L .46494 .40786 L p F P
0 0 0 r
s
.83 .24 .1 r
.46204 .40522 m
.48261 .42756 L
s
.255 .371 .736 r
.58077 .41499 m .57255 .41797 L .59389 .4332 L p F P
0 0 0 r
s
.255 .371 .736 r
.59389 .4332 m .60459 .42939 L .58077 .41499 L p F P
0 0 0 r
s
.83 .24 .1 r
.59317 .42249 m
.60176 .42271 L
s
.245 .355 .705 r
.60459 .42939 m .59389 .4332 L .61308 .44999 L p F P
0 0 0 r
s
.181 .25 .506 r
.60599 .54356 m .588 .54939 L .58979 .56863 L p F P
0 0 0 r
s
.24 .35 .67 r
.56871 .54804 m
.60453 .53636 L
s
.181 .25 .506 r
.57161 .57442 m .58979 .56863 L .588 .54939 L p F P
0 0 0 r
s
1 .308 .128 r
.40459 .44156 m .41241 .44943 L .42728 .43273 L p F P
0 0 0 r
s
.83 .24 .1 r
.41794 .44424 m
.43924 .46586 L
s
1 .308 .128 r
.42728 .43273 m .42087 .42611 L .40459 .44156 L p F P
0 0 0 r
s
1 .308 .129 r
.42087 .42611 m .42728 .43273 L .44381 .4176 L p F P
0 0 0 r
s
.265 .388 .766 r
.55505 .40253 m .54949 .40458 L .57255 .41797 L p F P
0 0 0 r
s
.265 .388 .766 r
.57255 .41797 m .58077 .41499 L .55505 .40253 L p F P
0 0 0 r
s
.83 .24 .1 r
.5645 .40669 m
.5651 .4074 L
s
.284 .42 .826 r
.50565 .40063 m .50842 .3996 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .297 .127 r
.5 .38446 m .48541 .39863 L .48703 .40043 L closepath p F P
0 0 0 r
s
1 .296 .121 r
.38068 .50552 m .39145 .51561 L .39883 .49575 L p F P
0 0 0 r
s
1 .296 .121 r
.39883 .49575 m .38885 .48619 L .38068 .50552 L p F P
0 0 0 r
s
1 .308 .129 r
.44381 .4176 m .43893 .41243 L .42087 .42611 L p F P
0 0 0 r
s
.83 .24 .1 r
.43871 .42317 m
.45965 .44515 L
s
1 .306 .129 r
.43893 .41243 m .44381 .4176 L .46168 .40433 L p F P
0 0 0 r
s
.83 .24 .1 r
.72091 .53997 m
.70431 .51931 L
s
.72091 .53997 m
.72628 .56333 L
s
.275 .404 .796 r
.52514 .39333 m .52234 .39438 L .54394 .40662 L p F P
0 0 0 r
s
.275 .404 .796 r
.54394 .40662 m .54949 .40458 L .52514 .39333 L p F P
0 0 0 r
s
.83 .24 .1 r
.41794 .44424 m
.43871 .42317 L
s
.245 .355 .705 r
.61308 .44999 m .62605 .44546 L .60459 .42939 L p F P
0 0 0 r
s
.83 .24 .1 r
.60176 .42271 m
.61156 .43461 L
s
.235 .338 .673 r
.62605 .44546 m .61308 .44999 L .62973 .468 L p F P
0 0 0 r
s
.284 .42 .826 r
.50842 .3996 m .51119 .39856 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .306 .127 r
.39043 .45845 m .39951 .46737 L .41241 .44943 L p F P
0 0 0 r
s
1 .306 .127 r
.41241 .44943 m .40459 .44156 L .39043 .45845 L p F P
0 0 0 r
s
.83 .24 .1 r
.40045 .46767 m
.41794 .44424 L
s
.134 .176 .364 r
.55345 .59789 m .53569 .60345 L .53475 .61904 L p F P
0 0 0 r
s
.134 .176 .364 r
.51764 .62432 m .53475 .61904 L .53569 .60345 L p F P
0 0 0 r
s
.24 .35 .67 r
.53436 .60811 m
.53547 .58501 L
s
.49918 .61908 m
.53436 .60811 L
s
.83 .24 .1 r
.74091 .67945 m
.72464 .66127 L
s
.74091 .67945 m
.7245 .70368 L
s
1 .297 .127 r
.5 .38446 m .48379 .39682 L .48541 .39863 L closepath p F P
0 0 0 r
s
.507 .125 .048 r
.44819 .65713 m .45696 .6647 L .45333 .65648 L p F P
0 0 0 r
s
.24 .35 .67 r
.45146 .66493 m
.45264 .6627 L
s
.45264 .6627 m
.45327 .66151 L
s
.507 .125 .048 r
.45333 .65648 m .44377 .64819 L .44819 .65713 L p F P
0 0 0 r
s
.066 .08 .157 r
.46896 .65171 m .45333 .65648 L .45696 .6647 L p F P
0 0 0 r
s
.83 .24 .1 r
.44866 .64794 m
.4569 .66019 L
s
.284 .42 .826 r
.51119 .39856 m .51397 .39751 L .5 .38446 L closepath p F P
0 0 0 r
s
.913 .25 .099 r
.39587 .58282 m .40699 .59268 L .4067 .57483 L p F P
0 0 0 r
s
.913 .25 .099 r
.4067 .57483 m .39554 .56478 L .39587 .58282 L p F P
0 0 0 r
s
.275 .404 .796 r
.52795 .39228 m .52514 .39333 L .54949 .40458 L p F P
0 0 0 r
s
.275 .404 .796 r
.54949 .40458 m .55505 .40253 L .52795 .39228 L p F P
0 0 0 r
s
.24 .35 .67 r
.37075 .69629 m
.337 .70644 L
s
.337 .70644 m
.32198 .71152 L
s
1 .306 .129 r
.46168 .40433 m .4584 .40077 L .43893 .41243 L p F P
0 0 0 r
s
.83 .24 .1 r
.43871 .42317 m
.46204 .40522 L
s
1 .303 .128 r
.4584 .40077 m .46168 .40433 L .48053 .3932 L p F P
0 0 0 r
s
.24 .35 .67 r
.4667 .40136 m
.46714 .40184 L
s
1 .303 .128 r
.48216 .39501 m .48053 .3932 L .46168 .40433 L p F P
0 0 0 r
s
.265 .388 .766 r
.56063 .40047 m .55505 .40253 L .58077 .41499 L p F P
0 0 0 r
s
.265 .388 .766 r
.58077 .41499 m .58902 .41199 L .56063 .40047 L p F P
0 0 0 r
s
.255 .371 .736 r
.58902 .41199 m .58077 .41499 L .60459 .42939 L p F P
0 0 0 r
s
.16 .218 .444 r
.58979 .56863 m .57161 .57442 L .57138 .59227 L p F P
0 0 0 r
s
.16 .218 .444 r
.55345 .59789 m .57138 .59227 L .57161 .57442 L p F P
0 0 0 r
s
.24 .35 .67 r
.53547 .58501 m
.57094 .57372 L
s
.35696 .39975 m
.37284 .40581 L
s
.809 .217 .084 r
.40947 .60871 m .42008 .618 L .41791 .60236 L p F P
0 0 0 r
s
.83 .24 .1 r
.41842 .58391 m
.42014 .60765 L
s
.809 .217 .084 r
.41791 .60236 m .40699 .59268 L .40947 .60871 L p F P
0 0 0 r
s
.284 .42 .826 r
.51397 .39751 m .51676 .39647 L .5 .38446 L closepath p F P
0 0 0 r
s
.255 .371 .736 r
.60459 .42939 m .61536 .42556 L .58902 .41199 L p F P
0 0 0 r
s
.245 .355 .705 r
.61536 .42556 m .60459 .42939 L .62605 .44546 L p F P
0 0 0 r
s
.24 .35 .67 r
.58182 .45325 m
.6178 .4406 L
s
.099 .122 .259 r
.51764 .62432 m .5007 .62955 L .50066 .64204 L p F P
0 0 0 r
s
.099 .122 .259 r
.48474 .6469 m .50066 .64204 L .5007 .62955 L p F P
0 0 0 r
s
.24 .35 .67 r
.49456 .63876 m
.49918 .61908 L
s
1 .297 .127 r
.5 .38446 m .48216 .39501 L .48379 .39682 L closepath p F P
0 0 0 r
s
.224 .319 .638 r
.62703 .49241 m .64348 .48688 L .62973 .468 L p F P
0 0 0 r
s
.24 .35 .67 r
.59162 .48095 m
.62769 .46858 L
s
.211 .299 .6 r
.64348 .48688 m .62703 .49241 L .63632 .51209 L p F P
0 0 0 r
s
.211 .299 .6 r
.61878 .51788 m .63632 .51209 L .62703 .49241 L p F P
0 0 0 r
s
.24 .35 .67 r
.59929 .50897 m
.63555 .49685 L
s
.83 .24 .1 r
.70379 .72498 m
.67986 .74226 L
s
.67986 .74226 m
.66246 .72517 L
s
.979 .272 .109 r
.38418 .55455 m .39554 .56478 L .39763 .54555 L p F P
0 0 0 r
s
.979 .272 .109 r
.39763 .54555 m .38652 .53535 L .38418 .55455 L p F P
0 0 0 r
s
.83 .24 .1 r
.39653 .56417 m
.40028 .53902 L
s
.284 .42 .826 r
.51676 .39647 m .51955 .39542 L .5 .38446 L closepath p F P
0 0 0 r
s
.235 .338 .673 r
.62973 .468 m .64468 .46288 L .62605 .44546 L p F P
0 0 0 r
s
.224 .319 .638 r
.64468 .46288 m .62973 .468 L .64348 .48688 L p F P
0 0 0 r
s
.197 .277 .557 r
.63632 .51209 m .61878 .51788 L .62417 .53768 L p F P
0 0 0 r
s
.197 .277 .557 r
.60599 .54356 m .62417 .53768 L .61878 .51788 L p F P
0 0 0 r
s
.275 .404 .796 r
.53075 .39123 m .52795 .39228 L .55505 .40253 L p F P
0 0 0 r
s
.275 .404 .796 r
.55505 .40253 m .56063 .40047 L .53075 .39123 L p F P
0 0 0 r
s
.24 .35 .67 r
.52174 .41553 m
.55714 .40248 L
s
.6178 .4406 m
.62769 .46858 L
s
.62769 .46858 m
.63555 .49685 L
s
1 .302 .124 r
.37871 .47647 m .38885 .48619 L .39951 .46737 L p F P
0 0 0 r
s
1 .302 .124 r
.39951 .46737 m .39043 .45845 L .37871 .47647 L p F P
0 0 0 r
s
.284 .42 .826 r
.51955 .39542 m .52234 .39438 L .5 .38446 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.50743 .39461 m
.52174 .41553 L
s
.245 .355 .705 r
.62605 .44546 m .63911 .4409 L .61536 .42556 L p F P
0 0 0 r
s
.83 .24 .1 r
.63517 .44227 m
.64201 .45071 L
s
.235 .338 .673 r
.63911 .4409 m .62605 .44546 L .64468 .46288 L p F P
0 0 0 r
s
1 .308 .129 r
.41439 .41942 m .42087 .42611 L .43893 .41243 L p F P
0 0 0 r
s
1 .308 .129 r
.43893 .41243 m .43401 .40721 L .41439 .41942 L p F P
0 0 0 r
s
1 .306 .129 r
.43401 .40721 m .43893 .41243 L .4584 .40077 L p F P
0 0 0 r
s
1 .297 .127 r
.5 .38446 m .48053 .3932 L .48216 .39501 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.48645 .4025 m
.50743 .39461 L
s
.856 .258 .113 r
.58471 .40678 m .58902 .41199 L .56063 .40047 L p F P
0 0 0 r
s
.24 .35 .67 r
.55714 .40248 m
.5702 .42679 L
s
.752 .23 .102 r
.58902 .41199 m .58471 .40678 L .6099 .41886 L p F P
0 0 0 r
s
.752 .23 .102 r
.6099 .41886 m .61536 .42556 L .58902 .41199 L p F P
0 0 0 r
s
.24 .35 .67 r
.60231 .41522 m
.6062 .41382 L
s
.5702 .42679 m
.59891 .41645 L
s
.6062 .41382 m
.60799 .41794 L
s
.65 .169 .063 r
.4242 .63121 m .43407 .63977 L .43052 .62713 L p F P
0 0 0 r
s
.65 .169 .063 r
.43052 .62713 m .42008 .618 L .4242 .63121 L p F P
0 0 0 r
s
.83 .24 .1 r
.42014 .60765 m
.4415 .62652 L
s
.7245 .70368 m
.70788 .68587 L
s
.7245 .70368 m
.70379 .72498 L
s
.181 .25 .506 r
.62417 .53768 m .60599 .54356 L .60816 .56279 L p F P
0 0 0 r
s
.181 .25 .506 r
.58979 .56863 m .60816 .56279 L .60599 .54356 L p F P
0 0 0 r
s
.24 .35 .67 r
.60453 .53636 m
.60713 .56219 L
s
.284 .42 .826 r
.52234 .39438 m .52514 .39333 L .5 .38446 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.74224 .60854 m
.72594 .58902 L
s
.74224 .60854 m
.73626 .63504 L
s
.6937 .4992 m
.70431 .51931 L
s
1 .306 .129 r
.4584 .40077 m .45511 .39719 L .43401 .40721 L p F P
0 0 0 r
s
1 .303 .128 r
.45511 .39719 m .4584 .40077 L .4789 .39138 L p F P
0 0 0 r
s
.24 .35 .67 r
.46387 .39826 m
.46431 .39875 L
s
1 .303 .128 r
.48053 .3932 m .4789 .39138 L .4584 .40077 L p F P
0 0 0 r
s
.83 .24 .1 r
.56423 .72948 m
.53999 .72534 L
s
.53999 .72534 m
.52003 .70792 L
s
1 .308 .128 r
.39666 .43358 m .40459 .44156 L .42087 .42611 L p F P
0 0 0 r
s
1 .308 .128 r
.42087 .42611 m .41439 .41942 L .39666 .43358 L p F P
0 0 0 r
s
.24 .35 .67 r
.22674 .44557 m
.24134 .43916 L
s
.27421 .42621 m
.24134 .43916 L
s
.927 .276 .12 r
.55762 .39689 m .56063 .40047 L .53075 .39123 L p F P
0 0 0 r
s
.856 .258 .113 r
.56063 .40047 m .55762 .39689 L .58471 .40678 L p F P
0 0 0 r
s
.83 .24 .1 r
.54905 .40128 m
.55848 .39954 L
s
.55848 .39954 m
.56183 .40351 L
s
.24 .35 .67 r
.55714 .40248 m
.56336 .40019 L
s
1 .286 .116 r
.37521 .52497 m .38652 .53535 L .39145 .51561 L p F P
0 0 0 r
s
1 .286 .116 r
.39145 .51561 m .38068 .50552 L .37521 .52497 L p F P
0 0 0 r
s
.83 .24 .1 r
.70379 .72498 m
.68679 .70755 L
s
.24 .35 .67 r
.45146 .66493 m
.41677 .67543 L
s
.41677 .67543 m
.4052 .68593 L
s
.601 .189 .087 r
.61536 .42556 m .6099 .41886 L .63267 .43291 L p F P
0 0 0 r
s
.601 .189 .087 r
.63267 .43291 m .63911 .4409 L .61536 .42556 L p F P
0 0 0 r
s
.24 .35 .67 r
.6178 .4406 m
.63172 .4357 L
s
.60953 .42151 m
.6178 .4406 L
s
.284 .42 .826 r
.52514 .39333 m .52795 .39228 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .297 .127 r
.5 .38446 m .4789 .39138 L .48053 .3932 L closepath p F P
0 0 0 r
s
.066 .08 .157 r
.48474 .6469 m .46896 .65171 L .47139 .66034 L p F P
0 0 0 r
s
.24 .35 .67 r
.45963 .64947 m
.49456 .63876 L
s
.066 .08 .157 r
.45696 .6647 m .47139 .66034 L .46896 .65171 L p F P
0 0 0 r
s
.83 .24 .1 r
.45943 .66396 m
.46096 .66623 L
s
.24 .35 .67 r
.45416 .65981 m
.45963 .64947 L
s
.284 .42 .826 r
.52795 .39228 m .53075 .39123 L .5 .38446 L closepath p F P
0 0 0 r
s
.134 .176 .364 r
.57138 .59227 m .55345 .59789 L .55203 .61371 L p F P
0 0 0 r
s
.134 .176 .364 r
.53475 .61904 m .55203 .61371 L .55345 .59789 L p F P
0 0 0 r
s
1 .303 .128 r
.4789 .39138 m .47726 .38955 L .45511 .39719 L p F P
0 0 0 r
s
1 .297 .127 r
.5 .38446 m .47726 .38955 L .4789 .39138 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.48709 .39105 m
.4993 .40473 L
s
.978 .289 .124 r
.52919 .3894 m .53075 .39123 L .5 .38446 L closepath p F P
0 0 0 r
s
.927 .276 .12 r
.53075 .39123 m .52919 .3894 L .55762 .39689 L p F P
0 0 0 r
s
1 .306 .127 r
.38122 .44941 m .39043 .45845 L .40459 .44156 L p F P
0 0 0 r
s
1 .306 .127 r
.40459 .44156 m .39666 .43358 L .38122 .44941 L p F P
0 0 0 r
s
.099 .122 .259 r
.53475 .61904 m .51764 .62432 L .51674 .63714 L p F P
0 0 0 r
s
.099 .122 .259 r
.50066 .64204 m .51674 .63714 L .51764 .62432 L p F P
0 0 0 r
s
.235 .338 .673 r
.64468 .46288 m .65976 .45771 L .63911 .4409 L p F P
0 0 0 r
s
.224 .319 .638 r
.65976 .45771 m .64468 .46288 L .66009 .4813 L p F P
0 0 0 r
s
.83 .24 .1 r
.65981 .46099 m
.66121 .4618 L
s
.224 .319 .638 r
.64348 .48688 m .66009 .4813 L .64468 .46288 L p F P
0 0 0 r
s
.16 .218 .444 r
.60816 .56279 m .58979 .56863 L .58951 .5866 L p F P
0 0 0 r
s
.16 .218 .444 r
.57138 .59227 m .58951 .5866 L .58979 .56863 L p F P
0 0 0 r
s
.211 .299 .6 r
.66009 .4813 m .64348 .48688 L .65403 .50625 L p F P
0 0 0 r
s
.211 .299 .6 r
.63632 .51209 m .65403 .50625 L .64348 .48688 L p F P
0 0 0 r
s
1 .306 .129 r
.42905 .40196 m .43401 .40721 L .45511 .39719 L p F P
0 0 0 r
s
1 .306 .129 r
.45511 .39719 m .4518 .39359 L .42905 .40196 L p F P
0 0 0 r
s
1 .303 .128 r
.4518 .39359 m .45511 .39719 L .47726 .38955 L p F P
0 0 0 r
s
.24 .35 .67 r
.42279 .40425 m
.45727 .39105 L
s
.83 .24 .1 r
.46204 .40522 m
.48709 .39105 L
s
.24 .35 .67 r
.45727 .39105 m
.45861 .39251 L
s
.453 .143 .069 r
.63911 .4409 m .63267 .43291 L .65252 .44865 L p F P
0 0 0 r
s
.453 .143 .069 r
.65252 .44865 m .65976 .45771 L .63911 .4409 L p F P
0 0 0 r
s
.927 .276 .12 r
.55459 .39329 m .55762 .39689 L .52919 .3894 L p F P
0 0 0 r
s
.856 .258 .113 r
.55762 .39689 m .55459 .39329 L .58036 .40152 L p F P
0 0 0 r
s
.24 .35 .67 r
.552 .39473 m
.55714 .40248 L
s
.565 .39959 m
.56708 .39882 L
s
.856 .258 .113 r
.58036 .40152 m .58471 .40678 L .55762 .39689 L p F P
0 0 0 r
s
1 .296 .121 r
.36972 .49525 m .38068 .50552 L .38885 .48619 L p F P
0 0 0 r
s
1 .296 .121 r
.38885 .48619 m .37871 .47647 L .36972 .49525 L p F P
0 0 0 r
s
.83 .24 .1 r
.38692 .49266 m
.40045 .46767 L
s
.38692 .49266 m
.40896 .51364 L
s
.197 .277 .557 r
.65403 .50625 m .63632 .51209 L .64253 .53173 L p F P
0 0 0 r
s
.197 .277 .557 r
.62417 .53768 m .64253 .53173 L .63632 .51209 L p F P
0 0 0 r
s
.24 .35 .67 r
.63555 .49685 m
.64109 .52445 L
s
.83 .24 .1 r
.63619 .73785 m
.60935 .74501 L
s
.60935 .74501 m
.59058 .72789 L
s
1 .308 .129 r
.40784 .41266 m .41439 .41942 L .43401 .40721 L p F P
0 0 0 r
s
1 .308 .129 r
.43401 .40721 m .42905 .40196 L .40784 .41266 L p F P
0 0 0 r
s
1 .303 .128 r
.47726 .38955 m .47561 .38772 L .4518 .39359 L p F P
0 0 0 r
s
1 .297 .127 r
.5 .38446 m .47561 .38772 L .47726 .38955 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.30777 .413 m
.32313 .41301 L
s
.35696 .39975 m
.32313 .41301 L
s
.978 .289 .124 r
.52762 .38757 m .52919 .3894 L .5 .38446 L closepath p F P
0 0 0 r
s
.927 .276 .12 r
.52919 .3894 m .52762 .38757 L .55459 .39329 L p F P
0 0 0 r
s
.752 .23 .102 r
.58471 .40678 m .58036 .40152 L .60439 .4121 L p F P
0 0 0 r
s
.752 .23 .102 r
.60439 .4121 m .6099 .41886 L .58471 .40678 L p F P
0 0 0 r
s
.24 .35 .67 r
.32198 .71152 m
.28849 .72158 L
s
.27109 .72076 m
.28849 .72158 L
s
.83 .24 .1 r
.65979 .46004 m
.66121 .4618 L
s
.507 .125 .048 r
.43928 .64944 m .44819 .65713 L .44377 .64819 L p F P
0 0 0 r
s
.507 .125 .048 r
.44377 .64819 m .43407 .63977 L .43928 .64944 L p F P
0 0 0 r
s
.181 .25 .506 r
.64253 .53173 m .62417 .53768 L .62672 .55688 L p F P
0 0 0 r
s
.24 .35 .67 r
.60453 .53636 m
.64109 .52445 L
s
.181 .25 .506 r
.60816 .56279 m .62672 .55688 L .62417 .53768 L p F P
0 0 0 r
s
1 .303 .128 r
.44847 .38997 m .4518 .39359 L .47561 .38772 L p F P
0 0 0 r
s
1 .303 .128 r
.47561 .38772 m .47396 .38588 L .44847 .38997 L p F P
0 0 0 r
s
1 .297 .127 r
.5 .38446 m .47396 .38588 L .47561 .38772 L closepath p F P
0 0 0 r
s
.978 .289 .124 r
.52604 .38573 m .52762 .38757 L .5 .38446 L closepath p F P
0 0 0 r
s
.927 .276 .12 r
.52762 .38757 m .52604 .38573 L .55154 .38967 L p F P
0 0 0 r
s
.927 .276 .12 r
.55154 .38967 m .55459 .39329 L .52762 .38757 L p F P
0 0 0 r
s
.24 .35 .67 r
.50743 .39461 m
.52867 .38662 L
s
.83 .24 .1 r
.52003 .70792 m
.49885 .69848 L
s
.49885 .69848 m
.47805 .68048 L
s
1 .308 .128 r
.38863 .4255 m .39666 .43358 L .41439 .41942 L p F P
0 0 0 r
s
1 .308 .128 r
.41439 .41942 m .40784 .41266 L .38863 .4255 L p F P
0 0 0 r
s
1 .306 .129 r
.42405 .39666 m .42905 .40196 L .4518 .39359 L p F P
0 0 0 r
s
1 .306 .129 r
.4518 .39359 m .44847 .38997 L .42405 .39666 L p F P
0 0 0 r
s
1 .297 .127 r
.5 .38446 m .46899 .38034 L .47065 .3822 L closepath p F P
0 0 0 r
s
1 .297 .127 r
.5 .38446 m .47065 .3822 L .47231 .38404 L closepath p F P
0 0 0 r
s
1 .297 .127 r
.5 .38446 m .47231 .38404 L .47396 .38588 L closepath p F P
0 0 0 r
s
.978 .289 .124 r
.52446 .38389 m .52604 .38573 L .5 .38446 L closepath p F P
0 0 0 r
s
.978 .289 .124 r
.52287 .38204 m .52446 .38389 L .5 .38446 L closepath p F P
0 0 0 r
s
.978 .289 .124 r
.52129 .38019 m .52287 .38204 L .5 .38446 L closepath p F P
0 0 0 r
s
.292 .436 .854 r
.5 .38446 m .46899 .38034 L .47177 .37927 L closepath p F P
0 0 0 r
s
.292 .436 .854 r
.5 .38446 m .47177 .37927 L .47456 .3782 L closepath p F P
0 0 0 r
s
.292 .436 .854 r
.5 .38446 m .47456 .3782 L .47736 .37712 L closepath p F P
0 0 0 r
s
.292 .436 .854 r
.5 .38446 m .47736 .37712 L .48016 .37605 L closepath p F P
0 0 0 r
s
.292 .436 .854 r
.5 .38446 m .48016 .37605 L .48296 .37497 L closepath p F P
0 0 0 r
s
.292 .436 .854 r
.5 .38446 m .48296 .37497 L .48577 .37389 L closepath p F P
0 0 0 r
s
.292 .436 .854 r
.5 .38446 m .48577 .37389 L .48858 .37281 L closepath p F P
0 0 0 r
s
.292 .436 .854 r
.5 .38446 m .48858 .37281 L .4914 .37172 L closepath p F P
0 0 0 r
s
.292 .436 .854 r
.5 .38446 m .4914 .37172 L .49422 .37064 L closepath p F P
0 0 0 r
s
.292 .436 .854 r
.5 .38446 m .49422 .37064 L .49705 .36955 L closepath p F P
0 0 0 r
s
.292 .436 .854 r
.5 .38446 m .49705 .36955 L .49988 .36846 L closepath p F P
0 0 0 r
s
.292 .436 .854 r
.5 .38446 m .49988 .36846 L .50272 .36737 L closepath p F P
0 0 0 r
s
.292 .436 .854 r
.5 .38446 m .50272 .36737 L .50556 .36627 L closepath p F P
0 0 0 r
s
.292 .436 .854 r
.5 .38446 m .50556 .36627 L .50841 .36518 L closepath p F P
0 0 0 r
s
.978 .289 .124 r
.51969 .37833 m .52129 .38019 L .5 .38446 L closepath p F P
0 0 0 r
s
.978 .289 .124 r
.51809 .37647 m .51969 .37833 L .5 .38446 L closepath p F P
0 0 0 r
s
.978 .289 .124 r
.51649 .3746 m .51809 .37647 L .5 .38446 L closepath p F P
0 0 0 r
s
.978 .289 .124 r
.51488 .37273 m .51649 .3746 L .5 .38446 L closepath p F P
0 0 0 r
s
.978 .289 .124 r
.51327 .37085 m .51488 .37273 L .5 .38446 L closepath p F P
0 0 0 r
s
.978 .289 .124 r
.51165 .36896 m .51327 .37085 L .5 .38446 L closepath p F P
0 0 0 r
s
.978 .289 .124 r
.51003 .36707 m .51165 .36896 L .5 .38446 L closepath p F P
0 0 0 r
s
.978 .289 .124 r
.50841 .36518 m .51003 .36707 L .5 .38446 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.49247 .37758 m
.50743 .39461 L
s
.83 .24 .1 r
.48709 .39105 m
.513 .38121 L
s
.856 .258 .113 r
.55459 .39329 m .55154 .38967 L .57598 .39622 L p F P
0 0 0 r
s
.24 .35 .67 r
.56932 .39799 m
.57463 .39603 L
s
.856 .258 .113 r
.57598 .39622 m .58036 .40152 L .55459 .39329 L p F P
0 0 0 r
s
.066 .08 .157 r
.50066 .64204 m .48474 .6469 L .48594 .65595 L p F P
0 0 0 r
s
.066 .08 .157 r
.47139 .66034 m .48594 .65595 L .48474 .6469 L p F P
0 0 0 r
s
.601 .189 .087 r
.6099 .41886 m .60439 .4121 L .62616 .42483 L p F P
0 0 0 r
s
.601 .189 .087 r
.62616 .42483 m .63267 .43291 L .6099 .41886 L p F P
0 0 0 r
s
.83 .24 .1 r
.60809 .42436 m
.62406 .42854 L
s
.62406 .42854 m
.63098 .43709 L
s
.913 .25 .099 r
.38454 .57279 m .39587 .58282 L .39554 .56478 L p F P
0 0 0 r
s
.913 .25 .099 r
.39554 .56478 m .38418 .55455 L .38454 .57279 L p F P
0 0 0 r
s
1 .302 .124 r
.36841 .4666 m .37871 .47647 L .39043 .45845 L p F P
0 0 0 r
s
1 .302 .124 r
.39043 .45845 m .38122 .44941 L .36841 .4666 L p F P
0 0 0 r
s
.809 .217 .084 r
.39867 .59926 m .40947 .60871 L .40699 .59268 L p F P
0 0 0 r
s
.809 .217 .084 r
.40699 .59268 m .39587 .58282 L .39867 .59926 L p F P
0 0 0 r
s
.83 .24 .1 r
.39653 .56417 m
.41842 .58391 L
s
1 .303 .128 r
.44512 .38633 m .44847 .38997 L .47396 .38588 L p F P
0 0 0 r
s
1 .303 .128 r
.47396 .38588 m .47231 .38404 L .44512 .38633 L p F P
0 0 0 r
s
.927 .276 .12 r
.52604 .38573 m .52446 .38389 L .54848 .38603 L p F P
0 0 0 r
s
.927 .276 .12 r
.54848 .38603 m .55154 .38967 L .52604 .38573 L p F P
0 0 0 r
s
.134 .176 .364 r
.58951 .5866 m .57138 .59227 L .56948 .60832 L p F P
0 0 0 r
s
.134 .176 .364 r
.55203 .61371 m .56948 .60832 L .57138 .59227 L p F P
0 0 0 r
s
.24 .35 .67 r
.57026 .59692 m
.57094 .57372 L
s
.53436 .60811 m
.57026 .59692 L
s
.224 .319 .638 r
.66009 .4813 m .67686 .47566 L .65976 .45771 L p F P
0 0 0 r
s
.309 .092 .048 r
.65976 .45771 m .65252 .44865 L .66897 .46577 L p F P
0 0 0 r
s
.24 .35 .67 r
.66077 .45724 m
.6645 .45596 L
s
.309 .092 .048 r
.66897 .46577 m .67686 .47566 L .65976 .45771 L p F P
0 0 0 r
s
.24 .35 .67 r
.62769 .46858 m
.65978 .45758 L
s
.979 .272 .109 r
.37261 .54413 m .38418 .55455 L .38652 .53535 L p F P
0 0 0 r
s
.979 .272 .109 r
.38652 .53535 m .37521 .52497 L .37261 .54413 L p F P
0 0 0 r
s
.24 .35 .67 r
.19413 .4584 m
.18145 .47088 L
s
.22674 .44557 m
.19413 .4584 L
s
.211 .299 .6 r
.67686 .47566 m .66009 .4813 L .67191 .50035 L p F P
0 0 0 r
s
.211 .299 .6 r
.65403 .50625 m .67191 .50035 L .66009 .4813 L p F P
0 0 0 r
s
.83 .24 .1 r
.72628 .56333 m
.70957 .54284 L
s
.72628 .56333 m
.72594 .58902 L
s
.24 .35 .67 r
.4052 .68593 m
.37075 .69629 L
s
.37075 .69629 m
.35616 .70125 L
s
.099 .122 .259 r
.55203 .61371 m .53475 .61904 L .53296 .63219 L p F P
0 0 0 r
s
.099 .122 .259 r
.51674 .63714 m .53296 .63219 L .53475 .61904 L p F P
0 0 0 r
s
1 .308 .129 r
.40122 .40583 m .40784 .41266 L .42905 .40196 L p F P
0 0 0 r
s
1 .308 .129 r
.42905 .40196 m .42405 .39666 L .40122 .40583 L p F P
0 0 0 r
s
.24 .35 .67 r
.37284 .40581 m
.40698 .39257 L
s
.40698 .39257 m
.41658 .39966 L
s
.16 .218 .444 r
.62672 .55688 m .60816 .56279 L .60782 .58087 L p F P
0 0 0 r
s
.16 .218 .444 r
.58951 .5866 m .60782 .58087 L .60816 .56279 L p F P
0 0 0 r
s
.24 .35 .67 r
.57094 .57372 m
.60713 .56219 L
s
1 .303 .128 r
.44175 .38268 m .44512 .38633 L .47231 .38404 L p F P
0 0 0 r
s
1 .303 .128 r
.47231 .38404 m .47065 .3822 L .44175 .38268 L p F P
0 0 0 r
s
.752 .23 .102 r
.58036 .40152 m .57598 .39622 L .59882 .40526 L p F P
0 0 0 r
s
.752 .23 .102 r
.59882 .40526 m .60439 .4121 L .58036 .40152 L p F P
0 0 0 r
s
.24 .35 .67 r
.59327 .38916 m
.6057 .41286 L
s
.927 .276 .12 r
.52446 .38389 m .52287 .38204 L .5454 .38237 L p F P
0 0 0 r
s
.927 .276 .12 r
.5454 .38237 m .54848 .38603 L .52446 .38389 L p F P
0 0 0 r
s
.197 .277 .557 r
.67191 .50035 m .65403 .50625 L .66109 .52572 L p F P
0 0 0 r
s
.197 .277 .557 r
.64253 .53173 m .66109 .52572 L .65403 .50625 L p F P
0 0 0 r
s
.83 .24 .1 r
.73626 .63504 m
.71971 .61583 L
s
.73626 .63504 m
.72464 .66127 L
s
1 .306 .129 r
.419 .39132 m .42405 .39666 L .44847 .38997 L p F P
0 0 0 r
s
1 .306 .129 r
.44847 .38997 m .44512 .38633 L .419 .39132 L p F P
0 0 0 r
s
.65 .169 .063 r
.41417 .62252 m .4242 .63121 L .42008 .618 L p F P
0 0 0 r
s
.83 .24 .1 r
.42014 .60765 m
.42715 .6292 L
s
.65 .169 .063 r
.42008 .618 m .40947 .60871 L .41417 .62252 L p F P
0 0 0 r
s
.856 .258 .113 r
.55154 .38967 m .54848 .38603 L .57156 .39087 L p F P
0 0 0 r
s
.856 .258 .113 r
.57156 .39087 m .57598 .39622 L .55154 .38967 L p F P
0 0 0 r
s
.24 .35 .67 r
.57555 .3957 m
.59327 .38916 L
s
1 .306 .127 r
.37187 .44023 m .38122 .44941 L .39666 .43358 L p F P
0 0 0 r
s
1 .306 .127 r
.39666 .43358 m .38863 .4255 L .37187 .44023 L p F P
0 0 0 r
s
1 .286 .116 r
.36369 .5144 m .37521 .52497 L .38068 .50552 L p F P
0 0 0 r
s
.83 .24 .1 r
.37789 .51832 m
.40028 .53902 L
s
1 .286 .116 r
.38068 .50552 m .36972 .49525 L .36369 .5144 L p F P
0 0 0 r
s
.24 .35 .67 r
.65452 .42769 m
.6645 .45596 L
s
.6645 .45596 m
.66656 .46327 L
s
1 .303 .128 r
.43836 .379 m .44175 .38268 L .47065 .3822 L p F P
0 0 0 r
s
1 .303 .128 r
.47065 .3822 m .46899 .38034 L .43836 .379 L p F P
0 0 0 r
s
.453 .143 .069 r
.63267 .43291 m .62616 .42483 L .64517 .43946 L p F P
0 0 0 r
s
.24 .35 .67 r
.63482 .43461 m
.63548 .43438 L
s
.453 .143 .069 r
.64517 .43946 m .65252 .44865 L .63267 .43291 L p F P
0 0 0 r
s
.24 .35 .67 r
.6376 .43364 m
.65452 .42769 L
s
.927 .276 .12 r
.52287 .38204 m .52129 .38019 L .54231 .37869 L p F P
0 0 0 r
s
.927 .276 .12 r
.54231 .37869 m .5454 .38237 L .52287 .38204 L p F P
0 0 0 r
s
.83 .24 .1 r
.513 .38121 m
.52502 .39511 L
s
.24 .35 .67 r
.64295 .40058 m
.65452 .42769 L
s
.69201 .4145 m
.65452 .42769 L
s
.83 .24 .1 r
.45861 .66421 m
.46096 .66623 L
s
.181 .25 .506 r
.66109 .52572 m .64253 .53173 L .64548 .55091 L p F P
0 0 0 r
s
.181 .25 .506 r
.62672 .55688 m .64548 .55091 L .64253 .53173 L p F P
0 0 0 r
s
.24 .35 .67 r
.64109 .52445 m
.64409 .55043 L
s
.63015 .37557 m
.59327 .38916 L
s
.066 .08 .157 r
.51674 .63714 m .50066 .64204 L .50061 .65151 L p F P
0 0 0 r
s
.24 .35 .67 r
.49456 .63876 m
.53021 .62783 L
s
.066 .08 .157 r
.48594 .65595 m .50061 .65151 L .50066 .64204 L p F P
0 0 0 r
s
.24 .35 .67 r
.26003 .43246 m
.27421 .42621 L
s
.30777 .413 m
.27421 .42621 L
s
.299 .449 .877 r
.47177 .37927 m .46899 .38034 L .43836 .379 L p F P
0 0 0 r
s
1 .308 .128 r
.3805 .41732 m .38863 .4255 L .40784 .41266 L p F P
0 0 0 r
s
.83 .24 .1 r
.39587 .42183 m
.41794 .44424 L
s
1 .308 .128 r
.40784 .41266 m .40122 .40583 L .3805 .41732 L p F P
0 0 0 r
s
.927 .276 .12 r
.52129 .38019 m .51969 .37833 L .5392 .37499 L p F P
0 0 0 r
s
.927 .276 .12 r
.5392 .37499 m .54231 .37869 L .52129 .38019 L p F P
0 0 0 r
s
.24 .35 .67 r
.45146 .66493 m
.44038 .67536 L
s
.83 .24 .1 r
.66246 .72517 m
.63619 .73785 L
s
.63619 .73785 m
.61777 .72047 L
s
1 .306 .129 r
.41392 .38593 m .419 .39132 L .44512 .38633 L p F P
0 0 0 r
s
.24 .35 .67 r
.40698 .39257 m
.41664 .38881 L
s
1 .306 .129 r
.44512 .38633 m .44175 .38268 L .41392 .38593 L p F P
0 0 0 r
s
.601 .189 .087 r
.60439 .4121 m .59882 .40526 L .61956 .41663 L p F P
0 0 0 r
s
.24 .35 .67 r
.60691 .41357 m
.608 .41317 L
s
.61117 .41203 m
.64295 .40058 L
s
.601 .189 .087 r
.61956 .41663 m .62616 .42483 L .60439 .4121 L p F P
0 0 0 r
s
1 .296 .121 r
.35856 .4848 m .36972 .49525 L .37871 .47647 L p F P
0 0 0 r
s
.83 .24 .1 r
.37789 .51832 m
.38692 .49266 L
s
1 .296 .121 r
.37871 .47647 m .36841 .4666 L .35856 .4848 L p F P
0 0 0 r
s
.856 .258 .113 r
.54848 .38603 m .5454 .38237 L .56711 .38548 L p F P
0 0 0 r
s
.856 .258 .113 r
.56711 .38548 m .57156 .39087 L .54848 .38603 L p F P
0 0 0 r
s
.299 .449 .877 r
.43836 .379 m .44385 .37686 L .47177 .37927 L p F P
0 0 0 r
s
.299 .449 .877 r
.47456 .3782 m .47177 .37927 L .44385 .37686 L p F P
0 0 0 r
s
.83 .24 .1 r
.59058 .72789 m
.56423 .72948 L
s
.56423 .72948 m
.54449 .71193 L
s
1 .308 .129 r
.39453 .39892 m .40122 .40583 L .42405 .39666 L p F P
0 0 0 r
s
.83 .24 .1 r
.41703 .4004 m
.43871 .42317 L
s
1 .308 .129 r
.42405 .39666 m .419 .39132 L .39453 .39892 L p F P
0 0 0 r
s
.134 .176 .364 r
.60782 .58087 m .58951 .5866 L .5871 .60288 L p F P
0 0 0 r
s
.134 .176 .364 r
.56948 .60832 m .5871 .60288 L .58951 .5866 L p F P
0 0 0 r
s
.211 .299 .6 r
.67191 .50035 m .68998 .49439 L .67686 .47566 L p F P
0 0 0 r
s
.24 .35 .67 r
.63555 .49685 m
.67256 .48448 L
s
.83 .24 .1 r
.68988 .49443 m
.6937 .4992 L
s
.471 .116 .045 r
.67686 .47566 m .66897 .46577 L .68162 .48393 L p F P
0 0 0 r
s
.83 .24 .1 r
.66617 .46696 m
.67652 .4777 L
s
.24 .35 .67 r
.66713 .46528 m
.67256 .48448 L
s
.471 .116 .045 r
.68162 .48393 m .68998 .49439 L .67686 .47566 L p F P
0 0 0 r
s
.83 .24 .1 r
.67652 .4777 m
.68044 .48261 L
s
.752 .23 .102 r
.57598 .39622 m .57156 .39087 L .59319 .39835 L p F P
0 0 0 r
s
.752 .23 .102 r
.59319 .39835 m .59882 .40526 L .57598 .39622 L p F P
0 0 0 r
s
.83 .24 .1 r
.583 .39992 m
.59804 .4182 L
s
.55848 .39954 m
.583 .39992 L
s
.325 .073 .03 r
.45398 .66257 m .46175 .66927 L .45696 .6647 L p F P
0 0 0 r
s
.24 .35 .67 r
.45146 .66493 m
.45535 .66375 L
s
.325 .073 .03 r
.45696 .6647 m .44819 .65713 L .45398 .66257 L p F P
0 0 0 r
s
.042 .053 .102 r
.47139 .66034 m .45696 .6647 L .46175 .66927 L p F P
0 0 0 r
s
.927 .276 .12 r
.51969 .37833 m .51809 .37647 L .53606 .37127 L p F P
0 0 0 r
s
.927 .276 .12 r
.53606 .37127 m .5392 .37499 L .51969 .37833 L p F P
0 0 0 r
s
.299 .449 .877 r
.44385 .37686 m .44936 .37472 L .47456 .3782 L p F P
0 0 0 r
s
.299 .449 .877 r
.47736 .37712 m .47456 .3782 L .44936 .37472 L p F P
0 0 0 r
s
.24 .35 .67 r
.47131 .38568 m
.49247 .37758 L
s
.681 .48166 m
.68236 .48121 L
s
.67256 .48448 m
.68022 .48192 L
s
.68236 .48121 m
.71035 .47185 L
s
.099 .122 .259 r
.56948 .60832 m .55203 .61371 L .54934 .6272 L p F P
0 0 0 r
s
.099 .122 .259 r
.53296 .63219 m .54934 .6272 L .55203 .61371 L p F P
0 0 0 r
s
.24 .35 .67 r
.53021 .62783 m
.53436 .60811 L
s
.507 .125 .048 r
.43024 .64163 m .43928 .64944 L .43407 .63977 L p F P
0 0 0 r
s
.507 .125 .048 r
.43407 .63977 m .4242 .63121 L .43024 .64163 L p F P
0 0 0 r
s
.83 .24 .1 r
.42715 .6292 m
.44866 .64794 L
s
.16 .218 .444 r
.64548 .55091 m .62672 .55688 L .62632 .57508 L p F P
0 0 0 r
s
.16 .218 .444 r
.60782 .58087 m .62632 .57508 L .62672 .55688 L p F P
0 0 0 r
s
.83 .24 .1 r
.70431 .51931 m
.70957 .54284 L
s
.299 .449 .877 r
.44936 .37472 m .45489 .37257 L .47736 .37712 L p F P
0 0 0 r
s
.299 .449 .877 r
.48016 .37605 m .47736 .37712 L .45489 .37257 L p F P
0 0 0 r
s
.83 .24 .1 r
.47463 .37706 m
.48709 .39105 L
s
.197 .277 .557 r
.68998 .49439 m .67191 .50035 L .67983 .51965 L p F P
0 0 0 r
s
.197 .277 .557 r
.66109 .52572 m .67983 .51965 L .67191 .50035 L p F P
0 0 0 r
s
.24 .35 .67 r
.67256 .48448 m
.67841 .51228 L
s
.63015 .37557 m
.64295 .40058 L
s
.68046 .38706 m
.64295 .40058 L
s
.83 .24 .1 r
.39587 .42183 m
.41703 .4004 L
s
1 .302 .124 r
.35794 .45656 m .36841 .4666 L .38122 .44941 L p F P
0 0 0 r
s
1 .302 .124 r
.38122 .44941 m .37187 .44023 L .35794 .45656 L p F P
0 0 0 r
s
.83 .24 .1 r
.378 .44562 m
.40045 .46767 L
s
.927 .276 .12 r
.51809 .37647 m .51649 .3746 L .53292 .36752 L p F P
0 0 0 r
s
.927 .276 .12 r
.53292 .36752 m .53606 .37127 L .51809 .37647 L p F P
0 0 0 r
s
.83 .24 .1 r
.513 .38121 m
.53882 .37619 L
s
.299 .449 .877 r
.45489 .37257 m .46044 .37042 L .48016 .37605 L p F P
0 0 0 r
s
.299 .449 .877 r
.48296 .37497 m .48016 .37605 L .46044 .37042 L p F P
0 0 0 r
s
1 .306 .129 r
.40879 .3805 m .41392 .38593 L .44175 .38268 L p F P
0 0 0 r
s
1 .306 .129 r
.44175 .38268 m .43836 .379 L .40879 .3805 L p F P
0 0 0 r
s
.83 .24 .1 r
.44073 .38208 m
.46204 .40522 L
s
.309 .092 .048 r
.65252 .44865 m .64517 .43946 L .66096 .45572 L p F P
0 0 0 r
s
.309 .092 .048 r
.66096 .45572 m .66897 .46577 L .65252 .44865 L p F P
0 0 0 r
s
.24 .35 .67 r
.6645 .45596 m
.70208 .44308 L
s
.856 .258 .113 r
.5454 .38237 m .54231 .37869 L .56262 .38005 L p F P
0 0 0 r
s
.856 .258 .113 r
.56262 .38005 m .56711 .38548 L .5454 .38237 L p F P
0 0 0 r
s
.24 .35 .67 r
.35616 .70125 m
.32198 .71152 L
s
.32198 .71152 m
.30496 .71052 L
s
.83 .24 .1 r
.72464 .66127 m
.70778 .64242 L
s
.72464 .66127 m
.70788 .68587 L
s
.299 .449 .877 r
.46044 .37042 m .466 .36826 L .48296 .37497 L p F P
0 0 0 r
s
.299 .449 .877 r
.48577 .37389 m .48296 .37497 L .466 .36826 L p F P
0 0 0 r
s
.927 .276 .12 r
.51649 .3746 m .51488 .37273 L .52975 .36376 L p F P
0 0 0 r
s
.927 .276 .12 r
.52975 .36376 m .53292 .36752 L .51649 .3746 L p F P
0 0 0 r
s
.913 .25 .099 r
.37302 .56257 m .38454 .57279 L .38418 .55455 L p F P
0 0 0 r
s
.913 .25 .099 r
.38418 .55455 m .37261 .54413 L .37302 .56257 L p F P
0 0 0 r
s
.066 .08 .157 r
.53296 .63219 m .51674 .63714 L .51541 .64704 L p F P
0 0 0 r
s
.066 .08 .157 r
.50061 .65151 m .51541 .64704 L .51674 .63714 L p F P
0 0 0 r
s
1 .306 .127 r
.36238 .43091 m .37187 .44023 L .38863 .4255 L p F P
0 0 0 r
s
1 .306 .127 r
.38863 .4255 m .3805 .41732 L .36238 .43091 L p F P
0 0 0 r
s
.83 .24 .1 r
.378 .44562 m
.39587 .42183 L
s
.809 .217 .084 r
.38768 .58964 m .39867 .59926 L .39587 .58282 L p F P
0 0 0 r
s
.83 .24 .1 r
.39653 .56417 m
.39801 .58809 L
s
.809 .217 .084 r
.39587 .58282 m .38454 .57279 L .38768 .58964 L p F P
0 0 0 r
s
.181 .25 .506 r
.67983 .51965 m .66109 .52572 L .66443 .54488 L p F P
0 0 0 r
s
.24 .35 .67 r
.64109 .52445 m
.67841 .51228 L
s
.181 .25 .506 r
.64548 .55091 m .66443 .54488 L .66109 .52572 L p F P
0 0 0 r
s
.299 .449 .877 r
.466 .36826 m .47158 .36609 L .48577 .37389 L p F P
0 0 0 r
s
.83 .24 .1 r
.46613 .36753 m
.46658 .36803 L
s
.299 .449 .877 r
.48858 .37281 m .48577 .37389 L .47158 .36609 L p F P
0 0 0 r
s
1 .308 .129 r
.38777 .39194 m .39453 .39892 L .419 .39132 L p F P
0 0 0 r
s
1 .308 .129 r
.419 .39132 m .41392 .38593 L .38777 .39194 L p F P
0 0 0 r
s
.83 .24 .1 r
.41703 .4004 m
.44073 .38208 L
s
.453 .143 .069 r
.62616 .42483 m .61956 .41663 L .63771 .43014 L p F P
0 0 0 r
s
.453 .143 .069 r
.63771 .43014 m .64517 .43946 L .62616 .42483 L p F P
0 0 0 r
s
.83 .24 .1 r
.46243 .36965 m
.46613 .36753 L
s
.979 .272 .109 r
.36083 .53352 m .37261 .54413 L .37521 .52497 L p F P
0 0 0 r
s
.979 .272 .109 r
.37521 .52497 m .36369 .5144 L .36083 .53352 L p F P
0 0 0 r
s
.83 .24 .1 r
.37384 .5437 m
.37789 .51832 L
s
.68679 .70755 m
.66246 .72517 L
s
.66246 .72517 m
.64443 .70747 L
s
1 .308 .128 r
.37227 .40903 m .3805 .41732 L .40122 .40583 L p F P
0 0 0 r
s
1 .308 .128 r
.40122 .40583 m .39453 .39892 L .37227 .40903 L p F P
0 0 0 r
s
.752 .23 .102 r
.57156 .39087 m .56711 .38548 L .5875 .39136 L p F P
0 0 0 r
s
.752 .23 .102 r
.5875 .39136 m .59319 .39835 L .57156 .39087 L p F P
0 0 0 r
s
.042 .053 .102 r
.48594 .65595 m .47139 .66034 L .47458 .66541 L p F P
0 0 0 r
s
.042 .053 .102 r
.46175 .66927 m .47458 .66541 L .47139 .66034 L p F P
0 0 0 r
s
.83 .24 .1 r
.46384 .66864 m
.47805 .68048 L
s
.299 .449 .877 r
.47158 .36609 m .47718 .36391 L .48858 .37281 L p F P
0 0 0 r
s
.299 .449 .877 r
.4914 .37172 m .48858 .37281 L .47718 .36391 L p F P
0 0 0 r
s
.927 .276 .12 r
.51488 .37273 m .51327 .37085 L .52656 .35997 L p F P
0 0 0 r
s
.927 .276 .12 r
.52656 .35997 m .52975 .36376 L .51488 .37273 L p F P
0 0 0 r
s
.601 .189 .087 r
.59882 .40526 m .59319 .39835 L .61288 .40833 L p F P
0 0 0 r
s
.601 .189 .087 r
.61288 .40833 m .61956 .41663 L .59882 .40526 L p F P
0 0 0 r
s
.3 .456 .884 r
.44385 .37686 m .43836 .379 L .40879 .3805 L p F P
0 0 0 r
s
.83 .24 .1 r
.44073 .38208 m
.45002 .37676 L
s
.24 .35 .67 r
.43572 .38141 m
.44182 .37904 L
s
.44182 .37904 m
.44755 .38349 L
s
.856 .258 .113 r
.54231 .37869 m .5392 .37499 L .55809 .37457 L p F P
0 0 0 r
s
.856 .258 .113 r
.55809 .37457 m .56262 .38005 L .54231 .37869 L p F P
0 0 0 r
s
.24 .35 .67 r
.55871 .37532 m
.57941 .36752 L
s
.83 .24 .1 r
.53882 .37619 m
.55848 .39954 L
s
.134 .176 .364 r
.62632 .57508 m .60782 .58087 L .60491 .59738 L p F P
0 0 0 r
s
.134 .176 .364 r
.5871 .60288 m .60491 .59738 L .60782 .58087 L p F P
0 0 0 r
s
.24 .35 .67 r
.60692 .58549 m
.60713 .56219 L
s
.57026 .59692 m
.60692 .58549 L
s
.65 .169 .063 r
.40398 .61367 m .41417 .62252 L .40947 .60871 L p F P
0 0 0 r
s
.65 .169 .063 r
.40947 .60871 m .39867 .59926 L .40398 .61367 L p F P
0 0 0 r
s
.83 .24 .1 r
.39801 .58809 m
.42014 .60765 L
s
.299 .449 .877 r
.47718 .36391 m .4828 .36173 L .4914 .37172 L p F P
0 0 0 r
s
.299 .449 .877 r
.49422 .37064 m .4914 .37172 L .4828 .36173 L p F P
0 0 0 r
s
.099 .122 .259 r
.5871 .60288 m .56948 .60832 L .56587 .62215 L p F P
0 0 0 r
s
.099 .122 .259 r
.54934 .6272 m .56587 .62215 L .56948 .60832 L p F P
0 0 0 r
s
.24 .35 .67 r
.21447 .45797 m
.22674 .44557 L
s
.26003 .43246 m
.22674 .44557 L
s
1 .286 .116 r
.35196 .50364 m .36369 .5144 L .36972 .49525 L p F P
0 0 0 r
s
1 .286 .116 r
.36972 .49525 m .35856 .4848 L .35196 .50364 L p F P
0 0 0 r
s
.24 .35 .67 r
.44038 .67536 m
.4052 .68593 L
s
.4052 .68593 m
.39107 .69076 L
s
.83 .24 .1 r
.70788 .68587 m
.69064 .66741 L
s
.70788 .68587 m
.68679 .70755 L
s
.72594 .58902 m
.70904 .56878 L
s
.72594 .58902 m
.71971 .61583 L
s
.927 .276 .12 r
.51327 .37085 m .51165 .36896 L .52336 .35616 L p F P
0 0 0 r
s
.927 .276 .12 r
.52336 .35616 m .52656 .35997 L .51327 .37085 L p F P
0 0 0 r
s
.83 .24 .1 r
.54449 .71193 m
.52003 .70792 L
s
.52003 .70792 m
.49935 .68986 L
s
.299 .449 .877 r
.4828 .36173 m .48844 .35954 L .49422 .37064 L p F P
0 0 0 r
s
.299 .449 .877 r
.49705 .36955 m .49422 .37064 L .48844 .35954 L p F P
0 0 0 r
s
.16 .218 .444 r
.66443 .54488 m .64548 .55091 L .64502 .56922 L p F P
0 0 0 r
s
.16 .218 .444 r
.62632 .57508 m .64502 .56922 L .64548 .55091 L p F P
0 0 0 r
s
.24 .35 .67 r
.60713 .56219 m
.64409 .55043 L
s
.197 .277 .557 r
.67983 .51965 m .69878 .51352 L .68998 .49439 L p F P
0 0 0 r
s
.641 .167 .062 r
.68998 .49439 m .68162 .48393 L .69011 .50274 L p F P
0 0 0 r
s
.641 .167 .062 r
.69011 .50274 m .69878 .51352 L .68998 .49439 L p F P
0 0 0 r
s
.83 .24 .1 r
.69761 .51098 m
.70431 .51931 L
s
.68679 .70755 m
.66916 .68948 L
s
.3 .456 .884 r
.40879 .3805 m .41685 .37734 L .44385 .37686 L p F P
0 0 0 r
s
.83 .24 .1 r
.43695 .37797 m
.44073 .38208 L
s
.3 .456 .884 r
.44936 .37472 m .44385 .37686 L .41685 .37734 L p F P
0 0 0 r
s
.299 .449 .877 r
.48844 .35954 m .49409 .35734 L .49705 .36955 L p F P
0 0 0 r
s
.83 .24 .1 r
.49235 .35733 m
.49279 .35785 L
s
.24 .35 .67 r
.4774 .36523 m
.49247 .37758 L
s
.299 .449 .877 r
.49988 .36846 m .49705 .36955 L .49409 .35734 L p F P
0 0 0 r
s
.24 .35 .67 r
.49247 .37758 m
.5139 .36937 L
s
.67841 .51228 m
.69376 .50728 L
s
.927 .276 .12 r
.51165 .36896 m .51003 .36707 L .52014 .35233 L p F P
0 0 0 r
s
.927 .276 .12 r
.52014 .35233 m .52336 .35616 L .51165 .36896 L p F P
0 0 0 r
s
1 .296 .121 r
.34722 .47417 m .35856 .4848 L .36841 .4666 L p F P
0 0 0 r
s
1 .296 .121 r
.36841 .4666 m .35794 .45656 L .34722 .47417 L p F P
0 0 0 r
s
.83 .24 .1 r
.36408 .47093 m
.38692 .49266 L
s
.24 .35 .67 r
.69201 .4145 m
.70208 .44308 L
s
.74045 .42993 m
.70208 .44308 L
s
.70208 .44308 m
.71035 .47185 L
s
.325 .073 .03 r
.44611 .65578 m .45398 .66257 L .44819 .65713 L p F P
0 0 0 r
s
.325 .073 .03 r
.44819 .65713 m .43928 .64944 L .44611 .65578 L p F P
0 0 0 r
s
.299 .449 .877 r
.49409 .35734 m .49976 .35514 L .49988 .36846 L p F P
0 0 0 r
s
.299 .449 .877 r
.50272 .36737 m .49988 .36846 L .49976 .35514 L p F P
0 0 0 r
s
.24 .35 .67 r
.68046 .38706 m
.69201 .4145 L
s
.73028 .40104 m
.69201 .4145 L
s
.856 .258 .113 r
.5392 .37499 m .53606 .37127 L .55352 .36904 L p F P
0 0 0 r
s
.856 .258 .113 r
.55352 .36904 m .55809 .37457 L .5392 .37499 L p F P
0 0 0 r
s
.066 .08 .157 r
.54934 .6272 m .53296 .63219 L .53034 .64252 L p F P
0 0 0 r
s
.066 .08 .157 r
.51541 .64704 m .53034 .64252 L .53296 .63219 L p F P
0 0 0 r
s
1 .308 .129 r
.38093 .38488 m .38777 .39194 L .41392 .38593 L p F P
0 0 0 r
s
1 .308 .129 r
.41392 .38593 m .40879 .3805 L .38093 .38488 L p F P
0 0 0 r
s
.471 .116 .045 r
.66897 .46577 m .66096 .45572 L .67311 .47328 L p F P
0 0 0 r
s
.471 .116 .045 r
.67311 .47328 m .68162 .48393 L .66897 .46577 L p F P
0 0 0 r
s
.3 .456 .884 r
.41685 .37734 m .42495 .37417 L .44936 .37472 L p F P
0 0 0 r
s
.3 .456 .884 r
.45489 .37257 m .44936 .37472 L .42495 .37417 L p F P
0 0 0 r
s
.752 .23 .102 r
.56711 .38548 m .56262 .38005 L .58175 .38429 L p F P
0 0 0 r
s
.752 .23 .102 r
.58175 .38429 m .5875 .39136 L .56711 .38548 L p F P
0 0 0 r
s
.24 .35 .67 r
.57941 .36752 m
.59327 .38916 L
s
.299 .449 .877 r
.49976 .35514 m .50546 .35293 L .50272 .36737 L p F P
0 0 0 r
s
.299 .449 .877 r
.50556 .36627 m .50272 .36737 L .50546 .35293 L p F P
0 0 0 r
s
.181 .25 .506 r
.69878 .51352 m .67983 .51965 L .68359 .53879 L p F P
0 0 0 r
s
.181 .25 .506 r
.66443 .54488 m .68359 .53879 L .67983 .51965 L p F P
0 0 0 r
s
.24 .35 .67 r
.67841 .51228 m
.68182 .53841 L
s
.30496 .71052 m
.27109 .72076 L
s
.25246 .71367 m
.27109 .72076 L
s
.042 .053 .102 r
.50061 .65151 m .48594 .65595 L .48751 .66153 L p F P
0 0 0 r
s
.24 .35 .67 r
.48688 .6542 m
.49456 .63876 L
s
.042 .053 .102 r
.47458 .66541 m .48751 .66153 L .48594 .65595 L p F P
0 0 0 r
s
.24 .35 .67 r
.45592 .66358 m
.48688 .6542 L
s
.61654 .35355 m
.63015 .37557 L
s
.66781 .36168 m
.63015 .37557 L
s
.927 .276 .12 r
.51003 .36707 m .50841 .36518 L .5169 .34848 L p F P
0 0 0 r
s
.927 .276 .12 r
.5169 .34848 m .52014 .35233 L .51003 .36707 L p F P
0 0 0 r
s
.83 .24 .1 r
.50072 .36702 m
.513 .38121 L
s
.507 .125 .048 r
.42106 .63371 m .43024 .64163 L .4242 .63121 L p F P
0 0 0 r
s
.507 .125 .048 r
.4242 .63121 m .41417 .62252 L .42106 .63371 L p F P
0 0 0 r
s
.24 .35 .67 r
.61654 .35355 m
.57941 .36752 L
s
1 .302 .124 r
.34729 .44636 m .35794 .45656 L .37187 .44023 L p F P
0 0 0 r
s
1 .302 .124 r
.37187 .44023 m .36238 .43091 L .34729 .44636 L p F P
0 0 0 r
s
.83 .24 .1 r
.36408 .47093 m
.378 .44562 L
s
.24 .35 .67 r
.29404 .41908 m
.30777 .413 L
s
.34203 .39951 m
.30777 .413 L
s
.299 .449 .877 r
.50546 .35293 m .51117 .35071 L .50556 .36627 L p F P
0 0 0 r
s
.299 .449 .877 r
.50841 .36518 m .50556 .36627 L .51117 .35071 L p F P
0 0 0 r
s
.83 .24 .1 r
.61777 .72047 m
.59058 .72789 L
s
.59058 .72789 m
.57112 .71013 L
s
1 .308 .128 r
.36392 .40063 m .37227 .40903 L .39453 .39892 L p F P
0 0 0 r
s
1 .308 .128 r
.39453 .39892 m .38777 .39194 L .36392 .40063 L p F P
0 0 0 r
s
.24 .35 .67 r
.35696 .39975 m
.38478 .38885 L
s
.309 .092 .048 r
.64517 .43946 m .63771 .43014 L .65281 .44551 L p F P
0 0 0 r
s
.309 .092 .048 r
.65281 .44551 m .66096 .45572 L .64517 .43946 L p F P
0 0 0 r
s
.83 .24 .1 r
.64336 .43953 m
.65897 .45902 L
s
.3 .456 .884 r
.42495 .37417 m .43309 .37098 L .45489 .37257 L p F P
0 0 0 r
s
.3 .456 .884 r
.46044 .37042 m .45489 .37257 L .43309 .37098 L p F P
0 0 0 r
s
1 .306 .127 r
.35274 .42146 m .36238 .43091 L .3805 .41732 L p F P
0 0 0 r
s
1 .306 .127 r
.3805 .41732 m .37227 .40903 L .35274 .42146 L p F P
0 0 0 r
s
.601 .189 .087 r
.59319 .39835 m .5875 .39136 L .6061 .39993 L p F P
0 0 0 r
s
.601 .189 .087 r
.6061 .39993 m .61288 .40833 L .59319 .39835 L p F P
0 0 0 r
s
.83 .24 .1 r
.583 .39992 m
.60546 .40557 L
s
.299 .449 .877 r
.51117 .35071 m .5169 .34848 L .50841 .36518 L p F P
0 0 0 r
s
.453 .143 .069 r
.61956 .41663 m .61288 .40833 L .63014 .42067 L p F P
0 0 0 r
s
.453 .143 .069 r
.63014 .42067 m .63771 .43014 L .61956 .41663 L p F P
0 0 0 r
s
.83 .24 .1 r
.60546 .40557 m
.62406 .42854 L
s
.62406 .42854 m
.64336 .43953 L
s
.134 .176 .364 r
.64502 .56922 m .62632 .57508 L .62289 .59183 L p F P
0 0 0 r
s
.134 .176 .364 r
.60491 .59738 m .62289 .59183 L .62632 .57508 L p F P
0 0 0 r
s
.099 .122 .259 r
.60491 .59738 m .5871 .60288 L .58256 .61706 L p F P
0 0 0 r
s
.099 .122 .259 r
.56587 .62215 m .58256 .61706 L .5871 .60288 L p F P
0 0 0 r
s
.24 .35 .67 r
.56661 .61668 m
.57026 .59692 L
s
.856 .258 .113 r
.53606 .37127 m .53292 .36752 L .54891 .36347 L p F P
0 0 0 r
s
.856 .258 .113 r
.54891 .36347 m .55352 .36904 L .53606 .37127 L p F P
0 0 0 r
s
.24 .35 .67 r
.74894 .45896 m
.71035 .47185 L
s
.71035 .47185 m
.71652 .49986 L
s
.83 .24 .1 r
.49935 .68986 m
.47805 .68048 L
s
.3 .456 .884 r
.43309 .37098 m .44127 .36778 L .46044 .37042 L p F P
0 0 0 r
s
.3 .456 .884 r
.466 .36826 m .46044 .37042 L .44127 .36778 L p F P
0 0 0 r
s
.16 .218 .444 r
.68359 .53879 m .66443 .54488 L .66391 .56331 L p F P
0 0 0 r
s
.16 .218 .444 r
.64502 .56922 m .66391 .56331 L .66443 .54488 L p F P
0 0 0 r
s
.24 .35 .67 r
.18145 .47088 m
.17182 .48898 L
s
.21447 .45797 m
.18145 .47088 L
s
.66781 .36168 m
.68046 .38706 L
s
.71877 .37326 m
.68046 .38706 L
s
.288 .444 .855 r
.41685 .37734 m .40879 .3805 L .38093 .38488 L p F P
0 0 0 r
s
.913 .25 .099 r
.36127 .55216 m .37302 .56257 L .37261 .54413 L p F P
0 0 0 r
s
.913 .25 .099 r
.37261 .54413 m .36083 .53352 L .36127 .55216 L p F P
0 0 0 r
s
.809 .217 .084 r
.3765 .57985 m .38768 .58964 L .38454 .57279 L p F P
0 0 0 r
s
.809 .217 .084 r
.38454 .57279 m .37302 .56257 L .3765 .57985 L p F P
0 0 0 r
s
.83 .24 .1 r
.37384 .5437 m
.39653 .56417 L
s
.752 .23 .102 r
.56262 .38005 m .55809 .37457 L .57593 .37715 L p F P
0 0 0 r
s
.752 .23 .102 r
.57593 .37715 m .58175 .38429 L .56262 .38005 L p F P
0 0 0 r
s
.066 .08 .157 r
.56587 .62215 m .54934 .6272 L .54539 .63797 L p F P
0 0 0 r
s
.066 .08 .157 r
.53034 .64252 m .54539 .63797 L .54934 .6272 L p F P
0 0 0 r
s
.24 .35 .67 r
.53021 .62783 m
.56661 .61668 L
s
.39107 .69076 m
.35616 .70125 L
s
.35616 .70125 m
.33955 .70007 L
s
.042 .053 .102 r
.51541 .64704 m .50061 .65151 L .50054 .65761 L p F P
0 0 0 r
s
.042 .053 .102 r
.48751 .66153 m .50054 .65761 L .50061 .65151 L p F P
0 0 0 r
s
.3 .456 .884 r
.44127 .36778 m .44949 .36456 L .466 .36826 L p F P
0 0 0 r
s
.3 .456 .884 r
.47158 .36609 m .466 .36826 L .44949 .36456 L p F P
0 0 0 r
s
.979 .272 .109 r
.34882 .52271 m .36083 .53352 L .36369 .5144 L p F P
0 0 0 r
s
.979 .272 .109 r
.36369 .5144 m .35196 .50364 L .34882 .52271 L p F P
0 0 0 r
s
.83 .24 .1 r
.70957 .54284 m
.70904 .56878 L
s
.856 .258 .113 r
.53292 .36752 m .52975 .36376 L .54427 .35785 L p F P
0 0 0 r
s
.856 .258 .113 r
.54427 .35785 m .54891 .36347 L .53292 .36752 L p F P
0 0 0 r
s
.65 .169 .063 r
.39361 .60468 m .40398 .61367 L .39867 .59926 L p F P
0 0 0 r
s
.65 .169 .063 r
.39867 .59926 m .38768 .58964 L .39361 .60468 L p F P
0 0 0 r
s
.83 .24 .1 r
.39801 .58809 m
.40485 .60977 L
s
.181 .25 .506 r
.68359 .53879 m .70296 .53263 L .69878 .51352 L p F P
0 0 0 r
s
.813 .22 .084 r
.69878 .51352 m .69011 .50274 L .69414 .5218 L p F P
0 0 0 r
s
.24 .35 .67 r
.69653 .50638 m
.71652 .49986 L
s
.69546 .50673 m
.69653 .50638 L
s
.813 .22 .084 r
.69414 .5218 m .70296 .53263 L .69878 .51352 L p F P
0 0 0 r
s
1 .286 .116 r
.34002 .49268 m .35196 .50364 L .35856 .4848 L p F P
0 0 0 r
s
.83 .24 .1 r
.35469 .49687 m
.37789 .51832 L
s
1 .286 .116 r
.35856 .4848 m .34722 .47417 L .34002 .49268 L p F P
0 0 0 r
s
.83 .24 .1 r
.71971 .61583 m
.70255 .5959 L
s
.71971 .61583 m
.70778 .64242 L
s
.288 .444 .855 r
.38093 .38488 m .39138 .38077 L .41685 .37734 L p F P
0 0 0 r
s
.83 .24 .1 r
.39914 .38161 m
.41703 .4004 L
s
.288 .444 .855 r
.42495 .37417 m .41685 .37734 L .39138 .38077 L p F P
0 0 0 r
s
.3 .456 .884 r
.44949 .36456 m .45774 .36133 L .47158 .36609 L p F P
0 0 0 r
s
.3 .456 .884 r
.47718 .36391 m .47158 .36609 L .45774 .36133 L p F P
0 0 0 r
s
.24 .35 .67 r
.44182 .37904 m
.4774 .36523 L
s
1 .308 .128 r
.35547 .39212 m .36392 .40063 L .38777 .39194 L p F P
0 0 0 r
s
.83 .24 .1 r
.373 .39861 m
.39587 .42183 L
s
.24 .35 .67 r
.34203 .39951 m
.35696 .39975 L
s
1 .308 .128 r
.38777 .39194 m .38093 .38488 L .35547 .39212 L p F P
0 0 0 r
s
.325 .073 .03 r
.43814 .64891 m .44611 .65578 L .43928 .64944 L p F P
0 0 0 r
s
.83 .24 .1 r
.43937 .64757 m
.45826 .6639 L
s
.325 .073 .03 r
.43928 .64944 m .43024 .64163 L .43814 .64891 L p F P
0 0 0 r
s
.83 .24 .1 r
.42715 .6292 m
.43937 .64757 L
s
.641 .167 .062 r
.68162 .48393 m .67311 .47328 L .68128 .49177 L p F P
0 0 0 r
s
.641 .167 .062 r
.68128 .49177 m .69011 .50274 L .68162 .48393 L p F P
0 0 0 r
s
.601 .189 .087 r
.5875 .39136 m .58175 .38429 L .59924 .39141 L p F P
0 0 0 r
s
.601 .189 .087 r
.59924 .39141 m .6061 .39993 L .5875 .39136 L p F P
0 0 0 r
s
.099 .122 .259 r
.62289 .59183 m .60491 .59738 L .59941 .61192 L p F P
0 0 0 r
s
.099 .122 .259 r
.58256 .61706 m .59941 .61192 L .60491 .59738 L p F P
0 0 0 r
s
.134 .176 .364 r
.66391 .56331 m .64502 .56922 L .64106 .58623 L p F P
0 0 0 r
s
.134 .176 .364 r
.62289 .59183 m .64106 .58623 L .64502 .56922 L p F P
0 0 0 r
s
.24 .35 .67 r
.64409 .55043 m
.64434 .57381 L
s
.60692 .58549 m
.64434 .57381 L
s
1 .296 .121 r
.33567 .46335 m .34722 .47417 L .35794 .45656 L p F P
0 0 0 r
s
.83 .24 .1 r
.35469 .49687 m
.36408 .47093 L
s
1 .296 .121 r
.35794 .45656 m .34729 .44636 L .33567 .46335 L p F P
0 0 0 r
s
.24 .35 .67 r
.2482 .44478 m
.26003 .43246 L
s
.29404 .41908 m
.26003 .43246 L
s
1 .306 .127 r
.34297 .41186 m .35274 .42146 L .37227 .40903 L p F P
0 0 0 r
s
1 .306 .127 r
.37227 .40903 m .36392 .40063 L .34297 .41186 L p F P
0 0 0 r
s
.24 .35 .67 r
.44038 .67536 m
.42673 .68005 L
s
.471 .116 .045 r
.66096 .45572 m .65281 .44551 L .66446 .46244 L p F P
0 0 0 r
s
.471 .116 .045 r
.66446 .46244 m .67311 .47328 L .66096 .45572 L p F P
0 0 0 r
s
.3 .456 .884 r
.45774 .36133 m .46604 .35808 L .47718 .36391 L p F P
0 0 0 r
s
.3 .456 .884 r
.4828 .36173 m .47718 .36391 L .46604 .35808 L p F P
0 0 0 r
s
.83 .24 .1 r
.48167 .36148 m
.49235 .35733 L
s
1 .302 .124 r
.33647 .43599 m .34729 .44636 L .36238 .43091 L p F P
0 0 0 r
s
1 .302 .124 r
.36238 .43091 m .35274 .42146 L .33647 .43599 L p F P
0 0 0 r
s
.83 .24 .1 r
.35471 .42275 m
.378 .44562 L
s
.856 .258 .113 r
.52975 .36376 m .52656 .35997 L .53959 .35218 L p F P
0 0 0 r
s
.856 .258 .113 r
.53959 .35218 m .54427 .35785 L .52975 .36376 L p F P
0 0 0 r
s
.24 .35 .67 r
.54421 .35777 m
.5651 .34977 L
s
.83 .24 .1 r
.49235 .35733 m
.4961 .35656 L
s
.752 .23 .102 r
.55809 .37457 m .55352 .36904 L .57005 .36993 L p F P
0 0 0 r
s
.752 .23 .102 r
.57005 .36993 m .57593 .37715 L .55809 .37457 L p F P
0 0 0 r
s
.83 .24 .1 r
.56355 .3763 m
.583 .39992 L
s
.53882 .37619 m
.56355 .3763 L
s
.453 .143 .069 r
.61288 .40833 m .6061 .39993 L .62245 .41106 L p F P
0 0 0 r
s
.453 .143 .069 r
.62245 .41106 m .63014 .42067 L .61288 .40833 L p F P
0 0 0 r
s
.16 .218 .444 r
.70296 .53263 m .68359 .53879 L .683 .55733 L p F P
0 0 0 r
s
.83 .24 .1 r
.7021 .53369 m
.70957 .54284 L
s
.16 .218 .444 r
.66391 .56331 m .683 .55733 L .68359 .53879 L p F P
0 0 0 r
s
.24 .35 .67 r
.64409 .55043 m
.68182 .53841 L
s
.288 .444 .855 r
.39138 .38077 m .40189 .37664 L .42495 .37417 L p F P
0 0 0 r
s
.83 .24 .1 r
.39456 .3768 m
.39644 .37878 L
s
.288 .444 .855 r
.43309 .37098 m .42495 .37417 L .40189 .37664 L p F P
0 0 0 r
s
.309 .092 .048 r
.63771 .43014 m .63014 .42067 L .64453 .43512 L p F P
0 0 0 r
s
.309 .092 .048 r
.64453 .43512 m .65281 .44551 L .63771 .43014 L p F P
0 0 0 r
s
.83 .24 .1 r
.64336 .43953 m
.65871 .45541 L
s
.507 .125 .048 r
.41174 .62567 m .42106 .63371 L .41417 .62252 L p F P
0 0 0 r
s
.507 .125 .048 r
.41417 .62252 m .40398 .61367 L .41174 .62567 L p F P
0 0 0 r
s
.83 .24 .1 r
.40485 .60977 m
.42715 .6292 L
s
.024 .035 .067 r
.47458 .66541 m .46175 .66927 L .46762 .6699 L p F P
0 0 0 r
s
.438 .139 .066 r
.46109 .66424 m .46762 .6699 L .46175 .66927 L p F P
0 0 0 r
s
.438 .139 .066 r
.46175 .66927 m .45398 .66257 L .46109 .66424 L p F P
0 0 0 r
s
.24 .35 .67 r
.46136 .66905 m
.46252 .6687 L
s
.44038 .67536 m
.46136 .66905 L
s
.83 .24 .1 r
.64443 .70747 m
.61777 .72047 L
s
.61777 .72047 m
.59867 .70243 L
s
.042 .053 .102 r
.53034 .64252 m .51541 .64704 L .51367 .65367 L p F P
0 0 0 r
s
.24 .35 .67 r
.52305 .64326 m
.53021 .62783 L
s
.042 .053 .102 r
.50054 .65761 m .51367 .65367 L .51541 .64704 L p F P
0 0 0 r
s
.24 .35 .67 r
.48688 .6542 m
.52305 .64326 L
s
.066 .08 .157 r
.58256 .61706 m .56587 .62215 L .56058 .63338 L p F P
0 0 0 r
s
.066 .08 .157 r
.54539 .63797 m .56058 .63338 L .56587 .62215 L p F P
0 0 0 r
s
.24 .35 .67 r
.75544 .48718 m
.71652 .49986 L
s
.71652 .49986 m
.72035 .52614 L
s
.83 .24 .1 r
.57112 .71013 m
.54449 .71193 L
s
.54449 .71193 m
.52401 .69373 L
s
.3 .456 .884 r
.46604 .35808 m .47438 .35482 L .4828 .36173 L p F P
0 0 0 r
s
.3 .456 .884 r
.48844 .35954 m .4828 .36173 L .47438 .35482 L p F P
0 0 0 r
s
.24 .35 .67 r
.73028 .40104 m
.74045 .42993 L
s
.77964 .41649 m
.74045 .42993 L
s
.74045 .42993 m
.74894 .45896 L
s
.71877 .37326 m
.73028 .40104 L
s
.76938 .3873 m
.73028 .40104 L
s
.33955 .70007 m
.30496 .71052 L
s
.30496 .71052 m
.28666 .70319 L
s
.856 .258 .113 r
.52656 .35997 m .52336 .35616 L .53486 .34646 L p F P
0 0 0 r
s
.856 .258 .113 r
.53486 .34646 m .53959 .35218 L .52656 .35997 L p F P
0 0 0 r
s
.24 .35 .67 r
.65447 .33929 m
.66781 .36168 L
s
.70628 .3475 m
.66781 .36168 L
s
.288 .444 .855 r
.40189 .37664 m .41246 .37248 L .43309 .37098 L p F P
0 0 0 r
s
.288 .444 .855 r
.44127 .36778 m .43309 .37098 L .41246 .37248 L p F P
0 0 0 r
s
.24 .35 .67 r
.60258 .33542 m
.61654 .35355 L
s
.65447 .33929 m
.61654 .35355 L
s
.3 .456 .884 r
.47438 .35482 m .48276 .35153 L .48844 .35954 L p F P
0 0 0 r
s
.3 .456 .884 r
.49409 .35734 m .48844 .35954 L .48276 .35153 L p F P
0 0 0 r
s
.83 .24 .1 r
.373 .39861 m
.38839 .38304 L
s
.39016 .38125 m
.39456 .3768 L
s
.25 .394 .75 r
.39138 .38077 m .38093 .38488 L .35547 .39212 L p F P
0 0 0 r
s
.099 .122 .259 r
.64106 .58623 m .62289 .59183 L .61642 .60673 L p F P
0 0 0 r
s
.099 .122 .259 r
.59941 .61192 m .61642 .60673 L .62289 .59183 L p F P
0 0 0 r
s
.24 .35 .67 r
.60378 .60528 m
.60692 .58549 L
s
.83 .24 .1 r
.70778 .64242 m
.69028 .62287 L
s
.70778 .64242 m
.69064 .66741 L
s
.601 .189 .087 r
.58175 .38429 m .57593 .37715 L .59229 .38278 L p F P
0 0 0 r
s
.601 .189 .087 r
.59229 .38278 m .59924 .39141 L .58175 .38429 L p F P
0 0 0 r
s
.134 .176 .364 r
.683 .55733 m .66391 .56331 L .65942 .58056 L p F P
0 0 0 r
s
.134 .176 .364 r
.64106 .58623 m .65942 .58056 L .66391 .56331 L p F P
0 0 0 r
s
.752 .23 .102 r
.55352 .36904 m .54891 .36347 L .56411 .36264 L p F P
0 0 0 r
s
.752 .23 .102 r
.56411 .36264 m .57005 .36993 L .55352 .36904 L p F P
0 0 0 r
s
.24 .35 .67 r
.5651 .34977 m
.57941 .36752 L
s
.024 .035 .067 r
.48751 .66153 m .47458 .66541 L .4785 .66664 L p F P
0 0 0 r
s
.024 .035 .067 r
.46762 .6699 m .4785 .66664 L .47458 .66541 L p F P
0 0 0 r
s
.24 .35 .67 r
.46529 .66787 m
.47631 .66456 L
s
.83 .24 .1 r
.46556 .66968 m
.47805 .68048 L
s
.3 .456 .884 r
.48276 .35153 m .49118 .34824 L .49409 .35734 L p F P
0 0 0 r
s
.3 .456 .884 r
.49976 .35514 m .49409 .35734 L .49118 .34824 L p F P
0 0 0 r
s
.24 .35 .67 r
.78835 .44579 m
.74894 .45896 L
s
.74894 .45896 m
.75544 .48718 L
s
.809 .217 .084 r
.36511 .56989 m .3765 .57985 L .37302 .56257 L p F P
0 0 0 r
s
.83 .24 .1 r
.37384 .5437 m
.37506 .56781 L
s
.809 .217 .084 r
.37302 .56257 m .36127 .55216 L .36511 .56989 L p F P
0 0 0 r
s
.913 .25 .099 r
.34931 .54156 m .36127 .55216 L .36083 .53352 L p F P
0 0 0 r
s
.913 .25 .099 r
.36083 .53352 m .34882 .52271 L .34931 .54156 L p F P
0 0 0 r
s
.042 .053 .102 r
.54539 .63797 m .53034 .64252 L .5269 .64969 L p F P
0 0 0 r
s
.042 .053 .102 r
.51367 .65367 m .5269 .64969 L .53034 .64252 L p F P
0 0 0 r
s
.288 .444 .855 r
.41246 .37248 m .4231 .36829 L .44127 .36778 L p F P
0 0 0 r
s
.83 .24 .1 r
.39456 .3768 m
.41863 .35808 L
s
.24 .35 .67 r
.42678 .37239 m
.44182 .37904 L
s
.39853 .38346 m
.42678 .37239 L
s
.288 .444 .855 r
.44949 .36456 m .44127 .36778 L .4231 .36829 L p F P
0 0 0 r
s
.83 .24 .1 r
.41863 .35808 m
.42746 .36767 L
s
.41863 .35808 m
.39571 .33319 L
s
.41863 .35808 m
.44439 .34314 L
s
.856 .258 .113 r
.52336 .35616 m .52014 .35233 L .5301 .3407 L p F P
0 0 0 r
s
.856 .258 .113 r
.5301 .3407 m .53486 .34646 L .52336 .35616 L p F P
0 0 0 r
s
.066 .08 .157 r
.59941 .61192 m .58256 .61706 L .5759 .62875 L p F P
0 0 0 r
s
.24 .35 .67 r
.56661 .61668 m
.60378 .60528 L
s
.066 .08 .157 r
.56058 .63338 m .5759 .62875 L .58256 .61706 L p F P
0 0 0 r
s
.24 .35 .67 r
.20524 .47606 m
.21447 .45797 L
s
.2482 .44478 m
.21447 .45797 L
s
.979 .272 .109 r
.33659 .51169 m .34882 .52271 L .35196 .50364 L p F P
0 0 0 r
s
.979 .272 .109 r
.35196 .50364 m .34002 .49268 L .33659 .51169 L p F P
0 0 0 r
s
.83 .24 .1 r
.35031 .52248 m
.35469 .49687 L
s
.16 .218 .444 r
.683 .55733 m .7023 .55129 L .70296 .53263 L p F P
0 0 0 r
s
.939 .259 .102 r
.70296 .53263 m .69414 .5218 L .69351 .54067 L p F P
0 0 0 r
s
.24 .35 .67 r
.68182 .53841 m
.69371 .53463 L
s
.70234 .53188 m
.72035 .52614 L
s
.939 .259 .102 r
.69351 .54067 m .7023 .55129 L .70296 .53263 L p F P
0 0 0 r
s
.24 .35 .67 r
.60258 .33542 m
.5651 .34977 L
s
.83 .24 .1 r
.66916 .68948 m
.64443 .70747 L
s
.64443 .70747 m
.62572 .6891 L
s
.24 .35 .67 r
.70628 .3475 m
.71877 .37326 L
s
.7579 .35916 m
.71877 .37326 L
s
.325 .073 .03 r
.43006 .64194 m .43814 .64891 L .43024 .64163 L p F P
0 0 0 r
s
.325 .073 .03 r
.43024 .64163 m .42106 .63371 L .43006 .64194 L p F P
0 0 0 r
s
.65 .169 .063 r
.38307 .59554 m .39361 .60468 L .38768 .58964 L p F P
0 0 0 r
s
.65 .169 .063 r
.38768 .58964 m .3765 .57985 L .38307 .59554 L p F P
0 0 0 r
s
.83 .24 .1 r
.37506 .56781 m
.39801 .58809 L
s
1 .306 .127 r
.33304 .40212 m .34297 .41186 L .36392 .40063 L p F P
0 0 0 r
s
1 .306 .127 r
.36392 .40063 m .35547 .39212 L .33304 .40212 L p F P
0 0 0 r
s
.83 .24 .1 r
.35471 .42275 m
.373 .39861 L
s
.3 .456 .884 r
.49118 .34824 m .49965 .34492 L .49976 .35514 L p F P
0 0 0 r
s
.3 .456 .884 r
.50546 .35293 m .49976 .35514 L .49965 .34492 L p F P
0 0 0 r
s
.813 .22 .084 r
.69011 .50274 m .68128 .49177 L .68516 .51077 L p F P
0 0 0 r
s
.813 .22 .084 r
.68516 .51077 m .69414 .5218 L .69011 .50274 L p F P
0 0 0 r
s
1 .286 .116 r
.32785 .48152 m .34002 .49268 L .34722 .47417 L p F P
0 0 0 r
s
1 .286 .116 r
.34722 .47417 m .33567 .46335 L .32785 .48152 L p F P
0 0 0 r
s
.453 .143 .069 r
.6061 .39993 m .59924 .39141 L .61465 .4013 L p F P
0 0 0 r
s
.453 .143 .069 r
.61465 .4013 m .62245 .41106 L .6061 .39993 L p F P
0 0 0 r
s
.24 .35 .67 r
.42673 .68005 m
.39107 .69076 L
s
.39107 .69076 m
.37488 .68938 L
s
.25 .394 .75 r
.35547 .39212 m .36805 .38715 L .39138 .38077 L p F P
0 0 0 r
s
.83 .24 .1 r
.36405 .38953 m
.373 .39861 L
s
.25 .394 .75 r
.40189 .37664 m .39138 .38077 L .36805 .38715 L p F P
0 0 0 r
s
.438 .139 .066 r
.45449 .65851 m .46109 .66424 L .45398 .66257 L p F P
0 0 0 r
s
.438 .139 .066 r
.45398 .66257 m .44611 .65578 L .45449 .65851 L p F P
0 0 0 r
s
.83 .24 .1 r
.43937 .64757 m
.45124 .65745 L
s
1 .296 .121 r
.32391 .45233 m .33567 .46335 L .34729 .44636 L p F P
0 0 0 r
s
1 .296 .121 r
.34729 .44636 m .33647 .43599 L .32391 .45233 L p F P
0 0 0 r
s
.83 .24 .1 r
.34039 .44838 m
.36408 .47093 L
s
1 .302 .124 r
.32547 .42545 m .33647 .43599 L .35274 .42146 L p F P
0 0 0 r
s
1 .302 .124 r
.35274 .42146 m .34297 .41186 L .32547 .42545 L p F P
0 0 0 r
s
.83 .24 .1 r
.34039 .44838 m
.35471 .42275 L
s
.641 .167 .062 r
.67311 .47328 m .66446 .46244 L .67228 .48059 L p F P
0 0 0 r
s
.83 .24 .1 r
.65871 .45541 m
.66461 .4628 L
s
.6731 .47342 m
.67327 .47364 L
s
.641 .167 .062 r
.67228 .48059 m .68128 .49177 L .67311 .47328 L p F P
0 0 0 r
s
.83 .24 .1 r
.69064 .66741 m
.67277 .64825 L
s
.69064 .66741 m
.66916 .68948 L
s
.70904 .56878 m
.70255 .5959 L
s
.24 .35 .67 r
.28666 .70319 m
.25246 .71367 L
s
.23348 .70035 m
.25246 .71367 L
s
.288 .444 .855 r
.4231 .36829 m .43381 .36407 L .44949 .36456 L p F P
0 0 0 r
s
.288 .444 .855 r
.45774 .36133 m .44949 .36456 L .43381 .36407 L p F P
0 0 0 r
s
.83 .24 .1 r
.52401 .69373 m
.49935 .68986 L
s
.49935 .68986 m
.47788 .67112 L
s
.309 .092 .048 r
.63014 .42067 m .62245 .41106 L .63611 .42456 L p F P
0 0 0 r
s
.83 .24 .1 r
.60546 .40557 m
.62486 .41644 L
s
.309 .092 .048 r
.63611 .42456 m .64453 .43512 L .63014 .42067 L p F P
0 0 0 r
s
.83 .24 .1 r
.62486 .41644 m
.64336 .43953 L
s
.471 .116 .045 r
.65281 .44551 m .64453 .43512 L .65564 .45141 L p F P
0 0 0 r
s
.471 .116 .045 r
.65564 .45141 m .66446 .46244 L .65281 .44551 L p F P
0 0 0 r
s
.3 .456 .884 r
.49965 .34492 m .50815 .34159 L .50546 .35293 L p F P
0 0 0 r
s
.3 .456 .884 r
.51117 .35071 m .50546 .35293 L .50815 .34159 L p F P
0 0 0 r
s
.24 .35 .67 r
.4774 .36523 m
.51374 .35113 L
s
.024 .035 .067 r
.50054 .65761 m .48751 .66153 L .48944 .66335 L p F P
0 0 0 r
s
.024 .035 .067 r
.4785 .66664 m .48944 .66335 L .48751 .66153 L p F P
0 0 0 r
s
.24 .35 .67 r
.47631 .66456 m
.48688 .6542 L
s
.83 .24 .1 r
.66916 .68948 m
.65087 .67073 L
s
.856 .258 .113 r
.52014 .35233 m .5169 .34848 L .52529 .33488 L p F P
0 0 0 r
s
.83 .24 .1 r
.5088 .35395 m
.51843 .35198 L
s
.24 .35 .67 r
.51374 .35113 m
.51917 .35583 L
s
.856 .258 .113 r
.52529 .33488 m .5301 .3407 L .52014 .35233 L p F P
0 0 0 r
s
.83 .24 .1 r
.51843 .35198 m
.53882 .37619 L
s
.752 .23 .102 r
.54891 .36347 m .54427 .35785 L .5581 .35525 L p F P
0 0 0 r
s
.752 .23 .102 r
.5581 .35525 m .56411 .36264 L .54891 .36347 L p F P
0 0 0 r
s
.507 .125 .048 r
.40228 .6175 m .41174 .62567 L .40398 .61367 L p F P
0 0 0 r
s
.507 .125 .048 r
.40398 .61367 m .39361 .60468 L .40228 .6175 L p F P
0 0 0 r
s
.099 .122 .259 r
.65942 .58056 m .64106 .58623 L .6336 .60149 L p F P
0 0 0 r
s
.099 .122 .259 r
.61642 .60673 m .6336 .60149 L .64106 .58623 L p F P
0 0 0 r
s
.042 .053 .102 r
.56058 .63338 m .54539 .63797 L .54023 .64568 L p F P
0 0 0 r
s
.042 .053 .102 r
.5269 .64969 m .54023 .64568 L .54539 .63797 L p F P
0 0 0 r
s
.134 .176 .364 r
.7023 .55129 m .683 .55733 L .67796 .57484 L p F P
0 0 0 r
s
.134 .176 .364 r
.65942 .58056 m .67796 .57484 L .683 .55733 L p F P
0 0 0 r
s
.24 .35 .67 r
.68182 .53841 m
.68257 .56189 L
s
.64434 .57381 m
.68257 .56189 L
s
.3 .456 .884 r
.50815 .34159 m .5167 .33825 L .51117 .35071 L p F P
0 0 0 r
s
.3 .456 .884 r
.5169 .34848 m .51117 .35071 L .5167 .33825 L p F P
0 0 0 r
s
.601 .189 .087 r
.57593 .37715 m .57005 .36993 L .58524 .37403 L p F P
0 0 0 r
s
.601 .189 .087 r
.58524 .37403 m .59229 .38278 L .57593 .37715 L p F P
0 0 0 r
s
.83 .24 .1 r
.56355 .3763 m
.58617 .38174 L
s
.24 .35 .67 r
.28265 .4313 m
.29404 .41908 L
s
.25 .394 .75 r
.36805 .38715 m .38074 .38215 L .40189 .37664 L p F P
0 0 0 r
s
.24 .35 .67 r
.37703 .38573 m
.38741 .38608 L
s
.25 .394 .75 r
.41246 .37248 m .40189 .37664 L .38074 .38215 L p F P
0 0 0 r
s
.288 .444 .855 r
.43381 .36407 m .44459 .35983 L .45774 .36133 L p F P
0 0 0 r
s
.288 .444 .855 r
.46604 .35808 m .45774 .36133 L .44459 .35983 L p F P
0 0 0 r
s
.83 .24 .1 r
.44439 .34314 m
.45827 .35872 L
s
.24 .35 .67 r
.17182 .48898 m
.16585 .51203 L
s
.20524 .47606 m
.17182 .48898 L
s
.066 .08 .157 r
.61642 .60673 m .59941 .61192 L .59136 .62408 L p F P
0 0 0 r
s
.066 .08 .157 r
.5759 .62875 m .59136 .62408 L .59941 .61192 L p F P
0 0 0 r
s
.83 .24 .1 r
.44439 .34314 m
.42183 .31784 L
s
.44439 .34314 m
.47092 .33257 L
s
.24 .35 .67 r
.51374 .35113 m
.52013 .34865 L
s
.83 .24 .1 r
.59867 .70243 m
.57112 .71013 L
s
.57112 .71013 m
.55093 .69171 L
s
.24 .35 .67 r
.75971 .51361 m
.72035 .52614 L
s
.72035 .52614 m
.72162 .54971 L
s
.3 .456 .884 r
.5167 .33825 m .52529 .33488 L .5169 .34848 L p F P
0 0 0 r
s
.83 .24 .1 r
.51481 .34768 m
.51843 .35198 L
s
.24 .35 .67 r
.7952 .47422 m
.75544 .48718 L
s
.75544 .48718 m
.75971 .51361 L
s
.024 .035 .067 r
.51367 .65367 m .50054 .65761 L .50046 .66005 L p F P
0 0 0 r
s
.024 .035 .067 r
.48944 .66335 m .50046 .66005 L .50054 .65761 L p F P
0 0 0 r
s
.24 .35 .67 r
.76938 .3873 m
.77964 .41649 L
s
.81967 .40277 m
.77964 .41649 L
s
.77964 .41649 m
.78835 .44579 L
s
.7579 .35916 m
.76938 .3873 L
s
.80931 .37325 m
.76938 .3873 L
s
.288 .444 .855 r
.44459 .35983 m .45544 .35556 L .46604 .35808 L p F P
0 0 0 r
s
.24 .35 .67 r
.46281 .35827 m
.4774 .36523 L
s
.288 .444 .855 r
.47438 .35482 m .46604 .35808 L .45544 .35556 L p F P
0 0 0 r
s
.752 .23 .102 r
.54427 .35785 m .53959 .35218 L .55202 .34779 L p F P
0 0 0 r
s
.752 .23 .102 r
.55202 .34779 m .5581 .35525 L .54427 .35785 L p F P
0 0 0 r
s
.024 .035 .067 r
.36805 .38715 m .35547 .39212 L .33304 .40212 L p F P
0 0 0 r
s
.24 .35 .67 r
.36359 .39102 m
.37703 .38573 L
s
.83 .24 .1 r
.36329 .38876 m
.36349 .38896 L
s
.24 .35 .67 r
.37488 .68938 m
.33955 .70007 L
s
.33955 .70007 m
.3216 .69249 L
s
.25 .394 .75 r
.38074 .38215 m .39352 .37711 L .41246 .37248 L p F P
0 0 0 r
s
.25 .394 .75 r
.4231 .36829 m .41246 .37248 L .39352 .37711 L p F P
0 0 0 r
s
.453 .143 .069 r
.59924 .39141 m .59229 .38278 L .60673 .3914 L p F P
0 0 0 r
s
.453 .143 .069 r
.60673 .3914 m .61465 .4013 L .59924 .39141 L p F P
0 0 0 r
s
.83 .24 .1 r
.58617 .38174 m
.60546 .40557 L
s
.24 .35 .67 r
.69321 .32471 m
.70628 .3475 L
s
.74557 .33302 m
.70628 .3475 L
s
.325 .073 .03 r
.42187 .63487 m .43006 .64194 L .42106 .63371 L p F P
0 0 0 r
s
.325 .073 .03 r
.42106 .63371 m .41174 .62567 L .42187 .63487 L p F P
0 0 0 r
s
.83 .24 .1 r
.41698 .62821 m
.43937 .64757 L
s
.40485 .60977 m
.41698 .62821 L
s
.24 .35 .67 r
.64088 .32076 m
.65447 .33929 L
s
.69321 .32471 m
.65447 .33929 L
s
.438 .139 .066 r
.44781 .65272 m .45449 .65851 L .44611 .65578 L p F P
0 0 0 r
s
.438 .139 .066 r
.44611 .65578 m .43814 .64891 L .44781 .65272 L p F P
0 0 0 r
s
.042 .053 .102 r
.5759 .62875 m .56058 .63338 L .55367 .64165 L p F P
0 0 0 r
s
.24 .35 .67 r
.55999 .63207 m
.56661 .61668 L
s
.042 .053 .102 r
.54023 .64568 m .55367 .64165 L .56058 .63338 L p F P
0 0 0 r
s
.24 .35 .67 r
.52305 .64326 m
.55999 .63207 L
s
.809 .217 .084 r
.35352 .55974 m .36511 .56989 L .36127 .55216 L p F P
0 0 0 r
s
.809 .217 .084 r
.36127 .55216 m .34931 .54156 L .35352 .55974 L p F P
0 0 0 r
s
.83 .24 .1 r
.35031 .52248 m
.37384 .5437 L
s
.913 .25 .099 r
.33713 .53076 m .34931 .54156 L .34882 .52271 L p F P
0 0 0 r
s
.913 .25 .099 r
.34882 .52271 m .33659 .51169 L .33713 .53076 L p F P
0 0 0 r
s
.099 .122 .259 r
.67796 .57484 m .65942 .58056 L .65094 .5962 L p F P
0 0 0 r
s
.099 .122 .259 r
.6336 .60149 m .65094 .5962 L .65942 .58056 L p F P
0 0 0 r
s
.24 .35 .67 r
.64175 .59364 m
.64434 .57381 L
s
1 .302 .124 r
.31428 .41472 m .32547 .42545 L .34297 .41186 L p F P
0 0 0 r
s
1 .302 .124 r
.34297 .41186 m .33304 .40212 L .31428 .41472 L p F P
0 0 0 r
s
.24 .35 .67 r
.29404 .41908 m
.32722 .40602 L
s
.979 .272 .109 r
.32413 .50047 m .33659 .51169 L .34002 .49268 L p F P
0 0 0 r
s
.979 .272 .109 r
.34002 .49268 m .32785 .48152 L .32413 .50047 L p F P
0 0 0 r
s
.134 .176 .364 r
.67796 .57484 m .6967 .56905 L .7023 .55129 L p F P
0 0 0 r
s
1 .284 .114 r
.7023 .55129 m .69351 .54067 L .6881 .55889 L p F P
0 0 0 r
s
1 .284 .114 r
.6881 .55889 m .6967 .56905 L .7023 .55129 L p F P
0 0 0 r
s
.24 .35 .67 r
.68257 .56189 m
.68896 .5599 L
s
.70004 .55645 m
.70114 .5561 L
s
.70114 .5561 m
.72162 .54971 L
s
.83 .24 .1 r
.70014 .55813 m
.70904 .56878 L
s
.65 .169 .063 r
.37235 .58624 m .38307 .59554 L .3765 .57985 L p F P
0 0 0 r
s
.65 .169 .063 r
.3765 .57985 m .36511 .56989 L .37235 .58624 L p F P
0 0 0 r
s
.83 .24 .1 r
.37506 .56781 m
.38172 .58962 L
s
.288 .444 .855 r
.45544 .35556 m .46636 .35127 L .47438 .35482 L p F P
0 0 0 r
s
.288 .444 .855 r
.48276 .35153 m .47438 .35482 L .46636 .35127 L p F P
0 0 0 r
s
.939 .259 .102 r
.69414 .5218 m .68516 .51077 L .68455 .52985 L p F P
0 0 0 r
s
.83 .24 .1 r
.69311 .52267 m
.69407 .52384 L
s
.939 .259 .102 r
.68455 .52985 m .69351 .54067 L .69414 .5218 L p F P
0 0 0 r
s
.066 .08 .157 r
.6336 .60149 m .61642 .60673 L .60695 .61936 L p F P
0 0 0 r
s
.24 .35 .67 r
.60378 .60528 m
.64175 .59364 L
s
.066 .08 .157 r
.59136 .62408 m .60695 .61936 L .61642 .60673 L p F P
0 0 0 r
s
.601 .189 .087 r
.57005 .36993 m .56411 .36264 L .5781 .36516 L p F P
0 0 0 r
s
.601 .189 .087 r
.5781 .36516 m .58524 .37403 L .57005 .36993 L p F P
0 0 0 r
s
.24 .35 .67 r
.82861 .43234 m
.78835 .44579 L
s
.78835 .44579 m
.7952 .47422 L
s
1 .286 .116 r
.31545 .47015 m .32785 .48152 L .33567 .46335 L p F P
0 0 0 r
s
.83 .24 .1 r
.33062 .47461 m
.35469 .49687 L
s
1 .286 .116 r
.33567 .46335 m .32391 .45233 L .31545 .47015 L p F P
0 0 0 r
s
.309 .092 .048 r
.62245 .41106 m .61465 .4013 L .62755 .41382 L p F P
0 0 0 r
s
.309 .092 .048 r
.62755 .41382 m .63611 .42456 L .62245 .41106 L p F P
0 0 0 r
s
1 .296 .121 r
.31194 .44112 m .32391 .45233 L .33647 .43599 L p F P
0 0 0 r
s
.83 .24 .1 r
.33062 .47461 m
.34039 .44838 L
s
1 .296 .121 r
.33647 .43599 m .32547 .42545 L .31194 .44112 L p F P
0 0 0 r
s
.813 .22 .084 r
.68128 .49177 m .67228 .48059 L .67601 .49953 L p F P
0 0 0 r
s
.813 .22 .084 r
.67601 .49953 m .68516 .51077 L .68128 .49177 L p F P
0 0 0 r
s
.024 .035 .067 r
.5269 .64969 m .51367 .65367 L .51154 .65673 L p F P
0 0 0 r
s
.024 .035 .067 r
.50046 .66005 m .51154 .65673 L .51367 .65367 L p F P
0 0 0 r
s
.641 .167 .062 r
.66446 .46244 m .65564 .45141 L .66312 .46919 L p F P
0 0 0 r
s
.641 .167 .062 r
.66312 .46919 m .67228 .48059 L .66446 .46244 L p F P
0 0 0 r
s
.24 .35 .67 r
.2394 .46286 m
.2482 .44478 L
s
.28265 .4313 m
.2482 .44478 L
s
.471 .116 .045 r
.64453 .43512 m .63611 .42456 L .64667 .44018 L p F P
0 0 0 r
s
.471 .116 .045 r
.64667 .44018 m .65564 .45141 L .64453 .43512 L p F P
0 0 0 r
s
.83 .24 .1 r
.70255 .5959 m
.69028 .62287 L
s
.24 .35 .67 r
.58878 .322 m
.60258 .33542 L
s
.64088 .32076 m
.60258 .33542 L
s
.25 .394 .75 r
.39352 .37711 m .4064 .37203 L .4231 .36829 L p F P
0 0 0 r
s
.83 .24 .1 r
.37124 .35232 m
.39449 .37673 L
s
.25 .394 .75 r
.43381 .36407 m .4231 .36829 L .4064 .37203 L p F P
0 0 0 r
s
.24 .35 .67 r
.42678 .37239 m
.46281 .35827 L
s
.74557 .33302 m
.7579 .35916 L
s
.79788 .34475 m
.7579 .35916 L
s
.024 .035 .067 r
.33304 .40212 m .34749 .39642 L .36805 .38715 L p F P
0 0 0 r
s
.024 .035 .067 r
.38074 .38215 m .36805 .38715 L .34749 .39642 L p F P
0 0 0 r
s
.752 .23 .102 r
.53959 .35218 m .53486 .34646 L .54587 .34025 L p F P
0 0 0 r
s
.752 .23 .102 r
.54587 .34025 m .55202 .34779 L .53959 .35218 L p F P
0 0 0 r
s
.83 .24 .1 r
.51843 .35198 m
.54338 .3518 L
s
.24 .35 .67 r
.55085 .33672 m
.5651 .34977 L
s
.507 .125 .048 r
.39267 .60921 m .40228 .6175 L .39361 .60468 L p F P
0 0 0 r
s
.507 .125 .048 r
.39361 .60468 m .38307 .59554 L .39267 .60921 L p F P
0 0 0 r
s
.83 .24 .1 r
.38172 .58962 m
.40485 .60977 L
s
.288 .444 .855 r
.46636 .35127 m .47735 .34694 L .48276 .35153 L p F P
0 0 0 r
s
.288 .444 .855 r
.49118 .34824 m .48276 .35153 L .47735 .34694 L p F P
0 0 0 r
s
.83 .24 .1 r
.47092 .33257 m
.48389 .34755 L
s
.24 .35 .67 r
.42673 .68005 m
.41099 .67847 L
s
.042 .053 .102 r
.59136 .62408 m .5759 .62875 L .56721 .63758 L p F P
0 0 0 r
s
.042 .053 .102 r
.55367 .64165 m .56721 .63758 L .5759 .62875 L p F P
0 0 0 r
s
.24 .35 .67 r
.3216 .69249 m
.28666 .70319 L
s
.28666 .70319 m
.26794 .68959 L
s
.83 .24 .1 r
.47092 .33257 m
.44869 .30686 L
s
.47092 .33257 m
.49728 .32686 L
s
.58 .187 .085 r
.46942 .66188 m .47452 .66634 L .46762 .6699 L p F P
0 0 0 r
s
.24 .35 .67 r
.47356 .66551 m
.47631 .66456 L
s
.58 .187 .085 r
.46762 .6699 m .46109 .66424 L .46942 .66188 L p F P
0 0 0 r
s
.24 .35 .67 r
.46639 .66798 m
.46697 .66778 L
s
.83 .24 .1 r
.46014 .66341 m
.46166 .66407 L
s
.24 .35 .67 r
.42673 .68005 m
.46316 .6691 L
s
.46316 .6691 m
.46639 .66798 L
s
.221 .353 .675 r
.4785 .66664 m .46762 .6699 L .47452 .66634 L p F P
0 0 0 r
s
.83 .24 .1 r
.4717 .66843 m
.47264 .66884 L
s
.47264 .66884 m
.47788 .67112 L
s
.62572 .6891 m
.59867 .70243 L
s
.59867 .70243 m
.57884 .68372 L
s
.099 .122 .259 r
.6967 .56905 m .67796 .57484 L .66845 .59086 L p F P
0 0 0 r
s
.099 .122 .259 r
.65094 .5962 m .66845 .59086 L .67796 .57484 L p F P
0 0 0 r
s
.024 .035 .067 r
.54023 .64568 m .5269 .64969 L .5227 .65338 L p F P
0 0 0 r
s
.024 .035 .067 r
.51154 .65673 m .5227 .65338 L .5269 .64969 L p F P
0 0 0 r
s
.24 .35 .67 r
.51301 .65352 m
.52305 .64326 L
s
.47631 .66456 m
.51301 .65352 L
s
.25 .394 .75 r
.4064 .37203 m .41938 .36691 L .43381 .36407 L p F P
0 0 0 r
s
.24 .35 .67 r
.41279 .37165 m
.42678 .37239 L
s
.25 .394 .75 r
.44459 .35983 m .43381 .36407 L .41938 .36691 L p F P
0 0 0 r
s
.83 .24 .1 r
.55093 .69171 m
.52401 .69373 L
s
.52401 .69373 m
.50275 .67484 L
s
.288 .444 .855 r
.47735 .34694 m .48841 .34259 L .49118 .34824 L p F P
0 0 0 r
s
.288 .444 .855 r
.49965 .34492 m .49118 .34824 L .48841 .34259 L p F P
0 0 0 r
s
.453 .143 .069 r
.59229 .38278 m .58524 .37403 L .59868 .38134 L p F P
0 0 0 r
s
.453 .143 .069 r
.59868 .38134 m .60673 .3914 L .59229 .38278 L p F P
0 0 0 r
s
.066 .08 .157 r
.65094 .5962 m .6336 .60149 L .62268 .61461 L p F P
0 0 0 r
s
.066 .08 .157 r
.60695 .61936 m .62268 .61461 L .6336 .60149 L p F P
0 0 0 r
s
.438 .139 .066 r
.44105 .64687 m .44781 .65272 L .43814 .64891 L p F P
0 0 0 r
s
.438 .139 .066 r
.43814 .64891 m .43006 .64194 L .44105 .64687 L p F P
0 0 0 r
s
.024 .035 .067 r
.34749 .39642 m .36207 .39068 L .38074 .38215 L p F P
0 0 0 r
s
.024 .035 .067 r
.39352 .37711 m .38074 .38215 L .36207 .39068 L p F P
0 0 0 r
s
.83 .24 .1 r
.34927 .37452 m
.36329 .38876 L
s
.601 .189 .087 r
.56411 .36264 m .5581 .35525 L .57087 .35618 L p F P
0 0 0 r
s
.83 .24 .1 r
.54338 .3518 m
.56355 .3763 L
s
.601 .189 .087 r
.57087 .35618 m .5781 .36516 L .56411 .36264 L p F P
0 0 0 r
s
.24 .35 .67 r
.19966 .49919 m
.20524 .47606 L
s
.2394 .46286 m
.20524 .47606 L
s
.325 .073 .03 r
.41358 .62771 m .42187 .63487 L .41174 .62567 L p F P
0 0 0 r
s
.325 .073 .03 r
.41174 .62567 m .40228 .6175 L .41358 .62771 L p F P
0 0 0 r
s
.24 .35 .67 r
.26794 .68959 m
.23348 .70035 L
s
.21511 .68126 m
.23348 .70035 L
s
.752 .23 .102 r
.53486 .34646 m .5301 .3407 L .53966 .33261 L p F P
0 0 0 r
s
.752 .23 .102 r
.53966 .33261 m .54587 .34025 L .53486 .34646 L p F P
0 0 0 r
s
.24 .35 .67 r
.54488 .33903 m
.55085 .33672 L
s
.58878 .322 m
.55085 .33672 L
s
.83 .24 .1 r
.34927 .37452 m
.37124 .35232 L
s
.37124 .35232 m
.34705 .32691 L
s
.37124 .35232 m
.39571 .33319 L
s
.221 .353 .675 r
.48944 .66335 m .4785 .66664 L .48309 .66377 L p F P
0 0 0 r
s
.221 .353 .675 r
.47452 .66634 m .48309 .66377 L .4785 .66664 L p F P
0 0 0 r
s
.24 .35 .67 r
.79993 .50081 m
.75971 .51361 L
s
.75971 .51361 m
.76152 .53727 L
s
.83 .24 .1 r
.34927 .37452 m
.32464 .34952 L
s
.288 .444 .855 r
.48841 .34259 m .49954 .33821 L .49965 .34492 L p F P
0 0 0 r
s
.288 .444 .855 r
.50815 .34159 m .49965 .34492 L .49954 .33821 L p F P
0 0 0 r
s
.24 .35 .67 r
.49961 .34385 m
.51374 .35113 L
s
.027 .038 .072 r
.34749 .39642 m .33304 .40212 L .31428 .41472 L p F P
0 0 0 r
s
.83 .24 .1 r
.33056 .39903 m
.34927 .37452 L
s
.33056 .39903 m
.33356 .40197 L
s
.33356 .40197 m
.33368 .40209 L
s
.33494 .40333 m
.35471 .42275 L
s
.24 .35 .67 r
.83583 .46098 m
.7952 .47422 L
s
.7952 .47422 m
.79993 .50081 L
s
.042 .053 .102 r
.60695 .61936 m .59136 .62408 L .58085 .63348 L p F P
0 0 0 r
s
.24 .35 .67 r
.59772 .62065 m
.60378 .60528 L
s
.042 .053 .102 r
.56721 .63758 m .58085 .63348 L .59136 .62408 L p F P
0 0 0 r
s
.24 .35 .67 r
.55999 .63207 m
.59772 .62065 L
s
.83 .24 .1 r
.69028 .62287 m
.67277 .64825 L
s
.24 .35 .67 r
.80931 .37325 m
.81967 .40277 L
s
.81967 .40277 m
.82861 .43234 L
s
.25 .394 .75 r
.41938 .36691 m .43246 .36175 L .44459 .35983 L p F P
0 0 0 r
s
.25 .394 .75 r
.45544 .35556 m .44459 .35983 L .43246 .36175 L p F P
0 0 0 r
s
.309 .092 .048 r
.61465 .4013 m .60673 .3914 L .61883 .4029 L p F P
0 0 0 r
s
.309 .092 .048 r
.61883 .4029 m .62755 .41382 L .61465 .4013 L p F P
0 0 0 r
s
.24 .35 .67 r
.79788 .34475 m
.80931 .37325 L
s
.16585 .51203 m
.19966 .49919 L
s
.16585 .51203 m
.16402 .53904 L
s
.024 .035 .067 r
.55367 .64165 m .54023 .64568 L .53393 .65002 L p F P
0 0 0 r
s
.024 .035 .067 r
.5227 .65338 m .53393 .65002 L .54023 .64568 L p F P
0 0 0 r
s
.809 .217 .084 r
.34172 .54941 m .35352 .55974 L .34931 .54156 L p F P
0 0 0 r
s
.83 .24 .1 r
.35031 .52248 m
.35126 .54677 L
s
.809 .217 .084 r
.34931 .54156 m .33713 .53076 L .34172 .54941 L p F P
0 0 0 r
s
.913 .25 .099 r
.32471 .51975 m .33713 .53076 L .33659 .51169 L p F P
0 0 0 r
s
.913 .25 .099 r
.33659 .51169 m .32413 .50047 L .32471 .51975 L p F P
0 0 0 r
s
.65 .169 .063 r
.36145 .57679 m .37235 .58624 L .36511 .56989 L p F P
0 0 0 r
s
.65 .169 .063 r
.36511 .56989 m .35352 .55974 L .36145 .57679 L p F P
0 0 0 r
s
.83 .24 .1 r
.35126 .54677 m
.37506 .56781 L
s
1 .296 .121 r
.29975 .4297 m .31194 .44112 L .32547 .42545 L p F P
0 0 0 r
s
1 .296 .121 r
.32547 .42545 m .31428 .41472 L .29975 .4297 L p F P
0 0 0 r
s
.24 .35 .67 r
.41099 .67847 m
.37488 .68938 L
s
.37488 .68938 m
.35731 .68155 L
s
.83 .24 .1 r
.39571 .33319 m
.37192 .30736 L
s
.39571 .33319 m
.42183 .31784 L
s
.58 .187 .085 r
.46427 .65738 m .46942 .66188 L .46109 .66424 L p F P
0 0 0 r
s
.58 .187 .085 r
.46109 .66424 m .45449 .65851 L .46427 .65738 L p F P
0 0 0 r
s
.24 .35 .67 r
.73279 .30982 m
.74557 .33302 L
s
.78572 .31822 m
.74557 .33302 L
s
.979 .272 .109 r
.31143 .48903 m .32413 .50047 L .32785 .48152 L p F P
0 0 0 r
s
.979 .272 .109 r
.32785 .48152 m .31545 .47015 L .31143 .48903 L p F P
0 0 0 r
s
.83 .24 .1 r
.32589 .50047 m
.33062 .47461 L
s
1 .284 .114 r
.69351 .54067 m .68455 .52985 L .67935 .54855 L p F P
0 0 0 r
s
1 .284 .114 r
.67935 .54855 m .6881 .55889 L .69351 .54067 L p F P
0 0 0 r
s
.24 .35 .67 r
.68 .30578 m
.69321 .32471 L
s
.73279 .30982 m
.69321 .32471 L
s
.83 .24 .1 r
.65087 .67073 m
.62572 .6891 L
s
.62572 .6891 m
.6063 .67003 L
s
.024 .035 .067 r
.36207 .39068 m .37678 .38488 L .39352 .37711 L p F P
0 0 0 r
s
.024 .035 .067 r
.4064 .37203 m .39352 .37711 L .37678 .38488 L p F P
0 0 0 r
s
.24 .35 .67 r
.37703 .38573 m
.41279 .37165 L
s
1 .286 .116 r
.30282 .45856 m .31545 .47015 L .32391 .45233 L p F P
0 0 0 r
s
1 .286 .116 r
.32391 .45233 m .31194 .44112 L .30282 .45856 L p F P
0 0 0 r
s
.83 .24 .1 r
.31581 .42499 m
.34039 .44838 L
s
.939 .259 .102 r
.68516 .51077 m .67601 .49953 L .67543 .51883 L p F P
0 0 0 r
s
.83 .24 .1 r
.67425 .49953 m
.67595 .50162 L
s
.68412 .51163 m
.68509 .51283 L
s
.939 .259 .102 r
.67543 .51883 m .68455 .52985 L .68516 .51077 L p F P
0 0 0 r
s
.24 .35 .67 r
.76152 .53727 m
.72162 .54971 L
s
.72162 .54971 m
.72019 .5696 L
s
.099 .122 .259 r
.66845 .59086 m .68613 .58547 L .6967 .56905 L p F P
0 0 0 r
s
1 .3 .122 r
.6967 .56905 m .6881 .55889 L .67791 .576 L p F P
0 0 0 r
s
.24 .35 .67 r
.6818 .56947 m
.68257 .56189 L
s
1 .3 .122 r
.67791 .576 m .68613 .58547 L .6967 .56905 L p F P
0 0 0 r
s
.24 .35 .67 r
.68055 .58175 m
.6808 .57932 L
s
.83 .24 .1 r
.68931 .58054 m
.70255 .5959 L
s
.471 .116 .045 r
.63611 .42456 m .62755 .41382 L .63753 .42874 L p F P
0 0 0 r
s
.471 .116 .045 r
.63753 .42874 m .64667 .44018 L .63611 .42456 L p F P
0 0 0 r
s
.83 .24 .1 r
.62486 .41644 m
.64023 .43229 L
s
.288 .444 .855 r
.49954 .33821 m .51074 .3338 L .50815 .34159 L p F P
0 0 0 r
s
.83 .24 .1 r
.49728 .32686 m
.50502 .33605 L
s
.50859 .34029 m
.50931 .34114 L
s
.288 .444 .855 r
.5167 .33825 m .50815 .34159 L .51074 .3338 L p F P
0 0 0 r
s
.066 .08 .157 r
.66845 .59086 m .65094 .5962 L .63855 .60981 L p F P
0 0 0 r
s
.24 .35 .67 r
.64175 .59364 m
.68055 .58175 L
s
.066 .08 .157 r
.62268 .61461 m .63855 .60981 L .65094 .5962 L p F P
0 0 0 r
s
.813 .22 .084 r
.67228 .48059 m .66312 .46919 L .66668 .48807 L p F P
0 0 0 r
s
.813 .22 .084 r
.66668 .48807 m .67601 .49953 L .67228 .48059 L p F P
0 0 0 r
s
.83 .24 .1 r
.67363 .49661 m
.67425 .49953 L
s
.221 .353 .675 r
.50046 .66005 m .48944 .66335 L .4917 .66119 L p F P
0 0 0 r
s
.221 .353 .675 r
.48309 .66377 m .4917 .66119 L .48944 .66335 L p F P
0 0 0 r
s
.641 .167 .062 r
.65564 .45141 m .64667 .44018 L .65378 .45759 L p F P
0 0 0 r
s
.83 .24 .1 r
.64023 .43229 m
.64681 .44052 L
s
.65561 .45153 m
.65579 .45176 L
s
.641 .167 .062 r
.65378 .45759 m .66312 .46919 L .65564 .45141 L p F P
0 0 0 r
s
.507 .125 .048 r
.38292 .60079 m .39267 .60921 L .38307 .59554 L p F P
0 0 0 r
s
.507 .125 .048 r
.38307 .59554 m .37235 .58624 L .38292 .60079 L p F P
0 0 0 r
s
.752 .23 .102 r
.5301 .3407 m .52529 .33488 L .53337 .3249 L p F P
0 0 0 r
s
.752 .23 .102 r
.53337 .3249 m .53966 .33261 L .5301 .3407 L p F P
0 0 0 r
s
.25 .394 .75 r
.43246 .36175 m .44565 .35655 L .45544 .35556 L p F P
0 0 0 r
s
.24 .35 .67 r
.44932 .35727 m
.46281 .35827 L
s
.25 .394 .75 r
.46636 .35127 m .45544 .35556 L .44565 .35655 L p F P
0 0 0 r
s
.24 .35 .67 r
.46281 .35827 m
.49961 .34385 L
s
.83 .24 .1 r
.67277 .64825 m
.65421 .62837 L
s
.67277 .64825 m
.65087 .67073 L
s
.24 .35 .67 r
.82861 .43234 m
.83583 .46098 L
s
.601 .189 .087 r
.5581 .35525 m .55202 .34779 L .56353 .34707 L p F P
0 0 0 r
s
.601 .189 .087 r
.56353 .34707 m .57087 .35618 L .5581 .35525 L p F P
0 0 0 r
s
.83 .24 .1 r
.54338 .3518 m
.56616 .35701 L
s
.50275 .67484 m
.47788 .67112 L
s
.47348 .66727 m
.47788 .67112 L
s
.65087 .67073 m
.63188 .65126 L
s
.453 .143 .069 r
.58524 .37403 m .5781 .36516 L .59051 .37112 L p F P
0 0 0 r
s
.453 .143 .069 r
.59051 .37112 m .59868 .38134 L .58524 .37403 L p F P
0 0 0 r
s
.027 .038 .072 r
.31428 .41472 m .33027 .40845 L .34749 .39642 L p F P
0 0 0 r
s
.83 .24 .1 r
.31581 .42499 m
.32376 .411 L
s
.027 .038 .072 r
.36207 .39068 m .34749 .39642 L .33027 .40845 L p F P
0 0 0 r
s
.83 .24 .1 r
.32575 .40749 m
.33056 .39903 L
s
.042 .053 .102 r
.62268 .61461 m .60695 .61936 L .59461 .62934 L p F P
0 0 0 r
s
.042 .053 .102 r
.58085 .63348 m .59461 .62934 L .60695 .61936 L p F P
0 0 0 r
s
.438 .139 .066 r
.43422 .64095 m .44105 .64687 L .43006 .64194 L p F P
0 0 0 r
s
.438 .139 .066 r
.43006 .64194 m .42187 .63487 L .43422 .64095 L p F P
0 0 0 r
s
.83 .24 .1 r
.41698 .62821 m
.4295 .63863 L
s
.24 .35 .67 r
.2743 .44937 m
.28265 .4313 L
s
.62754 .30695 m
.64088 .32076 L
s
.68 .30578 m
.64088 .32076 L
s
.024 .035 .067 r
.56721 .63758 m .55367 .64165 L .54523 .64663 L p F P
0 0 0 r
s
.024 .035 .067 r
.53393 .65002 m .54523 .64663 L .55367 .64165 L p F P
0 0 0 r
s
.24 .35 .67 r
.78572 .31822 m
.79788 .34475 L
s
.288 .444 .855 r
.51074 .3338 m .52202 .32936 L .5167 .33825 L p F P
0 0 0 r
s
.288 .444 .855 r
.52529 .33488 m .5167 .33825 L .52202 .32936 L p F P
0 0 0 r
s
.24 .35 .67 r
.5369 .32923 m
.53723 .32911 L
s
.221 .353 .675 r
.51154 .65673 m .50046 .66005 L .50036 .65859 L p F P
0 0 0 r
s
.221 .353 .675 r
.4917 .66119 m .50036 .65859 L .50046 .66005 L p F P
0 0 0 r
s
.024 .035 .067 r
.37678 .38488 m .39162 .37904 L .4064 .37203 L p F P
0 0 0 r
s
.024 .035 .067 r
.41938 .36691 m .4064 .37203 L .39162 .37904 L p F P
0 0 0 r
s
.24 .35 .67 r
.46316 .6691 m
.47058 .66687 L
s
.44789 .66731 m
.46316 .6691 L
s
.325 .073 .03 r
.40516 .62046 m .41358 .62771 L .40228 .6175 L p F P
0 0 0 r
s
.325 .073 .03 r
.40228 .6175 m .39267 .60921 L .40516 .62046 L p F P
0 0 0 r
s
.83 .24 .1 r
.49728 .32686 m
.47531 .30077 L
s
.24 .35 .67 r
.35731 .68155 m
.3216 .69249 L
s
.3216 .69249 m
.30316 .67858 L
s
.6894 .57904 m
.72019 .5696 L
s
.68055 .58175 m
.68241 .58118 L
s
.25 .394 .75 r
.44565 .35655 m .45894 .35131 L .46636 .35127 L p F P
0 0 0 r
s
.25 .394 .75 r
.47735 .34694 m .46636 .35127 L .45894 .35131 L p F P
0 0 0 r
s
.83 .24 .1 r
.42183 .31784 m
.39841 .29157 L
s
.42183 .31784 m
.44869 .30686 L
s
.58 .187 .085 r
.45907 .65283 m .46427 .65738 L .45449 .65851 L p F P
0 0 0 r
s
.58 .187 .085 r
.45449 .65851 m .44781 .65272 L .45907 .65283 L p F P
0 0 0 r
s
.066 .08 .157 r
.68613 .58547 m .66845 .59086 L .65456 .60497 L p F P
0 0 0 r
s
.066 .08 .157 r
.63855 .60981 m .65456 .60497 L .66845 .59086 L p F P
0 0 0 r
s
.24 .35 .67 r
.63628 .60898 m
.64175 .59364 L
s
.83 .24 .1 r
.57884 .68372 m
.55093 .69171 L
s
.55093 .69171 m
.52997 .67258 L
s
.288 .444 .855 r
.52202 .32936 m .53337 .3249 L .52529 .33488 L p F P
0 0 0 r
s
.83 .24 .1 r
.49728 .32686 m
.52244 .32637 L
s
.24 .35 .67 r
.49961 .34385 m
.52961 .33209 L
s
.83 .24 .1 r
.52671 .33156 m
.54338 .3518 L
s
.52244 .32637 m
.5242 .32851 L
s
.309 .092 .048 r
.60673 .3914 m .59868 .38134 L .60997 .39179 L p F P
0 0 0 r
s
.83 .24 .1 r
.58617 .38174 m
.60566 .39248 L
s
.309 .092 .048 r
.60997 .39179 m .61883 .4029 L .60673 .3914 L p F P
0 0 0 r
s
.83 .24 .1 r
.60566 .39248 m
.62486 .41644 L
s
.024 .035 .067 r
.58085 .63348 m .56721 .63758 L .55661 .64322 L p F P
0 0 0 r
s
.024 .035 .067 r
.54523 .64663 m .55661 .64322 L .56721 .63758 L p F P
0 0 0 r
s
.24 .35 .67 r
.55051 .64225 m
.55999 .63207 L
s
.027 .038 .072 r
.33027 .40845 m .34641 .40211 L .36207 .39068 L p F P
0 0 0 r
s
.83 .24 .1 r
.30548 .3744 m
.33056 .39903 L
s
.027 .038 .072 r
.37678 .38488 m .36207 .39068 L .34641 .40211 L p F P
0 0 0 r
s
.24 .35 .67 r
.36875 .38944 m
.37703 .38573 L
s
.042 .053 .102 r
.63855 .60981 m .62268 .61461 L .60846 .62518 L p F P
0 0 0 r
s
.042 .053 .102 r
.59461 .62934 m .60846 .62518 L .62268 .61461 L p F P
0 0 0 r
s
.24 .35 .67 r
.59772 .62065 m
.63628 .60898 L
s
.221 .353 .675 r
.5227 .65338 m .51154 .65673 L .50906 .65597 L p F P
0 0 0 r
s
.24 .35 .67 r
.51301 .65352 m
.55051 .64225 L
s
.221 .353 .675 r
.50036 .65859 m .50906 .65597 L .51154 .65673 L p F P
0 0 0 r
s
.24 .35 .67 r
.23421 .48607 m
.2394 .46286 L
s
.2743 .44937 m
.2394 .46286 L
s
.601 .189 .087 r
.55202 .34779 m .54587 .34025 L .55609 .33784 L p F P
0 0 0 r
s
.601 .189 .087 r
.55609 .33784 m .56353 .34707 L .55202 .34779 L p F P
0 0 0 r
s
.24 .35 .67 r
.30316 .67858 m
.26794 .68959 L
s
.26794 .68959 m
.24975 .67016 L
s
.024 .035 .067 r
.39162 .37904 m .40659 .37314 L .41938 .36691 L p F P
0 0 0 r
s
.024 .035 .067 r
.43246 .36175 m .41938 .36691 L .40659 .37314 L p F P
0 0 0 r
s
.24 .35 .67 r
.41279 .37165 m
.44932 .35727 L
s
.24975 .67016 m
.21511 .68126 L
s
.19835 .65721 m
.21511 .68126 L
s
.57568 .31404 m
.58878 .322 L
s
.62754 .30695 m
.58878 .322 L
s
.051 .063 .121 r
.33027 .40845 m .31428 .41472 L .29975 .4297 L p F P
0 0 0 r
s
.83 .24 .1 r
.30924 .41874 m
.31015 .4196 L
s
.31188 .42125 m
.31581 .42499 L
s
.25 .394 .75 r
.45894 .35131 m .47233 .34603 L .47735 .34694 L p F P
0 0 0 r
s
.25 .394 .75 r
.48841 .34259 m .47735 .34694 L .47233 .34603 L p F P
0 0 0 r
s
.809 .217 .084 r
.3297 .53889 m .34172 .54941 L .33713 .53076 L p F P
0 0 0 r
s
.809 .217 .084 r
.33713 .53076 m .32471 .51975 L .3297 .53889 L p F P
0 0 0 r
s
.83 .24 .1 r
.32589 .50047 m
.35031 .52248 L
s
.24 .35 .67 r
.84104 .48772 m
.79993 .50081 L
s
.79993 .50081 m
.80231 .52455 L
s
.65 .169 .063 r
.35036 .56717 m .36145 .57679 L .35352 .55974 L p F P
0 0 0 r
s
.65 .169 .063 r
.35352 .55974 m .34172 .54941 L .35036 .56717 L p F P
0 0 0 r
s
.83 .24 .1 r
.35126 .54677 m
.35771 .56871 L
s
.471 .116 .045 r
.62755 .41382 m .61883 .4029 L .62822 .4171 L p F P
0 0 0 r
s
.471 .116 .045 r
.62822 .4171 m .63753 .42874 L .62755 .41382 L p F P
0 0 0 r
s
.913 .25 .099 r
.31206 .50854 m .32471 .51975 L .32413 .50047 L p F P
0 0 0 r
s
.913 .25 .099 r
.32413 .50047 m .31143 .48903 L .31206 .50854 L p F P
0 0 0 r
s
.24 .35 .67 r
.83583 .46098 m
.84104 .48772 L
s
.453 .143 .069 r
.5781 .36516 m .57087 .35618 L .58222 .36074 L p F P
0 0 0 r
s
.453 .143 .069 r
.58222 .36074 m .59051 .37112 L .5781 .36516 L p F P
0 0 0 r
s
.83 .24 .1 r
.56616 .35701 m
.58617 .38174 L
s
1 .286 .116 r
.28995 .44675 m .30282 .45856 L .31194 .44112 L p F P
0 0 0 r
s
1 .286 .116 r
.31194 .44112 m .29975 .4297 L .28995 .44675 L p F P
0 0 0 r
s
.24 .35 .67 r
.28265 .4313 m
.3077 .42151 L
s
.979 .272 .109 r
.29848 .47737 m .31143 .48903 L .31545 .47015 L p F P
0 0 0 r
s
.979 .272 .109 r
.31545 .47015 m .30282 .45856 L .29848 .47737 L p F P
0 0 0 r
s
.83 .24 .1 r
.30564 .45151 m
.33062 .47461 L
s
1 .284 .114 r
.68455 .52985 m .67543 .51883 L .67043 .53801 L p F P
0 0 0 r
s
1 .284 .114 r
.67043 .53801 m .67935 .54855 L .68455 .52985 L p F P
0 0 0 r
s
1 .3 .122 r
.6881 .55889 m .67935 .54855 L .66955 .56637 L p F P
0 0 0 r
s
1 .3 .122 r
.66955 .56637 m .67791 .576 L .6881 .55889 L p F P
0 0 0 r
s
.438 .139 .066 r
.42731 .63496 m .43422 .64095 L .42187 .63487 L p F P
0 0 0 r
s
.438 .139 .066 r
.42187 .63487 m .41358 .62771 L .42731 .63496 L p F P
0 0 0 r
s
.83 .24 .1 r
.39375 .60812 m
.41698 .62821 L
s
.24 .35 .67 r
.16402 .53904 m
.16654 .56866 L
s
.19816 .52636 m
.16402 .53904 L
s
.939 .259 .102 r
.67601 .49953 m .66668 .48807 L .66612 .5076 L p F P
0 0 0 r
s
.939 .259 .102 r
.66612 .5076 m .67543 .51883 L .67601 .49953 L p F P
0 0 0 r
s
.507 .125 .048 r
.37301 .59224 m .38292 .60079 L .37235 .58624 L p F P
0 0 0 r
s
.83 .24 .1 r
.38172 .58962 m
.39375 .60812 L
s
.507 .125 .048 r
.37235 .58624 m .36145 .57679 L .37301 .59224 L p F P
0 0 0 r
s
.83 .24 .1 r
.35771 .56871 m
.38172 .58962 L
s
.641 .167 .062 r
.64667 .44018 m .63753 .42874 L .64427 .44576 L p F P
0 0 0 r
s
.641 .167 .062 r
.64427 .44576 m .65378 .45759 L .64667 .44018 L p F P
0 0 0 r
s
.24 .35 .67 r
.19966 .49919 m
.23421 .48607 L
s
.19816 .52636 m
.19966 .49919 L
s
.813 .22 .084 r
.66312 .46919 m .65378 .45759 L .65717 .47639 L p F P
0 0 0 r
s
.813 .22 .084 r
.65717 .47639 m .66668 .48807 L .66312 .46919 L p F P
0 0 0 r
s
.221 .353 .675 r
.53393 .65002 m .5227 .65338 L .5178 .65335 L p F P
0 0 0 r
s
.221 .353 .675 r
.50906 .65597 m .5178 .65335 L .5227 .65338 L p F P
0 0 0 r
s
.24 .35 .67 r
.50039 .65792 m
.51301 .65352 L
s
.066 .08 .157 r
.65456 .60497 m .67072 .60009 L .68613 .58547 L p F P
0 0 0 r
s
.83 .24 .1 r
.67212 .60257 m
.69028 .62287 L
s
1 .31 .127 r
.68613 .58547 m .67791 .576 L .66306 .59152 L p F P
0 0 0 r
s
1 .31 .127 r
.66306 .59152 m .67072 .60009 L .68613 .58547 L p F P
0 0 0 r
s
.24 .35 .67 r
.67639 .59484 m
.6773 .59198 L
s
.67569 .59705 m
.67639 .59484 L
s
.44789 .66731 m
.41099 .67847 L
s
.41099 .67847 m
.39381 .67037 L
s
.77325 .29459 m
.78572 .31822 L
s
.024 .035 .067 r
.59461 .62934 m .58085 .63348 L .56806 .63978 L p F P
0 0 0 r
s
.024 .035 .067 r
.55661 .64322 m .56806 .63978 L .58085 .63348 L p F P
0 0 0 r
s
.83 .24 .1 r
.67212 .60257 m
.67525 .59579 L
s
.24 .35 .67 r
.72 .29047 m
.73279 .30982 L
s
.77325 .29459 m
.73279 .30982 L
s
.58 .187 .085 r
.45383 .64825 m .45907 .65283 L .44781 .65272 L p F P
0 0 0 r
s
.58 .187 .085 r
.44781 .65272 m .44105 .64687 L .45383 .64825 L p F P
0 0 0 r
s
.83 .24 .1 r
.43777 .64403 m
.44553 .64735 L
s
.24 .35 .67 r
.80231 .52455 m
.76152 .53727 L
s
.76152 .53727 m
.76071 .55718 L
s
.25 .394 .75 r
.47233 .34603 m .48583 .34071 L .48841 .34259 L p F P
0 0 0 r
s
.25 .394 .75 r
.49954 .33821 m .48841 .34259 L .48583 .34071 L p F P
0 0 0 r
s
.24 .35 .67 r
.48666 .34257 m
.49961 .34385 L
s
.027 .038 .072 r
.34641 .40211 m .36272 .39571 L .37678 .38488 L p F P
0 0 0 r
s
.027 .038 .072 r
.39162 .37904 m .37678 .38488 L .36272 .39571 L p F P
0 0 0 r
s
.042 .053 .102 r
.65456 .60497 m .63855 .60981 L .62243 .62098 L p F P
0 0 0 r
s
.042 .053 .102 r
.60846 .62518 m .62243 .62098 L .63855 .60981 L p F P
0 0 0 r
s
.024 .035 .067 r
.40659 .37314 m .4217 .36718 L .43246 .36175 L p F P
0 0 0 r
s
.024 .035 .067 r
.44565 .35655 m .43246 .36175 L .4217 .36718 L p F P
0 0 0 r
s
.325 .073 .03 r
.39664 .6131 m .40516 .62046 L .39267 .60921 L p F P
0 0 0 r
s
.325 .073 .03 r
.39267 .60921 m .38292 .60079 L .39664 .6131 L p F P
0 0 0 r
s
.762 .236 .104 r
.47881 .65535 m .48233 .65847 L .47452 .66634 L p F P
0 0 0 r
s
.24 .35 .67 r
.47396 .66586 m
.47481 .6656 L
s
.762 .236 .104 r
.47452 .66634 m .46942 .66188 L .47881 .65535 L p F P
0 0 0 r
s
.27 .42 .813 r
.48309 .66377 m .47452 .66634 L .48233 .65847 L p F P
0 0 0 r
s
.24 .35 .67 r
.483 .66314 m
.50039 .65792 L
s
.83 .24 .1 r
.44869 .30686 m
.42559 .28017 L
s
.44869 .30686 m
.47531 .30077 L
s
.051 .063 .121 r
.29975 .4297 m .31692 .42301 L .33027 .40845 L p F P
0 0 0 r
s
.83 .24 .1 r
.30564 .45151 m
.31581 .42499 L
s
.051 .063 .121 r
.34641 .40211 m .33027 .40845 L .31692 .42301 L p F P
0 0 0 r
s
.601 .189 .087 r
.54587 .34025 m .53966 .33261 L .54855 .32848 L p F P
0 0 0 r
s
.24 .35 .67 r
.53723 .32911 m
.54176 .33164 L
s
.54715 .33465 m
.55085 .33672 L
s
.601 .189 .087 r
.54855 .32848 m .55609 .33784 L .54587 .34025 L p F P
0 0 0 r
s
.83 .24 .1 r
.6063 .67003 m
.57884 .68372 L
s
.57884 .68372 m
.55825 .66428 L
s
.221 .353 .675 r
.54523 .64663 m .53393 .65002 L .52659 .65071 L p F P
0 0 0 r
s
.221 .353 .675 r
.5178 .65335 m .52659 .65071 L .53393 .65002 L p F P
0 0 0 r
s
.24 .35 .67 r
.66715 .29157 m
.68 .30578 L
s
.72 .29047 m
.68 .30578 L
s
.83 .24 .1 r
.52997 .67258 m
.50275 .67484 L
s
.309 .092 .048 r
.59868 .38134 m .59051 .37112 L .60096 .38049 L p F P
0 0 0 r
s
.309 .092 .048 r
.60096 .38049 m .60997 .39179 L .59868 .38134 L p F P
0 0 0 r
s
.24 .35 .67 r
.53675 .32905 m
.53723 .32911 L
s
.024 .035 .067 r
.60846 .62518 m .59461 .62934 L .57959 .63633 L p F P
0 0 0 r
s
.024 .035 .067 r
.56806 .63978 m .57959 .63633 L .59461 .62934 L p F P
0 0 0 r
s
.24 .35 .67 r
.58883 .63073 m
.59772 .62065 L
s
.55051 .64225 m
.58883 .63073 L
s
.25 .394 .75 r
.48583 .34071 m .49943 .33534 L .49954 .33821 L p F P
0 0 0 r
s
.25 .394 .75 r
.51074 .3338 m .49954 .33821 L .49943 .33534 L p F P
0 0 0 r
s
.27 .42 .813 r
.4917 .66119 m .48309 .66377 L .48828 .65667 L p F P
0 0 0 r
s
.27 .42 .813 r
.48233 .65847 m .48828 .65667 L .48309 .66377 L p F P
0 0 0 r
s
.83 .24 .1 r
.48768 .66145 m
.50275 .67484 L
s
.48457 .65868 m
.48768 .66145 L
s
.24 .35 .67 r
.23309 .64576 m
.19835 .65721 L
s
.18417 .62942 m
.19835 .65721 L
s
.024 .035 .067 r
.4217 .36718 m .43695 .36118 L .44565 .35655 L p F P
0 0 0 r
s
.024 .035 .067 r
.45894 .35131 m .44565 .35655 L .43695 .36118 L p F P
0 0 0 r
s
.24 .35 .67 r
.39381 .67037 m
.35731 .68155 L
s
.35731 .68155 m
.33917 .66734 L
s
.76071 .55718 m
.72019 .5696 L
s
.72019 .5696 m
.71598 .58485 L
s
.453 .143 .069 r
.57087 .35618 m .56353 .34707 L .57378 .3502 L p F P
0 0 0 r
s
.453 .143 .069 r
.57378 .3502 m .58222 .36074 L .57087 .35618 L p F P
0 0 0 r
s
.027 .038 .072 r
.36272 .39571 m .37919 .38925 L .39162 .37904 L p F P
0 0 0 r
s
.027 .038 .072 r
.40659 .37314 m .39162 .37904 L .37919 .38925 L p F P
0 0 0 r
s
.24 .35 .67 r
.39809 .37814 m
.40052 .37718 L
s
.40052 .37718 m
.41279 .37165 L
s
.042 .053 .102 r
.67072 .60009 m .65456 .60497 L .63651 .61675 L p F P
0 0 0 r
s
.042 .053 .102 r
.62243 .62098 m .63651 .61675 L .65456 .60497 L p F P
0 0 0 r
s
.438 .139 .066 r
.42032 .62891 m .42731 .63496 L .41358 .62771 L p F P
0 0 0 r
s
.438 .139 .066 r
.41358 .62771 m .40516 .62046 L .42032 .62891 L p F P
0 0 0 r
s
.83 .24 .1 r
.32464 .34952 m
.34705 .32691 L
s
.34705 .32691 m
.32191 .30052 L
s
.34705 .32691 m
.37192 .30736 L
s
.52244 .32637 m
.52707 .32737 L
s
.58 .187 .085 r
.44854 .64362 m .45383 .64825 L .44105 .64687 L p F P
0 0 0 r
s
.58 .187 .085 r
.44105 .64687 m .43422 .64095 L .44854 .64362 L p F P
0 0 0 r
s
.24 .35 .67 r
.16654 .56866 m
.17336 .59935 L
s
.20095 .55622 m
.16654 .56866 L
s
.83 .24 .1 r
.30548 .3744 m
.32464 .34952 L
s
.32464 .34952 m
.29906 .32355 L
s
.221 .353 .675 r
.55661 .64322 m .54523 .64663 L .53543 .64806 L p F P
0 0 0 r
s
.221 .353 .675 r
.52659 .65071 m .53543 .64806 L .54523 .64663 L p F P
0 0 0 r
s
.83 .24 .1 r
.67015 .60037 m
.67212 .60257 L
s
.762 .236 .104 r
.47528 .65221 m .47881 .65535 L .46942 .66188 L p F P
0 0 0 r
s
.762 .236 .104 r
.46942 .66188 m .46427 .65738 L .47528 .65221 L p F P
0 0 0 r
s
.471 .116 .045 r
.61883 .4029 m .60997 .39179 L .61874 .40523 L p F P
0 0 0 r
s
.471 .116 .045 r
.61874 .40523 m .62822 .4171 L .61883 .4029 L p F P
0 0 0 r
s
.83 .24 .1 r
.60566 .39248 m
.62105 .40828 L
s
.65 .169 .063 r
.33908 .55738 m .35036 .56717 L .34172 .54941 L p F P
0 0 0 r
s
.65 .169 .063 r
.34172 .54941 m .3297 .53889 L .33908 .55738 L p F P
0 0 0 r
s
.25 .394 .75 r
.49943 .33534 m .51315 .32993 L .51074 .3338 L p F P
0 0 0 r
s
.25 .394 .75 r
.52202 .32936 m .51074 .3338 L .51315 .32993 L p F P
0 0 0 r
s
.809 .217 .084 r
.31745 .52817 m .3297 .53889 L .32471 .51975 L p F P
0 0 0 r
s
.83 .24 .1 r
.32655 .52494 m
.35126 .54677 L
s
.32589 .50047 m
.32655 .52494 L
s
.809 .217 .084 r
.32471 .51975 m .31206 .50854 L .31745 .52817 L p F P
0 0 0 r
s
.051 .063 .121 r
.31692 .42301 m .33427 .41625 L .34641 .40211 L p F P
0 0 0 r
s
.051 .063 .121 r
.36272 .39571 m .34641 .40211 L .33427 .41625 L p F P
0 0 0 r
s
.27 .42 .813 r
.50036 .65859 m .4917 .66119 L .49425 .65487 L p F P
0 0 0 r
s
.24 .35 .67 r
.49893 .65772 m
.50039 .65792 L
s
.27 .42 .813 r
.48828 .65667 m .49425 .65487 L .4917 .66119 L p F P
0 0 0 r
s
.507 .125 .048 r
.36294 .58355 m .37301 .59224 L .36145 .57679 L p F P
0 0 0 r
s
.507 .125 .048 r
.36145 .57679 m .35036 .56717 L .36294 .58355 L p F P
0 0 0 r
s
.09 .111 .237 r
.31692 .42301 m .29975 .4297 L .28995 .44675 L p F P
0 0 0 r
s
.24 .35 .67 r
.26953 .47265 m
.2743 .44937 L
s
.913 .25 .099 r
.29916 .4971 m .31206 .50854 L .31143 .48903 L p F P
0 0 0 r
s
.913 .25 .099 r
.31143 .48903 m .29848 .47737 L .29916 .4971 L p F P
0 0 0 r
s
1 .3 .122 r
.67935 .54855 m .67043 .53801 L .66104 .55656 L p F P
0 0 0 r
s
1 .3 .122 r
.66104 .55656 m .66955 .56637 L .67935 .54855 L p F P
0 0 0 r
s
.024 .035 .067 r
.62243 .62098 m .60846 .62518 L .59119 .63285 L p F P
0 0 0 r
s
.024 .035 .067 r
.57959 .63633 m .59119 .63285 L .60846 .62518 L p F P
0 0 0 r
s
.83 .24 .1 r
.37192 .30736 m
.34721 .28052 L
s
.37192 .30736 m
.39841 .29157 L
s
.24 .35 .67 r
.33917 .66734 m
.30316 .67858 L
s
.30316 .67858 m
.28517 .65882 L
s
.979 .272 .109 r
.28528 .46548 m .29848 .47737 L .30282 .45856 L p F P
0 0 0 r
s
.979 .272 .109 r
.30282 .45856 m .28995 .44675 L .28528 .46548 L p F P
0 0 0 r
s
.83 .24 .1 r
.30053 .4776 m
.30564 .45151 L
s
1 .284 .114 r
.67543 .51883 m .66612 .5076 L .66135 .52728 L p F P
0 0 0 r
s
1 .284 .114 r
.66135 .52728 m .67043 .53801 L .67543 .51883 L p F P
0 0 0 r
s
.24 .35 .67 r
.28517 .65882 m
.24975 .67016 L
s
.24975 .67016 m
.23309 .64576 L
s
.601 .189 .087 r
.53966 .33261 m .53337 .3249 L .54091 .31899 L p F P
0 0 0 r
s
.601 .189 .087 r
.54091 .31899 m .54855 .32848 L .53966 .33261 L p F P
0 0 0 r
s
.24 .35 .67 r
.54622 .32558 m
.57568 .31404 L
s
.83 .24 .1 r
.63188 .65126 m
.6063 .67003 L
s
.6063 .67003 m
.58613 .65022 L
s
.24 .35 .67 r
.61498 .29864 m
.62754 .30695 L
s
.66715 .29157 m
.62754 .30695 L
s
1 .31 .127 r
.67791 .576 m .66955 .56637 L .65529 .58282 L p F P
0 0 0 r
s
1 .31 .127 r
.65529 .58282 m .66306 .59152 L .67791 .576 L p F P
0 0 0 r
s
.641 .167 .062 r
.63753 .42874 m .62822 .4171 L .63456 .4337 L p F P
0 0 0 r
s
.83 .24 .1 r
.62105 .40828 m
.62835 .41742 L
s
.63747 .42884 m
.63766 .42908 L
s
.641 .167 .062 r
.63456 .4337 m .64427 .44576 L .63753 .42874 L p F P
0 0 0 r
s
.939 .259 .102 r
.66668 .48807 m .65717 .47639 L .65664 .49614 L p F P
0 0 0 r
s
.83 .24 .1 r
.65557 .47663 m
.65711 .47853 L
s
.6656 .48894 m
.66662 .49018 L
s
.939 .259 .102 r
.65664 .49614 m .66612 .5076 L .66668 .48807 L p F P
0 0 0 r
s
.813 .22 .084 r
.65378 .45759 m .64427 .44576 L .64748 .46448 L p F P
0 0 0 r
s
.813 .22 .084 r
.64748 .46448 m .65717 .47639 L .65378 .45759 L p F P
0 0 0 r
s
.83 .24 .1 r
.65497 .47369 m
.65557 .47663 L
s
.024 .035 .067 r
.43695 .36118 m .45233 .35511 L .45894 .35131 L p F P
0 0 0 r
s
.24 .35 .67 r
.43759 .36259 m
.44932 .35727 L
s
.024 .035 .067 r
.47233 .34603 m .45894 .35131 L .45233 .35511 L p F P
0 0 0 r
s
.24 .35 .67 r
.44932 .35727 m
.48666 .34257 L
s
.84104 .48772 m
.844 .51155 L
s
.21889 .61761 m
.18417 .62942 L
s
.17336 .59935 m
.18417 .62942 L
s
.325 .073 .03 r
.38799 .60564 m .39664 .6131 L .38292 .60079 L p F P
0 0 0 r
s
.325 .073 .03 r
.38292 .60079 m .37301 .59224 L .38799 .60564 L p F P
0 0 0 r
s
.221 .353 .675 r
.56806 .63978 m .55661 .64322 L .5443 .64539 L p F P
0 0 0 r
s
.221 .353 .675 r
.53543 .64806 m .5443 .64539 L .55661 .64322 L p F P
0 0 0 r
s
.24 .35 .67 r
.20798 .5872 m
.17336 .59935 L
s
.83 .24 .1 r
.29029 .40071 m
.30548 .3744 L
s
.30548 .3744 m
.27944 .34882 L
s
.027 .038 .072 r
.37919 .38925 m .39583 .38272 L .40659 .37314 L p F P
0 0 0 r
s
.027 .038 .072 r
.4217 .36718 m .40659 .37314 L .39583 .38272 L p F P
0 0 0 r
s
.24 .35 .67 r
.20095 .55622 m
.19816 .52636 L
s
.23306 .5134 m
.19816 .52636 L
s
.042 .053 .102 r
.63651 .61675 m .6507 .61249 L .67072 .60009 L p F P
0 0 0 r
s
1 .316 .13 r
.67072 .60009 m .66306 .59152 L .64381 .60502 L p F P
0 0 0 r
s
.24 .35 .67 r
.63628 .60898 m
.65787 .60244 L
s
.67084 .59852 m
.67569 .59705 L
s
.67064 .59858 m
.67084 .59852 L
s
1 .316 .13 r
.64381 .60502 m .6507 .61249 L .67072 .60009 L p F P
0 0 0 r
s
.83 .24 .1 r
.65421 .62837 m
.67212 .60257 L
s
.27 .42 .813 r
.50906 .65597 m .50036 .65859 L .50025 .65306 L p F P
0 0 0 r
s
.27 .42 .813 r
.49425 .65487 m .50025 .65306 L .50036 .65859 L p F P
0 0 0 r
s
.83 .24 .1 r
.65421 .62837 m
.63188 .65126 L
s
.67005 .53876 m
.67029 .53784 L
s
.24 .35 .67 r
.23421 .48607 m
.26953 .47265 L
s
.23306 .5134 m
.23421 .48607 L
s
.25 .394 .75 r
.51315 .32993 m .52697 .32448 L .52202 .32936 L p F P
0 0 0 r
s
.25 .394 .75 r
.53337 .3249 m .52202 .32936 L .52697 .32448 L p F P
0 0 0 r
s
.24 .35 .67 r
.52483 .32754 m
.53372 .32866 L
s
.83 .24 .1 r
.52894 .32778 m
.54537 .33133 L
s
.24 .35 .67 r
.44789 .66731 m
.4737 .65951 L
s
.4737 .65951 m
.479 .65791 L
s
.44789 .66731 m
.43112 .65894 L
s
.762 .236 .104 r
.47172 .64906 m .47528 .65221 L .46427 .65738 L p F P
0 0 0 r
s
.762 .236 .104 r
.46427 .65738 m .45907 .65283 L .47172 .64906 L p F P
0 0 0 r
s
.83 .24 .1 r
.45816 .65203 m
.4606 .65238 L
s
.24 .35 .67 r
.76089 .27481 m
.77325 .29459 L
s
.309 .092 .048 r
.59051 .37112 m .58222 .36074 L .59179 .36898 L p F P
0 0 0 r
s
.83 .24 .1 r
.56616 .35701 m
.58573 .3676 L
s
.309 .092 .048 r
.59179 .36898 m .60096 .38049 L .59051 .37112 L p F P
0 0 0 r
s
.83 .24 .1 r
.58573 .3676 m
.60566 .39248 L
s
.24 .35 .67 r
.844 .51155 m
.80231 .52455 L
s
.80231 .52455 m
.80214 .54448 L
s
.67569 .59705 m
.71598 .58485 L
s
.66806 .60691 m
.67569 .59705 L
s
.58 .187 .085 r
.44321 .63896 m .44854 .64362 L .43422 .64095 L p F P
0 0 0 r
s
.58 .187 .085 r
.43422 .64095 m .42731 .63496 L .44321 .63896 L p F P
0 0 0 r
s
.024 .035 .067 r
.63651 .61675 m .62243 .62098 L .60287 .62935 L p F P
0 0 0 r
s
.024 .035 .067 r
.59119 .63285 m .60287 .62935 L .62243 .62098 L p F P
0 0 0 r
s
.453 .143 .069 r
.56353 .34707 m .55609 .33784 L .56522 .33949 L p F P
0 0 0 r
s
.453 .143 .069 r
.56522 .33949 m .57378 .3502 L .56353 .34707 L p F P
0 0 0 r
s
.051 .063 .121 r
.33427 .41625 m .35181 .40942 L .36272 .39571 L p F P
0 0 0 r
s
.051 .063 .121 r
.37919 .38925 m .36272 .39571 L .35181 .40942 L p F P
0 0 0 r
s
.438 .139 .066 r
.41325 .62278 m .42032 .62891 L .40516 .62046 L p F P
0 0 0 r
s
.438 .139 .066 r
.40516 .62046 m .39664 .6131 L .41325 .62278 L p F P
0 0 0 r
s
.83 .24 .1 r
.39375 .60812 m
.40699 .61914 L
s
.27 .42 .813 r
.5178 .65335 m .50906 .65597 L .50627 .65124 L p F P
0 0 0 r
s
.24 .35 .67 r
.50801 .65563 m
.50873 .65541 L
s
.27 .42 .813 r
.50025 .65306 m .50627 .65124 L .50906 .65597 L p F P
0 0 0 r
s
.83 .24 .1 r
.47531 .30077 m
.45249 .27368 L
s
.47531 .30077 m
.50069 .29996 L
s
.221 .353 .675 r
.57959 .63633 m .56806 .63978 L .55323 .64271 L p F P
0 0 0 r
s
.221 .353 .675 r
.5443 .64539 m .55323 .64271 L .56806 .63978 L p F P
0 0 0 r
s
.24 .35 .67 r
.53844 .64648 m
.55051 .64225 L
s
.024 .035 .067 r
.45233 .35511 m .46786 .349 L .47233 .34603 L p F P
0 0 0 r
s
.024 .035 .067 r
.48583 .34071 m .47233 .34603 L .46786 .349 L p F P
0 0 0 r
s
.09 .111 .237 r
.28995 .44675 m .30791 .43982 L .31692 .42301 L p F P
0 0 0 r
s
.83 .24 .1 r
.29739 .44388 m
.30564 .45151 L
s
.24 .35 .67 r
.2743 .44937 m
.29248 .44234 L
s
.83 .24 .1 r
.27969 .42751 m
.29244 .4393 L
s
.29244 .4393 m
.29409 .44083 L
s
.09 .111 .237 r
.33427 .41625 m .31692 .42301 L .30791 .43982 L p F P
0 0 0 r
s
.83 .24 .1 r
.29029 .40071 m
.30869 .41822 L
s
.30869 .41822 m
.30924 .41874 L
s
.39841 .29157 m
.37408 .26427 L
s
.39841 .29157 m
.42559 .28017 L
s
.25 .394 .75 r
.52697 .32448 m .54091 .31899 L .53337 .3249 L p F P
0 0 0 r
s
.83 .24 .1 r
.55825 .66428 m
.52997 .67258 L
s
.50964 .65403 m
.52997 .67258 L
s
.24 .35 .67 r
.70766 .27585 m
.72 .29047 L
s
.76089 .27481 m
.72 .29047 L
s
.027 .038 .072 r
.39583 .38272 m .41264 .37612 L .4217 .36718 L p F P
0 0 0 r
s
.027 .038 .072 r
.43695 .36118 m .4217 .36718 L .41264 .37612 L p F P
0 0 0 r
s
.24 .35 .67 r
.4294 .36581 m
.43759 .36259 L
s
.56386 .31217 m
.57568 .31404 L
s
.61498 .29864 m
.57568 .31404 L
s
.27 .42 .813 r
.52659 .65071 m .5178 .65335 L .5123 .64942 L p F P
0 0 0 r
s
.24 .35 .67 r
.51643 .6531 m
.51715 .65288 L
s
.52489 .65056 m
.53844 .64648 L
s
.27 .42 .813 r
.50627 .65124 m .5123 .64942 L .5178 .65335 L p F P
0 0 0 r
s
.83 .24 .1 r
.50819 .65271 m
.50964 .65403 L
s
.471 .116 .045 r
.60997 .39179 m .60096 .38049 L .60909 .39314 L p F P
0 0 0 r
s
.471 .116 .045 r
.60909 .39314 m .61874 .40523 L .60997 .39179 L p F P
0 0 0 r
s
.762 .236 .104 r
.46815 .64589 m .47172 .64906 L .45907 .65283 L p F P
0 0 0 r
s
.762 .236 .104 r
.45907 .65283 m .45383 .64825 L .46815 .64589 L p F P
0 0 0 r
s
.024 .035 .067 r
.6507 .61249 m .63651 .61675 L .61463 .62582 L p F P
0 0 0 r
s
.024 .035 .067 r
.60287 .62935 m .61463 .62582 L .63651 .61675 L p F P
0 0 0 r
s
.24 .35 .67 r
.62801 .61895 m
.63628 .60898 L
s
.58883 .63073 m
.62801 .61895 L
s
.2686 .63406 m
.23309 .64576 L
s
.23309 .64576 m
.21889 .61761 L
s
.221 .353 .675 r
.59119 .63285 m .57959 .63633 L .5622 .64002 L p F P
0 0 0 r
s
.221 .353 .675 r
.55323 .64271 m .5622 .64002 L .57959 .63633 L p F P
0 0 0 r
s
.24 .35 .67 r
.43112 .65894 m
.39381 .67037 L
s
.39381 .67037 m
.37598 .65584 L
s
.83 .24 .1 r
.27969 .42751 m
.29029 .40071 L
s
.29029 .40071 m
.26377 .37547 L
s
.507 .125 .048 r
.35271 .57472 m .36294 .58355 L .35036 .56717 L p F P
0 0 0 r
s
.507 .125 .048 r
.35036 .56717 m .33908 .55738 L .35271 .57472 L p F P
0 0 0 r
s
.24 .35 .67 r
.80214 .54448 m
.76071 .55718 L
s
.76071 .55718 m
.75718 .57238 L
s
.65 .169 .063 r
.3276 .54742 m .33908 .55738 L .3297 .53889 L p F P
0 0 0 r
s
.65 .169 .063 r
.3297 .53889 m .31745 .52817 L .3276 .54742 L p F P
0 0 0 r
s
.83 .24 .1 r
.32655 .52494 m
.33277 .54698 L
s
.024 .035 .067 r
.46786 .349 m .48353 .34282 L .48583 .34071 L p F P
0 0 0 r
s
.024 .035 .067 r
.49943 .33534 m .48583 .34071 L .48353 .34282 L p F P
0 0 0 r
s
.809 .217 .084 r
.30498 .51726 m .31745 .52817 L .31206 .50854 L p F P
0 0 0 r
s
.809 .217 .084 r
.31206 .50854 m .29916 .4971 L .30498 .51726 L p F P
0 0 0 r
s
.83 .24 .1 r
.30053 .4776 m
.32589 .50047 L
s
1 .31 .127 r
.66955 .56637 m .66104 .55656 L .64738 .57399 L p F P
0 0 0 r
s
1 .31 .127 r
.64738 .57399 m .65529 .58282 L .66955 .56637 L p F P
0 0 0 r
s
.325 .073 .03 r
.37923 .59808 m .38799 .60564 L .37301 .59224 L p F P
0 0 0 r
s
.325 .073 .03 r
.37301 .59224 m .36294 .58355 L .37923 .59808 L p F P
0 0 0 r
s
.83 .24 .1 r
.35771 .56871 m
.36962 .58725 L
s
1 .3 .122 r
.67043 .53801 m .66135 .52728 L .65238 .54659 L p F P
0 0 0 r
s
1 .3 .122 r
.65238 .54659 m .66104 .55656 L .67043 .53801 L p F P
0 0 0 r
s
.24 .35 .67 r
.20798 .5872 m
.20095 .55622 L
s
.23614 .5435 m
.20095 .55622 L
s
.58 .187 .085 r
.43783 .63425 m .44321 .63896 L .42731 .63496 L p F P
0 0 0 r
s
.58 .187 .085 r
.42731 .63496 m .42032 .62891 L .43783 .63425 L p F P
0 0 0 r
s
.051 .063 .121 r
.35181 .40942 m .36954 .40251 L .37919 .38925 L p F P
0 0 0 r
s
.051 .063 .121 r
.39583 .38272 m .37919 .38925 L .36954 .40251 L p F P
0 0 0 r
s
.913 .25 .099 r
.28601 .48545 m .29916 .4971 L .29848 .47737 L p F P
0 0 0 r
s
.913 .25 .099 r
.29848 .47737 m .28528 .46548 L .28601 .48545 L p F P
0 0 0 r
s
.27 .42 .813 r
.53543 .64806 m .52659 .65071 L .51836 .64759 L p F P
0 0 0 r
s
.27 .42 .813 r
.5123 .64942 m .51836 .64759 L .52659 .65071 L p F P
0 0 0 r
s
.641 .167 .062 r
.62822 .4171 m .61874 .40523 L .62467 .4214 L p F P
0 0 0 r
s
.641 .167 .062 r
.62467 .4214 m .63456 .4337 L .62822 .4171 L p F P
0 0 0 r
s
.127 .167 .35 r
.30791 .43982 m .28995 .44675 L .28528 .46548 L p F P
0 0 0 r
s
1 .284 .114 r
.66612 .5076 m .65664 .49614 L .6521 .51634 L p F P
0 0 0 r
s
1 .284 .114 r
.6521 .51634 m .66135 .52728 L .66612 .5076 L p F P
0 0 0 r
s
1 .316 .13 r
.66306 .59152 m .65529 .58282 L .63682 .59745 L p F P
0 0 0 r
s
.83 .24 .1 r
.66238 .59168 m
.66256 .59188 L
s
1 .316 .13 r
.63682 .59745 m .64381 .60502 L .66306 .59152 L p F P
0 0 0 r
s
.09 .111 .237 r
.30791 .43982 m .32607 .43282 L .33427 .41625 L p F P
0 0 0 r
s
.09 .111 .237 r
.35181 .40942 m .33427 .41625 L .32607 .43282 L p F P
0 0 0 r
s
.939 .259 .102 r
.65717 .47639 m .64748 .46448 L .64697 .48447 L p F P
0 0 0 r
s
.939 .259 .102 r
.64697 .48447 m .65664 .49614 L .65717 .47639 L p F P
0 0 0 r
s
.813 .22 .084 r
.64427 .44576 m .63456 .4337 L .63759 .45234 L p F P
0 0 0 r
s
.813 .22 .084 r
.63759 .45234 m .64748 .46448 L .64427 .44576 L p F P
0 0 0 r
s
.027 .038 .072 r
.41264 .37612 m .42961 .36946 L .43695 .36118 L p F P
0 0 0 r
s
.027 .038 .072 r
.45233 .35511 m .43695 .36118 L .42961 .36946 L p F P
0 0 0 r
s
.453 .143 .069 r
.55609 .33784 m .54855 .32848 L .55652 .32861 L p F P
0 0 0 r
s
.453 .143 .069 r
.55652 .32861 m .56522 .33949 L .55609 .33784 L p F P
0 0 0 r
s
.83 .24 .1 r
.54537 .33133 m
.56616 .35701 L
s
.24 .35 .67 r
.37598 .65584 m
.33917 .66734 L
s
.33917 .66734 m
.32138 .64722 L
s
.309 .092 .048 r
.58222 .36074 m .57378 .3502 L .58245 .35728 L p F P
0 0 0 r
s
.309 .092 .048 r
.58245 .35728 m .59179 .36898 L .58222 .36074 L p F P
0 0 0 r
s
.24 .35 .67 r
.32138 .64722 m
.28517 .65882 L
s
.28517 .65882 m
.2686 .63406 L
s
.438 .139 .066 r
.4061 .61659 m .41325 .62278 L .39664 .6131 L p F P
0 0 0 r
s
.438 .139 .066 r
.39664 .6131 m .38799 .60564 L .4061 .61659 L p F P
0 0 0 r
s
.83 .24 .1 r
.36962 .58725 m
.39375 .60812 L
s
.221 .353 .675 r
.60287 .62935 m .59119 .63285 L .57121 .63731 L p F P
0 0 0 r
s
.221 .353 .675 r
.5622 .64002 m .57121 .63731 L .59119 .63285 L p F P
0 0 0 r
s
.24 .35 .67 r
.65518 .28288 m
.66715 .29157 L
s
.70766 .27585 m
.66715 .29157 L
s
.83 .24 .1 r
.54537 .33133 m
.56502 .34175 L
s
.024 .035 .067 r
.61463 .62582 m .62647 .62227 L .6507 .61249 L p F P
0 0 0 r
s
1 .318 .132 r
.6507 .61249 m .64381 .60502 L .62055 .61607 L p F P
0 0 0 r
s
1 .318 .132 r
.62055 .61607 m .62647 .62227 L .6507 .61249 L p F P
0 0 0 r
s
.24 .35 .67 r
.64318 .61439 m
.64446 .61401 L
s
.64446 .61401 m
.66806 .60691 L
s
.83 .24 .1 r
.64248 .61581 m
.64299 .61635 L
s
.64299 .61635 m
.65421 .62837 L
s
.762 .236 .104 r
.46455 .64269 m .46815 .64589 L .45383 .64825 L p F P
0 0 0 r
s
.762 .236 .104 r
.45383 .64825 m .44854 .64362 L .46455 .64269 L p F P
0 0 0 r
s
.27 .42 .813 r
.5443 .64539 m .53543 .64806 L .52444 .64575 L p F P
0 0 0 r
s
.27 .42 .813 r
.51836 .64759 m .52444 .64575 L .53543 .64806 L p F P
0 0 0 r
s
.24 .35 .67 r
.2544 .60554 m
.21889 .61761 L
s
.21889 .61761 m
.20798 .5872 L
s
.24337 .57479 m
.20798 .5872 L
s
.024 .035 .067 r
.48353 .34282 m .49934 .33659 L .49943 .33534 L p F P
0 0 0 r
s
.024 .035 .067 r
.51315 .32993 m .49943 .33534 L .49934 .33659 L p F P
0 0 0 r
s
.24 .35 .67 r
.48666 .34257 m
.52483 .32754 L
s
.23614 .5435 m
.23306 .5134 L
s
.26875 .50014 m
.23306 .5134 L
s
.886 .269 .117 r
.48909 .6446 m .49088 .64622 L .48233 .65847 L p F P
0 0 0 r
s
.24 .35 .67 r
.48101 .6573 m
.48322 .65663 L
s
.83 .24 .1 r
.48309 .65737 m
.48382 .65802 L
s
.886 .269 .117 r
.48233 .65847 m .47881 .65535 L .48909 .6446 L p F P
0 0 0 r
s
.83 .24 .1 r
.47828 .65488 m
.47915 .655 L
s
.289 .443 .863 r
.48828 .65667 m .48233 .65847 L .49088 .64622 L p F P
0 0 0 r
s
.24 .35 .67 r
.48838 .65628 m
.48919 .65639 L
s
.26953 .47265 m
.28532 .46666 L
s
.26875 .50014 m
.26953 .47265 L
s
.83 .24 .1 r
.42559 .28017 m
.40159 .25242 L
s
.42559 .28017 m
.45249 .27368 L
s
.58613 .65022 m
.55825 .66428 L
s
.051 .063 .121 r
.36954 .40251 m .38746 .39553 L .39583 .38272 L p F P
0 0 0 r
s
.24 .35 .67 r
.39552 .3832 m
.39596 .38267 L
s
.051 .063 .121 r
.41264 .37612 m .39583 .38272 L .38746 .39553 L p F P
0 0 0 r
s
.24 .35 .67 r
.844 .51155 m
.84451 .53149 L
s
.27 .42 .813 r
.55323 .64271 m .5443 .64539 L .53054 .64391 L p F P
0 0 0 r
s
.24 .35 .67 r
.54193 .64544 m
.54266 .64522 L
s
.27 .42 .813 r
.52444 .64575 m .53054 .64391 L .5443 .64539 L p F P
0 0 0 r
s
.83 .24 .1 r
.53684 .64408 m
.53826 .64542 L
s
.53826 .64542 m
.55825 .66428 L
s
.221 .353 .675 r
.61463 .62582 m .60287 .62935 L .58028 .63459 L p F P
0 0 0 r
s
.221 .353 .675 r
.57121 .63731 m .58028 .63459 L .60287 .62935 L p F P
0 0 0 r
s
.24 .35 .67 r
.75718 .57238 m
.71598 .58485 L
s
.71598 .58485 m
.70903 .5946 L
s
.58 .187 .085 r
.4324 .6295 m .43783 .63425 L .42032 .62891 L p F P
0 0 0 r
s
.58 .187 .085 r
.42032 .62891 m .41325 .62278 L .4324 .6295 L p F P
0 0 0 r
s
.289 .443 .863 r
.49425 .65487 m .48828 .65667 L .49396 .64528 L p F P
0 0 0 r
s
.24 .35 .67 r
.4887 .65497 m
.4892 .65482 L
s
.289 .443 .863 r
.49088 .64622 m .49396 .64528 L .48828 .65667 L p F P
0 0 0 r
s
.83 .24 .1 r
.49071 .6543 m
.49361 .65404 L
s
.127 .167 .35 r
.28528 .46548 m .30361 .45851 L .30791 .43982 L p F P
0 0 0 r
s
.127 .167 .35 r
.32607 .43282 m .30791 .43982 L .30361 .45851 L p F P
0 0 0 r
s
.027 .038 .072 r
.42961 .36946 m .44676 .36273 L .45233 .35511 L p F P
0 0 0 r
s
.027 .038 .072 r
.46786 .349 m .45233 .35511 L .44676 .36273 L p F P
0 0 0 r
s
.09 .111 .237 r
.32607 .43282 m .34444 .42574 L .35181 .40942 L p F P
0 0 0 r
s
.09 .111 .237 r
.36954 .40251 m .35181 .40942 L .34444 .42574 L p F P
0 0 0 r
s
.471 .116 .045 r
.60096 .38049 m .59179 .36898 L .59924 .38082 L p F P
0 0 0 r
s
.471 .116 .045 r
.59924 .38082 m .60909 .39314 L .60096 .38049 L p F P
0 0 0 r
s
.83 .24 .1 r
.58573 .3676 m
.60112 .38334 L
s
.762 .236 .104 r
.46093 .63948 m .46455 .64269 L .44854 .64362 L p F P
0 0 0 r
s
.762 .236 .104 r
.44854 .64362 m .44321 .63896 L .46093 .63948 L p F P
0 0 0 r
s
.886 .269 .117 r
.48729 .64297 m .48909 .6446 L .47881 .65535 L p F P
0 0 0 r
s
.886 .269 .117 r
.47881 .65535 m .47528 .65221 L .48729 .64297 L p F P
0 0 0 r
s
.83 .24 .1 r
.29906 .32355 m
.32191 .30052 L
s
.32191 .30052 m
.29578 .27308 L
s
.32191 .30052 m
.34721 .28052 L
s
.024 .035 .067 r
.49934 .33659 m .5153 .3303 L .51315 .32993 L p F P
0 0 0 r
s
.024 .035 .067 r
.52697 .32448 m .51315 .32993 L .5153 .3303 L p F P
0 0 0 r
s
.24 .35 .67 r
.52483 .32754 m
.53961 .32172 L
s
.83 .24 .1 r
.50069 .29996 m
.52145 .32518 L
s
.52145 .32518 m
.52237 .32629 L
s
.289 .443 .863 r
.50025 .65306 m .49425 .65487 L .49704 .64434 L p F P
0 0 0 r
s
.24 .35 .67 r
.49421 .65331 m
.49471 .65316 L
s
.289 .443 .863 r
.49396 .64528 m .49704 .64434 L .49425 .65487 L p F P
0 0 0 r
s
.507 .125 .048 r
.34232 .56575 m .35271 .57472 L .33908 .55738 L p F P
0 0 0 r
s
.507 .125 .048 r
.33908 .55738 m .3276 .54742 L .34232 .56575 L p F P
0 0 0 r
s
.83 .24 .1 r
.33277 .54698 m
.35771 .56871 L
s
.325 .073 .03 r
.37034 .59041 m .37923 .59808 L .36294 .58355 L p F P
0 0 0 r
s
.325 .073 .03 r
.36294 .58355 m .35271 .57472 L .37034 .59041 L p F P
0 0 0 r
s
.83 .24 .1 r
.50069 .29996 m
.47808 .2725 L
s
.50069 .29996 m
.52376 .30464 L
s
.27 .42 .813 r
.5622 .64002 m .55323 .64271 L .53666 .64206 L p F P
0 0 0 r
s
.24 .35 .67 r
.55052 .64286 m
.55125 .64264 L
s
.55914 .64026 m
.57735 .6348 L
s
.27 .42 .813 r
.53054 .64391 m .53666 .64206 L .55323 .64271 L p F P
0 0 0 r
s
.24 .35 .67 r
.74909 .25977 m
.76089 .27481 L
s
.83 .24 .1 r
.27419 .45384 m
.27969 .42751 L
s
.27969 .42751 m
.25271 .40257 L
s
.27944 .34882 m
.29906 .32355 L
s
.29906 .32355 m
.27246 .29655 L
s
.65 .169 .063 r
.31591 .53729 m .3276 .54742 L .31745 .52817 L p F P
0 0 0 r
s
.65 .169 .063 r
.31745 .52817 m .30498 .51726 L .31591 .53729 L p F P
0 0 0 r
s
1 .316 .13 r
.65529 .58282 m .64738 .57399 L .62974 .58977 L p F P
0 0 0 r
s
.83 .24 .1 r
.65462 .58301 m
.6548 .58321 L
s
1 .316 .13 r
.62974 .58977 m .63682 .59745 L .65529 .58282 L p F P
0 0 0 r
s
1 .31 .127 r
.66104 .55656 m .65238 .54659 L .63936 .565 L p F P
0 0 0 r
s
1 .31 .127 r
.63936 .565 m .64738 .57399 L .66104 .55656 L p F P
0 0 0 r
s
.453 .143 .069 r
.54855 .32848 m .54091 .31899 L .54767 .31755 L p F P
0 0 0 r
s
.83 .24 .1 r
.53723 .32127 m
.54537 .33133 L
s
.453 .143 .069 r
.54767 .31755 m .55652 .32861 L .54855 .32848 L p F P
0 0 0 r
s
.24 .35 .67 r
.54828 .3183 m
.56386 .31217 L
s
.221 .353 .675 r
.62647 .62227 m .61463 .62582 L .58939 .63186 L p F P
0 0 0 r
s
.221 .353 .675 r
.58028 .63459 m .58939 .63186 L .61463 .62582 L p F P
0 0 0 r
s
.24 .35 .67 r
.57735 .6348 m
.58883 .63073 L
s
.60378 .29645 m
.61498 .29864 L
s
.65518 .28288 m
.61498 .29864 L
s
.438 .139 .066 r
.39887 .61032 m .4061 .61659 L .38799 .60564 L p F P
0 0 0 r
s
.438 .139 .066 r
.38799 .60564 m .37923 .59808 L .39887 .61032 L p F P
0 0 0 r
s
1 .3 .122 r
.66135 .52728 m .6521 .51634 L .64357 .53644 L p F P
0 0 0 r
s
1 .3 .122 r
.64357 .53644 m .65238 .54659 L .66135 .52728 L p F P
0 0 0 r
s
.809 .217 .084 r
.29227 .50613 m .30498 .51726 L .29916 .4971 L p F P
0 0 0 r
s
.83 .24 .1 r
.30087 .50225 m
.32655 .52494 L
s
.809 .217 .084 r
.29916 .4971 m .28601 .48545 L .29227 .50613 L p F P
0 0 0 r
s
.289 .443 .863 r
.50627 .65124 m .50025 .65306 L .50013 .6434 L p F P
0 0 0 r
s
.24 .35 .67 r
.49973 .65164 m
.50023 .65149 L
s
.289 .443 .863 r
.49704 .64434 m .50013 .6434 L .50025 .65306 L p F P
0 0 0 r
s
.83 .24 .1 r
.49361 .65404 m
.50819 .65271 L
s
1 .318 .132 r
.64381 .60502 m .63682 .59745 L .61456 .60979 L p F P
0 0 0 r
s
1 .318 .132 r
.61456 .60979 m .62055 .61607 L .64381 .60502 L p F P
0 0 0 r
s
.641 .167 .062 r
.61874 .40523 m .60909 .39314 L .61459 .40886 L p F P
0 0 0 r
s
.83 .24 .1 r
.60112 .38334 m
.60919 .39345 L
s
.61866 .4053 m
.61886 .40555 L
s
.641 .167 .062 r
.61459 .40886 m .62467 .4214 L .61874 .40523 L p F P
0 0 0 r
s
.309 .092 .048 r
.57378 .3502 m .56522 .33949 L .57295 .34536 L p F P
0 0 0 r
s
.309 .092 .048 r
.57295 .34536 m .58245 .35728 L .57378 .3502 L p F P
0 0 0 r
s
.24 .35 .67 r
.30491 .62209 m
.2686 .63406 L
s
.2686 .63406 m
.2544 .60554 L
s
.83 .24 .1 r
.34721 .28052 m
.32151 .25262 L
s
.34721 .28052 m
.37408 .26427 L
s
.24 .35 .67 r
.43112 .65894 m
.41363 .64408 L
s
.158 .215 .442 r
.30361 .45851 m .28528 .46548 L .28601 .48545 L p F P
0 0 0 r
s
.83 .24 .1 r
.30053 .4776 m
.30087 .50225 L
s
.29462 .47227 m
.30053 .4776 L
s
.24 .35 .67 r
.30257 .46011 m
.30565 .45894 L
s
1 .284 .114 r
.65664 .49614 m .64697 .48447 L .64267 .5052 L p F P
0 0 0 r
s
1 .284 .114 r
.64267 .5052 m .6521 .51634 L .65664 .49614 L p F P
0 0 0 r
s
.24 .35 .67 r
.84451 .53149 m
.80214 .54448 L
s
.80214 .54448 m
.79932 .55963 L
s
.051 .063 .121 r
.38746 .39553 m .40558 .38847 L .41264 .37612 L p F P
0 0 0 r
s
.051 .063 .121 r
.42961 .36946 m .41264 .37612 L .40558 .38847 L p F P
0 0 0 r
s
.886 .269 .117 r
.48548 .64133 m .48729 .64297 L .47528 .65221 L p F P
0 0 0 r
s
.886 .269 .117 r
.47528 .65221 m .47172 .64906 L .48548 .64133 L p F P
0 0 0 r
s
.24 .35 .67 r
.47796 .65185 m
.47968 .65276 L
s
.27 .42 .813 r
.57121 .63731 m .5622 .64002 L .54281 .64021 L p F P
0 0 0 r
s
.27 .42 .813 r
.53666 .64206 m .54281 .64021 L .5622 .64002 L p F P
0 0 0 r
s
.027 .038 .072 r
.44676 .36273 m .46408 .35594 L .46786 .349 L p F P
0 0 0 r
s
.027 .038 .072 r
.48353 .34282 m .46786 .349 L .46408 .35594 L p F P
0 0 0 r
s
.24 .35 .67 r
.4781 .34649 m
.48666 .34257 L
s
.939 .259 .102 r
.64748 .46448 m .63759 .45234 L .63711 .47256 L p F P
0 0 0 r
s
.83 .24 .1 r
.63616 .45283 m
.63754 .45452 L
s
.64637 .46535 m
.64742 .46664 L
s
.939 .259 .102 r
.63711 .47256 m .64697 .48447 L .64748 .46448 L p F P
0 0 0 r
s
.813 .22 .084 r
.63456 .4337 m .62467 .4214 L .6275 .43995 L p F P
0 0 0 r
s
.813 .22 .084 r
.6275 .43995 m .63759 .45234 L .63456 .4337 L p F P
0 0 0 r
s
.83 .24 .1 r
.63558 .44987 m
.63616 .45283 L
s
.24 .35 .67 r
.24337 .57479 m
.23614 .5435 L
s
.27213 .53049 m
.23614 .5435 L
s
.289 .443 .863 r
.5123 .64942 m .50627 .65124 L .50322 .64246 L p F P
0 0 0 r
s
.24 .35 .67 r
.50527 .64997 m
.50577 .64981 L
s
.289 .443 .863 r
.50013 .6434 m .50322 .64246 L .50627 .65124 L p F P
0 0 0 r
s
.024 .035 .067 r
.5153 .3303 m .53141 .32396 L .52697 .32448 L p F P
0 0 0 r
s
.024 .035 .067 r
.54091 .31899 m .52697 .32448 L .53141 .32396 L p F P
0 0 0 r
s
.83 .24 .1 r
.53654 .32042 m
.53671 .32064 L
s
.762 .236 .104 r
.45728 .63625 m .46093 .63948 L .44321 .63896 L p F P
0 0 0 r
s
.762 .236 .104 r
.44321 .63896 m .43783 .63425 L .45728 .63625 L p F P
0 0 0 r
s
.127 .167 .35 r
.30361 .45851 m .32216 .45146 L .32607 .43282 L p F P
0 0 0 r
s
.24 .35 .67 r
.30565 .45894 m
.30589 .45764 L
s
.127 .167 .35 r
.34444 .42574 m .32607 .43282 L .32216 .45146 L p F P
0 0 0 r
s
.58 .187 .085 r
.42692 .62471 m .4324 .6295 L .41325 .62278 L p F P
0 0 0 r
s
.58 .187 .085 r
.41325 .62278 m .4061 .61659 L .42692 .62471 L p F P
0 0 0 r
s
.83 .24 .1 r
.26377 .37547 m
.27944 .34882 L
s
.27944 .34882 m
.25235 .32222 L
s
.09 .111 .237 r
.34444 .42574 m .36301 .41858 L .36954 .40251 L p F P
0 0 0 r
s
.09 .111 .237 r
.38746 .39553 m .36954 .40251 L .36301 .41858 L p F P
0 0 0 r
s
.221 .353 .675 r
.58939 .63186 m .59854 .62911 L .62647 .62227 L p F P
0 0 0 r
s
.83 .24 .1 r
.58613 .65022 m
.61215 .63104 L
s
.61215 .63104 m
.63188 .65126 L
s
1 .319 .133 r
.62647 .62227 m .62055 .61607 L .59381 .62431 L p F P
0 0 0 r
s
.24 .35 .67 r
.61981 .62189 m
.62029 .62171 L
s
1 .319 .133 r
.59381 .62431 m .59854 .62911 L .62647 .62227 L p F P
0 0 0 r
s
.83 .24 .1 r
.61215 .63104 m
.61867 .62436 L
s
.6081 .62688 m
.61215 .63104 L
s
.289 .443 .863 r
.51836 .64759 m .5123 .64942 L .50632 .64152 L p F P
0 0 0 r
s
.24 .35 .67 r
.51082 .64829 m
.51133 .64813 L
s
.289 .443 .863 r
.50322 .64246 m .50632 .64152 L .5123 .64942 L p F P
0 0 0 r
s
.24 .35 .67 r
.70903 .5946 m
.66806 .60691 L
s
.66806 .60691 m
.65783 .61062 L
s
.41363 .64408 m
.37598 .65584 L
s
.37598 .65584 m
.35841 .63537 L
s
.27 .42 .813 r
.58028 .63459 m .57121 .63731 L .54898 .63835 L p F P
0 0 0 r
s
.24 .35 .67 r
.57735 .6348 m
.59803 .62858 L
s
.27 .42 .813 r
.54281 .64021 m .54898 .63835 L .57121 .63731 L p F P
0 0 0 r
s
.24 .35 .67 r
.35841 .63537 m
.32138 .64722 L
s
.32138 .64722 m
.30491 .62209 L
s
.886 .269 .117 r
.48367 .63969 m .48548 .64133 L .47172 .64906 L p F P
0 0 0 r
s
.886 .269 .117 r
.47172 .64906 m .46815 .64589 L .48367 .63969 L p F P
0 0 0 r
s
.24 .35 .67 r
.46928 .64725 m
.47796 .65185 L
s
.43112 .65894 m
.46928 .64725 L
s
.69629 .26677 m
.70766 .27585 L
s
.74909 .25977 m
.70766 .27585 L
s
.29071 .59319 m
.2544 .60554 L
s
.2544 .60554 m
.24337 .57479 L
s
.27957 .56209 m
.24337 .57479 L
s
.289 .443 .863 r
.52444 .64575 m .51836 .64759 L .50942 .64057 L p F P
0 0 0 r
s
.24 .35 .67 r
.5164 .6466 m
.51691 .64645 L
s
.52199 .64491 m
.52419 .64425 L
s
.52419 .64425 m
.52764 .64479 L
s
.289 .443 .863 r
.50632 .64152 m .50942 .64057 L .51836 .64759 L p F P
0 0 0 r
s
.83 .24 .1 r
.45249 .27368 m
.42877 .2455 L
s
.45249 .27368 m
.47808 .2725 L
s
.24 .35 .67 r
.27213 .53049 m
.26875 .50014 L
s
.051 .063 .121 r
.40558 .38847 m .42389 .38134 L .42961 .36946 L p F P
0 0 0 r
s
.051 .063 .121 r
.44676 .36273 m .42961 .36946 L .42389 .38134 L p F P
0 0 0 r
s
.027 .038 .072 r
.46408 .35594 m .48158 .34907 L .48353 .34282 L p F P
0 0 0 r
s
.027 .038 .072 r
.49934 .33659 m .48353 .34282 L .48158 .34907 L p F P
0 0 0 r
s
.83 .24 .1 r
.37408 .26427 m
.34877 .23589 L
s
.37408 .26427 m
.40159 .25242 L
s
.024 .035 .067 r
.53141 .32396 m .54767 .31755 L .54091 .31899 L p F P
0 0 0 r
s
.83 .24 .1 r
.52376 .30464 m
.53654 .32042 L
s
.471 .116 .045 r
.59179 .36898 m .58245 .35728 L .58921 .36827 L p F P
0 0 0 r
s
.83 .24 .1 r
.56502 .34175 m
.58573 .3676 L
s
.471 .116 .045 r
.58921 .36827 m .59924 .38082 L .59179 .36898 L p F P
0 0 0 r
s
.325 .073 .03 r
.36132 .58263 m .37034 .59041 L .35271 .57472 L p F P
0 0 0 r
s
.325 .073 .03 r
.35271 .57472 m .34232 .56575 L .36132 .58263 L p F P
0 0 0 r
s
.83 .24 .1 r
.34454 .56557 m
.36962 .58725 L
s
.27 .42 .813 r
.58939 .63186 m .58028 .63459 L .55516 .63648 L p F P
0 0 0 r
s
.27 .42 .813 r
.54898 .63835 m .55516 .63648 L .58028 .63459 L p F P
0 0 0 r
s
.158 .215 .442 r
.28601 .48545 m .30429 .47861 L .30361 .45851 L p F P
0 0 0 r
s
.83 .24 .1 r
.27419 .45384 m
.28656 .46499 L
s
.158 .215 .442 r
.32216 .45146 m .30361 .45851 L .30429 .47861 L p F P
0 0 0 r
s
.438 .139 .066 r
.39155 .60398 m .39887 .61032 L .37923 .59808 L p F P
0 0 0 r
s
.438 .139 .066 r
.37923 .59808 m .37034 .59041 L .39155 .60398 L p F P
0 0 0 r
s
.83 .24 .1 r
.36962 .58725 m
.3837 .59896 L
s
.762 .236 .104 r
.45362 .63299 m .45728 .63625 L .43783 .63425 L p F P
0 0 0 r
s
.762 .236 .104 r
.43783 .63425 m .4324 .6295 L .45362 .63299 L p F P
0 0 0 r
s
.886 .269 .117 r
.48185 .63805 m .48367 .63969 L .46815 .64589 L p F P
0 0 0 r
s
.886 .269 .117 r
.46815 .64589 m .46455 .64269 L .48185 .63805 L p F P
0 0 0 r
s
1 .316 .13 r
.64738 .57399 m .63936 .565 L .62255 .58198 L p F P
0 0 0 r
s
.83 .24 .1 r
.64673 .5742 m
.64692 .5744 L
s
1 .316 .13 r
.62255 .58198 m .62974 .58977 L .64738 .57399 L p F P
0 0 0 r
s
.289 .443 .863 r
.53054 .64391 m .52444 .64575 L .51253 .63962 L p F P
0 0 0 r
s
.289 .443 .863 r
.50942 .64057 m .51253 .63962 L .52444 .64575 L p F P
0 0 0 r
s
.83 .24 .1 r
.50819 .65271 m
.53684 .64408 L
s
.507 .125 .048 r
.33176 .55664 m .34232 .56575 L .3276 .54742 L p F P
0 0 0 r
s
.83 .24 .1 r
.33277 .54698 m
.34454 .56557 L
s
.507 .125 .048 r
.3276 .54742 m .31591 .53729 L .33176 .55664 L p F P
0 0 0 r
s
.24 .35 .67 r
.55391 .31682 m
.56386 .31217 L
s
.60378 .29645 m
.56386 .31217 L
s
1 .318 .132 r
.63682 .59745 m .62974 .58977 L .60851 .60345 L p F P
0 0 0 r
s
1 .318 .132 r
.60851 .60345 m .61456 .60979 L .63682 .59745 L p F P
0 0 0 r
s
.24 .35 .67 r
.79932 .55963 m
.75718 .57238 L
s
.75718 .57238 m
.75093 .582 L
s
1 .31 .127 r
.65238 .54659 m .64357 .53644 L .6312 .55588 L p F P
0 0 0 r
s
1 .31 .127 r
.6312 .55588 m .63936 .565 L .65238 .54659 L p F P
0 0 0 r
s
.127 .167 .35 r
.32216 .45146 m .34092 .44432 L .34444 .42574 L p F P
0 0 0 r
s
.127 .167 .35 r
.36301 .41858 m .34444 .42574 L .34092 .44432 L p F P
0 0 0 r
s
.09 .111 .237 r
.36301 .41858 m .3818 .41134 L .38746 .39553 L p F P
0 0 0 r
s
.09 .111 .237 r
.40558 .38847 m .38746 .39553 L .3818 .41134 L p F P
0 0 0 r
s
.58 .187 .085 r
.42139 .61987 m .42692 .62471 L .4061 .61659 L p F P
0 0 0 r
s
.58 .187 .085 r
.4061 .61659 m .39887 .61032 L .42139 .61987 L p F P
0 0 0 r
s
.65 .169 .063 r
.30402 .52697 m .31591 .53729 L .30498 .51726 L p F P
0 0 0 r
s
.65 .169 .063 r
.30498 .51726 m .29227 .50613 L .30402 .52697 L p F P
0 0 0 r
s
.309 .092 .048 r
.56522 .33949 m .55652 .32861 L .56327 .33323 L p F P
0 0 0 r
s
.309 .092 .048 r
.56327 .33323 m .57295 .34536 L .56522 .33949 L p F P
0 0 0 r
s
1 .319 .133 r
.62055 .61607 m .61456 .60979 L .58904 .61947 L p F P
0 0 0 r
s
1 .319 .133 r
.58904 .61947 m .59381 .62431 L .62055 .61607 L p F P
0 0 0 r
s
.24 .35 .67 r
.61713 .62284 m
.61981 .62189 L
s
.60907 .62527 m
.61713 .62284 L
s
.289 .443 .863 r
.53666 .64206 m .53054 .64391 L .51565 .63867 L p F P
0 0 0 r
s
.24 .35 .67 r
.5276 .64321 m
.52811 .64306 L
s
.289 .443 .863 r
.51253 .63962 m .51565 .63867 L .53054 .64391 L p F P
0 0 0 r
s
.27 .42 .813 r
.59854 .62911 m .58939 .63186 L .56137 .6346 L p F P
0 0 0 r
s
.24 .35 .67 r
.57104 .63366 m
.57319 .63404 L
s
.27 .42 .813 r
.55516 .63648 m .56137 .6346 L .58939 .63186 L p F P
0 0 0 r
s
.83 .24 .1 r
.57182 .63616 m
.58613 .65022 L
s
.25271 .40257 m
.26377 .37547 L
s
.26377 .37547 m
.2362 .34922 L
s
1 .3 .122 r
.6521 .51634 m .64267 .5052 L .6346 .52611 L p F P
0 0 0 r
s
1 .3 .122 r
.6346 .52611 m .64357 .53644 L .6521 .51634 L p F P
0 0 0 r
s
.181 .252 .513 r
.30429 .47861 m .28601 .48545 L .29227 .50613 L p F P
0 0 0 r
s
.83 .24 .1 r
.27418 .47866 m
.28824 .49108 L
s
.24 .35 .67 r
.26875 .50014 m
.2877 .49311 L
s
.2877 .49311 m
.28827 .4929 L
s
.83 .24 .1 r
.28824 .49108 m
.28899 .49175 L
s
.29589 .49784 m
.30087 .50225 L
s
.641 .167 .062 r
.60909 .39314 m .59924 .38082 L .6043 .39608 L p F P
0 0 0 r
s
.641 .167 .062 r
.6043 .39608 m .61459 .40886 L .60909 .39314 L p F P
0 0 0 r
s
.886 .269 .117 r
.48002 .6364 m .48185 .63805 L .46455 .64269 L p F P
0 0 0 r
s
.886 .269 .117 r
.46455 .64269 m .46093 .63948 L .48002 .6364 L p F P
0 0 0 r
s
.83 .24 .1 r
.24679 .42913 m
.27419 .45384 L
s
.27418 .47866 m
.27419 .45384 L
s
1 .284 .114 r
.64697 .48447 m .63711 .47256 L .63306 .49384 L p F P
0 0 0 r
s
1 .284 .114 r
.63306 .49384 m .64267 .5052 L .64697 .48447 L p F P
0 0 0 r
s
.289 .443 .863 r
.54281 .64021 m .53666 .64206 L .51877 .63772 L p F P
0 0 0 r
s
.24 .35 .67 r
.53323 .64151 m
.53374 .64136 L
s
.289 .443 .863 r
.51565 .63867 m .51877 .63772 L .53666 .64206 L p F P
0 0 0 r
s
.027 .038 .072 r
.48158 .34907 m .49926 .34213 L .49934 .33659 L p F P
0 0 0 r
s
.027 .038 .072 r
.5153 .3303 m .49934 .33659 L .49926 .34213 L p F P
0 0 0 r
s
.24 .35 .67 r
.51033 .33397 m
.51426 .33242 L
s
.51426 .33242 m
.52483 .32754 L
s
.64462 .28037 m
.65518 .28288 L
s
.69629 .26677 m
.65518 .28288 L
s
.051 .063 .121 r
.42389 .38134 m .44241 .37413 L .44676 .36273 L p F P
0 0 0 r
s
.051 .063 .121 r
.46408 .35594 m .44676 .36273 L .44241 .37413 L p F P
0 0 0 r
s
.24 .35 .67 r
.61713 .62284 m
.65783 .61062 L
s
.604 .62012 m
.61713 .62284 L
s
.762 .236 .104 r
.44993 .62972 m .45362 .63299 L .4324 .6295 L p F P
0 0 0 r
s
.762 .236 .104 r
.4324 .6295 m .42692 .62471 L .44993 .62972 L p F P
0 0 0 r
s
.813 .22 .084 r
.62467 .4214 m .61459 .40886 L .61721 .42731 L p F P
0 0 0 r
s
.813 .22 .084 r
.61721 .42731 m .6275 .43995 L .62467 .4214 L p F P
0 0 0 r
s
.939 .259 .102 r
.63759 .45234 m .6275 .43995 L .62706 .46042 L p F P
0 0 0 r
s
.939 .259 .102 r
.62706 .46042 m .63711 .47256 L .63759 .45234 L p F P
0 0 0 r
s
.27 .42 .813 r
.56137 .6346 m .56761 .63272 L .59854 .62911 L p F P
0 0 0 r
s
.83 .24 .1 r
.56886 .63326 m
.57182 .63616 L
s
1 .316 .133 r
.59854 .62911 m .59381 .62431 L .56427 .62945 L p F P
0 0 0 r
s
1 .316 .133 r
.56427 .62945 m .56761 .63272 L .59854 .62911 L p F P
0 0 0 r
s
.24 .35 .67 r
.34206 .60985 m
.30491 .62209 L
s
.30491 .62209 m
.29071 .59319 L
s
.46928 .64725 m
.48484 .64249 L
s
.84451 .53149 m
.84243 .54658 L
s
.158 .215 .442 r
.30429 .47861 m .32277 .4717 L .32216 .45146 L p F P
0 0 0 r
s
.158 .215 .442 r
.34092 .44432 m .32216 .45146 L .32277 .4717 L p F P
0 0 0 r
s
.24 .35 .67 r
.33984 .44595 m
.34258 .44491 L
s
.289 .443 .863 r
.54898 .63835 m .54281 .64021 L .52189 .63677 L p F P
0 0 0 r
s
.24 .35 .67 r
.53888 .6398 m
.53939 .63965 L
s
.289 .443 .863 r
.51877 .63772 m .52189 .63677 L .54281 .64021 L p F P
0 0 0 r
s
.83 .24 .1 r
.52376 .30464 m
.50129 .27689 L
s
.52376 .30464 m
.54348 .31487 L
s
.24 .35 .67 r
.27957 .56209 m
.27213 .53049 L
s
.886 .269 .117 r
.47819 .63474 m .48002 .6364 L .46093 .63948 L p F P
0 0 0 r
s
.886 .269 .117 r
.46093 .63948 m .45728 .63625 L .47819 .63474 L p F P
0 0 0 r
s
.83 .24 .1 r
.45773 .63482 m
.45918 .63611 L
s
.45532 .6345 m
.45773 .63482 L
s
.09 .111 .237 r
.3818 .41134 m .4008 .40402 L .40558 .38847 L p F P
0 0 0 r
s
.09 .111 .237 r
.42389 .38134 m .40558 .38847 L .4008 .40402 L p F P
0 0 0 r
s
.127 .167 .35 r
.34092 .44432 m .3599 .43711 L .36301 .41858 L p F P
0 0 0 r
s
.24 .35 .67 r
.34258 .44491 m
.3428 .44361 L
s
.127 .167 .35 r
.3818 .41134 m .36301 .41858 L .3599 .43711 L p F P
0 0 0 r
s
.438 .139 .066 r
.38414 .59756 m .39155 .60398 L .37034 .59041 L p F P
0 0 0 r
s
.438 .139 .066 r
.37034 .59041 m .36132 .58263 L .38414 .59756 L p F P
0 0 0 r
s
.968 .29 .124 r
.49088 .64622 m .48909 .6446 L .5 .62969 L closepath p F P
0 0 0 r
s
.291 .44 .861 r
.5 .62969 m .49396 .64528 L .49088 .64622 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.50133 .64645 m
.50819 .65271 L
s
.58 .187 .085 r
.41581 .61499 m .42139 .61987 L .39887 .61032 L p F P
0 0 0 r
s
.58 .187 .085 r
.39887 .61032 m .39155 .60398 L .41581 .61499 L p F P
0 0 0 r
s
1 .318 .132 r
.62974 .58977 m .62255 .58198 L .60238 .59702 L p F P
0 0 0 r
s
1 .318 .132 r
.60238 .59702 m .60851 .60345 L .62974 .58977 L p F P
0 0 0 r
s
.289 .443 .863 r
.55516 .63648 m .54898 .63835 L .52503 .63582 L p F P
0 0 0 r
s
.24 .35 .67 r
.54455 .63809 m
.54506 .63793 L
s
.289 .443 .863 r
.52189 .63677 m .52503 .63582 L .54898 .63835 L p F P
0 0 0 r
s
.325 .073 .03 r
.35218 .57475 m .36132 .58263 L .34232 .56575 L p F P
0 0 0 r
s
.325 .073 .03 r
.34232 .56575 m .33176 .55664 L .35218 .57475 L p F P
0 0 0 r
s
1 .319 .133 r
.61456 .60979 m .60851 .60345 L .58422 .61459 L p F P
0 0 0 r
s
1 .319 .133 r
.58422 .61459 m .58904 .61947 L .61456 .60979 L p F P
0 0 0 r
s
.83 .24 .1 r
.40159 .25242 m
.37663 .22356 L
s
.40159 .25242 m
.42877 .2455 L
s
.291 .44 .861 r
.5 .62969 m .49704 .64434 L .49396 .64528 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.49922 .64452 m
.50133 .64645 L
s
.24 .35 .67 r
.75093 .582 m
.70903 .5946 L
s
.70903 .5946 m
.69946 .59811 L
s
1 .316 .13 r
.63936 .565 m .6312 .55588 L .61527 .57409 L p F P
0 0 0 r
s
.83 .24 .1 r
.63872 .56524 m
.63891 .56545 L
s
1 .316 .13 r
.61527 .57409 m .62255 .58198 L .63936 .565 L p F P
0 0 0 r
s
.24 .35 .67 r
.3963 .62323 m
.41363 .64408 L
s
.471 .116 .045 r
.58245 .35728 m .57295 .34536 L .57899 .35547 L p F P
0 0 0 r
s
.471 .116 .045 r
.57899 .35547 m .58921 .36827 L .58245 .35728 L p F P
0 0 0 r
s
.83 .24 .1 r
.56502 .34175 m
.5804 .35742 L
s
.968 .29 .124 r
.48909 .6446 m .48729 .64297 L .5 .62969 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.3963 .62323 m
.35841 .63537 L
s
.35841 .63537 m
.34206 .60985 L
s
.027 .038 .072 r
.49926 .34213 m .51713 .33512 L .5153 .3303 L p F P
0 0 0 r
s
.027 .038 .072 r
.53141 .32396 m .5153 .3303 L .51713 .33512 L p F P
0 0 0 r
s
.24 .35 .67 r
.73836 .25029 m
.74909 .25977 L
s
.181 .252 .513 r
.29227 .50613 m .31004 .49961 L .30429 .47861 L p F P
0 0 0 r
s
.24 .35 .67 r
.30531 .48235 m
.30537 .47821 L
s
.181 .252 .513 r
.32277 .4717 m .30429 .47861 L .31004 .49961 L p F P
0 0 0 r
s
.291 .44 .861 r
.5 .62969 m .50013 .6434 L .49704 .64434 L closepath p F P
0 0 0 r
s
.762 .236 .104 r
.44622 .62643 m .44993 .62972 L .42692 .62471 L p F P
0 0 0 r
s
.762 .236 .104 r
.42692 .62471 m .42139 .61987 L .44622 .62643 L p F P
0 0 0 r
s
.289 .443 .863 r
.56137 .6346 m .55516 .63648 L .52816 .63486 L p F P
0 0 0 r
s
.24 .35 .67 r
.55023 .63637 m
.55075 .63621 L
s
.289 .443 .863 r
.52503 .63582 m .52816 .63486 L .55516 .63648 L p F P
0 0 0 r
s
.83 .24 .1 r
.53684 .64408 m
.55173 .63648 L
s
.55173 .63648 m
.55473 .63495 L
s
.52802 .63575 m
.53684 .64408 L
s
.507 .125 .048 r
.32103 .54738 m .33176 .55664 L .31591 .53729 L p F P
0 0 0 r
s
.507 .125 .048 r
.31591 .53729 m .30402 .52697 L .32103 .54738 L p F P
0 0 0 r
s
1 .316 .133 r
.59381 .62431 m .58904 .61947 L .56091 .62615 L p F P
0 0 0 r
s
1 .316 .133 r
.56091 .62615 m .56427 .62945 L .59381 .62431 L p F P
0 0 0 r
s
.051 .063 .121 r
.44241 .37413 m .46113 .36683 L .46408 .35594 L p F P
0 0 0 r
s
.051 .063 .121 r
.48158 .34907 m .46408 .35594 L .46113 .36683 L p F P
0 0 0 r
s
.886 .269 .117 r
.47636 .63308 m .47819 .63474 L .45728 .63625 L p F P
0 0 0 r
s
.886 .269 .117 r
.45728 .63625 m .45362 .63299 L .47636 .63308 L p F P
0 0 0 r
s
.24 .35 .67 r
.32785 .58056 m
.29071 .59319 L
s
.29071 .59319 m
.27957 .56209 L
s
.291 .44 .861 r
.5 .62969 m .50322 .64246 L .50013 .6434 L closepath p F P
0 0 0 r
s
.309 .092 .048 r
.55652 .32861 m .54767 .31755 L .55342 .32088 L p F P
0 0 0 r
s
.309 .092 .048 r
.55342 .32088 m .56327 .33323 L .55652 .32861 L p F P
0 0 0 r
s
.24 .35 .67 r
.27957 .56209 m
.3166 .54909 L
s
1 .31 .127 r
.64357 .53644 m .6346 .52611 L .6229 .5466 L p F P
0 0 0 r
s
1 .31 .127 r
.6229 .5466 m .6312 .55588 L .64357 .53644 L p F P
0 0 0 r
s
.968 .29 .124 r
.48729 .64297 m .48548 .64133 L .5 .62969 L closepath p F P
0 0 0 r
s
.291 .44 .861 r
.5 .62969 m .50632 .64152 L .50322 .64246 L closepath p F P
0 0 0 r
s
.289 .443 .863 r
.56761 .63272 m .56137 .6346 L .53131 .6339 L p F P
0 0 0 r
s
.24 .35 .67 r
.55594 .63465 m
.55645 .63449 L
s
.56166 .63292 m
.56364 .63232 L
s
.56364 .63232 m
.56615 .63277 L
s
.289 .443 .863 r
.52816 .63486 m .53131 .6339 L .56137 .6346 L p F P
0 0 0 r
s
.83 .24 .1 r
.27246 .29655 m
.29578 .27308 L
s
.29578 .27308 m
.26861 .24454 L
s
.29578 .27308 m
.32151 .25262 L
s
.2 .282 .57 r
.31004 .49961 m .29227 .50613 L .30402 .52697 L p F P
0 0 0 r
s
.83 .24 .1 r
.30685 .5244 m
.33277 .54698 L
s
.3056 .51978 m
.30685 .5244 L
s
.24 .35 .67 r
.27213 .53049 m
.30027 .52032 L
s
.158 .215 .442 r
.32277 .4717 m .34147 .46471 L .34092 .44432 L p F P
0 0 0 r
s
.158 .215 .442 r
.3599 .43711 m .34092 .44432 L .34147 .46471 L p F P
0 0 0 r
s
.24 .35 .67 r
.57058 .63022 m
.57619 .62852 L
s
.56364 .63232 m
.56636 .6315 L
s
.291 .44 .861 r
.5 .62969 m .50942 .64057 L .50632 .64152 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.47808 .2725 m
.45456 .24394 L
s
.47808 .2725 m
.50129 .27689 L
s
.27988 .50091 m
.29933 .51785 L
s
.29933 .51785 m
.30087 .51919 L
s
.30495 .52274 m
.30685 .5244 L
s
.968 .29 .124 r
.48548 .64133 m .48367 .63969 L .5 .62969 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.24679 .42913 m
.25271 .40257 L
s
.25271 .40257 m
.22465 .37662 L
s
.25235 .32222 m
.27246 .29655 L
s
.27246 .29655 m
.2448 .26846 L
s
.24 .35 .67 r
.59449 .30085 m
.60378 .29645 L
s
.64462 .28037 m
.60378 .29645 L
s
1 .3 .122 r
.64267 .5052 m .63306 .49384 L .62546 .51559 L p F P
0 0 0 r
s
1 .3 .122 r
.62546 .51559 m .6346 .52611 L .64267 .5052 L p F P
0 0 0 r
s
.24 .35 .67 r
.84243 .54658 m
.79932 .55963 L
s
.79932 .55963 m
.79381 .56911 L
s
.09 .111 .237 r
.4008 .40402 m .42002 .39661 L .42389 .38134 L p F P
0 0 0 r
s
.09 .111 .237 r
.44241 .37413 m .42389 .38134 L .42002 .39661 L p F P
0 0 0 r
s
.291 .44 .861 r
.5 .62969 m .51253 .63962 L .50942 .64057 L closepath p F P
0 0 0 r
s
.641 .167 .062 r
.59924 .38082 m .58921 .36827 L .5938 .38303 L p F P
0 0 0 r
s
.83 .24 .1 r
.5804 .35742 m
.5893 .36856 L
s
.59914 .38087 m
.59934 .38112 L
s
.641 .167 .062 r
.5938 .38303 m .6043 .39608 L .59924 .38082 L p F P
0 0 0 r
s
.127 .167 .35 r
.3599 .43711 m .37909 .42981 L .3818 .41134 L p F P
0 0 0 r
s
.127 .167 .35 r
.4008 .40402 m .3818 .41134 L .37909 .42981 L p F P
0 0 0 r
s
.886 .269 .117 r
.47452 .63142 m .47636 .63308 L .45362 .63299 L p F P
0 0 0 r
s
.886 .269 .117 r
.45362 .63299 m .44993 .62972 L .47452 .63142 L p F P
0 0 0 r
s
.24 .35 .67 r
.45215 .63205 m
.46928 .64725 L
s
.41363 .64408 m
.45215 .63205 L
s
.289 .443 .863 r
.53131 .6339 m .53446 .63294 L .56761 .63272 L p F P
0 0 0 r
s
1 .312 .132 r
.56761 .63272 m .56427 .62945 L .53271 .63128 L p F P
0 0 0 r
s
1 .312 .132 r
.53271 .63128 m .53446 .63294 L .56761 .63272 L p F P
0 0 0 r
s
.58 .187 .085 r
.41018 .61007 m .41581 .61499 L .39155 .60398 L p F P
0 0 0 r
s
.83 .24 .1 r
.39041 .60299 m
.39739 .60589 L
s
.58 .187 .085 r
.39155 .60398 m .38414 .59756 L .41018 .61007 L p F P
0 0 0 r
s
.968 .29 .124 r
.48367 .63969 m .48185 .63805 L .5 .62969 L closepath p F P
0 0 0 r
s
.291 .44 .861 r
.5 .62969 m .51565 .63867 L .51253 .63962 L closepath p F P
0 0 0 r
s
.027 .038 .072 r
.51713 .33512 m .53518 .32804 L .53141 .32396 L p F P
0 0 0 r
s
.027 .038 .072 r
.54767 .31755 m .53141 .32396 L .53518 .32804 L p F P
0 0 0 r
s
.24 .35 .67 r
.54381 .32079 m
.54882 .31882 L
s
.762 .236 .104 r
.44248 .62311 m .44622 .62643 L .42139 .61987 L p F P
0 0 0 r
s
.762 .236 .104 r
.42139 .61987 m .41581 .61499 L .44248 .62311 L p F P
0 0 0 r
s
1 .319 .133 r
.60851 .60345 m .60238 .59702 L .57936 .60966 L p F P
0 0 0 r
s
1 .319 .133 r
.57936 .60966 m .58422 .61459 L .60851 .60345 L p F P
0 0 0 r
s
.83 .24 .1 r
.32151 .25262 m
.29478 .22359 L
s
.32151 .25262 m
.34877 .23589 L
s
1 .284 .114 r
.63711 .47256 m .62706 .46042 L .62327 .48227 L p F P
0 0 0 r
s
1 .284 .114 r
.62327 .48227 m .63306 .49384 L .63711 .47256 L p F P
0 0 0 r
s
.438 .139 .066 r
.37665 .59106 m .38414 .59756 L .36132 .58263 L p F P
0 0 0 r
s
.438 .139 .066 r
.36132 .58263 m .35218 .57475 L .37665 .59106 L p F P
0 0 0 r
s
1 .316 .133 r
.58904 .61947 m .58422 .61459 L .55753 .62284 L p F P
0 0 0 r
s
1 .316 .133 r
.55753 .62284 m .56091 .62615 L .58904 .61947 L p F P
0 0 0 r
s
.291 .44 .861 r
.5 .62969 m .51877 .63772 L .51565 .63867 L closepath p F P
0 0 0 r
s
.181 .252 .513 r
.31004 .49961 m .32801 .49302 L .32277 .4717 L p F P
0 0 0 r
s
.181 .252 .513 r
.34147 .46471 m .32277 .4717 L .32801 .49302 L p F P
0 0 0 r
s
.813 .22 .084 r
.61459 .40886 m .6043 .39608 L .60671 .41442 L p F P
0 0 0 r
s
.813 .22 .084 r
.60671 .41442 m .61721 .42731 L .61459 .40886 L p F P
0 0 0 r
s
.83 .24 .1 r
.61541 .4251 m
.61597 .42808 L
s
1 .318 .132 r
.62255 .58198 m .61527 .57409 L .59618 .59052 L p F P
0 0 0 r
s
1 .318 .132 r
.59618 .59052 m .60238 .59702 L .62255 .58198 L p F P
0 0 0 r
s
.051 .063 .121 r
.46113 .36683 m .48006 .35946 L .48158 .34907 L p F P
0 0 0 r
s
.051 .063 .121 r
.49926 .34213 m .48158 .34907 L .48006 .35946 L p F P
0 0 0 r
s
.939 .259 .102 r
.6275 .43995 m .61721 .42731 L .6168 .44803 L p F P
0 0 0 r
s
.83 .24 .1 r
.61597 .42808 m
.61717 .42955 L
s
.62636 .44082 m
.62745 .44216 L
s
.939 .259 .102 r
.6168 .44803 m .62706 .46042 L .6275 .43995 L p F P
0 0 0 r
s
.968 .29 .124 r
.48185 .63805 m .48002 .6364 L .5 .62969 L closepath p F P
0 0 0 r
s
.291 .44 .861 r
.5 .62969 m .52189 .63677 L .51877 .63772 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.2362 .34922 m
.25235 .32222 L
s
.25235 .32222 m
.22418 .29455 L
s
.24 .35 .67 r
.68641 .26392 m
.69629 .26677 L
s
.73836 .25029 m
.69629 .26677 L
s
.886 .269 .117 r
.47267 .62975 m .47452 .63142 L .44993 .62972 L p F P
0 0 0 r
s
.886 .269 .117 r
.44993 .62972 m .44622 .62643 L .47267 .62975 L p F P
0 0 0 r
s
.325 .073 .03 r
.34291 .56675 m .35218 .57475 L .33176 .55664 L p F P
0 0 0 r
s
.325 .073 .03 r
.33176 .55664 m .32103 .54738 L .34291 .56675 L p F P
0 0 0 r
s
1 .312 .132 r
.56427 .62945 m .56091 .62615 L .53095 .62961 L p F P
0 0 0 r
s
1 .312 .132 r
.53095 .62961 m .53271 .63128 L .56427 .62945 L p F P
0 0 0 r
s
.24 .35 .67 r
.69946 .59811 m
.65783 .61062 L
s
.65783 .61062 m
.64531 .60763 L
s
.291 .44 .861 r
.5 .62969 m .52503 .63582 L .52189 .63677 L closepath p F P
0 0 0 r
s
.968 .29 .124 r
.48002 .6364 m .47819 .63474 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .316 .13 r
.6312 .55588 m .6229 .5466 L .60787 .56608 L p F P
0 0 0 r
s
.83 .24 .1 r
.63058 .55615 m
.63077 .55636 L
s
1 .316 .13 r
.60787 .56608 m .61527 .57409 L .6312 .55588 L p F P
0 0 0 r
s
.24 .35 .67 r
.34206 .60985 m
.32785 .58056 L
s
.2 .282 .57 r
.30402 .52697 m .32084 .52093 L .31004 .49961 L p F P
0 0 0 r
s
.2 .282 .57 r
.32801 .49302 m .31004 .49961 L .32084 .52093 L p F P
0 0 0 r
s
.291 .44 .861 r
.5 .62969 m .52816 .63486 L .52503 .63582 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.27988 .50091 m
.27418 .47866 L
s
.27418 .47866 m
.2464 .45411 L
s
.158 .215 .442 r
.34147 .46471 m .36038 .45764 L .3599 .43711 L p F P
0 0 0 r
s
.158 .215 .442 r
.37909 .42981 m .3599 .43711 L .36038 .45764 L p F P
0 0 0 r
s
.24 .35 .67 r
.37798 .43146 m
.38037 .43055 L
s
.471 .116 .045 r
.57295 .34536 m .56327 .33323 L .56857 .34243 L p F P
0 0 0 r
s
.471 .116 .045 r
.56857 .34243 m .57899 .35547 L .57295 .34536 L p F P
0 0 0 r
s
.09 .111 .237 r
.42002 .39661 m .43946 .38912 L .44241 .37413 L p F P
0 0 0 r
s
.09 .111 .237 r
.46113 .36683 m .44241 .37413 L .43946 .38912 L p F P
0 0 0 r
s
.291 .44 .861 r
.5 .62969 m .53131 .6339 L .52816 .63486 L closepath p F P
0 0 0 r
s
.968 .29 .124 r
.47819 .63474 m .47636 .63308 L .5 .62969 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.47624 .63297 m
.47913 .63268 L
s
.027 .038 .072 r
.53518 .32804 m .55342 .32088 L .54767 .31755 L p F P
0 0 0 r
s
.83 .24 .1 r
.54952 .32241 m
.56502 .34175 L
s
.54348 .31487 m
.54616 .31821 L
s
.54616 .31821 m
.54627 .31834 L
s
.24 .35 .67 r
.54945 .31857 m
.55391 .31682 L
s
.762 .236 .104 r
.43872 .61978 m .44248 .62311 L .41581 .61499 L p F P
0 0 0 r
s
.762 .236 .104 r
.41581 .61499 m .41018 .61007 L .43872 .61978 L p F P
0 0 0 r
s
.216 .308 .619 r
.32084 .52093 m .30402 .52697 L .32103 .54738 L p F P
0 0 0 r
s
.24 .35 .67 r
.31551 .54455 m
.3166 .54909 L
s
.31424 .53923 m
.31551 .54455 L
s
.83 .24 .1 r
.31462 .53686 m
.31679 .54033 L
s
.31679 .54033 m
.31846 .54301 L
s
.127 .167 .35 r
.37909 .42981 m .39852 .42243 L .4008 .40402 L p F P
0 0 0 r
s
.24 .35 .67 r
.38037 .43055 m
.38056 .42925 L
s
.127 .167 .35 r
.42002 .39661 m .4008 .40402 L .39852 .42243 L p F P
0 0 0 r
s
1 .316 .133 r
.58422 .61459 m .57936 .60966 L .55413 .6195 L p F P
0 0 0 r
s
1 .316 .133 r
.55413 .6195 m .55753 .62284 L .58422 .61459 L p F P
0 0 0 r
s
.24 .35 .67 r
.57619 .62852 m
.604 .62012 L
s
.83 .24 .1 r
.42877 .2455 m
.40408 .21618 L
s
.42877 .2455 m
.45456 .24394 L
s
.291 .44 .861 r
.5 .62969 m .53446 .63294 L .53131 .6339 L closepath p F P
0 0 0 r
s
.886 .269 .117 r
.47082 .62807 m .47267 .62975 L .44622 .62643 L p F P
0 0 0 r
s
.886 .269 .117 r
.44622 .62643 m .44248 .62311 L .47082 .62807 L p F P
0 0 0 r
s
1 .31 .127 r
.6346 .52611 m .62546 .51559 L .61448 .53717 L p F P
0 0 0 r
s
1 .31 .127 r
.61448 .53717 m .6229 .5466 L .6346 .52611 L p F P
0 0 0 r
s
.58 .187 .085 r
.4045 .6051 m .41018 .61007 L .38414 .59756 L p F P
0 0 0 r
s
.58 .187 .085 r
.38414 .59756 m .37665 .59106 L .4045 .6051 L p F P
0 0 0 r
s
1 .312 .132 r
.56091 .62615 m .55753 .62284 L .52919 .62793 L p F P
0 0 0 r
s
1 .312 .132 r
.52919 .62793 m .53095 .62961 L .56091 .62615 L p F P
0 0 0 r
s
.24 .35 .67 r
.55643 .62798 m
.55806 .62896 L
s
.83 .24 .1 r
.34877 .23589 m
.32244 .20636 L
s
.34877 .23589 m
.37663 .22356 L
s
.24 .35 .67 r
.55183 .31996 m
.55391 .31682 L
s
.59449 .30085 m
.55391 .31682 L
s
.968 .29 .124 r
.47636 .63308 m .47452 .63142 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .319 .133 r
.60238 .59702 m .59618 .59052 L .57445 .60469 L p F P
0 0 0 r
s
1 .319 .133 r
.57445 .60469 m .57936 .60966 L .60238 .59702 L p F P
0 0 0 r
s
1 .303 .129 r
.5 .62969 m .53446 .63294 L .53271 .63128 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.79381 .56911 m
.75093 .582 L
s
.75093 .582 m
.74208 .5853 L
s
.051 .063 .121 r
.48006 .35946 m .4992 .352 L .49926 .34213 L p F P
0 0 0 r
s
.051 .063 .121 r
.51713 .33512 m .49926 .34213 L .4992 .352 L p F P
0 0 0 r
s
.24 .35 .67 r
.45215 .63205 m
.46416 .6283 L
s
.181 .252 .513 r
.32801 .49302 m .34619 .48636 L .34147 .46471 L p F P
0 0 0 r
s
.181 .252 .513 r
.36038 .45764 m .34147 .46471 L .34619 .48636 L p F P
0 0 0 r
s
.83 .24 .1 r
.54348 .31487 m
.52107 .28689 L
s
.54348 .31487 m
.54846 .31991 L
s
.24 .35 .67 r
.3166 .54909 m
.32785 .58056 L
s
.968 .29 .124 r
.47452 .63142 m .47267 .62975 L .5 .62969 L closepath p F P
0 0 0 r
s
.438 .139 .066 r
.36906 .58449 m .37665 .59106 L .35218 .57475 L p F P
0 0 0 r
s
.438 .139 .066 r
.35218 .57475 m .34291 .56675 L .36906 .58449 L p F P
0 0 0 r
s
.83 .24 .1 r
.34454 .56557 m
.3596 .57807 L
s
.24 .35 .67 r
.32785 .58056 m
.35004 .57302 L
s
.35004 .57302 m
.35126 .5726 L
s
1 .303 .129 r
.5 .62969 m .53271 .63128 L .53095 .62961 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.3166 .54909 m
.32116 .54749 L
s
1 .3 .122 r
.63306 .49384 m .62327 .48227 L .61616 .50488 L p F P
0 0 0 r
s
1 .3 .122 r
.61616 .50488 m .62546 .51559 L .63306 .49384 L p F P
0 0 0 r
s
1 .318 .132 r
.61527 .57409 m .60787 .56608 L .5899 .58394 L p F P
0 0 0 r
s
1 .318 .132 r
.5899 .58394 m .59618 .59052 L .61527 .57409 L p F P
0 0 0 r
s
.886 .269 .117 r
.46896 .62639 m .47082 .62807 L .44248 .62311 L p F P
0 0 0 r
s
.24 .35 .67 r
.46416 .6283 m
.46785 .62715 L
s
.886 .269 .117 r
.44248 .62311 m .43872 .61978 L .46896 .62639 L p F P
0 0 0 r
s
.641 .167 .062 r
.58921 .36827 m .57899 .35547 L .58309 .36972 L p F P
0 0 0 r
s
.641 .167 .062 r
.58309 .36972 m .5938 .38303 L .58921 .36827 L p F P
0 0 0 r
s
1 .312 .132 r
.55753 .62284 m .55413 .6195 L .52742 .62625 L p F P
0 0 0 r
s
1 .312 .132 r
.52742 .62625 m .52919 .62793 L .55753 .62284 L p F P
0 0 0 r
s
.83 .24 .1 r
.22465 .37662 m
.2362 .34922 L
s
.2362 .34922 m
.2075 .32191 L
s
.2 .282 .57 r
.32084 .52093 m .33784 .51483 L .32801 .49302 L p F P
0 0 0 r
s
.2 .282 .57 r
.34619 .48636 m .32801 .49302 L .33784 .51483 L p F P
0 0 0 r
s
.968 .29 .124 r
.47267 .62975 m .47082 .62807 L .5 .62969 L closepath p F P
0 0 0 r
s
.762 .236 .104 r
.43494 .61643 m .43872 .61978 L .41018 .61007 L p F P
0 0 0 r
s
.762 .236 .104 r
.41018 .61007 m .4045 .6051 L .43494 .61643 L p F P
0 0 0 r
s
1 .303 .129 r
.5 .62969 m .53095 .62961 L .52919 .62793 L closepath p F P
0 0 0 r
s
.158 .215 .442 r
.36038 .45764 m .37952 .45048 L .37909 .42981 L p F P
0 0 0 r
s
.158 .215 .442 r
.39852 .42243 m .37909 .42981 L .37952 .45048 L p F P
0 0 0 r
s
.24 .35 .67 r
.604 .62012 m
.64531 .60763 L
s
.58914 .61054 m
.604 .62012 L
s
1 .316 .133 r
.57936 .60966 m .57445 .60469 L .55071 .61615 L p F P
0 0 0 r
s
1 .316 .133 r
.55071 .61615 m .55413 .6195 L .57936 .60966 L p F P
0 0 0 r
s
.09 .111 .237 r
.43946 .38912 m .45913 .38154 L .46113 .36683 L p F P
0 0 0 r
s
.09 .111 .237 r
.48006 .35946 m .46113 .36683 L .45913 .38154 L p F P
0 0 0 r
s
.24 .35 .67 r
.63602 .28451 m
.64462 .28037 L
s
.68641 .26392 m
.64462 .28037 L
s
.83 .24 .1 r
.21827 .40341 m
.24679 .42913 L
s
.2464 .45411 m
.24679 .42913 L
s
.216 .308 .619 r
.32103 .54738 m .33647 .54196 L .32084 .52093 L p F P
0 0 0 r
s
.83 .24 .1 r
.32279 .54676 m
.34454 .56557 L
s
.216 .308 .619 r
.33784 .51483 m .32084 .52093 L .33647 .54196 L p F P
0 0 0 r
s
.24 .35 .67 r
.84243 .54658 m
.8377 .55592 L
s
1 .284 .114 r
.62706 .46042 m .6168 .44803 L .61328 .47047 L p F P
0 0 0 r
s
1 .284 .114 r
.61328 .47047 m .62327 .48227 L .62706 .46042 L p F P
0 0 0 r
s
.23 .33 .662 r
.33647 .54196 m .32103 .54738 L .34291 .56675 L p F P
0 0 0 r
s
.83 .24 .1 r
.31846 .54301 m
.3217 .54582 L
s
.3217 .54582 m
.32183 .54593 L
s
.127 .167 .35 r
.39852 .42243 m .41817 .41496 L .42002 .39661 L p F P
0 0 0 r
s
.127 .167 .35 r
.43946 .38912 m .42002 .39661 L .41817 .41496 L p F P
0 0 0 r
s
.968 .29 .124 r
.47082 .62807 m .46896 .62639 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .303 .129 r
.5 .62969 m .52919 .62793 L .52742 .62625 L closepath p F P
0 0 0 r
s
.813 .22 .084 r
.6043 .39608 m .5938 .38303 L .596 .40125 L p F P
0 0 0 r
s
.813 .22 .084 r
.596 .40125 m .60671 .41442 L .6043 .39608 L p F P
0 0 0 r
s
1 .316 .13 r
.6229 .5466 m .61448 .53717 L .60037 .55795 L p F P
0 0 0 r
s
.83 .24 .1 r
.62231 .5469 m
.62251 .54712 L
s
1 .316 .13 r
.60037 .55795 m .60787 .56608 L .6229 .5466 L p F P
0 0 0 r
s
.939 .259 .102 r
.61721 .42731 m .60671 .41442 L .60633 .43539 L p F P
0 0 0 r
s
.939 .259 .102 r
.60633 .43539 m .6168 .44803 L .61721 .42731 L p F P
0 0 0 r
s
.58 .187 .085 r
.39876 .60008 m .4045 .6051 L .37665 .59106 L p F P
0 0 0 r
s
.58 .187 .085 r
.37665 .59106 m .36906 .58449 L .39876 .60008 L p F P
0 0 0 r
s
.24 .35 .67 r
.34206 .60985 m
.38007 .59732 L
s
.38007 .59732 m
.3963 .62323 L
s
.051 .063 .121 r
.4992 .352 m .51856 .34446 L .51713 .33512 L p F P
0 0 0 r
s
.051 .063 .121 r
.53518 .32804 m .51713 .33512 L .51856 .34446 L p F P
0 0 0 r
s
.886 .269 .117 r
.46709 .6247 m .46896 .62639 L .43872 .61978 L p F P
0 0 0 r
s
.886 .269 .117 r
.43872 .61978 m .43494 .61643 L .46709 .6247 L p F P
0 0 0 r
s
.24 .35 .67 r
.44319 .62092 m
.45215 .63205 L
s
.44138 .61867 m
.44319 .62092 L
s
1 .303 .129 r
.5 .62969 m .5167 .61604 L .5149 .61433 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.4949 .62915 m
.50294 .62666 L
s
.24 .35 .67 r
.50122 .6287 m
.50201 .62944 L
s
1 .303 .129 r
.5 .62969 m .5149 .61433 L .51308 .6126 L closepath p F P
0 0 0 r
s
1 .303 .129 r
.5 .62969 m .51308 .6126 L .51126 .61087 L closepath p F P
0 0 0 r
s
1 .303 .129 r
.5 .62969 m .51126 .61087 L .50944 .60913 L closepath p F P
0 0 0 r
s
1 .303 .129 r
.5 .62969 m .52742 .62625 L .52565 .62456 L closepath p F P
0 0 0 r
s
1 .303 .129 r
.5 .62969 m .52565 .62456 L .52387 .62287 L closepath p F P
0 0 0 r
s
1 .303 .129 r
.5 .62969 m .52387 .62287 L .52209 .62117 L closepath p F P
0 0 0 r
s
1 .303 .129 r
.5 .62969 m .52209 .62117 L .5203 .61947 L closepath p F P
0 0 0 r
s
1 .303 .129 r
.5 .62969 m .5203 .61947 L .5185 .61776 L closepath p F P
0 0 0 r
s
1 .303 .129 r
.5 .62969 m .5185 .61776 L .5167 .61604 L closepath p F P
0 0 0 r
s
.968 .29 .124 r
.46709 .6247 m .46522 .62301 L .5 .62969 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.47958 .6266 m
.48072 .62764 L
s
.968 .29 .124 r
.46896 .62639 m .46709 .6247 L .5 .62969 L closepath p F P
0 0 0 r
s
.285 .426 .838 r
.46834 .62203 m .46522 .62301 L .5 .62969 L closepath p F P
0 0 0 r
s
.285 .426 .838 r
.47147 .62105 m .46834 .62203 L .5 .62969 L closepath p F P
0 0 0 r
s
.285 .426 .838 r
.4746 .62007 m .47147 .62105 L .5 .62969 L closepath p F P
0 0 0 r
s
.285 .426 .838 r
.47774 .61908 m .4746 .62007 L .5 .62969 L closepath p F P
0 0 0 r
s
.285 .426 .838 r
.48088 .61809 m .47774 .61908 L .5 .62969 L closepath p F P
0 0 0 r
s
.285 .426 .838 r
.48403 .61711 m .48088 .61809 L .5 .62969 L closepath p F P
0 0 0 r
s
.285 .426 .838 r
.48719 .61612 m .48403 .61711 L .5 .62969 L closepath p F P
0 0 0 r
s
.285 .426 .838 r
.49035 .61512 m .48719 .61612 L .5 .62969 L closepath p F P
0 0 0 r
s
.285 .426 .838 r
.49352 .61413 m .49035 .61512 L .5 .62969 L closepath p F P
0 0 0 r
s
.285 .426 .838 r
.49669 .61313 m .49352 .61413 L .5 .62969 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.49948 .62709 m
.50068 .62821 L
s
.285 .426 .838 r
.49987 .61214 m .49669 .61313 L .5 .62969 L closepath p F P
0 0 0 r
s
.285 .426 .838 r
.50305 .61114 m .49987 .61214 L .5 .62969 L closepath p F P
0 0 0 r
s
.285 .426 .838 r
.50624 .61014 m .50305 .61114 L .5 .62969 L closepath p F P
0 0 0 r
s
.285 .426 .838 r
.50944 .60913 m .50624 .61014 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .312 .132 r
.55413 .6195 m .55071 .61615 L .52565 .62456 L p F P
0 0 0 r
s
1 .312 .132 r
.52565 .62456 m .52742 .62625 L .55413 .6195 L p F P
0 0 0 r
s
1 .319 .133 r
.59618 .59052 m .5899 .58394 L .5695 .59967 L p F P
0 0 0 r
s
1 .319 .133 r
.5695 .59967 m .57445 .60469 L .59618 .59052 L p F P
0 0 0 r
s
.83 .24 .1 r
.50129 .27689 m
.47791 .248 L
s
.50129 .27689 m
.52107 .28689 L
s
.181 .252 .513 r
.34619 .48636 m .36456 .47962 L .36038 .45764 L p F P
0 0 0 r
s
.181 .252 .513 r
.37952 .45048 m .36038 .45764 L .36456 .47962 L p F P
0 0 0 r
s
.471 .116 .045 r
.56327 .33323 m .55342 .32088 L .55794 .32912 L p F P
0 0 0 r
s
.471 .116 .045 r
.55794 .32912 m .56857 .34243 L .56327 .33323 L p F P
0 0 0 r
s
.83 .24 .1 r
.31846 .54301 m
.33545 .55711 L
s
.31846 .54301 m
.29131 .51954 L
s
.24 .35 .67 r
.72919 .24707 m
.73836 .25029 L
s
.762 .236 .104 r
.43114 .61305 m .43494 .61643 L .4045 .6051 L p F P
0 0 0 r
s
.24 .35 .67 r
.3963 .62323 m
.42282 .61474 L
s
.762 .236 .104 r
.4045 .6051 m .39876 .60008 L .43114 .61305 L p F P
0 0 0 r
s
.24 .35 .67 r
.42282 .61474 m
.42827 .613 L
s
.886 .269 .117 r
.46522 .62301 m .46709 .6247 L .43494 .61643 L p F P
0 0 0 r
s
.24 .35 .67 r
.74208 .5853 m
.69946 .59811 L
s
.69946 .59811 m
.68758 .59485 L
s
1 .312 .132 r
.52387 .62287 m .52565 .62456 L .55071 .61615 L p F P
0 0 0 r
s
.24 .35 .67 r
.53213 .628 m
.54826 .62306 L
s
.54826 .62306 m
.55643 .62798 L
s
1 .316 .133 r
.57445 .60469 m .5695 .59967 L .54727 .61277 L p F P
0 0 0 r
s
1 .316 .133 r
.54727 .61277 m .55071 .61615 L .57445 .60469 L p F P
0 0 0 r
s
.83 .24 .1 r
.37663 .22356 m
.35064 .19352 L
s
.37663 .22356 m
.40408 .21618 L
s
.2 .282 .57 r
.33784 .51483 m .35502 .50866 L .34619 .48636 L p F P
0 0 0 r
s
.2 .282 .57 r
.36456 .47962 m .34619 .48636 L .35502 .50866 L p F P
0 0 0 r
s
1 .31 .127 r
.62546 .51559 m .61616 .50488 L .60591 .52759 L p F P
0 0 0 r
s
1 .31 .127 r
.60591 .52759 m .61448 .53717 L .62546 .51559 L p F P
0 0 0 r
s
.83 .24 .1 r
.61325 .53678 m
.61356 .53615 L
s
.61325 .53678 m
.6141 .53773 L
s
.886 .269 .117 r
.43494 .61643 m .43114 .61305 L .46522 .62301 L p F P
0 0 0 r
s
.24 .35 .67 r
.38007 .59732 m
.38781 .59477 L
s
.37664 .59015 m
.38007 .59732 L
s
.37602 .58885 m
.37664 .59015 L
s
.242 .351 .701 r
.35654 .56207 m .34291 .56675 L .36906 .58449 L p F P
0 0 0 r
s
.83 .24 .1 r
.35091 .57048 m
.35174 .5712 L
s
.23 .33 .662 r
.34291 .56675 m .35654 .56207 L .33647 .54196 L p F P
0 0 0 r
s
1 .312 .132 r
.55071 .61615 m .54727 .61277 L .52387 .62287 L p F P
0 0 0 r
s
.216 .308 .619 r
.33647 .54196 m .35205 .53649 L .33784 .51483 L p F P
0 0 0 r
s
.216 .308 .619 r
.35502 .50866 m .33784 .51483 L .35205 .53649 L p F P
0 0 0 r
s
.158 .215 .442 r
.37952 .45048 m .39887 .44324 L .39852 .42243 L p F P
0 0 0 r
s
.158 .215 .442 r
.41817 .41496 m .39852 .42243 L .39887 .44324 L p F P
0 0 0 r
s
.24 .35 .67 r
.41702 .41663 m
.41904 .41587 L
s
.23 .33 .662 r
.35205 .53649 m .33647 .54196 L .35654 .56207 L p F P
0 0 0 r
s
.83 .24 .1 r
.33545 .55711 m
.35091 .57048 L
s
.09 .111 .237 r
.45913 .38154 m .47903 .37387 L .48006 .35946 L p F P
0 0 0 r
s
.09 .111 .237 r
.4992 .352 m .48006 .35946 L .47903 .37387 L p F P
0 0 0 r
s
1 .318 .132 r
.60787 .56608 m .60037 .55795 L .58355 .57729 L p F P
0 0 0 r
s
.83 .24 .1 r
.59403 .56389 m
.59464 .56455 L
s
1 .318 .132 r
.58355 .57729 m .5899 .58394 L .60787 .56608 L p F P
0 0 0 r
s
.276 .409 .807 r
.46522 .62301 m .46834 .62203 L .43726 .61109 L p F P
0 0 0 r
s
.276 .409 .807 r
.43726 .61109 m .43114 .61305 L .46522 .62301 L p F P
0 0 0 r
s
1 .312 .132 r
.52209 .62117 m .52387 .62287 L .54727 .61277 L p F P
0 0 0 r
s
.24 .35 .67 r
.35285 .52905 m
.3545 .5358 L
s
.127 .167 .35 r
.41817 .41496 m .43805 .4074 L .43946 .38912 L p F P
0 0 0 r
s
.24 .35 .67 r
.41904 .41587 m
.4192 .41456 L
s
.127 .167 .35 r
.45913 .38154 m .43946 .38912 L .43805 .4074 L p F P
0 0 0 r
s
.276 .409 .807 r
.46834 .62203 m .47147 .62105 L .44341 .60912 L p F P
0 0 0 r
s
.276 .409 .807 r
.44341 .60912 m .43726 .61109 L .46834 .62203 L p F P
0 0 0 r
s
.051 .063 .121 r
.51856 .34446 m .53814 .33684 L .53518 .32804 L p F P
0 0 0 r
s
.051 .063 .121 r
.55342 .32088 m .53518 .32804 L .53814 .33684 L p F P
0 0 0 r
s
1 .312 .132 r
.54727 .61277 m .54381 .60937 L .52209 .62117 L p F P
0 0 0 r
s
1 .312 .132 r
.5203 .61947 m .52209 .62117 L .54381 .60937 L p F P
0 0 0 r
s
.276 .409 .807 r
.47147 .62105 m .4746 .62007 L .44957 .60715 L p F P
0 0 0 r
s
.276 .409 .807 r
.44957 .60715 m .44341 .60912 L .47147 .62105 L p F P
0 0 0 r
s
.254 .371 .738 r
.38051 .58066 m .36906 .58449 L .39876 .60008 L p F P
0 0 0 r
s
.83 .24 .1 r
.37706 .58603 m
.37802 .58642 L
s
.36782 .58226 m
.37139 .58372 L
s
.242 .351 .701 r
.36906 .58449 m .38051 .58066 L .35654 .56207 L p F P
0 0 0 r
s
.24 .35 .67 r
.58767 .312 m
.59449 .30085 L
s
.63602 .28451 m
.59449 .30085 L
s
.83 .24 .1 r
.26861 .24454 m
.2448 .26846 L
s
.29478 .22359 m
.26861 .24454 L
s
1 .3 .122 r
.62327 .48227 m .61328 .47047 L .60669 .49397 L p F P
0 0 0 r
s
1 .3 .122 r
.60669 .49397 m .61616 .50488 L .62327 .48227 L p F P
0 0 0 r
s
.265 .39 .773 r
.43114 .61305 m .43726 .61109 L .40769 .59717 L p F P
0 0 0 r
s
.24 .35 .67 r
.42979 .61251 m
.43016 .61239 L
s
.265 .39 .773 r
.40769 .59717 m .39876 .60008 L .43114 .61305 L p F P
0 0 0 r
s
.24 .35 .67 r
.8377 .55592 m
.79381 .56911 L
s
.79381 .56911 m
.7857 .5722 L
s
1 .319 .133 r
.5899 .58394 m .58355 .57729 L .5645 .5946 L p F P
0 0 0 r
s
1 .319 .133 r
.5645 .5946 m .5695 .59967 L .5899 .58394 L p F P
0 0 0 r
s
.83 .24 .1 r
.5703 .58813 m
.57092 .58877 L
s
.45456 .24394 m
.43008 .2142 L
s
.45456 .24394 m
.47791 .248 L
s
1 .316 .133 r
.54381 .60937 m .54727 .61277 L .5695 .59967 L p F P
0 0 0 r
s
.24 .35 .67 r
.54826 .62306 m
.58914 .61054 L
s
.83 .24 .1 r
.29131 .51954 m
.27988 .50091 L
s
.27988 .50091 m
.2518 .47645 L
s
.21827 .40341 m
.22465 .37662 L
s
.22465 .37662 m
.19544 .3496 L
s
.276 .409 .807 r
.4746 .62007 m .47774 .61908 L .45576 .60517 L p F P
0 0 0 r
s
.276 .409 .807 r
.45576 .60517 m .44957 .60715 L .4746 .62007 L p F P
0 0 0 r
s
.181 .252 .513 r
.36456 .47962 m .38314 .4728 L .37952 .45048 L p F P
0 0 0 r
s
.181 .252 .513 r
.39887 .44324 m .37952 .45048 L .38314 .4728 L p F P
0 0 0 r
s
.83 .24 .1 r
.2448 .26846 m
.22418 .29455 L
s
.641 .167 .062 r
.57899 .35547 m .56857 .34243 L .57217 .35613 L p F P
0 0 0 r
s
.83 .24 .1 r
.55884 .33044 m
.56864 .34269 L
s
.57886 .35549 m
.57907 .35575 L
s
.641 .167 .062 r
.57217 .35613 m .58309 .36972 L .57899 .35547 L p F P
0 0 0 r
s
.254 .371 .738 r
.39876 .60008 m .40769 .59717 L .38051 .58066 L p F P
0 0 0 r
s
1 .312 .132 r
.54381 .60937 m .54032 .60595 L .5203 .61947 L p F P
0 0 0 r
s
.83 .24 .1 r
.54286 .60844 m
.54334 .6082 L
s
1 .312 .132 r
.5185 .61776 m .5203 .61947 L .54032 .60595 L p F P
0 0 0 r
s
1 .316 .133 r
.5695 .59967 m .5645 .5946 L .54381 .60937 L p F P
0 0 0 r
s
.83 .24 .1 r
.54334 .6082 m
.54423 .60907 L
s
.242 .351 .701 r
.37029 .55736 m .35654 .56207 L .38051 .58066 L p F P
0 0 0 r
s
.23 .33 .662 r
.35654 .56207 m .37029 .55736 L .35205 .53649 L p F P
0 0 0 r
s
.24 .35 .67 r
.35216 .53662 m
.3545 .5358 L
s
.3545 .5358 m
.35661 .5417 L
s
.276 .409 .807 r
.47774 .61908 m .48088 .61809 L .46198 .60318 L p F P
0 0 0 r
s
.276 .409 .807 r
.46198 .60318 m .45576 .60517 L .47774 .61908 L p F P
0 0 0 r
s
1 .316 .13 r
.61448 .53717 m .60591 .52759 L .59276 .54971 L p F P
0 0 0 r
s
1 .316 .13 r
.59276 .54971 m .60037 .55795 L .61448 .53717 L p F P
0 0 0 r
s
.83 .24 .1 r
.59403 .56389 m
.59917 .55664 L
s
.265 .39 .773 r
.43726 .61109 m .44341 .60912 L .41666 .59423 L p F P
0 0 0 r
s
.24 .35 .67 r
.43603 .61051 m
.43641 .61039 L
s
.4332 .60777 m
.43441 .60975 L
s
.265 .39 .773 r
.41666 .59423 m .40769 .59717 L .43726 .61109 L p F P
0 0 0 r
s
.83 .24 .1 r
.42817 .60855 m
.42962 .60984 L
s
.2 .282 .57 r
.35502 .50866 m .37238 .50243 L .36456 .47962 L p F P
0 0 0 r
s
.2 .282 .57 r
.38314 .4728 m .36456 .47962 L .37238 .50243 L p F P
0 0 0 r
s
.23 .33 .662 r
.36779 .53097 m .35205 .53649 L .37029 .55736 L p F P
0 0 0 r
s
.216 .308 .619 r
.35205 .53649 m .36779 .53097 L .35502 .50866 L p F P
0 0 0 r
s
.276 .409 .807 r
.48088 .61809 m .48403 .61711 L .46821 .60119 L p F P
0 0 0 r
s
.276 .409 .807 r
.46821 .60119 m .46198 .60318 L .48088 .61809 L p F P
0 0 0 r
s
.83 .24 .1 r
.46932 .61724 m
.47155 .61927 L
s
.44411 .61249 m
.46198 .61054 L
s
1 .284 .114 r
.6168 .44803 m .60633 .43539 L .6031 .45843 L p F P
0 0 0 r
s
1 .284 .114 r
.6031 .45843 m .61328 .47047 L .6168 .44803 L p F P
0 0 0 r
s
.83 .24 .1 r
.32244 .20636 m
.29478 .22359 L
s
.216 .308 .619 r
.37238 .50243 m .35502 .50866 L .36779 .53097 L p F P
0 0 0 r
s
1 .312 .132 r
.54032 .60595 m .53681 .60251 L .5185 .61776 L p F P
0 0 0 r
s
1 .312 .132 r
.5167 .61604 m .5185 .61776 L .53681 .60251 L p F P
0 0 0 r
s
.09 .111 .237 r
.47903 .37387 m .49916 .36611 L .4992 .352 L p F P
0 0 0 r
s
.09 .111 .237 r
.51856 .34446 m .4992 .352 L .49916 .36611 L p F P
0 0 0 r
s
.254 .371 .738 r
.39204 .57681 m .38051 .58066 L .40769 .59717 L p F P
0 0 0 r
s
.83 .24 .1 r
.37802 .58642 m
.38336 .58859 L
s
.38336 .58859 m
.38847 .59306 L
s
.242 .351 .701 r
.38051 .58066 m .39204 .57681 L .37029 .55736 L p F P
0 0 0 r
s
.276 .409 .807 r
.48403 .61711 m .48719 .61612 L .47447 .59919 L p F P
0 0 0 r
s
.276 .409 .807 r
.47447 .59919 m .46821 .60119 L .48403 .61711 L p F P
0 0 0 r
s
.83 .24 .1 r
.46198 .61054 m
.46932 .61724 L
s
.813 .22 .084 r
.5938 .38303 m .58309 .36972 L .58506 .38782 L p F P
0 0 0 r
s
.813 .22 .084 r
.58506 .38782 m .596 .40125 L .5938 .38303 L p F P
0 0 0 r
s
.83 .24 .1 r
.59443 .39932 m
.59496 .40232 L
s
.24 .35 .67 r
.68758 .59485 m
.64531 .60763 L
s
.64531 .60763 m
.63098 .59772 L
s
.158 .215 .442 r
.39887 .44324 m .41846 .43592 L .41817 .41496 L p F P
0 0 0 r
s
.158 .215 .442 r
.43805 .4074 m .41817 .41496 L .41846 .43592 L p F P
0 0 0 r
s
.254 .371 .738 r
.40769 .59717 m .41666 .59423 L .39204 .57681 L p F P
0 0 0 r
s
1 .316 .133 r
.54032 .60595 m .54381 .60937 L .5645 .5946 L p F P
0 0 0 r
s
.83 .24 .1 r
.55667 .59828 m
.5703 .58813 L
s
.24 .35 .67 r
.67854 .26777 m
.68641 .26392 L
s
.72919 .24707 m
.68641 .26392 L
s
.265 .39 .773 r
.44341 .60912 m .44957 .60715 L .42568 .59129 L p F P
0 0 0 r
s
.24 .35 .67 r
.44229 .60851 m
.44267 .60838 L
s
.265 .39 .773 r
.42568 .59129 m .41666 .59423 L .44341 .60912 L p F P
0 0 0 r
s
.83 .24 .1 r
.42618 .60678 m
.42817 .60855 L
s
.939 .259 .102 r
.60671 .41442 m .596 .40125 L .59565 .42249 L p F P
0 0 0 r
s
.83 .24 .1 r
.59496 .40232 m
.59596 .40355 L
s
.60553 .41528 m
.60667 .41668 L
s
.939 .259 .102 r
.59565 .42249 m .60633 .43539 L .60671 .41442 L p F P
0 0 0 r
s
.276 .409 .807 r
.48719 .61612 m .49035 .61512 L .48075 .59718 L p F P
0 0 0 r
s
.276 .409 .807 r
.48075 .59718 m .47447 .59919 L .48719 .61612 L p F P
0 0 0 r
s
.24 .35 .67 r
.47475 .59811 m
.47536 .5989 L
s
.051 .063 .121 r
.53814 .33684 m .55794 .32912 L .55342 .32088 L p F P
0 0 0 r
s
.83 .24 .1 r
.55765 .32923 m
.55884 .33044 L
s
1 .312 .132 r
.53681 .60251 m .53328 .59904 L .5167 .61604 L p F P
0 0 0 r
s
1 .312 .132 r
.5149 .61433 m .5167 .61604 L .53328 .59904 L p F P
0 0 0 r
s
.83 .24 .1 r
.22418 .29455 m
.2075 .32191 L
s
.127 .167 .35 r
.43805 .4074 m .45817 .39975 L .45913 .38154 L p F P
0 0 0 r
s
.127 .167 .35 r
.47903 .37387 m .45913 .38154 L .45817 .39975 L p F P
0 0 0 r
s
1 .318 .132 r
.60037 .55795 m .59276 .54971 L .57712 .57055 L p F P
0 0 0 r
s
1 .318 .132 r
.57712 .57055 m .58355 .57729 L .60037 .55795 L p F P
0 0 0 r
s
.83 .24 .1 r
.5703 .58813 m
.58225 .57592 L
s
.53639 .30235 m
.55387 .32421 L
s
.55783 .32917 m
.55884 .33044 L
s
.276 .409 .807 r
.49035 .61512 m .49352 .61413 L .48706 .59516 L p F P
0 0 0 r
s
.276 .409 .807 r
.48706 .59516 m .48075 .59718 L .49035 .61512 L p F P
0 0 0 r
s
.242 .351 .701 r
.38415 .55261 m .37029 .55736 L .39204 .57681 L p F P
0 0 0 r
s
.83 .24 .1 r
.35729 .56583 m
.38336 .58859 L
s
.23 .33 .662 r
.37029 .55736 m .38415 .55261 L .36779 .53097 L p F P
0 0 0 r
s
.265 .39 .773 r
.44957 .60715 m .45576 .60517 L .43474 .58832 L p F P
0 0 0 r
s
.24 .35 .67 r
.44858 .60649 m
.44896 .60637 L
s
.265 .39 .773 r
.43474 .58832 m .42568 .59129 L .44957 .60715 L p F P
0 0 0 r
s
.83 .24 .1 r
.2518 .47645 m
.2464 .45411 L
s
.2464 .45411 m
.21748 .42855 L
s
1 .319 .133 r
.55946 .58949 m .5645 .5946 L .58355 .57729 L p F P
0 0 0 r
s
1 .316 .133 r
.5645 .5946 m .55946 .58949 L .54032 .60595 L p F P
0 0 0 r
s
1 .31 .127 r
.61616 .50488 m .60669 .49397 L .59719 .51784 L p F P
0 0 0 r
s
1 .31 .127 r
.59719 .51784 m .60591 .52759 L .61616 .50488 L p F P
0 0 0 r
s
1 .312 .132 r
.53328 .59904 m .52973 .59555 L .5149 .61433 L p F P
0 0 0 r
s
.24 .35 .67 r
.5319 .60714 m
.54826 .62306 L
s
1 .312 .132 r
.51308 .6126 m .5149 .61433 L .52973 .59555 L p F P
0 0 0 r
s
.276 .409 .807 r
.49352 .61413 m .49669 .61313 L .49338 .59313 L p F P
0 0 0 r
s
.276 .409 .807 r
.49338 .59313 m .48706 .59516 L .49352 .61413 L p F P
0 0 0 r
s
.254 .371 .738 r
.41666 .59423 m .42568 .59129 L .40364 .57292 L p F P
0 0 0 r
s
.24 .35 .67 r
.41897 .5845 m
.42047 .58695 L
s
.41794 .58484 m
.41897 .5845 L
s
.254 .371 .738 r
.40364 .57292 m .39204 .57681 L .41666 .59423 L p F P
0 0 0 r
s
.83 .24 .1 r
.40901 .59153 m
.42618 .60678 L
s
1 .319 .133 r
.58355 .57729 m .57712 .57055 L .55946 .58949 L p F P
0 0 0 r
s
.181 .252 .513 r
.38314 .4728 m .40193 .46591 L .39887 .44324 L p F P
0 0 0 r
s
.181 .252 .513 r
.41846 .43592 m .39887 .44324 L .40193 .46591 L p F P
0 0 0 r
s
.24 .35 .67 r
.55562 .32454 m
.58767 .312 L
s
.242 .351 .701 r
.39204 .57681 m .40364 .57292 L .38415 .55261 L p F P
0 0 0 r
s
1 .316 .133 r
.53681 .60251 m .54032 .60595 L .55946 .58949 L p F P
0 0 0 r
s
.276 .409 .807 r
.49669 .61313 m .49987 .61214 L .49974 .5911 L p F P
0 0 0 r
s
.276 .409 .807 r
.49974 .5911 m .49338 .59313 L .49669 .61313 L p F P
0 0 0 r
s
.83 .24 .1 r
.4914 .60119 m
.49862 .608 L
s
.23 .33 .662 r
.38367 .5254 m .36779 .53097 L .38415 .55261 L p F P
0 0 0 r
s
.216 .308 .619 r
.36779 .53097 m .38367 .5254 L .37238 .50243 L p F P
0 0 0 r
s
.265 .39 .773 r
.45576 .60517 m .46198 .60318 L .44386 .58534 L p F P
0 0 0 r
s
.24 .35 .67 r
.45489 .60447 m
.45527 .60435 L
s
.265 .39 .773 r
.44386 .58534 m .43474 .58832 L .45576 .60517 L p F P
0 0 0 r
s
1 .312 .132 r
.52973 .59555 m .52615 .59205 L .51308 .6126 L p F P
0 0 0 r
s
1 .312 .132 r
.51126 .61087 m .51308 .6126 L .52615 .59205 L p F P
0 0 0 r
s
.24 .35 .67 r
.5156 .61223 m
.5194 .61104 L
s
.83 .24 .1 r
.40408 .21618 m
.37837 .18565 L
s
.40408 .21618 m
.43008 .2142 L
s
.2 .282 .57 r
.37238 .50243 m .38992 .49613 L .38314 .4728 L p F P
0 0 0 r
s
.2 .282 .57 r
.40193 .46591 m .38314 .4728 L .38992 .49613 L p F P
0 0 0 r
s
.276 .409 .807 r
.49987 .61214 m .50305 .61114 L .50611 .58906 L p F P
0 0 0 r
s
.276 .409 .807 r
.50611 .58906 m .49974 .5911 L .49987 .61214 L p F P
0 0 0 r
s
.83 .24 .1 r
.49862 .608 m
.50081 .61007 L
s
.216 .308 .619 r
.38992 .49613 m .37238 .50243 L .38367 .5254 L p F P
0 0 0 r
s
.24 .35 .67 r
.7857 .5722 m
.74208 .5853 L
s
.74208 .5853 m
.73087 .58176 L
s
.83 .24 .1 r
.35064 .19352 m
.32244 .20636 L
s
.09 .111 .237 r
.49916 .36611 m .51953 .35825 L .51856 .34446 L p F P
0 0 0 r
s
.09 .111 .237 r
.53814 .33684 m .51856 .34446 L .51953 .35825 L p F P
0 0 0 r
s
.24 .35 .67 r
.63098 .59772 m
.58914 .61054 L
s
.57319 .59424 m
.58914 .61054 L
s
.254 .371 .738 r
.42568 .59129 m .43474 .58832 L .41533 .56901 L p F P
0 0 0 r
s
.254 .371 .738 r
.41533 .56901 m .40364 .57292 L .42568 .59129 L p F P
0 0 0 r
s
.83 .24 .1 r
.38336 .58859 m
.40901 .59153 L
s
.276 .409 .807 r
.50305 .61114 m .50624 .61014 L .51251 .58701 L p F P
0 0 0 r
s
.276 .409 .807 r
.51251 .58701 m .50611 .58906 L .50305 .61114 L p F P
0 0 0 r
s
1 .312 .132 r
.52615 .59205 m .52255 .58851 L .51126 .61087 L p F P
0 0 0 r
s
1 .312 .132 r
.50944 .60913 m .51126 .61087 L .52255 .58851 L p F P
0 0 0 r
s
.265 .39 .773 r
.46198 .60318 m .46821 .60119 L .45302 .58234 L p F P
0 0 0 r
s
.83 .24 .1 r
.46198 .61054 m
.4914 .60119 L
s
.24 .35 .67 r
.46122 .60244 m
.46161 .60232 L
s
.265 .39 .773 r
.45302 .58234 m .44386 .58534 L .46198 .60318 L p F P
0 0 0 r
s
.158 .215 .442 r
.41846 .43592 m .43827 .42851 L .43805 .4074 L p F P
0 0 0 r
s
.158 .215 .442 r
.45817 .39975 m .43805 .4074 L .43827 .42851 L p F P
0 0 0 r
s
.24 .35 .67 r
.45699 .40145 m
.45862 .40083 L
s
.242 .351 .701 r
.39813 .54782 m .38415 .55261 L .40364 .57292 L p F P
0 0 0 r
s
.23 .33 .662 r
.38415 .55261 m .39813 .54782 L .38367 .5254 L p F P
0 0 0 r
s
1 .3 .122 r
.61328 .47047 m .6031 .45843 L .59705 .48287 L p F P
0 0 0 r
s
1 .3 .122 r
.59705 .48287 m .60669 .49397 L .61328 .47047 L p F P
0 0 0 r
s
.276 .409 .807 r
.50624 .61014 m .50944 .60913 L .51893 .58496 L p F P
0 0 0 r
s
.276 .409 .807 r
.51893 .58496 m .51251 .58701 L .50624 .61014 L p F P
0 0 0 r
s
.83 .24 .1 r
.52107 .28689 m
.49773 .25776 L
s
.52107 .28689 m
.53639 .30235 L
s
1 .316 .133 r
.55946 .58949 m .55437 .58433 L .53681 .60251 L p F P
0 0 0 r
s
1 .316 .133 r
.53328 .59904 m .53681 .60251 L .55437 .58433 L p F P
0 0 0 r
s
1 .316 .13 r
.60591 .52759 m .59719 .51784 L .58504 .54134 L p F P
0 0 0 r
s
.83 .24 .1 r
.60536 .52795 m
.60556 .52818 L
s
1 .316 .13 r
.58504 .54134 m .59276 .54971 L .60591 .52759 L p F P
0 0 0 r
s
.242 .351 .701 r
.40364 .57292 m .41533 .56901 L .39813 .54782 L p F P
0 0 0 r
s
.24 .35 .67 r
.40376 .55476 m
.40477 .55441 L
s
.40477 .55441 m
.40657 .55822 L
s
.127 .167 .35 r
.45817 .39975 m .47853 .392 L .47903 .37387 L p F P
0 0 0 r
s
.24 .35 .67 r
.45862 .40083 m
.45875 .39952 L
s
.127 .167 .35 r
.49916 .36611 m .47903 .37387 L .47853 .392 L p F P
0 0 0 r
s
.641 .167 .062 r
.56857 .34243 m .55794 .32912 L .56101 .34227 L p F P
0 0 0 r
s
.641 .167 .062 r
.56101 .34227 m .57217 .35613 L .56857 .34243 L p F P
0 0 0 r
s
1 .319 .133 r
.55437 .58433 m .55946 .58949 L .57712 .57055 L p F P
0 0 0 r
s
1 .312 .132 r
.52255 .58851 m .51893 .58496 L .50944 .60913 L p F P
0 0 0 r
s
.24 .35 .67 r
.5194 .61104 m
.5319 .60714 L
s
.83 .24 .1 r
.35729 .56583 m
.33545 .55711 L
s
.33545 .55711 m
.30823 .53356 L
s
.265 .39 .773 r
.46821 .60119 m .47447 .59919 L .46224 .57933 L p F P
0 0 0 r
s
.24 .35 .67 r
.46758 .60041 m
.46796 .60028 L
s
.47396 .59836 m
.47475 .59811 L
s
.265 .39 .773 r
.46224 .57933 m .45302 .58234 L .46821 .60119 L p F P
0 0 0 r
s
.83 .24 .1 r
.2075 .32191 m
.19544 .3496 L
s
.254 .371 .738 r
.43474 .58832 m .44386 .58534 L .4271 .56508 L p F P
0 0 0 r
s
.83 .24 .1 r
.43744 .58814 m
.46041 .60911 L
s
.46041 .60911 m
.46198 .61054 L
s
.254 .371 .738 r
.4271 .56508 m .41533 .56901 L .43474 .58832 L p F P
0 0 0 r
s
.24 .35 .67 r
.6299 .29548 m
.63602 .28451 L
s
.67854 .26777 m
.63602 .28451 L
s
.8377 .55592 m
.83037 .55878 L
s
.23 .33 .662 r
.39971 .51977 m .38367 .5254 L .39813 .54782 L p F P
0 0 0 r
s
.216 .308 .619 r
.38367 .5254 m .39971 .51977 L .38992 .49613 L p F P
0 0 0 r
s
1 .318 .132 r
.59276 .54971 m .58504 .54134 L .57062 .56373 L p F P
0 0 0 r
s
1 .318 .132 r
.57062 .56373 m .57712 .57055 L .59276 .54971 L p F P
0 0 0 r
s
.181 .252 .513 r
.40193 .46591 m .42094 .45894 L .41846 .43592 L p F P
0 0 0 r
s
.181 .252 .513 r
.43827 .42851 m .41846 .43592 L .42094 .45894 L p F P
0 0 0 r
s
1 .319 .133 r
.57712 .57055 m .57062 .56373 L .55437 .58433 L p F P
0 0 0 r
s
.83 .24 .1 r
.18856 .37662 m
.21827 .40341 L
s
.21748 .42855 m
.21827 .40341 L
s
1 .284 .114 r
.60633 .43539 m .59565 .42249 L .59271 .44616 L p F P
0 0 0 r
s
1 .284 .114 r
.59271 .44616 m .6031 .45843 L .60633 .43539 L p F P
0 0 0 r
s
.265 .39 .773 r
.47447 .59919 m .48075 .59718 L .47151 .5763 L p F P
0 0 0 r
s
.265 .39 .773 r
.47151 .5763 m .46224 .57933 L .47447 .59919 L p F P
0 0 0 r
s
1 .316 .133 r
.55437 .58433 m .54923 .57912 L .53328 .59904 L p F P
0 0 0 r
s
1 .316 .133 r
.52973 .59555 m .53328 .59904 L .54923 .57912 L p F P
0 0 0 r
s
.24 .35 .67 r
.52323 .59559 m
.5319 .60714 L
s
.52148 .59325 m
.52323 .59559 L
s
.39872 .53742 m
.40477 .55441 L
s
.216 .308 .619 r
.40765 .48976 m .38992 .49613 L .39971 .51977 L p F P
0 0 0 r
s
.2 .282 .57 r
.38992 .49613 m .40765 .48976 L .40193 .46591 L p F P
0 0 0 r
s
.2 .282 .57 r
.42094 .45894 m .40193 .46591 L .40765 .48976 L p F P
0 0 0 r
s
.813 .22 .084 r
.58309 .36972 m .57217 .35613 L .57389 .3741 L p F P
0 0 0 r
s
.813 .22 .084 r
.57389 .3741 m .58506 .38782 L .58309 .36972 L p F P
0 0 0 r
s
.242 .351 .701 r
.41533 .56901 m .4271 .56508 L .41223 .54299 L p F P
0 0 0 r
s
.242 .351 .701 r
.41223 .54299 m .39813 .54782 L .41533 .56901 L p F P
0 0 0 r
s
.23 .33 .662 r
.39813 .54782 m .41223 .54299 L .39971 .51977 L p F P
0 0 0 r
s
.939 .259 .102 r
.596 .40125 m .58506 .38782 L .58475 .40933 L p F P
0 0 0 r
s
.83 .24 .1 r
.59479 .40212 m
.59496 .40232 L
s
.939 .259 .102 r
.58475 .40933 m .59565 .42249 L .596 .40125 L p F P
0 0 0 r
s
.254 .371 .738 r
.44386 .58534 m .45302 .58234 L .43895 .56111 L p F P
0 0 0 r
s
.254 .371 .738 r
.43895 .56111 m .4271 .56508 L .44386 .58534 L p F P
0 0 0 r
s
.09 .111 .237 r
.51953 .35825 m .54015 .35031 L .53814 .33684 L p F P
0 0 0 r
s
.09 .111 .237 r
.55794 .32912 m .53814 .33684 L .54015 .35031 L p F P
0 0 0 r
s
.265 .39 .773 r
.48075 .59718 m .48706 .59516 L .48082 .57326 L p F P
0 0 0 r
s
.24 .35 .67 r
.48037 .59631 m
.48075 .59619 L
s
.265 .39 .773 r
.48082 .57326 m .47151 .5763 L .48075 .59718 L p F P
0 0 0 r
s
.83 .24 .1 r
.47791 .248 m
.45354 .2179 L
s
.47791 .248 m
.49773 .25776 L
s
1 .31 .127 r
.60669 .49397 m .59705 .48287 L .58833 .50793 L p F P
0 0 0 r
s
1 .31 .127 r
.58833 .50793 m .59719 .51784 L .60669 .49397 L p F P
0 0 0 r
s
.24 .35 .67 r
.73087 .58176 m
.68758 .59485 L
s
.68758 .59485 m
.67383 .58459 L
s
1 .319 .133 r
.54923 .57912 m .55437 .58433 L .57062 .56373 L p F P
0 0 0 r
s
.158 .215 .442 r
.43827 .42851 m .45832 .42102 L .45817 .39975 L p F P
0 0 0 r
s
.158 .215 .442 r
.47853 .392 m .45817 .39975 L .45832 .42102 L p F P
0 0 0 r
s
.24 .35 .67 r
.72208 .25064 m
.72919 .24707 L
s
.83 .24 .1 r
.30823 .53356 m
.29131 .51954 L
s
.29131 .51954 m
.26303 .49508 L
s
.127 .167 .35 r
.47853 .392 m .49914 .38417 L .49916 .36611 L p F P
0 0 0 r
s
.127 .167 .35 r
.51953 .35825 m .49916 .36611 L .49914 .38417 L p F P
0 0 0 r
s
1 .316 .133 r
.54923 .57912 m .54404 .57386 L .52973 .59555 L p F P
0 0 0 r
s
1 .316 .133 r
.52615 .59205 m .52973 .59555 L .54404 .57386 L p F P
0 0 0 r
s
.24 .35 .67 r
.5319 .60714 m
.57319 .59424 L
s
.265 .39 .773 r
.48706 .59516 m .49338 .59313 L .49019 .57019 L p F P
0 0 0 r
s
.24 .35 .67 r
.4868 .59425 m
.48719 .59413 L
s
.265 .39 .773 r
.49019 .57019 m .48082 .57326 L .48706 .59516 L p F P
0 0 0 r
s
.23 .33 .662 r
.4159 .51409 m .39971 .51977 L .41223 .54299 L p F P
0 0 0 r
s
.216 .308 .619 r
.39971 .51977 m .4159 .51409 L .40765 .48976 L p F P
0 0 0 r
s
.83 .24 .1 r
.37837 .18565 m
.35064 .19352 L
s
.254 .371 .738 r
.45302 .58234 m .46224 .57933 L .45089 .55712 L p F P
0 0 0 r
s
.254 .371 .738 r
.45089 .55712 m .43895 .56111 L .45302 .58234 L p F P
0 0 0 r
s
.242 .351 .701 r
.4271 .56508 m .43895 .56111 L .42645 .53812 L p F P
0 0 0 r
s
.242 .351 .701 r
.42645 .53812 m .41223 .54299 L .4271 .56508 L p F P
0 0 0 r
s
.83 .24 .1 r
.4914 .60119 m
.50676 .59315 L
s
.50676 .59315 m
.50986 .59152 L
s
.23 .33 .662 r
.41223 .54299 m .42645 .53812 L .4159 .51409 L p F P
0 0 0 r
s
.83 .24 .1 r
.43744 .58814 m
.40901 .59153 L
s
.40901 .59153 m
.38313 .56852 L
s
.181 .252 .513 r
.42094 .45894 m .44016 .45189 L .43827 .42851 L p F P
0 0 0 r
s
.181 .252 .513 r
.45832 .42102 m .43827 .42851 L .44016 .45189 L p F P
0 0 0 r
s
1 .316 .13 r
.59719 .51784 m .58833 .50793 L .57721 .53285 L p F P
0 0 0 r
s
.83 .24 .1 r
.59667 .51824 m
.59687 .51847 L
s
1 .316 .13 r
.57721 .53285 m .58504 .54134 L .59719 .51784 L p F P
0 0 0 r
s
1 .318 .132 r
.56403 .55683 m .57062 .56373 L .58504 .54134 L p F P
0 0 0 r
s
1 .319 .133 r
.57062 .56373 m .56403 .55683 L .54923 .57912 L p F P
0 0 0 r
s
.24 .35 .67 r
.58378 .32975 m
.58767 .312 L
s
.6299 .29548 m
.58767 .312 L
s
.265 .39 .773 r
.49338 .59313 m .49974 .5911 L .49961 .56712 L p F P
0 0 0 r
s
.24 .35 .67 r
.49325 .59219 m
.49364 .59206 L
s
.265 .39 .773 r
.49961 .56712 m .49019 .57019 L .49338 .59313 L p F P
0 0 0 r
s
.216 .308 .619 r
.42558 .48333 m .40765 .48976 L .4159 .51409 L p F P
0 0 0 r
s
.2 .282 .57 r
.40765 .48976 m .42558 .48333 L .42094 .45894 L p F P
0 0 0 r
s
.2 .282 .57 r
.44016 .45189 m .42094 .45894 L .42558 .48333 L p F P
0 0 0 r
s
1 .318 .132 r
.58504 .54134 m .57721 .53285 L .56403 .55683 L p F P
0 0 0 r
s
1 .316 .133 r
.54404 .57386 m .5388 .56855 L .52615 .59205 L p F P
0 0 0 r
s
1 .316 .133 r
.52255 .58851 m .52615 .59205 L .5388 .56855 L p F P
0 0 0 r
s
1 .3 .122 r
.6031 .45843 m .59271 .44616 L .58722 .47155 L p F P
0 0 0 r
s
1 .3 .122 r
.58722 .47155 m .59705 .48287 L .6031 .45843 L p F P
0 0 0 r
s
.254 .371 .738 r
.46224 .57933 m .47151 .5763 L .46291 .55309 L p F P
0 0 0 r
s
.83 .24 .1 r
.46726 .5784 m
.48986 .59973 L
s
.48986 .59973 m
.4914 .60119 L
s
.254 .371 .738 r
.46291 .55309 m .45089 .55712 L .46224 .57933 L p F P
0 0 0 r
s
.24 .35 .67 r
.83037 .55878 m
.7857 .5722 L
s
.7857 .5722 m
.7752 .56836 L
s
1 .319 .133 r
.54404 .57386 m .54923 .57912 L .56403 .55683 L p F P
0 0 0 r
s
.09 .111 .237 r
.54015 .35031 m .56101 .34227 L .55794 .32912 L p F P
0 0 0 r
s
.83 .24 .1 r
.55747 .33662 m
.5589 .3384 L
s
.54636 .3228 m
.55747 .33662 L
s
.265 .39 .773 r
.49974 .5911 m .50611 .58906 L .50908 .56402 L p F P
0 0 0 r
s
.24 .35 .67 r
.49973 .59011 m
.50012 .58999 L
s
.265 .39 .773 r
.50908 .56402 m .49961 .56712 L .49974 .5911 L p F P
0 0 0 r
s
.24 .35 .67 r
.67383 .58459 m
.63098 .59772 L
s
.63098 .59772 m
.61549 .58103 L
s
.242 .351 .701 r
.43895 .56111 m .45089 .55712 L .44078 .53321 L p F P
0 0 0 r
s
.242 .351 .701 r
.44078 .53321 m .42645 .53812 L .43895 .56111 L p F P
0 0 0 r
s
.83 .24 .1 r
.43008 .2142 m
.40456 .18321 L
s
.43008 .2142 m
.45354 .2179 L
s
.26303 .49508 m
.2518 .47645 L
s
.2518 .47645 m
.22255 .45096 L
s
.19544 .3496 m
.18856 .37662 L
s
.158 .215 .442 r
.45832 .42102 m .47861 .41343 L .47853 .392 L p F P
0 0 0 r
s
.158 .215 .442 r
.49914 .38417 m .47853 .392 L .47861 .41343 L p F P
0 0 0 r
s
.24 .35 .67 r
.49792 .38591 m
.49915 .38544 L
s
.23 .33 .662 r
.43226 .50835 m .4159 .51409 L .42645 .53812 L p F P
0 0 0 r
s
.216 .308 .619 r
.4159 .51409 m .43226 .50835 L .42558 .48333 L p F P
0 0 0 r
s
.127 .167 .35 r
.49914 .38417 m .52 .37624 L .51953 .35825 L p F P
0 0 0 r
s
.24 .35 .67 r
.49915 .38544 m
.49925 .38413 L
s
.127 .167 .35 r
.54015 .35031 m .51953 .35825 L .52 .37624 L p F P
0 0 0 r
s
.265 .39 .773 r
.50611 .58906 m .51251 .58701 L .5186 .56091 L p F P
0 0 0 r
s
.24 .35 .67 r
.50623 .58803 m
.50662 .5879 L
s
.265 .39 .773 r
.5186 .56091 m .50908 .56402 L .50611 .58906 L p F P
0 0 0 r
s
.24 .35 .67 r
.51537 .5851 m
.51597 .58591 L
s
.51276 .58594 m
.51537 .5851 L
s
.23 .33 .662 r
.42645 .53812 m .44078 .53321 L .43226 .50835 L p F P
0 0 0 r
s
.254 .371 .738 r
.47151 .5763 m .48082 .57326 L .47502 .54904 L p F P
0 0 0 r
s
.254 .371 .738 r
.47502 .54904 m .46291 .55309 L .47151 .5763 L p F P
0 0 0 r
s
1 .316 .133 r
.5388 .56855 m .53352 .56319 L .52255 .58851 L p F P
0 0 0 r
s
1 .316 .133 r
.51893 .58496 m .52255 .58851 L .53352 .56319 L p F P
0 0 0 r
s
1 .284 .114 r
.59565 .42249 m .58475 .40933 L .58212 .43364 L p F P
0 0 0 r
s
1 .284 .114 r
.58212 .43364 m .59271 .44616 L .59565 .42249 L p F P
0 0 0 r
s
.24 .35 .67 r
.67316 .27856 m
.67854 .26777 L
s
.72208 .25064 m
.67854 .26777 L
s
.5606 .33871 m
.58378 .32975 L
s
.813 .22 .084 r
.57217 .35613 m .56101 .34227 L .56248 .36009 L p F P
0 0 0 r
s
.813 .22 .084 r
.56248 .36009 m .57389 .3741 L .57217 .35613 L p F P
0 0 0 r
s
.83 .24 .1 r
.57257 .37247 m
.57307 .37549 L
s
.24 .35 .67 r
.61549 .58103 m
.57319 .59424 L
s
.216 .308 .619 r
.44369 .47683 m .42558 .48333 L .43226 .50835 L p F P
0 0 0 r
s
.24 .35 .67 r
.43231 .5085 m
.433 .50826 L
s
.42627 .48183 m
.42656 .48297 L
s
.43271 .50711 m
.433 .50826 L
s
.2 .282 .57 r
.42558 .48333 m .44369 .47683 L .44016 .45189 L p F P
0 0 0 r
s
.265 .39 .773 r
.51251 .58701 m .51893 .58496 L .52818 .55777 L p F P
0 0 0 r
s
.265 .39 .773 r
.52818 .55777 m .5186 .56091 L .51251 .58701 L p F P
0 0 0 r
s
.83 .24 .1 r
.5152 .58057 m
.51658 .58192 L
s
.51912 .58442 m
.51923 .58452 L
s
.24 .35 .67 r
.51931 .58384 m
.51978 .58369 L
s
.181 .252 .513 r
.44016 .45189 m .4596 .44476 L .45832 .42102 L p F P
0 0 0 r
s
.181 .252 .513 r
.47861 .41343 m .45832 .42102 L .4596 .44476 L p F P
0 0 0 r
s
.242 .351 .701 r
.45089 .55712 m .46291 .55309 L .45525 .52825 L p F P
0 0 0 r
s
.242 .351 .701 r
.45525 .52825 m .44078 .53321 L .45089 .55712 L p F P
0 0 0 r
s
1 .31 .127 r
.59705 .48287 m .58722 .47155 L .57932 .49786 L p F P
0 0 0 r
s
1 .31 .127 r
.57932 .49786 m .58833 .50793 L .59705 .48287 L p F P
0 0 0 r
s
.939 .259 .102 r
.58506 .38782 m .57389 .3741 L .57362 .39588 L p F P
0 0 0 r
s
.83 .24 .1 r
.57307 .37549 m
.57386 .37645 L
s
.58383 .38868 m
.58503 .39014 L
s
.939 .259 .102 r
.57362 .39588 m .58475 .40933 L .58506 .38782 L p F P
0 0 0 r
s
1 .318 .132 r
.55737 .54984 m .56403 .55683 L .57721 .53285 L p F P
0 0 0 r
s
1 .319 .133 r
.56403 .55683 m .55737 .54984 L .54404 .57386 L p F P
0 0 0 r
s
1 .319 .133 r
.5388 .56855 m .54404 .57386 L .55737 .54984 L p F P
0 0 0 r
s
.24 .35 .67 r
.55697 .57178 m
.57319 .59424 L
s
.2 .282 .57 r
.4596 .44476 m .44016 .45189 L .44369 .47683 L p F P
0 0 0 r
s
.24 .35 .67 r
.433 .50826 m
.44176 .53287 L
s
.254 .371 .738 r
.48082 .57326 m .49019 .57019 L .48721 .54496 L p F P
0 0 0 r
s
.254 .371 .738 r
.48721 .54496 m .47502 .54904 L .48082 .57326 L p F P
0 0 0 r
s
.83 .24 .1 r
.53639 .30235 m
.513 .27307 L
s
.53639 .30235 m
.54636 .3228 L
s
.38313 .56852 m
.35729 .56583 L
s
.35729 .56583 m
.33011 .54211 L
s
1 .316 .133 r
.53352 .56319 m .52818 .55777 L .51893 .58496 L p F P
0 0 0 r
s
.24 .35 .67 r
.5283 .58096 m
.55697 .57178 L
s
.52495 .58204 m
.5283 .58096 L
s
.52252 .58281 m
.52495 .58204 L
s
.83 .24 .1 r
.22255 .45096 m
.21748 .42855 L
s
.21748 .42855 m
.18734 .40191 L
s
.23 .33 .662 r
.44877 .50255 m .43226 .50835 L .44078 .53321 L p F P
0 0 0 r
s
.216 .308 .619 r
.43226 .50835 m .44877 .50255 L .44369 .47683 L p F P
0 0 0 r
s
.23 .33 .662 r
.44078 .53321 m .45525 .52825 L .44877 .50255 L p F P
0 0 0 r
s
1 .316 .13 r
.58833 .50793 m .57932 .49786 L .56926 .52424 L p F P
0 0 0 r
s
.83 .24 .1 r
.58783 .50837 m
.58804 .5086 L
s
1 .316 .13 r
.56926 .52424 m .57721 .53285 L .58833 .50793 L p F P
0 0 0 r
s
1 .318 .132 r
.57721 .53285 m .56926 .52424 L .55737 .54984 L p F P
0 0 0 r
s
.24 .35 .67 r
.7752 .56836 m
.73087 .58176 L
s
.73087 .58176 m
.71773 .57115 L
s
.158 .215 .442 r
.47861 .41343 m .49914 .40575 L .49914 .38417 L p F P
0 0 0 r
s
.158 .215 .442 r
.52 .37624 m .49914 .38417 L .49914 .40575 L p F P
0 0 0 r
s
.242 .351 .701 r
.46291 .55309 m .47502 .54904 L .46983 .52325 L p F P
0 0 0 r
s
.242 .351 .701 r
.46983 .52325 m .45525 .52825 L .46291 .55309 L p F P
0 0 0 r
s
.254 .371 .738 r
.49019 .57019 m .49961 .56712 L .49949 .54086 L p F P
0 0 0 r
s
.83 .24 .1 r
.5133 .57871 m
.5152 .58057 L
s
.254 .371 .738 r
.49949 .54086 m .48721 .54496 L .49019 .57019 L p F P
0 0 0 r
s
.127 .167 .35 r
.52 .37624 m .54111 .36821 L .54015 .35031 L p F P
0 0 0 r
s
.127 .167 .35 r
.56101 .34227 m .54015 .35031 L .54111 .36821 L p F P
0 0 0 r
s
.83 .24 .1 r
.40456 .18321 m
.37837 .18565 L
s
.216 .308 .619 r
.462 .47025 m .44369 .47683 L .44877 .50255 L p F P
0 0 0 r
s
.2 .282 .57 r
.44369 .47683 m .462 .47025 L .4596 .44476 L p F P
0 0 0 r
s
1 .319 .133 r
.55737 .54984 m .55062 .54277 L .5388 .56855 L p F P
0 0 0 r
s
1 .319 .133 r
.53352 .56319 m .5388 .56855 L .55062 .54277 L p F P
0 0 0 r
s
.83 .24 .1 r
.46726 .5784 m
.43744 .58814 L
s
.43744 .58814 m
.41185 .5648 L
s
1 .3 .122 r
.59271 .44616 m .58212 .43364 L .57721 .46002 L p F P
0 0 0 r
s
1 .3 .122 r
.57721 .46002 m .58722 .47155 L .59271 .44616 L p F P
0 0 0 r
s
.181 .252 .513 r
.4596 .44476 m .47927 .43754 L .47861 .41343 L p F P
0 0 0 r
s
.181 .252 .513 r
.49914 .40575 m .47861 .41343 L .47927 .43754 L p F P
0 0 0 r
s
.24 .35 .67 r
.6267 .31316 m
.6299 .29548 L
s
.67316 .27856 m
.6299 .29548 L
s
.83 .24 .1 r
.49773 .25776 m
.47339 .22739 L
s
.49773 .25776 m
.513 .27307 L
s
.254 .371 .738 r
.49961 .56712 m .50908 .56402 L .51186 .53672 L p F P
0 0 0 r
s
.254 .371 .738 r
.51186 .53672 m .49949 .54086 L .49961 .56712 L p F P
0 0 0 r
s
.2 .282 .57 r
.47927 .43754 m .4596 .44476 L .462 .47025 L p F P
0 0 0 r
s
1 .318 .132 r
.55062 .54277 m .55737 .54984 L .56926 .52424 L p F P
0 0 0 r
s
.23 .33 .662 r
.45525 .52825 m .46983 .52325 L .46544 .4967 L p F P
0 0 0 r
s
.23 .33 .662 r
.46544 .4967 m .44877 .50255 L .45525 .52825 L p F P
0 0 0 r
s
.216 .308 .619 r
.44877 .50255 m .46544 .4967 L .462 .47025 L p F P
0 0 0 r
s
.242 .351 .701 r
.47502 .54904 m .48721 .54496 L .48454 .51821 L p F P
0 0 0 r
s
.242 .351 .701 r
.48454 .51821 m .46983 .52325 L .47502 .54904 L p F P
0 0 0 r
s
.83 .24 .1 r
.33011 .54211 m
.30823 .53356 L
s
.30823 .53356 m
.27985 .50901 L
s
.24 .35 .67 r
.83037 .55878 m
.82062 .55462 L
s
.71773 .57115 m
.67383 .58459 L
s
.67383 .58459 m
.65881 .5675 L
s
.83 .24 .1 r
.18856 .37662 m
.18734 .40191 L
s
1 .284 .114 r
.58475 .40933 m .57362 .39588 L .57131 .42087 L p F P
0 0 0 r
s
1 .284 .114 r
.57131 .42087 m .58212 .43364 L .58475 .40933 L p F P
0 0 0 r
s
.158 .215 .442 r
.49914 .40575 m .51993 .39798 L .52 .37624 L p F P
0 0 0 r
s
.158 .215 .442 r
.54111 .36821 m .52 .37624 L .51993 .39798 L p F P
0 0 0 r
s
.24 .35 .67 r
.53985 .36998 m
.54065 .36967 L
s
.54065 .36967 m
.5407 .36879 L
s
.254 .371 .738 r
.50908 .56402 m .5186 .56091 L .52432 .53255 L p F P
0 0 0 r
s
.254 .371 .738 r
.52432 .53255 m .51186 .53672 L .50908 .56402 L p F P
0 0 0 r
s
.83 .24 .1 r
.49695 .56264 m
.5133 .57871 L
s
1 .31 .127 r
.58722 .47155 m .57721 .46002 L .57016 .4876 L p F P
0 0 0 r
s
1 .31 .127 r
.57016 .4876 m .57932 .49786 L .58722 .47155 L p F P
0 0 0 r
s
.127 .167 .35 r
.54111 .36821 m .56248 .36009 L .56101 .34227 L p F P
0 0 0 r
s
.83 .24 .1 r
.55026 .34751 m
.55893 .35815 L
s
1 .319 .133 r
.55062 .54277 m .54378 .5356 L .53352 .56319 L p F P
0 0 0 r
s
1 .319 .133 r
.52818 .55777 m .53352 .56319 L .54378 .5356 L p F P
0 0 0 r
s
1 .316 .13 r
.56119 .51549 m .56926 .52424 L .57932 .49786 L p F P
0 0 0 r
s
1 .318 .132 r
.56926 .52424 m .56119 .51549 L .55062 .54277 L p F P
0 0 0 r
s
.216 .308 .619 r
.48051 .46361 m .462 .47025 L .46544 .4967 L p F P
0 0 0 r
s
.24 .35 .67 r
.46569 .46326 m
.46704 .46844 L
s
.2 .282 .57 r
.462 .47025 m .48051 .46361 L .47927 .43754 L p F P
0 0 0 r
s
.242 .351 .701 r
.48721 .54496 m .49949 .54086 L .49938 .51313 L p F P
0 0 0 r
s
.242 .351 .701 r
.49938 .51313 m .48454 .51821 L .48721 .54496 L p F P
0 0 0 r
s
.939 .259 .102 r
.57389 .3741 m .56248 .36009 L .56225 .38215 L p F P
0 0 0 r
s
.83 .24 .1 r
.57264 .37496 m
.57307 .37549 L
s
.939 .259 .102 r
.56225 .38215 m .57362 .39588 L .57389 .3741 L p F P
0 0 0 r
s
.23 .33 .662 r
.46983 .52325 m .48454 .51821 L .48228 .49079 L p F P
0 0 0 r
s
.23 .33 .662 r
.48228 .49079 m .46544 .4967 L .46983 .52325 L p F P
0 0 0 r
s
1 .316 .13 r
.57932 .49786 m .57016 .4876 L .56119 .51549 L p F P
0 0 0 r
s
.24 .35 .67 r
.71749 .26123 m
.72208 .25064 L
s
.83 .24 .1 r
.45354 .2179 m
.42814 .18652 L
s
.45354 .2179 m
.47339 .22739 L
s
.24 .35 .67 r
.58317 .35352 m
.58378 .32975 L
s
.6267 .31316 m
.58378 .32975 L
s
.65881 .5675 m
.61549 .58103 L
s
.61549 .58103 m
.59959 .55814 L
s
.55697 .57178 m
.59959 .55814 L
s
.181 .252 .513 r
.47927 .43754 m .49917 .43024 L .49914 .40575 L p F P
0 0 0 r
s
.181 .252 .513 r
.51993 .39798 m .49914 .40575 L .49917 .43024 L p F P
0 0 0 r
s
.254 .371 .738 r
.5186 .56091 m .52818 .55777 L .53686 .52835 L p F P
0 0 0 r
s
.254 .371 .738 r
.53686 .52835 m .52432 .53255 L .5186 .56091 L p F P
0 0 0 r
s
.83 .24 .1 r
.52492 .54161 m
.52747 .54422 L
s
.216 .308 .619 r
.46544 .4967 m .48228 .49079 L .48051 .46361 L p F P
0 0 0 r
s
.2 .282 .57 r
.49917 .43024 m .47927 .43754 L .48051 .46361 L p F P
0 0 0 r
s
.83 .24 .1 r
.27985 .50901 m
.26303 .49508 L
s
.26303 .49508 m
.23354 .46958 L
s
1 .318 .132 r
.54378 .5356 m .55062 .54277 L .56119 .51549 L p F P
0 0 0 r
s
.83 .24 .1 r
.46726 .5784 m
.49695 .56264 L
s
.46726 .5784 m
.44208 .55464 L
s
.24 .35 .67 r
.56329 .36108 m
.58317 .35352 L
s
.242 .351 .701 r
.49949 .54086 m .51186 .53672 L .51435 .508 L p F P
0 0 0 r
s
.242 .351 .701 r
.51435 .508 m .49938 .51313 L .49949 .54086 L p F P
0 0 0 r
s
.83 .24 .1 r
.41185 .5648 m
.38313 .56852 L
s
.38313 .56852 m
.35614 .54453 L
s
1 .319 .133 r
.54378 .5356 m .53686 .52835 L .52818 .55777 L p F P
0 0 0 r
s
.24 .35 .67 r
.53287 .54696 m
.53679 .54566 L
s
.53679 .54566 m
.54134 .54416 L
s
.83 .24 .1 r
.52747 .54422 m
.52965 .54646 L
s
.24 .35 .67 r
.54134 .54416 m
.55697 .57178 L
s
.82062 .55462 m
.7752 .56836 L
s
.7752 .56836 m
.7627 .55737 L
s
.23 .33 .662 r
.48454 .51821 m .49938 .51313 L .49929 .48483 L p F P
0 0 0 r
s
.23 .33 .662 r
.49929 .48483 m .48228 .49079 L .48454 .51821 L p F P
0 0 0 r
s
.158 .215 .442 r
.51993 .39798 m .54096 .39012 L .54111 .36821 L p F P
0 0 0 r
s
.158 .215 .442 r
.56248 .36009 m .54111 .36821 L .54096 .39012 L p F P
0 0 0 r
s
.24 .35 .67 r
.56121 .36187 m
.56247 .36139 L
s
.83 .24 .1 r
.56156 .36137 m
.56246 .36247 L
s
1 .3 .122 r
.58212 .43364 m .57131 .42087 L .56701 .44826 L p F P
0 0 0 r
s
1 .3 .122 r
.56701 .44826 m .57721 .46002 L .58212 .43364 L p F P
0 0 0 r
s
.216 .308 .619 r
.49922 .45689 m .48051 .46361 L .48228 .49079 L p F P
0 0 0 r
s
.2 .282 .57 r
.48051 .46361 m .49922 .45689 L .49917 .43024 L p F P
0 0 0 r
s
.83 .24 .1 r
.54636 .3228 m
.52282 .2935 L
s
.54636 .3228 m
.55026 .34751 L
s
.216 .308 .619 r
.48228 .49079 m .49929 .48483 L .49922 .45689 L p F P
0 0 0 r
s
.83 .24 .1 r
.42814 .18652 m
.40456 .18321 L
s
.23354 .46958 m
.22255 .45096 L
s
.22255 .45096 m
.19204 .42439 L
s
1 .316 .13 r
.553 .50662 m .56119 .51549 L .57016 .4876 L p F P
0 0 0 r
s
1 .318 .132 r
.56119 .51549 m .553 .50662 L .54378 .5356 L p F P
0 0 0 r
s
.181 .252 .513 r
.49917 .43024 m .5193 .42286 L .51993 .39798 L p F P
0 0 0 r
s
.181 .252 .513 r
.54096 .39012 m .51993 .39798 L .5193 .42286 L p F P
0 0 0 r
s
.242 .351 .701 r
.51186 .53672 m .52432 .53255 L .52945 .50282 L p F P
0 0 0 r
s
.242 .351 .701 r
.52945 .50282 m .51435 .508 L .51186 .53672 L p F P
0 0 0 r
s
.2 .282 .57 r
.5193 .42286 m .49917 .43024 L .49922 .45689 L p F P
0 0 0 r
s
.24 .35 .67 r
.67069 .29616 m
.67316 .27856 L
s
.71749 .26123 m
.67316 .27856 L
s
1 .318 .132 r
.53686 .52835 m .54378 .5356 L .553 .50662 L p F P
0 0 0 r
s
1 .31 .127 r
.57721 .46002 m .56701 .44826 L .56083 .47717 L p F P
0 0 0 r
s
1 .31 .127 r
.56083 .47717 m .57016 .4876 L .57721 .46002 L p F P
0 0 0 r
s
1 .284 .114 r
.57362 .39588 m .56225 .38215 L .56028 .40783 L p F P
0 0 0 r
s
1 .284 .114 r
.56028 .40783 m .57131 .42087 L .57362 .39588 L p F P
0 0 0 r
s
.23 .33 .662 r
.49938 .51313 m .51435 .508 L .51647 .4788 L p F P
0 0 0 r
s
.23 .33 .662 r
.51647 .4788 m .49929 .48483 L .49938 .51313 L p F P
0 0 0 r
s
1 .316 .13 r
.57016 .4876 m .56083 .47717 L .553 .50662 L p F P
0 0 0 r
s
.83 .24 .1 r
.49695 .56264 m
.52492 .54161 L
s
.49695 .56264 m
.47225 .5384 L
s
.24 .35 .67 r
.53792 .53658 m
.54134 .54416 L
s
.5373 .53521 m
.53792 .53658 L
s
.7627 .55737 m
.71773 .57115 L
s
.71773 .57115 m
.7032 .55363 L
s
.158 .215 .442 r
.54096 .39012 m .56225 .38215 L .56248 .36009 L p F P
0 0 0 r
s
.83 .24 .1 r
.55893 .35815 m
.56098 .36066 L
s
.216 .308 .619 r
.51814 .4501 m .49922 .45689 L .49929 .48483 L p F P
0 0 0 r
s
.2 .282 .57 r
.49922 .45689 m .51814 .4501 L .5193 .42286 L p F P
0 0 0 r
s
.242 .351 .701 r
.52432 .53255 m .53686 .52835 L .54468 .49761 L p F P
0 0 0 r
s
.242 .351 .701 r
.54468 .49761 m .52945 .50282 L .52432 .53255 L p F P
0 0 0 r
s
.24 .35 .67 r
.54134 .54416 m
.58414 .53006 L
s
.216 .308 .619 r
.49929 .48483 m .51647 .4788 L .51814 .4501 L p F P
0 0 0 r
s
.83 .24 .1 r
.52492 .54161 m
.53093 .53549 L
s
.53093 .53549 m
.53201 .53438 L
s
.513 .27307 m
.4886 .24253 L
s
.513 .27307 m
.52282 .2935 L
s
.35614 .54453 m
.33011 .54211 L
s
.33011 .54211 m
.30177 .51737 L
s
.50077 .51684 m
.52492 .54161 L
s
.18734 .40191 m
.19204 .42439 L
s
.24 .35 .67 r
.62675 .33698 m
.6267 .31316 L
s
.67069 .29616 m
.6267 .31316 L
s
.7032 .55363 m
.65881 .5675 L
s
.65881 .5675 m
.64326 .54415 L
s
.2 .282 .57 r
.53967 .41539 m .5193 .42286 L .51814 .4501 L p F P
0 0 0 r
s
.181 .252 .513 r
.5193 .42286 m .53967 .41539 L .54096 .39012 L p F P
0 0 0 r
s
.23 .33 .662 r
.51435 .508 m .52945 .50282 L .53382 .47271 L p F P
0 0 0 r
s
.23 .33 .662 r
.53382 .47271 m .51647 .4788 L .51435 .508 L p F P
0 0 0 r
s
.24 .35 .67 r
.64326 .54415 m
.59959 .55814 L
s
.59959 .55814 m
.58414 .53006 L
s
.181 .252 .513 r
.56225 .38215 m .54096 .39012 L .53967 .41539 L p F P
0 0 0 r
s
1 .316 .13 r
.54468 .49761 m .553 .50662 L .56083 .47717 L p F P
0 0 0 r
s
1 .318 .132 r
.553 .50662 m .54468 .49761 L .53686 .52835 L p F P
0 0 0 r
s
.24 .35 .67 r
.5434 .50728 m
.54477 .50681 L
s
.83 .24 .1 r
.54004 .50605 m
.54079 .50686 L
s
1 .3 .122 r
.57131 .42087 m .56028 .40783 L .55661 .43629 L p F P
0 0 0 r
s
1 .3 .122 r
.55661 .43629 m .56701 .44826 L .57131 .42087 L p F P
0 0 0 r
s
.24 .35 .67 r
.56344 .39071 m
.58604 .38232 L
s
.83 .24 .1 r
.44208 .55464 m
.41185 .5648 L
s
.41185 .5648 m
.38516 .54044 L
s
.24 .35 .67 r
.58317 .35352 m
.62675 .33698 L
s
.58604 .38232 m
.58317 .35352 L
s
.216 .308 .619 r
.53726 .44323 m .51814 .4501 L .51647 .4788 L p F P
0 0 0 r
s
.2 .282 .57 r
.51814 .4501 m .53726 .44323 L .53967 .41539 L p F P
0 0 0 r
s
.216 .308 .619 r
.51647 .4788 m .53382 .47271 L .53726 .44323 L p F P
0 0 0 r
s
.24 .35 .67 r
.82062 .55462 m
.80879 .54325 L
s
.83 .24 .1 r
.47339 .22739 m
.44801 .1957 L
s
.47339 .22739 m
.4886 .24253 L
s
.30177 .51737 m
.27985 .50901 L
s
.27985 .50901 m
.25025 .4834 L
s
.23 .33 .662 r
.52945 .50282 m .54468 .49761 L .55134 .46656 L p F P
0 0 0 r
s
.23 .33 .662 r
.55134 .46656 m .53382 .47271 L .52945 .50282 L p F P
0 0 0 r
s
.24 .35 .67 r
.54477 .50681 m
.57001 .49823 L
s
.83 .24 .1 r
.52607 .49109 m
.54004 .50605 L
s
1 .31 .127 r
.55134 .46656 m .56083 .47717 L .56701 .44826 L p F P
0 0 0 r
s
1 .316 .13 r
.56083 .47717 m .55134 .46656 L .54468 .49761 L p F P
0 0 0 r
s
1 .31 .127 r
.56701 .44826 m .55661 .43629 L .55134 .46656 L p F P
0 0 0 r
s
.2 .282 .57 r
.56028 .40783 m .53967 .41539 L .53726 .44323 L p F P
0 0 0 r
s
.24 .35 .67 r
.54474 .40792 m
.5457 .41318 L
s
.181 .252 .513 r
.53967 .41539 m .56028 .40783 L .56225 .38215 L p F P
0 0 0 r
s
.24 .35 .67 r
.56222 .39117 m
.56344 .39071 L
s
.83 .24 .1 r
.54762 .37546 m
.55983 .39008 L
s
.55983 .39008 m
.56048 .39086 L
s
.24 .35 .67 r
.71578 .27873 m
.71749 .26123 L
s
.83 .24 .1 r
.55026 .34751 m
.52645 .31832 L
s
.55026 .34751 m
.54762 .37546 L
s
.216 .308 .619 r
.53382 .47271 m .55134 .46656 L .55661 .43629 L p F P
0 0 0 r
s
.216 .308 .619 r
.55661 .43629 m .53726 .44323 L .53382 .47271 L p F P
0 0 0 r
s
.83 .24 .1 r
.54681 .46252 m
.54968 .46573 L
s
.54968 .46573 m
.54979 .46586 L
s
.24 .35 .67 r
.55276 .46624 m
.55803 .46439 L
s
.55254 .46632 m
.55276 .46624 L
s
.83 .24 .1 r
.54681 .46252 m
.55178 .45271 L
s
.2 .282 .57 r
.53726 .44323 m .55661 .43629 L .56028 .40783 L p F P
0 0 0 r
s
.83 .24 .1 r
.53835 .40532 m
.55671 .42663 L
s
.44801 .1957 m
.42814 .18652 L
s
.24 .35 .67 r
.628 .5156 m
.58414 .53006 L
s
.58414 .53006 m
.57001 .49823 L
s
.80879 .54325 m
.7627 .55737 L
s
.7627 .55737 m
.74871 .53942 L
s
.83 .24 .1 r
.25025 .4834 m
.23354 .46958 L
s
.23354 .46958 m
.20276 .44297 L
s
.24 .35 .67 r
.55672 .45955 m
.55803 .46439 L
s
.55502 .45325 m
.55672 .45955 L
s
.56105 .42605 m
.59233 .41474 L
s
.55855 .42695 m
.56105 .42605 L
s
.83 .24 .1 r
.47225 .5384 m
.44208 .55464 L
s
.44208 .55464 m
.4158 .52984 L
s
.24 .35 .67 r
.67141 .32001 m
.67069 .29616 L
s
.71578 .27873 m
.67069 .29616 L
s
.83 .24 .1 r
.38516 .54044 m
.35614 .54453 L
s
.35614 .54453 m
.32796 .51949 L
s
.24 .35 .67 r
.74871 .53942 m
.7032 .55363 L
s
.7032 .55363 m
.68802 .52982 L
s
.68802 .52982 m
.64326 .54415 L
s
.64326 .54415 m
.628 .5156 L
s
.61391 .4833 m
.57001 .49823 L
s
.55803 .46439 m
.57001 .49823 L
s
.55803 .46439 m
.60179 .44904 L
s
.83 .24 .1 r
.52282 .2935 m
.49824 .26292 L
s
.52282 .2935 m
.52645 .31832 L
s
.24 .35 .67 r
.59233 .41474 m
.58604 .38232 L
s
.63017 .36593 m
.58604 .38232 L
s
.62675 .33698 m
.67141 .32001 L
s
.63017 .36593 m
.62675 .33698 L
s
.83 .24 .1 r
.19204 .42439 m
.20276 .44297 L
s
.54681 .46252 m
.52272 .4356 L
s
.54681 .46252 m
.52607 .49109 L
s
.50077 .51684 m
.47225 .5384 L
s
.47225 .5384 m
.44648 .51309 L
s
.52607 .49109 m
.50142 .46468 L
s
.52607 .49109 m
.50077 .51684 L
s
.54762 .37546 m
.52345 .3465 L
s
.54762 .37546 m
.53835 .40532 L
s
.4886 .24253 m
.46312 .21065 L
s
.4886 .24253 m
.49824 .26292 L
s
.32796 .51949 m
.30177 .51737 L
s
.30177 .51737 m
.27218 .49153 L
s
.50077 .51684 m
.47555 .49099 L
s
.24 .35 .67 r
.67297 .50078 m
.628 .5156 L
s
.628 .5156 m
.61391 .4833 L
s
.80879 .54325 m
.79536 .52485 L
s
.60179 .44904 m
.59233 .41474 L
s
.63691 .39862 m
.59233 .41474 L
s
.83 .24 .1 r
.4158 .52984 m
.38516 .54044 L
s
.38516 .54044 m
.35729 .51501 L
s
.24 .35 .67 r
.71721 .30262 m
.71578 .27873 L
s
.79536 .52485 m
.74871 .53942 L
s
.74871 .53942 m
.73391 .51512 L
s
.73391 .51512 m
.68802 .52982 L
s
.68802 .52982 m
.67297 .50078 L
s
.83 .24 .1 r
.46312 .21065 m
.44801 .1957 L
s
.27218 .49153 m
.25025 .4834 L
s
.25025 .4834 m
.21933 .45665 L
s
.24 .35 .67 r
.65892 .468 m
.61391 .4833 L
s
.61391 .4833 m
.60179 .44904 L
s
.64666 .43329 m
.60179 .44904 L
s
.63691 .39862 m
.63017 .36593 L
s
.67542 .34913 m
.63017 .36593 L
s
.67141 .32001 m
.71721 .30262 L
s
.67542 .34913 m
.67141 .32001 L
s
.83 .24 .1 r
.52645 .31832 m
.50158 .28784 L
s
.52645 .31832 m
.52345 .3465 L
s
.53835 .40532 m
.51371 .37673 L
s
.53835 .40532 m
.52272 .4356 L
s
.20276 .44297 m
.21933 .45665 L
s
.44648 .51309 m
.4158 .52984 L
s
.4158 .52984 m
.38835 .50393 L
s
.35729 .51501 m
.32796 .51949 L
s
.32796 .51949 m
.29854 .49333 L
s
.24 .35 .67 r
.71909 .48558 m
.67297 .50078 L
s
.67297 .50078 m
.65892 .468 L
s
.64666 .43329 m
.63691 .39862 L
s
.68262 .3821 m
.63691 .39862 L
s
.83 .24 .1 r
.49824 .26292 m
.47256 .23097 L
s
.49824 .26292 m
.50158 .28784 L
s
.52272 .4356 m
.49755 .40747 L
s
.52272 .4356 m
.50142 .46468 L
s
.24 .35 .67 r
.79536 .52485 m
.78098 .50005 L
s
.78098 .50005 m
.73391 .51512 L
s
.73391 .51512 m
.71909 .48558 L
s
.70508 .45231 m
.65892 .468 L
s
.65892 .468 m
.64666 .43329 L
s
.69269 .41715 m
.64666 .43329 L
s
.83 .24 .1 r
.47555 .49099 m
.44648 .51309 L
s
.44648 .51309 m
.41955 .48664 L
s
.24 .35 .67 r
.68262 .3821 m
.67542 .34913 L
s
.72183 .3319 m
.67542 .34913 L
s
.72183 .3319 m
.71721 .30262 L
s
.83 .24 .1 r
.50142 .46468 m
.47567 .43709 L
s
.50142 .46468 m
.47555 .49099 L
s
.52345 .3465 m
.49819 .31625 L
s
.52345 .3465 m
.51371 .37673 L
s
.47256 .23097 m
.46312 .21065 L
s
.29854 .49333 m
.27218 .49153 L
s
.27218 .49153 m
.24126 .46454 L
s
.47555 .49099 m
.44919 .46396 L
s
.38835 .50393 m
.35729 .51501 L
s
.35729 .51501 m
.32816 .48843 L
s
.24 .35 .67 r
.7664 .46998 m
.71909 .48558 L
s
.71909 .48558 m
.70508 .45231 L
s
.69269 .41715 m
.68262 .3821 L
s
.72952 .36514 m
.68262 .3821 L
s
.83 .24 .1 r
.21933 .45665 m
.24126 .46454 L
s
.24 .35 .67 r
.78098 .50005 m
.7664 .46998 L
s
.83 .24 .1 r
.50158 .28784 m
.47559 .25597 L
s
.50158 .28784 m
.49819 .31625 L
s
.24 .35 .67 r
.75244 .4362 m
.70508 .45231 L
s
.70508 .45231 m
.69269 .41715 L
s
.73991 .40058 m
.69269 .41715 L
s
.83 .24 .1 r
.51371 .37673 m
.48796 .34683 L
s
.51371 .37673 m
.49755 .40747 L
s
.24 .35 .67 r
.72952 .36514 m
.72183 .3319 L
s
.83 .24 .1 r
.41955 .48664 m
.38835 .50393 L
s
.38835 .50393 m
.35965 .47684 L
s
.32816 .48843 m
.29854 .49333 L
s
.29854 .49333 m
.26776 .46598 L
s
.47559 .25597 m
.47256 .23097 L
s
.49755 .40747 m
.47122 .37805 L
s
.49755 .40747 m
.47567 .43709 L
s
.24 .35 .67 r
.7664 .46998 m
.75244 .4362 L
s
.73991 .40058 m
.72952 .36514 L
s
.83 .24 .1 r
.44919 .46396 m
.41955 .48664 L
s
.41955 .48664 m
.39138 .45898 L
s
.47567 .43709 m
.44872 .40822 L
s
.47567 .43709 m
.44919 .46396 L
s
.49819 .31625 m
.47176 .2846 L
s
.49819 .31625 m
.48796 .34683 L
s
.24126 .46454 m
.26776 .46598 L
s
.44919 .46396 m
.42162 .4357 L
s
.24 .35 .67 r
.75244 .4362 m
.73991 .40058 L
s
.83 .24 .1 r
.35965 .47684 m
.32816 .48843 L
s
.32816 .48843 m
.29769 .46062 L
s
.47176 .2846 m
.47559 .25597 L
s
.48796 .34683 m
.46101 .31555 L
s
.48796 .34683 m
.47122 .37805 L
s
.39138 .45898 m
.35965 .47684 L
s
.35965 .47684 m
.32961 .44848 L
s
.26776 .46598 m
.29769 .46062 L
s
.47122 .37805 m
.44366 .34725 L
s
.47122 .37805 m
.44872 .40822 L
s
.42162 .4357 m
.39138 .45898 L
s
.39138 .45898 m
.36188 .43002 L
s
.44872 .40822 m
.42051 .378 L
s
.44872 .40822 m
.42162 .4357 L
s
.46101 .31555 m
.47176 .2846 L
s
.42162 .4357 m
.39275 .4061 L
s
.29769 .46062 m
.32961 .44848 L
s
.44366 .34725 m
.46101 .31555 L
s
.32961 .44848 m
.36188 .43002 L
s
.42051 .378 m
.44366 .34725 L
s
.36188 .43002 m
.39275 .4061 L
s
.39275 .4061 m
.42051 .378 L
s
0 0 0 r
.25 Mabswid
.88764 .44767 m
.93472 .69847 L
s
.93472 .69847 m
.66126 .3169 L
s
.66126 .3169 m
.63805 .03848 L
s
.63805 .03848 m
.88764 .44767 L
s
.63805 .03848 m
.06705 .30234 L
s
.06705 .30234 m
.00747 .5665 L
s
.00747 .5665 m
.66126 .3169 L
s
.66126 .3169 m
.63805 .03848 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{500, 500},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40007d0001m2000`400?l00000o`00003oo`3ooooe
0?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3o
m^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40
oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?of
k_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3o
ool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^
m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofkSh0ooK^0P00002d0?ofkP40oooo003o0?of
kS`0ooK^0P0000000`3om^h000000000002c0?ofkP40oooo003o0?ofkSX0ooK^0P0000030?ofkP80
0000/`3om^h10?ooo`00o`3om^hh0?ofkP8000001@3om^h00`000000ooK^0000002b0?ofkP40oooo
003o0?ofkSH0ooK^0P0000070?ofkP030000003om^h000000;80ooK^0@3oool00?l0ooK^=03om^h2
000000T0ooK^00@000000?ofkP3om^h00000/@3om^h10?ooo`00o`3om^ha0?ofkP<000002`3om^h0
1@000000ooK^0?ofkP3om^h000000;00ooK^0@3oool00?l0ooK^;`3om^h2000000l0ooK^00@00000
0?ofkP3om^h00000/03om^h10?ooo`00o`3om^h]0?ofkP8000004@3om^h01@000000ooK^0?ofkP3o
m^h000000:l0ooK^0@3oool00?l0ooK^:`3om^h2000001<0ooK^00D000000?ofkP3om^h0ooK^0000
002_0?ofkP40oooo003o0?ofkRT0ooK^0P00000E0?ofkP030000003om^h0ooK^0080ooK^00<00000
0?ofkP3om^h0[03om^h10?ooo`00o`3om^hV0?ofkP<000005`3om^h00`000000ooK^0?ofkP030?of
kP030000003om^h0ooK^0:/0ooK^0@3oool00?l0ooK^903om^h2000001X0ooK^00<000000?ofkP3o
m^h00`3om^h00`000000ooK^0?ofkP2[0?ofkP40oooo003o0?ofkR80ooK^0P00000L0?ofkP030000
003om^h0ooK^00@0ooK^00<000000?ofkP3om^h0ZP3om^h10?ooo`00o`3om^hP0?ofkP8000007P3o
m^h00`000000ooK^0?ofkP050?ofkP030000003om^h0ooK^0:T0ooK^0@3oool00?l0ooK^7P3om^h2
00000200ooK^00<000000?ofkP3om^h01@3om^h00`000000ooK^0?ofkP2Y0?ofkP40oooo003o0?of
kQ`0ooK^0P00000R0?ofkP030000003om^h0ooK^00H0ooK^00<000000?ofkP3om^h0Z03om^h10?oo
o`00o`3om^hI0?ofkP<00000903om^h00`000000ooK^0?ofkP060?ofkP030000003om^h0ooK^0:P0
ooK^0@3oool00?l0ooK^5`3om^h2000002L0ooK^00<000000?ofkP3om^h01`3om^h00`000000ooK^
0?ofkP2W0?ofkP40oooo003o0?ofkQD0ooK^0P00000Z0?ofkP030000003om^h0ooK^00L0ooK^00<0
00000?ofkP3om^h0YP3om^h10?ooo`00o`3om^hC0?ofkP800000;03om^h00`000000ooK^0?ofkP07
0?ofkP030000003om^h0ooK^0:H0ooK^0@3oool00?l0ooK^4@3om^h2000002h0ooK^00<000000?of
kP3om^h0203om^h00`000000ooK^0?ofkP2U0?ofkP40oooo003o0?ofkPl0ooK^0P00000`0?ofkP03
0000003om^h0ooK^00P0ooK^00<000000?ofkP3om^h0Y@3om^h10?ooo`00o`3om^h<0?ofkP<00000
<P3om^h00`000000ooK^0?ofkP090?ofkP030000003om^h0ooK^0:@0ooK^0@3oool00?l0ooK^2P3o
m^h2000003D0ooK^00<000000?ofkP3om^h02P3om^h00`000000ooK^0?ofkP2S0?ofkP40oooo003o
0?ofkPP0ooK^0P00000g0?ofkP030000003om^h0ooK^00X0ooK^00<000000?ofkP3om^h0X`3om^h1
0?ooo`00o`3om^h60?ofkP800000>@3om^h00`000000ooK^0?ofkP0;0?ofkP030000003om^h0ooK^
0:80ooK^0@3oool00?l0ooK^103om^h2000003/0ooK^00<000000?ofkP3om^h02`3om^h00`000000
ooK^0?ofkP2R0?ofkP40oooo003o0?ofkP40ooK^0`00000m0?ofkP030000003om^h0ooK^00`0ooK^
00<000000?ofkP3om^h0X@3om^h10?ooo`00oP3om^h200000400ooK^00<000000?ofkP3om^h03@3o
m^h00`000000ooK^0?ofkP2P0?ofkP40oooo003l0?ofkP800000@P3om^h00`000000ooK^0?ofkP0=
0?ofkP030000003om^h0ooK^0:00ooK^0@3oool00?X0ooK^0P0000140?ofkP030000003om^h0ooK^
00h0ooK^00<000000?ofkP3om^h0W`3om^h10?ooo`00n03om^h2000004L0ooK^00<000000?ofkP3o
m^h03@3om^h00`000000ooK^0?ofkP2O0?ofkP40oooo003f0?ofkP800000B@3om^h00`000000ooK^
0?ofkP0>0?ofkP030000003om^h0ooK^09h0ooK^0@3oool00?<0ooK^0`00001;0?ofkP030000003o
m^h0ooK^00l0ooK^00<000000?ofkP3om^h0W@3om^h10?ooo`00l@3om^h2000004h0ooK^00<00000
0?ofkP3om^h03`3om^h00`000000ooK^0?ofkP2M0?ofkP40oooo003_0?ofkP800000D03om^h00`00
0000ooK^0?ofkP0@0?ofkP030000003om^h0ooK^09`0ooK^0@3oool00>d0ooK^0P00001B0?ofkP03
0000003om^h0ooK^0100ooK^00<000000?ofkP3om^h0W03om^h10?ooo`00j`3om^h2000005@0ooK^
00<000000?ofkP3om^h04@3om^h00`000000ooK^0?ofkP2K0?ofkP40oooo003Y0?ofkP800000EP3o
m^h00`000000ooK^0?ofkP0B0?ofkP030000003om^h0ooK^09X0ooK^0@3oool00>H0ooK^0`00001H
0?ofkP030000003om^h0ooK^0180ooK^00<000000?ofkP3om^h0VP3om^h10?ooo`00i03om^h20000
05/0ooK^00<000000?ofkP3om^h04`3om^h00`000000ooK^0?ofkP2I0?ofkP40oooo003R0?ofkP80
0000G@3om^h00`000000ooK^0?ofkP0D0?ofkP030000003om^h0ooK^09P0ooK^0@3oool00>00ooK^
0P00001O0?ofkP030000003om^h0ooK^01@0ooK^00<000000?ofkP3om^h0V03om^h10?ooo`00gP3o
m^h200000640ooK^00<000000?ofkP3om^h05@3om^h00`000000ooK^0?ofkP2G0?ofkP40oooo003L
0?ofkP800000I03om^h00`000000ooK^0?ofkP0D0?ofkP030000003om^h0ooK^09L0ooK^0@3oool0
0=T0ooK^0`00001V0?ofkP030000003om^h0ooK^01D0ooK^00<000000?ofkP3om^h0UP3om^h10?oo
o`00e`3om^h2000006T0ooK^00<000000?ofkP3om^h05P3om^h00`000000ooK^0?ofkP2E0?ofkP40
oooo003E0?ofkP800000J`3om^h00`000000ooK^0?ofkP0F0?ofkP030000003om^h0ooK^09D0ooK^
0@3oool00=<0ooK^0P00001]0?ofkP030000003om^h0ooK^01L0ooK^00<000000?ofkP3om^h0U03o
m^h10?ooo`00d@3om^h2000006l0ooK^00<000000?ofkP3om^h05`3om^h00`000000ooK^0?ofkP2D
0?ofkP40oooo003>0?ofkP<00000L@3om^h00`000000ooK^0?ofkP0H0?ofkP030000003om^h0ooK^
09<0ooK^0@3oool00<`0ooK^0P00001d0?ofkP030000003om^h0ooK^01T0ooK^00<000000?ofkP3o
m^h0TP3om^h10?ooo`00bP3om^h2000007H0ooK^00<000000?ofkP3om^h06@3om^h00`000000ooK^
0?ofkP2B0?ofkP40oooo00380?ofkP800000N03om^h00`000000ooK^0?ofkP0J0?ofkP030000003o
m^h0ooK^0940ooK^0@3oool00<H0ooK^0P00001j0?ofkP030000003om^h0ooK^01X0ooK^00<00000
0?ofkP3om^h0T@3om^h10?ooo`00a03om^h2000007`0ooK^00<000000?ofkP3om^h06`3om^h00`00
0000ooK^0?ofkP2@0?ofkP40oooo00310?ofkP<00000O`3om^h00`000000ooK^0?ofkP0K0?ofkP03
0000003om^h0ooK^08l0ooK^0@3oool00;l0ooK^0P0000220?ofkP030000003om^h0ooK^01/0ooK^
00<000000?ofkP3om^h0S`3om^h10?ooo`00_@3om^h2000008@0ooK^00<000000?ofkP3om^h0703o
m^h00`000000ooK^0?ofkP2>0?ofkP40oooo002k0?ofkP800000QP3om^h00`000000ooK^0?ofkP0L
0?ofkP030000003om^h0ooK^08h0ooK^0@3oool00;T0ooK^0P0000280?ofkP030000003om^h0ooK^
01d0ooK^00<000000?ofkP3om^h0S@3om^h10?ooo`00]`3om^h2000008X0ooK^00<000000?ofkP3o
m^h07P3om^h00`000000ooK^0?ofkP2<0?ofkP40oooo002d0?ofkP<00000S03om^h00`000000ooK^
0?ofkP0N0?ofkP030000003om^h0ooK^08`0ooK^0@3oool00;80ooK^0P00002?0?ofkP030000003o
m^h0ooK^01l0ooK^00<000000?ofkP3om^h0R`3om^h10?ooo`00/03om^h200000940ooK^00<00000
0?ofkP3om^h0803om^h00`000000ooK^0?ofkP2:0?ofkP40oooo002^0?ofkP800000T`3om^h00`00
0000ooK^0?ofkP0P0?ofkP030000003om^h0ooK^08X0ooK^0@3oool00:`0ooK^0P00002E0?ofkP03
0000003om^h0ooK^0240ooK^00<000000?ofkP3om^h0R@3om^h10?ooo`00Z@3om^h3000009L0ooK^
00<000000?ofkP3om^h08@3om^h00`000000ooK^0?ofkP290?ofkP40oooo002W0?ofkP800000VP3o
m^h00`000000ooK^0?ofkP0R0?ofkP030000003om^h0ooK^08P0ooK^0@3oool00:D0ooK^0P00002M
0?ofkP030000003om^h0ooK^0280ooK^00<000000?ofkP3om^h0Q`3om^h10?ooo`00X`3om^h20000
09l0ooK^00<000000?ofkP3om^h08P3om^h00`000000ooK^0?ofkP270?ofkP40oooo002Q0?ofkP80
0000803om^h90=@m6GP0ooK^00<000000?ofkP3om^h08`3om^h00`000000ooK^0?ofkP260?ofkP40
oooo002O0?ofkP8000006P3om^h80=@m6@L0ooK^00<0e3dI0?ofkP3D?AT01@3D?AUb0?ofkP030000
003om^h0ooK^02<0ooK^00<000000?ofkP3om^h0QP3om^h10?ooo`00W03om^h3000001P0ooK^103D
?AT20?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h0103om^h50=@m6Fd0ooK^00<0
00000?ofkP3om^h0903om^h00`000000ooK^0?ofkP250?ofkP40oooo002J0?ofkP800000603om^h3
0=@m6@L0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP070?ofkP<0e3dIJ`3om^h0
0`000000ooK^0?ofkP0U0?ofkP030000003om^h0ooK^08@0ooK^0@3oool009P0ooK^0P00000F0?of
kP@0e3dI2`3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?of
kP3D?AT00P3D?AUX0?ofkP030000003om^h0ooK^02D0ooK^00<000000?ofkP3om^h0Q03om^h10?oo
o`00UP3om^h2000001D0ooK^0`3D?AT?0?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3o
m^h0203om^h0103D?AT0ooK^0?ofkP3om^h20=@m6FH0ooK^00<000000?ofkP3om^h09P3om^h00`00
0000ooK^0?ofkP230?ofkP40oooo002D0?ofkP8000005@3om^h20=@m6@80ooK^00<0e3dI0?ofkP3o
m^h03P3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3o
m^h00`3om^h20=@m6F@0ooK^00<000000?ofkP3om^h09P3om^h00`000000ooK^0?ofkP230?ofkP40
oooo002B0?ofkP8000005@3om^h20=@m6@D0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^
0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^
0?ofkP1Q0?ofkP030000003om^h0ooK^02L0ooK^00<000000?ofkP3om^h0PP3om^h10?ooo`00S`3o
m^h3000001@0ooK^0`3D?AT80?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h02`3o
m^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h0H03o
m^h00`000000ooK^0?ofkP0X0?ofkP030000003om^h0ooK^0840ooK^0@3oool008d0ooK^0P00000E
0?ofkP80e3dI2`3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI
0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP030?ofkP80e3dIH@3om^h00`000000ooK^0?ofkP0X
0?ofkP030000003om^h0ooK^0840ooK^0@3oool008/0ooK^0P00000E0?ofkP80e3dI3P3om^h00`3D
?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D
?AT0ooK^0?ofkP030?ofkP80e3dIH03om^h00`000000ooK^0?ofkP0Y0?ofkP030000003om^h0ooK^
0800ooK^0@3oool008T0ooK^0P00000E0?ofkP80e3dI4@3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP03
0=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP030?ofkP80
e3dIH03om^h00`000000ooK^0?ofkP0X0?ofkP030000003om^h0ooK^0800ooK^0@3oool008L0ooK^
0P00000E0?ofkP80e3dI00<0ooK^0=@m6@3om^h04@3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m
6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP030?ofkP80e3dI
G`3om^h00`000000ooK^0?ofkP0Y0?ofkP030000003om^h0ooK^07l0ooK^0@3oool008@0ooK^0`00
000F0?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h0403om^h00`3D?AT0ooK^0?of
kP0>0?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?of
kP030?ofkP80e3dIGP3om^h00`000000ooK^0?ofkP0Z0?ofkP030000003om^h0ooK^07h0ooK^0@3o
ool00880ooK^0P00000G0?ofkP80e3dI1P3om^h00`3D?AT0ooK^0?ofkP0@0?ofkP030=@m6@3om^h0
ooK^00h0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0
ooK^00<0ooK^00<0e3dI0?ofkP3D?AT0G@3om^h00`000000ooK^0?ofkP0Z0?ofkP030000003om^h0
ooK^07h0ooK^0@3oool00800ooK^0P00000H0?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?of
kP3om^h0403om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00D0ooK^2@3D?AT70?of
kP030=@m6@3om^h0ooK^00<0ooK^0`3D?AUL0?ofkP030000003om^h0ooK^02/0ooK^00<000000?of
kP3om^h0O@3om^h10?ooo`00OP3om^h2000001T0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0
ooK^0?ofkP0@0?ofkP030=@m6@3om^h0ooK^00d0ooK^203D?AT70?ofkP030=@m6@3om^h0e3dI00D0
e3dI0P3om^h00`3D?AT0ooK^0?ofkP030?ofkP80e3dIG03om^h00`000000ooK^0?ofkP0[0?ofkP03
0000003om^h0ooK^07d0ooK^0@3oool007`0ooK^0P00000I0?ofkP80e3dI3@3om^h00`3D?AT0ooK^
0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00T0ooK^103D?AT20?ofkP030=@m6@3om^h0ooK^00/0ooK^
00<0e3dI0?ofkP3om^h0103om^h40=@m6@D0ooK^0P3D?AUK0?ofkP030000003om^h0ooK^02`0ooK^
00<000000?ofkP3om^h0O03om^h10?ooo`00NP3om^h2000001X0ooK^00<0e3dI0?ofkP3om^h03P3o
m^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00D0ooK^0`3D?AT70?ofkP030=@m6@3o
m^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h0203om^h20=@m6@@0ooK^0P3D?AUJ0?ofkP030000003o
m^h0ooK^02d0ooK^00<000000?ofkP3om^h0N`3om^h10?ooo`00M`3om^h3000001X0ooK^0P3D?ATA
0?ofkP030=@m6@3om^h0ooK^0100ooK^00<0e3dI0?ofkP3om^h0103D?AT:0?ofkP030=@m6@3om^h0
ooK^00/0ooK^00<0e3dI0?ofkP3om^h0203om^h30=@m6@80ooK^0`3D?AUI0?ofkP030000003om^h0
ooK^02d0ooK^00<000000?ofkP3om^h0N`3om^h10?ooo`00M@3om^h2000001`0ooK^00<0e3dI0?of
kP3om^h04P3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP<0e3dI3`3om^h00`3D?AT0ooK^0?ofkP0;0?of
kP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h01@3D?AUI0?ofkP030000003om^h0ooK^
02h0ooK^00<000000?ofkP3om^h0NP3om^h10?ooo`00L`3om^h2000001d0ooK^00<0e3dI0?ofkP3D
?AT0503om^h00`3D?AT0ooK^0?ofkP0<0?ofkP80e3dI0P3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP03
0=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h01`3om^h0103D?AT0ooK^0?ofkP3om^h40=@m
6EP0ooK^00<000000?ofkP3om^h0;`3om^h00`000000ooK^0?ofkP1i0?ofkP40oooo001a0?ofkP80
00007P3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI01@0ooK^00<0e3dI0?ofkP3om^h02@3om^h20=@m
6@D0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^
00L0ooK^00@0e3dI0?ofkP3om^h0ooK^103D?AUG0?ofkP030000003om^h0ooK^02l0ooK^00<00000
0?ofkP3om^h0N@3om^h10?ooo`00K`3om^h2000001h0ooK^0P3D?AT50?ofkP030=@m6@3om^h0ooK^
0180ooK^00<0e3dI0?ofkP3om^h01P3om^h20=@m6@P0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D
?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00P0ooK^00H0e3dI0?ofkP3om^h0ooK^0=@m6@3o
m^h20=@m6EL0ooK^00<000000?ofkP3om^h0;`3om^h00`000000ooK^0?ofkP1h0?ofkP40oooo001]
0?ofkP8000007`3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI
0?ofkP3om^h00`3om^h20=@m6@/0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0;
0?ofkP030=@m6@3om^h0ooK^00P0ooK^00@0e3dI0?ofkP3om^h0e3dI0P3om^h00`3D?AT0ooK^0?of
kP1E0?ofkP030000003om^h0ooK^02l0ooK^00<000000?ofkP3om^h0N03om^h10?ooo`00JP3om^h3
00000200ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0
ooK^0080e3dI3P3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI
0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP020=@m6@030?ofkP3D?AT0e3dI05H0ooK^00<00000
0?ofkP3om^h0<03om^h00`000000ooK^0?ofkP1g0?ofkP40oooo001X0?ofkP8000008P3om^h00`3D
?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^01<0ooK^0P3D?ATA0?ofkP030=@m6@3om^h0ooK^
00d0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP070?ofkP060=@m6@3om^h0e3dI
0?ofkP3D?AT0ooK^0P3D?AUE0?ofkP030000003om^h0ooK^0340ooK^00<000000?ofkP3om^h0MP3o
m^h10?ooo`00IP3om^h2000002<0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP0@
0?ofkP80e3dI00<0ooK^0=@m6@3om^h0403om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0
ooK^00/0ooK^00<0e3dI0?ofkP3om^h01`3om^h20=@m6@040?ofkP3D?AT0ooK^0?ofkP80e3dIE03o
m^h00`000000ooK^0?ofkP0a0?ofkP030000003om^h0ooK^07H0ooK^0@3oool006@0ooK^0P00000S
0?ofkP80e3dI3`3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI
0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI
0?ofkP3om^h0203om^h20=@m6@050?ofkP3D?AT0ooK^0?ofkP3D?AT0E03om^h00`000000ooK^0?of
kP0b0?ofkP030000003om^h0ooK^07D0ooK^0@3oool00680ooK^0P00000T0?ofkP030=@m6@3om^h0
ooK^0100ooK^00<0e3dI0?ofkP3om^h02`3om^h20=@m6@H0ooK^00<0e3dI0?ofkP3om^h03`3om^h0
0`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h0203om^h0
103D?AT0ooK^0?ofkP3D?AT20?ofkP030=@m6@3om^h0ooK^0540ooK^00<000000?ofkP3om^h0<P3o
m^h00`000000ooK^0?ofkP1e0?ofkP40oooo001P0?ofkP8000009@3om^h00`3D?AT0ooK^0?ofkP0B
0?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP0@
0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h01@3om^h90=@m6@L0ooK^00H0e3dI
0?ofkP3om^h0ooK^0=@m6@3om^h20=@m6E80ooK^00<000000?ofkP3om^h0<`3om^h00`000000ooK^
0?ofkP1d0?ofkP40oooo001M0?ofkP<000009P3om^h00`3D?AT0ooK^0?ofkP0D0?ofkP030=@m6@3o
m^h0ooK^00H0ooK^0P3D?AT:0?ofkP030=@m6@3om^h0ooK^0100ooK^00<0e3dI0?ofkP3om^h02`3o
m^h90=@m6@L0ooK^00<0e3dI0?ofkP3D?AT01@3D?AT00`3om^h0e3dI0=@m6@030?ofkP040=@m6@3o
m^h0e3dI0=@m6E40ooK^00<000000?ofkP3om^h0=03om^h00`000000ooK^0?ofkP1c0?ofkP40oooo
001K0?ofkP800000:03om^h00`3D?AT0ooK^0=@m6@0E0?ofkP030=@m6@3om^h0ooK^00@0ooK^0P3D
?AT=0?ofkP030=@m6@3om^h0ooK^0100ooK^00<0e3dI0?ofkP3om^h01P3om^h40=@m6@<0ooK^00<0
e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP040?ofkP@0e3dI0P3om^h00`3D?AT0ooK^0?of
kP020=@m6E00ooK^00<000000?ofkP3om^h08@3om^h403eIZ`l0ooK^00<000000?ofkP3om^h0L`3o
m^h10?ooo`00F@3om^h2000002T0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0E0?ofkP030=@m6@3o
m^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0@0?ofkP040=@m6@3o
m^h0ooK^0?ofkP@0e3dI203om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00@0ooK^
00<0e3dI0?ofkP3om^h00P3D?AT00`3om^h0e3dI0?ofkP020=@m6E00ooK^00<000000?ofkP3om^h0
7`3om^h303eIZ`<0ooK^0`0mFJ/=0?ofkP030000003om^h0ooK^0780ooK^0@3oool005L0ooK^0P00
000Z0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h04`3om^h0103D?AT0ooK^0=@m
6@3D?ATB0?ofkP030=@m6@3om^h0ooK^00l0ooK^103D?AT=0?ofkP030=@m6@3om^h0ooK^00X0ooK^
00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP040=@m6@030?ofkP3D?AT0e3dI04l0ooK^
00<000000?ofkP3om^h0703om^h403eIZ`@0ooK^0P0mFJ/20?ofkP0303eIZ`3om^h0ooK^00X0ooK^
00<000000?ofkP3om^h0LP3om^h10?ooo`00E@3om^h2000002/0ooK^00<0e3dI0?ofkP3om^h01@3o
m^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h0303o
m^h20=@m6@80ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3o
m^h0ooK^00@0ooK^00@0e3dI0?ofkP3om^h0e3dI0P3om^h50=@m6Dh0ooK^00<000000?ofkP3om^h0
6@3om^h503eIZ`040?ofkP0mFJ/0ooK^0?ofkP80?EV[1@3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP03
0000003om^h0ooK^0740ooK^0@3oool00580ooK^0`00000/0?ofkP030=@m6@3om^h0ooK^00L0ooK^
00<0e3dI0?ofkP3om^h04@3om^h00`3D?AT0ooK^0=@m6@0E0?ofkP030=@m6@3om^h0ooK^00T0ooK^
0P3D?AT50?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^
0?ofkP030?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT00`3om^h40=@m6Dh0ooK^00<000000?ofkP3o
m^h05P3om^h403eIZ`<0ooK^100mFJ/80?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<000000?ofkP3o
m^h0L03om^h10?ooo`00D03om^h2000002d0ooK^0P3D?AT;0?ofkP030=@m6@3om^h0ooK^00h0ooK^
0P3D?AT30?ofkP030=@m6@3om^h0ooK^0180ooK^00<0e3dI0?ofkP3om^h01P3om^h30=@m6@P0ooK^
00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^0080ooK^
0P3D?AT30?ofkP040=@m6@3om^h0ooK^0?ofkP@0e3dIC@3om^h00`000000ooK^0?ofkP0C0?ofkPD0
?EV[103om^h203eIZ``0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`000000ooK^0?ofkP1`0?ofkP40
oooo001>0?ofkP800000;P3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00d0ooK^
00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP0B0?ofkP030=@m6@3om^h0ooK^00<0ooK^
0P3D?AT;0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h02`3om^h01`3D?AT0ooK^
0?ofkP3om^h0e3dI0?ofkP3D?AT00`3om^h00`3D?AT0ooK^0?ofkP020=@m6@030?ofkP3D?AT0ooK^
04`0ooK^00<000000?ofkP3om^h0403om^h503eIZ`D0ooK^0`0mFJ/=0?ofkP80?EV[2`3om^h00`00
0000ooK^0?ofkP1_0?ofkP40oooo001<0?ofkP800000;`3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP03
0=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP0B0?ofkP03
0=@m6@3om^h0ooK^0080e3dI3P3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00/0
ooK^00H0e3dI0?ofkP3om^h0e3dI0?ofkP3D?AT40?ofkP040=@m6@3om^h0ooK^0=@m6@80ooK^00<0
e3dI0?ofkP3om^h0BP3om^h00`000000ooK^0?ofkP0>0?ofkP@0?EV[1@3om^h303eIZ`030?ofkP0m
FJ/0?EV[00/0ooK^0P0mFJ/20?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<000000?ofkP3om^h0K`3o
m^h10?ooo`00BP3om^h200000300ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP08
0?ofkP80e3dI2P3om^h00`3D?AT0ooK^0?ofkP0B0?ofkP80e3dI4@3om^h00`3D?AT0ooK^0?ofkP0=
0?ofkP030=@m6@3om^h0ooK^00/0ooK^0P3D?AT30?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT00`3o
m^h0103D?AT0ooK^0=@m6@3D?AU;0?ofkP030000003om^h0ooK^00/0ooK^100mFJ/60?ofkP80?EV[
0P3om^h203eIZ`030?ofkP0mFJ/0ooK^00L0ooK^0`0mFJ/40?ofkP0303eIZ`3om^h0ooK^00T0ooK^
00<000000?ofkP3om^h0KP3om^h10?ooo`00B03om^h200000340ooK^00<0e3dI0?ofkP3om^h04@3o
m^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h03`3o
m^h20=@m6@030?ofkP3D?AT0ooK^0140ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?of
kP0:0?ofkP80e3dI103om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI0080ooK^0P3D?AT00`3om^h0e3dI
0=@m6@1:0?ofkP030000003om^h0ooK^00T0ooK^100mFJ/00`3om^h0?EV[03eIZ`030?ofkP80?EV[
00@0ooK^03eIZ`0mFJ/0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP040?ofkP80?EV[203om^h00`0mFJ/0
ooK^0?ofkP090?ofkP030000003om^h0ooK^06d0ooK^0@3oool004D0ooK^0`00000b0?ofkP030=@m
6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m
6@3om^h0ooK^00`0ooK^0P3D?AT40?ofkP030=@m6@3om^h0ooK^0100ooK^00<0e3dI0?ofkP3om^h0
303om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00<0ooK^00X0e3dI0?ofkP3om^h0
ooK^0=@m6@3om^h0e3dI0?ofkP3D?AT0ooK^0P3D?AU90?ofkP030000003om^h0ooK^00H0ooK^100m
FJ/60?ofkP<0?EV[00<0ooK^03eIZ`0mFJ/01P3om^h0100mFJ/0ooK^0?ofkP3om^h303eIZ`/0ooK^
00<0?EV[0?ofkP3om^h0203om^h00`000000ooK^0?ofkP1]0?ofkP40oooo00130?ofkP800000=03o
m^h00`3D?AT0ooK^0=@m6@0E0?ofkP040=@m6@3om^h0ooK^0?ofkP80e3dI4@3om^h00`3D?AT0ooK^
0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h0403om^h00`3D?AT0ooK^
0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00X0ooK^0P3D?AT50?ofkP040=@m6@3om^h0ooK^0?ofkP80
e3dI00D0ooK^0=@m6@3om^h0ooK^0=@m6@190?ofkP030000003om^h0ooK^00<0ooK^1@0mFJ/60?of
kP80?EV[00@0ooK^03eIZ`0mFJ/0?EV[203om^h0100mFJ/0ooK^03eIZ`0mFJ/?0?ofkP0303eIZ`3o
m^h0ooK^00P0ooK^00<000000?ofkP3om^h0K03om^h10?ooo`00@@3om^h2000003D0ooK^00D0e3dI
0?ofkP3om^h0ooK^0=@m6@0E0?ofkP030=@m6@3om^h0e3dI01@0ooK^00<0e3dI0?ofkP3om^h01`3o
m^h20=@m6@P0ooK^00<0e3dI0?ofkP3om^h04@3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3o
m^h0ooK^00D0ooK^203D?AT30?ofkP030=@m6@3om^h0ooK^0080ooK^0P3D?AT01@3om^h0e3dI0?of
kP3om^h0e3dI04P0ooK^00@000000?ofkP3om^h0ooK^100mFJ/20?ofkP0403eIZ`3om^h0ooK^0?of
kPH0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP040?ofkP<0?EV[4@3om^h00`0mFJ/0ooK^0?ofkP090?of
kP030000003om^h0ooK^06/0ooK^0@3oool003l0ooK^0P00000f0?ofkP030=@m6@3om^h0ooK^00<0
ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP0D0?ofkP030=@m6@3om^h0ooK^00D0
ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP0@0?ofkP030=@m6@3om^h0ooK^00/0
ooK^2@3D?AT40?ofkP030=@m6@3om^h0ooK^00H0e3dI0`3om^h20=@m6@80ooK^00@0e3dI0?ofkP3D
?AT0e3dIA`3om^h00`000000?EV[03eIZ`0203eIZ`@0ooK^00<0?EV[0?ofkP0mFJ/00P0mFJ/00`3o
m^h0?EV[03eIZ`070?ofkP80?EV[0P3om^h303eIZa@0ooK^00<0?EV[0?ofkP3om^h0203om^h00`00
0000ooK^0?ofkP1[0?ofkP40oooo000m0?ofkP800000>03om^h00`3D?AT0ooK^0?ofkP040?ofkP03
0=@m6@3om^h0ooK^0140ooK^00<0e3dI0?ofkP3D?AT05P3om^h00`3D?AT0ooK^0?ofkP020?ofkP80
e3dI3@3om^h00`3D?AT0ooK^0?ofkP0@0?ofkP030=@m6@3om^h0ooK^00H0ooK^103D?AT30?ofkP03
0=@m6@3om^h0ooK^00L0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@030?ofkP@0e3dI00<0ooK^0=@m
6@3om^h00P3om^h0103D?AT0ooK^0=@m6@3D?AU40?ofkP80?EV[00<0000003eIZ`3om^h01P3om^h2
03eIZ`040?ofkP0mFJ/0?EV[03eIZ`X0ooK^0`0mFJ/20?ofkP0303eIZ`3om^h0ooK^0180ooK^0P0m
FJ/:0?ofkP030000003om^h0ooK^06X0ooK^0@3oool003/0ooK^0P00000i0?ofkP030=@m6@3om^h0
ooK^00H0ooK^00<0e3dI0?ofkP3om^h03`3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI01H0ooK^00@0
e3dI0?ofkP3D?AT0e3dI403om^h00`3D?AT0ooK^0?ofkP0@0?ofkP040=@m6@3om^h0ooK^0?ofkP@0
e3dI203om^h00`3D?AT0ooK^0?ofkP060?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT01@3om^h00`3D
?AT0ooK^0=@m6@020=@m6@<0ooK^00@0e3dI0?ofkP3D?AT0e3dI@@3om^h403eIZ`030000003om^h0
ooK^00<0ooK^0`0mFJ/00`3om^h0?EV[03eIZ`0;0?ofkP80?EV[0P3om^h0100mFJ/0ooK^0?ofkP0m
FJ/A0?ofkP<0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP070?ofkP030000003om^h0ooK^06X0ooK^0@3o
ool003P0ooK^0`00000j0?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h03@3om^h0
0`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^01@0ooK^00<0e3dI0?ofkP3om^h04@3om^h0
0`3D?AT0ooK^0?ofkP0?0?ofkP@0e3dI3@3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0
ooK^00<0ooK^00<0e3dI0?ofkP3om^h00`3om^h0103D?AT0ooK^0=@m6@3om^h20=@m6@030?ofkP3D
?AT0ooK^00<0e3dI?@3om^h403eIZ`<0ooK^00<000000?ofkP3om^h00`0mFJ/0103om^h0?EV[03eI
Z`0mFJ/:0?ofkP<0?EV[1@3om^h303eIZ`h0ooK^0`0mFJ/50?ofkP0303eIZ`3om^h0ooK^00P0ooK^
00<000000?ofkP3om^h0J@3om^h10?ooo`00=P3om^h2000003`0ooK^00<0e3dI0?ofkP3om^h02@3o
m^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h04P3o
m^h00`3D?AT0ooK^0=@m6@0C0?ofkP030=@m6@3om^h0ooK^00`0ooK^0P3D?AT20?ofkP030=@m6@3o
m^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3o
m^h0ooK^00<0ooK^0P3D?AT20?ofkP@0e3dI00<0ooK^0=@m6@3D?AT0>`3om^h303eIZ`80ooK^0P0m
FJ/30?ofkP040000000mFJ/0ooK^0?ofkP80?EV[00<0ooK^03eIZ`3om^h01`3om^h303eIZ`H0ooK^
1@0mFJ/<0?ofkP80?EV[2@3om^h00`0mFJ/0ooK^0?ofkP080?ofkP030000003om^h0ooK^06P0ooK^
0@3oool003@0ooK^0P00000m0?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h02P3o
m^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00l0ooK^0P3D?AT30?ofkP030=@m6@3o
m^h0ooK^0140ooK^00<0e3dI0?ofkP3om^h02@3om^h20=@m6@D0ooK^00<0e3dI0?ofkP3om^h0303o
m^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h00P3o
m^h01@3D?AT0ooK^0=@m6@3om^h0e3dI0080ooK^1@3D?ATg0?ofkP@0?EV[1P3om^h303eIZ`040000
000mFJ/0?EV[03eIZ`<0ooK^00<0?EV[0?ofkP3om^h0103om^h203eIZ`H0ooK^0`0mFJ/30?ofkP80
?EV[2@3om^h303eIZ``0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`000000ooK^0?ofkP1X0?ofkP40
oooo000b0?ofkP800000?P3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00L0ooK^
0P3D?AT;0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^
0?ofkP0@0?ofkP030=@m6@3om^h0ooK^00H0ooK^0`3D?AT70?ofkP030=@m6@3om^h0ooK^00d0ooK^
00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00<0ooK^
0P3D?AT20?ofkP040=@m6@3om^h0ooK^0?ofkP@0e3dI=03om^h403eIZ`H0ooK^0P0mFJ/0103om^h0
?EV[03eIZ`0000060?ofkP0403eIZ`3om^h0ooK^0?ofkP<0?EV[1@3om^h303eIZ`L0ooK^00<0?EV[
0?ofkP3om^h0103om^h303eIZ`l0ooK^00<0?EV[0?ofkP3om^h0203om^h00`000000ooK^0?ofkP1W
0?ofkP40oooo000`0?ofkP800000@03om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^
00D0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^
00D0ooK^00<0e3dI0?ofkP3om^h04@3om^h00`3D?AT0ooK^0?ofkP030?ofkP80e3dI2`3om^h00`3D
?AT0ooK^0?ofkP0=0?ofkP040=@m6@3om^h0ooK^0?ofkP80e3dI1`3om^h00`3D?AT0ooK^0?ofkP03
0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT00`3om^h40=@m6C00ooK^100mFJ/20?ofkP0403eIZ`3o
m^h0ooK^0?ofkP<0?EV[00<0ooK^03eIZ`0mFJ/00P3om^h00`000000?EV[0?ofkP030?ofkP0303eI
Z`3om^h0?EV[0080?EV[1P3om^h203eIZ`X0ooK^0P0mFJ/20?ofkP<0?EV[4`3om^h00`0mFJ/0ooK^
0?ofkP070?ofkP030000003om^h0ooK^06L0ooK^0@3oool002d0ooK^0`0000110?ofkP030=@m6@3o
m^h0ooK^0100ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3o
m^h0ooK^00P0ooK^0P3D?AT90?ofkP030=@m6@3om^h0ooK^0140ooK^00<0e3dI0?ofkP3om^h00P3D
?AT>0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3D?AT00P3om^h00`3D?AT0ooK^0?of
kP050?ofkP030=@m6@3om^h0ooK^0080ooK^0P3D?AT30?ofkP030=@m6@3om^h0ooK^0080e3dI00<0
ooK^0=@m6@3D?AT0;@3om^h403eIZ`<0ooK^00<0?EV[0?ofkP3om^h00P0mFJ/0103om^h0?EV[03eI
Z`0mFJ/40?ofkP040000003om^h0?EV[03eIZ`80ooK^0P0mFJ/60?ofkP<0?EV[303om^h403eIZaL0
ooK^00<0?EV[0?ofkP3om^h01`3om^h00`000000ooK^0?ofkP1V0?ofkP40oooo000[0?ofkP800000
@`3om^h00`3D?AT0ooK^0?ofkP0B0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT04P3om^h00`3D?AT0
ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h04@3om^h20=@m6A40
ooK^00<0e3dI0?ofkP3om^h03@3om^h20=@m6@<0ooK^00<0e3dI0?ofkP3om^h01@3om^h01`3D?AT0
ooK^0?ofkP3om^h0e3dI0?ofkP3D?AT00P3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI0080ooK^0P3D
?ATY0?ofkP@0?EV[1P3om^h603eIZ`L0ooK^00<000000?ofkP3om^h0100mFJ/40?ofkP<0?EV[3P3o
m^h203eIZ`80ooK^00<0?EV[0?ofkP3om^h05@3om^h00`0mFJ/0ooK^0?ofkP080?ofkP030000003o
m^h0ooK^06D0ooK^0@3oool002T0ooK^0P0000140?ofkP030=@m6@3om^h0ooK^01@0ooK^00<0e3dI
0?ofkP3D?AT0503om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI
0?ofkP3om^h03P3om^h20=@m6@030?ofkP3D?AT0ooK^0100ooK^00<0e3dI0?ofkP3om^h03P3om^h0
1@3D?AT0ooK^0?ofkP3om^h0e3dI00P0ooK^00H0e3dI0?ofkP3om^h0e3dI0?ofkP3D?AT30?ofkP06
0=@m6@3om^h0ooK^0?ofkP3D?AT0ooK^0`3D?ATV0?ofkP@0?EV[1P3om^h203eIZ`030?ofkP0mFJ/0
?EV[00X0ooK^00<0000003eIZ`0mFJ/00P3om^h203eIZ`040?ofkP0mFJ/0?EV[03eIZ`h0ooK^0`0m
FJ/01@3om^h0?EV[0?ofkP3om^h0?EV[01L0ooK^0P0mFJ/90?ofkP030000003om^h0ooK^06D0ooK^
0@3oool002L0ooK^0P0000150?ofkP030=@m6@3om^h0e3dI01H0ooK^00<0e3dI0?ofkP3om^h0503o
m^h0103D?AT0ooK^0?ofkP3om^h20=@m6A00ooK^00<0e3dI0?ofkP3om^h02`3om^h20=@m6@@0ooK^
00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP80e3dI103om^h00`3D?AT0ooK^
0?ofkP050?ofkP030=@m6@3om^h0e3dI00<0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@020?ofkP80
e3dI00<0ooK^0=@m6@3D?AT08`3om^h503eIZ`D0ooK^1P0mFJ/;0?ofkP0303eIZ`000000ooK^00<0
ooK^0`0mFJ/?0?ofkP80?EV[103om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[01@0ooK^0P0mFJ/20?of
kP0303eIZ`3om^h0ooK^00L0ooK^00<000000?ofkP3om^h0I03om^h10?ooo`009@3om^h2000004L0
ooK^00@0e3dI0?ofkP3om^h0e3dI503om^h00`3D?AT0ooK^0=@m6@0F0?ofkP030=@m6@3om^h0e3dI
01<0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^
00l0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0=@m6@040?ofkP030=@m6@3om^h0ooK^
00D0ooK^0P3D?AT40?ofkP0:0=@m6@3om^h0ooK^0?ofkP3D?AT0ooK^0=@m6@3om^h0e3dI0?ofkP80
e3dI803om^h403eIZ`030?ofkP0mFJ/0?EV[00<0ooK^0P0mFJ/01@3om^h0?EV[03eIZ`3om^h0?EV[
00T0ooK^0`0mFJ/0103om^h000000?ofkP3om^h203eIZ`030?ofkP0mFJ/0?EV[00`0ooK^0`0mFJ/6
0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/04@3om^h303eIZ`@0ooK^00<0?EV[0?ofkP3om^h01`3o
m^h00`000000ooK^0?ofkP1T0?ofkP40oooo000S0?ofkP800000B03om^h00`3D?AT0ooK^0?ofkP02
0?ofkP030=@m6@3om^h0ooK^0100ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0F0?ofkP030=@m6@3o
m^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h01P3om^h20=@m6@T0ooK^00<0e3dI0?ofkP3om^h03`3o
m^h00`3D?AT0ooK^0?ofkP0:0?ofkP040=@m6@3om^h0ooK^0=@m6@@0ooK^00<0e3dI0?ofkP3om^h0
1`3D?AT40?ofkP040=@m6@3om^h0ooK^0?ofkP80e3dI00@0ooK^0=@m6@3om^h0ooK^0P3D?ATL0?of
kPD0?EV[1@3om^h603eIZ`<0ooK^00<0?EV[0?ofkP3om^h01@3om^h203eIZ`@0ooK^00<0000003eI
Z`0mFJ/00`3om^h00`0mFJ/0ooK^03eIZ`090?ofkP80?EV[2@3om^h00`0mFJ/0ooK^0?ofkP020?of
kP0303eIZ`3om^h0ooK^00`0ooK^0P0mFJ/80?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<000000?of
kP3om^h0H`3om^h10?ooo`008@3om^h2000004X0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0
ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h04P3om^h00`3D?AT0
ooK^0=@m6@0D0?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0
ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h02@3D?AT50?ofkPH0
e3dI00d0ooK^0=@m6@3om^h0ooK^0=@m6@3om^h0e3dI0?ofkP3D?AT0ooK^0=@m6@3om^h0e3dI01T0
ooK^1@0mFJ/40?ofkPL0?EV[103om^h00`0mFJ/0ooK^0?ofkP030?ofkP<0?EV[103om^h203eIZ`03
0000003om^h0ooK^00<0ooK^00@0?EV[0?ofkP3om^h0?EV[1@3om^h303eIZ`/0ooK^00<0?EV[0?of
kP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP080?ofkP<0?EV[2P3om^h00`0mFJ/0ooK^0?ofkP080?of
kP030000003om^h0ooK^0680ooK^0@3oool00240ooK^0P0000190?ofkP030=@m6@3om^h0ooK^00D0
ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^0100
ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0D0?ofkP030=@m6@3om^h0ooK^0080ooK^0P3D?AT>0?of
kP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h01`3om^h40=@m6@<0ooK^00<0e3dI0?of
kP3om^h00P3om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0e3dI00<0ooK^103D?AT00`3o
m^h0e3dI0=@m6@020?ofkP030=@m6@3om^h0e3dI0080e3dI5@3om^h603eIZ`@0ooK^0P0mFJ/00`3o
m^h0?EV[03eIZ`040?ofkP80?EV[0P3om^h0100mFJ/0ooK^0?ofkP3om^h203eIZ`D0ooK^0P0mFJ/2
0?ofkP030000003om^h0ooK^00<0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`020?ofkP80?EV[3@3o
m^h203eIZ`D0ooK^00<0?EV[0?ofkP3om^h01P3om^h203eIZ`h0ooK^00<0?EV[0?ofkP3om^h01`3o
m^h00`000000ooK^0?ofkP1R0?ofkP40oooo000Q0?ofkP030000003om^h0000004P0ooK^00<0e3dI
0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI
0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^0180ooK^00@0e3dI
0?ofkP3D?AT0e3dI403om^h00`3D?AT0ooK^0?ofkP0?0?ofkP040=@m6@3om^h0ooK^0?ofkPD0e3dI
00<0ooK^0=@m6@3om^h01@3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^0080ooK^
00@0e3dI0?ofkP3om^h0e3dI103om^h00`3D?AT0ooK^0=@m6@020=@m6@<0ooK^00<0e3dI0?ofkP3D
?AT00P3D?ATB0?ofkPD0?EV[0P3om^h00`0mFJ/0ooK^03eIZ`0503eIZ`P0ooK^0`0mFJ/00`3om^h0
?EV[03eIZ`040?ofkP<0?EV[1@3om^h00`000000ooK^0?ofkP020?ofkP0403eIZ`3om^h0ooK^0?of
kP<0?EV[303om^h303eIZ`030?ofkP0mFJ/0ooK^00D0ooK^00<0?EV[0?ofkP3om^h00P3om^h303eI
Za00ooK^00<0?EV[0?ofkP3om^h0203om^h00`000000ooK^0?ofkP1Q0?ofkP40oooo000P0?ofkP05
0000003om^h0ooK^0?ofkP000000AP3om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^
00T0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^
00D0ooK^00<0e3dI0?ofkP3om^h04P3om^h00`3D?AT0ooK^0?ofkP0A0?ofkP030=@m6@3om^h0ooK^
00h0ooK^103D?AT50?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h00P3om^h01@3D
?AT0ooK^0?ofkP3om^h0e3dI0080ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP03
0=@m6@80ooK^00@0e3dI0?ofkP3D?AT0e3dI3`3om^h503eIZ`@0ooK^1P0mFJ/<0?ofkP<0?EV[103o
m^h203eIZ`P0ooK^00<000000?ofkP3om^h00P3om^h0100mFJ/0ooK^03eIZ`0mFJ/20?ofkP0303eI
Z`3om^h0ooK^00P0ooK^0P0mFJ/40?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h0
0P0mFJ/D0?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<000000?ofkP3om^h0H@3om^h10?ooo`00803o
m^h00`000000ooK^0?ofkP020?ofkP800000@`3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3o
m^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3o
m^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h0403om^h00`3D?AT0ooK^0=@m6@0C0?ofkP030=@m6@3o
m^h0ooK^00/0ooK^0P3D?AT20?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h01P3o
m^h00`3D?AT0ooK^0?ofkP020?ofkP040=@m6@3om^h0ooK^0=@m6@@0ooK^00<0e3dI0?ofkP3om^h0
0`3om^h0103D?AT0ooK^0=@m6@3om^h40=@m6@80ooK^0P3D?AT<0?ofkPD0?EV[103om^h503eIZ``0
ooK^100mFJ/00`3om^h0?EV[0?ofkP0303eIZ`X0ooK^00@000000?ofkP3om^h0ooK^0`0mFJ/40?of
kP0303eIZ`3om^h0ooK^00D0ooK^0`0mFJ/70?ofkP0303eIZ`3om^h0ooK^00<0ooK^0`0mFJ/G0?of
kP0303eIZ`3om^h0ooK^00L0ooK^00<000000?ofkP3om^h0H03om^h10?ooo`00803om^h00`000000
ooK^0?ofkP040?ofkP030000003om^h0ooK^0400ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0
ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0
ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^00h0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0C0?of
kP030=@m6@3om^h0ooK^00L0ooK^0`3D?AT50?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?of
kP3om^h01`3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0e3dI00D0ooK^00<0e3dI0?of
kP3om^h00`3om^h20=@m6@80ooK^00P0e3dI0?ofkP3D?AT0e3dI0?ofkP3D?AT0ooK^0=@m6@P0ooK^
1@0mFJ/40?ofkPH0?EV[2`3om^h303eIZ`<0ooK^00@0?EV[0?ofkP0mFJ/0?EV[3@3om^h010000000
ooK^03eIZ`0mFJ/20?ofkP0303eIZ`3om^h0ooK^00<0ooK^00@0?EV[0?ofkP3om^h0ooK^0`0mFJ/:
0?ofkP0403eIZ`3om^h0ooK^0?ofkP80?EV[0P3om^h00`0mFJ/0ooK^0?ofkP0E0?ofkP0303eIZ`3o
m^h0ooK^00P0ooK^00<000000?ofkP3om^h0G`3om^h10?ooo`00803om^h00`000000ooK^0?ofkP05
0?ofkP030000003om^h0ooK^03h0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP04
0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP09
0?ofkP030=@m6@3om^h0ooK^00`0ooK^0P3D?AT50?ofkP030=@m6@3om^h0ooK^0140ooK^00<0e3dI
0?ofkP3om^h00`3om^h30=@m6@T0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0;0?ofkP030=@m6@3o
m^h0ooK^0080ooK^0P3D?AT60?ofkP030=@m6@3om^h0ooK^0080ooK^00D0e3dI0?ofkP3D?AT0ooK^
0=@m6@030?ofkP<0e3dI00<0ooK^0=@m6@3om^h0103om^h503eIZ`030?ofkP0mFJ/0?EV[00<0?EV[
00D0ooK^03eIZ`0mFJ/0ooK^03eIZ`0:0?ofkP80?EV[1@3om^h303eIZ`80ooK^00<0?EV[0?ofkP3o
m^h02@3om^h00`0mFJ/0000003eIZ`040?ofkP0303eIZ`3om^h0ooK^00<0ooK^100mFJ/=0?ofkP@0
?EV[103om^h00`0mFJ/0ooK^0?ofkP0F0?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<000000?ofkP3o
m^h0G`3om^h10?ooo`007`3om^h00`000000ooK^0?ofkP070?ofkP030000003om^h0ooK^03d0ooK^
00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00l0ooK^
00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00X0ooK^
00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP0A0?ofkP030=@m6@3om^h0ooK^0080e3dI
3@3om^h0103D?AT0ooK^0?ofkP3D?AT<0?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3o
m^h01@3om^h00`3D?AT0ooK^0?ofkP020?ofkP80e3dI0P3om^h0103D?AT0ooK^0?ofkP3om^h30=@m
6@030?ofkP3D?AT0ooK^00D0?EV[103om^h203eIZ`040?ofkP0mFJ/0?EV[03eIZ`<0ooK^00<0?EV[
0?ofkP3om^h01@3om^h303eIZ`D0ooK^0P0mFJ/00`3om^h0?EV[0?ofkP020?ofkP0303eIZ`3om^h0
ooK^00L0ooK^0P0mFJ/00`3om^h000000?ofkP040?ofkP0303eIZ`3om^h0ooK^0080ooK^0`0mFJ/>
0?ofkP80?EV[203om^h00`0mFJ/0ooK^0?ofkP0E0?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<00000
0?ofkP3om^h0GP3om^h10?ooo`007`3om^h00`000000ooK^0?ofkP080?ofkP030000003om^h0ooK^
03/0ooK^00<0e3dI0?ofkP3om^h0403om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI0180ooK^00<0e3dI
0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI
0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP0A0?ofkP80e3dI403om^h20=@m6@030?ofkP3D?AT0
ooK^00/0ooK^00@0e3dI0?ofkP3om^h0ooK^0P3D?AT70?ofkP030=@m6@3om^h0ooK^0080ooK^00D0
e3dI0?ofkP3om^h0ooK^0=@m6@030?ofkP<0e3dI00<000000=@m6@0mFJ/00P0mFJ/30?ofkPH0?EV[
0`3om^h00`0mFJ/0ooK^03eIZ`050?ofkP<0?EV[1@3om^h303eIZ`<0ooK^00<0?EV[0?ofkP3om^h0
0P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP<0?EV[0P3om^h2000000D0ooK^00<0?EV[0?ofkP0mFJ/0
0P0mFJ/30?ofkP0303eIZ`3om^h0ooK^00P0ooK^0`0mFJ/00`3om^h0?EV[0?ofkP070?ofkP0303eI
Z`3om^h0ooK^01D0ooK^0P0mFJ/90?ofkP030000003om^h0ooK^05h0ooK^0@3oool001l0ooK^00<0
00000?ofkP3om^h02@3om^h00`000000ooK^0?ofkP0j0?ofkP030=@m6@3om^h0ooK^0140ooK^00<0
e3dI0?ofkP3D?AT0503om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI0140ooK^00<0e3dI0?ofkP3om^h0
1P3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00h0ooK^0P3D?AT00`3om^h0e3dI
0?ofkP0?0?ofkP80e3dI0P3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0e3dI0080ooK^
00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP020?ofkP80e3dI0`3om^h00`3D?AT00000
000000020=@m6@0400H94P3D?AT0e3dI03eIZ`<0ooK^0P0mFJ/00`3om^h0?EV[03eIZ`070?ofkP80
?EV[0P3om^h303eIZ`D0ooK^0`0mFJ/60?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3o
m^h00P0mFJ/30?ofkP8000000P3om^h010000000ooK^0?ofkP3om^h303eIZ`H0ooK^00<0?EV[0?of
kP3om^h01P3om^h203eIZ`D0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP0B0?of
kP80?EV[00<0ooK^03eIZ`3om^h02@3om^h00`000000ooK^0?ofkP1M0?ofkP40oooo000O0?ofkP03
0000003om^h0ooK^00X0ooK^00<000000?ofkP3om^h0>03om^h00`3D?AT0ooK^0?ofkP0C0?ofkP03
0=@m6@3om^h0ooK^01@0ooK^00<0e3dI0?ofkP3D?AT04`3om^h00`3D?AT0ooK^0?ofkP040?ofkP03
0=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h0303om^h20=@m6@@0ooK^00<0e3dI0?ofkP3o
m^h03@3om^h20=@m6@80ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0=@m6@030?ofkP03
0=@m6@3om^h0ooK^00@0ooK^00L0e3dI0?ofkP3om^h0ooK^0=@m6@3om^h0e3dI00D0000000@01PTB
0=@m6@3D?AT01PTB0P3D?AT00`000000?EV[03eIZ`0303eIZ`X0ooK^0`0mFJ/60?ofkP80?EV[2@3o
m^h00`0mFJ/0ooK^0?ofkP030?ofkP<0?EV[0P3om^h3000000@0ooK^00H000000?ofkP0mFJ/0?EV[
0?ofkP0mFJ/80?ofkP0303eIZ`3om^h0ooK^0080ooK^0`0mFJ/70?ofkP0303eIZ`3om^h0ooK^00H0
ooK^00<0?EV[0?ofkP3om^h03`3om^h303eIZ`@0ooK^00<0?EV[0?ofkP3om^h0203om^h00`000000
ooK^0?ofkP1L0?ofkP40oooo000N0?ofkP030000003om^h0ooK^00`0ooK^0P00000h0?ofkP80e3dI
4`3om^h00`3D?AT0ooK^0=@m6@0F0?ofkP030=@m6@3om^h0ooK^01<0ooK^00@0e3dI0?ofkP3om^h0
ooK^0P3D?AT?0?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0
ooK^0?ofkP0<0?ofkP030=@m6@3om^h0e3dI0080ooK^00<0e3dI0?ofkP3om^h02P3om^h20=@m6@<0
ooK^00<0e3dI0?ofkP3om^h01@3om^h01P3D?AT0ooK^0?ofkP3D?AT000000=@m6@8000001@062A80
1@3D?AT000000000000=41h0e3dI0080?EV[2`3om^h303eIZ`030?ofkP0mFJ/0ooK^0080ooK^0`0m
FJ/;0?ofkP0303eIZ`3om^h0ooK^00<0?EV[0P3om^h3000000H0ooK^0P0mFJ/01@000000ooK^0?of
kP3om^h0?EV[00P0ooK^00<0?EV[0?ofkP3om^h00P0mFJ/:0?ofkP0303eIZ`3om^h0ooK^00L0ooK^
00<0?EV[0?ofkP3om^h0303om^h203eIZ`L0ooK^00<0?EV[0?ofkP3om^h0203om^h00`000000ooK^
0?ofkP1L0?ofkP40oooo000N0?ofkP030000003om^h0ooK^00h0ooK^00<000000?ofkP3om^h0=03o
m^h0103D?AT0ooK^0?ofkP3D?ATB0?ofkP040=@m6@3om^h0ooK^0=@m6A@0ooK^00<0e3dI0?ofkP3D
?AT05@3om^h00`3D?AT0ooK^0=@m6@0B0?ofkP030=@m6@3om^h0ooK^00L0ooK^0P3D?AT80?ofkP03
0=@m6@3om^h0ooK^00/0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@020?ofkP030=@m6@3om^h0ooK^
00T0ooK^0P3D?AT40?ofkP030=@m6@3om^h0ooK^00H0e3dI00H01PPA0=@m6@0000001PTB0=@m6@00
000200H94P<000000P3D?AT300d@7P8000002@3om^h203eIZ`030?ofkP0mFJ/0ooK^0080ooK^0`0m
FJ/>0?ofkP<0?EV[0`3om^h2000000030?ofkP0mFJ/0ooK^00@0ooK^0P0mFJ/30?ofkP040000003o
m^h0ooK^03eIZ`P0ooK^0`0mFJ/<0?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h0
203om^h303eIZ`X0ooK^00<0?EV[0?ofkP3om^h0203om^h00`000000ooK^0?ofkP1K0?ofkP40oooo
000N0?ofkP030000003om^h0ooK^00l0ooK^00<000000?ofkP3om^h0<`3om^h01@3D?AT0ooK^0?of
kP3om^h0e3dI0100ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP0@0?ofkP050=@m
6@3om^h0ooK^0?ofkP3D?AT05@3om^h00`3D?AT0ooK^0?ofkP0B0?ofkP030=@m6@3om^h0ooK^00D0
ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^0080
ooK^00@0e3dI0?ofkP3om^h0e3dI2@3om^h:0=@m6@<0ooK^100000001@3D?AT01PTB00H94P062A80
e3dI008000000`0=41h00`3D?AT03A0N0=@m6@0200d@7P8000001P3om^h303eIZ`<0ooK^00H0?EV[
0?ofkP0mFJ/0?EV[0?ofkP0mFJ/=0?ofkP<0?EV[0P3om^h3000000<0ooK^00<0?EV[0?ofkP3om^h0
0`0mFJ/60?ofkP040000003om^h0ooK^03eIZ`@0ooK^0`0mFJ/20?ofkP0303eIZ`3om^h0ooK^00/0
ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP060?ofkP80?EV[3@3om^h00`0mFJ/0
ooK^0?ofkP090?ofkP030000003om^h0ooK^05X0ooK^0@3oool001h0ooK^00<000000?ofkP3om^h0
403om^h00`000000ooK^0?ofkP0a0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h0
3@3om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h0
0P3om^h00`3D?AT0ooK^0?ofkP0A0?ofkP030=@m6@3om^h0e3dI01@0ooK^00<0e3dI0?ofkP3om^h0
0P3om^h20=@m6@d0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP040?ofkP050=@m
6@3om^h0ooK^0=@m6@3om^h01`3D?AT01@3om^h0e3dI0?ofkP3om^h0e3dI00@0ooK^00<0e3dI0000
000000000P00000300H94P060=@m6@062A8000000000000=41h0e3dI100=41h01@3D?AT03A0N00d@
7P3D?AT03A0N00<000000`3om^h203eIZ`D0ooK^0`0mFJ/40?ofkP0303eIZ`3om^h0ooK^00L0ooK^
0`0mFJ/20?ofkP<000001P3om^h303eIZ`T0ooK^00@000000?ofkP3om^h0?EV[0P3om^h203eIZ`D0
ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^0080
ooK^0`0mFJ/@0?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<000000?ofkP3om^h0FP3om^h10?ooo`00
7P3om^h00`000000ooK^0?ofkP0A0?ofkP030000003om^h0ooK^0300ooK^00<0e3dI0?ofkP3om^h0
103om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h0
3@3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00l0ooK^00D0e3dI0?ofkP3om^h0
ooK^0=@m6@0D0?ofkP040=@m6@3om^h0e3dI0=@m6A00ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D
?AT0ooK^0?ofkP050?ofkPD0e3dI1`3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^
0080000000<0e3dI00H94P0000000`062A800`3D?AT000000000000300d@7P030000003D?AT03A0N
00<03A0N00D0e3dI00d@7P000000e3dI01LL?00300000080?EV[1@3om^h203eIZ`030?ofkP0mFJ/0
ooK^00D0ooK^00<0?EV[0?ofkP3om^h0103om^h203eIZ`<0ooK^0P0000000`0mFJ/0ooK^0?ofkP04
0?ofkP80?EV[0P3om^h00`0mFJ/0ooK^0?ofkP080?ofkP030000003om^h0?EV[0080?EV[203om^h0
0`0mFJ/0ooK^0?ofkP090?ofkP80?EV[2P3om^h00`0mFJ/0ooK^0?ofkP0203eIZa<0ooK^00<0?EV[
0?ofkP3om^h02@3om^h00`000000ooK^0?ofkP1I0?ofkP40oooo000M0?ofkP030000003om^h0ooK^
01<0ooK^00<000000?ofkP3om^h0;P3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^
00X0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^
00H0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^
0180ooK^00<0e3dI0?ofkP3om^h04@3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^
00<0ooK^0P3D?AT20?ofkP030=@m6@3om^h0e3dI00L0ooK^00<0e3dI0?ofkP3om^h00`3om^h30000
000803eIZ`062A80e3dI00H94P0000001PTB0000003D?AT600d@7P070=@m6@0=41h03A0N00d@7P00
0000e3dI0000000201LL?0030=@m6@000000Y2X?00800000103om^h203eIZ`<0ooK^00<0?EV[0?of
kP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP0303eIZ`80ooK^0`0000020?ofkP0403eIZ`3om^h0ooK^
0?ofkP<0?EV[1@3om^h00`0mFJ/0ooK^0?ofkP060?ofkP80?EV[00<0000003eIZ`3om^h02P3om^h0
0`0mFJ/0ooK^0?ofkP060?ofkP80?EV[00<0ooK^03eIZ`3om^h02@3om^h303eIZaD0ooK^00<0?EV[
0?ofkP3om^h02@3om^h00`000000ooK^0?ofkP1I0?ofkP40oooo000M0?ofkP030000003om^h0ooK^
01@0ooK^00<000000?ofkP3om^h0;@3om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^
00P0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^
00P0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^
0100ooK^00<0e3dI0?ofkP3D?AT04`3om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^
0080ooK^0P3D?AT50?ofkP030=@m6@3om^h0e3dI00H0ooK^00<0e3dI0?ofkP3om^h00`00000600H9
4P050=@m6@000000000000d@7P3D?AT01P0=41h01P000000e3dI0000000000005a`l0=@m6@@05a`l
00<0e3dI0:@Z3`0000000P00000303eIZ`D0ooK^00<0?EV[0?ofkP3om^h01@3om^h303eIZ`<0ooK^
0P0000050?ofkP0403eIZ`3om^h0?EV[03eIZ`P0ooK^00<0?EV[0?ofkP3om^h0103om^h203eIZ`80
ooK^00<0000003eIZ`3om^h02P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP<0?EV[0`3om^h00`0mFJ/0
ooK^0?ofkP050?ofkP<0?EV[00<0ooK^03eIZ`3om^h05P3om^h00`0mFJ/0ooK^0?ofkP090?ofkP03
0000003om^h0ooK^05P0ooK^0@3oool001d0ooK^00<000000?ofkP3om^h05@3om^h2000002d0ooK^
00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00X0ooK^
00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00X0ooK^
00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP80e3dI0`3om^h00`3D?AT0ooK^
0?ofkP0@0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h00P3D?AT80?ofkP030=@m
6@3om^h0e3dI00D0ooK^00D0e3dI0000000000001PTB0000000400H94P<0000000D03A0N0=@m6@0=
41h03A0N0=@m6@0500d@7P<0000000@0e3dI01LL?00G73`0e3dI100G73`00`3D?AT000000:@Z3`02
03eIZ`P0ooK^00<0?EV[0?ofkP3om^h00P3om^h303eIZ`80ooK^00@0?EV[00000000000000001P3o
m^h303eIZ`/0ooK^00<0?EV[0?ofkP3om^h00`0mFJ/50?ofkP030000003om^h0ooK^00X0ooK^00<0
?EV[0?ofkP3om^h00P0mFJ/70?ofkP0403eIZ`3om^h0ooK^0?ofkP<0?EV[1@3om^h00`0mFJ/0ooK^
0?ofkP0D0?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<000000?ofkP3om^h0E`3om^h10?ooo`007@3o
m^h00`000000ooK^0?ofkP0G0?ofkP030000003om^h0ooK^02T0ooK^00<0e3dI0?ofkP3om^h02P3o
m^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h01P3o
m^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00L0ooK^0P3D?AT;0?ofkP030=@m6@3o
m^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP0@0?ofkP060=@m6@3o
m^h0ooK^0?ofkP3D?AT0ooK^0P3D?AT:0?ofkP040=@m6@3om^h0ooK^0=@m6@<0ooK^00<0e3dI0000
000000000P062A800`0000001PTB00000002000000@03A0N00@0e3dI00d@7P0=41h0e3dI0P0=41h3
0000000701LL?00000005a`l01LL?03D?AT05a`l0=@m6@0501LL?080?EV[00<0Y2X?000000000000
1`3om^h00`0mFJ/0ooK^0?ofkP0203eIZ`<0ooK^0`0000000`0mFJ/0ooK^0?ofkP040?ofkP80?EV[
00<0ooK^03eIZ`3om^h02`3om^h303eIZ`P0ooK^00<0?EV[0000003om^h02P3om^h303eIZ`T0ooK^
00@0?EV[0?ofkP0mFJ/0?EV[203om^h00`0mFJ/0ooK^0?ofkP0E0?ofkP0303eIZ`3om^h0ooK^00T0
ooK^00<000000?ofkP3om^h0E`3om^h10?ooo`00703om^h00`000000ooK^0?ofkP0I0?ofkP030000
003om^h0ooK^02P0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m
6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m
6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m
6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h0403om^h00`3D?AT0ooK^0?ofkP020=@m6@d0ooK^
00L0e3dI0?ofkP3om^h0e3dI03eIZ`000000e3dI00<01PTB0`00000700d@7P040000003D?AT00000
0=@m6@800000100G73`0100000005a`l01LL?00G73`20=@m6@@05a`l0P0000030:@Z3`8000001P3o
m^h303eIZ`<0ooK^0P0000030?ofkP0403eIZ`3om^h0ooK^0?ofkP<0?EV[0`3om^h00`0mFJ/0ooK^
0?ofkP070?ofkP<0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0000000L0ooK^
0`0mFJ/00`3om^h0?EV[0?ofkP080?ofkP<0?EV[2`3om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP0303eI
Z`3om^h0ooK^00X0ooK^00<000000?ofkP3om^h0EP3om^h10?ooo`00703om^h00`000000ooK^0?of
kP0J0?ofkP030000003om^h0ooK^02H0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?of
kP020?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?of
kP0>0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?of
kP060?ofkP80e3dI2P3om^h00`3D?AT0ooK^0?ofkP0@0?ofkP80e3dI3P3om^h30000000603eIZ`3D
?AT0000000H94P3D?AT01PTB0P0000000`0=41h0000000d@7P0600d@7P<000000P3D?AT601LL?008
0000000G73`05a`l01LL?03D?AT05a`l0=@m6@0G73`200000003020ZF@00000000000080Y2X?0P00
00030?ofkP@0?EV[0P3om^h3000000H0ooK^0`0mFJ/60?ofkP0303eIZ`3om^h0ooK^00D0ooK^0P0m
FJ/50?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0000003om^h0103om^h203eIZ`D0ooK^00<0
?EV[0?ofkP3om^h00`3om^h303eIZ`030?ofkP0mFJ/0ooK^00/0ooK^00<0?EV[0?ofkP3om^h05@3o
m^h00`0mFJ/0ooK^0?ofkP090?ofkP030000003om^h0ooK^05H0ooK^0@3oool001`0ooK^00<00000
0?ofkP3om^h06`3om^h00`000000ooK^0?ofkP0U0?ofkP030=@m6@3om^h0ooK^00h0ooK^00@0e3dI
0?ofkP3om^h0e3dI4P3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI0140ooK^00D0e3dI0?ofkP3om^h0
ooK^0=@m6@0B0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0
ooK^0?ofkP0>0?ofkP80e3dI00<0ooK^0=@m6@3om^h02`3om^h20000000500H84@0mFJ/0?EV[00H9
4P0000000P3D?AT2000000<03A0N00<0000000d@7P0=41h00`0=41h20000000501LL?00000005a`l
01LL?03D?AT01`0G73`0100000005a`l01LL?00G73`20=@m6@070000000P:UT082YI020ZF@000000
d3PE000000020:@Z3`8000000P0mFJ/30?ofkP<000001`3om^h203eIZ`030?ofkP0mFJ/0ooK^00L0
ooK^00@0?EV[0?ofkP3om^h0ooK^0`0mFJ/80?ofkP0303eIZ`3om^h0ooK^00H0ooK^00@0?EV[0?of
kP000000ooK^0`0mFJ/70?ofkP0303eIZ`3om^h0ooK^00<0?EV[1@3om^h00`0mFJ/0ooK^0?ofkP0:
0?ofkP0303eIZ`3om^h0ooK^01<0ooK^0P0mFJ/<0?ofkP030000003om^h0ooK^05D0ooK^0@3oool0
01`0ooK^00<000000?ofkP3om^h0703om^h00`000000ooK^0?ofkP0S0?ofkP030=@m6@3om^h0ooK^
0100ooK^00<0e3dI0?ofkP3D?AT04`3om^h00`3D?AT0ooK^0=@m6@0C0?ofkP030=@m6@3om^h0e3dI
01@0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^
00/0ooK^0P3D?AT20?ofkP030=@m6@3om^h0e3dI00T0ooK^00<01PPA0000000000000P00000200H9
4P04000000062A8000000=@m6@D03A0N00@0000000d@7P0=41h03A0N0P00000301LL?0030000000G
73`05a`l0080e3dI1P0G73`01P0000005a`l00000000000082YI0=@m6@@082YI00D000000=0h5@3@
>1D000000:@Z3`0300000080ooK^0P0000000`0mFJ/0ooK^0?ofkP040?ofkP<0?EV[103om^h00`0m
FJ/0ooK^0?ofkP050?ofkP@0?EV[303om^h00`0mFJ/0ooK^0?ofkP050?ofkP0403eIZ`3om^h0?EV[
000000X0ooK^0`0mFJ/80?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h0403om^h3
03eIZ`030?ofkP0mFJ/0ooK^00`0ooK^00<000000?ofkP3om^h0E03om^h10?ooo`00703om^h00`00
0000ooK^0?ofkP0M0?ofkP030000003om^h0ooK^0280ooK^00<0e3dI0?ofkP3om^h04@3om^h00`3D
?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h0503om^h0103D
?AT0ooK^0=@m6@3D?AT@0?ofkP030=@m6@3om^h0ooK^00P0ooK^0P3D?AT30?ofkP050=@m6@3om^h0
e3dI0?ofkP3D?AT01P3om^h010062140000000000000000400H94P<0000000<0e3dI00d@7P3D?AT0
100=41h0100000003A0N00000000000501LL?0030000000G73`0e3dI00805a`l00<0e3dI01LL?00G
73`00P0G73`3000000<082YI0P3D?AT3020ZF@070000003@>1D0d3PE0000002T:Pl000000:@Z3`03
00000080ooK^00@0?EV[0?ofkP3om^h0ooK^0`0mFJ/70?ofkP0303eIZ`3om^h0ooK^00@0ooK^0P0m
FJ/?0?ofkP0303eIZ`3om^h0ooK^00@0ooK^0`0mFJ/20?ofkP030000003om^h0ooK^00@0ooK^0`0m
FJ/00`3om^h0?EV[0?ofkP080?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h0303o
m^h303eIZ`D0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`000000ooK^0?ofkP1D0?ofkP40oooo000K
0?ofkP030000003om^h0ooK^01l0ooK^0P00000R0?ofkP80e3dI4P3om^h20=@m6A<0ooK^00<0e3dI
0?ofkP3D?AT04`3om^h00`3D?AT0ooK^0=@m6@0F0?ofkP030=@m6@3om^h0ooK^0140ooK^00<0e3dI
0?ofkP3om^h01@3om^h20=@m6@@0ooK^00@0e3dI0?ofkP3om^h0ooK^0P3D?AT30?ofkP0300000006
21400000008000000`062A830000000400d@7P0000003A0N0=@m6@803A0N00<0e3dI00d@7P0=41h0
0`00000801LL?0050000003D?AT05a`l01LL?03D?AT00P0G73`200000003020ZF@00000082YI00<0
82YI00<0e3dI020ZF@3D?AT00`0P:UT00`000000d3PE0=0h5@03000000030:@Z3`000000ooK^0080
ooK^00@0?EV[0?ofkP0mFJ/0?EV[2`3om^h00`0mFJ/0ooK^0?ofkP0303eIZ`030?ofkP0mFJ/0ooK^
00l0ooK^00<0?EV[0?ofkP3om^h00`0mFJ/00`3om^h0?EV[0?ofkP020?ofkP030000003om^h0ooK^
0080ooK^0P0mFJ/50?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0m
FJ/0ooK^0?ofkP0:0?ofkP80?EV[203om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP030000003om^h0ooK^
05<0ooK^0@3oool001/0ooK^00<000000?ofkP3om^h08@3om^h00`000000ooK^0?ofkP0O0?ofkP03
0=@m6@3om^h0e3dI0100ooK^00@0e3dI0?ofkP3om^h0e3dI4P3om^h0103D?AT0ooK^0?ofkP3D?ATA
0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT0503om^h00`3D?AT0ooK^0=@m6@0C0?ofkP030=@m6@3o
m^h0ooK^0080ooK^0P3D?AT60?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0000000000000`00
000200H94P@00000100=41h00`000000e3dI00d@7P0300d@7P040=@m6@0000005a`l000000T05a`l
00L000000=@m6@0G73`05a`l0000003D?AT0000000<082YI00<00000020ZF@0P:UT00P0P:UT00`3D
?AT082YI0=@m6@03020ZF@<0000000@0d3PE000000000000Y2X?0P000000103om^h0?EV[03eIZ`0m
FJ/=0?ofkP<0?EV[103om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP<0?EV[103om^h00`0mFJ/0ooK^0?of
kP020?ofkP040000000mFJ/0?EV[03eIZ`L0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^
0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00H0ooK^0`0mFJ/:0?ofkP0303eIZ`3om^h0ooK^00/0ooK^
00<000000?ofkP3om^h0D`3om^h10?ooo`006`3om^h00`000000ooK^0?ofkP0R0?ofkP030000003o
m^h0ooK^01d0ooK^00@0e3dI0?ofkP3om^h0ooK^0P3D?AT>0?ofkP050=@m6@3om^h0ooK^0?ofkP3D
?AT0403om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3o
m^h00P3om^h00`3D?AT0ooK^0?ofkP0@0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT04`3om^h0103D
?AT0ooK^0=@m6@3D?AT70?ofkP030=@m6@3om^h0ooK^00@0000000<0e3dI000000062A800P062A83
000000H03A0N00@0000000d@7P3D?AT03A0N0`000000100G73`0e3dI01LL?000000901LL?0040=@m
6@0G73`000000000008082YI00D0e3dI020ZF@0P:UT082YI00000004020ZF@040=@m6@0P:UT082YI
0=@m6@<00000103@>1D00`000000Y2X?0:@Z3`0203eIZ`030?ofkP0mFJ/0ooK^00/0ooK^0P0mFJ/2
0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h02`3om^h303eIZ`030?ofkP0mFJ/0
ooK^00D0ooK^00<0?EV[0?ofkP0mFJ/00P0mFJ/00`000000ooK^0?ofkP080?ofkP0303eIZ`3om^h0
ooK^00H0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP030?ofkP<0?EV[3P3om^h0
0`0mFJ/0ooK^0?ofkP0;0?ofkP030000003om^h0ooK^0580ooK^0@3oool001/0ooK^00<000000?of
kP3om^h08`3om^h00`000000ooK^0?ofkP0L0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?of
kP3om^h02P3om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?of
kP3om^h00`3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?of
kP3om^h03P3om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^0140ooK^00<0e3dI0?of
kP3om^h01P3om^h0103D?AT0ooK^0000000621440000000300H94P3D?AT01PTB0080000000<03A0N
0000000=41h01P0=41h010000000e3dI00000000000501LL?0030=@m6@0000005a`l00L05a`l00<0
00000=@m6@0000001@0P:UT0103D?AT082YI020ZF@000004020ZF@070=@m6@0P:UT000000000003D
?AT082YI000000040=0h5@<0?EV[0`0000000`0mFJ/0ooK^0?ofkP070?ofkP<0?EV[103om^h00`0m
FJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00T0ooK^0P0mFJ/50?ofkP0303eIZ`3om^h0ooK^
00<0ooK^0P0mFJ/30?ofkP030000003om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0m
FJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0?EV[0080?EV[4@3om^h00`0mFJ/0ooK^0?ofkP0<0?of
kP030000003om^h0ooK^0540ooK^0@3oool001X0ooK^00<000000?ofkP3om^h09@3om^h00`000000
ooK^0?ofkP0K0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0
ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0
ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0
ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3D?AT01P3om^h00`3D?AT0
000000H84@030000000600H94P0000001PTB00H94P000000e3dI0`0=41h00`0000003A0N00d@7P04
00d@7P80000000<0e3dI01LL?00G73`01P0G73`00`3D?AT05a`l01LL?00401LL?080000000<082YI
0=@m6@0P:UT01P0P:UT0103D?AT082YI020ZF@000002020ZF@<000000`0P:UT0103D?AT000000=0h
5@3@>1D203eIZ`8000000P2T:Pl20000000303eIZ`3om^h0ooK^00D0ooK^0P0mFJ/80?ofkP0303eI
Z`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h01@3om^h303eIZ`L0ooK^00<0?EV[0?ofkP3om^h0
100mFJ/50?ofkP030000003om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^
0?ofkP0;0?ofkP<0?EV[503om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP030000003om^h0ooK^0540ooK^
0@3oool001X0ooK^00<000000?ofkP3om^h09P3om^h00`000000ooK^0?ofkP0J0?ofkP030=@m6@3o
m^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3o
m^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h01`3om^h20=@m6@T0ooK^00<0e3dI0?ofkP3om^h0203o
m^h20=@m6@/0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP050=@m6@3o
m^h0ooK^0?ofkP3D?AT0103om^h00`3D?AT01PPA00000002000000<01PTB0`00000200d@7P030=@m
6@0=41h0000000D03A0N0P0000000`0G73`0e3dI01LL?00801LL?0040=@m6@0G73`05a`l01LL?0<0
00000P0P:UT00`3D?AT00000020ZF@06020ZF@030=@m6@0P:UT082YI00<0000000@0e3dI020ZF@0P
:UT082YI0P000000100X=g40000003eIZ`0mFJ/20=0h5@080000003@>1D000000:@Z3`000000Y2X?
03eIZ`0000030?ofkP<0?EV[2`3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00@0ooK^0`0mFJ/:0?of
kP<0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP040?ofkP030000003om^h0ooK^00L0ooK^00<0?EV[0?of
kP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP070?ofkP<0?EV[00<0ooK^03eIZ`3om^h05@3om^h00`0m
FJ/0ooK^0?ofkP0<0?ofkP030000003om^h0ooK^0500ooK^0@3oool001X0ooK^00<000000?ofkP3o
m^h09`3om^h00`000000ooK^0?ofkP0H0?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3o
m^h01P3om^h00`3D?AT0ooK^0?ofkP070?ofkP80e3dI2@3om^h00`3D?AT0ooK^0?ofkP090?ofkP03
0=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP070?ofkP03
0=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h02`3om^h20=@m6@D0ooK^00L0e3dI0?ofkP00
00001PPA0=@m6@0mFJ/0000000<01PTB0`00000400d@7P030=@m6@0=41h0000000<03A0N0P000003
01LL?0030=@m6@0G73`05a`l00L05a`l00@000000=@m6@00000000001@0P:UT00`3D?AT00000020Z
F@07020ZF@<000000P0P:UT0103D?AT0000000000000000302PgL@030000003`@QX000000080d3PE
00<000000=0h5@3@>1D00P0000000`2T:Pl0?EV[0000000303eIZ`h0ooK^00H0?EV[0?ofkP3om^h0
ooK^03eIZ`3om^h303eIZ`X0ooK^0`0mFJ/00`3om^h0?EV[0?ofkP030?ofkP0303eIZ`3om^h0ooK^
00D0ooK^00<000000?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^
00@0ooK^0`0mFJ/50?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h0303om^h00`00
0000ooK^0?ofkP1@0?ofkP40oooo000J0?ofkP030000003om^h0ooK^02P0ooK^0P00000H0?ofkP03
0=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP090?ofkP03
0=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP040?ofkP03
0=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP03
0=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h01@3om^h3000000030=@m6@062A8000000080
1PTB0P0000000`0=41h0000000d@7P0500d@7P030=@m6@0000003A0N00800000100G73`00`3D?AT0
000001LL?00701LL?0<0000000<0e3dI020ZF@0P:UT0100P:UT00`3D?AT00000020ZF@04020ZF@<0
000000H082YI0=@m6@00000082YI0000003D?AT602PgL@040000003`@QX0l48J00000080d3PE00P0
00000=0h5@3@>1D000000:@Z3`0mFJ/0Y2X?00000140ooK^00<0?EV[0?ofkP0mFJ/00P0mFJ/;0?of
kP80?EV[1@3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00L0ooK^00<000000?ofkP3om^h01`3om^h0
0`0mFJ/0ooK^0?ofkP040?ofkP80?EV[103om^h203eIZ`P0ooK^00<0?EV[0?ofkP3om^h0503om^h0
0`0mFJ/0ooK^0?ofkP0<0?ofkP030000003om^h0ooK^04l0ooK^0@3oool001T0ooK^00<000000?of
kP3om^h0:`3om^h00`000000ooK^0?ofkP0E0?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?of
kP3om^h0103om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?of
kP3om^h03@3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?of
kP3om^h00`3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?of
kP3om^h00`3om^h40000000300H94P3D?AT01PTB00@000000P0=41h00`0000003A0N00d@7P0500d@
7P030000003D?AT0000000H05a`l00<0e3dI0000000G73`01@0G73`200000005020ZF@00000082YI
020ZF@3D?AT0100P:UT00`3D?AT082YI00000002020ZF@<00000100P:UT01@000000e3dI0000000X
=g40e3dI00H0:3Ma00@000000?126P3`@QX000000P3@>1D00`000000d3PE0=0h5@020000000403eI
Z`2T:Pl0Y2X?000000l0ooK^0`0mFJ/00`3om^h0?EV[0?ofkP080?ofkP<0?EV[1`3om^h00`0mFJ/0
ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<000000?ofkP3om^h01`3om^h00`0mFJ/0
ooK^0?ofkP0303eIZ`030?ofkP0mFJ/0ooK^00<0?EV[2P3om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP03
03eIZ`3om^h0ooK^00d0ooK^00<000000?ofkP3om^h0CP3om^h10?ooo`006@3om^h00`000000ooK^
0?ofkP0/0?ofkP030000003om^h0ooK^01@0ooK^00<0e3dI0?ofkP3om^h02P3om^h20=@m6@<0ooK^
00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00h0ooK^
00@0e3dI0?ofkP3om^h0e3dI4P3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI0100ooK^00<0e3dI0?of
kP3om^h01@3om^h00`3D?AT0ooK^0?ofkP06000000801PTB00@0e3dI00000000000000001@0=41h0
0`0000003A0N00d@7P0200d@7P<0000000<05a`l0000003D?AT01@0G73`00`3D?AT05a`l00000003
01LL?0<000000`0P:UT01@00000082YI020ZF@0P:UT0e3dI00<082YI00<0e3dI020ZF@0000000P00
0004020ZF@<0000000D0?EV[0000003D?AT0:3Ma0=@m6@0602PgL@070000003`@QX0l48J0?126P00
0000d3PE000000030=0h5@040000002T:Pl0?EV[0:@Z3`800000303om^h203eIZ`80ooK^00<0?EV[
0?ofkP0mFJ/01P3om^h303eIZ`/0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`080?ofkP030000003o
m^h0ooK^00H0ooK^0`0mFJ/30?ofkP<0?EV[3P3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3o
m^h0ooK^00d0ooK^00<000000?ofkP3om^h0CP3om^h10?ooo`006@3om^h00`000000ooK^0?ofkP0]
0?ofkP030000003om^h0ooK^0180ooK^00<0e3dI0?ofkP3om^h03@3om^h0103D?AT0ooK^0?ofkP3D
?AT?0?ofkP040=@m6@3om^h0ooK^0=@m6A80ooK^00<0e3dI0?ofkP3D?AT04`3om^h00`3D?AT0ooK^
0=@m6@0B0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP0000001P0000000`062A800000
0=@m6@02000000H03A0N00<0000000d@7P0000000`00000401LL?0030000000G73`0e3dI00@05a`l
00@0e3dI01LL?00000005a`l0P000006020ZF@030000000P:UT082YI008082YI00<0e3dI020ZF@0P
:UT00`000004020ZF@800000100X=g4010000000e3dI02PgL@3D?AT602PgL@030000003`@QX0l48J
0080l48J0P0000030=0h5@80000000<0?EV[0:@Z3`0000000P0000080?ofkP<0?EV[1@3om^h00`0m
FJ/0ooK^03eIZ`030?ofkP80?EV[3P3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00P0ooK^00<00000
0?ofkP3om^h00`3om^h303eIZ`030?ofkP0mFJ/0ooK^00<0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP0<
0?ofkP0303eIZ`3om^h0ooK^01@0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`000000ooK^0?ofkP1=
0?ofkP40oooo000I0?ofkP030000003om^h0ooK^02h0ooK^00<000000?ofkP3om^h04@3om^h00`3D
?AT0ooK^0?ofkP0>0?ofkP80e3dI4@3om^h00`3D?AT0ooK^0=@m6@0C0?ofkP030=@m6@3om^h0ooK^
01<0ooK^00<0e3dI0?ofkP3om^h04P3om^h00`3D?AT0ooK^0?ofkP020=@m6@@000000P062A840000
000400d@7P3D?AT03A0N000000D03A0N0`00000801LL?0040000000G73`05a`l0=@m6@805a`l00<0
e3dI01LL?00000000P000008020ZF@030000000P:UT082YI00<082YI0P000002020ZF@030000000P
:UT00000008000001P0X=g4010000000:3Ma0=@m6@3D?AT602PgL@030000003`@QX0l48J00<0l48J
00L000000=0h5@3@>1D0d3PE0000003@>1D0?EV[0080Y2X?0`0000040?ofkP<0?EV[203om^h00`0m
FJ/0ooK^03eIZ`0303eIZa40ooK^00@0?EV[0?ofkP3om^h0?EV[2@3om^h00`000000ooK^03eIZ`02
03eIZ`<0ooK^0`0mFJ/50?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h04`3om^h2
03eIZa00ooK^00<000000?ofkP3om^h0C03om^h10?ooo`006@3om^h00`000000ooK^0?ofkP0_0?of
kP030000003om^h0ooK^0100ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP0@0?of
kP030=@m6@3om^h0ooK^0140ooK^00<0e3dI0?ofkP3D?AT04`3om^h00`3D?AT0ooK^0=@m6@0D0?of
kP80e3dI1000000200H94P<000000`0=41h00`3D?AT03A0N0000000400d@7P80000000<05a`l0000
000G73`01`0G73`00`0000005a`l01LL?00201LL?0060=@m6@0G73`0e3dI0000000P:UT000002@0P
:UT00`00000082YI020ZF@0300000003020ZF@3D?AT082YI00<000002@0X=g4010000000:3Ma02Pg
L@3D?AT602PgL@030000003`@QX0l48J00<0l48J0P0000020=0h5@090000003@>1D0?EV[0000002T
:Pl000000:@Z3`000000ooK^00<0?EV[2`3om^h303eIZa@0ooK^00@0?EV[0?ofkP3om^h0?EV[203o
m^h203eIZ`040000003om^h0ooK^0?ofkP<0?EV[00<0ooK^03eIZ`3om^h01@3om^h00`0mFJ/0ooK^
0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00l0ooK^0`0mFJ/00`3om^h0?EV[0?ofkP0?0?ofkP030000
003om^h0ooK^04`0ooK^0@3oool001P0ooK^00<000000?ofkP3om^h0<@3om^h00`000000ooK^0?of
kP0?0?ofkP80e3dI403om^h20=@m6A40ooK^0P3D?ATB0?ofkP040=@m6@3om^h0ooK^0=@m6A40ooK^
00D0e3dI0?ofkP3om^h0ooK^0=@m6@0B0?ofkP<0000000@0?EV[0000000000001PTB0`00000400d@
7P040=@m6@0=41h03A0N000000803A0N0P00000301LL?0030000000G73`05a`l00H05a`l00@00000
01LL?00G73`05a`l0P0000001@3D?AT082YI020ZF@0P:UT0000000T082YI0`000003020ZF@050=@m
6@000000e3dI02PgL@0000002P0X=g400`000000:3Ma02PgL@020=@m6@D0:3Ma00<000000?126P3`
@QX00`3`@QX200000080d3PE00L000000=0h5@0mFJ/000000:@Z3`000000Y2X?0080?EV[303om^h2
03eIZ`030?ofkP0mFJ/0?EV[01D0ooK^00@0?EV[0?ofkP3om^h0?EV[103om^h303eIZ`<0ooK^00<0
000003eIZ`0mFJ/01@3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0
?EV[0?ofkP3om^h0303om^h303eIZ`D0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`000000ooK^0?of
kP1;0?ofkP40oooo000H0?ofkP030000003om^h0ooK^0380ooK^0P00000?0?ofkP030=@m6@3om^h0
e3dI00h0ooK^00@0e3dI0?ofkP3om^h0e3dI3`3om^h0103D?AT0ooK^0?ofkP3D?AT@0?ofkP030=@m
6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m
6@3om^h0ooK^00/0ooK^1P0000000`062A80000000000002000000803A0N00T0000000d@7P0=41h0
3A0N0=@m6@0=41h0e3dI0000000=41h00P00000501LL?0030000000G73`05a`l00H05a`l00P00000
01LL?00000000000020ZF@3D?AT082YI0=@m6@8082YI00<00000020ZF@0P:UT01@0P:UT3000000<0
82YI0P0000001@3D?AT0:3Ma02PgL@3D?AT0000000T0:3Ma00@0000002PgL@0X=g40e3dI0P0X=g40
0`3D?AT0:3Ma02PgL@0202PgL@030000003`@QX0l48J00<0l48J00<000000?126P0000000P3@>1D0
0`000000?EV[0=0h5@0303eIZ`030:@Z3`000000000000P0ooK^0`0mFJ/40?ofkP0303eIZ`3om^h0
ooK^01<0ooK^00D0?EV[0?ofkP3om^h0?EV[0?ofkP0303eIZ`@0ooK^0P0mFJ/00`000000ooK^0?of
kP050?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?of
kP090?ofkP80?EV[203om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP030000003om^h0ooK^04/0ooK^0@3o
ool001P0ooK^00<000000?ofkP3om^h0=03om^h00`000000ooK^0?ofkP0<0?ofkP040=@m6@3om^h0
ooK^0=@m6@d0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0>0?ofkP050=@m6@3om^h0ooK^0?ofkP3D
?AT03`3om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3o
m^h0103om^h00`3D?AT0ooK^0?ofkP070?ofkP<0000000@01PPA00000000000000000P062A820000
00@03A0N00D0000000d@7P0=41h03A0N0=@m6@0200d@7P030000003D?AT0000000H05a`l00<00000
01LL?00G73`01P0G73`30000008082YI00L0e3dI020ZF@0P:UT082YI0=@m6@0P:UT0000000@082YI
0`000002020ZF@060000000P:UT000000000000X=g40e3dI0`0X=g400`3D?AT0000002PgL@0802Pg
L@040000000X=g40:3Ma0=@m6@<0:3Ma00<0e3dI02PgL@0X=g400P0000050?126P050000003`@QX0
l48J0000003@>1D00`0mFJ/01@3@>1D000000000002T:Pl0e3dI008000001@3om^h203eIZ`L0ooK^
00<0?EV[0?ofkP3om^h0503om^h403eIZ`@0ooK^0`0mFJ/30?ofkP030000003om^h0ooK^00D0ooK^
00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00H0ooK^
0`0mFJ/;0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<000000?ofkP3om^h0BP3om^h10?ooo`00603o
m^h00`000000ooK^0?ofkP0e0?ofkP030000003om^h0ooK^00/0ooK^00D0e3dI0?ofkP3om^h0ooK^
0=@m6@0<0?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^
0?ofkP030?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^
0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h0103om^h2000000801PPA
0P0000000`062A80000000H94P02000000H03A0N00@0000000d@7P0=41h0e3dI0`0000000`0G73`0
00000=@m6@0601LL?0030000000G73`05a`l00@05a`l0P0000000`0P:UT00000020ZF@02020ZF@03
0=@m6@0P:UT082YI008082YI00<0e3dI020ZF@0P:UT00`000004020ZF@<000000`0X=g400`3D?AT0
:3Ma02PgL@0202PgL@030=@m6@0X=g40:3Ma00L0:3Ma00@0000002PgL@0X=g40e3dI0`0X=g40103D
?AT000000000000^@8<2000000@0l48J00<000000?126P0mFJ/00P0mFJ/00`000000?EV[0=0h5@02
0=0h5@030000002T:Pl0Y2X?00<0000000@0ooK^03eIZ`0mFJ/0?EV[2P3om^h00`0mFJ/0ooK^0?of
kP0A0?ofkP<0?EV[00<0ooK^03eIZ`3om^h00P3om^h203eIZ`L0ooK^00<000000?ofkP3om^h0103o
m^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h00`3o
m^h303eIZ`h0ooK^00<0?EV[0?ofkP3om^h03`3om^h00`000000ooK^0?ofkP190?ofkP40oooo000G
0?ofkP030000003om^h0ooK^03L0ooK^00<000000?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP02
0?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP09
0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP07
0?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h0203om^h0103D?AT0ooK^0?ofkP3o
m^h20000000500H84@0000000000000000062A80100000000`0=41h0000000d@7P0400d@7P050000
000=41h000000=@m6@0000000`0G73`0100000005a`l01LL?03D?AT501LL?0040000000G73`05a`l
01LL?0<000000`0P:UT01000000082YI020ZF@3D?AT5020ZF@030=@m6@000000000000@082YI0`00
00000`0mFJ/0000002PgL@0202PgL@030=@m6@0X=g40:3Ma00<0:3Ma00<000000=@m6@0X=g401`0X
=g400`000000:3Ma0=@m6@0202PgL@80000000L0;T230=@m6@0^@8<0;T230000003oB1d0000000<0
l48J0P0mFJ/20?126P80000000@0?EV[0=0h5@3@>1D0d3PE0P0000020:@Z3`80000000<0?EV[0?of
kP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP<0?EV[0`3om^h00`0mFJ/0ooK^03eIZ`0203eI
Z`X0ooK^00<000000?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^
00d0ooK^00<0?EV[0?ofkP0mFJ/00P0mFJ/B0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<000000?of
kP3om^h0B@3om^h10?ooo`005`3om^h00`000000ooK^0?ofkP0h0?ofkP030000003om^h0ooK^00T0
ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00D0
ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP050?ofkP80e3dI2@3om^h00`3D?AT0
ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0
000000000004000000801PTB0`00000200d@7P030000000=41h03A0N00<03A0N0`0000000`3D?AT0
5a`l01LL?00301LL?0050000000G73`05a`l01LL?03D?AT0100G73`0100000005a`l000000000006
020ZF@030000000P:UT0e3dI00@082YI0`000000103D?AT082YI020ZF@0P:UT2000000@0:3Ma00D0
000002PgL@0X=g40:3Ma0=@m6@0502PgL@030000000X=g40e3dI00L0:3Ma00<0000002PgL@3D?AT0
0P00000402i0P`030=@m6@0^@8<000000080odPM0`0mFJ/00`000000l48J0?126P020?126P030000
003@>1D0?EV[0080d3PE00@000000=0h5@000000Y2X?0`00000=0?ofkP80?EV[303om^h303eIZ`D0
ooK^100mFJ/<0?ofkP030000003om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0
ooK^0?ofkP0<0?ofkP<0?EV[5@3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP030000003om^h0ooK^04P0
ooK^0@3oool001L0ooK^00<000000?ofkP3om^h0>@3om^h00`000000ooK^0?ofkP070?ofkP030=@m
6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP060?ofkP80e3dI
1`3om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h0
2@3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00P0ooK^1000000200H94P030000
00062A801PTB00<00000100=41h0100000003A0N00d@7P0=41h20000000301LL?0000000e3dI00H0
5a`l00<0000001LL?00G73`00P0G73`00`3D?AT05a`l01LL?003000000P082YI00<000000=@m6@0P
:UT00P0P:UT20000008082YI00<00000020ZF@3D?AT00P00000602PgL@040000000X=g40:3Ma0=@m
6@H0:3Ma00@0000002PgL@0X=g40e3dI1@0X=g43000000030=@m6@0^@8<0;T2300D0;T2300D0e3dI
0000000mFJ/0?EV[000000020?126P030000003`@QX0l48J0080l48J0P0000002@0mFJ/0d3PE0=0h
5@000000d3PE0000002T:Pl000000:@Z3`02000000`0ooK^0P0mFJ/:0?ofkP80?EV[1@3om^h303eI
Z`040?ofkP0mFJ/0ooK^03eIZ`d0ooK^00<000000?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP04
0?ofkP0303eIZ`3om^h0ooK^00P0ooK^0`0mFJ/00`3om^h0?EV[0?ofkP0E0?ofkP0303eIZ`3om^h0
ooK^00l0ooK^00<000000?ofkP3om^h0B03om^h10?ooo`005`3om^h00`000000ooK^0?ofkP0j0?of
kP030000003om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP050?of
kP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP090?of
kP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP040?of
kP030=@m6@3om^h0ooK^00H0ooK^1000000300H94P03000000062A80000000<000001@0=41h00`00
00003A0N00d@7P02000000805a`l00<000000=@m6@0G73`01P0G73`00`0000005a`l01LL?00201LL
?0050000003D?AT00000020ZF@000000200P:UT00`000000e3dI020ZF@03000000<082YI0`000000
0`0X=g40e3dI02PgL@0602PgL@040000000X=g40:3Ma0=@m6@H0:3Ma00@0000002PgL@0X=g40e3dI
0`0X=g420000000302i0P`000000e3dI00P0;T2300<0e3dI03eIZ`3oB1d00P3oB1d00`000000l48J
000000040?126P030000003`@QX0?EV[0080d3PE00<000000=0h5@3@>1D00P000000102T:Pl00000
07PM2`00000;0?ofkP0303eIZ`3om^h0?EV[00H0ooK^0`0mFJ/40?ofkP<0?EV[1@3om^h203eIZ`h0
ooK^00<000000?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00H0
ooK^0P0mFJ/50?ofkP0303eIZ`3om^h0ooK^01@0ooK^00<0?EV[0?ofkP3om^h03`3om^h00`000000
ooK^0?ofkP170?ofkP40oooo000G0?ofkP030000003om^h0ooK^03/0ooK^0P0000060?ofkP030=@m
6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m
6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m
6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP050?ofkPD00000
0P062A84000000803A0N00<0000000d@7P0=41h0100=41h3000000@05a`l00<0e3dI01LL?00G73`0
1@0G73`00`0000005a`l0000000300000005020ZF@3D?AT082YI020ZF@000000200P:UT3000000@0
82YI0P0000000`0X=g40000002PgL@0202PgL@030=@m6@0X=g40:3Ma00@0:3Ma00<0000002PgL@3D
?AT01`0X=g401@000000:3Ma02PgL@0X=g40e3dI008000000`0^@8<00`000000e3dI02i0P`0802i0
P`030000003oB1d0odPM0080odPM0P0000040?126P040000003`@QX0?EV[00000080d3PE00<00000
0=0h5@3@>1D00P000000102T:Pl0000007PM2`00000;0?ofkP80?EV[0`3om^h303eIZ`<0ooK^100m
FJ/80?ofkP0303eIZ`3om^h0?EV[00d0ooK^00<000000?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?of
kP030?ofkP0303eIZ`3om^h0ooK^00<0ooK^0`0mFJ/70?ofkP0303eIZ`3om^h0ooK^01@0ooK^00<0
?EV[0?ofkP3om^h0403om^h00`000000ooK^0?ofkP160?ofkP40oooo000F0?ofkP030000003om^h0
ooK^03h0ooK^00<000000?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0
ooK^0080ooK^00<0e3dI0?ofkP3om^h02`3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00h0ooK^00@0
e3dI0?ofkP3om^h0e3dI403om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00D0ooK^0`00000010062A80
000000H94P062A83000000@03A0N00<0000000d@7P0=41h00`0=41h3000000D05a`l00<0e3dI0000
000G73`01@0G73`3000000H082YI00<0e3dI020ZF@0000001P0P:UT2000000040=@m6@0P:UT082YI
020ZF@<000000`0X=g400`000000:3Ma02PgL@0202PgL@030=@m6@0X=g40:3Ma00<0:3Ma00<00000
02PgL@3D?AT01`0X=g401P000000:3Ma000000000000;T230=@m6@@0;T2300<000000=@m6@0^@8<0
1`0^@8<00`000000odPM0?m87@040?m87@030000003`@QX0l48J0080l48J00@000000?126P0mFJ/0
00000P3@>1D01P000000d3PE0=0h5@3@>1D000000:@Z3`<000002`3om^h00`0mFJ/0ooK^03eIZ`02
03eIZ`<0ooK^0`0mFJ/=0?ofkP80?EV[3P3om^h00`000000ooK^0?ofkP030?ofkP0303eIZ`3om^h0
ooK^0080ooK^00<0?EV[0?ofkP3om^h00`0mFJ/;0?ofkP0303eIZ`3om^h0ooK^01@0ooK^00<0?EV[
0?ofkP3om^h03`3om^h00`000000ooK^0?ofkP160?ofkP40oooo000F0?ofkP030000003om^h0ooK^
03l0ooK^00<000000?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP090?ofkP050=@m6@3om^h0ooK^
0?ofkP3D?AT03P3om^h0103D?AT0ooK^0?ofkP3D?AT?0?ofkP030=@m6@3om^h0e3dI0140ooK^00<0
e3dI0?ofkP3D?AT0103om^h3000000801PTB00<0000000H94P0000000P00000600d@7P030000000=
41h03A0N00<0000000<05a`l0000000G73`0100G73`00`3D?AT05a`l0000000401LL?080000000<0
82YI0000000P:UT01`0P:UT00`3D?AT00000020ZF@02020ZF@<0000000@082YI0=@m6@00000082YI
0P00000602PgL@030000000X=g40:3Ma00<0:3Ma00<0e3dI02PgL@0X=g400P0X=g400`000000e3dI
02PgL@0602PgL@<00000100^@8<01@3D?AT0;T2302i0P`0^@8<0e3dI00T0;T2300<000000?m87@3o
B1d0103oB1d2000000<0l48J00L000000?126P0mFJ/0l48J0000003@>1D0000000<0d3PE0P000000
102T:Pl000000000000000090?ofkP@0?EV[0P3om^h303eIZa00ooK^0P0mFJ/?0?ofkP030000003o
m^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h00`3om^h203eIZ`h0ooK^00<0?EV[0?ofkP3om^h0503o
m^h00`0mFJ/0ooK^0?ofkP0@0?ofkP030000003om^h0ooK^04D0ooK^0@3oool001H0ooK^00<00000
0?ofkP3om^h0@03om^h01@000000ooK^0?ofkP3om^h0e3dI00`0ooK^00@0e3dI0?ofkP3om^h0e3dI
3`3om^h20=@m6A40ooK^00<0e3dI0?ofkP3om^h04@3om^h0103D?AT0ooK^0?ofkP3om^h300000080
1PTB1000000200d@7P030000000=41h03A0N00<03A0N1000000301LL?0030000000G73`05a`l00<0
5a`l00<0e3dI01LL?00000000`0G73`2000000<082YI00<00000020ZF@0P:UT01P0P:UT00`000000
e3dI00000002000000<082YI00@0e3dI0000000000000000200X=g400`000000:3Ma02PgL@0402Pg
L@060=@m6@0X=g40:3Ma02PgL@000000e3dI1@0X=g420000000302i0P`000000;T2300D0;T2300@0
e3dI02i0P`0^@8<0e3dI2@0^@8<00`000000odPM0?m87@040?m87@8000000`3`@QX01@000000l48J
0?126P0mFJ/0l48J008000000`3@>1D2000000030:@Z3`0000000000008000001@3om^h303eIZ`03
0?ofkP0mFJ/0ooK^00<0?EV[503om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP030000003om^h0ooK^0080
ooK^00<0?EV[0?ofkP0mFJ/00`0mFJ/@0?ofkP0303eIZ`3om^h0ooK^01@0ooK^00<0?EV[0?ofkP3o
m^h03`3om^h00`000000ooK^0?ofkP150?ofkP40oooo000F0?ofkP030000003om^h0ooK^0440ooK^
00@000000?ofkP3om^h0e3dI3@3om^h20=@m6A40ooK^00<0e3dI0?ofkP3om^h03`3om^h20=@m6A40
ooK^00@0e3dI0?ofkP3D?AT0e3dI0`00000010062A80000000000000000400d@7P030000000=41h0
3A0N00803A0N0`00000601LL?0030000000G73`05a`l00805a`l00D0e3dI01LL?00G73`0000001LL
?002000000D082YI00<00000020ZF@0P:UT01P0P:UT2000000030=@m6@0P:UT082YI008082YI00@0
e3dI0000000X=g4000002@0X=g400`000000:3Ma02PgL@0402PgL@050=@m6@0X=g40:3Ma02PgL@3D
?AT00`0X=g43000000<0;T2300<0000002i0P`0^@8<0100^@8<0103D?AT0;T2302i0P`3D?AT902i0
P`030000003oB1d0odPM00@0odPM00<000000?m87@0000000P3`@QX01`000000l48J0?126P0mFJ/0
l48J0=@m6@0000000`3@>1D01@000000d3PE000000000000Y2X?008000000`3om^h203eIZ`@0ooK^
0P0mFJ/00`3om^h0?EV[0?ofkP0D0?ofkP80?EV[3`3om^h010000000ooK^0?ofkP3om^h503eIZ`03
0?ofkP0mFJ/0ooK^00l0ooK^00<0?EV[0?ofkP3om^h04`3om^h203eIZa80ooK^00<000000?ofkP3o
m^h0A03om^h10?ooo`005@3om^h00`000000ooK^0?ofkP130?ofkP040000003om^h0e3dI0=@m6@d0
ooK^00<0e3dI0?ofkP3om^h03`3om^h20=@m6@l0ooK^00@0e3dI0?ofkP3om^h0e3dI403om^h01P3D
?AT00000000000062A80000000H94P<000001@0=41h0100000003A0N00d@7P0=41h20000000301LL
?00000005a`l00D05a`l00<0000001LL?00G73`00P0G73`00`3D?AT05a`l01LL?003000000L082YI
00<00000020ZF@0P:UT00`0P:UT40000008082YI00D0e3dI00000000000000000=@m6@0202PgL@03
0000000X=g40:3Ma00L0:3Ma00<0000002PgL@0X=g401@0X=g401@3D?AT0:3Ma02PgL@3D?AT0:3Ma
008000001P0^@8<00`000000;T2302i0P`0502i0P`80e3dI00<0000002i0P`0^@8<01`0^@8<00`00
0000odPM0?m87@040?m87@060000003oB1d0odPM0000003`@QX000000P3`@QX00`0mFJ/0l48J0?12
6P0200000080d3PE00<000000=0h5@3@>1D00P0000000`2T:Pl0000003eIZ`0203eIZ`<0ooK^0`0m
FJ/01@3om^h0?EV[0?ofkP3om^h0?EV[01D0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`000000?EV[
03eIZ`0303eIZ`@0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP<0?EV[
00<0ooK^03eIZ`3om^h04P3om^h00`000000ooK^0?ofkP130?ofkP40oooo000E0?ofkP030000003o
m^h0ooK^04@0ooK^00@000000=@m6@3om^h0e3dI303om^h20=@m6A00ooK^00<0e3dI0?ofkP3D?AT0
3P3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00h0ooK^00<0e3dI000000062A80100000000`0=41h0
000000d@7P0400d@7P030000000=41h03A0N008000000P0G73`00`0000005a`l01LL?00501LL?006
0000000G73`05a`l01LL?03D?AT05a`l0P0000000`0P:UT00000020ZF@06020ZF@030000000P:UT0
82YI008082YI0P000003020ZF@070000000P:UT000000000003D?AT0:3Ma0=@m6@0302PgL@030000
000X=g40:3Ma00L0:3Ma00<0000002PgL@0X=g401P0X=g420=@m6@800000200^@8<00`000000;T23
02i0P`0602i0P`030=@m6@000000;T2300P0;T2300<000000?m87@3oB1d0103oB1d010000000odPM
0?m87@3oB1d200000080l48J00H0?EV[0?126P3`@QX000000?126P0000020=0h5@030000003@>1D0
d3PE00<0?EV[0P000000103om^h0?EV[03eIZ`0mFJ/40?ofkP0403eIZ`3om^h0ooK^03eIZaD0ooK^
00<0?EV[0?ofkP3om^h02`3om^h403eIZ`050000000mFJ/0ooK^0?ofkP0mFJ/0103om^h00`0mFJ/0
ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00`0ooK^0`0mFJ/50?ofkP0303eIZ`3om^h0ooK^0100
ooK^00<000000?ofkP3om^h0@`3om^h10?ooo`005@3om^h00`000000ooK^0?ofkP150?ofkP030000
003D?AT0ooK^0080e3dI2P3om^h00`3D?AT0ooK^0=@m6@0>0?ofkP050=@m6@3om^h0ooK^0?ofkP3D
?AT03@3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0?EV[0000003D
?AT00`00000300d@7P030000000=41h03A0N00@03A0N0`00000401LL?0030000000G73`05a`l00D0
5a`l00H0000001LL?00G73`0e3dI0000003D?AT3020ZF@030000000P:UT082YI00D082YI00<00000
020ZF@0000000P000004020ZF@<000000`0X=g400`3D?AT0:3Ma02PgL@0202PgL@030000000X=g40
:3Ma00L0:3Ma00<0000002PgL@0X=g40100X=g43000000030=@m6@000000;T2300P0;T2300<00000
02i0P`0^@8<01@0^@8<01@3D?AT0;T230=@m6@0^@8<0?EV[00H0;T230P0000060?m87@040000003o
B1d0odPM0?m87@8000000P3`@QX01P0mFJ/0l48J0?126P000000l48J00000080d3PE0`0mFJ/20000
00040:@Z3`0000000000000000L0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0E0?ofkP0303eIZ`3o
m^h0ooK^00H0ooK^100mFJ/01@3om^h0?EV[03eIZ`3om^h0000000<0ooK^00<0?EV[0?ofkP3om^h0
0P3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00X0ooK^0P0mFJ/80?ofkP0303eI
Z`3om^h0ooK^0140ooK^00<000000?ofkP3om^h0@P3om^h10?ooo`005@3om^h00`000000ooK^0?of
kP160?ofkP050=@m6@000000ooK^0?ofkP3D?AT02@3om^h00`3D?AT0ooK^0?ofkP020=@m6@`0ooK^
00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^00@0ooK^
0P3D?AT60?ofkP80?EV[00<0000000H94P0000000P00000500d@7P030000000=41h03A0N00803A0N
0`00000501LL?0030000000G73`05a`l00D05a`l00@0000001LL?03D?AT0e3dI0`0P:UT00`3D?AT0
82YI00000007020ZF@<000001@0P:UT20000000302PgL@000000:3Ma0080:3Ma00<0e3dI02PgL@3D
?AT00`0X=g400`000000:3Ma02PgL@0702PgL@030000000X=g40:3Ma0080:3Ma0P00000202i0P`03
0=@m6@0^@8<0e3dI00T0;T2300<0000002i0P`0^@8<01@0^@8<0103D?AT0;T230000003D?AT502i0
P`80000000<0<dRA000000000000103oB1d00`000000odPM0?m87@030?m87@070000003`@QX0l48J
0?126P0mFJ/0l48J000000020?126P80?EV[00D000000=0h5@3@>1D0d3PE000000020:@Z3`<00000
1`3om^h0100mFJ/0ooK^0?ofkP0mFJ/E0?ofkP0303eIZ`3om^h0ooK^00<0ooK^0`0mFJ/20?ofkP<0
?EV[103om^h010000000ooK^0?ofkP0mFJ/50?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?of
kP3om^h01P3om^h303eIZ`X0ooK^00<0?EV[0?ofkP3om^h04@3om^h00`000000ooK^0?ofkP120?of
kP40oooo000D0?ofkP030000003om^h0ooK^04L0ooK^00<0e3dI0?ofkP0000000P3om^h00`3D?AT0
ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0
ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h01P3om^h0103D?AT0
ooK^0?ofkP3om^h203eIZ`@0000000<03A0N0000000=41h0100=41h00`0000003A0N00d@7P040000
00L05a`l00<0000001LL?00G73`0100G73`2000000030=@m6@0P:UT082YI00@082YI00<0e3dI0000
000P:UT0100P:UT200000003020ZF@00000082YI008082YI0`00000302PgL@040000000X=g40:3Ma
0=@m6@<0:3Ma00@0e3dI02PgL@0X=g4000002@0X=g400`000000:3Ma00000002000000@0;T2300@0
e3dI02i0P`000000e3dI200^@8<00`000000;T2302i0P`0402i0P`070=@m6@0^@8<0;T230000000^
@8<0e3dI02i0P`03000000<0<dRA00<000000?m<7`0000000`3oB1d00`000000odPM0?m87@030?m8
7@8000000P3`@QX00`0mFJ/0l48J03eIZ`0203eIZ`030?126P000000000000<0d3PE0P0000001@2T
:Pl000000000003D?AT0000000H0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0D0?ofkP80?EV[00@0
ooK^03eIZ`0mFJ/0?EV[0P3om^h303eIZ`P0ooK^00@000000?ofkP3om^h0?EV[103om^h00`0mFJ/0
ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00<0ooK^0`0mFJ/=0?ofkP0303eIZ`3om^h0ooK^0180
ooK^00<000000?ofkP3om^h0@@3om^h10?ooo`00503om^h00`000000ooK^0?ofkP170?ofkP040=@m
6@3om^h0ooK^00000080ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP030?ofkP03
0=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP060?ofkP03
0=@m6@3om^h0ooK^00P0ooK^00@0e3dI03eIZ`0mFJ/0?EV[0P00000400d@7P030000000=41h03A0N
00803A0N1000000301LL?0030000000G73`05a`l00D05a`l00@0000001LL?00G73`05a`l0`000000
0`0P:UT0e3dI020ZF@07020ZF@030=@m6@0P:UT082YI00<000000`0P:UT010000000?EV[00000000
000602PgL@030000000X=g40e3dI00D0:3Ma00<0e3dI02PgL@000000200X=g43000000H0;T2300H0
e3dI02i0P`0^@8<0000002i0P`3D?AT702i0P`030000000^@8<0;T2300@0;T2300L0e3dI02i0P`0^
@8<0000002i0P`000000e3dI00H0<dRA00@000000?m<7`3oC1l000000P3oB1d00`000000odPM0?m8
7@030?m87@030000003oB1d0000000<0?EV[00<000000?126P3`@QX00P3`@QX01P000000d3PE0=0h
5@3@>1D000000=0h5@80000000@0Y2X?00000000000000001@3om^h01@0mFJ/0ooK^0?ofkP3om^h0
?EV[01@0ooK^0`0mFJ/30?ofkP80?EV[303om^h00`000000ooK^03eIZ`040?ofkP0303eIZ`3om^h0
ooK^00l0ooK^00<0?EV[0?ofkP0mFJ/00P0mFJ/A0?ofkP0303eIZ`3om^h0ooK^0180ooK^00<00000
0?ofkP3om^h0@03om^h10?ooo`00503om^h00`000000ooK^0?ofkP170?ofkP050=@m6@3om^h0ooK^
0?ofkP0000000P3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI
0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI
0?ofkP3om^h01@3om^h403eIZ`030=@m6@3om^h0000000D03A0N00<0000000d@7P0=41h00P0=41h2
000000D05a`l00<0000001LL?00G73`01@0G73`00`0000005a`l00000002000000<082YI00<0e3dI
0000000P:UT01`0P:UT3000000D082YI0`00000802PgL@030000003D?AT0:3Ma00H0:3Ma00<0e3dI
0000000X=g401@0X=g420000000302i0P`000000;T2300D0;T2300L0e3dI02i0P`0^@8<0;T230000
000^@8<0e3dI00L0;T2300<0000002i0P`0^@8<00`0^@8<00`3D?AT0;T2302i0P`030000000303=8
T@3D?AT0<dRA00@0<dRA00D000000?m<7`3oC1l0od`O000000020?m87@030000003oB1d0odPM00<0
odPM00L0000003eIZ`0mFJ/0000003eIZ`3`@QX0000000@0l48J0P0000020=0h5@090000003@>1D0
00000:@Z3`000000Y2X?0000001h7@/0000000@0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0A0?of
kP<0?EV[00<0ooK^03eIZ`3om^h00`0mFJ/>0?ofkP030000003om^h0?EV[00D0ooK^00<0?EV[0?of
kP3om^h03@3om^h303eIZa@0ooK^00<0?EV[0?ofkP3om^h04P3om^h00`000000ooK^0?ofkP100?of
kP40oooo000D0?ofkP030000003om^h0ooK^04L0ooK^00<0e3dI0?ofkP3om^h00P3om^h010000000
ooK^0?ofkP3D?AT50?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D
?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h00P3om^h403eI
Z`@0ooK^00<0e3dI00d@7P0=41h00`0=41h0100000003A0N00d@7P0=41h2000000L05a`l00<00000
01LL?00G73`0100G73`3000000@082YI0P3D?AT00`0P:UT00000020ZF@05020ZF@8000000P0P:UT0
0`3D?AT082YI020ZF@030000000302PgL@000000:3Ma00P0:3Ma00<0e3dI02PgL@0X=g401`0X=g40
103D?AT0:3Ma02PgL@0X=g43000000<0;T2300<0000002i0P`0^@8<00`0^@8<00`3D?AT0;T2302i0
P`0202i0P`040000000^@8<0;T230=@m6@H0;T2300<0000002i0P`0^@8<00`0^@8<01@3D?AT00000
0000000cB940000000<0<dRA00<0e3dI03=8T@0cB9400P0cB9400`000000od`O0?m<7`020?m<7`03
0000003oB1d0000000<0odPM0`0mFJ/30?m87@030000000mFJ/0000000@0l48J0P0000020=0h5@03
0000003@>1D0d3PE008000000P2T:Pl3000000@0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0>0?of
kP80?EV[0`3om^h303eIZa80ooK^00<000000?ofkP0mFJ/0103om^h00`0mFJ/0ooK^0?ofkP0:0?of
kP<0?EV[00<0ooK^03eIZ`3om^h0503om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP030000003om^h0ooK^
03l0ooK^0@3oool001@0ooK^00<000000?ofkP3om^h0B03om^h00`3D?AT0ooK^0?ofkP020?ofkP04
0000003om^h0ooK^0=@m6@@0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP040?of
kP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h00P3om^h0103D?AT0ooK^0?ofkP3om^h4
03eIZ`@0ooK^00<0?EV[0000003D?AT0100=41h00`0000003A0N00d@7P020000000301LL?0000000
5a`l00D05a`l00<0000001LL?00G73`00`0G73`200000003020ZF@00000082YI00<082YI00D0e3dI
020ZF@0P:UT082YI00000003020ZF@<0000000<082YI0000000P:UT00P0000000`3D?AT0000002Pg
L@0302PgL@030000000X=g40:3Ma00H0:3Ma00<0e3dI0000000X=g40200X=g4010000000e3dI0000
0000000602i0P`030000000^@8<0;T2300<0;T2300<0e3dI02i0P`0^@8<00P0^@8<01@000000;T23
02i0P`0^@8<0e3dI00D0;T2300L0000002i0P`0^@8<0;T230000003D?AT0000000<0<dRA00<00000
03=8T@0cB9400P0cB9401@3D?AT0<dRA03=8T@0cB940000000D0od`O0P00000303eIZ`80odPM00<0
00000?m87@3oB1d00P3oB1d00`0mFJ/000000?126P030?126P030000003`@QX000000080d3PE00<0
00000=0h5@3@>1D00P000000102T:Pl000000000000000040?ofkP0503eIZ`3om^h0ooK^0?ofkP0m
FJ/02`3om^h303eIZ`80ooK^0`0mFJ/00`3om^h0?EV[03eIZ`0C0?ofkP030000000mFJ/0ooK^00<0
ooK^00<0?EV[0?ofkP3om^h01`3om^h303eIZ`D0ooK^00<0?EV[0?ofkP3om^h04P3om^h00`0mFJ/0
ooK^0?ofkP0C0?ofkP030000003om^h0ooK^03l0ooK^0@3oool001<0ooK^00<000000?ofkP3om^h0
B@3om^h00`3D?AT0ooK^0?ofkP030?ofkP030000003om^h0ooK^0080e3dI0P3om^h00`3D?AT0ooK^
0?ofkP070?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h02@3om^h01@3D?AT0ooK^
0?ofkP3om^h0e3dI00D0?EV[0`3om^h503eIZ`D03A0N0`00000201LL?0030000000G73`05a`l00D0
5a`l00<0000001LL?00G73`00`000003020ZF@050000000P:UT082YI020ZF@3D?AT00`0P:UT00`00
000082YI00000002000000<082YI0`00000302PgL@030=@m6@0X=g40:3Ma0080:3Ma00<0000002Pg
L@0X=g401@0X=g400`3D?AT0:3Ma0000000802PgL@<0000000<0e3dI02i0P`0^@8<01@0^@8<00`00
0000;T2302i0P`0202i0P`030=@m6@0^@8<0;T2300<0;T2300<0000002i0P`0^@8<00P0^@8<00`3D
?AT0;T2302i0P`0202i0P`060000000^@8<000000000000cB940e3dI100cB9400`000000<dRA03=8
T@0303=8T@040=@m6@0cB940<dRA000000D0od`O0P0mFJ/40?m87@030000003oB1d0odPM00<0odPM
00<0?EV[0000003`@QX00`3`@QX01P000000l48J0?126P000000d3PE000000<0d3PE00<000000:@Z
3`2T:Pl00`0000030?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h01@3om^h303eI
Z`80ooK^0`0mFJ/50?ofkP0303eIZ`3om^h0ooK^0140ooK^00<000000?ofkP0mFJ/0103om^h00`0m
FJ/0ooK^0?ofkP040?ofkP80?EV[203om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^
01<0ooK^00<000000?ofkP3om^h0?P3om^h10?ooo`004`3om^h00`000000ooK^0?ofkP190?ofkP03
0=@m6@3om^h0ooK^00@0ooK^0P0000020?ofkP030=@m6@3om^h0e3dI00X0ooK^0P3D?AT30?ofkP03
0=@m6@3om^h0ooK^00X0ooK^00D0e3dI03eIZ`0mFJ/0e3dI03eIZ`020?ofkP0303eIZ`3om^h0?EV[
0080?EV[00@0ooK^03eIZ`0mFJ/00000100=41h3000000@05a`l00<0000001LL?00G73`0100G73`0
100000005a`l000000000005020ZF@050000000P:UT082YI020ZF@3D?AT0100P:UT2000000@082YI
0P0000000`0X=g40000002PgL@0402PgL@050=@m6@0X=g40:3Ma02PgL@0000001`0X=g400`3D?AT0
:3Ma0000000502PgL@<0000000@0;T230000000^@8<0e3dI1`0^@8<01@000000;T2302i0P`0^@8<0
e3dI00H0;T2300<0000002i0P`0^@8<00`0^@8<00`3D?AT0;T2302i0P`0300000080<dRA00<0e3dI
03=8T@0cB9400`0cB9400`000000<dRA03=8T@0403=8T@030=@m6@0cB94000000080od`O0`0mFJ/0
0`3oC1l00000000000030?m87@030000003oB1d0odPM00<0odPM00<0?EV[0000000000000`3`@QX0
10000000l48J0?126P3`@QX2000000<0d3PE0P0000000`2T:Pl000000:@Z3`02000000<0ooK^00D0
?EV[0?ofkP3om^h0ooK^03eIZ`050?ofkP80?EV[0P3om^h303eIZ`P0ooK^0P0mFJ/C0?ofkP030000
000mFJ/0ooK^00<0ooK^00@0?EV[0?ofkP3om^h0ooK^0`0mFJ/:0?ofkP0303eIZ`3om^h0ooK^01<0
ooK^00<0?EV[0?ofkP3om^h0503om^h00`000000ooK^0?ofkP0m0?ofkP40oooo000C0?ofkP030000
003om^h0ooK^04X0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`000000ooK^0?ofkP020=@m6@`0ooK^
00<0e3dI0?ofkP3D?AT02`3om^h303eIZ`80e3dI1P0mFJ/20?ofkP80?EV[00@0ooK^0000000=41h0
3A0N1000000501LL?0030000000G73`05a`l00@05a`l0`000007020ZF@040000000P:UT0e3dI0=@m
6@8082YI10000003020ZF@8000000`0X=g400`000000:3Ma02PgL@0402PgL@040=@m6@0X=g40:3Ma
000000H0:3Ma00D0e3dI02PgL@0X=g40000002PgL@04000000@0;T2300@0000002i0P`0^@8<0e3dI
1P0^@8<010000000;T2302i0P`3D?AT702i0P`030000000^@8<0;T2300<0;T2300D000000=@m6@00
0000<dRA0000000303=8T@030=@m6@0cB940<dRA00<0<dRA00<0000003=8T@0cB9401@0cB940103D
?AT0000003eIZ`0mFJ/40?m<7`030000003oC1l000000080odPM00<000000?m87@3oB1d0103oB1d0
0`0mFJ/000000?126P020?126P060000003`@QX0l48J0?126P000000e3dI0`3@>1D010000000d3PE
0000000000020:@Z3`8000000P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0?EV[0080
?EV[0P3om^h203eIZ`/0ooK^0P0mFJ/D0?ofkP030000003om^h0ooK^0080ooK^100mFJ/=0?ofkP03
03eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h0503om^h00`000000ooK^0?ofkP0m0?ofkP40
oooo000C0?ofkP030000003om^h0ooK^04X0ooK^0P3D?AT70?ofkP040000003om^h0ooK^0=@m6@d0
ooK^0P3D?AT90?ofkP@0?EV[0P3om^h00`3D?AT0ooK^03eIZ`0203eIZ`030?ofkP0mFJ/0?EV[0080
?EV[00<0ooK^0000000000000P00000301LL?0030000000G73`05a`l00<05a`l00@0000001LL?00G
73`05a`l0`0000000`0P:UT00000020ZF@07020ZF@040000003D?AT082YI020ZF@8000000`0P:UT0
1000000082YI00000000000502PgL@030000000X=g40:3Ma00D0:3Ma00<0e3dI02PgL@0000001@0X
=g400`3D?AT0:3Ma02PgL@03000000P0;T2300D0000002i0P`0^@8<0;T230=@m6@0602i0P`030000
000^@8<0e3dI00L0;T2300<0000002i0P`0000000`00000203=8T@030=@m6@0cB94000000080<dRA
00<0e3dI03=8T@0cB940100cB9400`000000<dRA03=8T@0603=8T@0303eIZ`3oC1l0od`O00<0od`O
00@000000?m<7`3oC1l000000P3oB1d00`000000odPM0?m87@030?m87@040000000mFJ/0odPM0000
0080l48J00<000000?126P3`@QX00P3`@QX00`000000d3PE0=0h5@020=0h5@80000000D0Y2X?0000
002T:Pl0Y2X?000000020?ofkP0403eIZ`3om^h0ooK^0?ofkP<0?EV[0P3om^h303eIZ`h0ooK^00<0
?EV[0?ofkP3om^h04`3om^h00`000000ooK^03eIZ`0303eIZa00ooK^00<0?EV[0?ofkP3om^h04P3o
m^h00`0mFJ/0ooK^0?ofkP0E0?ofkP030000003om^h0ooK^03`0ooK^0@3oool00180ooK^00<00000
0?ofkP3om^h0C03om^h20=@m6@L0ooK^00@000000?ofkP3D?AT0e3dI3@3om^h00`3D?AT0ooK^0?of
kP050?ofkP<0?EV[103om^h0100mFJ/0e3dI0=@m6@3om^h303eIZ`@0ooK^0P00000501LL?0030000
000G73`05a`l00<05a`l00<0000001LL?00000000P000004020ZF@030000000P:UT082YI00H082YI
00@0e3dI0000000000000000100P:UT3000000L0:3Ma00<0000002PgL@0X=g401P0X=g400`3D?AT0
000002PgL@0302PgL@060=@m6@0X=g4000000000000^@8<000002@0^@8<00`000000;T2302i0P`02
02i0P`030=@m6@0^@8<0;T2300<0;T2300<000000=@m6@0^@8<01P0^@8<3000000H0<dRA00<0e3dI
03=8T@0000000P0cB9400`3D?AT0<dRA03=8T@0303=8T@030000000cB940<dRA00H0<dRA00<00000
0?m<7`3oC1l0103oC1l01`000000od`O0?m<7`3oC1l000000?m87@0000001@3oB1d01`000000?EV[
0?m87@3oB1d000000?126P000000103`@QX2000000<0d3PE00@000000=0h5@00000000000P2T:Pl2
000000030?ofkP0mFJ/0ooK^0080?EV[00<0ooK^03eIZ`0mFJ/00P0mFJ/A0?ofkP80?EV[4`3om^h0
0`0mFJ/0000003eIZ`030?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h04`3om^h0
0`0mFJ/0ooK^0?ofkP0E0?ofkP030000003om^h0ooK^03/0ooK^0@3oool00180ooK^00<000000?of
kP3om^h0C03om^h0103D?AT0ooK^0=@m6@3D?AT60?ofkP040000003D?AT0ooK^0=@m6@`0ooK^0P3D
?AT30?ofkP<0?EV[103om^h303eIZ`050?ofkP3D?AT0?EV[0=@m6@0mFJ/01@3om^h00`0000005a`l
01LL?00401LL?0030000000G73`05a`l00<05a`l0`000007020ZF@030000000P:UT082YI00@082YI
0`0000000`3D?AT082YI020ZF@02020ZF@80000000<0?EV[0000000X=g401`0X=g400`000000:3Ma
02PgL@0702PgL@050=@m6@0X=g40:3Ma02PgL@3D?AT00P00000302i0P`030000000^@8<0;T2300L0
;T2300<0000002i0P`0^@8<00`0^@8<00`3D?AT0;T2302i0P`0202i0P`030=@m6@0^@8<0;T2300@0
;T230P0000000`0cB940000003=8T@0703=8T@040=@m6@000000<dRA0=@m6@H0<dRA00<0000003=8
T@0cB9401P0cB9400`000000od`O0?m<7`040?m<7`030000003oC1l0od`O0080od`O0P0000050?m8
7@030000000mFJ/0odPM0080odPM0P0000040?126P030000003`@QX000000080d3PE00<000000=0h
5@3@>1D00P0000020:@Z3`8000000P0mFJ/00`3om^h0?EV[03eIZ`0203eIZa<0ooK^0P0mFJ/@0?of
kP<0?EV[00<0ooK^03eIZ`0000000`3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^
0180ooK^0P0mFJ/G0?ofkP030000003om^h0ooK^03/0ooK^0@3oool00180ooK^00<000000?ofkP3o
m^h0C@3om^h0103D?AT0ooK^0?ofkP3D?AT60?ofkP040000003D?AT0ooK^0=@m6@/0ooK^00<0e3dI
0?ofkP3D?AT00`0mFJ/40?ofkP80?EV[0P3om^h01P0mFJ/0e3dI03eIZ`0mFJ/0ooK^0=@m6@D0ooK^
00<0000001LL?00G73`0100G73`0100000005a`l01LL?00G73`200000003020ZF@00000082YI00L0
82YI00<00000020ZF@0P:UT00P0P:UT200000005020ZF@00000082YI020ZF@3D?AT00`00000302Pg
L@030000000X=g40:3Ma00L0:3Ma00<0000002PgL@0X=g401P0X=g4010000000e3dI0000003D?AT6
02i0P`030000000^@8<0;T2300P0;T2300<0000002i0P`0^@8<00`0^@8<01@3D?AT0;T2302i0P`3D
?AT0000000<0;T230`00000303=8T@030000000cB940<dRA00L0<dRA00<0e3dI03=8T@3D?AT01P0c
B9400`000000<dRA03=8T@0603=8T@030000003oC1l0od`O00@0od`O00<000000?m<7`3oC1l00`3o
C1l00`000000odPM0?m87@030?m87@030000003oB1d0?EV[0080odPM0P0000040?126P060000003`
@QX0l48J0000003@>1D000000`3@>1D00`000000Y2X?0:@Z3`02000000<0?EV[0`3om^h00`0mFJ/0
ooK^0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^00`0ooK^0P0mFJ/50?ofkP0303eIZ`000000ooK^0080
ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP<0?EV[00<0ooK^03eIZ`3o
m^h05`3om^h00`000000ooK^0?ofkP0j0?ofkP40oooo000B0?ofkP030000003om^h0ooK^04h0ooK^
00@0e3dI0?ofkP3om^h0e3dI1P3om^h0103D?AT0ooK^0?ofkP3D?AT:0?ofkP050=@m6@0mFJ/0?EV[
0=@m6@0mFJ/00P3om^h303eIZ`080?ofkP0mFJ/0?EV[03eIZ`3om^h0e3dI0?ofkP0mFJ/20?ofkP05
0=@m6@3om^h0ooK^03eIZ`0000001P0G73`00`0000005a`l01LL?002000000<082YI00<00000020Z
F@0P:UT01@0P:UT00`00000082YI020ZF@03000000<082YI00D00000020ZF@00000000000=@m6@05
02PgL@030000000X=g40:3Ma00L0:3Ma00<0000002PgL@0X=g401@0X=g43000000030=@m6@0^@8<0
;T2300D0;T2300<0000002i0P`0^@8<0200^@8<00`000000;T2302i0P`0402i0P`050=@m6@0^@8<0
e3dI0000000^@8<00P00000603=8T@030000000cB940<dRA00L0<dRA00<000000=@m6@0cB9401P0c
B9400`000000<dRA03=8T@0503=8T@8000001@3oC1l00`000000od`O0?m<7`040?m<7`800000103o
B1d00`000000odPM03eIZ`030?m87@030000003`@QX0l48J0080l48J00L000000?126P3`@QX0l48J
0000003@>1D000000080d3PE0P00000303eIZ`030000000mFJ/0ooK^00<0ooK^00<0?EV[0?ofkP3o
m^h04P3om^h203eIZ`X0ooK^0`0mFJ/70?ofkP0403eIZ`3om^h000000?ofkP80?EV[403om^h00`0m
FJ/0ooK^0?ofkP0;0?ofkP<0?EV[1@3om^h00`0mFJ/0ooK^0?ofkP0E0?ofkP030000003om^h0ooK^
03X0ooK^0@3oool00180ooK^00<000000?ofkP3om^h0CP3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI
00D0ooK^00D0e3dI000000000000ooK^0=@m6@080?ofkP0303eIZ`3D?AT0ooK^0080?EV[00@0e3dI
03eIZ`0mFJ/0ooK^0`0mFJ/40?ofkP030=@m6@0mFJ/0ooK^00<0ooK^00<0e3dI03eIZ`0000001`0G
73`3000000@082YI00<00000020ZF@0P:UT01P0P:UT3000000030=@m6@0P:UT082YI008082YI0`00
000302PgL@030=@m6@0X=g40:3Ma0080:3Ma00<0000002PgL@0X=g401`0X=g400`000000:3Ma02Pg
L@0302PgL@80000000D0;T230000003D?AT0;T230=@m6@0602i0P`030000000^@8<0;T2300P0;T23
00<0000002i0P`0^@8<01@0^@8<0103D?AT0000000000000000803=8T@030000000cB940<dRA00H0
<dRA00@000000=@m6@0cB940e3dI1P0cB9400`000000<dRA03=8T@0303=8T@80000000<0=djN0000
00000000103oC1l00`000000od`O0?m<7`040?m<7`030000003oC1l0000000<0odPM00<000000?m8
7@0mFJ/00`3oB1d2000000<0l48J00<000000?126P3`@QX00P3`@QX200000080d3PE0P0mFJ/00`00
0000Y2X?000000020000000303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h04P3om^h00`0m
FJ/0ooK^0?ofkP050?ofkP<0?EV[2P3om^h203eIZ`040000000mFJ/0ooK^03eIZa00ooK^00<0?EV[
0?ofkP3om^h02@3om^h203eIZ`P0ooK^00<0?EV[0?ofkP3om^h05P3om^h00`000000ooK^0?ofkP0i
0?ofkP40oooo000A0?ofkP030000003om^h0ooK^0500ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@04
0?ofkP060=@m6@3om^h0ooK^0000003om^h0e3dI103om^h403eIZ`060=@m6@0mFJ/0?EV[03eIZ`3o
m^h0e3dI0`0mFJ/60?ofkP030=@m6@0mFJ/0ooK^00<0?EV[00<0ooK^0=@m6@3D?AT01@0G73`30000
00H082YI00<00000020ZF@0P:UT0100P:UT300000080e3dI0P0P:UT30000000302PgL@000000:3Ma
00@0:3Ma00D0e3dI02PgL@0X=g40:3Ma0000000902PgL@040000000X=g40:3Ma02PgL@8000000P0^
@8<20=@m6@<0;T2300<0e3dI02i0P`0^@8<00`0^@8<00`000000;T2302i0P`0802i0P`030000000^
@8<0;T2300<0;T2300D000000=@m6@000000e3dI0000000903=8T@030000000cB940<dRA00H0<dRA
00D000000=@m6@0cB940<dRA0=@m6@0503=8T@040000000cB940<dRA03=8T@8000000`0gCYh00`00
0000odlP000000030?m<7`030000003oC1l0od`O00@0od`O00<000000?m<7`0000000P3oB1d01@00
0000odPM0?m87@3oB1d0?EV[0080odPM00<000000?m87@0000000P3`@QX00`000000l48J0?126P02
0?126P050=@m6@0mFJ/0?EV[03eIZ`3@>1D00P0000001@2T:Pl000000:@Z3`000000?EV[00@0ooK^
00<0?EV[0?ofkP3om^h04P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP80?EV[2`3om^h303eIZ`80ooK^
00@000000?ofkP3om^h0?EV[3`3om^h00`0mFJ/0ooK^0?ofkP060?ofkP<0?EV[2P3om^h00`0mFJ/0
ooK^0?ofkP0G0?ofkP030000003om^h0ooK^03P0ooK^0@3oool00140ooK^00<000000?ofkP3om^h0
D03om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^0080ooK^00D0e3dI0?ofkP3om^h0
00000?ofkP020=@m6@80?EV[0`3om^h00`3D?AT0?EV[03eIZ`0303eIZ`040?ofkP3D?AT0e3dI0?of
kP<0?EV[0P3om^h0103D?AT0?EV[03eIZ`0mFJ/30?ofkP80?EV[0`0G73`300000003020ZF@000000
82YI00H082YI00@00000020ZF@0P:UT082YI0`000000100P:UT0e3dI0=@m6@0P:UT3000000@0:3Ma
00<0000002PgL@0X=g40100X=g40103D?AT0:3Ma02PgL@00000902PgL@040000000X=g4000000000
00<0;T2300<0e3dI02i0P`000000100^@8<00`3D?AT0;T2302i0P`0302i0P`030000000^@8<0;T23
00L0;T2300<0000002i0P`0000000`0000001@3D?AT0<dRA03=8T@0cB940e3dI00T0<dRA00<00000
03=8T@0cB9401P0cB9400`3D?AT0<dRA03=8T@0203=8T@030=@m6@0cB940<dRA0080<dRA00@00000
03=8T@00000000001@0gCYh00`000000odlP000000030?m<7`030000003oC1l0od`O00<0od`O00L0
00000?m<7`3oC1l0od`O0000003oB1d0000000<0odPM00<0?EV[0?m87@0000000P3oB1d010000000
l48J0?126P0000020?126P<0?EV[0P0000020=0h5@070000003@>1D000000000002T:Pl0000003eI
Z`040?ofkP0303eIZ`3om^h0ooK^0180ooK^0P0mFJ/0103om^h0?EV[03eIZ`0mFJ/:0?ofkP<0?EV[
0`3om^h01P0mFJ/0ooK^0?ofkP000000ooK^03eIZ`l0ooK^00<0?EV[0?ofkP3om^h00`3om^h303eI
Z`d0ooK^00<0?EV[0?ofkP3om^h05`3om^h00`000000ooK^0?ofkP0h0?ofkP40oooo000A0?ofkP03
0000003om^h0ooK^0540ooK^00<0e3dI0?ofkP3om^h00P3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI
00<0ooK^0`0mFJ/01P3D?AT0ooK^0?ofkP3om^h0?EV[0=@m6@80?EV[1P3om^h0103D?AT0ooK^0?of
kP3om^h203eIZ`030=@m6@0mFJ/0ooK^0080ooK^0P0mFJ/00`3om^h0000000000002000000@082YI
00<00000020ZF@0P:UT01@0P:UT01000000082YI000000000002020ZF@80e3dI0`00000702PgL@03
0000000X=g40:3Ma00D0:3Ma00<0e3dI02PgL@000000200X=g43000000@0;T2300D0e3dI02i0P`0^
@8<0;T230000000402i0P`030=@m6@0^@8<0;T230080;T2300<0000002i0P`0^@8<01P0^@8<30000
00<0<dRA00<0e3dI03=8T@0cB9400P0cB9400`000000e3dI03=8T@0703=8T@030000000cB940<dRA
00D0<dRA00<0e3dI0000000cB940100cB9400`3D?AT0<dRA03=8T@03000000H0=djN00L000000?m?
803oCb00odlP0000003oC1l0000000H0od`O00<000000?m<7`3oC1l00P3oC1l2000000<0odPM00<0
?EV[0?m87@0000000`3oB1d00`000000l48J03eIZ`0203eIZ`<0l48J00D000000?126P000000d3PE
000000020=0h5@80000000<0Y2X?0000000mFJ/0103om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP<0?EV[
2P3om^h303eIZ`H0ooK^00@0?EV[0?ofkP3om^h000000P3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP03
03eIZ`3om^h0?EV[0080?EV[4@3om^h00`0mFJ/0ooK^0?ofkP0G0?ofkP030000003om^h0ooK^03L0
ooK^0@3oool00140ooK^00<000000?ofkP3om^h0DP3om^h00`3D?AT0ooK^0?ofkP020?ofkP80e3dI
00<0ooK^0=@m6@0mFJ/00`0mFJ/010000000ooK^0?ofkP3D?AT303eIZ`030=@m6@0mFJ/0ooK^00L0
ooK^00<0e3dI03eIZ`0mFJ/00P3om^h00`3D?AT0?EV[0?ofkP0203eIZ`80ooK^0P000006020ZF@03
0000000P:UT082YI00D082YI0`000002020ZF@80e3dI0P0000000`0mFJ/0000002PgL@0702PgL@03
0000000X=g40:3Ma00H0:3Ma00<0e3dI0000000X=g40100X=g430000000302i0P`000000;T2300<0
;T2300<0e3dI02i0P`0^@8<00P0^@8<00`000000;T2302i0P`0302i0P`050=@m6@0^@8<0;T2302i0
P`0000001P0^@8<20000000303=8T@000000<dRA0080<dRA00<0e3dI03=8T@0cB9400`0cB9400`00
0000<dRA0=@m6@0703=8T@030000000cB940<dRA00@0<dRA00<0e3dI03=8T@0000001@0cB9401@00
0000e3dI0000000gCYh0000000L0=djN00<000000?m?803oCb000P3oCb02000000H0od`O00<00000
0?m<7`3oC1l00`3oC1l01`000000odPM0?m87@3oB1d0?EV[0?m87@0000000`3oB1d203eIZ`030000
003`@QX0l48J00<0l48J00D000000?126P000000d3PE000000030=0h5@050000002T:Pl0000003eI
Z`0000000`3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP<0?EV[00<0ooK^03eIZ`3om^h01`3om^h303eI
Z`T0ooK^00L0?EV[0?ofkP3om^h0ooK^0000003om^h0?EV[00h0ooK^0`0mFJ/D0?ofkP0303eIZ`3o
m^h0ooK^01L0ooK^00<000000?ofkP3om^h0=`3om^h10?ooo`00403om^h00`000000ooK^0?ofkP1D
0?ofkP80e3dI103om^h20=@m6@80?EV[0`3om^h303eIZ`040=@m6@3om^h0ooK^0=@m6@L0ooK^0`0m
FJ/01@3D?AT0ooK^0?ofkP3om^h0e3dI00<0?EV[0`3om^h00`00000082YI020ZF@05020ZF@030000
000P:UT082YI008082YI10000002020ZF@80e3dI0P00000302PgL@030000000X=g40:3Ma00H0:3Ma
00<0000002PgL@0X=g401`0X=g400`3D?AT0:3Ma00000003000000@0;T2300<0000002i0P`0^@8<0
0P3D?AT502i0P`030000000^@8<0;T2300@0;T2300@0e3dI02i0P`0^@8<000000`0^@8<3000000<0
<dRA00@0000003=8T@0cB940e3dI1P0cB94010000000<dRA03=8T@3D?AT603=8T@030000000cB940
<dRA00@0<dRA00@0e3dI03=8T@000000<dRA1000000203M>WP030=@m6@0gCYh0000000L0=djN00<0
00000?m?803oCb000`3oCb000`000000od`O0?m<7`040?m<7`030000003oC1l0od`O00<0od`O0P00
00030?m87@0303eIZ`000000?EV[0080?EV[0P3oB1d00`000000l48J0?126P030?126P060000003`
@QX0l48J0000003@>1D000000P3@>1D2000000040:@Z3`0mFJ/00000000000<0ooK^00<0?EV[0?of
kP3om^h02P3om^h303eIZ`@0ooK^0P0mFJ/40?ofkP<0?EV[303om^h00`0mFJ/0ooK^0?ofkP020?of
kP030000000mFJ/0ooK^00X0ooK^0`0mFJ/00`3om^h0?EV[0?ofkP0D0?ofkP0303eIZ`3om^h0ooK^
01L0ooK^0P00000h0?ofkP40oooo000@0?ofkP030000003om^h0ooK^05D0ooK^0P3D?AT303eIZ`03
0?ofkP3D?AT0e3dI0080ooK^100mFJ/20?ofkP030=@m6@3om^h0e3dI00D0ooK^0P0mFJ/40?ofkP04
0=@m6@0mFJ/0e3dI03eIZ`<0ooK^0P0mFJ/00`3om^h00000020ZF@06020ZF@030000000P:UT082YI
008000000`0P:UT01P000000e3dI0=@m6@000000:3Ma0=@m6@@0:3Ma00<0000002PgL@0X=g401P0X
=g400`000000:3Ma02PgL@0602PgL@80000000<0e3dI02i0P`0^@8<01P0^@8<00`000000;T230=@m
6@0702i0P`030000000^@8<0;T2300D0;T2300@0e3dI02i0P`000000;T230P00000603=8T@030000
000cB940e3dI00L0<dRA00D0000003=8T@0cB940<dRA0=@m6@0503=8T@030000000cB940<dRA00<0
<dRA00<0e3dI03=8T@0000000P00000603M>WP030=@m6@0gCYh0000000L0=djN00<000000?m?803o
Cb000`3oCb02000000D0od`O00<000000?m<7`3oC1l00`3oC1l010000000od`O0000003oB1d303eI
Z`D0odPM0P0000030?126P030000003`@QX0l48J0080l48J0P0000020=0h5@050000003@>1D00000
0000000mFJ/00P0000020?ofkP0303eIZ`3om^h0ooK^00H0ooK^100mFJ/80?ofkP0303eIZ`3om^h0
?EV[0080?EV[403om^h00`0mFJ/0ooK^0?ofkP020?ofkP030000000mFJ/0ooK^00H0ooK^0`0mFJ/4
0?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h0503om^h3000000030?ofkP000000
ooK^03L0ooK^0@3oool00100ooK^00<000000?ofkP3om^h0E03om^h303eIZ`030=@m6@0mFJ/0?EV[
0080?EV[00<0e3dI03eIZ`0mFJ/00P0mFJ/20?ofkP80000000<0ooK^0=@m6@3D?AT00P3om^h303eI
Z`@0ooK^0`0mFJ/20=@m6@H0ooK^00<00000020ZF@0P:UT01P0P:UT3000000<082YI0`3D?AT00`00
0000:3Ma02PgL@0202PgL@050=@m6@0X=g40:3Ma02PgL@000000200X=g400`000000:3Ma02PgL@04
02PgL@80000000@0;T230000000^@8<0e3dI1`0^@8<00`000000e3dI02i0P`0702i0P`030000000^
@8<0;T2300H0;T2300<0e3dI000000000000200cB9400`000000e3dI03=8T@0703=8T@030000000c
B940<dRA0080<dRA00<0e3dI03=8T@0cB9400P0cB9400`000000<dRA03=8T@0203=8T@050=@m6@00
0000000003M>WP000000200gCYh00`3D?AT0=djN03M>WP0503M>WP030=@m6@000000odlP00@0odlP
00<000000?m?80000000103oC1l00`000000od`O0?m<7`030?m<7`070000000mFJ/0?EV[03eIZ`3o
B1d0?EV[000000050?m87@030000003oB1d000000080l48J00<000000?126P3`@QX00`3`@QX01000
0000d3PE0=0h5@3@>1D2000000040:@Z3`0mFJ/0Y2X?00000080ooK^00<0?EV[0?ofkP3om^h00`3o
m^h303eIZ`/0ooK^0`0mFJ/C0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0000003eIZ`3om^h0103o
m^h203eIZ`P0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP<00000103o
m^h00`000000ooK^0?ofkP0f0?ofkP40oooo000@0?ofkP030000003om^h0ooK^0580ooK^0`0mFJ/3
0?ofkP80e3dI00@0?EV[0?ofkP0mFJ/0e3dI0P3om^h403eIZ`040?ofkP000000?EV[0=@m6@80?EV[
103om^h303eIZ`@0ooK^00<0e3dI0?ofkP3om^h0103om^h00`00000082YI020ZF@03020ZF@<00000
0`0P:UT30=@m6@030000000X=g40000000H0:3Ma00@0e3dI02PgL@0X=g400000200X=g4010000000
:3Ma02PgL@0X=g43000000<0;T2300@0000002i0P`0^@8<0e3dI1P0^@8<00`3D?AT0;T2302i0P`07
02i0P`030000000^@8<0;T2300@0;T230P0000000`0cB940e3dI03=8T@0803=8T@030=@m6@0cB940
<dRA00L0<dRA00<0000003=8T@0cB9400`0cB9401P3D?AT0<dRA03=8T@0cB940000003=8T@<00000
00D0e3dI03M>WP0gCYh0=djN0000000803M>WP030000003D?AT0=djN00@0=djN00<0e3dI03M>WP0m
FJ/0103oCb001@000000odlP0?m?803oCb0000000080od`O00<000000?m<7`3oC1l00P3oC1l303eI
Z`80od`O00@000000?m87@000000?EV[1@3oB1d00`000000odPM000000020?126P030000003`@QX0
l48J00<0l48J0P0000020=0h5@050000003@>1D000000000000mFJ/00P0000020?ofkP0303eIZ`3o
m^h0?EV[0080?EV[2`3om^h303eIZ`030?ofkP0mFJ/0ooK^01<0ooK^00<0?EV[0?ofkP3om^h00`3o
m^h00`000000?EV[0?ofkP0303eIZ`X0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?of
kP0=0?ofkP<00000203om^h00`000000ooK^0?ofkP0e0?ofkP40oooo000?0?ofkP030000003om^h0
ooK^0500ooK^0`0mFJ/70?ofkP<0e3dI00<0ooK^0=@m6@3D?AT01@3om^h303eIZ`80e3dI0`3om^h2
03eIZ`H0ooK^00<0?EV[0=@m6@3D?AT0103om^h00`0mFJ/00000020ZF@02020ZF@8000000P0P:UT0
1@00000082YI0=@m6@3D?AT0000000@0:3Ma00<0000002PgL@0X=g401@0X=g400`3D?AT0:3Ma0000
000802PgL@040000000X=g400000000000L0;T2300@0000002i0P`0^@8<0e3dI0`0^@8<20=@m6@03
02i0P`000000;T2300P0;T2300@0000002i0P`0^@8<0;T230P00000303=8T@030000003D?AT0<dRA
00H0<dRA00<0e3dI0000000cB940200cB9400`000000<dRA03=8T@0403=8T@030=@m6@0cB9400000
008000000P0gCYh00`3D?AT0=djN03M>WP0203M>WP030000000gCYh0=djN00H0=djN00<0000003M>
WP3D?AT0100gCYh00`3D?AT0=djN03eIZ`040?m?80030000003oCb00odlP0080odlP00@000000?m<
7`000000od`O0`0mFJ/00`3oC1l000000?m<7`030?m<7`80000000<0?EV[0?m87@3oB1d00`3oB1d0
1P000000odPM0?m87@000000l48J000000D0l48J00D000000?126P000000d3PE000000020=0h5@03
0000000mFJ/0Y2X?0080000000<0ooK^03eIZ`0mFJ/02`3om^h303eIZ`D0ooK^00<0?EV[0?ofkP3o
m^h04@3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`000000?EV[00d0ooK^00<0?EV[0?ofkP3o
m^h04`3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP<000002`3om^h00`000000ooK^0?ofkP0e0?ofkP40
oooo000?0?ofkP030000003om^h0ooK^04h0ooK^0P0mFJ/80?ofkP<0?EV[1`3D?AT40?ofkP0303eI
Z`3om^h0?EV[0080e3dI0P0mFJ/80?ofkP0403eIZ`3D?AT0ooK^0=@m6@<0?EV[00<0ooK^00000000
00000P000003020ZF@<0e3dI1`0X=g400`000000:3Ma02PgL@0602PgL@030=@m6@000000:3Ma00H0
:3Ma0`00000902i0P`070000000^@8<0;T2302i0P`3D?AT0;T230=@m6@0302i0P`030000000^@8<0
;T2300L0;T2300@0000002i0P`00000000001@0cB9400`000000<dRA0=@m6@0503=8T@040=@m6@0c
B940<dRA000000P0<dRA00<0000003=8T@0cB940100cB94010000000e3dI03M>WP00000203M>WP03
0=@m6@0gCYh0=djN00<0=djN00<0000003M>WP0gCYh01P0gCYh010000000=djN03M>WP3D?AT203M>
WP050=@m6@0gCYh0=djN0000000mFJ/00`3oCb000`000000odlP0?m?80020?m?80@0?EV[103oC1l0
0`000000od`O0?m<7`030?m<7`030000000mFJ/0odPM00@0odPM00@000000?m87@3oB1d0odPM0P00
00050?126P050000003`@QX000000=0h5@0000000`3@>1D00`0mFJ/0Y2X?000000020000000303eI
Z`3om^h0ooK^00L0ooK^0`0mFJ/80?ofkP0303eIZ`3om^h0ooK^0180ooK^00<0?EV[0?ofkP0mFJ/0
0P0mFJ/00`3om^h0000003eIZ`0=0?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h0
1`3om^h3000000h0ooK^00<000000?ofkP3om^h0=@3om^h10?ooo`003`3om^h00`000000ooK^0?of
kP1=0?ofkP0303eIZ`3om^h0ooK^00D0ooK^100mFJ/30?ofkP80e3dI00<0ooK^0=@m6@3D?AT00P3D
?AT20?ofkP0603eIZ`3om^h0?EV[03eIZ`3D?AT0?EV[0P3D?AT80?ofkP0503eIZ`3D?AT0?EV[03eI
Z`3D?AT00P3om^h20000008082YI103D?AT00`0mFJ/0000002PgL@0702PgL@030000000X=g40:3Ma
00L0:3Ma00<0e3dI02PgL@0X=g400P0X=g430000000302i0P`000000;T2300T0;T2300<0000002i0
P`0^@8<00P0^@8<00`3D?AT0;T2302i0P`0202i0P`030000000^@8<0;T2300H0;T230`00000803=8
T@030000000cB940e3dI00<0<dRA00D0e3dI03=8T@0cB940<dRA0000000803=8T@040000000cB940
<dRA03=8T@<000000P0gCYh0103D?AT0000003M>WP3D?AT603M>WP030000000gCYh0=djN00H0=djN
00/0000003M>WP0gCYh0=djN0=@m6@0gCYh0e3dI03M>WP000000odlP03eIZ`030?m?80030000003o
Cb00?EV[0080?EV[0P3oCb000`000000od`O0?m<7`030?m<7`030000003oC1l0od`O00<0od`O0P00
00001@0mFJ/0odPM0?m87@3oB1d0000000D0odPM00<000000?126P3`@QX00`3`@QX01P000000l48J
0?126P000000d3PE00000080d3PE00@0000003eIZ`000000Y2X?0P0000070?ofkP80?EV[2`3om^h2
03eIZa80ooK^0`0mFJ/50?ofkP030000003om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h0503om^h0
0`0mFJ/0ooK^0?ofkP020?ofkP@000004@3om^h00`000000ooK^0?ofkP0e0?ofkP40oooo000?0?of
kP030000003om^h0ooK^04`0ooK^00<0?EV[0?ofkP3om^h00`3om^h303eIZ`<0ooK^00<0?EV[0?of
kP3om^h00P3om^h20=@m6@030?ofkP3D?AT0ooK^00<0e3dI0P0mFJ/20?ofkP050=@m6@000000?EV[
03eIZ`3D?AT01P3om^h203eIZ`030=@m6@3om^h0ooK^00<00000103D?AT20000000402PgL@3D?AT0
:3Ma000000P0:3Ma00<0000002PgL@0X=g401`0X=g400`000000e3dI0=@m6@02000000@0;T2300<0
000002i0P`0^@8<0200^@8<00`000000;T2302i0P`020=@m6@0302i0P`3D?AT0;T230080;T2300<0
000002i0P`0^@8<00`0^@8<30000000303=8T@000000<dRA00P0<dRA00H0000003=8T@0cB940e3dI
03=8T@3D?AT403=8T@030000000cB940<dRA00H0<dRA00@0000003=8T@00000000001P0gCYh00`3D
?AT0=djN0=@m6@0603M>WP030000000gCYh0=djN00H0=djN00<0000003M>WP0gCYh00P0gCYh01P3D
?AT0=djN03M>WP000000odlP03eIZ`80odlP0`0mFJ/50?m?80800000103oC1l00`000000od`O0?m<
7`020?m<7`040000003oC1l0od`O03eIZ`<0odPM00<000000?m87@3oB1d00`3oB1d2000000<0l48J
00<000000?126P3`@QX00P3`@QX200000080d3PE00L0000003eIZ`2T:Pl000000:@Z3`000000?EV[
00<0ooK^0`0mFJ/>0?ofkP0303eIZ`3om^h0ooK^00d0ooK^0`0mFJ/00`3om^h0?EV[0?ofkP050?of
kP0303eIZ`000000ooK^00`0ooK^00<0?EV[0?ofkP3om^h04P3om^h203eIZ`040?ofkP0000000000
000001D0ooK^00<000000?ofkP3om^h0=@3om^h10?ooo`003`3om^h00`000000ooK^0?ofkP1;0?of
kP0303eIZ`3om^h0ooK^0080ooK^0P0mFJ/50?ofkP0303eIZ`3om^h0ooK^00@0ooK^0`3D?AT00`3o
m^h0?EV[03eIZ`090=@m6@0403eIZ`3D?AT0ooK^0?ofkP<0?EV[00<0ooK^03eIZ`0000000P000003
0=@m6@040000000P:UT00000000000@0:3Ma00<0e3dI0000000X=g40200X=g400`000000:3Ma02Pg
L@0502PgL@<0000000<0;T230=@m6@0^@8<01@0^@8<00`000000;T2302i0P`0702i0P`030000003D
?AT0e3dI00@0;T2300D0e3dI02i0P`0^@8<0000002i0P`04000000@0<dRA00<0000003=8T@0cB940
1`0cB9401@000000<dRA03=8T@0cB940e3dI00D0<dRA00<0000003=8T@0cB9401@0cB943000000P0
=djN00<000000=@m6@0gCYh01@0gCYh00`000000=djN03M>WP0703M>WP0:0000000gCYh0=djN03M>
WP3D?AT0=djN0=@m6@0gCYh000000?m?80<0?EV[00<000000?m?803oCb00103oCb0010000000odlP
0?m?800000030?m<7`030000003oC1l0od`O0080od`O00D000000?m<7`3oC1l0?EV[000000020?m8
7@030000003oB1d0odPM00<0odPM00<000000?m87@0000000P3`@QX00`000000l48J0?126P030?12
6P050000003@>1D0d3PE0000000mFJ/00P0000000`2T:Pl000000000000303eIZa40ooK^00<0?EV[
0?ofkP3om^h02P3om^h303eIZ`@0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/000000?ofkP0;
0?ofkP0303eIZ`3om^h0ooK^00h0ooK^100mFJ/00`000000?EV[0000000I0?ofkP030000003om^h0
ooK^03@0ooK^0@3oool000h0ooK^00<000000?ofkP3om^h0B`3om^h00`0mFJ/0ooK^0?ofkP0303eI
Z`L0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0e3dI0=@m6@020?ofkP0403eIZ`3D?AT0ooK^
0=@m6@80ooK^00<0e3dI0?ofkP0000001`3D?AT2000000030=@m6@3om^h0ooK^0080ooK^00<0?EV[
0=@m6@0000001`0X=g400`3D?AT0:3Ma02PgL@0702PgL@030000000X=g40:3Ma00<0:3Ma0P000000
0`0^@8<0000002i0P`0202i0P`030=@m6@0^@8<0;T2300<0;T2300<0000002i0P`0^@8<01P0^@8<2
0=@m6@L0;T2300@0e3dI0000000000000000200cB9400`000000<dRA03=8T@0703=8T@060000000c
B940e3dI0=@m6@0cB940e3dI100cB9400`000000<dRA03=8T@0203=8T@<0000000<0=djN0000000g
CYh0200gCYh00`3D?AT0=djN0=@m6@0503M>WP030000000gCYh0=djN00H0=djN00<0000003M>WP0g
CYh00P0gCYh0103D?AT0=djN03M>WP3D?AT203eIZ`040?m?800mFJ/0odlP000000H0odlP00@00000
0?m?803oCb0000000P3oC1l00`000000od`O0?m<7`030?m<7`080000003oC1l0od`O0?m<7`0mFJ/0
00000?m87@0000050?m87@030000003oB1d000000080l48J00<000000?126P3`@QX00`3`@QX20000
00050=0h5@000000d3PE03eIZ`0000000`0mFJ/00`000000ooK^0?ofkP0A0?ofkP80?EV[1`3om^h4
03eIZ`P0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/000000?ofkP0;0?ofkP0303eIZ`3om^h0
ooK^00/0ooK^0`0mFJ/01P3om^h00000000000000000ooK^03eIZaX0ooK^00<000000?ofkP3om^h0
=03om^h10?ooo`003P3om^h00`000000ooK^0?ofkP1:0?ofkP@0?EV[2@3om^h00`0mFJ/0ooK^0?of
kP040?ofkP80?EV[0P3om^h02P3D?AT0ooK^0?ofkP0mFJ/0ooK^0=@m6@3om^h0e3dI0?ofkP3D?AT3
0?ofkP030000003om^h0e3dI00<0000000<0e3dI0?ofkP3D?AT00P3om^h203eIZ`030?ofkP000000
:3Ma00L0:3Ma00<000000=@m6@0X=g401`0X=g4010000000:3Ma02PgL@0X=g42000000<0;T2300<0
000002i0P`0^@8<00P0^@8<00`3D?AT0;T2302i0P`0202i0P`030000000^@8<0;T2300@0;T230P3D
?AT202i0P`030000000^@8<0;T230080;T230`0000000`3D?AT0000003=8T@0903=8T@030000000c
B940<dRA00H0<dRA00<000000=@m6@0cB9400`0cB9401P3D?AT0<dRA03=8T@0cB940000003=8T@<0
0000100gCYh00`000000=djN03M>WP0603M>WP050=@m6@000000=djN03M>WP3D?AT0100gCYh00`00
0000=djN03M>WP0603M>WP050000000gCYh0=djN03M>WP3D?AT00`0000000`0jE:T0000000000002
0?m?800303eIZ`000000odlP00D0odlP00L000000?m?803oCb00odlP0000003oC1l0000000D0od`O
00H000000?m<7`3oC1l0od`O03eIZ`3oC1l2000000D0odPM00H000000?m87@3oB1d000000?126P00
00050?126P8000000P3@>1D303eIZ`030000002T:Pl00000008000004P3om^h203eIZ`@0ooK^0`0m
FJ/<0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0000003om^h02P3om^h00`0mFJ/0ooK^0?of
kP070?ofkP@0?EV[00@0ooK^0000000000000000103om^h00`0mFJ/0ooK^0?ofkP0H0?ofkP030000
003om^h0ooK^03@0ooK^0@3oool000h0ooK^00<000000?ofkP3om^h0B@3om^h203eIZ``0ooK^00<0
?EV[0?ofkP3om^h00P3om^h203eIZ`D0ooK^0P3D?AT00`0mFJ/0ooK^0?ofkP040=@m6@<0ooK^0`00
0000103D?AT0ooK^0?ofkP0mFJ/20=@m6@80?EV[0`3om^h00`000000:3Ma02PgL@0602PgL@030000
000X=g40e3dI00L0:3Ma00@0000002PgL@00000000001P0^@8<00`000000;T2302i0P`0202i0P`05
0=@m6@0^@8<0;T2302i0P`000000100^@8<20=@m6@@0;T2300<0000002i0P`0000000P00000403=8
T@030=@m6@0cB940<dRA00P0<dRA00<0000003=8T@0cB9401P0cB9400`3D?AT0<dRA03=8T@0403=8
T@030=@m6@0cB9400000008000001`0gCYh00`000000=djN03M>WP0503M>WP030=@m6@0gCYh00000
00<0=djN00D0e3dI03M>WP0gCYh0=djN0000000803M>WP050000000gCYh000000=@m6@0000000`0j
E:T00`000000oe0Q000000020?m?800303eIZ`000000odlP00D0odlP00<000000?m?803oCb000P3o
Cb02000000@0od`O00<000000?m<7`3oC1l00`3oC1l00`0mFJ/0od`O000000050?m87@040000003o
B1d0odPM0?m87@8000001@3`@QX020000000?EV[03eIZ`0mFJ/0000003eIZ`3@>1D000000P2T:Pl3
00000180ooK^1@0mFJ/?0?ofkP0303eIZ`3om^h0ooK^00@0ooK^0P0mFJ/00`3om^h000000?ofkP0:
0?ofkP0303eIZ`3om^h0ooK^00<0ooK^0`0mFJ/20?ofkP<00000203om^h00`0mFJ/0ooK^0?ofkP0G
0?ofkP030000003om^h0ooK^03@0ooK^0@3oool000h0ooK^00<000000?ofkP3om^h0B03om^h00`0m
FJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00<0?EV[203om^h20=@m6@@0ooK^0P3D?AT00`3o
m^h00000000000020?ofkP040000003om^h0e3dI0=@m6@80?EV[00<0e3dI0?ofkP3om^h00`3om^h0
0`000000:3Ma02PgL@0602PgL@040000000X=g40:3Ma0=@m6@D0:3Ma0`00000802i0P`030000000^
@8<0;T2300<0;T2300@0e3dI02i0P`0^@8<000000P0^@8<20=@m6@D0;T230`00000803=8T@030=@m
6@0cB940<dRA00L0<dRA00<0000003=8T@0cB940100cB9420=@m6@0303=8T@000000<dRA00<0<dRA
0P0000000`3D?AT0=djN0000000803M>WP030000000gCYh0=djN00@0=djN00@0e3dI03M>WP0gCYh0
00000`0gCYh01@3D?AT0=djN03M>WP0gCYh0000000L0=djN0`0000000`0jE:T0e3dI03YDZ@0303YD
Z@070000003oD240oe0Q0000003oCb00?EV[000000050?m?80030000003oCb00odlP00@0odlP00<0
00000?m<7`3oC1l00P3oC1l00`000000od`O0?m<7`030?m<7`0403eIZ`3oC1l00000000000<0odPM
00<000000?m87@3oB1d00`3oB1d00`000000l48J0?126P020?126P80?EV[0P3`@QX2000000050=0h
5@0mFJ/000000000002T:Pl00`00000A0?ofkP<0?EV[4P3om^h0100mFJ/0ooK^0?ofkP3om^h303eI
Z`050?ofkP0mFJ/0ooK^0?ofkP0000002P3om^h00`0mFJ/0ooK^03eIZ`0303eIZ`80ooK^0`00000;
0?ofkP0303eIZ`3om^h0ooK^01L0ooK^00<000000?ofkP3om^h0=03om^h10?ooo`003@3om^h00`00
0000ooK^0?ofkP190?ofkP0303eIZ`3om^h0ooK^00/0ooK^0`0mFJ/;0?ofkP0303eIZ`3D?AT0e3dI
00<0ooK^0`0000050?ofkP<0?EV[00@0e3dI0?ofkP3D?AT0e3dI103om^h00`000000:3Ma02PgL@06
02PgL@040000000X=g40:3Ma02PgL@80e3dI0`0000000`0^@8<0000002i0P`0802i0P`030000000^
@8<0;T2300@0;T2300<0e3dI02i0P`0000000P3D?AT502i0P`80000000<0<dRA0000000cB940200c
B9400`000000e3dI0=@m6@0703=8T@030000000cB940<dRA00<0<dRA00H0e3dI03=8T@0cB940<dRA
0000000cB943000000<0=djN00<0e3dI0000000gCYh01`0gCYh00`000000=djN03M>WP0303M>WP05
0=@m6@0gCYh0=djN03M>WP000000100gCYh0103D?AT0=djN03M>WP00000403M>WP<0000000@0>UBY
0000000jE:T0e3dI1@0jE:T010000000oe0Q0?m@8@3oD2420000000303eIZ`3oCb00odlP00<0odlP
00<000000?m?803oCb00103oCb02000000<0od`O00<000000?m<7`3oC1l00`3oC1l01@0mFJ/00000
0?m<7`3oC1l000000080odPM00<000000?m87@3oB1d00`3oB1d2000000<0?EV[00@000000?126P3`
@QX0l48J0P0000001P3@>1D0?EV[0000003@>1D000000:@Z3`<000003@3om^h303eIZ`040?ofkP0m
FJ/0ooK^03eIZa40ooK^100mFJ/50?ofkP0303eIZ`3om^h0000000T0ooK^0`0mFJ/30?ofkP<00000
3P3om^h00`0mFJ/0ooK^0?ofkP0G0?ofkP030000003om^h0ooK^03@0ooK^0@3oool000d0ooK^00<0
00000?ofkP3om^h0B03om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP<0?EV[3@3om^h00`0mFJ/0ooK^0=@m
6@0300000080ooK^0P3D?AT0203om^h0?EV[03eIZ`0mFJ/0ooK^0000003om^h0?EV[0P3D?AT00`3o
m^h0e3dI0?ofkP020?ofkP030000000X=g40:3Ma00H0:3Ma00<0000002PgL@0000000`0000001@3D
?AT0;T2302i0P`0^@8<0000000T0;T2300<0000002i0P`0^@8<0100^@8<30=@m6@040000000^@8<0
;T2302i0P`<000000`0cB9400`000000<dRA03=8T@0703=8T@040000000cB940<dRA0=@m6@H0<dRA
00<0000003=8T@0cB9400P0cB940103D?AT0<dRA03=8T@0cB943000000L0=djN00<0e3dI03M>WP0g
CYh01P0gCYh00`000000=djN03M>WP0203M>WP030=@m6@0gCYh0=djN0080=djN00<0000003M>WP0g
CYh00`0gCYh0103D?AT0=djN0000000gCYh3000000@0>UBY00<000000=@m6@0jE:T01@0jE:T01000
0000oe0Q0?m@8@3oD2420000000303eIZ`3oCb00odlP00<0odlP00<000000?m?803oCb000`3oCb00
10000000odlP0?m?800000020?m<7`030000003oC1l0od`O00@0od`O00@0?EV[0?m<7`3oC1l00000
0P3oB1d00`000000odPM0?m87@020?m87@<0?EV[00@000000?126P3`@QX00000103`@QX01P000000
d3PE0=0h5@0mFJ/000000=0h5@D000002P3om^h203eIZ`@0ooK^00<0?EV[0?ofkP0mFJ/03`3om^h4
03eIZ`L0ooK^00@0?EV[0?ofkP3om^h000001@3om^h303eIZ`030?ofkP0mFJ/0ooK^00<000004@3o
m^h00`0mFJ/0ooK^0?ofkP0H0?ofkP030000003om^h0ooK^03<0ooK^0@3oool000d0ooK^00<00000
0?ofkP3om^h0B03om^h00`0mFJ/0ooK^0?ofkP070?ofkP<0?EV[00<0ooK^03eIZ`3om^h03@3om^h0
0`0mFJ/00000000000020=@m6@@0ooK^0`3D?AT40?ofkP040000000mFJ/0ooK^0=@m6@80ooK^00@0
e3dI0?ofkP3om^h000001`0X=g43000000D0;T2300D0e3dI02i0P`0^@8<0;T230000000802i0P`03
0000000^@8<0;T230080;T230P3D?AT202i0P`030=@m6@000000;T23008000001`0cB9400`000000
<dRA03=8T@0603=8T@050000000cB940<dRA03=8T@3D?AT01@0cB9400`000000<dRA03=8T@020=@m
6@80<dRA0P0000000`0gCYh0000003M>WP0703M>WP030=@m6@000000=djN00L0=djN00@0000003M>
WP0gCYh0e3dI1@0gCYh00`000000=djN03M>WP0403M>WP030=@m6@000000000000L0>UBY00<00000
0=@m6@0jE:T0100jE:T00`000000oe0Q0?m@8@030?m@8@030000000mFJ/0odlP00<0odlP00<00000
0?m?803oCb00103oCb001P000000odlP0?m?80000000od`O000000L0od`O00P0?EV[0?m<7`3oC1l0
od`O0000003oB1d000000?m87@<0?EV[00@000000?m87@3oB1d000000P3`@QX00`000000l48J0?12
6P020?126P80000000<0d3PE03eIZ`0000000P3@>1D5000000H0ooK^0`0mFJ/70?ofkP80?EV[303o
m^h303eIZ`<0ooK^00<0?EV[0?ofkP3om^h01P3om^h01@0mFJ/0ooK^0?ofkP000000ooK^00<0?EV[
0`3om^h00`000000?EV[0000000D0?ofkP0303eIZ`3om^h0ooK^01P0ooK^00<000000?ofkP3om^h0
<`3om^h10?ooo`003@3om^h00`000000ooK^0?ofkP170?ofkP0303eIZ`3om^h0ooK^00D0ooK^0`0m
FJ/30?ofkP0303eIZ`3om^h0ooK^00/0ooK^0`0000040?ofkP040=@m6@0mFJ/0?EV[03eIZ`80e3dI
00<0ooK^0=@m6@3om^h00`3om^h0100mFJ/000000=@m6@3D?AT20?ofkP80e3dI00<0000002PgL@0X
=g400`0X=g420000000302i0P`000000;T2300H0;T2300@0e3dI02i0P`0^@8<00000200^@8<00`00
0000;T230=@m6@020=@m6@@0;T2300<000000=@m6@0000002@0cB9400`000000<dRA03=8T@0703=8
T@050000000cB940<dRA03=8T@3D?AT01@0cB94010000000e3dI03=8T@0cB942000000<0=djN00<0
000003M>WP0gCYh01`0gCYh00`3D?AT0=djN03M>WP0603M>WP040000000gCYh0=djN0=@m6@D0=djN
00<0000003M>WP0gCYh00P0gCYh20000000303YDZ@3D?AT0>UBY00H0>UBY00<000000=@m6@0jE:T0
1@0jE:T00`000000oe0Q0?m@8@030?m@8@80000000D0?EV[0?m?803oCb00odlP000000060?m?8004
0000003oCb00odlP0?m?808000001P3oC1l00`000000?EV[0?m<7`030?m<7`030000000mFJ/0?EV[
00<0odPM00L000000?m87@3oB1d0odPM0000003`@QX0000000@0l48J00D000000?126P000000d3PE
03eIZ`030=0h5@80000000<0Y2X?0000000000000P3om^h303eIZ`X0ooK^00<0?EV[0?ofkP0mFJ/0
203om^h303eIZ`H0ooK^00<0?EV[0?ofkP3om^h01P3om^h01@0mFJ/0ooK^0?ofkP000000?EV[00<0
ooK^0`0000020?ofkP0303eIZ`3om^h0ooK^0180ooK^00<0?EV[0?ofkP3om^h0603om^h00`000000
ooK^0?ofkP0c0?ofkP40oooo000=0?ofkP030000003om^h0ooK^04L0ooK^00<0?EV[0?ofkP3om^h0
0`3om^h203eIZ`H0ooK^00<0?EV[0?ofkP3om^h02@3om^h2000000030?ofkP0mFJ/0ooK^0080ooK^
0`0mFJ/0103D?AT0ooK^0?ofkP3om^h40=@m6@<0ooK^00<0?EV[0?ofkP0000000P3D?AT0100mFJ/0
ooK^0?ofkP3D?AT302PgL@800000100^@8<00`000000;T2302i0P`0502i0P`030=@m6@0^@8<00000
00L0;T230`3D?AT402i0P`<0000000<0<dRA0000003D?AT02@0cB9400`000000<dRA03=8T@0703=8
T@030000000cB940<dRA0080<dRA00<0e3dI03=8T@0cB9400P0cB940103D?AT0<dRA000000000005
03M>WP030000000gCYh0=djN00L0=djN00<000000=@m6@0gCYh01P0gCYh00`000000=djN0=@m6@06
03M>WP030000000gCYh00000008000000`0jE:T00`000000e3dI03YDZ@0503YDZ@030=@m6@0jE:T0
>UBY00D0>UBY00<000000?m@8@3oD2400P3oD24010000000oe0Q0?m@8@0mFJ/30?m?80030000003o
Cb00odlP00<0odlP00<000000?m?803oCb000`3oCb000`000000od`O0?m<7`040?m<7`040000003o
C1l0?EV[0?m<7`<0?EV[00<000000?m87@3oB1d00P3oB1d00`000000odPM0?m87@020?m87@800000
103`@QX01@000000l48J0000003@>1D0?EV[00<0d3PE0`000000102T:Pl0000003eIZ`0mFJ/=0?of
kP0303eIZ`3om^h0?EV[00D0ooK^0`0mFJ/90?ofkP0303eIZ`3om^h0ooK^00H0ooK^0`0mFJ/00`3o
m^h0000000000002000000D0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP0G0?of
kP030000003om^h0ooK^03<0ooK^0@3oool000`0ooK^00<000000?ofkP3om^h0A`3om^h0100mFJ/0
ooK^0?ofkP3om^h303eIZ`P0ooK^00<0?EV[0?ofkP3om^h01P3om^h3000000<0ooK^00@0?EV[0?of
kP0mFJ/0?EV[103om^h20=@m6@040?ofkP3D?AT0ooK^0?ofkP80e3dI0P3om^h01P0mFJ/0ooK^0?of
kP3D?AT0ooK^0=@m6@80ooK^00@000000=@m6@00000000001P0^@8<00`000000;T2302i0P`0602i0
P`030=@m6@000000;T2300@0;T230P3D?AT202i0P`030000000^@8<00000008000001@0cB9400`00
0000e3dI03=8T@0703=8T@030000000cB940<dRA00L0<dRA00<0000003=8T@0cB9400`0cB940103D
?AT0<dRA0=@m6@3D?AT2000000P0=djN00<0000003M>WP0gCYh01P0gCYh00`000000=djN0=@m6@06
03M>WP030000003D?AT0=djN00D0=djN0`00000603YDZ@030000000jE:T0e3dI00D0>UBY00<0e3dI
03YDZ@0jE:T01@0jE:T00`000000oe0Q0?m@8@020?m@8@050000003oD240oe0Q0?m@8@0mFJ/00P3o
Cb000`000000odlP0?m?80030?m?80030000003oCb00odlP00<0odlP0P0000050?m<7`040000000m
FJ/0?EV[03eIZ`<0od`O0P0000030?m87@030000003oB1d0odPM00<0odPM00<000000?126P3`@QX0
0P3`@QX01P000000l48J0?126P000000?EV[00000080d3PE0`0000020:@Z3`030000003om^h0ooK^
00`0ooK^00D0?EV[0?ofkP3om^h0?EV[0?ofkP0303eIZ`d0ooK^00<0?EV[0?ofkP3om^h00P3om^h3
03eIZ`060?ofkP0mFJ/000000000003om^h000001`3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eI
Z`3om^h0ooK^01L0ooK^00<000000?ofkP3om^h0<`3om^h10?ooo`00303om^h00`000000ooK^0?of
kP170?ofkP@0?EV[2`3om^h00`0mFJ/0ooK^0?ofkP030?ofkP<000001@3om^h303eIZ`L0ooK^103D
?AT20?ofkP80e3dI00T0ooK^03eIZ`3om^h0ooK^0=@m6@000000ooK^0=@m6@3om^h00P0000000`3D
?AT0;T2302i0P`0502i0P`030000000^@8<0;T2300L0;T2300<0e3dI02i0P`0^@8<00`3D?AT302i0
P`<00000200cB9400`000000<dRA0=@m6@0803=8T@030000000cB940<dRA00H0<dRA00<0000003=8
T@0cB9400`0cB9401@000000e3dI0000000gCYh0000000T0=djN00<0000003M>WP0gCYh01P0gCYh0
10000000=djN03M>WP3D?AT503M>WP030=@m6@0gCYh0=djN0080=djN0`0000000`0jE:T0000003YD
Z@0603YDZ@030000000jE:T0e3dI00@0>UBY00<0e3dI0000000jE:T01@0jE:T00`000000oe0Q0?m@
8@030?m@8@050000003oD240oe0Q0?m@8@0mFJ/00P0000060?m?80030000003oCb00odlP0080odlP
00@000000?m?803oCb0000000P3oC1l303eIZ`030?m<7`0mFJ/0od`O0080od`O00<000000?m<7`00
00000`3oB1d00`000000odPM0?m87@030?m87@8000000`3`@QX01P000000l48J0?126P3`@QX00000
03eIZ`<0d3PE0`0000000`2T:Pl000000000000=0?ofkP0303eIZ`3om^h0?EV[0080?EV[403om^h0
0`0mFJ/0ooK^03eIZ`0203eIZ`060?ofkP00000000000000003om^h0?EV[0`3om^h00`000000ooK^
0?ofkP040?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h0603om^h00`000000ooK^
0?ofkP0b0?ofkP40oooo000<0?ofkP030000003om^h0ooK^04H0ooK^0P0mFJ/=0?ofkP0303eIZ`3o
m^h0ooK^0080ooK^0P0000060?ofkP80?EV[00<0ooK^03eIZ`3om^h0203om^h20=@m6@040?ofkP3D
?AT0e3dI0?ofkP80e3dI00T0?EV[0?ofkP3om^h0e3dI0?ofkP000000ooK^0=@m6@0000000P0^@8<0
0`3D?AT0;T2302i0P`0402i0P`030000000^@8<0;T2300H0;T23103D?AT402i0P`80000000<0<dRA
0000000cB940200cB94010000000<dRA03=8T@3D?AT703=8T@030000000cB940<dRA00L0<dRA00@0
000003=8T@00000000000P3D?AT0100gCYh0e3dI03M>WP00000903M>WP030000000gCYh0=djN00H0
=djN00D0000003M>WP0gCYh0=djN0=@m6@0303M>WP030=@m6@000000=djN00<00000100jE:T00`00
0000>UBY03YDZ@0503YDZ@040000000jE:T0>UBY0=@m6@80>UBY00<0e3dI03YDZ@0000001P0jE:T0
0`000000oe0Q0?m@8@030?m@8@070000003oD240oe0Q0?m@8@0mFJ/0oe0Q000000060?m?80030000
003oCb00odlP0080odlP00<000000?m?803oCb000`0mFJ/00`3oC1l000000?m<7`020?m<7`0403eI
Z`3oC1l0od`O00000080od`O00@000000?m87@3oB1d000001@3oB1d00`000000odPM000000020?12
6P030000003`@QX0l48J0080l48J00L0?EV[0=0h5@3@>1D0d3PE0000003@>1D000000080Y2X?0P00
000;0?ofkP<0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP<0?EV[00@0ooK^0000000000000000
103om^h01@0mFJ/0ooK^0?ofkP3om^h0000000L0ooK^00<0?EV[0?ofkP3om^h04@3om^h203eIZaX0
ooK^00<000000?ofkP3om^h0<P3om^h10?ooo`00303om^h00`000000ooK^0?ofkP160?ofkP0303eI
Z`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP0000000P0000050?ofkP<0?EV[0`3om^h00`0mFJ/0ooK^
0?ofkP080?ofkP<0e3dI00<0ooK^0=@m6@3D?AT00P3D?AT30?ofkP060=@m6@3om^h000000?ofkP3D
?AT000000P0^@8<00`3D?AT0;T2302i0P`0402i0P`030000000^@8<0;T2300D0e3dI0P0^@8<01000
0000e3dI02i0P`0^@8<2000000@0<dRA00<0000003=8T@0cB9401`0cB94010000000<dRA03=8T@3D
?AT603=8T@030000000cB940<dRA00H0<dRA0`0000020=@m6@@0=djN00<0e3dI03M>WP000000200g
CYh00`000000=djN03M>WP0703M>WP070000000gCYh0=djN03M>WP3D?AT0=djN0=@m6@03000000L0
>UBY00<0000003YDZ@0jE:T01@0jE:T02@000000>UBY03YDZ@0jE:T0e3dI03YDZ@3D?AT0>UBY0000
000603YDZ@030000003oD240oe0Q0080oe0Q00<000000?m@8@3oD2400`3oD2400`0mFJ/000000000
00040?m?80030000003oCb00odlP00<0odlP0`0mFJ/01@3oCb0000000?m<7`3oC1l0000000<0od`O
00@0?EV[0?m<7`3oC1l000000`3oC1l2000000D0odPM00@000000?m87@3oB1d000000P3`@QX00`00
0000l48J0?126P020?126P060000000mFJ/0d3PE0=0h5@000000d3PE0P0000000`2T:Pl000000000
00070?ofkP@0?EV[0P3om^h0100mFJ/0ooK^0?ofkP0mFJ/<0?ofkP<0?EV[00@0ooK^03eIZ`000000
0000203om^h01@0mFJ/0ooK^0?ofkP3om^h0000000H0ooK^00<0?EV[0?ofkP3om^h03P3om^h303eI
Z`030?ofkP0mFJ/0ooK^01T0ooK^00<000000?ofkP3om^h0<P3om^h10?ooo`002`3om^h00`000000
ooK^0?ofkP160?ofkP0303eIZ`3om^h0ooK^00`0ooK^0`0000060?ofkP80?EV[1P3om^h00`0mFJ/0
ooK^0?ofkP0:0?ofkP80e3dI0`3om^h80=@m6@0303eIZ`3D?AT0e3dI0080;T2300@0e3dI02i0P`0^
@8<0;T231@3D?AT702i0P`040000000^@8<0e3dI000000H0<dRA00<0000003=8T@0cB9401`0cB940
1@000000<dRA03=8T@0cB940e3dI00D0<dRA00<0000003=8T@0cB9400`0cB9430000000303M>WP3D
?AT0e3dI00L0=djN00<0e3dI0000000gCYh01`0gCYh00`000000=djN03M>WP0703M>WP030000000g
CYh0=djN0080=djN00@0e3dI0000000jE:T00000200jE:T00`000000>UBY03YDZ@0503YDZ@030000
000jE:T0>UBY0080>UBY00@0e3dI03YDZ@0jE:T000001P0jE:T00`000000oe0Q0?m@8@020?m@8@03
0000003oD240oe0Q00<0oe0Q00@0?EV[0?m@8@3oD24000000`3oCb000`000000odlP03eIZ`0303eI
Z`D0odlP0P0000050?m<7`0303eIZ`000000od`O00<0od`O0P0000050?m87@070000003oB1d0odPM
0?m87@000000l48J000000040?126P050000000mFJ/000000=0h5@0000000P3@>1D00`000000Y2X?
0:@Z3`02000000<0ooK^0`0mFJ/60?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/0203om^h303eIZ`05
0?ofkP00000000000000000mFJ/02P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP030000003om^h0ooK^
00<0ooK^00<0?EV[0?ofkP3om^h02P3om^h403eIZ`@0ooK^00<0?EV[0?ofkP3om^h0603om^h00`00
0000ooK^0?ofkP0b0?ofkP40oooo000;0?ofkP030000003om^h0ooK^04H0ooK^00<0?EV[0?ofkP3o
m^h02P3om^h2000000030?ofkP0mFJ/0ooK^00@0ooK^0P0mFJ/80?ofkP0303eIZ`3om^h0ooK^00/0
ooK^00D0e3dI0?ofkP3om^h0ooK^03eIZ`020=@m6@030?ofkP3D?AT0ooK^0080ooK^2@3D?AT202i0
P`030000000^@8<0;T2300H0;T230`0000000`0cB940e3dI0=@m6@0603=8T@030000000cB940<dRA
00L0<dRA00D0000003=8T@0cB940<dRA0=@m6@0503=8T@030000000cB9400000008000000`0gCYh0
0`3D?AT0=djN0000000803M>WP030=@m6@0gCYh0=djN00H0=djN00<0000003M>WP0gCYh01`0gCYh0
0`000000=djN000000020=@m6@0403YDZ@3D?AT0>UBY000000P0>UBY00<0000003YDZ@0jE:T0100j
E:T00`000000>UBY03YDZ@0203YDZ@050=@m6@0jE:T0e3dI03YDZ@0000001@0jE:T00`000000oe0Q
0?m@8@030?m@8@030000003oD240oe0Q00<0oe0Q00H0?EV[0?m@8@3oD240oe0Q0000003oCb0303eI
Z`<0odlP00<000000?m?803oCb00103oCb000`000000od`O0?m<7`030?m<7`0303eIZ`000000od`O
00@0od`O00<000000?m87@3oB1d00`3oB1d00`000000odPM0?m87@020?m87@800000103`@QX01@00
0000l48J03eIZ`3@>1D000000080d3PE0P0000000`2T:Pl000000:@Z3`0303eIZ`T0ooK^00D0?EV[
0?ofkP3om^h0ooK^03eIZ`040?ofkP@0?EV[00@0ooK^0000000000000000103om^h00`0mFJ/0ooK^
0?ofkP080?ofkP0503eIZ`3om^h0ooK^0?ofkP0000001@3om^h00`0mFJ/0ooK^0?ofkP070?ofkP<0
?EV[203om^h00`0mFJ/0ooK^0?ofkP0H0?ofkP030000003om^h0ooK^0380ooK^0@3oool000/0ooK^
00<000000?ofkP3om^h0AP3om^h00`0mFJ/0ooK^0?ofkP070?ofkP<000000P3om^h0100mFJ/0ooK^
0?ofkP3om^h303eIZ`X0ooK^00<0?EV[0?ofkP3om^h0303om^h20=@m6@040?ofkP0mFJ/0ooK^0?of
kP80e3dI0`0mFJ/00`3om^h0000002i0P`0402i0P`050=@m6@0^@8<0;T2302i0P`0000001@0^@8<3
0000000303=8T@000000<dRA00<0<dRA00<0e3dI03=8T@0cB9400`0cB9400`000000<dRA03=8T@07
03=8T@030000000cB940<dRA0080<dRA00@0e3dI03=8T@0cB940<dRA0`00000403M>WP80e3dI0P0g
CYh00`000000=djN03M>WP0603M>WP030000003D?AT0=djN00L0=djN00<0000003M>WP0gCYh01@0g
CYh3000000030=@m6@0jE:T0>UBY0080>UBY00<0e3dI0000000jE:T01`0jE:T00`000000>UBY03YD
Z@0403YDZ@050000000jE:T0>UBY03YDZ@3D?AT00`0jE:T00`3D?AT0>UBY03YDZ@0403YDZ@030000
003oD240oe0Q0080oe0Q00<000000?m@8@3oD240103oD2400`000000?EV[0?m@8@0303eIZ`030000
003oCb00odlP00<0odlP00<000000?m?803oCb00103oCb02000000@0od`O00<0000003eIZ`3oC1l0
103oC1l2000000@0odPM00<000000?m87@3oB1d00`3oB1d00`000000l48J0?126P020?126P080000
003`@QX0?EV[0000003D?AT000000=0h5@00000403eIZ`030000003D?AT0ooK^00X0ooK^00@0?EV[
0?ofkP3om^h0ooK^100mFJ/20?ofkP<000001`3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3o
m^h0ooK^0080ooK^00<000000?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP030?ofkP<0?EV[303o
m^h00`0mFJ/0ooK^0?ofkP0H0?ofkP030000003om^h0ooK^0340ooK^0@3oool000/0ooK^00<00000
0?ofkP3om^h0AP3om^h00`0mFJ/0ooK^0?ofkP050?ofkP8000001@3om^h0100mFJ/0ooK^03eIZ`0m
FJ/=0?ofkP0303eIZ`3om^h0ooK^00d0ooK^0P3D?AT0100mFJ/0ooK^03eIZ`0mFJ/20=@m6@@0ooK^
00<0000002i0P`0^@8<00`0^@8<01P3D?AT0;T2302i0P`0^@8<0000002i0P`<000001@0cB9400`00
0000<dRA03=8T@0203=8T@030=@m6@0cB940<dRA00<0<dRA00<0000003=8T@0cB9401P0cB9400`00
0000<dRA03=8T@0303=8T@050=@m6@000000000003M>WP0000000`0gCYh20=@m6@@0=djN00<00000
03M>WP0gCYh01`0gCYh00`000000e3dI03M>WP0603M>WP030000000gCYh0=djN0080=djN0`000000
0`0jE:T000000=@m6@0603YDZ@030=@m6@0jE:T0>UBY00H0>UBY00<0000003YDZ@0jE:T0100jE:T0
10000000>UBY03YDZ@3D?AT403YDZ@030000003D?AT0>UBY00<0>UBY0P0000040?m@8@030000003o
D240oe0Q00@0oe0Q0`0mFJ/30?m@8@030000003oCb00odlP00<0odlP00<000000?m?803oCb000`3o
Cb0010000000odlP0?m?800000030?m<7`030000000mFJ/0od`O00<0od`O00@000000?m<7`3oC1l0
00000`3oB1d00`000000odPM0?m87@030?m87@8000000`3`@QX01@000000l48J0?126P0mFJ/00000
00<0?EV[00H000000=0h5@00000000000:@Z3`00000;0?ofkP0303eIZ`3om^h0?EV[0080?EV[0P3o
m^h3000000X0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP020?ofkP030000003o
m^h0ooK^0080ooK^00<0?EV[0?ofkP0mFJ/00`0mFJ/?0?ofkP0303eIZ`3om^h0ooK^01P0ooK^00<0
00000?ofkP3om^h0<@3om^h10?ooo`002P3om^h00`000000ooK^0?ofkP160?ofkP0303eIZ`3om^h0
ooK^00<0ooK^0`0000060?ofkP<0?EV[3`3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP80e3dI00@0?EV[
0?ofkP3om^h0ooK^0P3D?AT30?ofkP030000000^@8<0;T2300@0;T230P3D?AT3000000P0<dRA00<0
000003=8T@0cB9400`0cB9400`3D?AT0<dRA03=8T@0203=8T@030000000cB940<dRA00L0<dRA00<0
000003=8T@0000000P0000000`0gCYh0e3dI03M>WP0203M>WP030000003D?AT0e3dI00L0=djN00<0
000003M>WP0gCYh01P0gCYh00`000000e3dI03M>WP0603M>WP030000000gCYh00000008000000`0j
E:T20=@m6@L0>UBY00<000000=@m6@0jE:T01P0jE:T00`000000>UBY03YDZ@0403YDZ@030000000j
E:T0e3dI00D0>UBY00<0000003YDZ@3D?AT00`0000000`0mFK<00000000000030?m@8@040000003o
D240oe0Q0?m@8@<0?EV[00<0oe0Q03eIZ`3oD2400`3oD242000000<0odlP00<000000?m?803oCb00
103oCb001@000000odlP0?m?803oCb0000000080od`O00<0000003eIZ`3oC1l00`3oC1l010000000
od`O0?m<7`0000030?m87@030000003oB1d0odPM00<0odPM00<000000?m87@0000000P3`@QX00`00
0000l48J03eIZ`0203eIZ`040000003@>1D0d3PE00000080d3PE0`0000000`3D?AT0ooK^0?ofkP07
0?ofkP<0?EV[0P3om^h00`000000?EV[0000000=0?ofkP0303eIZ`3om^h0ooK^00P0ooK^0P0mFJ/5
0?ofkP030000003om^h0ooK^00<0?EV[4`3om^h00`0mFJ/0ooK^0?ofkP0H0?ofkP030000003om^h0
ooK^0340ooK^0@3oool000X0ooK^00<000000?ofkP3om^h0AP3om^h00`0mFJ/0ooK^0?ofkP030000
00H0ooK^0`0mFJ/00`3om^h0?EV[0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00`0ooK^0P0mFJ/00`3o
m^h0e3dI0=@m6@040?ofkP80e3dI0P3om^h00`000000;T2302i0P`0302i0P`<0000000<0e3dI03=8
T@0000002@0cB9400`000000<dRA03=8T@0303=8T@030=@m6@0cB940<dRA0080<dRA00<0000003=8
T@0cB9401@0cB943000000D0=djN00@0e3dI03M>WP3D?AT0e3dI2@0gCYh00`000000=djN03M>WP06
03M>WP030000000gCYh0e3dI00D0=djN0`00000503YDZ@030=@m6@0jE:T0000000L0>UBY00<00000
03YDZ@3D?AT01P0jE:T00`000000>UBY03YDZ@0403YDZ@030000003D?AT0>UBY00@0>UBY0`000000
1@0mFK<0e3dI03eI/`0mFK<000000080oe4Q00<000000?m@8@3oD240100mFJ/20?m@8@040000003o
D240oe0Q03eIZ`80oe0Q00@000000?m@8@3oD24000000P3oCb000`000000odlP0?m?80030?m?8003
0000003oCb00odlP00<0odlP0P0000020?m<7`0503eIZ`3oC1l0od`O0?m<7`0000000`3oC1l00`00
0000odPM000000050?m87@050000003oB1d0odPM0000003`@QX00`0mFJ/20?126P0503eIZ`000000
00000=0h5@0000000`3@>1D010000000Y2X?0000003D?AT50?ofkP<0?EV[00<0ooK^03eIZ`000000
0P0000000`3om^h0?EV[0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00@0ooK^0`0mFJ/20?ofkP0303eI
Z`3om^h0ooK^0080ooK^00D0000003eIZ`0mFJ/0ooK^03eIZ`0D0?ofkP0303eIZ`3om^h0ooK^01P0
ooK^00<000000?ofkP3om^h0<@3om^h10?ooo`002P3om^h00`000000ooK^0?ofkP160?ofkP0303eI
Z`000000000000H0ooK^0`0mFJ/40?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h0
2@3om^h303eIZ`<0ooK^00@0?EV[0?ofkP3D?AT0e3dI0P3om^h30=@m6@80ooK^00<0000002i0P`00
00000P00000403=8T@030=@m6@000000<dRA00P0<dRA00<0000003=8T@0cB940100cB9401@3D?AT0
<dRA03=8T@0cB940000000D0<dRA0P0000000`0gCYh0000003M>WP0503M>WP80e3dI0P0gCYh00`00
0000=djN03M>WP0603M>WP030000000gCYh0=djN00H0=djN00@0000003M>WP0gCYh0e3dI0P0gCYh2
0000000303YDZ@000000>UBY00@0>UBY00D0e3dI03YDZ@0jE:T0>UBY0000000603YDZ@040000000j
E:T0>UBY0=@m6@D0>UBY00<0000003YDZ@0jE:T00`0jE:T20=@m6@@0>UBY0P0000000`0mFK<00000
03eI/`0203eI/`030=@m6@0mFK<000000080oe4Q0`0mFJ/60?m@8@040000003oD240oe0Q03eIZ`80
oe0Q00@000000?m@8@3oD24000000P3oCb000`000000odlP0?m?80030?m?80030000003oCb00odlP
00@0odlP00@000000?m<7`3oC1l0?EV[0`3oC1l00`000000od`O0?m<7`020?m<7`8000001@3oB1d0
0`000000odPM0?m87@0203eIZ`030?126P000000l48J0080l48J00<0?EV[0000003`@QX00P000003
0=0h5@<000000P3D?AT403eIZ`050?ofkP00000000000000000mFJ/01@3om^h00`0mFJ/0ooK^0?of
kP0<0?ofkP0403eIZ`3om^h0ooK^0?ofkP<0?EV[1@3om^h00`0mFJ/0ooK^03eIZ`0203eIZ`050?of
kP000000ooK^0?ofkP0mFJ/0503om^h00`0mFJ/0ooK^0?ofkP0H0?ofkP030000003om^h0ooK^0340
ooK^0@3oool000X0ooK^00<000000?ofkP3om^h0A03om^h3000000H0ooK^0P0mFJ/70?ofkP0303eI
Z`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h01`3om^h203eIZ`H0ooK^00<0?EV[0?ofkP3om^h0
0P3D?AT20?ofkP<0e3dI00<0ooK^000000000000200cB9400`3D?AT0000003=8T@0803=8T@030000
000cB940<dRA00@0<dRA00H0e3dI03=8T@0cB940<dRA0000000cB943000000@0=djN00<0000003M>
WP0gCYh00`3D?AT203M>WP030=@m6@0gCYh0000000T0=djN00<0000003M>WP0gCYh01P0gCYh01@00
0000=djN0000003D?AT0000000@0>UBY00<0000003YDZ@0jE:T00P3D?AT403YDZ@030000000jE:T0
>UBY00D0>UBY00@0000003YDZ@0jE:T0e3dI100jE:T00`000000>UBY03YDZ@0203YDZ@040=@m6@0j
E:T0000003YDZ@<000000`0mFK<00`000000?EVc03eI/`0203eI/`040=@m6@000000?EV[03eIZ`80
oe4Q00<000000?m@8@3oD2400`3oD2400`000000oe0Q0?m@8@020?m@8@0303eIZ`000000oe0Q00<0
oe0Q0P0000050?m?80030000003oCb00odlP00D0odlP0P0000020?m<7`0303eIZ`3oC1l0000000H0
od`O00<000000?m87@3oB1d00`3oB1d303eIZ`80odPM0P0000040?126P0503eIZ`3`@QX000000=0h
5@0000000P3@>1D300000080?EV[0P3om^h3000000<0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0m
FJ/0ooK^0?ofkP0<0?ofkP@0?EV[203om^h203eIZ`D0ooK^00<000000?ofkP0mFJ/0503om^h00`0m
FJ/0ooK^0?ofkP0I0?ofkP030000003om^h0ooK^0300ooK^0@3oool000X0ooK^00<000000?ofkP3o
m^h0@@3om^h3000000030?ofkP0mFJ/0ooK^00<0ooK^0`0mFJ/90?ofkP0303eIZ`3om^h0ooK^00h0
ooK^00<0?EV[0?ofkP3om^h0103om^h303eIZ`P0ooK^00@0?EV[0?ofkP3om^h0ooK^103D?AT01@3o
m^h0e3dI0=@m6@3om^h0000000T0<dRA00<0e3dI03=8T@0cB9401`0cB9400`000000<dRA03=8T@05
03=8T@80e3dI0`00000703M>WP<0e3dI1P0gCYh00`3D?AT0000003M>WP0803M>WP030000000gCYh0
=djN00D0=djN0`00000203YDZ@030=@m6@0jE:T0>UBY0080>UBY00<0000003YDZ@3D?AT01P0jE:T0
0`000000>UBY03YDZ@0503YDZ@050000000jE:T0>UBY03YDZ@3D?AT00`0jE:T01P000000>UBY03YD
Z@0jE:T0e3dI03YDZ@<000001@0mFK<00`000000?EVc03eI/`0403eI/`030000000mFJ/0oe4Q0080
oe4Q0P0000040?m@8@030000003oD240oe0Q0080oe0Q00<0?EV[0000003oD240103oD2400`000000
odlP0?m?80030?m?80030000003oCb00odlP00@0odlP00P000000?m?803oCb0000000?m<7`0mFJ/0
od`O000000H0od`O0P0000001@3oB1d0?EV[03eIZ`0mFJ/0000000D0odPM00<000000?126P3`@QX0
0P3`@QX00`0mFJ/0l48J0?126P02000000<0d3PE0`0000020=@m6@030000003om^h0ooK^00D0ooK^
00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP80?EV[203om^h303eIZ`030?of
kP0mFJ/0ooK^00@0ooK^00<000000?ofkP0mFJ/05@3om^h00`0mFJ/0ooK^0?ofkP0H0?ofkP030000
003om^h0ooK^0300ooK^0@3oool000T0ooK^00<000000?ofkP3om^h0@03om^h2000000@0ooK^00<0
?EV[0?ofkP0mFJ/00P0mFJ/<0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00@0?EV[0?ofkP3om^h0ooK^
0`0mFJ/;0?ofkP0303eIZ`3om^h0ooK^0080ooK^103D?AT0103om^h0e3dI0=@m6@00000:03=8T@03
0=@m6@0cB940<dRA00L0<dRA00<0000003=8T@0cB9400`0cB943000000030=@m6@0gCYh0000000@0
=djN0`3D?AT00`0gCYh0000003M>WP0703M>WP030=@m6@000000=djN00L0=djN00<0000003M>WP0g
CYh00`0gCYh20000000303YDZ@000000>UBY00<0>UBY00H0e3dI03YDZ@0jE:T0>UBY0000003D?AT7
03YDZ@030000000jE:T0>UBY00D0>UBY00<0000003YDZ@0jE:T00P0jE:T0103D?AT0>UBY03YDZ@00
000203YDZ@050=@m6@000000000003eI/`0000001P0mFK<00`000000?EVc03eI/`0303eI/`030000
003oDB40oe4Q0080oe4Q00@000000?mA8@3oDB4000000`3oD2400`000000oe0Q0?m@8@030?m@8@03
03eIZ`3oD240oe0Q00<0oe0Q0P0000040?m?80030000003oCb00odlP00@0odlP00@000000?m?803o
Cb0000000P3oC1l00`0mFJ/000000?m<7`040?m<7`040000000mFJ/0?EV[03eIZ`<0odPM00<00000
0?m87@3oB1d00`3oB1d2000000<0l48J00D0000003eIZ`3`@QX0l48J000000030=0h5@030000003@
>1D0000000<0e3dI1`3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00L0ooK^0`0m
FJ/20?ofkP0303eIZ`3om^h0ooK^0080ooK^0`0mFJ/50?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0
000003eIZ`3om^h0503om^h00`0mFJ/0ooK^0?ofkP0H0?ofkP030000003om^h0ooK^0300ooK^0@3o
ool000T0ooK^00<000000?ofkP3om^h0?@3om^h3000000H0ooK^0P0mFJ/?0?ofkP0303eIZ`3om^h0
ooK^00h0ooK^00@0?EV[0?ofkP0mFJ/0?EV[3P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP80e3dI00@0
ooK^0=@m6@3D?AT0ooK^0P3D?AT:03=8T@030=@m6@0cB940<dRA00H0<dRA00<0000003=8T@0cB940
0`00000403M>WP030=@m6@000000=djN00<0e3dI100gCYh00`000000=djN03M>WP0703M>WP030=@m
6@0gCYh0=djN00L0=djN00<0000003M>WP0000000P00000403YDZ@030000000jE:T0>UBY0080>UBY
00D0e3dI03YDZ@3D?AT0e3dI0000000703YDZ@030000000jE:T0>UBY00D0>UBY00<0000003YDZ@0j
E:T00`0jE:T01P3D?AT0>UBY0000000jE:T0e3dI000000<0?EVc00<0000003eI/`0mFK<0100mFK<0
0`000000?EVc03eI/`0303eI/`030000003oDB40oe4Q0080oe4Q00D000000?mA8@3oDB40oe4Q0000
00020?m@8@030000003oD240oe0Q0080oe0Q00<0000003eIZ`3oD2400`3oD24010000000oe0Q0?m@
8@0000020?m?80030000003oCb00odlP00@0odlP00<000000?m?803oCb000P3oCb0010000000od`O
03eIZ`0000040?m<7`80?EV[0`3oC1l00`000000odPM000000060?m87@030000003oB1d000000080
l48J00@0000003eIZ`3`@QX0l48J0P0000020=0h5@040000003@>1D00000000000<0e3dI1P3om^h0
0`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00<0ooK^0`0mFJ/50?ofkP0303eIZ`3om^h0
?EV[0080?EV[203om^h00`0mFJ/0ooK^0?ofkP040?ofkP030000003om^h0ooK^0180ooK^0P0mFJ/J
0?ofkP030000003om^h0ooK^0300ooK^0@3oool000T0ooK^00<000000?ofkP3om^h0>`3om^h20000
00T0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP<0?EV[403om^h00`0m
FJ/0ooK^0?ofkP040?ofkP<0e3dI00<0ooK^0=@m6@3D?AT00P3D?AT903=8T@030000003D?AT0e3dI
00H0<dRA0`00000603M>WP@0e3dI200gCYh00`000000=djN03M>WP0703M>WP030=@m6@0gCYh0=djN
00D0=djN0`00000703YDZ@030000000jE:T0>UBY00<0>UBY00@0e3dI03YDZ@0jE:T000001`0jE:T0
0`000000>UBY03YDZ@0503YDZ@030000000jE:T0>UBY00@0>UBY00<0e3dI0000003D?AT01@0mFK<0
0`000000?EVc03eI/`0403eI/`030000000mFK<0?EVc00<0?EVc00<000000?mA8@3oDB400P3oDB40
0`000000oe4Q0?mA8@020?mA8@8000001@3oD2400`000000?EV[0?m@8@030?m@8@040000003oD240
oe0Q00000080odlP00<000000?m?803oCb00103oCb000`000000odlP0?m?80030?m?8080000000<0
?EV[0?m<7`0mFJ/00P0mFJ/00`000000od`O0?m<7`030?m<7`8000001@3oB1d03`000000odPM0?m8
7@3oB1d000000?126P000000l48J03eIZ`3`@QX000000?126P000000d3PE000000020=0h5@030000
003D?AT0e3dI0080e3dI1@3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00<0?EV[
1`3om^h303eIZ``0ooK^00<0?EV[0?ofkP3om^h0103om^h00`000000ooK^0?ofkP0=0?ofkP@0?EV[
00<0ooK^03eIZ`3om^h06@3om^h00`000000ooK^0?ofkP0`0?ofkP40oooo00090?ofkP030000003o
m^h0ooK^03P0ooK^0`00000;0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h02`3o
m^h303eIZ`030?ofkP0mFJ/0ooK^0140ooK^00<0?EV[0?ofkP3om^h01@3om^h20=@m6@80ooK^0`3D
?AT903=8T@030000000cB940e3dI00<0<dRA0P00000203M>WP030000000gCYh0e3dI00@0e3dI0`0g
CYh00`3D?AT0=djN03M>WP0603M>WP030000000gCYh0=djN00L0=djN00<000000=@m6@0gCYh00`0g
CYh20000000303YDZ@000000>UBY00L0>UBY00@0000003YDZ@0jE:T0>UBY0P3D?AT0100jE:T0e3dI
03YDZ@00000703YDZ@030000000jE:T0>UBY00D0>UBY00<0000003YDZ@0jE:T0100000000`0mFK<0
e3dI03eI/`0503eI/`030000000mFK<0?EVc00@0?EVc00<0000003eI/`0mFK<00`0mFK<00`000000
oe4Q0?mA8@020?mA8@030000003oDB40oe4Q00<0oe4Q00<000000?m@8@3oD2400`3oD2400`000000
oe0Q03eIZ`020?m@8@030000003oD240oe0Q0080oe0Q0P0000060?m?80030000003oCb00odlP00D0
odlP0`0mFJ/30?m<7`030000003oC1l0od`O00@0od`O00<000000?m87@3oB1d00`3oB1d00`000000
odPM0?m87@020?m87@80000000P0l48J03eIZ`3`@QX000000?126P000000d3PE00000080d3PE00<0
00000?ofkP3D?AT00P3D?AT50?ofkP0303eIZ`3om^h0ooK^00@0ooK^0`0mFJ/70?ofkP<0?EV[00<0
ooK^03eIZ`3om^h03@3om^h00`0mFJ/0ooK^0?ofkP030?ofkP030000003om^h0ooK^00X0ooK^0`0m
FJ/50?ofkP0303eIZ`3om^h0ooK^01T0ooK^00<000000?ofkP3om^h0;`3om^h10?ooo`00203om^h0
0`000000ooK^0?ofkP0f0?ofkP<000003P3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0
ooK^00P0ooK^0`0mFJ/40?ofkP0303eIZ`3om^h0ooK^0100ooK^00<0?EV[0?ofkP3om^h01P3om^h0
0`3D?AT0ooK^0?ofkP020?ofkPP0e3dI0P0cB94010000000<dRA03=8T@3D?AT20000000303M>WP3D
?AT0e3dI00<0e3dI2@0gCYh00`3D?AT0=djN03M>WP0603M>WP030000000gCYh0=djN00L0=djN00<0
00000=@m6@3D?AT00P00000403YDZ@030000000jE:T0>UBY00H0>UBY00<000000=@m6@3D?AT0100j
E:T00`3D?AT0000003YDZ@0703YDZ@030000000jE:T0>UBY00<0>UBY1000000403eI/`030=@m6@00
0000e3dI00D0?EVc00<0000003eI/`0mFK<00`0mFK<00`000000?EVc03eI/`0303eI/`030000003o
DB40oe4Q0080oe4Q00<000000?mA8@3oDB40103oDB42000000<0oe0Q00@000000?m@8@3oD240?EV[
0P3oD2400`000000oe0Q0?m@8@030?m@8@030000003oCb00odlP00@0odlP00<000000?m?803oCb00
0P3oCb0303eIZ`030?m?800mFJ/0od`O00<0od`O00<000000?m<7`3oC1l0103oC1l2000000@0odPM
00<000000?m87@3oB1d00`3oB1d01@000000l48J0?126P0mFJ/000000080l48J00D000000=0h5@00
0000d3PE000000020=@m6@030?ofkP3D?AT0e3dI00@0ooK^00@0?EV[0?ofkP3om^h0ooK^0`0mFJ/2
0?ofkP0403eIZ`3om^h0ooK^0?ofkP@0?EV[103om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3o
m^h0ooK^00<0ooK^00<0?EV[0000003om^h01P3om^h403eIZ`P0ooK^00<0?EV[0?ofkP3om^h06@3o
m^h00`000000ooK^0?ofkP0_0?ofkP40oooo00080?ofkP030000003om^h0ooK^03@0ooK^0P00000A
0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h01@3om^h303eIZ`L0ooK^00<0?EV[
0?ofkP3om^h0403om^h00`0mFJ/0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^0080?EV[0P3D?AT5
03=8T@T0e3dI100gCYh00`000000=djN03M>WP0703M>WP030000003D?AT0=djN00H0=djN00<00000
03M>WP0gCYh01P0gCYh30000000303YDZ@3D?AT0>UBY00@0>UBY00<0000003YDZ@0jE:T01@0jE:T2
0=@m6@L0>UBY00<0e3dI0000000jE:T01P0jE:T010000000>UBY03YDZ@0jE:T20000000303eI/`00
0000?EVc00<0?EVc0P3D?AT0100mFK<0000003eI/`3D?AT403eI/`030000000mFK<0?EVc00<0?EVc
00<0000003eI/`0mFK<00`0mFK<00`000000oe4Q0?mA8@020?mA8@030000003oDB40oe4Q00<0oe4Q
00@000000?mA8@3oDB4000000P3oD2401P000000oe0Q0?m@8@3oD240?EV[000000D0oe0Q00<00000
0?m@8@0000001@3oCb000`000000odlP03eIZ`0203eIZ`80odlP00@000000?m?803oCb00?EV[0P3o
C1l00`000000od`O0?m<7`040?m<7`040000003oC1l0od`O000000<0odPM00<000000?m87@3oB1d0
0`3oB1d2000000030?126P0mFJ/0000000<0l48J0P0000020=0h5@060000003om^h0e3dI0=@m6@3o
m^h0e3dI0`3om^h403eIZ`D0ooK^100mFJ/80?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?of
kP3om^h00P3om^h00`0mFJ/0ooK^000000030?ofkP<0?EV[303om^h00`0mFJ/0ooK^0?ofkP0I0?of
kP030000003om^h0ooK^02l0ooK^0@3oool000P0ooK^00<000000?ofkP3om^h0<@3om^h3000001<0
ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP020?ofkP<0?EV[2P3om^h00`0mFJ/0
ooK^0?ofkP0@0?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0=@m6@3D?AT00P3om^h00`000000
<dRA0=@m6@0303=8T@<000000P0gCYh010000000=djN03M>WP3D?AT603M>WP030000000gCYh0=djN
00L0=djN00<000000=@m6@0gCYh01P0gCYh00`000000=djN03M>WP0303M>WP8000000P0jE:T01000
0000>UBY03YDZ@3D?AT503YDZ@030000000jE:T0>UBY0080>UBY0P3D?AT00`0jE:T0000003YDZ@07
03YDZ@030=@m6@0jE:T0>UBY00D0>UBY00@0000003YDZ@00000000000`0mFK<01@000000?EVc03eI
/`0mFK<0e3dI00<0?EVc00@0000003eI/`0mFK<0e3dI0P0mFK<00`000000?EVc03eI/`0403eI/`03
0000000mFK<0?EVc00<0?EVc00<000000?mA8@3oDB400P3oDB400`000000oe4Q0?mA8@030?mA8@04
0000003oDB40oe4Q0?mA8@800000103oD2400`0mFJ/000000?m@8@040?m@8@040000003oD240oe0Q
000000<0odlP0`0mFJ/40?m?80050000003oCb00odlP0?m?800mFJ/00P3oC1l00`000000od`O0?m<
7`040?m<7`040000003oC1l0od`O000000<0odPM00<000000?m87@3oB1d00P3oB1d00`000000odPM
000000020?126P0603eIZ`3`@QX0l48J0?126P3D?AT000000P3@>1D00`000000ooK^0=@m6@030=@m
6@<0?EV[00<0ooK^03eIZ`3om^h0103om^h403eIZ`X0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0m
FJ/0ooK^0?ofkP020?ofkP0403eIZ`3om^h0?EV[00000080?EV[3`3om^h00`0mFJ/0ooK^0?ofkP0I
0?ofkP030000003om^h0ooK^02l0ooK^0@3oool000P0ooK^00<000000?ofkP3om^h0;P3om^h30000
01H0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^03eIZ`0203eIZ`d0ooK^00<0?EV[0?of
kP3om^h0403om^h00`0mFJ/0ooK^0?ofkP050?ofkP80?EV[0P3om^h20=@m6@040?ofkP000000<dRA
03=8T@80e3dI00<0000003M>WP0gCYh00`0gCYh01@000000=djN03M>WP0gCYh0e3dI00D0=djN00<0
000003M>WP0gCYh01`0gCYh00`000000=djN0=@m6@0603M>WP030000000gCYh0=djN00<00000100j
E:T01@000000>UBY03YDZ@0jE:T0e3dI00@0>UBY00<0000003YDZ@0jE:T00P3D?AT303YDZ@030000
000jE:T0>UBY00H0>UBY00<000000=@m6@0jE:T0100jE:T3000000D0?EVc00@0000003eI/`0mFK<0
e3dI100mFK<01`000000?EVc03eI/`0mFK<0e3dI03eI/`0000001P0mFK<00`000000?EVc03eI/`03
03eI/`030000003oDB40oe4Q0080oe4Q00<000000?mA8@3oDB400P3oDB400`000000oe4Q0?mA8@03
0?mA8@030000003oD240oe0Q00<0oe0Q00<0?EV[0?m@8@3oD2400P3oD24010000000oe0Q0?m@8@3o
D24403eIZ`030000003oCb00odlP00@0odlP00<000000?m?803oCb000P3oCb000`0mFJ/000000?m<
7`050?m<7`030000003oC1l0od`O0080od`O00<000000?m87@0000001@3oB1d01P000000odPM0?m8
7@000000l48J03eIZ`@0l48J0P000000103@>1D000000=@m6@3om^h303eIZ`80e3dI0P3om^h00`0m
FJ/0ooK^03eIZ`0303eIZ`<0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP0=0?of
kP80?EV[0P3om^h303eIZ`030?ofkP000000ooK^0100ooK^00<0?EV[0?ofkP3om^h06@3om^h00`00
0000ooK^0?ofkP0_0?ofkP40oooo00080?ofkP030000003om^h0ooK^02`0ooK^0P00000H0?ofkP03
03eIZ`3om^h0ooK^00d0ooK^0`0mFJ/@0?ofkP0303eIZ`3om^h0ooK^0100ooK^00<0?EV[0?ofkP3o
m^h00P3om^h303eIZ`D0ooK^0P3D?AT00`3om^h000000000000203M>WP030=@m6@0gCYh0=djN00@0
=djN00@0000003M>WP0gCYh0=djN0P3D?AT403M>WP030000000gCYh0=djN00L0=djN00<0000003M>
WP3D?AT01@0gCYh3000000P0>UBY00D0000003YDZ@0jE:T0>UBY0=@m6@0303YDZ@030000003D?AT0
e3dI00H0>UBY00<0000003YDZ@0jE:T01P0jE:T00`000000e3dI0=@m6@030000000303eI/`000000
?EVc00H0?EVc00<000000=@m6@0mFK<0100mFK<00`000000?EVc03eI/`0203eI/`030=@m6@000000
?EVc00D0?EVc00<0000003eI/`0mFK<00P0mFK<00`000000oe4Q0?mA8@020?mA8@030000003oDB40
oe4Q00<0oe4Q00<000000?mA8@3oDB400`3oDB42000000<0oe0Q00<0000003eIZ`3oD2400`3oD240
10000000?EV[03eIZ`0mFJ/20?m@8@8000001P3oCb000`000000odlP0?m?80030?m?800303eIZ`00
0000od`O00D0od`O00<000000?m<7`3oC1l00`3oC1l2000000D0odPM00@000000?m87@3oB1d0odPM
0P0000001P0mFJ/0l48J0?126P3`@QX000000?126P@0?EV[0P3D?AT0103om^h0e3dI0=@m6@3om^h3
03eIZ`P0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP<0?EV[00H0ooK^
03eIZ`0mFJ/0?EV[0?ofkP0mFJ/30?ofkP030000003om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h0
6@3om^h00`000000ooK^0?ofkP0_0?ofkP40oooo00070?ofkP030000003om^h0ooK^02X0ooK^0`00
000J0?ofkP0303eIZ`3om^h0ooK^00X0ooK^0`0mFJ/00`3om^h0?EV[0?ofkP0@0?ofkP0303eIZ`3o
m^h0ooK^0100ooK^00<0?EV[0?ofkP0mFJ/00P0mFJ/90?ofkP80e3dI00<0ooK^0000000gCYh00P0g
CYh00`3D?AT0=djN03M>WP0403M>WP030000000gCYh0=djN0080=djN00D0e3dI03M>WP0gCYh0=djN
0000000903M>WP030000000gCYh0=djN0080e3dI0`00000203YDZ@030000000jE:T0>UBY00H0>UBY
00<0000003YDZ@0jE:T00P0jE:T01@3D?AT0>UBY0=@m6@3D?AT0000000L0>UBY00<0000003YDZ@0j
E:T01@0jE:T30000000303eI/`3D?AT0?EVc0080?EVc00<0000003eI/`0mFK<0100mFK<20=@m6@H0
?EVc00<0000003eI/`0mFK<00`0mFK<00`3D?AT0?EVc03eI/`0303eI/`030000000mFK<0?EVc0080
?EVc0P0000040?mA8@030000003oDB40oe4Q0080oe4Q00<000000?mA8@3oDB400`3oDB4010000000
oe4Q0?mA8@0000020?m@8@040000003oD240?EV[0?m@8@<0?EV[1P3oD2400`000000odlP0?m?8004
0?m?80030000003oCb00odlP00<0odlP00<0000003eIZ`0000001@3oC1l00`000000od`O0?m<7`04
0?m<7`030000003oB1d0odPM0080odPM00<000000?m87@3oB1d00P3oB1d20000000303eIZ`3`@QX0
l48J00<0?EV[00<000000=0h5@0000000P3D?AT00`3om^h0e3dI03eIZ`0203eIZ`030?ofkP0mFJ/0
ooK^00P0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP070?ofkP<0?EV[00H0ooK^
03eIZ`0mFJ/0?EV[0?ofkP0mFJ/20?ofkP0303eIZ`3om^h0ooK^0080ooK^00<000000?ofkP3om^h0
3@3om^h00`0mFJ/0ooK^0?ofkP0J0?ofkP030000003om^h0ooK^02h0ooK^0@3oool000L0ooK^00<0
00000?ofkP3om^h0:03om^h2000001d0ooK^00<0?EV[0?ofkP3om^h01`3om^h303eIZ`@0ooK^00<0
?EV[0?ofkP3om^h0403om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP<0?EV[3P3om^h00`3D?AT0ooK^0000
000303M>WP030=@m6@0gCYh0=djN00<0=djN00<0000003M>WP0gCYh00`0gCYh01@3D?AT0=djN03M>
WP0gCYh0000000P0=djN100000000`0jE:T0e3dI03YDZ@0303YDZ@030000000jE:T0>UBY00L0>UBY
00@0000003YDZ@0jE:T0>UBY0P3D?AT203YDZ@030000000jE:T0>UBY00D0>UBY00<0000003YDZ@0j
E:T00`0jE:T20000000303eI/`000000?EVc0080?EVc00D0e3dI03eI/`0mFK<0?EVc0000000403eI
/`030=@m6@0mFK<0000000H0?EVc00<0000003eI/`0mFK<00`0mFK<00`3D?AT0?EVc03eI/`0303eI
/`030000000mFK<000000080000000<0@Ejl0000000000000`3oDB400`000000oe4Q0?mA8@020?mA
8@030000003oDB40oe4Q00<0oe4Q00@000000?mA8@3oDB40oe4Q0P0000001P3oD240?EV[03eIZ`0m
FJ/0oe0Q000000H0oe0Q00<000000?m@8@000000103oCb000`000000odlP0?m?80040?m?80040000
000mFJ/0odlP000000<0od`O00<000000?m<7`3oC1l0103oC1l00`000000od`O000000030?m87@03
0000003oB1d0odPM00<0odPM00H0000003eIZ`0mFJ/0?EV[0?126P0000020?126P80000000@0e3dI
03eIZ`0mFJ/0?EV[103D?AT00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0
?EV[0?ofkP3om^h0103om^h303eIZ`040?ofkP0mFJ/0?EV[03eIZ`D0ooK^00<0?EV[0?ofkP0mFJ/0
103om^h00`000000ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^01X0ooK^00<000000?ofkP3om^h0
;P3om^h10?ooo`001`3om^h00`000000ooK^0?ofkP0U0?ofkP<000007`3om^h00`0mFJ/0ooK^0?of
kP050?ofkP80?EV[1`3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0303eIZ`3om^h0ooK^00`0ooK^0P0m
FJ/00`3om^h0?EV[0?ofkP0?0?ofkP030=@m6@000000=djN00<0=djN00<0e3dI03M>WP0gCYh00`0g
CYh00`000000=djN03M>WP0303M>WP050=@m6@0gCYh0=djN03M>WP0000001@0gCYh200000080>UBY
00D0000003YDZ@0jE:T0>UBY0=@m6@0403YDZ@030000000jE:T0>UBY00H0>UBY00@000000=@m6@3D
?AT0e3dI0P0jE:T0103D?AT0>UBY03YDZ@00000703YDZ@030000000jE:T00000008000000`0mFK<0
0`000000?EVc03eI/`0203eI/`040=@m6@0mFK<0?EVc000000<0?EVc00@0e3dI03eI/`0mFK<00000
1P0mFK<00`000000?EVc03eI/`0303eI/`030000003D?AT0?EVc0080?EVc0`000003045N_0040000
003oDB80oe4R00000080oe4Q00D000000?mA8@3oDB40oe4Q000000050?mA8@030000003oDB40oe4Q
0080oe4Q0`0mFJ/20?m@8@0303eIZ`000000oe0Q00H0oe0Q00@000000?m@8@3oD24000000`3oCb00
0`000000odlP0?m?80030?m?80060000003oCb00odlP03eIZ`3oCb0000000P3oC1l00`000000od`O
0?m<7`040?m<7`040000003oC1l0od`O00000080odPM00@000000?m87@3oB1d0odPM0`0mFJ/01@00
0000l48J03eIZ`3`@QX0000000<0l48J00@0000003eIZ`3D?AT0e3dI0P3om^h30=@m6@0303eIZ`3o
m^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP020?ofkP80?EV[00@0
ooK^03eIZ`0mFJ/0?EV[2@3om^h203eIZ`D0ooK^00<000000?ofkP3om^h02`3om^h203eIZa`0ooK^
00<000000?ofkP3om^h0;P3om^h10?ooo`001`3om^h00`000000ooK^0?ofkP0R0?ofkP<000008P3o
m^h00`0mFJ/0ooK^0?ofkP020?ofkP<0?EV[2P3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3o
m^h0ooK^00T0ooK^0`0mFJ/30?ofkP0303eIZ`3om^h0ooK^00l0ooK^0P3D?AT403M>WP030=@m6@0g
CYh0=djN0080=djN00<0000003M>WP0gCYh0100gCYh0103D?AT0=djN03M>WP00000203M>WP<00000
100jE:T00`000000>UBY03YDZ@0203YDZ@030=@m6@0jE:T0>UBY0080>UBY00<0000003YDZ@0jE:T0
0`0jE:T30=@m6@030000000jE:T0>UBY00<0>UBY00<0e3dI03YDZ@0000001P0jE:T3000000L0?EVc
00<0000003eI/`0mFK<00P0mFK<0103D?AT0?EVc0000000mFK<20=@m6@<0?EVc00<0000003eI/`0m
FK<0100mFK<00`000000?EVc03eI/`0303eI/`030000000mFK<0e3dI0080000000<0@Ejl00000011
G[`00P11G[`00`3D?AT000000?mA8P020?mA8P800000103oDB400`000000oe4Q0?mA8@030?mA8@03
0000003oDB40?EV[0080?EV[00<000000?mA8@0000000P3oD2400`0mFJ/000000?m@8@050?m@8@05
0000003oD240oe0Q0?m@8@0000000P3oCb000`000000odlP0?m?80040?m?80040000003oCb00odlP
03eIZ`80odlP0P0000060?m<7`050000003oC1l0od`O0?m<7`0000000P3oB1d403eIZ`080?m87@00
0000odPM0?m87@000000?EV[0?126P0000030?126P030000003om^h0ooK^00<0e3dI00D0ooK^0=@m
6@3D?AT0?EV[0=@m6@0:0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP0mFJ/01@0mFJ/<
0?ofkP80?EV[1P3om^h00`000000ooK^0?ofkP060?ofkP@0?EV[00<0ooK^03eIZ`3om^h06`3om^h0
0`000000ooK^0?ofkP0^0?ofkP40oooo00060?ofkP030000003om^h0ooK^0240ooK^0P00000U0?of
kP0303eIZ`3om^h0?EV[0080?EV[3@3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^
00L0ooK^0P0mFJ/70?ofkP0303eIZ`3om^h0ooK^00l0ooK^103D?AT203M>WP80e3dI0`0gCYh00`00
0000=djN03M>WP0403M>WP030=@m6@0gCYh0000000800000200jE:T00`000000>UBY03YDZ@0203YD
Z@050=@m6@0jE:T0>UBY03YDZ@0000000P0jE:T30=@m6@<0>UBY00<0000003YDZ@0jE:T0100jE:T0
103D?AT0>UBY0000000jE:T40000000303eI/`000000?EVc00L0?EVc00<0000003eI/`0mFK<00`0m
FK<00`3D?AT000000=@m6@0503eI/`030000000mFK<0?EVc00@0?EVc00<0000003eI/`0mFK<00P0m
FK<300000005045N_03D?AT0@Ejl045N_00000000P11G[`01@3D?AT0@Ejl0000003oDB80?EV[0080
oe4R00D000000?mA8@3oDB40oe4Q000000050?mA8@<0?EV[0`3oDB400`000000oe4Q000000020?m@
8@030000000mFJ/0oe0Q00@0oe0Q00<000000?m@8@3oD2400`3oD2400`000000e3dI000000050?m?
80030000003oCb00odlP0080odlP00@0?EV[0?m?803oCb0000001P3oC1l010000000od`O0?m<7`3o
C1l303eIZ`D0odPM00L000000?m87@3oB1d0odPM0000000mFJ/0000000<0l48J00@000000=@m6@3o
m^h0e3dI0P3om^h30=@m6@0303eIZ`3D?AT0ooK^00X0ooK^00<0?EV[0?ofkP3om^h00`3om^h603eI
Za00ooK^00<0?EV[0?ofkP3om^h01@3om^h00`000000ooK^0?ofkP020?ofkP<0?EV[1@3om^h00`0m
FJ/0ooK^0?ofkP0J0?ofkP030000003om^h0ooK^02h0ooK^0@3oool000H0ooK^00<000000?ofkP3o
m^h07P3om^h3000002L0ooK^0P0mFJ/@0?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3o
m^h0103om^h303eIZ`T0ooK^00<0?EV[0?ofkP3om^h0403om^h50=@m6@80=djN00D0e3dI03M>WP0g
CYh0=djN0000000503M>WP050000003D?AT0e3dI03YDZ@0000002@0jE:T00`000000>UBY03YDZ@02
03YDZ@030=@m6@0jE:T0>UBY00<0e3dI00<0>UBY03eIZ`0jE:T0100jE:T00`000000>UBY03YDZ@04
03YDZ@030=@m6@000000000000H0?EVc00<0000003eI/`0mFK<01@0mFK<00`000000?EVc03eI/`04
03eI/`030=@m6@000000?EVc00D0?EVc00<0000003eI/`0mFK<00`0mFK<00`000000?EVc00000002
00000003045N_0000000@Ejl0080@Ejl00D0e3dI00000011G[`0@Ejl0=@m6@02045N_0030000003o
DB80?EV[0080oe4R0P0000020?mA8@030000003oDB40oe4Q00<0?EV[00<000000?mA8@3oDB400P3o
DB4020000000oe4Q0?mA8@3oDB4000000?m@8@000000?EV[1@3oD2400`000000oe0Q0?m@8@040?m@
8@030000003oCb00odlP00<0odlP00<000000?m?803oCb000`3oCb001@0mFJ/0odlP0000003oCb00
000000@0od`O00<000000?m<7`0mFJ/00P0mFJ/20?m<7`030000003oB1d0odPM00<0odPM00<00000
0?m87@3oB1d00P3oB1d00`0mFJ/000000?126P020?126P040000003om^h0e3dI0=@m6@<0ooK^0P3D
?AT00`0mFJ/0e3dI0=@m6@0:0?ofkP0303eIZ`3om^h0ooK^00H0?EV[4`3om^h203eIZ`H0ooK^00<0
000003eIZ`0mFJ/00P0mFJ/80?ofkP0303eIZ`3om^h0ooK^01/0ooK^00<000000?ofkP3om^h0;@3o
m^h10?ooo`001P3om^h00`000000ooK^0?ofkP0K0?ofkP<00000:P3om^h00`0mFJ/0ooK^0?ofkP0?
0?ofkP0303eIZ`3om^h0ooK^00l0ooK^00@0?EV[0?ofkP3om^h0ooK^0`0mFJ/<0?ofkP0303eIZ`3o
m^h0ooK^0140ooK^00@0?EV[0=@m6@3D?AT0=djN103D?AT203M>WP030000000gCYh0=djN00<00000
0`0jE:T00`3D?AT0>UBY0000000903YDZ@030000000jE:T0e3dI00@0e3dI00D0>UBY0000000jE:T0
>UBY03eIZ`0503YDZ@030000000jE:T0>UBY00@0000000<0?EVc0=@m6@0000001P0mFK<00`000000
?EVc03eI/`0503eI/`030000000mFK<0?EVc0080?EVc0P3D?AT00`0mFK<0e3dI03eI/`0503eI/`03
0000000mFK<0?EVc0080?EVc0`000004045N_00300000011G[`0@Ejl0080@Ejl00<0e3dI045N_03D
?AT00P11G[`01P000000oe4R0?mA8P3oDB80?EV[00000080oe4R0P00000303eIZ`80oe4Q00<00000
0?mA8@3oDB400`3oDB4010000000oe4Q0?mA8@3oDB4200000080oe0Q00D0?EV[0?m@8@3oD240oe0Q
000000060?m@8@030000003oD240000000@0odlP00<000000?m?803oCb00103oCb001P0mFJ/00000
0?m?803oCb0000000?m<7`@0?EV[103oC1l00`000000od`O000000030?m87@030000003oB1d0odPM
00@0odPM00D0?EV[0?126P3`@QX0l48J000000020?ofkP80e3dI103om^h0103D?AT0?EV[0?ofkP3D
?AT90?ofkPH0?EV[00<0ooK^03eIZ`3om^h04`3om^h00`0mFJ/0ooK^03eIZ`030?ofkP<0?EV[00<0
00000?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP0L0?ofkP030000003om^h0ooK^02d0ooK^0@3o
ool000H0ooK^00<000000?ofkP3om^h06@3om^h2000002d0ooK^00<0?EV[0?ofkP3om^h03`3om^h0
0`0mFJ/0ooK^0?ofkP0?0?ofkP0403eIZ`3om^h0?EV[03eIZ`l0ooK^00<0?EV[0?ofkP3om^h04@3o
m^h203eIZ`030=@m6@0gCYh0=djN0080=djN203D?AT503YDZ@030=@m6@000000>UBY0080>UBY203D
?AT403YDZ@040=@m6@0jE:T0>UBY000000L0>UBY0`00000603eI/`80e3dI1P0mFK<00`000000?EVc
03eI/`0503eI/`040000000mFK<0e3dI0=@m6@<0?EVc00<000000=@m6@0mFK<0100mFK<00`000000
?EVc0000000200000003045N_0000000@Ejl00@0@Ejl00<00000045N_011G[`00P11G[`00`000000
e3dI045N_002045N_0070000003oDB80oe4R0?mA8P0mFJ/000000?mA8P0303eIZ`D0oe4Q00<00000
0?mA8@3oDB400P3oDB400`000000oe4Q0?mA8@030?mA8@040000003oD240oe0Q03eIZ`<0oe0Q00<0
00000?m@8@3oD240103oD24010000000oe0Q0?m@8@0000020?m?80030000003oCb00odlP00D0odlP
00<0?EV[0?m?803oCb000`0mFJ/00`3oC1l000000?m<7`050?m<7`040000003oC1l0od`O00000080
odPM00<000000?m87@3oB1d0103oB1d01@0mFJ/000000?126P3`@QX0000000<0ooK^00<0e3dI0?of
kP3om^h00P3om^h00`3D?AT0?EV[0=@m6@020=@m6@D0ooK^1P0mFJ/40?ofkP0303eIZ`3om^h0ooK^
0180ooK^00<0?EV[0?ofkP0mFJ/00`0mFJ/40?ofkP030000003om^h0ooK^00L0ooK^00<0?EV[0?of
kP3om^h0703om^h00`000000ooK^0?ofkP0]0?ofkP40oooo00050?ofkP030000003om^h0ooK^01L0
ooK^0`00000_0?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h03P3om^h303eIZa80
ooK^00<0?EV[0?ofkP3om^h04@3om^h00`0mFJ/000000=@m6@0403M>WP050000003D?AT0>UBY03YD
Z@0000000P0jE:T:0=@m6@L0>UBY00<0000003YDZ@0jE:T00`0jE:T0103D?AT0>UBY03YDZ@000004
03YDZ@8000000P0mFK<00`000000?EVc03eI/`0503eI/`030000003D?AT0?EVc00@0?EVc00<00000
03eI/`0mFK<01@0mFK<20=@m6@D0?EVc00<0000003eI/`3D?AT00`0mFK<3000000@0@Ejl00<00000
045N_011G[`00`11G[`010000000@Ejl045N_011G[`20=@m6@05045N_03D?AT0e3dI045N_0000000
0`3oDB8303eIZ`80oe4R0P0000030?mA8@030000003oDB40oe4Q0080oe4Q00<000000?mA8@3oDB40
0`3oDB400`000000oe4Q000000020?m@8@0303eIZ`3oD240000000H0oe0Q00<000000?m@8@3oD240
0P3oD2400`000000odlP000000060?m?80040000000mFJ/0?EV[03eIZ`80odlP00<000000?m<7`00
00001@3oC1l01@000000od`O0?m<7`3oC1l000000080odPM00<000000?m87@3oB1d00`3oB1d00`00
0000odPM03eIZ`020?126P040000003om^h0ooK^0?ofkP80e3dI0`3om^h00`3D?AT0?EV[0=@m6@03
0=@m6@L0?EV[0`3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[01<0ooK^1@0mFJ/60?ofkP030000003o
m^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h0703om^h00`000000ooK^0?ofkP0]0?ofkP40oooo0005
0?ofkP030000003om^h0ooK^01@0ooK^0`00000c0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[
0?ofkP3om^h02`3om^h303eIZ`030?ofkP0mFJ/0ooK^0180ooK^00<0?EV[0?ofkP3om^h04@3om^h2
03eIZ`030000003D?AT0e3dI008000000P0jE:T0103D?AT0>UBY03YDZ@00000803YDZ@030=@m6@00
0000>UBY00P0>UBY00<0000003YDZ@0jE:T00`0jE:T00`3D?AT0>UBY0000000203YDZ@800000100m
FK<00`000000?EVc03eI/`0603eI/`030000003D?AT0?EVc00<0?EVc00<0000003eI/`0mFK<00`0m
FK<20=@m6@030000000mFK<0?EVc00D0?EVc00<0000003eI/`3D?AT00P0000000`11G[`00000045N
_004045N_00300000011G[`0@Ejl00<0@Ejl00D00000045N_011G[`0e3dI00000004045N_0030=@m
6@0mFJ/0?EV[0080?EV[00D0000003eIZ`3oDB80oe4R000000020?mA8P040000003oDB40oe4Q0000
00@0oe4Q00<000000?mA8@3oDB400`3oDB4010000000oe4Q0?mA8@0000020?m@8@0303eIZ`3oD240
oe0Q00@0oe0Q00<000000?m@8@3oD240103oD2400`000000odlP0?m?80030?m?80<0?EV[0P3oCb00
1@0mFJ/0odlP0?m?803oCb00000000H0od`O00<000000?m<7`3oC1l00P3oC1l2000000H0odPM00H0
00000?m87@3oB1d0?EV[0?126P0000030?ofkP80e3dI103om^h00`0mFJ/0e3dI03eIZ`0503eIZ`L0
ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0@0?ofkPH0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP040?of
kP030000003om^h0ooK^00D0ooK^0P0mFJ/N0?ofkP030000003om^h0ooK^02d0ooK^0@3oool000D0
ooK^00<000000?ofkP3om^h04P3om^h2000003H0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0
ooK^0?ofkP080?ofkP<0?EV[1@3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0303eIZ`3om^h0ooK^0100
ooK^100mFJ/2000000030=@m6@0jE:T0>UBY0080>UBY0P3D?AT00`0jE:T0000003YDZ@0703YDZ@03
0=@m6@000000>UBY00P0>UBY00<0000003YDZ@0jE:T00`0jE:T0103D?AT0000000000000000703eI
/`030000000mFK<0?EVc00D0?EVc00<0000003eI/`3D?AT0100mFK<00`000000?EVc03eI/`020=@m
6@80?EVc00<0000003eI/`0mFK<0100mFK<300000005045N_03D?AT0@Ejl045N_00000001@11G[`0
0`000000@Ejl045N_003045N_00500000011G[`0e3dI045N_00000001011G[`00`000000oe4R0?mA
8P020?mA8P050000003oDB80?EV[0?mA8P0000000`3oDB82000000@0oe4Q00<000000?mA8@3oDB40
0`3oDB400`000000oe4Q0?mA8@020?mA8@030000003oD240?EV[00D0oe0Q00<000000?m@8@3oD240
103oD24010000000e3dI0000003oCb0303eIZ`030?m?80000000odlP0080odlP00H0?EV[0?m?803o
Cb0000000?m?800000040?m<7`030000003oC1l0od`O00@0od`O00<000000?m87@3oB1d0103oB1d0
10000000odPM0?m87@0mFJ/2000000<0ooK^00<0e3dI0?ofkP3D?AT00P3om^h603eIZ`030=@m6@3o
m^h0ooK^00P0ooK^00@0?EV[0?ofkP3om^h0?EV[3@3om^h703eIZ`D0ooK^00<0?EV[0?ofkP3om^h0
103om^h010000000ooK^0?ofkP3om^h303eIZ`030?ofkP0mFJ/0ooK^01h0ooK^00<000000?ofkP3o
m^h0;03om^h10?ooo`001@3om^h00`000000ooK^0?ofkP0?0?ofkP<00000>03om^h00`0mFJ/0ooK^
0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00D0ooK^0P0mFJ/80?ofkP0303eIZ`3om^h0ooK^0100ooK^
00<0?EV[0?ofkP3om^h03P3om^h203eIZ`080?ofkP0mFJ/0ooK^03eIZ`3om^h0000003YDZ@3D?AT5
03YDZ@030=@m6@0jE:T0000000P0>UBY0P3D?AT803YDZ@030000000jE:T0>UBY00@0000000<0e3dI
03eI/`000000200mFK<00`000000?EVc03eI/`0503eI/`030000000mFK<0e3dI00<0?EVc00<00000
0=@m6@3D?AT01@0mFK<00`000000?EVc0000000300000003045N_0000000@Ejl0080@Ejl00<0e3dI
045N_00000001@11G[`00`000000@Ejl045N_002045N_0030000003D?AT0e3dI0080@Ejl00<00000
045N_011G[`00P11G[`01@000000oe4R0?mA8P3oDB8000000080oe4R00<0?EV[0000003oDB80103o
DB800`000000oe4Q0?mA8@020?mA8@030000003oDB40oe4Q0080oe4Q00<000000?mA8@3oDB40103o
DB400`000000oe0Q03eIZ`040?m@8@030000003oD240oe0Q00@0oe0Q00@0000003eIZ`0mFJ/0?EV[
0`3oCb000`000000odlP0?m?80030?m?800303eIZ`3oCb0000000080odlP00D000000?m<7`3oC1l0
od`O000000060?m<7`800000103oB1d00`000000odPM0?m87@020?m87@0303eIZ`000000ooK^0080
ooK^00<0e3dI03eIZ`0mFJ/01@0mFJ/00`3om^h0e3dI0=@m6@020=@m6@X0ooK^00<0?EV[0?ofkP0m
FJ/02P3om^h503eIZ`@0ooK^00<0?EV[0?ofkP3om^h0103om^h203eIZ`D0ooK^00<0000003eIZ`0m
FJ/00`3om^h00`0mFJ/0ooK^0?ofkP0N0?ofkP030000003om^h0ooK^02`0ooK^0@3oool000D0ooK^
00<000000?ofkP3om^h03@3om^h2000003/0ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^
0?ofkP020?ofkP<0?EV[2P3om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP0303eIZ`3om^h0ooK^00X0ooK^
0`0mFJ/40?ofkP80?EV[0P3om^h200000080e3dI100jE:T00`3D?AT0>UBY0000000903YDZ@030=@m
6@0jE:T0>UBY00D0>UBY0`00000503eI/`80e3dI00<0000003eI/`0mFK<01P0mFK<00`000000?EVc
03eI/`0403eI/`050000000mFK<0?EVc0=@m6@0mFK<00P3D?AT00`000000?EVc03eI/`0403eI/`80
00001@11G[`00`000000@Ejl045N_002045N_0030=@m6@000000@Ejl00@0@Ejl00<00000045N_011
G[`00P11G[`00`3D?AT0@Ejl045N_002045N_00300000011G[`0@Ejl0080@Ejl00D000000?mA8P3o
DB80oe4R000000030?mA8P0303eIZ`3oDB80oe4R0080oe4R00<000000?mA8P0000000P3oDB400`00
0000oe4Q0?mA8@030?mA8@030000003oDB40oe4Q00<0oe4Q00@000000?mA8@000000?EV[0`3oD240
0`000000oe0Q0?m@8@030?m@8@<0?EV[0P3oD24010000000odlP0?m?800000070?m?800503eIZ`3o
Cb00odlP0?m?800000000P3oC1l00`000000od`O0?m<7`040?m<7`040000003oC1l0od`O000000<0
odPM00<000000?m87@3oB1d00P3oB1d00`0mFJ/000000?ofkP0703eIZ`030?ofkP0mFJ/0ooK^0080
ooK^103D?AT:0?ofkP80?EV[1`3om^h503eIZ`L0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0
ooK^03eIZ`0203eIZ`030000003om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h07P3om^h00`000000
ooK^0?ofkP0/0?ofkP40oooo00040?ofkP030000003om^h0ooK^00/0ooK^0`00000m0?ofkP0303eI
Z`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP0mFJ/00P0mFJ/=0?ofkP0303eIZ`3om^h0ooK^0140ooK^
00<0?EV[0?ofkP3om^h0203om^h203eIZ`L0ooK^00<0?EV[0?ofkP0mFJ/00`3om^h00`000000>UBY
0=@m6@0403YDZ@030=@m6@0jE:T0000000P0>UBY00<000000=@m6@0jE:T00`0jE:T200000080?EVc
00<0000003eI/`0mFK<01@0mFK<00`3D?AT0000003eI/`0603eI/`030000000mFK<0?EVc00D0?EVc
00@0000003eI/`3D?AT0e3dI0P0mFK<00`000000?EVc03eI/`0203eI/`<000001P11G[`00`000000
@Ejl045N_003045N_0030=@m6@11G[`0@Ejl00<0@Ejl00<00000045N_011G[`00P3D?AT00`000000
@Ejl045N_002045N_00300000011G[`0@Ejl0080@Ejl00D000000?mA8P3oDB80oe4R000000020?mA
8P030000000mFJ/0oe4R00<0oe4R00H000000?mA8P3oDB8000000?mA8@0000040?mA8@030000003o
DB40oe4Q00<0oe4Q00P000000?mA8@3oDB40oe4Q0000000mFJ/0oe0Q000000<0oe0Q0`0mFJ/00`00
0000oe0Q0?m@8@030?m@8@030000003oCb00000000H0odlP00<0000003eIZ`3oCb000`3oCb000`00
0000od`O000000060?m<7`050000003oC1l0od`O0?m<7`0000000P3oB1d00`000000odPM0?m87@02
0?m87@H0?EV[0`3om^h0103D?AT0ooK^03eIZ`3D?AT30?ofkP040=@m6@3om^h0e3dI0=@m6@T0ooK^
0P0mFJ/40?ofkPD0?EV[2P3om^h00`0mFJ/0ooK^0?ofkP040?ofkPD0?EV[0`3om^h01@000000ooK^
0?ofkP3om^h0?EV[0240ooK^00<000000?ofkP3om^h0;03om^h10?ooo`00103om^h00`000000ooK^
0?ofkP080?ofkP<00000@03om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP<0?EV[4@3om^h00`0mFJ/0ooK^
0?ofkP0@0?ofkP0303eIZ`3om^h0ooK^00D0ooK^0`0mFJ/90?ofkP0303eIZ`3om^h0?EV[00@0ooK^
00@0000003YDZ@3D?AT0e3dI0`0jE:T00`3D?AT0>UBY0000000803YDZ@030000003D?AT0>UBY0080
00001@0mFK<00`000000?EVc03eI/`0503eI/`030=@m6@000000?EVc00H0?EVc00<0000003eI/`0m
FK<00`0mFK<30=@m6@80?EVc00D0e3dI03eI/`0mFK<0000003eI/`02000000<0@Ejl00<00000045N
_011G[`01011G[`00`000000@Ejl045N_002045N_0030000003D?AT0@Ejl00<0@Ejl00<00000045N
_03D?AT00P11G[`01@000000@Ejl045N_011G[`0000000@0@Ejl00D000000?mA8P3oDB80oe4R0000
00030?mA8P030000003oDB80?EV[0080oe4R00<000000?mA8P3oDB800P3oDB800`000000oe4Q0?mA
8@030?mA8@030000003oDB40oe4Q00<0oe4Q00<000000?mA8@3oDB400P3oDB400`0mFJ/0oe0Q0000
000303eIZ`80oe0Q00<000000?m@8@3oD2401@3oD2400`000000odlP0?m?80050?m?80030000003o
Cb00?EV[00@0odlP00<000000?m<7`3oC1l0103oC1l00`000000od`O0?m<7`030?m<7`8000000P3o
B1d603eIZ`030?ofkP3D?AT0ooK^00@0ooK^00<0e3dI03eIZ`3D?AT00`3om^h20=@m6@030?ofkP3D
?AT0ooK^00T0ooK^00<0?EV[0?ofkP0mFJ/00`0mFJ/=0?ofkP0303eIZ`3om^h0ooK^0080ooK^1@0m
FJ/30?ofkP80?EV[0P3om^h010000000ooK^03eIZ`0mFJ/Q0?ofkP030000003om^h0ooK^02`0ooK^
0@3oool000@0ooK^00<000000?ofkP3om^h01P3om^h2000004<0ooK^00<0?EV[0?ofkP3om^h02`3o
m^h303eIZ`030?ofkP0mFJ/0ooK^0140ooK^00<0?EV[0?ofkP3om^h0403om^h00`0mFJ/0ooK^0?of
kP020?ofkP<0?EV[3@3om^h203eIZ`D0ooK^00<0000003YDZ@3D?AT00P3D?AT203YDZ@030=@m6@0j
E:T0000000L0>UBY0P0000000`3D?AT0?EVc03eI/`0603eI/`030000000mFK<0?EVc00D0?EVc00<0
e3dI03eI/`0mFK<01P0mFK<00`000000?EVc0=@m6@020=@m6@80?EVc00D0000003eI/`0mFK<0?EVc
0=@m6@03000000D0@Ejl00<00000045N_011G[`01011G[`00`000000@Ejl045N_003045N_0030000
003D?AT0@Ejl0080@Ejl00<000000=@m6@11G[`00P11G[`01@000000@Ejl045N_011G[`000000080
@Ejl0`0000030?mA8P040000003oDB80oe4R00000080oe4R00@0?EV[0?mA8P3oDB8000000`3oDB80
0`000000oe4R000000030?mA8@030000003oDB40oe4Q00<0oe4Q00<000000?mA8@3oDB400`3oDB43
03eIZ`D0oe0Q00<000000?m@8@3oD240103oD2400`000000oe0Q000000050?m?80050000003oCb00
odlP0?m?800mFJ/00P3oCb000`000000odlP000000050?m<7`030000003oC1l0od`O00@0od`O0`0m
FJ/30?m87@050=@m6@3om^h0ooK^03eIZ`3D?AT01P3om^h00`0mFJ/0e3dI0?ofkP030?ofkP040=@m
6@3om^h0ooK^0=@m6@P0ooK^100mFJ/@0?ofkP0303eIZ`3om^h0?EV[00@0?EV[203om^h303eIZ`03
0000003om^h0ooK^0280ooK^00<000000?ofkP3om^h0:`3om^h10?ooo`00103om^h00`000000ooK^
0?ofkP030?ofkP<00000A@3om^h00`0mFJ/0ooK^0?ofkP080?ofkP<0?EV[103om^h00`0mFJ/0ooK^
0?ofkP0@0?ofkP0303eIZ`3om^h0ooK^0140ooK^00@0?EV[0?ofkP0mFJ/0?EV[403om^h00`0mFJ/0
ooK^03eIZ`050?ofkP040000000jE:T0e3dI03YDZ@80e3dI00@0>UBY0=@m6@3D?AT000000P0jE:T4
00000080?EVc00<000000=@m6@0mFK<01`0mFK<00`000000?EVc03eI/`0503eI/`030=@m6@0mFK<0
?EVc00@0?EVc0`3D?AT503eI/`@0000000@0@Ejl0=@m6@11G[`000001P11G[`00`000000@Ejl045N
_003045N_00300000011G[`0@Ejl00<0@Ejl00@00000045N_03D?AT0@Ejl0P3D?AT4045N_0040000
0011G[`0@Ejl045N_0<000000P13HlD200000080oe4R00@000000?mA8P3oDB8000000`3oDB800`0m
FJ/000000?mA8P030?mA8P030000003oDB8000000080oe4Q00<000000?mA8@3oDB400`3oDB401000
0000oe4Q0?mA8@3oDB4303eIZ`030000003oDB40?EV[00@0oe0Q00<000000?m@8@3oD240103oD240
10000000oe0Q0?m@8@3oD24200000080odlP00<000000?m?803oCb000P3oCb00100mFJ/0odlP0?m?
800000020?m?80050000003oC1l0od`O0?m<7`000000103oC1l303eIZ`030?m<7`000000odPM0080
odPM00<000000?ofkP3D?AT00P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0e3dI00D0
ooK^00@0e3dI0?ofkP3om^h0e3dI103om^h503eIZ`030?ofkP0mFJ/0ooK^00h0ooK^100mFJ/80?of
kP@0?EV[0`3om^h00`000000ooK^0?ofkP0R0?ofkP030000003om^h0ooK^02/0ooK^0@3oool000<0
ooK^00@000000?ofkP3om^h0ooK^0`0000190?ofkP0303eIZ`3om^h0ooK^00D0ooK^0P0mFJ/80?of
kP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h0403om^h303eIZa<0ooK^0P0mFJ/60?of
kP80000000<0e3dI03YDZ@0jE:T00P3D?AT0100jE:T0e3dI00000000000703eI/`030000003D?AT0
e3dI00L0?EVc00<0000003eI/`0mFK<01@0mFK<00`3D?AT0?EVc03eI/`030=@m6@80?EVc00<00000
03eI/`0mFK<00`000002045N_00600000011G[`0@Ejl045N_03D?AT000001P11G[`00`000000@Ejl
045N_003045N_00300000011G[`0@Ejl00<0@Ejl00H00000045N_011G[`0e3dI045N_0000004045N
_00300000011G[`00000008000000`13HlD00`000000oe0R0?m@8P0200000080oe4R00<000000?mA
8P3oDB800P3oDB800`0mFJ/0oe4R0?mA8P020?mA8P070000003oDB80oe4R0?mA8P000000oe4Q0000
00040?mA8@030000003oDB40?EV[0080?EV[0P3oDB401@000000oe4Q0?mA8@0mFJ/000000080oe0Q
00<000000?m@8@3oD2401@3oD2400`000000oe0Q0?m@8@030?m@8@030000003oCb00000000D0odlP
00<0?EV[0000003oCb000`3oCb0010000000od`O0?m<7`00000403eIZ`80od`O00@000000?m<7`3o
C1l000000P3oB1d01`000000ooK^0?ofkP3D?AT0ooK^0=@m6@0mFJ/0103om^h0100mFJ/0ooK^0=@m
6@3D?AT40?ofkP80e3dI00<0ooK^0=@m6@0mFJ/0100mFJ/20?ofkP0503eIZ`3om^h0ooK^0?ofkP0m
FJ/02P3om^h503eIZ`P0ooK^100mFJ/70?ofkP030000003om^h0ooK^0240ooK^00<000000?ofkP3o
m^h0:`3om^h10?ooo`000`3om^h010000000ooK^00000000001<0?ofkP0303eIZ`3om^h0ooK^0080
ooK^0`0mFJ/:0?ofkP0303eIZ`3om^h0ooK^0100ooK^00<0?EV[0?ofkP3om^h0303om^h303eIZ`03
0?ofkP0mFJ/0ooK^01<0ooK^0P0mFJ/70?ofkP8000000P3D?AT2000000<0e3dI00<0000003eI/`0m
FK<01`0mFK<00`000000e3dI03eI/`0603eI/`030000000mFK<0?EVc0080?EVc1@3D?AT503eI/`<0
00001@11G[`00`000000@Ejl045N_002045N_0030=@m6@000000@Ejl00@0@Ejl00<00000045N_011
G[`00`11G[`00`000000@Ejl045N_003045N_0060000003D?AT0e3dI045N_03D?AT000000P11G[`4
00000080@f?500D0000004=Sa@13HlD0@f?5000000030?m@8P040000003oDB80oe4R000000@0oe4R
00D0000003eIZ`3oDB80oe4R000000050?mA8P030000003oDB40oe4Q0080oe4Q0`0mFJ/50?mA8@08
0000003oDB40oe4Q0?mA8@0mFJ/000000?m@8@0000060?m@8@030000003oD240oe0Q00D0oe0Q00<0
00000?m?803oCb00103oCb000`000000?EV[0?m?80040?m?80<0?EV[1@3oC1l01@000000od`O0?m<
7`3oC1l000000080odPM00L000000?ofkP3om^h0e3dI0?ofkP3D?AT0?EV[00@0ooK^00@0?EV[0?of
kP3om^h0e3dI1@3om^h503eIZ`D0ooK^00<0?EV[0?ofkP3om^h00P3om^h203eIZ`D0ooK^1@0mFJ/2
0?ofkP0303eIZ`3om^h0ooK^0080ooK^1@0mFJ/;0?ofkP030000003om^h0ooK^0200ooK^00<00000
0?ofkP3om^h0:`3om^h10?ooo`000`3om^h2000004h0ooK^00<0?EV[0?ofkP0mFJ/00P0mFJ/=0?of
kP0303eIZ`3om^h0ooK^0100ooK^00<0?EV[0?ofkP3om^h02@3om^h303eIZ`D0ooK^00<0?EV[0?of
kP3om^h04@3om^h00`0mFJ/0ooK^03eIZ`070?ofkP<0000000@0e3dI03eI/`0mFK<0?EVc203D?AT4
03eI/`030000003D?AT0?EVc00<0?EVc1`3D?AT403eI/`030=@m6@0mFK<0?EVc00<000000P11G[`0
0`000000@Ejl045N_004045N_00300000011G[`0@Ejl0080@Ejl0P3D?AT5045N_00300000011G[`0
@Ejl0080@Ejl00<00000045N_011G[`00P11G[`20=@m6@<0@Ejl00@000000=@m6@00000000000P13
HlD010000000@f?504=Sa@00000304=Sa@030000003oD280oe0R00<0oe0R0P0000040?mA8P030000
003oDB80?EV[0080oe4R00<000000?mA8P3oDB800P3oDB800`000000oe4R03eIZ`0303eIZ`030000
003oDB40oe4Q00@0oe4Q00<000000?mA8@3oDB400`3oDB400`0mFJ/000000?m@8@050?m@8@030000
003oD240oe0Q00D0oe0Q00<000000?m@8@0000001@3oCb0010000000?EV[0?m?803oCb0303eIZ`03
0?m?80000000od`O00D0od`O00<000000?m<7`3oC1l00P3oC1l2000000@0ooK^0P3D?AT00`3om^h0
?EV[0?ofkP020?ofkP0303eIZ`3om^h0ooK^0080e3dI00<0ooK^03eIZ`0mFJ/00`0mFJ/00`3om^h0
e3dI0?ofkP050?ofkP0303eIZ`3om^h0ooK^00@0ooK^1P0mFJ/50?ofkP0303eIZ`3om^h0?EV[00D0
?EV[3P3om^h00`000000ooK^0?ofkP0P0?ofkP030000003om^h0ooK^02/0ooK^0@3oool000@0ooK^
0P00001=0?ofkP80?EV[403om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0303eIZ`3om^h0ooK^00H0ooK^
0`0mFJ/80?ofkP0303eIZ`3om^h0ooK^0180ooK^0P0mFJ/40?ofkP<0?EV[00D0ooK^000000000000
00000=@m6@0403eI/`030=@m6@0mFK<0000000<0?EVc2P3D?AT403eI/`030000000mFK<0?EVc00@0
?EVc00<000000=@m6@0000001@11G[`00`000000@Ejl045N_005045N_00300000011G[`0@Ejl0080
@Ejl00<000000=@m6@11G[`00`11G[`00`000000@Ejl045N_003045N_00700000011G[`0e3dI0=@m
6@11G[`00000045N_0020000000304=Sa@000000e3dI00<0@f?500@0000004=Sa@13HlD000000`13
HlD01@000000oe0R0?m@8P3oD28000000080oe0R00<000000?mA8P3oDB800P3oDB801@000000oe4R
0?mA8P0mFJ/0000000@0oe4R0`0mFJ/0103oDB8000000?mA8@0000060?mA8@030000003oDB40oe4Q
00@0oe4Q00<0000003eIZ`000000103oD2400`000000oe0Q0?m@8@050?m@8@050000003oD240oe0Q
0?m@8@0000000`3oCb000`000000odlP03eIZ`0203eIZ`<0odlP00<000000?m?80000000103oC1l0
0`000000od`O0?m<7`040?m<7`030000003om^h0ooK^00<0ooK^00@0e3dI0?ofkP3om^h0?EV[0P3o
m^h00`0mFJ/0ooK^03eIZ`0403eIZ`80ooK^00D0e3dI0?ofkP3D?AT0ooK^0=@m6@050?ofkP0303eI
Z`3om^h0ooK^0080ooK^1@0mFJ/70?ofkPD0?EV[4`3om^h00`000000ooK^0?ofkP0P0?ofkP030000
003om^h0ooK^02X0ooK^0@3oool000H0ooK^00<000000?ofkP3om^h0BP3om^h00`0mFJ/0ooK^0?of
kP0?0?ofkP0303eIZ`3om^h0ooK^0100ooK^00<0?EV[0?ofkP3om^h00`3om^h303eIZ``0ooK^00<0
?EV[0?ofkP3om^h04@3om^h0100mFJ/0ooK^03eIZ`3om^h203eIZ`D0ooK^00@000000=@m6@000000
e3dI100mFK<00`3D?AT0?EVc0000000803eI/`030000003D?AT0?EVc00H0?EVc00<0000003eI/`0m
FK<00`000002045N_0030=@m6@11G[`0@Ejl00@0@Ejl00<00000045N_011G[`01011G[`00`000000
@Ejl045N_002045N_00300000011G[`0e3dI00@0@Ejl00<00000045N_011G[`00P11G[`010000000
e3dI045N_011G[`3000000<0@f?500D0000004=Sa@3D?AT0e3dI0000000304=Sa@0500000013HlD0
@f?504=Sa@0000000P3oD2800`000000oe0R0?m@8P020?m@8P040000003oDB80oe4R000000<0oe4R
00<0?EV[0000003oDB800`0mFJ/00`000000oe4R0?mA8P020?mA8P030000003oDB40oe4Q00@0oe4Q
00<000000?mA8@3oDB40103oDB401@000000oe4Q03eIZ`3oDB40000000<0oe0Q00<000000?m@8@3o
D240103oD2400`000000oe0Q0?m@8@020?m@8@030000003oCb00?EV[00<0?EV[0P3oCb00100mFJ/0
odlP0?m?800000030?m?80050000003oC1l0od`O0?m<7`0000001@3oC1l00`000000ooK^0?ofkP04
0?ofkP80e3dI0P3om^h603eIZ`80ooK^00@0e3dI0?ofkP3om^h0e3dI0P3om^h20=@m6@@0ooK^00<0
?EV[0?ofkP0mFJ/01@0mFJ/30?ofkP<0?EV[00<0ooK^03eIZ`0mFJ/00`0mFJ/G0?ofkP030000003o
m^h0ooK^01l0ooK^00<000000?ofkP3om^h0:P3om^h10?ooo`001`3om^h2000004X0ooK^00<0?EV[
0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP0303eIZ`3om^h0?EV[0080?EV[3`3om^h0
0`0mFJ/0ooK^0?ofkP0A0?ofkP0403eIZ`3om^h0?EV[03eIZ`P0ooK^0P0mFJ/00`3D?AT0000003eI
/`0303eI/`80e3dI0P00000703eI/`030000003D?AT0?EVc00D0?EVc0`000006045N_0030=@m6@11
G[`0@Ejl00@0@Ejl00<00000045N_011G[`01011G[`00`000000@Ejl045N_002045N_00300000011
G[`0e3dI00<0@Ejl00@00000045N_011G[`0@Ejl0P3D?AT01@11G[`0000000000013HlD0000000@0
@f?500D0000004=Sa@13HlD0@f?50=@m6@0304=Sa@0400000013HlD0@f?5000000<0oe0R00@00000
0?m@8P3oD28000000P3oD2800`000000oe4R000000030?mA8P<0?EV[0P3oDB800`000000oe4R0?mA
8P020?mA8P030000003oDB80000000@0oe4Q00<000000?mA8@3oDB40103oDB402@000000oe4Q0?mA
8@3oDB40?EV[0?mA8@000000oe0Q000000060?m@8@030000003oD240oe0Q0080oe0Q0`0mFJ/00`3o
Cb0000000?m?80040?m?800303eIZ`000000odlP00<0odlP00@000000?m<7`3oC1l000001P3oC1l0
0`000000ooK^0?ofkP040?ofkP030=@m6@0mFJ/0?EV[00@0?EV[0P3om^h01@3D?AT0ooK^0?ofkP3o
m^h0e3dI0080ooK^00<0e3dI0?ofkP3om^h00P3D?AT20?ofkPH0?EV[1`3om^h503eIZa/0ooK^00<0
00000?ofkP3om^h07P3om^h00`000000ooK^0?ofkP0Z0?ofkP40oooo00090?ofkP030000003om^h0
ooK^04P0ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP<0?EV[4P3om^h0
0`0mFJ/0ooK^0?ofkP0B0?ofkP80?EV[1P3om^h303eIZ`80ooK^00<000000=@m6@0000001@0mFK<0
0`3D?AT0?EVc0000000803eI/`030=@m6@0mFK<0?EVc00<000000P11G[`00`000000@Ejl045N_005
045N_0030=@m6@11G[`0@Ejl00@0@Ejl00<00000045N_011G[`00`11G[`00`000000@Ejl045N_002
045N_00400000011G[`0@Ejl0=@m6@<0@Ejl00<000000=@m6@3D?AT00`00000304=Sa@0300000013
HlD0@f?50080@f?500P0000004=Sa@13HlD0@f?50000003D?AT0@f?5000000<0@f?500@000000?m@
8P3oD28000000P3oD2800`000000oe0R0?m@8P020?m@8P030000000mFJ/0?EV[0080?EV[0P3oDB80
0`0mFJ/0oe4R000000040?mA8P050000003oDB80oe4R0?mA8P0000000`3oDB400`000000oe4Q0?mA
8@030?mA8@030000003oDB40oe4Q00<0oe4Q00<0?EV[0?mA8@0000001P3oD2400`000000oe0Q03eI
Z`0303eIZ`80oe0Q00<0e3dI0000003oCb001@3oCb000`000000?EV[0?m?80040?m?80030000003o
C1l0000000D0od`O00<000000?ofkP3om^h00P3om^h703eIZ`030?ofkP0mFJ/0?EV[0080ooK^00D0
e3dI0?ofkP3om^h0ooK^0=@m6@020?ofkP040=@m6@3om^h0ooK^0?ofkPH0?EV[1`3om^h503eIZah0
ooK^00<000000?ofkP3om^h07P3om^h00`000000ooK^0?ofkP0Z0?ofkP40oooo000:0?ofkP800000
B03om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00d0ooK^0P0mFJ/00`3om^h0?EV[
0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^0140ooK^0P0mFJ/40?ofkP80?EV[1P3om^h00`000000e3dI
0000000503eI/`030=@m6@0mFK<0000000L0?EVc00<000000=@m6@0000001P11G[`00`000000@Ejl
045N_005045N_080e3dI1011G[`00`000000@Ejl045N_004045N_00300000011G[`0@Ejl0080@Ejl
00D00000045N_011G[`0e3dI045N_0020=@m6@80000000<0@f?500000013HlD01013HlD01@000000
@f?504=Sa@13HlD0000000<0@f?500@0000004=Sa@3D?AT000000`13HlD010000000oe0R0?m@8P00
00020?m@8P030000003oD280oe0R00<0?EV[0P0000000`3oDB8000000?mA8P020?mA8P0303eIZ`3o
DB80oe4R00<0oe4R00<000000?mA8P3oDB800P3oDB800`000000oe4Q000000050?mA8@030000003o
DB40oe4Q00D0oe4Q00<0?EV[0?mA8@000000103oD24303eIZ`H0oe0Q00<000000?m@8@000000103o
Cb0010000000odlP0?m?800mFJ/50?m?80030000003oC1l0od`O00@0od`O00<0000003eIZ`0mFJ/0
1@0mFJ/40?ofkP060=@m6@0mFJ/0ooK^03eIZ`3om^h0e3dI103om^h00`3D?AT0ooK^03eIZ`0703eI
Z`D0ooK^1P0mFJ/R0?ofkP030000003om^h0ooK^01d0ooK^00<000000?ofkP3om^h0:P3om^h10?oo
o`00303om^h00`000000ooK^0?ofkP150?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3o
m^h02P3om^h303eIZ`@0ooK^00<0?EV[0?ofkP3om^h04@3om^h00`0mFJ/0ooK^0?ofkP0B0?ofkPD0
?EV[2@3om^h4000000@0?EVc00@0e3dI03eI/`00000000000P0mFK<300000080@Ejl00<0e3dI045N
_011G[`01@11G[`00`000000@Ejl045N_004045N_00300000011G[`0e3dI00@0@Ejl00<00000045N
_011G[`01011G[`01@000000@Ejl045N_011G[`000000080@Ejl0P3D?AT00`13HlD0000004=Sa@03
04=Sa@0300000013HlD0@f?50080@f?500D0000004=Sa@13HlD0@f?50000000304=Sa@0400000013
HlD0@f?50=@m6@80@f?500@000000?m@8P3oD28000000P3oD28403eIZ`030?m@8P000000oe0R0080
oe0R00H000000?mA8P3oDB80oe4R0000000mFJ/40?mA8P030000003oDB80oe4R00@0oe4R00<00000
0?mA8@3oDB400`3oDB400`000000oe4Q0?mA8@040?mA8@80000000<0?EV[0?mA8@000000100mFJ/8
0?m@8@040000003oD240oe0Q000000<0odlP00<000000?m?803oCb000P3oCb001`0mFJ/0odlP0?m?
803oCb0000000?m?80000000103oC1l503eIZ`<0ooK^00<0e3dI0?ofkP3om^h00P3om^h0103D?AT0
?EV[0?ofkP3om^h203eIZ`<0ooK^1P0mFJ/20?ofkP030=@m6@0mFJ/0ooK^0080ooK^1P0mFJ/V0?of
kP030000003om^h0ooK^01`0ooK^00<000000?ofkP3om^h0:P3om^h10?ooo`003@3om^h00`000000
ooK^0?ofkP140?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h0203om^h203eIZ`L0
ooK^00<0?EV[0?ofkP3om^h04P3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP<0?EV[3P3om^h3000000@0
?EVc00<0e3dI03eI/`0000000P000006045N_080e3dI1P11G[`00`000000@Ejl045N_004045N_003
00000011G[`0e3dI00@0@Ejl00<00000045N_011G[`00`11G[`010000000@Ejl045N_011G[`30=@m
6@80@f?500<0e3dI04=Sa@0000000`13HlD00`000000@f?504=Sa@0204=Sa@0500000013HlD0@f?5
04=Sa@0000000`13HlD01`000000@f?504=Sa@000000e3dI04=Sa@0000000P3oD28010000000?EV[
03eIZ`0000030?m@8P070000003oD280oe0R0?m@8P000000oe0R000000020?mA8P030000003oDB80
?EV[0080oe4R00<000000?mA8P3oDB80103oDB800`000000oe4R000000030?mA8@030000003oDB40
oe4Q00@0oe4Q00<000000?mA8@3oDB400`0mFJ/00`000000oe0Q000000080?m@8@030000003oD240
oe0Q0080oe0Q00<000000?m?800000001P3oCb000`0mFJ/0odlP000000030?m?80030000003oC1l0
?EV[00<0?EV[1P3om^h00`3D?AT0ooK^0?ofkP030?ofkP0503eIZ`3om^h0ooK^0?ofkP3D?AT01P0m
FJ/20=@m6@@0ooK^1`0mFJ/Y0?ofkP030000003om^h0ooK^01d0ooK^00<000000?ofkP3om^h0:@3o
m^h10?ooo`003P3om^h2000004@0ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP05
0?ofkP<0?EV[2@3om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^00d0ooK^0`0mFJ/0
0`3om^h0?EV[03eIZ`0?0?ofkP<0000000@0e3dI03eI/`0mFK<000000P3D?AT00`11G[`000000000
0007045N_0030=@m6@11G[`0@Ejl00@0@Ejl0P000005045N_00300000011G[`0e3dI00@0@Ejl00<0
0000045N_011G[`00P11G[`010000000e3dI0=@m6@3D?AT204=Sa@0600000013HlD0@f?504=Sa@3D
?AT000001013HlD01@000000@f?504=Sa@13HlD0000000<0@f?500@0000004=Sa@13HlD000000P13
HlD01@000000@f?50=@m6@000000oe0R00<0?EV[00<0oe0R0000003oD2800P3oD2801@000000oe0R
0?m@8P3oD28000000080oe0R00<000000?mA8P0000000`3oDB800`0mFJ/000000?mA8P040?mA8P80
00000`3oDB800`000000oe4Q000000060?mA8@040000000mFJ/0?EV[03eIZ`80oe4Q00<0?EV[0?mA
8@0000001`3oD242000000H0oe0Q00<000000?m?803oCb001P3oCb000`0mFJ/0odlP0?m?800403eI
Z`030?m<7`000000e3dI00H0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`0mFJ/0ooK^03eIZ`0603eI
Z`@0ooK^00<0e3dI0?ofkP3om^h01@0mFJ/^0?ofkP030000003om^h0ooK^01`0ooK^00<000000?of
kP3om^h0:@3om^h10?ooo`00403om^h00`000000ooK^0?ofkP110?ofkP0303eIZ`3om^h0ooK^0100
ooK^00@0?EV[0?ofkP3om^h0ooK^0`0mFJ/=0?ofkP0303eIZ`3om^h0ooK^0140ooK^00<0?EV[0?of
kP3om^h02P3om^h303eIZ`D0ooK^00<0?EV[0?ofkP3om^h03P3om^h5000000<0@Ejl00<0e3dI045N
_011G[`00P000006045N_0030=@m6@11G[`0@Ejl00D0@Ejl00<00000045N_011G[`00`11G[`00`00
0000@Ejl0=@m6@03045N_00300000011G[`0@Ejl00<0e3dI00<0@f?500000013HlD00P13HlD00`00
0000@f?504=Sa@0204=Sa@030=@m6@000000@f?50080@f?500D0000004=Sa@13HlD0@f?500000003
04=Sa@0400000013HlD0@f?500000080@f?500L0000004=Sa@000000000003eIZ`3oD28000000080
oe0R00D000000?m@8P3oD280oe0R000000030?m@8P050000003oD280oe0R0?m@8P000000103oDB80
0`000000?EV[0?mA8P030?mA8P030000003oDB80oe4R00@0oe4R00<000000?mA8@3oDB400`3oDB43
03eIZ`D0oe4Q00@0000003eIZ`3oDB4000001@3oD2400`000000oe0Q0?m@8@050?m@8@030000003D
?AT0000000H0odlP00@0000003eIZ`0mFJ/0?EV[0`3oCb001@000000od`O0000003om^h0e3dI00D0
ooK^00<0e3dI0?ofkP3om^h00P3om^h703eIZ`<0ooK^2@0mFJ/00`3om^h0e3dI0?ofkP0_0?ofkP03
0000003om^h0ooK^01/0ooK^00<000000?ofkP3om^h0:@3om^h10?ooo`004@3om^h200000480ooK^
00<0?EV[0?ofkP3om^h03`3om^h0100mFJ/0ooK^03eIZ`0mFJ/@0?ofkP0303eIZ`3om^h0ooK^0180
ooK^00<0?EV[0?ofkP3om^h01P3om^h303eIZ`P0ooK^0P0mFJ/?0?ofkP0303eIZ`000000000000<0
000000@0@Ejl0=@m6@3D?AT0e3dI0`11G[`2000000D0@Ejl00<0e3dI00000011G[`01@11G[`00`00
0000@Ejl045N_003045N_00500000011G[`0e3dI045N_00000000`3D?AT504=Sa@0500000013HlD0
@f?504=Sa@0000001013HlD01@3D?AT0@f?504=Sa@13HlD0000000<0@f?500D0000004=Sa@13HlD0
@f?50000000204=Sa@0300000013HlD000000080000000@0?EV[00000000000000000P3oD2801@00
0000oe0R0?m@8P3oD280000000<0oe0R00L000000?m@8P3oD280oe0R0000003oD280000000<0oe4R
00<000000?mA8P0mFJ/00P3oDB800`000000oe4R0?mA8P040?mA8P040000003oDB8000000?mA8@<0
?EV[00<000000?mA8@3oDB40103oDB400`000000oe4Q03eIZ`020?mA8@050000003oD240oe0Q0?m@
8@0000001`3oD2401@000000oe0Q0?m@8@3oD240000000<0odlP0`0mFJ/20?m?8080?EV[0`3oCb00
1@000000ooK^0?ofkP3om^h0e3dI00@0ooK^00<0e3dI0?ofkP0mFJ/01@0mFJ/20?ofkP80e3dI0`3o
m^h603eIZ`050=@m6@3om^h0ooK^0?ofkP3D?AT0<@3om^h00`000000ooK^0?ofkP0J0?ofkP030000
003om^h0ooK^02T0ooK^0@3oool001<0ooK^00<000000?ofkP3om^h0?`3om^h00`0mFJ/0ooK^0?of
kP0>0?ofkP<0?EV[4P3om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^00<0ooK^0`0m
FJ/<0?ofkP0303eIZ`3om^h0ooK^00`0ooK^0`0mFJ/600000003045N_03D?AT0e3dI00<0e3dI00<0
@Ejl00000011G[`01011G[`00`3D?AT00000045N_005045N_00300000011G[`0@Ejl0080@Ejl1@3D
?AT204=Sa@0300000013HlD0@f?500<0@f?500<0000004=Sa@13HlD00P13HlD01P000000@f?504=S
a@13HlD000000=@m6@<0@f?500D0000004=Sa@13HlD0@f?50000000204=Sa@0300000013HlD00000
0080000000@0AVS>00000016J<h000000P3oCb4010000000oe0R0?m@8P0000030?m@8P040000003o
D280oe0R000000<0oe0R00L000000?m@8P3oD280oe0R0000003oDB80000000<0oe4R00<0?EV[0000
003oDB80103oDB82000000060?mA8P0mFJ/0?EV[03eIZ`3oDB4000001`3oDB401@000000oe4Q0?mA
8@3oDB40?EV[0080oe4Q00<000000?m@8@0000001`3oD2400`000000oe0Q0?m@8@020?m@8@050000
000mFJ/0?EV[03eIZ`0000001P3oCb000`0mFJ/0odlP000000040?ofkP030=@m6@3om^h0ooK^00L0
?EV[1P3om^h703eIZ`040?ofkP3D?AT0ooK^0=@m6@<0ooK^00<0e3dI0?ofkP3om^h0;`3om^h00`00
0000ooK^0?ofkP0J0?ofkP030000003om^h0ooK^02T0ooK^0@3oool001@0ooK^0P00000o0?ofkP03
03eIZ`3om^h0ooK^00/0ooK^0`0mFJ/00`3om^h0?EV[0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^01<0
ooK^00<0?EV[0?ofkP0mFJ/00P0mFJ/?0?ofkP0303eIZ`3om^h0ooK^00T0ooK^0`0mFJ/0103om^h0
?EV[0?ofkP3om^h30000000603eIZ`2D;aD0000000000011G[`0e3dI0P11G[`60=@m6@80@Ejl00<0
e3dI00000011G[`00P11G[`70=@m6@0500000013HlD000000000003D?AT00`13HlD00`000000@f?5
04=Sa@0304=Sa@0500000013HlD0@f?504=Sa@0000001013HlD01@000000e3dI04=Sa@13HlD00000
00<0@f?500<0000004=Sa@0000000P0000001016J<h0000004IXcP00000204IXcP030000003oCb40
odlQ00<000000`3oD28010000000oe0R0?m@8P0000030?m@8P030000003oD280oe0R00<0oe0R00H0
00000?mA8P3oDB80oe4R0000000mFJ/50?mA8P040000000mFJ/0?EV[03eIZ`<0oe4R00<000000?mA
8@3oDB40103oDB42000000D0oe4Q00@0?EV[0?mA8@3oDB4000001P3oD242000000<0oe0Q0`0mFJ/0
0`000000odlP000000080?m?800303eIZ`3om^h0ooK^00<0ooK^1P0mFJ/30?ofkP0403eIZ`3om^h0
ooK^0?ofkPH0?EV[1@3om^h0103D?AT0ooK^0?ofkP3D?AT20?ofkP030=@m6@3om^h0ooK^0300ooK^
00<000000?ofkP3om^h06P3om^h00`000000ooK^0?ofkP0X0?ofkP40oooo000F0?ofkP030000003o
m^h0ooK^03`0ooK^00<0?EV[0?ofkP3om^h0203om^h303eIZ`D0ooK^00<0?EV[0?ofkP3om^h04@3o
m^h00`0mFJ/0ooK^0?ofkP0A0?ofkP<0?EV[4P3om^h203eIZ`L0ooK^0`0mFJ/40?ofkP0703eIZ`3o
m^h0ooK^0?ofkP000000L2<@03eIZ`020000000409@_5@000000@Ejl0=@m6@D0@Ejl0P0000070=@m
6@80@Ejl1000000504=Sa@030000003D?AT0@f?50080@f?500<0000004=Sa@13HlD00`13HlD01@00
0000@f?504=Sa@13HlD0000000<0@f?500<0000004=Sa@3D?AT00P13HlD00`000000@f?500000002
0000000404IXcP000000AVS>04IXcP<0e3dI0P16J<h00`000000odlQ000000020?m?8@040000003o
D280oe0R00000080oe0R00D000000?m@8P3oD280oe0R000000050?m@8P050000003oD28000000?mA
8P0000000P3oDB800`0mFJ/0oe4R0?mA8P0303eIZ`@0oe4R0P0000000`3oDB8000000?mA8@030?mA
8@030000003oDB40oe4Q00H0oe4Q00@0?EV[0000003oDB400000103oD2400`000000oe0Q03eIZ`03
03eIZ`@0oe0Q00<000000?m?803oCb00103oCb00100mFJ/0odlP0000003om^h803eIZ`030?ofkP3D
?AT0ooK^0080ooK^200mFJ/00`3D?AT0ooK^0=@m6@050?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT0
0P3om^h00`3D?AT0ooK^0?ofkP0`0?ofkP030000003om^h0ooK^01T0ooK^00<000000?ofkP3om^h0
:03om^h10?ooo`005`3om^h2000003`0ooK^00<0?EV[0?ofkP3om^h01P3om^h203eIZ`P0ooK^00<0
?EV[0?ofkP3om^h04@3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP<0?EV[00<0ooK^03eIZ`3om^h04`3o
m^h00`0mFJ/0ooK^0?ofkP020?ofkP<0?EV[1`3om^h00`0mFJ/0ooK^0?ofkP020?ofkP80000000<0
?EV[0000000000000`000007045N_08000000P11G[`00`3D?AT0000000000002000000<0@f?50P00
000504=Sa@030000003D?AT0@f?50080@f?50P00000404=Sa@0500000013HlD0@f?504=Sa@000000
0`13HlD010000000@f?50=@m6@0mFJ/20000000504IXcP000000AVS>04IXcP0000000P3D?AT01@00
0000AVS>00000016J<h000000080odlQ00L0000003eIZ`3oCb40odlQ0000003oD28000000080oe0R
00@000000?m@8P3oD2800000103oD282000000<0oe0R00@000000?mA8P3oDB80oe4R0`0mFJ/00`00
0000oe4R0?mA8P030?mA8P030000003oDB80oe4R0080oe4R00@000000?mA8@0000000000203oDB40
1@000000?EV[0?mA8@3oDB40000000<0oe0Q0`0mFJ/60?m@8@80000000<0oe0Q0000003oCb00103o
Cb000`0mFJ/0000003eIZ`0503eIZ`@0ooK^0P3D?AT00`3om^h0?EV[03eIZ`0403eIZ`<0ooK^00@0
e3dI0?ofkP3om^h0e3dI1@3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0e3dI03<0ooK^
00<000000?ofkP3om^h0603om^h00`000000ooK^0?ofkP0X0?ofkP40oooo000I0?ofkP030000003o
m^h0ooK^03X0ooK^00<0?EV[0?ofkP3om^h00P3om^h303eIZ`/0ooK^00<0?EV[0?ofkP3om^h0403o
m^h00`0mFJ/0ooK^0?ofkP0<0?ofkP80?EV[1@3om^h00`0mFJ/0ooK^0?ofkP0A0?ofkPD0?EV[2`3o
m^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`00000000000080?EV[0`000006045N_0@0000000@0
e3dI04=Sa@00000000001@13HlD2000000@0@f?500<000000=@m6@13HlD00`13HlD01@000000@f?5
04=Sa@13HlD0000000<0@f?500<0000004=Sa@13HlD0100000001P3D?AT0000004IXcP16J<h00000
04IXcP80e3dI0P16J<h01`000000AVS>00000016J<h000000?m?8@0000000P3oCb40100mFJ/0odlQ
0?m?8@0000020?m@8P040000003oD280oe0R000000@0oe0R00H000000?m@8P3oD280oe0R0=@m6@00
000403eIZ`030?mA8P000000?EV[00@0oe4R0P0000060?mA8P030000003oDB40oe4Q00H0oe4Q0P00
00020?mA8@0303eIZ`3oDB40oe4Q00<0?EV[203oD2400`000000oe0Q0?m@8@020?m@8@040000003o
Cb00odlP0?m?80H0?EV[0`3om^h303eIZ`030?ofkP0mFJ/0?EV[00@0?EV[1P3om^h01@3D?AT0ooK^
0?ofkP3om^h0e3dI00@0ooK^00<0e3dI0?ofkP3om^h00`3om^h20=@m6C<0ooK^00<000000?ofkP3o
m^h0603om^h00`000000ooK^0?ofkP0X0?ofkP40oooo000J0?ofkP800000>P3om^h00`0mFJ/0ooK^
03eIZ`0203eIZ`h0ooK^00<0?EV[0?ofkP3om^h04@3om^h00`0mFJ/0ooK^0?ofkP080?ofkP<0?EV[
1`3om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP80?EV[3P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP<0?EV[
00<0000009@_5@2D;aD010000002045N_08000000`13HlD2000000030=@m6@13HlD0@f?500800000
1@13HlD00`000000@f?504=Sa@0304=Sa@80e3dI0`13HlD01@000000@f?504=Sa@13HlD000000080
@f?50`00000204IXcP0600000016J<h0AVS>0=@m6@000000AVS>0P3D?AT01016J<h0000004IXcP16
J<h200000080AVS>00T000000?m?8@000000odlQ0000003oCb40?EV[0000003oCb400P0000020?m@
8P030000003oD280oe0R0080oe0R00@000000?m@8P3oD280e3dI0`0mFJ/20?m@8P030000003oDB80
00000080oe4R00@0?EV[0?mA8P00000000001P3oDB82000000030?mA8P000000oe4Q00@0oe4Q0P00
00040?mA8@<0?EV[00<0oe4Q0000003oD2401P3oD242000000H0oe0Q00<0000003eIZ`0mFJ/00`0m
FJ/60?ofkPH0?EV[00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP020?ofkP050=@m6@3o
m^h0ooK^0?ofkP3D?AT01@3om^h20=@m6C@0ooK^00<000000?ofkP3om^h05`3om^h00`000000ooK^
0?ofkP0X0?ofkP40oooo000L0?ofkP030000003om^h0ooK^03L0ooK^0P0mFJ/A0?ofkP0303eIZ`3o
m^h0ooK^0140ooK^00<0?EV[0?ofkP3om^h01@3om^h303eIZ`/0ooK^00<0?EV[0?ofkP3om^h0403o
m^h00`0mFJ/0ooK^03eIZ`0=0?ofkP0303eIZ`3om^h0ooK^00<0?EV[0P3om^h00`0mFJ/0L2<@0000
00020000000309@_5@0000000000008000001`13HlD00`000000e3dI0=@m6@0204=Sa@8000001013
HlD2000000@0@f?500<000000=@m6@13HlD00P13HlD00`000000@f?504=Sa@0300000080AVS>00@0
000004IXcP16J<h000000`16J<h20=@m6@0<00000016J<h0AVS>00000016J<h0000004IXcP000000
AVS>0000003oCb4000000P3oCb401@000000odlQ0000000mFJ/0odlQ0080000000<0oe0R0000003o
D2800`3oD2800`000000?EV[03eIZ`0203eIZ`H0oe0R00<000000?mA8P3oDB800P3oDB800`0mFJ/0
oe4R0?mA8P050?mA8P050000003oDB80oe4R0?mA8P000000103oDB400`000000oe4Q0?mA8@0403eI
Z`80oe4Q0P0mFJ/00`3oDB4000000?m@8@040?m@8@030000003oD240oe0Q00H0oe0Q0`0mFJ/60?of
kPH0?EV[00D0ooK^0=@m6@3om^h0ooK^0=@m6@080?ofkP030=@m6@3om^h0ooK^00<0ooK^00@0e3dI
0?ofkP3om^h0e3dI1P3om^h20=@m6C@0ooK^00<000000?ofkP3om^h05`3om^h00`000000ooK^0?of
kP0W0?ofkP40oooo000M0?ofkP800000=`3om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP0303eIZ`3om^h0
ooK^0100ooK^00<0?EV[0?ofkP3om^h00`3om^h203eIZ`h0ooK^00<0?EV[0?ofkP3om^h0403om^h0
0`0mFJ/0ooK^03eIZ`0=0?ofkP<0?EV[1@3om^h00`0mFJ/00000000000040000000309@_5@000000
000000<000001P13HlD00`000000e3dI04=Sa@0204=Sa@8000001013HlD2000000<0@f?500@00000
0=@m6@13HlD0@f?50`00000204IXcP0500000016J<h0AVS>04IXcP0000000P16J<h30=@m6@030000
0016J<h0e3dI0080AVS>0100000004IXcP000000AVS>00000016J<h000000?m?8@000000odlQ0000
003oCb4000000?m?8@0mFJ/000000P3oCb4010000000oe0R0?m@8P3oD28303eIZ`80oe0R00<00000
0?m@8P3oD2800`3oD282000000030?m@8P000000oe4R0080000000<0?EV[0?mA8P3oDB800`3oDB82
000000D0oe4R00@000000?mA8@00000000000`0mFJ/40?mA8@8000000P3oDB401@0mFJ/0oe4Q0000
00000000oe0Q008000000`3oD2400`0mFJ/0oe0Q0?m@8@0303eIZ`030000003om^h0?EV[00<0ooK^
1@0mFJ/50?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT01P3om^h00`3D?AT0ooK^0?ofkP050?ofkP03
0=@m6@3om^h0e3dI00L0ooK^00<0e3dI0?ofkP3om^h0<P3om^h00`000000ooK^0?ofkP0G0?ofkP03
0000003om^h0ooK^02L0ooK^0@3oool001l0ooK^00<000000?ofkP3om^h0=@3om^h00`0mFJ/0ooK^
0?ofkP0@0?ofkP0303eIZ`3om^h0ooK^0140ooK^00<0?EV[0?ofkP0mFJ/00P0mFJ/A0?ofkP0303eI
Z`3om^h0ooK^00l0ooK^00@0?EV[0?ofkP3om^h0?EV[203om^h503eIZ`P0ooK^00<0?EV[0000001`
8a000P000000102D;aD000000000002D;aD2000000040<<l6P0000000000000000D0@f?500<0e3dI
00000013HlD00P13HlD2000000@0@f?50P00000204=Sa@0303eIZ`3D?AT000000080AVS>00D00000
04IXcP16J<h0AVS>0000000204IXcP<0e3dI00h0000004IXcP16J<h0000004IXcP3D?AT0000004IX
cP000000AVS>00000016J<h0000004IXcP80000000@0odlQ0000003oCb4000000P3oCb4010000000
?EV[0?m?8@00000403eIZ`@0oe0R00<000000?m@8P3oD2800P3oD282000000@0oe0R00D000000?mA
8P3oDB80oe4R03eIZ`020?mA8P8000001`3oDB8403eIZ`D0oe4Q0P0000050?mA8@80?EV[00<0oe4Q
0000003oD240103oD24303eIZ`8000000P3om^h703eIZ`L0ooK^00<0e3dI0?ofkP3om^h00`3om^h0
0`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3D?AT01`3om^h0
0`3D?AT0ooK^0?ofkP0c0?ofkP030000003om^h0ooK^01H0ooK^00<000000?ofkP3om^h09`3om^h1
0?ooo`00803om^h00`000000ooK^0?ofkP0d0?ofkP0303eIZ`3om^h0ooK^0140ooK^00<0?EV[0?of
kP3om^h03`3om^h303eIZa@0ooK^00<0?EV[0?ofkP3om^h0403om^h00`0mFJ/0ooK^03eIZ`050?of
kP<0?EV[103om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`000000L2<@0080000000D0e3dI09@_
5@000000000009@_5@03000000030<<l6P000000000000@0@f?500<0e3dI0000000000000`13HlD2
000000<0@f?500<0?EV[0000000000000P16J<h01@3D?AT0000004IXcP16J<h000000080AVS>0`3D
?AT01@16J<h0000004IXcP16J<h000000080AVS>00H0000004IXcP3D?AT0AVS>00000016J<h20000
000;04IXcP000000odlQ0000003oCb4000000?m?8@000000odlQ0000003oCb400`0mFJ/20?m?8@04
0000003oD280oe0R0?m@8P8000000`3oD282000000@0oe0R0P0000000`3oD28000000?mA8P020?mA
8P0303eIZ`000000oe4R00D0oe4R0`0mFJ/20?mA8P030000003oDB40oe4Q0080oe4Q0P0000080?mA
8@050000000mFJ/0?EV[0000003oD2400`0mFJ/20?m@8@030000003om^h0ooK^00D0?EV[00<0e3dI
0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI
0?ofkP3om^h01P3om^h20=@m6@L0ooK^00<0e3dI0?ofkP3om^h0=03om^h00`000000ooK^0?ofkP0E
0?ofkP030000003om^h0ooK^02L0ooK^0@3oool00240ooK^0P00000d0?ofkP0303eIZ`3om^h0ooK^
0140ooK^00<0?EV[0?ofkP3om^h0303om^h303eIZ`80ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0m
FJ/0ooK^0?ofkP0?0?ofkP0503eIZ`3om^h0ooK^03eIZ`3om^h00`0mFJ/80?ofkP0303eIZ`3om^h0
ooK^00@0ooK^0`0mFJ/0103om^h000000000001`8a07000000030<<l6P000000000000@000000P13
HlD0103D?AT0@f?500000000000304=Sa@<000000P16J<h200000080AVS>00<0e3dI00000016J<h0
0`3D?AT204IXcP0600000016J<h0AVS>00000016J<h000000P16J<h01P000000AVS>0000003D?AT0
000004IXcP80000000P0AVS>000000000000odlQ0000003oCb4000000?m?8@<0?EV[00T000000?m?
8@0mFJ/0odlQ0000003oCb4000000?m@8P0000000`3oD282000000@0oe0R0P0000040?m@8P050000
003oDB8000000000000mFJ/00P3oDB8403eIZ`030000003oDB80oe4R00<0oe4R00@000000?mA8@00
00000000203oDB4200000080oe4Q100mFJ/20?m@8@8000001@0mFJ/40?ofkP030=@m6@3om^h0ooK^
00H0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^
00L0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP0e0?ofkP030000003om^h0ooK^
01@0ooK^00<000000?ofkP3om^h09`3om^h10?ooo`008`3om^h00`000000ooK^0?ofkP0b0?ofkP03
03eIZ`3om^h0ooK^0100ooK^00<0?EV[0?ofkP3om^h02@3om^h303eIZ`D0ooK^00<0?EV[0?ofkP3o
m^h04`3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0?EV[0080?EV[2`3om^h00`0mFJ/0
ooK^0?ofkP020?ofkP80?EV[0`3om^h00`0mFJ/0ooK^0000000200000003070S40000000U2lE00@0
00000`33?1X6000000030=@m6@13HlD0?EV[00<000000`16J<h20000000304IXcP3D?AT0e3dI00@0
e3dI00@0000004IXcP00000000000P16J<h03@000000AVS>04IXcP000000AVS>00000016J<h00000
04IXcP000000AVS>0=@m6@16J<h01@0000000`3oCb4000000000000203eIZ`030?m?8@0000000000
0080odlQ00<0000003eIZ`3oCb400P3oCb400`000000oe0R0?m@8P02000000@0oe0R0P0000060?m@
8P8000000P3oDB8303eIZ`<000001`3oDB82000000P0oe4Q0P00000403eIZ`80oe4Q00<000000?m@
8@0mFJ/0100mFJ/20?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D
?AT0ooK^0?ofkP060?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT02@3om^h20=@m6@H0ooK^00<0e3dI
0?ofkP3om^h0=@3om^h00`000000ooK^0?ofkP0E0?ofkP030000003om^h0ooK^02H0ooK^0@3oool0
02@0ooK^0P00000b0?ofkP0303eIZ`3om^h0ooK^0140ooK^00<0?EV[0?ofkP3om^h01P3om^h203eI
Z`T0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP<0?EV[0P3om^h00`0m
FJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0?EV[0080?EV[1P3om^h00`0mFJ/0ooK^0?ofkP060000
000309@_5@000000000000<000000P33?1X00`000000?EV[03eIZ`03000000<0AVS>00<000000=@m
6@3D?AT00`3D?AT01`000000AVS>04IXcP000000AVS>0=@m6@16J<h00P0000002@16J<h0000004IX
cP16J<h0000004IXcP000000AVS>0000000204IXcPT0000000L0oddQ0000000mFJ/0?EV[0000003o
Cb40000000<0odlQ00D000000?m?8@3oCb40?EV[000000020?m?8@800000103oD282000000H0oe0R
0P0000001P3oD280?EV[03eIZ`0mFJ/0oe4R00000080?EV[1`3oDB8200000080oe4R00<000000?mA
8@3oDB400`3oDB4010000000?EV[03eIZ`0mFJ/60?mA8@@0?EV[1@3om^h00`3D?AT0ooK^0?ofkP04
0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0=@m6@0:
0?ofkP030=@m6@3om^h0e3dI00D0ooK^00<0e3dI0?ofkP3om^h0=P3om^h00`000000ooK^0?ofkP0D
0?ofkP030000003om^h0ooK^02H0ooK^0@3oool002H0ooK^00<000000?ofkP3om^h0;`3om^h00`0m
FJ/0ooK^0?ofkP0A0?ofkP0303eIZ`3om^h0ooK^00<0ooK^0`0mFJ/;0?ofkP0303eIZ`3om^h0ooK^
01<0ooK^00<0?EV[0?ofkP3om^h02P3om^h303eIZ`030?ofkP0mFJ/0ooK^0080ooK^00<0?EV[0?of
kP3om^h0203om^h303eIZ`T0ooK^00@0?EV[0?ofkP3om^h0ooK^10000000102D;aD000000000002D
;aD2000000050<<l6P0mFJ/0?EV[03eIZ`33?1X0200000001016J<h0000000000000000204IXcPD0
000000H0e3dI04IXcP16J<h0000004IXcP00000204IXcP0400000016J<h0000004IXcP@0000000D0
B6gF00000018KMH0000004Q]eP04000000040?m?8@000000odlQ00000080odlQ0P0000020?m?8@03
0000003oCb40?EV[0080000000@0odlQ0000003oD280oe0R0P0000050?m@8P800000100mFJ/0103o
D28000000000000000030?mA8P0403eIZ`3oDB80oe4R0?mA8P<000001@3oDB800`000000oe4Q03eI
Z`0303eIZ`H0oe4Q0`0mFJ/80?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h00`3o
m^h00`3D?AT0ooK^0?ofkP090?ofkP80e3dI2@3om^h0103D?AT0ooK^0?ofkP3D?AT50?ofkP030=@m
6@3om^h0ooK^03L0ooK^00<000000?ofkP3om^h04`3om^h00`000000ooK^0?ofkP0V0?ofkP40oooo
000W0?ofkP800000<03om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP0303eIZ`3om^h0?EV[0080?EV[3`3o
m^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^00H0ooK^0`0mFJ/40?ofkP0303eIZ`3o
m^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h0103om^h303eIZ`030?ofkP0mFJ/0ooK^00X0ooK^00@0
?EV[0?ofkP3om^h0ooK^1000000209@_5@040000000mFJ/0?EV[03eIZ`D000000P33?1X2000000<0
hT@M0`0000000`16J<h000000000000304IXcP<0000000<0e3dI04IXcP16J<h00`00000204IXcP<0
000000D0B6gF000000000000000004Q]eP07000000040?m=8@000000odlQ00000080odlQ00@00000
0?m?8@00000000000P3oCb420000000403eIZ`3oCb40odlQ0?m?8@800000103oD282000000<0?EV[
0P3oD28300000080oe0R00<000000?mA8P3oDB800P3oDB8203eIZ`030000003oDB80oe4R00D0oe4R
0`0mFJ/00`000000oe4Q0?mA8@030?mA8@@0?EV[00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^
0?ofkP080?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT03@3om^h00`3D?AT0ooK^0?ofkP070?ofkP05
0=@m6@3om^h0ooK^0?ofkP3D?AT0103om^h00`3D?AT0ooK^0?ofkP0g0?ofkP030000003om^h0ooK^
01<0ooK^00<000000?ofkP3om^h09P3om^h10?ooo`00:@3om^h00`000000ooK^0?ofkP0]0?ofkP03
03eIZ`3om^h0ooK^0100ooK^0`0mFJ/B0?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3o
m^h00`3om^h303eIZ`P0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`030?ofkP<0?EV[103om^h00`0m
FJ/0ooK^0?ofkP0:0?ofkP0403eIZ`3om^h0ooK^03eIZ`800000100mFJ/0102D;aD0000000000000
00020<<l6PH0000000@0hT@M00000000000000000P3RA1d600000080AVS>0P000000103D?AT00000
04IXcP16J<h30000000304Q]eP000000B6gF0080000000<0B6gF0000000000001P0000001@3oCB40
00000?m=8@000000odlQ00@0000000@0odlQ00000000000000000P3oCb400`000000?EV[00000002
0?m?8@040000003oD280oe0R000000<0?EV[00<0oe0R0000000000000P0000050?m@8P030000003o
DB80oe4R008000000P3oDB8203eIZ`80oe4R100mFJ/010000000oe4R0?mA8P0000020?mA8@<0?EV[
0`0000020?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h02P3om^h0103D?AT0ooK^
0?ofkP3D?AT=0?ofkP80e3dI203om^h00`3D?AT0ooK^0?ofkP020?ofkP050=@m6@3om^h0ooK^0?of
kP3D?AT0>P3om^h00`000000ooK^0?ofkP0B0?ofkP030000003om^h0ooK^02H0ooK^0@3oool002X0
ooK^0P00000]0?ofkP0303eIZ`3om^h0ooK^00d0ooK^0`0mFJ/00`3om^h0?EV[0?ofkP0C0?ofkP03
03eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP0mFJ/00P0mFJ/;0?ofkP0303eIZ`3om^h0ooK^0080
ooK^0`0mFJ/70?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h00`0mFJ/01@000000
L2<@000000000000U2lE00@000001@33?1X300000080hT@M00<0?EV[0>947@0000002000000204IX
cP050000003D?AT0000000000018KMH00`0000000`18KMH0000004Q]eP09000000050?m=8@000000
00000000003oCB400`0000000`3oCb400000000000020?m?8@<000000P3oCb400`0mFJ/0odlQ0000
000403eIZ`040?m@8P0000000000000000P0oe0R100000050?mA8P@0?EV[00<000000?mA8P3oDB80
0P3oDB8403eIZ`030?mA8@000000000000H0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^
0?ofkP0;0?ofkP80e3dI3@3om^h0103D?AT0ooK^0?ofkP3D?AT70?ofkP030=@m6@3om^h0ooK^00<0
ooK^00@0e3dI0?ofkP3om^h0e3dI>`3om^h00`000000ooK^0?ofkP0B0?ofkP030000003om^h0ooK^
02D0ooK^0@3oool002`0ooK^00<000000?ofkP3om^h0:`3om^h00`0mFJ/0ooK^0?ofkP090?ofkP<0
?EV[1@3om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^0140ooK^0`0mFJ/>0?ofkP03
03eIZ`3om^h0?EV[0080?EV[00<0ooK^03eIZ`3om^h01`3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP@0
?EV[0P3om^h300000004070S40000000U2lE09@_5@L000000`33?1X30000000503eIZ`0000000000
0000003RA1d02000000204Q]eP<0000000<0B6gF0000000000000P0000000`18KMH0000000000005
000000040?m=8@00000000000?m=8@80000000D0oddQ00000000000000000?m?8@03000000<0odlQ
0P00000303eIZ`030?m?8@0000000000008000001`3oD284000000<0oe0R0P00000403eIZ`040000
003oDB80oe4R0?mA8PH0?EV[100000090?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3o
m^h03@3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT01@3om^h00`3D
?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0e3dI03`0ooK^00<000000?ofkP3om^h04@3om^h00`00
0000ooK^0?ofkP0U0?ofkP40oooo000]0?ofkP800000:`3om^h00`0mFJ/0ooK^0?ofkP060?ofkP<0
?EV[203om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^00h0ooK^0`0mFJ/20?ofkP03
03eIZ`3om^h0ooK^00`0ooK^0P0mFJ/40?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3o
m^h01`3om^h303eIZ`80ooK^0P0mFJ/30?ofkPL000000P2D;aD200000080`c`J100000000`33?1X0
000003eIZ`0@0000000304Q]eP000000000001H000000P3oCb4400000080?EV[0P0000001@0mFJ/0
00000?m?8@3oCb40000000<0oe0R1@0000060?m@8P<0?EV[0P0000070?mA8P80?EV[00@000000=@m
6@00000000003@3om^h0103D?AT0ooK^0?ofkP3D?AT?0?ofkP030=@m6@3om^h0e3dI00/0ooK^00<0
e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0
e3dI0?ofkP3D?AT0?03om^h00`000000ooK^0?ofkP0A0?ofkP030000003om^h0ooK^02D0ooK^0@3o
ool002l0ooK^00<000000?ofkP3om^h0:03om^h00`0mFJ/0ooK^0?ofkP030?ofkP<0?EV[303om^h0
0`0mFJ/0ooK^0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^00X0ooK^0`0mFJ/50?ofkP0303eIZ`3om^h0
ooK^00`0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0
ooK^00D0ooK^0P0mFJ/60?ofkP0303eIZ`3om^h0?EV[00<0?EV[00D00000070S40000000000009@_
5@0200000080U2lE1@0000001@33?1X00000000000000000?EV[00<0hT@M9`000000103oCb40?EV[
03eIZ`0mFJ/2000000<0odlQ0P0mFJ/5000000L0oe0R100mFJ/01@000000oe0R0?m@8P3oD2800000
00<0oe4R0P00000203eIZ`80000000<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0=@m6@0?0?of
kP040=@m6@3om^h0ooK^0=@m6@X0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP02
0?ofkP030=@m6@3om^h0ooK^00H0ooK^0P3D?ATm0?ofkP030000003om^h0ooK^0100ooK^00<00000
0?ofkP3om^h09@3om^h10?ooo`00<03om^h2000002T0ooK^00<0?EV[0?ofkP0mFJ/00P0mFJ/?0?of
kP0303eIZ`3om^h0ooK^0180ooK^00<0?EV[0?ofkP3om^h01`3om^h303eIZ`T0ooK^00<0?EV[0?of
kP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?of
kP3om^h00P3om^h303eIZ`L0ooK^0`0mFJ/20?ofkP040000003om^h0ooK^00000080L2<@00<00000
09@_5@2D;aD00`0000040<<l6PD0000000<0?EV[0>947@0000000`00000303eIZb0000000P0mFJ/0
0`3oCb40000000000006000000050?m?8@0mFJ/0?EV[0?m?8@0000000`3oD282000000<0?EV[1P3o
D2860000000603QJ[000000000000=@m6@3om^h0e3dI4`3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP03
0=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP050?ofkP05
0=@m6@3om^h0ooK^0?ofkP3D?AT02@3om^h00`3D?AT0ooK^0?ofkP0l0?ofkP030000003om^h0ooK^
00l0ooK^00<000000?ofkP3om^h09@3om^h10?ooo`00<P3om^h00`000000ooK^0?ofkP0V0?ofkP80
?EV[4`3om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^00<0ooK^0`0mFJ/=0?ofkP03
03eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP040?ofkP03
03eIZ`3om^h0?EV[0080?EV[1`3om^h303eIZ`030?ofkP0mFJ/0?EV[0080ooK^00@000000?ofkP3o
m^h0ooK^2@0000070<<l6P040000000mFJ/0hT@M0>947@<0?EV[0P3RA1dT000000H0odlQ2P000002
03eIZ`030?m@8P000000000000H0000000<0AF_@000000000000100000030?ofkP030=@m6@3om^h0
ooK^0140ooK^00<0e3dI0?ofkP3D?AT03@3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0
ooK^00D0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0=@m6@0:0?ofkP030=@m6@3om^h0
ooK^03`0ooK^00<000000?ofkP3om^h03`3om^h00`000000ooK^0?ofkP0U0?ofkP40oooo000c0?of
kP030000003om^h0ooK^02H0ooK^00<0?EV[0?ofkP3om^h04@3om^h00`0mFJ/0ooK^0?ofkP0B0?of
kP0303eIZ`3om^h0ooK^00<0?EV[403om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^
00H0ooK^00<0?EV[0?ofkP3om^h00`3om^h203eIZ`L0ooK^0`0mFJ/40?ofkP0503eIZ`3om^h0?EV[
0?ofkP000000103om^h50000000309@_5@0000000000008000000`33?1X3000000<0?EV[0`3RA1di
0000000304E[d0000000000000P000001P3om^h00`3D?AT0ooK^0=@m6@0A0?ofkP050=@m6@3om^h0
ooK^0?ofkP3D?AT0303om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0
e3dI0?ofkP3om^h0203om^h20=@m6@X0ooK^00<0e3dI0?ofkP3om^h0?@3om^h00`000000ooK^0?of
kP0?0?ofkP030000003om^h0ooK^02@0ooK^0@3oool003@0ooK^0P00000V0?ofkP0303eIZ`3om^h0
ooK^0180ooK^00<0?EV[0?ofkP3om^h04@3om^h303eIZa@0ooK^00<0?EV[0?ofkP3om^h02@3om^h0
0`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00@0?EV[103om^h403eIZ`L0ooK^00D0?EV[
0?ofkP3om^h0?EV[000000060?ofkP040000001`8a000000000000<0U2lE1000000303eIZ`80`c`J
00<0?EV[0000003RA1d01@3RA1dI0000000304Y`g0000000000001H0000000<0e3dI000000000000
1@0000000`0hFZ`000000?ofkP070?ofkP80e3dI0`3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m
6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m
6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m
6@3om^h0ooK^03l0ooK^00<000000?ofkP3om^h03P3om^h00`000000ooK^0?ofkP0T0?ofkP40oooo
000f0?ofkP030000003om^h0ooK^02@0ooK^00<0?EV[0?ofkP3om^h04@3om^h00`0mFJ/0ooK^0?of
kP0>0?ofkP<0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0
?EV[0?ofkP3om^h01P3om^h303eIZ`<0ooK^00<0?EV[0?ofkP0mFJ/00P0mFJ/;0?ofkP0503eIZ`3o
m^h0ooK^0?ofkP0mFJ/01`3om^h200000003070S400000000000008000000`0mFJ/20<<l6P@00000
0P0mFJ/5000000<0hT@M100000000`3gBQl00000000000070000000304Y`g0000000000000<00000
0P1:L=`4000000030=@m6@19LM`0BG7L00@0BG7L1@0000000`3D?AT00000000000060000000304E[
d03D?AT0AF_@00@000002P3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00/0ooK^
00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00P0ooK^
00D0e3dI0?ofkP3om^h0ooK^0=@m6@0<0?ofkP80e3dI203om^h00`3D?AT0ooK^0?ofkP100?ofkP03
0000003om^h0ooK^00d0ooK^00<000000?ofkP3om^h0903om^h10?ooo`00=`3om^h2000002@0ooK^
00<0?EV[0?ofkP3om^h04P3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP<0?EV[1@3om^h00`0mFJ/0ooK^
0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h00P3om^h403eIZ`80ooK^
00<0?EV[0?ofkP3om^h00`0mFJ/>0?ofkP0603eIZ`3om^h0ooK^0?ofkP000000?EV[1`3om^h20000
00@0?EV[00<0U2lE0000000000001@0000030<<l6P0403eIZ`3RA1d0hT@M0>947@@0000000<0hT@M
00000000000030000000101:L=`000000000001:L=`4000000<0BG7L00<000000=@m6@0000001`00
00020=@m6@/0000000<0e3dI0000003om^h02`3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3o
m^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3o
m^h0ooK^00X0ooK^00@0e3dI0?ofkP3om^h0e3dI2`3om^h0103D?AT0ooK^0?ofkP3D?AT70?ofkP03
0=@m6@3om^h0ooK^0400ooK^00<000000?ofkP3om^h03@3om^h00`000000ooK^0?ofkP0T0?ofkP40
oooo000i0?ofkP030000003om^h0ooK^0280ooK^00<0?EV[0?ofkP3om^h04@3om^h00`0mFJ/0ooK^
0?ofkP070?ofkP<0?EV[2@3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^00L0ooK^
00<0?EV[0?ofkP0mFJ/00P0mFJ/60?ofkP<0?EV[00<0ooK^03eIZ`3om^h03@3om^h00`0mFJ/0ooK^
0?ofkP020?ofkP030000000mFJ/0ooK^00D0ooK^0`0mFJ/0101`8a00000000000000000409@_5@04
00000033?1X0`c`J0<<l6P@0000000@0?EV[000000000000hT@M100000020>947@80000000<0mdXO
0000000000001@000000101:L=`0000004Y`g01:L=`300000080BG7L1P0000000`3D?AT0BG7L04Ua
g00300000080e3dI300000020?ofkP030=@m6@3om^h0ooK^00P0ooK^0P3D?AT:0?ofkP030=@m6@3o
m^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3o
m^h0ooK^00/0ooK^0P3D?AT<0?ofkP040=@m6@3om^h0ooK^0=@m6@L0ooK^00<0e3dI0?ofkP3om^h0
@@3om^h00`000000ooK^0?ofkP0<0?ofkP030000003om^h0ooK^02@0ooK^0@3oool003X0ooK^0P00
000R0?ofkP0303eIZ`3om^h0ooK^0180ooK^00<0?EV[0?ofkP3om^h00`3om^h303eIZ`d0ooK^00<0
?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP040?ofkP@0?EV[1P3om^h303eIZ`80ooK^00<0
?EV[0?ofkP0mFJ/03P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP030000003om^h0?EV[0080ooK^1P0m
FJ/200000003070S40000000000000@000001@33?1X300000080?EV[00<000000>947@3RA1d00P3R
A1d200000080?EV[0P000000103gBQl000000000001:L=`20000000504Y`g0000000000000000019
LM`00`00000304Uag080000000@0?EV[04Uag0000000e3dI0P0000020=@m6@X000001`3om^h00`3D
?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D
?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D
?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D
?AT0ooK^0?ofkP130?ofkP030000003om^h0ooK^00`0ooK^00<000000?ofkP3om^h08`3om^h10?oo
o`00?03om^h00`000000ooK^0?ofkP0P0?ofkP0303eIZ`3om^h0ooK^0140ooK^00<0?EV[0?ofkP3o
m^h00`0mFJ/@0?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h0100mFJ/20?ofkP03
03eIZ`3om^h0ooK^0080ooK^0`0mFJ/60?ofkP80?EV[3P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP03
0000003om^h0?EV[00@0?EV[103om^h00`0mFJ/000000000000300000080U2lE1P0000040<<l6P04
0000000mFJ/0hT@M000000@0?EV[00@000000>947@000000hT@M200000001P19LM`0000004Uag019
LM`0000004Uag08000000`19LM`3000000<0e3dI00@0AF_@03eIZ`15Jm00AF_@0`00000=0?ofkP03
0=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP030?ofkP03
0=@m6@3om^h0ooK^00`0ooK^00@0e3dI0?ofkP3om^h0e3dI3`3om^h00`3D?AT0ooK^0=@m6@0:0?of
kP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP140?of
kP030000003om^h0ooK^00/0ooK^00<000000?ofkP3om^h08`3om^h10?ooo`00?@3om^h200000200
ooK^00<0?EV[0?ofkP3om^h04@3om^h303eIZa@0ooK^00<0?EV[0?ofkP3om^h04P3om^h303eIZ`H0
ooK^00<0?EV[0?ofkP0mFJ/00P0mFJ/90?ofkP80?EV[3P3om^h0100mFJ/0ooK^0?ofkP3om^h603eI
Z`H0ooK^00H0?EV[0?ofkP0000000000070S403D?AT30000000309@_5@000000000000@0`c`J1000
000203eIZ`030>947@00000000000080hT@M00<000000>947@0000000P00000204Uag080000000@0
e3dI00000019LM`000000`19LM`00`000000BG7L04Uag002000000@0e3dI0P15Jm000`3D?AT00000
0000000300000100ooK^00@0e3dI0?ofkP3om^h0ooK^0P3D?ATA0?ofkP050=@m6@3om^h0ooK^0?of
kP3D?AT0403om^h00`3D?AT0ooK^0=@m6@0?0?ofkP040=@m6@3om^h0ooK^0=@m6@P0ooK^00<0e3dI
0?ofkP3om^h01@3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI04H0ooK^00<000000?ofkP3om^h02`3o
m^h00`000000ooK^0?ofkP0S0?ofkP40oooo000o0?ofkP030000003om^h0ooK^01h0ooK^00<0?EV[
0?ofkP3om^h0303om^h403eIZ`80ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP0>
0?ofkP<0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP040?ofkP80?EV[3@3om^h00`0mFJ/0ooK^0?ofkP0<
0?ofkPH0?EV[103om^h203eIZ`@0ooK^00@0?EV[0?ofkP3om^h0ooK^0P0000000`1`8a00e3dI0=@m
6@07000000<0?EV[00@0`c`J0000000mFJ/000000P3RA1d20000000@0>947@000000000004Uag000
0000BG7L00000019LM`0000004Uag03D?AT0000004Uag0000000?EV[04Uag08000000`3D?AT204E[
d0D0000000<0e3dI0000003om^h04`3om^h00`3D?AT0ooK^0=@m6@0D0?ofkP030=@m6@3om^h0e3dI
0180ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^
00D0ooK^00<0e3dI0?ofkP3om^h01P3om^h0103D?AT0ooK^0?ofkP3D?AU70?ofkP030000003om^h0
ooK^00X0ooK^00<000000?ofkP3om^h08`3om^h10?ooo`00@03om^h2000001h0ooK^00<0?EV[0?of
kP3om^h02@3om^h303eIZ`H0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP0;0?of
kP<0?EV[1P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?of
kP0mFJ/02P3om^h503eIZ`<0ooK^00<000000?ofkP3om^h0103om^h0100mFJ/0ooK^0?ofkP0mFJ/5
0?ofkP@00000102D;aD303eIZ`040<<l6P000000000000000080`c`J0P0mFJ/01@000000hT@M0>94
7@000000hT@M008000000P19LM`01P000000BG7L00000019LM`000000=@m6@800000103D?AT00`15
Jm0000000000000600000080ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP0D0?of
kP030=@m6@3om^h0ooK^0100ooK^00<0e3dI0?ofkP3D?AT03@3om^h00`3D?AT0ooK^0?ofkP040?of
kP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0=@m6@190?of
kP030000003om^h0ooK^00T0ooK^00<000000?ofkP3om^h08`3om^h10?ooo`00@P3om^h00`000000
ooK^0?ofkP0L0?ofkP0303eIZ`3om^h0ooK^00@0ooK^100mFJ/:0?ofkP0303eIZ`3om^h0ooK^01<0
ooK^00<0?EV[0?ofkP3om^h01`3om^h303eIZ`X0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0
ooK^0?ofkP0;0?ofkP0403eIZ`3om^h0ooK^03eIZ`H0ooK^1@0mFJ/00`3om^h0?EV[0?ofkP030?of
kP030000003om^h0ooK^00D0ooK^00<0?EV[0?ofkP0mFJ/01P3om^h00`000000L2<@0000000403eI
Z`040000003D?AT00000000000H0`c`J00/0000003eIZ`0mFJ/000000>947@000000BG7L00000019
LM`0000004Uag002000000D0e3dI00D0AF_@000000000000?EV[04E[d005000000H0ooK^00<0e3dI
0?ofkP3om^h0403om^h20=@m6@030?ofkP3D?AT0ooK^01<0ooK^00<0e3dI0?ofkP3D?AT0403om^h0
1@3D?AT0ooK^0?ofkP3om^h0e3dI00`0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?of
kP030?ofkP030=@m6@3om^h0ooK^00P0ooK^0P3D?AU90?ofkP030000003om^h0ooK^00X0ooK^00<0
00000?ofkP3om^h08P3om^h10?ooo`00@`3om^h2000001`0ooK^00<0?EV[0?ofkP3om^h0100mFJ/?
0?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h00`3om^h303eIZ`h0ooK^00@0?EV[
0?ofkP3om^h0?EV[3P3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[0080ooK^1@0mFJ/30?ofkP0303eI
Z`3om^h0ooK^00<0ooK^00<000000?ofkP3om^h01P3om^h203eIZ`H0ooK^0`0mFJ/00`1`8a000000
09@_5@0409@_5@0300000033?1X0`c`J0080`c`J0`0000001P3RA1d000000>947@000000BG7L0000
00H0e3dI0`15Jm0010000000e3dI04E[d015Jm05000000X0ooK^00<0e3dI0?ofkP3om^h03@3om^h2
0=@m6@@0ooK^00<0e3dI0?ofkP3om^h03`3om^h20=@m6@<0ooK^00<0e3dI0?ofkP3om^h0303om^h0
0`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h01P3om^h0
1@3D?AT0ooK^0?ofkP3om^h0e3dI00`0ooK^00<0e3dI0?ofkP3om^h0B03om^h00`000000ooK^0?of
kP090?ofkP030000003om^h0ooK^0280ooK^0@3oool004D0ooK^00<000000?ofkP3om^h06P3om^h2
03eIZa<0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP0303eIZa40ooK^00@0?EV[
0?ofkP3om^h0?EV[3P3om^h0100mFJ/0ooK^0?ofkP3om^h503eIZ`H0ooK^00<0?EV[0?ofkP3om^h0
0`3om^h00`000000ooK^0?ofkP070?ofkP80?EV[0P3om^h303eIZ`80ooK^0P0000000`1`8a000000
09@_5@0309@_5@0300000033?1X0`c`J008000000`33?1X00`000000hT@M0>947@040000000504E[
d0000000AF_@04E[d00000000P15Jm0010000000?EV[0000003D?AT2000000030?ofkP3D?AT0ooK^
00`0ooK^0P3D?AT;0?ofkP80e3dI1`3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^
00@0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^
00H0ooK^00<0e3dI0?ofkP3om^h0203om^h0103D?AT0ooK^0?ofkP3D?AT<0?ofkP030=@m6@3om^h0
ooK^04T0ooK^00<000000?ofkP3om^h0203om^h00`000000ooK^0?ofkP0R0?ofkP40oooo00160?of
kP8000006`3om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^0180ooK^0`0mFJ/E0?of
kP0303eIZ`3om^h0?EV[00h0ooK^1@0mFJ/00`3om^h0?EV[0?ofkP070?ofkP0303eIZ`3om^h0ooK^
00<0ooK^00<000000?ofkP3om^h01P3om^h00`0mFJ/0ooK^03eIZ`0203eIZ`H0ooK^2P0000040<<l
6P030000000mFJ/0000000<000000P15Jm0010000000AF_@04E[d00mFJ/500000080ooK^00@0e3dI
0?ofkP3om^h0e3dI3`3om^h00`3D?AT0ooK^0?ofkP060?ofkP80e3dI2P3om^h00`3D?AT0ooK^0?of
kP0;0?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?of
kP060?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h02P3om^h20=@m6@`0ooK^00<0
e3dI0?ofkP3om^h0B`3om^h00`000000ooK^0?ofkP070?ofkP030000003om^h0ooK^0280ooK^0@3o
ool004P0ooK^00<000000?ofkP3om^h0603om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0
ooK^00h0ooK^0`0mFJ/20?ofkP0303eIZ`3om^h0ooK^01@0ooK^0P0mFJ/;0?ofkPD0?EV[1@3om^h2
03eIZ`D0ooK^00<0?EV[0?ofkP3om^h0103om^h00`000000ooK^0?ofkP050?ofkP<0?EV[0P3om^h2
03eIZ`H0ooK^0P0000000`1`8a00000009@_5@0309@_5@800000100mFJ/01@33?1X0000004E[d015
Jm00e3dI0080AF_@0`000000100hFZ`000000000003D?AT50?ofkP030=@m6@3om^h0e3dI0100ooK^
00<0e3dI0?ofkP3om^h00`3om^h20=@m6@d0ooK^00<0e3dI0?ofkP3om^h0203om^h20=@m6@T0ooK^
00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00@0ooK^
00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^04/0ooK^
00<000000?ofkP3om^h01`3om^h00`000000ooK^0?ofkP0R0?ofkP40oooo00190?ofkP030000003o
m^h0ooK^01P0ooK^00<0?EV[0?ofkP3om^h04P3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP<0?EV[1P3o
m^h00`0mFJ/0ooK^0?ofkP0D0?ofkP0303eIZ`3om^h0ooK^00D0ooK^1P0mFJ/00`3om^h0?EV[0?of
kP070?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h0103om^h010000000ooK^0?of
kP3om^h503eIZ`H0ooK^0P0mFJ/50?ofkP0303eIZ`000000000000800000100mFJ/01@000000`c`J
0<<l6P33?1X000000080AF_@00D0000004E[d03D?AT0000003QJ[002000000050=@m6@3om^h0ooK^
0?ofkP3D?AT01@3om^h00`3D?AT0ooK^0?ofkP0@0?ofkP030=@m6@3om^h0ooK^0080e3dI403om^h0
0`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h01@3om^h0
0`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h02`3om^h0
0`3D?AT0ooK^0=@m6@0:0?ofkP030=@m6@3om^h0ooK^04d0ooK^00<000000?ofkP3om^h01`3om^h0
0`000000ooK^0?ofkP0Q0?ofkP40oooo001:0?ofkP8000006@3om^h00`0mFJ/0ooK^0?ofkP0B0?of
kP0303eIZ`3om^h0ooK^00L0ooK^0`0mFJ/:0?ofkP0303eIZ`3om^h0ooK^01<0ooK^0P0mFJ/20?of
kPL0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/01P3om^h0
0`000000?EV[03eIZ`0203eIZ`<0ooK^00<0?EV[0?ofkP3om^h01P3om^h203eIZ`80ooK^1P0mFJ/3
00000080U2lE00@000000<<l6P000000AF_@100000000`0hFZ`0e3dI000000030?ofkP050=@m6@3o
m^h0ooK^0?ofkP3D?AT0103om^h30=@m6A00ooK^0`3D?ATC0?ofkP030=@m6@3om^h0ooK^00@0ooK^
00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00`0ooK^
00@0e3dI0?ofkP3om^h0e3dI3P3om^h0103D?AT0ooK^0?ofkP3D?AT90?ofkP030=@m6@3om^h0ooK^
04h0ooK^00<000000?ofkP3om^h01P3om^h00`000000ooK^0?ofkP0Q0?ofkP40oooo001<0?ofkP03
0000003om^h0ooK^01L0ooK^00<0?EV[0?ofkP3om^h04P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP<0
?EV[3P3om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP0303eIZ`3om^h0?EV[00H0?EV[1P3om^h00`0mFJ/0
ooK^0?ofkP090?ofkP80?EV[00<0ooK^03eIZ`3om^h00`3om^h303eIZ`H0ooK^00<0?EV[0?ofkP3o
m^h0203om^h603eIZ`060?ofkP0000000000070S40000000U2lE0P0mFJ/00`2D;aD0000000000004
000000040=@m6@3om^h0ooK^0=@m6@<0ooK^00<0e3dI0?ofkP3om^h00P3om^h01@3D?AT0ooK^0?of
kP3om^h0e3dI0080ooK^00<0e3dI0?ofkP3om^h02@3om^h40=@m6@80ooK^00<0e3dI0?ofkP3om^h0
4P3om^h0103D?AT0ooK^0?ofkP3om^h20=@m6A00ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0@0?of
kP030=@m6@3om^h0e3dI00d0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@080?ofkP030=@m6@3om^h0
ooK^04l0ooK^00<000000?ofkP3om^h01P3om^h00`000000ooK^0?ofkP0Q0?ofkP40oooo001=0?of
kP8000005`3om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^00<0?EV[4@3om^h00`0m
FJ/0ooK^0?ofkP0@0?ofkPH0?EV[2P3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0?EV[
00<0?EV[0P3om^h00`000000ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00H0ooK^100mFJ/00`3o
m^h0?EV[0?ofkP020?ofkPL0?EV[00@000000=@m6@3D?AT0e3dI0`3om^h00`3D?AT0ooK^0=@m6@02
0?ofkP80e3dI00<0ooK^0=@m6@3om^h0103om^h20=@m6@030?ofkP3D?AT0ooK^0080ooK^00<0e3dI
0?ofkP3om^h01@3om^h30=@m6@L0ooK^00<0e3dI0?ofkP3om^h04P3om^h00`3D?AT0ooK^0=@m6@0C
0?ofkP030=@m6@3om^h0e3dI0180ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP02
0?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h0D03om^h00`000000ooK^0?ofkP05
0?ofkP030000003om^h0ooK^0240ooK^0@3oool004l0ooK^00<000000?ofkP3om^h05@3om^h00`0m
FJ/0ooK^0?ofkP0A0?ofkP<0?EV[5@3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP<0?EV[00<0ooK^03eI
Z`0mFJ/00`3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00/0ooK^100mFJ/50?of
kP030000003om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h00`3om^h403eIZ`<0ooK^00@0?EV[0?of
kP3om^h0ooK^100mFJ/20?ofkP030=@m6@000000000000L0e3dI0P3om^h0103D?AT0ooK^0?ofkP3o
m^h20=@m6@L0ooK^0P3D?AT40?ofkP030=@m6@3om^h0ooK^00@0e3dI2`3om^h00`3D?AT0ooK^0?of
kP0B0?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h0403om^h00`3D?AT0ooK^0=@m
6@0<0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?of
kP1B0?ofkP030000003om^h0ooK^00@0ooK^00<000000?ofkP3om^h08@3om^h10?ooo`00D03om^h2
000001H0ooK^00<0?EV[0?ofkP3om^h0303om^h403eIZ`80ooK^00<0?EV[0?ofkP3om^h0503om^h0
0`0mFJ/0ooK^0?ofkP080?ofkP<0?EV[103om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0
ooK^00D0ooK^00<0?EV[0?ofkP3om^h0203om^h403eIZ`<0ooK^0P0mFJ/20?ofkP030000003om^h0
ooK^00<0ooK^00@0?EV[0?ofkP3om^h0ooK^100mFJ/50?ofkP0303eIZ`3om^h0ooK^00<0?EV[1P3o
m^h00`3D?AT0ooK^0?ofkP020=@m6@030?ofkP3D?AT0ooK^00H0e3dI0P3om^h00`3D?AT0ooK^0?of
kP060?ofkPP0e3dI403om^h00`3D?AT0ooK^0?ofkP0?0?ofkP80e3dI00<0ooK^0=@m6@3om^h04P3o
m^h00`3D?AT0ooK^0=@m6@0@0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT02P3om^h00`3D?AT0ooK^
0?ofkP060?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h0D`3om^h00`000000ooK^
0?ofkP040?ofkP030000003om^h0ooK^0200ooK^0@3oool00580ooK^00<000000?ofkP3om^h0503o
m^h00`0mFJ/0ooK^0?ofkP080?ofkP<0?EV[1`3om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP0303eIZ`3o
m^h0ooK^00@0ooK^0`0mFJ/60?ofkP0303eIZ`3om^h0ooK^00D0ooK^0P0mFJ/50?ofkP0303eIZ`3o
m^h0ooK^00D0ooK^100mFJ/20?ofkP0303eIZ`3om^h0ooK^00<0ooK^0P0mFJ/00`000000ooK^0?of
kP030?ofkPD0?EV[1`3om^h403eIZ`X0ooK^0P3D?AT01`3om^h0e3dI0=@m6@3om^h0e3dI0?ofkP3D
?AT0103om^h<0=@m6@H0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP80
e3dI103om^h00`3D?AT0ooK^0?ofkP0>0?ofkP80e3dI0`3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP03
0=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP070?ofkP04
0=@m6@3om^h0ooK^0=@m6EH0ooK^00<000000?ofkP3om^h0103om^h00`000000ooK^0?ofkP0P0?of
kP40oooo001C0?ofkP800000503om^h00`0mFJ/0ooK^0?ofkP050?ofkP<0?EV[2`3om^h00`0mFJ/0
ooK^0?ofkP0D0?ofkP0303eIZ`3om^h0ooK^00<0?EV[2@3om^h00`0mFJ/0ooK^0?ofkP070?ofkP03
03eIZ`3om^h0ooK^0080ooK^00@0?EV[0?ofkP3om^h0ooK^1@0mFJ/40?ofkP0303eIZ`3om^h0ooK^
00H0ooK^0P0mFJ/20?ofkP@0?EV[1`3om^h403eIZ`h0ooK^0`3D?AT01P3om^h0e3dI0=@m6@3D?AT0
ooK^0=@m6@@0ooK^00@0e3dI0?ofkP3D?AT0e3dI1P3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m
6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h02@3om^h20=@m6@L0ooK^00<0e3dI0?ofkP3om^h0
303om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h0
1@3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00P0ooK^00@0e3dI0?ofkP3om^h0
e3dIE`3om^h00`000000ooK^0?ofkP030?ofkP030000003om^h0ooK^0200ooK^0@3oool005D0ooK^
00<000000?ofkP3om^h04P3om^h00`0mFJ/0ooK^0?ofkP0403eIZ`l0ooK^00<0?EV[0?ofkP3om^h0
4`3om^h303eIZ``0ooK^00<0?EV[0?ofkP3om^h0203om^h01@0mFJ/0ooK^0?ofkP0mFJ/0ooK^00D0
?EV[1`3om^h00`0mFJ/0ooK^0?ofkP060?ofkP030000000mFJ/0?EV[00@0?EV[1@3om^h403eIZa<0
ooK^0P3D?AT20?ofkP<0e3dI1@3om^h20=@m6@030?ofkP3D?AT0ooK^00@0ooK^00<0e3dI0?ofkP3o
m^h01P3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00H0ooK^0P3D?AT:0?ofkP03
0=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP080?ofkP03
0=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP80
e3dIF@3om^h00`000000ooK^0?ofkP020?ofkP030000003om^h0ooK^0200ooK^0@3oool005H0ooK^
0P00000C0?ofkP80?EV[4`3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP<0?EV[0P3om^h00`0mFJ/0ooK^
0?ofkP090?ofkP0303eIZ`3om^h0ooK^00X0ooK^1P0mFJ/90?ofkP0303eIZ`3om^h0ooK^00D0ooK^
100mFJ/00`3om^h0?EV[0?ofkP020?ofkPD0?EV[603om^h20=@m6@80ooK^0`3D?AT50?ofkP040=@m
6@3om^h0ooK^0=@m6@@0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP03
0=@m6@3om^h0ooK^00<0ooK^0P3D?AT=0?ofkP80e3dI203om^h20=@m6@T0ooK^00<0e3dI0?ofkP3o
m^h01`3om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3o
m^h02`3om^h00`3D?AT0ooK^0?ofkP1H0?ofkP050000003om^h0ooK^0?ofkP0000008P3om^h10?oo
o`00F03om^h00`000000ooK^0?ofkP0A0?ofkP0303eIZ`3om^h0ooK^0180ooK^00<0?EV[0?ofkP3o
m^h0303om^h303eIZ`H0ooK^0P0mFJ/90?ofkP0303eIZ`3om^h0ooK^00P0ooK^1@0mFJ/<0?ofkP04
03eIZ`3om^h0ooK^0?ofkP@0?EV[0P3om^h00`000000ooK^03eIZ`020?ofkP@0?EV[703om^h30=@m
6@040?ofkP3D?AT0e3dI0=@m6@@0ooK^0P3D?AT20?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT02P3o
m^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^0080e3dI4@3om^h00`3D?AT0ooK^0?of
kP040?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?of
kP0;0?ofkP040=@m6@3om^h0ooK^0=@m6@d0ooK^00<0e3dI0?ofkP3om^h0F@3om^h01@000000ooK^
0?ofkP3om^h000000280ooK^0@3oool005T0ooK^0P00000B0?ofkP0303eIZ`3om^h0ooK^0180ooK^
00<0?EV[0?ofkP3om^h0203om^h303eIZ`/0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^
0?ofkP050?ofkPD0?EV[00<0ooK^03eIZ`3om^h00`0mFJ/80?ofkP0303eIZ`3om^h0?EV[00<0?EV[
1@3om^h00`000000?EV[03eIZ`0303eIZb00ooK^00<0e3dI0?ofkP3D?AT00P3D?AT00`3om^h0e3dI
0?ofkP030?ofkP80e3dI0P3om^h20=@m6@030?ofkP3D?AT0ooK^00X0ooK^00<0e3dI0?ofkP3om^h0
3P3om^h30=@m6A@0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m
6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0=@m6@0=0?ofkP030=@m
6@3om^h0ooK^05X0ooK^00D000000?ofkP3om^h0ooK^0000000Q0?ofkP40oooo001K0?ofkP030000
003om^h0ooK^0100ooK^00<0?EV[0?ofkP3om^h04P3om^h00`0mFJ/0ooK^0?ofkP040?ofkP<0?EV[
3`3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0403eIZ`3om^h0ooK^0?ofkPD0?EV[103om^h00`0mFJ/0
ooK^0?ofkP030?ofkP<0?EV[0`3om^h403eIZ`P0ooK^0`0mFJ/U0?ofkP030=@m6@3om^h0ooK^0080
e3dI00<0ooK^0=@m6@3om^h00P3om^h00`3D?AT0ooK^0=@m6@030?ofkP030=@m6@3om^h0e3dI00/0
ooK^00<0e3dI0?ofkP3om^h02@3om^h40=@m6@80ooK^00<0e3dI0?ofkP3om^h04`3om^h0103D?AT0
ooK^0=@m6@3D?AT@0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT04@3om^h00`3D?AT0ooK^0?ofkP0;
0?ofkP030=@m6@3om^h0ooK^05`0ooK^00@000000?ofkP3om^h000008@3om^h10?ooo`00G03om^h0
0`000000ooK^0?ofkP0@0?ofkP0303eIZ`3om^h0ooK^0180ooK^00<0?EV[0?ofkP3om^h00`0mFJ/C
0?ofkP80?EV[103om^h00`0mFJ/0ooK^03eIZ`0403eIZ`H0ooK^00<0?EV[0?ofkP3om^h01`3om^h5
03eIZ`H0ooK^100mFJ/00`3om^h000000?ofkP0V0?ofkP030=@m6@3om^h0ooK^00@0e3dI0P3om^h0
0`3D?AT0ooK^0?ofkP020=@m6@80ooK^0P3D?AT<0?ofkP030=@m6@3om^h0ooK^00D0ooK^0`3D?AT7
0?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h04@3om^h00`3D?AT0ooK^0=@m6@0A
0?ofkP030=@m6@3om^h0e3dI00/0ooK^00<0e3dI0?ofkP3om^h0G@3om^h010000000ooK^0?ofkP00
000Q0?ofkP40oooo001M0?ofkP800000403om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP<0?EV[603om^h0
0`0mFJ/0ooK^0?ofkP0403eIZ`X0ooK^00<0?EV[0?ofkP3om^h0103om^h303eIZ`<0ooK^00<0?EV[
0?ofkP0mFJ/01@0mFJ/50?ofkP030000003om^h0ooK^02H0ooK^0P3D?AT00`3om^h0e3dI0=@m6@04
0=@m6@@0ooK^00@0e3dI0?ofkP3om^h0e3dI3@3om^h00`3D?AT0ooK^0?ofkP040=@m6@/0ooK^00<0
e3dI0?ofkP3om^h0403om^h20=@m6@030?ofkP3D?AT0ooK^0180ooK^00<0e3dI0?ofkP3om^h03`3o
m^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00X0ooK^00<0e3dI0?ofkP3om^h0GP3om^h00`000000ooK^
0000000Q0?ofkP40oooo001O0?ofkP030000003om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h03@3o
m^h403eIZ`80ooK^0P0mFJ/G0?ofkP@0?EV[303om^h00`0mFJ/0ooK^0?ofkP020?ofkP<0?EV[103o
m^h203eIZ`030?ofkP0mFJ/0?EV[0080?EV[203om^h00`000000ooK^0?ofkP0W0?ofkP80e3dI00<0
ooK^0=@m6@3D?AT00P3D?AT00`3om^h0e3dI0=@m6@040=@m6@030?ofkP3D?AT0e3dI00L0ooK^203D
?AT@0?ofkP030=@m6@3om^h0ooK^00d0ooK^0P3D?AT40?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0
e3dI0?ofkP3D?AT03`3om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0
e3dI0?ofkP3om^h0H03om^h200000240ooK^0@3oool00600ooK^0P00000?0?ofkP0303eIZ`3om^h0
ooK^00T0ooK^0`0mFJ/80?ofkP80?EV[4@3om^h403eIZ`<0ooK^0P0mFJ/;0?ofkPD0?EV[1P3om^h5
03eIZ`/0ooK^00<000000?ofkP3om^h0:03om^h30=@m6@80ooK^0`3D?AT50?ofkPX0e3dI1`3om^h0
0`3D?AT0ooK^0?ofkP0?0?ofkP80e3dI2`3om^h20=@m6@L0ooK^00<0e3dI0?ofkP3om^h0303om^h2
0=@m6@<0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0
ooK^00@0ooK^00<0e3dI0?ofkP3om^h0HP3om^h200000200ooK^0@3oool00680ooK^00<000000?of
kP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP050?ofkP<0?EV[3@3om^h00`0mFJ/0ooK^0?ofkP0;0?of
kP<0?EV[1P3om^h00`0mFJ/0ooK^0?ofkP0203eIZ`L0ooK^100mFJ/60?ofkP@0?EV[3`3om^h00`00
0000ooK^0?ofkP0Z0?ofkP80e3dI0P3om^h20=@m6@H0ooK^00@0e3dI0?ofkP3om^h0e3dI3@3om^h0
0`3D?AT0ooK^0?ofkP0@0?ofkP030=@m6@3om^h0ooK^00H0ooK^0P3D?AT:0?ofkP030=@m6@3om^h0
ooK^00X0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0
ooK^00H0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP1R0?ofkP800000803om^h1
0?ooo`00H`3om^h2000000h0ooK^00<0?EV[0?ofkP3om^h0100mFJ/A0?ofkP80?EV[203om^h303eI
Z`P0ooK^00<0?EV[0?ofkP3om^h00`3om^h203eIZ`80ooK^100mFJ/50?ofkPD0?EV[4P3om^h00`00
0000ooK^0?ofkP0[0?ofkP80e3dI0P3om^h20=@m6@D0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0=
0?ofkP030=@m6@3om^h0ooK^0100ooK^00<0e3dI0?ofkP3om^h00`3om^h20=@m6@`0ooK^00<0e3dI
0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI
0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^06<0ooK^0P00000P
0?ofkP40oooo001U0?ofkP030000003om^h0ooK^00`0ooK^0P0mFJ/G0?ofkP80?EV[0P3om^h403eI
Z`/0ooK^00<0?EV[0?ofkP3om^h0103om^h=03eIZaH0ooK^00<000000?ofkP3om^h0;03om^h30=@m
6@040?ofkP3D?AT0e3dI0=@m6@@0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0=0?ofkP030=@m6@3o
m^h0ooK^0100ooK^00<0e3dI0?ofkP3om^h00P3D?AT?0?ofkP030=@m6@3om^h0ooK^00H0ooK^0P3D
?AT:0?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h02P3om^h0103D?AT0ooK^0?of
kP3D?AUR0?ofkP@000008P3om^h10?ooo`00IP3om^h2000000d0ooK^00<0?EV[0?ofkP3om^h05P3o
m^h303eIZ`h0ooK^00@0?EV[0?ofkP3om^h0ooK^1@0mFJ/20?ofkP80?EV[00<0ooK^03eIZ`0mFJ/0
0P0mFJ/I0?ofkP030000003om^h0ooK^02d0ooK^00<0e3dI0?ofkP3D?AT00P3D?AT00`3om^h0e3dI
0?ofkP020?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h02`3om^h20=@m6A00ooK^
0`3D?ATB0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^
0?ofkP030?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3D?AT0GP3om^h4000002H0ooK^
0@3oool006P0ooK^00<000000?ofkP3om^h02`3om^h203eIZa<0ooK^0`0mFJ/30?ofkP80?EV[303o
m^h503eIZ`D0ooK^1@0mFJ/L0?ofkP030000003om^h0ooK^02h0ooK^00<0e3dI0?ofkP3om^h0103D
?AT30?ofkP030=@m6@3om^h0ooK^0080ooK^0P3D?AT=0?ofkP030=@m6@3om^h0ooK^00T0ooK^103D
?AT20?ofkP030=@m6@3om^h0ooK^0140ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?of
kP0=0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT0403om^h00`3D?AT0ooK^0?ofkP1I0?ofkP@00000
:P3om^h10?ooo`00J@3om^h2000000d0ooK^00<0?EV[0?ofkP3om^h03@3om^h303eIZ`P0ooK^0P0m
FJ/90?ofkP<0?EV[1P3om^h303eIZb00ooK^00<000000?ofkP3om^h0;`3om^h20=@m6@030?ofkP3D
?AT0e3dI0080e3dI0P3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0
e3dI0?ofkP3om^h01@3om^h30=@m6@L0ooK^00<0e3dI0?ofkP3om^h04@3om^h0103D?AT0ooK^0=@m
6@3D?ATA0?ofkP030=@m6@3om^h0e3dI0100ooK^00<0e3dI0?ofkP3om^h0EP3om^h4000002h0ooK^
0@3oool006/0ooK^00<000000?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP090?ofkP<0?EV[3@3o
m^h203eIZ`<0ooK^100mFJ/50?ofkPD0?EV[8P3om^h00`000000ooK^0?ofkP0`0?ofkP80e3dI00<0
ooK^0=@m6@3om^h0103D?AT70?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h0103D
?AT;0?ofkP030=@m6@3om^h0ooK^0100ooK^0P3D?ATD0?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0
e3dI0?ofkP3om^h0D`3om^h400000380ooK^0@3oool006`0ooK^0P00000<0?ofkP80?EV[1P3om^h3
03eIZa80ooK^1@0mFJ/40?ofkPD0?EV[9@3om^h00`000000ooK^0?ofkP0a0?ofkP80e3dI00<0ooK^
0=@m6@3om^h00P3D?AT00`3om^h0e3dI0=@m6@040=@m6@80ooK^00<0e3dI0?ofkP3om^h01@3om^h8
0=@m6A00ooK^00<0e3dI0?ofkP3om^h03@3om^h20=@m6@80ooK^00<0e3dI0?ofkP3om^h03`3om^h2
0=@m6@030?ofkP3D?AT0ooK^00d0ooK^00<0e3dI0?ofkP3om^h0D03om^h4000003H0ooK^0@3oool0
06h0ooK^00<000000?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP0303eIZa40ooK^100mFJ/30?of
kP0303eIZ`3om^h0?EV[00D0?EV[:03om^h00`000000ooK^0?ofkP0c0?ofkP040=@m6@3om^h0e3dI
0?ofkP<0e3dI1@3om^h:0=@m6@L0ooK^00<0e3dI0?ofkP3om^h03`3om^h20=@m6@/0ooK^0P3D?AT5
0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP0:
0?ofkP030=@m6@3om^h0ooK^04d0ooK^1000000j0?ofkP40oooo001_0?ofkP030000003om^h0ooK^
00/0ooK^0P0mFJ/A0?ofkP<0?EV[1@3om^h703eIZb/0ooK^00<000000?ofkP3om^h0=03om^h20=@m
6@<0ooK^0P3D?AT80?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h0403om^h00`3D
?AT0ooK^0?ofkP060?ofkP80e3dI203om^h00`3D?AT0ooK^0?ofkP0:0?ofkP80e3dI1P3om^h00`3D
?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^04X0ooK^1000000n0?ofkP40oooo001`0?ofkP80
00003@3om^h303eIZ`/0ooK^0`0mFJ/60?ofkPD0?EV[;`3om^h00`000000ooK^0?ofkP0e0?ofkP80
e3dI0`3om^h20=@m6@P0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP0@0?ofkP03
0=@m6@3om^h0ooK^00<0ooK^0P3D?AT;0?ofkP80e3dI2@3om^h00`3D?AT0ooK^0?ofkP070?ofkP80
e3dI1`3om^h00`3D?AT0ooK^0?ofkP170?ofkP@00000@P3om^h10?ooo`00LP3om^h00`000000ooK^
0?ofkP0=0?ofkP@0?EV[0`3om^h403eIZ`L0ooK^100mFJ/a0?ofkP030000003om^h0ooK^03L0ooK^
103D?AT00`3om^h0e3dI0=@m6@080?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h0
403om^h00`3D?AT0ooK^0?ofkP020=@m6@l0ooK^00<0e3dI0?ofkP3om^h0103om^h20=@m6@`0ooK^
00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP140?ofkP@00000AP3om^h10?ooo`00L`3o
m^h200000140ooK^1@0mFJ/60?ofkP@0?EV[=03om^h00`000000ooK^0?ofkP0h0?ofkP80e3dI00@0
ooK^0=@m6@3D?AT0ooK^0P3D?AT70?ofkP030=@m6@3om^h0ooK^00/0ooK^0P3D?AT@0?ofkP<0e3dI
4P3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00d0ooK^00D0e3dI0?ofkP3om^h0
ooK^0=@m6@130?ofkP@00000BP3om^h10?ooo`00M@3om^h00`000000ooK^0?ofkP0C0?ofkPH0?EV[
>03om^h00`000000ooK^0?ofkP0j0?ofkP030=@m6@3om^h0ooK^00@0e3dI1`3om^h20=@m6@d0ooK^
00<0e3dI0?ofkP3om^h02@3om^h40=@m6@80ooK^00<0e3dI0?ofkP3om^h04@3om^h0103D?AT0ooK^
0=@m6@3D?ATA0?ofkP030=@m6@3om^h0e3dI0400ooK^1000001>0?ofkP40oooo001f0?ofkP800000
D@3om^h00`000000ooK^0?ofkP0k0?ofkP050=@m6@3om^h0ooK^0=@m6@3om^h00`3D?AT70?ofkP03
0=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h01@3om^h30=@m6@L0ooK^00<0e3dI0?ofkP3o
m^h04@3om^h00`3D?AT0ooK^0?ofkP0B0?ofkP030=@m6@3om^h0ooK^03/0ooK^1000001B0?ofkP40
oooo001h0?ofkP030000003om^h0ooK^04h0ooK^00<000000?ofkP3om^h0?03om^h30=@m6@<0ooK^
1@3D?AT40?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h0103D?AT;0?ofkP030=@m
6@3om^h0ooK^00h0ooK^0P3D?AT00`3om^h0e3dI0?ofkP0A0?ofkP030=@m6@3om^h0ooK^03T0ooK^
0`00001F0?ofkP40oooo001i0?ofkP800000CP3om^h00`000000ooK^0?ofkP0m0?ofkP<0e3dI0`3o
m^h0103D?AT0ooK^0?ofkP3om^h40=@m6@030?ofkP3D?AT0ooK^00H0ooK^203D?AT@0?ofkP030=@m
6@3om^h0ooK^00/0ooK^0P3D?AT40?ofkP030=@m6@3om^h0ooK^00d0ooK^0P3D?ATh0?ofkP@00000
F@3om^h10?ooo`00N`3om^h00`000000ooK^0?ofkP1;0?ofkP030000003om^h0ooK^03l0ooK^0P3D
?AT30?ofkP030=@m6@3om^h0ooK^00@0ooK^2@3D?AT70?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0
e3dI0?ofkP3om^h0203om^h20=@m6@L0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?of
kP0d0?ofkP@00000G@3om^h10?ooo`00O03om^h2000004/0ooK^00<000000?ofkP3om^h0@03om^h2
0=@m6@<0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP80e3dI403om^h0
0`3D?AT0ooK^0?ofkP050?ofkP80e3dI2P3om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0
ooK^0340ooK^1000001Q0?ofkP40oooo001n0?ofkP030000003om^h0ooK^04P0ooK^00<000000?of
kP3om^h0@@3om^h30=@m6@80ooK^0P3D?AT70?ofkP80e3dI3@3om^h00`3D?AT0ooK^0?ofkP0>0?of
kP030=@m6@3om^h0ooK^0080ooK^0P3D?AT=0?ofkP030=@m6@3om^h0ooK^00H0ooK^0P3D?AT`0?of
kP@00000I@3om^h10?ooo`00O`3om^h2000004P0ooK^00<000000?ofkP3om^h0@P3om^h0103D?AT0
ooK^0=@m6@3D?AT20?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D
?AT0ooK^0?ofkP0>0?ofkP040=@m6@3om^h0e3dI0=@m6A00ooK^00<0e3dI0?ofkP3om^h0103om^h0
0`3D?AT0ooK^0?ofkP0/0?ofkP@00000J@3om^h10?ooo`00P@3om^h00`000000ooK^0?ofkP150?of
kP030000003om^h0ooK^04<0ooK^00<0e3dI0?ofkP3om^h00P3D?AT00`3om^h0e3dI0?ofkP070?of
kP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h0303om^h30=@m6A<0ooK^00<0e3dI0?of
kP3om^h00P3om^h00`3D?AT0ooK^0?ofkP0Y0?ofkP@00000K@3om^h10?ooo`00PP3om^h00`000000
ooK^0?ofkP140?ofkP030000003om^h0ooK^04@0ooK^0P3D?AT20?ofkP<0e3dI203om^h00`3D?AT0
ooK^0?ofkP0;0?ofkP80e3dI203om^h40=@m6@<0ooK^00<0e3dI0?ofkP3om^h04@3om^h0103D?AT0
ooK^0=@m6@3D?ATX0?ofkP@00000L@3om^h10?ooo`00P`3om^h2000004@0ooK^00<000000?ofkP3o
m^h0A@3om^h20=@m6@<0ooK^103D?AT60?ofkP80e3dI3@3om^h0103D?AT0ooK^0?ofkP3om^h40=@m
6@P0ooK^00<0e3dI0?ofkP3om^h0403om^h20=@m6BH0ooK^1000001e0?ofkP40oooo00250?ofkP03
0000003om^h0ooK^0440ooK^00<000000?ofkP3om^h0A`3om^h00`3D?AT0ooK^0?ofkP020?ofkP03
0=@m6@3om^h0e3dI00D0e3dI0P3om^h00`3D?AT0ooK^0?ofkP050?ofkPT0e3dI3@3om^h00`3D?AT0
ooK^0?ofkP0=0?ofkP80e3dI903om^h4000007T0ooK^0@3oool008H0ooK^0P0000110?ofkP030000
003om^h0ooK^04P0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP040?ofkPX0e3dI
1`3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP80e3dI2`3om^h20=@m6B80ooK^1000001m0?ofkP40oooo
00280?ofkP030000003om^h0ooK^03h0ooK^00<000000?ofkP3om^h0B@3om^h20=@m6@<0ooK^00<0
e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0
e3dI0?ofkP3om^h01P3om^h20=@m6B00ooK^100000210?ofkP40oooo00290?ofkP800000?P3om^h0
0`000000ooK^0?ofkP1;0?ofkP80e3dI0P3om^h20=@m6@P0ooK^00<0e3dI0?ofkP3om^h02`3om^h0
0`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00<0ooK^0P3D?ATN0?ofkP@00000Q@3om^h1
0?ooo`00R`3om^h00`000000ooK^0?ofkP0k0?ofkP030000003om^h0ooK^04d0ooK^0P3D?AT20?of
kP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP0>0?of
kP030=@m6@3om^h0ooK^0080e3dI7@3om^h3000008T0ooK^0@3oool008`0ooK^0P00000k0?ofkP03
0000003om^h0ooK^04l0ooK^0P3D?AT00`3om^h0e3dI0?ofkP070?ofkP80e3dI303om^h00`3D?AT0
ooK^0?ofkP0=0?ofkP<0e3dI6`3om^h4000008`0ooK^0@3oool008h0ooK^00<000000?ofkP3om^h0
>03om^h00`000000ooK^0?ofkP1A0?ofkP<0e3dI2@3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m
6@3om^h0ooK^00T0ooK^0`3D?ATJ0?ofkP@00000T03om^h10?ooo`00S`3om^h2000003P0ooK^00<0
00000?ofkP3om^h0D`3om^h40=@m6@L0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?of
kP040?ofkP@0e3dI6@3om^h4000009@0ooK^0@3oool00940ooK^00<000000?ofkP3om^h0=@3om^h0
0`000000ooK^0?ofkP1G0?ofkPH0e3dI0P3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0
ooK^00<0e3dI6@3om^h4000009P0ooK^0@3oool00980ooK^0P00000e0?ofkP030000003om^h0ooK^
05d0ooK^4P3D?ATH0?ofkP@00000W03om^h10?ooo`00U03om^h00`000000ooK^0?ofkP0b0?ofkP03
0000003om^h0ooK^08<0ooK^1000002P0?ofkP40oooo002E0?ofkP030000003om^h0ooK^0300ooK^
00<000000?ofkP3om^h0P03om^h400000:@0ooK^0@3oool009H0ooK^0P00000`0?ofkP030000003o
m^h0ooK^07`0ooK^1000002X0?ofkP40oooo002H0?ofkP030000003om^h0ooK^02d0ooK^00<00000
0?ofkP3om^h0N03om^h400000:`0ooK^0@3oool009T0ooK^0P00000]0?ofkP030000003om^h0ooK^
07@0ooK^1000002`0?ofkP40oooo002K0?ofkP030000003om^h0ooK^02X0ooK^00<000000?ofkP3o
m^h0L03om^h400000;@0ooK^0@3oool009`0ooK^0P00000Z0?ofkP030000003om^h0ooK^06`0ooK^
1000002h0?ofkP40oooo002N0?ofkP030000003om^h0ooK^02L0ooK^00<000000?ofkP3om^h0J03o
m^h400000;`0ooK^0@3oool009l0ooK^0P00000W0?ofkP030000003om^h0ooK^06D0ooK^0`000030
0?ofkP40oooo002Q0?ofkP030000003om^h0ooK^02@0ooK^00<000000?ofkP3om^h0H@3om^h40000
0<<0ooK^0@3oool00:80ooK^0P00000T0?ofkP030000003om^h0ooK^05d0ooK^100000370?ofkP40
oooo002T0?ofkP030000003om^h0ooK^0240ooK^00<000000?ofkP3om^h0F@3om^h400000</0ooK^
0@3oool00:D0ooK^0P00000Q0?ofkP030000003om^h0ooK^05D0ooK^1000003?0?ofkP40oooo002W
0?ofkP030000003om^h0ooK^01h0ooK^00<000000?ofkP3om^h0D@3om^h400000=<0ooK^0@3oool0
0:P0ooK^0P00000N0?ofkP030000003om^h0ooK^04d0ooK^1000003G0?ofkP40oooo002Z0?ofkP03
0000003om^h0ooK^01/0ooK^00<000000?ofkP3om^h0B@3om^h400000=/0ooK^0@3oool00:/0ooK^
00<000000?ofkP3om^h06P3om^h00`000000ooK^0?ofkP150?ofkP@00000g`3om^h10?ooo`00[03o
m^h2000001X0ooK^00<000000?ofkP3om^h0@@3om^h400000><0ooK^0@3oool00:h0ooK^00<00000
0?ofkP3om^h05`3om^h00`000000ooK^0?ofkP0m0?ofkP@00000i`3om^h10?ooo`00[`3om^h20000
01L0ooK^00<000000?ofkP3om^h0>@3om^h400000>/0ooK^0@3oool00;40ooK^00<000000?ofkP3o
m^h0503om^h00`000000ooK^0?ofkP0e0?ofkP@00000k`3om^h10?ooo`00/P3om^h2000001@0ooK^
00<000000?ofkP3om^h0<P3om^h300000?<0ooK^0@3oool00;@0ooK^00<000000?ofkP3om^h04@3o
m^h00`000000ooK^0?ofkP0^0?ofkP@00000mP3om^h10?ooo`00]@3om^h200000140ooK^00<00000
0?ofkP3om^h0:P3om^h400000?X0ooK^0@3oool00;L0ooK^00<000000?ofkP3om^h03@3om^h00`00
0000ooK^0?ofkP0W0?ofkP@00000oP3om^h10?ooo`00^03om^h2000000d0ooK^00<000000?ofkP3o
m^h08`3om^h400000?l0ooK^0`3om^h10?ooo`00^P3om^h00`000000ooK^0?ofkP0:0?ofkP030000
003om^h0ooK^01l0ooK^1000003o0?ofkPL0ooK^0@3oool00;/0ooK^0P00000:0?ofkP030000003o
m^h0ooK^01/0ooK^1000003o0?ofkP/0ooK^0@3oool00;d0ooK^00<000000?ofkP3om^h01`3om^h0
0`000000ooK^0?ofkP0G0?ofkP@00000o`3om^h?0?ofkP40oooo002n0?ofkP030000003om^h0ooK^
00H0ooK^00<000000?ofkP3om^h04`3om^h400000?l0ooK^4`3om^h10?ooo`00_`3om^h2000000H0
ooK^00<000000?ofkP3om^h03`3om^h400000?l0ooK^5`3om^h10?ooo`00`@3om^h00`000000ooK^
0?ofkP030?ofkP030000003om^h0ooK^00/0ooK^1000003o0?ofkQ/0ooK^0@3oool00<80ooK^0P00
00030?ofkP030000003om^h0ooK^00L0ooK^1000003o0?ofkQl0ooK^0@3oool00<@0ooK^00@00000
0?ofkP3om^h000001@3om^h400000?l0ooK^8`3om^h10?ooo`00a@3om^h3000000030?ofkP000000
000000800000o`3om^hW0?ofkP40oooo00370?ofkP800000o`3om^h[0?ofkP40oooo003o0?ofk_@0
ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool0
0?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03o
m^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00
o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?of
kP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o
0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^
0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0
ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h1
0?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3o
m^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40
oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?of
k_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3o
ool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^
m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?oo
o`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd
0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo
003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0
ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool0
0?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03o
m^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00
o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?of
kP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o
0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^
0@3oool00001\
\>"],
  ImageRangeCache->{{{0, 499}, {499, 0}} -> {-5.00005*^-06, -5.00005*^-06, \
0.00200403, 0.00200403}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
%%ImageSize: 500 500 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics3D
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Background color
1 .961 .933 r
MFill
% Scaling calculations
0 1 0 1 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 0 r
.25 Mabswid
[ ] 0 setdash
.83139 .50547 m
.86955 .74993 L
s
.86955 .74993 m
.80207 .35868 L
s
.80207 .35868 m
.75972 .08168 L
s
.75972 .08168 m
.83139 .50547 L
s
.32128 .58361 m
.08947 .22236 L
s
.08947 .22236 m
.02925 .49223 L
s
.02925 .49223 m
.3022 .81857 L
s
.3022 .81857 m
.32128 .58361 L
s
.83139 .50547 m
.86955 .74993 L
s
.86955 .74993 m
.3022 .81857 L
s
.3022 .81857 m
.32128 .58361 L
s
.32128 .58361 m
.83139 .50547 L
s
.75972 .08168 m
.08947 .22236 L
s
.08947 .22236 m
.02925 .49223 L
s
.02925 .49223 m
.80207 .35868 L
s
.80207 .35868 m
.75972 .08168 L
s
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
.83 .24 .1 r
.5 Mabswid
.50435 .56818 m
.52744 .55588 L
s
.52744 .55588 m
.51851 .53577 L
s
.52744 .55588 m
.55225 .54761 L
s
.48382 .58405 m
.50435 .56818 L
s
.50435 .56818 m
.49499 .54826 L
s
.55225 .54761 m
.54374 .52733 L
s
.55225 .54761 m
.57783 .54369 L
s
.46666 .60293 m
.48382 .58405 L
s
.48382 .58405 m
.47407 .56436 L
s
.57783 .54369 m
.56975 .52327 L
s
.57783 .54369 m
.60325 .54431 L
s
.45358 .62415 m
.46666 .60293 L
s
.46666 .60293 m
.45655 .58347 L
s
.60325 .54431 m
.59557 .52378 L
s
.60325 .54431 m
.6275 .54952 L
s
.44518 .64691 m
.45358 .62415 L
s
.45358 .62415 m
.44317 .60493 L
s
.6275 .54952 m
.62021 .52894 L
s
.6275 .54952 m
.64963 .55922 L
s
.49499 .54826 m
.51851 .53577 L
s
.51851 .53577 m
.50925 .51493 L
s
.51851 .53577 m
.54374 .52733 L
s
.47407 .56436 m
.49499 .54826 L
s
.49499 .54826 m
.4853 .52763 L
s
.54374 .52733 m
.53492 .50631 L
s
.54374 .52733 m
.56975 .52327 L
s
.45655 .58347 m
.47407 .56436 L
s
.47407 .56436 m
.46397 .54395 L
s
.56975 .52327 m
.56137 .5021 L
s
.56975 .52327 m
.59557 .52378 L
s
.4419 .67035 m
.44518 .64691 L
s
.44518 .64691 m
.43452 .62794 L
s
.64963 .55922 m
.64267 .53862 L
s
.64963 .55922 m
.66866 .57313 L
s
.44317 .60493 m
.45655 .58347 L
s
.45655 .58347 m
.44608 .5633 L
s
.59557 .52378 m
.58762 .5025 L
s
.59557 .52378 m
.62021 .52894 L
s
.43452 .62794 m
.44317 .60493 L
s
.44317 .60493 m
.43237 .58501 L
s
.43108 .65162 m
.4419 .67035 L
s
.44405 .6935 m
.4419 .67035 L
s
.62021 .52894 m
.61265 .50759 L
s
.62021 .52894 m
.64267 .53862 L
s
.4853 .52763 m
.50925 .51493 L
s
.50925 .51493 m
.49964 .49333 L
s
.50925 .51493 m
.53492 .50631 L
s
.66866 .57313 m
.66199 .55258 L
s
.66866 .57313 m
.68373 .59079 L
s
.46397 .54395 m
.4853 .52763 L
s
.4853 .52763 m
.47525 .50624 L
s
.53492 .50631 m
.52578 .48451 L
s
.53492 .50631 m
.56137 .5021 L
s
.44608 .5633 m
.46397 .54395 L
s
.46397 .54395 m
.45349 .52279 L
s
.56137 .5021 m
.55269 .48015 L
s
.56137 .5021 m
.58762 .5025 L
s
.43108 .65162 m
.43452 .62794 L
s
.43452 .62794 m
.42346 .60827 L
s
.64267 .53862 m
.63546 .51727 L
s
.64267 .53862 m
.66199 .55258 L
s
.43237 .58501 m
.44608 .5633 L
s
.44608 .5633 m
.43521 .54239 L
s
.45169 .71538 m
.44405 .6935 L
s
.44405 .6935 m
.43314 .675 L
s
.58762 .5025 m
.57937 .48044 L
s
.58762 .5025 m
.61265 .50759 L
s
.68373 .59079 m
.67726 .57035 L
s
.68373 .59079 m
.69405 .61157 L
s
.42346 .60827 m
.43237 .58501 L
s
.43237 .58501 m
.42117 .56435 L
s
.41985 .63219 m
.43108 .65162 L
s
.43314 .675 m
.43108 .65162 L
s
.61265 .50759 m
.6048 .48545 L
s
.61265 .50759 m
.63546 .51727 L
s
.47525 .50624 m
.49964 .49333 L
s
.49964 .49333 m
.48968 .47091 L
s
.49964 .49333 m
.52578 .48451 L
s
.66199 .55258 m
.65506 .53126 L
s
.66199 .55258 m
.67726 .57035 L
s
.45349 .52279 m
.47525 .50624 L
s
.47525 .50624 m
.46482 .48405 L
s
.52578 .48451 m
.51629 .4619 L
s
.52578 .48451 m
.55269 .48015 L
s
.46468 .73497 m
.45169 .71538 L
s
.45169 .71538 m
.44081 .69708 L
s
.69405 .61157 m
.6877 .59129 L
s
.69405 .61157 m
.699 .63465 L
s
.43521 .54239 m
.45349 .52279 L
s
.45349 .52279 m
.44262 .50083 L
s
.55269 .48015 m
.54367 .45737 L
s
.55269 .48015 m
.57937 .48044 L
s
.41985 .63219 m
.42346 .60827 L
s
.42346 .60827 m
.41199 .58786 L
s
.63546 .51727 m
.62797 .4951 L
s
.63546 .51727 m
.65506 .53126 L
s
.42117 .56435 m
.43521 .54239 L
s
.43521 .54239 m
.42394 .52068 L
s
.44081 .69708 m
.43314 .675 L
s
.43314 .675 m
.42183 .6558 L
s
.24 .35 .67 r
.27 .54129 m
.26487 .51389 L
s
.30589 .53554 m
.27 .54129 L
s
.27308 .56888 m
.27 .54129 L
s
.83 .24 .1 r
.57937 .48044 m
.57081 .45753 L
s
.57937 .48044 m
.6048 .48545 L
s
.67726 .57035 m
.67054 .54912 L
s
.67726 .57035 m
.6877 .59129 L
s
.24 .35 .67 r
.26487 .51389 m
.25786 .48758 L
s
.30078 .50799 m
.26487 .51389 L
s
.30907 .56326 m
.27308 .56888 L
s
.274 .59574 m
.27308 .56888 L
s
.83 .24 .1 r
.48259 .75129 m
.46468 .73497 L
s
.46468 .73497 m
.45392 .71683 L
s
.699 .63465 m
.69267 .61457 L
s
.699 .63465 m
.69818 .65903 L
s
.24 .35 .67 r
.30078 .50799 m
.30589 .53554 L
s
.34213 .52974 m
.30589 .53554 L
s
.30589 .53554 m
.30907 .56326 L
s
.25786 .48758 m
.24917 .46327 L
s
.2939 .48153 m
.25786 .48758 L
s
.2939 .48153 m
.30078 .50799 L
s
.33704 .50204 m
.30078 .50799 L
s
.83 .24 .1 r
.41199 .58786 m
.42117 .56435 L
s
.40819 .61202 m
.41985 .63219 L
s
.42183 .6558 m
.41985 .63219 L
s
.24 .35 .67 r
.34541 .55758 m
.30907 .56326 L
s
.30907 .56326 m
.3102 .59022 L
s
.83 .24 .1 r
.6048 .48545 m
.59666 .46246 L
s
.6048 .48545 m
.62797 .4951 L
s
.46482 .48405 m
.48968 .47091 L
s
.48968 .47091 m
.47934 .44764 L
s
.48968 .47091 m
.51629 .4619 L
s
.24 .35 .67 r
.3102 .59022 m
.274 .59574 L
s
.27268 .62095 m
.274 .59574 L
s
.83 .24 .1 r
.65506 .53126 m
.64787 .50913 L
s
.65506 .53126 m
.67054 .54912 L
s
.44262 .50083 m
.46482 .48405 L
s
.51629 .4619 m
.50645 .43843 L
s
.51629 .4619 m
.54367 .45737 L
s
.24 .35 .67 r
.33704 .50204 m
.34213 .52974 L
s
.37874 .52387 m
.34213 .52974 L
s
.34213 .52974 m
.34541 .55758 L
s
.83 .24 .1 r
.45392 .71683 m
.44081 .69708 L
s
.44081 .69708 m
.42951 .67808 L
s
.24 .35 .67 r
.28547 .45704 m
.2939 .48153 L
s
.33031 .47541 m
.2939 .48153 L
s
.33031 .47541 m
.33704 .50204 L
s
.37368 .49603 m
.33704 .50204 L
s
.83 .24 .1 r
.6877 .59129 m
.6811 .57022 L
s
.6877 .59129 m
.69267 .61457 L
s
.42394 .52068 m
.44262 .50083 L
s
.24 .35 .67 r
.38213 .55184 m
.34541 .55758 L
s
.34541 .55758 m
.34677 .58464 L
s
.83 .24 .1 r
.50473 .76347 m
.48259 .75129 L
s
.48259 .75129 m
.47206 .73327 L
s
.54367 .45737 m
.53431 .43372 L
s
.54367 .45737 m
.57081 .45753 L
s
.24 .35 .67 r
.34677 .58464 m
.3102 .59022 L
s
.3102 .59022 m
.30921 .6155 L
s
.24917 .46327 m
.23906 .44185 L
s
.28547 .45704 m
.24917 .46327 L
s
.83 .24 .1 r
.69818 .65903 m
.69177 .63921 L
s
.69818 .65903 m
.69145 .6836 L
s
.24 .35 .67 r
.37368 .49603 m
.37874 .52387 L
s
.37874 .52387 m
.38213 .55184 L
s
.83 .24 .1 r
.40819 .61202 m
.41199 .58786 L
s
.24 .35 .67 r
.32213 .45075 m
.33031 .47541 L
s
.36709 .46924 m
.33031 .47541 L
s
.36709 .46924 m
.37368 .49603 L
s
.41068 .48996 m
.37368 .49603 L
s
.83 .24 .1 r
.62797 .4951 m
.6202 .47208 L
s
.62797 .4951 m
.64787 .50913 L
s
.24 .35 .67 r
.30921 .6155 m
.27268 .62095 L
s
.26911 .64356 m
.27268 .62095 L
s
.38213 .55184 m
.38371 .57901 L
s
.83 .24 .1 r
.42951 .67808 m
.42183 .6558 L
s
.42183 .6558 m
.41008 .63586 L
s
.24 .35 .67 r
.38371 .57901 m
.34677 .58464 L
s
.34677 .58464 m
.34612 .61 L
s
.83 .24 .1 r
.57081 .45753 m
.56192 .43375 L
s
.57081 .45753 m
.59666 .46246 L
s
.24 .35 .67 r
.27572 .43545 m
.28547 .45704 L
s
.32213 .45075 m
.28547 .45704 L
s
.83 .24 .1 r
.67054 .54912 m
.66357 .52708 L
s
.67054 .54912 m
.6811 .57022 L
s
1 .312 .126 r
.40149 .55191 m .40724 .5623 L .41331 .54012 L p F P
0 0 0 r
s
1 .312 .126 r
.41331 .54012 m .40799 .53023 L .40149 .55191 L p F P
0 0 0 r
s
.24 .35 .67 r
.38213 .55184 m
.40246 .54866 L
s
1 .318 .13 r
.40799 .53023 m .41331 .54012 L .42129 .5171 L p F P
0 0 0 r
s
.238 .338 .668 r
.43651 .51466 m .42129 .5171 L .41331 .54012 L p F P
0 0 0 r
s
.238 .338 .668 r
.41331 .54012 m .43007 .53748 L .43651 .51466 L p F P
0 0 0 r
s
.227 .321 .635 r
.43007 .53748 m .41331 .54012 L .40724 .5623 L p F P
0 0 0 r
s
.83 .24 .1 r
.4153 .55353 m
.42117 .56435 L
s
1 .318 .13 r
.42129 .5171 m .41652 .50795 L .40799 .53023 L p F P
0 0 0 r
s
.24 .35 .67 r
.37874 .52387 m
.41249 .51847 L
s
1 .321 .132 r
.41652 .50795 m .42129 .5171 L .43103 .49365 L p F P
0 0 0 r
s
.247 .353 .697 r
.44439 .49147 m .43103 .49365 L .42129 .5171 L p F P
0 0 0 r
s
.83 .24 .1 r
.44025 .49606 m
.44262 .50083 L
s
.247 .353 .697 r
.42129 .5171 m .43651 .51466 L .44439 .49147 L p F P
0 0 0 r
s
.24 .35 .67 r
.41068 .48996 m
.41476 .51256 L
s
.35918 .4444 m
.36709 .46924 L
s
.40424 .463 m
.36709 .46924 L
s
.40424 .463 m
.41068 .48996 L
s
.83 .24 .1 r
.47206 .73327 m
.45392 .71683 L
s
.45392 .71683 m
.44275 .698 L
s
.247 .353 .697 r
.4578 .48928 m .44439 .49147 L .43651 .51466 L p F P
0 0 0 r
s
.247 .353 .697 r
.43651 .51466 m .45181 .51221 L .4578 .48928 L p F P
0 0 0 r
s
.238 .338 .668 r
.45181 .51221 m .43651 .51466 L .43007 .53748 L p F P
0 0 0 r
s
.238 .338 .668 r
.43007 .53748 m .4469 .53484 L .45181 .51221 L p F P
0 0 0 r
s
.227 .321 .635 r
.4469 .53484 m .43007 .53748 L .42516 .55954 L p F P
0 0 0 r
s
.227 .321 .635 r
.40724 .5623 m .42516 .55954 L .43007 .53748 L p F P
0 0 0 r
s
.24 .35 .67 r
.41687 .52713 m
.41922 .54605 L
s
.83 .24 .1 r
.40954 .5429 m
.41925 .52792 L
s
.40954 .5429 m
.4122 .5478 L
s
.24 .35 .67 r
.41084 .54736 m
.41922 .54605 L
s
.83 .24 .1 r
.53016 .77082 m
.50473 .76347 L
s
.50473 .76347 m
.49453 .74552 L
s
1 .3 .12 r
.39716 .57261 m .4032 .58325 L .40724 .5623 L p F P
0 0 0 r
s
1 .3 .12 r
.40724 .5623 m .40149 .55191 L .39716 .57261 L p F P
0 0 0 r
s
.216 .302 .599 r
.42516 .55954 m .40724 .5623 L .4032 .58325 L p F P
0 0 0 r
s
.83 .24 .1 r
.40706 .57908 m
.41199 .58786 L
s
.255 .368 .725 r
.45356 .4683 m .44239 .47016 L .43103 .49365 L p F P
0 0 0 r
s
.255 .368 .725 r
.43103 .49365 m .44439 .49147 L .45356 .4683 L p F P
0 0 0 r
s
1 .321 .132 r
.43103 .49365 m .42693 .48547 L .41652 .50795 L p F P
0 0 0 r
s
.24 .35 .67 r
.41068 .48996 m
.42602 .48744 L
s
1 .321 .133 r
.42693 .48547 m .43103 .49365 L .44239 .47016 L p F P
0 0 0 r
s
.24 .35 .67 r
.34612 .61 m
.30921 .6155 L
s
.30921 .6155 m
.30608 .63817 L
s
.83 .24 .1 r
.69267 .61457 m
.6861 .59372 L
s
.69267 .61457 m
.69177 .63921 L
s
.24 .35 .67 r
.38371 .57901 m
.39943 .57661 L
s
.38371 .57901 m
.3834 .60445 L
s
.83 .24 .1 r
.69145 .6836 m
.68485 .66408 L
s
.69145 .6836 m
.67899 .70718 L
s
.247 .353 .697 r
.47125 .48708 m .4578 .48928 L .45181 .51221 L p F P
0 0 0 r
s
.247 .353 .697 r
.45181 .51221 m .46716 .50975 L .47125 .48708 L p F P
0 0 0 r
s
.238 .338 .668 r
.46716 .50975 m .45181 .51221 L .4469 .53484 L p F P
0 0 0 r
s
.255 .368 .725 r
.46477 .46644 m .45356 .4683 L .44439 .49147 L p F P
0 0 0 r
s
.83 .24 .1 r
.45956 .47284 m
.46482 .48405 L
s
.255 .368 .725 r
.44439 .49147 m .4578 .48928 L .46477 .46644 L p F P
0 0 0 r
s
.24 .35 .67 r
.43376 .48617 m
.44807 .48382 L
s
.31276 .42897 m
.32213 .45075 L
s
.35918 .4444 m
.32213 .45075 L
s
.238 .338 .668 r
.4469 .53484 m .46381 .53218 L .46716 .50975 L p F P
0 0 0 r
s
.24 .35 .67 r
.42046 .51719 m
.45309 .51197 L
s
.227 .321 .635 r
.46381 .53218 m .4469 .53484 L .44317 .55676 L p F P
0 0 0 r
s
.227 .321 .635 r
.42516 .55954 m .44317 .55676 L .4469 .53484 L p F P
0 0 0 r
s
.216 .302 .599 r
.44317 .55676 m .42516 .55954 L .42189 .58042 L p F P
0 0 0 r
s
.216 .302 .599 r
.4032 .58325 m .42189 .58042 L .42516 .55954 L p F P
0 0 0 r
s
.24 .35 .67 r
.4042 .57589 m
.42103 .57332 L
s
.41922 .54605 m
.42103 .57332 L
s
.44807 .48382 m
.45309 .51197 L
s
.23906 .44185 m
.22786 .4242 L
s
.27572 .43545 m
.23906 .44185 L
s
.255 .368 .725 r
.47601 .46458 m .46477 .46644 L .4578 .48928 L p F P
0 0 0 r
s
.255 .368 .725 r
.4578 .48928 m .47125 .48708 L .47601 .46458 L p F P
0 0 0 r
s
.247 .353 .697 r
.48476 .48488 m .47125 .48708 L .46716 .50975 L p F P
0 0 0 r
s
.247 .353 .697 r
.46716 .50975 m .48258 .50728 L .48476 .48488 L p F P
0 0 0 r
s
.238 .338 .668 r
.48258 .50728 m .46716 .50975 L .46381 .53218 L p F P
0 0 0 r
s
.24 .35 .67 r
.3966 .43798 m
.40424 .463 L
s
.83 .24 .1 r
.59666 .46246 m
.6202 .47208 L
s
.238 .338 .668 r
.46381 .53218 m .4808 .52951 L .48258 .50728 L p F P
0 0 0 r
s
.227 .321 .635 r
.4808 .52951 m .46381 .53218 L .46126 .55397 L p F P
0 0 0 r
s
.227 .321 .635 r
.44317 .55676 m .46126 .55397 L .46381 .53218 L p F P
0 0 0 r
s
.24 .35 .67 r
.45309 .51197 m
.45669 .54019 L
s
.41922 .54605 m
.45669 .54019 L
s
.83 .24 .1 r
.47934 .44764 m
.50645 .43843 L
s
.996 .278 .11 r
.39511 .59192 m .40129 .60259 L .4032 .58325 L p F P
0 0 0 r
s
.996 .278 .11 r
.4032 .58325 m .39716 .57261 L .39511 .59192 L p F P
0 0 0 r
s
.202 .28 .556 r
.42189 .58042 m .4032 .58325 L .40129 .60259 L p F P
0 0 0 r
s
.263 .382 .752 r
.46389 .44559 m .45518 .44706 L .44239 .47016 L p F P
0 0 0 r
s
.263 .382 .752 r
.44239 .47016 m .45356 .4683 L .46389 .44559 L p F P
0 0 0 r
s
.83 .24 .1 r
.45546 .46413 m
.45714 .46771 L
s
.45779 .459 m
.47934 .44764 L
s
1 .321 .133 r
.44239 .47016 m .43903 .46321 L .42693 .48547 L p F P
0 0 0 r
s
1 .318 .133 r
.43903 .46321 m .44239 .47016 L .45518 .44706 L p F P
0 0 0 r
s
.24 .35 .67 r
.44178 .45669 m
.44249 .45975 L
s
.44358 .46449 m
.44807 .48382 L
s
.40424 .463 m
.44178 .45669 L
s
.216 .302 .599 r
.46126 .55397 m .44317 .55676 L .44068 .57757 L p F P
0 0 0 r
s
.216 .302 .599 r
.42189 .58042 m .44068 .57757 L .44317 .55676 L p F P
0 0 0 r
s
.24 .35 .67 r
.3834 .60445 m
.34612 .61 L
s
.34612 .61 m
.34342 .63272 L
s
.83 .24 .1 r
.64787 .50913 m
.6404 .48613 L
s
.64787 .50913 m
.66357 .52708 L
s
1 .318 .13 r
.40258 .52016 m .40799 .53023 L .41652 .50795 L p F P
0 0 0 r
s
1 .318 .13 r
.41652 .50795 m .41169 .49865 L .40258 .52016 L p F P
0 0 0 r
s
1 .321 .132 r
.41169 .49865 m .41652 .50795 L .42693 .48547 L p F P
0 0 0 r
s
.255 .368 .725 r
.48728 .4627 m .47601 .46458 L .47125 .48708 L p F P
0 0 0 r
s
.255 .368 .725 r
.47125 .48708 m .48476 .48488 L .48728 .4627 L p F P
0 0 0 r
s
.247 .353 .697 r
.49831 .48267 m .48476 .48488 L .48258 .50728 L p F P
0 0 0 r
s
.247 .353 .697 r
.48258 .50728 m .49807 .5048 L .49831 .48267 L p F P
0 0 0 r
s
.238 .338 .668 r
.49807 .5048 m .48258 .50728 L .4808 .52951 L p F P
0 0 0 r
s
.83 .24 .1 r
.50645 .43843 m
.53431 .43372 L
s
1 .312 .126 r
.39564 .54133 m .40149 .55191 L .40799 .53023 L p F P
0 0 0 r
s
1 .312 .126 r
.40799 .53023 m .40258 .52016 L .39564 .54133 L p F P
0 0 0 r
s
.263 .382 .752 r
.47261 .44412 m .46389 .44559 L .45356 .4683 L p F P
0 0 0 r
s
.263 .382 .752 r
.45356 .4683 m .46477 .46644 L .47261 .44412 L p F P
0 0 0 r
s
.238 .338 .668 r
.4808 .52951 m .49787 .52683 L .49807 .5048 L p F P
0 0 0 r
s
.24 .35 .67 r
.45309 .51197 m
.49083 .50592 L
s
.227 .321 .635 r
.49787 .52683 m .4808 .52951 L .47945 .55116 L p F P
0 0 0 r
s
.227 .321 .635 r
.46126 .55397 m .47945 .55116 L .4808 .52951 L p F P
0 0 0 r
s
1 .321 .132 r
.42693 .48547 m .42277 .47719 L .41169 .49865 L p F P
0 0 0 r
s
1 .321 .133 r
.42277 .47719 m .42693 .48547 L .43903 .46321 L p F P
0 0 0 r
s
.83 .24 .1 r
.43133 .47804 m
.44752 .46587 L
s
.43133 .47804 m
.43569 .48683 L
s
.44275 .698 m
.42951 .67808 L
s
.42951 .67808 m
.41777 .65834 L
s
.24 .35 .67 r
.35019 .42243 m
.35918 .4444 L
s
.3966 .43798 m
.35918 .4444 L
s
.30608 .63817 m
.26911 .64356 L
s
.26334 .66268 m
.26911 .64356 L
s
.255 .368 .725 r
.49859 .46083 m .48728 .4627 L .48476 .48488 L p F P
0 0 0 r
s
.255 .368 .725 r
.48476 .48488 m .49831 .48267 L .49859 .46083 L p F P
0 0 0 r
s
.24 .35 .67 r
.44807 .48382 m
.48583 .47763 L
s
.216 .302 .599 r
.47945 .55116 m .46126 .55397 L .45956 .57471 L p F P
0 0 0 r
s
.216 .302 .599 r
.44068 .57757 m .45956 .57471 L .46126 .55397 L p F P
0 0 0 r
s
.24 .35 .67 r
.42103 .57332 m
.45874 .56757 L
s
.45669 .54019 m
.45874 .56757 L
s
.202 .28 .556 r
.44068 .57757 m .42189 .58042 L .42034 .59975 L p F P
0 0 0 r
s
.202 .28 .556 r
.40129 .60259 m .42034 .59975 L .42189 .58042 L p F P
0 0 0 r
s
.83 .24 .1 r
.55768 .77285 m
.53016 .77082 L
s
.53016 .77082 m
.52037 .75287 L
s
.24 .35 .67 r
.48583 .47763 m
.49083 .50592 L
s
.263 .382 .752 r
.48135 .44264 m .47261 .44412 L .46477 .46644 L p F P
0 0 0 r
s
.83 .24 .1 r
.47877 .44635 m
.47934 .44764 L
s
.263 .382 .752 r
.46477 .46644 m .47601 .46458 L .48135 .44264 L p F P
0 0 0 r
s
.247 .353 .697 r
.51192 .48045 m .49831 .48267 L .49807 .5048 L p F P
0 0 0 r
s
.247 .353 .697 r
.49807 .5048 m .51362 .50231 L .51192 .48045 L p F P
0 0 0 r
s
.238 .338 .668 r
.51362 .50231 m .49807 .5048 L .49787 .52683 L p F P
0 0 0 r
s
.24 .35 .67 r
.26498 .41761 m
.27572 .43545 L
s
.31276 .42897 m
.27572 .43545 L
s
.83 .24 .1 r
.6811 .57022 m
.67425 .54833 L
s
.6811 .57022 m
.6861 .59372 L
s
.67899 .70718 m
.67209 .68796 L
s
.67899 .70718 m
.66127 .72857 L
s
.24 .35 .67 r
.44178 .45669 m
.44631 .45593 L
s
.238 .338 .668 r
.49787 .52683 m .51502 .52413 L .51362 .50231 L p F P
0 0 0 r
s
.227 .321 .635 r
.51502 .52413 m .49787 .52683 L .49772 .54834 L p F P
0 0 0 r
s
.227 .321 .635 r
.47945 .55116 m .49772 .54834 L .49787 .52683 L p F P
0 0 0 r
s
.24 .35 .67 r
.49083 .50592 m
.49455 .53428 L
s
.45669 .54019 m
.49455 .53428 L
s
.255 .368 .725 r
.50993 .45894 m .49859 .46083 L .49831 .48267 L p F P
0 0 0 r
s
.255 .368 .725 r
.49831 .48267 m .51192 .48045 L .50993 .45894 L p F P
0 0 0 r
s
1 .3 .12 r
.391 .56176 m .39716 .57261 L .40149 .55191 L p F P
0 0 0 r
s
.83 .24 .1 r
.40008 .56666 m
.4055 .5763 L
s
1 .3 .12 r
.40149 .55191 m .39564 .54133 L .391 .56176 L p F P
0 0 0 r
s
.83 .24 .1 r
.40008 .56666 m
.40954 .5429 L
s
.263 .382 .752 r
.49012 .44116 m .48135 .44264 L .47601 .46458 L p F P
0 0 0 r
s
.263 .382 .752 r
.47601 .46458 m .48728 .4627 L .49012 .44116 L p F P
0 0 0 r
s
.24 .35 .67 r
.4797 .45032 m
.48583 .47763 L
s
.83 .24 .1 r
.49453 .74552 m
.47206 .73327 L
s
.47206 .73327 m
.46112 .71456 L
s
.53431 .43372 m
.56192 .43375 L
s
.216 .302 .599 r
.49772 .54834 m .47945 .55116 L .47854 .57184 L p F P
0 0 0 r
s
.216 .302 .599 r
.45956 .57471 m .47854 .57184 L .47945 .55116 L p F P
0 0 0 r
s
.202 .28 .556 r
.45956 .57471 m .44068 .57757 L .4395 .5969 L p F P
0 0 0 r
s
.202 .28 .556 r
.42034 .59975 m .4395 .5969 L .44068 .57757 L p F P
0 0 0 r
s
.247 .353 .697 r
.52557 .47822 m .51192 .48045 L .51362 .50231 L p F P
0 0 0 r
s
.247 .353 .697 r
.51362 .50231 m .52924 .49981 L .52557 .47822 L p F P
0 0 0 r
s
.238 .338 .668 r
.52924 .49981 m .51362 .50231 L .51502 .52413 L p F P
0 0 0 r
s
.24 .35 .67 r
.3834 .60445 m
.38116 .62721 L
s
1 .321 .133 r
.43903 .46321 m .43564 .45617 L .42277 .47719 L p F P
0 0 0 r
s
1 .318 .133 r
.43564 .45617 m .43903 .46321 L .45263 .44156 L p F P
0 0 0 r
s
1 .318 .133 r
.45518 .44706 m .45263 .44156 L .43903 .46321 L p F P
0 0 0 r
s
.24 .35 .67 r
.44936 .45542 m
.4797 .45032 L
s
.263 .382 .752 r
.49891 .43968 m .49012 .44116 L .48728 .4627 L p F P
0 0 0 r
s
.263 .382 .752 r
.48728 .4627 m .49859 .46083 L .49891 .43968 L p F P
0 0 0 r
s
.255 .368 .725 r
.52131 .45705 m .50993 .45894 L .51192 .48045 L p F P
0 0 0 r
s
.255 .368 .725 r
.51192 .48045 m .52557 .47822 L .52131 .45705 L p F P
0 0 0 r
s
.83 .24 .1 r
.69177 .63921 m
.68511 .61862 L
s
.69177 .63921 m
.68485 .66408 L
s
.238 .338 .668 r
.51502 .52413 m .53225 .52142 L .52924 .49981 L p F P
0 0 0 r
s
.24 .35 .67 r
.49083 .50592 m
.52897 .49981 L
s
.227 .321 .635 r
.53225 .52142 m .51502 .52413 L .51609 .54551 L p F P
0 0 0 r
s
.227 .321 .635 r
.49772 .54834 m .51609 .54551 L .51502 .52413 L p F P
0 0 0 r
s
.888 .244 .094 r
.39543 .60945 m .40159 .61991 L .40129 .60259 L p F P
0 0 0 r
s
.888 .244 .094 r
.40129 .60259 m .39511 .59192 L .39543 .60945 L p F P
0 0 0 r
s
.24 .35 .67 r
.3834 .60445 m
.3953 .60267 L
s
.186 .253 .503 r
.42034 .59975 m .40129 .60259 L .40159 .61991 L p F P
0 0 0 r
s
.83 .24 .1 r
.40825 .61275 m
.41008 .63586 L
s
.271 .395 .778 r
.4752 .42375 m .46921 .42478 L .45518 .44706 L p F P
0 0 0 r
s
.271 .395 .778 r
.45518 .44706 m .46389 .44559 L .4752 .42375 L p F P
0 0 0 r
s
1 .314 .132 r
.45263 .44156 m .45518 .44706 L .46921 .42478 L p F P
0 0 0 r
s
.247 .353 .697 r
.53927 .47599 m .52557 .47822 L .52924 .49981 L p F P
0 0 0 r
s
.247 .353 .697 r
.52924 .49981 m .54492 .4973 L .53927 .47599 L p F P
0 0 0 r
s
.238 .338 .668 r
.54492 .4973 m .52924 .49981 L .53225 .52142 L p F P
0 0 0 r
s
.24 .35 .67 r
.388 .41582 m
.3966 .43798 L
s
.216 .302 .599 r
.51609 .54551 m .49772 .54834 L .49762 .56895 L p F P
0 0 0 r
s
.216 .302 .599 r
.47854 .57184 m .49762 .56895 L .49772 .54834 L p F P
0 0 0 r
s
.24 .35 .67 r
.45874 .56757 m
.49683 .56176 L
s
.49455 .53428 m
.49683 .56176 L
s
.34342 .63272 m
.30608 .63817 L
s
.30608 .63817 m
.30083 .6573 L
s
.263 .382 .752 r
.50771 .43819 m .49891 .43968 L .49859 .46083 L p F P
0 0 0 r
s
.263 .382 .752 r
.49859 .46083 m .50993 .45894 L .50771 .43819 L p F P
0 0 0 r
s
.202 .28 .556 r
.47854 .57184 m .45956 .57471 L .45876 .59403 L p F P
0 0 0 r
s
.202 .28 .556 r
.4395 .5969 m .45876 .59403 L .45956 .57471 L p F P
0 0 0 r
s
.255 .368 .725 r
.53273 .45516 m .52131 .45705 L .52557 .47822 L p F P
0 0 0 r
s
.24 .35 .67 r
.48583 .47763 m
.52399 .47136 L
s
.255 .368 .725 r
.52557 .47822 m .53927 .47599 L .53273 .45516 L p F P
0 0 0 r
s
.24 .35 .67 r
.52399 .47136 m
.52897 .49981 L
s
1 .318 .13 r
.39708 .50992 m .40258 .52016 L .41169 .49865 L p F P
0 0 0 r
s
1 .318 .13 r
.41169 .49865 m .40677 .4892 L .39708 .50992 L p F P
0 0 0 r
s
1 .321 .132 r
.40677 .4892 m .41169 .49865 L .42277 .47719 L p F P
0 0 0 r
s
.83 .24 .1 r
.41223 .49814 m
.42247 .51787 L
s
.271 .395 .778 r
.4812 .42272 m .4752 .42375 L .46389 .44559 L p F P
0 0 0 r
s
.271 .395 .778 r
.46389 .44559 m .47261 .44412 L .4812 .42272 L p F P
0 0 0 r
s
.83 .24 .1 r
.47506 .43801 m
.47742 .44331 L
s
.24 .35 .67 r
.30249 .41095 m
.31276 .42897 L
s
.35019 .42243 m
.31276 .42897 L
s
1 .321 .132 r
.42277 .47719 m .41856 .46878 L .40677 .4892 L p F P
0 0 0 r
s
.83 .24 .1 r
.41223 .49814 m
.43133 .47804 L
s
1 .321 .133 r
.41856 .46878 m .42277 .47719 L .43564 .45617 L p F P
0 0 0 r
s
.238 .338 .668 r
.53225 .52142 m .54955 .5187 L .54492 .4973 L p F P
0 0 0 r
s
.227 .321 .635 r
.54955 .5187 m .53225 .52142 L .53454 .54266 L p F P
0 0 0 r
s
.227 .321 .635 r
.51609 .54551 m .53454 .54266 L .53225 .52142 L p F P
0 0 0 r
s
.24 .35 .67 r
.49455 .53428 m
.53279 .5283 L
s
.52897 .49981 m
.53279 .5283 L
s
.83 .24 .1 r
.58596 .76938 m
.55768 .77285 L
s
.55768 .77285 m
.54838 .75484 L
s
.263 .382 .752 r
.51654 .4367 m .50771 .43819 L .50993 .45894 L p F P
0 0 0 r
s
.263 .382 .752 r
.50993 .45894 m .52131 .45705 L .51654 .4367 L p F P
0 0 0 r
s
.247 .353 .697 r
.55303 .47374 m .53927 .47599 L .54492 .4973 L p F P
0 0 0 r
s
.247 .353 .697 r
.54492 .4973 m .56067 .49478 L .55303 .47374 L p F P
0 0 0 r
s
.238 .338 .668 r
.56067 .49478 m .54492 .4973 L .54955 .5187 L p F P
0 0 0 r
s
.271 .395 .778 r
.4872 .42169 m .4812 .42272 L .47261 .44412 L p F P
0 0 0 r
s
.271 .395 .778 r
.47261 .44412 m .48135 .44264 L .4872 .42169 L p F P
0 0 0 r
s
.24 .35 .67 r
.47262 .42494 m
.4797 .45032 L
s
.996 .278 .11 r
.38881 .58104 m .39511 .59192 L .39716 .57261 L p F P
0 0 0 r
s
.996 .278 .11 r
.39716 .57261 m .391 .56176 L .38881 .58104 L p F P
0 0 0 r
s
.83 .24 .1 r
.39608 .59107 m
.40008 .56666 L
s
.66127 .72857 m
.65399 .70967 L
s
.66127 .72857 m
.6391 .74666 L
s
.41777 .65834 m
.41008 .63586 L
s
.186 .253 .503 r
.4395 .5969 m .42034 .59975 L .42059 .61713 L p F P
0 0 0 r
s
.24 .35 .67 r
.42103 .57332 m
.42107 .59883 L
s
.186 .253 .503 r
.40159 .61991 m .42059 .61713 L .42034 .59975 L p F P
0 0 0 r
s
.24 .35 .67 r
.40086 .60185 m
.42107 .59883 L
s
.83 .24 .1 r
.39608 .59107 m
.40262 .60239 L
s
.255 .368 .725 r
.54417 .45326 m .53273 .45516 L .53927 .47599 L p F P
0 0 0 r
s
.255 .368 .725 r
.53927 .47599 m .55303 .47374 L .54417 .45326 L p F P
0 0 0 r
s
1 .312 .126 r
.38967 .53055 m .39564 .54133 L .40258 .52016 L p F P
0 0 0 r
s
1 .312 .126 r
.40258 .52016 m .39708 .50992 L .38967 .53055 L p F P
0 0 0 r
s
.83 .24 .1 r
.39746 .52061 m
.40954 .5429 L
s
.216 .302 .599 r
.53454 .54266 m .51609 .54551 L .5168 .56604 L p F P
0 0 0 r
s
.216 .302 .599 r
.49762 .56895 m .5168 .56604 L .51609 .54551 L p F P
0 0 0 r
s
.202 .28 .556 r
.49762 .56895 m .47854 .57184 L .47811 .59115 L p F P
0 0 0 r
s
.202 .28 .556 r
.45876 .59403 m .47811 .59115 L .47854 .57184 L p F P
0 0 0 r
s
.263 .382 .752 r
.52539 .4352 m .51654 .4367 L .52131 .45705 L p F P
0 0 0 r
s
.24 .35 .67 r
.4797 .45032 m
.51802 .44389 L
s
.263 .382 .752 r
.52131 .45705 m .53273 .45516 L .52539 .4352 L p F P
0 0 0 r
s
.24 .35 .67 r
.51802 .44389 m
.52399 .47136 L
s
.271 .395 .778 r
.49322 .42066 m .4872 .42169 L .48135 .44264 L p F P
0 0 0 r
s
.271 .395 .778 r
.48135 .44264 m .49012 .44116 L .49322 .42066 L p F P
0 0 0 r
s
.238 .338 .668 r
.54955 .5187 m .56694 .51597 L .56067 .49478 L p F P
0 0 0 r
s
.227 .321 .635 r
.56694 .51597 m .54955 .5187 L .55309 .5398 L p F P
0 0 0 r
s
.227 .321 .635 r
.53454 .54266 m .55309 .5398 L .54955 .5187 L p F P
0 0 0 r
s
1 .321 .133 r
.43564 .45617 m .4322 .44906 L .41856 .46878 L p F P
0 0 0 r
s
1 .318 .133 r
.4322 .44906 m .43564 .45617 L .45006 .436 L p F P
0 0 0 r
s
.24 .35 .67 r
.43989 .45023 m
.44042 .45206 L
s
.3966 .43798 m
.43442 .43149 L
s
1 .318 .133 r
.45263 .44156 m .45006 .436 L .43564 .45617 L p F P
0 0 0 r
s
.24 .35 .67 r
.43442 .43149 m
.43825 .44463 L
s
.247 .353 .697 r
.56683 .47149 m .55303 .47374 L .56067 .49478 L p F P
0 0 0 r
s
.247 .353 .697 r
.56067 .49478 m .57648 .49224 L .56683 .47149 L p F P
0 0 0 r
s
.238 .338 .668 r
.57648 .49224 m .56067 .49478 L .56694 .51597 L p F P
0 0 0 r
s
.24 .35 .67 r
.52897 .49981 m
.5675 .49364 L
s
1 .314 .132 r
.45006 .436 m .45263 .44156 L .4675 .42094 L p F P
0 0 0 r
s
1 .314 .132 r
.46921 .42478 m .4675 .42094 L .45263 .44156 L p F P
0 0 0 r
s
.255 .368 .725 r
.55566 .45135 m .54417 .45326 L .55303 .47374 L p F P
0 0 0 r
s
.255 .368 .725 r
.55303 .47374 m .56683 .47149 L .55566 .45135 L p F P
0 0 0 r
s
.83 .24 .1 r
.66357 .52708 m
.67425 .54833 L
s
.271 .395 .778 r
.49925 .41963 m .49322 .42066 L .49012 .44116 L p F P
0 0 0 r
s
.271 .395 .778 r
.49012 .44116 m .49891 .43968 L .49925 .41963 L p F P
0 0 0 r
s
.83 .24 .1 r
.4969 .41566 m
.4986 .41974 L
s
.263 .382 .752 r
.53426 .4337 m .52539 .4352 L .53273 .45516 L p F P
0 0 0 r
s
.263 .382 .752 r
.53273 .45516 m .54417 .45326 L .53426 .4337 L p F P
0 0 0 r
s
.24 .35 .67 r
.22786 .4242 m
.21593 .41113 L
s
.26498 .41761 m
.22786 .4242 L
s
.186 .253 .503 r
.45876 .59403 m .4395 .5969 L .43968 .61433 L p F P
0 0 0 r
s
.186 .253 .503 r
.42059 .61713 m .43968 .61433 L .4395 .5969 L p F P
0 0 0 r
s
.216 .302 .599 r
.55309 .5398 m .53454 .54266 L .53608 .56312 L p F P
0 0 0 r
s
.216 .302 .599 r
.5168 .56604 m .53608 .56312 L .53454 .54266 L p F P
0 0 0 r
s
.24 .35 .67 r
.53279 .5283 m
.53532 .55589 L
s
.49683 .56176 m
.53532 .55589 L
s
.83 .24 .1 r
.61357 .7605 m
.58596 .76938 L
s
.58596 .76938 m
.57718 .75122 L
s
.24 .35 .67 r
.38116 .62721 m
.34342 .63272 L
s
.34342 .63272 m
.33871 .65187 L
s
.202 .28 .556 r
.5168 .56604 m .49762 .56895 L .49757 .58825 L p F P
0 0 0 r
s
.202 .28 .556 r
.47811 .59115 m .49757 .58825 L .49762 .56895 L p F P
0 0 0 r
s
.83 .24 .1 r
.6391 .74666 m
.63136 .72805 L
s
.6391 .74666 m
.61357 .7605 L
s
.271 .395 .778 r
.50529 .41859 m .49925 .41963 L .49891 .43968 L p F P
0 0 0 r
s
.83 .24 .1 r
.50229 .42851 m
.50644 .4384 L
s
.271 .395 .778 r
.49891 .43968 m .50771 .43819 L .50529 .41859 L p F P
0 0 0 r
s
.83 .24 .1 r
.46112 .71456 m
.44275 .698 L
s
.44275 .698 m
.43113 .67842 L
s
.238 .338 .668 r
.56694 .51597 m .58441 .51322 L .57648 .49224 L p F P
0 0 0 r
s
.227 .321 .635 r
.58441 .51322 m .56694 .51597 L .57173 .53692 L p F P
0 0 0 r
s
.227 .321 .635 r
.55309 .5398 m .57173 .53692 L .56694 .51597 L p F P
0 0 0 r
s
.24 .35 .67 r
.53279 .5283 m
.57143 .52226 L
s
.5675 .49364 m
.57143 .52226 L
s
.255 .368 .725 r
.56718 .44943 m .55566 .45135 L .56683 .47149 L p F P
0 0 0 r
s
.24 .35 .67 r
.52399 .47136 m
.56254 .46504 L
s
.255 .368 .725 r
.56683 .47149 m .58069 .46923 L .56718 .44943 L p F P
0 0 0 r
s
.247 .353 .697 r
.58069 .46923 m .56683 .47149 L .57648 .49224 L p F P
0 0 0 r
s
.24 .35 .67 r
.56254 .46504 m
.5675 .49364 L
s
1 .3 .12 r
.38472 .5507 m .391 .56176 L .39564 .54133 L p F P
0 0 0 r
s
1 .3 .12 r
.39564 .54133 m .38967 .53055 L .38472 .5507 L p F P
0 0 0 r
s
.247 .353 .697 r
.57648 .49224 m .59236 .4897 L .58069 .46923 L p F P
0 0 0 r
s
.238 .338 .668 r
.59236 .4897 m .57648 .49224 L .58441 .51322 L p F P
0 0 0 r
s
.24 .35 .67 r
.3404 .40422 m
.35019 .42243 L
s
.388 .41582 m
.35019 .42243 L
s
.263 .382 .752 r
.54315 .4322 m .53426 .4337 L .54417 .45326 L p F P
0 0 0 r
s
.263 .382 .752 r
.54417 .45326 m .55566 .45135 L .54315 .4322 L p F P
0 0 0 r
s
.83 .24 .1 r
.61357 .7605 m
.60532 .74214 L
s
.52037 .75287 m
.49453 .74552 L
s
.49453 .74552 m
.48393 .72687 L
s
.271 .395 .778 r
.51133 .41755 m .50529 .41859 L .50771 .43819 L p F P
0 0 0 r
s
.271 .395 .778 r
.50771 .43819 m .51654 .4367 L .51133 .41755 L p F P
0 0 0 r
s
.216 .302 .599 r
.57173 .53692 m .55309 .5398 L .55545 .56018 L p F P
0 0 0 r
s
.216 .302 .599 r
.53608 .56312 m .55545 .56018 L .55309 .5398 L p F P
0 0 0 r
s
.186 .253 .503 r
.47811 .59115 m .45876 .59403 L .45888 .61151 L p F P
0 0 0 r
s
.24 .35 .67 r
.45874 .56757 m
.45914 .59316 L
s
.186 .253 .503 r
.43968 .61433 m .45888 .61151 L .45876 .59403 L p F P
0 0 0 r
s
.24 .35 .67 r
.42107 .59883 m
.45914 .59316 L
s
.83 .24 .1 r
.6861 .59372 m
.67927 .57204 L
s
.6861 .59372 m
.68511 .61862 L
s
.263 .382 .752 r
.55206 .4307 m .54315 .4322 L .55566 .45135 L p F P
0 0 0 r
s
.263 .382 .752 r
.55566 .45135 m .56718 .44943 L .55206 .4307 L p F P
0 0 0 r
s
.255 .368 .725 r
.57873 .44752 m .56718 .44943 L .58069 .46923 L p F P
0 0 0 r
s
.255 .368 .725 r
.58069 .46923 m .5946 .46696 L .57873 .44752 L p F P
0 0 0 r
s
.247 .353 .697 r
.5946 .46696 m .58069 .46923 L .59236 .4897 L p F P
0 0 0 r
s
.202 .28 .556 r
.53608 .56312 m .5168 .56604 L .51714 .58533 L p F P
0 0 0 r
s
.202 .28 .556 r
.49757 .58825 m .51714 .58533 L .5168 .56604 L p F P
0 0 0 r
s
.271 .395 .778 r
.51739 .41651 m .51133 .41755 L .51654 .4367 L p F P
0 0 0 r
s
.271 .395 .778 r
.51654 .4367 m .52539 .4352 L .51739 .41651 L p F P
0 0 0 r
s
1 .321 .132 r
.40178 .4796 m .40677 .4892 L .41856 .46878 L p F P
0 0 0 r
s
1 .321 .132 r
.41856 .46878 m .41428 .46027 L .40178 .4796 L p F P
0 0 0 r
s
1 .321 .133 r
.41428 .46027 m .41856 .46878 L .4322 .44906 L p F P
0 0 0 r
s
.83 .24 .1 r
.68485 .66408 m
.678 .64378 L
s
.68485 .66408 m
.67209 .68796 L
s
.247 .353 .697 r
.59236 .4897 m .60831 .48715 L .5946 .46696 L p F P
0 0 0 r
s
.238 .338 .668 r
.60831 .48715 m .59236 .4897 L .60196 .51046 L p F P
0 0 0 r
s
.238 .338 .668 r
.58441 .51322 m .60196 .51046 L .59236 .4897 L p F P
0 0 0 r
s
.227 .321 .635 r
.60196 .51046 m .58441 .51322 L .59047 .53403 L p F P
0 0 0 r
s
.227 .321 .635 r
.57173 .53692 m .59047 .53403 L .58441 .51322 L p F P
0 0 0 r
s
1 .318 .133 r
.45006 .436 m .44746 .4304 L .4322 .44906 L p F P
0 0 0 r
s
1 .314 .132 r
.44746 .4304 m .45006 .436 L .46578 .41707 L p F P
0 0 0 r
s
.24 .35 .67 r
.43442 .43149 m
.44952 .4289 L
s
1 .314 .132 r
.4675 .42094 m .46578 .41707 L .45006 .436 L p F P
0 0 0 r
s
.24 .35 .67 r
.46596 .42608 m
.47262 .42494 L
s
1 .318 .13 r
.39148 .4995 m .39708 .50992 L .40677 .4892 L p F P
0 0 0 r
s
1 .318 .13 r
.40677 .4892 m .40178 .4796 L .39148 .4995 L p F P
0 0 0 r
s
.83 .24 .1 r
.39746 .52061 m
.41223 .49814 L
s
.72 .193 .072 r
.39818 .6248 m .40415 .63484 L .40159 .61991 L p F P
0 0 0 r
s
.72 .193 .072 r
.40159 .61991 m .39543 .60945 L .39818 .6248 L p F P
0 0 0 r
s
.164 .219 .436 r
.42059 .61713 m .40159 .61991 L .40415 .63484 L p F P
0 0 0 r
s
.83 .24 .1 r
.40741 .63133 m
.41008 .63586 L
s
.278 .409 .804 r
.48731 .40323 m .48423 .40376 L .46921 .42478 L p F P
0 0 0 r
s
.278 .409 .804 r
.46921 .42478 m .4752 .42375 L .48731 .40323 L p F P
0 0 0 r
s
1 .307 .13 r
.4675 .42094 m .46921 .42478 L .48423 .40376 L p F P
0 0 0 r
s
.83 .24 .1 r
.4686 .42347 m
.4705 .42774 L
s
.271 .395 .778 r
.52346 .41547 m .51739 .41651 L .52539 .4352 L p F P
0 0 0 r
s
.271 .395 .778 r
.52539 .4352 m .53426 .4337 L .52346 .41547 L p F P
0 0 0 r
s
.263 .382 .752 r
.561 .42919 m .55206 .4307 L .56718 .44943 L p F P
0 0 0 r
s
.24 .35 .67 r
.51802 .44389 m
.55673 .43739 L
s
.263 .382 .752 r
.56718 .44943 m .57873 .44752 L .561 .42919 L p F P
0 0 0 r
s
.888 .244 .094 r
.38915 .59877 m .39543 .60945 L .39511 .59192 L p F P
0 0 0 r
s
.888 .244 .094 r
.39511 .59192 m .38881 .58104 L .38915 .59877 L p F P
0 0 0 r
s
.24 .35 .67 r
.30083 .6573 m
.26334 .66268 L
s
.2555 .67739 m
.26334 .66268 L
s
1 .321 .133 r
.4322 .44906 m .42873 .44186 L .41428 .46027 L p F P
0 0 0 r
s
1 .318 .133 r
.42873 .44186 m .4322 .44906 L .44746 .4304 L p F P
0 0 0 r
s
.83 .24 .1 r
.44275 .43707 m
.45177 .45627 L
s
.255 .368 .725 r
.59032 .44559 m .57873 .44752 L .5946 .46696 L p F P
0 0 0 r
s
.255 .368 .725 r
.5946 .46696 m .60856 .46468 L .59032 .44559 L p F P
0 0 0 r
s
.247 .353 .697 r
.60856 .46468 m .5946 .46696 L .60831 .48715 L p F P
0 0 0 r
s
.278 .409 .804 r
.49038 .40269 m .48731 .40323 L .4752 .42375 L p F P
0 0 0 r
s
.278 .409 .804 r
.4752 .42375 m .4812 .42272 L .49038 .40269 L p F P
0 0 0 r
s
.216 .302 .599 r
.59047 .53403 m .57173 .53692 L .57493 .55723 L p F P
0 0 0 r
s
.216 .302 .599 r
.55545 .56018 m .57493 .55723 L .57173 .53692 L p F P
0 0 0 r
s
.24 .35 .67 r
.57143 .52226 m
.57422 .54996 L
s
.53532 .55589 m
.57422 .54996 L
s
.2536 .40437 m
.26498 .41761 L
s
.30249 .41095 m
.26498 .41761 L
s
.186 .253 .503 r
.49757 .58825 m .47811 .59115 L .47818 .60869 L p F P
0 0 0 r
s
.186 .253 .503 r
.45888 .61151 m .47818 .60869 L .47811 .59115 L p F P
0 0 0 r
s
.24 .35 .67 r
.38116 .62721 m
.39817 .62473 L
s
.38116 .62721 m
.37699 .64638 L
s
.271 .395 .778 r
.52954 .41443 m .52346 .41547 L .53426 .4337 L p F P
0 0 0 r
s
.83 .24 .1 r
.52523 .41078 m
.52686 .41489 L
s
.53418 .4334 m
.5343 .4337 L
s
.271 .395 .778 r
.53426 .4337 m .54315 .4322 L .52954 .41443 L p F P
0 0 0 r
s
.247 .353 .697 r
.60831 .48715 m .62433 .48458 L .60856 .46468 L p F P
0 0 0 r
s
.238 .338 .668 r
.62433 .48458 m .60831 .48715 L .6196 .50769 L p F P
0 0 0 r
s
.238 .338 .668 r
.60196 .51046 m .6196 .50769 L .60831 .48715 L p F P
0 0 0 r
s
.24 .35 .67 r
.5675 .49364 m
.60643 .48741 L
s
.202 .28 .556 r
.55545 .56018 m .53608 .56312 L .5368 .58241 L p F P
0 0 0 r
s
.202 .28 .556 r
.51714 .58533 m .5368 .58241 L .53608 .56312 L p F P
0 0 0 r
s
.24 .35 .67 r
.53532 .55589 m
.53646 .58164 L
s
.227 .321 .635 r
.6196 .50769 m .60196 .51046 L .6093 .53112 L p F P
0 0 0 r
s
.227 .321 .635 r
.59047 .53403 m .6093 .53112 L .60196 .51046 L p F P
0 0 0 r
s
.278 .409 .804 r
.49346 .40216 m .49038 .40269 L .4812 .42272 L p F P
0 0 0 r
s
.278 .409 .804 r
.4812 .42272 m .4872 .42169 L .49346 .40216 L p F P
0 0 0 r
s
.263 .382 .752 r
.56995 .42767 m .561 .42919 L .57873 .44752 L p F P
0 0 0 r
s
.24 .35 .67 r
.55673 .43739 m
.56254 .46504 L
s
.263 .382 .752 r
.57873 .44752 m .59032 .44559 L .56995 .42767 L p F P
0 0 0 r
s
.83 .24 .1 r
.58081 .43722 m
.5882 .43858 L
s
.5882 .43858 m
.5909 .44619 L
s
1 .312 .126 r
.38359 .51957 m .38967 .53055 L .39708 .50992 L p F P
0 0 0 r
s
1 .312 .126 r
.39708 .50992 m .39148 .4995 L .38359 .51957 L p F P
0 0 0 r
s
.83 .24 .1 r
.44275 .43707 m
.4686 .42347 L
s
.4686 .42347 m
.47873 .42001 L
s
.24 .35 .67 r
.37871 .39742 m
.388 .41582 L
s
.42621 .40915 m
.388 .41582 L
s
.278 .409 .804 r
.49653 .40162 m .49346 .40216 L .4872 .42169 L p F P
0 0 0 r
s
.278 .409 .804 r
.4872 .42169 m .49322 .42066 L .49653 .40162 L p F P
0 0 0 r
s
.255 .368 .725 r
.60195 .44366 m .59032 .44559 L .60856 .46468 L p F P
0 0 0 r
s
.24 .35 .67 r
.56254 .46504 m
.6015 .45864 L
s
.255 .368 .725 r
.60856 .46468 m .62257 .4624 L .60195 .44366 L p F P
0 0 0 r
s
.24 .35 .67 r
.6015 .45864 m
.60643 .48741 L
s
.83 .24 .1 r
.61722 .46327 m
.6202 .47208 L
s
.247 .353 .697 r
.62257 .4624 m .60856 .46468 L .62433 .48458 L p F P
0 0 0 r
s
.83 .24 .1 r
.62352 .47439 m
.6404 .48613 L
s
.271 .395 .778 r
.53562 .41338 m .52954 .41443 L .54315 .4322 L p F P
0 0 0 r
s
.271 .395 .778 r
.54315 .4322 m .55206 .4307 L .53562 .41338 L p F P
0 0 0 r
s
.164 .219 .436 r
.43968 .61433 m .42059 .61713 L .42266 .63217 L p F P
0 0 0 r
s
.164 .219 .436 r
.40415 .63484 m .42266 .63217 L .42059 .61713 L p F P
0 0 0 r
s
.24 .35 .67 r
.41929 .62165 m
.42107 .59883 L
s
.40209 .62416 m
.41929 .62165 L
s
.996 .278 .11 r
.38238 .56995 m .38881 .58104 L .391 .56176 L p F P
0 0 0 r
s
.996 .278 .11 r
.391 .56176 m .38472 .5507 L .38238 .56995 L p F P
0 0 0 r
s
1 .307 .13 r
.46578 .41707 m .4675 .42094 L .48338 .40176 L p F P
0 0 0 r
s
1 .307 .13 r
.48423 .40376 m .48338 .40176 L .4675 .42094 L p F P
0 0 0 r
s
.24 .35 .67 r
.46978 .41673 m
.47262 .42494 L
s
.278 .409 .804 r
.49962 .40108 m .49653 .40162 L .49322 .42066 L p F P
0 0 0 r
s
.278 .409 .804 r
.49322 .42066 m .49925 .41963 L .49962 .40108 L p F P
0 0 0 r
s
.216 .302 .599 r
.6093 .53112 m .59047 .53403 L .59451 .55427 L p F P
0 0 0 r
s
.216 .302 .599 r
.57493 .55723 m .59451 .55427 L .59047 .53403 L p F P
0 0 0 r
s
.263 .382 .752 r
.57893 .42616 m .56995 .42767 L .59032 .44559 L p F P
0 0 0 r
s
.263 .382 .752 r
.59032 .44559 m .60195 .44366 L .57893 .42616 L p F P
0 0 0 r
s
.247 .353 .697 r
.62433 .48458 m .64041 .482 L .62257 .4624 L p F P
0 0 0 r
s
.238 .338 .668 r
.64041 .482 m .62433 .48458 L .63731 .50491 L p F P
0 0 0 r
s
.83 .24 .1 r
.64001 .48495 m
.6404 .48613 L
s
.238 .338 .668 r
.6196 .50769 m .63731 .50491 L .62433 .48458 L p F P
0 0 0 r
s
.186 .253 .503 r
.51714 .58533 m .49757 .58825 L .49758 .60584 L p F P
0 0 0 r
s
.24 .35 .67 r
.49683 .56176 m
.4976 .58743 L
s
.186 .253 .503 r
.47818 .60869 m .49758 .60584 L .49757 .58825 L p F P
0 0 0 r
s
.24 .35 .67 r
.45914 .59316 m
.4976 .58743 L
s
.271 .395 .778 r
.54172 .41234 m .53562 .41338 L .55206 .4307 L p F P
0 0 0 r
s
.271 .395 .778 r
.55206 .4307 m .561 .42919 L .54172 .41234 L p F P
0 0 0 r
s
.227 .321 .635 r
.63731 .50491 m .6196 .50769 L .62822 .5282 L p F P
0 0 0 r
s
.227 .321 .635 r
.6093 .53112 m .62822 .5282 L .6196 .50769 L p F P
0 0 0 r
s
.24 .35 .67 r
.60643 .48741 m
.61048 .51616 L
s
.57143 .52226 m
.61048 .51616 L
s
1 .318 .133 r
.44746 .4304 m .44484 .42475 L .42873 .44186 L p F P
0 0 0 r
s
1 .314 .132 r
.44484 .42475 m .44746 .4304 L .46405 .41318 L p F P
0 0 0 r
s
1 .314 .132 r
.46578 .41707 m .46405 .41318 L .44746 .4304 L p F P
0 0 0 r
s
.202 .28 .556 r
.57493 .55723 m .55545 .56018 L .55657 .57946 L p F P
0 0 0 r
s
.202 .28 .556 r
.5368 .58241 m .55657 .57946 L .55545 .56018 L p F P
0 0 0 r
s
.278 .409 .804 r
.5027 .40055 m .49962 .40108 L .49925 .41963 L p F P
0 0 0 r
s
.278 .409 .804 r
.49925 .41963 m .50529 .41859 L .5027 .40055 L p F P
0 0 0 r
s
.655 .2 .091 r
.61971 .45379 m .62257 .4624 L .60195 .44366 L p F P
0 0 0 r
s
.24 .35 .67 r
.6015 .45864 m
.61647 .45619 L
s
.504 .158 .074 r
.62257 .4624 m .61971 .45379 L .63727 .47229 L p F P
0 0 0 r
s
.24 .35 .67 r
.62124 .4554 m
.64086 .45218 L
s
.504 .158 .074 r
.63727 .47229 m .64041 .482 L .62257 .4624 L p F P
0 0 0 r
s
.83 .24 .1 r
.43113 .67842 m
.41777 .65834 L
s
.278 .409 .804 r
.50579 .40001 m .5027 .40055 L .50529 .41859 L p F P
0 0 0 r
s
.278 .409 .804 r
.50529 .41859 m .51133 .41755 L .50579 .40001 L p F P
0 0 0 r
s
.24 .35 .67 r
.47262 .42494 m
.51123 .41832 L
s
.51123 .41832 m
.51802 .44389 L
s
.271 .395 .778 r
.54783 .41129 m .54172 .41234 L .561 .42919 L p F P
0 0 0 r
s
.271 .395 .778 r
.561 .42919 m .56995 .42767 L .54783 .41129 L p F P
0 0 0 r
s
.768 .232 .103 r
.59945 .4364 m .60195 .44366 L .57893 .42616 L p F P
0 0 0 r
s
.24 .35 .67 r
.55673 .43739 m
.58796 .43214 L
s
.655 .2 .091 r
.60195 .44366 m .59945 .4364 L .61971 .45379 L p F P
0 0 0 r
s
.24 .35 .67 r
.59748 .43881 m
.6015 .45864 L
s
.164 .219 .436 r
.45888 .61151 m .43968 .61433 L .44126 .62948 L p F P
0 0 0 r
s
.164 .219 .436 r
.42266 .63217 m .44126 .62948 L .43968 .61433 L p F P
0 0 0 r
s
.238 .338 .668 r
.63731 .50491 m .65511 .50211 L .64041 .482 L p F P
0 0 0 r
s
.38 .117 .058 r
.64041 .482 m .63727 .47229 L .65177 .49155 L p F P
0 0 0 r
s
.24 .35 .67 r
.64411 .48137 m
.64577 .4811 L
s
.38 .117 .058 r
.65177 .49155 m .65511 .50211 L .64041 .482 L p F P
0 0 0 r
s
.24 .35 .67 r
.60643 .48741 m
.64074 .48191 L
s
.83 .24 .1 r
.54838 .75484 m
.52037 .75287 L
s
.52037 .75287 m
.5102 .73421 L
s
.278 .409 .804 r
.50888 .39947 m .50579 .40001 L .51133 .41755 L p F P
0 0 0 r
s
.278 .409 .804 r
.51133 .41755 m .51739 .41651 L .50888 .39947 L p F P
0 0 0 r
s
.24 .35 .67 r
.33871 .65187 m
.30083 .6573 L
s
.30083 .6573 m
.29358 .672 L
s
.216 .302 .599 r
.62822 .5282 m .6093 .53112 L .6142 .55128 L p F P
0 0 0 r
s
.216 .302 .599 r
.59451 .55427 m .6142 .55128 L .6093 .53112 L p F P
0 0 0 r
s
.24 .35 .67 r
.61048 .51616 m
.61352 .54397 L
s
.57422 .54996 m
.61352 .54397 L
s
1 .307 .13 r
.46405 .41318 m .46578 .41707 L .48253 .39976 L p F P
0 0 0 r
s
1 .307 .13 r
.48338 .40176 m .48253 .39976 L .46578 .41707 L p F P
0 0 0 r
s
1 .321 .132 r
.39671 .46985 m .40178 .4796 L .41428 .46027 L p F P
0 0 0 r
s
1 .321 .132 r
.41428 .46027 m .40995 .45163 L .39671 .46985 L p F P
0 0 0 r
s
1 .321 .133 r
.40995 .45163 m .41428 .46027 L .42873 .44186 L p F P
0 0 0 r
s
.83 .24 .1 r
.4196 .45435 m
.43133 .47804 L
s
.271 .395 .778 r
.55395 .41024 m .54783 .41129 L .56995 .42767 L p F P
0 0 0 r
s
.271 .395 .778 r
.56995 .42767 m .57893 .42616 L .55395 .41024 L p F P
0 0 0 r
s
.24 .35 .67 r
.29167 .39753 m
.30249 .41095 L
s
.3404 .40422 m
.30249 .41095 L
s
.227 .321 .635 r
.65511 .50211 m .63731 .50491 L .64724 .52527 L p F P
0 0 0 r
s
.227 .321 .635 r
.62822 .5282 m .64724 .52527 L .63731 .50491 L p F P
0 0 0 r
s
.186 .253 .503 r
.5368 .58241 m .51714 .58533 L .51708 .60299 L p F P
0 0 0 r
s
.186 .253 .503 r
.49758 .60584 m .51708 .60299 L .51714 .58533 L p F P
0 0 0 r
s
1 .3 .12 r
.37832 .53942 m .38472 .5507 L .38967 .53055 L p F P
0 0 0 r
s
.83 .24 .1 r
.3877 .54463 m
.40008 .56666 L
s
1 .3 .12 r
.38967 .53055 m .38359 .51957 L .37832 .53942 L p F P
0 0 0 r
s
.83 .24 .1 r
.3877 .54463 m
.39746 .52061 L
s
1 .321 .133 r
.42873 .44186 m .42521 .43458 L .40995 .45163 L p F P
0 0 0 r
s
1 .318 .133 r
.42521 .43458 m .42873 .44186 L .44484 .42475 L p F P
0 0 0 r
s
.83 .24 .1 r
.4196 .45435 m
.44275 .43707 L
s
.24 .35 .67 r
.42621 .40915 m
.43394 .43021 L
s
.278 .409 .804 r
.51197 .39893 m .50888 .39947 L .51739 .41651 L p F P
0 0 0 r
s
.278 .409 .804 r
.51739 .41651 m .52346 .41547 L .51197 .39893 L p F P
0 0 0 r
s
.202 .28 .556 r
.59451 .55427 m .57493 .55723 L .57645 .5765 L p F P
0 0 0 r
s
.202 .28 .556 r
.55657 .57946 m .57645 .5765 L .57493 .55723 L p F P
0 0 0 r
s
.24 .35 .67 r
.57422 .54996 m
.57573 .57579 L
s
.83 .24 .1 r
.67425 .54833 m
.67927 .57204 L
s
.67209 .68796 m
.66493 .66798 L
s
.67209 .68796 m
.65399 .70967 L
s
.24 .35 .67 r
.64086 .45218 m
.64577 .4811 L
s
.64577 .4811 m
.68552 .47474 L
s
.64577 .4811 m
.64621 .48416 L
s
.855 .256 .112 r
.57689 .42047 m .57893 .42616 L .55395 .41024 L p F P
0 0 0 r
s
.768 .232 .103 r
.57893 .42616 m .57689 .42047 L .59945 .4364 L p F P
0 0 0 r
s
.24 .35 .67 r
.59237 .4314 m
.59585 .43082 L
s
.59585 .43082 m
.59657 .43437 L
s
.278 .409 .804 r
.51506 .39839 m .51197 .39893 L .52346 .41547 L p F P
0 0 0 r
s
.278 .409 .804 r
.52346 .41547 m .52954 .41443 L .51506 .39839 L p F P
0 0 0 r
s
.83 .24 .1 r
.48393 .72687 m
.46112 .71456 L
s
.46112 .71456 m
.44974 .69509 L
s
1 .318 .13 r
.38578 .48889 m .39148 .4995 L .40178 .4796 L p F P
0 0 0 r
s
1 .318 .13 r
.40178 .4796 m .39671 .46985 L .38578 .48889 L p F P
0 0 0 r
s
.83 .24 .1 r
.40006 .47471 m
.41223 .49814 L
s
.40006 .47471 m
.4196 .45435 L
s
.164 .219 .436 r
.47818 .60869 m .45888 .61151 L .45996 .62678 L p F P
0 0 0 r
s
.164 .219 .436 r
.44126 .62948 m .45996 .62678 L .45888 .61151 L p F P
0 0 0 r
s
.24 .35 .67 r
.45782 .61602 m
.45914 .59316 L
s
.41929 .62165 m
.45782 .61602 L
s
.278 .409 .804 r
.51816 .39786 m .51506 .39839 L .52954 .41443 L p F P
0 0 0 r
s
.278 .409 .804 r
.52954 .41443 m .53562 .41338 L .51816 .39786 L p F P
0 0 0 r
s
.216 .302 .599 r
.64724 .52527 m .62822 .5282 L .63398 .54829 L p F P
0 0 0 r
s
.216 .302 .599 r
.6142 .55128 m .63398 .54829 L .62822 .5282 L p F P
0 0 0 r
s
1 .318 .133 r
.44484 .42475 m .44219 .41904 L .42521 .43458 L p F P
0 0 0 r
s
1 .314 .132 r
.44219 .41904 m .44484 .42475 L .46231 .40926 L p F P
0 0 0 r
s
1 .314 .132 r
.46405 .41318 m .46231 .40926 L .44484 .42475 L p F P
0 0 0 r
s
.24 .35 .67 r
.63539 .42418 m
.64086 .45218 L
s
.68064 .44566 m
.64086 .45218 L
s
.227 .321 .635 r
.64724 .52527 m .66636 .52232 L .65511 .50211 L p F P
0 0 0 r
s
.24 .35 .67 r
.64713 .49055 m
.64994 .51 L
s
.61048 .51616 m
.64994 .51 L
s
.83 .24 .1 r
.66226 .52295 m
.66357 .52708 L
s
.267 .077 .042 r
.65511 .50211 m .65177 .49155 L .66287 .51118 L p F P
0 0 0 r
s
.267 .077 .042 r
.66287 .51118 m .66636 .52232 L .65511 .50211 L p F P
0 0 0 r
s
.83 .24 .1 r
.64557 .49199 m
.65632 .50418 L
s
.65632 .50418 m
.65798 .50941 L
s
.278 .409 .804 r
.52126 .39732 m .51816 .39786 L .53562 .41338 L p F P
0 0 0 r
s
.278 .409 .804 r
.53562 .41338 m .54172 .41234 L .52126 .39732 L p F P
0 0 0 r
s
.186 .253 .503 r
.55657 .57946 m .5368 .58241 L .53669 .60011 L p F P
0 0 0 r
s
.186 .253 .503 r
.51708 .60299 m .53669 .60011 L .5368 .58241 L p F P
0 0 0 r
s
.24 .35 .67 r
.4976 .58743 m
.53646 .58164 L
s
1 .307 .13 r
.46231 .40926 m .46405 .41318 L .48168 .39775 L p F P
0 0 0 r
s
.24 .35 .67 r
.46751 .41015 m
.46765 .41057 L
s
1 .307 .13 r
.48253 .39976 m .48168 .39775 L .46405 .41318 L p F P
0 0 0 r
s
.202 .28 .556 r
.6142 .55128 m .59451 .55427 L .59643 .57353 L p F P
0 0 0 r
s
.202 .28 .556 r
.57645 .5765 m .59643 .57353 L .59451 .55427 L p F P
0 0 0 r
s
.83 .24 .1 r
.68511 .61862 m
.67819 .5972 L
s
.68511 .61862 m
.678 .64378 L
s
.72 .193 .072 r
.39209 .61456 m .39818 .6248 L .39543 .60945 L p F P
0 0 0 r
s
.83 .24 .1 r
.39608 .59107 m
.39786 .61514 L
s
.39786 .61514 m
.40342 .62456 L
s
.72 .193 .072 r
.39543 .60945 m .38915 .59877 L .39209 .61456 L p F P
0 0 0 r
s
.24 .35 .67 r
.64994 .51 m
.65888 .5086 L
s
.66121 .50823 m
.68981 .50376 L
s
.278 .409 .804 r
.52436 .39678 m .52126 .39732 L .54172 .41234 L p F P
0 0 0 r
s
.278 .409 .804 r
.54172 .41234 m .54783 .41129 L .52436 .39678 L p F P
0 0 0 r
s
.24 .35 .67 r
.51123 .41832 m
.55024 .41163 L
s
.888 .244 .094 r
.38274 .58789 m .38915 .59877 L .38881 .58104 L p F P
0 0 0 r
s
.888 .244 .094 r
.38881 .58104 m .38238 .56995 L .38274 .58789 L p F P
0 0 0 r
s
.164 .219 .436 r
.49758 .60584 m .47818 .60869 L .47876 .62407 L p F P
0 0 0 r
s
.164 .219 .436 r
.45996 .62678 m .47876 .62407 L .47818 .60869 L p F P
0 0 0 r
s
.278 .409 .804 r
.52747 .39623 m .52436 .39678 L .54783 .41129 L p F P
0 0 0 r
s
.278 .409 .804 r
.54783 .41129 m .55395 .41024 L .52747 .39623 L p F P
0 0 0 r
s
.768 .232 .103 r
.59691 .42906 m .59945 .4364 L .57689 .42047 L p F P
0 0 0 r
s
.655 .2 .091 r
.59945 .4364 m .59691 .42906 L .6168 .44506 L p F P
0 0 0 r
s
.24 .35 .67 r
.59854 .43037 m
.63539 .42418 L
s
.655 .2 .091 r
.6168 .44506 m .61971 .45379 L .59945 .4364 L p F P
0 0 0 r
s
.83 .24 .1 r
.595 .4413 m
.61212 .44816 L
s
.61212 .44816 m
.61523 .45739 L
s
1 .312 .126 r
.3774 .50838 m .38359 .51957 L .39148 .4995 L p F P
0 0 0 r
s
1 .312 .126 r
.39148 .4995 m .38578 .48889 L .3774 .50838 L p F P
0 0 0 r
s
.216 .302 .599 r
.66636 .52232 m .64724 .52527 L .65388 .54527 L p F P
0 0 0 r
s
.216 .302 .599 r
.63398 .54829 m .65388 .54527 L .64724 .52527 L p F P
0 0 0 r
s
.24 .35 .67 r
.64994 .51 m
.65324 .53791 L
s
.61352 .54397 m
.65324 .53791 L
s
.37699 .64638 m
.33871 .65187 L
s
.33871 .65187 m
.33207 .66656 L
s
.561 .145 .055 r
.40339 .63758 m .40901 .64701 L .40415 .63484 L p F P
0 0 0 r
s
.561 .145 .055 r
.40415 .63484 m .39818 .6248 L .40339 .63758 L p F P
0 0 0 r
s
.135 .173 .347 r
.42266 .63217 m .40415 .63484 L .40901 .64701 L p F P
0 0 0 r
s
.83 .24 .1 r
.40556 .63782 m
.40835 .64251 L
s
.504 .158 .074 r
.61971 .45379 m .6168 .44506 L .63407 .46242 L p F P
0 0 0 r
s
.504 .158 .074 r
.63407 .46242 m .63727 .47229 L .61971 .45379 L p F P
0 0 0 r
s
.285 .422 .829 r
.48423 .40376 m .48731 .40323 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .299 .127 r
.5 .38446 m .48338 .40176 L .48423 .40376 L closepath p F P
0 0 0 r
s
.922 .274 .118 r
.55248 .4063 m .55395 .41024 L .52747 .39623 L p F P
0 0 0 r
s
.855 .256 .112 r
.55395 .41024 m .55248 .4063 L .57689 .42047 L p F P
0 0 0 r
s
.24 .35 .67 r
.55024 .41163 m
.55673 .43739 L
s
.33015 .39061 m
.3404 .40422 L
s
.37871 .39742 m
.3404 .40422 L
s
.186 .253 .503 r
.57645 .5765 m .55657 .57946 L .5564 .59723 L p F P
0 0 0 r
s
.186 .253 .503 r
.53669 .60011 m .5564 .59723 L .55657 .57946 L p F P
0 0 0 r
s
.83 .24 .1 r
.57718 .75122 m
.54838 .75484 L
s
.54838 .75484 m
.5387 .7361 L
s
.855 .256 .112 r
.57483 .41472 m .57689 .42047 L .55248 .4063 L p F P
0 0 0 r
s
.24 .35 .67 r
.55024 .41163 m
.55706 .41046 L
s
.83 .24 .1 r
.55267 .40902 m
.55431 .41339 L
s
.54233 .40907 m
.55267 .40902 L
s
.768 .232 .103 r
.57689 .42047 m .57483 .41472 L .59691 .42906 L p F P
0 0 0 r
s
.285 .422 .829 r
.48731 .40323 m .49038 .40269 L .5 .38446 L closepath p F P
0 0 0 r
s
.202 .28 .556 r
.63398 .54829 m .6142 .55128 L .61652 .57054 L p F P
0 0 0 r
s
.202 .28 .556 r
.59643 .57353 m .61652 .57054 L .6142 .55128 L p F P
0 0 0 r
s
.24 .35 .67 r
.61352 .54397 m
.61542 .56987 L
s
.21593 .41113 m
.20372 .40341 L
s
.2536 .40437 m
.21593 .41113 L
s
1 .314 .132 r
.46231 .40926 m .46056 .40532 L .44219 .41904 L p F P
0 0 0 r
s
1 .307 .13 r
.46056 .40532 m .46231 .40926 L .48082 .39573 L p F P
0 0 0 r
s
.24 .35 .67 r
.46621 .40641 m
.46636 .40685 L
s
1 .307 .13 r
.48168 .39775 m .48082 .39573 L .46231 .40926 L p F P
0 0 0 r
s
.24 .35 .67 r
.46482 .4024 m
.46509 .40318 L
s
.42621 .40915 m
.46482 .4024 L
s
1 .321 .133 r
.40555 .44287 m .40995 .45163 L .42521 .43458 L p F P
0 0 0 r
s
1 .321 .133 r
.42521 .43458 m .42165 .42722 L .40555 .44287 L p F P
0 0 0 r
s
1 .318 .133 r
.42165 .42722 m .42521 .43458 L .44219 .41904 L p F P
0 0 0 r
s
.285 .422 .829 r
.49038 .40269 m .49346 .40216 L .5 .38446 L closepath p F P
0 0 0 r
s
.996 .278 .11 r
.37582 .55863 m .38238 .56995 L .38472 .5507 L p F P
0 0 0 r
s
.996 .278 .11 r
.38472 .5507 m .37832 .53942 L .37582 .55863 L p F P
0 0 0 r
s
.83 .24 .1 r
.38349 .56929 m
.3877 .54463 L
s
.24 .35 .67 r
.68064 .44566 m
.68552 .47474 L
s
.72569 .4683 m
.68552 .47474 L
s
.68552 .47474 m
.68981 .50376 L
s
.83 .24 .1 r
.65399 .70967 m
.64642 .69 L
s
.65399 .70967 m
.63136 .72805 L
s
.285 .422 .829 r
.49346 .40216 m .49653 .40162 L .5 .38446 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.46482 .4024 m
.46786 .40187 L
s
1 .318 .133 r
.44219 .41904 m .43952 .41329 L .42165 .42722 L p F P
0 0 0 r
s
1 .314 .132 r
.43952 .41329 m .44219 .41904 L .46056 .40532 L p F P
0 0 0 r
s
1 .299 .127 r
.5 .38446 m .48253 .39976 L .48338 .40176 L closepath p F P
0 0 0 r
s
.164 .219 .436 r
.51708 .60299 m .49758 .60584 L .49764 .62134 L p F P
0 0 0 r
s
.164 .219 .436 r
.47876 .62407 m .49764 .62134 L .49758 .60584 L p F P
0 0 0 r
s
.24 .35 .67 r
.49676 .61034 m
.4976 .58743 L
s
.45782 .61602 m
.49676 .61034 L
s
.285 .422 .829 r
.49653 .40162 m .49962 .40108 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .321 .132 r
.39155 .45994 m .39671 .46985 L .40995 .45163 L p F P
0 0 0 r
s
1 .321 .132 r
.40995 .45163 m .40555 .44287 L .39155 .45994 L p F P
0 0 0 r
s
.216 .302 .599 r
.65388 .54527 m .67387 .54224 L .66636 .52232 L p F P
0 0 0 r
s
.83 .24 .1 r
.67242 .54246 m
.67425 .54833 L
s
.187 .054 .028 r
.66636 .52232 m .66287 .51118 L .6703 .53079 L p F P
0 0 0 r
s
.187 .054 .028 r
.6703 .53079 m .67387 .54224 L .66636 .52232 L p F P
0 0 0 r
s
.285 .422 .829 r
.49962 .40108 m .5027 .40055 L .5 .38446 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.62951 .39803 m
.63539 .42418 L
s
.67534 .41747 m
.63539 .42418 L
s
.38 .117 .058 r
.63727 .47229 m .63407 .46242 L .64836 .4808 L p F P
0 0 0 r
s
.38 .117 .058 r
.64836 .4808 m .65177 .49155 L .63727 .47229 L p F P
0 0 0 r
s
.24 .35 .67 r
.67534 .41747 m
.68064 .44566 L
s
.72084 .43906 m
.68064 .44566 L
s
.135 .173 .347 r
.44126 .62948 m .42266 .63217 L .42659 .6445 L p F P
0 0 0 r
s
.135 .173 .347 r
.40901 .64701 m .42659 .6445 L .42266 .63217 L p F P
0 0 0 r
s
.24 .35 .67 r
.41568 .64083 m
.41929 .62165 L
s
.83 .24 .1 r
.41087 .64674 m
.41777 .65834 L
s
.285 .422 .829 r
.5027 .40055 m .50579 .40001 L .5 .38446 L closepath p F P
0 0 0 r
s
.186 .253 .503 r
.59643 .57353 m .57645 .5765 L .57621 .59432 L p F P
0 0 0 r
s
.186 .253 .503 r
.5564 .59723 m .57621 .59432 L .57645 .5765 L p F P
0 0 0 r
s
.24 .35 .67 r
.53646 .58164 m
.57573 .57579 L
s
.285 .422 .829 r
.50579 .40001 m .50888 .39947 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .299 .127 r
.5 .38446 m .48168 .39775 L .48253 .39976 L closepath p F P
0 0 0 r
s
.922 .274 .118 r
.52747 .39623 m .52668 .39421 L .55248 .4063 L p F P
0 0 0 r
s
.922 .274 .118 r
.551 .40235 m .55248 .4063 L .52668 .39421 L p F P
0 0 0 r
s
.24 .35 .67 r
.54771 .40327 m
.55024 .41163 L
s
.855 .256 .112 r
.55248 .4063 m .551 .40235 L .57483 .41472 L p F P
0 0 0 r
s
.202 .28 .556 r
.65388 .54527 m .63398 .54829 L .63671 .56753 L p F P
0 0 0 r
s
.202 .28 .556 r
.61652 .57054 m .63671 .56753 L .63398 .54829 L p F P
0 0 0 r
s
.285 .422 .829 r
.50888 .39947 m .51197 .39893 L .5 .38446 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.7301 .49747 m
.68981 .50376 L
s
.68981 .50376 m
.69337 .53179 L
s
.285 .422 .829 r
.51197 .39893 m .51506 .39839 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .314 .132 r
.46056 .40532 m .4588 .40136 L .43952 .41329 L p F P
0 0 0 r
s
1 .307 .13 r
.4588 .40136 m .46056 .40532 L .47996 .39371 L p F P
0 0 0 r
s
1 .307 .13 r
.48082 .39573 m .47996 .39371 L .46056 .40532 L p F P
0 0 0 r
s
.285 .422 .829 r
.51506 .39839 m .51816 .39786 L .5 .38446 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.60532 .74214 m
.57718 .75122 L
s
.57718 .75122 m
.56804 .73233 L
s
1 .318 .13 r
.37997 .47809 m .38578 .48889 L .39671 .46985 L p F P
0 0 0 r
s
1 .318 .13 r
.39671 .46985 m .39155 .45994 L .37997 .47809 L p F P
0 0 0 r
s
.164 .219 .436 r
.53669 .60011 m .51708 .60299 L .51663 .6186 L p F P
0 0 0 r
s
.164 .219 .436 r
.49764 .62134 m .51663 .6186 L .51708 .60299 L p F P
0 0 0 r
s
1 .3 .12 r
.37179 .52791 m .37832 .53942 L .38359 .51957 L p F P
0 0 0 r
s
1 .3 .12 r
.38359 .51957 m .3774 .50838 L .37179 .52791 L p F P
0 0 0 r
s
.24 .35 .67 r
.65324 .53791 m
.67124 .53516 L
s
.285 .422 .829 r
.51816 .39786 m .52126 .39732 L .5 .38446 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.63136 .72805 m
.62331 .70869 L
s
.63136 .72805 m
.60532 .74214 L
s
1 .299 .127 r
.5 .38446 m .48082 .39573 L .48168 .39775 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.40693 .64209 m
.41568 .64083 L
s
.37699 .64638 m
.40615 .6422 L
s
.37699 .64638 m
.37098 .66105 L
s
.855 .256 .112 r
.57276 .40893 m .57483 .41472 L .551 .40235 L p F P
0 0 0 r
s
.24 .35 .67 r
.5703 .40818 m
.58967 .40486 L
s
.768 .232 .103 r
.57483 .41472 m .57276 .40893 L .59435 .42162 L p F P
0 0 0 r
s
.24 .35 .67 r
.5936 .42136 m
.59516 .42792 L
s
.768 .232 .103 r
.59435 .42162 m .59691 .42906 L .57483 .41472 L p F P
0 0 0 r
s
.24 .35 .67 r
.58967 .40486 m
.59355 .42115 L
s
.83 .24 .1 r
.44974 .69509 m
.43113 .67842 L
s
.43113 .67842 m
.41905 .65806 L
s
.285 .422 .829 r
.52126 .39732 m .52436 .39678 L .5 .38446 L closepath p F P
0 0 0 r
s
.135 .173 .347 r
.45996 .62678 m .44126 .62948 L .44426 .64198 L p F P
0 0 0 r
s
.135 .173 .347 r
.42659 .6445 m .44426 .64198 L .44126 .62948 L p F P
0 0 0 r
s
.655 .2 .091 r
.59691 .42906 m .59435 .42162 L .61385 .43621 L p F P
0 0 0 r
s
.655 .2 .091 r
.61385 .43621 m .6168 .44506 L .59691 .42906 L p F P
0 0 0 r
s
.24 .35 .67 r
.36905 .38363 m
.37871 .39742 L
s
.41742 .39055 m
.37871 .39742 L
s
.285 .422 .829 r
.52436 .39678 m .52747 .39623 L .5 .38446 L closepath p F P
0 0 0 r
s
.186 .253 .503 r
.61652 .57054 m .59643 .57353 L .59613 .5914 L p F P
0 0 0 r
s
.186 .253 .503 r
.57621 .59432 m .59613 .5914 L .59643 .57353 L p F P
0 0 0 r
s
.83 .24 .1 r
.60532 .74214 m
.59673 .72305 L
s
.202 .28 .556 r
.67387 .54224 m .65388 .54527 L .65702 .56451 L p F P
0 0 0 r
s
.202 .28 .556 r
.63671 .56753 m .65702 .56451 L .65388 .54527 L p F P
0 0 0 r
s
.24 .35 .67 r
.65324 .53791 m
.65553 .56389 L
s
.975 .288 .123 r
.52668 .39421 m .52747 .39623 L .5 .38446 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.50384 .39558 m
.51123 .41832 L
s
.83 .24 .1 r
.5102 .73421 m
.48393 .72687 L
s
.48393 .72687 m
.4729 .70746 L
s
.24 .35 .67 r
.242 .39647 m
.2536 .40437 L
s
.29167 .39753 m
.2536 .40437 L
s
.29358 .672 m
.2555 .67739 L
s
.24578 .68689 m
.2555 .67739 L
s
1 .318 .133 r
.41806 .41976 m .42165 .42722 L .43952 .41329 L p F P
0 0 0 r
s
1 .318 .133 r
.43952 .41329 m .43683 .40748 L .41806 .41976 L p F P
0 0 0 r
s
1 .314 .132 r
.43683 .40748 m .43952 .41329 L .4588 .40136 L p F P
0 0 0 r
s
.267 .077 .042 r
.65177 .49155 m .64836 .4808 L .65932 .49983 L p F P
0 0 0 r
s
.267 .077 .042 r
.65932 .49983 m .66287 .51118 L .65177 .49155 L p F P
0 0 0 r
s
.922 .274 .118 r
.52668 .39421 m .52589 .39218 L .551 .40235 L p F P
0 0 0 r
s
.922 .274 .118 r
.54951 .39836 m .551 .40235 L .52589 .39218 L p F P
0 0 0 r
s
.855 .256 .112 r
.551 .40235 m .54951 .39836 L .57276 .40893 L p F P
0 0 0 r
s
1 .299 .127 r
.5 .38446 m .47996 .39371 L .48082 .39573 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.48043 .39967 m
.50384 .39558 L
s
.72084 .43906 m
.72569 .4683 L
s
.76629 .4618 m
.72569 .4683 L
s
.72569 .4683 m
.7301 .49747 L
s
1 .321 .133 r
.40109 .43398 m .40555 .44287 L .42165 .42722 L p F P
0 0 0 r
s
1 .321 .133 r
.42165 .42722 m .41806 .41976 L .40109 .43398 L p F P
0 0 0 r
s
.164 .219 .436 r
.5564 .59723 m .53669 .60011 L .53571 .61584 L p F P
0 0 0 r
s
.164 .219 .436 r
.51663 .6186 m .53571 .61584 L .53669 .60011 L p F P
0 0 0 r
s
.83 .24 .1 r
.67927 .57204 m
.67819 .5972 L
s
1 .314 .132 r
.4588 .40136 m .45703 .39737 L .43683 .40748 L p F P
0 0 0 r
s
1 .307 .13 r
.45703 .39737 m .4588 .40136 L .47909 .39168 L p F P
0 0 0 r
s
.24 .35 .67 r
.4634 .39916 m
.4636 .39962 L
s
1 .307 .13 r
.47996 .39371 m .47909 .39168 L .4588 .40136 L p F P
0 0 0 r
s
.83 .24 .1 r
.45743 .39834 m
.4686 .42347 L
s
.504 .158 .074 r
.6168 .44506 m .61385 .43621 L .63083 .45239 L p F P
0 0 0 r
s
.504 .158 .074 r
.63083 .45239 m .63407 .46242 L .6168 .44506 L p F P
0 0 0 r
s
.83 .24 .1 r
.678 .64378 m
.67086 .62267 L
s
.678 .64378 m
.66493 .66798 L
s
.975 .288 .123 r
.52589 .39218 m .52668 .39421 L .5 .38446 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.66978 .39112 m
.67534 .41747 L
s
.71572 .41069 m
.67534 .41747 L
s
.135 .173 .347 r
.47876 .62407 m .45996 .62678 L .46201 .63945 L p F P
0 0 0 r
s
.135 .173 .347 r
.44426 .64198 m .46201 .63945 L .45996 .62678 L p F P
0 0 0 r
s
.24 .35 .67 r
.45478 .63523 m
.45782 .61602 L
s
.71572 .41069 m
.72084 .43906 L
s
.76147 .43239 m
.72084 .43906 L
s
1 .299 .127 r
.5 .38446 m .47909 .39168 L .47996 .39371 L closepath p F P
0 0 0 r
s
.72 .193 .072 r
.38589 .60412 m .39209 .61456 L .38915 .59877 L p F P
0 0 0 r
s
.72 .193 .072 r
.38915 .59877 m .38274 .58789 L .38589 .60412 L p F P
0 0 0 r
s
.83 .24 .1 r
.38349 .56929 m
.39608 .59107 L
s
.186 .253 .503 r
.63671 .56753 m .61652 .57054 L .61615 .58847 L p F P
0 0 0 r
s
.186 .253 .503 r
.59613 .5914 m .61615 .58847 L .61652 .57054 L p F P
0 0 0 r
s
.24 .35 .67 r
.57573 .57579 m
.61542 .56987 L
s
1 .312 .126 r
.37108 .49697 m .3774 .50838 L .38578 .48889 L p F P
0 0 0 r
s
.83 .24 .1 r
.3849 .49745 m
.39746 .52061 L
s
1 .312 .126 r
.38578 .48889 m .37997 .47809 L .37108 .49697 L p F P
0 0 0 r
s
.83 .24 .1 r
.3849 .49745 m
.40006 .47471 L
s
.202 .28 .556 r
.65702 .56451 m .67744 .56147 L .67387 .54224 L p F P
0 0 0 r
s
.66 .179 .065 r
.67387 .54224 m .6703 .53079 L .67383 .54997 L p F P
0 0 0 r
s
.24 .35 .67 r
.67237 .53499 m
.69337 .53179 L
s
.67165 .5351 m
.67237 .53499 L
s
.66 .179 .065 r
.67383 .54997 m .67744 .56147 L .67387 .54224 L p F P
0 0 0 r
s
1 .321 .132 r
.38632 .44987 m .39155 .45994 L .40555 .44287 L p F P
0 0 0 r
s
1 .321 .132 r
.40555 .44287 m .40109 .43398 L .38632 .44987 L p F P
0 0 0 r
s
.888 .244 .094 r
.37621 .57679 m .38274 .58789 L .38238 .56995 L p F P
0 0 0 r
s
.888 .244 .094 r
.38238 .56995 m .37582 .55863 L .37621 .57679 L p F P
0 0 0 r
s
.24 .35 .67 r
.77083 .4911 m
.7301 .49747 L
s
.7301 .49747 m
.73394 .5256 L
s
.975 .288 .123 r
.5251 .39015 m .52589 .39218 L .5 .38446 L closepath p F P
0 0 0 r
s
.922 .274 .118 r
.52589 .39218 m .5251 .39015 L .54951 .39836 L p F P
0 0 0 r
s
.922 .274 .118 r
.54802 .39436 m .54951 .39836 L .5251 .39015 L p F P
0 0 0 r
s
.24 .35 .67 r
.52987 .39103 m
.53112 .39081 L
s
.50384 .39558 m
.52741 .39146 L
s
.855 .256 .112 r
.54951 .39836 m .54802 .39436 L .57066 .40308 L p F P
0 0 0 r
s
.855 .256 .112 r
.57066 .40308 m .57276 .40893 L .54951 .39836 L p F P
0 0 0 r
s
1 .307 .13 r
.47909 .39168 m .47823 .38964 L .45703 .39737 L p F P
0 0 0 r
s
1 .299 .127 r
.5 .38446 m .47823 .38964 L .47909 .39168 L closepath p F P
0 0 0 r
s
.561 .145 .055 r
.39767 .62799 m .40339 .63758 L .39818 .6248 L p F P
0 0 0 r
s
.561 .145 .055 r
.39818 .6248 m .39209 .61456 L .39767 .62799 L p F P
0 0 0 r
s
.83 .24 .1 r
.39786 .61514 m
.40556 .63782 L
s
.768 .232 .103 r
.57276 .40893 m .57066 .40308 L .59176 .4141 L p F P
0 0 0 r
s
.24 .35 .67 r
.58967 .40486 m
.62951 .39803 L
s
.768 .232 .103 r
.59176 .4141 m .59435 .42162 L .57276 .40893 L p F P
0 0 0 r
s
.83 .24 .1 r
.55267 .40902 m
.57941 .41375 L
s
.57941 .41375 m
.58646 .43367 L
s
.164 .219 .436 r
.57621 .59432 m .5564 .59723 L .5549 .61307 L p F P
0 0 0 r
s
.164 .219 .436 r
.53571 .61584 m .5549 .61307 L .5564 .59723 L p F P
0 0 0 r
s
.24 .35 .67 r
.49676 .61034 m
.53612 .6046 L
s
.53612 .6046 m
.53646 .58164 L
s
.73394 .5256 m
.69337 .53179 L
s
.69337 .53179 m
.69608 .55785 L
s
1 .314 .132 r
.43411 .40162 m .43683 .40748 L .45703 .39737 L p F P
0 0 0 r
s
1 .314 .132 r
.45703 .39737 m .45524 .39336 L .43411 .40162 L p F P
0 0 0 r
s
1 .307 .13 r
.45524 .39336 m .45703 .39737 L .47823 .38964 L p F P
0 0 0 r
s
.135 .173 .347 r
.49764 .62134 m .47876 .62407 L .47984 .6369 L p F P
0 0 0 r
s
.135 .173 .347 r
.46201 .63945 m .47984 .6369 L .47876 .62407 L p F P
0 0 0 r
s
.24 .35 .67 r
.41568 .64083 m
.45478 .63523 L
s
.38 .117 .058 r
.63407 .46242 m .63083 .45239 L .64489 .46985 L p F P
0 0 0 r
s
.83 .24 .1 r
.61212 .44816 m
.63263 .46223 L
s
.38 .117 .058 r
.64489 .46985 m .64836 .4808 L .63407 .46242 L p F P
0 0 0 r
s
.83 .24 .1 r
.63263 .46223 m
.63943 .48315 L
s
.975 .288 .123 r
.5243 .38811 m .5251 .39015 L .5 .38446 L closepath p F P
0 0 0 r
s
.922 .274 .118 r
.5251 .39015 m .5243 .38811 L .54802 .39436 L p F P
0 0 0 r
s
.24 .35 .67 r
.53318 .39045 m
.54328 .38868 L
s
.54328 .38868 m
.54474 .39349 L
s
1 .318 .133 r
.41441 .41222 m .41806 .41976 L .43683 .40748 L p F P
0 0 0 r
s
1 .318 .133 r
.43683 .40748 m .43411 .40162 L .41441 .41222 L p F P
0 0 0 r
s
.24 .35 .67 r
.41742 .39055 m
.42498 .40653 L
s
.83 .24 .1 r
.43105 .41218 m
.44275 .43707 L
s
.43105 .41218 m
.45743 .39834 L
s
.24 .35 .67 r
.62342 .37468 m
.62951 .39803 L
s
.66978 .39112 m
.62951 .39803 L
s
.996 .278 .11 r
.36913 .54708 m .37582 .55863 L .37832 .53942 L p F P
0 0 0 r
s
.996 .278 .11 r
.37832 .53942 m .37179 .52791 L .36913 .54708 L p F P
0 0 0 r
s
1 .307 .13 r
.47823 .38964 m .47736 .3876 L .45524 .39336 L p F P
0 0 0 r
s
1 .299 .127 r
.5 .38446 m .47736 .3876 L .47823 .38964 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.45743 .39834 m
.48558 .38869 L
s
.48558 .38869 m
.492 .40399 L
s
.186 .253 .503 r
.65702 .56451 m .63671 .56753 L .63629 .58552 L p F P
0 0 0 r
s
.186 .253 .503 r
.61615 .58847 m .63629 .58552 L .63671 .56753 L p F P
0 0 0 r
s
.655 .2 .091 r
.59435 .42162 m .59176 .4141 L .61086 .42723 L p F P
0 0 0 r
s
.655 .2 .091 r
.61086 .42723 m .61385 .43621 L .59435 .42162 L p F P
0 0 0 r
s
.24 .35 .67 r
.28071 .38947 m
.29167 .39753 L
s
.33015 .39061 m
.29167 .39753 L
s
.33207 .66656 m
.29358 .672 L
s
.29358 .672 m
.28452 .68145 L
s
.187 .054 .028 r
.66287 .51118 m .65932 .49983 L .66666 .51911 L p F P
0 0 0 r
s
.187 .054 .028 r
.66666 .51911 m .6703 .53079 L .66287 .51118 L p F P
0 0 0 r
s
.83 .24 .1 r
.65632 .50418 m
.66713 .52558 L
s
.66713 .52558 m
.67037 .53593 L
s
.24 .35 .67 r
.76147 .43239 m
.76629 .4618 L
s
.80732 .45523 m
.76629 .4618 L
s
.76629 .4618 m
.77083 .4911 L
s
.975 .288 .123 r
.5235 .38606 m .5243 .38811 L .5 .38446 L closepath p F P
0 0 0 r
s
.922 .274 .118 r
.5243 .38811 m .5235 .38606 L .54652 .39033 L p F P
0 0 0 r
s
.922 .274 .118 r
.54652 .39033 m .54802 .39436 L .5243 .38811 L p F P
0 0 0 r
s
.164 .219 .436 r
.59613 .5914 m .57621 .59432 L .57418 .61028 L p F P
0 0 0 r
s
.164 .219 .436 r
.5549 .61307 m .57418 .61028 L .57621 .59432 L p F P
0 0 0 r
s
1 .318 .13 r
.37406 .4671 m .37997 .47809 L .39155 .45994 L p F P
0 0 0 r
s
1 .318 .13 r
.39155 .45994 m .38632 .44987 L .37406 .4671 L p F P
0 0 0 r
s
.83 .24 .1 r
.3874 .45035 m
.40006 .47471 L
s
.855 .256 .112 r
.54802 .39436 m .54652 .39033 L .56855 .39718 L p F P
0 0 0 r
s
.855 .256 .112 r
.56855 .39718 m .57066 .40308 L .54802 .39436 L p F P
0 0 0 r
s
1 .307 .13 r
.45345 .38932 m .45524 .39336 L .47736 .3876 L p F P
0 0 0 r
s
1 .307 .13 r
.47736 .3876 m .47649 .38555 L .45345 .38932 L p F P
0 0 0 r
s
1 .299 .127 r
.5 .38446 m .47649 .38555 L .47736 .3876 L closepath p F P
0 0 0 r
s
1 .321 .133 r
.39657 .42497 m .40109 .43398 L .41806 .41976 L p F P
0 0 0 r
s
.83 .24 .1 r
.40741 .42972 m
.4196 .45435 L
s
1 .321 .133 r
.41806 .41976 m .41441 .41222 L .39657 .42497 L p F P
0 0 0 r
s
.83 .24 .1 r
.40741 .42972 m
.43105 .41218 L
s
.135 .173 .347 r
.51663 .6186 m .49764 .62134 L .49777 .63434 L p F P
0 0 0 r
s
.135 .173 .347 r
.47984 .6369 m .49777 .63434 L .49764 .62134 L p F P
0 0 0 r
s
.24 .35 .67 r
.4943 .62956 m
.49676 .61034 L
s
.71048 .38414 m
.71572 .41069 L
s
.75653 .40383 m
.71572 .41069 L
s
.75653 .40383 m
.76147 .43239 L
s
.80253 .42565 m
.76147 .43239 L
s
.095 .112 .226 r
.42659 .6445 m .40901 .64701 L .41616 .65604 L p F P
0 0 0 r
s
.245 .071 .038 r
.41104 .64744 m .41616 .65604 L .40901 .64701 L p F P
0 0 0 r
s
.24 .35 .67 r
.4103 .65549 m
.41208 .65064 L
s
.41241 .64974 m
.41568 .64083 L
s
.245 .071 .038 r
.40901 .64701 m .40339 .63758 L .41104 .64744 L p F P
0 0 0 r
s
.83 .24 .1 r
.40556 .63782 m
.4146 .65138 L
s
1 .314 .132 r
.43137 .3957 m .43411 .40162 L .45524 .39336 L p F P
0 0 0 r
s
1 .314 .132 r
.45524 .39336 m .45345 .38932 L .43137 .3957 L p F P
0 0 0 r
s
.291 .434 .851 r
.5 .38446 m .48779 .37241 L .49093 .37185 L closepath p F P
0 0 0 r
s
.291 .434 .851 r
.5 .38446 m .49093 .37185 L .49408 .37129 L closepath p F P
0 0 0 r
s
.291 .434 .851 r
.5 .38446 m .49408 .37129 L .49724 .37073 L closepath p F P
0 0 0 r
s
.291 .434 .851 r
.5 .38446 m .49724 .37073 L .50039 .37016 L closepath p F P
0 0 0 r
s
.291 .434 .851 r
.5 .38446 m .50039 .37016 L .50355 .3696 L closepath p F P
0 0 0 r
s
.291 .434 .851 r
.5 .38446 m .50355 .3696 L .50671 .36904 L closepath p F P
0 0 0 r
s
.291 .434 .851 r
.5 .38446 m .50671 .36904 L .50988 .36847 L closepath p F P
0 0 0 r
s
.291 .434 .851 r
.5 .38446 m .50988 .36847 L .51304 .36791 L closepath p F P
0 0 0 r
s
.291 .434 .851 r
.5 .38446 m .51304 .36791 L .51621 .36734 L closepath p F P
0 0 0 r
s
1 .299 .127 r
.5 .38446 m .47209 .37521 L .47297 .37729 L closepath p F P
0 0 0 r
s
1 .299 .127 r
.5 .38446 m .47297 .37729 L .47385 .37937 L closepath p F P
0 0 0 r
s
.291 .434 .851 r
.5 .38446 m .47209 .37521 L .47522 .37465 L closepath p F P
0 0 0 r
s
.291 .434 .851 r
.5 .38446 m .47522 .37465 L .47836 .37409 L closepath p F P
0 0 0 r
s
.291 .434 .851 r
.5 .38446 m .47836 .37409 L .4815 .37353 L closepath p F P
0 0 0 r
s
.291 .434 .851 r
.5 .38446 m .4815 .37353 L .48464 .37297 L closepath p F P
0 0 0 r
s
.291 .434 .851 r
.5 .38446 m .48464 .37297 L .48779 .37241 L closepath p F P
0 0 0 r
s
1 .299 .127 r
.5 .38446 m .47385 .37937 L .47473 .38144 L closepath p F P
0 0 0 r
s
1 .299 .127 r
.5 .38446 m .47473 .38144 L .47561 .3835 L closepath p F P
0 0 0 r
s
1 .299 .127 r
.5 .38446 m .47561 .3835 L .47649 .38555 L closepath p F P
0 0 0 r
s
.975 .288 .123 r
.5227 .38401 m .5235 .38606 L .5 .38446 L closepath p F P
0 0 0 r
s
.975 .288 .123 r
.5219 .38195 m .5227 .38401 L .5 .38446 L closepath p F P
0 0 0 r
s
.975 .288 .123 r
.5211 .37988 m .5219 .38195 L .5 .38446 L closepath p F P
0 0 0 r
s
.975 .288 .123 r
.52029 .37781 m .5211 .37988 L .5 .38446 L closepath p F P
0 0 0 r
s
.975 .288 .123 r
.51948 .37573 m .52029 .37781 L .5 .38446 L closepath p F P
0 0 0 r
s
.975 .288 .123 r
.51867 .37364 m .51948 .37573 L .5 .38446 L closepath p F P
0 0 0 r
s
.975 .288 .123 r
.51785 .37155 m .51867 .37364 L .5 .38446 L closepath p F P
0 0 0 r
s
.975 .288 .123 r
.51703 .36945 m .51785 .37155 L .5 .38446 L closepath p F P
0 0 0 r
s
.975 .288 .123 r
.51621 .36734 m .51703 .36945 L .5 .38446 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.4961 .37658 m
.50384 .39558 L
s
.83 .24 .1 r
.48558 .38869 m
.51448 .3836 L
s
.51448 .3836 m
.52058 .39902 L
s
.186 .253 .503 r
.67744 .56147 m .65702 .56451 L .65653 .58255 L p F P
0 0 0 r
s
.83 .24 .1 r
.6763 .56261 m
.67927 .57204 L
s
.186 .253 .503 r
.63629 .58552 m .65653 .58255 L .65702 .56451 L p F P
0 0 0 r
s
.24 .35 .67 r
.61542 .56987 m
.65553 .56389 L
s
.922 .274 .118 r
.5235 .38606 m .5227 .38401 L .545 .38627 L p F P
0 0 0 r
s
.922 .274 .118 r
.545 .38627 m .54652 .39033 L .5235 .38606 L p F P
0 0 0 r
s
1 .3 .12 r
.36513 .51617 m .37179 .52791 L .3774 .50838 L p F P
0 0 0 r
s
.83 .24 .1 r
.37483 .52173 m
.3877 .54463 L
s
1 .3 .12 r
.3774 .50838 m .37108 .49697 L .36513 .51617 L p F P
0 0 0 r
s
.83 .24 .1 r
.37483 .52173 m
.3849 .49745 L
s
.5387 .7361 m
.5102 .73421 L
s
.5102 .73421 m
.49961 .71479 L
s
.768 .232 .103 r
.57066 .40308 m .56855 .39718 L .58914 .4065 L p F P
0 0 0 r
s
.768 .232 .103 r
.58914 .4065 m .59176 .4141 L .57066 .40308 L p F P
0 0 0 r
s
.24 .35 .67 r
.58314 .38172 m
.58967 .40486 L
s
1 .307 .13 r
.45164 .38526 m .45345 .38932 L .47649 .38555 L p F P
0 0 0 r
s
1 .307 .13 r
.47649 .38555 m .47561 .3835 L .45164 .38526 L p F P
0 0 0 r
s
.504 .158 .074 r
.61385 .43621 m .61086 .42723 L .62752 .44219 L p F P
0 0 0 r
s
.504 .158 .074 r
.62752 .44219 m .63083 .45239 L .61385 .43621 L p F P
0 0 0 r
s
.24 .35 .67 r
.81199 .48467 m
.77083 .4911 L
s
.77083 .4911 m
.77494 .51935 L
s
.164 .219 .436 r
.61615 .58847 m .59613 .5914 L .59356 .60749 L p F P
0 0 0 r
s
.164 .219 .436 r
.57418 .61028 m .59356 .60749 L .59613 .5914 L p F P
0 0 0 r
s
.24 .35 .67 r
.53612 .6046 m
.57589 .59879 L
s
.57573 .57579 m
.57589 .59879 L
s
.267 .077 .042 r
.64836 .4808 m .64489 .46985 L .6557 .48825 L p F P
0 0 0 r
s
.267 .077 .042 r
.6557 .48825 m .65932 .49983 L .64836 .4808 L p F P
0 0 0 r
s
.24 .35 .67 r
.77494 .51935 m
.73394 .5256 L
s
.73394 .5256 m
.73706 .55175 L
s
1 .318 .133 r
.41073 .40459 m .41441 .41222 L .43411 .40162 L p F P
0 0 0 r
s
1 .318 .133 r
.43411 .40162 m .43137 .3957 L .41073 .40459 L p F P
0 0 0 r
s
.83 .24 .1 r
.66493 .66798 m
.65747 .64719 L
s
.66493 .66798 m
.64642 .69 L
s
.135 .173 .347 r
.53571 .61584 m .51663 .6186 L .51577 .63177 L p F P
0 0 0 r
s
.135 .173 .347 r
.49777 .63434 m .51577 .63177 L .51663 .6186 L p F P
0 0 0 r
s
.922 .274 .118 r
.5227 .38401 m .5219 .38195 L .54348 .38219 L p F P
0 0 0 r
s
.922 .274 .118 r
.54348 .38219 m .545 .38627 L .5227 .38401 L p F P
0 0 0 r
s
.855 .256 .112 r
.54652 .39033 m .545 .38627 L .56642 .39122 L p F P
0 0 0 r
s
.24 .35 .67 r
.55021 .38747 m
.58314 .38172 L
s
.855 .256 .112 r
.56642 .39122 m .56855 .39718 L .54652 .39033 L p F P
0 0 0 r
s
.24 .35 .67 r
.45478 .63523 m
.4943 .62956 L
s
.095 .112 .226 r
.44426 .64198 m .42659 .6445 L .43237 .65375 L p F P
0 0 0 r
s
.095 .112 .226 r
.41616 .65604 m .43237 .65375 L .42659 .6445 L p F P
0 0 0 r
s
.83 .24 .1 r
.41757 .65584 m
.41905 .65806 L
s
1 .307 .13 r
.44983 .38117 m .45164 .38526 L .47561 .3835 L p F P
0 0 0 r
s
.24 .35 .67 r
.41742 .39055 m
.45132 .38453 L
s
1 .307 .13 r
.47561 .3835 m .47473 .38144 L .44983 .38117 L p F P
0 0 0 r
s
1 .321 .132 r
.38099 .43963 m .38632 .44987 L .40109 .43398 L p F P
0 0 0 r
s
1 .321 .132 r
.40109 .43398 m .39657 .42497 L .38099 .43963 L p F P
0 0 0 r
s
.83 .24 .1 r
.3874 .45035 m
.40741 .42972 L
s
.4729 .70746 m
.44974 .69509 L
s
.44974 .69509 m
.4379 .67484 L
s
.51448 .3836 m
.54306 .38331 L
s
.24 .35 .67 r
.66415 .36756 m
.66978 .39112 L
s
.71048 .38414 m
.66978 .39112 L
s
1 .314 .132 r
.4286 .38973 m .43137 .3957 L .45345 .38932 L p F P
0 0 0 r
s
1 .314 .132 r
.45345 .38932 m .45164 .38526 L .4286 .38973 L p F P
0 0 0 r
s
.186 .253 .503 r
.65653 .58255 m .67688 .57957 L .67744 .56147 L p F P
0 0 0 r
s
.855 .238 .09 r
.67744 .56147 m .67383 .54997 L .67328 .5683 L p F P
0 0 0 r
s
.24 .35 .67 r
.67719 .56067 m
.69608 .55785 L
s
.855 .238 .09 r
.67328 .5683 m .67688 .57957 L .67744 .56147 L p F P
0 0 0 r
s
.24 .35 .67 r
.65553 .56389 m
.67349 .56122 L
s
.31983 .38238 m
.33015 .39061 L
s
.36905 .38363 m
.33015 .39061 L
s
.37098 .66105 m
.33207 .66656 L
s
.33207 .66656 m
.32367 .67596 L
s
.922 .274 .118 r
.5219 .38195 m .5211 .37988 L .54194 .37808 L p F P
0 0 0 r
s
.922 .274 .118 r
.54194 .37808 m .54348 .38219 L .5219 .38195 L p F P
0 0 0 r
s
.655 .2 .091 r
.59176 .4141 m .58914 .4065 L .60782 .41812 L p F P
0 0 0 r
s
.655 .2 .091 r
.60782 .41812 m .61086 .42723 L .59176 .4141 L p F P
0 0 0 r
s
.83 .24 .1 r
.57941 .41375 m
.60371 .42328 L
s
.60371 .42328 m
.61212 .44816 L
s
.24 .35 .67 r
.80253 .42565 m
.80732 .45523 L
s
.80732 .45523 m
.81199 .48467 L
s
1 .307 .13 r
.448 .37705 m .44983 .38117 L .47473 .38144 L p F P
0 0 0 r
s
1 .307 .13 r
.47473 .38144 m .47385 .37937 L .448 .37705 L p F P
0 0 0 r
s
1 .312 .126 r
.36465 .48534 m .37108 .49697 L .37997 .47809 L p F P
0 0 0 r
s
1 .312 .126 r
.37997 .47809 m .37406 .4671 L .36465 .48534 L p F P
0 0 0 r
s
.24 .35 .67 r
.62342 .37468 m
.58314 .38172 L
s
.164 .219 .436 r
.63629 .58552 m .61615 .58847 L .61304 .60467 L p F P
0 0 0 r
s
.164 .219 .436 r
.59356 .60749 m .61304 .60467 L .61615 .58847 L p F P
0 0 0 r
s
.135 .173 .347 r
.5549 .61307 m .53571 .61584 L .53387 .62919 L p F P
0 0 0 r
s
.135 .173 .347 r
.51577 .63177 m .53387 .62919 L .53571 .61584 L p F P
0 0 0 r
s
.095 .112 .226 r
.46201 .63945 m .44426 .64198 L .44866 .65145 L p F P
0 0 0 r
s
.095 .112 .226 r
.43237 .65375 m .44866 .65145 L .44426 .64198 L p F P
0 0 0 r
s
.72 .193 .072 r
.37957 .59347 m .38589 .60412 L .38274 .58789 L p F P
0 0 0 r
s
.83 .24 .1 r
.38349 .56929 m
.38516 .59358 L
s
.72 .193 .072 r
.38274 .58789 m .37621 .57679 L .37957 .59347 L p F P
0 0 0 r
s
.24 .35 .67 r
.75162 .37708 m
.75653 .40383 L
s
.79778 .39691 m
.75653 .40383 L
s
.66 .179 .065 r
.6703 .53079 m .66666 .51911 L .67015 .53825 L p F P
0 0 0 r
s
.66 .179 .065 r
.67015 .53825 m .67383 .54997 L .6703 .53079 L p F P
0 0 0 r
s
.24 .35 .67 r
.79778 .39691 m
.80253 .42565 L
s
.922 .274 .118 r
.5211 .37988 m .52029 .37781 L .5404 .37394 L p F P
0 0 0 r
s
.922 .274 .118 r
.5404 .37394 m .54194 .37808 L .5211 .37988 L p F P
0 0 0 r
s
.38 .117 .058 r
.63083 .45239 m .62752 .44219 L .64136 .45871 L p F P
0 0 0 r
s
.38 .117 .058 r
.64136 .45871 m .64489 .46985 L .63083 .45239 L p F P
0 0 0 r
s
.83 .24 .1 r
.63263 .46223 m
.64878 .48035 L
s
1 .321 .133 r
.39198 .41583 m .39657 .42497 L .41441 .41222 L p F P
0 0 0 r
s
1 .321 .133 r
.41441 .41222 m .41073 .40459 L .39198 .41583 L p F P
0 0 0 r
s
.24 .35 .67 r
.20372 .40341 m
.19172 .40163 L
s
.242 .39647 m
.20372 .40341 L
s
.768 .232 .103 r
.56855 .39718 m .56642 .39122 L .58648 .3988 L p F P
0 0 0 r
s
.768 .232 .103 r
.58648 .3988 m .58914 .4065 L .56855 .39718 L p F P
0 0 0 r
s
.855 .256 .112 r
.545 .38627 m .54348 .38219 L .56426 .38521 L p F P
0 0 0 r
s
.855 .256 .112 r
.56426 .38521 m .56642 .39122 L .545 .38627 L p F P
0 0 0 r
s
1 .307 .13 r
.44616 .37291 m .448 .37705 L .47385 .37937 L p F P
0 0 0 r
s
1 .307 .13 r
.47385 .37937 m .47297 .37729 L .44616 .37291 L p F P
0 0 0 r
s
.888 .244 .094 r
.36955 .56546 m .37621 .57679 L .37582 .55863 L p F P
0 0 0 r
s
.888 .244 .094 r
.37582 .55863 m .36913 .54708 L .36955 .56546 L p F P
0 0 0 r
s
.561 .145 .055 r
.39184 .61822 m .39767 .62799 L .39209 .61456 L p F P
0 0 0 r
s
.561 .145 .055 r
.39209 .61456 m .38589 .60412 L .39184 .61822 L p F P
0 0 0 r
s
.83 .24 .1 r
.38516 .59358 m
.39786 .61514 L
s
1 .314 .132 r
.42581 .3837 m .4286 .38973 L .45164 .38526 L p F P
0 0 0 r
s
1 .314 .132 r
.45164 .38526 m .44983 .38117 L .42581 .3837 L p F P
0 0 0 r
s
.24 .35 .67 r
.73706 .55175 m
.69608 .55785 L
s
.69608 .55785 m
.6978 .581 L
s
.81199 .48467 m
.81639 .51303 L
s
1 .318 .133 r
.407 .39687 m .41073 .40459 L .43137 .3957 L p F P
0 0 0 r
s
1 .318 .133 r
.43137 .3957 m .4286 .38973 L .407 .39687 L p F P
0 0 0 r
s
.922 .274 .118 r
.52029 .37781 m .51948 .37573 L .53885 .36978 L p F P
0 0 0 r
s
.922 .274 .118 r
.53885 .36978 m .5404 .37394 L .52029 .37781 L p F P
0 0 0 r
s
.83 .24 .1 r
.56804 .73233 m
.5387 .7361 L
s
.5387 .7361 m
.52862 .71659 L
s
.164 .219 .436 r
.65653 .58255 m .63629 .58552 L .63262 .60184 L p F P
0 0 0 r
s
.164 .219 .436 r
.61304 .60467 m .63262 .60184 L .63629 .58552 L p F P
0 0 0 r
s
.24 .35 .67 r
.57589 .59879 m
.61609 .59293 L
s
.61542 .56987 m
.61609 .59293 L
s
.095 .112 .226 r
.47984 .6369 m .46201 .63945 L .46501 .64914 L p F P
0 0 0 r
s
.095 .112 .226 r
.44866 .65145 m .46501 .64914 L .46201 .63945 L p F P
0 0 0 r
s
1 .307 .13 r
.44431 .36874 m .44616 .37291 L .47297 .37729 L p F P
0 0 0 r
s
1 .307 .13 r
.47297 .37729 m .47209 .37521 L .44431 .36874 L p F P
0 0 0 r
s
.24 .35 .67 r
.47236 .38079 m
.4961 .37658 L
s
.135 .173 .347 r
.57418 .61028 m .5549 .61307 L .55206 .6266 L p F P
0 0 0 r
s
.135 .173 .347 r
.53387 .62919 m .55206 .6266 L .5549 .61307 L p F P
0 0 0 r
s
.24 .35 .67 r
.53425 .62383 m
.53612 .6046 L
s
.81639 .51303 m
.77494 .51935 L
s
.77494 .51935 m
.77848 .54557 L
s
1 .318 .13 r
.36805 .45591 m .37406 .4671 L .38632 .44987 L p F P
0 0 0 r
s
1 .318 .13 r
.38632 .44987 m .38099 .43963 L .36805 .45591 L p F P
0 0 0 r
s
.996 .278 .11 r
.3623 .53529 m .36913 .54708 L .37179 .52791 L p F P
0 0 0 r
s
.996 .278 .11 r
.37179 .52791 m .36513 .51617 L .3623 .53529 L p F P
0 0 0 r
s
.83 .24 .1 r
.37039 .54663 m
.37483 .52173 L
s
.24 .35 .67 r
.4943 .62956 m
.53425 .62383 L
s
.83 .24 .1 r
.64642 .69 m
.63854 .66954 L
s
.64642 .69 m
.62331 .70869 L
s
.187 .054 .028 r
.65932 .49983 m .6557 .48825 L .66295 .50719 L p F P
0 0 0 r
s
.83 .24 .1 r
.64878 .48035 m
.65632 .50418 L
s
.187 .054 .028 r
.66295 .50719 m .66666 .51911 L .65932 .49983 L p F P
0 0 0 r
s
.504 .158 .074 r
.61086 .42723 m .60782 .41812 L .62417 .43183 L p F P
0 0 0 r
s
.504 .158 .074 r
.62417 .43183 m .62752 .44219 L .61086 .42723 L p F P
0 0 0 r
s
.24 .35 .67 r
.70531 .36037 m
.71048 .38414 L
s
.75162 .37708 m
.71048 .38414 L
s
.922 .274 .118 r
.51948 .37573 m .51867 .37364 L .53729 .3656 L p F P
0 0 0 r
s
.922 .274 .118 r
.53729 .3656 m .53885 .36978 L .51948 .37573 L p F P
0 0 0 r
s
.855 .256 .112 r
.54348 .38219 m .54194 .37808 L .56209 .37914 L p F P
0 0 0 r
s
.855 .256 .112 r
.56209 .37914 m .56426 .38521 L .54348 .38219 L p F P
0 0 0 r
s
.83 .24 .1 r
.54306 .38331 m
.55267 .40902 L
s
.24 .35 .67 r
.35938 .37522 m
.36905 .38363 L
s
.40836 .37656 m
.36905 .38363 L
s
.293 .442 .865 r
.47522 .37465 m .47209 .37521 L .44431 .36874 L p F P
0 0 0 r
s
.24 .35 .67 r
.37098 .66105 m
.4103 .65549 L
s
.37098 .66105 m
.36325 .6704 L
s
.245 .071 .038 r
.40584 .6387 m .41104 .64744 L .40339 .63758 L p F P
0 0 0 r
s
.245 .071 .038 r
.40339 .63758 m .39767 .62799 L .40584 .6387 L p F P
0 0 0 r
s
.293 .442 .865 r
.44431 .36874 m .45054 .36762 L .47522 .37465 L p F P
0 0 0 r
s
.293 .442 .865 r
.47836 .37409 m .47522 .37465 L .45054 .36762 L p F P
0 0 0 r
s
1 .314 .132 r
.42299 .37762 m .42581 .3837 L .44983 .38117 L p F P
0 0 0 r
s
1 .314 .132 r
.44983 .38117 m .448 .37705 L .42299 .37762 L p F P
0 0 0 r
s
.095 .112 .226 r
.49777 .63434 m .47984 .6369 L .48144 .64682 L p F P
0 0 0 r
s
.095 .112 .226 r
.46501 .64914 m .48144 .64682 L .47984 .6369 L p F P
0 0 0 r
s
.24 .35 .67 r
.61734 .35506 m
.62342 .37468 L
s
.66415 .36756 m
.62342 .37468 L
s
.293 .442 .865 r
.45054 .36762 m .45678 .3665 L .47836 .37409 L p F P
0 0 0 r
s
.24 .35 .67 r
.4481 .36942 m
.45123 .37468 L
s
.293 .442 .865 r
.4815 .37353 m .47836 .37409 L .45678 .3665 L p F P
0 0 0 r
s
.164 .219 .436 r
.67688 .57957 m .65653 .58255 L .65231 .599 L p F P
0 0 0 r
s
.164 .219 .436 r
.63262 .60184 m .65231 .599 L .65653 .58255 L p F P
0 0 0 r
s
.655 .2 .091 r
.58914 .4065 m .58648 .3988 L .60474 .40888 L p F P
0 0 0 r
s
.655 .2 .091 r
.60474 .40888 m .60782 .41812 L .58914 .4065 L p F P
0 0 0 r
s
.135 .173 .347 r
.59356 .60749 m .57418 .61028 L .57033 .62399 L p F P
0 0 0 r
s
.135 .173 .347 r
.55206 .6266 m .57033 .62399 L .57418 .61028 L p F P
0 0 0 r
s
1 .321 .132 r
.37558 .42922 m .38099 .43963 L .39657 .42497 L p F P
0 0 0 r
s
1 .321 .132 r
.39657 .42497 m .39198 .41583 L .37558 .42922 L p F P
0 0 0 r
s
.922 .274 .118 r
.51867 .37364 m .51785 .37155 L .53572 .36138 L p F P
0 0 0 r
s
.922 .274 .118 r
.53572 .36138 m .53729 .3656 L .51867 .37364 L p F P
0 0 0 r
s
.24 .35 .67 r
.4961 .37658 m
.51999 .37234 L
s
.768 .232 .103 r
.56642 .39122 m .56426 .38521 L .5838 .391 L p F P
0 0 0 r
s
.768 .232 .103 r
.5838 .391 m .58648 .3988 L .56642 .39122 L p F P
0 0 0 r
s
.293 .442 .865 r
.45678 .3665 m .46304 .36538 L .4815 .37353 L p F P
0 0 0 r
s
.293 .442 .865 r
.48464 .37297 m .4815 .37353 L .46304 .36538 L p F P
0 0 0 r
s
.83 .24 .1 r
.47901 .37301 m
.48558 .38869 L
s
1 .3 .12 r
.35833 .50419 m .36513 .51617 L .37108 .49697 L p F P
0 0 0 r
s
1 .3 .12 r
.37108 .49697 m .36465 .48534 L .35833 .50419 L p F P
0 0 0 r
s
.24 .35 .67 r
.79321 .36995 m
.79778 .39691 L
s
.293 .442 .865 r
.46304 .36538 m .4693 .36425 L .48464 .37297 L p F P
0 0 0 r
s
.293 .442 .865 r
.48779 .37241 m .48464 .37297 L .4693 .36425 L p F P
0 0 0 r
s
.24 .35 .67 r
.23067 .39455 m
.242 .39647 L
s
.28071 .38947 m
.242 .39647 L
s
.267 .077 .042 r
.64489 .46985 m .64136 .45871 L .65201 .47645 L p F P
0 0 0 r
s
.267 .077 .042 r
.65201 .47645 m .6557 .48825 L .64489 .46985 L p F P
0 0 0 r
s
.293 .442 .865 r
.4693 .36425 m .47558 .36312 L .48779 .37241 L p F P
0 0 0 r
s
.83 .24 .1 r
.47451 .3623 m
.47491 .36324 L
s
.293 .442 .865 r
.49093 .37185 m .48779 .37241 L .47558 .36312 L p F P
0 0 0 r
s
.83 .24 .1 r
.59673 .72305 m
.56804 .73233 L
s
.56804 .73233 m
.55853 .71267 L
s
.24 .35 .67 r
.28452 .68145 m
.24578 .68689 L
s
.23452 .69047 m
.24578 .68689 L
s
1 .318 .133 r
.40323 .38905 m .407 .39687 L .4286 .38973 L p F P
0 0 0 r
s
1 .318 .133 r
.4286 .38973 m .42581 .3837 L .40323 .38905 L p F P
0 0 0 r
s
.24 .35 .67 r
.40836 .37656 m
.41469 .38634 L
s
1 .321 .133 r
.38733 .40656 m .39198 .41583 L .41073 .40459 L p F P
0 0 0 r
s
1 .321 .133 r
.41073 .40459 m .407 .39687 L .38733 .40656 L p F P
0 0 0 r
s
.293 .442 .865 r
.47558 .36312 m .48186 .36199 L .49093 .37185 L p F P
0 0 0 r
s
.293 .442 .865 r
.49408 .37129 m .49093 .37185 L .48186 .36199 L p F P
0 0 0 r
s
.83 .24 .1 r
.62331 .70869 m
.61493 .68853 L
s
.62331 .70869 m
.59673 .72305 L
s
.922 .274 .118 r
.51785 .37155 m .51703 .36945 L .53413 .35714 L p F P
0 0 0 r
s
.922 .274 .118 r
.53413 .35714 m .53572 .36138 L .51785 .37155 L p F P
0 0 0 r
s
.855 .256 .112 r
.54194 .37808 m .5404 .37394 L .5599 .37302 L p F P
0 0 0 r
s
.855 .256 .112 r
.5599 .37302 m .56209 .37914 L .54194 .37808 L p F P
0 0 0 r
s
.83 .24 .1 r
.41772 .65582 m
.41905 .65806 L
s
.24 .35 .67 r
.77848 .54557 m
.73706 .55175 L
s
.73706 .55175 m
.73933 .57494 L
s
.293 .442 .865 r
.48186 .36199 m .48816 .36086 L .49408 .37129 L p F P
0 0 0 r
s
.293 .442 .865 r
.49724 .37073 m .49408 .37129 L .48816 .36086 L p F P
0 0 0 r
s
.095 .112 .226 r
.51577 .63177 m .49777 .63434 L .49794 .64449 L p F P
0 0 0 r
s
.095 .112 .226 r
.48144 .64682 m .49794 .64449 L .49777 .63434 L p F P
0 0 0 r
s
.24 .35 .67 r
.49024 .64418 m
.4943 .62956 L
s
.293 .442 .865 r
.48816 .36086 m .49447 .35972 L .49724 .37073 L p F P
0 0 0 r
s
.293 .442 .865 r
.50039 .37016 m .49724 .37073 L .49447 .35972 L p F P
0 0 0 r
s
.135 .173 .347 r
.61304 .60467 m .59356 .60749 L .5887 .62137 L p F P
0 0 0 r
s
.135 .173 .347 r
.57033 .62399 m .5887 .62137 L .59356 .60749 L p F P
0 0 0 r
s
.24 .35 .67 r
.57463 .61804 m
.57589 .59879 L
s
.164 .219 .436 r
.65231 .599 m .6721 .59614 L .67688 .57957 L p F P
0 0 0 r
s
.24 .35 .67 r
.61609 .59293 m
.65673 .587 L
s
.65553 .56389 m
.65673 .587 L
s
.83 .24 .1 r
.67086 .62267 m
.67819 .5972 L
s
.998 .282 .11 r
.67688 .57957 m .67328 .5683 L .66855 .58534 L p F P
0 0 0 r
s
.998 .282 .11 r
.66855 .58534 m .6721 .59614 L .67688 .57957 L p F P
0 0 0 r
s
.83 .24 .1 r
.67481 .58675 m
.67819 .5972 L
s
.59673 .72305 m
.5878 .70317 L
s
1 .314 .132 r
.42015 .37149 m .42299 .37762 L .448 .37705 L p F P
0 0 0 r
s
1 .314 .132 r
.448 .37705 m .44616 .37291 L .42015 .37149 L p F P
0 0 0 r
s
.293 .442 .865 r
.49447 .35972 m .50079 .35859 L .50039 .37016 L p F P
0 0 0 r
s
.24 .35 .67 r
.48828 .36221 m
.4961 .37658 L
s
.293 .442 .865 r
.50355 .3696 m .50039 .37016 L .50079 .35859 L p F P
0 0 0 r
s
.83 .24 .1 r
.49961 .71479 m
.4729 .70746 L
s
.4729 .70746 m
.46142 .68725 L
s
.24 .35 .67 r
.81639 .51303 m
.82036 .53933 L
s
.293 .442 .865 r
.50079 .35859 m .50712 .35745 L .50355 .3696 L p F P
0 0 0 r
s
.293 .442 .865 r
.50671 .36904 m .50355 .3696 L .50712 .35745 L p F P
0 0 0 r
s
.83 .24 .1 r
.50395 .35701 m
.50433 .35795 L
s
.24 .35 .67 r
.53425 .62383 m
.57463 .61804 L
s
1 .312 .126 r
.35808 .47348 m .36465 .48534 L .37406 .4671 L p F P
0 0 0 r
s
1 .312 .126 r
.37406 .4671 m .36805 .45591 L .35808 .47348 L p F P
0 0 0 r
s
.83 .24 .1 r
.37184 .47335 m
.3849 .49745 L
s
.922 .274 .118 r
.51703 .36945 m .51621 .36734 L .53254 .35288 L p F P
0 0 0 r
s
.922 .274 .118 r
.53254 .35288 m .53413 .35714 L .51703 .36945 L p F P
0 0 0 r
s
.855 .238 .09 r
.67383 .54997 m .67015 .53825 L .6696 .5568 L p F P
0 0 0 r
s
.83 .24 .1 r
.67283 .5516 m
.6737 .55436 L
s
.66713 .52558 m
.67011 .53972 L
s
.855 .238 .09 r
.6696 .5568 m .67328 .5683 L .67383 .54997 L p F P
0 0 0 r
s
.293 .442 .865 r
.50712 .35745 m .51346 .35631 L .50671 .36904 L p F P
0 0 0 r
s
.293 .442 .865 r
.50988 .36847 m .50671 .36904 L .51346 .35631 L p F P
0 0 0 r
s
.38 .117 .058 r
.62752 .44219 m .62417 .43183 L .63776 .44736 L p F P
0 0 0 r
s
.38 .117 .058 r
.63776 .44736 m .64136 .45871 L .62752 .44219 L p F P
0 0 0 r
s
.83 .24 .1 r
.62455 .43735 m
.63263 .46223 L
s
.24 .35 .67 r
.74693 .35309 m
.75162 .37708 L
s
.79321 .36995 m
.75162 .37708 L
s
.67515 .58431 m
.6978 .581 L
s
.65673 .587 m
.66857 .58527 L
s
.293 .442 .865 r
.51346 .35631 m .51981 .35517 L .50988 .36847 L p F P
0 0 0 r
s
.293 .442 .865 r
.51304 .36791 m .50988 .36847 L .51981 .35517 L p F P
0 0 0 r
s
.24 .35 .67 r
.40836 .37656 m
.42141 .37422 L
s
.40327 .66478 m
.4103 .65549 L
s
.83 .24 .1 r
.67086 .62267 m
.65747 .64719 L
s
.293 .442 .865 r
.51981 .35517 m .52617 .35402 L .51304 .36791 L p F P
0 0 0 r
s
.293 .442 .865 r
.51621 .36734 m .51304 .36791 L .52617 .35402 L p F P
0 0 0 r
s
.83 .24 .1 r
.50823 .3678 m
.51448 .3836 L
s
.095 .112 .226 r
.53387 .62919 m .51577 .63177 L .51452 .64214 L p F P
0 0 0 r
s
.095 .112 .226 r
.49794 .64449 m .51452 .64214 L .51577 .63177 L p F P
0 0 0 r
s
.768 .232 .103 r
.56426 .38521 m .56209 .37914 L .58108 .38311 L p F P
0 0 0 r
s
.24 .35 .67 r
.57649 .36231 m
.58314 .38172 L
s
.768 .232 .103 r
.58108 .38311 m .5838 .391 L .56426 .38521 L p F P
0 0 0 r
s
.83 .24 .1 r
.54306 .38331 m
.57026 .38792 L
s
.57026 .38792 m
.57941 .41375 L
s
.069 .081 .154 r
.43237 .65375 m .41616 .65604 L .42554 .66161 L p F P
0 0 0 r
s
.365 .111 .056 r
.42107 .65402 m .42554 .66161 L .41616 .65604 L p F P
0 0 0 r
s
.365 .111 .056 r
.41616 .65604 m .41104 .64744 L .42107 .65402 L p F P
0 0 0 r
s
.24 .35 .67 r
.4103 .65549 m
.41513 .6548 L
s
.41513 .6548 m
.41533 .65478 L
s
.293 .442 .865 r
.52617 .35402 m .53254 .35288 L .51621 .36734 L p F P
0 0 0 r
s
.855 .256 .112 r
.5404 .37394 m .53885 .36978 L .55768 .36684 L p F P
0 0 0 r
s
.855 .256 .112 r
.55768 .36684 m .5599 .37302 L .5404 .37394 L p F P
0 0 0 r
s
.72 .193 .072 r
.37311 .58262 m .37957 .59347 L .37621 .57679 L p F P
0 0 0 r
s
.72 .193 .072 r
.37621 .57679 m .36955 .56546 L .37311 .58262 L p F P
0 0 0 r
s
.83 .24 .1 r
.37039 .54663 m
.38349 .56929 L
s
.135 .173 .347 r
.63262 .60184 m .61304 .60467 L .60715 .61874 L p F P
0 0 0 r
s
.135 .173 .347 r
.5887 .62137 m .60715 .61874 L .61304 .60467 L p F P
0 0 0 r
s
.24 .35 .67 r
.65864 .34773 m
.66415 .36756 L
s
.70531 .36037 m
.66415 .36756 L
s
.66 .179 .065 r
.66666 .51911 m .66295 .50719 L .66639 .52627 L p F P
0 0 0 r
s
.83 .24 .1 r
.6665 .52355 m
.66713 .52558 L
s
.66 .179 .065 r
.66639 .52627 m .67015 .53825 L .66666 .51911 L p F P
0 0 0 r
s
.504 .158 .074 r
.60782 .41812 m .60474 .40888 L .62075 .42129 L p F P
0 0 0 r
s
.504 .158 .074 r
.62075 .42129 m .62417 .43183 L .60782 .41812 L p F P
0 0 0 r
s
.83 .24 .1 r
.60371 .42328 m
.62455 .43735 L
s
.561 .145 .055 r
.3859 .60827 m .39184 .61822 L .38589 .60412 L p F P
0 0 0 r
s
.561 .145 .055 r
.38589 .60412 m .37957 .59347 L .3859 .60827 L p F P
0 0 0 r
s
.83 .24 .1 r
.38516 .59358 m
.39286 .61646 L
s
1 .318 .13 r
.36192 .44451 m .36805 .45591 L .38099 .43963 L p F P
0 0 0 r
s
.83 .24 .1 r
.37184 .47335 m
.3874 .45035 L
s
1 .318 .13 r
.38099 .43963 m .37558 .42922 L .36192 .44451 L p F P
0 0 0 r
s
1 .314 .132 r
.41727 .36529 m .42015 .37149 L .44616 .37291 L p F P
0 0 0 r
s
1 .314 .132 r
.44616 .37291 m .44431 .36874 L .41727 .36529 L p F P
0 0 0 r
s
.83 .24 .1 r
.44581 .37219 m
.45743 .39834 L
s
.24 .35 .67 r
.44117 .37067 m
.4481 .36942 L
s
.655 .2 .091 r
.58648 .3988 m .5838 .391 L .60162 .3995 L p F P
0 0 0 r
s
.655 .2 .091 r
.60162 .3995 m .60474 .40888 L .58648 .3988 L p F P
0 0 0 r
s
1 .318 .133 r
.39941 .38114 m .40323 .38905 L .42581 .3837 L p F P
0 0 0 r
s
.83 .24 .1 r
.41889 .38628 m
.43105 .41218 L
s
1 .318 .133 r
.42581 .3837 m .42299 .37762 L .39941 .38114 L p F P
0 0 0 r
s
.888 .244 .094 r
.36274 .5539 m .36955 .56546 L .36913 .54708 L p F P
0 0 0 r
s
.888 .244 .094 r
.36913 .54708 m .3623 .53529 L .36274 .5539 L p F P
0 0 0 r
s
.24 .35 .67 r
.27004 .3874 m
.28071 .38947 L
s
.31983 .38238 m
.28071 .38947 L
s
.32367 .67596 m
.28452 .68145 L
s
.28452 .68145 m
.27392 .68495 L
s
.095 .112 .226 r
.55206 .6266 m .53387 .62919 L .53117 .63979 L p F P
0 0 0 r
s
.095 .112 .226 r
.51452 .64214 m .53117 .63979 L .53387 .62919 L p F P
0 0 0 r
s
.069 .081 .154 r
.44866 .65145 m .43237 .65375 L .43996 .65959 L p F P
0 0 0 r
s
.069 .081 .154 r
.42554 .66161 m .43996 .65959 L .43237 .65375 L p F P
0 0 0 r
s
.83 .24 .1 r
.41905 .65806 m
.4379 .67484 L
s
1 .321 .132 r
.37007 .41864 m .37558 .42922 L .39198 .41583 L p F P
0 0 0 r
s
1 .321 .132 r
.39198 .41583 m .38733 .40656 L .37007 .41864 L p F P
0 0 0 r
s
.24 .35 .67 r
.82036 .53933 m
.77848 .54557 L
s
.77848 .54557 m
.78131 .56882 L
s
1 .321 .133 r
.38261 .39715 m .38733 .40656 L .407 .39687 L p F P
0 0 0 r
s
.83 .24 .1 r
.39472 .40408 m
.40741 .42972 L
s
1 .321 .133 r
.407 .39687 m .40323 .38905 L .38261 .39715 L p F P
0 0 0 r
s
.83 .24 .1 r
.41889 .38628 m
.44581 .37219 L
s
.44581 .37219 m
.45633 .36856 L
s
.46839 .36441 m
.47451 .3623 L
s
.135 .173 .347 r
.65231 .599 m .63262 .60184 L .6257 .61609 L p F P
0 0 0 r
s
.135 .173 .347 r
.60715 .61874 m .6257 .61609 L .63262 .60184 L p F P
0 0 0 r
s
.24 .35 .67 r
.61545 .61219 m
.61609 .59293 L
s
.187 .054 .028 r
.6557 .48825 m .65201 .47645 L .65916 .49503 L p F P
0 0 0 r
s
.187 .054 .028 r
.65916 .49503 m .66295 .50719 L .6557 .48825 L p F P
0 0 0 r
s
.83 .24 .1 r
.64878 .48035 m
.65972 .50189 L
s
.65972 .50189 m
.66509 .51905 L
s
.996 .278 .11 r
.35533 .52326 m .3623 .53529 L .36513 .51617 L p F P
0 0 0 r
s
.996 .278 .11 r
.36513 .51617 m .35833 .50419 L .35533 .52326 L p F P
0 0 0 r
s
.855 .256 .112 r
.53885 .36978 m .53729 .3656 L .55545 .3606 L p F P
0 0 0 r
s
.855 .256 .112 r
.55545 .3606 m .55768 .36684 L .53885 .36978 L p F P
0 0 0 r
s
.24 .35 .67 r
.55728 .36572 m
.57649 .36231 L
s
.245 .071 .038 r
.40055 .6298 m .40584 .6387 L .39767 .62799 L p F P
0 0 0 r
s
.245 .071 .038 r
.39767 .62799 m .39184 .61822 L .40055 .6298 L p F P
0 0 0 r
s
.83 .24 .1 r
.39286 .61646 m
.40556 .63782 L
s
.24 .35 .67 r
.57463 .61804 m
.61545 .61219 L
s
.83 .24 .1 r
.39472 .40408 m
.41889 .38628 L
s
.287 .44 .858 r
.45054 .36762 m .44431 .36874 L .41727 .36529 L p F P
0 0 0 r
s
.24 .35 .67 r
.61734 .35506 m
.57649 .36231 L
s
.069 .081 .154 r
.46501 .64914 m .44866 .65145 L .45442 .65756 L p F P
0 0 0 r
s
.24 .35 .67 r
.45005 .64986 m
.45478 .63523 L
s
.069 .081 .154 r
.43996 .65959 m .45442 .65756 L .44866 .65145 L p F P
0 0 0 r
s
.24 .35 .67 r
.421 .65397 m
.45005 .64986 L
s
.789 .34574 m
.79321 .36995 L
s
.73933 .57494 m
.6978 .581 L
s
.6978 .581 m
.69845 .60029 L
s
.768 .232 .103 r
.56209 .37914 m .5599 .37302 L .57833 .37513 L p F P
0 0 0 r
s
.768 .232 .103 r
.57833 .37513 m .58108 .38311 L .56209 .37914 L p F P
0 0 0 r
s
.095 .112 .226 r
.57033 .62399 m .55206 .6266 L .54789 .63743 L p F P
0 0 0 r
s
.095 .112 .226 r
.53117 .63979 m .54789 .63743 L .55206 .6266 L p F P
0 0 0 r
s
.287 .44 .858 r
.41727 .36529 m .4265 .36362 L .45054 .36762 L p F P
0 0 0 r
s
.287 .44 .858 r
.45678 .3665 m .45054 .36762 L .4265 .36362 L p F P
0 0 0 r
s
.83 .24 .1 r
.44375 .36754 m
.44581 .37219 L
s
.267 .077 .042 r
.64136 .45871 m .63776 .44736 L .64825 .46441 L p F P
0 0 0 r
s
.267 .077 .042 r
.64825 .46441 m .65201 .47645 L .64136 .45871 L p F P
0 0 0 r
s
1 .3 .12 r
.35139 .49197 m .35833 .50419 L .36465 .48534 L p F P
0 0 0 r
s
.83 .24 .1 r
.36143 .49788 m
.37483 .52173 L
s
1 .3 .12 r
.36465 .48534 m .35808 .47348 L .35139 .49197 L p F P
0 0 0 r
s
.135 .173 .347 r
.6721 .59614 m .65231 .599 L .64434 .61343 L p F P
0 0 0 r
s
.135 .173 .347 r
.6257 .61609 m .64434 .61343 L .65231 .599 L p F P
0 0 0 r
s
1 .318 .133 r
.39554 .37313 m .39941 .38114 L .42299 .37762 L p F P
0 0 0 r
s
1 .318 .133 r
.42299 .37762 m .42015 .37149 L .39554 .37313 L p F P
0 0 0 r
s
.24 .35 .67 r
.70039 .34031 m
.70531 .36037 L
s
.74693 .35309 m
.70531 .36037 L
s
.287 .44 .858 r
.4265 .36362 m .43575 .36194 L .45678 .3665 L p F P
0 0 0 r
s
.287 .44 .858 r
.46304 .36538 m .45678 .3665 L .43575 .36194 L p F P
0 0 0 r
s
.83 .24 .1 r
.52862 .71659 m
.49961 .71479 L
s
.49961 .71479 m
.48858 .69456 L
s
.855 .256 .112 r
.53729 .3656 m .53572 .36138 L .55319 .3543 L p F P
0 0 0 r
s
.855 .256 .112 r
.55319 .3543 m .55545 .3606 L .53729 .3656 L p F P
0 0 0 r
s
.287 .44 .858 r
.43575 .36194 m .44503 .36027 L .46304 .36538 L p F P
0 0 0 r
s
.287 .44 .858 r
.4693 .36425 m .46304 .36538 L .44503 .36027 L p F P
0 0 0 r
s
.069 .081 .154 r
.48144 .64682 m .46501 .64914 L .46895 .65552 L p F P
0 0 0 r
s
.069 .081 .154 r
.45442 .65756 m .46895 .65552 L .46501 .64914 L p F P
0 0 0 r
s
.24 .35 .67 r
.30986 .38017 m
.31983 .38238 L
s
.35938 .37522 m
.31983 .38238 L
s
.38 .117 .058 r
.62417 .43183 m .62075 .42129 L .6341 .4358 L p F P
0 0 0 r
s
.38 .117 .058 r
.6341 .4358 m .63776 .44736 L .62417 .43183 L p F P
0 0 0 r
s
.655 .2 .091 r
.5838 .391 m .58108 .38311 L .59845 .38998 L p F P
0 0 0 r
s
.655 .2 .091 r
.59845 .38998 m .60162 .3995 L .5838 .391 L p F P
0 0 0 r
s
.83 .24 .1 r
.57026 .38792 m
.59497 .39738 L
s
.095 .112 .226 r
.5887 .62137 m .57033 .62399 L .56469 .63505 L p F P
0 0 0 r
s
.095 .112 .226 r
.54789 .63743 m .56469 .63505 L .57033 .62399 L p F P
0 0 0 r
s
.24 .35 .67 r
.36325 .6704 m
.32367 .67596 L
s
.32367 .67596 m
.31377 .67937 L
s
.83 .24 .1 r
.65747 .64719 m
.6497 .62554 L
s
.65747 .64719 m
.63854 .66954 L
s
.287 .44 .858 r
.44503 .36027 m .45433 .35858 L .4693 .36425 L p F P
0 0 0 r
s
.287 .44 .858 r
.47558 .36312 m .4693 .36425 L .45433 .35858 L p F P
0 0 0 r
s
.83 .24 .1 r
.47451 .3623 m
.50395 .35701 L
s
1 .312 .126 r
.35139 .46138 m .35808 .47348 L .36805 .45591 L p F P
0 0 0 r
s
.83 .24 .1 r
.36143 .49788 m
.37184 .47335 L
s
1 .312 .126 r
.36805 .45591 m .36192 .44451 L .35139 .46138 L p F P
0 0 0 r
s
.504 .158 .074 r
.60474 .40888 m .60162 .3995 L .61728 .41057 L p F P
0 0 0 r
s
.83 .24 .1 r
.59497 .39738 m
.60371 .42328 L
s
.504 .158 .074 r
.61728 .41057 m .62075 .42129 L .60474 .40888 L p F P
0 0 0 r
s
.998 .282 .11 r
.67328 .5683 m .6696 .5568 L .66493 .57433 L p F P
0 0 0 r
s
.998 .282 .11 r
.66493 .57433 m .66855 .58534 L .67328 .5683 L p F P
0 0 0 r
s
.24 .35 .67 r
.82036 .53933 m
.82375 .56262 L
s
.135 .173 .347 r
.64434 .61343 m .66307 .61076 L .6721 .59614 L p F P
0 0 0 r
s
.24 .35 .67 r
.65672 .60627 m
.65673 .587 L
s
1 .308 .123 r
.6721 .59614 m .66855 .58534 L .65962 .60067 L p F P
0 0 0 r
s
1 .308 .123 r
.65962 .60067 m .66307 .61076 L .6721 .59614 L p F P
0 0 0 r
s
.83 .24 .1 r
.6655 .60681 m
.67086 .62267 L
s
.46142 .68725 m
.4379 .67484 L
s
.50395 .35701 m
.51013 .35691 L
s
.365 .111 .056 r
.41654 .64632 m .42107 .65402 L .41104 .64744 L p F P
0 0 0 r
s
.365 .111 .056 r
.41104 .64744 m .40584 .6387 L .41654 .64632 L p F P
0 0 0 r
s
.287 .44 .858 r
.45433 .35858 m .46365 .3569 L .47558 .36312 L p F P
0 0 0 r
s
.287 .44 .858 r
.48186 .36199 m .47558 .36312 L .46365 .3569 L p F P
0 0 0 r
s
.24 .35 .67 r
.4481 .36942 m
.48828 .36221 L
s
1 .321 .133 r
.37781 .3876 m .38261 .39715 L .40323 .38905 L p F P
0 0 0 r
s
1 .321 .133 r
.40323 .38905 m .39941 .38114 L .37781 .3876 L p F P
0 0 0 r
s
.855 .238 .09 r
.67015 .53825 m .66639 .52627 L .66585 .54506 L p F P
0 0 0 r
s
.83 .24 .1 r
.66913 .53986 m
.67002 .54269 L
s
.855 .238 .09 r
.66585 .54506 m .6696 .5568 L .67015 .53825 L p F P
0 0 0 r
s
.069 .081 .154 r
.49794 .64449 m .48144 .64682 L .48353 .65347 L p F P
0 0 0 r
s
.069 .081 .154 r
.46895 .65552 m .48353 .65347 L .48144 .64682 L p F P
0 0 0 r
s
.24 .35 .67 r
.45005 .64986 m
.49024 .64418 L
s
1 .318 .13 r
.35568 .43289 m .36192 .44451 L .37558 .42922 L p F P
0 0 0 r
s
1 .318 .13 r
.37558 .42922 m .37007 .41864 L .35568 .43289 L p F P
0 0 0 r
s
.83 .24 .1 r
.37422 .42498 m
.3874 .45035 L
s
.287 .44 .858 r
.46365 .3569 m .47299 .35521 L .48186 .36199 L p F P
0 0 0 r
s
.287 .44 .858 r
.48816 .36086 m .48186 .36199 L .47299 .35521 L p F P
0 0 0 r
s
.768 .232 .103 r
.5599 .37302 m .55768 .36684 L .57554 .36705 L p F P
0 0 0 r
s
.768 .232 .103 r
.57554 .36705 m .57833 .37513 L .5599 .37302 L p F P
0 0 0 r
s
.24 .35 .67 r
.61545 .61219 m
.65672 .60627 L
s
.19172 .40163 m
.18049 .40621 L
s
.23067 .39455 m
.19172 .40163 L
s
.095 .112 .226 r
.60715 .61874 m .5887 .62137 L .58157 .63267 L p F P
0 0 0 r
s
.095 .112 .226 r
.56469 .63505 m .58157 .63267 L .5887 .62137 L p F P
0 0 0 r
s
.24 .35 .67 r
.57194 .63262 m
.57463 .61804 L
s
1 .321 .132 r
.36447 .40788 m .37007 .41864 L .38733 .40656 L p F P
0 0 0 r
s
1 .321 .132 r
.38733 .40656 m .38261 .39715 L .36447 .40788 L p F P
0 0 0 r
s
.83 .24 .1 r
.37422 .42498 m
.39472 .40408 L
s
.855 .256 .112 r
.53572 .36138 m .53413 .35714 L .55092 .34794 L p F P
0 0 0 r
s
.855 .256 .112 r
.55092 .34794 m .55319 .3543 L .53572 .36138 L p F P
0 0 0 r
s
.24 .35 .67 r
.61148 .34007 m
.61734 .35506 L
s
.65864 .34773 m
.61734 .35506 L
s
.78131 .56882 m
.73933 .57494 L
s
.73933 .57494 m
.74063 .59424 L
s
.287 .44 .858 r
.47299 .35521 m .48236 .35351 L .48816 .36086 L p F P
0 0 0 r
s
.287 .44 .858 r
.49447 .35972 m .48816 .36086 L .48236 .35351 L p F P
0 0 0 r
s
.83 .24 .1 r
.6673 .58749 m
.66822 .58434 L
s
.72 .193 .072 r
.36654 .57155 m .37311 .58262 L .36955 .56546 L p F P
0 0 0 r
s
.83 .24 .1 r
.37039 .54663 m
.37194 .57115 L
s
.72 .193 .072 r
.36955 .56546 m .36274 .5539 L .36654 .57155 L p F P
0 0 0 r
s
1 .318 .133 r
.39162 .36502 m .39554 .37313 L .42015 .37149 L p F P
0 0 0 r
s
1 .318 .133 r
.42015 .37149 m .41727 .36529 L .39162 .36502 L p F P
0 0 0 r
s
.561 .145 .055 r
.37985 .59813 m .3859 .60827 L .37957 .59347 L p F P
0 0 0 r
s
.561 .145 .055 r
.37957 .59347 m .37311 .58262 L .37985 .59813 L p F P
0 0 0 r
s
.83 .24 .1 r
.37194 .57115 m
.38516 .59358 L
s
.66 .179 .065 r
.66295 .50719 m .65916 .49503 L .66256 .51405 L p F P
0 0 0 r
s
.66 .179 .065 r
.66256 .51405 m .66639 .52627 L .66295 .50719 L p F P
0 0 0 r
s
.287 .44 .858 r
.48236 .35351 m .49176 .35181 L .49447 .35972 L p F P
0 0 0 r
s
.287 .44 .858 r
.50079 .35859 m .49447 .35972 L .49176 .35181 L p F P
0 0 0 r
s
.069 .081 .154 r
.51452 .64214 m .49794 .64449 L .49818 .65142 L p F P
0 0 0 r
s
.069 .081 .154 r
.48353 .65347 m .49818 .65142 L .49794 .64449 L p F P
0 0 0 r
s
.24 .35 .67 r
.74261 .33282 m
.74693 .35309 L
s
.789 .34574 m
.74693 .35309 L
s
.888 .244 .094 r
.3558 .5421 m .36274 .5539 L .3623 .53529 L p F P
0 0 0 r
s
.888 .244 .094 r
.3623 .53529 m .35533 .52326 L .3558 .5421 L p F P
0 0 0 r
s
.287 .44 .858 r
.49176 .35181 m .50117 .35011 L .50079 .35859 L p F P
0 0 0 r
s
.287 .44 .858 r
.50712 .35745 m .50079 .35859 L .50117 .35011 L p F P
0 0 0 r
s
.095 .112 .226 r
.6257 .61609 m .60715 .61874 L .59852 .63027 L p F P
0 0 0 r
s
.095 .112 .226 r
.58157 .63267 m .59852 .63027 L .60715 .61874 L p F P
0 0 0 r
s
.24 .35 .67 r
.35012 .37286 m
.35938 .37522 L
s
.245 .071 .038 r
.39517 .62076 m .40055 .6298 L .39184 .61822 L p F P
0 0 0 r
s
.245 .071 .038 r
.39184 .61822 m .3859 .60827 L .39517 .62076 L p F P
0 0 0 r
s
.83 .24 .1 r
.55853 .71267 m
.52862 .71659 L
s
.52862 .71659 m
.51813 .69627 L
s
.24 .35 .67 r
.40327 .66478 m
.36325 .6704 L
s
.36325 .6704 m
.35406 .67373 L
s
.287 .44 .858 r
.50117 .35011 m .51061 .3484 L .50712 .35745 L p F P
0 0 0 r
s
.287 .44 .858 r
.51346 .35631 m .50712 .35745 L .51061 .3484 L p F P
0 0 0 r
s
.187 .054 .028 r
.65201 .47645 m .64825 .46441 L .65529 .48262 L p F P
0 0 0 r
s
.187 .054 .028 r
.65529 .48262 m .65916 .49503 L .65201 .47645 L p F P
0 0 0 r
s
.855 .256 .112 r
.53413 .35714 m .53254 .35288 L .54862 .34152 L p F P
0 0 0 r
s
.83 .24 .1 r
.52233 .35671 m
.53306 .35654 L
s
.855 .256 .112 r
.54862 .34152 m .55092 .34794 L .53413 .35714 L p F P
0 0 0 r
s
.83 .24 .1 r
.53306 .35654 m
.54306 .38331 L
s
.655 .2 .091 r
.58108 .38311 m .57833 .37513 L .59523 .38033 L p F P
0 0 0 r
s
.655 .2 .091 r
.59523 .38033 m .59845 .38998 L .58108 .38311 L p F P
0 0 0 r
s
.996 .278 .11 r
.34821 .51097 m .35533 .52326 L .35833 .50419 L p F P
0 0 0 r
s
.996 .278 .11 r
.35833 .50419 m .35139 .49197 L .34821 .51097 L p F P
0 0 0 r
s
.83 .24 .1 r
.35675 .52303 m
.36143 .49788 L
s
.069 .081 .154 r
.53117 .63979 m .51452 .64214 L .51287 .64936 L p F P
0 0 0 r
s
.069 .081 .154 r
.49818 .65142 m .51287 .64936 L .51452 .64214 L p F P
0 0 0 r
s
.83 .24 .1 r
.63854 .66954 m
.63033 .64822 L
s
.63854 .66954 m
.61493 .68853 L
s
.287 .44 .858 r
.51061 .3484 m .52008 .34668 L .51346 .35631 L p F P
0 0 0 r
s
.287 .44 .858 r
.51981 .35517 m .51346 .35631 L .52008 .34668 L p F P
0 0 0 r
s
.768 .232 .103 r
.55768 .36684 m .55545 .3606 L .57272 .35887 L p F P
0 0 0 r
s
.768 .232 .103 r
.57272 .35887 m .57554 .36705 L .55768 .36684 L p F P
0 0 0 r
s
.83 .24 .1 r
.56073 .36102 m
.57026 .38792 L
s
.287 .44 .858 r
.52008 .34668 m .52957 .34497 L .51981 .35517 L p F P
0 0 0 r
s
.287 .44 .858 r
.52617 .35402 m .51981 .35517 L .52957 .34497 L p F P
0 0 0 r
s
.24 .35 .67 r
.52889 .35491 m
.53156 .36032 L
s
.48828 .36221 m
.52889 .35491 L
s
.267 .077 .042 r
.63776 .44736 m .6341 .4358 L .64441 .45213 L p F P
0 0 0 r
s
.267 .077 .042 r
.64441 .45213 m .64825 .46441 L .63776 .44736 L p F P
0 0 0 r
s
.83 .24 .1 r
.62455 .43735 m
.64093 .45555 L
s
.64093 .45555 m
.64878 .48035 L
s
.095 .112 .226 r
.64434 .61343 m .6257 .61609 L .61555 .62787 L p F P
0 0 0 r
s
.095 .112 .226 r
.59852 .63027 m .61555 .62787 L .6257 .61609 L p F P
0 0 0 r
s
1 .321 .133 r
.37295 .3779 m .37781 .3876 L .39941 .38114 L p F P
0 0 0 r
s
1 .321 .133 r
.39941 .38114 m .39554 .37313 L .37295 .3779 L p F P
0 0 0 r
s
.24 .35 .67 r
.35938 .37522 m
.39356 .36903 L
s
.65672 .60627 m
.66131 .60561 L
s
.22011 .39903 m
.23067 .39455 L
s
.27004 .3874 m
.23067 .39455 L
s
.27392 .68495 m
.23452 .69047 L
s
.22212 .68765 m
.23452 .69047 L
s
.504 .158 .074 r
.60162 .3995 m .59845 .38998 L .61376 .39967 L p F P
0 0 0 r
s
.504 .158 .074 r
.61376 .39967 m .61728 .41057 L .60162 .3995 L p F P
0 0 0 r
s
.263 .411 .799 r
.4265 .36362 m .41727 .36529 L .39162 .36502 L p F P
0 0 0 r
s
1 .3 .12 r
.34431 .47949 m .35139 .49197 L .35808 .47348 L p F P
0 0 0 r
s
1 .3 .12 r
.35808 .47348 m .35139 .46138 L .34431 .47949 L p F P
0 0 0 r
s
.287 .44 .858 r
.52957 .34497 m .53908 .34324 L .52617 .35402 L p F P
0 0 0 r
s
.287 .44 .858 r
.53254 .35288 m .52617 .35402 L .53908 .34324 L p F P
0 0 0 r
s
.24 .35 .67 r
.65346 .33253 m
.65864 .34773 L
s
.70039 .34031 m
.65864 .34773 L
s
.38 .117 .058 r
.62075 .42129 m .61728 .41057 L .63037 .42402 L p F P
0 0 0 r
s
.38 .117 .058 r
.63037 .42402 m .6341 .4358 L .62075 .42129 L p F P
0 0 0 r
s
.24 .35 .67 r
.82375 .56262 m
.78131 .56882 L
s
.78131 .56882 m
.78329 .58812 L
s
.069 .081 .154 r
.54789 .63743 m .53117 .63979 L .52763 .64728 L p F P
0 0 0 r
s
.24 .35 .67 r
.53087 .63843 m
.53425 .62383 L
s
.069 .081 .154 r
.51287 .64936 m .52763 .64728 L .53117 .63979 L p F P
0 0 0 r
s
.24 .35 .67 r
.49024 .64418 m
.53087 .63843 L
s
.52889 .35491 m
.53599 .35363 L
s
.042 .053 .102 r
.43996 .65959 m .42554 .66161 L .43706 .66343 L p F P
0 0 0 r
s
.486 .155 .073 r
.43335 .65703 m .43706 .66343 L .42554 .66161 L p F P
0 0 0 r
s
.83 .24 .1 r
.43064 .66242 m
.43073 .66257 L
s
.486 .155 .073 r
.42554 .66161 m .42107 .65402 L .43335 .65703 L p F P
0 0 0 r
s
.287 .44 .858 r
.53908 .34324 m .54862 .34152 L .53254 .35288 L p F P
0 0 0 r
s
.83 .24 .1 r
.53128 .35178 m
.53306 .35654 L
s
.263 .411 .799 r
.39162 .36502 m .40368 .36283 L .4265 .36362 L p F P
0 0 0 r
s
.83 .24 .1 r
.4088 .36482 m
.41889 .38628 L
s
.263 .411 .799 r
.43575 .36194 m .4265 .36362 L .40368 .36283 L p F P
0 0 0 r
s
.83 .24 .1 r
.5878 .70317 m
.55853 .71267 L
s
.55853 .71267 m
.54862 .69219 L
s
.365 .111 .056 r
.41193 .6385 m .41654 .64632 L .40584 .6387 L p F P
0 0 0 r
s
.365 .111 .056 r
.40584 .6387 m .40055 .6298 L .41193 .6385 L p F P
0 0 0 r
s
.83 .24 .1 r
.39286 .61646 m
.40303 .6317 L
s
.24 .35 .67 r
.7853 .32524 m
.789 .34574 L
s
1 .312 .126 r
.34456 .44904 m .35139 .46138 L .36192 .44451 L p F P
0 0 0 r
s
1 .312 .126 r
.36192 .44451 m .35568 .43289 L .34456 .44904 L p F P
0 0 0 r
s
.83 .24 .1 r
.35824 .44825 m
.37184 .47335 L
s
1 .321 .132 r
.35878 .39693 m .36447 .40788 L .38261 .39715 L p F P
0 0 0 r
s
1 .321 .132 r
.38261 .39715 m .37781 .3876 L .35878 .39693 L p F P
0 0 0 r
s
.095 .112 .226 r
.66307 .61076 m .64434 .61343 L .63266 .62545 L p F P
0 0 0 r
s
.095 .112 .226 r
.61555 .62787 m .63266 .62545 L .64434 .61343 L p F P
0 0 0 r
s
.83 .24 .1 r
.61493 .68853 m
.60619 .66753 L
s
.61493 .68853 m
.5878 .70317 L
s
1 .318 .13 r
.34932 .42106 m .35568 .43289 L .37007 .41864 L p F P
0 0 0 r
s
.83 .24 .1 r
.35824 .44825 m
.37422 .42498 L
s
1 .318 .13 r
.37007 .41864 m .36447 .40788 L .34932 .42106 L p F P
0 0 0 r
s
.263 .411 .799 r
.40368 .36283 m .41577 .36064 L .43575 .36194 L p F P
0 0 0 r
s
.83 .24 .1 r
.40622 .35932 m
.40754 .36213 L
s
.263 .411 .799 r
.44503 .36027 m .43575 .36194 L .41577 .36064 L p F P
0 0 0 r
s
.24 .35 .67 r
.4398 .36066 m
.4481 .36942 L
s
.40745 .36652 m
.4398 .36066 L
s
.069 .081 .154 r
.56469 .63505 m .54789 .63743 L .54245 .64521 L p F P
0 0 0 r
s
.069 .081 .154 r
.52763 .64728 m .54245 .64521 L .54789 .63743 L p F P
0 0 0 r
s
.042 .053 .102 r
.45442 .65756 m .43996 .65959 L .44926 .66172 L p F P
0 0 0 r
s
.042 .053 .102 r
.43706 .66343 m .44926 .66172 L .43996 .65959 L p F P
0 0 0 r
s
.83 .24 .1 r
.43073 .66257 m
.4379 .67484 L
s
1 .308 .123 r
.66855 .58534 m .66493 .57433 L .65611 .59039 L p F P
0 0 0 r
s
1 .308 .123 r
.65611 .59039 m .65962 .60067 L .66855 .58534 L p F P
0 0 0 r
s
.24 .35 .67 r
.66608 .60493 m
.69845 .60029 L
s
.998 .282 .11 r
.6696 .5568 m .66585 .54506 L .66124 .56309 L p F P
0 0 0 r
s
.998 .282 .11 r
.66124 .56309 m .66493 .57433 L .6696 .5568 L p F P
0 0 0 r
s
.24 .35 .67 r
.40327 .66478 m
.42695 .66146 L
s
.42695 .66146 m
.42825 .66128 L
s
.43525 .6603 m
.44373 .65911 L
s
.40327 .66478 m
.3948 .66802 L
s
.83 .24 .1 r
.5878 .70317 m
.57848 .68245 L
s
.48858 .69456 m
.46142 .68725 L
s
.46142 .68725 m
.44945 .6662 L
s
.768 .232 .103 r
.55545 .3606 m .55319 .3543 L .56987 .35058 L p F P
0 0 0 r
s
.768 .232 .103 r
.56987 .35058 m .57272 .35887 L .55545 .3606 L p F P
0 0 0 r
s
.83 .24 .1 r
.53306 .35654 m
.56073 .36102 L
s
.24 .35 .67 r
.55193 .35077 m
.56996 .34753 L
s
.56996 .34753 m
.57649 .36231 L
s
.263 .411 .799 r
.41577 .36064 m .4279 .35843 L .44503 .36027 L p F P
0 0 0 r
s
.263 .411 .799 r
.45433 .35858 m .44503 .36027 L .4279 .35843 L p F P
0 0 0 r
s
.855 .238 .09 r
.66639 .52627 m .66256 .51405 L .66203 .53307 L p F P
0 0 0 r
s
.83 .24 .1 r
.66536 .52789 m
.66626 .53077 L
s
.65972 .50189 m
.66252 .5153 L
s
.855 .238 .09 r
.66203 .53307 m .66585 .54506 L .66639 .52627 L p F P
0 0 0 r
s
.655 .2 .091 r
.57833 .37513 m .57554 .36705 L .59197 .37053 L p F P
0 0 0 r
s
.655 .2 .091 r
.59197 .37053 m .59523 .38033 L .57833 .37513 L p F P
0 0 0 r
s
.095 .112 .226 r
.63266 .62545 m .64985 .62302 L .66307 .61076 L p F P
0 0 0 r
s
1 .323 .13 r
.66307 .61076 m .65962 .60067 L .64657 .61386 L p F P
0 0 0 r
s
1 .323 .13 r
.64657 .61386 m .64985 .62302 L .66307 .61076 L p F P
0 0 0 r
s
.24 .35 .67 r
.65547 .6208 m
.65588 .61599 L
s
.83 .24 .1 r
.6497 .62554 m
.6524 .62065 L
s
.042 .053 .102 r
.46895 .65552 m .45442 .65756 L .4615 .66001 L p F P
0 0 0 r
s
.042 .053 .102 r
.44926 .66172 m .4615 .66001 L .45442 .65756 L p F P
0 0 0 r
s
.24 .35 .67 r
.44373 .65911 m
.45005 .64986 L
s
.069 .081 .154 r
.58157 .63267 m .56469 .63505 L .55732 .64312 L p F P
0 0 0 r
s
.069 .081 .154 r
.54245 .64521 m .55732 .64312 L .56469 .63505 L p F P
0 0 0 r
s
.24 .35 .67 r
.53087 .63843 m
.57194 .63262 L
s
.263 .411 .799 r
.4279 .35843 m .44007 .35622 L .45433 .35858 L p F P
0 0 0 r
s
.83 .24 .1 r
.43371 .34496 m
.43882 .35645 L
s
.263 .411 .799 r
.46365 .3569 m .45433 .35858 L .44007 .35622 L p F P
0 0 0 r
s
.24 .35 .67 r
.74063 .59424 m
.69845 .60029 L
s
.69845 .60029 m
.69794 .61479 L
s
.26018 .39177 m
.27004 .3874 L
s
.30986 .38017 m
.27004 .3874 L
s
.561 .145 .055 r
.37369 .5878 m .37985 .59813 L .37311 .58262 L p F P
0 0 0 r
s
.561 .145 .055 r
.37311 .58262 m .36654 .57155 L .37369 .5878 L p F P
0 0 0 r
s
.83 .24 .1 r
.37194 .57115 m
.37964 .59422 L
s
.72 .193 .072 r
.35982 .56026 m .36654 .57155 L .36274 .5539 L p F P
0 0 0 r
s
.72 .193 .072 r
.36274 .5539 m .3558 .5421 L .35982 .56026 L p F P
0 0 0 r
s
.83 .24 .1 r
.35675 .52303 m
.37039 .54663 L
s
.24 .35 .67 r
.31377 .67937 m
.27392 .68495 L
s
.27392 .68495 m
.2622 .68201 L
s
.69592 .3249 m
.70039 .34031 L
s
.74261 .33282 m
.70039 .34031 L
s
1 .321 .133 r
.36801 .36807 m .37295 .3779 L .39554 .37313 L p F P
0 0 0 r
s
.83 .24 .1 r
.3815 .37739 m
.39472 .40408 L
s
1 .321 .133 r
.39554 .37313 m .39162 .36502 L .36801 .36807 L p F P
0 0 0 r
s
.66 .179 .065 r
.65916 .49503 m .65529 .48262 L .65864 .50157 L p F P
0 0 0 r
s
.83 .24 .1 r
.65884 .49908 m
.65972 .50189 L
s
.66 .179 .065 r
.65864 .50157 m .66256 .51405 L .65916 .49503 L p F P
0 0 0 r
s
.24 .35 .67 r
.82375 .56262 m
.82643 .58194 L
s
.61148 .34007 m
.56996 .34753 L
s
.263 .411 .799 r
.44007 .35622 m .45228 .354 L .46365 .3569 L p F P
0 0 0 r
s
.263 .411 .799 r
.47299 .35521 m .46365 .3569 L .45228 .354 L p F P
0 0 0 r
s
.245 .071 .038 r
.3897 .61156 m .39517 .62076 L .3859 .60827 L p F P
0 0 0 r
s
.245 .071 .038 r
.3859 .60827 m .37985 .59813 L .3897 .61156 L p F P
0 0 0 r
s
.83 .24 .1 r
.37964 .59422 m
.39286 .61646 L
s
.888 .244 .094 r
.34871 .53005 m .3558 .5421 L .35533 .52326 L p F P
0 0 0 r
s
.888 .244 .094 r
.35533 .52326 m .34821 .51097 L .34871 .53005 L p F P
0 0 0 r
s
.042 .053 .102 r
.48353 .65347 m .46895 .65552 L .47378 .65829 L p F P
0 0 0 r
s
.042 .053 .102 r
.4615 .66001 m .47378 .65829 L .46895 .65552 L p F P
0 0 0 r
s
.069 .081 .154 r
.59852 .63027 m .58157 .63267 L .57226 .64102 L p F P
0 0 0 r
s
.069 .081 .154 r
.55732 .64312 m .57226 .64102 L .58157 .63267 L p F P
0 0 0 r
s
.504 .158 .074 r
.59845 .38998 m .59523 .38033 L .61017 .38858 L p F P
0 0 0 r
s
.504 .158 .074 r
.61017 .38858 m .61376 .39967 L .59845 .38998 L p F P
0 0 0 r
s
.187 .054 .028 r
.64825 .46441 m .64441 .45213 L .65134 .46994 L p F P
0 0 0 r
s
.187 .054 .028 r
.65134 .46994 m .65529 .48262 L .64825 .46441 L p F P
0 0 0 r
s
.83 .24 .1 r
.64093 .45555 m
.652 .47723 L
s
.652 .47723 m
.65737 .49439 L
s
.263 .411 .799 r
.45228 .354 m .46454 .35178 L .47299 .35521 L p F P
0 0 0 r
s
.263 .411 .799 r
.48236 .35351 m .47299 .35521 L .46454 .35178 L p F P
0 0 0 r
s
.83 .24 .1 r
.40622 .35932 m
.43371 .34496 L
s
.43371 .34496 m
.4211 .31658 L
s
.43371 .34496 m
.46299 .33483 L
s
.486 .155 .073 r
.4296 .65055 m .43335 .65703 L .42107 .65402 L p F P
0 0 0 r
s
.486 .155 .073 r
.42107 .65402 m .41654 .64632 L .4296 .65055 L p F P
0 0 0 r
s
.83 .24 .1 r
.41584 .64514 m
.41755 .64665 L
s
.768 .232 .103 r
.55319 .3543 m .55092 .34794 L .56698 .3422 L p F P
0 0 0 r
s
.768 .232 .103 r
.56698 .3422 m .56987 .35058 L .55319 .3543 L p F P
0 0 0 r
s
.24 .35 .67 r
.56756 .3439 m
.56996 .34753 L
s
.996 .278 .11 r
.34094 .49843 m .34821 .51097 L .35139 .49197 L p F P
0 0 0 r
s
.996 .278 .11 r
.35139 .49197 m .34431 .47949 L .34094 .49843 L p F P
0 0 0 r
s
.267 .077 .042 r
.6341 .4358 m .63037 .42402 L .64049 .43961 L p F P
0 0 0 r
s
.267 .077 .042 r
.64049 .43961 m .64441 .45213 L .6341 .4358 L p F P
0 0 0 r
s
.38 .117 .058 r
.61728 .41057 m .61376 .39967 L .62657 .41202 L p F P
0 0 0 r
s
.83 .24 .1 r
.59497 .39738 m
.61613 .41145 L
s
.38 .117 .058 r
.62657 .41202 m .63037 .42402 L .61728 .41057 L p F P
0 0 0 r
s
.83 .24 .1 r
.61613 .41145 m
.62455 .43735 L
s
.042 .053 .102 r
.49818 .65142 m .48353 .65347 L .4861 .65657 L p F P
0 0 0 r
s
.042 .053 .102 r
.47378 .65829 m .4861 .65657 L .48353 .65347 L p F P
0 0 0 r
s
.24 .35 .67 r
.44373 .65911 m
.48464 .65336 L
s
.263 .411 .799 r
.46454 .35178 m .47683 .34955 L .48236 .35351 L p F P
0 0 0 r
s
.83 .24 .1 r
.46299 .33483 m
.4697 .35084 L
s
.263 .411 .799 r
.49176 .35181 m .48236 .35351 L .47683 .34955 L p F P
0 0 0 r
s
.24 .35 .67 r
.48067 .35326 m
.48828 .36221 L
s
.4398 .36066 m
.48067 .35326 L
s
1 .321 .132 r
.35299 .3858 m .35878 .39693 L .37781 .3876 L p F P
0 0 0 r
s
1 .321 .132 r
.37781 .3876 m .37295 .3779 L .35299 .3858 L p F P
0 0 0 r
s
.83 .24 .1 r
.40065 .36338 m
.40622 .35932 L
s
.069 .081 .154 r
.61555 .62787 m .59852 .63027 L .58725 .63892 L p F P
0 0 0 r
s
.069 .081 .154 r
.57226 .64102 m .58725 .63892 L .59852 .63027 L p F P
0 0 0 r
s
.83 .24 .1 r
.46299 .33483 m
.45098 .30619 L
s
.46299 .33483 m
.49299 .32931 L
s
1 .3 .12 r
.33708 .46675 m .34431 .47949 L .35139 .46138 L p F P
0 0 0 r
s
.83 .24 .1 r
.34748 .47305 m
.36143 .49788 L
s
1 .3 .12 r
.35139 .46138 m .34456 .44904 L .33708 .46675 L p F P
0 0 0 r
s
.365 .111 .056 r
.40726 .63057 m .41193 .6385 L .40055 .6298 L p F P
0 0 0 r
s
.365 .111 .056 r
.40055 .6298 m .39517 .62076 L .40726 .63057 L p F P
0 0 0 r
s
.263 .411 .799 r
.47683 .34955 m .48917 .34731 L .49176 .35181 L p F P
0 0 0 r
s
.263 .411 .799 r
.50117 .35011 m .49176 .35181 L .48917 .34731 L p F P
0 0 0 r
s
.655 .2 .091 r
.57554 .36705 m .57272 .35887 L .58865 .36058 L p F P
0 0 0 r
s
.655 .2 .091 r
.58865 .36058 m .59197 .37053 L .57554 .36705 L p F P
0 0 0 r
s
.83 .24 .1 r
.56073 .36102 m
.58585 .3704 L
s
.24 .35 .67 r
.78329 .58812 m
.74063 .59424 L
s
.74063 .59424 m
.74088 .60871 L
s
.042 .053 .102 r
.51287 .64936 m .49818 .65142 L .49846 .65484 L p F P
0 0 0 r
s
.042 .053 .102 r
.4861 .65657 m .49846 .65484 L .49818 .65142 L p F P
0 0 0 r
s
.24 .35 .67 r
.48464 .65336 m
.49024 .64418 L
s
.30071 .38442 m
.30986 .38017 L
s
.35012 .37286 m
.30986 .38017 L
s
1 .318 .13 r
.34284 .40901 m .34932 .42106 L .36447 .40788 L p F P
0 0 0 r
s
1 .318 .13 r
.36447 .40788 m .35878 .39693 L .34284 .40901 L p F P
0 0 0 r
s
.83 .24 .1 r
.3605 .39856 m
.37422 .42498 L
s
1 .312 .126 r
.33759 .43645 m .34456 .44904 L .35568 .43289 L p F P
0 0 0 r
s
.83 .24 .1 r
.34748 .47305 m
.35824 .44825 L
s
1 .312 .126 r
.35568 .43289 m .34932 .42106 L .33759 .43645 L p F P
0 0 0 r
s
.24 .35 .67 r
.35406 .67373 m
.31377 .67937 L
s
.31377 .67937 m
.30273 .6763 L
s
.73885 .31719 m
.74261 .33282 L
s
.7853 .32524 m
.74261 .33282 L
s
.263 .411 .799 r
.48917 .34731 m .50154 .34506 L .50117 .35011 L p F P
0 0 0 r
s
.83 .24 .1 r
.49299 .32931 m
.49938 .34545 L
s
.50118 .35 m
.50122 .3501 L
s
.263 .411 .799 r
.51061 .3484 m .50117 .35011 L .50154 .34506 L p F P
0 0 0 r
s
.83 .24 .1 r
.51813 .69627 m
.48858 .69456 L
s
.48858 .69456 m
.47708 .67348 L
s
.206 .334 .645 r
.40368 .36283 m .39162 .36502 L .36801 .36807 L p F P
0 0 0 r
s
.83 .24 .1 r
.3815 .37739 m
.39916 .36448 L
s
.069 .081 .154 r
.63266 .62545 m .61555 .62787 L .60231 .6368 L p F P
0 0 0 r
s
.24 .35 .67 r
.61347 .62674 m
.61545 .61219 L
s
.069 .081 .154 r
.58725 .63892 m .60231 .6368 L .61555 .62787 L p F P
0 0 0 r
s
.24 .35 .67 r
.57194 .63262 m
.61347 .62674 L
s
.60609 .33056 m
.61148 .34007 L
s
.65346 .33253 m
.61148 .34007 L
s
.65011 .62156 m
.65547 .6208 L
s
.263 .411 .799 r
.50154 .34506 m .51396 .3428 L .51061 .3484 L p F P
0 0 0 r
s
.263 .411 .799 r
.52008 .34668 m .51061 .3484 L .51396 .3428 L p F P
0 0 0 r
s
.042 .053 .102 r
.52763 .64728 m .51287 .64936 L .51086 .6531 L p F P
0 0 0 r
s
.042 .053 .102 r
.49846 .65484 m .51086 .6531 L .51287 .64936 L p F P
0 0 0 r
s
1 .308 .123 r
.66493 .57433 m .66124 .56309 L .65253 .57991 L p F P
0 0 0 r
s
1 .308 .123 r
.65253 .57991 m .65611 .59039 L .66493 .57433 L p F P
0 0 0 r
s
.24 .35 .67 r
.18049 .40621 m
.17059 .41731 L
s
.22011 .39903 m
.18049 .40621 L
s
.768 .232 .103 r
.55092 .34794 m .54862 .34152 L .56405 .3337 L p F P
0 0 0 r
s
.768 .232 .103 r
.56405 .3337 m .56698 .3422 L .55092 .34794 L p F P
0 0 0 r
s
.998 .282 .11 r
.66585 .54506 m .66203 .53307 L .65747 .55162 L p F P
0 0 0 r
s
.998 .282 .11 r
.65747 .55162 m .66124 .56309 L .66585 .54506 L p F P
0 0 0 r
s
.206 .334 .645 r
.36801 .36807 m .38265 .36541 L .40368 .36283 L p F P
0 0 0 r
s
.83 .24 .1 r
.37631 .36691 m
.3815 .37739 L
s
.24 .35 .67 r
.39083 .36547 m
.39696 .36727 L
s
.206 .334 .645 r
.41577 .36064 m .40368 .36283 L .38265 .36541 L p F P
0 0 0 r
s
1 .323 .13 r
.65962 .60067 m .65611 .59039 L .64324 .60454 L p F P
0 0 0 r
s
1 .323 .13 r
.64324 .60454 m .64657 .61386 L .65962 .60067 L p F P
0 0 0 r
s
.83 .24 .1 r
.49299 .32931 m
.48157 .30044 L
s
.49299 .32931 m
.52263 .32866 L
s
.263 .411 .799 r
.51396 .3428 m .52642 .34054 L .52008 .34668 L p F P
0 0 0 r
s
.263 .411 .799 r
.52957 .34497 m .52008 .34668 L .52642 .34054 L p F P
0 0 0 r
s
.24 .35 .67 r
.52201 .34578 m
.52889 .35491 L
s
.48067 .35326 m
.52201 .34578 L
s
.069 .081 .154 r
.64985 .62302 m .63266 .62545 L .61743 .63468 L p F P
0 0 0 r
s
.83 .24 .1 r
.64892 .62336 m
.6497 .62554 L
s
.069 .081 .154 r
.60231 .6368 m .61743 .63468 L .63266 .62545 L p F P
0 0 0 r
s
.855 .238 .09 r
.66256 .51405 m .65864 .50157 L .65812 .52083 L p F P
0 0 0 r
s
.83 .24 .1 r
.6615 .51566 m
.66243 .51861 L
s
.855 .238 .09 r
.65812 .52083 m .66203 .53307 L .66256 .51405 L p F P
0 0 0 r
s
.042 .053 .102 r
.54245 .64521 m .52763 .64728 L .52331 .65136 L p F P
0 0 0 r
s
.042 .053 .102 r
.51086 .6531 m .52331 .65136 L .52763 .64728 L p F P
0 0 0 r
s
.504 .158 .074 r
.59523 .38033 m .59197 .37053 L .60651 .3773 L p F P
0 0 0 r
s
.83 .24 .1 r
.58585 .3704 m
.59497 .39738 L
s
.504 .158 .074 r
.60651 .3773 m .61017 .38858 L .59523 .38033 L p F P
0 0 0 r
s
.206 .334 .645 r
.38265 .36541 m .39734 .36273 L .41577 .36064 L p F P
0 0 0 r
s
.206 .334 .645 r
.4279 .35843 m .41577 .36064 L .39734 .36273 L p F P
0 0 0 r
s
.263 .411 .799 r
.52642 .34054 m .53892 .33827 L .52957 .34497 L p F P
0 0 0 r
s
.83 .24 .1 r
.52263 .32866 m
.52703 .34043 L
s
.263 .411 .799 r
.53908 .34324 m .52957 .34497 L .53892 .33827 L p F P
0 0 0 r
s
.561 .145 .055 r
.36741 .57727 m .37369 .5878 L .36654 .57155 L p F P
0 0 0 r
s
.561 .145 .055 r
.36654 .57155 m .35982 .56026 L .36741 .57727 L p F P
0 0 0 r
s
.83 .24 .1 r
.65849 .56839 m
.66063 .56124 L
s
.486 .155 .073 r
.42581 .64399 m .4296 .65055 L .41654 .64632 L p F P
0 0 0 r
s
.486 .155 .073 r
.41654 .64632 m .41193 .6385 L .42581 .64399 L p F P
0 0 0 r
s
.72 .193 .072 r
.35297 .54874 m .35982 .56026 L .3558 .5421 L p F P
0 0 0 r
s
.83 .24 .1 r
.35816 .54777 m
.37194 .57115 L
s
.35675 .52303 m
.35816 .54777 L
s
.72 .193 .072 r
.3558 .5421 m .34871 .53005 L .35297 .54874 L p F P
0 0 0 r
s
.245 .071 .038 r
.38413 .6022 m .3897 .61156 L .37985 .59813 L p F P
0 0 0 r
s
.245 .071 .038 r
.37985 .59813 m .37369 .5878 L .38413 .6022 L p F P
0 0 0 r
s
.66 .179 .065 r
.65529 .48262 m .65134 .46994 L .65464 .48882 L p F P
0 0 0 r
s
.66 .179 .065 r
.65464 .48882 m .65864 .50157 L .65529 .48262 L p F P
0 0 0 r
s
.24 .35 .67 r
.82643 .58194 m
.78329 .58812 L
s
.78329 .58812 m
.78432 .60257 L
s
.37524 .3683 m
.39083 .36547 L
s
.069 .081 .154 r
.61743 .63468 m .6326 .63255 L .64985 .62302 L p F P
0 0 0 r
s
1 .33 .135 r
.64985 .62302 m .64657 .61386 L .62957 .62452 L p F P
0 0 0 r
s
.24 .35 .67 r
.61347 .62674 m
.6297 .62444 L
s
1 .33 .135 r
.62957 .62452 m .6326 .63255 L .64985 .62302 L p F P
0 0 0 r
s
.83 .24 .1 r
.63033 .64822 m
.6497 .62554 L
s
.655 .2 .091 r
.57272 .35887 m .56987 .35058 L .58529 .35048 L p F P
0 0 0 r
s
.655 .2 .091 r
.58529 .35048 m .58865 .36058 L .57272 .35887 L p F P
0 0 0 r
s
.263 .411 .799 r
.53892 .33827 m .55146 .33599 L .53908 .34324 L p F P
0 0 0 r
s
.263 .411 .799 r
.54862 .34152 m .53908 .34324 L .55146 .33599 L p F P
0 0 0 r
s
.24 .35 .67 r
.3948 .66802 m
.35406 .67373 L
s
.35406 .67373 m
.34373 .67053 L
s
1 .321 .132 r
.3471 .37447 m .35299 .3858 L .37295 .3779 L p F P
0 0 0 r
s
1 .321 .132 r
.37295 .3779 m .36801 .36807 L .3471 .37447 L p F P
0 0 0 r
s
.83 .24 .1 r
.3605 .39856 m
.3815 .37739 L
s
.24 .35 .67 r
.35012 .37286 m
.35561 .37186 L
s
.042 .053 .102 r
.55732 .64312 m .54245 .64521 L .5358 .64961 L p F P
0 0 0 r
s
.042 .053 .102 r
.52331 .65136 m .5358 .64961 L .54245 .64521 L p F P
0 0 0 r
s
.24 .35 .67 r
.48464 .65336 m
.52601 .64756 L
s
.52601 .64756 m
.53087 .63843 L
s
.78227 .30939 m
.7853 .32524 L
s
.206 .334 .645 r
.39734 .36273 m .4121 .36005 L .4279 .35843 L p F P
0 0 0 r
s
.206 .334 .645 r
.44007 .35622 m .4279 .35843 L .4121 .36005 L p F P
0 0 0 r
s
.888 .244 .094 r
.34147 .51775 m .34871 .53005 L .34821 .51097 L p F P
0 0 0 r
s
.888 .244 .094 r
.34821 .51097 m .34094 .49843 L .34147 .51775 L p F P
0 0 0 r
s
.38 .117 .058 r
.61376 .39967 m .61017 .38858 L .62269 .3998 L p F P
0 0 0 r
s
.38 .117 .058 r
.62269 .3998 m .62657 .41202 L .61376 .39967 L p F P
0 0 0 r
s
.24 .35 .67 r
.64884 .32282 m
.65346 .33253 L
s
.69592 .3249 m
.65346 .33253 L
s
.65547 .6208 m
.69794 .61479 L
s
.65295 .62974 m
.65547 .6208 L
s
.187 .054 .028 r
.64441 .45213 m .64049 .43961 L .64731 .45699 L p F P
0 0 0 r
s
.187 .054 .028 r
.64731 .45699 m .65134 .46994 L .64441 .45213 L p F P
0 0 0 r
s
.65 .203 .092 r
.44769 .65621 m .45053 .66124 L .43706 .66343 L p F P
0 0 0 r
s
.65 .203 .092 r
.43706 .66343 m .43335 .65703 L .44769 .65621 L p F P
0 0 0 r
s
.181 .298 .578 r
.44926 .66172 m .43706 .66343 L .45053 .66124 L p F P
0 0 0 r
s
.83 .24 .1 r
.44362 .66316 m
.44945 .6662 L
s
.44256 .66261 m
.44362 .66316 L
s
.24 .35 .67 r
.43791 .66148 m
.43825 .66134 L
s
.43601 .66225 m
.43791 .66148 L
s
.263 .411 .799 r
.55146 .33599 m .56405 .3337 L .54862 .34152 L p F P
0 0 0 r
s
.83 .24 .1 r
.5508 .33299 m
.55183 .33592 L
s
.55282 .33872 m
.56073 .36102 L
s
.267 .077 .042 r
.63037 .42402 m .62657 .41202 L .63649 .42683 L p F P
0 0 0 r
s
.267 .077 .042 r
.63649 .42683 m .64049 .43961 L .63037 .42402 L p F P
0 0 0 r
s
.83 .24 .1 r
.61613 .41145 m
.63276 .4297 L
s
.63276 .4297 m
.64093 .45555 L
s
.54862 .69219 m
.51813 .69627 L
s
.51813 .69627 m
.50719 .67509 L
s
.206 .334 .645 r
.4121 .36005 m .42691 .35736 L .44007 .35622 L p F P
0 0 0 r
s
.24 .35 .67 r
.43199 .35799 m
.4398 .36066 L
s
.206 .334 .645 r
.45228 .354 m .44007 .35622 L .42691 .35736 L p F P
0 0 0 r
s
.365 .111 .056 r
.40251 .62251 m .40726 .63057 L .39517 .62076 L p F P
0 0 0 r
s
.365 .111 .056 r
.39517 .62076 m .3897 .61156 L .40251 .62251 L p F P
0 0 0 r
s
.83 .24 .1 r
.37964 .59422 m
.39325 .6146 L
s
.24 .35 .67 r
.21088 .41007 m
.22011 .39903 L
s
.26018 .39177 m
.22011 .39903 L
s
.2622 .68201 m
.22212 .68765 L
s
.20911 .67818 m
.22212 .68765 L
s
.042 .053 .102 r
.57226 .64102 m .55732 .64312 L .54833 .64786 L p F P
0 0 0 r
s
.042 .053 .102 r
.5358 .64961 m .54833 .64786 L .55732 .64312 L p F P
0 0 0 r
s
.996 .278 .11 r
.33351 .48561 m .34094 .49843 L .34431 .47949 L p F P
0 0 0 r
s
.996 .278 .11 r
.34431 .47949 m .33708 .46675 L .33351 .48561 L p F P
0 0 0 r
s
.83 .24 .1 r
.34253 .49844 m
.34748 .47305 L
s
.63033 .64822 m
.60619 .66753 L
s
1 .318 .13 r
.33623 .39672 m .34284 .40901 L .35878 .39693 L p F P
0 0 0 r
s
1 .318 .13 r
.35878 .39693 m .35299 .3858 L .33623 .39672 L p F P
0 0 0 r
s
.24 .35 .67 r
.52201 .34578 m
.55538 .33974 L
s
.181 .298 .578 r
.4615 .66001 m .44926 .66172 L .46014 .6599 L p F P
0 0 0 r
s
.181 .298 .578 r
.45053 .66124 m .46014 .6599 L .44926 .66172 L p F P
0 0 0 r
s
1 .3 .12 r
.32969 .45373 m .33708 .46675 L .34456 .44904 L p F P
0 0 0 r
s
1 .3 .12 r
.34456 .44904 m .33759 .43645 L .32969 .45373 L p F P
0 0 0 r
s
.206 .334 .645 r
.42691 .35736 m .44178 .35465 L .45228 .354 L p F P
0 0 0 r
s
.206 .334 .645 r
.46454 .35178 m .45228 .354 L .44178 .35465 L p F P
0 0 0 r
s
.83 .24 .1 r
.52263 .32866 m
.51177 .29958 L
s
.52263 .32866 m
.5508 .33299 L
s
1 .312 .126 r
.33048 .42361 m .33759 .43645 L .34932 .42106 L p F P
0 0 0 r
s
1 .312 .126 r
.34932 .42106 m .34284 .40901 L .33048 .42361 L p F P
0 0 0 r
s
.83 .24 .1 r
.34406 .4221 m
.3605 .39856 L
s
.34406 .4221 m
.35824 .44825 L
s
.042 .053 .102 r
.58725 .63892 m .57226 .64102 L .5609 .6461 L p F P
0 0 0 r
s
.042 .053 .102 r
.54833 .64786 m .5609 .6461 L .57226 .64102 L p F P
0 0 0 r
s
.181 .298 .578 r
.47378 .65829 m .4615 .66001 L .46976 .65855 L p F P
0 0 0 r
s
.181 .298 .578 r
.46014 .6599 m .46976 .65855 L .4615 .66001 L p F P
0 0 0 r
s
.206 .334 .645 r
.44178 .35465 m .45672 .35194 L .46454 .35178 L p F P
0 0 0 r
s
.206 .334 .645 r
.47683 .34955 m .46454 .35178 L .45672 .35194 L p F P
0 0 0 r
s
.24 .35 .67 r
.82643 .58194 m
.82825 .59635 L
s
.3948 .66802 m
.43601 .66225 L
s
.3948 .66802 m
.3852 .6647 L
s
.504 .158 .074 r
.59197 .37053 m .58865 .36058 L .6028 .36583 L p F P
0 0 0 r
s
.504 .158 .074 r
.6028 .36583 m .60651 .3773 L .59197 .37053 L p F P
0 0 0 r
s
.83 .24 .1 r
.57848 .68245 m
.54862 .69219 L
s
.54862 .69219 m
.53828 .67083 L
s
.655 .2 .091 r
.56987 .35058 m .56698 .3422 L .58187 .34023 L p F P
0 0 0 r
s
.655 .2 .091 r
.58187 .34023 m .58529 .35048 L .56987 .35058 L p F P
0 0 0 r
s
.83 .24 .1 r
.60619 .66753 m
.59708 .64564 L
s
.60619 .66753 m
.57848 .68245 L
s
.042 .053 .102 r
.60231 .6368 m .58725 .63892 L .57351 .64434 L p F P
0 0 0 r
s
.042 .053 .102 r
.5609 .6461 m .57351 .64434 L .58725 .63892 L p F P
0 0 0 r
s
.24 .35 .67 r
.52601 .64756 m
.56785 .64168 L
s
.56785 .64168 m
.57194 .63262 L
s
.181 .298 .578 r
.4861 .65657 m .47378 .65829 L .47941 .6572 L p F P
0 0 0 r
s
.181 .298 .578 r
.46976 .65855 m .47941 .6572 L .47378 .65829 L p F P
0 0 0 r
s
1 .308 .123 r
.66124 .56309 m .65747 .55162 L .64889 .56923 L p F P
0 0 0 r
s
1 .308 .123 r
.64889 .56923 m .65253 .57991 L .66124 .56309 L p F P
0 0 0 r
s
.24 .35 .67 r
.69209 .31499 m
.69592 .3249 L
s
.73885 .31719 m
.69592 .3249 L
s
.74088 .60871 m
.69794 .61479 L
s
.69794 .61479 m
.69623 .62367 L
s
1 .323 .13 r
.65611 .59039 m .65253 .57991 L .63984 .59506 L p F P
0 0 0 r
s
1 .323 .13 r
.63984 .59506 m .64324 .60454 L .65611 .59039 L p F P
0 0 0 r
s
.486 .155 .073 r
.42196 .63735 m .42581 .64399 L .41193 .6385 L p F P
0 0 0 r
s
.486 .155 .073 r
.41193 .6385 m .40726 .63057 L .42196 .63735 L p F P
0 0 0 r
s
.206 .334 .645 r
.45672 .35194 m .47171 .34921 L .47683 .34955 L p F P
0 0 0 r
s
.24 .35 .67 r
.47363 .35043 m
.48067 .35326 L
s
.206 .334 .645 r
.48917 .34731 m .47683 .34955 L .47171 .34921 L p F P
0 0 0 r
s
.998 .282 .11 r
.66203 .53307 m .65812 .52083 L .65362 .53992 L p F P
0 0 0 r
s
.998 .282 .11 r
.65362 .53992 m .65747 .55162 L .66203 .53307 L p F P
0 0 0 r
s
.83 .24 .1 r
.57848 .68245 m
.56877 .66085 L
s
.65 .203 .092 r
.44482 .65113 m .44769 .65621 L .43335 .65703 L p F P
0 0 0 r
s
.65 .203 .092 r
.43335 .65703 m .4296 .65055 L .44482 .65113 L p F P
0 0 0 r
s
.83 .24 .1 r
.47708 .67348 m
.44945 .6662 L
s
.44699 .66186 m
.44945 .6662 L
s
.03 .041 .078 r
.38265 .36541 m .36801 .36807 L .3471 .37447 L p F P
0 0 0 r
s
.83 .24 .1 r
.37587 .36602 m
.37615 .36659 L
s
.24 .35 .67 r
.25163 .40273 m
.26018 .39177 L
s
.30071 .38442 m
.26018 .39177 L
s
.30273 .6763 m
.2622 .68201 L
s
.2622 .68201 m
.24984 .67239 L
s
.181 .298 .578 r
.49846 .65484 m .4861 .65657 L .48909 .65585 L p F P
0 0 0 r
s
.181 .298 .578 r
.47941 .6572 m .48909 .65585 L .4861 .65657 L p F P
0 0 0 r
s
.24 .35 .67 r
.47768 .65641 m
.48464 .65336 L
s
.042 .053 .102 r
.61743 .63468 m .60231 .6368 L .58617 .64257 L p F P
0 0 0 r
s
.042 .053 .102 r
.57351 .64434 m .58617 .64257 L .60231 .6368 L p F P
0 0 0 r
s
1 .33 .135 r
.64657 .61386 m .64324 .60454 L .6265 .61637 L p F P
0 0 0 r
s
.83 .24 .1 r
.64556 .61399 m
.64571 .6144 L
s
1 .33 .135 r
.6265 .61637 m .62957 .62452 L .64657 .61386 L p F P
0 0 0 r
s
.206 .334 .645 r
.47171 .34921 m .48677 .34648 L .48917 .34731 L p F P
0 0 0 r
s
.206 .334 .645 r
.50154 .34506 m .48917 .34731 L .48677 .34648 L p F P
0 0 0 r
s
.855 .238 .09 r
.65864 .50157 m .65464 .48882 L .65412 .50833 L p F P
0 0 0 r
s
.83 .24 .1 r
.65757 .50318 m
.65852 .50618 L
s
.652 .47723 m
.65461 .4898 L
s
.855 .238 .09 r
.65412 .50833 m .65812 .52083 L .65864 .50157 L p F P
0 0 0 r
s
.561 .145 .055 r
.36101 .56654 m .36741 .57727 L .35982 .56026 L p F P
0 0 0 r
s
.561 .145 .055 r
.35982 .56026 m .35297 .54874 L .36101 .56654 L p F P
0 0 0 r
s
.83 .24 .1 r
.35816 .54777 m
.36585 .57104 L
s
.245 .071 .038 r
.37846 .59267 m .38413 .6022 L .37369 .5878 L p F P
0 0 0 r
s
.245 .071 .038 r
.37369 .5878 m .36741 .57727 L .37846 .59267 L p F P
0 0 0 r
s
.83 .24 .1 r
.36585 .57104 m
.37964 .59422 L
s
.38 .117 .058 r
.61017 .38858 m .60651 .3773 L .61874 .38733 L p F P
0 0 0 r
s
.83 .24 .1 r
.58585 .3704 m
.60736 .38445 L
s
.38 .117 .058 r
.61874 .38733 m .62269 .3998 L .61017 .38858 L p F P
0 0 0 r
s
.83 .24 .1 r
.60736 .38445 m
.61613 .41145 L
s
.181 .298 .578 r
.51086 .6531 m .49846 .65484 L .49879 .65449 L p F P
0 0 0 r
s
.181 .298 .578 r
.48909 .65585 m .49879 .65449 L .49846 .65484 L p F P
0 0 0 r
s
.03 .041 .078 r
.3471 .37447 m .36401 .3714 L .38265 .36541 L p F P
0 0 0 r
s
.03 .041 .078 r
.39734 .36273 m .38265 .36541 L .36401 .3714 L p F P
0 0 0 r
s
.24 .35 .67 r
.39083 .36547 m
.43199 .35799 L
s
.72 .193 .072 r
.34598 .53697 m .35297 .54874 L .34871 .53005 L p F P
0 0 0 r
s
.72 .193 .072 r
.34871 .53005 m .34147 .51775 L .34598 .53697 L p F P
0 0 0 r
s
.83 .24 .1 r
.34253 .49844 m
.35675 .52303 L
s
.66 .179 .065 r
.65134 .46994 m .64731 .45699 L .65055 .4758 L p F P
0 0 0 r
s
.83 .24 .1 r
.65085 .47356 m
.652 .47723 L
s
.66 .179 .065 r
.65055 .4758 m .65464 .48882 L .65134 .46994 L p F P
0 0 0 r
s
.042 .053 .102 r
.6326 .63255 m .61743 .63468 L .59887 .64079 L p F P
0 0 0 r
s
.042 .053 .102 r
.58617 .64257 m .59887 .64079 L .61743 .63468 L p F P
0 0 0 r
s
.206 .334 .645 r
.48677 .34648 m .50188 .34373 L .50154 .34506 L p F P
0 0 0 r
s
.206 .334 .645 r
.51396 .3428 m .50154 .34506 L .50188 .34373 L p F P
0 0 0 r
s
.365 .111 .056 r
.39769 .61433 m .40251 .62251 L .3897 .61156 L p F P
0 0 0 r
s
.365 .111 .056 r
.3897 .61156 m .38413 .6022 L .39769 .61433 L p F P
0 0 0 r
s
.267 .077 .042 r
.62657 .41202 m .62269 .3998 L .63241 .41378 L p F P
0 0 0 r
s
.267 .077 .042 r
.63241 .41378 m .63649 .42683 L .62657 .41202 L p F P
0 0 0 r
s
.187 .054 .028 r
.64049 .43961 m .63649 .42683 L .64318 .44377 L p F P
0 0 0 r
s
.187 .054 .028 r
.64318 .44377 m .64731 .45699 L .64049 .43961 L p F P
0 0 0 r
s
.83 .24 .1 r
.63276 .4297 m
.64395 .45151 L
s
.64395 .45151 m
.64932 .46867 L
s
.888 .244 .094 r
.33407 .50518 m .34147 .51775 L .34094 .49843 L p F P
0 0 0 r
s
.888 .244 .094 r
.34094 .49843 m .33351 .48561 L .33407 .50518 L p F P
0 0 0 r
s
.181 .298 .578 r
.52331 .65136 m .51086 .6531 L .50852 .65313 L p F P
0 0 0 r
s
.181 .298 .578 r
.49879 .65449 m .50852 .65313 L .51086 .6531 L p F P
0 0 0 r
s
.24 .35 .67 r
.43601 .66225 m
.44434 .66108 L
s
.45 .66029 m
.47768 .65641 L
s
.42714 .6588 m
.43601 .66225 L
s
1 .318 .13 r
.3295 .38419 m .33623 .39672 L .35299 .3858 L p F P
0 0 0 r
s
1 .318 .13 r
.35299 .3858 m .3471 .37447 L .3295 .38419 L p F P
0 0 0 r
s
.24 .35 .67 r
.34169 .377 m
.35012 .37286 L
s
.03 .041 .078 r
.36401 .3714 m .381 .36832 L .39734 .36273 L p F P
0 0 0 r
s
.83 .24 .1 r
.36772 .34956 m
.37587 .36602 L
s
.03 .041 .078 r
.4121 .36005 m .39734 .36273 L .381 .36832 L p F P
0 0 0 r
s
.206 .334 .645 r
.50188 .34373 m .51706 .34097 L .51396 .3428 L p F P
0 0 0 r
s
.206 .334 .645 r
.52642 .34054 m .51396 .3428 L .51706 .34097 L p F P
0 0 0 r
s
.24 .35 .67 r
.51574 .34278 m
.52201 .34578 L
s
.73583 .30707 m
.73885 .31719 L
s
.78227 .30939 m
.73885 .31719 L
s
.78432 .60257 m
.74088 .60871 L
s
.74088 .60871 m
.74001 .61752 L
s
.042 .053 .102 r
.59887 .64079 m .61161 .63901 L .6326 .63255 L p F P
0 0 0 r
s
1 .332 .137 r
.6326 .63255 m .62957 .62452 L .60893 .6323 L p F P
0 0 0 r
s
.24 .35 .67 r
.61183 .63121 m
.61347 .62674 L
s
1 .332 .137 r
.60893 .6323 m .61161 .63901 L .6326 .63255 L p F P
0 0 0 r
s
.24 .35 .67 r
.61016 .63575 m
.61023 .63555 L
s
.83 .24 .1 r
.62535 .6353 m
.63033 .64822 L
s
.62517 .63484 m
.62535 .6353 L
s
.24 .35 .67 r
.56785 .64168 m
.61016 .63575 L
s
.83 .24 .1 r
.5508 .33299 m
.55652 .33507 L
s
.655 .2 .091 r
.56698 .3422 m .56405 .3337 L .57841 .32981 L p F P
0 0 0 r
s
.655 .2 .091 r
.57841 .32981 m .58187 .34023 L .56698 .3422 L p F P
0 0 0 r
s
.24 .35 .67 r
.58021 .33524 m
.60609 .33056 L
s
.83 .24 .1 r
.39301 .33121 m
.4211 .31658 L
s
.4211 .31658 m
.40795 .28698 L
s
.4211 .31658 m
.45098 .30619 L
s
.996 .278 .11 r
.32593 .47251 m .33351 .48561 L .33708 .46675 L p F P
0 0 0 r
s
.996 .278 .11 r
.33708 .46675 m .32969 .45373 L .32593 .47251 L p F P
0 0 0 r
s
.181 .298 .578 r
.5358 .64961 m .52331 .65136 L .51827 .65176 L p F P
0 0 0 r
s
.181 .298 .578 r
.50852 .65313 m .51827 .65176 L .52331 .65136 L p F P
0 0 0 r
s
.504 .158 .074 r
.58865 .36058 m .58529 .35048 L .59902 .35415 L p F P
0 0 0 r
s
.504 .158 .074 r
.59902 .35415 m .6028 .36583 L .58865 .36058 L p F P
0 0 0 r
s
1 .312 .126 r
.32323 .41049 m .33048 .42361 L .34284 .40901 L p F P
0 0 0 r
s
1 .312 .126 r
.34284 .40901 m .33623 .39672 L .32323 .41049 L p F P
0 0 0 r
s
.24 .35 .67 r
.29285 .39532 m
.30071 .38442 L
s
.30071 .38442 m
.34169 .377 L
s
.34373 .67053 m
.30273 .6763 L
s
.30273 .6763 m
.29103 .66653 L
s
1 .3 .12 r
.32215 .44044 m .32969 .45373 L .33759 .43645 L p F P
0 0 0 r
s
.83 .24 .1 r
.33293 .44716 m
.34748 .47305 L
s
1 .3 .12 r
.33759 .43645 m .33048 .42361 L .32215 .44044 L p F P
0 0 0 r
s
.83 .24 .1 r
.33293 .44716 m
.34406 .4221 L
s
.206 .334 .645 r
.51706 .34097 m .5323 .3382 L .52642 .34054 L p F P
0 0 0 r
s
.206 .334 .645 r
.53892 .33827 m .52642 .34054 L .5323 .3382 L p F P
0 0 0 r
s
.03 .041 .078 r
.381 .36832 m .39807 .36522 L .4121 .36005 L p F P
0 0 0 r
s
.24 .35 .67 r
.38314 .36948 m
.3877 .3671 L
s
.03 .041 .078 r
.42691 .35736 m .4121 .36005 L .39807 .36522 L p F P
0 0 0 r
s
.83 .24 .1 r
.39301 .33121 m
.40562 .35804 L
s
.40562 .35804 m
.40622 .35932 L
s
.36772 .34956 m
.39301 .33121 L
s
.39301 .33121 m
.37924 .30189 L
s
.65 .203 .092 r
.44193 .646 m .44482 .65113 L .4296 .65055 L p F P
0 0 0 r
s
.65 .203 .092 r
.4296 .65055 m .42581 .64399 L .44193 .646 L p F P
0 0 0 r
s
.83 .24 .1 r
.45098 .30619 m
.43845 .27632 L
s
.45098 .30619 m
.48157 .30044 L
s
.486 .155 .073 r
.41807 .63062 m .42196 .63735 L .40726 .63057 L p F P
0 0 0 r
s
.486 .155 .073 r
.40726 .63057 m .40251 .62251 L .41807 .63062 L p F P
0 0 0 r
s
.24 .35 .67 r
.60142 .32722 m
.60609 .33056 L
s
.64884 .32282 m
.60609 .33056 L
s
.62642 .63346 m
.62779 .63327 L
s
.61016 .63575 m
.6103 .63573 L
s
.17059 .41731 m
.16258 .43474 L
s
.21088 .41007 m
.17059 .41731 L
s
.181 .298 .578 r
.54833 .64786 m .5358 .64961 L .52805 .6504 L p F P
0 0 0 r
s
.181 .298 .578 r
.51827 .65176 m .52805 .6504 L .5358 .64961 L p F P
0 0 0 r
s
.24 .35 .67 r
.51982 .65051 m
.52601 .64756 L
s
.206 .334 .645 r
.5323 .3382 m .54761 .33541 L .53892 .33827 L p F P
0 0 0 r
s
.206 .334 .645 r
.55146 .33599 m .53892 .33827 L .54761 .33541 L p F P
0 0 0 r
s
.03 .041 .078 r
.39807 .36522 m .41522 .36211 L .42691 .35736 L p F P
0 0 0 r
s
.03 .041 .078 r
.44178 .35465 m .42691 .35736 L .41522 .36211 L p F P
0 0 0 r
s
.24 .35 .67 r
.43199 .35799 m
.47363 .35043 L
s
1 .323 .13 r
.65253 .57991 m .64889 .56923 L .63639 .58541 L p F P
0 0 0 r
s
1 .323 .13 r
.63639 .58541 m .63984 .59506 L .65253 .57991 L p F P
0 0 0 r
s
.83 .24 .1 r
.50719 .67509 m
.47708 .67348 L
s
.181 .298 .578 r
.5609 .6461 m .54833 .64786 L .53786 .64902 L p F P
0 0 0 r
s
.181 .298 .578 r
.52805 .6504 m .53786 .64902 L .54833 .64786 L p F P
0 0 0 r
s
1 .308 .123 r
.65747 .55162 m .65362 .53992 L .64517 .55834 L p F P
0 0 0 r
s
1 .308 .123 r
.64517 .55834 m .64889 .56923 L .65747 .55162 L p F P
0 0 0 r
s
.206 .334 .645 r
.54761 .33541 m .56297 .33262 L .55146 .33599 L p F P
0 0 0 r
s
.206 .334 .645 r
.56405 .3337 m .55146 .33599 L .56297 .33262 L p F P
0 0 0 r
s
.24 .35 .67 r
.55834 .33505 m
.56227 .33732 L
s
.83 .24 .1 r
.55806 .33563 m
.57636 .34228 L
s
1 .33 .135 r
.64324 .60454 m .63984 .59506 L .62338 .6081 L p F P
0 0 0 r
s
.83 .24 .1 r
.64224 .60472 m
.64239 .60514 L
s
1 .33 .135 r
.62338 .6081 m .6265 .61637 L .64324 .60454 L p F P
0 0 0 r
s
.83 .24 .1 r
.36772 .34956 m
.35335 .32053 L
s
.998 .282 .11 r
.65812 .52083 m .65412 .50833 L .6497 .52798 L p F P
0 0 0 r
s
.998 .282 .11 r
.6497 .52798 m .65362 .53992 L .65812 .52083 L p F P
0 0 0 r
s
.03 .041 .078 r
.41522 .36211 m .43245 .35898 L .44178 .35465 L p F P
0 0 0 r
s
.03 .041 .078 r
.45672 .35194 m .44178 .35465 L .43245 .35898 L p F P
0 0 0 r
s
.24 .35 .67 r
.78008 .29906 m
.78227 .30939 L
s
.82825 .59635 m
.78432 .60257 L
s
.78432 .60257 m
.78429 .61131 L
s
.38 .117 .058 r
.60651 .3773 m .6028 .36583 L .61471 .37462 L p F P
0 0 0 r
s
.38 .117 .058 r
.61471 .37462 m .61874 .38733 L .60651 .3773 L p F P
0 0 0 r
s
.181 .298 .578 r
.57351 .64434 m .5609 .6461 L .54769 .64765 L p F P
0 0 0 r
s
.181 .298 .578 r
.53786 .64902 m .54769 .64765 L .5609 .6461 L p F P
0 0 0 r
s
.83 .24 .1 r
.48157 .30044 m
.46965 .27032 L
s
.48157 .30044 m
.51177 .29958 L
s
.245 .071 .038 r
.3727 .58298 m .37846 .59267 L .36741 .57727 L p F P
0 0 0 r
s
.245 .071 .038 r
.36741 .57727 m .36101 .56654 L .3727 .58298 L p F P
0 0 0 r
s
.83 .24 .1 r
.36585 .57104 m
.3797 .59173 L
s
.788 .241 .106 r
.46382 .6514 m .46574 .65491 L .45053 .66124 L p F P
0 0 0 r
s
.788 .241 .106 r
.45053 .66124 m .44769 .65621 L .46382 .6514 L p F P
0 0 0 r
s
.248 .39 .761 r
.46014 .6599 m .45053 .66124 L .46574 .65491 L p F P
0 0 0 r
s
.206 .334 .645 r
.56297 .33262 m .57841 .32981 L .56405 .3337 L p F P
0 0 0 r
s
.561 .145 .055 r
.35448 .5556 m .36101 .56654 L .35297 .54874 L p F P
0 0 0 r
s
.561 .145 .055 r
.35297 .54874 m .34598 .53697 L .35448 .5556 L p F P
0 0 0 r
s
.24 .35 .67 r
.34169 .377 m
.34293 .37677 L
s
.3852 .6647 m
.34373 .67053 L
s
.34373 .67053 m
.33269 .6606 L
s
.365 .111 .056 r
.3928 .60602 m .39769 .61433 L .38413 .6022 L p F P
0 0 0 r
s
.365 .111 .056 r
.38413 .6022 m .37846 .59267 L .3928 .60602 L p F P
0 0 0 r
s
.83 .24 .1 r
.3797 .59173 m
.38248 .59641 L
s
.855 .238 .09 r
.65464 .48882 m .65055 .4758 L .65004 .49556 L p F P
0 0 0 r
s
.83 .24 .1 r
.64902 .47604 m
.65043 .48053 L
s
.65355 .49042 m
.65452 .49349 L
s
.855 .238 .09 r
.65004 .49556 m .65412 .50833 L .65464 .48882 L p F P
0 0 0 r
s
.181 .298 .578 r
.58617 .64257 m .57351 .64434 L .55754 .64627 L p F P
0 0 0 r
s
.181 .298 .578 r
.54769 .64765 m .55754 .64627 L .57351 .64434 L p F P
0 0 0 r
s
.24 .35 .67 r
.24984 .67239 m
.20911 .67818 L
s
.19613 .6622 m
.20911 .67818 L
s
.03 .041 .078 r
.43245 .35898 m .44976 .35584 L .45672 .35194 L p F P
0 0 0 r
s
.03 .041 .078 r
.47171 .34921 m .45672 .35194 L .44976 .35584 L p F P
0 0 0 r
s
1 .332 .137 r
.62957 .62452 m .6265 .61637 L .60622 .62551 L p F P
0 0 0 r
s
1 .332 .137 r
.60622 .62551 m .60893 .6323 L .62957 .62452 L p F P
0 0 0 r
s
.24 .35 .67 r
.62779 .63327 m
.65295 .62974 L
s
.64501 .31931 m
.64884 .32282 L
s
.69209 .31499 m
.64884 .32282 L
s
.248 .39 .761 r
.46976 .65855 m .46014 .6599 L .4724 .65397 L p F P
0 0 0 r
s
.248 .39 .761 r
.46574 .65491 m .4724 .65397 L .46014 .6599 L p F P
0 0 0 r
s
.83 .24 .1 r
.46721 .65537 m
.46891 .65848 L
s
.65 .203 .092 r
.439 .64081 m .44193 .646 L .42581 .64399 L p F P
0 0 0 r
s
.65 .203 .092 r
.42581 .64399 m .42196 .63735 L .439 .64081 L p F P
0 0 0 r
s
.83 .24 .1 r
.42127 .63616 m
.42464 .63789 L
s
.06 .072 .138 r
.36401 .3714 m .3471 .37447 L .3295 .38419 L p F P
0 0 0 r
s
.24 .35 .67 r
.34121 .37772 m
.34169 .377 L
s
.83 .24 .1 r
.34797 .37444 m
.34804 .37458 L
s
.34923 .37688 m
.3605 .39856 L
s
.24 .35 .67 r
.69623 .62367 m
.65295 .62974 L
s
.65295 .62974 m
.6492 .63239 L
s
.2035 .42747 m
.21088 .41007 L
s
.25163 .40273 m
.21088 .41007 L
s
.72 .193 .072 r
.33885 .52497 m .34598 .53697 L .34147 .51775 L p F P
0 0 0 r
s
.83 .24 .1 r
.3438 .5234 m
.35816 .54777 L
s
.34253 .49844 m
.3438 .5234 L
s
.72 .193 .072 r
.34147 .51775 m .33407 .50518 L .33885 .52497 L p F P
0 0 0 r
s
.267 .077 .042 r
.62269 .3998 m .61874 .38733 L .62824 .40046 L p F P
0 0 0 r
s
.267 .077 .042 r
.62824 .40046 m .63241 .41378 L .62269 .3998 L p F P
0 0 0 r
s
.83 .24 .1 r
.60736 .38445 m
.62423 .40276 L
s
.66 .179 .065 r
.64731 .45699 m .64318 .44377 L .64638 .46248 L p F P
0 0 0 r
s
.66 .179 .065 r
.64638 .46248 m .65055 .4758 L .64731 .45699 L p F P
0 0 0 r
s
.83 .24 .1 r
.64395 .45151 m
.64902 .47604 L
s
.504 .158 .074 r
.58529 .35048 m .58187 .34023 L .59517 .34226 L p F P
0 0 0 r
s
.504 .158 .074 r
.59517 .34226 m .59902 .35415 L .58529 .35048 L p F P
0 0 0 r
s
.83 .24 .1 r
.57636 .34228 m
.58585 .3704 L
s
.187 .054 .028 r
.63649 .42683 m .63241 .41378 L .63897 .43026 L p F P
0 0 0 r
s
.83 .24 .1 r
.62423 .40276 m
.63276 .4297 L
s
.187 .054 .028 r
.63897 .43026 m .64318 .44377 L .63649 .42683 L p F P
0 0 0 r
s
.248 .39 .761 r
.47941 .6572 m .46976 .65855 L .47907 .65303 L p F P
0 0 0 r
s
.248 .39 .761 r
.4724 .65397 m .47907 .65303 L .46976 .65855 L p F P
0 0 0 r
s
.83 .24 .1 r
.46891 .65848 m
.47708 .67348 L
s
.181 .298 .578 r
.59887 .64079 m .58617 .64257 L .56743 .64489 L p F P
0 0 0 r
s
.181 .298 .578 r
.55754 .64627 m .56743 .64489 L .58617 .64257 L p F P
0 0 0 r
s
.486 .155 .073 r
.41412 .6238 m .41807 .63062 L .40251 .62251 L p F P
0 0 0 r
s
.486 .155 .073 r
.40251 .62251 m .39769 .61433 L .41412 .6238 L p F P
0 0 0 r
s
.03 .041 .078 r
.44976 .35584 m .46715 .35268 L .47171 .34921 L p F P
0 0 0 r
s
.03 .041 .078 r
.48677 .34648 m .47171 .34921 L .46715 .35268 L p F P
0 0 0 r
s
.24 .35 .67 r
.47514 .35016 m
.51574 .34278 L
s
.888 .244 .094 r
.32652 .49234 m .33407 .50518 L .33351 .48561 L p F P
0 0 0 r
s
.888 .244 .094 r
.33351 .48561 m .32593 .47251 L .32652 .49234 L p F P
0 0 0 r
s
.06 .072 .138 r
.3295 .38419 m .34832 .38079 L .36401 .3714 L p F P
0 0 0 r
s
.83 .24 .1 r
.34619 .37101 m
.34797 .37444 L
s
.06 .072 .138 r
.381 .36832 m .36401 .3714 L .34832 .38079 L p F P
0 0 0 r
s
.24 .35 .67 r
.37324 .37128 m
.38314 .36948 L
s
.83 .24 .1 r
.34619 .37101 m
.36772 .34956 L
s
.248 .39 .761 r
.48909 .65585 m .47941 .6572 L .48576 .65209 L p F P
0 0 0 r
s
.24 .35 .67 r
.47933 .65618 m
.48096 .65595 L
s
.48827 .65493 m
.51982 .65051 L
s
.248 .39 .761 r
.47907 .65303 m .48576 .65209 L .47941 .6572 L p F P
0 0 0 r
s
.83 .24 .1 r
.53828 .67083 m
.50719 .67509 L
s
.57262 .33123 m
.57636 .34228 L
s
.57636 .34228 m
.59821 .35629 L
s
1 .312 .126 r
.31582 .39711 m .32323 .41049 L .33623 .39672 L p F P
0 0 0 r
s
1 .312 .126 r
.33623 .39672 m .3295 .38419 L .31582 .39711 L p F P
0 0 0 r
s
.181 .298 .578 r
.61161 .63901 m .59887 .64079 L .57733 .6435 L p F P
0 0 0 r
s
.181 .298 .578 r
.56743 .64489 m .57733 .6435 L .59887 .64079 L p F P
0 0 0 r
s
.24 .35 .67 r
.56245 .64454 m
.56785 .64168 L
s
.996 .278 .11 r
.31817 .45913 m .32593 .47251 L .32969 .45373 L p F P
0 0 0 r
s
.996 .278 .11 r
.32969 .45373 m .32215 .44044 L .31817 .45913 L p F P
0 0 0 r
s
.83 .24 .1 r
.32771 .47279 m
.33293 .44716 L
s
.788 .241 .106 r
.4619 .64788 m .46382 .6514 L .44769 .65621 L p F P
0 0 0 r
s
.788 .241 .106 r
.44769 .65621 m .44482 .65113 L .4619 .64788 L p F P
0 0 0 r
s
.24 .35 .67 r
.82825 .59635 m
.8291 .60502 L
s
.83 .24 .1 r
.34068 .37876 m
.34619 .37101 L
s
.32927 .39482 m
.3379 .38267 L
s
.34619 .37101 m
.33125 .34227 L
s
1 .3 .12 r
.31444 .42686 m .32215 .44044 L .33048 .42361 L p F P
0 0 0 r
s
1 .3 .12 r
.33048 .42361 m .32323 .41049 L .31444 .42686 L p F P
0 0 0 r
s
.83 .24 .1 r
.32927 .39482 m
.34406 .4221 L
s
.03 .041 .078 r
.46715 .35268 m .48463 .34951 L .48677 .34648 L p F P
0 0 0 r
s
.24 .35 .67 r
.46749 .35419 m
.47113 .35196 L
s
.03 .041 .078 r
.50188 .34373 m .48677 .34648 L .48463 .34951 L p F P
0 0 0 r
s
.248 .39 .761 r
.49879 .65449 m .48909 .65585 L .49246 .65115 L p F P
0 0 0 r
s
.248 .39 .761 r
.48576 .65209 m .49246 .65115 L .48909 .65585 L p F P
0 0 0 r
s
.24 .35 .67 r
.42714 .6588 m
.3852 .6647 L
s
.3852 .6647 m
.37485 .6546 L
s
.06 .072 .138 r
.34832 .38079 m .36723 .37738 L .381 .36832 L p F P
0 0 0 r
s
.06 .072 .138 r
.39807 .36522 m .381 .36832 L .36723 .37738 L p F P
0 0 0 r
s
.181 .298 .578 r
.57733 .6435 m .58727 .64211 L .61161 .63901 L p F P
0 0 0 r
s
1 .329 .137 r
.61161 .63901 m .60893 .6323 L .58506 .63689 L p F P
0 0 0 r
s
1 .329 .137 r
.58506 .63689 m .58727 .64211 L .61161 .63901 L p F P
0 0 0 r
s
.24 .35 .67 r
.60557 .6385 m
.6067 .63782 L
s
.6067 .63782 m
.6069 .6377 L
s
.83 .24 .1 r
.60309 .64086 m
.60417 .64 L
s
.59708 .64564 m
.60309 .64086 L
s
.51177 .29958 m
.50042 .26924 L
s
.51177 .29958 m
.54044 .30375 L
s
.248 .39 .761 r
.50852 .65313 m .49879 .65449 L .49916 .65021 L p F P
0 0 0 r
s
.248 .39 .761 r
.49246 .65115 m .49916 .65021 L .49879 .65449 L p F P
0 0 0 r
s
.83 .24 .1 r
.49653 .65445 m
.50719 .67509 L
s
.49577 .65298 m
.49653 .65445 L
s
.24 .35 .67 r
.29103 .66653 m
.24984 .67239 L
s
.24984 .67239 m
.23742 .65622 L
s
.6891 .3113 m
.69209 .31499 L
s
.73583 .30707 m
.69209 .31499 L
s
1 .323 .13 r
.64889 .56923 m .64517 .55834 L .63288 .57559 L p F P
0 0 0 r
s
1 .323 .13 r
.63288 .57559 m .63639 .58541 L .64889 .56923 L p F P
0 0 0 r
s
1 .33 .135 r
.63984 .59506 m .63639 .58541 L .62021 .5997 L p F P
0 0 0 r
s
.83 .24 .1 r
.63885 .59529 m
.63901 .59572 L
s
1 .33 .135 r
.62021 .5997 m .62338 .6081 L .63984 .59506 L p F P
0 0 0 r
s
.24 .35 .67 r
.74001 .61752 m
.69623 .62367 L
s
.69623 .62367 m
.69333 .62621 L
s
.03 .041 .078 r
.48463 .34951 m .50219 .34632 L .50188 .34373 L p F P
0 0 0 r
s
.03 .041 .078 r
.51706 .34097 m .50188 .34373 L .50219 .34632 L p F P
0 0 0 r
s
.24 .35 .67 r
.24488 .42011 m
.25163 .40273 L
s
.29285 .39532 m
.25163 .40273 L
s
.65 .203 .092 r
.43605 .63558 m .439 .64081 L .42196 .63735 L p F P
0 0 0 r
s
.65 .203 .092 r
.42196 .63735 m .41807 .63062 L .43605 .63558 L p F P
0 0 0 r
s
.248 .39 .761 r
.51827 .65176 m .50852 .65313 L .50589 .64927 L p F P
0 0 0 r
s
.248 .39 .761 r
.49916 .65021 m .50589 .64927 L .50852 .65313 L p F P
0 0 0 r
s
.38 .117 .058 r
.6028 .36583 m .59902 .35415 L .61061 .36166 L p F P
0 0 0 r
s
.38 .117 .058 r
.61061 .36166 m .61471 .37462 L .6028 .36583 L p F P
0 0 0 r
s
.83 .24 .1 r
.59821 .35629 m
.60736 .38445 L
s
1 .308 .123 r
.65362 .53992 m .6497 .52798 L .64138 .54724 L p F P
0 0 0 r
s
1 .308 .123 r
.64138 .54724 m .64517 .55834 L .65362 .53992 L p F P
0 0 0 r
s
.83 .24 .1 r
.56877 .66085 m
.53828 .67083 L
s
.06 .072 .138 r
.36723 .37738 m .38625 .37395 L .39807 .36522 L p F P
0 0 0 r
s
.06 .072 .138 r
.41522 .36211 m .39807 .36522 L .38625 .37395 L p F P
0 0 0 r
s
.83 .24 .1 r
.59521 .64112 m
.59708 .64564 L
s
.56877 .66085 m
.59708 .64564 L
s
1 .332 .137 r
.6265 .61637 m .62338 .6081 L .60347 .61863 L p F P
0 0 0 r
s
1 .332 .137 r
.60347 .61863 m .60622 .62551 L .6265 .61637 L p F P
0 0 0 r
s
.248 .39 .761 r
.52805 .6504 m .51827 .65176 L .51262 .64832 L p F P
0 0 0 r
s
.24 .35 .67 r
.52427 .64989 m
.56245 .64454 L
s
.248 .39 .761 r
.50589 .64927 m .51262 .64832 L .51827 .65176 L p F P
0 0 0 r
s
.03 .041 .078 r
.50219 .34632 m .51983 .34312 L .51706 .34097 L p F P
0 0 0 r
s
.03 .041 .078 r
.5323 .3382 m .51706 .34097 L .51983 .34312 L p F P
0 0 0 r
s
.24 .35 .67 r
.52491 .34112 m
.55834 .33505 L
s
.365 .111 .056 r
.38783 .59759 m .3928 .60602 L .37846 .59267 L p F P
0 0 0 r
s
.365 .111 .056 r
.37846 .59267 m .3727 .58298 L .38783 .59759 L p F P
0 0 0 r
s
.245 .071 .038 r
.36683 .57312 m .3727 .58298 L .36101 .56654 L p F P
0 0 0 r
s
.245 .071 .038 r
.36101 .56654 m .35448 .5556 L .36683 .57312 L p F P
0 0 0 r
s
.24 .35 .67 r
.55834 .33505 m
.57471 .33207 L
s
.998 .282 .11 r
.65412 .50833 m .65004 .49556 L .64569 .51578 L p F P
0 0 0 r
s
.998 .282 .11 r
.64569 .51578 m .6497 .52798 L .65412 .50833 L p F P
0 0 0 r
s
.788 .241 .106 r
.45996 .64433 m .4619 .64788 L .44482 .65113 L p F P
0 0 0 r
s
.788 .241 .106 r
.44482 .65113 m .44193 .646 L .45996 .64433 L p F P
0 0 0 r
s
.24 .35 .67 r
.59687 .63972 m
.60557 .6385 L
s
.56245 .64454 m
.58685 .64112 L
s
.504 .158 .074 r
.58187 .34023 m .57841 .32981 L .59125 .33016 L p F P
0 0 0 r
s
.24 .35 .67 r
.58601 .33002 m
.60142 .32722 L
s
.504 .158 .074 r
.59125 .33016 m .59517 .34226 L .58187 .34023 L p F P
0 0 0 r
s
.83 .24 .1 r
.44161 .64544 m
.44329 .64587 L
s
.248 .39 .761 r
.53786 .64902 m .52805 .6504 L .51937 .64737 L p F P
0 0 0 r
s
.83 .24 .1 r
.52821 .65002 m
.53828 .67083 L
s
.248 .39 .761 r
.51262 .64832 m .51937 .64737 L .52805 .6504 L p F P
0 0 0 r
s
.561 .145 .055 r
.34782 .54445 m .35448 .5556 L .34598 .53697 L p F P
0 0 0 r
s
.83 .24 .1 r
.35147 .54685 m
.36585 .57104 L
s
.561 .145 .055 r
.34598 .53697 m .33885 .52497 L .34782 .54445 L p F P
0 0 0 r
s
.83 .24 .1 r
.3438 .5234 m
.35147 .54685 L
s
.486 .155 .073 r
.41013 .6169 m .41412 .6238 L .39769 .61433 L p F P
0 0 0 r
s
.486 .155 .073 r
.39769 .61433 m .3928 .60602 L .41013 .6169 L p F P
0 0 0 r
s
.06 .072 .138 r
.38625 .37395 m .40536 .3705 L .41522 .36211 L p F P
0 0 0 r
s
.06 .072 .138 r
.43245 .35898 m .41522 .36211 L .40536 .3705 L p F P
0 0 0 r
s
.03 .041 .078 r
.51983 .34312 m .53756 .33991 L .5323 .3382 L p F P
0 0 0 r
s
.03 .041 .078 r
.54761 .33541 m .5323 .3382 L .53756 .33991 L p F P
0 0 0 r
s
.855 .238 .09 r
.65055 .4758 m .64638 .46248 L .64588 .48251 L p F P
0 0 0 r
s
.855 .238 .09 r
.64588 .48251 m .65004 .49556 L .65055 .4758 L p F P
0 0 0 r
s
.267 .077 .042 r
.61874 .38733 m .61471 .37462 L .62399 .38686 L p F P
0 0 0 r
s
.267 .077 .042 r
.62399 .38686 m .62824 .40046 L .61874 .38733 L p F P
0 0 0 r
s
.83 .24 .1 r
.64481 .55885 m
.64514 .55826 L
s
.248 .39 .761 r
.54769 .64765 m .53786 .64902 L .52613 .64642 L p F P
0 0 0 r
s
.248 .39 .761 r
.51937 .64737 m .52613 .64642 L .53786 .64902 L p F P
0 0 0 r
s
.83 .24 .1 r
.52749 .64853 m
.52821 .65002 L
s
.24 .35 .67 r
.42714 .6588 m
.46217 .65387 L
s
.41749 .64853 m
.42714 .6588 L
s
.16258 .43474 m
.15699 .45788 L
s
.2035 .42747 m
.16258 .43474 L
s
.72 .193 .072 r
.33156 .51271 m .33885 .52497 L .33407 .50518 L p F P
0 0 0 r
s
.72 .193 .072 r
.33407 .50518 m .32652 .49234 L .33156 .51271 L p F P
0 0 0 r
s
.83 .24 .1 r
.32771 .47279 m
.34253 .49844 L
s
1 .329 .137 r
.60893 .6323 m .60622 .62551 L .58282 .63161 L p F P
0 0 0 r
s
1 .329 .137 r
.58282 .63161 m .58506 .63689 L .60893 .6323 L p F P
0 0 0 r
s
.24 .35 .67 r
.33269 .6606 m
.29103 .66653 L
s
.29103 .66653 m
.2792 .65017 L
s
.73371 .3032 m
.73583 .30707 L
s
.78008 .29906 m
.73583 .30707 L
s
.66 .179 .065 r
.64318 .44377 m .63897 .43026 L .64211 .44888 L p F P
0 0 0 r
s
.83 .24 .1 r
.64252 .44693 m
.64395 .45151 L
s
.66 .179 .065 r
.64211 .44888 m .64638 .46248 L .64318 .44377 L p F P
0 0 0 r
s
.187 .054 .028 r
.63241 .41378 m .62824 .40046 L .63467 .41646 L p F P
0 0 0 r
s
.187 .054 .028 r
.63467 .41646 m .63897 .43026 L .63241 .41378 L p F P
0 0 0 r
s
.83 .24 .1 r
.62423 .40276 m
.63556 .42469 L
s
.63556 .42469 m
.64092 .44182 L
s
.24 .35 .67 r
.78429 .61131 m
.74001 .61752 L
s
.74001 .61752 m
.73798 .61995 L
s
.28676 .41267 m
.29285 .39532 L
s
.248 .39 .761 r
.55754 .64627 m .54769 .64765 L .5329 .64547 L p F P
0 0 0 r
s
.248 .39 .761 r
.52613 .64642 m .5329 .64547 L .54769 .64765 L p F P
0 0 0 r
s
.06 .072 .138 r
.40536 .3705 m .42457 .36703 L .43245 .35898 L p F P
0 0 0 r
s
.06 .072 .138 r
.44976 .35584 m .43245 .35898 L .42457 .36703 L p F P
0 0 0 r
s
.03 .041 .078 r
.53756 .33991 m .55537 .33667 L .54761 .33541 L p F P
0 0 0 r
s
.03 .041 .078 r
.56297 .33262 m .54761 .33541 L .55537 .33667 L p F P
0 0 0 r
s
.83 .24 .1 r
.54044 .30375 m
.55033 .33167 L
s
.55033 .33167 m
.5508 .33299 L
s
.088 .103 .207 r
.34832 .38079 m .3295 .38419 L .31582 .39711 L p F P
0 0 0 r
s
.83 .24 .1 r
.32737 .39131 m
.32927 .39482 L
s
.65 .203 .092 r
.43306 .63029 m .43605 .63558 L .41807 .63062 L p F P
0 0 0 r
s
.65 .203 .092 r
.41807 .63062 m .41412 .6238 L .43306 .63029 L p F P
0 0 0 r
s
.888 .244 .094 r
.3188 .47922 m .32652 .49234 L .32593 .47251 L p F P
0 0 0 r
s
.888 .244 .094 r
.32593 .47251 m .31817 .45913 L .3188 .47922 L p F P
0 0 0 r
s
.248 .39 .761 r
.56743 .64489 m .55754 .64627 L .53968 .64452 L p F P
0 0 0 r
s
.83 .24 .1 r
.56186 .64547 m
.56877 .66085 L
s
.248 .39 .761 r
.5329 .64547 m .53968 .64452 L .55754 .64627 L p F P
0 0 0 r
s
.788 .241 .106 r
.45801 .64076 m .45996 .64433 L .44193 .646 L p F P
0 0 0 r
s
.788 .241 .106 r
.44193 .646 m .439 .64081 L .45801 .64076 L p F P
0 0 0 r
s
.83 .24 .1 r
.54044 .30375 m
.52962 .27323 L
s
.54044 .30375 m
.56644 .31292 L
s
.37924 .30189 m
.40795 .28698 L
s
.40795 .28698 m
.39421 .25608 L
s
.40795 .28698 m
.43845 .27632 L
s
.24 .35 .67 r
.64501 .31931 m
.60142 .32722 L
s
.996 .278 .11 r
.31025 .44545 m .31817 .45913 L .32215 .44044 L p F P
0 0 0 r
s
.996 .278 .11 r
.32215 .44044 m .31444 .42686 L .31025 .44545 L p F P
0 0 0 r
s
1 .3 .12 r
.30656 .41298 m .31444 .42686 L .32323 .41049 L p F P
0 0 0 r
s
.83 .24 .1 r
.31775 .42014 m
.33293 .44716 L
s
1 .3 .12 r
.32323 .41049 m .31582 .39711 L .30656 .41298 L p F P
0 0 0 r
s
.03 .041 .078 r
.55537 .33667 m .57327 .33343 L .56297 .33262 L p F P
0 0 0 r
s
.03 .041 .078 r
.57841 .32981 m .56297 .33262 L .57327 .33343 L p F P
0 0 0 r
s
.83 .24 .1 r
.56644 .31292 m
.57231 .33029 L
s
.57231 .33029 m
.57251 .33089 L
s
.06 .072 .138 r
.42457 .36703 m .44389 .36354 L .44976 .35584 L p F P
0 0 0 r
s
.06 .072 .138 r
.46715 .35268 m .44976 .35584 L .44389 .36354 L p F P
0 0 0 r
s
.24 .35 .67 r
.46164 .35526 m
.46749 .35419 L
s
.60557 .6385 m
.6492 .63239 L
s
.59985 .63449 m
.60557 .6385 L
s
.248 .39 .761 r
.57733 .6435 m .56743 .64489 L .54647 .64356 L p F P
0 0 0 r
s
.248 .39 .761 r
.53968 .64452 m .54647 .64356 L .56743 .64489 L p F P
0 0 0 r
s
1 .33 .135 r
.63639 .58541 m .63288 .57559 L .61699 .59116 L p F P
0 0 0 r
s
.83 .24 .1 r
.63541 .5857 m
.63557 .58614 L
s
1 .33 .135 r
.61699 .59116 m .62021 .5997 L .63639 .58541 L p F P
0 0 0 r
s
.83 .24 .1 r
.35335 .32053 m
.37924 .30189 L
s
.37924 .30189 m
.36486 .27128 L
s
.088 .103 .207 r
.31582 .39711 m .33611 .39347 L .34832 .38079 L p F P
0 0 0 r
s
.83 .24 .1 r
.31775 .42014 m
.32927 .39482 L
s
.24 .35 .67 r
.29285 .39532 m
.32357 .38979 L
s
.83 .24 .1 r
.31384 .36635 m
.32586 .38852 L
s
.088 .103 .207 r
.36723 .37738 m .34832 .38079 L .33611 .39347 L p F P
0 0 0 r
s
1 .332 .137 r
.62338 .6081 m .62021 .5997 L .60068 .61166 L p F P
0 0 0 r
s
1 .332 .137 r
.60068 .61166 m .60347 .61863 L .62338 .6081 L p F P
0 0 0 r
s
1 .323 .13 r
.64517 .55834 m .64138 .54724 L .6293 .56559 L p F P
0 0 0 r
s
1 .323 .13 r
.6293 .56559 m .63288 .57559 L .64517 .55834 L p F P
0 0 0 r
s
.24 .35 .67 r
.23742 .65622 m
.19613 .6622 L
s
.18384 .64023 m
.19613 .6622 L
s
.38 .117 .058 r
.59902 .35415 m .59517 .34226 L .60642 .34845 L p F P
0 0 0 r
s
.38 .117 .058 r
.60642 .34845 m .61061 .36166 L .59902 .35415 L p F P
0 0 0 r
s
.83 .24 .1 r
.43845 .27632 m
.42536 .24514 L
s
.43845 .27632 m
.46965 .27032 L
s
.248 .39 .761 r
.58727 .64211 m .57733 .6435 L .55328 .64261 L p F P
0 0 0 r
s
.248 .39 .761 r
.54647 .64356 m .55328 .64261 L .57733 .6435 L p F P
0 0 0 r
s
.89 .268 .117 r
.4814 .64255 m .48236 .64436 L .46574 .65491 L p F P
0 0 0 r
s
.83 .24 .1 r
.46664 .65433 m
.46687 .65475 L
s
.89 .268 .117 r
.46574 .65491 m .46382 .6514 L .4814 .64255 L p F P
0 0 0 r
s
.83 .24 .1 r
.46367 .65112 m
.46414 .65124 L
s
.28 .43 .842 r
.4724 .65397 m .46574 .65491 L .48236 .64436 L p F P
0 0 0 r
s
.03 .041 .078 r
.57327 .33343 m .59125 .33016 L .57841 .32981 L p F P
0 0 0 r
s
.06 .072 .138 r
.44389 .36354 m .4633 .36003 L .46715 .35268 L p F P
0 0 0 r
s
.06 .072 .138 r
.48463 .34951 m .46715 .35268 L .4633 .36003 L p F P
0 0 0 r
s
.24 .35 .67 r
.19844 .45065 m
.2035 .42747 L
s
.24488 .42011 m
.2035 .42747 L
s
.365 .111 .056 r
.38278 .58902 m .38783 .59759 L .3727 .58298 L p F P
0 0 0 r
s
.365 .111 .056 r
.3727 .58298 m .36683 .57312 L .38278 .58902 L p F P
0 0 0 r
s
.24 .35 .67 r
.37485 .6546 m
.33269 .6606 L
s
.33269 .6606 m
.32147 .64405 L
s
.28 .43 .842 r
.47907 .65303 m .4724 .65397 L .48579 .64388 L p F P
0 0 0 r
s
.28 .43 .842 r
.48236 .64436 m .48579 .64388 L .4724 .65397 L p F P
0 0 0 r
s
1 .308 .123 r
.6497 .52798 m .64569 .51578 L .63752 .53592 L p F P
0 0 0 r
s
1 .308 .123 r
.63752 .53592 m .64138 .54724 L .6497 .52798 L p F P
0 0 0 r
s
.248 .39 .761 r
.55328 .64261 m .5601 .64165 L .58727 .64211 L p F P
0 0 0 r
s
.83 .24 .1 r
.56043 .64229 m
.56186 .64547 L
s
1 .324 .136 r
.58727 .64211 m .58506 .63689 L .55849 .63806 L p F P
0 0 0 r
s
1 .324 .136 r
.55849 .63806 m .5601 .64165 L .58727 .64211 L p F P
0 0 0 r
s
.486 .155 .073 r
.40608 .60991 m .41013 .6169 L .3928 .60602 L p F P
0 0 0 r
s
.486 .155 .073 r
.3928 .60602 m .38783 .59759 L .40608 .60991 L p F P
0 0 0 r
s
.24 .35 .67 r
.77885 .295 m
.78008 .29906 L
s
.8291 .60502 m
.78429 .61131 L
s
.78429 .61131 m
.78316 .61362 L
s
1 .329 .137 r
.60622 .62551 m .60347 .61863 L .58056 .62629 L p F P
0 0 0 r
s
1 .329 .137 r
.58056 .62629 m .58282 .63161 L .60622 .62551 L p F P
0 0 0 r
s
.088 .103 .207 r
.33611 .39347 m .35652 .38982 L .36723 .37738 L p F P
0 0 0 r
s
.088 .103 .207 r
.38625 .37395 m .36723 .37738 L .35652 .38982 L p F P
0 0 0 r
s
.245 .071 .038 r
.36085 .56308 m .36683 .57312 L .35448 .5556 L p F P
0 0 0 r
s
.245 .071 .038 r
.35448 .5556 m .34782 .54445 L .36085 .56308 L p F P
0 0 0 r
s
.28 .43 .842 r
.48576 .65209 m .47907 .65303 L .48923 .64339 L p F P
0 0 0 r
s
.24 .35 .67 r
.48034 .65131 m
.48098 .65122 L
s
.28 .43 .842 r
.48579 .64388 m .48923 .64339 L .47907 .65303 L p F P
0 0 0 r
s
.83 .24 .1 r
.47955 .65219 m
.49577 .65298 L
s
.4763 .65203 m
.47955 .65219 L
s
.788 .241 .106 r
.45604 .63716 m .45801 .64076 L .439 .64081 L p F P
0 0 0 r
s
.788 .241 .106 r
.439 .64081 m .43605 .63558 L .45604 .63716 L p F P
0 0 0 r
s
.28 .43 .842 r
.49246 .65115 m .48576 .65209 L .49268 .6429 L p F P
0 0 0 r
s
.24 .35 .67 r
.48641 .65046 m
.48706 .65037 L
s
.28 .43 .842 r
.48923 .64339 m .49268 .6429 L .48576 .65209 L p F P
0 0 0 r
s
.83 .24 .1 r
.33125 .34227 m
.35335 .32053 L
s
.35335 .32053 m
.33834 .29022 L
s
.06 .072 .138 r
.4633 .36003 m .48282 .35651 L .48463 .34951 L p F P
0 0 0 r
s
.06 .072 .138 r
.50219 .34632 m .48463 .34951 L .48282 .35651 L p F P
0 0 0 r
s
.998 .282 .11 r
.65004 .49556 m .64588 .48251 L .6416 .50333 L p F P
0 0 0 r
s
.998 .282 .11 r
.6416 .50333 m .64569 .51578 L .65004 .49556 L p F P
0 0 0 r
s
.65 .203 .092 r
.43005 .62495 m .43306 .63029 L .41412 .6238 L p F P
0 0 0 r
s
.65 .203 .092 r
.41412 .6238 m .41013 .6169 L .43005 .62495 L p F P
0 0 0 r
s
.89 .268 .117 r
.48044 .64072 m .4814 .64255 L .46382 .6514 L p F P
0 0 0 r
s
.89 .268 .117 r
.46382 .6514 m .4619 .64788 L .48044 .64072 L p F P
0 0 0 r
s
.24 .35 .67 r
.46539 .64794 m
.46633 .64904 L
s
.561 .145 .055 r
.34104 .53307 m .34782 .54445 L .33885 .52497 L p F P
0 0 0 r
s
.561 .145 .055 r
.33885 .52497 m .33156 .51271 L .34104 .53307 L p F P
0 0 0 r
s
.28 .43 .842 r
.49916 .65021 m .49246 .65115 L .49612 .64242 L p F P
0 0 0 r
s
.24 .35 .67 r
.4925 .6496 m
.49314 .64951 L
s
.28 .43 .842 r
.49268 .6429 m .49612 .64242 L .49246 .65115 L p F P
0 0 0 r
s
.24 .35 .67 r
.64217 .32253 m
.64501 .31931 L
s
.6891 .3113 m
.64501 .31931 L
s
.83 .24 .1 r
.46965 .27032 m
.4572 .23886 L
s
.46965 .27032 m
.50042 .26924 L
s
.267 .077 .042 r
.61471 .37462 m .61061 .36166 L .61965 .37298 L p F P
0 0 0 r
s
.267 .077 .042 r
.61965 .37298 m .62399 .38686 L .61471 .37462 L p F P
0 0 0 r
s
.83 .24 .1 r
.59821 .35629 m
.61533 .37464 L
s
.24 .35 .67 r
.69333 .62621 m
.6492 .63239 L
s
.6492 .63239 m
.64431 .62824 L
s
.088 .103 .207 r
.35652 .38982 m .37704 .38614 L .38625 .37395 L p F P
0 0 0 r
s
.088 .103 .207 r
.40536 .3705 m .38625 .37395 L .37704 .38614 L p F P
0 0 0 r
s
.28 .43 .842 r
.50589 .64927 m .49916 .65021 L .49957 .64193 L p F P
0 0 0 r
s
.24 .35 .67 r
.49859 .64874 m
.49924 .64865 L
s
.28 .43 .842 r
.49612 .64242 m .49957 .64193 L .49916 .65021 L p F P
0 0 0 r
s
.855 .238 .09 r
.64638 .46248 m .64211 .44888 L .64162 .46917 L p F P
0 0 0 r
s
.83 .24 .1 r
.64063 .44941 m
.64199 .45374 L
s
.64525 .46407 m
.64626 .46728 L
s
.855 .238 .09 r
.64162 .46917 m .64588 .48251 L .64638 .46248 L p F P
0 0 0 r
s
.24 .35 .67 r
.2792 .65017 m
.23742 .65622 L
s
.23742 .65622 m
.22561 .63404 L
s
.06 .072 .138 r
.48282 .35651 m .50245 .35297 L .50219 .34632 L p F P
0 0 0 r
s
.06 .072 .138 r
.51983 .34312 m .50219 .34632 L .50245 .35297 L p F P
0 0 0 r
s
.28 .43 .842 r
.51262 .64832 m .50589 .64927 L .50302 .64144 L p F P
0 0 0 r
s
.24 .35 .67 r
.5047 .64788 m
.50535 .64779 L
s
.51081 .64702 m
.51249 .64679 L
s
.51249 .64679 m
.51488 .648 L
s
.28 .43 .842 r
.49957 .64193 m .50302 .64144 L .50589 .64927 L p F P
0 0 0 r
s
.72 .193 .072 r
.32412 .50019 m .33156 .51271 L .32652 .49234 L p F P
0 0 0 r
s
.83 .24 .1 r
.32882 .49797 m
.3438 .5234 L
s
.32771 .47279 m
.32882 .49797 L
s
.72 .193 .072 r
.32652 .49234 m .3188 .47922 L .32412 .50019 L p F P
0 0 0 r
s
.187 .054 .028 r
.62824 .40046 m .62399 .38686 L .63028 .40235 L p F P
0 0 0 r
s
.83 .24 .1 r
.61533 .37464 m
.62423 .40276 L
s
.187 .054 .028 r
.63028 .40235 m .63467 .41646 L .62824 .40046 L p F P
0 0 0 r
s
1 .324 .136 r
.58506 .63689 m .58282 .63161 L .55686 .63444 L p F P
0 0 0 r
s
1 .324 .136 r
.55686 .63444 m .55849 .63806 L .58506 .63689 L p F P
0 0 0 r
s
.66 .179 .065 r
.63897 .43026 m .63467 .41646 L .63774 .43497 L p F P
0 0 0 r
s
.66 .179 .065 r
.63774 .43497 m .64211 .44888 L .63897 .43026 L p F P
0 0 0 r
s
.83 .24 .1 r
.63556 .42469 m
.64063 .44941 L
s
.28 .43 .842 r
.51937 .64737 m .51262 .64832 L .50648 .64095 L p F P
0 0 0 r
s
.28 .43 .842 r
.50302 .64144 m .50648 .64095 L .51262 .64832 L p F P
0 0 0 r
s
.24 .35 .67 r
.24038 .44333 m
.24488 .42011 L
s
.28676 .41267 m
.24488 .42011 L
s
.41749 .64853 m
.37485 .6546 L
s
.37485 .6546 m
.36423 .63786 L
s
.89 .268 .117 r
.47948 .63889 m .48044 .64072 L .4619 .64788 L p F P
0 0 0 r
s
.89 .268 .117 r
.4619 .64788 m .45996 .64433 L .47948 .63889 L p F P
0 0 0 r
s
1 .332 .137 r
.62021 .5997 m .61699 .59116 L .59786 .6046 L p F P
0 0 0 r
s
1 .332 .137 r
.59786 .6046 m .60068 .61166 L .62021 .5997 L p F P
0 0 0 r
s
.088 .103 .207 r
.37704 .38614 m .39768 .38245 L .40536 .3705 L p F P
0 0 0 r
s
.088 .103 .207 r
.42457 .36703 m .40536 .3705 L .39768 .38245 L p F P
0 0 0 r
s
.24 .35 .67 r
.8291 .60502 m
.82887 .60722 L
s
.788 .241 .106 r
.45406 .63354 m .45604 .63716 L .43605 .63558 L p F P
0 0 0 r
s
.788 .241 .106 r
.43605 .63558 m .43306 .63029 L .45406 .63354 L p F P
0 0 0 r
s
.28 .43 .842 r
.52613 .64642 m .51937 .64737 L .50994 .64046 L p F P
0 0 0 r
s
.24 .35 .67 r
.51694 .64616 m
.51759 .64607 L
s
.28 .43 .842 r
.50648 .64095 m .50994 .64046 L .51937 .64737 L p F P
0 0 0 r
s
1 .33 .135 r
.63288 .57559 m .6293 .56559 L .61372 .58249 L p F P
0 0 0 r
s
.83 .24 .1 r
.63191 .57594 m
.63207 .57638 L
s
1 .33 .135 r
.61372 .58249 m .61699 .59116 L .63288 .57559 L p F P
0 0 0 r
s
.06 .072 .138 r
.50245 .35297 m .52217 .3494 L .51983 .34312 L p F P
0 0 0 r
s
.06 .072 .138 r
.53756 .33991 m .51983 .34312 L .52217 .3494 L p F P
0 0 0 r
s
.888 .244 .094 r
.3109 .46581 m .3188 .47922 L .31817 .45913 L p F P
0 0 0 r
s
.888 .244 .094 r
.31817 .45913 m .31025 .44545 L .3109 .46581 L p F P
0 0 0 r
s
1 .329 .137 r
.60347 .61863 m .60068 .61166 L .57828 .62091 L p F P
0 0 0 r
s
1 .329 .137 r
.57828 .62091 m .58056 .62629 L .60347 .61863 L p F P
0 0 0 r
s
.28 .43 .842 r
.5329 .64547 m .52613 .64642 L .5134 .63997 L p F P
0 0 0 r
s
.24 .35 .67 r
.52308 .6453 m
.52373 .64521 L
s
.28 .43 .842 r
.50994 .64046 m .5134 .63997 L .52613 .64642 L p F P
0 0 0 r
s
.38 .117 .058 r
.59517 .34226 m .59125 .33016 L .60215 .33496 L p F P
0 0 0 r
s
.38 .117 .058 r
.60215 .33496 m .60642 .34845 L .59517 .34226 L p F P
0 0 0 r
s
.83 .24 .1 r
.49577 .65298 m
.52749 .64853 L
s
.49105 .64384 m
.49577 .65298 L
s
.56644 .31292 m
.55609 .28227 L
s
.56644 .31292 m
.58866 .32689 L
s
.13 .166 .335 r
.33611 .39347 m .31582 .39711 L .30656 .41298 L p F P
0 0 0 r
s
.24 .35 .67 r
.15699 .45788 m
.19844 .45065 L
s
.15699 .45788 m
.15419 .48576 L
s
.996 .278 .11 r
.30214 .43146 m .31025 .44545 L .31444 .42686 L p F P
0 0 0 r
s
.996 .278 .11 r
.31444 .42686 m .30656 .41298 L .30214 .43146 L p F P
0 0 0 r
s
.83 .24 .1 r
.31223 .44602 m
.31775 .42014 L
s
.486 .155 .073 r
.40198 .60282 m .40608 .60991 L .38783 .59759 L p F P
0 0 0 r
s
.486 .155 .073 r
.38783 .59759 m .38278 .58902 L .40198 .60282 L p F P
0 0 0 r
s
1 .323 .13 r
.64138 .54724 m .63752 .53592 L .62566 .55541 L p F P
0 0 0 r
s
1 .323 .13 r
.62566 .55541 m .6293 .56559 L .64138 .54724 L p F P
0 0 0 r
s
.28 .43 .842 r
.53968 .64452 m .5329 .64547 L .51687 .63948 L p F P
0 0 0 r
s
.24 .35 .67 r
.52922 .64443 m
.52988 .64434 L
s
.28 .43 .842 r
.5134 .63997 m .51687 .63948 L .5329 .64547 L p F P
0 0 0 r
s
.83 .24 .1 r
.31384 .36635 m
.33125 .34227 L
s
.33125 .34227 m
.31566 .31224 L
s
.24 .35 .67 r
.68715 .31438 m
.6891 .3113 L
s
.73371 .3032 m
.6891 .3113 L
s
.088 .103 .207 r
.39768 .38245 m .41843 .37873 L .42457 .36703 L p F P
0 0 0 r
s
.088 .103 .207 r
.44389 .36354 m .42457 .36703 L .41843 .37873 L p F P
0 0 0 r
s
.65 .203 .092 r
.427 .61956 m .43005 .62495 L .41013 .6169 L p F P
0 0 0 r
s
.65 .203 .092 r
.41013 .6169 m .40608 .60991 L .427 .61956 L p F P
0 0 0 r
s
.365 .111 .056 r
.37766 .58031 m .38278 .58902 L .36683 .57312 L p F P
0 0 0 r
s
.365 .111 .056 r
.36683 .57312 m .36085 .56308 L .37766 .58031 L p F P
0 0 0 r
s
.83 .24 .1 r
.36543 .56769 m
.36557 .56791 L
s
.24 .35 .67 r
.73798 .61995 m
.69333 .62621 L
s
.69333 .62621 m
.68929 .62191 L
s
.06 .072 .138 r
.52217 .3494 m .54201 .34582 L .53756 .33991 L p F P
0 0 0 r
s
.06 .072 .138 r
.55537 .33667 m .53756 .33991 L .54201 .34582 L p F P
0 0 0 r
s
.24 .35 .67 r
.55221 .33884 m
.55381 .33855 L
s
.55381 .33855 m
.5565 .33647 L
s
.28 .43 .842 r
.54647 .64356 m .53968 .64452 L .52033 .63899 L p F P
0 0 0 r
s
.24 .35 .67 r
.53538 .64357 m
.53603 .64347 L
s
.28 .43 .842 r
.51687 .63948 m .52033 .63899 L .53968 .64452 L p F P
0 0 0 r
s
.89 .268 .117 r
.47852 .63705 m .47948 .63889 L .45996 .64433 L p F P
0 0 0 r
s
.89 .268 .117 r
.45996 .64433 m .45801 .64076 L .47852 .63705 L p F P
0 0 0 r
s
.24 .35 .67 r
.46064 .64239 m
.46539 .64794 L
s
.83 .24 .1 r
.50042 .26924 m
.48857 .23754 L
s
.50042 .26924 m
.52962 .27323 L
s
.28 .43 .842 r
.55328 .64261 m .54647 .64356 L .52381 .63849 L p F P
0 0 0 r
s
.24 .35 .67 r
.54154 .6427 m
.5422 .64261 L
s
.28 .43 .842 r
.52033 .63899 m .52381 .63849 L .54647 .64356 L p F P
0 0 0 r
s
.24 .35 .67 r
.32147 .64405 m
.2792 .65017 L
s
.2792 .65017 m
.26787 .62778 L
s
1 .324 .136 r
.58282 .63161 m .58056 .62629 L .55522 .6308 L p F P
0 0 0 r
s
1 .324 .136 r
.55522 .6308 m .55686 .63444 L .58282 .63161 L p F P
0 0 0 r
s
.13 .166 .335 r
.30656 .41298 m .32785 .40921 L .33611 .39347 L p F P
0 0 0 r
s
.83 .24 .1 r
.31307 .41183 m
.31775 .42014 L
s
.30189 .39193 m
.30969 .40581 L
s
.30969 .40581 m
.3107 .4076 L
s
.13 .166 .335 r
.35652 .38982 m .33611 .39347 L .32785 .40921 L p F P
0 0 0 r
s
1 .308 .123 r
.64569 .51578 m .6416 .50333 L .63357 .52438 L p F P
0 0 0 r
s
1 .308 .123 r
.63357 .52438 m .63752 .53592 L .64569 .51578 L p F P
0 0 0 r
s
.245 .071 .038 r
.35477 .55285 m .36085 .56308 L .34782 .54445 L p F P
0 0 0 r
s
.245 .071 .038 r
.34782 .54445 m .34104 .53307 L .35477 .55285 L p F P
0 0 0 r
s
.83 .24 .1 r
.35147 .54685 m
.36543 .56769 L
s
.28 .43 .842 r
.5601 .64165 m .55328 .64261 L .52728 .638 L p F P
0 0 0 r
s
.24 .35 .67 r
.54772 .64183 m
.54838 .64174 L
s
.55391 .64096 m
.55591 .64068 L
s
.55591 .64068 m
.55697 .6413 L
s
.28 .43 .842 r
.52381 .63849 m .52728 .638 L .55328 .64261 L p F P
0 0 0 r
s
.24 .35 .67 r
.56351 .63961 m
.59985 .63449 L
s
.55591 .64068 m
.55944 .64018 L
s
.088 .103 .207 r
.41843 .37873 m .43931 .37499 L .44389 .36354 L p F P
0 0 0 r
s
.088 .103 .207 r
.4633 .36003 m .44389 .36354 L .43931 .37499 L p F P
0 0 0 r
s
.788 .241 .106 r
.45207 .62989 m .45406 .63354 L .43306 .63029 L p F P
0 0 0 r
s
.788 .241 .106 r
.43306 .63029 m .43005 .62495 L .45207 .62989 L p F P
0 0 0 r
s
.24 .35 .67 r
.28282 .43592 m
.28676 .41267 L
s
.28676 .41267 m
.30905 .40871 L
s
.22561 .63404 m
.18384 .64023 L
s
.17295 .61323 m
.18384 .64023 L
s
.06 .072 .138 r
.54201 .34582 m .56195 .34222 L .55537 .33667 L p F P
0 0 0 r
s
.06 .072 .138 r
.57327 .33343 m .55537 .33667 L .56195 .34222 L p F P
0 0 0 r
s
.83 .24 .1 r
.52749 .64853 m
.5439 .64314 L
s
.5439 .64314 m
.5472 .64206 L
s
.24 .35 .67 r
.41749 .64853 m
.46064 .64239 L
s
.41749 .64853 m
.40751 .63159 L
s
.28 .43 .842 r
.52728 .638 m .53076 .63751 L .5601 .64165 L p F P
0 0 0 r
s
.83 .24 .1 r
.52303 .63931 m
.52749 .64853 L
s
1 .316 .133 r
.5601 .64165 m .55849 .63806 L .52988 .63567 L p F P
0 0 0 r
s
1 .316 .133 r
.52988 .63567 m .53076 .63751 L .5601 .64165 L p F P
0 0 0 r
s
.267 .077 .042 r
.61061 .36166 m .60642 .34845 L .61521 .35879 L p F P
0 0 0 r
s
.267 .077 .042 r
.61521 .35879 m .61965 .37298 L .61061 .36166 L p F P
0 0 0 r
s
.89 .268 .117 r
.47755 .63521 m .47852 .63705 L .45801 .64076 L p F P
0 0 0 r
s
.89 .268 .117 r
.45801 .64076 m .45604 .63716 L .47755 .63521 L p F P
0 0 0 r
s
.998 .282 .11 r
.64588 .48251 m .64162 .46917 L .63742 .49061 L p F P
0 0 0 r
s
.998 .282 .11 r
.63742 .49061 m .6416 .50333 L .64588 .48251 L p F P
0 0 0 r
s
.561 .145 .055 r
.33411 .52147 m .34104 .53307 L .33156 .51271 L p F P
0 0 0 r
s
.561 .145 .055 r
.33156 .51271 m .32412 .50019 L .33411 .52147 L p F P
0 0 0 r
s
.13 .166 .335 r
.32785 .40921 m .34926 .40541 L .35652 .38982 L p F P
0 0 0 r
s
.13 .166 .335 r
.37704 .38614 m .35652 .38982 L .34926 .40541 L p F P
0 0 0 r
s
1 .329 .137 r
.60068 .61166 m .59786 .6046 L .57598 .61547 L p F P
0 0 0 r
s
1 .329 .137 r
.57598 .61547 m .57828 .62091 L .60068 .61166 L p F P
0 0 0 r
s
.24 .35 .67 r
.19844 .45065 m
.24038 .44333 L
s
.19608 .47861 m
.19844 .45065 L
s
1 .332 .137 r
.61699 .59116 m .61372 .58249 L .59501 .59744 L p F P
0 0 0 r
s
1 .332 .137 r
.59501 .59744 m .59786 .6046 L .61699 .59116 L p F P
0 0 0 r
s
.06 .072 .138 r
.56195 .34222 m .58199 .3386 L .57327 .33343 L p F P
0 0 0 r
s
.06 .072 .138 r
.59125 .33016 m .57327 .33343 L .58199 .3386 L p F P
0 0 0 r
s
.24 .35 .67 r
.58906 .33216 m
.59212 .33161 L
s
.088 .103 .207 r
.43931 .37499 m .4603 .37123 L .4633 .36003 L p F P
0 0 0 r
s
.088 .103 .207 r
.48282 .35651 m .4633 .36003 L .4603 .37123 L p F P
0 0 0 r
s
.24 .35 .67 r
.73266 .30613 m
.73371 .3032 L
s
.77885 .295 m
.73371 .3032 L
s
.78316 .61362 m
.73798 .61995 L
s
.73798 .61995 m
.73481 .6155 L
s
.855 .238 .09 r
.64211 .44888 m .63774 .43497 L .63726 .45554 L p F P
0 0 0 r
s
.855 .238 .09 r
.63726 .45554 m .64162 .46917 L .64211 .44888 L p F P
0 0 0 r
s
1 .324 .136 r
.58056 .62629 m .57828 .62091 L .55358 .62713 L p F P
0 0 0 r
s
1 .324 .136 r
.55358 .62713 m .55522 .6308 L .58056 .62629 L p F P
0 0 0 r
s
.65 .203 .092 r
.42393 .61411 m .427 .61956 L .40608 .60991 L p F P
0 0 0 r
s
.65 .203 .092 r
.40608 .60991 m .40198 .60282 L .42393 .61411 L p F P
0 0 0 r
s
1 .316 .133 r
.55849 .63806 m .55686 .63444 L .529 .63382 L p F P
0 0 0 r
s
1 .316 .133 r
.529 .63382 m .52988 .63567 L .55849 .63806 L p F P
0 0 0 r
s
.24 .35 .67 r
.55243 .63563 m
.55322 .63676 L
s
1 .33 .135 r
.6293 .56559 m .62566 .55541 L .6104 .57368 L p F P
0 0 0 r
s
.83 .24 .1 r
.62835 .566 m
.62851 .56645 L
s
1 .33 .135 r
.6104 .57368 m .61372 .58249 L .6293 .56559 L p F P
0 0 0 r
s
.187 .054 .028 r
.62399 .38686 m .61965 .37298 L .62578 .38792 L p F P
0 0 0 r
s
.187 .054 .028 r
.62578 .38792 m .63028 .40235 L .62399 .38686 L p F P
0 0 0 r
s
.83 .24 .1 r
.61533 .37464 m
.62679 .39668 L
s
.486 .155 .073 r
.39782 .59565 m .40198 .60282 L .38278 .58902 L p F P
0 0 0 r
s
.486 .155 .073 r
.38278 .58902 m .37766 .58031 L .39782 .59565 L p F P
0 0 0 r
s
.72 .193 .072 r
.31652 .48741 m .32412 .50019 L .3188 .47922 L p F P
0 0 0 r
s
.72 .193 .072 r
.3188 .47922 m .3109 .46581 L .31652 .48741 L p F P
0 0 0 r
s
.83 .24 .1 r
.31223 .44602 m
.32771 .47279 L
s
.24 .35 .67 r
.36423 .63786 m
.32147 .64405 L
s
.32147 .64405 m
.31063 .62144 L
s
.13 .166 .335 r
.34926 .40541 m .3708 .4016 L .37704 .38614 L p F P
0 0 0 r
s
.13 .166 .335 r
.39768 .38245 m .37704 .38614 L .3708 .4016 L p F P
0 0 0 r
s
.66 .179 .065 r
.63467 .41646 m .63028 .40235 L .63328 .42074 L p F P
0 0 0 r
s
.83 .24 .1 r
.62679 .39668 m
.63214 .41377 L
s
.63381 .41911 m
.63556 .42469 L
s
.66 .179 .065 r
.63328 .42074 m .63774 .43497 L .63467 .41646 L p F P
0 0 0 r
s
.89 .268 .117 r
.47658 .63336 m .47755 .63521 L .45604 .63716 L p F P
0 0 0 r
s
.89 .268 .117 r
.45604 .63716 m .45406 .63354 L .47658 .63336 L p F P
0 0 0 r
s
.967 .289 .124 r
.48236 .64436 m .4814 .64255 L .5 .62969 L closepath p F P
0 0 0 r
s
.289 .437 .857 r
.5 .62969 m .48579 .64388 L .48236 .64436 L closepath p F P
0 0 0 r
s
.06 .072 .138 r
.58199 .3386 m .60215 .33496 L .59125 .33016 L p F P
0 0 0 r
s
.83 .24 .1 r
.58866 .32689 m
.58985 .33055 L
s
.59188 .33682 m
.59821 .35629 L
s
.58985 .33055 m
.5899 .3307 L
s
.24 .35 .67 r
.59382 .3313 m
.59773 .33059 L
s
.59773 .33059 m
.60142 .32722 L
s
.788 .241 .106 r
.45006 .62621 m .45207 .62989 L .43005 .62495 L p F P
0 0 0 r
s
.83 .24 .1 r
.45112 .62816 m
.45257 .62852 L
s
.788 .241 .106 r
.43005 .62495 m .427 .61956 L .45006 .62621 L p F P
0 0 0 r
s
.088 .103 .207 r
.4603 .37123 m .48141 .36745 L .48282 .35651 L p F P
0 0 0 r
s
.088 .103 .207 r
.50245 .35297 m .48282 .35651 L .48141 .36745 L p F P
0 0 0 r
s
.289 .437 .857 r
.5 .62969 m .48923 .64339 L .48579 .64388 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.30189 .39193 m
.31384 .36635 L
s
.31384 .36635 m
.29771 .3366 L
s
.24 .35 .67 r
.5972 .33279 m
.59773 .33059 L
s
.59773 .33059 m
.64217 .32253 L
s
.64431 .62824 m
.59985 .63449 L
s
.59319 .62353 m
.59985 .63449 L
s
.289 .437 .857 r
.5 .62969 m .49268 .6429 L .48923 .64339 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.26787 .62778 m
.22561 .63404 L
s
.22561 .63404 m
.21506 .60682 L
s
.46064 .64239 m
.47809 .6399 L
s
.365 .111 .056 r
.37245 .57147 m .37766 .58031 L .36085 .56308 L p F P
0 0 0 r
s
.365 .111 .056 r
.36085 .56308 m .35477 .55285 L .37245 .57147 L p F P
0 0 0 r
s
.289 .437 .857 r
.5 .62969 m .49612 .64242 L .49268 .6429 L closepath p F P
0 0 0 r
s
.888 .244 .094 r
.30283 .4521 m .3109 .46581 L .31025 .44545 L p F P
0 0 0 r
s
.888 .244 .094 r
.31025 .44545 m .30214 .43146 L .30283 .4521 L p F P
0 0 0 r
s
.967 .289 .124 r
.4814 .64255 m .48044 .64072 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .323 .13 r
.63752 .53592 m .63357 .52438 L .62195 .54505 L p F P
0 0 0 r
s
1 .323 .13 r
.62195 .54505 m .62566 .55541 L .63752 .53592 L p F P
0 0 0 r
s
.83 .24 .1 r
.62434 .55483 m
.62503 .55363 L
s
.62434 .55483 m
.62488 .55635 L
s
.289 .437 .857 r
.5 .62969 m .49957 .64193 L .49612 .64242 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.15419 .48576 m
.15445 .51698 L
s
.19608 .47861 m
.15419 .48576 L
s
.83 .24 .1 r
.52962 .27323 m
.51832 .24133 L
s
.52962 .27323 m
.55609 .28227 L
s
.289 .437 .857 r
.5 .62969 m .50302 .64144 L .49957 .64193 L closepath p F P
0 0 0 r
s
1 .316 .133 r
.55686 .63444 m .55522 .6308 L .52812 .63196 L p F P
0 0 0 r
s
1 .316 .133 r
.52812 .63196 m .529 .63382 L .55686 .63444 L p F P
0 0 0 r
s
.83 .24 .1 r
.36486 .27128 m
.39421 .25608 L
s
.39421 .25608 m
.37986 .22379 L
s
.39421 .25608 m
.42536 .24514 L
s
.163 .218 .437 r
.32785 .40921 m .30656 .41298 L .30214 .43146 L p F P
0 0 0 r
s
.13 .166 .335 r
.3708 .4016 m .39247 .39776 L .39768 .38245 L p F P
0 0 0 r
s
.13 .166 .335 r
.41843 .37873 m .39768 .38245 L .39247 .39776 L p F P
0 0 0 r
s
.289 .437 .857 r
.5 .62969 m .50648 .64095 L .50302 .64144 L closepath p F P
0 0 0 r
s
.088 .103 .207 r
.48141 .36745 m .50265 .36364 L .50245 .35297 L p F P
0 0 0 r
s
.088 .103 .207 r
.52217 .3494 m .50245 .35297 L .50265 .36364 L p F P
0 0 0 r
s
.289 .437 .857 r
.5 .62969 m .50994 .64046 L .50648 .64095 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.24038 .44333 m
.28282 .43592 L
s
.23846 .47138 m
.24038 .44333 L
s
.83 .24 .1 r
.58866 .32689 m
.57868 .29617 L
s
.58866 .32689 m
.5943 .33285 L
s
.89 .268 .117 r
.4756 .6315 m .47658 .63336 L .45406 .63354 L p F P
0 0 0 r
s
.89 .268 .117 r
.45406 .63354 m .45207 .62989 L .4756 .6315 L p F P
0 0 0 r
s
.83 .24 .1 r
.45257 .62852 m
.45336 .62998 L
s
.967 .289 .124 r
.48044 .64072 m .47948 .63889 L .5 .62969 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.33834 .29022 m
.36486 .27128 L
s
.36486 .27128 m
.34983 .2393 L
s
.289 .437 .857 r
.5 .62969 m .5134 .63997 L .50994 .64046 L closepath p F P
0 0 0 r
s
1 .329 .137 r
.59786 .6046 m .59501 .59744 L .57365 .60998 L p F P
0 0 0 r
s
1 .329 .137 r
.57365 .60998 m .57598 .61547 L .59786 .6046 L p F P
0 0 0 r
s
1 .324 .136 r
.57828 .62091 m .57598 .61547 L .55192 .62344 L p F P
0 0 0 r
s
1 .324 .136 r
.55192 .62344 m .55358 .62713 L .57828 .62091 L p F P
0 0 0 r
s
.24 .35 .67 r
.77872 .29779 m
.77885 .295 L
s
.83 .24 .1 r
.42536 .24514 m
.41169 .21254 L
s
.42536 .24514 m
.4572 .23886 L
s
.289 .437 .857 r
.5 .62969 m .51687 .63948 L .5134 .63997 L closepath p F P
0 0 0 r
s
.245 .071 .038 r
.34858 .54244 m .35477 .55285 L .34104 .53307 L p F P
0 0 0 r
s
.245 .071 .038 r
.34104 .53307 m .33411 .52147 L .34858 .54244 L p F P
0 0 0 r
s
.83 .24 .1 r
.33645 .5216 m
.35147 .54685 L
s
.32882 .49797 m
.33645 .5216 L
s
.24 .35 .67 r
.82887 .60722 m
.78316 .61362 L
s
.78316 .61362 m
.78089 .60902 L
s
.289 .437 .857 r
.5 .62969 m .52033 .63899 L .51687 .63948 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.21506 .60682 m
.17295 .61323 L
s
.16409 .58255 m
.17295 .61323 L
s
1 .308 .123 r
.6416 .50333 m .63742 .49061 L .62955 .5126 L p F P
0 0 0 r
s
1 .308 .123 r
.62955 .5126 m .63357 .52438 L .6416 .50333 L p F P
0 0 0 r
s
.289 .437 .857 r
.5 .62969 m .52381 .63849 L .52033 .63899 L closepath p F P
0 0 0 r
s
.788 .241 .106 r
.44804 .62252 m .45006 .62621 L .427 .61956 L p F P
0 0 0 r
s
.788 .241 .106 r
.427 .61956 m .42393 .61411 L .44804 .62252 L p F P
0 0 0 r
s
.967 .289 .124 r
.47948 .63889 m .47852 .63705 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .332 .137 r
.61372 .58249 m .6104 .57368 L .59211 .59019 L p F P
0 0 0 r
s
1 .332 .137 r
.59211 .59019 m .59501 .59744 L .61372 .58249 L p F P
0 0 0 r
s
.13 .166 .335 r
.39247 .39776 m .41427 .3939 L .41843 .37873 L p F P
0 0 0 r
s
.13 .166 .335 r
.43931 .37499 m .41843 .37873 L .41427 .3939 L p F P
0 0 0 r
s
.65 .203 .092 r
.42082 .60861 m .42393 .61411 L .40198 .60282 L p F P
0 0 0 r
s
.65 .203 .092 r
.40198 .60282 m .39782 .59565 L .42082 .60861 L p F P
0 0 0 r
s
.163 .218 .437 r
.30214 .43146 m .3239 .42766 L .32785 .40921 L p F P
0 0 0 r
s
.163 .218 .437 r
.34926 .40541 m .32785 .40921 L .3239 .42766 L p F P
0 0 0 r
s
.289 .437 .857 r
.5 .62969 m .52728 .638 L .52381 .63849 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.40751 .63159 m
.36423 .63786 L
s
.36423 .63786 m
.3539 .61503 L
s
.088 .103 .207 r
.50265 .36364 m .524 .35982 L .52217 .3494 L p F P
0 0 0 r
s
.088 .103 .207 r
.54201 .34582 m .52217 .3494 L .524 .35982 L p F P
0 0 0 r
s
1 .316 .133 r
.55522 .6308 m .55358 .62713 L .52723 .6301 L p F P
0 0 0 r
s
1 .316 .133 r
.52723 .6301 m .52812 .63196 L .55522 .6308 L p F P
0 0 0 r
s
.289 .437 .857 r
.5 .62969 m .53076 .63751 L .52728 .638 L closepath p F P
0 0 0 r
s
.267 .077 .042 r
.60642 .34845 m .60215 .33496 L .61068 .34429 L p F P
0 0 0 r
s
.267 .077 .042 r
.61068 .34429 m .61521 .35879 L .60642 .34845 L p F P
0 0 0 r
s
.24 .35 .67 r
.64054 .33276 m
.64217 .32253 L
s
.68715 .31438 m
.64217 .32253 L
s
1 .304 .13 r
.5 .62969 m .53076 .63751 L .52988 .63567 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.68929 .62191 m
.64431 .62824 L
s
.64431 .62824 m
.63844 .61709 L
s
.89 .268 .117 r
.47462 .62964 m .4756 .6315 L .45207 .62989 L p F P
0 0 0 r
s
.89 .268 .117 r
.45207 .62989 m .45006 .62621 L .47462 .62964 L p F P
0 0 0 r
s
.967 .289 .124 r
.47852 .63705 m .47755 .63521 L .5 .62969 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.31063 .62144 m
.26787 .62778 L
s
.26787 .62778 m
.25766 .60033 L
s
.5307 .63242 m
.53486 .63183 L
s
.486 .155 .073 r
.39361 .58837 m .39782 .59565 L .37766 .58031 L p F P
0 0 0 r
s
.83 .24 .1 r
.37517 .5761 m
.38343 .58323 L
s
.486 .155 .073 r
.37766 .58031 m .37245 .57147 L .39361 .58837 L p F P
0 0 0 r
s
.561 .145 .055 r
.32705 .50963 m .33411 .52147 L .32412 .50019 L p F P
0 0 0 r
s
.561 .145 .055 r
.32412 .50019 m .31652 .48741 L .32705 .50963 L p F P
0 0 0 r
s
.83 .24 .1 r
.31566 .31224 m
.33834 .29022 L
s
.33834 .29022 m
.32265 .25853 L
s
.998 .282 .11 r
.64162 .46917 m .63726 .45554 L .63315 .47762 L p F P
0 0 0 r
s
.998 .282 .11 r
.63315 .47762 m .63742 .49061 L .64162 .46917 L p F P
0 0 0 r
s
1 .33 .135 r
.62566 .55541 m .62195 .54505 L .60702 .56474 L p F P
0 0 0 r
s
1 .33 .135 r
.60702 .56474 m .6104 .57368 L .62566 .55541 L p F P
0 0 0 r
s
.24 .35 .67 r
.19663 .50996 m
.19608 .47861 L
s
.23846 .47138 m
.19608 .47861 L
s
.13 .166 .335 r
.41427 .3939 m .4362 .39001 L .43931 .37499 L p F P
0 0 0 r
s
.13 .166 .335 r
.4603 .37123 m .43931 .37499 L .4362 .39001 L p F P
0 0 0 r
s
1 .304 .13 r
.5 .62969 m .52988 .63567 L .529 .63382 L closepath p F P
0 0 0 r
s
.088 .103 .207 r
.524 .35982 m .54548 .35597 L .54201 .34582 L p F P
0 0 0 r
s
.088 .103 .207 r
.56195 .34222 m .54201 .34582 L .54548 .35597 L p F P
0 0 0 r
s
.163 .218 .437 r
.3239 .42766 m .3458 .42383 L .34926 .40541 L p F P
0 0 0 r
s
.24 .35 .67 r
.32577 .42843 m
.32593 .4273 L
s
.163 .218 .437 r
.3708 .4016 m .34926 .40541 L .3458 .42383 L p F P
0 0 0 r
s
.83 .24 .1 r
.4572 .23886 m
.44418 .20598 L
s
.4572 .23886 m
.48857 .23754 L
s
.967 .289 .124 r
.47755 .63521 m .47658 .63336 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .324 .136 r
.57598 .61547 m .57365 .60998 L .55024 .61972 L p F P
0 0 0 r
s
1 .324 .136 r
.55024 .61972 m .55192 .62344 L .57598 .61547 L p F P
0 0 0 r
s
.24 .35 .67 r
.15445 .51698 m
.15781 .54985 L
s
.19663 .50996 m
.15445 .51698 L
s
.28282 .43592 m
.30218 .43254 L
s
.28136 .46406 m
.28282 .43592 L
s
1 .316 .133 r
.55358 .62713 m .55192 .62344 L .52635 .62823 L p F P
0 0 0 r
s
1 .316 .133 r
.52635 .62823 m .52723 .6301 L .55358 .62713 L p F P
0 0 0 r
s
.24 .35 .67 r
.53486 .63183 m
.54848 .62989 L
s
.54848 .62989 m
.55243 .63563 L
s
.187 .054 .028 r
.61965 .37298 m .61521 .35879 L .62118 .37317 L p F P
0 0 0 r
s
.187 .054 .028 r
.62118 .37317 m .62578 .38792 L .61965 .37298 L p F P
0 0 0 r
s
.855 .238 .09 r
.63774 .43497 m .63328 .42074 L .63281 .44159 L p F P
0 0 0 r
s
.83 .24 .1 r
.63186 .42159 m
.63316 .42574 L
s
.63657 .43654 m
.63763 .4399 L
s
.855 .238 .09 r
.63281 .44159 m .63726 .45554 L .63774 .43497 L p F P
0 0 0 r
s
1 .304 .13 r
.5 .62969 m .529 .63382 L .52812 .63196 L closepath p F P
0 0 0 r
s
.89 .268 .117 r
.47364 .62777 m .47462 .62964 L .45006 .62621 L p F P
0 0 0 r
s
.89 .268 .117 r
.45006 .62621 m .44804 .62252 L .47364 .62777 L p F P
0 0 0 r
s
.788 .241 .106 r
.446 .61879 m .44804 .62252 L .42393 .61411 L p F P
0 0 0 r
s
.788 .241 .106 r
.42393 .61411 m .42082 .60861 L .446 .61879 L p F P
0 0 0 r
s
.24 .35 .67 r
.82887 .60722 m
.82752 .60246 L
s
1 .329 .137 r
.59501 .59744 m .59211 .59019 L .5713 .60443 L p F P
0 0 0 r
s
1 .329 .137 r
.5713 .60443 m .57365 .60998 L .59501 .59744 L p F P
0 0 0 r
s
.365 .111 .056 r
.36716 .56249 m .37245 .57147 L .35477 .55285 L p F P
0 0 0 r
s
.365 .111 .056 r
.35477 .55285 m .34858 .54244 L .36716 .56249 L p F P
0 0 0 r
s
.83 .24 .1 r
.35053 .54257 m
.3538 .54808 L
s
.967 .289 .124 r
.47658 .63336 m .4756 .6315 L .5 .62969 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.20639 .57592 m
.16409 .58255 L
s
.15781 .54985 m
.16409 .58255 L
s
.72 .193 .072 r
.30876 .47434 m .31652 .48741 L .3109 .46581 L p F P
0 0 0 r
s
.83 .24 .1 r
.31316 .47141 m
.32882 .49797 L
s
.72 .193 .072 r
.3109 .46581 m .30283 .4521 L .30876 .47434 L p F P
0 0 0 r
s
.24 .35 .67 r
.25766 .60033 m
.21506 .60682 L
s
.21506 .60682 m
.20639 .57592 L
s
.66 .179 .065 r
.63028 .40235 m .62578 .38792 L .62871 .40619 L p F P
0 0 0 r
s
.83 .24 .1 r
.62679 .39668 m
.62866 .40586 L
s
.66 .179 .065 r
.62871 .40619 m .63328 .42074 L .63028 .40235 L p F P
0 0 0 r
s
.83 .24 .1 r
.62875 .40632 m
.63186 .42159 L
s
.088 .103 .207 r
.54548 .35597 m .56709 .3521 L .56195 .34222 L p F P
0 0 0 r
s
.088 .103 .207 r
.58199 .3386 m .56195 .34222 L .56709 .3521 L p F P
0 0 0 r
s
.13 .166 .335 r
.4362 .39001 m .45826 .38611 L .4603 .37123 L p F P
0 0 0 r
s
.13 .166 .335 r
.48141 .36745 m .4603 .37123 L .45826 .38611 L p F P
0 0 0 r
s
.83 .24 .1 r
.29606 .41804 m
.30189 .39193 L
s
.30189 .39193 m
.28532 .36243 L
s
.163 .218 .437 r
.3458 .42383 m .36783 .41999 L .3708 .4016 L p F P
0 0 0 r
s
.163 .218 .437 r
.39247 .39776 m .3708 .4016 L .36783 .41999 L p F P
0 0 0 r
s
1 .323 .13 r
.63357 .52438 m .62955 .5126 L .61818 .53449 L p F P
0 0 0 r
s
1 .323 .13 r
.61818 .53449 m .62195 .54505 L .63357 .52438 L p F P
0 0 0 r
s
1 .304 .13 r
.5 .62969 m .52812 .63196 L .52723 .6301 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.20012 .54302 m
.15781 .54985 L
s
.65 .203 .092 r
.41768 .60304 m .42082 .60861 L .39782 .59565 L p F P
0 0 0 r
s
.24 .35 .67 r
.3977 .60854 m
.40751 .63159 L
s
.65 .203 .092 r
.39782 .59565 m .39361 .58837 L .41768 .60304 L p F P
0 0 0 r
s
.967 .289 .124 r
.4756 .6315 m .47462 .62964 L .5 .62969 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.47454 .62948 m
.47822 .62965 L
s
.24 .35 .67 r
.68637 .32451 m
.68715 .31438 L
s
.73266 .30613 m
.68715 .31438 L
s
.73481 .6155 m
.68929 .62191 L
s
.68929 .62191 m
.68424 .61057 L
s
.187 .257 .511 r
.3239 .42766 m .30214 .43146 L .30283 .4521 L p F P
0 0 0 r
s
.83 .24 .1 r
.31223 .44602 m
.31316 .47141 L
s
.24 .35 .67 r
.3228 .42894 m
.32577 .42843 L
s
.83 .24 .1 r
.31056 .44313 m
.31223 .44602 L
s
1 .316 .133 r
.55192 .62344 m .55024 .61972 L .52545 .62636 L p F P
0 0 0 r
s
1 .316 .133 r
.52545 .62636 m .52635 .62823 L .55192 .62344 L p F P
0 0 0 r
s
.24 .35 .67 r
.3539 .61503 m
.31063 .62144 L
s
.31063 .62144 m
.30078 .59377 L
s
.83 .24 .1 r
.55609 .28227 m
.54526 .25022 L
s
.55609 .28227 m
.57868 .29617 L
s
1 .332 .137 r
.6104 .57368 m .60702 .56474 L .58918 .58285 L p F P
0 0 0 r
s
1 .332 .137 r
.58918 .58285 m .59211 .59019 L .6104 .57368 L p F P
0 0 0 r
s
1 .304 .13 r
.5 .62969 m .52723 .6301 L .52635 .62823 L closepath p F P
0 0 0 r
s
.088 .103 .207 r
.56709 .3521 m .58882 .34821 L .58199 .3386 L p F P
0 0 0 r
s
.088 .103 .207 r
.60215 .33496 m .58199 .3386 L .58882 .34821 L p F P
0 0 0 r
s
.89 .268 .117 r
.47266 .62589 m .47364 .62777 L .44804 .62252 L p F P
0 0 0 r
s
.89 .268 .117 r
.44804 .62252 m .446 .61879 L .47266 .62589 L p F P
0 0 0 r
s
.967 .289 .124 r
.47462 .62964 m .47364 .62777 L .5 .62969 L closepath p F P
0 0 0 r
s
.13 .166 .335 r
.45826 .38611 m .48046 .38217 L .48141 .36745 L p F P
0 0 0 r
s
.13 .166 .335 r
.50265 .36364 m .48141 .36745 L .48046 .38217 L p F P
0 0 0 r
s
.83 .24 .1 r
.29771 .3366 m
.31566 .31224 L
s
.31566 .31224 m
.29935 .28084 L
s
1 .324 .136 r
.57365 .60998 m .5713 .60443 L .54856 .61598 L p F P
0 0 0 r
s
1 .324 .136 r
.54856 .61598 m .55024 .61972 L .57365 .60998 L p F P
0 0 0 r
s
.83 .24 .1 r
.54804 .61474 m
.54859 .61596 L
s
.24 .35 .67 r
.23932 .50287 m
.23846 .47138 L
s
.28136 .46406 m
.23846 .47138 L
s
.245 .071 .038 r
.34227 .53184 m .34858 .54244 L .33411 .52147 L p F P
0 0 0 r
s
.245 .071 .038 r
.33411 .52147 m .32705 .50963 L .34227 .53184 L p F P
0 0 0 r
s
.83 .24 .1 r
.33645 .5216 m
.35053 .54257 L
s
.163 .218 .437 r
.36783 .41999 m .38999 .41611 L .39247 .39776 L p F P
0 0 0 r
s
.24 .35 .67 r
.36923 .42084 m
.36937 .41972 L
s
.163 .218 .437 r
.41427 .3939 m .39247 .39776 L .38999 .41611 L p F P
0 0 0 r
s
.24 .35 .67 r
.20012 .54302 m
.19663 .50996 L
s
.23932 .50287 m
.19663 .50996 L
s
.486 .155 .073 r
.38935 .581 m .39361 .58837 L .37245 .57147 L p F P
0 0 0 r
s
.486 .155 .073 r
.37245 .57147 m .36716 .56249 L .38935 .581 L p F P
0 0 0 r
s
1 .304 .13 r
.5 .62969 m .52635 .62823 L .52545 .62636 L closepath p F P
0 0 0 r
s
.788 .241 .106 r
.44395 .61504 m .446 .61879 L .42082 .60861 L p F P
0 0 0 r
s
.788 .241 .106 r
.42082 .60861 m .41768 .60304 L .44395 .61504 L p F P
0 0 0 r
s
.83 .24 .1 r
.48857 .23754 m
.47619 .2044 L
s
.48857 .23754 m
.51832 .24133 L
s
1 .308 .123 r
.63742 .49061 m .63315 .47762 L .62545 .50058 L p F P
0 0 0 r
s
1 .308 .123 r
.62545 .50058 m .62955 .5126 L .63742 .49061 L p F P
0 0 0 r
s
.967 .289 .124 r
.47364 .62777 m .47266 .62589 L .5 .62969 L closepath p F P
0 0 0 r
s
.187 .257 .511 r
.30283 .4521 m .32452 .44837 L .3239 .42766 L p F P
0 0 0 r
s
.83 .24 .1 r
.29606 .41804 m
.30366 .43119 L
s
.187 .257 .511 r
.3458 .42383 m .3239 .42766 L .32452 .44837 L p F P
0 0 0 r
s
1 .304 .13 r
.5 .62969 m .52095 .61688 L .52004 .61497 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.4925 .62865 m
.50359 .62706 L
s
.24 .35 .67 r
.50081 .6292 m
.501 .62956 L
s
1 .304 .13 r
.5 .62969 m .52004 .61497 L .51912 .61304 L closepath p F P
0 0 0 r
s
1 .304 .13 r
.5 .62969 m .51912 .61304 L .5182 .61112 L closepath p F P
0 0 0 r
s
1 .304 .13 r
.5 .62969 m .52545 .62636 L .52456 .62448 L closepath p F P
0 0 0 r
s
1 .304 .13 r
.5 .62969 m .52456 .62448 L .52366 .62259 L closepath p F P
0 0 0 r
s
1 .304 .13 r
.5 .62969 m .52366 .62259 L .52276 .62069 L closepath p F P
0 0 0 r
s
1 .304 .13 r
.5 .62969 m .52276 .62069 L .52185 .61879 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.50453 .62692 m
.50597 .62672 L
s
1 .304 .13 r
.5 .62969 m .52185 .61879 L .52095 .61688 L closepath p F P
0 0 0 r
s
.967 .289 .124 r
.46968 .62022 m .46868 .61832 L .5 .62969 L closepath p F P
0 0 0 r
s
.967 .289 .124 r
.47068 .62212 m .46968 .62022 L .5 .62969 L closepath p F P
0 0 0 r
s
.967 .289 .124 r
.47167 .62401 m .47068 .62212 L .5 .62969 L closepath p F P
0 0 0 r
s
.967 .289 .124 r
.47266 .62589 m .47167 .62401 L .5 .62969 L closepath p F P
0 0 0 r
s
.287 .429 .842 r
.4722 .61781 m .46868 .61832 L .5 .62969 L closepath p F P
0 0 0 r
s
.287 .429 .842 r
.47571 .61729 m .4722 .61781 L .5 .62969 L closepath p F P
0 0 0 r
s
.287 .429 .842 r
.47924 .61678 m .47571 .61729 L .5 .62969 L closepath p F P
0 0 0 r
s
.287 .429 .842 r
.48276 .61627 m .47924 .61678 L .5 .62969 L closepath p F P
0 0 0 r
s
.287 .429 .842 r
.48629 .61576 m .48276 .61627 L .5 .62969 L closepath p F P
0 0 0 r
s
.287 .429 .842 r
.48982 .61524 m .48629 .61576 L .5 .62969 L closepath p F P
0 0 0 r
s
.287 .429 .842 r
.49336 .61473 m .48982 .61524 L .5 .62969 L closepath p F P
0 0 0 r
s
.287 .429 .842 r
.4969 .61421 m .49336 .61473 L .5 .62969 L closepath p F P
0 0 0 r
s
.287 .429 .842 r
.50044 .6137 m .4969 .61421 L .5 .62969 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.50006 .62768 m
.5007 .62898 L
s
.287 .429 .842 r
.50399 .61318 m .50044 .6137 L .5 .62969 L closepath p F P
0 0 0 r
s
.287 .429 .842 r
.50754 .61267 m .50399 .61318 L .5 .62969 L closepath p F P
0 0 0 r
s
.287 .429 .842 r
.51109 .61215 m .50754 .61267 L .5 .62969 L closepath p F P
0 0 0 r
s
.287 .429 .842 r
.51464 .61163 m .51109 .61215 L .5 .62969 L closepath p F P
0 0 0 r
s
.287 .429 .842 r
.5182 .61112 m .51464 .61163 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .316 .133 r
.55024 .61972 m .54856 .61598 L .52456 .62448 L p F P
0 0 0 r
s
1 .316 .133 r
.52456 .62448 m .52545 .62636 L .55024 .61972 L p F P
0 0 0 r
s
.088 .103 .207 r
.58882 .34821 m .61068 .34429 L .60215 .33496 L p F P
0 0 0 r
s
.83 .24 .1 r
.60593 .34515 m
.60603 .34526 L
s
.60603 .34526 m
.61533 .37464 L
s
.59631 .31454 m
.60388 .33846 L
s
.60599 .34513 m
.60603 .34526 L
s
.24 .35 .67 r
.24919 .56921 m
.20639 .57592 L
s
.20639 .57592 m
.20012 .54302 L
s
.30078 .59377 m
.25766 .60033 L
s
.25766 .60033 m
.24919 .56921 L
s
.13 .166 .335 r
.48046 .38217 m .50278 .37822 L .50265 .36364 L p F P
0 0 0 r
s
.13 .166 .335 r
.524 .35982 m .50265 .36364 L .50278 .37822 L p F P
0 0 0 r
s
1 .329 .137 r
.59211 .59019 m .58918 .58285 L .56892 .59883 L p F P
0 0 0 r
s
1 .329 .137 r
.56892 .59883 m .5713 .60443 L .59211 .59019 L p F P
0 0 0 r
s
.89 .268 .117 r
.47167 .62401 m .47266 .62589 L .446 .61879 L p F P
0 0 0 r
s
.24 .35 .67 r
.40751 .63159 m
.4513 .62525 L
s
.4513 .62525 m
.46064 .64239 L
s
.89 .268 .117 r
.446 .61879 m .44395 .61504 L .47167 .62401 L p F P
0 0 0 r
s
1 .33 .135 r
.62195 .54505 m .61818 .53449 L .60359 .55564 L p F P
0 0 0 r
s
.83 .24 .1 r
.62102 .54559 m
.62119 .54605 L
s
1 .33 .135 r
.60359 .55564 m .60702 .56474 L .62195 .54505 L p F P
0 0 0 r
s
.163 .218 .437 r
.38999 .41611 m .41228 .41222 L .41427 .3939 L p F P
0 0 0 r
s
.163 .218 .437 r
.4362 .39001 m .41427 .3939 L .41228 .41222 L p F P
0 0 0 r
s
.24 .35 .67 r
.24295 .5361 m
.20012 .54302 L
s
.83 .24 .1 r
.54804 .61474 m
.57056 .60269 L
s
.561 .145 .055 r
.31984 .49755 m .32705 .50963 L .31652 .48741 L p F P
0 0 0 r
s
.561 .145 .055 r
.31652 .48741 m .30876 .47434 L .31984 .49755 L p F P
0 0 0 r
s
.24 .35 .67 r
.73277 .31616 m
.73266 .30613 L
s
.77872 .29779 m
.73266 .30613 L
s
.78089 .60902 m
.73481 .6155 L
s
.73481 .6155 m
.7306 .60397 L
s
.65 .203 .092 r
.41451 .59743 m .41768 .60304 L .39361 .58837 L p F P
0 0 0 r
s
.65 .203 .092 r
.39361 .58837 m .38935 .581 L .41451 .59743 L p F P
0 0 0 r
s
.187 .257 .511 r
.32452 .44837 m .34634 .44462 L .3458 .42383 L p F P
0 0 0 r
s
.187 .257 .511 r
.36783 .41999 m .3458 .42383 L .34634 .44462 L p F P
0 0 0 r
s
.24 .35 .67 r
.36669 .42128 m
.36923 .42084 L
s
1 .316 .133 r
.52366 .62259 m .52456 .62448 L .54856 .61598 L p F P
0 0 0 r
s
.83 .24 .1 r
.52679 .62176 m
.54804 .61474 L
s
.24 .35 .67 r
.54848 .62989 m
.59319 .62353 L
s
.998 .282 .11 r
.63726 .45554 m .63281 .44159 L .62879 .46434 L p F P
0 0 0 r
s
.998 .282 .11 r
.62879 .46434 m .63315 .47762 L .63726 .45554 L p F P
0 0 0 r
s
.24 .35 .67 r
.3977 .60854 m
.3539 .61503 L
s
.3539 .61503 m
.34443 .58713 L
s
.63844 .61709 m
.59319 .62353 L
s
.58589 .60576 m
.59319 .62353 L
s
1 .324 .136 r
.5713 .60443 m .56892 .59883 L .54687 .61221 L p F P
0 0 0 r
s
1 .324 .136 r
.54687 .61221 m .54856 .61598 L .5713 .60443 L p F P
0 0 0 r
s
.89 .268 .117 r
.47068 .62212 m .47167 .62401 L .44395 .61504 L p F P
0 0 0 r
s
.24 .35 .67 r
.46486 .62328 m
.46902 .62268 L
s
.4513 .62525 m
.46486 .62328 L
s
.365 .111 .056 r
.36178 .55336 m .36716 .56249 L .34858 .54244 L p F P
0 0 0 r
s
.365 .111 .056 r
.34858 .54244 m .34227 .53184 L .36178 .55336 L p F P
0 0 0 r
s
.24 .35 .67 r
.60584 .339 m
.64054 .33276 L
s
.13 .166 .335 r
.50278 .37822 m .52525 .37424 L .524 .35982 L p F P
0 0 0 r
s
.13 .166 .335 r
.54548 .35597 m .524 .35982 L .52525 .37424 L p F P
0 0 0 r
s
1 .316 .133 r
.54856 .61598 m .54687 .61221 L .52366 .62259 L p F P
0 0 0 r
s
.24 .35 .67 r
.28252 .49569 m
.28136 .46406 L
s
.163 .218 .437 r
.41228 .41222 m .43472 .4083 L .4362 .39001 L p F P
0 0 0 r
s
.24 .35 .67 r
.41322 .41316 m
.41333 .41204 L
s
.163 .218 .437 r
.45826 .38611 m .4362 .39001 L .43472 .4083 L p F P
0 0 0 r
s
.788 .241 .106 r
.44189 .61126 m .44395 .61504 L .41768 .60304 L p F P
0 0 0 r
s
.788 .241 .106 r
.41768 .60304 m .41451 .59743 L .44189 .61126 L p F P
0 0 0 r
s
.187 .054 .028 r
.61521 .35879 m .61068 .34429 L .61648 .35808 L p F P
0 0 0 r
s
.187 .054 .028 r
.61648 .35808 m .62118 .37317 L .61521 .35879 L p F P
0 0 0 r
s
1 .316 .133 r
.52276 .62069 m .52366 .62259 L .54687 .61221 L p F P
0 0 0 r
s
.89 .268 .117 r
.44395 .61504 m .44189 .61126 L .47068 .62212 L p F P
0 0 0 r
s
.89 .268 .117 r
.46968 .62022 m .47068 .62212 L .44189 .61126 L p F P
0 0 0 r
s
.24 .35 .67 r
.24295 .5361 m
.23932 .50287 L
s
.28252 .49569 m
.23932 .50287 L
s
.855 .238 .09 r
.63328 .42074 m .62871 .40619 L .62825 .42733 L p F P
0 0 0 r
s
.855 .238 .09 r
.62825 .42733 m .63281 .44159 L .63328 .42074 L p F P
0 0 0 r
s
1 .332 .137 r
.60702 .56474 m .60359 .55564 L .5862 .5754 L p F P
0 0 0 r
s
1 .332 .137 r
.5862 .5754 m .58918 .58285 L .60702 .56474 L p F P
0 0 0 r
s
.206 .287 .569 r
.32452 .44837 m .30283 .4521 L .30876 .47434 L p F P
0 0 0 r
s
.24 .35 .67 r
.28136 .46406 m
.30395 .4602 L
s
.30395 .4602 m
.30495 .46003 L
s
.83 .24 .1 r
.29679 .44363 m
.30543 .45829 L
s
.30543 .45829 m
.30589 .45907 L
s
.31187 .46921 m
.31316 .47141 L
s
1 .323 .13 r
.62955 .5126 m .62545 .50058 L .61433 .52374 L p F P
0 0 0 r
s
1 .323 .13 r
.61433 .52374 m .61818 .53449 L .62955 .5126 L p F P
0 0 0 r
s
.187 .257 .511 r
.34634 .44462 m .36829 .44085 L .36783 .41999 L p F P
0 0 0 r
s
.187 .257 .511 r
.38999 .41611 m .36783 .41999 L .36829 .44085 L p F P
0 0 0 r
s
.66 .179 .065 r
.62578 .38792 m .62118 .37317 L .62404 .3913 L p F P
0 0 0 r
s
.83 .24 .1 r
.61763 .3674 m
.62296 .38443 L
s
.6247 .39001 m
.62679 .39668 L
s
.66 .179 .065 r
.62404 .3913 m .62871 .40619 L .62578 .38792 L p F P
0 0 0 r
s
1 .316 .133 r
.54687 .61221 m .54516 .60841 L .52276 .62069 L p F P
0 0 0 r
s
1 .316 .133 r
.52185 .61879 m .52276 .62069 L .54516 .60841 L p F P
0 0 0 r
s
.24 .35 .67 r
.29251 .56242 m
.24919 .56921 L
s
.24919 .56921 m
.24295 .5361 L
s
.13 .166 .335 r
.52525 .37424 m .54785 .37024 L .54548 .35597 L p F P
0 0 0 r
s
.13 .166 .335 r
.56709 .3521 m .54548 .35597 L .54785 .37024 L p F P
0 0 0 r
s
.24 .35 .67 r
.34443 .58713 m
.30078 .59377 L
s
.30078 .59377 m
.29251 .56242 L
s
.89 .268 .117 r
.46868 .61832 m .46968 .62022 L .43981 .60746 L p F P
0 0 0 r
s
.89 .268 .117 r
.44189 .61126 m .43981 .60746 L .46968 .62022 L p F P
0 0 0 r
s
.24 .35 .67 r
.44644 .61306 m
.4513 .62525 L
s
.83 .24 .1 r
.28532 .36243 m
.29771 .3366 L
s
.29771 .3366 m
.28084 .30548 L
s
.486 .155 .073 r
.38502 .57353 m .38935 .581 L .36716 .56249 L p F P
0 0 0 r
s
.486 .155 .073 r
.36716 .56249 m .36178 .55336 L .38502 .57353 L p F P
0 0 0 r
s
.83 .24 .1 r
.37066 .55981 m
.37216 .56237 L
s
1 .324 .136 r
.54516 .60841 m .54687 .61221 L .56892 .59883 L p F P
0 0 0 r
s
.83 .24 .1 r
.27914 .38877 m
.29606 .41804 L
s
.29679 .44363 m
.29606 .41804 L
s
.163 .218 .437 r
.43472 .4083 m .45729 .40436 L .45826 .38611 L p F P
0 0 0 r
s
.163 .218 .437 r
.48046 .38217 m .45826 .38611 L .45729 .40436 L p F P
0 0 0 r
s
1 .329 .137 r
.58918 .58285 m .5862 .5754 L .56652 .59317 L p F P
0 0 0 r
s
1 .329 .137 r
.56652 .59317 m .56892 .59883 L .58918 .58285 L p F P
0 0 0 r
s
.24 .35 .67 r
.2863 .5291 m
.24295 .5361 L
s
1 .316 .133 r
.54516 .60841 m .54344 .60459 L .52185 .61879 L p F P
0 0 0 r
s
1 .316 .133 r
.52095 .61688 m .52185 .61879 L .54344 .60459 L p F P
0 0 0 r
s
.788 .241 .106 r
.43981 .60746 m .44189 .61126 L .41451 .59743 L p F P
0 0 0 r
s
.245 .071 .038 r
.33584 .52104 m .34227 .53184 L .32705 .50963 L p F P
0 0 0 r
s
.245 .071 .038 r
.32705 .50963 m .31984 .49755 L .33584 .52104 L p F P
0 0 0 r
s
.83 .24 .1 r
.32076 .49521 m
.33645 .5216 L
s
1 .324 .136 r
.56892 .59883 m .56652 .59317 L .54516 .60841 L p F P
0 0 0 r
s
.24 .35 .67 r
.77974 .30771 m
.77872 .29779 L
s
.82752 .60246 m
.78089 .60902 L
s
.78089 .60902 m
.77753 .59729 L
s
.83 .24 .1 r
.51832 .24133 m
.5065 .20796 L
s
.51832 .24133 m
.54526 .25022 L
s
.89 .268 .117 r
.43981 .60746 m .43772 .60363 L .46868 .61832 L p F P
0 0 0 r
s
.281 .415 .817 r
.46868 .61832 m .4722 .61781 L .44468 .6026 L p F P
0 0 0 r
s
.281 .415 .817 r
.44468 .6026 m .43772 .60363 L .46868 .61832 L p F P
0 0 0 r
s
.24 .35 .67 r
.44203 .60198 m
.44241 .60294 L
s
.206 .287 .569 r
.30876 .47434 m .32981 .47079 L .32452 .44837 L p F P
0 0 0 r
s
.83 .24 .1 r
.31382 .47349 m
.32076 .49521 L
s
.24 .35 .67 r
.32499 .45036 m
.32507 .44828 L
s
.206 .287 .569 r
.34634 .44462 m .32452 .44837 L .32981 .47079 L p F P
0 0 0 r
s
.83 .24 .1 r
.34983 .2393 m
.37986 .22379 L
s
.37986 .22379 m
.36485 .19001 L
s
.37986 .22379 m
.41169 .21254 L
s
.187 .257 .511 r
.36829 .44085 m .39038 .43706 L .38999 .41611 L p F P
0 0 0 r
s
.187 .257 .511 r
.41228 .41222 m .38999 .41611 L .39038 .43706 L p F P
0 0 0 r
s
.24 .35 .67 r
.41113 .41353 m
.41322 .41316 L
s
.281 .415 .817 r
.4722 .61781 m .47571 .61729 L .45166 .60157 L p F P
0 0 0 r
s
.281 .415 .817 r
.45166 .60157 m .44468 .6026 L .4722 .61781 L p F P
0 0 0 r
s
.24 .35 .67 r
.44546 .61059 m
.44644 .61306 L
s
.68424 .61057 m
.63844 .61709 L
s
.63844 .61709 m
.63185 .5991 L
s
.65 .203 .092 r
.4113 .59175 m .41451 .59743 L .38935 .581 L p F P
0 0 0 r
s
.65 .203 .092 r
.38935 .581 m .38502 .57353 L .4113 .59175 L p F P
0 0 0 r
s
.13 .166 .335 r
.54785 .37024 m .57058 .36621 L .56709 .3521 L p F P
0 0 0 r
s
.13 .166 .335 r
.58882 .34821 m .56709 .3521 L .57058 .36621 L p F P
0 0 0 r
s
.281 .415 .817 r
.47571 .61729 m .47924 .61678 L .45865 .60053 L p F P
0 0 0 r
s
.281 .415 .817 r
.45865 .60053 m .45166 .60157 L .47571 .61729 L p F P
0 0 0 r
s
.83 .24 .1 r
.57868 .29617 m
.56823 .26403 L
s
.57868 .29617 m
.59631 .31454 L
s
.788 .241 .106 r
.41451 .59743 m .4113 .59175 L .43981 .60746 L p F P
0 0 0 r
s
.24 .35 .67 r
.64025 .34987 m
.64054 .33276 L
s
.68637 .32451 m
.64054 .33276 L
s
1 .316 .133 r
.54344 .60459 m .54171 .60073 L .52095 .61688 L p F P
0 0 0 r
s
1 .316 .133 r
.52004 .61497 m .52095 .61688 L .54171 .60073 L p F P
0 0 0 r
s
.24 .35 .67 r
.52243 .61495 m
.52665 .61434 L
s
.83 .24 .1 r
.32265 .25853 m
.34983 .2393 L
s
.34983 .2393 m
.33411 .20583 L
s
.281 .415 .817 r
.47924 .61678 m .48276 .61627 L .46566 .59949 L p F P
0 0 0 r
s
.281 .415 .817 r
.46566 .59949 m .45865 .60053 L .47924 .61678 L p F P
0 0 0 r
s
1 .308 .123 r
.63315 .47762 m .62879 .46434 L .62126 .48831 L p F P
0 0 0 r
s
1 .308 .123 r
.62126 .48831 m .62545 .50058 L .63315 .47762 L p F P
0 0 0 r
s
.163 .218 .437 r
.45729 .40436 m .48 .40039 L .48046 .38217 L p F P
0 0 0 r
s
.24 .35 .67 r
.45775 .40539 m
.45782 .40426 L
s
.163 .218 .437 r
.50278 .37822 m .48046 .38217 L .48 .40039 L p F P
0 0 0 r
s
1 .33 .135 r
.61818 .53449 m .61433 .52374 L .60011 .5464 L p F P
0 0 0 r
s
.83 .24 .1 r
.61726 .5351 m
.61743 .53558 L
s
1 .33 .135 r
.60011 .5464 m .60359 .55564 L .61818 .53449 L p F P
0 0 0 r
s
.83 .24 .1 r
.41169 .21254 m
.39739 .17845 L
s
.41169 .21254 m
.44418 .20598 L
s
.281 .415 .817 r
.48276 .61627 m .48629 .61576 L .47268 .59846 L p F P
0 0 0 r
s
.281 .415 .817 r
.47268 .59846 m .46566 .59949 L .48276 .61627 L p F P
0 0 0 r
s
1 .324 .136 r
.54344 .60459 m .54516 .60841 L .56652 .59317 L p F P
0 0 0 r
s
.281 .415 .817 r
.48629 .61576 m .48982 .61524 L .47971 .59741 L p F P
0 0 0 r
s
.281 .415 .817 r
.47971 .59741 m .47268 .59846 L .48629 .61576 L p F P
0 0 0 r
s
.83 .24 .1 r
.47138 .60575 m
.47527 .61328 L
s
.47527 .61328 m
.47645 .61556 L
s
.24 .35 .67 r
.2863 .5291 m
.28252 .49569 L
s
.281 .415 .817 r
.48982 .61524 m .49336 .61473 L .48675 .59637 L p F P
0 0 0 r
s
.281 .415 .817 r
.48675 .59637 m .47971 .59741 L .48982 .61524 L p F P
0 0 0 r
s
.206 .287 .569 r
.32981 .47079 m .35098 .46722 L .34634 .44462 L p F P
0 0 0 r
s
.206 .287 .569 r
.36829 .44085 m .34634 .44462 L .35098 .46722 L p F P
0 0 0 r
s
.788 .241 .106 r
.43772 .60363 m .43981 .60746 L .4113 .59175 L p F P
0 0 0 r
s
.24 .35 .67 r
.3977 .60854 m
.42807 .60404 L
s
.42807 .60404 m
.43167 .60351 L
s
.43167 .60351 m
.43429 .60312 L
s
1 .316 .133 r
.54171 .60073 m .53997 .59686 L .52004 .61497 L p F P
0 0 0 r
s
.24 .35 .67 r
.54049 .61233 m
.54848 .62989 L
s
1 .316 .133 r
.51912 .61304 m .52004 .61497 L .53997 .59686 L p F P
0 0 0 r
s
.281 .415 .817 r
.49336 .61473 m .4969 .61421 L .49381 .59533 L p F P
0 0 0 r
s
.281 .415 .817 r
.49381 .59533 m .48675 .59637 L .49336 .61473 L p F P
0 0 0 r
s
.24 .35 .67 r
.48689 .59533 m
.48725 .5963 L
s
.187 .257 .511 r
.39038 .43706 m .4126 .43324 L .41228 .41222 L p F P
0 0 0 r
s
.187 .257 .511 r
.43472 .4083 m .41228 .41222 L .4126 .43324 L p F P
0 0 0 r
s
.281 .415 .817 r
.4969 .61421 m .50044 .6137 L .50088 .59428 L p F P
0 0 0 r
s
.281 .415 .817 r
.50088 .59428 m .49381 .59533 L .4969 .61421 L p F P
0 0 0 r
s
.13 .166 .335 r
.57058 .36621 m .59346 .36216 L .58882 .34821 L p F P
0 0 0 r
s
.13 .166 .335 r
.61068 .34429 m .58882 .34821 L .59346 .36216 L p F P
0 0 0 r
s
.83 .24 .1 r
.60734 .34776 m
.61763 .3674 L
s
.24 .35 .67 r
.33636 .55555 m
.29251 .56242 L
s
.29251 .56242 m
.2863 .5291 L
s
.83 .24 .1 r
.45114 .60497 m
.47138 .60575 L
s
.365 .111 .056 r
.35631 .54408 m .36178 .55336 L .34227 .53184 L p F P
0 0 0 r
s
.83 .24 .1 r
.3604 .55102 m
.37066 .55981 L
s
.365 .111 .056 r
.34227 .53184 m .33584 .52104 L .35631 .54408 L p F P
0 0 0 r
s
.24 .35 .67 r
.34443 .58713 m
.33636 .55555 L
s
.281 .415 .817 r
.50044 .6137 m .50399 .61318 L .50797 .59323 L p F P
0 0 0 r
s
.281 .415 .817 r
.50797 .59323 m .50088 .59428 L .50044 .6137 L p F P
0 0 0 r
s
.221 .311 .617 r
.32981 .47079 m .30876 .47434 L .31984 .49755 L p F P
0 0 0 r
s
.83 .24 .1 r
.31619 .48753 m
.31712 .4891 L
s
.32073 .49517 m
.32076 .49521 L
s
.30434 .4676 m
.31619 .48753 L
s
.24 .35 .67 r
.28252 .49569 m
.31627 .49008 L
s
1 .332 .137 r
.60359 .55564 m .60011 .5464 L .58319 .56786 L p F P
0 0 0 r
s
.83 .24 .1 r
.59375 .55324 m
.59407 .55406 L
s
1 .332 .137 r
.58319 .56786 m .5862 .5754 L .60359 .55564 L p F P
0 0 0 r
s
.281 .415 .817 r
.50399 .61318 m .50754 .61267 L .51506 .59218 L p F P
0 0 0 r
s
.281 .415 .817 r
.51506 .59218 m .50797 .59323 L .50399 .61318 L p F P
0 0 0 r
s
.163 .218 .437 r
.48 .40039 m .50285 .3964 L .50278 .37822 L p F P
0 0 0 r
s
.163 .218 .437 r
.52525 .37424 m .50278 .37822 L .50285 .3964 L p F P
0 0 0 r
s
1 .316 .133 r
.53997 .59686 m .53821 .59295 L .51912 .61304 L p F P
0 0 0 r
s
1 .316 .133 r
.5182 .61112 m .51912 .61304 L .53821 .59295 L p F P
0 0 0 r
s
.24 .35 .67 r
.52665 .61434 m
.54049 .61233 L
s
1 .329 .137 r
.5641 .58745 m .56652 .59317 L .5862 .5754 L p F P
0 0 0 r
s
1 .324 .136 r
.56652 .59317 m .5641 .58745 L .54344 .60459 L p F P
0 0 0 r
s
.24 .35 .67 r
.54049 .61233 m
.58589 .60576 L
s
.281 .415 .817 r
.50754 .61267 m .51109 .61215 L .52218 .59113 L p F P
0 0 0 r
s
.281 .415 .817 r
.52218 .59113 m .51506 .59218 L .50754 .61267 L p F P
0 0 0 r
s
.83 .24 .1 r
.50812 .60849 m
.50923 .61079 L
s
.50444 .60089 m
.50812 .60849 L
s
.29935 .28084 m
.32265 .25853 L
s
.32265 .25853 m
.30624 .22537 L
s
.24 .35 .67 r
.2863 .5291 m
.33018 .52201 L
s
.998 .282 .11 r
.63281 .44159 m .62825 .42733 L .62432 .45076 L p F P
0 0 0 r
s
.998 .282 .11 r
.62432 .45076 m .62879 .46434 L .63281 .44159 L p F P
0 0 0 r
s
.281 .415 .817 r
.51109 .61215 m .51464 .61163 L .5293 .59007 L p F P
0 0 0 r
s
.281 .415 .817 r
.5293 .59007 m .52218 .59113 L .51109 .61215 L p F P
0 0 0 r
s
1 .329 .137 r
.5862 .5754 m .58319 .56786 L .5641 .58745 L p F P
0 0 0 r
s
1 .324 .136 r
.54171 .60073 m .54344 .60459 L .5641 .58745 L p F P
0 0 0 r
s
.24 .35 .67 r
.82752 .60246 m
.82504 .59053 L
s
.206 .287 .569 r
.35098 .46722 m .37228 .46363 L .36829 .44085 L p F P
0 0 0 r
s
.24 .35 .67 r
.36881 .4438 m
.36886 .44075 L
s
.206 .287 .569 r
.39038 .43706 m .36829 .44085 L .37228 .46363 L p F P
0 0 0 r
s
.281 .415 .817 r
.51464 .61163 m .5182 .61112 L .53644 .58902 L p F P
0 0 0 r
s
.281 .415 .817 r
.53644 .58902 m .5293 .59007 L .51464 .61163 L p F P
0 0 0 r
s
.788 .241 .106 r
.4113 .59175 m .40806 .58601 L .43772 .60363 L p F P
0 0 0 r
s
.24 .35 .67 r
.43635 .60282 m
.44203 .60198 L
s
.65 .203 .092 r
.40806 .58601 m .4113 .59175 L .38502 .57353 L p F P
0 0 0 r
s
.83 .24 .1 r
.44418 .20598 m
.43057 .17158 L
s
.44418 .20598 m
.47619 .2044 L
s
.187 .257 .511 r
.4126 .43324 m .43495 .4294 L .43472 .4083 L p F P
0 0 0 r
s
.187 .257 .511 r
.45729 .40436 m .43472 .4083 L .43495 .4294 L p F P
0 0 0 r
s
.24 .35 .67 r
.45611 .40568 m
.45775 .40539 L
s
.7306 .60397 m
.68424 .61057 L
s
.68424 .61057 m
.67839 .59236 L
s
.273 .4 .789 r
.43772 .60363 m .44468 .6026 L .41831 .58447 L p F P
0 0 0 r
s
.273 .4 .789 r
.41831 .58447 m .40806 .58601 L .43772 .60363 L p F P
0 0 0 r
s
1 .316 .133 r
.53821 .59295 m .53644 .58902 L .5182 .61112 L p F P
0 0 0 r
s
.486 .155 .073 r
.38064 .56596 m .38502 .57353 L .36178 .55336 L p F P
0 0 0 r
s
.486 .155 .073 r
.36178 .55336 m .35631 .54408 L .38064 .56596 L p F P
0 0 0 r
s
.13 .166 .335 r
.59346 .36216 m .61648 .35808 L .61068 .34429 L p F P
0 0 0 r
s
.83 .24 .1 r
.61276 .35185 m
.61337 .35379 L
s
.60804 .33677 m
.61276 .35185 L
s
.24 .35 .67 r
.6869 .34158 m
.68637 .32451 L
s
.73277 .31616 m
.68637 .32451 L
s
.221 .311 .617 r
.31984 .49755 m .3397 .49427 L .32981 .47079 L p F P
0 0 0 r
s
.221 .311 .617 r
.35098 .46722 m .32981 .47079 L .3397 .49427 L p F P
0 0 0 r
s
1 .323 .13 r
.62545 .50058 m .62126 .48831 L .61042 .51279 L p F P
0 0 0 r
s
1 .323 .13 r
.61042 .51279 m .61433 .52374 L .62545 .50058 L p F P
0 0 0 r
s
.65 .203 .092 r
.38502 .57353 m .38064 .56596 L .40806 .58601 L p F P
0 0 0 r
s
.24 .35 .67 r
.3886 .5804 m
.3977 .60854 L
s
.34443 .58713 m
.3886 .5804 L
s
.273 .4 .789 r
.44468 .6026 m .45166 .60157 L .42858 .58291 L p F P
0 0 0 r
s
.24 .35 .67 r
.44347 .60176 m
.44394 .60169 L
s
.273 .4 .789 r
.42858 .58291 m .41831 .58447 L .44468 .6026 L p F P
0 0 0 r
s
.163 .218 .437 r
.50285 .3964 m .52584 .39238 L .52525 .37424 L p F P
0 0 0 r
s
.163 .218 .437 r
.54785 .37024 m .52525 .37424 L .52584 .39238 L p F P
0 0 0 r
s
.855 .238 .09 r
.62871 .40619 m .62404 .3913 L .62359 .41274 L p F P
0 0 0 r
s
.83 .24 .1 r
.62269 .39249 m
.62393 .39644 L
s
.6275 .40775 m
.6286 .41126 L
s
.855 .238 .09 r
.62359 .41274 m .62825 .42733 L .62871 .40619 L p F P
0 0 0 r
s
.273 .4 .789 r
.45166 .60157 m .45865 .60053 L .43888 .58136 L p F P
0 0 0 r
s
.24 .35 .67 r
.4506 .60071 m
.45107 .60064 L
s
.273 .4 .789 r
.43888 .58136 m .42858 .58291 L .45166 .60157 L p F P
0 0 0 r
s
.83 .24 .1 r
.43635 .59878 m
.43715 .60024 L
s
.66 .179 .065 r
.62118 .37317 m .61648 .35808 L .61926 .37606 L p F P
0 0 0 r
s
.83 .24 .1 r
.6148 .35838 m
.61763 .3674 L
s
.61763 .3674 m
.61887 .37358 L
s
.66 .179 .065 r
.61926 .37606 m .62404 .3913 L .62118 .37317 L p F P
0 0 0 r
s
.83 .24 .1 r
.61959 .37711 m
.62269 .39249 L
s
.27914 .38877 m
.28532 .36243 L
s
.28532 .36243 m
.26797 .33157 L
s
.206 .287 .569 r
.37228 .46363 m .39371 .46002 L .39038 .43706 L p F P
0 0 0 r
s
.206 .287 .569 r
.4126 .43324 m .39038 .43706 L .39371 .46002 L p F P
0 0 0 r
s
1 .324 .136 r
.5641 .58745 m .56165 .58166 L .54171 .60073 L p F P
0 0 0 r
s
1 .324 .136 r
.53997 .59686 m .54171 .60073 L .56165 .58166 L p F P
0 0 0 r
s
.24 .35 .67 r
.53621 .5999 m
.54049 .61233 L
s
.53534 .59738 m
.53621 .5999 L
s
.187 .257 .511 r
.43495 .4294 m .45744 .42554 L .45729 .40436 L p F P
0 0 0 r
s
.187 .257 .511 r
.48 .40039 m .45729 .40436 L .45744 .42554 L p F P
0 0 0 r
s
.273 .4 .789 r
.45865 .60053 m .46566 .59949 L .44921 .5798 L p F P
0 0 0 r
s
.24 .35 .67 r
.45774 .59965 m
.45822 .59958 L
s
.273 .4 .789 r
.44921 .5798 m .43888 .58136 L .45865 .60053 L p F P
0 0 0 r
s
.233 .332 .657 r
.3397 .49427 m .31984 .49755 L .33584 .52104 L p F P
0 0 0 r
s
.24 .35 .67 r
.32962 .51723 m
.33018 .52201 L
s
.32889 .511 m
.32962 .51723 L
s
.83 .24 .1 r
.33026 .50934 m
.33291 .51327 L
s
.33291 .51327 m
.33495 .5163 L
s
.24 .35 .67 r
.33636 .55555 m
.36232 .55148 L
s
.36232 .55148 m
.36375 .55125 L
s
.33018 .52201 m
.33636 .55555 L
s
1 .329 .137 r
.56165 .58166 m .5641 .58745 L .58319 .56786 L p F P
0 0 0 r
s
.221 .311 .617 r
.3397 .49427 m .35967 .49098 L .35098 .46722 L p F P
0 0 0 r
s
.221 .311 .617 r
.37228 .46363 m .35098 .46722 L .35967 .49098 L p F P
0 0 0 r
s
.273 .4 .789 r
.46566 .59949 m .47268 .59846 L .45957 .57823 L p F P
0 0 0 r
s
.24 .35 .67 r
.4649 .59859 m
.46538 .59852 L
s
.273 .4 .789 r
.45957 .57823 m .44921 .5798 L .46566 .59949 L p F P
0 0 0 r
s
.163 .218 .437 r
.52584 .39238 m .54898 .38834 L .54785 .37024 L p F P
0 0 0 r
s
.163 .218 .437 r
.57058 .36621 m .54785 .37024 L .54898 .38834 L p F P
0 0 0 r
s
.24 .35 .67 r
.63185 .5991 m
.58589 .60576 L
s
.5783 .58179 m
.58589 .60576 L
s
.83 .24 .1 r
.47138 .60575 m
.50444 .60089 L
s
1 .33 .135 r
.61433 .52374 m .61042 .51279 L .59656 .53701 L p F P
0 0 0 r
s
.83 .24 .1 r
.61343 .52442 m
.61361 .5249 L
s
1 .33 .135 r
.59656 .53701 m .60011 .5464 L .61433 .52374 L p F P
0 0 0 r
s
.83 .24 .1 r
.59375 .55324 m
.60002 .54617 L
s
.54526 .25022 m
.53393 .21667 L
s
.54526 .25022 m
.56823 .26403 L
s
.273 .4 .789 r
.47268 .59846 m .47971 .59741 L .46996 .57666 L p F P
0 0 0 r
s
.24 .35 .67 r
.47207 .59752 m
.47255 .59745 L
s
.273 .4 .789 r
.46996 .57666 m .45957 .57823 L .47268 .59846 L p F P
0 0 0 r
s
.264 .384 .758 r
.40806 .58601 m .41831 .58447 L .39389 .56392 L p F P
0 0 0 r
s
.264 .384 .758 r
.39389 .56392 m .38064 .56596 L .40806 .58601 L p F P
0 0 0 r
s
.83 .24 .1 r
.37759 .56322 m
.38256 .56567 L
s
.24 .35 .67 r
.3886 .5804 m
.39754 .57904 L
s
.38636 .57134 m
.3886 .5804 L
s
.33018 .52201 m
.33579 .52111 L
s
.83 .24 .1 r
.28084 .30548 m
.29935 .28084 L
s
.29935 .28084 m
.28228 .24798 L
s
.30434 .4676 m
.29679 .44363 L
s
.29679 .44363 m
.27966 .41457 L
s
.206 .287 .569 r
.39371 .46002 m .41526 .45639 L .4126 .43324 L p F P
0 0 0 r
s
.206 .287 .569 r
.43495 .4294 m .4126 .43324 L .41526 .45639 L p F P
0 0 0 r
s
.273 .4 .789 r
.47971 .59741 m .48675 .59637 L .48038 .57509 L p F P
0 0 0 r
s
.24 .35 .67 r
.47926 .59646 m
.47974 .59639 L
s
.48646 .59539 m
.48689 .59533 L
s
.273 .4 .789 r
.48038 .57509 m .46996 .57666 L .47971 .59741 L p F P
0 0 0 r
s
.83 .24 .1 r
.45833 .58049 m
.47138 .60575 L
s
.24 .35 .67 r
.61492 .35437 m
.64025 .34987 L
s
1 .332 .137 r
.58013 .56021 m .58319 .56786 L .60011 .5464 L p F P
0 0 0 r
s
1 .329 .137 r
.58319 .56786 m .58013 .56021 L .56165 .58166 L p F P
0 0 0 r
s
1 .308 .123 r
.62879 .46434 m .62432 .45076 L .61699 .47579 L p F P
0 0 0 r
s
1 .308 .123 r
.61699 .47579 m .62126 .48831 L .62879 .46434 L p F P
0 0 0 r
s
.187 .257 .511 r
.45744 .42554 m .48007 .42165 L .48 .40039 L p F P
0 0 0 r
s
.187 .257 .511 r
.50285 .3964 m .48 .40039 L .48007 .42165 L p F P
0 0 0 r
s
.24 .35 .67 r
.50165 .39773 m
.50282 .39752 L
s
.50282 .39752 m
.50286 .3964 L
s
.233 .332 .657 r
.33584 .52104 m .35397 .51811 L .3397 .49427 L p F P
0 0 0 r
s
.83 .24 .1 r
.33759 .52076 m
.34161 .52753 L
s
.233 .332 .657 r
.35967 .49098 m .3397 .49427 L .35397 .51811 L p F P
0 0 0 r
s
.24 .35 .67 r
.77753 .59729 m
.7306 .60397 L
s
.7306 .60397 m
.72549 .58554 L
s
.264 .384 .758 r
.41831 .58447 m .42858 .58291 L .4072 .56186 L p F P
0 0 0 r
s
.83 .24 .1 r
.43526 .59677 m
.43635 .59878 L
s
.264 .384 .758 r
.4072 .56186 m .39389 .56392 L .41831 .58447 L p F P
0 0 0 r
s
.83 .24 .1 r
.39611 .57234 m
.39902 .57747 L
s
.38877 .56873 m
.39611 .57234 L
s
1 .332 .137 r
.60011 .5464 m .59656 .53701 L .58013 .56021 L p F P
0 0 0 r
s
1 .324 .136 r
.56165 .58166 m .55917 .57582 L .53997 .59686 L p F P
0 0 0 r
s
1 .324 .136 r
.53821 .59295 m .53997 .59686 L .55917 .57582 L p F P
0 0 0 r
s
.221 .311 .617 r
.35967 .49098 m .37975 .48766 L .37228 .46363 L p F P
0 0 0 r
s
.221 .311 .617 r
.39371 .46002 m .37228 .46363 L .37975 .48766 L p F P
0 0 0 r
s
.24 .35 .67 r
.73412 .33319 m
.73277 .31616 L
s
.77974 .30771 m
.73277 .31616 L
s
.273 .4 .789 r
.48675 .59637 m .49381 .59533 L .49083 .57351 L p F P
0 0 0 r
s
.24 .35 .67 r
.48689 .59533 m
.48694 .59532 L
s
.273 .4 .789 r
.49083 .57351 m .48038 .57509 L .48675 .59637 L p F P
0 0 0 r
s
.83 .24 .1 r
.47619 .2044 m
.46322 .16971 L
s
.47619 .2044 m
.5065 .20796 L
s
.245 .351 .694 r
.35397 .51811 m .33584 .52104 L .35631 .54408 L p F P
0 0 0 r
s
.83 .24 .1 r
.33495 .5163 m
.33689 .51957 L
s
.33689 .51957 m
.33697 .51971 L
s
.163 .218 .437 r
.54898 .38834 m .57226 .38427 L .57058 .36621 L p F P
0 0 0 r
s
.163 .218 .437 r
.59346 .36216 m .57058 .36621 L .57226 .38427 L p F P
0 0 0 r
s
.255 .368 .727 r
.38064 .56596 m .39389 .56392 L .37222 .54157 L p F P
0 0 0 r
s
.255 .368 .727 r
.37222 .54157 m .35631 .54408 L .38064 .56596 L p F P
0 0 0 r
s
.83 .24 .1 r
.36441 .54912 m
.3649 .54995 L
s
.264 .384 .758 r
.42858 .58291 m .43888 .58136 L .42055 .5598 L p F P
0 0 0 r
s
.264 .384 .758 r
.42055 .5598 m .4072 .56186 L .42858 .58291 L p F P
0 0 0 r
s
.273 .4 .789 r
.49381 .59533 m .50088 .59428 L .5013 .57193 L p F P
0 0 0 r
s
.24 .35 .67 r
.49367 .59432 m
.49415 .59425 L
s
.273 .4 .789 r
.5013 .57193 m .49083 .57351 L .49381 .59533 L p F P
0 0 0 r
s
.83 .24 .1 r
.59631 .31454 m
.58614 .28238 L
s
.59631 .31454 m
.60804 .33677 L
s
.245 .351 .694 r
.35631 .54408 m .37222 .54157 L .35397 .51811 L p F P
0 0 0 r
s
.273 .4 .789 r
.50088 .59428 m .50797 .59323 L .51181 .57034 L p F P
0 0 0 r
s
.24 .35 .67 r
.5009 .59325 m
.50138 .59318 L
s
.273 .4 .789 r
.51181 .57034 m .5013 .57193 L .50088 .59428 L p F P
0 0 0 r
s
.206 .287 .569 r
.41526 .45639 m .43694 .45273 L .43495 .4294 L p F P
0 0 0 r
s
.206 .287 .569 r
.45744 .42554 m .43495 .4294 L .43694 .45273 L p F P
0 0 0 r
s
1 .329 .137 r
.55917 .57582 m .56165 .58166 L .58013 .56021 L p F P
0 0 0 r
s
.233 .332 .657 r
.35397 .51811 m .3722 .51517 L .35967 .49098 L p F P
0 0 0 r
s
.233 .332 .657 r
.37975 .48766 m .35967 .49098 L .3722 .51517 L p F P
0 0 0 r
s
.24 .35 .67 r
.37389 .509 m
.37459 .51484 L
s
.83 .24 .1 r
.50444 .60089 m
.52158 .59521 L
s
.52158 .59521 m
.52502 .59407 L
s
.49211 .57539 m
.50444 .60089 L
s
.264 .384 .758 r
.43888 .58136 m .44921 .5798 L .43395 .55773 L p F P
0 0 0 r
s
.264 .384 .758 r
.43395 .55773 m .42055 .5598 L .43888 .58136 L p F P
0 0 0 r
s
.187 .257 .511 r
.48007 .42165 m .50284 .41774 L .50285 .3964 L p F P
0 0 0 r
s
.187 .257 .511 r
.52584 .39238 m .50285 .3964 L .50284 .41774 L p F P
0 0 0 r
s
.245 .351 .694 r
.3722 .51517 m .35397 .51811 L .37222 .54157 L p F P
0 0 0 r
s
.83 .24 .1 r
.35535 .5336 m
.36441 .54912 L
s
.255 .368 .727 r
.39389 .56392 m .4072 .56186 L .3882 .53905 L p F P
0 0 0 r
s
.255 .368 .727 r
.3882 .53905 m .37222 .54157 L .39389 .56392 L p F P
0 0 0 r
s
.221 .311 .617 r
.37975 .48766 m .39994 .48433 L .39371 .46002 L p F P
0 0 0 r
s
.221 .311 .617 r
.41526 .45639 m .39371 .46002 L .39994 .48433 L p F P
0 0 0 r
s
.273 .4 .789 r
.50797 .59323 m .51506 .59218 L .52235 .56875 L p F P
0 0 0 r
s
.24 .35 .67 r
.50814 .59218 m
.50863 .59211 L
s
.273 .4 .789 r
.52235 .56875 m .51181 .57034 L .50797 .59323 L p F P
0 0 0 r
s
.83 .24 .1 r
.33495 .5163 m
.35535 .5336 L
s
.33495 .5163 m
.31863 .48881 L
s
1 .324 .136 r
.55917 .57582 m .55667 .56992 L .53821 .59295 L p F P
0 0 0 r
s
1 .324 .136 r
.53644 .58902 m .53821 .59295 L .55667 .56992 L p F P
0 0 0 r
s
.998 .282 .11 r
.62825 .42733 m .62359 .41274 L .61976 .43689 L p F P
0 0 0 r
s
.998 .282 .11 r
.61976 .43689 m .62432 .45076 L .62825 .42733 L p F P
0 0 0 r
s
.163 .218 .437 r
.57226 .38427 m .59568 .38018 L .59346 .36216 L p F P
0 0 0 r
s
.163 .218 .437 r
.61648 .35808 m .59346 .36216 L .59568 .38018 L p F P
0 0 0 r
s
.264 .384 .758 r
.44921 .5798 m .45957 .57823 L .4474 .55566 L p F P
0 0 0 r
s
.264 .384 .758 r
.4474 .55566 m .43395 .55773 L .44921 .5798 L p F P
0 0 0 r
s
.83 .24 .1 r
.42579 .57941 m
.43526 .59677 L
s
.245 .351 .694 r
.37222 .54157 m .3882 .53905 L .3722 .51517 L p F P
0 0 0 r
s
.24 .35 .67 r
.37459 .51484 m
.37557 .5202 L
s
.37223 .51522 m
.37459 .51484 L
s
.273 .4 .789 r
.51506 .59218 m .52218 .59113 L .53292 .56716 L p F P
0 0 0 r
s
.24 .35 .67 r
.5154 .5911 m
.51588 .59103 L
s
.273 .4 .789 r
.53292 .56716 m .52235 .56875 L .51506 .59218 L p F P
0 0 0 r
s
.24 .35 .67 r
.67839 .59236 m
.63185 .5991 L
s
.63185 .5991 m
.62485 .57489 L
s
.83 .24 .1 r
.39611 .57234 m
.42579 .57941 L
s
1 .323 .13 r
.62126 .48831 m .61699 .47579 L .60642 .50163 L p F P
0 0 0 r
s
1 .323 .13 r
.60642 .50163 m .61042 .51279 L .62126 .48831 L p F P
0 0 0 r
s
.255 .368 .727 r
.4072 .56186 m .42055 .5598 L .40425 .53651 L p F P
0 0 0 r
s
.255 .368 .727 r
.40425 .53651 m .3882 .53905 L .4072 .56186 L p F P
0 0 0 r
s
.83 .24 .1 r
.38121 .54613 m
.39611 .57234 L
s
.273 .4 .789 r
.52218 .59113 m .5293 .59007 L .54351 .56556 L p F P
0 0 0 r
s
.24 .35 .67 r
.52267 .59003 m
.52315 .58996 L
s
.273 .4 .789 r
.54351 .56556 m .53292 .56716 L .52218 .59113 L p F P
0 0 0 r
s
.24 .35 .67 r
.53231 .5886 m
.53265 .58958 L
s
.52995 .58895 m
.53231 .5886 L
s
.233 .332 .657 r
.3722 .51517 m .39051 .51221 L .37975 .48766 L p F P
0 0 0 r
s
.233 .332 .657 r
.39994 .48433 m .37975 .48766 L .39051 .51221 L p F P
0 0 0 r
s
.206 .287 .569 r
.43694 .45273 m .45875 .44905 L .45744 .42554 L p F P
0 0 0 r
s
.206 .287 .569 r
.48007 .42165 m .45744 .42554 L .45875 .44905 L p F P
0 0 0 r
s
.245 .351 .694 r
.39051 .51221 m .3722 .51517 L .3882 .53905 L p F P
0 0 0 r
s
.264 .384 .758 r
.45957 .57823 m .46996 .57666 L .4609 .55357 L p F P
0 0 0 r
s
.264 .384 .758 r
.4609 .55357 m .4474 .55566 L .45957 .57823 L p F P
0 0 0 r
s
.24 .35 .67 r
.6414 .37334 m
.64025 .34987 L
s
.6869 .34158 m
.64025 .34987 L
s
.187 .257 .511 r
.50284 .41774 m .52575 .4138 L .52584 .39238 L p F P
0 0 0 r
s
.187 .257 .511 r
.54898 .38834 m .52584 .39238 L .52575 .4138 L p F P
0 0 0 r
s
.24 .35 .67 r
.54776 .38968 m
.54844 .38956 L
s
.54844 .38956 m
.54845 .38892 L
s
.82504 .59053 m
.77753 .59729 L
s
.77753 .59729 m
.77319 .57863 L
s
.221 .311 .617 r
.39994 .48433 m .42024 .48097 L .41526 .45639 L p F P
0 0 0 r
s
.221 .311 .617 r
.43694 .45273 m .41526 .45639 L .42024 .48097 L p F P
0 0 0 r
s
.273 .4 .789 r
.5293 .59007 m .53644 .58902 L .55414 .56395 L p F P
0 0 0 r
s
.83 .24 .1 r
.53646 .58898 m
.53647 .58899 L
s
.273 .4 .789 r
.55414 .56395 m .54351 .56556 L .5293 .59007 L p F P
0 0 0 r
s
.83 .24 .1 r
.53432 .58421 m
.53499 .58571 L
s
.24 .35 .67 r
.53725 .58787 m
.53773 .5878 L
s
.245 .351 .694 r
.3882 .53905 m .40425 .53651 L .39051 .51221 L p F P
0 0 0 r
s
1 .332 .137 r
.57703 .55245 m .58013 .56021 L .59656 .53701 L p F P
0 0 0 r
s
1 .329 .137 r
.58013 .56021 m .57703 .55245 L .55917 .57582 L p F P
0 0 0 r
s
.24 .35 .67 r
.78194 .32469 m
.77974 .30771 L
s
.855 .238 .09 r
.62404 .3913 m .61926 .37606 L .61882 .39781 L p F P
0 0 0 r
s
.855 .238 .09 r
.61882 .39781 m .62359 .41274 L .62404 .3913 L p F P
0 0 0 r
s
.255 .368 .727 r
.42055 .5598 m .43395 .55773 L .42037 .53397 L p F P
0 0 0 r
s
.255 .368 .727 r
.42037 .53397 m .40425 .53651 L .42055 .5598 L p F P
0 0 0 r
s
.264 .384 .758 r
.46996 .57666 m .48038 .57509 L .47445 .55148 L p F P
0 0 0 r
s
.264 .384 .758 r
.47445 .55148 m .4609 .55357 L .46996 .57666 L p F P
0 0 0 r
s
1 .324 .136 r
.55667 .56992 m .55414 .56395 L .53644 .58902 L p F P
0 0 0 r
s
.24 .35 .67 r
.54026 .58742 m
.5783 .58179 L
s
.163 .218 .437 r
.59568 .38018 m .61926 .37606 L .61648 .35808 L p F P
0 0 0 r
s
.83 .24 .1 r
.61309 .36202 m
.61674 .37362 L
s
1 .33 .135 r
.61042 .51279 m .60642 .50163 L .59296 .52746 L p F P
0 0 0 r
s
.83 .24 .1 r
.60547 .50223 m
.60573 .50296 L
s
.60953 .51354 m
.60971 .51403 L
s
1 .33 .135 r
.59296 .52746 m .59656 .53701 L .61042 .51279 L p F P
0 0 0 r
s
1 .329 .137 r
.55667 .56992 m .55917 .57582 L .57703 .55245 L p F P
0 0 0 r
s
.233 .332 .657 r
.39051 .51221 m .40891 .50924 L .39994 .48433 L p F P
0 0 0 r
s
.233 .332 .657 r
.42024 .48097 m .39994 .48433 L .40891 .50924 L p F P
0 0 0 r
s
.245 .351 .694 r
.40891 .50924 m .39051 .51221 L .40425 .53651 L p F P
0 0 0 r
s
.83 .24 .1 r
.26797 .33157 m
.28084 .30548 L
s
.28084 .30548 m
.26318 .27289 L
s
1 .332 .137 r
.59656 .53701 m .59296 .52746 L .57703 .55245 L p F P
0 0 0 r
s
.264 .384 .758 r
.48038 .57509 m .49083 .57351 L .48805 .54938 L p F P
0 0 0 r
s
.264 .384 .758 r
.48805 .54938 m .47445 .55148 L .48038 .57509 L p F P
0 0 0 r
s
.206 .287 .569 r
.45875 .44905 m .48068 .44536 L .48007 .42165 L p F P
0 0 0 r
s
.206 .287 .569 r
.50284 .41774 m .48007 .42165 L .48068 .44536 L p F P
0 0 0 r
s
.245 .351 .694 r
.40425 .53651 m .42037 .53397 L .40891 .50924 L p F P
0 0 0 r
s
.255 .368 .727 r
.43395 .55773 m .4474 .55566 L .43656 .53141 L p F P
0 0 0 r
s
.255 .368 .727 r
.43656 .53141 m .42037 .53397 L .43395 .55773 L p F P
0 0 0 r
s
.83 .24 .1 r
.26143 .35813 m
.27914 .38877 L
s
.27966 .41457 m
.27914 .38877 L
s
.187 .257 .511 r
.52575 .4138 m .5488 .40984 L .54898 .38834 L p F P
0 0 0 r
s
.187 .257 .511 r
.57226 .38427 m .54898 .38834 L .5488 .40984 L p F P
0 0 0 r
s
.221 .311 .617 r
.42024 .48097 m .44066 .4776 L .43694 .45273 L p F P
0 0 0 r
s
.221 .311 .617 r
.45875 .44905 m .43694 .45273 L .44066 .4776 L p F P
0 0 0 r
s
.264 .384 .758 r
.49083 .57351 m .5013 .57193 L .5017 .54728 L p F P
0 0 0 r
s
.264 .384 .758 r
.5017 .54728 m .48805 .54938 L .49083 .57351 L p F P
0 0 0 r
s
.83 .24 .1 r
.5065 .20796 m
.49412 .17302 L
s
.5065 .20796 m
.53393 .21667 L
s
.36485 .19001 m
.33411 .20583 L
s
.39739 .17845 m
.36485 .19001 L
s
.255 .368 .727 r
.4474 .55566 m .4609 .55357 L .45283 .52884 L p F P
0 0 0 r
s
.255 .368 .727 r
.45283 .52884 m .43656 .53141 L .4474 .55566 L p F P
0 0 0 r
s
.24 .35 .67 r
.72549 .58554 m
.67839 .59236 L
s
.67839 .59236 m
.67199 .5679 L
s
.245 .351 .694 r
.42741 .50625 m .40891 .50924 L .42037 .53397 L p F P
0 0 0 r
s
.24 .35 .67 r
.42268 .5249 m
.4242 .53336 L
s
.233 .332 .657 r
.40891 .50924 m .42741 .50625 L .42024 .48097 L p F P
0 0 0 r
s
1 .308 .123 r
.62432 .45076 m .61976 .43689 L .61262 .463 L p F P
0 0 0 r
s
1 .308 .123 r
.61262 .463 m .61699 .47579 L .62432 .45076 L p F P
0 0 0 r
s
.245 .351 .694 r
.42037 .53397 m .43656 .53141 L .42741 .50625 L p F P
0 0 0 r
s
.233 .332 .657 r
.44066 .4776 m .42024 .48097 L .42741 .50625 L p F P
0 0 0 r
s
.83 .24 .1 r
.56823 .26403 m
.5573 .23037 L
s
.56823 .26403 m
.58614 .28238 L
s
.264 .384 .758 r
.5013 .57193 m .51181 .57034 L .5154 .54516 L p F P
0 0 0 r
s
.264 .384 .758 r
.5154 .54516 m .5017 .54728 L .5013 .57193 L p F P
0 0 0 r
s
.83 .24 .1 r
.33411 .20583 m
.30624 .22537 L
s
.206 .287 .569 r
.48068 .44536 m .50275 .44164 L .50284 .41774 L p F P
0 0 0 r
s
.206 .287 .569 r
.52575 .4138 m .50284 .41774 L .50275 .44164 L p F P
0 0 0 r
s
.24 .35 .67 r
.68875 .36507 m
.6869 .34158 L
s
.73412 .33319 m
.6869 .34158 L
s
.83 .24 .1 r
.43057 .17158 m
.39739 .17845 L
s
.24 .35 .67 r
.5783 .58179 m
.62485 .57489 L
s
.221 .311 .617 r
.44066 .4776 m .46118 .47421 L .45875 .44905 L p F P
0 0 0 r
s
.221 .311 .617 r
.48068 .44536 m .45875 .44905 L .46118 .47421 L p F P
0 0 0 r
s
.187 .257 .511 r
.5488 .40984 m .572 .40585 L .57226 .38427 L p F P
0 0 0 r
s
.187 .257 .511 r
.59568 .38018 m .57226 .38427 L .572 .40585 L p F P
0 0 0 r
s
.24 .35 .67 r
.59444 .38153 m
.59463 .3815 L
s
.59463 .38133 m
.59463 .3815 L
s
.82504 .59053 m
.82149 .57164 L
s
.255 .368 .727 r
.4609 .55357 m .47445 .55148 L .46916 .52626 L p F P
0 0 0 r
s
.255 .368 .727 r
.46916 .52626 m .45283 .52884 L .4609 .55357 L p F P
0 0 0 r
s
.264 .384 .758 r
.51181 .57034 m .52235 .56875 L .52915 .54304 L p F P
0 0 0 r
s
.83 .24 .1 r
.53339 .58215 m
.53432 .58421 L
s
.264 .384 .758 r
.52915 .54304 m .5154 .54516 L .51181 .57034 L p F P
0 0 0 r
s
.83 .24 .1 r
.31863 .48881 m
.30434 .4676 L
s
.30434 .4676 m
.28714 .43869 L
s
.245 .351 .694 r
.43656 .53141 m .45283 .52884 L .44601 .50325 L p F P
0 0 0 r
s
.245 .351 .694 r
.44601 .50325 m .42741 .50625 L .43656 .53141 L p F P
0 0 0 r
s
1 .329 .137 r
.57703 .55245 m .57389 .54459 L .55667 .56992 L p F P
0 0 0 r
s
1 .329 .137 r
.55414 .56395 m .55667 .56992 L .57389 .54459 L p F P
0 0 0 r
s
.233 .332 .657 r
.42741 .50625 m .44601 .50325 L .44066 .4776 L p F P
0 0 0 r
s
1 .332 .137 r
.57389 .54459 m .57703 .55245 L .59296 .52746 L p F P
0 0 0 r
s
.233 .332 .657 r
.46118 .47421 m .44066 .4776 L .44601 .50325 L p F P
0 0 0 r
s
.83 .24 .1 r
.45833 .58049 m
.42579 .57941 L
s
.42579 .57941 m
.41145 .55311 L
s
.264 .384 .758 r
.52235 .56875 m .53292 .56716 L .54295 .54091 L p F P
0 0 0 r
s
.264 .384 .758 r
.54295 .54091 m .52915 .54304 L .52235 .56875 L p F P
0 0 0 r
s
.255 .368 .727 r
.47445 .55148 m .48805 .54938 L .48557 .52367 L p F P
0 0 0 r
s
.255 .368 .727 r
.48557 .52367 m .46916 .52626 L .47445 .55148 L p F P
0 0 0 r
s
.24 .35 .67 r
.6196 .37714 m
.6414 .37334 L
s
.206 .287 .569 r
.50275 .44164 m .52495 .43789 L .52575 .4138 L p F P
0 0 0 r
s
.206 .287 .569 r
.5488 .40984 m .52575 .4138 L .52495 .43789 L p F P
0 0 0 r
s
.221 .311 .617 r
.46118 .47421 m .48183 .47081 L .48068 .44536 L p F P
0 0 0 r
s
.221 .311 .617 r
.50275 .44164 m .48068 .44536 L .48183 .47081 L p F P
0 0 0 r
s
1 .323 .13 r
.61699 .47579 m .61262 .463 L .60236 .49026 L p F P
0 0 0 r
s
1 .323 .13 r
.60236 .49026 m .60642 .50163 L .61699 .47579 L p F P
0 0 0 r
s
.83 .24 .1 r
.60547 .50223 m
.6062 .50101 L
s
.245 .351 .694 r
.45283 .52884 m .46916 .52626 L .46469 .50023 L p F P
0 0 0 r
s
.245 .351 .694 r
.46469 .50023 m .44601 .50325 L .45283 .52884 L p F P
0 0 0 r
s
.187 .257 .511 r
.572 .40585 m .59534 .40184 L .59568 .38018 L p F P
0 0 0 r
s
.187 .257 .511 r
.61926 .37606 m .59568 .38018 L .59534 .40184 L p F P
0 0 0 r
s
.24 .35 .67 r
.618 .37742 m
.61923 .3772 L
s
.83 .24 .1 r
.61795 .37747 m
.61915 .38127 L
s
.60804 .33677 m
.598 .30468 L
s
.60804 .33677 m
.61309 .36202 L
s
.30624 .22537 m
.28228 .24798 L
s
.998 .282 .11 r
.62359 .41274 m .61882 .39781 L .6151 .42269 L p F P
0 0 0 r
s
.998 .282 .11 r
.6151 .42269 m .61976 .43689 L .62359 .41274 L p F P
0 0 0 r
s
.264 .384 .758 r
.53292 .56716 m .54351 .56556 L .55681 .53877 L p F P
0 0 0 r
s
.264 .384 .758 r
.55681 .53877 m .54295 .54091 L .53292 .56716 L p F P
0 0 0 r
s
.83 .24 .1 r
.52537 .56431 m
.53339 .58215 L
s
.233 .332 .657 r
.44601 .50325 m .46469 .50023 L .46118 .47421 L p F P
0 0 0 r
s
.255 .368 .727 r
.48805 .54938 m .5017 .54728 L .50205 .52107 L p F P
0 0 0 r
s
.255 .368 .727 r
.50205 .52107 m .48557 .52367 L .48805 .54938 L p F P
0 0 0 r
s
.83 .24 .1 r
.38121 .54613 m
.35535 .5336 L
s
.35535 .5336 m
.3393 .50615 L
s
.46322 .16971 m
.43057 .17158 L
s
.233 .332 .657 r
.48183 .47081 m .46118 .47421 L .46469 .50023 L p F P
0 0 0 r
s
.24 .35 .67 r
.46501 .49968 m
.46508 .50023 L
s
.46508 .50023 m
.4697 .52618 L
s
.4647 .50029 m
.46508 .50023 L
s
1 .33 .135 r
.5893 .51776 m .59296 .52746 L .60642 .50163 L p F P
0 0 0 r
s
.83 .24 .1 r
.60381 .50409 m
.60547 .50223 L
s
1 .332 .137 r
.59296 .52746 m .5893 .51776 L .57389 .54459 L p F P
0 0 0 r
s
.24 .35 .67 r
.77319 .57863 m
.72549 .58554 L
s
.72549 .58554 m
.71972 .56083 L
s
.264 .384 .758 r
.54351 .56556 m .55414 .56395 L .57071 .53663 L p F P
0 0 0 r
s
.264 .384 .758 r
.57071 .53663 m .55681 .53877 L .54351 .56556 L p F P
0 0 0 r
s
1 .33 .135 r
.60642 .50163 m .60236 .49026 L .5893 .51776 L p F P
0 0 0 r
s
.245 .351 .694 r
.46916 .52626 m .48557 .52367 L .48347 .4972 L p F P
0 0 0 r
s
.245 .351 .694 r
.48347 .4972 m .46469 .50023 L .46916 .52626 L p F P
0 0 0 r
s
.206 .287 .569 r
.52495 .43789 m .54729 .43413 L .5488 .40984 L p F P
0 0 0 r
s
.206 .287 .569 r
.572 .40585 m .5488 .40984 L .54729 .43413 L p F P
0 0 0 r
s
.255 .368 .727 r
.5017 .54728 m .5154 .54516 L .51861 .51846 L p F P
0 0 0 r
s
.255 .368 .727 r
.51861 .51846 m .50205 .52107 L .5017 .54728 L p F P
0 0 0 r
s
.24 .35 .67 r
.7367 .3567 m
.73412 .33319 L
s
.78194 .32469 m
.73412 .33319 L
s
.221 .311 .617 r
.48183 .47081 m .50259 .46738 L .50275 .44164 L p F P
0 0 0 r
s
.221 .311 .617 r
.52495 .43789 m .50275 .44164 L .50259 .46738 L p F P
0 0 0 r
s
.24 .35 .67 r
.67199 .5679 m
.62485 .57489 L
s
.62485 .57489 m
.61779 .54552 L
s
.233 .332 .657 r
.46469 .50023 m .48347 .4972 L .48183 .47081 L p F P
0 0 0 r
s
1 .329 .137 r
.57389 .54459 m .57071 .53663 L .55414 .56395 L p F P
0 0 0 r
s
.24 .35 .67 r
.56144 .5541 m
.57081 .55267 L
s
.83 .24 .1 r
.55639 .5478 m
.55862 .55315 L
s
.24 .35 .67 r
.57081 .55267 m
.5783 .58179 L
s
.187 .257 .511 r
.59534 .40184 m .61882 .39781 L .61926 .37606 L p F P
0 0 0 r
s
.83 .24 .1 r
.61674 .37362 m
.6176 .37635 L
s
.233 .332 .657 r
.50259 .46738 m .48183 .47081 L .48347 .4972 L p F P
0 0 0 r
s
.83 .24 .1 r
.26143 .35813 m
.26797 .33157 L
s
.26797 .33157 m
.2498 .29923 L
s
.245 .351 .694 r
.48557 .52367 m .50205 .52107 L .50235 .49415 L p F P
0 0 0 r
s
.245 .351 .694 r
.50235 .49415 m .48347 .4972 L .48557 .52367 L p F P
0 0 0 r
s
.255 .368 .727 r
.5154 .54516 m .52915 .54304 L .53524 .51583 L p F P
0 0 0 r
s
.255 .368 .727 r
.53524 .51583 m .51861 .51846 L .5154 .54516 L p F P
0 0 0 r
s
1 .332 .137 r
.57071 .53663 m .57389 .54459 L .5893 .51776 L p F P
0 0 0 r
s
.24 .35 .67 r
.6414 .37334 m
.68875 .36507 L
s
.64398 .40217 m
.6414 .37334 L
s
.233 .332 .657 r
.48347 .4972 m .50235 .49415 L .50259 .46738 L p F P
0 0 0 r
s
.206 .287 .569 r
.54729 .43413 m .56976 .43034 L .572 .40585 L p F P
0 0 0 r
s
.206 .287 .569 r
.59534 .40184 m .572 .40585 L .56976 .43034 L p F P
0 0 0 r
s
.221 .311 .617 r
.50259 .46738 m .52346 .46393 L .52495 .43789 L p F P
0 0 0 r
s
.221 .311 .617 r
.54729 .43413 m .52495 .43789 L .52346 .46393 L p F P
0 0 0 r
s
.83 .24 .1 r
.49211 .57539 m
.45833 .58049 L
s
.45833 .58049 m
.44466 .55402 L
s
.53393 .21667 m
.52206 .18153 L
s
.53393 .21667 m
.5573 .23037 L
s
.255 .368 .727 r
.52915 .54304 m .54295 .54091 L .55194 .5132 L p F P
0 0 0 r
s
.255 .368 .727 r
.55194 .5132 m .53524 .51583 L .52915 .54304 L p F P
0 0 0 r
s
1 .308 .123 r
.61976 .43689 m .6151 .42269 L .60816 .44995 L p F P
0 0 0 r
s
1 .308 .123 r
.60816 .44995 m .61262 .463 L .61976 .43689 L p F P
0 0 0 r
s
.245 .351 .694 r
.50205 .52107 m .51861 .51846 L .52133 .49108 L p F P
0 0 0 r
s
.245 .351 .694 r
.52133 .49108 m .50235 .49415 L .50205 .52107 L p F P
0 0 0 r
s
.233 .332 .657 r
.52346 .46393 m .50259 .46738 L .50235 .49415 L p F P
0 0 0 r
s
.24 .35 .67 r
.57081 .55267 m
.61779 .54552 L
s
.56913 .54476 m
.57081 .55267 L
s
.56883 .54333 m
.56913 .54476 L
s
.83 .24 .1 r
.28228 .24798 m
.26318 .27289 L
s
.55639 .5478 m
.56419 .54175 L
s
.28714 .43869 m
.27966 .41457 L
s
.27966 .41457 m
.26172 .38411 L
s
.24 .35 .67 r
.82149 .57164 m
.77319 .57863 L
s
.77319 .57863 m
.76805 .55367 L
s
.233 .332 .657 r
.50235 .49415 m .52133 .49108 L .52346 .46393 L p F P
0 0 0 r
s
.255 .368 .727 r
.54295 .54091 m .55681 .53877 L .56872 .51055 L p F P
0 0 0 r
s
.255 .368 .727 r
.56872 .51055 m .55194 .5132 L .54295 .54091 L p F P
0 0 0 r
s
.83 .24 .1 r
.49412 .17302 m
.46322 .16971 L
s
.206 .287 .569 r
.56976 .43034 m .59236 .42653 L .59534 .40184 L p F P
0 0 0 r
s
.206 .287 .569 r
.61882 .39781 m .59534 .40184 L .59236 .42653 L p F P
0 0 0 r
s
.221 .311 .617 r
.52346 .46393 m .54446 .46046 L .54729 .43413 L p F P
0 0 0 r
s
.221 .311 .617 r
.56976 .43034 m .54729 .43413 L .54446 .46046 L p F P
0 0 0 r
s
.24 .35 .67 r
.55258 .45079 m
.55312 .4507 L
s
.55307 .45021 m
.55312 .4507 L
s
.245 .351 .694 r
.51861 .51846 m .53524 .51583 L .5404 .488 L p F P
0 0 0 r
s
.245 .351 .694 r
.5404 .488 m .52133 .49108 L .51861 .51846 L p F P
0 0 0 r
s
.24 .35 .67 r
.78526 .34823 m
.78194 .32469 L
s
.71972 .56083 m
.67199 .5679 L
s
.67199 .5679 m
.66537 .53828 L
s
.83 .24 .1 r
.58614 .28238 m
.57548 .24869 L
s
.58614 .28238 m
.598 .30468 L
s
1 .33 .135 r
.58558 .50788 m .5893 .51776 L .60236 .49026 L p F P
0 0 0 r
s
1 .332 .137 r
.5893 .51776 m .58558 .50788 L .57071 .53663 L p F P
0 0 0 r
s
.233 .332 .657 r
.54446 .46046 m .52346 .46393 L .52133 .49108 L p F P
0 0 0 r
s
.255 .368 .727 r
.55681 .53877 m .57071 .53663 L .58558 .50788 L p F P
0 0 0 r
s
.255 .368 .727 r
.58558 .50788 m .56872 .51055 L .55681 .53877 L p F P
0 0 0 r
s
1 .323 .13 r
.61262 .463 m .60816 .44995 L .59821 .47867 L p F P
0 0 0 r
s
1 .323 .13 r
.59821 .47867 m .60236 .49026 L .61262 .463 L p F P
0 0 0 r
s
.24 .35 .67 r
.61921 .4064 m
.64398 .40217 L
s
.83 .24 .1 r
.52537 .56431 m
.49211 .57539 L
s
.49211 .57539 m
.47918 .54868 L
s
.233 .332 .657 r
.52133 .49108 m .5404 .488 L .54446 .46046 L p F P
0 0 0 r
s
.83 .24 .1 r
.545 .52041 m
.55639 .5478 L
s
.52537 .56431 m
.55639 .5478 L
s
.245 .351 .694 r
.53524 .51583 m .55194 .5132 L .55957 .48491 L p F P
0 0 0 r
s
.245 .351 .694 r
.55957 .48491 m .5404 .488 L .53524 .51583 L p F P
0 0 0 r
s
1 .33 .135 r
.60236 .49026 m .59821 .47867 L .58558 .50788 L p F P
0 0 0 r
s
.83 .24 .1 r
.3393 .50615 m
.31863 .48881 L
s
.31863 .48881 m
.30154 .45999 L
s
.24 .35 .67 r
.68875 .36507 m
.7367 .3567 L
s
.6919 .394 m
.68875 .36507 L
s
.221 .311 .617 r
.54446 .46046 m .56557 .45698 L .56976 .43034 L p F P
0 0 0 r
s
.221 .311 .617 r
.59236 .42653 m .56976 .43034 L .56557 .45698 L p F P
0 0 0 r
s
.206 .287 .569 r
.59236 .42653 m .6151 .42269 L .61882 .39781 L p F P
0 0 0 r
s
.24 .35 .67 r
.61788 .40663 m
.61921 .4064 L
s
.83 .24 .1 r
.6161 .4052 m
.61637 .40605 L
s
.61094 .38925 m
.6161 .4052 L
s
.52537 .56431 m
.51322 .53729 L
s
.233 .332 .657 r
.56557 .45698 m .54446 .46046 L .5404 .488 L p F P
0 0 0 r
s
.83 .24 .1 r
.41145 .55311 m
.38121 .54613 L
s
.38121 .54613 m
.3656 .51866 L
s
.24 .35 .67 r
.58331 .51684 m
.61108 .51249 L
s
.5818 .51708 m
.58331 .51684 L
s
.66537 .53828 m
.61779 .54552 L
s
.61779 .54552 m
.61108 .51249 L
s
.233 .332 .657 r
.5404 .488 m .55957 .48491 L .56557 .45698 L p F P
0 0 0 r
s
.245 .351 .694 r
.55194 .5132 m .56872 .51055 L .57884 .48179 L p F P
0 0 0 r
s
.83 .24 .1 r
.57918 .51539 m
.57952 .51628 L
s
.245 .351 .694 r
.57884 .48179 m .55957 .48491 L .55194 .5132 L p F P
0 0 0 r
s
.83 .24 .1 r
.61309 .36202 m
.60302 .33009 L
s
.61309 .36202 m
.61094 .38925 L
s
.24 .35 .67 r
.82149 .57164 m
.817 .54642 L
s
.221 .311 .617 r
.56557 .45698 m .58681 .45347 L .59236 .42653 L p F P
0 0 0 r
s
.221 .311 .617 r
.6151 .42269 m .59236 .42653 L .58681 .45347 L p F P
0 0 0 r
s
.24 .35 .67 r
.59589 .44359 m
.60021 .44288 L
s
.59983 .43931 m
.60021 .44288 L
s
.233 .332 .657 r
.58681 .45347 m .56557 .45698 L .55957 .48491 L p F P
0 0 0 r
s
.24 .35 .67 r
.76805 .55367 m
.71972 .56083 L
s
.71972 .56083 m
.71356 .53094 L
s
.245 .351 .694 r
.56872 .51055 m .58558 .50788 L .59821 .47867 L p F P
0 0 0 r
s
.245 .351 .694 r
.59821 .47867 m .57884 .48179 L .56872 .51055 L p F P
0 0 0 r
s
.83 .24 .1 r
.57285 .49894 m
.57918 .51539 L
s
.233 .332 .657 r
.55957 .48491 m .57884 .48179 L .58681 .45347 L p F P
0 0 0 r
s
.83 .24 .1 r
.26318 .27289 m
.2498 .29923 L
s
.24 .35 .67 r
.6479 .43495 m
.64398 .40217 L
s
.6919 .394 m
.64398 .40217 L
s
.83 .24 .1 r
.24286 .32601 m
.26143 .35813 L
s
.26172 .38411 m
.26143 .35813 L
s
.24 .35 .67 r
.7367 .3567 m
.78526 .34823 L
s
.74043 .38571 m
.7367 .3567 L
s
.221 .311 .617 r
.58681 .45347 m .60816 .44995 L .6151 .42269 L p F P
0 0 0 r
s
.24 .35 .67 r
.6109 .4411 m
.61364 .44064 L
s
.61364 .44064 m
.6479 .43495 L
s
.83 .24 .1 r
.60143 .41721 m
.6093 .4405 L
s
.52206 .18153 m
.49412 .17302 L
s
.233 .332 .657 r
.60816 .44995 m .58681 .45347 L .57884 .48179 L p F P
0 0 0 r
s
.233 .332 .657 r
.57884 .48179 m .59821 .47867 L .60816 .44995 L p F P
0 0 0 r
s
.83 .24 .1 r
.59537 .47407 m
.6007 .46519 L
s
.24 .35 .67 r
.59907 .47859 m
.60511 .47761 L
s
.83 .24 .1 r
.59537 .47407 m
.59663 .47758 L
s
.59663 .47758 m
.59668 .47772 L
s
.24 .35 .67 r
.6035 .46622 m
.60511 .47761 L
s
.83 .24 .1 r
.5573 .23037 m
.54583 .19509 L
s
.5573 .23037 m
.57548 .24869 L
s
.24 .35 .67 r
.65891 .50499 m
.61108 .51249 L
s
.60511 .47761 m
.61108 .51249 L
s
.71356 .53094 m
.66537 .53828 L
s
.66537 .53828 m
.65891 .50499 L
s
.60511 .47761 m
.65297 .46988 L
s
.83 .24 .1 r
.30154 .45999 m
.28714 .43869 L
s
.28714 .43869 m
.26912 .40837 L
s
.24 .35 .67 r
.817 .54642 m
.76805 .55367 L
s
.76805 .55367 m
.76236 .52352 L
s
.83 .24 .1 r
.44466 .55402 m
.41145 .55311 L
s
.41145 .55311 m
.39642 .52553 L
s
.24 .35 .67 r
.6962 .42692 m
.6919 .394 L
s
.74043 .38571 m
.6919 .394 L
s
.83 .24 .1 r
.598 .30468 m
.58747 .27104 L
s
.598 .30468 m
.60302 .33009 L
s
.59537 .47407 m
.58478 .44453 L
s
.59537 .47407 m
.57285 .49894 L
s
.24 .35 .67 r
.65297 .46988 m
.6479 .43495 L
s
.6962 .42692 m
.6479 .43495 L
s
.78958 .37733 m
.78526 .34823 L
s
.83 .24 .1 r
.3656 .51866 m
.3393 .50615 L
s
.3393 .50615 m
.32248 .47737 L
s
.24 .35 .67 r
.70735 .4974 m
.65891 .50499 L
s
.65891 .50499 m
.65297 .46988 L
s
.76236 .52352 m
.71356 .53094 L
s
.71356 .53094 m
.70735 .4974 L
s
.83 .24 .1 r
.61094 .38925 m
.60069 .35756 L
s
.61094 .38925 m
.60143 .41721 L
s
.24 .35 .67 r
.70145 .46205 m
.65297 .46988 L
s
.83 .24 .1 r
.2498 .29923 m
.24286 .32601 L
s
.24 .35 .67 r
.817 .54642 m
.81178 .51599 L
s
.74513 .41879 m
.74043 .38571 L
s
.78958 .37733 m
.74043 .38571 L
s
.83 .24 .1 r
.47918 .54868 m
.44466 .55402 L
s
.44466 .55402 m
.43032 .52626 L
s
.54583 .19509 m
.52206 .18153 L
s
.24 .35 .67 r
.70145 .46205 m
.6962 .42692 L
s
.74513 .41879 m
.6962 .42692 L
s
.83 .24 .1 r
.57285 .49894 m
.56163 .46981 L
s
.57285 .49894 m
.545 .52041 L
s
.26912 .40837 m
.26172 .38411 L
s
.26172 .38411 m
.24289 .35217 L
s
.24 .35 .67 r
.75641 .48971 m
.70735 .4974 L
s
.70735 .4974 m
.70145 .46205 L
s
.81178 .51599 m
.76236 .52352 L
s
.76236 .52352 m
.75641 .48971 L
s
.83 .24 .1 r
.57548 .24869 m
.56429 .21335 L
s
.57548 .24869 m
.58747 .27104 L
s
.24 .35 .67 r
.75056 .45412 m
.70145 .46205 L
s
.83 .24 .1 r
.51322 .53729 m
.47918 .54868 L
s
.47918 .54868 m
.46562 .52065 L
s
.545 .52041 m
.53305 .49167 L
s
.545 .52041 m
.51322 .53729 L
s
.32248 .47737 m
.30154 .45999 L
s
.30154 .45999 m
.2836 .42976 L
s
.24 .35 .67 r
.79468 .41055 m
.78958 .37733 L
s
.83 .24 .1 r
.51322 .53729 m
.50048 .50893 L
s
.39642 .52553 m
.3656 .51866 L
s
.3656 .51866 m
.34922 .48984 L
s
.24 .35 .67 r
.75056 .45412 m
.74513 .41879 L
s
.79468 .41055 m
.74513 .41879 L
s
.83 .24 .1 r
.60302 .33009 m
.59247 .29659 L
s
.60302 .33009 m
.60069 .35756 L
s
.60143 .41721 m
.59083 .38583 L
s
.60143 .41721 m
.58478 .44453 L
s
.24 .35 .67 r
.80611 .48192 m
.75641 .48971 L
s
.75641 .48971 m
.75056 .45412 L
s
.81178 .51599 m
.80611 .48192 L
s
.8003 .44609 m
.75056 .45412 L
s
.83 .24 .1 r
.24286 .32601 m
.24289 .35217 L
s
.56429 .21335 m
.54583 .19509 L
s
.24 .35 .67 r
.8003 .44609 m
.79468 .41055 L
s
.80611 .48192 m
.8003 .44609 L
s
.83 .24 .1 r
.2836 .42976 m
.26912 .40837 L
s
.26912 .40837 m
.25019 .37655 L
s
.43032 .52626 m
.39642 .52553 L
s
.39642 .52553 m
.38063 .49659 L
s
.58747 .27104 m
.57642 .23572 L
s
.58747 .27104 m
.59247 .29659 L
s
.58478 .44453 m
.57366 .41353 L
s
.58478 .44453 m
.56163 .46981 L
s
.34922 .48984 m
.32248 .47737 L
s
.32248 .47737 m
.30482 .44716 L
s
.60069 .35756 m
.58994 .32428 L
s
.60069 .35756 m
.59083 .38583 L
s
.46562 .52065 m
.43032 .52626 L
s
.43032 .52626 m
.41526 .4971 L
s
.56163 .46981 m
.54984 .43921 L
s
.56163 .46981 m
.53305 .49167 L
s
.24289 .35217 m
.25019 .37655 L
s
.57642 .23572 m
.56429 .21335 L
s
.50048 .50893 m
.46562 .52065 L
s
.46562 .52065 m
.45138 .49122 L
s
.53305 .49167 m
.52049 .46149 L
s
.53305 .49167 m
.50048 .50893 L
s
.30482 .44716 m
.2836 .42976 L
s
.2836 .42976 m
.26476 .39801 L
s
.50048 .50893 m
.48709 .47914 L
s
.38063 .49659 m
.34922 .48984 L
s
.34922 .48984 m
.33201 .45956 L
s
.59247 .29659 m
.58138 .2614 L
s
.59247 .29659 m
.58994 .32428 L
s
.59083 .38583 m
.57969 .35287 L
s
.59083 .38583 m
.57366 .41353 L
s
.25019 .37655 m
.26476 .39801 L
s
.41526 .4971 m
.38063 .49659 L
s
.38063 .49659 m
.36405 .46617 L
s
.58138 .2614 m
.57642 .23572 L
s
.57366 .41353 m
.56197 .38094 L
s
.57366 .41353 m
.54984 .43921 L
s
.33201 .45956 m
.30482 .44716 L
s
.30482 .44716 m
.28625 .4154 L
s
.58994 .32428 m
.57863 .28931 L
s
.58994 .32428 m
.57969 .35287 L
s
.45138 .49122 m
.41526 .4971 L
s
.41526 .4971 m
.39944 .46646 L
s
.54984 .43921 m
.53746 .40704 L
s
.54984 .43921 m
.52049 .46149 L
s
.48709 .47914 m
.45138 .49122 L
s
.45138 .49122 m
.4364 .46026 L
s
.52049 .46149 m
.50729 .42975 L
s
.52049 .46149 m
.48709 .47914 L
s
.26476 .39801 m
.28625 .4154 L
s
.48709 .47914 m
.473 .44782 L
s
.36405 .46617 m
.33201 .45956 L
s
.33201 .45956 m
.31391 .42772 L
s
.57863 .28931 m
.58138 .2614 L
s
.57969 .35287 m
.56798 .3182 L
s
.57969 .35287 m
.56197 .38094 L
s
.39944 .46646 m
.36405 .46617 L
s
.36405 .46617 m
.34659 .43416 L
s
.56197 .38094 m
.54967 .34665 L
s
.56197 .38094 m
.53746 .40704 L
s
.28625 .4154 m
.31391 .42772 L
s
.56798 .3182 m
.57863 .28931 L
s
.4364 .46026 m
.39944 .46646 L
s
.39944 .46646 m
.38277 .43419 L
s
.53746 .40704 m
.52441 .37317 L
s
.53746 .40704 m
.50729 .42975 L
s
.473 .44782 m
.4364 .46026 L
s
.4364 .46026 m
.42063 .42767 L
s
.50729 .42975 m
.49339 .39633 L
s
.50729 .42975 m
.473 .44782 L
s
.473 .44782 m
.45817 .41483 L
s
.31391 .42772 m
.34659 .43416 L
s
.54967 .34665 m
.56798 .3182 L
s
.34659 .43416 m
.38277 .43419 L
s
.52441 .37317 m
.54967 .34665 L
s
.38277 .43419 m
.42063 .42767 L
s
.49339 .39633 m
.52441 .37317 L
s
.42063 .42767 m
.45817 .41483 L
s
.45817 .41483 m
.49339 .39633 L
s
0 0 0 r
.25 Mabswid
.83139 .50547 m
.86955 .74993 L
s
.86955 .74993 m
.80207 .35868 L
s
.80207 .35868 m
.75972 .08168 L
s
.75972 .08168 m
.83139 .50547 L
s
.75972 .08168 m
.08947 .22236 L
s
.08947 .22236 m
.02925 .49223 L
s
.02925 .49223 m
.80207 .35868 L
s
.80207 .35868 m
.75972 .08168 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{500, 500},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40007d0001m2000`400?l00000o`00003oo`3ooooe
0?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3o
m^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40
oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?of
k_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3o
ool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^
m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?oo
o`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd
0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo
003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0
ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool0
0?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03o
m^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofkWX0ooK^0`00001g0?ofkP40oooo003o0?ofkWD0
ooK^1@0000020?ofkP030000003om^h0ooK^07D0ooK^0@3oool00?l0ooK^L@3om^h4000000L0ooK^
00<000000?ofkP3om^h0M@3om^h10?ooo`00o`3om^i/0?ofkPD000002`3om^h00`000000ooK^0?of
kP1e0?ofkP40oooo003o0?ofkVL0ooK^1@00000A0?ofkP030000003om^h0ooK^07@0ooK^0@3oool0
0?l0ooK^HP3om^h5000001H0ooK^00<000000?ofkP3om^h0M03om^h10?ooo`00o`3om^iM0?ofkPD0
00006`3om^h00`000000ooK^0?ofkP1d0?ofkP40oooo003o0?ofkUT0ooK^1000000P0?ofkP030000
003om^h0ooK^07@0ooK^0@3oool00?l0ooK^E03om^h5000002@0ooK^00<000000?ofkP3om^h0M03o
m^h10?ooo`00o`3om^i?0?ofkPD00000:@3om^h00`000000ooK^0?ofkP1d0?ofkP40oooo003o0?of
kTX0ooK^1@00000_0?ofkP030000003om^h0ooK^07<0ooK^0@3oool00?l0ooK^A@3om^h5000003@0
ooK^00<000000?ofkP3om^h0L`3om^h10?ooo`00o`3om^i10?ofkP@00000>@3om^h00`000000ooK^
0?ofkP1c0?ofkP40oooo003o0?ofkS`0ooK^1@00000m0?ofkP030000003om^h0ooK^07<0ooK^0@3o
ool00?l0ooK^=`3om^h500000480ooK^00<000000?ofkP3om^h0L`3om^h10?ooo`00o`3om^hb0?of
kPD00000A`3om^h00`000000ooK^0?ofkP1c0?ofkP40oooo003o0?ofkRh0ooK^1000001<0?ofkP80
0000M03om^h10?ooo`00o`3om^hY0?ofkPD00000D@3om^h00`000000ooK^0?ofkP1b0?ofkP40oooo
003o0?ofkR@0ooK^1@00001F0?ofkP030000003om^h0ooK^0780ooK^0@3oool00?l0ooK^7`3om^h5
000005/0ooK^00<000000?ofkP3om^h0LP3om^h10?ooo`00o`3om^hJ0?ofkPD00000H03om^h00`00
0000ooK^0?ofkP1b0?ofkP40oooo003o0?ofkQH0ooK^1000001U0?ofkP030000003om^h0ooK^0780
ooK^0@3oool00?l0ooK^4@3om^h5000006T0ooK^0P00001c0?ofkP40oooo003o0?ofkP`0ooK^1@00
001^0?ofkP800000L`3om^h10?ooo`00o`3om^h70?ofkPD00000M03om^h00`000000ooK^0?ofkP1a
0?ofkP40oooo003o0?ofkP80ooK^1@00001i0?ofkP030000003om^h0ooK^0740ooK^0@3oool00?d0
ooK^1000001n0?ofkP030000003om^h0ooK^0740ooK^0@3oool00?P0ooK^1@0000220?ofkP030000
003om^h0ooK^0740ooK^0@3oool00?<0ooK^1@0000270?ofkP800000LP3om^h10?ooo`00kP3om^h5
000008`0ooK^0P00001b0?ofkP40oooo003Z0?ofkP@00000TP3om^h00`000000ooK^0?ofkP1`0?of
kP40oooo003U0?ofkPD00000UP3om^h00`000000ooK^0?ofkP1`0?ofkP40oooo003P0?ofkPD00000
V`3om^h00`000000ooK^0?ofkP1`0?ofkP40oooo003K0?ofkPD00000X03om^h00`000000ooK^0?of
kP1`0?ofkP40oooo003F0?ofkPD00000Y@3om^h200000740ooK^0@3oool00=80ooK^1000002Z0?of
kP800000L@3om^h10?ooo`00c@3om^h500000:h0ooK^0P00001a0?ofkP40oooo00380?ofkPD00000
]03om^h00`000000ooK^0?ofkP1_0?ofkP40oooo00330?ofkPD00000^@3om^h00`000000ooK^0?of
kP1_0?ofkP40oooo002n0?ofkPD00000_P3om^h00`000000ooK^0?ofkP1_0?ofkP40oooo002j0?of
kP@00000``3om^h200000700ooK^0@3oool00;D0ooK^1@0000370?ofkP800000L03om^h10?ooo`00
/03om^h500000<`0ooK^0P00001`0?ofkP40oooo002[0?ofkPD00000dP3om^h00`000000ooK^0?of
kP1^0?ofkP40oooo002W0?ofkP@00000=03om^h<0=@m6IL0ooK^00<000000?ofkP3om^h0KP3om^h1
0?ooo`00XP3om^h5000002h0ooK^2P3D?AT80?ofkP040=@m6@3om^h0ooK^0?ofkPP0e3dIS`3om^h0
0`000000ooK^0?ofkP1^0?ofkP40oooo002M0?ofkPD00000;`3om^h40=@m6@030?ofkP3D?AT0ooK^
0100ooK^00<0e3dI0?ofkP3om^h0203om^h50=@m6HX0ooK^0P00001_0?ofkP40oooo002H0?ofkPD0
0000<03om^h40=@m6@H0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP03
0=@m6@3om^h0e3dI00<0e3dIQP3om^h2000006l0ooK^0@3oool009<0ooK^1@00000a0?ofkP@0e3dI
2P3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h0
0P3om^h30=@m6H<0ooK^0P00001_0?ofkP40oooo002?0?ofkP@00000<P3om^h40=@m6@l0ooK^00<0
e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00D0ooK^103D
?AUo0?ofkP800000K`3om^h10?ooo`00RP3om^h5000003<0ooK^0`3D?AT00`3om^h0e3dI0?ofkP0@
0?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP09
0?ofkP80e3dIOP3om^h00`000000ooK^0?ofkP1]0?ofkP40oooo00250?ofkPD00000=@3om^h30=@m
6@D0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^
00`0ooK^00<0e3dI0?ofkP3om^h02@3om^h30=@m6G`0ooK^00<000000?ofkP3om^h0K@3om^h10?oo
o`00P03om^h5000003H0ooK^103D?AT80?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3o
m^h03P3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00X0ooK^00@0e3dI0?ofkP3D
?AT0e3dINP3om^h2000006h0ooK^0@3oool007/0ooK^1@00000h0?ofkP<0e3dI3@3om^h00`3D?AT0
ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0
ooK^0?ofkP0:0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT0N@3om^h2000006h0ooK^0@3oool007L0
ooK^1000000k0?ofkP80e3dI403om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00h0
ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^0080
ooK^0P3D?AUg0?ofkP800000KP3om^h10?ooo`00LP3om^h5000003d0ooK^0`3D?ATA0?ofkP030=@m
6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m
6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h00`3om^h20=@m6GD0ooK^0P00001^0?ofkP40oooo
001]0?ofkPD00000@03om^h20=@m6@<0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?of
kP0?0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?of
kP090?ofkP030=@m6@3om^h0ooK^00D0ooK^0P3D?AUd0?ofkP030000003om^h0ooK^06`0ooK^0@3o
ool006P0ooK^1@0000130?ofkP80e3dI1@3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0
ooK^00l0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0
ooK^00T0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP1a0?ofkP030000003om^h0
ooK^06`0ooK^0@3oool006@0ooK^100000160?ofkP80e3dI203om^h00`3D?AT0ooK^0?ofkP0?0?of
kP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0;0?of
kP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h01P3om^h20=@m6G80ooK^0P00001]0?of
kP40oooo001O0?ofkPD00000B03om^h20=@m6@X0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0
ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0
ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^00L0ooK^0P3D?AUa0?ofkP800000K@3om^h10?ooo`00
FP3om^h5000004/0ooK^0P3D?AT<0?ofkP030=@m6@3om^h0ooK^0100ooK^00<0e3dI0?ofkP3om^h0
3P3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h0
2@3om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0e3dI0700ooK^0P00001]0?ofkP40oooo
001E0?ofkPD00000CP3om^h20=@m6@l0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?of
kP0?0?ofkP030=@m6@3om^h0ooK^00H0ooK^2`3D?AT:0?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0
e3dI0?ofkP3om^h01P3om^h0103D?AT0ooK^0?ofkP3D?AU_0?ofkP800000K@3om^h10?ooo`00D03o
m^h500000540ooK^0P3D?ATA0?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h03P3o
m^h:0=@m6@L0ooK^00@0e3dI0?ofkP3om^h0ooK^203D?AT30?ofkP030=@m6@3om^h0ooK^00T0ooK^
00<0e3dI0?ofkP3om^h01`3om^h0103D?AT0ooK^0?ofkP3D?AU^0?ofkP800000K@3om^h10?ooo`00
C03om^h4000005@0ooK^0`3D?ATC0?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h0
2@3om^h40=@m6@030?ofkP3D?AT0ooK^00l0ooK^00<0e3dI0?ofkP3om^h0203om^h50=@m6@X0ooK^
00<0e3dI0?ofkP3om^h01`3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI06h0ooK^00<000000?ofkP3o
m^h0J`3om^h10?ooo`00A`3om^h5000005L0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0B0?ofkP03
0=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h01@3om^h40=@m6@H0ooK^00<0e3dI0?ofkP3o
m^h03@3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0e3dI0080e3dI203om^h00`3D?AT0
ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h0J`3om^h2000006`0
ooK^0@3oool00480ooK^1@00001K0?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h0
4@3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00@0e3dI2P3om^h00`3D?AT0ooK^
0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00`0ooK^00@0e3dI0?ofkP3om^h0ooK^0P3D?AT60?ofkP03
0=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP1Z0?ofkP80
0000K03om^h10?ooo`00?@3om^h5000005h0ooK^0P3D?AT60?ofkP030=@m6@3om^h0ooK^0100ooK^
00<0e3dI0?ofkP3om^h03P3om^h40=@m6@l0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^
0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00<0ooK^0`3D?AT30?ofkP030=@m6@3om^h0ooK^00L0ooK^
00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP1Y0?ofkP800000K03om^h10?ooo`00>03o
m^h500000680ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP0@0?ofkP030=@m6@3o
m^h0ooK^00/0ooK^0`3D?AT00`3om^h0e3dI0?ofkP0@0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0
e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP060?ofkP<0e3dI00<0ooK^0=@m6@3om^h0203o
m^h00`3D?AT0ooK^0?ofkP020?ofkP80e3dIJP3om^h2000006`0ooK^0@3oool003@0ooK^1000001U
0?ofkP80e3dI2P3om^h00`3D?AT0ooK^0?ofkP0@0?ofkP030=@m6@3om^h0ooK^00L0ooK^0`3D?AT5
0?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0<
0?ofkP030=@m6@3om^h0ooK^00P0ooK^0P3D?AT90?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI
0?ofkP3om^h0J03om^h2000006`0ooK^0@3oool002l0ooK^1@00001X0?ofkP030=@m6@3om^h0ooK^
00X0ooK^00<0e3dI0?ofkP3om^h0403om^h00`3D?AT0ooK^0?ofkP030?ofkP@0e3dI203om^h00`3D
?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D
?AT0ooK^0?ofkP090?ofkP<0e3dI1`3om^h00`3D?AT0ooK^0?ofkP030?ofkP80e3dIJ@3om^h20000
06`0ooK^0@3oool002`0ooK^0`00001/0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3o
m^h0403om^h00`3D?AT0ooK^0=@m6@020=@m6@d0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0
ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h02P3om^h0103D?AT0
ooK^0=@m6@3D?AT60?ofkP030=@m6@3om^h0ooK^0080ooK^0P3D?AUZ0?ofkP800000J`3om^h10?oo
o`00;03om^h2000006/0ooK^0P3D?AT?0?ofkP030=@m6@3om^h0ooK^0100ooK^0P3D?AT@0?ofkP03
0=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP03
0=@m6@3om^h0ooK^00T0ooK^00@0e3dI0?ofkP3om^h0ooK^0P3D?AT40?ofkP030=@m6@3om^h0ooK^
00<0ooK^0P3D?AUY0?ofkP800000J`3om^h10?ooo`00;03om^h2000006X0ooK^00<0e3dI0?ofkP3o
m^h0403om^h00`3D?AT0ooK^0?ofkP0=0?ofkP<0e3dI4P3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP03
0=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP090?ofkP03
0=@m6@3om^h0ooK^00<0ooK^0P3D?AT20?ofkP030=@m6@3om^h0ooK^00<0ooK^0P3D?AUY0?ofkP80
0000J`3om^h10?ooo`00:`3om^h010000000ooK^0?ofkP00001X0?ofkP030=@m6@3om^h0e3dI0140
ooK^00<0e3dI0?ofkP3om^h02`3om^h20=@m6@<0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0
ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0
ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^00@0ooK^0P3D?AT00`3om^h0e3dI0?ofkP030?ofkP03
0=@m6@3om^h0e3dI06P0ooK^0P00001[0?ofkP40oooo000[0?ofkP050000003om^h0ooK^0?ofkP00
0000IP3om^h0103D?AT0ooK^0?ofkP3D?ATB0?ofkP030=@m6@3om^h0ooK^00P0ooK^0P3D?AT50?of
kP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP0=0?of
kP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP060?of
kP80e3dI1@3om^h20=@m6FP0ooK^0P00001[0?ofkP40oooo000[0?ofkP050000003om^h0ooK^0?of
kP000000I@3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?of
kP3om^h01P3om^h20=@m6@P0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP0>0?of
kP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP0:0?of
kP030=@m6@3om^h0ooK^00H0ooK^0P3D?AT40?ofkP030=@m6@3om^h0e3dI06L0ooK^0P00001[0?of
kP40oooo000[0?ofkP030000003om^h0ooK^0080ooK^00<000000?ofkP3om^h0H@3om^h00`3D?AT0
ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^0100ooK^00<0e3dI0?ofkP3om^h00`3om^h20=@m6@X0
ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00`0
ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^00L0
ooK^0P3D?AT30?ofkP030=@m6@3om^h0e3dI06P0ooK^0P00001Z0?ofkP40oooo000Z0?ofkP030000
003om^h0ooK^00<0ooK^00<000000?ofkP3om^h0H03om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m
6@3om^h0ooK^00l0ooK^00@0e3dI0?ofkP3om^h0ooK^0P3D?AT=0?ofkP030=@m6@3om^h0ooK^00l0
ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00/0
ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0e3dI00<0
ooK^00<0e3dI0?ofkP3D?AT0I`3om^h2000006X0ooK^0@3oool002X0ooK^00<000000?ofkP3om^h0
103om^h00`000000ooK^0?ofkP1M0?ofkP80e3dI203om^h00`3D?AT0ooK^0?ofkP0@0?ofkP<0e3dI
3`3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h0
1@3om^h;0=@m6@X0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP060?ofkP040=@m
6@3om^h0ooK^0=@m6@80ooK^00<0e3dI0?ofkP3D?AT0I`3om^h2000006X0ooK^0@3oool002X0ooK^
00<000000?ofkP3om^h01@3om^h00`000000ooK^0?ofkP1K0?ofkP030=@m6@3om^h0ooK^00T0ooK^
00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^0100ooK^
00<0e3dI0?ofkP3om^h0303om^h:0=@m6@L0ooK^00@0e3dI0?ofkP3om^h0ooK^203D?AT30?ofkP03
0=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h01P3om^h0103D?AT0ooK^0?ofkP3D?AT20?of
kP040=@m6@3om^h0e3dI0=@m6FH0ooK^0P00001Z0?ofkP40oooo000Z0?ofkP030000003om^h0ooK^
00D0ooK^00<000000?ofkP3om^h0FP3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^
00h0ooK^0P3D?ATB0?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h01`3om^h50=@m
6@80ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP080?ofkPD0e3dI2P3om^h00`3D
?AT0ooK^0?ofkP070?ofkP040=@m6@3om^h0ooK^0=@m6@80ooK^00<0e3dI0?ofkP3D?AT0IP3om^h2
000006X0ooK^0@3oool002X0ooK^00<000000?ofkP3om^h01P3om^h00`000000ooK^0?ofkP1H0?of
kP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h02`3om^h20=@m6@80ooK^00<0e3dI0?of
kP3om^h03`3om^h00`3D?AT0ooK^0?ofkP0@0?ofkP030=@m6@3om^h0ooK^00H0e3dI203om^h00`3D
?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3D?AT00`3D?AT70?of
kP030=@m6@3om^h0ooK^00H0ooK^00T0e3dI0?ofkP3om^h0ooK^0=@m6@3om^h0e3dI0?ofkP3D?AT0
IP3om^h2000006X0ooK^0@3oool002T0ooK^00<000000?ofkP3om^h0203om^h00`000000ooK^0?of
kP1F0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?of
kP020?ofkP030=@m6@3om^h0ooK^0100ooK^00<0e3dI0?ofkP3om^h03P3om^h40=@m6@h0ooK^00<0
e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^0080ooK^0`3D
?AT40?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h00P3om^h20=@m6@030?ofkP3D
?AT0e3dI06D0ooK^00<000000?ofkP000000J@3om^h10?ooo`00:@3om^h00`000000ooK^0?ofkP08
0?ofkP030000003om^h0ooK^05D0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP08
0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP0;
0?ofkP<0e3dI00<0ooK^0=@m6@3om^h0403om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0
ooK^00/0ooK^00<0e3dI0?ofkP3om^h01@3om^h40=@m6@030?ofkP3D?AT0ooK^00L0ooK^00<0e3dI
0?ofkP3om^h00P3om^h40=@m6FH0ooK^0P00001Y0?ofkP40oooo000Y0?ofkP030000003om^h0ooK^
00T0ooK^00<000000?ofkP3om^h0D`3om^h00`3D?AT0ooK^0=@m6@0@0?ofkP030=@m6@3om^h0ooK^
00H0ooK^0P3D?AT70?ofkP030=@m6@3om^h0ooK^0100ooK^00<0e3dI0?ofkP3om^h01`3om^h30=@m
6@D0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^
00/0ooK^00<0e3dI0?ofkP3om^h02@3om^h20=@m6@P0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D
?AT0ooK^0=@m6@1V0?ofkP800000J@3om^h10?ooo`00:@3om^h00`000000ooK^0?ofkP0:0?ofkP03
0000003om^h0ooK^0580ooK^00<0e3dI0?ofkP3D?AT04@3om^h00`3D?AT0ooK^0?ofkP040?ofkP03
0=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP030?ofkP@0
e3dI203om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3o
m^h02`3om^h00`3D?AT0ooK^0?ofkP090?ofkP<0e3dI1P3om^h00`3D?AT0ooK^0?ofkP030?ofkP@0
e3dII@3om^h2000006T0ooK^0@3oool002P0ooK^00<000000?ofkP3om^h02`3om^h00`000000ooK^
0?ofkP1A0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT0403om^h00`3D?AT0ooK^0?ofkP030?ofkP03
0=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h0403om^h00`3D?AT0ooK^0=@m6@020=@m6@d0
ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00/0
ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0=@m6@060?ofkP030=@m6@3om^h0ooK^00<0
ooK^0`3D?AUU0?ofkP800000J@3om^h10?ooo`00:03om^h00`000000ooK^0?ofkP0<0?ofkP030000
003om^h0ooK^04l0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m
6@3om^h0ooK^0080e3dI3@3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP80e3dI403om^h00`3D?AT0ooK^
0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^
0?ofkP090?ofkP030=@m6@3om^h0ooK^0080e3dI103om^h00`3D?AT0ooK^0?ofkP030?ofkP<0e3dI
I@3om^h2000006T0ooK^0@3oool002P0ooK^00<000000?ofkP3om^h03@3om^h00`000000ooK^0?of
kP1>0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0=@m
6@0?0?ofkP030=@m6@3om^h0ooK^00d0ooK^0`3D?ATA0?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0
e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0
e3dI0?ofkP3om^h00P3om^h20=@m6@80ooK^00<0e3dI0?ofkP3om^h00`3om^h40=@m6F@0ooK^00<0
00000?ofkP000000J03om^h10?ooo`00:03om^h00`000000ooK^0?ofkP0=0?ofkP030000003om^h0
ooK^04d0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0
ooK^00l0ooK^00<0e3dI0?ofkP3om^h02P3om^h20=@m6@<0ooK^00<0e3dI0?ofkP3om^h03`3om^h0
0`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h02`3om^h0
0`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3D?AT01P3om^h3
0=@m6FD0ooK^0P00001X0?ofkP40oooo000X0?ofkP030000003om^h0ooK^00h0ooK^00<000000?of
kP3om^h0B`3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00d0ooK^0P3D?ATA0?of
kP030=@m6@3om^h0ooK^00P0ooK^0P3D?AT50?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?of
kP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?of
kP3om^h02@3om^h00`3D?AT0ooK^0?ofkP040?ofkP<0e3dI1@3om^h30=@m6FD0ooK^0P00001X0?of
kP40oooo000W0?ofkP030000003om^h0ooK^00l0ooK^00<000000?ofkP3om^h0BP3om^h00`3D?AT0
ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00`0ooK^00@0e3dI0?ofkP3om^h0e3dI4@3om^h00`3D
?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D
?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D
?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h00`3om^h40=@m
6F@0ooK^0P00001X0?ofkP40oooo000W0?ofkP030000003om^h0ooK^0100ooK^00<000000?ofkP3o
m^h0B@3om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00X0ooK^00D0e3dI0?ofkP3o
m^h0ooK^0=@m6@0A0?ofkP030=@m6@3om^h0ooK^00@0ooK^0P3D?AT90?ofkP030=@m6@3om^h0ooK^
00l0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^
00/0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP060?ofkP80e3dI103om^h40=@m
6F@0ooK^0P00001X0?ofkP40oooo000W0?ofkP030000003om^h0ooK^0140ooK^00<000000?ofkP3o
m^h0A`3om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3o
m^h00`3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP040=@m6@3om^h0ooK^0?ofkP80e3dI303om^h00`3D
?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D
?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h01P3om^h20=@m
6@@0ooK^0`3D?AUT0?ofkP800000J03om^h10?ooo`009`3om^h00`000000ooK^0?ofkP0A0?ofkP03
0000003om^h0ooK^04H0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP070?ofkP03
0=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h03`3om^h0103D?AT0ooK^0=@m6@3D?AT>0?of
kP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h0303om^hE0=@m6@X0ooK^00<0e3dI0?of
kP3om^h02@3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0e3dI0080ooK^1@3D?AUS0?of
kP030000003om^h0000006L0ooK^0@3oool002H0ooK^00<000000?ofkP3om^h04`3om^h00`000000
ooK^0?ofkP150?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h01@3om^h20=@m6@P0
ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00l0
ooK^00<0e3dI0?ofkP3om^h01`3om^h50=@m6@80ooK^00<0e3dI0?ofkP3om^h0303om^h0103D?AT0
ooK^0?ofkP3om^h80=@m6@<0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP060?of
kP050=@m6@3om^h0ooK^0=@m6@3om^h00`3D?AT00`3om^h0e3dI0?ofkP1R0?ofkP030000003om^h0
000006L0ooK^0@3oool002H0ooK^00<000000?ofkP3om^h0503om^h00`000000ooK^0?ofkP130?of
kP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP080?of
kP030=@m6@3om^h0ooK^00d0ooK^0`3D?ATA0?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?of
kP3om^h01P3D?AT80?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h0203om^h50=@m
6@X0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP020=@m6@040?ofkP3D?AT0e3dI
0=@m6F@0ooK^0P00001W0?ofkP40oooo000V0?ofkP030000003om^h0ooK^01@0ooK^00<000000?of
kP3om^h0@P3om^h00`3D?AT0ooK^0=@m6@0>0?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?of
kP3om^h02P3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT0403om^h0
0`3D?AT0ooK^0?ofkP0>0?ofkP@0e3dI3P3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0
ooK^00/0ooK^00<0e3dI0?ofkP3D?AT00P3D?AT70?ofkP030=@m6@3om^h0ooK^00H0ooK^00H0e3dI
0?ofkP3om^h0ooK^0=@m6@3om^h40=@m6F<0ooK^0P00001W0?ofkP40oooo000V0?ofkP030000003o
m^h0ooK^01D0ooK^00<000000?ofkP3om^h0@@3om^h00`3D?AT0ooK^0=@m6@0?0?ofkP040=@m6@3o
m^h0ooK^0=@m6@d0ooK^00<0e3dI0?ofkP3om^h02@3om^h20=@m6@@0ooK^00<0e3dI0?ofkP3om^h0
3`3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP80e3dI00<0ooK^0=@m6@3om^h0403om^h00`3D?AT0ooK^
0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00/0ooK^00@0e3dI0?ofkP3om^h0ooK^103D?AT30?ofkP03
0=@m6@3om^h0ooK^00H0ooK^00@0e3dI0?ofkP3om^h0ooK^1P3D?AUS0?ofkP800000I`3om^h10?oo
o`009P3om^h00`000000ooK^0?ofkP0F0?ofkP030000003om^h0ooK^03l0ooK^00D0e3dI0?ofkP3o
m^h0ooK^0=@m6@0>0?ofkP030=@m6@3om^h0e3dI00l0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D
?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h0203om^h30=@m
6@@0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^
00/0ooK^00<0e3dI0?ofkP3om^h01@3om^h30=@m6@030?ofkP3D?AT0ooK^00H0ooK^00H0e3dI0?of
kP3om^h0ooK^0=@m6@3om^h40=@m6F<0ooK^0P00001W0?ofkP40oooo000U0?ofkP030000003om^h0
ooK^01L0ooK^00<000000?ofkP3om^h0?`3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00l0ooK^00<0
e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP050?ofkP80e3dI203om^h00`3D?AT0ooK^0?of
kP0?0?ofkP030=@m6@3om^h0ooK^00D0ooK^0P3D?AT70?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0
e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00P0ooK^0P3D
?AT80?ofkP040=@m6@3om^h0ooK^0=@m6@80ooK^0`3D?AUS0?ofkP030000003om^h0000006H0ooK^
0@3oool002D0ooK^00<000000?ofkP3om^h0603om^h00`000000ooK^0?ofkP0m0?ofkP030=@m6@3o
m^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0=@m6@0@0?ofkP030=@m6@3o
m^h0ooK^0080ooK^0P3D?AT;0?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h00P3o
m^h30=@m6@X0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3o
m^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h0203om^h30=@m6@H0ooK^00<0e3dI0?ofkP3D?AT00`3o
m^h40=@m6F80ooK^00<000000?ofkP000000IP3om^h10?ooo`009@3om^h00`000000ooK^0?ofkP0I
0?ofkP030000003om^h0ooK^03`0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP0:
0?ofkP040=@m6@3om^h0ooK^0=@m6A00ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0=0?ofkP030=@m
6@3om^h0ooK^00l0ooK^00@0e3dI0?ofkP3D?AT0e3dI3@3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP03
0=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP090?ofkP03
0=@m6@3om^h0e3dI00D0ooK^00<0e3dI0?ofkP3D?AT0103om^h30=@m6F<0ooK^0P00001V0?ofkP40
oooo000U0?ofkP030000003om^h0ooK^01T0ooK^00<000000?ofkP3om^h0>`3om^h00`3D?AT0ooK^
0?ofkP050?ofkP030=@m6@3om^h0ooK^00T0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0@0?ofkP<0
e3dI3`3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP80e3dI403om^h00`3D?AT0ooK^0?ofkP0>0?ofkP03
0=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP090?ofkP03
0=@m6@3om^h0ooK^0080e3dI103om^h20=@m6@@0ooK^0`3D?AUS0?ofkP800000IP3om^h10?ooo`00
903om^h00`000000ooK^0?ofkP0K0?ofkP030000003om^h0ooK^03X0ooK^00<0e3dI0?ofkP3om^h0
1@3om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h0
3P3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00`0ooK^0`3D?ATA0?ofkP030=@m
6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m
6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h00P3om^h20=@m6@80ooK^0P3D?AT40?ofkP80e3dI
00<0ooK^0=@m6@3om^h0H@3om^h2000006H0ooK^0@3oool002@0ooK^00<000000?ofkP3om^h06`3o
m^h00`000000ooK^0?ofkP0i0?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h01P3o
m^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3D?AT04@3o
m^h00`3D?AT0ooK^0?ofkP090?ofkP80e3dI0`3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3o
m^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3o
m^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h00`3om^h0103D?AT0ooK^0=@m6@3D?AT50?ofkP<0e3dI
HP3om^h2000006H0ooK^0@3oool002@0ooK^00<000000?ofkP3om^h0703om^h00`000000ooK^0?of
kP0h0?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?of
kP050?ofkP030=@m6@3om^h0ooK^00/0ooK^00@0e3dI0?ofkP3om^h0e3dI4@3om^h00`3D?AT0ooK^
0?ofkP070?ofkP80e3dI1@3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00h0ooK^
00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00T0ooK^
00<0e3dI0?ofkP3om^h0103om^h40=@m6@@0ooK^0`3D?AUR0?ofkP800000IP3om^h10?ooo`00903o
m^h00`000000ooK^0?ofkP0M0?ofkP030000003om^h0ooK^03H0ooK^00<0e3dI0?ofkP3om^h02@3o
m^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h02@3o
m^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h0103o
m^h20=@m6@P0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3o
m^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3o
m^h0ooK^00D0ooK^0`3D?AT40?ofkP80e3dI00<0ooK^0=@m6@3om^h0E`3om^h303eIZ`H0ooK^00<0
00000?ofkP000000I@3om^h10?ooo`00903om^h00`000000ooK^0?ofkP0M0?ofkP030000003om^h0
ooK^03H0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0
ooK^00L0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0
ooK^00l0ooK^00<0e3dI0?ofkP3om^h00P3om^h20=@m6@X0ooK^00<0e3dI0?ofkP3om^h03`3om^h0
0`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h02P3om^h0
0`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00D0ooK^0`3D?AT40?ofkP@0e3dIDP3om^h9
03eIZ`H0ooK^00<000000?ofkP000000I@3om^h10?ooo`008`3om^h00`000000ooK^0?ofkP0O0?of
kP030000003om^h0ooK^03@0ooK^00<0e3dI0?ofkP3om^h02`3om^h01@3D?AT0ooK^0?ofkP3om^h0
e3dI00/0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0
ooK^00l0ooK^00@0e3dI0?ofkP3D?AT0e3dI3@3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3o
m^h0ooK^00/0ooK^5@3D?AT90?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h00`3o
m^h00`3D?AT0ooK^0?ofkP020=@m6@@0ooK^0`3D?AU=0?ofkP/0?EV[00@0ooK^03eIZ`0mFJ/0?EV[
1P3om^h2000006D0ooK^0@3oool002<0ooK^00<000000?ofkP3om^h0803om^h00`000000ooK^0?of
kP0c0?ofkP80e3dI3@3om^h00`3D?AT0ooK^0=@m6@0<0?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0
e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP80e3dI3`3om^h00`3D?AT0ooK^0?of
kP0?0?ofkP030=@m6@3om^h0ooK^00H0ooK^1@3D?AT20?ofkP030=@m6@3om^h0ooK^00`0ooK^00@0
e3dI0?ofkP3om^h0ooK^1`3D?AT30?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h0
0`3om^h00`3D?AT0ooK^0?ofkP030=@m6@<0ooK^0`3D?AU70?ofkP/0?EV[00<0ooK^03eIZ`0mFJ/0
100mFJ/00`3om^h0?EV[03eIZ`060?ofkP800000I@3om^h10?ooo`008`3om^h00`000000ooK^0?of
kP0P0?ofkP030000003om^h0ooK^03<0ooK^0P3D?AT=0?ofkP030=@m6@3om^h0e3dI00d0ooK^00<0
e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00`0ooK^0`3D
?ATA0?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h01@3D?AT80?ofkP030=@m6@3o
m^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h01`3om^h50=@m6@T0ooK^00<0e3dI0?ofkP3om^h00P3o
m^h0103D?AT0ooK^0?ofkP3om^h20=@m6@040?ofkP3D?AT0ooK^0?ofkP@0e3dI@@3om^h:03eIZ`80
ooK^1@0mFJ/80?ofkP0303eIZ`3om^h0ooK^00@0ooK^0P00001U0?ofkP40oooo000S0?ofkP030000
003om^h0ooK^0240ooK^00<000000?ofkP3om^h0<@3om^h0103D?AT0ooK^0?ofkP3D?AT=0?ofkP03
0=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP090?ofkP03
0=@m6@3om^h0ooK^00/0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0@0?ofkP030=@m6@3om^h0ooK^
00h0ooK^103D?AT=0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h02P3om^h0103D
?AT0ooK^0=@m6@3D?AT80?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT0103om^h20=@m6@030?ofkP3D
?AT0ooK^0080e3dI00<0ooK^0=@m6@3om^h0>P3om^h:03eIZ`80ooK^1P0mFJ/=0?ofkP80?EV[1@3o
m^h2000006D0ooK^0@3oool00280ooK^00<000000?ofkP3om^h08`3om^h00`000000ooK^0?ofkP0`
0?ofkP040=@m6@3om^h0ooK^0=@m6@`0ooK^00<0e3dI0?ofkP3D?AT03P3om^h0103D?AT0ooK^0?of
kP3D?AT=0?ofkP030=@m6@3om^h0ooK^00P0ooK^0P3D?AT40?ofkP030=@m6@3om^h0ooK^00l0ooK^
00<0e3dI0?ofkP3om^h02P3om^h30=@m6@030?ofkP3D?AT0ooK^00l0ooK^00<0e3dI0?ofkP3om^h0
2`3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00<0e3dI1@3om^h01@3D?AT0ooK^
0?ofkP3om^h0e3dI00@0ooK^0P3D?AT20?ofkPD0e3dI=@3om^h;03eIZ`80ooK^1@0mFJ/A0?ofkP@0
?EV[1@3om^h00`000000ooK^0000001T0?ofkP40oooo000R0?ofkP030000003om^h0ooK^02<0ooK^
00<000000?ofkP3om^h0<03om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00/0ooK^00<0e3dI0?ofkP3D
?AT03P3om^h00`3D?AT0ooK^0=@m6@0>0?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3o
m^h01@3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00L0ooK^0`3D?AT50?ofkP03
0=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP0:0?ofkP03
0=@m6@3om^h0ooK^00<0ooK^0`3D?AT20?ofkP040=@m6@3om^h0ooK^0=@m6@D0ooK^00@0e3dI0?of
kP3D?AT0ooK^1P3D?AT^0?ofkP/0?EV[0P3om^h703eIZ`030?ofkP0mFJ/0ooK^00`0ooK^1P0mFJ/0
103om^h0?EV[03eIZ`0mFJ/50?ofkP030000003om^h0000006@0ooK^0@3oool00280ooK^00<00000
0?ofkP3om^h0903om^h00`000000ooK^0?ofkP0_0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT02P3o
m^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00h0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^
0?ofkP050?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^
0?ofkP030?ofkP<0e3dI203om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00`0ooK^
00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP060?ofkP80e3dI00@0ooK^0=@m6@3om^h0
e3dI1@3om^h01P3D?AT0ooK^0=@m6@3om^h0e3dI0?ofkP@0e3dI:@3om^h:03eIZ`<0ooK^1@0mFJ/6
0?ofkP0303eIZ`3om^h0?EV[00L0ooK^1P0mFJ/00`3om^h0?EV[03eIZ`0403eIZ`030?ofkP0mFJ/0
?EV[00D0ooK^00<000000?ofkP000000I03om^h10?ooo`008P3om^h00`000000ooK^0?ofkP0T0?of
kP030000003om^h0ooK^02h0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP070?of
kP050=@m6@3om^h0ooK^0?ofkP3D?AT03@3om^h00`3D?AT0ooK^0=@m6@0?0?ofkP030=@m6@3om^h0
ooK^00<0ooK^0P3D?AT:0?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h00`3D?AT<
0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP0;
0?ofkP030=@m6@3om^h0ooK^00L0ooK^0P3D?AT00`3om^h0e3dI0?ofkP050?ofkP80e3dI00@0ooK^
0=@m6@3om^h0ooK^0`3D?ATS0?ofkPX0?EV[0`3om^h603eIZ`/0ooK^00<0?EV[0?ofkP3om^h01`0m
FJ/20?ofkPD0?EV[1`3om^h203eIZ`H0ooK^0P00001T0?ofkP40oooo000R0?ofkP030000003om^h0
ooK^02D0ooK^00<000000?ofkP3om^h0;@3om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0
ooK^00H0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP090?ofkP040=@m6@3om^h0
ooK^0=@m6A00ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0<0?ofkP030=@m6@3om^h0ooK^00l0ooK^
0P3D?AT?0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^
0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00P0ooK^0`3D?AT60?ofkP040=@m6@3om^h0e3dI0=@m6@80
ooK^103D?ATM0?ofkPX0?EV[0P3om^h603eIZ`l0ooK^1P0mFJ/20?ofkPH0?EV[303om^h203eIZ`H0
ooK^0P00001T0?ofkP40oooo000Q0?ofkP030000003om^h0ooK^02L0ooK^00<000000?ofkP3om^h0
;03om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h0
0`3om^h00`3D?AT0ooK^0?ofkP090?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT03`3om^h0103D?AT0
ooK^0=@m6@3D?AT>0?ofkP030=@m6@3om^h0ooK^00`0ooK^0`3D?AT@0?ofkP030=@m6@3om^h0ooK^
00h0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^
00T0ooK^00<0e3dI0?ofkP3D?AT01@3om^h0103D?AT0ooK^0=@m6@3D?AT30?ofkP<0e3dI5`3om^h:
03eIZ`<0ooK^1P0mFJ/20?ofkP0303eIZ`3om^h0ooK^00T0ooK^1P0mFJ/20?ofkPH0?EV[4`3om^h0
0`0mFJ/0ooK^0?ofkP040?ofkP800000I03om^h10?ooo`008@3om^h00`000000ooK^0?ofkP0W0?of
kP030000003om^h0ooK^02`0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP030?of
kP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP020?of
kP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0:0?of
kP80e3dI0`3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?of
kP3om^h02`3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00L0ooK^0P3D?AT20?of
kP80e3dI103om^h30=@m6@<0ooK^0`3D?ATB0?ofkPX0?EV[0`3om^h503eIZ`D0ooK^00D0?EV[0?of
kP3om^h0ooK^03eIZ`040?ofkPH0?EV[103om^h503eIZ`80ooK^00<0?EV[0?ofkP3om^h04`3om^h2
03eIZ`D0ooK^00<000000?ofkP000000H`3om^h10?ooo`008@3om^h00`000000ooK^0?ofkP0X0?of
kP030000003om^h0ooK^02X0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP030?of
kP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP040?of
kP030=@m6@3om^h0ooK^00`0ooK^0P3D?ATA0?ofkP030=@m6@3om^h0ooK^00L0ooK^0P3D?AT50?of
kP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0<0?of
kP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h01`3om^h30=@m6@<0ooK^0P3D?AT20?of
kP030=@m6@3om^h0e3dI00<0ooK^0`3D?AT=0?ofkPT0?EV[0`3om^h603eIZ`X0ooK^00<0?EV[0?of
kP3om^h01P0mFJ/40?ofkPH0?EV[103om^h0100mFJ/0ooK^0?ofkP0mFJ/E0?ofkP80?EV[1@3om^h0
0`000000ooK^0000001S0?ofkP40oooo000Q0?ofkP030000003om^h0ooK^02T0ooK^00<000000?of
kP3om^h0:@3om^h00`3D?AT0ooK^0?ofkP070?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT02@3om^h0
0`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h02`3om^h0
103D?AT0ooK^0?ofkP3D?AT@0?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h01P3o
m^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h02`3o
m^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00D0ooK^00@0e3dI0?ofkP3om^h0e3dI
1@3om^h01@3D?AT0ooK^0=@m6@3om^h0e3dI00@0ooK^00<0e3dI0?ofkP3D?AT01P3om^h:03eIZ`80
ooK^1P0mFJ/>0?ofkPD0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP0503eIZ`X0ooK^00D0?EV[0?ofkP3o
m^h0ooK^03eIZ`0D0?ofkP80?EV[1@3om^h00`000000ooK^0000001S0?ofkP40oooo000P0?ofkP03
0000003om^h0ooK^02X0ooK^00<000000?ofkP3om^h0:@3om^h00`3D?AT0ooK^0?ofkP070?ofkP05
0=@m6@3om^h0ooK^0?ofkP3D?AT02@3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^
00H0ooK^00<0e3dI0?ofkP3om^h02@3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI0140ooK^00<0e3dI
0?ofkP3om^h00`3om^h20=@m6@T0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0=
0?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP04
0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT01P3om^h40=@m6@@0ooK^0`3D?AT00`3om^h0?EV[03eI
Z`0703eIZ`030?ofkP0mFJ/0?EV[00H0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP090?ofkP@0?EV[0P3o
m^h00`0mFJ/0ooK^03eIZ`0503eIZa00ooK^00@0?EV[0?ofkP3om^h0?EV[4P3om^h403eIZ`H0ooK^
0P00001S0?ofkP40oooo000P0?ofkP030000003om^h0ooK^02/0ooK^00<000000?ofkP3om^h0:03o
m^h20=@m6@T0ooK^00<0e3dI0?ofkP3D?AT02`3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3o
m^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3o
m^h0ooK^00h0ooK^00@0e3dI0?ofkP3om^h0ooK^0P3D?AT;0?ofkP030=@m6@3om^h0ooK^00h0ooK^
00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00X0ooK^
00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00D0ooK^
00@0e3dI0?ofkP3D?AT0ooK^0P0mFJ/30=@m6@/0?EV[1P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP03
03eIZ`3om^h0ooK^00@0ooK^1@0mFJ/00`3om^h0?EV[03eIZ`0503eIZ`<0ooK^00<0?EV[0?ofkP3o
m^h0403om^h0100mFJ/0ooK^0?ofkP0mFJ/<0?ofkPL0?EV[00<0ooK^03eIZ`0mFJ/01P3om^h20000
06<0ooK^0@3oool00200ooK^00<000000?ofkP3om^h0;03om^h00`000000ooK^0?ofkP0W0?ofkP80
e3dI2@3om^h00`3D?AT0ooK^0=@m6@0;0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT02`3om^h00`3D
?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h03`3om^h30=@m
6@h0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0;0?ofkQ@0e3dI2P3om^h00`3D
?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0000000000001@0000030=@m
6@0403eIZ`3om^h0?EV[03eIZ`<0e3dI0`0mFJ/=0?ofkP0303eIZ`3om^h0ooK^00<0ooK^300mFJ/5
0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h03`3om^h0100mFJ/0ooK^0?ofkP0m
FJ/60?ofkPP0?EV[1P3om^h203eIZ`H0ooK^0P00001S0?ofkP40oooo000P0?ofkP030000003om^h0
ooK^02`0ooK^00<000000?ofkP3om^h09`3om^h00`3D?AT0ooK^0=@m6@090?ofkP030=@m6@3om^h0
ooK^00/0ooK^00<0e3dI0?ofkP3D?AT0303om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0
ooK^00H0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0
ooK^00h0ooK^00<0e3dI0?ofkP3om^h01P3om^h50=@m6@80ooK^00<0e3dI0?ofkP3om^h02`3om^h0
103D?AT0ooK^0?ofkP3om^h70=@m6@<0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@06000000040=@m
6@072Q<01`XC00L:4`@000000`3D?AT403eIZ`<0e3dI00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0
ooK^0?ofkP0803eIZ``0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP04
03eIZ`3om^h0ooK^0?ofkPP0?EV[303om^h00`0mFJ/0ooK^03eIZ`050?ofkP030000003om^h00000
0680ooK^0@3oool00200ooK^00<000000?ofkP3om^h0;@3om^h00`000000ooK^0?ofkP0V0?ofkP03
0=@m6@3om^h0e3dI00T0ooK^0P3D?AT<0?ofkP030=@m6@3om^h0e3dI00d0ooK^00<0e3dI0?ofkP3o
m^h00`3om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00`0ooK^0`3D?ATA0?ofkP03
0=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h01@3D?AT80?ofkP030=@m6@3om^h0ooK^00/0
ooK^00<0e3dI0?ofkP3om^h01`3om^h40=@m6@<0000000@0e3dI00L:4`072Q<01`XC100000000`3D
?AT000000000000300lB8`030=@m6@0?4R<03a8S0080e3dI00<03a8S03eIZ`0000000`3D?AT00`0m
FJ/0ooK^0?ofkP0;0?ofkPL0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^
00<0ooK^00<0?EV[0?ofkP3om^h03@3om^h903eIZa40ooK^00<0?EV[0?ofkP0mFJ/01@3om^h00`00
0000ooK^0000001R0?ofkP40oooo000O0?ofkP030000003om^h0ooK^02l0ooK^00<000000?ofkP3o
m^h09@3om^h0103D?AT0ooK^0?ofkP3D?AT80?ofkP80e3dI3@3om^h00`3D?AT0ooK^0?ofkP0<0?of
kP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP0:0?of
kP050=@m6@3om^h0ooK^0?ofkP3D?AT0403om^h00`3D?AT0ooK^0?ofkP0=0?ofkP@0e3dI3@3om^h0
0`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00H0ooK^1`0000000`3D?AT0000000000002
000000@03a8S00<0e3dI0000000000000`0?4R<01@3D?AT03a8S00lB8`0?4R<0e3dI00<00000103D
?AT00`0mFJ/0ooK^0?ofkP040?ofkPT0?EV[1P3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3o
m^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h01`3om^h903eIZ`<0ooK^00<0?EV[0?ofkP3om^h04@3o
m^h00`0mFJ/0ooK^03eIZ`050?ofkP030000003om^h000000680ooK^0@3oool001l0ooK^00<00000
0?ofkP3om^h0;`3om^h00`000000ooK^0?ofkP0U0?ofkP040=@m6@3om^h0ooK^0=@m6@L0ooK^00@0
e3dI0?ofkP3om^h0e3dI303om^h20=@m6@h0ooK^00@0e3dI0?ofkP3om^h0e3dI303om^h00`3D?AT0
ooK^0?ofkP080?ofkP80e3dI103om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00X0
ooK^0`3D?AT00`3om^h0e3dI0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP00
00001@0000000`072Q<0000000000002000000803a8S00<0e3dI0000000?4R<01P0?4R<00`3D?AT0
3a8S00000003000000050=@m6@00000000000000003D?AT00`0F6S@20=@m6@030?ofkP3D?AT0?EV[
00P0?EV[1P3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?of
kP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0803eIZ`H0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0D
0?ofkP80?EV[1@3om^h00`000000ooK^0000001R0?ofkP40oooo000O0?ofkP030000003om^h0ooK^
0300ooK^00<000000?ofkP3om^h0903om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00H0ooK^00@0e3dI
0?ofkP3om^h0e3dI2`3om^h00`3D?AT0ooK^0=@m6@0>0?ofkP030=@m6@3om^h0e3dI00h0ooK^00<0
e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0
e3dI0?ofkP3om^h01P3om^h30=@m6@D0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?of
kP090?ofkP<000000`072Q<5000000D03a8S00@0e3dI00lB8`0?4R<000000`0?4R<4000000050=@m
6@0F6S@05QXd01HJ=03D?AT0100F6S@01P3D?AT05QXd01HJ=00F6S@0e3dI01HJ=080e3dI100mFJ/;
0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h0303om^h0100mFJ/0ooK^0?ofkP3o
m^h703eIZ`d0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP80?EV[1P3o
m^h200000680ooK^0@3oool001l0ooK^00<000000?ofkP3om^h0<03om^h00`000000ooK^0?ofkP0T
0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT01P3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00X0ooK^
00@0e3dI0?ofkP3om^h0e3dI3P3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00D0
ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00<0
ooK^0`3D?AT80?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h0103om^h500000080
1`XC1000000300lB8`030000000?4R<03a8S00<03a8S00<0e3dI00lB8`0?4R<01@00000401HJ=005
0=@m6@0F6S@05QXd01HJ=03D?AT01@0F6S@01@3D?AT05QXd01HJ=03D?AT05QXd00<0e3dI00<0?EV[
0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00X0ooK^1`0mFJ/2
0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP0A
0?ofkP0303eIZ`3om^h0?EV[00D0ooK^0P00001R0?ofkP40oooo000N0?ofkP030000003om^h0ooK^
0380ooK^00<000000?ofkP3om^h08`3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^
00<0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP060?ofkP050=@m6@3om^h0ooK^
0?ofkP3D?AT03@3om^h20=@m6A00ooK^00<0e3dI0?ofkP3om^h00P3om^h20=@m6@X0ooK^00<0e3dI
0?ofkP3om^h03P3om^h00`3D?AT0ooK^0=@m6@020=@m6@/0ooK^00<0e3dI0?ofkP3om^h0303om^h7
0000000300L:4`000000000000D000001`0?4R<0100000003a8S00lB8`0?4R<2000000030=@m6@00
0000000000805QXd00<0000001HJ=00F6S@0100F6S@01P3D?AT05QXd01HJ=00F6S@0e3dI000000@0
5QXd00<0e3dI01HJ=03D?AT00P0F6S@30=@m6@030?ofkP0mFJ/0ooK^00/0ooK^00<0?EV[0?ofkP3o
m^h01@3om^h00`0mFJ/0ooK^0?ofkP040?ofkPT0?EV[1P3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP03
03eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h04@3om^h00`0mFJ/0ooK^03eIZ`050?ofkP03
0000003om^h000000640ooK^0@3oool001h0ooK^00<000000?ofkP3om^h0<`3om^h00`000000ooK^
0?ofkP0R0?ofkP030=@m6@3om^h0ooK^00<0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@050?ofkP03
0=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP090?ofkP04
0=@m6@3om^h0ooK^0=@m6@l0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0<0?ofkP030=@m6@3om^h0
ooK^00h0ooK^0P3D?AT?0?ofkP030=@m6@3om^h0ooK^00D0ooK^1P0000000`072Q<0000000000005
000000@03a8S00<0000000lB8`0?4R<01P0?4R<50000000301HJ=03D?AT05QXd00D05QXd00<00000
01HJ=00F6S@0100F6S@01@3D?AT05QXd0=@m6@0F6S@0000000<05QXd00@000000=@m6@000000e3dI
0P0000001@3D?AT08BYE0=@m6@3om^h0?EV[00`0ooK^00<0?EV[0?ofkP3om^h01P3om^h803eIZ`H0
ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0503eIZ`3om^h0ooK^0?of
kP0mFJ/04`3om^h303eIZ`D0ooK^00<000000?ofkP000000H@3om^h10?ooo`007P3om^h00`000000
ooK^0?ofkP0c0?ofkP030000003om^h0ooK^0280ooK^00<0e3dI0?ofkP3om^h00`3om^h01@3D?AT0
ooK^0?ofkP3om^h0e3dI00H0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP030?of
kP030=@m6@3om^h0ooK^00T0ooK^00@0e3dI0?ofkP3om^h0e3dI403om^h30=@m6@h0ooK^00<0e3dI
0?ofkP3om^h02`3om^h30=@m6A00ooK^00@0e3dI0?ofkP3om^h0ooK^0P00000200L:4`0300000007
2Q<01`XC00@000000P0?4R<00`0000003a8S00lB8`0700lB8`030000000?4R<03a8S00D000000P0F
6S@00`0000005QXd01HJ=0020=@m6@H05QXd00<0000001HJ=00F6S@0100F6S@00`3D?AT05QXd0=@m
6@05000000808BYE0P3D?AT3024ZE@80e3dI00<0000003eIZ`3om^h02`3om^h00`0mFJ/0ooK^0?of
kP0903eIZ`/0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0503eIZ`3o
m^h0ooK^0?ofkP0mFJ/03P3om^h603eIZ`030?ofkP0mFJ/0ooK^00@0ooK^00<000000?ofkP000000
H@3om^h10?ooo`007P3om^h00`000000ooK^0?ofkP0d0?ofkP030000003om^h0ooK^0240ooK^00<0
e3dI0?ofkP3om^h0103om^h0103D?AT0ooK^0?ofkP3D?AT60?ofkP030=@m6@3om^h0ooK^00@0ooK^
00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^0080ooK^
00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00T0ooK^
0P3D?AT30?ofkP030=@m6@3om^h0ooK^00`0ooK^1000000200L:4`H000001P0?4R<00`0000003a8S
00lB8`0500lB8`D00000200F6S@01@000000e3dI01HJ=00F6S@0e3dI00H05QXd00<0000001HJ=00F
6S@00`0000000`3D?AT000000=@m6@02024ZE@030000000Q:UD08BYE00808BYE0P3D?AT3024ZE@<0
e3dI00<0ooK^03eIZ`3om^h01`3om^h:03eIZ`80ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0
ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0
ooK^0?ofkP050?ofkPT0?EV[0P3om^h00`0mFJ/0ooK^03eIZ`050?ofkP030000003om^h000000640
ooK^0@3oool001h0ooK^00<000000?ofkP3om^h0=@3om^h00`000000ooK^0?ofkP0P0?ofkP030=@m
6@3om^h0ooK^00@0ooK^00@0e3dI0?ofkP3om^h0e3dI1`3om^h00`3D?AT0ooK^0?ofkP020?ofkP03
0=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP030?ofkP03
0=@m6@3om^h0ooK^00`0ooK^0P3D?ATA0?ofkP030=@m6@3om^h0ooK^00H0ooK^0P3D?AT50?ofkP03
0=@m6@3om^h0ooK^00@0ooK^3P00000300lB8`030000000?4R<03a8S00H03a8S00<0000000lB8`0?
4R<01@00000201HJ=0030000000F6S@05QXd00P05QXd00D0e3dI01HJ=00F6S@05QXd0=@m6@0401HJ
=0D00000100Q:UD00`3D?AT08BYE024ZE@02024ZE@040000000Q:UD08BYE024ZE@80e3dI0`0Q:UD3
0=@m6@040000000mFJ/0ooK^0?ofkP/0?EV[203om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3o
m^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3o
m^h0ooK^00P0?EV[203om^h00`0mFJ/0ooK^03eIZ`060?ofkP800000H@3om^h10?ooo`007@3om^h0
0`000000ooK^0?ofkP0f0?ofkP030000003om^h0ooK^0200ooK^0P3D?AT60?ofkP80e3dI2@3om^h0
1@3D?AT0ooK^0?ofkP3om^h0e3dI00P0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?of
kP050?ofkP030=@m6@3om^h0ooK^00X0ooK^00@0e3dI0?ofkP3om^h0e3dI403om^h00`3D?AT0ooK^
0?ofkP040?ofkP80e3dI203om^h00`3D?AT00000000000030000000300L:4`000000000000@00000
00<03a8S0000000?4R<01P0?4R<00`0000003a8S00lB8`0300lB8`L000001`0F6S@00`0000005QXd
01HJ=00701HJ=0030=@m6@0F6S@0000000805QXd00<0e3dI0000000000000P000002024ZE@030000
000Q:UD08BYE00@08BYE00<0e3dI024ZE@0Q:UD00P0Q:UD0100000008BYE024ZE@0Q:UD20=@m6@@0
8BYE00<0e3dI024ZE@0mFJ/00`0mFJ/00`3om^h0?EV[03eIZ`0303eIZ`<0ooK^00<0?EV[0?ofkP3o
m^h01`3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3o
m^h03P3om^h00`0mFJ/0ooK^03eIZ`0703eIZ`l0ooK^00<0?EV[0?ofkP0mFJ/01@3om^h200000640
ooK^0@3oool001d0ooK^00<000000?ofkP3om^h0=`3om^h00`000000ooK^0?ofkP0O0?ofkP80e3dI
1P3om^h20=@m6@T0ooK^00@0e3dI0?ofkP3om^h0e3dI2@3om^h00`3D?AT0ooK^0?ofkP040?ofkP03
0=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h02@3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI
0140ooK^00@0e3dI0?ofkP3om^h0ooK^0P3D?AT70?ofkP80000000<01`XC0000000000000P072Q<5
000000D03a8S00<0000000lB8`0?4R<00`0?4R<8000000@05QXd00<0000001HJ=00F6S@0200F6S@0
0`0000005QXd01HJ=00501HJ=0030=@m6@000000000000<0000000<08BYE0=@m6@0Q:UD01@0Q:UD0
0`0000008BYE024ZE@02024ZE@80e3dI1@0Q:UD01@0000008BYE024ZE@0Q:UD0e3dI00@08BYE00@0
e3dI024ZE@0Q:UD000000`0mFJ/80?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h0
2`3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00P0ooK^2@0mFJ/00`3om^h0?EV[
0?ofkP0B0?ofkP0303eIZ`3om^h0?EV[00D0ooK^00<000000?ofkP000000H03om^h10?ooo`007@3o
m^h00`000000ooK^0?ofkP0h0?ofkP030000003om^h0ooK^01l0ooK^0P3D?AT60?ofkP030=@m6@3o
m^h0ooK^00P0ooK^00<0e3dI0?ofkP3D?AT02P3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3o
m^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3o
m^h0ooK^00h0ooK^00@0e3dI0?ofkP3D?AT0e3dI103om^h4000000801`XC1P0000000`0?4R<00000
00lB8`0600lB8`030000000?4R<03a8S00@000000P0F6S@00`0000005QXd01HJ=00701HJ=0030000
000F6S@05QXd00P05QXd00<0000001HJ=00F6S@0100000001@3D?AT00000024ZE@0Q:UD0000000<0
8BYE00<0e3dI024ZE@0Q:UD0100Q:UD00`0000008BYE024ZE@02024ZE@030=@m6@0Q:UD0e3dI00@0
8BYE00D00000024ZE@0Q:UD08BYE0=@m6@04024ZE@80e3dI0P0000000`0mFJ/0ooK^0?ofkP080?of
kP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP050?of
kP0403eIZ`3om^h0ooK^0?ofkPX0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0
ooK^0140ooK^00<0?EV[0?ofkP0mFJ/00`3om^h3000000030?ofkP000000ooK^05l0ooK^0@3oool0
01d0ooK^00<000000?ofkP3om^h0>03om^h00`000000ooK^0?ofkP0O0?ofkP80e3dI1P3om^h20=@m
6@T0ooK^0P3D?AT;0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT02P3om^h00`3D?AT0ooK^0?ofkP06
0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h03P3om^h20=@m6@L0000000<01`XC
0000000000001000000400lB8`030000000?4R<03a8S00@03a8S1@00000601HJ=0030000000F6S@0
5QXd00L05QXd00<0000001HJ=00F6S@01P0F6S@5000000<08BYE00<0e3dI024ZE@0Q:UD00P0Q:UD0
1@0000008BYE024ZE@0Q:UD0e3dI00H08BYE00D00000024ZE@0Q:UD08BYE0=@m6@02024ZE@030=@m
6@0Q:UD08BYE00<08BYE00@00000024ZE@0Q:UD0e3dI1@0000001@3D?AT0:CM_0000003om^h0?EV[
00T0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^
00<0ooK^1P0mFJ/00`3om^h0?EV[03eIZ`0203eIZ`L0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0m
FJ/0ooK^0?ofkP0@0?ofkPH000000P3om^h00`000000ooK^0000001P0?ofkP40oooo000L0?ofkP03
0000003om^h0ooK^03X0ooK^00<000000?ofkP3om^h07P3om^h00`3D?AT0ooK^0=@m6@050?ofkP80
e3dI2P3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0e3dI00`0ooK^00<0e3dI0?ofkP3o
m^h0103om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00/0ooK^100000000`072Q<0
000000000005000000803a8S00<0000000lB8`0?4R<01@0?4R<00`0000003a8S0000000400000080
5QXd00<0000001HJ=00F6S@01P0F6S@00`0000005QXd01HJ=00701HJ=0030000000F6S@05QXd00H0
00000P0Q:UD00`0000008BYE024ZE@03024ZE@030=@m6@0Q:UD08BYE00808BYE00<00000024ZE@0Q
:UD00P0Q:UD00`3D?AT08BYE024ZE@03024ZE@040000000Q:UD08BYE0=@m6@<08BYE00@0e3dI024Z
E@0Q:UD08BYE100000000`3D?AT0:CM_0=@m6@0402TgK`050=@m6@0Y=fl000000?ofkP0mFJ/02@3o
m^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00X0ooK^1P0mFJ/20?ofkPD0?EV[2`3o
m^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00X0ooK^1P0000000`0mFJ/0ooK^03eI
Z`050?ofkP030000003om^h000000600ooK^0@3oool001`0ooK^00<000000?ofkP3om^h0>`3om^h0
0`000000ooK^0?ofkP0M0?ofkP030=@m6@3om^h0e3dI00D0ooK^00<0e3dI0?ofkP3D?AT02@3om^h2
0=@m6@/0ooK^00<0e3dI0?ofkP3D?AT0303om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0
ooK^00L0ooK^00<0e3dI0?ofkP3om^h01P3om^h3000000801`XC1@0000000`0?4R<0000000lB8`05
00lB8`030000000?4R<03a8S00<03a8S1@00000601HJ=0030000000F6S@05QXd00L05QXd00<00000
01HJ=00F6S@01@0F6S@5000000P08BYE00<00000024ZE@0Q:UD00P0Q:UD00`3D?AT08BYE024ZE@04
024ZE@050000000Q:UD08BYE024ZE@3D?AT01P0Q:UD0100000008BYE0=@m6@0Q:UD3000000030=@m
6@00000000000080:CM_00D0000002TgK`3D?AT0:CM_0=@m6@0402TgK`050=@m6@0Y=fl0:CM_0000
000mFJ/02P3om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00H0ooK^1@0mFJ/20?of
kPH0?EV[403om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00@0ooK^1P0000070?of
kP80?EV[1P3om^h200000600ooK^0@3oool001`0ooK^00<000000?ofkP3om^h0>`3om^h00`000000
ooK^0?ofkP0N0?ofkP030=@m6@3om^h0e3dI00@0ooK^00<0e3dI0?ofkP3D?AT02@3om^h20=@m6@`0
ooK^00<0e3dI0?ofkP3om^h0303om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00/0ooK^00<0e3dI0000
00000000100000000`072Q<0000000000004000000<03a8S0P00000600lB8`030000000?4R<00000
00@000000P0F6S@00`0000005QXd01HJ=00601HJ=0030000000F6S@05QXd00L05QXd00<0000001HJ
=00F6S@01@000002024ZE@030000000Q:UD08BYE00P08BYE00D00000024ZE@0Q:UD08BYE0=@m6@07
024ZE@050000000Q:UD08BYE024ZE@3D?AT0100Q:UD3000000030=@m6@000000000000<0:CM_00<0
e3dI02TgK`0Y=fl00P0Y=fl01@000000:CM_0=@m6@0Y=fl0e3dI00@0:CM_0P3D?AT0100Y=fl00000
0?ofkP0mFJ/90?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h01@0mFJ/20?ofkPD0
?EV[1P3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP00
00001000000=0?ofkP0303eIZ`3om^h0?EV[00D0ooK^0P00001P0?ofkP40oooo000L0?ofkP030000
003om^h0ooK^03`0ooK^00<000000?ofkP3om^h07@3om^h00`3D?AT0ooK^0=@m6@040?ofkP040=@m
6@3om^h0ooK^0=@m6@L0ooK^00@0e3dI0?ofkP3om^h0e3dI2`3om^h20=@m6@d0ooK^00@0e3dI0?of
kP3om^h0e3dI1`3om^h=0000000300lB8`000000000000D03a8S00@0000000lB8`0?4R<03a8S1`00
000601HJ=0030000000F6S@05QXd00L05QXd00<0000001HJ=00F6S@01@0F6S@5000000L08BYE00<0
0000024ZE@0Q:UD02@0Q:UD00`0000008BYE0=@m6@08024ZE@030000000Q:UD08BYE0080000000@0
e3dI00000000000000000P0Y=fl00`3D?AT0:CM_02TgK`0402TgK`030=@m6@0Y=fl0:CM_0080:CM_
00<000000=@m6@0Y=fl00P0Y=fl0103D?AT0:CM_02TgK`0Y=fl20=@m6@0402TgK`000000ooK^03eI
Z`T0ooK^00<0?EV[0?ofkP3om^h01@3om^h603eIZ`030?ofkP0mFJ/0?EV[00@0?EV[0P3om^h00`0m
FJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0000000000001000000B0?of
kP0303eIZ`3om^h0?EV[00D0ooK^00<000000?ofkP000000G`3om^h10?ooo`00703om^h00`000000
ooK^0?ofkP0l0?ofkP030000003om^h0ooK^01d0ooK^00@0e3dI0?ofkP3om^h0e3dI0`3om^h01@3D
?AT0ooK^0?ofkP3om^h0e3dI00H0ooK^00@0e3dI0?ofkP3om^h0e3dI2P3om^h00`3D?AT0ooK^0=@m
6@0>0?ofkP80e3dI1@3om^h30000000300L:4`000000000000D000001@0?4R<00`0000003a8S00lB
8`0200lB8`L000000`0F6S@00`0000005QXd01HJ=00701HJ=0030000000F6S@05QXd00H05QXd00<0
000001HJ=00F6S@01P000002024ZE@030000000Q:UD08BYE00L08BYE00<00000024ZE@0Q:UD02@0Q
:UD00`000000e3dI024ZE@06024ZE@D000000P0Y=fl00`3D?AT0:CM_02TgK`0302TgK`030=@m6@0Y
=fl0:CM_00@0:CM_00<0e3dI02TgK`0Y=fl00P0Y=fl00`000000e3dI02TgK`0202TgK`040=@m6@0Y
=fl0:CM_02TgK`80e3dI00@0:CM_0000003om^h0?EV[2@3om^h00`0mFJ/0ooK^03eIZ`0503eIZ`03
0?ofkP0mFJ/0?EV[00@0?EV[203om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00P0
ooK^1P0000050?ofkP0303eIZ`3om^h0ooK^0100ooK^0`0mFJ/50?ofkP030000003om^h0000005l0
ooK^0@3oool001/0ooK^00<000000?ofkP3om^h0?P3om^h00`000000ooK^0?ofkP0L0?ofkP050=@m
6@3om^h0ooK^0?ofkP3D?AT00P3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00H0ooK^00D0e3dI0?of
kP3om^h0ooK^0=@m6@090?ofkP040=@m6@3om^h0ooK^0=@m6@d0ooK^00<0e3dI0?ofkP3om^h02@00
000300lB8`030000000?4R<03a8S00<03a8S1`0000000`0F6S@0000001HJ=00701HJ=0030000000F
6S@05QXd00L05QXd00<0000001HJ=00F6S@0100F6S@5000000P08BYE00<00000024ZE@0Q:UD01`0Q
:UD00`0000008BYE024ZE@09024ZE@030=@m6@0Q:UD08BYE00H000000P0Y=fl00`000000:CM_02Tg
K`0202TgK`030=@m6@0Y=fl0:CM_0080:CM_00<0e3dI0000000Y=fl01P0Y=fl01P3D?AT0:CM_02Tg
K`0Y=fl0e3dI000000<0:CM_00/0e3dI02TgK`0Y=fl0:CM_0=@m6@0Y=fl0e3dI02TgK`000000ooK^
03eIZ`030?ofkPL0?EV[00<0ooK^03eIZ`0mFJ/0100mFJ/20?ofkP0303eIZ`3om^h0ooK^00T0ooK^
00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP020?ofkPH000001@3om^h00`0mFJ/0ooK^
0?ofkP030?ofkP0303eIZ`3om^h0ooK^00/0ooK^1P0mFJ/00`3om^h0?EV[0?ofkP040?ofkP030000
003om^h0000005l0ooK^0@3oool001/0ooK^00<000000?ofkP3om^h0?`3om^h00`000000ooK^0?of
kP0L0?ofkP040=@m6@3om^h0ooK^0=@m6@80ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^
0?ofkP030?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT0203om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI
00`0ooK^00<0e3dI03eIZ`3D?AT0100000000`0?4R<000000000000500lB8`040000000?4R<03a8S
00lB8`D000001P0F6S@00`0000005QXd01HJ=00501HJ=0030000000F6S@05QXd00L05QXd00<00000
01HJ=00F6S@01@000002024ZE@030000000Q:UD08BYE00P08BYE00<00000024ZE@0Q:UD01`0Q:UD0
0`0000008BYE024ZE@07024ZE@030000003D?AT0000000800000200Y=fl00`000000:CM_02TgK`03
02TgK`060=@m6@0Y=fl0:CM_02TgK`3D?AT000001`0Y=fl01P3D?AT0:CM_02TgK`0Y=fl0e3dI0000
00<0:CM_00T0e3dI02TgK`0Y=fl0:CM_0=@m6@0Y=fl0e3dI02TgK`0000001@0mFJ/30?ofkPD0?EV[
2@3om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^00D0ooK^1@00000;0?ofkP0303eI
Z`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h01P3om^h503eIZ`H0ooK^0P0mFJ/50?ofkP030000
003om^h0000005l0ooK^0@3oool001/0ooK^00<000000?ofkP3om^h0?`3om^h00`000000ooK^0?of
kP0L0?ofkP070=@m6@3om^h0ooK^0?ofkP3D?AT0ooK^0=@m6@040?ofkP030=@m6@3om^h0ooK^0080
ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^0080
ooK^00<0e3dI0?ofkP3om^h00`3om^h603eIZ`030=@m6@0000003a8S00@03a8S00<0000000lB8`0?
4R<00`0?4R<60000000301HJ=00000005QXd00L05QXd00<0000001HJ=00F6S@01P0F6S@00`000000
5QXd01HJ=00201HJ=0P000001`0Q:UD00`0000008BYE024ZE@07024ZE@030000000Q:UD08BYE00P0
8BYE00@00000024ZE@0Q:UD08BYE1@0000030=@m6@030000000Y=fl0:CM_00P0:CM_00<0000002Tg
K`0Y=fl00`0Y=fl0103D?AT0:CM_02TgK`3D?AT202TgK`030000000Y=fl0:CM_00@0:CM_00H0e3dI
02TgK`0Y=fl0:CM_0=@m6@00000402TgK`030=@m6@0Y=fl0e3dI0080:CM_00@000000=@m6@000000
ooK^1`0mFJ/20?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0
ooK^00000005000000030?ofkP0mFJ/0ooK^00d0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0
ooK^0?ofkP0503eIZ`/0ooK^00<0?EV[0?ofkP0mFJ/01@3om^h2000005l0ooK^0@3oool001/0ooK^
00<000000?ofkP3om^h0@03om^h00`000000ooK^0?ofkP0L0?ofkP060=@m6@3om^h0ooK^0=@m6@3o
m^h0e3dI1@3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00D0ooK^00<0e3dI0?ofkP3om^h0103om^h0
0`3D?AT0ooK^0?ofkP020?ofkP0303eIZ`3D?AT0?EV[00@0?EV[0P3om^h203eIZ`030000003D?AT0
3a8S00@03a8S0P00000300lB8`D000001@0F6S@00`0000005QXd01HJ=00501HJ=0030000000F6S@0
5QXd00@05QXd20000005024ZE@030000000Q:UD08BYE00L08BYE00<00000024ZE@0Q:UD01`0Q:UD0
0`0000008BYE024ZE@06024ZE@H00000100Y=fl01@3D?AT0:CM_02TgK`0Y=fl0e3dI00X0:CM_00<0
000002TgK`0Y=fl00`0Y=fl00`3D?AT0:CM_0=@m6@0302TgK`030000000Y=fl0:CM_00D0:CM_00D0
e3dI02TgK`3D?AT0:CM_0000000302TgK`040000003D?AT000000=@m6@80000000<0;d620=@m6@00
00000P0mFJ/80?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h01@3om^h6000000L0
ooK^00<0?EV[0?ofkP3om^h0303om^h0100mFJ/0ooK^0?ofkP3om^h603eIZ`d0ooK^100mFJ/00`3o
m^h0?EV[0?ofkP040?ofkP800000G`3om^h10?ooo`006P3om^h00`000000ooK^0?ofkP120?ofkP03
0000003om^h0ooK^01/0ooK^00@0e3dI0?ofkP3om^h0ooK^0P3D?AT60?ofkP040=@m6@3om^h0ooK^
0=@m6@H0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`0mFJ/0e3dI03eIZ`0303eIZ`80ooK^00<0e3dI
03eIZ`0mFJ/0100mFJ/2000000D03a8S1`0000000`0F6S@0000001HJ=00601HJ=0030000000F6S@0
5QXd00H05QXd00<0000001HJ=000000010000002024ZE@030000000Q:UD08BYE00L08BYE00<00000
024ZE@0Q:UD01`0Q:UD00`0000008BYE024ZE@08024ZE@030000000Q:UD08BYE00H000000P0Y=fl0
0`000000:CM_02TgK`0402TgK`030=@m6@0Y=fl0:CM_0080:CM_00<0e3dI02TgK`0Y=fl0200Y=fl0
0`000000:CM_02TgK`0402TgK`80e3dI0`0Y=fl00`000000:CM_02TgK`0502TgK`030=@m6@0Y=fl0
e3dI00D0000000@0;d620=@m6@0_@H80e3dI100_@H82000000030?ofkP0mFJ/0ooK^00H0ooK^00<0
?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^00000005000000@0ooK^00<0?EV[0?ofkP3om^h01P3o
m^h00`0mFJ/0ooK^0?ofkP090?ofkPL0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP070?ofkPH0?EV[0`3o
m^h00`0mFJ/0ooK^03eIZ`050?ofkP030000003om^h0000005h0ooK^0@3oool001X0ooK^00<00000
0?ofkP3om^h0@P3om^h00`000000ooK^0?ofkP0L0?ofkP030=@m6@3om^h0ooK^0080e3dI1P3om^h0
103D?AT0ooK^0?ofkP3D?AT60?ofkP030=@m6@0mFJ/0?EV[0080?EV[00<0e3dI03eIZ`0mFJ/01@0m
FJ/00`3D?AT0?EV[03eIZ`020?ofkP80000000<03a8S0=@m6@0000001P00000501HJ=0030000000F
6S@05QXd00D05QXd00<0000001HJ=00F6S@0100F6S@5000000H08BYE00<00000024ZE@0Q:UD0200Q
:UD00`0000008BYE024ZE@07024ZE@030000000Q:UD08BYE00H08BYE1@00000802TgK`030000000Y
=fl0:CM_0080:CM_0P3D?AT502TgK`030000003D?AT0:CM_00P0:CM_00<0000002TgK`0Y=fl0100Y
=fl00`3D?AT0:CM_02TgK`0202TgK`040000000Y=fl0:CM_02TgK`@0000000D0e3dI0000003D?AT0
?EV[0000000502m1PP80e3dI100_@H830000000303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3o
m^h01@3om^h6000000X0ooK^00<0?EV[0?ofkP3om^h01`3om^h0100mFJ/0ooK^0?ofkP3om^h703eI
Z`@0ooK^00<0?EV[0?ofkP3om^h00`3om^h0100mFJ/0ooK^0?ofkP3om^h603eIZ`T0ooK^00<0?EV[
0?ofkP0mFJ/01@3om^h00`000000ooK^0000001N0?ofkP40oooo000J0?ofkP030000003om^h0ooK^
04<0ooK^00<000000?ofkP3om^h06`3om^h20=@m6@80ooK^00<0e3dI0?ofkP3om^h01@3om^h20=@m
6@80ooK^1@0mFJ/00`3om^h0e3dI03eIZ`0203eIZ`030=@m6@0mFJ/0?EV[0080?EV[0`3om^h0100m
FJ/0e3dI0?ofkP3om^h5000000<05QXd00<0000001HJ=00F6S@01@0F6S@00`0000005QXd01HJ=006
01HJ=0030000000F6S@0000000@000000P0Q:UD00`0000008BYE024ZE@06024ZE@030000000Q:UD0
8BYE00P08BYE00<00000024ZE@0Q:UD01`0Q:UD00`0000008BYE024ZE@0600000080:CM_00<00000
02TgK`0Y=fl0200Y=fl01@000000:CM_02TgK`0Y=fl0e3dI00L0:CM_00<000000=@m6@0Y=fl0200Y
=fl00`000000:CM_02TgK`0302TgK`80e3dI0P0Y=fl6000000D0;d6200@0e3dI02m1PP0_@H800000
1@0_@H820=@m6@@0;d620`0000000`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00D00000
1@3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00D0ooK^1P0mFJ/;0?ofkP0403eI
Z`3om^h0ooK^0?ofkPH0?EV[3`3om^h00`0mFJ/0ooK^03eIZ`050?ofkP030000003om^h0000005h0
ooK^0@3oool001X0ooK^00<000000?ofkP3om^h0A03om^h00`000000ooK^0?ofkP0K0?ofkP80e3dI
00<0ooK^0=@m6@3D?AT01@3om^h00`0mFJ/0e3dI0=@m6@0203eIZ`030?ofkP0mFJ/0?EV[00<0?EV[
00@0e3dI03eIZ`0mFJ/0e3dI2@3om^h00`3D?AT0?EV[0000000701HJ=0030000000F6S@05QXd00D0
5QXd00<0000001HJ=00F6S@0100F6S@5000000H08BYE00<00000024ZE@0Q:UD01`0Q:UD00`000000
8BYE024ZE@08024ZE@030000000Q:UD08BYE00D08BYE1@00000802TgK`030000000Y=fl0:CM_00P0
:CM_00@0000002TgK`0Y=fl0e3dI200Y=fl00`000000e3dI02TgK`0802TgK`060000000Y=fl0:CM_
02TgK`000000e3dI0P0000001@3D?AT0000002m1PP0_@H80000000P0;d6200@0e3dI02m1PP0_@H80
00001@0_@H820=@m6@@0;d620P0000000`2X;A0000000?ofkP030?ofkPH000002P3om^h00`0mFJ/0
ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00D0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkPH0
?EV[0`3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0403eIZ`3om^h0ooK^03eIZ`@0ooK^00<000000?of
kP000000GP3om^h10?ooo`006P3om^h00`000000ooK^0?ofkP140?ofkP030000003om^h0ooK^01`0
ooK^00@0e3dI0?ofkP3om^h0e3dI1`0mFJ/00`3D?AT0?EV[03eIZ`0603eIZ`040?ofkP3D?AT0ooK^
0=@m6@X0ooK^00<0e3dI01HJ=00F6S@01@0F6S@00`0000005QXd01HJ=00501HJ=0030000000F6S@0
000000D000000P0Q:UD00`0000008BYE024ZE@06024ZE@030000000Q:UD08BYE00L08BYE00<00000
024ZE@0Q:UD01`0Q:UD00`0000008BYE024ZE@0600000080:CM_00<0000002TgK`0Y=fl0200Y=fl0
0`000000:CM_02TgK`0802TgK`030000003D?AT0e3dI00T0:CM_00<0000002TgK`3D?AT01P0Y=fl6
000000050=@m6@0_@H80;d6202m1PP3D?AT00`0_@H800`000000;d6202m1PP0502m1PP80e3dI0P0_
@H800`000000;d6202m1PP0402m1PP060=@m6@0_@H80;d6202m1PP000000fS`G1`0000030?ofkP03
03eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h01P3om^h503eIZ`L0ooK^00<0?EV[0?ofkP3o
m^h0103om^h603eIZ`80ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP03
03eIZ`3om^h0?EV[00D0ooK^0P00001N0?ofkP40oooo000I0?ofkP030000003om^h0ooK^04H0ooK^
00<000000?ofkP3om^h0603om^h303eIZ`80e3dI00<0?EV[0=@m6@3D?AT01P0mFJ/20=@m6@80?EV[
1@3om^h00`0mFJ/0e3dI0=@m6@080?ofkP<0?EV[1`0F6S@00`0000005QXd01HJ=00301HJ=0D00000
1`0Q:UD00`0000008BYE024ZE@06024ZE@030000000Q:UD08BYE00L08BYE00<00000024ZE@0Q:UD0
1P0Q:UD5000000P0:CM_00<0000002TgK`0Y=fl0200Y=fl00`000000:CM_02TgK`0802TgK`030=@m
6@0Y=fl0:CM_00T0:CM_00<0000002TgK`3D?AT01P00000202m1PP040000000_@H80;d620=@m6@@0
;d6200D0e3dI02m1PP0_@H80;d620000000702m1PP050=@m6@0_@H80e3dI02m1PP0000001P0_@H80
0`3D?AT00000000000060000000303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h02P3om^h0
0`0mFJ/0ooK^0?ofkP0503eIZ`<0ooK^00<0?EV[0?ofkP3om^h01`3om^h603eIZ`P0ooK^00<0?EV[
0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0303eIZ`3om^h0?EV[00D0ooK^0P00001N
0?ofkP40oooo000I0?ofkP030000003om^h0ooK^04H0ooK^00<000000?ofkP3om^h04P3om^h603eI
Z`80ooK^0P0mFJ/40=@m6@@0?EV[0P3om^h20=@m6@0303eIZ`3om^h0ooK^00<0ooK^00@0?EV[0?of
kP3om^h0e3dI0`3om^h603eIZ`030000000F6S@05QXd00D05QXd00<0000001HJ=000000010000002
024ZE@030000000Q:UD08BYE00L08BYE00<00000024ZE@0Q:UD01P0Q:UD00`0000008BYE024ZE@07
024ZE@030000000Q:UD08BYE00H000000P0Y=fl00`000000:CM_02TgK`0802TgK`030000000Y=fl0
:CM_00P0:CM_00<0000002TgK`0Y=fl01`0Y=fl00`3D?AT0000002TgK`0802TgK`D0000000<0e3dI
02m1PP0_@H801@0_@H800`000000;d620=@m6@0602m1PP040=@m6@0_@H80;d62000000H0;d6200H0
e3dI02m1PP0_@H80e3dI02m1PP00000202m1PPD000000`0_@H800`000000fS`G0=Xl5`03000000L0
ooK^00<0?EV[0?ofkP3om^h01`3om^h603eIZ`P0ooK^00@0?EV[0?ofkP3om^h0ooK^1`0mFJ/=0?of
kP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h0403om^h00`0mFJ/0ooK^03eIZ`050?of
kP030000003om^h0000005d0ooK^0@3oool001T0ooK^00<000000?ofkP3om^h0A`3om^h00`000000
ooK^0?ofkP0;0?ofkPH0?EV[0`3om^h803eIZ`@0e3dI1@3om^h00`3D?AT0ooK^0=@m6@0203eIZ`<0
ooK^00<0?EV[0?ofkP0mFJ/00P3D?AT503eIZ`80ooK^00<0000001HJ=00F6S@00`0F6S@5000000H0
8BYE00<00000024ZE@0Q:UD01`0Q:UD00`0000008BYE024ZE@07024ZE@030000000Q:UD08BYE00D0
8BYE1@00000802TgK`030000000Y=fl0:CM_00P0:CM_00<0000002TgK`0Y=fl0200Y=fl00`000000
:CM_02TgK`0502TgK`80e3dI00<0:CM_0000000Y=fl00P0Y=fl600000080;d6200@0000002m1PP0_
@H80e3dI1`0_@H800`000000e3dI02m1PP0602m1PP040=@m6@0_@H80;d62000000H0;d6200<0e3dI
02m1PP0000001@00000302m1PP030=@m6@0_@H80e3dI0080;d6200<000000=Xl5`3J?1L00`000007
0?ofkP0403eIZ`3om^h0ooK^0?ofkPH0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP060?ofkPH0?EV[1P3o
m^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h0403o
m^h0100mFJ/0ooK^0?ofkP0mFJ/40?ofkP030000003om^h0000005d0ooK^0@3oool001T0ooK^00<0
00000?ofkP3om^h0B03om^h00`000000ooK^0?ofkP050?ofkPL0?EV[0P3om^h703eIZ`<0ooK^00<0
?EV[0?ofkP3om^h00`3D?AT00`3om^h0e3dI0?ofkP030?ofkP040=@m6@3om^h0e3dI0?ofkPL0?EV[
0P3D?AT00`0mFJ/0ooK^0?ofkP030?ofkP030000000F6S@0000000@0000000<08BYE0000000Q:UD0
200Q:UD00`0000008BYE024ZE@07024ZE@030000000Q:UD08BYE00H08BYE00<00000024ZE@0Q:UD0
1P00000202TgK`030000000Y=fl0:CM_00P0:CM_00<0000002TgK`0Y=fl0200Y=fl00`000000:CM_
02TgK`0802TgK`030000000Y=fl0:CM_00@0:CM_00<0e3dI02TgK`0000001@00000802m1PP050000
000_@H80;d6202m1PP3D?AT01P0_@H800`000000e3dI02m1PP0702m1PP030=@m6@0_@H8000000080
;d621P00000202m1PP030=@m6@000000;d6200@0;d6200<0e3dI02m1PP3D?AT00P0_@H800`000000
fS`G0=Xl5`030000000403eIZ`3om^h0ooK^0?ofkPL0?EV[2@3om^h00`0mFJ/0ooK^0?ofkP0603eI
Z`80ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^
00<0ooK^00<0?EV[0?ofkP3om^h0403om^h0100mFJ/0ooK^0?ofkP0mFJ/40?ofkP030000003om^h0
000005d0ooK^0@3oool001P0ooK^00<000000?ofkP3om^h0B@3om^h00`000000ooK^0?ofkP0503eI
Z`<0ooK^1`0mFJ/30?ofkP80?EV[103om^h0100mFJ/0ooK^0?ofkP3om^h20=@m6@030?ofkP3D?AT0
ooK^00<0?EV[00@0e3dI03eIZ`0mFJ/0e3dI1@0mFJ/01@3om^h0e3dI0?ofkP3om^h0e3dI00@0ooK^
0`000006024ZE@030000000Q:UD08BYE00H08BYE00<00000024ZE@0Q:UD0200Q:UD00`0000008BYE
024ZE@04024ZE@D00000200Y=fl00`000000:CM_02TgK`0802TgK`030000000Y=fl0:CM_00P0:CM_
00<0000002TgK`0Y=fl0200Y=fl00`000000:CM_02TgK`02000000<0e3dI00@0000002m1PP0_@H80
00002`0_@H801@000000;d6202m1PP0_@H80e3dI00H0;d6200<0e3dI02m1PP0_@H801P0_@H860000
00<0;d6200<0e3dI02m1PP0_@H800P0_@H800`3D?AT0000002m1PP0402m1PP030=@m6@0_@H80e3dI
00<000000P3J?1L3000000@0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP070?ofkPH0?EV[203om^h00`0m
FJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0m
FJ/0ooK^0?ofkP0?0?ofkP@0?EV[103om^h00`000000ooK^0000001M0?ofkP40oooo000H0?ofkP03
0000003om^h0ooK^04L0ooK^1@0mFJ/30?ofkPL0?EV[2P3om^h0100mFJ/0ooK^0?ofkP0mFJ/20?of
kP80?EV[00D0e3dI03eIZ`3D?AT0?EV[0=@m6@0303eIZ`040=@m6@0mFJ/0?EV[0=@m6@80ooK^0P0m
FJ/20?ofkP040=@m6@3om^h0ooK^0=@m6@<0ooK^00<00000024ZE@0Q:UD01P0Q:UD00`0000008BYE
024ZE@07024ZE@030000000Q:UD08BYE00L08BYE00<00000024ZE@0Q:UD01@00000202TgK`030000
000Y=fl0:CM_00P0:CM_00<0000002TgK`0Y=fl01`0Y=fl00`000000:CM_02TgK`0902TgK`030000
000Y=fl0:CM_00H0:CM_1@0000020=@m6@<0;d6200@0e3dI02m1PP0_@H8000002`0_@H801@000000
;d6202m1PP0_@H80e3dI00D0;d6200<0e3dI0000000_@H800P0_@H850000000402m1PP3D?AT0;d62
000000@0;d6200<0e3dI02m1PP0_@H80100_@H800`3D?AT0;d6202m1PP03000000060=@m6@000000
00000=@m6@0dBI4000000P3J?1L4000000H0ooK^00@0?EV[0?ofkP3om^h0ooK^1P0mFJ/40?ofkP03
03eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP03
03eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h0203om^h803eIZ`80ooK^00<0?EV[0?ofkP3o
m^h00`3om^h2000005d0ooK^0@3oool001P0ooK^00<000000?ofkP3om^h0@`3om^h403eIZ`80ooK^
2@0mFJ/>0?ofkPH0?EV[00<0ooK^03eIZ`0mFJ/0103D?AT30?ofkP060=@m6@3om^h0ooK^0?ofkP3D
?AT0ooK^0P0mFJ/20?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT00P3om^h00`0000008BYE024ZE@06
024ZE@030000000Q:UD08BYE00L08BYE00<00000024ZE@0Q:UD01@0Q:UD5000000L0:CM_00<00000
02TgK`0Y=fl0200Y=fl00`000000:CM_02TgK`0702TgK`030000000Y=fl0:CM_00T0:CM_00<00000
02TgK`0Y=fl01P00000202m1PP030000003D?AT0e3dI00D0;d6200@0e3dI02m1PP0_@H8000002`0_
@H800`000000;d6202m1PP0202m1PP040=@m6@0_@H80;d6202m1PPH000001`0_@H800`3D?AT00000
02m1PP0202m1PP030=@m6@0_@H80;d6200<0;d620P0000000`3D?AT000000000000203A9T@060=@m
6@0dBI40=4VA03A9T@3D?AT0=4VA0P0000000`3J?1L0000000000002000000<0ooK^1`0mFJ/:0?of
kP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP0;0?of
kP0303eIZ`3om^h0ooK^00@0ooK^00@0?EV[0?ofkP3om^h0ooK^1`0mFJ/70?ofkP0403eIZ`3om^h0
ooK^03eIZ`D0ooK^0P00001M0?ofkP40oooo000H0?ofkP030000003om^h0ooK^0440ooK^300mFJ/3
0?ofkP0303eIZ`3om^h0ooK^00P0ooK^1@0mFJ/00`3om^h0?EV[03eIZ`0403eIZ`<0ooK^103D?AT2
0?ofkP060=@m6@3om^h0ooK^0?ofkP3D?AT0?EV[0P3om^h00`0mFJ/0ooK^0=@m6@030?ofkP030=@m
6@3om^h0000000P08BYE00<00000024ZE@0Q:UD01`0Q:UD00`0000008BYE024ZE@0600000080:CM_
00<0000002TgK`0Y=fl01`0Y=fl00`000000:CM_02TgK`0702TgK`030000000Y=fl0:CM_00P0:CM_
00<0000002TgK`0Y=fl01`0Y=fl5000000L0;d620P3D?AT802m1PP030=@m6@0_@H80000000/0;d62
00<0000002m1PP0_@H801P00000202m1PP030000000_@H80;d6200P0;d6200<0e3dI0000000_@H80
0P0_@H800`3D?AT000000000000300000080=4VA00<0e3dI03A9T@0dBI400P0dBI400`3D?AT0=4VA
03A9T@0203A9T@050=@m6@3oB1`000000=Xl5`0000001P0mFJ/30?ofkP0303eIZ`3om^h0ooK^00/0
ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00/0
ooK^00@0?EV[0?ofkP3om^h0ooK^1`0mFJ/?0?ofkP0303eIZ`3om^h0?EV[00D0ooK^00<000000?of
kP000000G03om^h10?ooo`00603om^h00`000000ooK^0?ofkP0o0?ofkP@0?EV[203om^h203eIZ`<0
ooK^00<0?EV[0?ofkP3om^h00`3om^h503eIZ`030?ofkP0mFJ/0?EV[00@0?EV[0P3om^h00`0mFJ/0
ooK^0?ofkP030?ofkP80e3dI00D0ooK^0=@m6@3D?AT0ooK^0=@m6@040?ofkP050=@m6@3om^h0ooK^
0?ofkP3D?AT01@3om^h00`3D?AT08BYE024ZE@07024ZE@030000000Q:UD08BYE00D08BYE1@000008
02TgK`030000000Y=fl0:CM_00L0:CM_00<0000002TgK`0Y=fl01`0Y=fl00`000000:CM_02TgK`08
02TgK`040000000Y=fl0:CM_02TgK`H0000000<0;d6203eIZ`0000001`0_@H820=@m6@0302m1PP00
0000;d6200L0;d6200<0e3dI02m1PP000000200_@H86000000<0;d620P3D?AT302m1PP030000000_
@H80;d6200L0;d6200<000000=@m6@0000000P0000000`3D?AT0=4VA03A9T@0603A9T@030000003D
?AT0=4VA0080=4VA00<0e3dI03A9T@0dBI400P0dBI400`3D?AT0?EV[03eIZ`0203eIZ`040=Xl5`00
00000000000000D0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eI
Z`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h0203om^h603eIZ`<0ooK^00<0?EV[0?ofkP3om^h0
403om^h0100mFJ/0ooK^0?ofkP0mFJ/40?ofkP030000003om^h0000005`0ooK^0@3oool001L0ooK^
00<000000?ofkP3om^h0?`3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0403eIZ`3om^h0?EV[0?ofkPD0
?EV[0P3om^h403eIZ`D0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`050?ofkP80e3dI00@0ooK^0=@m
6@3D?AT0e3dI103om^h01P3D?AT0ooK^0?ofkP3om^h0e3dI03eIZ`80ooK^0`0mFJ/00`3D?AT08BYE
024ZE@05024ZE@030000000Q:UD08BYE00H000000P0Y=fl00`000000:CM_02TgK`0702TgK`030000
000Y=fl0:CM_00L0:CM_00<0000002TgK`0Y=fl0200Y=fl00`000000:CM_02TgK`0602TgK`H00000
200_@H800`000000;d6202m1PP0302m1PP80e3dI0`0_@H800`000000;d6202m1PP0602m1PP030=@m
6@0_@H80000000<0;d621@00000302m1PP030000000_@H80;d6200<0;d6200<0e3dI02m1PP0_@H80
0P0_@H8010000000;d6202m1PP0_@H8600000080=4VA00@0e3dI03A9T@0dBI40e3dI1`0dBI400`00
0000=4VA0=@m6@0203A9T@030=@m6@0dBI40=4VA00<0=4VA00<000000?m8703oB1`00P000000103J
?1L000000:P]400000050?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h0203om^h0
0`0mFJ/0ooK^0?ofkP080?ofkP0403eIZ`3om^h0ooK^0?ofkPL0?EV[0P3om^h00`0mFJ/0ooK^0?of
kP040?ofkP0303eIZ`3om^h0ooK^0100ooK^00@0?EV[0?ofkP3om^h0?EV[103om^h00`000000ooK^
0000001L0?ofkP40oooo000G0?ofkP030000003om^h0ooK^03h0ooK^00<0?EV[0?ofkP3om^h0303o
m^h503eIZ`80ooK^1@0mFJ/90?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h00`3o
m^h00`3D?AT0ooK^0?ofkP020=@m6@<0ooK^00<0?EV[0?ofkP3D?AT00P0mFJ/01P3D?AT0?EV[03eI
Z`0mFJ/0ooK^000000L08BYE1@00000802TgK`030000000Y=fl0:CM_00L0:CM_00<0000002TgK`0Y
=fl01`0Y=fl00`000000:CM_02TgK`0802TgK`030000000Y=fl0:CM_00H000000P0_@H800`000000
;d6202m1PP0902m1PP040000000_@H80;d6202m1PP80e3dI1@0_@H800`000000;d6202m1PP0602m1
PPH00000200_@H8010000000;d6202m1PP0_@H830=@m6@80;d621P00000803A9T@030=@m6@0dBI40
e3dI00P0=4VA00<0000003A9T@3D?AT00P0dBI400`3D?AT0=4VA03A9T@0303A9T@060000003oB1`0
odPL0?m870000000fS`G0`0000050?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h0
203om^h00`0mFJ/0ooK^0?ofkP060?ofkPH0?EV[2@3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eI
Z`3om^h0ooK^00d0ooK^100mFJ/20?ofkP0303eIZ`3om^h0ooK^0080ooK^00<000000?ofkP000000
G03om^h10?ooo`005`3om^h00`000000ooK^0?ofkP0m0?ofkP0303eIZ`3om^h0ooK^00P0ooK^1@0m
FJ/20?ofkP0303eIZ`3om^h0?EV[0080?EV[3@3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3o
m^h0ooK^00<0ooK^0P3D?AT0103om^h0e3dI0=@m6@3D?AT403eIZ`040=@m6@3om^h0ooK^0=@m6@@0
?EV[00<00000024ZE@0000001@00000202TgK`030000000Y=fl0:CM_00L0:CM_00<0000002TgK`0Y
=fl0200Y=fl00`000000:CM_02TgK`0702TgK`030000000Y=fl0:CM_00H0:CM_1@00000802m1PP03
0000000_@H80;d6200T0;d6200@0000002m1PP3D?AT0e3dI1`0_@H800`000000;d6202m1PP060000
000302m1PP3D?AT0000000/0;d6200@0000002m1PP0_@H80e3dI0`0000001@3D?AT0000003A9T@0d
BI40000000/0=4VA00<000000=@m6@3D?AT0200dBI401P000000=4VA03A9T@3D?AT0=4VA0=@m6@D0
=4VA00H000000?m8703oB1`0odPL0000003J?1L30000000303eIZ`3om^h0ooK^00<0ooK^00<0?EV[
0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP070?ofkP0403eIZ`3om^h0ooK^0?ofkPD0?EV[0P3o
m^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h01P3o
m^h603eIZ`<0ooK^00@0?EV[0?ofkP3om^h0?EV[1@3om^h2000005`0ooK^0@3oool001L0ooK^00<0
00000?ofkP3om^h0?@3om^h00`0mFJ/0ooK^0?ofkP030?ofkPD0?EV[1P3om^h01@0mFJ/0ooK^0000
003om^h0?EV[00h0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP030?ofkP060=@m
6@0mFJ/0?EV[0=@m6@0mFJ/0e3dI100mFJ/20=@m6@<0ooK^00@0?EV[0000000000000000200Y=fl0
0`000000:CM_02TgK`0702TgK`030000000Y=fl0:CM_00P0:CM_00<0000002TgK`0Y=fl01`0Y=fl0
0`000000:CM_02TgK`0600000080;d6200<0000002m1PP0_@H80200_@H800`000000;d6202m1PP08
02m1PP<0e3dI1P0_@H86000000P0;d6200<0e3dI02m1PP0_@H801`0_@H84000000030=@m6@0dBI40
=4VA0080=4VA00D0e3dI03A9T@0dBI40=4VA0000000;03A9T@030000003D?AT0=4VA00P0=4VA00H0
000003A9T@0dBI40e3dI03A9T@3D?AT503A9T@080000003oB1`0odPL0?m870000000fS`G0000003J
?1L2000000D0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP050?ofkPH0?EV[1`3o
m^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h01P0m
FJ/90?ofkP0403eIZ`3om^h0ooK^03eIZ`D0ooK^0P00001L0?ofkP40oooo000F0?ofkP030000003o
m^h0ooK^03d0ooK^00<0?EV[0?ofkP0mFJ/0100mFJ/;0?ofkP0303eIZ`3om^h000000080ooK^00<0
?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP040?ofkPH0?EV[0P3D?AT0100mFJ/0e3dI0=@m
6@0mFJ/20=@m6@80ooK^0P3D?AT30?ofkP0303eIZ`000000:CM_00P0:CM_00<0000002TgK`0Y=fl0
200Y=fl00`000000:CM_02TgK`0702TgK`030000000Y=fl0:CM_00H0:CM_1@00000802m1PP030000
000_@H80;d6200P0;d6200<0000002m1PP0_@H801@0_@H830=@m6@0402m1PP3D?AT0;d6202m1PPD0
00000`0_@H800`000000;d6202m1PP0802m1PP040=@m6@0_@H80;d6202m1PPH000000P0dBI420=@m
6@D0=4VA00D0e3dI03A9T@0dBI40=4VA0000000;03A9T@80e3dI2@0dBI401@000000=4VA03A9T@0d
BI40e3dI00D0=4VA00<000000?m8703oB1`00P3oB1`010000000fS`G0000003J?1L2000000D0ooK^
00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP0503eIZ`80ooK^00<0?EV[0?ofkP3om^h0
203om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0403eIZ`3om^h0ooK^0?ofkPH0?EV[3`3om^h0100mFJ/0
ooK^0?ofkP0mFJ/50?ofkP030000003om^h0000005/0ooK^0@3oool001H0ooK^00<000000?ofkP3o
m^h0?03om^h303eIZ`l0ooK^00D0?EV[0?ofkP3om^h0ooK^000000020?ofkP0303eIZ`3om^h0ooK^
00T0ooK^00<0?EV[0?ofkP3om^h02`0mFJ/01`3om^h0e3dI0=@m6@3om^h0e3dI0?ofkP0mFJ/00`3D
?AT00`3om^h0e3dI0?ofkP030?ofkP030000000Y=fl0:CM_00L0:CM_00<0000002TgK`0Y=fl0200Y
=fl00`000000:CM_02TgK`0702TgK`030000000Y=fl0:CM_00H000000P0_@H800`000000;d6202m1
PP0802m1PP030000000_@H80;d6200P0;d6200<0000002m1PP0_@H800`0_@H820=@m6@0302m1PP00
0000000000@00000200_@H800`000000;d6202m1PP0602m1PP<0000000<0e3dI0000000000001`0d
BI400`3D?AT0000003A9T@0603A9T@040=@m6@0dBI40=4VA000000X0=4VA00@0e3dI03A9T@0dBI40
e3dI200dBI401@000000=4VA03A9T@0dBI40e3dI00D0=4VA00<000000?m8703oB1`00P3oB1`30000
0080fS`G00<000000?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP080?ofkPH0?EV[1`3om^h00`0m
FJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^00P0ooK^1P0mFJ/30?ofkP0303eIZ`3om^h0ooK^
0100ooK^00<0?EV[0?ofkP0mFJ/01@3om^h00`000000ooK^0000001K0?ofkP40oooo000F0?ofkP03
0000003om^h0ooK^03/0ooK^00<0?EV[0?ofkP3om^h0403om^h01@0mFJ/0ooK^0?ofkP3om^h00000
00<0ooK^00<0?EV[0?ofkP3om^h01P3om^h903eIZ`@0ooK^00<0?EV[0?ofkP3om^h00P3om^h01P3D
?AT0ooK^0=@m6@3D?AT0?EV[0=@m6@80ooK^0`3D?AT20?ofkP030000000Y=fl0:CM_00P0:CM_00<0
000002TgK`0Y=fl01`0Y=fl00`000000:CM_02TgK`0602TgK`D00000200_@H800`000000;d6202m1
PP0802m1PP030000000_@H80;d6200T0;d6200<0000002m1PP0000001@00000302m1PP030000003D
?AT0;d6200P0;d6200<0000002m1PP0_@H801P00000203A9T@030000003D?AT0=4VA00L0=4VA00<0
e3dI03A9T@0000001`0dBI40103D?AT0=4VA03A9T@00000903A9T@050=@m6@000000=4VA03A9T@3D
?AT01`0dBI4010000000=4VA03A9T@0dBI420=@m6@D0=4VA00H000000?m8703oB1`0odPL0000003o
B1`200000080fS`G0P0000040?ofkP0303eIZ`3om^h0ooK^0080ooK^1P0mFJ/30?ofkP0303eIZ`3o
m^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP030?ofkPD0?EV[0P3o
m^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^0100ooK^00@0?EV[0?ofkP3om^h0?EV[
103om^h00`000000ooK^0000001K0?ofkP40oooo000F0?ofkP030000003om^h0ooK^03/0ooK^00<0
?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP030?ofkP050000003om^h0ooK^0?ofkP0mFJ/0
0P3om^h803eIZ`X0ooK^00<0?EV[0?ofkP3om^h00P3om^h40=@m6@0303eIZ`3om^h0e3dI0080ooK^
103D?AT00`000000:CM_02TgK`0802TgK`030000000Y=fl0:CM_00L0:CM_00<0000002TgK`0Y=fl0
1P0000000`0_@H80?EV[0000000:02m1PP030000000_@H80;d6200P0;d6200<0000002m1PP0_@H80
1@0_@H86000000T0;d6200<0000002m1PP3D?AT01P0_@H85000000P0=4VA00<000000=@m6@0dBI40
1@0dBI420=@m6@80=4VA00<0000003A9T@0dBI401P0dBI400`3D?AT0=4VA0000000803A9T@030=@m
6@0dBI4000000080=4VA00<0e3dI03A9T@0dBI401@0dBI401`000000=4VA03A9T@0dBI40e3dI03A9
T@3D?AT00P0dBI43000000<0odPL00@000000?m87000000000000P3J?1L2000000<0ooK^1P0mFJ/9
0?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^03eIZ`03
03eIZ`L0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0403eIZ`3om^h0
ooK^03eIZ`@0ooK^00<000000?ofkP000000F`3om^h10?ooo`005P3om^h00`000000ooK^0?ofkP0j
0?ofkP0303eIZ`3om^h0ooK^0100ooK^00<0?EV[0?ofkP3om^h0103om^h803eIZ`@0ooK^00<0?EV[
0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP060=@m6@3om^h0e3dI0=@m6@3om^h0e3dI
0P3om^h0103D?AT0ooK^0=@m6@3om^h20=@m6@P0:CM_00<0000002TgK`0Y=fl01P0Y=fl5000000P0
;d6200<0000002m1PP0_@H80200_@H800`000000;d6202m1PP0802m1PP030000000_@H80;d6200D0
000000D0;d620=@m6@3D?AT0;d620000000:02m1PP030000000_@H80e3dI00H000000P0dBI400`00
0000=4VA03A9T@0803A9T@030000000dBI40e3dI00@0=4VA00<0e3dI03A9T@0dBI400P0dBI400`00
0000=4VA03A9T@0603A9T@030=@m6@0dBI40000000L0=4VA00@0e3dI03A9T@0dBI4000000`0dBI40
0`3D?AT0=4VA03A9T@0403A9T@040000000dBI40=4VA0=@m6@80000000<0e3dI0000000000000P0h
Cid01P000000odPL0?m8703oB1`000000?m8708000000P3J?1L2000000<0?EV[00<0ooK^03eIZ`3o
m^h03@3om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00D0ooK^1@0mFJ/;0?ofkP03
03eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h0403om^h0100mFJ/0ooK^0?ofkP0mFJ/50?of
kP800000F`3om^h10?ooo`005@3om^h00`000000ooK^0?ofkP0k0?ofkP0303eIZ`3om^h0ooK^00l0
ooK^00<0?EV[0?ofkP3om^h01@0mFJ/00`000000ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00@0
ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP<0e3dI00/0?EV[0=@m6@3o
m^h0e3dI0?ofkP3D?AT0ooK^0=@m6@3om^h0000002TgK`020=@m6@H0:CM_00<0000002TgK`0Y=fl0
1P00000202m1PP030000000_@H80;d6200P0;d6200<0000002m1PP0_@H80200_@H800`000000;d62
02m1PP0502m1PPH000000`0_@H830=@m6@<0;d6200<0000002m1PP0_@H801P0_@H85000000030=@m
6@0dBI40=4VA00D0=4VA00<0000003A9T@0dBI40200dBI400`000000=4VA0=@m6@0303A9T@030=@m
6@0dBI40=4VA0080=4VA00<0000003A9T@0dBI401`0dBI400`3D?AT0=4VA0000000603A9T@050=@m
6@0dBI40=4VA03A9T@0000000`0dBI400`3D?AT0=4VA03A9T@0203A9T@@0000000D0e3dI03Q?W@0h
Cid0>4nM0=@m6@0403Q?W@8000000P3oB1`010000000odPL0?m8700000020=Xl5`800000103om^h0
0`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h01@0mFJ/3
0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0?
0?ofkP@0?EV[1@3om^h2000005/0ooK^0@3oool001D0ooK^00<000000?ofkP3om^h0>P3om^h00`0m
FJ/0ooK^0?ofkP0=0?ofkPH0?EV[1P3om^h01@000000ooK^0?ofkP3om^h0?EV[00H0ooK^00<0?EV[
0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP020?ofkP80e3dI00@0?EV[0=@m6@3om^h0ooK^0P3D
?AT20?ofkP030=@m6@0Y=fl0:CM_0080:CM_103D?AT5000000P0;d6200<0000002m1PP0_@H80200_
@H800`000000;d6202m1PP0802m1PP030000000_@H80000000D000000`0_@H800`000000;d620=@m
6@030=@m6@H0;d6200<0000002m1PP0_@H801P00000203A9T@040000000dBI40=4VA0=@m6@L0=4VA
00<0000003A9T@0dBI40200dBI400`000000=4VA03A9T@030=@m6@D0=4VA00<0000003A9T@0dBI40
200dBI400`3D?AT0000003A9T@0503A9T@050=@m6@0dBI40=4VA03A9T@0000000P0dBI400`000000
e3dI0000000300000080>4nM00<0000003Q?W@3D?AT0100hCid01P3D?AT0>4nM03Q?W@000000odhO
00000080odPL00@000000?m8703oB1`000000P3J?1L3000000@0ooK^00<0?EV[0?ofkP3om^h02`3o
m^h00`0mFJ/0ooK^0?ofkP050?ofkPD0?EV[203om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3o
m^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h0203om^h803eIZ`80ooK^00<0?EV[0?ofkP3om^h00`3o
m^h00`000000ooK^0000001J0?ofkP40oooo000E0?ofkP030000003om^h0ooK^03X0ooK^00<0?EV[
0?ofkP3om^h01`3om^h603eIZ`<0ooK^00<0?EV[0?ofkP3om^h01`3om^h01@000000ooK^0?ofkP3o
m^h0?EV[00D0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP030?ofkP80e3dI00<0
ooK^0=@m6@3om^h00P3D?AT20?ofkP030=@m6@0Y=fl0:CM_00@0000000<0e3dI0000003D?AT0103D
?AT802m1PP030000000_@H80;d6200P0;d6200<0000002m1PP0_@H80100_@H86000000D0;d621P3D
?AT202m1PP030=@m6@0_@H80;d6200<0;d621@00000803A9T@050000000dBI40=4VA03A9T@3D?AT0
1P0dBI400`000000=4VA03A9T@0803A9T@040000000dBI40=4VA0=@m6@L0=4VA00<0000003A9T@0d
BI40200dBI400`3D?AT0000003A9T@0403A9T@030=@m6@0dBI40=4VA00D000000P0hCid00`3D?AT0
>4nM03Q?W@0303Q?W@030000003D?AT0>4nM00@0>4nM00H0e3dI03Q?W@0hCid000000?m>7`000002
0?m870040000003oB1`0odPL00000080fS`G0`0000040?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0
?EV[0?ofkP0mFJ/01@0mFJ/20?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h02`3o
m^h00`0mFJ/0ooK^0?ofkP040?ofkP0403eIZ`3om^h0ooK^0?ofkPL0?EV[203om^h00`0mFJ/0ooK^
03eIZ`050?ofkP030000003om^h0000005X0ooK^0@3oool001D0ooK^00<000000?ofkP3om^h0>@3o
m^h0100mFJ/0ooK^0?ofkP3om^h703eIZ`T0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`000000ooK^
0?ofkP020?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/03`3om^h00`0mFJ/0ooK^0?ofkP020?ofkP80
e3dI00@0ooK^0=@m6@3om^h0ooK^0P3D?AT0100mFJ/000000=@m6@00000402m1PP050=@m6@0_@H80
;d6202m1PP0000000P0_@H860=@m6@80;d6200<0000002m1PP0_@H80200_@H87000000@0;d6200<0
00000=@m6@3D?AT0103D?AT402m1PP060000000_@H80;d6202m1PP000000e3dI1000000203A9T@03
0000000dBI40=4VA00P0=4VA00D0000003A9T@0dBI40=4VA0=@m6@0603A9T@030000000dBI40=4VA
00P0=4VA00@000000=@m6@3D?AT0e3dI1`0dBI400`000000=4VA03A9T@0803A9T@040=@m6@000000
=4VA03A9T@80000000@0e3dI00000000000000000P0hCid00`000000>4nM03Q?W@0203Q?W@030=@m
6@0hCid0>4nM0080>4nM00<000000=@m6@0hCid01P0hCid00`3D?AT0>4nM000000020?m>7`800000
0`3oB1`3000000030=Xl5`000000000000@0ooK^00<0?EV[0?ofkP3om^h01`3om^h603eIZ`P0ooK^
00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^0080ooK^
1P0mFJ/?0?ofkP0303eIZ`3om^h0?EV[00D0ooK^00<000000?ofkP000000FP3om^h10?ooo`00503o
m^h00`000000ooK^0?ofkP0j0?ofkP@0?EV[3`3om^h00`0mFJ/0ooK^0?ofkP090?ofkP050000003o
m^h0ooK^0?ofkP0mFJ/00`3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^0080ooK^
00<0?EV[0=@m6@3D?AT00P3D?AT203eIZ`030=@m6@3om^h0000000L0;d6200@0e3dI02m1PP0_@H80
0000200_@H890=@m6@D000002`3D?AT802m1PPH0000000<0=4VA0=@m6@0dBI401@0dBI400`000000
=4VA03A9T@0803A9T@030000000dBI40=4VA0080=4VA00<0e3dI03A9T@0dBI400`0dBI400`000000
=4VA03A9T@0703A9T@80e3dI0`0dBI400`3D?AT0=4VA03A9T@0403A9T@030000000dBI40=4VA00L0
=4VA0P0000001@3D?AT000000000000hCid0e3dI00H0>4nM00<0000003Q?W@0hCid00P0hCid00`3D
?AT0>4nM03Q?W@0203Q?W@030=@m6@0hCid0>4nM00H0>4nM00<0e3dI03Q?W@0000000P3oCQl20000
0080odPL00@000000?m87000000000000P3J?1L2000000<0ooK^00@0?EV[0?ofkP3om^h0ooK^1P0m
FJ/50?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?of
kP0:0?ofkPD0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0403eIZ`3om^h0ooK^03eIZ`@0ooK^
00<000000?ofkP000000FP3om^h10?ooo`00503om^h00`000000ooK^0?ofkP0j0?ofkP0303eIZ`3o
m^h0ooK^0100ooK^00<0?EV[0?ofkP3om^h02P3om^h01@000000ooK^0?ofkP3om^h0?EV[0080ooK^
00<0?EV[0?ofkP3om^h0303om^h703eIZ`80e3dI00L0ooK^0=@m6@3D?AT0ooK^0=@m6@3om^h00000
00L0;d6200@0e3dI02m1PP0_@H8000002P0_@H87000000@0;d6200<0000002m1PP0_@H801@0_@H80
103D?AT0;d6202m1PP00000202m1PPH000000P0dBI400`000000=4VA03A9T@0303A9T@030=@m6@0d
BI40=4VA00<0=4VA00<0000003A9T@0dBI40200dBI400`000000=4VA03A9T@0203A9T@030=@m6@0d
BI40=4VA00<0=4VA00<0000003A9T@0dBI401@0dBI420=@m6@0303A9T@000000=4VA0080=4VA00<0
e3dI03A9T@0dBI40100dBI4010000000=4VA03A9T@0dBI4600000080>4nM00@0e3dI03Q?W@0hCid0
e3dI1`0hCid00`000000>4nM03Q?W@0303Q?W@050=@m6@0hCid0>4nM03Q?W@3D?AT0200hCid00`3D
?AT000000?m>7`030?m>7`050000003oB1`0odPL0000003oB1`00P0000000`3J?1L0e3dI00000008
03eIZ`/0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0
ooK^00D0ooK^1P0mFJ/60?ofkP0303eIZ`3om^h0ooK^0100ooK^00@0?EV[0?ofkP3om^h0?EV[1@3o
m^h2000005X0ooK^0@3oool001@0ooK^00<000000?ofkP3om^h0>@3om^h00`0mFJ/0ooK^0?ofkP0A
0?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<000000?ofkP3om^h00P3om^h00`0mFJ/0ooK^03eIZ`08
0?ofkPX0?EV[0P3om^h00`0mFJ/0ooK^0=@m6@020?ofkP050=@m6@3om^h0e3dI0=@m6@000000200_
@H800`3D?AT0;d620000000502m1PPH0000000<0e3dI02m1PP0_@H801`0_@H800`000000;d6202m1
PP0302m1PP<0000000<0e3dI0000000000000P00000803A9T@030000000dBI40=4VA00<0=4VA00<0
e3dI03A9T@0dBI400`0dBI400`000000=4VA03A9T@0803A9T@030000000dBI40=4VA00<0=4VA00<0
e3dI03A9T@0dBI400P0dBI400`000000=4VA03A9T@0303A9T@80e3dI0`0dBI401@000000=4VA03A9
T@0dBI40e3dI00@0=4VA1P00000803Q?W@030000003D?AT0e3dI00L0>4nM00<0000003Q?W@0hCid0
100hCid01@3D?AT0>4nM03Q?W@3D?AT0000000T0>4nM00<0e3dI0?m>7`3oCQl00P3oCQl00`000000
odPL03eIZ`0703eIZ`050000003om^h0ooK^0?ofkP0mFJ/03P3om^h00`0mFJ/0ooK^0?ofkP070?of
kP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h01@0mFJ/60?ofkP0303eIZ`3om^h0ooK^
00@0ooK^00<0?EV[0?ofkP3om^h03`3om^h0100mFJ/0ooK^0?ofkP0mFJ/50?ofkP800000FP3om^h1
0?ooo`00503om^h00`000000ooK^0?ofkP0i0?ofkP0303eIZ`3om^h0ooK^0140ooK^00<0?EV[0?of
kP3om^h02`3om^h010000000ooK^0?ofkP3om^h203eIZ`<0ooK^2P0mFJ/50?ofkP0403eIZ`3om^h0
ooK^03eIZ`80ooK^00<0e3dI0?ofkP3om^h00`3D?AT00`000000;d6202m1PP0602m1PP030=@m6@0_
@H80000000D000001@0_@H800`000000;d620=@m6@0602m1PPP000000`0dBI400`3D?AT0=4VA0000
000;03A9T@030000000dBI40=4VA00<0=4VA00<0e3dI03A9T@0dBI400P0dBI400`000000=4VA03A9
T@0803A9T@030000000dBI40=4VA00<0=4VA00<0e3dI03A9T@0dBI400P0dBI4010000000=4VA03A9
T@0dBI420=@m6@D0=4VA00<0000003A9T@0dBI400P000000103D?AT0000000000000000203Q?W@03
0000000hCid0>4nM00T0>4nM00<000000=@m6@0hCid01`0hCid00`000000>4nM03Q?W@0403Q?W@04
0=@m6@0hCid0e3dI000000X0>4nM00<0e3dI0?m>7`0mFJ/0100mFJ/01@3oB1`000000?m8703oB1`0
00000080fS`G0P0000030?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h01`3om^h0
0`0mFJ/0ooK^0?ofkP050?ofkPH0?EV[2`3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0
ooK^00l0ooK^00@0?EV[0?ofkP3om^h0?EV[1@3om^h00`000000ooK^0000001I0?ofkP40oooo000D
0?ofkP030000003om^h0ooK^03T0ooK^00<0?EV[0?ofkP3om^h04@3om^h00`0mFJ/0ooK^0?ofkP0;
0?ofkP030000003om^h0ooK^0080ooK^2@0mFJ/:0?ofkP0403eIZ`3om^h0ooK^03eIZ`80ooK^0P3D
?AT01@3om^h0e3dI0=@m6@3om^h0e3dI00D0;d621P00000:02m1PP030000000_@H80e3dI00H00000
0P0dBI400`000000=4VA03A9T@0703A9T@030=@m6@000000=4VA00X0=4VA00<0000003A9T@0dBI40
0`0dBI400`3D?AT0=4VA03A9T@0303A9T@030000000dBI40=4VA00L0=4VA00<0000003A9T@0dBI40
100dBI401P3D?AT0=4VA03A9T@0dBI40000003A9T@80e3dI1@0dBI4500000080>4nM00<0e3dI03Q?
W@0hCid00`0hCid00`000000>4nM03Q?W@0803Q?W@<0e3dI200hCid00`000000>4nM03Q?W@0503Q?
W@80e3dI00<0000003Q?W@0hCid0200hCid203eIZ`80odhO00D000000?m>7`000000odPL00000002
0?m870030000003J?1L0fS`G00<000000P3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0
ooK^00H0ooK^00<0?EV[0?ofkP0mFJ/01@0mFJ/30?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[
0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0303eIZ`3om^h0?EV[00D0ooK^00<00000
0?ofkP000000F@3om^h10?ooo`004`3om^h00`000000ooK^0?ofkP0j0?ofkP0303eIZ`3om^h0ooK^
0140ooK^00<0?EV[0?ofkP3om^h0303om^h00`000000?EV[03eIZ`0403eIZa40ooK^00<0?EV[0?of
kP0mFJ/00`3om^h00`3D?AT0ooK^0?ofkP020=@m6@H00000100_@H800`3D?AT0000002m1PP0702m1
PPD0000000<0e3dI03A9T@0dBI401@0dBI400`000000=4VA03A9T@0703A9T@030=@m6@0dBI400000
00X0=4VA00<0000003A9T@0dBI40100dBI400`3D?AT0=4VA03A9T@0203A9T@030000000dBI40=4VA
00L0=4VA00<0000003A9T@0dBI40100dBI40103D?AT0=4VA03A9T@0dBI420=@m6@0303A9T@000000
000000@000000P0hCid00`000000>4nM03Q?W@0303Q?W@030=@m6@0hCid0>4nM0080>4nM00<00000
03Q?W@0hCid01`0hCid01@3D?AT0000003Q?W@0hCid0e3dI00L0>4nM00<0000003Q?W@0hCid01@0h
Cid00`3D?AT0>4nM0000000:03Q?W@090000003oCQl0odhO0?m>7`000000odhO0000003oB1`00000
0080odPL00<000000=Xl5`3J?1L00`0000020?ofkP0303eIZ`3om^h0ooK^00d0ooK^00@0?EV[0?of
kP3om^h0ooK^1`0mFJ/90?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h0103om^h0
0`0mFJ/0ooK^0?ofkP0@0?ofkP0303eIZ`3om^h0?EV[00D0ooK^00<000000?ofkP000000F@3om^h1
0?ooo`004`3om^h00`000000ooK^0?ofkP0i0?ofkP0303eIZ`3om^h0ooK^0140ooK^00<0?EV[0?of
kP3om^h0203om^h603eIZ`030000003om^h0ooK^0080?EV[4P3om^h00`0mFJ/0ooK^03eIZ`020?of
kPH0000000<0ooK^0=@m6@0_@H80200_@H800`3D?AT0;d6202m1PP0600000080=4VA00@0000003A9
T@0dBI40e3dI1`0dBI400`000000=4VA03A9T@0803A9T@030=@m6@000000=4VA00T0=4VA00<00000
03A9T@0dBI40100dBI400`3D?AT0=4VA03A9T@0203A9T@030000000dBI40=4VA00L0=4VA00<00000
03A9T@0dBI401@0dBI430=@m6@<00000200hCid00`000000>4nM03Q?W@0303Q?W@030=@m6@0hCid0
>4nM0080>4nM00<0000003Q?W@0hCid01P0hCid00`3D?AT0>4nM0000000203Q?W@030=@m6@0hCid0
>4nM00D0>4nM00<0000003Q?W@0hCid0100hCid20=@m6@0303Q?W@000000>4nM00P0>4nM00<00000
0?m>7`3oCQl00P3oCQl010000000odhO0000000000030?m870<000000P3J?1L01@000000ooK^0?of
kP3om^h0?EV[00/0ooK^1`0mFJ/60?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h0
2P3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00d0ooK^100mFJ/00`3om^h0?EV[
0?ofkP040?ofkP030000003om^h0000005T0ooK^0@3oool001<0ooK^00<000000?ofkP3om^h0>@3o
m^h00`0mFJ/0ooK^0?ofkP0A0?ofkP0403eIZ`3om^h0ooK^0?ofkPL0?EV[1P3om^h00`000000ooK^
0?ofkP0203eIZa40ooK^1P0000020?ofkP060=@m6@3om^h0e3dI0=@m6@3om^h000000P3D?AT502m1
PP<0000000<0e3dI0000000dBI401`0dBI401@000000=4VA03A9T@0dBI40e3dI00L0=4VA00<00000
03A9T@0dBI401`0dBI400`3D?AT0000003A9T@0903A9T@030000000dBI40=4VA00D0=4VA00D0e3dI
03A9T@0dBI40=4VA0000000903A9T@030000000dBI40=4VA00@000000P3D?AT203Q?W@030000000h
Cid0>4nM00P0>4nM00<0000003Q?W@0hCid00`0hCid00`3D?AT0>4nM03Q?W@0203Q?W@030000000h
Cid0>4nM00@0>4nM0P3D?AT203Q?W@050000000hCid0>4nM03Q?W@3D?AT01P0hCid00`000000>4nM
03Q?W@0303Q?W@050=@m6@0hCid0>4nM0=@m6@0000002@0hCid01@000000odhO0?m>7`3oCQl00000
00<0odhO00D000000?m8703oB1`000000?m8700200000080fS`G0P0000020?ofkP0303eIZ`3om^h0
ooK^00<0ooK^1P0mFJ/30?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h0203om^h0
0`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h01P3om^h6
03eIZ`<0ooK^00<0?EV[0?ofkP0mFJ/01P3om^h2000005T0ooK^0@3oool001<0ooK^00<000000?of
kP3om^h0>@3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkPH0?EV[3P3om^h01@000000ooK^03eIZ`3om^h0
?EV[00/0ooK^1@0000020?ofkP0303eIZ`3om^h0ooK^00<0ooK^0P3D?AT01@3om^h0e3dI0=@m6@00
0000;d6200<0e3dI0`00000203A9T@030000003D?AT0=4VA00T0=4VA00@0000003A9T@0dBI40e3dI
1`0dBI400`000000=4VA03A9T@0803A9T@030=@m6@0dBI40=4VA00P0=4VA00<0000003A9T@0dBI40
1@0dBI401@3D?AT0=4VA03A9T@0dBI40000000D0=4VA1`0000001P0hCid0e3dI0=@m6@3D?AT0>4nM
0=@m6@80>4nM00<0000003Q?W@0hCid0200hCid00`000000>4nM03Q?W@0403Q?W@050=@m6@0hCid0
>4nM03Q?W@0000001@0hCid00`3D?AT0>4nM03Q?W@0203Q?W@050000000hCid0>4nM03eIZ`3D?AT0
1P0hCid00`000000>4nM03Q?W@0203Q?W@050=@m6@0hCid0>4nM03Q?W@3D?AT0200hCid3000000<0
odhO00D000000?m>7`3oCQl0odhO000000020?m870040000003oB1`0000000000080fS`G0P000000
0`3om^h0?EV[03eIZ`0503eIZ`T0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP08
0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP06
03eIZ`T0ooK^00@0?EV[0?ofkP3om^h0?EV[1@3om^h2000005T0ooK^0@3oool00180ooK^00<00000
0?ofkP3om^h0>P3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkPD0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP0@
0?ofkP040000000mFJ/0ooK^03eIZ`D0ooK^1P0000070?ofkP80?EV[1@3om^h40=@m6@80000000<0
e3dI03A9T@0dBI400P3D?AT403A9T@030000003D?AT0=4VA00P0=4VA00D0000003A9T@0dBI40=4VA
0=@m6@0603A9T@030000000dBI40=4VA00P0=4VA00<0e3dI03A9T@0dBI402@0dBI400`000000=4VA
03A9T@0503A9T@030=@m6@000000000000H00000100hCid010000000e3dI0=@m6@3D?AT503Q?W@03
0=@m6@0hCid0000000X0>4nM00<0000003Q?W@0hCid0100hCid01@3D?AT0>4nM03Q?W@0hCid00000
00@0>4nM00<0e3dI03Q?W@0hCid00`0hCid01@000000>4nM03Q?W@0hCid0e3dI00D0>4nM00<00000
03Q?W@0hCid00`0hCid01`3D?AT0>4nM03Q?W@0hCid000000=@m6@0hCid01P00000203]DZ0050000
003oCQl0odhO0?m>7`0000000`3oCQl01@000000odPL0?m870000000odPL008000000P3J?1L30000
00030?ofkP0mFJ/0ooK^00h0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP080?of
kP0303eIZ`3om^h0ooK^00/0ooK^00@0?EV[0?ofkP3om^h0ooK^1P0mFJ/?0?ofkP0403eIZ`3om^h0
ooK^03eIZ`D0ooK^00<000000?ofkP000000F03om^h10?ooo`004P3om^h00`000000ooK^0?ofkP0i
0?ofkP0303eIZ`3om^h0ooK^00D0ooK^1P0mFJ/70?ofkP0303eIZ`3om^h0ooK^0100ooK^00<00000
03eIZ`3om^h01P00000=0?ofkP80?EV[1@3om^h30=@m6@0503eIZ`3D?AT0=4VA03A9T@3D?AT00`0d
BI420=@m6@80=4VA00<000000=@m6@0dBI40200dBI400`000000=4VA03A9T@0203A9T@030=@m6@0d
BI40=4VA00<0=4VA00<0000003A9T@0dBI40200dBI400`000000e3dI03A9T@0903A9T@030000000d
BI40=4VA00D0000000@0e3dI03Q?W@0hCid000001P0hCid40=@m6@P0>4nM00<0e3dI03Q?W@000000
2P0hCid00`000000>4nM03Q?W@0403Q?W@050=@m6@0hCid0>4nM03Q?W@0000000P0hCid20=@m6@D0
>4nM00<0000003Q?W@0hCid00`0hCid00`3D?AT0>4nM03Q?W@0203Q?W@030000000hCid0>4nM0080
>4nM00<0e3dI03Q?W@0hCid00`0000000`3D?AT0000003]DZ00603]DZ0030000003oDR4000000080
odhO00P000000?m>7`3oCQl000000?m>7`000000odPL00000080odPL00<000000=Xl5`3J?1L00`00
00000`3om^h0?EV[0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h0203o
m^h00`0mFJ/0ooK^0?ofkP090?ofkPH0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0303eIZ`3o
m^h0?EV[00D0ooK^00<000000?ofkP000000F03om^h10?ooo`004P3om^h00`000000ooK^0?ofkP0i
0?ofkP0303eIZ`3om^h0ooK^00D0?EV[3@3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkPH0000000<0ooK^
03eIZ`3om^h0403om^h00`0mFJ/0ooK^03eIZ`020?ofkP<0?EV[0P3D?AT01@3om^h0e3dI0000000d
BI40e3dI00D0=4VA0P3D?AT00`000000=4VA0=@m6@0803A9T@030000000dBI40=4VA0080=4VA00<0
e3dI03A9T@0dBI400`0dBI400`000000=4VA03A9T@0903A9T@030=@m6@0dBI40=4VA00H0=4VA1@00
000603Q?W@030=@m6@0hCid0000000<0>4nM0`3D?AT303Q?W@030000000hCid0>4nM00L0>4nM00<0
e3dI0000000hCid02@0hCid00`000000>4nM03Q?W@0503Q?W@060=@m6@0hCid0>4nM0000000hCid0
e3dI1`0hCid00`000000>4nM03Q?W@0303Q?W@030=@m6@0hCid0>4nM0080>4nM00D0000003Q?W@0h
Cid000000=@m6@0300000080>eBX00<000000=@m6@0kE:P01`0kE:P01@000000oe8Q0000003oCQl0
000000<0odhO00D000000?m>7`000000odPL000000020?m870030000003J?1L0fS`G0080000000<0
Z2d@0000000mFJ/03`3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0
?EV[0?ofkP3om^h00P3om^h603eIZ`80ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?of
kP0?0?ofkP@0?EV[1@3om^h00`000000ooK^0000001H0?ofkP40oooo000B0?ofkP030000003om^h0
ooK^03T0ooK^0`0mFJ/A0?ofkP0303eIZ`3om^h0ooK^00T0ooK^1@0000030?ofkP0303eIZ`3om^h0
00000080ooK^00<0?EV[0?ofkP3om^h03P3om^h503eIZ`<0ooK^0`3D?AT01@3om^h0e3dI03A9T@0d
BI40e3dI00H0=4VA0`3D?AT903A9T@030000000dBI40=4VA0080=4VA00<0e3dI03A9T@0dBI400P0d
BI400`000000=4VA03A9T@0903A9T@030000003D?AT0=4VA00H000000P0hCid00`000000>4nM03Q?
W@0603Q?W@030=@m6@0hCid0000000<0e3dI1`0hCid00`000000>4nM03Q?W@0603Q?W@030=@m6@00
0000>4nM00T0>4nM00<0000003Q?W@0hCid01@0hCid01@3D?AT0>4nM03Q?W@000000e3dI00P0>4nM
00<0000003Q?W@0hCid00`0hCid00`000000e3dI00000005000000030=@m6@0kE:P0>eBX00<0>eBX
00@0000003]DZ00kE:P0e3dI1`0kE:P01@000000oe8Q0000003oCQl0000000<0odhO00D000000?m>
7`000000odPL000000020?m870030000003J?1L0fS`G00@0000000<0?EV[0?ofkP3om^h03@3om^h0
0`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00L0ooK^1P0mFJ/80?ofkP0303eIZ`3om^h0
ooK^00D0ooK^00<0?EV[0?ofkP3om^h0203om^h603eIZ`040?ofkP0mFJ/0ooK^03eIZ`D0ooK^00<0
00000?ofkP000000F03om^h10?ooo`004P3om^h00`000000ooK^0?ofkP0i0?ofkP0303eIZ`3om^h0
ooK^0140ooK^00<0?EV[0?ofkP3om^h00`3om^h6000000P0ooK^00<0?EV[0?ofkP0000000P3om^h0
0`0mFJ/0ooK^0?ofkP080?ofkPL0?EV[00<0ooK^03eIZ`3om^h01@3om^h20=@m6@0503eIZ`3D?AT0
=4VA03A9T@3D?AT01`0dBI400`000000e3dI0=@m6@020=@m6@H0=4VA00<0000003A9T@0dBI400P0d
BI400`3D?AT0=4VA03A9T@0303A9T@030000000dBI40=4VA00H0=4VA0`0000000`3D?AT0000003Q?
W@0703Q?W@030000000hCid0>4nM00D0>4nM103D?AT:03Q?W@030000000hCid0>4nM00L0>4nM00<0
e3dI0000000hCid0200hCid00`000000>4nM03Q?W@0603Q?W@<0e3dI1`0hCid80000000303]DZ03D
?AT0>eBX0080>eBX00<0000003]DZ03D?AT01P0kE:P010000000>eBX03]DZ03D?AT603]DZ0060000
003oDR40oe8Q0000003oCQl000000P3oCQl00`000000odhO0?m>7`02000000<0odPL0P0000000`3J
?1L000000=Xl5`020000000303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h01`3om^h0100m
FJ/0ooK^0?ofkP3om^h603eIZ`030?ofkP0mFJ/0ooK^00/0ooK^00<0?EV[0?ofkP3om^h01@3om^h0
100mFJ/0ooK^0?ofkP3om^h703eIZ`L0ooK^00<0?EV[0?ofkP0mFJ/01P3om^h2000005P0ooK^0@3o
ool00140ooK^00<000000?ofkP3om^h0>P3om^h00`0mFJ/0ooK^0?ofkP0A0?ofkPH000003P3om^h0
100mFJ/0ooK^0?ofkP0000020?ofkP0403eIZ`3om^h0ooK^0?ofkPH0?EV[1P3om^h00`0mFJ/0ooK^
0?ofkP0603eIZ`<0e3dI00D0000003A9T@0dBI40=4VA0=@m6@0603A9T@050000000dBI40=4VA0=@m
6@0dBI401@3D?AT00`0dBI40000003A9T@0403A9T@030=@m6@0dBI40=4VA0080=4VA00<0000003A9
T@0dBI401P00000203Q?W@030000000hCid0e3dI00P0>4nM00<0000003Q?W@3D?AT01@3D?AT203Q?
W@030=@m6@000000>4nM00T0>4nM00<0000003Q?W@0hCid01`0hCid00`3D?AT0000003Q?W@0803Q?
W@030000000hCid0>4nM00H0>4nM00<0e3dI03Q?W@0000000P0hCid500000080>eBX00<0000003]D
Z00kE:P0100kE:P01P3D?AT0>eBX03]DZ00kE:P000000=@m6@L0>eBX00D0000003]DZ00kE:P0>eBX
0=@m6@0503]DZ0050000003oDR40oe8Q0?mB8@0000000`3oCQl01@000000odhO0?m>7`3oCQl00000
0080odPL00H000000?m870000000fS`G0000003J?1L30000000303eIZ`3om^h0ooK^00d0ooK^00<0
?EV[0?ofkP3om^h00`3om^h703eIZ`L0ooK^00<0?EV[0?ofkP3om^h02`3om^h0100mFJ/0ooK^0?of
kP3om^h703eIZ`h0ooK^00@0?EV[0?ofkP3om^h0?EV[1@3om^h2000005P0ooK^0@3oool00140ooK^
00<000000?ofkP3om^h0>P3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkPH0000000<0?EV[0?ofkP3om^h0
4@3om^h01P0mFJ/0ooK^0?ofkP3om^h000000?ofkP@0?EV[2P3om^h603eIZ`H0ooK^0`3D?AT01000
0000=4VA03A9T@3D?AT603A9T@040000000dBI40=4VA0=@m6@H0=4VA1P3D?AT0100dBI40e3dI03A9
T@0dBI45000000P0>4nM00<0000003Q?W@3D?AT0100hCid60=@m6@T0>4nM00<0e3dI03Q?W@0hCid0
200hCid00`000000>4nM03Q?W@0703Q?W@030=@m6@000000>4nM00P0>4nM00<0000003Q?W@0hCid0
100hCid30=@m6@@000001`0kE:P00`000000>eBX03]DZ00503]DZ0050=@m6@0kE:P0000003]DZ03D
?AT01`0kE:P01@000000>eBX03]DZ00kE:P0e3dI00@0>eBX00<000000?mB8@3oDR400P3oDR401@00
0000odhO0?m>7`3oCQl0000000<0odhO00@000000?m8703oB1`000000P3oB1`2000000050=@m6@00
000000000000000mFJ/03`3om^h603eIZ`<0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^
0?ofkP080?ofkPH0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0403eIZ`3om^h0ooK^03eIZ`D0
ooK^00<000000?ofkP000000E`3om^h10?ooo`004@3om^h00`000000ooK^0?ofkP0i0?ofkP0303eI
Z`3om^h0ooK^00L0ooK^1@0000060?ofkP0303eIZ`3om^h0ooK^0140ooK^00L0?EV[0?ofkP3om^h0
ooK^0000003om^h0?EV[00L0ooK^1P0mFJ/20?ofkP0403eIZ`3om^h0ooK^03eIZ`H0ooK^103D?AT3
03A9T@030=@m6@0dBI40=4VA00<0=4VA00D0000003A9T@0dBI40=4VA0=@m6@0703A9T@040000000d
BI40=4VA000001P0e3dI1@0hCid00`000000>4nM03Q?W@0703Q?W@030=@m6@000000>4nM00P0>4nM
00<0000003Q?W@0hCid0200hCid00`3D?AT0>4nM03Q?W@0703Q?W@030000000hCid0>4nM00800000
0P3D?AT20000000303]DZ03D?AT0000000T0>eBX00<0000003]DZ00kE:P01@0kE:P0103D?AT0>eBX
0000003D?AT703]DZ0030000000kE:P0>eBX0080>eBX00L0e3dI03]DZ00kE:P0>eBX0=@m6@000000
?EV[00<0oe8Q00D000000?m>7`3oCQl0odhO000000030?m>7`040000003oB1`0odPL00000080odPL
0P0000001@3J?1L000000000003D?AT0?EV[00T0ooK^1`0mFJ/80?ofkP0303eIZ`3om^h0ooK^00T0
ooK^00@0?EV[0?ofkP3om^h0ooK^1`0mFJ/20?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?of
kP3om^h0403om^h00`0mFJ/0ooK^03eIZ`050?ofkP030000003om^h0000005L0ooK^0@3oool00140
ooK^00<000000?ofkP3om^h0>@3om^h0100mFJ/0ooK^0?ofkP3om^h6000000/0ooK^00<0?EV[0?of
kP3om^h04@3om^h00`0mFJ/0ooK^0?ofkP020?ofkP040000003om^h0?EV[0?ofkPD0?EV[203om^h0
1@0mFJ/0ooK^0?ofkP3om^h0?EV[00H0ooK^0P3D?AT01@000000e3dI03A9T@0dBI40e3dI00H0=4VA
00@0000003A9T@0dBI40e3dI0P0dBI48000000@0>4nM00D0e3dI03Q?W@0hCid0>4nM0000000:03Q?
W@030000000hCid0e3dI00P0>4nM00<0000003Q?W@0hCid0200hCid00`3D?AT0>4nM03Q?W@0703Q?
W@030000000hCid0>4nM00P0>4nM00<0e3dI03Q?W@0hCid00`0hCid700000080e3dI1@0kE:P00`3D
?AT0000003]DZ00703]DZ0030000000kE:P0>eBX00L0>eBX0P3D?AT803]DZ0030000000kE:P0>eBX
00<0>eBX00H0e3dI03]DZ03D?AT0>eBX0000000mFJ/20?mB8@050000003oDR4000000?m>7`000000
0`3oCQl01@000000odhO0000003oB1`0000000<0odPL00<000000=Xl5`0000000P000000100mFJ/0
ooK^0?ofkP3om^h603eIZ`H0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP060?of
kPL0?EV[2@3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^0100ooK^00<0?EV[0?of
kP0mFJ/01@3om^h00`000000ooK^0000001G0?ofkP40oooo000@0?ofkP030000003om^h0ooK^03P0
ooK^1P00000A0?ofkP0303eIZ`3om^h0ooK^0140ooK^00<0?EV[0?ofkP3om^h01P0mFJ/=0?ofkP05
03eIZ`3om^h0ooK^0?ofkP0mFJ/01`3om^h20=@m6@0503A9T@3D?AT0e3dI03A9T@3D?AT00`0dBI46
000000030=@m6@000000>4nM00@0>4nM00<0000003Q?W@0hCid0100hCid01@3D?AT0>4nM03Q?W@0h
Cid0000000X0>4nM00@0000003Q?W@0hCid0e3dI1`0hCid00`000000>4nM03Q?W@0803Q?W@030=@m
6@0hCid0>4nM00P0>4nM00<0000003Q?W@0hCid01@0hCid3000000030=@m6@000000000000800000
100kE:P00`000000>eBX0=@m6@0803]DZ0030=@m6@0kE:P0>eBX00H0>eBX00<0000003]DZ00kE:P0
1`0kE:P00`3D?AT0000003]DZ00703]DZ0030000000kE:P0>eBX00<0>eBX00H0e3dI03]DZ03D?AT0
00000?mB8@0mFJ/20?mB8@050000003oDR4000000?m>7`0000000`3oCQl01@000000odhO0000003o
B1`0000000<0odPL00<000000=Xl5`0000001P0mFJ/=0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0
?EV[0?ofkP3om^h01P0mFJ/30?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h01@3o
m^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0?EV[00D0ooK^00<000000?ofkP000000E`3o
m^h10?ooo`00403om^h00`000000ooK^0?ofkP0b0?ofkPH000000P3om^h00`0mFJ/0ooK^0?ofkP0A
0?ofkP0303eIZ`3om^h0ooK^00l0ooK^1P0mFJ/30?ofkP030000000mFJ/0ooK^00d0ooK^00D0?EV[
0?ofkP3om^h0ooK^03eIZ`070?ofkP80e3dI00<0000003A9T@0dBI400P3D?AT300000080>4nM00<0
000003Q?W@0hCid00P0hCid00`3D?AT0>4nM03Q?W@0403Q?W@030000000hCid0>4nM00@0>4nM00@0
e3dI03Q?W@0hCid000002P0hCid010000000>4nM03Q?W@3D?AT703Q?W@030000000hCid0>4nM00P0
>4nM00<000000=@m6@0hCid0200hCid00`000000>4nM03Q?W@0500000080>eBX00<000000=@m6@0k
E:P01`0kE:P20=@m6@T0>eBX00<0e3dI03]DZ00kE:P01P0kE:P00`000000>eBX03]DZ00503]DZ0<0
e3dI200kE:P00`000000>eBX03]DZ00503]DZ0070=@m6@0kE:P000000?mB8@0mFJ/0oe8Q00000002
0?mB8@030000003oCQl0000000<0odhO00D000000?m>7`000000odPL0000000603eIZ`80000000<0
?EV[0?ofkP3om^h03P3om^h0100mFJ/0ooK^0?ofkP3om^h703eIZ`T0ooK^00<0?EV[0?ofkP3om^h0
2P3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00l0ooK^00@0?EV[0?ofkP3om^h0
?EV[1@3om^h2000005L0ooK^0@3oool00100ooK^00<000000?ofkP3om^h0;03om^h6000000P0ooK^
00<0?EV[0?ofkP3om^h04@3om^h00`0mFJ/0ooK^0?ofkP080?ofkPL0?EV[0`3om^h00`0mFJ/0ooK^
0?ofkP040?ofkP030000000mFJ/0ooK^00`0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^
0?ofkP050?ofkP80e3dI0P0000000`0hCid0e3dI0=@m6@0503Q?W@050000000hCid0>4nM03Q?W@3D
?AT01P0hCid00`000000>4nM03Q?W@0403Q?W@050=@m6@0hCid0>4nM03Q?W@0000002P0hCid01000
0000>4nM03Q?W@3D?AT603Q?W@030000000hCid0>4nM00P0>4nM00<000000=@m6@0hCid01P0hCid5
000000L0>eBX00<0000003]DZ03D?AT01@0kE:P20=@m6@030000000kE:P0>eBX00P0>eBX00<0e3dI
03]DZ00kE:P01P0kE:P00`000000>eBX03]DZ00403]DZ0050=@m6@0kE:P0>eBX0000003D?AT01`0k
E:P00`000000>eBX03]DZ00503]DZ0070=@m6@0kE:P000000?mB8@0mFJ/0oe8Q000000030?mB8@04
0000003oCQl0odhO0?m>7`H0?EV[0`3oB1`3000000030=Xl5`000000?EV[00h0ooK^1P0mFJ/50?of
kP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP040?of
kP0303eIZ`3om^h0ooK^00l0ooK^00@0?EV[0?ofkP3om^h0?EV[1@3om^h2000005L0ooK^0@3oool0
0100ooK^00<000000?ofkP3om^h09`3om^h5000000h0ooK^00<0?EV[0?ofkP3om^h04@3om^h0100m
FJ/0ooK^0?ofkP3om^h703eIZ`X0ooK^00<0?EV[0?ofkP3om^h0103om^h00`000000?EV[0?ofkP0<
0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h01@3om^h30=@m6@<0>4nM00<0e3dI
03Q?W@0hCid00`0hCid00`000000>4nM03Q?W@0203Q?W@030=@m6@0hCid0>4nM00<0>4nM00<00000
03Q?W@0hCid01@0hCid0103D?AT0>4nM03Q?W@00000:03Q?W@040000000hCid0>4nM0=@m6@L0>4nM
00<0000003Q?W@0hCid01`0hCid00`000000>4nM0=@m6@0600000080>eBX00<0000003]DZ00kE:P0
1`0kE:P00`000000>eBX0=@m6@0303]DZ080e3dI0P0kE:P00`000000>eBX03]DZ00803]DZ0030000
003D?AT0>eBX00H0>eBX00<0000003]DZ00kE:P00`0kE:P01P3D?AT0>eBX03]DZ00kE:P000000=@m
6@L0>eBX00<0000003]DZ00kE:P0100kE:P20=@m6@070000003oDR40oe8Q03eIZ`3oDR4000000?mB
8@0603eIZ`050000003oCQl0odhO0?m>7`0000000`3oB1`01@000000odPL000000000000fS`G0080
000000<0?EV[0?ofkP3om^h01P3om^h503eIZ`80ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0
ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0
ooK^0?ofkP0?0?ofkP0403eIZ`3om^h0ooK^03eIZ`D0ooK^00<000000?ofkP000000EP3om^h10?oo
o`00403om^h00`000000ooK^0?ofkP0Q0?ofkPH000004`3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkPH0
?EV[4@3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3o
m^h00P3om^h00`0mFJ/0ooK^0?ofkP060?ofkP80e3dI100hCid20=@m6@@0>4nM00D0000003Q?W@0h
Cid0>4nM0=@m6@0603Q?W@030000000hCid0>4nM00@0>4nM00@0e3dI03Q?W@0hCid000002P0hCid0
1@000000>4nM03Q?W@0hCid0e3dI00H0>4nM00<0000003Q?W@0hCid01@0hCid4000000030=@m6@0k
E:P0>eBX00H0>eBX00<0000003]DZ00kE:P01`0kE:P00`000000>eBX03]DZ0030=@m6@@0>eBX00<0
000003]DZ00kE:P01`0kE:P00`000000>eBX0=@m6@0703]DZ0040000000kE:P0>eBX03]DZ080e3dI
100kE:P00`000000e3dI03]DZ00603]DZ0030000000kE:P0>eBX00<0>eBX00<0e3dI0000003D?AT0
1`0mFJ/20?mB8@050000003oCQl0odhO0?m>7`0000000`3oCQl01P000000odPL0?m8703oB1`00000
0?m87080000000@0fS`G000000000000?EV[0`3om^h503eIZ`L0ooK^00<0?EV[0?ofkP3om^h01P3o
m^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h0103o
m^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0303eIZ`3om^h0?EV[00D0ooK^00<000000?ofkP000000EP3o
m^h10?ooo`003`3om^h00`000000ooK^0?ofkP0L0?ofkPH00000603om^h00`0mFJ/0ooK^0?ofkP0;
0?ofkPD0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[
0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0403eIZ`3om^h0ooK^0?ofkPD0?EV[0P3D
?AT403Q?W@<0e3dI0P0hCid00`000000>4nM03Q?W@0203Q?W@030=@m6@0hCid0>4nM00<0>4nM00<0
000003Q?W@0hCid01@0hCid0103D?AT0>4nM03Q?W@00000903Q?W@050000000hCid0>4nM03Q?W@3D
?AT01P0hCid00`000000>4nM03Q?W@0500000080>eBX00@0000003]DZ00kE:P0e3dI1`0kE:P00`00
0000>eBX03]DZ00703]DZ0040000000kE:P0e3dI0=@m6@H0>eBX00<0000003]DZ00kE:P01`0kE:P0
10000000>eBX03]DZ03D?AT603]DZ0040000000kE:P0>eBX0=@m6@D0>eBX00@0000003]DZ00kE:P0
e3dI1@0kE:P00`000000>eBX03]DZ003000000050=@m6@000000?UVa03iI/@0000000P3oDR400`0m
FJ/000000?mB8@020?mB8@030000003oDR4000000080odhO00D000000?m>7`3oCQl0odhO00000003
0?m870050000003oB1`0odPL0000003J?1L00P00000403eIZ``0ooK^00<0?EV[0?ofkP3om^h01P3o
m^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h0103o
m^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0403eIZ`3om^h0ooK^03eIZ`@0ooK^00<000000?ofkP000000
EP3om^h10?ooo`003`3om^h00`000000ooK^0?ofkP0F0?ofkPH000007P3om^h00`0mFJ/0ooK^0?of
kP050?ofkPH0?EV[1`3om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0
?EV[0?ofkP3om^h02P3om^h0100mFJ/0ooK^0?ofkP3om^h603eIZ`D0ooK^0P3D?AT403Q?W@030=@m
6@0hCid0>4nM0080e3dI00<0000003Q?W@0hCid00`0hCid00`3D?AT0>4nM03Q?W@0303Q?W@030000
000hCid0>4nM00@0>4nM00@0e3dI03Q?W@0hCid000002P0hCid01P000000>4nM03Q?W@0hCid0e3dI
03Q?W@L000001`0kE:P010000000>eBX03]DZ03D?AT703]DZ0030000000kE:P0>eBX00H0>eBX0`3D
?AT00`0kE:P0e3dI03]DZ00503]DZ0030000000kE:P0>eBX00L0>eBX00@0000003]DZ00kE:P0e3dI
1@0kE:P010000000>eBX03]DZ03D?AT603]DZ0050000000kE:P0>eBX0=@m6@0kE:P01`00000203iI
/@0:0=@m6@0nFK40?UVa03iI/@000000oe@R0000003oDR40?EV[000000<0oe8Q00<000000?mB8@00
00000P3oCQl01P000000odhO0?m>7`000000odhO00000080odPL00D000000?m8703oB1`000000=Xl
5`020000000303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?of
kP090?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?of
kP0=0?ofkP@0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP030000003om^h0000005H0ooK^0@3o
ool000l0ooK^00<000000?ofkP3om^h04@3om^h5000002@0ooK^00<0?EV[0?ofkP3om^h01@0mFJ/=
0?ofkP0303eIZ`3om^h0ooK^0180ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/000000?ofkP08
0?ofkPH0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP070?ofkP80e3dI100hCid0103D?AT0>4nM03Q?W@0h
Cid30=@m6@<0>4nM00<0e3dI03Q?W@0hCid00`0hCid00`000000>4nM03Q?W@0503Q?W@030=@m6@0h
Cid0000000P0>4nM1P0000000`3D?AT0000003]DZ00303]DZ0030000000kE:P0>eBX00P0>eBX00@0
000003]DZ00kE:P0e3dI1P0kE:P00`000000>eBX03]DZ00303]DZ0<0e3dI00<0>eBX0000000kE:P0
0P0kE:P00`3D?AT0>eBX03]DZ00303]DZ0030000000kE:P0>eBX00L0>eBX00@0000003]DZ00kE:P0
e3dI1@0kE:P00`000000e3dI0=@m6@0503]DZ0D0000000<0e3dI0000000nFK400`0nFK401@000000
?UVa03iI/@0nFK40e3dI00@0?UVa00H000000?mD8P000000oe8Q0000000mFJ/20?mB8@040000003o
DR40oe8Q0?mB8@8000000`3oCQl00`000000odhO000000020?m870050000003oB1`0odPL0000003J
?1L00P0000000`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3o
m^h02@3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3o
m^h01`3om^h603eIZ`<0ooK^100mFJ/50?ofkP800000EP3om^h10?ooo`003`3om^h00`000000ooK^
0?ofkP0;0?ofkPH00000:@3om^h303eIZa80ooK^00<0?EV[0?ofkP3om^h04P3om^h00`0mFJ/0ooK^
0?ofkP070?ofkP0403eIZ`000000ooK^0?ofkPH0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP040?ofkP03
03eIZ`3om^h0ooK^00H0ooK^0P3D?AT503Q?W@060=@m6@0hCid0>4nM03Q?W@000000>4nM0P3D?AT2
03Q?W@030=@m6@0hCid0>4nM0080>4nM00<0000003Q?W@0hCid01@0hCid0103D?AT0>4nM03Q?W@00
000203Q?W@D000000P0kE:P00`000000>eBX03]DZ00203]DZ0030=@m6@0kE:P0>eBX00<0>eBX00<0
000003]DZ00kE:P01`0kE:P010000000>eBX03]DZ03D?AT603]DZ0030000000kE:P0>eBX00<0e3dI
1@0kE:P010000000>eBX03]DZ03D?AT503]DZ0030000000kE:P0>eBX00L0>eBX00D0000003]DZ00k
E:P0>eBX0=@m6@0403]DZ0030=@m6@0kE:P0>eBX00D000000P0nFK401@000000?UVa03iI/@0nFK40
e3dI00<0?UVa00D0000003iI/@0nFK40?UVa0=@m6@0403iI/@070000003oE280oe@R0000003oDR40
000003eIZ`020?mB8@040000003oDR40oe8Q0?mB8@8000000`3oCQl00`000000odhO0?m>7`020000
00<0odPL0`0000000`3J?1L0?EV[0000000?0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?of
kP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?of
kP3om^h01P0mFJ/50?ofkPD0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP800000EP3om^h10?oo
o`003P3om^h00`000000ooK^0?ofkP060?ofkPH00000;`3om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP03
03eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h01P3om^h403eIZ`P0ooK^00<0?EV[0?ofkP3o
m^h0103om^h00`0mFJ/0ooK^0?ofkP070?ofkP80e3dI100hCid00`3D?AT0>4nM03Q?W@0203Q?W@03
0000000hCid0>4nM00<0e3dI1@0hCid00`000000>4nM03Q?W@0303Q?W@80000000<0e3dI00000000
00000P00000803]DZ0050000000kE:P0>eBX03]DZ03D?AT01@0kE:P00`000000>eBX03]DZ00703]D
Z0050000000kE:P0>eBX03]DZ03D?AT01@0kE:P30=@m6@P0>eBX00D0000003]DZ00kE:P0>eBX0=@m
6@0403]DZ0030000000kE:P0>eBX00L0>eBX00D0000003]DZ00kE:P0>eBX0=@m6@0203]DZ0030000
003D?AT00000008000001P0nFK400`000000?UVa03iI/@0203iI/@050=@m6@0nFK40?UVa03iI/@00
00000P0nFK400`3D?AT0?UVa03iI/@0303iI/@070000003oE280oe@R0?mD8P000000oe8Q03eIZ`02
0?mB8@030000003oDR40oe8Q0080oe8Q00D000000?m>7`3oCQl0odhO000000020?m>7`8000000P3o
B1`01`000000odPL000000000000fS`G0000000mFJ/03`3om^h00`0mFJ/0ooK^0?ofkP050?ofkP03
03eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h02`3om^h0100mFJ/0ooK^0?ofkP3om^h603eI
Z`D0ooK^1P0mFJ/50?ofkP0303eIZ`3om^h0?EV[00D0ooK^00<000000?ofkP000000E@3om^h10?oo
o`003P3om^h00`000000ooK^0?ofkP06000003D0ooK^00<0?EV[0?ofkP3om^h04P3om^h00`0mFJ/0
ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP0000002@3om^h00`0mFJ/0
ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00D0ooK^0`0mFJ/20=@m6@@0>4nM00D0e3dI03Q?W@0h
Cid0>4nM0000000403Q?W@@0e3dI2000000203]DZ0030=@m6@0kE:P0000000X0>eBX00<0000003]D
Z00kE:P00P0kE:P00`3D?AT0>eBX03]DZ00203]DZ0030000000kE:P0>eBX00L0>eBX00D0000003]D
Z00kE:P0>eBX0=@m6@0203]DZ0<0e3dI00<0>eBX0000000kE:P0200kE:P01@000000>eBX03]DZ00k
E:P0e3dI00@0>eBX00<0000003]DZ00kE:P01`0kE:P00`000000>eBX03]DZ002000000<0e3dI00<0
?UVa0000000nFK401`0nFK400`000000?UVa03iI/@0303iI/@060=@m6@0nFK40?UVa0000000nFK40
e3dI1P0nFK402@000000oe@R0?mD8P3oE28000000?mB8@0mFJ/0oe8Q000000040?mB8@8000000P3o
CQl00`000000odhO0?m>7`020?m>7`050000003oB1`0odPL0000003oB1`00P0000000`3J?1L00000
03eIZ`0?0?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^
0?ofkP080?ofkPL0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP0503eIZ`/0ooK^00<0?EV[0?ofkP0mFJ/0
1@3om^h00`000000ooK^0000001E0?ofkP40oooo000>0?ofkP<00000>`3om^h00`0mFJ/0ooK^0?of
kP0B0?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0000
00080?ofkP0303eIZ`3om^h0ooK^00D0ooK^1`0mFJ/30?ofkP040000003D?AT0e3dI0=@m6@80>4nM
00<0e3dI03Q?W@0hCid00P0hCid00`000000>4nM03Q?W@03000000030=@m6@000000e3dI00@0e3dI
1P0kE:P00`3D?AT0>eBX0000000:03]DZ0050000000kE:P0>eBX03]DZ03D?AT01@0kE:P00`000000
>eBX03]DZ00703]DZ0030000000kE:P0e3dI00<0e3dI100kE:P00`000000>eBX03]DZ00703]DZ003
0000000kE:P0>eBX0080>eBX00D0e3dI03]DZ00kE:P0>eBX0000000503]DZ0L000000P0nFK401@3D
?AT0?UVa03iI/@0nFK40000000P0?UVa00<0000003iI/@0nFK400`0nFK401@3D?AT0?UVa0000000n
FK40e3dI00H0?UVa00<000000?mD8P3oE2800P3oE2801@000000oe8Q03eIZ`3oDR40000000@0oe8Q
00D000000?mB8@000000odhO000000040?m>7`050000003oB1`0odPL0000003oB1`00P000000103J
?1L0000003eIZ`3D?AT>0?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h02@3om^h0
100mFJ/0ooK^0?ofkP3om^h603eIZ`<0ooK^00@0?EV[0?ofkP3om^h0ooK^1P0mFJ/@0?ofkP0403eI
Z`3om^h0ooK^03eIZ`@0ooK^00<000000?ofkP000000E@3om^h10?ooo`003`3om^h00`000000ooK^
0?ofkP0j0?ofkP0303eIZ`3om^h0ooK^0180ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^
0?ofkP070?ofkP0303eIZ`3om^h0000000P0ooK^00<0?EV[0?ofkP3om^h01P0mFJ/90?ofkP050000
000hCid0e3dI03Q?W@3D?AT00P0hCid00`3D?AT0>4nM00000004000000<0>eBX00<0e3dI03]DZ00k
E:P00P0kE:P00`000000>eBX0=@m6@040=@m6@0403]DZ03D?AT0>eBX000000X0>eBX00<0000003]D
Z00kE:P00P0kE:P00`3D?AT0>eBX03]DZ00203]DZ0030000000kE:P0>eBX00<0>eBX1P3D?AT203]D
Z0030=@m6@0kE:P0>eBX00<0>eBX00<0000003]DZ00kE:P01`0kE:P00`000000>eBX03]DZ00203]D
Z0030=@m6@0kE:P0000000L00000100nFK400`000000?UVa03iI/@030=@m6@<0?UVa00<0000003iI
/@0nFK401P0nFK400`000000?UVa03iI/@0303iI/@040=@m6@0nFK4000000=@m6@L0?UVa00X00000
0?mD8P3oE280oe@R0000003oE280000003eIZ`3oDR4000000`3oDR401P000000oe8Q0?mB8@000000
odhO000000<0odhO00D000000?m>7`000000odPL000000020?m870050000003J?1L0000003eIZ`3D
?AT03P3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00L0ooK^1P0mFJ/70?ofkPH0
?EV[0`3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0403eIZ`3om^h0ooK^03eIZ`@0ooK^00<000000?of
kP000000E@3om^h10?ooo`00403om^h00`000000ooK^0?ofkP0i0?ofkP0303eIZ`3om^h0ooK^01<0
ooK^00<0?EV[0?ofkP3om^h04P3om^h00`0mFJ/0ooK^0?ofkP070?ofkP0403eIZ`3om^h0ooK^0000
00@0ooK^1P0mFJ/50?ofkP0303eIZ`3om^h0ooK^00P0ooK^00D0000003Q?W@3D?AT000000=@m6@02
000000050=@m6@0kE:P0>eBX03]DZ00000001@0kE:P01@3D?AT0>eBX03]DZ00kE:P0000000H0>eBX
2`3D?AT303]DZ0030000000kE:P0>eBX0080>eBX00<0e3dI03]DZ00kE:P00P0kE:P60=@m6@@0>eBX
00<0000003]DZ00kE:P00P0kE:P00`3D?AT0>eBX03]DZ00203]DZ0030000000kE:P0>eBX00L0>eBX
00<0000003]DZ00kE:P00P0000001@3D?AT0000003iI/@0nFK40000000T0?UVa00<000000=@m6@3D
?AT00`0nFK400`3D?AT0?UVa0000000803iI/@030000000nFK40?UVa00D0?UVa0P3D?AT703iI/@03
0000003oE280oe@R0080oe@R00D000000?mD8P000000oe8Q03eIZ`040?mB8@060000003oDR40oe8Q
0000003oCQl000000`3oCQl01@000000odhO0000003oB1`000000080odPL00D000000=Xl5`000000
?EV[0000000>0?ofkP0303eIZ`3om^h0ooK^00H0ooK^00@0?EV[0?ofkP3om^h0ooK^1P0mFJ/20?of
kP0403eIZ`3om^h0ooK^0?ofkPL0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0
ooK^0100ooK^00@0?EV[0?ofkP3om^h0?EV[1@3om^h2000005D0ooK^0@3oool00140ooK^00<00000
0?ofkP3om^h0>03om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^0180ooK^00<0?EV[
0?ofkP3om^h0203om^h703eIZ`<0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP08
0?ofkP80000000H0e3dI03]DZ00kE:P0e3dI03]DZ03D?AT303]DZ0030000000kE:P0>eBX00<0>eBX
00<0e3dI03]DZ00kE:P00P0kE:P00`000000>eBX03]DZ00603]DZ0030=@m6@000000>eBX00D0>eBX
3@3D?AT00`0kE:P0000003]DZ00703]DZ0030000000kE:P0>eBX0080>eBX00<0e3dI03]DZ00kE:P0
0P0kE:P00`000000>eBX03]DZ00303]DZ0L000000`0nFK40103D?AT0?UVa03iI/@00000803iI/@80
e3dI1@0nFK400`3D?AT0?UVa0000000803iI/@030000000nFK40?UVa00D0?UVa00<0e3dI03iI/@0n
FK401P0nFK401@000000oe@R0?mD8P3oE28000000080oe@R00<000000?mB8@0mFJ/00`3oDR400`00
0000oe8Q0?mB8@020?mB8@030000003oCQl0odhO0080odhO00D000000?m>7`000000odPL00000002
0?m870040000003J?1L0000003eIZ`8000003P3om^h00`0mFJ/0ooK^0?ofkP020?ofkPL0?EV[1@3o
m^h703eIZ`X0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0403eIZ`3o
m^h0ooK^03eIZ`D0ooK^0P00001E0?ofkP40oooo000A0?ofkP030000003om^h0ooK^03P0ooK^00<0
?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP0403eIZ`3om^h0ooK^0?ofkPP0?EV[
0P3om^h00`000000ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h0
203om^h00`000000>eBX0=@m6@0203]DZ0030=@m6@0kE:P0e3dI00<0>eBX00<0000003]DZ00kE:P0
0`0kE:P01@3D?AT0>eBX03]DZ00kE:P0000000P0>eBX00<0e3dI0000000kE:P02@0kE:P00`000000
>eBX03]DZ00203]DZ0030=@m6@0kE:P0>eBX0080>eBX00<0000003]DZ00kE:P01`0kE:P00`000000
>eBX03]DZ00203]DZ0030=@m6@0kE:P0000000L00000100nFK400`000000?UVa03iI/@0303iI/@04
0=@m6@0nFK40?UVa000000H0?UVa0P3D?AT00`000000?UVa03iI/@0503iI/@030=@m6@000000?UVa
00L0?UVa00<0000003iI/@0nFK40100nFK420=@m6@P0?UVa00D000000?mD8P3oE280oe@R00000003
0?mD8P030000000mFJ/0oe8Q0080oe8Q00<000000?mB8@3oDR400P3oDR401@000000odhO0?m>7`3o
CQl000000080odhO0P0000030?m870<0000000<0fS`G03eIZ`0000002`3om^h803eIZ`<0ooK^00<0
?EV[0?ofkP3om^h01P0mFJ/30?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h0103o
m^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0303eIZ`3om^h0?EV[00D0ooK^00<000000?ofkP000000E03o
m^h10?ooo`004P3om^h00`000000ooK^0?ofkP0h0?ofkP0303eIZ`3om^h0ooK^0180ooK^00<0?EV[
0?ofkP3om^h0403om^h603eIZ`L0ooK^00D0?EV[0?ofkP3om^h0ooK^000000050?ofkP0303eIZ`3o
m^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h0203om^h00`000000>eBX0=@m6@0303]DZ0<0e3dI0P0k
E:P00`000000>eBX03]DZ00303]DZ0030=@m6@0kE:P0>eBX0080>eBX00<0000003]DZ00kE:P01P0k
E:P00`3D?AT0000003]DZ00803]DZ0030000000kE:P0>eBX00<0>eBX00D0e3dI03]DZ00kE:P0>eBX
0000000903]DZ0030000000kE:P0>eBX0080000000D0e3dI0000000nFK40?UVa0000000903iI/@03
0000000nFK40?UVa00@0?UVa00<0e3dI03iI/@000000100nFK420=@m6@80?UVa00<0000003iI/@0n
FK401@0nFK400`3D?AT0000003iI/@0703iI/@030000000nFK40?UVa0080?UVa0P3D?AT00`000000
?UVa0=@m6@0603iI/@050000003oE280oe@R0?mD8P000000103oE2801@000000?EV[0?mB8@3oDR40
000000@0oe8Q0P0000030?m>7`050000003oCQl0odhO0?m>7`0000000P3oB1`01`000000odPL0000
00000000fS`G03eIZ`0000000`3om^h803eIZ`<0ooK^00@0?EV[0?ofkP3om^h0ooK^1`0mFJ/90?of
kP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0@0?of
kP0303eIZ`3om^h0?EV[00D0ooK^00<000000?ofkP000000E03om^h10?ooo`004`3om^h00`000000
ooK^0?ofkP0g0?ofkP0303eIZ`3om^h0ooK^0180ooK^00<0?EV[0?ofkP3om^h02`3om^h503eIZ`80
ooK^00<0?EV[0?ofkP3om^h0203om^h01@0mFJ/0ooK^0?ofkP3om^h0000000D0ooK^00<0?EV[0?of
kP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0403eIZ`000000>eBX0=@m6@@0>eBX00D0e3dI
03]DZ00kE:P0>eBX0000000503]DZ0050=@m6@0kE:P0>eBX03]DZ0000000200kE:P00`3D?AT00000
03]DZ00903]DZ0030000000kE:P0>eBX0080>eBX00<0e3dI03]DZ00kE:P00P0kE:P00`000000>eBX
03]DZ00203]DZ0L000000`0nFK40103D?AT0?UVa03iI/@00000903iI/@030000000nFK40?UVa00@0
?UVa00<0e3dI03iI/@0000000P0nFK420=@m6@@0?UVa00<0000003iI/@0nFK401P0nFK400`3D?AT0
?UVa03iI/@0503iI/@030000000nFK40?UVa0080?UVa00H0e3dI03iI/@0nFK40000003iI/@3D?AT6
03iI/@050000003oE280oe@R0?mD8P0000000`3oE2800`3D?AT0000003eIZ`020?mB8@030000003o
DR40oe8Q0080oe8Q00D000000?mB8@000000odhO000000040?m>7`060000003oB1`0odPL0000003o
B1`000001`0mFJ/80?ofkPL0?EV[1@3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^
00/0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0303eIZ`3om^h0?EV[
00D0ooK^00<000000?ofkP000000E03om^h10?ooo`00503om^h00`000000ooK^0?ofkP0f0?ofkP03
03eIZ`3om^h0ooK^0180ooK^00<0?EV[0?ofkP3om^h01@3om^h603eIZ`L0ooK^00<0?EV[0?ofkP3o
m^h02@3om^h01@0mFJ/0ooK^0?ofkP3om^h0000000D0ooK^00<0?EV[0?ofkP3om^h01P3om^h0100m
FJ/0ooK^0?ofkP3om^h603eIZ`80ooK^00<0000003]DZ03D?AT0100kE:P20=@m6@0303]DZ0000000
>eBX00D0>eBX00D0e3dI03]DZ00kE:P0>eBX0000000803]DZ0030=@m6@000000>eBX00P0>eBX00<0
000003]DZ00kE:P00`0kE:P00`3D?AT0>eBX00000006000000@0?UVa00<0000003iI/@0nFK400`0n
FK401@3D?AT0?UVa03iI/@0nFK40000000P0?UVa00<0000003iI/@0nFK401@0nFK40103D?AT00000
0=@m6@3D?AT603iI/@030000000nFK40?UVa00H0?UVa00<0e3dI03iI/@0nFK401@0nFK401@000000
?UVa03iI/@0nFK40e3dI00<0?UVa00@0000003iI/@0nFK40e3dI100nFK400`000000oe@R0?mD8P02
0?mD8P090000003oE280oe@R0?mD8P000000oe@R03eIZ`3oDR40000000@0oe8Q00H000000?mB8@3o
DR4000000?m>7`0000040?m>7`H0?EV[00<000000=Xl5`0mFJ/00P0000020?ofkPP0?EV[0`3om^h0
0`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h02P3om^h0
0`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^0100ooK^00@0?EV[0?ofkP3om^h0?EV[0`3o
m^h4000005@0ooK^0@3oool001D0ooK^00<000000?ofkP3om^h0=@3om^h00`0mFJ/0ooK^0?ofkP0B
0?ofkP0303eIZ`3om^h0ooK^00D0?EV[3@3om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0
ooK^0080ooK^00<000000?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP040?ofkPH0?EV[203om^h2
000000030=@m6@0kE:P0>eBX00<0>eBX0`3D?AT00`000000>eBX03]DZ00303]DZ0050=@m6@0kE:P0
>eBX03]DZ00000000P0kE:P00`0mFJ/0>eBX03]DZ00303]DZ0030=@m6@000000>eBX00T0>eBX00<0
000003]DZ00kE:P00P0000001@3D?AT0000003iI/@0nFK40000000P0?UVa00<0000003iI/@0nFK40
100nFK40103D?AT0?UVa03iI/@00000803iI/@030000000nFK40?UVa00@0?UVa0`3D?AT803iI/@03
0000000nFK40?UVa00H0?UVa00<0e3dI03iI/@0nFK401@0nFK4010000000?UVa03iI/@3D?AT303iI
/@050000000nFK40?UVa03iI/@3D?AT01@0000030?mD8P050000003oE280oe@R0?mD8P0000000P3o
E2800`000000?EV[000000040?mB8@040000003oDR40oe8Q000000H0?EV[00@0odhO0000003oB1`0
00000P3oB1`00`000000fS`G03eIZ`0200000080?EV[2`3om^h00`0mFJ/0ooK^0?ofkP060?ofkP03
03eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP030?ofkP03
03eIZ`3om^h0ooK^0100ooK^00@0?EV[000000000000?EV[0`0000020?ofkP800000E03om^h10?oo
o`005P3om^h00`000000ooK^0?ofkP0d0?ofkP0303eIZ`3om^h0ooK^00l0ooK^1P0mFJ/B0?ofkP03
03eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`000000ooK^0?ofkP020?ofkPL0
?EV[0P3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP030000003D?AT0e3dI00@0>eBX00<0e3dI03]DZ00k
E:P00P3D?AT503]DZ0050=@m6@0kE:P0>eBX03]DZ0000000200kE:P00`3D?AT0000003]DZ00403]D
Z0L000000`0nFK401@3D?AT0?UVa03iI/@0nFK40000000P0?UVa00<0000003iI/@0nFK400`0nFK40
103D?AT0?UVa03iI/@00000803iI/@040000000nFK40?UVa03iI/@<0e3dI00<0?UVa0=@m6@000000
200nFK400`000000?UVa03iI/@0503iI/@030000000nFK40e3dI00H0?UVa00<000000=@m6@3D?AT0
0`0nFK46000000030=@m6@11G[X0@Ejj008000000`3oE2801@000000oe@R0?mD8P3oE280000000<0
oe@R00@0?EV[0?mB8@3oDR40oe8Q1P0mFJ/00`000000odhO0?m>7`020?m>7`050000003oCQl00000
0?m8700000000P3oB1`01@000000fS`G0000000mFJ/0000000d0ooK^00<0?EV[0?ofkP3om^h01P3o
m^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h00`3o
m^h00`0mFJ/0ooK^0?ofkP0:0?ofkPH0000000@0?EV[0?ofkP3om^h0?EV[1@3om^h2000005@0ooK^
0@3oool001H0ooK^00<000000?ofkP3om^h0=03om^h00`0mFJ/0ooK^0?ofkP080?ofkPL0?EV[0`3o
m^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^00T0ooK^00@0?EV[0?ofkP3om^h0ooK^
1P0mFJ/80?ofkP0303eIZ`3om^h0ooK^00X0ooK^00@0000003eIZ`3D?AT0e3dI100kE:P0103D?AT0
>eBX03]DZ00000020=@m6@<0>eBX00D0e3dI03]DZ00kE:P0>eBX0000000703]DZ0030000003D?AT0
000000D00000100nFK400`000000?UVa03iI/@0303iI/@050=@m6@0nFK40?UVa03iI/@000000200n
FK400`000000?UVa03iI/@0403iI/@030=@m6@0nFK40000000T0?UVa0`3D?AT503iI/@030=@m6@0n
FK40?UVa00D0?UVa00<0000003iI/@0nFK401P0nFK400`000000?UVa0=@m6@0503iI/@030000003D
?AT0?UVa00@0000000<0@Ejj00000011G[X00`11G[X0203D?AT0@Ejj045N^P000000oe@S0000003o
E28000000`3oE2800`000000oe@R03eIZ`0603eIZ`030?mB8@000000oe8Q00<0oe8Q00D000000?m>
7`3oCQl0odhO000000020?m>7`8000000`3oB1`30000000303eIZ`000000000000`0ooK^00<0?EV[
0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[
0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP040?ofkPH000001`3om^h303eIZ`D0ooK^0P00001D
0?ofkP40oooo000G0?ofkP030000003om^h0ooK^03<0ooK^00@0?EV[0?ofkP3om^h0ooK^1`0mFJ/:
0?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h02@3om^h403eIZ`80ooK^00@00000
0?ofkP3om^h0?EV[203om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`000000e3dI00@0>eBX00H0
e3dI03]DZ00kE:P0>eBX0000000kE:P20=@m6@80>eBX00D0e3dI03]DZ00kE:P0>eBX0000000203]D
Z0@000000P0nFK400`3D?AT0000003iI/@0803iI/@030000000nFK40?UVa00<0?UVa00@0e3dI03iI
/@0nFK400000200nFK400`000000?UVa03iI/@0403iI/@040=@m6@0nFK40?UVa000000H0?UVa0P3D
?AT00`000000?UVa03iI/@0503iI/@030=@m6@0nFK40?UVa00D0?UVa00<0000003iI/@0nFK401P0n
FK401@000000?UVa03iI/@3D?AT0?UVa00<0000000<0e3dI0000000000001011G[X00`000000@Ejj
045N^P04045N^P060=@m6@000000oe@S0?mD8`000000oe@R1P0mFJ/20?mD8P030000000mFJ/0oe8Q
0080oe8Q00<000000?mB8@3oDR400P3oDR42000000<0odhO00D000000?m>7`3oCQl0odhO00000002
0?m870050000003oB1`000000000000mFJ/00P00000<0?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0
?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0
000003eIZ`000000100000080?ofkPH0?EV[00<0ooK^03eIZ`3om^h0103om^h00`000000ooK^0000
001C0?ofkP40oooo000H0?ofkP030000003om^h0ooK^0380ooK^100mFJ/A0?ofkP0303eIZ`3om^h0
ooK^01<0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP030?ofkP040000003om^h0
ooK^03eIZ`T0ooK^00<0?EV[0?ofkP3om^h02P3om^h0100mFJ/0e3dI0000003D?AT403]DZ0040=@m
6@0kE:P0>eBX000000<0>eBX0`3D?AT6000000H0?UVa00<0e3dI0000000nFK40200nFK400`000000
?UVa03iI/@0303iI/@050=@m6@0nFK40?UVa03iI/@0000001`0nFK400`000000?UVa03iI/@0503iI
/@030=@m6@0nFK40000000<0?UVa0`3D?AT203iI/@030000000nFK40?UVa00D0?UVa00<000000=@m
6@0nFK401@0nFK400`000000?UVa03iI/@0203iI/@L0000000<0e3dI00000011G[X00P3D?AT00`00
0000@Ejj045N^P04045N^P0300000011G[X0@Ejj00@0@Ejj00<0e3dI0000000mFJ/00`0mFJ/30?mD
8P030000003oE280oe@R0080oe@R00<0000003eIZ`0000000P3oDR400`000000oe8Q0?mB8@020?mB
8@030000003oDR4000000080odhO00D000000?m>7`3oCQl0odhO000000020?m870050000003oB1`0
00000000000mFJ/00P00000<0?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h0203o
m^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`000000000000<0000000<0ooK^03eIZ`3om^h01P3o
m^h603eIZ`80ooK^100mFJ/00`3om^h0?EV[0?ofkP040?ofkP030000003om^h0000005<0ooK^0@3o
ool001T0ooK^00<000000?ofkP3om^h0<@3om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP0303eIZ`3om^h0
ooK^01<0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP040?ofkP030000003om^h0
?EV[00T0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/00000000000020=@m6@<0>eBX00<0e3dI
0000000000001P0000030=@m6@80?UVa00<0000003iI/@0nFK401P0nFK400`3D?AT0000003iI/@08
03iI/@030000000nFK40?UVa00<0?UVa00@0e3dI03iI/@0nFK400000200nFK400`000000?UVa03iI
/@0403iI/@030=@m6@0nFK40000000<0e3dI1@0nFK400`000000?UVa03iI/@0503iI/@030000003D
?AT0?UVa00@0?UVa1P000004045N^P0400000011G[X0@Ejj045N^P80e3dI00<0@Ejj00000011G[X0
1@11G[X00`000000@Ejj045N^P05045N^P030000000mFJ/0oe@S0080oe@S00D000000?mD8P3oE280
oe@R000000030?mD8P060000003oE280oe@R03eIZ`3oDR400000103oDR401P000000oe8Q0?mB8@00
0000odhO000000@0odhO00@000000?m8703oB1`000000P3oB1`00`000000fS`G03eIZ`02000000/0
ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00@0
ooK^1`0000000`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00D0?EV[0P3om^h603eIZ`<0
ooK^00<0?EV[0?ofkP0mFJ/01@3om^h00`000000ooK^0000001C0?ofkP40oooo000J0?ofkP030000
003om^h0ooK^0300ooK^00<0?EV[0?ofkP3om^h04P3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eI
Z`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h0103om^h00`000000ooK^03eIZ`090?ofkP0303eI
Z`3om^h0ooK^00X0ooK^00@0?EV[0000003D?AT000000P3D?AT20000000303iI/@3D?AT0?UVa0080
?UVa00<0000003iI/@0nFK400`0nFK450=@m6@L0?UVa00<0e3dI0000000nFK40200nFK400`000000
?UVa03iI/@0303iI/@040=@m6@0nFK40?UVa000000P0?UVa00<0000003iI/@0nFK400`0nFK440=@m
6@P0?UVa00<0000003iI/@0nFK401@0nFK400`000000?UVa0=@m6@0400000003045N^P000000@Ejj
00L0@Ejj00D00000045N^P11G[X0@Ejj0=@m6@02045N^P0300000011G[X0@Ejj00@0@Ejj00<00000
045N^P11G[X01@11G[X010000000oe@S0?mD8`3oE2<200000080oe@R00<000000?mD8P3oE2800P3o
E2801P000000oe@R0?mD8P0mFJ/0oe8Q000000@0oe8Q00H000000?mB8@3oDR4000000?m>7`000003
0?m>7`050000003oCQl000000?m8700000000P3oB1`00`000000fS`G03eIZ`02000000`0ooK^00<0
?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`000000000000<00000203o
m^h00`0mFJ/0ooK^0?ofkP0603eIZ`030?ofkP0mFJ/0?EV[00@0?EV[2@3om^h0100mFJ/0ooK^0?of
kP0mFJ/50?ofkP800000D`3om^h10?ooo`006`3om^h00`000000ooK^0?ofkP0_0?ofkP0303eIZ`3o
m^h0ooK^0180ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3o
m^h0ooK^00@0ooK^00<000000?ofkP0mFJ/0203om^h00`0mFJ/0ooK^0?ofkP080?ofkPH0?EV[00<0
000003iI/@3D?AT00`0nFK40103D?AT0?UVa03iI/@00000503iI/@050=@m6@0nFK40?UVa03iI/@00
0000103D?AT403iI/@030=@m6@000000?UVa00L0?UVa00<0000003iI/@0nFK40100nFK400`3D?AT0
?UVa0000000803iI/@H0e3dI0P0nFK400`3D?AT0?UVa0000000703iI/@030000000nFK40?UVa0080
?UVa1@0000000`3D?AT0@Ejj045N^P03045N^P0300000011G[X0@Ejj00D0@Ejj00<00000045N^P11
G[X00`3D?AT00`11G[X00000045N^P05045N^P0300000011G[X0@Ejj00D0@Ejj00<000000?mD8`3o
E2<00P3oE2<200000080oe@R00D000000?mD8P3oE280oe@R000000030?mD8P0303eIZ`000000oe8Q
00<0oe8Q00<000000?mB8@3oDR400P3oDR400`000000odhO0?m>7`020?m>7`050000003oCQl00000
0?m8700000000P3oB1`00`000000fS`G03eIZ`02000000`0ooK^00<0?EV[0?ofkP3om^h01`3om^h0
100mFJ/0ooK^0?ofkP3om^h70000000303eIZ`3om^h0ooK^00P0ooK^1P0mFJ/00`3om^h0?EV[03eI
Z`0403eIZ`l0ooK^00@0?EV[0?ofkP3om^h0?EV[1@3om^h2000005<0ooK^0@3oool001/0ooK^00<0
00000?ofkP3om^h0;`3om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0
?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP050?ofkP030000000mFJ/0ooK^00L0ooK^00<0
?EV[0?ofkP3om^h00P3om^h603eIZ`80ooK^00<0?EV[0?ofkP3om^h00`0000001@0nFK40e3dI03iI
/@0nFK40e3dI00<0?UVa00<0000003iI/@0nFK400`0nFK401@3D?AT0?UVa03iI/@0nFK40000000<0
?UVa1@3D?AT00`000000?UVa03iI/@0703iI/@040000000nFK40?UVa03eIZ`80?UVa00D0e3dI03iI
/@0nFK40000003iI/@060=@m6@030000000nFK40?UVa00H0?UVa00<0e3dI0000000nFK400`0nFK48
000000<0@Ejj00@00000045N^P11G[X0e3dI1011G[X00`000000@Ejj045N^P05045N^P030000003D
?AT0e3dI00<0@Ejj00<0e3dI00000011G[X01@11G[X00`000000@Ejj045N^P04045N^P030000003o
E2<0oe@S0080oe@S00<000000?mD8`3oE2<00P0000030?mD8P030000003oE280oe@R0080oe@R00<0
?EV[0000003oDR400`3oDR400`000000oe8Q0?mB8@020?mB8@050000003oCQl0odhO0?m>7`000000
0P3oCQl2000000<0odPL0P000000100mFJ/0fS`G00000000000;0?ofkP0303eIZ`3om^h0ooK^00D0
ooK^0P000000100mFJ/000000000000000070?ofkP0403eIZ`3om^h0ooK^0?ofkPh0?EV[0P3om^h0
0`0mFJ/0ooK^0?ofkP0A0?ofkP0303eIZ`3om^h0?EV[00D0ooK^0P00001C0?ofkP40oooo000L0?of
kP030000003om^h0ooK^02h0ooK^00<0?EV[0?ofkP3om^h04P3om^h00`0mFJ/0ooK^0?ofkP0C0?of
kP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`000000?EV[0?ofkP070?of
kPD0?EV[203om^h00`0mFJ/0ooK^0?ofkP0300000080?UVa0P3D?AT00`0nFK40e3dI03iI/@0203iI
/@030000000nFK40?UVa0080?UVa00<0e3dI03iI/@0nFK400P0nFK400`000000?UVa03iI/@0403iI
/AH0e3dI1`0nFK400`000000?UVa03iI/@0203iI/@<0000000<0e3dI0000000000000`000003045N
^P0300000011G[X0@Ejj00D0@Ejj00@00000045N^P11G[X0e3dI1011G[X00`000000@Ejj045N^P05
045N^P030=@m6@11G[X0@Ejj00<0@Ejj00<0e3dI00000011G[X01@11G[X00`000000@Ejj045N^P04
045N^P030000003oE2<0oe@S0080oe@S00<000000?mD8`3oE2<00P0000030?mD8P030000003oE280
oe@R0080oe@R00<0000003eIZ`3oDR400P3oDR400`000000oe8Q0?mB8@020?mB8@8000000`3oCQl0
1@000000odhO0?m>7`3oCQl000000080odPL00D000000?m870000000000003eIZ`02000000/0ooK^
00<0?EV[0000000000001@0000020?ofkP0303eIZ`3om^h0ooK^00D0ooK^3P0mFJ/30?ofkP0303eI
Z`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h04@3om^h00`0mFJ/0ooK^03eIZ`050?ofkP030000
003om^h000000580ooK^0@3oool001d0ooK^00<000000?ofkP3om^h0;@3om^h00`0mFJ/0ooK^0?of
kP0C0?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?of
kP060?ofkP0303eIZ`3om^h0ooK^00L0?EV[3@3om^h00`0mFJ/0ooK^0?ofkP03000000<0?UVa0P3D
?AT403iI/@030000000nFK40?UVa0080?UVa00D0e3dI03iI/@0nFK40?UVa0000000803iI/@030=@m
6@000000?UVa00L0?UVa00<0000003iI/@0nFK400`0nFK400`3D?AT0?UVa0000000703iI/@H00000
1011G[X00`3D?AT0@Ejj045N^P05045N^P0300000011G[X0@Ejj00D0@Ejj00D00000045N^P11G[X0
@Ejj0=@m6@03045N^P0300000011G[X0@Ejj00<0@Ejj0P3D?AT00`000000@Ejj045N^P03045N^P03
0000003D?AT0@Ejj00@0@Ejj00<00000045N^P11G[X01011G[X00`000000oe@S0?mD8`020?mD8`05
0000003oE2<0oe@S0?mD8`0000000`3oE2800`000000oe@R0?mD8P030?mD8P030000000mFJ/00000
0080oe8Q00<000000?mB8@3oDR400P3oDR400`000000oe8Q000000020?m>7`050000003oCQl0odhO
0?m>7`0000000P3oB1`01@000000odPL000000000000?EV[00<000001@3om^h50000000303eIZ`3o
m^h0ooK^00P0ooK^3@0mFJ/;0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h0403o
m^h00`0mFJ/0ooK^03eIZ`050?ofkP030000003om^h000000580ooK^0@3oool001h0ooK^00<00000
0?ofkP3om^h0;03om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[
0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP030?ofkPH0?EV[1`3om^h00`0mFJ/0ooK^0?ofkP0:
0?ofkP0703eIZ`3om^h0ooK^03eIZ`000000GA`>0000000303iI/@80e3dI0`0nFK400`000000?UVa
03iI/@0203iI/@030=@m6@0nFK40?UVa0080?UVa00<0000003iI/@0nFK401@0nFK400`3D?AT00000
03iI/@0703iI/@030000000nFK40?UVa00@0?UVa00<0e3dI03iI/@0000000P0nFK4400000003045N
^P000000@Ejj00L0@Ejj00<0e3dI045N^P11G[X01@11G[X00`000000@Ejj045N^P05045N^P050000
0011G[X0@Ejj045N^P3D?AT00`11G[X010000000@Ejj045N^P11G[X20=@m6@03045N^P000000@Ejj
00D0@Ejj00<000000=@m6@11G[X01011G[X00`000000@Ejj045N^P04045N^P050000003oE2<0oe@S
0?mD8`0000000`3oE2<2000000<0oe@R00<000000?mD8P3oE2800P3oE2801P000000oe@R03eIZ`00
0000oe8Q000000@0oe8Q00H000000?mB8@3oDR4000000?m>7`0000040?m>7`040000003oB1`0odPL
00000080odPL00<0000003eIZ`0000001`0000050?ofkP0403eIZ`3om^h0ooK^0?ofkP`0?EV[1@3o
m^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h0403o
m^h00`0mFJ/0ooK^03eIZ`050?ofkP030000003om^h000000580ooK^0@3oool001l0ooK^00<00000
0?ofkP3om^h0:`3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[
0?ofkP3om^h0203om^h703eIZ`<0ooK^00<0?EV[0000003om^h01`3om^h00`0mFJ/0ooK^0?ofkP07
0?ofkPH0?EV[00D0ooK^000000000000GA`>0000000303iI/@030=@m6@0nFK40?UVa0080?UVa00<0
000003iI/@0nFK400P0nFK400`3D?AT0?UVa03iI/@0203iI/@030000000nFK40?UVa00D0?UVa00<0
e3dI0000000nFK401`0nFK400`000000?UVa03iI/@0203iI/@030000003D?AT0000000<000001P11
G[X00`000000@Ejj045N^P05045N^P030000003D?AT0@Ejj00D0@Ejj00<00000045N^P11G[X01@11
G[X00`000000@Ejj045N^P02045N^P030=@m6@11G[X0000000<0@Ejj00D0e3dI045N^P11G[X0@Ejj
00000006045N^P0300000011G[X0e3dI00<0@Ejj00<00000045N^P11G[X01011G[X00`000000oe@S
0?mD8`020?mD8`090000003oE2<0oe@S0?mD8`000000oe@S0000003oE280000000@0oe@R00D00000
0?mD8P3oE280?EV[0?mD8P02000000@0oe8Q00H000000?mB8@3oDR4000000?m>7`0000030?m>7`05
0000003oCQl000000?m8700000000P3oB1`00`000000?EV[00000002000000H0ooK^3@0mFJ/20?of
kP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP030?of
kP0303eIZ`3om^h0ooK^0100ooK^00<0?EV[0?ofkP0mFJ/01P3om^h200000580ooK^0@3oool00200
ooK^00<000000?ofkP3om^h0:`3om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^01<0
ooK^00@0?EV[0?ofkP3om^h0ooK^1`0mFJ/00`3om^h0?EV[0?ofkP070?ofkP0303eIZ`3om^h00000
00L0ooK^00@0?EV[0?ofkP3om^h0ooK^1P0mFJ/30?ofkP0303eIZ`3om^h0ooK^0080ooK^0P000000
0`1M70h0000003iI/@0203iI/@80e3dI0`0nFK400`000000?UVa03iI/@0203iI/@030=@m6@0nFK40
?UVa0080?UVa00<0000003iI/@0nFK40100nFK400`3D?AT0000003iI/@0403iI/@P000000P11G[X0
0`3D?AT00000045N^P07045N^P0300000011G[X0@Ejj00H0@Ejj00<0e3dI045N^P11G[X01011G[X0
0`000000@Ejj045N^P05045N^P0300000011G[X0@Ejj0080@Ejj00@0e3dI045N^P000000@Ejj0P3D
?AT4045N^P0300000011G[X0@Ejj00<0@Ejj00@00000045N^P11G[X0e3dI0`11G[X00`000000@Ejj
045N^P04045N^P050000003oE2<0oe@S0?mD8`0000000`3oE2<01P000000oe@S0?mD8`000000oe@R
000000@0oe@R00H000000?mD8P3oE280oe@R03eIZ`0000040?mB8@030000003oDR40oe8Q0080oe8Q
00<000000?m>7`3oCQl00P3oCQl01@000000odhO0000003oB1`000000080odPL00<000000=Xl5`0m
FJ/00P00000603eIZ`030?ofkP0mFJ/0?EV[00@0?EV[203om^h00`0mFJ/0ooK^0?ofkP070?ofkP03
03eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP04
03eIZ`3om^h0ooK^03eIZ`D0ooK^0P00001B0?ofkP40oooo000P0?ofkP030000003om^h0ooK^02/0
ooK^00<0?EV[0?ofkP3om^h04P3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkPL0?EV[2@3om^h00`0mFJ/0
ooK^0?ofkP060?ofkP0303eIZ`3om^h0000000@0ooK^1P0mFJ/90?ofkP0303eIZ`3om^h0ooK^0080
ooK^00D0?EV[000000000000GA`>0000000203iI/@040=@m6@0nFK40e3dI0=@m6@80?UVa00D00000
03iI/@0nFK40?UVa0=@m6@0403iI/@030000000nFK40?UVa00<0?UVa0P0000000`3D?AT000000000
0003000000@0@Ejj00<00000045N^P11G[X00`11G[X00`3D?AT0@Ejj00000007045N^P0300000011
G[X0@Ejj00H0@Ejj00<000000=@m6@11G[X01011G[X00`000000@Ejj045N^P05045N^P0300000011
G[X0@Ejj00<0@Ejj0`3D?AT6045N^P0300000011G[X0@Ejj00<0@Ejj00@00000045N^P11G[X0e3dI
0P11G[X010000000@Ejj045N^P11G[X4000000<0oe@S00D000000?mD8`3oE2<0oe@S000000040?mD
8`030000003oE280oe@R0080oe@R00<000000?mD8P3oE2800P3oE2800`0mFJ/0e3dI0?mB8@020?mB
8@030000003oDR40oe8Q00<0oe8Q00D000000?m>7`3oCQl0odhO000000020?m>7`8000000`3oB1`2
0000000403eIZ`3J?1L00000000000H0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3o
m^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3o
m^h0ooK^0100ooK^00@0?EV[0?ofkP3om^h0?EV[1@3om^h200000580ooK^0@3oool00240ooK^00<0
00000?ofkP3om^h0:P3om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^00T0ooK^1`0m
FJ/30?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h01P3om^h703eIZ`80ooK^00<0
?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP@000000`0nFK400`3D?AT0?UVa03iI
/@020=@m6@030000000nFK40?UVa0080?UVa00@0e3dI03iI/@0nFK40?UVa1P000003045N^P030=@m
6@000000@Ejj00H0@Ejj00<00000045N^P11G[X01011G[X00`3D?AT00000045N^P07045N^P030000
0011G[X0@Ejj00D0@Ejj00<000000=@m6@11G[X01@11G[X00`000000@Ejj045N^P04045N^P030000
0011G[X0@Ejj0080@Ejj0P3D?AT00`000000@Ejj045N^P04045N^P0300000011G[X0@Ejj00<0@Ejj
00H00000045N^P11G[X0@Ejj0000003D?AT500000080@f;20P0000030?mD8`050000003oE2<0oe@S
0?mD8`0000000`3oE2<2000000@0oe@R00<000000?mD8P3oE2800P3oE2800`0mFJ/0oe@R00000002
0?mB8@030000003oDR40oe8Q0080oe8Q0P0000030?m>7`050000003oCQl0odhO0?m>7`0000000P3o
B1`00`000000?EV[03eIZ`0403eIZ`T0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?of
kP060?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?of
kP0@0?ofkP0403eIZ`3om^h0ooK^03eIZ`D0ooK^0P00001B0?ofkP40oooo000R0?ofkP030000003o
m^h0ooK^02T0ooK^00<0?EV[0?ofkP3om^h04P3om^h0100mFJ/0ooK^0?ofkP3om^h803eIZ`X0ooK^
00<0?EV[0?ofkP3om^h02P3om^h0100mFJ/0ooK^0?ofkP3om^h603eIZ`80ooK^00<000000?ofkP3o
m^h00`3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0000001M
70h00P00000203iI/@030=@m6@0nFK40?UVa0080?UVa0P3D?AT303iI/@040=@m6@00000000000000
0080@Ejj00<00000045N^P11G[X01011G[X00`3D?AT00000045N^P07045N^P0300000011G[X0@Ejj
00<0@Ejj00<0e3dI045N^P0000001`11G[X00`000000@Ejj045N^P05045N^P0300000011G[X0e3dI
00D0@Ejj00<00000045N^P11G[X01011G[X00`000000e3dI0=@m6@020=@m6@03045N^P3D?AT00000
00H0@Ejj00@00000045N^P11G[X0@Ejj1P0000001013H/80e3dI04=R`P00000504=R`P050000003o
E2<000000?mD8`0000000`3oE2<00`000000oe@S0?mD8`020?mD8`030000003oE2<000000080oe@R
00<000000?mD8P3oE2800P3oE2801P000000?EV[0?mD8P000000oe8Q000000D0oe8Q00<000000?mB
8@0000000P3oCQl00`000000odhO03eIZ`0503eIZ`040?m870000000?EV[0=@m6@<000002@3om^h0
0`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h0303om^h0
0`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00l0ooK^100mFJ/50?ofkP030000003om^h0
00000540ooK^0@3oool002<0ooK^00<000000?ofkP3om^h0:03om^h00`0mFJ/0ooK^0?ofkP0@0?of
kPH0?EV[4`3om^h00`0mFJ/0ooK^0?ofkP090?ofkP@0?EV[1@3om^h01@0mFJ/0ooK^0?ofkP3om^h0
000000@0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0403eIZ`000000
000005dL3P8000000P0nFK400`3D?AT0?UVa03iI/@0300000080e3dI00<00000045N^P3D?AT01@11
G[X00`000000@Ejj045N^P04045N^P030=@m6@000000@Ejj00H0@Ejj00<00000045N^P11G[X01011
G[X00`3D?AT00000045N^P06045N^P0300000011G[X0@Ejj00D0@Ejj00<00000045N^P3D?AT01@11
G[X00`000000@Ejj045N^P02045N^P<0e3dI1P11G[X00`3D?AT0@Ejj045N^P03045N^PD000000P13
H/800`000000@f;204=R`P0304=R`P030=@m6@13H/80@f;20080@f;200L0e3dI0000003oE2<0oe@S
0000003oE2<000000080oe@S00<000000?mD8`3oE2<00P3oE2<01P000000oe@S0?mD8`000000oe@R
000000@0oe@R00D000000?mD8P3oE280?EV[0?mD8P02000000@0oe8Q00<000000?mB8@0mFJ/01@0m
FJ/00`3oCQl00000000000020?m870050000003oB1`0odPL03eIZ`3J?1L00`0000090?ofkP0303eI
Z`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eI
Z`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h0203om^h703eIZ`040?ofkP0mFJ/0ooK^03eIZ`D0
ooK^00<000000?ofkP000000D@3om^h10?ooo`00903om^h00`000000ooK^0?ofkP0W0?ofkP0303eI
Z`3om^h0ooK^00/0ooK^1@0mFJ/20?ofkP0303eIZ`3om^h0ooK^01@0ooK^00<0?EV[0?ofkP3om^h0
2@3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0503eIZ`3om^h0ooK^0?ofkP0000001@3om^h00`0mFJ/0
ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP0000000P000000101M70h0
00000000003D?AT2000000@0@Ejj00@000000=@m6@3D?AT0e3dI1@11G[X00`000000@Ejj045N^P05
045N^P030=@m6@000000@Ejj00H0@Ejj00<00000045N^P11G[X00`11G[X00`3D?AT0@Ejj00000006
045N^P0300000011G[X0@Ejj00D0@Ejj00@00000045N^P11G[X0e3dI1011G[X00`000000@Ejj0=@m
6@020=@m6@80@Ejj00<00000045N^P11G[X01011G[X00`3D?AT0@Ejj000000030000000304=R`P00
0000@f;200<0@f;200<0000004=R`P13H/801013H/80203D?AT0@f;204=R`P13H/80e3dI04=R`P00
0000?EV[0P3oE2<01@000000oe@S0?mD8`3oE2<0000000<0oe@S00<000000?mD8`3oE2<00P3oE2<2
000000@0oe@R00L000000?mD8P3oE280?EV[0?mD8P000000oe8Q00H0?EV[00@0oe8Q0000003oCQl0
00000`3oCQl01@000000odhO0000003oB1`000000080odPL00<0000003eIZ`0000000P0000090?of
kP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP0<0?of
kP0303eIZ`3om^h0ooK^00<0ooK^00@0?EV[0?ofkP3om^h0ooK^1`0mFJ/80?ofkP0303eIZ`3om^h0
?EV[00H0ooK^0P00001A0?ofkP40oooo000U0?ofkP030000003om^h0ooK^02H0ooK^00<0?EV[0?of
kP3om^h01@3om^h603eIZ`L0ooK^00<0?EV[0?ofkP3om^h0503om^h00`0mFJ/0ooK^0?ofkP090?of
kP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`000000ooK^0?ofkP020?of
kP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h00P3om^h0100mFJ/0ooK^0000000n4PT2
0000000405dL3P000000@Ejj0=@m6@H0@Ejj00<00000045N^P3D?AT00`3D?AT3045N^P0300000011
G[X0@Ejj00@0@Ejj00<0e3dI00000011G[X01P11G[X00`000000@Ejj045N^P04045N^P030=@m6@00
0000@Ejj00H0@Ejj00<00000045N^P11G[X01@11G[X00`000000@Ejj0=@m6@02045N^P@0e3dI1@11
G[X010000000@Ejj045N^P11G[X4000000030=@m6@13H/80@f;20080@f;200<0000004=R`P13H/80
0`13H/800`000000@f;204=R`P0304=R`P0300000013H/80e3dI0080e3dI00D0@f;20000003oE2<0
?EV[0?mD8`0200000080oe@S00<000000?mD8`3oE2<00P3oE2<00`000000oe@S0?mD8`020?mD8`03
0000003oE280oe@R0080oe@R00<0000003eIZ`0mFJ/01@0mFJ/30?mB8@030000003oDR40oe8Q0080
oe8Q00D000000?m>7`3oCQl0odhO000000020?m>7`030000003oB1`000000080odPL00<0000003eI
Z`0000000P0000090?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0m
FJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00L0?EV[3@3om^h303eIZ`80ooK^00<0?EV[0?of
kP3om^h00`3om^h200000540ooK^0@3oool002D0ooK^00<000000?ofkP3om^h09P3om^h00`0mFJ/0
ooK^0?ofkP0503eIZ`h0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP090?ofkP03
03eIZ`3om^h0ooK^00L0ooK^00D0?EV[0?ofkP3om^h0ooK^000000040?ofkP0303eIZ`3om^h0ooK^
00X0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP06000000030=@m6@11G[X0@Ejj
00D0@Ejj00D00000045N^P11G[X0e3dI045N^P050=@m6@H0@Ejj00<0e3dI00000011G[X01P11G[X0
0`000000@Ejj045N^P03045N^P030=@m6@11G[X0000000H0@Ejj00<00000045N^P11G[X01@11G[X0
0`000000e3dI0=@m6@020=@m6@80@Ejj00@00000045N^P11G[X0@Ejj1`00000304=R`P030000003D
?AT0@f;200<0@f;200<0000004=R`P13H/800`13H/800`000000@f;204=R`P0304=R`P0300000013
H/80e3dI00<0@f;200@000000?mD8`0mFJ/0oe@S0P0000000`3oE2<000000?mD8`030?mD8`040000
003oE2<0oe@S0?mD8`P0?EV[0`3oE280100mFJ/0oe@R0?mD8P0000020?mB8@030000003oDR40oe8Q
00<0oe8Q00D000000?m>7`3oCQl0odhO000000020?m>7`8000000P3oB1`01@000000odPL03eIZ`00
0000fS`G00800000203om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0
?EV[0?ofkP3om^h0203om^h703eIZ`<0ooK^00<0?EV[0?ofkP3om^h0203om^h603eIZ`80ooK^00@0
?EV[0?ofkP3om^h0?EV[1@3om^h200000540ooK^0@3oool002H0ooK^00<000000?ofkP3om^h09@3o
m^h303eIZa<0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3o
m^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h00P3om^h01@000000ooK^0?ofkP3om^h0?EV[00`0ooK^
00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP0700000080e3dI1P11G[X00`000000@Ejj
0=@m6@06045N^PD0e3dI00@0@Ejj0=@m6@11G[X000001`11G[X00`000000@Ejj045N^P03045N^P03
0=@m6@000000@Ejj00D0@Ejj00<00000045N^P11G[X01P3D?AT2045N^P030=@m6@000000000000D0
00000`13H/800`000000@f;204=R`P0404=R`P0300000013H/80e3dI00<0@f;200<0000004=R`P13
H/800P13H/800`000000@f;204=R`P0304=R`P040000003D?AT0e3dI0=@m6@80@f;200D000000?mD
8`3oE2<0oe@S03eIZ`020?mD8`800000200mFJ/0103oE2<000000?mD8`0000020?mD8P030000003o
E280oe@R0080oe@R00@0?EV[0?mD8P3oE28000000P3oDR400`000000oe8Q0?mB8@020?mB8@800000
0P3oCQl00`000000odhO0?m>7`020?m>7`080000003oB1`0odPL0000003oB1`0?EV[0000003J?1L2
000000P0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0403eIZ`3om^h0
ooK^0?ofkPL0?EV[1@3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^0080ooK^1P0m
FJ/80?ofkP0403eIZ`3om^h0ooK^03eIZ`D0ooK^0P00001A0?ofkP40oooo000W0?ofkP030000003o
m^h0ooK^02@0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3o
m^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP040000003o
m^h0ooK^03eIZ`d0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP02000000@0?EV[
00<00000045N^P11G[X01P11G[X00`000000@Ejj0=@m6@06045N^P0400000011G[X0@Ejj045N^PX0
e3dI00<0@Ejj00000011G[X01011G[X00`3D?AT0@Ejj00000002045N^PH0e3dI0P11G[X700000004
0=@m6@13H/80@f;2000000H0@f;200<0000004=R`P13H/800`13H/8010000000@f;204=R`P3D?AT2
04=R`P0300000013H/80@f;200<0@f;200<0000004=R`P13H/800P13H/820=@m6@<0@f;200<0e3dI
0000003oE2<00P3oE2<603eIZ`<0oe@S00<000000?mD8`3oE2<00P3oE2<01P000000oe@S0?mD8`00
0000oe@R000000@0oe@R00L000000?mD8P0mFJ/0oe@R0000003oDR40000000D0oe8Q0P0000020?m>
7`030000003oCQl0odhO0080odhO00P000000?m8703oB1`000000?m8700mFJ/000000=@m6@800000
2@3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00<0ooK^1`0mFJ/<0?ofkP0403eI
Z`3om^h0ooK^0?ofkPH0?EV[3P3om^h0100mFJ/0ooK^0?ofkP0mFJ/50?ofkP030000003om^h00000
0500ooK^0@3oool002P0ooK^00<000000?ofkP3om^h08`3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP03
03eIZ`3om^h0ooK^01@0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP060?ofkP03
03eIZ`3om^h0ooK^00<0ooK^00@000000?ofkP3om^h0?EV[3@3om^h0100mFJ/0ooK^0?ofkP3om^h6
03eIZ`@0000000<0O2LB00000011G[X01`11G[X00`000000e3dI045N^P06045N^P0300000011G[X0
@Ejj0080@Ejj00<0e3dI045N^P0000001@11G[X<0=@m6@80@Ejj1P00000304=R`P0500000013H/80
@f;204=R`P3D?AT00P13H/800`000000@f;204=R`P0404=R`P0300000013H/80@f;200<0@f;200L0
000004=R`P13H/80@f;20=@m6@13H/80000000@0@f;200@0000004=R`P13H/80@f;20P3D?AT00`13
H/80000004=R`P0204=R`P030=@m6@000000?EV[0080?EV[00<0000003eIZ`3oE2<00P0000030?mD
8`030000003oE2<0oe@S0080oe@S00<000000?mD8`3oE2<00P3oE2<2000000<0oe@R00@000000?mD
8P3oE280?EV[0P3oE282000000@0oe8Q00<000000?mB8@3oDR400P0000040?m>7`80000000<0odPL
0000003oB1`00P3oB1`0100mFJ/0fS`G0000000000090?ofkP0303eIZ`3om^h0ooK^00P0ooK^1P0m
FJ/30?ofkP0303eIZ`3om^h0ooK^00X0ooK^1`0mFJ/00`3om^h0?EV[0?ofkP0B0?ofkP0303eIZ`3o
m^h0?EV[00D0ooK^00<000000?ofkP000000D03om^h10?ooo`00:@3om^h00`000000ooK^0?ofkP0S
0?ofkP0303eIZ`3om^h0ooK^0180ooK^00<0?EV[0?ofkP3om^h0503om^h00`0mFJ/0ooK^0?ofkP09
0?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h0103om^h00`000000ooK^03eIZ`0:
0?ofkPL0?EV[00<0ooK^03eIZ`3om^h00P3om^h00`000000?Q89000000030000000307`W4P000000
000000L0@Ejj00<000000=@m6@11G[X01@11G[X00`000000@Ejj045N^P03045N^P030=@m6@11G[X0
000000H0@Ejj00<00000045N^P11G[X00P11G[X2000000030=@m6@0000000000008000000P13H/80
0`000000@f;204=R`P0504=R`P0700000013H/80@f;204=R`P3D?AT0@f;20000000604=R`P030000
0013H/80@f;200<0@f;200L0000004=R`P13H/80@f;20=@m6@13H/80000000@0@f;200@0000004=R
`P3D?AT0e3dI0P13H/800`000000@f;204=R`P0204=R`P050000003oE2<0oe@S0?mD8`0000000P3o
E2<01P0mFJ/000000?mD8`000000oe@S000000@0oe@S00<000000?mD8`3oE2<00`3oE2<01@000000
oe@R0?mD8P3oE280000000<0oe@R00@0?EV[0?mD8P3oE2800000103oDR4010000000oe8Q0?mB8@3o
DR42000000@0odhO0P0000000`3oB1`000000?m870020?m8700403eIZ`3J?1L00000000000T0ooK^
00@0?EV[0?ofkP3om^h0ooK^1`0mFJ/00`3om^h0?EV[0?ofkP060?ofkP0303eIZ`3om^h0ooK^0080
ooK^200mFJ/30?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h04@3om^h00`0mFJ/0
ooK^03eIZ`060?ofkP800000D03om^h10?ooo`00:P3om^h00`000000ooK^0?ofkP0R0?ofkP0303eI
Z`3om^h0ooK^0180ooK^00<0?EV[0?ofkP3om^h0503om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eI
Z`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h0103om^h00`000000ooK^03eIZ`020?ofkPL0?EV[
0`3om^h00`0mFJ/0ooK^0?ofkP0603eIZ`050?ofkP00000000000000001M70h00P00000207`W4P03
00000011G[X0@Ejj00D0@Ejj00<0e3dI045N^P11G[X01@11G[X00`000000@Ejj045N^P02045N^P03
0=@m6@11G[X0000000@0@Ejj1`00000204=R`P030=@m6@13H/80000000D0@f;200<0000004=R`P13
H/801013H/801`000000@f;204=R`P13H/80e3dI04=R`P0000001P13H/800`000000@f;204=R`P03
04=R`P0300000013H/80@f;20080@f;200<0e3dI00000013H/800`13H/820=@m6@@0@f;200<00000
04=R`P13H/800P13H/8010000000oe@S0?mD8`0000030?mD8`0603eIZ`3oE2<0oe@S0000003oE2<0
0000103oE2<00`000000oe@S0?mD8`020?mD8`8000000P3oE2800`000000oe@R0?mD8P020?mD8P04
03eIZ`3oE2800000000000@0oe8Q00D000000?mB8@3oDR40oe8Q000000040?m>7`030000003oCQl0
odhO008000000`3oB1`00`0mFJ/0fS`G00000002000000@0ooK^200mFJ/80?ofkP0303eIZ`3om^h0
ooK^0080ooK^200mFJ/;0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h0403om^h0
100mFJ/0ooK^0?ofkP0mFJ/50?ofkP800000D03om^h10?ooo`00:P3om^h00`000000ooK^0?ofkP0R
0?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP09
0?ofkP0303eIZ`3om^h0ooK^00L0ooK^00@0?EV[0?ofkP3om^h0ooK^200mFJ/70?ofkPH0?EV[0P3o
m^h00`0mFJ/0ooK^0?ofkP030?ofkP<0000000H0GA`>000000000000000007`W4P000007045N^P03
0=@m6@11G[X0@Ejj00D0@Ejj00<00000045N^P11G[X00P11G[X00`3D?AT0000000000003000000@0
@f;200<0000004=R`P13H/800`13H/800`3D?AT0000004=R`P0404=R`P0300000013H/80@f;200@0
@f;200<0000004=R`P13H/800P13H/800`3D?AT0000004=R`P0504=R`P0300000013H/80@f;200<0
@f;200<0000004=R`P13H/800P13H/80103D?AT0@f;204=R`P13H/820=@m6@D0@f;200<0000004=R
`P13H/800P13H/8010000000oe@S0?mD8`0000030?mD8`030000000mFJ/0oe@S0080oe@S00<00000
0?mD8`3oE2<00P3oE2<00`000000oe@S0?mD8`020?mD8`030000003oE2<000000080oe@R00<00000
0?mD8P3oE2800P3oE2801@0mFJ/000000?mD8P3oE28000000080oe8Q00@000000?mB8@3oDR40oe8Q
0P0000040?m>7`040000003oCQl0odhO000000<0odPL00@0000003eIZ`000000fS`G1P0mFJ/40?of
kP0303eIZ`3om^h0ooK^00L0ooK^1`0mFJ/30?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?of
kP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0403eIZ`3om^h0ooK^03eIZ`D0ooK^0P00001@
0?ofkP40oooo000[0?ofkP030000003om^h0ooK^0240ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0m
FJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h0103om^h603eI
Z`@0ooK^00<0000003eIZ`3om^h00P3om^h603eIZ`@0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`05
0?ofkP@0000000H0GA`>0000001l9a80000007`W4P000006045N^P030=@m6@000000@Ejj00<0@Ejj
1`000000103D?AT0@f;204=R`P00000604=R`P0300000013H/80@f;200<0@f;200<0e3dI04=R`P00
00001@13H/800`000000@f;204=R`P0304=R`P0300000013H/80@f;20080@f;200<0e3dI00000013
H/801@13H/800`000000@f;204=R`P0304=R`P0300000013H/80@f;20080@f;200H000000=@m6@3D
?AT0e3dI04=R`P00000504=R`P0300000013H/80@f;20080@f;200@000000?mD8`3oE2<000000`3o
E2<010000000?EV[0?mD8`3oE2<2000000<0oe@S00<000000?mD8`3oE2<00P3oE2<010000000oe@S
0?mD8`3oE2<2000000D0oe@R00L0000003eIZ`3oE280oe@R0000003oDR40000000@0oe8Q00<00000
0?mB8@0000000P3oCQl01@000000odhO0?m>7`3oCQl0000000<0odPL00H0000003eIZ`000000?EV[
0=Xl5`0000080?ofkP0403eIZ`3om^h0ooK^0?ofkPH0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP050?of
kP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP0@0?of
kP@0?EV[1@3om^h200000500ooK^0@3oool002`0ooK^00<000000?ofkP3om^h0803om^h00`0mFJ/0
ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0
ooK^03eIZ`0403eIZ`80ooK^00<0?EV[0?ofkP3om^h00P3om^h803eIZ`X0ooK^00D0?EV[0?ofkP3o
m^h0ooK^03eIZ`060?ofkP030000000n4PT0GA`>00<0000000@0O2LB0000001l9a8000001011G[X2
000000030=@m6@0000000000008000001013H/801@000000@f;204=R`P13H/80e3dI0080@f;200<0
000004=R`P13H/801013H/800`000000@f;204=R`P0304=R`P030=@m6@000000@f;200@0@f;200<0
000004=R`P13H/801013H/801`000000@f;204=R`P13H/80e3dI04=R`P0000001@13H/800`000000
@f;204=R`P0204=R`P0300000013H/80@f;200<0@f;20P3D?AT304=R`P0300000013H/80@f;20080
@f;200<0000004=R`P13H/800`0000020?mD8`050000003oE2<0oe@S0?mD8`0000000P3oE2<01`0m
FJ/000000?mD8`3oE2<000000?mD8`000000103oE2<00`000000oe@S0?mD8`020?mD8`030000003o
E280oe@R00<0oe@R00<000000?mD8P0mFJ/00`3oE282000000<0oe8Q00@000000?mB8@3oDR400000
0P3oCQl01@000000odhO0?m>7`3oCQl0000000<0odPL00<000000?m8700mFJ/00P3J?1L00`000000
ooK^0?ofkP040?ofkPH0?EV[203om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00d0
ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP090?ofkPP0?EV[0P3om^h00`0mFJ/0
ooK^0?ofkP030?ofkP030000003om^h0000004l0ooK^0@3oool002d0ooK^00<000000?ofkP3om^h0
7`3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^01@0ooK^00<0?EV[0?ofkP3om^h0
1@3om^h603eIZ`<0ooK^2@0mFJ/40?ofkP0303eIZ`3om^h0ooK^00/0ooK^00D0?EV[0?ofkP3om^h0
ooK^03eIZ`070?ofkP030000003D?AT0GA`>00<0000000<0O2LB0000001l9a801000000204=R`P03
0=@m6@13H/80000000L0@f;200@0000004=R`P13H/80e3dI0`13H/800`000000@f;204=R`P0404=R
`P0300000013H/80@f;20080@f;200<0e3dI04=R`P0000001@13H/800`000000@f;204=R`P0304=R
`P0300000013H/80@f;20080@f;200<0e3dI00000013H/801013H/800`000000@f;204=R`P0204=R
`P0300000013H/80@f;200<0e3dI00D0@f;20=@m6@13H/80@f;20000000304=R`PD0000000D0AFK9
000000000000oe@S000000030?mD8`060000003oE2<0oe@S0?mD8`0mFJ/000000P3oE2<00`000000
oe@S000000030?mD8`030000003oE2<0oe@S0080oe@S0P0000050?mD8P030000003oE280?EV[0080
oe@R00<0e3dI0000003oDR400P3oDR401`000000oe8Q0?mB8@3oDR4000000?m>7`0000000`3oCQl0
1@000000odhO0000003oB1`000000080odPL00@0?EV[0=Xl5`3J?1L000001P0mFJ/20?ofkP0303eI
Z`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eI
Z`3om^h0ooK^0080ooK^00@0?EV[0?ofkP3om^h0ooK^200mFJ/80?ofkP0303eIZ`3om^h0?EV[00H0
ooK^0P00001?0?ofkP40oooo000^0?ofkP030000003om^h0ooK^01l0ooK^00<0?EV[0?ofkP3om^h0
4P3om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP0303eIZ`3om^h0ooK^00D0?EV[103om^h503eIZ`D0ooK^
00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/000000?ofkP0<0?ofkP0403eIZ`3om^h0ooK^03eIZ`L0
ooK^0P0000000`3D?AT000000000000207`W4P80000000D0O2LB000000000000@f;20=@m6@0204=R
`P030=@m6@13H/80000000L0@f;200@0000004=R`P13H/80e3dI0`13H/800`000000@f;204=R`P04
04=R`P0300000013H/80@f;20080@f;200<0e3dI00000013H/801013H/800`000000@f;204=R`P03
04=R`P0300000013H/80@f;20080@f;200<0e3dI00000013H/801013H/800`000000@f;204=R`P02
04=R`P<0e3dI1@0000000`3D?AT00000000000030000000304EVb@000000AFK90080AFK900<00000
0?mB8P3oDR800P0000030?mD8`050000003oE2<0oe@S0?mD8`0mFJ/0103oE2<00`000000oe@S0?mD
8`020?mD8`050000003oE2<0oe@S0?mD8`0000000P3oE2<01@000000oe@R0?mD8P3oE28000000080
oe@R00<0?EV[0?mD8P3oE2800P0000030?mB8@030000003oDR40oe8Q0080oe8Q0P0000030?m>7`04
0000003oCQl000000?m870L0?EV[00<0e3dI0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP0:0?of
kP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^03eIZ`0603eI
Za00ooK^00<0?EV[0?ofkP0mFJ/01P3om^h2000004l0ooK^0@3oool002l0ooK^00<000000?ofkP3o
m^h07P3om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^0140ooK^1P0mFJ/90?ofkP03
03eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0000000<0?ofkP04
03eIZ`3om^h0ooK^03eIZ`P0ooK^0P0000000`1M70h000000000000207`W4P<0000000<0YS<G0000
0013H/800`3D?AT204=R`P8000001P13H/800`000000@f;20=@m6@0404=R`P0300000013H/80@f;2
00<0@f;200<0000004=R`P13H/800P13H/800`3D?AT0@f;20000000504=R`P0300000013H/80@f;2
0080@f;200<0000004=R`P13H/800`13H/800`3D?AT0@f;204=R`P0304=R`P0300000013H/80@f;2
0080e3dI0`00000204EVb@0600000015I/T0AFK90=@m6@15I/T000001015I/T01@000000AFK904EV
b@15I/T000000080oe8R00D000000?mD8`3oE2<0oe@S000000030?mD8`030000000mFJ/0oe@S0080
oe@S0P0000030?mD8`050000003oE2<0oe@S0?mD8`0000000`3oE2<010000000oe@R0?mD8P000004
0?mD8P0403eIZ`000000oe@R00000080oe8Q00<000000?mB8@3oDR400`3oDR400`000000?EV[03eI
Z`0603eIZ`040000003oB1`0odPL03eIZ`80fS`G00<000000=@m6@3om^h01`3om^h00`0mFJ/0ooK^
0?ofkP090?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h0203om^h703eIZ`<0ooK^
00<0?EV[0?ofkP3om^h04@3om^h00`0mFJ/0ooK^03eIZ`060?ofkP800000C`3om^h10?ooo`00;`3o
m^h00`000000ooK^0?ofkP0N0?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h02@3o
m^h703eIZ`<0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3o
m^h0ooK^00@0ooK^00<0?EV[0?ofkP000000303om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00L0ooK^
1@00000307`W4P050000001l9a80000003eIZ`0000000P13H/830=@m6@80@f;200<0000004=R`P13
H/801013H/800`000000@f;20=@m6@0304=R`P0300000013H/80@f;200@0@f;200<0000004=R`P13
H/800P13H/800`3D?AT0000004=R`P0404=R`P0300000013H/80@f;200<0@f;200<0000004=R`P13
H/800P13H/80103D?AT0@f;204=R`P13H/82000000<0e3dI0P15I/T01@000000AFK904EVb@15I/T0
000000@0AFK900<0e3dI04EVb@15I/T00P15I/T01@000000AFK904EVb@15I/T000000080oe8R00D0
00000?mB8P000000oe@S000000030?mD8`080000003oE2<0oe@S03eIZ`3oE2<000000?mD8`000002
0?mD8`050000003oE2<0oe@S0?mD8`0000001@3oE2<2000000D0oe@R00D0?EV[0?mD8P3oE280oe@R
0000000803eIZ`<0odhO00D000000?m>7`3oCQl0odhO000000030?m8700303eIZ`00000000000080
e3dI203om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^00D0ooK^00@0?EV[0?ofkP3o
m^h0ooK^1`0mFJ/50?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h03P3om^h403eI
Z`030?ofkP0mFJ/0ooK^00D0ooK^0P00001?0?ofkP40oooo000`0?ofkP030000003om^h0ooK^01d0
ooK^00<0?EV[0?ofkP3om^h04`3om^h0100mFJ/0ooK^0?ofkP3om^h803eIZ`/0ooK^00<0?EV[0?of
kP3om^h0203om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00@0ooK^00@0?EV[0?of
kP3om^h000002`3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00P0ooK^1P00000207`W4P040000001l
9a80?EV[0:Hc5`8000000P13H/850=@m6@H0@f;200<000000=@m6@13H/800`13H/800`000000@f;2
04=R`P0404=R`P0700000013H/80@f;204=R`P3D?AT0@f;20000000504=R`P0300000013H/80@f;2
00P0000000<0e3dI0000003D?AT00P3D?AT00`000000AFK904EVb@0204EVb@0500000015I/T0AFK9
04EVb@0000001015I/T00`3D?AT0AFK904EVb@0204EVb@0400000015I/T0AFK900000080oe8R00H0
00000?mB8P3oDR8000000?mD8`0000020?mD8`060000003oE2<0oe@S0?mD8`0mFJ/000000`3oE2<2
000000@0oe@S00<000000?mD8`3oE2<00`3oE2<00`000000oe@R0?mD8P020?mD8PL0?EV[00<00000
0?mB8@3oDR400P3oDR401P000000oe8Q0?mB8@000000odhO000000@0odhO00L000000?m8703oB1`0
00000?m8700mFJ/0000000<0e3dI1`3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0403eIZ`3om^h0ooK^
0?ofkPL0?EV[3@3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00P0ooK^200mFJ/30?ofkP0403eIZ`3o
m^h0ooK^03eIZ`D0ooK^0P00001?0?ofkP40oooo000a0?ofkP030000003om^h0ooK^01`0ooK^00<0
?EV[0?ofkP3om^h0403om^h703eIZa<0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?of
kP080?ofkP0303eIZ`3om^h0ooK^00@0ooK^00@0?EV[0?ofkP3om^h00000303om^h0100mFJ/0ooK^
0?ofkP0mFJ/80?ofkPD0000000L0O2LB0000001l9a80O2LB0000000mFJ/000000080YS<G00<00000
04=R`P3D?AT01013H/840=@m6@<0@f;200<000000=@m6@13H/800`13H/800`000000@f;204=R`P04
04=R`P0600000013H/80@f;204=R`P3D?AT000000`13H/8500000080AFK900<0000004EVb@3D?AT0
1@3D?AT304EVb@0500000015I/T0AFK904EVb@0000001015I/T01`000000AFK904EVb@15I/T00000
04EVb@3D?AT00P15I/T010000000AFK904EVb@0000030?mB8P050000003oDR80oe8R0?mB8P000000
0P3oE2<00`000000oe@S0?mD8`020?mD8`0303eIZ`3oE2<0oe@S0080oe@S00<000000?mD8`3oE2<0
0P3oE2<00`000000oe@S0?mD8`030?mD8`H0?EV[00<000000?mD8P0mFJ/00`3oE2800`000000oe8Q
0?mB8@030?mB8@060000003oDR40oe8Q0000003oCQl000000`3oCQl200000080odPL00@000000?m8
700mFJ/000000`3D?AT70?ofkP0303eIZ`3om^h0ooK^00P0ooK^1P0mFJ/30?ofkP0303eIZ`3om^h0
ooK^00h0ooK^00@0?EV[0?ofkP3om^h0ooK^2@0mFJ/;0?ofkP0403eIZ`3om^h0ooK^03eIZ`D0ooK^
0P00001?0?ofkP40oooo000b0?ofkP030000003om^h0ooK^01`0ooK^00<0?EV[0?ofkP3om^h0203o
m^h703eIZ`<0ooK^00<0?EV[0?ofkP3om^h0503om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3o
m^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h0103om^h01@0mFJ/0ooK^0?ofkP3om^h0000000/0ooK^
00@0?EV[0?ofkP3om^h0?EV[0`3om^h80000000505dL3P000000000007`W4P0000000`1l9a800`0m
FJ/0YS<G0000000303eIZ`030=@m6@13H/80@f;20080@f;200<0000004=R`P13H/801@3D?AT504=R
`P0300000013H/80@f;200<0@f;200D0000004=R`P13H/80@f;20=@m6@040000000304EVb@3D?AT0
e3dI00H0e3dI0`15I/T00`000000e3dI04EVb@0304EVb@0500000015I/T0AFK904EVb@0000001015
I/T02@000000AFK904EVb@15I/T0000004EVb@3D?AT0AFK90000000304EVb@040000003oDR80oe8R
000000<0oe8R0P0000020?mD8`060000003oE2<0oe@S0?mD8`000000?EV[0`3oE2<00`000000oe@S
000000020?mD8`030000000mFJ/0?EV[00@0?EV[0P3oE2<010000000oe@R0?mD8P0000030?mD8P04
03eIZ`3oE2800000000000@0oe8Q00<000000?mB8@3oDR400P3oDR400`000000odhO0?m>7`020?m>
7`080000003oCQl000000?m870000000odPL03eIZ`0000030=@m6@L0ooK^00@0?EV[0?ofkP3om^h0
ooK^1`0mFJ/20?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h0303om^h703eIZa@0
ooK^00<0?EV[0?ofkP0mFJ/01P3om^h2000004h0ooK^0@3oool003<0ooK^00<000000?ofkP3om^h0
6`3om^h0100mFJ/0ooK^0?ofkP3om^h703eIZ`/0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0
ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0
ooK^0?ofkP020?ofkP030000003om^h0ooK^00P0ooK^00@0?EV[000000000000?EV[0`0000060?of
kP0403eIZ`000000000005dL3P80000000<0O2LB03eIZ`0mFJ/0100mFJ/2000000030:Hc5`000000
@f;200@0@f;20P00000404=R`QH0e3dI0P15I/T00`000000AFK904EVb@0204EVb@0300000015I/T0
AFK90080AFK900<000000=@m6@15I/T00P15I/T01@000000AFK904EVb@15I/T0000000<0AFK900D0
000004EVb@15I/T0AFK90000000304EVb@050=@m6@000000AFK904EVb@0000000P3oDR801@000000
oe8R0?mB8P3oDR8000000080oe8R0P0000030?mD8`040000003oE2<0oe@S03eIZ`8000001P0mFJ/4
0?mD8`070000003oE2<0oe@S0?mD8`000000oe@R000000040?mD8P0503eIZ`000000oe@R0?mD8P00
00000P3oDR400`000000oe8Q0?mB8@030?mB8@050000003oCQl0odhO0?m>7`0000000P3oCQl01P00
0000odPL0000003oB1`0?EV[000000@0e3dI103om^h603eIZ`T0ooK^00<0?EV[0?ofkP3om^h0103o
m^h00`0mFJ/0ooK^0?ofkP060?ofkPH0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3o
m^h0ooK^0140ooK^00<0?EV[0?ofkP0mFJ/01P3om^h2000004h0ooK^0@3oool003@0ooK^00<00000
0?ofkP3om^h06P3om^h403eIZa80ooK^00<0?EV[0?ofkP3om^h0503om^h00`0mFJ/0ooK^0?ofkP07
0?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP02
0?ofkP030000003om^h0ooK^0080ooK^1P000000100mFJ/0ooK^0?ofkP0mFJ/30?ofkPd0?EV[0P1l
9a8010000000?EV[0000000000020:Hc5`030000002V<aL0000000H0@f;200@0000004=R`P13H/80
@f;20P0000000`3D?AT0000000000006000000<0AFK900H0000004EVb@15I/T0AFK90=@m6@000004
04EVb@0300000015I/T0AFK90080AFK900<0000004EVb@15I/T00P15I/T00`000000e3dI04EVb@02
04EVb@0500000015I/T0AFK904EVb@0000000`15I/T01@000000AFK904EVb@15I/T0000000<0AFK9
00@0e3dI04EVb@15I/T000000P3oDR801@000000oe8R0?mB8P3oDR80000000<0oe8R00D000000?mD
8`3oE2<0oe@S0000000603eIZ`<0oe@S00<000000?mD8`3oE2<00P3oE2<2000000D0oe@S00<00000
0?mD8P3oE2800`3oE2801`0mFJ/0oe@R0?mD8P3oE28000000?mB8@0000001@3oDR42000000<0odhO
00<000000?m>7`3oCQl00P0000030?m8700303eIZ`3D?AT0e3dI00H0?EV[0P3om^h00`0mFJ/0ooK^
0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h01P0mFJ/80?ofkP0303eI
Z`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h0403om^h403eIZ`H0ooK^0P00001>0?ofkP40oooo
000d0?ofkP030000003om^h0ooK^01X0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?of
kP0D0?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?of
kP030?ofkP0303eIZ`3om^h0ooK^00<0ooK^100000060?ofkPd0?EV[0P3om^h200000080GA`>0P00
0000103D?AT0O2LB0000000mFJ/3000000030:Hc5`000000YS<G008000000`13H/8500000080AFK9
00<0e3dI00000015I/T01015I/T00`000000AFK904EVb@0304EVb@0600000015I/T0AFK90=@m6@15
I/T000001015I/T01@000000AFK904EVb@15I/T0000000@0AFK900D0000004EVb@3D?AT0AFK90000
000404EVb@0500000015I/T0AFK904EVb@0000000P15I/T00`000000AFK904EVb@0204EVb@030=@m
6@15I/T000000080oe8R00D000000?mB8P3oDR80oe8R000000030?mB8PH0?EV[0P3oE2<00`000000
?EV[0?mD8`020?mD8`<000000`3oE2<00`000000oe@S0?mD8`040?mD8`8000000`3oE28200000003
0?mD8P0mFJ/0oe@R0080oe@R0P0000040?mB8@060000003oDR40oe8Q0000003oCQl00000103oCQl0
0`000000odPL0?m8700403eIZ`<0e3dI1@3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0
ooK^00H0?EV[3`3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00/0ooK^1`0mFJ/0103om^h0?EV[0?of
kP0mFJ/60?ofkP800000CP3om^h10?ooo`00=@3om^h00`000000ooK^0?ofkP0J0?ofkP0303eIZ`3o
m^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3o
m^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP040000003o
m^h0ooK^0?ofkP/0?EV[2P3om^h300000080GA`>00H0000007`W4P000000O2LB03eIZ`0000020:Hc
5`050000002V<aL000000000002V<aL00`00000304EVb@8000000`15I/T00`3D?AT0000004EVb@04
04EVb@0300000015I/T0AFK90080AFK900H0000004EVb@15I/T0AFK90=@m6@00000404EVb@030000
0015I/T0AFK90080AFK900T0000004EVb@15I/T0AFK900000015I/T0e3dI04EVb@0000001015I/T0
1@000000AFK904EVb@15I/T000000080AFK900X0000004EVb@15I/T0AFK90000003D?AT0AFK90000
003oDR8000000P3oDR8603eIZ`80oe8R0P0000030?mD8`060000003oE2<0oe@S03eIZ`3oE2<00000
0P3oE2<010000000oe@S0?mD8`0000050?mD8`80000000D0oe@S0000003oE280oe@R000000030?mD
8P0503eIZ`3oE280oe@R0?mD8P000000103oDR401`000000oe8Q0?mB8@3oDR4000000?m>7`000000
103oCQl01@000000odPL0?m8703D?AT0?EV[00D0e3dI1@3om^h00`0mFJ/0ooK^0?ofkP080?ofkPH0
?EV[103om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/00`3om^h803eI
Z`T0ooK^0P0mFJ/60?ofkP800000CP3om^h10?ooo`00=P3om^h00`000000ooK^0?ofkP0I0?ofkP03
03eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP070?ofkP03
03eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h00P3om^h0100mFJ/0ooK^0?ofkP3om^h;03eI
Z`80ooK^00<0?EV[0?ofkP0mFJ/0303om^h300000080GA`>00H0000007`W4P000000?EV[07`W4P00
00020:Hc5`050000002V<aL0YS<G0000002V<aL00P00000504EVb@0500000015I/T0AFK90=@m6@15
I/T00P00000404EVb@0300000015I/T0AFK90080AFK900H0000004EVb@15I/T0e3dI04EVb@000004
04EVb@0500000015I/T0AFK904EVb@0000000`15I/T01@000000AFK904EVb@3D?AT0000000<0AFK9
00D0000004EVb@15I/T0AFK90000000204EVb@0500000015I/T0AFK904EVb@0mFJ/00`00000503eI
Z`050000003oDR80oe8R0?mB8P0000000`3oDR800`000000oe@S0?mD8`02000000<0oe@S00<0?EV[
0000003oE2<00`3oE2<2000000D0oe@S00<000000?mD8`3oE2<00P3oE2<2000000@0oe@R00<0?EV[
0?mD8P3oE2800P0000040?mB8@030000003oDR40oe8Q0080oe8Q00<000000?m>7`3oCQl00P3oCQl2
00000080odPL00@0e3dI03eIZ`3D?AT0ooK^0`3D?AT50?ofkP0303eIZ`3om^h0ooK^00P0?EV[0`3o
m^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00h0ooK^200mFJ/A0?ofkP80?EV[1P3o
m^h2000004h0ooK^0@3oool003L0ooK^00<000000?ofkP3om^h0603om^h00`0mFJ/0ooK^0?ofkP0C
0?ofkP0303eIZ`3om^h0ooK^01@0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP0:
0?ofkP0303eIZ`3om^h0ooK^00`0?EV[203om^h203eIZ`d0ooK^00@0000005dL3P000000GA`>0P00
00000`1l9a80000003eIZ`0200000080YS<G0P000000102V<aL0000000000039?A/2000000@0AFK9
0P0000001@15I/T0e3dI04EVb@15I/T0000000@0AFK900<0000004EVb@15I/T00P15I/T01P000000
AFK904EVb@3D?AT0AFK9000000<0AFK900D0000004EVb@15I/T0AFK90000000304EVb@0500000015
I/T0AFK90=@m6@0000000`15I/T01P000000AFK904EVb@15I/T0000004EVb@80000000<0?EV[0000
00000000100000001@3oDR8000000?mB8P3oDR80000000<0oe8R00@000000?mB8P3oDR80oe8R0P00
00000`3oE2<000000?mD8`030?mD8`030000000mFJ/0oe@S00@0oe@S00<000000?mD8`3oE2<00`3o
E2<00`000000oe@S0?mD8`030?mD8`030000003oE280oe@R00@0oe@R00D0?EV[0000003oE280oe@R
000000020?mB8@030000003oDR40oe8Q00<0oe8Q00<000000?m>7`3oCQl00P3oCQl01`000000odhO
0000003oB1`000000=@m6@0mFJ/00P3om^h20=@m6@P0?EV[2`3om^h00`0mFJ/0ooK^0?ofkP040?of
kP0303eIZ`3om^h0ooK^00P0ooK^1`0mFJ/30?ofkP0303eIZ`3om^h0ooK^0100ooK^0`0mFJ/00`3o
m^h0?EV[0?ofkP050?ofkP800000C@3om^h10?ooo`00>03om^h00`000000ooK^0?ofkP0H0?ofkP03
03eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP060?ofkP03
03eIZ`3om^h0ooK^00L0ooK^1P0mFJ/00`3om^h0?EV[03eIZ`0303eIZ`80ooK^00<000000?ofkP3o
m^h02@3om^h203eIZ`d0ooK^0P0000000`1M70h0000005dL3P030000000503eIZ`00000000000:Hc
5`0000000P2V<aL010000000YS<G0:Hc5`0000020<Tm6`0300000015I/T0AFK900<0AFK900<00000
04EVb@3D?AT00P15I/T00`000000AFK904EVb@0204EVb@0300000015I/T0AFK90080AFK900D00000
04EVb@3D?AT0AFK90000000404EVb@0400000015I/T0AFK9000000@0AFK900D0000004EVb@15I/T0
e3dI03eIZ`0204EVb@0300000015I/T0AFK900<0000000L0Af[A00000017J]40Af[A00000017J]40
00000080oe0R00@000000?mB8P3oDR8000000P3oDR8200000080oe8R0P0000020?mB8P030000003o
E2<0oe@S0080oe@S00@000000?mD8`3oE2<0?EV[0P3oE2<3000000@0oe@S00<000000?mD8`3oE2<0
0`3oE2<2000000H0oe@R00L0?EV[0?mD8P3oE280oe@R0000003oDR40000000D0oe8Q0P0000030?m>
7`040000003oCQl0odhO000000P0?EV[00<0e3dI0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP0<
0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00@0?EV[0?ofkP3om^h0ooK^1`0mFJ/60?ofkP0503eIZ`3o
m^h0ooK^0?ofkP0mFJ/0303om^h603eIZ`80ooK^00<0?EV[0?ofkP0mFJ/01P3om^h2000004d0ooK^
0@3oool003T0ooK^00<000000?ofkP3om^h05`3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3o
m^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h01P3om^h0100mFJ/0ooK^0?ofkP3om^h603eIZ`030?of
kP0mFJ/0?EV[00@0?EV[00<0ooK^03eIZ`3om^h0103om^h00`000000ooK^0?ofkP090?ofkP80?EV[
3P3om^h20000000305dL3P00000000000080O2LB00<0?EV[07`W4P0000000`2V<aL010000000YS<G
0000002V<aL3000000030<Tm6`000000000000@0AFK900<000000=@m6@15I/T00P15I/T00`000000
AFK904EVb@0204EVb@0300000015I/T0AFK90080AFK900D0000004EVb@3D?AT0AFK90000000304EV
b@0500000015I/T0AFK904EVb@0000000`15I/T010000000AFK90000003D?AT60000000;04MZd@00
0000Af[A00000017J]40e3dI04MZd@000000Af[A0000003oD2800P0000001@3oDR8000000?mB8P3o
DR80000000<0oe8R00@000000?mB8P3oDR80oe8R0P0000030?mD8`070000003oE2<0oe@S0?mD8`0m
FJ/0oe@S000000020?mD8`030000003oE2<0oe@S00800000103oE2<200000080oe@S00@000000?mD
8P3oE280oe@R0P0000000`0mFJ/0oe@R0?mD8P020?mD8P030000003oDR40oe8Q00<0oe8Q00<00000
0?mB8@0mFJ/01`0mFJ/010000000ooK^0=@m6@0mFJ/30?ofkP80e3dI103om^h00`0mFJ/0ooK^0?of
kP0<0?ofkP0303eIZ`3om^h0ooK^00L0?EV[3P3om^h0100mFJ/0ooK^0?ofkP0mFJ/60?ofkPH0?EV[
203om^h00`0mFJ/0ooK^03eIZ`060?ofkP800000C@3om^h10?ooo`00>@3om^h00`000000ooK^0?of
kP0G0?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?of
kP060?ofkP/0?EV[0`3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00@0ooK^00<000000?ofkP3om^h0
2`3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP<0000000<0GA`>0000000000000P1l9a800`0mFJ/0O2LB
000000030:Hc5`D0000000@0bCdK000000000000bCdK0P00000304EVb@030000003D?AT0AFK90080
AFK900<0000004EVb@15I/T00P15I/T02@000000AFK904EVb@15I/T0000004EVb@3D?AT0AFK90000
000404EVb@0300000015I/T0000000H0000000<0Af[A0000003D?AT00P17J]401@000000Af[A04MZ
d@000000Af[A00<0e3dI00H0Af[A00000017J]4000000?m@8P0000020?m@8P040000003oDR80oe8R
000000<0oe8R00<000000?mB8P3oDR800P0000020?mB8P<00000103oE2<00`0mFJ/000000?mD8`03
0?mD8`8000001@3oE2<00`000000oe@S0?mD8`020?mD8`040000003oE280oe@R000000<0oe@R00@0
?EV[0?mD8P3oE2800000200mFJ/0103oDR4000000?m>7`0000040?m>7`050000003om^h0ooK^0=@m
6@0mFJ/00P3om^h30=@m6@<0ooK^00<0?EV[0?ofkP3om^h0203om^h703eIZ`<0ooK^00<0?EV[0?of
kP3om^h03`3om^h0100mFJ/0ooK^0?ofkP3om^h603eIZ`d0ooK^100mFJ/60?ofkP800000C@3om^h1
0?ooo`00>P3om^h00`000000ooK^0?ofkP0G0?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?of
kP3om^h04`3om^h0100mFJ/0ooK^0?ofkP3om^h803eIZ`/0ooK^00@0?EV[0?ofkP3om^h0?EV[103o
m^h00`000000ooK^0?ofkP0:0?ofkP80?EV[3`3om^h30000000505dL3P000000O2LB07`W4P0mFJ/0
100000030:Hc5`<000000`39?A/2000000030<Tm6`000000AFK90080AFK900<0e3dI00000015I/T0
0P15I/T2000000<0AFK900L0000004EVb@15I/T0AFK90000000mFJ/0e3dI00L0000000<0Af[A0000
0017J]400P17J]401@000000Af[A04MZd@000000e3dI0080Af[A00<000000=@m6@3D?AT00P3D?AT0
2P000000Af[A04MZd@000000Af[A0000003oD28000000?m@8P0mFJ/2000000030?mB8P000000oe8R
0080oe8R00@000000?mB8P3oDR800000103oDR800`000000oe@S0?mD8`030?mD8`80000000<0?EV[
0?mD8`3oE2<00P3oE2<00`000000oe@S0?mD8`030?mD8`030000003oE2<0oe@S00@0oe@S0P000002
0?mD8PH0?EV[00D000000?mB8@3oDR40oe8Q000000050?mB8@8000000`3oCQl01P000000ooK^0?of
kP3om^h0e3dI03eIZ`80ooK^0`3D?AT30?ofkP0403eIZ`3om^h0ooK^0?ofkPL0?EV[103om^h00`0m
FJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00`0ooK^200mFJ/;0?ofkPL0?EV[0P3om^h203eI
Z`H0ooK^0P00001=0?ofkP40oooo000k0?ofkP030000003om^h0ooK^01H0ooK^00<0?EV[0?ofkP3o
m^h04`3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkPL0?EV[103om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP04
03eIZ`3om^h0ooK^03eIZ`@0ooK^00<000000?ofkP3om^h02P3om^h203eIZa00ooK^00<0000005dL
3P0000000`0000001@1l9a80?EV[07`W4P000000YS<G008000000`2V<aL3000000<0bCdK00@00000
0<Tm6`00000000000P15I/T00`3D?AT000000000000304EVb@030000000mFJ/0AFK900H0000000@0
e3dI04MZd@17J]4000000`17J]4010000000Af[A04MZd@00000204MZd@0300000017J]40Af[A00D0
e3dI00/0Af[A00000017J]40Af[A00000017J]40000004MZd@000000oe0R000000020?m@8P0403eI
Z`3oD280oe0R00000080oe8R0P0000020?mB8P040000003oDR80oe8R0?mB8P80000000<0oe8R0000
003oE2<00P3oE2<010000000oe@S0?mD8`0mFJ/20?mD8`80000000@0oe@S0000003oE2<0oe@S0P00
00050?mD8`H0?EV[0P3oE2800`0mFJ/000000?mD8P020?mD8P030000003oDR40000000H0oe8Q00<0
00000?m>7`3oCQl00P3oCQl01P000000ooK^0?ofkP3om^h0e3dI03eIZ`80ooK^0`3D?AT703eIZ``0
ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP040?ofkPP0?EV[0`3om^h01@0mFJ/0
ooK^0?ofkP3om^h0?EV[00<0ooK^200mFJ/90?ofkP80?EV[1P3om^h2000004d0ooK^0@3oool003`0
ooK^00<000000?ofkP3om^h05@3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^00T0
ooK^1`0mFJ/30?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h0303om^h0100mFJ/0
ooK^0?ofkP0mFJ/40?ofkP030000003om^h0ooK^00X0ooK^00<0?EV[0?ofkP0mFJ/03`3om^h20000
0080GA`>00@0000007`W4P000000?EV[0P1l9a800`000000YS<G0:Hc5`02000000<0YS<G0`000002
0<Tm6`80000000<0bCdK0000000000000P15I/T700000080Af[A0P00000204MZd@050000003D?AT0
Af[A04MZd@0000000P17J]4010000000Af[A04MZd@0000050=@m6@0400000017J]40e3dI00000080
Af[A00<0000004MZd@0000000P17J]42000000070?m@8P000000oe0R0?m@8P000000?EV[0?m@8P02
000000030?mB8P000000oe8R0080oe8R00D000000?mB8P3oDR80oe8R000000030?mB8P040000003o
E2<00000000000<0oe@S00<0?EV[0000000000000`3oE2<010000000oe@S0000003oE2<603eIZ`<0
0000103oE2820000000403eIZ`3oE280oe@R0?mD8P8000001P3oDR42000000<0odhO00@000000?of
kP3om^h0ooK^200mFJ/30?ofkP0303eIZ`3om^h0ooK^00d0ooK^00@0?EV[0?ofkP3om^h0ooK^200m
FJ/<0?ofkPL0?EV[3P3om^h503eIZ`L0ooK^00<000000?ofkP3om^h0B`3om^h10?ooo`00?@3om^h0
0`000000ooK^0?ofkP0E0?ofkP0303eIZ`3om^h0ooK^01<0ooK^00@0?EV[0?ofkP3om^h0ooK^1`0m
FJ/;0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^03eI
Z`040?ofkP030000003om^h0ooK^00X0ooK^00<0?EV[0?ofkP0mFJ/03@3om^h303eIZ`8000000P1M
70h01@000000O2LB03eIZ`000000O2LB00<000000P2V<aL2000000030:Hc5`000000bCdK00H0?EV[
00@000000<Tm6`00000000000P17J]420000000304MZd@3D?AT0e3dI00<0e3dI00D0Af[A00000017
J]40Af[A0=@m6@0204MZd@030000003D?AT0e3dI00@0e3dI00<0000004MZd@0000000P17J]401000
0000Af[A04MZd@3D?AT204MZd@0400000017J]40000004MZd@8000000P3oD2801P000000oe0R0000
003oD280000003eIZ`80oe0R00<000000?mB8P3oDR800P0000020?mB8P8000001@3oDR800`000000
oe@S0?mD8`030?mD8`040000000mFJ/0oe@S0?mD8`H0?EV[103oE2<2000000<0oe@S00@000000?mD
8P3oE28000000P3oE2801@0mFJ/0oe@R0?mD8P3oE280000000H0oe8Q00<000000?mB8@0000000P3o
CQl503eIZ`050=@m6@3om^h0e3dI03eIZ`3om^h0103D?AT20?ofkP0303eIZ`3om^h0ooK^00X0ooK^
1`0mFJ/00`3om^h0?EV[0?ofkP0:0?ofkPP0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP070?ofkPP0?EV[
0P3om^h303eIZ`L0ooK^0P00001<0?ofkP40oooo000n0?ofkP030000003om^h0ooK^01@0ooK^00<0
?EV[0?ofkP3om^h0403om^h703eIZa80ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?of
kP0=0?ofkP0303eIZ`3om^h0?EV[00@0ooK^00<000000?ofkP3om^h02P3om^h0100mFJ/0ooK^0?of
kP0mFJ/60?ofkPH0?EV[0`3om^h300000080GA`>00H0000007`W4P0mFJ/0000007`W4P00000803eI
Z`80bCdK0`0000020<Tm6`80000000<0hd@M0000000000000P17J]4200000080Af[A00<0000004MZ
d@3D?AT01`3D?AT010000000Af[A04MZd@00000204MZd@0600000017J]40Af[A00000017J]400000
0P17J]402P3D?AT0Af[A00000017J]40000004MZd@000000Af[A0000003oD283000000040?m@8P00
0000oe0R03eIZ`<0000000@0oe8R0000003oDR80oe8R0P0000050?mB8P<000000`3oE2<603eIZ`04
0?mD8`0000000000000000D0oe@S00<000000?mD8`3oE2<00`3oE2<00`000000oe@R000000030?mD
8P0303eIZ`3oE280oe@R008000001@3oDR4010000000oe8Q0?mB8@3oDR42000000030=@m6@3om^h0
ooK^0080ooK^00D0e3dI0?ofkP3D?AT0?EV[0=@m6@020?ofkP80e3dI0P3om^h00`0mFJ/0ooK^0?of
kP020?ofkPP0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0403eIZ`3om^h0ooK^0?ofkPP0?EV[
203om^h0100mFJ/0ooK^03eIZ`3om^h803eIZ`@0ooK^1P0mFJ/20?ofkP0303eIZ`3om^h0ooK^00D0
ooK^0P00001<0?ofkP40oooo000n0?ofkP030000003om^h0ooK^01@0ooK^00<0?EV[0?ofkP3om^h0
2@3om^h703eIZ`<0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eI
Z`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP0mFJ/0103om^h00`000000ooK^0?ofkP0:0?ofkP0303eI
Z`3om^h0ooK^00L0?EV[2@3om^h0100mFJ/0000000000000000703eIZ`<0YS<G0P0000020:Hc5`03
00000039?A/0bCdK0080bCdK0`0000020<Tm6`030000003SA1d0hd@M008000000P17J]4200000003
04MZd@00000000000080Af[A0P0000001@3D?AT0000004MZd@17J]4000000080Af[A00h0000004MZ
d@17J]40000004MZd@000000Af[A00000017J]40000004MZd@3D?AT0000004MZd@80000000<0Af[A
0000003oD2800P0000000`3oD2800000000000020?m@8P0503eIZ`3oD280oe0R0?m@8P0000000P3o
DR800`000000oe8R0?mB8P030?mB8PP0?EV[0`3oE2<0100mFJ/0oe@S0000000000020?mD8`040000
003oE2<0oe@S0?mD8`8000001`3oE2<00`000000oe@R0?mD8P030?mD8P0503eIZ`000000oe@R0?mD
8P0000000`3oDR400`000000oe8Q0?mB8@020?mB8@80000000D0e3dI0?ofkP3om^h0ooK^0=@m6@02
0?ofkP030=@m6@3om^h0?EV[0080ooK^00<0e3dI03eIZ`0mFJ/01P0mFJ/<0?ofkPP0?EV[3P3om^h6
03eIZ`L0ooK^1@0mFJ/50?ofkP@0?EV[1`3om^h2000004`0ooK^0@3oool003l0ooK^00<000000?of
kP3om^h0503om^h0100mFJ/0ooK^0?ofkP3om^h703eIZ`/0ooK^00<0?EV[0?ofkP3om^h04`3om^h0
0`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00h0ooK^0P0mFJ/40?ofkP030000003om^h0
ooK^00P0ooK^1P0mFJ/<0?ofkPL0?EV[00D0GA`>000000000000?EV[0000000207`W4P030000002V
<aL0YS<G0080YS<G0P000000102V<aL000000000000000030<Tm6`@0000000@0hd@M0000000mFJ/0
hd@M0P00000204MZd@0400000017J]40Af[A000000<0Af[A00<000000=@m6@0000000P17J]400`00
0000Af[A0000000204MZd@0<00000017J]40000004MZd@000000Af[A00000017J]4000000=@m6@00
0000Af[A0P0000001@3oD28000000000003oD28000000080oe0R0P0000000`3oD280?EV[00000002
000000P0?EV[103oDR82000000D0oe@S00<0000003eIZ`3oE2<0103oE2<3000000L0oe@S0`000004
0?mD8P030000000mFJ/0oe@R0080oe@R00@000000?mB8@3oDR4000001@3oDR400`000000ooK^0=@m
6@030?ofkP030=@m6@3om^h0?EV[00H0?EV[0P3D?AT00`3om^h0?EV[0?ofkP090?ofkPL0?EV[0`3o
m^h00`0mFJ/0ooK^0?ofkP090?ofkPH0?EV[0P3om^h00`0mFJ/0ooK^03eIZ`020?ofkPH0?EV[0P3o
m^h803eIZ`/0ooK^0P00001<0?ofkP40oooo00100?ofkP030000003om^h0ooK^01<0ooK^100mFJ/B
0?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP0>
0?ofkP80?EV[103om^h00`000000ooK^0?ofkP020?ofkPH0?EV[0P3om^h01@0mFJ/0ooK^0?ofkP3o
m^h0?EV[00<0ooK^200mFJ/30?ofkP0403eIZ`3om^h0000000000080GA`>00<0000007`W4P0mFJ/0
0P000000101l9a8000000000000000030:Hc5`8000000P39?A/300000080bCdK0`0000001@3SA1d0
?EV[000000000000hd@M0080000000@0Af[A000000000000Af[A0P00000204MZd@050=@m6@17J]40
000004MZd@0000000P17J]400`000000Af[A04MZd@020000000304MZd@000000Af[A00L0000000H0
oddQ000000000000oe0R0000003oD282000000L0?EV[103oDR82000000@0oe8R0P0000000`3oDR80
00000?mD8`020?mD8`80000000<0oe@S03eIZ`3oE2<00`3oE2<2000000L0oe@S0P0000020?mD8`07
0000003oE280oe@R0?mD8P000000oe@R03eIZ`040?mD8P8000001@3oDR400`000000?EV[03eIZ`06
03eIZ`80ooK^00<0e3dI03eIZ`3om^h00P3om^h20=@m6@030?ofkP0mFJ/0ooK^0080ooK^1`0mFJ/6
0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/01@3om^h603eIZ`L0ooK^3P0mFJ/C0?ofkP800000C03o
m^h10?ooo`00@@3om^h00`000000ooK^0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[
0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00l0ooK^00@0?EV[
0?ofkP3om^h0ooK^1P0mFJ/80?ofkP0303eIZ`3om^h0?EV[00D0?EV[2`3om^h00`0mFJ/0ooK^0?of
kP0200000080GA`>00@0000003eIZ`1l9a80O2LB0P0000020:Hc5`8000000`2V<aL00`000000bCdK
0<Tm6`020<Tm6`<0000000D0bCdK000000000000?EV[000000020>=47@@0000000D0Af[A00000000
0000Af[A0000000204MZd@070=@m6@000000000004MZd@000000Af[A0000000204MZd@H0000000<0
BFgG0000000000000P0000000`3oCB4000000000000603eIZ`80000000D0oe0R03eIZ`000000oe0R
000000020?mB8P800000103oDR82000000@0oe8R0`0000040?mD8`0403eIZ`000000000000000080
oe@S00<000000?mD8`3oE2<00P3oE2<2000000D0oe@S0`0000030?mD8P0403eIZ`3oE280oe@R0?mD
8PP0?EV[0`3om^h00`3D?AT0ooK^0=@m6@040?ofkP80e3dI00<0?EV[0?ofkP3om^h01`0mFJ/>0?of
kP0303eIZ`3om^h0ooK^00H0?EV[1P3om^h=03eIZa`0ooK^00<000000?ofkP3om^h0BP3om^h10?oo
o`00@P3om^h00`000000ooK^0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3o
m^h04`3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00/0ooK^200mFJ/00`3om^h0
00000?ofkP080?ofkPD0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0403eIZ`3om^h0ooK^0?of
kP<0000000@0GA`>000000000000?EV[0`1l9a8010000000YS<G0:Hc5`2V<aL200000080YS<G1000
00030<Tm6`<0000000<0hd@M03eIZ`0000000P0000000`3SA1d00000000000020000000304MZd@00
000000000080000000<0e3dI04MZd@000000200000000`19KML0000004U]e`020000000404U]e`00
000000000?m=8@<0000000@0oe0R000000000000oe0R0P0000001@3oD28000000000003oD280?EV[
0080oe0R0P0000030?mB8P<000001@3oDR82000000D0oe@S00<0000003eIZ`3oE2<0103oE2<00`00
0000oe@S0?mD8`02000000L0oe@S00@000000?mD8P3oE280oe@R1P0mFJ/00`000000oe8Q0?mB8@02
0?mB8@0303eIZ`3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3D?AT00P3om^h703eIZ`80e3dI00<0ooK^
03eIZ`3om^h03@3om^h703eIZ`<0ooK^3P0mFJ/S0?ofkP800000B`3om^h10?ooo`00@`3om^h00`00
0000ooK^0?ofkP0A0?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0m
FJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^0080ooK^2@0mFJ/40?ofkP0303eIZ`3om^h0ooK^
0080ooK^00@000000?ofkP3om^h0ooK^1P0mFJ/30?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[
0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP020?ofkPD0000000H0?EV[0000001l9a80O2LB0000
002V<aL200000080YS<G0`0000030<Tm6`<000000P39?A/20000000303eIZ`3SA1d0hd@M00@00000
00<0hd@M0000000000001P0000002P19KML0000000000019KML0000004U]e`000000BFgG00000019
KML20000000504U]e`00000000000000003oCB400`0000000`3oCB4000000?m@8P02000000030?m@
8P00000000000080oe0R00D0000003eIZ`000000oe0R000000020?mB8P8000001@3oDR8300000004
0?mB8P000000oe@S0?mD8`<000000P3oE2<00`0mFJ/0oe@S0?mD8`020?mD8`<000001`3oE2<603eI
Z`80oe@R00<0?EV[0000003oE2800P3oE2801@000000oe8Q0?mB8@000000?EV[00<0ooK^1`0mFJ/3
0?ofkP040=@m6@0mFJ/0ooK^0?ofkP<0e3dI00<0?EV[0?ofkP3om^h0103om^h803eIZ`<0ooK^3P0m
FJ/Z0?ofkP800000B`3om^h10?ooo`00@`3om^h00`000000ooK^0?ofkP0A0?ofkP0303eIZ`3om^h0
ooK^01<0ooK^00<0?EV[0?ofkP3om^h0503om^h0100mFJ/0ooK^0?ofkP3om^h503eIZ`d0ooK^0P0m
FJ/20?ofkPD0?EV[2@3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0
?EV[0?ofkP3om^h00`3om^h20000000405dL3P000000?EV[07`W4P80000000@0O2LB0000002V<aL0
YS<G0`0000000`2V<aL00000000000050<Tm6`@0000000D0hd@M03eIZ`00000000000>=47@0<0000
0080BFgG100000000`19KML0000000000005000000040?m=8@00000000000?m=8@@0000000<0oe0R
0000000000000P3D?AT200000080oe0R00<0?EV[0?m@8P0000000P0000040?mB8P<00000103oDR83
000000D0oe@S00<0?EV[0?mD8`0000000P0000000`3oE2<000000?mD8`020?mD8`D0?EV[0`3oE2<0
10000000oe@R0?mD8P3oE2820000000703eIZ`3oE280oe@R0?mD8P000000oe8Q0=@m6@0503eIZ`<0
ooK^00<0e3dI0?ofkP3om^h0103om^h0103D?AT0ooK^03eIZ`3om^h20=@m6@P0?EV[103om^h=03eI
Zc80ooK^0P00001;0?ofkP40oooo00140?ofkP030000003om^h0ooK^0140ooK^00<0?EV[0?ofkP3o
m^h04`3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/03`3om^h603eI
Z`030000003om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP090?of
kP0303eIZ`3om^h0ooK^00<0ooK^0`0000000`1M70h0000003eIZ`0207`W4P8000001@2V<aL30000
00030<Tm6`0000000000008000000`39?A/20000000303eIZ`3SA1d0hd@M00l0000000<0BFgG0000
000000003P0000001@3oCB400000000000000000e3dI008000000`3oD2820000000403eIZ`000000
oe0R00000080oe8R0`0000030?mB8P@0000000<0oe8R0000003oE2<0103oE2<20000000303eIZ`3o
E2<0oe@S00H0?EV[00<0oe@S0000000000001@3oE2<010000000oe@R0000000000020?mD8P0303eI
Z`3oE280oe@R0080oe@R00@0000003eIZ`3om^h0?EV[1P3om^h00`3D?AT0ooK^0?ofkP030?ofkPP0
?EV[0`3om^h>03eIZcT0ooK^0P00001;0?ofkP40oooo00150?ofkP030000003om^h0ooK^0100ooK^
00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0503eIZ`3om^h0ooK^0?ofkP0m
FJ/0203om^h703eIZ`040?ofkP0mFJ/0ooK^03eIZ`80ooK^00<000000?ofkP3om^h02P3om^h00`0m
FJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h00P3om^h203eI
Z`<0000000<0GA`>03eIZ`0000000`1l9a800`000000YS<G0:Hc5`040:Hc5`8000001039?A/40000
00X0?EV[7P0000020?m@8P@000000`3oD2800`0mFJ/000000000000200000080oe8R100000060?mB
8P040000003oE2<00000000000H0?EV[0`3oE2<010000000oe@S0000000000070?mD8`8000001@3o
E2801`0mFJ/0oe@R000000000000e3dI0?ofkP0mFJ/01P3om^h703eIZ`040=@m6@3om^h0e3dI0?of
kPd0?EV[@@3om^h2000004/0ooK^0@3oool004H0ooK^00<000000?ofkP3om^h03`3om^h00`0mFJ/0
ooK^0?ofkP0D0?ofkP0303eIZ`3om^h0ooK^01<0ooK^00@0?EV[0?ofkP0mFJ/0ooK^200mFJ/80?of
kP0603eIZ`3om^h0ooK^03eIZ`3om^h00000303om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3o
m^h0ooK^00H0ooK^200mFJ/20?ofkP80000000@0GA`>000000000000?EV[0P00000207`W4P@00000
102V<aL2000000H0?EV[0P0000000`0mFJ/0hd@M0>=47@020>=47B<0000000<0oe0R000000000000
100000000`0mFJ/0000000000004000000H0oe8R200mFJ/40?mD8`0403eIZ`3oE2<0oe@S0?mD8`<0
00001P3oE2<3000000030?mD8`000000oe@R00@0oe@R00D0?EV[0000003om^h0ooK^0=@m6@0803eI
Z`040=@m6@3om^h0e3dI0?ofkP`0?EV[BP3om^h00`000000ooK^0?ofkP190?ofkP40oooo00170?of
kP030000003om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP0@0?of
kPL0?EV[403om^h01P0mFJ/0ooK^0?ofkP0mFJ/0ooK^000000`0ooK^00<0?EV[0?ofkP3om^h01@3o
m^h00`0mFJ/0ooK^03eIZ`0503eIZ`<0ooK^00<0?EV[0?ofkP3om^h01@3om^h200000080GA`>00<0
?EV[07`W4P1l9a800`0000030:Hc5`030000000mFJ/0?EV[00<0?EV[0`39?A/5000000030>=47@0m
FJ/0000000D0000000<0hd@M0000000000007P0000000`3oD2800000000000040000000403eIZ`3o
D280oe0R000000P0?EV[0P0000020?mB8P030000003oE2<0oe@S00D0oe@S00H0?EV[000000000000
00000?mD8`0000050?mD8`800000103oE2<010000000oe@R0?mD8P3oE28803eIZ`<0ooK^3@0mFJ/0
1P3om^h0e3dI0?ofkP3D?AT0ooK^0=@m6D/0ooK^00<000000?ofkP3om^h0B@3om^h10?ooo`00B03o
m^h00`000000ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h02@3o
m^h703eIZ`@0ooK^0P0mFJ/A0?ofkP0603eIZ`3om^h0ooK^0?ofkP0mFJ/00000303om^h0100mFJ/0
ooK^0?ofkP3om^h603eIZ`T0ooK^00<0?EV[0?ofkP3om^h01P3om^h01@000000GA`>05dL3P1M70h0
?EV[0080O2LB1P0mFJ/30:Hc5`8000001`39?A/20000000303eIZ`3SA1d0hd@M00@0hd@M8P000003
0?m@8PL0?EV[100000090?mB8P030000003oE2<0oe@S00@0000000<0oe@S03eIZ`3oE2<00`3oE2<0
0`000000oe@S00000002000000<0oe@S1`0mFJ/20?ofkPl0?EV[00<0e3dI0?ofkP3om^h00P3om^h0
1`3D?AT0ooK^0?ofkP3D?AT0ooK^0=@m6@3om^h00P3D?AU:0?ofkP800000BP3om^h10?ooo`00B03o
m^h00`000000ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^01<0ooK^00@0?EV[0?ofkP3om^h0ooK^
1`0mFJ/;0?ofkP80?EV[4@3om^h01P0mFJ/0ooK^0?ofkP3om^h0?EV[000000T0ooK^1`0mFJ/50?of
kP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`000000?EV[03eIZ`0403eI
Z`80O2LB00<000000:Hc5`0000000P0000030:Hc5`0300000039?A/0bCdK00D0000000@0bCdK0000
003SA1d0?EV[0`3SA1dQ000000H0?EV[00D000000?m@8P3oD280oe0R03eIZ`020?m@8P030000003o
DR80oe8R00@0oe8R2@0000050?mD8`0303eIZ`3oE2<0oe@S00800000200mFJ/20?mD8`h0?EV[103o
m^h00`3D?AT0ooK^0?ofkP020?ofkP040=@m6@3om^h0ooK^0=@m6@@0ooK^0P3D?AT20?ofkP030=@m
6@3om^h0ooK^04P0ooK^0P00001:0?ofkP40oooo00190?ofkP030000003om^h0ooK^00h0ooK^00<0
?EV[0?ofkP3om^h0403om^h703eIZa<0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?of
kP030?ofkP0403eIZ`3om^h0ooK^0?ofkPH0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eI
Z`3om^h0ooK^00H0ooK^00@0?EV[0?ofkP3om^h0ooK^1`0mFJ/01P000000GA`>0000001M70h0?EV[
07`W4P80000000<0O2LB0000002V<aL00P2V<aL3000000030:Hc5`000000bCdK00D0bCdK0`000000
0`0mFJ/000000000000/0000000303eIZ`000000000000L000001P3oDR800`000000oe@S0?mD8`02
0?mD8`8000001P0mFJ/00`3oE2<000000?mD8`050?mD8`030=@m6@0mFJ/0?EV[00H0?EV[00<0e3dI
0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^0080ooK^00@0e3dI
0?ofkP3om^h0e3dI103om^h20=@m6@80ooK^00<0e3dI0?ofkP3om^h0B03om^h2000004X0ooK^0@3o
ool004X0ooK^00<000000?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP090?ofkPL0?EV[103om^h0
0`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00@0?EV[0?ofkP3om^h0ooK^1P0m
FJ/90?ofkP0303eIZ`3om^h0ooK^00L0ooK^00@0?EV[0?ofkP3om^h0ooK^200mFJ/70?ofkP800000
00<0GA`>0000000mFJ/00`1l9a82000000H0YS<G300000000`0mFJ/0000000000002000000<0hd@M
100000000`3gBAl000000000000<0000000304U_f`000000000000d00000103oD28203eIZ`030000
003oDR80oe8R00D0oe8R1P00000603eIZ`<0oe@S0P0mFJ/20?mD8`030000003oE2<0?EV[00H0?EV[
1P3om^h00`3D?AT0ooK^0?ofkP040?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT01P3om^h00`3D?AT0
ooK^0=@m6@050?ofkP040=@m6@3om^h0ooK^0=@m6DX0ooK^0P00001:0?ofkP40oooo001;0?ofkP03
0000003om^h0ooK^00d0ooK^00@0?EV[0?ofkP3om^h0ooK^1`0mFJ/;0?ofkP0303eIZ`3om^h0ooK^
0180ooK^00<0?EV[0?ofkP0mFJ/03@3om^h603eIZ`80ooK^00<0000003eIZ`3om^h02@3om^h00`0m
FJ/0ooK^0?ofkP050?ofkPL0?EV[103om^h00`0mFJ/0ooK^0?ofkP090?ofkP8000000P1M70h00`0m
FJ/0O2LB07`W4P0207`W4PD000000`2V<aL00`000000bCdK0<Tm6`060<Tm6`030000000mFJ/0hd@M
0080hd@M100000020>=47@T0000000<0BFoK0000000000000P0000000`19Km/00000000000020000
000304U_f`000000000000P000000`3oD28>000000H0?EV[00<0oe8R0000003oE2<01P3oE2<603eI
Z`030000003om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP040?of
kP050=@m6@3om^h0ooK^0?ofkP3D?AT01P3om^h00`3D?AT0ooK^0=@m6@050?ofkP040=@m6@3om^h0
ooK^0=@m6D/0ooK^00<000000?ofkP3om^h0B03om^h10?ooo`00C03om^h00`000000ooK^0?ofkP0<
0?ofkP@0?EV[4`3om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP0303eIZ`3om^h0?EV[00L0ooK^1P0mFJ/2
0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0000003eIZ`3om^h02@3om^h803eIZ`@0ooK^00<0?EV[
0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP80000000<0GA`>03eIZ`1l9a800P000002
07`W4P040000002V<aL0YS<G0:Hc5`h0000000<0?EV[0000003SA1d00P3SA1d503eIZ`T0000000<0
BFoK00000019Km/0200000000`17K]L0e3dI0000000>00000080oe0R00<0000003eIZ`3oDR80100m
FJ/70?mB8P030000003oE2<0oe@S0080oe@S0`0mFJ/20=@m6@030000003om^h0ooK^00P0ooK^00<0
e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0e3dI00L0ooK^0P3D
?AT60?ofkP040=@m6@3om^h0ooK^0=@m6D/0ooK^00<000000?ofkP3om^h0B03om^h10?ooo`00C@3o
m^h00`000000ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h04@3o
m^h00`0mFJ/0ooK^0?ofkP0703eIZ`P0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`000000ooK^03eI
Z`030?ofkPL0?EV[2`3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00P0ooK^0`0m
FJ/40000000303eIZ`1l9a80O2LB00<000001`2V<aL00`000000bCdK0<Tm6`040<Tm6`P0?EV[00@0
00000>=47@00000000000P3SA1d20000000304U_f`000000BFoK00L0000000D0AfkG00000017K]L0
000004M^e`04000000030=@m6@17K]L0AfkG00H00000103D?ATG000000030=@m6@3om^h0e3dI00d0
ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@090?ofkP030=@m6@3om^h0e3dI00P0ooK^00<0e3dI0?of
kP3om^h00`3om^h01@3D?AT0ooK^0=@m6@3om^h0e3dI04/0ooK^0P0000190?ofkP40oooo001=0?of
kP030000003om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h0503om^h00`0mFJ/0ooK^0?ofkP0@0?of
kP@0?EV[3@3om^h00`0mFJ/0ooK^0?ofkP030?ofkPL0?EV[1P3om^h00`0mFJ/0ooK^0?ofkP0:0?of
kP0303eIZ`3om^h0ooK^0080ooK^00@0?EV[0?ofkP3om^h0ooK^1`0mFJ/40?ofkP80000000<0GA`>
0000000mFJ/00`1l9a85000000<0YS<G1`0mFJ/40000000403eIZ`3SA1d0hd@M0>=47@8000000P3S
A1d7000000090=@m6@000000AfkG04M^e`000000AfkG00000017K]L000000080AfkG0P0000001017
K]L000000000003D?AT20000000403eIZ`17K]L0AfkG03eIZ`80e3dI1@00000403mS`P030=@m6@0o
Hl80?f?200T000001P3om^h20=@m6@h0ooK^00@0e3dI0?ofkP3om^h0e3dI2`3om^h00`3D?AT0ooK^
0?ofkP070?ofkP030=@m6@3om^h0ooK^00<0ooK^00D0e3dI0?ofkP3D?AT0ooK^0=@m6@1;0?ofkP80
0000B@3om^h10?ooo`00CP3om^h00`000000ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^01<0ooK^
00<0?EV[0?ofkP3om^h0403om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00/0ooK^1`0mFJ/01@000000
ooK^0?ofkP3om^h0?EV[00P0ooK^00<0?EV[0?ofkP3om^h02`3om^h803eIZ``0ooK^00D0000005dL
3P1M70h0?EV[0000000307`W4PL0?EV[1P0000040<Tm6`030000003SA1d0?EV[008000000P3SA1d3
0000000404M^e`000000000004M^e`80000000D0e3dI00000017K]L0AfkG0000000204M^e`030000
0017K]L000000080AfkG00H0?EV[00000017K]L0AfkG0000003D?AT2000000<0e3dI1P0oHl860000
00030=@m6@000000000000h0ooK^00<0e3dI0?ofkP3om^h03P3om^h20=@m6@`0ooK^00<0e3dI0?of
kP3om^h01P3om^h20=@m6@D0ooK^00D0e3dI0?ofkP3D?AT0ooK^0=@m6@1;0?ofkP800000B@3om^h1
0?ooo`00C`3om^h00`000000ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^01@0ooK^00<0?EV[0?of
kP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^0080ooK^1`0mFJ/00`3o
m^h0?EV[0?ofkP040?ofkP050000003om^h0ooK^0?ofkP0mFJ/01`3om^h00`0mFJ/0ooK^0?ofkP07
0?ofkPL0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkPL0?EV[0P0000060:Hc5`0300000039?A/0
bCdK00<0bCdK1P0000002@0mFJ/0hd@M000000000000hd@M00000017K]L0000004M^e`0300000008
04M^e`000000e3dI04M^e`0mFJ/0000004M^e`0mFJ/8000000D0e3dI300000030?ofkP030=@m6@3o
m^h0ooK^00`0ooK^0`3D?AT@0?ofkP030=@m6@3om^h0ooK^00X0ooK^0P3D?AT80?ofkP030=@m6@3o
m^h0e3dI00<0ooK^00H0e3dI0?ofkP3om^h0e3dI0?ofkP3D?AU;0?ofkP800000B@3om^h10?ooo`00
D03om^h00`000000ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h0
3P3om^h00`0mFJ/0ooK^0?ofkP0703eIZ`P0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`000000ooK^
0?ofkP020?ofkP0303eIZ`3om^h0ooK^00@0ooK^00@0?EV[0?ofkP3om^h0ooK^1P0mFJ/60?ofkP03
03eIZ`3om^h0?EV[00X0ooK^1`0mFJ/40000000403eIZ`1l9a80O2LB07`W4Pd000001039?A/01@00
0000hd@M0>=47@000000hd@M0080000000H0AfkG00000017K]L0000004M^e`0mFJ/3000000030=@m
6@00000000000080000000<0?f?20=@m6@3D?AT01P3D?AT0100oHl8000000000003D?AT7000000X0
ooK^00<0e3dI0?ofkP3om^h02@3om^h20=@m6@<0ooK^00<0e3dI0?ofkP3om^h0303om^h20=@m6@/0
ooK^00@0e3dI0?ofkP3om^h0e3dI1P3om^h0103D?AT0ooK^0?ofkP3D?AT30?ofkP040=@m6@3om^h0
ooK^0?ofkP80e3dIC03om^h00`000000ooK^0?ofkP170?ofkP40oooo001A0?ofkP030000003om^h0
ooK^00X0ooK^00<0?EV[0?ofkP3om^h0503om^h00`0mFJ/0ooK^0?ofkP090?ofkPL0?EV[103om^h0
0`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<000000?ofkP3om^h00`3om^h0
0`0mFJ/0ooK^03eIZ`0703eIZ`d0ooK^0P0mFJ/30?ofkPL0?EV[1`3om^h00`0mFJ/0000005dL3P02
0000000303eIZ`1l9a80O2LB0080O2LB00<000000:Hc5`2V<aL0102V<aL00`000000bCdK0<Tm6`05
0<Tm6`80000000D0hd@M000000000000AfkG000000050=@m6@800000203D?AT;000000030=@m6@00
0000ooK^00l0ooK^00<0e3dI0?ofkP3om^h01`3om^h20=@m6@D0ooK^00<0e3dI0?ofkP3om^h02`3o
m^h0103D?AT0ooK^0?ofkP3D?AT90?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT01P3om^h0103D?AT0
ooK^0?ofkP3D?AT30?ofkP040=@m6@3om^h0ooK^0?ofkP80e3dIC03om^h00`000000ooK^0?ofkP17
0?ofkP40oooo001B0?ofkP030000003om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0m
FJ/0ooK^0?ofkP020?ofkPL0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^
00L0ooK^00<0?EV[0?ofkP3om^h00P3om^h:03eIZ`<0ooK^00<0?EV[0?ofkP3om^h03@3om^h703eI
Z`d0ooK^00@0?EV[0?ofkP0mFJ/0?EV[0P1M70h00`000000?EV[0000000207`W4P030000002V<aL0
YS<G00@0YS<G00@000000<Tm6`39?A/0bCdK1@0mFJ/80000000303mS`P00000000000080?f?200@0
000003mS`P0oHl80e3dI1000000<0?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h0
103om^h20=@m6@P0ooK^00<0e3dI0?ofkP3om^h0203om^h20=@m6@<0ooK^00<0e3dI0?ofkP3om^h0
1`3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00D0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@030?of
kP040=@m6@3om^h0ooK^0?ofkP80e3dIC03om^h2000004P0ooK^0@3oool00580ooK^00<000000?of
kP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP0A0?ofkPL0?EV[2P3om^h00`0mFJ/0ooK^0?ofkP060?of
kP0303eIZ`3om^h0ooK^00<0ooK^200mFJ/20?ofkP030000003om^h0ooK^00@0ooK^00D0?EV[0?of
kP3om^h0ooK^03eIZ`080?ofkPL0?EV[0P3om^h00`0mFJ/0ooK^03eIZ`0;0?ofkPH0?EV[00L0ooK^
0000001M70h0GA`>0000001l9a80?EV[00D00000200mFJ/30<Tm6`8000000P0oHl800`3D?AT00000
000000040000000303eIZ`000000000000@0000000<0ooK^0=@m6@3om^h03P3om^h00`3D?AT0ooK^
0?ofkP0?0?ofkP030=@m6@3om^h0ooK^0080ooK^0P3D?AT:0?ofkP030=@m6@3om^h0ooK^00L0ooK^
00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^0080ooK^
00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0e3dI00D0ooK^
00<0e3dI0?ofkP3om^h0BP3om^h2000004P0ooK^0@3oool005<0ooK^00<000000?ofkP3om^h02P3o
m^h00`0mFJ/0ooK^0?ofkP090?ofkPL0?EV[103om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3o
m^h0ooK^00H0ooK^1P0mFJ/20?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<000000?ofkP3om^h01@3o
m^h00`0mFJ/0ooK^03eIZ`020?ofkPL0?EV[203om^h0100mFJ/0ooK^0?ofkP3om^h;03eIZ`<0ooK^
00<0?EV[0?ofkP3om^h00P3om^h00`000000e3dI03eIZ`0703eIZ`D0YS<G00<000000<Tm6`39?A/0
0`00000203mS`P80000000<0e3dI000000000000100000080?ofkP030=@m6@3om^h0ooK^00h0ooK^
00<0e3dI0?ofkP3om^h03`3om^h0103D?AT0ooK^0=@m6@3D?AT=0?ofkP030=@m6@3om^h0ooK^00D0
ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00@0
ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@050?ofkP030=@m6@3om^h0e3dI00D0ooK^00<0e3dI0?of
kP3om^h0BP3om^h2000004P0ooK^0@3oool005@0ooK^00<000000?ofkP3om^h02@3om^h00`0mFJ/0
ooK^0?ofkP020?ofkPL0?EV[2`3om^h00`0mFJ/0ooK^0?ofkP090?ofkP0403eIZ`3om^h0ooK^0?of
kPH0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<000000?of
kP3om^h00`3om^h703eIZ``0ooK^2@0mFJ/;0?ofkPP0?EV[00<0e3dI0000001l9a800`0mFJ/0101l
9a8000000:Hc5`2V<aL203eIZ`030:Hc5`000000000000T0000000<0e3dI0?ofkP3om^h0303om^h0
0`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00h0ooK^0`3D?AT?0?ofkP030=@m6@3om^h0
ooK^00@0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0
ooK^00D0ooK^00@0e3dI0?ofkP3om^h0e3dI1P3om^h00`3D?AT0ooK^0=@m6@050?ofkP030=@m6@3o
m^h0ooK^04X0ooK^0P0000180?ofkP40oooo001E0?ofkP030000003om^h0ooK^00T0ooK^100mFJ/C
0?ofkP0303eIZ`3om^h0ooK^00P0ooK^100mFJ/80?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[
0?ofkP3om^h01@3om^h703eIZ`<0ooK^0P0mFJ/80?ofkPH0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP04
0?ofkP0303eIZ`3om^h0ooK^0080ooK^1`0mFJ/50?ofkP`0?EV[0P3D?AT00`000000e3dI00000003
000000H0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0
ooK^00X0ooK^0`3D?AT00`3om^h0e3dI0?ofkP0@0?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI
0?ofkP3om^h0203om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00P0ooK^00@0e3dI0?ofkP3om^h0e3dI
1`3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^04/0ooK^00<000000?ofkP3om^h0
AP3om^h10?ooo`00EP3om^h00`000000ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^01@0ooK^00<0
?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0403eIZ`3om^h0ooK^0?ofkPP0?EV[
00<0ooK^0000003om^h01`3om^h00`0mFJ/0ooK^03eIZ`0703eIZ`L0ooK^00<0?EV[0?ofkP3om^h0
0`3om^h703eIZ`80ooK^400mFJ/00`3om^h0e3dI0000000500000080e3dI2`3om^h00`3D?AT0ooK^
0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h01`3om^h30=@m6@D0ooK^
00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP020=@m6@/0ooK^00@0e3dI0?ofkP3om^h0
e3dI2@3om^h00`3D?AT0ooK^0=@m6@080?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3o
m^h0C03om^h00`000000ooK^0?ofkP160?ofkP40oooo001G0?ofkP030000003om^h0ooK^00T0ooK^
00<0?EV[0?ofkP3om^h0503om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00T0ooK^
1`0mFJ/70?ofkP030000003om^h0ooK^00<0ooK^200mFJ/<0?ofkPL0?EV[0`3om^h603eIZ`030?of
kP0mFJ/0?EV[00L0?EV[0P3om^h70=@m6@80ooK^0P3D?AT30?ofkP80e3dI2@3om^h00`3D?AT0ooK^
0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h00`3om^h30=@m6@P0ooK^
00<0e3dI0?ofkP3om^h03`3om^h20=@m6@d0ooK^00@0e3dI0?ofkP3om^h0e3dI2P3om^h20=@m6@L0
ooK^0P3D?AT50?ofkP030=@m6@3om^h0ooK^04`0ooK^00<000000?ofkP3om^h0AP3om^h10?ooo`00
E`3om^h00`000000ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h0
103om^h00`0mFJ/0ooK^0?ofkP030?ofkPL0?EV[103om^h203eIZ`P0ooK^1P0mFJ/20?ofkP0303eI
Z`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h00P3om^h803eIZ`80ooK^1`0mFJ/20?ofkPL0?EV[
2P3om^h20=@m6@040?ofkP3D?AT0e3dI0=@m6@80ooK^0P3D?AT40?ofkPD0e3dI1P3om^h00`3D?AT0
ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h00`3D?AT<0?ofkP03
0=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h03@3om^h20=@m6@/0ooK^00<0e3dI0?ofkP3o
m^h01P3om^h00`3D?AT0ooK^0=@m6@040?ofkP030=@m6@3om^h0ooK^04`0ooK^0P0000170?ofkP40
oooo001H0?ofkP030000003om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h0503om^h00`0mFJ/0ooK^
0?ofkP020?ofkPL0?EV[2`3om^h203eIZ`80ooK^1P0mFJ/00`000000ooK^0?ofkP040?ofkP0303eI
Z`3om^h0ooK^0080ooK^1`0mFJ/30?ofkPL0?EV[0P3om^h703eIZa80ooK^0P3D?AT0103om^h0e3dI
0=@m6@3D?AT20?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h00P3om^h30=@m6@@0
ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP0:0?ofkPD0e3dI3`3om^h00`3D?AT0
ooK^0?ofkP0<0?ofkP<0e3dI3`3om^h00`3D?AT0ooK^0?ofkP090?ofkP80e3dI1`3om^h0103D?AT0
ooK^0?ofkP3D?AT40?ofkP030=@m6@3om^h0ooK^04`0ooK^0P0000170?ofkP40oooo001I0?ofkP03
0000003om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h04@3om^h803eIZ`h0ooK^1`0mFJ/60?ofkP03
0000003om^h0ooK^00<0ooK^1P0mFJ/40?ofkPl0?EV[6@3om^h20=@m6@040?ofkP3D?AT0e3dI0=@m
6@80ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP040?ofkPD0e3dI3P3om^h00`3D
?AT0ooK^0?ofkP020?ofkPP0e3dI0`3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^
00T0ooK^0P3D?AT30?ofkP030=@m6@3om^h0ooK^00/0ooK^0P3D?AT:0?ofkP040=@m6@3om^h0ooK^
0=@m6@H0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@020?ofkP030=@m6@3om^h0ooK^04d0ooK^0P00
00170?ofkP40oooo001J0?ofkP030000003om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h02P3om^h6
03eIZ`@0ooK^00@0?EV[0?ofkP3om^h0?EV[203om^h603eIZ`80ooK^00<0?EV[0?ofkP3om^h00P3o
m^h00`0mFJ/0ooK^0?ofkP020?ofkPP0?EV[0P3om^h703eIZ`030?ofkP0mFJ/0?EV[00D0?EV[8@3o
m^h20=@m6@060?ofkP3D?AT0ooK^0=@m6@3om^h0e3dI1@3om^h00`3D?AT0ooK^0?ofkP080?ofkQ@0
e3dI303om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00L0ooK^0P3D?AT50?ofkP03
0=@m6@3om^h0ooK^00T0ooK^0P3D?AT20?ofkP030=@m6@3om^h0ooK^00L0ooK^00@0e3dI0?ofkP3o
m^h0e3dI1@3om^h00`3D?AT0ooK^0?ofkP020?ofkP040=@m6@3om^h0ooK^0=@m6E00ooK^00<00000
0?ofkP3om^h0A@3om^h10?ooo`00F`3om^h00`000000ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^
0080ooK^1`0mFJ/;0?ofkP80?EV[0`3om^h603eIZ`L0ooK^00@0?EV[0?ofkP3om^h0ooK^1`0mFJ/0
0`3om^h000000?ofkP0703eIZ`80ooK^1P0mFJ/X0?ofkP80e3dI00@0ooK^0=@m6@3om^h0ooK^0P3D
?AT60?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?of
kP0=0?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h0103om^h20=@m6@P0ooK^00<0
e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0
e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^0080ooK^00@0
e3dI0?ofkP3om^h0e3dID03om^h00`000000ooK^0?ofkP150?ofkP40oooo001L0?ofkP030000003o
m^h0ooK^00T0ooK^100mFJ/C0?ofkP@0?EV[2P3om^h703eIZ`@0ooK^3`0mFJ/_0?ofkP80e3dI00<0
ooK^0=@m6@3om^h0103D?AT50?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h0303o
m^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h00P3o
m^h20=@m6@X0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3o
m^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h00`3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00H0ooK^
00<0e3dI0?ofkP3D?AT0D03om^h00`000000ooK^0?ofkP150?ofkP40oooo001L0?ofkP030000003o
m^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h04P3om^h0100mFJ/0ooK^0?ofkP0mFJ/40?ofkPL0?EV[
00@0ooK^03eIZ`3om^h0ooK^3`0mFJ/g0?ofkP<0e3dI0P3om^h00`3D?AT0ooK^0?ofkP020=@m6@<0
ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00d0
ooK^00<0e3dI0?ofkP3om^h03`3om^h0103D?AT0ooK^0=@m6@3D?AT<0?ofkP030=@m6@3om^h0ooK^
00@0ooK^0P3D?AT70?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h0103om^h01@3D
?AT0ooK^0?ofkP3om^h0e3dI00H0ooK^0P3D?AUA0?ofkP800000AP3om^h10?ooo`00G@3om^h00`00
0000ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00l0ooK^0P0mFJ/00`3om^h0?EV[03eIZ`0503eI
Z`<0ooK^3`0mFJ/40?ofkP030000003om^h0ooK^03P0ooK^103D?AT00`3om^h0e3dI0?ofkP030?of
kP80e3dI0P3om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?of
kP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP<0e3dI3`3om^h00`3D?AT0ooK^0?ofkP020?of
kP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP060?of
kP030=@m6@3om^h0e3dI00P0ooK^00<0e3dI0?ofkP3om^h0C`3om^h2000004H0ooK^0@3oool005h0
ooK^00<000000?ofkP3om^h02P3om^h203eIZ``0ooK^5@0mFJ/>0?ofkP030000003om^h0ooK^03T0
ooK^0`3D?AT20?ofkP030=@m6@3om^h0ooK^00<0ooK^0`3D?AT:0?ofkP030=@m6@3om^h0ooK^00`0
ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP<0e3dI00<0ooK^0=@m6@3o
m^h03`3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00/0ooK^00@0e3dI0?ofkP3om^h0e3dI2@3om^h0
0`3D?AT0ooK^0=@m6@080?ofkP030=@m6@3om^h0ooK^04l0ooK^0P0000160?ofkP40oooo001O0?of
kP030000003om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h00P3om^hC03eIZaL0ooK^00<000000?of
kP3om^h0>@3om^h70=@m6@H0ooK^0`3D?AT90?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?of
kP3om^h03@3om^h00`3D?AT0ooK^0?ofkP060?ofkP<0e3dI1@3om^h00`3D?AT0ooK^0?ofkP0>0?of
kP<0e3dI303om^h0103D?AT0ooK^0?ofkP3D?AT:0?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI
0?ofkP3om^h0D@3om^h00`000000ooK^0?ofkP140?ofkP40oooo001P0?ofkP030000003om^h0ooK^
00/0ooK^100mFJ/50?ofkPP0?EV[7@3om^h00`000000ooK^0?ofkP0j0?ofkP<0e3dI00<0ooK^0=@m
6@3D?AT01`3om^h00`3D?AT0ooK^0=@m6@020=@m6@H0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D
?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00<0ooK^0`3D?AT80?ofkP030=@m6@3om^h0ooK^
00h0ooK^00<0e3dI0?ofkP3om^h03@3om^h20=@m6@/0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D
?AT0ooK^0?ofkP1A0?ofkP030000003om^h0ooK^04@0ooK^0@3oool00640ooK^00<000000?ofkP3o
m^h03P3om^h703eIZb80ooK^00<000000?ofkP3om^h0>`3om^h20=@m6@030?ofkP3D?AT0e3dI0080
e3dI1`3om^h0103D?AT0ooK^0?ofkP3om^h40=@m6@<0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D
?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0e3dI0080e3dI303om^h00`3D?AT0ooK^0?ofkP0;0?of
kP<0e3dI3`3om^h00`3D?AT0ooK^0?ofkP090?ofkP80e3dI1`3om^h00`3D?AT0ooK^0?ofkP1B0?of
kP030000003om^h0ooK^04@0ooK^0@3oool00640ooK^00<000000?ofkP3om^h0=`3om^h00`000000
ooK^0?ofkP0l0?ofkP060=@m6@3om^h0e3dI0=@m6@3om^h0e3dI1`3om^h00`3D?AT0ooK^0?ofkP05
0?ofkP@0e3dI3P3om^h00`3D?AT0ooK^0?ofkP0:0?ofkPD0e3dI3`3om^h00`3D?AT0ooK^0?ofkP09
0?ofkP80e3dI0`3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP80e3dI2P3om^h0103D?AT0ooK^0?ofkP3D
?AT50?ofkP030=@m6@3om^h0ooK^05<0ooK^00<000000?ofkP3om^h0A03om^h10?ooo`00HP3om^h0
0`000000ooK^0?ofkP0f0?ofkP030000003om^h0ooK^03`0ooK^0P3D?AT01@3om^h0e3dI0?ofkP3o
m^h0e3dI00L0ooK^00<0e3dI0?ofkP3om^h01`3om^h90=@m6@L0ooK^00@0e3dI0?ofkP3om^h0ooK^
203D?AT30?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h01P3om^h20=@m6@D0ooK^
00<0e3dI0?ofkP3om^h02@3om^h20=@m6@80ooK^00<0e3dI0?ofkP3om^h01`3om^h0103D?AT0ooK^
0?ofkP3D?AT50?ofkP030=@m6@3om^h0ooK^05<0ooK^0P0000150?ofkP40oooo001S0?ofkP030000
003om^h0ooK^03D0ooK^00<000000?ofkP3om^h0?@3om^h00`3D?AT0ooK^0=@m6@030?ofkP80e3dI
1@3om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^00@0ooK^2`3D?AT<0?ofkP030=@m
6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h0103om^h20=@m6@P0ooK^00<0e3dI0?ofkP3om^h0
1`3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00H0ooK^00D0e3dI0?ofkP3om^h0
ooK^0=@m6@040?ofkP030=@m6@3om^h0ooK^05@0ooK^0P0000150?ofkP40oooo001T0?ofkP030000
003om^h0ooK^03@0ooK^00<000000?ofkP3om^h0?P3om^h00`3D?AT0ooK^0=@m6@020?ofkP030=@m
6@3om^h0e3dI00D0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m
6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h03`3om^h0103D?AT0ooK^0?ofkP3om^h20=@m6@X0
ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00@0
ooK^00<0e3dI0?ofkP3om^h00`3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI05L0ooK^00<000000?of
kP3om^h0@`3om^h10?ooo`00I@3om^h00`000000ooK^0?ofkP0c0?ofkP030000003om^h0ooK^03h0
ooK^0`3D?AT30?ofkP040=@m6@3om^h0e3dI0=@m6@<0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D
?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h03P3om^h0103D
?AT0ooK^0=@m6@3D?AT=0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h01@3om^h0
0`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00@0ooK^00@0e3dI0?ofkP3om^h0e3dIF03o
m^h00`000000ooK^0?ofkP130?ofkP40oooo001V0?ofkP030000003om^h0ooK^0380ooK^00<00000
0?ofkP3om^h0?`3om^h30=@m6@80ooK^00@0e3dI0?ofkP3om^h0ooK^0P3D?AT20?ofkP030=@m6@3o
m^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3o
m^h0ooK^00h0ooK^0P3D?AT?0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h01P3o
m^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3D?AT0F@3o
m^h00`000000ooK^0?ofkP130?ofkP40oooo001V0?ofkP030000003om^h0ooK^0380ooK^00<00000
0?ofkP3om^h0@03om^h30=@m6@80ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0=@m6@0;
0?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0:
0?ofkP<0e3dI00<0ooK^0=@m6@3om^h03`3om^h00`3D?AT0ooK^0?ofkP020=@m6@X0ooK^00@0e3dI
0?ofkP3om^h0e3dI2@3om^h20=@m6ET0ooK^00<000000?ofkP3om^h0@`3om^h10?ooo`00I`3om^h0
0`000000ooK^0?ofkP0a0?ofkP030000003om^h0ooK^0400ooK^0P3D?AT01@3om^h0e3dI0?ofkP3o
m^h0e3dI00@0ooK^0`3D?AT;0?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h03@3o
m^h00`3D?AT0ooK^0?ofkP070?ofkP<0e3dI1@3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3o
m^h0e3dI00`0ooK^00@0e3dI0?ofkP3om^h0e3dI2@3om^h00`3D?AT0ooK^0?ofkP1H0?ofkP800000
A03om^h10?ooo`00J03om^h00`000000ooK^0?ofkP0`0?ofkP030000003om^h0ooK^0440ooK^0P3D
?AT0103om^h0e3dI0?ofkP3D?AT60?ofkP<0e3dI2@3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m
6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h00`3om^h30=@m6@P0ooK^00<0e3dI0?ofkP3om^h0
3P3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP80e3dI2@3om^h00`3D?AT0ooK^0?ofkP1I0?ofkP800000
A03om^h10?ooo`00J@3om^h00`000000ooK^0?ofkP0_0?ofkP030000003om^h0ooK^0480ooK^00<0
e3dI0?ofkP3om^h00`3D?AT60?ofkP030=@m6@3om^h0e3dI00<0e3dI1P3om^h00`3D?AT0ooK^0?of
kP0:0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h00`3D?AT<0?ofkP030=@m6@3o
m^h0ooK^00/0ooK^0`3D?AT>0?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h0F`3o
m^h00`000000ooK^0?ofkP120?ofkP40oooo001Z0?ofkP030000003om^h0ooK^02h0ooK^00<00000
0?ofkP3om^h0@P3om^h20=@m6@<0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP03
0?ofkPD0e3dI00<0ooK^0=@m6@3om^h0303om^h00`3D?AT0ooK^0?ofkP0:0?ofkPD0e3dI3`3om^h0
0`3D?AT0ooK^0?ofkP090?ofkP80e3dI0`3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP80e3dI2@3om^h0
0`3D?AT0ooK^0?ofkP1K0?ofkP030000003om^h0ooK^0480ooK^0@3oool006/0ooK^00<000000?of
kP3om^h0;03om^h00`000000ooK^0?ofkP140?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?of
kP3om^h0103om^h00`3D?AT0ooK^0?ofkP070?ofkPT0e3dI1P3om^h00`3D?AT0ooK^0?ofkP020?of
kPP0e3dI0`3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00L0ooK^0P3D?AT50?of
kP030=@m6@3om^h0ooK^00P0ooK^0P3D?AT20?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?of
kP3om^h0G03om^h00`000000ooK^0?ofkP120?ofkP40oooo001[0?ofkP030000003om^h0ooK^02`0
ooK^00<000000?ofkP3om^h0A@3om^h00`3D?AT0ooK^0?ofkP020?ofkP80e3dI1@3om^h00`3D?AT0
ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00@0ooK^2`3D?AT<0?ofkP030=@m6@3om^h0ooK^00h0
ooK^00<0e3dI0?ofkP3om^h0103om^h20=@m6@P0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0
ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h0G@3om^h00`000000
ooK^0?ofkP120?ofkP40oooo001/0?ofkP030000003om^h0ooK^02/0ooK^00<000000?ofkP3om^h0
A@3om^h20=@m6@<0ooK^00@0e3dI0?ofkP3D?AT0e3dI0`3om^h00`3D?AT0ooK^0?ofkP090?ofkP03
0=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP03
0=@m6@3om^h0ooK^0080ooK^0P3D?AT:0?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3o
m^h00`3om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^05h0ooK^0P0000130?ofkP40
oooo001]0?ofkP030000003om^h0ooK^02X0ooK^00<000000?ofkP3om^h0AP3om^h20=@m6@<0ooK^
00<0e3dI0?ofkP3om^h00P3D?AT20?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h0
2`3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00h0ooK^00@0e3dI0?ofkP3D?AT0
e3dI303om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00D0ooK^00D0e3dI0?ofkP3o
m^h0ooK^0=@m6@1Q0?ofkP800000@`3om^h10?ooo`00KP3om^h00`000000ooK^0?ofkP0Y0?ofkP03
0000003om^h0ooK^04H0ooK^0`3D?AT20?ofkP030=@m6@3om^h0ooK^0080ooK^0P3D?AT00`3om^h0
e3dI0?ofkP090?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0
ooK^0?ofkP0=0?ofkP<0e3dI3`3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00H0
ooK^00@0e3dI0?ofkP3om^h0e3dIH`3om^h00`000000ooK^0?ofkP110?ofkP40oooo001_0?ofkP03
0000003om^h0ooK^02P0ooK^00<000000?ofkP3om^h0A`3om^h01P3D?AT0ooK^0=@m6@3D?AT0ooK^
0=@m6@D0ooK^0P3D?AT:0?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h03@3om^h0
0`3D?AT0ooK^0?ofkP090?ofkP<0e3dI00<0ooK^0=@m6@3om^h03`3om^h00`3D?AT0ooK^0?ofkP02
0=@m6@T0ooK^00@0e3dI0?ofkP3om^h0e3dIH`3om^h00`000000ooK^0?ofkP110?ofkP40oooo001`
0?ofkP030000003om^h0ooK^02L0ooK^00<000000?ofkP3om^h0B03om^h00`3D?AT0ooK^0?ofkP02
0=@m6@L0ooK^0P3D?AT90?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h03@3om^h0
0`3D?AT0ooK^0?ofkP070?ofkP80e3dI1@3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP80e3dI303om^h2
0=@m6F@0ooK^00<000000?ofkP3om^h0@@3om^h10?ooo`00L03om^h00`000000ooK^0?ofkP0W0?of
kP030000003om^h0ooK^04P0ooK^00@0e3dI0?ofkP3om^h0ooK^0P3D?AT60?ofkP030=@m6@3om^h0
e3dI0080e3dI1P3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI
0?ofkP3om^h00`3om^h30=@m6@L0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0;
0?ofkP030=@m6@3om^h0ooK^06<0ooK^00<000000?ofkP3om^h0@@3om^h10?ooo`00L@3om^h00`00
0000ooK^0?ofkP0V0?ofkP030000003om^h0ooK^04T0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@07
0?ofkP040=@m6@3om^h0ooK^0?ofkP@0e3dI0`3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3o
m^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h00`3D?AT;0?ofkP030=@m6@3om^h0ooK^00/0ooK^0`3D
?AT<0?ofkP030=@m6@3om^h0ooK^06@0ooK^00<000000?ofkP3om^h0@@3om^h10?ooo`00LP3om^h0
0`000000ooK^0?ofkP0U0?ofkP030000003om^h0ooK^04T0ooK^00<0e3dI0?ofkP3om^h00P3om^h0
0`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00D0ooK^103D?AT=0?ofkP030=@m6@3om^h0
ooK^00X0ooK^1@3D?AT>0?ofkP030=@m6@3om^h0ooK^00T0ooK^0P3D?AT30?ofkP030=@m6@3om^h0
ooK^00L0ooK^0P3D?AUW0?ofkP800000@P3om^h10?ooo`00L`3om^h00`000000ooK^0?ofkP0T0?of
kP030000003om^h0ooK^04X0ooK^00<0e3dI0?ofkP3om^h00P3om^h20=@m6@D0ooK^00<0e3dI0?of
kP3om^h01`3om^h80=@m6@H0ooK^00<0e3dI0?ofkP3om^h00P3om^h80=@m6@@0ooK^00<0e3dI0?of
kP3om^h03@3om^h00`3D?AT0ooK^0?ofkP060?ofkP80e3dI1@3om^h00`3D?AT0ooK^0?ofkP060?of
kP030=@m6@3om^h0ooK^06P0ooK^00<000000?ofkP3om^h0@03om^h10?ooo`00M03om^h00`000000
ooK^0?ofkP0S0?ofkP030000003om^h0ooK^04/0ooK^00L0e3dI0?ofkP3om^h0ooK^0=@m6@3om^h0
e3dI00@0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP030?ofkP/0e3dI303om^h0
0`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00@0ooK^0P3D?AT70?ofkP030=@m6@3om^h0
ooK^00D0ooK^00<0e3dI0?ofkP3om^h0J@3om^h00`000000ooK^0?ofkP100?ofkP40oooo001e0?of
kP030000003om^h0ooK^0240ooK^00<000000?ofkP3om^h0C@3om^h01P3D?AT0ooK^0?ofkP3om^h0
e3dI0?ofkP80e3dI0`3om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0
e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP040=@m6@3om^h0ooK^0?ofkP80e3dI
2P3om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^06X0ooK^00<000000?ofkP3om^h0
@03om^h10?ooo`00M@3om^h00`000000ooK^0?ofkP0Q0?ofkP030000003om^h0ooK^04h0ooK^00@0
e3dI0?ofkP3om^h0e3dI0`3om^h20=@m6@030?ofkP3D?AT0ooK^00X0ooK^00<0e3dI0?ofkP3om^h0
2P3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00d0ooK^00@0e3dI0?ofkP3D?AT0
e3dI303om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^06/0ooK^00<000000?ofkP3o
m^h0@03om^h10?ooo`00MP3om^h00`000000ooK^0?ofkP0P0?ofkP030000003om^h0ooK^04l0ooK^
0P3D?AT00`3om^h0e3dI0?ofkP030?ofkP030=@m6@3om^h0e3dI00X0ooK^00<0e3dI0?ofkP3om^h0
2`3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00`0ooK^0P3D?AT>0?ofkP030=@m
6@3om^h0ooK^0080e3dIKP3om^h00`000000ooK^0?ofkP100?ofkP40oooo001g0?ofkP030000003o
m^h0ooK^01l0ooK^00<000000?ofkP3om^h0D@3om^h20=@m6@D0ooK^0P3D?AT;0?ofkP030=@m6@3o
m^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP080?ofkP@0e3dI00<0
ooK^0=@m6@3om^h03P3om^h20=@m6G00ooK^0P0000110?ofkP40oooo001h0?ofkP030000003om^h0
ooK^01h0ooK^00<000000?ofkP3om^h0DP3om^h20=@m6@H0ooK^0`3D?AT80?ofkP030=@m6@3om^h0
ooK^00/0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP040?ofkP<0e3dI1P3om^h0
0`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^0700ooK^00<000000?ofkP3om^h0?`3om^h1
0?ooo`00N@3om^h00`000000ooK^0?ofkP0M0?ofkP030000003om^h0ooK^05<0ooK^00<0e3dI0?of
kP3om^h01@3om^h00`3D?AT0ooK^0=@m6@030=@m6@D0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D
?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00@0e3dI2@3om^h00`3D?AT0ooK^0?ofkP0:0?of
kP80e3dIL`3om^h00`000000ooK^0?ofkP0o0?ofkP40oooo001j0?ofkP030000003om^h0ooK^01`0
ooK^00<000000?ofkP3om^h0E03om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00<0
ooK^103D?AT00`3om^h0e3dI0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00X0ooK^1@3D?AT>0?ofkP03
0=@m6@3om^h0ooK^00L0ooK^0P3D?AUa0?ofkPD00000@@3om^h10?ooo`00NP3om^h00`000000ooK^
0?ofkP0L0?ofkP030000003om^h0ooK^05D0ooK^0P3D?AT50?ofkP030=@m6@3om^h0ooK^00H0ooK^
2@3D?AT60?ofkP030=@m6@3om^h0ooK^0080ooK^203D?AT30?ofkP030=@m6@3om^h0ooK^00d0ooK^
00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP1Y0?ofkPP00000AP3om^h10?ooo`00N`3o
m^h00`000000ooK^0?ofkP0K0?ofkP030000003om^h0ooK^05L0ooK^0P3D?AT30?ofkP030=@m6@3o
m^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h00`3om^h;0=@m6@`0ooK^00<0e3dI0?ofkP3om^h03@3o
m^h00`3D?AT0ooK^0?ofkP030?ofkP80e3dII03om^h8000004h0ooK^0@3oool007`0ooK^00<00000
0?ofkP3om^h06P3om^h00`000000ooK^0?ofkP1I0?ofkP80e3dI0P3om^h00`3D?AT0ooK^0?ofkP08
0?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP0=
0?ofkP040=@m6@3om^h0ooK^0?ofkP80e3dIG@3om^h9000005H0ooK^0@3oool007d0ooK^00<00000
0?ofkP3om^h06@3om^h00`000000ooK^0?ofkP1K0?ofkP80e3dI00<0ooK^0=@m6@3om^h02@3om^h0
0`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h03@3om^h3
0=@m6EL0ooK^2000001O0?ofkP40oooo001n0?ofkP030000003om^h0ooK^01L0ooK^00<000000?of
kP3om^h0GP3om^h20=@m6@X0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP0<0?of
kP030=@m6@3om^h0ooK^00`0ooK^0P3D?AUA0?ofkPP00000I`3om^h10?ooo`00O`3om^h00`000000
ooK^0?ofkP0F0?ofkP030000003om^h0ooK^0600ooK^0P3D?AT90?ofkP030=@m6@3om^h0ooK^00X0
ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP070?ofkP@0e3dIBP3om^h9000006l0
ooK^0@3oool007l0ooK^00<000000?ofkP3om^h05P3om^h00`000000ooK^0?ofkP1R0?ofkP<0e3dI
1P3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h0
103om^h30=@m6DH0ooK^2000001h0?ofkP40oooo00200?ofkP030000003om^h0ooK^01D0ooK^00<0
00000?ofkP3om^h0I@3om^h40=@m6@<0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?of
kP0=0?ofkP030=@m6@3om^h0e3dI00<0e3dI@@3om^h800000800ooK^0@3oool00840ooK^00<00000
0?ofkP3om^h0503om^h00`000000ooK^0?ofkP1Y0?ofkP@0e3dI3@3om^h00`3D?AT0ooK^0?ofkP09
0?ofkPD0e3dI?03om^h9000008P0ooK^0@3oool00880ooK^00<000000?ofkP3om^h04`3om^h00`00
0000ooK^0?ofkP1/0?ofkPP0e3dI1P3om^h00`3D?AT0ooK^0?ofkP020?ofkPL0e3dI>@3om^h80000
0940ooK^0@3oool008<0ooK^00<000000?ofkP3om^h04P3om^h00`000000ooK^0?ofkP1d0?ofkP/0
e3dI>03om^h8000009T0ooK^0@3oool008@0ooK^00<000000?ofkP3om^h04@3om^h00`000000ooK^
0?ofkP2^0?ofkPT00000X@3om^h10?ooo`00Q03om^h00`000000ooK^0?ofkP0A0?ofkP030000003o
m^h0ooK^0:H0ooK^2000002Z0?ofkP40oooo00250?ofkP030000003om^h0ooK^0100ooK^00<00000
0?ofkP3om^h0WP3om^h800000;80ooK^0@3oool008H0ooK^00<000000?ofkP3om^h03`3om^h00`00
0000ooK^0?ofkP2E0?ofkPT00000^P3om^h10?ooo`00Q`3om^h00`000000ooK^0?ofkP0>0?ofkP03
0000003om^h0ooK^08d0ooK^200000330?ofkP40oooo00280?ofkP030000003om^h0ooK^00`0ooK^
00<000000?ofkP3om^h0QP3om^h800000</0ooK^0@3oool008T0ooK^00<000000?ofkP3om^h02`3o
m^h00`000000ooK^0?ofkP1n0?ofkPP00000d`3om^h10?ooo`00R@3om^h00`000000ooK^0?ofkP0;
0?ofkP030000003om^h0ooK^07D0ooK^2@00003K0?ofkP40oooo002:0?ofkP030000003om^h0ooK^
00X0ooK^00<000000?ofkP3om^h0K@3om^h800000>@0ooK^0@3oool008/0ooK^00<000000?ofkP3o
m^h02@3om^h00`000000ooK^0?ofkP1U0?ofkPP00000k03om^h10?ooo`00S03om^h00`000000ooK^
0?ofkP080?ofkP030000003om^h0ooK^05`0ooK^2@00003d0?ofkP40oooo002=0?ofkP030000003o
m^h0ooK^00L0ooK^00<000000?ofkP3om^h0E03om^h800000?d0ooK^0@3oool008h0ooK^00<00000
0?ofkP3om^h01P3om^h00`000000ooK^0?ofkP1<0?ofkPP00000o`3om^h60?ofkP40oooo002>0?of
kP030000003om^h0ooK^00H0ooK^00<000000?ofkP3om^h0@`3om^h900000?l0ooK^3P3om^h10?oo
o`00S`3om^h00`000000ooK^0?ofkP050?ofkP030000003om^h0ooK^03/0ooK^2000003o0?ofkQL0
ooK^0@3oool00900ooK^00<000000?ofkP3om^h0103om^h00`000000ooK^0?ofkP0c0?ofkPP00000
o`3om^hO0?ofkP40oooo002A0?ofkP030000003om^h0ooK^00<0ooK^00<000000?ofkP3om^h0:P3o
m^h900000?l0ooK^9`3om^h10?ooo`00TP3om^h01@000000ooK^0?ofkP3om^h0000002D0ooK^2000
003o0?ofkS00ooK^0@3oool009<0ooK^00@000000?ofkP3om^h000007@3om^h800000?l0ooK^>03o
m^h10?ooo`00T`3om^h010000000ooK^0?ofkP00000D0?ofkPT00000o`3om^i00?ofkP40oooo002D
0?ofkP030000003om^h0000000`0ooK^2000003o0?ofkTT0ooK^0@3oool009D0ooK^0P0000040?of
kPP00000o`3om^iA0?ofkP40oooo002F0?ofkPD00000o`3om^iI0?ofkP40oooo003o0?ofk_@0ooK^
0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0
ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h1
0?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3o
m^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40
oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?of
k_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3o
ool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^
m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?oo
o`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd
0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo
003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0
ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool0
0?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03o
m^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00
o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?of
kP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o
0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^
0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0
ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h1
0?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3o
m^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40
oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?of
k_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3o
ool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^
m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?oo
o`00o`3om^kd0?ofkP40oooo0000\
\>"],
  ImageRangeCache->{{{0, 499}, {499, 0}} -> {-5.00005*^-06, -5.00005*^-06, \
0.00200403, 0.00200403}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
%%ImageSize: 500 500 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics3D
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Background color
1 .961 .933 r
MFill
% Scaling calculations
0 1 0 1 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 0 r
.25 Mabswid
[ ] 0 setdash
.76019 .55099 m
.78887 .79004 L
s
.78887 .79004 m
.90748 .42015 L
s
.90748 .42015 m
.85264 .14594 L
s
.85264 .14594 m
.76019 .55099 L
s
.23981 .55099 m
.14736 .14594 L
s
.14736 .14594 m
.09252 .42015 L
s
.09252 .42015 m
.21113 .79004 L
s
.21113 .79004 m
.23981 .55099 L
s
.76019 .55099 m
.78887 .79004 L
s
.78887 .79004 m
.21113 .79004 L
s
.21113 .79004 m
.23981 .55099 L
s
.23981 .55099 m
.76019 .55099 L
s
.85264 .14594 m
.14736 .14594 L
s
.14736 .14594 m
.09252 .42015 L
s
.09252 .42015 m
.90748 .42015 L
s
.90748 .42015 m
.85264 .14594 L
s
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
.83 .24 .1 r
.5 Mabswid
.46127 .55504 m
.48693 .55057 L
s
.48693 .55057 m
.48669 .52967 L
s
.48693 .55057 m
.51307 .55057 L
s
.51307 .55057 m
.51331 .52967 L
s
.51307 .55057 m
.53873 .55504 L
s
.43708 .56382 m
.46127 .55504 L
s
.46127 .55504 m
.46056 .53417 L
s
.53873 .55504 m
.53944 .53417 L
s
.53873 .55504 m
.56292 .56382 L
s
.41531 .57664 m
.43708 .56382 L
s
.43708 .56382 m
.43592 .54303 L
s
.56292 .56382 m
.56408 .54303 L
s
.56292 .56382 m
.58469 .57664 L
s
.39684 .59306 m
.41531 .57664 L
s
.41531 .57664 m
.41374 .55596 L
s
.58469 .57664 m
.58626 .55596 L
s
.58469 .57664 m
.60316 .59306 L
s
.46056 .53417 m
.48669 .52967 L
s
.48669 .52967 m
.48644 .50798 L
s
.48669 .52967 m
.51331 .52967 L
s
.51331 .52967 m
.51356 .50798 L
s
.51331 .52967 m
.53944 .53417 L
s
.38248 .61251 m
.39684 .59306 L
s
.39684 .59306 m
.39491 .57253 L
s
.60316 .59306 m
.60509 .57253 L
s
.60316 .59306 m
.61752 .61251 L
s
.43592 .54303 m
.46056 .53417 L
s
.46056 .53417 m
.45982 .51252 L
s
.53944 .53417 m
.54018 .51252 L
s
.53944 .53417 m
.56408 .54303 L
s
.41374 .55596 m
.43592 .54303 L
s
.43592 .54303 m
.43472 .52145 L
s
.56408 .54303 m
.56528 .52145 L
s
.56408 .54303 m
.58626 .55596 L
s
.37294 .63427 m
.38248 .61251 L
s
.38248 .61251 m
.38026 .59216 L
s
.61752 .61251 m
.61974 .59216 L
s
.61752 .61251 m
.62706 .63427 L
s
.39491 .57253 m
.41374 .55596 L
s
.41374 .55596 m
.41211 .5345 L
s
.58626 .55596 m
.58789 .5345 L
s
.58626 .55596 m
.60509 .57253 L
s
.45982 .51252 m
.48644 .50798 L
s
.48644 .50798 m
.48618 .48547 L
s
.48644 .50798 m
.51356 .50798 L
s
.51356 .50798 m
.51382 .48547 L
s
.51356 .50798 m
.54018 .51252 L
s
.62706 .63427 m
.62948 .61413 L
s
.62706 .63427 m
.63123 .65748 L
s
.36877 .65748 m
.37294 .63427 L
s
.37294 .63427 m
.37052 .61413 L
s
.38026 .59216 m
.39491 .57253 L
s
.39491 .57253 m
.3929 .55122 L
s
.60509 .57253 m
.6071 .55122 L
s
.60509 .57253 m
.61974 .59216 L
s
.43472 .52145 m
.45982 .51252 L
s
.45982 .51252 m
.45906 .49005 L
s
.54018 .51252 m
.54094 .49005 L
s
.54018 .51252 m
.56528 .52145 L
s
.41211 .5345 m
.43472 .52145 L
s
.43472 .52145 m
.43347 .49905 L
s
.56528 .52145 m
.56653 .49905 L
s
.56528 .52145 m
.58789 .5345 L
s
.37052 .61413 m
.38026 .59216 L
s
.38026 .59216 m
.37796 .57104 L
s
.61974 .59216 m
.62204 .57104 L
s
.61974 .59216 m
.62948 .61413 L
s
.36624 .63758 m
.36877 .65748 L
s
.3703 .68118 m
.36877 .65748 L
s
.63123 .65748 m
.63376 .63758 L
s
.63123 .65748 m
.6297 .68118 L
s
.3929 .55122 m
.41211 .5345 L
s
.41211 .5345 m
.41041 .51221 L
s
.58789 .5345 m
.58959 .51221 L
s
.58789 .5345 m
.6071 .55122 L
s
.48618 .48547 m
.51382 .48547 L
s
.51382 .48547 m
.51409 .46208 L
s
.51382 .48547 m
.54094 .49005 L
s
.45906 .49005 m
.48618 .48547 L
s
.48618 .48547 m
.48591 .46208 L
s
.36624 .63758 m
.37052 .61413 L
s
.37052 .61413 m
.36801 .59322 L
s
.62948 .61413 m
.63199 .59322 L
s
.62948 .61413 m
.63376 .63758 L
s
.37796 .57104 m
.3929 .55122 L
s
.3929 .55122 m
.39082 .52908 L
s
.6071 .55122 m
.60918 .52908 L
s
.6071 .55122 m
.62204 .57104 L
s
.43347 .49905 m
.45906 .49005 L
s
.45906 .49005 m
.45826 .4667 L
s
.54094 .49005 m
.54174 .4667 L
s
.54094 .49005 m
.56653 .49905 L
s
.37764 .7043 m
.3703 .68118 L
s
.3703 .68118 m
.36777 .66153 L
s
.6297 .68118 m
.63223 .66153 L
s
.6297 .68118 m
.62236 .7043 L
s
.41041 .51221 m
.43347 .49905 L
s
.43347 .49905 m
.43217 .47578 L
s
.56653 .49905 m
.56783 .47578 L
s
.56653 .49905 m
.58959 .51221 L
s
.36801 .59322 m
.37796 .57104 L
s
.37796 .57104 m
.37557 .54908 L
s
.62204 .57104 m
.62443 .54908 L
s
.62204 .57104 m
.63199 .59322 L
s
.36361 .6169 m
.36624 .63758 L
s
.36777 .66153 m
.36624 .63758 L
s
.63376 .63758 m
.63639 .6169 L
s
.63376 .63758 m
.63223 .66153 L
s
.39082 .52908 m
.41041 .51221 L
s
.41041 .51221 m
.40865 .48905 L
s
.58959 .51221 m
.59135 .48905 L
s
.58959 .51221 m
.60918 .52908 L
s
.39064 .72577 m
.37764 .7043 L
s
.37764 .7043 m
.37524 .68491 L
s
.62236 .7043 m
.62476 .68491 L
s
.62236 .7043 m
.60936 .72577 L
s
.45826 .4667 m
.48591 .46208 L
s
.48591 .46208 m
.48563 .43777 L
s
.48591 .46208 m
.51409 .46208 L
s
.51409 .46208 m
.51437 .43777 L
s
.51409 .46208 m
.54174 .4667 L
s
.36361 .6169 m
.36801 .59322 L
s
.36801 .59322 m
.36539 .57147 L
s
.63199 .59322 m
.63461 .57147 L
s
.63199 .59322 m
.63639 .6169 L
s
.37557 .54908 m
.39082 .52908 L
s
.39082 .52908 m
.38866 .50606 L
s
.60918 .52908 m
.61134 .50606 L
s
.60918 .52908 m
.62443 .54908 L
s
.43217 .47578 m
.45826 .4667 L
s
.45826 .4667 m
.45743 .44242 L
s
.54174 .4667 m
.54257 .44242 L
s
.54174 .4667 m
.56783 .47578 L
s
.40883 .74451 m
.39064 .72577 L
s
.39064 .72577 m
.38847 .70662 L
s
.60936 .72577 m
.61153 .70662 L
s
.60936 .72577 m
.59117 .74451 L
s
.37524 .68491 m
.36777 .66153 L
s
.36777 .66153 m
.36515 .6411 L
s
.63223 .66153 m
.63485 .6411 L
s
.63223 .66153 m
.62476 .68491 L
s
.40865 .48905 m
.43217 .47578 L
s
.56783 .47578 m
.59135 .48905 L
s
.36539 .57147 m
.37557 .54908 L
s
.62443 .54908 m
.63461 .57147 L
s
.59117 .74451 m
.593 .72558 L
s
.59117 .74451 m
.56856 .75955 L
s
.43144 .75955 m
.40883 .74451 L
s
.40883 .74451 m
.407 .72558 L
s
.36088 .5954 m
.36361 .6169 L
s
.36515 .6411 m
.36361 .6169 L
s
.63639 .6169 m
.63912 .5954 L
s
.63639 .6169 m
.63485 .6411 L
s
.38866 .50606 m
.40865 .48905 L
s
.59135 .48905 m
.61134 .50606 L
s
.38847 .70662 m
.37524 .68491 L
s
.37524 .68491 m
.37274 .66473 L
s
.62476 .68491 m
.62726 .66473 L
s
.62476 .68491 m
.61153 .70662 L
s
.56856 .75955 m
.56994 .74079 L
s
.56856 .75955 m
.54256 .77007 L
s
.45744 .77007 m
.43144 .75955 L
s
.43144 .75955 m
.43006 .74079 L
s
.45743 .44242 m
.48563 .43777 L
s
.48563 .43777 m
.51437 .43777 L
s
.51437 .43777 m
.54257 .44242 L
s
.63461 .57147 m
.63912 .5954 L
s
.36088 .5954 m
.36539 .57147 L
s
.54256 .77007 m
.54342 .75144 L
s
.54256 .77007 m
.51443 .77548 L
s
.48557 .77548 m
.45744 .77007 L
s
.45744 .77007 m
.45658 .75144 L
s
.43082 .45158 m
.45743 .44242 L
s
.54257 .44242 m
.56918 .45158 L
s
.407 .72558 m
.38847 .70662 L
s
.38847 .70662 m
.38621 .68669 L
s
.61153 .70662 m
.61379 .68669 L
s
.61153 .70662 m
.593 .72558 L
s
.37274 .66473 m
.36515 .6411 L
s
.36515 .6411 m
.36242 .61984 L
s
.63485 .6411 m
.63758 .61984 L
s
.63485 .6411 m
.62726 .66473 L
s
1 .33 .134 r
.37455 .51338 m .37567 .52392 L .38726 .50212 L p F P
0 0 0 r
s
1 .33 .134 r
.38726 .50212 m .38634 .49239 L .37455 .51338 L p F P
0 0 0 r
s
1 .334 .136 r
.38634 .49239 m .38726 .50212 L .40138 .48028 L p F P
0 0 0 r
s
.258 .369 .723 r
.59862 .48028 m .58454 .48028 L .59663 .50212 L p F P
0 0 0 r
s
.258 .369 .723 r
.59663 .50212 m .61274 .50212 L .59862 .48028 L p F P
0 0 0 r
s
.83 .24 .1 r
.61134 .50606 m
.61161 .50319 L
s
.258 .369 .723 r
.58454 .48028 m .57045 .48028 L .58053 .50212 L p F P
0 0 0 r
s
.258 .369 .723 r
.58053 .50212 m .59663 .50212 L .58454 .48028 L p F P
0 0 0 r
s
.258 .369 .723 r
.57045 .48028 m .55636 .48028 L .56442 .50212 L p F P
0 0 0 r
s
.258 .369 .723 r
.56442 .50212 m .58053 .50212 L .57045 .48028 L p F P
0 0 0 r
s
.258 .369 .723 r
.55636 .48028 m .54227 .48028 L .54832 .50212 L p F P
0 0 0 r
s
.258 .369 .723 r
.54832 .50212 m .56442 .50212 L .55636 .48028 L p F P
0 0 0 r
s
.258 .369 .723 r
.54227 .48028 m .52818 .48028 L .53221 .50212 L p F P
0 0 0 r
s
.258 .369 .723 r
.53221 .50212 m .54832 .50212 L .54227 .48028 L p F P
0 0 0 r
s
.258 .369 .723 r
.52818 .48028 m .51409 .48028 L .51611 .50212 L p F P
0 0 0 r
s
.258 .369 .723 r
.51611 .50212 m .53221 .50212 L .52818 .48028 L p F P
0 0 0 r
s
.258 .369 .723 r
.51409 .48028 m .5 .48028 L .5 .50212 L p F P
0 0 0 r
s
.258 .369 .723 r
.5 .50212 m .51611 .50212 L .51409 .48028 L p F P
0 0 0 r
s
.258 .369 .723 r
.5 .48028 m .48591 .48028 L .48389 .50212 L p F P
0 0 0 r
s
.258 .369 .723 r
.48389 .50212 m .5 .50212 L .5 .48028 L p F P
0 0 0 r
s
.258 .369 .723 r
.48591 .48028 m .47182 .48028 L .46779 .50212 L p F P
0 0 0 r
s
.258 .369 .723 r
.46779 .50212 m .48389 .50212 L .48591 .48028 L p F P
0 0 0 r
s
.258 .369 .723 r
.47182 .48028 m .45773 .48028 L .45168 .50212 L p F P
0 0 0 r
s
.258 .369 .723 r
.45168 .50212 m .46779 .50212 L .47182 .48028 L p F P
0 0 0 r
s
.258 .369 .723 r
.45773 .48028 m .44364 .48028 L .43558 .50212 L p F P
0 0 0 r
s
.258 .369 .723 r
.43558 .50212 m .45168 .50212 L .45773 .48028 L p F P
0 0 0 r
s
.258 .369 .723 r
.44364 .48028 m .42955 .48028 L .41947 .50212 L p F P
0 0 0 r
s
.258 .369 .723 r
.41947 .50212 m .43558 .50212 L .44364 .48028 L p F P
0 0 0 r
s
.258 .369 .723 r
.42955 .48028 m .41546 .48028 L .40337 .50212 L p F P
0 0 0 r
s
.258 .369 .723 r
.40337 .50212 m .41947 .50212 L .42955 .48028 L p F P
0 0 0 r
s
.258 .369 .723 r
.41546 .48028 m .40138 .48028 L .38726 .50212 L p F P
0 0 0 r
s
.83 .24 .1 r
.4084 .48575 m
.40865 .48905 L
s
.38839 .50319 m
.38866 .50606 L
s
.258 .369 .723 r
.38726 .50212 m .40337 .50212 L .41546 .48028 L p F P
0 0 0 r
s
.251 .356 .697 r
.61274 .50212 m .59663 .50212 L .60657 .52392 L p F P
0 0 0 r
s
.251 .356 .697 r
.60657 .52392 m .62433 .52392 L .61274 .50212 L p F P
0 0 0 r
s
.251 .356 .697 r
.59663 .50212 m .58053 .50212 L .5888 .52392 L p F P
0 0 0 r
s
.251 .356 .697 r
.5888 .52392 m .60657 .52392 L .59663 .50212 L p F P
0 0 0 r
s
.251 .356 .697 r
.58053 .50212 m .56442 .50212 L .57104 .52392 L p F P
0 0 0 r
s
.251 .356 .697 r
.57104 .52392 m .5888 .52392 L .58053 .50212 L p F P
0 0 0 r
s
.251 .356 .697 r
.56442 .50212 m .54832 .50212 L .55328 .52392 L p F P
0 0 0 r
s
.251 .356 .697 r
.55328 .52392 m .57104 .52392 L .56442 .50212 L p F P
0 0 0 r
s
.251 .356 .697 r
.54832 .50212 m .53221 .50212 L .53552 .52392 L p F P
0 0 0 r
s
.251 .356 .697 r
.53552 .52392 m .55328 .52392 L .54832 .50212 L p F P
0 0 0 r
s
.251 .356 .697 r
.53221 .50212 m .51611 .50212 L .51776 .52392 L p F P
0 0 0 r
s
.251 .356 .697 r
.51776 .52392 m .53552 .52392 L .53221 .50212 L p F P
0 0 0 r
s
.251 .356 .697 r
.51611 .50212 m .5 .50212 L .5 .52392 L p F P
0 0 0 r
s
.251 .356 .697 r
.5 .52392 m .51776 .52392 L .51611 .50212 L p F P
0 0 0 r
s
.251 .356 .697 r
.5 .50212 m .48389 .50212 L .48224 .52392 L p F P
0 0 0 r
s
.251 .356 .697 r
.48224 .52392 m .5 .52392 L .5 .50212 L p F P
0 0 0 r
s
.251 .356 .697 r
.48389 .50212 m .46779 .50212 L .46448 .52392 L p F P
0 0 0 r
s
.251 .356 .697 r
.46448 .52392 m .48224 .52392 L .48389 .50212 L p F P
0 0 0 r
s
.251 .356 .697 r
.46779 .50212 m .45168 .50212 L .44672 .52392 L p F P
0 0 0 r
s
.251 .356 .697 r
.44672 .52392 m .46448 .52392 L .46779 .50212 L p F P
0 0 0 r
s
.251 .356 .697 r
.45168 .50212 m .43558 .50212 L .42896 .52392 L p F P
0 0 0 r
s
.251 .356 .697 r
.42896 .52392 m .44672 .52392 L .45168 .50212 L p F P
0 0 0 r
s
.251 .356 .697 r
.43558 .50212 m .41947 .50212 L .4112 .52392 L p F P
0 0 0 r
s
.251 .356 .697 r
.4112 .52392 m .42896 .52392 L .43558 .50212 L p F P
0 0 0 r
s
.251 .356 .697 r
.41947 .50212 m .40337 .50212 L .39343 .52392 L p F P
0 0 0 r
s
.251 .356 .697 r
.39343 .52392 m .4112 .52392 L .41947 .50212 L p F P
0 0 0 r
s
.251 .356 .697 r
.40337 .50212 m .38726 .50212 L .37567 .52392 L p F P
0 0 0 r
s
.251 .356 .697 r
.37567 .52392 m .39343 .52392 L .40337 .50212 L p F P
0 0 0 r
s
.597 .179 .083 r
.61366 .49239 m .61274 .50212 L .59862 .48028 L p F P
0 0 0 r
s
.465 .141 .068 r
.61274 .50212 m .61366 .49239 L .62545 .51338 L p F P
0 0 0 r
s
.465 .141 .068 r
.62545 .51338 m .62433 .52392 L .61274 .50212 L p F P
0 0 0 r
s
.83 .24 .1 r
.51443 .77548 m
.51472 .75692 L
s
.51443 .77548 m
.48557 .77548 L
s
.48557 .77548 m
.48528 .75692 L
s
.265 .381 .747 r
.58223 .45879 m .57048 .45879 L .58454 .48028 L p F P
0 0 0 r
s
.265 .381 .747 r
.58454 .48028 m .59862 .48028 L .58223 .45879 L p F P
0 0 0 r
s
.265 .381 .747 r
.57048 .45879 m .55874 .45879 L .57045 .48028 L p F P
0 0 0 r
s
.83 .24 .1 r
.56783 .47578 m
.56784 .4755 L
s
.265 .381 .747 r
.57045 .48028 m .58454 .48028 L .57048 .45879 L p F P
0 0 0 r
s
.265 .381 .747 r
.55874 .45879 m .54699 .45879 L .55636 .48028 L p F P
0 0 0 r
s
.265 .381 .747 r
.55636 .48028 m .57045 .48028 L .55874 .45879 L p F P
0 0 0 r
s
.83 .24 .1 r
.56878 .45879 m
.56918 .45158 L
s
.265 .381 .747 r
.54699 .45879 m .53524 .45879 L .54227 .48028 L p F P
0 0 0 r
s
.265 .381 .747 r
.54227 .48028 m .55636 .48028 L .54699 .45879 L p F P
0 0 0 r
s
.265 .381 .747 r
.53524 .45879 m .52349 .45879 L .52818 .48028 L p F P
0 0 0 r
s
.265 .381 .747 r
.52818 .48028 m .54227 .48028 L .53524 .45879 L p F P
0 0 0 r
s
.265 .381 .747 r
.52349 .45879 m .51175 .45879 L .51409 .48028 L p F P
0 0 0 r
s
.265 .381 .747 r
.51409 .48028 m .52818 .48028 L .52349 .45879 L p F P
0 0 0 r
s
.265 .381 .747 r
.51175 .45879 m .5 .45879 L .5 .48028 L p F P
0 0 0 r
s
.265 .381 .747 r
.5 .48028 m .51409 .48028 L .51175 .45879 L p F P
0 0 0 r
s
.265 .381 .747 r
.5 .45879 m .48825 .45879 L .48591 .48028 L p F P
0 0 0 r
s
.265 .381 .747 r
.48591 .48028 m .5 .48028 L .5 .45879 L p F P
0 0 0 r
s
.265 .381 .747 r
.48825 .45879 m .47651 .45879 L .47182 .48028 L p F P
0 0 0 r
s
.265 .381 .747 r
.47182 .48028 m .48591 .48028 L .48825 .45879 L p F P
0 0 0 r
s
.265 .381 .747 r
.47651 .45879 m .46476 .45879 L .45773 .48028 L p F P
0 0 0 r
s
.265 .381 .747 r
.45773 .48028 m .47182 .48028 L .47651 .45879 L p F P
0 0 0 r
s
.265 .381 .747 r
.46476 .45879 m .45301 .45879 L .44364 .48028 L p F P
0 0 0 r
s
.265 .381 .747 r
.44364 .48028 m .45773 .48028 L .46476 .45879 L p F P
0 0 0 r
s
.265 .381 .747 r
.45301 .45879 m .44126 .45879 L .42955 .48028 L p F P
0 0 0 r
s
.265 .381 .747 r
.42955 .48028 m .44364 .48028 L .45301 .45879 L p F P
0 0 0 r
s
.265 .381 .747 r
.44126 .45879 m .42952 .45879 L .41546 .48028 L p F P
0 0 0 r
s
.83 .24 .1 r
.43167 .46678 m
.43216 .4755 L
s
.265 .381 .747 r
.41546 .48028 m .42955 .48028 L .44126 .45879 L p F P
0 0 0 r
s
.83 .24 .1 r
.43082 .45158 m
.43122 .45879 L
s
.265 .381 .747 r
.42952 .45879 m .41777 .45879 L .40138 .48028 L p F P
0 0 0 r
s
.83 .24 .1 r
.40762 .47551 m
.40798 .48028 L
s
.265 .381 .747 r
.40138 .48028 m .41546 .48028 L .42952 .45879 L p F P
0 0 0 r
s
1 .334 .136 r
.40138 .48028 m .40067 .47162 L .38634 .49239 L p F P
0 0 0 r
s
1 .332 .137 r
.40067 .47162 m .40138 .48028 L .41777 .45879 L p F P
0 0 0 r
s
.702 .21 .094 r
.59933 .47162 m .59862 .48028 L .58223 .45879 L p F P
0 0 0 r
s
.597 .179 .083 r
.59862 .48028 m .59933 .47162 L .61366 .49239 L p F P
0 0 0 r
s
.24 .35 .67 r
.2629 .4733 m
.26329 .5021 L
s
.22384 .5021 m
.22339 .4733 L
s
.26329 .5021 m
.22384 .5021 L
s
.30242 .4733 m
.30274 .5021 L
s
.30274 .5021 m
.26329 .5021 L
s
.34193 .4733 m
.34219 .5021 L
s
.34219 .5021 m
.30274 .5021 L
s
.38145 .4733 m
.38163 .50077 L
s
.34219 .5021 m
.38089 .5021 L
s
.42097 .4733 m
.4211 .5021 L
s
.38666 .5021 m
.4211 .5021 L
s
.46048 .4733 m
.46055 .5021 L
s
.46055 .5021 m
.4211 .5021 L
s
.5 .4733 m
.5 .5021 L
s
.5 .5021 m
.46055 .5021 L
s
.53945 .5021 m
.53952 .4733 L
s
.53945 .5021 m
.5 .5021 L
s
.5789 .5021 m
.57903 .4733 L
s
.5789 .5021 m
.53945 .5021 L
s
.61837 .50077 m
.61855 .4733 L
s
.5789 .5021 m
.61334 .5021 L
s
.65807 .4733 m
.65781 .5021 L
s
.61911 .5021 m
.65781 .5021 L
s
.69758 .4733 m
.69726 .5021 L
s
.69726 .5021 m
.65781 .5021 L
s
.7371 .4733 m
.73671 .5021 L
s
.73671 .5021 m
.69726 .5021 L
s
.77661 .4733 m
.77616 .5021 L
s
.77616 .5021 m
.73671 .5021 L
s
.26329 .5021 m
.26277 .53082 L
s
.22323 .53082 m
.22384 .5021 L
s
.30274 .5021 m
.30231 .53082 L
s
.34219 .5021 m
.34185 .53082 L
s
.65781 .5021 m
.65815 .53082 L
s
.69726 .5021 m
.69769 .53082 L
s
.73671 .5021 m
.73723 .53082 L
s
.77616 .5021 m
.77677 .53082 L
s
1 .318 .127 r
.36555 .5342 m .36684 .54528 L .37567 .52392 L p F P
0 0 0 r
s
1 .318 .127 r
.37567 .52392 m .37455 .51338 L .36555 .5342 L p F P
0 0 0 r
s
.242 .342 .668 r
.62433 .52392 m .60657 .52392 L .61414 .54528 L p F P
0 0 0 r
s
.242 .342 .668 r
.61414 .54528 m .63316 .54528 L .62433 .52392 L p F P
0 0 0 r
s
.24 .35 .67 r
.61844 .51149 m
.61861 .53082 L
s
.83 .24 .1 r
.62443 .54908 m
.62484 .54528 L
s
.242 .342 .668 r
.60657 .52392 m .5888 .52392 L .59511 .54528 L p F P
0 0 0 r
s
.242 .342 .668 r
.59511 .54528 m .61414 .54528 L .60657 .52392 L p F P
0 0 0 r
s
.242 .342 .668 r
.5888 .52392 m .57104 .52392 L .57609 .54528 L p F P
0 0 0 r
s
.242 .342 .668 r
.57609 .54528 m .59511 .54528 L .5888 .52392 L p F P
0 0 0 r
s
.24 .35 .67 r
.5789 .5021 m
.57908 .53082 L
s
.242 .342 .668 r
.57104 .52392 m .55328 .52392 L .55707 .54528 L p F P
0 0 0 r
s
.242 .342 .668 r
.55707 .54528 m .57609 .54528 L .57104 .52392 L p F P
0 0 0 r
s
.242 .342 .668 r
.55328 .52392 m .53552 .52392 L .53805 .54528 L p F P
0 0 0 r
s
.242 .342 .668 r
.53805 .54528 m .55707 .54528 L .55328 .52392 L p F P
0 0 0 r
s
.24 .35 .67 r
.53945 .5021 m
.53954 .53082 L
s
.242 .342 .668 r
.53552 .52392 m .51776 .52392 L .51902 .54528 L p F P
0 0 0 r
s
.242 .342 .668 r
.51902 .54528 m .53805 .54528 L .53552 .52392 L p F P
0 0 0 r
s
.242 .342 .668 r
.51776 .52392 m .5 .52392 L .5 .54528 L p F P
0 0 0 r
s
.242 .342 .668 r
.5 .54528 m .51902 .54528 L .51776 .52392 L p F P
0 0 0 r
s
.242 .342 .668 r
.5 .52392 m .48224 .52392 L .48098 .54528 L p F P
0 0 0 r
s
.242 .342 .668 r
.48098 .54528 m .5 .54528 L .5 .52392 L p F P
0 0 0 r
s
.24 .35 .67 r
.5 .5021 m
.5 .53082 L
s
.242 .342 .668 r
.48224 .52392 m .46448 .52392 L .46195 .54528 L p F P
0 0 0 r
s
.242 .342 .668 r
.46195 .54528 m .48098 .54528 L .48224 .52392 L p F P
0 0 0 r
s
.242 .342 .668 r
.46448 .52392 m .44672 .52392 L .44293 .54528 L p F P
0 0 0 r
s
.242 .342 .668 r
.44293 .54528 m .46195 .54528 L .46448 .52392 L p F P
0 0 0 r
s
.24 .35 .67 r
.46046 .53082 m
.46055 .5021 L
s
.242 .342 .668 r
.44672 .52392 m .42896 .52392 L .42391 .54528 L p F P
0 0 0 r
s
.242 .342 .668 r
.42391 .54528 m .44293 .54528 L .44672 .52392 L p F P
0 0 0 r
s
.242 .342 .668 r
.42896 .52392 m .4112 .52392 L .40489 .54528 L p F P
0 0 0 r
s
.242 .342 .668 r
.40489 .54528 m .42391 .54528 L .42896 .52392 L p F P
0 0 0 r
s
.24 .35 .67 r
.42092 .53082 m
.4211 .5021 L
s
.242 .342 .668 r
.4112 .52392 m .39343 .52392 L .38586 .54528 L p F P
0 0 0 r
s
.242 .342 .668 r
.38586 .54528 m .40489 .54528 L .4112 .52392 L p F P
0 0 0 r
s
.242 .342 .668 r
.39343 .52392 m .37567 .52392 L .36684 .54528 L p F P
0 0 0 r
s
.83 .24 .1 r
.37449 .53914 m
.37557 .54908 L
s
.242 .342 .668 r
.36684 .54528 m .38586 .54528 L .39343 .52392 L p F P
0 0 0 r
s
.24 .35 .67 r
.38139 .53082 m
.38156 .51149 L
s
.83 .24 .1 r
.37308 .52624 m
.37365 .53146 L
s
.37308 .52624 m
.38359 .51263 L
s
.332 .1 .051 r
.62433 .52392 m .62545 .51338 L .63445 .5342 L p F P
0 0 0 r
s
.332 .1 .051 r
.63445 .5342 m .63316 .54528 L .62433 .52392 L p F P
0 0 0 r
s
.83 .24 .1 r
.61641 .51263 m
.62692 .52624 L
s
.62635 .53146 m
.62692 .52624 L
s
.24 .35 .67 r
.26162 .44538 m
.2629 .4733 L
s
.22339 .4733 m
.22189 .44538 L
s
.2629 .4733 m
.22339 .4733 L
s
.30135 .44538 m
.30242 .4733 L
s
.30242 .4733 m
.2629 .4733 L
s
.34108 .44538 m
.34193 .4733 L
s
.34193 .4733 m
.30242 .4733 L
s
.38081 .44538 m
.38145 .4733 L
s
.38145 .4733 m
.34193 .4733 L
s
.40589 .4733 m
.42097 .4733 L
s
.38145 .4733 m
.39951 .4733 L
s
.42097 .4733 m
.46048 .4733 L
s
.46048 .4733 m
.5 .4733 L
s
.5 .4733 m
.53952 .4733 L
s
.53952 .4733 m
.57903 .4733 L
s
.61919 .44538 m
.61855 .4733 L
s
.57903 .4733 m
.59411 .4733 L
s
.60049 .4733 m
.61855 .4733 L
s
.65892 .44538 m
.65807 .4733 L
s
.65807 .4733 m
.61855 .4733 L
s
.69865 .44538 m
.69758 .4733 L
s
.69758 .4733 m
.65807 .4733 L
s
.73838 .44538 m
.7371 .4733 L
s
.7371 .4733 m
.69758 .4733 L
s
.77811 .44538 m
.77661 .4733 L
s
.77661 .4733 m
.7371 .4733 L
s
.26277 .53082 m
.22323 .53082 L
s
.30231 .53082 m
.26277 .53082 L
s
.34185 .53082 m
.30231 .53082 L
s
.37248 .53082 m
.38139 .53082 L
s
.34185 .53082 m
.36701 .53082 L
s
.38139 .53082 m
.42092 .53082 L
s
.42092 .53082 m
.46046 .53082 L
s
.46046 .53082 m
.5 .53082 L
s
.5 .53082 m
.53954 .53082 L
s
.53954 .53082 m
.57908 .53082 L
s
.57908 .53082 m
.61861 .53082 L
s
.61861 .53082 m
.62752 .53082 L
s
.63299 .53082 m
.65815 .53082 L
s
.69769 .53082 m
.65815 .53082 L
s
.73723 .53082 m
.69769 .53082 L
s
.77677 .53082 m
.73723 .53082 L
s
.26277 .53082 m
.26137 .55854 L
s
.22159 .55854 m
.22323 .53082 L
s
.30231 .53082 m
.30114 .55854 L
s
.34185 .53082 m
.34091 .55854 L
s
.65815 .53082 m
.65909 .55854 L
s
.69769 .53082 m
.69886 .55854 L
s
.73723 .53082 m
.73863 .55854 L
s
.77677 .53082 m
.77841 .55854 L
s
.271 .393 .77 r
.56384 .43807 m .55472 .43807 L .57048 .45879 L p F P
0 0 0 r
s
.271 .393 .77 r
.57048 .45879 m .58223 .45879 L .56384 .43807 L p F P
0 0 0 r
s
.271 .393 .77 r
.55472 .43807 m .5456 .43807 L .55874 .45879 L p F P
0 0 0 r
s
.271 .393 .77 r
.55874 .45879 m .57048 .45879 L .55472 .43807 L p F P
0 0 0 r
s
.271 .393 .77 r
.5456 .43807 m .53648 .43807 L .54699 .45879 L p F P
0 0 0 r
s
.271 .393 .77 r
.54699 .45879 m .55874 .45879 L .5456 .43807 L p F P
0 0 0 r
s
.271 .393 .77 r
.53648 .43807 m .52736 .43807 L .53524 .45879 L p F P
0 0 0 r
s
.271 .393 .77 r
.53524 .45879 m .54699 .45879 L .53648 .43807 L p F P
0 0 0 r
s
.24 .35 .67 r
.53952 .4733 m
.53973 .44538 L
s
.271 .393 .77 r
.52736 .43807 m .51824 .43807 L .52349 .45879 L p F P
0 0 0 r
s
.271 .393 .77 r
.52349 .45879 m .53524 .45879 L .52736 .43807 L p F P
0 0 0 r
s
.271 .393 .77 r
.51824 .43807 m .50912 .43807 L .51175 .45879 L p F P
0 0 0 r
s
.271 .393 .77 r
.51175 .45879 m .52349 .45879 L .51824 .43807 L p F P
0 0 0 r
s
.271 .393 .77 r
.50912 .43807 m .5 .43807 L .5 .45879 L p F P
0 0 0 r
s
.271 .393 .77 r
.5 .45879 m .51175 .45879 L .50912 .43807 L p F P
0 0 0 r
s
.271 .393 .77 r
.5 .43807 m .49088 .43807 L .48825 .45879 L p F P
0 0 0 r
s
.271 .393 .77 r
.48825 .45879 m .5 .45879 L .5 .43807 L p F P
0 0 0 r
s
.24 .35 .67 r
.5 .44538 m
.5 .4733 L
s
.271 .393 .77 r
.49088 .43807 m .48176 .43807 L .47651 .45879 L p F P
0 0 0 r
s
.271 .393 .77 r
.47651 .45879 m .48825 .45879 L .49088 .43807 L p F P
0 0 0 r
s
.271 .393 .77 r
.48176 .43807 m .47264 .43807 L .46476 .45879 L p F P
0 0 0 r
s
.271 .393 .77 r
.46476 .45879 m .47651 .45879 L .48176 .43807 L p F P
0 0 0 r
s
.271 .393 .77 r
.47264 .43807 m .46352 .43807 L .45301 .45879 L p F P
0 0 0 r
s
.271 .393 .77 r
.45301 .45879 m .46476 .45879 L .47264 .43807 L p F P
0 0 0 r
s
.271 .393 .77 r
.46352 .43807 m .4544 .43807 L .44126 .45879 L p F P
0 0 0 r
s
.271 .393 .77 r
.44126 .45879 m .45301 .45879 L .46352 .43807 L p F P
0 0 0 r
s
.24 .35 .67 r
.46027 .44538 m
.46048 .4733 L
s
.271 .393 .77 r
.4544 .43807 m .44528 .43807 L .42952 .45879 L p F P
0 0 0 r
s
.271 .393 .77 r
.42952 .45879 m .44126 .45879 L .4544 .43807 L p F P
0 0 0 r
s
.271 .393 .77 r
.44528 .43807 m .43616 .43807 L .41777 .45879 L p F P
0 0 0 r
s
.271 .393 .77 r
.41777 .45879 m .42952 .45879 L .44528 .43807 L p F P
0 0 0 r
s
1 .332 .137 r
.41777 .45879 m .41728 .45146 L .40067 .47162 L p F P
0 0 0 r
s
1 .327 .136 r
.41728 .45146 m .41777 .45879 L .43616 .43807 L p F P
0 0 0 r
s
.24 .35 .67 r
.42066 .4534 m
.42097 .4733 L
s
.42054 .44538 m
.4206 .44911 L
s
.789 .235 .104 r
.58272 .45146 m .58223 .45879 L .56384 .43807 L p F P
0 0 0 r
s
.24 .35 .67 r
.57903 .4733 m
.57934 .4534 L
s
.5794 .44911 m
.57946 .44538 L
s
.702 .21 .094 r
.58223 .45879 m .58272 .45146 L .59933 .47162 L p F P
0 0 0 r
s
1 .295 .116 r
.35954 .55444 m .36095 .56581 L .36684 .54528 L p F P
0 0 0 r
s
1 .295 .116 r
.36684 .54528 m .36555 .5342 L .35954 .55444 L p F P
0 0 0 r
s
.232 .325 .636 r
.63316 .54528 m .61414 .54528 L .61919 .56581 L p F P
0 0 0 r
s
.232 .325 .636 r
.61919 .56581 m .63905 .56581 L .63316 .54528 L p F P
0 0 0 r
s
.83 .24 .1 r
.63461 .57147 m
.63529 .56581 L
s
.232 .325 .636 r
.61414 .54528 m .59511 .54528 L .59932 .56581 L p F P
0 0 0 r
s
.232 .325 .636 r
.59932 .56581 m .61919 .56581 L .61414 .54528 L p F P
0 0 0 r
s
.24 .35 .67 r
.61861 .53082 m
.61932 .55854 L
s
.232 .325 .636 r
.59511 .54528 m .57609 .54528 L .57946 .56581 L p F P
0 0 0 r
s
.232 .325 .636 r
.57946 .56581 m .59932 .56581 L .59511 .54528 L p F P
0 0 0 r
s
.232 .325 .636 r
.57609 .54528 m .55707 .54528 L .55959 .56581 L p F P
0 0 0 r
s
.232 .325 .636 r
.55959 .56581 m .57946 .56581 L .57609 .54528 L p F P
0 0 0 r
s
.24 .35 .67 r
.57908 .53082 m
.57954 .55854 L
s
.232 .325 .636 r
.55707 .54528 m .53805 .54528 L .53973 .56581 L p F P
0 0 0 r
s
.232 .325 .636 r
.53973 .56581 m .55959 .56581 L .55707 .54528 L p F P
0 0 0 r
s
.232 .325 .636 r
.53805 .54528 m .51902 .54528 L .51986 .56581 L p F P
0 0 0 r
s
.232 .325 .636 r
.51986 .56581 m .53973 .56581 L .53805 .54528 L p F P
0 0 0 r
s
.24 .35 .67 r
.53954 .53082 m
.53977 .55854 L
s
.232 .325 .636 r
.51902 .54528 m .5 .54528 L .5 .56581 L p F P
0 0 0 r
s
.232 .325 .636 r
.5 .56581 m .51986 .56581 L .51902 .54528 L p F P
0 0 0 r
s
.232 .325 .636 r
.5 .54528 m .48098 .54528 L .48014 .56581 L p F P
0 0 0 r
s
.232 .325 .636 r
.48014 .56581 m .5 .56581 L .5 .54528 L p F P
0 0 0 r
s
.24 .35 .67 r
.5 .53082 m
.5 .55854 L
s
.232 .325 .636 r
.48098 .54528 m .46195 .54528 L .46027 .56581 L p F P
0 0 0 r
s
.232 .325 .636 r
.46027 .56581 m .48014 .56581 L .48098 .54528 L p F P
0 0 0 r
s
.232 .325 .636 r
.46195 .54528 m .44293 .54528 L .44041 .56581 L p F P
0 0 0 r
s
.232 .325 .636 r
.44041 .56581 m .46027 .56581 L .46195 .54528 L p F P
0 0 0 r
s
.24 .35 .67 r
.46023 .55854 m
.46046 .53082 L
s
.232 .325 .636 r
.44293 .54528 m .42391 .54528 L .42054 .56581 L p F P
0 0 0 r
s
.232 .325 .636 r
.42054 .56581 m .44041 .56581 L .44293 .54528 L p F P
0 0 0 r
s
.232 .325 .636 r
.42391 .54528 m .40489 .54528 L .40068 .56581 L p F P
0 0 0 r
s
.232 .325 .636 r
.40068 .56581 m .42054 .56581 L .42391 .54528 L p F P
0 0 0 r
s
.24 .35 .67 r
.42046 .55854 m
.42092 .53082 L
s
.232 .325 .636 r
.40489 .54528 m .38586 .54528 L .38081 .56581 L p F P
0 0 0 r
s
.232 .325 .636 r
.38081 .56581 m .40068 .56581 L .40489 .54528 L p F P
0 0 0 r
s
.232 .325 .636 r
.38586 .54528 m .36684 .54528 L .36095 .56581 L p F P
0 0 0 r
s
.232 .325 .636 r
.36095 .56581 m .38081 .56581 L .38586 .54528 L p F P
0 0 0 r
s
.83 .24 .1 r
.36471 .56581 m
.36539 .57147 L
s
.24 .35 .67 r
.38068 .55854 m
.38139 .53082 L
s
.249 .072 .039 r
.63316 .54528 m .63445 .5342 L .64046 .55444 L p F P
0 0 0 r
s
.249 .072 .039 r
.64046 .55444 m .63905 .56581 L .63316 .54528 L p F P
0 0 0 r
s
.83 .24 .1 r
.593 .72558 m
.59489 .70587 L
s
.593 .72558 m
.56994 .74079 L
s
.43006 .74079 m
.407 .72558 L
s
.407 .72558 m
.40511 .70587 L
s
.24 .35 .67 r
.25948 .41926 m
.26162 .44538 L
s
.22189 .44538 m
.21939 .41926 L
s
.26162 .44538 m
.22189 .44538 L
s
.29957 .41926 m
.30135 .44538 L
s
.30135 .44538 m
.26162 .44538 L
s
.33965 .41926 m
.34108 .44538 L
s
.34108 .44538 m
.30135 .44538 L
s
.37974 .41926 m
.38081 .44538 L
s
.38081 .44538 m
.34108 .44538 L
s
.38081 .44538 m
.42054 .44538 L
s
.42852 .44538 m
.46027 .44538 L
s
.42054 .44538 m
.42586 .44538 L
s
.46027 .44538 m
.5 .44538 L
s
.5 .44538 m
.53973 .44538 L
s
.53973 .44538 m
.57148 .44538 L
s
.57414 .44538 m
.57946 .44538 L
s
.62026 .41926 m
.61919 .44538 L
s
.57946 .44538 m
.61919 .44538 L
s
.66035 .41926 m
.65892 .44538 L
s
.65892 .44538 m
.61919 .44538 L
s
.70043 .41926 m
.69865 .44538 L
s
.69865 .44538 m
.65892 .44538 L
s
.74052 .41926 m
.73838 .44538 L
s
.73838 .44538 m
.69865 .44538 L
s
.78061 .41926 m
.77811 .44538 L
s
.77811 .44538 m
.73838 .44538 L
s
1 .334 .136 r
.3854 .4825 m .38634 .49239 L .40067 .47162 L p F P
0 0 0 r
s
1 .334 .136 r
.40067 .47162 m .39996 .46284 L .3854 .4825 L p F P
0 0 0 r
s
1 .332 .137 r
.39996 .46284 m .40067 .47162 L .41728 .45146 L p F P
0 0 0 r
s
.83 .24 .1 r
.40682 .46496 m
.42398 .45539 L
s
.40682 .46496 m
.40753 .47426 L
s
.702 .21 .094 r
.60004 .46284 m .59933 .47162 L .58272 .45146 L p F P
0 0 0 r
s
.83 .24 .1 r
.59247 .47426 m
.59318 .46496 L
s
.57602 .45539 m
.59318 .46496 L
s
.597 .179 .083 r
.59933 .47162 m .60004 .46284 L .6146 .4825 L p F P
0 0 0 r
s
.597 .179 .083 r
.6146 .4825 m .61366 .49239 L .59933 .47162 L p F P
0 0 0 r
s
1 .33 .134 r
.37341 .50265 m .37455 .51338 L .38634 .49239 L p F P
0 0 0 r
s
1 .33 .134 r
.38634 .49239 m .3854 .4825 L .37341 .50265 L p F P
0 0 0 r
s
.465 .141 .068 r
.61366 .49239 m .6146 .4825 L .62659 .50265 L p F P
0 0 0 r
s
.465 .141 .068 r
.62659 .50265 m .62545 .51338 L .61366 .49239 L p F P
0 0 0 r
s
.24 .35 .67 r
.26137 .55854 m
.22159 .55854 L
s
.30114 .55854 m
.26137 .55854 L
s
.34091 .55854 m
.30114 .55854 L
s
.36279 .55854 m
.38068 .55854 L
s
.34091 .55854 m
.36005 .55854 L
s
.38068 .55854 m
.42046 .55854 L
s
.42046 .55854 m
.46023 .55854 L
s
.46023 .55854 m
.5 .55854 L
s
.5 .55854 m
.53977 .55854 L
s
.53977 .55854 m
.57954 .55854 L
s
.57954 .55854 m
.61932 .55854 L
s
.61932 .55854 m
.63721 .55854 L
s
.63995 .55854 m
.65909 .55854 L
s
.69886 .55854 m
.65909 .55854 L
s
.73863 .55854 m
.69886 .55854 L
s
.77841 .55854 m
.73863 .55854 L
s
.26137 .55854 m
.2591 .58431 L
s
.21895 .58431 m
.22159 .55854 L
s
.30114 .55854 m
.29925 .58431 L
s
.34091 .55854 m
.3394 .58431 L
s
.65909 .55854 m
.6606 .58431 L
s
.69886 .55854 m
.70075 .58431 L
s
.73863 .55854 m
.7409 .58431 L
s
.77841 .55854 m
.78105 .58431 L
s
1 .327 .136 r
.43616 .43807 m .43587 .43229 L .41728 .45146 L p F P
0 0 0 r
s
1 .32 .134 r
.43587 .43229 m .43616 .43807 L .45624 .41851 L p F P
0 0 0 r
s
.86 .255 .111 r
.56413 .43229 m .56384 .43807 L .54376 .41851 L p F P
0 0 0 r
s
.789 .235 .104 r
.56384 .43807 m .56413 .43229 L .58272 .45146 L p F P
0 0 0 r
s
.277 .404 .792 r
.54376 .41851 m .53751 .41851 L .55472 .43807 L p F P
0 0 0 r
s
.277 .404 .792 r
.55472 .43807 m .56384 .43807 L .54376 .41851 L p F P
0 0 0 r
s
.277 .404 .792 r
.53751 .41851 m .53126 .41851 L .5456 .43807 L p F P
0 0 0 r
s
.83 .24 .1 r
.54271 .43807 m
.54284 .43431 L
s
.277 .404 .792 r
.5456 .43807 m .55472 .43807 L .53751 .41851 L p F P
0 0 0 r
s
.277 .404 .792 r
.53126 .41851 m .52501 .41851 L .53648 .43807 L p F P
0 0 0 r
s
.277 .404 .792 r
.53648 .43807 m .5456 .43807 L .53126 .41851 L p F P
0 0 0 r
s
.24 .35 .67 r
.53973 .44538 m
.54009 .41926 L
s
.277 .404 .792 r
.52501 .41851 m .51876 .41851 L .52736 .43807 L p F P
0 0 0 r
s
.277 .404 .792 r
.52736 .43807 m .53648 .43807 L .52501 .41851 L p F P
0 0 0 r
s
.277 .404 .792 r
.51876 .41851 m .5125 .41851 L .51824 .43807 L p F P
0 0 0 r
s
.83 .24 .1 r
.51437 .43777 m
.51451 .42535 L
s
.277 .404 .792 r
.51824 .43807 m .52736 .43807 L .51876 .41851 L p F P
0 0 0 r
s
.277 .404 .792 r
.5125 .41851 m .50625 .41851 L .50912 .43807 L p F P
0 0 0 r
s
.277 .404 .792 r
.50912 .43807 m .51824 .43807 L .5125 .41851 L p F P
0 0 0 r
s
.277 .404 .792 r
.50625 .41851 m .5 .41851 L .5 .43807 L p F P
0 0 0 r
s
.277 .404 .792 r
.5 .43807 m .50912 .43807 L .50625 .41851 L p F P
0 0 0 r
s
.277 .404 .792 r
.5 .41851 m .49375 .41851 L .49088 .43807 L p F P
0 0 0 r
s
.277 .404 .792 r
.49088 .43807 m .5 .43807 L .5 .41851 L p F P
0 0 0 r
s
.24 .35 .67 r
.5 .41926 m
.5 .44538 L
s
.277 .404 .792 r
.49375 .41851 m .4875 .41851 L .48176 .43807 L p F P
0 0 0 r
s
.83 .24 .1 r
.48557 .43186 m
.48563 .43777 L
s
.277 .404 .792 r
.48176 .43807 m .49088 .43807 L .49375 .41851 L p F P
0 0 0 r
s
.277 .404 .792 r
.4875 .41851 m .48124 .41851 L .47264 .43807 L p F P
0 0 0 r
s
.277 .404 .792 r
.47264 .43807 m .48176 .43807 L .4875 .41851 L p F P
0 0 0 r
s
.277 .404 .792 r
.48124 .41851 m .47499 .41851 L .46352 .43807 L p F P
0 0 0 r
s
.277 .404 .792 r
.46352 .43807 m .47264 .43807 L .48124 .41851 L p F P
0 0 0 r
s
.277 .404 .792 r
.47499 .41851 m .46874 .41851 L .4544 .43807 L p F P
0 0 0 r
s
.83 .24 .1 r
.45719 .43542 m
.45729 .43807 L
s
.277 .404 .792 r
.4544 .43807 m .46352 .43807 L .47499 .41851 L p F P
0 0 0 r
s
.277 .404 .792 r
.46874 .41851 m .46249 .41851 L .44528 .43807 L p F P
0 0 0 r
s
.277 .404 .792 r
.44528 .43807 m .4544 .43807 L .46874 .41851 L p F P
0 0 0 r
s
.277 .404 .792 r
.46249 .41851 m .45624 .41851 L .43616 .43807 L p F P
0 0 0 r
s
.277 .404 .792 r
.43616 .43807 m .44528 .43807 L .46249 .41851 L p F P
0 0 0 r
s
.24 .35 .67 r
.45991 .41926 m
.46027 .44538 L
s
.83 .24 .1 r
.38621 .68669 m
.37274 .66473 L
s
.37274 .66473 m
.37013 .64374 L
s
.62726 .66473 m
.62987 .64374 L
s
.62726 .66473 m
.61379 .68669 L
s
1 .332 .137 r
.41728 .45146 m .41679 .44404 L .39996 .46284 L p F P
0 0 0 r
s
1 .327 .136 r
.41679 .44404 m .41728 .45146 L .43587 .43229 L p F P
0 0 0 r
s
.789 .235 .104 r
.58321 .44404 m .58272 .45146 L .56413 .43229 L p F P
0 0 0 r
s
.702 .21 .094 r
.58272 .45146 m .58321 .44404 L .60004 .46284 L p F P
0 0 0 r
s
.899 .254 .097 r
.35669 .5737 m .35816 .58511 L .36095 .56581 L p F P
0 0 0 r
s
.899 .254 .097 r
.36095 .56581 m .35954 .55444 L .35669 .5737 L p F P
0 0 0 r
s
.221 .306 .597 r
.63905 .56581 m .61919 .56581 L .62158 .58511 L p F P
0 0 0 r
s
.221 .306 .597 r
.62158 .58511 m .64184 .58511 L .63905 .56581 L p F P
0 0 0 r
s
.221 .306 .597 r
.61919 .56581 m .59932 .56581 L .60132 .58511 L p F P
0 0 0 r
s
.221 .306 .597 r
.60132 .58511 m .62158 .58511 L .61919 .56581 L p F P
0 0 0 r
s
.24 .35 .67 r
.61932 .55854 m
.62045 .58431 L
s
.221 .306 .597 r
.59932 .56581 m .57946 .56581 L .58105 .58511 L p F P
0 0 0 r
s
.221 .306 .597 r
.58105 .58511 m .60132 .58511 L .59932 .56581 L p F P
0 0 0 r
s
.221 .306 .597 r
.57946 .56581 m .55959 .56581 L .56079 .58511 L p F P
0 0 0 r
s
.221 .306 .597 r
.56079 .58511 m .58105 .58511 L .57946 .56581 L p F P
0 0 0 r
s
.24 .35 .67 r
.57954 .55854 m
.5803 .58431 L
s
.221 .306 .597 r
.55959 .56581 m .53973 .56581 L .54053 .58511 L p F P
0 0 0 r
s
.221 .306 .597 r
.54053 .58511 m .56079 .58511 L .55959 .56581 L p F P
0 0 0 r
s
.221 .306 .597 r
.53973 .56581 m .51986 .56581 L .52026 .58511 L p F P
0 0 0 r
s
.221 .306 .597 r
.52026 .58511 m .54053 .58511 L .53973 .56581 L p F P
0 0 0 r
s
.24 .35 .67 r
.53977 .55854 m
.54015 .58431 L
s
.221 .306 .597 r
.51986 .56581 m .5 .56581 L .5 .58511 L p F P
0 0 0 r
s
.221 .306 .597 r
.5 .58511 m .52026 .58511 L .51986 .56581 L p F P
0 0 0 r
s
.221 .306 .597 r
.5 .56581 m .48014 .56581 L .47974 .58511 L p F P
0 0 0 r
s
.221 .306 .597 r
.47974 .58511 m .5 .58511 L .5 .56581 L p F P
0 0 0 r
s
.24 .35 .67 r
.5 .55854 m
.5 .58431 L
s
.221 .306 .597 r
.48014 .56581 m .46027 .56581 L .45947 .58511 L p F P
0 0 0 r
s
.221 .306 .597 r
.45947 .58511 m .47974 .58511 L .48014 .56581 L p F P
0 0 0 r
s
.221 .306 .597 r
.46027 .56581 m .44041 .56581 L .43921 .58511 L p F P
0 0 0 r
s
.221 .306 .597 r
.43921 .58511 m .45947 .58511 L .46027 .56581 L p F P
0 0 0 r
s
.24 .35 .67 r
.45985 .58431 m
.46023 .55854 L
s
.221 .306 .597 r
.44041 .56581 m .42054 .56581 L .41895 .58511 L p F P
0 0 0 r
s
.221 .306 .597 r
.41895 .58511 m .43921 .58511 L .44041 .56581 L p F P
0 0 0 r
s
.221 .306 .597 r
.42054 .56581 m .40068 .56581 L .39868 .58511 L p F P
0 0 0 r
s
.221 .306 .597 r
.39868 .58511 m .41895 .58511 L .42054 .56581 L p F P
0 0 0 r
s
.24 .35 .67 r
.4197 .58431 m
.42046 .55854 L
s
.221 .306 .597 r
.40068 .56581 m .38081 .56581 L .37842 .58511 L p F P
0 0 0 r
s
.221 .306 .597 r
.37842 .58511 m .39868 .58511 L .40068 .56581 L p F P
0 0 0 r
s
.221 .306 .597 r
.38081 .56581 m .36095 .56581 L .35816 .58511 L p F P
0 0 0 r
s
.221 .306 .597 r
.35816 .58511 m .37842 .58511 L .38081 .56581 L p F P
0 0 0 r
s
.24 .35 .67 r
.37955 .58431 m
.38068 .55854 L
s
.181 .052 .027 r
.63905 .56581 m .64046 .55444 L .64331 .5737 L p F P
0 0 0 r
s
.181 .052 .027 r
.64331 .5737 m .64184 .58511 L .63905 .56581 L p F P
0 0 0 r
s
1 .318 .127 r
.36424 .52289 m .36555 .5342 L .37455 .51338 L p F P
0 0 0 r
s
1 .318 .127 r
.37455 .51338 m .37341 .50265 L .36424 .52289 L p F P
0 0 0 r
s
.332 .1 .051 r
.62545 .51338 m .62659 .50265 L .63576 .52289 L p F P
0 0 0 r
s
.332 .1 .051 r
.63576 .52289 m .63445 .5342 L .62545 .51338 L p F P
0 0 0 r
s
1 .327 .136 r
.43587 .43229 m .43557 .42645 L .41679 .44404 L p F P
0 0 0 r
s
1 .32 .134 r
.43557 .42645 m .43587 .43229 L .4561 .41449 L p F P
0 0 0 r
s
1 .32 .134 r
.45624 .41851 m .4561 .41449 L .43587 .43229 L p F P
0 0 0 r
s
.86 .255 .111 r
.54376 .41851 m .5439 .41449 L .56413 .43229 L p F P
0 0 0 r
s
.86 .255 .111 r
.56443 .42645 m .56413 .43229 L .5439 .41449 L p F P
0 0 0 r
s
.789 .235 .104 r
.56413 .43229 m .56443 .42645 L .58321 .44404 L p F P
0 0 0 r
s
.83 .24 .1 r
.56994 .74079 m
.57138 .72127 L
s
.56994 .74079 m
.54342 .75144 L
s
.45658 .75144 m
.43006 .74079 L
s
.43006 .74079 m
.42862 .72127 L
s
1 .295 .116 r
.35811 .54283 m .35954 .55444 L .36555 .5342 L p F P
0 0 0 r
s
.83 .24 .1 r
.36267 .54885 m
.36391 .55914 L
s
1 .295 .116 r
.36555 .5342 m .36424 .52289 L .35811 .54283 L p F P
0 0 0 r
s
.83 .24 .1 r
.36267 .54885 m
.37308 .52624 L
s
.249 .072 .039 r
.63445 .5342 m .63576 .52289 L .64189 .54283 L p F P
0 0 0 r
s
.249 .072 .039 r
.64189 .54283 m .64046 .55444 L .63445 .5342 L p F P
0 0 0 r
s
.83 .24 .1 r
.62692 .52624 m
.63733 .54885 L
s
.63609 .55914 m
.63733 .54885 L
s
1 .334 .136 r
.38445 .47245 m .3854 .4825 L .39996 .46284 L p F P
0 0 0 r
s
.83 .24 .1 r
.38641 .48212 m
.38838 .50307 L
s
1 .334 .136 r
.39996 .46284 m .39923 .45393 L .38445 .47245 L p F P
0 0 0 r
s
.83 .24 .1 r
.38641 .48212 m
.40682 .46496 L
s
1 .332 .137 r
.39923 .45393 m .39996 .46284 L .41679 .44404 L p F P
0 0 0 r
s
.702 .21 .094 r
.60077 .45393 m .60004 .46284 L .58321 .44404 L p F P
0 0 0 r
s
.597 .179 .083 r
.60004 .46284 m .60077 .45393 L .61555 .47245 L p F P
0 0 0 r
s
.597 .179 .083 r
.61555 .47245 m .6146 .4825 L .60004 .46284 L p F P
0 0 0 r
s
.83 .24 .1 r
.59318 .46496 m
.61359 .48212 L
s
.61162 .50307 m
.61359 .48212 L
s
1 .332 .137 r
.41679 .44404 m .41628 .43652 L .39923 .45393 L p F P
0 0 0 r
s
1 .327 .136 r
.41628 .43652 m .41679 .44404 L .43557 .42645 L p F P
0 0 0 r
s
.24 .35 .67 r
.41983 .41926 m
.42024 .43446 L
s
.789 .235 .104 r
.58372 .43652 m .58321 .44404 L .56443 .42645 L p F P
0 0 0 r
s
.24 .35 .67 r
.57976 .43446 m
.58017 .41926 L
s
.702 .21 .094 r
.58321 .44404 m .58372 .43652 L .60077 .45393 L p F P
0 0 0 r
s
.282 .414 .813 r
.52235 .40051 m .51916 .40051 L .53751 .41851 L p F P
0 0 0 r
s
.282 .414 .813 r
.53751 .41851 m .54376 .41851 L .52235 .40051 L p F P
0 0 0 r
s
.282 .414 .813 r
.51916 .40051 m .51597 .40051 L .53126 .41851 L p F P
0 0 0 r
s
.282 .414 .813 r
.53126 .41851 m .53751 .41851 L .51916 .40051 L p F P
0 0 0 r
s
.282 .414 .813 r
.51597 .40051 m .51277 .40051 L .52501 .41851 L p F P
0 0 0 r
s
.282 .414 .813 r
.52501 .41851 m .53126 .41851 L .51597 .40051 L p F P
0 0 0 r
s
.282 .414 .813 r
.51277 .40051 m .50958 .40051 L .51876 .41851 L p F P
0 0 0 r
s
.282 .414 .813 r
.51876 .41851 m .52501 .41851 L .51277 .40051 L p F P
0 0 0 r
s
.282 .414 .813 r
.50958 .40051 m .50639 .40051 L .5125 .41851 L p F P
0 0 0 r
s
.282 .414 .813 r
.5125 .41851 m .51876 .41851 L .50958 .40051 L p F P
0 0 0 r
s
.282 .414 .813 r
.50639 .40051 m .50319 .40051 L .50625 .41851 L p F P
0 0 0 r
s
.282 .414 .813 r
.50625 .41851 m .5125 .41851 L .50639 .40051 L p F P
0 0 0 r
s
.282 .414 .813 r
.50319 .40051 m .5 .40051 L .5 .41851 L p F P
0 0 0 r
s
.282 .414 .813 r
.5 .41851 m .50625 .41851 L .50319 .40051 L p F P
0 0 0 r
s
.282 .414 .813 r
.5 .40051 m .49681 .40051 L .49375 .41851 L p F P
0 0 0 r
s
.282 .414 .813 r
.49375 .41851 m .5 .41851 L .5 .40051 L p F P
0 0 0 r
s
.282 .414 .813 r
.49681 .40051 m .49361 .40051 L .4875 .41851 L p F P
0 0 0 r
s
.282 .414 .813 r
.4875 .41851 m .49375 .41851 L .49681 .40051 L p F P
0 0 0 r
s
.282 .414 .813 r
.49361 .40051 m .49042 .40051 L .48124 .41851 L p F P
0 0 0 r
s
.282 .414 .813 r
.48124 .41851 m .4875 .41851 L .49361 .40051 L p F P
0 0 0 r
s
.282 .414 .813 r
.49042 .40051 m .48723 .40051 L .47499 .41851 L p F P
0 0 0 r
s
.282 .414 .813 r
.47499 .41851 m .48124 .41851 L .49042 .40051 L p F P
0 0 0 r
s
.282 .414 .813 r
.48723 .40051 m .48403 .40051 L .46874 .41851 L p F P
0 0 0 r
s
.282 .414 .813 r
.46874 .41851 m .47499 .41851 L .48723 .40051 L p F P
0 0 0 r
s
.282 .414 .813 r
.48403 .40051 m .48084 .40051 L .46249 .41851 L p F P
0 0 0 r
s
.282 .414 .813 r
.46249 .41851 m .46874 .41851 L .48403 .40051 L p F P
0 0 0 r
s
.282 .414 .813 r
.48084 .40051 m .47765 .40051 L .45624 .41851 L p F P
0 0 0 r
s
.282 .414 .813 r
.45624 .41851 m .46249 .41851 L .48084 .40051 L p F P
0 0 0 r
s
1 .311 .131 r
.4561 .41449 m .45624 .41851 L .47765 .40051 L p F P
0 0 0 r
s
.83 .24 .1 r
.45657 .41717 m
.45672 .42163 L
s
.921 .272 .118 r
.5439 .41449 m .54376 .41851 L .52235 .40051 L p F P
0 0 0 r
s
.83 .24 .1 r
.54328 .42163 m
.54343 .41717 L
s
.45657 .41717 m
.46715 .41544 L
s
.53285 .41544 m
.54343 .41717 L
s
1 .33 .134 r
.37224 .49173 m .37341 .50265 L .3854 .4825 L p F P
0 0 0 r
s
1 .33 .134 r
.3854 .4825 m .38445 .47245 L .37224 .49173 L p F P
0 0 0 r
s
.465 .141 .068 r
.6146 .4825 m .61555 .47245 L .62776 .49173 L p F P
0 0 0 r
s
.465 .141 .068 r
.62776 .49173 m .62659 .50265 L .6146 .4825 L p F P
0 0 0 r
s
.24 .35 .67 r
.25652 .39591 m
.25948 .41926 L
s
.21939 .41926 m
.21594 .39591 L
s
.25948 .41926 m
.21939 .41926 L
s
.2971 .39591 m
.29957 .41926 L
s
.29957 .41926 m
.25948 .41926 L
s
.33768 .39591 m
.33965 .41926 L
s
.33965 .41926 m
.29957 .41926 L
s
.37826 .39591 m
.37974 .41926 L
s
.37974 .41926 m
.33965 .41926 L
s
.41983 .41926 m
.37974 .41926 L
s
.45295 .41926 m
.45991 .41926 L
s
.41983 .41926 m
.4479 .41926 L
s
.5 .41926 m
.45991 .41926 L
s
.54009 .41926 m
.5 .41926 L
s
.54009 .41926 m
.54705 .41926 L
s
.5521 .41926 m
.58017 .41926 L
s
.62174 .39591 m
.62026 .41926 L
s
.62026 .41926 m
.58017 .41926 L
s
.66232 .39591 m
.66035 .41926 L
s
.66035 .41926 m
.62026 .41926 L
s
.7029 .39591 m
.70043 .41926 L
s
.70043 .41926 m
.66035 .41926 L
s
.74348 .39591 m
.74052 .41926 L
s
.74052 .41926 m
.70043 .41926 L
s
.78406 .39591 m
.78061 .41926 L
s
.78061 .41926 m
.74052 .41926 L
s
.7 .195 .071 r
.35714 .59157 m .35859 .60276 L .35816 .58511 L p F P
0 0 0 r
s
.7 .195 .071 r
.35816 .58511 m .35669 .5737 L .35714 .59157 L p F P
0 0 0 r
s
.206 .282 .55 r
.64184 .58511 m .62158 .58511 L .62121 .60276 L p F P
0 0 0 r
s
.83 .24 .1 r
.63912 .5954 m
.64025 .58647 L
s
.206 .282 .55 r
.62121 .60276 m .64141 .60276 L .64184 .58511 L p F P
0 0 0 r
s
.83 .24 .1 r
.63758 .61984 m
.63865 .60276 L
s
.206 .282 .55 r
.62158 .58511 m .60132 .58511 L .601 .60276 L p F P
0 0 0 r
s
.206 .282 .55 r
.601 .60276 m .62121 .60276 L .62158 .58511 L p F P
0 0 0 r
s
.206 .282 .55 r
.60132 .58511 m .58105 .58511 L .5808 .60276 L p F P
0 0 0 r
s
.206 .282 .55 r
.5808 .60276 m .601 .60276 L .60132 .58511 L p F P
0 0 0 r
s
.206 .282 .55 r
.58105 .58511 m .56079 .58511 L .5606 .60276 L p F P
0 0 0 r
s
.206 .282 .55 r
.5606 .60276 m .5808 .60276 L .58105 .58511 L p F P
0 0 0 r
s
.206 .282 .55 r
.56079 .58511 m .54053 .58511 L .5404 .60276 L p F P
0 0 0 r
s
.206 .282 .55 r
.5404 .60276 m .5606 .60276 L .56079 .58511 L p F P
0 0 0 r
s
.206 .282 .55 r
.54053 .58511 m .52026 .58511 L .5202 .60276 L p F P
0 0 0 r
s
.206 .282 .55 r
.5202 .60276 m .5404 .60276 L .54053 .58511 L p F P
0 0 0 r
s
.206 .282 .55 r
.52026 .58511 m .5 .58511 L .5 .60276 L p F P
0 0 0 r
s
.206 .282 .55 r
.5 .60276 m .5202 .60276 L .52026 .58511 L p F P
0 0 0 r
s
.206 .282 .55 r
.5 .58511 m .47974 .58511 L .4798 .60276 L p F P
0 0 0 r
s
.206 .282 .55 r
.4798 .60276 m .5 .60276 L .5 .58511 L p F P
0 0 0 r
s
.206 .282 .55 r
.47974 .58511 m .45947 .58511 L .4596 .60276 L p F P
0 0 0 r
s
.206 .282 .55 r
.4596 .60276 m .4798 .60276 L .47974 .58511 L p F P
0 0 0 r
s
.206 .282 .55 r
.45947 .58511 m .43921 .58511 L .4394 .60276 L p F P
0 0 0 r
s
.206 .282 .55 r
.4394 .60276 m .4596 .60276 L .45947 .58511 L p F P
0 0 0 r
s
.206 .282 .55 r
.43921 .58511 m .41895 .58511 L .4192 .60276 L p F P
0 0 0 r
s
.206 .282 .55 r
.4192 .60276 m .4394 .60276 L .43921 .58511 L p F P
0 0 0 r
s
.206 .282 .55 r
.41895 .58511 m .39868 .58511 L .399 .60276 L p F P
0 0 0 r
s
.206 .282 .55 r
.399 .60276 m .4192 .60276 L .41895 .58511 L p F P
0 0 0 r
s
.206 .282 .55 r
.39868 .58511 m .37842 .58511 L .37879 .60276 L p F P
0 0 0 r
s
.206 .282 .55 r
.37879 .60276 m .399 .60276 L .39868 .58511 L p F P
0 0 0 r
s
.206 .282 .55 r
.37842 .58511 m .35816 .58511 L .35859 .60276 L p F P
0 0 0 r
s
.206 .282 .55 r
.35859 .60276 m .37879 .60276 L .37842 .58511 L p F P
0 0 0 r
s
.83 .24 .1 r
.36135 .60276 m
.36242 .61984 L
s
.098 .028 .012 r
.64184 .58511 m .64331 .5737 L .64286 .59157 L p F P
0 0 0 r
s
.098 .028 .012 r
.64286 .59157 m .64141 .60276 L .64184 .58511 L p F P
0 0 0 r
s
1 .327 .136 r
.43557 .42645 m .43527 .42056 L .41628 .43652 L p F P
0 0 0 r
s
1 .32 .134 r
.43527 .42056 m .43557 .42645 L .45596 .41044 L p F P
0 0 0 r
s
1 .32 .134 r
.4561 .41449 m .45596 .41044 L .43557 .42645 L p F P
0 0 0 r
s
.86 .255 .111 r
.5439 .41449 m .54404 .41044 L .56443 .42645 L p F P
0 0 0 r
s
.86 .255 .111 r
.56473 .42056 m .56443 .42645 L .54404 .41044 L p F P
0 0 0 r
s
.789 .235 .104 r
.56443 .42645 m .56473 .42056 L .58372 .43652 L p F P
0 0 0 r
s
.83 .24 .1 r
.54342 .75144 m
.54432 .73204 L
s
.54342 .75144 m
.51472 .75692 L
s
.48528 .75692 m
.45658 .75144 L
s
.45658 .75144 m
.45568 .73204 L
s
.24 .35 .67 r
.2591 .58431 m
.21895 .58431 L
s
.29925 .58431 m
.2591 .58431 L
s
.3394 .58431 m
.29925 .58431 L
s
.35806 .58431 m
.37955 .58431 L
s
.3394 .58431 m
.35696 .58431 L
s
.4197 .58431 m
.37955 .58431 L
s
.45985 .58431 m
.4197 .58431 L
s
.5 .58431 m
.45985 .58431 L
s
.54015 .58431 m
.5 .58431 L
s
.5803 .58431 m
.54015 .58431 L
s
.62045 .58431 m
.5803 .58431 L
s
.62045 .58431 m
.64194 .58431 L
s
.64304 .58431 m
.6606 .58431 L
s
.70075 .58431 m
.6606 .58431 L
s
.7409 .58431 m
.70075 .58431 L
s
.78105 .58431 m
.7409 .58431 L
s
.2591 .58431 m
.25603 .6072 L
s
.21537 .6072 m
.21895 .58431 L
s
.29925 .58431 m
.29669 .6072 L
s
.3394 .58431 m
.33735 .6072 L
s
.6606 .58431 m
.66265 .6072 L
s
.70075 .58431 m
.70331 .6072 L
s
.7409 .58431 m
.74397 .6072 L
s
.78105 .58431 m
.78463 .6072 L
s
.921 .272 .118 r
.52235 .40051 m .52239 .39843 L .5439 .41449 L p F P
0 0 0 r
s
.921 .272 .118 r
.54404 .41044 m .5439 .41449 L .52239 .39843 L p F P
0 0 0 r
s
.24 .35 .67 r
.54009 .41926 m
.54027 .41076 L
s
1 .311 .131 r
.45596 .41044 m .4561 .41449 L .47761 .39843 L p F P
0 0 0 r
s
1 .311 .131 r
.47765 .40051 m .47761 .39843 L .4561 .41449 L p F P
0 0 0 r
s
.24 .35 .67 r
.45973 .41076 m
.45991 .41926 L
s
.83 .24 .1 r
.40511 .70587 m
.38621 .68669 L
s
.38621 .68669 m
.38386 .66594 L
s
.61379 .68669 m
.61614 .66594 L
s
.61379 .68669 m
.59489 .70587 L
s
.37013 .64374 m
.36242 .61984 L
s
.63758 .61984 m
.62987 .64374 L
s
1 .318 .127 r
.3629 .51137 m .36424 .52289 L .37341 .50265 L p F P
0 0 0 r
s
1 .318 .127 r
.37341 .50265 m .37224 .49173 L .3629 .51137 L p F P
0 0 0 r
s
.83 .24 .1 r
.37049 .50248 m
.37308 .52624 L
s
.332 .1 .051 r
.62659 .50265 m .62776 .49173 L .6371 .51137 L p F P
0 0 0 r
s
.332 .1 .051 r
.6371 .51137 m .63576 .52289 L .62659 .50265 L p F P
0 0 0 r
s
.83 .24 .1 r
.62692 .52624 m
.62951 .50248 L
s
.899 .254 .097 r
.3552 .56206 m .35669 .5737 L .35954 .55444 L p F P
0 0 0 r
s
.83 .24 .1 r
.35804 .57301 m
.35958 .58511 L
s
.899 .254 .097 r
.35954 .55444 m .35811 .54283 L .3552 .56206 L p F P
0 0 0 r
s
.83 .24 .1 r
.35804 .57301 m
.36267 .54885 L
s
.181 .052 .027 r
.64046 .55444 m .64189 .54283 L .6448 .56206 L p F P
0 0 0 r
s
.181 .052 .027 r
.6448 .56206 m .64331 .5737 L .64046 .55444 L p F P
0 0 0 r
s
.83 .24 .1 r
.63733 .54885 m
.64196 .57301 L
s
.64042 .58511 m
.64196 .57301 L
s
.51472 .75692 m
.51503 .73759 L
s
.51472 .75692 m
.48528 .75692 L
s
.48528 .75692 m
.48497 .73759 L
s
1 .332 .137 r
.39849 .4449 m .39923 .45393 L .41628 .43652 L p F P
0 0 0 r
s
1 .332 .137 r
.41628 .43652 m .41578 .42892 L .39849 .4449 L p F P
0 0 0 r
s
1 .327 .136 r
.41578 .42892 m .41628 .43652 L .43527 .42056 L p F P
0 0 0 r
s
.789 .235 .104 r
.58422 .42892 m .58372 .43652 L .56473 .42056 L p F P
0 0 0 r
s
.702 .21 .094 r
.58372 .43652 m .58422 .42892 L .60151 .4449 L p F P
0 0 0 r
s
.702 .21 .094 r
.60151 .4449 m .60077 .45393 L .58372 .43652 L p F P
0 0 0 r
s
1 .334 .136 r
.38348 .46224 m .38445 .47245 L .39923 .45393 L p F P
0 0 0 r
s
1 .334 .136 r
.39923 .45393 m .39849 .4449 L .38348 .46224 L p F P
0 0 0 r
s
.597 .179 .083 r
.60077 .45393 m .60151 .4449 L .61652 .46224 L p F P
0 0 0 r
s
.597 .179 .083 r
.61652 .46224 m .61555 .47245 L .60077 .45393 L p F P
0 0 0 r
s
1 .32 .134 r
.45596 .41044 m .45582 .40637 L .43527 .42056 L p F P
0 0 0 r
s
1 .311 .131 r
.45582 .40637 m .45596 .41044 L .47757 .39634 L p F P
0 0 0 r
s
1 .311 .131 r
.47761 .39843 m .47757 .39634 L .45596 .41044 L p F P
0 0 0 r
s
.921 .272 .118 r
.52239 .39843 m .52243 .39634 L .54404 .41044 L p F P
0 0 0 r
s
.921 .272 .118 r
.54418 .40637 m .54404 .41044 L .52243 .39634 L p F P
0 0 0 r
s
.86 .255 .111 r
.54404 .41044 m .54418 .40637 L .56473 .42056 L p F P
0 0 0 r
s
1 .327 .136 r
.43527 .42056 m .43497 .41462 L .41578 .42892 L p F P
0 0 0 r
s
.83 .24 .1 r
.42941 .42639 m
.43054 .4466 L
s
1 .32 .134 r
.43497 .41462 m .43527 .42056 L .45582 .40637 L p F P
0 0 0 r
s
.83 .24 .1 r
.42941 .42639 m
.45657 .41717 L
s
.86 .255 .111 r
.56503 .41462 m .56473 .42056 L .54418 .40637 L p F P
0 0 0 r
s
.789 .235 .104 r
.56473 .42056 m .56503 .41462 L .58422 .42892 L p F P
0 0 0 r
s
.83 .24 .1 r
.54343 .41717 m
.57059 .42639 L
s
.56946 .4466 m
.57059 .42639 L
s
1 .295 .116 r
.35664 .53099 m .35811 .54283 L .36424 .52289 L p F P
0 0 0 r
s
1 .295 .116 r
.36424 .52289 m .3629 .51137 L .35664 .53099 L p F P
0 0 0 r
s
.249 .072 .039 r
.63576 .52289 m .6371 .51137 L .64336 .53099 L p F P
0 0 0 r
s
.249 .072 .039 r
.64336 .53099 m .64189 .54283 L .63576 .52289 L p F P
0 0 0 r
s
1 .33 .134 r
.37106 .4806 m .37224 .49173 L .38445 .47245 L p F P
0 0 0 r
s
.83 .24 .1 r
.37049 .50248 m
.38641 .48212 L
s
1 .33 .134 r
.38445 .47245 m .38348 .46224 L .37106 .4806 L p F P
0 0 0 r
s
.465 .141 .068 r
.61555 .47245 m .61652 .46224 L .62894 .4806 L p F P
0 0 0 r
s
.465 .141 .068 r
.62894 .4806 m .62776 .49173 L .61555 .47245 L p F P
0 0 0 r
s
.83 .24 .1 r
.61359 .48212 m
.62951 .50248 L
s
.973 .287 .123 r
.52239 .39843 m .52235 .40051 L .5 .38446 L closepath p F P
0 0 0 r
s
.287 .424 .832 r
.51916 .40051 m .52235 .40051 L .5 .38446 L closepath p F P
0 0 0 r
s
.287 .424 .832 r
.51597 .40051 m .51916 .40051 L .5 .38446 L closepath p F P
0 0 0 r
s
.287 .424 .832 r
.51277 .40051 m .51597 .40051 L .5 .38446 L closepath p F P
0 0 0 r
s
.287 .424 .832 r
.50958 .40051 m .51277 .40051 L .5 .38446 L closepath p F P
0 0 0 r
s
.287 .424 .832 r
.50639 .40051 m .50958 .40051 L .5 .38446 L closepath p F P
0 0 0 r
s
.287 .424 .832 r
.50319 .40051 m .50639 .40051 L .5 .38446 L closepath p F P
0 0 0 r
s
.287 .424 .832 r
.5 .40051 m .50319 .40051 L .5 .38446 L closepath p F P
0 0 0 r
s
.287 .424 .832 r
.49681 .40051 m .5 .40051 L .5 .38446 L closepath p F P
0 0 0 r
s
.287 .424 .832 r
.49361 .40051 m .49681 .40051 L .5 .38446 L closepath p F P
0 0 0 r
s
.287 .424 .832 r
.49042 .40051 m .49361 .40051 L .5 .38446 L closepath p F P
0 0 0 r
s
.287 .424 .832 r
.48723 .40051 m .49042 .40051 L .5 .38446 L closepath p F P
0 0 0 r
s
.287 .424 .832 r
.48403 .40051 m .48723 .40051 L .5 .38446 L closepath p F P
0 0 0 r
s
.287 .424 .832 r
.48084 .40051 m .48403 .40051 L .5 .38446 L closepath p F P
0 0 0 r
s
.287 .424 .832 r
.47765 .40051 m .48084 .40051 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.5 .38446 m .47761 .39843 L .47765 .40051 L closepath p F P
0 0 0 r
s
1 .32 .134 r
.45582 .40637 m .45568 .40227 L .43497 .41462 L p F P
0 0 0 r
s
1 .311 .131 r
.45568 .40227 m .45582 .40637 L .47754 .39425 L p F P
0 0 0 r
s
.24 .35 .67 r
.4596 .40426 m
.4596 .40463 L
s
1 .311 .131 r
.47757 .39634 m .47754 .39425 L .45582 .40637 L p F P
0 0 0 r
s
.921 .272 .118 r
.52243 .39634 m .52246 .39425 L .54418 .40637 L p F P
0 0 0 r
s
.921 .272 .118 r
.54432 .40227 m .54418 .40637 L .52246 .39425 L p F P
0 0 0 r
s
.86 .255 .111 r
.54418 .40637 m .54432 .40227 L .56503 .41462 L p F P
0 0 0 r
s
.973 .287 .123 r
.52243 .39634 m .52239 .39843 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.5 .38446 m .47757 .39634 L .47761 .39843 L closepath p F P
0 0 0 r
s
.187 .251 .489 r
.37879 .60276 m .35859 .60276 L .36234 .61838 L p F P
0 0 0 r
s
.157 .045 .023 r
.36096 .60765 m .36234 .61838 L .35859 .60276 L p F P
0 0 0 r
s
.83 .24 .1 r
.36211 .61742 m
.36242 .61984 L
s
.157 .045 .023 r
.35859 .60276 m .35714 .59157 L .36096 .60765 L p F P
0 0 0 r
s
.187 .251 .489 r
.64141 .60276 m .62121 .60276 L .618 .61838 L p F P
0 0 0 r
s
.187 .251 .489 r
.618 .61838 m .63766 .61838 L .64141 .60276 L p F P
0 0 0 r
s
.83 .24 .1 r
.63758 .61984 m
.63789 .61742 L
s
.187 .251 .489 r
.62121 .60276 m .601 .60276 L .59833 .61838 L p F P
0 0 0 r
s
.187 .251 .489 r
.59833 .61838 m .618 .61838 L .62121 .60276 L p F P
0 0 0 r
s
.24 .35 .67 r
.62045 .58431 m
.62199 .6072 L
s
.187 .251 .489 r
.601 .60276 m .5808 .60276 L .57866 .61838 L p F P
0 0 0 r
s
.187 .251 .489 r
.57866 .61838 m .59833 .61838 L .601 .60276 L p F P
0 0 0 r
s
.187 .251 .489 r
.5808 .60276 m .5606 .60276 L .559 .61838 L p F P
0 0 0 r
s
.187 .251 .489 r
.559 .61838 m .57866 .61838 L .5808 .60276 L p F P
0 0 0 r
s
.24 .35 .67 r
.5803 .58431 m
.58132 .6072 L
s
.187 .251 .489 r
.5606 .60276 m .5404 .60276 L .53933 .61838 L p F P
0 0 0 r
s
.187 .251 .489 r
.53933 .61838 m .559 .61838 L .5606 .60276 L p F P
0 0 0 r
s
.187 .251 .489 r
.5404 .60276 m .5202 .60276 L .51967 .61838 L p F P
0 0 0 r
s
.187 .251 .489 r
.51967 .61838 m .53933 .61838 L .5404 .60276 L p F P
0 0 0 r
s
.24 .35 .67 r
.54015 .58431 m
.54066 .6072 L
s
.187 .251 .489 r
.5202 .60276 m .5 .60276 L .5 .61838 L p F P
0 0 0 r
s
.187 .251 .489 r
.5 .61838 m .51967 .61838 L .5202 .60276 L p F P
0 0 0 r
s
.187 .251 .489 r
.5 .60276 m .4798 .60276 L .48033 .61838 L p F P
0 0 0 r
s
.187 .251 .489 r
.48033 .61838 m .5 .61838 L .5 .60276 L p F P
0 0 0 r
s
.24 .35 .67 r
.5 .58431 m
.5 .6072 L
s
.187 .251 .489 r
.4798 .60276 m .4596 .60276 L .46067 .61838 L p F P
0 0 0 r
s
.187 .251 .489 r
.46067 .61838 m .48033 .61838 L .4798 .60276 L p F P
0 0 0 r
s
.187 .251 .489 r
.4596 .60276 m .4394 .60276 L .441 .61838 L p F P
0 0 0 r
s
.187 .251 .489 r
.441 .61838 m .46067 .61838 L .4596 .60276 L p F P
0 0 0 r
s
.24 .35 .67 r
.45934 .6072 m
.45985 .58431 L
s
.187 .251 .489 r
.4394 .60276 m .4192 .60276 L .42134 .61838 L p F P
0 0 0 r
s
.187 .251 .489 r
.42134 .61838 m .441 .61838 L .4394 .60276 L p F P
0 0 0 r
s
.187 .251 .489 r
.4192 .60276 m .399 .60276 L .40167 .61838 L p F P
0 0 0 r
s
.187 .251 .489 r
.40167 .61838 m .42134 .61838 L .4192 .60276 L p F P
0 0 0 r
s
.24 .35 .67 r
.41868 .6072 m
.4197 .58431 L
s
.187 .251 .489 r
.399 .60276 m .37879 .60276 L .382 .61838 L p F P
0 0 0 r
s
.187 .251 .489 r
.382 .61838 m .40167 .61838 L .399 .60276 L p F P
0 0 0 r
s
.187 .251 .489 r
.36234 .61838 m .382 .61838 L .37879 .60276 L p F P
0 0 0 r
s
.24 .35 .67 r
.37801 .6072 m
.37955 .58431 L
s
.796 .229 .086 r
.64141 .60276 m .64286 .59157 L .63904 .60765 L p F P
0 0 0 r
s
.796 .229 .086 r
.63904 .60765 m .63766 .61838 L .64141 .60276 L p F P
0 0 0 r
s
1 .327 .136 r
.41526 .42122 m .41578 .42892 L .43497 .41462 L p F P
0 0 0 r
s
1 .327 .136 r
.43497 .41462 m .43466 .40861 L .41526 .42122 L p F P
0 0 0 r
s
.24 .35 .67 r
.41884 .39591 m
.41979 .41828 L
s
1 .32 .134 r
.43466 .40861 m .43497 .41462 L .45568 .40227 L p F P
0 0 0 r
s
.86 .255 .111 r
.56534 .40861 m .56503 .41462 L .54432 .40227 L p F P
0 0 0 r
s
.789 .235 .104 r
.56503 .41462 m .56534 .40861 L .58474 .42122 L p F P
0 0 0 r
s
.789 .235 .104 r
.58474 .42122 m .58422 .42892 L .56503 .41462 L p F P
0 0 0 r
s
.24 .35 .67 r
.58021 .41828 m
.58116 .39591 L
s
.83 .24 .1 r
.59489 .70587 m
.59687 .68534 L
s
.59489 .70587 m
.57138 .72127 L
s
.42862 .72127 m
.40511 .70587 L
s
.40511 .70587 m
.40313 .68534 L
s
1 .332 .137 r
.39775 .43573 m .39849 .4449 L .41578 .42892 L p F P
0 0 0 r
s
.83 .24 .1 r
.40491 .43988 m
.40682 .46496 L
s
1 .332 .137 r
.41578 .42892 m .41526 .42122 L .39775 .43573 L p F P
0 0 0 r
s
.83 .24 .1 r
.40491 .43988 m
.42941 .42639 L
s
.702 .21 .094 r
.58422 .42892 m .58474 .42122 L .60225 .43573 L p F P
0 0 0 r
s
.702 .21 .094 r
.60225 .43573 m .60151 .4449 L .58422 .42892 L p F P
0 0 0 r
s
.83 .24 .1 r
.57059 .42639 m
.59509 .43988 L
s
.59318 .46496 m
.59509 .43988 L
s
.7 .195 .071 r
.35566 .58015 m .35714 .59157 L .35669 .5737 L p F P
0 0 0 r
s
.7 .195 .071 r
.35669 .5737 m .3552 .56206 L .35566 .58015 L p F P
0 0 0 r
s
.098 .028 .012 r
.64331 .5737 m .6448 .56206 L .64434 .58015 L p F P
0 0 0 r
s
.098 .028 .012 r
.64434 .58015 m .64286 .59157 L .64331 .5737 L p F P
0 0 0 r
s
1 .3 .128 r
.5 .38446 m .47754 .39425 L .47757 .39634 L closepath p F P
0 0 0 r
s
.973 .287 .123 r
.52246 .39425 m .52243 .39634 L .5 .38446 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.5 .39591 m
.5 .41926 L
s
1 .318 .127 r
.36153 .49961 m .3629 .51137 L .37224 .49173 L p F P
0 0 0 r
s
1 .318 .127 r
.37224 .49173 m .37106 .4806 L .36153 .49961 L p F P
0 0 0 r
s
.332 .1 .051 r
.62776 .49173 m .62894 .4806 L .63847 .49961 L p F P
0 0 0 r
s
.332 .1 .051 r
.63847 .49961 m .6371 .51137 L .62776 .49173 L p F P
0 0 0 r
s
1 .32 .134 r
.45568 .40227 m .45554 .39815 L .43466 .40861 L p F P
0 0 0 r
s
1 .311 .131 r
.45554 .39815 m .45568 .40227 L .4775 .39215 L p F P
0 0 0 r
s
.24 .35 .67 r
.45952 .40049 m
.45952 .40086 L
s
1 .311 .131 r
.47754 .39425 m .4775 .39215 L .45568 .40227 L p F P
0 0 0 r
s
.24 .35 .67 r
.45942 .39591 m
.45945 .39708 L
s
.921 .272 .118 r
.52246 .39425 m .5225 .39215 L .54432 .40227 L p F P
0 0 0 r
s
.921 .272 .118 r
.54446 .39815 m .54432 .40227 L .5225 .39215 L p F P
0 0 0 r
s
.24 .35 .67 r
.54055 .39708 m
.54058 .39591 L
s
.86 .255 .111 r
.54432 .40227 m .54446 .39815 L .56534 .40861 L p F P
0 0 0 r
s
.24 .35 .67 r
.25282 .37624 m
.25652 .39591 L
s
.21594 .39591 m
.21163 .37624 L
s
.25652 .39591 m
.21594 .39591 L
s
.29402 .37624 m
.2971 .39591 L
s
.2971 .39591 m
.25652 .39591 L
s
.33522 .37624 m
.33768 .39591 L
s
.33768 .39591 m
.2971 .39591 L
s
.37641 .37624 m
.37826 .39591 L
s
.37826 .39591 m
.33768 .39591 L
s
.41884 .39591 m
.37826 .39591 L
s
.41884 .39591 m
.45942 .39591 L
s
.4757 .39591 m
.5 .39591 L
s
.45942 .39591 m
.46374 .39591 L
s
.5 .39591 m
.5243 .39591 L
s
.53626 .39591 m
.54058 .39591 L
s
.54058 .39591 m
.58116 .39591 L
s
.62359 .37624 m
.62174 .39591 L
s
.62174 .39591 m
.58116 .39591 L
s
.66478 .37624 m
.66232 .39591 L
s
.66232 .39591 m
.62174 .39591 L
s
.70598 .37624 m
.7029 .39591 L
s
.7029 .39591 m
.66232 .39591 L
s
.74718 .37624 m
.74348 .39591 L
s
.74348 .39591 m
.7029 .39591 L
s
.78837 .37624 m
.78406 .39591 L
s
.78406 .39591 m
.74348 .39591 L
s
1 .334 .136 r
.38249 .45184 m .38348 .46224 L .39849 .4449 L p F P
0 0 0 r
s
.83 .24 .1 r
.38407 .45718 m
.38641 .48212 L
s
1 .334 .136 r
.39849 .4449 m .39775 .43573 L .38249 .45184 L p F P
0 0 0 r
s
.597 .179 .083 r
.60151 .4449 m .60225 .43573 L .61751 .45184 L p F P
0 0 0 r
s
.597 .179 .083 r
.61751 .45184 m .61652 .46224 L .60151 .4449 L p F P
0 0 0 r
s
.83 .24 .1 r
.61359 .48212 m
.61593 .45718 L
s
1 .3 .128 r
.5 .38446 m .4775 .39215 L .47754 .39425 L closepath p F P
0 0 0 r
s
.973 .287 .123 r
.5225 .39215 m .52246 .39425 L .5 .38446 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.38386 .66594 m
.37013 .64374 L
s
.62987 .64374 m
.61614 .66594 L
s
.899 .254 .097 r
.35368 .55017 m .3552 .56206 L .35811 .54283 L p F P
0 0 0 r
s
.899 .254 .097 r
.35811 .54283 m .35664 .53099 L .35368 .55017 L p F P
0 0 0 r
s
.181 .052 .027 r
.64189 .54283 m .64336 .53099 L .64632 .55017 L p F P
0 0 0 r
s
.181 .052 .027 r
.64632 .55017 m .6448 .56206 L .64189 .54283 L p F P
0 0 0 r
s
.24 .35 .67 r
.25603 .6072 m
.21537 .6072 L
s
.29669 .6072 m
.25603 .6072 L
s
.33735 .6072 m
.29669 .6072 L
s
.33735 .6072 m
.35972 .6072 L
s
.36085 .6072 m
.37801 .6072 L
s
.37801 .6072 m
.41868 .6072 L
s
.41868 .6072 m
.45934 .6072 L
s
.45934 .6072 m
.5 .6072 L
s
.5 .6072 m
.54066 .6072 L
s
.54066 .6072 m
.58132 .6072 L
s
.58132 .6072 m
.62199 .6072 L
s
.64028 .6072 m
.66265 .6072 L
s
.62199 .6072 m
.63915 .6072 L
s
.70331 .6072 m
.66265 .6072 L
s
.74397 .6072 m
.70331 .6072 L
s
.78463 .6072 m
.74397 .6072 L
s
.25603 .6072 m
.25223 .62625 L
s
.21094 .62625 m
.21537 .6072 L
s
.29669 .6072 m
.29353 .62625 L
s
.33735 .6072 m
.33482 .62625 L
s
.66265 .6072 m
.66518 .62625 L
s
.70331 .6072 m
.70647 .62625 L
s
.74397 .6072 m
.74777 .62625 L
s
.78463 .6072 m
.78906 .62625 L
s
1 .311 .131 r
.4775 .39215 m .47747 .39004 L .45554 .39815 L p F P
0 0 0 r
s
1 .3 .128 r
.5 .38446 m .47747 .39004 L .4775 .39215 L closepath p F P
0 0 0 r
s
.973 .287 .123 r
.52253 .39004 m .5225 .39215 L .5 .38446 L closepath p F P
0 0 0 r
s
.921 .272 .118 r
.5225 .39215 m .52253 .39004 L .54446 .39815 L p F P
0 0 0 r
s
1 .32 .134 r
.43435 .40255 m .43466 .40861 L .45554 .39815 L p F P
0 0 0 r
s
1 .32 .134 r
.45554 .39815 m .45539 .394 L .43435 .40255 L p F P
0 0 0 r
s
1 .311 .131 r
.45539 .394 m .45554 .39815 L .47747 .39004 L p F P
0 0 0 r
s
.921 .272 .118 r
.54461 .394 m .54446 .39815 L .52253 .39004 L p F P
0 0 0 r
s
.86 .255 .111 r
.54446 .39815 m .54461 .394 L .56565 .40255 L p F P
0 0 0 r
s
.86 .255 .111 r
.56565 .40255 m .56534 .40861 L .54446 .39815 L p F P
0 0 0 r
s
1 .327 .136 r
.41474 .41343 m .41526 .42122 L .43466 .40861 L p F P
0 0 0 r
s
1 .327 .136 r
.43466 .40861 m .43435 .40255 L .41474 .41343 L p F P
0 0 0 r
s
.789 .235 .104 r
.56534 .40861 m .56565 .40255 L .58526 .41343 L p F P
0 0 0 r
s
.789 .235 .104 r
.58526 .41343 m .58474 .42122 L .56534 .40861 L p F P
0 0 0 r
s
1 .33 .134 r
.36985 .46926 m .37106 .4806 L .38348 .46224 L p F P
0 0 0 r
s
1 .33 .134 r
.38348 .46224 m .38249 .45184 L .36985 .46926 L p F P
0 0 0 r
s
.465 .141 .068 r
.61652 .46224 m .61751 .45184 L .63015 .46926 L p F P
0 0 0 r
s
.465 .141 .068 r
.63015 .46926 m .62894 .4806 L .61652 .46224 L p F P
0 0 0 r
s
1 .311 .131 r
.47747 .39004 m .47743 .38793 L .45539 .394 L p F P
0 0 0 r
s
1 .3 .128 r
.5 .38446 m .47743 .38793 L .47747 .39004 L closepath p F P
0 0 0 r
s
.973 .287 .123 r
.52257 .38793 m .52253 .39004 L .5 .38446 L closepath p F P
0 0 0 r
s
.921 .272 .118 r
.52253 .39004 m .52257 .38793 L .54461 .394 L p F P
0 0 0 r
s
1 .295 .116 r
.35515 .51889 m .35664 .53099 L .3629 .51137 L p F P
0 0 0 r
s
.83 .24 .1 r
.35984 .52529 m
.36267 .54885 L
s
1 .295 .116 r
.3629 .51137 m .36153 .49961 L .35515 .51889 L p F P
0 0 0 r
s
.83 .24 .1 r
.35984 .52529 m
.37049 .50248 L
s
.249 .072 .039 r
.6371 .51137 m .63847 .49961 L .64485 .51889 L p F P
0 0 0 r
s
.249 .072 .039 r
.64485 .51889 m .64336 .53099 L .6371 .51137 L p F P
0 0 0 r
s
.83 .24 .1 r
.62951 .50248 m
.64016 .52529 L
s
.63733 .54885 m
.64016 .52529 L
s
1 .332 .137 r
.39699 .42642 m .39775 .43573 L .41526 .42122 L p F P
0 0 0 r
s
1 .332 .137 r
.41526 .42122 m .41474 .41343 L .39699 .42642 L p F P
0 0 0 r
s
.702 .21 .094 r
.58474 .42122 m .58526 .41343 L .60301 .42642 L p F P
0 0 0 r
s
.702 .21 .094 r
.60301 .42642 m .60225 .43573 L .58474 .42122 L p F P
0 0 0 r
s
.83 .24 .1 r
.57138 .72127 m
.57288 .70093 L
s
.57138 .72127 m
.54432 .73204 L
s
.45568 .73204 m
.42862 .72127 L
s
.42862 .72127 m
.42712 .70093 L
s
1 .311 .131 r
.45525 .38982 m .45539 .394 L .47743 .38793 L p F P
0 0 0 r
s
.83 .24 .1 r
.45568 .39087 m
.45657 .41717 L
s
1 .311 .131 r
.47743 .38793 m .47739 .38581 L .45525 .38982 L p F P
0 0 0 r
s
1 .3 .128 r
.5 .38446 m .47739 .38581 L .47743 .38793 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.48504 .38615 m
.48522 .40205 L
s
.973 .287 .123 r
.52261 .38581 m .52257 .38793 L .5 .38446 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.51478 .40205 m
.51496 .38615 L
s
.921 .272 .118 r
.52257 .38793 m .52261 .38581 L .54475 .38982 L p F P
0 0 0 r
s
.24 .35 .67 r
.54067 .39292 m
.54078 .38948 L
s
.921 .272 .118 r
.54475 .38982 m .54461 .394 L .52257 .38793 L p F P
0 0 0 r
s
.83 .24 .1 r
.54343 .41717 m
.54432 .39087 L
s
1 .32 .134 r
.43404 .39644 m .43435 .40255 L .45539 .394 L p F P
0 0 0 r
s
1 .32 .134 r
.45539 .394 m .45525 .38982 L .43404 .39644 L p F P
0 0 0 r
s
.86 .255 .111 r
.54461 .394 m .54475 .38982 L .56596 .39644 L p F P
0 0 0 r
s
.86 .255 .111 r
.56596 .39644 m .56565 .40255 L .54461 .394 L p F P
0 0 0 r
s
.289 .431 .847 r
.5 .38446 m .47713 .37077 L .4804 .37077 L closepath p F P
0 0 0 r
s
.289 .431 .847 r
.5 .38446 m .4804 .37077 L .48367 .37077 L closepath p F P
0 0 0 r
s
.289 .431 .847 r
.5 .38446 m .48367 .37077 L .48693 .37077 L closepath p F P
0 0 0 r
s
.289 .431 .847 r
.5 .38446 m .48693 .37077 L .4902 .37077 L closepath p F P
0 0 0 r
s
.289 .431 .847 r
.5 .38446 m .4902 .37077 L .49347 .37077 L closepath p F P
0 0 0 r
s
.289 .431 .847 r
.5 .38446 m .49347 .37077 L .49673 .37077 L closepath p F P
0 0 0 r
s
.289 .431 .847 r
.5 .38446 m .49673 .37077 L .5 .37077 L closepath p F P
0 0 0 r
s
.289 .431 .847 r
.5 .38446 m .5 .37077 L .50327 .37077 L closepath p F P
0 0 0 r
s
.289 .431 .847 r
.5 .38446 m .50327 .37077 L .50653 .37077 L closepath p F P
0 0 0 r
s
.289 .431 .847 r
.5 .38446 m .50653 .37077 L .5098 .37077 L closepath p F P
0 0 0 r
s
.289 .431 .847 r
.5 .38446 m .5098 .37077 L .51307 .37077 L closepath p F P
0 0 0 r
s
.289 .431 .847 r
.5 .38446 m .51307 .37077 L .51633 .37077 L closepath p F P
0 0 0 r
s
.289 .431 .847 r
.5 .38446 m .51633 .37077 L .5196 .37077 L closepath p F P
0 0 0 r
s
.289 .431 .847 r
.5 .38446 m .5196 .37077 L .52287 .37077 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.5 .38446 m .47713 .37077 L .47717 .37294 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.5 .38446 m .47717 .37294 L .47721 .3751 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.5 .38446 m .47721 .3751 L .47724 .37726 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.5 .38446 m .47724 .37726 L .47728 .37941 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.5 .38446 m .47728 .37941 L .47732 .38155 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.5 .38446 m .47732 .38155 L .47736 .38368 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.5 .38446 m .47736 .38368 L .47739 .38581 L closepath p F P
0 0 0 r
s
.973 .287 .123 r
.52264 .38368 m .52261 .38581 L .5 .38446 L closepath p F P
0 0 0 r
s
.973 .287 .123 r
.52268 .38155 m .52264 .38368 L .5 .38446 L closepath p F P
0 0 0 r
s
.973 .287 .123 r
.52272 .37941 m .52268 .38155 L .5 .38446 L closepath p F P
0 0 0 r
s
.973 .287 .123 r
.52276 .37726 m .52272 .37941 L .5 .38446 L closepath p F P
0 0 0 r
s
.973 .287 .123 r
.52279 .3751 m .52276 .37726 L .5 .38446 L closepath p F P
0 0 0 r
s
.973 .287 .123 r
.52283 .37294 m .52279 .3751 L .5 .38446 L closepath p F P
0 0 0 r
s
.973 .287 .123 r
.52287 .37077 m .52283 .37294 L .5 .38446 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.5 .37624 m
.5 .39591 L
s
1 .311 .131 r
.45511 .38562 m .45525 .38982 L .47739 .38581 L p F P
0 0 0 r
s
1 .311 .131 r
.47739 .38581 m .47736 .38368 L .45511 .38562 L p F P
0 0 0 r
s
.921 .272 .118 r
.52261 .38581 m .52264 .38368 L .54489 .38562 L p F P
0 0 0 r
s
.921 .272 .118 r
.54489 .38562 m .54475 .38982 L .52261 .38581 L p F P
0 0 0 r
s
.83 .24 .1 r
.45568 .39087 m
.48504 .38615 L
s
.48504 .38615 m
.51496 .38615 L
s
.51496 .38615 m
.54432 .39087 L
s
1 .327 .136 r
.41422 .40554 m .41474 .41343 L .43435 .40255 L p F P
0 0 0 r
s
1 .327 .136 r
.43435 .40255 m .43404 .39644 L .41422 .40554 L p F P
0 0 0 r
s
.789 .235 .104 r
.56565 .40255 m .56596 .39644 L .58578 .40554 L p F P
0 0 0 r
s
.789 .235 .104 r
.58578 .40554 m .58526 .41343 L .56565 .40255 L p F P
0 0 0 r
s
1 .334 .136 r
.38149 .44128 m .38249 .45184 L .39775 .43573 L p F P
0 0 0 r
s
1 .334 .136 r
.39775 .43573 m .39699 .42642 L .38149 .44128 L p F P
0 0 0 r
s
.83 .24 .1 r
.38407 .45718 m
.40491 .43988 L
s
.597 .179 .083 r
.60225 .43573 m .60301 .42642 L .61851 .44128 L p F P
0 0 0 r
s
.597 .179 .083 r
.61851 .44128 m .61751 .45184 L .60225 .43573 L p F P
0 0 0 r
s
.83 .24 .1 r
.59509 .43988 m
.61593 .45718 L
s
.157 .045 .023 r
.35955 .5967 m .36096 .60765 L .35714 .59157 L p F P
0 0 0 r
s
.157 .045 .023 r
.35714 .59157 m .35566 .58015 L .35955 .5967 L p F P
0 0 0 r
s
.83 .24 .1 r
.35804 .57301 m
.3595 .59645 L
s
.796 .229 .086 r
.64286 .59157 m .64434 .58015 L .64045 .5967 L p F P
0 0 0 r
s
.796 .229 .086 r
.64045 .5967 m .63904 .60765 L .64286 .59157 L p F P
0 0 0 r
s
.83 .24 .1 r
.6405 .59645 m
.64196 .57301 L
s
1 .318 .127 r
.36014 .48762 m .36153 .49961 L .37106 .4806 L p F P
0 0 0 r
s
1 .318 .127 r
.37106 .4806 m .36985 .46926 L .36014 .48762 L p F P
0 0 0 r
s
.332 .1 .051 r
.62894 .4806 m .63015 .46926 L .63986 .48762 L p F P
0 0 0 r
s
.332 .1 .051 r
.63986 .48762 m .63847 .49961 L .62894 .4806 L p F P
0 0 0 r
s
.161 .21 .408 r
.63766 .61838 m .618 .61838 L .61192 .63157 L p F P
0 0 0 r
s
.161 .21 .408 r
.61192 .63157 m .63058 .63157 L .63766 .61838 L p F P
0 0 0 r
s
.24 .35 .67 r
.62199 .6072 m
.62388 .62625 L
s
.161 .21 .408 r
.618 .61838 m .59833 .61838 L .59327 .63157 L p F P
0 0 0 r
s
.161 .21 .408 r
.59327 .63157 m .61192 .63157 L .618 .61838 L p F P
0 0 0 r
s
.161 .21 .408 r
.59833 .61838 m .57866 .61838 L .57462 .63157 L p F P
0 0 0 r
s
.161 .21 .408 r
.57462 .63157 m .59327 .63157 L .59833 .61838 L p F P
0 0 0 r
s
.24 .35 .67 r
.58132 .6072 m
.58259 .62625 L
s
.161 .21 .408 r
.57866 .61838 m .559 .61838 L .55596 .63157 L p F P
0 0 0 r
s
.161 .21 .408 r
.55596 .63157 m .57462 .63157 L .57866 .61838 L p F P
0 0 0 r
s
.161 .21 .408 r
.559 .61838 m .53933 .61838 L .53731 .63157 L p F P
0 0 0 r
s
.161 .21 .408 r
.53731 .63157 m .55596 .63157 L .559 .61838 L p F P
0 0 0 r
s
.24 .35 .67 r
.54066 .6072 m
.54129 .62625 L
s
.161 .21 .408 r
.53933 .61838 m .51967 .61838 L .51865 .63157 L p F P
0 0 0 r
s
.161 .21 .408 r
.51865 .63157 m .53731 .63157 L .53933 .61838 L p F P
0 0 0 r
s
.161 .21 .408 r
.51967 .61838 m .5 .61838 L .5 .63157 L p F P
0 0 0 r
s
.161 .21 .408 r
.5 .63157 m .51865 .63157 L .51967 .61838 L p F P
0 0 0 r
s
.161 .21 .408 r
.5 .61838 m .48033 .61838 L .48135 .63157 L p F P
0 0 0 r
s
.161 .21 .408 r
.48135 .63157 m .5 .63157 L .5 .61838 L p F P
0 0 0 r
s
.24 .35 .67 r
.5 .6072 m
.5 .62625 L
s
.161 .21 .408 r
.48033 .61838 m .46067 .61838 L .46269 .63157 L p F P
0 0 0 r
s
.161 .21 .408 r
.46269 .63157 m .48135 .63157 L .48033 .61838 L p F P
0 0 0 r
s
.161 .21 .408 r
.46067 .61838 m .441 .61838 L .44404 .63157 L p F P
0 0 0 r
s
.161 .21 .408 r
.44404 .63157 m .46269 .63157 L .46067 .61838 L p F P
0 0 0 r
s
.24 .35 .67 r
.45871 .62625 m
.45934 .6072 L
s
.161 .21 .408 r
.441 .61838 m .42134 .61838 L .42538 .63157 L p F P
0 0 0 r
s
.161 .21 .408 r
.42538 .63157 m .44404 .63157 L .441 .61838 L p F P
0 0 0 r
s
.161 .21 .408 r
.42134 .61838 m .40167 .61838 L .40673 .63157 L p F P
0 0 0 r
s
.161 .21 .408 r
.40673 .63157 m .42538 .63157 L .42134 .61838 L p F P
0 0 0 r
s
.24 .35 .67 r
.41741 .62625 m
.41868 .6072 L
s
.161 .21 .408 r
.40167 .61838 m .382 .61838 L .38808 .63157 L p F P
0 0 0 r
s
.161 .21 .408 r
.38808 .63157 m .40673 .63157 L .40167 .61838 L p F P
0 0 0 r
s
.161 .21 .408 r
.382 .61838 m .36234 .61838 L .36942 .63157 L p F P
0 0 0 r
s
.161 .21 .408 r
.36942 .63157 m .38808 .63157 L .382 .61838 L p F P
0 0 0 r
s
.24 .35 .67 r
.37612 .62625 m
.37801 .6072 L
s
.236 .068 .036 r
.36818 .62152 m .36942 .63157 L .36234 .61838 L p F P
0 0 0 r
s
.83 .24 .1 r
.36838 .62964 m
.37013 .64374 L
s
.236 .068 .036 r
.36234 .61838 m .36096 .60765 L .36818 .62152 L p F P
0 0 0 r
s
.973 .282 .11 r
.63766 .61838 m .63904 .60765 L .63182 .62152 L p F P
0 0 0 r
s
.973 .282 .11 r
.63182 .62152 m .63058 .63157 L .63766 .61838 L p F P
0 0 0 r
s
.83 .24 .1 r
.62987 .64374 m
.63162 .62964 L
s
1 .311 .131 r
.45496 .38139 m .45511 .38562 L .47736 .38368 L p F P
0 0 0 r
s
1 .311 .131 r
.47736 .38368 m .47732 .38155 L .45496 .38139 L p F P
0 0 0 r
s
.921 .272 .118 r
.52264 .38368 m .52268 .38155 L .54504 .38139 L p F P
0 0 0 r
s
.921 .272 .118 r
.54504 .38139 m .54489 .38562 L .52264 .38368 L p F P
0 0 0 r
s
.7 .195 .071 r
.35414 .56849 m .35566 .58015 L .3552 .56206 L p F P
0 0 0 r
s
.7 .195 .071 r
.3552 .56206 m .35368 .55017 L .35414 .56849 L p F P
0 0 0 r
s
.098 .028 .012 r
.6448 .56206 m .64632 .55017 L .64586 .56849 L p F P
0 0 0 r
s
.098 .028 .012 r
.64586 .56849 m .64434 .58015 L .6448 .56206 L p F P
0 0 0 r
s
1 .32 .134 r
.43373 .39026 m .43404 .39644 L .45525 .38982 L p F P
0 0 0 r
s
1 .32 .134 r
.45525 .38982 m .45511 .38562 L .43373 .39026 L p F P
0 0 0 r
s
.86 .255 .111 r
.54475 .38982 m .54489 .38562 L .56627 .39026 L p F P
0 0 0 r
s
.86 .255 .111 r
.56627 .39026 m .56596 .39644 L .54475 .38982 L p F P
0 0 0 r
s
.83 .24 .1 r
.54432 .73204 m
.54525 .71183 L
s
.54432 .73204 m
.51503 .73759 L
s
.48497 .73759 m
.45568 .73204 L
s
.45568 .73204 m
.45475 .71183 L
s
1 .311 .131 r
.45481 .37713 m .45496 .38139 L .47732 .38155 L p F P
0 0 0 r
s
1 .311 .131 r
.47732 .38155 m .47728 .37941 L .45481 .37713 L p F P
0 0 0 r
s
.921 .272 .118 r
.52268 .38155 m .52272 .37941 L .54519 .37713 L p F P
0 0 0 r
s
.921 .272 .118 r
.54519 .37713 m .54504 .38139 L .52268 .38155 L p F P
0 0 0 r
s
.83 .24 .1 r
.40313 .68534 m
.38386 .66594 L
s
.38386 .66594 m
.38141 .64431 L
s
.61614 .66594 m
.61859 .64431 L
s
.61614 .66594 m
.59687 .68534 L
s
1 .332 .137 r
.39622 .41697 m .39699 .42642 L .41474 .41343 L p F P
0 0 0 r
s
1 .332 .137 r
.41474 .41343 m .41422 .40554 L .39622 .41697 L p F P
0 0 0 r
s
.702 .21 .094 r
.58526 .41343 m .58578 .40554 L .60378 .41697 L p F P
0 0 0 r
s
.702 .21 .094 r
.60378 .41697 m .60301 .42642 L .58526 .41343 L p F P
0 0 0 r
s
.899 .254 .097 r
.35212 .53803 m .35368 .55017 L .35664 .53099 L p F P
0 0 0 r
s
.899 .254 .097 r
.35664 .53099 m .35515 .51889 L .35212 .53803 L p F P
0 0 0 r
s
.83 .24 .1 r
.35508 .54969 m
.35984 .52529 L
s
.181 .052 .027 r
.64336 .53099 m .64485 .51889 L .64788 .53803 L p F P
0 0 0 r
s
.181 .052 .027 r
.64788 .53803 m .64632 .55017 L .64336 .53099 L p F P
0 0 0 r
s
.83 .24 .1 r
.64016 .52529 m
.64492 .54969 L
s
.51503 .73759 m
.51534 .71745 L
s
.51503 .73759 m
.48497 .73759 L
s
.48497 .73759 m
.48466 .71745 L
s
1 .311 .131 r
.45467 .37284 m .45481 .37713 L .47728 .37941 L p F P
0 0 0 r
s
1 .311 .131 r
.47728 .37941 m .47724 .37726 L .45467 .37284 L p F P
0 0 0 r
s
.921 .272 .118 r
.52272 .37941 m .52276 .37726 L .54533 .37284 L p F P
0 0 0 r
s
.921 .272 .118 r
.54533 .37284 m .54519 .37713 L .52272 .37941 L p F P
0 0 0 r
s
1 .33 .134 r
.36862 .45771 m .36985 .46926 L .38249 .45184 L p F P
0 0 0 r
s
1 .33 .134 r
.38249 .45184 m .38149 .44128 L .36862 .45771 L p F P
0 0 0 r
s
.465 .141 .068 r
.61751 .45184 m .61851 .44128 L .63138 .45771 L p F P
0 0 0 r
s
.465 .141 .068 r
.63138 .45771 m .63015 .46926 L .61751 .45184 L p F P
0 0 0 r
s
1 .32 .134 r
.43341 .38403 m .43373 .39026 L .45511 .38562 L p F P
0 0 0 r
s
1 .32 .134 r
.45511 .38562 m .45496 .38139 L .43341 .38403 L p F P
0 0 0 r
s
.86 .255 .111 r
.54489 .38562 m .54504 .38139 L .56659 .38403 L p F P
0 0 0 r
s
.86 .255 .111 r
.56659 .38403 m .56627 .39026 L .54489 .38562 L p F P
0 0 0 r
s
1 .327 .136 r
.41368 .39756 m .41422 .40554 L .43404 .39644 L p F P
0 0 0 r
s
.83 .24 .1 r
.42795 .40016 m
.42941 .42639 L
s
1 .327 .136 r
.43404 .39644 m .43373 .39026 L .41368 .39756 L p F P
0 0 0 r
s
.83 .24 .1 r
.42795 .40016 m
.45568 .39087 L
s
.24 .35 .67 r
.41761 .37624 m
.41883 .39569 L
s
.789 .235 .104 r
.56596 .39644 m .56627 .39026 L .58632 .39756 L p F P
0 0 0 r
s
.24 .35 .67 r
.58117 .39569 m
.58239 .37624 L
s
.789 .235 .104 r
.58632 .39756 m .58578 .40554 L .56596 .39644 L p F P
0 0 0 r
s
.83 .24 .1 r
.54432 .39087 m
.57205 .40016 L
s
.57059 .42639 m
.57205 .40016 L
s
1 .311 .131 r
.45452 .36853 m .45467 .37284 L .47724 .37726 L p F P
0 0 0 r
s
1 .311 .131 r
.47724 .37726 m .47721 .3751 L .45452 .36853 L p F P
0 0 0 r
s
.921 .272 .118 r
.52276 .37726 m .52279 .3751 L .54548 .36853 L p F P
0 0 0 r
s
.921 .272 .118 r
.54548 .36853 m .54533 .37284 L .52276 .37726 L p F P
0 0 0 r
s
1 .295 .116 r
.35362 .50655 m .35515 .51889 L .36153 .49961 L p F P
0 0 0 r
s
1 .295 .116 r
.36153 .49961 m .36014 .48762 L .35362 .50655 L p F P
0 0 0 r
s
.249 .072 .039 r
.63847 .49961 m .63986 .48762 L .64638 .50655 L p F P
0 0 0 r
s
.249 .072 .039 r
.64638 .50655 m .64485 .51889 L .63847 .49961 L p F P
0 0 0 r
s
.24 .35 .67 r
.24849 .36117 m
.25282 .37624 L
s
.21163 .37624 m
.20657 .36117 L
s
.25282 .37624 m
.21163 .37624 L
s
.29041 .36117 m
.29402 .37624 L
s
.29402 .37624 m
.25282 .37624 L
s
.33233 .36117 m
.33522 .37624 L
s
.33522 .37624 m
.29402 .37624 L
s
.37425 .36117 m
.37641 .37624 L
s
.37641 .37624 m
.33522 .37624 L
s
.41761 .37624 m
.37641 .37624 L
s
.41761 .37624 m
.45478 .37624 L
s
.47533 .37624 m
.5 .37624 L
s
.5 .37624 m
.52467 .37624 L
s
.54522 .37624 m
.58239 .37624 L
s
.62575 .36117 m
.62359 .37624 L
s
.62359 .37624 m
.58239 .37624 L
s
.66767 .36117 m
.66478 .37624 L
s
.66478 .37624 m
.62359 .37624 L
s
.70959 .36117 m
.70598 .37624 L
s
.70598 .37624 m
.66478 .37624 L
s
.75151 .36117 m
.74718 .37624 L
s
.74718 .37624 m
.70598 .37624 L
s
.79343 .36117 m
.78837 .37624 L
s
.78837 .37624 m
.74718 .37624 L
s
1 .334 .136 r
.38047 .43053 m .38149 .44128 L .39699 .42642 L p F P
0 0 0 r
s
.83 .24 .1 r
.38163 .4312 m
.38407 .45718 L
s
1 .334 .136 r
.39699 .42642 m .39622 .41697 L .38047 .43053 L p F P
0 0 0 r
s
.597 .179 .083 r
.60301 .42642 m .60378 .41697 L .61953 .43053 L p F P
0 0 0 r
s
.597 .179 .083 r
.61953 .43053 m .61851 .44128 L .60301 .42642 L p F P
0 0 0 r
s
.83 .24 .1 r
.61593 .45718 m
.61837 .4312 L
s
1 .311 .131 r
.45437 .36418 m .45452 .36853 L .47721 .3751 L p F P
0 0 0 r
s
1 .311 .131 r
.47721 .3751 m .47717 .37294 L .45437 .36418 L p F P
0 0 0 r
s
.921 .272 .118 r
.52279 .3751 m .52283 .37294 L .54563 .36418 L p F P
0 0 0 r
s
.921 .272 .118 r
.54563 .36418 m .54548 .36853 L .52279 .3751 L p F P
0 0 0 r
s
1 .32 .134 r
.43309 .37774 m .43341 .38403 L .45496 .38139 L p F P
0 0 0 r
s
1 .32 .134 r
.45496 .38139 m .45481 .37713 L .43309 .37774 L p F P
0 0 0 r
s
.86 .255 .111 r
.54504 .38139 m .54519 .37713 L .56691 .37774 L p F P
0 0 0 r
s
.86 .255 .111 r
.56691 .37774 m .56659 .38403 L .54504 .38139 L p F P
0 0 0 r
s
1 .332 .137 r
.39544 .40739 m .39622 .41697 L .41422 .40554 L p F P
0 0 0 r
s
.83 .24 .1 r
.40293 .41375 m
.40491 .43988 L
s
1 .332 .137 r
.41422 .40554 m .41368 .39756 L .39544 .40739 L p F P
0 0 0 r
s
.83 .24 .1 r
.40293 .41375 m
.42795 .40016 L
s
.702 .21 .094 r
.58578 .40554 m .58632 .39756 L .60456 .40739 L p F P
0 0 0 r
s
.702 .21 .094 r
.60456 .40739 m .60378 .41697 L .58578 .40554 L p F P
0 0 0 r
s
.83 .24 .1 r
.57205 .40016 m
.59707 .41375 L
s
.59509 .43988 m
.59707 .41375 L
s
1 .311 .131 r
.45422 .35981 m .45437 .36418 L .47717 .37294 L p F P
0 0 0 r
s
1 .311 .131 r
.47717 .37294 m .47713 .37077 L .45422 .35981 L p F P
0 0 0 r
s
.921 .272 .118 r
.52283 .37294 m .52287 .37077 L .54578 .35981 L p F P
0 0 0 r
s
.921 .272 .118 r
.54578 .35981 m .54563 .36418 L .52283 .37294 L p F P
0 0 0 r
s
1 .327 .136 r
.41314 .38947 m .41368 .39756 L .43373 .39026 L p F P
0 0 0 r
s
1 .327 .136 r
.43373 .39026 m .43341 .38403 L .41314 .38947 L p F P
0 0 0 r
s
.789 .235 .104 r
.56627 .39026 m .56659 .38403 L .58686 .38947 L p F P
0 0 0 r
s
.789 .235 .104 r
.58686 .38947 m .58632 .39756 L .56627 .39026 L p F P
0 0 0 r
s
.24 .35 .67 r
.25223 .62625 m
.21094 .62625 L
s
.29353 .62625 m
.25223 .62625 L
s
.33482 .62625 m
.29353 .62625 L
s
.33482 .62625 m
.36682 .62625 L
s
.36877 .62625 m
.37612 .62625 L
s
.37612 .62625 m
.41741 .62625 L
s
.41741 .62625 m
.45871 .62625 L
s
.45871 .62625 m
.5 .62625 L
s
.5 .62625 m
.54129 .62625 L
s
.54129 .62625 m
.58259 .62625 L
s
.58259 .62625 m
.62388 .62625 L
s
.63318 .62625 m
.66518 .62625 L
s
.62388 .62625 m
.63123 .62625 L
s
.70647 .62625 m
.66518 .62625 L
s
.74777 .62625 m
.70647 .62625 L
s
.78906 .62625 m
.74777 .62625 L
s
.25223 .62625 m
.24782 .64058 L
s
.20579 .64058 m
.21094 .62625 L
s
.29353 .62625 m
.28985 .64058 L
s
.33482 .62625 m
.33188 .64058 L
s
.66518 .62625 m
.66812 .64058 L
s
.70647 .62625 m
.71015 .64058 L
s
.74777 .62625 m
.75218 .64058 L
s
.78906 .62625 m
.79421 .64058 L
s
1 .318 .127 r
.35871 .47539 m .36014 .48762 L .36985 .46926 L p F P
0 0 0 r
s
.83 .24 .1 r
.36779 .47772 m
.37049 .50248 L
s
1 .318 .127 r
.36985 .46926 m .36862 .45771 L .35871 .47539 L p F P
0 0 0 r
s
.83 .24 .1 r
.36779 .47772 m
.38407 .45718 L
s
.332 .1 .051 r
.63015 .46926 m .63138 .45771 L .64129 .47539 L p F P
0 0 0 r
s
.332 .1 .051 r
.64129 .47539 m .63986 .48762 L .63015 .46926 L p F P
0 0 0 r
s
.83 .24 .1 r
.61593 .45718 m
.63221 .47772 L
s
.62951 .50248 m
.63221 .47772 L
s
.157 .045 .023 r
.35812 .58552 m .35955 .5967 L .35566 .58015 L p F P
0 0 0 r
s
.157 .045 .023 r
.35566 .58015 m .35414 .56849 L .35812 .58552 L p F P
0 0 0 r
s
.83 .24 .1 r
.35508 .54969 m
.35804 .57301 L
s
.796 .229 .086 r
.64434 .58015 m .64586 .56849 L .64188 .58552 L p F P
0 0 0 r
s
.83 .24 .1 r
.64196 .57301 m
.64492 .54969 L
s
.796 .229 .086 r
.64188 .58552 m .64045 .5967 L .64434 .58015 L p F P
0 0 0 r
s
.287 .433 .852 r
.45422 .35981 m .46076 .35981 L .4804 .37077 L p F P
0 0 0 r
s
.287 .433 .852 r
.4804 .37077 m .47713 .37077 L .45422 .35981 L p F P
0 0 0 r
s
.24 .35 .67 r
.45808 .36117 m
.45835 .36676 L
s
.287 .433 .852 r
.46076 .35981 m .4673 .35981 L .48367 .37077 L p F P
0 0 0 r
s
.287 .433 .852 r
.48367 .37077 m .4804 .37077 L .46076 .35981 L p F P
0 0 0 r
s
.287 .433 .852 r
.4673 .35981 m .47384 .35981 L .48693 .37077 L p F P
0 0 0 r
s
.287 .433 .852 r
.48693 .37077 m .48367 .37077 L .4673 .35981 L p F P
0 0 0 r
s
.287 .433 .852 r
.47384 .35981 m .48038 .35981 L .4902 .37077 L p F P
0 0 0 r
s
.287 .433 .852 r
.4902 .37077 m .48693 .37077 L .47384 .35981 L p F P
0 0 0 r
s
.287 .433 .852 r
.48038 .35981 m .48692 .35981 L .49347 .37077 L p F P
0 0 0 r
s
.287 .433 .852 r
.49347 .37077 m .4902 .37077 L .48038 .35981 L p F P
0 0 0 r
s
.83 .24 .1 r
.48486 .36985 m
.48504 .38615 L
s
.48473 .35871 m
.48474 .35981 L
s
.287 .433 .852 r
.48692 .35981 m .49346 .35981 L .49673 .37077 L p F P
0 0 0 r
s
.287 .433 .852 r
.49673 .37077 m .49347 .37077 L .48692 .35981 L p F P
0 0 0 r
s
.287 .433 .852 r
.49346 .35981 m .5 .35981 L .5 .37077 L p F P
0 0 0 r
s
.287 .433 .852 r
.5 .37077 m .49673 .37077 L .49346 .35981 L p F P
0 0 0 r
s
.287 .433 .852 r
.5 .35981 m .50654 .35981 L .50327 .37077 L p F P
0 0 0 r
s
.287 .433 .852 r
.50327 .37077 m .5 .37077 L .5 .35981 L p F P
0 0 0 r
s
.24 .35 .67 r
.5 .36117 m
.5 .37624 L
s
.287 .433 .852 r
.50654 .35981 m .51308 .35981 L .50653 .37077 L p F P
0 0 0 r
s
.287 .433 .852 r
.50653 .37077 m .50327 .37077 L .50654 .35981 L p F P
0 0 0 r
s
.287 .433 .852 r
.51308 .35981 m .51962 .35981 L .5098 .37077 L p F P
0 0 0 r
s
.287 .433 .852 r
.5098 .37077 m .50653 .37077 L .51308 .35981 L p F P
0 0 0 r
s
.287 .433 .852 r
.51962 .35981 m .52616 .35981 L .51307 .37077 L p F P
0 0 0 r
s
.287 .433 .852 r
.51307 .37077 m .5098 .37077 L .51962 .35981 L p F P
0 0 0 r
s
.287 .433 .852 r
.52616 .35981 m .5327 .35981 L .51633 .37077 L p F P
0 0 0 r
s
.287 .433 .852 r
.51633 .37077 m .51307 .37077 L .52616 .35981 L p F P
0 0 0 r
s
.83 .24 .1 r
.51496 .38615 m
.51514 .36985 L
s
.51526 .35981 m
.51527 .35871 L
s
.287 .433 .852 r
.5327 .35981 m .53924 .35981 L .5196 .37077 L p F P
0 0 0 r
s
.287 .433 .852 r
.5196 .37077 m .51633 .37077 L .5327 .35981 L p F P
0 0 0 r
s
.287 .433 .852 r
.53924 .35981 m .54578 .35981 L .52287 .37077 L p F P
0 0 0 r
s
.24 .35 .67 r
.54165 .36676 m
.54192 .36117 L
s
.287 .433 .852 r
.52287 .37077 m .5196 .37077 L .53924 .35981 L p F P
0 0 0 r
s
.236 .068 .036 r
.36692 .61128 m .36818 .62152 L .36096 .60765 L p F P
0 0 0 r
s
.83 .24 .1 r
.35976 .59827 m
.36326 .60905 L
s
.236 .068 .036 r
.36096 .60765 m .35955 .5967 L .36692 .61128 L p F P
0 0 0 r
s
.973 .282 .11 r
.63904 .60765 m .64045 .5967 L .63308 .61128 L p F P
0 0 0 r
s
.973 .282 .11 r
.63308 .61128 m .63182 .62152 L .63904 .60765 L p F P
0 0 0 r
s
1 .32 .134 r
.43276 .37138 m .43309 .37774 L .45481 .37713 L p F P
0 0 0 r
s
1 .32 .134 r
.45481 .37713 m .45467 .37284 L .43276 .37138 L p F P
0 0 0 r
s
.83 .24 .1 r
.45474 .36346 m
.45568 .39087 L
s
.86 .255 .111 r
.54519 .37713 m .54533 .37284 L .56724 .37138 L p F P
0 0 0 r
s
.86 .255 .111 r
.56724 .37138 m .56691 .37774 L .54519 .37713 L p F P
0 0 0 r
s
.83 .24 .1 r
.54432 .39087 m
.54526 .36346 L
s
.59687 .68534 m
.59893 .66394 L
s
.59687 .68534 m
.57288 .70093 L
s
.42712 .70093 m
.40313 .68534 L
s
.40313 .68534 m
.40107 .66394 L
s
.7 .195 .071 r
.35259 .55658 m .35414 .56849 L .35368 .55017 L p F P
0 0 0 r
s
.7 .195 .071 r
.35368 .55017 m .35212 .53803 L .35259 .55658 L p F P
0 0 0 r
s
.098 .028 .012 r
.64632 .55017 m .64788 .53803 L .64741 .55658 L p F P
0 0 0 r
s
.098 .028 .012 r
.64741 .55658 m .64586 .56849 L .64632 .55017 L p F P
0 0 0 r
s
1 .33 .134 r
.36737 .44594 m .36862 .45771 L .38149 .44128 L p F P
0 0 0 r
s
1 .33 .134 r
.38149 .44128 m .38047 .43053 L .36737 .44594 L p F P
0 0 0 r
s
.465 .141 .068 r
.61851 .44128 m .61953 .43053 L .63263 .44594 L p F P
0 0 0 r
s
.465 .141 .068 r
.63263 .44594 m .63138 .45771 L .61851 .44128 L p F P
0 0 0 r
s
.124 .151 .292 r
.38808 .63157 m .36942 .63157 L .37982 .64196 L p F P
0 0 0 r
s
.32 .095 .05 r
.37877 .63281 m .37982 .64196 L .36942 .63157 L p F P
0 0 0 r
s
.24 .35 .67 r
.37391 .64058 m
.37464 .63583 L
s
.32 .095 .05 r
.36942 .63157 m .36818 .62152 L .37877 .63281 L p F P
0 0 0 r
s
.24 .35 .67 r
.37562 .62945 m
.37612 .62625 L
s
.124 .151 .292 r
.63058 .63157 m .61192 .63157 L .60301 .64196 L p F P
0 0 0 r
s
.124 .151 .292 r
.60301 .64196 m .62018 .64196 L .63058 .63157 L p F P
0 0 0 r
s
.124 .151 .292 r
.61192 .63157 m .59327 .63157 L .58584 .64196 L p F P
0 0 0 r
s
.124 .151 .292 r
.58584 .64196 m .60301 .64196 L .61192 .63157 L p F P
0 0 0 r
s
.124 .151 .292 r
.59327 .63157 m .57462 .63157 L .56867 .64196 L p F P
0 0 0 r
s
.124 .151 .292 r
.56867 .64196 m .58584 .64196 L .59327 .63157 L p F P
0 0 0 r
s
.24 .35 .67 r
.58259 .62625 m
.58406 .64058 L
s
.124 .151 .292 r
.57462 .63157 m .55596 .63157 L .55151 .64196 L p F P
0 0 0 r
s
.124 .151 .292 r
.55151 .64196 m .56867 .64196 L .57462 .63157 L p F P
0 0 0 r
s
.124 .151 .292 r
.55596 .63157 m .53731 .63157 L .53434 .64196 L p F P
0 0 0 r
s
.124 .151 .292 r
.53434 .64196 m .55151 .64196 L .55596 .63157 L p F P
0 0 0 r
s
.24 .35 .67 r
.54129 .62625 m
.54203 .64058 L
s
.124 .151 .292 r
.53731 .63157 m .51865 .63157 L .51717 .64196 L p F P
0 0 0 r
s
.124 .151 .292 r
.51717 .64196 m .53434 .64196 L .53731 .63157 L p F P
0 0 0 r
s
.124 .151 .292 r
.51865 .63157 m .5 .63157 L .5 .64196 L p F P
0 0 0 r
s
.124 .151 .292 r
.5 .64196 m .51717 .64196 L .51865 .63157 L p F P
0 0 0 r
s
.124 .151 .292 r
.5 .63157 m .48135 .63157 L .48283 .64196 L p F P
0 0 0 r
s
.124 .151 .292 r
.48283 .64196 m .5 .64196 L .5 .63157 L p F P
0 0 0 r
s
.24 .35 .67 r
.5 .62625 m
.5 .64058 L
s
.124 .151 .292 r
.48135 .63157 m .46269 .63157 L .46566 .64196 L p F P
0 0 0 r
s
.124 .151 .292 r
.46566 .64196 m .48283 .64196 L .48135 .63157 L p F P
0 0 0 r
s
.124 .151 .292 r
.46269 .63157 m .44404 .63157 L .44849 .64196 L p F P
0 0 0 r
s
.124 .151 .292 r
.44849 .64196 m .46566 .64196 L .46269 .63157 L p F P
0 0 0 r
s
.24 .35 .67 r
.45797 .64058 m
.45871 .62625 L
s
.124 .151 .292 r
.44404 .63157 m .42538 .63157 L .43133 .64196 L p F P
0 0 0 r
s
.124 .151 .292 r
.43133 .64196 m .44849 .64196 L .44404 .63157 L p F P
0 0 0 r
s
.124 .151 .292 r
.42538 .63157 m .40673 .63157 L .41416 .64196 L p F P
0 0 0 r
s
.124 .151 .292 r
.41416 .64196 m .43133 .64196 L .42538 .63157 L p F P
0 0 0 r
s
.24 .35 .67 r
.41594 .64058 m
.41741 .62625 L
s
.124 .151 .292 r
.40673 .63157 m .38808 .63157 L .39699 .64196 L p F P
0 0 0 r
s
.124 .151 .292 r
.39699 .64196 m .41416 .64196 L .40673 .63157 L p F P
0 0 0 r
s
.124 .151 .292 r
.37982 .64196 m .39699 .64196 L .38808 .63157 L p F P
0 0 0 r
s
1 .315 .125 r
.63058 .63157 m .63182 .62152 L .62123 .63281 L p F P
0 0 0 r
s
.24 .35 .67 r
.62388 .62625 m
.62438 .62945 L
s
1 .315 .125 r
.62123 .63281 m .62018 .64196 L .63058 .63157 L p F P
0 0 0 r
s
.24 .35 .67 r
.62536 .63583 m
.62609 .64058 L
s
.83 .24 .1 r
.37995 .64196 m
.38141 .64431 L
s
.61859 .64431 m
.62005 .64196 L
s
.899 .254 .097 r
.35053 .52562 m .35212 .53803 L .35515 .51889 L p F P
0 0 0 r
s
.899 .254 .097 r
.35515 .51889 m .35362 .50655 L .35053 .52562 L p F P
0 0 0 r
s
.181 .052 .027 r
.64485 .51889 m .64638 .50655 L .64947 .52562 L p F P
0 0 0 r
s
.181 .052 .027 r
.64947 .52562 m .64788 .53803 L .64485 .51889 L p F P
0 0 0 r
s
1 .327 .136 r
.4126 .38129 m .41314 .38947 L .43341 .38403 L p F P
0 0 0 r
s
1 .327 .136 r
.43341 .38403 m .43309 .37774 L .4126 .38129 L p F P
0 0 0 r
s
.789 .235 .104 r
.56659 .38403 m .56691 .37774 L .5874 .38129 L p F P
0 0 0 r
s
.789 .235 .104 r
.5874 .38129 m .58686 .38947 L .56659 .38403 L p F P
0 0 0 r
s
1 .32 .134 r
.43244 .36497 m .43276 .37138 L .45467 .37284 L p F P
0 0 0 r
s
1 .32 .134 r
.45467 .37284 m .45452 .36853 L .43244 .36497 L p F P
0 0 0 r
s
.86 .255 .111 r
.54533 .37284 m .54548 .36853 L .56756 .36497 L p F P
0 0 0 r
s
.86 .255 .111 r
.56756 .36497 m .56724 .37138 L .54533 .37284 L p F P
0 0 0 r
s
1 .334 .136 r
.37943 .41959 m .38047 .43053 L .39622 .41697 L p F P
0 0 0 r
s
1 .334 .136 r
.39622 .41697 m .39544 .40739 L .37943 .41959 L p F P
0 0 0 r
s
.83 .24 .1 r
.38163 .4312 m
.40293 .41375 L
s
.597 .179 .083 r
.60378 .41697 m .60456 .40739 L .62057 .41959 L p F P
0 0 0 r
s
.597 .179 .083 r
.62057 .41959 m .61953 .43053 L .60378 .41697 L p F P
0 0 0 r
s
.83 .24 .1 r
.59707 .41375 m
.61837 .4312 L
s
1 .332 .137 r
.39464 .39766 m .39544 .40739 L .41368 .39756 L p F P
0 0 0 r
s
1 .332 .137 r
.41368 .39756 m .41314 .38947 L .39464 .39766 L p F P
0 0 0 r
s
.702 .21 .094 r
.58632 .39756 m .58686 .38947 L .60536 .39766 L p F P
0 0 0 r
s
.702 .21 .094 r
.60536 .39766 m .60456 .40739 L .58632 .39756 L p F P
0 0 0 r
s
1 .295 .116 r
.35206 .49394 m .35362 .50655 L .36014 .48762 L p F P
0 0 0 r
s
.83 .24 .1 r
.35689 .50075 m
.35984 .52529 L
s
1 .295 .116 r
.36014 .48762 m .35871 .47539 L .35206 .49394 L p F P
0 0 0 r
s
.83 .24 .1 r
.35689 .50075 m
.36779 .47772 L
s
.249 .072 .039 r
.63986 .48762 m .64129 .47539 L .64794 .49394 L p F P
0 0 0 r
s
.249 .072 .039 r
.64794 .49394 m .64638 .50655 L .63986 .48762 L p F P
0 0 0 r
s
.83 .24 .1 r
.63221 .47772 m
.64311 .50075 L
s
.64016 .52529 m
.64311 .50075 L
s
1 .32 .134 r
.43211 .35849 m .43244 .36497 L .45452 .36853 L p F P
0 0 0 r
s
1 .32 .134 r
.45452 .36853 m .45437 .36418 L .43211 .35849 L p F P
0 0 0 r
s
.86 .255 .111 r
.54548 .36853 m .54563 .36418 L .56789 .35849 L p F P
0 0 0 r
s
.86 .255 .111 r
.56789 .35849 m .56756 .36497 L .54548 .36853 L p F P
0 0 0 r
s
.83 .24 .1 r
.57288 .70093 m
.57444 .67971 L
s
.57288 .70093 m
.54525 .71183 L
s
.45475 .71183 m
.42712 .70093 L
s
.42712 .70093 m
.42556 .67971 L
s
1 .327 .136 r
.41204 .37299 m .4126 .38129 L .43309 .37774 L p F P
0 0 0 r
s
1 .327 .136 r
.43309 .37774 m .43276 .37138 L .41204 .37299 L p F P
0 0 0 r
s
.789 .235 .104 r
.56691 .37774 m .56724 .37138 L .58796 .37299 L p F P
0 0 0 r
s
.24 .35 .67 r
.58239 .37624 m
.58259 .3742 L
s
.789 .235 .104 r
.58796 .37299 m .5874 .38129 L .56691 .37774 L p F P
0 0 0 r
s
1 .318 .127 r
.35726 .4629 m .35871 .47539 L .36862 .45771 L p F P
0 0 0 r
s
1 .318 .127 r
.36862 .45771 m .36737 .44594 L .35726 .4629 L p F P
0 0 0 r
s
.332 .1 .051 r
.63138 .45771 m .63263 .44594 L .64274 .4629 L p F P
0 0 0 r
s
.332 .1 .051 r
.64274 .4629 m .64129 .47539 L .63138 .45771 L p F P
0 0 0 r
s
.83 .24 .1 r
.45474 .36346 m
.46576 .36171 L
s
.47775 .35981 m
.48473 .35871 L
s
.48473 .35871 m
.51527 .35871 L
s
.53424 .36171 m
.54526 .36346 L
s
.51527 .35871 m
.52225 .35981 L
s
1 .32 .134 r
.43177 .35194 m .43211 .35849 L .45437 .36418 L p F P
0 0 0 r
s
1 .32 .134 r
.45437 .36418 m .45422 .35981 L .43177 .35194 L p F P
0 0 0 r
s
.86 .255 .111 r
.54563 .36418 m .54578 .35981 L .56823 .35194 L p F P
0 0 0 r
s
.86 .255 .111 r
.56823 .35194 m .56789 .35849 L .54563 .36418 L p F P
0 0 0 r
s
.236 .068 .036 r
.36563 .60084 m .36692 .61128 L .35955 .5967 L p F P
0 0 0 r
s
.236 .068 .036 r
.35955 .5967 m .35812 .58552 L .36563 .60084 L p F P
0 0 0 r
s
.973 .282 .11 r
.64045 .5967 m .64188 .58552 L .63437 .60084 L p F P
0 0 0 r
s
.973 .282 .11 r
.63437 .60084 m .63308 .61128 L .64045 .5967 L p F P
0 0 0 r
s
.157 .045 .023 r
.35666 .57412 m .35812 .58552 L .35414 .56849 L p F P
0 0 0 r
s
.157 .045 .023 r
.35414 .56849 m .35259 .55658 L .35666 .57412 L p F P
0 0 0 r
s
.83 .24 .1 r
.35508 .54969 m
.35655 .57367 L
s
.796 .229 .086 r
.64586 .56849 m .64741 .55658 L .64334 .57412 L p F P
0 0 0 r
s
.796 .229 .086 r
.64334 .57412 m .64188 .58552 L .64586 .56849 L p F P
0 0 0 r
s
.83 .24 .1 r
.64345 .57367 m
.64492 .54969 L
s
1 .33 .134 r
.36609 .43394 m .36737 .44594 L .38047 .43053 L p F P
0 0 0 r
s
1 .33 .134 r
.38047 .43053 m .37943 .41959 L .36609 .43394 L p F P
0 0 0 r
s
.465 .141 .068 r
.61953 .43053 m .62057 .41959 L .63391 .43394 L p F P
0 0 0 r
s
.465 .141 .068 r
.63391 .43394 m .63263 .44594 L .61953 .43053 L p F P
0 0 0 r
s
1 .332 .137 r
.39384 .38777 m .39464 .39766 L .41314 .38947 L p F P
0 0 0 r
s
1 .332 .137 r
.41314 .38947 m .4126 .38129 L .39384 .38777 L p F P
0 0 0 r
s
.702 .21 .094 r
.58686 .38947 m .5874 .38129 L .60616 .38777 L p F P
0 0 0 r
s
.702 .21 .094 r
.60616 .38777 m .60536 .39766 L .58686 .38947 L p F P
0 0 0 r
s
1 .334 .136 r
.37838 .40846 m .37943 .41959 L .39544 .40739 L p F P
0 0 0 r
s
1 .334 .136 r
.39544 .40739 m .39464 .39766 L .37838 .40846 L p F P
0 0 0 r
s
.597 .179 .083 r
.60456 .40739 m .60536 .39766 L .62162 .40846 L p F P
0 0 0 r
s
.597 .179 .083 r
.62162 .40846 m .62057 .41959 L .60456 .40739 L p F P
0 0 0 r
s
.7 .195 .071 r
.35101 .54442 m .35259 .55658 L .35212 .53803 L p F P
0 0 0 r
s
.7 .195 .071 r
.35212 .53803 m .35053 .52562 L .35101 .54442 L p F P
0 0 0 r
s
.098 .028 .012 r
.64788 .53803 m .64947 .52562 L .64899 .54442 L p F P
0 0 0 r
s
.098 .028 .012 r
.64899 .54442 m .64741 .55658 L .64788 .53803 L p F P
0 0 0 r
s
.83 .24 .1 r
.54525 .71183 m
.54623 .69075 L
s
.54525 .71183 m
.51534 .71745 L
s
.48466 .71745 m
.45475 .71183 L
s
.45475 .71183 m
.45377 .69075 L
s
.32 .095 .05 r
.3777 .62349 m .37877 .63281 L .36818 .62152 L p F P
0 0 0 r
s
.32 .095 .05 r
.36818 .62152 m .36692 .61128 L .3777 .62349 L p F P
0 0 0 r
s
1 .315 .125 r
.63182 .62152 m .63308 .61128 L .6223 .62349 L p F P
0 0 0 r
s
1 .315 .125 r
.6223 .62349 m .62123 .63281 L .63182 .62152 L p F P
0 0 0 r
s
.83 .24 .1 r
.38115 .64196 m
.38141 .64431 L
s
.61859 .64431 m
.61885 .64196 L
s
1 .327 .136 r
.41148 .3646 m .41204 .37299 L .43276 .37138 L p F P
0 0 0 r
s
.83 .24 .1 r
.42642 .37282 m
.42795 .40016 L
s
1 .327 .136 r
.43276 .37138 m .43244 .36497 L .41148 .3646 L p F P
0 0 0 r
s
.24 .35 .67 r
.41616 .36117 m
.4165 .36469 L
s
.83 .24 .1 r
.42642 .37282 m
.45474 .36346 L
s
.789 .235 .104 r
.56724 .37138 m .56756 .36497 L .58852 .3646 L p F P
0 0 0 r
s
.24 .35 .67 r
.58274 .37259 m
.58335 .36625 L
s
.789 .235 .104 r
.58852 .3646 m .58796 .37299 L .56724 .37138 L p F P
0 0 0 r
s
.24 .35 .67 r
.5835 .36469 m
.58384 .36117 L
s
.83 .24 .1 r
.54526 .36346 m
.57358 .37282 L
s
.57205 .40016 m
.57358 .37282 L
s
.274 .422 .83 r
.43177 .35194 m .44152 .35194 L .46076 .35981 L p F P
0 0 0 r
s
.274 .422 .83 r
.46076 .35981 m .45422 .35981 L .43177 .35194 L p F P
0 0 0 r
s
.274 .422 .83 r
.44152 .35194 m .45127 .35194 L .4673 .35981 L p F P
0 0 0 r
s
.274 .422 .83 r
.4673 .35981 m .46076 .35981 L .44152 .35194 L p F P
0 0 0 r
s
.274 .422 .83 r
.45127 .35194 m .46101 .35194 L .47384 .35981 L p F P
0 0 0 r
s
.274 .422 .83 r
.47384 .35981 m .4673 .35981 L .45127 .35194 L p F P
0 0 0 r
s
.83 .24 .1 r
.45457 .35858 m
.45474 .36346 L
s
.274 .422 .83 r
.46101 .35194 m .47076 .35194 L .48038 .35981 L p F P
0 0 0 r
s
.274 .422 .83 r
.48038 .35981 m .47384 .35981 L .46101 .35194 L p F P
0 0 0 r
s
.274 .422 .83 r
.47076 .35194 m .48051 .35194 L .48692 .35981 L p F P
0 0 0 r
s
.274 .422 .83 r
.48692 .35981 m .48038 .35981 L .47076 .35194 L p F P
0 0 0 r
s
.274 .422 .83 r
.48051 .35194 m .49025 .35194 L .49346 .35981 L p F P
0 0 0 r
s
.83 .24 .1 r
.48468 .35448 m
.48471 .3571 L
s
.274 .422 .83 r
.49346 .35981 m .48692 .35981 L .48051 .35194 L p F P
0 0 0 r
s
.274 .422 .83 r
.49025 .35194 m .5 .35194 L .5 .35981 L p F P
0 0 0 r
s
.274 .422 .83 r
.5 .35981 m .49346 .35981 L .49025 .35194 L p F P
0 0 0 r
s
.274 .422 .83 r
.5 .35194 m .50975 .35194 L .50654 .35981 L p F P
0 0 0 r
s
.274 .422 .83 r
.50654 .35981 m .5 .35981 L .5 .35194 L p F P
0 0 0 r
s
.274 .422 .83 r
.50975 .35194 m .51949 .35194 L .51308 .35981 L p F P
0 0 0 r
s
.83 .24 .1 r
.51527 .35871 m
.51529 .3571 L
s
.274 .422 .83 r
.51308 .35981 m .50654 .35981 L .50975 .35194 L p F P
0 0 0 r
s
.274 .422 .83 r
.51949 .35194 m .52924 .35194 L .51962 .35981 L p F P
0 0 0 r
s
.274 .422 .83 r
.51962 .35981 m .51308 .35981 L .51949 .35194 L p F P
0 0 0 r
s
.274 .422 .83 r
.52924 .35194 m .53899 .35194 L .52616 .35981 L p F P
0 0 0 r
s
.274 .422 .83 r
.52616 .35981 m .51962 .35981 L .52924 .35194 L p F P
0 0 0 r
s
.274 .422 .83 r
.53899 .35194 m .54873 .35194 L .5327 .35981 L p F P
0 0 0 r
s
.274 .422 .83 r
.5327 .35981 m .52616 .35981 L .53899 .35194 L p F P
0 0 0 r
s
.274 .422 .83 r
.54873 .35194 m .55848 .35194 L .53924 .35981 L p F P
0 0 0 r
s
.274 .422 .83 r
.53924 .35981 m .5327 .35981 L .54873 .35194 L p F P
0 0 0 r
s
.274 .422 .83 r
.55848 .35194 m .56823 .35194 L .54578 .35981 L p F P
0 0 0 r
s
.274 .422 .83 r
.54578 .35981 m .53924 .35981 L .55848 .35194 L p F P
0 0 0 r
s
.83 .24 .1 r
.54526 .36346 m
.54543 .35858 L
s
.24 .35 .67 r
.24367 .35155 m
.24849 .36117 L
s
.20657 .36117 m
.20094 .35155 L
s
.24849 .36117 m
.20657 .36117 L
s
.28639 .35155 m
.29041 .36117 L
s
.29041 .36117 m
.24849 .36117 L
s
.32911 .35155 m
.33233 .36117 L
s
.33233 .36117 m
.29041 .36117 L
s
.37183 .35155 m
.37425 .36117 L
s
.37425 .36117 m
.33233 .36117 L
s
.41616 .36117 m
.37425 .36117 L
s
.4508 .36117 m
.45808 .36117 L
s
.41616 .36117 m
.43224 .36117 L
s
.5 .36117 m
.45808 .36117 L
s
.54192 .36117 m
.5 .36117 L
s
.54192 .36117 m
.5492 .36117 L
s
.56776 .36117 m
.58384 .36117 L
s
.62817 .35155 m
.62575 .36117 L
s
.62575 .36117 m
.58384 .36117 L
s
.67089 .35155 m
.66767 .36117 L
s
.66767 .36117 m
.62575 .36117 L
s
.71361 .35155 m
.70959 .36117 L
s
.70959 .36117 m
.66767 .36117 L
s
.75633 .35155 m
.75151 .36117 L
s
.75151 .36117 m
.70959 .36117 L
s
.79906 .35155 m
.79343 .36117 L
s
.79343 .36117 m
.75151 .36117 L
s
.899 .254 .097 r
.3489 .51295 m .35053 .52562 L .35362 .50655 L p F P
0 0 0 r
s
.899 .254 .097 r
.35362 .50655 m .35206 .49394 L .3489 .51295 L p F P
0 0 0 r
s
.83 .24 .1 r
.35199 .52537 m
.35689 .50075 L
s
.181 .052 .027 r
.64638 .50655 m .64794 .49394 L .6511 .51295 L p F P
0 0 0 r
s
.181 .052 .027 r
.6511 .51295 m .64947 .52562 L .64638 .50655 L p F P
0 0 0 r
s
.83 .24 .1 r
.64311 .50075 m
.64801 .52537 L
s
.51534 .71745 m
.51568 .69643 L
s
.51534 .71745 m
.48466 .71745 L
s
.48466 .71745 m
.48432 .69643 L
s
.088 .1 .192 r
.39699 .64196 m .37982 .64196 L .39343 .64919 L p F P
0 0 0 r
s
.43 .135 .065 r
.39261 .64114 m .39343 .64919 L .37982 .64196 L p F P
0 0 0 r
s
.43 .135 .065 r
.37982 .64196 m .37877 .63281 L .39261 .64114 L p F P
0 0 0 r
s
.088 .1 .192 r
.62018 .64196 m .60301 .64196 L .59134 .64919 L p F P
0 0 0 r
s
.088 .1 .192 r
.59134 .64919 m .60657 .64919 L .62018 .64196 L p F P
0 0 0 r
s
.088 .1 .192 r
.60301 .64196 m .58584 .64196 L .57612 .64919 L p F P
0 0 0 r
s
.088 .1 .192 r
.57612 .64919 m .59134 .64919 L .60301 .64196 L p F P
0 0 0 r
s
.088 .1 .192 r
.58584 .64196 m .56867 .64196 L .5609 .64919 L p F P
0 0 0 r
s
.088 .1 .192 r
.5609 .64919 m .57612 .64919 L .58584 .64196 L p F P
0 0 0 r
s
.088 .1 .192 r
.56867 .64196 m .55151 .64196 L .54567 .64919 L p F P
0 0 0 r
s
.088 .1 .192 r
.54567 .64919 m .5609 .64919 L .56867 .64196 L p F P
0 0 0 r
s
.088 .1 .192 r
.55151 .64196 m .53434 .64196 L .53045 .64919 L p F P
0 0 0 r
s
.088 .1 .192 r
.53045 .64919 m .54567 .64919 L .55151 .64196 L p F P
0 0 0 r
s
.088 .1 .192 r
.53434 .64196 m .51717 .64196 L .51522 .64919 L p F P
0 0 0 r
s
.088 .1 .192 r
.51522 .64919 m .53045 .64919 L .53434 .64196 L p F P
0 0 0 r
s
.088 .1 .192 r
.51717 .64196 m .5 .64196 L .5 .64919 L p F P
0 0 0 r
s
.088 .1 .192 r
.5 .64919 m .51522 .64919 L .51717 .64196 L p F P
0 0 0 r
s
.088 .1 .192 r
.5 .64196 m .48283 .64196 L .48478 .64919 L p F P
0 0 0 r
s
.088 .1 .192 r
.48478 .64919 m .5 .64919 L .5 .64196 L p F P
0 0 0 r
s
.088 .1 .192 r
.48283 .64196 m .46566 .64196 L .46955 .64919 L p F P
0 0 0 r
s
.088 .1 .192 r
.46955 .64919 m .48478 .64919 L .48283 .64196 L p F P
0 0 0 r
s
.088 .1 .192 r
.46566 .64196 m .44849 .64196 L .45433 .64919 L p F P
0 0 0 r
s
.088 .1 .192 r
.45433 .64919 m .46955 .64919 L .46566 .64196 L p F P
0 0 0 r
s
.088 .1 .192 r
.44849 .64196 m .43133 .64196 L .4391 .64919 L p F P
0 0 0 r
s
.088 .1 .192 r
.4391 .64919 m .45433 .64919 L .44849 .64196 L p F P
0 0 0 r
s
.088 .1 .192 r
.43133 .64196 m .41416 .64196 L .42388 .64919 L p F P
0 0 0 r
s
.088 .1 .192 r
.42388 .64919 m .4391 .64919 L .43133 .64196 L p F P
0 0 0 r
s
.088 .1 .192 r
.41416 .64196 m .39699 .64196 L .40866 .64919 L p F P
0 0 0 r
s
.088 .1 .192 r
.40866 .64919 m .42388 .64919 L .41416 .64196 L p F P
0 0 0 r
s
.088 .1 .192 r
.39343 .64919 m .40866 .64919 L .39699 .64196 L p F P
0 0 0 r
s
.83 .24 .1 r
.38141 .64431 m
.40107 .66394 L
s
1 .333 .134 r
.62018 .64196 m .62123 .63281 L .60739 .64114 L p F P
0 0 0 r
s
1 .333 .134 r
.60739 .64114 m .60657 .64919 L .62018 .64196 L p F P
0 0 0 r
s
.83 .24 .1 r
.59893 .66394 m
.61859 .64431 L
s
1 .295 .116 r
.35047 .48105 m .35206 .49394 L .35871 .47539 L p F P
0 0 0 r
s
1 .295 .116 r
.35871 .47539 m .35726 .4629 L .35047 .48105 L p F P
0 0 0 r
s
.249 .072 .039 r
.64129 .47539 m .64274 .4629 L .64953 .48105 L p F P
0 0 0 r
s
.249 .072 .039 r
.64953 .48105 m .64794 .49394 L .64129 .47539 L p F P
0 0 0 r
s
.24 .35 .67 r
.24782 .64058 m
.20579 .64058 L
s
.28985 .64058 m
.24782 .64058 L
s
.33188 .64058 m
.28985 .64058 L
s
.33188 .64058 m
.37391 .64058 L
s
.37391 .64058 m
.37904 .64058 L
s
.37904 .64058 m
.37925 .64058 L
s
.39167 .64058 m
.41594 .64058 L
s
.45797 .64058 m
.41594 .64058 L
s
.5 .64058 m
.45797 .64058 L
s
.54203 .64058 m
.5 .64058 L
s
.58406 .64058 m
.54203 .64058 L
s
.62096 .64058 m
.62609 .64058 L
s
.62075 .64058 m
.62096 .64058 L
s
.58406 .64058 m
.60833 .64058 L
s
.62609 .64058 m
.66812 .64058 L
s
.71015 .64058 m
.66812 .64058 L
s
.75218 .64058 m
.71015 .64058 L
s
.79421 .64058 m
.75218 .64058 L
s
.24782 .64058 m
.24294 .64935 L
s
.20009 .64935 m
.20579 .64058 L
s
.28985 .64058 m
.28578 .64935 L
s
.33188 .64058 m
.32862 .64935 L
s
.37147 .64935 m
.37391 .64058 L
s
.62609 .64058 m
.62853 .64935 L
s
.66812 .64058 m
.67138 .64935 L
s
.71015 .64058 m
.71422 .64935 L
s
.75218 .64058 m
.75706 .64935 L
s
.79421 .64058 m
.79991 .64935 L
s
1 .332 .137 r
.39302 .37774 m .39384 .38777 L .4126 .38129 L p F P
0 0 0 r
s
.83 .24 .1 r
.40086 .38651 m
.40293 .41375 L
s
1 .332 .137 r
.4126 .38129 m .41204 .37299 L .39302 .37774 L p F P
0 0 0 r
s
.702 .21 .094 r
.5874 .38129 m .58796 .37299 L .60698 .37774 L p F P
0 0 0 r
s
.702 .21 .094 r
.60698 .37774 m .60616 .38777 L .5874 .38129 L p F P
0 0 0 r
s
.83 .24 .1 r
.59707 .41375 m
.59914 .38651 L
s
1 .327 .136 r
.41092 .35609 m .41148 .3646 L .43244 .36497 L p F P
0 0 0 r
s
1 .327 .136 r
.43244 .36497 m .43211 .35849 L .41092 .35609 L p F P
0 0 0 r
s
.789 .235 .104 r
.56756 .36497 m .56789 .35849 L .58908 .35609 L p F P
0 0 0 r
s
.789 .235 .104 r
.58908 .35609 m .58852 .3646 L .56756 .36497 L p F P
0 0 0 r
s
1 .318 .127 r
.35578 .45015 m .35726 .4629 L .36737 .44594 L p F P
0 0 0 r
s
.83 .24 .1 r
.36498 .45191 m
.36779 .47772 L
s
1 .318 .127 r
.36737 .44594 m .36609 .43394 L .35578 .45015 L p F P
0 0 0 r
s
.332 .1 .051 r
.63263 .44594 m .63391 .43394 L .64422 .45015 L p F P
0 0 0 r
s
.332 .1 .051 r
.64422 .45015 m .64274 .4629 L .63263 .44594 L p F P
0 0 0 r
s
.83 .24 .1 r
.63221 .47772 m
.63502 .45191 L
s
1 .334 .136 r
.3773 .39713 m .37838 .40846 L .39464 .39766 L p F P
0 0 0 r
s
1 .334 .136 r
.39464 .39766 m .39384 .38777 L .3773 .39713 L p F P
0 0 0 r
s
.597 .179 .083 r
.60536 .39766 m .60616 .38777 L .6227 .39713 L p F P
0 0 0 r
s
.597 .179 .083 r
.6227 .39713 m .62162 .40846 L .60536 .39766 L p F P
0 0 0 r
s
1 .33 .134 r
.36478 .4217 m .36609 .43394 L .37943 .41959 L p F P
0 0 0 r
s
.83 .24 .1 r
.36498 .45191 m
.38163 .4312 L
s
1 .33 .134 r
.37943 .41959 m .37838 .40846 L .36478 .4217 L p F P
0 0 0 r
s
.83 .24 .1 r
.37908 .40409 m
.38163 .4312 L
s
.465 .141 .068 r
.62057 .41959 m .62162 .40846 L .63522 .4217 L p F P
0 0 0 r
s
.465 .141 .068 r
.63522 .4217 m .63391 .43394 L .62057 .41959 L p F P
0 0 0 r
s
.83 .24 .1 r
.61837 .4312 m
.62092 .40409 L
s
.61837 .4312 m
.63502 .45191 L
s
.236 .068 .036 r
.36432 .59019 m .36563 .60084 L .35812 .58552 L p F P
0 0 0 r
s
.83 .24 .1 r
.3568 .57521 m
.36084 .58757 L
s
.236 .068 .036 r
.35812 .58552 m .35666 .57412 L .36432 .59019 L p F P
0 0 0 r
s
.973 .282 .11 r
.64188 .58552 m .64334 .57412 L .63568 .59019 L p F P
0 0 0 r
s
.973 .282 .11 r
.63568 .59019 m .63437 .60084 L .64188 .58552 L p F P
0 0 0 r
s
.157 .045 .023 r
.35516 .56248 m .35666 .57412 L .35259 .55658 L p F P
0 0 0 r
s
.157 .045 .023 r
.35259 .55658 m .35101 .54442 L .35516 .56248 L p F P
0 0 0 r
s
.83 .24 .1 r
.35199 .52537 m
.35508 .54969 L
s
.796 .229 .086 r
.64741 .55658 m .64899 .54442 L .64484 .56248 L p F P
0 0 0 r
s
.83 .24 .1 r
.64492 .54969 m
.64801 .52537 L
s
.796 .229 .086 r
.64484 .56248 m .64334 .57412 L .64741 .55658 L p F P
0 0 0 r
s
.83 .24 .1 r
.42556 .67971 m
.40107 .66394 L
s
.59893 .66394 m
.57444 .67971 L
s
.32 .095 .05 r
.37662 .61402 m .3777 .62349 L .36692 .61128 L p F P
0 0 0 r
s
.32 .095 .05 r
.36692 .61128 m .36563 .60084 L .37662 .61402 L p F P
0 0 0 r
s
1 .315 .125 r
.63308 .61128 m .63437 .60084 L .62338 .61402 L p F P
0 0 0 r
s
1 .315 .125 r
.62338 .61402 m .6223 .62349 L .63308 .61128 L p F P
0 0 0 r
s
.7 .195 .071 r
.3494 .53199 m .35101 .54442 L .35053 .52562 L p F P
0 0 0 r
s
.7 .195 .071 r
.35053 .52562 m .3489 .51295 L .3494 .53199 L p F P
0 0 0 r
s
.098 .028 .012 r
.64947 .52562 m .6511 .51295 L .6506 .53199 L p F P
0 0 0 r
s
.098 .028 .012 r
.6506 .53199 m .64899 .54442 L .64947 .52562 L p F P
0 0 0 r
s
1 .327 .136 r
.41034 .34748 m .41092 .35609 L .43211 .35849 L p F P
0 0 0 r
s
1 .327 .136 r
.43211 .35849 m .43177 .35194 L .41034 .34748 L p F P
0 0 0 r
s
.789 .235 .104 r
.56789 .35849 m .56823 .35194 L .58966 .34748 L p F P
0 0 0 r
s
.789 .235 .104 r
.58966 .34748 m .58908 .35609 L .56789 .35849 L p F P
0 0 0 r
s
1 .332 .137 r
.39219 .36755 m .39302 .37774 L .41204 .37299 L p F P
0 0 0 r
s
1 .332 .137 r
.41204 .37299 m .41148 .3646 L .39219 .36755 L p F P
0 0 0 r
s
.83 .24 .1 r
.40086 .38651 m
.42642 .37282 L
s
.702 .21 .094 r
.58796 .37299 m .58852 .3646 L .60781 .36755 L p F P
0 0 0 r
s
.702 .21 .094 r
.60781 .36755 m .60698 .37774 L .58796 .37299 L p F P
0 0 0 r
s
.83 .24 .1 r
.57358 .37282 m
.59914 .38651 L
s
.36562 .60068 m
.36596 .60123 L
s
.63404 .60123 m
.63438 .60068 L
s
.899 .254 .097 r
.34724 .5 m .3489 .51295 L .35206 .49394 L p F P
0 0 0 r
s
.899 .254 .097 r
.35206 .49394 m .35047 .48105 L .34724 .5 L p F P
0 0 0 r
s
.181 .052 .027 r
.64794 .49394 m .64953 .48105 L .65276 .5 L p F P
0 0 0 r
s
.181 .052 .027 r
.65276 .5 m .6511 .51295 L .64794 .49394 L p F P
0 0 0 r
s
.43 .135 .065 r
.39177 .63297 m .39261 .64114 L .37877 .63281 L p F P
0 0 0 r
s
.43 .135 .065 r
.37877 .63281 m .3777 .62349 L .39177 .63297 L p F P
0 0 0 r
s
1 .333 .134 r
.62123 .63281 m .6223 .62349 L .60823 .63297 L p F P
0 0 0 r
s
.83 .24 .1 r
.61979 .63367 m
.61989 .63282 L
s
1 .333 .134 r
.60823 .63297 m .60739 .64114 L .62123 .63281 L p F P
0 0 0 r
s
1 .295 .116 r
.34885 .46789 m .35047 .48105 L .35726 .4629 L p F P
0 0 0 r
s
.83 .24 .1 r
.35381 .47514 m
.35689 .50075 L
s
1 .295 .116 r
.35726 .4629 m .35578 .45015 L .34885 .46789 L p F P
0 0 0 r
s
.83 .24 .1 r
.35381 .47514 m
.36498 .45191 L
s
.249 .072 .039 r
.64274 .4629 m .64422 .45015 L .65115 .46789 L p F P
0 0 0 r
s
.249 .072 .039 r
.65115 .46789 m .64953 .48105 L .64274 .4629 L p F P
0 0 0 r
s
.83 .24 .1 r
.63502 .45191 m
.64619 .47514 L
s
.64311 .50075 m
.64619 .47514 L
s
1 .334 .136 r
.37621 .38561 m .3773 .39713 L .39384 .38777 L p F P
0 0 0 r
s
1 .334 .136 r
.39384 .38777 m .39302 .37774 L .37621 .38561 L p F P
0 0 0 r
s
.83 .24 .1 r
.37908 .40409 m
.40086 .38651 L
s
.597 .179 .083 r
.60616 .38777 m .60698 .37774 L .62379 .38561 L p F P
0 0 0 r
s
.597 .179 .083 r
.62379 .38561 m .6227 .39713 L .60616 .38777 L p F P
0 0 0 r
s
.83 .24 .1 r
.59914 .38651 m
.62092 .40409 L
s
.24 .38 .748 r
.41034 .34748 m .42315 .34748 L .44152 .35194 L p F P
0 0 0 r
s
.24 .38 .748 r
.44152 .35194 m .43177 .35194 L .41034 .34748 L p F P
0 0 0 r
s
.24 .38 .748 r
.42315 .34748 m .43596 .34748 L .45127 .35194 L p F P
0 0 0 r
s
.24 .38 .748 r
.45127 .35194 m .44152 .35194 L .42315 .34748 L p F P
0 0 0 r
s
.83 .24 .1 r
.42483 .3443 m
.42501 .34748 L
s
.42516 .35013 m
.42642 .37282 L
s
.24 .38 .748 r
.43596 .34748 m .44877 .34748 L .46101 .35194 L p F P
0 0 0 r
s
.83 .24 .1 r
.45431 .35075 m
.45435 .35194 L
s
.24 .38 .748 r
.46101 .35194 m .45127 .35194 L .43596 .34748 L p F P
0 0 0 r
s
.24 .38 .748 r
.44877 .34748 m .46157 .34748 L .47076 .35194 L p F P
0 0 0 r
s
.83 .24 .1 r
.45423 .34859 m
.45426 .34948 L
s
.24 .38 .748 r
.47076 .35194 m .46101 .35194 L .44877 .34748 L p F P
0 0 0 r
s
.83 .24 .1 r
.45377 .33487 m
.4542 .34748 L
s
.24 .35 .67 r
.45728 .35155 m
.45808 .36117 L
s
.24 .38 .748 r
.46157 .34748 m .47438 .34748 L .48051 .35194 L p F P
0 0 0 r
s
.24 .38 .748 r
.48051 .35194 m .47076 .35194 L .46157 .34748 L p F P
0 0 0 r
s
.24 .38 .748 r
.47438 .34748 m .48719 .34748 L .49025 .35194 L p F P
0 0 0 r
s
.83 .24 .1 r
.48463 .35036 m
.48465 .35194 L
s
.24 .38 .748 r
.49025 .35194 m .48051 .35194 L .47438 .34748 L p F P
0 0 0 r
s
.83 .24 .1 r
.4844 .33009 m
.4846 .34748 L
s
.24 .38 .748 r
.48719 .34748 m .5 .34748 L .5 .35194 L p F P
0 0 0 r
s
.24 .38 .748 r
.5 .35194 m .49025 .35194 L .48719 .34748 L p F P
0 0 0 r
s
.24 .38 .748 r
.5 .34748 m .51281 .34748 L .50975 .35194 L p F P
0 0 0 r
s
.24 .38 .748 r
.50975 .35194 m .5 .35194 L .5 .34748 L p F P
0 0 0 r
s
.24 .35 .67 r
.5 .35155 m
.5 .36117 L
s
.24 .38 .748 r
.51281 .34748 m .52562 .34748 L .51949 .35194 L p F P
0 0 0 r
s
.83 .24 .1 r
.51535 .35194 m
.51538 .3492 L
s
.24 .38 .748 r
.51949 .35194 m .50975 .35194 L .51281 .34748 L p F P
0 0 0 r
s
.83 .24 .1 r
.5154 .34748 m
.5156 .33009 L
s
.24 .38 .748 r
.52562 .34748 m .53843 .34748 L .52924 .35194 L p F P
0 0 0 r
s
.24 .38 .748 r
.52924 .35194 m .51949 .35194 L .52562 .34748 L p F P
0 0 0 r
s
.24 .38 .748 r
.53843 .34748 m .55123 .34748 L .53899 .35194 L p F P
0 0 0 r
s
.83 .24 .1 r
.54565 .35194 m
.54574 .34948 L
s
.24 .38 .748 r
.53899 .35194 m .52924 .35194 L .53843 .34748 L p F P
0 0 0 r
s
.24 .38 .748 r
.55123 .34748 m .56404 .34748 L .54873 .35194 L p F P
0 0 0 r
s
.24 .38 .748 r
.54873 .35194 m .53899 .35194 L .55123 .34748 L p F P
0 0 0 r
s
.83 .24 .1 r
.5458 .34748 m
.54623 .33487 L
s
.24 .35 .67 r
.54192 .36117 m
.54272 .35155 L
s
.24 .38 .748 r
.56404 .34748 m .57685 .34748 L .55848 .35194 L p F P
0 0 0 r
s
.24 .38 .748 r
.55848 .35194 m .54873 .35194 L .56404 .34748 L p F P
0 0 0 r
s
.24 .38 .748 r
.57685 .34748 m .58966 .34748 L .56823 .35194 L p F P
0 0 0 r
s
.24 .38 .748 r
.56823 .35194 m .55848 .35194 L .57685 .34748 L p F P
0 0 0 r
s
.83 .24 .1 r
.57358 .37282 m
.57484 .35013 L
s
.57499 .34748 m
.57517 .3443 L
s
1 .318 .127 r
.35427 .43714 m .35578 .45015 L .36609 .43394 L p F P
0 0 0 r
s
1 .318 .127 r
.36609 .43394 m .36478 .4217 L .35427 .43714 L p F P
0 0 0 r
s
.332 .1 .051 r
.63391 .43394 m .63522 .4217 L .64573 .43714 L p F P
0 0 0 r
s
.332 .1 .051 r
.64573 .43714 m .64422 .45015 L .63391 .43394 L p F P
0 0 0 r
s
1 .33 .134 r
.36346 .40923 m .36478 .4217 L .37838 .40846 L p F P
0 0 0 r
s
1 .33 .134 r
.37838 .40846 m .3773 .39713 L .36346 .40923 L p F P
0 0 0 r
s
.465 .141 .068 r
.62162 .40846 m .6227 .39713 L .63654 .40923 L p F P
0 0 0 r
s
.465 .141 .068 r
.63654 .40923 m .63522 .4217 L .62162 .40846 L p F P
0 0 0 r
s
.83 .24 .1 r
.57444 .67971 m
.57607 .65756 L
s
.57444 .67971 m
.54623 .69075 L
s
.45377 .69075 m
.42556 .67971 L
s
.42556 .67971 m
.42393 .65756 L
s
1 .332 .137 r
.39135 .3572 m .39219 .36755 L .41148 .3646 L p F P
0 0 0 r
s
1 .332 .137 r
.41148 .3646 m .41092 .35609 L .39135 .3572 L p F P
0 0 0 r
s
.83 .24 .1 r
.3987 .35809 m
.40086 .38651 L
s
.702 .21 .094 r
.58852 .3646 m .58908 .35609 L .60865 .3572 L p F P
0 0 0 r
s
.702 .21 .094 r
.60865 .3572 m .60781 .36755 L .58852 .3646 L p F P
0 0 0 r
s
.83 .24 .1 r
.59914 .38651 m
.6013 .35809 L
s
.062 .074 .141 r
.42388 .64919 m .40866 .64919 L .42292 .65296 L p F P
0 0 0 r
s
.062 .074 .141 r
.40866 .64919 m .39343 .64919 L .41008 .65296 L p F P
0 0 0 r
s
.062 .074 .141 r
.41008 .65296 m .42292 .65296 L .40866 .64919 L p F P
0 0 0 r
s
.583 .18 .083 r
.40949 .6462 m .41008 .65296 L .39343 .64919 L p F P
0 0 0 r
s
.83 .24 .1 r
.39982 .65096 m
.40107 .66394 L
s
.39978 .65063 m
.39982 .65096 L
s
.583 .18 .083 r
.39343 .64919 m .39261 .64114 L .40949 .6462 L p F P
0 0 0 r
s
.062 .074 .141 r
.60657 .64919 m .59134 .64919 L .57708 .65296 L p F P
0 0 0 r
s
.062 .074 .141 r
.57708 .65296 m .58992 .65296 L .60657 .64919 L p F P
0 0 0 r
s
.062 .074 .141 r
.59134 .64919 m .57612 .64919 L .56423 .65296 L p F P
0 0 0 r
s
.062 .074 .141 r
.56423 .65296 m .57708 .65296 L .59134 .64919 L p F P
0 0 0 r
s
.24 .35 .67 r
.58406 .64058 m
.58569 .64935 L
s
.062 .074 .141 r
.57612 .64919 m .5609 .64919 L .55138 .65296 L p F P
0 0 0 r
s
.062 .074 .141 r
.55138 .65296 m .56423 .65296 L .57612 .64919 L p F P
0 0 0 r
s
.062 .074 .141 r
.5609 .64919 m .54567 .64919 L .53854 .65296 L p F P
0 0 0 r
s
.062 .074 .141 r
.53854 .65296 m .55138 .65296 L .5609 .64919 L p F P
0 0 0 r
s
.062 .074 .141 r
.54567 .64919 m .53045 .64919 L .52569 .65296 L p F P
0 0 0 r
s
.062 .074 .141 r
.52569 .65296 m .53854 .65296 L .54567 .64919 L p F P
0 0 0 r
s
.24 .35 .67 r
.54203 .64058 m
.54284 .64935 L
s
.062 .074 .141 r
.53045 .64919 m .51522 .64919 L .51285 .65296 L p F P
0 0 0 r
s
.062 .074 .141 r
.51285 .65296 m .52569 .65296 L .53045 .64919 L p F P
0 0 0 r
s
.062 .074 .141 r
.51522 .64919 m .5 .64919 L .5 .65296 L p F P
0 0 0 r
s
.062 .074 .141 r
.5 .65296 m .51285 .65296 L .51522 .64919 L p F P
0 0 0 r
s
.062 .074 .141 r
.5 .64919 m .48478 .64919 L .48715 .65296 L p F P
0 0 0 r
s
.062 .074 .141 r
.48715 .65296 m .5 .65296 L .5 .64919 L p F P
0 0 0 r
s
.24 .35 .67 r
.5 .64058 m
.5 .64935 L
s
.062 .074 .141 r
.48478 .64919 m .46955 .64919 L .47431 .65296 L p F P
0 0 0 r
s
.062 .074 .141 r
.47431 .65296 m .48715 .65296 L .48478 .64919 L p F P
0 0 0 r
s
.062 .074 .141 r
.46955 .64919 m .45433 .64919 L .46146 .65296 L p F P
0 0 0 r
s
.062 .074 .141 r
.46146 .65296 m .47431 .65296 L .46955 .64919 L p F P
0 0 0 r
s
.062 .074 .141 r
.45433 .64919 m .4391 .64919 L .44862 .65296 L p F P
0 0 0 r
s
.062 .074 .141 r
.44862 .65296 m .46146 .65296 L .45433 .64919 L p F P
0 0 0 r
s
.24 .35 .67 r
.45716 .64935 m
.45797 .64058 L
s
.062 .074 .141 r
.4391 .64919 m .42388 .64919 L .43577 .65296 L p F P
0 0 0 r
s
.062 .074 .141 r
.43577 .65296 m .44862 .65296 L .4391 .64919 L p F P
0 0 0 r
s
.24 .35 .67 r
.41431 .64935 m
.41594 .64058 L
s
.062 .074 .141 r
.42292 .65296 m .43577 .65296 L .42388 .64919 L p F P
0 0 0 r
s
1 .338 .138 r
.60657 .64919 m .60739 .64114 L .59051 .6462 L p F P
0 0 0 r
s
1 .338 .138 r
.59051 .6462 m .58992 .65296 L .60657 .64919 L p F P
0 0 0 r
s
.83 .24 .1 r
.59893 .66394 m
.60018 .65096 L
s
.60018 .65096 m
.60022 .65063 L
s
.236 .068 .036 r
.36298 .57934 m .36432 .59019 L .35666 .57412 L p F P
0 0 0 r
s
.236 .068 .036 r
.35666 .57412 m .35516 .56248 L .36298 .57934 L p F P
0 0 0 r
s
.973 .282 .11 r
.64334 .57412 m .64484 .56248 L .63702 .57934 L p F P
0 0 0 r
s
.973 .282 .11 r
.63702 .57934 m .63568 .59019 L .64334 .57412 L p F P
0 0 0 r
s
.83 .24 .1 r
.45377 .33487 m
.4844 .33009 L
s
.4844 .33009 m
.48406 .30021 L
s
.4844 .33009 m
.5156 .33009 L
s
.5156 .33009 m
.51594 .30021 L
s
.5156 .33009 m
.54623 .33487 L
s
.32 .095 .05 r
.37551 .60437 m .37662 .61402 L .36563 .60084 L p F P
0 0 0 r
s
.32 .095 .05 r
.36563 .60084 m .36432 .59019 L .37551 .60437 L p F P
0 0 0 r
s
1 .315 .125 r
.63437 .60084 m .63568 .59019 L .62449 .60437 L p F P
0 0 0 r
s
1 .315 .125 r
.62449 .60437 m .62338 .61402 L .63437 .60084 L p F P
0 0 0 r
s
.157 .045 .023 r
.35364 .55059 m .35516 .56248 L .35101 .54442 L p F P
0 0 0 r
s
.157 .045 .023 r
.35101 .54442 m .3494 .53199 L .35364 .55059 L p F P
0 0 0 r
s
.83 .24 .1 r
.35199 .52537 m
.35348 .5499 L
s
.796 .229 .086 r
.64899 .54442 m .6506 .53199 L .64636 .55059 L p F P
0 0 0 r
s
.796 .229 .086 r
.64636 .55059 m .64484 .56248 L .64899 .54442 L p F P
0 0 0 r
s
.83 .24 .1 r
.64652 .5499 m
.64801 .52537 L
s
.24 .35 .67 r
.23852 .34808 m
.24367 .35155 L
s
.20094 .35155 m
.19494 .34808 L
s
.24367 .35155 m
.20094 .35155 L
s
.2821 .34808 m
.28639 .35155 L
s
.28639 .35155 m
.24367 .35155 L
s
.32568 .34808 m
.32911 .35155 L
s
.32911 .35155 m
.28639 .35155 L
s
.36926 .34808 m
.37183 .35155 L
s
.37183 .35155 m
.32911 .35155 L
s
.41284 .34808 m
.41407 .35057 L
s
.37183 .35155 m
.41061 .35155 L
s
.45642 .34808 m
.45728 .35155 L
s
.42314 .35155 m
.45728 .35155 L
s
.5 .34808 m
.5 .35155 L
s
.45728 .35155 m
.5 .35155 L
s
.54272 .35155 m
.54358 .34808 L
s
.5 .35155 m
.54272 .35155 L
s
.58593 .35057 m
.58716 .34808 L
s
.54272 .35155 m
.57686 .35155 L
s
.63074 .34808 m
.62817 .35155 L
s
.58939 .35155 m
.62817 .35155 L
s
.67432 .34808 m
.67089 .35155 L
s
.67089 .35155 m
.62817 .35155 L
s
.7179 .34808 m
.71361 .35155 L
s
.71361 .35155 m
.67089 .35155 L
s
.76148 .34808 m
.75633 .35155 L
s
.75633 .35155 m
.71361 .35155 L
s
.80506 .34808 m
.79906 .35155 L
s
.79906 .35155 m
.75633 .35155 L
s
.7 .195 .071 r
.34775 .51929 m .3494 .53199 L .3489 .51295 L p F P
0 0 0 r
s
.7 .195 .071 r
.3489 .51295 m .34724 .5 L .34775 .51929 L p F P
0 0 0 r
s
.098 .028 .012 r
.6511 .51295 m .65276 .5 L .65225 .51929 L p F P
0 0 0 r
s
.098 .028 .012 r
.65225 .51929 m .6506 .53199 L .6511 .51295 L p F P
0 0 0 r
s
.83 .24 .1 r
.54623 .69075 m
.54724 .66874 L
s
.54623 .69075 m
.51568 .69643 L
s
.48432 .69643 m
.45377 .69075 L
s
.45377 .69075 m
.45276 .66874 L
s
.42483 .3443 m
.45377 .33487 L
s
.45377 .33487 m
.45275 .30502 L
s
.54623 .33487 m
.54725 .30502 L
s
.54623 .33487 m
.57517 .3443 L
s
.43 .135 .065 r
.39092 .62466 m .39177 .63297 L .3777 .62349 L p F P
0 0 0 r
s
.43 .135 .065 r
.3777 .62349 m .37662 .61402 L .39092 .62466 L p F P
0 0 0 r
s
1 .333 .134 r
.6223 .62349 m .62338 .61402 L .60908 .62466 L p F P
0 0 0 r
s
.83 .24 .1 r
.62083 .62448 m
.62093 .62361 L
s
1 .333 .134 r
.60908 .62466 m .60823 .63297 L .6223 .62349 L p F P
0 0 0 r
s
1 .334 .136 r
.3751 .37387 m .37621 .38561 L .39302 .37774 L p F P
0 0 0 r
s
1 .334 .136 r
.39302 .37774 m .39219 .36755 L .3751 .37387 L p F P
0 0 0 r
s
.597 .179 .083 r
.60698 .37774 m .60781 .36755 L .6249 .37387 L p F P
0 0 0 r
s
.597 .179 .083 r
.6249 .37387 m .62379 .38561 L .60698 .37774 L p F P
0 0 0 r
s
.899 .254 .097 r
.34554 .48676 m .34724 .5 L .35047 .48105 L p F P
0 0 0 r
s
.899 .254 .097 r
.35047 .48105 m .34885 .46789 L .34554 .48676 L p F P
0 0 0 r
s
.83 .24 .1 r
.34877 .5 m
.35381 .47514 L
s
.181 .052 .027 r
.64953 .48105 m .65115 .46789 L .65446 .48676 L p F P
0 0 0 r
s
.181 .052 .027 r
.65446 .48676 m .65276 .5 L .64953 .48105 L p F P
0 0 0 r
s
.83 .24 .1 r
.64619 .47514 m
.65123 .5 L
s
.24 .35 .67 r
.24294 .64935 m
.20009 .64935 L
s
.28578 .64935 m
.24294 .64935 L
s
.32862 .64935 m
.28578 .64935 L
s
.37147 .64935 m
.32862 .64935 L
s
.37147 .64935 m
.39797 .64935 L
s
.40977 .64935 m
.41431 .64935 L
s
.41431 .64935 m
.45716 .64935 L
s
.45716 .64935 m
.5 .64935 L
s
.5 .64935 m
.54284 .64935 L
s
.54284 .64935 m
.58569 .64935 L
s
.60203 .64935 m
.62853 .64935 L
s
.58569 .64935 m
.59023 .64935 L
s
.67138 .64935 m
.62853 .64935 L
s
.71422 .64935 m
.67138 .64935 L
s
.75706 .64935 m
.71422 .64935 L
s
.79991 .64935 m
.75706 .64935 L
s
.24294 .64935 m
.23776 .65188 L
s
.19405 .65188 m
.20009 .64935 L
s
.28578 .64935 m
.28147 .65188 L
s
.32862 .64935 m
.32517 .65188 L
s
.37147 .64935 m
.36888 .65188 L
s
.45629 .65188 m
.45716 .64935 L
s
.5 .64935 m
.5 .65188 L
s
.54284 .64935 m
.54371 .65188 L
s
.62853 .64935 m
.63112 .65188 L
s
.67138 .64935 m
.67483 .65188 L
s
.71422 .64935 m
.71853 .65188 L
s
.75706 .64935 m
.76224 .65188 L
s
.79991 .64935 m
.80595 .65188 L
s
.83 .24 .1 r
.51568 .69643 m
.51602 .67449 L
s
.51568 .69643 m
.48432 .69643 L
s
.48432 .69643 m
.48398 .67449 L
s
1 .332 .137 r
.39049 .34669 m .39135 .3572 L .41092 .35609 L p F P
0 0 0 r
s
1 .332 .137 r
.41092 .35609 m .41034 .34748 L .39049 .34669 L p F P
0 0 0 r
s
.702 .21 .094 r
.58908 .35609 m .58966 .34748 L .60951 .34669 L p F P
0 0 0 r
s
.702 .21 .094 r
.60951 .34669 m .60865 .3572 L .58908 .35609 L p F P
0 0 0 r
s
1 .295 .116 r
.34718 .45444 m .34885 .46789 L .35578 .45015 L p F P
0 0 0 r
s
1 .295 .116 r
.35578 .45015 m .35427 .43714 L .34718 .45444 L p F P
0 0 0 r
s
.249 .072 .039 r
.64422 .45015 m .64573 .43714 L .65282 .45444 L p F P
0 0 0 r
s
.249 .072 .039 r
.65282 .45444 m .65115 .46789 L .64422 .45015 L p F P
0 0 0 r
s
1 .33 .134 r
.3621 .39651 m .36346 .40923 L .3773 .39713 L p F P
0 0 0 r
s
1 .33 .134 r
.3773 .39713 m .37621 .38561 L .3621 .39651 L p F P
0 0 0 r
s
.83 .24 .1 r
.37642 .3758 m
.37908 .40409 L
s
.465 .141 .068 r
.6227 .39713 m .62379 .38561 L .6379 .39651 L p F P
0 0 0 r
s
.465 .141 .068 r
.6379 .39651 m .63654 .40923 L .6227 .39713 L p F P
0 0 0 r
s
.83 .24 .1 r
.62092 .40409 m
.62358 .3758 L
s
1 .318 .127 r
.35272 .42385 m .35427 .43714 L .36478 .4217 L p F P
0 0 0 r
s
.83 .24 .1 r
.36205 .42498 m
.36498 .45191 L
s
1 .318 .127 r
.36478 .4217 m .36346 .40923 L .35272 .42385 L p F P
0 0 0 r
s
.83 .24 .1 r
.36205 .42498 m
.37908 .40409 L
s
.332 .1 .051 r
.63522 .4217 m .63654 .40923 L .64728 .42385 L p F P
0 0 0 r
s
.332 .1 .051 r
.64728 .42385 m .64573 .43714 L .63522 .4217 L p F P
0 0 0 r
s
.83 .24 .1 r
.62092 .40409 m
.63795 .42498 L
s
.63502 .45191 m
.63795 .42498 L
s
.3987 .35809 m
.41739 .34823 L
s
.4188 .34748 m
.42483 .3443 L
s
.42483 .3443 m
.42317 .31451 L
s
.57517 .3443 m
.57683 .31451 L
s
.58261 .34823 m
.6013 .35809 L
s
.57517 .3443 m
.5812 .34748 L
s
.583 .18 .083 r
.4089 .63935 m .40949 .6462 L .39261 .64114 L p F P
0 0 0 r
s
.583 .18 .083 r
.39261 .64114 m .39177 .63297 L .4089 .63935 L p F P
0 0 0 r
s
1 .338 .138 r
.60739 .64114 m .60823 .63297 L .5911 .63935 L p F P
0 0 0 r
s
1 .338 .138 r
.5911 .63935 m .59051 .6462 L .60739 .64114 L p F P
0 0 0 r
s
.32 .095 .05 r
.37439 .59454 m .37551 .60437 L .36432 .59019 L p F P
0 0 0 r
s
.32 .095 .05 r
.36432 .59019 m .36298 .57934 L .37439 .59454 L p F P
0 0 0 r
s
1 .315 .125 r
.63568 .59019 m .63702 .57934 L .62561 .59454 L p F P
0 0 0 r
s
1 .315 .125 r
.62561 .59454 m .62449 .60437 L .63568 .59019 L p F P
0 0 0 r
s
.236 .068 .036 r
.36162 .56827 m .36298 .57934 L .35516 .56248 L p F P
0 0 0 r
s
.236 .068 .036 r
.35516 .56248 m .35364 .55059 L .36162 .56827 L p F P
0 0 0 r
s
.973 .282 .11 r
.64484 .56248 m .64636 .55059 L .63838 .56827 L p F P
0 0 0 r
s
.973 .282 .11 r
.63838 .56827 m .63702 .57934 L .64484 .56248 L p F P
0 0 0 r
s
1 .334 .136 r
.37397 .36193 m .3751 .37387 L .39219 .36755 L p F P
0 0 0 r
s
1 .334 .136 r
.39219 .36755 m .39135 .3572 L .37397 .36193 L p F P
0 0 0 r
s
.597 .179 .083 r
.60781 .36755 m .60865 .3572 L .62603 .36193 L p F P
0 0 0 r
s
.597 .179 .083 r
.62603 .36193 m .6249 .37387 L .60781 .36755 L p F P
0 0 0 r
s
.157 .045 .023 r
.35208 .53845 m .35364 .55059 L .3494 .53199 L p F P
0 0 0 r
s
.157 .045 .023 r
.3494 .53199 m .34775 .51929 L .35208 .53845 L p F P
0 0 0 r
s
.83 .24 .1 r
.34877 .5 m
.35199 .52537 L
s
.796 .229 .086 r
.6506 .53199 m .65225 .51929 L .64792 .53845 L p F P
0 0 0 r
s
.83 .24 .1 r
.64801 .52537 m
.65123 .5 L
s
.796 .229 .086 r
.64792 .53845 m .64636 .55059 L .6506 .53199 L p F P
0 0 0 r
s
.43 .135 .065 r
.39006 .61622 m .39092 .62466 L .37662 .61402 L p F P
0 0 0 r
s
.43 .135 .065 r
.37662 .61402 m .37551 .60437 L .39006 .61622 L p F P
0 0 0 r
s
1 .333 .134 r
.62338 .61402 m .62449 .60437 L .60994 .61622 L p F P
0 0 0 r
s
.83 .24 .1 r
.62189 .61512 m
.62199 .61424 L
s
1 .333 .134 r
.60994 .61622 m .60908 .62466 L .62338 .61402 L p F P
0 0 0 r
s
.172 .286 .565 r
.39049 .34669 m .40614 .34669 L .42315 .34748 L p F P
0 0 0 r
s
.172 .286 .565 r
.42315 .34748 m .41034 .34748 L .39049 .34669 L p F P
0 0 0 r
s
.172 .286 .565 r
.40614 .34669 m .42178 .34669 L .43596 .34748 L p F P
0 0 0 r
s
.172 .286 .565 r
.43596 .34748 m .42315 .34748 L .40614 .34669 L p F P
0 0 0 r
s
.172 .286 .565 r
.42178 .34669 m .43742 .34669 L .44877 .34748 L p F P
0 0 0 r
s
.172 .286 .565 r
.44877 .34748 m .43596 .34748 L .42178 .34669 L p F P
0 0 0 r
s
.172 .286 .565 r
.43742 .34669 m .45307 .34669 L .46157 .34748 L p F P
0 0 0 r
s
.172 .286 .565 r
.46157 .34748 m .44877 .34748 L .43742 .34669 L p F P
0 0 0 r
s
.172 .286 .565 r
.45307 .34669 m .46871 .34669 L .47438 .34748 L p F P
0 0 0 r
s
.172 .286 .565 r
.47438 .34748 m .46157 .34748 L .45307 .34669 L p F P
0 0 0 r
s
.172 .286 .565 r
.46871 .34669 m .48436 .34669 L .48719 .34748 L p F P
0 0 0 r
s
.172 .286 .565 r
.48719 .34748 m .47438 .34748 L .46871 .34669 L p F P
0 0 0 r
s
.172 .286 .565 r
.48436 .34669 m .5 .34669 L .5 .34748 L p F P
0 0 0 r
s
.172 .286 .565 r
.5 .34748 m .48719 .34748 L .48436 .34669 L p F P
0 0 0 r
s
.172 .286 .565 r
.5 .34669 m .51564 .34669 L .51281 .34748 L p F P
0 0 0 r
s
.172 .286 .565 r
.51281 .34748 m .5 .34748 L .5 .34669 L p F P
0 0 0 r
s
.172 .286 .565 r
.51564 .34669 m .53129 .34669 L .52562 .34748 L p F P
0 0 0 r
s
.172 .286 .565 r
.52562 .34748 m .51281 .34748 L .51564 .34669 L p F P
0 0 0 r
s
.172 .286 .565 r
.53129 .34669 m .54693 .34669 L .53843 .34748 L p F P
0 0 0 r
s
.172 .286 .565 r
.53843 .34748 m .52562 .34748 L .53129 .34669 L p F P
0 0 0 r
s
.172 .286 .565 r
.54693 .34669 m .56258 .34669 L .55123 .34748 L p F P
0 0 0 r
s
.172 .286 .565 r
.55123 .34748 m .53843 .34748 L .54693 .34669 L p F P
0 0 0 r
s
.172 .286 .565 r
.56258 .34669 m .57822 .34669 L .56404 .34748 L p F P
0 0 0 r
s
.172 .286 .565 r
.56404 .34748 m .55123 .34748 L .56258 .34669 L p F P
0 0 0 r
s
.172 .286 .565 r
.57822 .34669 m .59386 .34669 L .57685 .34748 L p F P
0 0 0 r
s
.172 .286 .565 r
.57685 .34748 m .56404 .34748 L .57822 .34669 L p F P
0 0 0 r
s
.172 .286 .565 r
.59386 .34669 m .60951 .34669 L .58966 .34748 L p F P
0 0 0 r
s
.172 .286 .565 r
.58966 .34748 m .57685 .34748 L .59386 .34669 L p F P
0 0 0 r
s
.83 .24 .1 r
.41783 .65367 m
.42393 .65756 L
s
.57607 .65756 m
.58217 .65367 L
s
.7 .195 .071 r
.34606 .50631 m .34775 .51929 L .34724 .5 L p F P
0 0 0 r
s
.7 .195 .071 r
.34724 .5 m .34554 .48676 L .34606 .50631 L p F P
0 0 0 r
s
.098 .028 .012 r
.65276 .5 m .65446 .48676 L .65394 .50631 L p F P
0 0 0 r
s
.098 .028 .012 r
.65394 .50631 m .65225 .51929 L .65276 .5 L p F P
0 0 0 r
s
.83 .24 .1 r
.39785 .34691 m
.3987 .35809 L
s
.6013 .35809 m
.60215 .34691 L
s
.025 .036 .068 r
.43577 .65296 m .42292 .65296 L .43956 .65302 L p F P
0 0 0 r
s
.025 .036 .068 r
.42292 .65296 m .41008 .65296 L .42949 .65302 L p F P
0 0 0 r
s
.025 .036 .068 r
.42949 .65302 m .43956 .65302 L .42292 .65296 L p F P
0 0 0 r
s
.712 .216 .097 r
.42913 .64773 m .42949 .65302 L .41008 .65296 L p F P
0 0 0 r
s
.83 .24 .1 r
.41675 .65298 m
.41783 .65367 L
s
.712 .216 .097 r
.41008 .65296 m .40949 .6462 L .42913 .64773 L p F P
0 0 0 r
s
.24 .35 .67 r
.41259 .65188 m
.41309 .65114 L
s
.025 .036 .068 r
.58992 .65296 m .57708 .65296 L .56044 .65302 L p F P
0 0 0 r
s
.025 .036 .068 r
.56044 .65302 m .57051 .65302 L .58992 .65296 L p F P
0 0 0 r
s
.025 .036 .068 r
.57708 .65296 m .56423 .65296 L .55037 .65302 L p F P
0 0 0 r
s
.025 .036 .068 r
.55037 .65302 m .56044 .65302 L .57708 .65296 L p F P
0 0 0 r
s
.025 .036 .068 r
.56423 .65296 m .55138 .65296 L .54029 .65302 L p F P
0 0 0 r
s
.025 .036 .068 r
.54029 .65302 m .55037 .65302 L .56423 .65296 L p F P
0 0 0 r
s
.025 .036 .068 r
.55138 .65296 m .53854 .65296 L .53022 .65302 L p F P
0 0 0 r
s
.025 .036 .068 r
.53022 .65302 m .54029 .65302 L .55138 .65296 L p F P
0 0 0 r
s
.025 .036 .068 r
.53854 .65296 m .52569 .65296 L .52015 .65302 L p F P
0 0 0 r
s
.025 .036 .068 r
.52015 .65302 m .53022 .65302 L .53854 .65296 L p F P
0 0 0 r
s
.025 .036 .068 r
.52569 .65296 m .51285 .65296 L .51007 .65302 L p F P
0 0 0 r
s
.025 .036 .068 r
.51007 .65302 m .52015 .65302 L .52569 .65296 L p F P
0 0 0 r
s
.025 .036 .068 r
.51285 .65296 m .5 .65296 L .5 .65302 L p F P
0 0 0 r
s
.025 .036 .068 r
.5 .65302 m .51007 .65302 L .51285 .65296 L p F P
0 0 0 r
s
.025 .036 .068 r
.5 .65296 m .48715 .65296 L .48993 .65302 L p F P
0 0 0 r
s
.025 .036 .068 r
.48993 .65302 m .5 .65302 L .5 .65296 L p F P
0 0 0 r
s
.025 .036 .068 r
.48715 .65296 m .47431 .65296 L .47985 .65302 L p F P
0 0 0 r
s
.025 .036 .068 r
.47985 .65302 m .48993 .65302 L .48715 .65296 L p F P
0 0 0 r
s
.025 .036 .068 r
.47431 .65296 m .46146 .65296 L .46978 .65302 L p F P
0 0 0 r
s
.025 .036 .068 r
.46978 .65302 m .47985 .65302 L .47431 .65296 L p F P
0 0 0 r
s
.025 .036 .068 r
.46146 .65296 m .44862 .65296 L .45971 .65302 L p F P
0 0 0 r
s
.025 .036 .068 r
.45971 .65302 m .46978 .65302 L .46146 .65296 L p F P
0 0 0 r
s
.025 .036 .068 r
.44862 .65296 m .43577 .65296 L .44963 .65302 L p F P
0 0 0 r
s
.025 .036 .068 r
.44963 .65302 m .45971 .65302 L .44862 .65296 L p F P
0 0 0 r
s
.025 .036 .068 r
.43956 .65302 m .44963 .65302 L .43577 .65296 L p F P
0 0 0 r
s
1 .336 .139 r
.58992 .65296 m .59051 .6462 L .57087 .64773 L p F P
0 0 0 r
s
1 .336 .139 r
.57087 .64773 m .57051 .65302 L .58992 .65296 L p F P
0 0 0 r
s
.24 .35 .67 r
.58691 .65114 m
.58741 .65188 L
s
.83 .24 .1 r
.58217 .65367 m
.58325 .65298 L
s
1 .33 .134 r
.36072 .38353 m .3621 .39651 L .37621 .38561 L p F P
0 0 0 r
s
1 .33 .134 r
.37621 .38561 m .3751 .37387 L .36072 .38353 L p F P
0 0 0 r
s
.465 .141 .068 r
.62379 .38561 m .6249 .37387 L .63928 .38353 L p F P
0 0 0 r
s
.465 .141 .068 r
.63928 .38353 m .6379 .39651 L .62379 .38561 L p F P
0 0 0 r
s
.899 .254 .097 r
.34381 .47322 m .34554 .48676 L .34885 .46789 L p F P
0 0 0 r
s
.899 .254 .097 r
.34885 .46789 m .34718 .45444 L .34381 .47322 L p F P
0 0 0 r
s
.181 .052 .027 r
.65115 .46789 m .65282 .45444 L .65619 .47322 L p F P
0 0 0 r
s
.181 .052 .027 r
.65619 .47322 m .65446 .48676 L .65115 .46789 L p F P
0 0 0 r
s
.583 .18 .083 r
.4083 .63241 m .4089 .63935 L .39177 .63297 L p F P
0 0 0 r
s
.583 .18 .083 r
.39177 .63297 m .39092 .62466 L .4083 .63241 L p F P
0 0 0 r
s
1 .338 .138 r
.60823 .63297 m .60908 .62466 L .5917 .63241 L p F P
0 0 0 r
s
1 .338 .138 r
.5917 .63241 m .5911 .63935 L .60823 .63297 L p F P
0 0 0 r
s
1 .295 .116 r
.34548 .44069 m .34718 .45444 L .35427 .43714 L p F P
0 0 0 r
s
.83 .24 .1 r
.3506 .44841 m
.35381 .47514 L
s
1 .295 .116 r
.35427 .43714 m .35272 .42385 L .34548 .44069 L p F P
0 0 0 r
s
.83 .24 .1 r
.3506 .44841 m
.36205 .42498 L
s
.249 .072 .039 r
.64573 .43714 m .64728 .42385 L .65452 .44069 L p F P
0 0 0 r
s
.249 .072 .039 r
.65452 .44069 m .65282 .45444 L .64573 .43714 L p F P
0 0 0 r
s
.83 .24 .1 r
.63795 .42498 m
.6494 .44841 L
s
.64619 .47514 m
.6494 .44841 L
s
1 .318 .127 r
.35115 .41027 m .35272 .42385 L .36346 .40923 L p F P
0 0 0 r
s
1 .318 .127 r
.36346 .40923 m .3621 .39651 L .35115 .41027 L p F P
0 0 0 r
s
.332 .1 .051 r
.63654 .40923 m .6379 .39651 L .64885 .41027 L p F P
0 0 0 r
s
.332 .1 .051 r
.64885 .41027 m .64728 .42385 L .63654 .40923 L p F P
0 0 0 r
s
1 .334 .136 r
.37281 .34976 m .37397 .36193 L .39135 .3572 L p F P
0 0 0 r
s
.83 .24 .1 r
.37642 .3758 m
.3987 .35809 L
s
1 .334 .136 r
.39135 .3572 m .39049 .34669 L .37281 .34976 L p F P
0 0 0 r
s
.597 .179 .083 r
.60865 .3572 m .60951 .34669 L .62719 .34976 L p F P
0 0 0 r
s
.597 .179 .083 r
.62719 .34976 m .62603 .36193 L .60865 .3572 L p F P
0 0 0 r
s
.83 .24 .1 r
.6013 .35809 m
.62358 .3758 L
s
.57607 .65756 m
.5764 .653 L
s
.57607 .65756 m
.54724 .66874 L
s
.45276 .66874 m
.42393 .65756 L
s
.4236 .653 m
.42393 .65756 L
s
.32 .095 .05 r
.37324 .58454 m .37439 .59454 L .36298 .57934 L p F P
0 0 0 r
s
.83 .24 .1 r
.36268 .57689 m
.36483 .58027 L
s
.32 .095 .05 r
.36298 .57934 m .36162 .56827 L .37324 .58454 L p F P
0 0 0 r
s
1 .315 .125 r
.63702 .57934 m .63838 .56827 L .62676 .58454 L p F P
0 0 0 r
s
1 .315 .125 r
.62676 .58454 m .62561 .59454 L .63702 .57934 L p F P
0 0 0 r
s
.43 .135 .065 r
.38918 .60765 m .39006 .61622 L .37551 .60437 L p F P
0 0 0 r
s
.43 .135 .065 r
.37551 .60437 m .37439 .59454 L .38918 .60765 L p F P
0 0 0 r
s
1 .333 .134 r
.62449 .60437 m .62561 .59454 L .61082 .60765 L p F P
0 0 0 r
s
.83 .24 .1 r
.62297 .6056 m
.62308 .60471 L
s
1 .333 .134 r
.61082 .60765 m .60994 .61622 L .62449 .60437 L p F P
0 0 0 r
s
.236 .068 .036 r
.36023 .55697 m .36162 .56827 L .35364 .55059 L p F P
0 0 0 r
s
.236 .068 .036 r
.35364 .55059 m .35208 .53845 L .36023 .55697 L p F P
0 0 0 r
s
.973 .282 .11 r
.64636 .55059 m .64792 .53845 L .63977 .55697 L p F P
0 0 0 r
s
.973 .282 .11 r
.63977 .55697 m .63838 .56827 L .64636 .55059 L p F P
0 0 0 r
s
.712 .216 .097 r
.42876 .64238 m .42913 .64773 L .40949 .6462 L p F P
0 0 0 r
s
.712 .216 .097 r
.40949 .6462 m .4089 .63935 L .42876 .64238 L p F P
0 0 0 r
s
1 .336 .139 r
.59051 .6462 m .5911 .63935 L .57124 .64238 L p F P
0 0 0 r
s
1 .336 .139 r
.57124 .64238 m .57087 .64773 L .59051 .6462 L p F P
0 0 0 r
s
.83 .24 .1 r
.45275 .30502 m
.48406 .30021 L
s
.48406 .30021 m
.4837 .26899 L
s
.48406 .30021 m
.51594 .30021 L
s
.51594 .30021 m
.5163 .26899 L
s
.51594 .30021 m
.54725 .30502 L
s
.24 .35 .67 r
.23326 .35131 m
.23852 .34808 L
s
.19494 .34808 m
.18881 .35131 L
s
.23852 .34808 m
.19494 .34808 L
s
.27772 .35131 m
.2821 .34808 L
s
.2821 .34808 m
.23852 .34808 L
s
.32218 .35131 m
.32568 .34808 L
s
.32568 .34808 m
.2821 .34808 L
s
.36926 .34808 m
.32568 .34808 L
s
.39622 .34808 m
.41284 .34808 L
s
.36926 .34808 m
.38249 .34808 L
s
.45642 .34808 m
.41284 .34808 L
s
.5 .34808 m
.45642 .34808 L
s
.54358 .34808 m
.5 .34808 L
s
.58716 .34808 m
.54358 .34808 L
s
.58716 .34808 m
.60378 .34808 L
s
.61751 .34808 m
.63074 .34808 L
s
.67782 .35131 m
.67432 .34808 L
s
.67432 .34808 m
.63074 .34808 L
s
.72228 .35131 m
.7179 .34808 L
s
.7179 .34808 m
.67432 .34808 L
s
.76674 .35131 m
.76148 .34808 L
s
.76148 .34808 m
.7179 .34808 L
s
.81119 .35131 m
.80506 .34808 L
s
.80506 .34808 m
.76148 .34808 L
s
.157 .045 .023 r
.35049 .52605 m .35208 .53845 L .34775 .51929 L p F P
0 0 0 r
s
.157 .045 .023 r
.34775 .51929 m .34606 .50631 L .35049 .52605 L p F P
0 0 0 r
s
.83 .24 .1 r
.34877 .5 m
.35027 .52509 L
s
.796 .229 .086 r
.65225 .51929 m .65394 .50631 L .64951 .52605 L p F P
0 0 0 r
s
.796 .229 .086 r
.64951 .52605 m .64792 .53845 L .65225 .51929 L p F P
0 0 0 r
s
.83 .24 .1 r
.64973 .52509 m
.65123 .5 L
s
.583 .18 .083 r
.40769 .62538 m .4083 .63241 L .39092 .62466 L p F P
0 0 0 r
s
.583 .18 .083 r
.39092 .62466 m .39006 .61622 L .40769 .62538 L p F P
0 0 0 r
s
1 .338 .138 r
.60908 .62466 m .60994 .61622 L .59231 .62538 L p F P
0 0 0 r
s
1 .338 .138 r
.59231 .62538 m .5917 .63241 L .60908 .62466 L p F P
0 0 0 r
s
1 .33 .134 r
.35931 .3703 m .36072 .38353 L .3751 .37387 L p F P
0 0 0 r
s
1 .33 .134 r
.3751 .37387 m .37397 .36193 L .35931 .3703 L p F P
0 0 0 r
s
.465 .141 .068 r
.6249 .37387 m .62603 .36193 L .64069 .3703 L p F P
0 0 0 r
s
.465 .141 .068 r
.64069 .3703 m .63928 .38353 L .6249 .37387 L p F P
0 0 0 r
s
.83 .24 .1 r
.54724 .66874 m
.54797 .65306 L
s
.54724 .66874 m
.51602 .67449 L
s
.48398 .67449 m
.45276 .66874 L
s
.45203 .65306 m
.45276 .66874 L
s
.42317 .31451 m
.45275 .30502 L
s
.45275 .30502 m
.45169 .27383 L
s
.54725 .30502 m
.54831 .27383 L
s
.54725 .30502 m
.57683 .31451 L
s
.7 .195 .071 r
.34434 .49304 m .34606 .50631 L .34554 .48676 L p F P
0 0 0 r
s
.7 .195 .071 r
.34554 .48676 m .34381 .47322 L .34434 .49304 L p F P
0 0 0 r
s
.098 .028 .012 r
.65446 .48676 m .65619 .47322 L .65566 .49304 L p F P
0 0 0 r
s
.098 .028 .012 r
.65566 .49304 m .65394 .50631 L .65446 .48676 L p F P
0 0 0 r
s
.24 .35 .67 r
.23776 .65188 m
.19405 .65188 L
s
.28147 .65188 m
.23776 .65188 L
s
.32517 .65188 m
.28147 .65188 L
s
.36888 .65188 m
.32517 .65188 L
s
.36888 .65188 m
.41259 .65188 L
s
.41259 .65188 m
.42137 .65188 L
s
.42941 .65188 m
.45629 .65188 L
s
.5 .65188 m
.45629 .65188 L
s
.54371 .65188 m
.5 .65188 L
s
.57863 .65188 m
.58741 .65188 L
s
.54371 .65188 m
.57059 .65188 L
s
.58741 .65188 m
.63112 .65188 L
s
.67483 .65188 m
.63112 .65188 L
s
.71853 .65188 m
.67483 .65188 L
s
.76224 .65188 m
.71853 .65188 L
s
.80595 .65188 m
.76224 .65188 L
s
.23776 .65188 m
.23251 .64765 L
s
.18792 .64765 m
.19405 .65188 L
s
.28147 .65188 m
.27709 .64765 L
s
.32517 .65188 m
.32167 .64765 L
s
.36888 .65188 m
.36625 .64765 L
s
.41084 .64765 m
.41259 .65188 L
s
.58741 .65188 m
.58916 .64765 L
s
.63112 .65188 m
.63375 .64765 L
s
.67483 .65188 m
.67833 .64765 L
s
.71853 .65188 m
.72291 .64765 L
s
.76224 .65188 m
.76749 .64765 L
s
.80595 .65188 m
.81208 .64765 L
s
.899 .254 .097 r
.34203 .45938 m .34381 .47322 L .34718 .45444 L p F P
0 0 0 r
s
.899 .254 .097 r
.34718 .45444 m .34548 .44069 L .34203 .45938 L p F P
0 0 0 r
s
.83 .24 .1 r
.3454 .4735 m
.3506 .44841 L
s
.181 .052 .027 r
.65282 .45444 m .65452 .44069 L .65797 .45938 L p F P
0 0 0 r
s
.181 .052 .027 r
.65797 .45938 m .65619 .47322 L .65282 .45444 L p F P
0 0 0 r
s
.83 .24 .1 r
.6494 .44841 m
.6546 .4735 L
s
1 .318 .127 r
.34953 .3964 m .35115 .41027 L .3621 .39651 L p F P
0 0 0 r
s
.83 .24 .1 r
.35898 .39685 m
.36205 .42498 L
s
1 .318 .127 r
.3621 .39651 m .36072 .38353 L .34953 .3964 L p F P
0 0 0 r
s
.83 .24 .1 r
.35898 .39685 m
.37642 .3758 L
s
.332 .1 .051 r
.6379 .39651 m .63928 .38353 L .65047 .3964 L p F P
0 0 0 r
s
.332 .1 .051 r
.65047 .3964 m .64885 .41027 L .6379 .39651 L p F P
0 0 0 r
s
.83 .24 .1 r
.62358 .3758 m
.64102 .39685 L
s
.63795 .42498 m
.64102 .39685 L
s
.51602 .67449 m
.51636 .65309 L
s
.51602 .67449 m
.48398 .67449 L
s
.48364 .65309 m
.48398 .67449 L
s
1 .295 .116 r
.34375 .42663 m .34548 .44069 L .35272 .42385 L p F P
0 0 0 r
s
1 .295 .116 r
.35272 .42385 m .35115 .41027 L .34375 .42663 L p F P
0 0 0 r
s
.249 .072 .039 r
.64728 .42385 m .64885 .41027 L .65625 .42663 L p F P
0 0 0 r
s
.249 .072 .039 r
.65625 .42663 m .65452 .44069 L .64728 .42385 L p F P
0 0 0 r
s
.055 .066 .127 r
.37281 .34976 m .39098 .34976 L .40614 .34669 L p F P
0 0 0 r
s
.83 .24 .1 r
.39644 .32839 m
.39778 .34597 L
s
.39778 .34597 m
.39783 .34669 L
s
.055 .066 .127 r
.40614 .34669 m .39049 .34669 L .37281 .34976 L p F P
0 0 0 r
s
.055 .066 .127 r
.39098 .34976 m .40915 .34976 L .42178 .34669 L p F P
0 0 0 r
s
.055 .066 .127 r
.42178 .34669 m .40614 .34669 L .39098 .34976 L p F P
0 0 0 r
s
.055 .066 .127 r
.40915 .34976 m .42732 .34976 L .43742 .34669 L p F P
0 0 0 r
s
.055 .066 .127 r
.43742 .34669 m .42178 .34669 L .40915 .34976 L p F P
0 0 0 r
s
.24 .35 .67 r
.41109 .35131 m
.41193 .34976 L
s
.055 .066 .127 r
.42732 .34976 m .44549 .34976 L .45307 .34669 L p F P
0 0 0 r
s
.055 .066 .127 r
.45307 .34669 m .43742 .34669 L .42732 .34976 L p F P
0 0 0 r
s
.055 .066 .127 r
.44549 .34976 m .46366 .34976 L .46871 .34669 L p F P
0 0 0 r
s
.24 .35 .67 r
.45635 .34832 m
.45642 .34808 L
s
.055 .066 .127 r
.46871 .34669 m .45307 .34669 L .44549 .34976 L p F P
0 0 0 r
s
.24 .35 .67 r
.45554 .35131 m
.45596 .34976 L
s
.055 .066 .127 r
.46366 .34976 m .48183 .34976 L .48436 .34669 L p F P
0 0 0 r
s
.055 .066 .127 r
.48436 .34669 m .46871 .34669 L .46366 .34976 L p F P
0 0 0 r
s
.055 .066 .127 r
.48183 .34976 m .5 .34976 L .5 .34669 L p F P
0 0 0 r
s
.055 .066 .127 r
.5 .34669 m .48436 .34669 L .48183 .34976 L p F P
0 0 0 r
s
.055 .066 .127 r
.5 .34976 m .51817 .34976 L .51564 .34669 L p F P
0 0 0 r
s
.055 .066 .127 r
.51564 .34669 m .5 .34669 L .5 .34976 L p F P
0 0 0 r
s
.24 .35 .67 r
.5 .34976 m
.5 .35131 L
s
.055 .066 .127 r
.51817 .34976 m .53634 .34976 L .53129 .34669 L p F P
0 0 0 r
s
.055 .066 .127 r
.53129 .34669 m .51564 .34669 L .51817 .34976 L p F P
0 0 0 r
s
.055 .066 .127 r
.53634 .34976 m .55451 .34976 L .54693 .34669 L p F P
0 0 0 r
s
.055 .066 .127 r
.54693 .34669 m .53129 .34669 L .53634 .34976 L p F P
0 0 0 r
s
.24 .35 .67 r
.54404 .34976 m
.54446 .35131 L
s
.055 .066 .127 r
.55451 .34976 m .57268 .34976 L .56258 .34669 L p F P
0 0 0 r
s
.055 .066 .127 r
.56258 .34669 m .54693 .34669 L .55451 .34976 L p F P
0 0 0 r
s
.055 .066 .127 r
.57268 .34976 m .59085 .34976 L .57822 .34669 L p F P
0 0 0 r
s
.055 .066 .127 r
.57822 .34669 m .56258 .34669 L .57268 .34976 L p F P
0 0 0 r
s
.055 .066 .127 r
.59085 .34976 m .60902 .34976 L .59386 .34669 L p F P
0 0 0 r
s
.83 .24 .1 r
.60222 .34597 m
.60356 .32839 L
s
.60217 .34669 m
.60222 .34597 L
s
.055 .066 .127 r
.59386 .34669 m .57822 .34669 L .59085 .34976 L p F P
0 0 0 r
s
.24 .35 .67 r
.58807 .34976 m
.58891 .35131 L
s
.055 .066 .127 r
.60902 .34976 m .62719 .34976 L .60951 .34669 L p F P
0 0 0 r
s
.055 .066 .127 r
.60951 .34669 m .59386 .34669 L .60902 .34976 L p F P
0 0 0 r
s
.712 .216 .097 r
.4284 .63697 m .42876 .64238 L .4089 .63935 L p F P
0 0 0 r
s
.712 .216 .097 r
.4089 .63935 m .4083 .63241 L .4284 .63697 L p F P
0 0 0 r
s
1 .336 .139 r
.5911 .63935 m .5917 .63241 L .5716 .63697 L p F P
0 0 0 r
s
1 .336 .139 r
.5716 .63697 m .57124 .64238 L .5911 .63935 L p F P
0 0 0 r
s
.83 .24 .1 r
.39644 .32839 m
.42317 .31451 L
s
.42317 .31451 m
.42143 .28338 L
s
.57683 .31451 m
.57857 .28338 L
s
.57683 .31451 m
.60356 .32839 L
s
.43 .135 .065 r
.38829 .59894 m .38918 .60765 L .37439 .59454 L p F P
0 0 0 r
s
.43 .135 .065 r
.37439 .59454 m .37324 .58454 L .38829 .59894 L p F P
0 0 0 r
s
1 .333 .134 r
.62561 .59454 m .62676 .58454 L .61171 .59894 L p F P
0 0 0 r
s
.83 .24 .1 r
.62407 .59591 m
.62417 .595 L
s
1 .333 .134 r
.61171 .59894 m .61082 .60765 L .62561 .59454 L p F P
0 0 0 r
s
.32 .095 .05 r
.37208 .57435 m .37324 .58454 L .36162 .56827 L p F P
0 0 0 r
s
.32 .095 .05 r
.36162 .56827 m .36023 .55697 L .37208 .57435 L p F P
0 0 0 r
s
1 .315 .125 r
.63838 .56827 m .63977 .55697 L .62792 .57435 L p F P
0 0 0 r
s
1 .315 .125 r
.62792 .57435 m .62676 .58454 L .63838 .56827 L p F P
0 0 0 r
s
.814 .245 .108 r
.45111 .64553 m .45128 .64919 L .42949 .65302 L p F P
0 0 0 r
s
.814 .245 .108 r
.42949 .65302 m .42913 .64773 L .45111 .64553 L p F P
0 0 0 r
s
.229 .365 .719 r
.57051 .65302 m .56044 .65302 L .54176 .64919 L p F P
0 0 0 r
s
.229 .365 .719 r
.54176 .64919 m .54872 .64919 L .57051 .65302 L p F P
0 0 0 r
s
.229 .365 .719 r
.56044 .65302 m .55037 .65302 L .5348 .64919 L p F P
0 0 0 r
s
.24 .35 .67 r
.54371 .65188 m
.5438 .65141 L
s
.229 .365 .719 r
.5348 .64919 m .54176 .64919 L .56044 .65302 L p F P
0 0 0 r
s
.229 .365 .719 r
.55037 .65302 m .54029 .65302 L .52784 .64919 L p F P
0 0 0 r
s
.229 .365 .719 r
.52784 .64919 m .5348 .64919 L .55037 .65302 L p F P
0 0 0 r
s
.83 .24 .1 r
.54797 .65306 m
.54812 .64981 L
s
.24 .35 .67 r
.54426 .64919 m
.54458 .64765 L
s
.229 .365 .719 r
.54029 .65302 m .53022 .65302 L .52088 .64919 L p F P
0 0 0 r
s
.229 .365 .719 r
.52088 .64919 m .52784 .64919 L .54029 .65302 L p F P
0 0 0 r
s
.229 .365 .719 r
.53022 .65302 m .52015 .65302 L .51392 .64919 L p F P
0 0 0 r
s
.229 .365 .719 r
.51392 .64919 m .52088 .64919 L .53022 .65302 L p F P
0 0 0 r
s
.229 .365 .719 r
.52015 .65302 m .51007 .65302 L .50696 .64919 L p F P
0 0 0 r
s
.229 .365 .719 r
.50696 .64919 m .51392 .64919 L .52015 .65302 L p F P
0 0 0 r
s
.83 .24 .1 r
.51636 .65309 m
.51638 .65156 L
s
.229 .365 .719 r
.51007 .65302 m .5 .65302 L .5 .64919 L p F P
0 0 0 r
s
.229 .365 .719 r
.5 .64919 m .50696 .64919 L .51007 .65302 L p F P
0 0 0 r
s
.229 .365 .719 r
.5 .65302 m .48993 .65302 L .49304 .64919 L p F P
0 0 0 r
s
.229 .365 .719 r
.49304 .64919 m .5 .64919 L .5 .65302 L p F P
0 0 0 r
s
.24 .35 .67 r
.5 .64765 m
.5 .64919 L
s
.229 .365 .719 r
.48993 .65302 m .47985 .65302 L .48608 .64919 L p F P
0 0 0 r
s
.229 .365 .719 r
.48608 .64919 m .49304 .64919 L .48993 .65302 L p F P
0 0 0 r
s
.229 .365 .719 r
.47985 .65302 m .46978 .65302 L .47912 .64919 L p F P
0 0 0 r
s
.229 .365 .719 r
.47912 .64919 m .48608 .64919 L .47985 .65302 L p F P
0 0 0 r
s
.83 .24 .1 r
.48362 .65156 m
.48364 .65309 L
s
.229 .365 .719 r
.46978 .65302 m .45971 .65302 L .47216 .64919 L p F P
0 0 0 r
s
.229 .365 .719 r
.47216 .64919 m .47912 .64919 L .46978 .65302 L p F P
0 0 0 r
s
.229 .365 .719 r
.45971 .65302 m .44963 .65302 L .4652 .64919 L p F P
0 0 0 r
s
.229 .365 .719 r
.4652 .64919 m .47216 .64919 L .45971 .65302 L p F P
0 0 0 r
s
.229 .365 .719 r
.44963 .65302 m .43956 .65302 L .45824 .64919 L p F P
0 0 0 r
s
.229 .365 .719 r
.45824 .64919 m .4652 .64919 L .44963 .65302 L p F P
0 0 0 r
s
.229 .365 .719 r
.43956 .65302 m .42949 .65302 L .45128 .64919 L p F P
0 0 0 r
s
.229 .365 .719 r
.45128 .64919 m .45824 .64919 L .43956 .65302 L p F P
0 0 0 r
s
.83 .24 .1 r
.45188 .64981 m
.45203 .65306 L
s
.24 .35 .67 r
.45542 .64765 m
.45574 .64919 L
s
1 .329 .137 r
.57051 .65302 m .57087 .64773 L .54889 .64553 L p F P
0 0 0 r
s
1 .329 .137 r
.54889 .64553 m .54872 .64919 L .57051 .65302 L p F P
0 0 0 r
s
.583 .18 .083 r
.40707 .61825 m .40769 .62538 L .39006 .61622 L p F P
0 0 0 r
s
.583 .18 .083 r
.39006 .61622 m .38918 .60765 L .40707 .61825 L p F P
0 0 0 r
s
1 .338 .138 r
.60994 .61622 m .61082 .60765 L .59293 .61825 L p F P
0 0 0 r
s
1 .338 .138 r
.59293 .61825 m .59231 .62538 L .60994 .61622 L p F P
0 0 0 r
s
.236 .068 .036 r
.35881 .54545 m .36023 .55697 L .35208 .53845 L p F P
0 0 0 r
s
.236 .068 .036 r
.35208 .53845 m .35049 .52605 L .35881 .54545 L p F P
0 0 0 r
s
.83 .24 .1 r
.35048 .52602 m
.3505 .52608 L
s
.973 .282 .11 r
.64792 .53845 m .64951 .52605 L .64119 .54545 L p F P
0 0 0 r
s
.83 .24 .1 r
.6495 .52608 m
.64952 .52602 L
s
.973 .282 .11 r
.64119 .54545 m .63977 .55697 L .64792 .53845 L p F P
0 0 0 r
s
1 .33 .134 r
.35787 .35679 m .35931 .3703 L .37397 .36193 L p F P
0 0 0 r
s
1 .33 .134 r
.37397 .36193 m .37281 .34976 L .35787 .35679 L p F P
0 0 0 r
s
.24 .35 .67 r
.36663 .35131 m
.36926 .34808 L
s
.465 .141 .068 r
.62603 .36193 m .62719 .34976 L .64213 .35679 L p F P
0 0 0 r
s
.24 .35 .67 r
.63074 .34808 m
.63337 .35131 L
s
.465 .141 .068 r
.64213 .35679 m .64069 .3703 L .62603 .36193 L p F P
0 0 0 r
s
.157 .045 .023 r
.34886 .51338 m .35049 .52605 L .34606 .50631 L p F P
0 0 0 r
s
.157 .045 .023 r
.34606 .50631 m .34434 .49304 L .34886 .51338 L p F P
0 0 0 r
s
.83 .24 .1 r
.3454 .4735 m
.34877 .5 L
s
.796 .229 .086 r
.65394 .50631 m .65566 .49304 L .65114 .51338 L p F P
0 0 0 r
s
.83 .24 .1 r
.65123 .5 m
.6546 .4735 L
s
.796 .229 .086 r
.65114 .51338 m .64951 .52605 L .65394 .50631 L p F P
0 0 0 r
s
.712 .216 .097 r
.42802 .63152 m .4284 .63697 L .4083 .63241 L p F P
0 0 0 r
s
.712 .216 .097 r
.4083 .63241 m .40769 .62538 L .42802 .63152 L p F P
0 0 0 r
s
.83 .24 .1 r
.40768 .62524 m
.4081 .6255 L
s
1 .336 .139 r
.5917 .63241 m .59231 .62538 L .57198 .63152 L p F P
0 0 0 r
s
.83 .24 .1 r
.5919 .6255 m
.59232 .62524 L
s
1 .336 .139 r
.57198 .63152 m .5716 .63697 L .5917 .63241 L p F P
0 0 0 r
s
.814 .245 .108 r
.45093 .64183 m .45111 .64553 L .42913 .64773 L p F P
0 0 0 r
s
.814 .245 .108 r
.42913 .64773 m .42876 .64238 L .45093 .64183 L p F P
0 0 0 r
s
1 .329 .137 r
.57087 .64773 m .57124 .64238 L .54907 .64183 L p F P
0 0 0 r
s
1 .329 .137 r
.54907 .64183 m .54889 .64553 L .57087 .64773 L p F P
0 0 0 r
s
.7 .195 .071 r
.34257 .47947 m .34434 .49304 L .34381 .47322 L p F P
0 0 0 r
s
.7 .195 .071 r
.34381 .47322 m .34203 .45938 L .34257 .47947 L p F P
0 0 0 r
s
.098 .028 .012 r
.65619 .47322 m .65797 .45938 L .65743 .47947 L p F P
0 0 0 r
s
.098 .028 .012 r
.65743 .47947 m .65566 .49304 L .65619 .47322 L p F P
0 0 0 r
s
1 .318 .127 r
.34789 .38223 m .34953 .3964 L .36072 .38353 L p F P
0 0 0 r
s
1 .318 .127 r
.36072 .38353 m .35931 .3703 L .34789 .38223 L p F P
0 0 0 r
s
.332 .1 .051 r
.63928 .38353 m .64069 .3703 L .65211 .38223 L p F P
0 0 0 r
s
.332 .1 .051 r
.65211 .38223 m .65047 .3964 L .63928 .38353 L p F P
0 0 0 r
s
.83 .24 .1 r
.37364 .34623 m
.39644 .32839 L
s
.39644 .32839 m
.39408 .29735 L
s
.60356 .32839 m
.60592 .29735 L
s
.60356 .32839 m
.62636 .34623 L
s
.899 .254 .097 r
.34021 .44522 m .34203 .45938 L .34548 .44069 L p F P
0 0 0 r
s
.899 .254 .097 r
.34548 .44069 m .34375 .42663 L .34021 .44522 L p F P
0 0 0 r
s
.181 .052 .027 r
.65452 .44069 m .65625 .42663 L .65979 .44522 L p F P
0 0 0 r
s
.181 .052 .027 r
.65979 .44522 m .65797 .45938 L .65452 .44069 L p F P
0 0 0 r
s
1 .295 .116 r
.34197 .41225 m .34375 .42663 L .35115 .41027 L p F P
0 0 0 r
s
.83 .24 .1 r
.34724 .42048 m
.3506 .44841 L
s
1 .295 .116 r
.35115 .41027 m .34953 .3964 L .34197 .41225 L p F P
0 0 0 r
s
.83 .24 .1 r
.34724 .42048 m
.35898 .39685 L
s
.249 .072 .039 r
.64885 .41027 m .65047 .3964 L .65803 .41225 L p F P
0 0 0 r
s
.249 .072 .039 r
.65803 .41225 m .65625 .42663 L .64885 .41027 L p F P
0 0 0 r
s
.83 .24 .1 r
.64102 .39685 m
.65276 .42048 L
s
.6494 .44841 m
.65276 .42048 L
s
.43 .135 .065 r
.38739 .59009 m .38829 .59894 L .37324 .58454 L p F P
0 0 0 r
s
.43 .135 .065 r
.37324 .58454 m .37208 .57435 L .38739 .59009 L p F P
0 0 0 r
s
.83 .24 .1 r
.3734 .57358 m
.37367 .576 L
s
1 .333 .134 r
.62676 .58454 m .62792 .57435 L .61261 .59009 L p F P
0 0 0 r
s
.83 .24 .1 r
.62519 .58604 m
.62529 .58511 L
s
.62633 .576 m
.6266 .57358 L
s
1 .333 .134 r
.61261 .59009 m .61171 .59894 L .62676 .58454 L p F P
0 0 0 r
s
.583 .18 .083 r
.40645 .61103 m .40707 .61825 L .38918 .60765 L p F P
0 0 0 r
s
.583 .18 .083 r
.38918 .60765 m .38829 .59894 L .40645 .61103 L p F P
0 0 0 r
s
1 .338 .138 r
.61082 .60765 m .61171 .59894 L .59355 .61103 L p F P
0 0 0 r
s
1 .338 .138 r
.59355 .61103 m .59293 .61825 L .61082 .60765 L p F P
0 0 0 r
s
.32 .095 .05 r
.37089 .56398 m .37208 .57435 L .36023 .55697 L p F P
0 0 0 r
s
.83 .24 .1 r
.37168 .5709 m
.3734 .57358 L
s
.32 .095 .05 r
.36023 .55697 m .35881 .54545 L .37089 .56398 L p F P
0 0 0 r
s
1 .315 .125 r
.63977 .55697 m .64119 .54545 L .62911 .56398 L p F P
0 0 0 r
s
1 .315 .125 r
.62911 .56398 m .62792 .57435 L .63977 .55697 L p F P
0 0 0 r
s
.83 .24 .1 r
.6266 .57358 m
.62832 .5709 L
s
.814 .245 .108 r
.45076 .63812 m .45093 .64183 L .42876 .64238 L p F P
0 0 0 r
s
.814 .245 .108 r
.42876 .64238 m .4284 .63697 L .45076 .63812 L p F P
0 0 0 r
s
1 .329 .137 r
.57124 .64238 m .5716 .63697 L .54924 .63812 L p F P
0 0 0 r
s
1 .329 .137 r
.54924 .63812 m .54907 .64183 L .57124 .64238 L p F P
0 0 0 r
s
.712 .216 .097 r
.42765 .626 m .42802 .63152 L .40769 .62538 L p F P
0 0 0 r
s
.712 .216 .097 r
.40769 .62538 m .40707 .61825 L .42765 .626 L p F P
0 0 0 r
s
1 .336 .139 r
.59231 .62538 m .59293 .61825 L .57235 .626 L p F P
0 0 0 r
s
1 .336 .139 r
.57235 .626 m .57198 .63152 L .59231 .62538 L p F P
0 0 0 r
s
.83 .24 .1 r
.57106 .637 m
.57162 .63679 L
s
.42838 .63679 m
.42894 .637 L
s
.24 .35 .67 r
.22814 .36147 m
.23326 .35131 L
s
.18881 .35131 m
.18283 .36147 L
s
.23326 .35131 m
.18881 .35131 L
s
.27345 .36147 m
.27772 .35131 L
s
.27772 .35131 m
.23326 .35131 L
s
.31876 .36147 m
.32218 .35131 L
s
.32218 .35131 m
.27772 .35131 L
s
.32218 .35131 m
.36663 .35131 L
s
.37228 .35131 m
.41109 .35131 L
s
.36663 .35131 m
.36952 .35131 L
s
.45554 .35131 m
.41109 .35131 L
s
.5 .35131 m
.45554 .35131 L
s
.54446 .35131 m
.5 .35131 L
s
.58891 .35131 m
.54446 .35131 L
s
.58891 .35131 m
.62772 .35131 L
s
.63048 .35131 m
.63337 .35131 L
s
.68124 .36147 m
.67782 .35131 L
s
.63337 .35131 m
.67782 .35131 L
s
.72655 .36147 m
.72228 .35131 L
s
.72228 .35131 m
.67782 .35131 L
s
.77186 .36147 m
.76674 .35131 L
s
.76674 .35131 m
.72228 .35131 L
s
.81717 .36147 m
.81119 .35131 L
s
.81119 .35131 m
.76674 .35131 L
s
.236 .068 .036 r
.35736 .53369 m .35881 .54545 L .35049 .52605 L p F P
0 0 0 r
s
.236 .068 .036 r
.35049 .52605 m .34886 .51338 L .35736 .53369 L p F P
0 0 0 r
s
.973 .282 .11 r
.64951 .52605 m .65114 .51338 L .64264 .53369 L p F P
0 0 0 r
s
.973 .282 .11 r
.64264 .53369 m .64119 .54545 L .64951 .52605 L p F P
0 0 0 r
s
.084 .096 .185 r
.35787 .35679 m .37817 .35679 L .39098 .34976 L p F P
0 0 0 r
s
.83 .24 .1 r
.37463 .35679 m
.37642 .3758 L
s
.084 .096 .185 r
.39098 .34976 m .37281 .34976 L .35787 .35679 L p F P
0 0 0 r
s
.83 .24 .1 r
.37399 .34991 m
.374 .35006 L
s
.37364 .34623 m
.37399 .34991 L
s
.24 .35 .67 r
.36624 .35285 m
.36663 .35131 L
s
.084 .096 .185 r
.37817 .35679 m .39848 .35679 L .40915 .34976 L p F P
0 0 0 r
s
.084 .096 .185 r
.40915 .34976 m .39098 .34976 L .37817 .35679 L p F P
0 0 0 r
s
.084 .096 .185 r
.39848 .35679 m .41878 .35679 L .42732 .34976 L p F P
0 0 0 r
s
.084 .096 .185 r
.42732 .34976 m .40915 .34976 L .39848 .35679 L p F P
0 0 0 r
s
.084 .096 .185 r
.41878 .35679 m .43909 .35679 L .44549 .34976 L p F P
0 0 0 r
s
.084 .096 .185 r
.44549 .34976 m .42732 .34976 L .41878 .35679 L p F P
0 0 0 r
s
.084 .096 .185 r
.43909 .35679 m .45939 .35679 L .46366 .34976 L p F P
0 0 0 r
s
.084 .096 .185 r
.46366 .34976 m .44549 .34976 L .43909 .35679 L p F P
0 0 0 r
s
.084 .096 .185 r
.45939 .35679 m .4797 .35679 L .48183 .34976 L p F P
0 0 0 r
s
.084 .096 .185 r
.48183 .34976 m .46366 .34976 L .45939 .35679 L p F P
0 0 0 r
s
.084 .096 .185 r
.4797 .35679 m .5 .35679 L .5 .34976 L p F P
0 0 0 r
s
.084 .096 .185 r
.5 .34976 m .48183 .34976 L .4797 .35679 L p F P
0 0 0 r
s
.084 .096 .185 r
.5 .35679 m .5203 .35679 L .51817 .34976 L p F P
0 0 0 r
s
.084 .096 .185 r
.51817 .34976 m .5 .34976 L .5 .35679 L p F P
0 0 0 r
s
.084 .096 .185 r
.5203 .35679 m .54061 .35679 L .53634 .34976 L p F P
0 0 0 r
s
.084 .096 .185 r
.53634 .34976 m .51817 .34976 L .5203 .35679 L p F P
0 0 0 r
s
.084 .096 .185 r
.54061 .35679 m .56091 .35679 L .55451 .34976 L p F P
0 0 0 r
s
.084 .096 .185 r
.55451 .34976 m .53634 .34976 L .54061 .35679 L p F P
0 0 0 r
s
.084 .096 .185 r
.56091 .35679 m .58122 .35679 L .57268 .34976 L p F P
0 0 0 r
s
.084 .096 .185 r
.57268 .34976 m .55451 .34976 L .56091 .35679 L p F P
0 0 0 r
s
.084 .096 .185 r
.58122 .35679 m .60152 .35679 L .59085 .34976 L p F P
0 0 0 r
s
.084 .096 .185 r
.59085 .34976 m .57268 .34976 L .58122 .35679 L p F P
0 0 0 r
s
.084 .096 .185 r
.60152 .35679 m .62183 .35679 L .60902 .34976 L p F P
0 0 0 r
s
.084 .096 .185 r
.60902 .34976 m .59085 .34976 L .60152 .35679 L p F P
0 0 0 r
s
.084 .096 .185 r
.62183 .35679 m .64213 .35679 L .62719 .34976 L p F P
0 0 0 r
s
.24 .35 .67 r
.63337 .35131 m
.63376 .35285 L
s
.83 .24 .1 r
.62358 .3758 m
.62537 .35679 L
s
.084 .096 .185 r
.62719 .34976 m .60902 .34976 L .62183 .35679 L p F P
0 0 0 r
s
.83 .24 .1 r
.626 .35006 m
.62601 .34991 L
s
.62601 .34991 m
.62636 .34623 L
s
.45169 .27383 m
.4837 .26899 L
s
.4837 .26899 m
.48332 .23634 L
s
.4837 .26899 m
.5163 .26899 L
s
.5163 .26899 m
.51668 .23634 L
s
.5163 .26899 m
.54831 .27383 L
s
.157 .045 .023 r
.3472 .50043 m .34886 .51338 L .34434 .49304 L p F P
0 0 0 r
s
.157 .045 .023 r
.34434 .49304 m .34257 .47947 L .3472 .50043 L p F P
0 0 0 r
s
.83 .24 .1 r
.3454 .4735 m
.34692 .49916 L
s
.796 .229 .086 r
.65566 .49304 m .65743 .47947 L .6528 .50043 L p F P
0 0 0 r
s
.796 .229 .086 r
.6528 .50043 m .65114 .51338 L .65566 .49304 L p F P
0 0 0 r
s
.83 .24 .1 r
.65308 .49916 m
.6546 .4735 L
s
.24 .35 .67 r
.23251 .64765 m
.18792 .64765 L
s
.27709 .64765 m
.23251 .64765 L
s
.32167 .64765 m
.27709 .64765 L
s
.36625 .64765 m
.32167 .64765 L
s
.41084 .64765 m
.36625 .64765 L
s
.41084 .64765 m
.44768 .64765 L
s
.45121 .64765 m
.45542 .64765 L
s
.5 .64765 m
.45542 .64765 L
s
.54458 .64765 m
.5 .64765 L
s
.55232 .64765 m
.58916 .64765 L
s
.54458 .64765 m
.54879 .64765 L
s
.63375 .64765 m
.58916 .64765 L
s
.67833 .64765 m
.63375 .64765 L
s
.72291 .64765 m
.67833 .64765 L
s
.76749 .64765 m
.72291 .64765 L
s
.81208 .64765 m
.76749 .64765 L
s
.23251 .64765 m
.22743 .63648 L
s
.182 .63648 m
.18792 .64765 L
s
.27709 .64765 m
.27286 .63648 L
s
.32167 .64765 m
.31828 .63648 L
s
.36625 .64765 m
.36371 .63648 L
s
.40914 .63648 m
.41084 .64765 L
s
.58916 .64765 m
.59086 .63648 L
s
.63375 .64765 m
.63629 .63648 L
s
.67833 .64765 m
.68172 .63648 L
s
.72291 .64765 m
.72714 .63648 L
s
.76749 .64765 m
.77257 .63648 L
s
.81208 .64765 m
.818 .63648 L
s
.898 .269 .117 r
.47493 .63951 m .47498 .6414 L .45128 .64919 L p F P
0 0 0 r
s
.83 .24 .1 r
.45184 .64901 m
.45185 .64919 L
s
.898 .269 .117 r
.45128 .64919 m .45111 .64553 L .47493 .63951 L p F P
0 0 0 r
s
.83 .24 .1 r
.45111 .64551 m
.45113 .64552 L
s
.271 .418 .822 r
.54872 .64919 m .54176 .64919 L .52145 .6414 L p F P
0 0 0 r
s
.271 .418 .822 r
.52145 .6414 m .52502 .6414 L .54872 .64919 L p F P
0 0 0 r
s
.271 .418 .822 r
.54176 .64919 m .5348 .64919 L .51787 .6414 L p F P
0 0 0 r
s
.271 .418 .822 r
.51787 .6414 m .52145 .6414 L .54176 .64919 L p F P
0 0 0 r
s
.271 .418 .822 r
.5348 .64919 m .52784 .64919 L .5143 .6414 L p F P
0 0 0 r
s
.271 .418 .822 r
.5143 .6414 m .51787 .6414 L .5348 .64919 L p F P
0 0 0 r
s
.271 .418 .822 r
.52784 .64919 m .52088 .64919 L .51072 .6414 L p F P
0 0 0 r
s
.271 .418 .822 r
.51072 .6414 m .5143 .6414 L .52784 .64919 L p F P
0 0 0 r
s
.271 .418 .822 r
.52088 .64919 m .51392 .64919 L .50715 .6414 L p F P
0 0 0 r
s
.271 .418 .822 r
.50715 .6414 m .51072 .6414 L .52088 .64919 L p F P
0 0 0 r
s
.271 .418 .822 r
.51392 .64919 m .50696 .64919 L .50357 .6414 L p F P
0 0 0 r
s
.271 .418 .822 r
.50357 .6414 m .50715 .6414 L .51392 .64919 L p F P
0 0 0 r
s
.271 .418 .822 r
.50696 .64919 m .5 .64919 L .5 .6414 L p F P
0 0 0 r
s
.271 .418 .822 r
.5 .6414 m .50357 .6414 L .50696 .64919 L p F P
0 0 0 r
s
.271 .418 .822 r
.5 .64919 m .49304 .64919 L .49643 .6414 L p F P
0 0 0 r
s
.271 .418 .822 r
.49643 .6414 m .5 .6414 L .5 .64919 L p F P
0 0 0 r
s
.271 .418 .822 r
.49304 .64919 m .48608 .64919 L .49285 .6414 L p F P
0 0 0 r
s
.271 .418 .822 r
.49285 .6414 m .49643 .6414 L .49304 .64919 L p F P
0 0 0 r
s
.271 .418 .822 r
.48608 .64919 m .47912 .64919 L .48928 .6414 L p F P
0 0 0 r
s
.271 .418 .822 r
.48928 .6414 m .49285 .6414 L .48608 .64919 L p F P
0 0 0 r
s
.271 .418 .822 r
.47912 .64919 m .47216 .64919 L .4857 .6414 L p F P
0 0 0 r
s
.271 .418 .822 r
.4857 .6414 m .48928 .6414 L .47912 .64919 L p F P
0 0 0 r
s
.271 .418 .822 r
.47216 .64919 m .4652 .64919 L .48213 .6414 L p F P
0 0 0 r
s
.271 .418 .822 r
.48213 .6414 m .4857 .6414 L .47216 .64919 L p F P
0 0 0 r
s
.271 .418 .822 r
.4652 .64919 m .45824 .64919 L .47855 .6414 L p F P
0 0 0 r
s
.271 .418 .822 r
.47855 .6414 m .48213 .6414 L .4652 .64919 L p F P
0 0 0 r
s
.271 .418 .822 r
.45824 .64919 m .45128 .64919 L .47498 .6414 L p F P
0 0 0 r
s
.271 .418 .822 r
.47498 .6414 m .47855 .6414 L .45824 .64919 L p F P
0 0 0 r
s
1 .318 .134 r
.54872 .64919 m .54889 .64553 L .52507 .63951 L p F P
0 0 0 r
s
.24 .35 .67 r
.54458 .64765 m
.54459 .6475 L
s
.83 .24 .1 r
.54887 .64552 m
.54889 .64551 L
s
.54816 .64901 m
.54816 .64896 L
s
1 .318 .134 r
.52507 .63951 m .52502 .6414 L .54872 .64919 L p F P
0 0 0 r
s
.814 .245 .108 r
.45059 .63437 m .45076 .63812 L .4284 .63697 L p F P
0 0 0 r
s
.814 .245 .108 r
.4284 .63697 m .42802 .63152 L .45059 .63437 L p F P
0 0 0 r
s
1 .329 .137 r
.5716 .63697 m .57198 .63152 L .54941 .63437 L p F P
0 0 0 r
s
1 .329 .137 r
.54941 .63437 m .54924 .63812 L .5716 .63697 L p F P
0 0 0 r
s
.83 .24 .1 r
.36784 .35312 m
.37364 .34623 L
s
.37364 .34623 m
.37074 .31531 L
s
.62636 .34623 m
.62926 .31531 L
s
.62636 .34623 m
.63216 .35312 L
s
1 .318 .127 r
.3462 .36775 m .34789 .38223 L .35931 .3703 L p F P
0 0 0 r
s
1 .318 .127 r
.35931 .3703 m .35787 .35679 L .3462 .36775 L p F P
0 0 0 r
s
.83 .24 .1 r
.35578 .36744 m
.35898 .39685 L
s
.35578 .36744 m
.36475 .35679 L
s
.332 .1 .051 r
.64069 .3703 m .64213 .35679 L .6538 .36775 L p F P
0 0 0 r
s
.83 .24 .1 r
.63525 .35679 m
.64422 .36744 L
s
.332 .1 .051 r
.6538 .36775 m .65211 .38223 L .64069 .3703 L p F P
0 0 0 r
s
.83 .24 .1 r
.64102 .39685 m
.64422 .36744 L
s
.51638 .65156 m
.53661 .64787 L
s
.46339 .64787 m
.48362 .65156 L
s
.42143 .28338 m
.45169 .27383 L
s
.45169 .27383 m
.45057 .24121 L
s
.54831 .27383 m
.54943 .24121 L
s
.54831 .27383 m
.57857 .28338 L
s
.7 .195 .071 r
.34077 .46558 m .34257 .47947 L .34203 .45938 L p F P
0 0 0 r
s
.7 .195 .071 r
.34203 .45938 m .34021 .44522 L .34077 .46558 L p F P
0 0 0 r
s
.098 .028 .012 r
.65797 .45938 m .65979 .44522 L .65923 .46558 L p F P
0 0 0 r
s
.098 .028 .012 r
.65923 .46558 m .65743 .47947 L .65797 .45938 L p F P
0 0 0 r
s
.583 .18 .083 r
.40581 .60371 m .40645 .61103 L .38829 .59894 L p F P
0 0 0 r
s
.583 .18 .083 r
.38829 .59894 m .38739 .59009 L .40581 .60371 L p F P
0 0 0 r
s
1 .338 .138 r
.61171 .59894 m .61261 .59009 L .59419 .60371 L p F P
0 0 0 r
s
1 .338 .138 r
.59419 .60371 m .59355 .61103 L .61171 .59894 L p F P
0 0 0 r
s
.712 .216 .097 r
.42727 .62042 m .42765 .626 L .40707 .61825 L p F P
0 0 0 r
s
.712 .216 .097 r
.40707 .61825 m .40645 .61103 L .42727 .62042 L p F P
0 0 0 r
s
1 .336 .139 r
.59293 .61825 m .59355 .61103 L .57273 .62042 L p F P
0 0 0 r
s
1 .336 .139 r
.57273 .62042 m .57235 .626 L .59293 .61825 L p F P
0 0 0 r
s
.43 .135 .065 r
.38647 .5811 m .38739 .59009 L .37208 .57435 L p F P
0 0 0 r
s
.43 .135 .065 r
.37208 .57435 m .37089 .56398 L .38647 .5811 L p F P
0 0 0 r
s
1 .333 .134 r
.62792 .57435 m .62911 .56398 L .61353 .5811 L p F P
0 0 0 r
s
1 .333 .134 r
.61353 .5811 m .61261 .59009 L .62792 .57435 L p F P
0 0 0 r
s
.899 .254 .097 r
.33836 .43072 m .34021 .44522 L .34375 .42663 L p F P
0 0 0 r
s
.899 .254 .097 r
.34375 .42663 m .34197 .41225 L .33836 .43072 L p F P
0 0 0 r
s
.83 .24 .1 r
.34188 .44579 m
.34724 .42048 L
s
.181 .052 .027 r
.65625 .42663 m .65803 .41225 L .66164 .43072 L p F P
0 0 0 r
s
.181 .052 .027 r
.66164 .43072 m .65979 .44522 L .65625 .42663 L p F P
0 0 0 r
s
.83 .24 .1 r
.65276 .42048 m
.65812 .44579 L
s
1 .295 .116 r
.34015 .39754 m .34197 .41225 L .34953 .3964 L p F P
0 0 0 r
s
1 .295 .116 r
.34953 .3964 m .34789 .38223 L .34015 .39754 L p F P
0 0 0 r
s
.249 .072 .039 r
.65047 .3964 m .65211 .38223 L .65985 .39754 L p F P
0 0 0 r
s
.249 .072 .039 r
.65985 .39754 m .65803 .41225 L .65047 .3964 L p F P
0 0 0 r
s
.898 .269 .117 r
.47489 .63761 m .47493 .63951 L .45111 .64553 L p F P
0 0 0 r
s
.898 .269 .117 r
.45111 .64553 m .45093 .64183 L .47489 .63761 L p F P
0 0 0 r
s
1 .318 .134 r
.54889 .64553 m .54907 .64183 L .52511 .63761 L p F P
0 0 0 r
s
.83 .24 .1 r
.54832 .64538 m
.54833 .64534 L
s
1 .318 .134 r
.52511 .63761 m .52507 .63951 L .54889 .64553 L p F P
0 0 0 r
s
.83 .24 .1 r
.51638 .65156 m
.51653 .64207 L
s
.51638 .65156 m
.48362 .65156 L
s
.48347 .64207 m
.48362 .65156 L
s
.32 .095 .05 r
.36968 .55341 m .37089 .56398 L .35881 .54545 L p F P
0 0 0 r
s
.32 .095 .05 r
.35881 .54545 m .35736 .53369 L .36968 .55341 L p F P
0 0 0 r
s
1 .315 .125 r
.64119 .54545 m .64264 .53369 L .63032 .55341 L p F P
0 0 0 r
s
1 .315 .125 r
.63032 .55341 m .62911 .56398 L .64119 .54545 L p F P
0 0 0 r
s
.814 .245 .108 r
.45041 .6306 m .45059 .63437 L .42802 .63152 L p F P
0 0 0 r
s
.814 .245 .108 r
.42802 .63152 m .42765 .626 L .45041 .6306 L p F P
0 0 0 r
s
1 .329 .137 r
.57198 .63152 m .57235 .626 L .54959 .6306 L p F P
0 0 0 r
s
1 .329 .137 r
.54959 .6306 m .54941 .63437 L .57198 .63152 L p F P
0 0 0 r
s
.83 .24 .1 r
.39408 .29735 m
.42143 .28338 L
s
.42143 .28338 m
.41961 .25081 L
s
.57857 .28338 m
.58039 .25081 L
s
.57857 .28338 m
.60592 .29735 L
s
.898 .269 .117 r
.47484 .6357 m .47489 .63761 L .45093 .64183 L p F P
0 0 0 r
s
.898 .269 .117 r
.45093 .64183 m .45076 .63812 L .47484 .6357 L p F P
0 0 0 r
s
1 .318 .134 r
.54907 .64183 m .54924 .63812 L .52516 .6357 L p F P
0 0 0 r
s
.83 .24 .1 r
.54849 .64173 m
.54849 .64169 L
s
1 .318 .134 r
.52516 .6357 m .52511 .63761 L .54907 .64183 L p F P
0 0 0 r
s
.236 .068 .036 r
.35588 .52169 m .35736 .53369 L .34886 .51338 L p F P
0 0 0 r
s
.236 .068 .036 r
.34886 .51338 m .3472 .50043 L .35588 .52169 L p F P
0 0 0 r
s
.83 .24 .1 r
.34694 .49926 m
.34793 .50221 L
s
.973 .282 .11 r
.65114 .51338 m .6528 .50043 L .64412 .52169 L p F P
0 0 0 r
s
.83 .24 .1 r
.65207 .50221 m
.65306 .49926 L
s
.973 .282 .11 r
.64412 .52169 m .64264 .53369 L .65114 .51338 L p F P
0 0 0 r
s
.712 .216 .097 r
.42689 .61479 m .42727 .62042 L .40645 .61103 L p F P
0 0 0 r
s
.712 .216 .097 r
.40645 .61103 m .40581 .60371 L .42689 .61479 L p F P
0 0 0 r
s
1 .336 .139 r
.59355 .61103 m .59419 .60371 L .57311 .61479 L p F P
0 0 0 r
s
1 .336 .139 r
.57311 .61479 m .57273 .62042 L .59355 .61103 L p F P
0 0 0 r
s
.583 .18 .083 r
.40517 .59629 m .40581 .60371 L .38739 .59009 L p F P
0 0 0 r
s
.583 .18 .083 r
.38739 .59009 m .38647 .5811 L .40517 .59629 L p F P
0 0 0 r
s
1 .338 .138 r
.61261 .59009 m .61353 .5811 L .59483 .59629 L p F P
0 0 0 r
s
1 .338 .138 r
.59483 .59629 m .59419 .60371 L .61261 .59009 L p F P
0 0 0 r
s
.898 .269 .117 r
.4748 .63378 m .47484 .6357 L .45076 .63812 L p F P
0 0 0 r
s
.898 .269 .117 r
.45076 .63812 m .45059 .63437 L .4748 .63378 L p F P
0 0 0 r
s
.24 .35 .67 r
.45457 .63648 m
.45511 .6436 L
s
1 .318 .134 r
.54924 .63812 m .54941 .63437 L .5252 .63378 L p F P
0 0 0 r
s
.83 .24 .1 r
.54866 .63806 m
.54866 .63801 L
s
1 .318 .134 r
.5252 .63378 m .52516 .6357 L .54924 .63812 L p F P
0 0 0 r
s
.24 .35 .67 r
.54489 .6436 m
.54543 .63648 L
s
.814 .245 .108 r
.45023 .6268 m .45041 .6306 L .42765 .626 L p F P
0 0 0 r
s
.814 .245 .108 r
.42765 .626 m .42727 .62042 L .45023 .6268 L p F P
0 0 0 r
s
1 .329 .137 r
.57235 .626 m .57273 .62042 L .54977 .6268 L p F P
0 0 0 r
s
1 .329 .137 r
.54977 .6268 m .54959 .6306 L .57235 .626 L p F P
0 0 0 r
s
.157 .045 .023 r
.3455 .48719 m .3472 .50043 L .34257 .47947 L p F P
0 0 0 r
s
.157 .045 .023 r
.34257 .47947 m .34077 .46558 L .3455 .48719 L p F P
0 0 0 r
s
.83 .24 .1 r
.34188 .44579 m
.3454 .4735 L
s
.796 .229 .086 r
.65743 .47947 m .65923 .46558 L .6545 .48719 L p F P
0 0 0 r
s
.83 .24 .1 r
.6546 .4735 m
.65812 .44579 L
s
.796 .229 .086 r
.6545 .48719 m .6528 .50043 L .65743 .47947 L p F P
0 0 0 r
s
.119 .144 .278 r
.3462 .36775 m .36817 .36775 L .37817 .35679 L p F P
0 0 0 r
s
.119 .144 .278 r
.37817 .35679 m .35787 .35679 L .3462 .36775 L p F P
0 0 0 r
s
.83 .24 .1 r
.35242 .33666 m
.35503 .36063 L
s
.119 .144 .278 r
.36817 .36775 m .39015 .36775 L .39848 .35679 L p F P
0 0 0 r
s
.119 .144 .278 r
.39848 .35679 m .37817 .35679 L .36817 .36775 L p F P
0 0 0 r
s
.119 .144 .278 r
.39015 .36775 m .41212 .36775 L .41878 .35679 L p F P
0 0 0 r
s
.119 .144 .278 r
.41878 .35679 m .39848 .35679 L .39015 .36775 L p F P
0 0 0 r
s
.119 .144 .278 r
.41212 .36775 m .43409 .36775 L .43909 .35679 L p F P
0 0 0 r
s
.119 .144 .278 r
.43909 .35679 m .41878 .35679 L .41212 .36775 L p F P
0 0 0 r
s
.119 .144 .278 r
.43409 .36775 m .45606 .36775 L .45939 .35679 L p F P
0 0 0 r
s
.24 .35 .67 r
.45492 .35872 m
.45508 .35679 L
s
.119 .144 .278 r
.45939 .35679 m .43909 .35679 L .43409 .36775 L p F P
0 0 0 r
s
.119 .144 .278 r
.45606 .36775 m .47803 .36775 L .4797 .35679 L p F P
0 0 0 r
s
.119 .144 .278 r
.4797 .35679 m .45939 .35679 L .45606 .36775 L p F P
0 0 0 r
s
.119 .144 .278 r
.47803 .36775 m .5 .36775 L .5 .35679 L p F P
0 0 0 r
s
.119 .144 .278 r
.5 .35679 m .4797 .35679 L .47803 .36775 L p F P
0 0 0 r
s
.119 .144 .278 r
.5 .36775 m .52197 .36775 L .5203 .35679 L p F P
0 0 0 r
s
.119 .144 .278 r
.5203 .35679 m .5 .35679 L .5 .36775 L p F P
0 0 0 r
s
.119 .144 .278 r
.52197 .36775 m .54394 .36775 L .54061 .35679 L p F P
0 0 0 r
s
.119 .144 .278 r
.54061 .35679 m .5203 .35679 L .52197 .36775 L p F P
0 0 0 r
s
.119 .144 .278 r
.54394 .36775 m .56591 .36775 L .56091 .35679 L p F P
0 0 0 r
s
.119 .144 .278 r
.56091 .35679 m .54061 .35679 L .54394 .36775 L p F P
0 0 0 r
s
.119 .144 .278 r
.56591 .36775 m .58788 .36775 L .58122 .35679 L p F P
0 0 0 r
s
.119 .144 .278 r
.58122 .35679 m .56091 .35679 L .56591 .36775 L p F P
0 0 0 r
s
.119 .144 .278 r
.58788 .36775 m .60985 .36775 L .60152 .35679 L p F P
0 0 0 r
s
.119 .144 .278 r
.60152 .35679 m .58122 .35679 L .58788 .36775 L p F P
0 0 0 r
s
.119 .144 .278 r
.60985 .36775 m .63183 .36775 L .62183 .35679 L p F P
0 0 0 r
s
.119 .144 .278 r
.62183 .35679 m .60152 .35679 L .60985 .36775 L p F P
0 0 0 r
s
.119 .144 .278 r
.63183 .36775 m .6538 .36775 L .64213 .35679 L p F P
0 0 0 r
s
.83 .24 .1 r
.64497 .36063 m
.64758 .33666 L
s
.119 .144 .278 r
.64213 .35679 m .62183 .35679 L .63183 .36775 L p F P
0 0 0 r
s
.43 .135 .065 r
.38553 .57195 m .38647 .5811 L .37089 .56398 L p F P
0 0 0 r
s
.43 .135 .065 r
.37089 .56398 m .36968 .55341 L .38553 .57195 L p F P
0 0 0 r
s
1 .333 .134 r
.62911 .56398 m .63032 .55341 L .61447 .57195 L p F P
0 0 0 r
s
.83 .24 .1 r
.62749 .56577 m
.6276 .5648 L
s
1 .333 .134 r
.61447 .57195 m .61353 .5811 L .62911 .56398 L p F P
0 0 0 r
s
.7 .195 .071 r
.33892 .45138 m .34077 .46558 L .34021 .44522 L p F P
0 0 0 r
s
.7 .195 .071 r
.34021 .44522 m .33836 .43072 L .33892 .45138 L p F P
0 0 0 r
s
.098 .028 .012 r
.65979 .44522 m .66164 .43072 L .66108 .45138 L p F P
0 0 0 r
s
.098 .028 .012 r
.66108 .45138 m .65923 .46558 L .65979 .44522 L p F P
0 0 0 r
s
.83 .24 .1 r
.37074 .31531 m
.39408 .29735 L
s
.39408 .29735 m
.39161 .26485 L
s
.60592 .29735 m
.60839 .26485 L
s
.60592 .29735 m
.62926 .31531 L
s
.898 .269 .117 r
.47475 .63186 m .4748 .63378 L .45059 .63437 L p F P
0 0 0 r
s
.898 .269 .117 r
.45059 .63437 m .45041 .6306 L .47475 .63186 L p F P
0 0 0 r
s
1 .318 .134 r
.54941 .63437 m .54959 .6306 L .52525 .63186 L p F P
0 0 0 r
s
.83 .24 .1 r
.54883 .63436 m
.54883 .63431 L
s
1 .318 .134 r
.52525 .63186 m .5252 .63378 L .54941 .63437 L p F P
0 0 0 r
s
1 .295 .116 r
.33829 .38248 m .34015 .39754 L .34789 .38223 L p F P
0 0 0 r
s
.83 .24 .1 r
.34372 .39126 m
.34724 .42048 L
s
1 .295 .116 r
.34789 .38223 m .3462 .36775 L .33829 .38248 L p F P
0 0 0 r
s
.83 .24 .1 r
.34372 .39126 m
.35562 .36775 L
s
.249 .072 .039 r
.65211 .38223 m .6538 .36775 L .66171 .38248 L p F P
0 0 0 r
s
.249 .072 .039 r
.66171 .38248 m .65985 .39754 L .65211 .38223 L p F P
0 0 0 r
s
.83 .24 .1 r
.64438 .36775 m
.65628 .39126 L
s
.65276 .42048 m
.65628 .39126 L
s
.968 .289 .124 r
.47498 .6414 m .47493 .63951 L .5 .62969 L closepath p F P
0 0 0 r
s
.286 .433 .851 r
.5 .62969 m .52502 .6414 L .52145 .6414 L closepath p F P
0 0 0 r
s
.286 .433 .851 r
.5 .62969 m .52145 .6414 L .51787 .6414 L closepath p F P
0 0 0 r
s
.286 .433 .851 r
.5 .62969 m .51787 .6414 L .5143 .6414 L closepath p F P
0 0 0 r
s
.286 .433 .851 r
.5 .62969 m .5143 .6414 L .51072 .6414 L closepath p F P
0 0 0 r
s
.286 .433 .851 r
.5 .62969 m .51072 .6414 L .50715 .6414 L closepath p F P
0 0 0 r
s
.286 .433 .851 r
.5 .62969 m .50715 .6414 L .50357 .6414 L closepath p F P
0 0 0 r
s
.286 .433 .851 r
.5 .62969 m .50357 .6414 L .5 .6414 L closepath p F P
0 0 0 r
s
.286 .433 .851 r
.5 .62969 m .5 .6414 L .49643 .6414 L closepath p F P
0 0 0 r
s
.286 .433 .851 r
.5 .62969 m .49643 .6414 L .49285 .6414 L closepath p F P
0 0 0 r
s
.286 .433 .851 r
.5 .62969 m .49285 .6414 L .48928 .6414 L closepath p F P
0 0 0 r
s
.286 .433 .851 r
.5 .62969 m .48928 .6414 L .4857 .6414 L closepath p F P
0 0 0 r
s
.286 .433 .851 r
.5 .62969 m .4857 .6414 L .48213 .6414 L closepath p F P
0 0 0 r
s
.286 .433 .851 r
.5 .62969 m .48213 .6414 L .47855 .6414 L closepath p F P
0 0 0 r
s
.286 .433 .851 r
.5 .62969 m .47855 .6414 L .47498 .6414 L closepath p F P
0 0 0 r
s
1 .305 .13 r
.5 .62969 m .52502 .6414 L .52507 .63951 L closepath p F P
0 0 0 r
s
.899 .254 .097 r
.33645 .41589 m .33836 .43072 L .34197 .41225 L p F P
0 0 0 r
s
.899 .254 .097 r
.34197 .41225 m .34015 .39754 L .33645 .41589 L p F P
0 0 0 r
s
.181 .052 .027 r
.65803 .41225 m .65985 .39754 L .66355 .41589 L p F P
0 0 0 r
s
.181 .052 .027 r
.66355 .41589 m .66164 .43072 L .65803 .41225 L p F P
0 0 0 r
s
.32 .095 .05 r
.36844 .54264 m .36968 .55341 L .35736 .53369 L p F P
0 0 0 r
s
.32 .095 .05 r
.35736 .53369 m .35588 .52169 L .36844 .54264 L p F P
0 0 0 r
s
1 .315 .125 r
.64264 .53369 m .64412 .52169 L .63156 .54264 L p F P
0 0 0 r
s
1 .315 .125 r
.63156 .54264 m .63032 .55341 L .64264 .53369 L p F P
0 0 0 r
s
.24 .35 .67 r
.22342 .37848 m
.22814 .36147 L
s
.18283 .36147 m
.17732 .37848 L
s
.22814 .36147 m
.18283 .36147 L
s
.26952 .37848 m
.27345 .36147 L
s
.27345 .36147 m
.22814 .36147 L
s
.31561 .37848 m
.31876 .36147 L
s
.31876 .36147 m
.27345 .36147 L
s
.31876 .36147 m
.35288 .36147 L
s
.68439 .37848 m
.68124 .36147 L
s
.64712 .36147 m
.68124 .36147 L
s
.73048 .37848 m
.72655 .36147 L
s
.72655 .36147 m
.68124 .36147 L
s
.77658 .37848 m
.77186 .36147 L
s
.77186 .36147 m
.72655 .36147 L
s
.82268 .37848 m
.81717 .36147 L
s
.81717 .36147 m
.77186 .36147 L
s
.814 .245 .108 r
.45005 .62298 m .45023 .6268 L .42727 .62042 L p F P
0 0 0 r
s
.814 .245 .108 r
.42727 .62042 m .42689 .61479 L .45005 .62298 L p F P
0 0 0 r
s
1 .329 .137 r
.57273 .62042 m .57311 .61479 L .54995 .62298 L p F P
0 0 0 r
s
1 .329 .137 r
.54995 .62298 m .54977 .6268 L .57273 .62042 L p F P
0 0 0 r
s
.968 .289 .124 r
.47493 .63951 m .47489 .63761 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .305 .13 r
.5 .62969 m .52507 .63951 L .52511 .63761 L closepath p F P
0 0 0 r
s
.712 .216 .097 r
.4265 .6091 m .42689 .61479 L .40581 .60371 L p F P
0 0 0 r
s
.712 .216 .097 r
.40581 .60371 m .40517 .59629 L .4265 .6091 L p F P
0 0 0 r
s
1 .336 .139 r
.59419 .60371 m .59483 .59629 L .5735 .6091 L p F P
0 0 0 r
s
1 .336 .139 r
.5735 .6091 m .57311 .61479 L .59419 .60371 L p F P
0 0 0 r
s
.898 .269 .117 r
.4747 .62994 m .47475 .63186 L .45041 .6306 L p F P
0 0 0 r
s
.898 .269 .117 r
.45041 .6306 m .45023 .6268 L .4747 .62994 L p F P
0 0 0 r
s
1 .318 .134 r
.54959 .6306 m .54977 .6268 L .5253 .62994 L p F P
0 0 0 r
s
.83 .24 .1 r
.549 .63063 m
.54901 .63058 L
s
1 .318 .134 r
.5253 .62994 m .52525 .63186 L .54959 .6306 L p F P
0 0 0 r
s
.968 .289 .124 r
.47489 .63761 m .47484 .6357 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .305 .13 r
.5 .62969 m .52511 .63761 L .52516 .6357 L closepath p F P
0 0 0 r
s
.583 .18 .083 r
.40452 .58877 m .40517 .59629 L .38647 .5811 L p F P
0 0 0 r
s
.583 .18 .083 r
.38647 .5811 m .38553 .57195 L .40452 .58877 L p F P
0 0 0 r
s
1 .338 .138 r
.61353 .5811 m .61447 .57195 L .59548 .58877 L p F P
0 0 0 r
s
1 .338 .138 r
.59548 .58877 m .59483 .59629 L .61353 .5811 L p F P
0 0 0 r
s
.24 .35 .67 r
.22743 .63648 m
.182 .63648 L
s
.27286 .63648 m
.22743 .63648 L
s
.31828 .63648 m
.27286 .63648 L
s
.36371 .63648 m
.31828 .63648 L
s
.40914 .63648 m
.36371 .63648 L
s
.40914 .63648 m
.45457 .63648 L
s
.45457 .63648 m
.47279 .63648 L
s
.52721 .63648 m
.54543 .63648 L
s
.54543 .63648 m
.59086 .63648 L
s
.63629 .63648 m
.59086 .63648 L
s
.68172 .63648 m
.63629 .63648 L
s
.72714 .63648 m
.68172 .63648 L
s
.77257 .63648 m
.72714 .63648 L
s
.818 .63648 m
.77257 .63648 L
s
.22743 .63648 m
.22278 .61852 L
s
.17658 .61852 m
.182 .63648 L
s
.27286 .63648 m
.26899 .61852 L
s
.31828 .63648 m
.31519 .61852 L
s
.36371 .63648 m
.36139 .61852 L
s
.40759 .61852 m
.40914 .63648 L
s
.59086 .63648 m
.59241 .61852 L
s
.63629 .63648 m
.63861 .61852 L
s
.68172 .63648 m
.68481 .61852 L
s
.72714 .63648 m
.73101 .61852 L
s
.77257 .63648 m
.77722 .61852 L
s
.818 .63648 m
.82342 .61852 L
s
.236 .068 .036 r
.35437 .50943 m .35588 .52169 L .3472 .50043 L p F P
0 0 0 r
s
.236 .068 .036 r
.3472 .50043 m .3455 .48719 L .35437 .50943 L p F P
0 0 0 r
s
.973 .282 .11 r
.6528 .50043 m .6545 .48719 L .64563 .50943 L p F P
0 0 0 r
s
.973 .282 .11 r
.64563 .50943 m .64412 .52169 L .6528 .50043 L p F P
0 0 0 r
s
.968 .289 .124 r
.47484 .6357 m .4748 .63378 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .305 .13 r
.5 .62969 m .52516 .6357 L .5252 .63378 L closepath p F P
0 0 0 r
s
.814 .245 .108 r
.44987 .61912 m .45005 .62298 L .42689 .61479 L p F P
0 0 0 r
s
.83 .24 .1 r
.44998 .62145 m
.45058 .62168 L
s
.814 .245 .108 r
.42689 .61479 m .4265 .6091 L .44987 .61912 L p F P
0 0 0 r
s
1 .329 .137 r
.57311 .61479 m .5735 .6091 L .55013 .61912 L p F P
0 0 0 r
s
1 .329 .137 r
.55013 .61912 m .54995 .62298 L .57311 .61479 L p F P
0 0 0 r
s
.83 .24 .1 r
.54942 .62168 m
.55002 .62145 L
s
.898 .269 .117 r
.47466 .628 m .4747 .62994 L .45023 .6268 L p F P
0 0 0 r
s
.898 .269 .117 r
.45023 .6268 m .45005 .62298 L .47466 .628 L p F P
0 0 0 r
s
.83 .24 .1 r
.45058 .62168 m
.45065 .6231 L
s
1 .318 .134 r
.54977 .6268 m .54995 .62298 L .52534 .628 L p F P
0 0 0 r
s
.83 .24 .1 r
.54918 .62688 m
.54918 .62683 L
s
.54935 .6231 m
.54942 .62168 L
s
1 .318 .134 r
.52534 .628 m .5253 .62994 L .54977 .6268 L p F P
0 0 0 r
s
.43 .135 .065 r
.38458 .56266 m .38553 .57195 L .36968 .55341 L p F P
0 0 0 r
s
.43 .135 .065 r
.36968 .55341 m .36844 .54264 L .38458 .56266 L p F P
0 0 0 r
s
1 .333 .134 r
.63032 .55341 m .63156 .54264 L .61542 .56266 L p F P
0 0 0 r
s
.83 .24 .1 r
.62867 .55535 m
.62878 .55437 L
s
1 .333 .134 r
.61542 .56266 m .61447 .57195 L .63032 .55341 L p F P
0 0 0 r
s
.968 .289 .124 r
.4748 .63378 m .47475 .63186 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .305 .13 r
.5 .62969 m .5252 .63378 L .52525 .63186 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.45057 .24121 m
.48332 .23634 L
s
.48332 .23634 m
.48293 .20215 L
s
.48332 .23634 m
.51668 .23634 L
s
.51668 .23634 m
.51707 .20215 L
s
.51668 .23634 m
.54943 .24121 L
s
.157 .045 .023 r
.34376 .47365 m .3455 .48719 L .34077 .46558 L p F P
0 0 0 r
s
.157 .045 .023 r
.34077 .46558 m .33892 .45138 L .34376 .47365 L p F P
0 0 0 r
s
.83 .24 .1 r
.34339 .47174 m
.34346 .47228 L
s
.34188 .44579 m
.34339 .47174 L
s
.796 .229 .086 r
.65923 .46558 m .66108 .45138 L .65624 .47365 L p F P
0 0 0 r
s
.796 .229 .086 r
.65624 .47365 m .6545 .48719 L .65923 .46558 L p F P
0 0 0 r
s
.83 .24 .1 r
.65654 .47228 m
.65661 .47174 L
s
.65661 .47174 m
.65812 .44579 L
s
.712 .216 .097 r
.42611 .60335 m .4265 .6091 L .40517 .59629 L p F P
0 0 0 r
s
.712 .216 .097 r
.40517 .59629 m .40452 .58877 L .42611 .60335 L p F P
0 0 0 r
s
1 .336 .139 r
.59483 .59629 m .59548 .58877 L .57389 .60335 L p F P
0 0 0 r
s
1 .336 .139 r
.57389 .60335 m .5735 .6091 L .59483 .59629 L p F P
0 0 0 r
s
.83 .24 .1 r
.35242 .33666 m
.37074 .31531 L
s
.37074 .31531 m
.36769 .28292 L
s
.62926 .31531 m
.63231 .28292 L
s
.62926 .31531 m
.64758 .33666 L
s
.968 .289 .124 r
.47475 .63186 m .4747 .62994 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .305 .13 r
.5 .62969 m .52525 .63186 L .5253 .62994 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.41961 .25081 m
.45057 .24121 L
s
.45057 .24121 m
.44941 .20704 L
s
.54943 .24121 m
.55059 .20704 L
s
.54943 .24121 m
.58039 .25081 L
s
.898 .269 .117 r
.47461 .62606 m .47466 .628 L .45005 .62298 L p F P
0 0 0 r
s
.898 .269 .117 r
.45005 .62298 m .44987 .61912 L .47461 .62606 L p F P
0 0 0 r
s
.83 .24 .1 r
.47418 .62594 m
.48324 .62757 L
s
1 .318 .134 r
.54995 .62298 m .55013 .61912 L .52539 .62606 L p F P
0 0 0 r
s
1 .318 .134 r
.52539 .62606 m .52534 .628 L .54995 .62298 L p F P
0 0 0 r
s
.83 .24 .1 r
.51676 .62757 m
.52582 .62594 L
s
.7 .195 .071 r
.33703 .43684 m .33892 .45138 L .33836 .43072 L p F P
0 0 0 r
s
.7 .195 .071 r
.33836 .43072 m .33645 .41589 L .33703 .43684 L p F P
0 0 0 r
s
.098 .028 .012 r
.66164 .43072 m .66355 .41589 L .66297 .43684 L p F P
0 0 0 r
s
.098 .028 .012 r
.66297 .43684 m .66108 .45138 L .66164 .43072 L p F P
0 0 0 r
s
.968 .289 .124 r
.4747 .62994 m .47466 .628 L .5 .62969 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.48324 .62757 m
.48326 .62857 L
s
1 .305 .13 r
.5 .62969 m .5253 .62994 L .52534 .628 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.51674 .62857 m
.51676 .62757 L
s
.161 .21 .408 r
.33829 .38248 m .36139 .38248 L .36817 .36775 L p F P
0 0 0 r
s
.24 .35 .67 r
.36283 .37038 m
.3632 .36775 L
s
.161 .21 .408 r
.36817 .36775 m .3462 .36775 L .33829 .38248 L p F P
0 0 0 r
s
.83 .24 .1 r
.34267 .38248 m
.34372 .39126 L
s
.34005 .36067 m
.34209 .37767 L
s
.161 .21 .408 r
.36139 .38248 m .38449 .38248 L .39015 .36775 L p F P
0 0 0 r
s
.161 .21 .408 r
.39015 .36775 m .36817 .36775 L .36139 .38248 L p F P
0 0 0 r
s
.161 .21 .408 r
.38449 .38248 m .40759 .38248 L .41212 .36775 L p F P
0 0 0 r
s
.24 .35 .67 r
.40863 .36961 m
.4088 .36775 L
s
.161 .21 .408 r
.41212 .36775 m .39015 .36775 L .38449 .38248 L p F P
0 0 0 r
s
.161 .21 .408 r
.40759 .38248 m .4307 .38248 L .43409 .36775 L p F P
0 0 0 r
s
.161 .21 .408 r
.43409 .36775 m .41212 .36775 L .40759 .38248 L p F P
0 0 0 r
s
.161 .21 .408 r
.4307 .38248 m .4538 .38248 L .45606 .36775 L p F P
0 0 0 r
s
.24 .35 .67 r
.45435 .36874 m
.4544 .36775 L
s
.161 .21 .408 r
.45606 .36775 m .43409 .36775 L .4307 .38248 L p F P
0 0 0 r
s
.161 .21 .408 r
.4538 .38248 m .4769 .38248 L .47803 .36775 L p F P
0 0 0 r
s
.161 .21 .408 r
.47803 .36775 m .45606 .36775 L .4538 .38248 L p F P
0 0 0 r
s
.161 .21 .408 r
.4769 .38248 m .5 .38248 L .5 .36775 L p F P
0 0 0 r
s
.161 .21 .408 r
.5 .36775 m .47803 .36775 L .4769 .38248 L p F P
0 0 0 r
s
.161 .21 .408 r
.5 .38248 m .5231 .38248 L .52197 .36775 L p F P
0 0 0 r
s
.161 .21 .408 r
.52197 .36775 m .5 .36775 L .5 .38248 L p F P
0 0 0 r
s
.161 .21 .408 r
.5231 .38248 m .5462 .38248 L .54394 .36775 L p F P
0 0 0 r
s
.161 .21 .408 r
.54394 .36775 m .52197 .36775 L .5231 .38248 L p F P
0 0 0 r
s
.161 .21 .408 r
.5462 .38248 m .5693 .38248 L .56591 .36775 L p F P
0 0 0 r
s
.161 .21 .408 r
.56591 .36775 m .54394 .36775 L .5462 .38248 L p F P
0 0 0 r
s
.161 .21 .408 r
.5693 .38248 m .59241 .38248 L .58788 .36775 L p F P
0 0 0 r
s
.161 .21 .408 r
.58788 .36775 m .56591 .36775 L .5693 .38248 L p F P
0 0 0 r
s
.161 .21 .408 r
.59241 .38248 m .61551 .38248 L .60985 .36775 L p F P
0 0 0 r
s
.161 .21 .408 r
.60985 .36775 m .58788 .36775 L .59241 .38248 L p F P
0 0 0 r
s
.161 .21 .408 r
.61551 .38248 m .63861 .38248 L .63183 .36775 L p F P
0 0 0 r
s
.161 .21 .408 r
.63183 .36775 m .60985 .36775 L .61551 .38248 L p F P
0 0 0 r
s
.161 .21 .408 r
.63861 .38248 m .66171 .38248 L .6538 .36775 L p F P
0 0 0 r
s
.83 .24 .1 r
.65791 .37767 m
.65995 .36067 L
s
.65628 .39126 m
.65733 .38248 L
s
.161 .21 .408 r
.6538 .36775 m .63183 .36775 L .63861 .38248 L p F P
0 0 0 r
s
.32 .095 .05 r
.36718 .53166 m .36844 .54264 L .35588 .52169 L p F P
0 0 0 r
s
.32 .095 .05 r
.35588 .52169 m .35437 .50943 L .36718 .53166 L p F P
0 0 0 r
s
1 .315 .125 r
.64412 .52169 m .64563 .50943 L .63282 .53166 L p F P
0 0 0 r
s
1 .315 .125 r
.63282 .53166 m .63156 .54264 L .64412 .52169 L p F P
0 0 0 r
s
.899 .254 .097 r
.3345 .4007 m .33645 .41589 L .34015 .39754 L p F P
0 0 0 r
s
.899 .254 .097 r
.34015 .39754 m .33829 .38248 L .3345 .4007 L p F P
0 0 0 r
s
.83 .24 .1 r
.3382 .41679 m
.34372 .39126 L
s
.181 .052 .027 r
.65985 .39754 m .66171 .38248 L .6655 .4007 L p F P
0 0 0 r
s
.181 .052 .027 r
.6655 .4007 m .66355 .41589 L .65985 .39754 L p F P
0 0 0 r
s
.83 .24 .1 r
.65628 .39126 m
.6618 .41679 L
s
.583 .18 .083 r
.40386 .58114 m .40452 .58877 L .38553 .57195 L p F P
0 0 0 r
s
.583 .18 .083 r
.38553 .57195 m .38458 .56266 L .40386 .58114 L p F P
0 0 0 r
s
1 .338 .138 r
.61447 .57195 m .61542 .56266 L .59614 .58114 L p F P
0 0 0 r
s
1 .338 .138 r
.59614 .58114 m .59548 .58877 L .61447 .57195 L p F P
0 0 0 r
s
.814 .245 .108 r
.44969 .61524 m .44987 .61912 L .4265 .6091 L p F P
0 0 0 r
s
.814 .245 .108 r
.4265 .6091 m .42611 .60335 L .44969 .61524 L p F P
0 0 0 r
s
1 .329 .137 r
.5735 .6091 m .57389 .60335 L .55031 .61524 L p F P
0 0 0 r
s
1 .329 .137 r
.55031 .61524 m .55013 .61912 L .5735 .6091 L p F P
0 0 0 r
s
.83 .24 .1 r
.51676 .62757 m
.48324 .62757 L
s
.968 .289 .124 r
.47466 .628 m .47461 .62606 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .305 .13 r
.5 .62969 m .52534 .628 L .52539 .62606 L closepath p F P
0 0 0 r
s
1 .305 .13 r
.5 .62969 m .52562 .61624 L .52567 .61425 L closepath p F P
0 0 0 r
s
1 .305 .13 r
.5 .62969 m .52539 .62606 L .52543 .62411 L closepath p F P
0 0 0 r
s
1 .305 .13 r
.5 .62969 m .52543 .62411 L .52548 .62215 L closepath p F P
0 0 0 r
s
1 .305 .13 r
.5 .62969 m .52548 .62215 L .52553 .62019 L closepath p F P
0 0 0 r
s
1 .305 .13 r
.5 .62969 m .52553 .62019 L .52557 .61822 L closepath p F P
0 0 0 r
s
1 .305 .13 r
.5 .62969 m .52557 .61822 L .52562 .61624 L closepath p F P
0 0 0 r
s
.968 .289 .124 r
.47443 .61822 m .47438 .61624 L .5 .62969 L closepath p F P
0 0 0 r
s
.968 .289 .124 r
.47447 .62019 m .47443 .61822 L .5 .62969 L closepath p F P
0 0 0 r
s
.968 .289 .124 r
.47452 .62215 m .47447 .62019 L .5 .62969 L closepath p F P
0 0 0 r
s
.968 .289 .124 r
.47457 .62411 m .47452 .62215 L .5 .62969 L closepath p F P
0 0 0 r
s
.968 .289 .124 r
.47461 .62606 m .47457 .62411 L .5 .62969 L closepath p F P
0 0 0 r
s
.968 .289 .124 r
.47438 .61624 m .47433 .61425 L .5 .62969 L closepath p F P
0 0 0 r
s
.289 .431 .847 r
.478 .61425 m .47433 .61425 L .5 .62969 L closepath p F P
0 0 0 r
s
.289 .431 .847 r
.48166 .61425 m .478 .61425 L .5 .62969 L closepath p F P
0 0 0 r
s
.289 .431 .847 r
.48533 .61425 m .48166 .61425 L .5 .62969 L closepath p F P
0 0 0 r
s
.289 .431 .847 r
.489 .61425 m .48533 .61425 L .5 .62969 L closepath p F P
0 0 0 r
s
.289 .431 .847 r
.49267 .61425 m .489 .61425 L .5 .62969 L closepath p F P
0 0 0 r
s
.289 .431 .847 r
.49633 .61425 m .49267 .61425 L .5 .62969 L closepath p F P
0 0 0 r
s
.289 .431 .847 r
.5 .61425 m .49633 .61425 L .5 .62969 L closepath p F P
0 0 0 r
s
.289 .431 .847 r
.50367 .61425 m .5 .61425 L .5 .62969 L closepath p F P
0 0 0 r
s
.289 .431 .847 r
.50733 .61425 m .50367 .61425 L .5 .62969 L closepath p F P
0 0 0 r
s
.289 .431 .847 r
.511 .61425 m .50733 .61425 L .5 .62969 L closepath p F P
0 0 0 r
s
.289 .431 .847 r
.51467 .61425 m .511 .61425 L .5 .62969 L closepath p F P
0 0 0 r
s
.289 .431 .847 r
.51834 .61425 m .51467 .61425 L .5 .62969 L closepath p F P
0 0 0 r
s
.289 .431 .847 r
.522 .61425 m .51834 .61425 L .5 .62969 L closepath p F P
0 0 0 r
s
.289 .431 .847 r
.52567 .61425 m .522 .61425 L .5 .62969 L closepath p F P
0 0 0 r
s
.898 .269 .117 r
.47457 .62411 m .47461 .62606 L .44987 .61912 L p F P
0 0 0 r
s
.898 .269 .117 r
.44987 .61912 m .44969 .61524 L .47457 .62411 L p F P
0 0 0 r
s
1 .318 .134 r
.55013 .61912 m .55031 .61524 L .52543 .62411 L p F P
0 0 0 r
s
.83 .24 .1 r
.54953 .61929 m
.54953 .61924 L
s
1 .318 .134 r
.52543 .62411 m .52539 .62606 L .55013 .61912 L p F P
0 0 0 r
s
.83 .24 .1 r
.39161 .26485 m
.41961 .25081 L
s
.41961 .25081 m
.41771 .21669 L
s
.58039 .25081 m
.58229 .21669 L
s
.58039 .25081 m
.60839 .26485 L
s
.712 .216 .097 r
.42572 .59753 m .42611 .60335 L .40452 .58877 L p F P
0 0 0 r
s
.712 .216 .097 r
.40452 .58877 m .40386 .58114 L .42572 .59753 L p F P
0 0 0 r
s
1 .336 .139 r
.59548 .58877 m .59614 .58114 L .57428 .59753 L p F P
0 0 0 r
s
1 .336 .139 r
.57428 .59753 m .57389 .60335 L .59548 .58877 L p F P
0 0 0 r
s
.236 .068 .036 r
.35283 .49692 m .35437 .50943 L .3455 .48719 L p F P
0 0 0 r
s
.236 .068 .036 r
.3455 .48719 m .34376 .47365 L .35283 .49692 L p F P
0 0 0 r
s
.83 .24 .1 r
.34339 .47174 m
.3458 .47889 L
s
.973 .282 .11 r
.6545 .48719 m .65624 .47365 L .64717 .49692 L p F P
0 0 0 r
s
.83 .24 .1 r
.6542 .47889 m
.65661 .47174 L
s
.973 .282 .11 r
.64717 .49692 m .64563 .50943 L .6545 .48719 L p F P
0 0 0 r
s
.898 .269 .117 r
.47452 .62215 m .47457 .62411 L .44969 .61524 L p F P
0 0 0 r
s
1 .318 .134 r
.52548 .62215 m .52543 .62411 L .55031 .61524 L p F P
0 0 0 r
s
.43 .135 .065 r
.38361 .55321 m .38458 .56266 L .36844 .54264 L p F P
0 0 0 r
s
.43 .135 .065 r
.36844 .54264 m .36718 .53166 L .38361 .55321 L p F P
0 0 0 r
s
1 .333 .134 r
.63156 .54264 m .63282 .53166 L .61639 .55321 L p F P
0 0 0 r
s
.83 .24 .1 r
.62987 .54473 m
.62998 .54373 L
s
1 .333 .134 r
.61639 .55321 m .61542 .56266 L .63156 .54264 L p F P
0 0 0 r
s
.814 .245 .108 r
.44951 .61133 m .44969 .61524 L .42611 .60335 L p F P
0 0 0 r
s
.814 .245 .108 r
.42611 .60335 m .42572 .59753 L .44951 .61133 L p F P
0 0 0 r
s
1 .329 .137 r
.57389 .60335 m .57428 .59753 L .55049 .61133 L p F P
0 0 0 r
s
1 .329 .137 r
.55049 .61133 m .55031 .61524 L .57389 .60335 L p F P
0 0 0 r
s
.898 .269 .117 r
.44969 .61524 m .44951 .61133 L .47452 .62215 L p F P
0 0 0 r
s
1 .318 .134 r
.55031 .61524 m .55049 .61133 L .52548 .62215 L p F P
0 0 0 r
s
.898 .269 .117 r
.47447 .62019 m .47452 .62215 L .44951 .61133 L p F P
0 0 0 r
s
1 .318 .134 r
.52553 .62019 m .52548 .62215 L .55049 .61133 L p F P
0 0 0 r
s
.24 .35 .67 r
.21936 .40178 m
.22342 .37848 L
s
.17732 .37848 m
.17259 .40178 L
s
.22342 .37848 m
.17732 .37848 L
s
.26614 .40178 m
.26952 .37848 L
s
.26952 .37848 m
.22342 .37848 L
s
.31291 .40178 m
.31561 .37848 L
s
.31561 .37848 m
.26952 .37848 L
s
.31561 .37848 m
.34044 .37848 L
s
.68709 .40178 m
.68439 .37848 L
s
.65956 .37848 m
.68439 .37848 L
s
.73386 .40178 m
.73048 .37848 L
s
.73048 .37848 m
.68439 .37848 L
s
.78064 .40178 m
.77658 .37848 L
s
.77658 .37848 m
.73048 .37848 L
s
.82741 .40178 m
.82268 .37848 L
s
.82268 .37848 m
.77658 .37848 L
s
.157 .045 .023 r
.34199 .45981 m .34376 .47365 L .33892 .45138 L p F P
0 0 0 r
s
.157 .045 .023 r
.33892 .45138 m .33703 .43684 L .34199 .45981 L p F P
0 0 0 r
s
.83 .24 .1 r
.3382 .41679 m
.34188 .44579 L
s
.796 .229 .086 r
.66108 .45138 m .66297 .43684 L .65801 .45981 L p F P
0 0 0 r
s
.83 .24 .1 r
.65812 .44579 m
.6618 .41679 L
s
.796 .229 .086 r
.65801 .45981 m .65624 .47365 L .66108 .45138 L p F P
0 0 0 r
s
.83 .24 .1 r
.34005 .36067 m
.35242 .33666 L
s
.35242 .33666 m
.34891 .30442 L
s
.64758 .33666 m
.65109 .30442 L
s
.64758 .33666 m
.65995 .36067 L
s
.898 .269 .117 r
.47443 .61822 m .47447 .62019 L .44932 .6074 L p F P
0 0 0 r
s
.898 .269 .117 r
.44951 .61133 m .44932 .6074 L .47447 .62019 L p F P
0 0 0 r
s
.24 .35 .67 r
.4538 .61852 m
.45457 .63648 L
s
1 .318 .134 r
.55049 .61133 m .55068 .6074 L .52553 .62019 L p F P
0 0 0 r
s
1 .318 .134 r
.52557 .61822 m .52553 .62019 L .55068 .6074 L p F P
0 0 0 r
s
.24 .35 .67 r
.54543 .63648 m
.5462 .61852 L
s
.583 .18 .083 r
.40319 .57341 m .40386 .58114 L .38458 .56266 L p F P
0 0 0 r
s
.83 .24 .1 r
.38444 .56124 m
.38791 .56458 L
s
.583 .18 .083 r
.38458 .56266 m .38361 .55321 L .40319 .57341 L p F P
0 0 0 r
s
1 .338 .138 r
.61542 .56266 m .61639 .55321 L .59681 .57341 L p F P
0 0 0 r
s
1 .338 .138 r
.59681 .57341 m .59614 .58114 L .61542 .56266 L p F P
0 0 0 r
s
.24 .35 .67 r
.22278 .61852 m
.17658 .61852 L
s
.26899 .61852 m
.22278 .61852 L
s
.31519 .61852 m
.26899 .61852 L
s
.36139 .61852 m
.31519 .61852 L
s
.40759 .61852 m
.36139 .61852 L
s
.40759 .61852 m
.4538 .61852 L
s
.4538 .61852 m
.46799 .61852 L
s
.46799 .61852 m
.47233 .61852 L
s
.53201 .61852 m
.5462 .61852 L
s
.52767 .61852 m
.53201 .61852 L
s
.5462 .61852 m
.59241 .61852 L
s
.63861 .61852 m
.59241 .61852 L
s
.68481 .61852 m
.63861 .61852 L
s
.73101 .61852 m
.68481 .61852 L
s
.77722 .61852 m
.73101 .61852 L
s
.82342 .61852 m
.77722 .61852 L
s
.22278 .61852 m
.21885 .59437 L
s
.17199 .59437 m
.17658 .61852 L
s
.26899 .61852 m
.26571 .59437 L
s
.31519 .61852 m
.31256 .59437 L
s
.36139 .61852 m
.35942 .59437 L
s
.63861 .61852 m
.64058 .59437 L
s
.68481 .61852 m
.68744 .59437 L
s
.73101 .61852 m
.73429 .59437 L
s
.77722 .61852 m
.78115 .59437 L
s
.82342 .61852 m
.82801 .59437 L
s
1 .329 .137 r
.55068 .6074 m .55049 .61133 L .57428 .59753 L p F P
0 0 0 r
s
.814 .245 .108 r
.44932 .6074 m .44951 .61133 L .42572 .59753 L p F P
0 0 0 r
s
.32 .095 .05 r
.3659 .52047 m .36718 .53166 L .35437 .50943 L p F P
0 0 0 r
s
.32 .095 .05 r
.35437 .50943 m .35283 .49692 L .3659 .52047 L p F P
0 0 0 r
s
1 .315 .125 r
.64563 .50943 m .64717 .49692 L .6341 .52047 L p F P
0 0 0 r
s
1 .315 .125 r
.6341 .52047 m .63282 .53166 L .64563 .50943 L p F P
0 0 0 r
s
1 .318 .134 r
.55068 .6074 m .55086 .60343 L .52557 .61822 L p F P
0 0 0 r
s
1 .318 .134 r
.52562 .61624 m .52557 .61822 L .55086 .60343 L p F P
0 0 0 r
s
.898 .269 .117 r
.47438 .61624 m .47443 .61822 L .44914 .60343 L p F P
0 0 0 r
s
.898 .269 .117 r
.44932 .6074 m .44914 .60343 L .47443 .61822 L p F P
0 0 0 r
s
.7 .195 .071 r
.3351 .42195 m .33703 .43684 L .33645 .41589 L p F P
0 0 0 r
s
.7 .195 .071 r
.33645 .41589 m .3345 .4007 L .3351 .42195 L p F P
0 0 0 r
s
.098 .028 .012 r
.66355 .41589 m .6655 .4007 L .6649 .42195 L p F P
0 0 0 r
s
.098 .028 .012 r
.6649 .42195 m .66297 .43684 L .66355 .41589 L p F P
0 0 0 r
s
.712 .216 .097 r
.42532 .59165 m .42572 .59753 L .40386 .58114 L p F P
0 0 0 r
s
.24 .35 .67 r
.40628 .59437 m
.40759 .61852 L
s
.712 .216 .097 r
.40386 .58114 m .40319 .57341 L .42532 .59165 L p F P
0 0 0 r
s
.83 .24 .1 r
.41858 .5849 m
.41868 .58618 L
s
.41276 .5813 m
.41858 .5849 L
s
1 .336 .139 r
.59614 .58114 m .59681 .57341 L .57468 .59165 L p F P
0 0 0 r
s
1 .336 .139 r
.57468 .59165 m .57428 .59753 L .59614 .58114 L p F P
0 0 0 r
s
.83 .24 .1 r
.58132 .58618 m
.58142 .5849 L
s
.58142 .5849 m
.58724 .5813 L
s
.24 .35 .67 r
.59241 .61852 m
.59372 .59437 L
s
.83 .24 .1 r
.36769 .28292 m
.39161 .26485 L
s
.39161 .26485 m
.38902 .23081 L
s
.60839 .26485 m
.61098 .23081 L
s
.60839 .26485 m
.63231 .28292 L
s
.814 .245 .108 r
.42572 .59753 m .42532 .59165 L .44932 .6074 L p F P
0 0 0 r
s
1 .329 .137 r
.57428 .59753 m .57468 .59165 L .55068 .6074 L p F P
0 0 0 r
s
.19 .256 .498 r
.3345 .4007 m .35815 .4007 L .36139 .38248 L p F P
0 0 0 r
s
.24 .35 .67 r
.36136 .38251 m
.36136 .38248 L
s
.19 .256 .498 r
.36139 .38248 m .33829 .38248 L .3345 .4007 L p F P
0 0 0 r
s
.19 .256 .498 r
.35815 .4007 m .38179 .4007 L .38449 .38248 L p F P
0 0 0 r
s
.19 .256 .498 r
.38449 .38248 m .36139 .38248 L .35815 .4007 L p F P
0 0 0 r
s
.24 .35 .67 r
.35968 .40178 m
.35978 .4007 L
s
.19 .256 .498 r
.38179 .4007 m .40543 .4007 L .40759 .38248 L p F P
0 0 0 r
s
.24 .35 .67 r
.40757 .3825 m
.40757 .38248 L
s
.19 .256 .498 r
.40759 .38248 m .38449 .38248 L .38179 .4007 L p F P
0 0 0 r
s
.19 .256 .498 r
.40543 .4007 m .42907 .4007 L .4307 .38248 L p F P
0 0 0 r
s
.19 .256 .498 r
.4307 .38248 m .40759 .38248 L .40543 .4007 L p F P
0 0 0 r
s
.24 .35 .67 r
.40645 .40178 m
.40652 .4007 L
s
.19 .256 .498 r
.42907 .4007 m .45272 .4007 L .4538 .38248 L p F P
0 0 0 r
s
.24 .35 .67 r
.45379 .38249 m
.45379 .38248 L
s
.19 .256 .498 r
.4538 .38248 m .4307 .38248 L .42907 .4007 L p F P
0 0 0 r
s
.19 .256 .498 r
.45272 .4007 m .47636 .4007 L .4769 .38248 L p F P
0 0 0 r
s
.19 .256 .498 r
.4769 .38248 m .4538 .38248 L .45272 .4007 L p F P
0 0 0 r
s
.24 .35 .67 r
.45323 .40178 m
.45326 .4007 L
s
.19 .256 .498 r
.47636 .4007 m .5 .4007 L .5 .38248 L p F P
0 0 0 r
s
.19 .256 .498 r
.5 .38248 m .4769 .38248 L .47636 .4007 L p F P
0 0 0 r
s
.19 .256 .498 r
.5 .4007 m .52364 .4007 L .5231 .38248 L p F P
0 0 0 r
s
.19 .256 .498 r
.5231 .38248 m .5 .38248 L .5 .4007 L p F P
0 0 0 r
s
.24 .35 .67 r
.5 .4007 m
.5 .40178 L
s
.19 .256 .498 r
.52364 .4007 m .54728 .4007 L .5462 .38248 L p F P
0 0 0 r
s
.24 .35 .67 r
.54621 .38248 m
.54622 .38281 L
s
.19 .256 .498 r
.5462 .38248 m .5231 .38248 L .52364 .4007 L p F P
0 0 0 r
s
.19 .256 .498 r
.54728 .4007 m .57093 .4007 L .5693 .38248 L p F P
0 0 0 r
s
.19 .256 .498 r
.5693 .38248 m .5462 .38248 L .54728 .4007 L p F P
0 0 0 r
s
.24 .35 .67 r
.54674 .4007 m
.54677 .40178 L
s
.19 .256 .498 r
.57093 .4007 m .59457 .4007 L .59241 .38248 L p F P
0 0 0 r
s
.24 .35 .67 r
.59243 .38248 m
.59245 .38281 L
s
.19 .256 .498 r
.59241 .38248 m .5693 .38248 L .57093 .4007 L p F P
0 0 0 r
s
.19 .256 .498 r
.59457 .4007 m .61821 .4007 L .61551 .38248 L p F P
0 0 0 r
s
.19 .256 .498 r
.61551 .38248 m .59241 .38248 L .59457 .4007 L p F P
0 0 0 r
s
.24 .35 .67 r
.59348 .4007 m
.59355 .40178 L
s
.19 .256 .498 r
.61821 .4007 m .64185 .4007 L .63861 .38248 L p F P
0 0 0 r
s
.24 .35 .67 r
.63864 .38248 m
.63867 .38281 L
s
.19 .256 .498 r
.63861 .38248 m .61551 .38248 L .61821 .4007 L p F P
0 0 0 r
s
.19 .256 .498 r
.64185 .4007 m .6655 .4007 L .66171 .38248 L p F P
0 0 0 r
s
.19 .256 .498 r
.66171 .38248 m .63861 .38248 L .64185 .4007 L p F P
0 0 0 r
s
.24 .35 .67 r
.64022 .4007 m
.64032 .40178 L
s
1 .318 .134 r
.55086 .60343 m .55105 .59943 L .52562 .61624 L p F P
0 0 0 r
s
1 .318 .134 r
.52567 .61425 m .52562 .61624 L .55105 .59943 L p F P
0 0 0 r
s
.898 .269 .117 r
.47433 .61425 m .47438 .61624 L .44895 .59943 L p F P
0 0 0 r
s
.898 .269 .117 r
.44914 .60343 m .44895 .59943 L .47438 .61624 L p F P
0 0 0 r
s
.814 .245 .108 r
.44914 .60343 m .44932 .6074 L .42532 .59165 L p F P
0 0 0 r
s
1 .329 .137 r
.55086 .60343 m .55068 .6074 L .57468 .59165 L p F P
0 0 0 r
s
1 .318 .134 r
.55105 .59943 m .55124 .59541 L .52567 .61425 L p F P
0 0 0 r
s
.898 .269 .117 r
.44895 .59943 m .44876 .59541 L .47433 .61425 L p F P
0 0 0 r
s
.286 .423 .829 r
.47433 .61425 m .478 .61425 L .45608 .59541 L p F P
0 0 0 r
s
.286 .423 .829 r
.45608 .59541 m .44876 .59541 L .47433 .61425 L p F P
0 0 0 r
s
.24 .35 .67 r
.45314 .59437 m
.45317 .59541 L
s
.45338 .60331 m
.4538 .61852 L
s
.286 .423 .829 r
.478 .61425 m .48166 .61425 L .4634 .59541 L p F P
0 0 0 r
s
.286 .423 .829 r
.4634 .59541 m .45608 .59541 L .478 .61425 L p F P
0 0 0 r
s
.286 .423 .829 r
.48166 .61425 m .48533 .61425 L .47072 .59541 L p F P
0 0 0 r
s
.286 .423 .829 r
.47072 .59541 m .4634 .59541 L .48166 .61425 L p F P
0 0 0 r
s
.286 .423 .829 r
.48533 .61425 m .489 .61425 L .47804 .59541 L p F P
0 0 0 r
s
.286 .423 .829 r
.47804 .59541 m .47072 .59541 L .48533 .61425 L p F P
0 0 0 r
s
.286 .423 .829 r
.489 .61425 m .49267 .61425 L .48536 .59541 L p F P
0 0 0 r
s
.286 .423 .829 r
.48536 .59541 m .47804 .59541 L .489 .61425 L p F P
0 0 0 r
s
.83 .24 .1 r
.48284 .60245 m
.48297 .61029 L
s
.48297 .61029 m
.483 .61267 L
s
.286 .423 .829 r
.49267 .61425 m .49633 .61425 L .49268 .59541 L p F P
0 0 0 r
s
.286 .423 .829 r
.49268 .59541 m .48536 .59541 L .49267 .61425 L p F P
0 0 0 r
s
.286 .423 .829 r
.49633 .61425 m .5 .61425 L .5 .59541 L p F P
0 0 0 r
s
.286 .423 .829 r
.5 .59541 m .49268 .59541 L .49633 .61425 L p F P
0 0 0 r
s
.286 .423 .829 r
.5 .61425 m .50367 .61425 L .50732 .59541 L p F P
0 0 0 r
s
.286 .423 .829 r
.50732 .59541 m .5 .59541 L .5 .61425 L p F P
0 0 0 r
s
.24 .35 .67 r
.5 .59437 m
.5 .59541 L
s
.286 .423 .829 r
.50367 .61425 m .50733 .61425 L .51464 .59541 L p F P
0 0 0 r
s
.286 .423 .829 r
.51464 .59541 m .50732 .59541 L .50367 .61425 L p F P
0 0 0 r
s
.286 .423 .829 r
.50733 .61425 m .511 .61425 L .52196 .59541 L p F P
0 0 0 r
s
.286 .423 .829 r
.52196 .59541 m .51464 .59541 L .50733 .61425 L p F P
0 0 0 r
s
.286 .423 .829 r
.511 .61425 m .51467 .61425 L .52928 .59541 L p F P
0 0 0 r
s
.286 .423 .829 r
.52928 .59541 m .52196 .59541 L .511 .61425 L p F P
0 0 0 r
s
.286 .423 .829 r
.51467 .61425 m .51834 .61425 L .5366 .59541 L p F P
0 0 0 r
s
.286 .423 .829 r
.5366 .59541 m .52928 .59541 L .51467 .61425 L p F P
0 0 0 r
s
.83 .24 .1 r
.51703 .61029 m
.51716 .60245 L
s
.517 .61267 m
.51703 .61029 L
s
.286 .423 .829 r
.51834 .61425 m .522 .61425 L .54392 .59541 L p F P
0 0 0 r
s
.286 .423 .829 r
.54392 .59541 m .5366 .59541 L .51834 .61425 L p F P
0 0 0 r
s
.286 .423 .829 r
.522 .61425 m .52567 .61425 L .55124 .59541 L p F P
0 0 0 r
s
.286 .423 .829 r
.55124 .59541 m .54392 .59541 L .522 .61425 L p F P
0 0 0 r
s
.24 .35 .67 r
.5462 .61852 m
.54662 .60331 L
s
.54683 .59541 m
.54686 .59437 L
s
.43 .135 .065 r
.38263 .54359 m .38361 .55321 L .36718 .53166 L p F P
0 0 0 r
s
.43 .135 .065 r
.36718 .53166 m .3659 .52047 L .38263 .54359 L p F P
0 0 0 r
s
.83 .24 .1 r
.36743 .52087 m
.36766 .5229 L
s
1 .333 .134 r
.63282 .53166 m .6341 .52047 L .61737 .54359 L p F P
0 0 0 r
s
.83 .24 .1 r
.6311 .53392 m
.63121 .5329 L
s
.63234 .5229 m
.63257 .52087 L
s
1 .333 .134 r
.61737 .54359 m .61639 .55321 L .63282 .53166 L p F P
0 0 0 r
s
.236 .068 .036 r
.35125 .48413 m .35283 .49692 L .34376 .47365 L p F P
0 0 0 r
s
.236 .068 .036 r
.34376 .47365 m .34199 .45981 L .35125 .48413 L p F P
0 0 0 r
s
.973 .282 .11 r
.65624 .47365 m .65801 .45981 L .64875 .48413 L p F P
0 0 0 r
s
.973 .282 .11 r
.64875 .48413 m .64717 .49692 L .65624 .47365 L p F P
0 0 0 r
s
.814 .245 .108 r
.42532 .59165 m .42491 .58571 L .44914 .60343 L p F P
0 0 0 r
s
.712 .216 .097 r
.42491 .58571 m .42532 .59165 L .40319 .57341 L p F P
0 0 0 r
s
1 .336 .139 r
.57509 .58571 m .57468 .59165 L .59681 .57341 L p F P
0 0 0 r
s
1 .329 .137 r
.57468 .59165 m .57509 .58571 L .55086 .60343 L p F P
0 0 0 r
s
.814 .245 .108 r
.44895 .59943 m .44914 .60343 L .42491 .58571 L p F P
0 0 0 r
s
1 .329 .137 r
.55105 .59943 m .55086 .60343 L .57509 .58571 L p F P
0 0 0 r
s
.583 .18 .083 r
.40251 .56557 m .40319 .57341 L .38361 .55321 L p F P
0 0 0 r
s
.583 .18 .083 r
.38361 .55321 m .38263 .54359 L .40251 .56557 L p F P
0 0 0 r
s
1 .338 .138 r
.61639 .55321 m .61737 .54359 L .59749 .56557 L p F P
0 0 0 r
s
1 .338 .138 r
.59749 .56557 m .59681 .57341 L .61639 .55321 L p F P
0 0 0 r
s
.712 .216 .097 r
.40319 .57341 m .40251 .56557 L .42491 .58571 L p F P
0 0 0 r
s
1 .336 .139 r
.59681 .57341 m .59749 .56557 L .57509 .58571 L p F P
0 0 0 r
s
.83 .24 .1 r
.44941 .20704 m
.48293 .20215 L
s
.48293 .20215 m
.48252 .16632 L
s
.48293 .20215 m
.51707 .20215 L
s
.51707 .20215 m
.51748 .16632 L
s
.51707 .20215 m
.55059 .20704 L
s
.157 .045 .023 r
.34017 .44565 m .34199 .45981 L .33703 .43684 L p F P
0 0 0 r
s
.157 .045 .023 r
.33703 .43684 m .3351 .42195 L .34017 .44565 L p F P
0 0 0 r
s
.83 .24 .1 r
.3397 .44298 m
.33986 .44419 L
s
.796 .229 .086 r
.66297 .43684 m .6649 .42195 L .65983 .44565 L p F P
0 0 0 r
s
.796 .229 .086 r
.65983 .44565 m .65801 .45981 L .66297 .43684 L p F P
0 0 0 r
s
.83 .24 .1 r
.66014 .44419 m
.6603 .44298 L
s
.32 .095 .05 r
.3646 .50907 m .3659 .52047 L .35283 .49692 L p F P
0 0 0 r
s
.83 .24 .1 r
.36563 .51812 m
.36743 .52087 L
s
.32 .095 .05 r
.35283 .49692 m .35125 .48413 L .3646 .50907 L p F P
0 0 0 r
s
1 .315 .125 r
.64717 .49692 m .64875 .48413 L .6354 .50907 L p F P
0 0 0 r
s
1 .315 .125 r
.6354 .50907 m .6341 .52047 L .64717 .49692 L p F P
0 0 0 r
s
.83 .24 .1 r
.63257 .52087 m
.63437 .51812 L
s
.65995 .36067 m
.66381 .3286 L
s
.65995 .36067 m
.66566 .38641 L
s
.33434 .38641 m
.34005 .36067 L
s
.34005 .36067 m
.33619 .3286 L
s
.34891 .30442 m
.36769 .28292 L
s
.36769 .28292 m
.3645 .24898 L
s
.63231 .28292 m
.6355 .24898 L
s
.63231 .28292 m
.65109 .30442 L
s
.814 .245 .108 r
.44876 .59541 m .44895 .59943 L .42451 .57971 L p F P
0 0 0 r
s
.83 .24 .1 r
.43293 .59029 m
.4417 .59358 L
s
.814 .245 .108 r
.42491 .58571 m .42451 .57971 L .44895 .59943 L p F P
0 0 0 r
s
1 .329 .137 r
.57509 .58571 m .57549 .57971 L .55105 .59943 L p F P
0 0 0 r
s
1 .329 .137 r
.55124 .59541 m .55105 .59943 L .57549 .57971 L p F P
0 0 0 r
s
.83 .24 .1 r
.51716 .60245 m
.53834 .59867 L
s
.46166 .59867 m
.48284 .60245 L
s
.24 .35 .67 r
.17259 .40178 m
.21936 .40178 L
s
.21936 .40178 m
.26614 .40178 L
s
.26614 .40178 m
.31291 .40178 L
s
.33464 .40178 m
.35968 .40178 L
s
.31291 .40178 m
.33453 .40178 L
s
.35968 .40178 m
.40645 .40178 L
s
.40645 .40178 m
.45323 .40178 L
s
.45323 .40178 m
.5 .40178 L
s
.5 .40178 m
.54677 .40178 L
s
.54677 .40178 m
.59355 .40178 L
s
.59355 .40178 m
.64032 .40178 L
s
.64032 .40178 m
.66536 .40178 L
s
.66547 .40178 m
.68709 .40178 L
s
.68709 .40178 m
.73386 .40178 L
s
.73386 .40178 m
.78064 .40178 L
s
.78064 .40178 m
.82741 .40178 L
s
.21623 .43038 m
.21936 .40178 L
s
.17259 .40178 m
.16893 .43038 L
s
.26352 .43038 m
.26614 .40178 L
s
.31082 .43038 m
.31291 .40178 L
s
.68918 .43038 m
.68709 .40178 L
s
.73648 .43038 m
.73386 .40178 L
s
.78377 .43038 m
.78064 .40178 L
s
.83107 .43038 m
.82741 .40178 L
s
.83 .24 .1 r
.41771 .21669 m
.44941 .20704 L
s
.44941 .20704 m
.44819 .17123 L
s
.55059 .20704 m
.55181 .17123 L
s
.55059 .20704 m
.58229 .21669 L
s
.712 .216 .097 r
.42451 .57971 m .42491 .58571 L .40251 .56557 L p F P
0 0 0 r
s
1 .336 .139 r
.57549 .57971 m .57509 .58571 L .59749 .56557 L p F P
0 0 0 r
s
.211 .29 .565 r
.3351 .42195 m .35866 .42195 L .35815 .4007 L p F P
0 0 0 r
s
.83 .24 .1 r
.3382 .41679 m
.33833 .41898 L
s
.211 .29 .565 r
.35815 .4007 m .3345 .4007 L .3351 .42195 L p F P
0 0 0 r
s
.83 .24 .1 r
.33434 .38641 m
.33616 .4007 L
s
.3385 .42195 m
.3397 .44298 L
s
.211 .29 .565 r
.35866 .42195 m .38221 .42195 L .38179 .4007 L p F P
0 0 0 r
s
.211 .29 .565 r
.38179 .4007 m .35815 .4007 L .35866 .42195 L p F P
0 0 0 r
s
.211 .29 .565 r
.38221 .42195 m .40577 .42195 L .40543 .4007 L p F P
0 0 0 r
s
.211 .29 .565 r
.40543 .4007 m .38179 .4007 L .38221 .42195 L p F P
0 0 0 r
s
.211 .29 .565 r
.40577 .42195 m .42933 .42195 L .42907 .4007 L p F P
0 0 0 r
s
.211 .29 .565 r
.42907 .4007 m .40543 .4007 L .40577 .42195 L p F P
0 0 0 r
s
.211 .29 .565 r
.42933 .42195 m .45289 .42195 L .45272 .4007 L p F P
0 0 0 r
s
.211 .29 .565 r
.45272 .4007 m .42907 .4007 L .42933 .42195 L p F P
0 0 0 r
s
.211 .29 .565 r
.45289 .42195 m .47644 .42195 L .47636 .4007 L p F P
0 0 0 r
s
.211 .29 .565 r
.47636 .4007 m .45272 .4007 L .45289 .42195 L p F P
0 0 0 r
s
.211 .29 .565 r
.47644 .42195 m .5 .42195 L .5 .4007 L p F P
0 0 0 r
s
.211 .29 .565 r
.5 .4007 m .47636 .4007 L .47644 .42195 L p F P
0 0 0 r
s
.211 .29 .565 r
.5 .42195 m .52356 .42195 L .52364 .4007 L p F P
0 0 0 r
s
.211 .29 .565 r
.52364 .4007 m .5 .4007 L .5 .42195 L p F P
0 0 0 r
s
.211 .29 .565 r
.52356 .42195 m .54711 .42195 L .54728 .4007 L p F P
0 0 0 r
s
.211 .29 .565 r
.54728 .4007 m .52364 .4007 L .52356 .42195 L p F P
0 0 0 r
s
.211 .29 .565 r
.54711 .42195 m .57067 .42195 L .57093 .4007 L p F P
0 0 0 r
s
.211 .29 .565 r
.57093 .4007 m .54728 .4007 L .54711 .42195 L p F P
0 0 0 r
s
.211 .29 .565 r
.57067 .42195 m .59423 .42195 L .59457 .4007 L p F P
0 0 0 r
s
.211 .29 .565 r
.59457 .4007 m .57093 .4007 L .57067 .42195 L p F P
0 0 0 r
s
.211 .29 .565 r
.59423 .42195 m .61779 .42195 L .61821 .4007 L p F P
0 0 0 r
s
.211 .29 .565 r
.61821 .4007 m .59457 .4007 L .59423 .42195 L p F P
0 0 0 r
s
.211 .29 .565 r
.61779 .42195 m .64134 .42195 L .64185 .4007 L p F P
0 0 0 r
s
.24 .35 .67 r
.64032 .40178 m
.64033 .40205 L
s
.211 .29 .565 r
.64185 .4007 m .61821 .4007 L .61779 .42195 L p F P
0 0 0 r
s
.211 .29 .565 r
.64134 .42195 m .6649 .42195 L .6655 .4007 L p F P
0 0 0 r
s
.211 .29 .565 r
.6655 .4007 m .64185 .4007 L .64134 .42195 L p F P
0 0 0 r
s
.83 .24 .1 r
.66384 .4007 m
.66566 .38641 L
s
.6603 .44298 m
.6615 .42195 L
s
.24 .35 .67 r
.21885 .59437 m
.17199 .59437 L
s
.26571 .59437 m
.21885 .59437 L
s
.31256 .59437 m
.26571 .59437 L
s
.35942 .59437 m
.31256 .59437 L
s
.40628 .59437 m
.35942 .59437 L
s
.40628 .59437 m
.445 .59437 L
s
.44717 .59437 m
.45314 .59437 L
s
.5 .59437 m
.45314 .59437 L
s
.54686 .59437 m
.5 .59437 L
s
.555 .59437 m
.59372 .59437 L
s
.54686 .59437 m
.55283 .59437 L
s
.64058 .59437 m
.59372 .59437 L
s
.68744 .59437 m
.64058 .59437 L
s
.73429 .59437 m
.68744 .59437 L
s
.78115 .59437 m
.73429 .59437 L
s
.82801 .59437 m
.78115 .59437 L
s
.21885 .59437 m
.21586 .56511 L
s
.1685 .56511 m
.17199 .59437 L
s
.26571 .59437 m
.26322 .56511 L
s
.31256 .59437 m
.31057 .56511 L
s
.35942 .59437 m
.35793 .56511 L
s
.64058 .59437 m
.64207 .56511 L
s
.68744 .59437 m
.68943 .56511 L
s
.73429 .59437 m
.73678 .56511 L
s
.78115 .59437 m
.78414 .56511 L
s
.82801 .59437 m
.8315 .56511 L
s
.43 .135 .065 r
.38163 .53382 m .38263 .54359 L .3659 .52047 L p F P
0 0 0 r
s
.43 .135 .065 r
.3659 .52047 m .3646 .50907 L .38163 .53382 L p F P
0 0 0 r
s
1 .333 .134 r
.6341 .52047 m .6354 .50907 L .61837 .53382 L p F P
0 0 0 r
s
1 .333 .134 r
.61837 .53382 m .61737 .54359 L .6341 .52047 L p F P
0 0 0 r
s
.83 .24 .1 r
.48284 .60245 m
.51716 .60245 L
s
1 .329 .137 r
.57549 .57971 m .57591 .57364 L .55124 .59541 L p F P
0 0 0 r
s
.814 .245 .108 r
.42451 .57971 m .42409 .57364 L .44876 .59541 L p F P
0 0 0 r
s
.281 .411 .806 r
.44876 .59541 m .45608 .59541 L .43494 .57364 L p F P
0 0 0 r
s
.281 .411 .806 r
.43494 .57364 m .42409 .57364 L .44876 .59541 L p F P
0 0 0 r
s
.281 .411 .806 r
.45608 .59541 m .4634 .59541 L .44578 .57364 L p F P
0 0 0 r
s
.281 .411 .806 r
.44578 .57364 m .43494 .57364 L .45608 .59541 L p F P
0 0 0 r
s
.281 .411 .806 r
.4634 .59541 m .47072 .59541 L .45662 .57364 L p F P
0 0 0 r
s
.281 .411 .806 r
.45662 .57364 m .44578 .57364 L .4634 .59541 L p F P
0 0 0 r
s
.83 .24 .1 r
.44914 .59045 m
.44921 .59199 L
s
.281 .411 .806 r
.47072 .59541 m .47804 .59541 L .46747 .57364 L p F P
0 0 0 r
s
.281 .411 .806 r
.46747 .57364 m .45662 .57364 L .47072 .59541 L p F P
0 0 0 r
s
.281 .411 .806 r
.47804 .59541 m .48536 .59541 L .47831 .57364 L p F P
0 0 0 r
s
.281 .411 .806 r
.47831 .57364 m .46747 .57364 L .47804 .59541 L p F P
0 0 0 r
s
.281 .411 .806 r
.48536 .59541 m .49268 .59541 L .48916 .57364 L p F P
0 0 0 r
s
.281 .411 .806 r
.48916 .57364 m .47831 .57364 L .48536 .59541 L p F P
0 0 0 r
s
.83 .24 .1 r
.48243 .57611 m
.48284 .60245 L
s
.281 .411 .806 r
.49268 .59541 m .5 .59541 L .5 .57364 L p F P
0 0 0 r
s
.281 .411 .806 r
.5 .57364 m .48916 .57364 L .49268 .59541 L p F P
0 0 0 r
s
.281 .411 .806 r
.5 .59541 m .50732 .59541 L .51084 .57364 L p F P
0 0 0 r
s
.281 .411 .806 r
.51084 .57364 m .5 .57364 L .5 .59541 L p F P
0 0 0 r
s
.281 .411 .806 r
.50732 .59541 m .51464 .59541 L .52169 .57364 L p F P
0 0 0 r
s
.281 .411 .806 r
.52169 .57364 m .51084 .57364 L .50732 .59541 L p F P
0 0 0 r
s
.281 .411 .806 r
.51464 .59541 m .52196 .59541 L .53253 .57364 L p F P
0 0 0 r
s
.281 .411 .806 r
.53253 .57364 m .52169 .57364 L .51464 .59541 L p F P
0 0 0 r
s
.83 .24 .1 r
.51716 .60245 m
.51757 .57611 L
s
.281 .411 .806 r
.52196 .59541 m .52928 .59541 L .54338 .57364 L p F P
0 0 0 r
s
.281 .411 .806 r
.54338 .57364 m .53253 .57364 L .52196 .59541 L p F P
0 0 0 r
s
.281 .411 .806 r
.52928 .59541 m .5366 .59541 L .55422 .57364 L p F P
0 0 0 r
s
.281 .411 .806 r
.55422 .57364 m .54338 .57364 L .52928 .59541 L p F P
0 0 0 r
s
.281 .411 .806 r
.5366 .59541 m .54392 .59541 L .56506 .57364 L p F P
0 0 0 r
s
.24 .35 .67 r
.54686 .59437 m
.54689 .59234 L
s
.281 .411 .806 r
.56506 .57364 m .55422 .57364 L .5366 .59541 L p F P
0 0 0 r
s
.281 .411 .806 r
.54392 .59541 m .55124 .59541 L .57591 .57364 L p F P
0 0 0 r
s
.281 .411 .806 r
.57591 .57364 m .56506 .57364 L .54392 .59541 L p F P
0 0 0 r
s
.83 .24 .1 r
.55079 .59199 m
.55086 .59045 L
s
.712 .216 .097 r
.40251 .56557 m .40182 .55761 L .42451 .57971 L p F P
0 0 0 r
s
.583 .18 .083 r
.40182 .55761 m .40251 .56557 L .38263 .54359 L p F P
0 0 0 r
s
1 .338 .138 r
.59818 .55761 m .59749 .56557 L .61737 .54359 L p F P
0 0 0 r
s
1 .336 .139 r
.59749 .56557 m .59818 .55761 L .57549 .57971 L p F P
0 0 0 r
s
.583 .18 .083 r
.38263 .54359 m .38163 .53382 L .40182 .55761 L p F P
0 0 0 r
s
1 .338 .138 r
.61737 .54359 m .61837 .53382 L .59818 .55761 L p F P
0 0 0 r
s
.236 .068 .036 r
.34964 .47107 m .35125 .48413 L .34199 .45981 L p F P
0 0 0 r
s
.236 .068 .036 r
.34199 .45981 m .34017 .44565 L .34964 .47107 L p F P
0 0 0 r
s
.83 .24 .1 r
.3397 .44298 m
.34513 .45898 L
s
.973 .282 .11 r
.65801 .45981 m .65983 .44565 L .65036 .47107 L p F P
0 0 0 r
s
.83 .24 .1 r
.65487 .45898 m
.6603 .44298 L
s
.973 .282 .11 r
.65036 .47107 m .64875 .48413 L .65801 .45981 L p F P
0 0 0 r
s
.83 .24 .1 r
.38902 .23081 m
.41771 .21669 L
s
.41771 .21669 m
.41571 .18091 L
s
.58229 .21669 m
.58429 .18091 L
s
.58229 .21669 m
.61098 .23081 L
s
.712 .216 .097 r
.42409 .57364 m .42451 .57971 L .40182 .55761 L p F P
0 0 0 r
s
1 .336 .139 r
.57591 .57364 m .57549 .57971 L .59818 .55761 L p F P
0 0 0 r
s
.32 .095 .05 r
.36326 .49743 m .3646 .50907 L .35125 .48413 L p F P
0 0 0 r
s
.32 .095 .05 r
.35125 .48413 m .34964 .47107 L .36326 .49743 L p F P
0 0 0 r
s
1 .315 .125 r
.64875 .48413 m .65036 .47107 L .63674 .49743 L p F P
0 0 0 r
s
1 .315 .125 r
.63674 .49743 m .6354 .50907 L .64875 .48413 L p F P
0 0 0 r
s
.227 .315 .616 r
.34017 .44565 m .363 .44565 L .35866 .42195 L p F P
0 0 0 r
s
.24 .35 .67 r
.35857 .42206 m
.35858 .42195 L
s
.227 .315 .616 r
.35866 .42195 m .3351 .42195 L .34017 .44565 L p F P
0 0 0 r
s
.83 .24 .1 r
.33787 .42874 m
.33798 .42959 L
s
.33583 .41283 m
.33787 .42874 L
s
.227 .315 .616 r
.363 .44565 m .38583 .44565 L .38221 .42195 L p F P
0 0 0 r
s
.227 .315 .616 r
.38221 .42195 m .35866 .42195 L .363 .44565 L p F P
0 0 0 r
s
.227 .315 .616 r
.38583 .44565 m .40867 .44565 L .40577 .42195 L p F P
0 0 0 r
s
.24 .35 .67 r
.40571 .42202 m
.40572 .42195 L
s
.227 .315 .616 r
.40577 .42195 m .38221 .42195 L .38583 .44565 L p F P
0 0 0 r
s
.227 .315 .616 r
.40867 .44565 m .4315 .44565 L .42933 .42195 L p F P
0 0 0 r
s
.227 .315 .616 r
.42933 .42195 m .40577 .42195 L .40867 .44565 L p F P
0 0 0 r
s
.227 .315 .616 r
.4315 .44565 m .45433 .44565 L .45289 .42195 L p F P
0 0 0 r
s
.24 .35 .67 r
.45286 .42198 m
.45286 .42195 L
s
.227 .315 .616 r
.45289 .42195 m .42933 .42195 L .4315 .44565 L p F P
0 0 0 r
s
.227 .315 .616 r
.45433 .44565 m .47717 .44565 L .47644 .42195 L p F P
0 0 0 r
s
.227 .315 .616 r
.47644 .42195 m .45289 .42195 L .45433 .44565 L p F P
0 0 0 r
s
.227 .315 .616 r
.47717 .44565 m .5 .44565 L .5 .42195 L p F P
0 0 0 r
s
.227 .315 .616 r
.5 .42195 m .47644 .42195 L .47717 .44565 L p F P
0 0 0 r
s
.227 .315 .616 r
.5 .44565 m .52283 .44565 L .52356 .42195 L p F P
0 0 0 r
s
.227 .315 .616 r
.52356 .42195 m .5 .42195 L .5 .44565 L p F P
0 0 0 r
s
.227 .315 .616 r
.52283 .44565 m .54567 .44565 L .54711 .42195 L p F P
0 0 0 r
s
.227 .315 .616 r
.54711 .42195 m .52356 .42195 L .52283 .44565 L p F P
0 0 0 r
s
.227 .315 .616 r
.54567 .44565 m .5685 .44565 L .57067 .42195 L p F P
0 0 0 r
s
.227 .315 .616 r
.57067 .42195 m .54711 .42195 L .54567 .44565 L p F P
0 0 0 r
s
.227 .315 .616 r
.5685 .44565 m .59133 .44565 L .59423 .42195 L p F P
0 0 0 r
s
.227 .315 .616 r
.59423 .42195 m .57067 .42195 L .5685 .44565 L p F P
0 0 0 r
s
.227 .315 .616 r
.59133 .44565 m .61417 .44565 L .61779 .42195 L p F P
0 0 0 r
s
.227 .315 .616 r
.61779 .42195 m .59423 .42195 L .59133 .44565 L p F P
0 0 0 r
s
.227 .315 .616 r
.61417 .44565 m .637 .44565 L .64134 .42195 L p F P
0 0 0 r
s
.227 .315 .616 r
.64134 .42195 m .61779 .42195 L .61417 .44565 L p F P
0 0 0 r
s
.227 .315 .616 r
.637 .44565 m .65983 .44565 L .6649 .42195 L p F P
0 0 0 r
s
.227 .315 .616 r
.6649 .42195 m .64134 .42195 L .637 .44565 L p F P
0 0 0 r
s
.83 .24 .1 r
.66213 .42874 m
.66417 .41283 L
s
.66202 .42959 m
.66213 .42874 L
s
.712 .216 .097 r
.40182 .55761 m .40112 .54955 L .42409 .57364 L p F P
0 0 0 r
s
.583 .18 .083 r
.40112 .54955 m .40182 .55761 L .38163 .53382 L p F P
0 0 0 r
s
1 .338 .138 r
.59888 .54955 m .59818 .55761 L .61837 .53382 L p F P
0 0 0 r
s
1 .336 .139 r
.59818 .55761 m .59888 .54955 L .57591 .57364 L p F P
0 0 0 r
s
.83 .24 .1 r
.33619 .3286 m
.34891 .30442 L
s
.34891 .30442 m
.34522 .27061 L
s
.65109 .30442 m
.65478 .27061 L
s
.65109 .30442 m
.66381 .3286 L
s
.274 .398 .781 r
.42409 .57364 m .43494 .57364 L .41525 .54955 L p F P
0 0 0 r
s
.274 .398 .781 r
.41525 .54955 m .40112 .54955 L .42409 .57364 L p F P
0 0 0 r
s
.24 .35 .67 r
.40529 .56511 m
.40628 .59437 L
s
.274 .398 .781 r
.43494 .57364 m .44578 .57364 L .42937 .54955 L p F P
0 0 0 r
s
.274 .398 .781 r
.42937 .54955 m .41525 .54955 L .43494 .57364 L p F P
0 0 0 r
s
.83 .24 .1 r
.40876 .55354 m
.41663 .55835 L
s
.41663 .55835 m
.41703 .56379 L
s
.274 .398 .781 r
.44578 .57364 m .45662 .57364 L .4435 .54955 L p F P
0 0 0 r
s
.83 .24 .1 r
.44904 .58834 m
.44914 .59045 L
s
.274 .398 .781 r
.4435 .54955 m .42937 .54955 L .44578 .57364 L p F P
0 0 0 r
s
.274 .398 .781 r
.45662 .57364 m .46747 .57364 L .45762 .54955 L p F P
0 0 0 r
s
.274 .398 .781 r
.45762 .54955 m .4435 .54955 L .45662 .57364 L p F P
0 0 0 r
s
.83 .24 .1 r
.4482 .57007 m
.44904 .58834 L
s
.274 .398 .781 r
.46747 .57364 m .47831 .57364 L .47175 .54955 L p F P
0 0 0 r
s
.274 .398 .781 r
.47175 .54955 m .45762 .54955 L .46747 .57364 L p F P
0 0 0 r
s
.274 .398 .781 r
.47831 .57364 m .48916 .57364 L .48587 .54955 L p F P
0 0 0 r
s
.274 .398 .781 r
.48587 .54955 m .47175 .54955 L .47831 .57364 L p F P
0 0 0 r
s
.274 .398 .781 r
.48916 .57364 m .5 .57364 L .5 .54955 L p F P
0 0 0 r
s
.274 .398 .781 r
.5 .54955 m .48587 .54955 L .48916 .57364 L p F P
0 0 0 r
s
.274 .398 .781 r
.5 .57364 m .51084 .57364 L .51413 .54955 L p F P
0 0 0 r
s
.274 .398 .781 r
.51413 .54955 m .5 .54955 L .5 .57364 L p F P
0 0 0 r
s
.274 .398 .781 r
.51084 .57364 m .52169 .57364 L .52825 .54955 L p F P
0 0 0 r
s
.274 .398 .781 r
.52825 .54955 m .51413 .54955 L .51084 .57364 L p F P
0 0 0 r
s
.274 .398 .781 r
.52169 .57364 m .53253 .57364 L .54238 .54955 L p F P
0 0 0 r
s
.274 .398 .781 r
.54238 .54955 m .52825 .54955 L .52169 .57364 L p F P
0 0 0 r
s
.274 .398 .781 r
.53253 .57364 m .54338 .57364 L .5565 .54955 L p F P
0 0 0 r
s
.83 .24 .1 r
.55086 .59045 m
.55096 .58834 L
s
.274 .398 .781 r
.5565 .54955 m .54238 .54955 L .53253 .57364 L p F P
0 0 0 r
s
.274 .398 .781 r
.54338 .57364 m .55422 .57364 L .57063 .54955 L p F P
0 0 0 r
s
.274 .398 .781 r
.57063 .54955 m .5565 .54955 L .54338 .57364 L p F P
0 0 0 r
s
.83 .24 .1 r
.55096 .58834 m
.5518 .57007 L
s
.274 .398 .781 r
.55422 .57364 m .56506 .57364 L .58475 .54955 L p F P
0 0 0 r
s
.274 .398 .781 r
.58475 .54955 m .57063 .54955 L .55422 .57364 L p F P
0 0 0 r
s
.274 .398 .781 r
.56506 .57364 m .57591 .57364 L .59888 .54955 L p F P
0 0 0 r
s
.274 .398 .781 r
.59888 .54955 m .58475 .54955 L .56506 .57364 L p F P
0 0 0 r
s
.24 .35 .67 r
.59372 .59437 m
.59471 .56511 L
s
.83 .24 .1 r
.58297 .56379 m
.58337 .55835 L
s
.58337 .55835 m
.59124 .55354 L
s
.24 .35 .67 r
.21421 .46287 m
.21623 .43038 L
s
.16893 .43038 m
.16658 .46287 L
s
.21623 .43038 m
.16893 .43038 L
s
.26184 .46287 m
.26352 .43038 L
s
.26352 .43038 m
.21623 .43038 L
s
.30947 .46287 m
.31082 .43038 L
s
.31082 .43038 m
.26352 .43038 L
s
.31082 .43038 m
.33683 .43038 L
s
.69053 .46287 m
.68918 .43038 L
s
.66317 .43038 m
.68918 .43038 L
s
.73816 .46287 m
.73648 .43038 L
s
.73648 .43038 m
.68918 .43038 L
s
.78579 .46287 m
.78377 .43038 L
s
.78377 .43038 m
.73648 .43038 L
s
.83342 .46287 m
.83107 .43038 L
s
.83107 .43038 m
.78377 .43038 L
s
.83 .24 .1 r
.3303 .35454 m
.33434 .38641 L
s
.33583 .41283 m
.33434 .38641 L
s
.66566 .38641 m
.6697 .35454 L
s
.66566 .38641 m
.66417 .41283 L
s
.43 .135 .065 r
.38061 .52388 m .38163 .53382 L .3646 .50907 L p F P
0 0 0 r
s
.43 .135 .065 r
.3646 .50907 m .36326 .49743 L .38061 .52388 L p F P
0 0 0 r
s
1 .333 .134 r
.6354 .50907 m .63674 .49743 L .61939 .52388 L p F P
0 0 0 r
s
.83 .24 .1 r
.63362 .51166 m
.63374 .51061 L
s
1 .333 .134 r
.61939 .52388 m .61837 .53382 L .6354 .50907 L p F P
0 0 0 r
s
.583 .18 .083 r
.38163 .53382 m .38061 .52388 L .40112 .54955 L p F P
0 0 0 r
s
.83 .24 .1 r
.40007 .54823 m
.40222 .54955 L
s
1 .338 .138 r
.61837 .53382 m .61939 .52388 L .59888 .54955 L p F P
0 0 0 r
s
.83 .24 .1 r
.59778 .54955 m
.59993 .54823 L
s
.24 .35 .67 r
.21586 .56511 m
.1685 .56511 L
s
.26322 .56511 m
.21586 .56511 L
s
.31057 .56511 m
.26322 .56511 L
s
.35793 .56511 m
.31057 .56511 L
s
.35793 .56511 m
.40529 .56511 L
s
.40529 .56511 m
.4148 .56511 L
s
.5852 .56511 m
.59471 .56511 L
s
.59471 .56511 m
.64207 .56511 L
s
.68943 .56511 m
.64207 .56511 L
s
.73678 .56511 m
.68943 .56511 L
s
.78414 .56511 m
.73678 .56511 L
s
.8315 .56511 m
.78414 .56511 L
s
.21586 .56511 m
.21402 .5322 L
s
.16636 .5322 m
.1685 .56511 L
s
.26322 .56511 m
.26169 .5322 L
s
.31057 .56511 m
.30935 .5322 L
s
.35793 .56511 m
.35701 .5322 L
s
.40511 .55573 m
.40529 .56511 L
s
.59471 .56511 m
.59489 .55573 L
s
.64207 .56511 m
.64299 .5322 L
s
.68943 .56511 m
.69065 .5322 L
s
.73678 .56511 m
.73831 .5322 L
s
.78414 .56511 m
.78598 .5322 L
s
.8315 .56511 m
.83364 .5322 L
s
.83 .24 .1 r
.3645 .24898 m
.38902 .23081 L
s
.38902 .23081 m
.38631 .1951 L
s
.61098 .23081 m
.61369 .1951 L
s
.61098 .23081 m
.6355 .24898 L
s
.239 .337 .658 r
.34964 .47107 m .37112 .47107 L .363 .44565 L p F P
0 0 0 r
s
.83 .24 .1 r
.34915 .46977 m
.34981 .47076 L
s
.239 .337 .658 r
.363 .44565 m .34017 .44565 L .34964 .47107 L p F P
0 0 0 r
s
.83 .24 .1 r
.34739 .46034 m
.3476 .46205 L
s
.34471 .43875 m
.34739 .46034 L
s
.239 .337 .658 r
.37112 .47107 m .3926 .47107 L .38583 .44565 L p F P
0 0 0 r
s
.239 .337 .658 r
.38583 .44565 m .363 .44565 L .37112 .47107 L p F P
0 0 0 r
s
.239 .337 .658 r
.3926 .47107 m .41408 .47107 L .40867 .44565 L p F P
0 0 0 r
s
.24 .35 .67 r
.40497 .45149 m
.40509 .44565 L
s
.239 .337 .658 r
.40867 .44565 m .38583 .44565 L .3926 .47107 L p F P
0 0 0 r
s
.239 .337 .658 r
.41408 .47107 m .43556 .47107 L .4315 .44565 L p F P
0 0 0 r
s
.239 .337 .658 r
.4315 .44565 m .40867 .44565 L .41408 .47107 L p F P
0 0 0 r
s
.239 .337 .658 r
.43556 .47107 m .45704 .47107 L .45433 .44565 L p F P
0 0 0 r
s
.24 .35 .67 r
.45252 .4481 m
.45255 .44565 L
s
.239 .337 .658 r
.45433 .44565 m .4315 .44565 L .43556 .47107 L p F P
0 0 0 r
s
.239 .337 .658 r
.45704 .47107 m .47852 .47107 L .47717 .44565 L p F P
0 0 0 r
s
.239 .337 .658 r
.47717 .44565 m .45433 .44565 L .45704 .47107 L p F P
0 0 0 r
s
.239 .337 .658 r
.47852 .47107 m .5 .47107 L .5 .44565 L p F P
0 0 0 r
s
.239 .337 .658 r
.5 .44565 m .47717 .44565 L .47852 .47107 L p F P
0 0 0 r
s
.239 .337 .658 r
.5 .47107 m .52148 .47107 L .52283 .44565 L p F P
0 0 0 r
s
.239 .337 .658 r
.52283 .44565 m .5 .44565 L .5 .47107 L p F P
0 0 0 r
s
.239 .337 .658 r
.52148 .47107 m .54296 .47107 L .54567 .44565 L p F P
0 0 0 r
s
.239 .337 .658 r
.54567 .44565 m .52283 .44565 L .52148 .47107 L p F P
0 0 0 r
s
.239 .337 .658 r
.54296 .47107 m .56444 .47107 L .5685 .44565 L p F P
0 0 0 r
s
.239 .337 .658 r
.5685 .44565 m .54567 .44565 L .54296 .47107 L p F P
0 0 0 r
s
.239 .337 .658 r
.56444 .47107 m .58592 .47107 L .59133 .44565 L p F P
0 0 0 r
s
.239 .337 .658 r
.59133 .44565 m .5685 .44565 L .56444 .47107 L p F P
0 0 0 r
s
.239 .337 .658 r
.58592 .47107 m .6074 .47107 L .61417 .44565 L p F P
0 0 0 r
s
.239 .337 .658 r
.61417 .44565 m .59133 .44565 L .58592 .47107 L p F P
0 0 0 r
s
.239 .337 .658 r
.6074 .47107 m .62888 .47107 L .637 .44565 L p F P
0 0 0 r
s
.239 .337 .658 r
.637 .44565 m .61417 .44565 L .6074 .47107 L p F P
0 0 0 r
s
.239 .337 .658 r
.62888 .47107 m .65036 .47107 L .65983 .44565 L p F P
0 0 0 r
s
.239 .337 .658 r
.65983 .44565 m .637 .44565 L .62888 .47107 L p F P
0 0 0 r
s
.83 .24 .1 r
.65261 .46034 m
.65529 .43875 L
s
.6524 .46205 m
.65261 .46034 L
s
.267 .385 .754 r
.40112 .54955 m .41525 .54955 L .39767 .52388 L p F P
0 0 0 r
s
.267 .385 .754 r
.39767 .52388 m .38061 .52388 L .40112 .54955 L p F P
0 0 0 r
s
.267 .385 .754 r
.41525 .54955 m .42937 .54955 L .41472 .52388 L p F P
0 0 0 r
s
.267 .385 .754 r
.41472 .52388 m .39767 .52388 L .41525 .54955 L p F P
0 0 0 r
s
.267 .385 .754 r
.42937 .54955 m .4435 .54955 L .43178 .52388 L p F P
0 0 0 r
s
.267 .385 .754 r
.43178 .52388 m .41472 .52388 L .42937 .54955 L p F P
0 0 0 r
s
.267 .385 .754 r
.4435 .54955 m .45762 .54955 L .44883 .52388 L p F P
0 0 0 r
s
.267 .385 .754 r
.44883 .52388 m .43178 .52388 L .4435 .54955 L p F P
0 0 0 r
s
.267 .385 .754 r
.45762 .54955 m .47175 .54955 L .46589 .52388 L p F P
0 0 0 r
s
.267 .385 .754 r
.46589 .52388 m .44883 .52388 L .45762 .54955 L p F P
0 0 0 r
s
.267 .385 .754 r
.47175 .54955 m .48587 .54955 L .48294 .52388 L p F P
0 0 0 r
s
.267 .385 .754 r
.48294 .52388 m .46589 .52388 L .47175 .54955 L p F P
0 0 0 r
s
.267 .385 .754 r
.48587 .54955 m .5 .54955 L .5 .52388 L p F P
0 0 0 r
s
.267 .385 .754 r
.5 .52388 m .48294 .52388 L .48587 .54955 L p F P
0 0 0 r
s
.267 .385 .754 r
.5 .54955 m .51413 .54955 L .51706 .52388 L p F P
0 0 0 r
s
.267 .385 .754 r
.51706 .52388 m .5 .52388 L .5 .54955 L p F P
0 0 0 r
s
.267 .385 .754 r
.51413 .54955 m .52825 .54955 L .53411 .52388 L p F P
0 0 0 r
s
.267 .385 .754 r
.53411 .52388 m .51706 .52388 L .51413 .54955 L p F P
0 0 0 r
s
.267 .385 .754 r
.52825 .54955 m .54238 .54955 L .55117 .52388 L p F P
0 0 0 r
s
.267 .385 .754 r
.55117 .52388 m .53411 .52388 L .52825 .54955 L p F P
0 0 0 r
s
.267 .385 .754 r
.54238 .54955 m .5565 .54955 L .56822 .52388 L p F P
0 0 0 r
s
.267 .385 .754 r
.56822 .52388 m .55117 .52388 L .54238 .54955 L p F P
0 0 0 r
s
.267 .385 .754 r
.5565 .54955 m .57063 .54955 L .58528 .52388 L p F P
0 0 0 r
s
.267 .385 .754 r
.58528 .52388 m .56822 .52388 L .5565 .54955 L p F P
0 0 0 r
s
.267 .385 .754 r
.57063 .54955 m .58475 .54955 L .60233 .52388 L p F P
0 0 0 r
s
.267 .385 .754 r
.60233 .52388 m .58528 .52388 L .57063 .54955 L p F P
0 0 0 r
s
.267 .385 .754 r
.58475 .54955 m .59888 .54955 L .61939 .52388 L p F P
0 0 0 r
s
.267 .385 .754 r
.61939 .52388 m .60233 .52388 L .58475 .54955 L p F P
0 0 0 r
s
.24 .35 .67 r
.21346 .49746 m
.21421 .46287 L
s
.16658 .46287 m
.1657 .49746 L
s
.21421 .46287 m
.16658 .46287 L
s
.26122 .49746 m
.26184 .46287 L
s
.26184 .46287 m
.21421 .46287 L
s
.30897 .49746 m
.30947 .46287 L
s
.30947 .46287 m
.26184 .46287 L
s
.35686 .48505 m
.35702 .47107 L
s
.30947 .46287 m
.34638 .46287 L
s
.64298 .47107 m
.64314 .48505 L
s
.69103 .49746 m
.69053 .46287 L
s
.65362 .46287 m
.69053 .46287 L
s
.73878 .49746 m
.73816 .46287 L
s
.73816 .46287 m
.69053 .46287 L
s
.78654 .49746 m
.78579 .46287 L
s
.78579 .46287 m
.73816 .46287 L
s
.8343 .49746 m
.83342 .46287 L
s
.83342 .46287 m
.78579 .46287 L
s
.83 .24 .1 r
.58337 .55835 m
.58542 .5305 L
s
.58337 .55835 m
.5518 .57007 L
s
.4482 .57007 m
.41663 .55835 L
s
.41458 .5305 m
.41663 .55835 L
s
.24 .35 .67 r
.21402 .5322 m
.16636 .5322 L
s
.26169 .5322 m
.21402 .5322 L
s
.30935 .5322 m
.26169 .5322 L
s
.35701 .5322 m
.30935 .5322 L
s
.35701 .5322 m
.38497 .5322 L
s
.38497 .5322 m
.38649 .5322 L
s
.61503 .5322 m
.64299 .5322 L
s
.61351 .5322 m
.61503 .5322 L
s
.69065 .5322 m
.64299 .5322 L
s
.73831 .5322 m
.69065 .5322 L
s
.78598 .5322 m
.73831 .5322 L
s
.83364 .5322 m
.78598 .5322 L
s
.21402 .5322 m
.21346 .49746 L
s
.1657 .49746 m
.16636 .5322 L
s
.26169 .5322 m
.26122 .49746 L
s
.30935 .5322 m
.30897 .49746 L
s
.35673 .49746 m
.35701 .5322 L
s
.40449 .49746 m
.40463 .52388 L
s
.45224 .49746 m
.45231 .52388 L
s
.5 .49746 m
.5 .52388 L
s
.54769 .52388 m
.54776 .49746 L
s
.59537 .52388 m
.59551 .49746 L
s
.64299 .5322 m
.64327 .49746 L
s
.69065 .5322 m
.69103 .49746 L
s
.73831 .5322 m
.73878 .49746 L
s
.78598 .5322 m
.78654 .49746 L
s
.83364 .5322 m
.8343 .49746 L
s
.25 .354 .694 r
.36326 .49743 m .3828 .49743 L .37112 .47107 L p F P
0 0 0 r
s
.25 .354 .694 r
.37112 .47107 m .34964 .47107 L .36326 .49743 L p F P
0 0 0 r
s
.83 .24 .1 r
.36422 .49261 m
.36464 .49627 L
s
.36196 .48917 m
.36422 .49261 L
s
.24 .35 .67 r
.35673 .49746 m
.35685 .48612 L
s
.83 .24 .1 r
.35901 .48471 m
.36196 .48917 L
s
.25 .354 .694 r
.3828 .49743 m .40233 .49743 L .3926 .47107 L p F P
0 0 0 r
s
.25 .354 .694 r
.3926 .47107 m .37112 .47107 L .3828 .49743 L p F P
0 0 0 r
s
.25 .354 .694 r
.40233 .49743 m .42186 .49743 L .41408 .47107 L p F P
0 0 0 r
s
.25 .354 .694 r
.41408 .47107 m .3926 .47107 L .40233 .49743 L p F P
0 0 0 r
s
.24 .35 .67 r
.40449 .49746 m
.40449 .49743 L
s
.25 .354 .694 r
.42186 .49743 m .4414 .49743 L .43556 .47107 L p F P
0 0 0 r
s
.25 .354 .694 r
.43556 .47107 m .41408 .47107 L .42186 .49743 L p F P
0 0 0 r
s
.25 .354 .694 r
.4414 .49743 m .46093 .49743 L .45704 .47107 L p F P
0 0 0 r
s
.24 .35 .67 r
.45231 .47905 m
.45234 .47107 L
s
.25 .354 .694 r
.45704 .47107 m .43556 .47107 L .4414 .49743 L p F P
0 0 0 r
s
.24 .35 .67 r
.45224 .49746 m
.45224 .49743 L
s
.25 .354 .694 r
.46093 .49743 m .48047 .49743 L .47852 .47107 L p F P
0 0 0 r
s
.25 .354 .694 r
.47852 .47107 m .45704 .47107 L .46093 .49743 L p F P
0 0 0 r
s
.25 .354 .694 r
.48047 .49743 m .5 .49743 L .5 .47107 L p F P
0 0 0 r
s
.25 .354 .694 r
.5 .47107 m .47852 .47107 L .48047 .49743 L p F P
0 0 0 r
s
.25 .354 .694 r
.5 .49743 m .51953 .49743 L .52148 .47107 L p F P
0 0 0 r
s
.25 .354 .694 r
.52148 .47107 m .5 .47107 L .5 .49743 L p F P
0 0 0 r
s
.24 .35 .67 r
.5 .49743 m
.5 .49746 L
s
.25 .354 .694 r
.51953 .49743 m .53907 .49743 L .54296 .47107 L p F P
0 0 0 r
s
.25 .354 .694 r
.54296 .47107 m .52148 .47107 L .51953 .49743 L p F P
0 0 0 r
s
.25 .354 .694 r
.53907 .49743 m .5586 .49743 L .56444 .47107 L p F P
0 0 0 r
s
.24 .35 .67 r
.54766 .47107 m
.54772 .48844 L
s
.25 .354 .694 r
.56444 .47107 m .54296 .47107 L .53907 .49743 L p F P
0 0 0 r
s
.24 .35 .67 r
.54776 .49743 m
.54776 .49746 L
s
.25 .354 .694 r
.5586 .49743 m .57814 .49743 L .58592 .47107 L p F P
0 0 0 r
s
.25 .354 .694 r
.58592 .47107 m .56444 .47107 L .5586 .49743 L p F P
0 0 0 r
s
.25 .354 .694 r
.57814 .49743 m .59767 .49743 L .6074 .47107 L p F P
0 0 0 r
s
.24 .35 .67 r
.59532 .47107 m
.5954 .48188 L
s
.25 .354 .694 r
.6074 .47107 m .58592 .47107 L .57814 .49743 L p F P
0 0 0 r
s
.24 .35 .67 r
.59551 .49743 m
.59551 .49746 L
s
.25 .354 .694 r
.59767 .49743 m .6172 .49743 L .62888 .47107 L p F P
0 0 0 r
s
.25 .354 .694 r
.62888 .47107 m .6074 .47107 L .59767 .49743 L p F P
0 0 0 r
s
.25 .354 .694 r
.6172 .49743 m .63674 .49743 L .65036 .47107 L p F P
0 0 0 r
s
.83 .24 .1 r
.64957 .4717 m
.64998 .47107 L
s
.25 .354 .694 r
.65036 .47107 m .62888 .47107 L .6172 .49743 L p F P
0 0 0 r
s
.83 .24 .1 r
.63536 .49627 m
.63578 .49261 L
s
.63578 .49261 m
.63804 .48917 L
s
.63804 .48917 m
.64099 .48471 L
s
.24 .35 .67 r
.64315 .48612 m
.64327 .49746 L
s
.21346 .49746 m
.1657 .49746 L
s
.26122 .49746 m
.21346 .49746 L
s
.30897 .49746 m
.26122 .49746 L
s
.30897 .49746 m
.35673 .49746 L
s
.35673 .49746 m
.3628 .49746 L
s
.36328 .49746 m
.40449 .49746 L
s
.45224 .49746 m
.40449 .49746 L
s
.5 .49746 m
.45224 .49746 L
s
.54776 .49746 m
.5 .49746 L
s
.59551 .49746 m
.54776 .49746 L
s
.6372 .49746 m
.64327 .49746 L
s
.59551 .49746 m
.63672 .49746 L
s
.64327 .49746 m
.69103 .49746 L
s
.73878 .49746 m
.69103 .49746 L
s
.78654 .49746 m
.73878 .49746 L
s
.8343 .49746 m
.78654 .49746 L
s
.259 .37 .725 r
.38061 .52388 m .39767 .52388 L .3828 .49743 L p F P
0 0 0 r
s
.83 .24 .1 r
.38818 .53021 m
.38827 .5311 L
s
.259 .37 .725 r
.3828 .49743 m .36326 .49743 L .38061 .52388 L p F P
0 0 0 r
s
.259 .37 .725 r
.39767 .52388 m .41472 .52388 L .40233 .49743 L p F P
0 0 0 r
s
.259 .37 .725 r
.40233 .49743 m .3828 .49743 L .39767 .52388 L p F P
0 0 0 r
s
.83 .24 .1 r
.38658 .5136 m
.38818 .53021 L
s
.259 .37 .725 r
.41472 .52388 m .43178 .52388 L .42186 .49743 L p F P
0 0 0 r
s
.259 .37 .725 r
.42186 .49743 m .40233 .49743 L .41472 .52388 L p F P
0 0 0 r
s
.259 .37 .725 r
.43178 .52388 m .44883 .52388 L .4414 .49743 L p F P
0 0 0 r
s
.259 .37 .725 r
.4414 .49743 m .42186 .49743 L .43178 .52388 L p F P
0 0 0 r
s
.259 .37 .725 r
.44883 .52388 m .46589 .52388 L .46093 .49743 L p F P
0 0 0 r
s
.259 .37 .725 r
.46093 .49743 m .4414 .49743 L .44883 .52388 L p F P
0 0 0 r
s
.259 .37 .725 r
.46589 .52388 m .48294 .52388 L .48047 .49743 L p F P
0 0 0 r
s
.259 .37 .725 r
.48047 .49743 m .46093 .49743 L .46589 .52388 L p F P
0 0 0 r
s
.259 .37 .725 r
.48294 .52388 m .5 .52388 L .5 .49743 L p F P
0 0 0 r
s
.259 .37 .725 r
.5 .49743 m .48047 .49743 L .48294 .52388 L p F P
0 0 0 r
s
.259 .37 .725 r
.5 .52388 m .51706 .52388 L .51953 .49743 L p F P
0 0 0 r
s
.259 .37 .725 r
.51953 .49743 m .5 .49743 L .5 .52388 L p F P
0 0 0 r
s
.259 .37 .725 r
.51706 .52388 m .53411 .52388 L .53907 .49743 L p F P
0 0 0 r
s
.259 .37 .725 r
.53907 .49743 m .51953 .49743 L .51706 .52388 L p F P
0 0 0 r
s
.259 .37 .725 r
.53411 .52388 m .55117 .52388 L .5586 .49743 L p F P
0 0 0 r
s
.259 .37 .725 r
.5586 .49743 m .53907 .49743 L .53411 .52388 L p F P
0 0 0 r
s
.259 .37 .725 r
.55117 .52388 m .56822 .52388 L .57814 .49743 L p F P
0 0 0 r
s
.259 .37 .725 r
.57814 .49743 m .5586 .49743 L .55117 .52388 L p F P
0 0 0 r
s
.259 .37 .725 r
.56822 .52388 m .58528 .52388 L .59767 .49743 L p F P
0 0 0 r
s
.259 .37 .725 r
.59767 .49743 m .57814 .49743 L .56822 .52388 L p F P
0 0 0 r
s
.259 .37 .725 r
.58528 .52388 m .60233 .52388 L .6172 .49743 L p F P
0 0 0 r
s
.83 .24 .1 r
.61173 .5311 m
.61182 .53021 L
s
.259 .37 .725 r
.6172 .49743 m .59767 .49743 L .58528 .52388 L p F P
0 0 0 r
s
.259 .37 .725 r
.60233 .52388 m .61939 .52388 L .63674 .49743 L p F P
0 0 0 r
s
.259 .37 .725 r
.63674 .49743 m .6172 .49743 L .60233 .52388 L p F P
0 0 0 r
s
.83 .24 .1 r
.61182 .53021 m
.61342 .5136 L
s
.48252 .16632 m
.44819 .17123 L
s
.51748 .16632 m
.48252 .16632 L
s
.55181 .17123 m
.51748 .16632 L
s
.66381 .3286 m
.66786 .29495 L
s
.66381 .3286 m
.6697 .35454 L
s
.3303 .35454 m
.33619 .3286 L
s
.33619 .3286 m
.33214 .29495 L
s
.34522 .27061 m
.3645 .24898 L
s
.3645 .24898 m
.36116 .21336 L
s
.6355 .24898 m
.63884 .21336 L
s
.6355 .24898 m
.65478 .27061 L
s
.5518 .57007 m
.55308 .54236 L
s
.5518 .57007 m
.51757 .57611 L
s
.48243 .57611 m
.4482 .57007 L
s
.4482 .57007 m
.44692 .54236 L
s
.44819 .17123 m
.41571 .18091 L
s
.58429 .18091 m
.55181 .17123 L
s
.38658 .5136 m
.36422 .49261 L
s
.36422 .49261 m
.36086 .46294 L
s
.63578 .49261 m
.63914 .46294 L
s
.63578 .49261 m
.61342 .5136 L
s
.34471 .43875 m
.33583 .41283 L
s
.33583 .41283 m
.33176 .38118 L
s
.66417 .41283 m
.66824 .38118 L
s
.66417 .41283 m
.65529 .43875 L
s
.51757 .57611 m
.51801 .54847 L
s
.51757 .57611 m
.48243 .57611 L
s
.48243 .57611 m
.48199 .54847 L
s
.41571 .18091 m
.38631 .1951 L
s
.61369 .1951 m
.58429 .18091 L
s
.33214 .29495 m
.34522 .27061 L
s
.34522 .27061 m
.34136 .2351 L
s
.65478 .27061 m
.65864 .2351 L
s
.65478 .27061 m
.66786 .29495 L
s
.61342 .5136 m
.61625 .48416 L
s
.61342 .5136 m
.58542 .5305 L
s
.41458 .5305 m
.38658 .5136 L
s
.38658 .5136 m
.38375 .48416 L
s
.32605 .32108 m
.3303 .35454 L
s
.33176 .38118 m
.3303 .35454 L
s
.6697 .35454 m
.67395 .32108 L
s
.6697 .35454 m
.66824 .38118 L
s
.38631 .1951 m
.36116 .21336 L
s
.63884 .21336 m
.61369 .1951 L
s
.36086 .46294 m
.34471 .43875 L
s
.34471 .43875 m
.34082 .40734 L
s
.65529 .43875 m
.65918 .40734 L
s
.65529 .43875 m
.63914 .46294 L
s
.58542 .5305 m
.58758 .50124 L
s
.58542 .5305 m
.55308 .54236 L
s
.44692 .54236 m
.41458 .5305 L
s
.41458 .5305 m
.41242 .50124 L
s
.66786 .29495 m
.67211 .25959 L
s
.66786 .29495 m
.67395 .32108 L
s
.32605 .32108 m
.33214 .29495 L
s
.33214 .29495 m
.32789 .25959 L
s
.36116 .21336 m
.34136 .2351 L
s
.65864 .2351 m
.63884 .21336 L
s
.55308 .54236 m
.55443 .51323 L
s
.55308 .54236 m
.51801 .54847 L
s
.48199 .54847 m
.44692 .54236 L
s
.44692 .54236 m
.44557 .51323 L
s
.63914 .46294 m
.64267 .43177 L
s
.63914 .46294 m
.61625 .48416 L
s
.38375 .48416 m
.36086 .46294 L
s
.36086 .46294 m
.35733 .43177 L
s
.34082 .40734 m
.33176 .38118 L
s
.33176 .38118 m
.32749 .34793 L
s
.66824 .38118 m
.67251 .34793 L
s
.66824 .38118 m
.65918 .40734 L
s
.51801 .54847 m
.51847 .51941 L
s
.51801 .54847 m
.48199 .54847 L
s
.48199 .54847 m
.48153 .51941 L
s
.67211 .25959 m
.65864 .2351 L
s
.34136 .2351 m
.32789 .25959 L
s
.61625 .48416 m
.61923 .4532 L
s
.61625 .48416 m
.58758 .50124 L
s
.41242 .50124 m
.38375 .48416 L
s
.38375 .48416 m
.38077 .4532 L
s
.32158 .2859 m
.32605 .32108 L
s
.32749 .34793 m
.32605 .32108 L
s
.67395 .32108 m
.67842 .2859 L
s
.67395 .32108 m
.67251 .34793 L
s
.35733 .43177 m
.34082 .40734 L
s
.34082 .40734 m
.33672 .37432 L
s
.65918 .40734 m
.66328 .37432 L
s
.65918 .40734 m
.64267 .43177 L
s
.58758 .50124 m
.58984 .47047 L
s
.58758 .50124 m
.55443 .51323 L
s
.44557 .51323 m
.41242 .50124 L
s
.41242 .50124 m
.41016 .47047 L
s
.67842 .2859 m
.67211 .25959 L
s
.32789 .25959 m
.32158 .2859 L
s
.55443 .51323 m
.55585 .4826 L
s
.55443 .51323 m
.51847 .51941 L
s
.48153 .51941 m
.44557 .51323 L
s
.44557 .51323 m
.44415 .4826 L
s
.64267 .43177 m
.64639 .39897 L
s
.64267 .43177 m
.61923 .4532 L
s
.38077 .4532 m
.35733 .43177 L
s
.35733 .43177 m
.35361 .39897 L
s
.33672 .37432 m
.32749 .34793 L
s
.32749 .34793 m
.323 .31295 L
s
.67251 .34793 m
.677 .31295 L
s
.67251 .34793 m
.66328 .37432 L
s
.51847 .51941 m
.51895 .48885 L
s
.51847 .51941 m
.48153 .51941 L
s
.48153 .51941 m
.48105 .48885 L
s
.61923 .4532 m
.62237 .42062 L
s
.61923 .4532 m
.58984 .47047 L
s
.41016 .47047 m
.38077 .4532 L
s
.38077 .4532 m
.37763 .42062 L
s
.32158 .2859 m
.323 .31295 L
s
.677 .31295 m
.67842 .2859 L
s
.35361 .39897 m
.33672 .37432 L
s
.33672 .37432 m
.33241 .33955 L
s
.66328 .37432 m
.66759 .33955 L
s
.66328 .37432 m
.64639 .39897 L
s
.58984 .47047 m
.59223 .43807 L
s
.58984 .47047 m
.55585 .4826 L
s
.44415 .4826 m
.41016 .47047 L
s
.41016 .47047 m
.40777 .43807 L
s
.55585 .4826 m
.55734 .45032 L
s
.55585 .4826 m
.51895 .48885 L
s
.48105 .48885 m
.44415 .4826 L
s
.44415 .4826 m
.44266 .45032 L
s
.37763 .42062 m
.35361 .39897 L
s
.35361 .39897 m
.3497 .36442 L
s
.64639 .39897 m
.6503 .36442 L
s
.64639 .39897 m
.62237 .42062 L
s
.66759 .33955 m
.677 .31295 L
s
.323 .31295 m
.33241 .33955 L
s
.51895 .48885 m
.51945 .45664 L
s
.51895 .48885 m
.48105 .48885 L
s
.48105 .48885 m
.48055 .45664 L
s
.62237 .42062 m
.62568 .38627 L
s
.62237 .42062 m
.59223 .43807 L
s
.40777 .43807 m
.37763 .42062 L
s
.37763 .42062 m
.37432 .38627 L
s
.6503 .36442 m
.66759 .33955 L
s
.33241 .33955 m
.3497 .36442 L
s
.59223 .43807 m
.59474 .4039 L
s
.59223 .43807 m
.55734 .45032 L
s
.44266 .45032 m
.40777 .43807 L
s
.40777 .43807 m
.40526 .4039 L
s
.55734 .45032 m
.55891 .41628 L
s
.55734 .45032 m
.51945 .45664 L
s
.48055 .45664 m
.44266 .45032 L
s
.44266 .45032 m
.44109 .41628 L
s
.62568 .38627 m
.6503 .36442 L
s
.3497 .36442 m
.37432 .38627 L
s
.51945 .45664 m
.51999 .42267 L
s
.51945 .45664 m
.48055 .45664 L
s
.48055 .45664 m
.48001 .42267 L
s
.59474 .4039 m
.62568 .38627 L
s
.37432 .38627 m
.40526 .4039 L
s
.55891 .41628 m
.59474 .4039 L
s
.40526 .4039 m
.44109 .41628 L
s
.51999 .42267 m
.55891 .41628 L
s
.44109 .41628 m
.48001 .42267 L
s
.48001 .42267 m
.51999 .42267 L
s
0 0 0 r
.25 Mabswid
.85264 .14594 m
.14736 .14594 L
s
.14736 .14594 m
.09252 .42015 L
s
.09252 .42015 m
.90748 .42015 L
s
.90748 .42015 m
.85264 .14594 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{500, 500},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40007d0001m2000`400?l00000o`00003oo`3ooooe
0?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3o
m^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40
oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?of
k_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3o
ool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^
m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?oo
o`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd
0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo
003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0
ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool0
0?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03o
m^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00
o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?of
kP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o
0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^
0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0
ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h1
0?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3o
m^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40
oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?of
k_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00B@3om^ko000006800000B@3om^h10?ooo`00B@3o
m^h00`000000ooK^0?ofkP3o0?ofkUh0ooK^00<000000?ofkP3om^h0A`3om^h10?ooo`00B@3om^h0
0`000000ooK^0?ofkP3o0?ofkUh0ooK^00<000000?ofkP3om^h0A`3om^h10?ooo`00B03om^h00`00
0000ooK^0000003o0?ofkUh0ooK^00<000000?ofkP000000B03om^h10?ooo`00B03om^h00`000000
ooK^0000003o0?ofkUh0ooK^00<000000?ofkP000000B03om^h10?ooo`00B03om^h00`000000ooK^
0000003o0?ofkUh0ooK^00<000000?ofkP000000B03om^h10?ooo`00B03om^h00`000000ooK^0000
003o0?ofkUh0ooK^00<000000?ofkP000000B03om^h10?ooo`00B03om^h010000000ooK^0?ofkP00
003o0?ofkU`0ooK^00@000000?ofkP3om^h00000B03om^h10?ooo`00A`3om^h01@000000ooK^0?of
kP3om^h000000?l0ooK^G03om^h01@000000ooK^0?ofkP3om^h0000004L0ooK^0@3oool004L0ooK^
00D000000?ofkP3om^h0ooK^0000003o0?ofkU`0ooK^00D000000?ofkP3om^h0ooK^000000170?of
kP40oooo00170?ofkP050000003om^h0ooK^0?ofkP000000XP3om^hG0=@m6J80ooK^00D000000?of
kP3om^h0ooK^000000170?ofkP40oooo00170?ofkP030000003om^h0ooK^0080ooK^00<000000?of
kP3om^h0V@3om^h60=@m6@80ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP060=@m
6I/0ooK^00<000000?ofkP3om^h00P3om^h00`000000ooK^0?ofkP150?ofkP40oooo00170?ofkP03
0000003om^h0ooK^0080ooK^00<000000?ofkP3om^h0T`3om^h60=@m6@P0ooK^00<0e3dI0?ofkP3o
m^h03`3om^h00`3D?AT0ooK^0?ofkP060?ofkPH0e3dIU@3om^h00`000000ooK^0?ofkP020?ofkP03
0000003om^h0ooK^04D0ooK^0@3oool004H0ooK^00<000000?ofkP3om^h00`3om^h00`000000ooK^
0?ofkP2?0?ofkP@0e3dI3P3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00`0ooK^
103D?AVA0?ofkP030000003om^h0ooK^00<0ooK^00<000000?ofkP3om^h0A03om^h10?ooo`00AP3o
m^h00`000000ooK^0?ofkP030?ofkP030000003om^h0ooK^08`0ooK^0`3D?AT00`3om^h0e3dI0?of
kP0?0?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0=@m
6@020=@m6Hh0ooK^00<000000?ofkP3om^h00`3om^h00`000000ooK^0?ofkP140?ofkP40oooo0016
0?ofkP030000003om^h0ooK^00<0ooK^00<000000?ofkP3om^h0R@3om^h30=@m6@@0ooK^00<0e3dI
0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI
0?ofkP3om^h00P3om^h30=@m6H/0ooK^00<000000?ofkP3om^h00`3om^h00`000000ooK^0?ofkP14
0?ofkP40oooo00160?ofkP030000003om^h0ooK^00@0ooK^00<000000?ofkP3om^h0Q03om^h40=@m
6@L0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^
00h0ooK^00<0e3dI0?ofkP3om^h01@3om^h40=@m6HH0ooK^00<000000?ofkP3om^h0103om^h00`00
0000ooK^0?ofkP140?ofkP40oooo00160?ofkP030000003om^h0ooK^00@0ooK^00<000000?ofkP3o
m^h0P@3om^h30=@m6@/0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP03
0=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h02@3om^h30=@m6H<0ooK^00<000000?ofkP3o
m^h0103om^h00`000000ooK^0?ofkP140?ofkP40oooo00150?ofkP030000003om^h0ooK^00D0ooK^
00<000000?ofkP3om^h0OP3om^h30=@m6@h0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^
0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h0303om^h30=@m6H00ooK^
00<000000?ofkP3om^h01@3om^h00`000000ooK^0?ofkP130?ofkP40oooo00150?ofkP030000003o
m^h0ooK^00D0ooK^00<000000?ofkP3om^h0O03om^h20=@m6@030?ofkP3D?AT0ooK^00h0ooK^00<0
e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0
e3dI0?ofkP3om^h03@3om^h0103D?AT0ooK^0=@m6@3D?AUn0?ofkP030000003om^h0ooK^00D0ooK^
00<000000?ofkP3om^h0@`3om^h10?ooo`00A@3om^h00`000000ooK^0?ofkP060?ofkP030000003o
m^h0ooK^07T0ooK^0P3D?AT30?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h03P3o
m^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h03@3o
m^h0103D?AT0ooK^0?ofkP3om^h20=@m6G/0ooK^00<000000?ofkP3om^h01P3om^h00`000000ooK^
0?ofkP130?ofkP40oooo00150?ofkP030000003om^h0ooK^00H0ooK^00<000000?ofkP3om^h0M`3o
m^h20=@m6@D0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3o
m^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3o
m^h0ooK^00<0ooK^0P3D?AUi0?ofkP030000003om^h0ooK^00H0ooK^00<000000?ofkP3om^h0@`3o
m^h10?ooo`00A@3om^h00`000000ooK^0?ofkP060?ofkP030000003om^h0ooK^07D0ooK^0P3D?AT7
0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0?
0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP05
0?ofkP80e3dIM`3om^h00`000000ooK^0?ofkP060?ofkP030000003om^h0ooK^04<0ooK^0@3oool0
04@0ooK^00<000000?ofkP3om^h01`3om^h00`000000ooK^0?ofkP1c0?ofkP80e3dI2@3om^h00`3D
?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D
?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h01`3om^h20=@m
6GD0ooK^00<000000?ofkP3om^h01`3om^h00`000000ooK^0?ofkP120?ofkP40oooo00140?ofkP03
0000003om^h0ooK^00L0ooK^00<000000?ofkP3om^h0L@3om^h20=@m6@/0ooK^00<0e3dI0?ofkP3o
m^h03P3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3o
m^h03@3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00T0ooK^0P3D?AUc0?ofkP03
0000003om^h0ooK^00L0ooK^00<000000?ofkP3om^h0@P3om^h10?ooo`00A03om^h00`000000ooK^
0?ofkP080?ofkP030000003om^h0ooK^06h0ooK^0P3D?AT=0?ofkP030=@m6@3om^h0ooK^00h0ooK^
00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00d0ooK^
00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP80e3dIL03om^h00`000000ooK^
0?ofkP080?ofkP030000003om^h0ooK^0480ooK^0@3oool004@0ooK^00<000000?ofkP3om^h0203o
m^h00`000000ooK^0?ofkP1]0?ofkP80e3dI3P3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3o
m^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3o
m^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h0303om^h20=@m6Fl0ooK^00<000000?ofkP3om^h0203o
m^h00`000000ooK^0?ofkP120?ofkP40oooo00140?ofkP030000003om^h0ooK^00P0ooK^00<00000
0?ofkP3om^h0J`3om^h20=@m6@030?ofkP3D?AT0ooK^00d0ooK^00<0e3dI0?ofkP3om^h03P3om^h0
0`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h03@3om^h0
0`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00d0ooK^00@0e3dI0?ofkP3D?AT0e3dIK@3o
m^h00`000000ooK^0?ofkP080?ofkP030000003om^h0ooK^0480ooK^0@3oool004<0ooK^00<00000
0?ofkP3om^h02@3om^h00`000000ooK^0?ofkP1Z0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT03`3o
m^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00/0ooK^5`3D?AT=0?ofkP030=@m6@3o
m^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h03@3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI06`0ooK^
00<000000?ofkP3om^h02@3om^h00`000000ooK^0?ofkP110?ofkP40oooo00130?ofkP030000003o
m^h0ooK^00X0ooK^00<000000?ofkP3om^h0J03om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3o
m^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP060?ofkPD0e3dI0P3o
m^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00D0e3dI203om^h00`3D?AT0ooK^0?of
kP0=0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?of
kP1X0?ofkP030000003om^h0ooK^00X0ooK^00<000000?ofkP3om^h0@@3om^h10?ooo`00@`3om^h0
0`000000ooK^0?ofkP0:0?ofkP030000003om^h0ooK^06H0ooK^0P3D?AT60?ofkP030=@m6@3om^h0
ooK^00`0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP060=@m6@L0ooK^00<0e3dI
0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP050?ofkPH0e3dI0P3om^h00`3D?AT0ooK^0?ofkP0=
0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h0103om^h20=@m6FP0ooK^00<00000
0?ofkP3om^h02P3om^h00`000000ooK^0?ofkP110?ofkP40oooo00130?ofkP030000003om^h0ooK^
00X0ooK^00<000000?ofkP3om^h0I@3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^
00`0ooK^00<0e3dI0?ofkP3om^h0303om^h40=@m6@d0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D
?AT0ooK^0?ofkP0;0?ofkP@0e3dI3P3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^
00H0ooK^00<0e3dI0?ofkP3om^h0I@3om^h00`000000ooK^0?ofkP0:0?ofkP030000003om^h0ooK^
0440ooK^0@3oool004<0ooK^00<000000?ofkP3om^h02P3om^h00`000000ooK^0?ofkP1T0?ofkP03
0=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP090?ofkP<0
e3dI00<0ooK^0=@m6@3om^h03P3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00d0
ooK^00<0e3dI0?ofkP3D?AT00P3D?AT;0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3o
m^h01`3om^h00`3D?AT0ooK^0?ofkP1T0?ofkP030000003om^h0ooK^00X0ooK^00<000000?ofkP3o
m^h0@@3om^h10?ooo`00@P3om^h00`000000ooK^0?ofkP0<0?ofkP030000003om^h0ooK^0640ooK^
0P3D?AT:0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h01P3om^h30=@m6@@0ooK^
00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00d0ooK^
00<0e3dI0?ofkP3om^h00P3om^h30=@m6@P0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^
0?ofkP080?ofkP80e3dIH`3om^h00`000000ooK^0?ofkP0<0?ofkP030000003om^h0ooK^0400ooK^
0@3oool00480ooK^00<000000?ofkP3om^h0303om^h00`000000ooK^0?ofkP1P0?ofkP030=@m6@3o
m^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP020?ofkP@0e3dI1`3o
m^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h03@3o
m^h00`3D?AT0ooK^0?ofkP050?ofkP@0e3dI103om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3o
m^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h0H03om^h00`000000ooK^0?ofkP0<0?ofkP030000003o
m^h0ooK^0400ooK^0@3oool00480ooK^00<000000?ofkP3om^h0303om^h00`000000ooK^0?ofkP1O
0?ofkP80e3dI303om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0e3dI0080e3dI2`3om^h0
0`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h03@3om^h0
0`3D?AT0ooK^0?ofkP090?ofkP<0e3dI00<0ooK^0=@m6@3om^h03@3om^h00`3D?AT0ooK^0?ofkP0:
0?ofkP80e3dIH@3om^h00`000000ooK^0?ofkP0<0?ofkP030000003om^h0ooK^0400ooK^0@3oool0
0480ooK^00<000000?ofkP3om^h0303om^h00`000000ooK^0?ofkP1N0?ofkP030=@m6@3om^h0e3dI
00`0ooK^00<0e3dI0?ofkP3om^h0303om^h20=@m6@h0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D
?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h0303om^h20=@m
6@h0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0=@m6@1P0?ofkP030000003om^h0ooK^
00`0ooK^00<000000?ofkP3om^h0@03om^h10?ooo`00@P3om^h00`000000ooK^0?ofkP0<0?ofkP03
0000003om^h0ooK^05d0ooK^00@0e3dI0?ofkP3om^h0e3dI303om^h00`3D?AT0ooK^0?ofkP0:0?of
kP<0e3dI3`3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?of
kP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP<0e3dI303om^h00`3D?AT0ooK^0?ofkP0:0?of
kP040=@m6@3om^h0ooK^0=@m6El0ooK^00<000000?ofkP3om^h0303om^h00`000000ooK^0?ofkP10
0?ofkP40oooo00120?ofkP030000003om^h0ooK^00d0ooK^00<000000?ofkP3om^h0F`3om^h01@3D
?AT0ooK^0?ofkP3om^h0e3dI00`0ooK^00<0e3dI0?ofkP3om^h0203om^h20=@m6@80ooK^00<0e3dI
0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI
0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^0080e3dI2P3om^h0
0`3D?AT0ooK^0?ofkP0:0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT0G@3om^h00`000000ooK^0?of
kP0=0?ofkP030000003om^h0ooK^0400ooK^0@3oool00440ooK^00<000000?ofkP3om^h03P3om^h0
0`000000ooK^0?ofkP1J0?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h02`3om^h0
0`3D?AT0ooK^0?ofkP050?ofkP80e3dI103om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0
ooK^00h0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0
ooK^00d0ooK^00<0e3dI0?ofkP3om^h00P3om^h20=@m6@L0ooK^00<0e3dI0?ofkP3om^h02`3om^h0
0`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^05X0ooK^00<000000?ofkP3om^h03P3om^h0
0`000000ooK^0?ofkP0o0?ofkP40oooo00110?ofkP030000003om^h0ooK^00h0ooK^00<000000?of
kP3om^h0FP3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?of
kP3om^h00`3om^h20=@m6@H0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0>0?of
kP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0=0?of
kP030=@m6@3om^h0ooK^00@0ooK^0P3D?AT50?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?of
kP3om^h00P3om^h00`3D?AT0ooK^0?ofkP1J0?ofkP030000003om^h0ooK^00h0ooK^00<000000?of
kP3om^h0?`3om^h10?ooo`00@@3om^h00`000000ooK^0?ofkP0>0?ofkP030000003om^h0ooK^05T0
ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP040=@m6@3om^h0ooK^0?of
kP80e3dI203om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?of
kP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?of
kP3om^h01P3om^h20=@m6@<0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP030?of
kP030=@m6@3om^h0ooK^05T0ooK^00<000000?ofkP3om^h03P3om^h00`000000ooK^0?ofkP0o0?of
kP40oooo00110?ofkP030000003om^h0ooK^00l0ooK^00<000000?ofkP3om^h0E`3om^h00`3D?AT0
ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00/0ooK^00@0e3dI0?ofkP3D?AT0e3dI2P3om^h00`3D
?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D
?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h0203om^h20=@m
6@030?ofkP3D?AT0ooK^00`0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP1G0?of
kP030000003om^h0ooK^00l0ooK^00<000000?ofkP3om^h0?`3om^h10?ooo`00@@3om^h00`000000
ooK^0?ofkP0?0?ofkP030000003om^h0ooK^05H0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0
ooK^0?ofkP0;0?ofkP80e3dI303om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00h0
ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00d0
ooK^00<0e3dI0?ofkP3om^h02P3om^h20=@m6@`0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0
ooK^0?ofkP1F0?ofkP030000003om^h0ooK^00l0ooK^00<000000?ofkP3om^h0?`3om^h10?ooo`00
@03om^h00`000000ooK^0?ofkP0@0?ofkP030000003om^h0ooK^05D0ooK^00<0e3dI0?ofkP3om^h0
1`3om^h00`3D?AT0ooK^0?ofkP080?ofkP<0e3dI3@3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m
6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m
6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h02`3om^h30=@m6@X0ooK^00<0e3dI0?ofkP3om^h0
1`3om^h00`3D?AT0ooK^0?ofkP1E0?ofkP030000003om^h0ooK^0100ooK^00<000000?ofkP3om^h0
?P3om^h10?ooo`00@03om^h00`000000ooK^0?ofkP0@0?ofkP030000003om^h0ooK^05@0ooK^00<0
e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP070?ofkP040=@m6@3om^h0ooK^0=@m6@h0ooK^
00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP0<0?ofkQD0e3dI3P3om^h00`3D?AT0ooK^
0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00`0ooK^00@0e3dI0?ofkP3om^h0e3dI2@3om^h00`3D?AT0
ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^05@0ooK^00<000000?ofkP3om^h0403om^h00`000000
ooK^0?ofkP0n0?ofkP40oooo00100?ofkP030000003om^h0ooK^0100ooK^00<000000?ofkP3om^h0
D`3om^h20=@m6@X0ooK^00<0e3dI0?ofkP3om^h01@3om^h20=@m6@<0ooK^00<0e3dI0?ofkP3om^h0
303om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00H0ooK^1P3D?AT20?ofkP030=@m
6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h01P3D?AT80?ofkP030=@m6@3om^h0ooK^00`0ooK^
00<0e3dI0?ofkP3om^h0303om^h0103D?AT0ooK^0?ofkP3om^h20=@m6@L0ooK^00<0e3dI0?ofkP3o
m^h0203om^h20=@m6ED0ooK^00<000000?ofkP3om^h0403om^h00`000000ooK^0?ofkP0n0?ofkP40
oooo00100?ofkP030000003om^h0ooK^0140ooK^00<000000?ofkP3om^h0DP3om^h20=@m6@X0ooK^
00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00`0ooK^
00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP060=@m6@P0ooK^00<0e3dI0?ofkP3om^h0
3@3om^h00`3D?AT0ooK^0?ofkP060?ofkPH0e3dI0P3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m
6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m
6@3om^h0ooK^00P0ooK^0P3D?AUD0?ofkP030000003om^h0ooK^0140ooK^00<000000?ofkP3om^h0
?P3om^h10?ooo`00@03om^h00`000000ooK^0?ofkP0A0?ofkP030000003om^h0ooK^0540ooK^00<0
e3dI0?ofkP3D?AT02P3om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0
e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP0;0?ofkP@0e3dI3P3om^h00`3D?AT0ooK^0?of
kP0=0?ofkP030=@m6@3om^h0ooK^00`0ooK^103D?AT=0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0
e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0
e3dI0?ofkP3D?AT0D`3om^h00`000000ooK^0?ofkP0A0?ofkP030000003om^h0ooK^03h0ooK^0@3o
ool003l0ooK^00<000000?ofkP3om^h04P3om^h00`000000ooK^0?ofkP1A0?ofkP030=@m6@3om^h0
e3dI00X0ooK^00@0e3dI0?ofkP3om^h0ooK^0P3D?AT70?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0
e3dI0?ofkP3om^h0203om^h30=@m6@030?ofkP3D?AT0ooK^00l0ooK^00<0e3dI0?ofkP3om^h03@3o
m^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0e3dI0080e3dI2P3om^h00`3D?AT0ooK^0?of
kP0<0?ofkP030=@m6@3om^h0ooK^00D0ooK^0P3D?AT30?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0
e3dI0?ofkP3D?AT0D`3om^h00`000000ooK^0?ofkP0B0?ofkP030000003om^h0ooK^03d0ooK^0@3o
ool003l0ooK^00<000000?ofkP3om^h04P3om^h00`000000ooK^0?ofkP1@0?ofkP050=@m6@3om^h0
ooK^0?ofkP3D?AT02@3om^h0103D?AT0ooK^0?ofkP3D?AT90?ofkP030=@m6@3om^h0ooK^00`0ooK^
00<0e3dI0?ofkP3om^h01@3om^h30=@m6@@0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^
0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h00P3om^h30=@m6@L0ooK^
00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP070?ofkP040=@m6@3om^h0ooK^0=@m6@T0
ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@1B0?ofkP030000003om^h0ooK^0180ooK^00<000000?of
kP3om^h0?@3om^h10?ooo`00?`3om^h00`000000ooK^0?ofkP0C0?ofkP030000003om^h0ooK^04h0
ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP070?ofkP<0e3dI2P3om^h00`3D?AT0
ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^0080ooK^0`3D?AT70?ofkP030=@m6@3om^h0ooK^00h0
ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00D0
ooK^0`3D?AT40?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h0203om^h30=@m6@T0
ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@1A0?ofkP030000003om^h0ooK^01<0ooK^00<000000?of
kP3om^h0?@3om^h10?ooo`00?`3om^h00`000000ooK^0?ofkP0C0?ofkP030000003om^h0ooK^04h0
ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00/0
ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0=@m6@020=@m6@X0ooK^00<0e3dI0?ofkP3o
m^h03P3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3o
m^h0203om^h30=@m6@030?ofkP3D?AT0ooK^00`0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0
ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h0CP3om^h00`000000
ooK^0?ofkP0C0?ofkP030000003om^h0ooK^03d0ooK^0@3oool003l0ooK^00<000000?ofkP3om^h0
4`3om^h00`000000ooK^0?ofkP1=0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h0
1P3om^h20=@m6@d0ooK^00<0e3dI0?ofkP3om^h02`3om^h20=@m6@d0ooK^00<0e3dI0?ofkP3om^h0
3P3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h0
2`3om^h20=@m6@d0ooK^00<0e3dI0?ofkP3om^h02`3om^h20=@m6@P0ooK^00<0e3dI0?ofkP3om^h0
0`3om^h00`3D?AT0ooK^0?ofkP1=0?ofkP030000003om^h0ooK^01<0ooK^00<000000?ofkP3om^h0
?@3om^h10?ooo`00?P3om^h00`000000ooK^0?ofkP0D0?ofkP030000003om^h0ooK^04d0ooK^00<0
e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0e3dI00d0ooK^00<0
e3dI0?ofkP3om^h02@3om^h30=@m6@h0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?of
kP0=0?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h0303om^h30=@m6@/0ooK^00<0
e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0=@m6@070?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0
e3dI0?ofkP3om^h0C@3om^h00`000000ooK^0?ofkP0D0?ofkP030000003om^h0ooK^03`0ooK^0@3o
ool003h0ooK^00<000000?ofkP3om^h05@3om^h00`000000ooK^0?ofkP1;0?ofkP030=@m6@3om^h0
ooK^00@0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0=@m6@0=0?ofkP030=@m6@3om^h0
ooK^00L0ooK^0P3D?AT20?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h03P3om^h0
0`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h0303om^h0
0`3D?AT0ooK^0?ofkP020=@m6@T0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0=@m6@07
0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h0B`3om^h00`000000ooK^0?ofkP0E
0?ofkP030000003om^h0ooK^03`0ooK^0@3oool003h0ooK^00<000000?ofkP3om^h05@3om^h00`00
0000ooK^0?ofkP1;0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h0103om^h0103D
?AT0ooK^0?ofkP3D?AT=0?ofkP030=@m6@3om^h0ooK^00D0ooK^0P3D?AT40?ofkP030=@m6@3om^h0
ooK^00`0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0
ooK^00d0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP020?ofkP80e3dI1`3om^h0
0`3D?AT0ooK^0?ofkP0;0?ofkP040=@m6@3om^h0ooK^0=@m6@H0ooK^00<0e3dI0?ofkP3om^h0103o
m^h00`3D?AT0ooK^0?ofkP1;0?ofkP030000003om^h0ooK^01D0ooK^00<000000?ofkP3om^h0?03o
m^h10?ooo`00?P3om^h00`000000ooK^0?ofkP0E0?ofkP030000003om^h0ooK^04X0ooK^00<0e3dI
0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI
0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP030?ofkP80e3dI1P3om^h00`3D?AT0ooK^0?ofkP0=
0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0=
0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h0103om^h20=@m6@D0ooK^00<0e3dI
0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI
0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP1:0?ofkP030000003om^h0ooK^01D0ooK^00<00000
0?ofkP3om^h0?03om^h10?ooo`00?P3om^h00`000000ooK^0?ofkP0E0?ofkP030000003om^h0ooK^
04X0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^
00<0ooK^00<0e3dI0?ofkP3om^h02P3om^h0103D?AT0ooK^0?ofkP3om^h20=@m6@P0ooK^00<0e3dI
0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI
0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00H0ooK^0P3D?AT3
0?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP02
0?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h0BP3om^h00`000000ooK^0?ofkP0E
0?ofkP030000003om^h0ooK^03`0ooK^0@3oool003d0ooK^00<000000?ofkP3om^h05P3om^h00`00
0000ooK^0?ofkP1:0?ofkP030=@m6@3om^h0ooK^00H0ooK^00@0e3dI0?ofkP3om^h0e3dI1P3om^h0
0`3D?AT0ooK^0?ofkP0:0?ofkP040=@m6@3om^h0e3dI0=@m6@X0ooK^00<0e3dI0?ofkP3om^h03@3o
m^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h03@3o
m^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00P0ooK^0P3D?AT00`3om^h0e3dI0?of
kP0;0?ofkP030=@m6@3om^h0ooK^00@0ooK^00@0e3dI0?ofkP3om^h0e3dI203om^h00`3D?AT0ooK^
0?ofkP1:0?ofkP030000003om^h0ooK^01H0ooK^00<000000?ofkP3om^h0>`3om^h10?ooo`00?@3o
m^h00`000000ooK^0?ofkP0G0?ofkP030000003om^h0ooK^04P0ooK^0P3D?AT80?ofkP030=@m6@3o
m^h0e3dI00L0ooK^00<0e3dI0?ofkP3om^h02P3om^h20=@m6@`0ooK^00<0e3dI0?ofkP3om^h03@3o
m^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h03@3o
m^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00X0ooK^0P3D?AT<0?ofkP030=@m6@3o
m^h0ooK^00D0ooK^00<0e3dI0?ofkP3D?AT0203om^h20=@m6DX0ooK^00<000000?ofkP3om^h05`3o
m^h00`000000ooK^0?ofkP0k0?ofkP40oooo000m0?ofkP030000003om^h0ooK^01L0ooK^00<00000
0?ofkP3om^h0B03om^h20=@m6@P0ooK^00<0e3dI0?ofkP3D?AT01`3om^h00`3D?AT0ooK^0?ofkP09
0?ofkP80e3dI3@3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI
0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI
0?ofkP3om^h0303om^h20=@m6@/0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0=@m6@08
0?ofkP80e3dIBP3om^h00`000000ooK^0?ofkP0G0?ofkP030000003om^h0ooK^03/0ooK^0@3oool0
03d0ooK^00<000000?ofkP3om^h05`3om^h00`000000ooK^0?ofkP180?ofkP030=@m6@3om^h0e3dI
00L0ooK^0P3D?AT80?ofkP030=@m6@3om^h0ooK^00L0ooK^0P3D?AT00`3om^h0e3dI0?ofkP0=0?of
kP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h02P3om^hG0=@m6@`0ooK^00<0e3dI0?of
kP3om^h0303om^h00`3D?AT0ooK^0?ofkP0<0?ofkP040=@m6@3om^h0e3dI0=@m6@T0ooK^00<0e3dI
0?ofkP3om^h01P3om^h20=@m6@L0ooK^00<0e3dI0?ofkP3D?AT0BP3om^h00`000000ooK^0?ofkP0G
0?ofkP030000003om^h0ooK^03/0ooK^0@3oool003d0ooK^00<000000?ofkP3om^h05`3om^h00`00
0000ooK^0?ofkP180?ofkP030=@m6@3om^h0e3dI00L0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D
?AT0ooK^0?ofkP060?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT03P3om^h00`3D?AT0ooK^0?ofkP0<
0?ofkP030=@m6@3om^h0ooK^0080ooK^203D?AT30?ofkP030=@m6@3om^h0ooK^00d0ooK^00@0e3dI
0?ofkP3om^h0ooK^203D?AT40?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h0303o
m^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00P0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^
0?ofkP050?ofkP030=@m6@3om^h0e3dI04X0ooK^00<000000?ofkP3om^h05`3om^h00`000000ooK^
0?ofkP0k0?ofkP40oooo000l0?ofkP030000003om^h0ooK^01T0ooK^00<000000?ofkP3om^h0AP3o
m^h0103D?AT0ooK^0?ofkP3D?AT60?ofkP80e3dI2@3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m
6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP0;0?ofkPH0e3dI
2`3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00T0ooK^1P3D?AT=0?ofkP030=@m
6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m
6@3om^h0ooK^00L0ooK^0P3D?AT60?ofkP040=@m6@3om^h0ooK^0=@m6DP0ooK^00<000000?ofkP3o
m^h06@3om^h00`000000ooK^0?ofkP0j0?ofkP40oooo000l0?ofkP030000003om^h0ooK^01T0ooK^
00<000000?ofkP3om^h0AP3om^h0103D?AT0ooK^0?ofkP3D?AT60?ofkP80e3dI2P3om^h00`3D?AT0
ooK^0?ofkP020?ofkP80e3dI1@3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00P0
ooK^0`3D?AT00`3om^h0e3dI0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3o
m^h03@3om^h00`3D?AT0ooK^0=@m6@020=@m6@X0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0
ooK^0?ofkP030?ofkP80e3dI103om^h00`3D?AT0ooK^0?ofkP080?ofkP80e3dI1P3om^h0103D?AT0
ooK^0?ofkP3D?AU80?ofkP030000003om^h0ooK^01T0ooK^00<000000?ofkP3om^h0>P3om^h10?oo
o`00?03om^h00`000000ooK^0?ofkP0I0?ofkP030000003om^h0ooK^04H0ooK^00@0e3dI0?ofkP3o
m^h0e3dI1@3om^h00`3D?AT0ooK^0=@m6@0:0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT01`3om^h0
0`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00D0ooK^0`3D?AT40?ofkP030=@m6@3om^h0
ooK^00d0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0
ooK^0080ooK^0`3D?AT70?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h01@3om^h0
1@3D?AT0ooK^0?ofkP3om^h0e3dI00X0ooK^00<0e3dI0?ofkP3D?AT01@3om^h0103D?AT0ooK^0?of
kP3D?AU80?ofkP030000003om^h0ooK^01T0ooK^00<000000?ofkP3om^h0>P3om^h10?ooo`00?03o
m^h00`000000ooK^0?ofkP0I0?ofkP030000003om^h0ooK^04H0ooK^00@0e3dI0?ofkP3om^h0e3dI
1@3om^h00`3D?AT0ooK^0=@m6@0:0?ofkP040=@m6@3om^h0ooK^0=@m6@P0ooK^00<0e3dI0?ofkP3o
m^h0303om^h00`3D?AT0ooK^0?ofkP020?ofkP<0e3dI1`3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP03
0=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP050?ofkP<0
e3dI103om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00H0ooK^00@0e3dI0?ofkP3o
m^h0e3dI2@3om^h0103D?AT0ooK^0?ofkP3D?AT50?ofkP040=@m6@3om^h0ooK^0=@m6DP0ooK^00<0
00000?ofkP3om^h06@3om^h00`000000ooK^0?ofkP0j0?ofkP40oooo000l0?ofkP030000003om^h0
ooK^01T0ooK^00<000000?ofkP3om^h0A@3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00@0ooK^00D0
e3dI0?ofkP3om^h0ooK^0=@m6@090?ofkP<0e3dI2@3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m
6@3om^h0e3dI0080e3dI2P3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00d0ooK^
00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP080?ofkP<0e3dI00<0ooK^0=@m6@3om^h0
303om^h00`3D?AT0ooK^0?ofkP080?ofkP<0e3dI2@3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00@0
ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@170?ofkP030000003om^h0ooK^01T0ooK^00<000000?of
kP3om^h0>P3om^h10?ooo`00>`3om^h00`000000ooK^0?ofkP0K0?ofkP030000003om^h0ooK^04@0
ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@030?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?of
kP3om^h01`3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00/0ooK^0P3D?AT=0?of
kP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0=0?of
kP030=@m6@3om^h0ooK^00/0ooK^0P3D?AT=0?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?of
kP3om^h01`3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00@0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m
6@160?ofkP030000003om^h0ooK^01/0ooK^00<000000?ofkP3om^h0>@3om^h10?ooo`00>`3om^h0
0`000000ooK^0?ofkP0K0?ofkP030000003om^h0ooK^04@0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m
6@030?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h01P3om^h20=@m6@`0ooK^00<0
e3dI0?ofkP3om^h02@3om^h30=@m6@h0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?of
kP0=0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h0303om^h30=@m6@/0ooK^00<0
e3dI0?ofkP3om^h02P3om^h20=@m6@P0ooK^00<0e3dI0?ofkP3om^h00P3om^h01@3D?AT0ooK^0?of
kP3om^h0e3dI00<0ooK^00<0e3dI0?ofkP3om^h0A03om^h00`000000ooK^0?ofkP0K0?ofkP030000
003om^h0ooK^03T0ooK^0@3oool003/0ooK^00<000000?ofkP3om^h06`3om^h00`000000ooK^0?of
kP140?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3D?AT01@3om^h00`3D?AT0ooK^0?of
kP050?ofkP030=@m6@3om^h0e3dI00`0ooK^00<0e3dI0?ofkP3om^h01`3om^h20=@m6@80ooK^00<0
e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0
e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^0080e3dI2@3o
m^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0e3dI00L0ooK^00<0e3dI0?ofkP3om^h00`3o
m^h00`3D?AT0ooK^0=@m6@040?ofkP030=@m6@3om^h0ooK^04@0ooK^00<000000?ofkP3om^h06`3o
m^h00`000000ooK^0?ofkP0i0?ofkP40oooo000k0?ofkP030000003om^h0ooK^01/0ooK^00<00000
0?ofkP3om^h0A03om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0e3dI00D0ooK^00<0e3dI
0?ofkP3om^h0103om^h0103D?AT0ooK^0?ofkP3D?AT<0?ofkP030=@m6@3om^h0ooK^00D0ooK^0P3D
?AT40?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?of
kP0=0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?of
kP020?ofkP80e3dI1`3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP040=@m6@3om^h0ooK^0=@m6@H0ooK^
00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0=@m6@040?ofkP030=@m6@3om^h0ooK^04@0ooK^
00<000000?ofkP3om^h06`3om^h00`000000ooK^0?ofkP0i0?ofkP40oooo000k0?ofkP030000003o
m^h0ooK^01`0ooK^00<000000?ofkP3om^h0@`3om^h00`3D?AT0ooK^0?ofkP020?ofkP80e3dI1P3o
m^h00`3D?AT0ooK^0?ofkP030?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT0303om^h00`3D?AT0ooK^
0?ofkP030?ofkP80e3dI1P3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00d0ooK^
00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00`0ooK^
00<0e3dI0?ofkP3om^h0103om^h20=@m6@D0ooK^00<0e3dI0?ofkP3om^h02P3om^h01@3D?AT0ooK^
0?ofkP3om^h0e3dI00D0ooK^00<0e3dI0?ofkP3om^h0103om^h20=@m6@@0ooK^00<0e3dI0?ofkP3o
m^h0@`3om^h00`000000ooK^0?ofkP0L0?ofkP030000003om^h0ooK^03T0ooK^0@3oool003X0ooK^
00<000000?ofkP3om^h07@3om^h00`000000ooK^0?ofkP130?ofkP030=@m6@3om^h0ooK^0080ooK^
0P3D?AT60?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^
0?ofkP090?ofkP040=@m6@3om^h0ooK^0?ofkP80e3dI203om^h00`3D?AT0ooK^0?ofkP0<0?ofkP03
0=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP03
0=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h01P3om^h20=@m6@<0ooK^00<0e3dI0?ofkP3o
m^h02P3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00D0ooK^00<0e3dI0?ofkP3om^h0103om^h20=@m
6@@0ooK^00<0e3dI0?ofkP3om^h0@`3om^h00`000000ooK^0?ofkP0M0?ofkP030000003om^h0ooK^
03P0ooK^0@3oool003X0ooK^00<000000?ofkP3om^h07@3om^h00`000000ooK^0?ofkP130?ofkP80
e3dI0`3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3o
m^h00`3om^h00`3D?AT0ooK^0?ofkP090?ofkP040=@m6@3om^h0e3dI0=@m6@X0ooK^00<0e3dI0?of
kP3om^h0303om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?of
kP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00P0ooK^0P3D?AT00`3o
m^h0e3dI0?ofkP0;0?ofkP030=@m6@3om^h0ooK^0080ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@08
0?ofkP040=@m6@3om^h0ooK^0?ofkP80e3dIA@3om^h00`000000ooK^0?ofkP0M0?ofkP030000003o
m^h0ooK^03P0ooK^0@3oool003X0ooK^00<000000?ofkP3om^h07@3om^h00`000000ooK^0?ofkP13
0?ofkP80e3dI0`3om^h00`3D?AT0ooK^0?ofkP060?ofkP040=@m6@3om^h0ooK^0=@m6@H0ooK^00<0
e3dI0?ofkP3om^h02@3om^h20=@m6@`0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?of
kP0=0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?of
kP0<0?ofkP030=@m6@3om^h0ooK^00X0ooK^0P3D?AT<0?ofkP030=@m6@3om^h0ooK^00<0ooK^00@0
e3dI0?ofkP3om^h0e3dI203om^h0103D?AT0ooK^0?ofkP3om^h20=@m6DD0ooK^00<000000?ofkP3o
m^h07@3om^h00`000000ooK^0?ofkP0h0?ofkP40oooo000j0?ofkP030000003om^h0ooK^01h0ooK^
00<000000?ofkP3om^h0@P3om^h20=@m6@<0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^
0=@m6@070?ofkP030=@m6@3om^h0ooK^00P0ooK^0P3D?AT>0?ofkP030=@m6@3om^h0ooK^00/0ooK^
00<0e3dI0?ofkP3om^h02`3om^hE0=@m6@d0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^
0?ofkP0<0?ofkP80e3dI2P3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0e3dI00P0ooK^
00D0e3dI0?ofkP3om^h0ooK^0=@m6@150?ofkP030000003om^h0ooK^01h0ooK^00<000000?ofkP3o
m^h0>03om^h10?ooo`00>P3om^h00`000000ooK^0?ofkP0N0?ofkP030000003om^h0ooK^04<0ooK^
00<0e3dI0?ofkP3om^h00P3D?AT80?ofkP80e3dI203om^h00`3D?AT0ooK^0?ofkP060?ofkP80e3dI
00<0ooK^0=@m6@3om^h03@3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00H0ooK^
1@3D?AT20?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h01@3D?AT80?ofkP030=@m
6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h0303om^h0103D?AT0ooK^0=@m6@3D?AT80?ofkP03
0=@m6@3om^h0ooK^00H0ooK^0P3D?AT80?ofkP80e3dI0P3om^h00`3D?AT0ooK^0?ofkP130?ofkP03
0000003om^h0ooK^01h0ooK^00<000000?ofkP3om^h0>03om^h10?ooo`00>@3om^h00`000000ooK^
0?ofkP0O0?ofkP030000003om^h0ooK^04<0ooK^00<0e3dI0?ofkP3om^h00P3D?AT80?ofkP030=@m
6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h01@3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00h0
ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP060=@m6@L0ooK^00<0e3dI0?ofkP3o
m^h03@3om^h00`3D?AT0ooK^0?ofkP050?ofkPH0e3dI0P3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP03
0=@m6@3om^h0ooK^00`0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@070?ofkP030=@m6@3om^h0ooK^
00L0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0=@m6@020?ofkP030=@m6@3om^h0ooK^
04<0ooK^00<000000?ofkP3om^h07`3om^h00`000000ooK^0?ofkP0g0?ofkP40oooo000i0?ofkP03
0000003om^h0ooK^01l0ooK^00<000000?ofkP3om^h0@`3om^h01P3D?AT0ooK^0?ofkP3D?AT0ooK^
0=@m6@H0ooK^0P3D?AT90?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h00P3om^h0
0`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00X0ooK^103D?AT=0?ofkP030=@m6@3om^h0
ooK^00d0ooK^00<0e3dI0?ofkP3om^h02`3om^h40=@m6@`0ooK^00<0e3dI0?ofkP3om^h0303om^h0
0`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h01`3om^h2
0=@m6@H0ooK^00<0e3dI0?ofkP3D?AT00P3om^h00`3D?AT0ooK^0?ofkP130?ofkP030000003om^h0
ooK^01l0ooK^00<000000?ofkP3om^h0=`3om^h10?ooo`00>@3om^h00`000000ooK^0?ofkP0O0?of
kP030000003om^h0ooK^04<0ooK^00H0e3dI0?ofkP3om^h0e3dI0?ofkP3D?AT60?ofkP80e3dI2@3o
m^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h0303o
m^h00`3D?AT0ooK^0?ofkP060?ofkP@0e3dI00<0ooK^0=@m6@3om^h03P3om^h00`3D?AT0ooK^0?of
kP0=0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3D?AT00`3D?AT80?ofkP030=@m6@3o
m^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h00`3om^h20=@m6@@0ooK^00<0e3dI0?ofkP3om^h01`3o
m^h20=@m6@H0ooK^00<0e3dI0?ofkP3D?AT00P3om^h00`3D?AT0ooK^0?ofkP130?ofkP030000003o
m^h0ooK^01l0ooK^00<000000?ofkP3om^h0=`3om^h10?ooo`00>@3om^h00`000000ooK^0?ofkP0P
0?ofkP030000003om^h0ooK^0480ooK^00<0e3dI0?ofkP3D?AT00P3om^h00`3D?AT0ooK^0?ofkP03
0?ofkP030=@m6@3om^h0e3dI00X0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@060?ofkP030=@m6@3o
m^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h00`3om^h30=@m6@D0ooK^00<0e3dI0?ofkP3om^h03@3o
m^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h00`3o
m^h30=@m6@D0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP050?ofkP050=@m6@3o
m^h0ooK^0?ofkP3D?AT02@3om^h00`3D?AT0ooK^0=@m6@050?ofkP060=@m6@3om^h0ooK^0=@m6@3o
m^h0e3dIA03om^h00`000000ooK^0?ofkP0P0?ofkP030000003om^h0ooK^03L0ooK^0@3oool003T0
ooK^00<000000?ofkP3om^h0803om^h00`000000ooK^0?ofkP120?ofkP030=@m6@3om^h0e3dI0080
ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0=@m6@0:0?ofkP040=@m6@3om^h0e3dI0=@m
6@L0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0=@m6@030=@m6@P0ooK^00<0e3dI0?of
kP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?of
kP3om^h01P3om^h40=@m6@030?ofkP3D?AT0ooK^00d0ooK^00<0e3dI0?ofkP3om^h01P3om^h0103D
?AT0ooK^0?ofkP3D?AT90?ofkP030=@m6@3om^h0e3dI00D0ooK^00H0e3dI0?ofkP3om^h0e3dI0?of
kP3D?AU40?ofkP030000003om^h0ooK^0200ooK^00<000000?ofkP3om^h0=`3om^h10?ooo`00>03o
m^h00`000000ooK^0?ofkP0Q0?ofkP030000003om^h0ooK^0480ooK^0`3D?AT20?ofkP030=@m6@3o
m^h0ooK^0080ooK^00@0e3dI0?ofkP3om^h0e3dI2P3om^h20=@m6@X0ooK^00<0e3dI0?ofkP3om^h0
2`3om^h20=@m6@`0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m
6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h02P3om^h20=@m6@d0ooK^00<0e3dI0?ofkP3om^h0
203om^h30=@m6@T0ooK^00@0e3dI0?ofkP3om^h0e3dI103om^h00`3D?AT0ooK^0?ofkP030=@m6D@0
ooK^00<000000?ofkP3om^h08@3om^h00`000000ooK^0?ofkP0f0?ofkP40oooo000h0?ofkP030000
003om^h0ooK^0240ooK^00<000000?ofkP3om^h0@P3om^h30=@m6@80ooK^00D0e3dI0?ofkP3om^h0
ooK^0=@m6@030?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0
ooK^0?ofkP090?ofkP<0e3dI3@3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00d0
ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP<0e3dI2`3om^h00`3D?AT0
ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00L0ooK^00@0e3dI0?ofkP3om^h0e3dI103om^h00`3D
?AT0ooK^0?ofkP030=@m6D@0ooK^00<000000?ofkP3om^h08@3om^h00`000000ooK^0?ofkP0f0?of
kP40oooo000h0?ofkP030000003om^h0ooK^0280ooK^00<000000?ofkP3om^h0@@3om^h20=@m6@<0
ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@030?ofkP030=@m6@3om^h0ooK^00L0ooK^0P3D?AT;0?of
kP030=@m6@3om^h0ooK^00L0ooK^0P3D?AT20?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?of
kP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?of
kP3om^h02`3om^h00`3D?AT0ooK^0?ofkP020=@m6@T0ooK^00<0e3dI0?ofkP3om^h02P3om^h20=@m
6@P0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@030?ofkP040=@m6@3om^h0ooK^0?ofkP80e3dI@`3o
m^h00`000000ooK^0?ofkP0R0?ofkP030000003om^h0ooK^03H0ooK^0@3oool003P0ooK^00<00000
0?ofkP3om^h08P3om^h00`000000ooK^0?ofkP110?ofkP80e3dI0`3om^h0103D?AT0ooK^0?ofkP3D
?AT40?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3D?AT02`3om^h00`3D?AT0ooK^0?of
kP050?ofkP80e3dI103om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0
e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0
e3dI0?ofkP3om^h00P3om^h20=@m6@L0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0=@m
6@060?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3D?AT0103om^h20=@m6D<0ooK^00<0
00000?ofkP3om^h08P3om^h00`000000ooK^0?ofkP0f0?ofkP40oooo000h0?ofkP030000003om^h0
ooK^0280ooK^00<000000?ofkP3om^h0@@3om^h20=@m6@@0ooK^00<0e3dI0?ofkP3D?AT01@3om^h0
0`3D?AT0ooK^0?ofkP040?ofkP040=@m6@3om^h0ooK^0=@m6@/0ooK^00<0e3dI0?ofkP3om^h00`3o
m^h20=@m6@H0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3o
m^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3o
m^h0ooK^00@0ooK^0P3D?AT50?ofkP030=@m6@3om^h0ooK^00X0ooK^00@0e3dI0?ofkP3om^h0e3dI
1@3om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0e3dI00@0ooK^0P3D?AU30?ofkP030000
003om^h0ooK^0280ooK^00<000000?ofkP3om^h0=P3om^h10?ooo`00=`3om^h00`000000ooK^0?of
kP0S0?ofkP030000003om^h0ooK^0480ooK^0P3D?AT30?ofkP80e3dI1P3om^h00`3D?AT0ooK^0?of
kP030?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT02`3om^h0103D?AT0ooK^0?ofkP3om^h20=@m6@P0
ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00d0
ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00H0
ooK^0P3D?AT30?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0
ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00@0ooK^0P3D?AT30?ofkP80e3dIA03om^h00`000000
ooK^0?ofkP0S0?ofkP030000003om^h0ooK^03D0ooK^0@3oool003L0ooK^00<000000?ofkP3om^h0
8`3om^h00`000000ooK^0?ofkP120?ofkP80e3dI0`3om^h20=@m6@H0ooK^00<0e3dI0?ofkP3om^h0
0P3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00T0ooK^00@0e3dI0?ofkP3D?AT0
e3dI2P3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3o
m^h03@3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3o
m^h0203om^h20=@m6@030?ofkP3D?AT0ooK^00X0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0
ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00@0ooK^0P3D?AT30?ofkP80e3dIA03om^h00`000000
ooK^0?ofkP0S0?ofkP030000003om^h0ooK^03D0ooK^0@3oool003L0ooK^00<000000?ofkP3om^h0
903om^h00`000000ooK^0?ofkP110?ofkP80e3dI0`3om^h00`3D?AT0ooK^0?ofkP050?ofkP050=@m
6@3om^h0ooK^0?ofkP3D?AT01@3om^h00`3D?AT0ooK^0?ofkP090?ofkP80e3dI303om^h00`3D?AT0
ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0
ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h02P3om^h20=@m6@/0
ooK^00<0e3dI0?ofkP3om^h00`3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00L0ooK^00@0e3dI0?of
kP3om^h0ooK^0P3D?AU30?ofkP030000003om^h0ooK^02@0ooK^00<000000?ofkP3om^h0=@3om^h1
0?ooo`00=`3om^h00`000000ooK^0?ofkP0T0?ofkP030000003om^h0ooK^0440ooK^0P3D?AT30?of
kP030=@m6@3om^h0ooK^00D0ooK^00@0e3dI0?ofkP3om^h0e3dI1P3om^h00`3D?AT0ooK^0?ofkP08
0?ofkP80e3dI3@3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00X0ooK^5@3D?AT<
0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h02`3om^h20=@m6@X0ooK^00<0e3dI
0?ofkP3om^h0103om^h0103D?AT0ooK^0?ofkP3D?AT70?ofkP040=@m6@3om^h0ooK^0?ofkP80e3dI
@`3om^h00`000000ooK^0?ofkP0T0?ofkP030000003om^h0ooK^03D0ooK^0@3oool003L0ooK^00<0
00000?ofkP3om^h0903om^h00`000000ooK^0?ofkP110?ofkP<0e3dI0P3om^h00`3D?AT0ooK^0?of
kP050?ofkP030=@m6@3om^h0e3dI00P0ooK^00<0e3dI0?ofkP3om^h01@3om^h20=@m6@030?ofkP3D
?AT0ooK^00`0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP050?ofkPD0e3dI0P3o
m^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00D0e3dI1`3om^h00`3D?AT0ooK^0?of
kP0<0?ofkP030=@m6@3om^h0ooK^00/0ooK^00@0e3dI0?ofkP3D?AT0e3dI203om^h00`3D?AT0ooK^
0?ofkP050?ofkP030=@m6@3om^h0e3dI00L0ooK^00<0e3dI0?ofkP3om^h00`3D?AU30?ofkP030000
003om^h0ooK^02@0ooK^00<000000?ofkP3om^h0=@3om^h10?ooo`00=P3om^h00`000000ooK^0?of
kP0U0?ofkP030000003om^h0ooK^0440ooK^0`3D?AT00`3om^h0e3dI0=@m6@070?ofkP80e3dI2@3o
m^h00`3D?AT0ooK^0?ofkP040?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT03@3om^h00`3D?AT0ooK^
0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00D0e3dI1`3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m
6@3om^h0ooK^00D0ooK^1@3D?AT20?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h0
2`3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00L0ooK^00<0e3dI0?ofkP3om^h01P3om^h20=@m6@L0
ooK^0P3D?AT0103om^h0e3dI0=@m6@3D?AU30?ofkP030000003om^h0ooK^02D0ooK^00<000000?of
kP3om^h0=03om^h10?ooo`00=P3om^h00`000000ooK^0?ofkP0V0?ofkP030000003om^h0ooK^0400
ooK^0`3D?AT00`3om^h0e3dI0=@m6@070?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3o
m^h00`3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3o
m^h02`3om^h40=@m6@`0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP@0
e3dI3@3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3o
m^h0103om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00@0ooK^00@0e3dI0?ofkP3D
?AT0ooK^0`3D?AU20?ofkP030000003om^h0ooK^02H0ooK^00<000000?ofkP3om^h0=03om^h10?oo
o`00=P3om^h00`000000ooK^0?ofkP0V0?ofkP030000003om^h0ooK^0400ooK^0P3D?AT01@3om^h0
e3dI0=@m6@3om^h0e3dI00D0ooK^0P3D?AT:0?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?of
kP3om^h0103om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00L0ooK^103D?AT00`3o
m^h0e3dI0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D
?AT0ooK^0=@m6@030=@m6@T0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP040?of
kP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP040?of
kP050=@m6@3om^h0e3dI0=@m6@3om^h00P3D?AU20?ofkP030000003om^h0ooK^02H0ooK^00<00000
0?ofkP3om^h0=03om^h10?ooo`00=P3om^h00`000000ooK^0?ofkP0V0?ofkP030000003om^h0ooK^
0440ooK^00H0e3dI0?ofkP3D?AT0e3dI0?ofkP3D?AT50?ofkP80e3dI2P3om^h01@3D?AT0ooK^0?of
kP3om^h0e3dI00L0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP030?ofkP@0e3dI
1@3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h0
303om^h00`3D?AT0ooK^0?ofkP030?ofkP@0e3dI1@3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m
6@3om^h0ooK^00D0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0:0?ofkP80e3dI1@3om^h01P3D?AT0
ooK^0=@m6@3D?AT0ooK^0=@m6D<0ooK^00<000000?ofkP3om^h09P3om^h00`000000ooK^0?ofkP0d
0?ofkP40oooo000f0?ofkP030000003om^h0ooK^02H0ooK^00<000000?ofkP3om^h0@@3om^h01P3D
?AT0ooK^0=@m6@3D?AT0ooK^0=@m6@@0ooK^00<0e3dI0?ofkP3D?AT02P3om^h0103D?AT0ooK^0=@m
6@3D?AT80?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3D?AT00`3D?AT90?ofkP030=@m
6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m
6@3om^h0ooK^00L0ooK^103D?AT00`3om^h0e3dI0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00H0ooK^
0P3D?AT00`3om^h0e3dI0?ofkP080?ofkP030=@m6@3om^h0e3dI00D0ooK^00H0e3dI0?ofkP3D?AT0
e3dI0?ofkP3D?AU30?ofkP030000003om^h0ooK^02H0ooK^00<000000?ofkP3om^h0=03om^h10?oo
o`00=@3om^h00`000000ooK^0?ofkP0X0?ofkP030000003om^h0ooK^0400ooK^00H0e3dI0?ofkP3D
?AT0e3dI0?ofkP3D?AT40?ofkP040=@m6@3om^h0ooK^0=@m6@T0ooK^0P3D?AT:0?ofkP030=@m6@3o
m^h0ooK^00X0ooK^0P3D?AT=0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h03@3o
m^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00/0ooK^0P3D?AT<0?ofkP030=@m6@3o
m^h0ooK^00P0ooK^0P3D?AT90?ofkP040=@m6@3om^h0ooK^0=@m6@@0ooK^0P3D?AT0103om^h0e3dI
0?ofkP3D?AU20?ofkP030000003om^h0ooK^02P0ooK^00<000000?ofkP3om^h0<`3om^h10?ooo`00
=@3om^h00`000000ooK^0?ofkP0X0?ofkP030000003om^h0ooK^0400ooK^00<0e3dI0?ofkP3D?AT0
0`3D?AT30?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT02@3om^h00`3D?AT0ooK^0?ofkP040?ofkW40
00001P3om^h00`3D?AT0ooK^0?ofkP070?ofkP040=@m6@3om^h0ooK^0=@m6@@0ooK^1P3D?AU20?of
kP030000003om^h0ooK^02P0ooK^00<000000?ofkP3om^h0<`3om^h10?ooo`00=@3om^h00`000000
ooK^0?ofkP0X0?ofkP030000000mFJ/0?EV[0400?EV[103D?AT00`0mFJ/0e3dI03eIZ`0203eIZ`05
0=@m6@0mFJ/0?EV[03eIZ`3D?AT0200mFJ/20=@m6@80?EV[1000000400h@80@000001@0>42030000
00H03Q0P0P00000700h@808000001P0>42000`0000003Q0P00h@800500h@80030000000>42003Q0P
00H03Q0P00<0000000h@800>42001@0>42000`0000003Q0P00h@800600h@80030000000>42003Q0P
00@03Q0P0P00000700h@808000001P0>4203000000D03Q0P1000000400h@80@000000P0mFJ/20=@m
6@P0?EV[00D0e3dI03eIZ`0mFJ/0?EV[0=@m6@0303eIZ`030=@m6@0mFJ/0e3dI00<0e3dI@P0mFJ/0
0`000000ooK^0?ofkP0X0?ofkP030000003om^h0ooK^03<0ooK^0@3oool003D0ooK^00<000000?of
kP3om^h09`3om^h203eIZ`030?ofkP0mFJ/0?EV[0140ooK^0P0mFJ/00`3om^h0?EV[0?ofkP0A0?of
kP0303eIZ`3om^h0?EV[01<0ooK^00L0?EV[0?ofkP3D?AT0e3dI0?ofkP3D?AT0ooK^0080e3dI00<0
ooK^0=@m6@3om^h00`3om^h00`3D?AT0ooK^0?ofkP040?ofkP0403eIZ`3D?AT0ooK^0=@m6Gd00000
0P3D?AT00`3om^h0?EV[0?ofkP050?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT00P3om^h20=@m6@03
0?ofkP3D?AT0ooK^0080e3dI00<0ooK^03eIZ`3om^h04P3om^h00`0mFJ/0ooK^03eIZ`0B0?ofkP04
03eIZ`3om^h0?EV[03eIZa40ooK^0P0mFJ/00`3om^h0?EV[03eIZ`0Y0?ofkP030000003om^h0ooK^
03<0ooK^0@3oool003D0ooK^00<000000?ofkP3om^h09P3om^i503eIZ`80e3dI00<0?EV[0=@m6@0m
FJ/00P3D?AT00`0mFJ/0e3dI03eIZ`0303eIZ`030=@m6@0mFJ/0?EV[00D0?EV[00<0e3dI0000000E
62l01P0E62l2000000L05AP_0P00000801DH;`030000000E62l05AP_00H05AP_00<0000001DH;`0E
62l01P0E62l00`0000005AP_01DH;`0701DH;`030000000E62l05AP_00H05AP_00<0000001DH;`0E
62l01P0E62l00`0000005AP_01DH;`0601DH;`030000000E62l05AP_00L05AP_00<0000001DH;`0E
62l01P0E62l00`0000005AP_01DH;`0601DH;`8000001`0E62l2000000L05AP_00<000000=@m6@0m
FJ/01P0mFJ/00`3D?AT0?EV[03eIZ`0203eIZ`<0e3dI0P0mFJ/0103D?AT0?EV[0=@m6@3D?AU503eI
ZbP0ooK^00<000000?ofkP3om^h0<`3om^h10?ooo`00=@3om^h00`000000ooK^0?ofkP0U0?ofkP05
03eIZ`3om^h0ooK^0?ofkP0000000`3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^
00<0ooK^00<0?EV[0?ofkP3om^h03P3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[0140ooK^00<0?EV[
0?ofkP3om^h00P3D?AT0103om^h0e3dI0?ofkP3om^h20=@m6@D0ooK^00<0e3dI0?ofkP3om^h00`3o
m^h00`0mFJ/0e3dI01DH;`0601DH;`800000200E62l00`0000005AP_01DH;`0601DH;`800000200E
62l00`0000005AP_01DH;`0701DH;`030000000E62l05AP_00H05AP_00<0000001DH;`0E62l01`0E
62l00`0000005AP_01DH;`0601DH;`030000000E62l05AP_00L05AP_00<0000001DH;`0E62l01P0E
62l00`0000005AP_01DH;`0701DH;`800000200E62l00`0000005AP_01DH;`0601DH;`8000001`0E
62l00`3D?AT0?EV[0?ofkP030?ofkP030=@m6@3om^h0ooK^00<0ooK^0`3D?AT20?ofkP040=@m6@3o
m^h0e3dI0=@m6@80ooK^00<0?EV[0?ofkP3om^h03`3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[0100
ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0503eIZ`3om^h0ooK^0?of
kP0000000`3om^h00`0mFJ/0ooK^0?ofkP0U0?ofkP030000003om^h0ooK^03<0ooK^0@3oool003@0
ooK^00<000000?ofkP3om^h09P3om^h01@0mFJ/0ooK^0?ofkP3om^h0000000<0ooK^00<0?EV[0?of
kP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?of
kP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00@0e3dI0P3om^h30=@m
6@D0ooK^00<0e3dI0?ofkP3om^h00P00000701DH;`800000200E62l2000000P05AP_00<0000001DH
;`0E62l0200E62l00`0000005AP_01DH;`0601DH;`030000000E62l05AP_00L05AP_00<0000001DH
;`0E62l01`0E62l00`0000005AP_01DH;`0701DH;`030000000E62l05AP_00H05AP_00<0000001DH
;`0E62l01`0E62l00`0000005AP_01DH;`0801DH;`030000000E62l05AP_00H05AP_0P00000801DH
;`8000001`0E62l200000080ooK^00<0e3dI0?ofkP3om^h00`3om^h30=@m6@80ooK^103D?AT20?of
kP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP0<0?of
kP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h02`3om^h01@0mFJ/0ooK^0?ofkP3om^h0
000000<0ooK^00<0?EV[0?ofkP3om^h09P3om^h00`000000ooK^0?ofkP0b0?ofkP40oooo000d0?of
kP030000003om^h0ooK^02D0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`000000ooK^0?ofkP020?of
kP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP0<0?of
kP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP020?of
kP80e3dI00@0ooK^0=@m6@3om^h0e3dI0P3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@000000
000008d0000000<0e3dI0?ofkP3om^h00P3om^h01`3D?AT0ooK^0=@m6@3D?AT0ooK^0=@m6@3om^h0
0P3D?AT40?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^
0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^
0?ofkP020?ofkP030000003om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h09@3om^h00`000000ooK^
0?ofkP0b0?ofkP40oooo000d0?ofkP030000003om^h0ooK^02D0ooK^00<0?EV[0?ofkP3om^h00P3o
m^h00`000000ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h01P3o
m^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h0303o
m^h00`0mFJ/0ooK^0?ofkP020?ofkP80e3dI00@0ooK^0=@m6@3om^h0e3dI0P3om^h00`3D?AT0ooK^
0?ofkP020?ofkP030=@m6@0N94L07RA700L07RA700<0000001hTA`0N94L01`0N94L00`0000007RA7
01hTA`0701hTA`030000000N94L07RA700P07RA700<0000001hTA`0N94L01P0N94L00`0mFJ/07RA7
0000000901hTA`030000000N94L07RA700L07RA700<0000001hTA`0N94L01`0N94L00`0000007RA7
01hTA`0701hTA`030000000N94L07RA700P07RA700<0000001hTA`0N94L0200N94L00`0000007RA7
01hTA`0701hTA`030000000N94L07RA700L07RA700<0000001hTA`0N94L01`0N94L01@3D?AT0ooK^
0?ofkP3om^h0e3dI00<0ooK^00@0e3dI0?ofkP3D?AT0ooK^0P3D?AT40?ofkP0303eIZ`3om^h0ooK^
00`0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^
00H0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP020?ofkP030000003om^h0ooK^
0080ooK^00<0?EV[0?ofkP3om^h09@3om^h00`000000ooK^0?ofkP0b0?ofkP40oooo000d0?ofkP03
0000003om^h0ooK^02@0ooK^B@0mFJ/01P3D?AT0?EV[0=@m6@3D?AT0?EV[0=@m6@<0?EV[00@0e3dI
03eIZ`0mFJ/0?EV[2@0N94L00`0000007RA701hTA`0701hTA`030000000N94L07RA700P07RA700<0
000001hTA`0N94L0200N94L00`0000007RA701hTA`0701hTA`030000000N94L07RA700P07RA700<0
000001hTA`0N94L01`0N94L00`0000007RA701hTA`0701hTA`030000000N94L07RA700P07RA700<0
000001hTA`0N94L01`0N94L00`0000007RA701hTA`0801hTA`030000000N94L07RA700P07RA700<0
000001hTA`0N94L01`0N94L00`0000007RA701hTA`0701hTA`<0?EV[00H0e3dI03eIZ`0mFJ/0?EV[
0=@m6@0mFJ/40=@m6DT0?EV[9P3om^h00`000000ooK^0?ofkP0b0?ofkP40oooo000d0?ofkP030000
003om^h0ooK^02@0ooK^00<0?EV[0?ofkP3om^h0103om^h00`000000ooK^0?ofkP020?ofkP0303eI
Z`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eI
Z`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP020?ofkP@0e3dI
00<0ooK^0=@m6@3om^h00`3om^h00`3D?AT0000001hTA`0801hTA`030000000N94L07RA700P07RA7
00<0000001hTA`0N94L01`0N94L00`0000007RA701hTA`0801hTA`030000000N94L07RA700P07RA7
00<0000001hTA`0N94L01`0N94L00`0000007RA701hTA`0801hTA`030000000N94L07RA700P07RA7
00<0000001hTA`0N94L01`0N94L00`0000007RA701hTA`0801hTA`030000000N94L07RA700P07RA7
00<0000001hTA`0N94L01`0N94L00`0000007RA701hTA`0801hTA`030000000N94L07RA700L07RA7
00<000000=@m6@3om^h00`3om^h00`3D?AT0ooK^0=@m6@030=@m6@@0ooK^00<0?EV[0?ofkP3om^h0
303om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h0
1`3om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^0080ooK^00<000000?ofkP3om^h0
103om^h00`0mFJ/0ooK^0?ofkP0T0?ofkP030000003om^h0ooK^0380ooK^0@3oool003<0ooK^00<0
00000?ofkP3om^h0903om^h00`0mFJ/0ooK^0?ofkP050?ofkP030000003om^h0ooK^00<0ooK^00<0
?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0
?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00<0ooK^1P3D
?AT30?ofkP030000003D?AT0e3dI00P07RA700<0000001hTA`0N94L0200N94L00`0000007RA701hT
A`0801hTA`030000000N94L07RA700P07RA700<0000001hTA`0N94L01`0N94L00`0000007RA701hT
A`0801hTA`030000000N94L07RA700P07RA700<0000001hTA`0N94L0200N94L00`0000007RA701hT
A`0801hTA`030000000N94L07RA700L07RA700<0000001hTA`0N94L0200N94L00`0000007RA701hT
A`0801hTA`030000000N94L07RA700P07RA700<0000001hTA`0N94L01P0N94L20=@m6@040000003o
m^h0ooK^0?ofkPH0e3dI103om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00H0ooK^
00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00H0ooK^
00<0?EV[0?ofkP3om^h00`3om^h00`000000ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^02@0ooK^
00<000000?ofkP3om^h0<@3om^h10?ooo`00<`3om^h00`000000ooK^0?ofkP0T0?ofkP0303eIZ`3o
m^h0ooK^00D0ooK^00<000000?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3o
m^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3o
m^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h00`3om^h20=@m6@0403eIZ`3D?AT0e3dI0=@m6@80ooK^
0P0000000`3D?AT000000=@m6@2A000000030=@m6@000000e3dI008000000P3om^h30=@m6@0303eI
Z`3D?AT0e3dI00D0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eI
Z`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eI
Z`3om^h0ooK^00<0ooK^00<000000?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP0T0?ofkP030000
003om^h0ooK^0340ooK^0@3oool003<0ooK^00<000000?ofkP3om^h08`3om^h00`0mFJ/0ooK^0?of
kP070?ofkP030000003om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?of
kP0:0?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?of
kP0:0?ofkP0303eIZ`3om^h0ooK^00<0ooK^0P3D?AT01P0mFJ/0e3dI0=@m6@3om^h0e3dI00000080
:CEX00@0e3dI02TeJ00Y=FP0e3dI0`0Y=FP00`0mFJ/0:CEX0000000:02TeJ0030000000Y=FP0:CEX
00H0:CEX00<0?EV[02TeJ00000002P0Y=FP00`000000:CEX02TeJ00802TeJ0030000000Y=FP0:CEX
00P0:CEX00<0000002TeJ00Y=FP0200Y=FP00`000000:CEX02TeJ00802TeJ0030000000Y=FP0:CEX
00P0:CEX00<0000002TeJ00Y=FP0200Y=FP00`000000:CEX02TeJ00802TeJ0030000000Y=FP0:CEX
00P0:CEX00<0000002TeJ00Y=FP0200Y=FP00`000000:CEX02TeJ00302TeJ0040=@m6@0Y=FP0:CEX
0=@m6@80:CEX00<000000=@m6@3om^h00P3D?AT00`0mFJ/0e3dI0=@m6@050?ofkP0303eIZ`3om^h0
ooK^00X0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0
ooK^00X0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP020?ofkP030000003om^h0
ooK^00H0ooK^00<0?EV[0?ofkP3om^h0903om^h00`000000ooK^0?ofkP0a0?ofkP40oooo000c0?of
kP030000003om^h0ooK^02<0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`000000ooK^0?ofkP020?of
kP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP070?of
kP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP030?of
kP80e3dI00H0?EV[0?ofkP3D?AT0ooK^0=@m6@00000202TeJ0050=@m6@0Y=FP0:CEX02TeJ03D?AT0
0`0Y=FP00`000000:CEX02TeJ00802TeJ0030000000Y=FP0:CEX00P0:CEX00<0000002TeJ00Y=FP0
200Y=FP00`000000:CEX02TeJ00902TeJ0030000000Y=FP0:CEX00P0:CEX00<0000002TeJ00Y=FP0
200Y=FP00`000000:CEX02TeJ00802TeJ0030000000Y=FP0:CEX00P0:CEX00<0000002TeJ00Y=FP0
2@0Y=FP00`000000:CEX02TeJ00802TeJ0030000000Y=FP0:CEX00P0:CEX00<0000002TeJ00Y=FP0
200Y=FP01@000000:CEX02TeJ00Y=FP0e3dI00<0:CEX00T0e3dI02TeJ00Y=FP000000=@m6@3om^h0
e3dI0?ofkP0mFJ/00P3D?AT50?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h01`3o
m^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h01@3o
m^h00`0mFJ/0ooK^0?ofkP020?ofkP030000003om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h08`3o
m^h00`000000ooK^0?ofkP0a0?ofkP40oooo000c0?ofkP030000003om^h0ooK^02<0ooK^00<0?EV[
0?ofkP3om^h01`3om^h00`000000ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[
0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[
0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP050?ofkP060=@m6@3om^h0e3dI0=@m6@3om^h0e3dI
100Y=FP01@3D?AT0:CEX02TeJ00Y=FP0e3dI0080:CEX00<0000002TeJ00Y=FP0200Y=FP00`000000
:CEX02TeJ00802TeJ0030000000Y=FP0:CEX00P0:CEX00<0000002TeJ00Y=FP02@0Y=FP00`000000
:CEX02TeJ00802TeJ0030000000Y=FP0:CEX00P0:CEX00<0000002TeJ00Y=FP0200Y=FP00`000000
:CEX02TeJ00802TeJ0030000000Y=FP0:CEX00T0:CEX00<0000002TeJ00Y=FP0200Y=FP00`000000
:CEX02TeJ00802TeJ0030000000Y=FP0:CEX00P0:CEX00@0000002TeJ00Y=FP0e3dI0`0Y=FP00`3D
?AT0:CEX02TeJ00202TeJ0060=@m6@3om^h0e3dI0=@m6@3om^h0e3dI1P3om^h00`0mFJ/0ooK^0?of
kP090?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?of
kP0;0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`000000ooK^0?of
kP070?ofkP0303eIZ`3om^h0ooK^02<0ooK^00<000000?ofkP3om^h0<@3om^h10?ooo`00<P3om^h0
0`000000ooK^0?ofkP0S0?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<000000?ofkP3om^h00`3om^hl
03eIZ`030=@m6@0mFJ/0e3dI00<0e3dI100Y=FP00`3D?AT0:CEX02TeJ00202TeJ080e3dI2P0Y=FP0
0`000000:CEX02TeJ00902TeJ0030000000Y=FP0:CEX00P0:CEX00<0000002TeJ00Y=FP0200Y=FP0
0`000000:CEX02TeJ00802TeJ0030000000Y=FP0:CEX00T0:CEX00<0000002TeJ00Y=FP02@0Y=FP0
0`000000:CEX02TeJ00802TeJ0030000000Y=FP0:CEX00P0:CEX00<0000002TeJ00Y=FP0200Y=FP0
0`000000:CEX02TeJ00902TeJ0030000000Y=FP0:CEX00P0:CEX0P3D?AT402TeJ0030=@m6@0Y=FP0
:CEX0080:CEX103D?AT00`0mFJ/0e3dI03eIZ`0k03eIZ`D0ooK^00<000000?ofkP3om^h0203om^h0
0`0mFJ/0ooK^0?ofkP0S0?ofkP030000003om^h0ooK^0300ooK^0@3oool00380ooK^00<000000?of
kP3om^h08`3om^i=03eIZ`030=@m6@0mFJ/0e3dI00<0e3dI100Y=FP00`3D?AT0:CEX02TeJ00302Te
J0030000003D?AT0:CEX00P0:CEX00<0000002TeJ00Y=FP02@0Y=FP00`000000:CEX02TeJ00802Te
J0030000000Y=FP0:CEX00P0:CEX00<0000002TeJ00Y=FP0200Y=FP00`000000:CEX02TeJ00902Te
J0030000000Y=FP0:CEX00T0:CEX00<0000002TeJ00Y=FP0200Y=FP00`000000:CEX02TeJ00802Te
J0030000000Y=FP0:CEX00P0:CEX00<0000002TeJ00Y=FP02@0Y=FP00`000000:CEX02TeJ00702Te
J0030=@m6@000000:CEX00@0:CEX00<0e3dI02TeJ00Y=FP00P0Y=FP60=@m6Dd0?EV[9@3om^h00`00
0000ooK^0?ofkP0`0?ofkP40oooo000b0?ofkP030000003om^h0ooK^02<0ooK^00<0?EV[0?ofkP3o
m^h02@3om^h00`000000ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3o
m^h0303om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3o
m^h0203om^h00`0mFJ/0ooK^0?ofkP050?ofkP@0e3dI00<000000=@m6@0Y=FP00`0Y=FP00`3D?AT0
:CEX02TeJ00202TeJ0040000000Y=FP0:CEX0=@m6@L0:CEX00<0000002TeJ00Y=FP02@0Y=FP00`00
0000:CEX02TeJ00802TeJ0030000000Y=FP0:CEX00T0:CEX00<0000002TeJ00Y=FP0200Y=FP00`00
0000:CEX02TeJ00902TeJ0030000000Y=FP0:CEX00T0:CEX00<0000002TeJ00Y=FP0200Y=FP00`00
0000:CEX02TeJ00902TeJ0030000000Y=FP0:CEX00P0:CEX00<0000002TeJ00Y=FP02@0Y=FP00`00
0000:CEX02TeJ00502TeJ0040=@m6@0Y=FP0:CEX000000@0:CEX00<0e3dI02TeJ00Y=FP00P0Y=FP0
0`3D?AT000000=@m6@030=@m6@L0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP09
0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP03
0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<000000?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP0S
0?ofkP030000003om^h0ooK^0300ooK^0@3oool00380ooK^00<000000?ofkP3om^h08`3om^h00`0m
FJ/0ooK^0?ofkP090?ofkP030000003om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0m
FJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0m
FJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00D0ooK^0P3D?AT0100mFJ/0e3dI0000003D?AT4
000000030=@m6@000000000000H0000000<0e3dI000000000000O`0000000`3D?AT0000000000006
000000030=@m6@00000000000080000000@0e3dI0000003D?AT0?EV[0P3D?AT70?ofkP0303eIZ`3o
m^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3o
m^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP030000003o
m^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h08`3om^h00`000000ooK^0?ofkP0`0?ofkP40oooo000b
0?ofkP030000003om^h0ooK^0280ooK^00<0?EV[0?ofkP3om^h02P3om^h00`000000ooK^0?ofkP03
0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/0403om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3o
m^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP050?ofkP80e3dI00D0
?EV[0000003D?AT0<45o0=@m6@030311O`030=@m6@0`@Gl0<45o0080<45o00<000000311O`0`@Gl0
0P0`@Gl00`3D?AT0<45o0311O`030311O`030000000`@Gl0<45o00T0<45o00<000000311O`0`@Gl0
200`@Gl00`000000<45o0311O`090311O`030000000`@Gl0<45o00P0<45o00<000000311O`0`@Gl0
2@0`@Gl00`000000<45o0311O`090311O`030000000`@Gl0<45o00P0<45o00<000000311O`0`@Gl0
2@0`@Gl00`000000<45o0311O`080311O`030000000`@Gl0<45o00T0<45o00<000000311O`0`@Gl0
0`0`@Gl00`3D?AT0<45o0311O`020311O`030000000`@Gl0<45o0080<45o00T0e3dI0311O`0`@Gl0
<45o0=@m6@0`@Gl0e3dI0000000mFJ/00P3D?AT70?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[
0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[
0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP030000003om^h0ooK^00T0ooK^00<0?EV[
0?ofkP3om^h08`3om^h00`000000ooK^0?ofkP0`0?ofkP40oooo000a0?ofkP030000003om^h0ooK^
02<0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`000000ooK^0?ofkP030?ofkP0503eIZ`3om^h0ooK^
0?ofkP0mFJ/0403om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[
0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP050?ofkP80e3dI00<0?EV[0000003D?AT00P0`@Gl0
103D?AT0<45o0311O`3D?AT40311O`030000000`@Gl0<45o00<0<45o00<0e3dI0311O`0`@Gl00P0`
@Gl00`000000<45o0311O`090311O`030000000`@Gl0<45o00P0<45o00<000000311O`0`@Gl02@0`
@Gl00`000000<45o0311O`080311O`030000000`@Gl0<45o00T0<45o00<000000311O`0`@Gl02@0`
@Gl00`000000<45o0311O`080311O`030000000`@Gl0<45o00T0<45o00<000000311O`0`@Gl0200`
@Gl00`000000<45o0311O`090311O`030000000`@Gl0<45o0080<45o00<0e3dI0311O`0`@Gl00`0`
@Gl00`000000<45o0311O`020311O`040=@m6@0`@Gl0<45o0=@m6@80<45o00<0e3dI0000003om^h0
0P3D?AT70?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^
0?ofkP030?ofkP0303eIZ`3om^h0ooK^00h0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`050?ofkP03
0000003om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h08`3om^h00`000000ooK^0?ofkP0_0?ofkP40
oooo000a0?ofkP030000003om^h0ooK^02<0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`000000ooK^
0?ofkP020?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/0403om^h00`0mFJ/0ooK^0?ofkP030?ofkP03
03eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP050?ofkP80
e3dI00<000000311O`3D?AT00P0`@Gl0103D?AT0<45o0311O`3D?AT30311O`030000000`@Gl0<45o
00@0<45o0`3D?AT20311O`030000000`@Gl0<45o00T0<45o00<000000311O`0`@Gl0200`@Gl00`00
0000<45o0311O`090311O`030000000`@Gl0<45o00P0<45o00<000000311O`0`@Gl02@0`@Gl00`00
0000<45o0311O`090311O`030000000`@Gl0<45o00P0<45o00<000000311O`0`@Gl02@0`@Gl00`00
0000<45o0311O`080311O`030000000`@Gl0<45o00T0<45o00<000000311O`0`@Gl00`3D?AT60311
O`050000000`@Gl0<45o0311O`3D?AT00P0`@Gl01P3D?AT0<45o0311O`3D?AT0<45o00000080e3dI
1`3om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h0
0`3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/0103om^h00`000000
ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^02<0ooK^00<000000?ofkP3om^h0;`3om^h10?ooo`00
<@3om^h00`000000ooK^0?ofkP0S0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<000000?ofkP3om^h0
0P3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[0100ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0
ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h01P3om^h30=@m6@03
0311O`3D?AT0<45o0080<45o00<0e3dI0311O`3D?AT00`0`@Gl00`000000<45o0311O`040311O`03
0=@m6@0`@Gl0<45o0080e3dI00<000000311O`0`@Gl02@0`@Gl00`000000<45o0311O`080311O`03
0000000`@Gl0<45o00T0<45o00<000000311O`0`@Gl0200`@Gl00`000000<45o0311O`090311O`03
0000000`@Gl0<45o00T0<45o00<000000311O`0`@Gl0200`@Gl00`000000<45o0311O`090311O`03
0000000`@Gl0<45o00P0<45o00<000000311O`0`@Gl02@0`@Gl00`000000e3dI0=@m6@020311O`03
0=@m6@0`@Gl0<45o00@0<45o00L000000311O`0`@Gl0<45o0=@m6@0`@Gl0e3dI00<0<45o00@0e3dI
0311O`3D?AT0e3dI203om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0
?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/0
103om^h00`000000ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^02<0ooK^00<000000?ofkP3om^h0
;`3om^h10?ooo`00<@3om^h00`000000ooK^0?ofkP0S0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0
00000?ofkP3om^h00`3om^h0100mFJ/0ooK^0?ofkP0mFJ/A0?ofkP0303eIZ`3om^h0ooK^0080ooK^
00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00L0ooK^
0P3D?AT00`0`@Gl0e3dI0311O`030311O`030=@m6@0`@Gl0e3dI0080<45o00<000000311O`0`@Gl0
100`@Gl01@3D?AT0<45o0311O`0`@Gl000000080e3dI2@0`@Gl00`000000<45o0311O`090311O`03
0000000`@Gl0<45o00P0<45o00<000000311O`0`@Gl02@0`@Gl00`000000<45o0311O`090311O`03
0000000`@Gl0<45o00T0<45o00<000000311O`0`@Gl02@0`@Gl00`000000<45o0311O`080311O`03
0000000`@Gl0<45o00T0<45o00<000000311O`0`@Gl01`0`@Gl20=@m6@050000000`@Gl0<45o0311
O`3D?AT01P0`@Gl01P000000<45o0311O`3D?AT0<45o0=@m6@@0<45o00@0e3dI0311O`3D?AT0e3dI
2@3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h0
0P3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0403eIZ`3om^h0ooK^03eIZ`D0ooK^00<000000?ofkP3o
m^h02`3om^h00`0mFJ/0ooK^0?ofkP0S0?ofkP030000003om^h0ooK^02l0ooK^0@3oool00340ooK^
00<000000?ofkP3om^h08`3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP030000003om^h0ooK^00<0ooK^
00@0?EV[0?ofkP3om^h0?EV[4@3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00`0
ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP070?ofkP80e3dI00<0<45o0=@m6@0`
@Gl00`0`@Gl00`3D?AT0<45o0=@m6@020311O`030000000`@Gl0<45o00@0<45o00D0e3dI0311O`0`
@Gl0<45o000000020311O`030=@m6@0`@Gl0<45o00H0<45o00<000000311O`0`@Gl02@0`@Gl00`00
0000<45o0311O`080311O`030000000`@Gl0<45o00T0<45o00<000000311O`0`@Gl02@0`@Gl00`00
0000<45o0311O`090311O`030000000`@Gl0<45o00T0<45o00<000000311O`0`@Gl0200`@Gl00`00
0000<45o0311O`090311O`030000000`@Gl0<45o00H0<45o00@0e3dI0311O`0`@Gl000000`0`@Gl0
0`3D?AT0<45o0311O`040311O`060000000`@Gl0<45o0=@m6@0`@Gl0e3dI100`@Gl0103D?AT0<45o
0=@m6@3D?AT90?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0
ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00l0ooK^00@0?EV[0?ofkP3om^h0?EV[1@3om^h00`00
0000ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^02<0ooK^00<000000?ofkP3om^h0;`3om^h10?oo
o`00<03om^h00`000000ooK^0?ofkP0S0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<000000?ofkP3o
m^h00`3om^hk03eIZ`@0e3dI1@0`@Gl20=@m6@030311O`000000<45o00L0<45o00@0e3dI0311O`0`
@Gl000000`0`@Gl20=@m6@H0<45o00<000000311O`0`@Gl02@0`@Gl00`000000<45o0311O`080311
O`030000000`@Gl0<45o00T0<45o00<000000311O`0`@Gl02@0`@Gl00`000000<45o0311O`090311
O`030000000`@Gl0<45o00T0<45o00<000000311O`0`@Gl0200`@Gl00`000000<45o0311O`090311
O`030000000`@Gl0<45o00@0<45o0P3D?AT30311O`040000000`@Gl0<45o0=@m6@P0<45o00@00000
0311O`3D?AT0e3dI1@0`@Gl40=@m6C/0?EV[1@3om^h00`000000ooK^0?ofkP0;0?ofkP0303eIZ`3o
m^h0ooK^02@0ooK^00<000000?ofkP3om^h0;P3om^h10?ooo`00<03om^h00`000000ooK^0?ofkP0S
0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<000000?ofkP3om^h00P3om^h00`0mFJ/0ooK^03eIZ`0B
0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/03`3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3o
m^h0ooK^00L0ooK^103D?AT50311O`80e3dI00<0<45o0000000`@Gl01`0`@Gl0103D?AT0<45o0311
O`0000050311O`80e3dI100`@Gl00`000000<45o0311O`090311O`030000000`@Gl0<45o00P0<45o
00<000000311O`0`@Gl02@0`@Gl00`000000<45o0311O`090311O`030000000`@Gl0<45o00T0<45o
00<000000311O`0`@Gl02@0`@Gl00`000000<45o0311O`080311O`030000000`@Gl0<45o00T0<45o
00<000000311O`0`@Gl00P0`@Gl20=@m6@D0<45o00@000000311O`0`@Gl0e3dI200`@Gl010000000
<45o0=@m6@3D?AT50311O`@0e3dI2@3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^
00d0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0B0?ofkP0303eIZ`3om^h0?EV[00@0ooK^00<00000
0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0S0?ofkP030000003om^h0ooK^02h0ooK^0@3oool0
0300ooK^00<000000?ofkP3om^h08`3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP030000003om^h0ooK^
0080ooK^00<0?EV[0?ofkP0mFJ/04P3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00l0ooK^00<0?EV[
0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP070?ofkP<0e3dI00<000000=@m6@00000010000000
0`3D?AT0000000000008000000030=@m6@000000000000P000000P3D?AUS00000080e3dI2P000000
0`3D?AT0000000000008000000030=@m6@000000000000<0000000<0e3dI0000003D?AT00P3D?AT9
0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h03@3om^h01@0mFJ/0ooK^0?ofkP3o
m^h0?EV[0180ooK^00<0?EV[0?ofkP0mFJ/0103om^h00`000000ooK^0?ofkP0=0?ofkP0303eIZ`3o
m^h0ooK^02<0ooK^00<000000?ofkP3om^h0;P3om^h10?ooo`00<03om^h00`000000ooK^0?ofkP0S
0?ofkU00?EV[0P3D?AT00`0fBY00e3dI0=@m6@0503I:T080e3dI00<0000003I:T00fBY001P0fBY00
103D?AT0=TZ@03I:T000000903I:T080e3dI00<0000003I:T00fBY002@0fBY000`000000=TZ@03I:
T00803I:T0030000000fBY00=TZ@00T0=TZ@00<0000003I:T00fBY002@0fBY000`000000=TZ@03I:
T00903I:T0030000000fBY00=TZ@00T0=TZ@00<0000003I:T00fBY00200fBY000`000000=TZ@03I:
T00903I:T0030000003D?AT0e3dI00T0=TZ@00@0000003I:T00fBY00e3dI1`0fBY00100mFJ/00000
0=@m6@3D?AT503I:T080e3dI00<0=TZ@0=@m6@3D?AT0D00mFJ/U0?ofkP030000003om^h0ooK^02h0
ooK^0@3oool00300ooK^00<000000?ofkP3om^h08`3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP030000
003om^h0ooK^00<0ooK^0P0mFJ/B0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/03`3om^h00`0mFJ/0
ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00L0ooK^0P3D?AT00`0fBY00e3dI0=@m6@0503I:T003
0=@m6@0fBY00e3dI00P0=TZ@00@0e3dI03I:T00fBY0000002`0fBY020=@m6@X0=TZ@00<0000003I:
T00fBY00200fBY000`000000=TZ@03I:T00903I:T0030000000fBY00=TZ@00T0=TZ@00<0000003I:
T00fBY002@0fBY000`000000=TZ@03I:T00903I:T0030000000fBY00=TZ@00P0=TZ@00<0000003I:
T00fBY00200fBY020=@m6@/0=TZ@00@0000003I:T00fBY00e3dI200fBY000`3D?AT0=TZ@0=@m6@05
03I:T080e3dI00<0=TZ@0=@m6@3D?AT02@3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0
ooK^00d0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0B0?ofkP80?EV[1@3om^h00`000000ooK^0?of
kP0=0?ofkP0303eIZ`3om^h0ooK^02<0ooK^00<000000?ofkP3om^h0;P3om^h10?ooo`00;`3om^h0
0`000000ooK^0?ofkP0T0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<000000?ofkP3om^h00P3om^h2
03eIZa80ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0?0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0
?EV[0?ofkP3om^h01`3om^h20=@m6@80=TZ@00<0e3dI03I:T00fBY000`0fBY000`3D?AT0=TZ@0000
00020=@m6@H0=TZ@00@0e3dI03I:T00fBY0000002`0fBY000`3D?AT0=TZ@0=@m6@020=@m6@L0=TZ@
00<0000003I:T00fBY00200fBY000`000000=TZ@03I:T00903I:T0030000000fBY00=TZ@00T0=TZ@
00<0000003I:T00fBY002@0fBY000`000000=TZ@03I:T00903I:T0030000000fBY00=TZ@00P0=TZ@
00<0000003I:T00fBY001@0fBY030=@m6@0303I:T03D?AT0=TZ@00X0=TZ@00@0000003I:T00fBY00
e3dI1P0fBY020=@m6@030000000fBY00e3dI00D0=TZ@00D0e3dI03I:T00fBY00e3dI000000090?of
kP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h03@3om^h01@0mFJ/0ooK^0?ofkP3om^h0
?EV[0180ooK^0P0mFJ/40?ofkP030000003om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h0903om^h0
0`000000ooK^0?ofkP0]0?ofkP40oooo000_0?ofkP030000003om^h0ooK^02@0ooK^00<0?EV[0?of
kP3om^h03P3om^h00`000000ooK^0?ofkP020?ofkP80?EV[4P3om^h01@0mFJ/0ooK^0?ofkP3om^h0
?EV[00l0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP070?ofkP050000003D?AT0
=TZ@03I:T03D?AT01@0fBY000`3D?AT0=TZ@0000000203I:T0030=@m6@0fBY00=TZ@00<0=TZ@00@0
e3dI03I:T00fBY0000002`0fBY000`3D?AT0=TZ@03I:T00203I:T0<0e3dI100fBY000`000000=TZ@
03I:T00803I:T0030000000fBY00=TZ@00T0=TZ@00<0000003I:T00fBY002@0fBY000`000000=TZ@
03I:T00903I:T0030000000fBY00=TZ@00T0=TZ@00<0000003I:T00fBY00200fBY000`000000=TZ@
03I:T00203I:T0<0e3dI100fBY000`3D?AT0=TZ@03I:T00903I:T0040000000fBY00=TZ@0=@m6@D0
=TZ@00D0e3dI03I:T00fBY0000000=@m6@0603I:T0050=@m6@0fBY00=TZ@0=@m6@0000002@3om^h0
0`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00h0ooK^00@0?EV[0?ofkP3om^h0?EV[4`3o
m^h203eIZ`@0ooK^00<000000?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0T0?ofkP030000003o
m^h0ooK^02d0ooK^0@3oool002l0ooK^00<000000?ofkP3om^h08`3om^h00`0mFJ/0ooK^0?ofkP0?
0?ofkP030000003om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h04P3om^h0100mFJ/0ooK^0?ofkP0m
FJ/@0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h01`3om^h010000000e3dI03I:
T00fBY020=@m6@D0=TZ@00<0e3dI0000000fBY000P0fBY000`3D?AT0=TZ@03I:T00203I:T0040=@m
6@0fBY00=TZ@000000/0=TZ@00<0e3dI03I:T00fBY001@0fBY030=@m6@0303I:T0000000=TZ@00T0
=TZ@00<0000003I:T00fBY002@0fBY000`000000=TZ@03I:T00903I:T0030000000fBY00=TZ@00T0
=TZ@00<0000003I:T00fBY002@0fBY000`000000=TZ@03I:T00803I:T0030000000fBY00e3dI0080
e3dI1`0fBY000`3D?AT0=TZ@03I:T00903I:T0040000000fBY00=TZ@0=@m6@@0=TZ@00H0e3dI03I:
T00fBY00=TZ@0000003D?AT503I:T080e3dI0P0fBY000`3D?AT000000?ofkP080?ofkP0303eIZ`3o
m^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h03P3om^h0100mFJ/0ooK^0?ofkP0mFJ/D0?ofkP0303eI
Z`3om^h0ooK^0080ooK^00<000000?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP0S0?ofkP030000
003om^h0ooK^02d0ooK^0@3oool002l0ooK^00<000000?ofkP3om^h08`3om^h00`0mFJ/0ooK^0?of
kP0?0?ofkP030000003om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h04P3om^h0100mFJ/0ooK^0?of
kP0mFJ/@0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h0203om^h00`3D?AT0=TZ@
03I:T0020=@m6@D0=TZ@00<0e3dI0000000fBY000`0fBY000`3D?AT0=TZ@03I:T00203I:T0030=@m
6@0fBY00000000/0=TZ@00<0e3dI03I:T00fBY00200fBY030=@m6@T0=TZ@00<0000003I:T00fBY00
2@0fBY000`000000=TZ@03I:T00903I:T0030000000fBY00=TZ@00T0=TZ@00<0000003I:T00fBY00
2@0fBY000`000000=TZ@03I:T00703I:T0<0e3dI2P0fBY000`3D?AT0=TZ@03I:T00903I:T0030000
000fBY00e3dI00@0=TZ@00<0e3dI03I:T00fBY000P0fBY000`000000e3dI03I:T00403I:T080e3dI
0P0fBY000`3D?AT0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h0
3P3om^h0100mFJ/0ooK^0?ofkP0mFJ/D0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<000000?ofkP3o
m^h03`3om^h00`0mFJ/0ooK^0?ofkP0S0?ofkP030000003om^h0ooK^02d0ooK^0@3oool002l0ooK^
00<000000?ofkP3om^h08`3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP050000003om^h0ooK^0?ofkP0m
FJ/0503om^h0100mFJ/0ooK^0?ofkP0mFJ/@0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?of
kP3om^h0203om^h01P3D?AT0=TZ@03I:T03D?AT0=TZ@0=@m6@@0=TZ@00<0e3dI0000000fBY00100f
BY001`3D?AT0=TZ@03I:T00fBY00e3dI03I:T00000002`0fBY000`3D?AT0=TZ@03I:T00903I:T003
0000000fBY00e3dI0080e3dI1P0fBY000`000000=TZ@03I:T00903I:T0030000000fBY00=TZ@00T0
=TZ@00<0000003I:T00fBY002@0fBY000`000000=TZ@03I:T00903I:T0030000000fBY00=TZ@00@0
=TZ@0`3D?AT00`0fBY00000003I:T00:03I:T0030=@m6@0fBY00=TZ@00T0=TZ@00<0000003I:T03D
?AT00`0fBY000`3D?AT0=TZ@03I:T00303I:T0030000003D?AT0=TZ@00<0=TZ@00<0e3dI03I:T03D
?AT00P0fBY000`3D?AT0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3o
m^h03P3om^h0100mFJ/0ooK^0?ofkP0mFJ/C0?ofkP80?EV[0`3om^h00`000000ooK^0?ofkP0@0?of
kP0303eIZ`3om^h0ooK^02<0ooK^00<000000?ofkP3om^h0;@3om^h10?ooo`00;P3om^h00`000000
ooK^0?ofkP0T0?ofkP0303eIZ`3om^h0ooK^0100ooK^00@000000?ofkP3om^h0ooK^0P0mFJ/C0?of
kP0303eIZ`3om^h0?EV[0140ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP090?of
kP070=@m6@0fBY00=TZ@03I:T03D?AT0=TZ@0=@m6@0303I:T0030=@m6@000000=TZ@00D0=TZ@0P3D
?AT0100fBY00e3dI03I:T000000;03I:T0030=@m6@0fBY00=TZ@00T0=TZ@00<0000003I:T00fBY00
0P0fBY050=@m6@0303I:T0000000=TZ@00X0=TZ@00<0000003I:T00fBY002@0fBY000`000000=TZ@
03I:T00903I:T0030000000fBY00=TZ@00T0=TZ@00<0000003I:T03D?AT0103D?AT403I:T0030000
000fBY00=TZ@00T0=TZ@00<0e3dI03I:T00fBY002@0fBY0010000000=TZ@0=@m6@0fBY020=@m6@H0
=TZ@00<000000=@m6@0fBY000P0fBY000`3D?AT0=TZ@0=@m6@0303I:T0030=@m6@3om^h0ooK^00P0
ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0403eIZ`3om^h0ooK^03eI
Za<0ooK^0P0mFJ/30?ofkP030000003om^h0ooK^0100ooK^00<0?EV[0?ofkP3om^h0903om^h00`00
0000ooK^0?ofkP0/0?ofkP40oooo000^0?ofkP030000003om^h0ooK^02@0ooK^00<0?EV[0?ofkP3o
m^h0403om^h010000000ooK^0?ofkP3om^h203eIZa<0ooK^00<0?EV[0?ofkP0mFJ/04@3om^h00`0m
FJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00T0ooK^0P3D?AT203I:T0030=@m6@0fBY00e3dI
00<0=TZ@00<0e3dI0000000fBY001`0fBY020=@m6@0303I:T0000000=TZ@00X0=TZ@00<0e3dI03I:
T00fBY002@0fBY000`000000=TZ@03I:T00303I:T0040=@m6@0fBY00=TZ@03I:T0H0e3dI1`0fBY00
0`000000=TZ@03I:T00903I:T0030000000fBY00=TZ@00T0=TZ@00<0000003I:T00fBY001@0fBY06
0=@m6@<0=TZ@00<0e3dI03I:T00fBY000`0fBY000`000000=TZ@03I:T00903I:T0030=@m6@0fBY00
=TZ@00T0=TZ@00@0000003I:T03D?AT0e3dI200fBY000`000000e3dI03I:T00203I:T0030=@m6@0f
BY00e3dI0080=TZ@0P3D?AT;0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h03`3o
m^h00`0mFJ/0ooK^03eIZ`0C0?ofkP80?EV[0`3om^h00`000000ooK^0?ofkP0@0?ofkP0303eIZ`3o
m^h0ooK^02@0ooK^00<000000?ofkP3om^h0;03om^h10?ooo`00;P3om^ko000009P00000;P3om^h1
0?ooo`00;P3om^h00`000000ooK^0?ofkP0T0?ofkP0303eIZ`3om^h0ooK^0100ooK^00@000000?of
kP3om^h0ooK^0P0mFJ/C0?ofkP0303eIZ`3om^h0?EV[0140ooK^00<0?EV[0?ofkP3om^h00`3om^h0
0`0mFJ/0ooK^0?ofkP090?ofkP050000003D?AT0e3dI0000003D?AT00`0000000`3D?AT000000=@m
6@0:000000<0e3dI300000000`3D?AT000000000000>000000030=@m6@000000000000d000006`3D
?AT?000000030=@m6@000000000000h0000000<0e3dI0000000000002P0000030=@m6@X0000000<0
e3dI0000003D?AT00`0000001@3D?AT000000=@m6@3D?AT0000000/0ooK^00<0?EV[0?ofkP3om^h0
0`3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0?EV[01<0ooK^0P0mFJ/30?ofkP030000
003om^h0ooK^0100ooK^00<0?EV[0?ofkP3om^h0903om^h00`000000ooK^0?ofkP0/0?ofkP40oooo
000_0?ofkP030000003om^h0ooK^0280ooK^00<0?EV[0?ofkP3om^h04P3om^h01@000000ooK^03eI
Z`3om^h0?EV[01<0ooK^00<0?EV[0?ofkP0mFJ/04@3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eI
Z`3om^h0ooK^00T0ooK^00D000000=@m6@3D?AT0>U2M0=@m6@0303Y@W@040=@m6@0jD9d0e3dI0000
00T0>U2M00<0e3dI03Y@W@0000000P3D?AT903Y@W@030000003D?AT0>U2M00T0>U2M00<0000003Y@
W@0jD9d00`0jD9d00`3D?AT0>U2M03Y@W@0203Y@W@030000000jD9d0>U2M00T0>U2M00<0000003Y@
W@3D?AT02@0jD9d00`000000>U2M03Y@W@0703Y@W@030=@m6@0jD9d0000000/0>U2M00<0000003Y@
W@0jD9d00P0jD9d00`3D?AT0>U2M03Y@W@0303Y@W@030000000jD9d0>U2M00P0>U2M00<0e3dI0000
000jD9d0200jD9d20=@m6@030000000jD9d0e3dI00T0>U2M00@0e3dI03Y@W@0jD9d0e3dI0`0jD9d0
1@3D?AT0>U2M0=@m6@3D?AT0000000/0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?of
kP0?0?ofkP0303eIZ`3om^h0?EV[01<0ooK^00D0?EV[0?ofkP0mFJ/0ooK^0000000D0?ofkP0303eI
Z`3om^h0ooK^0280ooK^00<000000?ofkP3om^h0;@3om^h10?ooo`00;`3om^h00`000000ooK^0?of
kP0R0?ofkP0303eIZ`3om^h0ooK^0180ooK^00D000000?ofkP0mFJ/0ooK^03eIZ`0C0?ofkP0303eI
Z`3om^h0?EV[0140ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP090?ofkP050000
003D?AT0e3dI03Y@W@3D?AT0100jD9d00`3D?AT0>U2M0=@m6@0903Y@W@030=@m6@0jD9d000000080
>U2M00<0e3dI03Y@W@0jD9d01P0jD9d00`000000e3dI03Y@W@0903Y@W@030000000jD9d0>U2M00<0
>U2M00<0e3dI03Y@W@0jD9d00P0jD9d00`000000>U2M03Y@W@0903Y@W@030000000jD9d0e3dI00T0
>U2M00<0000003Y@W@0jD9d01`0jD9d00`3D?AT0>U2M0000000;03Y@W@030000000jD9d0>U2M0080
>U2M00<0e3dI03Y@W@0jD9d00`0jD9d00`000000>U2M03Y@W@0803Y@W@030=@m6@000000>U2M00L0
>U2M00H0e3dI03Y@W@0jD9d0000003Y@W@3D?AT803Y@W@040000003D?AT0>U2M0=@m6@@0>U2M0P3D
?AT00`0jD9d0e3dI0000000;0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h03`3o
m^h00`0mFJ/0ooK^03eIZ`0C0?ofkP0503eIZ`3om^h0?EV[0?ofkP000000503om^h00`0mFJ/0ooK^
0?ofkP0R0?ofkP030000003om^h0ooK^02d0ooK^0@3oool002l0ooK^00<000000?ofkP3om^h08P3o
m^h00`0mFJ/0ooK^0?ofkP0B0?ofkP050000003om^h0?EV[0?ofkP0mFJ/04`3om^h00`0mFJ/0ooK^
03eIZ`0A0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`000000e3dI
03Y@W@020=@m6@D0>U2M0P3D?AT00`000000>U2M03Y@W@0603Y@W@030=@m6@0jD9d0000000<0>U2M
0P3D?AT603Y@W@030000003D?AT0>U2M00T0>U2M00<0000003Y@W@0jD9d00`0jD9d00`3D?AT0>U2M
03Y@W@0203Y@W@030000000jD9d0>U2M00T0>U2M00<0000003Y@W@3D?AT02@0jD9d00`000000>U2M
03Y@W@0703Y@W@030=@m6@0jD9d0000000/0>U2M00<0000003Y@W@0jD9d00P0jD9d00`3D?AT0>U2M
03Y@W@0303Y@W@030000000jD9d0>U2M00P0>U2M00<0e3dI0000000jD9d01@0jD9d20=@m6@80>U2M
00@0000003Y@W@0jD9d0e3dI200jD9d00`000000e3dI0=@m6@0503Y@W@80e3dI00<0>U2M0=@m6@00
00002`3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP0m
FJ/04`3om^h01@0mFJ/0ooK^03eIZ`3om^h0000001@0ooK^00<0?EV[0?ofkP3om^h08P3om^h00`00
0000ooK^0?ofkP0]0?ofkP40oooo000`0?ofkP030000003om^h0ooK^0240ooK^E@0mFJ/00`0jD9d0
e3dI0=@m6@0503Y@W@80e3dI00<0000003Y@W@0jD9d01`0jD9d00`3D?AT0>U2M0000000403Y@W@80
e3dI100jD9d00`000000e3dI03Y@W@0903Y@W@030000000jD9d0>U2M00<0>U2M00<0e3dI03Y@W@0j
D9d00P0jD9d00`000000>U2M03Y@W@0903Y@W@030000000jD9d0e3dI00T0>U2M00<0000003Y@W@0j
D9d01`0jD9d00`3D?AT0>U2M0000000;03Y@W@030000000jD9d0>U2M0080>U2M00<0e3dI03Y@W@0j
D9d00`0jD9d00`000000>U2M03Y@W@0803Y@W@030=@m6@000000>U2M00<0>U2M0P3D?AT403Y@W@03
0000000jD9d0e3dI00T0>U2M00<000000=@m6@3D?AT01@0jD9d20=@m6@0303Y@W@0mFJ/0?EV[05<0
?EV[8`3om^h00`000000ooK^0?ofkP0^0?ofkP40oooo000`0?ofkP030000003om^h0ooK^0240ooK^
00<0?EV[0?ofkP3om^h04`3om^h010000000?EV[0?ofkP0mFJ/C0?ofkP0303eIZ`3om^h0?EV[0140
ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP030000000jD9d0>U2M0080
e3dI1@0jD9d00`3D?AT0000003Y@W@0803Y@W@030=@m6@0jD9d0000000H0>U2M00H0e3dI03Y@W@0j
D9d0>U2M0000003D?AT:03Y@W@030000000jD9d0>U2M00<0>U2M00<0e3dI03Y@W@0jD9d00P0jD9d0
0`000000>U2M03Y@W@0903Y@W@030000000jD9d0e3dI00T0>U2M00<0000003Y@W@0jD9d01`0jD9d0
0`3D?AT0>U2M0000000;03Y@W@030000000jD9d0>U2M0080>U2M00<0e3dI03Y@W@0jD9d00`0jD9d0
0`000000>U2M03Y@W@0803Y@W@030=@m6@000000>U2M0080>U2M00<0e3dI03Y@W@0jD9d0100jD9d0
0`000000>U2M0=@m6@0903Y@W@030000003D?AT0>U2M00@0>U2M0P3D?AT203Y@W@030000003om^h0
ooK^00X0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0
?EV[01<0ooK^00@0?EV[0?ofkP0mFJ/000005@3om^h00`0mFJ/0ooK^0?ofkP0Q0?ofkP030000003o
m^h0ooK^02h0ooK^0@3oool00300ooK^00<000000?ofkP3om^h08@3om^h00`0mFJ/0ooK^0?ofkP0C
0?ofkP050000000mFJ/0ooK^0?ofkP0mFJ/04`3om^h203eIZa80ooK^00<0?EV[0?ofkP3om^h00P3o
m^h00`0mFJ/0ooK^0?ofkP0:0?ofkP030000000jD9d0>U2M0080e3dI1@0jD9d20=@m6@T0>U2M00<0
e3dI03Y@W@0000001`0jD9d20=@m6@0303Y@W@000000e3dI00X0>U2M00<0000003Y@W@0jD9d00`0j
D9d00`3D?AT0>U2M03Y@W@0203Y@W@030000000jD9d0>U2M00T0>U2M00<0000003Y@W@3D?AT02@0j
D9d00`000000>U2M03Y@W@0703Y@W@030=@m6@000000>U2M00X0>U2M00<0000003Y@W@0jD9d00`0j
D9d00`3D?AT0>U2M03Y@W@0203Y@W@030000000jD9d0>U2M00T0>U2M00<0e3dI03Y@W@0jD9d00P3D
?AT703Y@W@030000000jD9d0e3dI00P0>U2M00<000000=@m6@3D?AT01@0jD9d20=@m6@80>U2M00<0
00000?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^0100ooK^0P0m
FJ/C0?ofkP0503eIZ`3om^h0ooK^03eIZ`0000005@3om^h00`0mFJ/0ooK^0?ofkP0Q0?ofkP030000
003om^h0ooK^02h0ooK^0@3oool00340ooK^00<000000?ofkP3om^h0803om^h00`0mFJ/0ooK^0?of
kP0C0?ofkP050000000mFJ/0ooK^0?ofkP0mFJ/04`3om^h203eIZa80ooK^00<0?EV[0?ofkP3om^h0
0P3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP050000000jD9d0>U2M03Y@W@3D?AT01@0jD9d00`3D?AT0
>U2M0=@m6@0803Y@W@030=@m6@0jD9d0000000T0>U2M0`3D?AT;03Y@W@030000000jD9d0>U2M0080
>U2M00<0e3dI03Y@W@0jD9d00`0jD9d00`000000>U2M03Y@W@0903Y@W@030000003D?AT0>U2M00P0
>U2M00<0000003Y@W@0jD9d01`0jD9d00`3D?AT0000003Y@W@0:03Y@W@030000000jD9d0>U2M00<0
>U2M00<0e3dI03Y@W@0jD9d00P0jD9d00`000000>U2M03Y@W@0903Y@W@<0e3dI2@0jD9d00`000000
>U2M0=@m6@0803Y@W@030=@m6@0jD9d0e3dI00D0>U2M00D0e3dI03Y@W@0jD9d0>U2M0000000<0?of
kP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h0403om^h203eIZa<0ooK^00D0?EV[0?of
kP3om^h0?EV[0000000E0?ofkP0303eIZ`3om^h0ooK^0200ooK^00<000000?ofkP3om^h0;`3om^h1
0?ooo`00<@3om^h00`000000ooK^0?ofkP0P0?ofkP0303eIZ`3om^h0ooK^01<0ooK^00D0000003eI
Z`3om^h0ooK^03eIZ`0C0?ofkP80?EV[4P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0
ooK^00X0ooK^00D0000003Y@W@0jD9d0>U2M0=@m6@0503Y@W@040=@m6@0jD9d000000=@m6@L0>U2M
00<0e3dI03Y@W@0000002`0jD9d20=@m6@X0>U2M00<0000003Y@W@0jD9d00P0jD9d00`3D?AT0>U2M
03Y@W@0303Y@W@030000000jD9d0>U2M00T0>U2M00<000000=@m6@0jD9d0200jD9d00`000000>U2M
03Y@W@0703Y@W@030=@m6@000000>U2M00X0>U2M00<0000003Y@W@0jD9d00`0jD9d00`3D?AT0>U2M
03Y@W@0203Y@W@030000000jD9d0>U2M00P0>U2M0P3D?AT;03Y@W@030000000jD9d0e3dI00L0>U2M
00@0e3dI0000000jD9d0e3dI1@0jD9d01@3D?AT0>U2M03Y@W@0jD9d0000000`0ooK^00<0?EV[0?of
kP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP80?EV[4`3om^h01@0mFJ/0ooK^0?ofkP0mFJ/0
000001D0ooK^00<0?EV[0?ofkP3om^h0803om^h00`000000ooK^0?ofkP0_0?ofkP40oooo000a0?of
kP030000003om^h0ooK^0200ooK^00<0?EV[0?ofkP3om^h04`3om^h01@000000?EV[0?ofkP3om^h0
?EV[01<0ooK^0P0mFJ/B0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h02P3om^h0
10000000>U2M03Y@W@0jD9d20=@m6@@0>U2M00D0e3dI03Y@W@000000>U2M0=@m6@0603Y@W@030=@m
6@0jD9d0000000/0>U2M00<0e3dI03Y@W@3D?AT00P3D?AT703Y@W@030000000jD9d0>U2M0080>U2M
00<0e3dI03Y@W@0jD9d00`0jD9d00`000000>U2M03Y@W@0903Y@W@030000003D?AT0>U2M00P0>U2M
00<0000003Y@W@0jD9d01`0jD9d00`3D?AT0000003Y@W@0:03Y@W@030000000jD9d0>U2M00<0>U2M
00<0e3dI03Y@W@0jD9d00P0jD9d00`000000>U2M03Y@W@0503Y@W@<0e3dI00<0>U2M0=@m6@0jD9d0
2@0jD9d010000000>U2M03Y@W@3D?AT603Y@W@040=@m6@0jD9d000000=@m6@D0>U2M0P3D?AT203Y@
W@800000303om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^0100ooK^0P0mFJ/C0?of
kP0503eIZ`3om^h0ooK^03eIZ`0000005@3om^h00`0mFJ/0ooK^0?ofkP0P0?ofkP030000003om^h0
ooK^02l0ooK^0@3oool00380ooK^00<000000?ofkP3om^h07`3om^h00`0mFJ/0ooK^0?ofkP0D0?of
kP0403eIZ`3om^h0ooK^03eIZa<0ooK^0P0mFJ/B0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[
0?ofkP3om^h02P3om^h200000080>U2M0P3D?AT503Y@W@050=@m6@000000>U2M03Y@W@3D?AT01@0j
D9d0103D?AT0>U2M03Y@W@00000:03Y@W@030=@m6@0jD9d0>U2M0080>U2M0`3D?AT403Y@W@030000
000jD9d0>U2M0080>U2M00<0e3dI03Y@W@0jD9d00`0jD9d00`000000>U2M03Y@W@0903Y@W@030000
003D?AT0>U2M00P0>U2M00<0000003Y@W@0jD9d01`0jD9d00`3D?AT0000003Y@W@0:03Y@W@030000
000jD9d0>U2M00<0>U2M00<0e3dI03Y@W@0jD9d00P0jD9d00`000000>U2M03Y@W@0203Y@W@<0e3dI
100jD9d00`3D?AT0>U2M03Y@W@0803Y@W@040000000jD9d0>U2M0=@m6@D0>U2M00D0e3dI03Y@W@00
0000>U2M0=@m6@0503Y@W@80e3dI0P0jD9d2000000`0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0m
FJ/0ooK^0?ofkP0@0?ofkP80?EV[4`3om^h0100mFJ/0ooK^0?ofkP0mFJ/F0?ofkP0303eIZ`3om^h0
ooK^01l0ooK^00<000000?ofkP3om^h0<03om^h10?ooo`00<P3om^h00`000000ooK^0?ofkP0O0?of
kP0303eIZ`3om^h0ooK^01@0ooK^00@0?EV[0?ofkP3om^h0?EV[4`3om^h203eIZa80ooK^00<0?EV[
0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP8000000P0jD9d00`3D?AT0>U2M0=@m6@04
03Y@W@030=@m6@0jD9d000000080>U2M0P3D?AT303Y@W@040=@m6@0jD9d0>U2M000000X0>U2M00<0
e3dI03Y@W@0jD9d01@0jD9d20=@m6@80>U2M00<0000003Y@W@0jD9d00P0jD9d00`3D?AT0>U2M03Y@
W@0303Y@W@030000000jD9d0>U2M00T0>U2M00<000000=@m6@0jD9d0200jD9d00`000000>U2M03Y@
W@0703Y@W@030=@m6@000000>U2M00X0>U2M00<0000003Y@W@0jD9d00`0jD9d00`3D?AT0>U2M03Y@
W@0203Y@W@030000000jD9d0>U2M0080e3dI1`0jD9d00`3D?AT0>U2M03Y@W@0803Y@W@040000000j
D9d0>U2M0=@m6@<0>U2M0P3D?AT203Y@W@030000000jD9d0e3dI00@0>U2M00<0e3dI03Y@W@3D?AT0
0P0jD9d00`000000ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h0
403om^h203eIZa<0ooK^00@0?EV[0?ofkP3om^h0?EV[5P3om^h00`0mFJ/0ooK^0?ofkP0O0?ofkP03
0000003om^h0ooK^0300ooK^0@3oool00380ooK^00<000000?ofkP3om^h07P3om^h00`0mFJ/0ooK^
0?ofkP0D0?ofkP0403eIZ`000000ooK^0?ofkS/0?EV[0`0000000`3D?AT000000=@m6@0400000003
0=@m6@000000000000@0000000D0e3dI00000000000000000=@m6@0<000000030=@m6@0000000000
00L000000`3D?AT4000000030=@m6@00000000000100000000<0e3dI0000000000004@0000000`3D
?AT000000000000@000000030=@m6@0000000000008000000`3D?AT9000000030=@m6@0000000000
00X0000000D0e3dI00000000000000000=@m6@06000000030=@m6@00000000000080000000<0e3dI
0000003D?AT00`00000k03eIZ`80ooK^00<0?EV[0?ofkP3om^h0503om^h00`0mFJ/0ooK^0?ofkP0O
0?ofkP030000003om^h0ooK^0300ooK^0@3oool00380ooK^00<000000?ofkP3om^h07P3om^h00`0m
FJ/0ooK^0?ofkP0D0?ofkP0503eIZ`000000ooK^0?ofkP0mFJ/04`3om^h00`0mFJ/0ooK^0?ofkP0A
0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/03P3om^h010000000?EJX03eFZ03D?AT203eFZ0070=@m
6@0mEZP0?EJX03eFZ03D?AT0?EJX0000000503eFZ0060=@m6@0mEZP0?EJX0=@m6@0mEZP000002P0m
EZP00`3D?AT0?EJX03eFZ00903eFZ0060000003D?AT0e3dI0=@m6@0mEZP0e3dI1@0mEZP00`000000
?EJX03eFZ00903eFZ0030000003D?AT0?EJX00P0?EJX00<0000003eFZ00mEZP01`0mEZP00`3D?AT0
000003eFZ00:03eFZ0030000000mEZP0?EJX00<0?EJX00<0e3dI03eFZ03D?AT00P3D?AT00`000000
?EJX03eFZ00903eFZ0030=@m6@0mEZP0?EJX00P0?EJX00<0000003eFZ03D?AT00P0mEZP00`3D?AT0
?EJX03eFZ00303eFZ0030000000mEZP0e3dI00<0?EJX00@0e3dI03eFZ00mEZP0e3dI0P0mEZP00`00
0000ooK^0?ofkP0<0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/04`3om^h00`0mFJ/0ooK^0?ofkP0A
0?ofkP0503eIZ`3om^h0ooK^0000000mFJ/05P3om^h00`0mFJ/0ooK^0?ofkP0N0?ofkP030000003o
m^h0ooK^0300ooK^0@3oool003<0ooK^00<000000?ofkP3om^h07@3om^h00`0mFJ/0ooK^0?ofkP0D
0?ofkP0503eIZ`3om^h000000?ofkP0mFJ/04`3om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP0503eIZ`3o
m^h0ooK^0?ofkP0mFJ/03P3om^h200000080?EJX00@0e3dI03eFZ00mEZP0e3dI0P0mEZP0103D?AT0
?EJX03eFZ000000503eFZ0050=@m6@0mEZP0e3dI03eFZ00000002@0mEZP00`0mFJ/0e3dI03eFZ00:
03eFZ0040000000mEZP0?EJX03eFZ0D0e3dI0P0mEZP00`000000?EJX03eFZ00903eFZ0030000003D
?AT0?EJX00P0?EJX00<0000003eFZ00mEZP01`0mEZP00`3D?AT0000003eFZ00:03eFZ0030000000m
EZP0?EJX00D0e3dI0`0mEZP00`000000?EJX03eFZ00903eFZ0030=@m6@0mEZP0?EJX00P0?EJX00D0
000003eFZ03D?AT0?EJX0=@m6@0503eFZ0040000000mEZP0?EJX0=@m6@80?EJX00@0e3dI03eFZ00m
EZP0e3dI0P0mEZP2000000h0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0C0?ofkP0303eIZ`3om^h0
ooK^0140ooK^00D0?EV[0?ofkP000000ooK^03eIZ`0F0?ofkP0303eIZ`3om^h0ooK^01d0ooK^00<0
00000?ofkP3om^h0<@3om^h10?ooo`00<`3om^h00`000000ooK^0?ofkP0M0?ofkP0303eIZ`3om^h0
ooK^01@0ooK^00D0?EV[0?ofkP000000ooK^03eIZ`0C0?ofkP0303eIZ`3om^h0ooK^0140ooK^00D0
?EV[0?ofkP3om^h0ooK^03eIZ`0>0?ofkP8000000P0mEZP0103D?AT0?EJX03eFZ03D?AT203eFZ004
0=@m6@0mEZP0?EJX000000H0?EJX0P3D?AT203eFZ0030000000mEZP0?EJX00H0?EJX00<0?EV[0=@m
6@0000002P0mEZP00`000000?EJX03eFZ00203eFZ0040=@m6@0mEZP0?EJX03eFZ0H0e3dI200mEZP0
0`000000e3dI03eFZ00803eFZ0030000000mEZP0?EJX00L0?EJX00<0e3dI0000000mEZP01`0mEZP6
0=@m6@<0?EJX00<0e3dI03eFZ00mEZP00P0mEZP00`000000?EJX03eFZ00803eFZ0030000003D?AT0
?EJX00P0?EJX00<0000003eFZ00mEZP00P3D?AT603eFZ0040000000mEZP0?EJX0=@m6@80?EJX00@0
e3dI03eFZ00mEZP0e3dI0P0mEZP2000000h0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0C0?ofkP03
03eIZ`3om^h0ooK^0140ooK^00D0?EV[0?ofkP000000ooK^03eIZ`0F0?ofkP0303eIZ`3om^h0ooK^
01d0ooK^00<000000?ofkP3om^h0<@3om^h10?ooo`00<`3om^h00`000000ooK^0?ofkP0M0?ofkP03
03eIZ`3om^h0ooK^01@0ooK^00D0?EV[0?ofkP000000ooK^03eIZ`0C0?ofkP0303eIZ`3om^h0ooK^
0140ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0>0?ofkP<0000000<0?EJX0=@m6@0mEZP00P0mEZP0
0`3D?AT0?EJX0=@m6@0203eFZ0030000000mEZP0?EJX00D0?EJX00@0e3dI03eFZ00mEZP000002@0m
EZP00`3D?AT0000003eFZ00:03eFZ0050000000mEZP0?EJX03eFZ03D?AT01P0mEZP00`000000?EJX
03eFZ0060=@m6@80?EJX00<000000=@m6@0mEZP0200mEZP00`000000?EJX03eFZ00703eFZ0040=@m
6@000000?EJX03eFZ0H0e3dI0P0mEZP00`000000?EJX03eFZ00403eFZ0050=@m6@0mEZP0?EJX03eF
Z00000002`0mEZP00`3D?AT0?EJX03eFZ00803eFZ0040000000mEZP0?EJX0=@m6@L0?EJX00H00000
03eFZ00mEZP0e3dI03eFZ03D?AT303eFZ0030=@m6@0mEZP00000008000003P3om^h01@0mFJ/0ooK^
0?ofkP3om^h0?EV[01<0ooK^00<0?EV[0?ofkP3om^h04@3om^h01@0mFJ/0ooK^0000003om^h0?EV[
01H0ooK^00<0?EV[0?ofkP3om^h07@3om^h00`000000ooK^0?ofkP0a0?ofkP40oooo000d0?ofkP03
0000003om^h0ooK^01`0ooK^00<0?EV[0?ofkP3om^h0503om^h01@0mFJ/0ooK^0000003om^h0?EV[
01<0ooK^00<0?EV[0?ofkP3om^h04@3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00h0ooK^0`000000
0`0mEZP0e3dI03eFZ00303eFZ080e3dI0`0mEZP00`000000?EJX03eFZ00403eFZ0<0e3dI00<00000
03eFZ00mEZP0200mEZP00`3D?AT0?EJX03eFZ00903eFZ0050000000mEZP0?EJX03eFZ03D?AT01P0m
EZP00`000000?EJX03eFZ00603eFZ1/0e3dI200mEZP00`000000?EJX03eFZ00403eFZ0050=@m6@0m
EZP0?EJX03eFZ00000002`0mEZP00`3D?AT0?EJX03eFZ00803eFZ0040000003D?AT0e3dI0=@m6@H0
?EJX00H0000003eFZ00mEZP0e3dI03eFZ03D?AT403eFZ0030=@m6@0mEZP00000008000003P3om^h0
1@0mFJ/0ooK^0?ofkP3om^h0?EV[01<0ooK^00<0?EV[0?ofkP3om^h04@3om^h01@0mFJ/0ooK^0000
003om^h0?EV[01H0ooK^00<0?EV[0?ofkP3om^h0703om^h00`000000ooK^0?ofkP0b0?ofkP40oooo
000d0?ofkP030000003om^h0ooK^01`0ooK^00<0?EV[0?ofkP3om^h0503om^h01@0mFJ/0ooK^0?of
kP000000?EV[01<0ooK^00<0?EV[0?ofkP3om^h04@3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00h0
ooK^0`0000000`0mEZP0e3dI03eFZ00303eFZ0030=@m6@0mEZP0e3dI0080?EJX00<0000003eFZ00m
EZP0100mEZP00`3D?AT0?EJX03eFZ0020=@m6@T0?EJX00<0e3dI03eFZ00mEZP02@0mEZP01@000000
?EJX03eFZ00mEZP0e3dI00H0?EJX00<0000003eFZ00mEZP0200mEZP00`000000e3dI03eFZ00803eF
Z0030000000mEZP0?EJX00L0?EJX00<0e3dI0000000mEZP02@0mEZP00`000000?EJX03eFZ00403eF
Z0050=@m6@0mEZP0?EJX03eFZ00000002`0mEZP00`3D?AT0?EJX03eFZ00703eFZ080e3dI0P0mEZP0
0`3D?AT0?EJX03eFZ00403eFZ0060000000mEZP0?EJX0=@m6@0mEZP0e3dI100mEZP00`3D?AT0?EJX
00000002000000h0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0C0?ofkP0303eIZ`3om^h0ooK^0140
ooK^00D0?EV[0000003om^h0ooK^03eIZ`0F0?ofkP0303eIZ`3om^h0ooK^01`0ooK^00<000000?of
kP3om^h0<P3om^h10?ooo`00=03om^h00`000000ooK^0?ofkP0L0?ofkP0303eIZ`3om^h0ooK^01@0
ooK^00D0?EV[0?ofkP3om^h0000003eIZ`0C0?ofkP0303eIZ`3om^h0ooK^0140ooK^00D0?EV[0?of
kP3om^h0ooK^03eIZ`0?0?ofkP040000000l4@T000000=@m6@D0?EJX0P3D?AT203eFZ0030000000m
EZP0?EJX00@0?EJX00D0e3dI03eFZ00mEZP0?EJX000000020=@m6@L0?EJX00<0e3dI0000000mEZP0
2@0mEZP01@000000?EJX03eFZ00mEZP0e3dI00H0?EJX00<0000003eFZ00mEZP0200mEZP00`000000
e3dI03eFZ00803eFZ0030000000mEZP0?EJX00L0?EJX00<0e3dI0000000mEZP02@0mEZP00`000000
?EJX03eFZ00403eFZ0050=@m6@0mEZP0?EJX03eFZ00000002P0mEZP00`000000e3dI03eFZ00603eF
Z080e3dI00D0000003eFZ00mEZP0?EJX0=@m6@0603eFZ0030000000mEZP0?EJX0080e3dI1@0mEZP0
103D?AT000000?U87000000?0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/04P3om^h203eIZa80ooK^
00<0?EV[0?ofkP0000000P3om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP0303eIZ`3om^h0ooK^01`0ooK^
00<000000?ofkP3om^h0<P3om^h10?ooo`00=@3om^h00`000000ooK^0?ofkP0K0?ofkUX0?EV[00<0
e3dI03eFZ00mEZP00`0mEZP20=@m6@80?EJX00<0000003eFZ00mEZP0100mEZP01@3D?AT0?EJX03eF
Z00mEZP000000080?EJX00<0e3dI03eFZ00mEZP0100mEZP00`3D?AT0000003eFZ00903eFZ0050000
000mEZP0?EJX03eFZ03D?AT01P0mEZP00`000000?EJX03eFZ00803eFZ0030000003D?AT0?EJX00P0
?EJX00<0000003eFZ00mEZP01`0mEZP00`3D?AT0000003eFZ00903eFZ0030000000mEZP0?EJX00@0
?EJX00D0e3dI03eFZ00mEZP0?EJX0000000:03eFZ0030000003D?AT0?EJX00D0?EJX00@0e3dI03eF
Z00mEZP000000`0mEZP00`3D?AT0?EJX03eFZ00403eFZ0030000000mEZP0?EJX0080e3dI1@0mEZP0
0`3D?AT0?EV[03eIZ`1H03eIZad0ooK^00<000000?ofkP3om^h0<`3om^h10?ooo`00=@3om^h00`00
0000ooK^0?ofkP0K0?ofkP0303eIZ`3om^h0ooK^01@0ooK^00H0?EV[0?ofkP3om^h000000?ofkP0m
FJ/B0?ofkP80?EV[4P3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00l0ooK^0`00000703eFZ0050=@m
6@0mEZP0?EJX03eFZ00000001@0mEZP01@3D?AT0?EJX03eFZ00mEZP0000000<0?EJX0P3D?AT403eF
Z0030=@m6@000000?EJX00T0?EJX00D0000003eFZ00mEZP0?EJX0=@m6@0603eFZ0030000000mEZP0
?EJX00P0?EJX00<000000=@m6@0mEZP0200mEZP00`000000?EJX03eFZ00703eFZ0030=@m6@000000
?EJX00T0?EJX00<0000003eFZ00mEZP0100mEZP01@3D?AT0?EJX03eFZ00mEZP0000000X0?EJX00<0
00000=@m6@0mEZP00`0mEZP20=@m6@<0?EJX00D0000003eFZ00mEZP0?EJX0=@m6@0503eFZ0050000
000mEZP0?EJX03eFZ03D?AT01`0mEZP3000000l0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0B0?of
kP80?EV[4P3om^h00`0mFJ/0ooK^000000020?ofkP0303eIZ`3om^h0ooK^01@0ooK^00<0?EV[0?of
kP3om^h06`3om^h00`000000ooK^0?ofkP0c0?ofkP40oooo000e0?ofkP030000003om^h0ooK^01/0
ooK^00<0?EV[0?ofkP3om^h0503om^h01P0mFJ/0ooK^0?ofkP000000ooK^03eIZa80ooK^0P0mFJ/B
0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/03`3om^h20000000303`A2@000000?EJX00D0?EJX0P3D
?AT203eFZ0030000000mEZP0?EJX00<0?EJX00D0e3dI03eFZ00mEZP0?EJX0000000503eFZ080e3dI
0P0mEZP00`3D?AT0000003eFZ00:03eFZ0040000000mEZP0?EJX0=@m6@L0?EJX00<0000003eFZ00m
EZP01`0mEZP00`000000e3dI03eFZ00803eFZ0030000000mEZP0?EJX00L0?EJX00<0e3dI0000000m
EZP0200mEZP00`000000?EJX03eFZ00403eFZ0050=@m6@0mEZP0?EJX03eFZ00000002`0mEZP01000
0000e3dI03eFZ00mEZP20=@m6@D0?EJX00D0000003eFZ00mEZP0?EJX0=@m6@0503eFZ0030000000m
EZP0?EJX0080e3dI1P0mEZP010000000nDPL00000000000?0?ofkP0503eIZ`3om^h0ooK^0?ofkP0m
FJ/04P3om^h203eIZa80ooK^00<0?EV[0?ofkP0000000P3om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP03
03eIZ`3om^h0ooK^01/0ooK^00<000000?ofkP3om^h0<`3om^h10?ooo`00=P3om^h00`000000ooK^
0?ofkP0J0?ofkP0303eIZ`3om^h0ooK^01@0ooK^00H0?EV[0?ofkP3om^h0ooK^0000000mFJ/B0?of
kP80?EV[4P3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00l0ooK^1000000603eFZ0050=@m6@0mEZP0
e3dI03eFZ00000001@0mEZP00`3D?AT0?EJX03eFZ00203eFZ0030000000mEZP0?EJX00@0?EJX0`3D
?AT00`0mEZP0000003eFZ00903eFZ0050000000mEZP0?EJX03eFZ03D?AT01P0mEZP00`000000?EJX
03eFZ00703eFZ0030000003D?AT0?EJX00P0?EJX00<0000003eFZ00mEZP01`0mEZP00`3D?AT00000
03eFZ00803eFZ0030000000mEZP0?EJX00@0?EJX00D0e3dI03eFZ00mEZP0?EJX0000000:03eFZ003
0000000mEZP0e3dI0080e3dI1P0mEZP00`000000?EJX03eFZ00203eFZ0030=@m6@0mEZP0?EJX00<0
?EJX00D0000003eFZ03D?AT0?EJX0=@m6@0603eFZ0@000003`3om^h01@0mFJ/0ooK^0?ofkP3om^h0
?EV[0180ooK^0P0mFJ/B0?ofkP0303eIZ`000000ooK^0080ooK^00<0?EV[0?ofkP3om^h0503om^h0
0`0mFJ/0ooK^0?ofkP0J0?ofkP030000003om^h0ooK^03@0ooK^0@3oool003H0ooK^00<000000?of
kP3om^h06P3om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP0603eIZ`3om^h0ooK^0?ofkP000000?EV[4P3o
m^h203eIZa80ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0?0?ofkP<0000000<0?1490000000mEZP0
100mEZP01P3D?AT0?EJX03eFZ03D?AT0?EJX000000D0?EJX00D0e3dI03eFZ00mEZP0?EJX00000008
03eFZ080e3dI00<0000003eFZ00mEZP0200mEZP01@000000?EJX03eFZ00mEZP0e3dI00H0?EJX00<0
000003eFZ00mEZP01`0mEZP00`000000e3dI03eFZ00803eFZ0030000000mEZP0?EJX00L0?EJX00<0
e3dI0000000mEZP0200mEZP00`000000?EJX03eFZ00403eFZ0050=@m6@0mEZP0?EJX03eFZ0000000
2P0mEZP00`000000e3dI0=@m6@0803eFZ0050000000mEZP0?EJX03eFZ03D?AT01@0mEZP00`000000
?EJX0=@m6@0203eFZ0030=@m6@0mEZP0?EJX00<0?EJX00<000000?U8700000000P00000?0?ofkP05
03eIZ`3om^h0ooK^0?ofkP0mFJ/04P3om^h203eIZa80ooK^00<0?EV[0000003om^h00P3om^h00`0m
FJ/0ooK^0?ofkP0D0?ofkP0303eIZ`3om^h0ooK^01X0ooK^00<000000?ofkP3om^h0=03om^h10?oo
o`00=P3om^h00`000000ooK^0?ofkP0J0?ofkP0303eIZ`3om^h0ooK^01@0ooK^00H0?EV[0?ofkP3o
m^h0ooK^0000000mFJ/B0?ofkP80?EV[4P3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00l0ooK^0`00
00000`0l4@T0000000000004000000050=@m6@00000000000000003D?AT01P0000000`3D?AT00000
0000000:000000030=@m6@000000e3dI0080e3dI300000000`3D?AT000000000000?000000030=@m
6@00000000000100000000<0e3dI000000000000400000000`3D?AT000000000000:000000<0e3dI
00<000000=@m6@0000002`0000000`3D?AT0000000000004000000050=@m6@00000000000000003D
?AT01`0000000`3iB1`000000000000?0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/04P3om^h203eI
Za80ooK^00<0?EV[0000003om^h00P3om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP0303eIZ`3om^h0ooK^
01X0ooK^00<000000?ofkP3om^h0=03om^h10?ooo`00=`3om^h00`000000ooK^0?ofkP0I0?ofkP03
03eIZ`3om^h0ooK^01@0ooK^00D0?EV[0?ofkP3om^h0ooK^0000000k03eIZ`80000000@0?1490000
000000000000100oF[400`3D?AT0?eZa03mJ/@0203mJ/@80e3dI100oF[401@3D?AT0?eZa03mJ/@0o
F[40000000P0?eZa00<0e3dI03mJ/@0000000P0oF[430=@m6@D0?eZa00D0000003mJ/@0oF[40?eZa
0=@m6@0603mJ/@030000000oF[40?eZa00L0?eZa00<0000003mJ/@3D?AT0200oF[400`000000?eZa
03mJ/@0603mJ/@030=@m6@0oF[40000000T0?eZa00<0000003mJ/@0oF[40100oF[401@3D?AT0?eZa
03mJ/@0oF[40000000D0?eZa0`3D?AT203mJ/@030000000oF[40e3dI00P0?eZa00D0000003mJ/@0o
F[40?eZa0=@m6@0403mJ/@80e3dI100oF[400`3D?AT0?eZa03mJ/@0203mJ/@<0000000<0nDPL0000
00000000>`0mFJ/01@000000ooK^0?ofkP3om^h0?EV[01H0ooK^00<0?EV[0?ofkP3om^h06@3om^h0
0`000000ooK^0?ofkP0e0?ofkP40oooo000g0?ofkP030000003om^h0ooK^01T0ooK^00<0?EV[0?of
kP3om^h0503om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^0100ooK^0P0mFJ/B0?of
kP0503eIZ`3om^h0ooK^0?ofkP0mFJ/03`3om^h20000000403`A2@0000000000000000@0?eZa00<0
e3dI03mJ/@0oF[400`0oF[400`000000e3dI03mJ/@0203mJ/@030=@m6@0oF[40?eZa0080?eZa00<0
000003mJ/@0oF[401@0oF[40103D?AT0?eZa03mJ/@00000403mJ/@80e3dI0`0oF[401@000000?eZa
03mJ/@0oF[40e3dI00H0?eZa00<0000003mJ/@0oF[401`0oF[400`000000?eZa0=@m6@0803mJ/@03
0000000oF[40?eZa00H0?eZa00<0e3dI03mJ/@0000002@0oF[400`000000?eZa03mJ/@0403mJ/@05
0=@m6@0oF[40?eZa03mJ/@0000000`0oF[420=@m6@@0?eZa00@0000003mJ/@0oF[40e3dI1`0oF[40
0`000000?eZa03mJ/@0203mJ/@060=@m6@0oF[40?eZa03mJ/@3D?AT000001@0oF[400`3D?AT0?eZa
03mJ/@0203mJ/@<0000000<0nDPL0000000000003`3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[0180
ooK^0P0mFJ/B0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h0503om^h00`0mFJ/0
ooK^0?ofkP0I0?ofkP030000003om^h0ooK^03D0ooK^0@3oool003L0ooK^00<000000?ofkP3om^h0
6@3om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h0
403om^h203eIZa80ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0?0?ofkP<0000000@0?1490000001A
60`000000`0oF[400`3D?AT0?eZa03mJ/@0303mJ/@030000000oF[40e3dI0080?eZa00<0e3dI03mJ
/@0oF[400P0oF[400`000000?eZa03mJ/@0503mJ/@040=@m6@0oF[40?eZa000000H0?eZa0`3D?AT0
1@0oF[40000003mJ/@0oF[40e3dI00H0?eZa00<0000003mJ/@0oF[401`0oF[400`000000?eZa0=@m
6@0803mJ/@030000000oF[40?eZa00H0?eZa00<0e3dI03mJ/@0000002@0oF[400`000000?eZa03mJ
/@0403mJ/@050=@m6@0oF[40?eZa0000000oF[400`3D?AT603mJ/@040000000oF[40?eZa0=@m6@L0
?eZa00<0000003mJ/@0oF[400P0oF[401P3D?AT0?eZa03mJ/@3D?AT0?eZa000000@0?eZa00<0e3dI
03mJ/@0oF[400P0oF[43000000040?U8700000000000000000l0ooK^00D0?EV[0?ofkP3om^h0ooK^
03eIZ`0B0?ofkP80?EV[4P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^01@0ooK^
00<0?EV[0?ofkP3om^h06@3om^h00`000000ooK^0?ofkP0e0?ofkP40oooo000h0?ofkP030000003o
m^h0ooK^01L0ooK^00<0?EV[0?ofkP3om^h05@3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3o
m^h0ooK^0100ooK^0P0mFJ/B0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/03`3om^h30000000403`A
2@0000000000000000@0?eZa00<0e3dI03mJ/@0oF[400`0oF[401@000000?eZa0=@m6@0oF[40e3dI
00D0?eZa00<0000003mJ/@0oF[40100oF[40103D?AT0?eZa03mJ/@00000903mJ/@<0e3dI00<0?eZa
0=@m6@0oF[401P0oF[400`000000?eZa03mJ/@0603mJ/@030000000oF[40e3dI00P0?eZa00<00000
03mJ/@0oF[401P0oF[400`3D?AT0?eZa0000000803mJ/@030000000oF[40?eZa00D0?eZa00<0e3dI
03mJ/@3D?AT00P3D?AT903mJ/@040000000oF[40?eZa0=@m6@H0?eZa00<0000003mJ/@0oF[400`0o
F[401@3D?AT0?eZa0=@m6@0oF[40000000D0?eZa00<0e3dI03mJ/@0oF[400P0oF[43000000040?U8
700000000000000000l0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0B0?ofkP80?EV[4P3om^h00`0m
FJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^01@0ooK^00<0?EV[0?ofkP3om^h0603om^h00`00
0000ooK^0?ofkP0f0?ofkP40oooo000h0?ofkP030000003om^h0ooK^01L0ooK^00<0?EV[0?ofkP3o
m^h05@3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^0100ooK^0P0mFJ/B0?ofkP05
03eIZ`3om^h0ooK^0?ofkP0mFJ/03`3om^h40000000403`A2@000000DAP<000000<0?eZa00<0e3dI
03mJ/@0oF[400`0oF[400`000000?eZa03mJ/@020=@m6@D0?eZa00<0000003mJ/@0oF[40100oF[40
1@3D?AT0?eZa03mJ/@0oF[40000000T0?eZa00<0000003mJ/@3D?AT0103D?AT403mJ/@030000000o
F[40?eZa00H0?eZa00<0000003mJ/@3D?AT0200oF[400`000000?eZa03mJ/@0603mJ/@030=@m6@0o
F[40000000P0?eZa00<0000003mJ/@0oF[400P0oF[450=@m6@0303mJ/@000000?eZa00P0?eZa00D0
000003mJ/@0oF[40?eZa0=@m6@0603mJ/@030000000oF[40?eZa00<0?eZa0P3D?AT203mJ/@030000
000oF[40?eZa00<0?eZa00P0e3dI03mJ/@0oF[40?eZa0000003oD1l000000?U870@000003`3om^h0
1@0mFJ/0ooK^0?ofkP3om^h0?EV[0180ooK^0P0mFJ/B0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0
?EV[0?ofkP3om^h05@3om^h00`0mFJ/0ooK^0?ofkP0G0?ofkP030000003om^h0ooK^03H0ooK^0@3o
ool003P0ooK^00<000000?ofkP3om^h05`3om^h00`0mFJ/0ooK^0?ofkP0E0?ofkP0303eIZ`3om^h0
ooK^0080ooK^00<0?EV[0?ofkP3om^h0403om^h203eIZa80ooK^00D0?EV[0?ofkP3om^h0ooK^03eI
Z`0?0?ofkP0<0000000X2`D000000000000l4@T00000054H30000000?eZa0=@m6@0oF[40e3dI1P0o
F[4010000000?eZa03mJ/@3D?AT503mJ/@030000000oF[40?eZa00@0?eZa00D0e3dI03mJ/@0oF[40
?eZa0000000903mJ/@040000000oF[40?eZa0=@m6@<0?eZa1P3D?AT703mJ/@030000000oF[40e3dI
00P0?eZa00<0000003mJ/@0oF[401P0oF[400`3D?AT0?eZa0000000703mJ/@H0e3dI0`0oF[40103D
?AT0?eZa03mJ/@00000903mJ/@050000000oF[40?eZa03mJ/@3D?AT01P0oF[400`000000?eZa03mJ
/@0303mJ/@040=@m6@0oF[40?eZa000000H0?eZa00P0e3dI03mJ/@3D?AT0?eZa0000003oD1l00000
0?U870@000003`3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[0180ooK^0P0mFJ/B0?ofkP0303eIZ`3o
m^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h05@3om^h00`0mFJ/0ooK^0?ofkP0G0?ofkP030000003o
m^h0ooK^03H0ooK^0@3oool003T0ooK^00<000000?ofkP3om^h05P3om^h00`0mFJ/0ooK^0?ofkP0E
0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0000003om^h0403om^h203eIZa80ooK^00D0?EV[
0?ofkP3om^h0ooK^03eIZ`0?0?ofkP<0000000<0?1490000000000000P1A60`0100mFJ/0e3dI03mJ
/@3D?AT603mJ/@030000000oF[40?eZa00<0e3dI100oF[400`000000?eZa03mJ/@0303mJ/@050=@m
6@0oF[40?eZa03mJ/@0000002P0oF[400`000000?eZa0=@m6@0703mJ/@030000000oF[40e3dI00D0
e3dI0P0oF[400`000000e3dI03mJ/@0703mJ/@030000000oF[40?eZa00H0?eZa00@0e3dI0000000o
F[40?eZa1P3D?AT00`0oF[40000003mJ/@0603mJ/@030=@m6@0oF[40000000X0?eZa00@0000003mJ
/@0oF[40e3dI1P0oF[400`000000?eZa03mJ/@0203mJ/@<0e3dI0P0oF[400`000000?eZa03mJ/@04
03mJ/@040=@m6@0oF[40e3dI03eIZ`80oe0O0P000000103iB1`0000000000000000?0?ofkP0503eI
Z`3om^h0ooK^0?ofkP0mFJ/04P3om^h203eIZa40ooK^00<0000003eIZ`3om^h00`3om^h00`0mFJ/0
ooK^0?ofkP0E0?ofkP0303eIZ`3om^h0ooK^01H0ooK^00<000000?ofkP3om^h0=`3om^h10?ooo`00
>@3om^h00`000000ooK^0?ofkP0F0?ofkP0303eIZ`3om^h0ooK^01D0ooK^00<0?EV[0?ofkP3om^h0
0P3om^h00`0mFJ/000000?ofkP0@0?ofkP80?EV[4P3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00l0
ooK^00@0?EV[000000000000?1490`0000000`1A60`0?EV[03mJ/@020=@m6@L0?eZa00<0000003mJ
/@3D?AT00P0oF[401@3D?AT0?eZa03mJ/@0oF[40000000H0?eZa00@0e3dI03mJ/@0oF[4000002P0o
F[400`000000?eZa0=@m6@0703mJ/@030000000oF[40?eZa00D0?eZa6@3D?AT703mJ/@050000000o
F[40?eZa03mJ/@0mFJ/00`0oF[400`3D?AT0?eZa0000000:03mJ/@040000000oF[40?eZa0=@m6@H0
?eZa00D0000003mJ/@0oF[40?eZa0=@m6@0203mJ/@030=@m6@0oF[40000000L0?eZa0P3D?AT00`0o
F[40?EV[0?m@7`03000000040?U870000000000003eIZ`l0ooK^00@0?EV[0?ofkP3om^h0?EV[4`3o
m^h203eIZa40ooK^00<0000003eIZ`3om^h00`3om^h00`0mFJ/0ooK^0?ofkP0E0?ofkP0303eIZ`3o
m^h0ooK^01H0ooK^00<000000?ofkP3om^h0=`3om^h10?ooo`00>@3om^h00`000000ooK^0?ofkP0F
0?ofkP0303eIZ`3om^h0ooK^01D0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/000000?ofkP0@
0?ofkP80?EV[4`3om^h0100mFJ/0ooK^0?ofkP0mFJ/?0?ofkP0303eIZ`00000000000080?1490P00
00000`1A60`0?EV[000000020=@m6@L0?eZa00<0000003mJ/@3D?AT00`0oF[420=@m6@0303mJ/@00
0000?eZa00D0?eZa00D0e3dI03mJ/@0oF[40?eZa0000000903mJ/@030000000oF[40e3dI00L0?eZa
00<0000003mJ/@0oF[401`0oF[400`000000e3dI03mJ/@0703mJ/@030000000oF[40?eZa00H0?eZa
00<0e3dI0000000oF[40200oF[400`000000?eZa03mJ/@0503mJ/@030=@m6@0oF[40000000T0?eZa
00D0000003mJ/@0oF[40?eZa0=@m6@0603mJ/@040000000oF[40e3dI0=@m6@<0?eZa00<0e3dI03mJ
/@0000001`0oF[420=@m6@030000000mFJ/0oe0O008000000P3iB1`20000000303eIZ`3om^h0ooK^
00d0ooK^00@0?EV[0?ofkP3om^h0?EV[4`3om^h203eIZa40ooK^00<0000003eIZ`3om^h00`3om^h0
0`0mFJ/0ooK^0?ofkP0E0?ofkP0303eIZ`3om^h0ooK^01H0ooK^00<000000?ofkP3om^h0=`3om^h1
0?ooo`00>@3om^h00`000000ooK^0?ofkP0F0?ofkP0303eIZ`3om^h0ooK^01D0ooK^00<0?EV[0?of
kP3om^h00P3om^h00`0mFJ/000000?ofkP0@0?ofkP80?EV[4`3om^h0100mFJ/0ooK^0?ofkP0mFJ/?
0?ofkP0503eIZ`00000000000000000l4@T00`000000100mFJ/0000003mJ/@3D?AT803mJ/@030000
003D?AT0?eZa00@0?eZa00<0e3dI03mJ/@0000001@0oF[401@3D?AT0?eZa03mJ/@0oF[40000000T0
?eZa00<0000003mJ/@3D?AT0200oF[400`000000?eZa03mJ/@0603mJ/@030000003D?AT0?eZa00L0
?eZa00<0000003mJ/@0oF[401P0oF[400`3D?AT0000003mJ/@0703mJ/@030000000oF[40?eZa00H0
?eZa00<0e3dI03mJ/@0000002@0oF[401@000000?eZa03mJ/@0oF[40e3dI00D0?eZa00<0000003mJ
/@3D?AT01@0oF[400`3D?AT0000003mJ/@0703mJ/@040=@m6@0oF[40000003eIZ`<0000000D0nDPL
000000000000000003eIZ`0?0?ofkP0403eIZ`3om^h0ooK^03eIZa<0ooK^0P0mFJ/A0?ofkP030000
000mFJ/0ooK^00<0ooK^00<0?EV[0?ofkP3om^h05@3om^h00`0mFJ/0ooK^0?ofkP0F0?ofkP030000
003om^h0ooK^03L0ooK^0@3oool003X0ooK^00<000000?ofkP3om^h05@3om^h00`0mFJ/0ooK^0?of
kP0E0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP000000403om^h203eIZa<0ooK^00@0
?EV[0?ofkP3om^h0?EV[3`3om^h0100mFJ/0000000000000000203`A2@80000000<0?EV[054H3000
00000P3D?AT703mJ/@030000003D?AT0?eZa00D0?eZa0P3D?AT503mJ/@050=@m6@0oF[40?eZa03mJ
/@0000002P0oF[400`000000e3dI03mJ/@0703mJ/@030000000oF[40?eZa00H0?eZa00<000000=@m
6@0oF[401`0oF[400`000000?eZa03mJ/@0603mJ/@030=@m6@000000?eZa00L0?eZa00<0000003mJ
/@0oF[401P0oF[400`3D?AT0000003mJ/@0903mJ/@050000000oF[40?eZa03mJ/@3D?AT01@0oF[42
0=@m6@H0?eZa00<0e3dI0000000oF[401P0oF[420=@m6@030000003oD1l0?EV[008000000P3iB1`3
0000000303eIZ`3om^h0ooK^00d0ooK^00@0?EV[0?ofkP3om^h0?EV[4`3om^h203eIZa00ooK^00<0
00000?ofkP0mFJ/0103om^h00`0mFJ/0ooK^0?ofkP0E0?ofkP0303eIZ`3om^h0ooK^01D0ooK^00<0
00000?ofkP3om^h0>03om^h10?ooo`00>P3om^h00`000000ooK^0?ofkP0E0?ofkP0303eIZ`3om^h0
ooK^01D0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0000000@0?ofkP80?EV[4`3om^h0
100mFJ/0ooK^0?ofkP0mFJ/?0?ofkP0403eIZ`000000000000000080?14900P00000054H300mFJ/0
DAP<0000003D?AT0?eZa0=@m6@L0?eZa00<0e3dI03mJ/@0oF[401P0oF[420=@m6@0403eIZ`0oF[40
?eZa0=@m6@@0?eZa00<0000003mJ/@0oF[401`0oF[400`000000e3dI03mJ/@0203mJ/@0303eIZ`0o
F[40?eZa0080?eZa00<0000003mJ/@0oF[401P0oF[400`000000e3dI03mJ/@0703mJ/@0303eIZ`0o
F[40?eZa00H0?eZa00<0e3dI0000000oF[401`0oF[400`000000?eZa03mJ/@0203mJ/@0603eIZ`0o
F[40?eZa03mJ/@3D?AT000002@0oF[400`000000?eZa03mJ/@0203mJ/@040=@m6@0oF[40?eZa03mJ
/@80e3dI200oF[400`3D?AT0?eZa03mJ/@0503mJ/@080=@m6@0oF[40e3dI0000003oD1l0?EV[0?m@
7`0000020?U870<0000000<0?EV[0?ofkP3om^h03@3om^h0100mFJ/0ooK^0?ofkP0mFJ/C0?ofkP80
?EV[403om^h00`000000ooK^03eIZ`040?ofkP0303eIZ`3om^h0ooK^01D0ooK^00<0?EV[0?ofkP3o
m^h05@3om^h00`000000ooK^0?ofkP0h0?ofkP40oooo000j0?ofkP030000003om^h0ooK^01D0ooK^
H`0mFJ/3000000030=@m6@000000000000@0000000<0e3dI00000000000020000000103D?AT00000
0000003D?AT?000000030=@m6@00000000000100000000<0e3dI0000000000003`0000000`3D?AT0
00000000000?000000030=@m6@000000000000h0000000@0e3dI000000000000e3dI2P0000000`3D
?AT0000000000004000000040=@m6@0000000000000006<0?EV[5`3om^h00`000000ooK^0?ofkP0h
0?ofkP40oooo000k0?ofkP030000003om^h0ooK^01@0ooK^00<0?EV[0?ofkP3om^h05@3om^h00`0m
FJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h000000100ooK^0P0mFJ/C0?ofkP0403eIZ`3om^h0ooK^
03eIZ`l0ooK^00<0?EV[0000000000000P0000001P0l4@T000000000000mFJ/00000054H30800000
0P12G[T00`3D?AT0@Uji049N^@04049N^@030=@m6@12G[T0@Uji00D0@Uji00<00000049N^@12G[T0
0`3D?AT4049N^@0300000012G[T0@Uji00L0@Uji00<00000049N^@3D?AT01`12G[T00`000000@Uji
049N^@06049N^@030000003D?AT0@Uji00L0@Uji00<00000049N^@12G[T01P12G[T00`3D?AT00000
049N^@07049N^@0300000012G[T0@Uji00D0@Uji00<0e3dI049N^@0000002@12G[T00`000000@Uji
049N^@02049N^@<0e3dI0P12G[T00`000000@Uji049N^@05049N^@030=@m6@12G[T0@Uji00@0@Uji
00<0e3dI049N^@12G[T00P0000000`3oD1l0000003eIZ`02000000060?U87000000000000000003o
m^h0?EV[3`3om^h0100mFJ/0ooK^0?ofkP0mFJ/C0?ofkP80?EV[403om^h00`000000ooK^03eIZ`04
0?ofkP0303eIZ`3om^h0ooK^01D0ooK^00<0?EV[0?ofkP3om^h0503om^h00`000000ooK^0?ofkP0i
0?ofkP40oooo000k0?ofkP030000003om^h0ooK^01@0ooK^00<0?EV[0?ofkP3om^h05@3om^h00`0m
FJ/0ooK^0?ofkP020?ofkSd0?EV[0P0000001`0l4@T00000000000000000?EV[0000001A60`00P00
0003049N^@030=@m6@12G[T0@Uji00<0@Uji00<0e3dI049N^@12G[T01P12G[T010000000@Uji049N
^@12G[T20=@m6@@0@Uji00<00000049N^@12G[T01P12G[T00`000000@Uji0=@m6@07049N^@030000
0012G[T0@Uji00H0@Uji00<000000=@m6@12G[T01`12G[T00`000000@Uji049N^@06049N^@030=@m
6@000000@Uji00L0@Uji00<00000049N^@12G[T01@12G[T00`3D?AT0@Uji00000008049N^@030000
0012G[T0@Uji0080@Uji0P3D?AT3049N^@0300000012G[T0@Uji00H0@Uji00<0e3dI049N^@12G[T0
0`12G[T0103D?AT0@Uji049N^@12G[T2000000040?m@7`000000?EV[0?m@7`80000000<0nDPL0000
00000000?@0mFJ/40?ofkP0303eIZ`3om^h0ooK^01D0ooK^00<0?EV[0?ofkP3om^h0503om^h00`00
0000ooK^0?ofkP0i0?ofkP40oooo000k0?ofkP030000003om^h0ooK^01@0ooK^00<0?EV[0?ofkP3o
m^h05@3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0403eIZ`3om^h0ooK^000000l0ooK^0P0mFJ/C0?of
kP0403eIZ`3om^h0ooK^03eIZ`l0ooK^00<0?EV[0?ofkP000000100000000`1A60`0?EV[054H3002
0000000306hR40000000@Uji0080@Uji00<0e3dI049N^@12G[T00P12G[T00`3D?AT00000049N^@06
049N^@0600000012G[T0@Uji049N^@3D?AT0@Uji0`3D?AT00`12G[T00000049N^@08049N^@030000
003D?AT0@Uji00H0@Uji00<00000049N^@12G[T01P12G[T00`000000e3dI049N^@07049N^@030000
0012G[T0@Uji00H0@Uji00<0e3dI00000012G[T01`12G[T00`000000@Uji049N^@05049N^@030=@m
6@000000@Uji00P0@Uji00<00000049N^@3D?AT00P3D?AT00`12G[T0e3dI049N^@02049N^@030000
0012G[T0@Uji00D0@Uji00<000000=@m6@12G[T00`12G[T01P3D?AT0@Uji049N^@12G[T000000?mE
8P80000000<0oe0O03eIZ`3oD1l01@0000000`3om^h0?EV[0?ofkP0>0?ofkP0403eIZ`3om^h0ooK^
03eIZa<0ooK^0P0mFJ/?0?ofkP040000003om^h0ooK^03eIZ`@0ooK^00<0?EV[0?ofkP3om^h05@3o
m^h00`0mFJ/0ooK^0?ofkP0D0?ofkP030000003om^h0ooK^03T0ooK^0@3oool003`0ooK^00<00000
0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP0E0?ofkP0303eIZ`3om^h0ooK^0080ooK^00@0?EV[
0?ofkP3om^h000003`3om^h203eIZa<0ooK^00@0?EV[0?ofkP3om^h0?EV[3`3om^h00`0mFJ/0ooK^
0000000400000003054H300mFJ/0DAP<0080000000<0KR8@00000012G[T00`12G[T01P3D?AT0@Uji
049N^@12G[T0e3dI000000P0@Uji00@00000049N^@12G[T0e3dI1012G[T30=@m6@P0@Uji00<00000
0=@m6@12G[T01`12G[T00`000000@Uji049N^@05049N^@030000003D?AT0@Uji00L0@Uji00<00000
049N^@12G[T01P12G[T00`3D?AT00000049N^@06049N^@0300000012G[T0@Uji00H0@Uji00<0e3dI
00000012G[T01`12G[T30=@m6@@0@Uji00@0e3dI049N^@12G[T000002012G[T00`000000e3dI049N
^@02049N^@030=@m6@12G[T0@Uji0080@Uji00<000000?mE8P0000000P0000000`0mFJ/0oe0O0000
0004000000030?ofkP0mFJ/0ooK^00h0ooK^00@0?EV[0?ofkP3om^h0?EV[4`3om^h203eIZ`l0ooK^
00@000000?ofkP3om^h0?EV[103om^h00`0mFJ/0ooK^0?ofkP0E0?ofkP0303eIZ`3om^h0ooK^01<0
ooK^00<000000?ofkP3om^h0>P3om^h10?ooo`00?03om^h00`000000ooK^0?ofkP0C0?ofkP0303eI
Z`3om^h0ooK^01D0ooK^00<0?EV[0?ofkP3om^h00P3om^h0100mFJ/0ooK^0?ofkP00000?0?ofkP80
?EV[4`3om^h0100mFJ/0ooK^0?ofkP0mFJ/?0?ofkP0303eIZ`3om^h000000080000000L0?1490000
001A60`0?EV[0000001A60`000000080KR8@00<00000049N^@12G[T00P12G[T01P3D?AT0@Uji049N
^@3D?AT0@Uji000000L0@Uji00@00000049N^@12G[T0e3dI1P12G[T00`000000e3dI0=@m6@06049N
^@030000003D?AT0@Uji00L0@Uji00<00000049N^@12G[T01@12G[T00`000000e3dI049N^@07049N
^@0300000012G[T0@Uji00H0@Uji00<0e3dI00000012G[T01P12G[T00`000000@Uji049N^@06049N
^@030=@m6@000000@Uji00D0@Uji0P3D?AT00`000000@Uji049N^@04049N^@040=@m6@12G[T0@Uji
000000L0@Uji00<00000049N^@3D?AT00P12G[T00`3D?AT0@Uji049N^@02049N^@0:0000003oEB80
oeDR0000003oD1l0000003eIZ`3oD1l000000?U870<0000000<0ooK^03eIZ`3om^h03P3om^h0100m
FJ/0ooK^0?ofkP0mFJ/C0?ofkP80?EV[3`3om^h010000000ooK^0?ofkP0mFJ/40?ofkP0303eIZ`3o
m^h0ooK^01D0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`000000ooK^0?ofkP0j0?ofkP40oooo000l
0?ofkP030000003om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h05@3om^h00`0mFJ/0ooK^0?ofkP02
0?ofkP0403eIZ`3om^h0ooK^000000l0ooK^0P0mFJ/C0?ofkP0403eIZ`3om^h0ooK^03eIZ`l0ooK^
00<0?EV[0?ofkP000000100000001@1A60`0?EV[0000001A60`0000000<0KR8@00<00000049N^@12
G[T00P12G[T01@3D?AT0@Uji0=@m6@12G[T0000000P0@Uji00<00000049N^@3D?AT01P12G[T00`00
0000@Uji049N^@030=@m6@<0@Uji00<000000=@m6@12G[T01`12G[T00`000000@Uji049N^@05049N
^@030000003D?AT0@Uji00L0@Uji00<00000049N^@12G[T01P12G[T00`3D?AT00000049N^@06049N
^@0300000012G[T0@Uji00H0@Uji00<0e3dI00000012G[T00P12G[T30=@m6@80@Uji00<00000049N
^@12G[T01012G[T00`3D?AT0@Uji00000008049N^@0500000012G[T0e3dI049N^@3D?AT01012G[T0
10000000oeDR0?mE8P3D?AT2000000030?m@7`0mFJ/0oe0O00D0000000<0ooK^03eIZ`3om^h03P3o
m^h0100mFJ/0ooK^0?ofkP0mFJ/C0?ofkP80?EV[3`3om^h010000000ooK^0?ofkP0mFJ/40?ofkP03
03eIZ`3om^h0ooK^01D0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`000000ooK^0?ofkP0j0?ofkP40
oooo000m0?ofkP030000003om^h0ooK^0180ooK^00<0?EV[0?ofkP3om^h05@3om^h00`0mFJ/0ooK^
0?ofkP020?ofkP0503eIZ`3om^h0ooK^0?ofkP0000003P3om^h203eIZa<0ooK^00@0?EV[0?ofkP3o
m^h0?EV[3`3om^h00`0mFJ/0ooK^000000050000000303eIZ`1A60`00000008000000P1^8Q000`00
0000@Uji049N^@03049N^@80e3dI0P12G[T00`000000@Uji049N^@05049N^@0300000012G[T0e3dI
00L0@Uji00<00000049N^@12G[T00P12G[T30=@m6@03049N^@3D?AT0@Uji00L0@Uji00<00000049N
^@12G[T01P12G[T00`3D?AT0@Uji049N^@06049N^@0300000012G[T0@Uji00H0@Uji00<0e3dI049N
^@12G[T01P12G[T00`000000@Uji049N^@06049N^@030=@m6@12G[T0e3dI0080e3dI1012G[T00`00
0000@Uji049N^@05049N^@030=@m6@12G[T0000000L0@Uji00<00000049N^@12G[T00P3D?AT5049N
^@030000003oEB80oeDR00<0000000<0oe0O03eIZ`0000001@0000000`3om^h0?EV[0?ofkP0>0?of
kP0403eIZ`3om^h0ooK^03eIZa<0ooK^0P0mFJ/>0?ofkP050000003om^h0ooK^0?ofkP0mFJ/0103o
m^h00`0mFJ/0ooK^0?ofkP0E0?ofkP0303eIZ`3om^h0ooK^0180ooK^00<000000?ofkP3om^h0>`3o
m^h10?ooo`00?@3om^h00`000000ooK^0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^01D0ooK^00<0?EV[
0?ofkP3om^h00P3om^h01@0mFJ/0ooK^0?ofkP3om^h0000000h0ooK^0P0mFJ/C0?ofkP0403eIZ`3o
m^h0ooK^03eIZ`l0ooK^00<0?EV[0?ofkP3om^h00P0000001@0l4@T000000000000mFJ/0DAP<00<0
00000`1^8Q000`000000@Uji049N^@03049N^@040=@m6@12G[T0@Uji000000P0@Uji00<000000=@m
6@12G[T01P12G[T00`000000@Uji049N^@05049N^@@0e3dI1P12G[T00`000000@Uji049N^@06049N
^@030=@m6@12G[T0@Uji00H0@Uji00<00000049N^@12G[T01P12G[T00`3D?AT0@Uji049N^@06049N
^@0300000012G[T0@Uji00@0@Uji103D?AT7049N^@0300000012G[T0@Uji00D0@Uji00<0e3dI0000
0012G[T01`12G[T010000000@Uji049N^@3D?AT5049N^@060000003oEB80oeDR0000003oEB800000
0P3oD1l0100mFJ/000000000003iB1`200000080ooK^00<0?EV[0?ofkP3om^h03@3om^h0100mFJ/0
ooK^0?ofkP0mFJ/C0?ofkP80?EV[3P3om^h01@000000ooK^0?ofkP3om^h0?EV[00@0ooK^00<0?EV[
0?ofkP3om^h05@3om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP030000003om^h0ooK^03/0ooK^0@3oool0
03d0ooK^00<000000?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP0303eIZ`3om^h0ooK^
0080ooK^00D0?EV[0?ofkP3om^h0ooK^0000000>0?ofkP80?EV[4P3om^h01@0mFJ/0ooK^0?ofkP3o
m^h0?EV[00l0ooK^00<0?EV[0?ofkP3om^h00P000000100l4@T00000054H300mFJ/2054H30<00000
0`1^8Q000`000000@Uji049N^@02049N^@<0e3dI00<0@Uji00000012G[T01P12G[T00`000000e3dI
049N^@06049N^@0300000012G[T0@Uji00H0@Uji00<0e3dI049N^@12G[T01P3D?AT00`000000@Uji
049N^@06049N^@030=@m6@12G[T0@Uji00H0@Uji00<00000049N^@12G[T01P12G[T00`3D?AT0@Uji
049N^@06049N^@030000003D?AT0e3dI00@0e3dI0P12G[T00`3D?AT0@Uji049N^@06049N^@030000
0012G[T0@Uji00@0@Uji00<0e3dI049N^@0000001`12G[T00`000000@Uji0=@m6@020=@m6@@0@Uji
00@000000?mE8P3oEB80oeDR0`0000020?m@7`0403eIZ`00000000000?U8708000000P3om^h00`0m
FJ/0ooK^0?ofkP0=0?ofkP0403eIZ`3om^h0ooK^03eIZa<0ooK^0P0mFJ/>0?ofkP050000003om^h0
ooK^0?ofkP0mFJ/0103om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0
00000?ofkP3om^h0>`3om^h10?ooo`00?P3om^h00`000000ooK^0?ofkP0B0?ofkP0303eIZ`3om^h0
ooK^01@0ooK^00<0?EV[0?ofkP3om^h00P3om^h01@0mFJ/0ooK^0?ofkP3om^h0000000h0ooK^0P0m
FJ/B0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/03`3om^h00`0mFJ/0ooK^0?ofkP050000000303eI
Z`000000DAP<0080000000D0KR8@0000001^8Q00KR8@00000004049N^@030=@m6@12G[T0@Uji0080
e3dI2012G[T00`000000e3dI049N^@06049N^@0300000012G[T0@Uji00D0@Uji00<0e3dI049N^@12
G[T01P12G[T60=@m6@<0@Uji00<0e3dI049N^@12G[T01P12G[T00`000000@Uji049N^@06049N^@04
0=@m6@12G[T0@Uji049N^@H0e3dI2012G[T00`3D?AT0@Uji049N^@05049N^@0300000012G[T0@Uji
00D0@Uji00<0e3dI00000012G[T01`12G[T20=@m6@80@Uji00<0e3dI049N^@12G[T00P12G[T01P00
0000oeDR0?mE8P000000oeDR00000080oe0O00<0000003eIZ`000000100000020?ofkP0303eIZ`3o
m^h0ooK^00d0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0B0?ofkP80?EV[3P3om^h01@000000ooK^
0?ofkP3om^h0?EV[00@0ooK^00<0?EV[0?ofkP3om^h0503om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP03
0000003om^h0ooK^03`0ooK^0@3oool003h0ooK^00<000000?ofkP3om^h04P3om^h00`0mFJ/0ooK^
0?ofkP0D0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h00P3om^h00`000000ooK^
0?ofkP0;0?ofkP80?EV[4P3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00l0ooK^00<0?EV[0?ofkP3o
m^h00`000000100l4@T0000003eIZ`000002054H30040000001^8Q00KR8@00000080KR8@00D00000
049N^@12G[T0@Uji0=@m6@04049N^@80e3dI1P12G[T00`000000e3dI049N^@06049N^@0300000012
G[T0@Uji00D0@Uji00<0e3dI00000012G[T01`12G[T00`000000@Uji049N^@02049N^AT0e3dI1012
G[T00`000000@Uji049N^@06049N^@030000003D?AT0@Uji00H0@Uji00<00000049N^@12G[T01@12
G[T00`3D?AT00000049N^@05049N^@80e3dI1012G[T01@3D?AT0@Uji049N^@12G[T000000080oeDR
00@000000?mE8P3oEB8000000P3oD1l010000000?EV[0000003iB1`300000080ooK^00<0?EV[0?of
kP3om^h03@3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[0180ooK^0P0mFJ/=0?ofkP030000003om^h0
ooK^0080ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP0303eIZ`3om^h0
ooK^0180ooK^00<000000?ofkP3om^h0?03om^h10?ooo`00?P3om^h00`000000ooK^0?ofkP0B0?of
kP0303eIZ`3om^h0ooK^01@0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP020?of
kP030000003om^h0ooK^00/0ooK^0P0mFJ/B0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/03`3om^h0
0`0mFJ/0ooK^0?ofkP020000000703`A2@000000000003eIZ`1A60`00000054H30020000000506hR
40000000KR8@06hR400000000`12G[T00`3D?AT0@Uji049N^@02049N^@0300000012G[T0e3dI00H0
@Uji00<0e3dI049N^@12G[T01P12G[T00`000000@Uji049N^@04049N^@030=@m6@000000@Uji00L0
@Uji00<00000049N^@12G[T01@12G[T00`3D?AT0@Uji049N^@06049N^@0300000012G[T0@Uji00H0
@Uji00<0e3dI049N^@12G[T01@12G[T00`000000@Uji049N^@06049N^@030000003D?AT0@Uji00D0
@Uji00<00000049N^@12G[T01P12G[T00`3D?AT0@Uji049N^@04049N^@030=@m6@12G[T0000000<0
@Uji00<0e3dI049N^@12G[T00P12G[T00`000000oeDR000000020?mE8P80000000@0oe0O0000003o
D1l0?EV[0P0000000`3iB1`00000000000020?ofkP0303eIZ`3om^h0ooK^00d0ooK^00D0?EV[0?of
kP3om^h0ooK^03eIZ`0B0?ofkP80?EV[3@3om^h00`000000ooK^0?ofkP020?ofkP0303eIZ`3om^h0
ooK^0080ooK^00<0?EV[0?ofkP3om^h0503om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP030000003om^h0
ooK^03`0ooK^0@3oool003l0ooK^00<000000?ofkP3om^h04@3om^h00`0mFJ/0ooK^0?ofkP0D0?of
kP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h00P3om^h00`000000ooK^0?ofkP0;0?of
kP80?EV[4P3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00l0ooK^00<0?EV[0?ofkP3om^h00P000000
1`0l4@T000000000000mFJ/0DAP<0000001A60`00P00000206hR40030000001^8Q00KR8@00@00000
00<0e3dI000000000000100000020=@m6@@0000000<0e3dI0000000000003@0000000`3D?AT00000
0000000?000000030=@m6@000000000000l0000000<0e3dI0000000000003`0000000`3D?AT00000
0000000=000000030=@m6@0000000000008000000P3D?AT6000000030=@m6@000000000000800000
0P3oEB800`000000oeDR0?mE8P02000000040?m@7`000000oe0O03eIZ`80000000<0nDPL00000000
00000P3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/04P3om^h203eI
Z`d0ooK^00<000000?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^
01@0ooK^00<0?EV[0?ofkP3om^h04@3om^h00`000000ooK^0?ofkP0m0?ofkP40oooo000o0?ofkP03
0000003om^h0ooK^0140ooK^00<0?EV[0?ofkP3om^h0503om^h00`0mFJ/0ooK^0?ofkP020?ofkP03
03eIZ`3om^h0ooK^0080ooK^00<000000?ofkP3om^h02`3om^h203eIZa80ooK^00D0?EV[0?ofkP3o
m^h0ooK^03eIZ`0?0?ofkP0303eIZ`3om^h0ooK^0080000000@0?149000000000000?EV[0P1A60`2
0000000606hR40000000KR8@06hR40000000KR8@0P00000204AR`@030=@m6@14H/40A6;100<0A6;1
00<0000004AR`@14H/400P3D?AT204AR`@030=@m6@000000A6;100H0A6;100<0000004AR`@14H/40
1014H/400`3D?AT0000004AR`@0704AR`@0300000014H/40A6;100D0A6;100<0e3dI04AR`@14H/40
1P14H/400`000000A6;104AR`@0604AR`@030=@m6@14H/40A6;100D0A6;100<0000004AR`@14H/40
1P14H/400`000000e3dI04AR`@0504AR`@0300000014H/40A6;100D0A6;100@000000=@m6@14H/40
A6;10P3D?AT204AR`@0300000014H/40A6;100<0A6;100<0e3dI04AR`@14H/400P000000103oEB80
00000?mE8P3oEB82000000050?m@7`000000oe0O0?m@7`0mFJ/00P0000000`3iB1`000000?ofkP02
0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0B0?ofkP80?EV[3@3o
m^h00`000000ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h0503o
m^h00`0mFJ/0ooK^0?ofkP0A0?ofkP030000003om^h0ooK^03d0ooK^0@3oool003l0ooK^00<00000
0?ofkP3om^h04@3om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[
0?ofkP3om^h00P3om^h00`000000ooK^0?ofkP0;0?ofkP80?EV[4P3om^h01@0mFJ/0ooK^0?ofkP3o
m^h0?EV[00l0ooK^00D0?EV[0?ofkP3om^h0ooK^0000000203`A2@030000000mFJ/000000080DAP<
0P000000101^8Q00000006hR401^8Q020000000409D^5@000000A6;10=@m6@D0A6;100<0000004AR
`@14H/400P14H/430=@m6@0300000014H/40A6;100H0A6;100<0000004AR`@14H/400`14H/400`3D
?AT0A6;10000000704AR`@0300000014H/40A6;100D0A6;100<0e3dI04AR`@14H/401P14H/400`00
0000A6;104AR`@0604AR`@030=@m6@14H/40A6;100D0A6;100<0000004AR`@14H/401@14H/400`00
0000e3dI04AR`@0504AR`@0300000014H/40A6;100H0A6;100@000000=@m6@3D?AT0e3dI1014H/40
0`000000A6;104AR`@0304AR`@040=@m6@14H/4000000?mF8`8000000P3oEB8010000000oeDR0000
000000020?m@7`040000000mFJ/000000?U8708000000`3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP05
03eIZ`3om^h0ooK^0?ofkP0mFJ/04P3om^h203eIZ`d0ooK^00<000000?ofkP3om^h00P3om^h00`0m
FJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^01@0ooK^00<0?EV[0?ofkP3om^h04@3om^h00`00
0000ooK^0?ofkP0m0?ofkP40oooo00100?ofkP030000003om^h0ooK^0100ooK^00<0?EV[0?ofkP3o
m^h0503om^h00`0mFJ/0ooK^0?ofkP020?ofkSl0?EV[0P000000100l4@T0000003eIZ`000002054H
3080000000X0KR8@0000001^8Q00KR8@0000001^8Q00000009D^5@000000e3dI1P14H/400`000000
A6;104AR`@0304AR`@80e3dI00<0000004AR`@14H/401@14H/400`000000A6;104AR`@0404AR`@03
0=@m6@000000A6;100L0A6;100<0000004AR`@14H/401014H/400`3D?AT0A6;104AR`@0604AR`@03
00000014H/40A6;100H0A6;100<0e3dI04AR`@14H/401014H/400`000000A6;104AR`@0604AR`@03
0000003D?AT0A6;100D0A6;100<0000004AR`@14H/401@14H/400`000000e3dI0=@m6@0504AR`@03
00000014H/40A6;100@0A6;100<0e3dI0000003oER<00P0000030?mE8P040000003oEB8000000000
0080oe0O00@0000003eIZ`000000nDPL0P00000o03eIZ`@0ooK^00<0?EV[0?ofkP3om^h0503om^h0
0`0mFJ/0ooK^0?ofkP0@0?ofkP030000003om^h0ooK^03h0ooK^0@3oool00400ooK^00<000000?of
kP3om^h0403om^i^03eIZ`030=@m6@14H/40A6;100D0A6;100<0000004AR`@14H/400P14H/400`3D
?AT0A6;10=@m6@020=@m6@H0A6;100<0000004AR`@14H/400`14H/400`3D?AT0A6;10000000704AR
`@0300000014H/40A6;100@0A6;100<0e3dI00000014H/401P14H/400`000000A6;104AR`@0504AR
`@030000003D?AT0A6;100D0A6;100<0000004AR`@14H/401@14H/400`000000A6;10=@m6@0504AR
`@0300000014H/40A6;100@0A6;10`3D?AT00`14H/40e3dI04AR`@0304AR`@0300000014H/40A6;1
00D0A6;100<0e3dI03eIZ`0mFJ/0K00mFJ/B0?ofkP030000003om^h0ooK^03h0ooK^0@3oool00400
ooK^00<000000?ofkP3om^h0403om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP0303eIZ`3om^h0ooK^0080
ooK^00<0?EV[0?ofkP3om^h00`3om^h00`000000ooK^0?ofkP0:0?ofkP80?EV[4P3om^h01@0mFJ/0
ooK^0?ofkP3om^h0?EV[00l0ooK^00@0?EV[0?ofkP3om^h0ooK^0`0000001P0l4@T0?EV[054H301A
60`00000054H308000000P1^8Q0010000000KR8@06hR4000000209D^5@0300000014H/40A6;100D0
A6;100<0000004AR`@14H/400P14H/401@3D?AT0A6;104AR`@000000A6;100<0e3dI0`14H/400`00
0000A6;104AR`@0304AR`@030=@m6@14H/40000000L0A6;100<0000004AR`@14H/401014H/400`3D
?AT0000004AR`@0604AR`@0300000014H/40A6;100D0A6;100<000000=@m6@14H/401@14H/400`00
0000A6;104AR`@0504AR`@0300000014H/40e3dI00D0A6;100@0000004AR`@14H/40A6;10`3D?AT0
1@14H/40000004AR`@14H/40e3dI00@0A6;100<0000004AR`@14H/401@14H/4010000000oeHS0?mF
8`0000020?mE8P030000003oEB80oeDR0080000000H0oe0O0000003oD1l0oe0O03eIZ`3iB1`30000
00<0ooK^00<0?EV[0?ofkP3om^h03@3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[0180ooK^0P0mFJ/<
0?ofkP030000003om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP0D
0?ofkP0303eIZ`3om^h0ooK^0100ooK^00<000000?ofkP3om^h0?P3om^h10?ooo`00@03om^h00`00
0000ooK^0?ofkP0@0?ofkP0303eIZ`3om^h0ooK^01@0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0m
FJ/0ooK^0?ofkP030?ofkP030000003om^h0ooK^00X0ooK^0P0mFJ/B0?ofkP0503eIZ`3om^h0ooK^
0?ofkP0mFJ/03`3om^h0100mFJ/0ooK^0?ofkP3om^h30000000603`A2@0mFJ/00000054H30000000
DAP<0P00000206hR40030000001^8Q00KR8@008000000P2E;QD00`000000A6;104AR`@0504AR`@05
00000014H/40A6;104AR`@3D?AT00`14H/4010000000A6;104AR`@14H/420=@m6@80A6;100<00000
04AR`@14H/400P14H/400`3D?AT0A6;10000000704AR`@0300000014H/40A6;100@0A6;100<0e3dI
00000014H/401P14H/400`000000A6;104AR`@0504AR`@030000003D?AT0A6;100D0A6;100<00000
04AR`@14H/401@14H/400`000000A6;10=@m6@0404AR`@0300000014H/40A6;10080e3dI0`14H/40
1@000000A6;104AR`@14H/40e3dI00<0A6;100<0000004AR`@14H/401@14H/400`000000oeHS0?mF
8`0200000080oeDR00<000000?mE8P3oEB800P0000001`3oD1l000000?m@7`000000?EV[0000003i
B1`00P0000030?ofkP0303eIZ`3om^h0ooK^00d0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0B0?of
kP80?EV[303om^h00`000000ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?of
kP3om^h0503om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP030000003om^h0ooK^03h0ooK^0@3oool00440
ooK^00<000000?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP0303eIZ`3om^h0ooK^0080
ooK^00<0?EV[0?ofkP3om^h0103om^h00`000000ooK^0?ofkP090?ofkP80?EV[4P3om^h01@0mFJ/0
ooK^0?ofkP3om^h0?EV[00l0ooK^00@0?EV[0?ofkP3om^h0ooK^0P000000100l4@T0000003eIZ`00
0002054H3080000000T0KR8@0000001^8Q00KR8@0000001^8Q00000009D^5@0000000P2E;QD00`00
0000A6;104AR`@0504AR`@0400000014H/40A6;10=@m6@<0A6;100<0000004AR`@14H/400`14H/43
0=@m6@@0A6;100@0e3dI04AR`@14H/4000001`14H/400`000000A6;104AR`@0304AR`@030=@m6@00
0000A6;100H0A6;100<0000004AR`@14H/401@14H/400`000000e3dI04AR`@0404AR`@0300000014
H/40A6;100D0A6;100@0000004AR`@14H/40e3dI1014H/430=@m6@D0A6;100D0000004AR`@14H/40
A6;10=@m6@0204AR`@0300000014H/40A6;100D0A6;100P000000?mF8`3oER<000000?mF8`000000
oeDR00000080oeDR00@000000?mE8P00000000000P3oD1l01@000000?EV[0000003iB1`0000000@0
ooK^00<0?EV[0?ofkP3om^h03@3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[0180ooK^0P0mFJ/;0?of
kP030000003om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP0D0?of
kP0303eIZ`3om^h0ooK^00l0ooK^00<000000?ofkP3om^h0?`3om^h10?ooo`00@@3om^h00`000000
ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^01@0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0
ooK^0?ofkP040?ofkP030000003om^h0ooK^00T0ooK^0P0mFJ/B0?ofkP0503eIZ`3om^h0ooK^0?of
kP0mFJ/03`3om^h00`0mFJ/0ooK^0?ofkP020?ofkP070000000l4@T0000003eIZ`1A60`00000054H
300200000080KR8@00<0000006hR401^8Q000P0000000`2E;QD0000009D^5@0209D^5@0300000014
H/40A6;100D0A6;100<0000004AR`@3D?AT01014H/400`000000A6;104AR`@0504AR`@<0e3dI00D0
A6;10=@m6@14H/40A6;10000000704AR`@0300000014H/40A6;100<0A6;100<0e3dI00000014H/40
1P14H/400`000000A6;104AR`@0504AR`@030000003D?AT0A6;100@0A6;100<0000004AR`@14H/40
1@14H/401@000000A6;104AR`@3D?AT0A6;100<0e3dI1`14H/400`000000A6;104AR`@0204AR`@03
0=@m6@14H/40000000L0A6;100@000000?mF8`3oER<000000P3oER<200000080oeDR00<000000?mE
8P3oEB800P000000103oD1l000000000000mFJ/20?U870030000003om^h0ooK^0080ooK^00<0?EV[
0?ofkP3om^h03@3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[0180ooK^0P0mFJ/;0?ofkP030000003o
m^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP0303eIZ`3o
m^h0ooK^00l0ooK^00<000000?ofkP3om^h0?`3om^h10?ooo`00@@3om^h00`000000ooK^0?ofkP0?
0?ofkP0303eIZ`3om^h0ooK^01@0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP04
0?ofkP030000003om^h0ooK^00T0ooK^0P0mFJ/B0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/03`3o
m^h00`0mFJ/0ooK^0?ofkP020?ofkP80000000@0?14903eIZ`00000000000P1A60`01P000000KR8@
06hR401^8Q00000006hR408000000P2E;QD01@000000UBhE09D^5@2E;QD0000000H0A6;100<00000
04AR`@3D?AT01@14H/400`000000A6;104AR`@0404AR`@0300000014H/40A6;100@0e3dI00<00000
04AR`@14H/401@14H/400`000000A6;104AR`@0304AR`@030=@m6@000000A6;100H0A6;100<00000
04AR`@14H/401@14H/400`000000e3dI04AR`@0404AR`@0300000014H/40A6;100D0A6;100<00000
0=@m6@3D?AT00P3D?AT204AR`@0300000014H/40A6;100@0A6;100<0000004AR`@14H/400`14H/40
0`3D?AT0A6;10000000604AR`@050000003oER<0oeHS0?mF8`0000000P3oER<2000000030?mE8P00
0000oeDR0080oeDR00<000000?m@7`3oD1l00P000000100mFJ/0nDPL0000000000040?ofkP0303eI
Z`3om^h0ooK^00d0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0B0?ofkP80?EV[2`3om^h00`000000
ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h0503om^h00`0mFJ/0
ooK^0?ofkP0?0?ofkP030000003om^h0ooK^03l0ooK^0@3oool00480ooK^00<000000?ofkP3om^h0
3P3om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/01`3om^h00`000000
ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^0140ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0?0?of
kP0303eIZ`3om^h0ooK^0080ooK^0P0000001P0l4@T0?EV[0000001A60`00000054H308000000P1^
8Q0010000000KR8@06hR4000000309D^5@040000002E;QD0UBhE000000L0A6;100<000000=@m6@14
H/401014H/400`000000A6;104AR`@0504AR`@0400000014H/40A6;10=@m6@80A6;11P3D?AT204AR
`@0300000014H/40A6;100<0A6;100<0e3dI04AR`@0000001P14H/400`000000A6;104AR`@0404AR
`@0300000014H/40e3dI00D0A6;100<0000004AR`@14H/401P3D?AT204AR`@040=@m6@14H/40A6;1
000000L0A6;100<0000004AR`@14H/400P14H/400`3D?AT0A6;10000000704AR`@040000003oER<0
oeHS000000<0oeHS00@000000?mE8P3oEB8000000P3oEB82000000060?m@7`000000oe0O0000000m
FJ/0nDPL0P0000040?ofkP0303eIZ`3om^h0ooK^00d0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0B
0?ofkP80?EV[2`3om^h00`000000ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[
0?ofkP3om^h0503om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP030000003om^h0ooK^0400ooK^0@3oool0
0480ooK^00<000000?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP0503eIZ`3om^h0ooK^
0?ofkP0mFJ/0203om^h00`000000ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^0140ooK^00D0?EV[
0?ofkP3om^h0ooK^03eIZ`0?0?ofkP0303eIZ`3om^h0ooK^0080ooK^0`000000100mFJ/00000054H
301A60`20000000606hR40000000KR8@06hR40000000KR8@0P00000309D^5@040000002E;QD0UBhE
000000L0A6;100<000000=@m6@14H/401014H/400`000000A6;104AR`@0404AR`@0400000014H/40
A6;10=@m6@<0A6;100<0000004AR`@14H/400P14H/460=@m6@80A6;100<0e3dI04AR`@0000001P14
H/400`000000A6;104AR`@0404AR`@0300000014H/40e3dI0080A6;11P3D?AT404AR`@0500000014
H/40A6;104AR`@3D?AT00P14H/400`000000A6;104AR`@0404AR`@0300000014H/40A6;100<0A6;1
00<0e3dI00000014H/401P14H/4010000000oeHS0?mF8`0000030?mF8`80000000H0oeDR0000003o
EB80oeDR0000003oEB8200000080oe0O00<0000003eIZ`0000000P0000040?ofkP0303eIZ`3om^h0
ooK^00d0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0C0?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0
00000?ofkP3om^h01P3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[01H0ooK^00<0?EV[0?ofkP3om^h0
3P3om^h00`000000ooK^0?ofkP100?ofkP40oooo00120?ofkP030000003om^h0ooK^00h0ooK^00<0
?EV[0?ofkP3om^h0503om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00P0ooK^00<000000?ofkP3om^h0
203om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/03`3om^h00`0mFJ/0
ooK^0?ofkP020?ofkP<0000000@0?EV[000000000000DAP<0P0000000`1^8Q00000006hR400206hR
4080000000<0UBhE0000002E;QD00P2E;QD010000000UBhE09D^5@00000604AR`@030000003D?AT0
A6;100@0A6;100<0000004AR`@14H/401@14H/400`000000A6;10=@m6@0404AR`@0300000014H/40
A6;100@0A6;100<0000004AR`@14H/405`3D?AT204AR`@0300000014H/40A6;100@0A6;100<00000
04AR`@14H/400P14H/400`3D?AT0A6;10000000704AR`@0300000014H/40A6;100<0A6;100<0e3dI
00000014H/401@14H/4010000000oeHS0?mF8`0000030?mF8`040000003oER<00000000000<0oeDR
0P0000000`3oD1l000000?m@7`020000000403eIZ`0000000000000000@0ooK^00<0?EV[0?ofkP3o
m^h03@3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[0180ooK^0P0mFJ/:0?ofkP030000003om^h0ooK^
00H0ooK^00@0?EV[0?ofkP3om^h0?EV[5P3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP030000003om^h0
ooK^0400ooK^0@3oool004<0ooK^00<000000?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0D0?of
kP0403eIZ`3om^h0ooK^03eIZ`P0ooK^2`00000203eIZa80000000D0?EV[000000000000000003eI
Z`0?0000000303eIZ`000000000000@0000000@0?14903eIZ`00000000000P1A60`20000000306hR
40000000KR8@0080KR8@0P0000000`2E;QD0000009D^5@0209D^5@030000002E;QD0UBhE00L00000
00<0e3dI0000000000003@0000000`3D?AT000000000000>000000030=@m6@000000000000l00000
00<0e3dI0000000000003P0000000`3D?AT000000000000=000000030=@m6@000000000000D00000
0P3oER<01P000000oeHS0?mF8`3oER<000000?mF8`8000000`3oEB8010000000oeDR000000000002
0?m@7`80000000<0?EV[0?U8700000001@0000000`0mFJ/000000000000=0000000503eIZ`000000
00000000000mFJ/04P00000203eIZ`/00000203om^h0100mFJ/0ooK^0?ofkP0mFJ/F0?ofkP0303eI
Z`3om^h0ooK^00h0ooK^00<000000?ofkP3om^h0@@3om^h10?ooo`00@`3om^h00`000000ooK^0?of
kP0>0?ofkP0303eIZ`3om^h0ooK^01@0ooK^00@0?EV[0?ofkP3om^h0?EV[203om^h00`000000ooK^
0?ofkP080?ofkP80?EV[4P3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00l0ooK^00<0?EV[0?ofkP3o
m^h00P3om^h20000000603`A2@0mFJ/00000054H30000000DAP<0P00000206hR40030000001^8Q00
KR8@008000000P2E;QD010000000UBhE09D^5@00000209D^5@8000001@16ILL00`3D?AT0000004IU
a`0504IUa`0300000016ILL0AVG700<0AVG700<0000004IUa`3D?AT01016ILL00`000000AVG704IU
a`0404IUa`0300000016ILL0AVG70080AVG700<0e3dI04IUa`0000001P16ILL00`000000AVG704IU
a`0404IUa`0300000016ILL0e3dI00@0AVG700<0000004IUa`16ILL01016ILL00`000000AVG704IU
a`0204IUa`030=@m6@000000AVG700D0AVG700<0000004IUa`16ILL01016ILL00`000000e3dI04IU
a`0404IUa`80000000<0oeHS0000003oER<00P3oER<00`000000oeHS0?mF8`0200000080oeDR00<0
00000?mE8P3oEB800P0000001P3oD1l000000?m@7`000000?EV[0?U870800000103om^h00`0mFJ/0
ooK^0?ofkP0=0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/04P3om^h203eIZ`X0ooK^00<000000?of
kP3om^h01P3om^h0100mFJ/0ooK^0?ofkP0mFJ/F0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<00000
0?ofkP3om^h0@@3om^h10?ooo`00@`3om^h00`000000ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^
01@0ooK^00@0?EV[0?ofkP3om^h0?EV[203om^h00`000000ooK^0?ofkP080?ofkP80?EV[4P3om^h0
1@0mFJ/0ooK^0?ofkP3om^h0?EV[00l0ooK^00<0?EV[0?ofkP3om^h00P3om^h30000000703eIZ`00
0000DAP<054H30000000DAP<0000000306hR40040000001^8Q00KR8@000000<0UBhE00T0000009D^
5@2E;QD0000009D^5@000000]SLH0000003D?AT00`16ILL00`3D?AT0AVG70000000504IUa`030000
0016ILL0AVG700@0AVG700<000000=@m6@16ILL01016ILL00`000000AVG704IUa`0304IUa`030000
0016ILL0AVG70080AVG700<0e3dI04IUa`0000001P16ILL00`000000AVG704IUa`0404IUa`030000
0016ILL0e3dI00<0AVG700<0000004IUa`16ILL01016ILL00`000000AVG704IUa`0304IUa`030=@m
6@000000AVG700D0AVG700<0000004IUa`16ILL00`16ILL00`000000AVG70=@m6@0304IUa`060=@m
6@000000oeHS0000003oER<000000P3oER<01@000000oeHS0?mF8`3oER<000000080oeDR00L00000
0?mE8P3oEB80e3dI0000003oD1l000000080oe0O00<0000003eIZ`0000000P0000040?ofkP0303eI
Z`3om^h0ooK^00d0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0B0?ofkP80?EV[2P3om^h00`000000
ooK^0?ofkP060?ofkP0403eIZ`3om^h0ooK^03eIZaH0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`00
0000ooK^0?ofkP110?ofkP40oooo00140?ofkP030000003om^h0ooK^00d0ooK^00<0?EV[0?ofkP3o
m^h0503om^h0100mFJ/0ooK^0?ofkP0mFJ/80?ofkP030000003om^h0ooK^00P0ooK^0P0mFJ/B0?of
kP0503eIZ`3om^h0ooK^0?ofkP0mFJ/03`3om^h00`0mFJ/0ooK^0?ofkP020?ofkP<0000000H0?EV[
0000001A60`0DAP<0000001A60`2000000<0KR8@00@0000006hR4000000000000P2E;QD010000000
UBhE09D^5@2E;QD2000000030;Hg600mFJ/000000080e3dI00@0AVG70=@m6@16ILL000001P16ILL0
0`000000AVG704IUa`0304IUa`030000003D?AT0AVG700@0AVG700<0000004IUa`16ILL01016ILL0
1`000000AVG704IUa`16ILL0e3dI04IUa`0000001P16ILL00`000000AVG704IUa`0304IUa`040000
0016ILL0AVG70=@m6@<0AVG700<0000004IUa`16ILL01016ILL00`000000AVG704IUa`0304IUa`03
0=@m6@16ILL0AVG700@0AVG700<0000004IUa`16ILL00`16ILL01@000000AVG704IUa`3D?AT0AVG7
0080e3dI00<0000003eIZ`3oER<00P0000030?mF8`030000003oER<0oeHS0080000000<0oeDR0000
003oEB800P3oEB82000000060?m@7`000000oe0O0?m@7`000000?EV[0`0000040?ofkP0303eIZ`3o
m^h0ooK^00d0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0B0?ofkP80?EV[2P3om^h00`000000ooK^
0?ofkP060?ofkP0403eIZ`3om^h0ooK^03eIZaH0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`000000
ooK^0?ofkP120?ofkP40oooo00140?ofkP030000003om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h0
503om^h00`0mFJ/0ooK^0?ofkP1103eIZ`040000000X2`D0000003eIZ`8000000P1A60`200000009
06hR40000000KR8@06hR40000000KR8@0000002E;QD000000080UBhE00X0000009D^5@2E;QD0UBhE
0000002f=aP0?EV[0;Hg60000000AVG70`3D?AT00`16ILL0000004IUa`0504IUa`0300000016ILL0
AVG700<0AVG700<0e3dI04IUa`16ILL01016ILL00`000000AVG704IUa`0304IUa`0500000016ILL0
AVG704IUa`3D?AT00P16ILL00`000000AVG704IUa`0304IUa`0300000016ILL0AVG700<0AVG700@0
000004IUa`16ILL0e3dI0`16ILL00`000000AVG704IUa`0304IUa`0300000016ILL0AVG700@0AVG7
00<0e3dI04IUa`16ILL00`16ILL00`000000AVG704IUa`0404IUa`0300000016ILL0e3dI0080e3dI
00H0AVG70000003oER<0?EV[0?mF8`0000030?mF8`080000003oER<0oeHS0000003oER<000000?mE
8P0000020?mE8P040000003oEB80000000000080oe0O0P000000100mFJ/000000</j5P00001103eI
Z`80ooK^00<0?EV[0?ofkP3om^h0503om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP030000003om^h0ooK^
0480ooK^0@3oool004@0ooK^00<000000?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP04
03eIZ`3om^h0ooK^03eIZ`L0ooK^00<000000?ofkP3om^h02@3om^h203eIZa80ooK^00D0?EV[0?of
kP3om^h0ooK^03eIZ`0?0?ofkP0303eIZ`3om^h0ooK^0080ooK^00@0000002P;1@000000?EV[0P00
0003054H3080000000@0KR8@0000001^8Q00KR8@0P00000209D^5@040000002E;QD0UBhE00000080
UBhE0P0000001`0mFJ/0]SLH0;Hg60000000AVG70=@m6@16ILL00P3D?AT00`000000AVG704IUa`03
04IUa`0300000016ILL0AVG700<0AVG700<0e3dI04IUa`16ILL01016ILL00`000000AVG704IUa`03
04IUa`0500000016ILL0AVG704IUa`3D?AT00P16ILL00`000000AVG704IUa`0304IUa`0300000016
ILL0AVG700<0AVG700@0000004IUa`16ILL0e3dI0`16ILL00`000000AVG704IUa`0304IUa`030000
0016ILL0AVG700<0AVG700<000000=@m6@16ILL01016ILL00`000000AVG704IUa`0304IUa`070000
003D?AT0e3dI04IUa`3D?AT0AVG7000000020?mF8`0303eIZ`00000000000080oeHS00@000000?mF
8`3oER<000000P3oER<200000080oeDR00@000000?mE8P00000000000`3oD1l20000000403eIZ`00
0000bcXF000000@0ooK^00<0?EV[0?ofkP3om^h03@3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[0180
ooK^0P0mFJ/;0?ofkP030000003om^h0ooK^00D0ooK^00@0?EV[0?ofkP3om^h0?EV[5P3om^h00`0m
FJ/0ooK^0?ofkP0=0?ofkP030000003om^h0ooK^0480ooK^0@3oool004D0ooK^00<000000?ofkP3o
m^h0303om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP0403eIZ`3om^h0ooK^03eIZ`L0ooK^00<000000?of
kP3om^h02@3om^h203eIZa80ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0?0?ofkP0303eIZ`3om^h0
ooK^0080ooK^0`000000100mFJ/00000054H30000002054H308000000P1^8Q0010000000KR8@06hR
4000000309D^5@080000002E;QD0UBhE0000002E;QD000000;Hg600mFJ/20;Hg600400000016ILL0
AVG70=@m6@80AVG70`3D?AT404IUa`0300000016ILL0AVG70080AVG700<0e3dI00000016ILL01016
ILL00`000000AVG704IUa`0304IUa`0500000016ILL0AVG704IUa`3D?AT00P16ILL00`000000AVG7
04IUa`0304IUa`0300000016ILL0AVG700<0AVG700@0000004IUa`16ILL0e3dI0P16ILL00`000000
AVG704IUa`0304IUa`0300000016ILL0AVG700@0AVG700<000000=@m6@16ILL00`16ILL00`000000
AVG704IUa`0204IUa`<0e3dI0P16ILL00`3D?AT0AVG7000000030?mF8`0503eIZ`3oER<000000?mF
8`0000000P3oER<01@000000oeHS0?mF8`3oER<000000080oeDR00<000000?mE8P3oEB800P000002
0?m@7`<0000000<0?EV[0000000000001@3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0503eIZ`3om^h0
ooK^0?ofkP0mFJ/04P3om^h203eIZ`/0ooK^00<000000?ofkP3om^h01@3om^h0100mFJ/0ooK^0?of
kP0mFJ/F0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<000000?ofkP3om^h0@`3om^h10?ooo`00A@3o
m^h00`000000ooK^0?ofkP0<0?ofkW/0?EV[00<0AVG70=@m6@16ILL00`16ILL010000000e3dI0=@m
6@3D?AT204IUa`0600000016ILL0AVG704IUa`3D?AT000001P16ILL00`000000AVG704IUa`0304IU
a`0400000016ILL0AVG70=@m6@80AVG700<0000004IUa`16ILL00`16ILL00`000000AVG704IUa`03
04IUa`0400000016ILL0AVG70=@m6@80AVG700<0000004IUa`16ILL00`16ILL00`000000AVG704IU
a`0304IUa`0300000016ILL0e3dI00<0AVG700<0000004IUa`16ILL00`3D?AT00`000000AVG704IU
a`0204IUa`030=@m6@16ILL0?EV[07X0?EV[3P3om^h00`000000ooK^0?ofkP130?ofkP40oooo0015
0?ofkP030000003om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h0503om^h0100mFJ/0ooK^0?ofkP0m
FJ/70?ofkP030000003om^h0ooK^00T0ooK^0P0mFJ/B0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/0
3`3om^h00`0mFJ/0ooK^0?ofkP030?ofkP80000000D0?EV[03`A2@000000DAP<00000002054H3080
00000P1^8Q001@000000KR8@0000002E;QD0000000<0UBhE00P0000009D^5@2E;QD000000;Hg600m
FJ/0]SLH00000080]SLH00<0000004IUa`16ILL01016ILL00`000000AVG704IUa`020=@m6@070000
0016ILL0AVG704IUa`3D?AT0AVG70000000504IUa`0300000016ILL0AVG700<0AVG700@0000004IU
a`16ILL0e3dI0P16ILL00`000000AVG704IUa`0304IUa`0300000016ILL0AVG700<0AVG700@00000
04IUa`16ILL0e3dI0P16ILL00`000000AVG704IUa`0304IUa`0300000016ILL0AVG700<0AVG700<0
000004IUa`3D?AT00`16ILL00`000000e3dI0=@m6@0204IUa`0300000016ILL0AVG700@0AVG700P0
00000?mF8`3oER<000000?mF8`0mFJ/0oeHS00000080oeHS00T000000?mF8`3oER<0oeHS0000003o
ER<000000?mE8P0000000P3oEB802@000000e3dI0?m@7`3oD1l000000?m@7`000000nDPL03eIZ`02
000000D0ooK^00<0?EV[0?ofkP3om^h03@3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[0180ooK^0P0m
FJ/;0?ofkP030000003om^h0ooK^00D0ooK^00@0?EV[0?ofkP3om^h0?EV[5P3om^h00`0mFJ/0ooK^
0?ofkP0<0?ofkP030000003om^h0ooK^04<0ooK^0@3oool004H0ooK^00<000000?ofkP3om^h02`3o
m^h00`0mFJ/0ooK^0?ofkP0D0?ofkP0403eIZ`3om^h0ooK^03eIZ`L0ooK^00<000000?ofkP3om^h0
2@3om^h203eIZa80ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0?0?ofkP0303eIZ`3om^h0ooK^00<0
ooK^0P0000000`0mFJ/0?14900000002054H30050000001A60`0000006hR400000000P1^8Q001@00
0000KR8@0000002E;QD0000000<0UBhE00D0000009D^5@000000000003eIZ`020;Hg60040000002f
=aP0]SLH000000D0AVG700<0000004IUa`16ILL00P16ILL30=@m6@0404IUa`3D?AT0AVG7000000H0
AVG700<0000004IUa`16ILL00P16ILL010000000AVG704IUa`3D?AT204IUa`0300000016ILL0AVG7
00<0AVG700<0000004IUa`16ILL00P16ILL01@000000AVG704IUa`16ILL0e3dI0080AVG700<00000
04IUa`16ILL00P16ILL00`000000AVG704IUa`0304IUa`0500000016ILL0AVG70=@m6@16ILL00`3D
?AT304IUa`0300000016ILL0AVG700@0AVG700@000000?mF8`3oER<000000P3oER<01@0mFJ/00000
0000003oER<0000000<0oeHS00D000000?mF8`000000oeDR000000020?mE8P050000003oEB800000
0?m@7`0000000P3oD1l00`000000nDPL03eIZ`02000000D0ooK^00<0?EV[0?ofkP3om^h03@3om^h0
1@0mFJ/0ooK^0?ofkP3om^h0?EV[0180ooK^0P0mFJ/;0?ofkP030000003om^h0ooK^00D0ooK^00@0
?EV[0?ofkP3om^h0?EV[5P3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP030000003om^h0ooK^04@0ooK^
0@3oool004H0ooK^00<000000?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP0403eIZ`3o
m^h0ooK^03eIZ`L0ooK^00<000000?ofkP3om^h02@3om^h203eIZa80ooK^00D0?EV[0?ofkP3om^h0
ooK^03eIZ`0?0?ofkP0303eIZ`3om^h0ooK^00<0ooK^0P000000100mFJ/00000000000000002054H
308000000P1^8Q000`000000KR8@06hR400200000080UBhE00@0000009D^5@2E;QD0UBhE0P000000
0`2f=aP0?EV[0;Hg60020;Hg60040000002f=aP0]SLH000000D0AVG700<0000004IUa`16ILL00`16
ILL00`000000e3dI0=@m6@020=@m6@0300000016ILL0AVG700<0AVG700<0000004IUa`16ILL00P16
ILL010000000AVG704IUa`3D?AT304IUa`0300000016ILL0AVG70080AVG700<0000004IUa`16ILL0
0P16ILL01`000000AVG704IUa`16ILL0e3dI04IUa`0000001@16ILL00`000000AVG704IUa`0304IU
a`030000003D?AT0e3dI0080e3dI00<0000004IUa`16ILL00`16ILL00`000000AVG704IUa`0304IU
a`040000003oER<0oeHS000000<0oeHS00@0?EV[0000003oER<000000`3oER<00`000000oeHS0?mF
8`0200000080oeDR00<000000?mE8P3oEB800P0000020?m@7`<0000000<0?EV[0000000000001@3o
m^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/04P3om^h203eIZ`/0ooK^
00<000000?ofkP3om^h01@3om^h0100mFJ/0ooK^0?ofkP0mFJ/F0?ofkP0303eIZ`3om^h0ooK^00/0
ooK^00<000000?ofkP3om^h0A03om^h10?ooo`00AP3om^h00`000000ooK^0?ofkP0;0?ofkP0303eI
Z`3om^h0ooK^01D0ooK^0P0mFJ/80?ofkP030000003om^h0ooK^00P0ooK^00<0?EV[0?ofkP0mFJ/0
4@3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h0
103om^h20000000403eIZ`000000000000000080DAP<0P00000206hR40050000001^8Q00KR8@06hR
400000000`2E;QD200000080UBhE0P0000000`0mFJ/00000000000020;Hg60040000002f=aP0]SLH
000000D0AVG700<0000004IUa`16ILL00P16ILL00`000000AVG70=@m6@0204IUa`H0e3dI00<0AVG7
00000016ILL00`16ILL00`000000AVG70=@m6@0304IUa`0300000016ILL0AVG70080AVG700<00000
04IUa`16ILL00P16ILL01`000000AVG704IUa`16ILL0e3dI04IUa`0000001016ILL00`000000AVG7
0=@m6@050=@m6@80AVG700<0e3dI04IUa`0000001016ILL00`000000AVG704IUa`0304IUa`040000
003oER<0oeHS00000080oeHS0P0000000`0mFJ/00000000000020?mF8`8000000`3oER<010000000
oeDR0?mE8P0000030?mE8P80000000<0oe0O0000003oD1l00P0000000`0mFJ/00000000000060?of
kP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP0?0?of
kP0303eIZ`3om^h0?EV[00X0ooK^00<000000?ofkP3om^h01P3om^h203eIZaL0ooK^00<0?EV[0?of
kP3om^h02`3om^h00`000000ooK^0?ofkP140?ofkP40oooo00170?ofkP030000003om^h0ooK^00X0
ooK^00<0?EV[0?ofkP3om^h05@3om^h203eIZ`P0ooK^00<000000?ofkP3om^h0203om^h00`0mFJ/0
ooK^03eIZ`0A0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0
ooK^0?ofkP040?ofkP80000000D0?EV[03`A2@000000DAP<00000002054H30050000001^8Q00KR8@
06hR400000000P1^8Q02000000@0UBhE00D0000009D^5@2E;QD0000003eIZ`020;Hg60040000002f
=aP0]SLH00000080]SLH300000000`3D?AT0000000000006000000H0e3dI0P0000000`3D?AT00000
0000000?000000030=@m6@000000000000H0e3dI200000000`3D?AT000000000000:00000080oeHS
00@000000?mF8`3oER<000000P3oER<01@0mFJ/000000?mF8`3oER<0000000@0oeHS0P0000020?mE
8P050000003oEB80oeDR0?mE8P0000000P3oD1l3000000030?U8700mFJ/0000000L0ooK^00<0?EV[
0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[
0?ofkP0mFJ/02P3om^h00`000000ooK^0?ofkP060?ofkP80?EV[5`3om^h00`0mFJ/0ooK^0?ofkP0:
0?ofkP030000003om^h0ooK^04D0ooK^0@3oool004L0ooK^00<000000?ofkP3om^h02P3om^h00`0m
FJ/0ooK^0?ofkP0E0?ofkP80?EV[1`3om^h00`000000ooK^0?ofkP090?ofkP0303eIZ`3om^h0?EV[
0140ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^
00D0ooK^00P0000003eIZ`0l4@T0e3dI0000001A60`00000054H308000000`1^8Q001@000000KR8@
0000002E;QD0000000@0UBhE00@0000009D^5@000000?EV[0`2f=aP01@000000]SLH0;Hg60000000
]SLH008000001@17JLh00`000000AfW>04MYcP0204MYcP030=@m6@17JLh0AfW>0080AfW>00<00000
04MYcP17JLh00P17JLh00`000000AfW>04MYcP0204MYcQL0e3dI1017JLh00`000000AfW>04MYcP02
04MYcP0300000017JLh0AfW>0080AfW>00<0e3dI04MYcP17JLh00P17JLh00`000000AfW>04MYcP03
04MYcP80000000D0oeHS0000003oER<0oeHS000000030?mF8`0403eIZ`000000oeHS000000@0oeHS
00D000000?mF8`000000oeDR000000030?mE8P80000000<0oe0O0000003oD1l00P0000000`3iB1`0
?EV[000000070?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0
ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0?EV[00/0ooK^00<000000?ofkP3om^h01@3om^h203eIZaL0
ooK^00<0?EV[0?ofkP3om^h02P3om^h00`000000ooK^0?ofkP150?ofkP40oooo00170?ofkP030000
003om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h05@3om^h203eIZ`L0ooK^00<000000?ofkP3om^h0
2@3om^h00`0mFJ/0ooK^03eIZ`0A0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h0
303om^h00`0mFJ/0ooK^0?ofkP050?ofkP050000000mFJ/0?14903`A2@0000000P1A60`200000003
06hR40000000KR8@0080KR8@0P00000209D^5@030000002E;QD0UBhE0080UBhE0P0000000`0mFJ/0
0000000000020;Hg60030000002f=aP0]SLH0080000000<0d3hK00000017JLh01017JLh01P000000
AfW>04MYcP17JLh0e3dI000000<0AfW>00<0000004MYcP17JLh00`17JLh00`000000AfW>04MYcP02
04MYcP030000003D?AT0AfW>0080AfW>00<0000004MYcP17JLh00P17JLh00`000000AfW>04MYcP02
04MYcP0600000017JLh0AfW>04MYcP3D?AT000001017JLh00`000000AfW>04MYcP0304MYcP060000
0017JLh0AfW>04MYcP000000e3dI0`17JLh00`000000AfW>04MYcP0304MYcP040000003oE2<00000
00000080oeHS00<000000?mF8`3oER<00P0000000`0mFJ/00000000000040?mF8`030000003oER<0
oeHS008000000`3oEB8010000000oeDR0000000000020?m@7`050000003iB1`0nDPL03eIZ`000000
1`3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h0
3`3om^h00`0mFJ/0ooK^03eIZ`0;0?ofkP030000003om^h0ooK^00D0ooK^0P0mFJ/G0?ofkP0303eI
Z`3om^h0ooK^00X0ooK^00<000000?ofkP3om^h0A@3om^h10?ooo`00B03om^h00`000000ooK^0?of
kP0:0?ofkP0303eIZ`3om^h0ooK^01@0ooK^0P0mFJ/70?ofkP030000003om^h0ooK^00T0ooK^00@0
?EV[0?ofkP3om^h0?EV[403om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00/0ooK^
00<0?EV[0?ofkP3om^h01@3om^h20000000303eIZ`0l4@T000000080DAP<00D00000054H30000000
KR8@0000000306hR40040000002E;QD0UBhE09D^5@8000000`2E;QD01@000000?EV[0;Hg602f=aP0
00000080]SLH00@000000;Hg602f=aP000000P3@?Q/00`000000AfW>04MYcP0304MYcP0500000017
JLh0AfW>04MYcP3D?AT01017JLh00`000000AfW>04MYcP0204MYcP0300000017JLh0AfW>0080AfW>
00<000000=@m6@17JLh00P17JLh00`000000AfW>04MYcP0204MYcP0300000017JLh0AfW>0080AfW>
00H0000004MYcP17JLh0AfW>0=@m6@00000404MYcP0300000017JLh0AfW>0080AfW>00<0000004MY
cP17JLh00P17JLh01@3D?AT0AfW>04MYcP17JLh0000000D0AfW>00@000000?mD8`3oE2<000000P3o
ER<010000000oeHS0?mF8`0000020?mF8`0303eIZ`000000oeHS0080oeHS0P0000030?mF8`060000
003oEB80oeDR0?mE8P000000oeDR0P0000030?m@7`030000003iB1`0?EV[008000001`3om^h00`0m
FJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h03P3om^h0100m
FJ/0ooK^0?ofkP0mFJ/;0?ofkP030000003om^h0ooK^00D0ooK^0P0mFJ/F0?ofkP0303eIZ`3om^h0
ooK^00X0ooK^00<000000?ofkP3om^h0AP3om^h10?ooo`00B03om^h00`000000ooK^0?ofkP0:0?of
kP0303eIZ`3om^h0ooK^01@0ooK^0P0mFJ/70?ofkP030000003om^h0ooK^00T0ooK^00@0?EV[0?of
kP3om^h0?EV[403om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[
0?ofkP3om^h01@3om^h20000000403eIZ`0l4@T0000000000080DAP<0P00000206hR40030000001^
8Q00KR8@00800000102E;QD01@000000UBhE09D^5@000000?EV[0080]SLH00@0e3dI0000002f=aP0
]SLH100000020=0n6`0300000017JLh0AfW>00<0AfW>00D0000004MYcP17JLh0e3dI0000000404MY
cP0300000017JLh0AfW>0080AfW>00H0000004MYcP17JLh0AfW>0000003D?AT304MYcP0300000017
JLh0AfW>0080AfW>00<0000004MYcP17JLh00P17JLh01P000000AfW>04MYcP17JLh0e3dI000000<0
AfW>00<0000004MYcP17JLh00P17JLh00`000000AfW>04MYcP0204MYcP050000003D?AT0AfW>04MY
cP0000001@17JLh00`000000oe@S0?mD8`0400000080oeHS00H000000=@m6@3oER<0oeHS03eIZ`00
00020?mF8`030000003oER<0oeHS0080oeHS0P0000020?mE8P030000003oEB80oeDR008000000P3o
D1l2000000040?U8700mFJ/00000000000L0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^
0?ofkP030?ofkP0303eIZ`3om^h0ooK^00h0ooK^00@0?EV[0?ofkP3om^h0?EV[2`3om^h00`000000
ooK^0?ofkP050?ofkP80?EV[5P3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP030000003om^h0ooK^04H0
ooK^0@3oool004P0ooK^00<000000?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP0D0?ofkTD0?EV[
0P000000100mFJ/0?149000000000003054H30080000001^8Q00KR8@06hR40000000KR8@0000002E
;QD2000000<0UBhE00@0000009D^5@000000?EV[0P0000020;Hg60040000002f=aP0]SLH0;Hg60<0
00000P3@?Q/00`000000AfW>04MYcP0304MYcP0500000017JLh0e3dI04MYcP0000000`17JLh00`00
0000AfW>04MYcP0204MYcP0300000017JLh0AfW>0080AfW>00D0e3dI04MYcP17JLh0AfW>00000004
04MYcP0300000017JLh0AfW>0080AfW>00D0000004MYcP17JLh0AfW>0=@m6@0404MYcP0300000017
JLh0AfW>0080AfW>00T0000004MYcP17JLh0AfW>00000017JLh0e3dI04MYcP0000001@17JLh00`00
0000oe@S00000003000000<0oeHS00<000000?mF8`3oER<00P000000100mFJ/000000?mF8`000003
0?mF8`80000000@0oeHS0000003oEB8000000`3oEB8010000000oe0O0?m@7`3oD1l30000000303eI
Z`000000000004D0?EV[5P3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP030000003om^h0ooK^04H0ooK^
0@3oool004P0ooK^00<000000?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP80?EV[1`3o
m^h00`000000ooK^0?ofkP090?ofkP0403eIZ`3om^h0ooK^03eIZa00ooK^00<0?EV[0?ofkP3om^h0
0`3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00D0ooK^0P0000001@0mFJ/00000
0000001A60`000000080DAP<0P00000306hR40030000001^8Q0000000080UBhE00@0000009D^5@2E
;QD0UBhE0P000000100mFJ/0]SLH0;Hg600000020;Hg60050000002f=aP0]SLH0;Hg600000000P3@
?Q/010000000d3hK00000000000304MYcP0300000017JLh0e3dI0080AfW>00D0000004MYcP17JLh0
AfW>0000000404MYcP0500000017JLh0AfW>04MYcP3D?AT01017JLh01@000000AfW>04MYcP17JLh0
000000<0AfW>00<0000004MYcP17JLh00P17JLh01@3D?AT0AfW>04MYcP17JLh0000000@0AfW>00D0
000004MYcP17JLh0AfW>0000000204MYcP030=@m6@17JLh0000000<0AfW>0P0000001@3oE2<00000
0?mD8`3oE2<0000000<0oeHS00@000000?mF8`3oER<000000P3oER<00`0mFJ/00000000000030?mF
8`060000003oER<0oeHS0000003oEB8000000`3oEB8200000080oe0O00H000000?m@7`0000000000
03eIZ`0000080?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0
ooK^0?ofkP0>0?ofkP0403eIZ`3om^h0ooK^03eIZ`/0ooK^00<000000?ofkP3om^h01@3om^h203eI
ZaH0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`000000ooK^0?ofkP160?ofkP40oooo00190?ofkP03
0000003om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h05@3om^h00`0mFJ/0ooK^0?ofkP050?ofkP03
0000003om^h0ooK^00T0ooK^00@0?EV[0?ofkP3om^h0?EV[403om^h00`0mFJ/0ooK^0?ofkP030?of
kP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h01P3om^h010000000?EV[000000000002
054H30050000001A60`0000006hR400000000`1^8Q02000000<0UBhE00H0000009D^5@2E;QD0UBhE
0000000mFJ/30;Hg60030000002f=aP0]SLH0080000000<0]SLH0000000000000P3@?Q/010000000
d3hK0=0n6`00000304MYcP030000003D?AT0AfW>0080AfW>00@0000004MYcP17JLh000001017JLh0
1P000000AfW>04MYcP17JLh0e3dI000000<0AfW>00D0000004MYcP17JLh0AfW>0000000304MYcP06
00000017JLh0AfW>04MYcP000000e3dI0`17JLh00`000000AfW>04MYcP0204MYcP0400000017JLh0
AfW>000000<0AfW>00<0e3dI00000017JLh00P17JLh010000000oe@S0?mD8`0000020?mD8`800000
00<0oeHS0000000000000P3oER<01P000000oeHS0?mF8`3oER<0?EV[000000<0oeHS00@000000?mF
8`3oER<0oeHS0P0000030?mE8P050000003oEB8000000?m@7`0000000P3oD1l010000000nDPL03eI
Z`0000080?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^
0?ofkP0>0?ofkP0403eIZ`3om^h0ooK^03eIZ`/0ooK^00<000000?ofkP3om^h01@3om^h00`0mFJ/0
ooK^0?ofkP0E0?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<000000?ofkP3om^h0A`3om^h10?ooo`00
B@3om^h00`000000ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^01@0ooK^0P0mFJ/70?ofkP030000
003om^h0ooK^00P0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0@0?ofkP0303eIZ`3om^h0ooK^00<0
ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP060?ofkP040000000mFJ/0?1490000
00<0DAP<0P00000206hR40050000001^8Q00KR8@06hR40000000102E;QD01P000000UBhE09D^5@00
0000?EV[000000<0]SLH00@000000;Hg602f=aP0]SLH0P000000103@?Q/000000000003@?Q/20000
00030=0n6`000000AfW>0080AfW>00<0e3dI04MYcP17JLh00P17JLh010000000AfW>04MYcP000004
04MYcP0500000017JLh0AfW>0=@m6@0000000`17JLh01@000000AfW>04MYcP17JLh0000000<0AfW>
00H0000004MYcP17JLh0AfW>0000003D?AT204MYcP0300000017JLh0AfW>0080AfW>00@0000004MY
cP17JLh000001017JLh01P3D?AT0AfW>04MYcP17JLh000000?mD8`80000000@0oe@S000000000000
oe@S0P0000030?mF8`070000003oER<0oeHS0?mF8`000000?EV[000000020?mF8`030000003oER<0
oeHS0080oeHS00D000000?mE8P3oEB80oeDR000000020?mE8P8000000`3oD1l010000000nDPL03eI
Z`0000080?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^
0?ofkP0>0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/02P3om^h00`000000ooK^0?ofkP050?ofkP80
?EV[5P3om^h00`0mFJ/0ooK^0?ofkP090?ofkP030000003om^h0ooK^04L0ooK^0@3oool004T0ooK^
00<000000?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP80?EV[1`3om^h00`000000ooK^
0?ofkP080?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/0403om^h00`0mFJ/0ooK^0?ofkP030?ofkP03
03eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`000000?EV[0000000200000080
DAP<0P00000306hR40030000001^8Q00KR8@00800000102E;QD30000000303eIZ`2f=aP0000000<0
]SLH00D000000;Hg602f=aP0]SLH000000030=0n6`060000003D?AT0d3hK0000003@?Q/000000P17
JLh00`3D?AT0000004MYcP0204MYcP0500000017JLh0AfW>04MYcP0000000`17JLh01@000000AfW>
04MYcP3D?AT0000000<0AfW>00D0000004MYcP17JLh0AfW>0000000304MYcP0600000017JLh0AfW>
04MYcP000000e3dI0P17JLh01@000000AfW>04MYcP17JLh0000000<0AfW>00H0000004MYcP17JLh0
?EV[0000003D?AT204MYcP030000003oE2<000000080oe@S00D000000?mD8`3oE2<0oe@S00000003
0?mF8`080000003oER<0oeHS0?mF8`000000oeHS03eIZ`3oER<2000000@0oeHS0P0000020?mE8P04
0000003oEB80oeDR0?mE8P8000000P3oD1l30000000303eIZ`000000ooK^00L0ooK^00<0?EV[0?of
kP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00h0ooK^00D0?EV[0?of
kP3om^h0ooK^03eIZ`0:0?ofkP030000003om^h0ooK^00D0ooK^0P0mFJ/F0?ofkP0303eIZ`3om^h0
ooK^00T0ooK^00<000000?ofkP3om^h0A`3om^h10?ooo`00BP3om^h00`000000ooK^0?ofkP080?of
kXT0?EV[00D0000004MYcP17JLh0AfW>0000000304MYcP0400000017JLh0AfW>000000@0AfW>00D0
000004MYcP3D?AT0AfW>0000000204MYcP0500000017JLh0AfW>04MYcP0000000`17JLh020000000
AfW>04MYcP000000AfW>0=@m6@17JLh000001017JLh010000000AfW>04MYcP00000304MYcP050000
0017JLh0AfW>04MYcP000000R@0mFJ/:0?ofkP030000003om^h0ooK^04P0ooK^0@3oool004X0ooK^
00<000000?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP80?EV[1P3om^h00`000000ooK^
0?ofkP090?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/03`3om^h00`0mFJ/0ooK^0?ofkP040?ofkP03
03eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`000000?EV[03`A2@0200000003
054H30000000DAP<00800000101^8Q02000000<0UBhE00<0000009D^5@2E;QD00P2E;QD0100mFJ/0
]SLH0;Hg602f=aP2000000<0]SLH0P0000020=0n6`030000003@?Q/0d3hK0080000000<0d3hK0000
000000004@0000000`3D?AT000000000000?000000030=@m6@00000000000140000000<0oe@S0000
000000000P3oE2<00`000000oe@S0?mD8`02000000<0oeHS0P0000030?mF8`0303eIZ`3oER<0oeHS
0080oeHS00@000000?mF8`3oER<0oeHS0P0000040?mE8P80000000<0oe0O0000003oD1l00P000000
0`3iB1`0?EV[000000090?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h0103om^h0
0`0mFJ/0ooK^0?ofkP0=0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/02`3om^h00`000000ooK^0?of
kP040?ofkP80?EV[5P3om^h00`0mFJ/0ooK^0?ofkP080?ofkP030000003om^h0ooK^04P0ooK^0@3o
ool004X0ooK^00<000000?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP80?EV[1P3om^h0
0`000000ooK^0?ofkP090?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/03`3om^h00`0mFJ/0ooK^0?of
kP040?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`000000?EV[03`A
2@0200000006054H30000000DAP<0000001^8Q000000101^8Q000`000000UBhE09D^5@0209D^5@05
0000002E;QD0UBhE09D^5@0mFJ/00P0000030;Hg60050000002f=aP0]SLH0;Hg600000000`3@?Q/2
00000080d3hK00<000000=0n6`3@?Q/00`00000204U/e00300000019K=@0e3dI0080e3dI0P19K=@0
20000000BFcD04U/e019K=@000000=@m6@19K=@000000P19K=@01@000000BFcD04U/e019K=@00000
00<0BFcD00L0000004U/e019K=@0000004U/e03D?AT0000000<0BFcD00<0000004U/e019K=@00`3D
?AT00`19K=@0000004U/e00204U/e08000000P3oE2<00`000000oe@S0?mD8`02000000<0oe@S00D0
00000?mF8`3oER<0oeHS000000030?mF8`80000000D0?EV[0?mF8`3oER<0oeHS000000040?mF8`03
0000003oEB80oeDR0080oeDR00H000000?mE8P000000oe0O0000003oD1l30000000303eIZ`000000
ooK^00P0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0
ooK^00d0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0;0?ofkP030000003om^h0ooK^00@0ooK^0P0m
FJ/E0?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<000000?ofkP3om^h0B03om^h10?ooo`00B`3om^h0
0`000000ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^01<0ooK^0P0mFJ/60?ofkP030000003om^h0
ooK^00T0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0?0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0
?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP070?ofkP050000000mFJ/0000003`A2@000000
0P1A60`01@000000DAP<0000001^8Q00000000<0KR8@0`00000309D^5@80000000@0UBhE03eIZ`2f
=aP0]SLH0P0000020;Hg60030000002f=aP0]SLH00<000000`3@?Q/010000000d3hK0=0n6`000002
0=0n6`030000003UA1d000000080BFcD0P00000204U/e0D0e3dI00<0BFcD0000003D?AT00P19K=@0
0`000000BFcD0000000304U/e00700000019K=@0BFcD04U/e0000000BFcD0000000204U/e0030=@m
6@000000BFcD00D0e3dI0P19K=@200000080BFcD00<000000?mA8P0000000P3oE2<010000000oe@S
0?mD8`0000030?mD8`<000000P3oER<00`000000oeHS0?mF8`0200000080oeHS00@0?EV[0?mF8`00
000000000`3oER<3000000<0oeDR00D000000?mE8P000000oe0O000000020?m@7`050000003iB1`0
000003eIZ`0000002@3om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0
?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0
00000?ofkP3om^h00`3om^h00`0mFJ/0ooK^03eIZ`0E0?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0
00000?ofkP3om^h0B@3om^h10?ooo`00B`3om^h00`000000ooK^0?ofkP080?ofkP0303eIZ`3om^h0
ooK^0180ooK^00@0?EV[0?ofkP3om^h0?EV[1@3om^h00`000000ooK^0?ofkP080?ofkP0303eIZ`3o
m^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3o
m^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h01`3om^h01P000000?EV[0000000l4@T0e3dI00000080
DAP<0P00000206hR4080000000D0KR8@0000002E;QD0UBhE0000000409D^5@030000000mFJ/0]SLH
00<0]SLH00<000000;Hg602f=aP00`0000020=0n6`8000000P3@?Q/2000000030=0n6`0000000000
0080000000<0iD@M0000000000000P19K=@010000000BFcD04U/e000000204U/e0030000003D?AT0
e3dI01D0e3dI00@0000004U/e019K=@000000P19K=@00`000000BFcD04U/e002000000030?mA8P00
000000000080000000<0oe@S0000000000000P3oE2<200000080oe@S0`0000020?mF8`030000003o
ER<0oeHS0080oeHS00<0?EV[0000003oER<00`3oER<01@000000oeHS0?mF8`000000oeDR00800000
0P3oEB8200000080oe0O00H000000=@m6@000000000003eIZ`0000090?ofkP0303eIZ`3om^h0ooK^
00T0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^
00<0ooK^00<0?EV[0?ofkP3om^h0203om^h00`000000ooK^0?ofkP030?ofkP0403eIZ`3om^h0ooK^
03eIZa@0ooK^00<0?EV[0?ofkP3om^h0203om^h00`000000ooK^0?ofkP190?ofkP40oooo001;0?of
kP030000003om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h04P3om^h0100mFJ/0ooK^0?ofkP0mFJ/5
0?ofkP030000003om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP0<
0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP07
0?ofkP030000000mFJ/0000000<000000`1A60`00`000000KR8@06hR400206hR40030000001^8Q00
00000080UBhE0P00000309D^5@0303eIZ`2f=aP0]SLH00<0]SLH0P0000020;Hg60030000003@?Q/0
d3hK0080d3hK00D000000=0n6`3@?Q/0d3hK000000020=0n6`060000003UA1d0?EV[0000003UA1d0
00000P19K=@010000000BFcD04U/e000000204U/e00600000019K=@0e3dI00000019K=@000000P19
K=@010000000BFcD04U/e000000204U/e00900000019K=@0BFcD00000019K=@000000=@m6@19K=@0
00000080BFcD00@0000004U/e019K=@000000P19K=@01P000000oe4R0000000mFJ/0oe4R00000080
oe@S00D000000?mD8`3oE2<0oe@S000000040?mD8`030000003oER<0oeHS00800000103oER<00`00
0000?EV[0?mF8`020?mF8`8000000P3oER<00`000000oeDR000000030?mE8P030=@m6@000000oe0O
0080oe0O100000000`0mFJ/000000?ofkP080?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?of
kP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?of
kP3om^h0203om^h00`000000ooK^0?ofkP030?ofkP0403eIZ`3om^h0ooK^03eIZa@0ooK^00<0?EV[
0?ofkP3om^h0203om^h00`000000ooK^0?ofkP190?ofkP40oooo001<0?ofkP030000003om^h0ooK^
00L0ooK^00<0?EV[0?ofkP3om^h04P3om^i903eIZ`<0000000@0DAP<0000001A60`0DAP<0P000004
06hR40800000102E;QD01@000000UBhE09D^5@0mFJ/0]SLH00800000102f=aP5000000<0d3hK0P00
00020=0n6`@0000000<0?EV[0>E47@0000000P00000204U/e00900000019K=@0BFcD00000019K=@0
000004U/e03D?AT000000080BFcD00<0000004U/e00000000P19K=@01P000000BFcD04U/e0000000
BFcD00000080BFcD00H0e3dI04U/e019K=@0000004U/e000000204U/e00300000019K=@0BFcD00<0
000000<0oe4R03eIZ`0000000`0000020?mD8`8000000`3oE2<5000000@0oeHS0P0000001@0mFJ/0
00000?mF8`3oER<0000000@0oeHS0P0000040?mE8P8000000P3oD1l3000000030?U8700mFJ/0?EV[
04P0?EV[4`3om^h00`0mFJ/0ooK^0?ofkP080?ofkP030000003om^h0ooK^04X0ooK^0@3oool004`0
ooK^00<000000?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP0403eIZ`3om^h0ooK^03eI
Z`D0ooK^00<000000?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^
00`0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^
00P0ooK^00<0000003eIZ`0l4@T00P0000001P1A60`00000054H30000000KR8@000000@0KR8@00<0
000009D^5@2E;QD00`2E;QD30000000303eIZ`2f=aP0]SLH00800000102f=aP00`000000d3hK0=0n
6`02000000<0d3hK0P0000020=0n6`040000003UA1d0?EV[00000080iD@M0`0000003P19K=@00000
04U/e019K=@0000004U/e0000000BFcD0=@m6@000000BFcD00000019K=@000000P19K=@03@000000
BFcD04U/e0000000BFcD00000019K=@000000=@m6@19K=@0000004U/e00000000P19K=@00`000000
BFcD00000002000000060?mA8P000000000003eIZ`3oDB8000000P3oE2<2000000<0oe@S0P000000
0`3oE2<00000000000040?mF8`8000000P3oER<0100mFJ/000000000000000050?mF8`030000003o
EB80oeDR0080oeDR00H000000?mE8P000000oe0O0000003oD1l2000000030?U8700mFJ/0000000X0
ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00`0
ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP080?ofkP030000003om^h0ooK^00<0
ooK^00@0?EV[0?ofkP3om^h0?EV[4`3om^h00`0mFJ/0ooK^0?ofkP080?ofkP030000003om^h0ooK^
04X0ooK^0@3oool004`0ooK^00<000000?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP04
03eIZ`3om^h0ooK^03eIZ`@0ooK^00<000000?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP030?of
kP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP090?of
kP0303eIZ`3om^h0ooK^00P0ooK^00<0000003eIZ`0l4@T00P000002054H308000000P1^8Q020000
0080KR8@0`00000509D^5@030000000mFJ/0]SLH00<0]SLH0P0000020;Hg60030000003@?Q/00000
0080d3hK0P0000030=0n6`@0000000D0?EV[0>E47@3UA1d000000>E47@030000000904U/e0000000
000004U/e0000000BFcD0000003D?AT0BFcD008000000P19K=@01@000000BFcD00000019K=@00000
0080BFcD0P0000001P19K=@0e3dI00000019K=@0000004U/e080000000H0BFcD0000000000000000
0?mA8P0000020?mA8P0303eIZ`0000000000008000000`3oE2<2000000050?mD8`00000000000?mD
8`0000000P3oER<2000000@0oeHS00<0?EV[0000003oER<0103oER<300000080oeDR0P0000020?mE
8P8000000P3oD1l01@000000nDPL0?U8700mFJ/0000000X0ooK^00<0?EV[0?ofkP3om^h02@3om^h0
0`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h00`3om^h0
0`0mFJ/0ooK^0?ofkP080?ofkP030000003om^h0ooK^00<0ooK^00@0?EV[0?ofkP3om^h0?EV[4`3o
m^h00`0mFJ/0ooK^0?ofkP080?ofkP030000003om^h0ooK^04X0ooK^0@3oool004d0ooK^00<00000
0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/0103o
m^h00`000000ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h02`3o
m^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h0203o
m^h01@000000?EV[0000000l4@T000000080DAP<0P00000406hR40030000001^8Q0000000080UBhE
0P00000309D^5@040000000mFJ/00000000000@0]SLH0P000000102f=aP000000=0n6`3@?Q/20000
00030=0n6`000000000000<0d3hK00<000000>E47@0mFJ/00P000000103UA1d000000000003UA1d3
0000000K04U/e0000000BFcD00000019K=@0e3dI04U/e0000000BFcD00000019K=@0000004U/e000
0000BFcD00000019K=@0000004U/e0000000BFcD0=@m6@19K=@0000004U/e0000000BFcD00<00000
00@0oe4R000000000000oe4R0P0000000`0mFJ/0oe4R000000030?mD8`80000000<0oe@S00000000
00000P3oE2<010000000oeHS0000000000040?mF8`80000000<0?EV[0000003oER<00P3oER<20000
0080oeHS00<000000?mE8P000000103oEB8200000080oe0O00D000000?U870000000?EV[0000000:
0?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP0:
0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h0203om^h01@000000ooK^0?ofkP3o
m^h0?EV[00@0ooK^00<0?EV[0?ofkP3om^h0403om^h00`0mFJ/0ooK^0?ofkP070?ofkP030000003o
m^h0ooK^04/0ooK^0@3oool004d0ooK^00<000000?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP0@
0?ofkP0303eIZ`3om^h0ooK^0080ooK^00D0?EV[0?ofkP3om^h0ooK^0000000:0?ofkP0303eIZ`3o
m^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3o
m^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h0203om^h010000000?EV[0000000l4@T200000080DAP<
00<0000006hR401^8Q000`1^8Q02000000@0UBhE0P0000000`2E;QD0000003eIZ`020;Hg60800000
102f=aP2000000@0d3hK1@000000103@?Q/000000>E47@0mFJ/20>E47@80000000<0iD@M00000000
00008@0000002@3oDB8000000000003oDB80000003eIZ`3oDB8000000?mD8`05000000<0oe@S0`00
00040?mF8`8000000P3oER<00`0mFJ/0oeHS0?mF8`02000000@0oeHS0P0000040?mE8P040=@m6@00
0000oe0O0?m@7`80000000<0nDPL0000000mFJ/02`3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eI
Z`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eI
Z`3om^h0ooK^00P0ooK^00D000000?ofkP3om^h0ooK^03eIZ`040?ofkP0303eIZ`3om^h0ooK^00l0
ooK^00<0?EV[0?ofkP3om^h0203om^h00`000000ooK^0?ofkP1;0?ofkP40oooo001=0?ofkP030000
003om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0503eI
Z`3om^h0ooK^0?ofkP0000002P3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00X0
ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00X0
ooK^00L0?EV[03`A2@0000000000054H30000000DAP<00<00000101^8Q000`000000UBhE09D^5@04
09D^5@80000000<0?EV[0;Hg602f=aP00P2f=aP2000000<0]SLH00<000000=0n6`0000000P000003
0=0n6`@0000000<0iD@M03eIZ`3UA1d00P000000103UA1d000000000003UA1d80000000904U^f000
0000BFkH00000019K]P0000004U^f0000000BFkH00<0000000<0BFkH00000019K]P020000000103o
DB8000000000003oDB82000000030?mA8P0mFJ/0oe4R00@000000`3oE2<3000000030?mD8`000000
oeHS0080oeHS0P0000040?mF8`0303eIZ`000000000000H0oeHS00<000000?mE8P3oEB800P3oEB83
000000030?m@7`000000oe0O0080000000<0nDPL03eIZ`3om^h02P3om^h00`0mFJ/0ooK^0?ofkP08
0?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP05
0?ofkP0303eIZ`3om^h0ooK^00P0ooK^00D000000?ofkP3om^h0ooK^03eIZ`040?ofkP0303eIZ`3o
m^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h0203om^h00`000000ooK^0?ofkP1;0?ofkP40oooo001>
0?ofkP030000003om^h0ooK^00L0ooK^U00mFJ/70000000304U^f000000000000080000000@0BFkH
000000000000BFkH0`0000000`19K]P0000000000005000009@0?EV[2@3om^h00`000000ooK^0?of
kP1<0?ofkP40oooo001>0?ofkP030000003om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h03`3om^h0
0`0mFJ/0ooK^0?ofkP020?ofkP0503eIZ`3om^h0ooK^0?ofkP0000002P3om^h00`0mFJ/0ooK^0?of
kP050?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?of
kP070?ofkP0303eIZ`3om^h0ooK^00X0ooK^00@0?EV[0000000l4@T000000P1A60`00`000000DAP<
0000000206hR4080000000@0KR8@0000002E;QD0UBhE0P00000409D^5@0403eIZ`2f=aP000000000
00D0]SLH0P0000060=0n6`<0000000H0d3hK0000003UA1d0?EV[0000003UA1d3000000030>E47@00
0000000000T0000000@0BFkH000000000000BFkH1P0000000`19K]P0000000000009000000030?mA
8P000000000000<0000000@0?EV[0?mA8P3D?AT0oe@S0`0000050?mD8`<000001@3oER<200000003
0?mF8`0mFJ/0oeHS00<0oeHS0P000000103oER<000000?mE8P3oEB8200000080oeDR00<000000?m@
7`0000000P3oD1l010000000nDPL0000000mFJ/<0?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[
0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[
0?ofkP3om^h0203om^h01@000000ooK^0?ofkP3om^h0?EV[00@0ooK^00<0?EV[0?ofkP3om^h03`3o
m^h00`0mFJ/0ooK^0?ofkP070?ofkP030000003om^h0ooK^04`0ooK^0@3oool004h0ooK^00<00000
0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00D0?EV[
0?ofkP3om^h0ooK^000000090?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h02@3o
m^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h02P3o
m^h0100mFJ/0000003`A2@000003054H30800000101^8Q03000000<0UBhE0P00000209D^5@0403eI
Z`2f=aP0]SLH0;Hg60<000000`2f=aP00`000000d3hK00000003000000@0d3hK0P000000103UA1d0
?EV[0>E47@3UA1dY00000080oe4R00@0?EV[0000000000000000103oE2<4000000030?mD8`000000
oeHS0080oeHS0`0000030?mF8`0303eIZ`3oER<0oeHS008000000`3oER<3000000@0oeDR0P000003
0?m@7`040000003iB1`0000003eIZ``0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?of
kP080?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?of
kP070?ofkP050000003om^h0ooK^0?ofkP0mFJ/01@3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eI
Z`3om^h0ooK^00L0ooK^00<000000?ofkP3om^h0C03om^h10?ooo`00C`3om^h00`000000ooK^0?of
kP070?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h0103om^h0100mFJ/0ooK^0?of
kP0000090?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^
0?ofkP080?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0e3dI
00000002000000<0DAP<00<0000006hR401^8Q00101^8Q000`000000UBhE09D^5@0309D^5@800000
00<0?EV[0;Hg602f=aP0102f=aP2000000030;Hg60000000d3hK00@0d3hK10000000103@?Q/00000
0>E47@0mFJ/300000080iD@M8`0000020?mA8P<0000000@0?EV[0?mA8P000000oe@S100000050?mD
8`040000003oER<00000000000H0oeHS00<0?EV[0000000000001@3oER<00`000000oeDR0?mE8P03
0?mE8P030=@m6@000000oe0O0080oe0O0`0000000`3D?AT0?EV[0?ofkP0;0?ofkP0303eIZ`3om^h0
ooK^00L0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0
ooK^00L0ooK^00<0?EV[0?ofkP3om^h01`3om^h010000000ooK^0?ofkP0mFJ/60?ofkP0303eIZ`3o
m^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`000000ooK^0?ofkP1=0?ofkP40oooo001?
0?ofkP030000003om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h03@3om^i>03eIZ`030000001A60`0
00000080DAP<0`00000406hR40<000001@2E;QD00`0mFJ/0]SLH0;Hg60060;Hg608000002@3@?Q/2
000000030>E47@0mFJ/0iD@M0080iD@M100000000`3UA1d000000000000K000000030?mA8P000000
0000008000000`3oDB80100mFJ/000000000000000070?mD8`@000001`3oER<00`000000?EV[0?mF
8`040?mF8`<00000103oEB8300000080oe0O00<000000?m@7`000000CP0mFJ/?0?ofkP0303eIZ`3o
m^h0ooK^00L0ooK^00<000000?ofkP3om^h0C@3om^h10?ooo`00C`3om^h00`000000ooK^0?ofkP07
0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0000000:
0?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP09
0?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h02`3om^h01@0mFJ/0e3dI00000000
0000DAP<00<000000P1^8Q0200000080KR8@00<0000009D^5@2E;QD00P00000309D^5@030000000m
FJ/00000008000001@2f=aP00`000000d3hK0=0n6`0600000080d3hK00<000000>E47@0mFJ/01P00
00000`3UA1d000000000000M000000030?mA8P000000000000@0000000<0?EV[0?mA8P0000000P3o
E2<600000080oe@S00<000000?mF8`3oER<00`3oER<30000000303eIZ`000000oeHS0080oeHS0P00
00020?mF8`030000003oEB80oeDR0080000000<0oeDR0000003oD1l00P0000001@3oD1l000000000
003D?AT0?EV[00d0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eI
Z`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP080?ofkP030000
003om^h0?EV[00H0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP070?ofkP030000
003om^h0ooK^04d0ooK^0@3oool004l0ooK^00<000000?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?of
kP0<0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP0000002@3om^h00`0mFJ/0ooK^0?of
kP080?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?of
kP050?ofkP0303eIZ`3om^h0ooK^00`0ooK^00@0?EV[0=@m6@3D?AT000000P1A60`00`0mFJ/00000
0000000306hR40<00000102E;QD20000000309D^5@000000?EV[00<0]SLH100000000`2f=aP00000
0=0n6`070=0n6`<0000000<0iD@M03eIZ`3UA1d01@3UA1dQ000000<0oe4R0`0000000`0mFJ/00000
00000002000000P0oe@S00<000000?mF8`0000000`0000030?mF8`0303eIZ`000000oeHS00800000
103oER<3000000<0oeDR0P000000100mFJ/0oe0O0?m@7`0000020=@m6@0303eIZ`3om^h0ooK^00`0
ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00L0
ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP070?ofkP030000003om^h0?EV[00L0
ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP070?ofkP030000003om^h0ooK^04d0
ooK^0@3oool00500ooK^00<000000?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eI
Z`3om^h0ooK^00H0ooK^00<0?EV[0000003om^h0203om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eI
Z`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eI
Z`3om^h0ooK^00`0ooK^00@0?EV[0=@m6@3D?AT00000101A60`00`000000KR8@06hR400306hR4003
0000002E;QD0UBhE00@0UBhE0P0000000`0mFJ/0]SLH0;Hg60050;Hg60L000001@3@?Q/00`000000
iD@M03eIZ`030>E47BL000000`3oDB800`0mFJ/0oe4R000000050?mD8`L000001P3oER<010000000
?EV[0000000000050?mF8`8000001@3oEB800`000000oe0O0?m@7`020?m@7`040000003D?AT0e3dI
03eIZ`h0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0
ooK^00H0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP070?ofkP030000000mFJ/0
ooK^00L0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP070?ofkP030000003om^h0
ooK^04h0ooK^0@3oool00500ooK^00<000000?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP0:0?of
kP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0000003om^h0203om^h00`0mFJ/0ooK^0?ofkP090?of
kP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP050?of
kP0303eIZ`3om^h0ooK^00`0ooK^00D0?EV[0=@m6@3D?AT0ooK^00000003054H30<000000`1^8Q00
10000000UBhE00000000000409D^5@030000000mFJ/0]SLH00D000000P2f=aP00`000000d3hK0=0n
6`030=0n6`L0000000<0?EV[000000000000:`0000000`0mFJ/0000000000005000000D0oe@S00<0
00000?mF8`3oER<01@0000000`3oER<0?EV[000000040?mF8`80000000<0oeHS0000003oEB800P3o
EB82000000060=@m6@3oD1l0oe0O0?m@7`000000ooK^0P3D?AT00`0mFJ/0ooK^0?ofkP0<0?ofkP03
03eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP060?ofkP03
03eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`000000?EV[0?ofkP080?ofkP03
03eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`000000ooK^0?ofkP1>0?ofkP40
oooo001@0?ofkP030000003om^h0ooK^00L0ooK^TP0mFJ/K00000980?EV[2@3om^h00`000000ooK^
0?ofkP1>0?ofkP40oooo001A0?ofkP030000003om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h02@3o
m^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`000000ooK^00L0ooK^00<0?EV[0?ofkP3om^h02P3o
m^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h0103o
m^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0903eIZ`3D?AT0e3dI0=@m6@3om^h0?EV[0000001A60`00000
00<0KR8@0`00000509D^5@80000000<0UBhE03eIZ`2f=aP01`2f=aP00`000000d3hK0=0n6`030=0n
6`L0000000<0?EV[0000000000000P0000030>E47@H0000000<0mdTO0000000000000P0000000`19
K]T0000004U^f@030000000304U^f@000000BFkI00@0000000<0odhQ000000000000100000030?mA
8P@0000000<0?EV[0000000000001@0000050?mD8`030000003oER<0oeHS00H0oeHS00@0?EV[0?mF
8`00000000001@3oER<3000000<0oeDR00D000000?m@7`000000?EV[0?ofkP030=@m6@0303eIZ`3o
m^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3o
m^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3o
m^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP070?ofkP030000003o
m^h0ooK^04l0ooK^0@3oool00540ooK^00<000000?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP08
0?ofkUP0?EV[1@1^8Q000`000000UBhE09D^5@0509D^5@030000000mFJ/0000000<00000102f=aP0
0`000000d3hK0=0n6`080=0n6`030000003UA1d0?EV[0080iD@M1@0000001@3UA1d0000000000000
0000mdTO00D0000000L0BFkI000000000000000004U^f@000000BFkI00<0000000<0BFkI00000000
00000`0000001@3oCR400000000000000000oe4R00H0000000<0?EV[0?mA8P3D?AT02`3oE2<00`00
0000oeHS0?mF8`020?mF8`@0000000<0?EV[0000003oER<01@3oER<2000000D0oeDRF00mFJ/:0?of
kP0303eIZ`3om^h0ooK^00L0ooK^00<000000?ofkP3om^h0C`3om^h10?ooo`00D@3om^h00`000000
ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0
ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0
ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0
e3dI0?ofkP020=@m6@0303eIZ`3om^h0ooK^00800000101^8Q000`000000UBhE00000002000000@0
UBhE00<0?EV[0;Hg602f=aP00P2f=aPB0000000403eIZ`3UA1d0iD@M0>E47@@0000000<0iD@M0000
000000006@0000000`3oDB80000000000002000000<0oe4R00<0?EV[000000000000400000030?mF
8`0303eIZ`000000oeHS00<0oeHS0`0000000`3oER<000000?mE8P030?mE8P8000000P3om^h01@0m
FJ/0e3dI0=@m6@3om^h0?EV[0100ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP0<
0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP05
0?ofkP0303eIZ`000000ooK^00/0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP08
0?ofkP030000003om^h0ooK^04l0ooK^0@3oool00580ooK^00<000000?ofkP3om^h01`3om^h00`0m
FJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0000003eIZ`3om^h01@3om^h00`0m
FJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0m
FJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00l0ooK^00D0?EV[0=@m6@3D?AT0e3dI03eIZ`03
0?ofkP030=@m6@00000000000080KR8@00<0000009D^5@2E;QD00P2E;QD30000000309D^5@000000
?EV[00L0]SLH00<000000=0n6`3@?Q/02@3@?Q/00`000000iD@M03eIZ`03000000030>E47@000000
000000L0000000@0e3dI00000000000000000P15Jm801@000000AF_B00000015Jm8000000080AF_B
0`0000000`3D?AT0000000000007000000060?mA8P00000000000000000mFJ/0oe4R0P3D?AT:0?mD
8`030000003oER<0oeHS00D0oeHS00<0?EV[0000003oER<00`0000030?mF8`040000003oEB80oeDR
0?mE8P80000000D0e3dI0?ofkP3om^h0ooK^03eIZ`030=@m6@0303eIZ`3om^h0ooK^00l0ooK^00<0
?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0
?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`000000ooK^00/0ooK^00<0
?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP070?ofkP030000003om^h0ooK^0500ooK^0@3o
ool00580ooK^00<000000?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0
ooK^00X0ooK^00<000000?ofkP0mFJ/01P3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0
ooK^0080ooK^00<0?EV[0?ofkP3om^h03P3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[0140ooK^00@0
?EV[0=@m6@3D?AT0?EV[103om^h20=@m6@050?ofkP000000000006hR400000001P2E;QD200000004
03eIZ`0000000000000000D0]SLH00<000000=0n6`3@?Q/00`3@?Q/7000000030>E47@0000000000
00T0000000D0AF_B0000003D?AT0AF_B0000000204E[dP0400000015Jm80AF_B00000080AF_B00P0
000004E[dP15Jm80000004E[dP3D?AT0000004E[dP/0000000<0oe4R0000000000001@0000050?mD
8`030000003oER<0oeHS00<0oeHS0`0000000`0mFJ/00000000000060?mF8`050000003oEB800000
0000003om^h00P3D?AT40?ofkP0403eIZ`3D?AT0e3dI03eIZa40ooK^00D0?EV[0?ofkP3om^h0ooK^
03eIZ`0@0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^
0?ofkP030?ofkP0403eIZ`3om^h0ooK^000000`0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0
ooK^0?ofkP080?ofkP030000003om^h0ooK^0500ooK^0@3oool00580ooK^00<000000?ofkP3om^h0
203om^j303eIZ`L000000`3D?AT7000000030=@m6@000000000000d0000000<0e3dI000000000000
1@0000030=@m6@L00000P`0mFJ/:0?ofkP030000003om^h0ooK^0500ooK^0@3oool005<0ooK^00<0
00000?ofkP3om^h0203om^h203eIZ`80ooK^I@0mFJ/00`3D?AT000000000000209D^5@030000000m
FJ/0?EV[00L0]SLH00<000000=0n6`3@?Q/0200000000`3D?AT0>Ufh00000006000000D0e3dI00<0
>Ufh0000003D?AT00`0jGKP01@000000>Ufh03YM^00jGKP0000000<0>Ufh00L0000003YM^00jGKP0
>Ufh0=@m6@000000>Ufh00D0e3dI1`0000000`0jGKP0e3dI0000000700000080oe@S00<000000?mF
8`3oER<01@3oER<203eIZ`030000003oER<0oeHS0080000000<0e3dI03eIZ`0mFJ/0H`0mFJ/20?of
kP80?EV[2P3om^h00`000000ooK^0?ofkP1A0?ofkP40oooo001C0?ofkP030000003om^h0ooK^00X0
ooK^L`0mFJ/00`3D?AT000000000000;000000030=@m6@000000000000/000005@3D?AT=00000003
0=@m6@000000000000/0000000<0e3dI03eIZ`0mFJ/0L@0mFJ/<0?ofkP030000003om^h0ooK^0540
ooK^0@3oool005<0ooK^00<000000?ofkP3om^h06`3om^h00`000000ooK^0?ofkP130?ofkP80e3dI
0P3om^h0103D?AT0ooK^0?ofkP3D?AT40?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT0203om^h0103D
?AT0ooK^0?ofkP3D?AT=0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h03@3om^h0
0`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00/0ooK^00@0e3dI0?ofkP3om^h0e3dI203o
m^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00@0ooK^00D0e3dI0?ofkP3om^h0e3dI0?ofkP030=@m6DD0
ooK^00<000000?ofkP3om^h06`3om^h00`000000ooK^0?ofkP1A0?ofkP40oooo001D0?ofkP030000
003om^h0ooK^01X0ooK^00<000000?ofkP3om^h0@`3om^h30=@m6@80ooK^00@0e3dI0?ofkP3om^h0
e3dI103om^h0103D?AT0ooK^0?ofkP3D?AT90?ofkP<0e3dI3@3om^h00`3D?AT0ooK^0?ofkP0=0?of
kP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0;0?of
kP<0e3dI2@3om^h0103D?AT0ooK^0?ofkP3D?AT40?ofkP040=@m6@3om^h0ooK^0=@m6@80ooK^0`3D
?AU50?ofkP030000003om^h0ooK^01X0ooK^00<000000?ofkP3om^h0DP3om^h10?ooo`00E03om^h0
0`000000ooK^0?ofkP0J0?ofkP030000003om^h0ooK^04<0ooK^0`3D?AT20?ofkP040=@m6@3om^h0
ooK^0=@m6@D0ooK^00@0e3dI0?ofkP3om^h0e3dI2P3om^h20=@m6@`0ooK^00<0e3dI0?ofkP3om^h0
3@3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h0
2P3om^h20=@m6@X0ooK^00@0e3dI0?ofkP3om^h0e3dI1@3om^h0103D?AT0ooK^0?ofkP3D?AT20?of
kP<0e3dIA@3om^h00`000000ooK^0?ofkP0J0?ofkP030000003om^h0ooK^0580ooK^0@3oool005@0
ooK^00<000000?ofkP3om^h06P3om^h00`000000ooK^0?ofkP130?ofkP<0e3dI0`3om^h00`3D?AT0
ooK^0=@m6@060?ofkP030=@m6@3om^h0e3dI00X0ooK^00<0e3dI0?ofkP3D?AT00P3D?AT90?ofkP03
0=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP03
0=@m6@3om^h0ooK^00L0ooK^0`3D?AT00`3om^h0e3dI0?ofkP090?ofkP030=@m6@3om^h0e3dI00H0
ooK^00<0e3dI0?ofkP3D?AT00`3om^h30=@m6DD0ooK^00<000000?ofkP3om^h06P3om^h00`000000
ooK^0?ofkP1B0?ofkP40oooo001E0?ofkP030000003om^h0ooK^01P0ooK^00<000000?ofkP3om^h0
A03om^h30=@m6@@0ooK^0P3D?AT70?ofkP80e3dI2P3om^h00`3D?AT0ooK^0?ofkP020?ofkP80e3dI
1`3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h0
3@3om^h00`3D?AT0ooK^0?ofkP050?ofkP80e3dI103om^h00`3D?AT0ooK^0?ofkP080?ofkP80e3dI
1`3om^h20=@m6@@0ooK^0`3D?AU60?ofkP030000003om^h0ooK^01P0ooK^00<000000?ofkP3om^h0
D`3om^h10?ooo`00E@3om^h00`000000ooK^0?ofkP0H0?ofkP030000003om^h0ooK^04@0ooK^0`3D
?AT40?ofkP80e3dI203om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00@0ooK^0`3D
?AT40?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?of
kP0=0?ofkP030=@m6@3om^h0ooK^0080ooK^0`3D?AT60?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0
e3dI0?ofkP3om^h01P3om^h20=@m6@@0ooK^0`3D?AU60?ofkP030000003om^h0ooK^01P0ooK^00<0
00000?ofkP3om^h0D`3om^h10?ooo`00E@3om^h00`000000ooK^0?ofkP0H0?ofkP030000003om^h0
ooK^04@0ooK^103D?AT40?ofkP030=@m6@3om^h0ooK^00H0ooK^0`3D?AT80?ofkP030=@m6@3om^h0
ooK^00L0ooK^0`3D?AT00`3om^h0e3dI0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI
0?ofkP3om^h03@3om^h00`3D?AT0ooK^0=@m6@020=@m6@T0ooK^00<0e3dI0?ofkP3om^h01P3om^h3
0=@m6@P0ooK^00<0e3dI0?ofkP3om^h00P3om^h40=@m6DH0ooK^00<000000?ofkP3om^h0603om^h0
0`000000ooK^0?ofkP1C0?ofkP40oooo001F0?ofkP030000003om^h0ooK^01L0ooK^00<000000?of
kP3om^h0A03om^h40=@m6@@0ooK^0P3D?AT70?ofkP040=@m6@3om^h0ooK^0=@m6@L0ooK^00<0e3dI
0?ofkP3om^h02P3om^h40=@m6@d0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0;
0?ofkP@0e3dI303om^h00`3D?AT0ooK^0?ofkP050?ofkP040=@m6@3om^h0ooK^0=@m6@L0ooK^0P3D
?AT40?ofkP@0e3dIAP3om^h00`000000ooK^0?ofkP0G0?ofkP030000003om^h0ooK^05@0ooK^0@3o
ool005H0ooK^00<000000?ofkP3om^h05`3om^h00`000000ooK^0?ofkP140?ofkP80e3dI00<0ooK^
0=@m6@3D?AT00`3om^h00`3D?AT0ooK^0=@m6@060?ofkP040=@m6@3om^h0ooK^0?ofkP80e3dI1P3o
m^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00D0e3dI203om^h00`3D?AT0ooK^0?of
kP0=0?ofkP030=@m6@3om^h0ooK^00H0ooK^1@3D?AT20?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0
e3dI0?ofkP3om^h0103om^h20=@m6@<0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0=@m
6@030?ofkP80e3dI00<0ooK^0=@m6@3D?AT0AP3om^h00`000000ooK^0?ofkP0G0?ofkP030000003o
m^h0ooK^05@0ooK^0@3oool005H0ooK^00<000000?ofkP3om^h05`3om^h00`000000ooK^0?ofkP15
0?ofkP<0e3dI00D0ooK^0=@m6@3om^h0ooK^0=@m6@020?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0
e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0
e3dI0?ofkP3om^h01@3om^h60=@m6@80ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?of
kP060=@m6@L0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3o
m^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h00`3om^h0103D?AT0ooK^0?ofkP3D?AT20?ofkP030=@m
6@3om^h0e3dI0080e3dIA`3om^h00`000000ooK^0?ofkP0G0?ofkP030000003om^h0ooK^05@0ooK^
0@3oool005L0ooK^00<000000?ofkP3om^h05P3om^h00`000000ooK^0?ofkP150?ofkP<0e3dI00D0
ooK^0=@m6@3om^h0ooK^0=@m6@030?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h0
103om^h20=@m6@<0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP0;0?ofkQD0e3dI
3@3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP040=@m6@3om^h0ooK^0?ofkP80e3dI1@3om^h00`3D?AT0
ooK^0?ofkP030?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT00P3om^h00`3D?AT0ooK^0=@m6@020=@m
6DL0ooK^00<000000?ofkP3om^h05P3om^h00`000000ooK^0?ofkP1E0?ofkP40oooo001G0?ofkP03
0000003om^h0ooK^01H0ooK^00<000000?ofkP3om^h0A@3om^h00`3D?AT0ooK^0=@m6@020?ofkP03
0=@m6@3om^h0e3dI00@0ooK^0P3D?AT30?ofkP030=@m6@3om^h0ooK^00D0ooK^00@0e3dI0?ofkP3o
m^h0e3dI303om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?of
kP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP040=@m6@3om^h0ooK^0=@m6@L0ooK^00@0e3dI
0?ofkP3om^h0ooK^0P3D?AT30?ofkP040=@m6@3om^h0ooK^0=@m6@80ooK^00<0e3dI0?ofkP3D?AT0
A`3om^h00`000000ooK^0?ofkP0F0?ofkP030000003om^h0ooK^05D0ooK^0@3oool005L0ooK^00<0
00000?ofkP3om^h05P3om^h00`000000ooK^0?ofkP150?ofkP030=@m6@3om^h0e3dI0080ooK^00@0
e3dI0?ofkP3om^h0e3dI1@3om^h0103D?AT0ooK^0?ofkP3D?AT80?ofkP<0e3dI303om^h00`3D?AT0
ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0
ooK^0?ofkP0:0?ofkP<0e3dI203om^h0103D?AT0ooK^0?ofkP3D?AT50?ofkP040=@m6@3om^h0ooK^
0=@m6@80ooK^00<0e3dI0?ofkP3D?AT0A`3om^h00`000000ooK^0?ofkP0F0?ofkP030000003om^h0
ooK^05D0ooK^0@3oool005L0ooK^00<000000?ofkP3om^h05@3om^h00`000000ooK^0?ofkP160?of
kP040=@m6@3om^h0e3dI0=@m6@80ooK^00<0e3dI0?ofkP3D?AT01P3om^h00`3D?AT0ooK^0=@m6@0:
0?ofkP80e3dI303om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI
0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP0:0?ofkP80e3dI2P3om^h00`3D?AT0ooK^0=@m6@06
0?ofkP030=@m6@3om^h0e3dI0080ooK^0P3D?AT00`3om^h0e3dI0?ofkP170?ofkP030000003om^h0
ooK^01D0ooK^00<000000?ofkP3om^h0E@3om^h10?ooo`00F03om^h00`000000ooK^0?ofkP0D0?of
kP030000003om^h0ooK^04H0ooK^00@0e3dI0?ofkP3om^h0e3dI0`3om^h20=@m6@L0ooK^0P3D?AT:
0?ofkP030=@m6@3om^h0e3dI0080e3dI2@3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0
ooK^00d0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP070?ofkP<0e3dI00<0ooK^
0=@m6@3om^h02@3om^h20=@m6@L0ooK^0P3D?AT30?ofkP040=@m6@3om^h0ooK^0=@m6DP0ooK^00<0
00000?ofkP3om^h0503om^h00`000000ooK^0?ofkP1F0?ofkP40oooo001H0?ofkP030000003om^h0
ooK^01@0ooK^00<000000?ofkP3om^h0A`3om^h00`3D?AT0ooK^0=@m6@030?ofkP80e3dI203om^h0
0`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^0080ooK^0P3D?AT70?ofkP030=@m6@3om^h0
ooK^00`0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0
ooK^00D0ooK^0P3D?AT40?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h01P3om^h2
0=@m6@<0ooK^00<0e3dI0?ofkP3D?AT0B@3om^h00`000000ooK^0?ofkP0D0?ofkP030000003om^h0
ooK^05H0ooK^0@3oool005P0ooK^00<000000?ofkP3om^h0503om^h00`000000ooK^0?ofkP170?of
kP040=@m6@3om^h0e3dI0=@m6@<0ooK^00<0e3dI0?ofkP3om^h01P3om^h30=@m6@P0ooK^00<0e3dI
0?ofkP3om^h0103om^h30=@m6@@0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP0=
0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h00P3om^h30=@m6@H0ooK^00<0e3dI
0?ofkP3om^h01P3om^h30=@m6@P0ooK^00@0e3dI0?ofkP3om^h0ooK^0P3D?AT00`3om^h0e3dI0?of
kP180?ofkP030000003om^h0ooK^01@0ooK^00<000000?ofkP3om^h0EP3om^h10?ooo`00F@3om^h0
0`000000ooK^0?ofkP0C0?ofkP030000003om^h0ooK^04L0ooK^00@0e3dI0?ofkP3D?AT0e3dI0`3o
m^h20=@m6@L0ooK^00@0e3dI0?ofkP3om^h0e3dI1`3om^h00`3D?AT0ooK^0?ofkP070?ofkP<0e3dI
00<0ooK^0=@m6@3om^h03@3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00`0ooK^
00<0e3dI0?ofkP3D?AT00P3D?AT90?ofkP030=@m6@3om^h0ooK^00D0ooK^00@0e3dI0?ofkP3om^h0
e3dI1`3om^h20=@m6@<0ooK^0P3D?AT00`3om^h0e3dI0?ofkP180?ofkP030000003om^h0ooK^01<0
ooK^00<000000?ofkP3om^h0E`3om^h10?ooo`00F@3om^h00`000000ooK^0?ofkP0C0?ofkP030000
003om^h0ooK^04P0ooK^0P3D?AT01`3om^h0e3dI0?ofkP3om^h0e3dI0?ofkP3D?AT01P3om^h0103D
?AT0ooK^0?ofkP3om^h20=@m6@D0ooK^00<0e3dI0?ofkP3om^h02P3om^h40=@m6@`0ooK^00<0e3dI
0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP@0e3dI2`3om^h00`3D?AT0ooK^0?ofkP04
0?ofkP80e3dI0`3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0e3dI0080ooK^00@0e3dI
0?ofkP3D?AT0e3dIBP3om^h00`000000ooK^0?ofkP0C0?ofkP030000003om^h0ooK^05L0ooK^0@3o
ool005T0ooK^00<000000?ofkP3om^h04`3om^h00`000000ooK^0?ofkP180?ofkP80e3dI00D0ooK^
0=@m6@3om^h0ooK^0=@m6@020?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h00`3o
m^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h01@3D
?AT70?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h01@3om^h50=@m6@80ooK^00<0
e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0
e3dI0?ofkP3om^h00`3om^h0103D?AT0ooK^0?ofkP3D?AT20?ofkP040=@m6@3om^h0e3dI0=@m6DX0
ooK^00<000000?ofkP3om^h04`3om^h00`000000ooK^0?ofkP1G0?ofkP40oooo001J0?ofkP030000
003om^h0ooK^0180ooK^00<000000?ofkP3om^h0B03om^h20=@m6@80ooK^00<0e3dI0?ofkP3D?AT0
0`3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00@0ooK^0P3D?AT30?ofkP030=@m
6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h01@3om^h50=@m6@80ooK^00<0e3dI0?ofkP3om^h0
3@3om^h00`3D?AT0ooK^0?ofkP050=@m6@L0ooK^00<0e3dI0?ofkP3om^h02P3om^h0103D?AT0ooK^
0?ofkP3om^h20=@m6@H0ooK^00<0e3dI0?ofkP3om^h00P3om^h02`3D?AT0ooK^0?ofkP3om^h0e3dI
0?ofkP3D?AT0ooK^0=@m6@3om^h0e3dI04X0ooK^00<000000?ofkP3om^h04P3om^h00`000000ooK^
0?ofkP1H0?ofkP40oooo001J0?ofkP030000003om^h0ooK^0140ooK^00<000000?ofkP3om^h0BP3o
m^h20=@m6@040?ofkP3D?AT0ooK^0=@m6@@0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^
0?ofkP050?ofkP040=@m6@3om^h0ooK^0=@m6@`0ooK^00<0e3dI0?ofkP3om^h02P3om^hE0=@m6@`0
ooK^00<0e3dI0?ofkP3om^h02P3om^h0103D?AT0ooK^0?ofkP3D?AT70?ofkP030=@m6@3om^h0ooK^
0080ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@020?ofkP040=@m6@3om^h0e3dI0=@m6D`0ooK^00<0
00000?ofkP3om^h04@3om^h00`000000ooK^0?ofkP1H0?ofkP40oooo001J0?ofkP030000003om^h0
ooK^0140ooK^00<000000?ofkP3om^h0BP3om^h20=@m6@80ooK^00<0e3dI0?ofkP3D?AT0103om^h0
1@3D?AT0ooK^0?ofkP3om^h0e3dI00P0ooK^0`3D?AT<0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0
e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00X0ooK^0`3D
?AT80?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT0103om^h00`3D?AT0ooK^0=@m6@020?ofkP80e3dI
C03om^h00`000000ooK^0?ofkP0A0?ofkP030000003om^h0ooK^05P0ooK^0@3oool005/0ooK^00<0
00000?ofkP3om^h0403om^h00`000000ooK^0?ofkP1:0?ofkP80e3dI0P3om^h00`3D?AT0ooK^0=@m
6@050?ofkP040=@m6@3om^h0ooK^0=@m6@X0ooK^0P3D?AT;0?ofkP030=@m6@3om^h0ooK^00`0ooK^
00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00T0ooK^
0P3D?AT:0?ofkP040=@m6@3om^h0ooK^0=@m6@D0ooK^00<0e3dI0?ofkP3D?AT00P3om^h20=@m6D`0
ooK^00<000000?ofkP3om^h0403om^h00`000000ooK^0?ofkP1I0?ofkP40oooo001K0?ofkP030000
003om^h0ooK^0100ooK^00<000000?ofkP3om^h0B`3om^h0103D?AT0ooK^0?ofkP3om^h20=@m6@H0
ooK^00<0e3dI0?ofkP3D?AT02P3om^h0103D?AT0ooK^0=@m6@3D?AT90?ofkP030=@m6@3om^h0ooK^
00`0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^
00L0ooK^0P3D?AT00`3om^h0e3dI0?ofkP090?ofkP030=@m6@3om^h0e3dI00H0ooK^0P3D?AT30?of
kP030=@m6@3om^h0ooK^04/0ooK^00<000000?ofkP3om^h0403om^h00`000000ooK^0?ofkP1I0?of
kP40oooo001K0?ofkP030000003om^h0ooK^0100ooK^00<000000?ofkP3om^h0B`3om^h0103D?AT0
ooK^0?ofkP3om^h20=@m6@L0ooK^0P3D?AT:0?ofkP040=@m6@3om^h0ooK^0?ofkP80e3dI1`3om^h0
0`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h0303om^h0
0`3D?AT0ooK^0?ofkP050?ofkP80e3dI0`3om^h00`3D?AT0ooK^0?ofkP080?ofkP80e3dI1`3om^h2
0=@m6@<0ooK^00<0e3dI0?ofkP3om^h0B`3om^h00`000000ooK^0?ofkP0@0?ofkP030000003om^h0
ooK^05T0ooK^0@3oool005`0ooK^00<000000?ofkP3om^h03`3om^h00`000000ooK^0?ofkP1<0?of
kP050=@m6@3om^h0ooK^0?ofkP3D?AT0203om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0
ooK^00<0ooK^0P3D?AT50?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h03@3om^h0
0`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00<0ooK^0P3D?AT50?ofkP030=@m6@3om^h0
ooK^00P0ooK^00<0e3dI0?ofkP3om^h01P3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI04h0ooK^00<0
00000?ofkP3om^h03`3om^h00`000000ooK^0?ofkP1J0?ofkP40oooo001L0?ofkP030000003om^h0
ooK^00l0ooK^00<000000?ofkP3om^h0C03om^h0103D?AT0ooK^0?ofkP3om^h20=@m6@L0ooK^0`3D
?AT80?ofkP030=@m6@3om^h0ooK^00D0ooK^0P3D?AT30?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0
e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP040=@m6@3om^h0ooK^0?ofkP80e3dI
1`3om^h00`3D?AT0ooK^0?ofkP060?ofkP<0e3dI1`3om^h20=@m6@<0ooK^00<0e3dI0?ofkP3om^h0
C03om^h00`000000ooK^0?ofkP0?0?ofkP030000003om^h0ooK^05X0ooK^0@3oool005`0ooK^00<0
00000?ofkP3om^h03`3om^h00`000000ooK^0?ofkP1=0?ofkP060=@m6@3om^h0ooK^0=@m6@3om^h0
e3dI1P3om^h0103D?AT0ooK^0?ofkP3D?AT70?ofkP030=@m6@3om^h0ooK^00L0ooK^0P3D?AT00`3o
m^h0e3dI0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h0303om^h0103D
?AT0ooK^0=@m6@3D?AT90?ofkP030=@m6@3om^h0ooK^00D0ooK^00@0e3dI0?ofkP3om^h0e3dI1P3o
m^h00`3D?AT0ooK^0=@m6@020?ofkP030=@m6@3om^h0ooK^04d0ooK^00<000000?ofkP3om^h03`3o
m^h00`000000ooK^0?ofkP1J0?ofkP40oooo001M0?ofkP030000003om^h0ooK^00h0ooK^00<00000
0?ofkP3om^h0C@3om^h0103D?AT0ooK^0?ofkP3D?AT20?ofkP030=@m6@3om^h0ooK^00<0ooK^00@0
e3dI0?ofkP3om^h0ooK^0P3D?AT50?ofkP030=@m6@3om^h0ooK^00T0ooK^103D?AT<0?ofkP030=@m
6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h02P3om^h40=@m6@/0ooK^00<0e3dI0?ofkP3om^h0
0`3om^h20=@m6@<0ooK^00<0e3dI0?ofkP3om^h00`3om^h0103D?AT0ooK^0?ofkP3D?AT20?ofkP03
0=@m6@3om^h0ooK^04d0ooK^00<000000?ofkP3om^h03P3om^h00`000000ooK^0?ofkP1K0?ofkP40
oooo001M0?ofkP030000003om^h0ooK^00d0ooK^00<000000?ofkP3om^h0C`3om^h00`3D?AT0ooK^
0=@m6@030?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h00`3om^h20=@m6@<0ooK^
00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP050=@m6@L0ooK^00<0e3dI0?ofkP3om^h0
3@3om^h00`3D?AT0ooK^0?ofkP050?ofkPD0e3dI0P3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP040=@m
6@3om^h0ooK^0?ofkP80e3dI1@3om^h00`3D?AT0ooK^0?ofkP020?ofkP070=@m6@3om^h0ooK^0?of
kP3D?AT0ooK^0=@m6@1A0?ofkP030000003om^h0ooK^00d0ooK^00<000000?ofkP3om^h0F`3om^h1
0?ooo`00G@3om^h00`000000ooK^0?ofkP0=0?ofkP030000003om^h0ooK^04l0ooK^00<0e3dI0?of
kP3D?AT0103om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00L0ooK^00@0e3dI0?ofkP3om^h0e3dI303o
m^h00`3D?AT0ooK^0?ofkP050?ofkPD0e3dI0P3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3o
m^h0ooK^00D0e3dI1`3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP040=@m6@3om^h0ooK^0=@m6@H0ooK^
00<0e3dI0?ofkP3om^h00P3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI0080ooK^00<0e3dI0?ofkP3o
m^h0C`3om^h00`000000ooK^0?ofkP0=0?ofkP030000003om^h0ooK^05/0ooK^0@3oool005h0ooK^
00<000000?ofkP3om^h0303om^h00`000000ooK^0?ofkP1@0?ofkP030=@m6@3om^h0e3dI00@0ooK^
00D0e3dI0?ofkP3om^h0ooK^0=@m6@070?ofkP<0e3dI303om^h00`3D?AT0ooK^0?ofkP0:0?ofkQD0
e3dI303om^h00`3D?AT0ooK^0?ofkP0:0?ofkP<0e3dI1`3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI
00@0ooK^00<0e3dI0?ofkP3D?AT0DP3om^h00`000000ooK^0?ofkP0<0?ofkP030000003om^h0ooK^
05`0ooK^0@3oool005h0ooK^00<000000?ofkP3om^h0303om^h00`000000ooK^0?ofkP1@0?ofkP03
0=@m6@3om^h0e3dI00D0ooK^00@0e3dI0?ofkP3om^h0e3dI2@3om^h20=@m6@/0ooK^00<0e3dI0?of
kP3om^h0303om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?of
kP3om^h02@3om^h20=@m6@T0ooK^00@0e3dI0?ofkP3om^h0e3dI1@3om^h00`3D?AT0ooK^0=@m6@1B
0?ofkP030000003om^h0ooK^00`0ooK^00<000000?ofkP3om^h0G03om^h10?ooo`00GP3om^h00`00
0000ooK^0?ofkP0<0?ofkP030000003om^h0ooK^0540ooK^0P3D?AT60?ofkP030=@m6@3om^h0e3dI
00T0ooK^00@0e3dI0?ofkP3D?AT0e3dI2@3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0
ooK^00d0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP080?ofkP80e3dI00<0ooK^
0=@m6@3om^h0203om^h00`3D?AT0ooK^0=@m6@060?ofkP80e3dID`3om^h00`000000ooK^0?ofkP0<
0?ofkP030000003om^h0ooK^05`0ooK^0@3oool005h0ooK^00<000000?ofkP3om^h0303om^h00`00
0000ooK^0?ofkP1A0?ofkP80e3dI1`3om^h20=@m6@T0ooK^00@0e3dI0?ofkP3om^h0ooK^0P3D?AT8
0?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0;
0?ofkP030=@m6@3om^h0ooK^00H0ooK^0P3D?AT30?ofkP030=@m6@3om^h0ooK^00L0ooK^0P3D?AT7
0?ofkP80e3dID`3om^h00`000000ooK^0?ofkP0<0?ofkP030000003om^h0ooK^05`0ooK^0@3oool0
05l0ooK^00<000000?ofkP3om^h02`3om^h00`000000ooK^0?ofkP1B0?ofkP030=@m6@3om^h0ooK^
00H0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP030?ofkP<0e3dI1@3om^h00`3D
?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D
?AT0ooK^0?ofkP030?ofkP<0e3dI1@3om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^
00H0ooK^00<0e3dI0?ofkP3om^h0DP3om^h00`000000ooK^0?ofkP0;0?ofkP030000003om^h0ooK^
05d0ooK^0@3oool005l0ooK^00<000000?ofkP3om^h02`3om^h00`000000ooK^0?ofkP1C0?ofkP03
0=@m6@3om^h0ooK^00D0ooK^0`3D?AT70?ofkP030=@m6@3om^h0ooK^00H0ooK^0P3D?AT30?ofkP03
0=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP04
0=@m6@3om^h0ooK^0?ofkP80e3dI203om^h00`3D?AT0ooK^0?ofkP050?ofkP<0e3dI1`3om^h00`3D
?AT0ooK^0?ofkP1C0?ofkP030000003om^h0ooK^00/0ooK^00<000000?ofkP3om^h0G@3om^h10?oo
o`00G`3om^h00`000000ooK^0?ofkP0:0?ofkP030000003om^h0ooK^05D0ooK^00<0e3dI0?ofkP3o
m^h0103om^h0103D?AT0ooK^0?ofkP3D?AT60?ofkP030=@m6@3om^h0ooK^00P0ooK^0P3D?AT00`3o
m^h0e3dI0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h02`3om^h0103D
?AT0ooK^0=@m6@3D?AT90?ofkP030=@m6@3om^h0ooK^00D0ooK^00@0e3dI0?ofkP3om^h0e3dI1P3o
m^h00`3D?AT0ooK^0?ofkP1D0?ofkP030000003om^h0ooK^00/0ooK^00<000000?ofkP3om^h0G@3o
m^h10?ooo`00H03om^h00`000000ooK^0?ofkP090?ofkP030000003om^h0ooK^05H0ooK^00<0e3dI
0?ofkP3om^h00`3om^h0103D?AT0ooK^0?ofkP3om^h20=@m6@D0ooK^00<0e3dI0?ofkP3om^h02@3o
m^h40=@m6@`0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP090?ofkP@0e3dI2`3o
m^h00`3D?AT0ooK^0?ofkP030?ofkP80e3dI0`3om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3o
m^h0ooK^05H0ooK^00<000000?ofkP3om^h02@3om^h00`000000ooK^0?ofkP1N0?ofkP40oooo001P
0?ofkP030000003om^h0ooK^00T0ooK^00<000000?ofkP3om^h0E`3om^h00`3D?AT0ooK^0?ofkP02
0?ofkP030=@m6@3om^h0ooK^00<0ooK^0P3D?AT30?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI
0?ofkP3om^h01@3D?AT70?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h01@3om^h4
0=@m6@80ooK^00<0e3dI0?ofkP3om^h02P3om^h0103D?AT0ooK^0?ofkP3om^h20=@m6@D0ooK^00<0
e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP1G0?ofkP030000003om^h0ooK^00T0ooK^00<0
00000?ofkP3om^h0GP3om^h10?ooo`00H03om^h00`000000ooK^0?ofkP090?ofkP030000003om^h0
ooK^05P0ooK^0P3D?AT30?ofkP030=@m6@3om^h0ooK^00@0ooK^00@0e3dI0?ofkP3om^h0e3dI303o
m^h00`3D?AT0ooK^0?ofkP050?ofkPD0e3dI0P3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3o
m^h0ooK^00D0e3dI1P3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP040=@m6@3om^h0ooK^0=@m6@H0ooK^
00@0e3dI0?ofkP3om^h0ooK^0P3D?AUJ0?ofkP030000003om^h0ooK^00T0ooK^00<000000?ofkP3o
m^h0GP3om^h10?ooo`00H@3om^h00`000000ooK^0?ofkP080?ofkP030000003om^h0ooK^05X0ooK^
00@0e3dI0?ofkP3om^h0e3dI1`3om^h30=@m6@`0ooK^00<0e3dI0?ofkP3om^h02P3om^hD0=@m6@/0
ooK^00<0e3dI0?ofkP3om^h02P3om^h30=@m6@L0ooK^00@0e3dI0?ofkP3om^h0e3dIG03om^h00`00
0000ooK^0?ofkP080?ofkP030000003om^h0ooK^05l0ooK^0@3oool00640ooK^00<000000?ofkP3o
m^h0203om^h00`000000ooK^0?ofkP1K0?ofkP030=@m6@3om^h0e3dI00T0ooK^0P3D?AT;0?ofkP03
0=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP0;0?ofkP03
0=@m6@3om^h0ooK^00T0ooK^0P3D?AT90?ofkP030=@m6@3om^h0e3dI05d0ooK^00<000000?ofkP3o
m^h0203om^h00`000000ooK^0?ofkP1O0?ofkP40oooo001Q0?ofkP030000003om^h0ooK^00P0ooK^
00<000000?ofkP3om^h0G03om^h20=@m6@T0ooK^00@0e3dI0?ofkP3D?AT0e3dI2@3om^h00`3D?AT0
ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0
ooK^0?ofkP070?ofkP80e3dI00<0ooK^0=@m6@3om^h0203om^h20=@m6Eh0ooK^00<000000?ofkP3o
m^h0203om^h00`000000ooK^0?ofkP1O0?ofkP40oooo001R0?ofkP030000003om^h0ooK^00L0ooK^
00<000000?ofkP3om^h0G@3om^h00`3D?AT0ooK^0?ofkP070?ofkP040=@m6@3om^h0ooK^0?ofkP<0
e3dI1P3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3o
m^h02`3om^h00`3D?AT0ooK^0?ofkP040?ofkP<0e3dI0`3om^h00`3D?AT0ooK^0?ofkP070?ofkP03
0=@m6@3om^h0ooK^05d0ooK^00<000000?ofkP3om^h01`3om^h00`000000ooK^0?ofkP1P0?ofkP40
oooo001R0?ofkP030000003om^h0ooK^00L0ooK^00<000000?ofkP3om^h0GP3om^h20=@m6@L0ooK^
00<0e3dI0?ofkP3om^h0103om^h30=@m6@<0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^
0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00/0ooK^00@0e3dI0?ofkP3om^h0ooK^0`3D?AT60?ofkP03
0=@m6@3om^h0ooK^00D0ooK^0P3D?AUP0?ofkP030000003om^h0ooK^00L0ooK^00<000000?ofkP3o
m^h0H03om^h10?ooo`00HP3om^h00`000000ooK^0?ofkP060?ofkP030000003om^h0ooK^0640ooK^
00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP070?ofkP80e3dI00<0ooK^0=@m6@3om^h0
3@3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00`0ooK^00@0e3dI0?ofkP3D?AT0
e3dI2@3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^0640ooK^00<000000?ofkP3o
m^h01P3om^h00`000000ooK^0?ofkP1P0?ofkP40oooo001S0?ofkP030000003om^h0ooK^00D0ooK^
00<000000?ofkP3om^h0HP3om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00T0ooK^
103D?AT<0?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h02P3om^h40=@m6@X0ooK^
00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP1R0?ofkP030000003om^h0ooK^00D0ooK^
00<000000?ofkP3om^h0H@3om^h10?ooo`00H`3om^h00`000000ooK^0?ofkP050?ofkP030000003o
m^h0ooK^06<0ooK^0P3D?AT40?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h01@3D
?AT70?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h01@3om^h50=@m6@80ooK^00<0
e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP020?ofkP80e3dII@3om^h00`000000ooK^0?of
kP050?ofkP030000003om^h0ooK^0640ooK^0@3oool006<0ooK^00<000000?ofkP3om^h01@3om^h0
0`000000ooK^0?ofkP1U0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT02`3om^h00`3D?AT0ooK^0?of
kP050?ofkPD0e3dI0P3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00D0e3dI1`3o
m^h00`3D?AT0ooK^0?ofkP090?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT0I`3om^h00`000000ooK^
0?ofkP050?ofkP030000003om^h0ooK^0640ooK^0@3oool006@0ooK^00<000000?ofkP3om^h0103o
m^h00`000000ooK^0?ofkP1V0?ofkP040=@m6@3om^h0ooK^0=@m6@/0ooK^00<0e3dI0?ofkP3om^h0
2P3om^hC0=@m6@`0ooK^00<0e3dI0?ofkP3om^h02@3om^h0103D?AT0ooK^0?ofkP3D?AUX0?ofkP03
0000003om^h0ooK^00@0ooK^00<000000?ofkP3om^h0HP3om^h10?ooo`00I03om^h00`000000ooK^
0?ofkP040?ofkP030000003om^h0ooK^06L0ooK^0`3D?AT;0?ofkP030=@m6@3om^h0ooK^00`0ooK^
00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00T0ooK^
0`3D?AUY0?ofkP030000003om^h0ooK^00@0ooK^00<000000?ofkP3om^h0HP3om^h10?ooo`00I03o
m^h00`000000ooK^0?ofkP040?ofkP030000003om^h0ooK^06T0ooK^0P3D?AT:0?ofkP030=@m6@3o
m^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3o
m^h0ooK^00T0ooK^0P3D?AU[0?ofkP030000003om^h0ooK^00@0ooK^00<000000?ofkP3om^h0HP3o
m^h10?ooo`00I@3om^h00`000000ooK^0?ofkP030?ofkP030000003om^h0ooK^06/0ooK^0P3D?AT9
0?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP0;
0?ofkP030=@m6@3om^h0ooK^00L0ooK^0P3D?AU]0?ofkP030000003om^h0ooK^00<0ooK^00<00000
0?ofkP3om^h0H`3om^h10?ooo`00I@3om^h00`000000ooK^0?ofkP030?ofkP030000003om^h0ooK^
06d0ooK^0`3D?AT60?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D
?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00@0ooK^0`3D?AU_0?ofkP030000003om^h0ooK^
00<0ooK^00<000000?ofkP3om^h0H`3om^h10?ooo`00I@3om^h00`000000ooK^0?ofkP020?ofkP03
0000003om^h0ooK^0740ooK^0`3D?AT30?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3o
m^h02`3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP040=@m6@3om^h0ooK^0?ofkP<0e3dIL`3om^h00`00
0000ooK^0?ofkP020?ofkP030000003om^h0ooK^06<0ooK^0@3oool006D0ooK^00<000000?ofkP3o
m^h00P3om^h00`000000ooK^0?ofkP1d0?ofkP80e3dI00<0ooK^0=@m6@3om^h0303om^h00`3D?AT0
ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00/0ooK^00@0e3dI0?ofkP3D?AT0e3dIMP3om^h00`00
0000ooK^0?ofkP020?ofkP030000003om^h0ooK^06<0ooK^0@3oool006H0ooK^00D000000?ofkP3o
m^h0ooK^0000001h0?ofkPD0e3dI2P3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^
00P0ooK^1@3D?AUh0?ofkP050000003om^h0ooK^0?ofkP000000IP3om^h10?ooo`00IP3om^h01@00
0000ooK^0?ofkP3om^h0000007d0ooK^1`3D?AT30?ofkP030=@m6@3om^h0ooK^00/0ooK^00@0e3dI
0?ofkP3om^h0ooK^1`3D?AUm0?ofkP050000003om^h0ooK^0?ofkP000000IP3om^h10?ooo`00IP3o
m^h01@000000ooK^0?ofkP3om^h0000008@0ooK^5@3D?AV40?ofkP050000003om^h0ooK^0?ofkP00
0000IP3om^h10?ooo`00I`3om^h010000000ooK^0?ofkP00003o0?ofkQh0ooK^00@000000?ofkP3o
m^h00000I`3om^h10?ooo`00I`3om^h010000000ooK^0?ofkP00003o0?ofkQh0ooK^00@000000?of
kP3om^h00000I`3om^h10?ooo`00I`3om^h010000000ooK^0?ofkP00003o0?ofkQh0ooK^00@00000
0?ofkP3om^h00000I`3om^h10?ooo`00J03om^h200000?l0ooK^803om^h2000006P0ooK^0@3oool0
06P0ooK^0P00003o0?ofkR00ooK^0P00001X0?ofkP40oooo001X0?ofkP800000o`3om^hP0?ofkP80
0000J03om^h10?ooo`00J@3om^h00`000000ooK^0?ofkP3o0?ofkQh0ooK^00<000000?ofkP3om^h0
I`3om^h10?ooo`00J@3om^ko000002800000J@3om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?of
k_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3o
ool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^
m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?oo
o`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd
0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo
003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0
ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool0
0?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03o
m^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00
o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?of
kP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o
0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^
0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0
ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h1
0?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3o
m^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40
oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?of
k_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3o
ool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^
m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?oo
o`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd
0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo
003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0
ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool0
0?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03o
m^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00
o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?of
kP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o
0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^
0@3oool00001\
\>"],
  ImageRangeCache->{{{0, 499}, {499, 0}} -> {-5.00005*^-06, -5.00005*^-06, \
0.00200403, 0.00200403}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
%%ImageSize: 500 500 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics3D
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Background color
1 .961 .933 r
MFill
% Scaling calculations
0 1 0 1 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 0 r
.25 Mabswid
[ ] 0 setdash
.67872 .58361 m
.6978 .81857 L
s
.6978 .81857 m
.97075 .49223 L
s
.97075 .49223 m
.91053 .22236 L
s
.91053 .22236 m
.67872 .58361 L
s
.16861 .50547 m
.24028 .08168 L
s
.24028 .08168 m
.19793 .35868 L
s
.19793 .35868 m
.13045 .74993 L
s
.13045 .74993 m
.16861 .50547 L
s
.67872 .58361 m
.6978 .81857 L
s
.6978 .81857 m
.13045 .74993 L
s
.13045 .74993 m
.16861 .50547 L
s
.16861 .50547 m
.67872 .58361 L
s
.91053 .22236 m
.24028 .08168 L
s
.24028 .08168 m
.19793 .35868 L
s
.19793 .35868 m
.97075 .49223 L
s
.97075 .49223 m
.91053 .22236 L
s
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
.83 .24 .1 r
.5 Mabswid
.44775 .54761 m
.47256 .55588 L
s
.47256 .55588 m
.48149 .53577 L
s
.47256 .55588 m
.49565 .56818 L
s
.49565 .56818 m
.50501 .54826 L
s
.49565 .56818 m
.51618 .58405 L
s
.42217 .54369 m
.44775 .54761 L
s
.44775 .54761 m
.45626 .52733 L
s
.51618 .58405 m
.52593 .56436 L
s
.51618 .58405 m
.53334 .60293 L
s
.39675 .54431 m
.42217 .54369 L
s
.42217 .54369 m
.43025 .52327 L
s
.53334 .60293 m
.54345 .58347 L
s
.53334 .60293 m
.54642 .62415 L
s
.3725 .54952 m
.39675 .54431 L
s
.39675 .54431 m
.40443 .52378 L
s
.54642 .62415 m
.55683 .60493 L
s
.54642 .62415 m
.55482 .64691 L
s
.35037 .55922 m
.3725 .54952 L
s
.3725 .54952 m
.37979 .52894 L
s
.45626 .52733 m
.48149 .53577 L
s
.48149 .53577 m
.49075 .51493 L
s
.48149 .53577 m
.50501 .54826 L
s
.50501 .54826 m
.5147 .52763 L
s
.50501 .54826 m
.52593 .56436 L
s
.43025 .52327 m
.45626 .52733 L
s
.45626 .52733 m
.46508 .50631 L
s
.52593 .56436 m
.53603 .54395 L
s
.52593 .56436 m
.54345 .58347 L
s
.40443 .52378 m
.43025 .52327 L
s
.43025 .52327 m
.43863 .5021 L
s
.55482 .64691 m
.56548 .62794 L
s
.55482 .64691 m
.5581 .67035 L
s
.33134 .57313 m
.35037 .55922 L
s
.35037 .55922 m
.35733 .53862 L
s
.54345 .58347 m
.55392 .5633 L
s
.54345 .58347 m
.55683 .60493 L
s
.37979 .52894 m
.40443 .52378 L
s
.40443 .52378 m
.41238 .5025 L
s
.55683 .60493 m
.56763 .58501 L
s
.55683 .60493 m
.56548 .62794 L
s
.5581 .67035 m
.56892 .65162 L
s
.5581 .67035 m
.55595 .6935 L
s
.35733 .53862 m
.37979 .52894 L
s
.37979 .52894 m
.38735 .50759 L
s
.46508 .50631 m
.49075 .51493 L
s
.49075 .51493 m
.50036 .49333 L
s
.49075 .51493 m
.5147 .52763 L
s
.31627 .59079 m
.33134 .57313 L
s
.33134 .57313 m
.33801 .55258 L
s
.5147 .52763 m
.52475 .50624 L
s
.5147 .52763 m
.53603 .54395 L
s
.43863 .5021 m
.46508 .50631 L
s
.46508 .50631 m
.47422 .48451 L
s
.53603 .54395 m
.54651 .52279 L
s
.53603 .54395 m
.55392 .5633 L
s
.41238 .5025 m
.43863 .5021 L
s
.43863 .5021 m
.44731 .48015 L
s
.56548 .62794 m
.57654 .60827 L
s
.56548 .62794 m
.56892 .65162 L
s
.33801 .55258 m
.35733 .53862 L
s
.35733 .53862 m
.36454 .51727 L
s
.55392 .5633 m
.56479 .54239 L
s
.55392 .5633 m
.56763 .58501 L
s
.55595 .6935 m
.56686 .675 L
s
.55595 .6935 m
.54831 .71538 L
s
.38735 .50759 m
.41238 .5025 L
s
.41238 .5025 m
.42063 .48044 L
s
.30595 .61157 m
.31627 .59079 L
s
.31627 .59079 m
.32274 .57035 L
s
.56763 .58501 m
.57883 .56435 L
s
.56763 .58501 m
.57654 .60827 L
s
.56892 .65162 m
.58015 .63219 L
s
.56892 .65162 m
.56686 .675 L
s
.36454 .51727 m
.38735 .50759 L
s
.38735 .50759 m
.3952 .48545 L
s
.47422 .48451 m
.50036 .49333 L
s
.50036 .49333 m
.51032 .47091 L
s
.50036 .49333 m
.52475 .50624 L
s
.32274 .57035 m
.33801 .55258 L
s
.33801 .55258 m
.34494 .53126 L
s
.52475 .50624 m
.53518 .48405 L
s
.52475 .50624 m
.54651 .52279 L
s
.44731 .48015 m
.47422 .48451 L
s
.47422 .48451 m
.48371 .4619 L
s
.54831 .71538 m
.55919 .69708 L
s
.54831 .71538 m
.53532 .73497 L
s
.301 .63465 m
.30595 .61157 L
s
.30595 .61157 m
.3123 .59129 L
s
.54651 .52279 m
.55738 .50083 L
s
.54651 .52279 m
.56479 .54239 L
s
.42063 .48044 m
.44731 .48015 L
s
.44731 .48015 m
.45633 .45737 L
s
.57654 .60827 m
.58801 .58786 L
s
.57654 .60827 m
.58015 .63219 L
s
.34494 .53126 m
.36454 .51727 L
s
.36454 .51727 m
.37203 .4951 L
s
.56479 .54239 m
.57606 .52068 L
s
.56479 .54239 m
.57883 .56435 L
s
.56686 .675 m
.57817 .6558 L
s
.56686 .675 m
.55919 .69708 L
s
.24 .35 .67 r
.73513 .51389 m
.73 .54129 L
s
.73 .54129 m
.69411 .53554 L
s
.73 .54129 m
.72692 .56888 L
s
.83 .24 .1 r
.3952 .48545 m
.42063 .48044 L
s
.42063 .48044 m
.42919 .45753 L
s
.3123 .59129 m
.32274 .57035 L
s
.32274 .57035 m
.32946 .54912 L
s
.24 .35 .67 r
.74214 .48758 m
.73513 .51389 L
s
.73513 .51389 m
.69922 .50799 L
s
.72692 .56888 m
.69093 .56326 L
s
.72692 .56888 m
.726 .59574 L
s
.83 .24 .1 r
.53532 .73497 m
.54608 .71683 L
s
.53532 .73497 m
.51741 .75129 L
s
.30733 .61457 m
.301 .63465 L
s
.30182 .65903 m
.301 .63465 L
s
.24 .35 .67 r
.69922 .50799 m
.69411 .53554 L
s
.69411 .53554 m
.65787 .52974 L
s
.69411 .53554 m
.69093 .56326 L
s
.75083 .46327 m
.74214 .48758 L
s
.74214 .48758 m
.7061 .48153 L
s
.7061 .48153 m
.69922 .50799 L
s
.69922 .50799 m
.66296 .50204 L
s
.83 .24 .1 r
.57883 .56435 m
.58801 .58786 L
s
.58015 .63219 m
.59181 .61202 L
s
.58015 .63219 m
.57817 .6558 L
s
.24 .35 .67 r
.69093 .56326 m
.65459 .55758 L
s
.69093 .56326 m
.6898 .59022 L
s
.83 .24 .1 r
.37203 .4951 m
.3952 .48545 L
s
.3952 .48545 m
.40334 .46246 L
s
.48371 .4619 m
.51032 .47091 L
s
.51032 .47091 m
.52066 .44764 L
s
.51032 .47091 m
.53518 .48405 L
s
.24 .35 .67 r
.726 .59574 m
.6898 .59022 L
s
.726 .59574 m
.72732 .62095 L
s
.83 .24 .1 r
.32946 .54912 m
.34494 .53126 L
s
.34494 .53126 m
.35213 .50913 L
s
.53518 .48405 m
.55738 .50083 L
s
.45633 .45737 m
.48371 .4619 L
s
.48371 .4619 m
.49355 .43843 L
s
.24 .35 .67 r
.66296 .50204 m
.65787 .52974 L
s
.65787 .52974 m
.62126 .52387 L
s
.65787 .52974 m
.65459 .55758 L
s
.83 .24 .1 r
.55919 .69708 m
.57049 .67808 L
s
.55919 .69708 m
.54608 .71683 L
s
.24 .35 .67 r
.71453 .45704 m
.7061 .48153 L
s
.7061 .48153 m
.66969 .47541 L
s
.66969 .47541 m
.66296 .50204 L
s
.66296 .50204 m
.62632 .49603 L
s
.83 .24 .1 r
.30733 .61457 m
.3123 .59129 L
s
.3123 .59129 m
.3189 .57022 L
s
.55738 .50083 m
.57606 .52068 L
s
.24 .35 .67 r
.65459 .55758 m
.61787 .55184 L
s
.65459 .55758 m
.65323 .58464 L
s
.83 .24 .1 r
.51741 .75129 m
.52794 .73327 L
s
.51741 .75129 m
.49527 .76347 L
s
.42919 .45753 m
.45633 .45737 L
s
.45633 .45737 m
.46569 .43372 L
s
.24 .35 .67 r
.6898 .59022 m
.65323 .58464 L
s
.6898 .59022 m
.69079 .6155 L
s
.76094 .44185 m
.75083 .46327 L
s
.75083 .46327 m
.71453 .45704 L
s
.83 .24 .1 r
.30855 .6836 m
.30182 .65903 L
s
.30182 .65903 m
.30823 .63921 L
s
.24 .35 .67 r
.62632 .49603 m
.62126 .52387 L
s
.62126 .52387 m
.61787 .55184 L
s
.83 .24 .1 r
.58801 .58786 m
.59181 .61202 L
s
.24 .35 .67 r
.67787 .45075 m
.66969 .47541 L
s
.66969 .47541 m
.63291 .46924 L
s
.63291 .46924 m
.62632 .49603 L
s
.62632 .49603 m
.58932 .48996 L
s
.83 .24 .1 r
.35213 .50913 m
.37203 .4951 L
s
.37203 .4951 m
.3798 .47208 L
s
.24 .35 .67 r
.72732 .62095 m
.69079 .6155 L
s
.72732 .62095 m
.73089 .64356 L
s
.61787 .55184 m
.61629 .57901 L
s
.83 .24 .1 r
.57817 .6558 m
.58992 .63586 L
s
.57817 .6558 m
.57049 .67808 L
s
.24 .35 .67 r
.65323 .58464 m
.61629 .57901 L
s
.65323 .58464 m
.65388 .61 L
s
.83 .24 .1 r
.40334 .46246 m
.42919 .45753 L
s
.42919 .45753 m
.43808 .43375 L
s
.24 .35 .67 r
.72428 .43545 m
.71453 .45704 L
s
.71453 .45704 m
.67787 .45075 L
s
.83 .24 .1 r
.3189 .57022 m
.32946 .54912 L
s
.32946 .54912 m
.33643 .52708 L
s
.264 .375 .727 r
.56993 .53748 m .58669 .54012 L .57871 .5171 L p F P
0 0 0 r
s
.83 .24 .1 r
.57606 .52068 m
.57673 .52171 L
s
.257 .362 .701 r
.58669 .54012 m .56993 .53748 L .57484 .55954 L p F P
0 0 0 r
s
.257 .362 .701 r
.57484 .55954 m .59276 .5623 L .58669 .54012 L p F P
0 0 0 r
s
.83 .24 .1 r
.57883 .56435 m
.58093 .56048 L
s
.578 .169 .078 r
.59201 .53023 m .58669 .54012 L .57871 .5171 L p F P
0 0 0 r
s
.471 .137 .065 r
.58669 .54012 m .59201 .53023 L .59851 .55191 L p F P
0 0 0 r
s
.471 .137 .065 r
.59851 .55191 m .59276 .5623 L .58669 .54012 L p F P
0 0 0 r
s
.83 .24 .1 r
.5878 .5478 m
.59046 .5429 L
s
.24 .35 .67 r
.59754 .54866 m
.61787 .55184 L
s
.58078 .54605 m
.58916 .54736 L
s
.667 .196 .088 r
.58348 .50795 m .57871 .5171 L .56897 .49365 L p F P
0 0 0 r
s
.578 .169 .078 r
.57871 .5171 m .58348 .50795 L .59201 .53023 L p F P
0 0 0 r
s
.83 .24 .1 r
.58075 .52792 m
.59046 .5429 L
s
.24 .35 .67 r
.58751 .51847 m
.62126 .52387 L
s
.27 .386 .75 r
.56349 .51466 m .57871 .5171 L .56897 .49365 L p F P
0 0 0 r
s
.264 .375 .727 r
.57871 .5171 m .56349 .51466 L .56993 .53748 L p F P
0 0 0 r
s
.24 .35 .67 r
.58524 .51256 m
.58932 .48996 L
s
.58078 .54605 m
.58313 .52713 L
s
.64082 .4444 m
.63291 .46924 L
s
.63291 .46924 m
.59576 .463 L
s
.59576 .463 m
.58932 .48996 L
s
.83 .24 .1 r
.54608 .71683 m
.55725 .698 L
s
.54608 .71683 m
.52794 .73327 L
s
.27 .386 .75 r
.56897 .49365 m .55561 .49147 L .56349 .51466 L p F P
0 0 0 r
s
.83 .24 .1 r
.55738 .50083 m
.55822 .49914 L
s
.27 .386 .75 r
.54819 .51221 m .56349 .51466 L .55561 .49147 L p F P
0 0 0 r
s
.264 .375 .727 r
.56349 .51466 m .54819 .51221 L .5531 .53484 L p F P
0 0 0 r
s
.264 .375 .727 r
.5531 .53484 m .56993 .53748 L .56349 .51466 L p F P
0 0 0 r
s
.257 .362 .701 r
.56993 .53748 m .5531 .53484 L .55683 .55676 L p F P
0 0 0 r
s
.257 .362 .701 r
.55683 .55676 m .57484 .55954 L .56993 .53748 L p F P
0 0 0 r
s
.83 .24 .1 r
.49527 .76347 m
.50547 .74552 L
s
.49527 .76347 m
.46984 .77082 L
s
.248 .347 .671 r
.59276 .5623 m .57484 .55954 L .57811 .58042 L p F P
0 0 0 r
s
.248 .347 .671 r
.57811 .58042 m .5968 .58325 L .59276 .5623 L p F P
0 0 0 r
s
.83 .24 .1 r
.58801 .58786 m
.59108 .58239 L
s
.34 .098 .05 r
.59276 .5623 m .59851 .55191 L .60284 .57261 L p F P
0 0 0 r
s
.34 .098 .05 r
.60284 .57261 m .5968 .58325 L .59276 .5623 L p F P
0 0 0 r
s
.275 .396 .771 r
.55561 .49147 m .56897 .49365 L .55761 .47016 L p F P
0 0 0 r
s
.744 .218 .097 r
.57307 .48547 m .56897 .49365 L .55761 .47016 L p F P
0 0 0 r
s
.667 .196 .088 r
.56897 .49365 m .57307 .48547 L .58348 .50795 L p F P
0 0 0 r
s
.24 .35 .67 r
.57398 .48744 m
.58932 .48996 L
s
.69079 .6155 m
.65388 .61 L
s
.69079 .6155 m
.69392 .63817 L
s
.57897 .57332 m
.58078 .54605 L
s
.83 .24 .1 r
.3139 .59372 m
.30733 .61457 L
s
.30823 .63921 m
.30733 .61457 L
s
.24 .35 .67 r
.57897 .57332 m
.5958 .57589 L
s
.60057 .57661 m
.61629 .57901 L
s
.61629 .57901 m
.6166 .60445 L
s
.83 .24 .1 r
.32101 .70718 m
.30855 .6836 L
s
.30855 .6836 m
.31515 .66408 L
s
.27 .386 .75 r
.55561 .49147 m .5422 .48928 L .54819 .51221 L p F P
0 0 0 r
s
.27 .386 .75 r
.53284 .50975 m .54819 .51221 L .5422 .48928 L p F P
0 0 0 r
s
.264 .375 .727 r
.54819 .51221 m .53284 .50975 L .53619 .53218 L p F P
0 0 0 r
s
.264 .375 .727 r
.53619 .53218 m .5531 .53484 L .54819 .51221 L p F P
0 0 0 r
s
.24 .35 .67 r
.54691 .51197 m
.57954 .51719 L
s
.275 .396 .771 r
.55761 .47016 m .54644 .4683 L .55561 .49147 L p F P
0 0 0 r
s
.275 .396 .771 r
.5422 .48928 m .55561 .49147 L .54644 .4683 L p F P
0 0 0 r
s
.24 .35 .67 r
.55193 .48382 m
.56624 .48617 L
s
.68724 .42897 m
.67787 .45075 L
s
.67787 .45075 m
.64082 .4444 L
s
.257 .362 .701 r
.5531 .53484 m .53619 .53218 L .53874 .55397 L p F P
0 0 0 r
s
.257 .362 .701 r
.53874 .55397 m .55683 .55676 L .5531 .53484 L p F P
0 0 0 r
s
.24 .35 .67 r
.54331 .54019 m
.58078 .54605 L
s
.248 .347 .671 r
.57484 .55954 m .55683 .55676 L .55932 .57757 L p F P
0 0 0 r
s
.248 .347 .671 r
.55932 .57757 m .57811 .58042 L .57484 .55954 L p F P
0 0 0 r
s
.24 .35 .67 r
.54691 .51197 m
.55193 .48382 L
s
.54331 .54019 m
.54691 .51197 L
s
.77214 .4242 m
.76094 .44185 L
s
.76094 .44185 m
.72428 .43545 L
s
.275 .396 .771 r
.54644 .4683 m .53523 .46644 L .5422 .48928 L p F P
0 0 0 r
s
.83 .24 .1 r
.53518 .48405 m
.53847 .47705 L
s
.275 .396 .771 r
.52875 .48708 m .5422 .48928 L .53523 .46644 L p F P
0 0 0 r
s
.27 .386 .75 r
.5422 .48928 m .52875 .48708 L .53284 .50975 L p F P
0 0 0 r
s
.27 .386 .75 r
.51742 .50728 m .53284 .50975 L .52875 .48708 L p F P
0 0 0 r
s
.264 .375 .727 r
.53284 .50975 m .51742 .50728 L .5192 .52951 L p F P
0 0 0 r
s
.264 .375 .727 r
.5192 .52951 m .53619 .53218 L .53284 .50975 L p F P
0 0 0 r
s
.24 .35 .67 r
.6034 .43798 m
.59576 .463 L
s
.83 .24 .1 r
.3798 .47208 m
.40334 .46246 L
s
.257 .362 .701 r
.53619 .53218 m .5192 .52951 L .52055 .55116 L p F P
0 0 0 r
s
.257 .362 .701 r
.52055 .55116 m .53874 .55397 L .53619 .53218 L p F P
0 0 0 r
s
.83 .24 .1 r
.49355 .43843 m
.52066 .44764 L
s
.237 .33 .635 r
.5968 .58325 m .57811 .58042 L .57966 .59975 L p F P
0 0 0 r
s
.237 .33 .635 r
.57966 .59975 m .59871 .60259 L .5968 .58325 L p F P
0 0 0 r
s
.231 .067 .035 r
.5968 .58325 m .60284 .57261 L .60489 .59192 L p F P
0 0 0 r
s
.231 .067 .035 r
.60489 .59192 m .59871 .60259 L .5968 .58325 L p F P
0 0 0 r
s
.81 .238 .105 r
.56097 .46321 m .55761 .47016 L .54482 .44706 L p F P
0 0 0 r
s
.24 .35 .67 r
.55822 .45669 m
.59576 .463 L
s
.744 .218 .097 r
.55761 .47016 m .56097 .46321 L .57307 .48547 L p F P
0 0 0 r
s
.28 .405 .79 r
.54644 .4683 m .55761 .47016 L .54482 .44706 L p F P
0 0 0 r
s
.83 .24 .1 r
.54286 .46771 m
.5459 .46124 L
s
.24 .35 .67 r
.55193 .48382 m
.55642 .46449 L
s
.55751 .45975 m
.55822 .45669 L
s
.83 .24 .1 r
.52066 .44764 m
.54587 .46093 L
s
.248 .347 .671 r
.55683 .55676 m .53874 .55397 L .54044 .57471 L p F P
0 0 0 r
s
.248 .347 .671 r
.54044 .57471 m .55932 .57757 L .55683 .55676 L p F P
0 0 0 r
s
.24 .35 .67 r
.65388 .61 m
.6166 .60445 L
s
.65388 .61 m
.65658 .63272 L
s
.54126 .56757 m
.54331 .54019 L
s
.83 .24 .1 r
.33643 .52708 m
.35213 .50913 L
s
.35213 .50913 m
.3596 .48613 L
s
.667 .196 .088 r
.58831 .49865 m .58348 .50795 L .57307 .48547 L p F P
0 0 0 r
s
.578 .169 .078 r
.58348 .50795 m .58831 .49865 L .59742 .52016 L p F P
0 0 0 r
s
.578 .169 .078 r
.59742 .52016 m .59201 .53023 L .58348 .50795 L p F P
0 0 0 r
s
.275 .396 .771 r
.53523 .46644 m .52399 .46458 L .52875 .48708 L p F P
0 0 0 r
s
.275 .396 .771 r
.51524 .48488 m .52875 .48708 L .52399 .46458 L p F P
0 0 0 r
s
.27 .386 .75 r
.52875 .48708 m .51524 .48488 L .51742 .50728 L p F P
0 0 0 r
s
.27 .386 .75 r
.50193 .5048 m .51742 .50728 L .51524 .48488 L p F P
0 0 0 r
s
.264 .375 .727 r
.51742 .50728 m .50193 .5048 L .50213 .52683 L p F P
0 0 0 r
s
.264 .375 .727 r
.50213 .52683 m .5192 .52951 L .51742 .50728 L p F P
0 0 0 r
s
.24 .35 .67 r
.50917 .50592 m
.54691 .51197 L
s
.83 .24 .1 r
.46569 .43372 m
.49355 .43843 L
s
.24 .35 .67 r
.54126 .56757 m
.57897 .57332 L
s
.471 .137 .065 r
.59201 .53023 m .59742 .52016 L .60436 .54133 L p F P
0 0 0 r
s
.471 .137 .065 r
.60436 .54133 m .59851 .55191 L .59201 .53023 L p F P
0 0 0 r
s
.28 .405 .79 r
.54482 .44706 m .53611 .44559 L .54644 .4683 L p F P
0 0 0 r
s
.28 .405 .79 r
.53523 .46644 m .54644 .4683 L .53611 .44559 L p F P
0 0 0 r
s
.257 .362 .701 r
.5192 .52951 m .50213 .52683 L .50228 .54834 L p F P
0 0 0 r
s
.257 .362 .701 r
.50228 .54834 m .52055 .55116 L .5192 .52951 L p F P
0 0 0 r
s
.24 .35 .67 r
.50545 .53428 m
.54331 .54019 L
s
.744 .218 .097 r
.57723 .47719 m .57307 .48547 L .56097 .46321 L p F P
0 0 0 r
s
.83 .24 .1 r
.55248 .46587 m
.56867 .47804 L
s
.56431 .48683 m
.56867 .47804 L
s
.667 .196 .088 r
.57307 .48547 m .57723 .47719 L .58831 .49865 L p F P
0 0 0 r
s
.83 .24 .1 r
.57049 .67808 m
.58223 .65834 L
s
.57049 .67808 m
.55725 .698 L
s
.24 .35 .67 r
.64981 .42243 m
.64082 .4444 L
s
.64082 .4444 m
.6034 .43798 L
s
.73089 .64356 m
.69392 .63817 L
s
.73089 .64356 m
.73666 .66268 L
s
.275 .396 .771 r
.52399 .46458 m .51272 .4627 L .51524 .48488 L p F P
0 0 0 r
s
.275 .396 .771 r
.50169 .48267 m .51524 .48488 L .51272 .4627 L p F P
0 0 0 r
s
.27 .386 .75 r
.51524 .48488 m .50169 .48267 L .50193 .5048 L p F P
0 0 0 r
s
.24 .35 .67 r
.51417 .47763 m
.55193 .48382 L
s
.248 .347 .671 r
.53874 .55397 m .52055 .55116 L .52146 .57184 L p F P
0 0 0 r
s
.248 .347 .671 r
.52146 .57184 m .54044 .57471 L .53874 .55397 L p F P
0 0 0 r
s
.237 .33 .635 r
.57811 .58042 m .55932 .57757 L .5605 .5969 L p F P
0 0 0 r
s
.237 .33 .635 r
.5605 .5969 m .57966 .59975 L .57811 .58042 L p F P
0 0 0 r
s
.83 .24 .1 r
.46984 .77082 m
.47963 .75287 L
s
.46984 .77082 m
.44232 .77285 L
s
.24 .35 .67 r
.50545 .53428 m
.50917 .50592 L
s
.28 .405 .79 r
.53611 .44559 m .52739 .44412 L .53523 .46644 L p F P
0 0 0 r
s
.28 .405 .79 r
.52399 .46458 m .53523 .46644 L .52739 .44412 L p F P
0 0 0 r
s
.27 .386 .75 r
.48638 .50231 m .50193 .5048 L .50169 .48267 L p F P
0 0 0 r
s
.264 .375 .727 r
.50193 .5048 m .48638 .50231 L .48498 .52413 L p F P
0 0 0 r
s
.264 .375 .727 r
.48498 .52413 m .50213 .52683 L .50193 .5048 L p F P
0 0 0 r
s
.24 .35 .67 r
.73502 .41761 m
.72428 .43545 L
s
.72428 .43545 m
.68724 .42897 L
s
.83 .24 .1 r
.3139 .59372 m
.3189 .57022 L
s
.3189 .57022 m
.32575 .54833 L
s
.33873 .72857 m
.32101 .70718 L
s
.32101 .70718 m
.32791 .68796 L
s
.24 .35 .67 r
.55369 .45593 m
.55822 .45669 L
s
.257 .362 .701 r
.50213 .52683 m .48498 .52413 L .48391 .54551 L p F P
0 0 0 r
s
.257 .362 .701 r
.48391 .54551 m .50228 .54834 L .50213 .52683 L p F P
0 0 0 r
s
.275 .396 .771 r
.51272 .4627 m .50141 .46083 L .50169 .48267 L p F P
0 0 0 r
s
.24 .35 .67 r
.50917 .50592 m
.51417 .47763 L
s
.275 .396 .771 r
.48808 .48045 m .50169 .48267 L .50141 .46083 L p F P
0 0 0 r
s
.27 .386 .75 r
.50169 .48267 m .48808 .48045 L .48638 .50231 L p F P
0 0 0 r
s
.34 .098 .05 r
.59851 .55191 m .60436 .54133 L .609 .56176 L p F P
0 0 0 r
s
.34 .098 .05 r
.609 .56176 m .60284 .57261 L .59851 .55191 L p F P
0 0 0 r
s
.83 .24 .1 r
.59046 .5429 m
.59992 .56666 L
s
.5945 .5763 m
.59992 .56666 L
s
.28 .405 .79 r
.52739 .44412 m .51865 .44264 L .52399 .46458 L p F P
0 0 0 r
s
.28 .405 .79 r
.51272 .4627 m .52399 .46458 L .51865 .44264 L p F P
0 0 0 r
s
.83 .24 .1 r
.52794 .73327 m
.53888 .71456 L
s
.52794 .73327 m
.50547 .74552 L
s
.43808 .43375 m
.46569 .43372 L
s
.248 .347 .671 r
.52055 .55116 m .50228 .54834 L .50238 .56895 L p F P
0 0 0 r
s
.248 .347 .671 r
.50238 .56895 m .52146 .57184 L .52055 .55116 L p F P
0 0 0 r
s
.237 .33 .635 r
.55932 .57757 m .54044 .57471 L .54124 .59403 L p F P
0 0 0 r
s
.237 .33 .635 r
.54124 .59403 m .5605 .5969 L .55932 .57757 L p F P
0 0 0 r
s
.27 .386 .75 r
.47076 .49981 m .48638 .50231 L .48808 .48045 L p F P
0 0 0 r
s
.264 .375 .727 r
.48638 .50231 m .47076 .49981 L .46775 .52142 L p F P
0 0 0 r
s
.264 .375 .727 r
.46775 .52142 m .48498 .52413 L .48638 .50231 L p F P
0 0 0 r
s
.24 .35 .67 r
.47103 .49981 m
.50917 .50592 L
s
.6166 .60445 m
.61884 .62721 L
s
.50317 .56176 m
.50545 .53428 L
s
.81 .238 .105 r
.54482 .44706 m .54737 .44156 L .56097 .46321 L p F P
0 0 0 r
s
.81 .238 .105 r
.56436 .45617 m .56097 .46321 L .54737 .44156 L p F P
0 0 0 r
s
.24 .35 .67 r
.5203 .45032 m
.55064 .45542 L
s
.744 .218 .097 r
.56097 .46321 m .56436 .45617 L .57723 .47719 L p F P
0 0 0 r
s
.28 .405 .79 r
.51865 .44264 m .50988 .44116 L .51272 .4627 L p F P
0 0 0 r
s
.24 .35 .67 r
.51417 .47763 m
.5203 .45032 L
s
.28 .405 .79 r
.50141 .46083 m .51272 .4627 L .50988 .44116 L p F P
0 0 0 r
s
.275 .396 .771 r
.50141 .46083 m .49007 .45894 L .48808 .48045 L p F P
0 0 0 r
s
.275 .396 .771 r
.47443 .47822 m .48808 .48045 L .49007 .45894 L p F P
0 0 0 r
s
.27 .386 .75 r
.48808 .48045 m .47443 .47822 L .47076 .49981 L p F P
0 0 0 r
s
.24 .35 .67 r
.50317 .56176 m
.54126 .56757 L
s
.83 .24 .1 r
.31515 .66408 m
.30823 .63921 L
s
.30823 .63921 m
.31489 .61862 L
s
.257 .362 .701 r
.48498 .52413 m .46775 .52142 L .46546 .54266 L p F P
0 0 0 r
s
.257 .362 .701 r
.46546 .54266 m .48391 .54551 L .48498 .52413 L p F P
0 0 0 r
s
.224 .307 .59 r
.59871 .60259 m .57966 .59975 L .57941 .61713 L p F P
0 0 0 r
s
.83 .24 .1 r
.59181 .61202 m
.59615 .60451 L
s
.224 .307 .59 r
.57941 .61713 m .59841 .61991 L .59871 .60259 L p F P
0 0 0 r
s
.83 .24 .1 r
.58992 .63586 m
.59127 .61886 L
s
.171 .049 .025 r
.59871 .60259 m .60489 .59192 L .60457 .60945 L p F P
0 0 0 r
s
.24 .35 .67 r
.6047 .60267 m
.6166 .60445 L
s
.171 .049 .025 r
.60457 .60945 m .59841 .61991 L .59871 .60259 L p F P
0 0 0 r
s
.87 .256 .112 r
.54737 .44156 m .54482 .44706 L .53079 .42478 L p F P
0 0 0 r
s
.284 .414 .807 r
.53611 .44559 m .54482 .44706 L .53079 .42478 L p F P
0 0 0 r
s
.27 .386 .75 r
.45508 .4973 m .47076 .49981 L .47443 .47822 L p F P
0 0 0 r
s
.264 .375 .727 r
.47076 .49981 m .45508 .4973 L .45045 .5187 L p F P
0 0 0 r
s
.264 .375 .727 r
.45045 .5187 m .46775 .52142 L .47076 .49981 L p F P
0 0 0 r
s
.24 .35 .67 r
.612 .41582 m
.6034 .43798 L
s
.248 .347 .671 r
.50228 .54834 m .48391 .54551 L .4832 .56604 L p F P
0 0 0 r
s
.248 .347 .671 r
.4832 .56604 m .50238 .56895 L .50228 .54834 L p F P
0 0 0 r
s
.24 .35 .67 r
.69392 .63817 m
.65658 .63272 L
s
.69392 .63817 m
.69917 .6573 L
s
.28 .405 .79 r
.50988 .44116 m .50109 .43968 L .50141 .46083 L p F P
0 0 0 r
s
.28 .405 .79 r
.49007 .45894 m .50141 .46083 L .50109 .43968 L p F P
0 0 0 r
s
.237 .33 .635 r
.54044 .57471 m .52146 .57184 L .52189 .59115 L p F P
0 0 0 r
s
.237 .33 .635 r
.52189 .59115 m .54124 .59403 L .54044 .57471 L p F P
0 0 0 r
s
.275 .396 .771 r
.49007 .45894 m .47869 .45705 L .47443 .47822 L p F P
0 0 0 r
s
.275 .396 .771 r
.46073 .47599 m .47443 .47822 L .47869 .45705 L p F P
0 0 0 r
s
.24 .35 .67 r
.47601 .47136 m
.51417 .47763 L
s
.27 .386 .75 r
.47443 .47822 m .46073 .47599 L .45508 .4973 L p F P
0 0 0 r
s
.24 .35 .67 r
.47103 .49981 m
.47601 .47136 L
s
.667 .196 .088 r
.59323 .4892 m .58831 .49865 L .57723 .47719 L p F P
0 0 0 r
s
.83 .24 .1 r
.57753 .51787 m
.58777 .49814 L
s
.578 .169 .078 r
.58831 .49865 m .59323 .4892 L .60292 .50992 L p F P
0 0 0 r
s
.578 .169 .078 r
.60292 .50992 m .59742 .52016 L .58831 .49865 L p F P
0 0 0 r
s
.284 .414 .807 r
.53079 .42478 m .5248 .42375 L .53611 .44559 L p F P
0 0 0 r
s
.284 .414 .807 r
.52739 .44412 m .53611 .44559 L .5248 .42375 L p F P
0 0 0 r
s
.24 .35 .67 r
.69751 .41095 m
.68724 .42897 L
s
.68724 .42897 m
.64981 .42243 L
s
.744 .218 .097 r
.58144 .46878 m .57723 .47719 L .56436 .45617 L p F P
0 0 0 r
s
.667 .196 .088 r
.57723 .47719 m .58144 .46878 L .59323 .4892 L p F P
0 0 0 r
s
.83 .24 .1 r
.56867 .47804 m
.58777 .49814 L
s
.257 .362 .701 r
.46775 .52142 m .45045 .5187 L .44691 .5398 L p F P
0 0 0 r
s
.257 .362 .701 r
.44691 .5398 m .46546 .54266 L .46775 .52142 L p F P
0 0 0 r
s
.24 .35 .67 r
.46721 .5283 m
.50545 .53428 L
s
.46721 .5283 m
.47103 .49981 L
s
.83 .24 .1 r
.44232 .77285 m
.45162 .75484 L
s
.44232 .77285 m
.41404 .76938 L
s
.28 .405 .79 r
.50109 .43968 m .49229 .43819 L .49007 .45894 L p F P
0 0 0 r
s
.28 .405 .79 r
.47869 .45705 m .49007 .45894 L .49229 .43819 L p F P
0 0 0 r
s
.27 .386 .75 r
.43933 .49478 m .45508 .4973 L .46073 .47599 L p F P
0 0 0 r
s
.264 .375 .727 r
.45508 .4973 m .43933 .49478 L .43306 .51597 L p F P
0 0 0 r
s
.264 .375 .727 r
.43306 .51597 m .45045 .5187 L .45508 .4973 L p F P
0 0 0 r
s
.284 .414 .807 r
.5248 .42375 m .5188 .42272 L .52739 .44412 L p F P
0 0 0 r
s
.83 .24 .1 r
.52258 .44331 m
.52494 .43801 L
s
.284 .414 .807 r
.51865 .44264 m .52739 .44412 L .5188 .42272 L p F P
0 0 0 r
s
.24 .35 .67 r
.5203 .45032 m
.52738 .42494 L
s
.231 .067 .035 r
.60284 .57261 m .609 .56176 L .61119 .58104 L p F P
0 0 0 r
s
.231 .067 .035 r
.61119 .58104 m .60489 .59192 L .60284 .57261 L p F P
0 0 0 r
s
.83 .24 .1 r
.59992 .56666 m
.60392 .59107 L
s
.59738 .60239 m
.60392 .59107 L
s
.3609 .74666 m
.33873 .72857 L
s
.33873 .72857 m
.34601 .70967 L
s
.58992 .63586 m
.58223 .65834 L
s
.224 .307 .59 r
.57966 .59975 m .5605 .5969 L .56032 .61433 L p F P
0 0 0 r
s
.24 .35 .67 r
.57893 .59883 m
.57897 .57332 L
s
.224 .307 .59 r
.56032 .61433 m .57941 .61713 L .57966 .59975 L p F P
0 0 0 r
s
.24 .35 .67 r
.57893 .59883 m
.59914 .60185 L
s
.275 .396 .771 r
.47869 .45705 m .46727 .45516 L .46073 .47599 L p F P
0 0 0 r
s
.275 .396 .771 r
.44697 .47374 m .46073 .47599 L .46727 .45516 L p F P
0 0 0 r
s
.27 .386 .75 r
.46073 .47599 m .44697 .47374 L .43933 .49478 L p F P
0 0 0 r
s
.471 .137 .065 r
.59742 .52016 m .60292 .50992 L .61033 .53055 L p F P
0 0 0 r
s
.471 .137 .065 r
.61033 .53055 m .60436 .54133 L .59742 .52016 L p F P
0 0 0 r
s
.83 .24 .1 r
.59046 .5429 m
.60254 .52061 L
s
.248 .347 .671 r
.48391 .54551 m .46546 .54266 L .46392 .56312 L p F P
0 0 0 r
s
.248 .347 .671 r
.46392 .56312 m .4832 .56604 L .48391 .54551 L p F P
0 0 0 r
s
.237 .33 .635 r
.52146 .57184 m .50238 .56895 L .50243 .58825 L p F P
0 0 0 r
s
.237 .33 .635 r
.50243 .58825 m .52189 .59115 L .52146 .57184 L p F P
0 0 0 r
s
.28 .405 .79 r
.49229 .43819 m .48346 .4367 L .47869 .45705 L p F P
0 0 0 r
s
.28 .405 .79 r
.46727 .45516 m .47869 .45705 L .48346 .4367 L p F P
0 0 0 r
s
.284 .414 .807 r
.5188 .42272 m .5128 .42169 L .51865 .44264 L p F P
0 0 0 r
s
.284 .414 .807 r
.50988 .44116 m .51865 .44264 L .5128 .42169 L p F P
0 0 0 r
s
.257 .362 .701 r
.45045 .5187 m .43306 .51597 L .42827 .53692 L p F P
0 0 0 r
s
.257 .362 .701 r
.42827 .53692 m .44691 .5398 L .45045 .5187 L p F P
0 0 0 r
s
.81 .238 .105 r
.54737 .44156 m .54994 .436 L .56436 .45617 L p F P
0 0 0 r
s
.81 .238 .105 r
.5678 .44906 m .56436 .45617 L .54994 .436 L p F P
0 0 0 r
s
.24 .35 .67 r
.56175 .44463 m
.56558 .43149 L
s
.56558 .43149 m
.6034 .43798 L
s
.744 .218 .097 r
.56436 .45617 m .5678 .44906 L .58144 .46878 L p F P
0 0 0 r
s
.27 .386 .75 r
.42352 .49224 m .43933 .49478 L .44697 .47374 L p F P
0 0 0 r
s
.264 .375 .727 r
.43933 .49478 m .42352 .49224 L .41559 .51322 L p F P
0 0 0 r
s
.264 .375 .727 r
.41559 .51322 m .43306 .51597 L .43933 .49478 L p F P
0 0 0 r
s
.24 .35 .67 r
.4325 .49364 m
.47103 .49981 L
s
.87 .256 .112 r
.53079 .42478 m .5325 .42094 L .54737 .44156 L p F P
0 0 0 r
s
.87 .256 .112 r
.54994 .436 m .54737 .44156 L .5325 .42094 L p F P
0 0 0 r
s
.275 .396 .771 r
.46727 .45516 m .45583 .45326 L .44697 .47374 L p F P
0 0 0 r
s
.275 .396 .771 r
.43317 .47149 m .44697 .47374 L .45583 .45326 L p F P
0 0 0 r
s
.27 .386 .75 r
.44697 .47374 m .43317 .47149 L .42352 .49224 L p F P
0 0 0 r
s
.83 .24 .1 r
.32575 .54833 m
.33643 .52708 L
s
.284 .414 .807 r
.5128 .42169 m .50678 .42066 L .50988 .44116 L p F P
0 0 0 r
s
.284 .414 .807 r
.50109 .43968 m .50988 .44116 L .50678 .42066 L p F P
0 0 0 r
s
.28 .405 .79 r
.48346 .4367 m .47461 .4352 L .46727 .45516 L p F P
0 0 0 r
s
.24 .35 .67 r
.47601 .47136 m
.48198 .44389 L
s
.48198 .44389 m
.5203 .45032 L
s
.28 .405 .79 r
.45583 .45326 m .46727 .45516 L .47461 .4352 L p F P
0 0 0 r
s
.24 .35 .67 r
.78407 .41113 m
.77214 .4242 L
s
.77214 .4242 m
.73502 .41761 L
s
.224 .307 .59 r
.5605 .5969 m .54124 .59403 L .54112 .61151 L p F P
0 0 0 r
s
.224 .307 .59 r
.54112 .61151 m .56032 .61433 L .5605 .5969 L p F P
0 0 0 r
s
.248 .347 .671 r
.46546 .54266 m .44691 .5398 L .44455 .56018 L p F P
0 0 0 r
s
.248 .347 .671 r
.44455 .56018 m .46392 .56312 L .46546 .54266 L p F P
0 0 0 r
s
.24 .35 .67 r
.46468 .55589 m
.46721 .5283 L
s
.46468 .55589 m
.50317 .56176 L
s
.83 .24 .1 r
.41404 .76938 m
.42282 .75122 L
s
.41404 .76938 m
.38643 .7605 L
s
.24 .35 .67 r
.65658 .63272 m
.61884 .62721 L
s
.65658 .63272 m
.66129 .65187 L
s
.237 .33 .635 r
.50238 .56895 m .4832 .56604 L .48286 .58533 L p F P
0 0 0 r
s
.237 .33 .635 r
.48286 .58533 m .50243 .58825 L .50238 .56895 L p F P
0 0 0 r
s
.83 .24 .1 r
.38643 .7605 m
.3609 .74666 L
s
.3609 .74666 m
.36864 .72805 L
s
.284 .414 .807 r
.50678 .42066 m .50075 .41963 L .50109 .43968 L p F P
0 0 0 r
s
.83 .24 .1 r
.5014 .41974 m
.5031 .41566 L
s
.284 .414 .807 r
.49229 .43819 m .50109 .43968 L .50075 .41963 L p F P
0 0 0 r
s
.83 .24 .1 r
.55725 .698 m
.56887 .67842 L
s
.55725 .698 m
.53888 .71456 L
s
.257 .362 .701 r
.43306 .51597 m .41559 .51322 L .40953 .53403 L p F P
0 0 0 r
s
.257 .362 .701 r
.40953 .53403 m .42827 .53692 L .43306 .51597 L p F P
0 0 0 r
s
.24 .35 .67 r
.42857 .52226 m
.46721 .5283 L
s
.42857 .52226 m
.4325 .49364 L
s
.275 .396 .771 r
.45583 .45326 m .44434 .45135 L .43317 .47149 L p F P
0 0 0 r
s
.275 .396 .771 r
.41931 .46923 m .43317 .47149 L .44434 .45135 L p F P
0 0 0 r
s
.24 .35 .67 r
.43746 .46504 m
.47601 .47136 L
s
.27 .386 .75 r
.43317 .47149 m .41931 .46923 L .40764 .4897 L p F P
0 0 0 r
s
.27 .386 .75 r
.40764 .4897 m .42352 .49224 L .43317 .47149 L p F P
0 0 0 r
s
.24 .35 .67 r
.4325 .49364 m
.43746 .46504 L
s
.34 .098 .05 r
.60436 .54133 m .61033 .53055 L .61528 .5507 L p F P
0 0 0 r
s
.34 .098 .05 r
.61528 .5507 m .609 .56176 L .60436 .54133 L p F P
0 0 0 r
s
.264 .375 .727 r
.42352 .49224 m .40764 .4897 L .39804 .51046 L p F P
0 0 0 r
s
.264 .375 .727 r
.39804 .51046 m .41559 .51322 L .42352 .49224 L p F P
0 0 0 r
s
.24 .35 .67 r
.6596 .40422 m
.64981 .42243 L
s
.64981 .42243 m
.612 .41582 L
s
.28 .405 .79 r
.47461 .4352 m .46574 .4337 L .45583 .45326 L p F P
0 0 0 r
s
.28 .405 .79 r
.44434 .45135 m .45583 .45326 L .46574 .4337 L p F P
0 0 0 r
s
.83 .24 .1 r
.38643 .7605 m
.39468 .74214 L
s
.50547 .74552 m
.51607 .72687 L
s
.50547 .74552 m
.47963 .75287 L
s
.284 .414 .807 r
.50075 .41963 m .49471 .41859 L .49229 .43819 L p F P
0 0 0 r
s
.284 .414 .807 r
.48346 .4367 m .49229 .43819 L .49471 .41859 L p F P
0 0 0 r
s
.248 .347 .671 r
.44691 .5398 m .42827 .53692 L .42507 .55723 L p F P
0 0 0 r
s
.248 .347 .671 r
.42507 .55723 m .44455 .56018 L .44691 .5398 L p F P
0 0 0 r
s
.224 .307 .59 r
.54124 .59403 m .52189 .59115 L .52182 .60869 L p F P
0 0 0 r
s
.24 .35 .67 r
.54086 .59316 m
.54126 .56757 L
s
.224 .307 .59 r
.52182 .60869 m .54112 .61151 L .54124 .59403 L p F P
0 0 0 r
s
.24 .35 .67 r
.54086 .59316 m
.57893 .59883 L
s
.83 .24 .1 r
.32073 .57204 m
.3139 .59372 L
s
.31489 .61862 m
.3139 .59372 L
s
.28 .405 .79 r
.46574 .4337 m .45685 .4322 L .44434 .45135 L p F P
0 0 0 r
s
.28 .405 .79 r
.43282 .44943 m .44434 .45135 L .45685 .4322 L p F P
0 0 0 r
s
.275 .396 .771 r
.44434 .45135 m .43282 .44943 L .41931 .46923 L p F P
0 0 0 r
s
.275 .396 .771 r
.4054 .46696 m .41931 .46923 L .43282 .44943 L p F P
0 0 0 r
s
.27 .386 .75 r
.41931 .46923 m .4054 .46696 L .39169 .48715 L p F P
0 0 0 r
s
.27 .386 .75 r
.39169 .48715 m .40764 .4897 L .41931 .46923 L p F P
0 0 0 r
s
.237 .33 .635 r
.4832 .56604 m .46392 .56312 L .4632 .58241 L p F P
0 0 0 r
s
.237 .33 .635 r
.4632 .58241 m .48286 .58533 L .4832 .56604 L p F P
0 0 0 r
s
.284 .414 .807 r
.49471 .41859 m .48867 .41755 L .48346 .4367 L p F P
0 0 0 r
s
.284 .414 .807 r
.47461 .4352 m .48346 .4367 L .48867 .41755 L p F P
0 0 0 r
s
.744 .218 .097 r
.58572 .46027 m .58144 .46878 L .5678 .44906 L p F P
0 0 0 r
s
.667 .196 .088 r
.58144 .46878 m .58572 .46027 L .59822 .4796 L p F P
0 0 0 r
s
.667 .196 .088 r
.59822 .4796 m .59323 .4892 L .58144 .46878 L p F P
0 0 0 r
s
.83 .24 .1 r
.32791 .68796 m
.31515 .66408 L
s
.31515 .66408 m
.322 .64378 L
s
.264 .375 .727 r
.40764 .4897 m .39169 .48715 L .3804 .50769 L p F P
0 0 0 r
s
.264 .375 .727 r
.3804 .50769 m .39804 .51046 L .40764 .4897 L p F P
0 0 0 r
s
.24 .35 .67 r
.39357 .48741 m
.4325 .49364 L
s
.257 .362 .701 r
.41559 .51322 m .39804 .51046 L .3907 .53112 L p F P
0 0 0 r
s
.257 .362 .701 r
.3907 .53112 m .40953 .53403 L .41559 .51322 L p F P
0 0 0 r
s
.87 .256 .112 r
.5325 .42094 m .53422 .41707 L .54994 .436 L p F P
0 0 0 r
s
.24 .35 .67 r
.54298 .42762 m
.56558 .43149 L
s
.52738 .42494 m
.53404 .42608 L
s
.87 .256 .112 r
.55254 .4304 m .54994 .436 L .53422 .41707 L p F P
0 0 0 r
s
.81 .238 .105 r
.54994 .436 m .55254 .4304 L .5678 .44906 L p F P
0 0 0 r
s
.578 .169 .078 r
.59323 .4892 m .59822 .4796 L .60852 .4995 L p F P
0 0 0 r
s
.578 .169 .078 r
.60852 .4995 m .60292 .50992 L .59323 .4892 L p F P
0 0 0 r
s
.83 .24 .1 r
.58777 .49814 m
.60254 .52061 L
s
.206 .277 .53 r
.59841 .61991 m .57941 .61713 L .57734 .63217 L p F P
0 0 0 r
s
.206 .277 .53 r
.57734 .63217 m .59585 .63484 L .59841 .61991 L p F P
0 0 0 r
s
.83 .24 .1 r
.58992 .63586 m
.59094 .63413 L
s
.096 .028 .012 r
.59841 .61991 m .60457 .60945 L .60182 .6248 L p F P
0 0 0 r
s
.096 .028 .012 r
.60182 .6248 m .59585 .63484 L .59841 .61991 L p F P
0 0 0 r
s
.287 .421 .823 r
.5248 .42375 m .53079 .42478 L .51577 .40376 L p F P
0 0 0 r
s
.924 .272 .118 r
.5325 .42094 m .53079 .42478 L .51577 .40376 L p F P
0 0 0 r
s
.83 .24 .1 r
.5295 .42774 m
.5314 .42347 L
s
.284 .414 .807 r
.48867 .41755 m .48261 .41651 L .47461 .4352 L p F P
0 0 0 r
s
.284 .414 .807 r
.46574 .4337 m .47461 .4352 L .48261 .41651 L p F P
0 0 0 r
s
.28 .405 .79 r
.45685 .4322 m .44794 .4307 L .43282 .44943 L p F P
0 0 0 r
s
.28 .405 .79 r
.42127 .44752 m .43282 .44943 L .44794 .4307 L p F P
0 0 0 r
s
.275 .396 .771 r
.43282 .44943 m .42127 .44752 L .4054 .46696 L p F P
0 0 0 r
s
.171 .049 .025 r
.60489 .59192 m .61119 .58104 L .61085 .59877 L p F P
0 0 0 r
s
.171 .049 .025 r
.61085 .59877 m .60457 .60945 L .60489 .59192 L p F P
0 0 0 r
s
.24 .35 .67 r
.73666 .66268 m
.69917 .6573 L
s
.73666 .66268 m
.7445 .67739 L
s
.81 .238 .105 r
.57127 .44186 m .5678 .44906 L .55254 .4304 L p F P
0 0 0 r
s
.83 .24 .1 r
.54823 .45627 m
.55725 .43707 L
s
.744 .218 .097 r
.5678 .44906 m .57127 .44186 L .58572 .46027 L p F P
0 0 0 r
s
.275 .396 .771 r
.39144 .46468 m .4054 .46696 L .42127 .44752 L p F P
0 0 0 r
s
.27 .386 .75 r
.4054 .46696 m .39144 .46468 L .37567 .48458 L p F P
0 0 0 r
s
.27 .386 .75 r
.37567 .48458 m .39169 .48715 L .4054 .46696 L p F P
0 0 0 r
s
.287 .421 .823 r
.51577 .40376 m .51269 .40323 L .5248 .42375 L p F P
0 0 0 r
s
.287 .421 .823 r
.5188 .42272 m .5248 .42375 L .51269 .40323 L p F P
0 0 0 r
s
.248 .347 .671 r
.42827 .53692 m .40953 .53403 L .40549 .55427 L p F P
0 0 0 r
s
.248 .347 .671 r
.40549 .55427 m .42507 .55723 L .42827 .53692 L p F P
0 0 0 r
s
.24 .35 .67 r
.42578 .54996 m
.42857 .52226 L
s
.42578 .54996 m
.46468 .55589 L
s
.7464 .40437 m
.73502 .41761 L
s
.73502 .41761 m
.69751 .41095 L
s
.224 .307 .59 r
.52189 .59115 m .50243 .58825 L .50242 .60584 L p F P
0 0 0 r
s
.224 .307 .59 r
.50242 .60584 m .52182 .60869 L .52189 .59115 L p F P
0 0 0 r
s
.24 .35 .67 r
.58071 .62165 m
.59791 .62416 L
s
.60183 .62473 m
.61884 .62721 L
s
.61884 .62721 m
.62301 .64638 L
s
.284 .414 .807 r
.48261 .41651 m .47654 .41547 L .46574 .4337 L p F P
0 0 0 r
s
.284 .414 .807 r
.45685 .4322 m .46574 .4337 L .47654 .41547 L p F P
0 0 0 r
s
.264 .375 .727 r
.39169 .48715 m .37567 .48458 L .36269 .50491 L p F P
0 0 0 r
s
.264 .375 .727 r
.36269 .50491 m .3804 .50769 L .39169 .48715 L p F P
0 0 0 r
s
.237 .33 .635 r
.46392 .56312 m .44455 .56018 L .44343 .57946 L p F P
0 0 0 r
s
.237 .33 .635 r
.44343 .57946 m .4632 .58241 L .46392 .56312 L p F P
0 0 0 r
s
.24 .35 .67 r
.46354 .58164 m
.46468 .55589 L
s
.257 .362 .701 r
.39804 .51046 m .3804 .50769 L .37178 .5282 L p F P
0 0 0 r
s
.257 .362 .701 r
.37178 .5282 m .3907 .53112 L .39804 .51046 L p F P
0 0 0 r
s
.24 .35 .67 r
.38952 .51616 m
.42857 .52226 L
s
.287 .421 .823 r
.51269 .40323 m .50962 .40269 L .5188 .42272 L p F P
0 0 0 r
s
.287 .421 .823 r
.5128 .42169 m .5188 .42272 L .50962 .40269 L p F P
0 0 0 r
s
.28 .405 .79 r
.44794 .4307 m .439 .42919 L .42127 .44752 L p F P
0 0 0 r
s
.24 .35 .67 r
.44327 .43739 m
.48198 .44389 L
s
.28 .405 .79 r
.40968 .44559 m .42127 .44752 L .439 .42919 L p F P
0 0 0 r
s
.83 .24 .1 r
.4118 .43858 m
.42731 .43573 L
s
.24 .35 .67 r
.43746 .46504 m
.44327 .43739 L
s
.275 .396 .771 r
.42127 .44752 m .40968 .44559 L .39144 .46468 L p F P
0 0 0 r
s
.83 .24 .1 r
.4091 .44619 m
.4118 .43858 L
s
.24 .35 .67 r
.38952 .51616 m
.39357 .48741 L
s
.471 .137 .065 r
.60292 .50992 m .60852 .4995 L .61641 .51957 L p F P
0 0 0 r
s
.471 .137 .065 r
.61641 .51957 m .61033 .53055 L .60292 .50992 L p F P
0 0 0 r
s
.83 .24 .1 r
.52127 .42001 m
.5314 .42347 L
s
.5314 .42347 m
.55725 .43707 L
s
.24 .35 .67 r
.62129 .39742 m
.612 .41582 L
s
.612 .41582 m
.57379 .40915 L
s
.287 .421 .823 r
.50962 .40269 m .50654 .40216 L .5128 .42169 L p F P
0 0 0 r
s
.287 .421 .823 r
.50678 .42066 m .5128 .42169 L .50654 .40216 L p F P
0 0 0 r
s
.275 .396 .771 r
.37743 .4624 m .39144 .46468 L .40968 .44559 L p F P
0 0 0 r
s
.24 .35 .67 r
.39357 .48741 m
.3985 .45864 L
s
.3985 .45864 m
.43746 .46504 L
s
.83 .24 .1 r
.3798 .47208 m
.38278 .46327 L
s
.27 .386 .75 r
.39144 .46468 m .37743 .4624 L .35959 .482 L p F P
0 0 0 r
s
.27 .386 .75 r
.35959 .482 m .37567 .48458 L .39144 .46468 L p F P
0 0 0 r
s
.83 .24 .1 r
.3596 .48613 m
.36442 .48278 L
s
.284 .414 .807 r
.47654 .41547 m .47046 .41443 L .45685 .4322 L p F P
0 0 0 r
s
.83 .24 .1 r
.47314 .41489 m
.47477 .41078 L
s
.284 .414 .807 r
.44794 .4307 m .45685 .4322 L .47046 .41443 L p F P
0 0 0 r
s
.206 .277 .53 r
.57941 .61713 m .56032 .61433 L .55874 .62948 L p F P
0 0 0 r
s
.206 .277 .53 r
.55874 .62948 m .57734 .63217 L .57941 .61713 L p F P
0 0 0 r
s
.24 .35 .67 r
.57893 .59883 m
.58071 .62165 L
s
.231 .067 .035 r
.609 .56176 m .61528 .5507 L .61762 .56995 L p F P
0 0 0 r
s
.231 .067 .035 r
.61762 .56995 m .61119 .58104 L .609 .56176 L p F P
0 0 0 r
s
.924 .272 .118 r
.51577 .40376 m .51662 .40176 L .5325 .42094 L p F P
0 0 0 r
s
.924 .272 .118 r
.53422 .41707 m .5325 .42094 L .51662 .40176 L p F P
0 0 0 r
s
.24 .35 .67 r
.52738 .42494 m
.53022 .41673 L
s
.287 .421 .823 r
.50654 .40216 m .50347 .40162 L .50678 .42066 L p F P
0 0 0 r
s
.287 .421 .823 r
.50075 .41963 m .50678 .42066 L .50347 .40162 L p F P
0 0 0 r
s
.248 .347 .671 r
.40953 .53403 m .3907 .53112 L .3858 .55128 L p F P
0 0 0 r
s
.248 .347 .671 r
.3858 .55128 m .40549 .55427 L .40953 .53403 L p F P
0 0 0 r
s
.28 .405 .79 r
.439 .42919 m .43005 .42767 L .40968 .44559 L p F P
0 0 0 r
s
.28 .405 .79 r
.39805 .44366 m .40968 .44559 L .43005 .42767 L p F P
0 0 0 r
s
.275 .396 .771 r
.40968 .44559 m .39805 .44366 L .37743 .4624 L p F P
0 0 0 r
s
.264 .375 .727 r
.37567 .48458 m .35959 .482 L .34489 .50211 L p F P
0 0 0 r
s
.264 .375 .727 r
.34489 .50211 m .36269 .50491 L .37567 .48458 L p F P
0 0 0 r
s
.224 .307 .59 r
.50243 .58825 m .48286 .58533 L .48292 .60299 L p F P
0 0 0 r
s
.24 .35 .67 r
.5024 .58743 m
.50317 .56176 L
s
.224 .307 .59 r
.48292 .60299 m .50242 .60584 L .50243 .58825 L p F P
0 0 0 r
s
.24 .35 .67 r
.5024 .58743 m
.54086 .59316 L
s
.284 .414 .807 r
.47046 .41443 m .46438 .41338 L .44794 .4307 L p F P
0 0 0 r
s
.284 .414 .807 r
.439 .42919 m .44794 .4307 L .46438 .41338 L p F P
0 0 0 r
s
.257 .362 .701 r
.3804 .50769 m .36269 .50491 L .35276 .52527 L p F P
0 0 0 r
s
.257 .362 .701 r
.35276 .52527 m .37178 .5282 L .3804 .50769 L p F P
0 0 0 r
s
.87 .256 .112 r
.53422 .41707 m .53595 .41318 L .55254 .4304 L p F P
0 0 0 r
s
.87 .256 .112 r
.55516 .42475 m .55254 .4304 L .53595 .41318 L p F P
0 0 0 r
s
.81 .238 .105 r
.55254 .4304 m .55516 .42475 L .57127 .44186 L p F P
0 0 0 r
s
.237 .33 .635 r
.44455 .56018 m .42507 .55723 L .42355 .5765 L p F P
0 0 0 r
s
.237 .33 .635 r
.42355 .5765 m .44343 .57946 L .44455 .56018 L p F P
0 0 0 r
s
.287 .421 .823 r
.50347 .40162 m .50038 .40108 L .50075 .41963 L p F P
0 0 0 r
s
.287 .421 .823 r
.49471 .41859 m .50075 .41963 L .50038 .40108 L p F P
0 0 0 r
s
1 .336 .137 r
.36273 .47229 m .35959 .482 L .37743 .4624 L p F P
0 0 0 r
s
1 .336 .137 r
.37743 .4624 m .38029 .45379 L .36273 .47229 L p F P
0 0 0 r
s
1 .338 .139 r
.38029 .45379 m .37743 .4624 L .39805 .44366 L p F P
0 0 0 r
s
.24 .35 .67 r
.35914 .45218 m
.37876 .4554 L
s
.38353 .45619 m
.3985 .45864 L
s
.83 .24 .1 r
.58223 .65834 m
.56887 .67842 L
s
.287 .421 .823 r
.50038 .40108 m .4973 .40055 L .49471 .41859 L p F P
0 0 0 r
s
.287 .421 .823 r
.48867 .41755 m .49471 .41859 L .4973 .40055 L p F P
0 0 0 r
s
.24 .35 .67 r
.48877 .41832 m
.52738 .42494 L
s
.48198 .44389 m
.48877 .41832 L
s
.284 .414 .807 r
.46438 .41338 m .45828 .41234 L .439 .42919 L p F P
0 0 0 r
s
.284 .414 .807 r
.43005 .42767 m .439 .42919 L .45828 .41234 L p F P
0 0 0 r
s
1 .338 .139 r
.39805 .44366 m .40055 .4364 L .38029 .45379 L p F P
0 0 0 r
s
1 .333 .138 r
.40055 .4364 m .39805 .44366 L .42107 .42616 L p F P
0 0 0 r
s
.28 .405 .79 r
.43005 .42767 m .42107 .42616 L .39805 .44366 L p F P
0 0 0 r
s
.24 .35 .67 r
.41204 .43214 m
.44327 .43739 L
s
.3985 .45864 m
.40252 .43881 L
s
.206 .277 .53 r
.56032 .61433 m .54112 .61151 L .54004 .62678 L p F P
0 0 0 r
s
.206 .277 .53 r
.54004 .62678 m .55874 .62948 L .56032 .61433 L p F P
0 0 0 r
s
1 .323 .129 r
.34823 .49155 m .34489 .50211 L .35959 .482 L p F P
0 0 0 r
s
1 .323 .129 r
.35959 .482 m .36273 .47229 L .34823 .49155 L p F P
0 0 0 r
s
.24 .35 .67 r
.35926 .48191 m
.39357 .48741 L
s
.35423 .4811 m
.35589 .48137 L
s
.83 .24 .1 r
.47963 .75287 m
.4898 .73421 L
s
.47963 .75287 m
.45162 .75484 L
s
.287 .421 .823 r
.4973 .40055 m .49421 .40001 L .48867 .41755 L p F P
0 0 0 r
s
.287 .421 .823 r
.48261 .41651 m .48867 .41755 L .49421 .40001 L p F P
0 0 0 r
s
.24 .35 .67 r
.69917 .6573 m
.66129 .65187 L
s
.69917 .6573 m
.70642 .672 L
s
.248 .347 .671 r
.3907 .53112 m .37178 .5282 L .36602 .54829 L p F P
0 0 0 r
s
.248 .347 .671 r
.36602 .54829 m .3858 .55128 L .3907 .53112 L p F P
0 0 0 r
s
.24 .35 .67 r
.38648 .54397 m
.38952 .51616 L
s
.38648 .54397 m
.42578 .54996 L
s
.924 .272 .118 r
.51662 .40176 m .51747 .39976 L .53422 .41707 L p F P
0 0 0 r
s
.924 .272 .118 r
.53595 .41318 m .53422 .41707 L .51747 .39976 L p F P
0 0 0 r
s
.744 .218 .097 r
.59005 .45163 m .58572 .46027 L .57127 .44186 L p F P
0 0 0 r
s
.83 .24 .1 r
.56867 .47804 m
.5804 .45435 L
s
.667 .196 .088 r
.58572 .46027 m .59005 .45163 L .60329 .46985 L p F P
0 0 0 r
s
.667 .196 .088 r
.60329 .46985 m .59822 .4796 L .58572 .46027 L p F P
0 0 0 r
s
.284 .414 .807 r
.45828 .41234 m .45217 .41129 L .43005 .42767 L p F P
0 0 0 r
s
.284 .414 .807 r
.42107 .42616 m .43005 .42767 L .45217 .41129 L p F P
0 0 0 r
s
.24 .35 .67 r
.70833 .39753 m
.69751 .41095 L
s
.69751 .41095 m
.6596 .40422 L
s
.257 .362 .701 r
.36269 .50491 m .34489 .50211 L .33364 .52232 L p F P
0 0 0 r
s
.83 .24 .1 r
.33643 .52708 m
.33894 .51914 L
s
.257 .362 .701 r
.33364 .52232 m .35276 .52527 L .36269 .50491 L p F P
0 0 0 r
s
.24 .35 .67 r
.35006 .51 m
.38952 .51616 L
s
.224 .307 .59 r
.48286 .58533 m .4632 .58241 L .46331 .60011 L p F P
0 0 0 r
s
.224 .307 .59 r
.46331 .60011 m .48292 .60299 L .48286 .58533 L p F P
0 0 0 r
s
.24 .35 .67 r
.46354 .58164 m
.5024 .58743 L
s
.34 .098 .05 r
.61033 .53055 m .61641 .51957 L .62168 .53942 L p F P
0 0 0 r
s
.34 .098 .05 r
.62168 .53942 m .61528 .5507 L .61033 .53055 L p F P
0 0 0 r
s
.83 .24 .1 r
.60254 .52061 m
.6123 .54463 L
s
.59992 .56666 m
.6123 .54463 L
s
.81 .238 .105 r
.57479 .43458 m .57127 .44186 L .55516 .42475 L p F P
0 0 0 r
s
.24 .35 .67 r
.56606 .43021 m
.57379 .40915 L
s
.744 .218 .097 r
.57127 .44186 m .57479 .43458 L .59005 .45163 L p F P
0 0 0 r
s
.83 .24 .1 r
.55725 .43707 m
.5804 .45435 L
s
.24 .35 .67 r
.54218 .61602 m
.58071 .62165 L
s
.287 .421 .823 r
.49421 .40001 m .49112 .39947 L .48261 .41651 L p F P
0 0 0 r
s
.287 .421 .823 r
.47654 .41547 m .48261 .41651 L .49112 .39947 L p F P
0 0 0 r
s
.237 .33 .635 r
.42507 .55723 m .40549 .55427 L .40357 .57353 L p F P
0 0 0 r
s
.237 .33 .635 r
.40357 .57353 m .42355 .5765 L .42507 .55723 L p F P
0 0 0 r
s
.24 .35 .67 r
.42427 .57579 m
.42578 .54996 L
s
.83 .24 .1 r
.34601 .70967 m
.32791 .68796 L
s
.32791 .68796 m
.33507 .66798 L
s
.24 .35 .67 r
.35423 .4811 m
.35914 .45218 L
s
.31448 .47474 m
.35423 .4811 L
s
.35006 .51 m
.35287 .49055 L
s
.35379 .48416 m
.35423 .4811 L
s
.284 .414 .807 r
.45217 .41129 m .44605 .41024 L .42107 .42616 L p F P
0 0 0 r
s
1 .333 .138 r
.42107 .42616 m .42311 .42047 L .40055 .4364 L p F P
0 0 0 r
s
.24 .35 .67 r
.40343 .43437 m
.40415 .43082 L
s
.40415 .43082 m
.40763 .4314 L
s
1 .324 .136 r
.42311 .42047 m .42107 .42616 L .44605 .41024 L p F P
0 0 0 r
s
.287 .421 .823 r
.49112 .39947 m .48803 .39893 L .47654 .41547 L p F P
0 0 0 r
s
.287 .421 .823 r
.47046 .41443 m .47654 .41547 L .48803 .39893 L p F P
0 0 0 r
s
.83 .24 .1 r
.47541 .40915 m
.47628 .4093 L
s
.47486 .41055 m
.47541 .40915 L
s
.53888 .71456 m
.55026 .69509 L
s
.53888 .71456 m
.51607 .72687 L
s
.578 .169 .078 r
.59822 .4796 m .60329 .46985 L .61422 .48889 L p F P
0 0 0 r
s
.83 .24 .1 r
.5804 .45435 m
.59994 .47471 L
s
.578 .169 .078 r
.61422 .48889 m .60852 .4995 L .59822 .4796 L p F P
0 0 0 r
s
.83 .24 .1 r
.58777 .49814 m
.59994 .47471 L
s
.206 .277 .53 r
.54112 .61151 m .52182 .60869 L .52124 .62407 L p F P
0 0 0 r
s
.206 .277 .53 r
.52124 .62407 m .54004 .62678 L .54112 .61151 L p F P
0 0 0 r
s
.24 .35 .67 r
.54086 .59316 m
.54218 .61602 L
s
.287 .421 .823 r
.48803 .39893 m .48494 .39839 L .47046 .41443 L p F P
0 0 0 r
s
.287 .421 .823 r
.46438 .41338 m .47046 .41443 L .48494 .39839 L p F P
0 0 0 r
s
.248 .347 .671 r
.37178 .5282 m .35276 .52527 L .34612 .54527 L p F P
0 0 0 r
s
.248 .347 .671 r
.34612 .54527 m .36602 .54829 L .37178 .5282 L p F P
0 0 0 r
s
.87 .256 .112 r
.53595 .41318 m .53769 .40926 L .55516 .42475 L p F P
0 0 0 r
s
.87 .256 .112 r
.55781 .41904 m .55516 .42475 L .53769 .40926 L p F P
0 0 0 r
s
.81 .238 .105 r
.55516 .42475 m .55781 .41904 L .57479 .43458 L p F P
0 0 0 r
s
.24 .35 .67 r
.36461 .42418 m
.35914 .45218 L
s
.35914 .45218 m
.31936 .44566 L
s
.997 .292 .115 r
.33713 .51118 m .33364 .52232 L .34489 .50211 L p F P
0 0 0 r
s
.997 .292 .115 r
.34489 .50211 m .34823 .49155 L .33713 .51118 L p F P
0 0 0 r
s
.83 .24 .1 r
.34368 .50418 m
.35443 .49199 L
s
.34202 .50941 m
.34368 .50418 L
s
.287 .421 .823 r
.48494 .39839 m .48184 .39786 L .46438 .41338 L p F P
0 0 0 r
s
.287 .421 .823 r
.45828 .41234 m .46438 .41338 L .48184 .39786 L p F P
0 0 0 r
s
.224 .307 .59 r
.4632 .58241 m .44343 .57946 L .4436 .59723 L p F P
0 0 0 r
s
.224 .307 .59 r
.4436 .59723 m .46331 .60011 L .4632 .58241 L p F P
0 0 0 r
s
.924 .272 .118 r
.51747 .39976 m .51832 .39775 L .53595 .41318 L p F P
0 0 0 r
s
.924 .272 .118 r
.53769 .40926 m .53595 .41318 L .51832 .39775 L p F P
0 0 0 r
s
.237 .33 .635 r
.40549 .55427 m .3858 .55128 L .38348 .57054 L p F P
0 0 0 r
s
.237 .33 .635 r
.38348 .57054 m .40357 .57353 L .40549 .55427 L p F P
0 0 0 r
s
.83 .24 .1 r
.322 .64378 m
.31489 .61862 L
s
.31489 .61862 m
.32181 .5972 L
s
.096 .028 .012 r
.60457 .60945 m .61085 .59877 L .60791 .61456 L p F P
0 0 0 r
s
.096 .028 .012 r
.60791 .61456 m .60182 .6248 L .60457 .60945 L p F P
0 0 0 r
s
.83 .24 .1 r
.60214 .61514 m
.60392 .59107 L
s
.59658 .62456 m
.60214 .61514 L
s
.24 .35 .67 r
.34112 .5086 m
.35006 .51 L
s
.31019 .50376 m
.33879 .50823 L
s
.287 .421 .823 r
.48184 .39786 m .47874 .39732 L .45828 .41234 L p F P
0 0 0 r
s
.287 .421 .823 r
.45217 .41129 m .45828 .41234 L .47874 .39732 L p F P
0 0 0 r
s
.24 .35 .67 r
.44976 .41163 m
.48877 .41832 L
s
.171 .049 .025 r
.61119 .58104 m .61762 .56995 L .61726 .58789 L p F P
0 0 0 r
s
.171 .049 .025 r
.61726 .58789 m .61085 .59877 L .61119 .58104 L p F P
0 0 0 r
s
.206 .277 .53 r
.52182 .60869 m .50242 .60584 L .50236 .62134 L p F P
0 0 0 r
s
.206 .277 .53 r
.50236 .62134 m .52124 .62407 L .52182 .60869 L p F P
0 0 0 r
s
.287 .421 .823 r
.47874 .39732 m .47564 .39678 L .45217 .41129 L p F P
0 0 0 r
s
.287 .421 .823 r
.44605 .41024 m .45217 .41129 L .47564 .39678 L p F P
0 0 0 r
s
1 .338 .139 r
.3832 .44506 m .38029 .45379 L .40055 .4364 L p F P
0 0 0 r
s
.83 .24 .1 r
.38477 .45739 m
.38788 .44816 L
s
1 .338 .139 r
.40055 .4364 m .40309 .42906 L .3832 .44506 L p F P
0 0 0 r
s
.83 .24 .1 r
.38788 .44816 m
.405 .4413 L
s
.24 .35 .67 r
.40257 .43055 m
.40415 .43082 L
s
1 .333 .138 r
.40309 .42906 m .40055 .4364 L .42311 .42047 L p F P
0 0 0 r
s
.24 .35 .67 r
.36461 .42418 m
.40146 .43037 L
s
.471 .137 .065 r
.60852 .4995 m .61422 .48889 L .6226 .50838 L p F P
0 0 0 r
s
.471 .137 .065 r
.6226 .50838 m .61641 .51957 L .60852 .4995 L p F P
0 0 0 r
s
.248 .347 .671 r
.35276 .52527 m .33364 .52232 L .32613 .54224 L p F P
0 0 0 r
s
.248 .347 .671 r
.32613 .54224 m .34612 .54527 L .35276 .52527 L p F P
0 0 0 r
s
.83 .24 .1 r
.32575 .54833 m
.32758 .54246 L
s
.24 .35 .67 r
.34676 .53791 m
.35006 .51 L
s
.34676 .53791 m
.38648 .54397 L
s
.66129 .65187 m
.62301 .64638 L
s
.66129 .65187 m
.66793 .66656 L
s
.18 .237 .449 r
.59585 .63484 m .57734 .63217 L .57341 .6445 L p F P
0 0 0 r
s
.18 .237 .449 r
.57341 .6445 m .59099 .64701 L .59585 .63484 L p F P
0 0 0 r
s
.83 .24 .1 r
.58223 .65834 m
.58913 .64674 L
s
.24 .35 .67 r
.58071 .62165 m
.58432 .64083 L
s
.083 .024 .01 r
.59585 .63484 m .60182 .6248 L .59661 .63758 L p F P
0 0 0 r
s
.083 .024 .01 r
.59661 .63758 m .59099 .64701 L .59585 .63484 L p F P
0 0 0 r
s
.83 .24 .1 r
.59165 .64251 m
.59444 .63782 L
s
1 .336 .137 r
.36593 .46242 m .36273 .47229 L .38029 .45379 L p F P
0 0 0 r
s
1 .336 .137 r
.38029 .45379 m .3832 .44506 L .36593 .46242 L p F P
0 0 0 r
s
.288 .426 .836 r
.51269 .40323 m .51577 .40376 L .5 .38446 L closepath p F P
0 0 0 r
s
.973 .287 .123 r
.51662 .40176 m .51577 .40376 L .5 .38446 L closepath p F P
0 0 0 r
s
.287 .421 .823 r
.47564 .39678 m .47253 .39623 L .44605 .41024 L p F P
0 0 0 r
s
1 .324 .136 r
.44605 .41024 m .44752 .4063 L .42311 .42047 L p F P
0 0 0 r
s
.24 .35 .67 r
.44327 .43739 m
.44976 .41163 L
s
1 .313 .132 r
.44752 .4063 m .44605 .41024 L .47253 .39623 L p F P
0 0 0 r
s
.24 .35 .67 r
.66985 .39061 m
.6596 .40422 L
s
.6596 .40422 m
.62129 .39742 L
s
.224 .307 .59 r
.44343 .57946 m .42355 .5765 L .42379 .59432 L p F P
0 0 0 r
s
.224 .307 .59 r
.42379 .59432 m .4436 .59723 L .44343 .57946 L p F P
0 0 0 r
s
.24 .35 .67 r
.42427 .57579 m
.46354 .58164 L
s
.83 .24 .1 r
.45162 .75484 m
.4613 .7361 L
s
.45162 .75484 m
.42282 .75122 L
s
.24 .35 .67 r
.50324 .61034 m
.54218 .61602 L
s
1 .333 .138 r
.42311 .42047 m .42517 .41472 L .40309 .42906 L p F P
0 0 0 r
s
1 .324 .136 r
.42517 .41472 m .42311 .42047 L .44752 .4063 L p F P
0 0 0 r
s
.24 .35 .67 r
.44294 .41046 m
.44976 .41163 L
s
.83 .24 .1 r
.44733 .40902 m
.45767 .40907 L
s
.44569 .41339 m
.44733 .40902 L
s
.288 .426 .836 r
.50962 .40269 m .51269 .40323 L .5 .38446 L closepath p F P
0 0 0 r
s
.237 .33 .635 r
.3858 .55128 m .36602 .54829 L .36329 .56753 L p F P
0 0 0 r
s
.237 .33 .635 r
.36329 .56753 m .38348 .57054 L .3858 .55128 L p F P
0 0 0 r
s
.24 .35 .67 r
.38458 .56987 m
.38648 .54397 L
s
.79628 .40341 m
.78407 .41113 L
s
.78407 .41113 m
.7464 .40437 L
s
.924 .272 .118 r
.51832 .39775 m .51918 .39573 L .53769 .40926 L p F P
0 0 0 r
s
.924 .272 .118 r
.53944 .40532 m .53769 .40926 L .51918 .39573 L p F P
0 0 0 r
s
.24 .35 .67 r
.53491 .40318 m
.53518 .4024 L
s
.87 .256 .112 r
.53769 .40926 m .53944 .40532 L .55781 .41904 L p F P
0 0 0 r
s
.24 .35 .67 r
.53518 .4024 m
.57379 .40915 L
s
.81 .238 .105 r
.57835 .42722 m .57479 .43458 L .55781 .41904 L p F P
0 0 0 r
s
.744 .218 .097 r
.57479 .43458 m .57835 .42722 L .59445 .44287 L p F P
0 0 0 r
s
.744 .218 .097 r
.59445 .44287 m .59005 .45163 L .57479 .43458 L p F P
0 0 0 r
s
.288 .426 .836 r
.50654 .40216 m .50962 .40269 L .5 .38446 L closepath p F P
0 0 0 r
s
.231 .067 .035 r
.61528 .5507 m .62168 .53942 L .62418 .55863 L p F P
0 0 0 r
s
.231 .067 .035 r
.62418 .55863 m .61762 .56995 L .61528 .5507 L p F P
0 0 0 r
s
.83 .24 .1 r
.6123 .54463 m
.61651 .56929 L
s
.24 .35 .67 r
.31936 .44566 m
.31448 .47474 L
s
.31448 .47474 m
.27431 .4683 L
s
.31448 .47474 m
.31019 .50376 L
s
.83 .24 .1 r
.36864 .72805 m
.34601 .70967 L
s
.34601 .70967 m
.35358 .69 L
s
.288 .426 .836 r
.50347 .40162 m .50654 .40216 L .5 .38446 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.53214 .40187 m
.53518 .4024 L
s
.87 .256 .112 r
.56048 .41329 m .55781 .41904 L .53944 .40532 L p F P
0 0 0 r
s
.81 .238 .105 r
.55781 .41904 m .56048 .41329 L .57835 .42722 L p F P
0 0 0 r
s
.973 .287 .123 r
.51747 .39976 m .51662 .40176 L .5 .38446 L closepath p F P
0 0 0 r
s
.206 .277 .53 r
.50242 .60584 m .48292 .60299 L .48337 .6186 L p F P
0 0 0 r
s
.206 .277 .53 r
.48337 .6186 m .50236 .62134 L .50242 .60584 L p F P
0 0 0 r
s
.24 .35 .67 r
.5024 .58743 m
.50324 .61034 L
s
.288 .426 .836 r
.50038 .40108 m .50347 .40162 L .5 .38446 L closepath p F P
0 0 0 r
s
.667 .196 .088 r
.59005 .45163 m .59445 .44287 L .60845 .45994 L p F P
0 0 0 r
s
.667 .196 .088 r
.60845 .45994 m .60329 .46985 L .59005 .45163 L p F P
0 0 0 r
s
.822 .24 .091 r
.3297 .53079 m .32613 .54224 L .33364 .52232 L p F P
0 0 0 r
s
.822 .24 .091 r
.33364 .52232 m .33713 .51118 L .3297 .53079 L p F P
0 0 0 r
s
.288 .426 .836 r
.4973 .40055 m .50038 .40108 L .5 .38446 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.37049 .39803 m
.36461 .42418 L
s
.36461 .42418 m
.32466 .41747 L
s
1 .323 .129 r
.35164 .4808 m .34823 .49155 L .36273 .47229 L p F P
0 0 0 r
s
1 .323 .129 r
.36273 .47229 m .36593 .46242 L .35164 .4808 L p F P
0 0 0 r
s
.24 .35 .67 r
.32466 .41747 m
.31936 .44566 L
s
.31936 .44566 m
.27916 .43906 L
s
.18 .237 .449 r
.57734 .63217 m .55874 .62948 L .55574 .64198 L p F P
0 0 0 r
s
.18 .237 .449 r
.55574 .64198 m .57341 .6445 L .57734 .63217 L p F P
0 0 0 r
s
.288 .426 .836 r
.49421 .40001 m .4973 .40055 L .5 .38446 L closepath p F P
0 0 0 r
s
.224 .307 .59 r
.42355 .5765 m .40357 .57353 L .40387 .5914 L p F P
0 0 0 r
s
.224 .307 .59 r
.40387 .5914 m .42379 .59432 L .42355 .5765 L p F P
0 0 0 r
s
.288 .426 .836 r
.49112 .39947 m .49421 .40001 L .5 .38446 L closepath p F P
0 0 0 r
s
.973 .287 .123 r
.51832 .39775 m .51747 .39976 L .5 .38446 L closepath p F P
0 0 0 r
s
1 .324 .136 r
.44752 .4063 m .449 .40235 L .42517 .41472 L p F P
0 0 0 r
s
1 .313 .132 r
.449 .40235 m .44752 .4063 L .47332 .39421 L p F P
0 0 0 r
s
1 .313 .132 r
.47253 .39623 m .47332 .39421 L .44752 .4063 L p F P
0 0 0 r
s
.24 .35 .67 r
.44976 .41163 m
.45229 .40327 L
s
.237 .33 .635 r
.36602 .54829 m .34612 .54527 L .34298 .56451 L p F P
0 0 0 r
s
.237 .33 .635 r
.34298 .56451 m .36329 .56753 L .36602 .54829 L p F P
0 0 0 r
s
.288 .426 .836 r
.48803 .39893 m .49112 .39947 L .5 .38446 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.31019 .50376 m
.2699 .49747 L
s
.31019 .50376 m
.30663 .53179 L
s
.288 .426 .836 r
.48494 .39839 m .48803 .39893 L .5 .38446 L closepath p F P
0 0 0 r
s
.924 .272 .118 r
.51918 .39573 m .52004 .39371 L .53944 .40532 L p F P
0 0 0 r
s
.924 .272 .118 r
.5412 .40136 m .53944 .40532 L .52004 .39371 L p F P
0 0 0 r
s
.87 .256 .112 r
.53944 .40532 m .5412 .40136 L .56048 .41329 L p F P
0 0 0 r
s
.288 .426 .836 r
.48184 .39786 m .48494 .39839 L .5 .38446 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.42282 .75122 m
.43196 .73233 L
s
.42282 .75122 m
.39468 .74214 L
s
.578 .169 .078 r
.60329 .46985 m .60845 .45994 L .62003 .47809 L p F P
0 0 0 r
s
.578 .169 .078 r
.62003 .47809 m .61422 .48889 L .60329 .46985 L p F P
0 0 0 r
s
.206 .277 .53 r
.48292 .60299 m .46331 .60011 L .46429 .61584 L p F P
0 0 0 r
s
.206 .277 .53 r
.46429 .61584 m .48337 .6186 L .48292 .60299 L p F P
0 0 0 r
s
.34 .098 .05 r
.61641 .51957 m .6226 .50838 L .62821 .52791 L p F P
0 0 0 r
s
.34 .098 .05 r
.62821 .52791 m .62168 .53942 L .61641 .51957 L p F P
0 0 0 r
s
.24 .35 .67 r
.32876 .53516 m
.34676 .53791 L
s
.288 .426 .836 r
.47874 .39732 m .48184 .39786 L .5 .38446 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.39468 .74214 m
.36864 .72805 L
s
.36864 .72805 m
.37669 .70869 L
s
.973 .287 .123 r
.51918 .39573 m .51832 .39775 L .5 .38446 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.58432 .64083 m
.59307 .64209 L
s
.59385 .6422 m
.62301 .64638 L
s
.62301 .64638 m
.62902 .66105 L
s
1 .333 .138 r
.40565 .42162 m .40309 .42906 L .42517 .41472 L p F P
0 0 0 r
s
1 .333 .138 r
.42517 .41472 m .42724 .40893 L .40565 .42162 L p F P
0 0 0 r
s
.24 .35 .67 r
.40645 .42115 m
.41033 .40486 L
s
1 .324 .136 r
.42724 .40893 m .42517 .41472 L .449 .40235 L p F P
0 0 0 r
s
.24 .35 .67 r
.41033 .40486 m
.4297 .40818 L
s
.83 .24 .1 r
.56887 .67842 m
.58095 .65806 L
s
.56887 .67842 m
.55026 .69509 L
s
.288 .426 .836 r
.47564 .39678 m .47874 .39732 L .5 .38446 L closepath p F P
0 0 0 r
s
.18 .237 .449 r
.55874 .62948 m .54004 .62678 L .53799 .63945 L p F P
0 0 0 r
s
.18 .237 .449 r
.53799 .63945 m .55574 .64198 L .55874 .62948 L p F P
0 0 0 r
s
.24 .35 .67 r
.54218 .61602 m
.54522 .63523 L
s
1 .338 .139 r
.38615 .43621 m .3832 .44506 L .40309 .42906 L p F P
0 0 0 r
s
1 .338 .139 r
.40309 .42906 m .40565 .42162 L .38615 .43621 L p F P
0 0 0 r
s
.24 .35 .67 r
.63095 .38363 m
.62129 .39742 L
s
.62129 .39742 m
.58258 .39055 L
s
.288 .426 .836 r
.47253 .39623 m .47564 .39678 L .5 .38446 L closepath p F P
0 0 0 r
s
.224 .307 .59 r
.40357 .57353 m .38348 .57054 L .38385 .58847 L p F P
0 0 0 r
s
.224 .307 .59 r
.38385 .58847 m .40387 .5914 L .40357 .57353 L p F P
0 0 0 r
s
.24 .35 .67 r
.38458 .56987 m
.42427 .57579 L
s
.83 .24 .1 r
.39468 .74214 m
.40327 .72305 L
s
.237 .33 .635 r
.34612 .54527 m .32613 .54224 L .32256 .56147 L p F P
0 0 0 r
s
.237 .33 .635 r
.32256 .56147 m .34298 .56451 L .34612 .54527 L p F P
0 0 0 r
s
.83 .24 .1 r
.32073 .57204 m
.32296 .56152 L
s
.24 .35 .67 r
.34447 .56389 m
.34676 .53791 L
s
1 .3 .128 r
.5 .38446 m .47332 .39421 L .47253 .39623 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.48877 .41832 m
.49616 .39558 L
s
.83 .24 .1 r
.51607 .72687 m
.5271 .70746 L
s
.51607 .72687 m
.4898 .73421 L
s
.24 .35 .67 r
.758 .39647 m
.7464 .40437 L
s
.7464 .40437 m
.70833 .39753 L
s
.7445 .67739 m
.70642 .672 L
s
.7445 .67739 m
.75422 .68689 L
s
.87 .256 .112 r
.56317 .40748 m .56048 .41329 L .5412 .40136 L p F P
0 0 0 r
s
.81 .238 .105 r
.56048 .41329 m .56317 .40748 L .58194 .41976 L p F P
0 0 0 r
s
.81 .238 .105 r
.58194 .41976 m .57835 .42722 L .56048 .41329 L p F P
0 0 0 r
s
.997 .292 .115 r
.34068 .49983 m .33713 .51118 L .34823 .49155 L p F P
0 0 0 r
s
.997 .292 .115 r
.34823 .49155 m .35164 .4808 L .34068 .49983 L p F P
0 0 0 r
s
1 .324 .136 r
.449 .40235 m .45049 .39836 L .42724 .40893 L p F P
0 0 0 r
s
1 .313 .132 r
.45049 .39836 m .449 .40235 L .47411 .39218 L p F P
0 0 0 r
s
.24 .35 .67 r
.45298 .40102 m
.45307 .4007 L
s
1 .313 .132 r
.47332 .39421 m .47411 .39218 L .449 .40235 L p F P
0 0 0 r
s
.973 .287 .123 r
.52004 .39371 m .51918 .39573 L .5 .38446 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.49616 .39558 m
.51957 .39967 L
s
.27916 .43906 m
.27431 .4683 L
s
.27431 .4683 m
.23371 .4618 L
s
.27431 .4683 m
.2699 .49747 L
s
.744 .218 .097 r
.57835 .42722 m .58194 .41976 L .59891 .43398 L p F P
0 0 0 r
s
.744 .218 .097 r
.59891 .43398 m .59445 .44287 L .57835 .42722 L p F P
0 0 0 r
s
.206 .277 .53 r
.46331 .60011 m .4436 .59723 L .4451 .61307 L p F P
0 0 0 r
s
.206 .277 .53 r
.4451 .61307 m .46429 .61584 L .46331 .60011 L p F P
0 0 0 r
s
.24 .35 .67 r
.46388 .6046 m
.50324 .61034 L
s
.46354 .58164 m
.46388 .6046 L
s
.83 .24 .1 r
.32181 .5972 m
.32073 .57204 L
s
.924 .272 .118 r
.52004 .39371 m .52091 .39168 L .5412 .40136 L p F P
0 0 0 r
s
.924 .272 .118 r
.54297 .39737 m .5412 .40136 L .52091 .39168 L p F P
0 0 0 r
s
.87 .256 .112 r
.5412 .40136 m .54297 .39737 L .56317 .40748 L p F P
0 0 0 r
s
.83 .24 .1 r
.5314 .42347 m
.54257 .39834 L
s
1 .336 .137 r
.36917 .45239 m .36593 .46242 L .3832 .44506 L p F P
0 0 0 r
s
1 .336 .137 r
.3832 .44506 m .38615 .43621 L .36917 .45239 L p F P
0 0 0 r
s
.83 .24 .1 r
.33507 .66798 m
.322 .64378 L
s
.322 .64378 m
.32914 .62267 L
s
1 .3 .128 r
.5 .38446 m .47411 .39218 L .47332 .39421 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.33022 .39112 m
.32466 .41747 L
s
.32466 .41747 m
.28428 .41069 L
s
.18 .237 .449 r
.54004 .62678 m .52124 .62407 L .52016 .6369 L p F P
0 0 0 r
s
.18 .237 .449 r
.52016 .6369 m .53799 .63945 L .54004 .62678 L p F P
0 0 0 r
s
.24 .35 .67 r
.28428 .41069 m
.27916 .43906 L
s
.27916 .43906 m
.23853 .43239 L
s
.973 .287 .123 r
.52091 .39168 m .52004 .39371 L .5 .38446 L closepath p F P
0 0 0 r
s
.096 .028 .012 r
.61085 .59877 m .61726 .58789 L .61411 .60412 L p F P
0 0 0 r
s
.83 .24 .1 r
.60392 .59107 m
.61651 .56929 L
s
.096 .028 .012 r
.61411 .60412 m .60791 .61456 L .61085 .59877 L p F P
0 0 0 r
s
.224 .307 .59 r
.38348 .57054 m .36329 .56753 L .36371 .58552 L p F P
0 0 0 r
s
.224 .307 .59 r
.36371 .58552 m .38385 .58847 L .38348 .57054 L p F P
0 0 0 r
s
.471 .137 .065 r
.61422 .48889 m .62003 .47809 L .62892 .49697 L p F P
0 0 0 r
s
.471 .137 .065 r
.62892 .49697 m .6226 .50838 L .61422 .48889 L p F P
0 0 0 r
s
.83 .24 .1 r
.59994 .47471 m
.6151 .49745 L
s
.60254 .52061 m
.6151 .49745 L
s
.083 .024 .01 r
.32617 .54997 m .32256 .56147 L .32613 .54224 L p F P
0 0 0 r
s
.083 .024 .01 r
.32613 .54224 m .3297 .53079 L .32617 .54997 L p F P
0 0 0 r
s
.24 .35 .67 r
.30663 .53179 m
.32763 .53499 L
s
.32763 .53499 m
.32835 .5351 L
s
.667 .196 .088 r
.59445 .44287 m .59891 .43398 L .61368 .44987 L p F P
0 0 0 r
s
.667 .196 .088 r
.61368 .44987 m .60845 .45994 L .59445 .44287 L p F P
0 0 0 r
s
.171 .049 .025 r
.61762 .56995 m .62418 .55863 L .62379 .57679 L p F P
0 0 0 r
s
.171 .049 .025 r
.62379 .57679 m .61726 .58789 L .61762 .56995 L p F P
0 0 0 r
s
.24 .35 .67 r
.2699 .49747 m
.22917 .4911 L
s
.2699 .49747 m
.26606 .5256 L
s
1 .313 .132 r
.47411 .39218 m .4749 .39015 L .45049 .39836 L p F P
0 0 0 r
s
1 .3 .128 r
.5 .38446 m .4749 .39015 L .47411 .39218 L closepath p F P
0 0 0 r
s
1 .324 .136 r
.42934 .40308 m .42724 .40893 L .45049 .39836 L p F P
0 0 0 r
s
1 .324 .136 r
.45049 .39836 m .45198 .39436 L .42934 .40308 L p F P
0 0 0 r
s
1 .313 .132 r
.45198 .39436 m .45049 .39836 L .4749 .39015 L p F P
0 0 0 r
s
.24 .35 .67 r
.47259 .39146 m
.49616 .39558 L
s
.46888 .39081 m
.47013 .39103 L
s
.973 .287 .123 r
.52177 .38964 m .52091 .39168 L .5 .38446 L closepath p F P
0 0 0 r
s
.924 .272 .118 r
.52091 .39168 m .52177 .38964 L .54297 .39737 L p F P
0 0 0 r
s
.083 .024 .01 r
.60182 .6248 m .60791 .61456 L .60233 .62799 L p F P
0 0 0 r
s
.083 .024 .01 r
.60233 .62799 m .59661 .63758 L .60182 .6248 L p F P
0 0 0 r
s
.83 .24 .1 r
.59444 .63782 m
.60214 .61514 L
s
1 .333 .138 r
.40824 .4141 m .40565 .42162 L .42724 .40893 L p F P
0 0 0 r
s
1 .333 .138 r
.42724 .40893 m .42934 .40308 L .40824 .4141 L p F P
0 0 0 r
s
.83 .24 .1 r
.41354 .43367 m
.42059 .41375 L
s
.42059 .41375 m
.44733 .40902 L
s
.24 .35 .67 r
.37049 .39803 m
.41033 .40486 L
s
.206 .277 .53 r
.4436 .59723 m .42379 .59432 L .42582 .61028 L p F P
0 0 0 r
s
.206 .277 .53 r
.42582 .61028 m .4451 .61307 L .4436 .59723 L p F P
0 0 0 r
s
.24 .35 .67 r
.30663 .53179 m
.26606 .5256 L
s
.30663 .53179 m
.30392 .55785 L
s
.924 .272 .118 r
.54476 .39336 m .54297 .39737 L .52177 .38964 L p F P
0 0 0 r
s
.87 .256 .112 r
.54297 .39737 m .54476 .39336 L .56589 .40162 L p F P
0 0 0 r
s
.87 .256 .112 r
.56589 .40162 m .56317 .40748 L .54297 .39737 L p F P
0 0 0 r
s
.18 .237 .449 r
.52124 .62407 m .50236 .62134 L .50223 .63434 L p F P
0 0 0 r
s
.18 .237 .449 r
.50223 .63434 m .52016 .6369 L .52124 .62407 L p F P
0 0 0 r
s
.24 .35 .67 r
.50324 .61034 m
.5057 .62956 L
s
.54522 .63523 m
.58432 .64083 L
s
1 .323 .129 r
.35511 .46985 m .35164 .4808 L .36593 .46242 L p F P
0 0 0 r
s
1 .323 .129 r
.36593 .46242 m .36917 .45239 L .35511 .46985 L p F P
0 0 0 r
s
.83 .24 .1 r
.36057 .48315 m
.36737 .46223 L
s
.36737 .46223 m
.38788 .44816 L
s
1 .313 .132 r
.4749 .39015 m .4757 .38811 L .45198 .39436 L p F P
0 0 0 r
s
.24 .35 .67 r
.45672 .38868 m
.46682 .39045 L
s
.45526 .39349 m
.45672 .38868 L
s
1 .3 .128 r
.5 .38446 m .4757 .38811 L .4749 .39015 L closepath p F P
0 0 0 r
s
.81 .238 .105 r
.56317 .40748 m .56589 .40162 L .58559 .41222 L p F P
0 0 0 r
s
.24 .35 .67 r
.57502 .40653 m
.58258 .39055 L
s
.81 .238 .105 r
.58559 .41222 m .58194 .41976 L .56317 .40748 L p F P
0 0 0 r
s
.83 .24 .1 r
.55725 .43707 m
.56895 .41218 L
s
.54257 .39834 m
.56895 .41218 L
s
.24 .35 .67 r
.37658 .37468 m
.37049 .39803 L
s
.37049 .39803 m
.33022 .39112 L
s
.231 .067 .035 r
.62168 .53942 m .62821 .52791 L .63087 .54708 L p F P
0 0 0 r
s
.231 .067 .035 r
.63087 .54708 m .62418 .55863 L .62168 .53942 L p F P
0 0 0 r
s
.973 .287 .123 r
.52264 .3876 m .52177 .38964 L .5 .38446 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.508 .40399 m
.51442 .38869 L
s
.924 .272 .118 r
.52177 .38964 m .52264 .3876 L .54476 .39336 L p F P
0 0 0 r
s
.83 .24 .1 r
.51442 .38869 m
.54257 .39834 L
s
.224 .307 .59 r
.36329 .56753 m .34298 .56451 L .34347 .58255 L p F P
0 0 0 r
s
.224 .307 .59 r
.34347 .58255 m .36371 .58552 L .36329 .56753 L p F P
0 0 0 r
s
.24 .35 .67 r
.34447 .56389 m
.38458 .56987 L
s
1 .338 .139 r
.38914 .42723 m .38615 .43621 L .40565 .42162 L p F P
0 0 0 r
s
1 .338 .139 r
.40565 .42162 m .40824 .4141 L .38914 .42723 L p F P
0 0 0 r
s
.24 .35 .67 r
.71929 .38947 m
.70833 .39753 L
s
.70833 .39753 m
.66985 .39061 L
s
.70642 .672 m
.66793 .66656 L
s
.70642 .672 m
.71548 .68145 L
s
.822 .24 .091 r
.33334 .51911 m .3297 .53079 L .33713 .51118 L p F P
0 0 0 r
s
.83 .24 .1 r
.32963 .53593 m
.33287 .52558 L
s
.822 .24 .091 r
.33713 .51118 m .34068 .49983 L .33334 .51911 L p F P
0 0 0 r
s
.83 .24 .1 r
.33287 .52558 m
.34368 .50418 L
s
.24 .35 .67 r
.23853 .43239 m
.23371 .4618 L
s
.23371 .4618 m
.19268 .45523 L
s
.23371 .4618 m
.22917 .4911 L
s
1 .313 .132 r
.45348 .39033 m .45198 .39436 L .4757 .38811 L p F P
0 0 0 r
s
1 .313 .132 r
.4757 .38811 m .4765 .38606 L .45348 .39033 L p F P
0 0 0 r
s
1 .3 .128 r
.5 .38446 m .4765 .38606 L .4757 .38811 L closepath p F P
0 0 0 r
s
.206 .277 .53 r
.42379 .59432 m .40387 .5914 L .40644 .60749 L p F P
0 0 0 r
s
.206 .277 .53 r
.40644 .60749 m .42582 .61028 L .42379 .59432 L p F P
0 0 0 r
s
.24 .35 .67 r
.42411 .59879 m
.46388 .6046 L
s
.42411 .59879 m
.42427 .57579 L
s
.578 .169 .078 r
.60845 .45994 m .61368 .44987 L .62594 .4671 L p F P
0 0 0 r
s
.578 .169 .078 r
.62594 .4671 m .62003 .47809 L .60845 .45994 L p F P
0 0 0 r
s
.83 .24 .1 r
.59994 .47471 m
.6126 .45035 L
s
1 .324 .136 r
.43145 .39718 m .42934 .40308 L .45198 .39436 L p F P
0 0 0 r
s
1 .324 .136 r
.45198 .39436 m .45348 .39033 L .43145 .39718 L p F P
0 0 0 r
s
.973 .287 .123 r
.52351 .38555 m .52264 .3876 L .5 .38446 L closepath p F P
0 0 0 r
s
.924 .272 .118 r
.52264 .3876 m .52351 .38555 L .54655 .38932 L p F P
0 0 0 r
s
.24 .35 .67 r
.53973 .39205 m
.5411 .38893 L
s
.924 .272 .118 r
.54655 .38932 m .54476 .39336 L .52264 .3876 L p F P
0 0 0 r
s
.744 .218 .097 r
.58194 .41976 m .58559 .41222 L .60343 .42497 L p F P
0 0 0 r
s
.744 .218 .097 r
.60343 .42497 m .59891 .43398 L .58194 .41976 L p F P
0 0 0 r
s
.83 .24 .1 r
.56895 .41218 m
.59259 .42972 L
s
.5804 .45435 m
.59259 .42972 L
s
.18 .237 .449 r
.50236 .62134 m .48337 .6186 L .48423 .63177 L p F P
0 0 0 r
s
.18 .237 .449 r
.48423 .63177 m .50223 .63434 L .50236 .62134 L p F P
0 0 0 r
s
.24 .35 .67 r
.28952 .38414 m
.28428 .41069 L
s
.28428 .41069 m
.24347 .40383 L
s
.24347 .40383 m
.23853 .43239 L
s
.23853 .43239 m
.19747 .42565 L
s
.143 .178 .333 r
.59099 .64701 m .57341 .6445 L .56763 .65375 L p F P
0 0 0 r
s
.143 .178 .333 r
.56763 .65375 m .58384 .65604 L .59099 .64701 L p F P
0 0 0 r
s
.83 .24 .1 r
.58095 .65806 m
.58243 .65584 L
s
.871 .26 .101 r
.59099 .64701 m .59661 .63758 L .58896 .64744 L p F P
0 0 0 r
s
.871 .26 .101 r
.58896 .64744 m .58384 .65604 L .59099 .64701 L p F P
0 0 0 r
s
.24 .35 .67 r
.58432 .64083 m
.58759 .64974 L
s
.58792 .65064 m
.5897 .65549 L
s
.83 .24 .1 r
.5854 .65138 m
.59444 .63782 L
s
.87 .256 .112 r
.54476 .39336 m .54655 .38932 L .56863 .3957 L p F P
0 0 0 r
s
.87 .256 .112 r
.56863 .3957 m .56589 .40162 L .54476 .39336 L p F P
0 0 0 r
s
1 .3 .128 r
.5 .38446 m .48379 .36734 L .48297 .36945 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.5 .38446 m .48297 .36945 L .48215 .37155 L closepath p F P
0 0 0 r
s
.287 .429 .843 r
.5 .38446 m .48696 .36791 L .49012 .36847 L closepath p F P
0 0 0 r
s
.287 .429 .843 r
.5 .38446 m .49012 .36847 L .49329 .36904 L closepath p F P
0 0 0 r
s
.287 .429 .843 r
.5 .38446 m .49329 .36904 L .49645 .3696 L closepath p F P
0 0 0 r
s
.287 .429 .843 r
.5 .38446 m .49645 .3696 L .49961 .37016 L closepath p F P
0 0 0 r
s
.287 .429 .843 r
.5 .38446 m .49961 .37016 L .50276 .37073 L closepath p F P
0 0 0 r
s
.287 .429 .843 r
.5 .38446 m .50276 .37073 L .50592 .37129 L closepath p F P
0 0 0 r
s
.287 .429 .843 r
.5 .38446 m .50592 .37129 L .50907 .37185 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.5 .38446 m .48215 .37155 L .48133 .37364 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.5 .38446 m .48133 .37364 L .48052 .37573 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.5 .38446 m .48052 .37573 L .47971 .37781 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.5 .38446 m .47971 .37781 L .4789 .37988 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.5 .38446 m .4789 .37988 L .4781 .38195 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.5 .38446 m .4781 .38195 L .4773 .38401 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.5 .38446 m .4773 .38401 L .4765 .38606 L closepath p F P
0 0 0 r
s
.973 .287 .123 r
.52439 .3835 m .52351 .38555 L .5 .38446 L closepath p F P
0 0 0 r
s
.973 .287 .123 r
.52527 .38144 m .52439 .3835 L .5 .38446 L closepath p F P
0 0 0 r
s
.973 .287 .123 r
.52615 .37937 m .52527 .38144 L .5 .38446 L closepath p F P
0 0 0 r
s
.287 .429 .843 r
.5 .38446 m .48379 .36734 L .48696 .36791 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.47942 .39902 m
.48552 .3836 L
s
.287 .429 .843 r
.5 .38446 m .50907 .37185 L .51221 .37241 L closepath p F P
0 0 0 r
s
.287 .429 .843 r
.5 .38446 m .51221 .37241 L .51536 .37297 L closepath p F P
0 0 0 r
s
.287 .429 .843 r
.5 .38446 m .51536 .37297 L .5185 .37353 L closepath p F P
0 0 0 r
s
.287 .429 .843 r
.5 .38446 m .5185 .37353 L .52164 .37409 L closepath p F P
0 0 0 r
s
.287 .429 .843 r
.5 .38446 m .52164 .37409 L .52478 .37465 L closepath p F P
0 0 0 r
s
.287 .429 .843 r
.5 .38446 m .52478 .37465 L .52791 .37521 L closepath p F P
0 0 0 r
s
.973 .287 .123 r
.52703 .37729 m .52615 .37937 L .5 .38446 L closepath p F P
0 0 0 r
s
.973 .287 .123 r
.52791 .37521 m .52703 .37729 L .5 .38446 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.49616 .39558 m
.5039 .37658 L
s
.83 .24 .1 r
.48552 .3836 m
.51442 .38869 L
s
.224 .307 .59 r
.34298 .56451 m .32256 .56147 L .32312 .57957 L p F P
0 0 0 r
s
.83 .24 .1 r
.32073 .57204 m
.3227 .5658 L
s
.224 .307 .59 r
.32312 .57957 m .34347 .58255 L .34298 .56451 L p F P
0 0 0 r
s
1 .313 .132 r
.455 .38627 m .45348 .39033 L .4765 .38606 L p F P
0 0 0 r
s
1 .313 .132 r
.4765 .38606 m .4773 .38401 L .455 .38627 L p F P
0 0 0 r
s
.34 .098 .05 r
.6226 .50838 m .62892 .49697 L .63487 .51617 L p F P
0 0 0 r
s
.34 .098 .05 r
.63487 .51617 m .62821 .52791 L .6226 .50838 L p F P
0 0 0 r
s
.83 .24 .1 r
.6151 .49745 m
.62517 .52173 L
s
.6123 .54463 m
.62517 .52173 L
s
.4898 .73421 m
.50039 .71479 L
s
.4898 .73421 m
.4613 .7361 L
s
1 .333 .138 r
.41086 .4065 m .40824 .4141 L .42934 .40308 L p F P
0 0 0 r
s
1 .333 .138 r
.42934 .40308 m .43145 .39718 L .41086 .4065 L p F P
0 0 0 r
s
.24 .35 .67 r
.41033 .40486 m
.41686 .38172 L
s
.924 .272 .118 r
.52351 .38555 m .52439 .3835 L .54836 .38526 L p F P
0 0 0 r
s
.924 .272 .118 r
.54836 .38526 m .54655 .38932 L .52351 .38555 L p F P
0 0 0 r
s
1 .336 .137 r
.37248 .44219 m .36917 .45239 L .38615 .43621 L p F P
0 0 0 r
s
1 .336 .137 r
.38615 .43621 m .38914 .42723 L .37248 .44219 L p F P
0 0 0 r
s
.24 .35 .67 r
.22917 .4911 m
.18801 .48467 L
s
.22917 .4911 m
.22506 .51935 L
s
.206 .277 .53 r
.40387 .5914 m .38385 .58847 L .38696 .60467 L p F P
0 0 0 r
s
.206 .277 .53 r
.38696 .60467 m .40644 .60749 L .40387 .5914 L p F P
0 0 0 r
s
.997 .292 .115 r
.3443 .48825 m .34068 .49983 L .35164 .4808 L p F P
0 0 0 r
s
.997 .292 .115 r
.35164 .4808 m .35511 .46985 L .3443 .48825 L p F P
0 0 0 r
s
.24 .35 .67 r
.26606 .5256 m
.22506 .51935 L
s
.26606 .5256 m
.26294 .55175 L
s
.81 .238 .105 r
.56589 .40162 m .56863 .3957 L .58927 .40459 L p F P
0 0 0 r
s
.81 .238 .105 r
.58927 .40459 m .58559 .41222 L .56589 .40162 L p F P
0 0 0 r
s
.83 .24 .1 r
.35358 .69 m
.33507 .66798 L
s
.33507 .66798 m
.34253 .64719 L
s
.18 .237 .449 r
.48337 .6186 m .46429 .61584 L .46613 .62919 L p F P
0 0 0 r
s
.18 .237 .449 r
.46613 .62919 m .48423 .63177 L .48337 .6186 L p F P
0 0 0 r
s
1 .313 .132 r
.45652 .38219 m .455 .38627 L .4773 .38401 L p F P
0 0 0 r
s
1 .313 .132 r
.4773 .38401 m .4781 .38195 L .45652 .38219 L p F P
0 0 0 r
s
1 .324 .136 r
.43358 .39122 m .43145 .39718 L .45348 .39033 L p F P
0 0 0 r
s
1 .324 .136 r
.45348 .39033 m .455 .38627 L .43358 .39122 L p F P
0 0 0 r
s
.24 .35 .67 r
.41686 .38172 m
.44979 .38747 L
s
.5057 .62956 m
.54522 .63523 L
s
.143 .178 .333 r
.57341 .6445 m .55574 .64198 L .55134 .65145 L p F P
0 0 0 r
s
.143 .178 .333 r
.55134 .65145 m .56763 .65375 L .57341 .6445 L p F P
0 0 0 r
s
.924 .272 .118 r
.52439 .3835 m .52527 .38144 L .55017 .38117 L p F P
0 0 0 r
s
.924 .272 .118 r
.55017 .38117 m .54836 .38526 L .52439 .3835 L p F P
0 0 0 r
s
.24 .35 .67 r
.54868 .38453 m
.58258 .39055 L
s
.667 .196 .088 r
.59891 .43398 m .60343 .42497 L .61901 .43963 L p F P
0 0 0 r
s
.667 .196 .088 r
.61901 .43963 m .61368 .44987 L .59891 .43398 L p F P
0 0 0 r
s
.83 .24 .1 r
.59259 .42972 m
.6126 .45035 L
s
.55026 .69509 m
.5621 .67484 L
s
.55026 .69509 m
.5271 .70746 L
s
.45694 .38331 m
.48552 .3836 L
s
.24 .35 .67 r
.33585 .36756 m
.33022 .39112 L
s
.33022 .39112 m
.28952 .38414 L
s
.87 .256 .112 r
.54655 .38932 m .54836 .38526 L .5714 .38973 L p F P
0 0 0 r
s
.87 .256 .112 r
.5714 .38973 m .56863 .3957 L .54655 .38932 L p F P
0 0 0 r
s
.154 .045 .022 r
.32672 .5683 m .32312 .57957 L .32256 .56147 L p F P
0 0 0 r
s
.154 .045 .022 r
.32256 .56147 m .32617 .54997 L .32672 .5683 L p F P
0 0 0 r
s
.24 .35 .67 r
.32651 .56122 m
.34447 .56389 L
s
.30392 .55785 m
.32281 .56067 L
s
.68017 .38238 m
.66985 .39061 L
s
.66985 .39061 m
.63095 .38363 L
s
.66793 .66656 m
.62902 .66105 L
s
.66793 .66656 m
.67633 .67596 L
s
1 .313 .132 r
.45806 .37808 m .45652 .38219 L .4781 .38195 L p F P
0 0 0 r
s
1 .313 .132 r
.4781 .38195 m .4789 .37988 L .45806 .37808 L p F P
0 0 0 r
s
1 .338 .139 r
.39218 .41812 m .38914 .42723 L .40824 .4141 L p F P
0 0 0 r
s
.83 .24 .1 r
.38788 .44816 m
.39629 .42328 L
s
1 .338 .139 r
.40824 .4141 m .41086 .4065 L .39218 .41812 L p F P
0 0 0 r
s
.83 .24 .1 r
.39629 .42328 m
.42059 .41375 L
s
.24 .35 .67 r
.19268 .45523 m
.19747 .42565 L
s
.18801 .48467 m
.19268 .45523 L
s
.924 .272 .118 r
.52527 .38144 m .52615 .37937 L .552 .37705 L p F P
0 0 0 r
s
.924 .272 .118 r
.552 .37705 m .55017 .38117 L .52527 .38144 L p F P
0 0 0 r
s
.471 .137 .065 r
.62003 .47809 m .62594 .4671 L .63535 .48534 L p F P
0 0 0 r
s
.471 .137 .065 r
.63535 .48534 m .62892 .49697 L .62003 .47809 L p F P
0 0 0 r
s
.24 .35 .67 r
.41686 .38172 m
.37658 .37468 L
s
.206 .277 .53 r
.38385 .58847 m .36371 .58552 L .36738 .60184 L p F P
0 0 0 r
s
.206 .277 .53 r
.36738 .60184 m .38696 .60467 L .38385 .58847 L p F P
0 0 0 r
s
.24 .35 .67 r
.38391 .59293 m
.42411 .59879 L
s
.38391 .59293 m
.38458 .56987 L
s
.18 .237 .449 r
.46429 .61584 m .4451 .61307 L .44794 .6266 L p F P
0 0 0 r
s
.18 .237 .449 r
.44794 .6266 m .46613 .62919 L .46429 .61584 L p F P
0 0 0 r
s
.24 .35 .67 r
.46388 .6046 m
.46575 .62383 L
s
.143 .178 .333 r
.55574 .64198 m .53799 .63945 L .53499 .64914 L p F P
0 0 0 r
s
.143 .178 .333 r
.53499 .64914 m .55134 .65145 L .55574 .64198 L p F P
0 0 0 r
s
.096 .028 .012 r
.61726 .58789 m .62379 .57679 L .62043 .59347 L p F P
0 0 0 r
s
.096 .028 .012 r
.62043 .59347 m .61411 .60412 L .61726 .58789 L p F P
0 0 0 r
s
.83 .24 .1 r
.61484 .59358 m
.61651 .56929 L
s
.24 .35 .67 r
.24838 .37708 m
.24347 .40383 L
s
.24347 .40383 m
.20222 .39691 L
s
.083 .024 .01 r
.32985 .53825 m .32617 .54997 L .3297 .53079 L p F P
0 0 0 r
s
.083 .024 .01 r
.3297 .53079 m .33334 .51911 L .32985 .53825 L p F P
0 0 0 r
s
.24 .35 .67 r
.19747 .42565 m
.20222 .39691 L
s
1 .313 .132 r
.4596 .37394 m .45806 .37808 L .4789 .37988 L p F P
0 0 0 r
s
1 .313 .132 r
.4789 .37988 m .47971 .37781 L .4596 .37394 L p F P
0 0 0 r
s
1 .323 .129 r
.35864 .45871 m .35511 .46985 L .36917 .45239 L p F P
0 0 0 r
s
.83 .24 .1 r
.35122 .48035 m
.36737 .46223 L
s
1 .323 .129 r
.36917 .45239 m .37248 .44219 L .35864 .45871 L p F P
0 0 0 r
s
.744 .218 .097 r
.58559 .41222 m .58927 .40459 L .60802 .41583 L p F P
0 0 0 r
s
.744 .218 .097 r
.60802 .41583 m .60343 .42497 L .58559 .41222 L p F P
0 0 0 r
s
.24 .35 .67 r
.80828 .40163 m
.79628 .40341 L
s
.79628 .40341 m
.758 .39647 L
s
1 .333 .138 r
.41352 .3988 m .41086 .4065 L .43145 .39718 L p F P
0 0 0 r
s
1 .333 .138 r
.43145 .39718 m .43358 .39122 L .41352 .3988 L p F P
0 0 0 r
s
1 .324 .136 r
.43574 .38521 m .43358 .39122 L .455 .38627 L p F P
0 0 0 r
s
1 .324 .136 r
.455 .38627 m .45652 .38219 L .43574 .38521 L p F P
0 0 0 r
s
.924 .272 .118 r
.52615 .37937 m .52703 .37729 L .55384 .37291 L p F P
0 0 0 r
s
.924 .272 .118 r
.55384 .37291 m .552 .37705 L .52615 .37937 L p F P
0 0 0 r
s
.171 .049 .025 r
.62418 .55863 m .63087 .54708 L .63045 .56546 L p F P
0 0 0 r
s
.171 .049 .025 r
.63045 .56546 m .62379 .57679 L .62418 .55863 L p F P
0 0 0 r
s
.083 .024 .01 r
.60791 .61456 m .61411 .60412 L .60816 .61822 L p F P
0 0 0 r
s
.083 .024 .01 r
.60816 .61822 m .60233 .62799 L .60791 .61456 L p F P
0 0 0 r
s
.83 .24 .1 r
.60214 .61514 m
.61484 .59358 L
s
.87 .256 .112 r
.54836 .38526 m .55017 .38117 L .57419 .3837 L p F P
0 0 0 r
s
.87 .256 .112 r
.57419 .3837 m .5714 .38973 L .54836 .38526 L p F P
0 0 0 r
s
.24 .35 .67 r
.30392 .55785 m
.26294 .55175 L
s
.30392 .55785 m
.3022 .581 L
s
.18361 .51303 m
.18801 .48467 L
s
.81 .238 .105 r
.56863 .3957 m .5714 .38973 L .593 .39687 L p F P
0 0 0 r
s
.81 .238 .105 r
.593 .39687 m .58927 .40459 L .56863 .3957 L p F P
0 0 0 r
s
1 .313 .132 r
.46115 .36978 m .4596 .37394 L .47971 .37781 L p F P
0 0 0 r
s
1 .313 .132 r
.47971 .37781 m .48052 .37573 L .46115 .36978 L p F P
0 0 0 r
s
.83 .24 .1 r
.4613 .7361 m
.47138 .71659 L
s
.4613 .7361 m
.43196 .73233 L
s
.206 .277 .53 r
.36371 .58552 m .34347 .58255 L .34769 .599 L p F P
0 0 0 r
s
.206 .277 .53 r
.34769 .599 m .36738 .60184 L .36371 .58552 L p F P
0 0 0 r
s
.143 .178 .333 r
.53799 .63945 m .52016 .6369 L .51856 .64682 L p F P
0 0 0 r
s
.143 .178 .333 r
.51856 .64682 m .53499 .64914 L .53799 .63945 L p F P
0 0 0 r
s
.924 .272 .118 r
.52703 .37729 m .52791 .37521 L .55569 .36874 L p F P
0 0 0 r
s
.924 .272 .118 r
.55569 .36874 m .55384 .37291 L .52703 .37729 L p F P
0 0 0 r
s
.24 .35 .67 r
.5039 .37658 m
.52764 .38079 L
s
.18 .237 .449 r
.4451 .61307 m .42582 .61028 L .42967 .62399 L p F P
0 0 0 r
s
.18 .237 .449 r
.42967 .62399 m .44794 .6266 L .4451 .61307 L p F P
0 0 0 r
s
.24 .35 .67 r
.22506 .51935 m
.18361 .51303 L
s
.22506 .51935 m
.22152 .54557 L
s
.578 .169 .078 r
.61368 .44987 m .61901 .43963 L .63195 .45591 L p F P
0 0 0 r
s
.578 .169 .078 r
.63195 .45591 m .62594 .4671 L .61368 .44987 L p F P
0 0 0 r
s
.231 .067 .035 r
.62821 .52791 m .63487 .51617 L .6377 .53529 L p F P
0 0 0 r
s
.231 .067 .035 r
.6377 .53529 m .63087 .54708 L .62821 .52791 L p F P
0 0 0 r
s
.83 .24 .1 r
.62517 .52173 m
.62961 .54663 L
s
.24 .35 .67 r
.46575 .62383 m
.5057 .62956 L
s
.83 .24 .1 r
.37669 .70869 m
.35358 .69 L
s
.35358 .69 m
.36146 .66954 L
s
.822 .24 .091 r
.33705 .50719 m .33334 .51911 L .34068 .49983 L p F P
0 0 0 r
s
.822 .24 .091 r
.34068 .49983 m .3443 .48825 L .33705 .50719 L p F P
0 0 0 r
s
.83 .24 .1 r
.34368 .50418 m
.35122 .48035 L
s
1 .336 .137 r
.37583 .43183 m .37248 .44219 L .38914 .42723 L p F P
0 0 0 r
s
1 .336 .137 r
.38914 .42723 m .39218 .41812 L .37583 .43183 L p F P
0 0 0 r
s
.24 .35 .67 r
.29469 .36037 m
.28952 .38414 L
s
.28952 .38414 m
.24838 .37708 L
s
1 .313 .132 r
.46271 .3656 m .46115 .36978 L .48052 .37573 L p F P
0 0 0 r
s
1 .313 .132 r
.48052 .37573 m .48133 .37364 L .46271 .3656 L p F P
0 0 0 r
s
1 .324 .136 r
.43791 .37914 m .43574 .38521 L .45652 .38219 L p F P
0 0 0 r
s
.83 .24 .1 r
.44733 .40902 m
.45694 .38331 L
s
1 .324 .136 r
.45652 .38219 m .45806 .37808 L .43791 .37914 L p F P
0 0 0 r
s
.24 .35 .67 r
.64062 .37522 m
.63095 .38363 L
s
.63095 .38363 m
.59164 .37656 L
s
.281 .424 .837 r
.54946 .36762 m .55569 .36874 L .52791 .37521 L p F P
0 0 0 r
s
.281 .424 .837 r
.52791 .37521 m .52478 .37465 L .54946 .36762 L p F P
0 0 0 r
s
.24 .35 .67 r
.5897 .65549 m
.62902 .66105 L
s
.62902 .66105 m
.63675 .6704 L
s
.871 .26 .101 r
.59661 .63758 m .60233 .62799 L .59416 .6387 L p F P
0 0 0 r
s
.871 .26 .101 r
.59416 .6387 m .58896 .64744 L .59661 .63758 L p F P
0 0 0 r
s
.281 .424 .837 r
.54322 .3665 m .54946 .36762 L .52478 .37465 L p F P
0 0 0 r
s
.24 .35 .67 r
.54877 .37468 m
.5519 .36942 L
s
.281 .424 .837 r
.52478 .37465 m .52164 .37409 L .54322 .3665 L p F P
0 0 0 r
s
.87 .256 .112 r
.55017 .38117 m .552 .37705 L .57701 .37762 L p F P
0 0 0 r
s
.87 .256 .112 r
.57701 .37762 m .57419 .3837 L .55017 .38117 L p F P
0 0 0 r
s
.143 .178 .333 r
.52016 .6369 m .50223 .63434 L .50206 .64449 L p F P
0 0 0 r
s
.143 .178 .333 r
.50206 .64449 m .51856 .64682 L .52016 .6369 L p F P
0 0 0 r
s
.24 .35 .67 r
.5057 .62956 m
.50976 .64418 L
s
.38266 .35506 m
.37658 .37468 L
s
.37658 .37468 m
.33585 .36756 L
s
.281 .424 .837 r
.53696 .36538 m .54322 .3665 L .52164 .37409 L p F P
0 0 0 r
s
.281 .424 .837 r
.52164 .37409 m .5185 .37353 L .53696 .36538 L p F P
0 0 0 r
s
.206 .277 .53 r
.34347 .58255 m .32312 .57957 L .3279 .59614 L p F P
0 0 0 r
s
.206 .277 .53 r
.3279 .59614 m .34769 .599 L .34347 .58255 L p F P
0 0 0 r
s
.24 .35 .67 r
.34327 .587 m
.34447 .56389 L
s
.34327 .587 m
.38391 .59293 L
s
.83 .24 .1 r
.32181 .5972 m
.32914 .62267 L
s
1 .338 .139 r
.39526 .40888 m .39218 .41812 L .41086 .4065 L p F P
0 0 0 r
s
1 .338 .139 r
.41086 .4065 m .41352 .3988 L .39526 .40888 L p F P
0 0 0 r
s
.18 .237 .449 r
.42582 .61028 m .40644 .60749 L .4113 .62137 L p F P
0 0 0 r
s
.18 .237 .449 r
.4113 .62137 m .42967 .62399 L .42582 .61028 L p F P
0 0 0 r
s
.24 .35 .67 r
.42411 .59879 m
.42537 .61804 L
s
.667 .196 .088 r
.60343 .42497 m .60802 .41583 L .62442 .42922 L p F P
0 0 0 r
s
.667 .196 .088 r
.62442 .42922 m .61901 .43963 L .60343 .42497 L p F P
0 0 0 r
s
1 .313 .132 r
.46428 .36138 m .46271 .3656 L .48133 .37364 L p F P
0 0 0 r
s
1 .313 .132 r
.48133 .37364 m .48215 .37155 L .46428 .36138 L p F P
0 0 0 r
s
.24 .35 .67 r
.48001 .37234 m
.5039 .37658 L
s
1 .333 .138 r
.4162 .391 m .41352 .3988 L .43358 .39122 L p F P
0 0 0 r
s
1 .333 .138 r
.43358 .39122 m .43574 .38521 L .4162 .391 L p F P
0 0 0 r
s
.281 .424 .837 r
.5307 .36425 m .53696 .36538 L .5185 .37353 L p F P
0 0 0 r
s
.281 .424 .837 r
.5185 .37353 m .51536 .37297 L .5307 .36425 L p F P
0 0 0 r
s
.83 .24 .1 r
.51442 .38869 m
.52099 .37301 L
s
.34 .098 .05 r
.62892 .49697 m .63535 .48534 L .64167 .50419 L p F P
0 0 0 r
s
.34 .098 .05 r
.64167 .50419 m .63487 .51617 L .62892 .49697 L p F P
0 0 0 r
s
.24 .35 .67 r
.20222 .39691 m
.20679 .36995 L
s
.281 .424 .837 r
.52442 .36312 m .5307 .36425 L .51536 .37297 L p F P
0 0 0 r
s
.83 .24 .1 r
.52509 .36324 m
.52549 .3623 L
s
.281 .424 .837 r
.51536 .37297 m .51221 .37241 L .52442 .36312 L p F P
0 0 0 r
s
.24 .35 .67 r
.76933 .39455 m
.758 .39647 L
s
.758 .39647 m
.71929 .38947 L
s
.997 .292 .115 r
.34799 .47645 m .3443 .48825 L .35511 .46985 L p F P
0 0 0 r
s
.997 .292 .115 r
.35511 .46985 m .35864 .45871 L .34799 .47645 L p F P
0 0 0 r
s
.281 .424 .837 r
.51814 .36199 m .52442 .36312 L .51221 .37241 L p F P
0 0 0 r
s
.281 .424 .837 r
.51221 .37241 m .50907 .37185 L .51814 .36199 L p F P
0 0 0 r
s
.83 .24 .1 r
.43196 .73233 m
.44147 .71267 L
s
.43196 .73233 m
.40327 .72305 L
s
.24 .35 .67 r
.75422 .68689 m
.71548 .68145 L
s
.75422 .68689 m
.76548 .69047 L
s
.81 .238 .105 r
.5714 .38973 m .57419 .3837 L .59677 .38905 L p F P
0 0 0 r
s
.24 .35 .67 r
.58258 .39055 m
.58331 .38941 L
s
.58531 .38634 m
.59164 .37656 L
s
.81 .238 .105 r
.59677 .38905 m .593 .39687 L .5714 .38973 L p F P
0 0 0 r
s
.744 .218 .097 r
.58927 .40459 m .593 .39687 L .61267 .40656 L p F P
0 0 0 r
s
.744 .218 .097 r
.61267 .40656 m .60802 .41583 L .58927 .40459 L p F P
0 0 0 r
s
.281 .424 .837 r
.51184 .36086 m .51814 .36199 L .50907 .37185 L p F P
0 0 0 r
s
.281 .424 .837 r
.50907 .37185 m .50592 .37129 L .51184 .36086 L p F P
0 0 0 r
s
.83 .24 .1 r
.40327 .72305 m
.37669 .70869 L
s
.37669 .70869 m
.38507 .68853 L
s
1 .313 .132 r
.46587 .35714 m .46428 .36138 L .48215 .37155 L p F P
0 0 0 r
s
1 .313 .132 r
.48215 .37155 m .48297 .36945 L .46587 .35714 L p F P
0 0 0 r
s
1 .324 .136 r
.4401 .37302 m .43791 .37914 L .45806 .37808 L p F P
0 0 0 r
s
1 .324 .136 r
.45806 .37808 m .4596 .37394 L .4401 .37302 L p F P
0 0 0 r
s
.83 .24 .1 r
.58095 .65806 m
.58228 .65582 L
s
.24 .35 .67 r
.26294 .55175 m
.22152 .54557 L
s
.26294 .55175 m
.26067 .57494 L
s
.281 .424 .837 r
.50553 .35972 m .51184 .36086 L .50592 .37129 L p F P
0 0 0 r
s
.281 .424 .837 r
.50592 .37129 m .50276 .37073 L .50553 .35972 L p F P
0 0 0 r
s
.143 .178 .333 r
.50223 .63434 m .48423 .63177 L .48548 .64214 L p F P
0 0 0 r
s
.143 .178 .333 r
.48548 .64214 m .50206 .64449 L .50223 .63434 L p F P
0 0 0 r
s
.281 .424 .837 r
.49921 .35859 m .50553 .35972 L .50276 .37073 L p F P
0 0 0 r
s
.24 .35 .67 r
.5039 .37658 m
.51172 .36221 L
s
.281 .424 .837 r
.50276 .37073 m .49961 .37016 L .49921 .35859 L p F P
0 0 0 r
s
.18 .237 .449 r
.40644 .60749 m .38696 .60467 L .39285 .61874 L p F P
0 0 0 r
s
.18 .237 .449 r
.39285 .61874 m .4113 .62137 L .40644 .60749 L p F P
0 0 0 r
s
.226 .065 .035 r
.33145 .58534 m .3279 .59614 L .32312 .57957 L p F P
0 0 0 r
s
.83 .24 .1 r
.32181 .5972 m
.32519 .58675 L
s
.226 .065 .035 r
.32312 .57957 m .32672 .5683 L .33145 .58534 L p F P
0 0 0 r
s
.83 .24 .1 r
.40327 .72305 m
.4122 .70317 L
s
.87 .256 .112 r
.552 .37705 m .55384 .37291 L .57985 .37149 L p F P
0 0 0 r
s
.87 .256 .112 r
.57985 .37149 m .57701 .37762 L .552 .37705 L p F P
0 0 0 r
s
.281 .424 .837 r
.49288 .35745 m .49921 .35859 L .49961 .37016 L p F P
0 0 0 r
s
.281 .424 .837 r
.49961 .37016 m .49645 .3696 L .49288 .35745 L p F P
0 0 0 r
s
.83 .24 .1 r
.5271 .70746 m
.53858 .68725 L
s
.5271 .70746 m
.50039 .71479 L
s
.24 .35 .67 r
.17964 .53933 m
.18361 .51303 L
s
.281 .424 .837 r
.48654 .35631 m .49288 .35745 L .49645 .3696 L p F P
0 0 0 r
s
.281 .424 .837 r
.49645 .3696 m .49329 .36904 L .48654 .35631 L p F P
0 0 0 r
s
.83 .24 .1 r
.49567 .35795 m
.49605 .35701 L
s
.24 .35 .67 r
.42537 .61804 m
.46575 .62383 L
s
.471 .137 .065 r
.62594 .4671 m .63195 .45591 L .64192 .47348 L p F P
0 0 0 r
s
.471 .137 .065 r
.64192 .47348 m .63535 .48534 L .62594 .4671 L p F P
0 0 0 r
s
.83 .24 .1 r
.6151 .49745 m
.62816 .47335 L
s
1 .313 .132 r
.46746 .35288 m .46587 .35714 L .48297 .36945 L p F P
0 0 0 r
s
1 .313 .132 r
.48297 .36945 m .48379 .36734 L .46746 .35288 L p F P
0 0 0 r
s
.154 .045 .022 r
.3304 .5568 m .32672 .5683 L .32617 .54997 L p F P
0 0 0 r
s
.154 .045 .022 r
.32617 .54997 m .32985 .53825 L .3304 .5568 L p F P
0 0 0 r
s
.83 .24 .1 r
.32989 .53972 m
.33287 .52558 L
s
.281 .424 .837 r
.48019 .35517 m .48654 .35631 L .49329 .36904 L p F P
0 0 0 r
s
.281 .424 .837 r
.49329 .36904 m .49012 .36847 L .48019 .35517 L p F P
0 0 0 r
s
1 .323 .129 r
.36224 .44736 m .35864 .45871 L .37248 .44219 L p F P
0 0 0 r
s
1 .323 .129 r
.37248 .44219 m .37583 .43183 L .36224 .44736 L p F P
0 0 0 r
s
.83 .24 .1 r
.36737 .46223 m
.37545 .43735 L
s
.24 .35 .67 r
.25307 .35309 m
.24838 .37708 L
s
.24838 .37708 m
.20679 .36995 L
s
.3022 .581 m
.32485 .58431 L
s
.33143 .58527 m
.34327 .587 L
s
.281 .424 .837 r
.47383 .35402 m .48019 .35517 L .49012 .36847 L p F P
0 0 0 r
s
.281 .424 .837 r
.49012 .36847 m .48696 .36791 L .47383 .35402 L p F P
0 0 0 r
s
.24 .35 .67 r
.57859 .37422 m
.59164 .37656 L
s
.5897 .65549 m
.59673 .66478 L
s
.83 .24 .1 r
.34253 .64719 m
.32914 .62267 L
s
.281 .424 .837 r
.46746 .35288 m .47383 .35402 L .48696 .36791 L p F P
0 0 0 r
s
.281 .424 .837 r
.48696 .36791 m .48379 .36734 L .46746 .35288 L p F P
0 0 0 r
s
.83 .24 .1 r
.48552 .3836 m
.49177 .3678 L
s
.143 .178 .333 r
.48423 .63177 m .46613 .62919 L .46883 .63979 L p F P
0 0 0 r
s
.143 .178 .333 r
.46883 .63979 m .48548 .64214 L .48423 .63177 L p F P
0 0 0 r
s
1 .333 .138 r
.41892 .38311 m .4162 .391 L .43574 .38521 L p F P
0 0 0 r
s
.83 .24 .1 r
.42059 .41375 m
.42974 .38792 L
s
1 .333 .138 r
.43574 .38521 m .43791 .37914 L .41892 .38311 L p F P
0 0 0 r
s
.83 .24 .1 r
.42974 .38792 m
.45694 .38331 L
s
.24 .35 .67 r
.41686 .38172 m
.42351 .36231 L
s
.101 .114 .218 r
.58384 .65604 m .56763 .65375 L .56004 .65959 L p F P
0 0 0 r
s
.101 .114 .218 r
.56004 .65959 m .57446 .66161 L .58384 .65604 L p F P
0 0 0 r
s
1 .304 .122 r
.58384 .65604 m .58896 .64744 L .57893 .65402 L p F P
0 0 0 r
s
.24 .35 .67 r
.58487 .6548 m
.5897 .65549 L
s
.58467 .65478 m
.58487 .6548 L
s
1 .304 .122 r
.57893 .65402 m .57446 .66161 L .58384 .65604 L p F P
0 0 0 r
s
1 .324 .136 r
.44232 .36684 m .4401 .37302 L .4596 .37394 L p F P
0 0 0 r
s
1 .324 .136 r
.4596 .37394 m .46115 .36978 L .44232 .36684 L p F P
0 0 0 r
s
.096 .028 .012 r
.62379 .57679 m .63045 .56546 L .62689 .58262 L p F P
0 0 0 r
s
.83 .24 .1 r
.61651 .56929 m
.62961 .54663 L
s
.096 .028 .012 r
.62689 .58262 m .62043 .59347 L .62379 .57679 L p F P
0 0 0 r
s
.18 .237 .449 r
.38696 .60467 m .36738 .60184 L .3743 .61609 L p F P
0 0 0 r
s
.18 .237 .449 r
.3743 .61609 m .39285 .61874 L .38696 .60467 L p F P
0 0 0 r
s
.24 .35 .67 r
.38391 .59293 m
.38455 .61219 L
s
.34136 .34773 m
.33585 .36756 L
s
.33585 .36756 m
.29469 .36037 L
s
.083 .024 .01 r
.33361 .52627 m .32985 .53825 L .33334 .51911 L p F P
0 0 0 r
s
.083 .024 .01 r
.33334 .51911 m .33705 .50719 L .33361 .52627 L p F P
0 0 0 r
s
1 .336 .137 r
.37925 .42129 m .37583 .43183 L .39218 .41812 L p F P
0 0 0 r
s
.83 .24 .1 r
.37545 .43735 m
.39629 .42328 L
s
1 .336 .137 r
.39218 .41812 m .39526 .40888 L .37925 .42129 L p F P
0 0 0 r
s
.083 .024 .01 r
.61411 .60412 m .62043 .59347 L .6141 .60827 L p F P
0 0 0 r
s
.083 .024 .01 r
.6141 .60827 m .60816 .61822 L .61411 .60412 L p F P
0 0 0 r
s
.83 .24 .1 r
.60714 .61646 m
.61484 .59358 L
s
.578 .169 .078 r
.61901 .43963 m .62442 .42922 L .63808 .44451 L p F P
0 0 0 r
s
.578 .169 .078 r
.63808 .44451 m .63195 .45591 L .61901 .43963 L p F P
0 0 0 r
s
.83 .24 .1 r
.6126 .45035 m
.62816 .47335 L
s
.87 .256 .112 r
.55384 .37291 m .55569 .36874 L .58273 .36529 L p F P
0 0 0 r
s
.87 .256 .112 r
.58273 .36529 m .57985 .37149 L .55384 .37291 L p F P
0 0 0 r
s
.83 .24 .1 r
.54257 .39834 m
.55419 .37219 L
s
.24 .35 .67 r
.5519 .36942 m
.55883 .37067 L
s
1 .338 .139 r
.39838 .3995 m .39526 .40888 L .41352 .3988 L p F P
0 0 0 r
s
1 .338 .139 r
.41352 .3988 m .4162 .391 L .39838 .3995 L p F P
0 0 0 r
s
.81 .238 .105 r
.57419 .3837 m .57701 .37762 L .60059 .38114 L p F P
0 0 0 r
s
.81 .238 .105 r
.60059 .38114 m .59677 .38905 L .57419 .3837 L p F P
0 0 0 r
s
.83 .24 .1 r
.56895 .41218 m
.58111 .38628 L
s
.171 .049 .025 r
.63087 .54708 m .6377 .53529 L .63726 .5539 L p F P
0 0 0 r
s
.171 .049 .025 r
.63726 .5539 m .63045 .56546 L .63087 .54708 L p F P
0 0 0 r
s
.24 .35 .67 r
.72996 .3874 m
.71929 .38947 L
s
.71929 .38947 m
.68017 .38238 L
s
.71548 .68145 m
.67633 .67596 L
s
.71548 .68145 m
.72608 .68495 L
s
.143 .178 .333 r
.46613 .62919 m .44794 .6266 L .45211 .63743 L p F P
0 0 0 r
s
.143 .178 .333 r
.45211 .63743 m .46883 .63979 L .46613 .62919 L p F P
0 0 0 r
s
.101 .114 .218 r
.56763 .65375 m .55134 .65145 L .54558 .65756 L p F P
0 0 0 r
s
.101 .114 .218 r
.54558 .65756 m .56004 .65959 L .56763 .65375 L p F P
0 0 0 r
s
.83 .24 .1 r
.5621 .67484 m
.58095 .65806 L
s
.667 .196 .088 r
.60802 .41583 m .61267 .40656 L .62993 .41864 L p F P
0 0 0 r
s
.667 .196 .088 r
.62993 .41864 m .62442 .42922 L .60802 .41583 L p F P
0 0 0 r
s
.24 .35 .67 r
.22152 .54557 m
.17964 .53933 L
s
.22152 .54557 m
.21869 .56882 L
s
.744 .218 .097 r
.593 .39687 m .59677 .38905 L .61739 .39715 L p F P
0 0 0 r
s
.744 .218 .097 r
.61739 .39715 m .61267 .40656 L .593 .39687 L p F P
0 0 0 r
s
.83 .24 .1 r
.59259 .42972 m
.60528 .40408 L
s
.54367 .36856 m
.55419 .37219 L
s
.52549 .3623 m
.53161 .36441 L
s
.55419 .37219 m
.58111 .38628 L
s
.18 .237 .449 r
.36738 .60184 m .34769 .599 L .35566 .61343 L p F P
0 0 0 r
s
.18 .237 .449 r
.35566 .61343 m .3743 .61609 L .36738 .60184 L p F P
0 0 0 r
s
.822 .24 .091 r
.34084 .49503 m .33705 .50719 L .3443 .48825 L p F P
0 0 0 r
s
.83 .24 .1 r
.33491 .51905 m
.34028 .50189 L
s
.822 .24 .091 r
.3443 .48825 m .34799 .47645 L .34084 .49503 L p F P
0 0 0 r
s
.83 .24 .1 r
.34028 .50189 m
.35122 .48035 L
s
.231 .067 .035 r
.63487 .51617 m .64167 .50419 L .64467 .52326 L p F P
0 0 0 r
s
.231 .067 .035 r
.64467 .52326 m .6377 .53529 L .63487 .51617 L p F P
0 0 0 r
s
1 .324 .136 r
.44455 .3606 m .44232 .36684 L .46115 .36978 L p F P
0 0 0 r
s
.24 .35 .67 r
.42351 .36231 m
.44272 .36572 L
s
.45904 .36862 m
.46143 .36904 L
s
1 .324 .136 r
.46115 .36978 m .46271 .3656 L .44455 .3606 L p F P
0 0 0 r
s
.871 .26 .101 r
.60233 .62799 m .60816 .61822 L .59945 .6298 L p F P
0 0 0 r
s
.871 .26 .101 r
.59945 .6298 m .59416 .6387 L .60233 .62799 L p F P
0 0 0 r
s
.83 .24 .1 r
.59444 .63782 m
.60714 .61646 L
s
.24 .35 .67 r
.38455 .61219 m
.42537 .61804 L
s
.83 .24 .1 r
.58111 .38628 m
.60528 .40408 L
s
.263 .406 .804 r
.5735 .36362 m .58273 .36529 L .55569 .36874 L p F P
0 0 0 r
s
.263 .406 .804 r
.55569 .36874 m .54946 .36762 L .5735 .36362 L p F P
0 0 0 r
s
.24 .35 .67 r
.42351 .36231 m
.38266 .35506 L
s
.101 .114 .218 r
.55134 .65145 m .53499 .64914 L .53105 .65552 L p F P
0 0 0 r
s
.24 .35 .67 r
.54522 .63523 m
.54995 .64986 L
s
.101 .114 .218 r
.53105 .65552 m .54558 .65756 L .55134 .65145 L p F P
0 0 0 r
s
.24 .35 .67 r
.54995 .64986 m
.579 .65397 L
s
.20679 .36995 m
.211 .34574 L
s
.3022 .581 m
.26067 .57494 L
s
.3022 .581 m
.30155 .60029 L
s
1 .333 .138 r
.42167 .37513 m .41892 .38311 L .43791 .37914 L p F P
0 0 0 r
s
1 .333 .138 r
.43791 .37914 m .4401 .37302 L .42167 .37513 L p F P
0 0 0 r
s
.143 .178 .333 r
.44794 .6266 m .42967 .62399 L .43531 .63505 L p F P
0 0 0 r
s
.143 .178 .333 r
.43531 .63505 m .45211 .63743 L .44794 .6266 L p F P
0 0 0 r
s
.263 .406 .804 r
.56425 .36194 m .5735 .36362 L .54946 .36762 L p F P
0 0 0 r
s
.263 .406 .804 r
.54946 .36762 m .54322 .3665 L .56425 .36194 L p F P
0 0 0 r
s
.83 .24 .1 r
.55419 .37219 m
.55625 .36754 L
s
.997 .292 .115 r
.35175 .46441 m .34799 .47645 L .35864 .45871 L p F P
0 0 0 r
s
.997 .292 .115 r
.35864 .45871 m .36224 .44736 L .35175 .46441 L p F P
0 0 0 r
s
.34 .098 .05 r
.63535 .48534 m .64192 .47348 L .64861 .49197 L p F P
0 0 0 r
s
.34 .098 .05 r
.64861 .49197 m .64167 .50419 L .63535 .48534 L p F P
0 0 0 r
s
.83 .24 .1 r
.62517 .52173 m
.63857 .49788 L
s
.18 .237 .449 r
.34769 .599 m .3279 .59614 L .33693 .61076 L p F P
0 0 0 r
s
.18 .237 .449 r
.33693 .61076 m .35566 .61343 L .34769 .599 L p F P
0 0 0 r
s
.24 .35 .67 r
.34327 .587 m
.34328 .60627 L
s
.81 .238 .105 r
.57701 .37762 m .57985 .37149 L .60446 .37313 L p F P
0 0 0 r
s
.24 .35 .67 r
.59164 .37656 m
.59333 .37495 L
s
.81 .238 .105 r
.60446 .37313 m .60059 .38114 L .57701 .37762 L p F P
0 0 0 r
s
.24 .35 .67 r
.29961 .34031 m
.29469 .36037 L
s
.29469 .36037 m
.25307 .35309 L
s
.263 .406 .804 r
.55497 .36027 m .56425 .36194 L .54322 .3665 L p F P
0 0 0 r
s
.263 .406 .804 r
.54322 .3665 m .53696 .36538 L .55497 .36027 L p F P
0 0 0 r
s
.83 .24 .1 r
.50039 .71479 m
.51142 .69456 L
s
.50039 .71479 m
.47138 .71659 L
s
1 .324 .136 r
.44681 .3543 m .44455 .3606 L .46271 .3656 L p F P
0 0 0 r
s
1 .324 .136 r
.46271 .3656 m .46428 .36138 L .44681 .3543 L p F P
0 0 0 r
s
.263 .406 .804 r
.54567 .35858 m .55497 .36027 L .53696 .36538 L p F P
0 0 0 r
s
.263 .406 .804 r
.53696 .36538 m .5307 .36425 L .54567 .35858 L p F P
0 0 0 r
s
.101 .114 .218 r
.53499 .64914 m .51856 .64682 L .51647 .65347 L p F P
0 0 0 r
s
.101 .114 .218 r
.51647 .65347 m .53105 .65552 L .53499 .64914 L p F P
0 0 0 r
s
.24 .35 .67 r
.69014 .38017 m
.68017 .38238 L
s
.68017 .38238 m
.64062 .37522 L
s
1 .323 .129 r
.3659 .4358 m .36224 .44736 L .37583 .43183 L p F P
0 0 0 r
s
1 .323 .129 r
.37583 .43183 m .37925 .42129 L .3659 .4358 L p F P
0 0 0 r
s
1 .338 .139 r
.40155 .38998 m .39838 .3995 L .4162 .391 L p F P
0 0 0 r
s
1 .338 .139 r
.4162 .391 m .41892 .38311 L .40155 .38998 L p F P
0 0 0 r
s
.83 .24 .1 r
.40503 .39738 m
.42974 .38792 L
s
.143 .178 .333 r
.42967 .62399 m .4113 .62137 L .41843 .63267 L p F P
0 0 0 r
s
.143 .178 .333 r
.41843 .63267 m .43531 .63505 L .42967 .62399 L p F P
0 0 0 r
s
.24 .35 .67 r
.42537 .61804 m
.42806 .63262 L
s
.67633 .67596 m
.63675 .6704 L
s
.67633 .67596 m
.68623 .67937 L
s
.83 .24 .1 r
.36146 .66954 m
.34253 .64719 L
s
.34253 .64719 m
.3503 .62554 L
s
.263 .406 .804 r
.53635 .3569 m .54567 .35858 L .5307 .36425 L p F P
0 0 0 r
s
.263 .406 .804 r
.5307 .36425 m .52442 .36312 L .53635 .3569 L p F P
0 0 0 r
s
.83 .24 .1 r
.49605 .35701 m
.52549 .3623 L
s
.471 .137 .065 r
.63195 .45591 m .63808 .44451 L .64861 .46138 L p F P
0 0 0 r
s
.471 .137 .065 r
.64861 .46138 m .64192 .47348 L .63195 .45591 L p F P
0 0 0 r
s
.83 .24 .1 r
.62816 .47335 m
.63857 .49788 L
s
1 .336 .137 r
.38272 .41057 m .37925 .42129 L .39526 .40888 L p F P
0 0 0 r
s
1 .336 .137 r
.39526 .40888 m .39838 .3995 L .38272 .41057 L p F P
0 0 0 r
s
.83 .24 .1 r
.39629 .42328 m
.40503 .39738 L
s
.226 .065 .035 r
.33507 .57433 m .33145 .58534 L .32672 .5683 L p F P
0 0 0 r
s
.226 .065 .035 r
.32672 .5683 m .3304 .5568 L .33507 .57433 L p F P
0 0 0 r
s
.24 .35 .67 r
.17625 .56262 m
.17964 .53933 L
s
.294 .087 .046 r
.34038 .60067 m .33693 .61076 L .3279 .59614 L p F P
0 0 0 r
s
.83 .24 .1 r
.32914 .62267 m
.3345 .60681 L
s
.294 .087 .046 r
.3279 .59614 m .33145 .58534 L .34038 .60067 L p F P
0 0 0 r
s
.83 .24 .1 r
.5621 .67484 m
.53858 .68725 L
s
.48987 .35691 m
.49605 .35701 L
s
1 .304 .122 r
.58896 .64744 m .59416 .6387 L .58346 .64632 L p F P
0 0 0 r
s
.83 .24 .1 r
.58616 .64928 m
.58743 .64713 L
s
1 .304 .122 r
.58346 .64632 m .57893 .65402 L .58896 .64744 L p F P
0 0 0 r
s
.263 .406 .804 r
.52701 .35521 m .53635 .3569 L .52442 .36312 L p F P
0 0 0 r
s
.263 .406 .804 r
.52442 .36312 m .51814 .36199 L .52701 .35521 L p F P
0 0 0 r
s
.24 .35 .67 r
.51172 .36221 m
.5519 .36942 L
s
.744 .218 .097 r
.59677 .38905 m .60059 .38114 L .62219 .3876 L p F P
0 0 0 r
s
.744 .218 .097 r
.62219 .3876 m .61739 .39715 L .59677 .38905 L p F P
0 0 0 r
s
.154 .045 .022 r
.33415 .54506 m .3304 .5568 L .32985 .53825 L p F P
0 0 0 r
s
.154 .045 .022 r
.32985 .53825 m .33361 .52627 L .33415 .54506 L p F P
0 0 0 r
s
.101 .114 .218 r
.51856 .64682 m .50206 .64449 L .50182 .65142 L p F P
0 0 0 r
s
.101 .114 .218 r
.50182 .65142 m .51647 .65347 L .51856 .64682 L p F P
0 0 0 r
s
.24 .35 .67 r
.50976 .64418 m
.54995 .64986 L
s
.578 .169 .078 r
.62442 .42922 m .62993 .41864 L .64432 .43289 L p F P
0 0 0 r
s
.578 .169 .078 r
.64432 .43289 m .63808 .44451 L .62442 .42922 L p F P
0 0 0 r
s
.83 .24 .1 r
.6126 .45035 m
.62578 .42498 L
s
.263 .406 .804 r
.51764 .35351 m .52701 .35521 L .51814 .36199 L p F P
0 0 0 r
s
.263 .406 .804 r
.51814 .36199 m .51184 .36086 L .51764 .35351 L p F P
0 0 0 r
s
1 .333 .138 r
.42446 .36705 m .42167 .37513 L .4401 .37302 L p F P
0 0 0 r
s
1 .333 .138 r
.4401 .37302 m .44232 .36684 L .42446 .36705 L p F P
0 0 0 r
s
.24 .35 .67 r
.34328 .60627 m
.38455 .61219 L
s
.81951 .40621 m
.80828 .40163 L
s
.80828 .40163 m
.76933 .39455 L
s
.143 .178 .333 r
.4113 .62137 m .39285 .61874 L .40148 .63027 L p F P
0 0 0 r
s
.143 .178 .333 r
.40148 .63027 m .41843 .63267 L .4113 .62137 L p F P
0 0 0 r
s
.667 .196 .088 r
.61267 .40656 m .61739 .39715 L .63553 .40788 L p F P
0 0 0 r
s
.667 .196 .088 r
.63553 .40788 m .62993 .41864 L .61267 .40656 L p F P
0 0 0 r
s
.83 .24 .1 r
.60528 .40408 m
.62578 .42498 L
s
1 .324 .136 r
.44908 .34794 m .44681 .3543 L .46428 .36138 L p F P
0 0 0 r
s
1 .324 .136 r
.46428 .36138 m .46587 .35714 L .44908 .34794 L p F P
0 0 0 r
s
.24 .35 .67 r
.38852 .34007 m
.38266 .35506 L
s
.38266 .35506 m
.34136 .34773 L
s
.26067 .57494 m
.21869 .56882 L
s
.26067 .57494 m
.25937 .59424 L
s
.263 .406 .804 r
.50824 .35181 m .51764 .35351 L .51184 .36086 L p F P
0 0 0 r
s
.263 .406 .804 r
.51184 .36086 m .50553 .35972 L .50824 .35181 L p F P
0 0 0 r
s
.83 .24 .1 r
.33178 .58434 m
.3327 .58749 L
s
.096 .028 .012 r
.63045 .56546 m .63726 .5539 L .63346 .57155 L p F P
0 0 0 r
s
.096 .028 .012 r
.63346 .57155 m .62689 .58262 L .63045 .56546 L p F P
0 0 0 r
s
.83 .24 .1 r
.62806 .57115 m
.62961 .54663 L
s
.81 .238 .105 r
.57985 .37149 m .58273 .36529 L .60838 .36502 L p F P
0 0 0 r
s
.81 .238 .105 r
.60838 .36502 m .60446 .37313 L .57985 .37149 L p F P
0 0 0 r
s
.083 .024 .01 r
.62043 .59347 m .62689 .58262 L .62015 .59813 L p F P
0 0 0 r
s
.083 .024 .01 r
.62015 .59813 m .6141 .60827 L .62043 .59347 L p F P
0 0 0 r
s
.83 .24 .1 r
.61484 .59358 m
.62806 .57115 L
s
.083 .024 .01 r
.33744 .51405 m .33361 .52627 L .33705 .50719 L p F P
0 0 0 r
s
.083 .024 .01 r
.33705 .50719 m .34084 .49503 L .33744 .51405 L p F P
0 0 0 r
s
.263 .406 .804 r
.49883 .35011 m .50824 .35181 L .50553 .35972 L p F P
0 0 0 r
s
.263 .406 .804 r
.50553 .35972 m .49921 .35859 L .49883 .35011 L p F P
0 0 0 r
s
.101 .114 .218 r
.50206 .64449 m .48548 .64214 L .48713 .64936 L p F P
0 0 0 r
s
.101 .114 .218 r
.48713 .64936 m .50182 .65142 L .50206 .64449 L p F P
0 0 0 r
s
.24 .35 .67 r
.25739 .33282 m
.25307 .35309 L
s
.25307 .35309 m
.211 .34574 L
s
.171 .049 .025 r
.6377 .53529 m .64467 .52326 L .6442 .5421 L p F P
0 0 0 r
s
.171 .049 .025 r
.6442 .5421 m .63726 .5539 L .6377 .53529 L p F P
0 0 0 r
s
.263 .406 .804 r
.48939 .3484 m .49883 .35011 L .49921 .35859 L p F P
0 0 0 r
s
.83 .24 .1 r
.49605 .35701 m
.49652 .3558 L
s
.263 .406 .804 r
.49921 .35859 m .49288 .35745 L .48939 .3484 L p F P
0 0 0 r
s
.143 .178 .333 r
.39285 .61874 m .3743 .61609 L .38445 .62787 L p F P
0 0 0 r
s
.143 .178 .333 r
.38445 .62787 m .40148 .63027 L .39285 .61874 L p F P
0 0 0 r
s
.24 .35 .67 r
.38455 .61219 m
.38653 .62674 L
s
.64988 .37286 m
.64062 .37522 L
s
.871 .26 .101 r
.60816 .61822 m .6141 .60827 L .60483 .62076 L p F P
0 0 0 r
s
.871 .26 .101 r
.60483 .62076 m .59945 .6298 L .60816 .61822 L p F P
0 0 0 r
s
.83 .24 .1 r
.47138 .71659 m
.48187 .69627 L
s
.47138 .71659 m
.44147 .71267 L
s
.24 .35 .67 r
.63675 .6704 m
.59673 .66478 L
s
.63675 .6704 m
.64594 .67373 L
s
.263 .406 .804 r
.47992 .34668 m .48939 .3484 L .49288 .35745 L p F P
0 0 0 r
s
.263 .406 .804 r
.49288 .35745 m .48654 .35631 L .47992 .34668 L p F P
0 0 0 r
s
.822 .24 .091 r
.34471 .48262 m .34084 .49503 L .34799 .47645 L p F P
0 0 0 r
s
.822 .24 .091 r
.34799 .47645 m .35175 .46441 L .34471 .48262 L p F P
0 0 0 r
s
1 .324 .136 r
.45138 .34152 m .44908 .34794 L .46587 .35714 L p F P
0 0 0 r
s
1 .324 .136 r
.46587 .35714 m .46746 .35288 L .45138 .34152 L p F P
0 0 0 r
s
.83 .24 .1 r
.45694 .38331 m
.46694 .35654 L
s
.46694 .35654 m
.47767 .35671 L
s
1 .338 .139 r
.40477 .38033 m .40155 .38998 L .41892 .38311 L p F P
0 0 0 r
s
1 .338 .139 r
.41892 .38311 m .42167 .37513 L .40477 .38033 L p F P
0 0 0 r
s
.231 .067 .035 r
.64167 .50419 m .64861 .49197 L .65179 .51097 L p F P
0 0 0 r
s
.231 .067 .035 r
.65179 .51097 m .64467 .52326 L .64167 .50419 L p F P
0 0 0 r
s
.83 .24 .1 r
.63857 .49788 m
.64325 .52303 L
s
.101 .114 .218 r
.48548 .64214 m .46883 .63979 L .47237 .64728 L p F P
0 0 0 r
s
.101 .114 .218 r
.47237 .64728 m .48713 .64936 L .48548 .64214 L p F P
0 0 0 r
s
.83 .24 .1 r
.38507 .68853 m
.36146 .66954 L
s
.36146 .66954 m
.36967 .64822 L
s
.263 .406 .804 r
.47043 .34497 m .47992 .34668 L .48654 .35631 L p F P
0 0 0 r
s
.263 .406 .804 r
.48654 .35631 m .48019 .35517 L .47043 .34497 L p F P
0 0 0 r
s
1 .333 .138 r
.42728 .35887 m .42446 .36705 L .44232 .36684 L p F P
0 0 0 r
s
1 .333 .138 r
.44232 .36684 m .44455 .3606 L .42728 .35887 L p F P
0 0 0 r
s
.83 .24 .1 r
.42974 .38792 m
.43927 .36102 L
s
.263 .406 .804 r
.46092 .34324 m .47043 .34497 L .48019 .35517 L p F P
0 0 0 r
s
.263 .406 .804 r
.48019 .35517 m .47383 .35402 L .46092 .34324 L p F P
0 0 0 r
s
.24 .35 .67 r
.46844 .36032 m
.47111 .35491 L
s
.47111 .35491 m
.51172 .36221 L
s
.997 .292 .115 r
.35559 .45213 m .35175 .46441 L .36224 .44736 L p F P
0 0 0 r
s
.83 .24 .1 r
.35122 .48035 m
.35907 .45555 L
s
.997 .292 .115 r
.36224 .44736 m .3659 .4358 L .35559 .45213 L p F P
0 0 0 r
s
.83 .24 .1 r
.35907 .45555 m
.37545 .43735 L
s
.143 .178 .333 r
.3743 .61609 m .35566 .61343 L .36734 .62545 L p F P
0 0 0 r
s
.143 .178 .333 r
.36734 .62545 m .38445 .62787 L .3743 .61609 L p F P
0 0 0 r
s
.744 .218 .097 r
.60059 .38114 m .60446 .37313 L .62705 .3779 L p F P
0 0 0 r
s
.24 .35 .67 r
.60644 .36903 m
.64062 .37522 L
s
.744 .218 .097 r
.62705 .3779 m .62219 .3876 L .60059 .38114 L p F P
0 0 0 r
s
.24 .35 .67 r
.33869 .60561 m
.34328 .60627 L
s
.77989 .39903 m
.76933 .39455 L
s
.76933 .39455 m
.72996 .3874 L
s
.76548 .69047 m
.72608 .68495 L
s
.76548 .69047 m
.77788 .68765 L
s
1 .336 .137 r
.38624 .39967 m .38272 .41057 L .39838 .3995 L p F P
0 0 0 r
s
1 .336 .137 r
.39838 .3995 m .40155 .38998 L .38624 .39967 L p F P
0 0 0 r
s
.224 .356 .712 r
.59632 .36283 m .60838 .36502 L .58273 .36529 L p F P
0 0 0 r
s
.224 .356 .712 r
.58273 .36529 m .5735 .36362 L .59632 .36283 L p F P
0 0 0 r
s
.83 .24 .1 r
.58111 .38628 m
.5912 .36482 L
s
.34 .098 .05 r
.64192 .47348 m .64861 .46138 L .65569 .47949 L p F P
0 0 0 r
s
.34 .098 .05 r
.65569 .47949 m .64861 .49197 L .64192 .47348 L p F P
0 0 0 r
s
.263 .406 .804 r
.45138 .34152 m .46092 .34324 L .47383 .35402 L p F P
0 0 0 r
s
.263 .406 .804 r
.47383 .35402 m .46746 .35288 L .45138 .34152 L p F P
0 0 0 r
s
.83 .24 .1 r
.46694 .35654 m
.46872 .35178 L
s
.24 .35 .67 r
.34654 .33253 m
.34136 .34773 L
s
.34136 .34773 m
.29961 .34031 L
s
1 .323 .129 r
.36963 .42402 m .3659 .4358 L .37925 .42129 L p F P
0 0 0 r
s
1 .323 .129 r
.37925 .42129 m .38272 .41057 L .36963 .42402 L p F P
0 0 0 r
s
.24 .35 .67 r
.21869 .56882 m
.17625 .56262 L
s
.21869 .56882 m
.21671 .58812 L
s
.101 .114 .218 r
.46883 .63979 m .45211 .63743 L .45755 .64521 L p F P
0 0 0 r
s
.24 .35 .67 r
.46575 .62383 m
.46913 .63843 L
s
.101 .114 .218 r
.45755 .64521 m .47237 .64728 L .46883 .63979 L p F P
0 0 0 r
s
.24 .35 .67 r
.46913 .63843 m
.50976 .64418 L
s
.46401 .35363 m
.47111 .35491 L
s
.074 .086 .165 r
.57446 .66161 m .56004 .65959 L .55074 .66172 L p F P
0 0 0 r
s
.074 .086 .165 r
.55074 .66172 m .56294 .66343 L .57446 .66161 L p F P
0 0 0 r
s
1 .327 .133 r
.57446 .66161 m .57893 .65402 L .56665 .65703 L p F P
0 0 0 r
s
1 .327 .133 r
.56665 .65703 m .56294 .66343 L .57446 .66161 L p F P
0 0 0 r
s
.83 .24 .1 r
.5621 .67484 m
.56927 .66257 L
s
.56927 .66257 m
.56936 .66242 L
s
.224 .356 .712 r
.58423 .36064 m .59632 .36283 L .5735 .36362 L p F P
0 0 0 r
s
.83 .24 .1 r
.59246 .36213 m
.59378 .35932 L
s
.224 .356 .712 r
.5735 .36362 m .56425 .36194 L .58423 .36064 L p F P
0 0 0 r
s
.83 .24 .1 r
.44147 .71267 m
.45138 .69219 L
s
.44147 .71267 m
.4122 .70317 L
s
1 .304 .122 r
.59416 .6387 m .59945 .6298 L .58807 .6385 L p F P
0 0 0 r
s
.83 .24 .1 r
.59697 .6317 m
.60714 .61646 L
s
.59118 .64082 m
.59247 .63864 L
s
1 .304 .122 r
.58807 .6385 m .58346 .64632 L .59416 .6387 L p F P
0 0 0 r
s
.24 .35 .67 r
.211 .34574 m
.2147 .32524 L
s
.471 .137 .065 r
.63808 .44451 m .64432 .43289 L .65544 .44904 L p F P
0 0 0 r
s
.471 .137 .065 r
.65544 .44904 m .64861 .46138 L .63808 .44451 L p F P
0 0 0 r
s
.83 .24 .1 r
.62816 .47335 m
.64176 .44825 L
s
.667 .196 .088 r
.61739 .39715 m .62219 .3876 L .64122 .39693 L p F P
0 0 0 r
s
.667 .196 .088 r
.64122 .39693 m .63553 .40788 L .61739 .39715 L p F P
0 0 0 r
s
.143 .178 .333 r
.35566 .61343 m .33693 .61076 L .35015 .62302 L p F P
0 0 0 r
s
.143 .178 .333 r
.35015 .62302 m .36734 .62545 L .35566 .61343 L p F P
0 0 0 r
s
.83 .24 .1 r
.4122 .70317 m
.38507 .68853 L
s
.38507 .68853 m
.39381 .66753 L
s
.578 .169 .078 r
.62993 .41864 m .63553 .40788 L .65068 .42106 L p F P
0 0 0 r
s
.578 .169 .078 r
.65068 .42106 m .64432 .43289 L .62993 .41864 L p F P
0 0 0 r
s
.83 .24 .1 r
.62578 .42498 m
.64176 .44825 L
s
.224 .356 .712 r
.5721 .35843 m .58423 .36064 L .56425 .36194 L p F P
0 0 0 r
s
.224 .356 .712 r
.56425 .36194 m .55497 .36027 L .5721 .35843 L p F P
0 0 0 r
s
.24 .35 .67 r
.5519 .36942 m
.5602 .36066 L
s
.5602 .36066 m
.59255 .36652 L
s
.101 .114 .218 r
.45211 .63743 m .43531 .63505 L .44268 .64312 L p F P
0 0 0 r
s
.101 .114 .218 r
.44268 .64312 m .45755 .64521 L .45211 .63743 L p F P
0 0 0 r
s
.074 .086 .165 r
.56004 .65959 m .54558 .65756 L .5385 .66001 L p F P
0 0 0 r
s
.24 .35 .67 r
.54995 .64986 m
.55627 .65911 L
s
.074 .086 .165 r
.5385 .66001 m .55074 .66172 L .56004 .65959 L p F P
0 0 0 r
s
.294 .087 .046 r
.34389 .59039 m .34038 .60067 L .33145 .58534 L p F P
0 0 0 r
s
.24 .35 .67 r
.30155 .60029 m
.33392 .60493 L
s
.294 .087 .046 r
.33145 .58534 m .33507 .57433 L .34389 .59039 L p F P
0 0 0 r
s
.226 .065 .035 r
.33876 .56309 m .33507 .57433 L .3304 .5568 L p F P
0 0 0 r
s
.226 .065 .035 r
.3304 .5568 m .33415 .54506 L .33876 .56309 L p F P
0 0 0 r
s
.24 .35 .67 r
.57305 .66146 m
.59673 .66478 L
s
.57175 .66128 m
.57305 .66146 L
s
.55627 .65911 m
.56475 .6603 L
s
.59673 .66478 m
.6052 .66802 L
s
.83 .24 .1 r
.4122 .70317 m
.42152 .68245 L
s
.53858 .68725 m
.55055 .6662 L
s
.53858 .68725 m
.51142 .69456 L
s
1 .333 .138 r
.43013 .35058 m .42728 .35887 L .44455 .3606 L p F P
0 0 0 r
s
.24 .35 .67 r
.42351 .36231 m
.43004 .34753 L
s
1 .333 .138 r
.44455 .3606 m .44681 .3543 L .43013 .35058 L p F P
0 0 0 r
s
.83 .24 .1 r
.43927 .36102 m
.46694 .35654 L
s
.24 .35 .67 r
.43004 .34753 m
.44807 .35077 L
s
.224 .356 .712 r
.55993 .35622 m .5721 .35843 L .55497 .36027 L p F P
0 0 0 r
s
.83 .24 .1 r
.56118 .35645 m
.56629 .34496 L
s
.224 .356 .712 r
.55497 .36027 m .54567 .35858 L .55993 .35622 L p F P
0 0 0 r
s
.154 .045 .022 r
.33797 .53307 m .33415 .54506 L .33361 .52627 L p F P
0 0 0 r
s
.154 .045 .022 r
.33361 .52627 m .33744 .51405 L .33797 .53307 L p F P
0 0 0 r
s
.83 .24 .1 r
.33748 .5153 m
.34028 .50189 L
s
1 .338 .139 r
.40803 .37053 m .40477 .38033 L .42167 .37513 L p F P
0 0 0 r
s
1 .338 .139 r
.42167 .37513 m .42446 .36705 L .40803 .37053 L p F P
0 0 0 r
s
.433 .13 .063 r
.35343 .61386 m .35015 .62302 L .33693 .61076 L p F P
0 0 0 r
s
.24 .35 .67 r
.34412 .61599 m
.34453 .6208 L
s
.433 .13 .063 r
.33693 .61076 m .34038 .60067 L .35343 .61386 L p F P
0 0 0 r
s
.83 .24 .1 r
.3476 .62065 m
.3503 .62554 L
s
.074 .086 .165 r
.54558 .65756 m .53105 .65552 L .52622 .65829 L p F P
0 0 0 r
s
.074 .086 .165 r
.52622 .65829 m .5385 .66001 L .54558 .65756 L p F P
0 0 0 r
s
.101 .114 .218 r
.43531 .63505 m .41843 .63267 L .42774 .64102 L p F P
0 0 0 r
s
.101 .114 .218 r
.42774 .64102 m .44268 .64312 L .43531 .63505 L p F P
0 0 0 r
s
.24 .35 .67 r
.42806 .63262 m
.46913 .63843 L
s
.224 .356 .712 r
.54772 .354 m .55993 .35622 L .54567 .35858 L p F P
0 0 0 r
s
.224 .356 .712 r
.54567 .35858 m .53635 .3569 L .54772 .354 L p F P
0 0 0 r
s
.24 .35 .67 r
.30155 .60029 m
.25937 .59424 L
s
.30155 .60029 m
.30206 .61479 L
s
.73982 .39177 m
.72996 .3874 L
s
.72996 .3874 m
.69014 .38017 L
s
.083 .024 .01 r
.62689 .58262 m .63346 .57155 L .62631 .5878 L p F P
0 0 0 r
s
.083 .024 .01 r
.62631 .5878 m .62015 .59813 L .62689 .58262 L p F P
0 0 0 r
s
.83 .24 .1 r
.62036 .59422 m
.62806 .57115 L
s
.096 .028 .012 r
.63726 .5539 m .6442 .5421 L .64018 .56026 L p F P
0 0 0 r
s
.83 .24 .1 r
.62961 .54663 m
.64325 .52303 L
s
.096 .028 .012 r
.64018 .56026 m .63346 .57155 L .63726 .5539 L p F P
0 0 0 r
s
.24 .35 .67 r
.72608 .68495 m
.68623 .67937 L
s
.72608 .68495 m
.7378 .68201 L
s
.30408 .3249 m
.29961 .34031 L
s
.29961 .34031 m
.25739 .33282 L
s
.744 .218 .097 r
.60446 .37313 m .60838 .36502 L .63199 .36807 L p F P
0 0 0 r
s
.744 .218 .097 r
.63199 .36807 m .62705 .3779 L .60446 .37313 L p F P
0 0 0 r
s
.83 .24 .1 r
.60528 .40408 m
.6185 .37739 L
s
.083 .024 .01 r
.34136 .50157 m .33744 .51405 L .34084 .49503 L p F P
0 0 0 r
s
.083 .024 .01 r
.34084 .49503 m .34471 .48262 L .34136 .50157 L p F P
0 0 0 r
s
.24 .35 .67 r
.17357 .58194 m
.17625 .56262 L
s
.43004 .34753 m
.38852 .34007 L
s
.224 .356 .712 r
.53546 .35178 m .54772 .354 L .53635 .3569 L p F P
0 0 0 r
s
.224 .356 .712 r
.53635 .3569 m .52701 .35521 L .53546 .35178 L p F P
0 0 0 r
s
.871 .26 .101 r
.6141 .60827 m .62015 .59813 L .6103 .61156 L p F P
0 0 0 r
s
.871 .26 .101 r
.6103 .61156 m .60483 .62076 L .6141 .60827 L p F P
0 0 0 r
s
.83 .24 .1 r
.60714 .61646 m
.62036 .59422 L
s
.171 .049 .025 r
.64467 .52326 m .65179 .51097 L .65129 .53005 L p F P
0 0 0 r
s
.171 .049 .025 r
.65129 .53005 m .6442 .5421 L .64467 .52326 L p F P
0 0 0 r
s
.074 .086 .165 r
.53105 .65552 m .51647 .65347 L .5139 .65657 L p F P
0 0 0 r
s
.074 .086 .165 r
.5139 .65657 m .52622 .65829 L .53105 .65552 L p F P
0 0 0 r
s
.101 .114 .218 r
.41843 .63267 m .40148 .63027 L .41275 .63892 L p F P
0 0 0 r
s
.101 .114 .218 r
.41275 .63892 m .42774 .64102 L .41843 .63267 L p F P
0 0 0 r
s
1 .336 .137 r
.38983 .38858 m .38624 .39967 L .40155 .38998 L p F P
0 0 0 r
s
1 .336 .137 r
.40155 .38998 m .40477 .38033 L .38983 .38858 L p F P
0 0 0 r
s
.822 .24 .091 r
.34866 .46994 m .34471 .48262 L .35175 .46441 L p F P
0 0 0 r
s
.83 .24 .1 r
.34263 .49439 m
.348 .47723 L
s
.822 .24 .091 r
.35175 .46441 m .35559 .45213 L .34866 .46994 L p F P
0 0 0 r
s
.83 .24 .1 r
.348 .47723 m
.35907 .45555 L
s
.224 .356 .712 r
.52317 .34955 m .53546 .35178 L .52701 .35521 L p F P
0 0 0 r
s
.83 .24 .1 r
.5303 .35084 m
.53701 .33483 L
s
.224 .356 .712 r
.52701 .35521 m .51764 .35351 L .52317 .34955 L p F P
0 0 0 r
s
.83 .24 .1 r
.53701 .33483 m
.56629 .34496 L
s
.56629 .34496 m
.5789 .31658 L
s
.56629 .34496 m
.59378 .35932 L
s
1 .327 .133 r
.57893 .65402 m .58346 .64632 L .5704 .65055 L p F P
0 0 0 r
s
.83 .24 .1 r
.58245 .64665 m
.58416 .64514 L
s
1 .327 .133 r
.5704 .65055 m .56665 .65703 L .57893 .65402 L p F P
0 0 0 r
s
1 .333 .138 r
.43302 .3422 m .43013 .35058 L .44681 .3543 L p F P
0 0 0 r
s
.24 .35 .67 r
.43004 .34753 m
.43244 .3439 L
s
1 .333 .138 r
.44681 .3543 m .44908 .34794 L .43302 .3422 L p F P
0 0 0 r
s
.231 .067 .035 r
.64861 .49197 m .65569 .47949 L .65906 .49843 L p F P
0 0 0 r
s
.231 .067 .035 r
.65906 .49843 m .65179 .51097 L .64861 .49197 L p F P
0 0 0 r
s
.997 .292 .115 r
.35951 .43961 m .35559 .45213 L .3659 .4358 L p F P
0 0 0 r
s
.997 .292 .115 r
.3659 .4358 m .36963 .42402 L .35951 .43961 L p F P
0 0 0 r
s
1 .323 .129 r
.37343 .41202 m .36963 .42402 L .38272 .41057 L p F P
0 0 0 r
s
1 .323 .129 r
.38272 .41057 m .38624 .39967 L .37343 .41202 L p F P
0 0 0 r
s
.83 .24 .1 r
.37545 .43735 m
.38387 .41145 L
s
.38387 .41145 m
.40503 .39738 L
s
.074 .086 .165 r
.51647 .65347 m .50182 .65142 L .50154 .65484 L p F P
0 0 0 r
s
.24 .35 .67 r
.50976 .64418 m
.51536 .65336 L
s
.074 .086 .165 r
.50154 .65484 m .5139 .65657 L .51647 .65347 L p F P
0 0 0 r
s
.24 .35 .67 r
.51536 .65336 m
.55627 .65911 L
s
.224 .356 .712 r
.51083 .34731 m .52317 .34955 L .51764 .35351 L p F P
0 0 0 r
s
.24 .35 .67 r
.51933 .35326 m
.5602 .36066 L
s
.224 .356 .712 r
.51764 .35351 m .50824 .35181 L .51083 .34731 L p F P
0 0 0 r
s
.24 .35 .67 r
.51172 .36221 m
.51933 .35326 L
s
.667 .196 .088 r
.62219 .3876 m .62705 .3779 L .64701 .3858 L p F P
0 0 0 r
s
.667 .196 .088 r
.64701 .3858 m .64122 .39693 L .62219 .3876 L p F P
0 0 0 r
s
.83 .24 .1 r
.59378 .35932 m
.60699 .33121 L
s
.59378 .35932 m
.59935 .36338 L
s
.101 .114 .218 r
.40148 .63027 m .38445 .62787 L .39769 .6368 L p F P
0 0 0 r
s
.101 .114 .218 r
.39769 .6368 m .41275 .63892 L .40148 .63027 L p F P
0 0 0 r
s
.83 .24 .1 r
.50701 .32931 m
.53701 .33483 L
s
.53701 .33483 m
.54902 .30619 L
s
.34 .098 .05 r
.64861 .46138 m .65544 .44904 L .66292 .46675 L p F P
0 0 0 r
s
.34 .098 .05 r
.66292 .46675 m .65569 .47949 L .64861 .46138 L p F P
0 0 0 r
s
.83 .24 .1 r
.63857 .49788 m
.65252 .47305 L
s
1 .304 .122 r
.59945 .6298 m .60483 .62076 L .59274 .63057 L p F P
0 0 0 r
s
.83 .24 .1 r
.59627 .63223 m
.59759 .63001 L
s
1 .304 .122 r
.59274 .63057 m .58807 .6385 L .59945 .6298 L p F P
0 0 0 r
s
.224 .356 .712 r
.49846 .34506 m .51083 .34731 L .50824 .35181 L p F P
0 0 0 r
s
.83 .24 .1 r
.49878 .3501 m
.50028 .34631 L
s
.224 .356 .712 r
.50824 .35181 m .49883 .35011 L .49846 .34506 L p F P
0 0 0 r
s
.83 .24 .1 r
.50062 .34545 m
.50701 .32931 L
s
1 .338 .139 r
.41135 .36058 m .40803 .37053 L .42446 .36705 L p F P
0 0 0 r
s
1 .338 .139 r
.42446 .36705 m .42728 .35887 L .41135 .36058 L p F P
0 0 0 r
s
.83 .24 .1 r
.41415 .3704 m
.43927 .36102 L
s
.24 .35 .67 r
.25937 .59424 m
.21671 .58812 L
s
.25937 .59424 m
.25912 .60871 L
s
.074 .086 .165 r
.50182 .65142 m .48713 .64936 L .48914 .6531 L p F P
0 0 0 r
s
.074 .086 .165 r
.48914 .6531 m .50154 .65484 L .50182 .65142 L p F P
0 0 0 r
s
.24 .35 .67 r
.69929 .38442 m
.69014 .38017 L
s
.69014 .38017 m
.64988 .37286 L
s
.578 .169 .078 r
.63553 .40788 m .64122 .39693 L .65716 .40901 L p F P
0 0 0 r
s
.578 .169 .078 r
.65716 .40901 m .65068 .42106 L .63553 .40788 L p F P
0 0 0 r
s
.83 .24 .1 r
.62578 .42498 m
.6395 .39856 L
s
.471 .137 .065 r
.64432 .43289 m .65068 .42106 L .66241 .43645 L p F P
0 0 0 r
s
.471 .137 .065 r
.66241 .43645 m .65544 .44904 L .64432 .43289 L p F P
0 0 0 r
s
.83 .24 .1 r
.64176 .44825 m
.65252 .47305 L
s
.24 .35 .67 r
.68623 .67937 m
.64594 .67373 L
s
.68623 .67937 m
.69727 .6763 L
s
.26115 .31719 m
.25739 .33282 L
s
.25739 .33282 m
.2147 .32524 L
s
.224 .356 .712 r
.48604 .3428 m .49846 .34506 L .49883 .35011 L p F P
0 0 0 r
s
.224 .356 .712 r
.49883 .35011 m .48939 .3484 L .48604 .3428 L p F P
0 0 0 r
s
.83 .24 .1 r
.51142 .69456 m
.52292 .67348 L
s
.51142 .69456 m
.48187 .69627 L
s
.157 .263 .533 r
.61735 .36541 m .63199 .36807 L .60838 .36502 L p F P
0 0 0 r
s
.24 .35 .67 r
.60304 .36727 m
.60917 .36547 L
s
.157 .263 .533 r
.60838 .36502 m .59632 .36283 L .61735 .36541 L p F P
0 0 0 r
s
.83 .24 .1 r
.60084 .36448 m
.6185 .37739 L
s
.101 .114 .218 r
.38445 .62787 m .36734 .62545 L .38257 .63468 L p F P
0 0 0 r
s
.101 .114 .218 r
.38257 .63468 m .39769 .6368 L .38445 .62787 L p F P
0 0 0 r
s
.24 .35 .67 r
.38653 .62674 m
.42806 .63262 L
s
.39391 .33056 m
.38852 .34007 L
s
.38852 .34007 m
.34654 .33253 L
s
.34453 .6208 m
.34989 .62156 L
s
.224 .356 .712 r
.47358 .34054 m .48604 .3428 L .48939 .3484 L p F P
0 0 0 r
s
.224 .356 .712 r
.48939 .3484 m .47992 .34668 L .47358 .34054 L p F P
0 0 0 r
s
.074 .086 .165 r
.48713 .64936 m .47237 .64728 L .47669 .65136 L p F P
0 0 0 r
s
.074 .086 .165 r
.47669 .65136 m .48914 .6531 L .48713 .64936 L p F P
0 0 0 r
s
.294 .087 .046 r
.34747 .57991 m .34389 .59039 L .33507 .57433 L p F P
0 0 0 r
s
.294 .087 .046 r
.33507 .57433 m .33876 .56309 L .34747 .57991 L p F P
0 0 0 r
s
.83 .24 .1 r
.6185 .37739 m
.62369 .36691 L
s
.24 .35 .67 r
.82941 .41731 m
.81951 .40621 L
s
.81951 .40621 m
.77989 .39903 L
s
1 .333 .138 r
.43595 .3337 m .43302 .3422 L .44908 .34794 L p F P
0 0 0 r
s
1 .333 .138 r
.44908 .34794 m .45138 .34152 L .43595 .3337 L p F P
0 0 0 r
s
.226 .065 .035 r
.34253 .55162 m .33876 .56309 L .33415 .54506 L p F P
0 0 0 r
s
.226 .065 .035 r
.33415 .54506 m .33797 .53307 L .34253 .55162 L p F P
0 0 0 r
s
.157 .263 .533 r
.60266 .36273 m .61735 .36541 L .59632 .36283 L p F P
0 0 0 r
s
.157 .263 .533 r
.59632 .36283 m .58423 .36064 L .60266 .36273 L p F P
0 0 0 r
s
.433 .13 .063 r
.35676 .60454 m .35343 .61386 L .34038 .60067 L p F P
0 0 0 r
s
.433 .13 .063 r
.34038 .60067 m .34389 .59039 L .35676 .60454 L p F P
0 0 0 r
s
.83 .24 .1 r
.47737 .32866 m
.50701 .32931 L
s
.50701 .32931 m
.51843 .30044 L
s
.224 .356 .712 r
.46108 .33827 m .47358 .34054 L .47992 .34668 L p F P
0 0 0 r
s
.83 .24 .1 r
.47122 .34511 m
.47196 .34313 L
s
.224 .356 .712 r
.47992 .34668 m .47043 .34497 L .46108 .33827 L p F P
0 0 0 r
s
.83 .24 .1 r
.47297 .34043 m
.47737 .32866 L
s
.24 .35 .67 r
.47111 .35491 m
.47799 .34578 L
s
.47799 .34578 m
.51933 .35326 L
s
.101 .114 .218 r
.36734 .62545 m .35015 .62302 L .3674 .63255 L p F P
0 0 0 r
s
.83 .24 .1 r
.3503 .62554 m
.35103 .6235 L
s
.101 .114 .218 r
.3674 .63255 m .38257 .63468 L .36734 .62545 L p F P
0 0 0 r
s
.154 .045 .022 r
.34188 .52083 m .33797 .53307 L .33744 .51405 L p F P
0 0 0 r
s
.154 .045 .022 r
.33744 .51405 m .34136 .50157 L .34188 .52083 L p F P
0 0 0 r
s
.074 .086 .165 r
.47237 .64728 m .45755 .64521 L .4642 .64961 L p F P
0 0 0 r
s
.074 .086 .165 r
.4642 .64961 m .47669 .65136 L .47237 .64728 L p F P
0 0 0 r
s
.24 .35 .67 r
.46913 .63843 m
.47399 .64756 L
s
.47399 .64756 m
.51536 .65336 L
s
1 .336 .137 r
.39349 .3773 m .38983 .38858 L .40477 .38033 L p F P
0 0 0 r
s
1 .336 .137 r
.40477 .38033 m .40803 .37053 L .39349 .3773 L p F P
0 0 0 r
s
.83 .24 .1 r
.40503 .39738 m
.41415 .3704 L
s
.157 .263 .533 r
.5879 .36005 m .60266 .36273 L .58423 .36064 L p F P
0 0 0 r
s
.157 .263 .533 r
.58423 .36064 m .5721 .35843 L .5879 .36005 L p F P
0 0 0 r
s
.224 .356 .712 r
.44854 .33599 m .46108 .33827 L .47043 .34497 L p F P
0 0 0 r
s
.224 .356 .712 r
.47043 .34497 m .46092 .34324 L .44854 .33599 L p F P
0 0 0 r
s
.083 .024 .01 r
.63346 .57155 m .64018 .56026 L .63259 .57727 L p F P
0 0 0 r
s
.083 .024 .01 r
.63259 .57727 m .62631 .5878 L .63346 .57155 L p F P
0 0 0 r
s
.83 .24 .1 r
.33937 .56124 m
.34151 .56839 L
s
1 .327 .133 r
.58346 .64632 m .58807 .6385 L .57419 .64399 L p F P
0 0 0 r
s
1 .327 .133 r
.57419 .64399 m .5704 .65055 L .58346 .64632 L p F P
0 0 0 r
s
.096 .028 .012 r
.6442 .5421 m .65129 .53005 L .64703 .54874 L p F P
0 0 0 r
s
.096 .028 .012 r
.64703 .54874 m .64018 .56026 L .6442 .5421 L p F P
0 0 0 r
s
.83 .24 .1 r
.62806 .57115 m
.64184 .54777 L
s
.64184 .54777 m
.64325 .52303 L
s
.871 .26 .101 r
.62015 .59813 m .62631 .5878 L .61587 .6022 L p F P
0 0 0 r
s
.871 .26 .101 r
.61587 .6022 m .6103 .61156 L .62015 .59813 L p F P
0 0 0 r
s
.083 .024 .01 r
.34536 .48882 m .34136 .50157 L .34471 .48262 L p F P
0 0 0 r
s
.083 .024 .01 r
.34471 .48262 m .34866 .46994 L .34536 .48882 L p F P
0 0 0 r
s
.24 .35 .67 r
.21671 .58812 m
.17357 .58194 L
s
.21671 .58812 m
.21568 .60257 L
s
.60917 .36547 m
.62476 .3683 L
s
.564 .169 .078 r
.37043 .62452 m .3674 .63255 L .35015 .62302 L p F P
0 0 0 r
s
.83 .24 .1 r
.3503 .62554 m
.36967 .64822 L
s
.564 .169 .078 r
.35015 .62302 m .35343 .61386 L .37043 .62452 L p F P
0 0 0 r
s
.24 .35 .67 r
.3703 .62444 m
.38653 .62674 L
s
1 .338 .139 r
.41471 .35048 m .41135 .36058 L .42728 .35887 L p F P
0 0 0 r
s
1 .338 .139 r
.42728 .35887 m .43013 .35058 L .41471 .35048 L p F P
0 0 0 r
s
.224 .356 .712 r
.43595 .3337 m .44854 .33599 L .46092 .34324 L p F P
0 0 0 r
s
.224 .356 .712 r
.46092 .34324 m .45138 .34152 L .43595 .3337 L p F P
0 0 0 r
s
.83 .24 .1 r
.43927 .36102 m
.44718 .33872 L
s
.44817 .33592 m
.4492 .33299 L
s
.24 .35 .67 r
.64594 .67373 m
.6052 .66802 L
s
.64594 .67373 m
.65627 .67053 L
s
.667 .196 .088 r
.62705 .3779 m .63199 .36807 L .6529 .37447 L p F P
0 0 0 r
s
.24 .35 .67 r
.64439 .37186 m
.64988 .37286 L
s
.667 .196 .088 r
.6529 .37447 m .64701 .3858 L .62705 .3779 L p F P
0 0 0 r
s
.83 .24 .1 r
.6185 .37739 m
.6395 .39856 L
s
.074 .086 .165 r
.45755 .64521 m .44268 .64312 L .45167 .64786 L p F P
0 0 0 r
s
.074 .086 .165 r
.45167 .64786 m .4642 .64961 L .45755 .64521 L p F P
0 0 0 r
s
.24 .35 .67 r
.2147 .32524 m
.21773 .30939 L
s
.157 .263 .533 r
.57309 .35736 m .5879 .36005 L .5721 .35843 L p F P
0 0 0 r
s
.157 .263 .533 r
.5721 .35843 m .55993 .35622 L .57309 .35736 L p F P
0 0 0 r
s
.24 .35 .67 r
.5602 .36066 m
.56801 .35799 L
s
.171 .049 .025 r
.65179 .51097 m .65906 .49843 L .65853 .51775 L p F P
0 0 0 r
s
.171 .049 .025 r
.65853 .51775 m .65129 .53005 L .65179 .51097 L p F P
0 0 0 r
s
1 .323 .129 r
.37731 .3998 m .37343 .41202 L .38624 .39967 L p F P
0 0 0 r
s
1 .323 .129 r
.38624 .39967 m .38983 .38858 L .37731 .3998 L p F P
0 0 0 r
s
.24 .35 .67 r
.35116 .32282 m
.34654 .33253 L
s
.34654 .33253 m
.30408 .3249 L
s
.30206 .61479 m
.34453 .6208 L
s
.34453 .6208 m
.34705 .62974 L
s
.822 .24 .091 r
.35269 .45699 m .34866 .46994 L .35559 .45213 L p F P
0 0 0 r
s
.822 .24 .091 r
.35559 .45213 m .35951 .43961 L .35269 .45699 L p F P
0 0 0 r
s
.148 .248 .501 r
.56294 .66343 m .55074 .66172 L .53986 .6599 L p F P
0 0 0 r
s
.148 .248 .501 r
.53986 .6599 m .54947 .66124 L .56294 .66343 L p F P
0 0 0 r
s
1 .333 .137 r
.56294 .66343 m .56665 .65703 L .55231 .65621 L p F P
0 0 0 r
s
.24 .35 .67 r
.55627 .65911 m
.55703 .65942 L
s
1 .333 .137 r
.55231 .65621 m .54947 .66124 L .56294 .66343 L p F P
0 0 0 r
s
.24 .35 .67 r
.56209 .66148 m
.56399 .66225 L
s
.56175 .66134 m
.56209 .66148 L
s
.83 .24 .1 r
.55638 .66316 m
.55744 .66261 L
s
.55055 .6662 m
.55638 .66316 L
s
.997 .292 .115 r
.36351 .42683 m .35951 .43961 L .36963 .42402 L p F P
0 0 0 r
s
.83 .24 .1 r
.35907 .45555 m
.36724 .4297 L
s
.997 .292 .115 r
.36963 .42402 m .37343 .41202 L .36351 .42683 L p F P
0 0 0 r
s
.83 .24 .1 r
.36724 .4297 m
.38387 .41145 L
s
.48187 .69627 m
.49281 .67509 L
s
.48187 .69627 m
.45138 .69219 L
s
.157 .263 .533 r
.55822 .35465 m .57309 .35736 L .55993 .35622 L p F P
0 0 0 r
s
.157 .263 .533 r
.55993 .35622 m .54772 .354 L .55822 .35465 L p F P
0 0 0 r
s
1 .304 .122 r
.60483 .62076 m .6103 .61156 L .59749 .62251 L p F P
0 0 0 r
s
.83 .24 .1 r
.60675 .6146 m
.62036 .59422 L
s
.60145 .6235 m
.60279 .62124 L
s
1 .304 .122 r
.59749 .62251 m .59274 .63057 L .60483 .62076 L p F P
0 0 0 r
s
.24 .35 .67 r
.78912 .41007 m
.77989 .39903 L
s
.77989 .39903 m
.73982 .39177 L
s
.77788 .68765 m
.7378 .68201 L
s
.77788 .68765 m
.79089 .67818 L
s
.074 .086 .165 r
.44268 .64312 m .42774 .64102 L .4391 .6461 L p F P
0 0 0 r
s
.074 .086 .165 r
.4391 .6461 m .45167 .64786 L .44268 .64312 L p F P
0 0 0 r
s
.231 .067 .035 r
.65569 .47949 m .66292 .46675 L .66649 .48561 L p F P
0 0 0 r
s
.231 .067 .035 r
.66649 .48561 m .65906 .49843 L .65569 .47949 L p F P
0 0 0 r
s
.83 .24 .1 r
.65252 .47305 m
.65747 .49844 L
s
.39381 .66753 m
.36967 .64822 L
s
.578 .169 .078 r
.64122 .39693 m .64701 .3858 L .66377 .39672 L p F P
0 0 0 r
s
.578 .169 .078 r
.66377 .39672 m .65716 .40901 L .64122 .39693 L p F P
0 0 0 r
s
.24 .35 .67 r
.44462 .33974 m
.47799 .34578 L
s
.148 .248 .501 r
.55074 .66172 m .5385 .66001 L .53024 .65855 L p F P
0 0 0 r
s
.148 .248 .501 r
.53024 .65855 m .53986 .6599 L .55074 .66172 L p F P
0 0 0 r
s
.34 .098 .05 r
.65544 .44904 m .66241 .43645 L .67031 .45373 L p F P
0 0 0 r
s
.34 .098 .05 r
.67031 .45373 m .66292 .46675 L .65544 .44904 L p F P
0 0 0 r
s
.157 .263 .533 r
.54328 .35194 m .55822 .35465 L .54772 .354 L p F P
0 0 0 r
s
.157 .263 .533 r
.54772 .354 m .53546 .35178 L .54328 .35194 L p F P
0 0 0 r
s
.83 .24 .1 r
.4492 .33299 m
.47737 .32866 L
s
.47737 .32866 m
.48823 .29958 L
s
.471 .137 .065 r
.65068 .42106 m .65716 .40901 L .66952 .42361 L p F P
0 0 0 r
s
.471 .137 .065 r
.66952 .42361 m .66241 .43645 L .65068 .42106 L p F P
0 0 0 r
s
.83 .24 .1 r
.6395 .39856 m
.65594 .4221 L
s
.64176 .44825 m
.65594 .4221 L
s
.074 .086 .165 r
.42774 .64102 m .41275 .63892 L .42649 .64434 L p F P
0 0 0 r
s
.074 .086 .165 r
.42649 .64434 m .4391 .6461 L .42774 .64102 L p F P
0 0 0 r
s
.24 .35 .67 r
.43215 .64168 m
.47399 .64756 L
s
.42806 .63262 m
.43215 .64168 L
s
.148 .248 .501 r
.5385 .66001 m .52622 .65829 L .52059 .6572 L p F P
0 0 0 r
s
.148 .248 .501 r
.52059 .6572 m .53024 .65855 L .5385 .66001 L p F P
0 0 0 r
s
.157 .263 .533 r
.52829 .34921 m .54328 .35194 L .53546 .35178 L p F P
0 0 0 r
s
.157 .263 .533 r
.53546 .35178 m .52317 .34955 L .52829 .34921 L p F P
0 0 0 r
s
.24 .35 .67 r
.51933 .35326 m
.52637 .35043 L
s
.17175 .59635 m
.17357 .58194 L
s
.56399 .66225 m
.6052 .66802 L
s
.6052 .66802 m
.6148 .6647 L
s
1 .336 .137 r
.3972 .36583 m .39349 .3773 L .40803 .37053 L p F P
0 0 0 r
s
1 .336 .137 r
.40803 .37053 m .41135 .36058 L .3972 .36583 L p F P
0 0 0 r
s
.83 .24 .1 r
.45138 .69219 m
.46172 .67083 L
s
.45138 .69219 m
.42152 .68245 L
s
1 .338 .139 r
.41813 .34023 m .41471 .35048 L .43013 .35058 L p F P
0 0 0 r
s
1 .338 .139 r
.43013 .35058 m .43302 .3422 L .41813 .34023 L p F P
0 0 0 r
s
.83 .24 .1 r
.42152 .68245 m
.39381 .66753 L
s
.39381 .66753 m
.40292 .64564 L
s
.074 .086 .165 r
.41275 .63892 m .39769 .6368 L .41383 .64257 L p F P
0 0 0 r
s
.074 .086 .165 r
.41383 .64257 m .42649 .64434 L .41275 .63892 L p F P
0 0 0 r
s
.148 .248 .501 r
.52622 .65829 m .5139 .65657 L .51091 .65585 L p F P
0 0 0 r
s
.148 .248 .501 r
.51091 .65585 m .52059 .6572 L .52622 .65829 L p F P
0 0 0 r
s
.24 .35 .67 r
.51536 .65336 m
.52232 .65641 L
s
.294 .087 .046 r
.35111 .56923 m .34747 .57991 L .33876 .56309 L p F P
0 0 0 r
s
.294 .087 .046 r
.33876 .56309 m .34253 .55162 L .35111 .56923 L p F P
0 0 0 r
s
.24 .35 .67 r
.30791 .31499 m
.30408 .3249 L
s
.30408 .3249 m
.26115 .31719 L
s
.30206 .61479 m
.25912 .60871 L
s
.30206 .61479 m
.30377 .62367 L
s
.433 .13 .063 r
.36016 .59506 m .35676 .60454 L .34389 .59039 L p F P
0 0 0 r
s
.433 .13 .063 r
.34389 .59039 m .34747 .57991 L .36016 .59506 L p F P
0 0 0 r
s
1 .327 .133 r
.58807 .6385 m .59274 .63057 L .57804 .63735 L p F P
0 0 0 r
s
1 .327 .133 r
.57804 .63735 m .57419 .64399 L .58807 .6385 L p F P
0 0 0 r
s
.157 .263 .533 r
.51323 .34648 m .52829 .34921 L .52317 .34955 L p F P
0 0 0 r
s
.157 .263 .533 r
.52317 .34955 m .51083 .34731 L .51323 .34648 L p F P
0 0 0 r
s
.226 .065 .035 r
.34638 .53992 m .34253 .55162 L .33797 .53307 L p F P
0 0 0 r
s
.226 .065 .035 r
.33797 .53307 m .34188 .52083 L .34638 .53992 L p F P
0 0 0 r
s
.83 .24 .1 r
.42152 .68245 m
.43123 .66085 L
s
1 .333 .137 r
.56665 .65703 m .5704 .65055 L .55518 .65113 L p F P
0 0 0 r
s
1 .333 .137 r
.55518 .65113 m .55231 .65621 L .56665 .65703 L p F P
0 0 0 r
s
.83 .24 .1 r
.55055 .6662 m
.55301 .66186 L
s
.55055 .6662 m
.52292 .67348 L
s
.069 .081 .156 r
.63599 .3714 m .6529 .37447 L .63199 .36807 L p F P
0 0 0 r
s
.069 .081 .156 r
.63199 .36807 m .61735 .36541 L .63599 .3714 L p F P
0 0 0 r
s
.83 .24 .1 r
.62385 .36659 m
.62413 .36602 L
s
.24 .35 .67 r
.74837 .40273 m
.73982 .39177 L
s
.73982 .39177 m
.69929 .38442 L
s
.7378 .68201 m
.69727 .6763 L
s
.7378 .68201 m
.75016 .67239 L
s
.148 .248 .501 r
.5139 .65657 m .50154 .65484 L .50121 .65449 L p F P
0 0 0 r
s
.148 .248 .501 r
.50121 .65449 m .51091 .65585 L .5139 .65657 L p F P
0 0 0 r
s
.074 .086 .165 r
.39769 .6368 m .38257 .63468 L .40113 .64079 L p F P
0 0 0 r
s
.074 .086 .165 r
.40113 .64079 m .41383 .64257 L .39769 .6368 L p F P
0 0 0 r
s
.564 .169 .078 r
.3735 .61637 m .37043 .62452 L .35343 .61386 L p F P
0 0 0 r
s
.564 .169 .078 r
.35343 .61386 m .35676 .60454 L .3735 .61637 L p F P
0 0 0 r
s
.157 .263 .533 r
.49812 .34373 m .51323 .34648 L .51083 .34731 L p F P
0 0 0 r
s
.157 .263 .533 r
.51083 .34731 m .49846 .34506 L .49812 .34373 L p F P
0 0 0 r
s
.154 .045 .022 r
.34588 .50833 m .34188 .52083 L .34136 .50157 L p F P
0 0 0 r
s
.154 .045 .022 r
.34136 .50157 m .34536 .48882 L .34588 .50833 L p F P
0 0 0 r
s
.83 .24 .1 r
.34539 .4898 m
.348 .47723 L
s
.083 .024 .01 r
.64018 .56026 m .64703 .54874 L .63899 .56654 L p F P
0 0 0 r
s
.083 .024 .01 r
.63899 .56654 m .63259 .57727 L .64018 .56026 L p F P
0 0 0 r
s
.83 .24 .1 r
.63415 .57104 m
.64184 .54777 L
s
.871 .26 .101 r
.62631 .5878 m .63259 .57727 L .62154 .59267 L p F P
0 0 0 r
s
.871 .26 .101 r
.62154 .59267 m .61587 .6022 L .62631 .5878 L p F P
0 0 0 r
s
.83 .24 .1 r
.62036 .59422 m
.63415 .57104 L
s
1 .323 .129 r
.38126 .38733 m .37731 .3998 L .38983 .38858 L p F P
0 0 0 r
s
1 .323 .129 r
.38983 .38858 m .39349 .3773 L .38126 .38733 L p F P
0 0 0 r
s
.83 .24 .1 r
.38387 .41145 m
.39264 .38445 L
s
.39264 .38445 m
.41415 .3704 L
s
.148 .248 .501 r
.50154 .65484 m .48914 .6531 L .49148 .65313 L p F P
0 0 0 r
s
.148 .248 .501 r
.49148 .65313 m .50121 .65449 L .50154 .65484 L p F P
0 0 0 r
s
.069 .081 .156 r
.619 .36832 m .63599 .3714 L .61735 .36541 L p F P
0 0 0 r
s
.83 .24 .1 r
.62413 .36602 m
.63228 .34956 L
s
.069 .081 .156 r
.61735 .36541 m .60266 .36273 L .619 .36832 L p F P
0 0 0 r
s
.24 .35 .67 r
.56801 .35799 m
.60917 .36547 L
s
.096 .028 .012 r
.65129 .53005 m .65853 .51775 L .65402 .53697 L p F P
0 0 0 r
s
.83 .24 .1 r
.64325 .52303 m
.65747 .49844 L
s
.096 .028 .012 r
.65402 .53697 m .64703 .54874 L .65129 .53005 L p F P
0 0 0 r
s
.083 .024 .01 r
.34945 .4758 m .34536 .48882 L .34866 .46994 L p F P
0 0 0 r
s
.083 .024 .01 r
.34866 .46994 m .35269 .45699 L .34945 .4758 L p F P
0 0 0 r
s
.074 .086 .165 r
.38257 .63468 m .3674 .63255 L .38839 .63901 L p F P
0 0 0 r
s
.074 .086 .165 r
.38839 .63901 m .40113 .64079 L .38257 .63468 L p F P
0 0 0 r
s
.157 .263 .533 r
.48294 .34097 m .49812 .34373 L .49846 .34506 L p F P
0 0 0 r
s
.157 .263 .533 r
.49846 .34506 m .48604 .3428 L .48294 .34097 L p F P
0 0 0 r
s
1 .304 .122 r
.6103 .61156 m .61587 .6022 L .60231 .61433 L p F P
0 0 0 r
s
.83 .24 .1 r
.60672 .61462 m
.60808 .61233 L
s
1 .304 .122 r
.60231 .61433 m .59749 .62251 L .6103 .61156 L p F P
0 0 0 r
s
.997 .292 .115 r
.36759 .41378 m .36351 .42683 L .37343 .41202 L p F P
0 0 0 r
s
.997 .292 .115 r
.37343 .41202 m .37731 .3998 L .36759 .41378 L p F P
0 0 0 r
s
.822 .24 .091 r
.35682 .44377 m .35269 .45699 L .35951 .43961 L p F P
0 0 0 r
s
.83 .24 .1 r
.35068 .46867 m
.35605 .45151 L
s
.822 .24 .091 r
.35951 .43961 m .36351 .42683 L .35682 .44377 L p F P
0 0 0 r
s
.83 .24 .1 r
.35605 .45151 m
.36724 .4297 L
s
.171 .049 .025 r
.65906 .49843 m .66649 .48561 L .66593 .50518 L p F P
0 0 0 r
s
.171 .049 .025 r
.66593 .50518 m .65853 .51775 L .65906 .49843 L p F P
0 0 0 r
s
.148 .248 .501 r
.48914 .6531 m .47669 .65136 L .48173 .65176 L p F P
0 0 0 r
s
.148 .248 .501 r
.48173 .65176 m .49148 .65313 L .48914 .6531 L p F P
0 0 0 r
s
.24 .35 .67 r
.55566 .66108 m
.56399 .66225 L
s
.52232 .65641 m
.55 .66029 L
s
.56399 .66225 m
.57286 .6588 L
s
.578 .169 .078 r
.64701 .3858 m .6529 .37447 L .6705 .38419 L p F P
0 0 0 r
s
.24 .35 .67 r
.64988 .37286 m
.65831 .377 L
s
.578 .169 .078 r
.6705 .38419 m .66377 .39672 L .64701 .3858 L p F P
0 0 0 r
s
.069 .081 .156 r
.60193 .36522 m .619 .36832 L .60266 .36273 L p F P
0 0 0 r
s
.24 .35 .67 r
.6123 .3671 m
.61686 .36948 L
s
.069 .081 .156 r
.60266 .36273 m .5879 .36005 L .60193 .36522 L p F P
0 0 0 r
s
.157 .263 .533 r
.4677 .3382 m .48294 .34097 L .48604 .3428 L p F P
0 0 0 r
s
.157 .263 .533 r
.48604 .3428 m .47358 .34054 L .4677 .3382 L p F P
0 0 0 r
s
.24 .35 .67 r
.47799 .34578 m
.48426 .34278 L
s
.26417 .30707 m
.26115 .31719 L
s
.26115 .31719 m
.21773 .30939 L
s
.25912 .60871 m
.21568 .60257 L
s
.25912 .60871 m
.25999 .61752 L
s
.672 .201 .091 r
.39107 .6323 m .38839 .63901 L .3674 .63255 L p F P
0 0 0 r
s
.24 .35 .67 r
.38984 .63575 m
.43215 .64168 L
s
.38653 .62674 m
.38858 .63233 L
s
.38977 .63555 m
.38984 .63575 L
s
.83 .24 .1 r
.37465 .6353 m
.37483 .63484 L
s
.36967 .64822 m
.37465 .6353 L
s
.672 .201 .091 r
.3674 .63255 m .37043 .62452 L .39107 .6323 L p F P
0 0 0 r
s
.83 .24 .1 r
.44348 .33507 m
.4492 .33299 L
s
1 .338 .139 r
.42159 .32981 m .41813 .34023 L .43302 .3422 L p F P
0 0 0 r
s
.24 .35 .67 r
.39391 .33056 m
.41979 .33524 L
s
.42797 .33672 m
.4345 .33791 L
s
1 .338 .139 r
.43302 .3422 m .43595 .3337 L .42159 .32981 L p F P
0 0 0 r
s
.83 .24 .1 r
.54902 .30619 m
.5789 .31658 L
s
.5789 .31658 m
.59205 .28698 L
s
.5789 .31658 m
.60699 .33121 L
s
.231 .067 .035 r
.66292 .46675 m .67031 .45373 L .67407 .47251 L p F P
0 0 0 r
s
.231 .067 .035 r
.67407 .47251 m .66649 .48561 L .66292 .46675 L p F P
0 0 0 r
s
.148 .248 .501 r
.47669 .65136 m .4642 .64961 L .47195 .6504 L p F P
0 0 0 r
s
.148 .248 .501 r
.47195 .6504 m .48173 .65176 L .47669 .65136 L p F P
0 0 0 r
s
.24 .35 .67 r
.47399 .64756 m
.48018 .65051 L
s
1 .336 .137 r
.40098 .35415 m .3972 .36583 L .41135 .36058 L p F P
0 0 0 r
s
1 .336 .137 r
.41135 .36058 m .41471 .35048 L .40098 .35415 L p F P
0 0 0 r
s
.471 .137 .065 r
.65716 .40901 m .66377 .39672 L .67677 .41049 L p F P
0 0 0 r
s
.471 .137 .065 r
.67677 .41049 m .66952 .42361 L .65716 .40901 L p F P
0 0 0 r
s
.24 .35 .67 r
.70715 .39532 m
.69929 .38442 L
s
.65831 .377 m
.69929 .38442 L
s
.69727 .6763 m
.65627 .67053 L
s
.69727 .6763 m
.70897 .66653 L
s
.34 .098 .05 r
.66241 .43645 m .66952 .42361 L .67785 .44044 L p F P
0 0 0 r
s
.34 .098 .05 r
.67785 .44044 m .67031 .45373 L .66241 .43645 L p F P
0 0 0 r
s
.83 .24 .1 r
.65594 .4221 m
.66707 .44716 L
s
.65252 .47305 m
.66707 .44716 L
s
.157 .263 .533 r
.45239 .33541 m .4677 .3382 L .47358 .34054 L p F P
0 0 0 r
s
.157 .263 .533 r
.47358 .34054 m .46108 .33827 L .45239 .33541 L p F P
0 0 0 r
s
.069 .081 .156 r
.58478 .36211 m .60193 .36522 L .5879 .36005 L p F P
0 0 0 r
s
.069 .081 .156 r
.5879 .36005 m .57309 .35736 L .58478 .36211 L p F P
0 0 0 r
s
.83 .24 .1 r
.60699 .33121 m
.62076 .30189 L
s
.60699 .33121 m
.63228 .34956 L
s
1 .333 .137 r
.5704 .65055 m .57419 .64399 L .55807 .646 L p F P
0 0 0 r
s
1 .333 .137 r
.55807 .646 m .55518 .65113 L .5704 .65055 L p F P
0 0 0 r
s
.83 .24 .1 r
.51843 .30044 m
.54902 .30619 L
s
.54902 .30619 m
.56155 .27632 L
s
1 .327 .133 r
.59274 .63057 m .59749 .62251 L .58193 .63062 L p F P
0 0 0 r
s
1 .327 .133 r
.58193 .63062 m .57804 .63735 L .59274 .63057 L p F P
0 0 0 r
s
.24 .35 .67 r
.39858 .32722 m
.39391 .33056 L
s
.39391 .33056 m
.35116 .32282 L
s
.37221 .63327 m
.37358 .63346 L
s
.3897 .63573 m
.38984 .63575 L
s
.83742 .43474 m
.82941 .41731 L
s
.82941 .41731 m
.78912 .41007 L
s
.148 .248 .501 r
.4642 .64961 m .45167 .64786 L .46214 .64902 L p F P
0 0 0 r
s
.148 .248 .501 r
.46214 .64902 m .47195 .6504 L .4642 .64961 L p F P
0 0 0 r
s
.157 .263 .533 r
.43703 .33262 m .45239 .33541 L .46108 .33827 L p F P
0 0 0 r
s
.157 .263 .533 r
.46108 .33827 m .44854 .33599 L .43703 .33262 L p F P
0 0 0 r
s
.069 .081 .156 r
.56755 .35898 m .58478 .36211 L .57309 .35736 L p F P
0 0 0 r
s
.24 .35 .67 r
.56801 .35799 m
.56901 .35855 L
s
.069 .081 .156 r
.57309 .35736 m .55822 .35465 L .56755 .35898 L p F P
0 0 0 r
s
.24 .35 .67 r
.52637 .35043 m
.56375 .35722 L
s
.433 .13 .063 r
.36361 .58541 m .36016 .59506 L .34747 .57991 L p F P
0 0 0 r
s
.433 .13 .063 r
.34747 .57991 m .35111 .56923 L .36361 .58541 L p F P
0 0 0 r
s
.83 .24 .1 r
.52292 .67348 m
.49281 .67509 L
s
.148 .248 .501 r
.45167 .64786 m .4391 .6461 L .45231 .64765 L p F P
0 0 0 r
s
.148 .248 .501 r
.45231 .64765 m .46214 .64902 L .45167 .64786 L p F P
0 0 0 r
s
.294 .087 .046 r
.35483 .55834 m .35111 .56923 L .34253 .55162 L p F P
0 0 0 r
s
.294 .087 .046 r
.34253 .55162 m .34638 .53992 L .35483 .55834 L p F P
0 0 0 r
s
.157 .263 .533 r
.42159 .32981 m .43703 .33262 L .44854 .33599 L p F P
0 0 0 r
s
.157 .263 .533 r
.44854 .33599 m .43595 .3337 L .42159 .32981 L p F P
0 0 0 r
s
.24 .35 .67 r
.43773 .33732 m
.44166 .33505 L
s
.83 .24 .1 r
.42364 .34228 m
.44194 .33563 L
s
.564 .169 .078 r
.37662 .6081 m .3735 .61637 L .35676 .60454 L p F P
0 0 0 r
s
.564 .169 .078 r
.35676 .60454 m .36016 .59506 L .37662 .6081 L p F P
0 0 0 r
s
.83 .24 .1 r
.63228 .34956 m
.64665 .32053 L
s
.226 .065 .035 r
.3503 .52798 m .34638 .53992 L .34188 .52083 L p F P
0 0 0 r
s
.226 .065 .035 r
.34188 .52083 m .34588 .50833 L .3503 .52798 L p F P
0 0 0 r
s
.069 .081 .156 r
.55024 .35584 m .56755 .35898 L .55822 .35465 L p F P
0 0 0 r
s
.069 .081 .156 r
.55822 .35465 m .54328 .35194 L .55024 .35584 L p F P
0 0 0 r
s
.24 .35 .67 r
.21773 .30939 m
.21992 .29906 L
s
.21568 .60257 m
.17175 .59635 L
s
.21568 .60257 m
.21571 .61131 L
s
1 .323 .129 r
.38529 .37462 m .38126 .38733 L .39349 .3773 L p F P
0 0 0 r
s
1 .323 .129 r
.39349 .3773 m .3972 .36583 L .38529 .37462 L p F P
0 0 0 r
s
.148 .248 .501 r
.4391 .6461 m .42649 .64434 L .44246 .64627 L p F P
0 0 0 r
s
.148 .248 .501 r
.44246 .64627 m .45231 .64765 L .4391 .6461 L p F P
0 0 0 r
s
.83 .24 .1 r
.48823 .29958 m
.51843 .30044 L
s
.51843 .30044 m
.53035 .27032 L
s
.871 .26 .101 r
.63259 .57727 m .63899 .56654 L .6273 .58298 L p F P
0 0 0 r
s
.871 .26 .101 r
.6273 .58298 m .62154 .59267 L .63259 .57727 L p F P
0 0 0 r
s
.83 .24 .1 r
.6203 .59173 m
.63415 .57104 L
s
.217 .348 .693 r
.54947 .66124 m .53986 .6599 L .5276 .65397 L p F P
0 0 0 r
s
.217 .348 .693 r
.5276 .65397 m .53426 .65491 L .54947 .66124 L p F P
0 0 0 r
s
1 .329 .137 r
.54947 .66124 m .55231 .65621 L .53618 .6514 L p F P
0 0 0 r
s
1 .329 .137 r
.53618 .6514 m .53426 .65491 L .54947 .66124 L p F P
0 0 0 r
s
.083 .024 .01 r
.64703 .54874 m .65402 .53697 L .64552 .5556 L p F P
0 0 0 r
s
.083 .024 .01 r
.64552 .5556 m .63899 .56654 L .64703 .54874 L p F P
0 0 0 r
s
.24 .35 .67 r
.65707 .37677 m
.65831 .377 L
s
.65627 .67053 m
.6148 .6647 L
s
.65627 .67053 m
.66731 .6606 L
s
1 .304 .122 r
.61587 .6022 m .62154 .59267 L .6072 .60602 L p F P
0 0 0 r
s
.83 .24 .1 r
.61208 .60559 m
.61346 .60326 L
s
.61752 .59641 m
.6203 .59173 L
s
1 .304 .122 r
.6072 .60602 m .60231 .61433 L .61587 .6022 L p F P
0 0 0 r
s
.154 .045 .022 r
.34996 .49556 m .34588 .50833 L .34536 .48882 L p F P
0 0 0 r
s
.154 .045 .022 r
.34536 .48882 m .34945 .4758 L .34996 .49556 L p F P
0 0 0 r
s
.83 .24 .1 r
.34957 .48053 m
.35098 .47604 L
s
.148 .248 .501 r
.42649 .64434 m .41383 .64257 L .43257 .64489 L p F P
0 0 0 r
s
.148 .248 .501 r
.43257 .64489 m .44246 .64627 L .42649 .64434 L p F P
0 0 0 r
s
.24 .35 .67 r
.79089 .67818 m
.75016 .67239 L
s
.79089 .67818 m
.80387 .6622 L
s
.069 .081 .156 r
.53285 .35268 m .55024 .35584 L .54328 .35194 L p F P
0 0 0 r
s
.069 .081 .156 r
.54328 .35194 m .52829 .34921 L .53285 .35268 L p F P
0 0 0 r
s
.672 .201 .091 r
.39378 .62551 m .39107 .6323 L .37043 .62452 L p F P
0 0 0 r
s
.24 .35 .67 r
.34705 .62974 m
.37221 .63327 L
s
.672 .201 .091 r
.37043 .62452 m .3735 .61637 L .39378 .62551 L p F P
0 0 0 r
s
.24 .35 .67 r
.35499 .31931 m
.35116 .32282 L
s
.35116 .32282 m
.30791 .31499 L
s
.217 .348 .693 r
.53986 .6599 m .53024 .65855 L .52093 .65303 L p F P
0 0 0 r
s
.217 .348 .693 r
.52093 .65303 m .5276 .65397 L .53986 .6599 L p F P
0 0 0 r
s
.83 .24 .1 r
.53109 .65848 m
.53279 .65537 L
s
1 .333 .137 r
.57419 .64399 m .57804 .63735 L .561 .64081 L p F P
0 0 0 r
s
.83 .24 .1 r
.57536 .63789 m
.57873 .63616 L
s
1 .333 .137 r
.561 .64081 m .55807 .646 L .57419 .64399 L p F P
0 0 0 r
s
.1 .113 .216 r
.65168 .38079 m .6705 .38419 L .6529 .37447 L p F P
0 0 0 r
s
.24 .35 .67 r
.65831 .377 m
.65879 .37772 L
s
.1 .113 .216 r
.6529 .37447 m .63599 .3714 L .65168 .38079 L p F P
0 0 0 r
s
.83 .24 .1 r
.6395 .39856 m
.64943 .37945 L
s
.65196 .37458 m
.65203 .37444 L
s
.65203 .37444 m
.65381 .37101 L
s
.24 .35 .67 r
.34705 .62974 m
.30377 .62367 L
s
.34705 .62974 m
.3508 .63239 L
s
.7965 .42747 m
.78912 .41007 L
s
.78912 .41007 m
.74837 .40273 L
s
.096 .028 .012 r
.65853 .51775 m .66593 .50518 L .66115 .52497 L p F P
0 0 0 r
s
.096 .028 .012 r
.66115 .52497 m .65402 .53697 L .65853 .51775 L p F P
0 0 0 r
s
.83 .24 .1 r
.64184 .54777 m
.6562 .5234 L
s
.6562 .5234 m
.65747 .49844 L
s
.997 .292 .115 r
.37176 .40046 m .36759 .41378 L .37731 .3998 L p F P
0 0 0 r
s
.997 .292 .115 r
.37731 .3998 m .38126 .38733 L .37176 .40046 L p F P
0 0 0 r
s
.83 .24 .1 r
.37577 .40276 m
.39264 .38445 L
s
.083 .024 .01 r
.35362 .46248 m .34945 .4758 L .35269 .45699 L p F P
0 0 0 r
s
.083 .024 .01 r
.35269 .45699 m .35682 .44377 L .35362 .46248 L p F P
0 0 0 r
s
.83 .24 .1 r
.35098 .47604 m
.35605 .45151 L
s
1 .336 .137 r
.40483 .34226 m .40098 .35415 L .41471 .35048 L p F P
0 0 0 r
s
1 .336 .137 r
.41471 .35048 m .41813 .34023 L .40483 .34226 L p F P
0 0 0 r
s
.83 .24 .1 r
.41415 .3704 m
.42364 .34228 L
s
.822 .24 .091 r
.36103 .43026 m .35682 .44377 L .36351 .42683 L p F P
0 0 0 r
s
.822 .24 .091 r
.36351 .42683 m .36759 .41378 L .36103 .43026 L p F P
0 0 0 r
s
.83 .24 .1 r
.36724 .4297 m
.37577 .40276 L
s
.217 .348 .693 r
.53024 .65855 m .52059 .6572 L .51424 .65209 L p F P
0 0 0 r
s
.217 .348 .693 r
.51424 .65209 m .52093 .65303 L .53024 .65855 L p F P
0 0 0 r
s
.83 .24 .1 r
.52292 .67348 m
.53109 .65848 L
s
.148 .248 .501 r
.41383 .64257 m .40113 .64079 L .42267 .6435 L p F P
0 0 0 r
s
.148 .248 .501 r
.42267 .6435 m .43257 .64489 L .41383 .64257 L p F P
0 0 0 r
s
.24 .35 .67 r
.43215 .64168 m
.43755 .64454 L
s
1 .327 .133 r
.59749 .62251 m .60231 .61433 L .58588 .6238 L p F P
0 0 0 r
s
1 .327 .133 r
.58588 .6238 m .58193 .63062 L .59749 .62251 L p F P
0 0 0 r
s
.069 .081 .156 r
.51537 .34951 m .53285 .35268 L .52829 .34921 L p F P
0 0 0 r
s
.24 .35 .67 r
.52887 .35196 m
.53251 .35419 L
s
.069 .081 .156 r
.52829 .34921 m .51323 .34648 L .51537 .34951 L p F P
0 0 0 r
s
.24 .35 .67 r
.48426 .34278 m
.5145 .34827 L
s
.171 .049 .025 r
.66649 .48561 m .67407 .47251 L .67348 .49234 L p F P
0 0 0 r
s
.171 .049 .025 r
.67348 .49234 m .66593 .50518 L .66649 .48561 L p F P
0 0 0 r
s
.1 .113 .216 r
.63277 .37738 m .65168 .38079 L .63599 .3714 L p F P
0 0 0 r
s
.1 .113 .216 r
.63599 .3714 m .619 .36832 L .63277 .37738 L p F P
0 0 0 r
s
.24 .35 .67 r
.61686 .36948 m
.62226 .37046 L
s
.83 .24 .1 r
.63228 .34956 m
.65381 .37101 L
s
.217 .348 .693 r
.52059 .6572 m .51091 .65585 L .50754 .65115 L p F P
0 0 0 r
s
.24 .35 .67 r
.5174 .65572 m
.51904 .65595 L
s
.217 .348 .693 r
.50754 .65115 m .51424 .65209 L .52059 .6572 L p F P
0 0 0 r
s
.24 .35 .67 r
.48018 .65051 m
.51009 .6547 L
s
.83 .24 .1 r
.49281 .67509 m
.46172 .67083 L
s
.40179 .35629 m
.42364 .34228 L
s
.42364 .34228 m
.42738 .33123 L
s
.471 .137 .065 r
.66377 .39672 m .6705 .38419 L .68418 .39711 L p F P
0 0 0 r
s
.471 .137 .065 r
.68418 .39711 m .67677 .41049 L .66377 .39672 L p F P
0 0 0 r
s
.148 .248 .501 r
.40113 .64079 m .38839 .63901 L .41273 .64211 L p F P
0 0 0 r
s
.148 .248 .501 r
.41273 .64211 m .42267 .6435 L .40113 .64079 L p F P
0 0 0 r
s
.231 .067 .035 r
.67031 .45373 m .67785 .44044 L .68183 .45913 L p F P
0 0 0 r
s
.231 .067 .035 r
.68183 .45913 m .67407 .47251 L .67031 .45373 L p F P
0 0 0 r
s
.83 .24 .1 r
.66707 .44716 m
.67229 .47279 L
s
1 .329 .137 r
.55231 .65621 m .55518 .65113 L .5381 .64788 L p F P
0 0 0 r
s
1 .329 .137 r
.5381 .64788 m .53618 .6514 L .55231 .65621 L p F P
0 0 0 r
s
.24 .35 .67 r
.1709 .60502 m
.17175 .59635 L
s
.83 .24 .1 r
.65381 .37101 m
.66875 .34227 L
s
.65381 .37101 m
.65932 .37876 L
s
.6621 .38267 m
.67073 .39482 L
s
.34 .098 .05 r
.66952 .42361 m .67677 .41049 L .68556 .42686 L p F P
0 0 0 r
s
.83 .24 .1 r
.65594 .4221 m
.67073 .39482 L
s
.34 .098 .05 r
.68556 .42686 m .67785 .44044 L .66952 .42361 L p F P
0 0 0 r
s
.069 .081 .156 r
.49781 .34632 m .51537 .34951 L .51323 .34648 L p F P
0 0 0 r
s
.069 .081 .156 r
.51323 .34648 m .49812 .34373 L .49781 .34632 L p F P
0 0 0 r
s
.217 .348 .693 r
.51091 .65585 m .50121 .65449 L .50084 .65021 L p F P
0 0 0 r
s
.217 .348 .693 r
.50084 .65021 m .50754 .65115 L .51091 .65585 L p F P
0 0 0 r
s
.83 .24 .1 r
.50347 .65445 m
.50423 .65298 L
s
.24 .35 .67 r
.6148 .6647 m
.57286 .6588 L
s
.6148 .6647 m
.62515 .6546 L
s
.1 .113 .216 r
.61375 .37395 m .63277 .37738 L .619 .36832 L p F P
0 0 0 r
s
.1 .113 .216 r
.619 .36832 m .60193 .36522 L .61375 .37395 L p F P
0 0 0 r
s
.762 .227 .101 r
.41494 .63689 m .41273 .64211 L .38839 .63901 L p F P
0 0 0 r
s
.83 .24 .1 r
.39691 .64086 m
.40292 .64564 L
s
.39583 .64 m
.39691 .64086 L
s
.762 .227 .101 r
.38839 .63901 m .39107 .6323 L .41494 .63689 L p F P
0 0 0 r
s
.24 .35 .67 r
.3933 .63782 m
.39443 .6385 L
s
.3931 .6377 m
.3933 .63782 L
s
.83 .24 .1 r
.45956 .30375 m
.48823 .29958 L
s
.48823 .29958 m
.49958 .26924 L
s
.217 .348 .693 r
.50121 .65449 m .49148 .65313 L .49411 .64927 L p F P
0 0 0 r
s
.217 .348 .693 r
.49411 .64927 m .50084 .65021 L .50121 .65449 L p F P
0 0 0 r
s
.83 .24 .1 r
.49281 .67509 m
.50347 .65445 L
s
.24 .35 .67 r
.75016 .67239 m
.70897 .66653 L
s
.75016 .67239 m
.76258 .65622 L
s
.3109 .3113 m
.30791 .31499 L
s
.30791 .31499 m
.26417 .30707 L
s
.433 .13 .063 r
.36712 .57559 m .36361 .58541 L .35111 .56923 L p F P
0 0 0 r
s
.433 .13 .063 r
.35111 .56923 m .35483 .55834 L .36712 .57559 L p F P
0 0 0 r
s
.564 .169 .078 r
.37979 .5997 m .37662 .6081 L .36016 .59506 L p F P
0 0 0 r
s
.564 .169 .078 r
.36016 .59506 m .36361 .58541 L .37979 .5997 L p F P
0 0 0 r
s
.24 .35 .67 r
.30377 .62367 m
.25999 .61752 L
s
.30377 .62367 m
.30667 .62621 L
s
.069 .081 .156 r
.48017 .34312 m .49781 .34632 L .49812 .34373 L p F P
0 0 0 r
s
.24 .35 .67 r
.48426 .34278 m
.485 .34329 L
s
.069 .081 .156 r
.49812 .34373 m .48294 .34097 L .48017 .34312 L p F P
0 0 0 r
s
.24 .35 .67 r
.75512 .42011 m
.74837 .40273 L
s
.74837 .40273 m
.70715 .39532 L
s
1 .333 .137 r
.57804 .63735 m .58193 .63062 L .56395 .63558 L p F P
0 0 0 r
s
1 .333 .137 r
.56395 .63558 m .561 .64081 L .57804 .63735 L p F P
0 0 0 r
s
.217 .348 .693 r
.49148 .65313 m .48173 .65176 L .48738 .64832 L p F P
0 0 0 r
s
.217 .348 .693 r
.48738 .64832 m .49411 .64927 L .49148 .65313 L p F P
0 0 0 r
s
1 .323 .129 r
.38939 .36166 m .38529 .37462 L .3972 .36583 L p F P
0 0 0 r
s
1 .323 .129 r
.3972 .36583 m .40098 .35415 L .38939 .36166 L p F P
0 0 0 r
s
.83 .24 .1 r
.39264 .38445 m
.40179 .35629 L
s
.294 .087 .046 r
.35862 .54724 m .35483 .55834 L .34638 .53992 L p F P
0 0 0 r
s
.83 .24 .1 r
.34729 .53715 m
.34852 .5412 L
s
.294 .087 .046 r
.34638 .53992 m .3503 .52798 L .35862 .54724 L p F P
0 0 0 r
s
.83 .24 .1 r
.46172 .67083 m
.43123 .66085 L
s
.1 .113 .216 r
.59464 .3705 m .61375 .37395 L .60193 .36522 L p F P
0 0 0 r
s
.1 .113 .216 r
.60193 .36522 m .58478 .36211 L .59464 .3705 L p F P
0 0 0 r
s
.83 .24 .1 r
.40292 .64564 m
.43123 .66085 L
s
.40292 .64564 m
.40479 .64112 L
s
.672 .201 .091 r
.39653 .61863 m .39378 .62551 L .3735 .61637 L p F P
0 0 0 r
s
.672 .201 .091 r
.3735 .61637 m .37662 .6081 L .39653 .61863 L p F P
0 0 0 r
s
.217 .348 .693 r
.48173 .65176 m .47195 .6504 L .48063 .64737 L p F P
0 0 0 r
s
.24 .35 .67 r
.43755 .64454 m
.47407 .64965 L
s
.217 .348 .693 r
.48063 .64737 m .48738 .64832 L .48173 .65176 L p F P
0 0 0 r
s
.069 .081 .156 r
.46244 .33991 m .48017 .34312 L .48294 .34097 L p F P
0 0 0 r
s
.069 .081 .156 r
.48294 .34097 m .4677 .3382 L .46244 .33991 L p F P
0 0 0 r
s
.24 .35 .67 r
.44166 .33505 m
.46459 .33921 L
s
1 .304 .122 r
.62154 .59267 m .6273 .58298 L .61217 .59759 L p F P
0 0 0 r
s
1 .304 .122 r
.61217 .59759 m .6072 .60602 L .62154 .59267 L p F P
0 0 0 r
s
.871 .26 .101 r
.63899 .56654 m .64552 .5556 L .63317 .57312 L p F P
0 0 0 r
s
.871 .26 .101 r
.63317 .57312 m .6273 .58298 L .63899 .56654 L p F P
0 0 0 r
s
.24 .35 .67 r
.42529 .33207 m
.44166 .33505 L
s
.226 .065 .035 r
.35431 .51578 m .3503 .52798 L .34588 .50833 L p F P
0 0 0 r
s
.226 .065 .035 r
.34588 .50833 m .34996 .49556 L .35431 .51578 L p F P
0 0 0 r
s
1 .329 .137 r
.55518 .65113 m .55807 .646 L .54004 .64433 L p F P
0 0 0 r
s
1 .329 .137 r
.54004 .64433 m .5381 .64788 L .55518 .65113 L p F P
0 0 0 r
s
.24 .35 .67 r
.39443 .6385 m
.40313 .63972 L
s
.41315 .64112 m
.43755 .64454 L
s
1 .336 .137 r
.40875 .33016 m .40483 .34226 L .41813 .34023 L p F P
0 0 0 r
s
1 .336 .137 r
.41813 .34023 m .42159 .32981 L .40875 .33016 L p F P
0 0 0 r
s
.24 .35 .67 r
.39858 .32722 m
.41399 .33002 L
s
.83 .24 .1 r
.55671 .64587 m
.55839 .64544 L
s
.217 .348 .693 r
.47195 .6504 m .46214 .64902 L .47387 .64642 L p F P
0 0 0 r
s
.83 .24 .1 r
.46172 .67083 m
.47179 .65002 L
s
.217 .348 .693 r
.47387 .64642 m .48063 .64737 L .47195 .6504 L p F P
0 0 0 r
s
.083 .024 .01 r
.65402 .53697 m .66115 .52497 L .65218 .54445 L p F P
0 0 0 r
s
.083 .024 .01 r
.65218 .54445 m .64552 .5556 L .65402 .53697 L p F P
0 0 0 r
s
.83 .24 .1 r
.64853 .54685 m
.6562 .5234 L
s
.63415 .57104 m
.64853 .54685 L
s
1 .327 .133 r
.60231 .61433 m .6072 .60602 L .58987 .6169 L p F P
0 0 0 r
s
1 .327 .133 r
.58987 .6169 m .58588 .6238 L .60231 .61433 L p F P
0 0 0 r
s
.1 .113 .216 r
.57543 .36703 m .59464 .3705 L .58478 .36211 L p F P
0 0 0 r
s
.1 .113 .216 r
.58478 .36211 m .56755 .35898 L .57543 .36703 L p F P
0 0 0 r
s
.069 .081 .156 r
.44463 .33667 m .46244 .33991 L .4677 .3382 L p F P
0 0 0 r
s
.069 .081 .156 r
.4677 .3382 m .45239 .33541 L .44463 .33667 L p F P
0 0 0 r
s
.154 .045 .022 r
.35412 .48251 m .34996 .49556 L .34945 .4758 L p F P
0 0 0 r
s
.154 .045 .022 r
.34945 .4758 m .35362 .46248 L .35412 .48251 L p F P
0 0 0 r
s
.997 .292 .115 r
.37601 .38686 m .37176 .40046 L .38126 .38733 L p F P
0 0 0 r
s
.997 .292 .115 r
.38126 .38733 m .38529 .37462 L .37601 .38686 L p F P
0 0 0 r
s
.83 .24 .1 r
.35486 .55826 m
.35519 .55885 L
s
.217 .348 .693 r
.46214 .64902 m .45231 .64765 L .4671 .64547 L p F P
0 0 0 r
s
.217 .348 .693 r
.4671 .64547 m .47387 .64642 L .46214 .64902 L p F P
0 0 0 r
s
.83 .24 .1 r
.47179 .65002 m
.47251 .64853 L
s
.24 .35 .67 r
.53783 .65387 m
.57286 .6588 L
s
.57286 .6588 m
.58251 .64853 L
s
.84301 .45788 m
.83742 .43474 L
s
.83742 .43474 m
.7965 .42747 L
s
.096 .028 .012 r
.66593 .50518 m .67348 .49234 L .66844 .51271 L p F P
0 0 0 r
s
.83 .24 .1 r
.65747 .49844 m
.67229 .47279 L
s
.096 .028 .012 r
.66844 .51271 m .66115 .52497 L .66593 .50518 L p F P
0 0 0 r
s
.762 .227 .101 r
.41718 .63161 m .41494 .63689 L .39107 .6323 L p F P
0 0 0 r
s
.762 .227 .101 r
.39107 .6323 m .39378 .62551 L .41718 .63161 L p F P
0 0 0 r
s
.24 .35 .67 r
.70897 .66653 m
.66731 .6606 L
s
.70897 .66653 m
.7208 .65017 L
s
.26629 .3032 m
.26417 .30707 L
s
.26417 .30707 m
.21992 .29906 L
s
.083 .024 .01 r
.35789 .44888 m .35362 .46248 L .35682 .44377 L p F P
0 0 0 r
s
.083 .024 .01 r
.35682 .44377 m .36103 .43026 L .35789 .44888 L p F P
0 0 0 r
s
.822 .24 .091 r
.36533 .41646 m .36103 .43026 L .36759 .41378 L p F P
0 0 0 r
s
.83 .24 .1 r
.35908 .44182 m
.36444 .42469 L
s
.822 .24 .091 r
.36759 .41378 m .37176 .40046 L .36533 .41646 L p F P
0 0 0 r
s
.83 .24 .1 r
.36444 .42469 m
.37577 .40276 L
s
.24 .35 .67 r
.25999 .61752 m
.21571 .61131 L
s
.25999 .61752 m
.26202 .61995 L
s
.71324 .41267 m
.70715 .39532 L
s
.217 .348 .693 r
.45231 .64765 m .44246 .64627 L .46032 .64452 L p F P
0 0 0 r
s
.217 .348 .693 r
.46032 .64452 m .4671 .64547 L .45231 .64765 L p F P
0 0 0 r
s
.1 .113 .216 r
.55611 .36354 m .57543 .36703 L .56755 .35898 L p F P
0 0 0 r
s
.1 .113 .216 r
.56755 .35898 m .55024 .35584 L .55611 .36354 L p F P
0 0 0 r
s
.069 .081 .156 r
.42673 .33343 m .44463 .33667 L .45239 .33541 L p F P
0 0 0 r
s
.069 .081 .156 r
.45239 .33541 m .43703 .33262 L .42673 .33343 L p F P
0 0 0 r
s
.83 .24 .1 r
.44967 .33167 m
.45956 .30375 L
s
.4492 .33299 m
.44967 .33167 L
s
.142 .176 .325 r
.66389 .39347 m .68418 .39711 L .6705 .38419 L p F P
0 0 0 r
s
.83 .24 .1 r
.67414 .38852 m
.68616 .36635 L
s
.67073 .39482 m
.67079 .39471 L
s
.24 .35 .67 r
.67643 .38979 m
.70715 .39532 L
s
.142 .176 .325 r
.6705 .38419 m .65168 .38079 L .66389 .39347 L p F P
0 0 0 r
s
1 .333 .137 r
.58193 .63062 m .58588 .6238 L .56694 .63029 L p F P
0 0 0 r
s
1 .333 .137 r
.56694 .63029 m .56395 .63558 L .58193 .63062 L p F P
0 0 0 r
s
.171 .049 .025 r
.67407 .47251 m .68183 .45913 L .6812 .47922 L p F P
0 0 0 r
s
.171 .049 .025 r
.6812 .47922 m .67348 .49234 L .67407 .47251 L p F P
0 0 0 r
s
.217 .348 .693 r
.44246 .64627 m .43257 .64489 L .45353 .64356 L p F P
0 0 0 r
s
.83 .24 .1 r
.43123 .66085 m
.43814 .64547 L
s
.217 .348 .693 r
.45353 .64356 m .46032 .64452 L .44246 .64627 L p F P
0 0 0 r
s
1 .329 .137 r
.55807 .646 m .561 .64081 L .54199 .64076 L p F P
0 0 0 r
s
1 .329 .137 r
.54199 .64076 m .54004 .64433 L .55807 .646 L p F P
0 0 0 r
s
.83 .24 .1 r
.43356 .31292 m
.45956 .30375 L
s
.45956 .30375 m
.47038 .27323 L
s
.56155 .27632 m
.59205 .28698 L
s
.59205 .28698 m
.60579 .25608 L
s
.59205 .28698 m
.62076 .30189 L
s
.24 .35 .67 r
.39858 .32722 m
.35499 .31931 L
s
.231 .067 .035 r
.67785 .44044 m .68556 .42686 L .68975 .44545 L p F P
0 0 0 r
s
.231 .067 .035 r
.68975 .44545 m .68183 .45913 L .67785 .44044 L p F P
0 0 0 r
s
.34 .098 .05 r
.67677 .41049 m .68418 .39711 L .69344 .41298 L p F P
0 0 0 r
s
.34 .098 .05 r
.69344 .41298 m .68556 .42686 L .67677 .41049 L p F P
0 0 0 r
s
.83 .24 .1 r
.67073 .39482 m
.68225 .42014 L
s
.66707 .44716 m
.68225 .42014 L
s
.069 .081 .156 r
.40875 .33016 m .42673 .33343 L .43703 .33262 L p F P
0 0 0 r
s
.83 .24 .1 r
.42749 .33089 m
.42769 .33029 L
s
.069 .081 .156 r
.43703 .33262 m .42159 .32981 L .40875 .33016 L p F P
0 0 0 r
s
.83 .24 .1 r
.42769 .33029 m
.43356 .31292 L
s
.1 .113 .216 r
.5367 .36003 m .55611 .36354 L .55024 .35584 L p F P
0 0 0 r
s
.1 .113 .216 r
.55024 .35584 m .53285 .35268 L .5367 .36003 L p F P
0 0 0 r
s
.24 .35 .67 r
.53251 .35419 m
.53376 .35442 L
s
.3508 .63239 m
.39443 .6385 L
s
.39443 .6385 m
.40015 .63449 L
s
.217 .348 .693 r
.43257 .64489 m .42267 .6435 L .44672 .64261 L p F P
0 0 0 r
s
.24 .35 .67 r
.43755 .64454 m
.43861 .64391 L
s
.217 .348 .693 r
.44672 .64261 m .45353 .64356 L .43257 .64489 L p F P
0 0 0 r
s
.564 .169 .078 r
.38301 .59116 m .37979 .5997 L .36361 .58541 L p F P
0 0 0 r
s
.564 .169 .078 r
.36361 .58541 m .36712 .57559 L .38301 .59116 L p F P
0 0 0 r
s
.83 .24 .1 r
.62076 .30189 m
.63514 .27128 L
s
.62076 .30189 m
.64665 .32053 L
s
.142 .176 .325 r
.64348 .38982 m .66389 .39347 L .65168 .38079 L p F P
0 0 0 r
s
.142 .176 .325 r
.65168 .38079 m .63277 .37738 L .64348 .38982 L p F P
0 0 0 r
s
.672 .201 .091 r
.39932 .61166 m .39653 .61863 L .37662 .6081 L p F P
0 0 0 r
s
.672 .201 .091 r
.37662 .6081 m .37979 .5997 L .39932 .61166 L p F P
0 0 0 r
s
.433 .13 .063 r
.3707 .56559 m .36712 .57559 L .35483 .55834 L p F P
0 0 0 r
s
.433 .13 .063 r
.35483 .55834 m .35862 .54724 L .3707 .56559 L p F P
0 0 0 r
s
.24 .35 .67 r
.80387 .6622 m
.76258 .65622 L
s
.80387 .6622 m
.81616 .64023 L
s
1 .323 .129 r
.39358 .34845 m .38939 .36166 L .40098 .35415 L p F P
0 0 0 r
s
1 .323 .129 r
.40098 .35415 m .40483 .34226 L .39358 .34845 L p F P
0 0 0 r
s
.83 .24 .1 r
.53035 .27032 m
.56155 .27632 L
s
.56155 .27632 m
.57464 .24514 L
s
.217 .348 .693 r
.42267 .6435 m .41273 .64211 L .4399 .64165 L p F P
0 0 0 r
s
.217 .348 .693 r
.4399 .64165 m .44672 .64261 L .42267 .6435 L p F P
0 0 0 r
s
.83 .24 .1 r
.43814 .64547 m
.43957 .64229 L
s
.264 .407 .805 r
.53426 .65491 m .5276 .65397 L .51421 .64388 L p F P
0 0 0 r
s
.264 .407 .805 r
.51421 .64388 m .51764 .64436 L .53426 .65491 L p F P
0 0 0 r
s
1 .319 .134 r
.53426 .65491 m .53618 .6514 L .5186 .64255 L p F P
0 0 0 r
s
.83 .24 .1 r
.53336 .65433 m
.53341 .65423 L
s
.53586 .65124 m
.53633 .65112 L
s
1 .319 .134 r
.5186 .64255 m .51764 .64436 L .53426 .65491 L p F P
0 0 0 r
s
.1 .113 .216 r
.51718 .35651 m .5367 .36003 L .53285 .35268 L p F P
0 0 0 r
s
.1 .113 .216 r
.53285 .35268 m .51537 .34951 L .51718 .35651 L p F P
0 0 0 r
s
.24 .35 .67 r
.80156 .45065 m
.7965 .42747 L
s
.7965 .42747 m
.75512 .42011 L
s
1 .304 .122 r
.6273 .58298 m .63317 .57312 L .61722 .58902 L p F P
0 0 0 r
s
.83 .24 .1 r
.62306 .58707 m
.62449 .58466 L
s
1 .304 .122 r
.61722 .58902 m .61217 .59759 L .6273 .58298 L p F P
0 0 0 r
s
.24 .35 .67 r
.66731 .6606 m
.62515 .6546 L
s
.66731 .6606 m
.67853 .64405 L
s
.264 .407 .805 r
.5276 .65397 m .52093 .65303 L .51077 .64339 L p F P
0 0 0 r
s
.264 .407 .805 r
.51077 .64339 m .51421 .64388 L .5276 .65397 L p F P
0 0 0 r
s
.294 .087 .046 r
.36248 .53592 m .35862 .54724 L .3503 .52798 L p F P
0 0 0 r
s
.294 .087 .046 r
.3503 .52798 m .35431 .51578 L .36248 .53592 L p F P
0 0 0 r
s
.841 .25 .11 r
.44151 .63806 m .4399 .64165 L .41273 .64211 L p F P
0 0 0 r
s
.841 .25 .11 r
.41273 .64211 m .41494 .63689 L .44151 .63806 L p F P
0 0 0 r
s
1 .327 .133 r
.6072 .60602 m .61217 .59759 L .59392 .60991 L p F P
0 0 0 r
s
1 .327 .133 r
.59392 .60991 m .58987 .6169 L .6072 .60602 L p F P
0 0 0 r
s
.24 .35 .67 r
.21992 .29906 m
.22115 .295 L
s
.21571 .61131 m
.1709 .60502 L
s
.21571 .61131 m
.21684 .61362 L
s
.762 .227 .101 r
.41944 .62629 m .41718 .63161 L .39378 .62551 L p F P
0 0 0 r
s
.762 .227 .101 r
.39378 .62551 m .39653 .61863 L .41944 .62629 L p F P
0 0 0 r
s
.142 .176 .325 r
.62296 .38614 m .64348 .38982 L .63277 .37738 L p F P
0 0 0 r
s
.142 .176 .325 r
.63277 .37738 m .61375 .37395 L .62296 .38614 L p F P
0 0 0 r
s
.871 .26 .101 r
.64552 .5556 m .65218 .54445 L .63915 .56308 L p F P
0 0 0 r
s
.871 .26 .101 r
.63915 .56308 m .63317 .57312 L .64552 .5556 L p F P
0 0 0 r
s
.264 .407 .805 r
.52093 .65303 m .51424 .65209 L .50732 .6429 L p F P
0 0 0 r
s
.264 .407 .805 r
.50732 .6429 m .51077 .64339 L .52093 .65303 L p F P
0 0 0 r
s
.83 .24 .1 r
.50423 .65298 m
.52045 .65219 L
s
.52045 .65219 m
.5237 .65203 L
s
1 .329 .137 r
.561 .64081 m .56395 .63558 L .54396 .63716 L p F P
0 0 0 r
s
1 .329 .137 r
.54396 .63716 m .54199 .64076 L .561 .64081 L p F P
0 0 0 r
s
.264 .407 .805 r
.51424 .65209 m .50754 .65115 L .50388 .64242 L p F P
0 0 0 r
s
.24 .35 .67 r
.5123 .65028 m
.51294 .65037 L
s
.264 .407 .805 r
.50388 .64242 m .50732 .6429 L .51424 .65209 L p F P
0 0 0 r
s
.83 .24 .1 r
.64665 .32053 m
.66166 .29022 L
s
.64665 .32053 m
.66875 .34227 L
s
.1 .113 .216 r
.49755 .35297 m .51718 .35651 L .51537 .34951 L p F P
0 0 0 r
s
.1 .113 .216 r
.51537 .34951 m .49781 .34632 L .49755 .35297 L p F P
0 0 0 r
s
.226 .065 .035 r
.3584 .50333 m .35431 .51578 L .34996 .49556 L p F P
0 0 0 r
s
.226 .065 .035 r
.34996 .49556 m .35412 .48251 L .3584 .50333 L p F P
0 0 0 r
s
1 .333 .137 r
.58588 .6238 m .58987 .6169 L .56995 .62495 L p F P
0 0 0 r
s
1 .333 .137 r
.56995 .62495 m .56694 .63029 L .58588 .6238 L p F P
0 0 0 r
s
1 .319 .134 r
.53618 .6514 m .5381 .64788 L .51956 .64072 L p F P
0 0 0 r
s
.83 .24 .1 r
.53522 .65092 m
.53527 .65082 L
s
1 .319 .134 r
.51956 .64072 m .5186 .64255 L .53618 .6514 L p F P
0 0 0 r
s
.24 .35 .67 r
.53367 .64904 m
.53461 .64794 L
s
.083 .024 .01 r
.66115 .52497 m .66844 .51271 L .65896 .53307 L p F P
0 0 0 r
s
.083 .024 .01 r
.65896 .53307 m .65218 .54445 L .66115 .52497 L p F P
0 0 0 r
s
.264 .407 .805 r
.50754 .65115 m .50084 .65021 L .50043 .64193 L p F P
0 0 0 r
s
.24 .35 .67 r
.50621 .64942 m
.50686 .64951 L
s
.264 .407 .805 r
.50043 .64193 m .50388 .64242 L .50754 .65115 L p F P
0 0 0 r
s
.24 .35 .67 r
.35783 .32253 m
.35499 .31931 L
s
.35499 .31931 m
.3109 .3113 L
s
.83 .24 .1 r
.49958 .26924 m
.53035 .27032 L
s
.53035 .27032 m
.5428 .23886 L
s
.997 .292 .115 r
.38035 .37298 m .37601 .38686 L .38529 .37462 L p F P
0 0 0 r
s
.997 .292 .115 r
.38529 .37462 m .38939 .36166 L .38035 .37298 L p F P
0 0 0 r
s
.83 .24 .1 r
.38467 .37464 m
.40179 .35629 L
s
.24 .35 .67 r
.3508 .63239 m
.30667 .62621 L
s
.3508 .63239 m
.35569 .62824 L
s
.142 .176 .325 r
.60232 .38245 m .62296 .38614 L .61375 .37395 L p F P
0 0 0 r
s
.142 .176 .325 r
.61375 .37395 m .59464 .3705 L .60232 .38245 L p F P
0 0 0 r
s
.264 .407 .805 r
.50084 .65021 m .49411 .64927 L .49698 .64144 L p F P
0 0 0 r
s
.24 .35 .67 r
.50011 .64856 m
.50076 .64865 L
s
.264 .407 .805 r
.49698 .64144 m .50043 .64193 L .50084 .65021 L p F P
0 0 0 r
s
.154 .045 .022 r
.35838 .46917 m .35412 .48251 L .35362 .46248 L p F P
0 0 0 r
s
.154 .045 .022 r
.35362 .46248 m .35789 .44888 L .35838 .46917 L p F P
0 0 0 r
s
.83 .24 .1 r
.35801 .45374 m
.35937 .44941 L
s
.24 .35 .67 r
.76258 .65622 m
.7208 .65017 L
s
.76258 .65622 m
.77439 .63404 L
s
.1 .113 .216 r
.47783 .3494 m .49755 .35297 L .49781 .34632 L p F P
0 0 0 r
s
.1 .113 .216 r
.49781 .34632 m .48017 .34312 L .47783 .3494 L p F P
0 0 0 r
s
.264 .407 .805 r
.49411 .64927 m .48738 .64832 L .49352 .64095 L p F P
0 0 0 r
s
.24 .35 .67 r
.48751 .64679 m
.48854 .64693 L
s
.494 .6477 m
.49465 .64779 L
s
.48512 .648 m
.48751 .64679 L
s
.264 .407 .805 r
.49352 .64095 m .49698 .64144 L .49411 .64927 L p F P
0 0 0 r
s
.096 .028 .012 r
.67348 .49234 m .6812 .47922 L .67588 .50019 L p F P
0 0 0 r
s
.096 .028 .012 r
.67588 .50019 m .66844 .51271 L .67348 .49234 L p F P
0 0 0 r
s
.83 .24 .1 r
.6562 .5234 m
.67118 .49797 L
s
.67118 .49797 m
.67229 .47279 L
s
.822 .24 .091 r
.36972 .40235 m .36533 .41646 L .37176 .40046 L p F P
0 0 0 r
s
.822 .24 .091 r
.37176 .40046 m .37601 .38686 L .36972 .40235 L p F P
0 0 0 r
s
.83 .24 .1 r
.37577 .40276 m
.38467 .37464 L
s
.841 .25 .11 r
.44314 .63444 m .44151 .63806 L .41494 .63689 L p F P
0 0 0 r
s
.841 .25 .11 r
.41494 .63689 m .41718 .63161 L .44314 .63444 L p F P
0 0 0 r
s
.083 .024 .01 r
.36226 .43497 m .35789 .44888 L .36103 .43026 L p F P
0 0 0 r
s
.083 .024 .01 r
.36103 .43026 m .36533 .41646 L .36226 .43497 L p F P
0 0 0 r
s
.83 .24 .1 r
.35937 .44941 m
.36444 .42469 L
s
.264 .407 .805 r
.48738 .64832 m .48063 .64737 L .49006 .64046 L p F P
0 0 0 r
s
.264 .407 .805 r
.49006 .64046 m .49352 .64095 L .48738 .64832 L p F P
0 0 0 r
s
.24 .35 .67 r
.75962 .44333 m
.75512 .42011 L
s
.75512 .42011 m
.71324 .41267 L
s
.62515 .6546 m
.58251 .64853 L
s
.62515 .6546 m
.63577 .63786 L
s
1 .319 .134 r
.5381 .64788 m .54004 .64433 L .52052 .63889 L p F P
0 0 0 r
s
.83 .24 .1 r
.53709 .64749 m
.53714 .64739 L
s
1 .319 .134 r
.52052 .63889 m .51956 .64072 L .5381 .64788 L p F P
0 0 0 r
s
.672 .201 .091 r
.40214 .6046 m .39932 .61166 L .37979 .5997 L p F P
0 0 0 r
s
.672 .201 .091 r
.37979 .5997 m .38301 .59116 L .40214 .6046 L p F P
0 0 0 r
s
.142 .176 .325 r
.58157 .37873 m .60232 .38245 L .59464 .3705 L p F P
0 0 0 r
s
.142 .176 .325 r
.59464 .3705 m .57543 .36703 L .58157 .37873 L p F P
0 0 0 r
s
.24 .35 .67 r
.17113 .60722 m
.1709 .60502 L
s
1 .329 .137 r
.56395 .63558 m .56694 .63029 L .54594 .63354 L p F P
0 0 0 r
s
1 .329 .137 r
.54594 .63354 m .54396 .63716 L .56395 .63558 L p F P
0 0 0 r
s
.264 .407 .805 r
.48063 .64737 m .47387 .64642 L .4866 .63997 L p F P
0 0 0 r
s
.24 .35 .67 r
.48176 .64598 m
.48241 .64607 L
s
.264 .407 .805 r
.4866 .63997 m .49006 .64046 L .48063 .64737 L p F P
0 0 0 r
s
.564 .169 .078 r
.38628 .58249 m .38301 .59116 L .36712 .57559 L p F P
0 0 0 r
s
.564 .169 .078 r
.36712 .57559 m .3707 .56559 L .38628 .58249 L p F P
0 0 0 r
s
.1 .113 .216 r
.45799 .34582 m .47783 .3494 L .48017 .34312 L p F P
0 0 0 r
s
.1 .113 .216 r
.48017 .34312 m .46244 .33991 L .45799 .34582 L p F P
0 0 0 r
s
.171 .049 .025 r
.68183 .45913 m .68975 .44545 L .6891 .46581 L p F P
0 0 0 r
s
.171 .049 .025 r
.6891 .46581 m .6812 .47922 L .68183 .45913 L p F P
0 0 0 r
s
.762 .227 .101 r
.42172 .62091 m .41944 .62629 L .39653 .61863 L p F P
0 0 0 r
s
.762 .227 .101 r
.39653 .61863 m .39932 .61166 L .42172 .62091 L p F P
0 0 0 r
s
.264 .407 .805 r
.47387 .64642 m .4671 .64547 L .48313 .63948 L p F P
0 0 0 r
s
.24 .35 .67 r
.47562 .64511 m
.47627 .64521 L
s
.264 .407 .805 r
.48313 .63948 m .4866 .63997 L .47387 .64642 L p F P
0 0 0 r
s
1 .323 .129 r
.39785 .33496 m .39358 .34845 L .40483 .34226 L p F P
0 0 0 r
s
1 .323 .129 r
.40483 .34226 m .40875 .33016 L .39785 .33496 L p F P
0 0 0 r
s
.83 .24 .1 r
.50423 .65298 m
.50895 .64384 L
s
.47251 .64853 m
.50423 .65298 L
s
.41134 .32689 m
.43356 .31292 L
s
.43356 .31292 m
.44391 .28227 L
s
.183 .241 .456 r
.67215 .40921 m .69344 .41298 L .68418 .39711 L p F P
0 0 0 r
s
.83 .24 .1 r
.6893 .4076 m
.69031 .40581 L
s
.69031 .40581 m
.69811 .39193 L
s
.183 .241 .456 r
.68418 .39711 m .66389 .39347 L .67215 .40921 L p F P
0 0 0 r
s
.24 .35 .67 r
.80156 .45065 m
.84301 .45788 L
s
.84581 .48576 m
.84301 .45788 L
s
.231 .067 .035 r
.68556 .42686 m .69344 .41298 L .69786 .43146 L p F P
0 0 0 r
s
.83 .24 .1 r
.68225 .42014 m
.68693 .41183 L
s
.231 .067 .035 r
.69786 .43146 m .68975 .44545 L .68556 .42686 L p F P
0 0 0 r
s
.83 .24 .1 r
.68225 .42014 m
.68777 .44602 L
s
1 .327 .133 r
.61217 .59759 m .61722 .58902 L .59802 .60282 L p F P
0 0 0 r
s
1 .327 .133 r
.59802 .60282 m .59392 .60991 L .61217 .59759 L p F P
0 0 0 r
s
.433 .13 .063 r
.37434 .55541 m .3707 .56559 L .35862 .54724 L p F P
0 0 0 r
s
.433 .13 .063 r
.35862 .54724 m .36248 .53592 L .37434 .55541 L p F P
0 0 0 r
s
.264 .407 .805 r
.4671 .64547 m .46032 .64452 L .47967 .63899 L p F P
0 0 0 r
s
.24 .35 .67 r
.46947 .64425 m
.47012 .64434 L
s
.264 .407 .805 r
.47967 .63899 m .48313 .63948 L .4671 .64547 L p F P
0 0 0 r
s
.83 .24 .1 r
.66875 .34227 m
.68434 .31224 L
s
.66875 .34227 m
.68616 .36635 L
s
.24 .35 .67 r
.31285 .31438 m
.3109 .3113 L
s
.3109 .3113 m
.26629 .3032 L
s
.142 .176 .325 r
.56069 .37499 m .58157 .37873 L .57543 .36703 L p F P
0 0 0 r
s
.142 .176 .325 r
.57543 .36703 m .55611 .36354 L .56069 .37499 L p F P
0 0 0 r
s
1 .333 .137 r
.58987 .6169 m .59392 .60991 L .573 .61956 L p F P
0 0 0 r
s
1 .333 .137 r
.573 .61956 m .56995 .62495 L .58987 .6169 L p F P
0 0 0 r
s
1 .304 .122 r
.63317 .57312 m .63915 .56308 L .62234 .58031 L p F P
0 0 0 r
s
.83 .24 .1 r
.6287 .57758 m
.63015 .57512 L
s
.63443 .56791 m
.63457 .56769 L
s
1 .304 .122 r
.62234 .58031 m .61722 .58902 L .63317 .57312 L p F P
0 0 0 r
s
.24 .35 .67 r
.30667 .62621 m
.26202 .61995 L
s
.30667 .62621 m
.31071 .62191 L
s
.1 .113 .216 r
.43805 .34222 m .45799 .34582 L .46244 .33991 L p F P
0 0 0 r
s
.1 .113 .216 r
.46244 .33991 m .44463 .33667 L .43805 .34222 L p F P
0 0 0 r
s
.24 .35 .67 r
.4435 .33647 m
.44422 .33702 L
s
.264 .407 .805 r
.46032 .64452 m .45353 .64356 L .47619 .63849 L p F P
0 0 0 r
s
.24 .35 .67 r
.46331 .64338 m
.46397 .64347 L
s
.264 .407 .805 r
.47619 .63849 m .47967 .63899 L .46032 .64452 L p F P
0 0 0 r
s
1 .319 .134 r
.54004 .64433 m .54199 .64076 L .52148 .63705 L p F P
0 0 0 r
s
.83 .24 .1 r
.53897 .64403 m
.53903 .64393 L
s
1 .319 .134 r
.52148 .63705 m .52052 .63889 L .54004 .64433 L p F P
0 0 0 r
s
.24 .35 .67 r
.53461 .64794 m
.53936 .64239 L
s
.83 .24 .1 r
.47038 .27323 m
.49958 .26924 L
s
.49958 .26924 m
.51143 .23754 L
s
.264 .407 .805 r
.45353 .64356 m .44672 .64261 L .47272 .638 L p F P
0 0 0 r
s
.24 .35 .67 r
.45714 .64251 m
.4578 .64261 L
s
.264 .407 .805 r
.47272 .638 m .47619 .63849 L .45353 .64356 L p F P
0 0 0 r
s
.24 .35 .67 r
.7208 .65017 m
.67853 .64405 L
s
.7208 .65017 m
.73213 .62778 L
s
.841 .25 .11 r
.44478 .6308 m .44314 .63444 L .41718 .63161 L p F P
0 0 0 r
s
.841 .25 .11 r
.41718 .63161 m .41944 .62629 L .44478 .6308 L p F P
0 0 0 r
s
.183 .241 .456 r
.65074 .40541 m .67215 .40921 L .66389 .39347 L p F P
0 0 0 r
s
.183 .241 .456 r
.66389 .39347 m .64348 .38982 L .65074 .40541 L p F P
0 0 0 r
s
.294 .087 .046 r
.36643 .52438 m .36248 .53592 L .35431 .51578 L p F P
0 0 0 r
s
.294 .087 .046 r
.35431 .51578 m .3584 .50333 L .36643 .52438 L p F P
0 0 0 r
s
.871 .26 .101 r
.65218 .54445 m .65896 .53307 L .64523 .55285 L p F P
0 0 0 r
s
.871 .26 .101 r
.64523 .55285 m .63915 .56308 L .65218 .54445 L p F P
0 0 0 r
s
.83 .24 .1 r
.63457 .56769 m
.64853 .54685 L
s
.264 .407 .805 r
.44672 .64261 m .4399 .64165 L .46924 .63751 L p F P
0 0 0 r
s
.24 .35 .67 r
.44409 .64068 m
.44543 .64087 L
s
.45096 .64164 m
.45162 .64174 L
s
.44324 .64118 m
.44409 .64068 L
s
.264 .407 .805 r
.46924 .63751 m .47272 .638 L .44672 .64261 L p F P
0 0 0 r
s
.24 .35 .67 r
.40015 .63449 m
.43649 .63961 L
s
.44056 .64018 m
.44409 .64068 L
s
.142 .176 .325 r
.5397 .37123 m .56069 .37499 L .55611 .36354 L p F P
0 0 0 r
s
.142 .176 .325 r
.55611 .36354 m .5367 .36003 L .5397 .37123 L p F P
0 0 0 r
s
1 .329 .137 r
.56694 .63029 m .56995 .62495 L .54793 .62989 L p F P
0 0 0 r
s
1 .329 .137 r
.54793 .62989 m .54594 .63354 L .56694 .63029 L p F P
0 0 0 r
s
.24 .35 .67 r
.71718 .43592 m
.71324 .41267 L
s
.69095 .40871 m
.71324 .41267 L
s
.81616 .64023 m
.77439 .63404 L
s
.81616 .64023 m
.82705 .61323 L
s
.1 .113 .216 r
.41801 .3386 m .43805 .34222 L .44463 .33667 L p F P
0 0 0 r
s
.1 .113 .216 r
.44463 .33667 m .42673 .33343 L .41801 .3386 L p F P
0 0 0 r
s
.83 .24 .1 r
.47251 .64853 m
.47697 .63931 L
s
.4561 .64314 m
.47251 .64853 L
s
.4528 .64206 m
.4561 .64314 L
s
.24 .35 .67 r
.53936 .64239 m
.58251 .64853 L
s
.58251 .64853 m
.59249 .63159 L
s
.909 .271 .117 r
.47012 .63567 m .46924 .63751 L .4399 .64165 L p F P
0 0 0 r
s
.909 .271 .117 r
.4399 .64165 m .44151 .63806 L .47012 .63567 L p F P
0 0 0 r
s
.997 .292 .115 r
.38479 .35879 m .38035 .37298 L .38939 .36166 L p F P
0 0 0 r
s
.997 .292 .115 r
.38939 .36166 m .39358 .34845 L .38479 .35879 L p F P
0 0 0 r
s
1 .319 .134 r
.54199 .64076 m .54396 .63716 L .52245 .63521 L p F P
0 0 0 r
s
.83 .24 .1 r
.54087 .64055 m
.54092 .64045 L
s
1 .319 .134 r
.52245 .63521 m .52148 .63705 L .54199 .64076 L p F P
0 0 0 r
s
.226 .065 .035 r
.36258 .49061 m .3584 .50333 L .35412 .48251 L p F P
0 0 0 r
s
.226 .065 .035 r
.35412 .48251 m .35838 .46917 L .36258 .49061 L p F P
0 0 0 r
s
.083 .024 .01 r
.66844 .51271 m .67588 .50019 L .66589 .52147 L p F P
0 0 0 r
s
.083 .024 .01 r
.66589 .52147 m .65896 .53307 L .66844 .51271 L p F P
0 0 0 r
s
.183 .241 .456 r
.6292 .4016 m .65074 .40541 L .64348 .38982 L p F P
0 0 0 r
s
.183 .241 .456 r
.64348 .38982 m .62296 .38614 L .6292 .4016 L p F P
0 0 0 r
s
.762 .227 .101 r
.42402 .61547 m .42172 .62091 L .39932 .61166 L p F P
0 0 0 r
s
.762 .227 .101 r
.39932 .61166 m .40214 .6046 L .42402 .61547 L p F P
0 0 0 r
s
.24 .35 .67 r
.75962 .44333 m
.80156 .45065 L
s
.80392 .47861 m
.80156 .45065 L
s
.672 .201 .091 r
.40499 .59744 m .40214 .6046 L .38301 .59116 L p F P
0 0 0 r
s
.672 .201 .091 r
.38301 .59116 m .38628 .58249 L .40499 .59744 L p F P
0 0 0 r
s
.1 .113 .216 r
.39785 .33496 m .41801 .3386 L .42673 .33343 L p F P
0 0 0 r
s
.83 .24 .1 r
.40179 .35629 m
.40812 .33682 L
s
.1 .113 .216 r
.42673 .33343 m .40875 .33016 L .39785 .33496 L p F P
0 0 0 r
s
.83 .24 .1 r
.4101 .3307 m
.41015 .33055 L
s
.24 .35 .67 r
.40227 .33059 m
.40618 .3313 L
s
.39858 .32722 m
.40227 .33059 L
s
.83 .24 .1 r
.41015 .33055 m
.41134 .32689 L
s
.142 .176 .325 r
.51859 .36745 m .5397 .37123 L .5367 .36003 L p F P
0 0 0 r
s
.24 .35 .67 r
.53508 .35974 m
.53545 .36054 L
s
.142 .176 .325 r
.5367 .36003 m .51718 .35651 L .51859 .36745 L p F P
0 0 0 r
s
.24 .35 .67 r
.26734 .30613 m
.26629 .3032 L
s
.26629 .3032 m
.22115 .295 L
s
.26202 .61995 m
.21684 .61362 L
s
.26202 .61995 m
.26519 .6155 L
s
.154 .045 .022 r
.36274 .45554 m .35838 .46917 L .35789 .44888 L p F P
0 0 0 r
s
.154 .045 .022 r
.35789 .44888 m .36226 .43497 L .36274 .45554 L p F P
0 0 0 r
s
.841 .25 .11 r
.44642 .62713 m .44478 .6308 L .41944 .62629 L p F P
0 0 0 r
s
.841 .25 .11 r
.41944 .62629 m .42172 .62091 L .44642 .62713 L p F P
0 0 0 r
s
1 .333 .137 r
.59392 .60991 m .59802 .60282 L .57607 .61411 L p F P
0 0 0 r
s
1 .333 .137 r
.57607 .61411 m .573 .61956 L .59392 .60991 L p F P
0 0 0 r
s
.909 .271 .117 r
.471 .63382 m .47012 .63567 L .44151 .63806 L p F P
0 0 0 r
s
.909 .271 .117 r
.44151 .63806 m .44314 .63444 L .471 .63382 L p F P
0 0 0 r
s
.24 .35 .67 r
.44678 .63676 m
.44757 .63563 L
s
.564 .169 .078 r
.3896 .57368 m .38628 .58249 L .3707 .56559 L p F P
0 0 0 r
s
.564 .169 .078 r
.3707 .56559 m .37434 .55541 L .3896 .57368 L p F P
0 0 0 r
s
.822 .24 .091 r
.37422 .38792 m .36972 .40235 L .37601 .38686 L p F P
0 0 0 r
s
.822 .24 .091 r
.37601 .38686 m .38035 .37298 L .37422 .38792 L p F P
0 0 0 r
s
.83 .24 .1 r
.37321 .39668 m
.38467 .37464 L
s
1 .327 .133 r
.61722 .58902 m .62234 .58031 L .60218 .59565 L p F P
0 0 0 r
s
1 .327 .133 r
.60218 .59565 m .59802 .60282 L .61722 .58902 L p F P
0 0 0 r
s
.096 .028 .012 r
.6812 .47922 m .6891 .46581 L .68348 .48741 L p F P
0 0 0 r
s
.83 .24 .1 r
.67229 .47279 m
.68777 .44602 L
s
.096 .028 .012 r
.68348 .48741 m .67588 .50019 L .6812 .47922 L p F P
0 0 0 r
s
.24 .35 .67 r
.67853 .64405 m
.63577 .63786 L
s
.67853 .64405 m
.68937 .62144 L
s
.183 .241 .456 r
.60753 .39776 m .6292 .4016 L .62296 .38614 L p F P
0 0 0 r
s
.183 .241 .456 r
.62296 .38614 m .60232 .38245 L .60753 .39776 L p F P
0 0 0 r
s
.083 .024 .01 r
.36672 .42074 m .36226 .43497 L .36533 .41646 L p F P
0 0 0 r
s
.083 .024 .01 r
.36533 .41646 m .36972 .40235 L .36672 .42074 L p F P
0 0 0 r
s
.83 .24 .1 r
.36786 .41377 m
.37321 .39668 L
s
1 .319 .134 r
.54396 .63716 m .54594 .63354 L .52342 .63336 L p F P
0 0 0 r
s
.83 .24 .1 r
.54278 .63705 m
.54283 .63695 L
s
1 .319 .134 r
.52342 .63336 m .52245 .63521 L .54396 .63716 L p F P
0 0 0 r
s
.284 .43 .846 r
.5 .62969 m .51764 .64436 L .51421 .64388 L closepath p F P
0 0 0 r
s
1 .305 .13 r
.5 .62969 m .51764 .64436 L .5186 .64255 L closepath p F P
0 0 0 r
s
1 .329 .137 r
.56995 .62495 m .573 .61956 L .54994 .62621 L p F P
0 0 0 r
s
1 .329 .137 r
.54994 .62621 m .54793 .62989 L .56995 .62495 L p F P
0 0 0 r
s
.83 .24 .1 r
.54743 .62852 m
.54888 .62816 L
s
.142 .176 .325 r
.49735 .36364 m .51859 .36745 L .51718 .35651 L p F P
0 0 0 r
s
.142 .176 .325 r
.51718 .35651 m .49755 .35297 L .49735 .36364 L p F P
0 0 0 r
s
.284 .43 .846 r
.5 .62969 m .51421 .64388 L .51077 .64339 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.68616 .36635 m
.70229 .3366 L
s
.68616 .36635 m
.69811 .39193 L
s
.24 .35 .67 r
.40227 .33059 m
.4028 .33279 L
s
.35783 .32253 m
.40227 .33059 L
s
.40015 .63449 m
.35569 .62824 L
s
.40015 .63449 m
.40681 .62353 L
s
.284 .43 .846 r
.5 .62969 m .51077 .64339 L .50732 .6429 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.77439 .63404 m
.73213 .62778 L
s
.77439 .63404 m
.78494 .60682 L
s
.52191 .6399 m
.53936 .64239 L
s
1 .304 .122 r
.63915 .56308 m .64523 .55285 L .62755 .57147 L p F P
0 0 0 r
s
.83 .24 .1 r
.63457 .56769 m
.63591 .56542 L
s
1 .304 .122 r
.62755 .57147 m .62234 .58031 L .63915 .56308 L p F P
0 0 0 r
s
.284 .43 .846 r
.5 .62969 m .50732 .6429 L .50388 .64242 L closepath p F P
0 0 0 r
s
.171 .049 .025 r
.68975 .44545 m .69786 .43146 L .69717 .4521 L p F P
0 0 0 r
s
.171 .049 .025 r
.69717 .4521 m .6891 .46581 L .68975 .44545 L p F P
0 0 0 r
s
1 .305 .13 r
.5 .62969 m .5186 .64255 L .51956 .64072 L closepath p F P
0 0 0 r
s
.433 .13 .063 r
.37805 .54505 m .37434 .55541 L .36248 .53592 L p F P
0 0 0 r
s
.83 .24 .1 r
.37512 .55635 m
.37566 .55483 L
s
.37497 .55363 m
.37566 .55483 L
s
.433 .13 .063 r
.36248 .53592 m .36643 .52438 L .37805 .54505 L p F P
0 0 0 r
s
.284 .43 .846 r
.5 .62969 m .50388 .64242 L .50043 .64193 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.84555 .51698 m
.84581 .48576 L
s
.84581 .48576 m
.80392 .47861 L
s
.83 .24 .1 r
.44391 .28227 m
.47038 .27323 L
s
.47038 .27323 m
.48168 .24133 L
s
.284 .43 .846 r
.5 .62969 m .50043 .64193 L .49698 .64144 L closepath p F P
0 0 0 r
s
.909 .271 .117 r
.47188 .63196 m .471 .63382 L .44314 .63444 L p F P
0 0 0 r
s
.909 .271 .117 r
.44314 .63444 m .44478 .6308 L .47188 .63196 L p F P
0 0 0 r
s
.83 .24 .1 r
.57464 .24514 m
.60579 .25608 L
s
.60579 .25608 m
.62014 .22379 L
s
.60579 .25608 m
.63514 .27128 L
s
.211 .286 .545 r
.6761 .42766 m .69786 .43146 L .69344 .41298 L p F P
0 0 0 r
s
.211 .286 .545 r
.69344 .41298 m .67215 .40921 L .6761 .42766 L p F P
0 0 0 r
s
.183 .241 .456 r
.58573 .3939 m .60753 .39776 L .60232 .38245 L p F P
0 0 0 r
s
.183 .241 .456 r
.60232 .38245 m .58157 .37873 L .58573 .3939 L p F P
0 0 0 r
s
.284 .43 .846 r
.5 .62969 m .49698 .64144 L .49352 .64095 L closepath p F P
0 0 0 r
s
.142 .176 .325 r
.476 .35982 m .49735 .36364 L .49755 .35297 L p F P
0 0 0 r
s
.142 .176 .325 r
.49755 .35297 m .47783 .3494 L .476 .35982 L p F P
0 0 0 r
s
.284 .43 .846 r
.5 .62969 m .49352 .64095 L .49006 .64046 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.71718 .43592 m
.75962 .44333 L
s
.76154 .47138 m
.75962 .44333 L
s
.83 .24 .1 r
.4057 .33285 m
.41134 .32689 L
s
.41134 .32689 m
.42132 .29617 L
s
1 .319 .134 r
.54594 .63354 m .54793 .62989 L .5244 .6315 L p F P
0 0 0 r
s
.83 .24 .1 r
.5447 .63353 m
.54476 .63342 L
s
.54664 .62998 m
.54743 .62852 L
s
1 .319 .134 r
.5244 .6315 m .52342 .63336 L .54594 .63354 L p F P
0 0 0 r
s
1 .305 .13 r
.5 .62969 m .51956 .64072 L .52052 .63889 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.63514 .27128 m
.65017 .2393 L
s
.63514 .27128 m
.66166 .29022 L
s
.284 .43 .846 r
.5 .62969 m .49006 .64046 L .4866 .63997 L closepath p F P
0 0 0 r
s
.762 .227 .101 r
.42635 .60998 m .42402 .61547 L .40214 .6046 L p F P
0 0 0 r
s
.762 .227 .101 r
.40214 .6046 m .40499 .59744 L .42635 .60998 L p F P
0 0 0 r
s
.841 .25 .11 r
.44808 .62344 m .44642 .62713 L .42172 .62091 L p F P
0 0 0 r
s
.841 .25 .11 r
.42172 .62091 m .42402 .61547 L .44808 .62344 L p F P
0 0 0 r
s
.24 .35 .67 r
.22115 .295 m
.22128 .29779 L
s
.83 .24 .1 r
.5428 .23886 m
.57464 .24514 L
s
.57464 .24514 m
.58831 .21254 L
s
.284 .43 .846 r
.5 .62969 m .4866 .63997 L .48313 .63948 L closepath p F P
0 0 0 r
s
.871 .26 .101 r
.65896 .53307 m .66589 .52147 L .65142 .54244 L p F P
0 0 0 r
s
.83 .24 .1 r
.66355 .5216 m
.67118 .49797 L
s
.871 .26 .101 r
.65142 .54244 m .64523 .55285 L .65896 .53307 L p F P
0 0 0 r
s
.83 .24 .1 r
.64853 .54685 m
.66355 .5216 L
s
.24 .35 .67 r
.21684 .61362 m
.17113 .60722 L
s
.21684 .61362 m
.21911 .60902 L
s
.284 .43 .846 r
.5 .62969 m .48313 .63948 L .47967 .63899 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.82705 .61323 m
.78494 .60682 L
s
.82705 .61323 m
.83591 .58255 L
s
.294 .087 .046 r
.37045 .5126 m .36643 .52438 L .3584 .50333 L p F P
0 0 0 r
s
.294 .087 .046 r
.3584 .50333 m .36258 .49061 L .37045 .5126 L p F P
0 0 0 r
s
.284 .43 .846 r
.5 .62969 m .47967 .63899 L .47619 .63849 L closepath p F P
0 0 0 r
s
1 .329 .137 r
.573 .61956 m .57607 .61411 L .55196 .62252 L p F P
0 0 0 r
s
1 .329 .137 r
.55196 .62252 m .54994 .62621 L .573 .61956 L p F P
0 0 0 r
s
1 .305 .13 r
.5 .62969 m .52052 .63889 L .52148 .63705 L closepath p F P
0 0 0 r
s
.672 .201 .091 r
.40789 .59019 m .40499 .59744 L .38628 .58249 L p F P
0 0 0 r
s
.672 .201 .091 r
.38628 .58249 m .3896 .57368 L .40789 .59019 L p F P
0 0 0 r
s
.183 .241 .456 r
.5638 .39001 m .58573 .3939 L .58157 .37873 L p F P
0 0 0 r
s
.183 .241 .456 r
.58157 .37873 m .56069 .37499 L .5638 .39001 L p F P
0 0 0 r
s
1 .333 .137 r
.59802 .60282 m .60218 .59565 L .57918 .60861 L p F P
0 0 0 r
s
1 .333 .137 r
.57918 .60861 m .57607 .61411 L .59802 .60282 L p F P
0 0 0 r
s
.211 .286 .545 r
.6542 .42383 m .6761 .42766 L .67215 .40921 L p F P
0 0 0 r
s
.24 .35 .67 r
.67145 .40908 m
.67154 .40971 L
s
.67407 .4273 m
.67423 .42843 L
s
.211 .286 .545 r
.67215 .40921 m .65074 .40541 L .6542 .42383 L p F P
0 0 0 r
s
.284 .43 .846 r
.5 .62969 m .47619 .63849 L .47272 .638 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.63577 .63786 m
.59249 .63159 L
s
.63577 .63786 m
.6461 .61503 L
s
.142 .176 .325 r
.45452 .35597 m .476 .35982 L .47783 .3494 L p F P
0 0 0 r
s
.142 .176 .325 r
.47783 .3494 m .45799 .34582 L .45452 .35597 L p F P
0 0 0 r
s
.909 .271 .117 r
.47277 .6301 m .47188 .63196 L .44478 .6308 L p F P
0 0 0 r
s
.909 .271 .117 r
.44478 .6308 m .44642 .62713 L .47277 .6301 L p F P
0 0 0 r
s
.284 .43 .846 r
.5 .62969 m .47272 .638 L .46924 .63751 L closepath p F P
0 0 0 r
s
.997 .292 .115 r
.38932 .34429 m .38479 .35879 L .39358 .34845 L p F P
0 0 0 r
s
.997 .292 .115 r
.39358 .34845 m .39785 .33496 L .38932 .34429 L p F P
0 0 0 r
s
.24 .35 .67 r
.35946 .33276 m
.35783 .32253 L
s
.35783 .32253 m
.31285 .31438 L
s
.97 .289 .124 r
.46924 .63751 m .47012 .63567 L .5 .62969 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.35569 .62824 m
.31071 .62191 L
s
.35569 .62824 m
.36156 .61709 L
s
1 .319 .134 r
.54793 .62989 m .54994 .62621 L .52538 .62964 L p F P
0 0 0 r
s
1 .319 .134 r
.52538 .62964 m .5244 .6315 L .54793 .62989 L p F P
0 0 0 r
s
1 .305 .13 r
.5 .62969 m .52148 .63705 L .52245 .63521 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.73213 .62778 m
.68937 .62144 L
s
.73213 .62778 m
.74234 .60033 L
s
.46514 .63183 m
.4693 .63242 L
s
1 .327 .133 r
.62234 .58031 m .62755 .57147 L .60639 .58837 L p F P
0 0 0 r
s
1 .327 .133 r
.60639 .58837 m .60218 .59565 L .62234 .58031 L p F P
0 0 0 r
s
.083 .024 .01 r
.67588 .50019 m .68348 .48741 L .67295 .50963 L p F P
0 0 0 r
s
.083 .024 .01 r
.67295 .50963 m .66589 .52147 L .67588 .50019 L p F P
0 0 0 r
s
.83 .24 .1 r
.66166 .29022 m
.67735 .25853 L
s
.66166 .29022 m
.68434 .31224 L
s
.226 .065 .035 r
.36685 .47762 m .36258 .49061 L .35838 .46917 L p F P
0 0 0 r
s
.226 .065 .035 r
.35838 .46917 m .36274 .45554 L .36685 .47762 L p F P
0 0 0 r
s
.564 .169 .078 r
.39298 .56474 m .3896 .57368 L .37434 .55541 L p F P
0 0 0 r
s
.564 .169 .078 r
.37434 .55541 m .37805 .54505 L .39298 .56474 L p F P
0 0 0 r
s
.24 .35 .67 r
.80337 .50996 m
.80392 .47861 L
s
.80392 .47861 m
.76154 .47138 L
s
.183 .241 .456 r
.54174 .38611 m .5638 .39001 L .56069 .37499 L p F P
0 0 0 r
s
.183 .241 .456 r
.56069 .37499 m .5397 .37123 L .54174 .38611 L p F P
0 0 0 r
s
.97 .289 .124 r
.47012 .63567 m .471 .63382 L .5 .62969 L closepath p F P
0 0 0 r
s
.142 .176 .325 r
.43291 .3521 m .45452 .35597 L .45799 .34582 L p F P
0 0 0 r
s
.142 .176 .325 r
.45799 .34582 m .43805 .34222 L .43291 .3521 L p F P
0 0 0 r
s
.211 .286 .545 r
.63217 .41999 m .6542 .42383 L .65074 .40541 L p F P
0 0 0 r
s
.211 .286 .545 r
.65074 .40541 m .6292 .4016 L .63217 .41999 L p F P
0 0 0 r
s
.83 .24 .1 r
.51143 .23754 m
.5428 .23886 L
s
.5428 .23886 m
.55582 .20598 L
s
1 .305 .13 r
.5 .62969 m .52245 .63521 L .52342 .63336 L closepath p F P
0 0 0 r
s
.841 .25 .11 r
.44976 .61972 m .44808 .62344 L .42402 .61547 L p F P
0 0 0 r
s
.841 .25 .11 r
.42402 .61547 m .42635 .60998 L .44976 .61972 L p F P
0 0 0 r
s
.24 .35 .67 r
.84219 .54985 m
.84555 .51698 L
s
.84555 .51698 m
.80337 .50996 L
s
.69782 .43254 m
.71718 .43592 L
s
.71864 .46406 m
.71718 .43592 L
s
.909 .271 .117 r
.47365 .62823 m .47277 .6301 L .44642 .62713 L p F P
0 0 0 r
s
.24 .35 .67 r
.45152 .62989 m
.46514 .63183 L
s
.44757 .63563 m
.45152 .62989 L
s
.909 .271 .117 r
.44642 .62713 m .44808 .62344 L .47365 .62823 L p F P
0 0 0 r
s
.822 .24 .091 r
.37882 .37317 m .37422 .38792 L .38035 .37298 L p F P
0 0 0 r
s
.822 .24 .091 r
.38035 .37298 m .38479 .35879 L .37882 .37317 L p F P
0 0 0 r
s
.154 .045 .022 r
.36719 .44159 m .36274 .45554 L .36226 .43497 L p F P
0 0 0 r
s
.154 .045 .022 r
.36226 .43497 m .36672 .42074 L .36719 .44159 L p F P
0 0 0 r
s
.83 .24 .1 r
.36684 .42574 m
.36814 .42159 L
s
.97 .289 .124 r
.471 .63382 m .47188 .63196 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .319 .134 r
.54994 .62621 m .55196 .62252 L .52636 .62777 L p F P
0 0 0 r
s
.83 .24 .1 r
.54858 .6264 m
.54864 .6263 L
s
1 .319 .134 r
.52636 .62777 m .52538 .62964 L .54994 .62621 L p F P
0 0 0 r
s
1 .329 .137 r
.57607 .61411 m .57918 .60861 L .554 .61879 L p F P
0 0 0 r
s
1 .329 .137 r
.554 .61879 m .55196 .62252 L .57607 .61411 L p F P
0 0 0 r
s
.24 .35 .67 r
.17248 .60246 m
.17113 .60722 L
s
.762 .227 .101 r
.4287 .60443 m .42635 .60998 L .40499 .59744 L p F P
0 0 0 r
s
.762 .227 .101 r
.40499 .59744 m .40789 .59019 L .4287 .60443 L p F P
0 0 0 r
s
1 .304 .122 r
.64523 .55285 m .65142 .54244 L .63284 .56249 L p F P
0 0 0 r
s
.83 .24 .1 r
.64026 .55808 m
.64177 .55554 L
s
.6462 .54808 m
.64947 .54257 L
s
1 .304 .122 r
.63284 .56249 m .62755 .57147 L .64523 .55285 L p F P
0 0 0 r
s
1 .305 .13 r
.5 .62969 m .52342 .63336 L .5244 .6315 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.83591 .58255 m
.79361 .57592 L
s
.83591 .58255 m
.84219 .54985 L
s
.096 .028 .012 r
.6891 .46581 m .69717 .4521 L .69124 .47434 L p F P
0 0 0 r
s
.096 .028 .012 r
.69124 .47434 m .68348 .48741 L .6891 .46581 L p F P
0 0 0 r
s
.83 .24 .1 r
.67118 .49797 m
.68684 .47141 L
s
.24 .35 .67 r
.78494 .60682 m
.74234 .60033 L
s
.78494 .60682 m
.79361 .57592 L
s
.083 .024 .01 r
.37129 .40619 m .36672 .42074 L .36972 .40235 L p F P
0 0 0 r
s
.83 .24 .1 r
.36814 .42159 m
.37125 .40632 L
s
.083 .024 .01 r
.36972 .40235 m .37422 .38792 L .37129 .40619 L p F P
0 0 0 r
s
.83 .24 .1 r
.37134 .40586 m
.37321 .39668 L
s
.142 .176 .325 r
.41118 .34821 m .43291 .3521 L .43805 .34222 L p F P
0 0 0 r
s
.142 .176 .325 r
.43805 .34222 m .41801 .3386 L .41118 .34821 L p F P
0 0 0 r
s
.183 .241 .456 r
.51954 .38217 m .54174 .38611 L .5397 .37123 L p F P
0 0 0 r
s
.24 .35 .67 r
.53861 .37103 m
.53875 .37175 L
s
.183 .241 .456 r
.5397 .37123 m .51859 .36745 L .51954 .38217 L p F P
0 0 0 r
s
.83 .24 .1 r
.69811 .39193 m
.71468 .36243 L
s
.69811 .39193 m
.70394 .41804 L
s
.211 .286 .545 r
.61001 .41611 m .63217 .41999 L .6292 .4016 L p F P
0 0 0 r
s
.24 .35 .67 r
.62848 .40147 m
.62855 .40209 L
s
.63063 .41972 m
.63077 .42084 L
s
.211 .286 .545 r
.6292 .4016 m .60753 .39776 L .61001 .41611 L p F P
0 0 0 r
s
.433 .13 .063 r
.38182 .53449 m .37805 .54505 L .36643 .52438 L p F P
0 0 0 r
s
.433 .13 .063 r
.36643 .52438 m .37045 .5126 L .38182 .53449 L p F P
0 0 0 r
s
.97 .289 .124 r
.47188 .63196 m .47277 .6301 L .5 .62969 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.84219 .54985 m
.79988 .54302 L
s
1 .333 .137 r
.60218 .59565 m .60639 .58837 L .58232 .60304 L p F P
0 0 0 r
s
1 .333 .137 r
.58232 .60304 m .57918 .60861 L .60218 .59565 L p F P
0 0 0 r
s
.24 .35 .67 r
.59249 .63159 m
.6023 .60854 L
s
1 .305 .13 r
.5 .62969 m .5244 .6315 L .52538 .62964 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.52178 .62965 m
.52546 .62948 L
s
.24 .35 .67 r
.31363 .32451 m
.31285 .31438 L
s
.31285 .31438 m
.26734 .30613 L
s
.31071 .62191 m
.26519 .6155 L
s
.31071 .62191 m
.31576 .61057 L
s
.231 .318 .61 r
.67548 .44837 m .69717 .4521 L .69786 .43146 L p F P
0 0 0 r
s
.83 .24 .1 r
.68684 .47141 m
.68761 .45046 L
s
.231 .318 .61 r
.69786 .43146 m .6761 .42766 L .67548 .44837 L p F P
0 0 0 r
s
.24 .35 .67 r
.67423 .42843 m
.67606 .42875 L
s
.83 .24 .1 r
.69634 .43119 m
.70394 .41804 L
s
.909 .271 .117 r
.47455 .62636 m .47365 .62823 L .44808 .62344 L p F P
0 0 0 r
s
.909 .271 .117 r
.44808 .62344 m .44976 .61972 L .47455 .62636 L p F P
0 0 0 r
s
.24 .35 .67 r
.68937 .62144 m
.6461 .61503 L
s
.68937 .62144 m
.69922 .59377 L
s
.83 .24 .1 r
.42132 .29617 m
.44391 .28227 L
s
.44391 .28227 m
.45474 .25022 L
s
.672 .201 .091 r
.41082 .58285 m .40789 .59019 L .3896 .57368 L p F P
0 0 0 r
s
.83 .24 .1 r
.39039 .57161 m
.3938 .57549 L
s
.672 .201 .091 r
.3896 .57368 m .39298 .56474 L .41082 .58285 L p F P
0 0 0 r
s
.97 .289 .124 r
.47277 .6301 m .47365 .62823 L .5 .62969 L closepath p F P
0 0 0 r
s
.142 .176 .325 r
.38932 .34429 m .41118 .34821 L .41801 .3386 L p F P
0 0 0 r
s
.83 .24 .1 r
.38467 .37464 m
.39397 .34526 L
s
.39397 .34526 m
.39407 .34515 L
s
.142 .176 .325 r
.41801 .3386 m .39785 .33496 L .38932 .34429 L p F P
0 0 0 r
s
1 .319 .134 r
.55196 .62252 m .554 .61879 L .52734 .62589 L p F P
0 0 0 r
s
.83 .24 .1 r
.55055 .62281 m
.5506 .6227 L
s
1 .319 .134 r
.52734 .62589 m .52636 .62777 L .55196 .62252 L p F P
0 0 0 r
s
1 .305 .13 r
.5 .62969 m .52538 .62964 L .52636 .62777 L closepath p F P
0 0 0 r
s
.183 .241 .456 r
.49722 .37822 m .51954 .38217 L .51859 .36745 L p F P
0 0 0 r
s
.183 .241 .456 r
.51859 .36745 m .49735 .36364 L .49722 .37822 L p F P
0 0 0 r
s
.83 .24 .1 r
.68434 .31224 m
.70065 .28084 L
s
.68434 .31224 m
.70229 .3366 L
s
.841 .25 .11 r
.45144 .61598 m .44976 .61972 L .42635 .60998 L p F P
0 0 0 r
s
.841 .25 .11 r
.42635 .60998 m .4287 .60443 L .45144 .61598 L p F P
0 0 0 r
s
.83 .24 .1 r
.45141 .61596 m
.45196 .61474 L
s
.24 .35 .67 r
.76068 .50287 m
.76154 .47138 L
s
.76154 .47138 m
.71864 .46406 L
s
.871 .26 .101 r
.66589 .52147 m .67295 .50963 L .65773 .53184 L p F P
0 0 0 r
s
.871 .26 .101 r
.65773 .53184 m .65142 .54244 L .66589 .52147 L p F P
0 0 0 r
s
.83 .24 .1 r
.64947 .54257 m
.66355 .5216 L
s
.211 .286 .545 r
.58772 .41222 m .61001 .41611 L .60753 .39776 L p F P
0 0 0 r
s
.211 .286 .545 r
.60753 .39776 m .58573 .3939 L .58772 .41222 L p F P
0 0 0 r
s
.24 .35 .67 r
.79988 .54302 m
.80337 .50996 L
s
.80337 .50996 m
.76068 .50287 L
s
1 .327 .133 r
.62755 .57147 m .63284 .56249 L .61065 .581 L p F P
0 0 0 r
s
1 .327 .133 r
.61065 .581 m .60639 .58837 L .62755 .57147 L p F P
0 0 0 r
s
.97 .289 .124 r
.47365 .62823 m .47455 .62636 L .5 .62969 L closepath p F P
0 0 0 r
s
1 .329 .137 r
.57918 .60861 m .58232 .60304 L .55605 .61504 L p F P
0 0 0 r
s
1 .329 .137 r
.55605 .61504 m .554 .61879 L .57918 .60861 L p F P
0 0 0 r
s
.83 .24 .1 r
.48168 .24133 m
.51143 .23754 L
s
.51143 .23754 m
.52381 .2044 L
s
.294 .087 .046 r
.37455 .50058 m .37045 .5126 L .36258 .49061 L p F P
0 0 0 r
s
.294 .087 .046 r
.36258 .49061 m .36685 .47762 L .37455 .50058 L p F P
0 0 0 r
s
1 .305 .13 r
.5 .62969 m .52636 .62777 L .52734 .62589 L closepath p F P
0 0 0 r
s
.231 .318 .61 r
.65366 .44462 m .67548 .44837 L .6761 .42766 L p F P
0 0 0 r
s
.24 .35 .67 r
.67423 .42843 m
.67425 .42905 L
s
.231 .318 .61 r
.6761 .42766 m .6542 .42383 L .65366 .44462 L p F P
0 0 0 r
s
1 .305 .13 r
.5 .62969 m .52734 .62589 L .52833 .62401 L closepath p F P
0 0 0 r
s
1 .305 .13 r
.5 .62969 m .52833 .62401 L .52932 .62212 L closepath p F P
0 0 0 r
s
1 .305 .13 r
.5 .62969 m .52932 .62212 L .53032 .62022 L closepath p F P
0 0 0 r
s
1 .305 .13 r
.5 .62969 m .53032 .62022 L .53132 .61832 L closepath p F P
0 0 0 r
s
.97 .289 .124 r
.47815 .61879 m .47905 .61688 L .5 .62969 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.49547 .62692 m
.50418 .62817 L
s
.24 .35 .67 r
.499 .62956 m
.49915 .62927 L
s
.97 .289 .124 r
.47724 .62069 m .47815 .61879 L .5 .62969 L closepath p F P
0 0 0 r
s
.97 .289 .124 r
.47634 .62259 m .47724 .62069 L .5 .62969 L closepath p F P
0 0 0 r
s
.97 .289 .124 r
.47544 .62448 m .47634 .62259 L .5 .62969 L closepath p F P
0 0 0 r
s
.97 .289 .124 r
.47455 .62636 m .47544 .62448 L .5 .62969 L closepath p F P
0 0 0 r
s
.291 .434 .852 r
.51724 .61627 m .51371 .61576 L .5 .62969 L closepath p F P
0 0 0 r
s
.291 .434 .852 r
.52076 .61678 m .51724 .61627 L .5 .62969 L closepath p F P
0 0 0 r
s
.291 .434 .852 r
.52429 .61729 m .52076 .61678 L .5 .62969 L closepath p F P
0 0 0 r
s
.291 .434 .852 r
.5278 .61781 m .52429 .61729 L .5 .62969 L closepath p F P
0 0 0 r
s
.291 .434 .852 r
.53132 .61832 m .5278 .61781 L .5 .62969 L closepath p F P
0 0 0 r
s
.97 .289 .124 r
.48088 .61304 m .4818 .61112 L .5 .62969 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.49919 .6292 m
.49926 .62905 L
s
.97 .289 .124 r
.47996 .61497 m .48088 .61304 L .5 .62969 L closepath p F P
0 0 0 r
s
.97 .289 .124 r
.47905 .61688 m .47996 .61497 L .5 .62969 L closepath p F P
0 0 0 r
s
.291 .434 .852 r
.48536 .61163 m .4818 .61112 L .5 .62969 L closepath p F P
0 0 0 r
s
.291 .434 .852 r
.48891 .61215 m .48536 .61163 L .5 .62969 L closepath p F P
0 0 0 r
s
.291 .434 .852 r
.49246 .61267 m .48891 .61215 L .5 .62969 L closepath p F P
0 0 0 r
s
.291 .434 .852 r
.49601 .61318 m .49246 .61267 L .5 .62969 L closepath p F P
0 0 0 r
s
.291 .434 .852 r
.49956 .6137 m .49601 .61318 L .5 .62969 L closepath p F P
0 0 0 r
s
.291 .434 .852 r
.5031 .61421 m .49956 .6137 L .5 .62969 L closepath p F P
0 0 0 r
s
.291 .434 .852 r
.50664 .61473 m .5031 .61421 L .5 .62969 L closepath p F P
0 0 0 r
s
.291 .434 .852 r
.51018 .61524 m .50664 .61473 L .5 .62969 L closepath p F P
0 0 0 r
s
.291 .434 .852 r
.51371 .61576 m .51018 .61524 L .5 .62969 L closepath p F P
0 0 0 r
s
.909 .271 .117 r
.47544 .62448 m .47455 .62636 L .44976 .61972 L p F P
0 0 0 r
s
.909 .271 .117 r
.44976 .61972 m .45144 .61598 L .47544 .62448 L p F P
0 0 0 r
s
.83 .24 .1 r
.39612 .33846 m
.40369 .31454 L
s
.39397 .34526 m
.39401 .34513 L
s
.24 .35 .67 r
.79361 .57592 m
.75081 .56921 L
s
.79361 .57592 m
.79988 .54302 L
s
.74234 .60033 m
.69922 .59377 L
s
.74234 .60033 m
.75081 .56921 L
s
.183 .241 .456 r
.47475 .37424 m .49722 .37822 L .49735 .36364 L p F P
0 0 0 r
s
.24 .35 .67 r
.49465 .36316 m
.4949 .3648 L
s
.183 .241 .456 r
.49735 .36364 m .476 .35982 L .47475 .37424 L p F P
0 0 0 r
s
.762 .227 .101 r
.43108 .59883 m .4287 .60443 L .40789 .59019 L p F P
0 0 0 r
s
.83 .24 .1 r
.4087 .58817 m
.41432 .59259 L
s
.762 .227 .101 r
.40789 .59019 m .41082 .58285 L .43108 .59883 L p F P
0 0 0 r
s
1 .319 .134 r
.554 .61879 m .55605 .61504 L .52833 .62401 L p F P
0 0 0 r
s
.83 .24 .1 r
.55252 .61918 m
.55258 .61908 L
s
1 .319 .134 r
.52833 .62401 m .52734 .62589 L .554 .61879 L p F P
0 0 0 r
s
.24 .35 .67 r
.5487 .62525 m
.59249 .63159 L
s
.53936 .64239 m
.5487 .62525 L
s
.564 .169 .078 r
.39641 .55564 m .39298 .56474 L .37805 .54505 L p F P
0 0 0 r
s
.564 .169 .078 r
.37805 .54505 m .38182 .53449 L .39641 .55564 L p F P
0 0 0 r
s
.211 .286 .545 r
.56528 .4083 m .58772 .41222 L .58573 .3939 L p F P
0 0 0 r
s
.24 .35 .67 r
.585 .39377 m
.58505 .39438 L
s
.58667 .41204 m
.58678 .41316 L
s
.211 .286 .545 r
.58573 .3939 m .5638 .39001 L .56528 .4083 L p F P
0 0 0 r
s
.24 .35 .67 r
.79988 .54302 m
.75705 .5361 L
s
.83 .24 .1 r
.42944 .60269 m
.45196 .61474 L
s
.083 .024 .01 r
.68348 .48741 m .69124 .47434 L .68016 .49755 L p F P
0 0 0 r
s
.083 .024 .01 r
.68016 .49755 m .67295 .50963 L .68348 .48741 L p F P
0 0 0 r
s
.24 .35 .67 r
.26723 .31616 m
.26734 .30613 L
s
.26734 .30613 m
.22128 .29779 L
s
.26519 .6155 m
.21911 .60902 L
s
.26519 .6155 m
.2694 .60397 L
s
1 .333 .137 r
.60639 .58837 m .61065 .581 L .58549 .59743 L p F P
0 0 0 r
s
1 .333 .137 r
.58549 .59743 m .58232 .60304 L .60639 .58837 L p F P
0 0 0 r
s
.231 .318 .61 r
.63171 .44085 m .65366 .44462 L .6542 .42383 L p F P
0 0 0 r
s
.231 .318 .61 r
.6542 .42383 m .63217 .41999 L .63171 .44085 L p F P
0 0 0 r
s
.24 .35 .67 r
.63077 .42084 m
.63215 .42108 L
s
.909 .271 .117 r
.47634 .62259 m .47544 .62448 L .45144 .61598 L p F P
0 0 0 r
s
.83 .24 .1 r
.45196 .61474 m
.47321 .62176 L
s
.24 .35 .67 r
.40681 .62353 m
.45152 .62989 L
s
.226 .065 .035 r
.37121 .46434 m .36685 .47762 L .36274 .45554 L p F P
0 0 0 r
s
.226 .065 .035 r
.36274 .45554 m .36719 .44159 L .37121 .46434 L p F P
0 0 0 r
s
.24 .35 .67 r
.6461 .61503 m
.6023 .60854 L
s
.6461 .61503 m
.65557 .58713 L
s
.40681 .62353 m
.36156 .61709 L
s
.40681 .62353 m
.41411 .60576 L
s
.841 .25 .11 r
.45313 .61221 m .45144 .61598 L .4287 .60443 L p F P
0 0 0 r
s
.841 .25 .11 r
.4287 .60443 m .43108 .59883 L .45313 .61221 L p F P
0 0 0 r
s
1 .319 .134 r
.52932 .62212 m .52833 .62401 L .55605 .61504 L p F P
0 0 0 r
s
.24 .35 .67 r
.53098 .62268 m
.53514 .62328 L
s
.53514 .62328 m
.5487 .62525 L
s
1 .304 .122 r
.65142 .54244 m .65773 .53184 L .63822 .55336 L p F P
0 0 0 r
s
1 .304 .122 r
.63822 .55336 m .63284 .56249 L .65142 .54244 L p F P
0 0 0 r
s
.24 .35 .67 r
.35946 .33276 m
.39416 .339 L
s
.183 .241 .456 r
.45215 .37024 m .47475 .37424 L .476 .35982 L p F P
0 0 0 r
s
.183 .241 .456 r
.476 .35982 m .45452 .35597 L .45215 .37024 L p F P
0 0 0 r
s
.909 .271 .117 r
.45144 .61598 m .45313 .61221 L .47634 .62259 L p F P
0 0 0 r
s
.24 .35 .67 r
.71748 .49569 m
.71864 .46406 L
s
.211 .286 .545 r
.54271 .40436 m .56528 .4083 L .5638 .39001 L p F P
0 0 0 r
s
.211 .286 .545 r
.5638 .39001 m .54174 .38611 L .54271 .40436 L p F P
0 0 0 r
s
1 .329 .137 r
.58232 .60304 m .58549 .59743 L .55811 .61126 L p F P
0 0 0 r
s
1 .329 .137 r
.55811 .61126 m .55605 .61504 L .58232 .60304 L p F P
0 0 0 r
s
.822 .24 .091 r
.38352 .35808 m .37882 .37317 L .38479 .35879 L p F P
0 0 0 r
s
.822 .24 .091 r
.38479 .35879 m .38932 .34429 L .38352 .35808 L p F P
0 0 0 r
s
.909 .271 .117 r
.47724 .62069 m .47634 .62259 L .45313 .61221 L p F P
0 0 0 r
s
1 .319 .134 r
.55605 .61504 m .55811 .61126 L .52932 .62212 L p F P
0 0 0 r
s
1 .319 .134 r
.53032 .62022 m .52932 .62212 L .55811 .61126 L p F P
0 0 0 r
s
.24 .35 .67 r
.75705 .5361 m
.76068 .50287 L
s
.76068 .50287 m
.71748 .49569 L
s
.154 .045 .022 r
.37175 .42733 m .36719 .44159 L .36672 .42074 L p F P
0 0 0 r
s
.83 .24 .1 r
.36814 .42159 m
.36822 .4227 L
s
.154 .045 .022 r
.36672 .42074 m .37129 .40619 L .37175 .42733 L p F P
0 0 0 r
s
.672 .201 .091 r
.4138 .5754 m .41082 .58285 L .39298 .56474 L p F P
0 0 0 r
s
.672 .201 .091 r
.39298 .56474 m .39641 .55564 L .4138 .5754 L p F P
0 0 0 r
s
.245 .342 .659 r
.67019 .47079 m .69124 .47434 L .69717 .4521 L p F P
0 0 0 r
s
.83 .24 .1 r
.67924 .49521 m
.68618 .47349 L
s
.245 .342 .659 r
.69717 .4521 m .67548 .44837 L .67019 .47079 L p F P
0 0 0 r
s
.83 .24 .1 r
.69457 .45829 m
.70321 .44363 L
s
.69411 .45907 m
.69457 .45829 L
s
.24 .35 .67 r
.67493 .44828 m
.67501 .45036 L
s
.69505 .46003 m
.69605 .4602 L
s
.69605 .4602 m
.71864 .46406 L
s
.433 .13 .063 r
.38567 .52374 m .38182 .53449 L .37045 .5126 L p F P
0 0 0 r
s
.433 .13 .063 r
.37045 .5126 m .37455 .50058 L .38567 .52374 L p F P
0 0 0 r
s
.231 .318 .61 r
.60962 .43706 m .63171 .44085 L .63217 .41999 L p F P
0 0 0 r
s
.24 .35 .67 r
.63077 .42084 m
.63077 .42105 L
s
.231 .318 .61 r
.63217 .41999 m .61001 .41611 L .60962 .43706 L p F P
0 0 0 r
s
.083 .024 .01 r
.37596 .3913 m .37129 .40619 L .37422 .38792 L p F P
0 0 0 r
s
.083 .024 .01 r
.37422 .38792 m .37882 .37317 L .37596 .3913 L p F P
0 0 0 r
s
.83 .24 .1 r
.37704 .38443 m
.38237 .3674 L
s
.909 .271 .117 r
.47815 .61879 m .47724 .62069 L .45484 .60841 L p F P
0 0 0 r
s
.909 .271 .117 r
.45313 .61221 m .45484 .60841 L .47724 .62069 L p F P
0 0 0 r
s
.24 .35 .67 r
.75081 .56921 m
.70749 .56242 L
s
.75081 .56921 m
.75705 .5361 L
s
.183 .241 .456 r
.42942 .36621 m .45215 .37024 L .45452 .35597 L p F P
0 0 0 r
s
.24 .35 .67 r
.45016 .35519 m
.45043 .35764 L
s
.183 .241 .456 r
.45452 .35597 m .43291 .3521 L .42942 .36621 L p F P
0 0 0 r
s
.24 .35 .67 r
.69922 .59377 m
.65557 .58713 L
s
.69922 .59377 m
.70749 .56242 L
s
1 .319 .134 r
.55811 .61126 m .56019 .60746 L .53032 .62022 L p F P
0 0 0 r
s
1 .319 .134 r
.53132 .61832 m .53032 .62022 L .56019 .60746 L p F P
0 0 0 r
s
.24 .35 .67 r
.5487 .62525 m
.55356 .61306 L
s
.83 .24 .1 r
.70229 .3366 m
.71916 .30548 L
s
.70229 .3366 m
.71468 .36243 L
s
1 .327 .133 r
.63284 .56249 m .63822 .55336 L .61498 .57353 L p F P
0 0 0 r
s
.83 .24 .1 r
.62784 .56237 m
.62934 .55981 L
s
1 .327 .133 r
.61498 .57353 m .61065 .581 L .63284 .56249 L p F P
0 0 0 r
s
.841 .25 .11 r
.45484 .60841 m .45313 .61221 L .43108 .59883 L p F P
0 0 0 r
s
.83 .24 .1 r
.70394 .41804 m
.72086 .38877 L
s
.70394 .41804 m
.70321 .44363 L
s
.211 .286 .545 r
.52 .40039 m .54271 .40436 L .54174 .38611 L p F P
0 0 0 r
s
.24 .35 .67 r
.54099 .38597 m
.54103 .38657 L
s
.54218 .40426 m
.54225 .40539 L
s
.211 .286 .545 r
.54174 .38611 m .51954 .38217 L .52 .40039 L p F P
0 0 0 r
s
.762 .227 .101 r
.43348 .59317 m .43108 .59883 L .41082 .58285 L p F P
0 0 0 r
s
.762 .227 .101 r
.41082 .58285 m .4138 .5754 L .43348 .59317 L p F P
0 0 0 r
s
.24 .35 .67 r
.75705 .5361 m
.7137 .5291 L
s
.909 .271 .117 r
.47905 .61688 m .47815 .61879 L .45656 .60459 L p F P
0 0 0 r
s
.909 .271 .117 r
.45484 .60841 m .45656 .60459 L .47815 .61879 L p F P
0 0 0 r
s
1 .329 .137 r
.56019 .60746 m .55811 .61126 L .58549 .59743 L p F P
0 0 0 r
s
.871 .26 .101 r
.67295 .50963 m .68016 .49755 L .66416 .52104 L p F P
0 0 0 r
s
.871 .26 .101 r
.66416 .52104 m .65773 .53184 L .67295 .50963 L p F P
0 0 0 r
s
.83 .24 .1 r
.66355 .5216 m
.67924 .49521 L
s
.841 .25 .11 r
.43108 .59883 m .43348 .59317 L .45484 .60841 L p F P
0 0 0 r
s
.24 .35 .67 r
.22128 .29779 m
.22026 .30771 L
s
.21911 .60902 m
.17248 .60246 L
s
.21911 .60902 m
.22247 .59729 L
s
.83 .24 .1 r
.45474 .25022 m
.48168 .24133 L
s
.48168 .24133 m
.4935 .20796 L
s
1 .319 .134 r
.56019 .60746 m .56228 .60363 L .53132 .61832 L p F P
0 0 0 r
s
.292 .43 .842 r
.5278 .61781 m .53132 .61832 L .56228 .60363 L p F P
0 0 0 r
s
.245 .342 .659 r
.64902 .46722 m .67019 .47079 L .67548 .44837 L p F P
0 0 0 r
s
.245 .342 .659 r
.67548 .44837 m .65366 .44462 L .64902 .46722 L p F P
0 0 0 r
s
.83 .24 .1 r
.58831 .21254 m
.62014 .22379 L
s
.62014 .22379 m
.63515 .19001 L
s
.62014 .22379 m
.65017 .2393 L
s
.231 .318 .61 r
.5874 .43324 m .60962 .43706 L .61001 .41611 L p F P
0 0 0 r
s
.231 .318 .61 r
.61001 .41611 m .58772 .41222 L .5874 .43324 L p F P
0 0 0 r
s
.24 .35 .67 r
.58678 .41316 m
.5877 .41332 L
s
.292 .43 .842 r
.52429 .61729 m .5278 .61781 L .55532 .6026 L p F P
0 0 0 r
s
.292 .43 .842 r
.56228 .60363 m .55532 .6026 L .5278 .61781 L p F P
0 0 0 r
s
.24 .35 .67 r
.55759 .60294 m
.55797 .60198 L
s
.36156 .61709 m
.31576 .61057 L
s
.36156 .61709 m
.36815 .5991 L
s
1 .333 .137 r
.61065 .581 m .61498 .57353 L .5887 .59175 L p F P
0 0 0 r
s
1 .333 .137 r
.5887 .59175 m .58549 .59743 L .61065 .581 L p F P
0 0 0 r
s
.183 .241 .456 r
.40654 .36216 m .42942 .36621 L .43291 .3521 L p F P
0 0 0 r
s
.183 .241 .456 r
.43291 .3521 m .41118 .34821 L .40654 .36216 L p F P
0 0 0 r
s
.292 .43 .842 r
.52076 .61678 m .52429 .61729 L .54834 .60157 L p F P
0 0 0 r
s
.292 .43 .842 r
.55532 .6026 m .54834 .60157 L .52429 .61729 L p F P
0 0 0 r
s
.24 .35 .67 r
.55356 .61306 m
.55454 .61059 L
s
.83 .24 .1 r
.40369 .31454 m
.42132 .29617 L
s
.42132 .29617 m
.43177 .26403 L
s
1 .329 .137 r
.58549 .59743 m .5887 .59175 L .56019 .60746 L p F P
0 0 0 r
s
.24 .35 .67 r
.35975 .34987 m
.35946 .33276 L
s
.35946 .33276 m
.31363 .32451 L
s
.909 .271 .117 r
.47996 .61497 m .47905 .61688 L .45829 .60073 L p F P
0 0 0 r
s
.909 .271 .117 r
.45656 .60459 m .45829 .60073 L .47905 .61688 L p F P
0 0 0 r
s
.24 .35 .67 r
.47335 .61434 m
.47757 .61495 L
s
.83 .24 .1 r
.65017 .2393 m
.66589 .20583 L
s
.65017 .2393 m
.67735 .25853 L
s
.292 .43 .842 r
.51724 .61627 m .52076 .61678 L .54135 .60053 L p F P
0 0 0 r
s
.292 .43 .842 r
.54834 .60157 m .54135 .60053 L .52076 .61678 L p F P
0 0 0 r
s
.294 .087 .046 r
.37874 .48831 m .37455 .50058 L .36685 .47762 L p F P
0 0 0 r
s
.294 .087 .046 r
.36685 .47762 m .37121 .46434 L .37874 .48831 L p F P
0 0 0 r
s
.211 .286 .545 r
.49715 .3964 m .52 .40039 L .51954 .38217 L p F P
0 0 0 r
s
.211 .286 .545 r
.51954 .38217 m .49722 .37822 L .49715 .3964 L p F P
0 0 0 r
s
.564 .169 .078 r
.39989 .5464 m .39641 .55564 L .38182 .53449 L p F P
0 0 0 r
s
.564 .169 .078 r
.38182 .53449 m .38567 .52374 L .39989 .5464 L p F P
0 0 0 r
s
.83 .24 .1 r
.55582 .20598 m
.58831 .21254 L
s
.58831 .21254 m
.60261 .17845 L
s
.292 .43 .842 r
.51371 .61576 m .51724 .61627 L .53434 .59949 L p F P
0 0 0 r
s
.292 .43 .842 r
.54135 .60053 m .53434 .59949 L .51724 .61627 L p F P
0 0 0 r
s
.841 .25 .11 r
.45656 .60459 m .45484 .60841 L .43348 .59317 L p F P
0 0 0 r
s
.292 .43 .842 r
.51018 .61524 m .51371 .61576 L .52732 .59846 L p F P
0 0 0 r
s
.292 .43 .842 r
.53434 .59949 m .52732 .59846 L .51371 .61576 L p F P
0 0 0 r
s
.24 .35 .67 r
.7137 .5291 m
.71748 .49569 L
s
.292 .43 .842 r
.50664 .61473 m .51018 .61524 L .52029 .59741 L p F P
0 0 0 r
s
.292 .43 .842 r
.52732 .59846 m .52029 .59741 L .51018 .61524 L p F P
0 0 0 r
s
.83 .24 .1 r
.52473 .61328 m
.52862 .60575 L
s
.52355 .61556 m
.52473 .61328 L
s
.245 .342 .659 r
.62772 .46363 m .64902 .46722 L .65366 .44462 L p F P
0 0 0 r
s
.245 .342 .659 r
.65366 .44462 m .63171 .44085 L .62772 .46363 L p F P
0 0 0 r
s
.24 .35 .67 r
.63114 .44075 m
.63119 .4438 L
s
1 .329 .137 r
.56228 .60363 m .56019 .60746 L .5887 .59175 L p F P
0 0 0 r
s
.24 .35 .67 r
.57193 .60404 m
.6023 .60854 L
s
.56833 .60351 m
.57193 .60404 L
s
.56571 .60312 m
.56833 .60351 L
s
.909 .271 .117 r
.48088 .61304 m .47996 .61497 L .46003 .59686 L p F P
0 0 0 r
s
.909 .271 .117 r
.45829 .60073 m .46003 .59686 L .47996 .61497 L p F P
0 0 0 r
s
.24 .35 .67 r
.45152 .62989 m
.45951 .61233 L
s
.292 .43 .842 r
.5031 .61421 m .50664 .61473 L .51325 .59637 L p F P
0 0 0 r
s
.292 .43 .842 r
.52029 .59741 m .51325 .59637 L .50664 .61473 L p F P
0 0 0 r
s
.231 .318 .61 r
.56505 .4294 m .5874 .43324 L .58772 .41222 L p F P
0 0 0 r
s
.231 .318 .61 r
.58772 .41222 m .56528 .4083 L .56505 .4294 L p F P
0 0 0 r
s
.292 .43 .842 r
.49956 .6137 m .5031 .61421 L .50619 .59533 L p F P
0 0 0 r
s
.292 .43 .842 r
.51325 .59637 m .50619 .59533 L .5031 .61421 L p F P
0 0 0 r
s
.24 .35 .67 r
.51275 .5963 m
.51311 .59533 L
s
.183 .241 .456 r
.38352 .35808 m .40654 .36216 L .41118 .34821 L p F P
0 0 0 r
s
.83 .24 .1 r
.38237 .3674 m
.38694 .35868 L
s
.38811 .35644 m
.39397 .34526 L
s
.183 .241 .456 r
.41118 .34821 m .38932 .34429 L .38352 .35808 L p F P
0 0 0 r
s
.24 .35 .67 r
.70749 .56242 m
.66364 .55555 L
s
.70749 .56242 m
.7137 .5291 L
s
.83 .24 .1 r
.52862 .60575 m
.54886 .60497 L
s
1 .304 .122 r
.65773 .53184 m .66416 .52104 L .64369 .54408 L p F P
0 0 0 r
s
.83 .24 .1 r
.65224 .53789 m
.6538 .53526 L
s
1 .304 .122 r
.64369 .54408 m .63822 .55336 L .65773 .53184 L p F P
0 0 0 r
s
.83 .24 .1 r
.62934 .55981 m
.6396 .55102 L
s
.24 .35 .67 r
.65557 .58713 m
.66364 .55555 L
s
.292 .43 .842 r
.49601 .61318 m .49956 .6137 L .49912 .59428 L p F P
0 0 0 r
s
.292 .43 .842 r
.50619 .59533 m .49912 .59428 L .49956 .6137 L p F P
0 0 0 r
s
.257 .361 .697 r
.6603 .49427 m .68016 .49755 L .69124 .47434 L p F P
0 0 0 r
s
.257 .361 .697 r
.69124 .47434 m .67019 .47079 L .6603 .49427 L p F P
0 0 0 r
s
.24 .35 .67 r
.68373 .49008 m
.71748 .49569 L
s
.83 .24 .1 r
.68381 .48753 m
.69566 .4676 L
s
.68288 .4891 m
.68381 .48753 L
s
.672 .201 .091 r
.41681 .56786 m .4138 .5754 L .39641 .55564 L p F P
0 0 0 r
s
.672 .201 .091 r
.39641 .55564 m .39989 .5464 L .41681 .56786 L p F P
0 0 0 r
s
.83 .24 .1 r
.40593 .55406 m
.40625 .55324 L
s
.292 .43 .842 r
.49246 .61267 m .49601 .61318 L .49203 .59323 L p F P
0 0 0 r
s
.292 .43 .842 r
.49912 .59428 m .49203 .59323 L .49601 .61318 L p F P
0 0 0 r
s
.211 .286 .545 r
.47416 .39238 m .49715 .3964 L .49722 .37822 L p F P
0 0 0 r
s
.24 .35 .67 r
.49645 .37808 m
.49648 .37867 L
s
.211 .286 .545 r
.49722 .37822 m .47475 .37424 L .47416 .39238 L p F P
0 0 0 r
s
.909 .271 .117 r
.4818 .61112 m .48088 .61304 L .46179 .59295 L p F P
0 0 0 r
s
.909 .271 .117 r
.46003 .59686 m .46179 .59295 L .48088 .61304 L p F P
0 0 0 r
s
.24 .35 .67 r
.45951 .61233 m
.47335 .61434 L
s
.841 .25 .11 r
.43348 .59317 m .4359 .58745 L .45656 .60459 L p F P
0 0 0 r
s
.762 .227 .101 r
.4359 .58745 m .43348 .59317 L .4138 .5754 L p F P
0 0 0 r
s
.24 .35 .67 r
.41411 .60576 m
.45951 .61233 L
s
.292 .43 .842 r
.48891 .61215 m .49246 .61267 L .48494 .59218 L p F P
0 0 0 r
s
.292 .43 .842 r
.49203 .59323 m .48494 .59218 L .49246 .61267 L p F P
0 0 0 r
s
.83 .24 .1 r
.49077 .61079 m
.49188 .60849 L
s
.49188 .60849 m
.49556 .60089 L
s
.38724 .35185 m
.39196 .33677 L
s
.38663 .35379 m
.38724 .35185 L
s
.67735 .25853 m
.69376 .22537 L
s
.67735 .25853 m
.70065 .28084 L
s
.24 .35 .67 r
.66982 .52201 m
.7137 .5291 L
s
.226 .065 .035 r
.37568 .45076 m .37121 .46434 L .36719 .44159 L p F P
0 0 0 r
s
.226 .065 .035 r
.36719 .44159 m .37175 .42733 L .37568 .45076 L p F P
0 0 0 r
s
.292 .43 .842 r
.48536 .61163 m .48891 .61215 L .47782 .59113 L p F P
0 0 0 r
s
.292 .43 .842 r
.48494 .59218 m .47782 .59113 L .48891 .61215 L p F P
0 0 0 r
s
.762 .227 .101 r
.4138 .5754 m .41681 .56786 L .4359 .58745 L p F P
0 0 0 r
s
.841 .25 .11 r
.45829 .60073 m .45656 .60459 L .4359 .58745 L p F P
0 0 0 r
s
.24 .35 .67 r
.17496 .59053 m
.17248 .60246 L
s
.245 .342 .659 r
.60629 .46002 m .62772 .46363 L .63171 .44085 L p F P
0 0 0 r
s
.245 .342 .659 r
.63171 .44085 m .60962 .43706 L .60629 .46002 L p F P
0 0 0 r
s
.292 .43 .842 r
.4818 .61112 m .48536 .61163 L .4707 .59007 L p F P
0 0 0 r
s
.292 .43 .842 r
.47782 .59113 m .4707 .59007 L .48536 .61163 L p F P
0 0 0 r
s
1 .333 .137 r
.59194 .58601 m .5887 .59175 L .61498 .57353 L p F P
0 0 0 r
s
1 .329 .137 r
.5887 .59175 m .59194 .58601 L .56228 .60363 L p F P
0 0 0 r
s
.24 .35 .67 r
.55797 .60198 m
.56365 .60282 L
s
.83 .24 .1 r
.52381 .2044 m
.55582 .20598 L
s
.55582 .20598 m
.56943 .17158 L
s
.231 .318 .61 r
.54256 .42554 m .56505 .4294 L .56528 .4083 L p F P
0 0 0 r
s
.231 .318 .61 r
.56528 .4083 m .54271 .40436 L .54256 .42554 L p F P
0 0 0 r
s
.24 .35 .67 r
.54225 .40539 m
.5427 .40547 L
s
.31576 .61057 m
.2694 .60397 L
s
.31576 .61057 m
.32161 .59236 L
s
.289 .423 .825 r
.55532 .6026 m .56228 .60363 L .59194 .58601 L p F P
0 0 0 r
s
.909 .271 .117 r
.46179 .59295 m .46356 .58902 L .4818 .61112 L p F P
0 0 0 r
s
.292 .43 .842 r
.4707 .59007 m .46356 .58902 L .4818 .61112 L p F P
0 0 0 r
s
1 .327 .133 r
.63822 .55336 m .64369 .54408 L .61936 .56596 L p F P
0 0 0 r
s
1 .327 .133 r
.61936 .56596 m .61498 .57353 L .63822 .55336 L p F P
0 0 0 r
s
.24 .35 .67 r
.3131 .34158 m
.31363 .32451 L
s
.31363 .32451 m
.26723 .31616 L
s
.257 .361 .697 r
.64033 .49098 m .6603 .49427 L .67019 .47079 L p F P
0 0 0 r
s
.257 .361 .697 r
.67019 .47079 m .64902 .46722 L .64033 .49098 L p F P
0 0 0 r
s
.433 .13 .063 r
.38958 .51279 m .38567 .52374 L .37455 .50058 L p F P
0 0 0 r
s
.433 .13 .063 r
.37455 .50058 m .37874 .48831 L .38958 .51279 L p F P
0 0 0 r
s
1 .333 .137 r
.61498 .57353 m .61936 .56596 L .59194 .58601 L p F P
0 0 0 r
s
.24 .35 .67 r
.6023 .60854 m
.6114 .5804 L
s
.6114 .5804 m
.65557 .58713 L
s
.289 .423 .825 r
.54834 .60157 m .55532 .6026 L .58169 .58447 L p F P
0 0 0 r
s
.24 .35 .67 r
.55653 .60176 m
.55701 .60183 L
s
.55818 .6013 m
.55844 .60045 L
s
.289 .423 .825 r
.59194 .58601 m .58169 .58447 L .55532 .6026 L p F P
0 0 0 r
s
.211 .286 .545 r
.45102 .38834 m .47416 .39238 L .47475 .37424 L p F P
0 0 0 r
s
.211 .286 .545 r
.47475 .37424 m .45215 .37024 L .45102 .38834 L p F P
0 0 0 r
s
.154 .045 .022 r
.37641 .41274 m .37175 .42733 L .37129 .40619 L p F P
0 0 0 r
s
.154 .045 .022 r
.37129 .40619 m .37596 .3913 L .37641 .41274 L p F P
0 0 0 r
s
.83 .24 .1 r
.37607 .39644 m
.37731 .39249 L
s
.289 .423 .825 r
.54135 .60053 m .54834 .60157 L .57142 .58291 L p F P
0 0 0 r
s
.24 .35 .67 r
.5494 .60071 m
.54988 .60078 L
s
.289 .423 .825 r
.58169 .58447 m .57142 .58291 L .54834 .60157 L p F P
0 0 0 r
s
.83 .24 .1 r
.56285 .60024 m
.56365 .59878 L
s
.083 .024 .01 r
.38074 .37606 m .37596 .3913 L .37882 .37317 L p F P
0 0 0 r
s
.83 .24 .1 r
.37731 .39249 m
.38041 .37711 L
s
.083 .024 .01 r
.37882 .37317 m .38352 .35808 L .38074 .37606 L p F P
0 0 0 r
s
.83 .24 .1 r
.38113 .37358 m
.38237 .3674 L
s
.38237 .3674 m
.3852 .35838 L
s
.71468 .36243 m
.73203 .33157 L
s
.71468 .36243 m
.72086 .38877 L
s
.245 .342 .659 r
.58474 .45639 m .60629 .46002 L .60962 .43706 L p F P
0 0 0 r
s
.245 .342 .659 r
.60962 .43706 m .5874 .43324 L .58474 .45639 L p F P
0 0 0 r
s
.841 .25 .11 r
.46003 .59686 m .45829 .60073 L .43835 .58166 L p F P
0 0 0 r
s
.24 .35 .67 r
.45951 .61233 m
.46379 .5999 L
s
.46379 .5999 m
.46466 .59738 L
s
.83 .24 .1 r
.45826 .60072 m
.45826 .60071 L
s
.841 .25 .11 r
.4359 .58745 m .43835 .58166 L .45829 .60073 L p F P
0 0 0 r
s
.231 .318 .61 r
.51993 .42165 m .54256 .42554 L .54271 .40436 L p F P
0 0 0 r
s
.231 .318 .61 r
.54271 .40436 m .52 .40039 L .51993 .42165 L p F P
0 0 0 r
s
.289 .423 .825 r
.53434 .59949 m .54135 .60053 L .56112 .58136 L p F P
0 0 0 r
s
.24 .35 .67 r
.54226 .59965 m
.54274 .59972 L
s
.289 .423 .825 r
.57142 .58291 m .56112 .58136 L .54135 .60053 L p F P
0 0 0 r
s
.266 .377 .73 r
.64603 .51811 m .66416 .52104 L .68016 .49755 L p F P
0 0 0 r
s
.24 .35 .67 r
.67212 .50239 m
.67282 .49634 L
s
.83 .24 .1 r
.67597 .50007 m
.67792 .49718 L
s
.65839 .52753 m
.66241 .52076 L
s
.266 .377 .73 r
.68016 .49755 m .6603 .49427 L .64603 .51811 L p F P
0 0 0 r
s
.83 .24 .1 r
.66505 .5163 m
.66709 .51327 L
s
.66709 .51327 m
.66974 .50934 L
s
.24 .35 .67 r
.67038 .51723 m
.67111 .511 L
s
.66982 .52201 m
.67038 .51723 L
s
.63768 .55148 m
.66364 .55555 L
s
.63625 .55125 m
.63768 .55148 L
s
.66364 .55555 m
.66982 .52201 L
s
.762 .227 .101 r
.43835 .58166 m .4359 .58745 L .41681 .56786 L p F P
0 0 0 r
s
.257 .361 .697 r
.62025 .48766 m .64033 .49098 L .64902 .46722 L p F P
0 0 0 r
s
.257 .361 .697 r
.64902 .46722 m .62772 .46363 L .62025 .48766 L p F P
0 0 0 r
s
.289 .423 .825 r
.52732 .59846 m .53434 .59949 L .55079 .5798 L p F P
0 0 0 r
s
.24 .35 .67 r
.5351 .59859 m
.53558 .59866 L
s
.289 .423 .825 r
.56112 .58136 m .55079 .5798 L .53434 .59949 L p F P
0 0 0 r
s
.211 .286 .545 r
.42774 .38427 m .45102 .38834 L .45215 .37024 L p F P
0 0 0 r
s
.24 .35 .67 r
.45138 .3701 m
.45138 .37068 L
s
.211 .286 .545 r
.45215 .37024 m .42942 .36621 L .42774 .38427 L p F P
0 0 0 r
s
.24 .35 .67 r
.41411 .60576 m
.36815 .5991 L
s
.41411 .60576 m
.4217 .58179 L
s
.83 .24 .1 r
.49556 .60089 m
.52862 .60575 L
s
.564 .169 .078 r
.40344 .53701 m .39989 .5464 L .38567 .52374 L p F P
0 0 0 r
s
.83 .24 .1 r
.39998 .54617 m
.40625 .55324 L
s
.564 .169 .078 r
.38567 .52374 m .38958 .51279 L .40344 .53701 L p F P
0 0 0 r
s
.83 .24 .1 r
.43177 .26403 m
.45474 .25022 L
s
.45474 .25022 m
.46607 .21667 L
s
.289 .423 .825 r
.52029 .59741 m .52732 .59846 L .54043 .57823 L p F P
0 0 0 r
s
.24 .35 .67 r
.52793 .59752 m
.52841 .5976 L
s
.289 .423 .825 r
.55079 .5798 m .54043 .57823 L .52732 .59846 L p F P
0 0 0 r
s
.285 .413 .805 r
.58169 .58447 m .59194 .58601 L .61936 .56596 L p F P
0 0 0 r
s
.24 .35 .67 r
.6114 .5804 m
.61364 .57134 L
s
.60246 .57904 m
.6114 .5804 L
s
.66421 .52111 m
.66982 .52201 L
s
.83 .24 .1 r
.70065 .28084 m
.71772 .24798 L
s
.70065 .28084 m
.71916 .30548 L
s
.70321 .44363 m
.72034 .41457 L
s
.70321 .44363 m
.69566 .4676 L
s
.245 .342 .659 r
.56306 .45273 m .58474 .45639 L .5874 .43324 L p F P
0 0 0 r
s
.24 .35 .67 r
.5868 .43314 m
.5868 .43372 L
s
.245 .342 .659 r
.5874 .43324 m .56505 .4294 L .56306 .45273 L p F P
0 0 0 r
s
.289 .423 .825 r
.51325 .59637 m .52029 .59741 L .53004 .57666 L p F P
0 0 0 r
s
.24 .35 .67 r
.51311 .59533 m
.51402 .59546 L
s
.52074 .59646 m
.52122 .59653 L
s
.289 .423 .825 r
.54043 .57823 m .53004 .57666 L .52029 .59741 L p F P
0 0 0 r
s
.24 .35 .67 r
.35975 .34987 m
.38508 .35437 L
s
.762 .227 .101 r
.41681 .56786 m .41987 .56021 L .43835 .58166 L p F P
0 0 0 r
s
.672 .201 .091 r
.41987 .56021 m .41681 .56786 L .39989 .5464 L p F P
0 0 0 r
s
.294 .087 .046 r
.38301 .47579 m .37874 .48831 L .37121 .46434 L p F P
0 0 0 r
s
.294 .087 .046 r
.37121 .46434 m .37568 .45076 L .38301 .47579 L p F P
0 0 0 r
s
.231 .318 .61 r
.49716 .41774 m .51993 .42165 L .52 .40039 L p F P
0 0 0 r
s
.231 .318 .61 r
.52 .40039 m .49715 .3964 L .49716 .41774 L p F P
0 0 0 r
s
.24 .35 .67 r
.49714 .3964 m
.49715 .3967 L
s
.266 .377 .73 r
.6278 .51517 m .64603 .51811 L .6603 .49427 L p F P
0 0 0 r
s
.266 .377 .73 r
.6603 .49427 m .64033 .49098 L .6278 .51517 L p F P
0 0 0 r
s
.24 .35 .67 r
.2694 .60397 m
.22247 .59729 L
s
.2694 .60397 m
.27451 .58554 L
s
.285 .413 .805 r
.57142 .58291 m .58169 .58447 L .60611 .56392 L p F P
0 0 0 r
s
.83 .24 .1 r
.56365 .59878 m
.56474 .59677 L
s
.285 .413 .805 r
.61936 .56596 m .60611 .56392 L .58169 .58447 L p F P
0 0 0 r
s
.83 .24 .1 r
.61744 .56567 m
.62241 .56322 L
s
.672 .201 .091 r
.39989 .5464 m .40344 .53701 L .41987 .56021 L p F P
0 0 0 r
s
.841 .25 .11 r
.46179 .59295 m .46003 .59686 L .44083 .57582 L p F P
0 0 0 r
s
.83 .24 .1 r
.46001 .59684 m
.46001 .59683 L
s
.841 .25 .11 r
.43835 .58166 m .44083 .57582 L .46003 .59686 L p F P
0 0 0 r
s
.257 .361 .697 r
.60006 .48433 m .62025 .48766 L .62772 .46363 L p F P
0 0 0 r
s
.257 .361 .697 r
.62772 .46363 m .60629 .46002 L .60006 .48433 L p F P
0 0 0 r
s
.24 .35 .67 r
.26588 .33319 m
.26723 .31616 L
s
.26723 .31616 m
.22026 .30771 L
s
.289 .423 .825 r
.50619 .59533 m .51325 .59637 L .51962 .57509 L p F P
0 0 0 r
s
.289 .423 .825 r
.53004 .57666 m .51962 .57509 L .51325 .59637 L p F P
0 0 0 r
s
.83 .24 .1 r
.52862 .60575 m
.54167 .58049 L
s
.4935 .20796 m
.52381 .2044 L
s
.52381 .2044 m
.53678 .16971 L
s
.273 .391 .758 r
.62778 .54157 m .64369 .54408 L .66416 .52104 L p F P
0 0 0 r
s
.273 .391 .758 r
.66416 .52104 m .64603 .51811 L .62778 .54157 L p F P
0 0 0 r
s
.83 .24 .1 r
.66311 .51957 m
.66505 .5163 L
s
.66303 .51971 m
.66311 .51957 L
s
.211 .286 .545 r
.40432 .38018 m .42774 .38427 L .42942 .36621 L p F P
0 0 0 r
s
.211 .286 .545 r
.42942 .36621 m .40654 .36216 L .40432 .38018 L p F P
0 0 0 r
s
.279 .403 .783 r
.60611 .56392 m .61936 .56596 L .64369 .54408 L p F P
0 0 0 r
s
.285 .413 .805 r
.56112 .58136 m .57142 .58291 L .5928 .56186 L p F P
0 0 0 r
s
.285 .413 .805 r
.60611 .56392 m .5928 .56186 L .57142 .58291 L p F P
0 0 0 r
s
.83 .24 .1 r
.60389 .57234 m
.61123 .56873 L
s
.60098 .57747 m
.60389 .57234 L
s
.289 .423 .825 r
.49912 .59428 m .50619 .59533 L .50917 .57351 L p F P
0 0 0 r
s
.24 .35 .67 r
.50633 .59432 m
.50681 .5944 L
s
.289 .423 .825 r
.51962 .57509 m .50917 .57351 L .50619 .59533 L p F P
0 0 0 r
s
.83 .24 .1 r
.39196 .33677 m
.40369 .31454 L
s
.40369 .31454 m
.41386 .28238 L
s
.279 .403 .783 r
.64369 .54408 m .62778 .54157 L .60611 .56392 L p F P
0 0 0 r
s
.83 .24 .1 r
.6351 .54995 m
.63559 .54912 L
s
.289 .423 .825 r
.49203 .59323 m .49912 .59428 L .4987 .57193 L p F P
0 0 0 r
s
.24 .35 .67 r
.4991 .59325 m
.49958 .59332 L
s
.289 .423 .825 r
.50917 .57351 m .4987 .57193 L .49912 .59428 L p F P
0 0 0 r
s
.245 .342 .659 r
.54125 .44905 m .56306 .45273 L .56505 .4294 L p F P
0 0 0 r
s
.245 .342 .659 r
.56505 .4294 m .54256 .42554 L .54125 .44905 L p F P
0 0 0 r
s
.762 .227 .101 r
.44083 .57582 m .43835 .58166 L .41987 .56021 L p F P
0 0 0 r
s
.266 .377 .73 r
.60949 .51221 m .6278 .51517 L .64033 .49098 L p F P
0 0 0 r
s
.24 .35 .67 r
.62541 .51484 m
.62541 .51478 L
s
.266 .377 .73 r
.64033 .49098 m .62025 .48766 L .60949 .51221 L p F P
0 0 0 r
s
.83 .24 .1 r
.47842 .59521 m
.49556 .60089 L
s
.47498 .59407 m
.47842 .59521 L
s
.285 .413 .805 r
.55079 .5798 m .56112 .58136 L .57945 .5598 L p F P
0 0 0 r
s
.285 .413 .805 r
.5928 .56186 m .57945 .5598 L .56112 .58136 L p F P
0 0 0 r
s
.231 .318 .61 r
.47425 .4138 m .49716 .41774 L .49715 .3964 L p F P
0 0 0 r
s
.231 .318 .61 r
.49715 .3964 m .47416 .39238 L .47425 .4138 L p F P
0 0 0 r
s
.273 .391 .758 r
.6118 .53905 m .62778 .54157 L .64603 .51811 L p F P
0 0 0 r
s
.273 .391 .758 r
.64603 .51811 m .6278 .51517 L .6118 .53905 L p F P
0 0 0 r
s
.83 .24 .1 r
.63559 .54912 m
.64465 .5336 L
s
.24 .35 .67 r
.62541 .51484 m
.62777 .51522 L
s
.279 .403 .783 r
.5928 .56186 m .60611 .56392 L .62778 .54157 L p F P
0 0 0 r
s
.257 .361 .697 r
.57976 .48097 m .60006 .48433 L .60629 .46002 L p F P
0 0 0 r
s
.257 .361 .697 r
.60629 .46002 m .58474 .45639 L .57976 .48097 L p F P
0 0 0 r
s
.24 .35 .67 r
.61968 .54627 m
.62074 .54046 L
s
.62443 .5202 m
.62541 .51484 L
s
.289 .423 .825 r
.48494 .59218 m .49203 .59323 L .48819 .57034 L p F P
0 0 0 r
s
.24 .35 .67 r
.49186 .59218 m
.49234 .59225 L
s
.289 .423 .825 r
.4987 .57193 m .48819 .57034 L .49203 .59323 L p F P
0 0 0 r
s
.83 .24 .1 r
.49556 .60089 m
.50789 .57539 L
s
.66505 .5163 m
.68137 .48881 L
s
.64465 .5336 m
.66505 .5163 L
s
.841 .25 .11 r
.46356 .58902 m .46179 .59295 L .44333 .56992 L p F P
0 0 0 r
s
.83 .24 .1 r
.46176 .59293 m
.46177 .59292 L
s
.841 .25 .11 r
.44083 .57582 m .44333 .56992 L .46179 .59295 L p F P
0 0 0 r
s
.226 .065 .035 r
.38024 .43689 m .37568 .45076 L .37175 .42733 L p F P
0 0 0 r
s
.226 .065 .035 r
.37175 .42733 m .37641 .41274 L .38024 .43689 L p F P
0 0 0 r
s
.211 .286 .545 r
.38074 .37606 m .40432 .38018 L .40654 .36216 L p F P
0 0 0 r
s
.24 .35 .67 r
.40574 .36259 m
.40575 .36202 L
s
.211 .286 .545 r
.40654 .36216 m .38352 .35808 L .38074 .37606 L p F P
0 0 0 r
s
.285 .413 .805 r
.54043 .57823 m .55079 .5798 L .56605 .55773 L p F P
0 0 0 r
s
.285 .413 .805 r
.57945 .5598 m .56605 .55773 L .55079 .5798 L p F P
0 0 0 r
s
.83 .24 .1 r
.56474 .59677 m
.57421 .57941 L
s
.279 .403 .783 r
.62778 .54157 m .6118 .53905 L .5928 .56186 L p F P
0 0 0 r
s
.289 .423 .825 r
.47782 .59113 m .48494 .59218 L .47765 .56875 L p F P
0 0 0 r
s
.24 .35 .67 r
.4846 .5911 m
.48509 .59118 L
s
.289 .423 .825 r
.48819 .57034 m .47765 .56875 L .48494 .59218 L p F P
0 0 0 r
s
.24 .35 .67 r
.36815 .5991 m
.32161 .59236 L
s
.36815 .5991 m
.37515 .57489 L
s
.83 .24 .1 r
.57421 .57941 m
.60389 .57234 L
s
.433 .13 .063 r
.39358 .50163 m .38958 .51279 L .37874 .48831 L p F P
0 0 0 r
s
.433 .13 .063 r
.37874 .48831 m .38301 .47579 L .39358 .50163 L p F P
0 0 0 r
s
.279 .403 .783 r
.57945 .5598 m .5928 .56186 L .6118 .53905 L p F P
0 0 0 r
s
.289 .423 .825 r
.4707 .59007 m .47782 .59113 L .46708 .56716 L p F P
0 0 0 r
s
.24 .35 .67 r
.47733 .59003 m
.47782 .5901 L
s
.289 .423 .825 r
.47765 .56875 m .46708 .56716 L .47782 .59113 L p F P
0 0 0 r
s
.24 .35 .67 r
.46735 .58958 m
.46769 .5886 L
s
.46769 .5886 m
.47053 .58902 L
s
.266 .377 .73 r
.59109 .50924 m .60949 .51221 L .62025 .48766 L p F P
0 0 0 r
s
.266 .377 .73 r
.62025 .48766 m .60006 .48433 L .59109 .50924 L p F P
0 0 0 r
s
.245 .342 .659 r
.51932 .44536 m .54125 .44905 L .54256 .42554 L p F P
0 0 0 r
s
.24 .35 .67 r
.54192 .42608 m
.54193 .42543 L
s
.245 .342 .659 r
.54256 .42554 m .51993 .42165 L .51932 .44536 L p F P
0 0 0 r
s
.273 .391 .758 r
.59575 .53651 m .6118 .53905 L .6278 .51517 L p F P
0 0 0 r
s
.273 .391 .758 r
.6278 .51517 m .60949 .51221 L .59575 .53651 L p F P
0 0 0 r
s
.285 .413 .805 r
.53004 .57666 m .54043 .57823 L .5526 .55566 L p F P
0 0 0 r
s
.285 .413 .805 r
.56605 .55773 m .5526 .55566 L .54043 .57823 L p F P
0 0 0 r
s
.24 .35 .67 r
.3586 .37334 m
.35975 .34987 L
s
.35975 .34987 m
.3131 .34158 L
s
.83 .24 .1 r
.38326 .37362 m
.38691 .36202 L
s
.231 .318 .61 r
.4512 .40984 m .47425 .4138 L .47416 .39238 L p F P
0 0 0 r
s
.231 .318 .61 r
.47416 .39238 m .45102 .38834 L .4512 .40984 L p F P
0 0 0 r
s
.24 .35 .67 r
.22247 .59729 m
.17496 .59053 L
s
.22247 .59729 m
.22681 .57863 L
s
.257 .361 .697 r
.55934 .4776 m .57976 .48097 L .58474 .45639 L p F P
0 0 0 r
s
.257 .361 .697 r
.58474 .45639 m .56306 .45273 L .55934 .4776 L p F P
0 0 0 r
s
.289 .423 .825 r
.46356 .58902 m .4707 .59007 L .45649 .56556 L p F P
0 0 0 r
s
.83 .24 .1 r
.46353 .58899 m
.46354 .58896 L
s
.289 .423 .825 r
.46708 .56716 m .45649 .56556 L .4707 .59007 L p F P
0 0 0 r
s
.83 .24 .1 r
.46501 .58571 m
.46568 .58421 L
s
.24 .35 .67 r
.46227 .5878 m
.46323 .58794 L
s
.279 .403 .783 r
.6118 .53905 m .59575 .53651 L .57945 .5598 L p F P
0 0 0 r
s
.83 .24 .1 r
.60389 .57234 m
.61879 .54613 L
s
.762 .227 .101 r
.41987 .56021 m .42297 .55245 L .44083 .57582 L p F P
0 0 0 r
s
.672 .201 .091 r
.42297 .55245 m .41987 .56021 L .40344 .53701 L p F P
0 0 0 r
s
.24 .35 .67 r
.22026 .30771 m
.21806 .32469 L
s
.154 .045 .022 r
.38118 .39781 m .37641 .41274 L .37596 .3913 L p F P
0 0 0 r
s
.83 .24 .1 r
.37731 .39249 m
.37735 .39304 L
s
.154 .045 .022 r
.37596 .3913 m .38074 .37606 L .38118 .39781 L p F P
0 0 0 r
s
.279 .403 .783 r
.56605 .55773 m .57945 .5598 L .59575 .53651 L p F P
0 0 0 r
s
.285 .413 .805 r
.51962 .57509 m .53004 .57666 L .5391 .55357 L p F P
0 0 0 r
s
.285 .413 .805 r
.5526 .55566 m .5391 .55357 L .53004 .57666 L p F P
0 0 0 r
s
.841 .25 .11 r
.44333 .56992 m .44586 .56395 L .46356 .58902 L p F P
0 0 0 r
s
.289 .423 .825 r
.45649 .56556 m .44586 .56395 L .46356 .58902 L p F P
0 0 0 r
s
.24 .35 .67 r
.4217 .58179 m
.45974 .58742 L
s
.564 .169 .078 r
.40704 .52746 m .40344 .53701 L .38958 .51279 L p F P
0 0 0 r
s
.564 .169 .078 r
.38958 .51279 m .39358 .50163 L .40704 .52746 L p F P
0 0 0 r
s
.83 .24 .1 r
.39427 .50296 m
.39453 .50223 L
s
.762 .227 .101 r
.44333 .56992 m .44083 .57582 L .42297 .55245 L p F P
0 0 0 r
s
.266 .377 .73 r
.57259 .50625 m .59109 .50924 L .60006 .48433 L p F P
0 0 0 r
s
.266 .377 .73 r
.60006 .48433 m .57976 .48097 L .57259 .50625 L p F P
0 0 0 r
s
.273 .391 .758 r
.57963 .53397 m .59575 .53651 L .60949 .51221 L p F P
0 0 0 r
s
.273 .391 .758 r
.60949 .51221 m .59109 .50924 L .57963 .53397 L p F P
0 0 0 r
s
.83 .24 .1 r
.71916 .30548 m
.73682 .27289 L
s
.71916 .30548 m
.73203 .33157 L
s
.672 .201 .091 r
.40344 .53701 m .40704 .52746 L .42297 .55245 L p F P
0 0 0 r
s
.285 .413 .805 r
.50917 .57351 m .51962 .57509 L .52555 .55148 L p F P
0 0 0 r
s
.285 .413 .805 r
.5391 .55357 m .52555 .55148 L .51962 .57509 L p F P
0 0 0 r
s
.245 .342 .659 r
.49725 .44164 m .51932 .44536 L .51993 .42165 L p F P
0 0 0 r
s
.245 .342 .659 r
.51993 .42165 m .49716 .41774 L .49725 .44164 L p F P
0 0 0 r
s
.279 .403 .783 r
.59575 .53651 m .57963 .53397 L .56605 .55773 L p F P
0 0 0 r
s
.279 .403 .783 r
.5526 .55566 m .56605 .55773 L .57963 .53397 L p F P
0 0 0 r
s
.83 .24 .1 r
.72086 .38877 m
.73857 .35813 L
s
.72086 .38877 m
.72034 .41457 L
s
.231 .318 .61 r
.428 .40585 m .4512 .40984 L .45102 .38834 L p F P
0 0 0 r
s
.231 .318 .61 r
.45102 .38834 m .42774 .38427 L .428 .40585 L p F P
0 0 0 r
s
.257 .361 .697 r
.53882 .47421 m .55934 .4776 L .56306 .45273 L p F P
0 0 0 r
s
.257 .361 .697 r
.56306 .45273 m .54125 .44905 L .53882 .47421 L p F P
0 0 0 r
s
.285 .413 .805 r
.4987 .57193 m .50917 .57351 L .51195 .54938 L p F P
0 0 0 r
s
.285 .413 .805 r
.52555 .55148 m .51195 .54938 L .50917 .57351 L p F P
0 0 0 r
s
.83 .24 .1 r
.46607 .21667 m
.4935 .20796 L
s
.4935 .20796 m
.50588 .17302 L
s
.63515 .19001 m
.60261 .17845 L
s
.66589 .20583 m
.63515 .19001 L
s
.279 .403 .783 r
.5391 .55357 m .5526 .55566 L .56344 .53141 L p F P
0 0 0 r
s
.279 .403 .783 r
.57963 .53397 m .56344 .53141 L .5526 .55566 L p F P
0 0 0 r
s
.24 .35 .67 r
.32161 .59236 m
.27451 .58554 L
s
.32161 .59236 m
.32801 .5679 L
s
.273 .391 .758 r
.56344 .53141 m .57963 .53397 L .59109 .50924 L p F P
0 0 0 r
s
.273 .391 .758 r
.59109 .50924 m .57259 .50625 L .56344 .53141 L p F P
0 0 0 r
s
.294 .087 .046 r
.38738 .463 m .38301 .47579 L .37568 .45076 L p F P
0 0 0 r
s
.294 .087 .046 r
.37568 .45076 m .38024 .43689 L .38738 .463 L p F P
0 0 0 r
s
.266 .377 .73 r
.55399 .50325 m .57259 .50625 L .57976 .48097 L p F P
0 0 0 r
s
.266 .377 .73 r
.57976 .48097 m .55934 .4776 L .55399 .50325 L p F P
0 0 0 r
s
.83 .24 .1 r
.41386 .28238 m
.43177 .26403 L
s
.43177 .26403 m
.4427 .23037 L
s
.285 .413 .805 r
.48819 .57034 m .4987 .57193 L .4983 .54728 L p F P
0 0 0 r
s
.285 .413 .805 r
.51195 .54938 m .4983 .54728 L .4987 .57193 L p F P
0 0 0 r
s
.83 .24 .1 r
.69376 .22537 m
.66589 .20583 L
s
.245 .342 .659 r
.47505 .43789 m .49725 .44164 L .49716 .41774 L p F P
0 0 0 r
s
.24 .35 .67 r
.49647 .41836 m
.4965 .41762 L
s
.245 .342 .659 r
.49716 .41774 m .47425 .4138 L .47505 .43789 L p F P
0 0 0 r
s
.24 .35 .67 r
.31125 .36507 m
.3131 .34158 L
s
.3131 .34158 m
.26588 .33319 L
s
.83 .24 .1 r
.60261 .17845 m
.56943 .17158 L
s
.24 .35 .67 r
.37515 .57489 m
.4217 .58179 L
s
.257 .361 .697 r
.51817 .47081 m .53882 .47421 L .54125 .44905 L p F P
0 0 0 r
s
.24 .35 .67 r
.54057 .4497 m
.54063 .44895 L
s
.257 .361 .697 r
.54125 .44905 m .51932 .44536 L .51817 .47081 L p F P
0 0 0 r
s
.231 .318 .61 r
.40466 .40184 m .428 .40585 L .42774 .38427 L p F P
0 0 0 r
s
.231 .318 .61 r
.42774 .38427 m .40432 .38018 L .40466 .40184 L p F P
0 0 0 r
s
.24 .35 .67 r
.17851 .57164 m
.17496 .59053 L
s
.279 .403 .783 r
.52555 .55148 m .5391 .55357 L .54717 .52884 L p F P
0 0 0 r
s
.279 .403 .783 r
.56344 .53141 m .54717 .52884 L .5391 .55357 L p F P
0 0 0 r
s
.285 .413 .805 r
.47765 .56875 m .48819 .57034 L .4846 .54516 L p F P
0 0 0 r
s
.285 .413 .805 r
.4983 .54728 m .4846 .54516 L .48819 .57034 L p F P
0 0 0 r
s
.83 .24 .1 r
.69566 .4676 m
.71286 .43869 L
s
.69566 .4676 m
.68137 .48881 L
s
.273 .391 .758 r
.54717 .52884 m .56344 .53141 L .57259 .50625 L p F P
0 0 0 r
s
.762 .227 .101 r
.44586 .56395 m .44333 .56992 L .42611 .54459 L p F P
0 0 0 r
s
.762 .227 .101 r
.42297 .55245 m .42611 .54459 L .44333 .56992 L p F P
0 0 0 r
s
.273 .391 .758 r
.57259 .50625 m .55399 .50325 L .54717 .52884 L p F P
0 0 0 r
s
.672 .201 .091 r
.42611 .54459 m .42297 .55245 L .40704 .52746 L p F P
0 0 0 r
s
.266 .377 .73 r
.53531 .50023 m .55399 .50325 L .55934 .4776 L p F P
0 0 0 r
s
.266 .377 .73 r
.55934 .4776 m .53882 .47421 L .53531 .50023 L p F P
0 0 0 r
s
.83 .24 .1 r
.57421 .57941 m
.58855 .55311 L
s
.57421 .57941 m
.54167 .58049 L
s
.285 .413 .805 r
.46708 .56716 m .47765 .56875 L .47085 .54304 L p F P
0 0 0 r
s
.83 .24 .1 r
.46568 .58421 m
.46661 .58215 L
s
.285 .413 .805 r
.4846 .54516 m .47085 .54304 L .47765 .56875 L p F P
0 0 0 r
s
.279 .403 .783 r
.51195 .54938 m .52555 .55148 L .53084 .52626 L p F P
0 0 0 r
s
.279 .403 .783 r
.54717 .52884 m .53084 .52626 L .52555 .55148 L p F P
0 0 0 r
s
.24 .35 .67 r
.3586 .37334 m
.3804 .37714 L
s
.245 .342 .659 r
.45271 .43413 m .47505 .43789 L .47425 .4138 L p F P
0 0 0 r
s
.245 .342 .659 r
.47425 .4138 m .4512 .40984 L .45271 .43413 L p F P
0 0 0 r
s
.257 .361 .697 r
.49741 .46738 m .51817 .47081 L .51932 .44536 L p F P
0 0 0 r
s
.257 .361 .697 r
.51932 .44536 m .49725 .44164 L .49741 .46738 L p F P
0 0 0 r
s
.433 .13 .063 r
.39764 .49026 m .39358 .50163 L .38301 .47579 L p F P
0 0 0 r
s
.83 .24 .1 r
.3938 .50101 m
.39453 .50223 L
s
.433 .13 .063 r
.38301 .47579 m .38738 .463 L .39764 .49026 L p F P
0 0 0 r
s
.273 .391 .758 r
.53084 .52626 m .54717 .52884 L .55399 .50325 L p F P
0 0 0 r
s
.231 .318 .61 r
.38118 .39781 m .40466 .40184 L .40432 .38018 L p F P
0 0 0 r
s
.231 .318 .61 r
.40432 .38018 m .38074 .37606 L .38118 .39781 L p F P
0 0 0 r
s
.83 .24 .1 r
.3824 .37635 m
.38326 .37362 L
s
.38691 .36202 m
.39196 .33677 L
s
.39196 .33677 m
.402 .30468 L
s
.71772 .24798 m
.69376 .22537 L
s
.226 .065 .035 r
.3849 .42269 m .38024 .43689 L .37641 .41274 L p F P
0 0 0 r
s
.226 .065 .035 r
.37641 .41274 m .38118 .39781 L .3849 .42269 L p F P
0 0 0 r
s
.285 .413 .805 r
.45649 .56556 m .46708 .56716 L .45705 .54091 L p F P
0 0 0 r
s
.285 .413 .805 r
.47085 .54304 m .45705 .54091 L .46708 .56716 L p F P
0 0 0 r
s
.83 .24 .1 r
.46661 .58215 m
.47463 .56431 L
s
.273 .391 .758 r
.55399 .50325 m .53531 .50023 L .53084 .52626 L p F P
0 0 0 r
s
.279 .403 .783 r
.4983 .54728 m .51195 .54938 L .51443 .52367 L p F P
0 0 0 r
s
.279 .403 .783 r
.53084 .52626 m .51443 .52367 L .51195 .54938 L p F P
0 0 0 r
s
.83 .24 .1 r
.64465 .5336 m
.6607 .50615 L
s
.64465 .5336 m
.61879 .54613 L
s
.56943 .17158 m
.53678 .16971 L
s
.266 .377 .73 r
.51653 .4972 m .53531 .50023 L .53882 .47421 L p F P
0 0 0 r
s
.24 .35 .67 r
.5303 .52618 m
.53492 .50023 L
s
.53492 .50023 m
.5353 .50029 L
s
.53492 .50023 m
.53493 .50017 L
s
.53818 .47487 m
.53828 .47413 L
s
.266 .377 .73 r
.53882 .47421 m .51817 .47081 L .51653 .4972 L p F P
0 0 0 r
s
.672 .201 .091 r
.40704 .52746 m .4107 .51776 L .42611 .54459 L p F P
0 0 0 r
s
.564 .169 .078 r
.4107 .51776 m .40704 .52746 L .39358 .50163 L p F P
0 0 0 r
s
.83 .24 .1 r
.39453 .50223 m
.39619 .50409 L
s
.24 .35 .67 r
.27451 .58554 m
.22681 .57863 L
s
.27451 .58554 m
.28028 .56083 L
s
.285 .413 .805 r
.44586 .56395 m .45649 .56556 L .44319 .53877 L p F P
0 0 0 r
s
.285 .413 .805 r
.45705 .54091 m .44319 .53877 L .45649 .56556 L p F P
0 0 0 r
s
.564 .169 .078 r
.39358 .50163 m .39764 .49026 L .4107 .51776 L p F P
0 0 0 r
s
.273 .391 .758 r
.51443 .52367 m .53084 .52626 L .53531 .50023 L p F P
0 0 0 r
s
.245 .342 .659 r
.43024 .43034 m .45271 .43413 L .4512 .40984 L p F P
0 0 0 r
s
.24 .35 .67 r
.45046 .41056 m
.45051 .40972 L
s
.245 .342 .659 r
.4512 .40984 m .428 .40585 L .43024 .43034 L p F P
0 0 0 r
s
.279 .403 .783 r
.4846 .54516 m .4983 .54728 L .49795 .52107 L p F P
0 0 0 r
s
.279 .403 .783 r
.51443 .52367 m .49795 .52107 L .4983 .54728 L p F P
0 0 0 r
s
.24 .35 .67 r
.2633 .3567 m
.26588 .33319 L
s
.26588 .33319 m
.21806 .32469 L
s
.257 .361 .697 r
.47654 .46393 m .49741 .46738 L .49725 .44164 L p F P
0 0 0 r
s
.24 .35 .67 r
.4946 .44448 m
.49489 .44124 L
s
.257 .361 .697 r
.49725 .44164 m .47505 .43789 L .47654 .46393 L p F P
0 0 0 r
s
.24 .35 .67 r
.37515 .57489 m
.32801 .5679 L
s
.37515 .57489 m
.38221 .54552 L
s
.273 .391 .758 r
.53531 .50023 m .51653 .4972 L .51443 .52367 L p F P
0 0 0 r
s
.762 .227 .101 r
.42611 .54459 m .42929 .53663 L .44586 .56395 L p F P
0 0 0 r
s
.24 .35 .67 r
.4217 .58179 m
.42919 .55267 L
s
.285 .413 .805 r
.44319 .53877 m .42929 .53663 L .44586 .56395 L p F P
0 0 0 r
s
.24 .35 .67 r
.42919 .55267 m
.43856 .5541 L
s
.83 .24 .1 r
.44138 .55315 m
.44361 .5478 L
s
.266 .377 .73 r
.49765 .49415 m .51653 .4972 L .51817 .47081 L p F P
0 0 0 r
s
.266 .377 .73 r
.51817 .47081 m .49741 .46738 L .49765 .49415 L p F P
0 0 0 r
s
.83 .24 .1 r
.73203 .33157 m
.7502 .29923 L
s
.73203 .33157 m
.73857 .35813 L
s
.273 .391 .758 r
.49795 .52107 m .51443 .52367 L .51653 .4972 L p F P
0 0 0 r
s
.279 .403 .783 r
.47085 .54304 m .4846 .54516 L .48139 .51846 L p F P
0 0 0 r
s
.279 .403 .783 r
.49795 .52107 m .48139 .51846 L .4846 .54516 L p F P
0 0 0 r
s
.672 .201 .091 r
.42929 .53663 m .42611 .54459 L .4107 .51776 L p F P
0 0 0 r
s
.24 .35 .67 r
.31125 .36507 m
.3586 .37334 L
s
.35602 .40217 m
.3586 .37334 L
s
.273 .391 .758 r
.51653 .4972 m .49765 .49415 L .49795 .52107 L p F P
0 0 0 r
s
.245 .342 .659 r
.40764 .42653 m .43024 .43034 L .428 .40585 L p F P
0 0 0 r
s
.245 .342 .659 r
.428 .40585 m .40466 .40184 L .40764 .42653 L p F P
0 0 0 r
s
.257 .361 .697 r
.45554 .46046 m .47654 .46393 L .47505 .43789 L p F P
0 0 0 r
s
.257 .361 .697 r
.47505 .43789 m .45271 .43413 L .45554 .46046 L p F P
0 0 0 r
s
.83 .24 .1 r
.54167 .58049 m
.55534 .55402 L
s
.54167 .58049 m
.50789 .57539 L
s
.4427 .23037 m
.46607 .21667 L
s
.46607 .21667 m
.47794 .18153 L
s
.279 .403 .783 r
.45705 .54091 m .47085 .54304 L .46476 .51583 L p F P
0 0 0 r
s
.279 .403 .783 r
.48139 .51846 m .46476 .51583 L .47085 .54304 L p F P
0 0 0 r
s
.294 .087 .046 r
.39184 .44995 m .38738 .463 L .38024 .43689 L p F P
0 0 0 r
s
.294 .087 .046 r
.38024 .43689 m .3849 .42269 L .39184 .44995 L p F P
0 0 0 r
s
.273 .391 .758 r
.48139 .51846 m .49795 .52107 L .49765 .49415 L p F P
0 0 0 r
s
.266 .377 .73 r
.47867 .49108 m .49765 .49415 L .49741 .46738 L p F P
0 0 0 r
s
.24 .35 .67 r
.49115 .4753 m
.49231 .46654 L
s
.266 .377 .73 r
.49741 .46738 m .47654 .46393 L .47867 .49108 L p F P
0 0 0 r
s
.24 .35 .67 r
.38221 .54552 m
.42919 .55267 L
s
.42919 .55267 m
.43087 .54476 L
s
.43087 .54476 m
.43117 .54333 L
s
.83 .24 .1 r
.73682 .27289 m
.71772 .24798 L
s
.43581 .54175 m
.44361 .5478 L
s
.72034 .41457 m
.73828 .38411 L
s
.72034 .41457 m
.71286 .43869 L
s
.24 .35 .67 r
.22681 .57863 m
.17851 .57164 L
s
.22681 .57863 m
.23195 .55367 L
s
.273 .391 .758 r
.49765 .49415 m .47867 .49108 L .48139 .51846 L p F P
0 0 0 r
s
.279 .403 .783 r
.44319 .53877 m .45705 .54091 L .44806 .5132 L p F P
0 0 0 r
s
.279 .403 .783 r
.46476 .51583 m .44806 .5132 L .45705 .54091 L p F P
0 0 0 r
s
.83 .24 .1 r
.53678 .16971 m
.50588 .17302 L
s
.245 .342 .659 r
.3849 .42269 m .40764 .42653 L .40466 .40184 L p F P
0 0 0 r
s
.24 .35 .67 r
.40387 .40268 m
.40394 .40172 L
s
.245 .342 .659 r
.40466 .40184 m .38118 .39781 L .3849 .42269 L p F P
0 0 0 r
s
.83 .24 .1 r
.3839 .4052 m
.38906 .38925 L
s
.38363 .40605 m
.3839 .4052 L
s
.257 .361 .697 r
.43443 .45698 m .45554 .46046 L .45271 .43413 L p F P
0 0 0 r
s
.257 .361 .697 r
.45271 .43413 m .43024 .43034 L .43443 .45698 L p F P
0 0 0 r
s
.273 .391 .758 r
.46476 .51583 m .48139 .51846 L .47867 .49108 L p F P
0 0 0 r
s
.24 .35 .67 r
.21806 .32469 m
.21474 .34823 L
s
.32801 .5679 m
.28028 .56083 L
s
.32801 .5679 m
.33463 .53828 L
s
.83 .24 .1 r
.402 .30468 m
.41386 .28238 L
s
.41386 .28238 m
.42452 .24869 L
s
.672 .201 .091 r
.4107 .51776 m .41442 .50788 L .42929 .53663 L p F P
0 0 0 r
s
.564 .169 .078 r
.41442 .50788 m .4107 .51776 L .39764 .49026 L p F P
0 0 0 r
s
.266 .377 .73 r
.4596 .488 m .47867 .49108 L .47654 .46393 L p F P
0 0 0 r
s
.266 .377 .73 r
.47654 .46393 m .45554 .46046 L .4596 .488 L p F P
0 0 0 r
s
.279 .403 .783 r
.42929 .53663 m .44319 .53877 L .43128 .51055 L p F P
0 0 0 r
s
.279 .403 .783 r
.44806 .5132 m .43128 .51055 L .44319 .53877 L p F P
0 0 0 r
s
.433 .13 .063 r
.40179 .47867 m .39764 .49026 L .38738 .463 L p F P
0 0 0 r
s
.433 .13 .063 r
.38738 .463 m .39184 .44995 L .40179 .47867 L p F P
0 0 0 r
s
.24 .35 .67 r
.35602 .40217 m
.38079 .4064 L
s
.38079 .4064 m
.38212 .40663 L
s
.83 .24 .1 r
.50789 .57539 m
.52082 .54868 L
s
.50789 .57539 m
.47463 .56431 L
s
.273 .391 .758 r
.47867 .49108 m .4596 .488 L .46476 .51583 L p F P
0 0 0 r
s
.83 .24 .1 r
.44361 .5478 m
.47463 .56431 L
s
.44361 .5478 m
.455 .52041 L
s
.273 .391 .758 r
.44806 .5132 m .46476 .51583 L .4596 .488 L p F P
0 0 0 r
s
.564 .169 .078 r
.39764 .49026 m .40179 .47867 L .41442 .50788 L p F P
0 0 0 r
s
.83 .24 .1 r
.68137 .48881 m
.69846 .45999 L
s
.68137 .48881 m
.6607 .50615 L
s
.24 .35 .67 r
.2633 .3567 m
.31125 .36507 L
s
.3081 .394 m
.31125 .36507 L
s
.257 .361 .697 r
.41319 .45347 m .43443 .45698 L .43024 .43034 L p F P
0 0 0 r
s
.257 .361 .697 r
.43024 .43034 m .40764 .42653 L .41319 .45347 L p F P
0 0 0 r
s
.279 .403 .783 r
.43128 .51055 m .41442 .50788 L .42929 .53663 L p F P
0 0 0 r
s
.83 .24 .1 r
.47463 .56431 m
.48678 .53729 L
s
.266 .377 .73 r
.44043 .48491 m .4596 .488 L .45554 .46046 L p F P
0 0 0 r
s
.266 .377 .73 r
.45554 .46046 m .43443 .45698 L .44043 .48491 L p F P
0 0 0 r
s
.83 .24 .1 r
.61879 .54613 m
.6344 .51866 L
s
.61879 .54613 m
.58855 .55311 L
s
.24 .35 .67 r
.38892 .51249 m
.41669 .51684 L
s
.41669 .51684 m
.4182 .51708 L
s
.38221 .54552 m
.33463 .53828 L
s
.38221 .54552 m
.38892 .51249 L
s
.273 .391 .758 r
.4596 .488 m .44043 .48491 L .44806 .5132 L p F P
0 0 0 r
s
.273 .391 .758 r
.43128 .51055 m .44806 .5132 L .44043 .48491 L p F P
0 0 0 r
s
.83 .24 .1 r
.39698 .33009 m
.38691 .36202 L
s
.38906 .38925 m
.38691 .36202 L
s
.24 .35 .67 r
.183 .54642 m
.17851 .57164 L
s
.257 .361 .697 r
.39184 .44995 m .41319 .45347 L .40764 .42653 L p F P
0 0 0 r
s
.257 .361 .697 r
.40764 .42653 m .3849 .42269 L .39184 .44995 L p F P
0 0 0 r
s
.83 .24 .1 r
.3907 .4405 m
.39857 .41721 L
s
.266 .377 .73 r
.42116 .48179 m .44043 .48491 L .43443 .45698 L p F P
0 0 0 r
s
.266 .377 .73 r
.43443 .45698 m .41319 .45347 L .42116 .48179 L p F P
0 0 0 r
s
.24 .35 .67 r
.28028 .56083 m
.23195 .55367 L
s
.28028 .56083 m
.28644 .53094 L
s
.273 .391 .758 r
.41442 .50788 m .43128 .51055 L .42116 .48179 L p F P
0 0 0 r
s
.83 .24 .1 r
.42048 .51628 m
.42082 .51539 L
s
.273 .391 .758 r
.44043 .48491 m .42116 .48179 L .43128 .51055 L p F P
0 0 0 r
s
.83 .24 .1 r
.7502 .29923 m
.73682 .27289 L
s
.24 .35 .67 r
.3521 .43495 m
.35602 .40217 L
s
.35602 .40217 m
.3081 .394 L
s
.83 .24 .1 r
.73857 .35813 m
.75714 .32601 L
s
.73857 .35813 m
.73828 .38411 L
s
.24 .35 .67 r
.3521 .43495 m
.38636 .44064 L
s
.38636 .44064 m
.3891 .4411 L
s
.21474 .34823 m
.2633 .3567 L
s
.25957 .38571 m
.2633 .3567 L
s
.273 .391 .758 r
.42116 .48179 m .40179 .47867 L .41442 .50788 L p F P
0 0 0 r
s
.83 .24 .1 r
.42082 .51539 m
.42715 .49894 L
s
.50588 .17302 m
.47794 .18153 L
s
.266 .377 .73 r
.40179 .47867 m .42116 .48179 L .41319 .45347 L p F P
0 0 0 r
s
.266 .377 .73 r
.41319 .45347 m .39184 .44995 L .40179 .47867 L p F P
0 0 0 r
s
.83 .24 .1 r
.3993 .46519 m
.40463 .47407 L
s
.40337 .47758 m
.40463 .47407 L
s
.40332 .47772 m
.40337 .47758 L
s
.24 .35 .67 r
.39489 .47761 m
.3965 .46622 L
s
.39489 .47761 m
.40093 .47859 L
s
.83 .24 .1 r
.42452 .24869 m
.4427 .23037 L
s
.4427 .23037 m
.45417 .19509 L
s
.24 .35 .67 r
.38892 .51249 m
.34109 .50499 L
s
.38892 .51249 m
.39489 .47761 L
s
.33463 .53828 m
.28644 .53094 L
s
.33463 .53828 m
.34109 .50499 L
s
.34703 .46988 m
.39489 .47761 L
s
.83 .24 .1 r
.71286 .43869 m
.73088 .40837 L
s
.71286 .43869 m
.69846 .45999 L
s
.24 .35 .67 r
.23195 .55367 m
.183 .54642 L
s
.23195 .55367 m
.23764 .52352 L
s
.83 .24 .1 r
.58855 .55311 m
.60358 .52553 L
s
.58855 .55311 m
.55534 .55402 L
s
.24 .35 .67 r
.3038 .42692 m
.3081 .394 L
s
.3081 .394 m
.25957 .38571 L
s
.83 .24 .1 r
.39698 .33009 m
.402 .30468 L
s
.402 .30468 m
.41253 .27104 L
s
.42715 .49894 m
.40463 .47407 L
s
.40463 .47407 m
.41522 .44453 L
s
.24 .35 .67 r
.34703 .46988 m
.3521 .43495 L
s
.3521 .43495 m
.3038 .42692 L
s
.21474 .34823 m
.21042 .37733 L
s
.83 .24 .1 r
.6607 .50615 m
.67752 .47737 L
s
.6607 .50615 m
.6344 .51866 L
s
.24 .35 .67 r
.34109 .50499 m
.29265 .4974 L
s
.34109 .50499 m
.34703 .46988 L
s
.28644 .53094 m
.23764 .52352 L
s
.28644 .53094 m
.29265 .4974 L
s
.83 .24 .1 r
.39857 .41721 m
.38906 .38925 L
s
.38906 .38925 m
.39931 .35756 L
s
.24 .35 .67 r
.34703 .46988 m
.29855 .46205 L
s
.83 .24 .1 r
.75714 .32601 m
.7502 .29923 L
s
.24 .35 .67 r
.18822 .51599 m
.183 .54642 L
s
.25487 .41879 m
.25957 .38571 L
s
.25957 .38571 m
.21042 .37733 L
s
.83 .24 .1 r
.55534 .55402 m
.56968 .52626 L
s
.55534 .55402 m
.52082 .54868 L
s
.47794 .18153 m
.45417 .19509 L
s
.24 .35 .67 r
.29855 .46205 m
.3038 .42692 L
s
.3038 .42692 m
.25487 .41879 L
s
.83 .24 .1 r
.455 .52041 m
.42715 .49894 L
s
.42715 .49894 m
.43837 .46981 L
s
.73828 .38411 m
.75711 .35217 L
s
.73828 .38411 m
.73088 .40837 L
s
.24 .35 .67 r
.29265 .4974 m
.24359 .48971 L
s
.29265 .4974 m
.29855 .46205 L
s
.23764 .52352 m
.18822 .51599 L
s
.23764 .52352 m
.24359 .48971 L
s
.83 .24 .1 r
.41253 .27104 m
.42452 .24869 L
s
.42452 .24869 m
.43571 .21335 L
s
.24 .35 .67 r
.29855 .46205 m
.24944 .45412 L
s
.83 .24 .1 r
.52082 .54868 m
.53438 .52065 L
s
.52082 .54868 m
.48678 .53729 L
s
.48678 .53729 m
.455 .52041 L
s
.455 .52041 m
.46695 .49167 L
s
.69846 .45999 m
.7164 .42976 L
s
.69846 .45999 m
.67752 .47737 L
s
.24 .35 .67 r
.21042 .37733 m
.20532 .41055 L
s
.83 .24 .1 r
.48678 .53729 m
.49952 .50893 L
s
.6344 .51866 m
.65078 .48984 L
s
.6344 .51866 m
.60358 .52553 L
s
.24 .35 .67 r
.24944 .45412 m
.25487 .41879 L
s
.25487 .41879 m
.20532 .41055 L
s
.83 .24 .1 r
.40753 .29659 m
.39698 .33009 L
s
.39931 .35756 m
.39698 .33009 L
s
.41522 .44453 m
.39857 .41721 L
s
.39857 .41721 m
.40917 .38583 L
s
.24 .35 .67 r
.24359 .48971 m
.19389 .48192 L
s
.24359 .48971 m
.24944 .45412 L
s
.19389 .48192 m
.18822 .51599 L
s
.24944 .45412 m
.1997 .44609 L
s
.83 .24 .1 r
.75711 .35217 m
.75714 .32601 L
s
.45417 .19509 m
.43571 .21335 L
s
.24 .35 .67 r
.20532 .41055 m
.1997 .44609 L
s
.1997 .44609 m
.19389 .48192 L
s
.83 .24 .1 r
.73088 .40837 m
.74981 .37655 L
s
.73088 .40837 m
.7164 .42976 L
s
.60358 .52553 m
.61937 .49659 L
s
.60358 .52553 m
.56968 .52626 L
s
.40753 .29659 m
.41253 .27104 L
s
.41253 .27104 m
.42358 .23572 L
s
.43837 .46981 m
.41522 .44453 L
s
.41522 .44453 m
.42634 .41353 L
s
.67752 .47737 m
.69518 .44716 L
s
.67752 .47737 m
.65078 .48984 L
s
.40917 .38583 m
.39931 .35756 L
s
.39931 .35756 m
.41006 .32428 L
s
.56968 .52626 m
.58474 .4971 L
s
.56968 .52626 m
.53438 .52065 L
s
.46695 .49167 m
.43837 .46981 L
s
.43837 .46981 m
.45016 .43921 L
s
.74981 .37655 m
.75711 .35217 L
s
.43571 .21335 m
.42358 .23572 L
s
.53438 .52065 m
.54862 .49122 L
s
.53438 .52065 m
.49952 .50893 L
s
.49952 .50893 m
.46695 .49167 L
s
.46695 .49167 m
.47951 .46149 L
s
.7164 .42976 m
.73524 .39801 L
s
.7164 .42976 m
.69518 .44716 L
s
.49952 .50893 m
.51291 .47914 L
s
.65078 .48984 m
.66799 .45956 L
s
.65078 .48984 m
.61937 .49659 L
s
.41862 .2614 m
.40753 .29659 L
s
.41006 .32428 m
.40753 .29659 L
s
.42634 .41353 m
.40917 .38583 L
s
.40917 .38583 m
.42031 .35287 L
s
.73524 .39801 m
.74981 .37655 L
s
.61937 .49659 m
.63595 .46617 L
s
.61937 .49659 m
.58474 .4971 L
s
.42358 .23572 m
.41862 .2614 L
s
.45016 .43921 m
.42634 .41353 L
s
.42634 .41353 m
.43803 .38094 L
s
.69518 .44716 m
.71375 .4154 L
s
.69518 .44716 m
.66799 .45956 L
s
.42031 .35287 m
.41006 .32428 L
s
.41006 .32428 m
.42137 .28931 L
s
.58474 .4971 m
.60056 .46646 L
s
.58474 .4971 m
.54862 .49122 L
s
.47951 .46149 m
.45016 .43921 L
s
.45016 .43921 m
.46254 .40704 L
s
.54862 .49122 m
.5636 .46026 L
s
.54862 .49122 m
.51291 .47914 L
s
.51291 .47914 m
.47951 .46149 L
s
.47951 .46149 m
.49271 .42975 L
s
.71375 .4154 m
.73524 .39801 L
s
.51291 .47914 m
.527 .44782 L
s
.66799 .45956 m
.68609 .42772 L
s
.66799 .45956 m
.63595 .46617 L
s
.41862 .2614 m
.42137 .28931 L
s
.43803 .38094 m
.42031 .35287 L
s
.42031 .35287 m
.43202 .3182 L
s
.63595 .46617 m
.65341 .43416 L
s
.63595 .46617 m
.60056 .46646 L
s
.46254 .40704 m
.43803 .38094 L
s
.43803 .38094 m
.45033 .34665 L
s
.68609 .42772 m
.71375 .4154 L
s
.42137 .28931 m
.43202 .3182 L
s
.60056 .46646 m
.61723 .43419 L
s
.60056 .46646 m
.5636 .46026 L
s
.49271 .42975 m
.46254 .40704 L
s
.46254 .40704 m
.47559 .37317 L
s
.5636 .46026 m
.57937 .42767 L
s
.5636 .46026 m
.527 .44782 L
s
.527 .44782 m
.49271 .42975 L
s
.49271 .42975 m
.50661 .39633 L
s
.527 .44782 m
.54183 .41483 L
s
.65341 .43416 m
.68609 .42772 L
s
.43202 .3182 m
.45033 .34665 L
s
.61723 .43419 m
.65341 .43416 L
s
.45033 .34665 m
.47559 .37317 L
s
.57937 .42767 m
.61723 .43419 L
s
.47559 .37317 m
.50661 .39633 L
s
.54183 .41483 m
.57937 .42767 L
s
.50661 .39633 m
.54183 .41483 L
s
0 0 0 r
.25 Mabswid
.16861 .50547 m
.24028 .08168 L
s
.24028 .08168 m
.19793 .35868 L
s
.19793 .35868 m
.13045 .74993 L
s
.13045 .74993 m
.16861 .50547 L
s
.91053 .22236 m
.24028 .08168 L
s
.24028 .08168 m
.19793 .35868 L
s
.19793 .35868 m
.97075 .49223 L
s
.97075 .49223 m
.91053 .22236 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{500, 500},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40007d0001m2000`400?l00000o`00003oo`3ooooe
0?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3o
m^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40
oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?of
k_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3o
ool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^
m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?oo
o`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd
0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo
003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0
ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool0
0?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03o
m^h10?ooo`00o`3om^kd0?ofkP40oooo001g0?ofkP<00000o`3om^ij0?ofkP40oooo001g0?ofkP03
0000003om^h0ooK^00D00000o`3om^ie0?ofkP40oooo001g0?ofkP030000003om^h0ooK^00D0ooK^
1000003o0?ofkW40ooK^0@3oool007L0ooK^00<000000?ofkP3om^h02@3om^h500000?l0ooK^K03o
m^h10?ooo`00MP3om^h00`000000ooK^0?ofkP0?0?ofkPD00000o`3om^iW0?ofkP40oooo001f0?of
kP030000003om^h0ooK^01@0ooK^1@00003o0?ofkV80ooK^0@3oool007H0ooK^00<000000?ofkP3o
m^h06@3om^h500000?l0ooK^G@3om^h10?ooo`00MP3om^h00`000000ooK^0?ofkP0N0?ofkP@00000
o`3om^iI0?ofkP40oooo001f0?ofkP030000003om^h0ooK^0280ooK^1@00003o0?ofkU@0ooK^0@3o
ool007H0ooK^00<000000?ofkP3om^h09`3om^h500000?l0ooK^C`3om^h10?ooo`00M@3om^h00`00
0000ooK^0?ofkP0]0?ofkPD00000o`3om^i:0?ofkP40oooo001e0?ofkP030000003om^h0ooK^0380
ooK^1@00003o0?ofkTD0ooK^0@3oool007D0ooK^00<000000?ofkP3om^h0=`3om^h400000?l0ooK^
@@3om^h10?ooo`00M@3om^h00`000000ooK^0?ofkP0k0?ofkPD00000o`3om^hl0?ofkP40oooo001e
0?ofkP030000003om^h0ooK^0400ooK^1@00003o0?ofkSL0ooK^0@3oool007D0ooK^00<000000?of
kP3om^h0A@3om^h500000?l0ooK^<P3om^h10?ooo`00M03om^h2000004`0ooK^1000003o0?ofkRh0
ooK^0@3oool007@0ooK^00<000000?ofkP3om^h0C`3om^h500000?l0ooK^:@3om^h10?ooo`00M03o
m^h00`000000ooK^0?ofkP1D0?ofkPD00000o`3om^hT0?ofkP40oooo001d0?ofkP030000003om^h0
ooK^05T0ooK^1@00003o0?ofkQl0ooK^0@3oool007@0ooK^00<000000?ofkP3om^h0GP3om^h50000
0?l0ooK^6P3om^h10?ooo`00M03om^h00`000000ooK^0?ofkP1S0?ofkP@00000o`3om^hF0?ofkP40
oooo001c0?ofkP800000J@3om^h500000?l0ooK^4@3om^h10?ooo`00L`3om^h00`000000ooK^0?of
kP1]0?ofkPD00000o`3om^h<0?ofkP40oooo001c0?ofkP030000003om^h0ooK^0780ooK^1@00003o
0?ofkPL0ooK^0@3oool007<0ooK^00<000000?ofkP3om^h0M`3om^h500000?l0ooK^0P3om^h10?oo
o`00L`3om^h00`000000ooK^0?ofkP1l0?ofkP@00000o@3om^h10?ooo`00L`3om^h00`000000ooK^
0?ofkP200?ofkPD00000n03om^h10?ooo`00LP3om^h2000008L0ooK^1@00003c0?ofkP40oooo001b
0?ofkP800000S03om^h500000>h0ooK^0@3oool00780ooK^00<000000?ofkP3om^h0T03om^h40000
0>X0ooK^0@3oool00780ooK^00<000000?ofkP3om^h0U03om^h500000>D0ooK^0@3oool00780ooK^
00<000000?ofkP3om^h0V@3om^h500000>00ooK^0@3oool00780ooK^00<000000?ofkP3om^h0WP3o
m^h500000=/0ooK^0@3oool00740ooK^0P00002U0?ofkPD00000eP3om^h10?ooo`00L@3om^h20000
0:X0ooK^1000003B0?ofkP40oooo001a0?ofkP800000[P3om^h500000<d0ooK^0@3oool00740ooK^
00<000000?ofkP3om^h0/P3om^h500000<P0ooK^0@3oool00740ooK^00<000000?ofkP3om^h0]`3o
m^h500000<<0ooK^0@3oool00740ooK^00<000000?ofkP3om^h0_03om^h500000;h0ooK^0@3oool0
0700ooK^0P0000330?ofkP@00000^P3om^h10?ooo`00L03om^h200000<L0ooK^1@00002e0?ofkP40
oooo001`0?ofkP800000c03om^h500000;00ooK^0@3oool00700ooK^00<000000?ofkP3om^h0d03o
m^h500000:/0ooK^0@3oool00700ooK^00<000000?ofkP3om^h0U@3om^h<0=@m6C@0ooK^1000002W
0?ofkP40oooo001`0?ofkP030000003om^h0ooK^08d0ooK^203D?AT30?ofkP030=@m6@3om^h0ooK^
00H0ooK^2P3D?AT^0?ofkPD00000XP3om^h10?ooo`00K`3om^h2000008X0ooK^1@3D?AT:0?ofkP03
0=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3D?AT00`3D?AT_0?ofkPD00000W@3om^h10?ooo`00
K`3om^h2000008H0ooK^103D?AT00`3om^h0e3dI0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00h0ooK^
00<0e3dI0?ofkP3om^h0103om^h40=@m6C00ooK^1@00002H0?ofkP40oooo001_0?ofkP800000P`3o
m^h30=@m6@@0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3o
m^h0ooK^00P0ooK^103D?ATa0?ofkPD00000T`3om^h10?ooo`00K`3om^h2000007l0ooK^103D?AT7
0?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0=
0?ofkP@0e3dI<P3om^h4000008l0ooK^0@3oool006l0ooK^00<000000?ofkP3om^h0O03om^h20=@m
6@/0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^
00l0ooK^00<0e3dI0?ofkP3D?AT00P3D?ATc0?ofkPD00000RP3om^h10?ooo`00K`3om^h00`000000
ooK^0?ofkP1j0?ofkP<0e3dI2`3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00h0
ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP030?ofkP<0e3dI=@3om^h5000008D0
ooK^0@3oool006h0ooK^0P00001j0?ofkP80e3dI00<0ooK^0=@m6@3om^h02`3om^h00`3D?AT0ooK^
0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^
0?ofkP060?ofkP@0e3dI=P3om^h500000800ooK^0@3oool006h0ooK^0P00001i0?ofkP050=@m6@3o
m^h0ooK^0?ofkP3D?AT0303om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00h0ooK^
00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP<0e3dI>03om^h5000007/0ooK^
0@3oool006h0ooK^0P00001g0?ofkP80e3dI103om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3o
m^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3o
m^h0ooK^00h0ooK^0P3D?ATk0?ofkP@00000M`3om^h10?ooo`00KP3om^h2000007D0ooK^0P3D?AT5
0?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP0>
0?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h03`3om^h30=@m6Cd0ooK^1@00001b
0?ofkP40oooo001^0?ofkP030000003om^h0ooK^0780ooK^0P3D?AT70?ofkP030=@m6@3om^h0ooK^
00T0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^
00l0ooK^00<0e3dI0?ofkP3om^h03`3om^h0103D?AT0ooK^0?ofkP3om^h20=@m6D00ooK^1@00001]
0?ofkP40oooo001^0?ofkP030000003om^h0ooK^0740ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D
?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D
?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h00`3om^h20=@m
6D<0ooK^1@00001X0?ofkP40oooo001]0?ofkP800000LP3om^h20=@m6@P0ooK^00<0e3dI0?ofkP3o
m^h02P3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3o
m^h03P3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00H0ooK^0P3D?AU60?ofkP@0
0000I03om^h10?ooo`00K@3om^h200000740ooK^0P3D?AT90?ofkP030=@m6@3om^h0ooK^00T0ooK^
00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00l0ooK^
00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP080?ofkP80e3dIB03om^h5000005l0ooK^
0@3oool006d0ooK^0P00001`0?ofkP030=@m6@3om^h0e3dI00T0ooK^00<0e3dI0?ofkP3om^h02@3o
m^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h03P3o
m^h00`3D?AT0ooK^0?ofkP0@0?ofkP030=@m6@3om^h0ooK^00X0ooK^0P3D?AU;0?ofkPD00000FP3o
m^h10?ooo`00K@3om^h2000006l0ooK^00@0e3dI0?ofkP3om^h0e3dI203om^h00`3D?AT0ooK^0?of
kP0:0?ofkP030=@m6@3om^h0ooK^00P0ooK^2`3D?AT80?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0
e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP80e3dICP3om^h5000005D0ooK^0@3o
ool006d0ooK^0P00001^0?ofkP040=@m6@3om^h0ooK^0=@m6@T0ooK^00<0e3dI0?ofkP3om^h02@3o
m^h0103D?AT0ooK^0?ofkP3om^h80=@m6@<0ooK^00<0e3dI0?ofkP3om^h01@3om^h:0=@m6A00ooK^
00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP80e3dID@3om^h500000500ooK^
0@3oool006d0ooK^00<000000?ofkP3om^h0K03om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00T0ooK^
00<0e3dI0?ofkP3om^h0203om^h50=@m6@X0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^
0=@m6@030=@m6@/0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP0A0?ofkP<0e3dI
E03om^h4000004`0ooK^0@3oool006`0ooK^0P00001]0?ofkP030=@m6@3om^h0ooK^0080ooK^00<0
e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP060?ofkP<0e3dI00<0ooK^0=@m6@3om^h0303o
m^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00@0ooK^103D?AT70?ofkP030=@m6@3o
m^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h0403om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI05L0ooK^
1@0000170?ofkP40oooo001/0?ofkP800000K03om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3o
m^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h0103om^h20=@m6@<0ooK^00<0e3dI0?ofkP3om^h0303o
m^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00P0ooK^103D?AT20?ofkP030=@m6@3o
m^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h04@3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3o
m^h0ooK^05T0ooK^1@0000120?ofkP40oooo001/0?ofkP800000J`3om^h00`3D?AT0ooK^0?ofkP03
0?ofkP030=@m6@3om^h0ooK^00L0ooK^00@0e3dI0?ofkP3om^h0ooK^0`3D?AT50?ofkP030=@m6@3o
m^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP@0e3dI403o
m^h00`3D?AT0ooK^0?ofkP0@0?ofkP030=@m6@3om^h0ooK^00@0ooK^0P3D?AUN0?ofkPD00000?@3o
m^h10?ooo`00K03om^h2000006X0ooK^0P3D?AT40?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI
0?ofkP3D?AT00P3D?AT80?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h03@3om^h0
0`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0e3dI0080e3dI3@3om^h00`3D?AT0ooK^0?ofkP0@
0?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h0H03om^h5000003P0ooK^0@3oool0
06`0ooK^0P00001Z0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h01`3om^h20=@m
6@X0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^
00h0ooK^00<0e3dI0?ofkP3om^h00`3om^h30=@m6@T0ooK^00<0e3dI0?ofkP3om^h0403om^h00`3D
?AT0ooK^0?ofkP080?ofkP80e3dII@3om^h4000003@0ooK^0@3oool006`0ooK^00<000000?ofkP3o
m^h0J03om^h20=@m6@D0ooK^00<0e3dI0?ofkP3om^h01@3om^h30=@m6@/0ooK^00<0e3dI0?ofkP3o
m^h02`3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3o
m^h01P3om^h40=@m6@D0ooK^00<0e3dI0?ofkP3om^h0403om^h00`3D?AT0ooK^0?ofkP0:0?ofkP03
0=@m6@3om^h0ooK^06H0ooK^1@00000_0?ofkP40oooo001[0?ofkP800000JP3om^h20=@m6@@0ooK^
00<0e3dI0?ofkP3om^h0103om^h20=@m6@030?ofkP3D?AT0ooK^00/0ooK^00<0e3dI0?ofkP3om^h0
2`3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h0
2`3om^h30=@m6@030?ofkP3D?AT0ooK^0140ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^
0?ofkP1Z0?ofkP<00000;03om^h10?ooo`00J`3om^h2000006T0ooK^0P3D?AT50?ofkP030=@m6@3o
m^h0ooK^0080ooK^0P3D?AT30?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h02`3o
m^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h03P3o
m^h20=@m6A80ooK^00<0e3dI0?ofkP3om^h03@3om^h20=@m6F/0ooK^0P00000/0?ofkP40oooo001[
0?ofkP800000J@3om^h20=@m6@D0ooK^00<0e3dI0?ofkP3om^h00P3D?AT40?ofkP030=@m6@3om^h0
ooK^00X0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0
ooK^00h0ooK^00<0e3dI0?ofkP3om^h0403om^h30=@m6@l0ooK^00<0e3dI0?ofkP3om^h0403om^h0
0`3D?AT0ooK^0?ofkP1X0?ofkP800000;03om^h10?ooo`00J`3om^h2000006P0ooK^00<0e3dI0?of
kP3D?AT0103om^h0103D?AT0ooK^0=@m6@3D?AT60?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI
0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI
0?ofkP3om^h03`3om^h0103D?AT0ooK^0?ofkP3om^h20=@m6@d0ooK^00<0e3dI0?ofkP3om^h03`3o
m^h00`3D?AT0ooK^0=@m6@1X0?ofkP040000003om^h0ooK^000002/0ooK^0@3oool006/0ooK^0P00
001X0?ofkP80e3dI1@3om^h20=@m6@P0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?of
kP0;0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?of
kP0@0?ofkP030=@m6@3om^h0ooK^00<0ooK^0P3D?AT:0?ofkP030=@m6@3om^h0ooK^0100ooK^00@0
e3dI0?ofkP3om^h0e3dIIP3om^h01@000000ooK^0?ofkP3om^h0000002/0ooK^0@3oool006/0ooK^
0P00001W0?ofkP030=@m6@3om^h0e3dI00@0ooK^0P3D?AT80?ofkP030=@m6@3om^h0ooK^00X0ooK^
00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00h0ooK^
00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP060?ofkP80e3dI203om^h00`3D?AT0ooK^
0?ofkP0?0?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h0H`3om^h01@000000ooK^
0?ofkP3om^h0000002/0ooK^0@3oool006X0ooK^0P00001X0?ofkP030=@m6@3om^h0e3dI00<0ooK^
0P3D?AT90?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^
0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^
0?ofkP080?ofkP80e3dI1@3om^h00`3D?AT0ooK^0?ofkP0@0?ofkP030=@m6@3om^h0ooK^00<0ooK^
00<0e3dI0?ofkP3om^h0H@3om^h00`000000ooK^0?ofkP020?ofkP030000003om^h0ooK^02T0ooK^
0@3oool006X0ooK^0P00001W0?ofkP030=@m6@3om^h0e3dI00<0ooK^00<0e3dI0?ofkP3D?AT02@3o
m^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h03@3o
m^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h02`3o
m^h20=@m6@<0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3o
m^h0ooK^0600ooK^00<000000?ofkP3om^h00`3om^h00`000000ooK^0?ofkP0X0?ofkP40oooo001Z
0?ofkP800000I`3om^h00`3D?AT0ooK^0=@m6@020?ofkP040=@m6@3om^h0ooK^0=@m6@P0ooK^00<0
e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP080?ofkP/0e3dI1`3om^h00`3D?AT0ooK^0?of
kP0?0?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h03@3om^h30=@m6A80ooK^00<0
e3dI0?ofkP3om^h01P3om^h20=@m6El0ooK^00<000000?ofkP3om^h0103om^h00`000000ooK^0?of
kP0X0?ofkP40oooo001Z0?ofkP800000IP3om^h20=@m6@040?ofkP3D?AT0ooK^0=@m6@<0ooK^00<0
e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP090?ofkP040=@m6@3om^h0ooK^0?ofkPP0e3dI
0`3om^h00`3D?AT0ooK^0?ofkP050?ofkPX0e3dI3P3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m
6@3om^h0ooK^0100ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m
6@3om^h0ooK^05/0ooK^00<000000?ofkP3om^h01@3om^h00`000000ooK^0?ofkP0X0?ofkP40oooo
001Z0?ofkP800000IP3om^h00`3D?AT0ooK^0=@m6@020?ofkP040=@m6@3om^h0ooK^0=@m6@P0ooK^
00<0e3dI0?ofkP3om^h02@3om^h50=@m6@X0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^
0?ofkP050=@m6@T0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m
6@3om^h0e3dI0100ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP1J0?ofkP030000
003om^h0ooK^00D0ooK^00<000000?ofkP3om^h0:03om^h10?ooo`00JP3om^h2000006H0ooK^00D0
e3dI0?ofkP3D?AT0ooK^0=@m6@030?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h0
1@3om^h40=@m6@030?ofkP3D?AT0ooK^00`0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^
0?ofkP060?ofkPH0e3dI0P3om^h00`3D?AT0ooK^0?ofkP0@0?ofkP030=@m6@3om^h0ooK^00l0ooK^
00<0e3dI0?ofkP3om^h00P3D?AT=0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h0
F03om^h00`000000ooK^0?ofkP060?ofkP030000003om^h0ooK^02P0ooK^0@3oool006T0ooK^00<0
00000?ofkP000000I@3om^h20=@m6@030?ofkP3D?AT0e3dI00@0ooK^00<0e3dI0?ofkP3om^h01P3o
m^h00`3D?AT0ooK^0?ofkP020?ofkP<0e3dI103om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3o
m^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h0303om^h40=@m6A00ooK^00<0e3dI0?ofkP3om^h03`3o
m^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h03@3o
m^h00`3D?AT0ooK^0?ofkP1F0?ofkP030000003om^h0ooK^00P0ooK^00<000000?ofkP3om^h09`3o
m^h10?ooo`00J@3om^h2000006H0ooK^103D?AT40?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI
0?ofkP3D?AT00`3D?AT70?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h0303om^h0
0`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0e3dI0080e3dI3@3om^h00`3D?AT0ooK^0?ofkP0?
0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP0?
0?ofkP030=@m6@3om^h0ooK^05D0ooK^00<000000?ofkP3om^h0203om^h00`000000ooK^0?ofkP0W
0?ofkP40oooo001Y0?ofkP800000IP3om^h00`3D?AT0ooK^0=@m6@050?ofkP030=@m6@3om^h0ooK^
00H0ooK^0P3D?AT:0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D
?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00<0ooK^0`3D?AT90?ofkP030=@m6@3om^h0ooK^
00l0ooK^00<0e3dI0?ofkP3om^h01P3om^h20=@m6@P0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D
?AT0ooK^0=@m6@1E0?ofkP030000003om^h0ooK^00T0ooK^00<000000?ofkP3om^h09`3om^h10?oo
o`00J@3om^h2000006D0ooK^103D?AT50?ofkP030=@m6@3om^h0ooK^00@0ooK^0`3D?AT;0?ofkP03
0=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP03
0=@m6@3om^h0ooK^00H0ooK^103D?AT50?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3o
m^h0203om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3D
?AT0E03om^h00`000000ooK^0?ofkP0:0?ofkP030000003om^h0ooK^02L0ooK^0@3oool006T0ooK^
0P00001U0?ofkP<0e3dI1@3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0e3dI00`0ooK^
00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00h0ooK^
00<0e3dI0?ofkP3om^h02`3om^h30=@m6@030?ofkP3D?AT0ooK^0100ooK^00<0e3dI0?ofkP3om^h0
2P3om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00h0ooK^00D0e3dI0?ofkP3om^h0
ooK^0=@m6@1C0?ofkP030000003om^h0ooK^00/0ooK^00<000000?ofkP3om^h09P3om^h10?ooo`00
J@3om^h2000006D0ooK^0`3D?AT50?ofkP030=@m6@3om^h0ooK^0080ooK^0P3D?AT20?ofkP030=@m
6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m
6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h03P3om^h20=@m6A40ooK^00<0e3dI0?ofkP3om^h0
2`3om^h20=@m6@80ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m
6@3om^h0ooK^04l0ooK^00<000000?ofkP3om^h0303om^h00`000000ooK^0?ofkP0V0?ofkP40oooo
001X0?ofkP030000003om^h0000006@0ooK^103D?AT50?ofkP030=@m6@3om^h0ooK^0080e3dI103o
m^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h0303o
m^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00l0ooK^0`3D?AT>0?ofkP030=@m6@3o
m^h0ooK^00h0ooK^00<0e3dI0?ofkP3D?AT0403om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3o
m^h0ooK^04h0ooK^00<000000?ofkP3om^h03@3om^h00`000000ooK^0?ofkP0V0?ofkP40oooo001X
0?ofkP800000I@3om^h30=@m6@H0ooK^00<0e3dI0?ofkP3D?AT01@3om^h00`3D?AT0ooK^0?ofkP0:
0?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP0>
0?ofkP030=@m6@3om^h0ooK^00l0ooK^00@0e3dI0?ofkP3om^h0ooK^0P3D?AT<0?ofkP030=@m6@3o
m^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3o
m^h0ooK^04d0ooK^00<000000?ofkP3om^h03@3om^h00`000000ooK^0?ofkP0V0?ofkP40oooo001X
0?ofkP800000I@3om^h30=@m6@D0ooK^0`3D?AT60?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI
0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI
0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP030?ofkP80e3dI2@3om^h00`3D?AT0ooK^0?ofkP0@
0?ofkP80e3dI3`3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^04/0ooK^00<00000
0?ofkP3om^h03P3om^h00`000000ooK^0?ofkP0V0?ofkP40oooo001X0?ofkP800000I03om^h40=@m
6@D0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^
00/0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^
00l0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^
00l0ooK^00@0e3dI0?ofkP3om^h0e3dI3P3om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0
ooK^04X0ooK^00<000000?ofkP3om^h03`3om^h00`000000ooK^0?ofkP0U0?ofkP40oooo001X0?of
kP800000I03om^h30=@m6@D0ooK^0P3D?AT70?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?of
kP3om^h0303om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?of
kP3om^h03`3om^h00`3D?AT0ooK^0?ofkP070?ofkP80e3dI1@3om^h00`3D?AT0ooK^0?ofkP0@0?of
kP050=@m6@3om^h0ooK^0?ofkP3D?AT0303om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0
ooK^04T0ooK^00<000000?ofkP3om^h0403om^h00`000000ooK^0?ofkP0U0?ofkP40oooo001X0?of
kP800000I03om^h30=@m6@@0ooK^0P3D?AT80?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?of
kP3om^h02`3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?of
kP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP80e3dI0`3om^h00`3D?AT0ooK^0?ofkP0?0?of
kP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP090?of
kP030=@m6@3om^h0ooK^04L0ooK^00<000000?ofkP3om^h04@3om^h00`000000ooK^0?ofkP0U0?of
kP40oooo001W0?ofkP030000003om^h0000006<0ooK^1@3D?AT20?ofkP030=@m6@3om^h0e3dI00P0
ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP080?ofkQD0e3dI3P3om^h00`3D?AT0
ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00`0ooK^0`3D?ATB0?ofkP030=@m6@3om^h0ooK^00@0
ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^04H0
ooK^00<000000?ofkP3om^h04@3om^h00`000000ooK^0?ofkP0U0?ofkP40oooo001W0?ofkP030000
003om^h0000006<0ooK^00<0e3dI0?ofkP3D?AT00P3D?AT01@3om^h0e3dI0?ofkP3om^h0e3dI00P0
ooK^00<0e3dI0?ofkP3om^h0203om^h0103D?AT0ooK^0?ofkP3om^h80=@m6@<0ooK^00<0e3dI0?of
kP3om^h0303om^h00`3D?AT0ooK^0?ofkP050=@m6@T0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D
?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h01P3om^h20=@m
6@L0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP150?ofkP030000003om^h0ooK^
01<0ooK^00<000000?ofkP3om^h0903om^h10?ooo`00I`3om^h2000006@0ooK^0`3D?AT00`3om^h0
e3dI0=@m6@020?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h0203om^h50=@m6@X0
ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP060?ofkPH0e3dI0P3om^h00`3D?AT0
ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00l0ooK^0`3D?AT?0?ofkP030=@m6@3om^h0ooK^00P0
ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^04<0
ooK^00<000000?ofkP3om^h0503om^h00`000000ooK^0?ofkP0T0?ofkP40oooo001W0?ofkP800000
H`3om^h40=@m6@030?ofkP3D?AT0ooK^0080ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^
0?ofkP050?ofkP<0e3dI00<0ooK^0=@m6@3om^h0303om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m
6@3om^h0ooK^00`0ooK^103D?AT@0?ofkP030=@m6@3om^h0ooK^00h0ooK^00D0e3dI0?ofkP3om^h0
ooK^0=@m6@0=0?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0
ooK^0?ofkP0<0?ofkP030=@m6@3om^h0e3dI04@0ooK^00<000000?ofkP3om^h0503om^h00`000000
ooK^0?ofkP0T0?ofkP40oooo001W0?ofkP800000H`3om^h00`3D?AT0ooK^0=@m6@030=@m6@<0ooK^
00<0e3dI0?ofkP3om^h01P3om^h0103D?AT0ooK^0?ofkP3om^h40=@m6@<0ooK^00<0e3dI0?ofkP3o
m^h02`3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00l0ooK^00@0e3dI0?ofkP3D
?AT0e3dI3@3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^0080ooK^0P3D?AT;0?of
kP030=@m6@3om^h0ooK^00/0ooK^00@0e3dI0?ofkP3om^h0e3dI3`3om^h00`3D?AT0ooK^0=@m6@13
0?ofkP030000003om^h0ooK^01D0ooK^00<000000?ofkP3om^h0903om^h10?ooo`00I`3om^h20000
06<0ooK^103D?AT01@3om^h0e3dI0?ofkP3om^h0e3dI00P0ooK^00<0e3dI0?ofkP3D?AT00P3D?AT7
0?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP0>
0?ofkP030=@m6@3om^h0ooK^0080ooK^0`3D?AT:0?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI
0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI
0?ofkP3D?AT03P3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI0440ooK^00<000000?ofkP3om^h05P3o
m^h00`000000ooK^0?ofkP0T0?ofkP40oooo001V0?ofkP030000003om^h0000006<0ooK^0`3D?AT2
0?ofkP040=@m6@3om^h0ooK^0=@m6@P0ooK^0P3D?AT:0?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0
e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00D0ooK^0P3D
?AT70?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h01P3om^h20=@m6@L0ooK^00<0
e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT0
@@3om^h00`000000ooK^0?ofkP0G0?ofkP030000003om^h0ooK^02<0ooK^0@3oool006H0ooK^00<0
00000?ofkP000000HP3om^h40=@m6@<0ooK^00<0e3dI0?ofkP3D?AT01P3om^h30=@m6@X0ooK^00<0
e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0
e3dI0?ofkP3om^h0203om^h30=@m6@@0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?of
kP090?ofkP80e3dI103om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0e3dI00d0ooK^00<0
e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP0m0?ofkP030000003om^h0ooK^01P0ooK^00<0
00000?ofkP3om^h08`3om^h10?ooo`00IP3om^h2000006<0ooK^0`3D?AT40?ofkP030=@m6@3om^h0
e3dI00D0ooK^00<0e3dI0?ofkP3D?AT02`3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0
ooK^00`0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP80e3dI00<0ooK^
0=@m6@3om^h0403om^h00`3D?AT0ooK^0?ofkP0;0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT0403o
m^h00`3D?AT0ooK^0=@m6@0=0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h0?03o
m^h00`000000ooK^0?ofkP0I0?ofkP030000003om^h0ooK^02<0ooK^0@3oool006H0ooK^0P00001S
0?ofkP<0e3dI103om^h20=@m6@@0ooK^0P3D?AT20?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI
0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI
0?ofkP3om^h03P3om^h20=@m6A00ooK^00<0e3dI0?ofkP3om^h03@3om^h30=@m6A00ooK^00D0e3dI
0?ofkP3om^h0ooK^0=@m6@0;0?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h0>`3o
m^h00`000000ooK^0?ofkP0I0?ofkP030000003om^h0ooK^02<0ooK^0@3oool006H0ooK^0P00001R
0?ofkP@0e3dI103om^h20=@m6@80ooK^0P3D?AT40?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI
0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI
0?ofkP3om^h03P3om^h0103D?AT0ooK^0=@m6@3D?AT>0?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0
e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0
e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP0j0?ofkP030000003om^h0ooK^01/0ooK^00<0
00000?ofkP3om^h08P3om^h10?ooo`00IP3om^h200000680ooK^0`3D?AT50?ofkP80e3dI00<0ooK^
0=@m6@3om^h0103om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI
0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00l0ooK^00@0e3dI
0?ofkP3om^h0ooK^0P3D?AT;0?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3D?AT03P3o
m^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h01`3o
m^h00`3D?AT0ooK^0?ofkP0i0?ofkP030000003om^h0ooK^01/0ooK^00<000000?ofkP3om^h08P3o
m^h10?ooo`00I@3om^h00`000000ooK^0000001R0?ofkP<0e3dI103om^h40=@m6@H0ooK^00<0e3dI
0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI
0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00@0ooK^0P3D?AT9
0?ofkP030=@m6@3om^h0ooK^00l0ooK^00@0e3dI0?ofkP3om^h0e3dI3@3om^h00`3D?AT0ooK^0?of
kP040?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?of
kP0h0?ofkP030000003om^h0ooK^01`0ooK^00<000000?ofkP3om^h08P3om^h10?ooo`00I@3om^h0
0`000000ooK^000000060?ofkP<0?EV[F03om^h40=@m6@@0ooK^0`3D?AT70?ofkP030=@m6@3om^h0
ooK^00P0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0
ooK^00d0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP060?ofkP80e3dI1P3om^h0
0`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h02@3om^h0
0`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h02@3om^h0
0`3D?AT0ooK^0?ofkP0f0?ofkP030000003om^h0ooK^01d0ooK^00<000000?ofkP3om^h08P3om^h1
0?ooo`00I@3om^h00`000000ooK^000000050?ofkPX0?EV[DP3om^h30=@m6@D0ooK^0`3D?AT60?of
kP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP0<0?of
kP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP090?of
kP80e3dI103om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?of
kP3om^h0203om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?of
kP3om^h02P3om^h00`3D?AT0ooK^0?ofkP0f0?ofkP030000003om^h0ooK^01d0ooK^00<000000?of
kP3om^h08P3om^h10?ooo`00I@3om^h2000000H0ooK^0`0mFJ/00`3om^h0?EV[03eIZ`0903eIZdd0
ooK^0`3D?AT40?ofkP80e3dI0P3om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00T0
ooK^00<0e3dI0?ofkP3om^h01`3om^hE0=@m6@d0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0
ooK^0?ofkP0;0?ofkP80e3dI00<0ooK^0=@m6@3om^h0403om^h00`3D?AT0ooK^0?ofkP050?ofkP03
0=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h02@3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI
00d0ooK^00<0e3dI0?ofkP3om^h0=03om^h00`000000ooK^0?ofkP0O0?ofkP030000003om^h0ooK^
0240ooK^0@3oool006D0ooK^0P0000060?ofkP80?EV[00<0ooK^03eIZ`0mFJ/0100mFJ/00`3om^h0
?EV[03eIZ`0903eIZdL0ooK^0`3D?AT30?ofkP<0e3dI0P3om^h00`3D?AT0ooK^0?ofkP030?ofkP03
0=@m6@3om^h0ooK^00P0ooK^00@0e3dI0?ofkP3om^h0ooK^1`3D?AT30?ofkP030=@m6@3om^h0ooK^
00`0ooK^00<0e3dI0?ofkP3om^h01@3D?AT80?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?of
kP3om^h03P3om^h20=@m6A40ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP050?of
kP030=@m6@3om^h0ooK^00T0ooK^00@0e3dI0?ofkP3om^h0e3dI3@3om^h20=@m6CD0ooK^00<00000
0?ofkP3om^h0803om^h00`000000ooK^0?ofkP0Q0?ofkP40oooo001U0?ofkP8000001P3om^h00`0m
FJ/0ooK^0?ofkP060?ofkPD0?EV[0P3om^h:03eIZd40ooK^00@0e3dI0?ofkP3D?AT0e3dI0P3om^h0
103D?AT0ooK^0=@m6@3D?AT20?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h01`3o
m^h50=@m6@T0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP060?ofkPD0e3dI0P3o
m^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00l0ooK^0`3D?AT>0?ofkP030=@m6@3o
m^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3o
m^h0e3dI00d0ooK^0P3D?ATe0?ofkP030000003om^h0ooK^0200ooK^00<000000?ofkP3om^h08@3o
m^h10?ooo`00I@3om^h2000000D0ooK^0P0mFJ/=0?ofkPH0?EV[0P3om^h:03eIZc/0ooK^00L0e3dI
0?ofkP3D?AT0e3dI0?ofkP3D?AT0ooK^0080e3dI103om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00P0
ooK^0P3D?AT00`3om^h0e3dI0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3o
m^h02`3om^h40=@m6@l0ooK^00<0e3dI0?ofkP3om^h03`3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI
00d0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^
00`0ooK^00<0e3dI0?ofkP3om^h02`3om^h0103D?AT0ooK^0?ofkP3D?ATc0?ofkP030000003om^h0
ooK^0240ooK^00<000000?ofkP3om^h08@3om^h10?ooo`00I03om^h00`000000ooK^000000050?of
kP@0?EV[4@3om^h503eIZ`80ooK^2`0mFJ/e0?ofkPD0e3dI0P3om^h20=@m6@@0ooK^00D0e3dI0?of
kP3om^h0ooK^0=@m6@050?ofkP<0e3dI0P3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0
ooK^00/0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0=@m6@020=@m6@`0ooK^00<0e3dI
0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP020?ofkP80e3dI2P3om^h00`3D?AT0ooK^0?ofkP0;
0?ofkP040=@m6@3om^h0ooK^0=@m6@h0ooK^00<0e3dI0?ofkP3D?AT0303om^h0103D?AT0ooK^0?of
kP3D?ATb0?ofkP030000003om^h0ooK^02<0ooK^00<000000?ofkP3om^h0803om^h10?ooo`00I03o
m^h00`000000ooK^000000050?ofkP<0?EV[00<0ooK^03eIZ`0mFJ/0100mFJ/=0?ofkP0303eIZ`3o
m^h0?EV[00H0?EV[0P3om^h;03eIZbh0ooK^1@3D?AT20?ofkP030=@m6@3om^h0e3dI00D0ooK^00@0
e3dI0?ofkP3om^h0e3dI0P3om^h30=@m6@D0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^
0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h00`3om^h30=@m6@P0ooK^
00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00L0ooK^
00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0=@m6@0>0?ofkP030=@m6@3om^h0e3dI00/0ooK^
00D0e3dI0?ofkP3om^h0ooK^0=@m6@0b0?ofkP030000003om^h0ooK^02<0ooK^00<000000?ofkP3o
m^h0803om^h10?ooo`00I03om^h2000000H0ooK^0P0mFJ/00`3om^h0?EV[03eIZ`0403eIZ`030?of
kP0mFJ/0?EV[00@0?EV[1`3om^h00`0mFJ/0ooK^03eIZ`060?ofkPD0?EV[0`3om^h:03eIZbT0ooK^
00L0e3dI0?ofkP3D?AT0e3dI0?ofkP3D?AT0ooK^0080e3dI1P3om^h0103D?AT0ooK^0=@m6@3om^h2
0=@m6@P0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0
ooK^00d0ooK^00<0e3dI0?ofkP3om^h01P3om^h30=@m6@D0ooK^00<0e3dI0?ofkP3om^h03`3om^h0
0`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h03P3om^h0
0`3D?AT0ooK^0?ofkP0<0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT02P3om^h01@3D?AT0ooK^0?of
kP3om^h0e3dI0340ooK^00<000000?ofkP3om^h0903om^h00`000000ooK^0?ofkP0P0?ofkP40oooo
001T0?ofkP8000001P3om^h203eIZ`L0ooK^1@0mFJ/20?ofkPL0?EV[0P3om^h00`0mFJ/0ooK^0?of
kP090?ofkPH0?EV[0`3om^h:03eIZb<0ooK^0`3D?AT20?ofkP040=@m6@3om^h0e3dI0=@m6@H0ooK^
00@0e3dI0?ofkP3D?AT0e3dI2@3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00/0
ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP<0e3dI00<0ooK^0=@m6@3o
m^h0403om^h00`3D?AT0ooK^0?ofkP080?ofkP80e3dI1@3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP03
0=@m6@3om^h0e3dI00d0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@090?ofkP030=@m6@3om^h0ooK^
00<0ooK^00<0e3dI0?ofkP3om^h0;P3om^h00`000000ooK^0?ofkP0T0?ofkP030000003om^h0ooK^
0200ooK^0@3oool006@0ooK^0P0000060?ofkP80?EV[303om^h603eIZ`80ooK^1P0mFJ/?0?ofkPH0
?EV[0P3om^h:03eIZad0ooK^103D?AT20?ofkP80e3dI00<0ooK^0=@m6@3om^h01@3om^h30=@m6@X0
ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00d0
ooK^00<0e3dI0?ofkP3om^h03@3om^h20=@m6A40ooK^00<0e3dI0?ofkP3om^h02P3om^h01@3D?AT0
ooK^0?ofkP3om^h0e3dI0100ooK^00<0e3dI0?ofkP3D?AT0303om^h00`3D?AT0ooK^0?ofkP030?of
kP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP0]0?of
kP030000003om^h0ooK^02D0ooK^00<000000?ofkP3om^h0803om^h10?ooo`00I03om^h2000000D0
ooK^0P0mFJ/C0?ofkPH0?EV[0P3om^h603eIZ`/0ooK^00<0?EV[0?ofkP3om^h01P0mFJ/30?ofkPX0
?EV[5`3om^h30=@m6@<0ooK^0P3D?AT00`3om^h0e3dI0?ofkP040?ofkP030=@m6@3om^h0e3dI00X0
ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00h0
ooK^00<0e3dI0?ofkP3om^h03P3om^h30=@m6@h0ooK^00<0e3dI0?ofkP3om^h0303om^h20=@m6@03
0?ofkP3D?AT0ooK^00h0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0;0?ofkP030=@m6@3om^h0ooK^
00<0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^
02`0ooK^00<000000?ofkP3om^h09`3om^h00`000000ooK^0?ofkP0O0?ofkP40oooo001S0?ofkP03
0000003om^h0000000D0ooK^0P0mFJ/E0?ofkP0303eIZ`3om^h0ooK^00D0?EV[103om^h603eIZ`@0
ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`050?ofkPD0?EV[0`3om^h:03eIZa80ooK^0`3D?AT30?of
kP<0e3dI103om^h20=@m6@80ooK^0P3D?AT90?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?of
kP3om^h02`3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00h0ooK^00@0e3dI0?of
kP3om^h0ooK^0P3D?AT<0?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h03P3om^h0
0`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h01@3om^h0
0`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h0;03om^h0
0`000000ooK^0?ofkP0W0?ofkP030000003om^h0ooK^01l0ooK^0@3oool006<0ooK^00<000000?of
kP0000001@3om^h203eIZa@0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`040?ofkPH0?EV[103om^h6
03eIZ`80ooK^00<0?EV[0?ofkP3om^h0203om^h603eIZ`<0ooK^2@0mFJ/<0?ofkP040=@m6@3om^h0
e3dI0=@m6@<0ooK^00<0e3dI0?ofkP3D?AT00P3om^h20=@m6@<0ooK^00<0e3dI0?ofkP3D?AT02@3o
m^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h03@3o
m^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00<0ooK^0P3D?AT90?ofkP030=@m6@3o
m^h0ooK^00l0ooK^0P3D?AT>0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h01P3o
m^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h01P3o
m^h00`3D?AT0ooK^0?ofkP0Z0?ofkP030000003om^h0ooK^02P0ooK^00<000000?ofkP3om^h07`3o
m^h10?ooo`00H`3om^h00`000000ooK^000000050?ofkP80?EV[503om^h01@0mFJ/0ooK^0?ofkP3o
m^h0?EV[00X0ooK^1@0mFJ/20?ofkP0303eIZ`3om^h0ooK^00D0?EV[3P3om^h603eIZ`80ooK^2P0m
FJ/60?ofkP<0e3dI103om^h01@3D?AT0ooK^0=@m6@3om^h0e3dI00D0ooK^00@0e3dI0?ofkP3om^h0
e3dI1`3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3o
m^h03@3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3o
m^h01P3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP040=@m6@3om^h0ooK^0=@m6@d0ooK^00<0e3dI0?of
kP3om^h0103om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00L0ooK^00D0e3dI0?of
kP3om^h0ooK^0=@m6@090?ofkP030=@m6@3om^h0ooK^02T0ooK^00<000000?ofkP3om^h0:@3om^h0
0`000000ooK^0?ofkP0O0?ofkP40oooo001S0?ofkP8000001P3om^h403eIZa80ooK^00@0?EV[0?of
kP3om^h0?EV[403om^h603eIZ`040?ofkP0mFJ/0ooK^0?ofkP@0?EV[2`3om^h0100mFJ/0ooK^0?of
kP3om^h803eIZ`030?ofkP0mFJ/0?EV[00L0?EV[00@0ooK^0=@m6@3D?AT0e3dI103om^h40=@m6@H0
ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@060?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?of
kP3om^h02`3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?of
kP3om^h01`3om^h20=@m6@D0ooK^00<0e3dI0?ofkP3om^h03`3om^h01@3D?AT0ooK^0?ofkP3om^h0
e3dI00/0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0
ooK^00L0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@090?ofkP030=@m6@3om^h0ooK^02T0ooK^00<0
00000?ofkP3om^h0:P3om^h00`000000ooK^0?ofkP0N0?ofkP40oooo001S0?ofkP8000001P3om^h2
03eIZ`030?ofkP0mFJ/0?EV[00D0?EV[303om^h0100mFJ/0ooK^0?ofkP0mFJ/B0?ofkP0403eIZ`3o
m^h0ooK^0?ofkPL0?EV[00<0ooK^03eIZ`0mFJ/00`0mFJ/50?ofkP0303eIZ`3om^h0ooK^0080ooK^
00<0?EV[0?ofkP3om^h01@3om^h;03eIZ`<0e3dI0P0mFJ/0103om^h0e3dI0?ofkP3D?AT70?ofkP03
0=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP0:0?ofkP03
0=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP03
0=@m6@3om^h0ooK^00T0ooK^0P3D?AT30?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3o
m^h00`3om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3o
m^h00P3om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0e3dI00T0ooK^0P3D?ATZ0?ofkP03
0000003om^h0ooK^02/0ooK^00<000000?ofkP3om^h07P3om^h10?ooo`00H`3om^h2000000H0ooK^
0P0mFJ/60?ofkPP0?EV[1@3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[0140ooK^00<0?EV[0?ofkP3o
m^h00`3om^h00`0mFJ/0ooK^0?ofkP030?ofkP`0?EV[1@3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP<0
?EV[0`3D?AT203eIZ`030?ofkP0mFJ/0e3dI0080e3dI1`0000000`3D?AT0ooK^0?ofkP030?ofkP03
0=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h0203om^hD0=@m6@d0ooK^00<0e3dI0?ofkP3o
m^h03P3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP<0e3dI4@3om^h00`3D?AT0ooK^0?ofkP040?ofkP03
0=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h02@3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI
00/0ooK^00<0e3dI0?ofkP3D?AT02@3om^h20=@m6BT0ooK^00<000000?ofkP3om^h0;03om^h00`00
0000ooK^0?ofkP0N0?ofkP40oooo001R0?ofkP030000003om^h0000000D0ooK^00<0?EV[0?ofkP0m
FJ/0303om^h803eIZ`<0ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP030?ofkP03
03eIZ`3om^h0ooK^00X0ooK^200mFJ/20?ofkP0303eIZ`3om^h0ooK^00d0ooK^00@0?EV[0=@m6@3o
m^h0e3dI100mFJ/30=@m6@@000000`0A52L00`3D?AT0000000000003000000030=@m6@3om^h0ooK^
0080ooK^00@0e3dI0?ofkP3om^h0ooK^1`3D?AT30?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI
0?ofkP3om^h01@3D?AT80?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h03P3om^h0
0`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h01@3om^h0
0`3D?AT0ooK^0?ofkP090?ofkP040=@m6@3om^h0ooK^0=@m6@d0ooK^00<0e3dI0?ofkP3om^h01`3o
m^h00`3D?AT0ooK^0=@m6@0Y0?ofkP030000003om^h0ooK^02`0ooK^00<000000?ofkP3om^h07P3o
m^h10?ooo`00HP3om^h00`000000ooK^000000050?ofkP0303eIZ`3om^h0?EV[0140ooK^2@0mFJ/?
0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP07
03eIZ`d0ooK^00L0?EV[0=@m6@3D?AT0e3dI0000000mFJ/06A`g0080e3dI0P0I73L0103D?AT06A`g
01TL=`0I73L2000000030=@m6@0000000000008000000`0A52L0103D?AT000000000000000040=@m
6@T0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP060?ofkPD0e3dI0P3om^h00`3D
?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00l0ooK^0`3D?AT>0?ofkP030=@m6@3om^h0ooK^
00L0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0e3dI
00`0ooK^0P3D?AT90?ofkP030=@m6@3om^h0e3dI02P0ooK^00<000000?ofkP3om^h0;@3om^h00`00
0000ooK^0?ofkP0N0?ofkP40oooo001R0?ofkP030000003om^h0000000D0ooK^00<0?EV[0?ofkP0m
FJ/04`3om^h0100mFJ/0ooK^0?ofkP3om^h903eIZ`T0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0m
FJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00D0ooK^2@0mFJ/60?ofkP0303eIZ`3D?AT0ooK^
0080e3dI0`0000001@3D?AT06A`g01TL=`0I73L0e3dI00<06A`g0P0000000`3D?AT06A`g01TL=`02
01TL=`@0000000<0e3dI0000000000001@0000080?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI
0?ofkP3om^h02`3om^h40=@m6@l0ooK^00<0e3dI0?ofkP3om^h03P3om^h01@3D?AT0ooK^0?ofkP3o
m^h0e3dI00`0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3o
m^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h02`3om^h20=@m6@P0ooK^00@0e3dI0?ofkP3om^h0e3dI
9`3om^h00`000000ooK^0?ofkP0_0?ofkP030000003om^h0ooK^01d0ooK^0@3oool00680ooK^00<0
00000?ofkP0000001@3om^h203eIZa@0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`060?ofkPP0?EV[
0P3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h0
1@3om^h00`0mFJ/0ooK^0?ofkP040?ofkPT0?EV[00@0e3dI0?ofkP3D?AT0e3dI0`0T;E<01@3D?AT0
0000000000000000e3dI00@0000000<06A`g0=@m6@0I73L01P0I73L010000000e3dI01TL=`0I73L4
00000003014D9`000000000000@0000000<0ooK^0=@m6@3om^h0303om^h00`3D?AT0ooK^0?ofkP0>
0?ofkP030=@m6@3om^h0e3dI0080e3dI303om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0
ooK^0080ooK^0P3D?AT:0?ofkP030=@m6@3om^h0ooK^00X0ooK^00@0e3dI0?ofkP3om^h0e3dI3P3o
m^h20=@m6@`0ooK^00@0e3dI0?ofkP3om^h0e3dI1`3om^h0103D?AT0ooK^0?ofkP3D?ATW0?ofkP03
0000003om^h0ooK^02l0ooK^00<000000?ofkP3om^h07@3om^h10?ooo`00HP3om^h2000000H0ooK^
0P0mFJ/C0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h02`3om^h703eIZ`<0ooK^
00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00T0ooK^
100mFJ/20=@m6@0302@]D`3D?AT092eC008092eC00<0e3dI02@]D`0T;E<00P0T;E<01@3D?AT092eC
02@]D`0T;E<0e3dI00@000000`0I73L0100000006A`g01TL=`3D?AT501TL=`D000000P0A52L40000
00/0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP030?ofkP<0e3dI203om^h00`3D
?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D
?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0e3dI00h0ooK^00<0e3dI0?ofkP3D?AT02`3om^h0103D
?AT0ooK^0?ofkP3D?AT60?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT09P3om^h00`000000ooK^0?of
kP0`0?ofkP030000003om^h0ooK^01d0ooK^0@3oool00680ooK^0P0000050?ofkP0303eIZ`3om^h0
?EV[01<0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0
ooK^00L0?EV[303om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00/0ooK^00H0?EV[
0=@m6@3D?AT0e3dI02@]D`3D?AT202@]D`030=@m6@0T;E<092eC00<092eC00D0e3dI02@]D`0T;E<0
92eC0=@m6@0402@]D`D000000P0I73L00`3D?AT06A`g01TL=`0301TL=`040000000I73L06A`g01TL
=`@000000P0A52L5000000H0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP060?of
kP<0e3dI1@3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?of
kP3om^h01@3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00`0ooK^00@0e3dI0?of
kP3om^h0e3dI2P3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00D0ooK^00<0e3dI0?ofkP3om^h00P3o
m^h00`3D?AT0ooK^0?ofkP0T0?ofkP030000003om^h0ooK^0300ooK^00<000000?ofkP3om^h07@3o
m^h10?ooo`00H@3om^h00`000000ooK^000000050?ofkP0303eIZ`3om^h0?EV[01<0ooK^00<0?EV[
0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00@0ooK^2@0mFJ/5
0?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h02P3om^h01`0mFJ/0ooK^0=@m6@00
0000e3dI02@]D`3D?AT00P0T;E<00`3D?AT092eC02@]D`0202@]D`030000003D?AT092eC008092eC
00<0e3dI02@]D`0T;E<0100T;E<00`00000092eC02@]D`02000000030=@m6@000000000000<06A`g
00<0000001TL=`0I73L01@0I73L?000000d0ooK^00<0e3dI0?ofkP3om^h02P3om^h30=@m6@030?of
kP3D?AT0ooK^00l0ooK^00<0e3dI0?ofkP3om^h0203om^h20=@m6@@0ooK^00<0e3dI0?ofkP3om^h0
3P3om^h20=@m6@d0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@080?ofkP030=@m6@3om^h0ooK^0080
ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^02<0
ooK^00<000000?ofkP3om^h0<P3om^h00`000000ooK^0?ofkP0L0?ofkP40oooo001Q0?ofkP030000
003om^h0000000D0ooK^0`0mFJ/C0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/0403om^h00`0mFJ/0
ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00@0ooK^200mFJ/80?ofkP0303eIZ`3om^h0ooK^00X0
ooK^00D0?EV[0?ofkP3D?AT0e3dI02hmM002000000040=@m6@000000e3dI000000<092eC00D00000
02@]D`3D?AT092eC0=@m6@0602@]D`030000000T;E<092eC00@092eC00<0e3dI02@]D`0000001000
000801TL=`030000000I73L06A`g00806A`g1`0000000`0A52L0000000000004000000L0ooK^00<0
e3dI0?ofkP3om^h03@3om^h20=@m6A00ooK^00<0e3dI0?ofkP3om^h02P3om^h01@3D?AT0ooK^0?of
kP3om^h0e3dI00l0ooK^00<0e3dI0?ofkP3D?AT0303om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m
6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h00`3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00D0
ooK^00<0e3dI0?ofkP3om^h08P3om^h00`000000ooK^0?ofkP0c0?ofkP030000003om^h0ooK^01`0
ooK^0@3oool00640ooK^00<000000?ofkP0000001@3om^h00`0mFJ/0ooK^03eIZ`0503eIZ`h0ooK^
00D0?EV[0?ofkP3om^h0ooK^03eIZ`0@0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3o
m^h02@3om^h903eIZ`80ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^000000020=@m6@<0
;Sed0P3D?AT202hmM0D0000000<0e3dI02@]D`3D?AT01P0T;E<00`00000092eC02@]D`0402@]D`80
e3dI0P0T;E<00`00000092eC02@]D`05000000806A`g00<0000001TL=`0I73L01`0I73L00`000000
6A`g01TL=`0400000003014D9`0000004A@W00@000000`3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP<0
e3dI3P3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP<0e3dI403om^h0103D?AT0ooK^0?ofkP3D?AT;0?of
kP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP040?of
kP050=@m6@3om^h0ooK^0?ofkP3D?AT01@3om^h00`3D?AT0ooK^0?ofkP0R0?ofkP030000003om^h0
ooK^03<0ooK^00<000000?ofkP3om^h0703om^h10?ooo`00H@3om^h00`000000ooK^000000050?of
kP0303eIZ`3om^h0?EV[0080ooK^2@0mFJ/70?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?of
kP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?of
kP3om^h02P0mFJ/80?ofkP0303eIZ`3om^h0e3dI0080e3dI0`0^?G@20=@m6@@0;Sed00H0000002hm
M00^?G@0e3dI0000003D?AT30000008092eC00<0000002@]D`0T;E<0100T;E<01@3D?AT092eC02@]
D`3D?AT0000000P092eC1@00000701TL=`030000000I73L06A`g00@06A`g1P0000000`0A52L00000
00000003000000h0ooK^00@0e3dI0?ofkP3om^h0ooK^0P3D?AT;0?ofkP030=@m6@3om^h0ooK^00h0
ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00L0
ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00@0
ooK^00@0e3dI0?ofkP3om^h0e3dI1P3om^h00`3D?AT0ooK^0?ofkP0Q0?ofkP030000003om^h0ooK^
03@0ooK^00<000000?ofkP3om^h0703om^h10?ooo`00H@3om^h2000000D0ooK^00@0?EV[0?ofkP3o
m^h0?EV[203om^h803eIZ`80ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP0>0?of
kP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP060?of
kP/0?EV[0P3om^h00`0mFJ/000000=@m6@020=@m6@<0;Sed0P3D?AT302hmM0030000000^?G@0;Sed
0080;Sed00<0e3dI02hmM00^?G@00P0^?G@5000000@092eC00D0e3dI02@]D`0T;E<092eC0=@m6@0:
02@]D`030000000T;E<092eC00D000000P0I73L00`0000006A`g01TL=`0601TL=`040000000I73L0
6A`g01TL=`h000001P3om^h00`3D?AT0ooK^0?ofkP030?ofkP80e3dI2@3om^h00`3D?AT0ooK^0?of
kP0=0?ofkP030=@m6@3om^h0e3dI00h0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?of
kP060?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?of
kP050?ofkP040=@m6@3om^h0ooK^0=@m6@H0ooK^00<0e3dI0?ofkP3om^h0803om^h00`000000ooK^
0?ofkP0e0?ofkP030000003om^h0ooK^01`0ooK^0@3oool00640ooK^0P0000050?ofkP0403eIZ`3o
m^h0ooK^03eIZ`h0ooK^200mFJ/00`3om^h0?EV[0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00@0ooK^
00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP070?ofkP0403eIZ`3om^h0ooK^0?ofkPD0
?EV[00<0ooK^03eIZ`0mFJ/00P0mFJ/00`0^?G@0e3dI02hmM00302hmM080e3dI0`0^?G@00`000000
;Sed02hmM00202hmM0030=@m6@0^?G@0;Sed00@0;Sed00<0000002hmM00^?G@0100000001P3D?AT0
92eC02@]D`00000092eC0=@m6@T092eC00<0000002@]D`0T;E<01@0T;E<7000000D06A`g00<00000
01TL=`0I73L0100I73L00`000000?EV[01TL=`0600000003014D9`000000000000<0000000<0e3dI
0?ofkP3om^h01P3om^h20=@m6@H0ooK^00<0e3dI0?ofkP3om^h03P3om^h0103D?AT0ooK^0?ofkP3D
?AT<0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?of
kP060?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT02@3om^h20=@m6@H0ooK^0P3D?ATR0?ofkP030000
003om^h0ooK^03H0ooK^00<000000?ofkP3om^h06`3om^h10?ooo`00H03om^h00`000000ooK^0000
00050?ofkP0303eIZ`3om^h0?EV[01<0ooK^00<0?EV[0?ofkP0mFJ/0200mFJ/:0?ofkP0303eIZ`3o
m^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3o
m^h0ooK^00H0ooK^0`0mFJ/010000000;Sed0=@m6@3D?AT402hmM0050=@m6@0^?G@0;Sed02hmM000
00001@0^?G@20=@m6@@0;Sed00<0000002hmM00^?G@0100^?G@00`3D?AT0;Sed0000000400000003
0=@m6@0T;E<092eC00D092eC00<0000002@]D`0T;E<0200T;E<00`00000092eC02@]D`0202@]D`P0
00001@0I73L00`0000006A`g01TL=`0301TL=`D000000P0A52L5000000L0ooK^0P3D?AT40?ofkP03
0=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP090?ofkP03
0=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP070?ofkP04
0=@m6@3om^h0ooK^0=@m6@T0ooK^0P3D?AT60?ofkP030=@m6@3om^h0ooK^0200ooK^00<000000?of
kP3om^h0=`3om^h00`000000ooK^0?ofkP0K0?ofkP40oooo001P0?ofkP030000003om^h000000080
00000`3om^h00`0mFJ/0ooK^03eIZ`0B0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3o
m^h02P0mFJ/30?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0
ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0000000000000P3D?AT402hmM005
0=@m6@0^?G@0;Sed02hmM0000000100^?G@00`3D?AT0;Sed0=@m6@0402hmM0030000000^?G@0;Sed
00@0;Sed00D0e3dI02hmM00mFJ/0;Sed0000000202hmM0030000003D?AT0000000<000000P0T;E<0
0`00000092eC02@]D`0802@]D`030000000T;E<092eC00L092eC00<0000002@]D`0T;E<010000000
0`0I73L0000001TL=`0701TL=`030000000I73L0000000D0000000<04A@W0000000000000`000004
0?ofkP80e3dI00<0ooK^0=@m6@3om^h03`3om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0
ooK^00L0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0
ooK^00P0ooK^00<0e3dI0?ofkP3D?AT02P3om^h00`3D?AT0ooK^0?ofkP040?ofkP80e3dI8@3om^h0
0`000000ooK^0?ofkP0h0?ofkP030000003om^h0ooK^01/0ooK^0@3oool00600ooK^00<000000?of
kP0000000P3om^h600000180ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP050?of
kP@0?EV[00<0ooK^03eIZ`0mFJ/0100mFJ/50?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?of
kP3om^h0203om^h00`0mFJ/0ooK^0?ofkP070?ofkP0503eIZ`3om^h0000003I9R`3D?AT01@000000
103D?AT0;Sed02hmM000000502hmM0040=@m6@0^?G@0;Sed0=@m6@<0;Sed00<0000002hmM00^?G@0
100^?G@01@3D?AT0;Sed02hmM00^?G@0000000<0;Sed00<0e3dI02hmM00^?G@00P0^?G@5000000P0
92eC00<0000002@]D`0T;E<01`0T;E<00`00000092eC02@]D`0402@]D`D000001@0I73L00`000000
6A`g01TL=`0301TL=`h000000P3D?AT?0?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3o
m^h01P3om^h00`3D?AT0ooK^0?ofkP080?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT02`3om^h20=@m
6@T0ooK^0P3D?AT60?ofkP80e3dI8@3om^h00`000000ooK^0?ofkP0h0?ofkP030000003om^h0ooK^
01/0ooK^0@3oool00600ooK^00<000000?ofkP0000001@3om^h00`0mFJ/0ooK^03eIZ`06000000`0
ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP090?ofkPD0?EV[0P3om^h603eIZ``0
ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0503eIZ`000000000003I9
R`3D?AT0100fBH/00`3D?AT0=TV;0=@m6@04000000<0;Sed00D0e3dI02hmM00^?G@0;Sed0=@m6@02
02hmM0030000000^?G@0;Sed00<0;Sed00<0e3dI02hmM00^?G@00P0^?G@00`000000;Sed02hmM002
02hmM0030=@m6@0^?G@0;Sed00<0;Sed00<0000002hmM00^?G@01P00000202@]D`030000000T;E<0
92eC00L092eC00<0000002@]D`0T;E<01P0T;E<00`00000092eC02@]D`050000000301TL=`000000
6A`g00H06A`g00<0000001TL=`0I73L01`0000000`0A52L0000000000002000000d0ooK^00<0e3dI
0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00T0ooK^00@0e3dI
0?ofkP3om^h0e3dI303om^h00`3D?AT0ooK^0?ofkP080?ofkP80e3dI1@3om^h00`3D?AT0ooK^0=@m
6@0P0?ofkP030000003om^h0ooK^03X0ooK^00<000000?ofkP3om^h06P3om^h10?ooo`00H03om^h2
000000D0ooK^00@0?EV[0?ofkP3om^h0?EV[1P3om^h6000000H0ooK^00<0?EV[0?ofkP3om^h00P3o
m^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0?EV[00@0?EV[0P3om^h503eIZ`P0ooK^00<0
?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0503eIZ`000000=TV;03I9R`3D?AT0
100fBH/01@3D?AT0=TV;0=@m6@0fBH/000000080=TV;0P000000203D?AT00000000000000000;Sed
0=@m6@0^?G@000001P0^?G@01@3D?AT0;Sed02hmM00^?G@0000000H0;Sed00<0e3dI02hmM00^?G@0
0P0^?G@00`000000;Sed02hmM00602hmM0D000001`0T;E<00`00000092eC02@]D`0702@]D`030000
000T;E<092eC00@092eC1@00000501TL=`030000000I73L06A`g00@06A`g00<0000001TL=`000000
2@0000070?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^
0?ofkP0:0?ofkP030=@m6@3om^h0e3dI00/0ooK^0P3D?AT90?ofkP030=@m6@3om^h0e3dI00D0ooK^
0P3D?ATP0?ofkP030000003om^h0ooK^03/0ooK^00<000000?ofkP3om^h06P3om^h10?ooo`00H03o
m^h2000000D0ooK^00@0?EV[0?ofkP3om^h0?EV[303om^h50000000303eIZ`3om^h0ooK^00<0ooK^
00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP040?ofkPD0?EV[0P3om^h503eIZ`80ooK^
00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP070?ofkP0403eIZ`3om^h0000003I9R`80
e3dI100fBH/01@3D?AT0=TV;0=@m6@0fBH/0000000@0=TV;00@0e3dI03I9R`0fBH/0=TV;0P000000
103D?AT0000000000000000402hmM0050=@m6@0^?G@0;Sed02hmM00000001`0^?G@01@3D?AT0;Sed
02hmM00^?G@0000000P0;Sed00<0?EV[02hmM00000000P0^?G@50000008092eC00<0000002@]D`0T
;E<01`0T;E<00`00000092eC02@]D`0602@]D`030000000T;E<092eC00D0000000<06A`g0000000I
73L01@0I73L2000000<06A`g3@0000000`3D?AT0ooK^0?ofkP090?ofkP050=@m6@3om^h0ooK^0?of
kP3D?AT03P3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP80e3dI2@3om^h00`3D?AT0ooK^0=@m6@040?of
kP030=@m6@3om^h0e3dI0200ooK^00<000000?ofkP3om^h0>`3om^h00`000000ooK^0?ofkP0J0?of
kP40oooo001O0?ofkP030000003om^h0000000D0ooK^00@0?EV[0?ofkP3om^h0?EV[4@3om^h60000
000303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP0603eI
Z`030?ofkP0mFJ/0?EV[00@0?EV[1`3om^h00`0mFJ/0ooK^0?ofkP070?ofkP0403eIZ`3om^h00000
03I9R`80e3dI0`0fBH/01P3D?AT0=TV;03I9R`0fBH/0e3dI000000@0=TV;00<0e3dI03I9R`0fBH/0
0`0fBH/0103D?AT0000003I9R`0fBH/3000000030=@m6@00000000000080;Sed00<0000002hmM00^
?G@01P0^?G@00`3D?AT0;Sed0000000;02hmM0030000000^?G@0;Sed00D0;Sed1@00000702@]D`03
0000000T;E<092eC00L092eC00<0000002@]D`0T;E<0100T;E<7000000<06A`g00<0000001TL=`0I
73L00`0I73L20000000301TL=`000000000000/000001`3om^h0103D?AT0ooK^0?ofkP3D?AT=0?of
kP80e3dI2`3om^h0103D?AT0ooK^0?ofkP3D?AT70?ofkP040=@m6@3om^h0ooK^0=@m6@<0ooK^00@0
e3dI0?ofkP3om^h0e3dI7`3om^h00`000000ooK^0?ofkP0l0?ofkP030000003om^h0ooK^01X0ooK^
0@3oool005l0ooK^00<000000?ofkP0000001@3om^h403eIZa40ooK^00<0?EV[0?ofkP3om^h00`3o
m^h6000000X0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP060?ofkPH0?EV[00<0
ooK^03eIZ`0mFJ/0100mFJ/00`3om^h0?EV[0?ofkP080?ofkP0403eIZ`000000000003I9R`80e3dI
0`0fBH/01P3D?AT0=TV;03I9R`0fBH/0e3dI000000<0=TV;00<0e3dI03I9R`0fBH/01@0fBH/00`3D
?AT0=TV;03I9R`0303I9R`030=@m6@0fBH/0=TV;00D000001`0^?G@00`3D?AT0000002hmM00:02hm
M0030000000^?G@0;Sed00L0;Sed00<0000002hmM00^?G@01P00000202@]D`030000000T;E<092eC
00H092eC00<0000002@]D`0T;E<01`0T;E<01000000092eC02@]D`0T;E<7000000@06A`g00<00000
01TL=`0I73L00`0I73L700000004014D9`0000000000000000D0ooK^0P3D?AT>0?ofkP030=@m6@3o
m^h0e3dI00X0ooK^00@0e3dI0?ofkP3om^h0e3dI1P3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00<0
ooK^00@0e3dI0?ofkP3om^h0e3dI7`3om^h00`000000ooK^0?ofkP0l0?ofkP030000003om^h0ooK^
01X0ooK^0@3oool005l0ooK^00<000000?ofkP0000001@3om^h00`0mFJ/0ooK^03eIZ`0503eIZ`d0
ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP030?ofkPH000000`3om^h00`0mFJ/0
ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00P0ooK^00@0?EV[0?ofkP3om^h0ooK^1P0mFJ/00`3o
m^h0?EV[03eIZ`0503eIZ`<0ooK^00L0?EV[0?ofkP000000=TV;0=@m6@0fBH/0e3dI00<0=TV;00D0
e3dI03I9R`0fBH/0=TV;0=@m6@0403I9R`030=@m6@0fBH/0=TV;00D0=TV;00<000000=@m6@0fBH/0
0`0fBH/00`3D?AT0=TV;03I9R`0203I9R`030000000fBH/0=TV;00H000000P0^?G@00`3D?AT0;Sed
02hmM00902hmM0030000000^?G@0;Sed00L0;Sed00<0000002hmM00^?G@01P0^?G@5000000H092eC
00<0000002@]D`0T;E<01`0T;E<00`00000092eC02@]D`0602@]D`030000000T;E<0000000H00000
1@0I73L0100000006A`g01TL=`0I73L900000080ooK^00<0e3dI0?ofkP3om^h02`3om^h0103D?AT0
ooK^0?ofkP3D?AT90?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT01P3om^h01@3D?AT0ooK^0?ofkP3o
m^h0e3dI0080ooK^00@0e3dI0?ofkP3om^h0e3dI7`3om^h00`000000ooK^0?ofkP0n0?ofkP030000
003om^h0ooK^01T0ooK^0@3oool005l0ooK^00<000000?ofkP0000001@3om^h00`0mFJ/0ooK^03eI
Z`050?ofkPD0?EV[1`3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00T0ooK^1@00
00070?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h01`3om^h503eIZ`<0ooK^1@0m
FJ/01@000000=TV;0=@m6@0fBH/0e3dI0080=TV;00<0e3dI03I9R`0fBH/00P0fBH/00`000000e3dI
03I9R`0203I9R`030=@m6@0fBH/0=TV;00D0=TV;00<000000=@m6@0fBH/00P0fBH/00`3D?AT0=TV;
03I9R`0303I9R`030000000fBH/0=TV;00H0=TV;0`0000000`3D?AT0000002hmM00802hmM0030000
000^?G@0;Sed00L0;Sed00<0000002hmM00^?G@0200^?G@00`000000;Sed02hmM0050000008092eC
00<0000002@]D`0T;E<01`0T;E<00`00000092eC02@]D`0502@]D`030000000T;E<092eC00@092eC
1@00000301TL=`030000000I73L06A`g00<06A`g0P0000000`0I73L0000000000002000000030=@m
6@0mFJ/0e3dI00`0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@080?ofkP050=@m6@3om^h0ooK^0?of
kP3D?AT01@3om^h00`3D?AT0ooK^0?ofkP020?ofkP040=@m6@3om^h0ooK^0=@m6@80ooK^00<0e3dI
0?ofkP3om^h0703om^h00`000000ooK^0?ofkP0o0?ofkP030000003om^h0ooK^01T0ooK^0@3oool0
05l0ooK^0P0000050?ofkP0403eIZ`3om^h0ooK^03eIZ`X0ooK^1@0mFJ/20?ofkP0303eIZ`3om^h0
ooK^00@0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^00000005000000030?ofkP0mFJ/0
ooK^00X0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP0703eIZ`060?ofkP000000
e3dI0000000fBH/0e3dI0P0fBH/00`3D?AT0=TV;03I9R`0203I9R`030000003D?AT0=TV;0080=TV;
00<0e3dI03I9R`0fBH/0100fBH/010000000=TV;03I9R`3D?AT203I9R`030=@m6@0fBH/0=TV;00<0
=TV;00<0000003I9R`0fBH/0200fBH/010000000e3dI0=@m6@3D?AT5000000<0;Sed00<0000002hm
M00^?G@0200^?G@00`000000;Sed02hmM00702hmM0030000000^?G@0;Sed00D0;Sed2000000402@]
D`030000000T;E<092eC00H092eC00<0000002@]D`0T;E<01P0T;E<00`00000092eC000000050000
00D06A`g00<0000001TL=`0I73L00`0I73L2000000030=@m6@0mFJ/0?EV[00<0?EV[1@3om^h00`3D
?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D
?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3D?AT00`3om^h00`3D
?AT0ooK^0?ofkP0L0?ofkP030000003om^h0ooK^03l0ooK^00<000000?ofkP3om^h06@3om^h10?oo
o`00G`3om^h2000000D0ooK^00<0?EV[0?ofkP3om^h00`0mFJ/=0?ofkPH0?EV[0`3om^h00`0mFJ/0
ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00D0ooK^1P0000070?ofkP0303eIZ`3om^h0ooK^00T0
ooK^00<0?EV[0?ofkP3om^h01@3om^h303eIZ`030000000kDI`0>e6L0080000000@0e3dI0000003D
?AT000000`0fBH/01@000000=TV;0=@m6@0fBH/0e3dI00L0=TV;00L0000003I9R`0fBH/0=TV;0=@m
6@0fBH/0e3dI00D0=TV;00<0000003I9R`0fBH/0200fBH/01@3D?AT0=TV;03I9R`0fBH/0e3dI00@0
=TV;1P00000802hmM0030000000^?G@0;Sed00L0;Sed00<0000002hmM00^?G@01`0^?G@00`000000
;Sed02hmM00302hmM0P000001P0T;E<00`00000092eC02@]D`0502@]D`030000000T;E<092eC00<0
92eC1@00000301TL=`8000001@0I73L0100mFJ/0e3dI03eIZ`0mFJ/20?ofkPD0?EV[00<0e3dI03eI
Z`3om^h00`3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00<0ooK^00D0e3dI0?of
kP3om^h0ooK^0=@m6@050?ofkP030=@m6@3om^h0e3dI0080ooK^00<0e3dI0?ofkP3om^h0703om^h0
0`000000ooK^0?ofkP100?ofkP030000003om^h0ooK^01T0ooK^0@3oool005h0ooK^00<000000?of
kP0000001@3om^h0100mFJ/0ooK^0?ofkP0mFJ/20?ofkPH0?EV[2@3om^h0100mFJ/0ooK^0?ofkP3o
m^h703eIZ`X0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP020?ofkPH0000000<0
?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0403eIZ`3om^h00000000000@0>e6L
00@0e3dI03]AW03D?AT0>e6L1@0000000`3D?AT0=TV;0=@m6@0703I9R`040000000fBH/0=TV;03I9
R`80e3dI1P0fBH/00`000000=TV;03I9R`0803I9R`030=@m6@0fBH/0=TV;0080=TV;00<0e3dI03I9
R`0fBH/0100fBH/00`000000=TV;03I9R`0600000080;Sed00<0000002hmM00^?G@0200^?G@00`00
0000;Sed02hmM00702hmM0030000000^?G@0;Sed00L0;Sed00<0000002hmM00^?G@01@0000000`0T
;E<0000002@]D`0702@]D`030000000T;E<092eC00D092eC00<0000002@]D`0000001P00000501TL
=`8000001P0mFJ/00`3D?AT0ooK^0?ofkP0403eIZ`030=@m6@0mFJ/0ooK^00<0ooK^00<0e3dI0?of
kP3om^h0103om^h0103D?AT0ooK^0?ofkP3D?AT60?ofkP80e3dI0`3om^h00`3D?AT0ooK^0?ofkP0K
0?ofkP030000003om^h0ooK^0480ooK^00<000000?ofkP3om^h0603om^h10?ooo`00GP3om^h00`00
0000ooK^000000050?ofkP0403eIZ`3om^h0ooK^03eIZ`P0ooK^1P0mFJ/30?ofkP0303eIZ`3om^h0
ooK^00<0ooK^00<0?EV[0?ofkP3om^h00P3om^h703eIZ`<0ooK^00<0?EV[0?ofkP3om^h01`3om^h0
0`0mFJ/0ooK^0?ofkP080?ofkPH000001`3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0403eIZ`000000
0000000000@0>e6L0P3D?AT503]AW0050000000kDI`0e3dI0000003D?AT01000000303I9R`030000
000fBH/0=TV;0080=TV;00<0e3dI03I9R`0fBH/0100fBH/00`000000=TV;03I9R`0703I9R`030=@m
6@000000=TV;00@0=TV;0P3D?AT403I9R`030000000fBH/0=TV;00H0=TV;1@00000802hmM0030000
000^?G@0;Sed00L0;Sed00<0000002hmM00^?G@01`0^?G@00`000000;Sed02hmM00502hmM0D00000
1P0T;E<00`00000092eC02@]D`0502@]D`030000000T;E<092eC00<092eC1`000000103D?AT06A`g
0000000000020?ofkP80?EV[00<0e3dI03eIZ`0mFJ/01@0mFJ/00`3D?AT0?EV[03eIZ`0203eIZ`03
0=@m6@3om^h0ooK^00@0ooK^00@0e3dI0?ofkP3om^h0e3dI1P3om^h20=@m6@80ooK^00<0e3dI0?of
kP3om^h0703om^h00`000000ooK^0?ofkP120?ofkP030000003om^h0ooK^01P0ooK^0@3oool005h0
ooK^00<000000?ofkP000000103om^h0100mFJ/0ooK^0?ofkP0mFJ/?0?ofkPH0?EV[0`3om^h00`0m
FJ/0ooK^0?ofkP090?ofkPH0?EV[1`3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^
00<0ooK^1@0000020?ofkP0303eIZ`3om^h0ooK^00D0ooK^00@0?EV[0000000000000000100kDI`2
0=@m6@D0>e6L00@0000003]AW00kDI`0e3dI1@0kDI`600000080=TV;0P3D?AT503I9R`030000000f
BH/0=TV;00L0=TV;00<0e3dI0000000fBH/01P0fBH/01@3D?AT0=TV;03I9R`0fBH/0000000X0=TV;
00<0000003I9R`0fBH/01P00000202hmM0030000000^?G@0;Sed00L0;Sed00<0000002hmM00^?G@0
200^?G@00`000000;Sed02hmM00602hmM0030000000^?G@0;Sed00D0000000<092eC0000000T;E<0
1`0T;E<00`00000092eC02@]D`0502@]D`040000000T;E<092eC02@]D`D000000P3om^h00`3D?AT0
?EV[0?ofkP020?ofkP@0?EV[00H0e3dI03eIZ`0mFJ/0?EV[0=@m6@3om^h503eIZ`80ooK^0P3D?AT7
0?ofkP040=@m6@3om^h0ooK^0=@m6Ah0ooK^00<000000?ofkP3om^h0@`3om^h00`000000ooK^0?of
kP0H0?ofkP40oooo001N0?ofkP030000003om^h0000000@0ooK^00@0?EV[0?ofkP3om^h0?EV[4@3o
m^h0100mFJ/0ooK^0?ofkP3om^h603eIZ``0ooK^00<0?EV[0?ofkP3om^h01@0mFJ/20?ofkP0303eI
Z`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h0203om^h6000000<0ooK^00<0?EV[0000000E1P80
0P00000403]AW080e3dI1@0kDI`010000000>e6L03]AW03D?AT803]AW0050000000kDI`0>e6L0000
003D?AT00P0000000`3D?AT0000003I9R`0203I9R`030000000fBH/0=TV;00L0=TV;00<0e3dI0000
000fBH/01`0fBH/0103D?AT0=TV;03I9R`00000:03I9R`030000000fBH/0=TV;00H0=TV;1@000007
02hmM0030000000^?G@0;Sed00P0;Sed00<0000002hmM00^?G@01`0^?G@00`000000;Sed02hmM004
02hmM0D000001P0T;E<00`00000092eC02@]D`0502@]D`030000000T;E<092eC00D092eC00<00000
03eIZ`3D?AT02@3om^h0103D?AT0?EV[03eIZ`3D?AT503eIZ`030?ofkP0mFJ/0?EV[0080e3dI00<0
?EV[0?ofkP3om^h00`3om^h20=@m6@030?ofkP3D?AT0e3dI01d0ooK^00<000000?ofkP3om^h0A03o
m^h00`000000ooK^0?ofkP0H0?ofkP40oooo001N0?ofkP8000001@3om^h0100mFJ/0ooK^0?ofkP0m
FJ/A0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h01P0mFJ/60?ofkP0303eIZ`3o
m^h0ooK^00D0ooK^1@0mFJ/70?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h00P3o
m^h6000000809`/500D0000003]AW00kDI`0>e6L0=@m6@0603]AW0030000000kDI`0>e6L0080e3dI
1`0kDI`01@000000>e6L03]AW00kDI`0e3dI00<0>e6L00<0e3dI0000000000001000000603I9R`03
0=@m6@0fBH/0000000T0=TV;0P3D?AT00`000000=TV;03I9R`0803I9R`030000000fBH/0=TV;00P0
=TV;00<0000003I9R`0fBH/01P00000202hmM0030000000^?G@0;Sed00L0;Sed00<0000002hmM00^
?G@01`0^?G@00`000000;Sed02hmM00602hmM0030000000^?G@0;Sed00H0000000<092eC0000000T
;E<01P0T;E<00`00000092eC02@]D`0502@]D`030=@m6@3om^h0ooK^00P0ooK^00@0e3dI0?ofkP3D
?AT0ooK^200mFJ/00`3D?AT0?EV[03eIZ`0503eIZ`040=@m6@3om^h0ooK^0=@m6Ah0ooK^00<00000
0?ofkP3om^h0A03om^h00`000000ooK^0?ofkP0H0?ofkP40oooo001N0?ofkP8000001@3om^h0100m
FJ/0ooK^0?ofkP0mFJ/A0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h01P3om^h6
03eIZ`T0ooK^00@0?EV[0?ofkP3om^h0ooK^1@0mFJ/20?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0
?EV[0?ofkP3om^h01@3om^h00`0mFJ/0000000000006000000030=@m6@0kDI`0>e6L00@0>e6L00D0
000003]AW03D?AT0>e6L0=@m6@0703]AW0040000000kDI`0>e6L0=@m6@D0>e6L00@0e3dI03]AW00k
DI`000000P0kDI`6000000030=@m6@0fBH/0000000/0=TV;00<0e3dI03I9R`0fBH/0200fBH/00`00
0000=TV;03I9R`0803I9R`030000000fBH/0=TV;00H0=TV;1@00000702hmM0030000000^?G@0;Sed
00L0;Sed00<0000002hmM00^?G@01`0^?G@00`000000;Sed02hmM00502hmM0D000001@0T;E<00`00
000092eC02@]D`0502@]D`<0?EV[203om^h20=@m6@0303eIZ`3om^h0ooK^00<0ooK^0P0mFJ/20=@m
6@H0?EV[0P3D?AT00`0mFJ/0e3dI0=@m6@0303eIZaX0ooK^00<000000?ofkP3om^h0AP3om^h00`00
0000ooK^0?ofkP0G0?ofkP40oooo001M0?ofkP030000003om^h0000000D0ooK^00@0?EV[0?ofkP3o
m^h0?EV[4@3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00/0ooK^1`0mFJ/30?of
kP0303eIZ`3om^h0ooK^00H0ooK^1P0mFJ/90?ofkP0303eIZ`3om^h0ooK^00D0ooK^0`00000202L;
1@040000000kDI`0>e6L03]AW0D000000P0kDI`00`000000>e6L0=@m6@0203]AW0030=@m6@0kDI`0
>e6L00@0>e6L00@0000003]AW00kDI`0e3dI1P0kDI`00`3D?AT0>e6L0000000703]AW0030=@m6@00
0000000000<000002@0fBH/00`000000e3dI03I9R`0803I9R`030000000fBH/0=TV;00P0=TV;00<0
000003I9R`0fBH/0200fBH/00`000000=TV;03I9R`0600000080;Sed00<0000002hmM00^?G@01`0^
?G@00`000000;Sed02hmM00602hmM0030000000^?G@0;Sed00L0;Sed00<0000002hmM00^?G@01@00
00000`0T;E<0000002@]D`0602@]D`030000000mFJ/0?EV[00@0?EV[0`3om^h0103D?AT0ooK^0?of
kP0mFJ/50?ofkP0303eIZ`3D?AT0e3dI0080ooK^100mFJ/40=@m6@80?EV[0P3om^h603eIZa@0ooK^
00<000000?ofkP3om^h0AP3om^h00`000000ooK^0?ofkP0G0?ofkP40oooo001M0?ofkP030000003o
m^h0000000@0ooK^00@0?EV[0?ofkP3om^h0?EV[4P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eI
Z`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h0103om^h603eIZ`P0ooK^00@0?EV[0?ofkP3om^h0
ooK^1P0mFJ/30?ofkP0303eIZ`3om^h0ooK^00@0ooK^00@0?EV[00000000000000000P0W2`D01P00
0000>e6L03]AW03D?AT0>e6L0=@m6@<0>e6L1P0000000`0kDI`0e3dI03]AW00503]AW0040000000k
DI`0>e6L0=@m6@L0>e6L00<0e3dI0000000kDI`01P0kDI`0103D?AT0>e6L03]AW000000203]AW0H0
00000`0fBH/010000000=TV;0=@m6@3D?AT703I9R`030000000fBH/0=TV;00P0=TV;00<0000003I9
R`0fBH/0200fBH/00`000000=TV;03I9R`0603I9R`D000001`0^?G@00`000000;Sed02hmM00602hm
M0030000000^?G@0;Sed00P0;Sed00<0000002hmM00^?G@0100^?G@5000000030=@m6@0T;E<092eC
008092eC00<000000?ofkP3om^h01@0mFJ/20=@m6@0303eIZ`3om^h0?EV[00<0ooK^0P0mFJ/00`3D
?AT0ooK^0=@m6@050?ofkP@0e3dI200mFJ/30?ofkPH0?EV[3@3om^h00`000000ooK^0?ofkP170?of
kP030000003om^h0ooK^01L0ooK^0@3oool005d0ooK^00<000000?ofkP000000103om^h0100mFJ/0
ooK^0?ofkP0mFJ/B0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0m
FJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00H0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP070?of
kPL0?EV[0`3om^h0100mFJ/0000000000000000202L;1@060000000kDI`0>e6L0=@m6@0kDI`0e3dI
1@0kDI`010000000e3dI03]AW00kDI`600000080>e6L00<0000003]AW03D?AT0200kDI`00`3D?AT0
000003]AW00503]AW0050=@m6@0kDI`0>e6L03]AW0000000200kDI`60000000303I9R`3D?AT0=TV;
00D0=TV;00<0000003I9R`0fBH/0200fBH/00`000000=TV;03I9R`0803I9R`030000000fBH/0=TV;
00P0=TV;00<0000003I9R`0fBH/01P00000202hmM0030000000^?G@0;Sed00H0;Sed00<0000002hm
M00^?G@01`0^?G@00`000000;Sed02hmM00602hmM0030000000^?G@0;Sed00D0000000<092eC0000
003om^h0103om^h00`0mFJ/0e3dI0=@m6@0703eIZ`040?ofkP3D?AT0ooK^0=@m6@@0ooK^00<0e3dI
0?ofkP3D?AT00P3D?AT20?ofkP0403eIZ`3om^h0ooK^0?ofkPL0?EV[0P3om^h703eIZ`L0ooK^00<0
00000?ofkP3om^h0B03om^h00`000000ooK^0?ofkP0G0?ofkP40oooo001M0?ofkP030000003om^h0
000000@0ooK^100mFJ/A0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h02`3om^h0
0`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00H0ooK^1P0mFJ/90?ofkP0403eIZ`3om^h0
ooK^0?ofkP@0?EV[0`00000202L;1@80000000@0e3dI03]AW00kDI`0e3dI1@0kDI`00`000000e3dI
03]AW00303]AW0040=@m6@0kDI`0>e6L03]AW0H00000200kDI`00`3D?AT0>e6L03]AW00403]AW005
0=@m6@0kDI`0>e6L03]AW00000002`0kDI`010000000>e6L03]AW00000030=@m6@8000000P0fBH/0
0`000000=TV;03I9R`0803I9R`030000000fBH/0=TV;00P0=TV;00<0000003I9R`0fBH/0200fBH/0
0`000000=TV;03I9R`0603I9R`D000001P0^?G@00`000000;Sed02hmM00702hmM0030000000^?G@0
;Sed00L0;Sed00<0000002hmM00^?G@0100^?G@3000000@0ooK^00D0e3dI0?ofkP3om^h0e3dI0?of
kP0503eIZ`040=@m6@0mFJ/0?EV[0=@m6@<0?EV[00<0ooK^0=@m6@3om^h00P3D?AT30?ofkP0303eI
Z`3om^h0ooK^0080ooK^0P0mFJ/30?ofkPL0?EV[0`3om^h503eIZ`80ooK^00<000000?ofkP3om^h0
B@3om^h00`000000ooK^0?ofkP0F0?ofkP40oooo001M0?ofkP8000001@3om^h00`0mFJ/0ooK^0?of
kP0803eIZ`X0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3o
m^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP020?ofkPH0?EV[0`3o
m^h00`0mFJ/0ooK^0?ofkP040?ofkP@000000P0W2`D00`000000?UNX0=@m6@02000000040=@m6@00
0000000000000080>e6L00<0e3dI03]AW00kDI`0100kDI`00`3D?AT0>e6L03]AW00203]AW0040000
000kDI`0e3dI03]AW0D000000`0kDI`00`000000e3dI03]AW00403]AW0050=@m6@0kDI`0>e6L03]A
W00000002`0kDI`010000000>e6L03]AW03D?AT303]AW080e3dI1@00000803I9R`030000000fBH/0
=TV;00T0=TV;00<0000003I9R`0fBH/01`0fBH/00`000000=TV;03I9R`0803I9R`030000000fBH/0
=TV;00D000000P0^?G@00`000000;Sed02hmM00702hmM0030000000^?G@0;Sed00H0;Sed00<00000
02hmM00^?G@01`0^?G@01@000000ooK^0?ofkP3om^h0e3dI0080ooK^00<0e3dI0?ofkP3om^h00P0m
FJ/20?ofkP040=@m6@0mFJ/0?EV[0=@m6@<0?EV[00@0e3dI03eIZ`3D?AT0e3dI0`0mFJ/20?ofkP04
03eIZ`3om^h0ooK^03eIZ`X0ooK^1`0mFJ/30?ofkPD0?EV[B@3om^h00`000000ooK^0?ofkP0F0?of
kP40oooo001M0?ofkP8000001@3om^h0100mFJ/0ooK^0?ofkP0mFJ/70?ofkPL0?EV[0`3om^h00`0m
FJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0m
FJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00P0ooK^1`0mFJ/30?ofkP@0000000D09`/50000
00000000?UNX0=@m6@0303iGZ0030=@m6@0nEjP0?UNX0080000000<0e3dI0000000000001@0kDI`0
1P3D?AT0>e6L03]AW00kDI`000000=@m6@L0>e6L1P00000303]AW0030=@m6@0kDI`0>e6L0080>e6L
00<0000003]AW00kDI`02@0kDI`010000000>e6L03]AW03D?AT503]AW080e3dI00<0000003]AW00k
DI`01P00000203I9R`030000000fBH/0=TV;00T0=TV;00<0000003I9R`0fBH/01`0fBH/00`000000
=TV;03I9R`0803I9R`030000000fBH/0=TV;00D0=TV;1@00000702hmM0030000000^?G@0;Sed00L0
;Sed00<0000002hmM00^?G@01P0^?G@010000000ooK^0?ofkP3D?AT30?ofkP030=@m6@3om^h0ooK^
0080?EV[00<0ooK^0=@m6@3om^h00P3om^h0103D?AT0ooK^0?ofkP3om^h40=@m6@80?EV[00<0ooK^
03eIZ`0mFJ/0100mFJ/>0?ofkPT0?EV[0P3om^h403eIZdD0ooK^00<000000?ofkP3om^h05P3om^h1
0?ooo`00G03om^h00`000000ooK^000000050?ofkP0403eIZ`3om^h0ooK^03eIZ`h0ooK^1`0mFJ/3
0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP08
0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00@0?EV[0?ofkP3om^h0ooK^1P0mFJ/01@0000009`/50000
00000000e3dI00@0?UNX00<0e3dI03iGZ00nEjP00P0nEjP00`3D?AT0?UNX03iGZ005000000060=@m
6@0kDI`0>e6L03]AW0000000e3dI2P0kDI`00`000000>e6L03]AW00600000080>e6L00<0000003]A
W00kDI`02@0kDI`00`000000>e6L0=@m6@0803]AW080e3dI1`0kDI`5000000T0=TV;00<0000003I9
R`0fBH/0200fBH/00`000000=TV;03I9R`0703I9R`030000000fBH/0=TV;00L0=TV;00<0000003I9
R`0fBH/01P00000202hmM0030000000^?G@0;Sed00H0;Sed00<0000002hmM00^?G@01`0^?G@00`00
0000ooK^0=@m6@030?ofkP070=@m6@3om^h0?EV[0?ofkP0mFJ/0ooK^0=@m6@030?ofkP030=@m6@3o
m^h0ooK^00@0e3dI0`3om^h603eIZ`030?ofkP0mFJ/0?EV[00<0?EV[2P3om^h0100mFJ/0ooK^0?of
kP3om^h<03eIZd<0ooK^00<000000?ofkP3om^h05P3om^h10?ooo`00G03om^h00`000000ooK^0000
00040?ofkP0403eIZ`3om^h0ooK^03eIZa80ooK^00@0?EV[0?ofkP3om^h0ooK^1P0mFJ/:0?ofkP03
03eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP03
03eIZ`3om^h0ooK^00<0ooK^0`0000000`0W2`D0?EV[03eIZ`0203eIZ`030=@m6@0nEjP0?UNX0080
?UNX00H0e3dI03iGZ00nEjP0?UNX0=@m6@00000803iGZ0040=@m6@00000000000=@m6@8000002@0k
DI`010000000>e6L03]AW00kDI`20=@m6@<0>e6L1P00000803]AW0030000000kDI`0e3dI00P0>e6L
00@0000003]AW03D?AT0e3dI1`0kDI`00`000000>e6L03]AW006000000<0=TV;00<0000003I9R`0f
BH/0200fBH/00`000000=TV;03I9R`0703I9R`030000000fBH/0=TV;00L0=TV;00<0000003I9R`0f
BH/01P0fBH/5000000L0;Sed00<0000002hmM00^?G@01P0^?G@00`000000e3dI0?ofkP040?ofkP05
0=@m6@3om^h0ooK^0?ofkP3D?AT0103om^h01@3D?AT0ooK^0=@m6@3D?AT0ooK^0080e3dI1@3om^h0
0`0mFJ/0ooK^0?ofkP0603eIZ`030?ofkP0mFJ/0?EV[00<0?EV[1@3om^h0100mFJ/0ooK^0?ofkP3o
m^h203eIZ`P0ooK^100mFJ]10?ofkP030000003om^h0ooK^01H0ooK^0@3oool005`0ooK^00<00000
0?ofkP000000103om^h0100mFJ/0ooK^0?ofkP0mFJ/B0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0
?EV[0?ofkP3om^h01`0mFJ/30?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h0203o
m^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00@0000001D60P0000009`/5
0P00000203T@20030000000nEjP0?UNX00<0?UNX00D0e3dI03iGZ00nEjP0e3dI0000000803iGZ004
0=@m6@0nEjP0?UNX0=@m6@80?UNX1P00000303]AW0030000000kDI`0>e6L0080>e6L00<0e3dI03]A
W00kDI`00`0kDI`010000000>e6L03]AW00kDI`5000000<0>e6L00<0000003]AW03D?AT0200kDI`0
10000000>e6L03]AW00kDI`20=@m6@D0>e6L00<0000003]AW00kDI`01P0kDI`6000000P0=TV;00<0
000003I9R`0fBH/0200fBH/00`000000=TV;03I9R`0703I9R`030000000fBH/0=TV;00L0=TV;00<0
000003I9R`0fBH/01P0000000`0^?G@0000002hmM00702hmM0040=@m6@0mFJ/0?EV[03eIZ`80ooK^
00<0?EV[0=@m6@3om^h00P3om^h00`3D?AT0ooK^0?ofkP020?ofkP<0e3dI00<0ooK^0=@m6@3D?AT0
1@3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00D0ooK^100mFJ/20?ofkPD0?EV[00@0ooK^03eIZ`3o
m^h0?EV[3P3om^h00`0mFJ/0ooK^0?ofkP0o0?ofkP030000003om^h0ooK^01D0ooK^0@3oool005`0
ooK^00<000000?ofkP000000103om^h00`0mFJ/0ooK^0?ofkP0403eIZ`l0ooK^00<0?EV[0?ofkP3o
m^h00`3om^h00`0mFJ/0ooK^0?ofkP080?ofkPH0?EV[203om^h00`0mFJ/0ooK^0?ofkP080?ofkP03
03eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h00`3om^h30000000302L;1@000000>A080080
>A0800<0000003iGZ00nEjP00`0nEjP00`3D?AT0?UNX0=@m6@0203iGZ0030000000nEjP0?UNX00H0
?UNX00<0e3dI03iGZ03D?AT0200nEjP600000080>e6L0`3D?AT303]AW0030000000kDI`0>e6L00H0
>e6L1P00000803]AW0030000000kDI`0>e6L00<0>e6L0P3D?AT303]AW0030000000kDI`0>e6L00T0
>e6L00<0000003]AW00kDI`01P00000203I9R`030000000fBH/0=TV;00P0=TV;00<0000003I9R`0f
BH/01`0fBH/00`000000=TV;03I9R`0703I9R`030000000fBH/0=TV;00H0=TV;1@00000702hmM003
0000003om^h0?EV[0080?EV[00H0e3dI03eIZ`0mFJ/0e3dI0?ofkP0mFJ/30?ofkP80e3dI0P3om^h0
0`3D?AT0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h01`3om^h5
03eIZ`80ooK^1@0mFJ/>0?ofkP0303eIZ`3om^h0ooK^03h0ooK^00<000000?ofkP3om^h05@3om^h1
0?ooo`00G03om^h2000000D0ooK^00@0?EV[0?ofkP3om^h0?EV[0`3om^h603eIZ`P0ooK^00<0?EV[
0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00D0?EV[0`3om^h0
0`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h00`3om^h0
1P0mFJ/000000000000000009`/5000000<0>A0800<0000003iGZ00nEjP00`0nEjP00`3D?AT0?UNX
0=@m6@0203iGZ0030000000nEjP0?UNX00H0?UNX0P3D?AT00`000000?UNX03iGZ00903iGZ0050000
000nEjP0?UNX0000003D?AT00`000000103D?AT0>e6L03]AW000000;03]AW0030000003D?AT0>e6L
00H000000P0kDI`00`000000>e6L03]AW00503]AW080e3dI00<0>e6L0000000kDI`02P0kDI`00`00
0000>e6L03]AW00603]AW0D00000200fBH/00`000000=TV;03I9R`0703I9R`030000000fBH/0=TV;
00P0=TV;00<0000003I9R`0fBH/01`0fBH/00`000000=TV;03I9R`060000000302hmM0000000?EV[
00<0?EV[00@0e3dI0?ofkP3om^h0e3dI100mFJ/30=@m6@030?ofkP3D?AT0e3dI00D0ooK^00<0?EV[
0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP<0?EV[00@0ooK^03eIZ`3om^h0ooK^1@0m
FJ/90?ofkP0303eIZ`3om^h0ooK^03h0ooK^00<000000?ofkP3om^h05@3om^h10?ooo`00G03om^h2
000000D0ooK^00@0?EV[0?ofkP3om^h0?EV[2@3om^h603eIZ`80ooK^00<0?EV[0?ofkP3om^h0103o
m^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00D0ooK^1P0mFJ/70?ofkP0303eIZ`3o
m^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h00`3om^h20000000402L;1@0000009`/5000000<0>A08
00<0000003iGZ00nEjP00`0nEjP00`3D?AT0?UNX0=@m6@0203iGZ0030000000nEjP0?UNX00L0?UNX
00<0e3dI0000000nEjP02P0nEjP01@000000?UNX03iGZ00nEjP0e3dI00@0?UNX00<0e3dI00000000
00000P00000903]AW0030=@m6@0kDI`0>e6L00H0>e6L1P00000603]AW0<0e3dI2P0kDI`00`000000
>e6L03]AW00803]AW0030000000kDI`0>e6L00H000000P0fBH/00`000000=TV;03I9R`0703I9R`03
0000000fBH/0=TV;00P0=TV;00<0000003I9R`0fBH/01`0fBH/00`000000=TV;03I9R`0603I9R`<0
000000@0?EV[0?ofkP3om^h0ooK^0P3D?AT403eIZ`040=@m6@0mFJ/0e3dI03eIZ`80e3dI1@3om^h0
0`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00`0ooK^00D0?EV[0?ofkP000000ooK^03eI
Z`060?ofkPD0?EV[1@3om^h00`0mFJ/0ooK^0?ofkP0m0?ofkP030000003om^h0ooK^01D0ooK^0@3o
ool005/0ooK^00<000000?ofkP0000001@3om^h00`0mFJ/0ooK^03eIZ`0@0?ofkPH0?EV[0`3om^h0
0`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h01@0mFJ/2
0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h00`3om^h20000000402L;1@000000
0000000000<0>A0800<0000003iGZ00nEjP0100nEjP01@3D?AT0?UNX03iGZ00nEjP0000000T0?UNX
0P3D?AT;03iGZ0040000000nEjP0?UNX0=@m6@H0?UNX0P3D?AT203iGZ0H000000`0kDI`00`3D?AT0
>e6L03]AW00803]AW0040000000kDI`0>e6L03]AW0D000000P0kDI`00`3D?AT0>e6L0=@m6@020=@m
6@L0>e6L00<0000003]AW00kDI`0200kDI`00`000000>e6L03]AW00603]AW0D00000200fBH/00`00
0000=TV;03I9R`0703I9R`030000000fBH/0=TV;00P0=TV;00<0000003I9R`0fBH/01`0fBH/00`00
0000?EV[0?ofkP020?ofkP80e3dI0P3om^h20=@m6@0403eIZ`3D?AT0e3dI03eIZ`80e3dI1P0mFJ/6
0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00H0?EV[0?ofkP3om^h000000?ofkP0mFJ/;0?ofkPD0?EV[
00<0ooK^03eIZ`3om^h0?P3om^h00`000000ooK^0?ofkP0D0?ofkP40oooo001K0?ofkP030000003o
m^h0000000D0ooK^00<0?EV[0?ofkP0mFJ/04P3om^h0100mFJ/0ooK^0?ofkP3om^h603eIZ`X0ooK^
00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP050?ofkPH0?EV[2P3om^h00`0mFJ/0ooK^
0?ofkP030?ofkP030000000W2`D09`/500<00000100i40P00`000000?UNX03iGZ00303iGZ0050=@m
6@0nEjP0?UNX03iGZ0000000200nEjP0103D?AT0?UNX0000003D?AT:03iGZ0040000000nEjP0?UNX
0=@m6@L0?UNX00<000000=@m6@0nEjP01P0nEjP2000000040=@m6@0000000000000000P0>e6L00<0
000003]AW00kDI`01P0kDI`60000000303]AW03D?AT0e3dI00D0>e6L00<0000003]AW00kDI`0200k
DI`00`000000>e6L03]AW00803]AW0030000000kDI`0>e6L00H000000P0fBH/00`000000=TV;03I9
R`0703I9R`030000000fBH/0=TV;00P0=TV;00<0000003I9R`0fBH/01`0fBH/00`000000ooK^0?of
kP020?ofkP030=@m6@3om^h0e3dI0080e3dI0P3om^h01@3D?AT0ooK^0=@m6@3D?AT0ooK^00/0?EV[
0P3om^h00`0mFJ/0ooK^0?ofkP090?ofkP0403eIZ`3om^h0ooK^000000<0ooK^00<0?EV[0?ofkP3o
m^h03@3om^h303eIZch0ooK^00<000000?ofkP3om^h0503om^h10?ooo`00F`3om^h00`000000ooK^
000000040?ofkP0403eIZ`3om^h0ooK^03eIZa80ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0
ooK^0?ofkP0503eIZ`D0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP080?ofkP04
03eIZ`3om^h0ooK^0?ofkPH0?EV[103om^h00`0mFJ/0ooK^0?ofkP020?ofkP8000000P0W2`D20000
000303T@20000000>A080080>A0800<0000003iGZ00nEjP00`0nEjP20=@m6@80?UNX00<0000003iG
Z00nEjP01P0nEjP01@3D?AT0?UNX03iGZ0000000e3dI00T0?UNX00@0000003iGZ00nEjP0e3dI1`0n
EjP00`000000?UNX0=@m6@0803iGZ0040=@m6@000000?UNX03iGZ0H000000P0kDI`00`000000>e6L
03]AW00703]AW0030=@m6@000000>e6L0080>e6L1P0000000`0kDI`0000003]AW00:03]AW0030000
000kDI`0>e6L00P0>e6L00<0000003]AW00kDI`01P0kDI`5000000P0=TV;00<0000003I9R`0fBH/0
1`0fBH/00`000000=TV;03I9R`0803I9R`030000003om^h0ooK^00<0e3dI0P3om^h01P3D?AT0?EV[
0=@m6@3D?AT0ooK^0=@m6@@0ooK^00<0?EV[0?ofkP3om^h00P3om^h903eIZ`P0ooK^00D0?EV[0?of
kP3om^h0ooK^000000030?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h0?03om^h0
0`000000ooK^0?ofkP0D0?ofkP40oooo001K0?ofkP030000003om^h0000000@0ooK^00@0?EV[0?of
kP3om^h0?EV[4P3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00D0ooK^100mFJ/0
0`3om^h0?EV[0?ofkP090?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h01`3om^h6
03eIZ`<0ooK^0P00000202L;1@80000000<0>A080000000i40P00P0i40P300000080?UNX00<0e3dI
03iGZ03D?AT00`0nEjP00`000000?UNX03iGZ00503iGZ0060=@m6@0nEjP0?UNX0000000nEjP0e3dI
200nEjP00`000000?UNX0=@m6@0803iGZ0030000000nEjP0?UNX0080e3dI1P0nEjP00`3D?AT00000
03iGZ00703iGZ0D000001P0kDI`00`3D?AT0>e6L0000000903]AW0H000001`0kDI`00`000000>e6L
03]AW00803]AW0030000000kDI`0>e6L00L0>e6L00@0?EV[0000000kDI`0>e6L1P00000203I9R`03
0000000fBH/0=TV;00L0=TV;00<0000003I9R`0fBH/0200fBH/00`000000e3dI0=@m6@020=@m6@80
ooK^00<0e3dI0?ofkP0mFJ/0103D?AT40?ofkP0303eIZ`3om^h0ooK^00P0ooK^200mFJ/20?ofkP05
03eIZ`3om^h0ooK^0?ofkP0000001@3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^
03/0ooK^00<000000?ofkP3om^h0503om^h10?ooo`00F`3om^h2000000D0ooK^00@0?EV[0?ofkP3o
m^h0?EV[4P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00X0ooK^1@0mFJ/70?of
kP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^03eIZ`0203eI
Z`8000000P0W2`D010000000>A0803T@2000000303T@200300000011G;80@Ebb0080000000@0e3dI
000000000000e3dI0P0nEjP00`000000?UNX03iGZ00403iGZ0050=@m6@0nEjP0?UNX03iGZ0000000
0P0nEjP00`3D?AT0?UNX03iGZ00503iGZ0030000000nEjP0e3dI00P0?UNX00<0000003iGZ00nEjP0
0P0nEjP00`3D?AT0?UNX03iGZ00203iGZ0030=@m6@0nEjP0000000X0?UNX00<0000003iGZ00nEjP0
1P0000000`3D?AT0>e6L0000000:03]AW0050000000kDI`0e3dI0=@m6@0kDI`01@00000203]AW003
0000000kDI`0>e6L00P0>e6L00<0000003]AW00kDI`0200kDI`00`000000>e6L03]AW00603]AW0D0
0000200fBH/00`000000=TV;03I9R`0603I9R`80e3dI00H0ooK^0=@m6@3om^h0e3dI0?ofkP3D?AT2
0?ofkP80e3dI00<0ooK^0=@m6@3om^h00`3om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0
ooK^00<0ooK^200mFJ/60?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h0>`3om^h0
0`000000ooK^0?ofkP0D0?ofkP40oooo001K0?ofkP8000001@3om^h403eIZa40ooK^00<0?EV[0?of
kP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0403eIZ`3om^h0ooK^0?ofkPD0?EV[0P3om^h0
0`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h00P3om^h2
000000809`/500@0000003T@200i40P000000P0i40P2000000@0@Ebb00D0e3dI045L/P11G;80@Ebb
0=@m6@04000000@0?UNX00D0e3dI03iGZ00nEjP0?UNX0000000303iGZ0030=@m6@0nEjP0?UNX00@0
?UNX00<0000003iGZ03D?AT0200nEjP00`000000?UNX03iGZ00303iGZ0070=@m6@0nEjP0?UNX03iG
Z03D?AT0?UNX0000000:03iGZ0030000000nEjP0?UNX00D0?UNX00<0e3dI0000000000000`000008
03]AW0040000000kDI`0>e6L03]AW0<0e3dI0`0kDI`6000000L0>e6L00<0000003]AW00kDI`0200k
DI`00`000000>e6L03]AW00803]AW0030000000kDI`0>e6L00H000000P0fBH/00`000000=TV;03I9
R`0403I9R`80e3dI00/0=TV;0000003om^h0e3dI0?ofkP3D?AT0ooK^0=@m6@3om^h0e3dI03eIZ`03
0=@m6@@0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0
ooK^0080ooK^00<0000003eIZ`0mFJ/00`0mFJ/20?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[
0?ofkP3om^h0>`3om^h00`000000ooK^0?ofkP0C0?ofkP40oooo001J0?ofkP030000003om^h00000
00D0ooK^00@0?EV[0?ofkP0mFJ/0ooK^1`0mFJ/:0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[
0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP060?ofkPD0?EV[1`3om^h00`0mFJ/0ooK^0?ofkP0;
0?ofkP0303eIZ`3om^h0ooK^0080ooK^0`00000202L;1@040000000i40P0>A0800000080>A0800<0
000004/F2`0000000P11G;800`3D?AT0@Ebb045L/P02045L/P030=@m6@11G;8000000080@Ebb1000
00001@3D?AT0000003iGZ00nEjP0000000<0?UNX00<0e3dI03iGZ00nEjP0100nEjP00`000000e3dI
03iGZ00903iGZ0030000000nEjP0?UNX00<0?UNX0`3D?AT203iGZ0030000000nEjP0?UNX00P0?UNX
00<0000003iGZ00nEjP01@0nEjP0103D?AT0?UNX03iGZ000000203iGZ0H000000P0kDI`00`000000
>e6L03]AW00403]AW0@0e3dI00<0>e6L0000000kDI`00P0kDI`60000000303]AW0000000>e6L00T0
>e6L00<0000003]AW00kDI`0200kDI`00`000000>e6L03]AW00603]AW0D00000103D?AT403I9R`03
0=@m6@3om^h0ooK^0080e3dI0P3om^h0103D?AT0?EV[0=@m6@3D?AT40?ofkP0303eIZ`3om^h0ooK^
00/0ooK^00<0?EV[0?ofkP3om^h0103om^h01@0mFJ/0ooK^0?ofkP3om^h0000000H0ooK^1P0mFJ/>
0?ofkP0303eIZ`3om^h0ooK^03/0ooK^00<000000?ofkP3om^h04`3om^h10?ooo`00FP3om^h00`00
0000ooK^000000050?ofkP0303eIZ`3om^h0?EV[00P0ooK^1`0mFJ/30?ofkP0303eIZ`3om^h0ooK^
00@0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^
00H0?EV[00<0ooK^03eIZ`3om^h0303om^h00`0mFJ/0ooK^0?ofkP020?ofkP<000000P0W2`D01P00
0000>A0803T@20000000>A0800000080BaH;00@00000045L/P11G;80e3dI1@11G;800`3D?AT00000
045L/P04045L/P030=@m6@11G;80@Ebb00D000000P0nEjP00`3D?AT0?UNX03iGZ00303iGZ0030000
003D?AT0?UNX00T0?UNX00<0000003iGZ00nEjP01@0nEjP0103D?AT0?UNX03iGZ000000:03iGZ003
0000000nEjP0?UNX00@0?UNX00D0e3dI03iGZ00nEjP0?UNX0000000803iGZ0D00000100kDI`0103D
?AT0>e6L03]AW00kDI`60=@m6@D0>e6L1P00000603]AW0030000000kDI`0>e6L00P0>e6L00<00000
03]AW00kDI`01P0kDI`50=@m6@030000003D?AT0000000<000000P0fBH/00`3D?AT0ooK^0?ofkP02
0=@m6@030?ofkP3D?AT0ooK^0080e3dI1@3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0
ooK^00<0ooK^00D0?EV[0?ofkP3om^h0ooK^000000090?ofkP0403eIZ`3om^h0ooK^0?ofkPH0?EV[
2@3om^h00`0mFJ/0ooK^0?ofkP0j0?ofkP030000003om^h0ooK^01<0ooK^0@3oool005X0ooK^00<0
00000?ofkP0000001@3om^h00`0mFJ/0ooK^03eIZ`0?0?ofkPH0?EV[103om^h00`0mFJ/0ooK^0?of
kP0;0?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h01P3om^h603eIZ`T0ooK^00<0
?EV[0?ofkP3om^h00P3om^h00`0000009`/502L;1@03000000<0>A080P00000204/F2`0300000011
G;80e3dI00L0@Ebb00<0e3dI00000011G;800`11G;800`3D?AT0@Ebb045L/P02045L/P0300000011
G;80@Ebb00<0000000<0e3dI0000000000000P0nEjP00`3D?AT0?UNX03iGZ00903iGZ0030000000n
EjP0?UNX00D0?UNX0`3D?AT00`000000?UNX03iGZ00803iGZ0030000000nEjP0?UNX00@0?UNX00D0
e3dI03iGZ00nEjP0?UNX0000000:03iGZ0030000000nEjP0?UNX00@0000000<0e3dI0000000kDI`0
0P0kDI`00`000000>e6L03]AW00203]AW0H0e3dI00<0000003]AW00kDI`00P0kDI`7000000X0>e6L
00<0000003]AW00kDI`01P3D?AT203]AW0050000000kDI`0>e6L03]AW03D?AT0100kDI`010000000
e3dI0000000mFJ/20=@m6@80ooK^00@0e3dI0?ofkP3D?AT0e3dI103om^h00`0mFJ/0ooK^0?ofkP0<
0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h00P3om^h00`000000ooK^0?ofkP07
0?ofkP0303eIZ`3om^h0ooK^00L0ooK^1`0mFJ/20?ofkP0303eIZ`3om^h0ooK^03X0ooK^00<00000
0?ofkP3om^h04`3om^h10?ooo`00FP3om^h00`000000ooK^000000040?ofkP0403eIZ`3om^h0ooK^
03eIZa80ooK^00<0?EV[0?ofkP3om^h01@0mFJ/<0?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[
0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP030?ofkPH0?EV[0`3om^h0100mFJ/0ooK^0?ofkP3o
m^h2000000809`/50P000000100i40P0000003T@200i40P200000080BaH;00<00000045L/P3D?AT0
2011G;800`3D?AT0@Ebb045L/P02045L/P030=@m6@11G;80@Ebb0080@Ebb00<00000045L/P11G;80
1011G;801@3D?AT0@Ebb000000000000e3dI008000002@0nEjP00`000000?UNX03iGZ00403iGZ004
0=@m6@0nEjP0?UNX03iGZ080e3dI2@0nEjP00`000000?UNX03iGZ00303iGZ0030=@m6@0nEjP0?UNX
0080?UNX00<0000003iGZ00nEjP0200nEjP00`000000?UNX03iGZ00303iGZ0030=@m6@0nEjP0?UNX
00H00000200kDI`;0=@m6@D000002@3D?AT803]AW0040000000kDI`0>e6L0=@m6@L0>e6L00<00000
0?ofkP3D?AT00P0mFJ/40=@m6@0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h03@3om^h0
1@0mFJ/0ooK^0?ofkP3om^h0?EV[00<0ooK^00<000000?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?of
kP0=0?ofkP@0?EV[?03om^h00`000000ooK^0?ofkP0B0?ofkP40oooo001J0?ofkP8000001@3om^h0
100mFJ/0ooK^0?ofkP0mFJ/B0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP0mFJ/0100m
FJ/70?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?of
kP090?ofkPP0?EV[00<0000002L;1@0W2`D00P0000001@0i40P0000003T@200i40P0000000<0BaH;
00<00000045L/P3D?AT02011G;801@3D?AT0@Ebb045L/P11G;80e3dI00D0@Ebb00<00000045L/P11
G;801@11G;80103D?AT0@Ebb045L/P3D?AT2045L/PH000000`0nEjP00`000000?UNX03iGZ00403iG
Z0060=@m6@0nEjP0?UNX03iGZ0000000?UNX0P3D?AT703iGZ0030000000nEjP0?UNX00<0?UNX00<0
e3dI03iGZ00nEjP00P0nEjP00`000000?UNX03iGZ00803iGZ0030000000nEjP0?UNX00<0?UNX00<0
e3dI03iGZ00nEjP00`0nEjP00`000000?UNX03iGZ00600000080>e6L00<0000003]AW03D?AT0200k
DI`00`000000>e6L03]AW00203]AW0L000002P0kDI`010000000>e6L03]AW03D?AT703]AW0040000
003om^h0e3dI0?ofkP80e3dI00<0ooK^0=@m6@3D?AT01`0mFJ/>0?ofkP0403eIZ`3om^h0ooK^03eI
Z`<0ooK^00<000000?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0303eIZ`3om^h0ooK^
03X0ooK^00<000000?ofkP3om^h04P3om^h10?ooo`00FP3om^h2000000D0ooK^00@0?EV[0?ofkP3o
m^h0?EV[4@3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00@0ooK^1@0mFJ/20?of
kP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP0<0?of
kP0503eIZ`3om^h0ooK^0?ofkP000000200mFJ/00`0i40P0000004/F2`0304/F2`030=@m6@11G;80
@Ebb00L0@Ebb00D000000=@m6@11G;80@Ebb0=@m6@06045L/P0300000011G;80@Ebb00D0@Ebb0P3D
?AT00`000000@Ebb045L/P06045L/PH000000`0nEjP00`3D?AT0?UNX03iGZ00203iGZ0040000000n
EjP0?UNX03iGZ080e3dI1@0nEjP00`000000?UNX03iGZ00203iGZ0030=@m6@0nEjP0?UNX00<0?UNX
00<0000003iGZ00nEjP0200nEjP00`000000?UNX03iGZ00203iGZ0030=@m6@0nEjP0?UNX00@0?UNX
00<0000003iGZ00nEjP01P0nEjP4000000040=@m6@0000000000000000D0>e6L00<0000003]AW00k
DI`01`0kDI`00`3D?AT0000000000004000000D0>e6L00<0000003]AW03D?AT0200kDI`01@000000
e3dI0=@m6@3om^h0e3dI0080ooK^00<0e3dI0?ofkP0mFJ/00P3om^h:03eIZ`P0ooK^00<0?EV[0?of
kP0mFJ/0103om^h00`000000ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^0100ooK^00<0?EV[0?of
kP3om^h0>P3om^h00`000000ooK^0?ofkP0B0?ofkP40oooo001I0?ofkP030000003om^h0000000D0
ooK^00<0?EV[0?ofkP0mFJ/04P3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00T0
ooK^1P0mFJ/70?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h0303om^h0100mFJ/0
ooK^0?ofkP3om^h2000000809`/500D0000003T@200i40P0000003T@200503eIZ`0304/F2`3D?AT0
@Ebb00P0@Ebb00D00000045L/P3D?AT0@Ebb0=@m6@06045L/P0300000011G;80@Ebb00H0@Ebb00<0
e3dI00000011G;802P11G;800`000000@Ebb045L/P03000000030=@m6@00000000000080?UNX00<0
000003iGZ00nEjP00`0nEjP20=@m6@<0?UNX00<0000003iGZ00nEjP00P0nEjP00`3D?AT0?UNX03iG
Z00303iGZ0030000000nEjP0?UNX00P0?UNX00<0000003iGZ00nEjP00P0nEjP00`3D?AT0?UNX03iG
Z00303iGZ0030000000nEjP0?UNX00T0?UNX00<000000=@m6@0nEjP00`0nEjP8000000H0>e6L00<0
e3dI03]AW00000001@0kDI`60000000303]AW03D?AT0>e6L00L0>e6L00@0e3dI0?ofkP3D?AT0e3dI
0P3om^h0103D?AT0ooK^0?ofkP0mFJ/20?ofkP0303eIZ`3om^h0ooK^00<0ooK^2P0mFJ/20?ofkP03
03eIZ`3om^h0?EV[00<0ooK^00<000000?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP03
03eIZ`3om^h0ooK^03T0ooK^00<000000?ofkP3om^h04P3om^h10?ooo`00F@3om^h00`000000ooK^
000000050?ofkP0303eIZ`3om^h0?EV[0180ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^
0?ofkP0;0?ofkP0403eIZ`3om^h0ooK^0?ofkPH0?EV[00<0ooK^03eIZ`3om^h01`3om^h00`0mFJ/0
ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00<000000P0W2`D020000000>A0803T@20000000>A08
0000001;5P/000000P1;5P/203eIZ`X0@Ebb00<000000=@m6@3D?AT01`11G;800`000000@Ebb045L
/P06045L/P<0e3dI2P11G;800`000000@Ebb045L/P03045L/P030=@m6@11G;80@Ebb00D000001@0n
EjP20=@m6@0303iGZ0000000?UNX0080?UNX00<0e3dI03iGZ00nEjP0100nEjP00`000000?UNX03iG
Z00703iGZ0030000000nEjP0?UNX0080?UNX00<0e3dI03iGZ00nEjP0100nEjP00`000000?UNX03iG
Z00903iGZ0030000003D?AT0?UNX00P0?UNX00<0000003iGZ00nEjP01P0000000`3D?AT0>e6L0000
000:03]AW0H00000100kDI`00`000000e3dI0?ofkP020=@m6@030?ofkP3D?AT0e3dI0080ooK^00@0
?EV[0?ofkP3om^h0?EV[2P3om^h903eIZ`@0ooK^00<000000?ofkP3om^h02`3om^h00`0mFJ/0ooK^
0?ofkP0A0?ofkP0303eIZ`3om^h0ooK^03T0ooK^00<000000?ofkP3om^h04P3om^h10?ooo`00F@3o
m^h00`000000ooK^000000050?ofkP0303eIZ`3om^h0?EV[0180ooK^00<0?EV[0?ofkP3om^h0103o
m^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00L0ooK^1`0mFJ/30?ofkP0303eIZ`3o
m^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h00`00000202L;1@080000000i40P0>A080000000i40P0
000004/F2`00000304/F2`0300000011G;80@Ebb00P0@Ebb00<00000045L/P3D?AT01`11G;800`00
0000@Ebb045L/P05045L/P050=@m6@11G;80@Ebb0000003D?AT02@11G;800`000000@Ebb045L/P02
045L/P030=@m6@11G;80@Ebb00<0@Ebb00<00000045L/P11G;801P0000000`0nEjP0e3dI0=@m6@03
03iGZ0030=@m6@0nEjP0?UNX00@0?UNX00<0000003iGZ00nEjP01`0nEjP00`000000?UNX03iGZ002
03iGZ0030=@m6@0nEjP0?UNX00@0?UNX00<0000003iGZ00nEjP0200nEjP00`000000e3dI03iGZ009
03iGZ0030000000nEjP0?UNX00D0?UNX00<0e3dI0000000000000`00000803]AW0030=@m6@0kDI`0
>e6L00<0>e6L1P0000020=@m6@80ooK^00L0e3dI0?ofkP3om^h0ooK^03eIZ`3om^h0?EV[0140ooK^
1P0mFJ/00`000000ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^0140ooK^00<0?EV[0?ofkP3om^h0
>P3om^h00`000000ooK^0?ofkP0A0?ofkP40oooo001I0?ofkP030000003om^h0000000D0ooK^00<0
?EV[0?ofkP0mFJ/00`0mFJ/?0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h02P3o
m^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00@0ooK^1`0mFJ/;0?ofkP0803eIZ`3o
m^h0ooK^0?ofkP0000009`/50000000W2`D2000000<0>A080P0000000`1;5P/0000004/F2`0304/F
2`0300000011G;80@Ebb00L0@Ebb00@00000045L/P3D?AT0e3dI1P11G;800`000000@Ebb045L/P05
045L/P060=@m6@11G;80@Ebb00000011G;80e3dI2011G;800`000000@Ebb045L/P02045L/P030=@m
6@11G;80@Ebb00<0@Ebb00<00000045L/P11G;801P11G;83000000<0e3dI1`0nEjP00`000000?UNX
03iGZ00703iGZ0050000000nEjP0?UNX03iGZ03D?AT01`0nEjP00`000000?UNX03iGZ00803iGZ003
0000003D?AT0?UNX00P0?UNX00<0000003iGZ00nEjP01P0nEjP0103D?AT0?UNX03iGZ000000203iG
Z0H000000P0kDI`00`3D?AT0>e6L03]AW00703]AW0030=@m6@3om^h0000000D000000P3om^h00`0m
FJ/0ooK^03eIZ`0B0?ofkP80?EV[0P3om^h00`000000?EV[03eIZ`0403eIZ`X0ooK^00<0?EV[0?of
kP3om^h0403om^h00`0mFJ/0ooK^0?ofkP0j0?ofkP030000003om^h0ooK^0140ooK^0@3oool005T0
ooK^0P0000060?ofkP0303eIZ`3om^h0?EV[00<0ooK^1P0mFJ/80?ofkP0303eIZ`3om^h0ooK^00@0
ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00L0
ooK^00@0?EV[0?ofkP3om^h0ooK^1P0mFJ/50?ofkP0303eIZ`3om^h0ooK^008000000P0W2`D20000
000503T@20000000>A0803T@200000000`1;5P/01@000000BaH;04/F2`1;5P/0000000T0@Ebb00D0
00000=@m6@11G;80@Ebb0=@m6@05045L/P0300000011G;80@Ebb00@0@Ebb00D0e3dI045L/P11G;80
@Ebb00000002045L/P80e3dI1P11G;800`000000@Ebb045L/P02045L/P030=@m6@11G;80@Ebb00<0
@Ebb00<00000045L/P11G;802011G;800`000000@Ebb045L/P020=@m6@@000000P0nEjP00`000000
?UNX03iGZ00703iGZ0050000000nEjP0?UNX03iGZ03D?AT01`0nEjP00`000000?UNX03iGZ00803iG
Z0030=@m6@0nEjP0?UNX00P0?UNX00<0000003iGZ00nEjP01@0nEjP0103D?AT0?UNX03iGZ0000009
03iGZ0030000003D?AT00000008000001@0kDI`20=@m6@030000003om^h0e3dI0080ooK^00<0e3dI
0?ofkP3om^h01P00000A0?ofkP80?EV[0P3om^h00`000000ooK^0?ofkP040?ofkPL0?EV[0`3om^h0
0`0mFJ/0ooK^0?ofkP0A0?ofkP0303eIZ`3om^h0ooK^03T0ooK^00<000000?ofkP3om^h04@3om^h1
0?ooo`00F@3om^h2000000D0ooK^00@0?EV[0?ofkP3om^h0?EV[2@3om^h603eIZ`80ooK^00<0?EV[
0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[
0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP070?ofkPL0?EV[00<0ooK^0000000000000P0W2`D2
0000000503T@20000000>A0803T@200000000`1;5P/010000000BaH;04/F2`1;5P/3000000P0@Ebb
00D0e3dI045L/P11G;80@Ebb0=@m6@04045L/P0300000011G;80@Ebb00@0@Ebb00D0e3dI045L/P11
G;80@Ebb00000004045L/P030=@m6@11G;80@Ebb00<0@Ebb00D00000045L/P11G;80@Ebb0=@m6@06
045L/P0300000011G;80@Ebb00P0@Ebb00D00000045L/P11G;80e3dI045L/P030=@m6@03045L/P00
0000000000D000001@0nEjP010000000?UNX03iGZ03D?AT803iGZ0030000000nEjP0?UNX00P0?UNX
00<0e3dI03iGZ00nEjP0200nEjP00`000000?UNX03iGZ00403iGZ0050=@m6@0nEjP0?UNX03iGZ000
00002P0nEjP0103D?AT0000003iGZ00nEjP3000000<0e3dI00D0>e6L0000003D?AT0e3dI0?ofkP02
0=@m6@@0ooK^0P0mFJ/20?ofkPD000002`3om^h01@0mFJ/0ooK^03eIZ`3om^h0000000h0ooK^1P0m
FJ/A0?ofkP0303eIZ`3om^h0ooK^03T0ooK^00<000000?ofkP3om^h04@3om^h10?ooo`00F03om^h0
0`000000ooK^000000050?ofkP0303eIZ`3om^h0?EV[0100ooK^1P0mFJ/30?ofkP0303eIZ`3om^h0
ooK^00/0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0
ooK^00d0ooK^00<0?EV[0?ofkP0000000P00000202L;1@80000000D0>A080000000i40P0>A080000
000304/F2`050000001;5P/0BaH;04/F2`0000000P14H;X600000003045L/P3D?AT0000000<0@Ebb
00<0e3dI045L/P11G;800`11G;800`000000@Ebb045L/P03045L/P050=@m6@11G;80@Ebb045L/P00
00001@11G;800`3D?AT0@Ebb045L/P02045L/P0500000011G;80@Ebb045L/P3D?AT01P11G;800`00
0000@Ebb045L/P08045L/P0300000011G;80e3dI00D0@Ebb0`3D?AT00`000000@Ebb045L/P02045L
/PP0000000<0e3dI03iGZ00nEjP01@0nEjP00`000000?UNX03iGZ00803iGZ0030=@m6@000000?UNX
00T0?UNX00<0000003iGZ00nEjP0100nEjP01@3D?AT0?UNX03iGZ00nEjP0000000T0?UNX00<0e3dI
0000000nEjP00`0nEjP20=@m6@80?UNX00<0e3dI000000000000103D?AT50?ofkP80?EV[1`3om^h6
000000D0ooK^00@0?EV[0?ofkP0mFJ/000004P3om^h00`0mFJ/0ooK^0?ofkP0503eIZ``0ooK^00<0
?EV[0?ofkP3om^h0>P3om^h00`000000ooK^0?ofkP0@0?ofkP40oooo001H0?ofkP030000003om^h0
000000D0ooK^00<0?EV[0?ofkP0mFJ/04P3om^h0100mFJ/0ooK^0?ofkP3om^h603eIZ`X0ooK^00<0
?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0
?EV[0?ofkP0000000P00000202L;1@080000000i40P0>A080000000i40P0000004/F2`00000204/F
2`060000001;5P/0BaH;0000001^8A0000001`14H;X00`000000e3dI0000000200000080@Ebb00<0
e3dI045L/P11G;800P11G;800`000000@Ebb045L/P02045L/P030=@m6@11G;80@Ebb00<0@Ebb00<0
0000045L/P11G;800`11G;820=@m6@80@Ebb00@00000045L/P11G;80e3dI1`11G;800`000000@Ebb
045L/P08045L/P0300000011G;80e3dI00P0@Ebb103D?AT6045L/P0300000011G;80e3dI00H00000
0P0nEjP00`000000?UNX03iGZ00803iGZ0030=@m6@000000?UNX00T0?UNX00<0000003iGZ00nEjP0
0`0nEjP00`3D?AT0?UNX03iGZ00203iGZ0030000000nEjP0?UNX00L0?UNX00@0e3dI0000000nEjP0
?UNX0P3D?AT303iGZ0050=@m6@0nEjP0?UNX0=@m6@0mFJ/00`3D?AT50?ofkP80?EV[3@3om^h60000
00030?ofkP0mFJ/000000180ooK^00<0?EV[0?ofkP3om^h01@3om^h603eIZ`H0ooK^00<0?EV[0?of
kP3om^h0>P3om^h00`000000ooK^0?ofkP0@0?ofkP40oooo001H0?ofkP030000003om^h0000000D0
ooK^100mFJ/A0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h01P0mFJ/40?ofkP03
03eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP03
03eIZ`0000005@H2008000000P0W2`D020000000>A0803T@20000000>A080000001;5P/000000`1;
5P/01@000000BaH;0000001^8A00000000P0A62j00@0e3dI00000014H;X0A62j0`0000001@3D?AT0
0000045L/P11G;80000000@0@Ebb00<0e3dI045L/P11G;800`11G;800`000000@Ebb045L/P05045L
/P030=@m6@11G;8000000080@Ebb00<0e3dI045L/P11G;801@11G;800`000000@Ebb045L/P08045L
/P030000003D?AT0@Ebb00L0@Ebb00<00000045L/P11G;800P11G;830=@m6@<0@Ebb00<00000045L
/P3D?AT01P11G;85000000L0?UNX00<0e3dI0000000nEjP02P0nEjP00`000000?UNX03iGZ00303iG
Z0050=@m6@0nEjP0?UNX03iGZ00000002@0nEjP00`3D?AT0?UNX000000020=@m6@D0?UNX00<0e3dI
03iGZ0000000103D?AT303eIZ`80ooK^00<0?EV[0?ofkP0mFJ/04@3om^h00`0mFJ/0ooK^00000005
000000l0ooK^00<0?EV[0?ofkP3om^h02`3om^h503eIZ`80ooK^00<0?EV[0?ofkP3om^h0>@3om^h0
0`000000ooK^0?ofkP0@0?ofkP40oooo001H0?ofkP030000003om^h0000000D0ooK^00@0?EV[0?of
kP0mFJ/0ooK^1P0mFJ/:0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h01P3om^h6
03eIZ`T0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`000000
0000008000000P0W2`D020000000>A0803T@20000000>A080000001;5P/000000`1;5P/01@000000
BaH;0000001^8A00000000L0A62j00@0e3dI04AP^P14H;X000001@14H;X00`3D?AT0000000000004
000000030=@m6@000000@Ebb00@0@Ebb00<00000045L/P11G;801P11G;801@3D?AT00000045L/P11
G;80e3dI00L0@Ebb00<00000045L/P11G;801`11G;800`000000@Ebb0=@m6@08045L/P0300000011
G;80@Ebb00D0@Ebb0`3D?AT00`000000e3dI045L/P08045L/P0300000011G;80@Ebb00H0000000<0
?UNX0=@m6@0000002P0nEjP00`000000?UNX03iGZ00303iGZ0030=@m6@0nEjP0?UNX0080?UNX00<0
000003iGZ00nEjP01`0nEjP30=@m6@H0?UNX00D0e3dI03iGZ00nEjP0e3dI0?ofkP030=@m6@<0ooK^
1@0mFJ/@0?ofkP0503eIZ`3om^h0ooK^0000000mFJ/0103om^h5000000/0ooK^00<0?EV[0?ofkP3o
m^h03`3om^h303eIZc/0ooK^00<000000?ofkP3om^h0403om^h10?ooo`00F03om^h2000000H0ooK^
00<0?EV[0?ofkP0mFJ/01`3om^h703eIZ`<0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^
0?ofkP0;0?ofkP0303eIZ`3om^h0?EV[00D0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eI
Z`3om^h0ooK^00h0ooK^00H0?EV[0000000000009`/50000000W2`D2000000<0>A080P00000204/F
2`060000001;5P/0BaH;0000001;5P/000000P1^8A000`000000A62j04AP^P0404AP^P040=@m6@14
H;X0A62j000000H0A62j00<0e3dI04AP^P0000000`14H;X00`3D?AT0A62j00000007000000L0@Ebb
0`3D?AT8045L/P0300000011G;80@Ebb00L0@Ebb00<000000=@m6@11G;802011G;800`000000@Ebb
045L/P08045L/P@0e3dI1`11G;800`000000@Ebb045L/P06045L/P030=@m6@000000000000800000
200nEjP00`000000?UNX03iGZ00303iGZ0030=@m6@0nEjP0?UNX0080?UNX00<0000003iGZ00nEjP0
100nEjP40=@m6@030000000nEjP0?UNX00D0?UNX00<0e3dI03iGZ00nEjP00P0mFJ/20=@m6@H0ooK^
00<0?EV[0?ofkP0mFJ/01P0mFJ/:0?ofkP0603eIZ`3om^h0ooK^0000003om^h0?EV[203om^h60000
00D0ooK^00<0?EV[0?ofkP3om^h04@3om^h00`0mFJ/0ooK^0?ofkP0i0?ofkP030000003om^h0ooK^
0100ooK^0@3oool005P0ooK^0P0000050?ofkP0403eIZ`3om^h0ooK^03eIZ`h0ooK^1`0mFJ/30?of
kP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h01@3om^h703eIZ`D0ooK^00<0?EV[0?of
kP3om^h03@3om^h02P0mFJ/000000000000000009`/50000000W2`D0000003T@2000000203T@2005
0000001;5P/0BaH;04/F2`0000000`1;5P/01@000000KR4@06hQ401^8A00000000D0A62j00D0e3dI
04AP^P14H;X0A62j0000000704AP^P030=@m6@000000A62j0080A62j00<0e3dI04AP^P14H;X01014
H;X00`000000A62j04AP^P0500000080@Ebb00<00000045L/P3D?AT02011G;800`000000@Ebb045L
/P07045L/P030000003D?AT0@Ebb00P0@Ebb00<00000045L/P11G;802011G;80103D?AT0@Ebb045L
/P11G;860=@m6@03045L/P000000@Ebb00L0@Ebb00<0e3dI045L/P0000000P11G;8600000080?UNX
00<0000003iGZ00nEjP00P0nEjP00`3D?AT0?UNX03iGZ00303iGZ0030000000nEjP0e3dI00@0e3dI
00D0?UNX0=@m6@0nEjP0?UNX0000000603iGZ0050=@m6@0nEjP0?UNX03iGZ00000000`3D?AT603eI
Z`80ooK^00<0?EV[0?ofkP3om^h0103om^h603eIZ`<0ooK^00@0?EV[0?ofkP3om^h000000P3om^h0
0`0mFJ/0ooK^0?ofkP0<0?ofkPH000004`3om^h00`0mFJ/0ooK^0?ofkP0j0?ofkP030000003om^h0
ooK^00l0ooK^0@3oool005L0ooK^00<000000?ofkP0000001@3om^h00`0mFJ/0ooK^03eIZ`0B0?of
kP0403eIZ`3om^h0ooK^0?ofkPH0?EV[2P3om^h00`0mFJ/0ooK^0?ofkP090?ofkP0403eIZ`3om^h0
ooK^0?ofkPH0?EV[3`3om^h01@0mFJ/000000000000000009`/5008000000P0i40P010000000>A08
03T@2000000304/F2`050000001;5P/0BaH;04/F2`0000000`1^8A000`000000A62j04AP^P0304AP
^P050=@m6@14H;X0A62j04AP^P0000001`14H;X01@3D?AT0A62j00000014H;X0e3dI00L0A62j00<0
000004AP^P14H;X01@14H;X4000000<0e3dI1P11G;800`000000@Ebb045L/P07045L/P030=@m6@11
G;80@Ebb00P0@Ebb00<00000045L/P11G;802011G;800`3D?AT0@Ebb045L/P07045L/PH0e3dI0`11
G;800`3D?AT0@Ebb00000009045L/PD000000P0nEjP00`3D?AT0?UNX0=@m6@050=@m6@H0?UNX00@0
e3dI03iGZ00nEjP000001P0nEjP0103D?AT0?UNX03iGZ00000030=@m6@H0ooK^1P0mFJ/:0?ofkP@0
?EV[00<0ooK^0000003om^h00P3om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP0303eIZ`000000000000@0
00003@3om^h00`0mFJ/0ooK^0?ofkP0j0?ofkP030000003om^h0ooK^00l0ooK^0@3oool005L0ooK^
00<000000?ofkP0000001@3om^h00`0mFJ/0ooK^03eIZ`0B0?ofkP0303eIZ`3om^h0ooK^00@0ooK^
00<0?EV[0?ofkP3om^h01`0mFJ/30?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h0
1P3om^h703eIZ`T0ooK^00D0?EV[0=@m6@000000000002L;1@0200000080>A0800@0000003T@200i
40P000000`1;5P/01@000000BaH;04/F2`1;5P/0000000<0KR4@00<0?EV[0000003D?AT00`14H;X0
0`3D?AT0A62j04AP^P0204AP^P0300000014H;X0A62j00D0A62j00@0e3dI00000014H;X0e3dI1`14
H;X00`000000A62j04AP^P0704AP^P030000003D?AT0A62j008000000P3D?AT200000080@Ebb00<0
0000045L/P11G;801`11G;800`3D?AT0@Ebb045L/P08045L/P0300000011G;80@Ebb00L0@Ebb00<0
e3dI045L/P11G;802011G;800`000000@Ebb045L/P03045L/QP0e3dI00@0000003iGZ00nEjP00000
1`0nEjP01@3D?AT0?UNX03iGZ00nEjP0000000D0?UNX00@0e3dI03iGZ00nEjP0?UNX103D?AT60?of
kP0403eIZ`3om^h0ooK^03eIZ`80ooK^1P0mFJ/70?ofkP0303eIZ`3om^h0000000<0ooK^00<0?EV[
0?ofkP3om^h04@3om^h00`0mFJ/0ooK^0?ofkP040?ofkPD000002@3om^h00`0mFJ/0ooK^0?ofkP0i
0?ofkP030000003om^h0ooK^00l0ooK^0@3oool005L0ooK^00<000000?ofkP0000001@3om^h00`0m
FJ/0ooK^03eIZ`0B0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h01`3om^h703eI
Z`P0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP040?ofkPH0?EV[0`3om^h01P0m
FJ/000000000000000009`/5000000<0>A0800@0000003T@200000000000101;5P/01@000000BaH;
0000001^8A0000000080KR4@00<0?EV[0000003D?AT00P14H;X00`3D?AT0A62j04AP^P0304AP^P03
00000014H;X0A62j00H0A62j0P3D?AT904AP^P0300000014H;X0A62j00H0A62j00<000000=@m6@14
H;X01014H;X20=@m6@L000001@11G;800`3D?AT0@Ebb045L/P07045L/P0300000011G;80@Ebb00P0
@Ebb00<0e3dI045L/P11G;802011G;800`000000@Ebb045L/P05045L/P040=@m6@11G;80@Ebb0000
00X0@Ebb00D00000045L/P11G;80@Ebb0=@m6@04045L/PP000000P0nEjP0103D?AT0?UNX03iGZ000
000603iGZ0050=@m6@0nEjP0?UNX0=@m6@0000000P3D?AT60?ofkP0503eIZ`3om^h0ooK^0?ofkP0m
FJ/0203om^h503eIZ`040?ofkP0mFJ/0ooK^000000@0ooK^00<0?EV[0?ofkP3om^h04@3om^h00`0m
FJ/0ooK^0?ofkP090?ofkPH000000`3om^h00`0mFJ/0ooK^0?ofkP0i0?ofkP030000003om^h0ooK^
00l0ooK^0@3oool005L0ooK^00<000000?ofkP000000103om^h0100mFJ/0ooK^0?ofkP0mFJ/A0?of
kP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h02P3om^h0100mFJ/0ooK^0?ofkP3om^h6
03eIZ`80ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkPH0?EV[00<00000
02L;1@0000000`0i40P01@000000>A080000001;5P/0000000<0BaH;00D0000004/F2`000000KR4@
0000000206hQ400603eIZ`1^8A0000000=@m6@14H;X0e3dI1@14H;X00`000000A62j04AP^P0604AP
^P030000003D?AT0A62j00P0A62j00<0000004AP^P14H;X01P14H;X00`3D?AT0A62j04AP^P0604AP
^P030=@m6@14H;X0000000@0A62j10000000103D?AT00000000000000007045L/P0300000011G;80
@Ebb00L0@Ebb00<0e3dI00000011G;802@11G;800`000000@Ebb045L/P05045L/P040=@m6@11G;80
@Ebb000000X0@Ebb00D00000045L/P11G;80@Ebb0=@m6@06045L/P0300000011G;80@Ebb00<0@Ebb
00<000000=@m6@0000001@00000303iGZ0050=@m6@0nEjP0e3dI0=@m6@0nEjP00P3D?AT70?ofkP05
03eIZ`3om^h0ooK^0?ofkP0mFJ/03@3om^h603eIZ`80ooK^00<0?EV[0?ofkP3om^h04@3om^h00`0m
FJ/0ooK^0?ofkP0?0?ofkPH00000>P3om^h00`000000ooK^0?ofkP0>0?ofkP40oooo001G0?ofkP80
00001@3om^h0100mFJ/0ooK^0?ofkP0mFJ/A0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?of
kP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP070?ofkPL0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP0>0?of
kP0303eIZ`000000000000H0?EV[00D0000003T@20000000BaH;0000000304/F2`030000001;5P/0
00000080KR4@00D0000006hQ400mFJ/0KR4@000000020=@m6@L0A62j00<0000004AP^P14H;X01P14
H;X30=@m6@L0A62j00<0000004AP^P14H;X01P14H;X00`3D?AT0A62j04AP^P0704AP^P80e3dI2014
H;X0103D?AT0000004AP^P14H;X500000080@Ebb00<00000045L/P11G;801`11G;800`3D?AT00000
045L/P09045L/P0300000011G;80@Ebb00@0@Ebb00@0e3dI045L/P11G;8000002`11G;8010000000
@Ebb045L/P3D?AT6045L/P0300000011G;80@Ebb00@0@Ebb00<0e3dI045L/P11G;800P11G;800`00
0000@Ebb045L/P0300000080e3dI0P0nEjP00`000000e3dI0=@m6@070?ofkP0503eIZ`3om^h0ooK^
0?ofkP0mFJ/03P3om^h00`0mFJ/000000?ofkP020?ofkPH0?EV[4@3om^h00`0mFJ/0ooK^0?ofkP0A
0?ofkP0303eIZ`3om^h0ooK^00H00000=03om^h00`000000ooK^0?ofkP0>0?ofkP40oooo001G0?of
kP8000001@3om^h0100mFJ/0ooK^0?ofkP0mFJ/A0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[
0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00<0ooK^1P0mFJ/>
0?ofkP0303eIZ`0000009`/500<000000`0i40P603eIZ`<0BaH;00/0000006hQ401^8A00KR4@0000
001^8A00?EV[06hQ40000000A62j0=@m6@0704AP^P0300000014H;X0A62j00D0A62j00D0e3dI0000
0014H;X0A62j0=@m6@0604AP^P0300000014H;X0A62j00H0A62j00<0e3dI04AP^P14H;X02014H;X0
0`000000e3dI0=@m6@0504AP^P030=@m6@14H;X0000000L0A62j1@000006045L/P030=@m6@11G;80
000000X0@Ebb00<00000045L/P11G;801011G;80103D?AT0@Ebb045L/P00000:045L/P0500000011
G;80@Ebb045L/P3D?AT01P11G;800`000000@Ebb045L/P04045L/P050=@m6@11G;80@Ebb045L/P00
00001@11G;820=@m6@03045L/P00000000000080e3dI1`3om^h00`0mFJ/0ooK^0?ofkP020?ofkP03
03eIZ`3om^h0ooK^00/0ooK^00<0?EV[0000003om^h01@3om^h0100mFJ/0ooK^0?ofkP3om^h703eI
Z`X0ooK^00<0?EV[0?ofkP3om^h04@3om^h00`0mFJ/0ooK^0?ofkP060?ofkPH00000;P3om^h00`00
0000ooK^0?ofkP0>0?ofkP40oooo001F0?ofkP030000003om^h0000000D0ooK^00<0?EV[0?ofkP0m
FJ/04P3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3o
m^h02@3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00D0?EV[203om^h0100mFJ/0
00000000000W2`D20000000303T@20000000>A080080>A0800D0000004/F2`1;5P/0000004/F2`06
03eIZ`0406hQ40000000KR4@03eIZ`80KR4@00<000000=@m6@3D?AT01P14H;X00`000000A62j04AP
^P0504AP^P030=@m6@000000A62j0080A62j00<0e3dI04AP^P14H;X00`14H;X00`000000A62j04AP
^P0504AP^P030=@m6@000000A62j00H0A62j00@0?EV[04AP^P14H;X000000P14H;X20=@m6@<0A62j
00<0e3dI04AP^P0000002@14H;X00`000000A62j04AP^P06000000030=@m6@11G;80000000T0@Ebb
00<00000045L/P11G;801011G;801@3D?AT0@Ebb045L/P11G;80000000X0@Ebb00@00000045L/P11
G;80e3dI1`11G;800`000000@Ebb045L/P03045L/P030=@m6@11G;80@Ebb0080@Ebb00<00000045L
/P11G;800`11G;80103D?AT0@Ebb045L/P11G;830=@m6@L0ooK^00<0?EV[0?ofkP3om^h00P3om^h0
0`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`000000ooK^00D0ooK^00<0?EV[0?ofkP3om^h0203om^h7
03eIZ`<0ooK^00<0?EV[0?ofkP3om^h04@3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkPD00000:@3om^h0
0`000000ooK^0?ofkP0>0?ofkP40oooo001F0?ofkP030000003om^h0000000D0ooK^00<0?EV[0?of
kP0mFJ/04P3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?of
kP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00D0ooK^1@0mFJ/30?of
kP0403eIZ`000000000002L;1@80000000<0>A080000000i40P00P0i40P01@000000BaH;04/F2`1;
5P/000000080BaH;0P00000206hQ40L0?EV[00<0e3dI0000003D?AT01@14H;X00`000000A62j04AP
^P0504AP^P030=@m6@000000A62j00<0A62j0P3D?AT304AP^P0300000014H;X0A62j00D0A62j00<0
e3dI00000014H;X02@14H;X00`000000A62j04AP^P0204AP^P<0e3dI0P14H;X00`000000A62j04AP
^P0704AP^P0300000014H;X0A62j00D0A62j00<0e3dI0000000000000`000007045L/P0300000011
G;80@Ebb00@0@Ebb00D0e3dI045L/P11G;80@Ebb0000000:045L/P0400000011G;80@Ebb0=@m6@H0
@Ebb00<00000045L/P11G;801011G;801@3D?AT0@Ebb045L/P11G;80000000@0@Ebb0P3D?AT4045L
/P80e3dI203om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?of
kP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkPH0?EV[4@3om^h00`0mFJ/0ooK^0?ofkP0A0?of
kPH000008`3om^h00`000000ooK^0?ofkP0>0?ofkP40oooo001F0?ofkP030000003om^h0000000@0
ooK^00@0?EV[0?ofkP3om^h0?EV[4P3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^
00X0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^
00X0ooK^100mFJ/20000000502L;1@000000>A0803T@200000000P0i40P2000000<0BaH;00H00000
04/F2`1;5P/0000006hQ4000000306hQ40050000000mFJ/0KR4@06hQ400000000P15I<800`000000
e3dI0000000200000080A62j00<0000004AP^P14H;X00`14H;X0103D?AT0A62j04AP^P00000504AP
^P040=@m6@14H;X0A62j000000H0A62j00@0e3dI04AP^P14H;X000002@14H;X00`000000A62j04AP
^P0404AP^P80e3dI00<0A62j00000014H;X02014H;X00`000000A62j04AP^P0504AP^P040=@m6@14
H;X0A62j00000080A62j1@000002045L/P0300000011G;80@Ebb00<0@Ebb00D0e3dI045L/P11G;80
@Ebb0000000:045L/P0400000011G;80@Ebb0=@m6@L0@Ebb00<00000045L/P11G;800`11G;800`3D
?AT0@Ebb045L/P02045L/P0300000011G;80@Ebb00<0e3dI1011G;820=@m6@D0?EV[0`3om^h00`0m
FJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0m
FJ/0ooK^0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^00D0?EV[3@3om^h00`0mFJ/0ooK^0?ofkP0F0?of
kPH000007P3om^h00`000000ooK^0?ofkP0=0?ofkP40oooo001F0?ofkP030000003om^h0000000@0
ooK^00<0?EV[0?ofkP3om^h0100mFJ/?0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3o
m^h02P3om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3o
m^h03P3om^h01@0mFJ/000000000000W2`D000000080>A0800H0000003T@200i40P0000004/F2`00
000204/F2`030000001;5P/000000080KR4@00X0000006hQ401^8A00KR4@0000000mFJ/0KR4@0000
002@:a<000000`15I<800`3D?AT0AFC204ET`P070000000504AP^P3D?AT0A62j04AP^P0000001P14
H;X0103D?AT0A62j04AP^P00000504AP^P040=@m6@14H;X0A62j000000T0A62j00<0000004AP^P14
H;X01014H;X00`3D?AT0A62j0=@m6@020=@m6@P0A62j00<0000004AP^P14H;X01014H;X01@3D?AT0
A62j04AP^P14H;X0000000L0A62j1`0000000`11G;80e3dI045L/P02045L/P0300000011G;80@Ebb
00P0@Ebb00@00000045L/P11G;80e3dI1P11G;800`000000@Ebb045L/P03045L/P030=@m6@11G;80
@Ebb0080@Ebb00@00000045L/P3D?AT0e3dI0P11G;800`3D?AT0@Ebb045L/P02045L/P80e3dI1@3o
m^h603eIZ`<0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3o
m^h0ooK^0180ooK^00<0?EV[0?ofkP3om^h01@3om^h603eIZ`L0ooK^00<0?EV[0?ofkP3om^h0703o
m^h6000001P0ooK^00<000000?ofkP3om^h03@3om^h10?ooo`00EP3om^h2000000D0ooK^100mFJ/3
0?ofkPH0?EV[2@3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[
0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00h0ooK^00D0?EV[
0000000000009`/50000000203T@20030000000i40P000000080BaH;00H0000004/F2`1;5P/00000
04/F2`00000306hQ40090000001^8A00KR4@03eIZ`000000KR4@0000002@:a<0000000@0AFC200D0
e3dI04ET`P15I<80AFC20000000404ET`P030=@m6@000000000000@000001@14H;X20=@m6@030000
0014H;X0A62j00<0A62j00@0e3dI04AP^P14H;X000002@14H;X00`000000A62j04AP^P0304AP^P04
0=@m6@14H;X0A62j00000080A62j0`3D?AT504AP^P0300000014H;X0A62j00@0A62j00@0e3dI04AP
^P14H;X000002P14H;X00`000000A62j04AP^P0204AP^P030=@m6@000000000000D000002011G;80
0`000000@Ebb0=@m6@07045L/P0300000011G;80@Ebb00<0@Ebb00@0e3dI045L/P11G;80@Ebb0`3D
?AT3045L/P030=@m6@11G;80@Ebb0080@Ebb0P3D?AT90?ofkP0303eIZ`3om^h0ooK^00H0?EV[2@3o
m^h00`000000?EV[0?ofkP070?ofkP0303eIZ`3om^h0ooK^0180ooK^00<0?EV[0?ofkP3om^h02`3o
m^h503eIZ`80ooK^00<0?EV[0?ofkP3om^h08P3om^h5000001<0ooK^00<000000?ofkP3om^h03@3o
m^h10?ooo`00EP3om^h2000000D0ooK^00<0?EV[0?ofkP3om^h01@0mFJ/50?ofkPH0?EV[0P3om^h0
0`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h02@3om^h0
0`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0e3dI03eIZ`0W2`D00`000003
03T@208000000P1;5P/01@000000BaH;04/F2`1;5P/0000000@0KR4@00L0000006hQ401^8A00?EV[
0000001^8A0000000080T2/C00<0000004ET`P15I<800P15I<801@3D?AT0AFC204ET`P15I<800000
00<0AFC200D0e3dI04ET`P15I<80AFC20000000204ET`PD000000P14H;X00`3D?AT0A62j04AP^P02
04AP^P050=@m6@14H;X0A62j04AP^P0000002@14H;X00`000000A62j04AP^P0304AP^P040=@m6@14
H;X0A62j000000D0A62j0`3D?AT204AP^P0300000014H;X0A62j00<0A62j00D0e3dI04AP^P14H;X0
A62j0000000904AP^P0300000014H;X0A62j00<0A62j00<0e3dI04AP^P14H;X00P14H;X00`000000
A62j04AP^P0500000080@Ebb00@00000045L/P11G;80e3dI1`11G;800`000000@Ebb045L/P02045L
/P030=@m6@11G;80@Ebb0080e3dI00<0@Ebb00000011G;800P11G;800`3D?AT0@Ebb045L/P03045L
/P80e3dI203om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00H0?EV[0P3om^h00`00
0000?EV[0?ofkP080?ofkP0303eIZ`3om^h0ooK^0180ooK^00<0?EV[0?ofkP3om^h0403om^h303eI
ZbT0ooK^1P00000=0?ofkP030000003om^h0ooK^00d0ooK^0@3oool005D0ooK^00<000000?ofkP00
00001@3om^h00`0mFJ/0ooK^03eIZ`050?ofkPH0?EV[1@3om^h603eIZ`<0ooK^00<0?EV[0?ofkP3o
m^h02`3om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3o
m^h03@3om^h00`0mFJ/0000002L;1@020000000503T@20000000>A0803T@200000000`1;5P/01@00
0000BaH;04/F2`1;5P/0000000@0KR4@00H0000006hQ401^8A00?EV[06hQ40000003090[4`030000
0015I<80AFC200<0AFC200@0e3dI04ET`P15I<8000000`15I<800`3D?AT0AFC204ET`P0204ET`P03
00000015I<80AFC200@0AFC20`0000001@3D?AT0000004AP^P14H;X0e3dI00<0A62j00<0000004AP
^P14H;X01`14H;X00`000000A62j04AP^P0204AP^P050=@m6@14H;X0A62j04AP^P0000002014H;X3
0=@m6@D0A62j00D0e3dI04AP^P14H;X0A62j0000000904AP^P0300000014H;X0A62j0080A62j00<0
e3dI04AP^P14H;X00P14H;X00`000000A62j04AP^P0604AP^P@0000000<0e3dI0000000000001@11
G;800`000000@Ebb045L/P03045L/P<0e3dI0P11G;800`000000@Ebb045L/P02045L/P030=@m6@11
G;80@Ebb0080@Ebb0P3D?AT90?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h01P3o
m^h403eIZ`P0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP0303eIZ`3o
m^h0ooK^02d0ooK^1P0000080?ofkP030000003om^h0ooK^00`0ooK^0@3oool005D0ooK^00<00000
0?ofkP0000001@3om^h00`0mFJ/0ooK^03eIZ`0;0?ofkPD0?EV[0P3om^h0100mFJ/0ooK^0?ofkP3o
m^h703eIZ`X0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3o
m^h0ooK^00d0ooK^00<0?EV[0000000W2`D00P0000001@0i40P0000003T@200i40P0000000@0BaH;
00@0000004/F2`1;5P/000001@1^8A001@000000KR4@03eIZ`1^8A00000000<0T2/C00<0000004ET
`P15I<801015I<800`3D?AT0AFC20000000204ET`P030=@m6@15I<80AFC200<0AFC200<0000004ET
`P15I<801P15I<800`000000AFC20=@m6@020=@m6@8000000P14H;X00`000000A62j04AP^P0704AP
^P0300000014H;X0A62j0080A62j00D0e3dI04AP^P14H;X0A62j0000000904AP^P0300000014H;X0
e3dI0080e3dI00<0A62j0=@m6@14H;X00`14H;X00`000000A62j04AP^P0704AP^P0300000014H;X0
A62j0080A62j00<0e3dI04AP^P14H;X00P14H;X00`000000A62j04AP^P0804AP^P0300000014H;X0
e3dI0080A62j200000040=@m6@@0@Ebb00D00000045L/P11G;80@Ebb0=@m6@04045L/P80e3dI0`0m
FJ/70?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`000000ooK^03eI
Z`080?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h04P3om^h00`0mFJ/0ooK^0?of
kP0c0?ofkPH000000P3om^h00`000000ooK^0?ofkP0<0?ofkP40oooo001E0?ofkP030000003om^h0
000000@0ooK^00@0?EV[0?ofkP3om^h0?EV[403om^h603eIZ`<0ooK^00@0?EV[0?ofkP3om^h0ooK^
1P0mFJ/30?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^
0?ofkP0<0?ofkP040=@m6@0mFJ/0000002L;1@80000000D0>A080000000i40P0>A080000000404/F
2`050000001;5P/0000006hQ40000000101^8A001@000000KR4@03eIZ`1^8A00000000@0T2/C00<0
000004ET`P15I<801015I<801@3D?AT0AFC200000015I<80e3dI00D0AFC200<0000004ET`P15I<80
1P15I<801@000000AFC204ET`P15I<80e3dI0080AFC21`00000504AP^P0500000014H;X0A62j04AP
^P3D?AT01014H;X00`000000A62j04AP^P0704AP^P0300000014H;X0A62j0080A62j103D?AT00`14
H;X0000004AP^P0804AP^P0300000014H;X0A62j0080A62j00<0e3dI04AP^P14H;X00P14H;X00`00
0000A62j04AP^P0804AP^P0300000014H;X0e3dI00H0A62j1@3D?AT00`000000e3dI000000020000
0080@Ebb00D00000045L/P11G;80@Ebb0=@m6@03045L/P<0e3dI00@000000?ofkP3om^h0ooK^1`0m
FJ/70?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<000000?ofkP0mFJ/02@3om^h00`0mFJ/0ooK^0?of
kP0C0?ofkP0303eIZ`3om^h0ooK^0180ooK^00<0?EV[0?ofkP3om^h0>@3om^h3000000h0ooK^0@3o
ool005D0ooK^00<000000?ofkP000000103om^h0100mFJ/0ooK^0?ofkP0mFJ/B0?ofkP0403eIZ`3o
m^h0ooK^0?ofkPH0?EV[1`3om^h603eIZ`T0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^
0?ofkP0<0?ofkP050=@m6@0mFJ/0000002L;1@0000000P0i40P01@000000>A080000001;5P/00000
00<0BaH;00D0000004/F2`000000KR4@0000000406hQ40060000001^8A00?EV[0000002@:a<00000
0`2@:a<00`000000AFC204ET`P0504ET`P040=@m6@000000AFC20=@m6@D0AFC200<0000004ET`P15
I<801P15I<8010000000AFC204ET`P15I<830=@m6@80AFC200<0000004ET`P15I<800P15I<880000
000304AP^P3D?AT0A62j00<0A62j00<0000004AP^P14H;X01`14H;X00`000000A62j04AP^P0204AP
^P040=@m6@14H;X0A62j04AP^PH0e3dI1@14H;X00`000000A62j04AP^P0204AP^P030=@m6@14H;X0
A62j0080A62j00<0000004AP^P14H;X02014H;X010000000A62j0=@m6@14H;X50=@m6@0304AP^P00
0000A62j00<0A62j00@0e3dI04AP^P14H;X0A62j1@0000002@11G;80e3dI045L/P11G;80e3dI045L
/P3D?AT0@Ebb000000090?ofkPH0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP060?ofkP030000003om^h0
?EV[00T0ooK^00<0?EV[0?ofkP3om^h04P3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0
ooK^03X0ooK^00<000000?ofkP3om^h03@3om^h10?ooo`00E@3om^h2000000D0ooK^00@0?EV[0?of
kP3om^h0?EV[4P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0403eIZ`3om^h0ooK^0?ofkPL0?EV[0`3o
m^h00`0mFJ/0ooK^0?ofkP0603eIZ`<0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?of
kP0<0?ofkP050000000mFJ/0000002L;1@0000000P0i40P01@000000>A080000001;5P/0000000<0
BaH;00<0000004/F2`0000000P1^8A000`000000KR4@06hQ400206hQ400503eIZ`1^8A000000090[
4`000000102@:a<00`000000AFC204ET`P0504ET`P80e3dI1`15I<800`000000AFC204ET`P0604ET
`P0300000015I<80e3dI00<0AFC20P3D?AT00`000000AFC204ET`P0704ET`P0500000015I<80AFC2
0000003D?AT00P00000204AP^P0300000014H;X0A62j00L0A62j00<0000004AP^P14H;X00P14H;X0
0`3D?AT0A62j04AP^P0204AP^P0300000014H;X0A62j0080A62j1P3D?AT304AP^P030=@m6@14H;X0
A62j00<0A62j00@0000004AP^P14H;X0A62j2`3D?AT604AP^P0500000014H;X0A62j04AP^P3D?AT0
1@14H;X01@000000A62j04AP^P14H;X0e3dI0080000000D0e3dI0000003D?AT0@Ebb0000000:0?of
kP0303eIZ`3om^h0ooK^00<0ooK^1P0mFJ/40?ofkP040000003om^h0ooK^03eIZ`T0ooK^00<0?EV[
0?ofkP3om^h04P3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^03T0ooK^00<00000
0?ofkP3om^h03P3om^h10?ooo`00E@3om^h2000000D0ooK^00@0?EV[0?ofkP3om^h0?EV[4P3om^h0
0`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00P0ooK^1`0mFJ/50?ofkPL0?EV[103om^h0
0`0mFJ/0ooK^0?ofkP0<0?ofkP80000000@0?EV[0000000W2`D000000P0i40P01@000000>A080000
001;5P/0000000@0BaH;00D0000006hQ401^8A00KR4@0000000406hQ400303eIZ`1^8A0000000080
T2/C00D00000090[4`2@:a<0T2/C0000000804ET`P030=@m6@15I<80AFC200D0AFC200<0000004ET
`P15I<801P15I<800`000000AFC20=@m6@0504ET`P80e3dI2015I<8010000000AFC204ET`P3D?AT3
04ET`PL000001@14H;X01@000000A62j04AP^P14H;X0e3dI00D0A62j00<0000004AP^P14H;X01P14
H;X00`000000A62j0=@m6@0<0=@m6@H0A62j00<000000=@m6@14H;X01`14H;X00`000000A62j04AP
^P0204AP^P030=@m6@14H;X0A62j00<0A62j00L0000004AP^P14H;X0A62j0=@m6@14H;X0e3dI0080
A62j00<0e3dI0000000000002P3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0403eIZ`3om^h0ooK^0?of
kPL0?EV[2P3om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?of
kP3om^h0>03om^h00`000000ooK^0?ofkP0?0?ofkP40oooo001D0?ofkP030000003om^h0000000D0
ooK^00<0?EV[0?ofkP0mFJ/04P3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00/0
ooK^00@0?EV[0?ofkP3om^h0ooK^1P0mFJ/20?ofkP0403eIZ`3om^h0ooK^0?ofkPP0?EV[2`3om^h0
0`000000?EV[02L;1@03000000<0>A080P00000204/F2`050000001;5P/0BaH;04/F2`000000101^
8A001P000000KR4@06hQ401^8A00?EV[000000<0T2/C00D00000090[4`2@:a<0T2/C0000000804ET
`P80e3dI1P15I<800`000000AFC204ET`P0604ET`P030000003D?AT0AFC200H0AFC200<000000=@m
6@3D?AT01P15I<8010000000AFC204ET`P3D?AT504ET`P0300000015I<80AFC20080AFC220000000
0`14H;X0e3dI04AP^P0304AP^P0300000014H;X0A62j00L0A62j00D0000004AP^P14H;X0A62j0=@m
6@0504AP^P0300000014H;X0A62j00L0A62j00<0000004AP^P3D?AT02014H;X01@000000A62j04AP
^P14H;X0e3dI00D0A62j00L0000004AP^P14H;X0A62j0=@m6@14H;X0e3dI0080A62j00<0e3dI04AP
^P0000002P3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<000000?of
kP3om^h0200mFJ/30?ofkP0303eIZ`3om^h0ooK^0180ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0m
FJ/0ooK^0?ofkP0h0?ofkP030000003om^h0ooK^00l0ooK^0@3oool005@0ooK^00<000000?ofkP00
00001@3om^h00`0mFJ/0ooK^03eIZ`0B0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3o
m^h02`3om^h00`0mFJ/0ooK^0?ofkP070?ofkPL0?EV[0`3om^h0100mFJ/0ooK^0?ofkP3om^h803eI
Z`<0ooK^00<0000003eIZ`0W2`D00P0000001@0i40P0000003T@200i40P0000000<0BaH;00D00000
04/F2`1;5P/0BaH;0000000406hQ40060000001^8A00KR4@06hQ400mFJ/00000102@:a<01@000000
T2/C090[4`2@:a<0000000H0AFC200<0e3dI04ET`P0000000P3D?AT404ET`P0300000015I<80AFC2
00H0AFC200<000000=@m6@15I<801P15I<800`000000AFC204ET`P020=@m6@@0AFC200<0000004ET
`P3D?AT01P15I<800`000000AFC204ET`P0704ET`P0400000015I<80AFC20=@m6@<000000P14H;X0
0`000000A62j04AP^P0704AP^P0500000014H;X0A62j04AP^P3D?AT01@14H;X00`000000A62j04AP
^P0704AP^P030000003D?AT0A62j00L0A62j00<0000004AP^P14H;X00P14H;X00`3D?AT0A62j04AP
^P0304AP^P0300000014H;X0A62j00<0e3dI0P14H;X0103D?AT0A62j04AP^P00000:0?ofkP0303eI
Z`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h00`3om^h01@000000ooK^0?ofkP3om^h0?EV[00L0
ooK^1P0mFJ/B0?ofkP0303eIZ`3om^h0ooK^0180ooK^00<0?EV[0?ofkP3om^h0>03om^h00`000000
ooK^0?ofkP0@0?ofkP40oooo001D0?ofkP030000003om^h0000000D0ooK^00<0?EV[0?ofkP0mFJ/0
4P3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h0
203om^h00`0mFJ/0ooK^0?ofkP030?ofkPL0?EV[203om^h703eIZ`030000000i40P000000080>A08
00<0000004/F2`1;5P/00P1;5P/01@000000BaH;0000001^8A00000000@0KR4@00D0000006hQ401^
8A00?EV[00000004090[4`050000002@:a<0T2/C090[4`0000001P15I<800`3D?AT0AFC200000002
04ET`P030=@m6@15I<80AFC20080AFC200<0000004ET`P15I<801@15I<800`3D?AT0AFC204ET`P06
04ET`P0300000015I<80AFC20080AFC20P3D?AT204ET`P0300000015I<80e3dI00H0AFC200<00000
04ET`P15I<801`15I<8010000000AFC204ET`P3D?AT304ET`PL000001014H;X01@000000A62j04AP
^P14H;X0e3dI00D0A62j00<0000004AP^P14H;X02014H;X00`000000e3dI04AP^P0704AP^P050000
0014H;X0A62j04AP^P3D?AT01@14H;X01@000000A62j04AP^P14H;X0e3dI00@0A62j00@0e3dI04AP
^P000000?EV[2P3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00<0ooK^00D00000
0?ofkP3om^h0ooK^03eIZ`0:0?ofkP0303eIZ`3om^h0ooK^00D0?EV[3@3om^h00`0mFJ/0ooK^0?of
kP0B0?ofkP0303eIZ`3om^h0ooK^03L0ooK^00<000000?ofkP3om^h04@3om^h10?ooo`00E03om^h4
000000<0ooK^00@0?EV[0?ofkP3om^h0?EV[4P3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3o
m^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0403eIZ`3o
m^h0ooK^0?ofkPP0?EV[0P3om^h20000000303eIZ`0W2`D0000000H0?EV[101;5P/01@000000BaH;
0000001^8A00000000@0KR4@00H0000006hQ401^8A00?EV[090[4`000003090[4`030000002@:a<0
T2/C0080T2/C00<0000004ET`P15I<800P15I<80103D?AT0AFC204ET`P00000304ET`P050=@m6@15
I<80AFC204ET`P0000001`15I<800`3D?AT0AFC204ET`P0604ET`P0300000015I<80AFC200@0AFC2
0P3D?AT00`000000e3dI04ET`P0604ET`P0300000015I<80AFC200H0AFC200@0000004ET`P15I<80
e3dI1P15I<800`000000AFC204ET`P0204ET`PL0000000<0A62j0=@m6@14H;X01014H;X00`000000
A62j04AP^P0704AP^P030000003D?AT0A62j00L0A62j00D0000004AP^P14H;X0A62j0=@m6@0504AP
^P0300000014H;X0A62j0080e3dI1014H;X00`3D?AT0A62j000000020?ofkPH0?EV[0`3om^h00`0m
FJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00<0ooK^00D000000?ofkP3om^h0ooK^03eIZ`0;
0?ofkP0303eIZ`3om^h0ooK^00D0ooK^1P0mFJ/70?ofkP0303eIZ`3om^h0ooK^0180ooK^00<0?EV[
0?ofkP3om^h0=P3om^h00`000000ooK^0?ofkP0B0?ofkP40oooo001D0?ofkP8000000P3om^h30000
000403eIZ`000000000003eIZa80ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP0;
0?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP09
0?ofkP80?EV[0P0000000`0mFJ/09`/50000000203T@20040000000i40P0000004/F2`H0?EV[00@0
000006hQ401^8A000000101^8A000`000000?EV[00000002090[4`050000002@:a<0T2/C090[4`00
00000`2@:a<5000000050=@m6@15I<80AFC204ET`P0000000`15I<80103D?AT0AFC204ET`P000007
04ET`P030=@m6@15I<80AFC200H0AFC200<0000004ET`P15I<801P15I<830=@m6@H0AFC200<00000
04ET`P15I<801P15I<8010000000AFC204ET`P3D?AT504ET`P0300000015I<80AFC200L0AFC200@0
000004ET`P15I<80e3dI0`00000204AP^P0300000014H;X0A62j00P0A62j00<000000=@m6@14H;X0
1`14H;X01@000000A62j04AP^P14H;X0e3dI00D0A62j00@000000=@m6@3D?AT0e3dI1@14H;X00`3D
?AT00000000000080?ofkPH0?EV[1P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP030000003om^h0ooK^
0080ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkPD0?EV[0P3om^h00`0m
FJ/0ooK^0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^03D0ooK^00<000000?ofkP3om^h04`3om^h10?oo
o`00E03om^h2000000D0ooK^00@0?EV[0?ofkP3om^h0?EV[1P00000<0?ofkP0303eIZ`3om^h0ooK^
00<0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^
00L0ooK^00<0?EV[0?ofkP3om^h02`3om^h01@000000?EV[0000000W2`D000000080>A0800D00000
03T@20000000BaH;0000000404/F2`030000000mFJ/0?EV[00@0?EV[0P1^8A000`000000?EV[090[
4`02090[4`050000002@:a<0T2/C090[4`0000000`2@:a<200000080AfO800<0e3dI000000000000
1000000304ET`P80e3dI00<0000004ET`P15I<801015I<800`3D?AT0AFC20000000704ET`P030000
0015I<80AFC200H0AFC200<000000=@m6@15I<800`3D?AT304ET`P0300000015I<80AFC200H0AFC2
00<0000004ET`P3D?AT01P15I<800`000000AFC204ET`P0604ET`P0500000015I<80AFC204ET`P3D
?AT00`15I<87000000D0A62j00<000000=@m6@14H;X01`14H;X01@000000A62j04AP^P14H;X0e3dI
00D0A62j0P3D?AT204AP^P030=@m6@14H;X0A62j0080A62j00<0e3dI03eIZ`000000303om^h00`0m
FJ/0ooK^0?ofkP0703eIZ`@0ooK^00<000000?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP090?of
kP0303eIZ`3om^h0ooK^0100ooK^1P0mFJ/A0?ofkP0303eIZ`3om^h0ooK^03@0ooK^00<000000?of
kP3om^h0503om^h10?ooo`00E03om^h2000000D0ooK^0`0mFJ/70?ofkPH000001P3om^h00`0mFJ/0
ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0
ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00X0ooK^0P000000100mFJ/0000000000000000303T@
208000000P1;5P/01@000000BaH;04/F2`1;5P/0000000@0KR4@00<0000006hQ400mFJ/01P0mFJ/0
0`2@:a<00000090[4`02090[4`050000002@:a<000000:`c5`0000000P17IlP00`3D?AT0AfO804MW
b00204MWb00300000017IlP0000000<0000000<0AFC20=@m6@0000001@15I<800`3D?AT0AFC20000
000804ET`P0300000015I<80AFC200D0AFC200<0e3dI04ET`P15I<800`15I<830=@m6@T0AFC200<0
000004ET`P3D?AT01P15I<800`000000AFC204ET`P0604ET`P0400000015I<80AFC20=@m6@H0AFC2
00<0000004ET`P15I<800P15I<86000000030=@m6@000000A62j00H0A62j00D0000004AP^P14H;X0
A62j0=@m6@0304AP^P80e3dI00@0000004AP^P14H;X0e3dI1014H;X20=@m6@0303eIZ`3om^h0ooK^
00/0ooK^00<0?EV[0?ofkP3om^h01P3om^h603eIZ`<0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0m
FJ/0ooK^0?ofkP0C0?ofkP0403eIZ`3om^h0ooK^0?ofkPL0?EV[2P3om^h00`0mFJ/0ooK^0?ofkP0d
0?ofkP030000003om^h0ooK^01@0ooK^0@3oool005<0ooK^00<000000?ofkP0000001@3om^h00`0m
FJ/0ooK^03eIZ`0503eIZ`P0ooK^1@0000000`0mFJ/000000?ofkP040?ofkP0303eIZ`3om^h0ooK^
00/0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^
00X0ooK^0P0000001@0mFJ/000000000000i40P000000080>A0800D0000004/F2`1;5P/0BaH;0000
000304/F2`8000000`1^8A000`000000KR4@06hQ400206hQ400403eIZ`000000T2/C090[4`H0?EV[
00H0T2/C0000002/<aL0[3<G0000003D?AT604MWb00300000017IlP0AfO80080AfO80P0000001P3D
?AT00000000000000000AFC20=@m6@80AFC200<0000004ET`P15I<801P15I<800`000000AFC204ET
`P0504ET`P030=@m6@15I<80AFC200D0AFC200<000000=@m6@3D?AT01P15I<800`000000AFC20=@m
6@0704ET`P0300000015I<80AFC200H0AFC200@0000004ET`P15I<80e3dI1@15I<800`000000AFC2
04ET`P0704ET`P040000003D?AT0AFC204ET`P@0000000<0A62j03eIZ`0000000`14H;X00`3D?AT0
A62j04AP^P020=@m6@0304AP^P000000A62j0080A62j00<0e3dI04AP^P14H;X00P14H;X00`3D?AT0
000003eIZ`0=0?ofkP0303eIZ`3om^h0ooK^00H0ooK^00@0?EV[0?ofkP3om^h000000P3om^h403eI
Z`/0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP080?ofkPL0?EV[0`3om^h00`0m
FJ/0ooK^0?ofkP0c0?ofkP030000003om^h0ooK^01D0ooK^0@3oool005<0ooK^00<000000?ofkP00
00001@3om^h00`0mFJ/0ooK^03eIZ`0303eIZ`80ooK^1P0mFJ/70?ofkP0303eIZ`3om^h0000000@0
000000<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00L0
ooK^00<0?EV[0?ofkP3om^h02P3om^h20000000503eIZ`000000000003T@200000000P0i40P01@00
0000BaH;04/F2`1;5P/000000080BaH;00<0000006hQ40000000101^8A001P000000KR4@06hQ4000
0000?EV[000000@0T2/C00@00000090[4`2@:a<0T2/C100mFJ/00`000000e3dI04MWb00504MWb003
00000017IlP0AfO800@0AfO800H000000=@m6@3D?AT0AfO80000003D?AT7000000@0AFC200<00000
04ET`P15I<801015I<800`3D?AT0000004ET`P0604ET`P0300000015I<80AFC200<0e3dI0`15I<80
0`000000AFC20=@m6@0604ET`P0300000015I<80AFC200H0AFC200@0000004ET`P15I<80e3dI1P15
I<800`000000AFC204ET`P0704ET`P030000003D?AT0AFC200D0AFC21P0000030=@m6@<0A62j00@0
000004AP^P14H;X0e3dI1014H;X0103D?AT000000=@m6@0mFJ/<0?ofkP0303eIZ`3om^h0ooK^00L0
ooK^00@0?EV[0?ofkP3om^h000001@3om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^
01<0ooK^00<0?EV[0?ofkP3om^h03`3om^h403eIZc@0ooK^00<000000?ofkP3om^h05P3om^h10?oo
o`00D`3om^h00`000000ooK^000000050?ofkP0303eIZ`3om^h0?EV[00<0ooK^1P0mFJ/20?ofkPD0
?EV[0P3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`000000000000D000001P3om^h00`0mFJ/0
ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h02P3om^h200000003
03eIZ`0W2`D000000080>A0800@0000003T@200i40P00000101;5P/00`000000BaH;0000000206hQ
40050000001^8A00KR4@06hQ400000000P1^8A00100mFJ/0T2/C090[4`000003090[4`050000002@
:a<0T2/C090[4`0000000`2/<aL00`0mFJ/0000004MWb00604MWb00300000017IlP0AfO800@0AfO8
00@0000004MWb03D?AT0e3dI0`17IlP00`000000AfO804MWb00204MWb0H000001@15I<800`3D?AT0
000004ET`P0604ET`P0300000015I<80AFC200<0AFC20`3D?AT00`000000e3dI04ET`P0604ET`P03
00000015I<80AFC200H0AFC200@0000004ET`P15I<80e3dI1@15I<800`000000AFC204ET`P0704ET
`P030000003D?AT0AFC200L0AFC200<0000004ET`P15I<800`3D?AT8000000060=@m6@14H;X0A62j
04AP^P3D?AT0A62j0P0000000`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0
?EV[0?ofkP0000001P3om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0
?EV[0?ofkP3om^h04P3om^h00`0mFJ/0ooK^0?ofkP0a0?ofkP030000003om^h0ooK^01L0ooK^0@3o
ool005<0ooK^0P0000050?ofkP0403eIZ`3om^h0ooK^03eIZ`T0ooK^1P0mFJ/00`3om^h0?EV[03eI
Z`0403eIZ`80ooK^00<0?EV[0?ofkP3om^h01P3om^h50000000303eIZ`3om^h0ooK^00P0ooK^00<0
?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP80000000<0?EV[02L;1@0000000P0i
40P01@000000>A080000001;5P/0000000<0BaH;00<0000004/F2`0000000P1^8A000`000000KR4@
06hQ400206hQ40030000001^8A00?EV[0080T2/C00<00000090[4`2@:a<00P2@:a<00`000000T2/C
090[4`02000000<0[3<G00<0000004MWb017IlP01@17IlP00`000000AfO804MWb00404MWb0040000
0017IlP0AfO80=@m6@<0AfO800<0000004MWb017IlP01P17IlP00`000000AfO80000000300000003
0=@m6@15I<80000000L0AFC200<0000004ET`P15I<801P15I<840=@m6@D0AFC200<0000004ET`P15
I<801P15I<800`000000AFC20=@m6@0604ET`P0300000015I<80AFC200L0AFC200<000000=@m6@15
I<801P15I<850=@m6@D0AFC200H0000004ET`P15I<80AFC20=@m6@15I<8200000080e3dI00@00000
0=@m6@3om^h0?EV[303om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0000000H0ooK^00<0
?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^0180ooK^00<0
?EV[0?ofkP3om^h0<03om^h00`000000ooK^0?ofkP0H0?ofkP40oooo001C0?ofkP8000001@3om^h0
100mFJ/0ooK^0?ofkP0mFJ/?0?ofkPH0?EV[00<0ooK^03eIZ`0mFJ/0100mFJ/:0?ofkP0303eIZ`00
0000000000D000000`3om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00X0ooK^0P00
00000`0mFJ/09`/50000000203T@20050000000i40P0000004/F2`000000101;5P/00`000000KR4@
06hQ400206hQ40040000001^8A00KR4@06hQ4080000000D0?EV[090[4`2@:a<0T2/C00000003090[
4`030000002@:a<0T2/C00800000102/<aL00`000000AfO804MWb00504MWb00300000017IlP0AfO8
00@0AfO800<0000004MWb03D?AT00P3D?AT204MWb00300000017IlP0AfO800D0AfO800<0000004MW
b017IlP00`17IlP00`3D?AT0000000000003000000@0AFC200<0000004ET`P15I<801@15I<800`00
0000e3dI04ET`P0204ET`PH0e3dI2015I<800`000000AFC20=@m6@0504ET`P0300000015I<80AFC2
00L0AFC200<000000=@m6@15I<800`15I<840=@m6@0500000015I<80AFC204ET`P3D?AT01015I<80
1@000000AFC204ET`P15I<80e3dI00<0AFC200<0e3dI04ET`P0000001P0mFJ/:0?ofkP0303eIZ`3o
m^h0ooK^00H0ooK^00<0?EV[0?ofkP0000001P3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3o
m^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h04P3om^h00`0mFJ/0ooK^0?ofkP0_0?ofkP030000003o
m^h0ooK^01T0ooK^0@3oool005<0ooK^0P0000050?ofkP0303eIZ`3om^h0?EV[01<0ooK^00<0?EV[
0?ofkP3om^h03P0mFJ/30?ofkP0303eIZ`3om^h0ooK^00D0ooK^0`0000000`0mFJ/0000000000007
0?ofkP0303eIZ`3om^h0ooK^00T0ooK^0P000000100W2`D0?EV[00000000000303T@208000000P1;
5P/01@000000BaH;04/F2`1;5P/0000000@0KR4@00<0000006hQ401^8A000P1^8A000`000000?EV[
090[4`02090[4`030000002@:a<0T2/C0080T2/C0P0000020:`c5`030000002/<aL0[3<G0080[3<G
00<0000004MWb017IlP01017IlP00`000000AfO804MWb00404MWb0030000003D?AT0AfO80080AfO8
0P3D?AT00`000000AfO804MWb00504MWb00300000017IlP0AfO80080AfO800@0e3dI04MWb017IlP0
00000`17IlP8000000@0AFC200<000000=@m6@15I<801P15I<800`000000AFC20=@m6@050=@m6@04
04ET`P000000AFC20=@m6@H0AFC200<0000004ET`P15I<801P15I<800`000000AFC20=@m6@040=@m
6@<0AFC200D0000004ET`P15I<80AFC20=@m6@0504ET`P0500000015I<80AFC204ET`P3D?AT00P15
I<800`3D?AT0AFC20000000200000080ooK^00<0?EV[0?ofkP3om^h01P0mFJ/40?ofkP0303eIZ`3o
m^h0ooK^00H0ooK^00<0?EV[0000003om^h01P3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3o
m^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h04P3om^h00`0mFJ/0ooK^0?ofkP0_0?ofkP030000003o
m^h0ooK^01T0ooK^0@3oool00580ooK^00<000000?ofkP0000001@3om^h00`0mFJ/0ooK^03eIZ`0C
0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00@0?EV[0?ofkP3om^h0ooK^3P0mFJ/60?ofkP0403eIZ`3o
m^h0ooK^0?ofkPL0000000<0?EV[0?ofkP3om^h02@3om^h20000000503eIZ`000000000003T@2000
00000P0i40P01@000000BaH;04/F2`1;5P/0000000<0BaH;0P00000406hQ40060000001^8A00KR4@
06hQ400mFJ/00000102@:a<010000000T2/C090[4`2@:a<200000080[3<G00<000000:`c5`2/<aL0
0P2/<aL00`000000AfO804MWb00404MWb00300000017IlP0AfO800@0AfO800<000000=@m6@17IlP0
1017IlP00`3D?AT0AfO804MWb00504MWb00300000017IlP0AfO80080AfO800@0e3dI04MWb017IlP0
00001`17IlP010000000AfO804MWb017IlP4000000030=@m6@0000000000008000001015I<800`00
0000AFC204ET`P0504ET`QH0e3dI1P15I<800`000000AFC204ET`P0204ET`P030=@m6@15I<80AFC2
0080AFC200H0000004ET`P15I<80AFC20=@m6@15I<820=@m6@0304ET`P0000000000008000000P3o
m^h00`0mFJ/0ooK^0?ofkP060?ofkPD0?EV[203om^h00`0mFJ/000000?ofkP060?ofkP0303eIZ`3o
m^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h04P3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3o
m^h0ooK^02h0ooK^00<000000?ofkP3om^h06P3om^h10?ooo`00DP3om^h00`000000ooK^00000005
0?ofkP0303eIZ`3om^h0?EV[0180ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP09
0?ofkPd0?EV[2P3om^h00`0mFJ/0000000000003000000D0ooK^0`0000001@0mFJ/000000000000i
40P000000080>A0800D0000004/F2`1;5P/0BaH;0000000204/F2`030000001^8A00000000@0KR4@
00H0000006hQ401^8A00000003eIZ`000005090[4`050000002@:a<0T2/C090[4`0000000`2/<aL0
0`000000[3<G0:`c5`020:`c5`0300000017IlP0AfO800@0AfO800<0000004MWb017IlP00`17IlP0
0`3D?AT0000004MWb00404MWb0030000003D?AT0e3dI00D0AfO800D0000004MWb017IlP0AfO80=@m
6@0304MWb00300000017IlP0AfO800D0AfO800<0000004MWb017IlP01@17IlP00`3D?AT0AfO804MW
b00204MWb0H000001`15I<800`000000e3dI04ET`P0504ET`P0300000015I<80AFC200H0AFC200<0
00000=@m6@15I<801`15I<801@000000AFC204ET`P15I<80e3dI00@0AFC200<0000004ET`P15I<80
0P15I<820=@m6@<0AFC20`0000020?ofkP0303eIZ`3om^h0ooK^00/0ooK^1`0mFJ/20?ofkP0303eI
Z`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eI
Z`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h0;@3om^h00`000000ooK^0?ofkP0K0?ofkP40oooo
001B0?ofkP030000003om^h0000000D0ooK^00<0?EV[0?ofkP0mFJ/04P3om^h00`0mFJ/0ooK^0?of
kP030?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h00`3om^h<03eIZ`<0ooK^00<0
?EV[0?ofkP3om^h00`3om^h80000000503eIZ`000000>A0803T@200000000P0i40P00`000000BaH;
04/F2`0204/F2`030000001;5P/000000080KR4@00<0000006hQ401^8A000P1^8A001P000000KR4@
0000000mFJ/0T2/C000000@0T2/C00H00000090[4`2@:a<000000:`c5`0000030:`c5`050000002/
<aL0[3<G0:`c5`0000001P17IlP00`000000AfO804MWb00304MWb0030=@m6@000000AfO800D0AfO8
00@0000004MWb03D?AT0e3dI0`17IlP01@000000AfO804MWb017IlP0e3dI00<0AfO800<0000004MW
b017IlP01@17IlP00`000000AfO804MWb00404MWb0030=@m6@000000AfO800L0AfO800<0000004MW
b00000000`00000204ET`P0300000015I<80e3dI00H0AFC200<0000004ET`P15I<801P15I<800`00
0000e3dI04ET`P0604ET`P0300000015I<80AFC20080AFC200D0e3dI04ET`P15I<80AFC200000004
04ET`P80e3dI0`15I<830000000403eIZ`3om^h0ooK^03eIZ``0ooK^00<0?EV[0?ofkP3om^h01@3o
m^h603eIZ`D0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3o
m^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h0;03om^h00`000000ooK^0?ofkP0L0?ofkP40oooo001B
0?ofkP8000001P3om^h00`0mFJ/0ooK^03eIZ`0B0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[
0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00d0?EV[1P3om^h0
1@0E1P8000000000000mFJ/000000080>A0800D0000003T@20000000BaH;0000000304/F2`030000
001;5P/000000080KR4@00<0000006hQ401^8A000P1^8A0200000005090[4`0mFJ/0T2/C090[4`00
0000102@:a<01@000000T2/C0000002/<aL0000000<0[3<G00<000000:`c5`2/<aL00P2/<aL00`00
0000AfO804MWb00404MWb00700000017IlP0AfO804MWb03D?AT0AfO80000000604MWb00500000017
IlP0AfO804MWb03D?AT00P17IlP010000000AfO804MWb03D?AT404MWb00300000017IlP0AfO800D0
AfO800<0000004MWb017IlP01017IlP00`3D?AT0000004MWb00604MWb00300000017IlP0AfO800@0
AfO80`0000000`3D?AT000000000000404ET`P0300000015I<80AFC200H0AFC200<000000=@m6@15
I<801P15I<800`000000AFC204ET`P0204ET`P030=@m6@15I<80AFC20080AFC200<0000004ET`P15
I<800P15I<801`3D?AT0AFC204ET`P15I<8000000?m=7`0000000P3om^h603eIZ`T0ooK^00<0?EV[
0?ofkP3om^h01P3om^h00`000000?EV[0?ofkP020?ofkPL0?EV[2P3om^h00`0mFJ/0ooK^0?ofkP0C
0?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h0:`3om^h00`000000ooK^0?ofkP0M
0?ofkP40oooo001B0?ofkP8000001@3om^h0100mFJ/0ooK^0?ofkP0mFJ/B0?ofkP0303eIZ`3om^h0
ooK^00<0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0
ooK^00H0ooK^1P0mFJ/00`3om^h0?EV[03eIZ`0403eIZ`80000000<0?EV[02L;1@0000000P0i40P0
1@000000>A080000001;5P/0000000@0BaH;00<0000006hQ401^8A000P1^8A000`000000KR4@06hQ
400206hQ40030000000mFJ/0T2/C0080T2/C00<00000090[4`2@:a<00P2@:a<2000000<0[3<G00D0
00000:`c5`2/<aL0[3<G000000030:`c5`0300000017IlP0AfO800@0AfO800D0000004MWb017IlP0
AfO80=@m6@0204MWb00300000017IlP0AfO800<0AfO800<0000004MWb017IlP00P17IlP20=@m6@04
04MWb0000000AfO80=@m6@@0AfO800<0000004MWb017IlP01@17IlP00`000000AfO804MWb00304MW
b0030=@m6@000000AfO800L0AfO800<0000004MWb017IlP01@17IlP00`000000AfO80=@m6@0204MW
b0P000001@15I<800`000000e3dI04ET`P0504ET`P0300000015I<80AFC20080AFC200<0e3dI04ET
`P15I<800P15I<8010000000AFC204ET`P15I<820=@m6@<0AFC200@000000?m=7`0000000000103o
m^h0100mFJ/0ooK^0?ofkP3om^h603eIZ`<0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`000000ooK^
03eIZ`080?ofkP0303eIZ`3om^h0?EV[00H0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eI
Z`3om^h0ooK^0180ooK^00<0?EV[0?ofkP3om^h0:`3om^h00`000000ooK^0?ofkP0N0?ofkP40oooo
001B0?ofkP8000001@3om^h0100mFJ/0ooK^0?ofkP0mFJ/B0?ofkP0303eIZ`3om^h0ooK^00<0ooK^
00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00T0ooK^
00@0?EV[0?ofkP3om^h0ooK^1P0mFJ/20000000402L;1@0mFJ/00000000000<0>A080P00000204/F
2`050000001;5P/0BaH;04/F2`0000001@1^8A001P000000KR4@06hQ401^8A00000003eIZ`@0T2/C
00<00000090[4`2@:a<00P2@:a<00`000000[3<G0:`c5`020:`c5`050000002/<aL0[3<G0:`c5`00
00000`2/<aL4000000<0AfO800@0000004MWb017IlP0e3dI0P17IlP00`000000AfO804MWb00304MW
b00300000017IlP0AfO800@0AfO80`3D?AT504MWb00300000017IlP0AfO800D0AfO800<0000004MW
b017IlP00`17IlP00`3D?AT0000004MWb00704MWb00300000017IlP0AfO800D0AfO800<000000=@m
6@17IlP01@17IlP00`000000AfO804MWb00204MWb0D0000000<0e3dI0000000000001@15I<800`00
0000AFC204ET`P0204ET`P050=@m6@15I<80AFC204ET`P0000000P15I<830=@m6@<0AFC200D00000
0?m=7`000000000003eIZ`040?ofkP0303eIZ`3om^h0ooK^00L0ooK^1P0mFJ/40?ofkP030000003o
m^h0?EV[00P0ooK^00<0?EV[0?ofkP3om^h01`3om^h703eIZa80ooK^00<0?EV[0?ofkP3om^h04P3o
m^h00`0mFJ/0ooK^0?ofkP0[0?ofkP030000003om^h0ooK^01h0ooK^0@3oool00580ooK^0P000005
0?ofkP0403eIZ`3om^h0ooK^03eIZa80ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?of
kP0<0?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?of
kP070?ofkPH0?EV[00@0000003T@200i40P000000`1;5P/010000000BaH;04/F2`1;5P/2000000@0
KR4@00H0000006hQ401^8A000000090[4`0mFJ/4090[4`030000002@:a<0T2/C0080T2/C0P000003
0:`c5`050000002/<aL0[3<G0:`c5`0000000P2/<aL00`000000`cXI0000000204QYcPD0000000<0
e3dI00000017IlP00P17IlP00`000000AfO804MWb00304MWb00300000017IlP0AfO800@0AfO800<0
00000=@m6@3D?AT01017IlP00`000000AfO804MWb00404MWb00300000017IlP0AfO800<0AfO800<0
e3dI04MWb00000001`17IlP00`000000AfO804MWb00504MWb00300000017IlP0e3dI00H0AfO800<0
000004MWb017IlP01@17IlP00`000000e3dI04MWb00204MWb0H000000`15I<801P3D?AT0AFC204ET
`P15I<80000004ET`P80e3dI0P15I<801@3D?AT0AFC204ET`P000000oddO0080000000<0?EV[0?of
kP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00L0?EV[203om^h00`0m
FJ/0ooK^0?ofkP0:0?ofkP0403eIZ`3om^h0ooK^0?ofkPL0?EV[2`3om^h00`0mFJ/0ooK^0?ofkP0B
0?ofkP0303eIZ`3om^h0ooK^02X0ooK^00<000000?ofkP3om^h07`3om^h10?ooo`00D@3om^h00`00
0000ooK^000000050?ofkP@0?EV[4@3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^
00`0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^
00L0ooK^0`000000100W2`D0?EV[0000000i40P603eIZ`0704/F2`000000BaH;04/F2`000000KR4@
0000000506hQ40060000001^8A000000090[4`0mFJ/00000102@:a<01P000000T2/C090[4`000000
[3<G000000@0[3<G00T000000:`c5`2/<aL0[3<G0000002/<aL000000<<j6@0000001`18JLh00`3D
?AT0B6W>00000005000000<0AfO800<0000004MWb017IlP01017IlP00`000000e3dI04MWb0040=@m
6@0300000017IlP0AfO800@0AfO800<0000004MWb017IlP00`17IlP00`3D?AT0AfO80000000704MW
b00300000017IlP0AfO800D0AfO800<000000=@m6@17IlP01@17IlP00`000000AfO804MWb00604MW
b0030000003D?AT0AfO800D0AfO800<0000004MWb017IlP00`000000103D?AT0AFC204ET`P15I<82
0=@m6@<0AFC200@0e3dI04ET`P15I<80AFC20P0000000`3oCAl0000003eIZ`040?ofkP0303eIZ`3o
m^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`000000ooK^0?ofkP0603eIZ`<0ooK^00<0
?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP080?ofkPP0?EV[0`3om^h00`0mFJ/0ooK^0?of
kP0B0?ofkP0303eIZ`3om^h0ooK^02T0ooK^00<000000?ofkP3om^h0803om^h10?ooo`00D@3om^h0
0`000000ooK^000000050?ofkP0403eIZ`3om^h0?EV[0?ofkPL0?EV[2P3om^h00`0mFJ/0ooK^0?of
kP030?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?of
kP080?ofkP0303eIZ`3om^h0ooK^00L0ooK^0`0000001@0W2`D0?EV[03T@200i40P000000080>A08
00<000000=@m6@1;5P/01P0mFJ/00`1^8A00000006hQ400306hQ4080000000D0T2/C03eIZ`2@:a<0
T2/C00000004090[4`030000002@:a<000000080[3<G00<000000:`c5`2/<aL00P2/<aL00`000000
[3<G0:`c5`02000000<0`cXI00<000000=@m6@18JLh00`18JLh00`3D?AT0B6W>04QYcP0304QYcP03
00000018JLh0B6W>00D000001@17IlP00`3D?AT0AfO804MWb00404MWb0<0e3dI1017IlP00`000000
AfO804MWb00204MWb0040=@m6@17IlP0AfO8000000L0AfO800<0000004MWb017IlP01017IlP00`00
0000AfO80=@m6@0604MWb00300000017IlP0AfO800D0AfO800<000000=@m6@17IlP01@17IlP00`00
0000AfO804MWb00304MWb0030=@m6@17IlP000000080e3dI0`00000204ET`P030=@m6@15I<80AFC2
0080000000@0oddO0000003om^h0?EV[103om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0
ooK^0080ooK^00D000000?ofkP3om^h0ooK^03eIZ`050?ofkP@0?EV[2`3om^h00`0mFJ/0ooK^0?of
kP0A0?ofkPH0?EV[4P3om^h00`0mFJ/0ooK^0?ofkP0X0?ofkP030000003om^h0ooK^0240ooK^0@3o
ool00540ooK^0P0000060?ofkP0303eIZ`3om^h0?EV[00P0ooK^1`0mFJ/30?ofkP0303eIZ`3om^h0
ooK^00<0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0
ooK^00P0ooK^00<0?EV[0?ofkP3om^h01`3om^h01@0E1P8000000000000mFJ/000000080>A0800D0
000003T@20000000BaH;0000000304/F2`040000001;5P/0000006hQ40H0?EV[00@0KR4@0000002@
:a<0?EV[0P2@:a<00`000000T2/C090[4`02090[4`800000102/<aL01@000000[3<G0:`c5`2/<aL0
000000<0[3<G00L000000<<j6@33>QT0?EV[00000018JLh0e3dI00<0B6W>00<0e3dI04QYcP18JLh0
1018JLh00`000000B6W>04QYcP0204QYcP0300000018JLh0000000<0000000<0AfO80=@m6@17IlP0
1@17IlP00`000000AfO804MWb0030=@m6@0304MWb0000000AfO800<0AfO800@0e3dI04MWb017IlP0
00001`17IlP00`000000AfO804MWb00404MWb0030000003D?AT0AfO800D0AfO800<0000004MWb017
IlP01@17IlP00`000000e3dI04MWb00504MWb00300000017IlP0AfO800@0AfO80`3D?AT00`000000
AfO804MWb00204MWb0030000003D?AT000000080000000H0oddO00000000000000000?ofkP0mFJ/4
0?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h00`3om^h01@000000ooK^0?ofkP3o
m^h0?EV[00P0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP0303eIZ`3o
m^h0ooK^00D0?EV[3@3om^h00`0mFJ/0ooK^0?ofkP0W0?ofkP030000003om^h0ooK^0280ooK^0@3o
ool00540ooK^0P0000050?ofkP0303eIZ`3om^h0ooK^00<0?EV[3@3om^h703eIZ`80ooK^00<0?EV[
0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[
0?ofkP3om^h01`3om^h30000000703eIZ`000000>A0803T@20000000>A080000000204/F2`050000
001;5P/0BaH;04/F2`000000101^8A0010000000KR4@06hQ401^8A0703eIZ`030000002@:a<0T2/C
0080T2/C00<000000:`c5`2/<aL00P2/<aL00`000000[3<G0:`c5`020:`c5`040000002/<aL0[3<G
00000080`cXI00@0?EV[0<<j6@000000B6W>0`3D?AT00`18JLh0000004QYcP0404QYcP0300000018
JLh0B6W>00<0B6W>00<0000004QYcP18JLh00P18JLh00`3D?AT0000000000002000000<0AfO800<0
000004MWb017IlP00`17IlP40=@m6@0504MWb03D?AT0AfO804MWb00000001`17IlP00`000000AfO8
04MWb00404MWb00300000017IlP0e3dI00D0AfO800<0000004MWb017IlP01P17IlP00`000000e3dI
04MWb00504MWb00400000017IlP0AfO804MWb0@0e3dI00<0AfO800000017IlP01@17IlP0103D?AT0
AfO80000003oCAl300000080ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP0:0?of
kP0303eIZ`3om^h0ooK^0080ooK^00D000000?ofkP3om^h0ooK^03eIZ`090?ofkP0303eIZ`3om^h0
ooK^00T0ooK^00<0?EV[0?ofkP3om^h0503om^h00`0mFJ/0ooK^0?ofkP050?ofkPH0?EV[1`3om^h0
0`0mFJ/0ooK^0?ofkP0V0?ofkP030000003om^h0ooK^02<0ooK^0@3oool00540ooK^0P0000050?of
kP0403eIZ`3om^h0ooK^03eIZ`80ooK^1P0mFJ/:0?ofkP0403eIZ`3om^h0ooK^0?ofkPL0?EV[2P3o
m^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h01P3o
m^h20000000502L;1@000000?EV[03T@200000000P0i40P200000080BaH;00D0000004/F2`1;5P/0
BaH;0000000506hQ40040000001^8A00KR4@00000080T2/C00@0?EV[090[4`2@:a<0T2/C200mFJ/3
0:`c5`030000002/<aL0[3<G0080[3<G0P0000000`33>QT0000003eIZ`020<<j6@0700000018JLh0
B6W>04QYcP3D?AT0B6W>0000000504QYcP0300000018JLh0B6W>00<0B6W>00<0000004QYcP18JLh0
0P18JLh00`3D?AT0000004QYcP0204QYcPL000000`17IlP00`000000AfO804MWb0040=@m6@030000
0017IlP0AfO800D0AfO800<0000004MWb017IlP01017IlP00`000000e3dI04MWb00504MWb0030000
0017IlP0AfO800D0AfO800<000000=@m6@17IlP01@17IlP50=@m6@0504MWb03D?AT0AfO804MWb000
00001P17IlP00`3D?AT0AfO80000000500000080ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0
ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^0080ooK^00D000000?ofkP3om^h0ooK^03eIZ`090?of
kP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP0<0?of
kPD0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP0V0?ofkP030000003om^h0ooK^02<0ooK^0@3oool00540
ooK^0P0000050?ofkP0403eIZ`3om^h0ooK^03eIZ`P0ooK^1P0mFJ/40?ofkP0303eIZ`3om^h0ooK^
0080ooK^00<0?EV[0?ofkP3om^h00`3om^h703eIZ`<0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0m
FJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^00H0ooK^0P0000001@0W2`D0000003eIZ`0i40P0
00000080>A0800<0000004/F2`1;5P/00P1;5P/00`000000BaH;04/F2`02000000@0KR4@00@00000
06hQ401^8A0000000P2@:a<00`0mFJ/0T2/C090[4`02090[4`070000002@:a<0T2/C0000002/<aL0
00000:`c5`0803eIZ`8000000P33>QT01@0mFJ/0`cXI0<<j6@33>QT000000080B6W>0`3D?AT00`00
0000B6W>04QYcP0304QYcP0300000018JLh0B6W>0080B6W>00L0000004QYcP18JLh0B6W>0=@m6@18
JLh0000000H0B6W>00@0000004QYcP18JLh0B6W>1`0000000`3D?AT0AfO804MWb0060=@m6@80AfO8
00<0000004MWb017IlP00`17IlP00`000000AfO80=@m6@0504MWb00300000017IlP0AfO800D0AfO8
00@0000004MWb03D?AT0AfO81@3D?AT604MWb0030=@m6@17IlP0000000H0AfO80P3D?AT6000000<0
ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0503eIZ`3om^h0ooK^0?of
kP000000103om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?of
kP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP<0?EV[9`3om^h00`000000ooK^0?ofkP0T0?of
kP40oooo001@0?ofkP030000003om^h0000000D0ooK^00@0?EV[0?ofkP3om^h0?EV[3P3om^h603eI
Z`<0ooK^00<0?EV[0?ofkP3om^h02P3om^h703eIZ`D0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0m
FJ/0ooK^0?ofkP070?ofkP80000000D09`/50000000mFJ/0>A080000000203T@20030000001;5P/0
BaH;0080BaH;00<0000004/F2`1;5P/00P00000506hQ40070000001^8A000000090[4`0mFJ/0T2/C
00000004090[4`030000002@:a<000000080[3<G00<000000:`c5`2/<aL00P2/<aL010000000[3<G
0:`c5`2/<aL603eIZ`<0`cXI00<000000=@m6@18JLh00P18JLh20=@m6@@0B6W>00<0000004QYcP18
JLh00`18JLh01P000000B6W>04QYcP3D?AT0B6W>000000H0B6W>00<0000004QYcP18JLh01018JLh0
10000000B6W>04QYcP3D?AT700000080AfO81P3D?AT204MWb0030000003D?AT0AfO800D0AfO800<0
000004MWb03D?AT02@3D?AT304MWb00300000017IlP0AfO800@0AfO800<0e3dI04MWb00000002017
IlP00`000000?EV[03eIZ`0203eIZ`8000000P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3o
m^h0ooK^00/0ooK^00@0?EV[0?ofkP3om^h000001@3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eI
Z`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eI
Z`3om^h0ooK^02@0ooK^00<000000?ofkP3om^h09@3om^h10?ooo`00D03om^h2000000H0ooK^00<0
?EV[0?ofkP0mFJ/04`3om^h00`0mFJ/0ooK^03eIZ`0603eIZ``0ooK^00@0?EV[0?ofkP3om^h0ooK^
1P0mFJ/:0?ofkP0303eIZ`3om^h0ooK^00L0ooK^0P0000000`0W2`D0?EV[03T@200203T@20040000
000i40P00000000000@0BaH;0P00000206hQ40030000001^8A00KR4@0080KR4@0P000002090[4`04
03eIZ`2@:a<0T2/C000000<0T2/C0P0000040:`c5`030000002/<aL0[3<G0080[3<G00T000000:`c
5`2/<aL000000<<j6@000000`cXI03eIZ`0000000`0mFJ/00`000000e3dI04QYcP0204QYcP040000
0018JLh0e3dI0=@m6@80B6W>00<0000004QYcP18JLh00`18JLh00`000000B6W>0=@m6@0304QYcP03
00000018JLh0B6W>00<0B6W>00<0000004QYcP18JLh01018JLh010000000B6W>04QYcP3D?AT304QY
cP0400000018JLh0B6W>04QYcPH000000P17IlP<0=@m6@D0AfO800<000000=@m6@17IlP01017IlP0
0`000000AfO804MWb00504MWb0030=@m6@000000AfO800L0AfO800<000000?mC8P0000000`000006
03eIZ`<0ooK^00<0?EV[0?ofkP3om^h02`3om^h0100mFJ/0ooK^0?ofkP0000050?ofkP0303eIZ`3o
m^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP0303eIZ`3o
m^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h08`3om^h00`000000ooK^0?ofkP0V0?ofkP40oooo001@
0?ofkP8000001P3om^h00`0mFJ/0ooK^03eIZ`0C0?ofkP0303eIZ`3om^h0ooK^0080ooK^00@0?EV[
0?ofkP3om^h0ooK^200mFJ/40?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP0mFJ/01P0m
FJ/30?ofkP0303eIZ`3om^h0ooK^00L0ooK^0P0000000`0W2`D0?EV[03T@200203T@20040000000i
40P00000000000@0BaH;0P00000306hQ40030000001^8A00KR4@0080KR4@00@00000090[4`2@:a<0
?EV[0`2@:a<01@000000T2/C090[4`2@:a<0000000D0[3<G00<000000:`c5`2/<aL00P2/<aL01P00
0000[3<G00000033>QT0000003eIZ`80`cXI00D000000<<j6@33>QT0`cXI0000000404QYcP030000
0018JLh0B6W>0080e3dI00<0B6W>00000018JLh00`18JLh00`000000B6W>0=@m6@0304QYcP030000
0018JLh0B6W>00<0B6W>00<0000004QYcP18JLh01018JLh00`000000B6W>0=@m6@0304QYcP030000
0018JLh0B6W>00D0B6W>00<0000004QYcP18JLh0100000000`3D?AT000000000000404MWb0030000
0017IlP0AfO800@0AfO800<0000004MWb03D?AT01017IlP00`000000AfO804MWb00504MWb0030=@m
6@000000AfO800H0AfO80P0000001`3oDb800000000000000000e3dI0=i26@0000000`3om^h00`0m
FJ/0ooK^03eIZ`0603eIZ`X0ooK^00<0?EV[0?ofkP0000001P3om^h00`0mFJ/0ooK^0?ofkP060?of
kP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h0503om^h00`0mFJ/0ooK^0?ofkP0B0?of
kP0303eIZ`3om^h0ooK^02<0ooK^00<000000?ofkP3om^h09`3om^h10?ooo`00D03om^h2000000D0
ooK^00@0?EV[0?ofkP3om^h0?EV[4P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^
00T0ooK^200mFJ/40?ofkP0303eIZ`3om^h0ooK^00H0ooK^200mFJ/40?ofkP<0000000<09`/503eI
Z`0i40P00P0i40P200000080BaH;00<0000004/F2`1;5P/00P1;5P/01@000000KR4@06hQ401^8A00
000000@0KR4@0P0000000`2@:a<0?EV[090[4`03090[4`030000002@:a<0T2/C00800000102/<aL0
0`000000[3<G0:`c5`020:`c5`8000000`33>QT01@0mFJ/0`cXI0<<j6@33>QT000000080`cXI00<0
000004QYcP18JLh00P18JLh00`000000B6W>04QYcP0204QYcP80e3dI1018JLh00`000000e3dI04QY
cP0304QYcP0300000018JLh0B6W>00<0B6W>00<0000004QYcP18JLh01018JLh00`000000B6W>0=@m
6@0304QYcP0300000018JLh0B6W>00@0B6W>00<0000004QYcP18JLh00`18JLh00`000000B6W>0=@m
6@0204QYcPL000001017IlP00`000000e3dI04MWb00404MWb00300000017IlP0AfO800D0AfO800<0
e3dI04MWb017IlP01@17IlP00`000000oe<R0?mC8P02000000050?m=7`00000000000000003om^h0
1P0mFJ/20?ofkP0403eIZ`3om^h0ooK^0?ofkPL0?EV[0P3om^h00`0mFJ/0ooK^000000060?ofkP03
03eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP03
03eIZ`3om^h0ooK^0180ooK^00<0?EV[0?ofkP3om^h08P3om^h00`000000ooK^0?ofkP0X0?ofkP40
oooo001@0?ofkP8000001@3om^h0100mFJ/0ooK^0?ofkP0mFJ/B0?ofkP0303eIZ`3om^h0ooK^0080
ooK^00<0?EV[0?ofkP3om^h03P3om^h0100mFJ/0ooK^0?ofkP3om^h703eIZ`T0ooK^00<0?EV[0?of
kP3om^h00P3om^h603eIZ`0402L;1@000000?EV[000000<0>A0800@0000004/F2`1;5P/00000101;
5P/2000000<0KR4@00@0000006hQ401^8A0000000P2@:a<00`0mFJ/0T2/C090[4`03090[4`030000
002@:a<000000080[3<G00<000000:`c5`2/<aL00P2/<aL00`000000[3<G0:`c5`020:`c5`060000
0033>QT0`cXI0<<j6@0mFJ/000000`33>QT010000000`cXI0<<j6@00000404QYcP0300000018JLh0
B6W>00<0B6W>0P3D?AT304QYcP030=@m6@18JLh0B6W>0080B6W>00<0000004QYcP18JLh00`18JLh0
0`000000B6W>04QYcP0404QYcP030000003D?AT0B6W>00<0B6W>00<0000004QYcP18JLh01018JLh0
0`000000B6W>04QYcP0304QYcP030000003D?AT0B6W>00@0B6W>00<0000004QYcP18JLh00P18JLh5
000000030=@m6@17IlP0AfO80080AfO800<0000004MWb017IlP01@17IlP00`3D?AT0AfO804MWb005
04MWb0030000003oDb8000000080000000@0oddO00000000000000001@3om^h00`0mFJ/0ooK^0?of
kP0603eIZ`L0ooK^200mFJ/30?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h02@3o
m^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h08P3o
m^h00`000000ooK^0?ofkP0X0?ofkP40oooo001@0?ofkP8000001@3om^h403eIZa80ooK^00<0?EV[
0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[
0?ofkP3om^h01P0mFJ/30?ofkP0303eIZ`3om^h0ooK^00H0ooK^00H0000002L;1@0mFJ/0000003eI
Z`00000303T@20050000001;5P/0BaH;04/F2`0000000P1;5P/00`000000KR4@0000000406hQ4003
0000001^8A0000000080T2/C00<0?EV[0000002@:a<0102@:a<2000000<0[3<G00<000000:`c5`2/
<aL00P2/<aL01P000000[3<G0:`c5`000000`cXI00000080`cXI00<0?EV[00000033>QT00P33>QT0
10000000`cXI0<<j6@00000404QYcP0300000018JLh0B6W>00<0B6W>00<0000004QYcP3D?AT00P3D
?AT00`000000B6W>04QYcP0204QYcP0300000018JLh0B6W>00<0B6W>00<0000004QYcP18JLh00`18
JLh00`000000B6W>0=@m6@0404QYcP0300000018JLh0B6W>00<0B6W>00<0000004QYcP18JLh00`18
JLh00`000000B6W>0=@m6@0504QYcP0300000018JLh0B6W>00@0B6W>00@0000004QYcP3D?AT0B6W>
1`00000404MWb0030000003D?AT0AfO800D0AfO800H000000?mC8P000000oe<R0000003oCAl40000
00D0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`040?ofkPH0?EV[0`3om^h00`0mFJ/000000?ofkP03
0?ofkPH0?EV[1P3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[
0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP0Q0?ofkP030000003om^h0ooK^02T0ooK^0@3oool0
04l0ooK^00<000000?ofkP0000001@3om^h00`0mFJ/0ooK^0?ofkP0803eIZ`/0ooK^00<0?EV[0?of
kP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?of
kP3om^h01P3om^h603eIZ`H0ooK^00H0000002L;1@0W2`D0?EV[03T@2000000303T@20050000001;
5P/0BaH;04/F2`0000000P1;5P/010000000KR4@06hQ4000000306hQ408000000`2@:a<00`0mFJ/0
T2/C00000005090[4`030000002/<aL0[3<G0080[3<G00<000000:`c5`2/<aL00P2/<aL00`000000
[3<G000000020<<j6@050000000mFJ/0`cXI0<<j6@0000000`33>QT00`000000`cXI0<<j6@030000
0080B6W>00<0000004QYcP18JLh00P18JLh010000000B6W>04QYcP18JLh20=@m6@@0B6W>00<00000
04QYcP18JLh00`18JLh00`000000B6W>04QYcP0304QYcP0300000018JLh0e3dI00<0B6W>00<00000
04QYcP18JLh01018JLh00`000000B6W>04QYcP0304QYcP030000003D?AT0B6W>00@0B6W>00<00000
04QYcP18JLh01018JLh010000000B6W>04QYcP3D?AT304QYcP0300000018JLh0B6W>0080B6W>1000
00000`3D?AT000000000000404MWb0040000003oDb8000000?mC8PH000001P3om^h01@0mFJ/0ooK^
0?ofkP3om^h0?EV[00X0ooK^200mFJ/40?ofkP0303eIZ`3om^h0ooK^00D0?EV[00<0ooK^03eIZ`3o
m^h02`3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3o
m^h0803om^h00`000000ooK^0?ofkP0Z0?ofkP40oooo001?0?ofkP8000001P3om^h00`0mFJ/0ooK^
03eIZ`080?ofkPP0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00d0ooK^
00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00H0?EV[
00@0000002L;1@0W2`D0?EV[0P0i40P01@000000>A080000001;5P/0000000<0BaH;00<0000004/F
2`0000000`1^8A001@000000KR4@06hQ401^8A00000000<0T2/C00<0?EV[090[4`0000001@2@:a<2
000000<0[3<G00<000000:`c5`2/<aL00P2/<aL2000000<0`cXI00<0000003eIZ`33>QT00P33>QT0
1P000000`cXI0<<j6@33>QT000000<<j6@80000000<0BFcC0000000000000`00000304QYcP050000
0018JLh0B6W>0=@m6@18JLh00`3D?AT204QYcP0300000018JLh0B6W>0080B6W>00<0000004QYcP18
JLh00`18JLh00`000000e3dI04QYcP0304QYcP0300000018JLh0B6W>00<0B6W>00<0000004QYcP18
JLh00`18JLh00`000000B6W>0=@m6@0404QYcP0300000018JLh0B6W>00D0B6W>00<0000004QYcP3D
?AT00`18JLh00`000000B6W>04QYcP0504QYcP0300000018JLh0e3dI0080B6W>100000000`3oDb80
000000000004000000030=@m6@000000ooK^00H0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0=0?of
kP0303eIZ`3om^h0ooK^0080ooK^2@0mFJ/30?ofkPH0?EV[1`3om^h00`0mFJ/0ooK^0?ofkP0D0?of
kP0303eIZ`3om^h0ooK^0180ooK^00<0?EV[0?ofkP3om^h0803om^h00`000000ooK^0?ofkP0[0?of
kP40oooo001?0?ofkP8000001P3om^h00`0mFJ/0ooK^03eIZ`0@0?ofkPL0?EV[00<0ooK^03eIZ`3o
m^h03P3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3o
m^h01@3om^h00`3D?AT0?EV[03eIZ`0503eIZ`0403T@20000000BaH;000000<0BaH;0P00000406hQ
40040000001^8A00KR4@06hQ408000000P2@:a<0100mFJ/0T2/C090[4`000003090[4`040000002/
<aL0[3<G000000<0[3<G00<000000:`c5`2/<aL00P2/<aL00`000000`cXI0<<j6@020<<j6@0503eI
Z`33>QT0`cXI0<<j6@0000000`33>QT2000000030=Lo70000000BFcC00<0BFcC00<0000004U/d`00
0000100000000`3D?AT0000000000003000000<0e3dI1018JLh00`000000B6W>04QYcP0304QYcP03
0000003D?AT0B6W>00<0B6W>00<0000004QYcP18JLh00`18JLh00`000000B6W>04QYcP0304QYcP03
0000003D?AT0B6W>00<0B6W>00<0000004QYcP18JLh01@18JLh010000000B6W>04QYcP3D?AT204QY
cP0300000018JLh0B6W>00D0B6W>00<0000004QYcP3D?AT00P18JLh01@3D?AT0B6W>000000000000
oe<R008000000P3oDb82000000030=@m6@000000ooK^00L0ooK^00@0?EV[0?ofkP3om^h0?EV[3@3o
m^h00`000000?EV[0?ofkP060?ofkP0303eIZ`3om^h0ooK^00<0ooK^1@0mFJ/40?ofkPD0?EV[0P3o
m^h00`0mFJ/0ooK^0?ofkP0D0?ofkP0303eIZ`3om^h0ooK^0180ooK^00<0?EV[0?ofkP3om^h07`3o
m^h00`000000ooK^0?ofkP0/0?ofkP40oooo001?0?ofkP8000001P3om^h00`0mFJ/0ooK^03eIZ`0C
0?ofkP0403eIZ`3om^h0ooK^0?ofkPL0?EV[2P3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3o
m^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h01P3om^h01@3D?AT0000002L;1@0W2`D0?EV[0080>A08
00<0000003eIZ`0mFJ/01P0mFJ/00`000000KR4@06hQ400306hQ40070000001^8A00KR4@0000002@
:a<0000003eIZ`04090[4`040000002@:a<0T2/C000000<0[3<G00D000000:`c5`2/<aL0[3<G0000
00030:`c5`8000000`33>QT00`0mFJ/000000<<j6@020<<j6@0500000033>QT0`cXI0<<j6@000000
0P3G?a`01@000000BFcC04U/d`19K=<0000000H0BFcC00@0e3dI04U/d`19K=<000000P19K=<30000
0080e3dI0P18JLh00`000000B6W>04QYcP0304QYcP030=@m6@18JLh0B6W>00<0B6W>00<0000004QY
cP18JLh00P18JLh00`000000B6W>04QYcP0304QYcP0300000018JLh0e3dI00@0B6W>00<0000004QY
cP18JLh01018JLh010000000B6W>04QYcP3D?AT204QYcP0300000018JLh0B6W>00@0B6W>0P000002
04QYcP<0e3dI00<0B6W>0000000000000`0000020?mC8P80000000<0oddO000000000000203om^h0
100mFJ/0ooK^0?ofkP0mFJ/<0?ofkP030000003om^h0?EV[00L0ooK^00<0?EV[0?ofkP3om^h01`3o
m^h00`0mFJ/0ooK^0?ofkP070?ofkPH0?EV[4`3om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP0303eIZ`3o
m^h0ooK^01h0ooK^00<000000?ofkP3om^h0;@3om^h10?ooo`00C`3om^h2000000D0ooK^00<0?EV[
0?ofkP3om^h0100mFJ/@0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/01P3om^h703eIZ`<0ooK^00<0
?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^00H0ooK^0P3D
?AT00`000000?EV[0000000303T@20050000001;5P/0BaH;04/F2`0000000`1;5P/803eIZ`050000
002@:a<0T2/C090[4`0mFJ/01@2@:a<2000000D0[3<G00L000000:`c5`2/<aL0[3<G0000002/<aL0
00000080`cXI00<000000<<j6@0mFJ/00P33>QT02@000000`cXI0<<j6@33>QT000000<<j6@000000
eclL000000020=Lo700500000019K=<0BFcC04U/d`0000001019K=<01@3D?AT0BFcC04U/d`19K=<0
000000@0BFcC00<0000004U/d`19K=<00`3D?AT2000000<0B6W>00<0e3dI04QYcP18JLh00P18JLh0
0`000000B6W>04QYcP0304QYcP0300000018JLh0B6W>00<0B6W>00<000000=@m6@18JLh00`18JLh0
0`000000B6W>04QYcP0404QYcP0700000018JLh0B6W>04QYcP3D?AT0B6W>0000000604QYcP030000
0018JLh0B6W>00<0e3dI0P18JLh01@000000?EV[0000003oDb80000000<0oe<R100000080?ofkP05
03eIZ`3om^h0ooK^0?ofkP0mFJ/0303om^h00`000000ooK^03eIZ`060?ofkP0303eIZ`3om^h0ooK^
00P0ooK^00<0?EV[0?ofkP3om^h02@3om^h0100mFJ/0ooK^0?ofkP3om^h703eIZ`/0ooK^00<0?EV[
0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP0N0?ofkP030000003om^h0ooK^02d0ooK^0@3oool0
04l0ooK^0P0000050?ofkP0403eIZ`3om^h0ooK^03eIZ`<0ooK^200mFJ/80?ofkP0503eIZ`3om^h0
ooK^0?ofkP0mFJ/03@3om^h703eIZ`<0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?of
kP050?ofkP070=@m6@3om^h0e3dI0000000mFJ/0>A080000000203T@20030000001;5P/0BaH;0080
BaH;00D0000004/F2`000000KR4@0000000506hQ40030000000mFJ/0?EV[00D0?EV[102@:a<00`00
0000[3<G0:`c5`040:`c5`040000002/<aL0[3<G0:`c5`8000000`33>QT00`000000?EV[0<<j6@02
0<<j6@0600000033>QT0`cXI00000033>QT000000P3G?a`010000000eclL0=Lo7000000204U/d`03
00000019K=<0BFcC0080BFcC00<0e3dI04U/d`19K=<00P19K=<01@000000BFcC04U/d`19K=<00000
00@0BFcC00H000000=@m6@3D?AT0e3dI0000003D?AT800000080B6W>00<0000004QYcP18JLh00`18
JLh00`000000B6W>0=@m6@0304QYcP0300000018JLh0B6W>00@0B6W>00L0000004QYcP18JLh0B6W>
0=@m6@18JLh0000000H0B6W>1@3D?AT204QYcP80000000@0oeDS03eIZ`3oDb8000000P3oDb860000
00P0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0;0?ofkP040000003om^h0ooK^03eIZ`H0ooK^00<0
?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00T0ooK^200m
FJ/30?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h07@3om^h00`000000ooK^0?of
kP0^0?ofkP40oooo001?0?ofkP8000001@3om^h0100mFJ/0ooK^0?ofkP0mFJ/;0?ofkPT0?EV[0`3o
m^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0403eIZ`3om^h0ooK^0?ofkPH0?EV[2P3om^h00`0mFJ/0ooK^
0?ofkP050?ofkP<0e3dI00@0000003eIZ`0i40P000000P0i40P00`000000BaH;04/F2`0204/F2`03
0000001;5P/000000080KR4@00<0000006hQ401^8A000`1^8A001`000000T2/C090[4`2@:a<0?EV[
090[4`0000001P0mFJ/00`3D?AT0[3<G0:`c5`030:`c5`050000002/<aL0[3<G0:`c5`0000001033
>QT00`0mFJ/0`cXI0<<j6@020<<j6@0400000033>QT0`cXI000000<0eclL00@000000=Lo703G?a`0
00000`19K=<01P000000BFcC04U/d`3D?AT0BFcC000000<0BFcC00D0000004U/d`19K=<0BFcC0000
000404U/d`0400000019K=<0BFcC04U/d`H0e3dI00@0BFcC00000019K=<0BFcC1@00000304QYcP03
0000003D?AT0B6W>0080B6W>00<0000004QYcP18JLh01018JLh00`000000B6W>04QYcP0204QYcP03
0=@m6@000000B6W>0080B6W>103D?AT404QYcP030=@m6@18JLh000000080oeDS00<0?EV[00000000
00000P3oDb86000000T0ooK^00@0?EV[0?ofkP3om^h0?EV[303om^h010000000ooK^0?ofkP0mFJ/6
0?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP0A
0?ofkPL0?EV[4P3om^h00`0mFJ/0ooK^0?ofkP0L0?ofkP030000003om^h0ooK^02l0ooK^0@3oool0
04h0ooK^0P0000060?ofkP0303eIZ`3om^h0?EV[01<0ooK^200mFJ/>0?ofkP0303eIZ`3om^h0ooK^
00@0ooK^00<0?EV[0?ofkP3om^h01`0mFJ/30?ofkP0303eIZ`3om^h0ooK^00D0ooK^0`3D?AT02000
0000?EV[03T@20000000>A080000001;5P/00000101;5P/00`000000KR4@06hQ400206hQ40030000
001^8A00KR4@0080KR4@0P0000000`2@:a<0?EV[090[4`02090[4`040000002@:a<0T2/C00000080
[3<G1P0mFJ/0102/<aL000000:`c5`2/<aL2000000<0`cXI00<0?EV[00000033>QT00P33>QT00`00
0000`cXI0<<j6@02000000<0eclL00@000000=Lo703G?a`000000P19K=<01P000000BFcC04U/d`3D
?AT0BFcC000000<0BFcC00<0000004U/d`19K=<00P19K=<01@000000BFcC04U/d`19K=<0000000<0
BFcC00<0e3dI04U/d`0000000`19K=<80=@m6@0304U/d`00000000000080000000D0e3dI04QYcP18
JLh0B6W>0000000604QYcP0600000018JLh0B6W>04QYcP3D?AT00000103D?AT204QYcP0300000018
JLh0B6W>0080B6W>00L0e3dI03eIZ`0mFJ/0?EV[0000003oEB<0?EV[00<0oe<R00D000000?mC8P00
000000000=@m6@08000000<0ooK^00@0?EV[0?ofkP3om^h0?EV[2`3om^h01@000000ooK^0?ofkP3o
m^h0?EV[00D0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3o
m^h0ooK^01@0ooK^00@0?EV[0?ofkP3om^h0ooK^1`0mFJ/:0?ofkP0303eIZ`3om^h0ooK^01`0ooK^
00<000000?ofkP3om^h0<03om^h10?ooo`00CP3om^h2000000H0ooK^00<0?EV[0?ofkP0mFJ/04`3o
m^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00H0?EV[203om^h00`0mFJ/0ooK^0?of
kP040?ofkP0303eIZ`3om^h0ooK^00L0ooK^1P0mFJ/40?ofkP@0e3dI00P0?EV[03T@200i40P00000
03T@20000000BaH;000000@0BaH;00<0000006hQ401^8A000`1^8A0010000000KR4@06hQ40000002
090[4`030000000mFJ/0T2/C00<0T2/C0P0000040:`c5`030000002/<aL0[3<G0080[3<G1P0mFJ/2
0000000403eIZ`33>QT0`cXI000000<0`cXI0P0000020=Lo70050000003G?a`0eclL0=Lo70000000
0P3G?a`01@000000BFcC04U/d`000000e3dI00<0BFcC00@0000004U/d`19K=<000001019K=<01@00
0000BFcC04U/d`19K=<0000000<0BFcC00<0e3dI00000019K=<00`19K=<00`000000BFcC04U/d`02
04U/d`0300000019K=<0BFcC01H0e3dI1018JLh2000000D0B6W>00@000000?mE8`00000000001P0m
FJ/0103oDb8000000000003oCAl20000000303eIZ`3om^h0ooK^00@0ooK^0`000000100mFJ/00000
0000000mFJ/:0?ofkP030000003om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0
ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0
ooK^0?ofkP090?ofkPL0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP0K0?ofkP030000003om^h0ooK^0340
ooK^0@3oool004h0ooK^0P0000060?ofkP@0?EV[4P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eI
Z`3om^h0ooK^00H0ooK^1P0mFJ/20?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h0
2`3om^h00`0mFJ/0ooK^0?ofkP0603eIZ`80e3dI00@0?EV[03T@200i40P0>A080P00000204/F2`04
0000001;5P/0BaH;04/F2`800000101^8A0010000000KR4@06hQ40000003090[4`0303eIZ`2@:a<0
T2/C00<0T2/C00<000000:`c5`2/<aL00`2/<aL2000000D0[3<G00<000000<<j6@33>QT01P0mFJ/0
1@000000`cXI0<<j6@33>QT0000000<0eclL00D000000=Lo703G?a`0eclL000000020=Lo70040000
0019K=<0BFcC0=@m6@<0BFcC00D0000004U/d`19K=<0BFcC0000000304U/d`0500000019K=<0BFcC
04U/d`0000000P19K=<00`3D?AT0BFcC0000000404U/d`0300000019K=<0BFcC0080BFcC00<00000
04U/d`19K=<00P19K=<00`000000e3dI04U/d`0204U/d`0400000019K=<0BFcC04U/d`P0000000<0
e3dI0000000000000`18JLh00`000000B6W>04QYcP0404QYcP030000003oEB<000000080oeDS00@0
00000?mC8P0mFJ/000000P3oDb8=03eIZ`<0ooK^00@0?EV[0?ofkP3om^h0?EV[1P0000040?ofkP03
0000003om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP090?ofkP03
03eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h0503om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP@0
?EV[703om^h00`000000ooK^0?ofkP0b0?ofkP40oooo001>0?ofkP8000001P3om^h0100mFJ/0ooK^
03eIZ`3om^h703eIZ`/0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0?0?ofkPH0?EV[0P3om^h00`0m
FJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00<0ooK^0`3D?AT403eIZ`80>A0800D0000004/F
2`1;5P/0BaH;0000000204/F2`040000001^8A00KR4@000000@0KR4@0P000003090[4`0403eIZ`2@
:a<00000000000<0T2/C0P0000060:`c5`070000002/<aL0[3<G0:`c5`000000`cXI000000030<<j
6@0403eIZ`000000`cXI0<<j6@H0?EV[0`3G?a`01`000000eclL0=Lo703G?a`000000=Lo70000000
0P19K=<00`3D?AT0BFcC04U/d`0204U/d`0400000019K=<0BFcC000000<0BFcC00<0000004U/d`19
K=<00P19K=<01@000000BFcC0=@m6@19K=<0000000@0BFcC00D0000004U/d`19K=<0BFcC00000004
04U/d`0300000019K=<0e3dI0080BFcC00<0000004U/d`19K=<01019K=<00`000000BFcC04U/d`02
04U/d`040000003D?AT0BFcC04U/d`D000000`18JLh2000000030?mE8`000000oeDS00<0000000<0
?EV[0000003oDb800`0000020?m=7`8000000P3om^h=03eIZ`H0ooK^100000050?ofkP0303eIZ`3o
m^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3o
m^h0ooK^01@0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP0J0?ofkP030000003o
m^h0ooK^0380ooK^0@3oool004h0ooK^0P0000060?ofkP80?EV[2@3om^h803eIZ`<0ooK^00D0?EV[
0?ofkP3om^h0ooK^03eIZ`0@0?ofkP0303eIZ`3om^h0ooK^0080ooK^1P0mFJ/:0?ofkP0303eIZ`3o
m^h0ooK^00<0ooK^1@3D?AT01@0mFJ/0e3dI03T@200i40P0000000@0BaH;00<0000004/F2`000000
0`1^8A000`000000KR4@06hQ400206hQ40050000002@:a<0T2/C090[4`0mFJ/00`2@:a<00`000000
T2/C000000020:`c5`8000001@2/<aL010000000[3<G0:`c5`0000020<<j6@80000000@0?EV[0<<j
6@33>QT000000`33>QT200000080eclL1P0mFJ/20=Lo70060000003G?a`0000004U/d`3D?AT00000
0`19K=<010000000BFcC04U/d`00000304U/d`0300000019K=<0BFcC0080BFcC00D000000=@m6@19
K=<0BFcC0000000304U/d`0300000019K=<0BFcC0080BFcC00<0000004U/d`19K=<00P19K=<00`00
0000e3dI04U/d`0204U/d`0300000019K=<0BFcC00<0BFcC00<0000004U/d`19K=<00P19K=<00`00
0000e3dI04U/d`0304U/d`0400000019K=<0BFcC04U/d`<0000000H0oeDS000000000000oeDS0000
003oEB<20000000503eIZ`3oDb8000000?mC8P0000000P3oCAl3000000X0ooK^2`0mFJ/30?ofkP03
0000003om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP03
03eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP03
03eIZ`3om^h0ooK^01X0ooK^00<000000?ofkP3om^h0<`3om^h10?ooo`00CP3om^h2000000H0ooK^
0P0mFJ/A0?ofkPP0?EV[403om^h00`0mFJ/0ooK^0?ofkP040?ofkP0403eIZ`3om^h0ooK^0?ofkPP0
?EV[0P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP<0e3dI00@0ooK^03eIZ`3om^h0e3dI0P0i40P20000
00<0BaH;0P00000406hQ40070000001^8A00KR4@06hQ40000000T2/C00000002090[4`0303eIZ`2@
:a<0T2/C0080T2/C0P0000040:`c5`030000002/<aL0[3<G00<0[3<G0P0000050<<j6@0403eIZ`33
>QT0`cXI0<<j6@8000000P33>QT01@000000eclL0=Lo703G?a`0000000<0eclL00<0000003eIZ`0m
FJ/00`0mFJ/30000000703eIZ`19K=<0BFcC04U/d`000000BFcC0000000304U/d`0300000019K=<0
BFcC0080BFcC00D000000=@m6@19K=<0BFcC0000000304U/d`0500000019K=<0BFcC04U/d`000000
1019K=<00`000000BFcC0=@m6@0204U/d`0300000019K=<0BFcC00<0BFcC00@0000004U/d`19K=<0
BFcC0P0000001@3D?AT0BFcC04U/d`19K=<0000000D0BFcC0P0000001@3oEB<000000?mE8`3oEB<0
00000080oeDS00H000000?mC8P0mFJ/000000?mC8P0000020?m=7`<00000303om^h00`0mFJ/0ooK^
03eIZ`020?ofkP/0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00X0ooK^
00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^01<0ooK^
00<0?EV[0?ofkP3om^h06@3om^h00`000000ooK^0?ofkP0d0?ofkP40oooo001=0?ofkP8000001P3o
m^h00`0mFJ/0ooK^03eIZ`0203eIZa80ooK^00@0?EV[0?ofkP3om^h0ooK^1`0mFJ/:0?ofkP0303eI
Z`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h02@3om^h803eIZ`80e3dI0P3om^h01`0mFJ/0e3dI
0000000i40P0000004/F2`000000101;5P/00`000000KR4@06hQ400306hQ40040000001^8A00KR4@
00000080T2/C00<0000003eIZ`2@:a<01@2@:a<00`000000[3<G0:`c5`030:`c5`030000002/<aL0
[3<G00<0[3<G00<000000<<j6@33>QT00`33>QT00`0mFJ/000000<<j6@030<<j6@80000000<0eclL
0000003G?a`00P3G?a`01@000000eclL0=Lo703G?a`000000080eclL0P0000000`3XAAd000000000
00060000000304U/d`000000?EV[0080BFcC00D0000004U/d`19K=<0BFcC0=@m6@0304U/d`050000
0019K=<0BFcC04U/d`0000000`19K=<01`000000BFcC04U/d`19K=<0000004U/d`3D?AT00P19K=<0
0`000000BFcC04U/d`0304U/d`0500000019K=<0BFcC04U/d`0000000P19K=<0103D?AT0BFcC0000
0000000404U/d`80000000@0oe@S000000000000oeDS0P0000001`3oEB<000000000003oDb80?EV[
0000003oDb800P000000103oCAl000000?m=7`00000=0?ofkP80?EV[203om^h<03eIZ`80ooK^00<0
?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^01@0ooK^00<0
?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP0H0?ofkP030000003om^h0ooK^03D0ooK^0@3o
ool004d0ooK^0P0000060?ofkP0303eIZ`3om^h0?EV[0080ooK^1P0mFJ/<0?ofkP0503eIZ`3om^h0
ooK^0?ofkP0mFJ/01P3om^h703eIZ`<0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?of
kP0<0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0e3dI03eIZ`0mFJ/01P0mFJ/010000000BaH;04/F
2`00000304/F2`8000001@1^8A02000000@0T2/C00<0?EV[090[4`2@:a<0102@:a<2000000D0[3<G
00<000000:`c5`2/<aL00P2/<aL300000080`cXI00@0?EV[0<<j6@33>QT000001033>QT00`000000
eclL0=Lo700200000080eclL0P0000020=Lo70040000003G?a`0eclL00000080j4DM00<0000004Y^
e`000000101:K]L300000080BFcC00D0000004U/d`19K=<0BFcC0=@m6@0204U/d`0300000019K=<0
BFcC0080BFcC00@0000004U/d`19K=<000001019K=<01@000000BFcC0=@m6@19K=<0000000@0BFcC
0P00000304U/d`0600000019K=<0BFcC0=@m6@19K=<000001@19K=<010000000oe@S0?mD8`000002
0?mE8`050000003oEB<000000000003oEB<00P0000001`0mFJ/00000000000000000oddO0000003o
CAl00P00000=0?ofkP80?EV[2`3om^h00`000000ooK^0?ofkP0503eIZ`030?ofkP0mFJ/0?EV[00@0
?EV[2@3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3o
m^h04`3om^h00`0mFJ/0ooK^0?ofkP0H0?ofkP030000003om^h0ooK^03H0ooK^0@3oool004d0ooK^
0P0000060?ofkP0303eIZ`3om^h0?EV[00P0ooK^1P0mFJ/60?ofkP0403eIZ`3om^h0ooK^03eIZ`h0
ooK^1`0mFJ/20?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h00P3om^h20=@m6@<0
ooK^00@0?EV[0=@m6@3om^h00000200mFJ/00`1^8A00000006hQ400406hQ40030000002@:a<0T2/C
0080T2/C00<0?EV[0000000000000`2@:a<00`000000[3<G0:`c5`02000000@0[3<G0P0000000`2/
<aL000000<<j6@020<<j6@0300000033>QT0?EV[00<0`cXI0P0000020<<j6@8000000`3G?a`01@00
0000eclL0=Lo703G?a`000000080eclL0P000000103XAAd000000>Q57@00000304Y^e`030=@m6@1:
K]L0000000<0BVkG1@0000001@3D?AT0000000000019K=<0000000<0BFcC00D0000004U/d`19K=<0
BFcC0000000304U/d`0500000019K=<0e3dI04U/d`0000001019K=<00`000000BFcC04U/d`0204U/
d`0600000019K=<0BFcC04U/d`3D?AT000001019K=<2000000080?mD8`00000000000000003oEB<0
00000?mE8`0000020?mE8`80000000@0?EV[0000003oDb80oe<R0P0000000`3oCAl000000000000>
0?ofkP80?EV[2`3om^h00`000000ooK^0?ofkP030?ofkP0303eIZ`3om^h0?EV[00D0?EV[00<0ooK^
03eIZ`0mFJ/0100mFJ/30?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h04`3om^h0
0`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^01L0ooK^00<000000?ofkP3om^h0=`3om^h1
0?ooo`00C@3om^h2000000H0ooK^100mFJ/=0?ofkPH0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP0?0?of
kP0403eIZ`3om^h0ooK^0?ofkPL0?EV[2P3om^h0100mFJ/0ooK^0?ofkP3om^h30=@m6@80ooK^00D0
?EV[0=@m6@3om^h0ooK^0000000404/F2`040000001;5P/0000006hQ40P0?EV[00@00000090[4`2@
:a<0?EV[0`2@:a<010000000T2/C090[4`0000040:`c5`030000002/<aL0[3<G00<0[3<G0P000004
0<<j6@030000000mFJ/0`cXI00@0`cXI0P0000020=Lo708000000P3G?a`01@000000eclL0=Lo703G
?a`000000080eclL00T000000>Q57@3XAAd000000>Q57@000000BVkG0000001:K]L00`3D?AT01@1:
K]L0000004Y^e`1:K]L000000080BVkG00<0e3dI0000001:K]L01`0000000`19K=<0000003eIZ`03
04U/d`0500000019K=<0e3dI04U/d`0000000`19K=<00`000000BFcC04U/d`0204U/d`0600000019
K=<0BFcC04U/d`3D?AT000000`19K=<2000000040?mD8`00000000000?mD8`D000000`3oEB<00`00
0000oe<R03eIZ`020?mC8P80000000@0oddO00000000000000003P3om^h00`0mFJ/0ooK^0?ofkP0;
0?ofkP030000003om^h0ooK^0080ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`030?ofkP/0?EV[203o
m^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h05`3o
m^h00`000000ooK^0?ofkP0g0?ofkP40oooo001=0?ofkP8000001P3om^h203eIZ`80ooK^1`0mFJ/;
0?ofkPP0?EV[3P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^0080ooK^1`0mFJ/3
0?ofkP0403eIZ`3om^h0ooK^0?ofkP<0e3dI0P3om^h00`0mFJ/0e3dI0?ofkP020?ofkP040000001;
5P/0BaH;04/F2`8000001@1^8A001@000000KR4@06hQ401^8A00000000H0?EV[0P2@:a<2000000H0
[3<G00<000000:`c5`2/<aL00`2/<aL00`000000`cXI0<<j6@020<<j6@0303eIZ`000000000000D0
`cXI00<000000=Lo703G?a`00P3G?a`010000000eclL0=Lo700000030=Lo7080000000T0j4DM0000
000mFJ/0j4DM0000003XAAd0000004Y^e`0000000P1:K]L00`000000e3dI0=@m6@020=@m6@050000
001:K]L0e3dI04Y^e`0000000P1:K]L01P000000BVkG04Y^e`1:K]L0000004Y^e`L0000000<0e3dI
04U/d`0000000`19K=<010000000BFcC04U/d`19K=<2000000<0BFcC00<000000=@m6@19K=<00P19
K=<010000000oe@S0000000000030?mD8`<000000`3oEB<40000000503eIZ`3oDb80oe<R0000003o
CAl00`00000?0?ofkP80?EV[303om^h00`000000ooK^0?ofkP020?ofkP0403eIZ`3om^h0ooK^03eI
Z`/0ooK^200mFJ/30?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0m
FJ/0ooK^0?ofkP0G0?ofkP030000003om^h0ooK^03P0ooK^0@3oool004d0ooK^0P0000060?ofkP80
?EV[2@3om^h803eIZ`<0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`030?ofkPP0?EV[1P3om^h00`0m
FJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00X0ooK^1`0mFJ/30=@m6@80ooK^00<0?EV[0=@m
6@3om^h00P3om^h00`000000BaH;04/F2`0204/F2`030000001^8A00KR4@00@0KR4@00<0000006hQ
400000000`2@:a<010000000?EV[090[4`2@:a<603eIZ`D0[3<G0P0000020:`c5`0400000033>QT0
000000000080`cXI00@0?EV[0<<j6@33>QT000000`33>QT010000000eclL0000000000030=Lo7003
0000003G?a`0eclL008000000P3G?a`010000000j4DM0>Q57@0mFJ/20>Q57@070000003XAAd00000
04Y^e`000000BVkG0000000204Y^e`030000001:K]L0e3dI00@0e3dI0P1:K]L010000000BVkG04Y^
e`00000604Y^e`040000001:K]L0BVkG0=@m6@H000000P19K=<010000000BFcC04U/d`19K=<20000
00030=@m6@19K=<0BFcC0080000000<0oe@S0000003oE2<00P3oE2<3000000<0oeDS0P0000001@3o
EB<000000?mC8P0mFJ/0oe<R00@0000000<0oddO0000003om^h03P3om^h00`0mFJ/0ooK^03eIZ`0<
0?ofkP030000003om^h0ooK^0080ooK^00@0?EV[0?ofkP3om^h0?EV[3P3om^h00`0mFJ/0ooK^0?of
kP020?ofkPL0?EV[4P3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^01H0ooK^00<0
00000?ofkP3om^h0>@3om^h10?ooo`00C@3om^h00`000000ooK^0?ofkP050?ofkPD0?EV[3P3om^h7
03eIZ``0ooK^200mFJ/30?ofkP0303eIZ`3om^h0ooK^00d0ooK^00@0?EV[0?ofkP3om^h0e3dI200m
FJ/30?ofkP040000001;5P/0BaH;04/F2`8000001P1^8A02000000<0T2/C00<0?EV[000000000000
0`2@:a<010000000[3<G00000000000603eIZ`040:`c5`000000[3<G000000<0`cXI0P000000100m
FJ/0`cXI0<<j6@33>QT2000000030<<j6@000000eclL0080eclL00D000000=Lo703G?a`0eclL0000
00030=Lo7080000000L0j4DM0000003XAAd0?EV[0000003XAAd000000080j4DM0P00000204Y^e`03
0000001:K]L000000080BVkG00@0e3dI04Y^e`1:K]L000001@3D?AT010000000BVkG04Y^e`000002
04Y^e`050000001:K]L0BVkG0=@m6@0000000`1:K]L00`000000BVkG04Y^e`060000000303eIZ`19
K=<0BFcC0080000000<0oe@S0000000000000P3oE2<3000000<0oeDS0P0000020?mE8`040000003o
Db80oe<R03eIZ`<000000P3oCAl2000000l0ooK^00<0?EV[0?ofkP0mFJ/0303om^h00`000000ooK^
0?ofkP020?ofkP0403eIZ`3om^h0ooK^03eIZ`h0ooK^00<0?EV[0?ofkP3om^h01@3om^h0100mFJ/0
ooK^0?ofkP3om^h703eIZ`/0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP0E0?of
kP030000003om^h0ooK^03X0ooK^0@3oool004`0ooK^0P0000070?ofkP<0?EV[0P3om^h803eIZ`T0
ooK^00<0?EV[0?ofkP3om^h0200mFJ/;0?ofkP0303eIZ`3om^h0?EV[00H0?EV[303om^h00`0mFJ/0
ooK^0?ofkP020=@m6@070?ofkP3D?AT0ooK^03eIZ`3D?AT0ooK^0=@m6@0503eIZ`80BaH;00<00000
06hQ400000001P1^8A001@000000T2/C090[4`2@:a<0?EV[0080T2/C00@00000090[4`2@:a<00000
0`2/<aL2000000@0[3<G1P0mFJ/20<<j6@0303eIZ`000000`cXI00@0`cXI00<000000=Lo703G?a`0
0`3G?a`200000080eclL0P0000020=Lo70090000003XAAd0j4DM03eIZ`000000j4DM0000003XAAd0
00000080j4DM0P000000101:K]L0000004Y^e`00000204Y^e`040=@m6@1:K]L0BVkG00000080BVkG
00<0000004Y^e`0000001P3D?AT010000000BVkG04Y^e`3D?AT204Y^e`030000001:K]L0e3dI00@0
e3dI00<0BVkG0000000000000P1:K]L2000000030?mD8`000000?EV[00D0?EV[00<0oe@S0000003o
EB<00P0000020?mE8`8000000P3oDb8010000000?EV[0?mC8P0000020?m=7`8000000`0mFJ/=0?of
kP0303eIZ`3om^h0?EV[00`0ooK^00<000000?ofkP3om^h00P3om^h00`0mFJ/0ooK^03eIZ`0?0?of
kP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h02@3om^h703eIZ`<0ooK^00<0?EV[0?of
kP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP0E0?ofkP030000003om^h0ooK^03/0ooK^0@3oool004`0
ooK^0P0000070?ofkP0303eIZ`3om^h0ooK^00H0?EV[103om^h803eIZ`040?ofkP0mFJ/0ooK^03eI
Z`P0ooK^200mFJ/30?ofkP0303eIZ`3om^h0ooK^0080ooK^00@0?EV[0?ofkP3om^h0ooK^200mFJ/4
0?ofkP0303eIZ`3om^h0ooK^0080e3dI00L0ooK^0=@m6@3om^h0?EV[0=@m6@3om^h0e3dI00@0ooK^
00<0e3dI0000000000000`1^8A000`000000KR4@06hQ400306hQ408000000P2@:a<0100mFJ/0T2/C
090[4`2@:a<2000000H0[3<G00<000000:`c5`2/<aL00`2/<aL3000000030<<j6@0mFJ/0?EV[00@0
?EV[0`33>QT3000000D0eclL0P0000020=Lo7080000000L0j4DM0000003XAAd0?EV[0>Q57@000000
j4DM00<0000000X0j4DM0000001:K]L0000004Y^e`000000BVkG0000003D?AT000000P1:K]L00`00
0000BVkG0000000204Y^e`040000001:K]L0BVkG00000080BVkG00<000000=@m6@3D?AT01P3D?AT0
101:K]L0000004Y^e`1:K]L2000000<0BVkG100000020?mD8`<000000P3oE2<803eIZ`060000003o
Db80000003eIZ`3oDb8000000P3oCAl3000000<0ooK^1P0mFJ/60?ofkP0403eIZ`3om^h0ooK^03eI
Z``0ooK^00<000000?ofkP3om^h00P3om^h00`0mFJ/0ooK^03eIZ`0?0?ofkP0303eIZ`3om^h0ooK^
00@0ooK^00<0?EV[0?ofkP3om^h0403om^h703eIZa80ooK^00<0?EV[0?ofkP3om^h0503om^h00`00
0000ooK^0?ofkP0l0?ofkP40oooo001<0?ofkP8000001`3om^h403eIZ`D0ooK^1@0mFJ/70?ofkPH0
?EV[3P3om^h803eIZ``0ooK^200mFJ/01@3D?AT0ooK^0?ofkP0mFJ/0e3dI00<0ooK^00D0e3dI0?of
kP3om^h0ooK^0=@m6@02000000@0KR4@00D0000006hQ401^8A00KR4@00000002090[4`030000000m
FJ/0T2/C00@0T2/C00<000000:`c5`2/<aL01@2/<aL200000080[3<G00@000000<<j6@33>QT0`cXI
0P0000000`33>QT0?EV[0<<j6@020<<j6@P0?EV[1@3G?a`010000000eclL0=Lo700000030>Q57@03
03eIZ`3XAAd0j4DM0080000000H0j4DM000000000000j4DM0000001:K]L20000000;04Y^e`000000
e3dI04Y^e`000000BVkG0000001:K]L0000004Y^e`0000000P1:K]L010000000BVkG04Y^e`000002
04Y^e`040=@m6@1:K]L0000000000080BVkG0P0000000`1:K]L000000000000304Y^e`040000003o
DB80oe4R00000080oe@S0`0000030?mD8`8000000P3oEB<200000080oeDS00<0000003eIZ`0mFJ/0
1@0mFJ/30000000303eIZ`3om^h0ooK^00L0ooK^1`0mFJ/20?ofkP0303eIZ`3om^h0ooK^00X0ooK^
00<000000?ofkP3om^h00P3om^h203eIZa00ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^
0?ofkP0C0?ofkP0403eIZ`3om^h0ooK^0?ofkPL0?EV[2`3om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP03
0000003om^h0ooK^03`0ooK^0@3oool004`0ooK^0P00000;0?ofkPP0?EV[0P3om^h603eIZ`80ooK^
00<0?EV[0?ofkP0mFJ/00P3om^h603eIZ`/0ooK^00@0?EV[0?ofkP3om^h0ooK^1`0mFJ/:0?ofkP04
03eIZ`3om^h0e3dI0=@m6@L0?EV[00D0ooK^0=@m6@3om^h0ooK^0=@m6@020?ofkP030000001^8A00
KR4@00<0KR4@00@0000006hQ401^8A0000000`2@:a<00`0mFJ/00000090[4`03090[4`<000001`2/
<aL3000000D0`cXI00<0?EV[00000033>QT01033>QT00`000000eclL0=Lo70030=Lo70P0?EV[0`00
0000100mFJ/0j4DM0000000000020>Q57@050000003XAAd000000000003XAAd00P000000301:K]L0
00000=@m6@000000BVkG0000001:K]L0000004Y^e`000000BVkG00000080BVkG00<0000004Y^e`00
00000P1:K]L00`000000e3dI0000000304Y^e`040000001:K]L0BVkG00000080BVkG0P0000001@3o
DB80?EV[000000000000oe@S00<000000`3oE2<3000000030?mE8`000000000000<0oeDS0P000002
0?mC8P050000000mFJ/000000000003oCAl01`0mFJ/<0?ofkPH0?EV[2P3om^h00`000000ooK^0?of
kP020?ofkP80?EV[403om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0
?EV[0?ofkP3om^h02@3om^h703eIZ`<0ooK^00<0?EV[0?ofkP3om^h0503om^h00`000000ooK^0?of
kP0m0?ofkP40oooo001<0?ofkP8000004`3om^h>03eIZ`L0ooK^1P0mFJ/50?ofkP0503eIZ`3om^h0
ooK^0?ofkP0mFJ/01P3om^h703eIZ`<0ooK^00@0?EV[0?ofkP3D?AT0e3dI0`3om^h0100mFJ/0e3dI
0?ofkP3om^h803eIZ`030000001^8A00KR4@00<0KR4@0P000004090[4`0303eIZ`2@:a<000000080
T2/C00@000000:`c5`2/<aL0[3<G0P0000070:`c5`0300000033>QT0`cXI00<0`cXI00@0?EV[0<<j
6@00000000000`33>QT010000000eclL0000000000040=Lo70800000103G?a`703eIZ`80000000<0
j4DM0000003XAAd00P0000000`3hBAl00000000000050000000304Y^e`000000BVkG008000000P1:
K]L020000000BVkG04Y^e`000000BVkG0000003D?AT000000P1:K]L20000000404Y^e`0000000000
04Y^e`80000000D0oe4R000000000000?EV[0?mA8P0300000080oe@S0`0000020?mD8`8000000`3o
EB<3000000040?mC8P000000000003eIZ`80000000H0oddO0=@m6@00000000000?ofkP0mFJ/30?of
kPP0?EV[0`3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[0080ooK^1P0mFJ/40?ofkP030000003om^h0
ooK^0080ooK^0P0mFJ/@0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h04`3om^h0
0`0mFJ/0ooK^0?ofkP0@0?ofkP@0?EV[5@3om^h00`000000ooK^0?ofkP0n0?ofkP40oooo001<0?of
kP030000003om^h0ooK^01X0ooK^3@0mFJ/60?ofkPH0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP0<0?of
kPL0?EV[0P3om^h00`0mFJ/0e3dI0=@m6@040?ofkP030=@m6@3om^h0e3dI00<0ooK^200mFJ/3090[
4`0403eIZ`2@:a<0T2/C090[4`<000001@2/<aL2000000@0[3<G00<000000<<j6@33>QT00`000000
0`33>QT0?EV[0<<j6@020<<j6@<00000103G?a`2000000@0eclL0P0000001`3G?a`000000>Q57@3X
AAd0000003eIZ`3XAAd00P00000603eIZ`80000000<0n4TO0000000000000P0000000`1:KmX00000
0000000400000080BVkG00@0000004Y^e`000000BVkG0P0000001@3D?AT0BVkG04Y^e`000000BVkG
0080000000<0BVkG0000000000000P0000020?mA8P0503eIZ`00000000000000003oE2<00`000003
0?mD8`8000000`3oEB<200000080oeDS0P0000020?mC8P0403eIZ`000000oddO0?m=7`8000000P3o
m^h00`0mFJ/0ooK^0?ofkP090?ofkPH0?EV[00<0ooK^03eIZ`3om^h01`3om^h603eIZ`<0ooK^00<0
?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^01@0ooK^00<0
?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP030000003om^h0ooK^03l0ooK^0@3o
ool004/0ooK^0P00000S0?ofkPh0?EV[0`3om^h703eIZ`h0ooK^00@0?EV[0?ofkP3D?AT0e3dI1`0m
FJ/20?ofkP030=@m6@3om^h0e3dI00D0ooK^00H0?EV[06hQ401^8A00KR4@0000002@:a<603eIZ`<0
T2/C00<000000:`c5`2/<aL01@2/<aL200000080[3<G00<000000<<j6@33>QT00`33>QT00`0mFJ/0
00000<<j6@040<<j6@030000003G?a`0eclL00@0eclL0`0000030=Lo708000000P3XAAd01@0mFJ/0
j4DM000000000000j4DM0080000000@0j4DM000000000000j4DM0`000000103hBAl000000000001:
KmX20000000304Y_fP000000BVoJ00T0000000<0BVkG0=@m6@0000000`0000000`1:K]L000000000
0002000000070?mA8P00000000000000000mFJ/000000?mD8`02000000<0oe@S100000020?mE8`80
00000P3oEB<2000000<0oe<R00@0?EV[0000003oCAl0oddO0`0000030?ofkP0303eIZ`3om^h0ooK^
00/0ooK^00<0?EV[0?ofkP3om^h01@0mFJ/90?ofkP030000003om^h0?EV[00L0?EV[3@3om^h00`0m
FJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0m
FJ/0ooK^0?ofkP0B0?ofkP030000003om^h0ooK^0400ooK^0@3oool004/0ooK^0P00000Z0?ofkPh0
?EV[0`3om^h803eIZ`H0ooK^00@0?EV[0=@m6@3D?AT0e3dI0P3om^h00`0mFJ/0e3dI0?ofkP020?of
kPL0?EV[0`3om^h01@0mFJ/0000006hQ401^8A00000000<0T2/C00@0?EV[090[4`2@:a<0T2/C1P0m
FJ/70:`c5`8000001P33>QT00`0mFJ/0`cXI00000002000000040<<j6@000000eclL0=Lo70<00000
1@3G?a`2000000060=Lo70000000j4DM0>Q57@000000?EV[0`3XAAd2000000060>Q57@0000000000
0>Q57@000000n4TO0`0000001@3hBAl00000000000000000BVoJ00@0000000D0BVoJ0000001:KmX0
000004Y_fP020000000304Y_fP000000000000H0000000<0oe4R0000000000000P0000000`3oDB80
?EV[0000000200000080oe@S0`0000030?mD8`<000000P3oEB<3000000<0oe<R00<0000003eIZ`00
0000100000040?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h00P3om^h0100mFJ/0
ooK^0?ofkP3om^h603eIZ`<0ooK^00<000000?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP020?of
kPT0?EV[103om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?of
kP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP030000003om^h0ooK^0440ooK^0@3oool004/0
ooK^0P00000b0?ofkPd0?EV[103om^h803eIZ`80e3dI00@0ooK^03eIZ`3om^h0e3dI1P3om^h0103D
?AT0ooK^0?ofkP3om^h503eIZ`030=@m6@000000T2/C00<0T2/C00<0?EV[0000000000000`2@:a<0
10000000[3<G0:`c5`2/<aL603eIZ`80[3<G00<000000<<j6@0000000P0000020<<j6@0303eIZ`33
>QT0`cXI0080`cXI0P0000050=Lo70<00000103G?a`200000080j4DM00<0?EV[0>Q57@3XAAd00P00
00001@3D?AT0j4DM000000000000j4DM00@0000000<0n4TO000000000000200000000`1:KmX00000
0000000200000080BVoJ300000001P3oDB8000000000000mFJ/000000?mD8`<00000103oE2<30000
00040?mE8`000000000000000080oeDS00D000000?mC8P000000000003eIZ`02000000030=@m6@00
0000000000D0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3o
m^h0ooK^00L0ooK^1@0mFJ/20?ofkP80?EV[3@3om^h503eIZ`<0ooK^00<0?EV[0?ofkP3om^h04`3o
m^h00`0mFJ/0ooK^0?ofkP0D0?ofkP0303eIZ`3om^h0ooK^0140ooK^00<000000?ofkP3om^h0@@3o
m^h10?ooo`00B`3om^h2000003T0ooK^3P0mFJ/30?ofkPP0?EV[1@3om^h00`3D?AT0ooK^0?ofkP04
0?ofkP0403eIZ`3om^h0?EV[000000<0T2/C00@0?EV[090[4`2@:a<0T2/C0`0000060:`c5`800000
0P2/<aL603eIZ`040<<j6@000000?EV[000000D0`cXI00<000000=Lo700000000`0000030=Lo70<0
000000H0eclL0000003XAAd0j4DM0000000mFJ/2000000<0j4DM0P0000001@3D?AT0000000000000
0000n4TO00/0000000<0BVoJ0000000000000P0000000`1:KmX000000000000=000000030?mA8P0m
FJ/00000008000000`3oE2<5000000030?mE8`000000000000@0oeDS0`0000020?mC8P0303eIZ`00
0000oddO00<000001@3om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0
?EV[0?ofkP3om^h02P3om^h00`000000?EV[03eIZ`0403eIZ`l0ooK^00D0?EV[0?ofkP3om^h0ooK^
03eIZ`0E0?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h04@3om^h00`000000ooK^
0?ofkP120?ofkP40oooo001;0?ofkP800000@@3om^h=03eIZ`040?ofkP3D?AT0ooK^0=@m6@L0?EV[
1P3om^h00`0mFJ/0ooK^0=@m6@0200000003090[4`0mFJ/0T2/C00@0T2/C00<000000:`c5`2/<aL0
1P2/<aL2000000030:`c5`000000`cXI00<0`cXI1P0mFJ/00`000000`cXI000000060=Lo70@00000
0P3G?a`200000080j4DM00@0?EV[0>Q57@3XAAd0j4DM100000020>Q57Ah000002P0mFJ/4000000<0
oe@S0`0000050?mE8`8000000`3oDb801P000000?EV[0?m=7`000000e3dI00000080?EV[103om^h0
0`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h02P3om^h0
1`000000ooK^0?ofkP0mFJ/0ooK^03eIZ`3om^h01`0mFJ/80?ofkP0503eIZ`3om^h0ooK^0?ofkP0m
FJ/05@3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^0100ooK^00<000000?ofkP3o
m^h0@`3om^h10?ooo`00B`3om^h00`000000ooK^0?ofkP180?ofkP`0?EV[00@0ooK^0=@m6@3om^h0
e3dI200mFJ/01@3D?AT0ooK^0?ofkP0mFJ/0000000D0T2/C00<000000:`c5`0000000P0000060:`c
5`8000001@33>QT00`0mFJ/0`cXI0<<j6@020<<j6@L0?EV[1P3G?a`3000000<0j4DM00<0?EV[0000
00000000100000000`3XAAd000000000000Q000000<0oe4R00@0000003eIZ`00000000001P0mFJ/2
000000@0oeDS100000020?mC8P80000000@0?EV[000000000000oddO0P0000020?ofkPP0?EV[1`3o
m^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<000000?ofkP0mFJ/00P3o
m^h00`0mFJ/0ooK^0?ofkP060?ofkPT0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3o
m^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h0403om^h00`000000ooK^0?ofkP140?ofkP40oooo001:
0?ofkP800000B`3om^h01P3D?AT0ooK^0=@m6@3om^h0e3dI0?ofkPd0?EV[0`3om^h803eIZ`80T2/C
00<000000:`c5`2/<aL00`2/<aL2000000D0[3<G00<000000<<j6@0000000P0000000`0mFJ/0`cXI
0<<j6@050<<j6@030000003G?a`0eclL00800000200mFJ/30>Q57@0303eIZ`000000000000@00000
00<0j4DM0000000000007P0000000`3oDB800000000000040000000303eIZ`000000oe@S00@00000
0`3oE2<503eIZ`040000003oEB<0oeDS0?mE8`<000000P3oDb800`0mFJ/0oddO0?m=7`02000000L0
ooK^00@0?EV[0?ofkP3om^h0ooK^1P0mFJ/00`3om^h0?EV[0?ofkP060?ofkP0303eIZ`3om^h0ooK^
00X0ooK^00<000000?ofkP0mFJ/00P3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkPL0?EV[4P3om^h00`0m
FJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<000000?ofkP3om^h0A@3om^h10?oo
o`00BP3om^h2000004X0ooK^0P3D?AT0103om^h0e3dI0?ofkP3D?AT20?ofkP030=@m6@3om^h0ooK^
0080ooK^00<0e3dI03eIZ`0mFJ/03@0mFJ/20?ofkPL0?EV[0`2/<aL3000000030:`c5`000000`cXI
00@0`cXI00<0?EV[0000000000000P0000020<<j6@030000003G?a`0eclL00L0eclL1000000703eI
Z`<0j4DM8P0000020?mA8P@0000000<0?EV[0000000000001@3oE2<4000000<0oeDS1P0mFJ/20?mC
8P0503eIZ`3oCAl0oddO0=@m6@000000203om^h00`0mFJ/0ooK^0?ofkP070?ofkPH0?EV[0`3om^h0
0`0mFJ/0ooK^0?ofkP0:0?ofkP030000000mFJ/0ooK^0080ooK^00<0?EV[0?ofkP3om^h03`3om^h2
03eIZ`@0ooK^1`0mFJ/;0?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h03P3om^h0
0`000000ooK^0?ofkP160?ofkP40oooo001:0?ofkP800000BP3om^h00`3D?AT0ooK^0?ofkP020=@m
6@@0ooK^00@0e3dI0?ofkP3om^h0e3dI0`3om^h00`3D?AT0ooK^0?ofkP030?ofkPh0?EV[0P2/<aL8
03eIZ`@0`cXI00<0?EV[0<<j6@33>QT00`33>QT9000000H0eclL00@000000>Q57@3XAAd0?EV[0`3X
AAd00`000000?EV[03eIZ`0403eIZb4000000`3oDB80100mFJ/000000?mD8`3oE2<500000080oe@S
00@000000?mE8`3oEB<0oeDS100000030?mC8PH0?EV[00<000000?ofkP3om^h01`3om^h00`0mFJ/0
ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00<0ooK^1`0mFJ/90?ofkP030000000mFJ/0ooK^0080
ooK^00<0?EV[0?ofkP3om^h03`3om^h203eIZ`/0ooK^1`0mFJ/30?ofkP0303eIZ`3om^h0ooK^01<0
ooK^00<0?EV[0?ofkP3om^h03`3om^h00`000000ooK^0?ofkP160?ofkP40oooo001:0?ofkP800000
BP3om^h00`3D?AT0ooK^0?ofkP020=@m6@@0ooK^00@0e3dI0?ofkP3om^h0e3dI103om^h00`3D?AT0
ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI03eIZ`0mFJ/01P0mFJ/00`3D?AT0
[3<G0:`c5`040:`c5`0300000033>QT0?EV[00D0?EV[0P0000030<<j6@030000003G?a`0eclL00D0
eclL2@0000000`0mFJ/000000000000/0000000403eIZ`0000000000000000H0oe@S00<000000?mE
8`0000000P0000030?mE8`070000003oDb8000000000003oDb80?EV[0?m=7`03000000L0?EV[0`3o
m^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00H0ooK^00@0?EV[0?ofkP3om^h0ooK^
1P0mFJ/30?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^
0?ofkP0A0?ofkPL0?EV[4P3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP030000003om^h0ooK^04L0ooK^
0@3oool004X0ooK^0P00001:0?ofkP040=@m6@3om^h0ooK^0=@m6@D0ooK^00<0e3dI0?ofkP3D?AT0
1@3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h0
103om^h703eIZ`040:`c5`000000`cXI0<<j6@80?EV[0`33>QT603eIZ`H000001P3G?a`010000000
j4DM03eIZ`0mFJ/40>Q57@l0000000<0B6kH000000000000300000000`3oCR400000000000020000
00<0oe4R100000000`0mFJ/000000000000:000000D0oeDS0`0000020?mC8P040000000mFJ/00000
0?m=7`8000001`3om^h803eIZ`<0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP07
0?ofkPH0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[
0?ofkP3om^h00P3om^h703eIZ`/0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`000000ooK^0?ofkP18
0?ofkP40oooo001:0?ofkP030000003om^h0ooK^04T0ooK^00@0e3dI0?ofkP3om^h0e3dI1@3om^h0
0`3D?AT0ooK^0=@m6@060?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT01P3om^h00`3D?AT0ooK^0?of
kP040?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0000003eIZ`0mFJ/0100mFJ/70<<j6@030000003G
?a`0?EV[00D0?EV[3P0000030>Q57@X0000000<0B6kH0000000000000P0000000`18K]P000000000
00020000000304Q^f0000000000000L000000P3oDB8500000080oe4R00<0?EV[0?mD8`3oE2<01`3o
E2<010000000oeDS0?mE8`3oEB<5000000<0oe<R00@0000003eIZ`3oCAl0e3dI0P00000;0?ofkP03
03eIZ`3om^h0ooK^0080ooK^1`0mFJ/70?ofkP0303eIZ`3om^h0ooK^00P0ooK^00@0?EV[0000003o
m^h0ooK^1P0mFJ/=0?ofkP80?EV[5@3om^h00`0mFJ/0ooK^0?ofkP090?ofkPL0?EV[0`3om^h00`0m
FJ/0ooK^0?ofkP0=0?ofkP030000003om^h0ooK^04T0ooK^0@3oool004X0ooK^00<000000?ofkP3o
m^h0B@3om^h0103D?AT0ooK^0?ofkP3D?AT60?ofkP80e3dI1P3om^h0103D?AT0ooK^0?ofkP3D?AT8
0?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h0203om^h00`000000e3dI0=@m6@03
03eIZ`@0`cXI00<000000=Lo703G?a`01@3G?a`403eIZ`030=Lo70000000j4DM00<0j4DM3P000000
0`3D?AT0@fS>000000070000000304Q^f0000000B6kH00T000001@0mFJ/30?mA8P030000000mFJ/0
000000d000000`3oEB<00`000000oe<R0?mC8P020000000303eIZ`3oCAl0oddO00800000303om^h0
0`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^0080ooK^200mFJ/:0?ofkP0303eIZ`000000
ooK^00@0ooK^00<0?EV[0?ofkP3om^h01P0mFJ/70?ofkP0303eIZ`3om^h0?EV[01<0ooK^00<0?EV[
0?ofkP3om^h04@3om^h403eIZ`h0ooK^00<000000?ofkP3om^h0BP3om^h10?ooo`00B@3om^h20000
04/0ooK^00D0e3dI0?ofkP3D?AT0ooK^0=@m6@050?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI
0?ofkP3D?AT02@3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00d0ooK^00<0e3dI0?ofkP3D?AT05`00
00040=@m6@H000000P13J<h00`3D?AT00000000000020000000504=XcP000000@fS>00000013J<h0
1`0000000`18K]P0000004Q^f00200000080oe4R0P0000000`3oDB80000003eIZ`0703eIZ`H0oe@S
00<000000?mE8`3oEB<01@3oEB<300000080oe<R00@0?EV[0000000000000000100mFJ/:0?ofkP03
03eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h02P3om^h703eIZ`<0ooK^00<0?EV[0?ofkP00
00001@3om^h00`0mFJ/0ooK^0?ofkP060?ofkPL0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP03
03eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h0303om^h00`000000ooK^0?ofkP1;0?ofkP40
oooo00190?ofkP800000B`3om^h01@3D?AT0ooK^0=@m6@3om^h0e3dI00D0ooK^00<0e3dI0?ofkP3o
m^h01P3om^h20=@m6@/0ooK^00@0e3dI0?ofkP3om^h0e3dI3P3om^h20=@m6@H0ooK^2P0000000`3D
?AT000000000000800000080e3dI00H0?EV[04=XcP13J<h0?EV[0000003D?AT30000000504=XcP00
0000000004=XcP0000000P13J<h01`000000@fS>00000013J<h0000004=XcP3D?AT01`0000020?mA
8P8000000`3oDB800`0mFJ/0000000000002000000L0?EV[0`3oEB<5000000<0oe<R00<0?EV[0000
003oCAl00P0000040?ofkPL0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^
00X0ooK^00<0?EV[0?ofkP3om^h0103om^h703eIZ`D0ooK^00<0?EV[0?ofkP3om^h02`3om^h403eI
Za80ooK^00<0?EV[0?ofkP3om^h0503om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP030000003om^h0ooK^
04/0ooK^0@3oool004T0ooK^0P00001;0?ofkP050=@m6@3om^h0e3dI0?ofkP3D?AT01@3om^h20=@m
6@P0ooK^00<0e3dI0?ofkP3om^h02P3om^h20=@m6A00ooK^00<0e3dI0?ofkP3om^h0303om^h20000
00030=@m6@000000000000@000001@0gFK4010000000e3dI0=@m6@3D?AT2000000050=@m6@000000
@fS>04=XcP0000000`13J<h00`000000@fS>0000000204=XcP0500000013J<h0@fS>0=@m6@13J<h0
0P0000000`13J<h000000000000400000080oe4R0P0000000`0mFJ/000000?mD8`040?mD8`H00000
1`0mFJ/30?mC8P050000000mFJ/0oddO0=@m6@000000303om^h803eIZ`d0ooK^00<0?EV[0?ofkP3o
m^h01P3om^h01@0mFJ/0ooK^0?ofkP3om^h0000000L0?EV[2`3om^h01@0mFJ/0ooK^0?ofkP3om^h0
?EV[0180ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP030000003om^h0
ooK^04`0ooK^0@3oool004T0ooK^0P00001;0?ofkP80e3dI0`3om^h01`3D?AT0ooK^0?ofkP3om^h0
e3dI0?ofkP3D?AT0203om^h20=@m6@`0ooK^00<0e3dI0?ofkP3om^h03P3om^h30=@m6@h0ooK^00@0
e3dI0?ofkP3om^h0ooK^300000050=@m6@T0000000D0@fS>00000013J<h0@fS>0=@m6@0204=XcP<0
000000D0@fS>00000013J<h000000?mA8P02000000030?mA8P0mFJ/0000000D00000103oE2<00`00
0000oeDS0?mE8`050?mE8`8000001`0mFJ/@0?ofkP0303eIZ`3om^h0ooK^00L0?EV[2@3om^h00`0m
FJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^0080ooK^00<000000?ofkP3om^h00`3om^h00`0m
FJ/0ooK^03eIZ`0603eIZ`@0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP0>0?of
kP0303eIZ`3om^h0ooK^01@0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`000000ooK^0?ofkP1=0?of
kP40oooo00190?ofkP030000003om^h0ooK^04X0ooK^0P3D?AT30?ofkP050=@m6@3om^h0ooK^0?of
kP3D?AT00P3om^h00`3D?AT0ooK^0?ofkP040?ofkP040=@m6@3om^h0ooK^0=@m6@/0ooK^0P3D?AT>
0?ofkP040=@m6@3om^h0ooK^0?ofkP80e3dI2`3om^h00`3D?AT0ooK^0?ofkP080?ofkPL0000000@0
e3dI000000000000=eVa203D?AT01P0gFK400000000000000000e3dI03eIZ`<000000P13J<h01000
0000@fS>00000013J<h2000000040?mA8P00000000000=@m6@D0oe@S3@0000030?mC8P0503eIZ`3o
CAl000000000003D?AT01`0mFJ/:0?ofkP80?EV[1`3om^h603eIZ`<0ooK^00<0?EV[0?ofkP3om^h0
103om^h00`0mFJ/0ooK^0?ofkP020?ofkP030000003om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h0
1P3om^h703eIZ`80ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eI
Z`3om^h0ooK^00/0ooK^00<000000?ofkP3om^h0CP3om^h10?ooo`00B@3om^h00`000000ooK^0?of
kP1:0?ofkP80e3dI0`3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI0080ooK^00<0e3dI0?ofkP3om^h0
103om^h0103D?AT0ooK^0?ofkP3D?AT:0?ofkP040=@m6@3om^h0ooK^0=@m6@d0ooK^00<0e3dI0?of
kP3om^h00`3om^h20=@m6@T0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT000000000000:0000
00P0e3dI0P0000050=@m6@0500000013J<h000000000003oDB800P0000070?mD8`030000003oEB<0
oeDS00@0oeDS00<000000?mC8P3oDb800P3oDb801P0mFJ/000000000003oCAl0000003eIZ`L0ooK^
1`0mFJ/30?ofkP80?EV[3@3om^h803eIZ`030?ofkP0mFJ/0ooK^00@0ooK^00<000000?ofkP3om^h0
103om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^0080ooK^1`0mFJ/;0?ofkP0303eI
Z`3om^h0ooK^01@0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`000000ooK^0?ofkP1?0?ofkP40oooo
00180?ofkP800000C03om^h20=@m6@<0ooK^00@0e3dI0?ofkP3om^h0e3dI103om^h00`3D?AT0ooK^
0?ofkP030?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT02@3om^h0103D?AT0ooK^0?ofkP3om^h20=@m
6@X0ooK^00<0e3dI0?ofkP3om^h01P3om^h20=@m6@H0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D
?AT0ooK^0?ofkP0:0?ofkP@0000000@0e3dI03MI/@0gFK4000000P0gFK420000000303MI/@000000
000000H000001@0mFJ/30?mD8`030000003oEB<0oeDS00@0oeDS00H000000?mC8P3oDb80000003eI
Z`0000020?m=7`80?EV[00<0ooK^03eIZ`3om^h0303om^h703eIZ`l0ooK^00@0?EV[0?ofkP3om^h0
ooK^2P0mFJ/40?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h01P3om^h0100mFJ/0
ooK^0?ofkP3om^h703eIZ`@0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP0:0?of
kP030000003om^h0ooK^0500ooK^0@3oool004P0ooK^0P00001<0?ofkP030=@m6@3om^h0ooK^00<0
ooK^00<0e3dI0?ofkP3D?AT0103om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^0080
ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00L0
ooK^00<0e3dI0?ofkP3om^h0203om^h20=@m6@@0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0
ooK^0?ofkP0>0?ofkP030=@m6@3om^h0000000D0000000<0?EV[000000000000100000000`3D?AT0
=eVa03MI/@02000000<0oe@S200mFJ/50000000303eIZ`000000oddO0080oddO00<000000?ofkP0m
FJ/01@0mFJ/;0?ofkP0303eIZ`3om^h0?EV[0080ooK^1`0mFJ/80?ofkP0403eIZ`3om^h0ooK^03eI
Z`L0ooK^00<000000?ofkP3om^h0200mFJ/50?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?of
kP3om^h0203om^h703eIZa<0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`000000ooK^0?ofkP1@0?of
kP40oooo00180?ofkP800000C03om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0e3dI00D0
ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@060?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?of
kP3om^h01@3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00/0ooK^0P3D?AT00`3o
m^h0e3dI0?ofkP0@0?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h01P3om^h60000
00030=@m6@00000000000080=eVa0`0000001@3oE2<000000?mE8`3oEB<0?EV[00<0oeDS200mFJ/0
0`3D?AT000000?ofkP030?ofkP0403eIZ`3om^h0ooK^0?ofkP/0?EV[0`3om^h00`0mFJ/0ooK^0?of
kP060?ofkPL0?EV[0P3om^h00`0mFJ/0ooK^03eIZ`070?ofkP030000003om^h0ooK^00@0ooK^00@0
?EV[0?ofkP3om^h0ooK^1P0mFJ/80?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h0
0P3om^h703eIZ`/0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`000000ooK^0?ofkP1A0?ofkP40oooo
00180?ofkP800000C03om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0e3dI00H0ooK^00@0
e3dI0?ofkP3om^h0e3dI1`3om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00H0ooK^
00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP0=0?ofkP<0e3dI3`3om^h00`3D?AT0ooK^
0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0000000000002@0000000`3oEB<0?EV[
03eIZ`020?mE8`030000003oDb80?EV[0080?EV[0P0000000`3D?AT0?EV[03eIZ`0503eIZ``0ooK^
2@0mFJ/<0?ofkPL0?EV[1@3om^h00`000000ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00<0ooK^
00<0?EV[0?ofkP3om^h01P0mFJ/30?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h0
2P3om^h703eIZ`@0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`000000ooK^0?ofkP1B0?ofkP40oooo
00180?ofkP030000003om^h0ooK^04/0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?of
kP050?ofkP040=@m6@3om^h0ooK^0=@m6@P0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0:0?ofkP03
0=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0=@m6@020=@m6@`0
ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00@0
ooK^10000000103D?AT000000=@m6@3D?AT<03eIZ`D0ooK^1`0mFJ/40?ofkP0303eIZ`3om^h0ooK^
00@0ooK^00<0?EV[0?ofkP3om^h01P0mFJ/80?ofkP80?EV[0`3om^h703eIZ`H0ooK^00<0?EV[0?of
kP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP070?ofkP@0?EV[2P3om^h00`0mFJ/0ooK^0?ofkP0A0?of
kP@0?EV[2`3om^h00`000000ooK^0?ofkP1C0?ofkP40oooo00180?ofkP030000003om^h0ooK^04`0
ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0e3dI00P0
ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0;0?ofkP80e3dI0P3om^h00`3D?AT0ooK^0?ofkP0>0?of
kP030=@m6@3om^h0ooK^00<0ooK^0`3D?AT80?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?of
kP3om^h0303om^h00`3D?AT0ooK^0?ofkP080?ofkP<0e3dI1P0000000`3D?AT0ooK^03eIZ`0?03eI
Z`80ooK^1`0mFJ/50?ofkP0303eIZ`3om^h0ooK^00D0ooK^200mFJ/00`3om^h0?EV[0?ofkP070?of
kP030000003om^h0?EV[00L0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^
00L0ooK^00<0?EV[0?ofkP3om^h0503om^h00`0mFJ/0ooK^0?ofkP090?ofkP030000003om^h0ooK^
05@0ooK^0@3oool004P0ooK^00<000000?ofkP3om^h0C03om^h00`3D?AT0ooK^0?ofkP030?ofkP03
0=@m6@3om^h0ooK^00H0ooK^0P3D?AT:0?ofkP040=@m6@3om^h0ooK^0=@m6@d0ooK^0P3D?ATA0?of
kP030=@m6@3om^h0ooK^00H0ooK^0`3D?AT50?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?of
kP3om^h0303om^h00`3D?AT0ooK^0?ofkP080?ofkP80e3dI0`3om^h20=@m6@80ooK^1`3D?AT20?of
kPT0?EV[00<0ooK^03eIZ`0mFJ/0100mFJ/30?ofkPL0?EV[303om^h803eIZ`D0ooK^00<000000?of
kP3om^h01@3om^h703eIZ`/0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP0D0?of
kP0303eIZ`3om^h0ooK^00T0ooK^00<000000?ofkP3om^h0E@3om^h10?ooo`00A`3om^h2000004h0
ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0=@m6@080?ofkP030=@m6@3om^h0ooK^00T0
ooK^0P3D?AT?0?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h02P3om^h30=@m6@03
0?ofkP3D?AT0ooK^00l0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP040?ofkPD0
e3dI103om^h20=@m6@80ooK^0`3D?AT00`3om^h0e3dI0=@m6@0:0?ofkPL0?EV[0P3om^h703eIZ`80
ooK^200mFJ/40?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h01P0mFJ/80?ofkP80
?EV[103om^h703eIZ`@0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP03
03eIZ`3om^h0ooK^00X0ooK^00<000000?ofkP3om^h0E@3om^h10?ooo`00A`3om^h2000004h0ooK^
00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0=@m6@080?ofkP80e3dI2`3om^h00`3D?AT0ooK^
0?ofkP0=0?ofkP<0e3dI3P3om^h00`3D?AT0ooK^0?ofkP0=0?ofkPD0e3dI303om^h00`3D?AT0ooK^
0?ofkP0<0?ofkP030=@m6@3om^h0ooK^0080ooK^0`3D?AT40?ofkP030=@m6@3om^h0ooK^0080ooK^
00<0e3dI0?ofkP3om^h00`3D?AT00`3om^h0e3dI0=@m6@0B0?ofkPL0?EV[0P3om^h703eIZ`<0ooK^
1`0mFJ/40?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0000003eIZ`0mFJ/0100mFJ/20?ofkP0303eI
Z`3om^h0ooK^00X0ooK^1`0mFJ/40?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h0
2P3om^h00`000000ooK^0?ofkP1F0?ofkP40oooo00170?ofkP800000C`3om^h0103D?AT0ooK^0?of
kP3D?AT30?ofkP030=@m6@3om^h0ooK^00@0ooK^00@0e3dI0?ofkP3om^h0e3dI2P3om^h20=@m6@d0
ooK^00@0e3dI0?ofkP3om^h0ooK^0P3D?AT;0?ofkP030=@m6@3om^h0ooK^00l0ooK^00@0e3dI0?of
kP3om^h0ooK^203D?AT40?ofkP030=@m6@3om^h0ooK^00`0ooK^1@3D?AT60?ofkP030=@m6@3om^h0
ooK^00<0ooK^00<0e3dI0?ofkP3om^h00`3D?AT00`3om^h0e3dI0=@m6@0I0?ofkPl0?EV[103om^h6
03eIZ`D0ooK^00<000000?ofkP3om^h0103om^h703eIZ`d0ooK^00<0?EV[0?ofkP0mFJ/01P0mFJ/C
0?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<000000?ofkP3om^h0E`3om^h10?ooo`00A`3om^h00`00
0000ooK^0?ofkP1>0?ofkP040=@m6@3om^h0ooK^0=@m6@<0ooK^00<0e3dI0?ofkP3om^h0103om^h0
103D?AT0ooK^0?ofkP3D?AT90?ofkP030=@m6@3om^h0ooK^0080e3dI2`3om^h00`3D?AT0ooK^0?of
kP030?ofkP80e3dI2@3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00X0ooK^503D
?AT:0?ofkP030=@m6@3om^h0ooK^00<0ooK^00H0e3dI0?ofkP3D?AT0ooK^0=@m6@3om^h20=@m6B40
ooK^1`0mFJ/00`3om^h0?EV[03eIZ`0503eIZ`80ooK^200mFJ/40?ofkP0303eIZ`3om^h0ooK^0080
ooK^00<0?EV[0?ofkP3om^h01P0mFJ/80?ofkP0403eIZ`3om^h0ooK^03eIZ`@0ooK^1P0mFJ/<0?of
kP0303eIZ`3om^h0ooK^00T0ooK^00<000000?ofkP3om^h0F03om^h10?ooo`00A`3om^h00`000000
ooK^0?ofkP1>0?ofkP040=@m6@3om^h0ooK^0=@m6@@0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D
?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D
?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00H0ooK^0P3D?AT60?ofkP030=@m6@3om^h0ooK^
00l0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^
00T0ooK^00<0e3dI0?ofkP3om^h0103om^h20=@m6@040?ofkP3D?AT0e3dI0?ofkP80e3dI:03om^h6
03eIZ`80ooK^1`0mFJ/00`3om^h000000?ofkP0703eIZ`<0ooK^00<0?EV[0?ofkP3om^h01@3om^h6
03eIZ`80ooK^00<0?EV[0?ofkP0mFJ/02`3om^h703eIZ`@0ooK^00<0?EV[0?ofkP3om^h02@3om^h0
0`000000ooK^0?ofkP1I0?ofkP40oooo00170?ofkP030000003om^h0ooK^04h0ooK^00<0e3dI0?of
kP3D?AT01@3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?of
kP3om^h0103om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?of
kP3om^h0203om^h20=@m6@@0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0=0?of
kP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP030?of
kP@0e3dI00<0ooK^0=@m6@3om^h00P3D?AT_0?ofkPl0?EV[103om^h703eIZ`X0ooK^100mFJ/C0?of
kP@0?EV[2`3om^h00`000000ooK^0?ofkP1J0?ofkP40oooo00160?ofkP800000D@3om^h20=@m6@H0
ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@060?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?of
kP3om^h01@3om^h20=@m6@H0ooK^00<0e3dI0?ofkP3om^h02P3om^h20=@m6@030?ofkP3D?AT0ooK^
0100ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^
00T0ooK^00@0e3dI0?ofkP3om^h0ooK^0P3D?AT20?ofkP030=@m6@3om^h0e3dI00<0e3dI=`3om^h?
03eIZ`80ooK^00<0?EV[0?ofkP0mFJ/01P0mFJ/40?ofkP0403eIZ`3om^h0ooK^03eIZa@0ooK^00<0
?EV[0?ofkP3om^h02P3om^h00`000000ooK^0?ofkP1J0?ofkP40oooo00160?ofkP800000D@3om^h0
0`3D?AT0ooK^0?ofkP050?ofkP040=@m6@3om^h0ooK^0=@m6@P0ooK^00<0e3dI0?ofkP3om^h00P3o
m^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h03@3o
m^h30=@m6@l0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3o
m^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h00P3D?AT30?ofkP80e3dI00<0ooK^0=@m6@3D?AT00P3D
?ATj0?ofkP030000003om^h0ooK^0080ooK^3`0mFJ/30?ofkPL0?EV[00<0ooK^03eIZ`0mFJ/04@3o
m^h00`0mFJ/0ooK^0?ofkP0:0?ofkP030000003om^h0ooK^05/0ooK^0@3oool004H0ooK^0P00001A
0?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3D?AT02@3om^h0103D?AT0ooK^0?ofkP3D
?AT;0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT03`3om^h00`3D?AT0ooK^0?ofkP030=@m6@`0ooK^
00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00T0ooK^
0`3D?AT50?ofkP030=@m6@3om^h0e3dI00<0e3dI>`3om^h00`000000ooK^0?ofkP0<0?ofkQD0?EV[
303om^h203eIZ``0ooK^00<000000?ofkP3om^h0G03om^h10?ooo`00AP3om^h00`000000ooK^0?of
kP1A0?ofkP030=@m6@3om^h0ooK^00D0ooK^0P3D?AT:0?ofkP040=@m6@3om^h0ooK^0=@m6@`0ooK^
0`3D?AT@0?ofkP030=@m6@3om^h0ooK^00<0ooK^0`3D?AT80?ofkP030=@m6@3om^h0ooK^00d0ooK^
00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP070?ofkP<0e3dI1P3om^h70=@m6C/0ooK^
00<000000?ofkP3om^h05@3om^hC03eIZ`@0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`000000ooK^
0?ofkP1M0?ofkP40oooo00160?ofkP030000003om^h0ooK^0540ooK^00<0e3dI0?ofkP3om^h01P3o
m^h00`3D?AT0ooK^0?ofkP090?ofkP80e3dI3`3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3o
m^h0ooK^00L0ooK^0`3D?AT50?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h02`3o
m^h00`3D?AT0ooK^0?ofkP050?ofkP<0e3dI00<0ooK^0=@m6@3om^h01P3om^h30=@m6@030?ofkP3D
?AT0e3dI03`0ooK^00<000000?ofkP3om^h06`3om^h803eIZ`D0ooK^100mFJ/=0?ofkP030000003o
m^h0ooK^05h0ooK^0@3oool004H0ooK^00<000000?ofkP3om^h0DP3om^h00`3D?AT0ooK^0?ofkP05
0?ofkP80e3dI2`3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP040=@m6@3om^h0e3dI0=@m6@d0ooK^00<0
e3dI0?ofkP3om^h02P3om^h30=@m6@030?ofkP3D?AT0ooK^00h0ooK^00<0e3dI0?ofkP3om^h0303o
m^h0103D?AT0ooK^0?ofkP3om^h40=@m6@<0ooK^00<0e3dI0?ofkP3om^h01@3om^h40=@m6@030?of
kP3D?AT0e3dI03d0ooK^00<000000?ofkP3om^h0803om^h703eIZa00ooK^00<000000?ofkP3om^h0
G`3om^h10?ooo`00AP3om^h00`000000ooK^0?ofkP1C0?ofkP030=@m6@3om^h0ooK^00<0ooK^00@0
e3dI0?ofkP3om^h0e3dI2P3om^h20=@m6@d0ooK^00@0e3dI0?ofkP3om^h0ooK^0P3D?AT:0?ofkP03
0=@m6@3om^h0ooK^00h0ooK^1@3D?AT<0?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3D
?AT00P3D?AT70?ofkP030=@m6@3om^h0ooK^00D0ooK^00@0e3dI0?ofkP3D?AT0ooK^0P3D?ATn0?of
kP030000003om^h0ooK^03L0ooK^00<000000?ofkP3om^h0G`3om^h10?ooo`00A@3om^h2000005D0
ooK^00<0e3dI0?ofkP3om^h00`3om^h0103D?AT0ooK^0?ofkP3D?AT90?ofkP030=@m6@3om^h0ooK^
0080e3dI2P3om^h00`3D?AT0ooK^0?ofkP040?ofkP80e3dI203om^h00`3D?AT0ooK^0?ofkP0>0?of
kP030=@m6@3om^h0ooK^0080ooK^203D?AT30?ofkP030=@m6@3om^h0ooK^00D0ooK^2@3D?AT90?of
kP030=@m6@3om^h0ooK^00D0ooK^00D0e3dI0?ofkP3om^h0e3dI0?ofkP020=@m6Ch0ooK^00<00000
0?ofkP3om^h0=P3om^h00`000000ooK^0?ofkP1P0?ofkP40oooo00150?ofkP800000EP3om^h00`3D
?AT0ooK^0?ofkP020?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT0203om^h00`3D?AT0ooK^0?ofkP02
0?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h01P3om^h20=@m6@D0ooK^00<0e3dI
0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP/0e3dI1P3om^h00`3D?AT0ooK^0?ofkP09
0?ofkP030=@m6@3om^h0ooK^00<0ooK^0P3D?AT30?ofkP<0e3dI?`3om^h00`000000ooK^0?ofkP0e
0?ofkP030000003om^h0ooK^0640ooK^0@3oool004D0ooK^00<000000?ofkP3om^h0E@3om^h01@3D
?AT0ooK^0?ofkP3om^h0e3dI00D0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP04
0?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h02@3om^h20=@m6@<0ooK^00<0e3dI
0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI
0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0e3dI0080ooK^00<0e3dI
0?ofkP3D?AT0@03om^h00`000000ooK^0?ofkP0d0?ofkP030000003om^h0ooK^0680ooK^0@3oool0
04D0ooK^00<000000?ofkP3om^h0EP3om^h0103D?AT0ooK^0?ofkP3D?AT60?ofkP030=@m6@3om^h0
ooK^00<0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0
ooK^00/0ooK^0`3D?ATA0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h02`3om^h0
0`3D?AT0ooK^0?ofkP090?ofkP040=@m6@3om^h0ooK^0?ofkP80e3dI00<0ooK^0=@m6@3om^h00P3o
m^h30=@m6D00ooK^00<000000?ofkP3om^h0<`3om^h00`000000ooK^0?ofkP1S0?ofkP40oooo0015
0?ofkP030000003om^h0ooK^05L0ooK^00<0e3dI0?ofkP3D?AT01`3om^h00`3D?AT0ooK^0?ofkP02
0?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP0>
0?ofkP80e3dI3`3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI
0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP020=@m6@<0ooK^00<0e3dI0?ofkP3om^h00`3D?AU1
0?ofkP030000003om^h0ooK^0380ooK^00<000000?ofkP3om^h0I03om^h10?ooo`00A@3om^h00`00
0000ooK^0?ofkP1G0?ofkP80e3dI2@3om^h0103D?AT0ooK^0?ofkP3D?AT:0?ofkP80e3dI0P3om^h0
0`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0e3dI0080e3dI303om^h00`3D?AT0ooK^0?ofkP0=
0?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0=@m6@04
0?ofkP030=@m6@3om^h0ooK^00<0e3dI@P3om^h00`000000ooK^0?ofkP0b0?ofkP030000003om^h0
ooK^06@0ooK^0@3oool004@0ooK^0P00001J0?ofkP030=@m6@3om^h0ooK^00L0ooK^00@0e3dI0?of
kP3om^h0e3dI303om^h20=@m6A00ooK^00<0e3dI0?ofkP3om^h00`3om^h30=@m6@P0ooK^00<0e3dI
0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00T0ooK^0`3D?AT4
0?ofkP050=@m6@3om^h0ooK^0=@m6@3om^h00P3D?AU20?ofkP030000003om^h0ooK^0340ooK^00<0
00000?ofkP3om^h0I@3om^h10?ooo`00A03om^h2000005/0ooK^00<0e3dI0?ofkP3om^h01`3om^h2
0=@m6@h0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP060?ofkP<0e3dI1@3om^h0
0`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h01`3om^h3
0=@m6@H0ooK^00@0e3dI0?ofkP3D?AT0ooK^0P3D?AU30?ofkP030000003om^h0ooK^0300ooK^00<0
00000?ofkP3om^h0IP3om^h10?ooo`00A03om^h00`000000ooK^0?ofkP1K0?ofkP030=@m6@3om^h0
ooK^00L0ooK^00<0e3dI0?ofkP3om^h0303om^h30=@m6@d0ooK^00<0e3dI0?ofkP3om^h02P3om^h3
0=@m6@030?ofkP3D?AT0ooK^00h0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP04
0?ofkP@0e3dI00<0ooK^0=@m6@3om^h01@3om^h30=@m6@80ooK^00<0e3dI0?ofkP3om^h0@P3om^h0
0`000000ooK^0?ofkP0_0?ofkP030000003om^h0ooK^06L0ooK^0@3oool004@0ooK^00<000000?of
kP3om^h0F`3om^h00`3D?AT0ooK^0?ofkP070?ofkP80e3dI303om^h0103D?AT0ooK^0?ofkP3om^h2
0=@m6@/0ooK^00<0e3dI0?ofkP3om^h03@3om^h50=@m6@`0ooK^00<0e3dI0?ofkP3om^h02`3om^h0
0`3D?AT0ooK^0=@m6@040=@m6@D0ooK^00<0e3dI0?ofkP3om^h0103om^h0103D?AT0ooK^0?ofkP3o
m^h20=@m6D@0ooK^00<000000?ofkP3om^h0;P3om^h00`000000ooK^0?ofkP1X0?ofkP40oooo0014
0?ofkP030000003om^h0ooK^05`0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP02
0=@m6@X0ooK^00<0e3dI0?ofkP3om^h00`3om^h20=@m6@T0ooK^00<0e3dI0?ofkP3om^h03@3om^h0
0`3D?AT0ooK^0?ofkP020?ofkPP0e3dI0`3om^h00`3D?AT0ooK^0?ofkP050?ofkPT0e3dI2@3om^h0
0`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h0A03om^h0
0`000000ooK^0?ofkP0/0?ofkP030000003om^h0ooK^06T0ooK^0@3oool004@0ooK^00<000000?of
kP3om^h0G@3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?of
kP3om^h01P3om^h00`3D?AT0ooK^0?ofkP060?ofkP80e3dI1P3om^h00`3D?AT0ooK^0?ofkP0>0?of
kP030=@m6@3om^h0ooK^00X0ooK^2`3D?AT50?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?of
kP3om^h00`3om^h20=@m6@@0ooK^00<0e3dI0?ofkP3om^h0A@3om^h00`000000ooK^0?ofkP0/0?of
kP030000003om^h0ooK^06T0ooK^0@3oool004<0ooK^0P00001P0?ofkP030=@m6@3om^h0ooK^00<0
ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00P0
ooK^0P3D?AT40?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0
ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00T0ooK^00@0e3dI0?ofkP3om^h0ooK^0P3D?AT00`3o
m^h0e3dI0?ofkP020?ofkP80e3dIA`3om^h00`000000ooK^0?ofkP0[0?ofkP030000003om^h0ooK^
06X0ooK^0@3oool004<0ooK^0P00001Q0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT01`3om^h00`3D
?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00X0ooK^0P3D?AT00`3om^h0e3dI0?ofkP0?0?of
kP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP090?of
kP030=@m6@3om^h0ooK^0080e3dI0P3om^h0103D?AT0ooK^0?ofkP3om^h20=@m6DP0ooK^00<00000
0?ofkP3om^h0:P3om^h00`000000ooK^0?ofkP1[0?ofkP40oooo00130?ofkP030000003om^h0ooK^
0640ooK^00@0e3dI0?ofkP3om^h0e3dI203om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0
ooK^00d0ooK^0`3D?AT>0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h02`3om^h0
0`3D?AT0ooK^0?ofkP080?ofkP040=@m6@3om^h0e3dI0=@m6@@0ooK^00<0e3dI0?ofkP3om^h00`3D
?AU80?ofkP030000003om^h0ooK^02T0ooK^00<000000?ofkP3om^h0K03om^h10?ooo`00@`3om^h0
0`000000ooK^0?ofkP1Q0?ofkP040=@m6@3om^h0ooK^0=@m6@T0ooK^0P3D?AT20?ofkP030=@m6@3o
m^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h00`3D?AT;0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0
e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP090?ofkP80e3dI1@3om^h01P3D?AT0ooK^0=@m
6@3D?AT0ooK^0=@m6DT0ooK^00<000000?ofkP3om^h0:03om^h00`000000ooK^0?ofkP1]0?ofkP40
oooo00130?ofkP030000003om^h0ooK^0680ooK^0P3D?AT<0?ofkP80e3dI403om^h00`3D?AT0ooK^
0?ofkP030?ofkP80e3dI203om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00/0ooK^
00<0e3dI0?ofkP3om^h01`3om^h20=@m6@L0ooK^0P3D?AT20?ofkP030=@m6@3om^h0ooK^04P0ooK^
00<000000?ofkP3om^h09`3om^h00`000000ooK^0?ofkP1^0?ofkP40oooo00130?ofkP030000003o
m^h0ooK^06<0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3o
m^h0ooK^00H0ooK^0`3D?AT50?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h02P3o
m^h00`3D?AT0ooK^0?ofkP050?ofkP@0e3dI1`3om^h20=@m6@<0ooK^00<0e3dI0?ofkP3om^h0B03o
m^h00`000000ooK^0?ofkP0W0?ofkP030000003om^h0ooK^06h0ooK^0@3oool004<0ooK^00<00000
0?ofkP3om^h0I03om^h00`3D?AT0ooK^0?ofkP0:0?ofkP<0e3dI3@3om^h00`3D?AT0ooK^0?ofkP09
0?ofkP<0e3dI00<0ooK^0=@m6@3om^h03P3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP040=@m6@3om^h0
ooK^0?ofkP@0e3dI0`3om^h00`3D?AT0ooK^0?ofkP050?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT0
B`3om^h00`000000ooK^0?ofkP0V0?ofkP030000003om^h0ooK^06l0ooK^0@3oool00480ooK^0P00
001W0?ofkP80e3dI2@3om^h0103D?AT0ooK^0?ofkP3om^h20=@m6@X0ooK^00<0e3dI0?ofkP3om^h0
3@3om^h50=@m6@`0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0=@m6@020=@m6@H0ooK^
00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^04T0ooK^
00<000000?ofkP3om^h09@3om^h00`000000ooK^0?ofkP1`0?ofkP40oooo00120?ofkP030000003o
m^h0ooK^06P0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP030?ofkP80e3dI203o
m^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^0080ooK^203D?AT30?ofkP030=@m6@3o
m^h0ooK^00D0ooK^203D?AT90?ofkP030=@m6@3om^h0ooK^00<0ooK^0P3D?AT40?ofkP030=@m6@3o
m^h0ooK^04X0ooK^00<000000?ofkP3om^h0903om^h00`000000ooK^0?ofkP1a0?ofkP40oooo0012
0?ofkP030000003om^h0ooK^06T0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP05
0?ofkP80e3dI1@3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00X0ooK^2`3D?AT5
0?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0=@m6@03
0?ofkP030=@m6@3om^h0ooK^04/0ooK^00<000000?ofkP3om^h08`3om^h00`000000ooK^0?ofkP1b
0?ofkP40oooo00120?ofkP030000003om^h0ooK^06X0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D
?AT0ooK^0?ofkP080?ofkP80e3dI0`3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^
00d0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP080?ofkP040=@m6@3om^h0ooK^
0?ofkP80e3dI00<0ooK^0=@m6@3om^h00P3om^h00`3D?AT0ooK^0?ofkP1=0?ofkP030000003om^h0
ooK^0240ooK^00<000000?ofkP3om^h0L`3om^h10?ooo`00@P3om^h00`000000ooK^0?ofkP1[0?of
kP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h02P3om^h30=@m6A00ooK^00<0e3dI0?of
kP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?of
kP3om^h00P3D?AT30?ofkP040=@m6@3om^h0ooK^0=@m6E00ooK^00<000000?ofkP3om^h08@3om^h0
0`000000ooK^0?ofkP1c0?ofkP40oooo00120?ofkP030000003om^h0ooK^06`0ooK^0P3D?AT20?of
kP030=@m6@3om^h0ooK^00`0ooK^0P3D?AT>0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?of
kP3om^h02`3om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0e3dI00@0ooK^00@0e3dI0?of
kP3D?AT0e3dID@3om^h00`000000ooK^0?ofkP0P0?ofkP030000003om^h0ooK^07@0ooK^0@3oool0
0440ooK^0P00001`0?ofkP80e3dI3`3om^h00`3D?AT0ooK^0=@m6@030=@m6@X0ooK^00<0e3dI0?of
kP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00P0ooK^0`3D?AT50?of
kP80e3dID`3om^h00`000000ooK^0?ofkP0O0?ofkP030000003om^h0ooK^07D0ooK^0@3oool00440
ooK^00<000000?ofkP3om^h0L03om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00@0
ooK^0`3D?AT60?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0
ooK^0?ofkP060?ofkP<0e3dI1P3om^h20=@m6E@0ooK^00<000000?ofkP3om^h07P3om^h00`000000
ooK^0?ofkP1f0?ofkP40oooo00110?ofkP030000003om^h0ooK^0740ooK^0P3D?AT<0?ofkP030=@m
6@3om^h0ooK^00L0ooK^103D?AT20?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h0
2P3om^h00`3D?AT0ooK^0?ofkP030?ofkP@0e3dI00<0ooK^0=@m6@3om^h01P3om^h00`3D?AT0ooK^
0?ofkP1C0?ofkP030000003om^h0ooK^01d0ooK^00<000000?ofkP3om^h0M`3om^h10?ooo`00@@3o
m^h500000740ooK^0P3D?AT90?ofkP030=@m6@3om^h0ooK^00`0ooK^1@3D?AT<0?ofkP030=@m6@3o
m^h0ooK^00/0ooK^00<0e3dI0?ofkP3D?AT00`3D?AT50?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0
e3dI0?ofkP3om^h0E03om^h00`000000ooK^0?ofkP0L0?ofkP030000003om^h0ooK^07P0ooK^0@3o
ool004H0ooK^2000001[0?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h03@3om^h0
103D?AT0ooK^0?ofkP3om^h80=@m6@@0ooK^00<0e3dI0?ofkP3om^h0103om^h90=@m6@P0ooK^00<0
e3dI0?ofkP3om^h00`3om^h20=@m6EL0ooK^00<000000?ofkP3om^h0703om^h00`000000ooK^0?of
kP1h0?ofkP40oooo001>0?ofkPP00000I03om^h20=@m6@D0ooK^00<0e3dI0?ofkP3om^h03@3om^h0
0`3D?AT0ooK^0?ofkP0:0?ofkP/0e3dI1@3om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0
ooK^0080ooK^0P3D?AUI0?ofkP030000003om^h0ooK^01/0ooK^00<000000?ofkP3om^h0N@3om^h1
0?ooo`00EP3om^h9000005d0ooK^0P3D?AT30?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?of
kP3om^h0303om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?of
kP3om^h00P3D?AUK0?ofkP030000003om^h0ooK^01X0ooK^00<000000?ofkP3om^h0NP3om^h10?oo
o`00G`3om^h8000005L0ooK^0`3D?AT?0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3o
m^h02P3om^h00`3D?AT0ooK^0?ofkP080?ofkP040=@m6@3om^h0e3dI0=@m6Ed0ooK^00<000000?of
kP3om^h06@3om^h00`000000ooK^0?ofkP1k0?ofkP40oooo001W0?ofkPP00000D@3om^h20=@m6@h0
ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00P0
ooK^0P3D?AUP0?ofkP030000003om^h0ooK^01L0ooK^00<000000?ofkP3om^h0O03om^h10?ooo`00
K`3om^h9000004X0ooK^103D?AT90?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h0
2P3om^h00`3D?AT0ooK^0?ofkP070?ofkP80e3dIHP3om^h00`000000ooK^0?ofkP0F0?ofkP030000
003om^h0ooK^07d0ooK^0@3oool007P0ooK^200000160?ofkP<0e3dI1P3om^h00`3D?AT0ooK^0?of
kP0<0?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h0103om^h30=@m6F@0ooK^00<0
00000?ofkP3om^h05P3om^h00`000000ooK^0?ofkP1m0?ofkP40oooo00200?ofkPP00000@@3om^h4
0=@m6@030?ofkP3D?AT0ooK^00h0ooK^00<0e3dI0?ofkP3om^h02P3om^h0103D?AT0ooK^0?ofkP3o
m^h40=@m6FL0ooK^00<000000?ofkP3om^h05@3om^h00`000000ooK^0?ofkP1n0?ofkP40oooo0028
0?ofkPT00000?03om^h50=@m6@/0ooK^00<0e3dI0?ofkP3om^h02`3om^h40=@m6F/0ooK^00<00000
0?ofkP3om^h0503om^h00`000000ooK^0?ofkP1o0?ofkP40oooo002A0?ofkPP00000>@3om^h70=@m
6@@0ooK^00<0e3dI0?ofkP3om^h0103om^h80=@m6Fh0ooK^00<000000?ofkP3om^h04`3om^h00`00
0000ooK^0?ofkP200?ofkP40oooo002I0?ofkPP00000>03om^h;0=@m6GH0ooK^00<000000?ofkP3o
m^h04P3om^h00`000000ooK^0?ofkP210?ofkP40oooo002Q0?ofkPT00000/03om^h00`000000ooK^
0?ofkP0A0?ofkP030000003om^h0ooK^0880ooK^0@3oool00:X0ooK^2000002X0?ofkP030000003o
m^h0ooK^0140ooK^00<000000?ofkP3om^h0PP3om^h10?ooo`00/P3om^h800000:00ooK^00<00000
0?ofkP3om^h0403om^h00`000000ooK^0?ofkP230?ofkP40oooo002j0?ofkPT00000U`3om^h00`00
0000ooK^0?ofkP0?0?ofkP030000003om^h0ooK^08@0ooK^0@3oool00<<0ooK^2000002?0?ofkP03
0000003om^h0ooK^00h0ooK^00<000000?ofkP3om^h0Q@3om^h10?ooo`00b`3om^h8000008P0ooK^
00<000000?ofkP3om^h0303om^h00`000000ooK^0?ofkP260?ofkP40oooo003C0?ofkPP00000P03o
m^h00`000000ooK^0?ofkP0;0?ofkP030000003om^h0ooK^08L0ooK^0@3oool00=/0ooK^2@00001g
0?ofkP030000003om^h0ooK^00/0ooK^00<000000?ofkP3om^h0Q`3om^h10?ooo`00i03om^h80000
06l0ooK^00<000000?ofkP3om^h02P3om^h00`000000ooK^0?ofkP280?ofkP40oooo003/0?ofkPP0
0000I`3om^h00`000000ooK^0?ofkP090?ofkP030000003om^h0ooK^08T0ooK^0@3oool00?@0ooK^
2@00001N0?ofkP030000003om^h0ooK^00P0ooK^00<000000?ofkP3om^h0RP3om^h10?ooo`00o@3o
m^h8000005H0ooK^00<000000?ofkP3om^h01`3om^h00`000000ooK^0?ofkP2;0?ofkP40oooo003o
0?ofkPH0ooK^2000001>0?ofkP030000003om^h0ooK^00H0ooK^00<000000?ofkP3om^h0S03om^h1
0?ooo`00o`3om^h>0?ofkPT00000A@3om^h00`000000ooK^0?ofkP060?ofkP030000003om^h0ooK^
08`0ooK^0@3oool00?l0ooK^5`3om^h8000003d0ooK^00<000000?ofkP3om^h01@3om^h00`000000
ooK^0?ofkP2=0?ofkP40oooo003o0?ofkQl0ooK^2000000e0?ofkP030000003om^h0ooK^00@0ooK^
00<000000?ofkP3om^h0SP3om^h10?ooo`00o`3om^hW0?ofkPT00000;03om^h00`000000ooK^0?of
kP030?ofkP030000003om^h0ooK^08l0ooK^0@3oool00?l0ooK^<03om^h8000002D0ooK^00D00000
0?ofkP3om^h0ooK^0000002B0?ofkP40oooo003o0?ofkSP0ooK^2000000M0?ofkP040000003om^h0
ooK^000009<0ooK^0@3oool00?l0ooK^@03om^h9000001@0ooK^00@000000?ofkP3om^h00000T`3o
m^h10?ooo`00o`3om^i90?ofkPP00000303om^h00`000000ooK^0000002D0?ofkP40oooo003o0?of
kU40ooK^200000040?ofkP800000U@3om^h10?ooo`00o`3om^iI0?ofkPD00000UP3om^h10?ooo`00
o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?of
kP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o
0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^
0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0
ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h1
0?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3o
m^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40
oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?of
k_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3o
ool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^
m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?oo
o`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd
0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo
003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0
ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool0
0?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03o
m^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00
o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?of
kP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o
0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^
0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0
ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h1
0?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3o
m^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40
oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?of
k_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00\
\>"],
  ImageRangeCache->{{{0, 499}, {499, 0}} -> {-5.00005*^-06, -5.00005*^-06, \
0.00200403, 0.00200403}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
%%ImageSize: 500 500 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics3D
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Background color
1 .961 .933 r
MFill
% Scaling calculations
0 1 0 1 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 0 r
.25 Mabswid
[ ] 0 setdash
.59088 .60318 m
.60039 .8356 L
s
.60039 .8356 m
.99253 .5665 L
s
.99253 .5665 m
.93295 .30234 L
s
.93295 .30234 m
.59088 .60318 L
s
.11236 .44767 m
.36195 .03848 L
s
.36195 .03848 m
.33874 .3169 L
s
.33874 .3169 m
.06528 .69847 L
s
.06528 .69847 m
.11236 .44767 L
s
.59088 .60318 m
.60039 .8356 L
s
.60039 .8356 m
.06528 .69847 L
s
.06528 .69847 m
.11236 .44767 L
s
.11236 .44767 m
.59088 .60318 L
s
.93295 .30234 m
.36195 .03848 L
s
.36195 .03848 m
.33874 .3169 L
s
.33874 .3169 m
.99253 .5665 L
s
.99253 .5665 m
.93295 .30234 L
s
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
.83 .24 .1 r
.5 Mabswid
.40755 .54684 m
.42857 .56253 L
s
.42857 .56253 m
.44572 .54453 L
s
.42857 .56253 m
.447 .58135 L
s
.447 .58135 m
.46445 .56364 L
s
.447 .58135 m
.46216 .60261 L
s
.38469 .53486 m
.40755 .54684 L
s
.40755 .54684 m
.4244 .52855 L
s
.46216 .60261 m
.4799 .58518 L
s
.46216 .60261 m
.47346 .62555 L
s
.3608 .52709 m
.38469 .53486 L
s
.38469 .53486 m
.40124 .5163 L
s
.47346 .62555 m
.49148 .6084 L
s
.47346 .62555 m
.48042 .64934 L
s
.33678 .52391 m
.3608 .52709 L
s
.3608 .52709 m
.37708 .50827 L
s
.4244 .52855 m
.44572 .54453 L
s
.44572 .54453 m
.46342 .52595 L
s
.44572 .54453 m
.46445 .56364 L
s
.48042 .64934 m
.49869 .63245 L
s
.48042 .64934 m
.48268 .6731 L
s
.46445 .56364 m
.48246 .54535 L
s
.46445 .56364 m
.4799 .58518 L
s
.40124 .5163 m
.4244 .52855 L
s
.4244 .52855 m
.44179 .50967 L
s
.4799 .58518 m
.49822 .56719 L
s
.4799 .58518 m
.49148 .6084 L
s
.31356 .52555 m
.33678 .52391 L
s
.33678 .52391 m
.35282 .50487 L
s
.37708 .50827 m
.40124 .5163 L
s
.40124 .5163 m
.41833 .49713 L
s
.49148 .6084 m
.51009 .59069 L
s
.49148 .6084 m
.49869 .63245 L
s
.48268 .6731 m
.50117 .65643 L
s
.48268 .6731 m
.48002 .69588 L
s
.35282 .50487 m
.37708 .50827 L
s
.37708 .50827 m
.3939 .48884 L
s
.24 .35 .67 r
.68175 .54593 m
.6726 .57153 L
s
.6726 .57153 m
.64176 .56096 L
s
.6726 .57153 m
.6663 .59771 L
s
.69344 .5218 m
.68175 .54593 L
s
.68175 .54593 m
.65099 .53511 L
s
.83 .24 .1 r
.44179 .50967 m
.46342 .52595 L
s
.46342 .52595 m
.4817 .50675 L
s
.46342 .52595 m
.48246 .54535 L
s
.2921 .53211 m
.31356 .52555 L
s
.31356 .52555 m
.32938 .50634 L
s
.49869 .63245 m
.51757 .61499 L
s
.49869 .63245 m
.50117 .65643 L
s
.48246 .54535 m
.50107 .52646 L
s
.48246 .54535 m
.49822 .56719 L
s
.41833 .49713 m
.44179 .50967 L
s
.44179 .50967 m
.45975 .49016 L
s
.24 .35 .67 r
.6663 .59771 m
.63531 .58735 L
s
.6663 .59771 m
.66309 .62359 L
s
.70729 .49996 m
.69344 .5218 L
s
.69344 .5218 m
.66267 .51071 L
s
.83 .24 .1 r
.49822 .56719 m
.51714 .5486 L
s
.49822 .56719 m
.51009 .59069 L
s
.48002 .69588 m
.49867 .6794 L
s
.48002 .69588 m
.47238 .71672 L
s
.32938 .50634 m
.35282 .50487 L
s
.35282 .50487 m
.36938 .4852 L
s
.3939 .48884 m
.41833 .49713 L
s
.41833 .49713 m
.43599 .47732 L
s
.24 .35 .67 r
.66309 .62359 m
.63187 .61341 L
s
.66309 .62359 m
.66313 .64824 L
s
.83 .24 .1 r
.51009 .59069 m
.52932 .57239 L
s
.51009 .59069 m
.51757 .61499 L
s
.24 .35 .67 r
.65099 .53511 m
.64176 .56096 L
s
.64176 .56096 m
.61033 .55018 L
s
.64176 .56096 m
.63531 .58735 L
s
.66267 .51071 m
.65099 .53511 L
s
.65099 .53511 m
.61963 .52409 L
s
.83 .24 .1 r
.50117 .65643 m
.52027 .63921 L
s
.50117 .65643 m
.49867 .6794 L
s
.24 .35 .67 r
.72286 .48125 m
.70729 .49996 L
s
.70729 .49996 m
.67644 .48859 L
s
.83 .24 .1 r
.27335 .54349 m
.2921 .53211 L
s
.2921 .53211 m
.30775 .51278 L
s
.24 .35 .67 r
.63531 .58735 m
.60372 .5768 L
s
.63531 .58735 m
.63187 .61341 L
s
.67644 .48859 m
.66267 .51071 L
s
.66267 .51071 m
.63132 .49941 L
s
.83 .24 .1 r
.36938 .4852 m
.3939 .48884 L
s
.3939 .48884 m
.41127 .46875 L
s
.45975 .49016 m
.4817 .50675 L
s
.4817 .50675 m
.5006 .4869 L
s
.4817 .50675 m
.50107 .52646 L
s
.30775 .51278 m
.32938 .50634 L
s
.32938 .50634 m
.34573 .48648 L
s
.47238 .71672 m
.49113 .70039 L
s
.47238 .71672 m
.45991 .73466 L
s
.51757 .61499 m
.53707 .59696 L
s
.51757 .61499 m
.52027 .63921 L
s
.50107 .52646 m
.5203 .50694 L
s
.50107 .52646 m
.51714 .5486 L
s
.24 .35 .67 r
.66313 .64824 m
.63162 .63821 L
s
.66313 .64824 m
.66652 .67076 L
s
.63187 .61341 m
.60005 .60304 L
s
.63187 .61341 m
.63162 .63821 L
s
.83 .24 .1 r
.43599 .47732 m
.45975 .49016 L
s
.45975 .49016 m
.47832 .46999 L
s
.24 .35 .67 r
.61963 .52409 m
.61033 .55018 L
s
.61033 .55018 m
.57829 .5392 L
s
.61033 .55018 m
.60372 .5768 L
s
.63132 .49941 m
.61963 .52409 L
s
.61963 .52409 m
.58767 .51285 L
s
.69186 .46959 m
.67644 .48859 L
s
.67644 .48859 m
.64501 .477 L
s
.73962 .46644 m
.72286 .48125 L
s
.72286 .48125 m
.69186 .46959 L
s
.83 .24 .1 r
.51714 .5486 m
.5367 .52939 L
s
.51714 .5486 m
.52932 .57239 L
s
.49867 .6794 m
.51794 .66237 L
s
.49867 .6794 m
.49113 .70039 L
s
.24 .35 .67 r
.60372 .5768 m
.57152 .56604 L
s
.60372 .5768 m
.60005 .60304 L
s
.64501 .477 m
.63132 .49941 L
s
.63132 .49941 m
.59935 .48789 L
s
.83 .24 .1 r
.34573 .48648 m
.36938 .4852 L
s
.36938 .4852 m
.3865 .46487 L
s
.41127 .46875 m
.43599 .47732 L
s
.43599 .47732 m
.45425 .45684 L
s
.25823 .55936 m
.27335 .54349 L
s
.27335 .54349 m
.28888 .5241 L
s
.52932 .57239 m
.53707 .59696 L
s
.52027 .63921 m
.54001 .6214 L
s
.52027 .63921 m
.51794 .66237 L
s
.24 .35 .67 r
.63162 .63821 m
.5995 .62799 L
s
.63162 .63821 m
.63467 .66082 L
s
.60005 .60304 m
.56761 .59247 L
s
.60005 .60304 m
.5995 .62799 L
s
.58767 .51285 m
.57829 .5392 L
s
.57829 .5392 m
.57152 .56604 L
s
.59935 .48789 m
.58767 .51285 L
s
.58767 .51285 m
.55509 .50139 L
s
.83 .24 .1 r
.28888 .5241 m
.30775 .51278 L
s
.30775 .51278 m
.32393 .49279 L
s
.45991 .73466 m
.47868 .71843 L
s
.45991 .73466 m
.44296 .74882 L
s
.24 .35 .67 r
.66026 .4577 m
.64501 .477 L
s
.64501 .477 m
.61295 .46519 L
s
.70841 .45448 m
.69186 .46959 L
s
.69186 .46959 m
.66026 .4577 L
s
.66652 .67076 m
.63467 .66082 L
s
.66652 .67076 m
.67325 .6902 L
s
.83 .24 .1 r
.3865 .46487 m
.41127 .46875 L
s
.41127 .46875 m
.42924 .44798 L
s
.24 .35 .67 r
.57152 .56604 m
.56761 .59247 L
s
.757 .45621 m
.73962 .46644 L
s
.73962 .46644 m
.70841 .45448 L
s
.61295 .46519 m
.59935 .48789 L
s
.59935 .48789 m
.56677 .47615 L
s
.83 .24 .1 r
.47832 .46999 m
.5006 .4869 L
s
.5006 .4869 m
.5203 .50694 L
s
.32393 .49279 m
.34573 .48648 L
s
.34573 .48648 m
.36264 .46595 L
s
.49113 .70039 m
.51051 .6835 L
s
.49113 .70039 m
.47868 .71843 L
s
.53707 .59696 m
.54001 .6214 L
s
.5203 .50694 m
.5367 .52939 L
s
.45425 .45684 m
.47832 .46999 L
s
.47832 .46999 m
.49752 .44914 L
s
.24757 .57919 m
.25823 .55936 L
s
.25823 .55936 m
.27371 .53999 L
s
.24 .35 .67 r
.5995 .62799 m
.56675 .61756 L
s
.5995 .62799 m
.60219 .6507 L
s
.56761 .59247 m
.56675 .61756 L
s
.278 .395 .76 r
.52958 .54506 m .54449 .55007 L .54043 .52633 L p F P
0 0 0 r
s
.83 .24 .1 r
.5367 .52939 m
.53762 .53117 L
s
.271 .384 .736 r
.54449 .55007 m .52958 .54506 L .53164 .56749 L p F P
0 0 0 r
s
.271 .384 .736 r
.53164 .56749 m .54757 .57274 L .54449 .55007 L p F P
0 0 0 r
s
.83 .24 .1 r
.52932 .57239 m
.53374 .56818 L
s
.659 .189 .085 r
.55357 .54137 m .54449 .55007 L .54043 .52633 L p F P
0 0 0 r
s
.24 .35 .67 r
.54563 .528 m
.57829 .5392 L
s
.585 .167 .076 r
.54449 .55007 m .55357 .54137 L .55732 .56361 L p F P
0 0 0 r
s
.24 .35 .67 r
.55691 .56116 m
.57152 .56604 L
s
.585 .167 .076 r
.55732 .56361 m .54757 .57274 L .54449 .55007 L p F P
0 0 0 r
s
.83 .24 .1 r
.54466 .55778 m
.5492 .55347 L
s
.24 .35 .67 r
.53869 .55507 m
.54614 .55756 L
s
.83 .24 .1 r
.51794 .66237 m
.53787 .64475 L
s
.51794 .66237 m
.51051 .6835 L
s
.24 .35 .67 r
.54563 .528 m
.55509 .50139 L
s
.54478 .53131 m
.54563 .528 L
s
.56677 .47615 m
.55509 .50139 L
s
.282 .404 .78 r
.52687 .52168 m .54043 .52633 L .53545 .5019 L p F P
0 0 0 r
s
.278 .395 .76 r
.54043 .52633 m .52687 .52168 L .52958 .54506 L p F P
0 0 0 r
s
.723 .209 .093 r
.54865 .51826 m .54043 .52633 L .53545 .5019 L p F P
0 0 0 r
s
.659 .189 .085 r
.54043 .52633 m .54865 .51826 L .55357 .54137 L p F P
0 0 0 r
s
.24 .35 .67 r
.53869 .55507 m
.54336 .53684 L
s
.83 .24 .1 r
.54078 .53724 m
.5492 .55347 L
s
.24 .35 .67 r
.62804 .44558 m
.61295 .46519 L
s
.61295 .46519 m
.58027 .45314 L
s
.67658 .4423 m
.66026 .4577 L
s
.66026 .4577 m
.62804 .44558 L
s
.83 .24 .1 r
.36264 .46595 m
.3865 .46487 L
s
.3865 .46487 m
.40421 .44384 L
s
.24 .35 .67 r
.63467 .66082 m
.60219 .6507 L
s
.63467 .66082 m
.64101 .68032 L
s
.497 .14 .065 r
.54757 .57274 m .55732 .56361 L .55981 .58459 L p F P
0 0 0 r
s
.497 .14 .065 r
.55981 .58459 m .54962 .59394 L .54757 .57274 L p F P
0 0 0 r
s
.24 .35 .67 r
.55552 .58853 m
.56761 .59247 L
s
.264 .37 .707 r
.54757 .57274 m .53164 .56749 L .53301 .58856 L p F P
0 0 0 r
s
.264 .37 .707 r
.53301 .58856 m .54962 .59394 L .54757 .57274 L p F P
0 0 0 r
s
.83 .24 .1 r
.53707 .59696 m
.54274 .59171 L
s
.24 .35 .67 r
.53453 .58169 m
.54949 .58656 L
s
.83 .24 .1 r
.42924 .44798 m
.45425 .45684 L
s
.45425 .45684 m
.47313 .43566 L
s
.24 .35 .67 r
.53453 .58169 m
.53869 .55507 L
s
.83 .24 .1 r
.27371 .53999 m
.28888 .5241 L
s
.28888 .5241 m
.30495 .50405 L
s
.24 .35 .67 r
.7255 .44399 m
.70841 .45448 L
s
.70841 .45448 m
.67658 .4423 L
s
.286 .412 .798 r
.52355 .49774 m .53545 .5019 L .52965 .4772 L p F P
0 0 0 r
s
.83 .24 .1 r
.5203 .50694 m
.52787 .49925 L
s
.282 .404 .78 r
.53545 .5019 m .52355 .49774 L .52687 .52168 L p F P
0 0 0 r
s
.781 .227 .1 r
.54263 .49468 m .53545 .5019 L .52965 .4772 L p F P
0 0 0 r
s
.723 .209 .093 r
.53545 .5019 m .54263 .49468 L .54865 .51826 L p F P
0 0 0 r
s
.24 .35 .67 r
.54329 .49724 m
.55509 .50139 L
s
.58027 .45314 m
.56677 .47615 L
s
.83 .24 .1 r
.44296 .74882 m
.46169 .73262 L
s
.44296 .74882 m
.42216 .75839 L
s
.278 .395 .76 r
.51454 .54001 m .52958 .54506 L .52687 .52168 L p F P
0 0 0 r
s
.271 .384 .736 r
.52958 .54506 m .51454 .54001 L .51556 .56218 L p F P
0 0 0 r
s
.271 .384 .736 r
.51556 .56218 m .53164 .56749 L .52958 .54506 L p F P
0 0 0 r
s
.282 .404 .78 r
.5132 .517 m .52687 .52168 L .52355 .49774 L p F P
0 0 0 r
s
.278 .395 .76 r
.52687 .52168 m .5132 .517 L .51454 .54001 L p F P
0 0 0 r
s
.24 .35 .67 r
.67325 .6902 m
.64101 .68032 L
s
.67325 .6902 m
.68318 .70568 L
s
.391 .108 .052 r
.54962 .59394 m .55981 .58459 L .56099 .60393 L p F P
0 0 0 r
s
.83 .24 .1 r
.54808 .58677 m
.55724 .5783 L
s
.391 .108 .052 r
.56099 .60393 m .55059 .61329 L .54962 .59394 L p F P
0 0 0 r
s
.254 .353 .671 r
.54962 .59394 m .53301 .58856 L .53366 .60791 L p F P
0 0 0 r
s
.254 .353 .671 r
.53366 .60791 m .55059 .61329 L .54962 .59394 L p F P
0 0 0 r
s
.264 .37 .707 r
.53164 .56749 m .51556 .56218 L .51624 .58313 L p F P
0 0 0 r
s
.264 .37 .707 r
.51624 .58313 m .53301 .58856 L .53164 .56749 L p F P
0 0 0 r
s
.659 .189 .085 r
.5628 .53252 m .55357 .54137 L .54865 .51826 L p F P
0 0 0 r
s
.585 .167 .076 r
.55357 .54137 m .5628 .53252 L .56723 .55433 L p F P
0 0 0 r
s
.585 .167 .076 r
.56723 .55433 m .55732 .56361 L .55357 .54137 L p F P
0 0 0 r
s
.83 .24 .1 r
.5492 .55347 m
.55724 .5783 L
s
.723 .209 .093 r
.55699 .51007 m .54865 .51826 L .54263 .49468 L p F P
0 0 0 r
s
.659 .189 .085 r
.54865 .51826 m .55699 .51007 L .5628 .53252 L p F P
0 0 0 r
s
.286 .412 .798 r
.52965 .4772 m .51968 .47365 L .52355 .49774 L p F P
0 0 0 r
s
.286 .412 .798 r
.51157 .49355 m .52355 .49774 L .51968 .47365 L p F P
0 0 0 r
s
.282 .404 .78 r
.52355 .49774 m .51157 .49355 L .5132 .517 L p F P
0 0 0 r
s
.83 .24 .1 r
.30495 .50405 m
.32393 .49279 L
s
.32393 .49279 m
.34067 .47212 L
s
.47868 .71843 m
.49811 .70163 L
s
.47868 .71843 m
.46169 .73262 L
s
.24 .35 .67 r
.77432 .4512 m
.757 .45621 L
s
.757 .45621 m
.7255 .44399 L
s
.282 .404 .78 r
.49943 .51227 m .5132 .517 L .51157 .49355 L p F P
0 0 0 r
s
.278 .395 .76 r
.5132 .517 m .49943 .51227 L .49937 .53491 L p F P
0 0 0 r
s
.278 .395 .76 r
.49937 .53491 m .51454 .54001 L .5132 .517 L p F P
0 0 0 r
s
.24 .35 .67 r
.51233 .51658 m
.54143 .52656 L
s
.271 .384 .736 r
.51454 .54001 m .49937 .53491 L .49932 .55683 L p F P
0 0 0 r
s
.271 .384 .736 r
.49932 .55683 m .51556 .56218 L .51454 .54001 L p F P
0 0 0 r
s
.24 .35 .67 r
.50521 .54388 m
.53869 .55507 L
s
.56675 .61756 m
.56907 .64037 L
s
.83 .24 .1 r
.40421 .44384 m
.42924 .44798 L
s
.42924 .44798 m
.44783 .4265 L
s
.497 .14 .065 r
.55732 .56361 m .56723 .55433 L .57018 .57508 L p F P
0 0 0 r
s
.497 .14 .065 r
.57018 .57508 m .55981 .58459 L .55732 .56361 L p F P
0 0 0 r
s
.24 .35 .67 r
.51233 .51658 m
.52187 .48971 L
s
.50521 .54388 m
.51233 .51658 L
s
.833 .243 .106 r
.53561 .47104 m .52965 .4772 L .52309 .45265 L p F P
0 0 0 r
s
.781 .227 .1 r
.52965 .4772 m .53561 .47104 L .54263 .49468 L p F P
0 0 0 r
s
.24 .35 .67 r
.52187 .48971 m
.53462 .4942 L
s
.289 .419 .812 r
.51968 .47365 m .52965 .4772 L .52309 .45265 L p F P
0 0 0 r
s
.781 .227 .1 r
.54989 .48737 m .54263 .49468 L .53561 .47104 L p F P
0 0 0 r
s
.83 .24 .1 r
.53252 .49453 m
.54018 .48675 L
s
.24 .35 .67 r
.53354 .46417 m
.56677 .47615 L
s
.723 .209 .093 r
.54263 .49468 m .54989 .48737 L .55699 .51007 L p F P
0 0 0 r
s
.24 .35 .67 r
.52187 .48971 m
.53019 .4715 L
s
.53249 .46646 m
.53354 .46417 L
s
.254 .353 .671 r
.53301 .58856 m .51624 .58313 L .51656 .60246 L p F P
0 0 0 r
s
.254 .353 .671 r
.51656 .60246 m .53366 .60791 L .53301 .58856 L p F P
0 0 0 r
s
.24 .35 .67 r
.59518 .43322 m
.58027 .45314 L
s
.286 .412 .798 r
.51968 .47365 m .50966 .47008 L .51157 .49355 L p F P
0 0 0 r
s
.83 .24 .1 r
.5006 .4869 m
.51021 .47681 L
s
.51485 .47193 m
.52014 .46638 L
s
.286 .412 .798 r
.4995 .48933 m .51157 .49355 L .50966 .47008 L p F P
0 0 0 r
s
.282 .404 .78 r
.51157 .49355 m .4995 .48933 L .49943 .51227 L p F P
0 0 0 r
s
.264 .37 .707 r
.51556 .56218 m .49932 .55683 L .49929 .57765 L p F P
0 0 0 r
s
.264 .37 .707 r
.49929 .57765 m .51624 .58313 L .51556 .56218 L p F P
0 0 0 r
s
.24 .35 .67 r
.64411 .42987 m
.62804 .44558 L
s
.62804 .44558 m
.59518 .43322 L
s
.60219 .6507 m
.56907 .64037 L
s
.60219 .6507 m
.60813 .67024 L
s
.83 .24 .1 r
.24202 .6022 m
.24757 .57919 L
s
.24757 .57919 m
.26305 .55992 L
s
.52014 .46638 m
.52101 .46546 L
s
.52587 .47221 m
.54018 .48675 L
s
.52014 .46638 m
.52076 .46702 L
s
.34067 .47212 m
.36264 .46595 L
s
.36264 .46595 m
.38013 .44471 L
s
.51051 .6835 m
.53057 .66603 L
s
.51051 .6835 m
.49811 .70163 L
s
.282 .404 .78 r
.48554 .50751 m .49943 .51227 L .4995 .48933 L p F P
0 0 0 r
s
.278 .395 .76 r
.49943 .51227 m .48554 .50751 L .48406 .52976 L p F P
0 0 0 r
s
.278 .395 .76 r
.48406 .52976 m .49937 .53491 L .49943 .51227 L p F P
0 0 0 r
s
.24 .35 .67 r
.5008 .57069 m
.50521 .54388 L
s
.289 .419 .812 r
.52309 .45265 m .51532 .44983 L .51968 .47365 L p F P
0 0 0 r
s
.289 .419 .812 r
.50966 .47008 m .51968 .47365 L .51532 .44983 L p F P
0 0 0 r
s
.83 .24 .1 r
.49752 .44914 m
.51235 .46045 L
s
.271 .384 .736 r
.49937 .53491 m .48406 .52976 L .48293 .55142 L p F P
0 0 0 r
s
.271 .384 .736 r
.48293 .55142 m .49932 .55683 L .49937 .53491 L p F P
0 0 0 r
s
.24 .33 .624 r
.55059 .61329 m .53366 .60791 L .53356 .62513 L p F P
0 0 0 r
s
.83 .24 .1 r
.54001 .6214 m
.54364 .61813 L
s
.24 .33 .624 r
.53356 .62513 m .55044 .63042 L .55059 .61329 L p F P
0 0 0 r
s
.83 .24 .1 r
.53787 .64475 m
.5395 .62699 L
s
.273 .073 .037 r
.55059 .61329 m .56099 .60393 L .56081 .62123 L p F P
0 0 0 r
s
.24 .35 .67 r
.56087 .61568 m
.56675 .61756 L
s
.273 .073 .037 r
.56081 .62123 m .55044 .63042 L .55059 .61329 L p F P
0 0 0 r
s
.24 .35 .67 r
.69338 .43152 m
.67658 .4423 L
s
.67658 .4423 m
.64411 .42987 L
s
.5301 .46294 m
.53354 .46417 L
s
.723 .209 .093 r
.56544 .50177 m .55699 .51007 L .54989 .48737 L p F P
0 0 0 r
s
.83 .24 .1 r
.53924 .5269 m
.55693 .50952 L
s
.659 .189 .085 r
.55699 .51007 m .56544 .50177 L .57217 .52354 L p F P
0 0 0 r
s
.659 .189 .085 r
.57217 .52354 m .5628 .53252 L .55699 .51007 L p F P
0 0 0 r
s
.286 .412 .798 r
.50966 .47008 m .49958 .46649 L .4995 .48933 L p F P
0 0 0 r
s
.286 .412 .798 r
.48734 .48509 m .4995 .48933 L .49958 .46649 L p F P
0 0 0 r
s
.282 .404 .78 r
.4995 .48933 m .48734 .48509 L .48554 .50751 L p F P
0 0 0 r
s
.391 .108 .052 r
.55981 .58459 m .57018 .57508 L .57157 .5944 L p F P
0 0 0 r
s
.391 .108 .052 r
.57157 .5944 m .56099 .60393 L .55981 .58459 L p F P
0 0 0 r
s
.83 .24 .1 r
.55724 .5783 m
.56044 .60298 L
s
.54941 .61292 m
.56044 .60298 L
s
.585 .167 .076 r
.5628 .53252 m .57217 .52354 L .5773 .54489 L p F P
0 0 0 r
s
.585 .167 .076 r
.5773 .54489 m .56723 .55433 L .5628 .53252 L p F P
0 0 0 r
s
.833 .243 .106 r
.52309 .45265 m .52771 .44776 L .53561 .47104 L p F P
0 0 0 r
s
.833 .243 .106 r
.54164 .46482 m .53561 .47104 L .52771 .44776 L p F P
0 0 0 r
s
.781 .227 .1 r
.53561 .47104 m .54164 .46482 L .54989 .48737 L p F P
0 0 0 r
s
.83 .24 .1 r
.54018 .48675 m
.55693 .50952 L
s
.24 .35 .67 r
.64101 .68032 m
.60813 .67024 L
s
.64101 .68032 m
.65054 .6958 L
s
.264 .37 .707 r
.49932 .55683 m .48293 .55142 L .48218 .57211 L p F P
0 0 0 r
s
.264 .37 .707 r
.48218 .57211 m .49929 .57765 L .49932 .55683 L p F P
0 0 0 r
s
.289 .419 .812 r
.51532 .44983 m .50752 .447 L .50966 .47008 L p F P
0 0 0 r
s
.289 .419 .812 r
.49958 .46649 m .50966 .47008 L .50752 .447 L p F P
0 0 0 r
s
.254 .353 .671 r
.51624 .58313 m .49929 .57765 L .49928 .59697 L p F P
0 0 0 r
s
.24 .35 .67 r
.5008 .57069 m
.53453 .58169 L
s
.254 .353 .671 r
.49928 .59697 m .51656 .60246 L .51624 .58313 L p F P
0 0 0 r
s
.781 .227 .1 r
.55725 .47997 m .54989 .48737 L .54164 .46482 L p F P
0 0 0 r
s
.723 .209 .093 r
.54989 .48737 m .55725 .47997 L .56544 .50177 L p F P
0 0 0 r
s
.83 .24 .1 r
.26305 .55992 m
.27371 .53999 L
s
.27371 .53999 m
.28972 .51995 L
s
.42216 .75839 m
.44076 .74215 L
s
.42216 .75839 m
.39833 .76276 L
s
.282 .404 .78 r
.47154 .50272 m .48554 .50751 L .48734 .48509 L p F P
0 0 0 r
s
.278 .395 .76 r
.48554 .50751 m .47154 .50272 L .46862 .52457 L p F P
0 0 0 r
s
.278 .395 .76 r
.46862 .52457 m .48406 .52976 L .48554 .50751 L p F P
0 0 0 r
s
.24 .35 .67 r
.47836 .50494 m
.51233 .51658 L
s
.271 .384 .736 r
.48406 .52976 m .46862 .52457 L .46639 .54597 L p F P
0 0 0 r
s
.271 .384 .736 r
.46639 .54597 m .48293 .55142 L .48406 .52976 L p F P
0 0 0 r
s
.24 .35 .67 r
.47107 .53248 m
.50521 .54388 L
s
.497 .14 .065 r
.56723 .55433 m .5773 .54489 L .58072 .56541 L p F P
0 0 0 r
s
.83 .24 .1 r
.5492 .55347 m
.56976 .5339 L
s
.497 .14 .065 r
.58072 .56541 m .57018 .57508 L .56723 .55433 L p F P
0 0 0 r
s
.24 .33 .624 r
.53366 .60791 m .51656 .60246 L .51651 .61979 L p F P
0 0 0 r
s
.24 .35 .67 r
.53335 .60692 m
.53453 .58169 L
s
.24 .33 .624 r
.51651 .61979 m .53356 .62513 L .53366 .60791 L p F P
0 0 0 r
s
.24 .35 .67 r
.53335 .60692 m
.55132 .61264 L
s
.286 .412 .798 r
.49958 .46649 m .48944 .46288 L .48734 .48509 L p F P
0 0 0 r
s
.286 .412 .798 r
.4751 .48081 m .48734 .48509 L .48944 .46288 L p F P
0 0 0 r
s
.24 .35 .67 r
.48799 .4778 m
.52187 .48971 L
s
.282 .404 .78 r
.48734 .48509 m .4751 .48081 L .47154 .50272 L p F P
0 0 0 r
s
.24 .35 .67 r
.74249 .43872 m
.7255 .44399 L
s
.7255 .44399 m
.69338 .43152 L
s
.291 .424 .825 r
.51532 .44983 m .52309 .45265 L .51589 .42869 L p F P
0 0 0 r
s
.883 .258 .112 r
.52771 .44776 m .52309 .45265 L .51589 .42869 L p F P
0 0 0 r
s
.83 .24 .1 r
.38013 .44471 m
.40421 .44384 L
s
.40421 .44384 m
.42254 .42208 L
s
.289 .419 .812 r
.50752 .447 m .49967 .44416 L .49958 .46649 L p F P
0 0 0 r
s
.83 .24 .1 r
.49752 .44914 m
.49966 .44681 L
s
.289 .419 .812 r
.48944 .46288 m .49958 .46649 L .49967 .44416 L p F P
0 0 0 r
s
.83 .24 .1 r
.47313 .43566 m
.49708 .4489 L
s
.44783 .4265 m
.47313 .43566 L
s
.24 .35 .67 r
.47836 .50494 m
.48799 .4778 L
s
.833 .243 .106 r
.52771 .44776 m .53236 .44283 L .54164 .46482 L p F P
0 0 0 r
s
.833 .243 .106 r
.54773 .45853 m .54164 .46482 L .53236 .44283 L p F P
0 0 0 r
s
.24 .35 .67 r
.54083 .45148 m
.54694 .44085 L
s
.54694 .44085 m
.58027 .45314 L
s
.781 .227 .1 r
.54164 .46482 m .54773 .45853 L .55725 .47997 L p F P
0 0 0 r
s
.83 .24 .1 r
.28972 .51995 m
.30495 .50405 L
s
.30495 .50405 m
.32157 .4833 L
s
.264 .37 .707 r
.48293 .55142 m .46639 .54597 L .4649 .56651 L p F P
0 0 0 r
s
.264 .37 .707 r
.4649 .56651 m .48218 .57211 L .48293 .55142 L p F P
0 0 0 r
s
.282 .404 .78 r
.45743 .49788 m .47154 .50272 L .4751 .48081 L p F P
0 0 0 r
s
.278 .395 .76 r
.47154 .50272 m .45743 .49788 L .45303 .51933 L p F P
0 0 0 r
s
.278 .395 .76 r
.45303 .51933 m .46862 .52457 L .47154 .50272 L p F P
0 0 0 r
s
.24 .35 .67 r
.47107 .53248 m
.47836 .50494 L
s
.291 .424 .825 r
.51589 .42869 m .51054 .42672 L .51532 .44983 L p F P
0 0 0 r
s
.291 .424 .825 r
.50752 .447 m .51532 .44983 L .51054 .42672 L p F P
0 0 0 r
s
.254 .353 .671 r
.49929 .57765 m .48218 .57211 L .48183 .59142 L p F P
0 0 0 r
s
.254 .353 .671 r
.48183 .59142 m .49928 .59697 L .49929 .57765 L p F P
0 0 0 r
s
.24 .35 .67 r
.49929 .59608 m
.5008 .57069 L
s
.611 .41719 m
.59518 .43322 L
s
.59518 .43322 m
.56166 .4206 L
s
.56907 .64037 m
.57459 .65996 L
s
.83 .24 .1 r
.46169 .73262 m
.48108 .71585 L
s
.46169 .73262 m
.44076 .74215 L
s
.24 .35 .67 r
.68318 .70568 m
.65054 .6958 L
s
.68318 .70568 m
.69607 .71638 L
s
.723 .209 .093 r
.57402 .49335 m .56544 .50177 L .55725 .47997 L p F P
0 0 0 r
s
.659 .189 .085 r
.56544 .50177 m .57402 .49335 L .58169 .51442 L p F P
0 0 0 r
s
.659 .189 .085 r
.58169 .51442 m .57217 .52354 L .56544 .50177 L p F P
0 0 0 r
s
.83 .24 .1 r
.55693 .50952 m
.56976 .5339 L
s
.286 .412 .798 r
.48944 .46288 m .47924 .45925 L .4751 .48081 L p F P
0 0 0 r
s
.286 .412 .798 r
.46277 .4765 m .4751 .48081 L .47924 .45925 L p F P
0 0 0 r
s
.282 .404 .78 r
.4751 .48081 m .46277 .4765 L .45743 .49788 L p F P
0 0 0 r
s
.273 .073 .037 r
.56099 .60393 m .57157 .5944 L .57136 .61188 L p F P
0 0 0 r
s
.273 .073 .037 r
.57136 .61188 m .56081 .62123 L .56099 .60393 L p F P
0 0 0 r
s
.289 .419 .812 r
.49967 .44416 m .4918 .4413 L .48944 .46288 L p F P
0 0 0 r
s
.24 .35 .67 r
.49965 .45196 m
.52678 .46174 L
s
.289 .419 .812 r
.47924 .45925 m .48944 .46288 L .4918 .4413 L p F P
0 0 0 r
s
.24 .35 .67 r
.48799 .4778 m
.49965 .45196 L
s
.271 .384 .736 r
.46862 .52457 m .45303 .51933 L .44968 .54046 L p F P
0 0 0 r
s
.271 .384 .736 r
.44968 .54046 m .46639 .54597 L .46862 .52457 L p F P
0 0 0 r
s
.781 .227 .1 r
.56469 .47247 m .55725 .47997 L .54773 .45853 L p F P
0 0 0 r
s
.723 .209 .093 r
.55725 .47997 m .56469 .47247 L .57402 .49335 L p F P
0 0 0 r
s
.883 .258 .112 r
.51589 .42869 m .51904 .42527 L .52771 .44776 L p F P
0 0 0 r
s
.883 .258 .112 r
.53236 .44283 m .52771 .44776 L .51904 .42527 L p F P
0 0 0 r
s
.161 .046 .023 r
.55044 .63042 m .56081 .62123 L .55923 .63611 L p F P
0 0 0 r
s
.161 .046 .023 r
.55923 .63611 m .54914 .64493 L .55044 .63042 L p F P
0 0 0 r
s
.24 .35 .67 r
.55822 .63698 m
.56907 .64037 L
s
.221 .299 .561 r
.55044 .63042 m .53356 .62513 L .53269 .63986 L p F P
0 0 0 r
s
.221 .299 .561 r
.53269 .63986 m .54914 .64493 L .55044 .63042 L p F P
0 0 0 r
s
.83 .24 .1 r
.53787 .64475 m
.54064 .64231 L
s
.54913 .6348 m
.5585 .62652 L
s
.24 .35 .67 r
.53529 .62983 m
.55057 .6346 L
s
.83 .24 .1 r
.53057 .66603 m
.53787 .64475 L
s
.585 .167 .076 r
.57217 .52354 m .58169 .51442 L .58754 .53529 L p F P
0 0 0 r
s
.585 .167 .076 r
.58754 .53529 m .5773 .54489 L .57217 .52354 L p F P
0 0 0 r
s
.24 .35 .67 r
.46639 .55948 m
.47107 .53248 L
s
.291 .424 .825 r
.51054 .42672 m .50516 .42474 L .50752 .447 L p F P
0 0 0 r
s
.83 .24 .1 r
.5015 .44482 m
.50669 .43918 L
s
.291 .424 .825 r
.49967 .44416 m .50752 .447 L .50516 .42474 L p F P
0 0 0 r
s
.24 .33 .624 r
.51656 .60246 m .49928 .59697 L .49928 .6144 L p F P
0 0 0 r
s
.24 .33 .624 r
.49928 .6144 m .51651 .61979 L .51656 .60246 L p F P
0 0 0 r
s
.24 .35 .67 r
.49929 .59608 m
.53335 .60692 L
s
.391 .108 .052 r
.57018 .57508 m .58072 .56541 L .58234 .5847 L p F P
0 0 0 r
s
.391 .108 .052 r
.58234 .5847 m .57157 .5944 L .57018 .57508 L p F P
0 0 0 r
s
.83 .24 .1 r
.25759 .58311 m
.24202 .6022 L
s
.24203 .62739 m
.24202 .6022 L
s
.24 .35 .67 r
.6606 .4188 m
.64411 .42987 L
s
.64411 .42987 m
.611 .41719 L
s
.79087 .45184 m
.77432 .4512 L
s
.77432 .4512 m
.74249 .43872 L
s
.83 .24 .1 r
.32157 .4833 m
.34067 .47212 L
s
.34067 .47212 m
.35799 .45071 L
s
.289 .419 .812 r
.4918 .4413 m .48388 .43843 L .47924 .45925 L p F P
0 0 0 r
s
.289 .419 .812 r
.46898 .45559 m .47924 .45925 L .48388 .43843 L p F P
0 0 0 r
s
.286 .412 .798 r
.47924 .45925 m .46898 .45559 L .46277 .4765 L p F P
0 0 0 r
s
.282 .404 .78 r
.4432 .493 m .45743 .49788 L .46277 .4765 L p F P
0 0 0 r
s
.278 .395 .76 r
.45743 .49788 m .4432 .493 L .43731 .51404 L p F P
0 0 0 r
s
.278 .395 .76 r
.43731 .51404 m .45303 .51933 L .45743 .49788 L p F P
0 0 0 r
s
.24 .35 .67 r
.44372 .49306 m
.47836 .50494 L
s
.286 .412 .798 r
.45036 .47216 m .46277 .4765 L .46898 .45559 L p F P
0 0 0 r
s
.282 .404 .78 r
.46277 .4765 m .45036 .47216 L .4432 .493 L p F P
0 0 0 r
s
.833 .243 .106 r
.53236 .44283 m .53705 .43787 L .54773 .45853 L p F P
0 0 0 r
s
.833 .243 .106 r
.55388 .45218 m .54773 .45853 L .53705 .43787 L p F P
0 0 0 r
s
.83 .24 .1 r
.52414 .46218 m
.54035 .44515 L
s
.781 .227 .1 r
.54773 .45853 m .55388 .45218 L .56469 .47247 L p F P
0 0 0 r
s
.264 .37 .707 r
.46639 .54597 m .44968 .54046 L .44745 .56086 L p F P
0 0 0 r
s
.264 .37 .707 r
.44745 .56086 m .4649 .56651 L .46639 .54597 L p F P
0 0 0 r
s
.291 .424 .825 r
.50516 .42474 m .49978 .42275 L .49967 .44416 L p F P
0 0 0 r
s
.291 .424 .825 r
.4918 .4413 m .49967 .44416 L .49978 .42275 L p F P
0 0 0 r
s
.83 .24 .1 r
.49811 .70163 m
.51822 .68424 L
s
.49811 .70163 m
.48108 .71585 L
s
.24 .35 .67 r
.60813 .67024 m
.57459 .65996 L
s
.60813 .67024 m
.61723 .68572 L
s
.254 .353 .671 r
.48218 .57211 m .4649 .56651 L .4642 .58581 L p F P
0 0 0 r
s
.24 .35 .67 r
.46639 .55948 m
.5008 .57069 L
s
.254 .353 .671 r
.4642 .58581 m .48183 .59142 L .48218 .57211 L p F P
0 0 0 r
s
.497 .14 .065 r
.5773 .54489 m .58754 .53529 L .59145 .55556 L p F P
0 0 0 r
s
.497 .14 .065 r
.59145 .55556 m .58072 .56541 L .5773 .54489 L p F P
0 0 0 r
s
.83 .24 .1 r
.56976 .5339 m
.57812 .559 L
s
.55724 .5783 m
.57812 .559 L
s
.42254 .42208 m
.44783 .4265 L
s
.883 .258 .112 r
.51904 .42527 m .52221 .42183 L .53236 .44283 L p F P
0 0 0 r
s
.883 .258 .112 r
.53705 .43787 m .53236 .44283 L .52221 .42183 L p F P
0 0 0 r
s
.24 .35 .67 r
.53613 .43687 m
.54694 .44085 L
s
.271 .384 .736 r
.45303 .51933 m .43731 .51404 L .43282 .53489 L p F P
0 0 0 r
s
.271 .384 .736 r
.43282 .53489 m .44968 .54046 L .45303 .51933 L p F P
0 0 0 r
s
.83 .24 .1 r
.39833 .76276 m
.41672 .74641 L
s
.39833 .76276 m
.37254 .76154 L
s
.221 .299 .561 r
.53356 .62513 m .51651 .61979 L .51608 .63473 L p F P
0 0 0 r
s
.221 .299 .561 r
.51608 .63473 m .53269 .63986 L .53356 .62513 L p F P
0 0 0 r
s
.24 .35 .67 r
.53335 .60692 m
.53529 .62983 L
s
.291 .424 .825 r
.49978 .42275 m .49437 .42076 L .4918 .4413 L p F P
0 0 0 r
s
.291 .424 .825 r
.48388 .43843 m .4918 .4413 L .49437 .42076 L p F P
0 0 0 r
s
.289 .419 .812 r
.48388 .43843 m .47593 .43555 L .46898 .45559 L p F P
0 0 0 r
s
.289 .419 .812 r
.45866 .45192 m .46898 .45559 L .47593 .43555 L p F P
0 0 0 r
s
.286 .412 .798 r
.46898 .45559 m .45866 .45192 L .45036 .47216 L p F P
0 0 0 r
s
.24 .33 .624 r
.49928 .59697 m .48183 .59142 L .48188 .60895 L p F P
0 0 0 r
s
.24 .33 .624 r
.48188 .60895 m .49928 .6144 L .49928 .59697 L p F P
0 0 0 r
s
.24 .35 .67 r
.71001 .42599 m
.69338 .43152 L
s
.69338 .43152 m
.6606 .4188 L
s
.781 .227 .1 r
.57223 .46489 m .56469 .47247 L .55388 .45218 L p F P
0 0 0 r
s
.83 .24 .1 r
.54018 .48675 m
.56076 .46586 L
s
.723 .209 .093 r
.56469 .47247 m .57223 .46489 L .58272 .48481 L p F P
0 0 0 r
s
.723 .209 .093 r
.58272 .48481 m .57402 .49335 L .56469 .47247 L p F P
0 0 0 r
s
.659 .189 .085 r
.57402 .49335 m .58272 .48481 L .59135 .50516 L p F P
0 0 0 r
s
.659 .189 .085 r
.59135 .50516 m .58169 .51442 L .57402 .49335 L p F P
0 0 0 r
s
.83 .24 .1 r
.55693 .50952 m
.57787 .48896 L
s
.286 .412 .798 r
.43785 .46779 m .45036 .47216 L .45866 .45192 L p F P
0 0 0 r
s
.24 .35 .67 r
.45344 .46565 m
.48799 .4778 L
s
.282 .404 .78 r
.45036 .47216 m .43785 .46779 L .42885 .48808 L p F P
0 0 0 r
s
.282 .404 .78 r
.42885 .48808 m .4432 .493 L .45036 .47216 L p F P
0 0 0 r
s
.278 .395 .76 r
.4432 .493 m .42885 .48808 L .42144 .50871 L p F P
0 0 0 r
s
.278 .395 .76 r
.42144 .50871 m .43731 .51404 L .4432 .493 L p F P
0 0 0 r
s
.83 .24 .1 r
.25759 .58311 m
.26305 .55992 L
s
.26305 .55992 m
.27909 .53997 L
s
.54035 .44515 m
.56076 .46586 L
s
.93 .273 .118 r
.51904 .42527 m .51589 .42869 L .50815 .4058 L p F P
0 0 0 r
s
.291 .428 .835 r
.51054 .42672 m .51589 .42869 L .50815 .4058 L p F P
0 0 0 r
s
.24 .35 .67 r
.51295 .42832 m
.5189 .43051 L
s
.83 .24 .1 r
.51389 .43136 m
.51739 .42756 L
s
.24 .35 .67 r
.49965 .45196 m
.51295 .42832 L
s
.83 .24 .1 r
.35799 .45071 m
.38013 .44471 L
s
.24 .35 .67 r
.44372 .49306 m
.45344 .46565 L
s
.83 .24 .1 r
.53057 .66603 m
.51822 .68424 L
s
.56076 .46586 m
.57787 .48896 L
s
.291 .424 .825 r
.49437 .42076 m .48895 .41876 L .48388 .43843 L p F P
0 0 0 r
s
.291 .424 .825 r
.47593 .43555 m .48388 .43843 L .48895 .41876 L p F P
0 0 0 r
s
.264 .37 .707 r
.44968 .54046 m .43282 .53489 L .42981 .55515 L p F P
0 0 0 r
s
.264 .37 .707 r
.42981 .55515 m .44745 .56086 L .44968 .54046 L p F P
0 0 0 r
s
.883 .258 .112 r
.52221 .42183 m .5254 .41836 L .53705 .43787 L p F P
0 0 0 r
s
.883 .258 .112 r
.54178 .43286 m .53705 .43787 L .5254 .41836 L p F P
0 0 0 r
s
.833 .243 .106 r
.53705 .43787 m .54178 .43286 L .55388 .45218 L p F P
0 0 0 r
s
.83 .24 .1 r
.51739 .42756 m
.54035 .44515 L
s
.833 .243 .106 r
.56009 .44577 m .55388 .45218 L .54178 .43286 L p F P
0 0 0 r
s
.24 .35 .67 r
.54904 .43797 m
.56166 .4206 L
s
.781 .227 .1 r
.55388 .45218 m .56009 .44577 L .57223 .46489 L p F P
0 0 0 r
s
.273 .073 .037 r
.57157 .5944 m .58234 .5847 L .58209 .60236 L p F P
0 0 0 r
s
.273 .073 .037 r
.58209 .60236 m .57136 .61188 L .57157 .5944 L p F P
0 0 0 r
s
.585 .167 .076 r
.58169 .51442 m .59135 .50516 L .59796 .52554 L p F P
0 0 0 r
s
.585 .167 .076 r
.59796 .52554 m .58754 .53529 L .58169 .51442 L p F P
0 0 0 r
s
.289 .419 .812 r
.47593 .43555 m .46794 .43265 L .45866 .45192 L p F P
0 0 0 r
s
.289 .419 .812 r
.44827 .44822 m .45866 .45192 L .46794 .43265 L p F P
0 0 0 r
s
.286 .412 .798 r
.45866 .45192 m .44827 .44822 L .43785 .46779 L p F P
0 0 0 r
s
.254 .353 .671 r
.4649 .56651 m .44745 .56086 L .44639 .58014 L p F P
0 0 0 r
s
.254 .353 .671 r
.44639 .58014 m .4642 .58581 L .4649 .56651 L p F P
0 0 0 r
s
.24 .35 .67 r
.46453 .58501 m
.46639 .55948 L
s
.291 .428 .835 r
.50815 .4058 m .5054 .40477 L .51054 .42672 L p F P
0 0 0 r
s
.291 .428 .835 r
.50516 .42474 m .51054 .42672 L .5054 .40477 L p F P
0 0 0 r
s
.271 .384 .736 r
.43731 .51404 m .42144 .50871 L .41578 .52928 L p F P
0 0 0 r
s
.271 .384 .736 r
.41578 .52928 m .43282 .53489 L .43731 .51404 L p F P
0 0 0 r
s
.24 .35 .67 r
.43625 .52084 m
.47107 .53248 L
s
.43625 .52084 m
.44372 .49306 L
s
.161 .046 .023 r
.56081 .62123 m .57136 .61188 L .56948 .62713 L p F P
0 0 0 r
s
.161 .046 .023 r
.56948 .62713 m .55923 .63611 L .56081 .62123 L p F P
0 0 0 r
s
.83 .24 .1 r
.5585 .62652 m
.56044 .60298 L
s
.24 .35 .67 r
.65054 .6958 m
.61723 .68572 L
s
.65054 .6958 m
.663 .70644 L
s
.391 .108 .052 r
.58072 .56541 m .59145 .55556 L .5933 .57483 L p F P
0 0 0 r
s
.391 .108 .052 r
.5933 .57483 m .58234 .5847 L .58072 .56541 L p F P
0 0 0 r
s
.83 .24 .1 r
.57812 .559 m
.58158 .58391 L
s
.93 .273 .118 r
.50815 .4058 m .50975 .40402 L .51904 .42527 L p F P
0 0 0 r
s
.93 .273 .118 r
.52221 .42183 m .51904 .42527 L .50975 .40402 L p F P
0 0 0 r
s
.24 .35 .67 r
.51295 .42832 m
.51824 .42082 L
s
.83 .24 .1 r
.50835 .42251 m
.51739 .42756 L
s
.291 .424 .825 r
.48895 .41876 m .48351 .41675 L .47593 .43555 L p F P
0 0 0 r
s
.83 .24 .1 r
.47389 .43481 m
.47816 .43002 L
s
.48838 .41855 m
.49137 .4152 L
s
.291 .424 .825 r
.46794 .43265 m .47593 .43555 L .48351 .41675 L p F P
0 0 0 r
s
.286 .412 .798 r
.42526 .46339 m .43785 .46779 L .44827 .44822 L p F P
0 0 0 r
s
.282 .404 .78 r
.43785 .46779 m .42526 .46339 L .41439 .48312 L p F P
0 0 0 r
s
.282 .404 .78 r
.41439 .48312 m .42885 .48808 L .43785 .46779 L p F P
0 0 0 r
s
.291 .428 .835 r
.5054 .40477 m .50264 .40374 L .50516 .42474 L p F P
0 0 0 r
s
.291 .428 .835 r
.49978 .42275 m .50516 .42474 L .50264 .40374 L p F P
0 0 0 r
s
.221 .299 .561 r
.51651 .61979 m .49928 .6144 L .4993 .62955 L p F P
0 0 0 r
s
.221 .299 .561 r
.4993 .62955 m .51608 .63473 L .51651 .61979 L p F P
0 0 0 r
s
.24 .35 .67 r
.50082 .61908 m
.53529 .62983 L
s
.278 .395 .76 r
.42885 .48808 m .41439 .48312 L .40543 .50333 L p F P
0 0 0 r
s
.278 .395 .76 r
.40543 .50333 m .42144 .50871 L .42885 .48808 L p F P
0 0 0 r
s
.24 .33 .624 r
.48183 .59142 m .4642 .58581 L .46431 .60345 L p F P
0 0 0 r
s
.24 .33 .624 r
.46431 .60345 m .48188 .60895 L .48183 .59142 L p F P
0 0 0 r
s
.24 .35 .67 r
.46453 .58501 m
.49929 .59608 L
s
.83 .24 .1 r
.24777 .65357 m
.24203 .62739 L
s
.24203 .62739 m
.25776 .60854 L
s
.27909 .53997 m
.28972 .51995 L
s
.28972 .51995 m
.3063 .4992 L
s
.44076 .74215 m
.46001 .72534 L
s
.44076 .74215 m
.41672 .74641 L
s
.289 .419 .812 r
.46794 .43265 m .45992 .42974 L .44827 .44822 L p F P
0 0 0 r
s
.24 .35 .67 r
.46507 .4395 m
.49965 .45196 L
s
.289 .419 .812 r
.43783 .4445 m .44827 .44822 L .45992 .42974 L p F P
0 0 0 r
s
.24 .35 .67 r
.45344 .46565 m
.46507 .4395 L
s
.286 .412 .798 r
.44827 .44822 m .43783 .4445 L .42526 .46339 L p F P
0 0 0 r
s
.24 .35 .67 r
.62716 .40581 m
.611 .41719 L
s
.611 .41719 m
.57721 .40425 L
s
.291 .428 .835 r
.50264 .40374 m .49989 .40271 L .49978 .42275 L p F P
0 0 0 r
s
.291 .428 .835 r
.49437 .42076 m .49978 .42275 L .49989 .40271 L p F P
0 0 0 r
s
.194 .255 .473 r
.54914 .64493 m .53269 .63986 L .53104 .65171 L p F P
0 0 0 r
s
.194 .255 .473 r
.53104 .65171 m .54667 .65648 L .54914 .64493 L p F P
0 0 0 r
s
.83 .24 .1 r
.53057 .66603 m
.54286 .65532 L
s
.24 .35 .67 r
.53529 .62983 m
.54037 .64947 L
s
.084 .024 .01 r
.54914 .64493 m .55923 .63611 L .55623 .64819 L p F P
0 0 0 r
s
.084 .024 .01 r
.55623 .64819 m .54667 .65648 L .54914 .64493 L p F P
0 0 0 r
s
.83 .24 .1 r
.5466 .65206 m
.55134 .64794 L
s
.883 .258 .112 r
.5254 .41836 m .5286 .41488 L .54178 .43286 L p F P
0 0 0 r
s
.883 .258 .112 r
.54654 .42781 m .54178 .43286 L .5286 .41488 L p F P
0 0 0 r
s
.833 .243 .106 r
.54178 .43286 m .54654 .42781 L .56009 .44577 L p F P
0 0 0 r
s
.24 .35 .67 r
.75866 .43916 m
.74249 .43872 L
s
.74249 .43872 m
.71001 .42599 L
s
.291 .424 .825 r
.48351 .41675 m .47805 .41474 L .46794 .43265 L p F P
0 0 0 r
s
.291 .424 .825 r
.45992 .42974 m .46794 .43265 L .47805 .41474 L p F P
0 0 0 r
s
.497 .14 .065 r
.58754 .53529 m .59796 .52554 L .60237 .54555 L p F P
0 0 0 r
s
.83 .24 .1 r
.56976 .5339 m
.59104 .51364 L
s
.497 .14 .065 r
.60237 .54555 m .59145 .55556 L .58754 .53529 L p F P
0 0 0 r
s
.93 .273 .118 r
.50975 .40402 m .51136 .40223 L .52221 .42183 L p F P
0 0 0 r
s
.93 .273 .118 r
.5254 .41836 m .52221 .42183 L .51136 .40223 L p F P
0 0 0 r
s
.781 .227 .1 r
.57986 .45721 m .57223 .46489 L .56009 .44577 L p F P
0 0 0 r
s
.723 .209 .093 r
.57223 .46489 m .57986 .45721 L .59154 .47615 L p F P
0 0 0 r
s
.723 .209 .093 r
.59154 .47615 m .58272 .48481 L .57223 .46489 L p F P
0 0 0 r
s
.264 .37 .707 r
.43282 .53489 m .41578 .52928 L .412 .54939 L p F P
0 0 0 r
s
.264 .37 .707 r
.412 .54939 m .42981 .55515 L .43282 .53489 L p F P
0 0 0 r
s
.24 .35 .67 r
.43129 .54804 m
.43625 .52084 L
s
.271 .384 .736 r
.42144 .50871 m .40543 .50333 L .39859 .5236 L p F P
0 0 0 r
s
.271 .384 .736 r
.39859 .5236 m .41578 .52928 L .42144 .50871 L p F P
0 0 0 r
s
.291 .428 .835 r
.49989 .40271 m .49712 .40167 L .49437 .42076 L p F P
0 0 0 r
s
.291 .428 .835 r
.48895 .41876 m .49437 .42076 L .49712 .40167 L p F P
0 0 0 r
s
.24 .35 .67 r
.54037 .64947 m
.54814 .65185 L
s
.551 .65273 m
.57459 .65996 L
s
.57459 .65996 m
.58323 .67543 L
s
.833 .243 .106 r
.56637 .43928 m .56009 .44577 L .54654 .42781 L p F P
0 0 0 r
s
.781 .227 .1 r
.56009 .44577 m .56637 .43928 L .57986 .45721 L p F P
0 0 0 r
s
.659 .189 .085 r
.58272 .48481 m .59154 .47615 L .60117 .49575 L p F P
0 0 0 r
s
.659 .189 .085 r
.60117 .49575 m .59135 .50516 L .58272 .48481 L p F P
0 0 0 r
s
.83 .24 .1 r
.57787 .48896 m
.59104 .51364 L
s
.254 .353 .671 r
.44745 .56086 m .42981 .55515 L .42839 .57442 L p F P
0 0 0 r
s
.24 .35 .67 r
.43129 .54804 m
.46639 .55948 L
s
.254 .353 .671 r
.42839 .57442 m .44639 .58014 L .44745 .56086 L p F P
0 0 0 r
s
.286 .412 .798 r
.41257 .45896 m .42526 .46339 L .43783 .4445 L p F P
0 0 0 r
s
.282 .404 .78 r
.42526 .46339 m .41257 .45896 L .3998 .47813 L p F P
0 0 0 r
s
.282 .404 .78 r
.3998 .47813 m .41439 .48312 L .42526 .46339 L p F P
0 0 0 r
s
.289 .419 .812 r
.45992 .42974 m .45186 .42682 L .43783 .4445 L p F P
0 0 0 r
s
.289 .419 .812 r
.42732 .44076 m .43783 .4445 L .45186 .42682 L p F P
0 0 0 r
s
.286 .412 .798 r
.43783 .4445 m .42732 .44076 L .41257 .45896 L p F P
0 0 0 r
s
.291 .424 .825 r
.47805 .41474 m .47258 .41272 L .45992 .42974 L p F P
0 0 0 r
s
.291 .424 .825 r
.45186 .42682 m .45992 .42974 L .47258 .41272 L p F P
0 0 0 r
s
.83 .24 .1 r
.37254 .76154 m
.39065 .74501 L
s
.37254 .76154 m
.34603 .75463 L
s
.278 .395 .76 r
.41439 .48312 m .3998 .47813 L .38928 .49789 L p F P
0 0 0 r
s
.278 .395 .76 r
.38928 .49789 m .40543 .50333 L .41439 .48312 L p F P
0 0 0 r
s
.24 .35 .67 r
.40838 .48095 m
.44372 .49306 L
s
.291 .428 .835 r
.49712 .40167 m .49435 .40063 L .48895 .41876 L p F P
0 0 0 r
s
.291 .428 .835 r
.48351 .41675 m .48895 .41876 L .49435 .40063 L p F P
0 0 0 r
s
.93 .273 .118 r
.51136 .40223 m .51297 .40043 L .5254 .41836 L p F P
0 0 0 r
s
.93 .273 .118 r
.5286 .41488 m .5254 .41836 L .51297 .40043 L p F P
0 0 0 r
s
.221 .299 .561 r
.49928 .6144 m .48188 .60895 L .48236 .62432 L p F P
0 0 0 r
s
.221 .299 .561 r
.48236 .62432 m .4993 .62955 L .49928 .6144 L p F P
0 0 0 r
s
.24 .35 .67 r
.49929 .59608 m
.50082 .61908 L
s
.83 .24 .1 r
.3063 .4992 m
.32157 .4833 L
s
.24 .35 .67 r
.69607 .71638 m
.663 .70644 L
s
.69607 .71638 m
.71151 .72158 L
s
.24 .33 .624 r
.4642 .58581 m .44639 .58014 L .44655 .59789 L p F P
0 0 0 r
s
.24 .33 .624 r
.44655 .59789 m .46431 .60345 L .4642 .58581 L p F P
0 0 0 r
s
.883 .258 .112 r
.5286 .41488 m .53182 .41138 L .54654 .42781 L p F P
0 0 0 r
s
.883 .258 .112 r
.55135 .42272 m .54654 .42781 L .53182 .41138 L p F P
0 0 0 r
s
.833 .243 .106 r
.54654 .42781 m .55135 .42272 L .56637 .43928 L p F P
0 0 0 r
s
.24 .35 .67 r
.67687 .41301 m
.6606 .4188 L
s
.6606 .4188 m
.62716 .40581 L
s
.585 .167 .076 r
.59135 .50516 m .60117 .49575 L .60855 .51561 L p F P
0 0 0 r
s
.585 .167 .076 r
.60855 .51561 m .59796 .52554 L .59135 .50516 L p F P
0 0 0 r
s
.83 .24 .1 r
.48108 .71585 m
.50115 .69848 L
s
.48108 .71585 m
.46001 .72534 L
s
.291 .428 .835 r
.49435 .40063 m .49158 .3996 L .48351 .41675 L p F P
0 0 0 r
s
.291 .428 .835 r
.47805 .41474 m .48351 .41675 L .49158 .3996 L p F P
0 0 0 r
s
.24 .35 .67 r
.47826 .41553 m
.51295 .42832 L
s
.194 .255 .473 r
.53269 .63986 m .51608 .63473 L .51526 .6469 L p F P
0 0 0 r
s
.194 .255 .473 r
.51526 .6469 m .53104 .65171 L .53269 .63986 L p F P
0 0 0 r
s
.291 .424 .825 r
.47258 .41272 m .46709 .41069 L .45186 .42682 L p F P
0 0 0 r
s
.291 .424 .825 r
.44376 .42388 m .45186 .42682 L .46709 .41069 L p F P
0 0 0 r
s
.83 .24 .1 r
.44783 .4265 m
.44858 .42563 L
s
.24 .35 .67 r
.46507 .4395 m
.47826 .41553 L
s
.289 .419 .812 r
.45186 .42682 m .44376 .42388 L .42732 .44076 L p F P
0 0 0 r
s
.273 .073 .037 r
.58234 .5847 m .5933 .57483 L .59301 .59268 L p F P
0 0 0 r
s
.273 .073 .037 r
.59301 .59268 m .58209 .60236 L .58234 .5847 L p F P
0 0 0 r
s
.286 .412 .798 r
.39979 .45449 m .41257 .45896 L .42732 .44076 L p F P
0 0 0 r
s
.282 .404 .78 r
.41257 .45896 m .39979 .45449 L .3851 .47308 L p F P
0 0 0 r
s
.282 .404 .78 r
.3851 .47308 m .3998 .47813 L .41257 .45896 L p F P
0 0 0 r
s
.289 .419 .812 r
.41674 .43699 m .42732 .44076 L .44376 .42388 L p F P
0 0 0 r
s
.286 .412 .798 r
.42732 .44076 m .41674 .43699 L .39979 .45449 L p F P
0 0 0 r
s
.24 .35 .67 r
.41818 .45325 m
.45344 .46565 L
s
.40838 .48095 m
.41818 .45325 L
s
.161 .046 .023 r
.57136 .61188 m .58209 .60236 L .57992 .618 L p F P
0 0 0 r
s
.83 .24 .1 r
.56044 .60298 m
.58158 .58391 L
s
.161 .046 .023 r
.57992 .618 m .56948 .62713 L .57136 .61188 L p F P
0 0 0 r
s
.264 .37 .707 r
.41578 .52928 m .39859 .5236 L .39401 .54356 L p F P
0 0 0 r
s
.264 .37 .707 r
.39401 .54356 m .412 .54939 L .41578 .52928 L p F P
0 0 0 r
s
.271 .384 .736 r
.40543 .50333 m .38928 .49789 L .38122 .51788 L p F P
0 0 0 r
s
.271 .384 .736 r
.38122 .51788 m .39859 .5236 L .40543 .50333 L p F P
0 0 0 r
s
.24 .35 .67 r
.40071 .50897 m
.43625 .52084 L
s
.40071 .50897 m
.40838 .48095 L
s
.93 .273 .118 r
.51297 .40043 m .51459 .39863 L .5286 .41488 L p F P
0 0 0 r
s
.93 .273 .118 r
.53182 .41138 m .5286 .41488 L .51459 .39863 L p F P
0 0 0 r
s
.24 .35 .67 r
.52727 .40801 m
.52747 .40774 L
s
.52747 .40774 m
.56166 .4206 L
s
.291 .428 .835 r
.49158 .3996 m .48881 .39856 L .47805 .41474 L p F P
0 0 0 r
s
.291 .428 .835 r
.47258 .41272 m .47805 .41474 L .48881 .39856 L p F P
0 0 0 r
s
.391 .108 .052 r
.59145 .55556 m .60237 .54555 L .60446 .56478 L p F P
0 0 0 r
s
.391 .108 .052 r
.60446 .56478 m .5933 .57483 L .59145 .55556 L p F P
0 0 0 r
s
.83 .24 .1 r
.27372 .56333 m
.25759 .58311 L
s
.25776 .60854 m
.25759 .58311 L
s
.833 .243 .106 r
.57272 .43273 m .56637 .43928 L .55135 .42272 L p F P
0 0 0 r
s
.781 .227 .1 r
.56637 .43928 m .57272 .43273 L .58759 .44943 L p F P
0 0 0 r
s
.781 .227 .1 r
.58759 .44943 m .57986 .45721 L .56637 .43928 L p F P
0 0 0 r
s
.254 .353 .671 r
.42981 .55515 m .412 .54939 L .41021 .56863 L p F P
0 0 0 r
s
.254 .353 .671 r
.41021 .56863 m .42839 .57442 L .42981 .55515 L p F P
0 0 0 r
s
.24 .35 .67 r
.42906 .57372 m
.43129 .54804 L
s
.723 .209 .093 r
.57986 .45721 m .58759 .44943 L .60049 .46737 L p F P
0 0 0 r
s
.723 .209 .093 r
.60049 .46737 m .59154 .47615 L .57986 .45721 L p F P
0 0 0 r
s
.24 .35 .67 r
.52631 .4073 m
.52747 .40774 L
s
.278 .395 .76 r
.3998 .47813 m .3851 .47308 L .37297 .49241 L p F P
0 0 0 r
s
.278 .395 .76 r
.37297 .49241 m .38928 .49789 L .3998 .47813 L p F P
0 0 0 r
s
.24 .35 .67 r
.80587 .4584 m
.79087 .45184 L
s
.79087 .45184 m
.75866 .43916 L
s
.61723 .68572 m
.58323 .67543 L
s
.61723 .68572 m
.62925 .69629 L
s
.291 .424 .825 r
.46709 .41069 m .46158 .40866 L .44376 .42388 L p F P
0 0 0 r
s
.291 .424 .825 r
.43562 .42093 m .44376 .42388 L .46158 .40866 L p F P
0 0 0 r
s
.289 .419 .812 r
.44376 .42388 m .43562 .42093 L .41674 .43699 L p F P
0 0 0 r
s
.83 .24 .1 r
.25909 .67945 m
.24777 .65357 L
s
.24777 .65357 m
.26374 .63504 L
s
.291 .428 .835 r
.48881 .39856 m .48603 .39751 L .47258 .41272 L p F P
0 0 0 r
s
.291 .428 .835 r
.46709 .41069 m .47258 .41272 L .48603 .39751 L p F P
0 0 0 r
s
.975 .287 .123 r
.50975 .40402 m .50815 .4058 L .5 .38446 L closepath p F P
0 0 0 r
s
.29 .429 .84 r
.5054 .40477 m .50815 .4058 L .5 .38446 L closepath p F P
0 0 0 r
s
.883 .258 .112 r
.53182 .41138 m .53506 .40786 L .55135 .42272 L p F P
0 0 0 r
s
.883 .258 .112 r
.55619 .4176 m .55135 .42272 L .53506 .40786 L p F P
0 0 0 r
s
.833 .243 .106 r
.55135 .42272 m .55619 .4176 L .57272 .43273 L p F P
0 0 0 r
s
.24 .35 .67 r
.56166 .4206 m
.57721 .40425 L
s
.084 .024 .01 r
.55923 .63611 m .56948 .62713 L .56593 .63977 L p F P
0 0 0 r
s
.084 .024 .01 r
.56593 .63977 m .55623 .64819 L .55923 .63611 L p F P
0 0 0 r
s
.83 .24 .1 r
.55134 .64794 m
.5585 .62652 L
s
.221 .299 .561 r
.48188 .60895 m .46431 .60345 L .46525 .61904 L p F P
0 0 0 r
s
.221 .299 .561 r
.46525 .61904 m .48236 .62432 L .48188 .60895 L p F P
0 0 0 r
s
.24 .35 .67 r
.46564 .60811 m
.50082 .61908 L
s
.289 .419 .812 r
.40611 .4332 m .41674 .43699 L .43562 .42093 L p F P
0 0 0 r
s
.286 .412 .798 r
.41674 .43699 m .40611 .4332 L .38692 .44999 L p F P
0 0 0 r
s
.286 .412 .798 r
.38692 .44999 m .39979 .45449 L .41674 .43699 L p F P
0 0 0 r
s
.659 .189 .085 r
.59154 .47615 m .60049 .46737 L .61115 .48619 L p F P
0 0 0 r
s
.659 .189 .085 r
.61115 .48619 m .60117 .49575 L .59154 .47615 L p F P
0 0 0 r
s
.83 .24 .1 r
.57787 .48896 m
.59955 .46767 L
s
.93 .273 .118 r
.51459 .39863 m .51621 .39682 L .53182 .41138 L p F P
0 0 0 r
s
.93 .273 .118 r
.53506 .40786 m .53182 .41138 L .51621 .39682 L p F P
0 0 0 r
s
.83 .24 .1 r
.51822 .68424 m
.53904 .66623 L
s
.51822 .68424 m
.50115 .69848 L
s
.29 .429 .84 r
.50264 .40374 m .5054 .40477 L .5 .38446 L closepath p F P
0 0 0 r
s
.497 .14 .065 r
.59796 .52554 m .60855 .51561 L .61348 .53535 L p F P
0 0 0 r
s
.497 .14 .065 r
.61348 .53535 m .60237 .54555 L .59796 .52554 L p F P
0 0 0 r
s
.83 .24 .1 r
.59104 .51364 m
.59972 .53902 L
s
.57812 .559 m
.59972 .53902 L
s
.282 .404 .78 r
.39979 .45449 m .38692 .44999 L .37027 .468 L p F P
0 0 0 r
s
.282 .404 .78 r
.37027 .468 m .3851 .47308 L .39979 .45449 L p F P
0 0 0 r
s
.24 .33 .624 r
.44639 .58014 m .42839 .57442 L .42862 .59227 L p F P
0 0 0 r
s
.24 .33 .624 r
.42862 .59227 m .44655 .59789 L .44639 .58014 L p F P
0 0 0 r
s
.24 .35 .67 r
.42906 .57372 m
.46453 .58501 L
s
.291 .428 .835 r
.48603 .39751 m .48324 .39647 L .46709 .41069 L p F P
0 0 0 r
s
.291 .428 .835 r
.46158 .40866 m .46709 .41069 L .48324 .39647 L p F P
0 0 0 r
s
.83 .24 .1 r
.46707 .40425 m
.46848 .40478 L
s
.46484 .40683 m
.46707 .40425 L
s
.975 .287 .123 r
.51136 .40223 m .50975 .40402 L .5 .38446 L closepath p F P
0 0 0 r
s
.29 .429 .84 r
.49989 .40271 m .50264 .40374 L .5 .38446 L closepath p F P
0 0 0 r
s
.291 .424 .825 r
.46158 .40866 m .45606 .40662 L .43562 .42093 L p F P
0 0 0 r
s
.291 .424 .825 r
.42745 .41797 m .43562 .42093 L .45606 .40662 L p F P
0 0 0 r
s
.289 .419 .812 r
.43562 .42093 m .42745 .41797 L .40611 .4332 L p F P
0 0 0 r
s
.24 .35 .67 r
.41818 .45325 m
.4298 .42679 L
s
.4298 .42679 m
.46507 .4395 L
s
.194 .255 .473 r
.51608 .63473 m .4993 .62955 L .49934 .64204 L p F P
0 0 0 r
s
.194 .255 .473 r
.49934 .64204 m .51526 .6469 L .51608 .63473 L p F P
0 0 0 r
s
.24 .35 .67 r
.50082 .61908 m
.50544 .63876 L
s
.83 .24 .1 r
.34603 .75463 m
.36381 .73785 L
s
.34603 .75463 m
.32014 .74226 L
s
.24 .35 .67 r
.72579 .42621 m
.71001 .42599 L
s
.71001 .42599 m
.67687 .41301 L
s
.271 .384 .736 r
.38928 .49789 m .37297 .49241 L .36368 .51209 L p F P
0 0 0 r
s
.271 .384 .736 r
.36368 .51209 m .38122 .51788 L .38928 .49789 L p F P
0 0 0 r
s
.29 .429 .84 r
.49712 .40167 m .49989 .40271 L .5 .38446 L closepath p F P
0 0 0 r
s
.264 .37 .707 r
.39859 .5236 m .38122 .51788 L .37583 .53768 L p F P
0 0 0 r
s
.264 .37 .707 r
.37583 .53768 m .39401 .54356 L .39859 .5236 L p F P
0 0 0 r
s
.24 .35 .67 r
.39547 .53636 m
.40071 .50897 L
s
.83 .24 .1 r
.41672 .74641 m
.43577 .72948 L
s
.41672 .74641 m
.39065 .74501 L
s
.975 .287 .123 r
.51297 .40043 m .51136 .40223 L .5 .38446 L closepath p F P
0 0 0 r
s
.291 .428 .835 r
.48324 .39647 m .48045 .39542 L .46158 .40866 L p F P
0 0 0 r
s
.291 .428 .835 r
.45606 .40662 m .46158 .40866 L .48045 .39542 L p F P
0 0 0 r
s
.278 .395 .76 r
.3851 .47308 m .37027 .468 L .35652 .48688 L p F P
0 0 0 r
s
.278 .395 .76 r
.35652 .48688 m .37297 .49241 L .3851 .47308 L p F P
0 0 0 r
s
.24 .35 .67 r
.37231 .46858 m
.40838 .48095 L
s
.29 .429 .84 r
.49435 .40063 m .49712 .40167 L .5 .38446 L closepath p F P
0 0 0 r
s
.93 .273 .118 r
.51621 .39682 m .51784 .39501 L .53506 .40786 L p F P
0 0 0 r
s
.93 .273 .118 r
.53832 .40433 m .53506 .40786 L .51784 .39501 L p F P
0 0 0 r
s
.883 .258 .112 r
.53506 .40786 m .53832 .40433 L .55619 .4176 L p F P
0 0 0 r
s
.83 .24 .1 r
.51739 .42756 m
.53796 .40522 L
s
.289 .419 .812 r
.39541 .42939 m .40611 .4332 L .42745 .41797 L p F P
0 0 0 r
s
.286 .412 .798 r
.40611 .4332 m .39541 .42939 L .37395 .44546 L p F P
0 0 0 r
s
.83 .24 .1 r
.38013 .44471 m
.38205 .44238 L
s
.286 .412 .798 r
.37395 .44546 m .38692 .44999 L .40611 .4332 L p F P
0 0 0 r
s
.254 .353 .671 r
.412 .54939 m .39401 .54356 L .39184 .56279 L p F P
0 0 0 r
s
.24 .35 .67 r
.39547 .53636 m
.43129 .54804 L
s
.254 .353 .671 r
.39184 .56279 m .41021 .56863 L .412 .54939 L p F P
0 0 0 r
s
.833 .243 .106 r
.57913 .42611 m .57272 .43273 L .55619 .4176 L p F P
0 0 0 r
s
.781 .227 .1 r
.57272 .43273 m .57913 .42611 L .59541 .44156 L p F P
0 0 0 r
s
.781 .227 .1 r
.59541 .44156 m .58759 .44943 L .57272 .43273 L p F P
0 0 0 r
s
.83 .24 .1 r
.56076 .46586 m
.58206 .44424 L
s
.291 .424 .825 r
.45606 .40662 m .45051 .40458 L .42745 .41797 L p F P
0 0 0 r
s
.291 .424 .825 r
.41923 .41499 m .42745 .41797 L .45051 .40458 L p F P
0 0 0 r
s
.83 .24 .1 r
.42538 .4187 m
.42634 .41756 L
s
.43212 .4107 m
.4355 .40669 L
s
.289 .419 .812 r
.42745 .41797 m .41923 .41499 L .39541 .42939 L p F P
0 0 0 r
s
.83 .24 .1 r
.38844 .43461 m
.39824 .42271 L
s
.39824 .42271 m
.40683 .42249 L
s
.29 .429 .84 r
.49158 .3996 m .49435 .40063 L .5 .38446 L closepath p F P
0 0 0 r
s
.975 .287 .123 r
.51459 .39863 m .51297 .40043 L .5 .38446 L closepath p F P
0 0 0 r
s
.585 .167 .076 r
.60117 .49575 m .61115 .48619 L .61932 .50552 L p F P
0 0 0 r
s
.585 .167 .076 r
.61932 .50552 m .60855 .51561 L .60117 .49575 L p F P
0 0 0 r
s
.883 .258 .112 r
.56107 .41243 m .55619 .4176 L .53832 .40433 L p F P
0 0 0 r
s
.833 .243 .106 r
.55619 .4176 m .56107 .41243 L .57913 .42611 L p F P
0 0 0 r
s
.83 .24 .1 r
.54035 .44515 m
.56129 .42317 L
s
.27372 .56333 m
.27909 .53997 L
s
.27909 .53997 m
.29569 .51931 L
s
.291 .428 .835 r
.48045 .39542 m .47766 .39438 L .45606 .40662 L p F P
0 0 0 r
s
.291 .428 .835 r
.45051 .40458 m .45606 .40662 L .47766 .39438 L p F P
0 0 0 r
s
.83 .24 .1 r
.56129 .42317 m
.58206 .44424 L
s
.282 .404 .78 r
.38692 .44999 m .37395 .44546 L .35532 .46288 L p F P
0 0 0 r
s
.282 .404 .78 r
.35532 .46288 m .37027 .468 L .38692 .44999 L p F P
0 0 0 r
s
.29 .429 .84 r
.48881 .39856 m .49158 .3996 L .5 .38446 L closepath p F P
0 0 0 r
s
.723 .209 .093 r
.58759 .44943 m .59541 .44156 L .60957 .45845 L p F P
0 0 0 r
s
.723 .209 .093 r
.60957 .45845 m .60049 .46737 L .58759 .44943 L p F P
0 0 0 r
s
.83 .24 .1 r
.58206 .44424 m
.59955 .46767 L
s
.221 .299 .561 r
.46431 .60345 m .44655 .59789 L .44797 .61371 L p F P
0 0 0 r
s
.221 .299 .561 r
.44797 .61371 m .46525 .61904 L .46431 .60345 L p F P
0 0 0 r
s
.24 .35 .67 r
.46453 .58501 m
.46564 .60811 L
s
.83 .24 .1 r
.2755 .70368 m
.25909 .67945 L
s
.25909 .67945 m
.27536 .66127 L
s
.975 .287 .123 r
.51621 .39682 m .51459 .39863 L .5 .38446 L closepath p F P
0 0 0 r
s
.153 .191 .345 r
.54667 .65648 m .53104 .65171 L .52861 .66034 L p F P
0 0 0 r
s
.153 .191 .345 r
.52861 .66034 m .54304 .6647 L .54667 .65648 L p F P
0 0 0 r
s
.83 .24 .1 r
.53904 .66623 m
.54057 .66396 L
s
.083 .024 .01 r
.54667 .65648 m .55623 .64819 L .55181 .65713 L p F P
0 0 0 r
s
.083 .024 .01 r
.55181 .65713 m .54304 .6647 L .54667 .65648 L p F P
0 0 0 r
s
.24 .35 .67 r
.54673 .66151 m
.54736 .6627 L
s
.54037 .64947 m
.54584 .65981 L
s
.83 .24 .1 r
.5431 .66019 m
.55134 .64794 L
s
.24 .35 .67 r
.54736 .6627 m
.54854 .66493 L
s
.29 .429 .84 r
.48603 .39751 m .48881 .39856 L .5 .38446 L closepath p F P
0 0 0 r
s
.273 .073 .037 r
.5933 .57483 m .60446 .56478 L .60413 .58282 L p F P
0 0 0 r
s
.273 .073 .037 r
.60413 .58282 m .59301 .59268 L .5933 .57483 L p F P
0 0 0 r
s
.291 .428 .835 r
.47766 .39438 m .47486 .39333 L .45051 .40458 L p F P
0 0 0 r
s
.291 .428 .835 r
.44495 .40253 m .45051 .40458 L .47486 .39333 L p F P
0 0 0 r
s
.291 .424 .825 r
.45051 .40458 m .44495 .40253 L .41923 .41499 L p F P
0 0 0 r
s
.24 .35 .67 r
.663 .70644 m
.62925 .69629 L
s
.663 .70644 m
.67802 .71152 L
s
.93 .273 .118 r
.51784 .39501 m .51947 .3932 L .53832 .40433 L p F P
0 0 0 r
s
.93 .273 .118 r
.5416 .40077 m .53832 .40433 L .51947 .3932 L p F P
0 0 0 r
s
.883 .258 .112 r
.53832 .40433 m .5416 .40077 L .56107 .41243 L p F P
0 0 0 r
s
.83 .24 .1 r
.53796 .40522 m
.56129 .42317 L
s
.291 .424 .825 r
.41098 .41199 m .41923 .41499 L .44495 .40253 L p F P
0 0 0 r
s
.289 .419 .812 r
.41923 .41499 m .41098 .41199 L .38464 .42556 L p F P
0 0 0 r
s
.289 .419 .812 r
.38464 .42556 m .39541 .42939 L .41923 .41499 L p F P
0 0 0 r
s
.24 .33 .624 r
.42839 .57442 m .41021 .56863 L .41049 .5866 L p F P
0 0 0 r
s
.24 .33 .624 r
.41049 .5866 m .42862 .59227 L .42839 .57442 L p F P
0 0 0 r
s
.24 .35 .67 r
.64304 .39975 m
.62716 .40581 L
s
.161 .046 .023 r
.58209 .60236 m .59301 .59268 L .59053 .60871 L p F P
0 0 0 r
s
.161 .046 .023 r
.59053 .60871 m .57992 .618 L .58209 .60236 L p F P
0 0 0 r
s
.83 .24 .1 r
.57986 .60765 m
.58158 .58391 L
s
.29 .429 .84 r
.48324 .39647 m .48603 .39751 L .5 .38446 L closepath p F P
0 0 0 r
s
.286 .412 .798 r
.39541 .42939 m .38464 .42556 L .36089 .4409 L p F P
0 0 0 r
s
.286 .412 .798 r
.36089 .4409 m .37395 .44546 L .39541 .42939 L p F P
0 0 0 r
s
.83 .24 .1 r
.35799 .45071 m
.36483 .44227 L
s
.24 .35 .67 r
.3822 .4406 m
.41818 .45325 L
s
.194 .255 .473 r
.4993 .62955 m .48236 .62432 L .48326 .63714 L p F P
0 0 0 r
s
.194 .255 .473 r
.48326 .63714 m .49934 .64204 L .4993 .62955 L p F P
0 0 0 r
s
.975 .287 .123 r
.51784 .39501 m .51621 .39682 L .5 .38446 L closepath p F P
0 0 0 r
s
.271 .384 .736 r
.37297 .49241 m .35652 .48688 L .34597 .50625 L p F P
0 0 0 r
s
.271 .384 .736 r
.34597 .50625 m .36368 .51209 L .37297 .49241 L p F P
0 0 0 r
s
.24 .35 .67 r
.36445 .49685 m
.40071 .50897 L
s
.83 .24 .1 r
.32014 .74226 m
.33754 .72517 L
s
.32014 .74226 m
.29621 .72498 L
s
.391 .108 .052 r
.60237 .54555 m .61348 .53535 L .61582 .55455 L p F P
0 0 0 r
s
.391 .108 .052 r
.61582 .55455 m .60446 .56478 L .60237 .54555 L p F P
0 0 0 r
s
.83 .24 .1 r
.59972 .53902 m
.60347 .56417 L
s
.29 .429 .84 r
.48045 .39542 m .48324 .39647 L .5 .38446 L closepath p F P
0 0 0 r
s
.278 .395 .76 r
.37027 .468 m .35532 .46288 L .33991 .4813 L p F P
0 0 0 r
s
.278 .395 .76 r
.33991 .4813 m .35652 .48688 L .37027 .468 L p F P
0 0 0 r
s
.264 .37 .707 r
.38122 .51788 m .36368 .51209 L .35747 .53173 L p F P
0 0 0 r
s
.264 .37 .707 r
.35747 .53173 m .37583 .53768 L .38122 .51788 L p F P
0 0 0 r
s
.291 .428 .835 r
.47486 .39333 m .47205 .39228 L .44495 .40253 L p F P
0 0 0 r
s
.291 .428 .835 r
.43937 .40047 m .44495 .40253 L .47205 .39228 L p F P
0 0 0 r
s
.291 .424 .825 r
.44495 .40253 m .43937 .40047 L .41098 .41199 L p F P
0 0 0 r
s
.24 .35 .67 r
.44286 .40248 m
.47826 .41553 L
s
.37231 .46858 m
.3822 .4406 L
s
.36445 .49685 m
.37231 .46858 L
s
.659 .189 .085 r
.60049 .46737 m .60957 .45845 L .62129 .47647 L p F P
0 0 0 r
s
.659 .189 .085 r
.62129 .47647 m .61115 .48619 L .60049 .46737 L p F P
0 0 0 r
s
.29 .429 .84 r
.47766 .39438 m .48045 .39542 L .5 .38446 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.47826 .41553 m
.49257 .39461 L
s
.282 .404 .78 r
.37395 .44546 m .36089 .4409 L .34024 .45771 L p F P
0 0 0 r
s
.282 .404 .78 r
.34024 .45771 m .35532 .46288 L .37395 .44546 L p F P
0 0 0 r
s
.883 .258 .112 r
.56599 .40721 m .56107 .41243 L .5416 .40077 L p F P
0 0 0 r
s
.833 .243 .106 r
.56107 .41243 m .56599 .40721 L .58561 .41942 L p F P
0 0 0 r
s
.833 .243 .106 r
.58561 .41942 m .57913 .42611 L .56107 .41243 L p F P
0 0 0 r
s
.975 .287 .123 r
.51947 .3932 m .51784 .39501 L .5 .38446 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.49257 .39461 m
.51355 .4025 L
s
1 .332 .138 r
.3901 .41886 m .38464 .42556 L .41098 .41199 L p F P
0 0 0 r
s
1 .332 .138 r
.41098 .41199 m .41529 .40678 L .3901 .41886 L p F P
0 0 0 r
s
.24 .35 .67 r
.3938 .41382 m
.39769 .41522 L
s
.40109 .41645 m
.4298 .42679 L
s
.39201 .41794 m
.3938 .41382 L
s
1 .324 .136 r
.41529 .40678 m .41098 .41199 L .43937 .40047 L p F P
0 0 0 r
s
.24 .35 .67 r
.4298 .42679 m
.44286 .40248 L
s
.084 .024 .01 r
.56948 .62713 m .57992 .618 L .5758 .63121 L p F P
0 0 0 r
s
.83 .24 .1 r
.5585 .62652 m
.57986 .60765 L
s
.084 .024 .01 r
.5758 .63121 m .56593 .63977 L .56948 .62713 L p F P
0 0 0 r
s
.83 .24 .1 r
.29621 .72498 m
.2755 .70368 L
s
.2755 .70368 m
.29212 .68587 L
s
.254 .353 .671 r
.39401 .54356 m .37583 .53768 L .37328 .55688 L p F P
0 0 0 r
s
.254 .353 .671 r
.37328 .55688 m .39184 .56279 L .39401 .54356 L p F P
0 0 0 r
s
.24 .35 .67 r
.39287 .56219 m
.39547 .53636 L
s
.29 .429 .84 r
.47486 .39333 m .47766 .39438 L .5 .38446 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.26374 .63504 m
.25776 .60854 L
s
.25776 .60854 m
.27406 .58902 L
s
.29569 .51931 m
.3063 .4992 L
s
.93 .273 .118 r
.51947 .3932 m .5211 .39138 L .5416 .40077 L p F P
0 0 0 r
s
.93 .273 .118 r
.54489 .39719 m .5416 .40077 L .5211 .39138 L p F P
0 0 0 r
s
.883 .258 .112 r
.5416 .40077 m .54489 .39719 L .56599 .40721 L p F P
0 0 0 r
s
.83 .24 .1 r
.46001 .72534 m
.47997 .70792 L
s
.46001 .72534 m
.43577 .72948 L
s
.781 .227 .1 r
.57913 .42611 m .58561 .41942 L .60334 .43358 L p F P
0 0 0 r
s
.781 .227 .1 r
.60334 .43358 m .59541 .44156 L .57913 .42611 L p F P
0 0 0 r
s
.24 .35 .67 r
.77326 .44557 m
.75866 .43916 L
s
.75866 .43916 m
.72579 .42621 L
s
1 .324 .136 r
.43937 .40047 m .44238 .39689 L .41529 .40678 L p F P
0 0 0 r
s
1 .313 .132 r
.44238 .39689 m .43937 .40047 L .46925 .39123 L p F P
0 0 0 r
s
.291 .428 .835 r
.47205 .39228 m .46925 .39123 L .43937 .40047 L p F P
0 0 0 r
s
.24 .35 .67 r
.43664 .40019 m
.44286 .40248 L
s
.83 .24 .1 r
.43817 .40351 m
.44152 .39954 L
s
.44152 .39954 m
.45095 .40128 L
s
.497 .14 .065 r
.60855 .51561 m .61932 .50552 L .62479 .52497 L p F P
0 0 0 r
s
.497 .14 .065 r
.62479 .52497 m .61348 .53535 L .60855 .51561 L p F P
0 0 0 r
s
.83 .24 .1 r
.29621 .72498 m
.31321 .70755 L
s
.24 .35 .67 r
.58323 .67543 m
.54854 .66493 L
s
.58323 .67543 m
.5948 .68593 L
s
1 .331 .136 r
.36733 .43291 m .36089 .4409 L .38464 .42556 L p F P
0 0 0 r
s
.24 .35 .67 r
.36828 .4357 m
.3822 .4406 L
s
1 .331 .136 r
.38464 .42556 m .3901 .41886 L .36733 .43291 L p F P
0 0 0 r
s
.24 .35 .67 r
.3822 .4406 m
.39047 .42151 L
s
.29 .429 .84 r
.47205 .39228 m .47486 .39333 L .5 .38446 L closepath p F P
0 0 0 r
s
.975 .287 .123 r
.5211 .39138 m .51947 .3932 L .5 .38446 L closepath p F P
0 0 0 r
s
.153 .191 .345 r
.53104 .65171 m .51526 .6469 L .51406 .65595 L p F P
0 0 0 r
s
.24 .35 .67 r
.50544 .63876 m
.54037 .64947 L
s
.153 .191 .345 r
.51406 .65595 m .52861 .66034 L .53104 .65171 L p F P
0 0 0 r
s
.29 .429 .84 r
.46925 .39123 m .47205 .39228 L .5 .38446 L closepath p F P
0 0 0 r
s
.221 .299 .561 r
.44655 .59789 m .42862 .59227 L .43052 .60832 L p F P
0 0 0 r
s
.221 .299 .561 r
.43052 .60832 m .44797 .61371 L .44655 .59789 L p F P
0 0 0 r
s
.975 .287 .123 r
.52274 .38955 m .5211 .39138 L .5 .38446 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.5007 .40473 m
.51291 .39105 L
s
.93 .273 .118 r
.5211 .39138 m .52274 .38955 L .54489 .39719 L p F P
0 0 0 r
s
1 .313 .132 r
.46925 .39123 m .47081 .3894 L .44238 .39689 L p F P
0 0 0 r
s
1 .3 .128 r
.5 .38446 m .47081 .3894 L .46925 .39123 L closepath p F P
0 0 0 r
s
.723 .209 .093 r
.59541 .44156 m .60334 .43358 L .61878 .44941 L p F P
0 0 0 r
s
.723 .209 .093 r
.61878 .44941 m .60957 .45845 L .59541 .44156 L p F P
0 0 0 r
s
.194 .255 .473 r
.48236 .62432 m .46525 .61904 L .46704 .63219 L p F P
0 0 0 r
s
.194 .255 .473 r
.46704 .63219 m .48326 .63714 L .48236 .62432 L p F P
0 0 0 r
s
.278 .395 .76 r
.35532 .46288 m .34024 .45771 L .32314 .47566 L p F P
0 0 0 r
s
.83 .24 .1 r
.32157 .4833 m
.32982 .47301 L
s
.278 .395 .76 r
.32314 .47566 m .33991 .4813 L .35532 .46288 L p F P
0 0 0 r
s
.24 .33 .624 r
.41021 .56863 m .39184 .56279 L .39218 .58087 L p F P
0 0 0 r
s
.24 .33 .624 r
.39218 .58087 m .41049 .5866 L .41021 .56863 L p F P
0 0 0 r
s
.24 .35 .67 r
.39287 .56219 m
.42906 .57372 L
s
.271 .384 .736 r
.35652 .48688 m .33991 .4813 L .32809 .50035 L p F P
0 0 0 r
s
.271 .384 .736 r
.32809 .50035 m .34597 .50625 L .35652 .48688 L p F P
0 0 0 r
s
.93 .273 .118 r
.5482 .39359 m .54489 .39719 L .52274 .38955 L p F P
0 0 0 r
s
.24 .35 .67 r
.54139 .39251 m
.54273 .39105 L
s
.83 .24 .1 r
.51291 .39105 m
.53796 .40522 L
s
.883 .258 .112 r
.54489 .39719 m .5482 .39359 L .57095 .40196 L p F P
0 0 0 r
s
.883 .258 .112 r
.57095 .40196 m .56599 .40721 L .54489 .39719 L p F P
0 0 0 r
s
.24 .35 .67 r
.54273 .39105 m
.57721 .40425 L
s
1 .316 .128 r
.34748 .44865 m .34024 .45771 L .36089 .4409 L p F P
0 0 0 r
s
1 .316 .128 r
.36089 .4409 m .36733 .43291 L .34748 .44865 L p F P
0 0 0 r
s
1 .324 .136 r
.41964 .40152 m .41529 .40678 L .44238 .39689 L p F P
0 0 0 r
s
1 .324 .136 r
.44238 .39689 m .44541 .39329 L .41964 .40152 L p F P
0 0 0 r
s
1 .313 .132 r
.44541 .39329 m .44238 .39689 L .47081 .3894 L p F P
0 0 0 r
s
.24 .35 .67 r
.44286 .40248 m
.448 .39473 L
s
.585 .167 .076 r
.61115 .48619 m .62129 .47647 L .63028 .49525 L p F P
0 0 0 r
s
.585 .167 .076 r
.63028 .49525 m .61932 .50552 L .61115 .48619 L p F P
0 0 0 r
s
.83 .24 .1 r
.59955 .46767 m
.61308 .49266 L
s
.59104 .51364 m
.61308 .49266 L
s
.264 .37 .707 r
.36368 .51209 m .34597 .50625 L .33891 .52572 L p F P
0 0 0 r
s
.264 .37 .707 r
.33891 .52572 m .35747 .53173 L .36368 .51209 L p F P
0 0 0 r
s
.24 .35 .67 r
.35891 .52445 m
.36445 .49685 L
s
.83 .24 .1 r
.39065 .74501 m
.40942 .72789 L
s
.39065 .74501 m
.36381 .73785 L
s
.833 .243 .106 r
.56599 .40721 m .57095 .40196 L .59216 .41266 L p F P
0 0 0 r
s
.833 .243 .106 r
.59216 .41266 m .58561 .41942 L .56599 .40721 L p F P
0 0 0 r
s
.975 .287 .123 r
.52439 .38772 m .52274 .38955 L .5 .38446 L closepath p F P
0 0 0 r
s
.93 .273 .118 r
.52274 .38955 m .52439 .38772 L .5482 .39359 L p F P
0 0 0 r
s
.24 .35 .67 r
.69223 .413 m
.67687 .41301 L
s
.67687 .41301 m
.64304 .39975 L
s
1 .313 .132 r
.47081 .3894 m .47238 .38757 L .44541 .39329 L p F P
0 0 0 r
s
1 .3 .128 r
.5 .38446 m .47238 .38757 L .47081 .3894 L closepath p F P
0 0 0 r
s
1 .332 .138 r
.39561 .4121 m .3901 .41886 L .41529 .40678 L p F P
0 0 0 r
s
1 .332 .138 r
.41529 .40678 m .41964 .40152 L .39561 .4121 L p F P
0 0 0 r
s
.24 .35 .67 r
.71151 .72158 m
.67802 .71152 L
s
.71151 .72158 m
.72891 .72076 L
s
.083 .024 .01 r
.55623 .64819 m .56593 .63977 L .56072 .64944 L p F P
0 0 0 r
s
.083 .024 .01 r
.56072 .64944 m .55181 .65713 L .55623 .64819 L p F P
0 0 0 r
s
.254 .353 .671 r
.37583 .53768 m .35747 .53173 L .35452 .55091 L p F P
0 0 0 r
s
.24 .35 .67 r
.35891 .52445 m
.39547 .53636 L
s
.254 .353 .671 r
.35452 .55091 m .37328 .55688 L .37583 .53768 L p F P
0 0 0 r
s
.975 .287 .123 r
.52604 .38588 m .52439 .38772 L .5 .38446 L closepath p F P
0 0 0 r
s
.93 .273 .118 r
.52439 .38772 m .52604 .38588 L .55153 .38997 L p F P
0 0 0 r
s
.24 .35 .67 r
.54273 .39105 m
.54483 .38942 L
s
.53669 .38874 m
.54273 .39105 L
s
.93 .273 .118 r
.55153 .38997 m .5482 .39359 L .52439 .38772 L p F P
0 0 0 r
s
1 .313 .132 r
.44846 .38967 m .44541 .39329 L .47238 .38757 L p F P
0 0 0 r
s
1 .313 .132 r
.47238 .38757 m .47396 .38573 L .44846 .38967 L p F P
0 0 0 r
s
1 .3 .128 r
.5 .38446 m .47396 .38573 L .47238 .38757 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.47133 .38662 m
.49257 .39461 L
s
.83 .24 .1 r
.50115 .69848 m
.52195 .68048 L
s
.50115 .69848 m
.47997 .70792 L
s
.781 .227 .1 r
.58561 .41942 m .59216 .41266 L .61137 .4255 L p F P
0 0 0 r
s
.781 .227 .1 r
.61137 .4255 m .60334 .43358 L .58561 .41942 L p F P
0 0 0 r
s
.883 .258 .112 r
.5482 .39359 m .55153 .38997 L .57595 .39666 L p F P
0 0 0 r
s
.883 .258 .112 r
.57595 .39666 m .57095 .40196 L .5482 .39359 L p F P
0 0 0 r
s
1 .3 .128 r
.5 .38446 m .49159 .36518 L .48997 .36707 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.5 .38446 m .48997 .36707 L .48835 .36896 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.5 .38446 m .48835 .36896 L .48673 .37085 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.5 .38446 m .48031 .37833 L .47871 .38019 L closepath p F P
0 0 0 r
s
.285 .426 .838 r
.5 .38446 m .49159 .36518 L .49444 .36627 L closepath p F P
0 0 0 r
s
.285 .426 .838 r
.5 .38446 m .49444 .36627 L .49728 .36737 L closepath p F P
0 0 0 r
s
.285 .426 .838 r
.5 .38446 m .49728 .36737 L .50012 .36846 L closepath p F P
0 0 0 r
s
.285 .426 .838 r
.5 .38446 m .50012 .36846 L .50295 .36955 L closepath p F P
0 0 0 r
s
.285 .426 .838 r
.5 .38446 m .50295 .36955 L .50578 .37064 L closepath p F P
0 0 0 r
s
.285 .426 .838 r
.5 .38446 m .50578 .37064 L .5086 .37172 L closepath p F P
0 0 0 r
s
.285 .426 .838 r
.5 .38446 m .52823 .37927 L .53101 .38034 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.5 .38446 m .48673 .37085 L .48512 .37273 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.5 .38446 m .48512 .37273 L .48351 .3746 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.5 .38446 m .48351 .3746 L .48191 .37647 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.5 .38446 m .48191 .37647 L .48031 .37833 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.5 .38446 m .47871 .38019 L .47713 .38204 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.5 .38446 m .47713 .38204 L .47554 .38389 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.5 .38446 m .47554 .38389 L .47396 .38573 L closepath p F P
0 0 0 r
s
.975 .287 .123 r
.52769 .38404 m .52604 .38588 L .5 .38446 L closepath p F P
0 0 0 r
s
.975 .287 .123 r
.52935 .3822 m .52769 .38404 L .5 .38446 L closepath p F P
0 0 0 r
s
.975 .287 .123 r
.53101 .38034 m .52935 .3822 L .5 .38446 L closepath p F P
0 0 0 r
s
.285 .426 .838 r
.5 .38446 m .5086 .37172 L .51142 .37281 L closepath p F P
0 0 0 r
s
.285 .426 .838 r
.5 .38446 m .51142 .37281 L .51423 .37389 L closepath p F P
0 0 0 r
s
.285 .426 .838 r
.5 .38446 m .51423 .37389 L .51704 .37497 L closepath p F P
0 0 0 r
s
.285 .426 .838 r
.5 .38446 m .51704 .37497 L .51984 .37605 L closepath p F P
0 0 0 r
s
.285 .426 .838 r
.5 .38446 m .51984 .37605 L .52264 .37712 L closepath p F P
0 0 0 r
s
.285 .426 .838 r
.5 .38446 m .52264 .37712 L .52544 .3782 L closepath p F P
0 0 0 r
s
.285 .426 .838 r
.5 .38446 m .52544 .3782 L .52823 .37927 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.49257 .39461 m
.50753 .37758 L
s
.83 .24 .1 r
.487 .38121 m
.51291 .39105 L
s
1 .324 .136 r
.42402 .39622 m .41964 .40152 L .44541 .39329 L p F P
0 0 0 r
s
1 .324 .136 r
.44541 .39329 m .44846 .38967 L .42402 .39622 L p F P
0 0 0 r
s
.153 .191 .345 r
.51526 .6469 m .49934 .64204 L .49939 .65151 L p F P
0 0 0 r
s
.153 .191 .345 r
.49939 .65151 m .51406 .65595 L .51526 .6469 L p F P
0 0 0 r
s
1 .331 .136 r
.37384 .42483 m .36733 .43291 L .3901 .41886 L p F P
0 0 0 r
s
.83 .24 .1 r
.36902 .43709 m
.37594 .42854 L
s
1 .331 .136 r
.3901 .41886 m .39561 .4121 L .37384 .42483 L p F P
0 0 0 r
s
.83 .24 .1 r
.37594 .42854 m
.39191 .42436 L
s
.273 .073 .037 r
.60446 .56478 m .61582 .55455 L .61546 .57279 L p F P
0 0 0 r
s
.273 .073 .037 r
.61546 .57279 m .60413 .58282 L .60446 .56478 L p F P
0 0 0 r
s
.659 .189 .085 r
.60957 .45845 m .61878 .44941 L .63159 .4666 L p F P
0 0 0 r
s
.659 .189 .085 r
.63159 .4666 m .62129 .47647 L .60957 .45845 L p F P
0 0 0 r
s
.161 .046 .023 r
.59301 .59268 m .60413 .58282 L .60133 .59926 L p F P
0 0 0 r
s
.83 .24 .1 r
.58158 .58391 m
.60347 .56417 L
s
.161 .046 .023 r
.60133 .59926 m .59053 .60871 L .59301 .59268 L p F P
0 0 0 r
s
.93 .273 .118 r
.52604 .38588 m .52769 .38404 L .55488 .38633 L p F P
0 0 0 r
s
.93 .273 .118 r
.55488 .38633 m .55153 .38997 L .52604 .38588 L p F P
0 0 0 r
s
1 .313 .132 r
.45152 .38603 m .44846 .38967 L .47396 .38573 L p F P
0 0 0 r
s
1 .313 .132 r
.47396 .38573 m .47554 .38389 L .45152 .38603 L p F P
0 0 0 r
s
.221 .299 .561 r
.42862 .59227 m .41049 .5866 L .4129 .60288 L p F P
0 0 0 r
s
.221 .299 .561 r
.4129 .60288 m .43052 .60832 L .42862 .59227 L p F P
0 0 0 r
s
.24 .35 .67 r
.42974 .59692 m
.46564 .60811 L
s
.42906 .57372 m
.42974 .59692 L
s
.918 .277 .11 r
.33103 .46577 m .32314 .47566 L .34024 .45771 L p F P
0 0 0 r
s
.918 .277 .11 r
.34024 .45771 m .34748 .44865 L .33103 .46577 L p F P
0 0 0 r
s
.24 .35 .67 r
.34022 .45758 m
.37231 .46858 L
s
.3355 .45596 m
.33923 .45724 L
s
.391 .108 .052 r
.61348 .53535 m .62479 .52497 L .62739 .54413 L p F P
0 0 0 r
s
.391 .108 .052 r
.62739 .54413 m .61582 .55455 L .61348 .53535 L p F P
0 0 0 r
s
.24 .35 .67 r
.81855 .47088 m
.80587 .4584 L
s
.80587 .4584 m
.77326 .44557 L
s
.271 .384 .736 r
.33991 .4813 m .32314 .47566 L .31002 .49439 L p F P
0 0 0 r
s
.83 .24 .1 r
.3063 .4992 m
.31021 .49431 L
s
.271 .384 .736 r
.31002 .49439 m .32809 .50035 L .33991 .4813 L p F P
0 0 0 r
s
.24 .35 .67 r
.32744 .48448 m
.36445 .49685 L
s
.83 .24 .1 r
.29043 .54284 m
.27372 .56333 L
s
.27406 .58902 m
.27372 .56333 L
s
.24 .35 .67 r
.62925 .69629 m
.5948 .68593 L
s
.62925 .69629 m
.64384 .70125 L
s
.194 .255 .473 r
.46525 .61904 m .44797 .61371 L .45066 .6272 L p F P
0 0 0 r
s
.194 .255 .473 r
.45066 .6272 m .46704 .63219 L .46525 .61904 L p F P
0 0 0 r
s
.24 .35 .67 r
.46564 .60811 m
.46979 .62783 L
s
.833 .243 .106 r
.57095 .40196 m .57595 .39666 L .59878 .40583 L p F P
0 0 0 r
s
.24 .35 .67 r
.57721 .40425 m
.57883 .40305 L
s
.58342 .39966 m
.59302 .39257 L
s
.833 .243 .106 r
.59878 .40583 m .59216 .41266 L .57095 .40196 L p F P
0 0 0 r
s
.24 .35 .67 r
.59302 .39257 m
.62716 .40581 L
s
.24 .33 .624 r
.39184 .56279 m .37328 .55688 L .37368 .57508 L p F P
0 0 0 r
s
.24 .33 .624 r
.37368 .57508 m .39218 .58087 L .39184 .56279 L p F P
0 0 0 r
s
.93 .273 .118 r
.52769 .38404 m .52935 .3822 L .55825 .38268 L p F P
0 0 0 r
s
.93 .273 .118 r
.55825 .38268 m .55488 .38633 L .52769 .38404 L p F P
0 0 0 r
s
1 .332 .138 r
.40118 .40526 m .39561 .4121 L .41964 .40152 L p F P
0 0 0 r
s
1 .332 .138 r
.41964 .40152 m .42402 .39622 L .40118 .40526 L p F P
0 0 0 r
s
.24 .35 .67 r
.3943 .41286 m
.40673 .38916 L
s
1 .313 .132 r
.4546 .38237 m .45152 .38603 L .47554 .38389 L p F P
0 0 0 r
s
1 .313 .132 r
.47554 .38389 m .47713 .38204 L .4546 .38237 L p F P
0 0 0 r
s
.264 .37 .707 r
.34597 .50625 m .32809 .50035 L .32017 .51965 L p F P
0 0 0 r
s
.264 .37 .707 r
.32017 .51965 m .33891 .52572 L .34597 .50625 L p F P
0 0 0 r
s
.83 .24 .1 r
.27536 .66127 m
.26374 .63504 L
s
.26374 .63504 m
.28029 .61583 L
s
.883 .258 .112 r
.55153 .38997 m .55488 .38633 L .581 .39132 L p F P
0 0 0 r
s
.883 .258 .112 r
.581 .39132 m .57595 .39666 L .55153 .38997 L p F P
0 0 0 r
s
.084 .024 .01 r
.57992 .618 m .59053 .60871 L .58583 .62252 L p F P
0 0 0 r
s
.084 .024 .01 r
.58583 .62252 m .5758 .63121 L .57992 .618 L p F P
0 0 0 r
s
.83 .24 .1 r
.57285 .6292 m
.57986 .60765 L
s
1 .324 .136 r
.42844 .39087 m .42402 .39622 L .44846 .38967 L p F P
0 0 0 r
s
.24 .35 .67 r
.40673 .38916 m
.42445 .3957 L
s
1 .324 .136 r
.44846 .38967 m .45152 .38603 L .42844 .39087 L p F P
0 0 0 r
s
.723 .209 .093 r
.60334 .43358 m .61137 .4255 L .62813 .44023 L p F P
0 0 0 r
s
.723 .209 .093 r
.62813 .44023 m .61878 .44941 L .60334 .43358 L p F P
0 0 0 r
s
.497 .14 .065 r
.61932 .50552 m .63028 .49525 L .63631 .5144 L p F P
0 0 0 r
s
.497 .14 .065 r
.63631 .5144 m .62479 .52497 L .61932 .50552 L p F P
0 0 0 r
s
.83 .24 .1 r
.59972 .53902 m
.62211 .51832 L
s
.24 .35 .67 r
.3355 .45596 m
.34548 .42769 L
s
.33344 .46327 m
.3355 .45596 L
s
.93 .273 .118 r
.52935 .3822 m .53101 .38034 L .56164 .379 L p F P
0 0 0 r
s
.93 .273 .118 r
.56164 .379 m .55825 .38268 L .52935 .3822 L p F P
0 0 0 r
s
1 .316 .128 r
.35483 .43946 m .34748 .44865 L .36733 .43291 L p F P
0 0 0 r
s
1 .316 .128 r
.36733 .43291 m .37384 .42483 L .35483 .43946 L p F P
0 0 0 r
s
.24 .35 .67 r
.34548 .42769 m
.3624 .43364 L
s
1 .313 .132 r
.45769 .37869 m .4546 .38237 L .47713 .38204 L p F P
0 0 0 r
s
1 .313 .132 r
.47713 .38204 m .47871 .38019 L .45769 .37869 L p F P
0 0 0 r
s
.83 .24 .1 r
.47498 .39511 m
.487 .38121 L
s
.24 .35 .67 r
.34548 .42769 m
.35705 .40058 L
s
.34548 .42769 m
.30799 .4145 L
s
.83 .24 .1 r
.53904 .66623 m
.54139 .66421 L
s
.254 .353 .671 r
.35747 .53173 m .33891 .52572 L .33557 .54488 L p F P
0 0 0 r
s
.254 .353 .671 r
.33557 .54488 m .35452 .55091 L .35747 .53173 L p F P
0 0 0 r
s
.24 .35 .67 r
.35591 .55043 m
.35891 .52445 L
s
.40673 .38916 m
.36985 .37557 L
s
.153 .191 .345 r
.49934 .64204 m .48326 .63714 L .48459 .64704 L p F P
0 0 0 r
s
.24 .35 .67 r
.46979 .62783 m
.50544 .63876 L
s
.153 .191 .345 r
.48459 .64704 m .49939 .65151 L .49934 .64204 L p F P
0 0 0 r
s
.24 .35 .67 r
.73997 .43246 m
.72579 .42621 L
s
.72579 .42621 m
.69223 .413 L
s
.275 .416 .823 r
.55615 .37686 m .56164 .379 L .53101 .38034 L p F P
0 0 0 r
s
.275 .416 .823 r
.53101 .38034 m .52823 .37927 L .55615 .37686 L p F P
0 0 0 r
s
.781 .227 .1 r
.59216 .41266 m .59878 .40583 L .6195 .41732 L p F P
0 0 0 r
s
.781 .227 .1 r
.6195 .41732 m .61137 .4255 L .59216 .41266 L p F P
0 0 0 r
s
.83 .24 .1 r
.58206 .44424 m
.60413 .42183 L
s
1 .313 .132 r
.4608 .37499 m .45769 .37869 L .47871 .38019 L p F P
0 0 0 r
s
1 .313 .132 r
.47871 .38019 m .48031 .37833 L .4608 .37499 L p F P
0 0 0 r
s
.24 .35 .67 r
.54854 .66493 m
.55962 .67536 L
s
.83 .24 .1 r
.36381 .73785 m
.38223 .72047 L
s
.36381 .73785 m
.33754 .72517 L
s
.883 .258 .112 r
.55488 .38633 m .55825 .38268 L .58608 .38593 L p F P
0 0 0 r
s
.883 .258 .112 r
.58608 .38593 m .581 .39132 L .55488 .38633 L p F P
0 0 0 r
s
.24 .35 .67 r
.58336 .38881 m
.59302 .39257 L
s
1 .331 .136 r
.38044 .41663 m .37384 .42483 L .39561 .4121 L p F P
0 0 0 r
s
1 .331 .136 r
.39561 .4121 m .40118 .40526 L .38044 .41663 L p F P
0 0 0 r
s
.24 .35 .67 r
.35705 .40058 m
.38883 .41203 L
s
.585 .167 .076 r
.62129 .47647 m .63159 .4666 L .64144 .4848 L p F P
0 0 0 r
s
.585 .167 .076 r
.64144 .4848 m .63028 .49525 L .62129 .47647 L p F P
0 0 0 r
s
.83 .24 .1 r
.61308 .49266 m
.62211 .51832 L
s
1 .324 .136 r
.43289 .38548 m .42844 .39087 L .45152 .38603 L p F P
0 0 0 r
s
1 .324 .136 r
.45152 .38603 m .4546 .38237 L .43289 .38548 L p F P
0 0 0 r
s
.275 .416 .823 r
.55064 .37472 m .55615 .37686 L .52823 .37927 L p F P
0 0 0 r
s
.24 .35 .67 r
.55245 .38349 m
.55818 .37904 L
s
.275 .416 .823 r
.52823 .37927 m .52544 .3782 L .55064 .37472 L p F P
0 0 0 r
s
.83 .24 .1 r
.43577 .72948 m
.45551 .71193 L
s
.43577 .72948 m
.40942 .72789 L
s
.833 .243 .106 r
.57595 .39666 m .581 .39132 L .60547 .39892 L p F P
0 0 0 r
s
.833 .243 .106 r
.60547 .39892 m .59878 .40583 L .57595 .39666 L p F P
0 0 0 r
s
.83 .24 .1 r
.56129 .42317 m
.58297 .4004 L
s
.221 .299 .561 r
.41049 .5866 m .39218 .58087 L .39509 .59738 L p F P
0 0 0 r
s
.221 .299 .561 r
.39509 .59738 m .4129 .60288 L .41049 .5866 L p F P
0 0 0 r
s
.083 .024 .01 r
.31838 .48393 m .31002 .49439 L .32314 .47566 L p F P
0 0 0 r
s
.083 .024 .01 r
.32314 .47566 m .33103 .46577 L .31838 .48393 L p F P
0 0 0 r
s
.83 .24 .1 r
.31956 .48261 m
.32348 .4777 L
s
.24 .35 .67 r
.32744 .48448 m
.33287 .46528 L
s
.83 .24 .1 r
.32348 .4777 m
.33383 .46696 L
s
1 .332 .138 r
.40681 .39835 m .40118 .40526 L .42402 .39622 L p F P
0 0 0 r
s
.83 .24 .1 r
.417 .39992 m
.44152 .39954 L
s
.40196 .4182 m
.417 .39992 L
s
1 .332 .138 r
.42402 .39622 m .42844 .39087 L .40681 .39835 L p F P
0 0 0 r
s
.083 .024 .01 r
.54304 .6647 m .55181 .65713 L .54602 .66257 L p F P
0 0 0 r
s
.24 .35 .67 r
.54446 .66369 m
.54854 .66493 L
s
.083 .024 .01 r
.54602 .66257 m .53825 .66927 L .54304 .6647 L p F P
0 0 0 r
s
.112 .127 .241 r
.54304 .6647 m .52861 .66034 L .52542 .66541 L p F P
0 0 0 r
s
.112 .127 .241 r
.52542 .66541 m .53825 .66927 L .54304 .6647 L p F P
0 0 0 r
s
.83 .24 .1 r
.52195 .68048 m
.53616 .66864 L
s
1 .313 .132 r
.46394 .37127 m .4608 .37499 L .48031 .37833 L p F P
0 0 0 r
s
1 .313 .132 r
.48031 .37833 m .48191 .37647 L .46394 .37127 L p F P
0 0 0 r
s
.275 .416 .823 r
.54511 .37257 m .55064 .37472 L .52544 .3782 L p F P
0 0 0 r
s
.275 .416 .823 r
.52544 .3782 m .52264 .37712 L .54511 .37257 L p F P
0 0 0 r
s
.24 .35 .67 r
.50753 .37758 m
.52869 .38568 L
s
.31764 .48121 m
.319 .48166 L
s
.31978 .48192 m
.32744 .48448 L
s
.28965 .47185 m
.31764 .48121 L
s
.194 .255 .473 r
.44797 .61371 m .43052 .60832 L .43413 .62215 L p F P
0 0 0 r
s
.194 .255 .473 r
.43413 .62215 m .45066 .6272 L .44797 .61371 L p F P
0 0 0 r
s
.083 .024 .01 r
.56593 .63977 m .5758 .63121 L .56976 .64163 L p F P
0 0 0 r
s
.083 .024 .01 r
.56976 .64163 m .56072 .64944 L .56593 .63977 L p F P
0 0 0 r
s
.83 .24 .1 r
.55134 .64794 m
.57285 .6292 L
s
.24 .33 .624 r
.37328 .55688 m .35452 .55091 L .35498 .56922 L p F P
0 0 0 r
s
.24 .33 .624 r
.35498 .56922 m .37368 .57508 L .37328 .55688 L p F P
0 0 0 r
s
.24 .35 .67 r
.35591 .55043 m
.39287 .56219 L
s
.83 .24 .1 r
.29043 .54284 m
.29569 .51931 L
s
.275 .416 .823 r
.53956 .37042 m .54511 .37257 L .52264 .37712 L p F P
0 0 0 r
s
.275 .416 .823 r
.52264 .37712 m .51984 .37605 L .53956 .37042 L p F P
0 0 0 r
s
.83 .24 .1 r
.51291 .39105 m
.52537 .37706 L
s
.264 .37 .707 r
.32809 .50035 m .31002 .49439 L .30122 .51352 L p F P
0 0 0 r
s
.264 .37 .707 r
.30122 .51352 m .32017 .51965 L .32809 .50035 L p F P
0 0 0 r
s
.24 .35 .67 r
.32159 .51228 m
.32744 .48448 L
s
.36985 .37557 m
.35705 .40058 L
s
.35705 .40058 m
.31954 .38706 L
s
.83 .24 .1 r
.58297 .4004 m
.60413 .42183 L
s
.659 .189 .085 r
.61878 .44941 m .62813 .44023 L .64206 .45656 L p F P
0 0 0 r
s
.659 .189 .085 r
.64206 .45656 m .63159 .4666 L .61878 .44941 L p F P
0 0 0 r
s
.83 .24 .1 r
.59955 .46767 m
.622 .44562 L
s
1 .313 .132 r
.46708 .36752 m .46394 .37127 L .48191 .37647 L p F P
0 0 0 r
s
1 .313 .132 r
.48191 .37647 m .48351 .3746 L .46708 .36752 L p F P
0 0 0 r
s
.83 .24 .1 r
.46118 .37619 m
.487 .38121 L
s
.275 .416 .823 r
.534 .36826 m .53956 .37042 L .51984 .37605 L p F P
0 0 0 r
s
.275 .416 .823 r
.51984 .37605 m .51704 .37497 L .534 .36826 L p F P
0 0 0 r
s
.883 .258 .112 r
.55825 .38268 m .56164 .379 L .59121 .3805 L p F P
0 0 0 r
s
.883 .258 .112 r
.59121 .3805 m .58608 .38593 L .55825 .38268 L p F P
0 0 0 r
s
.83 .24 .1 r
.53796 .40522 m
.55927 .38208 L
s
.918 .277 .11 r
.33904 .45572 m .33103 .46577 L .34748 .44865 L p F P
0 0 0 r
s
.24 .35 .67 r
.29792 .44308 m
.3355 .45596 L
s
.918 .277 .11 r
.34748 .44865 m .35483 .43946 L .33904 .45572 L p F P
0 0 0 r
s
1 .324 .136 r
.43738 .38005 m .43289 .38548 L .4546 .38237 L p F P
0 0 0 r
s
1 .324 .136 r
.4546 .38237 m .45769 .37869 L .43738 .38005 L p F P
0 0 0 r
s
.24 .35 .67 r
.67802 .71152 m
.64384 .70125 L
s
.67802 .71152 m
.69504 .71052 L
s
.83 .24 .1 r
.29212 .68587 m
.27536 .66127 L
s
.27536 .66127 m
.29222 .64242 L
s
.275 .416 .823 r
.52842 .36609 m .534 .36826 L .51704 .37497 L p F P
0 0 0 r
s
.83 .24 .1 r
.53342 .36803 m
.53387 .36753 L
s
.275 .416 .823 r
.51704 .37497 m .51423 .37389 L .52842 .36609 L p F P
0 0 0 r
s
1 .313 .132 r
.47025 .36376 m .46708 .36752 L .48351 .3746 L p F P
0 0 0 r
s
1 .313 .132 r
.48351 .3746 m .48512 .37273 L .47025 .36376 L p F P
0 0 0 r
s
.273 .073 .037 r
.61582 .55455 m .62739 .54413 L .62698 .56257 L p F P
0 0 0 r
s
.273 .073 .037 r
.62698 .56257 m .61546 .57279 L .61582 .55455 L p F P
0 0 0 r
s
.153 .191 .345 r
.48326 .63714 m .46704 .63219 L .46966 .64252 L p F P
0 0 0 r
s
.153 .191 .345 r
.46966 .64252 m .48459 .64704 L .48326 .63714 L p F P
0 0 0 r
s
.723 .209 .093 r
.61137 .4255 m .6195 .41732 L .63762 .43091 L p F P
0 0 0 r
s
.723 .209 .093 r
.63762 .43091 m .62813 .44023 L .61137 .4255 L p F P
0 0 0 r
s
.83 .24 .1 r
.60413 .42183 m
.622 .44562 L
s
.161 .046 .023 r
.60413 .58282 m .61546 .57279 L .61232 .58964 L p F P
0 0 0 r
s
.161 .046 .023 r
.61232 .58964 m .60133 .59926 L .60413 .58282 L p F P
0 0 0 r
s
.83 .24 .1 r
.60199 .58809 m
.60347 .56417 L
s
.254 .353 .671 r
.33891 .52572 m .32017 .51965 L .31641 .53879 L p F P
0 0 0 r
s
.24 .35 .67 r
.32159 .51228 m
.35891 .52445 L
s
.254 .353 .671 r
.31641 .53879 m .33557 .54488 L .33891 .52572 L p F P
0 0 0 r
s
.275 .416 .823 r
.52282 .36391 m .52842 .36609 L .51423 .37389 L p F P
0 0 0 r
s
.275 .416 .823 r
.51423 .37389 m .51142 .37281 L .52282 .36391 L p F P
0 0 0 r
s
.833 .243 .106 r
.581 .39132 m .58608 .38593 L .61223 .39194 L p F P
0 0 0 r
s
.24 .35 .67 r
.59302 .39257 m
.59537 .3916 L
s
.833 .243 .106 r
.61223 .39194 m .60547 .39892 L .581 .39132 L p F P
0 0 0 r
s
.83 .24 .1 r
.55927 .38208 m
.58297 .4004 L
s
1 .316 .128 r
.36229 .43014 m .35483 .43946 L .37384 .42483 L p F P
0 0 0 r
s
1 .316 .128 r
.37384 .42483 m .38044 .41663 L .36229 .43014 L p F P
0 0 0 r
s
.83 .24 .1 r
.53387 .36753 m
.53757 .36965 L
s
.391 .108 .052 r
.62479 .52497 m .63631 .5144 L .63917 .53352 L p F P
0 0 0 r
s
.391 .108 .052 r
.63917 .53352 m .62739 .54413 L .62479 .52497 L p F P
0 0 0 r
s
.83 .24 .1 r
.62211 .51832 m
.62616 .5437 L
s
.33754 .72517 m
.35557 .70747 L
s
.33754 .72517 m
.31321 .70755 L
s
.781 .227 .1 r
.59878 .40583 m .60547 .39892 L .62773 .40903 L p F P
0 0 0 r
s
.781 .227 .1 r
.62773 .40903 m .6195 .41732 L .59878 .40583 L p F P
0 0 0 r
s
1 .332 .138 r
.4125 .39136 m .40681 .39835 L .42844 .39087 L p F P
0 0 0 r
s
1 .332 .138 r
.42844 .39087 m .43289 .38548 L .4125 .39136 L p F P
0 0 0 r
s
.112 .127 .241 r
.52861 .66034 m .51406 .65595 L .51249 .66153 L p F P
0 0 0 r
s
.112 .127 .241 r
.51249 .66153 m .52542 .66541 L .52861 .66034 L p F P
0 0 0 r
s
.275 .416 .823 r
.5172 .36173 m .52282 .36391 L .51142 .37281 L p F P
0 0 0 r
s
.275 .416 .823 r
.51142 .37281 m .5086 .37172 L .5172 .36173 L p F P
0 0 0 r
s
1 .313 .132 r
.47344 .35997 m .47025 .36376 L .48512 .37273 L p F P
0 0 0 r
s
1 .313 .132 r
.48512 .37273 m .48673 .37085 L .47344 .35997 L p F P
0 0 0 r
s
1 .331 .136 r
.38712 .40833 m .38044 .41663 L .40118 .40526 L p F P
0 0 0 r
s
1 .331 .136 r
.40118 .40526 m .40681 .39835 L .38712 .40833 L p F P
0 0 0 r
s
.255 .392 .783 r
.58315 .37734 m .59121 .3805 L .56164 .379 L p F P
0 0 0 r
s
.24 .35 .67 r
.55818 .37904 m
.56428 .38141 L
s
.255 .392 .783 r
.56164 .379 m .55615 .37686 L .58315 .37734 L p F P
0 0 0 r
s
.83 .24 .1 r
.55927 .38208 m
.56305 .37797 L
s
.54998 .37676 m
.55927 .38208 L
s
1 .324 .136 r
.44191 .37457 m .43738 .38005 L .45769 .37869 L p F P
0 0 0 r
s
.24 .35 .67 r
.42059 .36752 m
.44129 .37532 L
s
1 .324 .136 r
.45769 .37869 m .4608 .37499 L .44191 .37457 L p F P
0 0 0 r
s
.83 .24 .1 r
.44152 .39954 m
.46118 .37619 L
s
.221 .299 .561 r
.39218 .58087 m .37368 .57508 L .37711 .59183 L p F P
0 0 0 r
s
.221 .299 .561 r
.37711 .59183 m .39509 .59738 L .39218 .58087 L p F P
0 0 0 r
s
.24 .35 .67 r
.39308 .58549 m
.42974 .59692 L
s
.39287 .56219 m
.39308 .58549 L
s
.084 .024 .01 r
.59053 .60871 m .60133 .59926 L .59602 .61367 L p F P
0 0 0 r
s
.83 .24 .1 r
.57986 .60765 m
.60199 .58809 L
s
.084 .024 .01 r
.59602 .61367 m .58583 .62252 L .59053 .60871 L p F P
0 0 0 r
s
.275 .416 .823 r
.51156 .35954 m .5172 .36173 L .5086 .37172 L p F P
0 0 0 r
s
.275 .416 .823 r
.5086 .37172 m .50578 .37064 L .51156 .35954 L p F P
0 0 0 r
s
.194 .255 .473 r
.43052 .60832 m .4129 .60288 L .41744 .61706 L p F P
0 0 0 r
s
.194 .255 .473 r
.41744 .61706 m .43413 .62215 L .43052 .60832 L p F P
0 0 0 r
s
.24 .35 .67 r
.42974 .59692 m
.43339 .61668 L
s
.78553 .45797 m
.77326 .44557 L
s
.77326 .44557 m
.73997 .43246 L
s
.497 .14 .065 r
.63028 .49525 m .64144 .4848 L .64804 .50364 L p F P
0 0 0 r
s
.497 .14 .065 r
.64804 .50364 m .63631 .5144 L .63028 .49525 L p F P
0 0 0 r
s
.24 .35 .67 r
.5948 .68593 m
.55962 .67536 L
s
.5948 .68593 m
.60893 .69076 L
s
.83 .24 .1 r
.31321 .70755 m
.29212 .68587 L
s
.29212 .68587 m
.30936 .66741 L
s
.28029 .61583 m
.27406 .58902 L
s
.27406 .58902 m
.29096 .56878 L
s
1 .313 .132 r
.47664 .35616 m .47344 .35997 L .48673 .37085 L p F P
0 0 0 r
s
1 .313 .132 r
.48673 .37085 m .48835 .36896 L .47664 .35616 L p F P
0 0 0 r
s
.83 .24 .1 r
.47997 .70792 m
.50065 .68986 L
s
.47997 .70792 m
.45551 .71193 L
s
.275 .416 .823 r
.50591 .35734 m .51156 .35954 L .50578 .37064 L p F P
0 0 0 r
s
.83 .24 .1 r
.50721 .35785 m
.50765 .35733 L
s
.24 .35 .67 r
.50753 .37758 m
.5226 .36523 L
s
.275 .416 .823 r
.50578 .37064 m .50295 .36955 L .50591 .35734 L p F P
0 0 0 r
s
.24 .33 .624 r
.35452 .55091 m .33557 .54488 L .33609 .56331 L p F P
0 0 0 r
s
.24 .33 .624 r
.33609 .56331 m .35498 .56922 L .35452 .55091 L p F P
0 0 0 r
s
.083 .024 .01 r
.30989 .50274 m .30122 .51352 L .31002 .49439 L p F P
0 0 0 r
s
.83 .24 .1 r
.29569 .51931 m
.30239 .51098 L
s
.083 .024 .01 r
.31002 .49439 m .31838 .48393 L .30989 .50274 L p F P
0 0 0 r
s
.83 .24 .1 r
.31321 .70755 m
.33084 .68948 L
s
.255 .392 .783 r
.57505 .37417 m .58315 .37734 L .55615 .37686 L p F P
0 0 0 r
s
.255 .392 .783 r
.55615 .37686 m .55064 .37472 L .57505 .37417 L p F P
0 0 0 r
s
.275 .416 .823 r
.50024 .35514 m .50591 .35734 L .50295 .36955 L p F P
0 0 0 r
s
.275 .416 .823 r
.50295 .36955 m .50012 .36846 L .50024 .35514 L p F P
0 0 0 r
s
.24 .35 .67 r
.4861 .36937 m
.50753 .37758 L
s
.30624 .50728 m
.32159 .51228 L
s
1 .313 .132 r
.47986 .35233 m .47664 .35616 L .48835 .36896 L p F P
0 0 0 r
s
1 .313 .132 r
.48835 .36896 m .48997 .36707 L .47986 .35233 L p F P
0 0 0 r
s
.585 .167 .076 r
.63159 .4666 m .64206 .45656 L .65278 .47417 L p F P
0 0 0 r
s
.585 .167 .076 r
.65278 .47417 m .64144 .4848 L .63159 .4666 L p F P
0 0 0 r
s
.83 .24 .1 r
.61308 .49266 m
.63592 .47093 L
s
.24 .35 .67 r
.30799 .4145 m
.29792 .44308 L
s
.29792 .44308 m
.25955 .42993 L
s
.29792 .44308 m
.28965 .47185 L
s
.083 .024 .01 r
.55181 .65713 m .56072 .64944 L .55389 .65578 L p F P
0 0 0 r
s
.083 .024 .01 r
.55389 .65578 m .54602 .66257 L .55181 .65713 L p F P
0 0 0 r
s
.275 .416 .823 r
.49454 .35293 m .50024 .35514 L .50012 .36846 L p F P
0 0 0 r
s
.275 .416 .823 r
.50012 .36846 m .49728 .36737 L .49454 .35293 L p F P
0 0 0 r
s
.24 .35 .67 r
.31954 .38706 m
.30799 .4145 L
s
.30799 .4145 m
.26972 .40104 L
s
1 .324 .136 r
.44648 .36904 m .44191 .37457 L .4608 .37499 L p F P
0 0 0 r
s
1 .324 .136 r
.4608 .37499 m .46394 .37127 L .44648 .36904 L p F P
0 0 0 r
s
.153 .191 .345 r
.46704 .63219 m .45066 .6272 L .45461 .63797 L p F P
0 0 0 r
s
.153 .191 .345 r
.45461 .63797 m .46966 .64252 L .46704 .63219 L p F P
0 0 0 r
s
.833 .243 .106 r
.58608 .38593 m .59121 .3805 L .61907 .38488 L p F P
0 0 0 r
s
.833 .243 .106 r
.61907 .38488 m .61223 .39194 L .58608 .38593 L p F P
0 0 0 r
s
.083 .024 .01 r
.32689 .47328 m .31838 .48393 L .33103 .46577 L p F P
0 0 0 r
s
.083 .024 .01 r
.33103 .46577 m .33904 .45572 L .32689 .47328 L p F P
0 0 0 r
s
.255 .392 .783 r
.56691 .37098 m .57505 .37417 L .55064 .37472 L p F P
0 0 0 r
s
.255 .392 .783 r
.55064 .37472 m .54511 .37257 L .56691 .37098 L p F P
0 0 0 r
s
1 .332 .138 r
.41825 .38429 m .4125 .39136 L .43289 .38548 L p F P
0 0 0 r
s
1 .332 .138 r
.43289 .38548 m .43738 .38005 L .41825 .38429 L p F P
0 0 0 r
s
.24 .35 .67 r
.40673 .38916 m
.42059 .36752 L
s
.275 .416 .823 r
.48883 .35071 m .49454 .35293 L .49728 .36737 L p F P
0 0 0 r
s
.275 .416 .823 r
.49728 .36737 m .49444 .36627 L .48883 .35071 L p F P
0 0 0 r
s
.254 .353 .671 r
.32017 .51965 m .30122 .51352 L .29704 .53263 L p F P
0 0 0 r
s
.254 .353 .671 r
.29704 .53263 m .31641 .53879 L .32017 .51965 L p F P
0 0 0 r
s
.24 .35 .67 r
.31818 .53841 m
.32159 .51228 L
s
.72891 .72076 m
.69504 .71052 L
s
.72891 .72076 m
.74754 .71367 L
s
.112 .127 .241 r
.51406 .65595 m .49939 .65151 L .49946 .65761 L p F P
0 0 0 r
s
.24 .35 .67 r
.50544 .63876 m
.51312 .6542 L
s
.112 .127 .241 r
.49946 .65761 m .51249 .66153 L .51406 .65595 L p F P
0 0 0 r
s
.24 .35 .67 r
.51312 .6542 m
.54408 .66358 L
s
.38346 .35355 m
.36985 .37557 L
s
.36985 .37557 m
.33219 .36168 L
s
1 .313 .132 r
.4831 .34848 m .47986 .35233 L .48997 .36707 L p F P
0 0 0 r
s
1 .313 .132 r
.48997 .36707 m .49159 .36518 L .4831 .34848 L p F P
0 0 0 r
s
.83 .24 .1 r
.487 .38121 m
.49928 .36702 L
s
.083 .024 .01 r
.5758 .63121 m .58583 .62252 L .57894 .63371 L p F P
0 0 0 r
s
.083 .024 .01 r
.57894 .63371 m .56976 .64163 L .5758 .63121 L p F P
0 0 0 r
s
.24 .35 .67 r
.42059 .36752 m
.38346 .35355 L
s
.659 .189 .085 r
.62813 .44023 m .63762 .43091 L .65271 .44636 L p F P
0 0 0 r
s
.659 .189 .085 r
.65271 .44636 m .64206 .45656 L .62813 .44023 L p F P
0 0 0 r
s
.83 .24 .1 r
.622 .44562 m
.63592 .47093 L
s
.24 .35 .67 r
.70596 .41908 m
.69223 .413 L
s
.69223 .413 m
.65797 .39951 L
s
.275 .416 .823 r
.4831 .34848 m .48883 .35071 L .49444 .36627 L p F P
0 0 0 r
s
.275 .416 .823 r
.49444 .36627 m .49159 .36518 L .4831 .34848 L p F P
0 0 0 r
s
.83 .24 .1 r
.40942 .72789 m
.42888 .71013 L
s
.40942 .72789 m
.38223 .72047 L
s
.781 .227 .1 r
.60547 .39892 m .61223 .39194 L .63608 .40063 L p F P
0 0 0 r
s
.781 .227 .1 r
.63608 .40063 m .62773 .40903 L .60547 .39892 L p F P
0 0 0 r
s
.24 .35 .67 r
.61522 .38885 m
.64304 .39975 L
s
.918 .277 .11 r
.34719 .44551 m .33904 .45572 L .35483 .43946 L p F P
0 0 0 r
s
.918 .277 .11 r
.35483 .43946 m .36229 .43014 L .34719 .44551 L p F P
0 0 0 r
s
.83 .24 .1 r
.34103 .45902 m
.35664 .43953 L
s
.255 .392 .783 r
.55873 .36778 m .56691 .37098 L .54511 .37257 L p F P
0 0 0 r
s
.255 .392 .783 r
.54511 .37257 m .53956 .37042 L .55873 .36778 L p F P
0 0 0 r
s
.723 .209 .093 r
.6195 .41732 m .62773 .40903 L .64726 .42146 L p F P
0 0 0 r
s
.723 .209 .093 r
.64726 .42146 m .63762 .43091 L .6195 .41732 L p F P
0 0 0 r
s
1 .331 .136 r
.3939 .39993 m .38712 .40833 L .40681 .39835 L p F P
0 0 0 r
s
1 .331 .136 r
.40681 .39835 m .4125 .39136 L .3939 .39993 L p F P
0 0 0 r
s
.83 .24 .1 r
.39454 .40557 m
.417 .39992 L
s
1 .316 .128 r
.36986 .42067 m .36229 .43014 L .38044 .41663 L p F P
0 0 0 r
s
.83 .24 .1 r
.35664 .43953 m
.37594 .42854 L
s
1 .316 .128 r
.38044 .41663 m .38712 .40833 L .36986 .42067 L p F P
0 0 0 r
s
.83 .24 .1 r
.37594 .42854 m
.39454 .40557 L
s
.221 .299 .561 r
.37368 .57508 m .35498 .56922 L .35894 .58623 L p F P
0 0 0 r
s
.221 .299 .561 r
.35894 .58623 m .37711 .59183 L .37368 .57508 L p F P
0 0 0 r
s
.194 .255 .473 r
.4129 .60288 m .39509 .59738 L .40059 .61192 L p F P
0 0 0 r
s
.194 .255 .473 r
.40059 .61192 m .41744 .61706 L .4129 .60288 L p F P
0 0 0 r
s
1 .324 .136 r
.45109 .36347 m .44648 .36904 L .46394 .37127 L p F P
0 0 0 r
s
1 .324 .136 r
.46394 .37127 m .46708 .36752 L .45109 .36347 L p F P
0 0 0 r
s
.24 .35 .67 r
.28965 .47185 m
.25106 .45896 L
s
.28965 .47185 m
.28348 .49986 L
s
.83 .24 .1 r
.52195 .68048 m
.50065 .68986 L
s
.255 .392 .783 r
.55051 .36456 m .55873 .36778 L .53956 .37042 L p F P
0 0 0 r
s
.255 .392 .783 r
.53956 .37042 m .534 .36826 L .55051 .36456 L p F P
0 0 0 r
s
.24 .33 .624 r
.33557 .54488 m .31641 .53879 L .317 .55733 L p F P
0 0 0 r
s
.24 .33 .624 r
.317 .55733 m .33609 .56331 L .33557 .54488 L p F P
0 0 0 r
s
.24 .35 .67 r
.31818 .53841 m
.35591 .55043 L
s
.82818 .48898 m
.81855 .47088 L
s
.81855 .47088 m
.78553 .45797 L
s
.33219 .36168 m
.31954 .38706 L
s
.31954 .38706 m
.28123 .37326 L
s
.216 .343 .692 r
.60862 .38077 m .61907 .38488 L .59121 .3805 L p F P
0 0 0 r
s
.83 .24 .1 r
.58297 .4004 m
.60086 .38161 L
s
.216 .343 .692 r
.59121 .3805 m .58315 .37734 L .60862 .38077 L p F P
0 0 0 r
s
.273 .073 .037 r
.62739 .54413 m .63917 .53352 L .63873 .55216 L p F P
0 0 0 r
s
.273 .073 .037 r
.63873 .55216 m .62698 .56257 L .62739 .54413 L p F P
0 0 0 r
s
.161 .046 .023 r
.61546 .57279 m .62698 .56257 L .6235 .57985 L p F P
0 0 0 r
s
.83 .24 .1 r
.60347 .56417 m
.62616 .5437 L
s
.161 .046 .023 r
.6235 .57985 m .61232 .58964 L .61546 .57279 L p F P
0 0 0 r
s
1 .332 .138 r
.42407 .37715 m .41825 .38429 L .43738 .38005 L p F P
0 0 0 r
s
1 .332 .138 r
.43738 .38005 m .44191 .37457 L .42407 .37715 L p F P
0 0 0 r
s
.153 .191 .345 r
.45066 .6272 m .43413 .62215 L .43942 .63338 L p F P
0 0 0 r
s
.153 .191 .345 r
.43942 .63338 m .45461 .63797 L .45066 .6272 L p F P
0 0 0 r
s
.24 .35 .67 r
.43339 .61668 m
.46979 .62783 L
s
.64384 .70125 m
.60893 .69076 L
s
.64384 .70125 m
.66045 .70007 L
s
.112 .127 .241 r
.49939 .65151 m .48459 .64704 L .48633 .65367 L p F P
0 0 0 r
s
.112 .127 .241 r
.48633 .65367 m .49946 .65761 L .49939 .65151 L p F P
0 0 0 r
s
.255 .392 .783 r
.54226 .36133 m .55051 .36456 L .534 .36826 L p F P
0 0 0 r
s
.255 .392 .783 r
.534 .36826 m .52842 .36609 L .54226 .36133 L p F P
0 0 0 r
s
.391 .108 .052 r
.63631 .5144 m .64804 .50364 L .65118 .52271 L p F P
0 0 0 r
s
.391 .108 .052 r
.65118 .52271 m .63917 .53352 L .63631 .5144 L p F P
0 0 0 r
s
.83 .24 .1 r
.29096 .56878 m
.29043 .54284 L
s
1 .324 .136 r
.45573 .35785 m .45109 .36347 L .46708 .36752 L p F P
0 0 0 r
s
1 .324 .136 r
.46708 .36752 m .47025 .36376 L .45573 .35785 L p F P
0 0 0 r
s
.084 .024 .01 r
.60133 .59926 m .61232 .58964 L .60639 .60468 L p F P
0 0 0 r
s
.084 .024 .01 r
.60639 .60468 m .59602 .61367 L .60133 .59926 L p F P
0 0 0 r
s
.83 .24 .1 r
.59515 .60977 m
.60199 .58809 L
s
.143 .041 .02 r
.30586 .5218 m .29704 .53263 L .30122 .51352 L p F P
0 0 0 r
s
.143 .041 .02 r
.30122 .51352 m .30989 .50274 L .30586 .5218 L p F P
0 0 0 r
s
.24 .35 .67 r
.28348 .49986 m
.30347 .50638 L
s
.30347 .50638 m
.30454 .50673 L
s
.497 .14 .065 r
.64144 .4848 m .65278 .47417 L .65998 .49268 L p F P
0 0 0 r
s
.497 .14 .065 r
.65998 .49268 m .64804 .50364 L .64144 .4848 L p F P
0 0 0 r
s
.83 .24 .1 r
.62211 .51832 m
.64531 .49687 L
s
.29222 .64242 m
.28029 .61583 L
s
.28029 .61583 m
.29745 .5959 L
s
.216 .343 .692 r
.59811 .37664 m .60862 .38077 L .58315 .37734 L p F P
0 0 0 r
s
.83 .24 .1 r
.60356 .37878 m
.60544 .3768 L
s
.216 .343 .692 r
.58315 .37734 m .57505 .37417 L .59811 .37664 L p F P
0 0 0 r
s
.255 .392 .783 r
.53396 .35808 m .54226 .36133 L .52842 .36609 L p F P
0 0 0 r
s
.255 .392 .783 r
.52842 .36609 m .52282 .36391 L .53396 .35808 L p F P
0 0 0 r
s
.24 .35 .67 r
.5226 .36523 m
.55818 .37904 L
s
.781 .227 .1 r
.61223 .39194 m .61907 .38488 L .64453 .39212 L p F P
0 0 0 r
s
.781 .227 .1 r
.64453 .39212 m .63608 .40063 L .61223 .39194 L p F P
0 0 0 r
s
.83 .24 .1 r
.60413 .42183 m
.627 .39861 L
s
.24 .35 .67 r
.64304 .39975 m
.65797 .39951 L
s
.083 .024 .01 r
.56072 .64944 m .56976 .64163 L .56186 .64891 L p F P
0 0 0 r
s
.83 .24 .1 r
.56063 .64757 m
.57285 .6292 L
s
.083 .024 .01 r
.56186 .64891 m .55389 .65578 L .56072 .64944 L p F P
0 0 0 r
s
.83 .24 .1 r
.54174 .6639 m
.56063 .64757 L
s
.083 .024 .01 r
.31872 .49177 m .30989 .50274 L .31838 .48393 L p F P
0 0 0 r
s
.83 .24 .1 r
.31852 .48718 m
.32348 .4777 L
s
.083 .024 .01 r
.31838 .48393 m .32689 .47328 L .31872 .49177 L p F P
0 0 0 r
s
1 .331 .136 r
.40076 .39141 m .3939 .39993 L .4125 .39136 L p F P
0 0 0 r
s
1 .331 .136 r
.4125 .39136 m .41825 .38429 L .40076 .39141 L p F P
0 0 0 r
s
.194 .255 .473 r
.39509 .59738 m .37711 .59183 L .38358 .60673 L p F P
0 0 0 r
s
.194 .255 .473 r
.38358 .60673 m .40059 .61192 L .39509 .59738 L p F P
0 0 0 r
s
.24 .35 .67 r
.39308 .58549 m
.39622 .60528 L
s
.221 .299 .561 r
.35498 .56922 m .33609 .56331 L .34058 .58056 L p F P
0 0 0 r
s
.221 .299 .561 r
.34058 .58056 m .35894 .58623 L .35498 .56922 L p F P
0 0 0 r
s
.24 .35 .67 r
.35566 .57381 m
.39308 .58549 L
s
.35566 .57381 m
.35591 .55043 L
s
.585 .167 .076 r
.64206 .45656 m .65271 .44636 L .66433 .46335 L p F P
0 0 0 r
s
.585 .167 .076 r
.66433 .46335 m .65278 .47417 L .64206 .45656 L p F P
0 0 0 r
s
.83 .24 .1 r
.63592 .47093 m
.64531 .49687 L
s
.24 .35 .67 r
.7518 .44478 m
.73997 .43246 L
s
.73997 .43246 m
.70596 .41908 L
s
.723 .209 .093 r
.62773 .40903 m .63608 .40063 L .65703 .41186 L p F P
0 0 0 r
s
.723 .209 .093 r
.65703 .41186 m .64726 .42146 L .62773 .40903 L p F P
0 0 0 r
s
.24 .35 .67 r
.55962 .67536 m
.57327 .68005 L
s
.083 .024 .01 r
.33554 .46244 m .32689 .47328 L .33904 .45572 L p F P
0 0 0 r
s
.083 .024 .01 r
.33904 .45572 m .34719 .44551 L .33554 .46244 L p F P
0 0 0 r
s
.255 .392 .783 r
.52562 .35482 m .53396 .35808 L .52282 .36391 L p F P
0 0 0 r
s
.255 .392 .783 r
.52282 .36391 m .5172 .36173 L .52562 .35482 L p F P
0 0 0 r
s
.83 .24 .1 r
.50765 .35733 m
.51777 .36126 L
s
.659 .189 .085 r
.63762 .43091 m .64726 .42146 L .66353 .43599 L p F P
0 0 0 r
s
.659 .189 .085 r
.66353 .43599 m .65271 .44636 L .63762 .43091 L p F P
0 0 0 r
s
.83 .24 .1 r
.622 .44562 m
.64529 .42275 L
s
1 .324 .136 r
.46041 .35218 m .45573 .35785 L .47025 .36376 L p F P
0 0 0 r
s
.24 .35 .67 r
.4349 .34977 m
.45579 .35777 L
s
.46968 .36309 m
.47054 .36341 L
s
1 .324 .136 r
.47025 .36376 m .47344 .35997 L .46041 .35218 L p F P
0 0 0 r
s
.83 .24 .1 r
.5039 .35656 m
.50765 .35733 L
s
1 .332 .138 r
.42995 .36993 m .42407 .37715 L .44191 .37457 L p F P
0 0 0 r
s
.83 .24 .1 r
.417 .39992 m
.43645 .3763 L
s
.43645 .3763 m
.46118 .37619 L
s
1 .332 .138 r
.44191 .37457 m .44648 .36904 L .42995 .36993 L p F P
0 0 0 r
s
1 .316 .128 r
.37755 .41106 m .36986 .42067 L .38712 .40833 L p F P
0 0 0 r
s
1 .316 .128 r
.38712 .40833 m .3939 .39993 L .37755 .41106 L p F P
0 0 0 r
s
.24 .33 .624 r
.31641 .53879 m .29704 .53263 L .2977 .55129 L p F P
0 0 0 r
s
.83 .24 .1 r
.29043 .54284 m
.29711 .53465 L
s
.24 .33 .624 r
.2977 .55129 m .317 .55733 L .31641 .53879 L p F P
0 0 0 r
s
.216 .343 .692 r
.58754 .37248 m .59811 .37664 L .57505 .37417 L p F P
0 0 0 r
s
.216 .343 .692 r
.57505 .37417 m .56691 .37098 L .58754 .37248 L p F P
0 0 0 r
s
.918 .277 .11 r
.35547 .43512 m .34719 .44551 L .36229 .43014 L p F P
0 0 0 r
s
.83 .24 .1 r
.34129 .45541 m
.35664 .43953 L
s
.918 .277 .11 r
.36229 .43014 m .36986 .42067 L .35547 .43512 L p F P
0 0 0 r
s
.083 .024 .01 r
.58583 .62252 m .59602 .61367 L .58826 .62567 L p F P
0 0 0 r
s
.083 .024 .01 r
.58826 .62567 m .57894 .63371 L .58583 .62252 L p F P
0 0 0 r
s
.83 .24 .1 r
.57285 .6292 m
.59515 .60977 L
s
.079 .091 .174 r
.53825 .66927 m .52542 .66541 L .5215 .66664 L p F P
0 0 0 r
s
.079 .091 .174 r
.5215 .66664 m .53238 .6699 L .53825 .66927 L p F P
0 0 0 r
s
.944 .288 .117 r
.53825 .66927 m .54602 .66257 L .53891 .66424 L p F P
0 0 0 r
s
.944 .288 .117 r
.53891 .66424 m .53238 .6699 L .53825 .66927 L p F P
0 0 0 r
s
.24 .35 .67 r
.53864 .66905 m
.55962 .67536 L
s
.53748 .6687 m
.53864 .66905 L
s
.83 .24 .1 r
.52195 .68048 m
.53444 .66968 L
s
.38223 .72047 m
.40133 .70243 L
s
.38223 .72047 m
.35557 .70747 L
s
.112 .127 .241 r
.48459 .64704 m .46966 .64252 L .4731 .64969 L p F P
0 0 0 r
s
.24 .35 .67 r
.46979 .62783 m
.47695 .64326 L
s
.112 .127 .241 r
.4731 .64969 m .48633 .65367 L .48459 .64704 L p F P
0 0 0 r
s
.24 .35 .67 r
.47695 .64326 m
.51312 .6542 L
s
.153 .191 .345 r
.43413 .62215 m .41744 .61706 L .4241 .62875 L p F P
0 0 0 r
s
.153 .191 .345 r
.4241 .62875 m .43942 .63338 L .43413 .62215 L p F P
0 0 0 r
s
.24 .35 .67 r
.28348 .49986 m
.24456 .48718 L
s
.28348 .49986 m
.27965 .52614 L
s
.83 .24 .1 r
.45551 .71193 m
.47599 .69373 L
s
.45551 .71193 m
.42888 .71013 L
s
.255 .392 .783 r
.51724 .35153 m .52562 .35482 L .5172 .36173 L p F P
0 0 0 r
s
.255 .392 .783 r
.5172 .36173 m .51156 .35954 L .51724 .35153 L p F P
0 0 0 r
s
.24 .35 .67 r
.26972 .40104 m
.25955 .42993 L
s
.25955 .42993 m
.22036 .41649 L
s
.25955 .42993 m
.25106 .45896 L
s
.28123 .37326 m
.26972 .40104 L
s
.26972 .40104 m
.23062 .3873 L
s
.69504 .71052 m
.66045 .70007 L
s
.69504 .71052 m
.71334 .70319 L
s
1 .324 .136 r
.46514 .34646 m .46041 .35218 L .47344 .35997 L p F P
0 0 0 r
s
1 .324 .136 r
.47344 .35997 m .47664 .35616 L .46514 .34646 L p F P
0 0 0 r
s
.24 .35 .67 r
.34553 .33929 m
.33219 .36168 L
s
.33219 .36168 m
.29372 .3475 L
s
.216 .343 .692 r
.5769 .36829 m .58754 .37248 L .56691 .37098 L p F P
0 0 0 r
s
.24 .35 .67 r
.55818 .37904 m
.57322 .37239 L
s
.57322 .37239 m
.60147 .38346 L
s
.216 .343 .692 r
.56691 .37098 m .55873 .36778 L .5769 .36829 L p F P
0 0 0 r
s
.24 .35 .67 r
.39742 .33542 m
.38346 .35355 L
s
.38346 .35355 m
.34553 .33929 L
s
.255 .392 .783 r
.50882 .34824 m .51724 .35153 L .51156 .35954 L p F P
0 0 0 r
s
.83 .24 .1 r
.50765 .35733 m
.51029 .35429 L
s
.255 .392 .783 r
.51156 .35954 m .50591 .35734 L .50882 .34824 L p F P
0 0 0 r
s
.83 .24 .1 r
.58137 .35808 m
.60544 .3768 L
s
.61161 .38304 m
.627 .39861 L
s
.60544 .3768 m
.60984 .38125 L
s
.156 .259 .536 r
.63195 .38715 m .64453 .39212 L .61907 .38488 L p F P
0 0 0 r
s
.83 .24 .1 r
.627 .39861 m
.63595 .38953 L
s
.156 .259 .536 r
.61907 .38488 m .60862 .38077 L .63195 .38715 L p F P
0 0 0 r
s
.194 .255 .473 r
.37711 .59183 m .35894 .58623 L .3664 .60149 L p F P
0 0 0 r
s
.194 .255 .473 r
.3664 .60149 m .38358 .60673 L .37711 .59183 L p F P
0 0 0 r
s
.83 .24 .1 r
.30936 .66741 m
.29222 .64242 L
s
.29222 .64242 m
.30972 .62287 L
s
1 .331 .136 r
.40771 .38278 m .40076 .39141 L .41825 .38429 L p F P
0 0 0 r
s
1 .331 .136 r
.41825 .38429 m .42407 .37715 L .40771 .38278 L p F P
0 0 0 r
s
.221 .299 .561 r
.33609 .56331 m .317 .55733 L .32204 .57484 L p F P
0 0 0 r
s
.221 .299 .561 r
.32204 .57484 m .34058 .58056 L .33609 .56331 L p F P
0 0 0 r
s
1 .332 .138 r
.43589 .36264 m .42995 .36993 L .44648 .36904 L p F P
0 0 0 r
s
.24 .35 .67 r
.42059 .36752 m
.4349 .34977 L
s
1 .332 .138 r
.44648 .36904 m .45109 .36347 L .43589 .36264 L p F P
0 0 0 r
s
.079 .091 .174 r
.52542 .66541 m .51249 .66153 L .51056 .66335 L p F P
0 0 0 r
s
.079 .091 .174 r
.51056 .66335 m .5215 .66664 L .52542 .66541 L p F P
0 0 0 r
s
.24 .35 .67 r
.51312 .6542 m
.52369 .66456 L
s
.52369 .66456 m
.53471 .66787 L
s
.255 .392 .783 r
.50035 .34492 m .50882 .34824 L .50591 .35734 L p F P
0 0 0 r
s
.255 .392 .783 r
.50591 .35734 m .50024 .35514 L .50035 .34492 L p F P
0 0 0 r
s
.24 .35 .67 r
.25106 .45896 m
.21165 .44579 L
s
.25106 .45896 m
.24456 .48718 L
s
.161 .046 .023 r
.62698 .56257 m .63873 .55216 L .63489 .56989 L p F P
0 0 0 r
s
.161 .046 .023 r
.63489 .56989 m .6235 .57985 L .62698 .56257 L p F P
0 0 0 r
s
.83 .24 .1 r
.62494 .56781 m
.62616 .5437 L
s
.273 .073 .037 r
.63917 .53352 m .65118 .52271 L .65069 .54156 L p F P
0 0 0 r
s
.273 .073 .037 r
.65069 .54156 m .63873 .55216 L .63917 .53352 L p F P
0 0 0 r
s
.112 .127 .241 r
.46966 .64252 m .45461 .63797 L .45977 .64568 L p F P
0 0 0 r
s
.112 .127 .241 r
.45977 .64568 m .4731 .64969 L .46966 .64252 L p F P
0 0 0 r
s
.216 .343 .692 r
.56619 .36407 m .5769 .36829 L .55873 .36778 L p F P
0 0 0 r
s
.83 .24 .1 r
.57328 .36687 m
.58137 .35808 L
s
.216 .343 .692 r
.55873 .36778 m .55051 .36456 L .56619 .36407 L p F P
0 0 0 r
s
.83 .24 .1 r
.55561 .34314 m
.58137 .35808 L
s
.58137 .35808 m
.60429 .33319 L
s
1 .324 .136 r
.4699 .3407 m .46514 .34646 L .47664 .35616 L p F P
0 0 0 r
s
1 .324 .136 r
.47664 .35616 m .47986 .35233 L .4699 .3407 L p F P
0 0 0 r
s
.153 .191 .345 r
.41744 .61706 m .40059 .61192 L .40864 .62408 L p F P
0 0 0 r
s
.24 .35 .67 r
.39622 .60528 m
.43339 .61668 L
s
.153 .191 .345 r
.40864 .62408 m .4241 .62875 L .41744 .61706 L p F P
0 0 0 r
s
.24 .35 .67 r
.79476 .47606 m
.78553 .45797 L
s
.78553 .45797 m
.7518 .44478 L
s
.391 .108 .052 r
.64804 .50364 m .65998 .49268 L .66341 .51169 L p F P
0 0 0 r
s
.391 .108 .052 r
.66341 .51169 m .65118 .52271 L .64804 .50364 L p F P
0 0 0 r
s
.83 .24 .1 r
.64531 .49687 m
.64969 .52248 L
s
.212 .061 .032 r
.30649 .54067 m .2977 .55129 L .29704 .53263 L p F P
0 0 0 r
s
.212 .061 .032 r
.29704 .53263 m .30586 .5218 L .30649 .54067 L p F P
0 0 0 r
s
.24 .35 .67 r
.30629 .53463 m
.31818 .53841 L
s
.27965 .52614 m
.29766 .53188 L
s
.4349 .34977 m
.39742 .33542 L
s
.83 .24 .1 r
.35557 .70747 m
.37428 .6891 L
s
.35557 .70747 m
.33084 .68948 L
s
.24 .35 .67 r
.29372 .3475 m
.28123 .37326 L
s
.28123 .37326 m
.2421 .35916 L
s
.083 .024 .01 r
.56976 .64163 m .57894 .63371 L .56994 .64194 L p F P
0 0 0 r
s
.083 .024 .01 r
.56994 .64194 m .56186 .64891 L .56976 .64163 L p F P
0 0 0 r
s
.084 .024 .01 r
.61232 .58964 m .6235 .57985 L .61693 .59554 L p F P
0 0 0 r
s
.83 .24 .1 r
.60199 .58809 m
.62494 .56781 L
s
.084 .024 .01 r
.61693 .59554 m .60639 .60468 L .61232 .58964 L p F P
0 0 0 r
s
.723 .209 .093 r
.63608 .40063 m .64453 .39212 L .66696 .40212 L p F P
0 0 0 r
s
.723 .209 .093 r
.66696 .40212 m .65703 .41186 L .63608 .40063 L p F P
0 0 0 r
s
.83 .24 .1 r
.627 .39861 m
.64529 .42275 L
s
.255 .392 .783 r
.49185 .34159 m .50035 .34492 L .50024 .35514 L p F P
0 0 0 r
s
.255 .392 .783 r
.50024 .35514 m .49454 .35293 L .49185 .34159 L p F P
0 0 0 r
s
.143 .041 .02 r
.31484 .51077 m .30586 .5218 L .30989 .50274 L p F P
0 0 0 r
s
.143 .041 .02 r
.30989 .50274 m .31872 .49177 L .31484 .51077 L p F P
0 0 0 r
s
.497 .14 .065 r
.65278 .47417 m .66433 .46335 L .67215 .48152 L p F P
0 0 0 r
s
.497 .14 .065 r
.67215 .48152 m .65998 .49268 L .65278 .47417 L p F P
0 0 0 r
s
1 .316 .128 r
.38535 .4013 m .37755 .41106 L .3939 .39993 L p F P
0 0 0 r
s
1 .316 .128 r
.3939 .39993 m .40076 .39141 L .38535 .4013 L p F P
0 0 0 r
s
.24 .35 .67 r
.60893 .69076 m
.57327 .68005 L
s
.60893 .69076 m
.62512 .68938 L
s
.156 .259 .536 r
.61926 .38215 m .63195 .38715 L .60862 .38077 L p F P
0 0 0 r
s
.24 .35 .67 r
.61259 .38608 m
.62297 .38573 L
s
.156 .259 .536 r
.60862 .38077 m .59811 .37664 L .61926 .38215 L p F P
0 0 0 r
s
.944 .288 .117 r
.54602 .66257 m .55389 .65578 L .54551 .65851 L p F P
0 0 0 r
s
.83 .24 .1 r
.54876 .65745 m
.56063 .64757 L
s
.944 .288 .117 r
.54551 .65851 m .53891 .66424 L .54602 .66257 L p F P
0 0 0 r
s
.585 .167 .076 r
.65271 .44636 m .66353 .43599 L .67609 .45233 L p F P
0 0 0 r
s
.585 .167 .076 r
.67609 .45233 m .66433 .46335 L .65271 .44636 L p F P
0 0 0 r
s
.83 .24 .1 r
.63592 .47093 m
.65961 .44838 L
s
.659 .189 .085 r
.64726 .42146 m .65703 .41186 L .67453 .42545 L p F P
0 0 0 r
s
.659 .189 .085 r
.67453 .42545 m .66353 .43599 L .64726 .42146 L p F P
0 0 0 r
s
.83 .24 .1 r
.64529 .42275 m
.65961 .44838 L
s
.083 .024 .01 r
.32772 .48059 m .31872 .49177 L .32689 .47328 L p F P
0 0 0 r
s
.083 .024 .01 r
.32689 .47328 m .33554 .46244 L .32772 .48059 L p F P
0 0 0 r
s
.83 .24 .1 r
.33539 .4628 m
.34129 .45541 L
s
.33084 .68948 m
.30936 .66741 L
s
.30936 .66741 m
.32723 .64825 L
s
.29745 .5959 m
.29096 .56878 L
s
.24 .35 .67 r
.74754 .71367 m
.71334 .70319 L
s
.74754 .71367 m
.76652 .70035 L
s
.216 .343 .692 r
.55541 .35983 m .56619 .36407 L .55051 .36456 L p F P
0 0 0 r
s
.216 .343 .692 r
.55051 .36456 m .54226 .36133 L .55541 .35983 L p F P
0 0 0 r
s
.83 .24 .1 r
.50065 .68986 m
.52212 .67112 L
s
.50065 .68986 m
.47599 .69373 L
s
.918 .277 .11 r
.36389 .42456 m .35547 .43512 L .36986 .42067 L p F P
0 0 0 r
s
.918 .277 .11 r
.36986 .42067 m .37755 .41106 L .36389 .42456 L p F P
0 0 0 r
s
.83 .24 .1 r
.35664 .43953 m
.37514 .41644 L
s
.37514 .41644 m
.39454 .40557 L
s
.083 .024 .01 r
.34436 .45141 m .33554 .46244 L .34719 .44551 L p F P
0 0 0 r
s
.083 .024 .01 r
.34719 .44551 m .35547 .43512 L .34436 .45141 L p F P
0 0 0 r
s
.255 .392 .783 r
.4833 .33825 m .49185 .34159 L .49454 .35293 L p F P
0 0 0 r
s
.255 .392 .783 r
.49454 .35293 m .48883 .35071 L .4833 .33825 L p F P
0 0 0 r
s
.24 .35 .67 r
.48626 .35113 m
.5226 .36523 L
s
.079 .091 .174 r
.51249 .66153 m .49946 .65761 L .49954 .66005 L p F P
0 0 0 r
s
.079 .091 .174 r
.49954 .66005 m .51056 .66335 L .51249 .66153 L p F P
0 0 0 r
s
.83 .24 .1 r
.33084 .68948 m
.34913 .67073 L
s
1 .324 .136 r
.47471 .33488 m .4699 .3407 L .47986 .35233 L p F P
0 0 0 r
s
1 .324 .136 r
.47986 .35233 m .4831 .34848 L .47471 .33488 L p F P
0 0 0 r
s
.83 .24 .1 r
.46118 .37619 m
.48157 .35198 L
s
.48157 .35198 m
.4912 .35395 L
s
.24 .35 .67 r
.48083 .35583 m
.48626 .35113 L
s
1 .332 .138 r
.4419 .35525 m .43589 .36264 L .45109 .36347 L p F P
0 0 0 r
s
1 .332 .138 r
.45109 .36347 m .45573 .35785 L .4419 .35525 L p F P
0 0 0 r
s
.083 .024 .01 r
.59602 .61367 m .60639 .60468 L .59772 .6175 L p F P
0 0 0 r
s
.083 .024 .01 r
.59772 .6175 m .58826 .62567 L .59602 .61367 L p F P
0 0 0 r
s
.194 .255 .473 r
.35894 .58623 m .34058 .58056 L .34906 .5962 L p F P
0 0 0 r
s
.194 .255 .473 r
.34906 .5962 m .3664 .60149 L .35894 .58623 L p F P
0 0 0 r
s
.24 .35 .67 r
.35566 .57381 m
.35825 .59364 L
s
.112 .127 .241 r
.45461 .63797 m .43942 .63338 L .44633 .64165 L p F P
0 0 0 r
s
.112 .127 .241 r
.44633 .64165 m .45977 .64568 L .45461 .63797 L p F P
0 0 0 r
s
.221 .299 .561 r
.317 .55733 m .2977 .55129 L .3033 .56905 L p F P
0 0 0 r
s
.221 .299 .561 r
.3033 .56905 m .32204 .57484 L .317 .55733 L p F P
0 0 0 r
s
.24 .35 .67 r
.31743 .56189 m
.35566 .57381 L
s
.31743 .56189 m
.31818 .53841 L
s
.255 .392 .783 r
.47471 .33488 m .4833 .33825 L .48883 .35071 L p F P
0 0 0 r
s
.255 .392 .783 r
.48883 .35071 m .4831 .34848 L .47471 .33488 L p F P
0 0 0 r
s
1 .331 .136 r
.41476 .37403 m .40771 .38278 L .42407 .37715 L p F P
0 0 0 r
s
1 .331 .136 r
.42407 .37715 m .42995 .36993 L .41476 .37403 L p F P
0 0 0 r
s
.83 .24 .1 r
.41383 .38174 m
.43645 .3763 L
s
.24 .35 .67 r
.71735 .4313 m
.70596 .41908 L
s
.83 .24 .1 r
.48157 .35198 m
.48519 .34768 L
s
.156 .259 .536 r
.60648 .37711 m .61926 .38215 L .59811 .37664 L p F P
0 0 0 r
s
.156 .259 .536 r
.59811 .37664 m .58754 .37248 L .60648 .37711 L p F P
0 0 0 r
s
.216 .343 .692 r
.54456 .35556 m .55541 .35983 L .54226 .36133 L p F P
0 0 0 r
s
.216 .343 .692 r
.54226 .36133 m .53396 .35808 L .54456 .35556 L p F P
0 0 0 r
s
.83 .24 .1 r
.54453 .35557 m
.55561 .34314 L
s
.24 .35 .67 r
.5226 .36523 m
.53719 .35827 L
s
.83415 .51203 m
.82818 .48898 L
s
.82818 .48898 m
.79476 .47606 L
s
.153 .191 .345 r
.40059 .61192 m .38358 .60673 L .39305 .61936 L p F P
0 0 0 r
s
.153 .191 .345 r
.39305 .61936 m .40864 .62408 L .40059 .61192 L p F P
0 0 0 r
s
.83 .24 .1 r
.52908 .33257 m
.55561 .34314 L
s
.55561 .34314 m
.57817 .31784 L
s
.24 .35 .67 r
.47987 .34865 m
.48626 .35113 L
s
.83 .24 .1 r
.42888 .71013 m
.44907 .69171 L
s
.42888 .71013 m
.40133 .70243 L
s
.24 .35 .67 r
.27965 .52614 m
.24029 .51361 L
s
.27965 .52614 m
.27838 .54971 L
s
.24456 .48718 m
.2048 .47422 L
s
.24456 .48718 m
.24029 .51361 L
s
.079 .091 .174 r
.49946 .65761 m .48633 .65367 L .48846 .65673 L p F P
0 0 0 r
s
.079 .091 .174 r
.48846 .65673 m .49954 .66005 L .49946 .65761 L p F P
0 0 0 r
s
.24 .35 .67 r
.23062 .3873 m
.22036 .41649 L
s
.22036 .41649 m
.18033 .40277 L
s
.22036 .41649 m
.21165 .44579 L
s
.2421 .35916 m
.23062 .3873 L
s
.23062 .3873 m
.19069 .37325 L
s
.216 .343 .692 r
.53364 .35127 m .54456 .35556 L .53396 .35808 L p F P
0 0 0 r
s
.216 .343 .692 r
.53396 .35808 m .52562 .35482 L .53364 .35127 L p F P
0 0 0 r
s
1 .332 .138 r
.44798 .34779 m .4419 .35525 L .45573 .35785 L p F P
0 0 0 r
s
1 .332 .138 r
.45573 .35785 m .46041 .35218 L .44798 .34779 L p F P
0 0 0 r
s
.073 .085 .164 r
.65251 .39642 m .66696 .40212 L .64453 .39212 L p F P
0 0 0 r
s
.073 .085 .164 r
.64453 .39212 m .63195 .38715 L .65251 .39642 L p F P
0 0 0 r
s
.24 .35 .67 r
.62297 .38573 m
.63641 .39102 L
s
.83 .24 .1 r
.63651 .38896 m
.63671 .38876 L
s
.24 .35 .67 r
.66045 .70007 m
.62512 .68938 L
s
.66045 .70007 m
.6784 .69249 L
s
.156 .259 .536 r
.5936 .37203 m .60648 .37711 L .58754 .37248 L p F P
0 0 0 r
s
.83 .24 .1 r
.60551 .37673 m
.62876 .35232 L
s
.156 .259 .536 r
.58754 .37248 m .5769 .36829 L .5936 .37203 L p F P
0 0 0 r
s
1 .316 .128 r
.39327 .3914 m .38535 .4013 L .40076 .39141 L p F P
0 0 0 r
s
1 .316 .128 r
.40076 .39141 m .40771 .38278 L .39327 .3914 L p F P
0 0 0 r
s
.83 .24 .1 r
.39454 .40557 m
.41383 .38174 L
s
.24 .35 .67 r
.30679 .32471 m
.29372 .3475 L
s
.29372 .3475 m
.25443 .33302 L
s
.083 .024 .01 r
.57894 .63371 m .58826 .62567 L .57813 .63487 L p F P
0 0 0 r
s
.83 .24 .1 r
.58302 .62821 m
.59515 .60977 L
s
.083 .024 .01 r
.57813 .63487 m .56994 .64194 L .57894 .63371 L p F P
0 0 0 r
s
.83 .24 .1 r
.56063 .64757 m
.58302 .62821 L
s
.24 .35 .67 r
.35912 .32076 m
.34553 .33929 L
s
.34553 .33929 m
.30679 .32471 L
s
.944 .288 .117 r
.55389 .65578 m .56186 .64891 L .55219 .65272 L p F P
0 0 0 r
s
.944 .288 .117 r
.55219 .65272 m .54551 .65851 L .55389 .65578 L p F P
0 0 0 r
s
.112 .127 .241 r
.43942 .63338 m .4241 .62875 L .43279 .63758 L p F P
0 0 0 r
s
.24 .35 .67 r
.43339 .61668 m
.44001 .63207 L
s
.112 .127 .241 r
.43279 .63758 m .44633 .64165 L .43942 .63338 L p F P
0 0 0 r
s
.24 .35 .67 r
.44001 .63207 m
.47695 .64326 L
s
.161 .046 .023 r
.63873 .55216 m .65069 .54156 L .64648 .55974 L p F P
0 0 0 r
s
.83 .24 .1 r
.62616 .5437 m
.64969 .52248 L
s
.161 .046 .023 r
.64648 .55974 m .63489 .56989 L .63873 .55216 L p F P
0 0 0 r
s
.273 .073 .037 r
.65118 .52271 m .66341 .51169 L .66287 .53076 L p F P
0 0 0 r
s
.273 .073 .037 r
.66287 .53076 m .65069 .54156 L .65118 .52271 L p F P
0 0 0 r
s
.194 .255 .473 r
.34058 .58056 m .32204 .57484 L .33155 .59086 L p F P
0 0 0 r
s
.194 .255 .473 r
.33155 .59086 m .34906 .5962 L .34058 .58056 L p F P
0 0 0 r
s
.659 .189 .085 r
.65703 .41186 m .66696 .40212 L .68572 .41472 L p F P
0 0 0 r
s
.659 .189 .085 r
.68572 .41472 m .67453 .42545 L .65703 .41186 L p F P
0 0 0 r
s
.24 .35 .67 r
.67278 .40602 m
.70596 .41908 L
s
.391 .108 .052 r
.65998 .49268 m .67215 .48152 L .67587 .50047 L p F P
0 0 0 r
s
.391 .108 .052 r
.67587 .50047 m .66341 .51169 L .65998 .49268 L p F P
0 0 0 r
s
.34 .095 .048 r
.3119 .55889 m .3033 .56905 L .2977 .55129 L p F P
0 0 0 r
s
.24 .35 .67 r
.31104 .5599 m
.31743 .56189 L
s
.34 .095 .048 r
.2977 .55129 m .30649 .54067 L .3119 .55889 L p F P
0 0 0 r
s
.83 .24 .1 r
.29096 .56878 m
.29986 .55813 L
s
.24 .35 .67 r
.27838 .54971 m
.29886 .5561 L
s
.29886 .5561 m
.29996 .55645 L
s
.084 .024 .01 r
.6235 .57985 m .63489 .56989 L .62765 .58624 L p F P
0 0 0 r
s
.084 .024 .01 r
.62765 .58624 m .61693 .59554 L .6235 .57985 L p F P
0 0 0 r
s
.83 .24 .1 r
.61828 .58962 m
.62494 .56781 L
s
.216 .343 .692 r
.52265 .34694 m .53364 .35127 L .52562 .35482 L p F P
0 0 0 r
s
.216 .343 .692 r
.52562 .35482 m .51724 .35153 L .52265 .34694 L p F P
0 0 0 r
s
.212 .061 .032 r
.31545 .52985 m .30649 .54067 L .30586 .5218 L p F P
0 0 0 r
s
.212 .061 .032 r
.30586 .5218 m .31484 .51077 L .31545 .52985 L p F P
0 0 0 r
s
.153 .191 .345 r
.38358 .60673 m .3664 .60149 L .37732 .61461 L p F P
0 0 0 r
s
.24 .35 .67 r
.35825 .59364 m
.39622 .60528 L
s
.153 .191 .345 r
.37732 .61461 m .39305 .61936 L .38358 .60673 L p F P
0 0 0 r
s
1 .331 .136 r
.4219 .36516 m .41476 .37403 L .42995 .36993 L p F P
0 0 0 r
s
1 .331 .136 r
.42995 .36993 m .43589 .36264 L .4219 .36516 L p F P
0 0 0 r
s
.24 .35 .67 r
.21165 .44579 m
.17139 .43234 L
s
.21165 .44579 m
.2048 .47422 L
s
.497 .14 .065 r
.66433 .46335 m .67609 .45233 L .68455 .47015 L p F P
0 0 0 r
s
.497 .14 .065 r
.68455 .47015 m .67215 .48152 L .66433 .46335 L p F P
0 0 0 r
s
.83 .24 .1 r
.64531 .49687 m
.66938 .47461 L
s
.918 .277 .11 r
.37245 .41382 m .36389 .42456 L .37755 .41106 L p F P
0 0 0 r
s
.918 .277 .11 r
.37755 .41106 m .38535 .4013 L .37245 .41382 L p F P
0 0 0 r
s
.585 .167 .076 r
.66353 .43599 m .67453 .42545 L .68806 .44112 L p F P
0 0 0 r
s
.585 .167 .076 r
.68806 .44112 m .67609 .45233 L .66353 .43599 L p F P
0 0 0 r
s
.83 .24 .1 r
.65961 .44838 m
.66938 .47461 L
s
.143 .041 .02 r
.32399 .49953 m .31484 .51077 L .31872 .49177 L p F P
0 0 0 r
s
.143 .041 .02 r
.31872 .49177 m .32772 .48059 L .32399 .49953 L p F P
0 0 0 r
s
.079 .091 .174 r
.48633 .65367 m .4731 .64969 L .4773 .65338 L p F P
0 0 0 r
s
.079 .091 .174 r
.4773 .65338 m .48846 .65673 L .48633 .65367 L p F P
0 0 0 r
s
.083 .024 .01 r
.33688 .46919 m .32772 .48059 L .33554 .46244 L p F P
0 0 0 r
s
.83 .24 .1 r
.33612 .46537 m
.34129 .45541 L
s
.083 .024 .01 r
.33554 .46244 m .34436 .45141 L .33688 .46919 L p F P
0 0 0 r
s
.24 .35 .67 r
.7606 .46286 m
.7518 .44478 L
s
.7518 .44478 m
.71735 .4313 L
s
.083 .024 .01 r
.35333 .44018 m .34436 .45141 L .35547 .43512 L p F P
0 0 0 r
s
.083 .024 .01 r
.35547 .43512 m .36389 .42456 L .35333 .44018 L p F P
0 0 0 r
s
.83 .24 .1 r
.30972 .62287 m
.29745 .5959 L
s
.24 .35 .67 r
.41122 .322 m
.39742 .33542 L
s
.39742 .33542 m
.35912 .32076 L
s
.156 .259 .536 r
.58062 .36691 m .5936 .37203 L .5769 .36829 L p F P
0 0 0 r
s
.24 .35 .67 r
.57322 .37239 m
.58721 .37165 L
s
.156 .259 .536 r
.5769 .36829 m .56619 .36407 L .58062 .36691 L p F P
0 0 0 r
s
.24 .35 .67 r
.53719 .35827 m
.57322 .37239 L
s
.25443 .33302 m
.2421 .35916 L
s
.2421 .35916 m
.20212 .34475 L
s
.073 .085 .164 r
.63793 .39068 m .65251 .39642 L .63195 .38715 L p F P
0 0 0 r
s
.073 .085 .164 r
.63195 .38715 m .61926 .38215 L .63793 .39068 L p F P
0 0 0 r
s
1 .332 .138 r
.45413 .34025 m .44798 .34779 L .46041 .35218 L p F P
0 0 0 r
s
.24 .35 .67 r
.4349 .34977 m
.44915 .33672 L
s
1 .332 .138 r
.46041 .35218 m .46514 .34646 L .45413 .34025 L p F P
0 0 0 r
s
.83 .24 .1 r
.45662 .3518 m
.48157 .35198 L
s
.083 .024 .01 r
.60639 .60468 m .61693 .59554 L .60733 .60921 L p F P
0 0 0 r
s
.083 .024 .01 r
.60733 .60921 m .59772 .6175 L .60639 .60468 L p F P
0 0 0 r
s
.83 .24 .1 r
.59515 .60977 m
.61828 .58962 L
s
.216 .343 .692 r
.51159 .34259 m .52265 .34694 L .51724 .35153 L p F P
0 0 0 r
s
.83 .24 .1 r
.51383 .3502 m
.51531 .34848 L
s
.51817 .34518 m
.52908 .33257 L
s
.216 .343 .692 r
.51724 .35153 m .50882 .34824 L .51159 .34259 L p F P
0 0 0 r
s
.24 .35 .67 r
.57327 .68005 m
.58901 .67847 L
s
.112 .127 .241 r
.4241 .62875 m .40864 .62408 L .41915 .63348 L p F P
0 0 0 r
s
.112 .127 .241 r
.41915 .63348 m .43279 .63758 L .4241 .62875 L p F P
0 0 0 r
s
.24 .35 .67 r
.71334 .70319 m
.6784 .69249 L
s
.71334 .70319 m
.73206 .68959 L
s
.83 .24 .1 r
.50272 .32686 m
.52908 .33257 L
s
.52908 .33257 m
.55131 .30686 L
s
.15 .249 .511 r
.53238 .6699 m .5215 .66664 L .51691 .66377 L p F P
0 0 0 r
s
.15 .249 .511 r
.51691 .66377 m .52548 .66634 L .53238 .6699 L p F P
0 0 0 r
s
.24 .35 .67 r
.48699 .65352 m
.52369 .66456 L
s
1 .315 .13 r
.53238 .6699 m .53891 .66424 L .53058 .66188 L p F P
0 0 0 r
s
.83 .24 .1 r
.53834 .66407 m
.53986 .66341 L
s
.24 .35 .67 r
.53303 .66778 m
.53361 .66798 L
s
.53684 .6691 m
.57327 .68005 L
s
.53361 .66798 m
.53684 .6691 L
s
1 .315 .13 r
.53058 .66188 m .52548 .66634 L .53238 .6699 L p F P
0 0 0 r
s
.24 .35 .67 r
.52369 .66456 m
.52644 .66551 L
s
.83 .24 .1 r
.52212 .67112 m
.52736 .66884 L
s
.52736 .66884 m
.5283 .66843 L
s
.40133 .70243 m
.42116 .68372 L
s
.40133 .70243 m
.37428 .6891 L
s
.194 .255 .473 r
.32204 .57484 m .3033 .56905 L .31387 .58547 L p F P
0 0 0 r
s
.194 .255 .473 r
.31387 .58547 m .33155 .59086 L .32204 .57484 L p F P
0 0 0 r
s
.079 .091 .174 r
.4731 .64969 m .45977 .64568 L .46607 .65002 L p F P
0 0 0 r
s
.079 .091 .174 r
.46607 .65002 m .4773 .65338 L .4731 .64969 L p F P
0 0 0 r
s
.24 .35 .67 r
.47695 .64326 m
.48699 .65352 L
s
.156 .259 .536 r
.56754 .36175 m .58062 .36691 L .56619 .36407 L p F P
0 0 0 r
s
.156 .259 .536 r
.56619 .36407 m .55541 .35983 L .56754 .36175 L p F P
0 0 0 r
s
.83 .24 .1 r
.47599 .69373 m
.49725 .67484 L
s
.47599 .69373 m
.44907 .69171 L
s
.216 .343 .692 r
.50046 .33821 m .51159 .34259 L .50882 .34824 L p F P
0 0 0 r
s
.216 .343 .692 r
.50882 .34824 m .50035 .34492 L .50046 .33821 L p F P
0 0 0 r
s
1 .316 .128 r
.40132 .38134 m .39327 .3914 L .40771 .38278 L p F P
0 0 0 r
s
1 .316 .128 r
.40771 .38278 m .41476 .37403 L .40132 .38134 L p F P
0 0 0 r
s
.153 .191 .345 r
.3664 .60149 m .34906 .5962 L .36145 .60981 L p F P
0 0 0 r
s
.153 .191 .345 r
.36145 .60981 m .37732 .61461 L .3664 .60149 L p F P
0 0 0 r
s
.944 .288 .117 r
.56186 .64891 m .56994 .64194 L .55895 .64687 L p F P
0 0 0 r
s
.944 .288 .117 r
.55895 .64687 m .55219 .65272 L .56186 .64891 L p F P
0 0 0 r
s
.073 .085 .164 r
.62322 .38488 m .63793 .39068 L .61926 .38215 L p F P
0 0 0 r
s
.83 .24 .1 r
.63671 .38876 m
.65073 .37452 L
s
.073 .085 .164 r
.61926 .38215 m .60648 .37711 L .62322 .38488 L p F P
0 0 0 r
s
1 .331 .136 r
.42913 .35618 m .4219 .36516 L .43589 .36264 L p F P
0 0 0 r
s
1 .331 .136 r
.43589 .36264 m .4419 .35525 L .42913 .35618 L p F P
0 0 0 r
s
.83 .24 .1 r
.43645 .3763 m
.45662 .3518 L
s
.24 .35 .67 r
.80034 .49919 m
.79476 .47606 L
s
.79476 .47606 m
.7606 .46286 L
s
.083 .024 .01 r
.58826 .62567 m .59772 .6175 L .58642 .62771 L p F P
0 0 0 r
s
.083 .024 .01 r
.58642 .62771 m .57813 .63487 L .58826 .62567 L p F P
0 0 0 r
s
.24 .35 .67 r
.76652 .70035 m
.73206 .68959 L
s
.76652 .70035 m
.78489 .68126 L
s
1 .332 .138 r
.46034 .33261 m .45413 .34025 L .46514 .34646 L p F P
0 0 0 r
s
.24 .35 .67 r
.44915 .33672 m
.45512 .33903 L
s
.46372 .34238 m
.46735 .34378 L
s
1 .332 .138 r
.46514 .34646 m .4699 .3407 L .46034 .33261 L p F P
0 0 0 r
s
.24 .35 .67 r
.44915 .33672 m
.41122 .322 L
s
.83 .24 .1 r
.60429 .33319 m
.62876 .35232 L
s
.62876 .35232 m
.65295 .32691 L
s
.62876 .35232 m
.65073 .37452 L
s
.15 .249 .511 r
.5215 .66664 m .51056 .66335 L .5083 .66119 L p F P
0 0 0 r
s
.15 .249 .511 r
.5083 .66119 m .51691 .66377 L .5215 .66664 L p F P
0 0 0 r
s
.24 .35 .67 r
.24029 .51361 m
.20007 .50081 L
s
.24029 .51361 m
.23848 .53727 L
s
.83 .24 .1 r
.65073 .37452 m
.67536 .34952 L
s
.216 .343 .692 r
.48926 .3338 m .50046 .33821 L .50035 .34492 L p F P
0 0 0 r
s
.83 .24 .1 r
.49069 .34114 m
.49339 .33794 L
s
.216 .343 .692 r
.50035 .34492 m .49185 .34159 L .48926 .3338 L p F P
0 0 0 r
s
.83 .24 .1 r
.49498 .33605 m
.50272 .32686 L
s
.24 .35 .67 r
.48626 .35113 m
.50039 .34385 L
s
.109 .123 .235 r
.66973 .40845 m .68572 .41472 L .66696 .40212 L p F P
0 0 0 r
s
.109 .123 .235 r
.66696 .40212 m .65251 .39642 L .66973 .40845 L p F P
0 0 0 r
s
.83 .24 .1 r
.65073 .37452 m
.66944 .39903 L
s
.66632 .40209 m
.66644 .40197 L
s
.64529 .42275 m
.66396 .40441 L
s
.66644 .40197 m
.66944 .39903 L
s
.24 .35 .67 r
.2048 .47422 m
.16417 .46098 L
s
.2048 .47422 m
.20007 .50081 L
s
.112 .127 .241 r
.40864 .62408 m .39305 .61936 L .40539 .62934 L p F P
0 0 0 r
s
.24 .35 .67 r
.39622 .60528 m
.40228 .62065 L
s
.112 .127 .241 r
.40539 .62934 m .41915 .63348 L .40864 .62408 L p F P
0 0 0 r
s
.24 .35 .67 r
.40228 .62065 m
.44001 .63207 L
s
.83 .24 .1 r
.32723 .64825 m
.30972 .62287 L
s
.30972 .62287 m
.32788 .60257 L
s
.24 .35 .67 r
.18033 .40277 m
.19069 .37325 L
s
.17139 .43234 m
.18033 .40277 L
s
.156 .259 .536 r
.55435 .35655 m .56754 .36175 L .55541 .35983 L p F P
0 0 0 r
s
.156 .259 .536 r
.55541 .35983 m .54456 .35556 L .55435 .35655 L p F P
0 0 0 r
s
.24 .35 .67 r
.53719 .35827 m
.55068 .35727 L
s
.918 .277 .11 r
.38117 .4029 m .37245 .41382 L .38535 .4013 L p F P
0 0 0 r
s
.918 .277 .11 r
.38535 .4013 m .39327 .3914 L .38117 .4029 L p F P
0 0 0 r
s
.24 .35 .67 r
.19069 .37325 m
.20212 .34475 L
s
.80034 .49919 m
.83415 .51203 L
s
.83598 .53904 m
.83415 .51203 L
s
.079 .091 .174 r
.45977 .64568 m .44633 .64165 L .45477 .64663 L p F P
0 0 0 r
s
.079 .091 .174 r
.45477 .64663 m .46607 .65002 L .45977 .64568 L p F P
0 0 0 r
s
.161 .046 .023 r
.65069 .54156 m .66287 .53076 L .65828 .54941 L p F P
0 0 0 r
s
.161 .046 .023 r
.65828 .54941 m .64648 .55974 L .65069 .54156 L p F P
0 0 0 r
s
.83 .24 .1 r
.64874 .54677 m
.64969 .52248 L
s
.273 .073 .037 r
.66341 .51169 m .67587 .50047 L .67529 .51975 L p F P
0 0 0 r
s
.273 .073 .037 r
.67529 .51975 m .66287 .53076 L .66341 .51169 L p F P
0 0 0 r
s
.084 .024 .01 r
.63489 .56989 m .64648 .55974 L .63855 .57679 L p F P
0 0 0 r
s
.83 .24 .1 r
.62494 .56781 m
.64874 .54677 L
s
.084 .024 .01 r
.63855 .57679 m .62765 .58624 L .63489 .56989 L p F P
0 0 0 r
s
.585 .167 .076 r
.67453 .42545 m .68572 .41472 L .70025 .4297 L p F P
0 0 0 r
s
.585 .167 .076 r
.70025 .4297 m .68806 .44112 L .67453 .42545 L p F P
0 0 0 r
s
.24 .35 .67 r
.62512 .68938 m
.58901 .67847 L
s
.62512 .68938 m
.64269 .68155 L
s
.83 .24 .1 r
.57817 .31784 m
.60429 .33319 L
s
.60429 .33319 m
.62808 .30736 L
s
1 .315 .13 r
.53891 .66424 m .54551 .65851 L .53573 .65738 L p F P
0 0 0 r
s
1 .315 .13 r
.53573 .65738 m .53058 .66188 L .53891 .66424 L p F P
0 0 0 r
s
.24 .35 .67 r
.26721 .30982 m
.25443 .33302 L
s
.25443 .33302 m
.21428 .31822 L
s
.391 .108 .052 r
.67215 .48152 m .68455 .47015 L .68857 .48903 L p F P
0 0 0 r
s
.391 .108 .052 r
.68857 .48903 m .67587 .50047 L .67215 .48152 L p F P
0 0 0 r
s
.83 .24 .1 r
.66938 .47461 m
.67411 .50047 L
s
.34 .095 .048 r
.32065 .54855 m .3119 .55889 L .30649 .54067 L p F P
0 0 0 r
s
.83 .24 .1 r
.30824 .53856 m
.30833 .54169 L
s
.34 .095 .048 r
.30649 .54067 m .31545 .52985 L .32065 .54855 L p F P
0 0 0 r
s
.24 .35 .67 r
.32 .30578 m
.30679 .32471 L
s
.30679 .32471 m
.26721 .30982 L
s
.83 .24 .1 r
.37428 .6891 m
.3937 .67003 L
s
.37428 .6891 m
.34913 .67073 L
s
.073 .085 .164 r
.60838 .37904 m .62322 .38488 L .60648 .37711 L p F P
0 0 0 r
s
.073 .085 .164 r
.60648 .37711 m .5936 .37203 L .60838 .37904 L p F P
0 0 0 r
s
.24 .35 .67 r
.58721 .37165 m
.62297 .38573 L
s
.497 .14 .065 r
.67609 .45233 m .68806 .44112 L .69718 .45856 L p F P
0 0 0 r
s
.83 .24 .1 r
.65961 .44838 m
.68419 .42499 L
s
.497 .14 .065 r
.69718 .45856 m .68455 .47015 L .67609 .45233 L p F P
0 0 0 r
s
.212 .061 .032 r
.32457 .51883 m .31545 .52985 L .31484 .51077 L p F P
0 0 0 r
s
.212 .061 .032 r
.31484 .51077 m .32399 .49953 L .32457 .51883 L p F P
0 0 0 r
s
.83 .24 .1 r
.32405 .50162 m
.32575 .49953 L
s
.24 .35 .67 r
.27838 .54971 m
.23848 .53727 L
s
.27838 .54971 m
.27981 .5696 L
s
.47 .135 .064 r
.32209 .576 m .31387 .58547 L .3033 .56905 L p F P
0 0 0 r
s
.24 .35 .67 r
.31743 .56189 m
.31874 .57476 L
s
.3192 .57932 m
.31945 .58175 L
s
.83 .24 .1 r
.29745 .5959 m
.31069 .58054 L
s
.47 .135 .064 r
.3033 .56905 m .3119 .55889 L .32209 .576 L p F P
0 0 0 r
s
.083 .024 .01 r
.36247 .42874 m .35333 .44018 L .36389 .42456 L p F P
0 0 0 r
s
.083 .024 .01 r
.36389 .42456 m .37245 .41382 L .36247 .42874 L p F P
0 0 0 r
s
.83 .24 .1 r
.35977 .43229 m
.37514 .41644 L
s
.216 .343 .692 r
.47798 .32936 m .48926 .3338 L .49185 .34159 L p F P
0 0 0 r
s
.216 .343 .692 r
.49185 .34159 m .4833 .33825 L .47798 .32936 L p F P
0 0 0 r
s
.153 .191 .345 r
.34906 .5962 m .33155 .59086 L .34544 .60497 L p F P
0 0 0 r
s
.24 .35 .67 r
.31945 .58175 m
.35825 .59364 L
s
.153 .191 .345 r
.34544 .60497 m .36145 .60981 L .34906 .5962 L p F P
0 0 0 r
s
.24 .35 .67 r
.35825 .59364 m
.36372 .60898 L
s
.143 .041 .02 r
.33332 .48807 m .32399 .49953 L .32772 .48059 L p F P
0 0 0 r
s
.83 .24 .1 r
.32575 .49953 m
.32637 .49661 L
s
.143 .041 .02 r
.32772 .48059 m .33688 .46919 L .33332 .48807 L p F P
0 0 0 r
s
.15 .249 .511 r
.51056 .66335 m .49954 .66005 L .49964 .65859 L p F P
0 0 0 r
s
.15 .249 .511 r
.49964 .65859 m .5083 .66119 L .51056 .66335 L p F P
0 0 0 r
s
.083 .024 .01 r
.34622 .45759 m .33688 .46919 L .34436 .45141 L p F P
0 0 0 r
s
.083 .024 .01 r
.34436 .45141 m .35333 .44018 L .34622 .45759 L p F P
0 0 0 r
s
.83 .24 .1 r
.35319 .44052 m
.35977 .43229 L
s
.083 .024 .01 r
.61693 .59554 m .62765 .58624 L .61708 .60079 L p F P
0 0 0 r
s
.083 .024 .01 r
.61708 .60079 m .60733 .60921 L .61693 .59554 L p F P
0 0 0 r
s
1 .332 .138 r
.46663 .3249 m .46034 .33261 L .4699 .3407 L p F P
0 0 0 r
s
1 .332 .138 r
.4699 .3407 m .47471 .33488 L .46663 .3249 L p F P
0 0 0 r
s
.83 .24 .1 r
.67624 .411 m
.68419 .42499 L
s
.156 .259 .536 r
.54106 .35131 m .55435 .35655 L .54456 .35556 L p F P
0 0 0 r
s
.156 .259 .536 r
.54456 .35556 m .53364 .35127 L .54106 .35131 L p F P
0 0 0 r
s
.24 .35 .67 r
.50039 .34385 m
.53719 .35827 L
s
.83 .24 .1 r
.34913 .67073 m
.32723 .64825 L
s
.32723 .64825 m
.34579 .62837 L
s
.24 .35 .67 r
.16417 .46098 m
.17139 .43234 L
s
1 .331 .136 r
.43647 .34707 m .42913 .35618 L .4419 .35525 L p F P
0 0 0 r
s
1 .331 .136 r
.4419 .35525 m .44798 .34779 L .43647 .34707 L p F P
0 0 0 r
s
.83 .24 .1 r
.43384 .35701 m
.45662 .3518 L
s
.52212 .67112 m
.52652 .66727 L
s
.52212 .67112 m
.49725 .67484 L
s
.34913 .67073 m
.36812 .65126 L
s
1 .316 .128 r
.40949 .37112 m .40132 .38134 L .41476 .37403 L p F P
0 0 0 r
s
1 .316 .128 r
.41476 .37403 m .4219 .36516 L .40949 .37112 L p F P
0 0 0 r
s
.109 .123 .235 r
.65359 .40211 m .66973 .40845 L .65251 .39642 L p F P
0 0 0 r
s
.83 .24 .1 r
.66944 .39903 m
.67425 .40749 L
s
.66944 .39903 m
.69452 .3744 L
s
.109 .123 .235 r
.65251 .39642 m .63793 .39068 L .65359 .40211 L p F P
0 0 0 r
s
.112 .127 .241 r
.39305 .61936 m .37732 .61461 L .39154 .62518 L p F P
0 0 0 r
s
.112 .127 .241 r
.39154 .62518 m .40539 .62934 L .39305 .61936 L p F P
0 0 0 r
s
.944 .288 .117 r
.56994 .64194 m .57813 .63487 L .56578 .64095 L p F P
0 0 0 r
s
.83 .24 .1 r
.5705 .63863 m
.58302 .62821 L
s
.944 .288 .117 r
.56578 .64095 m .55895 .64687 L .56994 .64194 L p F P
0 0 0 r
s
.24 .35 .67 r
.7257 .44937 m
.71735 .4313 L
s
.37246 .30695 m
.35912 .32076 L
s
.35912 .32076 m
.32 .30578 L
s
.079 .091 .174 r
.44633 .64165 m .43279 .63758 L .44339 .64322 L p F P
0 0 0 r
s
.079 .091 .174 r
.44339 .64322 m .45477 .64663 L .44633 .64165 L p F P
0 0 0 r
s
.24 .35 .67 r
.20212 .34475 m
.21428 .31822 L
s
.216 .343 .692 r
.46663 .3249 m .47798 .32936 L .4833 .33825 L p F P
0 0 0 r
s
.216 .343 .692 r
.4833 .33825 m .47471 .33488 L .46663 .3249 L p F P
0 0 0 r
s
.83 .24 .1 r
.4758 .32851 m
.47756 .32637 L
s
.45662 .3518 m
.47329 .33156 L
s
.24 .35 .67 r
.47039 .33209 m
.50039 .34385 L
s
.46277 .32911 m
.4631 .32923 L
s
.15 .249 .511 r
.49954 .66005 m .48846 .65673 L .49094 .65597 L p F P
0 0 0 r
s
.15 .249 .511 r
.49094 .65597 m .49964 .65859 L .49954 .66005 L p F P
0 0 0 r
s
.073 .085 .164 r
.59341 .37314 m .60838 .37904 L .5936 .37203 L p F P
0 0 0 r
s
.073 .085 .164 r
.5936 .37203 m .58062 .36691 L .59341 .37314 L p F P
0 0 0 r
s
.24 .35 .67 r
.52942 .66687 m
.53684 .6691 L
s
.53684 .6691 m
.55211 .66731 L
s
.083 .024 .01 r
.59772 .6175 m .60733 .60921 L .59484 .62046 L p F P
0 0 0 r
s
.083 .024 .01 r
.59484 .62046 m .58642 .62771 L .59772 .6175 L p F P
0 0 0 r
s
.83 .24 .1 r
.47756 .32637 m
.50272 .32686 L
s
.50272 .32686 m
.52469 .30077 L
s
.24 .35 .67 r
.6784 .69249 m
.64269 .68155 L
s
.6784 .69249 m
.69684 .67858 L
s
.27981 .5696 m
.3106 .57904 L
s
.31759 .58118 m
.31945 .58175 L
s
.156 .259 .536 r
.52767 .34603 m .54106 .35131 L .53364 .35127 L p F P
0 0 0 r
s
.156 .259 .536 r
.53364 .35127 m .52265 .34694 L .52767 .34603 L p F P
0 0 0 r
s
.83 .24 .1 r
.55131 .30686 m
.57817 .31784 L
s
.57817 .31784 m
.60159 .29157 L
s
1 .315 .13 r
.54551 .65851 m .55219 .65272 L .54093 .65283 L p F P
0 0 0 r
s
1 .315 .13 r
.54093 .65283 m .53573 .65738 L .54551 .65851 L p F P
0 0 0 r
s
.153 .191 .345 r
.33155 .59086 m .31387 .58547 L .32928 .60009 L p F P
0 0 0 r
s
.153 .191 .345 r
.32928 .60009 m .34544 .60497 L .33155 .59086 L p F P
0 0 0 r
s
.83 .24 .1 r
.44907 .69171 m
.47003 .67258 L
s
.44907 .69171 m
.42116 .68372 L
s
.918 .277 .11 r
.39003 .39179 m .38117 .4029 L .39327 .3914 L p F P
0 0 0 r
s
.83 .24 .1 r
.37514 .41644 m
.39434 .39248 L
s
.918 .277 .11 r
.39327 .3914 m .40132 .38134 L .39003 .39179 L p F P
0 0 0 r
s
.83 .24 .1 r
.39434 .39248 m
.41383 .38174 L
s
.079 .091 .174 r
.43279 .63758 m .41915 .63348 L .43194 .63978 L p F P
0 0 0 r
s
.079 .091 .174 r
.43194 .63978 m .44339 .64322 L .43279 .63758 L p F P
0 0 0 r
s
.24 .35 .67 r
.44001 .63207 m
.44949 .64225 L
s
.109 .123 .235 r
.63728 .39571 m .65359 .40211 L .63793 .39068 L p F P
0 0 0 r
s
.109 .123 .235 r
.63793 .39068 m .62322 .38488 L .63728 .39571 L p F P
0 0 0 r
s
.24 .35 .67 r
.62297 .38573 m
.6262 .38718 L
s
.112 .127 .241 r
.37732 .61461 m .36145 .60981 L .37757 .62098 L p F P
0 0 0 r
s
.112 .127 .241 r
.37757 .62098 m .39154 .62518 L .37732 .61461 L p F P
0 0 0 r
s
.24 .35 .67 r
.36372 .60898 m
.40228 .62065 L
s
.15 .249 .511 r
.48846 .65673 m .4773 .65338 L .4822 .65335 L p F P
0 0 0 r
s
.15 .249 .511 r
.4822 .65335 m .49094 .65597 L .48846 .65673 L p F P
0 0 0 r
s
.24 .35 .67 r
.44949 .64225 m
.48699 .65352 L
s
.48699 .65352 m
.49961 .65792 L
s
.76579 .48607 m
.7606 .46286 L
s
.7606 .46286 m
.7257 .44937 L
s
1 .331 .136 r
.44391 .33784 m .43647 .34707 L .44798 .34779 L p F P
0 0 0 r
s
1 .331 .136 r
.44798 .34779 m .45413 .34025 L .44391 .33784 L p F P
0 0 0 r
s
.24 .35 .67 r
.73206 .68959 m
.69684 .67858 L
s
.73206 .68959 m
.75025 .67016 L
s
.073 .085 .164 r
.5783 .36718 m .59341 .37314 L .58062 .36691 L p F P
0 0 0 r
s
.073 .085 .164 r
.58062 .36691 m .56754 .36175 L .5783 .36718 L p F P
0 0 0 r
s
.24 .35 .67 r
.55068 .35727 m
.58721 .37165 L
s
.78489 .68126 m
.75025 .67016 L
s
.78489 .68126 m
.80165 .65721 L
s
.42432 .31404 m
.41122 .322 L
s
.41122 .322 m
.37246 .30695 L
s
.152 .189 .336 r
.68308 .42301 m .70025 .4297 L .68572 .41472 L p F P
0 0 0 r
s
.83 .24 .1 r
.68985 .4196 m
.69076 .41874 L
s
.68419 .42499 m
.68534 .42389 L
s
.69076 .41874 m
.70971 .40071 L
s
.152 .189 .336 r
.68572 .41472 m .66973 .40845 L .68308 .42301 L p F P
0 0 0 r
s
.156 .259 .536 r
.51417 .34071 m .52767 .34603 L .52265 .34694 L p F P
0 0 0 r
s
.156 .259 .536 r
.52265 .34694 m .51159 .34259 L .51417 .34071 L p F P
0 0 0 r
s
.161 .046 .023 r
.66287 .53076 m .67529 .51975 L .6703 .53889 L p F P
0 0 0 r
s
.83 .24 .1 r
.64969 .52248 m
.67411 .50047 L
s
.161 .046 .023 r
.6703 .53889 m .65828 .54941 L .66287 .53076 L p F P
0 0 0 r
s
.24 .35 .67 r
.20007 .50081 m
.15896 .48772 L
s
.20007 .50081 m
.19769 .52455 L
s
.084 .024 .01 r
.64648 .55974 m .65828 .54941 L .64964 .56717 L p F P
0 0 0 r
s
.084 .024 .01 r
.64964 .56717 m .63855 .57679 L .64648 .55974 L p F P
0 0 0 r
s
.83 .24 .1 r
.64229 .56871 m
.64874 .54677 L
s
.083 .024 .01 r
.37178 .4171 m .36247 .42874 L .37245 .41382 L p F P
0 0 0 r
s
.083 .024 .01 r
.37245 .41382 m .38117 .4029 L .37178 .4171 L p F P
0 0 0 r
s
.273 .073 .037 r
.67587 .50047 m .68857 .48903 L .68794 .50854 L p F P
0 0 0 r
s
.273 .073 .037 r
.68794 .50854 m .67529 .51975 L .67587 .50047 L p F P
0 0 0 r
s
.24 .35 .67 r
.15896 .48772 m
.16417 .46098 L
s
1 .316 .128 r
.41778 .36074 m .40949 .37112 L .4219 .36516 L p F P
0 0 0 r
s
1 .316 .128 r
.4219 .36516 m .42913 .35618 L .41778 .36074 L p F P
0 0 0 r
s
.83 .24 .1 r
.41383 .38174 m
.43384 .35701 L
s
.497 .14 .065 r
.68806 .44112 m .70025 .4297 L .71005 .44675 L p F P
0 0 0 r
s
.24 .35 .67 r
.6923 .42151 m
.71735 .4313 L
s
.497 .14 .065 r
.71005 .44675 m .69718 .45856 L .68806 .44112 L p F P
0 0 0 r
s
.83 .24 .1 r
.68419 .42499 m
.69436 .45151 L
s
.391 .108 .052 r
.68455 .47015 m .69718 .45856 L .70152 .47737 L p F P
0 0 0 r
s
.391 .108 .052 r
.70152 .47737 m .68857 .48903 L .68455 .47015 L p F P
0 0 0 r
s
.83 .24 .1 r
.66938 .47461 m
.69436 .45151 L
s
.34 .095 .048 r
.32957 .53801 m .32065 .54855 L .31545 .52985 L p F P
0 0 0 r
s
.34 .095 .048 r
.31545 .52985 m .32457 .51883 L .32957 .53801 L p F P
0 0 0 r
s
.47 .135 .064 r
.33045 .56637 m .32209 .576 L .3119 .55889 L p F P
0 0 0 r
s
.47 .135 .064 r
.3119 .55889 m .32065 .54855 L .33045 .56637 L p F P
0 0 0 r
s
.944 .288 .117 r
.57813 .63487 m .58642 .62771 L .57269 .63496 L p F P
0 0 0 r
s
.83 .24 .1 r
.58302 .62821 m
.60625 .60812 L
s
.944 .288 .117 r
.57269 .63496 m .56578 .64095 L .57813 .63487 L p F P
0 0 0 r
s
.24 .35 .67 r
.83346 .56866 m
.83598 .53904 L
s
.83598 .53904 m
.80184 .52636 L
s
.212 .061 .032 r
.33388 .5076 m .32457 .51883 L .32399 .49953 L p F P
0 0 0 r
s
.212 .061 .032 r
.32399 .49953 m .33332 .48807 L .33388 .5076 L p F P
0 0 0 r
s
.083 .024 .01 r
.62765 .58624 m .63855 .57679 L .62699 .59224 L p F P
0 0 0 r
s
.083 .024 .01 r
.62699 .59224 m .61708 .60079 L .62765 .58624 L p F P
0 0 0 r
s
.83 .24 .1 r
.61828 .58962 m
.64229 .56871 L
s
.60625 .60812 m
.61828 .58962 L
s
.083 .024 .01 r
.35573 .44576 m .34622 .45759 L .35333 .44018 L p F P
0 0 0 r
s
.83 .24 .1 r
.35441 .44269 m
.35977 .43229 L
s
.083 .024 .01 r
.35333 .44018 m .36247 .42874 L .35573 .44576 L p F P
0 0 0 r
s
.24 .35 .67 r
.76579 .48607 m
.80034 .49919 L
s
.80184 .52636 m
.80034 .49919 L
s
.143 .041 .02 r
.34283 .47639 m .33332 .48807 L .33688 .46919 L p F P
0 0 0 r
s
.143 .041 .02 r
.33688 .46919 m .34622 .45759 L .34283 .47639 L p F P
0 0 0 r
s
.15 .249 .511 r
.4773 .65338 m .46607 .65002 L .47341 .65071 L p F P
0 0 0 r
s
.15 .249 .511 r
.47341 .65071 m .4822 .65335 L .4773 .65338 L p F P
0 0 0 r
s
.575 .166 .076 r
.33694 .59152 m .32928 .60009 L .31387 .58547 L p F P
0 0 0 r
s
.24 .35 .67 r
.32361 .59484 m
.32431 .59705 L
s
.3227 .59198 m
.32361 .59484 L
s
.575 .166 .076 r
.31387 .58547 m .32209 .576 L .33694 .59152 L p F P
0 0 0 r
s
.24 .35 .67 r
.58901 .67847 m
.55211 .66731 L
s
.58901 .67847 m
.60619 .67037 L
s
.21428 .31822 m
.22675 .29459 L
s
.079 .091 .174 r
.41915 .63348 m .40539 .62934 L .42041 .63633 L p F P
0 0 0 r
s
.079 .091 .174 r
.42041 .63633 m .43194 .63978 L .41915 .63348 L p F P
0 0 0 r
s
.83 .24 .1 r
.32475 .59579 m
.32788 .60257 L
s
.24 .35 .67 r
.28 .29047 m
.26721 .30982 L
s
.26721 .30982 m
.22675 .29459 L
s
1 .315 .13 r
.55219 .65272 m .55895 .64687 L .54617 .64825 L p F P
0 0 0 r
s
.83 .24 .1 r
.55447 .64735 m
.56223 .64403 L
s
1 .315 .13 r
.54617 .64825 m .54093 .65283 L .55219 .65272 L p F P
0 0 0 r
s
.24 .35 .67 r
.23848 .53727 m
.19769 .52455 L
s
.23848 .53727 m
.23929 .55718 L
s
.156 .259 .536 r
.50057 .33534 m .51417 .34071 L .51159 .34259 L p F P
0 0 0 r
s
.156 .259 .536 r
.51159 .34259 m .50046 .33821 L .50057 .33534 L p F P
0 0 0 r
s
.24 .35 .67 r
.50039 .34385 m
.51334 .34257 L
s
.109 .123 .235 r
.62081 .38925 m .63728 .39571 L .62322 .38488 L p F P
0 0 0 r
s
.109 .123 .235 r
.62322 .38488 m .60838 .37904 L .62081 .38925 L p F P
0 0 0 r
s
.112 .127 .241 r
.36145 .60981 m .34544 .60497 L .36349 .61675 L p F P
0 0 0 r
s
.112 .127 .241 r
.36349 .61675 m .37757 .62098 L .36145 .60981 L p F P
0 0 0 r
s
.073 .085 .164 r
.56305 .36118 m .5783 .36718 L .56754 .36175 L p F P
0 0 0 r
s
.073 .085 .164 r
.56754 .36175 m .55435 .35655 L .56305 .36118 L p F P
0 0 0 r
s
.083 .024 .01 r
.60733 .60921 m .61708 .60079 L .60336 .6131 L p F P
0 0 0 r
s
.083 .024 .01 r
.60336 .6131 m .59484 .62046 L .60733 .60921 L p F P
0 0 0 r
s
.213 .34 .684 r
.52548 .66634 m .51691 .66377 L .51172 .65667 L p F P
0 0 0 r
s
.24 .35 .67 r
.52385 .6652 m
.52604 .66586 L
s
.213 .34 .684 r
.51172 .65667 m .51767 .65847 L .52548 .66634 L p F P
0 0 0 r
s
.24 .35 .67 r
.49961 .65792 m
.51629 .66293 L
s
1 .322 .134 r
.52548 .66634 m .53058 .66188 L .52119 .65535 L p F P
0 0 0 r
s
1 .322 .134 r
.52119 .65535 m .51767 .65847 L .52548 .66634 L p F P
0 0 0 r
s
.83 .24 .1 r
.52469 .30077 m
.55131 .30686 L
s
.55131 .30686 m
.57441 .28017 L
s
.152 .189 .336 r
.66573 .41625 m .68308 .42301 L .66973 .40845 L p F P
0 0 0 r
s
.152 .189 .336 r
.66973 .40845 m .65359 .40211 L .66573 .41625 L p F P
0 0 0 r
s
1 .331 .136 r
.45145 .32848 m .44391 .33784 L .45413 .34025 L p F P
0 0 0 r
s
1 .331 .136 r
.45413 .34025 m .46034 .33261 L .45145 .32848 L p F P
0 0 0 r
s
.24 .35 .67 r
.45824 .33164 m
.46277 .32911 L
s
.83 .24 .1 r
.42116 .68372 m
.44175 .66428 L
s
.42116 .68372 m
.3937 .67003 L
s
.15 .249 .511 r
.46607 .65002 m .45477 .64663 L .46457 .64806 L p F P
0 0 0 r
s
.15 .249 .511 r
.46457 .64806 m .47341 .65071 L .46607 .65002 L p F P
0 0 0 r
s
.24 .35 .67 r
.33285 .29157 m
.32 .30578 L
s
.32 .30578 m
.28 .29047 L
s
.83 .24 .1 r
.49725 .67484 m
.47003 .67258 L
s
.918 .277 .11 r
.39904 .38049 m .39003 .39179 L .40132 .38134 L p F P
0 0 0 r
s
.918 .277 .11 r
.40132 .38134 m .40949 .37112 L .39904 .38049 L p F P
0 0 0 r
s
.24 .35 .67 r
.46277 .32911 m
.46325 .32905 L
s
.079 .091 .174 r
.40539 .62934 m .39154 .62518 L .40881 .63285 L p F P
0 0 0 r
s
.079 .091 .174 r
.40881 .63285 m .42041 .63633 L .40539 .62934 L p F P
0 0 0 r
s
.24 .35 .67 r
.40228 .62065 m
.41117 .63073 L
s
.41117 .63073 m
.44949 .64225 L
s
.156 .259 .536 r
.48685 .32993 m .50057 .33534 L .50046 .33821 L p F P
0 0 0 r
s
.156 .259 .536 r
.50046 .33821 m .48926 .3338 L .48685 .32993 L p F P
0 0 0 r
s
.213 .34 .684 r
.51691 .66377 m .5083 .66119 L .50575 .65487 L p F P
0 0 0 r
s
.213 .34 .684 r
.50575 .65487 m .51172 .65667 L .51691 .66377 L p F P
0 0 0 r
s
.83 .24 .1 r
.49725 .67484 m
.51232 .66145 L
s
.51232 .66145 m
.51543 .65868 L
s
.24 .35 .67 r
.80165 .65721 m
.76691 .64576 L
s
.80165 .65721 m
.81583 .62942 L
s
.073 .085 .164 r
.54767 .35511 m .56305 .36118 L .55435 .35655 L p F P
0 0 0 r
s
.24 .35 .67 r
.55068 .35727 m
.56241 .36259 L
s
.073 .085 .164 r
.55435 .35655 m .54106 .35131 L .54767 .35511 L p F P
0 0 0 r
s
.24 .35 .67 r
.64269 .68155 m
.60619 .67037 L
s
.64269 .68155 m
.66083 .66734 L
s
.27981 .5696 m
.23929 .55718 L
s
.27981 .5696 m
.28402 .58485 L
s
1 .316 .128 r
.42622 .3502 m .41778 .36074 L .42913 .35618 L p F P
0 0 0 r
s
1 .316 .128 r
.42913 .35618 m .43647 .34707 L .42622 .3502 L p F P
0 0 0 r
s
.109 .123 .235 r
.60417 .38272 m .62081 .38925 L .60838 .37904 L p F P
0 0 0 r
s
.109 .123 .235 r
.60838 .37904 m .59341 .37314 L .60417 .38272 L p F P
0 0 0 r
s
.24 .35 .67 r
.58721 .37165 m
.59638 .37578 L
s
.112 .127 .241 r
.34544 .60497 m .32928 .60009 L .3493 .61249 L p F P
0 0 0 r
s
.112 .127 .241 r
.3493 .61249 m .36349 .61675 L .34544 .60497 L p F P
0 0 0 r
s
.944 .288 .117 r
.58642 .62771 m .59484 .62046 L .57968 .62891 L p F P
0 0 0 r
s
.944 .288 .117 r
.57968 .62891 m .57269 .63496 L .58642 .62771 L p F P
0 0 0 r
s
.83 .24 .1 r
.62808 .30736 m
.65295 .32691 L
s
.65295 .32691 m
.67809 .30052 L
s
.65295 .32691 m
.67536 .34952 L
s
1 .315 .13 r
.55895 .64687 m .56578 .64095 L .55146 .64362 L p F P
0 0 0 r
s
1 .315 .13 r
.55146 .64362 m .54617 .64825 L .55895 .64687 L p F P
0 0 0 r
s
.24 .35 .67 r
.82664 .59935 m
.83346 .56866 L
s
.83346 .56866 m
.79905 .55622 L
s
.83 .24 .1 r
.67536 .34952 m
.70094 .32355 L
s
.67536 .34952 m
.69452 .3744 L
s
.15 .249 .511 r
.45477 .64663 m .44339 .64322 L .4557 .64539 L p F P
0 0 0 r
s
.15 .249 .511 r
.4557 .64539 m .46457 .64806 L .45477 .64663 L p F P
0 0 0 r
s
.83 .24 .1 r
.32788 .60257 m
.32981 .60041 L
s
1 .322 .134 r
.53058 .66188 m .53573 .65738 L .52472 .65221 L p F P
0 0 0 r
s
1 .322 .134 r
.52472 .65221 m .52119 .65535 L .53058 .66188 L p F P
0 0 0 r
s
.083 .024 .01 r
.38126 .40523 m .37178 .4171 L .38117 .4029 L p F P
0 0 0 r
s
.083 .024 .01 r
.38117 .4029 m .39003 .39179 L .38126 .40523 L p F P
0 0 0 r
s
.83 .24 .1 r
.37895 .40828 m
.39434 .39248 L
s
.084 .024 .01 r
.65828 .54941 m .6703 .53889 L .66092 .55738 L p F P
0 0 0 r
s
.084 .024 .01 r
.66092 .55738 m .64964 .56717 L .65828 .54941 L p F P
0 0 0 r
s
.156 .259 .536 r
.47303 .32448 m .48685 .32993 L .48926 .3338 L p F P
0 0 0 r
s
.156 .259 .536 r
.48926 .3338 m .47798 .32936 L .47303 .32448 L p F P
0 0 0 r
s
.83 .24 .1 r
.47293 .32737 m
.47542 .32684 L
s
.161 .046 .023 r
.67529 .51975 m .68794 .50854 L .68255 .52817 L p F P
0 0 0 r
s
.161 .046 .023 r
.68255 .52817 m .6703 .53889 L .67529 .51975 L p F P
0 0 0 r
s
.83 .24 .1 r
.64874 .54677 m
.67345 .52494 L
s
.67345 .52494 m
.67411 .50047 L
s
.152 .189 .336 r
.64819 .40942 m .66573 .41625 L .65359 .40211 L p F P
0 0 0 r
s
.152 .189 .336 r
.65359 .40211 m .63728 .39571 L .64819 .40942 L p F P
0 0 0 r
s
.213 .34 .684 r
.5083 .66119 m .49964 .65859 L .49975 .65306 L p F P
0 0 0 r
s
.24 .35 .67 r
.49961 .65792 m
.49965 .65791 L
s
.213 .34 .684 r
.49975 .65306 m .50575 .65487 L .5083 .66119 L p F P
0 0 0 r
s
.083 .024 .01 r
.63855 .57679 m .64964 .56717 L .63706 .58355 L p F P
0 0 0 r
s
.083 .024 .01 r
.63706 .58355 m .62699 .59224 L .63855 .57679 L p F P
0 0 0 r
s
.198 .262 .481 r
.69209 .43982 m .71005 .44675 L .70025 .4297 L p F P
0 0 0 r
s
.83 .24 .1 r
.70591 .44083 m
.70756 .4393 L
s
.70756 .4393 m
.72031 .42751 L
s
.198 .262 .481 r
.70025 .4297 m .68308 .42301 L .69209 .43982 L p F P
0 0 0 r
s
.24 .35 .67 r
.73047 .47265 m
.7257 .44937 L
s
.273 .073 .037 r
.68857 .48903 m .70152 .47737 L .70084 .4971 L p F P
0 0 0 r
s
.273 .073 .037 r
.70084 .4971 m .68794 .50854 L .68857 .48903 L p F P
0 0 0 r
s
.47 .135 .064 r
.33896 .55656 m .33045 .56637 L .32065 .54855 L p F P
0 0 0 r
s
.47 .135 .064 r
.32065 .54855 m .32957 .53801 L .33896 .55656 L p F P
0 0 0 r
s
.079 .091 .174 r
.39154 .62518 m .37757 .62098 L .39713 .62935 L p F P
0 0 0 r
s
.079 .091 .174 r
.39713 .62935 m .40881 .63285 L .39154 .62518 L p F P
0 0 0 r
s
.83 .24 .1 r
.60159 .29157 m
.62808 .30736 L
s
.62808 .30736 m
.65279 .28052 L
s
.24 .35 .67 r
.69684 .67858 m
.66083 .66734 L
s
.69684 .67858 m
.71483 .65882 L
s
.391 .108 .052 r
.69718 .45856 m .71005 .44675 L .71472 .46548 L p F P
0 0 0 r
s
.24 .35 .67 r
.70752 .44234 m
.7257 .44937 L
s
.83 .24 .1 r
.69436 .45151 m
.70261 .44388 L
s
.391 .108 .052 r
.71472 .46548 m .70152 .47737 L .69718 .45856 L p F P
0 0 0 r
s
.83 .24 .1 r
.69436 .45151 m
.69947 .4776 L
s
.34 .095 .048 r
.33865 .52728 m .32957 .53801 L .32457 .51883 L p F P
0 0 0 r
s
.83 .24 .1 r
.32637 .51667 m
.32649 .51998 L
s
.34 .095 .048 r
.32457 .51883 m .33388 .5076 L .33865 .52728 L p F P
0 0 0 r
s
.24 .35 .67 r
.75025 .67016 m
.71483 .65882 L
s
.75025 .67016 m
.76691 .64576 L
s
1 .331 .136 r
.45909 .31899 m .45145 .32848 L .46034 .33261 L p F P
0 0 0 r
s
.24 .35 .67 r
.42432 .31404 m
.45378 .32558 L
s
.45992 .32799 m
.46277 .32911 L
s
1 .331 .136 r
.46034 .33261 m .46663 .3249 L .45909 .31899 L p F P
0 0 0 r
s
.83 .24 .1 r
.3937 .67003 m
.41387 .65022 L
s
.3937 .67003 m
.36812 .65126 L
s
.24 .35 .67 r
.38502 .29864 m
.37246 .30695 L
s
.37246 .30695 m
.33285 .29157 L
s
.575 .166 .076 r
.34471 .58282 m .33694 .59152 L .32209 .576 L p F P
0 0 0 r
s
.575 .166 .076 r
.32209 .576 m .33045 .56637 L .34471 .58282 L p F P
0 0 0 r
s
.083 .024 .01 r
.36544 .4337 m .35573 .44576 L .36247 .42874 L p F P
0 0 0 r
s
.083 .024 .01 r
.36247 .42874 m .37178 .4171 L .36544 .4337 L p F P
0 0 0 r
s
.83 .24 .1 r
.37165 .41742 m
.37895 .40828 L
s
.212 .061 .032 r
.34336 .49614 m .33388 .5076 L .33332 .48807 L p F P
0 0 0 r
s
.212 .061 .032 r
.33332 .48807 m .34283 .47639 L .34336 .49614 L p F P
0 0 0 r
s
.83 .24 .1 r
.34289 .47853 m
.34443 .47663 L
s
.143 .041 .02 r
.35252 .46448 m .34283 .47639 L .34622 .45759 L p F P
0 0 0 r
s
.83 .24 .1 r
.34443 .47663 m
.34503 .47369 L
s
.143 .041 .02 r
.34622 .45759 m .35573 .44576 L .35252 .46448 L p F P
0 0 0 r
s
.073 .085 .164 r
.53214 .349 m .54767 .35511 L .54106 .35131 L p F P
0 0 0 r
s
.073 .085 .164 r
.54106 .35131 m .52767 .34603 L .53214 .349 L p F P
0 0 0 r
s
.24 .35 .67 r
.51334 .34257 m
.55068 .35727 L
s
.156 .51155 m
.15896 .48772 L
s
.81583 .62942 m
.78111 .61761 L
s
.81583 .62942 m
.82664 .59935 L
s
.083 .024 .01 r
.61708 .60079 m .62699 .59224 L .61201 .60564 L p F P
0 0 0 r
s
.083 .024 .01 r
.61201 .60564 m .60336 .6131 L .61708 .60079 L p F P
0 0 0 r
s
.15 .249 .511 r
.44339 .64322 m .43194 .63978 L .44677 .64271 L p F P
0 0 0 r
s
.15 .249 .511 r
.44677 .64271 m .4557 .64539 L .44339 .64322 L p F P
0 0 0 r
s
.24 .35 .67 r
.44949 .64225 m
.46156 .64648 L
s
.82664 .59935 m
.79202 .5872 L
s
.83 .24 .1 r
.69452 .3744 m
.72056 .34882 L
s
.69452 .3744 m
.70971 .40071 L
s
.109 .123 .235 r
.58736 .37612 m .60417 .38272 L .59341 .37314 L p F P
0 0 0 r
s
.109 .123 .235 r
.59341 .37314 m .5783 .36718 L .58736 .37612 L p F P
0 0 0 r
s
.24 .35 .67 r
.79905 .55622 m
.80184 .52636 L
s
.80184 .52636 m
.76694 .5134 L
s
.663 .193 .087 r
.35619 .60502 m .3493 .61249 L .32928 .60009 L p F P
0 0 0 r
s
.24 .35 .67 r
.35498 .60633 m
.36372 .60898 L
s
.663 .193 .087 r
.32928 .60009 m .33694 .59152 L .35619 .60502 L p F P
0 0 0 r
s
.83 .24 .1 r
.32788 .60257 m
.34579 .62837 L
s
.24 .35 .67 r
.32431 .59705 m
.32916 .59852 L
s
.32916 .59852 m
.32936 .59858 L
s
.213 .34 .684 r
.49964 .65859 m .49094 .65597 L .49373 .65124 L p F P
0 0 0 r
s
.24 .35 .67 r
.49894 .65771 m
.49961 .65792 L
s
.213 .34 .684 r
.49373 .65124 m .49975 .65306 L .49964 .65859 L p F P
0 0 0 r
s
.83 .24 .1 r
.36812 .65126 m
.34579 .62837 L
s
.32971 .53784 m
.32995 .53876 L
s
.24 .35 .67 r
.73047 .47265 m
.76579 .48607 L
s
.76694 .5134 m
.76579 .48607 L
s
.156 .259 .536 r
.45909 .31899 m .47303 .32448 L .47798 .32936 L p F P
0 0 0 r
s
.156 .259 .536 r
.47798 .32936 m .46663 .3249 L .45909 .31899 L p F P
0 0 0 r
s
.83 .24 .1 r
.45463 .33133 m
.47106 .32778 L
s
.24 .35 .67 r
.46628 .32866 m
.47517 .32754 L
s
.5263 .65951 m
.55211 .66731 L
s
.521 .65791 m
.5263 .65951 L
s
.55211 .66731 m
.56888 .65894 L
s
1 .322 .134 r
.53573 .65738 m .54093 .65283 L .52828 .64906 L p F P
0 0 0 r
s
.83 .24 .1 r
.5394 .65238 m
.54184 .65203 L
s
1 .322 .134 r
.52828 .64906 m .52472 .65221 L .53573 .65738 L p F P
0 0 0 r
s
.24 .35 .67 r
.22675 .29459 m
.23911 .27481 L
s
.918 .277 .11 r
.40821 .36898 m .39904 .38049 L .40949 .37112 L p F P
0 0 0 r
s
.918 .277 .11 r
.40949 .37112 m .41778 .36074 L .40821 .36898 L p F P
0 0 0 r
s
.83 .24 .1 r
.39434 .39248 m
.41427 .3676 L
s
.41427 .3676 m
.43384 .35701 L
s
.24 .35 .67 r
.19769 .52455 m
.156 .51155 L
s
.19769 .52455 m
.19786 .54448 L
s
.28402 .58485 m
.32431 .59705 L
s
.32431 .59705 m
.33194 .60691 L
s
1 .315 .13 r
.56578 .64095 m .57269 .63496 L .55679 .63896 L p F P
0 0 0 r
s
1 .315 .13 r
.55679 .63896 m .55146 .64362 L .56578 .64095 L p F P
0 0 0 r
s
.079 .091 .174 r
.37757 .62098 m .36349 .61675 L .38537 .62582 L p F P
0 0 0 r
s
.079 .091 .174 r
.38537 .62582 m .39713 .62935 L .37757 .62098 L p F P
0 0 0 r
s
1 .316 .128 r
.43478 .33949 m .42622 .3502 L .43647 .34707 L p F P
0 0 0 r
s
1 .316 .128 r
.43647 .34707 m .44391 .33784 L .43478 .33949 L p F P
0 0 0 r
s
.152 .189 .336 r
.63046 .40251 m .64819 .40942 L .63728 .39571 L p F P
0 0 0 r
s
.152 .189 .336 r
.63728 .39571 m .62081 .38925 L .63046 .40251 L p F P
0 0 0 r
s
.944 .288 .117 r
.59484 .62046 m .60336 .6131 L .58675 .62278 L p F P
0 0 0 r
s
.83 .24 .1 r
.59301 .61914 m
.60625 .60812 L
s
.944 .288 .117 r
.58675 .62278 m .57968 .62891 L .59484 .62046 L p F P
0 0 0 r
s
.213 .34 .684 r
.49094 .65597 m .4822 .65335 L .4877 .64942 L p F P
0 0 0 r
s
.24 .35 .67 r
.49056 .6552 m
.49127 .65541 L
s
.213 .34 .684 r
.4877 .64942 m .49373 .65124 L .49094 .65597 L p F P
0 0 0 r
s
.83 .24 .1 r
.49931 .29996 m
.52469 .30077 L
s
.52469 .30077 m
.54751 .27368 L
s
.15 .249 .511 r
.43194 .63978 m .42041 .63633 L .4378 .64002 L p F P
0 0 0 r
s
.15 .249 .511 r
.4378 .64002 m .44677 .64271 L .43194 .63978 L p F P
0 0 0 r
s
.073 .085 .164 r
.51647 .34282 m .53214 .349 L .52767 .34603 L p F P
0 0 0 r
s
.073 .085 .164 r
.52767 .34603 m .51417 .34071 L .51647 .34282 L p F P
0 0 0 r
s
.198 .262 .481 r
.67393 .43282 m .69209 .43982 L .68308 .42301 L p F P
0 0 0 r
s
.198 .262 .481 r
.68308 .42301 m .66573 .41625 L .67393 .43282 L p F P
0 0 0 r
s
.83 .24 .1 r
.57441 .28017 m
.60159 .29157 L
s
.60159 .29157 m
.62592 .26427 L
s
.47003 .67258 m
.49036 .65403 L
s
.49036 .65403 m
.49181 .65271 L
s
.47003 .67258 m
.44175 .66428 L
s
.24 .35 .67 r
.29234 .27585 m
.28 .29047 L
s
.28 .29047 m
.23911 .27481 L
s
.109 .123 .235 r
.57039 .36946 m .58736 .37612 L .5783 .36718 L p F P
0 0 0 r
s
.109 .123 .235 r
.5783 .36718 m .56305 .36118 L .57039 .36946 L p F P
0 0 0 r
s
.24 .35 .67 r
.56241 .36259 m
.56532 .36374 L
s
.43614 .31217 m
.42432 .31404 L
s
.42432 .31404 m
.38502 .29864 L
s
.213 .34 .684 r
.4822 .65335 m .47341 .65071 L .48164 .64759 L p F P
0 0 0 r
s
.24 .35 .67 r
.46156 .64648 m
.47439 .65034 L
s
.48213 .65266 m
.48285 .65288 L
s
.213 .34 .684 r
.48164 .64759 m .4877 .64942 L .4822 .65335 L p F P
0 0 0 r
s
.083 .024 .01 r
.39091 .39314 m .38126 .40523 L .39003 .39179 L p F P
0 0 0 r
s
.083 .024 .01 r
.39003 .39179 m .39904 .38049 L .39091 .39314 L p F P
0 0 0 r
s
1 .322 .134 r
.54093 .65283 m .54617 .64825 L .53185 .64589 L p F P
0 0 0 r
s
1 .322 .134 r
.53185 .64589 m .52828 .64906 L .54093 .65283 L p F P
0 0 0 r
s
.079 .091 .174 r
.36349 .61675 m .3493 .61249 L .37353 .62227 L p F P
0 0 0 r
s
.079 .091 .174 r
.37353 .62227 m .38537 .62582 L .36349 .61675 L p F P
0 0 0 r
s
.24 .35 .67 r
.36372 .60898 m
.37199 .61895 L
s
.37199 .61895 m
.41117 .63073 L
s
.76691 .64576 m
.7314 .63406 L
s
.76691 .64576 m
.78111 .61761 L
s
.15 .249 .511 r
.42041 .63633 m .40881 .63285 L .42879 .63731 L p F P
0 0 0 r
s
.15 .249 .511 r
.42879 .63731 m .4378 .64002 L .42041 .63633 L p F P
0 0 0 r
s
.24 .35 .67 r
.60619 .67037 m
.56888 .65894 L
s
.60619 .67037 m
.62402 .65584 L
s
.83 .24 .1 r
.70971 .40071 m
.73623 .37547 L
s
.70971 .40071 m
.72031 .42751 L
s
.083 .024 .01 r
.64964 .56717 m .66092 .55738 L .64729 .57472 L p F P
0 0 0 r
s
.083 .024 .01 r
.64729 .57472 m .63706 .58355 L .64964 .56717 L p F P
0 0 0 r
s
.24 .35 .67 r
.23929 .55718 m
.19786 .54448 L
s
.23929 .55718 m
.24282 .57238 L
s
.084 .024 .01 r
.6703 .53889 m .68255 .52817 L .6724 .54742 L p F P
0 0 0 r
s
.084 .024 .01 r
.6724 .54742 m .66092 .55738 L .6703 .53889 L p F P
0 0 0 r
s
.83 .24 .1 r
.66723 .54698 m
.67345 .52494 L
s
.073 .085 .164 r
.50066 .33659 m .51647 .34282 L .51417 .34071 L p F P
0 0 0 r
s
.073 .085 .164 r
.51417 .34071 m .50057 .33534 L .50066 .33659 L p F P
0 0 0 r
s
.161 .046 .023 r
.68794 .50854 m .70084 .4971 L .69502 .51726 L p F P
0 0 0 r
s
.83 .24 .1 r
.67411 .50047 m
.69947 .4776 L
s
.161 .046 .023 r
.69502 .51726 m .68255 .52817 L .68794 .50854 L p F P
0 0 0 r
s
.575 .166 .076 r
.35262 .57399 m .34471 .58282 L .33045 .56637 L p F P
0 0 0 r
s
.575 .166 .076 r
.33045 .56637 m .33896 .55656 L .35262 .57399 L p F P
0 0 0 r
s
.083 .024 .01 r
.62699 .59224 m .63706 .58355 L .62077 .59808 L p F P
0 0 0 r
s
.83 .24 .1 r
.63038 .58725 m
.64229 .56871 L
s
.083 .024 .01 r
.62077 .59808 m .61201 .60564 L .62699 .59224 L p F P
0 0 0 r
s
.47 .135 .064 r
.34762 .54659 m .33896 .55656 L .32957 .53801 L p F P
0 0 0 r
s
.47 .135 .064 r
.32957 .53801 m .33865 .52728 L .34762 .54659 L p F P
0 0 0 r
s
.24 .35 .67 r
.79202 .5872 m
.79905 .55622 L
s
.79905 .55622 m
.76386 .5435 L
s
1 .315 .13 r
.57269 .63496 m .57968 .62891 L .56217 .63425 L p F P
0 0 0 r
s
1 .315 .13 r
.56217 .63425 m .55679 .63896 L .57269 .63496 L p F P
0 0 0 r
s
.152 .189 .336 r
.61254 .39553 m .63046 .40251 L .62081 .38925 L p F P
0 0 0 r
s
.152 .189 .336 r
.62081 .38925 m .60417 .38272 L .61254 .39553 L p F P
0 0 0 r
s
.24 .35 .67 r
.60404 .38267 m
.60448 .3832 L
s
.273 .073 .037 r
.70152 .47737 m .71472 .46548 L .71399 .48545 L p F P
0 0 0 r
s
.273 .073 .037 r
.71399 .48545 m .70084 .4971 L .70152 .47737 L p F P
0 0 0 r
s
.213 .34 .684 r
.47341 .65071 m .46457 .64806 L .47556 .64575 L p F P
0 0 0 r
s
.213 .34 .684 r
.47556 .64575 m .48164 .64759 L .47341 .65071 L p F P
0 0 0 r
s
.083 .024 .01 r
.37533 .4214 m .36544 .4337 L .37178 .4171 L p F P
0 0 0 r
s
.083 .024 .01 r
.37178 .4171 m .38126 .40523 L .37533 .4214 L p F P
0 0 0 r
s
.229 .31 .58 r
.69639 .45851 m .71472 .46548 L .71005 .44675 L p F P
0 0 0 r
s
.229 .31 .58 r
.71005 .44675 m .69209 .43982 L .69639 .45851 L p F P
0 0 0 r
s
.34 .095 .048 r
.3479 .51634 m .33865 .52728 L .33388 .5076 L p F P
0 0 0 r
s
.34 .095 .048 r
.33388 .5076 m .34336 .49614 L .3479 .51634 L p F P
0 0 0 r
s
.663 .193 .087 r
.36318 .59745 m .35619 .60502 L .33694 .59152 L p F P
0 0 0 r
s
.663 .193 .087 r
.33694 .59152 m .34471 .58282 L .36318 .59745 L p F P
0 0 0 r
s
.198 .262 .481 r
.65556 .42574 m .67393 .43282 L .66573 .41625 L p F P
0 0 0 r
s
.198 .262 .481 r
.66573 .41625 m .64819 .40942 L .65556 .42574 L p F P
0 0 0 r
s
.212 .061 .032 r
.35303 .48447 m .34336 .49614 L .34283 .47639 L p F P
0 0 0 r
s
.212 .061 .032 r
.34283 .47639 m .35252 .46448 L .35303 .48447 L p F P
0 0 0 r
s
.143 .041 .02 r
.36241 .45234 m .35252 .46448 L .35573 .44576 L p F P
0 0 0 r
s
.143 .041 .02 r
.35573 .44576 m .36544 .4337 L .36241 .45234 L p F P
0 0 0 r
s
.109 .123 .235 r
.55324 .36273 m .57039 .36946 L .56305 .36118 L p F P
0 0 0 r
s
.109 .123 .235 r
.56305 .36118 m .54767 .35511 L .55324 .36273 L p F P
0 0 0 r
s
1 .316 .128 r
.44348 .32861 m .43478 .33949 L .44391 .33784 L p F P
0 0 0 r
s
1 .316 .128 r
.44391 .33784 m .45145 .32848 L .44348 .32861 L p F P
0 0 0 r
s
.83 .24 .1 r
.43384 .35701 m
.45463 .33133 L
s
.24 .35 .67 r
.66083 .66734 m
.62402 .65584 L
s
.66083 .66734 m
.67862 .64722 L
s
.918 .277 .11 r
.41755 .35728 m .40821 .36898 L .41778 .36074 L p F P
0 0 0 r
s
.918 .277 .11 r
.41778 .36074 m .42622 .3502 L .41755 .35728 L p F P
0 0 0 r
s
.24 .35 .67 r
.71483 .65882 m
.67862 .64722 L
s
.71483 .65882 m
.7314 .63406 L
s
.944 .288 .117 r
.60336 .6131 m .61201 .60564 L .5939 .61659 L p F P
0 0 0 r
s
.83 .24 .1 r
.60625 .60812 m
.63038 .58725 L
s
.944 .288 .117 r
.5939 .61659 m .58675 .62278 L .60336 .6131 L p F P
0 0 0 r
s
.15 .249 .511 r
.40881 .63285 m .39713 .62935 L .41972 .63459 L p F P
0 0 0 r
s
.15 .249 .511 r
.41972 .63459 m .42879 .63731 L .40881 .63285 L p F P
0 0 0 r
s
.24 .35 .67 r
.34482 .28288 m
.33285 .29157 L
s
.33285 .29157 m
.29234 .27585 L
s
.83 .24 .1 r
.43498 .34175 m
.45463 .33133 L
s
.738 .216 .096 r
.37945 .61607 m .37353 .62227 L .3493 .61249 L p F P
0 0 0 r
s
.83 .24 .1 r
.34579 .62837 m
.35701 .61635 L
s
.738 .216 .096 r
.3493 .61249 m .35619 .60502 L .37945 .61607 L p F P
0 0 0 r
s
.83 .24 .1 r
.35701 .61635 m
.35752 .61581 L
s
.24 .35 .67 r
.33194 .60691 m
.35554 .61401 L
s
.35554 .61401 m
.35682 .61439 L
s
1 .322 .134 r
.54617 .64825 m .55146 .64362 L .53545 .64269 L p F P
0 0 0 r
s
1 .322 .134 r
.53545 .64269 m .53185 .64589 L .54617 .64825 L p F P
0 0 0 r
s
.213 .34 .684 r
.46457 .64806 m .4557 .64539 L .46946 .64391 L p F P
0 0 0 r
s
.213 .34 .684 r
.46946 .64391 m .47556 .64575 L .46457 .64806 L p F P
0 0 0 r
s
.24 .35 .67 r
.78111 .61761 m
.7456 .60554 L
s
.78111 .61761 m
.79202 .5872 L
s
.79202 .5872 m
.75663 .57479 L
s
.073 .085 .164 r
.4847 .3303 m .50066 .33659 L .50057 .33534 L p F P
0 0 0 r
s
.073 .085 .164 r
.50057 .33534 m .48685 .32993 L .4847 .3303 L p F P
0 0 0 r
s
.24 .35 .67 r
.47517 .32754 m
.51334 .34257 L
s
.76386 .5435 m
.76694 .5134 L
s
.76694 .5134 m
.73125 .50014 L
s
.259 .4 .793 r
.51767 .65847 m .51172 .65667 L .50604 .64528 L p F P
0 0 0 r
s
.24 .35 .67 r
.51081 .65639 m
.51153 .65629 L
s
.259 .4 .793 r
.50604 .64528 m .50912 .64622 L .51767 .65847 L p F P
0 0 0 r
s
1 .316 .133 r
.51767 .65847 m .52119 .65535 L .51091 .6446 L p F P
0 0 0 r
s
.83 .24 .1 r
.51691 .65737 m
.51707 .65722 L
s
.52085 .655 m
.52172 .65488 L
s
1 .316 .133 r
.51091 .6446 m .50912 .64622 L .51767 .65847 L p F P
0 0 0 r
s
.24 .35 .67 r
.71468 .46666 m
.73047 .47265 L
s
.73125 .50014 m
.73047 .47265 L
s
.83 .24 .1 r
.54751 .27368 m
.57441 .28017 L
s
.57441 .28017 m
.59841 .25242 L
s
.44175 .66428 m
.46174 .64542 L
s
.44175 .66428 m
.41387 .65022 L
s
.152 .189 .336 r
.59442 .38847 m .61254 .39553 L .60417 .38272 L p F P
0 0 0 r
s
.152 .189 .336 r
.60417 .38272 m .58736 .37612 L .59442 .38847 L p F P
0 0 0 r
s
.24 .35 .67 r
.15549 .53149 m
.156 .51155 L
s
.213 .34 .684 r
.4557 .64539 m .44677 .64271 L .46334 .64206 L p F P
0 0 0 r
s
.24 .35 .67 r
.45661 .645 m
.45734 .64522 L
s
.213 .34 .684 r
.46334 .64206 m .46946 .64391 L .4557 .64539 L p F P
0 0 0 r
s
.83 .24 .1 r
.46174 .64542 m
.46316 .64408 L
s
.15 .249 .511 r
.39713 .62935 m .38537 .62582 L .41061 .63186 L p F P
0 0 0 r
s
.15 .249 .511 r
.41061 .63186 m .41972 .63459 L .39713 .62935 L p F P
0 0 0 r
s
.24 .35 .67 r
.41117 .63073 m
.42265 .6348 L
s
.28402 .58485 m
.24282 .57238 L
s
.28402 .58485 m
.29097 .5946 L
s
1 .315 .13 r
.57968 .62891 m .58675 .62278 L .5676 .6295 L p F P
0 0 0 r
s
1 .315 .13 r
.5676 .6295 m .56217 .63425 L .57968 .62891 L p F P
0 0 0 r
s
.259 .4 .793 r
.51172 .65667 m .50575 .65487 L .50296 .64434 L p F P
0 0 0 r
s
.259 .4 .793 r
.50296 .64434 m .50604 .64528 L .51172 .65667 L p F P
0 0 0 r
s
.83 .24 .1 r
.50639 .65404 m
.50929 .6543 L
s
.229 .31 .58 r
.67784 .45146 m .69639 .45851 L .69209 .43982 L p F P
0 0 0 r
s
.24 .35 .67 r
.69071 .43929 m
.69098 .44073 L
s
.69411 .45764 m
.69435 .45894 L
s
.229 .31 .58 r
.69209 .43982 m .67393 .43282 L .67784 .45146 L p F P
0 0 0 r
s
.109 .123 .235 r
.53592 .35594 m .55324 .36273 L .54767 .35511 L p F P
0 0 0 r
s
.109 .123 .235 r
.54767 .35511 m .53214 .349 L .53592 .35594 L p F P
0 0 0 r
s
.198 .262 .481 r
.63699 .41858 m .65556 .42574 L .64819 .40942 L p F P
0 0 0 r
s
.198 .262 .481 r
.64819 .40942 m .63046 .40251 L .63699 .41858 L p F P
0 0 0 r
s
.083 .024 .01 r
.40076 .38082 m .39091 .39314 L .39904 .38049 L p F P
0 0 0 r
s
.083 .024 .01 r
.39904 .38049 m .40821 .36898 L .40076 .38082 L p F P
0 0 0 r
s
.83 .24 .1 r
.39888 .38334 m
.41427 .3676 L
s
1 .322 .134 r
.55146 .64362 m .55679 .63896 L .53907 .63948 L p F P
0 0 0 r
s
1 .322 .134 r
.53907 .63948 m .53545 .64269 L .55146 .64362 L p F P
0 0 0 r
s
1 .316 .133 r
.52119 .65535 m .52472 .65221 L .51271 .64297 L p F P
0 0 0 r
s
.83 .24 .1 r
.52026 .65438 m
.52043 .65424 L
s
1 .316 .133 r
.51271 .64297 m .51091 .6446 L .52119 .65535 L p F P
0 0 0 r
s
.83 .24 .1 r
.65279 .28052 m
.67809 .30052 L
s
.67809 .30052 m
.70422 .27308 L
s
.67809 .30052 m
.70094 .32355 L
s
.073 .085 .164 r
.46859 .32396 m .4847 .3303 L .48685 .32993 L p F P
0 0 0 r
s
.83 .24 .1 r
.47763 .32629 m
.47855 .32518 L
s
.073 .085 .164 r
.48685 .32993 m .47303 .32448 L .46859 .32396 L p F P
0 0 0 r
s
.83 .24 .1 r
.47855 .32518 m
.49931 .29996 L
s
.24 .35 .67 r
.46039 .32172 m
.47517 .32754 L
s
.259 .4 .793 r
.50575 .65487 m .49975 .65306 L .49987 .6434 L p F P
0 0 0 r
s
.24 .35 .67 r
.50479 .65301 m
.50529 .65316 L
s
.259 .4 .793 r
.49987 .6434 m .50296 .64434 L .50575 .65487 L p F P
0 0 0 r
s
.083 .024 .01 r
.66092 .55738 m .6724 .54742 L .65768 .56575 L p F P
0 0 0 r
s
.083 .024 .01 r
.65768 .56575 m .64729 .57472 L .66092 .55738 L p F P
0 0 0 r
s
.83 .24 .1 r
.64229 .56871 m
.66723 .54698 L
s
.083 .024 .01 r
.63706 .58355 m .64729 .57472 L .62966 .59041 L p F P
0 0 0 r
s
.083 .024 .01 r
.62966 .59041 m .62077 .59808 L .63706 .58355 L p F P
0 0 0 r
s
.83 .24 .1 r
.47624 .30464 m
.49931 .29996 L
s
.49931 .29996 m
.52192 .2725 L
s
.213 .34 .684 r
.44677 .64271 m .4378 .64002 L .45719 .64021 L p F P
0 0 0 r
s
.24 .35 .67 r
.42265 .6348 m
.44012 .64004 L
s
.44801 .64241 m
.44875 .64264 L
s
.213 .34 .684 r
.45719 .64021 m .46334 .64206 L .44677 .64271 L p F P
0 0 0 r
s
.24 .35 .67 r
.23911 .27481 m
.25091 .25977 L
s
.83 .24 .1 r
.72031 .42751 m
.74729 .40257 L
s
.72031 .42751 m
.72581 .45384 L
s
.70094 .32355 m
.72754 .29655 L
s
.70094 .32355 m
.72056 .34882 L
s
.084 .024 .01 r
.68255 .52817 m .69502 .51726 L .68409 .53729 L p F P
0 0 0 r
s
.084 .024 .01 r
.68409 .53729 m .6724 .54742 L .68255 .52817 L p F P
0 0 0 r
s
.663 .193 .087 r
.37026 .58977 m .36318 .59745 L .34471 .58282 L p F P
0 0 0 r
s
.663 .193 .087 r
.34471 .58282 m .35262 .57399 L .37026 .58977 L p F P
0 0 0 r
s
.575 .166 .076 r
.36064 .565 m .35262 .57399 L .33896 .55656 L p F P
0 0 0 r
s
.575 .166 .076 r
.33896 .55656 m .34762 .54659 L .36064 .565 L p F P
0 0 0 r
s
1 .316 .128 r
.45233 .31755 m .44348 .32861 L .45145 .32848 L p F P
0 0 0 r
s
1 .316 .128 r
.45145 .32848 m .45909 .31899 L .45233 .31755 L p F P
0 0 0 r
s
.24 .35 .67 r
.43614 .31217 m
.45172 .3183 L
s
.83 .24 .1 r
.45463 .33133 m
.46277 .32127 L
s
.15 .249 .511 r
.38537 .62582 m .37353 .62227 L .40146 .62911 L p F P
0 0 0 r
s
.15 .249 .511 r
.40146 .62911 m .41061 .63186 L .38537 .62582 L p F P
0 0 0 r
s
.83 .24 .1 r
.36812 .65126 m
.38785 .63104 L
s
.24 .35 .67 r
.39622 .29645 m
.38502 .29864 L
s
.38502 .29864 m
.34482 .28288 L
s
.944 .288 .117 r
.61201 .60564 m .62077 .59808 L .60113 .61032 L p F P
0 0 0 r
s
.944 .288 .117 r
.60113 .61032 m .5939 .61659 L .61201 .60564 L p F P
0 0 0 r
s
.47 .135 .064 r
.35643 .53644 m .34762 .54659 L .33865 .52728 L p F P
0 0 0 r
s
.47 .135 .064 r
.33865 .52728 m .3479 .51634 L .35643 .53644 L p F P
0 0 0 r
s
.161 .046 .023 r
.70084 .4971 m .71399 .48545 L .70773 .50613 L p F P
0 0 0 r
s
.161 .046 .023 r
.70773 .50613 m .69502 .51726 L .70084 .4971 L p F P
0 0 0 r
s
.83 .24 .1 r
.67345 .52494 m
.69913 .50225 L
s
.259 .4 .793 r
.49975 .65306 m .49373 .65124 L .49678 .64246 L p F P
0 0 0 r
s
.24 .35 .67 r
.49927 .65134 m
.49977 .65149 L
s
.259 .4 .793 r
.49678 .64246 m .49987 .6434 L .49975 .65306 L p F P
0 0 0 r
s
.83 .24 .1 r
.49181 .65271 m
.50639 .65404 L
s
.738 .216 .096 r
.38544 .60979 m .37945 .61607 L .35619 .60502 L p F P
0 0 0 r
s
.738 .216 .096 r
.35619 .60502 m .36318 .59745 L .38544 .60979 L p F P
0 0 0 r
s
.083 .024 .01 r
.38541 .40886 m .37533 .4214 L .38126 .40523 L p F P
0 0 0 r
s
.083 .024 .01 r
.38126 .40523 m .39091 .39314 L .38541 .40886 L p F P
0 0 0 r
s
.83 .24 .1 r
.39081 .39345 m
.39888 .38334 L
s
.918 .277 .11 r
.42705 .34536 m .41755 .35728 L .42622 .3502 L p F P
0 0 0 r
s
.918 .277 .11 r
.42622 .3502 m .43478 .33949 L .42705 .34536 L p F P
0 0 0 r
s
.24 .35 .67 r
.7314 .63406 m
.69509 .62209 L
s
.7314 .63406 m
.7456 .60554 L
s
.83 .24 .1 r
.62592 .26427 m
.65279 .28052 L
s
.65279 .28052 m
.67849 .25262 L
s
.24 .35 .67 r
.56888 .65894 m
.58637 .64408 L
s
.249 .344 .649 r
.69571 .47861 m .71399 .48545 L .71472 .46548 L p F P
0 0 0 r
s
.83 .24 .1 r
.69913 .50225 m
.69943 .48 L
s
.249 .344 .649 r
.71472 .46548 m .69639 .45851 L .69571 .47861 L p F P
0 0 0 r
s
.24 .35 .67 r
.69435 .45894 m
.69635 .45969 L
s
.83 .24 .1 r
.71344 .46499 m
.72581 .45384 L
s
.34 .095 .048 r
.35733 .5052 m .3479 .51634 L .34336 .49614 L p F P
0 0 0 r
s
.83 .24 .1 r
.3452 .49393 m
.34535 .49743 L
s
.34 .095 .048 r
.34336 .49614 m .35303 .48447 L .35733 .5052 L p F P
0 0 0 r
s
.24 .35 .67 r
.19786 .54448 m
.15549 .53149 L
s
.19786 .54448 m
.20068 .55963 L
s
.152 .189 .336 r
.57611 .38134 m .59442 .38847 L .58736 .37612 L p F P
0 0 0 r
s
.152 .189 .336 r
.58736 .37612 m .57039 .36946 L .57611 .38134 L p F P
0 0 0 r
s
1 .316 .133 r
.52472 .65221 m .52828 .64906 L .51452 .64133 L p F P
0 0 0 r
s
.83 .24 .1 r
.52364 .65138 m
.52381 .65124 L
s
1 .316 .133 r
.51452 .64133 m .51271 .64297 L .52472 .65221 L p F P
0 0 0 r
s
.24 .35 .67 r
.52032 .65276 m
.52204 .65185 L
s
.83 .24 .1 r
.38785 .63104 m
.41387 .65022 L
s
.213 .34 .684 r
.4378 .64002 m .42879 .63731 L .45102 .63835 L p F P
0 0 0 r
s
.213 .34 .684 r
.45102 .63835 m .45719 .64021 L .4378 .64002 L p F P
0 0 0 r
s
.109 .123 .235 r
.51842 .34907 m .53592 .35594 L .53214 .349 L p F P
0 0 0 r
s
.109 .123 .235 r
.53214 .349 m .51647 .34282 L .51842 .34907 L p F P
0 0 0 r
s
.24 .35 .67 r
.51334 .34257 m
.5169 .34419 L
s
.212 .061 .032 r
.36289 .47256 m .35303 .48447 L .35252 .46448 L p F P
0 0 0 r
s
.212 .061 .032 r
.35252 .46448 m .36241 .45234 L .36289 .47256 L p F P
0 0 0 r
s
.83 .24 .1 r
.36246 .45452 m
.36384 .45283 L
s
.143 .041 .02 r
.3725 .43995 m .36241 .45234 L .36544 .4337 L p F P
0 0 0 r
s
.83 .24 .1 r
.36384 .45283 m
.36442 .44987 L
s
.36726 .43531 m
.36826 .43019 L
s
.143 .041 .02 r
.36544 .4337 m .37533 .4214 L .3725 .43995 L p F P
0 0 0 r
s
.24 .35 .67 r
.75663 .57479 m
.76386 .5435 L
s
.76386 .5435 m
.72787 .53049 L
s
.259 .4 .793 r
.49373 .65124 m .4877 .64942 L .49368 .64152 L p F P
0 0 0 r
s
.24 .35 .67 r
.49373 .64966 m
.49423 .64981 L
s
.259 .4 .793 r
.49368 .64152 m .49678 .64246 L .49373 .65124 L p F P
0 0 0 r
s
.073 .085 .164 r
.45233 .31755 m .46859 .32396 L .47303 .32448 L p F P
0 0 0 r
s
.83 .24 .1 r
.46329 .32064 m
.46346 .32042 L
s
.073 .085 .164 r
.47303 .32448 m .45909 .31899 L .45233 .31755 L p F P
0 0 0 r
s
.83 .24 .1 r
.46346 .32042 m
.47624 .30464 L
s
1 .322 .134 r
.55679 .63896 m .56217 .63425 L .54272 .63625 L p F P
0 0 0 r
s
1 .322 .134 r
.54272 .63625 m .53907 .63948 L .55679 .63896 L p F P
0 0 0 r
s
.229 .31 .58 r
.65908 .44432 m .67784 .45146 L .67393 .43282 L p F P
0 0 0 r
s
.229 .31 .58 r
.67393 .43282 m .65556 .42574 L .65908 .44432 L p F P
0 0 0 r
s
1 .315 .13 r
.58675 .62278 m .5939 .61659 L .57308 .62471 L p F P
0 0 0 r
s
1 .315 .13 r
.57308 .62471 m .5676 .6295 L .58675 .62278 L p F P
0 0 0 r
s
.83 .24 .1 r
.72056 .34882 m
.74765 .32222 L
s
.72056 .34882 m
.73623 .37547 L
s
.198 .262 .481 r
.6182 .41134 m .63699 .41858 L .63046 .40251 L p F P
0 0 0 r
s
.198 .262 .481 r
.63046 .40251 m .61254 .39553 L .6182 .41134 L p F P
0 0 0 r
s
.805 .237 .104 r
.40619 .62431 m .40146 .62911 L .37353 .62227 L p F P
0 0 0 r
s
.805 .237 .104 r
.37353 .62227 m .37945 .61607 L .40619 .62431 L p F P
0 0 0 r
s
.24 .35 .67 r
.37971 .62171 m
.38019 .62189 L
s
.83 .24 .1 r
.38133 .62436 m
.38785 .63104 L
s
.38785 .63104 m
.3919 .62688 L
s
.259 .4 .793 r
.4877 .64942 m .48164 .64759 L .49058 .64057 L p F P
0 0 0 r
s
.24 .35 .67 r
.48817 .64798 m
.48867 .64813 L
s
.259 .4 .793 r
.49058 .64057 m .49368 .64152 L .4877 .64942 L p F P
0 0 0 r
s
.24 .35 .67 r
.33194 .60691 m
.29097 .5946 L
s
.33194 .60691 m
.34217 .61062 L
s
.62402 .65584 m
.58637 .64408 L
s
.62402 .65584 m
.64159 .63537 L
s
.213 .34 .684 r
.42879 .63731 m .41972 .63459 L .44484 .63648 L p F P
0 0 0 r
s
.24 .35 .67 r
.40197 .62858 m
.42265 .6348 L
s
.213 .34 .684 r
.44484 .63648 m .45102 .63835 L .42879 .63731 L p F P
0 0 0 r
s
.24 .35 .67 r
.67862 .64722 m
.64159 .63537 L
s
.67862 .64722 m
.69509 .62209 L
s
1 .316 .133 r
.52828 .64906 m .53185 .64589 L .51633 .63969 L p F P
0 0 0 r
s
.83 .24 .1 r
.52704 .64836 m
.5272 .64822 L
s
.24 .35 .67 r
.53072 .64725 m
.56888 .65894 L
s
1 .316 .133 r
.51633 .63969 m .51452 .64133 L .52828 .64906 L p F P
0 0 0 r
s
.24 .35 .67 r
.52204 .65185 m
.53072 .64725 L
s
.30371 .26677 m
.29234 .27585 L
s
.29234 .27585 m
.25091 .25977 L
s
.7456 .60554 m
.70929 .59319 L
s
.7456 .60554 m
.75663 .57479 L
s
.75663 .57479 m
.72043 .56209 L
s
.259 .4 .793 r
.48164 .64759 m .47556 .64575 L .48747 .63962 L p F P
0 0 0 r
s
.24 .35 .67 r
.47581 .64425 m
.4775 .64476 L
s
.48259 .64629 m
.48309 .64645 L
s
.47236 .64479 m
.47581 .64425 L
s
.259 .4 .793 r
.48747 .63962 m .49058 .64057 L .48164 .64759 L p F P
0 0 0 r
s
.83 .24 .1 r
.52192 .2725 m
.54751 .27368 L
s
.54751 .27368 m
.57123 .2455 L
s
.24 .35 .67 r
.72787 .53049 m
.73125 .50014 L
s
.152 .189 .336 r
.55759 .37413 m .57611 .38134 L .57039 .36946 L p F P
0 0 0 r
s
.24 .35 .67 r
.56672 .36802 m
.56843 .37018 L
s
.152 .189 .336 r
.57039 .36946 m .55324 .36273 L .55759 .37413 L p F P
0 0 0 r
s
.109 .123 .235 r
.50074 .34213 m .51842 .34907 L .51647 .34282 L p F P
0 0 0 r
s
.109 .123 .235 r
.51647 .34282 m .50066 .33659 L .50074 .34213 L p F P
0 0 0 r
s
.83 .24 .1 r
.59841 .25242 m
.62592 .26427 L
s
.62592 .26427 m
.65123 .23589 L
s
.083 .024 .01 r
.41079 .36827 m .40076 .38082 L .40821 .36898 L p F P
0 0 0 r
s
.083 .024 .01 r
.40821 .36898 m .41755 .35728 L .41079 .36827 L p F P
0 0 0 r
s
.83 .24 .1 r
.41427 .3676 m
.43498 .34175 L
s
.083 .024 .01 r
.64729 .57472 m .65768 .56575 L .63868 .58263 L p F P
0 0 0 r
s
.083 .024 .01 r
.63868 .58263 m .62966 .59041 L .64729 .57472 L p F P
0 0 0 r
s
.83 .24 .1 r
.63038 .58725 m
.65546 .56557 L
s
.213 .34 .684 r
.41972 .63459 m .41061 .63186 L .43863 .6346 L p F P
0 0 0 r
s
.24 .35 .67 r
.42265 .6348 m
.42377 .63459 L
s
.213 .34 .684 r
.43863 .6346 m .44484 .63648 L .41972 .63459 L p F P
0 0 0 r
s
.83 .24 .1 r
.41387 .65022 m
.42818 .63616 L
s
.249 .344 .649 r
.67723 .4717 m .69571 .47861 L .69639 .45851 L p F P
0 0 0 r
s
.249 .344 .649 r
.69639 .45851 m .67784 .45146 L .67723 .4717 L p F P
0 0 0 r
s
.944 .288 .117 r
.62077 .59808 m .62966 .59041 L .60845 .60398 L p F P
0 0 0 r
s
.83 .24 .1 r
.6163 .59896 m
.63038 .58725 L
s
.944 .288 .117 r
.60845 .60398 m .60113 .61032 L .62077 .59808 L p F P
0 0 0 r
s
1 .322 .134 r
.56217 .63425 m .5676 .6295 L .54638 .63299 L p F P
0 0 0 r
s
1 .322 .134 r
.54638 .63299 m .54272 .63625 L .56217 .63425 L p F P
0 0 0 r
s
1 .316 .133 r
.53185 .64589 m .53545 .64269 L .51815 .63805 L p F P
0 0 0 r
s
.83 .24 .1 r
.53045 .64533 m
.53062 .64518 L
s
1 .316 .133 r
.51815 .63805 m .51633 .63969 L .53185 .64589 L p F P
0 0 0 r
s
.663 .193 .087 r
.37745 .58198 m .37026 .58977 L .35262 .57399 L p F P
0 0 0 r
s
.663 .193 .087 r
.35262 .57399 m .36064 .565 L .37745 .58198 L p F P
0 0 0 r
s
.259 .4 .793 r
.47556 .64575 m .46946 .64391 L .48435 .63867 L p F P
0 0 0 r
s
.259 .4 .793 r
.48435 .63867 m .48747 .63962 L .47556 .64575 L p F P
0 0 0 r
s
.83 .24 .1 r
.46316 .64408 m
.49181 .65271 L
s
.083 .024 .01 r
.6724 .54742 m .68409 .53729 L .66824 .55664 L p F P
0 0 0 r
s
.083 .024 .01 r
.66824 .55664 m .65768 .56575 L .6724 .54742 L p F P
0 0 0 r
s
.83 .24 .1 r
.65546 .56557 m
.66723 .54698 L
s
.24 .35 .67 r
.44609 .31682 m
.43614 .31217 L
s
.43614 .31217 m
.39622 .29645 L
s
.738 .216 .096 r
.39149 .60345 m .38544 .60979 L .36318 .59745 L p F P
0 0 0 r
s
.738 .216 .096 r
.36318 .59745 m .37026 .58977 L .39149 .60345 L p F P
0 0 0 r
s
.24 .35 .67 r
.24282 .57238 m
.20068 .55963 L
s
.24282 .57238 m
.24907 .582 L
s
.575 .166 .076 r
.3688 .55588 m .36064 .565 L .34762 .54659 L p F P
0 0 0 r
s
.575 .166 .076 r
.34762 .54659 m .35643 .53644 L .3688 .55588 L p F P
0 0 0 r
s
.229 .31 .58 r
.6401 .43711 m .65908 .44432 L .65556 .42574 L p F P
0 0 0 r
s
.24 .35 .67 r
.65416 .4252 m
.65439 .4266 L
s
.6572 .44361 m
.65742 .44491 L
s
.229 .31 .58 r
.65556 .42574 m .63699 .41858 L .6401 .43711 L p F P
0 0 0 r
s
.198 .262 .481 r
.5992 .40402 m .6182 .41134 L .61254 .39553 L p F P
0 0 0 r
s
.24 .35 .67 r
.61171 .39521 m
.61197 .39589 L
s
.198 .262 .481 r
.61254 .39553 m .59442 .38847 L .5992 .40402 L p F P
0 0 0 r
s
1 .315 .13 r
.5939 .61659 m .60113 .61032 L .57861 .61987 L p F P
0 0 0 r
s
1 .315 .13 r
.57861 .61987 m .57308 .62471 L .5939 .61659 L p F P
0 0 0 r
s
.084 .024 .01 r
.69502 .51726 m .70773 .50613 L .69598 .52697 L p F P
0 0 0 r
s
.084 .024 .01 r
.69598 .52697 m .68409 .53729 L .69502 .51726 L p F P
0 0 0 r
s
.918 .277 .11 r
.43673 .33323 m .42705 .34536 L .43478 .33949 L p F P
0 0 0 r
s
.918 .277 .11 r
.43478 .33949 m .44348 .32861 L .43673 .33323 L p F P
0 0 0 r
s
.805 .237 .104 r
.41096 .61947 m .40619 .62431 L .37945 .61607 L p F P
0 0 0 r
s
.24 .35 .67 r
.38287 .62284 m
.39093 .62527 L
s
.38019 .62189 m
.38287 .62284 L
s
.805 .237 .104 r
.37945 .61607 m .38544 .60979 L .41096 .61947 L p F P
0 0 0 r
s
.259 .4 .793 r
.46946 .64391 m .46334 .64206 L .48123 .63772 L p F P
0 0 0 r
s
.24 .35 .67 r
.47138 .6429 m
.47189 .64306 L
s
.259 .4 .793 r
.48123 .63772 m .48435 .63867 L .46946 .64391 L p F P
0 0 0 r
s
.213 .34 .684 r
.41061 .63186 m .40146 .62911 L .43239 .63272 L p F P
0 0 0 r
s
.213 .34 .684 r
.43239 .63272 m .43863 .6346 L .41061 .63186 L p F P
0 0 0 r
s
.83 .24 .1 r
.42818 .63616 m
.43114 .63326 L
s
.73623 .37547 m
.7638 .34922 L
s
.73623 .37547 m
.74729 .40257 L
s
.47 .135 .064 r
.3654 .52611 m .35643 .53644 L .3479 .51634 L p F P
0 0 0 r
s
.83 .24 .1 r
.34876 .51533 m
.34922 .51708 L
s
.47 .135 .064 r
.3479 .51634 m .35733 .5052 L .3654 .52611 L p F P
0 0 0 r
s
.263 .368 .699 r
.68996 .49961 m .70773 .50613 L .71399 .48545 L p F P
0 0 0 r
s
.263 .368 .699 r
.71399 .48545 m .69571 .47861 L .68996 .49961 L p F P
0 0 0 r
s
.83 .24 .1 r
.71176 .49108 m
.72582 .47866 L
s
.71101 .49175 m
.71176 .49108 L
s
.24 .35 .67 r
.71173 .4929 m
.7123 .49311 L
s
.7123 .49311 m
.73125 .50014 L
s
.69463 .47821 m
.69469 .48235 L
s
.083 .024 .01 r
.3957 .39608 m .38541 .40886 L .39091 .39314 L p F P
0 0 0 r
s
.083 .024 .01 r
.39091 .39314 m .40076 .38082 L .3957 .39608 L p F P
0 0 0 r
s
1 .316 .133 r
.53545 .64269 m .53907 .63948 L .51998 .6364 L p F P
0 0 0 r
s
.83 .24 .1 r
.53389 .64227 m
.53406 .64212 L
s
1 .316 .133 r
.51998 .6364 m .51815 .63805 L .53545 .64269 L p F P
0 0 0 r
s
.83 .24 .1 r
.72581 .45384 m
.75321 .42913 L
s
.72581 .45384 m
.72582 .47866 L
s
.34 .095 .048 r
.36694 .49384 m .35733 .5052 L .35303 .48447 L p F P
0 0 0 r
s
.34 .095 .048 r
.35303 .48447 m .36289 .47256 L .36694 .49384 L p F P
0 0 0 r
s
.259 .4 .793 r
.46334 .64206 m .45719 .64021 L .47811 .63677 L p F P
0 0 0 r
s
.24 .35 .67 r
.46574 .6412 m
.46626 .64136 L
s
.259 .4 .793 r
.47811 .63677 m .48123 .63772 L .46334 .64206 L p F P
0 0 0 r
s
.109 .123 .235 r
.48287 .33512 m .50074 .34213 L .50066 .33659 L p F P
0 0 0 r
s
.109 .123 .235 r
.50066 .33659 m .4847 .3303 L .48287 .33512 L p F P
0 0 0 r
s
.24 .35 .67 r
.47517 .32754 m
.48417 .3317 L
s
.35538 .28037 m
.34482 .28288 L
s
.34482 .28288 m
.30371 .26677 L
s
.152 .189 .336 r
.53887 .36683 m .55759 .37413 L .55324 .36273 L p F P
0 0 0 r
s
.152 .189 .336 r
.55324 .36273 m .53592 .35594 L .53887 .36683 L p F P
0 0 0 r
s
.24 .35 .67 r
.34217 .61062 m
.38287 .62284 L
s
.38287 .62284 m
.396 .62012 L
s
1 .322 .134 r
.5676 .6295 m .57308 .62471 L .55007 .62972 L p F P
0 0 0 r
s
1 .322 .134 r
.55007 .62972 m .54638 .63299 L .5676 .6295 L p F P
0 0 0 r
s
.143 .041 .02 r
.38279 .42731 m .3725 .43995 L .37533 .4214 L p F P
0 0 0 r
s
.143 .041 .02 r
.37533 .4214 m .38541 .40886 L .38279 .42731 L p F P
0 0 0 r
s
.212 .061 .032 r
.37294 .46042 m .36289 .47256 L .36241 .45234 L p F P
0 0 0 r
s
.83 .24 .1 r
.36384 .45283 m
.36388 .45346 L
s
.212 .061 .032 r
.36241 .45234 m .3725 .43995 L .37294 .46042 L p F P
0 0 0 r
s
.866 .256 .112 r
.43573 .62945 m .43239 .63272 L .40146 .62911 L p F P
0 0 0 r
s
.866 .256 .112 r
.40146 .62911 m .40619 .62431 L .43573 .62945 L p F P
0 0 0 r
s
.24 .35 .67 r
.69509 .62209 m
.65794 .60985 L
s
.69509 .62209 m
.70929 .59319 L
s
.51516 .64249 m
.53072 .64725 L
s
.15757 .54658 m
.15549 .53149 L
s
.249 .344 .649 r
.65853 .46471 m .67723 .4717 L .67784 .45146 L p F P
0 0 0 r
s
.249 .344 .649 r
.67784 .45146 m .65908 .44432 L .65853 .46471 L p F P
0 0 0 r
s
.24 .35 .67 r
.65742 .44491 m
.65905 .44553 L
s
.259 .4 .793 r
.45719 .64021 m .45102 .63835 L .47497 .63582 L p F P
0 0 0 r
s
.24 .35 .67 r
.46009 .63949 m
.46061 .63965 L
s
.259 .4 .793 r
.47497 .63582 m .47811 .63677 L .45719 .64021 L p F P
0 0 0 r
s
.83 .24 .1 r
.45652 .31487 m
.47624 .30464 L
s
.47624 .30464 m
.49871 .27689 L
s
.24 .35 .67 r
.72043 .56209 m
.72787 .53049 L
s
1 .316 .133 r
.53907 .63948 m .54272 .63625 L .52181 .63474 L p F P
0 0 0 r
s
.83 .24 .1 r
.53735 .6392 m
.53751 .63905 L
s
.54082 .63611 m
.54227 .63482 L
s
.54227 .63482 m
.54468 .6345 L
s
1 .316 .133 r
.52181 .63474 m .51998 .6364 L .53907 .63948 L p F P
0 0 0 r
s
.198 .262 .481 r
.57998 .39661 m .5992 .40402 L .59442 .38847 L p F P
0 0 0 r
s
.198 .262 .481 r
.59442 .38847 m .57611 .38134 L .57998 .39661 L p F P
0 0 0 r
s
.229 .31 .58 r
.62091 .42981 m .6401 .43711 L .63699 .41858 L p F P
0 0 0 r
s
.229 .31 .58 r
.63699 .41858 m .6182 .41134 L .62091 .42981 L p F P
0 0 0 r
s
.944 .288 .117 r
.62966 .59041 m .63868 .58263 L .61586 .59756 L p F P
0 0 0 r
s
.944 .288 .117 r
.61586 .59756 m .60845 .60398 L .62966 .59041 L p F P
0 0 0 r
s
1 .304 .13 r
.5 .62969 m .50912 .64622 L .51091 .6446 L closepath p F P
0 0 0 r
s
.282 .427 .841 r
.5 .62969 m .50912 .64622 L .50604 .64528 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.49181 .65271 m
.49867 .64645 L
s
1 .315 .13 r
.60113 .61032 m .60845 .60398 L .58419 .61499 L p F P
0 0 0 r
s
1 .315 .13 r
.58419 .61499 m .57861 .61987 L .60113 .61032 L p F P
0 0 0 r
s
.738 .216 .096 r
.39762 .59702 m .39149 .60345 L .37026 .58977 L p F P
0 0 0 r
s
.738 .216 .096 r
.37026 .58977 m .37745 .58198 L .39762 .59702 L p F P
0 0 0 r
s
.259 .4 .793 r
.45102 .63835 m .44484 .63648 L .47184 .63486 L p F P
0 0 0 r
s
.24 .35 .67 r
.45442 .63778 m
.45494 .63793 L
s
.259 .4 .793 r
.47184 .63486 m .47497 .63582 L .45102 .63835 L p F P
0 0 0 r
s
.083 .024 .01 r
.65768 .56575 m .66824 .55664 L .64782 .57475 L p F P
0 0 0 r
s
.083 .024 .01 r
.64782 .57475 m .63868 .58263 L .65768 .56575 L p F P
0 0 0 r
s
.805 .237 .104 r
.41578 .61459 m .41096 .61947 L .38544 .60979 L p F P
0 0 0 r
s
.805 .237 .104 r
.38544 .60979 m .39149 .60345 L .41578 .61459 L p F P
0 0 0 r
s
.83 .24 .1 r
.57123 .2455 m
.59841 .25242 L
s
.59841 .25242 m
.62337 .22356 L
s
.282 .427 .841 r
.5 .62969 m .50604 .64528 L .50296 .64434 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.49867 .64645 m
.50078 .64452 L
s
.24 .35 .67 r
.29097 .5946 m
.24907 .582 L
s
.29097 .5946 m
.30054 .59811 L
s
.663 .193 .087 r
.38473 .57409 m .37745 .58198 L .36064 .565 L p F P
0 0 0 r
s
.663 .193 .087 r
.36064 .565 m .3688 .55588 L .38473 .57409 L p F P
0 0 0 r
s
.24 .35 .67 r
.58637 .64408 m
.6037 .62323 L
s
.083 .024 .01 r
.42101 .35547 m .41079 .36827 L .41755 .35728 L p F P
0 0 0 r
s
.083 .024 .01 r
.41755 .35728 m .42705 .34536 L .42101 .35547 L p F P
0 0 0 r
s
.83 .24 .1 r
.4196 .35742 m
.43498 .34175 L
s
1 .304 .13 r
.5 .62969 m .51091 .6446 L .51271 .64297 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.64159 .63537 m
.6037 .62323 L
s
.64159 .63537 m
.65794 .60985 L
s
.109 .123 .235 r
.46482 .32804 m .48287 .33512 L .4847 .3303 L p F P
0 0 0 r
s
.109 .123 .235 r
.4847 .3303 m .46859 .32396 L .46482 .32804 L p F P
0 0 0 r
s
.24 .35 .67 r
.25091 .25977 m
.26164 .25029 L
s
.263 .368 .699 r
.67199 .49302 m .68996 .49961 L .69571 .47861 L p F P
0 0 0 r
s
.263 .368 .699 r
.69571 .47861 m .67723 .4717 L .67199 .49302 L p F P
0 0 0 r
s
.282 .427 .841 r
.5 .62969 m .50296 .64434 L .49987 .6434 L closepath p F P
0 0 0 r
s
1 .322 .134 r
.57308 .62471 m .57861 .61987 L .55378 .62643 L p F P
0 0 0 r
s
1 .322 .134 r
.55378 .62643 m .55007 .62972 L .57308 .62471 L p F P
0 0 0 r
s
.259 .4 .793 r
.44484 .63648 m .43863 .6346 L .46869 .6339 L p F P
0 0 0 r
s
.24 .35 .67 r
.44873 .63606 m
.44925 .63621 L
s
.259 .4 .793 r
.46869 .6339 m .47184 .63486 L .44484 .63648 L p F P
0 0 0 r
s
.83 .24 .1 r
.46316 .64408 m
.47198 .63575 L
s
.44827 .63648 m
.46316 .64408 L
s
.44527 .63495 m
.44827 .63648 L
s
.083 .024 .01 r
.68409 .53729 m .69598 .52697 L .67897 .54738 L p F P
0 0 0 r
s
.083 .024 .01 r
.67897 .54738 m .66824 .55664 L .68409 .53729 L p F P
0 0 0 r
s
.866 .256 .112 r
.43909 .62615 m .43573 .62945 L .40619 .62431 L p F P
0 0 0 r
s
.866 .256 .112 r
.40619 .62431 m .41096 .61947 L .43909 .62615 L p F P
0 0 0 r
s
.152 .189 .336 r
.51994 .35946 m .53887 .36683 L .53592 .35594 L p F P
0 0 0 r
s
.152 .189 .336 r
.53592 .35594 m .51842 .34907 L .51994 .35946 L p F P
0 0 0 r
s
1 .316 .133 r
.54272 .63625 m .54638 .63299 L .52364 .63308 L p F P
0 0 0 r
s
1 .316 .133 r
.52364 .63308 m .52181 .63474 L .54272 .63625 L p F P
0 0 0 r
s
.24 .35 .67 r
.70929 .59319 m
.67215 .58056 L
s
.70929 .59319 m
.72043 .56209 L
s
.282 .427 .841 r
.5 .62969 m .49987 .6434 L .49678 .64246 L closepath p F P
0 0 0 r
s
.918 .277 .11 r
.44658 .32088 m .43673 .33323 L .44348 .32861 L p F P
0 0 0 r
s
.918 .277 .11 r
.44348 .32861 m .45233 .31755 L .44658 .32088 L p F P
0 0 0 r
s
.24 .35 .67 r
.6834 .54909 m
.72043 .56209 L
s
.575 .166 .076 r
.3771 .5466 m .3688 .55588 L .35643 .53644 L p F P
0 0 0 r
s
.575 .166 .076 r
.35643 .53644 m .3654 .52611 L .3771 .5466 L p F P
0 0 0 r
s
1 .304 .13 r
.5 .62969 m .51271 .64297 L .51452 .64133 L closepath p F P
0 0 0 r
s
.282 .427 .841 r
.5 .62969 m .49678 .64246 L .49368 .64152 L closepath p F P
0 0 0 r
s
.259 .4 .793 r
.43863 .6346 m .43239 .63272 L .46554 .63294 L p F P
0 0 0 r
s
.24 .35 .67 r
.43636 .63232 m
.43782 .63276 L
s
.44303 .63433 m
.44355 .63449 L
s
.43405 .63273 m
.43636 .63232 L
s
.259 .4 .793 r
.46554 .63294 m .46869 .6339 L .43863 .6346 L p F P
0 0 0 r
s
.83 .24 .1 r
.67849 .25262 m
.70422 .27308 L
s
.70422 .27308 m
.73139 .24454 L
s
.70422 .27308 m
.72754 .29655 L
s
.274 .386 .737 r
.67916 .52093 m .69598 .52697 L .70773 .50613 L p F P
0 0 0 r
s
.83 .24 .1 r
.66723 .54698 m
.69189 .5255 L
s
.69651 .51194 m
.69895 .50291 L
s
.274 .386 .737 r
.70773 .50613 m .68996 .49961 L .67916 .52093 L p F P
0 0 0 r
s
.24 .35 .67 r
.69973 .52032 m
.72787 .53049 L
s
.249 .344 .649 r
.63962 .45764 m .65853 .46471 L .65908 .44432 L p F P
0 0 0 r
s
.24 .35 .67 r
.65742 .44546 m
.65742 .44491 L
s
.249 .344 .649 r
.65908 .44432 m .6401 .43711 L .63962 .45764 L p F P
0 0 0 r
s
.24 .35 .67 r
.42381 .62852 m
.42942 .63022 L
s
.43364 .6315 m
.43636 .63232 L
s
.282 .427 .841 r
.5 .62969 m .49368 .64152 L .49058 .64057 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.49871 .27689 m
.52192 .2725 L
s
.52192 .2725 m
.54544 .24394 L
s
.70067 .51785 m
.72012 .50091 L
s
.69913 .51919 m
.70067 .51785 L
s
1 .304 .13 r
.5 .62969 m .51452 .64133 L .51633 .63969 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.74729 .40257 m
.77535 .37662 L
s
.74729 .40257 m
.75321 .42913 L
s
.72754 .29655 m
.7552 .26846 L
s
.72754 .29655 m
.74765 .32222 L
s
.24 .35 .67 r
.40551 .30085 m
.39622 .29645 L
s
.39622 .29645 m
.35538 .28037 L
s
.47 .135 .064 r
.37454 .51559 m .3654 .52611 L .35733 .5052 L p F P
0 0 0 r
s
.47 .135 .064 r
.35733 .5052 m .36694 .49384 L .37454 .51559 L p F P
0 0 0 r
s
.24 .35 .67 r
.20068 .55963 m
.15757 .54658 L
s
.20068 .55963 m
.20619 .56911 L
s
.198 .262 .481 r
.56054 .38912 m .57998 .39661 L .57611 .38134 L p F P
0 0 0 r
s
.24 .35 .67 r
.5739 .38048 m
.57449 .38215 L
s
.198 .262 .481 r
.57611 .38134 m .55759 .37413 L .56054 .38912 L p F P
0 0 0 r
s
.282 .427 .841 r
.5 .62969 m .49058 .64057 L .48747 .63962 L closepath p F P
0 0 0 r
s
.083 .024 .01 r
.4062 .38303 m .3957 .39608 L .40076 .38082 L p F P
0 0 0 r
s
.083 .024 .01 r
.40076 .38082 m .41079 .36827 L .4062 .38303 L p F P
0 0 0 r
s
.83 .24 .1 r
.4107 .36856 m
.4196 .35742 L
s
.229 .31 .58 r
.60148 .42243 m .62091 .42981 L .6182 .41134 L p F P
0 0 0 r
s
.24 .35 .67 r
.61678 .41079 m
.61697 .41216 L
s
.61944 .42925 m
.61963 .43055 L
s
.229 .31 .58 r
.6182 .41134 m .5992 .40402 L .60148 .42243 L p F P
0 0 0 r
s
1 .316 .133 r
.54638 .63299 m .55007 .62972 L .52548 .63142 L p F P
0 0 0 r
s
.83 .24 .1 r
.54432 .633 m
.54449 .63285 L
s
.24 .35 .67 r
.54785 .63205 m
.58637 .64408 L
s
1 .316 .133 r
.52548 .63142 m .52364 .63308 L .54638 .63299 L p F P
0 0 0 r
s
.24 .35 .67 r
.53072 .64725 m
.54785 .63205 L
s
.922 .273 .118 r
.46729 .63128 m .46554 .63294 L .43239 .63272 L p F P
0 0 0 r
s
.922 .273 .118 r
.43239 .63272 m .43573 .62945 L .46729 .63128 L p F P
0 0 0 r
s
1 .315 .13 r
.60845 .60398 m .61586 .59756 L .58982 .61007 L p F P
0 0 0 r
s
1 .315 .13 r
.58982 .61007 m .58419 .61499 L .60845 .60398 L p F P
0 0 0 r
s
1 .304 .13 r
.5 .62969 m .51633 .63969 L .51815 .63805 L closepath p F P
0 0 0 r
s
.282 .427 .841 r
.5 .62969 m .48747 .63962 L .48435 .63867 L closepath p F P
0 0 0 r
s
.109 .123 .235 r
.44658 .32088 m .46482 .32804 L .46859 .32396 L p F P
0 0 0 r
s
.109 .123 .235 r
.46859 .32396 m .45233 .31755 L .44658 .32088 L p F P
0 0 0 r
s
.83 .24 .1 r
.43498 .34175 m
.45048 .32241 L
s
.45373 .31834 m
.45384 .31821 L
s
.24 .35 .67 r
.44609 .31682 m
.45055 .31857 L
s
.83 .24 .1 r
.45384 .31821 m
.45652 .31487 L
s
1 .322 .134 r
.57861 .61987 m .58419 .61499 L .55752 .62311 L p F P
0 0 0 r
s
1 .322 .134 r
.55752 .62311 m .55378 .62643 L .57861 .61987 L p F P
0 0 0 r
s
.805 .237 .104 r
.42064 .60966 m .41578 .61459 L .39149 .60345 L p F P
0 0 0 r
s
.805 .237 .104 r
.39149 .60345 m .39762 .59702 L .42064 .60966 L p F P
0 0 0 r
s
.83 .24 .1 r
.65123 .23589 m
.67849 .25262 L
s
.67849 .25262 m
.70522 .22359 L
s
.34 .095 .048 r
.37673 .48227 m .36694 .49384 L .36289 .47256 L p F P
0 0 0 r
s
.83 .24 .1 r
.36477 .47029 m
.36497 .47402 L
s
.34 .095 .048 r
.36289 .47256 m .37294 .46042 L .37673 .48227 L p F P
0 0 0 r
s
.944 .288 .117 r
.63868 .58263 m .64782 .57475 L .62335 .59106 L p F P
0 0 0 r
s
.944 .288 .117 r
.62335 .59106 m .61586 .59756 L .63868 .58263 L p F P
0 0 0 r
s
.866 .256 .112 r
.44247 .62284 m .43909 .62615 L .41096 .61947 L p F P
0 0 0 r
s
.866 .256 .112 r
.41096 .61947 m .41578 .61459 L .44247 .62284 L p F P
0 0 0 r
s
.282 .427 .841 r
.5 .62969 m .48435 .63867 L .48123 .63772 L closepath p F P
0 0 0 r
s
.263 .368 .699 r
.65381 .48636 m .67199 .49302 L .67723 .4717 L p F P
0 0 0 r
s
.263 .368 .699 r
.67723 .4717 m .65853 .46471 L .65381 .48636 L p F P
0 0 0 r
s
.143 .041 .02 r
.39329 .41442 m .38279 .42731 L .38541 .40886 L p F P
0 0 0 r
s
.83 .24 .1 r
.38403 .42808 m
.38459 .4251 L
s
.38736 .41024 m
.38828 .4053 L
s
.143 .041 .02 r
.38541 .40886 m .3957 .39608 L .39329 .41442 L p F P
0 0 0 r
s
.738 .216 .096 r
.40382 .59052 m .39762 .59702 L .37745 .58198 L p F P
0 0 0 r
s
.738 .216 .096 r
.37745 .58198 m .38473 .57409 L .40382 .59052 L p F P
0 0 0 r
s
.152 .189 .336 r
.5008 .352 m .51994 .35946 L .51842 .34907 L p F P
0 0 0 r
s
.152 .189 .336 r
.51842 .34907 m .50074 .34213 L .5008 .352 L p F P
0 0 0 r
s
.212 .061 .032 r
.3832 .44803 m .37294 .46042 L .3725 .43995 L p F P
0 0 0 r
s
.212 .061 .032 r
.3725 .43995 m .38279 .42731 L .3832 .44803 L p F P
0 0 0 r
s
.83 .24 .1 r
.38283 .42955 m
.38403 .42808 L
s
1 .304 .13 r
.5 .62969 m .51815 .63805 L .51998 .6364 L closepath p F P
0 0 0 r
s
.282 .427 .841 r
.5 .62969 m .48123 .63772 L .47811 .63677 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.74765 .32222 m
.77582 .29455 L
s
.74765 .32222 m
.7638 .34922 L
s
.24 .35 .67 r
.31359 .26392 m
.30371 .26677 L
s
.30371 .26677 m
.26164 .25029 L
s
1 .316 .133 r
.55007 .62972 m .55378 .62643 L .52733 .62975 L p F P
0 0 0 r
s
.83 .24 .1 r
.54784 .62988 m
.54801 .62972 L
s
1 .316 .133 r
.52733 .62975 m .52548 .63142 L .55007 .62972 L p F P
0 0 0 r
s
.083 .024 .01 r
.66824 .55664 m .67897 .54738 L .65709 .56675 L p F P
0 0 0 r
s
.083 .024 .01 r
.65709 .56675 m .64782 .57475 L .66824 .55664 L p F P
0 0 0 r
s
.922 .273 .118 r
.46905 .62961 m .46729 .63128 L .43573 .62945 L p F P
0 0 0 r
s
.922 .273 .118 r
.43573 .62945 m .43909 .62615 L .46905 .62961 L p F P
0 0 0 r
s
.24 .35 .67 r
.34217 .61062 m
.30054 .59811 L
s
.34217 .61062 m
.35469 .60763 L
s
.282 .427 .841 r
.5 .62969 m .47811 .63677 L .47497 .63582 L closepath p F P
0 0 0 r
s
1 .304 .13 r
.5 .62969 m .51998 .6364 L .52181 .63474 L closepath p F P
0 0 0 r
s
.663 .193 .087 r
.39213 .56608 m .38473 .57409 L .3688 .55588 L p F P
0 0 0 r
s
.663 .193 .087 r
.3688 .55588 m .3771 .5466 L .39213 .56608 L p F P
0 0 0 r
s
.24 .35 .67 r
.65794 .60985 m
.67215 .58056 L
s
.274 .386 .737 r
.66216 .51483 m .67916 .52093 L .68996 .49961 L p F P
0 0 0 r
s
.274 .386 .737 r
.68996 .49961 m .67199 .49302 L .66216 .51483 L p F P
0 0 0 r
s
.282 .427 .841 r
.5 .62969 m .47497 .63582 L .47184 .63486 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.72582 .47866 m
.7536 .45411 L
s
.72582 .47866 m
.72012 .50091 L
s
.249 .344 .649 r
.62048 .45048 m .63962 .45764 L .6401 .43711 L p F P
0 0 0 r
s
.249 .344 .649 r
.6401 .43711 m .62091 .42981 L .62048 .45048 L p F P
0 0 0 r
s
.24 .35 .67 r
.61963 .43055 m
.62088 .43103 L
s
.083 .024 .01 r
.43143 .34243 m .42101 .35547 L .42705 .34536 L p F P
0 0 0 r
s
.083 .024 .01 r
.42705 .34536 m .43673 .33323 L .43143 .34243 L p F P
0 0 0 r
s
.198 .262 .481 r
.54087 .38154 m .56054 .38912 L .55759 .37413 L p F P
0 0 0 r
s
.198 .262 .481 r
.55759 .37413 m .53887 .36683 L .54087 .38154 L p F P
0 0 0 r
s
.282 .427 .841 r
.5 .62969 m .47184 .63486 L .46869 .6339 L closepath p F P
0 0 0 r
s
1 .304 .13 r
.5 .62969 m .52181 .63474 L .52364 .63308 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.52087 .63268 m
.52376 .63297 L
s
1 .322 .134 r
.58419 .61499 m .58982 .61007 L .56128 .61978 L p F P
0 0 0 r
s
1 .322 .134 r
.56128 .61978 m .55752 .62311 L .58419 .61499 L p F P
0 0 0 r
s
.282 .401 .768 r
.66353 .54196 m .67897 .54738 L .69598 .52697 L p F P
0 0 0 r
s
.24 .35 .67 r
.6834 .54909 m
.68449 .54455 L
s
.83 .24 .1 r
.65546 .56557 m
.67721 .54676 L
s
.68975 .52985 m
.69236 .52567 L
s
.282 .401 .768 r
.69598 .52697 m .67916 .52093 L .66353 .54196 L p F P
0 0 0 r
s
.83 .24 .1 r
.68154 .54301 m
.68321 .54033 L
s
.68321 .54033 m
.68538 .53686 L
s
.24 .35 .67 r
.68449 .54455 m
.68576 .53923 L
s
.229 .31 .58 r
.58183 .41496 m .60148 .42243 L .5992 .40402 L p F P
0 0 0 r
s
.229 .31 .58 r
.5992 .40402 m .57998 .39661 L .58183 .41496 L p F P
0 0 0 r
s
.866 .256 .112 r
.44587 .6195 m .44247 .62284 L .41578 .61459 L p F P
0 0 0 r
s
.24 .35 .67 r
.396 .62012 m
.42381 .62852 L
s
.866 .256 .112 r
.41578 .61459 m .42064 .60966 L .44587 .6195 L p F P
0 0 0 r
s
.83 .24 .1 r
.54544 .24394 m
.57123 .2455 L
s
.57123 .2455 m
.59592 .21618 L
s
.282 .427 .841 r
.5 .62969 m .46869 .6339 L .46554 .63294 L closepath p F P
0 0 0 r
s
1 .316 .133 r
.55378 .62643 m .55752 .62311 L .52918 .62807 L p F P
0 0 0 r
s
.83 .24 .1 r
.55138 .62673 m
.55155 .62658 L
s
1 .316 .133 r
.52918 .62807 m .52733 .62975 L .55378 .62643 L p F P
0 0 0 r
s
.575 .166 .076 r
.38552 .53717 m .3771 .5466 L .3654 .52611 L p F P
0 0 0 r
s
.575 .166 .076 r
.3654 .52611 m .37454 .51559 L .38552 .53717 L p F P
0 0 0 r
s
1 .315 .13 r
.61586 .59756 m .62335 .59106 L .5955 .6051 L p F P
0 0 0 r
s
1 .315 .13 r
.5955 .6051 m .58982 .61007 L .61586 .59756 L p F P
0 0 0 r
s
.922 .273 .118 r
.47081 .62793 m .46905 .62961 L .43909 .62615 L p F P
0 0 0 r
s
.24 .35 .67 r
.44194 .62896 m
.44357 .62798 L
s
.922 .273 .118 r
.43909 .62615 m .44247 .62284 L .47081 .62793 L p F P
0 0 0 r
s
.83 .24 .1 r
.62337 .22356 m
.65123 .23589 L
s
.65123 .23589 m
.67756 .20636 L
s
.24 .35 .67 r
.44609 .31682 m
.44817 .31996 L
s
.44609 .31682 m
.40551 .30085 L
s
1 .304 .13 r
.5 .62969 m .52364 .63308 L .52548 .63142 L closepath p F P
0 0 0 r
s
.805 .237 .104 r
.42555 .60469 m .42064 .60966 L .39762 .59702 L p F P
0 0 0 r
s
.805 .237 .104 r
.39762 .59702 m .40382 .59052 L .42555 .60469 L p F P
0 0 0 r
s
.974 .29 .124 r
.46554 .63294 m .46729 .63128 L .5 .62969 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.24907 .582 m
.20619 .56911 L
s
.24907 .582 m
.25792 .5853 L
s
.152 .189 .336 r
.48144 .34446 m .5008 .352 L .50074 .34213 L p F P
0 0 0 r
s
.152 .189 .336 r
.50074 .34213 m .48287 .33512 L .48144 .34446 L p F P
0 0 0 r
s
.24 .35 .67 r
.53584 .6283 m
.54785 .63205 L
s
.263 .368 .699 r
.63544 .47962 m .65381 .48636 L .65853 .46471 L p F P
0 0 0 r
s
.24 .35 .67 r
.65741 .46543 m
.65741 .46429 L
s
.263 .368 .699 r
.65853 .46471 m .63962 .45764 L .63544 .47962 L p F P
0 0 0 r
s
.83 .24 .1 r
.45154 .31991 m
.45652 .31487 L
s
.45652 .31487 m
.47893 .28689 L
s
.24 .35 .67 r
.67215 .58056 m
.6834 .54909 L
s
1 .304 .13 r
.5 .62969 m .52548 .63142 L .52733 .62975 L closepath p F P
0 0 0 r
s
.944 .288 .117 r
.64782 .57475 m .65709 .56675 L .63094 .58449 L p F P
0 0 0 r
s
.24 .35 .67 r
.64996 .57302 m
.67215 .58056 L
s
.64874 .5726 m
.64996 .57302 L
s
.83 .24 .1 r
.6404 .57807 m
.65546 .56557 L
s
.63187 .58539 m
.63684 .58109 L
s
.944 .288 .117 r
.63094 .58449 m .62335 .59106 L .64782 .57475 L p F P
0 0 0 r
s
.974 .29 .124 r
.46729 .63128 m .46905 .62961 L .5 .62969 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.67884 .54749 m
.6834 .54909 L
s
.47 .135 .064 r
.38384 .50488 m .37454 .51559 L .36694 .49384 L p F P
0 0 0 r
s
.83 .24 .1 r
.36856 .49193 m
.36954 .49554 L
s
.47 .135 .064 r
.36694 .49384 m .37673 .48227 L .38384 .50488 L p F P
0 0 0 r
s
.738 .216 .096 r
.4101 .58394 m .40382 .59052 L .38473 .57409 L p F P
0 0 0 r
s
.738 .216 .096 r
.38473 .57409 m .39213 .56608 L .4101 .58394 L p F P
0 0 0 r
s
1 .316 .133 r
.55752 .62311 m .56128 .61978 L .53104 .62639 L p F P
0 0 0 r
s
.83 .24 .1 r
.55494 .62357 m
.55511 .62341 L
s
1 .316 .133 r
.53104 .62639 m .52918 .62807 L .55752 .62311 L p F P
0 0 0 r
s
.24 .35 .67 r
.53215 .62715 m
.53584 .6283 L
s
.083 .024 .01 r
.41691 .36972 m .4062 .38303 L .41079 .36827 L p F P
0 0 0 r
s
.083 .024 .01 r
.41079 .36827 m .42101 .35547 L .41691 .36972 L p F P
0 0 0 r
s
.922 .273 .118 r
.47258 .62625 m .47081 .62793 L .44247 .62284 L p F P
0 0 0 r
s
.922 .273 .118 r
.44247 .62284 m .44587 .6195 L .47258 .62625 L p F P
0 0 0 r
s
.83 .24 .1 r
.7638 .34922 m
.7925 .32191 L
s
.7638 .34922 m
.77535 .37662 L
s
.274 .386 .737 r
.64498 .50866 m .66216 .51483 L .67199 .49302 L p F P
0 0 0 r
s
.274 .386 .737 r
.67199 .49302 m .65381 .48636 L .64498 .50866 L p F P
0 0 0 r
s
1 .304 .13 r
.5 .62969 m .52733 .62975 L .52918 .62807 L closepath p F P
0 0 0 r
s
1 .322 .134 r
.58982 .61007 m .5955 .6051 L .56506 .61643 L p F P
0 0 0 r
s
.83 .24 .1 r
.58526 .61124 m
.58702 .61102 L
s
1 .322 .134 r
.56506 .61643 m .56128 .61978 L .58982 .61007 L p F P
0 0 0 r
s
.974 .29 .124 r
.46905 .62961 m .47081 .62793 L .5 .62969 L closepath p F P
0 0 0 r
s
.249 .344 .649 r
.60113 .44324 m .62048 .45048 L .62091 .42981 L p F P
0 0 0 r
s
.24 .35 .67 r
.61963 .43068 m
.61963 .43055 L
s
.249 .344 .649 r
.62091 .42981 m .60148 .42243 L .60113 .44324 L p F P
0 0 0 r
s
.24 .35 .67 r
.35469 .60763 m
.396 .62012 L
s
.396 .62012 m
.41086 .61054 L
s
.866 .256 .112 r
.44929 .61615 m .44587 .6195 L .42064 .60966 L p F P
0 0 0 r
s
.866 .256 .112 r
.42064 .60966 m .42555 .60469 L .44929 .61615 L p F P
0 0 0 r
s
.198 .262 .481 r
.52097 .37387 m .54087 .38154 L .53887 .36683 L p F P
0 0 0 r
s
.24 .35 .67 r
.53522 .36541 m
.53604 .36795 L
s
.198 .262 .481 r
.53887 .36683 m .51994 .35946 L .52097 .37387 L p F P
0 0 0 r
s
.24 .35 .67 r
.36398 .28451 m
.35538 .28037 L
s
.35538 .28037 m
.31359 .26392 L
s
.83 .24 .1 r
.75321 .42913 m
.78173 .40341 L
s
.75321 .42913 m
.7536 .45411 L
s
.282 .401 .768 r
.64795 .53649 m .66353 .54196 L .67916 .52093 L p F P
0 0 0 r
s
.282 .401 .768 r
.67916 .52093 m .66216 .51483 L .64795 .53649 L p F P
0 0 0 r
s
.24 .35 .67 r
.1623 .55592 m
.15757 .54658 L
s
.34 .095 .048 r
.38672 .47047 m .37673 .48227 L .37294 .46042 L p F P
0 0 0 r
s
.34 .095 .048 r
.37294 .46042 m .3832 .44803 L .38672 .47047 L p F P
0 0 0 r
s
.288 .412 .793 r
.64346 .56207 m .65709 .56675 L .67897 .54738 L p F P
0 0 0 r
s
.288 .412 .793 r
.67897 .54738 m .66353 .54196 L .64346 .56207 L p F P
0 0 0 r
s
.83 .24 .1 r
.6783 .54582 m
.68154 .54301 L
s
.67817 .54593 m
.6783 .54582 L
s
.229 .31 .58 r
.56195 .4074 m .58183 .41496 L .57998 .39661 L p F P
0 0 0 r
s
.24 .35 .67 r
.57853 .39605 m
.5787 .39738 L
s
.5808 .41456 m
.58096 .41587 L
s
.229 .31 .58 r
.57998 .39661 m .56054 .38912 L .56195 .4074 L p F P
0 0 0 r
s
1 .304 .13 r
.5 .62969 m .52918 .62807 L .53104 .62639 L closepath p F P
0 0 0 r
s
.974 .29 .124 r
.47081 .62793 m .47258 .62625 L .5 .62969 L closepath p F P
0 0 0 r
s
.143 .041 .02 r
.404 .40125 m .39329 .41442 L .3957 .39608 L p F P
0 0 0 r
s
.143 .041 .02 r
.3957 .39608 m .4062 .38303 L .404 .40125 L p F P
0 0 0 r
s
.663 .193 .087 r
.39963 .55795 m .39213 .56608 L .3771 .5466 L p F P
0 0 0 r
s
.663 .193 .087 r
.3771 .5466 m .38552 .53717 L .39963 .55795 L p F P
0 0 0 r
s
.212 .061 .032 r
.39367 .43539 m .3832 .44803 L .38279 .42731 L p F P
0 0 0 r
s
.83 .24 .1 r
.38403 .42808 m
.38404 .42824 L
s
.212 .061 .032 r
.38279 .42731 m .39329 .41442 L .39367 .43539 L p F P
0 0 0 r
s
1 .315 .13 r
.62335 .59106 m .63094 .58449 L .60124 .60008 L p F P
0 0 0 r
s
1 .315 .13 r
.60124 .60008 m .5955 .6051 L .62335 .59106 L p F P
0 0 0 r
s
.24 .35 .67 r
.61993 .59732 m
.65794 .60985 L
s
.6037 .62323 m
.61993 .59732 L
s
.152 .189 .336 r
.46186 .33684 m .48144 .34446 L .48287 .33512 L p F P
0 0 0 r
s
.152 .189 .336 r
.48287 .33512 m .46482 .32804 L .46186 .33684 L p F P
0 0 0 r
s
1 .316 .133 r
.56128 .61978 m .56506 .61643 L .53291 .6247 L p F P
0 0 0 r
s
.83 .24 .1 r
.55852 .62038 m
.55869 .62023 L
s
1 .316 .133 r
.53291 .6247 m .53104 .62639 L .56128 .61978 L p F P
0 0 0 r
s
.24 .35 .67 r
.55681 .62092 m
.55862 .61867 L
s
.54785 .63205 m
.55681 .62092 L
s
1 .304 .13 r
.5 .62969 m .53104 .62639 L .53291 .6247 L closepath p F P
0 0 0 r
s
1 .304 .13 r
.5 .62969 m .53291 .6247 L .53478 .62301 L closepath p F P
0 0 0 r
s
.974 .29 .124 r
.4815 .61776 m .4833 .61604 L .5 .62969 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.49799 .62944 m
.49865 .62882 L
s
.974 .29 .124 r
.4797 .61947 m .4815 .61776 L .5 .62969 L closepath p F P
0 0 0 r
s
.974 .29 .124 r
.47791 .62117 m .4797 .61947 L .5 .62969 L closepath p F P
0 0 0 r
s
.974 .29 .124 r
.47613 .62287 m .47791 .62117 L .5 .62969 L closepath p F P
0 0 0 r
s
.974 .29 .124 r
.47435 .62456 m .47613 .62287 L .5 .62969 L closepath p F P
0 0 0 r
s
.974 .29 .124 r
.47258 .62625 m .47435 .62456 L .5 .62969 L closepath p F P
0 0 0 r
s
.293 .437 .856 r
.51597 .61711 m .51281 .61612 L .5 .62969 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.50193 .62817 m
.50423 .62888 L
s
.293 .437 .856 r
.51912 .61809 m .51597 .61711 L .5 .62969 L closepath p F P
0 0 0 r
s
.293 .437 .856 r
.52226 .61908 m .51912 .61809 L .5 .62969 L closepath p F P
0 0 0 r
s
.293 .437 .856 r
.5254 .62007 m .52226 .61908 L .5 .62969 L closepath p F P
0 0 0 r
s
.293 .437 .856 r
.52853 .62105 m .5254 .62007 L .5 .62969 L closepath p F P
0 0 0 r
s
.293 .437 .856 r
.53166 .62203 m .52853 .62105 L .5 .62969 L closepath p F P
0 0 0 r
s
.293 .437 .856 r
.53478 .62301 m .53166 .62203 L .5 .62969 L closepath p F P
0 0 0 r
s
.974 .29 .124 r
.4851 .61433 m .48692 .6126 L .5 .62969 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.49878 .6287 m
.49892 .62858 L
s
.83 .24 .1 r
.49787 .62691 m
.50155 .62805 L
s
.974 .29 .124 r
.4833 .61604 m .4851 .61433 L .5 .62969 L closepath p F P
0 0 0 r
s
.293 .437 .856 r
.50331 .61313 m .50013 .61214 L .5 .62969 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.49905 .62845 m
.50002 .62756 L
s
.293 .437 .856 r
.50648 .61413 m .50331 .61313 L .5 .62969 L closepath p F P
0 0 0 r
s
.293 .437 .856 r
.50965 .61512 m .50648 .61413 L .5 .62969 L closepath p F P
0 0 0 r
s
.293 .437 .856 r
.51281 .61612 m .50965 .61512 L .5 .62969 L closepath p F P
0 0 0 r
s
.974 .29 .124 r
.48874 .61087 m .49056 .60913 L .5 .62969 L closepath p F P
0 0 0 r
s
.974 .29 .124 r
.48692 .6126 m .48874 .61087 L .5 .62969 L closepath p F P
0 0 0 r
s
.293 .437 .856 r
.49376 .61014 m .49056 .60913 L .5 .62969 L closepath p F P
0 0 0 r
s
.293 .437 .856 r
.49695 .61114 m .49376 .61014 L .5 .62969 L closepath p F P
0 0 0 r
s
.293 .437 .856 r
.50013 .61214 m .49695 .61114 L .5 .62969 L closepath p F P
0 0 0 r
s
.922 .273 .118 r
.47435 .62456 m .47258 .62625 L .44587 .6195 L p F P
0 0 0 r
s
.922 .273 .118 r
.44587 .6195 m .44929 .61615 L .47435 .62456 L p F P
0 0 0 r
s
.805 .237 .104 r
.4305 .59967 m .42555 .60469 L .40382 .59052 L p F P
0 0 0 r
s
.805 .237 .104 r
.40382 .59052 m .4101 .58394 L .4305 .59967 L p F P
0 0 0 r
s
.83 .24 .1 r
.47893 .28689 m
.49871 .27689 L
s
.49871 .27689 m
.52209 .248 L
s
.263 .368 .699 r
.61686 .4728 m .63544 .47962 L .63962 .45764 L p F P
0 0 0 r
s
.263 .368 .699 r
.63962 .45764 m .62048 .45048 L .61686 .4728 L p F P
0 0 0 r
s
.083 .024 .01 r
.44206 .32912 m .43143 .34243 L .43673 .33323 L p F P
0 0 0 r
s
.083 .024 .01 r
.43673 .33323 m .44658 .32088 L .44206 .32912 L p F P
0 0 0 r
s
.83 .24 .1 r
.68154 .54301 m
.70869 .51954 L
s
.66455 .55711 m
.68154 .54301 L
s
.24 .35 .67 r
.26164 .25029 m
.27081 .24707 L
s
1 .322 .134 r
.5955 .6051 m .60124 .60008 L .56886 .61305 L p F P
0 0 0 r
s
1 .322 .134 r
.56886 .61305 m .56506 .61643 L .5955 .6051 L p F P
0 0 0 r
s
.24 .35 .67 r
.57173 .613 m
.57718 .61474 L
s
.57718 .61474 m
.6037 .62323 L
s
1 .316 .133 r
.53478 .62301 m .53291 .6247 L .56506 .61643 L p F P
0 0 0 r
s
.24 .35 .67 r
.30054 .59811 m
.25792 .5853 L
s
.30054 .59811 m
.31242 .59485 L
s
.922 .273 .118 r
.47613 .62287 m .47435 .62456 L .44929 .61615 L p F P
0 0 0 r
s
.24 .35 .67 r
.45174 .62306 m
.46787 .628 L
s
.44357 .62798 m
.45174 .62306 L
s
.866 .256 .112 r
.45273 .61277 m .44929 .61615 L .42555 .60469 L p F P
0 0 0 r
s
.866 .256 .112 r
.42555 .60469 m .4305 .59967 L .45273 .61277 L p F P
0 0 0 r
s
.83 .24 .1 r
.59592 .21618 m
.62337 .22356 L
s
.62337 .22356 m
.64936 .19352 L
s
.274 .386 .737 r
.62762 .50243 m .64498 .50866 L .65381 .48636 L p F P
0 0 0 r
s
.274 .386 .737 r
.65381 .48636 m .63544 .47962 L .62762 .50243 L p F P
0 0 0 r
s
.575 .166 .076 r
.39409 .52759 m .38552 .53717 L .37454 .51559 L p F P
0 0 0 r
s
.83 .24 .1 r
.37582 .51412 m
.37736 .51733 L
s
.38644 .53615 m
.38675 .53678 L
s
.3859 .53773 m
.38675 .53678 L
s
.575 .166 .076 r
.37454 .51559 m .38384 .50488 L .39409 .52759 L p F P
0 0 0 r
s
1 .316 .133 r
.56506 .61643 m .56886 .61305 L .53478 .62301 L p F P
0 0 0 r
s
.24 .35 .67 r
.61219 .59477 m
.61993 .59732 L
s
.61993 .59732 m
.62336 .59015 L
s
.62336 .59015 m
.62398 .58885 L
s
.292 .422 .814 r
.61949 .58066 m .63094 .58449 L .65709 .56675 L p F P
0 0 0 r
s
.24 .35 .67 r
.62443 .58791 m
.62674 .58309 L
s
.292 .422 .814 r
.65709 .56675 m .64346 .56207 L .61949 .58066 L p F P
0 0 0 r
s
.83 .24 .1 r
.64826 .5712 m
.64909 .57048 L
s
.922 .273 .118 r
.44929 .61615 m .45273 .61277 L .47613 .62287 L p F P
0 0 0 r
s
.282 .401 .768 r
.63221 .53097 m .64795 .53649 L .66216 .51483 L p F P
0 0 0 r
s
.282 .401 .768 r
.66216 .51483 m .64498 .50866 L .63221 .53097 L p F P
0 0 0 r
s
.249 .344 .649 r
.58154 .43592 m .60113 .44324 L .60148 .42243 L p F P
0 0 0 r
s
.249 .344 .649 r
.60148 .42243 m .58183 .41496 L .58154 .43592 L p F P
0 0 0 r
s
.24 .35 .67 r
.58096 .41587 m
.58182 .41619 L
s
.288 .412 .793 r
.62971 .55736 m .64346 .56207 L .66353 .54196 L p F P
0 0 0 r
s
.288 .412 .793 r
.66353 .54196 m .64795 .53649 L .62971 .55736 L p F P
0 0 0 r
s
.83 .24 .1 r
.64909 .57048 m
.66455 .55711 L
s
.24 .35 .67 r
.6455 .5358 m
.64784 .53662 L
s
.198 .262 .481 r
.50084 .36611 m .52097 .37387 L .51994 .35946 L p F P
0 0 0 r
s
.198 .262 .481 r
.51994 .35946 m .5008 .352 L .50084 .36611 L p F P
0 0 0 r
s
.738 .216 .096 r
.41645 .57729 m .4101 .58394 L .39213 .56608 L p F P
0 0 0 r
s
.738 .216 .096 r
.39213 .56608 m .39963 .55795 L .41645 .57729 L p F P
0 0 0 r
s
.83 .24 .1 r
.40536 .56455 m
.40597 .56389 L
s
.297 .439 .855 r
.53166 .62203 m .53478 .62301 L .56886 .61305 L p F P
0 0 0 r
s
.83 .24 .1 r
.56614 .61361 m
.56696 .61351 L
s
.56599 .61374 m
.56614 .61361 L
s
.922 .273 .118 r
.47791 .62117 m .47613 .62287 L .45273 .61277 L p F P
0 0 0 r
s
.24 .35 .67 r
.6455 .5358 m
.64554 .53565 L
s
.229 .31 .58 r
.54183 .39975 m .56195 .4074 L .56054 .38912 L p F P
0 0 0 r
s
.229 .31 .58 r
.56054 .38912 m .54087 .38154 L .54183 .39975 L p F P
0 0 0 r
s
.297 .439 .855 r
.52853 .62105 m .53166 .62203 L .56274 .61109 L p F P
0 0 0 r
s
.297 .439 .855 r
.56886 .61305 m .56274 .61109 L .53166 .62203 L p F P
0 0 0 r
s
.152 .189 .336 r
.44206 .32912 m .46186 .33684 L .46482 .32804 L p F P
0 0 0 r
s
.83 .24 .1 r
.44116 .33044 m
.44235 .32923 L
s
.152 .189 .336 r
.46482 .32804 m .44658 .32088 L .44206 .32912 L p F P
0 0 0 r
s
.922 .273 .118 r
.4797 .61947 m .47791 .62117 L .45619 .60937 L p F P
0 0 0 r
s
.922 .273 .118 r
.45273 .61277 m .45619 .60937 L .47791 .62117 L p F P
0 0 0 r
s
.297 .439 .855 r
.5254 .62007 m .52853 .62105 L .55659 .60912 L p F P
0 0 0 r
s
.297 .439 .855 r
.56274 .61109 m .55659 .60912 L .52853 .62105 L p F P
0 0 0 r
s
.296 .43 .832 r
.59231 .59717 m .60124 .60008 L .63094 .58449 L p F P
0 0 0 r
s
.296 .43 .832 r
.63094 .58449 m .61949 .58066 L .59231 .59717 L p F P
0 0 0 r
s
.83 .24 .1 r
.62198 .58642 m
.62294 .58603 L
s
.24 .35 .67 r
.41233 .312 m
.40551 .30085 L
s
.40551 .30085 m
.36398 .28451 L
s
.83 .24 .1 r
.73139 .24454 m
.70522 .22359 L
s
.7552 .26846 m
.73139 .24454 L
s
.47 .135 .064 r
.39331 .49397 m .38384 .50488 L .37673 .48227 L p F P
0 0 0 r
s
.47 .135 .064 r
.37673 .48227 m .38672 .47047 L .39331 .49397 L p F P
0 0 0 r
s
.297 .436 .846 r
.56274 .61109 m .56886 .61305 L .60124 .60008 L p F P
0 0 0 r
s
.24 .35 .67 r
.20619 .56911 m
.1623 .55592 L
s
.20619 .56911 m
.2143 .5722 L
s
.805 .237 .104 r
.4355 .5946 m .4305 .59967 L .4101 .58394 L p F P
0 0 0 r
s
.805 .237 .104 r
.4101 .58394 m .41645 .57729 L .4355 .5946 L p F P
0 0 0 r
s
.83 .24 .1 r
.42908 .58877 m
.4297 .58813 L
s
.52209 .248 m
.54544 .24394 L
s
.54544 .24394 m
.56992 .2142 L
s
.866 .256 .112 r
.45619 .60937 m .45273 .61277 L .4305 .59967 L p F P
0 0 0 r
s
.24 .35 .67 r
.41086 .61054 m
.45174 .62306 L
s
.83 .24 .1 r
.72012 .50091 m
.7482 .47645 L
s
.72012 .50091 m
.70869 .51954 L
s
.77535 .37662 m
.80456 .3496 L
s
.77535 .37662 m
.78173 .40341 L
s
.297 .439 .855 r
.52226 .61908 m .5254 .62007 L .55043 .60715 L p F P
0 0 0 r
s
.297 .439 .855 r
.55659 .60912 m .55043 .60715 L .5254 .62007 L p F P
0 0 0 r
s
.263 .368 .699 r
.59807 .46591 m .61686 .4728 L .62048 .45048 L p F P
0 0 0 r
s
.24 .35 .67 r
.61931 .45129 m
.61933 .45005 L
s
.263 .368 .699 r
.62048 .45048 m .60113 .44324 L .59807 .46591 L p F P
0 0 0 r
s
.83 .24 .1 r
.77582 .29455 m
.7552 .26846 L
s
.083 .024 .01 r
.42783 .35613 m .41691 .36972 L .42101 .35547 L p F P
0 0 0 r
s
.083 .024 .01 r
.42101 .35547 m .43143 .34243 L .42783 .35613 L p F P
0 0 0 r
s
.83 .24 .1 r
.43136 .34269 m
.44116 .33044 L
s
.297 .436 .846 r
.60124 .60008 m .59231 .59717 L .56274 .61109 L p F P
0 0 0 r
s
.922 .273 .118 r
.4815 .61776 m .4797 .61947 L .45968 .60595 L p F P
0 0 0 r
s
.922 .273 .118 r
.45619 .60937 m .45968 .60595 L .4797 .61947 L p F P
0 0 0 r
s
.83 .24 .1 r
.45666 .6082 m
.45714 .60844 L
s
.866 .256 .112 r
.4305 .59967 m .4355 .5946 L .45619 .60937 L p F P
0 0 0 r
s
.83 .24 .1 r
.45577 .60907 m
.45666 .6082 L
s
.292 .422 .814 r
.60796 .57681 m .61949 .58066 L .64346 .56207 L p F P
0 0 0 r
s
.292 .422 .814 r
.64346 .56207 m .62971 .55736 L .60796 .57681 L p F P
0 0 0 r
s
.24 .35 .67 r
.64339 .5417 m
.6455 .5358 L
s
.297 .439 .855 r
.51912 .61809 m .52226 .61908 L .54424 .60517 L p F P
0 0 0 r
s
.297 .439 .855 r
.55043 .60715 m .54424 .60517 L .52226 .61908 L p F P
0 0 0 r
s
.663 .193 .087 r
.40724 .54971 m .39963 .55795 L .38552 .53717 L p F P
0 0 0 r
s
.83 .24 .1 r
.38675 .53678 m
.38807 .53865 L
s
.40083 .55664 m
.40597 .56389 L
s
.663 .193 .087 r
.38552 .53717 m .39409 .52759 L .40724 .54971 L p F P
0 0 0 r
s
.297 .436 .846 r
.55659 .60912 m .56274 .61109 L .59231 .59717 L p F P
0 0 0 r
s
.83 .24 .1 r
.57038 .60984 m
.57183 .60855 L
s
.274 .386 .737 r
.61008 .49613 m .62762 .50243 L .63544 .47962 L p F P
0 0 0 r
s
.274 .386 .737 r
.63544 .47962 m .61686 .4728 L .61008 .49613 L p F P
0 0 0 r
s
.288 .412 .793 r
.61585 .55261 m .62971 .55736 L .64795 .53649 L p F P
0 0 0 r
s
.288 .412 .793 r
.64795 .53649 m .63221 .53097 L .61585 .55261 L p F P
0 0 0 r
s
.297 .439 .855 r
.51597 .61711 m .51912 .61809 L .53802 .60318 L p F P
0 0 0 r
s
.297 .439 .855 r
.54424 .60517 m .53802 .60318 L .51912 .61809 L p F P
0 0 0 r
s
.83 .24 .1 r
.52845 .61927 m
.53068 .61724 L
s
.34 .095 .048 r
.3969 .45843 m .38672 .47047 L .3832 .44803 L p F P
0 0 0 r
s
.83 .24 .1 r
.38513 .4457 m
.38538 .44969 L
s
.34 .095 .048 r
.3832 .44803 m .39367 .43539 L .3969 .45843 L p F P
0 0 0 r
s
.83 .24 .1 r
.70522 .22359 m
.67756 .20636 L
s
.282 .401 .768 r
.61633 .5254 m .63221 .53097 L .64498 .50866 L p F P
0 0 0 r
s
.282 .401 .768 r
.64498 .50866 m .62762 .50243 L .61633 .5254 L p F P
0 0 0 r
s
.922 .273 .118 r
.4833 .61604 m .4815 .61776 L .46319 .60251 L p F P
0 0 0 r
s
.922 .273 .118 r
.45968 .60595 m .46319 .60251 L .4815 .61776 L p F P
0 0 0 r
s
.198 .262 .481 r
.48047 .35825 m .50084 .36611 L .5008 .352 L p F P
0 0 0 r
s
.198 .262 .481 r
.5008 .352 m .48144 .34446 L .48047 .35825 L p F P
0 0 0 r
s
.296 .43 .832 r
.58334 .59423 m .59231 .59717 L .61949 .58066 L p F P
0 0 0 r
s
.296 .43 .832 r
.61949 .58066 m .60796 .57681 L .58334 .59423 L p F P
0 0 0 r
s
.83 .24 .1 r
.61153 .59306 m
.61664 .58859 L
s
.61664 .58859 m
.62198 .58642 L
s
.297 .439 .855 r
.51281 .61612 m .51597 .61711 L .53179 .60119 L p F P
0 0 0 r
s
.297 .439 .855 r
.53802 .60318 m .53179 .60119 L .51597 .61711 L p F P
0 0 0 r
s
.83 .24 .1 r
.53802 .61054 m
.55589 .61249 L
s
.143 .041 .02 r
.41494 .38782 m .404 .40125 L .4062 .38303 L p F P
0 0 0 r
s
.83 .24 .1 r
.40504 .40232 m
.40557 .39932 L
s
.40826 .38416 m
.40911 .37941 L
s
.143 .041 .02 r
.4062 .38303 m .41691 .36972 L .41494 .38782 L p F P
0 0 0 r
s
.24 .35 .67 r
.35469 .60763 m
.31242 .59485 L
s
.35469 .60763 m
.36902 .59772 L
s
.249 .344 .649 r
.56173 .42851 m .58154 .43592 L .58183 .41496 L p F P
0 0 0 r
s
.249 .344 .649 r
.58183 .41496 m .56195 .4074 L .56173 .42851 L p F P
0 0 0 r
s
.297 .436 .846 r
.59231 .59717 m .58334 .59423 L .55659 .60912 L p F P
0 0 0 r
s
.866 .256 .112 r
.45968 .60595 m .45619 .60937 L .4355 .5946 L p F P
0 0 0 r
s
.83 .24 .1 r
.4297 .58813 m
.44333 .59828 L
s
.24 .35 .67 r
.32146 .26777 m
.31359 .26392 L
s
.31359 .26392 m
.27081 .24707 L
s
.297 .436 .846 r
.55043 .60715 m .55659 .60912 L .58334 .59423 L p F P
0 0 0 r
s
.83 .24 .1 r
.57183 .60855 m
.57382 .60678 L
s
.212 .061 .032 r
.40435 .42249 m .39367 .43539 L .39329 .41442 L p F P
0 0 0 r
s
.212 .061 .032 r
.39329 .41442 m .404 .40125 L .40435 .42249 L p F P
0 0 0 r
s
.83 .24 .1 r
.40404 .40355 m
.40504 .40232 L
s
.297 .439 .855 r
.50965 .61512 m .51281 .61612 L .52553 .59919 L p F P
0 0 0 r
s
.297 .439 .855 r
.53179 .60119 m .52553 .59919 L .51281 .61612 L p F P
0 0 0 r
s
.83 .24 .1 r
.53068 .61724 m
.53802 .61054 L
s
.922 .273 .118 r
.4851 .61433 m .4833 .61604 L .46672 .59904 L p F P
0 0 0 r
s
.922 .273 .118 r
.46319 .60251 m .46672 .59904 L .4833 .61604 L p F P
0 0 0 r
s
.83 .24 .1 r
.7925 .32191 m
.77582 .29455 L
s
.229 .31 .58 r
.52147 .392 m .54183 .39975 L .54087 .38154 L p F P
0 0 0 r
s
.24 .35 .67 r
.5394 .38097 m
.53953 .38226 L
s
.54125 .39952 m
.54138 .40083 L
s
.229 .31 .58 r
.54087 .38154 m .52097 .37387 L .52147 .392 L p F P
0 0 0 r
s
.738 .216 .096 r
.42288 .57055 m .41645 .57729 L .39963 .55795 L p F P
0 0 0 r
s
.83 .24 .1 r
.41775 .57592 m
.4297 .58813 L
s
.738 .216 .096 r
.39963 .55795 m .40724 .54971 L .42288 .57055 L p F P
0 0 0 r
s
.83 .24 .1 r
.44613 .32421 m
.46361 .30235 L
s
.44116 .33044 m
.44217 .32917 L
s
.297 .439 .855 r
.50648 .61413 m .50965 .61512 L .51925 .59718 L p F P
0 0 0 r
s
.297 .439 .855 r
.52553 .59919 m .51925 .59718 L .50965 .61512 L p F P
0 0 0 r
s
.24 .35 .67 r
.52464 .5989 m
.52525 .59811 L
s
.292 .422 .814 r
.59636 .57292 m .60796 .57681 L .62971 .55736 L p F P
0 0 0 r
s
.292 .422 .814 r
.62971 .55736 m .61585 .55261 L .59636 .57292 L p F P
0 0 0 r
s
.83 .24 .1 r
.61664 .58859 m
.64271 .56583 L
s
.297 .436 .846 r
.54424 .60517 m .55043 .60715 L .57432 .59129 L p F P
0 0 0 r
s
.24 .35 .67 r
.55142 .60649 m
.5518 .60661 L
s
.297 .436 .846 r
.58334 .59423 m .57432 .59129 L .55043 .60715 L p F P
0 0 0 r
s
.83 .24 .1 r
.7536 .45411 m
.78252 .42855 L
s
.7536 .45411 m
.7482 .47645 L
s
.866 .256 .112 r
.4355 .5946 m .44054 .58949 L .45968 .60595 L p F P
0 0 0 r
s
.805 .237 .104 r
.44054 .58949 m .4355 .5946 L .41645 .57729 L p F P
0 0 0 r
s
.575 .166 .076 r
.40281 .51784 m .39409 .52759 L .38384 .50488 L p F P
0 0 0 r
s
.575 .166 .076 r
.38384 .50488 m .39331 .49397 L .40281 .51784 L p F P
0 0 0 r
s
.922 .273 .118 r
.48692 .6126 m .4851 .61433 L .47027 .59555 L p F P
0 0 0 r
s
.922 .273 .118 r
.46672 .59904 m .47027 .59555 L .4851 .61433 L p F P
0 0 0 r
s
.24 .35 .67 r
.45174 .62306 m
.4681 .60714 L
s
.297 .439 .855 r
.50331 .61313 m .50648 .61413 L .51294 .59516 L p F P
0 0 0 r
s
.297 .439 .855 r
.51925 .59718 m .51294 .59516 L .50648 .61413 L p F P
0 0 0 r
s
.296 .43 .832 r
.57432 .59129 m .58334 .59423 L .60796 .57681 L p F P
0 0 0 r
s
.805 .237 .104 r
.41645 .57729 m .42288 .57055 L .44054 .58949 L p F P
0 0 0 r
s
.263 .368 .699 r
.57906 .45894 m .59807 .46591 L .60113 .44324 L p F P
0 0 0 r
s
.263 .368 .699 r
.60113 .44324 m .58154 .43592 L .57906 .45894 L p F P
0 0 0 r
s
.24 .35 .67 r
.41233 .312 m
.44438 .32454 L
s
.296 .43 .832 r
.60796 .57681 m .59636 .57292 L .57432 .59129 L p F P
0 0 0 r
s
.24 .35 .67 r
.58103 .5845 m
.58206 .58484 L
s
.57953 .58695 m
.58103 .5845 L
s
.866 .256 .112 r
.46319 .60251 m .45968 .60595 L .44054 .58949 L p F P
0 0 0 r
s
.297 .439 .855 r
.50013 .61214 m .50331 .61313 L .50662 .59313 L p F P
0 0 0 r
s
.297 .439 .855 r
.51294 .59516 m .50662 .59313 L .50331 .61313 L p F P
0 0 0 r
s
.288 .412 .793 r
.60187 .54782 m .61585 .55261 L .63221 .53097 L p F P
0 0 0 r
s
.288 .412 .793 r
.63221 .53097 m .61633 .5254 L .60187 .54782 L p F P
0 0 0 r
s
.297 .436 .846 r
.53802 .60318 m .54424 .60517 L .56526 .58832 L p F P
0 0 0 r
s
.24 .35 .67 r
.54511 .60447 m
.54549 .60459 L
s
.297 .436 .846 r
.57432 .59129 m .56526 .58832 L .54424 .60517 L p F P
0 0 0 r
s
.83 .24 .1 r
.57382 .60678 m
.59099 .59153 L
s
.922 .273 .118 r
.48874 .61087 m .48692 .6126 L .47385 .59205 L p F P
0 0 0 r
s
.922 .273 .118 r
.47027 .59555 m .47385 .59205 L .48692 .6126 L p F P
0 0 0 r
s
.24 .35 .67 r
.4806 .61104 m
.4844 .61223 L
s
.83 .24 .1 r
.56992 .2142 m
.59592 .21618 L
s
.59592 .21618 m
.62163 .18565 L
s
.274 .386 .737 r
.59235 .48976 m .61008 .49613 L .61686 .4728 L p F P
0 0 0 r
s
.274 .386 .737 r
.61686 .4728 m .59807 .46591 L .59235 .48976 L p F P
0 0 0 r
s
.297 .439 .855 r
.49695 .61114 m .50013 .61214 L .50026 .5911 L p F P
0 0 0 r
s
.297 .439 .855 r
.50662 .59313 m .50026 .5911 L .50013 .61214 L p F P
0 0 0 r
s
.83 .24 .1 r
.50138 .608 m
.5086 .60119 L
s
.282 .401 .768 r
.60029 .51977 m .61633 .5254 L .62762 .50243 L p F P
0 0 0 r
s
.282 .401 .768 r
.62762 .50243 m .61008 .49613 L .60029 .51977 L p F P
0 0 0 r
s
.24 .35 .67 r
.25792 .5853 m
.2143 .5722 L
s
.25792 .5853 m
.26913 .58176 L
s
.83 .24 .1 r
.67756 .20636 m
.64936 .19352 L
s
.198 .262 .481 r
.45985 .35031 m .48047 .35825 L .48144 .34446 L p F P
0 0 0 r
s
.198 .262 .481 r
.48144 .34446 m .46186 .33684 L .45985 .35031 L p F P
0 0 0 r
s
.24 .35 .67 r
.41086 .61054 m
.36902 .59772 L
s
.41086 .61054 m
.42681 .59424 L
s
.296 .43 .832 r
.56526 .58832 m .57432 .59129 L .59636 .57292 L p F P
0 0 0 r
s
.83 .24 .1 r
.59099 .59153 m
.61664 .58859 L
s
.297 .439 .855 r
.49376 .61014 m .49695 .61114 L .49389 .58906 L p F P
0 0 0 r
s
.297 .439 .855 r
.50026 .5911 m .49389 .58906 L .49695 .61114 L p F P
0 0 0 r
s
.83 .24 .1 r
.49919 .61007 m
.50138 .608 L
s
.922 .273 .118 r
.49056 .60913 m .48874 .61087 L .47745 .58851 L p F P
0 0 0 r
s
.922 .273 .118 r
.47385 .59205 m .47745 .58851 L .48874 .61087 L p F P
0 0 0 r
s
.297 .436 .846 r
.53179 .60119 m .53802 .60318 L .55614 .58534 L p F P
0 0 0 r
s
.83 .24 .1 r
.5086 .60119 m
.53802 .61054 L
s
.24 .35 .67 r
.53878 .60244 m
.53916 .60256 L
s
.297 .436 .846 r
.56526 .58832 m .55614 .58534 L .53802 .60318 L p F P
0 0 0 r
s
.249 .344 .649 r
.54168 .42102 m .56173 .42851 L .56195 .4074 L p F P
0 0 0 r
s
.249 .344 .649 r
.56195 .4074 m .54183 .39975 L .54168 .42102 L p F P
0 0 0 r
s
.24 .35 .67 r
.54138 .40083 m
.54182 .401 L
s
.292 .422 .814 r
.58467 .56901 m .59636 .57292 L .61585 .55261 L p F P
0 0 0 r
s
.292 .422 .814 r
.61585 .55261 m .60187 .54782 L .58467 .56901 L p F P
0 0 0 r
s
.24 .35 .67 r
.59523 .55441 m
.59624 .55476 L
s
.59343 .55822 m
.59523 .55441 L
s
.47 .135 .064 r
.40295 .48287 m .39331 .49397 L .38672 .47047 L p F P
0 0 0 r
s
.47 .135 .064 r
.38672 .47047 m .3969 .45843 L .40295 .48287 L p F P
0 0 0 r
s
.297 .439 .855 r
.49056 .60913 m .49376 .61014 L .48749 .58701 L p F P
0 0 0 r
s
.297 .439 .855 r
.49389 .58906 m .48749 .58701 L .49376 .61014 L p F P
0 0 0 r
s
.83 .24 .1 r
.46361 .30235 m
.47893 .28689 L
s
.47893 .28689 m
.50227 .25776 L
s
.866 .256 .112 r
.46672 .59904 m .46319 .60251 L .44563 .58433 L p F P
0 0 0 r
s
.83 .24 .1 r
.46273 .60224 m
.46283 .60214 L
s
.866 .256 .112 r
.44054 .58949 m .44563 .58433 L .46319 .60251 L p F P
0 0 0 r
s
.663 .193 .087 r
.41496 .54134 m .40724 .54971 L .39409 .52759 L p F P
0 0 0 r
s
.663 .193 .087 r
.39409 .52759 m .40281 .51784 L .41496 .54134 L p F P
0 0 0 r
s
.296 .43 .832 r
.59636 .57292 m .58467 .56901 L .56526 .58832 L p F P
0 0 0 r
s
.229 .31 .58 r
.50086 .38417 m .52147 .392 L .52097 .37387 L p F P
0 0 0 r
s
.229 .31 .58 r
.52097 .37387 m .50084 .36611 L .50086 .38417 L p F P
0 0 0 r
s
.083 .024 .01 r
.43899 .34227 m .42783 .35613 L .43143 .34243 L p F P
0 0 0 r
s
.083 .024 .01 r
.43143 .34243 m .44206 .32912 L .43899 .34227 L p F P
0 0 0 r
s
.805 .237 .104 r
.44563 .58433 m .44054 .58949 L .42288 .57055 L p F P
0 0 0 r
s
.922 .273 .118 r
.47745 .58851 m .48107 .58496 L .49056 .60913 L p F P
0 0 0 r
s
.24 .35 .67 r
.4681 .60714 m
.4806 .61104 L
s
.297 .439 .855 r
.48749 .58701 m .48107 .58496 L .49056 .60913 L p F P
0 0 0 r
s
.83 .24 .1 r
.66455 .55711 m
.69177 .53356 L
s
.66455 .55711 m
.64271 .56583 L
s
.297 .436 .846 r
.52553 .59919 m .53179 .60119 L .54698 .58234 L p F P
0 0 0 r
s
.24 .35 .67 r
.52525 .59811 m
.52642 .59849 L
s
.53242 .60041 m
.5328 .60053 L
s
.297 .436 .846 r
.55614 .58534 m .54698 .58234 L .53179 .60119 L p F P
0 0 0 r
s
.83 .24 .1 r
.80456 .3496 m
.7925 .32191 L
s
.296 .43 .832 r
.55614 .58534 m .56526 .58832 L .58467 .56901 L p F P
0 0 0 r
s
.83 .24 .1 r
.53802 .61054 m
.53959 .60911 L
s
.24 .35 .67 r
.3701 .29548 m
.36398 .28451 L
s
.36398 .28451 m
.32146 .26777 L
s
.16963 .55878 m
.1623 .55592 L
s
.288 .412 .793 r
.58777 .54299 m .60187 .54782 L .61633 .5254 L p F P
0 0 0 r
s
.288 .412 .793 r
.61633 .5254 m .60029 .51977 L .58777 .54299 L p F P
0 0 0 r
s
.24 .35 .67 r
.48403 .58591 m
.48463 .5851 L
s
.738 .216 .096 r
.42938 .56373 m .42288 .57055 L .40724 .54971 L p F P
0 0 0 r
s
.738 .216 .096 r
.40724 .54971 m .41496 .54134 L .42938 .56373 L p F P
0 0 0 r
s
.263 .368 .699 r
.55984 .45189 m .57906 .45894 L .58154 .43592 L p F P
0 0 0 r
s
.24 .35 .67 r
.58031 .43683 m
.58035 .43548 L
s
.263 .368 .699 r
.58154 .43592 m .56173 .42851 L .55984 .45189 L p F P
0 0 0 r
s
.805 .237 .104 r
.42288 .57055 m .42938 .56373 L .44563 .58433 L p F P
0 0 0 r
s
.83 .24 .1 r
.78173 .40341 m
.81144 .37662 L
s
.78173 .40341 m
.78252 .42855 L
s
.34 .095 .048 r
.40729 .44616 m .3969 .45843 L .39367 .43539 L p F P
0 0 0 r
s
.34 .095 .048 r
.39367 .43539 m .40435 .42249 L .40729 .44616 L p F P
0 0 0 r
s
.297 .436 .846 r
.51925 .59718 m .52553 .59919 L .53776 .57933 L p F P
0 0 0 r
s
.297 .436 .846 r
.54698 .58234 m .53776 .57933 L .52553 .59919 L p F P
0 0 0 r
s
.83 .24 .1 r
.53959 .60911 m
.56256 .58814 L
s
.866 .256 .112 r
.47027 .59555 m .46672 .59904 L .45077 .57912 L p F P
0 0 0 r
s
.24 .35 .67 r
.4681 .60714 m
.47677 .59559 L
s
.47677 .59559 m
.47852 .59325 L
s
.83 .24 .1 r
.46629 .59874 m
.4664 .59864 L
s
.866 .256 .112 r
.44563 .58433 m .45077 .57912 L .46672 .59904 L p F P
0 0 0 r
s
.24 .35 .67 r
.59523 .55441 m
.59804 .54651 L
s
.282 .401 .768 r
.5841 .51409 m .60029 .51977 L .61008 .49613 L p F P
0 0 0 r
s
.282 .401 .768 r
.61008 .49613 m .59235 .48976 L .5841 .51409 L p F P
0 0 0 r
s
.274 .386 .737 r
.57442 .48333 m .59235 .48976 L .59807 .46591 L p F P
0 0 0 r
s
.274 .386 .737 r
.59807 .46591 m .57906 .45894 L .57442 .48333 L p F P
0 0 0 r
s
.143 .041 .02 r
.42611 .3741 m .41494 .38782 L .41691 .36972 L p F P
0 0 0 r
s
.143 .041 .02 r
.41691 .36972 m .42783 .35613 L .42611 .3741 L p F P
0 0 0 r
s
.296 .43 .832 r
.58467 .56901 m .5729 .56508 L .55614 .58534 L p F P
0 0 0 r
s
.292 .422 .814 r
.5729 .56508 m .58467 .56901 L .60187 .54782 L p F P
0 0 0 r
s
.292 .422 .814 r
.60187 .54782 m .58777 .54299 L .5729 .56508 L p F P
0 0 0 r
s
.212 .061 .032 r
.41525 .40933 m .40435 .42249 L .404 .40125 L p F P
0 0 0 r
s
.212 .061 .032 r
.404 .40125 m .41494 .38782 L .41525 .40933 L p F P
0 0 0 r
s
.296 .43 .832 r
.54698 .58234 m .55614 .58534 L .5729 .56508 L p F P
0 0 0 r
s
.198 .262 .481 r
.43899 .34227 m .45985 .35031 L .46186 .33684 L p F P
0 0 0 r
s
.198 .262 .481 r
.46186 .33684 m .44206 .32912 L .43899 .34227 L p F P
0 0 0 r
s
.297 .436 .846 r
.51294 .59516 m .51925 .59718 L .52849 .5763 L p F P
0 0 0 r
s
.24 .35 .67 r
.51963 .59631 m
.52002 .59644 L
s
.297 .436 .846 r
.53776 .57933 m .52849 .5763 L .51925 .59718 L p F P
0 0 0 r
s
.83 .24 .1 r
.50227 .25776 m
.52209 .248 L
s
.52209 .248 m
.54646 .2179 L
s
.575 .166 .076 r
.41167 .50793 m .40281 .51784 L .39331 .49397 L p F P
0 0 0 r
s
.575 .166 .076 r
.39331 .49397 m .40295 .48287 L .41167 .50793 L p F P
0 0 0 r
s
.24 .35 .67 r
.31242 .59485 m
.26913 .58176 L
s
.31242 .59485 m
.32617 .58459 L
s
.805 .237 .104 r
.45077 .57912 m .44563 .58433 L .42938 .56373 L p F P
0 0 0 r
s
.249 .344 .649 r
.52139 .41343 m .54168 .42102 L .54183 .39975 L p F P
0 0 0 r
s
.249 .344 .649 r
.54183 .39975 m .52147 .392 L .52139 .41343 L p F P
0 0 0 r
s
.24 .35 .67 r
.27081 .24707 m
.27792 .25064 L
s
.83 .24 .1 r
.70869 .51954 m
.73697 .49508 L
s
.70869 .51954 m
.69177 .53356 L
s
.229 .31 .58 r
.48 .37624 m .50086 .38417 L .50084 .36611 L p F P
0 0 0 r
s
.24 .35 .67 r
.49934 .36553 m
.49943 .36679 L
s
.50075 .38413 m
.50085 .38544 L
s
.229 .31 .58 r
.50084 .36611 m .48047 .35825 L .48 .37624 L p F P
0 0 0 r
s
.866 .256 .112 r
.47385 .59205 m .47027 .59555 L .45596 .57386 L p F P
0 0 0 r
s
.83 .24 .1 r
.46988 .59522 m
.46998 .59512 L
s
.866 .256 .112 r
.45077 .57912 m .45596 .57386 L .47027 .59555 L p F P
0 0 0 r
s
.24 .35 .67 r
.42681 .59424 m
.4681 .60714 L
s
.297 .436 .846 r
.50662 .59313 m .51294 .59516 L .51918 .57326 L p F P
0 0 0 r
s
.24 .35 .67 r
.5132 .59425 m
.51359 .59438 L
s
.297 .436 .846 r
.52849 .5763 m .51918 .57326 L .51294 .59516 L p F P
0 0 0 r
s
.288 .412 .793 r
.57355 .53812 m .58777 .54299 L .60029 .51977 L p F P
0 0 0 r
s
.288 .412 .793 r
.60029 .51977 m .5841 .51409 L .57355 .53812 L p F P
0 0 0 r
s
.83 .24 .1 r
.64936 .19352 m
.62163 .18565 L
s
.296 .43 .832 r
.53776 .57933 m .54698 .58234 L .56105 .56111 L p F P
0 0 0 r
s
.296 .43 .832 r
.5729 .56508 m .56105 .56111 L .54698 .58234 L p F P
0 0 0 r
s
.292 .422 .814 r
.56105 .56111 m .5729 .56508 L .58777 .54299 L p F P
0 0 0 r
s
.83 .24 .1 r
.49324 .59315 m
.5086 .60119 L
s
.49014 .59152 m
.49324 .59315 L
s
.292 .422 .814 r
.58777 .54299 m .57355 .53812 L .56105 .56111 L p F P
0 0 0 r
s
.83 .24 .1 r
.59099 .59153 m
.61687 .56852 L
s
.59099 .59153 m
.56256 .58814 L
s
.263 .368 .699 r
.5404 .44476 m .55984 .45189 L .56173 .42851 L p F P
0 0 0 r
s
.263 .368 .699 r
.56173 .42851 m .54168 .42102 L .5404 .44476 L p F P
0 0 0 r
s
.663 .193 .087 r
.42279 .53285 m .41496 .54134 L .40281 .51784 L p F P
0 0 0 r
s
.663 .193 .087 r
.40281 .51784 m .41167 .50793 L .42279 .53285 L p F P
0 0 0 r
s
.805 .237 .104 r
.42938 .56373 m .43597 .55683 L .45077 .57912 L p F P
0 0 0 r
s
.738 .216 .096 r
.43597 .55683 m .42938 .56373 L .41496 .54134 L p F P
0 0 0 r
s
.24 .35 .67 r
.41622 .32975 m
.41233 .312 L
s
.41233 .312 m
.3701 .29548 L
s
.297 .436 .846 r
.50026 .5911 m .50662 .59313 L .50981 .57019 L p F P
0 0 0 r
s
.24 .35 .67 r
.50675 .59219 m
.50714 .59231 L
s
.297 .436 .846 r
.51918 .57326 m .50981 .57019 L .50662 .59313 L p F P
0 0 0 r
s
.282 .401 .768 r
.56774 .50835 m .5841 .51409 L .59235 .48976 L p F P
0 0 0 r
s
.282 .401 .768 r
.59235 .48976 m .57442 .48333 L .56774 .50835 L p F P
0 0 0 r
s
.274 .386 .737 r
.55631 .47683 m .57442 .48333 L .57906 .45894 L p F P
0 0 0 r
s
.24 .35 .67 r
.57768 .46003 m
.5779 .45851 L
s
.274 .386 .737 r
.57906 .45894 m .55984 .45189 L .55631 .47683 L p F P
0 0 0 r
s
.738 .216 .096 r
.41496 .54134 m .42279 .53285 L .43597 .55683 L p F P
0 0 0 r
s
.866 .256 .112 r
.47745 .58851 m .47385 .59205 L .4612 .56855 L p F P
0 0 0 r
s
.83 .24 .1 r
.47349 .59168 m
.47359 .59157 L
s
.866 .256 .112 r
.45596 .57386 m .4612 .56855 L .47385 .59205 L p F P
0 0 0 r
s
.47 .135 .064 r
.41278 .47155 m .40295 .48287 L .3969 .45843 L p F P
0 0 0 r
s
.47 .135 .064 r
.3969 .45843 m .40729 .44616 L .41278 .47155 L p F P
0 0 0 r
s
.296 .43 .832 r
.52849 .5763 m .53776 .57933 L .54911 .55712 L p F P
0 0 0 r
s
.83 .24 .1 r
.51014 .59973 m
.53274 .5784 L
s
.5086 .60119 m
.51014 .59973 L
s
.296 .43 .832 r
.56105 .56111 m .54911 .55712 L .53776 .57933 L p F P
0 0 0 r
s
.24 .35 .67 r
.2143 .5722 m
.16963 .55878 L
s
.2143 .5722 m
.2248 .56836 L
s
.805 .237 .104 r
.45596 .57386 m .45077 .57912 L .43597 .55683 L p F P
0 0 0 r
s
.83 .24 .1 r
.44253 .33662 m
.45364 .3228 L
s
.4411 .3384 m
.44253 .33662 L
s
.297 .436 .846 r
.49389 .58906 m .50026 .5911 L .50039 .56712 L p F P
0 0 0 r
s
.24 .35 .67 r
.50027 .59011 m
.50066 .59024 L
s
.297 .436 .846 r
.50981 .57019 m .50039 .56712 L .50026 .5911 L p F P
0 0 0 r
s
.24 .35 .67 r
.36902 .59772 m
.32617 .58459 L
s
.36902 .59772 m
.38451 .58103 L
s
.292 .422 .814 r
.54911 .55712 m .56105 .56111 L .57355 .53812 L p F P
0 0 0 r
s
.83 .24 .1 r
.54646 .2179 m
.56992 .2142 L
s
.56992 .2142 m
.59544 .18321 L
s
.7482 .47645 m
.77745 .45096 L
s
.7482 .47645 m
.73697 .49508 L
s
.81144 .37662 m
.80456 .3496 L
s
.249 .344 .649 r
.50086 .40575 m .52139 .41343 L .52147 .392 L p F P
0 0 0 r
s
.249 .344 .649 r
.52147 .392 m .50086 .38417 L .50086 .40575 L p F P
0 0 0 r
s
.24 .35 .67 r
.50085 .38544 m
.50086 .38544 L
s
.288 .412 .793 r
.55922 .53321 m .57355 .53812 L .5841 .51409 L p F P
0 0 0 r
s
.288 .412 .793 r
.5841 .51409 m .56774 .50835 L .55922 .53321 L p F P
0 0 0 r
s
.229 .31 .58 r
.45889 .36821 m .48 .37624 L .48047 .35825 L p F P
0 0 0 r
s
.229 .31 .58 r
.48047 .35825 m .45985 .35031 L .45889 .36821 L p F P
0 0 0 r
s
.297 .436 .846 r
.48749 .58701 m .49389 .58906 L .49092 .56402 L p F P
0 0 0 r
s
.24 .35 .67 r
.48463 .5851 m
.48763 .58607 L
s
.49377 .58803 m
.49416 .58816 L
s
.297 .436 .846 r
.50039 .56712 m .49092 .56402 L .49389 .58906 L p F P
0 0 0 r
s
.292 .422 .814 r
.57355 .53812 m .55922 .53321 L .54911 .55712 L p F P
0 0 0 r
s
.296 .43 .832 r
.51918 .57326 m .52849 .5763 L .53709 .55309 L p F P
0 0 0 r
s
.296 .43 .832 r
.54911 .55712 m .53709 .55309 L .52849 .5763 L p F P
0 0 0 r
s
.866 .256 .112 r
.48107 .58496 m .47745 .58851 L .46648 .56319 L p F P
0 0 0 r
s
.83 .24 .1 r
.47712 .58811 m
.47723 .58801 L
s
.866 .256 .112 r
.4612 .56855 m .46648 .56319 L .47745 .58851 L p F P
0 0 0 r
s
.34 .095 .048 r
.41788 .43364 m .40729 .44616 L .40435 .42249 L p F P
0 0 0 r
s
.34 .095 .048 r
.40435 .42249 m .41525 .40933 L .41788 .43364 L p F P
0 0 0 r
s
.24 .35 .67 r
.32684 .27856 m
.32146 .26777 L
s
.32146 .26777 m
.27792 .25064 L
s
.41622 .32975 m
.4394 .33871 L
s
.143 .041 .02 r
.43752 .36009 m .42611 .3741 L .42783 .35613 L p F P
0 0 0 r
s
.83 .24 .1 r
.42693 .37549 m
.42743 .37247 L
s
.43003 .35703 m
.43079 .35246 L
s
.143 .041 .02 r
.42783 .35613 m .43899 .34227 L .43752 .36009 L p F P
0 0 0 r
s
.24 .35 .67 r
.42681 .59424 m
.38451 .58103 L
s
.282 .401 .768 r
.55123 .50255 m .56774 .50835 L .57442 .48333 L p F P
0 0 0 r
s
.24 .35 .67 r
.567 .50826 m
.56704 .5081 L
s
.57306 .48446 m
.57344 .48297 L
s
.567 .50826 m
.56769 .5085 L
s
.282 .401 .768 r
.57442 .48333 m .55631 .47683 L .55123 .50255 L p F P
0 0 0 r
s
.297 .436 .846 r
.48107 .58496 m .48749 .58701 L .4814 .56091 L p F P
0 0 0 r
s
.24 .35 .67 r
.48022 .58369 m
.48108 .58397 L
s
.83 .24 .1 r
.48077 .58452 m
.48108 .58422 L
s
.297 .436 .846 r
.49092 .56402 m .4814 .56091 L .48749 .58701 L p F P
0 0 0 r
s
.83 .24 .1 r
.48342 .58192 m
.4848 .58057 L
s
.263 .368 .699 r
.52073 .43754 m .5404 .44476 L .54168 .42102 L p F P
0 0 0 r
s
.24 .35 .67 r
.54037 .42205 m
.54044 .42055 L
s
.263 .368 .699 r
.54168 .42102 m .52139 .41343 L .52073 .43754 L p F P
0 0 0 r
s
.292 .422 .814 r
.53709 .55309 m .54911 .55712 L .55922 .53321 L p F P
0 0 0 r
s
.575 .166 .076 r
.42068 .49786 m .41167 .50793 L .40295 .48287 L p F P
0 0 0 r
s
.575 .166 .076 r
.40295 .48287 m .41278 .47155 L .42068 .49786 L p F P
0 0 0 r
s
.212 .061 .032 r
.42638 .39588 m .41525 .40933 L .41494 .38782 L p F P
0 0 0 r
s
.212 .061 .032 r
.41494 .38782 m .42611 .3741 L .42638 .39588 L p F P
0 0 0 r
s
.83 .24 .1 r
.42614 .37645 m
.42693 .37549 L
s
.805 .237 .104 r
.43597 .55683 m .44263 .54984 L .45596 .57386 L p F P
0 0 0 r
s
.738 .216 .096 r
.44263 .54984 m .43597 .55683 L .42279 .53285 L p F P
0 0 0 r
s
.805 .237 .104 r
.4612 .56855 m .45596 .57386 L .44263 .54984 L p F P
0 0 0 r
s
.24 .35 .67 r
.42681 .59424 m
.44303 .57178 L
s
.274 .386 .737 r
.538 .47025 m .55631 .47683 L .55984 .45189 L p F P
0 0 0 r
s
.274 .386 .737 r
.55984 .45189 m .5404 .44476 L .538 .47025 L p F P
0 0 0 r
s
.24 .35 .67 r
.55761 .53465 m
.567 .50826 L
s
.296 .43 .832 r
.50981 .57019 m .51918 .57326 L .52498 .54904 L p F P
0 0 0 r
s
.296 .43 .832 r
.53709 .55309 m .52498 .54904 L .51918 .57326 L p F P
0 0 0 r
s
.83 .24 .1 r
.45364 .3228 m
.46361 .30235 L
s
.46361 .30235 m
.487 .27307 L
s
.64271 .56583 m
.66989 .54211 L
s
.64271 .56583 m
.61687 .56852 L
s
.866 .256 .112 r
.46648 .56319 m .47182 .55777 L .48107 .58496 L p F P
0 0 0 r
s
.24 .35 .67 r
.44303 .57178 m
.4717 .58096 L
s
.297 .436 .846 r
.4814 .56091 m .47182 .55777 L .48107 .58496 L p F P
0 0 0 r
s
.24 .35 .67 r
.47505 .58204 m
.47748 .58281 L
s
.4717 .58096 m
.47505 .58204 L
s
.83 .24 .1 r
.78252 .42855 m
.81266 .40191 L
s
.78252 .42855 m
.77745 .45096 L
s
.288 .412 .793 r
.54475 .52825 m .55922 .53321 L .56774 .50835 L p F P
0 0 0 r
s
.288 .412 .793 r
.56774 .50835 m .55123 .50255 L .54475 .52825 L p F P
0 0 0 r
s
.292 .422 .814 r
.55922 .53321 m .54475 .52825 L .53709 .55309 L p F P
0 0 0 r
s
.663 .193 .087 r
.43074 .52424 m .42279 .53285 L .41167 .50793 L p F P
0 0 0 r
s
.663 .193 .087 r
.41167 .50793 m .42068 .49786 L .43074 .52424 L p F P
0 0 0 r
s
.738 .216 .096 r
.42279 .53285 m .43074 .52424 L .44263 .54984 L p F P
0 0 0 r
s
.24 .35 .67 r
.26913 .58176 m
.2248 .56836 L
s
.26913 .58176 m
.28227 .57115 L
s
.249 .344 .649 r
.48007 .39798 m .50086 .40575 L .50086 .38417 L p F P
0 0 0 r
s
.249 .344 .649 r
.50086 .38417 m .48 .37624 L .48007 .39798 L p F P
0 0 0 r
s
.292 .422 .814 r
.52498 .54904 m .53709 .55309 L .54475 .52825 L p F P
0 0 0 r
s
.296 .43 .832 r
.50039 .56712 m .50981 .57019 L .51279 .54496 L p F P
0 0 0 r
s
.83 .24 .1 r
.4848 .58057 m
.4867 .57871 L
s
.296 .43 .832 r
.52498 .54904 m .51279 .54496 L .50981 .57019 L p F P
0 0 0 r
s
.229 .31 .58 r
.43752 .36009 m .45889 .36821 L .45985 .35031 L p F P
0 0 0 r
s
.24 .35 .67 r
.45832 .34972 m
.45839 .35095 L
s
.229 .31 .58 r
.45985 .35031 m .43899 .34227 L .43752 .36009 L p F P
0 0 0 r
s
.83 .24 .1 r
.62163 .18565 m
.59544 .18321 L
s
.282 .401 .768 r
.53456 .4967 m .55123 .50255 L .55631 .47683 L p F P
0 0 0 r
s
.282 .401 .768 r
.55631 .47683 m .538 .47025 L .53456 .4967 L p F P
0 0 0 r
s
.805 .237 .104 r
.46648 .56319 m .4612 .56855 L .44938 .54277 L p F P
0 0 0 r
s
.805 .237 .104 r
.44263 .54984 m .44938 .54277 L .4612 .56855 L p F P
0 0 0 r
s
.83 .24 .1 r
.56256 .58814 m
.58815 .5648 L
s
.56256 .58814 m
.53274 .5784 L
s
.47 .135 .064 r
.42279 .46002 m .41278 .47155 L .40729 .44616 L p F P
0 0 0 r
s
.47 .135 .064 r
.40729 .44616 m .41788 .43364 L .42279 .46002 L p F P
0 0 0 r
s
.263 .368 .699 r
.50083 .43024 m .52073 .43754 L .52139 .41343 L p F P
0 0 0 r
s
.263 .368 .699 r
.52139 .41343 m .50086 .40575 L .50083 .43024 L p F P
0 0 0 r
s
.24 .35 .67 r
.3733 .31316 m
.3701 .29548 L
s
.3701 .29548 m
.32684 .27856 L
s
.83 .24 .1 r
.487 .27307 m
.50227 .25776 L
s
.50227 .25776 m
.52661 .22739 L
s
.296 .43 .832 r
.49092 .56402 m .50039 .56712 L .50051 .54086 L p F P
0 0 0 r
s
.296 .43 .832 r
.51279 .54496 m .50051 .54086 L .50039 .56712 L p F P
0 0 0 r
s
.274 .386 .737 r
.51949 .46361 m .538 .47025 L .5404 .44476 L p F P
0 0 0 r
s
.24 .35 .67 r
.53704 .44778 m
.53769 .44376 L
s
.274 .386 .737 r
.5404 .44476 m .52073 .43754 L .51949 .46361 L p F P
0 0 0 r
s
.738 .216 .096 r
.44938 .54277 m .44263 .54984 L .43074 .52424 L p F P
0 0 0 r
s
.292 .422 .814 r
.54475 .52825 m .53017 .52325 L .52498 .54904 L p F P
0 0 0 r
s
.288 .412 .793 r
.53017 .52325 m .54475 .52825 L .55123 .50255 L p F P
0 0 0 r
s
.288 .412 .793 r
.55123 .50255 m .53456 .4967 L .53017 .52325 L p F P
0 0 0 r
s
.292 .422 .814 r
.51279 .54496 m .52498 .54904 L .53017 .52325 L p F P
0 0 0 r
s
.83 .24 .1 r
.69177 .53356 m
.72015 .50901 L
s
.69177 .53356 m
.66989 .54211 L
s
.24 .35 .67 r
.17938 .55462 m
.16963 .55878 L
s
.32617 .58459 m
.28227 .57115 L
s
.32617 .58459 m
.34119 .5675 L
s
.83 .24 .1 r
.81266 .40191 m
.81144 .37662 L
s
.34 .095 .048 r
.42869 .42087 m .41788 .43364 L .41525 .40933 L p F P
0 0 0 r
s
.34 .095 .048 r
.41525 .40933 m .42638 .39588 L .42869 .42087 L p F P
0 0 0 r
s
.249 .344 .649 r
.45904 .39012 m .48007 .39798 L .48 .37624 L p F P
0 0 0 r
s
.249 .344 .649 r
.48 .37624 m .45889 .36821 L .45904 .39012 L p F P
0 0 0 r
s
.296 .43 .832 r
.4814 .56091 m .49092 .56402 L .48814 .53672 L p F P
0 0 0 r
s
.296 .43 .832 r
.50051 .54086 m .48814 .53672 L .49092 .56402 L p F P
0 0 0 r
s
.83 .24 .1 r
.4867 .57871 m
.50305 .56264 L
s
.575 .166 .076 r
.42984 .4876 m .42068 .49786 L .41278 .47155 L p F P
0 0 0 r
s
.575 .166 .076 r
.41278 .47155 m .42279 .46002 L .42984 .4876 L p F P
0 0 0 r
s
.83 .24 .1 r
.44107 .35815 m
.44974 .34751 L
s
.805 .237 .104 r
.47182 .55777 m .46648 .56319 L .45622 .5356 L p F P
0 0 0 r
s
.805 .237 .104 r
.44938 .54277 m .45622 .5356 L .46648 .56319 L p F P
0 0 0 r
s
.738 .216 .096 r
.43074 .52424 m .43881 .51549 L .44938 .54277 L p F P
0 0 0 r
s
.663 .193 .087 r
.43881 .51549 m .43074 .52424 L .42068 .49786 L p F P
0 0 0 r
s
.282 .401 .768 r
.51772 .49079 m .53456 .4967 L .538 .47025 L p F P
0 0 0 r
s
.282 .401 .768 r
.538 .47025 m .51949 .46361 L .51772 .49079 L p F P
0 0 0 r
s
.292 .422 .814 r
.50051 .54086 m .51279 .54496 L .51546 .51821 L p F P
0 0 0 r
s
.292 .422 .814 r
.53017 .52325 m .51546 .51821 L .51279 .54496 L p F P
0 0 0 r
s
.212 .061 .032 r
.43775 .38215 m .42638 .39588 L .42611 .3741 L p F P
0 0 0 r
s
.212 .061 .032 r
.42611 .3741 m .43752 .36009 L .43775 .38215 L p F P
0 0 0 r
s
.288 .412 .793 r
.51546 .51821 m .53017 .52325 L .53456 .4967 L p F P
0 0 0 r
s
.663 .193 .087 r
.42068 .49786 m .42984 .4876 L .43881 .51549 L p F P
0 0 0 r
s
.24 .35 .67 r
.27792 .25064 m
.28251 .26123 L
s
.83 .24 .1 r
.52661 .22739 m
.54646 .2179 L
s
.54646 .2179 m
.57186 .18652 L
s
.24 .35 .67 r
.41683 .35352 m
.41622 .32975 L
s
.41622 .32975 m
.3733 .31316 L
s
.38451 .58103 m
.34119 .5675 L
s
.38451 .58103 m
.40041 .55814 L
s
.40041 .55814 m
.44303 .57178 L
s
.263 .368 .699 r
.4807 .42286 m .50083 .43024 L .50086 .40575 L p F P
0 0 0 r
s
.24 .35 .67 r
.49947 .40692 m
.49958 .40527 L
s
.263 .368 .699 r
.50086 .40575 m .48007 .39798 L .4807 .42286 L p F P
0 0 0 r
s
.296 .43 .832 r
.47182 .55777 m .4814 .56091 L .47568 .53255 L p F P
0 0 0 r
s
.296 .43 .832 r
.48814 .53672 m .47568 .53255 L .4814 .56091 L p F P
0 0 0 r
s
.288 .412 .793 r
.53456 .4967 m .51772 .49079 L .51546 .51821 L p F P
0 0 0 r
s
.274 .386 .737 r
.50078 .45689 m .51949 .46361 L .52073 .43754 L p F P
0 0 0 r
s
.274 .386 .737 r
.52073 .43754 m .50083 .43024 L .50078 .45689 L p F P
0 0 0 r
s
.83 .24 .1 r
.73697 .49508 m
.76646 .46958 L
s
.73697 .49508 m
.72015 .50901 L
s
.738 .216 .096 r
.45622 .5356 m .44938 .54277 L .43881 .51549 L p F P
0 0 0 r
s
.83 .24 .1 r
.53274 .5784 m
.55792 .55464 L
s
.50305 .56264 m
.53274 .5784 L
s
.24 .35 .67 r
.41683 .35352 m
.43671 .36108 L
s
.292 .422 .814 r
.48814 .53672 m .50051 .54086 L .50062 .51313 L p F P
0 0 0 r
s
.292 .422 .814 r
.51546 .51821 m .50062 .51313 L .50051 .54086 L p F P
0 0 0 r
s
.83 .24 .1 r
.61687 .56852 m
.64386 .54453 L
s
.61687 .56852 m
.58815 .5648 L
s
.805 .237 .104 r
.45622 .5356 m .46314 .52835 L .47182 .55777 L p F P
0 0 0 r
s
.24 .35 .67 r
.44303 .57178 m
.45866 .54416 L
s
.296 .43 .832 r
.47568 .53255 m .46314 .52835 L .47182 .55777 L p F P
0 0 0 r
s
.24 .35 .67 r
.45866 .54416 m
.46321 .54566 L
s
.46321 .54566 m
.46713 .54696 L
s
.83 .24 .1 r
.47035 .54646 m
.47253 .54422 L
s
.47253 .54422 m
.47508 .54161 L
s
.24 .35 .67 r
.2248 .56836 m
.17938 .55462 L
s
.2248 .56836 m
.2373 .55737 L
s
.288 .412 .793 r
.50062 .51313 m .51546 .51821 L .51772 .49079 L p F P
0 0 0 r
s
.249 .344 .649 r
.43775 .38215 m .45904 .39012 L .45889 .36821 L p F P
0 0 0 r
s
.249 .344 .649 r
.45889 .36821 m .43752 .36009 L .43775 .38215 L p F P
0 0 0 r
s
.83 .24 .1 r
.43902 .36066 m
.44107 .35815 L
s
.47 .135 .064 r
.43299 .44826 m .42279 .46002 L .41788 .43364 L p F P
0 0 0 r
s
.47 .135 .064 r
.41788 .43364 m .42869 .42087 L .43299 .44826 L p F P
0 0 0 r
s
.282 .401 .768 r
.50071 .48483 m .51772 .49079 L .51949 .46361 L p F P
0 0 0 r
s
.282 .401 .768 r
.51949 .46361 m .50078 .45689 L .50071 .48483 L p F P
0 0 0 r
s
.83 .24 .1 r
.44974 .34751 m
.45364 .3228 L
s
.45364 .3228 m
.47718 .2935 L
s
.288 .412 .793 r
.51772 .49079 m .50071 .48483 L .50062 .51313 L p F P
0 0 0 r
s
.83 .24 .1 r
.59544 .18321 m
.57186 .18652 L
s
.77745 .45096 m
.80796 .42439 L
s
.77745 .45096 m
.76646 .46958 L
s
.738 .216 .096 r
.43881 .51549 m .447 .50662 L .45622 .5356 L p F P
0 0 0 r
s
.663 .193 .087 r
.447 .50662 m .43881 .51549 L .42984 .4876 L p F P
0 0 0 r
s
.263 .368 .699 r
.46033 .41539 m .4807 .42286 L .48007 .39798 L p F P
0 0 0 r
s
.263 .368 .699 r
.48007 .39798 m .45904 .39012 L .46033 .41539 L p F P
0 0 0 r
s
.292 .422 .814 r
.47568 .53255 m .48814 .53672 L .48565 .508 L p F P
0 0 0 r
s
.292 .422 .814 r
.50062 .51313 m .48565 .508 L .48814 .53672 L p F P
0 0 0 r
s
.274 .386 .737 r
.48186 .4501 m .50078 .45689 L .50083 .43024 L p F P
0 0 0 r
s
.274 .386 .737 r
.50083 .43024 m .4807 .42286 L .48186 .4501 L p F P
0 0 0 r
s
.24 .35 .67 r
.32931 .29616 m
.32684 .27856 L
s
.32684 .27856 m
.28251 .26123 L
s
.738 .216 .096 r
.46314 .52835 m .45622 .5356 L .447 .50662 L p F P
0 0 0 r
s
.575 .166 .076 r
.43917 .47717 m .42984 .4876 L .42279 .46002 L p F P
0 0 0 r
s
.575 .166 .076 r
.42279 .46002 m .43299 .44826 L .43917 .47717 L p F P
0 0 0 r
s
.34 .095 .048 r
.43972 .40783 m .42869 .42087 L .42638 .39588 L p F P
0 0 0 r
s
.34 .095 .048 r
.42638 .39588 m .43775 .38215 L .43972 .40783 L p F P
0 0 0 r
s
.288 .412 .793 r
.48565 .508 m .50062 .51313 L .50071 .48483 L p F P
0 0 0 r
s
.663 .193 .087 r
.42984 .4876 m .43917 .47717 L .447 .50662 L p F P
0 0 0 r
s
.83 .24 .1 r
.50305 .56264 m
.52775 .5384 L
s
.47508 .54161 m
.50305 .56264 L
s
.24 .35 .67 r
.41586 .53006 m
.45866 .54416 L
s
.45866 .54416 m
.46208 .53658 L
s
.46208 .53658 m
.4627 .53521 L
s
.28227 .57115 m
.2373 .55737 L
s
.28227 .57115 m
.2968 .55363 L
s
.282 .401 .768 r
.48353 .4788 m .50071 .48483 L .50078 .45689 L p F P
0 0 0 r
s
.282 .401 .768 r
.50078 .45689 m .48186 .4501 L .48353 .4788 L p F P
0 0 0 r
s
.292 .422 .814 r
.46314 .52835 m .47568 .53255 L .47055 .50282 L p F P
0 0 0 r
s
.292 .422 .814 r
.48565 .508 m .47055 .50282 L .47568 .53255 L p F P
0 0 0 r
s
.288 .412 .793 r
.50071 .48483 m .48353 .4788 L .48565 .508 L p F P
0 0 0 r
s
.83 .24 .1 r
.46799 .53438 m
.47508 .54161 L
s
.47718 .2935 m
.487 .27307 L
s
.487 .27307 m
.5114 .24253 L
s
.66989 .54211 m
.69823 .51737 L
s
.66989 .54211 m
.64386 .54453 L
s
.47508 .54161 m
.49923 .51684 L
s
.80796 .42439 m
.81266 .40191 L
s
.24 .35 .67 r
.37325 .33698 m
.3733 .31316 L
s
.3733 .31316 m
.32931 .29616 L
s
.34119 .5675 m
.2968 .55363 L
s
.34119 .5675 m
.35674 .54415 L
s
.274 .386 .737 r
.46274 .44323 m .48186 .4501 L .4807 .42286 L p F P
0 0 0 r
s
.274 .386 .737 r
.4807 .42286 m .46033 .41539 L .46274 .44323 L p F P
0 0 0 r
s
.288 .412 .793 r
.47055 .50282 m .48565 .508 L .48353 .4788 L p F P
0 0 0 r
s
.24 .35 .67 r
.40041 .55814 m
.35674 .54415 L
s
.40041 .55814 m
.41586 .53006 L
s
.263 .368 .699 r
.43972 .40783 m .46033 .41539 L .45904 .39012 L p F P
0 0 0 r
s
.24 .35 .67 r
.45757 .39146 m
.45772 .38962 L
s
.263 .368 .699 r
.45904 .39012 m .43775 .38215 L .43972 .40783 L p F P
0 0 0 r
s
.83 .24 .1 r
.43952 .39086 m
.44017 .39008 L
s
.44017 .39008 m
.45238 .37546 L
s
.738 .216 .096 r
.447 .50662 m .45532 .49761 L .46314 .52835 L p F P
0 0 0 r
s
.663 .193 .087 r
.45532 .49761 m .447 .50662 L .43917 .47717 L p F P
0 0 0 r
s
.24 .35 .67 r
.42999 .49823 m
.45523 .50681 L
s
.292 .422 .814 r
.47055 .50282 m .45532 .49761 L .46314 .52835 L p F P
0 0 0 r
s
.24 .35 .67 r
.45523 .50681 m
.4566 .50728 L
s
.83 .24 .1 r
.45921 .50686 m
.45996 .50605 L
s
.47 .135 .064 r
.44339 .43629 m .43299 .44826 L .42869 .42087 L p F P
0 0 0 r
s
.47 .135 .064 r
.42869 .42087 m .43972 .40783 L .44339 .43629 L p F P
0 0 0 r
s
.24 .35 .67 r
.41396 .38232 m
.43656 .39071 L
s
.43656 .39071 m
.43778 .39117 L
s
.83 .24 .1 r
.58815 .5648 m
.61484 .54044 L
s
.58815 .5648 m
.55792 .55464 L
s
.24 .35 .67 r
.37325 .33698 m
.41683 .35352 L
s
.41396 .38232 m
.41683 .35352 L
s
.282 .401 .768 r
.46618 .47271 m .48353 .4788 L .48186 .4501 L p F P
0 0 0 r
s
.282 .401 .768 r
.48186 .4501 m .46274 .44323 L .46618 .47271 L p F P
0 0 0 r
s
.288 .412 .793 r
.48353 .4788 m .46618 .47271 L .47055 .50282 L p F P
0 0 0 r
s
.24 .35 .67 r
.19121 .54325 m
.17938 .55462 L
s
.83 .24 .1 r
.5114 .24253 m
.52661 .22739 L
s
.52661 .22739 m
.55199 .1957 L
s
.72015 .50901 m
.74975 .4834 L
s
.72015 .50901 m
.69823 .51737 L
s
.288 .412 .793 r
.45532 .49761 m .47055 .50282 L .46618 .47271 L p F P
0 0 0 r
s
.663 .193 .087 r
.43917 .47717 m .44866 .46656 L .45532 .49761 L p F P
0 0 0 r
s
.575 .166 .076 r
.44866 .46656 m .43917 .47717 L .43299 .44826 L p F P
0 0 0 r
s
.575 .166 .076 r
.43299 .44826 m .44339 .43629 L .44866 .46656 L p F P
0 0 0 r
s
.274 .386 .737 r
.44339 .43629 m .46274 .44323 L .46033 .41539 L p F P
0 0 0 r
s
.274 .386 .737 r
.46033 .41539 m .43972 .40783 L .44339 .43629 L p F P
0 0 0 r
s
.24 .35 .67 r
.28251 .26123 m
.28422 .27873 L
s
.83 .24 .1 r
.47355 .31832 m
.44974 .34751 L
s
.45238 .37546 m
.44974 .34751 L
s
.288 .412 .793 r
.46618 .47271 m .44866 .46656 L .45532 .49761 L p F P
0 0 0 r
s
.83 .24 .1 r
.45996 .50605 m
.47393 .49109 L
s
.282 .401 .768 r
.44866 .46656 m .46618 .47271 L .46274 .44323 L p F P
0 0 0 r
s
.83 .24 .1 r
.44329 .42663 m
.46165 .40532 L
s
.282 .401 .768 r
.46274 .44323 m .44339 .43629 L .44866 .46656 L p F P
0 0 0 r
s
.83 .24 .1 r
.44822 .45271 m
.45319 .46252 L
s
.45032 .46573 m
.45319 .46252 L
s
.45021 .46586 m
.45032 .46573 L
s
.24 .35 .67 r
.44724 .46624 m
.44746 .46632 L
s
.44197 .46439 m
.44724 .46624 L
s
.83 .24 .1 r
.57186 .18652 m
.55199 .1957 L
s
.24 .35 .67 r
.41586 .53006 m
.372 .5156 L
s
.41586 .53006 m
.42999 .49823 L
s
.2373 .55737 m
.19121 .54325 L
s
.2373 .55737 m
.25129 .53942 L
s
.83 .24 .1 r
.76646 .46958 m
.79724 .44297 L
s
.76646 .46958 m
.74975 .4834 L
s
.24 .35 .67 r
.44197 .46439 m
.44328 .45955 L
s
.44328 .45955 m
.44498 .45325 L
s
.40767 .41474 m
.43895 .42605 L
s
.43895 .42605 m
.44145 .42695 L
s
.83 .24 .1 r
.55792 .55464 m
.5842 .52984 L
s
.55792 .55464 m
.52775 .5384 L
s
.24 .35 .67 r
.32859 .32001 m
.32931 .29616 L
s
.32931 .29616 m
.28422 .27873 L
s
.83 .24 .1 r
.64386 .54453 m
.67204 .51949 L
s
.64386 .54453 m
.61484 .54044 L
s
.24 .35 .67 r
.2968 .55363 m
.25129 .53942 L
s
.2968 .55363 m
.31198 .52982 L
s
.35674 .54415 m
.31198 .52982 L
s
.35674 .54415 m
.372 .5156 L
s
.42999 .49823 m
.38609 .4833 L
s
.42999 .49823 m
.44197 .46439 L
s
.39821 .44904 m
.44197 .46439 L
s
.83 .24 .1 r
.47355 .31832 m
.47718 .2935 L
s
.47718 .2935 m
.50176 .26292 L
s
.24 .35 .67 r
.40767 .41474 m
.41396 .38232 L
s
.41396 .38232 m
.36983 .36593 L
s
.32859 .32001 m
.37325 .33698 L
s
.36983 .36593 m
.37325 .33698 L
s
.83 .24 .1 r
.79724 .44297 m
.80796 .42439 L
s
.47393 .49109 m
.45319 .46252 L
s
.45319 .46252 m
.47728 .4356 L
s
.52775 .5384 m
.55352 .51309 L
s
.52775 .5384 m
.49923 .51684 L
s
.49923 .51684 m
.47393 .49109 L
s
.47393 .49109 m
.49858 .46468 L
s
.46165 .40532 m
.45238 .37546 L
s
.45238 .37546 m
.47655 .3465 L
s
.50176 .26292 m
.5114 .24253 L
s
.5114 .24253 m
.53688 .21065 L
s
.69823 .51737 m
.72782 .49153 L
s
.69823 .51737 m
.67204 .51949 L
s
.49923 .51684 m
.52445 .49099 L
s
.24 .35 .67 r
.372 .5156 m
.32703 .50078 L
s
.372 .5156 m
.38609 .4833 L
s
.20464 .52485 m
.19121 .54325 L
s
.39821 .44904 m
.40767 .41474 L
s
.40767 .41474 m
.36309 .39862 L
s
.83 .24 .1 r
.61484 .54044 m
.64271 .51501 L
s
.61484 .54044 m
.5842 .52984 L
s
.24 .35 .67 r
.28422 .27873 m
.28279 .30262 L
s
.25129 .53942 m
.20464 .52485 L
s
.25129 .53942 m
.26609 .51512 L
s
.31198 .52982 m
.26609 .51512 L
s
.31198 .52982 m
.32703 .50078 L
s
.83 .24 .1 r
.55199 .1957 m
.53688 .21065 L
s
.74975 .4834 m
.78067 .45665 L
s
.74975 .4834 m
.72782 .49153 L
s
.24 .35 .67 r
.38609 .4833 m
.34108 .468 L
s
.38609 .4833 m
.39821 .44904 L
s
.39821 .44904 m
.35334 .43329 L
s
.36309 .39862 m
.36983 .36593 L
s
.36983 .36593 m
.32458 .34913 L
s
.28279 .30262 m
.32859 .32001 L
s
.32458 .34913 m
.32859 .32001 L
s
.83 .24 .1 r
.49842 .28784 m
.47355 .31832 L
s
.47655 .3465 m
.47355 .31832 L
s
.47728 .4356 m
.46165 .40532 L
s
.46165 .40532 m
.48629 .37673 L
s
.78067 .45665 m
.79724 .44297 L
s
.5842 .52984 m
.61165 .50393 L
s
.5842 .52984 m
.55352 .51309 L
s
.67204 .51949 m
.70146 .49333 L
s
.67204 .51949 m
.64271 .51501 L
s
.24 .35 .67 r
.32703 .50078 m
.28091 .48558 L
s
.32703 .50078 m
.34108 .468 L
s
.35334 .43329 m
.36309 .39862 L
s
.36309 .39862 m
.31738 .3821 L
s
.83 .24 .1 r
.49842 .28784 m
.50176 .26292 L
s
.50176 .26292 m
.52744 .23097 L
s
.49858 .46468 m
.47728 .4356 L
s
.47728 .4356 m
.50245 .40747 L
s
.24 .35 .67 r
.21902 .50005 m
.20464 .52485 L
s
.26609 .51512 m
.21902 .50005 L
s
.26609 .51512 m
.28091 .48558 L
s
.34108 .468 m
.29492 .45231 L
s
.34108 .468 m
.35334 .43329 L
s
.35334 .43329 m
.30731 .41715 L
s
.83 .24 .1 r
.55352 .51309 m
.58045 .48664 L
s
.55352 .51309 m
.52445 .49099 L
s
.24 .35 .67 r
.31738 .3821 m
.32458 .34913 L
s
.32458 .34913 m
.27817 .3319 L
s
.28279 .30262 m
.27817 .3319 L
s
.83 .24 .1 r
.52445 .49099 m
.49858 .46468 L
s
.49858 .46468 m
.52433 .43709 L
s
.48629 .37673 m
.47655 .3465 L
s
.47655 .3465 m
.50181 .31625 L
s
.53688 .21065 m
.52744 .23097 L
s
.72782 .49153 m
.75874 .46454 L
s
.72782 .49153 m
.70146 .49333 L
s
.52445 .49099 m
.55081 .46396 L
s
.64271 .51501 m
.67184 .48843 L
s
.64271 .51501 m
.61165 .50393 L
s
.24 .35 .67 r
.28091 .48558 m
.2336 .46998 L
s
.28091 .48558 m
.29492 .45231 L
s
.30731 .41715 m
.31738 .3821 L
s
.31738 .3821 m
.27048 .36514 L
s
.83 .24 .1 r
.75874 .46454 m
.78067 .45665 L
s
.24 .35 .67 r
.2336 .46998 m
.21902 .50005 L
s
.83 .24 .1 r
.52441 .25597 m
.49842 .28784 L
s
.50181 .31625 m
.49842 .28784 L
s
.24 .35 .67 r
.29492 .45231 m
.24756 .4362 L
s
.29492 .45231 m
.30731 .41715 L
s
.30731 .41715 m
.26009 .40058 L
s
.83 .24 .1 r
.50245 .40747 m
.48629 .37673 L
s
.48629 .37673 m
.51204 .34683 L
s
.24 .35 .67 r
.27817 .3319 m
.27048 .36514 L
s
.83 .24 .1 r
.61165 .50393 m
.64035 .47684 L
s
.61165 .50393 m
.58045 .48664 L
s
.70146 .49333 m
.73224 .46598 L
s
.70146 .49333 m
.67184 .48843 L
s
.52744 .23097 m
.52441 .25597 L
s
.52433 .43709 m
.50245 .40747 L
s
.50245 .40747 m
.52878 .37805 L
s
.24 .35 .67 r
.24756 .4362 m
.2336 .46998 L
s
.27048 .36514 m
.26009 .40058 L
s
.83 .24 .1 r
.58045 .48664 m
.60862 .45898 L
s
.58045 .48664 m
.55081 .46396 L
s
.55081 .46396 m
.52433 .43709 L
s
.52433 .43709 m
.55128 .40822 L
s
.51204 .34683 m
.50181 .31625 L
s
.50181 .31625 m
.52824 .2846 L
s
.73224 .46598 m
.75874 .46454 L
s
.55081 .46396 m
.57838 .4357 L
s
.24 .35 .67 r
.26009 .40058 m
.24756 .4362 L
s
.83 .24 .1 r
.67184 .48843 m
.70231 .46062 L
s
.67184 .48843 m
.64035 .47684 L
s
.52441 .25597 m
.52824 .2846 L
s
.52878 .37805 m
.51204 .34683 L
s
.51204 .34683 m
.53899 .31555 L
s
.64035 .47684 m
.67039 .44848 L
s
.64035 .47684 m
.60862 .45898 L
s
.70231 .46062 m
.73224 .46598 L
s
.55128 .40822 m
.52878 .37805 L
s
.52878 .37805 m
.55634 .34725 L
s
.60862 .45898 m
.63812 .43002 L
s
.60862 .45898 m
.57838 .4357 L
s
.57838 .4357 m
.55128 .40822 L
s
.55128 .40822 m
.57949 .378 L
s
.52824 .2846 m
.53899 .31555 L
s
.57838 .4357 m
.60725 .4061 L
s
.67039 .44848 m
.70231 .46062 L
s
.53899 .31555 m
.55634 .34725 L
s
.63812 .43002 m
.67039 .44848 L
s
.55634 .34725 m
.57949 .378 L
s
.60725 .4061 m
.63812 .43002 L
s
.57949 .378 m
.60725 .4061 L
s
0 0 0 r
.25 Mabswid
.11236 .44767 m
.36195 .03848 L
s
.36195 .03848 m
.33874 .3169 L
s
.33874 .3169 m
.06528 .69847 L
s
.06528 .69847 m
.11236 .44767 L
s
.93295 .30234 m
.36195 .03848 L
s
.36195 .03848 m
.33874 .3169 L
s
.33874 .3169 m
.99253 .5665 L
s
.99253 .5665 m
.93295 .30234 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{500, 500},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40007d0001m2000`400?l00000o`00003oo`3ooooe
0?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3o
m^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40
oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?of
k_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3o
ool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^
m03om^h10?ooo`00o`3om^kd0?ofkP40oooo002d0?ofkP800000o`3om^hn0?ofkP40oooo002c0?of
kP80000000<0ooK^000000000000o`3om^hl0?ofkP40oooo002c0?ofkP8000000`3om^h200000?l0
ooK^>P3om^h10?ooo`00/P3om^h00`000000ooK^000000050?ofkP800000o`3om^hh0?ofkP40oooo
002b0?ofkP030000003om^h0000000L0ooK^0P00003o0?ofkSH0ooK^0@3oool00;40ooK^00@00000
0?ofkP3om^h000002@3om^h200000?l0ooK^=03om^h10?ooo`00/03om^h01@000000ooK^0?ofkP3o
m^h0000000/0ooK^0`00003o0?ofkS40ooK^0@3oool00;00ooK^00@000000?ofkP3om^h000003`3o
m^h200000?l0ooK^;`3om^h10?ooo`00[`3om^h01@000000ooK^0?ofkP3om^h000000140ooK^0P00
003o0?ofkRd0ooK^0@3oool00:l0ooK^00D000000?ofkP3om^h0ooK^0000000C0?ofkP800000o`3o
m^h[0?ofkP40oooo002^0?ofkP030000003om^h0ooK^0080ooK^00<000000?ofkP3om^h04`3om^h2
00000?l0ooK^:@3om^h10?ooo`00[@3om^h00`000000ooK^0?ofkP030?ofkP030000003om^h0ooK^
01D0ooK^0`00003o0?ofkRH0ooK^0@3oool00:d0ooK^00<000000?ofkP3om^h00`3om^h00`000000
ooK^0?ofkP0H0?ofkP800000o`3om^hT0?ofkP40oooo002/0?ofkP030000003om^h0ooK^00@0ooK^
00<000000?ofkP3om^h06P3om^h200000?l0ooK^8P3om^h10?ooo`00Z`3om^h00`000000ooK^0?of
kP050?ofkP030000003om^h0ooK^01`0ooK^0P00003o0?ofkR00ooK^0@3oool00:/0ooK^00<00000
0?ofkP3om^h01@3om^h00`000000ooK^0?ofkP0N0?ofkP800000o`3om^hN0?ofkP40oooo002Z0?of
kP030000003om^h0ooK^00H0ooK^00<000000?ofkP3om^h0803om^h200000?l0ooK^703om^h10?oo
o`00ZP3om^h00`000000ooK^0?ofkP060?ofkP030000003om^h0ooK^0280ooK^0`00003o0?ofkQT0
ooK^0@3oool00:T0ooK^00<000000?ofkP3om^h01`3om^h00`000000ooK^0?ofkP0U0?ofkP800000
o`3om^hG0?ofkP40oooo002X0?ofkP030000003om^h0ooK^00L0ooK^00<000000?ofkP3om^h0:03o
m^h200000?l0ooK^5@3om^h10?ooo`00Z03om^h00`000000ooK^0?ofkP070?ofkP030000003om^h0
ooK^02X0ooK^0P00003o0?ofkQ<0ooK^0@3oool00:L0ooK^00<000000?ofkP3om^h0203om^h00`00
0000ooK^0?ofkP0/0?ofkP800000o`3om^hA0?ofkP40oooo002W0?ofkP030000003om^h0ooK^00P0
ooK^00<000000?ofkP3om^h0;P3om^h200000?l0ooK^3`3om^h10?ooo`00YP3om^h00`000000ooK^
0?ofkP090?ofkP030000003om^h0ooK^0300ooK^0`00003o0?ofkP`0ooK^0@3oool00:D0ooK^00<0
00000?ofkP3om^h02P3om^h00`000000ooK^0?ofkP0c0?ofkP800000o`3om^h:0?ofkP40oooo002U
0?ofkP030000003om^h0ooK^00X0ooK^00<000000?ofkP3om^h0=@3om^h200000?l0ooK^203om^h1
0?ooo`00Y03om^h00`000000ooK^0?ofkP0;0?ofkP030000003om^h0ooK^03L0ooK^0P00003o0?of
kPH0ooK^0@3oool00:@0ooK^00<000000?ofkP3om^h02`3om^h00`000000ooK^0?ofkP0i0?ofkP80
0000o`3om^h40?ofkP40oooo002S0?ofkP030000003om^h0ooK^00`0ooK^00<000000?ofkP3om^h0
>`3om^h300000?l0ooK^0@3om^h10?ooo`00XP3om^h00`000000ooK^0?ofkP0=0?ofkP030000003o
m^h0ooK^03h0ooK^0P00003n0?ofkP40oooo002R0?ofkP030000003om^h0ooK^00d0ooK^00<00000
0?ofkP3om^h0@03om^h200000?`0ooK^0@3oool00:40ooK^00<000000?ofkP3om^h03P3om^h00`00
0000ooK^0?ofkP120?ofkP800000nP3om^h10?ooo`00X@3om^h00`000000ooK^0?ofkP0=0?ofkP03
0000003om^h0ooK^04D0ooK^0P00003h0?ofkP40oooo002P0?ofkP030000003om^h0ooK^00h0ooK^
00<000000?ofkP3om^h0A`3om^h200000?H0ooK^0@3oool009l0ooK^00<000000?ofkP3om^h03`3o
m^h00`000000ooK^0?ofkP190?ofkP<00000l`3om^h10?ooo`00W`3om^h00`000000ooK^0?ofkP0?
0?ofkP030000003om^h0ooK^04`0ooK^0P00003a0?ofkP40oooo002N0?ofkP030000003om^h0ooK^
0100ooK^00<000000?ofkP3om^h0CP3om^h200000>l0ooK^0@3oool009h0ooK^00<000000?ofkP3o
m^h0403om^h00`000000ooK^0?ofkP1@0?ofkP800000k@3om^h10?ooo`00W@3om^h00`000000ooK^
0?ofkP0A0?ofkP030000003om^h0ooK^0580ooK^0P00003[0?ofkP40oooo002L0?ofkP030000003o
m^h0ooK^0180ooK^00<000000?ofkP3om^h0E03om^h200000>T0ooK^0@3oool009`0ooK^00<00000
0?ofkP3om^h04P3om^h00`000000ooK^0?ofkP1F0?ofkP<00000iP3om^h10?ooo`00V`3om^h00`00
0000ooK^0?ofkP0C0?ofkP030000003om^h0ooK^05T0ooK^0P00003T0?ofkP40oooo002J0?ofkP03
0000003om^h0ooK^01@0ooK^00<000000?ofkP3om^h0F`3om^h200000>80ooK^0@3oool009X0ooK^
00<000000?ofkP3om^h0503om^h00`000000ooK^0?ofkP1M0?ofkP800000h03om^h10?ooo`00V@3o
m^h00`000000ooK^0?ofkP0E0?ofkP030000003om^h0ooK^05l0ooK^0P00003N0?ofkP40oooo002I
0?ofkP030000003om^h0ooK^01@0ooK^00<000000?ofkP3om^h0HP3om^h200000=`0ooK^0@3oool0
09P0ooK^00<000000?ofkP3om^h05@3om^h00`000000ooK^0?ofkP1T0?ofkP<00000f@3om^h10?oo
o`00U`3om^h00`000000ooK^0?ofkP0F0?ofkP030000003om^h0ooK^06L0ooK^0P00003G0?ofkP40
oooo002G0?ofkP030000003om^h0ooK^01H0ooK^00<000000?ofkP3om^h0J@3om^h200000=D0ooK^
0@3oool009H0ooK^00<000000?ofkP3om^h05`3om^h00`000000ooK^0?ofkP1[0?ofkP800000d`3o
m^h10?ooo`00UP3om^h00`000000ooK^0?ofkP0G0?ofkP030000003om^h0ooK^06d0ooK^0P00003A
0?ofkP40oooo002E0?ofkP030000003om^h0ooK^01P0ooK^00<000000?ofkP3om^h0K`3om^h30000
0<h0ooK^0@3oool009@0ooK^00<000000?ofkP3om^h06@3om^h00`000000ooK^0?ofkP1b0?ofkP80
0000c03om^h10?ooo`00U03om^h00`000000ooK^0?ofkP0I0?ofkP030000003om^h0ooK^07@0ooK^
0P00003:0?ofkP40oooo002C0?ofkP030000003om^h0ooK^01X0ooK^00<000000?ofkP3om^h0MP3o
m^h200000<P0ooK^0@3oool009<0ooK^00<000000?ofkP3om^h06P3om^h00`000000ooK^0?ofkP1h
0?ofkP800000aP3om^h10?ooo`00TP3om^h00`000000ooK^0?ofkP0K0?ofkP030000003om^h0ooK^
07X0ooK^0P0000340?ofkP40oooo002A0?ofkP030000003om^h0ooK^01/0ooK^00<000000?ofkP3o
m^h0O@3om^h300000<40ooK^0@3oool00940ooK^00<000000?ofkP3om^h06`3om^h00`000000ooK^
0?ofkP200?ofkP800000_`3om^h10?ooo`00T03om^h00`000000ooK^0?ofkP0L0?ofkP030000003o
m^h0ooK^0880ooK^0P00002m0?ofkP40oooo002@0?ofkP030000003om^h0ooK^01`0ooK^00<00000
0?ofkP3om^h0Q03om^h200000;/0ooK^0@3oool008l0ooK^00<000000?ofkP3om^h07@3om^h00`00
0000ooK^0?ofkP260?ofkP800000^@3om^h10?ooo`00SP3om^h00`000000ooK^0?ofkP0N0?ofkP03
0000003om^h0ooK^08P0ooK^0P00002g0?ofkP40oooo002>0?ofkP030000003om^h0ooK^01h0ooK^
00<000000?ofkP3om^h0RP3om^h300000;@0ooK^0@3oool008d0ooK^00<000000?ofkP3om^h07`3o
m^h00`000000ooK^0?ofkP2=0?ofkP800000/P3om^h10?ooo`00S03om^h00`000000ooK^0?ofkP0P
0?ofkP030000003om^h0ooK^08l0ooK^0P00002`0?ofkP40oooo002<0?ofkP030000003om^h0ooK^
0200ooK^00<000000?ofkP3om^h0T@3om^h200000:h0ooK^0@3oool008/0ooK^00<000000?ofkP3o
m^h08@3om^h00`000000ooK^0?ofkP2C0?ofkP800000[03om^h10?ooo`00R`3om^h00`000000ooK^
0?ofkP0Q0?ofkP030000003om^h0ooK^09D0ooK^0`00002Y0?ofkP40oooo002:0?ofkP030000003o
m^h0ooK^0280ooK^00<000000?ofkP3om^h0V03om^h200000:L0ooK^0@3oool008T0ooK^00<00000
0?ofkP3om^h08P3om^h00`000000ooK^0?ofkP2K0?ofkP800000Y@3om^h10?ooo`00R@3om^h00`00
0000ooK^0?ofkP0R0?ofkP030000003om^h0ooK^09d0ooK^0P00002S0?ofkP40oooo00280?ofkP03
0000003om^h0ooK^02<0ooK^00<000000?ofkP3om^h0MP3om^h90=@m6B00ooK^0P00002Q0?ofkP40
oooo00280?ofkP030000003om^h0ooK^02<0ooK^00<000000?ofkP3om^h0L03om^h60=@m6@030?of
kP3D?AT0ooK^00H0ooK^203D?ATJ0?ofkP800000W`3om^h10?ooo`00Q`3om^h00`000000ooK^0?of
kP0T0?ofkP030000003om^h0ooK^06/0ooK^1@3D?AT60?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0
e3dI0?ofkP3om^h0103D?ATH0?ofkP<00000W03om^h10?ooo`00QP3om^h00`000000ooK^0?ofkP0U
0?ofkP030000003om^h0ooK^06T0ooK^0`3D?AT90?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI
0?ofkP3om^h01@3om^h30=@m6AP0ooK^0P00002J0?ofkP40oooo00260?ofkP030000003om^h0ooK^
02D0ooK^00<000000?ofkP3om^h0IP3om^h30=@m6@030?ofkP3D?AT0ooK^00T0ooK^00<0e3dI0?of
kP3om^h02P3om^h00`3D?AT0ooK^0?ofkP090?ofkP@0e3dI5P3om^h2000009P0ooK^0@3oool008D0
ooK^00<000000?ofkP3om^h09P3om^h00`000000ooK^0?ofkP1T0?ofkP80e3dI0`3om^h00`3D?AT0
ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h03@3om^h30=@m6AD0
ooK^0P00002F0?ofkP40oooo00250?ofkP030000003om^h0ooK^02H0ooK^00<000000?ofkP3om^h0
HP3om^h20=@m6@D0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m
6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h00P3D?ATE0?ofkP800000U03om^h10?ooo`00Q03o
m^h00`000000ooK^0?ofkP0W0?ofkP030000003om^h0ooK^0640ooK^00<0e3dI0?ofkP3om^h0103o
m^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h03P3o
m^h00`3D?AT0ooK^0?ofkP030?ofkP80e3dI5@3om^h200000980ooK^0@3oool008<0ooK^00<00000
0?ofkP3om^h0:03om^h00`000000ooK^0?ofkP1P0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI
0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI
0?ofkP3om^h01P3om^h30=@m6A@0ooK^0`00002?0?ofkP40oooo00230?ofkP030000003om^h0ooK^
02P0ooK^00<000000?ofkP3om^h0G`3om^h20=@m6@D0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D
?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h02@3om^h20=@m
6AD0ooK^0P00002=0?ofkP40oooo00220?ofkP030000003om^h0ooK^02T0ooK^00<000000?ofkP3o
m^h0GP3om^h20=@m6@D0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP03
0=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h0303om^h20=@m6AD0ooK^0P00002;0?ofkP40
oooo00220?ofkP030000003om^h0ooK^02P0ooK^00<000000?ofkP3om^h0GP3om^h20=@m6@D0ooK^
00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00l0ooK^
00<0e3dI0?ofkP3om^h03`3om^h20=@m6AD0ooK^0P0000290?ofkP40oooo00210?ofkP030000003o
m^h0ooK^02T0ooK^00<000000?ofkP3om^h0G@3om^h20=@m6@D0ooK^00<0e3dI0?ofkP3om^h0203o
m^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h0403o
m^h0103D?AT0ooK^0=@m6@3D?ATE0?ofkP800000Q`3om^h10?ooo`00P03om^h00`000000ooK^0?of
kP0Z0?ofkP030000003om^h0ooK^05`0ooK^0P3D?AT50?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0
e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^0100ooK^00<0
e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP0D0?ofkP<00000Q03om^h10?ooo`00P03om^h0
0`000000ooK^0?ofkP0Z0?ofkP030000003om^h0ooK^05/0ooK^0P3D?AT60?ofkP030=@m6@3om^h0
ooK^00L0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0
ooK^0100ooK^00<0e3dI0?ofkP3om^h0103om^h20=@m6AL0ooK^0P0000220?ofkP40oooo001o0?of
kP030000003om^h0ooK^02/0ooK^00<000000?ofkP3om^h0FP3om^h30=@m6@D0ooK^00<0e3dI0?of
kP3om^h01@3om^h90=@m6@L0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0@0?of
kP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h05P3om^h200000800ooK^0@3oool007l0
ooK^00<000000?ofkP3om^h0:`3om^h00`000000ooK^0?ofkP1I0?ofkP<0e3dI1@3om^h00`3D?AT0
ooK^0?ofkP060=@m6@030?ofkP3D?AT0ooK^00H0ooK^203D?AT?0?ofkP030=@m6@3om^h0ooK^0100
ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP0G0?ofkP800000OP3om^h10?ooo`00
OP3om^h00`000000ooK^0?ofkP0/0?ofkP030000003om^h0ooK^05T0ooK^0P3D?AT50?ofkP@0e3dI
1P3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00@0e3dI2`3om^h00`3D?AT0ooK^
0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00/0ooK^0P3D?ATI0?ofkP800000O03om^h10?ooo`00O@3o
m^h00`000000ooK^0?ofkP0]0?ofkP030000003om^h0ooK^05P0ooK^0P3D?AT40?ofkP80e3dI2P3o
m^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00D0ooK^0`3D?AT70?ofkP030=@m6@3o
m^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0H0?ofkP800000NP3o
m^h10?ooo`00O@3om^h00`000000ooK^0?ofkP0]0?ofkP030000003om^h0ooK^05L0ooK^0`3D?AT2
0?ofkP<0e3dI2P3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00P0ooK^103D?AT2
0?ofkP030=@m6@3om^h0ooK^0100ooK^00<0e3dI0?ofkP3om^h03`3om^h20=@m6AX0ooK^0`00001g
0?ofkP40oooo001l0?ofkP030000003om^h0ooK^02h0ooK^00<000000?ofkP3om^h0EP3om^h00`3D
?AT0ooK^0=@m6@030=@m6@80ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP0;0?of
kP030=@m6@3om^h0ooK^00d0ooK^0`3D?ATA0?ofkP030=@m6@3om^h0ooK^0180ooK^00<0e3dI0?of
kP3om^h06P3om^h2000007D0ooK^0@3oool007/0ooK^00<000000?ofkP3om^h0;`3om^h00`000000
ooK^0?ofkP1F0?ofkP@0e3dI0`3om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00/0
ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP020=@m6@h0ooK^00<0e3dI0?ofkP3o
m^h04P3om^h00`3D?AT0ooK^0=@m6@0M0?ofkP800000L`3om^h10?ooo`00N`3om^h00`000000ooK^
0?ofkP0_0?ofkP030000003om^h0ooK^05D0ooK^103D?AT30?ofkP030=@m6@3om^h0ooK^00L0ooK^
00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00<0ooK^
0P3D?AT;0?ofkP030=@m6@3om^h0ooK^0180ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0N0?ofkP80
0000L@3om^h10?ooo`00NP3om^h00`000000ooK^0?ofkP0_0?ofkP030000003om^h0ooK^05D0ooK^
0P3D?AT00`3om^h0e3dI0?ofkP020?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h0
2P3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00H0ooK^0P3D?AT80?ofkP030=@m
6@3om^h0ooK^0180ooK^00<0e3dI0?ofkP3om^h00`3om^h20=@m6Ah0ooK^0P00001_0?ofkP40oooo
001j0?ofkP030000003om^h0ooK^02l0ooK^00<000000?ofkP3om^h0E03om^h20=@m6@80ooK^00@0
e3dI0?ofkP3om^h0e3dI2P3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00d0ooK^
00<0e3dI0?ofkP3om^h02@3om^h20=@m6@D0ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^
0?ofkP050?ofkP030=@m6@3om^h0ooK^01d0ooK^0P00001]0?ofkP40oooo001i0?ofkP030000003o
m^h0ooK^0300ooK^00<000000?ofkP3om^h0E03om^h20=@m6@030?ofkP3D?AT0e3dI0080ooK^00<0
e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0
e3dI0?ofkP3om^h0303om^h20=@m6@80ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?of
kP070?ofkP030=@m6@3om^h0ooK^01h0ooK^0`00001Z0?ofkP40oooo001h0?ofkP030000003om^h0
ooK^0340ooK^00<000000?ofkP3om^h0D`3om^h20=@m6@060?ofkP3D?AT0ooK^0=@m6@3om^h0e3dI
2@3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h0
3`3om^h20=@m6AD0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP0P0?ofkP800000
J03om^h10?ooo`00N03om^h00`000000ooK^0?ofkP0a0?ofkP030000003om^h0ooK^0580ooK^0P3D
?AT20?ofkP80e3dI00<0ooK^0=@m6@3om^h0203om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3o
m^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h0403om^h0103D?AT0ooK^0=@m6@3D?ATB0?ofkP030=@m
6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h08@3om^h2000006H0ooK^0@3oool007L0ooK^00<0
00000?ofkP3om^h0<P3om^h00`000000ooK^0?ofkP1A0?ofkP80e3dI0P3om^h0103D?AT0ooK^0=@m
6@3D?AT:0?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^
0?ofkP0?0?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^
0?ofkP0=0?ofkP80e3dI8`3om^h2000006@0ooK^0@3oool007L0ooK^00<000000?ofkP3om^h0<P3o
m^h00`000000ooK^0?ofkP1A0?ofkP040=@m6@3om^h0ooK^0=@m6@80ooK^00<0e3dI0?ofkP3om^h0
203om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h0
3`3om^h00`3D?AT0ooK^0?ofkP040?ofkP80e3dI3@3om^h00`3D?AT0ooK^0?ofkP0@0?ofkP030=@m
6@3om^h0ooK^0280ooK^0P00001R0?ofkP40oooo001f0?ofkP030000003om^h0ooK^03<0ooK^00<0
00000?ofkP3om^h0D03om^h20=@m6@030?ofkP3D?AT0ooK^0080ooK^00<0e3dI0?ofkP3om^h01@3o
m^h90=@m6@L0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0@0?ofkP030=@m6@3o
m^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP0B0?ofkP030=@m6@3o
m^h0ooK^02<0ooK^0P00001P0?ofkP40oooo001e0?ofkP030000003om^h0ooK^03@0ooK^00<00000
0?ofkP3om^h0C`3om^h20=@m6@030?ofkP3D?AT0ooK^0080ooK^0P3D?AT00`3om^h0e3dI0=@m6@04
0=@m6@030?ofkP3D?AT0ooK^00H0ooK^2@3D?AT=0?ofkP030=@m6@3om^h0ooK^0100ooK^00<0e3dI
0?ofkP3om^h0203om^h20=@m6@P0ooK^00<0e3dI0?ofkP3om^h0503om^h00`3D?AT0ooK^0?ofkP0T
0?ofkP<00000G@3om^h10?ooo`00M@3om^h00`000000ooK^0?ofkP0=0?ofkP@0?EV[8`3om^h00`00
0000ooK^0?ofkP1>0?ofkP80e3dI00<0ooK^0=@m6@3om^h00P3om^h40=@m6@H0ooK^00<0e3dI0?of
kP3om^h02`3om^h0103D?AT0ooK^0?ofkP3om^h40=@m6@P0ooK^00<0e3dI0?ofkP3om^h0403om^h0
0`3D?AT0ooK^0?ofkP0;0?ofkP80e3dI1P3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0
e3dI02P0ooK^0P00001K0?ofkP40oooo001d0?ofkP030000003om^h0ooK^00/0ooK^0`0mFJ/30?of
kP<0?EV[8@3om^h00`000000ooK^0?ofkP1>0?ofkP050=@m6@3om^h0ooK^0=@m6@3om^h00P3D?AT0
0`3om^h0e3dI0?ofkP060?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h01P3om^h4
0=@m6@<0ooK^00<0e3dI0?ofkP3om^h0403om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0
ooK^0080ooK^00<0e3dI0?ofkP3om^h04`3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI02T0ooK^0P00
001I0?ofkP40oooo001d0?ofkP030000003om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h00P0mFJ/4
0?ofkP@0?EV[7P3om^h00`000000ooK^0?ofkP1=0?ofkP80e3dI00<0ooK^0=@m6@3D?AT00P3D?AT2
0?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP0;
0?ofkP@0e3dI4@3om^h00`3D?AT0ooK^0?ofkP0@0?ofkP80e3dI00<0ooK^0=@m6@3om^h0503om^h0
0`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^02P0ooK^0P00001G0?ofkP40oooo001c0?of
kP030000003om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h00`3om^h203eIZ`80ooK^00<0?EV[0?of
kP0mFJ/0100mFJ/K0?ofkP030000003om^h0ooK^04`0ooK^0P3D?AT00`3om^h0e3dI0=@m6@020?of
kP040=@m6@3om^h0ooK^0=@m6@H0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP0<
0?ofkP030=@m6@3om^h0ooK^0080e3dI3P3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0
ooK^01<0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP0Y0?ofkP800000E@3om^h1
0?ooo`00LP3om^h00`000000ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00H0ooK^100mFJ/30?of
kP@0?EV[603om^h00`000000ooK^0?ofkP1<0?ofkP@0e3dI0`3om^h01@3D?AT0ooK^0?ofkP3om^h0
e3dI00D0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0
ooK^00<0ooK^0P3D?AT;0?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3D?AT04`3om^h0
0`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^02X0ooK^0`00001B0?ofkP40oooo001b0?of
kP030000003om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h02P3om^h203eIZ`@0ooK^1@0mFJ/E0?of
kP030000003om^h0ooK^04/0ooK^103D?AT30?ofkP040=@m6@3om^h0ooK^0?ofkP80e3dI103om^h0
0`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h01P3om^h3
0=@m6@P0ooK^00<0e3dI0?ofkP3om^h04P3om^h0103D?AT0ooK^0?ofkP3om^h20=@m6A00ooK^00<0
e3dI0?ofkP3om^h02@3om^h20=@m6Bd0ooK^0P00001@0?ofkP40oooo001a0?ofkP030000003om^h0
ooK^00T0ooK^0P0mFJ/=0?ofkP<0?EV[1@3om^h503eIZa80ooK^00<000000?ofkP3om^h0B`3om^h0
103D?AT0ooK^0=@m6@3D?AT20?ofkP070=@m6@3om^h0ooK^0?ofkP3D?AT0ooK^0=@m6@030?ofkP03
0=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP090?ofkP80
e3dI1@3om^h00`3D?AT0ooK^0?ofkP0B0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3o
m^h0303om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^02`0ooK^0P00001>0?ofkP40
oooo001a0?ofkP030000003om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h00P0mFJ/;0?ofkP80?EV[
00@0ooK^03eIZ`0mFJ/0?EV[1@3om^h403eIZa00ooK^00<000000?ofkP3om^h0BP3om^h0103D?AT0
ooK^0=@m6@3D?AT20?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3D?AT00P3om^h00`3D
?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h0303om^h20=@m
6@80ooK^00<0e3dI0?ofkP3om^h04P3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^
00/0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0]0?ofkP800000C03om^h10?oo
o`00L03om^h00`000000ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00<0ooK^0`0mFJ/80?ofkP04
03eIZ`3om^h0?EV[03eIZ`80ooK^0P0mFJ/60?ofkP@0?EV[3@3om^h00`000000ooK^0?ofkP190?of
kP80e3dI00<0ooK^0=@m6@3om^h00P3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00<0ooK^0P3D?AT=
0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h03`3om^h20=@m6A@0ooK^00<0e3dI
0?ofkP3om^h0203om^h20=@m6@X0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP0^
0?ofkP800000BP3om^h10?ooo`00K`3om^h00`000000ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^
00H0ooK^0P0mFJ/60?ofkP0403eIZ`3om^h0ooK^0?ofkP<0?EV[00<0ooK^03eIZ`0mFJ/00`3om^h2
03eIZ`030?ofkP0mFJ/0?EV[0080?EV[2`3om^h00`000000ooK^0?ofkP180?ofkP80e3dI00<0ooK^
0=@m6@3D?AT00P3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00@0ooK^0P3D?AT<0?ofkP030=@m6@3o
m^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h0403om^h0103D?AT0ooK^0=@m6@3D?ATA0?ofkP030=@m
6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP0A0?ofkP030=@m
6@3om^h0ooK^02l0ooK^0P0000180?ofkP40oooo001_0?ofkP030000003om^h0ooK^00P0ooK^00<0
?EV[0?ofkP3om^h02@3om^h303eIZ`<0ooK^00<0?EV[0?ofkP3om^h0103om^h203eIZ`040?ofkP0m
FJ/0?EV[03eIZ`H0ooK^100mFJ/80?ofkP030000003om^h0ooK^04L0ooK^0P3D?AT01P3om^h0e3dI
0?ofkP3D?AT0ooK^0=@m6@<0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP0;0?of
kP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h0403om^h00`3D?AT0ooK^0?ofkP020?of
kP80e3dI3P3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?of
kP3om^h04`3om^h00`3D?AT0ooK^0?ofkP0`0?ofkP<00000A@3om^h10?ooo`00KP3om^h00`000000
ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00d0ooK^0P0mFJ/00`3om^h0?EV[0?ofkP070?ofkP<0
?EV[00<0ooK^03eIZ`0mFJ/01@3om^h00`0mFJ/0ooK^03eIZ`0303eIZ`D0ooK^00<000000?ofkP3o
m^h0A`3om^h00`3D?AT0ooK^0?ofkP020=@m6@030?ofkP3D?AT0ooK^0080ooK^00<0e3dI0?ofkP3o
m^h00`3om^h20=@m6@`0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP0@0?ofkP03
0=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP80
e3dI0`3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0e3dI03@0ooK^0P0000130?ofkP40
oooo001]0?ofkP030000003om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h0403om^h303eIZ`H0ooK^
00@0?EV[0?ofkP3om^h0ooK^1P0mFJ/30?ofkP0303eIZ`3om^h0ooK^00@0?EV[0`3om^h00`000000
ooK^0?ofkP160?ofkP050=@m6@3om^h0ooK^0=@m6@3om^h00P3D?AT30?ofkP030=@m6@3om^h0ooK^
0080ooK^203D?AT70?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h04@3om^h00`3D
?AT0ooK^0?ofkP060?ofkP80e3dI2@3om^h00`3D?AT0ooK^0?ofkP0B0?ofkP030=@m6@3om^h0e3dI
01D0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0e0?ofkP800000@@3om^h10?ooo`00K@3om^h00`00
0000ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^0180ooK^0`0mFJ/20?ofkP80?EV[1`3om^h203eI
Z`030?ofkP0mFJ/0?EV[0080?EV[1@3om^h403eIZ`030000003om^h0ooK^04D0ooK^0P3D?AT0103o
m^h0e3dI0?ofkP3om^h20=@m6@<0ooK^1P3D?AT20?ofkP030=@m6@3om^h0ooK^0080ooK^2@3D?AT=
0?ofkP030=@m6@3om^h0ooK^0100ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP05
0?ofkP030=@m6@3om^h0ooK^01@0ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP03
0?ofkP030=@m6@3om^h0ooK^03@0ooK^0P00000o0?ofkP40oooo001/0?ofkP030000003om^h0ooK^
00P0ooK^0P0mFJ/D0?ofkP0303eIZ`3om^h0ooK^00<0?EV[2P3om^h303eIZ`030?ofkP0mFJ/0?EV[
00L0ooK^00@0?EV[0000000mFJ/0?EV[A03om^h20=@m6@030?ofkP3D?AT0ooK^0080ooK^00<0e3dI
0?ofkP3D?AT00`3D?AT30?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT02@3om^h0103D?AT0ooK^0?of
kP3om^h40=@m6@P0ooK^00<0e3dI0?ofkP3om^h0403om^h00`3D?AT0ooK^0?ofkP0;0?ofkP80e3dI
103om^h00`3D?AT0ooK^0?ofkP0D0?ofkP030=@m6@3om^h0e3dI01<0ooK^00<0e3dI0?ofkP3om^h0
103om^h00`3D?AT0ooK^0?ofkP0f0?ofkP800000?@3om^h10?ooo`00K03om^h00`000000ooK^0?of
kP070?ofkP0303eIZ`3om^h0ooK^00<0?EV[4@3om^h0100mFJ/0ooK^0?ofkP0mFJ/20?ofkP80?EV[
2`3om^h603eIZ`D0ooK^00<0000003eIZ`0mFJ/00P0mFJ]10?ofkP80e3dI00<0ooK^0=@m6@3om^h0
0P3om^h30=@m6@030?ofkP3D?AT0ooK^00@0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@080?ofkP03
0=@m6@3om^h0ooK^00H0ooK^103D?AT30?ofkP030=@m6@3om^h0ooK^0100ooK^00<0e3dI0?ofkP3o
m^h03P3om^h20=@m6@030?ofkP3D?AT0ooK^01D0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0A0?of
kP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h0=`3om^h2000003/0ooK^0@3oool006/0
ooK^00<000000?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP030?ofkP<0?EV[3P3om^h303eIZ`D0
ooK^0`0mFJ/:0?ofkP<0?EV[00@0ooK^03eIZ`0mFJ/0?EV[0P3om^h010000000ooK^0?ofkP3om^h4
03eIZcd0ooK^0P3D?AT20?ofkP080=@m6@3om^h0e3dI0=@m6@3om^h0e3dI0?ofkP3D?AT50?ofkP03
0=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP0;0?ofkP@0
e3dI4@3om^h00`3D?AT0ooK^0?ofkP0A0?ofkP030=@m6@3om^h0ooK^01@0ooK^00<0e3dI0?ofkP3o
m^h00`3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3o
m^h0>03om^h3000003P0ooK^0@3oool006X0ooK^00<000000?ofkP3om^h0203om^h00`0mFJ/0ooK^
0?ofkP070?ofkP80?EV[303om^h503eIZ`H0ooK^0`0mFJ/80?ofkP0403eIZ`3om^h0?EV[03eIZ`80
ooK^00<0?EV[0000003om^h00P3om^h203eIZ`80ooK^0`0mFJ/k0?ofkP80e3dI00<0ooK^0=@m6@3D
?AT00P3D?AT0103om^h0e3dI0?ofkP3D?AT50?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?of
kP3om^h0103om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^0080e3dI3P3om^h00`3D
?AT0ooK^0?ofkP0A0?ofkP030=@m6@3om^h0e3dI01@0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D
?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h0>P3om^h20000
03H0ooK^0@3oool006X0ooK^00<000000?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP<0
?EV[2@3om^h203eIZ`<0ooK^0`0mFJ/60?ofkP80?EV[1P3om^h0100mFJ/0ooK^0?ofkP3om^h303eI
Z`040000000mFJ/0?EV[03eIZ`H0ooK^100mFJ/g0?ofkP80e3dI00<0ooK^0=@m6@3D?AT00P3om^h0
1@3D?AT0ooK^0=@m6@3om^h0e3dI00@0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?of
kP030?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h00`3om^h20=@m6@/0ooK^00<0
e3dI0?ofkP3om^h04@3om^h0103D?AT0ooK^0?ofkP3om^h20=@m6A40ooK^00<0e3dI0?ofkP3om^h0
1`3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h0
>`3om^h2000003@0ooK^0@3oool006T0ooK^00<000000?ofkP3om^h0203om^h00`0mFJ/0ooK^0?of
kP0=0?ofkP<0?EV[1P3om^h00`0mFJ/0ooK^0?ofkP050?ofkP<0?EV[1@3om^h303eIZ`<0ooK^00<0
?EV[0?ofkP3om^h0103om^h010000000?EV[03eIZ`3om^h203eIZ`D0ooK^00<0?EV[0?ofkP0mFJ/0
0P0mFJ/d0?ofkP@0e3dI0`3om^h00`3D?AT0ooK^0?ofkP020=@m6@@0ooK^00<0e3dI0?ofkP3om^h0
1P3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h0
1@3om^h30=@m6@P0ooK^00<0e3dI0?ofkP3om^h0403om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m
6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h02@3om^h20=@m6@T0ooK^00<0e3dI0?ofkP3om^h0
3@3om^h00`3D?AT0ooK^0?ofkP0l0?ofkP800000<P3om^h10?ooo`00J@3om^h00`000000ooK^0?of
kP070?ofkP0303eIZ`3om^h0ooK^0140ooK^0`0mFJ/20?ofkP80?EV[2P3om^h203eIZ`H0ooK^100m
FJ/50?ofkP0403eIZ`000000ooK^0?ofkP80?EV[00@0ooK^03eIZ`0mFJ/0?EV[0`3om^h00`0mFJ/0
ooK^0?ofkP0403eIZc00ooK^103D?AT30?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT01@3om^h00`3D
?AT0ooK^0?ofkP050?ofkP80e3dI0`3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^
00T0ooK^0P3D?AT50?ofkP030=@m6@3om^h0ooK^0140ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D
?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D
?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^03h0ooK^0P00000`0?ofkP40oooo001X0?ofkP03
0000003om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h05@3om^h403eIZ``0ooK^0`0mFJ/60?ofkP80
?EV[0P3om^h203eIZ`030?ofkP000000ooK^00<0ooK^0`0mFJ/01@3om^h0?EV[03eIZ`3om^h0?EV[
00@0ooK^100mFJ/]0?ofkP80e3dI00<0ooK^0=@m6@3D?AT00P3om^h0103D?AT0ooK^0?ofkP3om^h2
0=@m6@@0ooK^00<0e3dI0?ofkP3om^h01@3om^h01P3D?AT0ooK^0?ofkP3D?AT0ooK^0=@m6@l0ooK^
00<0e3dI0?ofkP3om^h0303om^h20=@m6@80ooK^00<0e3dI0?ofkP3om^h04@3om^h00`3D?AT0ooK^
0?ofkP070?ofkP80e3dI2P3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00<0ooK^
00<0e3dI0?ofkP3om^h0403om^h00`3D?AT0ooK^0?ofkP0o0?ofkP<00000;@3om^h10?ooo`00I`3o
m^h00`000000ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^01D0ooK^00<0?EV[0?ofkP3om^h00P0m
FJ/>0?ofkP<0?EV[103om^h403eIZ`80ooK^00<000000?ofkP3om^h01@3om^h603eIZ`H0ooK^100m
FJ/Y0?ofkP80e3dI00<0ooK^0=@m6@3D?AT00P3om^h01`3D?AT0ooK^0?ofkP3om^h0e3dI0?ofkP3D
?AT00`3om^h00`3D?AT0ooK^0?ofkP050?ofkP040=@m6@3om^h0ooK^0?ofkP80e3dI3`3om^h00`3D
?AT0ooK^0?ofkP0?0?ofkP80e3dI4`3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^
00H0ooK^00<0e3dI0?ofkP3om^h0403om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI01@0ooK^00<0e3dI
0?ofkP3om^h0@@3om^h2000002/0ooK^0@3oool006L0ooK^00<000000?ofkP3om^h01`3om^h203eI
ZaL0ooK^00D0?EV[0?ofkP3om^h0?EV[0?ofkP0303eIZ`h0ooK^0`0mFJ/00`3om^h0?EV[03eIZ`02
0?ofkP80?EV[00<000000?ofkP3om^h0203om^h503eIZ`H0ooK^100mFJ/V0?ofkP<0e3dI00<0ooK^
0=@m6@3om^h00P3om^h01`3D?AT0ooK^0?ofkP3om^h0e3dI0?ofkP3D?AT00P3om^h00`3D?AT0ooK^
0?ofkP060?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT03`3om^h00`3D?AT0ooK^0?ofkP0@0?ofkP04
0=@m6@3om^h0e3dI0=@m6A00ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP040?of
kP030=@m6@3om^h0ooK^0180ooK^00<0e3dI0?ofkP3D?AT05P3om^h00`3D?AT0ooK^0?ofkP120?of
kP800000:@3om^h10?ooo`00IP3om^h00`000000ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^0080
?EV[503om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00@0ooK^0P0mFJ/?0?ofkP<0?EV[103om^h00`00
0000?EV[0?ofkP0:0?ofkPH0?EV[1@3om^h503eIZb<0ooK^0P3D?AT00`3om^h0e3dI0=@m6@020?of
kP050=@m6@3om^h0ooK^0?ofkP3D?AT00`3om^h00`3D?AT0ooK^0=@m6@070?ofkP030=@m6@3om^h0
ooK^0080ooK^0P3D?AT>0?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h00P3om^h2
0=@m6@d0ooK^00<0e3dI0?ofkP3om^h03P3om^h20=@m6@<0ooK^00<0e3dI0?ofkP3om^h0503om^h0
0`3D?AT0ooK^0?ofkP0D0?ofkP030=@m6@3om^h0e3dI04D0ooK^0P00000W0?ofkP40oooo001V0?of
kP030000003om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h00P3om^h303eIZa40ooK^00D0?EV[0?of
kP3om^h0ooK^03eIZ`060?ofkP<0?EV[303om^h203eIZ`030?ofkP0mFJ/0?EV[0080ooK^00<00000
0?ofkP0mFJ/00P0mFJ/90?ofkP0503eIZ`3om^h0?EV[03eIZ`3om^h00P0mFJ/30?ofkP80?EV[00<0
ooK^03eIZ`0mFJ/00P0mFJ/P0?ofkP80e3dI00H0ooK^0=@m6@3om^h0e3dI0?ofkP3D?AT30?ofkP03
0=@m6@3om^h0ooK^0080ooK^0P3D?AT70?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3D
?AT03@3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3o
m^h02@3om^h00`3D?AT0ooK^0?ofkP0A0?ofkP030=@m6@3om^h0e3dI01H0ooK^00<0e3dI0?ofkP3D
?AT0503om^h0103D?AT0ooK^0?ofkP3D?AU70?ofkP8000009@3om^h10?ooo`00I@3om^h00`000000
ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00H0ooK^0P0mFJ/>0?ofkP0303eIZ`3om^h0ooK^0080
ooK^00<0?EV[0?ofkP3om^h01`3om^h203eIZ`T0ooK^00<0?EV[0?ofkP0mFJ/00`3om^h203eIZ`03
0000003om^h0ooK^0080ooK^0P0mFJ/70?ofkP0403eIZ`3om^h0ooK^0?ofkPH0?EV[1@3om^h503eI
Za`0ooK^0P3D?AT20?ofkP80e3dI00<0ooK^0=@m6@3om^h00P3om^h00`3D?AT0ooK^0?ofkP020?of
kPL0e3dI0P3om^h00`3D?AT0ooK^0?ofkP020?ofkP040=@m6@3om^h0ooK^0=@m6@`0ooK^00<0e3dI
0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP070?ofkP80e3dI203om^h00`3D?AT0ooK^0?ofkP0C
0?ofkP030=@m6@3om^h0ooK^01@0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0B0?ofkP030=@m6@3o
m^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h0AP3om^h2000002<0ooK^0@3oool006@0ooK^00<00000
0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP080?ofkP<0?EV[2P3om^h00`0mFJ/0ooK^0?ofkP03
0?ofkP0303eIZ`3om^h0ooK^00T0ooK^0`0mFJ/50?ofkP0403eIZ`3om^h0ooK^03eIZ`D0ooK^00<0
000003eIZ`0mFJ/0103om^h303eIZ`D0ooK^00<0?EV[0?ofkP3om^h00P3om^h703eIZ`@0ooK^1@0m
FJ/I0?ofkP80e3dI0P3om^h01@3D?AT0ooK^0=@m6@3om^h0e3dI0080ooK^00<0e3dI0?ofkP3D?AT0
1@3D?AT50?ofkPT0e3dI0P3om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00l0ooK^
00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^0180ooK^
00<0e3dI0?ofkP3D?AT0503om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00l0ooK^
00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP180?ofkP8000008@3om^h10?ooo`00I03o
m^h00`000000ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00`0ooK^0P0mFJ/80?ofkP0303eIZ`3o
m^h0ooK^00<0ooK^0P0mFJ/=0?ofkP80?EV[0P3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00D0ooK^
00<000000?ofkP3om^h00P0mFJ/50?ofkP80?EV[0`3om^h00`0mFJ/0ooK^0?ofkP0203eIZ`@0ooK^
0P0mFJ/00`3om^h0?EV[03eIZ`040?ofkPH0?EV[5@3om^h30=@m6@040?ofkP3D?AT0ooK^0?ofkP80
e3dI00<0ooK^0=@m6@3D?AT00P3D?AT30?ofkP030=@m6@3om^h0e3dI00D0ooK^00<0e3dI0?ofkP3o
m^h00P3om^h0103D?AT0ooK^0?ofkP3om^h40=@m6@T0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D
?AT0ooK^0?ofkP0<0?ofkP80e3dI103om^h00`3D?AT0ooK^0?ofkP0B0?ofkP050=@m6@3om^h0ooK^
0?ofkP3D?AT04P3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI
0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP170?ofkP8000008@3om^h10?ooo`00H`3om^h00`00
0000ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00l0ooK^0`0mFJ/40?ofkP0303eIZ`3om^h0ooK^
00@0ooK^00<0?EV[0?ofkP0mFJ/00P0mFJ/<0?ofkP<0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP020?of
kP030000003om^h0ooK^00<0ooK^0`0mFJ/40?ofkP80?EV[00@0ooK^03eIZ`0mFJ/0?EV[203om^h6
03eIZ`040?ofkP0mFJ/0ooK^0?ofkPD0?EV[4P3om^h30=@m6@030?ofkP3D?AT0ooK^0080ooK^0`3D
?AT00`3om^h0e3dI0?ofkP030?ofkP040=@m6@3om^h0ooK^0=@m6@@0ooK^00<0e3dI0?ofkP3om^h0
0P3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0e3dI00@0e3dI0`3om^h00`3D?AT0ooK^
0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00h0ooK^0P3D?AT00`3om^h0e3dI0?ofkP0C0?ofkP030=@m
6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m
6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP160?ofkP030000
003om^h000000240ooK^0@3oool006<0ooK^00<000000?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?of
kP0B0?ofkP80?EV[0P3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^0080ooK^0P0m
FJ/:0?ofkP0303eIZ`3om^h0ooK^00<0?EV[1@3om^h00`000000ooK^0?ofkP060?ofkP80?EV[103o
m^h303eIZ``0ooK^1P0mFJ/40?ofkPD0?EV[3`3om^h20=@m6@040?ofkP3D?AT0ooK^0?ofkP<0e3dI
0P3om^h00`3D?AT0ooK^0?ofkP030?ofkP040=@m6@3om^h0ooK^0=@m6@<0ooK^00<0e3dI0?ofkP3o
m^h00P3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00<0ooK^103D?AT@0?ofkP03
0=@m6@3om^h0ooK^0140ooK^00<0e3dI0?ofkP3om^h04P3om^h00`3D?AT0ooK^0?ofkP050?ofkP03
0=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP090?ofkP03
0=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h0A03om^h01@000000ooK^0?ofkP3om^h00000
0200ooK^0@3oool00680ooK^00<000000?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP0E0?ofkP<0
?EV[1@3om^h00`0mFJ/0ooK^0?ofkP050?ofkP<0?EV[1`3om^h00`0mFJ/0ooK^0?ofkP020?ofkP<0
?EV[0`3om^h00`000000ooK^0?ofkP080?ofkP<0?EV[00<0ooK^03eIZ`3om^h0100mFJ/<0?ofkPD0
?EV[103om^h503eIZ``0ooK^0P3D?AT20?ofkP@0e3dI00@0ooK^0=@m6@3om^h0e3dI1@3om^h00`3D
?AT0ooK^0?ofkP020?ofkP040=@m6@3om^h0ooK^0=@m6@@0ooK^00<0e3dI0?ofkP3om^h01P3om^h0
0`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^0080e3dI3@3om^h00`3D?AT0ooK^0?ofkP0A
0?ofkP030=@m6@3om^h0e3dI0180ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP0:
0?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP0:
0?ofkP030=@m6@3om^h0ooK^0440ooK^0P0000040?ofkP030000003om^h0ooK^01h0ooK^0@3oool0
0640ooK^00<000000?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP0E0?ofkP0303eIZ`3om^h0ooK^
0080?EV[0`3om^h00`0mFJ/0ooK^0?ofkP080?ofkP<0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP030?of
kP0303eIZ`3om^h0ooK^0080?EV[00<0ooK^0000003om^h0303om^h203eIZ`030?ofkP0mFJ/0ooK^
0080ooK^0`0mFJ/;0?ofkPH0?EV[103om^h503eIZ`P0ooK^00@0e3dI0?ofkP3D?AT0ooK^0P3D?AT0
1P3om^h0e3dI0?ofkP3D?AT0ooK^0=@m6@D0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^
0=@m6@040?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^
0?ofkP030?ofkP<0e3dI2@3om^h00`3D?AT0ooK^0?ofkP0A0?ofkP050=@m6@3om^h0ooK^0?ofkP3D
?AT0403om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3o
m^h02`3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3o
m^h0@03om^h00`000000ooK^0?ofkP040?ofkP030000003om^h0ooK^01h0ooK^0@3oool00640ooK^
00<000000?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP0F0?ofkP0303eIZ`3om^h0ooK^0080ooK^
100mFJ/=0?ofkP@0?EV[1@3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`000000?EV[00/0ooK^
00<0?EV[0?ofkP3om^h00`0mFJ/50?ofkP80?EV[2P3om^h01@0mFJ/0ooK^03eIZ`0mFJ/0ooK^00D0
?EV[00<0ooK^03eIZ`0mFJ/00`0mFJ/50?ofkP030=@m6@3om^h0e3dI0080e3dI0`3om^h01@3D?AT0
ooK^0=@m6@3om^h0e3dI00@0ooK^00<0e3dI0?ofkP3om^h0103om^h20=@m6@@0ooK^00<0e3dI0?of
kP3om^h02@3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00T0ooK^0`3D?AT50?ofkP030=@m6@3om^h0
ooK^0140ooK^00<0e3dI0?ofkP3om^h00`3om^h20=@m6@d0ooK^00<0e3dI0?ofkP3om^h02P3om^h0
0`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h0103om^h0
0`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^03h0ooK^00<000000?ofkP3om^h01@3om^h0
0`000000ooK^0?ofkP0N0?ofkP40oooo001P0?ofkP030000003om^h0ooK^00P0ooK^00<0?EV[0?of
kP3om^h05@3om^h00`0mFJ/0ooK^0?ofkP060?ofkP80?EV[3P3om^h303eIZ`@0ooK^00<0?EV[0?of
kP3om^h00`3om^h010000000ooK^03eIZ`0mFJ/90?ofkP0603eIZ`3om^h0ooK^0?ofkP0mFJ/0ooK^
0P0mFJ/50?ofkP<0?EV[1`3om^h0100mFJ/0ooK^0?ofkP3om^h303eIZ`030?ofkP0mFJ/0?EV[00@0
ooK^1@0mFJ/00`3om^h0e3dI0?ofkP030=@m6@<0ooK^00<0e3dI0?ofkP3om^h00P3D?AT40?ofkP03
0=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP04
0=@m6@3om^h0ooK^0=@m6@d0ooK^0P3D?AT20?ofkP030=@m6@3om^h0ooK^0140ooK^00<0e3dI0?of
kP3om^h01P3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?of
kP3om^h01@3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?of
kP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0m0?ofkP030000003om^h0ooK^00L0ooK^00<000000?of
kP3om^h07@3om^h10?ooo`00H03om^h00`000000ooK^0?ofkP070?ofkP80?EV[5`3om^h00`0mFJ/0
ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00<0?EV[2P3om^h0100mFJ/0ooK^0?ofkP3om^h303eI
Z`030?ofkP0mFJ/0ooK^00@0ooK^0P0000020?ofkP<0?EV[1@3om^h00`0mFJ/0ooK^0?ofkP020?of
kP0403eIZ`3om^h0ooK^0?ofkP<0?EV[1@3om^h303eIZ`D0ooK^00<0?EV[0?ofkP0mFJ/00`3om^h6
03eIZ`<0ooK^0`0mFJ/00`3D?AT000000=@m6@020=@m6@<0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m
6@040?ofkP030=@m6@3om^h0ooK^00D0ooK^0P3D?AT30?ofkP030=@m6@3om^h0ooK^00X0ooK^00@0
e3dI0?ofkP3D?AT0e3dI403om^h20=@m6A<0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^
0?ofkP080?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^
0?ofkP0@0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT04P3om^h00`3D?AT0ooK^0?ofkP0k0?ofkP03
0000003om^h0ooK^00P0ooK^00<000000?ofkP3om^h07@3om^h10?ooo`00G`3om^h00`000000ooK^
0?ofkP080?ofkP0403eIZ`3om^h0?EV[03eIZa@0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0
ooK^0?ofkP030?ofkP80?EV[203om^h00`0mFJ/0ooK^0?ofkP040?ofkP<0?EV[0`3om^h00`000000
ooK^0?ofkP02000000<0ooK^0P0mFJ/20?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3o
m^h0103om^h303eIZ`D0ooK^0`0mFJ/20?ofkP80?EV[1`3om^h203eIZ`030?ofkP0mFJ/0?EV[00<0
ooK^00@0?EV[0=@m6@3D?AT06all0P3D?AT2000000040=@m6@3om^h0ooK^0?ofkP80e3dI103om^h0
0`3D?AT0ooK^0?ofkP040?ofkP060=@m6@3om^h0ooK^0=@m6@3om^h0e3dI303om^h0103D?AT0ooK^
0?ofkP3D?ATA0?ofkP040=@m6@3om^h0e3dI0=@m6A00ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D
?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00l0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0D
0?ofkP030=@m6@3om^h0e3dI01<0ooK^00<0e3dI0?ofkP3om^h0>P3om^h00`000000ooK^0?ofkP09
0?ofkP030000003om^h0ooK^01d0ooK^0@3oool005h0ooK^00<000000?ofkP3om^h0203om^h00`0m
FJ/0ooK^0?ofkP020?ofkP<0?EV[403om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^
00D0ooK^0`0mFJ/40?ofkP0303eIZ`3om^h0ooK^00H0ooK^00H0?EV[0?ofkP0mFJ/0?EV[0?ofkP00
00040?ofkP<000000P3om^h303eIZ`D0ooK^00<0?EV[0?ofkP3om^h01`3om^h203eIZ`H0ooK^0`0m
FJ/:0?ofkPD0?EV[00@000000=@m6@3D?AT06all0P3D?AT00`0K7c`0000000000003000000030=@m
6@3om^h0e3dI00<0ooK^00<0e3dI0?ofkP3om^h0103om^h01`3D?AT0ooK^0?ofkP3om^h0e3dI0?of
kP3D?AT0303om^h00`3D?AT0ooK^0?ofkP020=@m6@l0ooK^00<0e3dI0?ofkP3om^h00P3om^h20=@m
6@h0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^
0140ooK^00<0e3dI0?ofkP3D?AT05P3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^
03P0ooK^00<000000?ofkP3om^h02P3om^h00`000000ooK^0?ofkP0M0?ofkP40oooo001N0?ofkP03
0000003om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h01@3om^h203eIZ`h0ooK^00<0?EV[0?ofkP3o
m^h01`3om^h00`0mFJ/0ooK^0?ofkP080?ofkP80?EV[0P3om^h00`0mFJ/0ooK^0?ofkP060?ofkP05
03eIZ`3om^h0ooK^0?ofkP0000000P0mFJ/60?ofkP<000000P3om^h303eIZ`80ooK^00<0?EV[0?of
kP3om^h02@3om^h303eIZ`<0ooK^00<0?EV[0?ofkP0mFJ/00P0mFJ/;0?ofkP80?EV[00D0e3dI02H`
EP00000000000=@m6@0501/O?080000000<0e3dI0000003D?AT00P3om^h00`3D?AT0ooK^0?ofkP05
0?ofkP040=@m6@3om^h0ooK^0?ofkP80e3dI303om^h01P3D?AT0ooK^0?ofkP3D?AT0ooK^0=@m6@h0
ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00d0
ooK^0P3D?AT30?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h0503om^h00`3D?AT0
ooK^0=@m6@0C0?ofkP80e3dI>03om^h2000000d0ooK^00<000000?ofkP3om^h07@3om^h10?ooo`00
G@3om^h00`000000ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00P0ooK^0`0mFJ/:0?ofkP0303eI
Z`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h02P3om^h303eIZ`P0ooK^00@0?EV[0?ofkP3om^h0
00000`3om^h203eIZ`D0ooK^00@0?EV[0?ofkP00000000000`3om^h303eIZ`h0ooK^0`0mFJ/30?of
kP0403eIZ`3om^h0?EV[03eIZ`T0ooK^0P00000302H`EP80e3dI0`00000201/O?0060000003D?AT0
6all0000003D?AT000001P3D?AT20?ofkP030=@m6@3om^h0ooK^0080ooK^0P3D?AT;0?ofkP040=@m
6@3om^h0ooK^0=@m6@<0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP060?ofkP80
e3dI2@3om^h00`3D?AT0ooK^0?ofkP0@0?ofkP030=@m6@3om^h0e3dI01D0ooK^00<0e3dI0?ofkP3D
?AT0503om^h0103D?AT0ooK^0?ofkP3D?ATB0?ofkP040=@m6@3om^h0ooK^0=@m6CH0ooK^00<00000
0?ofkP3om^h03P3om^h00`000000ooK^0?ofkP0L0?ofkP40oooo001L0?ofkP030000003om^h0ooK^
00T0ooK^00<0?EV[0?ofkP3om^h02`3om^h203eIZ`P0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0m
FJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00<0?EV[103om^h0100mFJ/0ooK^0?ofkP000006
0?ofkP<0?EV[0P3om^h0100mFJ/0ooK^0?ofkP3om^h300000080ooK^0`0mFJ/=0?ofkP0603eIZ`3o
m^h0?EV[03eIZ`3om^h0?EV[0`3om^h303eIZ`D0ooK^0P00000302H`EP030=@m6@0V<5H0e3dI00<0
9S1F0P0000001@3D?AT06all01/O?00K7c`0e3dI00@000000`3om^h:0=@m6@T0ooK^00@0e3dI0?of
kP3om^h0e3dI103om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI
0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP0B0?ofkP030=@m6@3om^h0ooK^01<0ooK^00D0e3dI
0?ofkP3om^h0ooK^0=@m6@0B0?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h03P3o
m^h01@3D?AT0ooK^0?ofkP3om^h0e3dI03D0ooK^00<000000?ofkP3om^h03`3om^h00`000000ooK^
0?ofkP0L0?ofkP40oooo001L0?ofkP030000003om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h03P3o
m^h303eIZ`@0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3o
m^h0ooK^00<0ooK^0P0mFJ/20?ofkP0403eIZ`3om^h0ooK^000000T0ooK^0`0mFJ/60?ofkP<00000
0P3om^h303eIZ`T0ooK^00<0?EV[0?ofkP3om^h00P3om^h303eIZ`D0ooK^0P0mFJ/30?ofkP<00000
00@09S1F0=@m6@0V<5H0e3dI1@0V<5H01P3D?AT09S1F0000000000006all0=@m6@<06all10000000
0`3D?AT0ooK^0?ofkP020?ofkP050=@m6@3om^h0ooK^0=@m6@3om^h01`3D?AT01@3om^h0e3dI0?of
kP3om^h0e3dI00H0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP0;0?ofkP80e3dI
103om^h00`3D?AT0ooK^0?ofkP0B0?ofkP030=@m6@3om^h0e3dI01<0ooK^00<0e3dI0?ofkP3om^h0
0P3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h0
3@3om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^0340ooK^00<000000?ofkP3om^h0
403om^h00`000000ooK^0?ofkP0L0?ofkP40oooo001K0?ofkP030000003om^h0ooK^00T0ooK^00<0
?EV[0?ofkP3om^h04@3om^h203eIZ`80ooK^00<0?EV[0?ofkP3om^h0203om^h203eIZ`/0ooK^00<0
?EV[0?ofkP3om^h01P3om^h303eIZ`030?ofkP000000ooK^00T0ooK^00<0?EV[0?ofkP3om^h00P0m
FJ/60?ofkP0303eIZ`000000000000<0ooK^0P0mFJ/60?ofkP0303eIZ`3om^h0ooK^00@0ooK^00@0
?EV[0?ofkP0mFJ/0?EV[1@3om^h203eIZ`<0000000D0<T=k0=@m6@0000009S1F0=@m6@0402H`EP03
0=@m6@0000009S1F00809S1F00<000000=@m6@0K7c`00`0K7c`00`0000006all0=@m6@0200000080
ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@080?ofkPD0e3dI1P3om^h00`3D?AT0ooK^0?ofkP070?of
kP030=@m6@3om^h0ooK^00h0ooK^0P3D?AT00`3om^h0e3dI0?ofkP0C0?ofkP050=@m6@3om^h0ooK^
0?ofkP3D?AT04@3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI
0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI
0?ofkP3om^h0<03om^h00`000000ooK^0?ofkP0A0?ofkP030000003om^h0ooK^01`0ooK^0@3oool0
05/0ooK^00<000000?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP<0?EV[2P3om^h0100m
FJ/0ooK^03eIZ`0mFJ/80?ofkP0303eIZ`3om^h0ooK^00T0ooK^00@0?EV[0000000mFJ/0?EV[203o
m^h00`0mFJ/0ooK^0?ofkP030?ofkP<0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP0300000080ooK^0`0m
FJ/20?ofkP0303eIZ`3om^h0ooK^00D0ooK^00@0?EV[0?ofkP3om^h0ooK^0P0mFJ/40?ofkP800000
00<05@H20000003D?AT00P0b@g/00`000000e3dI0000000302H`EP030=@m6@0V<5H09S1F00@09S1F
00H0e3dI0000000K7c`0000001/O?03D?AT201/O?0<000001@3om^h00`3D?AT0ooK^0?ofkP050?of
kP030=@m6@3om^h0e3dI0080ooK^0P3D?AT50?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?of
kP3om^h04@3om^h00`3D?AT0ooK^0?ofkP0B0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?of
kP3om^h03@3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?of
kP3om^h01P3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?of
kP3om^h0;P3om^h00`000000ooK^0?ofkP0C0?ofkP030000003om^h0ooK^01/0ooK^0@3oool005X0
ooK^00<000000?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP0E0?ofkP0303eIZ`3om^h0?EV[0080
?EV[1`3om^h0100mFJ/0ooK^0?ofkP3om^h303eIZ`D0ooK^00<0?EV[0?ofkP3om^h02@3om^h0100m
FJ/000000?ofkP3om^h203eIZ`H0ooK^00<0?EV[0?ofkP3om^h01P3om^h203eIZ`030?ofkP0mFJ/0
ooK^00@0ooK^0P0000030?ofkP<0?EV[1`3om^h00`0mFJ/0ooK^0?ofkP030?ofkP<0?EV[0P000000
0`0E1P8000000=@m6@040393N`060=@m6@0b@g/000000000003D?AT000001P0V<5H01@3D?AT09S1F
000000000000e3dI00H06all0`0000020?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3D
?AT01@3om^h20=@m6@@0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP0A0?ofkP03
0=@m6@3om^h0e3dI0180ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP03
0=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP080?ofkP03
0=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP0]0?ofkP03
0000003om^h0ooK^01@0ooK^00<000000?ofkP3om^h06`3om^h10?ooo`00F@3om^h00`000000ooK^
0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^01@0ooK^00<0?EV[0?ofkP3om^h00`3om^h303eIZ`<0ooK^
00<0?EV[0?ofkP3om^h01@3om^h203eIZ`80ooK^00<0?EV[0?ofkP3om^h02P3om^h00`000000ooK^
0?ofkP030?ofkP<0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP090?ofkP<0?EV[1P3om^h30000000303eI
Z`3om^h0ooK^00<0?EV[103om^h00`0mFJ/0ooK^0?ofkP060?ofkP80?EV[00<05@H20000003D?AT0
100b@g/0103D?AT0<T=k0393N`3D?AT3000000D09S1F00D0e3dI02H`EP0V<5H0e3dI02H`EP030000
00@06all100000000`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0e3dI00P0ooK^0P3D?AT20?of
kP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h0403om^h0103D?AT0ooK^0?ofkP3om^h2
0=@m6@l0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0
ooK^00P0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0
ooK^00H0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP0[0?ofkP8000005`3om^h0
0`000000ooK^0?ofkP0K0?ofkP40oooo001I0?ofkP030000003om^h0ooK^00T0ooK^00<0?EV[0?of
kP3om^h05@3om^h00`0mFJ/0ooK^0?ofkP060?ofkP80?EV[00<0ooK^03eIZ`3om^h0203om^h303eI
Z`/0ooK^00<0000003eIZ`3om^h01`3om^h303eIZ``0ooK^00<0?EV[0?ofkP0mFJ/00P0mFJ/50?of
kP0403eIZ`0000000000000000<0ooK^0P0mFJ/20?ofkP0303eIZ`3om^h0ooK^00D0ooK^0P000000
0`0E1P80?EV[03eIZ`050393N`030=@m6@0b@g/0e3dI0080<T=k00<000000393N`0000000P000002
02H`EP040=@m6@0V<5H09S1F0=@m6@@09S1F0`000000100K7c`0000001/O?00K7c`2000000050=@m
6@3om^h0ooK^0?ofkP3D?AT00P3om^h00`3D?AT0ooK^0?ofkP080?ofkP80e3dI00<0ooK^0=@m6@3o
m^h00P3om^h00`3D?AT0ooK^0?ofkP0@0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3o
m^h02`3om^h00`3D?AT0ooK^0?ofkP090?ofkP80e3dI2@3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP03
0=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP050?ofkP03
0=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h0:@3om^h00`000000ooK^0?ofkP0G0?ofkP03
0000003om^h0ooK^01/0ooK^0@3oool005P0ooK^00<000000?ofkP3om^h02P3om^h00`0mFJ/0ooK^
0?ofkP0D0?ofkP0303eIZ`3om^h0ooK^00T0ooK^0`0mFJ/90?ofkP0303eIZ`3om^h0?EV[0080?EV[
1`3om^h00`000000ooK^03eIZ`080?ofkP0303eIZ`3om^h0ooK^00<0?EV[2@3om^h00`0mFJ/0ooK^
0?ofkP020?ofkP80?EV[0`3om^h0100mFJ/0ooK^0?ofkP3om^h2000000<0ooK^0`0mFJ/60?ofkP80
00000`0E1P82000000<0<T=k00<0e3dI0393N`3D?AT00`0b@g/00`000000<T=k0393N`020393N`80
000000@0e3dI0000003D?AT000001`0V<5H3000000<06all00@0e3dI0000000mFJ/0e3dI0P3om^h0
0`3D?AT0ooK^0?ofkP0;0?ofkP80e3dI0P3om^h00`3D?AT0ooK^0?ofkP0@0?ofkP030=@m6@3om^h0
ooK^00H0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0
ooK^00D0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0
ooK^00d0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0
ooK^02P0ooK^00<000000?ofkP3om^h06@3om^h00`000000ooK^0?ofkP0J0?ofkP40oooo001H0?of
kP030000003om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h05@3om^h00`0mFJ/0ooK^0?ofkP0:0?of
kP0303eIZ`3om^h0?EV[0080?EV[1@3om^h00`0mFJ/0ooK^0?ofkP030?ofkP80?EV[1@3om^h00`00
0000?EV[0?ofkP080?ofkP0303eIZ`3om^h0ooK^00<0ooK^0P0mFJ/70?ofkP0303eIZ`3om^h0ooK^
00@0ooK^0`0mFJ/60?ofkP<000000`3om^h303eIZ`<0ooK^0P00000201D60P80000000L0>TnD0000
00000000<T=k0=@m6@0b@g/0e3dI0080<T=k00<000000393N`0b@g/01@0b@g/20=@m6@<000001`0V
<5H02@0000009S1F0000000000006all0=@m6@0K7c`000000=@m6@04000000h0ooK^0P3D?ATB0?of
kP030=@m6@3om^h0ooK^00P0ooK^0P3D?AT80?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?of
kP3om^h00`3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?of
kP3om^h03P3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?of
kP3om^h09P3om^h00`000000ooK^0?ofkP0J0?ofkP030000003om^h0ooK^01X0ooK^0@3oool005L0
ooK^00<000000?ofkP3om^h02P3om^h203eIZaD0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0
ooK^0?ofkP030?ofkP<0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP050?ofkP<0?EV[00@0ooK^0000003o
m^h0?EV[203om^h00`0mFJ/0ooK^0?ofkP060?ofkP<0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP060?of
kP0303eIZ`3om^h0?EV[0080?EV[1P3om^h30000000303eIZ`3om^h0ooK^0080?EV[0P00000201D6
0P030000000T2PD0000000<0>TnD00<000000=@m6@3D?AT00`0b@g/00`000000<T=k0393N`050393
N`050=@m6@0b@g/0<T=k0000000b@g/00P00000502H`EP040000000V<5H09S1F02H`EP8000000P3D
?AT01@0000006all0000000000004QDY00800000303om^h0103D?AT0ooK^0=@m6@3D?AT?0?ofkP03
0=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP0@0?ofkP05
0=@m6@3om^h0ooK^0?ofkP3D?AT04@3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI0180ooK^00@0e3dI
0?ofkP3om^h0e3dI403om^h00`3D?AT0ooK^0?ofkP0U0?ofkP030000003om^h0ooK^01/0ooK^00<0
00000?ofkP3om^h06P3om^h10?ooo`00EP3om^h00`000000ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0
?EV[0080?EV[4P3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00H0ooK^0`0mFJ/:
0?ofkP040000000mFJ/0ooK^03eIZ`L0ooK^00<0?EV[0?ofkP3om^h02P3om^h403eIZ`L0ooK^00<0
?EV[0?ofkP3om^h00`3om^h303eIZ`H0ooK^0P0000020?ofkP<0000000D05@H20000000T2PD090X5
0000000403Y?U0060=@m6@0jCi@000000000000b@g/000001P0b@g/20=@m6@80<T=k00@000000393
N`0b@g/0<T=k0P00000302H`EP030000000V<5H09S1F00<09S1F00@0e3dI0000000K7c`000000P0K
7c`5000000T0ooK^00<0e3dI0?ofkP3D?AT00P3om^h20=@m6@d0ooK^00<0e3dI0?ofkP3om^h0303o
m^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^0180ooK^00<0e3dI0?ofkP3D?AT04`3o
m^h00`3D?AT0ooK^0=@m6@0C0?ofkP030=@m6@3om^h0e3dI0180ooK^00<0e3dI0?ofkP3om^h08`3o
m^h00`000000ooK^0?ofkP0L0?ofkP030000003om^h0ooK^01X0ooK^0@3oool005H0ooK^00<00000
0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP<0?EV[3P3om^h00`0mFJ/0ooK^0?ofkP0;
0?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP0mFJ/00P0mFJ/60?ofkP030000003om^h0
ooK^00<0?EV[1P3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP80?EV[1P3om^h00`0mFJ/0ooK^0?ofkP06
0?ofkP80?EV[103om^h00`0mFJ/0ooK^000000020000000401D60P0000005@H20000008090X500@0
000003Y?U00jCi@0>TnD0P3D?AT303Y?U0<00000100b@g/01P3D?AT0<T=k0393N`3D?AT0<T=k0000
00D0<T=k0P0000000`0V<5H0000002H`EP0302H`EP030=@m6@0V<5H0e3dI00<00000100K7c`40000
00H0ooK^00D0e3dI0?ofkP3D?AT0ooK^0=@m6@030?ofkP80e3dI2P3om^h00`3D?AT0ooK^0?ofkP0>
0?ofkP80e3dI00<0ooK^0=@m6@3om^h05@3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0
ooK^01<0ooK^00<0e3dI0?ofkP3om^h04@3om^h00`3D?AT0ooK^0?ofkP0R0?ofkP030000003om^h0
ooK^01d0ooK^00<000000?ofkP3om^h06P3om^h10?ooo`00E@3om^h00`000000ooK^0?ofkP0;0?of
kP0303eIZ`3om^h0ooK^00H0ooK^0P0mFJ/<0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?of
kP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP80?EV[103om^h01P000000ooK^0?ofkP3om^h0
?EV[0?ofkP<0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0?EV[0080?EV[0P3o
m^h00`0mFJ/0ooK^0?ofkP090?ofkP<0?EV[00<0ooK^03eIZ`3om^h00P000000100E1P8000000000
0000000202@:1@070000000jCi@0>TnD03Y?U03D?AT0>TnD0=@m6@0303Y?U00303eIZ`000000>TnD
008000000P0b@g/01@3D?AT0<T=k0393N`3D?AT0000000P0<T=k0`00000202H`EP070=@m6@0V<5H0
9S1F0=@m6@0V<5H0000002H`EP03000000<06all1@0000020?ofkP030=@m6@3om^h0e3dI00<0ooK^
00<0e3dI0?ofkP3om^h00P3om^h20=@m6@L0ooK^00<0e3dI0?ofkP3om^h04@3om^h00`3D?AT0ooK^
0?ofkP0D0?ofkP030=@m6@3om^h0e3dI01<0ooK^00<0e3dI0?ofkP3D?AT04`3om^h20=@m6A80ooK^
0P3D?ATR0?ofkP8000008@3om^h00`000000ooK^0?ofkP0I0?ofkP40oooo001E0?ofkP030000003o
m^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h0203om^h303eIZ`P0ooK^00<0?EV[0?ofkP3om^h02`3o
m^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00D0ooK^0`0mFJ/00`000000ooK^0?of
kP020?ofkP0303eIZ`3om^h0ooK^0080ooK^0`0mFJ/@0?ofkP0303eIZ`3om^h0ooK^0080ooK^0`0m
FJ/>0?ofkP<0?EV[0P000000100E1P8000000000000T2PD3000000<0>TnD00<0e3dI03Y?U03D?AT0
100jCi@01`000000>TnD03Y?U00jCi@000000=@m6@0000000P0b@g/00`3D?AT000000393N`080393
N`040000000b@g/000000=@m6@@09S1F00<0e3dI0000000V<5H00`0V<5H4000000806all1@000000
0`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00@0ooK^0P3D?AT40?ofkP030=@m6@3om^h0
ooK^0140ooK^00<0e3dI0?ofkP3D?AT0503om^h0103D?AT0ooK^0?ofkP3D?ATB0?ofkP040=@m6@3o
m^h0ooK^0=@m6A80ooK^00@0e3dI0?ofkP3om^h0e3dI403om^h00`3D?AT0ooK^0=@m6@0Q0?ofkP03
0000003om^h0ooK^0240ooK^00<000000?ofkP3om^h06@3om^h10?ooo`00E03om^h00`000000ooK^
0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00`0ooK^0`0mFJ/50?ofkP0303eIZ`3om^h0ooK^00/0ooK^
00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP080?ofkP060000000mFJ/0?EV[03eIZ`3o
m^h0?EV[1P3om^h00`0mFJ/0ooK^03eIZ`0203eIZ`d0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0m
FJ/0ooK^0?ofkP0203eIZ`d0ooK^00H0?EV[0000000mFJ/0?EV[01D60P00000402@:1@<0000000@0
e3dI03Y?U00jCi@0e3dI100jCi@01@000000>TnD03Y?U00jCi@0e3dI0080>TnD0P0000000`0b@g/0
e3dI0393N`080393N`040000000b@g/0e3dI0393N`<0000000@09S1F0=@m6@0V<5H000001P0V<5H3
000000<06all00<000000=@m6@0000000`0000020?ofkP030=@m6@3om^h0ooK^00D0ooK^0P3D?AT0
0`3om^h0e3dI0?ofkP0B0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT04P3om^h00`3D?AT0ooK^0?of
kP020?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?of
kP0>0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT03P3om^h20=@m6@<0ooK^00<0e3dI0?ofkP3om^h0
7@3om^h00`000000ooK^0?ofkP0R0?ofkP030000003om^h0ooK^01T0ooK^0@3oool005<0ooK^00<0
00000?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP<0?EV[00<0ooK^03eIZ`3om^h03@3o
m^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00P0ooK^00@000000?ofkP3om^h0ooK^
0P0mFJ/50?ofkP0303eIZ`3om^h0ooK^00<0ooK^0P0mFJ/;0?ofkP0303eIZ`3om^h0ooK^0080ooK^
00<0?EV[0?ofkP3om^h00P3om^h303eIZ`X0ooK^00@0?EV[0000000000005@H20P0mFJ/01`3D?AT0
90X502@:1@0T2PD0000003Y?U03D?AT00P0000000`0jCi@0e3dI03Y?U00303Y?U0040000000jCi@0
>TnD0=@m6@D0>TnD00<000000=@m6@000000200b@g/00`000000e3dI0393N`040393N`80000000<0
e3dI0000000V<5H01P0V<5H01`0000009S1F0000000000006all0=@m6@0K7c`01P0000000`3om^h0
e3dI0?ofkP070?ofkP030=@m6@3om^h0ooK^0140ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0
ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0
ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0
ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h0703om^h00`000000
ooK^0?ofkP0S0?ofkP030000003om^h0ooK^01T0ooK^0@3oool005<0ooK^00<000000?ofkP3om^h0
2`3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP<0?EV[3@3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eI
Z`3om^h0ooK^00P0ooK^00<000000?ofkP3om^h00`3om^h403eIZ`80ooK^00<0?EV[0?ofkP3om^h0
1@3om^h303eIZ`L0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP060?ofkP80?EV[
1`3om^h00`000000?EV[0000000201D60P8000000P0mFJ/202@:1@030000003D?AT0>TnD0080>TnD
0`00000203Y?U0040000000jCi@0>TnD0=@m6@L0>TnD00@0e3dI03Y?U000000000001P0b@g/00`3D
?AT0<T=k0393N`060393N`030=@m6@000000000000H09S1F00P0000002H`EP0V<5H09S1F0=@m6@00
00006all000000806all1@0000000`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0e3dI0140ooK^
00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00H0ooK^
00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00/0ooK^
00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^00@0ooK^
00<0e3dI0?ofkP3om^h06`3om^h00`000000ooK^0?ofkP0U0?ofkP030000003om^h0ooK^01P0ooK^
0@3oool00580ooK^00<000000?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP0303eIZ`3o
m^h0?EV[0080?EV[2@3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0
00000?ofkP3om^h0103om^h0100mFJ/0ooK^0?ofkP3om^h303eIZ`X0ooK^0`0mFJ/40?ofkP0503eI
Z`3om^h0ooK^0?ofkP0mFJ/02`3om^h303eIZ`<0ooK^00P0000003eIZ`0E1P80000001D60P000000
90X50000008090X50P0mFJ/010000000?eRV00000000000203Y?U0030=@m6@0jCi@0000000800000
0P0jCi@00`3D?AT0>TnD03Y?U00503Y?U0040000003D?AT0>TnD03Y?U0<000000P0b@g/00`3D?AT0
00000393N`080393N`040=@m6@0b@g/00000000000@09S1F00@0000002H`EP0V<5H0e3dI0P0V<5H3
000000<06all100000000`3D?AT0ooK^0?ofkP020?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT03`3o
m^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00T0ooK^0P3D?AT90?ofkP030=@m6@3o
m^h0ooK^00P0ooK^0P3D?AT90?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h01@3o
m^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h06P3o
m^h00`000000ooK^0?ofkP0V0?ofkP030000003om^h0ooK^01P0ooK^0@3oool00580ooK^00<00000
0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^00<0ooK^0`0mFJ/6
0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`000000ooK^0?ofkP05
0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP0mFJ/00P0mFJ/:0?ofkP<0?EV[00<0ooK^
03eIZ`3om^h00P3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP80?EV[0P000000100mFJ/05@H200000000
000202@:1@060000000T2PD090X50000000f3`P000000`0oF:H3000000030=@m6@0jCi@0>TnD00<0
0000200jCi@00`000000e3dI03Y?U00403Y?U080000000<0e3dI0000000b@g/0200b@g/0103D?AT0
<T=k0393N`0b@g/2000000<09S1F00<0000002H`EP3D?AT0100V<5H3000000<06all00<0000003eI
Z`3D?AT00P0000020?ofkP030=@m6@3om^h0ooK^0080ooK^0P3D?AT<0?ofkP030=@m6@3om^h0ooK^
00T0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^
00H0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP070?ofkP80e3dI2@3om^h00`3D
?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h0603om^h00`00
0000ooK^0?ofkP0W0?ofkP030000003om^h0ooK^01P0ooK^0@3oool00540ooK^00<000000?ofkP3o
m^h0303om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP0303eIZ`3om^h0ooK^00H0ooK^0P0mFJ/40?ofkP80
?EV[1P3om^h00`0mFJ/0ooK^0?ofkP070?ofkP030000003om^h0ooK^00@0ooK^00<0?EV[0?ofkP3o
m^h00P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP80?EV[2`3om^h303eIZ`030?ofkP0mFJ/0ooK^0100
ooK^00D0000001D60P0mFJ/05@H20000000202@:1@040000000T2PD090X500000080=Pl800<00000
03mHYP0oF:H0100oF:H01P3D?AT0000003Y?U0000000e3dI03Y?U0<000001@0jCi@00`000000e3dI
03Y?U00503Y?U0040=@m6@0000000000000000P0<T=k00<000000=@m6@0b@g/00`0b@g/200000003
03eIZ`000000e3dI00H09S1F00@0000002H`EP00000000000P0K7c`00`0000006all0=@m6@030000
00L0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^
00D0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^
00/0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^
00D0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP0F0?ofkP800000:P3om^h00`00
0000ooK^0?ofkP0H0?ofkP40oooo001@0?ofkP030000003om^h0ooK^00d0ooK^00<0?EV[0?ofkP3o
m^h0503om^h00`0mFJ/0ooK^0?ofkP080?ofkP<0?EV[00<0ooK^03eIZ`3om^h00`0mFJ/20?ofkP03
03eIZ`3om^h0ooK^00L0ooK^00<000000?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP020?ofkP03
03eIZ`3om^h0ooK^00D0ooK^0`0mFJ/90?ofkP0303eIZ`3om^h0?EV[0080?EV[3`3om^h010000000
5@H201D60P0mFJ/20000008090X500@0000002@:1@0T2PD000000P0f3`P00`000000?eRV03mHYP04
03mHYP050=@m6@0oF:H000000=@m6@000000100jCi@300000080>TnD00<0000003Y?U03D?AT0100j
Ci@01@3D?AT0>TnD03Y?U00mFJ/0>TnD008000001P0b@g/00`000000e3dI0393N`050393N`030000
003D?AT0000000L09S1F00<0000002H`EP0V<5H0100000000`0K7c`0e3dI01/O?004000000D0ooK^
00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00<0ooK^
00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00d0ooK^
00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00@0ooK^
00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP0E0?ofkP030000003om^h0ooK^02X0ooK^
00<000000?ofkP3om^h0603om^h10?ooo`00D03om^h00`000000ooK^0?ofkP0=0?ofkP0303eIZ`3o
m^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h0303om^h303eIZ`<0ooK^0`0mFJ/80?ofkP030000003o
m^h0ooK^00H0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0;0?ofkP<0?EV[1P3om^h00`0mFJ/0ooK^
03eIZ`020?ofkP80?EV[303om^h2000000805@H200<0?EV[0000000T2PD00P0T2PD00`00000090X5
0000000303H?20030000000oF:H0?eRV00@0?eRV00D0e3dI03mHYP3D?AT0000003mHYP03000000@0
>TnD0`0000000`0jCi@0e3dI03Y?U00203Y?U0050=@m6@0jCi@0>TnD03Y?U00000000`0jCi@30000
00<0<T=k00<000000393N`3D?AT01@0b@g/00`3D?AT000000393N`03000000@09S1F00<0000002H`
EP0V<5H00`0V<5H3000000030=@m6@0K7c`06all00H000000P3om^h00`3D?AT0ooK^0?ofkP050?of
kP030=@m6@3om^h0ooK^00h0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0A0?ofkP050=@m6@3om^h0
ooK^0?ofkP3D?AT0403om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00`0ooK^00@0
e3dI0?ofkP3om^h0ooK^0P3D?AT<0?ofkP030=@m6@3om^h0ooK^01@0ooK^00<000000?ofkP3om^h0
;03om^h00`000000ooK^0?ofkP0G0?ofkP40oooo001?0?ofkP030000003om^h0ooK^00d0ooK^00<0
?EV[0?ofkP3om^h0503om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00<0?EV[00<0
ooK^03eIZ`3om^h00`0mFJ/50?ofkP030000003om^h0ooK^00H0ooK^00D0?EV[0?ofkP3om^h0ooK^
03eIZ`0>0?ofkP80?EV[0`3om^h00`0mFJ/0ooK^03eIZ`050?ofkP<0?EV[203om^h2000000<05@H2
00<0?EV[0000000T2PD00P0T2PD2000000@0=Pl800<0000003mHYP0oF:H0100oF:H0103D?AT0?eRV
0=@m6@00000403mHYP800000100jCi@300000080>TnD00<0e3dI03Y?U00jCi@00P0jCi@00`000000
>TnD03Y?U00403Y?U080000000@0<T=k0000000b@g/0e3dI100b@g/00`3D?AT0<T=k000000040393
N`@0000000<09S1F0000000V<5H0100V<5H01P0000009S1F0000003D?AT0000001/O?0L0000000<0
ooK^0=@m6@3om^h0103om^h00`3D?AT0ooK^0?ofkP0@0?ofkP030=@m6@3om^h0e3dI01<0ooK^00<0
e3dI0?ofkP3D?AT04P3om^h0103D?AT0ooK^0?ofkP3D?AT?0?ofkP040=@m6@3om^h0ooK^0=@m6@l0
ooK^00<0e3dI0?ofkP3om^h04P3om^h00`000000ooK^0?ofkP0]0?ofkP030000003om^h0ooK^01L0
ooK^0@3oool004h0ooK^00<000000?ofkP3om^h03P3om^h203eIZa@0ooK^00<0?EV[0?ofkP3om^h0
3@3om^h00`0mFJ/0ooK^0?ofkP030?ofkP<0?EV[0`3om^h303eIZ`030?ofkP000000ooK^00P0ooK^
00@0?EV[0?ofkP3om^h0?EV[4@3om^h403eIZ`030?ofkP0mFJ/0ooK^00L0ooK^0`0mFJ/40?ofkP<0
00000P0E1P800`000000?EV[0000000302@:1@030000000f3`P0=Pl800<0=Pl800<0000003mHYP0o
F:H0100oF:H20=@m6@0303mHYP000000?eRV00D0?eRV0`000000100jCi@0000003Y?U00jCi@20000
00D0>TnD00<0000003Y?U00jCi@01P0jCi@3000000050393N`3D?AT0<T=k0393N`3D?AT00P0b@g/0
0`000000<T=k0393N`060393N`<000001@0V<5H0100000009S1F0=@m6@0V<5H4000000806all1000
00020=@m6@80ooK^00<0e3dI0?ofkP3om^h04P3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3o
m^h0ooK^0140ooK^00<0e3dI0?ofkP3D?AT04@3om^h20=@m6A00ooK^00<0e3dI0?ofkP3om^h04@3o
m^h00`000000ooK^0?ofkP0^0?ofkP030000003om^h0ooK^01L0ooK^0@3oool004h0ooK^00<00000
0?ofkP3om^h03P3om^h00`0mFJ/0ooK^03eIZ`0203eIZa40ooK^00<0?EV[0?ofkP3om^h03@3om^h0
0`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0?EV[0080?EV[0`3om^h00`000000?EV[03eIZ`08
0?ofkP0403eIZ`3om^h0ooK^03eIZa@0ooK^0`0mFJ/;0?ofkP<0?EV[00T0ooK^0000000E1P800000
01D60P000000?EV[02@:1@0000000P0T2PD2000000D0=Pl800<0000003mHYP0oF:H0100oF:H0103D
?AT0?eRV03mHYP00000903mHYP<0000000<0>TnD0=@m6@0jCi@00`00000203Y?U0030000000jCi@0
>TnD00L0>TnD00H0000003Y?U0000000e3dI0393N`3D?AT40393N`030000000b@g/0<T=k00H0<T=k
00@000000393N`00000000000`0V<5H0100000009S1F02H`EP3D?AT302H`EP<000000P0K7c`40000
0080e3dI503om^h00`3D?AT0ooK^0=@m6@0C0?ofkP030=@m6@3om^h0e3dI01<0ooK^00<0e3dI0?of
kP3om^h0403om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^0100ooK^00<000000?of
kP3om^h0;`3om^h00`000000ooK^0?ofkP0G0?ofkP40oooo001=0?ofkP030000003om^h0ooK^00h0
ooK^00<0?EV[0?ofkP3om^h00`3om^h303eIZ`h0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0
ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00<0ooK^0P0mFJ/010000000ooK^0?ofkP3om^h303eI
Z`@0ooK^00@0?EV[0?ofkP3om^h0?EV[5@3om^h00`0mFJ/0ooK^0?ofkP0203eIZ``0ooK^0P0mFJ/0
1`0E1P80000001D60P000000?EV[02@:1@0000000P0T2PD2000000D0=Pl800<0000003mHYP0oF:H0
0`0oF:H20=@m6@80?eRV00<0000003mHYP0oF:H0200oF:H010000000?eRV0=@m6@3D?AT403Y?U0<0
00002@0jCi@01@000000>TnD03Y?U00jCi@0e3dI008000000`0b@g/00`000000<T=k0393N`060393
N`040000000b@g/0<T=k0393N`8000000P0V<5H0100000009S1F02H`EP3D?AT302H`EP050000000V
<5H000000000000K7c`01P00000B0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT04@3om^h0103D?AT0
ooK^0?ofkP3D?ATB0?ofkP80e3dI4@3om^h20=@m6A00ooK^0P3D?ATA0?ofkP030000003om^h0ooK^
0340ooK^00<000000?ofkP3om^h05P3om^h10?ooo`00C@3om^h00`000000ooK^0?ofkP0>0?ofkP03
03eIZ`3om^h0ooK^00H0ooK^0P0mFJ/;0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3o
m^h0103om^h00`0mFJ/0ooK^0?ofkP050?ofkP030000000mFJ/0?EV[00@0ooK^0`0mFJ/01@3om^h0
?EV[0?ofkP3om^h0?EV[01D0ooK^00<0?EV[0?ofkP3om^h00P3om^h303eIZ`P0ooK^0P0000001`0E
1P80?EV[03eIZ`0mFJ/090X503eIZ`0000000P0T2PD00`000000=Pl80000000503H?20030000000o
F:H0?eRV0080?eRV00@0e3dI03mHYP0oF:H0e3dI0P0oF:H00`000000?eRV03mHYP0703mHYP050000
003D?AT0?eRV03mHYP3D?AT00P00000303Y?U0<000001`0jCi@01`000000>TnD03Y?U03D?AT0>TnD
0=@m6@0jCi@00P0000000`0b@g/000000393N`070393N`030000000b@g/0<T=k00<0<T=k0P000000
1@0mFJ/09S1F0=@m6@0V<5H0e3dI00<09S1F00<0000002H`EP0V<5H0100000000`0K7c`000000000
0004000000d0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3o
m^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h03P3om^h0103D?AT0ooK^0?ofkP3D?AT?0?ofkP040=@m
6@3om^h0ooK^0=@m6@h0ooK^00<0e3dI0?ofkP3D?AT03`3om^h2000003@0ooK^00<000000?ofkP3o
m^h05P3om^h10?ooo`00C03om^h00`000000ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00T0ooK^
0`0mFJ/80?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^
0?ofkP050?ofkP040000003om^h0ooK^0?ofkP<0?EV[103om^h403eIZaD0ooK^00<0?EV[0?ofkP3o
m^h01P3om^h203eIZ`D0ooK^0P00000201D60P80000000H090X503eIZ`0mFJ/0?EV[02@:1@000002
03H?20030000000f3`P0=Pl800<0=Pl80P00000203mHYP050=@m6@0oF:H0?eRV03mHYP3D?AT00P0o
F:H00`000000?eRV03mHYP0703mHYP050000003D?AT0?eRV03mHYP3D?AT00P0oF:H20000000403Y?
U0000000>TnD03Y?U0<00000100jCi@00`000000>TnD0=@m6@0303Y?U0030=@m6@0jCi@0>TnD00<0
00001`0b@g/00`000000<T=k0393N`050393N`030000003D?AT0000000809S1F00@0e3dI02H`EP0V
<5H000001@0V<5H2000000806all0`000000100B5BT000000000000000090?ofkP030=@m6@3om^h0
ooK^00@0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0
ooK^00d0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0>0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT0
3@3om^h0103D?AT0ooK^0?ofkP3D?AT>0?ofkP030000003om^h0ooK^03@0ooK^00<000000?ofkP3o
m^h05P3om^h10?ooo`00B`3om^h00`000000ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00`0ooK^
0`0mFJ/50?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^
0?ofkP040?ofkP030000003om^h0ooK^00D0ooK^0P0mFJ/30?ofkP0303eIZ`3om^h0?EV[0080?EV[
4`3om^h00`0mFJ/0ooK^0?ofkP080?ofkP<0?EV[00@0ooK^00000000000000000P0E1P801P000000
90X502@:1@0T2PD0?EV[000000<0?EV[00<0=Pl80000000f3`P00`0f3`P20000000404=N/P000000
00000=@m6@<0?eRV00@0e3dI03mHYP0oF:H000002@0oF:H00`3D?AT0?eRV03mHYP0203mHYP040=@m
6@0oF:H0?eRV03mHYP<00000100jCi@300000080>TnD00<0e3dI03Y?U00jCi@00P0jCi@01P3D?AT0
>TnD03Y?U00jCi@0000003Y?U08000001P0b@g/00`000000<T=k0393N`040393N`030=@m6@000000
<T=k00<0000000@0e3dI02H`EP0V<5H000001P0V<5H20000000301/O?00000006all008000000P0B
5BT2000000H0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3o
m^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3o
m^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP050=@m6@3o
m^h0ooK^0?ofkP3D?AT03@3om^h00`000000ooK^0?ofkP0e0?ofkP030000003om^h0ooK^01H0ooK^
0@3oool004/0ooK^00<000000?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP<0?EV[00<0
ooK^03eIZ`3om^h03P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0
00000?ofkP3om^h0203om^h303eIZ`030?ofkP0mFJ/0ooK^0080ooK^0`0mFJ/?0?ofkP80?EV[3@3o
m^h3000000805@H20P00000302@:1@0303eIZ`00000000000080=Pl80P0mFJ/303H?20030000001G
60`000000080@ejb00@0e3dI04=N/P00000000000P0oF:H00`3D?AT0?eRV0000000803mHYP030=@m
6@000000?eRV00<0?eRV00<0e3dI03mHYP0oF:H00P0oF:H00`000000?EV[00000002000000@0>TnD
0P0000000`3D?AT0>TnD03Y?U00303Y?U0040=@m6@0jCi@0>TnD000000<0>TnD0`0000030393N`03
0000000b@g/0<T=k00<0<T=k00@0e3dI0393N`0b@g/000000`0b@g/010000000e3dI000000000006
02H`EP030000000V<5H0000000<0000000D06all0000000000000000018E:@02000000<0ooK^00<0
e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0
e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0
e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^0080ooK^00<0
e3dI0?ofkP3om^h02P3om^h00`000000ooK^0?ofkP0g0?ofkP030000003om^h0ooK^01D0ooK^0@3o
ool004X0ooK^00<000000?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP<0?EV[3P3om^h0
0`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<000000?ofkP3om^h02P3om^h4
03eIZ`D0ooK^0`0mFJ/<0?ofkP80?EV[3@3om^h30000000401D60P00000090X50000008090X500<0
?EV[02@:1@000000100f3`P010000000?EV[03eIZ`0mFJ/205LH300300000013G[80e3dI00@0@ejb
0P0000000`3D?AT0?eRV0000000703mHYP030=@m6@0oF:H0000000D0?eRV00D0e3dI03mHYP0oF:H0
?eRV0000000403mHYP8000000`0jCi@0103D?AT0000000000000000403Y?U0030=@m6@0jCi@00000
00H0>TnD0P0000000`0b@g/000000393N`030393N`050=@m6@0b@g/0<T=k0393N`0000001@0b@g/0
103D?AT0000000000000000502H`EP030000000V<5H09S1F00<000000P0K7c`6000000030=@m6@3o
m^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3o
m^h0ooK^00L0ooK^0P3D?AT70?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h01@3o
m^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h02@3o
m^h00`000000ooK^0?ofkP0h0?ofkP030000003om^h0ooK^01D0ooK^0@3oool004X0ooK^00<00000
0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP0303eIZ`3om^h0?EV[0080?EV[2P3om^h0
0`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<000000?ofkP3om^h02`3om^h0
100mFJ/0ooK^03eIZ`3om^h303eIZ`D0ooK^0P0mFJ/90?ofkP0303eIZ`3om^h0?EV[00`0ooK^0P00
00000`0E1P8000000000000202@:1@040000000T2PD090X503eIZ`800000100f3`P010000000=Pl8
03H?2000000203eIZ`030000003D?AT0@ejb00H0@ejb00@0e3dI00000000000000001@0oF:H0103D
?AT0?eRV03mHYP00000503mHYP050=@m6@0oF:H0?eRV03mHYP0000001P0oF:H2000000030=@m6@0j
Ci@000000080>TnD0P00000303Y?U0030=@m6@000000>TnD00L0>TnD0`0000020393N`030=@m6@0b
@g/0<T=k0080<T=k00<000000393N`0b@g/0100b@g/00`3D?AT000000393N`02000000<09S1F00<0
000002H`EP0V<5H00P0V<5H3000000806all00<0000001/O?00K7c`01000000:0?ofkP030=@m6@3o
m^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3o
m^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h01@3om^h20=@m6@P0ooK^00<0e3dI0?ofkP3om^h01P3o
m^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00L0ooK^00<000000?ofkP3om^h0>@3o
m^h00`000000ooK^0?ofkP0E0?ofkP40oooo00190?ofkP030000003om^h0ooK^00l0ooK^00<0?EV[
0?ofkP3om^h0503om^h00`0mFJ/0ooK^0?ofkP030?ofkP80?EV[203om^h00`0mFJ/0ooK^0?ofkP03
0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<000000?ofkP3om^h0303om^h203eIZ`D0ooK^0`0mFJ/4
0?ofkP<0?EV[1P3om^h00`0mFJ/0ooK^03eIZ`0;0?ofkP040000000E1P80000001D60P8000000P0T
2PD01P00000090X502@:1@0mFJ/0=Pl8000000@0=Pl800<0000003H?200000000`1G60`00`0mFJ/0
e3dI04=N/P0704=N/P030=@m6@000000@ejb008000000`0oF:H0103D?AT0?eRV03mHYP00000603mH
YP040=@m6@0oF:H0?eRV000000L0?eRV00<0e3dI03mHYP0000000P00000303Y?U0<0000000<0>TnD
0=@m6@000000200jCi@01@000000>TnD0000003D?AT0000000@0<T=k00<000000393N`0b@g/01@0b
@g/0103D?AT000000393N`0b@g/2000000809S1F00<0000002H`EP0V<5H00`0V<5H6000000<06all
100000080?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^
0?ofkP030?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^
0?ofkP080?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^
0?ofkP060?ofkP030000003om^h0ooK^03X0ooK^00<000000?ofkP3om^h05@3om^h10?ooo`00B03o
m^h00`000000ooK^0?ofkP0@0?ofkP0303eIZ`3om^h0ooK^01@0ooK^00<0?EV[0?ofkP3om^h01@3o
m^h303eIZ`D0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP030?ofkP030000003o
m^h0ooK^00/0ooK^00<0?EV[0?ofkP0mFJ/0203om^h403eIZ`<0ooK^0`0mFJ/20?ofkP0303eIZ`3o
m^h0?EV[00/0ooK^00@0000001D60P0000005@H20P00000202@:1@070000000T2PD090X50000000m
FJ/0=Pl80000000403H?20800000101G60`00`000000@ejb04=N/P0704=N/P030=@m6@000000@ejb
0080@ejb0P0000001@3D?AT0?eRV03mHYP0oF:H0000000H0?eRV00@0e3dI03mHYP0oF:H000001P0o
F:H01P3D?AT0?eRV03mHYP0oF:H0000003mHYP800000100jCi@3000000P0>TnD00D0000003Y?U00j
Ci@0e3dI03Y?U004000000030393N`000000<T=k00H0<T=k00<0e3dI0393N`0b@g/00P0b@g/30000
00H09S1F00<0000002H`EP0V<5H01000000201/O?0D000001`3om^h00`3D?AT0ooK^0?ofkP020?of
kP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP0:0?of
kP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP030?of
kP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h0103om^h2000003d0ooK^00<000000?of
kP3om^h05@3om^h10?ooo`00B03om^h00`000000ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^01@0
ooK^00<0?EV[0?ofkP3om^h02@3om^h303eIZ`80ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0
ooK^0?ofkP030?ofkP030000003om^h0ooK^00`0ooK^0P0mFJ/=0?ofkP<0?EV[0`3om^h303eIZ`03
0?ofkP0mFJ/0ooK^00X0ooK^0`0000000`0E1P80000002@:1@0202@:1@070000000T2PD090X50000
000mFJ/0=Pl80000000403H?20030000001G60`0EaP<00@0EaP<00<0000004=N/P13G[801P13G[80
0`3D?AT0000004=N/P0304=N/P060=@m6@13G[8000000000000oF:H000001`0oF:H00`3D?AT0?eRV
0000000503mHYP030=@m6@0oF:H0?eRV0080?eRV00@0000003mHYP0oF:H0?eRV0`00000303Y?U003
0=@m6@000000000000H0>TnD00<0000003Y?U03D?AT01P0jCi@3000000H0<T=k00<000000=@m6@0b
@g/0100b@g/3000000@09S1F00<0000002H`EP0V<5H00`0V<5H3000000806all00<0000001/O?000
00000P0000050?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT0403om^h0103D?AT0ooK^0?ofkP3D?AT>
0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT03@3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3o
m^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`000000ooK^0?ofkP0n0?ofkP030000003o
m^h0ooK^01@0ooK^0@3oool004L0ooK^00<000000?ofkP3om^h0403om^h00`0mFJ/0ooK^0?ofkP0D
0?ofkP0303eIZ`3om^h0ooK^00`0ooK^0P0mFJ/50?ofkP0303eIZ`3om^h0ooK^0080ooK^00<00000
0?ofkP3om^h03@3om^h203eIZa00ooK^0`0mFJ/00`3om^h0?EV[0?ofkP0303eIZ`T0ooK^0`000000
0`0E1P8000000000000302@:1@040000000T2PD0000003eIZ`80=Pl800@0000003H?200f3`P0=Pl8
0P00000605LH300300000013G[80@ejb00L0@ejb00D0e3dI04=N/P13G[80@ejb0=@m6@0404=N/P<0
00001P0oF:H00`3D?AT0?eRV0000000403mHYP030=@m6@0oF:H0?eRV00<0?eRV00<0000003mHYP0o
F:H0100oF:H20000000403Y?U0000000e3dI03Y?U0<000000`0jCi@00`000000e3dI03Y?U00603Y?
U00303eIZ`000000>TnD008000001@0b@g/00`000000e3dI0393N`040393N`030000000b@g/00000
008000000P0V<5H00`0000009S1F02H`EP0402H`EP<0000000@06all0000000K7c`06all0`000004
0?ofkP030=@m6@3om^h0e3dI0140ooK^00<0e3dI0?ofkP3D?AT03`3om^h0103D?AT0ooK^0?ofkP3D
?AT>0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT02`3om^h00`3D?AT0ooK^0?ofkP020?ofkP030000
003om^h0ooK^03l0ooK^00<000000?ofkP3om^h0503om^h10?ooo`00A`3om^h00`000000ooK^0?of
kP0?0?ofkP0303eIZ`3om^h0ooK^01@0ooK^00<0?EV[0?ofkP3om^h03P3om^h403eIZ`030?ofkP0m
FJ/0ooK^00<0ooK^00<000000?ofkP3om^h03@3om^h203eIZa@0ooK^0`0mFJ/00`3om^h0?EV[0?of
kP0303eIZ`D0ooK^0P0000000`0E1P80000001D60P02000000<090X50P0000001@0f3`P0?EV[03H?
200f3`P0000000<0=Pl80P00000605LH300300000013G[80@ejb00L0@ejb00@0e3dI04=N/P13G[80
e3dI1P13G[8010000000@ejb00000000000503mHYP030=@m6@000000?eRV0080?eRV00<0e3dI03mH
YP0oF:H0100oF:H00`000000?eRV03mHYP0603mHYP<0000000@0e3dI03Y?U00jCi@0>TnD0`000000
0`3D?AT0000003Y?U00703Y?U0040000000jCi@0>TnD03Y?U0<000000P0b@g/00`000000<T=k0=@m
6@050393N`040000000b@g/0<T=k0393N`@000001@0V<5H00`0000009S1F02H`EP04000000806all
0`0000030?ofkP030=@m6@3om^h0ooK^0140ooK^00<0e3dI0?ofkP3om^h03`3om^h20=@m6@l0ooK^
00@0e3dI0?ofkP3om^h0e3dI303om^h01@3D?AT0ooK^0?ofkP3om^h000000480ooK^00<000000?of
kP3om^h0503om^h10?ooo`00AP3om^h00`000000ooK^0?ofkP0@0?ofkP80?EV[5@3om^h00`0mFJ/0
ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0?EV[00@0?EV[0`3om^h00`000000ooK^0?ofkP0=0?ofkP80
?EV[5@3om^h0100mFJ/0ooK^03eIZ`0mFJ/40?ofkP80?EV[0`3om^h30000000401D60P00000090X5
000000<090X500@0000003H?200f3`P0?EV[0P0f3`P01P000000=Pl803H?20000000EaP<000000H0
EaP<00<0000004=N/P13G[801`13G[80103D?AT0@ejb04=N/P3D?AT604=N/P0400000013G[80@ejb
04=N/P<000000P0oF:H00`3D?AT0000003mHYP0203mHYP030=@m6@0oF:H0?eRV00@0?eRV00<00000
03mHYP0oF:H01`0oF:H010000000?eRV0000003D?AT403Y?U0030=@m6@000000000000P0>TnD00<0
000003Y?U00jCi@0100jCi@2000000040393N`000000<T=k0=@m6@@0<T=k00<000000393N`0b@g/0
100b@g/3000000@09S1F00<0000002H`EP0V<5H00P0V<5H30000000401/O?00000000000000000<0
e3dI4P3om^h20=@m6A40ooK^00<0e3dI0?ofkP3om^h03`3om^h20=@m6@d0ooK^00@0e3dI0?ofkP3o
m^h00000@`3om^h00`000000ooK^0?ofkP0D0?ofkP40oooo00150?ofkP030000003om^h0ooK^0140
ooK^00<0?EV[0?ofkP0mFJ/00P0mFJ/B0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3o
m^h00P3om^h503eIZ`030000003om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h04`3om^h01@0mFJ/0
ooK^0?ofkP0mFJ/0ooK^00<0?EV[0`3om^h303eIZ`040000000E1P8000000000008090X500<00000
02@:1@0T2PD00P00000203H?200603eIZ`0f3`P0=Pl80000000f3`P000000P1G60`00`000000EaP<
05LH300405LH300300000013G[80@ejb00L0@ejb00<000000=@m6@3D?AT01`13G[800`000000@ejb
04=N/P0404=N/P80000000D0?eRV0=@m6@0oF:H0?eRV0=@m6@0703mHYP030000000oF:H0?eRV00L0
?eRV00@0000003mHYP0oF:H0e3dI0`0000000`3D?AT0>TnD03Y?U004000000D0>TnD00<0000003Y?
U00jCi@01P0jCi@3000000030393N`3D?AT0<T=k0080<T=k00<000000393N`0b@g/01@0b@g/01000
0000<T=k00000000000302H`EP030000000V<5H09S1F00<09S1F0`0000000`0K7c`0000001/O?002
000000030=@m6@3om^h0ooK^00h0ooK^00@0e3dI0?ofkP3om^h0e3dI3`3om^h20=@m6A40ooK^00<0
e3dI0?ofkP3om^h02`3om^h20=@m6@030?ofkP000000ooK^04@0ooK^00<000000?ofkP3om^h04`3o
m^h10?ooo`00A@3om^h00`000000ooK^0?ofkP0@0?ofkP0303eIZ`3om^h0ooK^00<0ooK^0`0mFJ/>
0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h00P3om^h01@0mFJ/0ooK^0?ofkP0m
FJ/0000000@0?EV[3@3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0403eIZ`3om^h0ooK^03eIZ`@0ooK^
0`0mFJ/00`3om^h000000000000303eIZ`8090X500H0000002@:1@0T2PD0000003H?2000000203H?
200303eIZ`0f3`P0=Pl8008000000`1G60`00`000000EaP<05LH300405LH300300000013G[80@ejb
00L0@ejb00<000000=@m6@13G[801`13G[800`000000@ejb04=N/P0604=N/P040000003D?AT00000
0=@m6@P0?eRV00<0000003mHYP0oF:H01`0oF:H01`000000?eRV03mHYP0oF:H0e3dI03mHYP3D?AT0
0P0000000`0jCi@0000003Y?U00203Y?U08000000`0jCi@00`000000>TnD03Y?U00703Y?U0050000
000jCi@000000000003D?AT00`0b@g/00`000000<T=k0393N`050393N`030000000b@g/0<T=k0080
00000P0V<5H00`0000009S1F02H`EP0302H`EP030000000V<5H0000000<0000000<06all0=@m6@00
00003P3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00h0ooK^00<0e3dI0?ofkP3D?AT0403om^h20=@m
6@`0ooK^00@0e3dI0?ofkP3D?AT00000AP3om^h00`000000ooK^0?ofkP0C0?ofkP40oooo00140?of
kP030000003om^h0ooK^0140ooK^00<0?EV[0?ofkP3om^h01P3om^h203eIZ``0ooK^00<0?EV[0?of
kP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0603eIZ`3om^h0ooK^0?ofkP000000ooK^0P0m
FJ/00`3om^h0?EV[03eIZ`0203eIZ`P0ooK^00<0?EV[0?ofkP3om^h04`3om^h01@0mFJ/0ooK^0?of
kP3om^h0?EV[00L0ooK^0`0000000`0E1P8000000000000303eIZ`0502@:1@000000=Pl803H?2000
00000P0f3`P00`0mFJ/0=Pl803H?2002000000<0EaP<00<0000005LH301G60`0101G60`2000000P0
@ejb00<0e3dI04=N/P3D?AT01`13G[800`000000@ejb04=N/P0704=N/P0303eIZ`3D?AT000000080
00001P0oF:H00`000000?eRV03mHYP0703mHYP030000000oF:H0?eRV0080?eRV00@0e3dI03mHYP0o
F:H0?eRV0`00000403Y?U0<0000000<0>TnD0000000jCi@01`0jCi@01P000000>TnD03Y?U03D?AT0
00000=@m6@80<T=k00<000000393N`0b@g/01@0b@g/00`000000<T=k0393N`020393N`<000001P0V
<5H0100000009S1F02H`EP0V<5H3000000030=@m6@000000?EV[00/0ooK^00<0e3dI0?ofkP3om^h0
0P3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT03P3om^h00`3D?AT0
ooK^0=@m6@0:0?ofkP80e3dI00<0ooK^0=@m6@000000A`3om^h00`000000ooK^0?ofkP0C0?ofkP40
oooo00140?ofkP030000003om^h0ooK^0140ooK^00<0?EV[0?ofkP3om^h0203om^h303eIZ`P0ooK^
00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0403eIZ`3om^h0ooK^000000@0
ooK^0`0mFJ/20?ofkP<0?EV[1@3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0403eIZ`3om^h0ooK^03eI
Z`L0ooK^0`00000201D60P050000000T2PD090X502@:1@0000000P0mFJ/203H?20030000000f3`P0
?EV[00<0=Pl800<0000005LH301G60`00`1G60`00`000000EaP<05LH300205LH3080000000<0AV:l
0000000000001@13G[80103D?AT0000004=N/P3D?AT704=N/P0300000013G[80@ejb00L0@ejb00<0
e3dI04=N/P3D?AT00P13G[82000000@0?eRV00<0000003mHYP0oF:H01`0oF:H01`000000?eRV03mH
YP0oF:H0e3dI03mHYP3D?AT00`0oF:H010000000?eRV00000000000503Y?U0<000001`0jCi@00`00
0000>TnD0=@m6@0303Y?U080e3dI00<0?EV[0000000b@g/01@0b@g/00`000000<T=k0393N`040393
N`<00000100V<5H00`0000009S1F02H`EP0302H`EPD000000P0mFJ/60?ofkP80e3dI1P3om^h00`3D
?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h02P3om^h20=@m
6@80ooK^00<0e3dI0?ofkP3om^h01`3om^h01@3D?AT0ooK^0?ofkP000000e3dI04P0ooK^00<00000
0?ofkP3om^h04`3om^h10?ooo`00@`3om^h00`000000ooK^0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^
00/0ooK^0`0mFJ/50?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h00P3om^h0100m
FJ/0ooK^0?ofkP0000080?ofkP<0?EV[0P3om^h303eIZ`030?ofkP0mFJ/0?EV[01@0ooK^00D0?EV[
0?ofkP3om^h0ooK^03eIZ`060?ofkP80000000<05@H20000000E1P800P00000302@:1@80000000H0
=Pl803eIZ`0mFJ/0?EV[03H?200mFJ/203H?208000001@1G60`01`000000EaP<05LH301G60`00000
07PR400000000`16H[`30000000404=N/P3D?AT0@ejb00000080@ejb00<0e3dI04=N/P13G[801013
G[800`000000@ejb04=N/P0604=N/P040=@m6@000000@ejb0=@m6@@0@ejb0`0000000`0oF:H00000
03mHYP0803mHYP040000000oF:H0?eRV0=@m6@<0?eRV00@0e3dI03mHYP0oF:H000000`0oF:H30000
00<0>TnD00@0000003Y?U000000000001@0jCi@00`000000e3dI03Y?U00503Y?U0030=@m6@000000
000000H0<T=k00<000000393N`0b@g/0100b@g/00`000000<T=k00000002000000809S1F00<00000
02H`EP0V<5H00P0V<5H00`0000009S1F02H`EP0400000080?EV[0`3om^h00`3D?AT0ooK^0?ofkP06
0?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP09
0?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h01P3om^h01P3D?AT0ooK^0?ofkP00
0000ooK^0=@m6DP0ooK^00<000000?ofkP3om^h04`3om^h10?ooo`00@P3om^h00`000000ooK^0?of
kP0B0?ofkP0303eIZ`3om^h0ooK^00l0ooK^0`0mFJ/00`3om^h0?EV[0?ofkP0@0?ofkP0303eIZ`3o
m^h0ooK^0080ooK^00<0?EV[0?ofkP000000303om^h203eIZ`<0ooK^0`0mFJ/D0?ofkP0503eIZ`3o
m^h0ooK^0?ofkP0mFJ/01@3om^h40000000401D60P00000090X5000000<090X500<0000003H?200f
3`P00P0f3`P01`000000?EV[03eIZ`0mFJ/0000005LH300000001@1G60`010000000EaP<05LH3000
000207PR400300000016H[`0AV:l00@0AV:l00@0e3dI00000013G[8000000P13G[800`3D?AT0@ejb
04=N/P0404=N/P0300000013G[80@ejb00D0@ejb00<0e3dI04=N/P0000000P13G[800`3D?AT0@ejb
04=N/P0404=N/P<00000200oF:H00`000000?eRV0=@m6@0503mHYP030=@m6@0oF:H0000000H0?eRV
0P0000000`0mFJ/0000003Y?U00203Y?U0<000000P0jCi@00`3D?AT0000003Y?U00603Y?U0030=@m
6@0jCi@00000008000000`0b@g/00`000000<T=k0393N`050393N`040000000b@g/0<T=k0393N`@0
0000100V<5H00`0000009S1F02H`EP0202H`EP8000000`0mFJ/00`3D?AT0ooK^0?ofkP070?ofkP03
0=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP080?ofkP03
0=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h01@3om^h0103D?AT0ooK^0?ofkP0000020?of
kP030=@m6@3om^h0ooK^04L0ooK^00<000000?ofkP3om^h04P3om^h10?ooo`00@P3om^h00`000000
ooK^0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^0180ooK^0`0mFJ/?0?ofkP0303eIZ`3om^h0ooK^0080
ooK^00@0?EV[0?ofkP3om^h000003P3om^h303eIZ`030?ofkP0mFJ/0ooK^00<0?EV[4@3om^h0100m
FJ/0ooK^0?ofkP0mFJ/50?ofkP040000000E1P80000001D60P8000000P0T2PD00`00000090X502@:
1@02000000@0=Pl800@0000003H?200mFJ/000000P0mFJ/00`000000EaP<05LH300305LH30040000
001G60`0EaP<000000<0N28@00<0000004IR_016H[`00P16H[`00`3D?AT0AV:l04IR_00300000080
@ejb00<0e3dI04=N/P13G[800`13G[800`000000@ejb04=N/P0504=N/P030=@m6@13G[80000000<0
@ejb00<0e3dI04=N/P13G[801013G[8010000000@ejb00000000000603mHYP030000003D?AT0?eRV
00H0?eRV00<0e3dI0000000oF:H01`0oF:H3000000D0>TnD1000000703Y?U0030000003D?AT0>TnD
0080>TnD0`0000000`0b@g/000000393N`050393N`030000000b@g/0<T=k00@0<T=k0P00000402H`
EP030000000V<5H09S1F00<09S1F00<000000?ofkP3D?AT0100mFJ/70?ofkP030=@m6@3om^h0ooK^
00D0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^
00@0ooK^00<0e3dI0?ofkP3om^h0103om^h0103D?AT0ooK^0?ofkP0000030?ofkP030=@m6@3om^h0
ooK^04L0ooK^00<000000?ofkP3om^h04P3om^h10?ooo`00@@3om^h00`000000ooK^0?ofkP0C0?of
kP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP0mFJ/00P0mFJ/<0?ofkP0303eIZ`3om^h0ooK^
0080ooK^00<0?EV[0?ofkP0000004P3om^h303eIZ`<0ooK^0P0mFJ/>0?ofkP0503eIZ`3om^h0ooK^
0?ofkP0mFJ/0103om^h3000000805@H20P00000202@:1@030000000T2PD090X500800000100f3`P0
0`000000?EV[0000000305LH30<0?EV[0`1G60`00`000000EaP<0000000407PR400300000016H[`0
AV:l0080AV:l00H0e3dI04IR_016H[`0AV:l00000016H[`2000000030=@m6@13G[80@ejb00<0@ejb
00<0000004=N/P13G[801013G[80103D?AT0@ejb04=N/P00000404=N/P030=@m6@13G[80@ejb00<0
@ejb00@0000004=N/P13G[80@ejb0`00000303mHYP030=@m6@0oF:H0?eRV00L0?eRV00<0e3dI03mH
YP0oF:H01`0oF:H00`000000?eRV0000000200000080>TnD00<0e3dI03Y?U00jCi@00P00000603Y?
U0040000000jCi@0e3dI0=@m6@@0>TnD0`0000060393N`030000000b@g/0<T=k00@0<T=k0`000003
02H`EP030000000V<5H09S1F00<09S1F00<0e3dI0?ofkP3om^h00P3om^h403eIZ`@0ooK^00<0e3dI
0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI
0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP030?ofkP040=@m6@3om^h0ooK^000000@0ooK^00<0
e3dI0?ofkP3om^h0A`3om^h00`000000ooK^0?ofkP0B0?ofkP40oooo00110?ofkP030000003om^h0
ooK^01<0ooK^00<0?EV[0?ofkP3om^h04P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP<0?EV[2@3om^h0
0`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`000000ooK^0180ooK^0P0mFJ/0103om^h0?EV[03eIZ`0m
FJ/20?ofkP<0?EV[2`3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00@0ooK^0`0000000`0E1P800000
0000000202@:1@060000000T2PD090X50000000f3`P00000100f3`P00`000000?EV[05LH300305LH
30030000001G60`0EaP<00<0?EV[0P00000507PR400500000016H[`0AV:l04IR_03D?AT01016H[`0
1`000000AV:l04IR_016H[`000000=@m6@0000000`13G[800`000000@ejb04=N/P0304=N/P050=@m
6@13G[80@ejb04=N/P0000001013G[800`3D?AT0@ejb04=N/P0304=N/P0300000013G[80@ejb00@0
@ejb0P0000000`3D?AT0000003mHYP0803mHYP030000003D?AT0?eRV00L0?eRV00<0000003mHYP0o
F:H00P0oF:H01`000000e3dI000000000000>TnD0000000jCi@00`00000303Y?U0050000000jCi@0
>TnD03Y?U03D?AT0100jCi@010000000>TnD0000000000040393N`030000000b@g/0<T=k00D0<T=k
00H000000393N`000000000002H`EP00000502H`EP030=@m6@000000?EV[00@0ooK^100mFJ/30?of
kP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP040?of
kP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h00P3om^h0103D?AT0ooK^0?ofkP000004
0?ofkP030=@m6@3om^h0ooK^04P0ooK^00<000000?ofkP3om^h04P3om^h10?ooo`00@03om^h00`00
0000ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h01P3om^h203eI
Z`H0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0000000C0?ofkP0303eIZ`3om^h0ooK^
00<0ooK^0`0mFJ/20?ofkP<0?EV[1`3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0403eIZ`3om^h0ooK^
0?ofkP<000000P0E1P801`00000090X502@:1@0T2PD0000002@:1@0000000P0f3`P00`000000=Pl8
03H?200203H?20030000000mFJ/0EaP<00<0EaP<00<0000005LH301G60`00`1G60`203eIZ`D0N28@
00@0000004IR_016H[`0e3dI1@16H[`00`000000AV:l04IR_00204IR_0060=@m6@16H[`000000000
0013G[8000001013G[800`3D?AT0@ejb04=N/P0204=N/P0300000013G[80@ejb00<0@ejb00<0e3dI
04=N/P13G[800P13G[800`000000@ejb04=N/P0504=N/P040=@m6@0000000000000000P0?eRV00<0
00000=@m6@0oF:H01`0oF:H00`000000?eRV03mHYP0203mHYP040=@m6@0oF:H0?eRV03mHYP<00000
0`0jCi@30000000303Y?U0000000>TnD0080>TnD00D0e3dI03Y?U00jCi@0>TnD0000000303Y?U0<0
00000P0b@g/00`000000<T=k0393N`040393N`040000000b@g/0<T=k0393N`<000001@0V<5H503eI
Z`<0ooK^1@0mFJ/01@3D?AT0ooK^0?ofkP3om^h0e3dI00/0ooK^00<0e3dI0?ofkP3om^h00`3om^h0
0`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^0080e3dI0P3om^h00`000000ooK^0?ofkP03
0?ofkP030=@m6@3om^h0ooK^04T0ooK^00<000000?ofkP3om^h04@3om^h10?ooo`00?`3om^h00`00
0000ooK^0?ofkP0D0?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h0203om^h303eI
Z`<0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/000000?ofkP0B0?ofkP80?EV[203om^h303eI
Z`80ooK^0P0mFJ/50?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/00`3om^h20000000301D60P000000
5@H2008000000`0T2PD2000000<0=Pl800@0000003H?200f3`P0=Pl80P0000000`0mFJ/0EaP<05LH
300305LH30040000001G60`0EaP<05LH3080000000@0N28@03eIZ`0mFJ/0?EV[0P1h8Q000`000000
AV:l0=@m6@0604IR_00300000016H[`0AV:l00<0AV:l00<0e3dI04IR_016H[`00`00000204=N/P03
0=@m6@13G[80@ejb00<0@ejb00<0000004=N/P13G[801013G[801@3D?AT0@ejb04=N/P13G[800000
00L0@ejb00@0e3dI04=N/P000000@ejb0`00000503mHYP030000000oF:H0e3dI00L0?eRV00D00000
03mHYP0oF:H0?eRV0=@m6@0503mHYP040000000oF:H00000000000@0>TnD0P00000403Y?U0050=@m
6@0jCi@0>TnD03Y?U00000001@0jCi@3000000L0<T=k00<000000393N`0b@g/00P0b@g/3000000@0
9S1F00@0000003eIZ`0mFJ/0ooK^0`0mFJ/01P3om^h0?EV[0?ofkP3om^h0?EV[0=@m6@80?EV[00<0
e3dI0?ofkP3om^h02P3om^h0103D?AT0ooK^0?ofkP3om^h20=@m6@X0ooK^00<0e3dI0?ofkP3D?AT0
0P3om^h2000000H0ooK^00<0e3dI0?ofkP3om^h0B@3om^h00`000000ooK^0?ofkP0A0?ofkP40oooo
000o0?ofkP030000003om^h0ooK^01@0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?of
kP0;0?ofkP@0?EV[103om^h00`000000ooK^0?ofkP0B0?ofkP80?EV[2`3om^h203eIZ`80ooK^0`0m
FJ/00`3om^h0?EV[0?ofkP030?ofkP0303eIZ`3om^h0ooK^0080000000H05@H20000000E1P800000
02@:1@00000302@:1@030=@m6@000000=Pl80080=Pl800H0000003H?200f3`P0=Pl80000000mFJ/6
05LH30060000001G60`0EaP<0000001h8Q000000101h8Q0203eIZ`030000003D?AT0AV:l00H0AV:l
00<0000004IR_016H[`00`16H[`02@3D?AT0AV:l04IR_016H[`0000004IR_0000000e3dI00000005
04=N/P0300000013G[80@ejb00D0@ejb00<0e3dI04=N/P0000001`13G[80103D?AT0@ejb04=N/P00
000404=N/P@0000000D0?eRV0000000oF:H0?eRV0=@m6@0603mHYP040000000oF:H0?eRV0=@m6@H0
?eRV00@0000003mHYP0oF:H0?eRV0P00000303Y?U0@000000P0jCi@20=@m6@0303Y?U0000000>TnD
00H0>TnD0`0000050393N`030000000b@g/0<T=k00@0<T=k1000000202H`EP040000003om^h0?EV[
03eIZ`80ooK^1P0mFJ/20=@m6@<0?EV[2`3om^h00`3D?AT0ooK^0=@m6@0<0?ofkP80e3dI0P3om^h0
0`000000ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^04X0ooK^00<000000?ofkP3om^h04@3om^h1
0?ooo`00?P3om^h00`000000ooK^0?ofkP0E0?ofkP0303eIZ`3om^h0ooK^0180ooK^00<0?EV[0?of
kP3om^h03P3om^h403eIZ`030?ofkP000000ooK^01@0ooK^00<0?EV[0?ofkP3om^h0303om^h303eI
Z`80ooK^0`0mFJ/30?ofkP0403eIZ`3om^h0ooK^000000805@H20P0000000`0T2PD0000002@:1@03
02@:1@030000000f3`P0=Pl80080=Pl800H0000003H?200f3`P0000005LH300mFJ/605LH30030000
001G60`0000000<0N28@00<0000007PR401h8Q000`1h8Q000`0mFJ/0AV:l04IR_00604IR_0030000
0016H[`0AV:l00@0AV:l00H0e3dI04IR_016H[`0000004IR_03D?AT204IR_0@0000000<0@ejb0000
0013G[801P13G[800`3D?AT0@ejb0000000604=N/P050=@m6@13G[80@ejb04=N/P0000002013G[83
00000080?eRV00<0e3dI03mHYP0oF:H00`0oF:H00`000000?eRV0=@m6@0703mHYP030000000oF:H0
?eRV00<0?eRV0P0000000`0jCi@0000003Y?U00203Y?U08000000P0jCi@00`3D?AT0000003Y?U007
03Y?U0030000000jCi@00000008000000`0b@g/00`000000<T=k0393N`030393N`040000000b@g/0
<T=k0393N`@0000000<0ooK^03eIZ`0mFJ/00P0mFJ/01P3om^h0?EV[03eIZ`0mFJ/0ooK^0=@m6@80
ooK^100mFJ/90?ofkP80e3dI3@3om^h0103D?AT0ooK^0?ofkP0000070?ofkP80e3dIC03om^h00`00
0000ooK^0?ofkP0A0?ofkP40oooo000m0?ofkP030000003om^h0ooK^01D0ooK^00<0?EV[0?ofkP3o
m^h04`3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0703eIZ`3om^h0ooK^0?ofkP0mFJ/0000003eIZ`0C
0?ofkP80?EV[4@3om^h403eIZ`060?ofkP0mFJ/0?EV[0?ofkP0mFJ/0ooK^0P00000201D60P040=@m
6@00000090X5000000<090X50P00000403H?20030000000f3`P000000080EaP<00<0?EV[0000001G
60`0101G60`00`000000EaP<0000000307PR40030000001h8Q00N28@00@0N28@00<0000004IR_016
H[`01@16H[`00`000000AV:l04IR_00404IR_0060=@m6@16H[`0AV:l00000016H[`0e3dI1P16H[`3
000000L0@ejb00<0e3dI00000013G[801013G[800`3D?AT0@ejb04=N/P0204=N/P0300000013G[80
@ejb00L0@ejb00H0000004=N/P000000000003mHYP3D?AT403mHYP030000003D?AT0?eRV00L0?eRV
00<0000003mHYP0oF:H01@0oF:H3000000@0>TnD0`0000000`3D?AT0>TnD03Y?U00603Y?U0030000
000jCi@0>TnD0080>TnD100000060393N`030000000b@g/0<T=k00<0<T=k0P0000040?ofkP<0?EV[
00@0ooK^0=@m6@3D?AT0?EV[103om^h303eIZ`L0ooK^00<0e3dI0?ofkP3om^h02`3om^h20=@m6@03
0?ofkP000000ooK^00H0ooK^0P3D?AU>0?ofkP030000003om^h0ooK^0100ooK^0@3oool003d0ooK^
00<000000?ofkP3om^h05@3om^h203eIZa@0ooK^00<0?EV[0?ofkP3om^h03P3om^h01`0mFJ/0ooK^
0?ofkP3om^h0000003eIZ`3om^h00`0mFJ/@0?ofkP80?EV[4`3om^h403eIZ`030?ofkP0mFJ/0?EV[
008000000P0E1P820000008090X500H0000002@:1@0T2PD0000003H?2000000403H?208000000P1G
60`00`0mFJ/0EaP<0000000505LH30800000101h8Q000`000000N28@07PR400407PR400300000016
H[`0AV:l00H0AV:l00<0000004IR_016H[`01016H[`0103D?AT0AV:l0000003D?AT804IR_0040000
0016H[`00000000000H0@ejb00<0e3dI04=N/P13G[800P13G[800`3D?AT0@ejb04=N/P0304=N/P03
00000013G[80@ejb00L0@ejb00@0000004=N/P13G[80@ejb0P0000001@3D?AT0?eRV03mHYP0oF:H0
e3dI00T0?eRV00<0000003mHYP0oF:H01P0oF:H010000000?eRV00000000000403Y?U0040=@m6@00
00000000000000H0>TnD00<0000003Y?U00jCi@01@0jCi@3000000@0<T=k00<000000393N`0b@g/0
1@0b@g/00`000000ooK^0?ofkP030?ofkP0503eIZ`3D?AT0?EV[0=@m6@3om^h00`0mFJ/40?ofkP<0
?EV[0`3om^h20=@m6@`0ooK^0P3D?AT00`3om^h000000?ofkP050?ofkP80e3dI00<0ooK^0=@m6@3o
m^h0C@3om^h00`000000ooK^0?ofkP0@0?ofkP40oooo000l0?ofkP030000003om^h0ooK^01H0ooK^
00<0?EV[0?ofkP0mFJ/00P0mFJ/A0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00H0?EV[0?ofkP3om^h0
ooK^0000000mFJ/50?ofkP80?EV[3P3om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP0403eIZ`3om^h0ooK^
0?ofkP<0?EV[0P00000201D60P070000000T2PD090X502@:1@00000090X50000000203H?20030000
000f3`P0=Pl80080=Pl80P00000205LH300303eIZ`1G60`0000000D0EaP<00<0000007PR401h8Q00
0`1h8Q000`000000N28@07PR400407PR400300000016H[`0AV:l00H0AV:l00<0000004IR_016H[`0
1016H[`00`3D?AT0AV:l0=@m6@0904IR_00400000016H[`0AV:l04IR_0<000000`13G[801@000000
e3dI04=N/P13G[80e3dI00D0@ejb00<0000004=N/P13G[802013G[800`000000@ejb04=N/P0404=N
/P040=@m6@000000e3dI000000P0?eRV00<0000003mHYP0oF:H01`0oF:H010000000?eRV03mHYP0o
F:H3000000050=@m6@0jCi@0>TnD0000000jCi@00P00000403Y?U0030000000jCi@0>TnD00H0>TnD
00@0000003Y?U000000000000`0b@g/00`000000<T=k0393N`040393N`030000003om^h0ooK^00<0
ooK^00H0e3dI0?ofkP0mFJ/0?EV[0=@m6@0mFJ/20?ofkP80?EV[103om^h303eIZ`030=@m6@3om^h0
e3dI00/0ooK^00@0e3dI0?ofkP3D?AT000001P3om^h0103D?AT0ooK^0?ofkP3D?AU?0?ofkP030000
003om^h0ooK^0100ooK^0@3oool003`0ooK^00<000000?ofkP3om^h05@3om^h00`0mFJ/0ooK^0?of
kP030?ofkP<0?EV[3@3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP80?EV[00@0ooK^0000003om^h0?EV[
1`3om^h303eIZ`X0ooK^0P0mFJ/D0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0000000mFJ/0
0P0mFJ/20000008090X500<0000002@:1@0000000`0f3`P00`000000=Pl803H?200203H?20070000
001G60`0EaP<05LH300mFJ/0EaP<0000000405LH308000001P1h8Q000`000000N28@07PR400307PR
408000001`16H[`00`000000AV:l04IR_00504IR_0030=@m6@000000AV:l00P0AV:l00<0000004IR
_016H[`01016H[`20000000504=N/P000000e3dI04=N/P3D?AT01P13G[800`000000@ejb04=N/P08
04=N/P0300000013G[80@ejb00D0@ejb00@0e3dI00000000000000001`0oF:H00`000000?eRV03mH
YP0703mHYP030000000oF:H0?eRV00<0?eRV00D0e3dI000000000000>TnD0000000303Y?U0<00000
0P0jCi@00`000000>TnD03Y?U00503Y?U0040000000jCi@0>TnD03Y?U08000000P0b@g/00`000000
<T=k0393N`040393N`050000000mFJ/0ooK^0?ofkP3D?AT00P3om^h0100mFJ/0ooK^0=@m6@3om^h3
03eIZ`040?ofkP0mFJ/0?EV[03eIZ`80ooK^00D0?EV[0=@m6@0mFJ/0?EV[0=@m6@0:0?ofkP040=@m
6@3om^h0ooK^0=@m6@H0ooK^00@0e3dI0?ofkP3om^h0e3dID03om^h00`000000ooK^0?ofkP0@0?of
kP40oooo000k0?ofkP030000003om^h0ooK^01H0ooK^00<0?EV[0?ofkP3om^h01P3om^h203eIZ`/0
ooK^00<0?EV[0?ofkP3om^h03P3om^h0100mFJ/0ooK^03eIZ`00000203eIZ`X0ooK^0`0mFJ/70?of
kP0303eIZ`3om^h0ooK^0180ooK^00<0?EV[0?ofkP3om^h00P3om^h01P0mFJ/00000000000000000
5@H200000080?EV[0P0T2PD2000000@0=Pl800@0000003H?200f3`P0=Pl80P00000305LH300303eI
Z`1G60`0000000<0EaP<00<0000007PR400000001P1h8Q000`000000N28@07PR400207PR40800000
00<0B6K40000000000001@16H[`00`000000AV:l04IR_00404IR_0040=@m6@16H[`0e3dI000000P0
AV:l00<0000004IR_016H[`01P16H[`3000000030=@m6@13G[80@ejb00D0@ejb00<0000004=N/P13
G[802013G[800`000000@ejb04=N/P0404=N/P050=@m6@13G[80e3dI00000013G[800P00000503mH
YP030000000oF:H0?eRV00L0?eRV00<0000003mHYP0oF:H00P0oF:H0103D?AT0?eRV03mHYP0oF:H3
000000@0>TnD00@0e3dI0000000000000000200jCi@00`000000>TnD03Y?U00203Y?U0<000001P0b
@g/010000000ooK^03eIZ`3D?AT40?ofkP0303eIZ`3D?AT0ooK^00<0ooK^0`0mFJ/0103om^h0?EV[
03eIZ`3D?AT203eIZ`030?ofkP3D?AT0?EV[00P0ooK^00D0e3dI0?ofkP00000000000=@m6@050?of
kP050=@m6@3om^h0ooK^0?ofkP3D?AT0D03om^h00`000000ooK^0?ofkP0@0?ofkP40oooo000j0?of
kP030000003om^h0ooK^01L0ooK^00<0?EV[0?ofkP3om^h0203om^h303eIZ`P0ooK^00<0?EV[0?of
kP3om^h03@3om^h0100mFJ/0ooK^0?ofkP0000020?ofkP<0?EV[2`3om^h203eIZ`D0ooK^00<0?EV[
0?ofkP3om^h04P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`0000005@H20080000000<090X5
0000000T2PD00`0mFJ/503H?20060000000f3`P0=Pl80000001G60`000000P1G60`0100mFJ/0EaP<
05LH3000000205LH30040000001h8Q00N28@000000H0N28@00L0000007PR401h8Q00N28@0000002C
:Q<0000000<0B6K40P00000304IR_00300000016H[`0AV:l00<0AV:l00D0e3dI04IR_016H[`0e3dI
0000000804IR_00300000016H[`0AV:l00L0AV:l00D000000=@m6@000000e3dI0000000504=N/P03
00000013G[80@ejb00L0@ejb00<0000004=N/P13G[801013G[80103D?AT0@ejb04=N/P13G[820=@m
6@80@ejb0P00000303mHYP030000000oF:H0?eRV00L0?eRV00D0000003mHYP0oF:H0?eRV0=@m6@05
03mHYP030000000oF:H00000008000000P0jCi@20=@m6@<000001P0jCi@00`000000>TnD03Y?U004
03Y?U0<000001@0b@g/20=@m6@070?ofkP0mFJ/0?EV[03eIZ`3om^h0?EV[0=@m6@060?ofkP<0?EV[
00<0e3dI0?ofkP0mFJ/00P0mFJ/00`3D?AT0?EV[03eIZ`0203eIZ`@0ooK^00D0e3dI0?ofkP000000
ooK^0=@m6@050?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT0DP3om^h00`000000ooK^0?ofkP0?0?of
kP40oooo000j0?ofkP030000003om^h0ooK^01L0ooK^00<0?EV[0?ofkP3om^h02`3om^h303eIZ`D0
ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^000000020?ofkP0403eIZ`3om^h0ooK^0?of
kP<0?EV[2P3om^h303eIZ`030?ofkP0mFJ/0?EV[01<0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0m
FJ/0e3dI01D60P020000000402@:1@00000090X502@:1@8000000`0mFJ/203H?20030000000f3`P0
000000<0EaP<00<0000005LH300mFJ/00`1G60`00`000000EaP<0000000307PR40030000001h8Q00
N28@00<0N28@00@0000007PR401h8Q0000000P2C:Q<00`000000B6K404QVa00304QVa080000000<0
AV:l00000016H[`00`16H[`00`3D?AT0AV:l04IR_00204IR_0030=@m6@16H[`0AV:l00H0AV:l00<0
000004IR_016H[`01`16H[`01@3D?AT0AV:l04IR_016H[`0e3dI00@0000000<0@ejb00000013G[80
2013G[800`000000@ejb04=N/P0304=N/P050=@m6@13G[80@ejb04=N/P0000000P13G[80103D?AT0
@ejb04=N/P13G[820000000303mHYP000000?eRV00P0?eRV00@0000003mHYP0oF:H0e3dI1P0oF:H0
0`000000?eRV03mHYP0203mHYP<0000000@0>TnD0=@m6@3D?AT0>TnD0`00000303Y?U0030000000j
Ci@0>TnD00D0>TnD00<0000003Y?U00000000P0000030393N`80?EV[0`3om^h303eIZ`030=@m6@3o
m^h0ooK^00<0?EV[00@0ooK^0=@m6@3D?AT0ooK^100mFJ/00`3D?AT0ooK^0?ofkP020?ofkP80?EV[
0P3D?AT01@3om^h000000?ofkP3om^h0e3dI00@0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0
ooK^0?ofkP1@0?ofkP030000003om^h0ooK^00l0ooK^0@3oool003T0ooK^00<000000?ofkP3om^h0
5`3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP<0?EV[00<0ooK^03eIZ`3om^h03P3om^h0100mFJ/0ooK^
0?ofkP0000020?ofkP0303eIZ`3om^h0ooK^00@0ooK^0`0mFJ/:0?ofkP<0?EV[4`3om^h00`0mFJ/0
ooK^0?ofkP020?ofkP0303eIZ`0000005@H2008000000P0T2PD01@00000090X50000000f3`P00000
00<0=Pl80`0mFJ/00`0f3`P0000005LH300205LH30030000001G60`0?EV[00<0EaP<0P00000407PR
40030000001h8Q00N28@00@0N28@00<0000007PR400000000`2C:Q<00`000000B6K404QVa00404QV
a0<000000P16H[`00`3D?AT0AV:l04IR_00304IR_0030000003D?AT0AV:l00H0AV:l00<0000004IR
_016H[`01P16H[`00`3D?AT0000004IR_00304IR_0040=@m6@16H[`0AV:l04IR_0<000002013G[80
0`000000@ejb04=N/P0204=N/P030=@m6@13G[80@ejb0080@ejb00D0000004=N/P13G[80@ejb0=@m
6@0404=N/P<00000200oF:H00`000000?eRV0=@m6@0703mHYP030000000oF:H0?eRV00D0?eRV0`00
00020=@m6@80>TnD0P0000000`0jCi@0000003Y?U00603Y?U0030000000jCi@0>TnD0080>TnD1000
00000`3om^h0?EV[03eIZ`030?ofkP0403eIZ`3D?AT0?EV[03eIZ`<0ooK^00<0e3dI0?ofkP3om^h0
103om^h203eIZ`030=@m6@0mFJ/0ooK^0080ooK^00@0e3dI03eIZ`0mFJ/0?EV[0`3om^h01@3D?AT0
ooK^0?ofkP3om^h0e3dI00@0ooK^00<0e3dI0?ofkP3om^h0D@3om^h00`000000ooK^0?ofkP0?0?of
kP40oooo000i0?ofkP030000003om^h0ooK^01L0ooK^00<0?EV[0?ofkP3om^h04P3om^h303eIZ`h0
ooK^00<0?EV[0?ofkP0000000`3om^h00`0mFJ/0ooK^0?ofkP070?ofkP<0?EV[203om^h00`0mFJ/0
ooK^03eIZ`0203eIZa00ooK^00T0?EV[0?ofkP3om^h0ooK^0000000mFJ/0000001D60P0000000`0T
2PD200000080=Pl800<0000003H?200f3`P00`0f3`P00`000000?EV[03eIZ`0305LH30030000001G
60`0?EV[00<0EaP<00<0000007PR401h8Q000`1h8Q000`000000N28@07PR400407PR40800000102C
:Q<00`000000B6K404QVa00504QVa00500000018I/@000000=@m6@0000001@16H[`00`000000AV:l
0=@m6@0604IR_00300000016H[`0AV:l00D0AV:l00<0e3dI04IR_00000001@16H[`01P3D?AT0AV:l
04IR_016H[`0000004IR_08000001P13G[801@000000@ejb04=N/P13G[80e3dI00D0@ejb00<00000
04=N/P13G[800P13G[800`3D?AT0@ejb04=N/P0204=N/P0300000013G[800000008000001@0oF:H0
0`000000e3dI03mHYP0703mHYP030000000oF:H0?eRV00H0?eRV00@0?EV[03mHYP00000000000P3D
?AT203Y?U0<000001`0jCi@00`000000>TnD03Y?U00403Y?U08000000P3om^h203eIZ`030?ofkP0m
FJ/0e3dI0080ooK^0P0mFJ/00`3D?AT0ooK^0?ofkP060?ofkP0303eIZ`3D?AT0?EV[0080?EV[00@0
e3dI0?ofkP3om^h00000100mFJ/0103D?AT0ooK^0=@m6@3D?AT40?ofkP030=@m6@3om^h0ooK^0580
ooK^00<000000?ofkP3om^h03`3om^h10?ooo`00>03om^h2000001T0ooK^00<0?EV[0?ofkP3om^h0
4`3om^h00`0mFJ/0ooK^03eIZ`0203eIZ`/0ooK^00<0?EV[0000003om^h00`3om^h00`0mFJ/0ooK^
0?ofkP0:0?ofkP<0?EV[103om^h203eIZ`@0ooK^0`0mFJ/<0?ofkP0403eIZ`3om^h0ooK^0?ofkP80
000000@0?EV[01D60P00000000000P0T2PD00`00000090X50000000203H?20030000000f3`P0=Pl8
00<0=Pl800<0000005LH301G60`00`0mFJ/00`000000?EV[05LH300205LH308000001@1h8Q000`00
0000N28@07PR400407PR40030000002C:Q<0TbXC00<0TbXC00<0000004QVa018I/@01@18I/@00`00
0000B6K40=@m6@0204QVa0@0000000@0AV:l00000016H[`0e3dI1P16H[`00`000000AV:l04IR_004
04IR_0040=@m6@16H[`0AV:l000000H0AV:l00@0e3dI03eIZ`16H[`000000`16H[`3000000<0@ejb
00@0000004=N/P13G[80e3dI1P13G[800`000000@ejb04=N/P0304=N/P80e3dI0P13G[800`000000
@ejb04=N/P0204=N/P@0000000<0?eRV0=@m6@0oF:H0200oF:H00`000000?eRV03mHYP0603mHYP04
0000000oF:H0?eRV03mHYP8000000P3D?AT203Y?U0@00000100jCi@00`000000>TnD03Y?U00503Y?
U0040000003om^h0ooK^0?ofkP<0?EV[00D0e3dI0?ofkP3om^h0ooK^0=@m6@0303eIZ`L0ooK^00@0
e3dI0?ofkP3om^h0e3dI0`0mFJ/30?ofkP0403eIZ`3D?AT0?EV[0=@m6@@0ooK^0P3D?AUF0?ofkP03
0000003om^h0ooK^00h0ooK^0@3oool003P0ooK^00<000000?ofkP0000000P00000F0?ofkP0303eI
Z`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h00P3om^h303eIZ`L0ooK^00<0?EV[0000003om^h0
0`3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP<0?EV[00<0ooK^03eIZ`3om^h01`3om^h403eIZ`P0ooK^
00<0?EV[0?ofkP3om^h00P0000001@0mFJ/000000000000T2PD00000008090X50P00000303H?2003
0000000f3`P0=Pl80080=Pl80P0000000`3D?AT0EaP<05LH300205LH30<0?EV[00@0EaP<0000001h
8Q0000001@1h8Q000`000000N28@07PR400307PR408000001@2C:Q<00`000000B6K404QVa00504QV
a00300000018I/@0e3dI00H0B6K40`0000000`16H[`0e3dI04IR_00404IR_00300000016H[`0AV:l
00<0AV:l00D0e3dI04IR_016H[`0AV:l0000000704IR_0030=@m6@16H[`0000000H0AV:l0P000000
1013G[80000004=N/P3D?AT704=N/P0300000013G[80@ejb00D0@ejb00<0e3dI04=N/P0000002013
G[800`3D?AT000000000000803mHYP030000000oF:H0?eRV00H0?eRV00<0000003mHYP0oF:H00P0o
F:H00`3D?AT0?eRV000000020=@m6@040000000jCi@0>TnD03Y?U08000000P0jCi@00`000000>TnD
03Y?U00503Y?U0040000003om^h0?EV[03eIZ`<0ooK^00@0?EV[0=@m6@0mFJ/0e3dI103om^h203eI
Z`D0ooK^00<0e3dI0?ofkP3D?AT00P3om^h403eIZ`80ooK^0P3D?AT0103om^h0?EV[03eIZ`0mFJ/2
0=@m6EL0ooK^00<000000?ofkP3om^h03P3om^h10?ooo`00>03om^h00`000000ooK^0?ofkP020?of
kP<000004P3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^00H0ooK^0P0mFJ/50?of
kP0303eIZ`000000ooK^00<0ooK^00<0?EV[0?ofkP3om^h04@3om^h303eIZ`/0ooK^0`0mFJ/50?of
kP0903eIZ`3om^h0ooK^0000000E1P80?EV[0000000T2PD0000000<090X500<0000003H?200f3`P0
0`0f3`P01P000000=Pl803H?20000000EaP<000000D0EaP<00<0000003eIZ`1G60`00`0mFJ/00`00
0000N28@07PR400307PR40030000001h8Q00N28@0080N28@00<0000009<Z4`0000001@2C:Q<00`00
0000e3dI04QVa00604QVa0030=@m6@18I/@0B6K400H0B6K400D0000004QVa000000000000=@m6@04
04IR_00300000016H[`0AV:l0080AV:l00<0e3dI04IR_016H[`00P16H[`00`000000AV:l04IR_006
04IR_0030=@m6@000000AV:l00L0AV:l0P0000000`3D?AT0@ejb04=N/P0604=N/P0300000013G[80
@ejb00H0@ejb00<0e3dI00000013G[801P13G[80103D?AT0@ejb03eIZ`13G[82000000H0?eRV00<0
000003mHYP0oF:H01P0oF:H01@000000?eRV03mHYP0oF:H0e3dI00@0?eRV00@000000=@m6@3D?AT0
e3dI0`0jCi@3000000P0>TnD00<000000?ofkP3om^h0103om^h20=@m6@<0?EV[103om^h303eIZ`80
ooK^0P3D?AT00`3om^h00000000000020?ofkP@0?EV[00<0e3dI03eIZ`0mFJ/00P0mFJ/0103D?AT0
?EV[03eIZ`0mFJ]F0?ofkP030000003om^h0ooK^00h0ooK^0@3oool003L0ooK^00<000000?ofkP3o
m^h01P3om^h3000000l0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP080?ofkP<0
?EV[00<0ooK^03eIZ`0000001@3om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP0303eIZ`3om^h0?EV[0080
?EV[2`3om^h303eIZ`040?ofkP0mFJ/0ooK^0?ofkP80000000D0?EV[00000000000090X500000002
02@:1@80000000<0e3dI03H?200f3`P00P0f3`P00`000000=Pl80000000205LH30030000001G60`0
EaP<00<0EaP<00@0?EV[0000001G60`000000P1h8Q0303eIZ`@0N28@00@0000007PR401h8Q000000
0`2C:Q<00`000000TbXC09<Z4`0209<Z4`0303eIZ`18I/@0e3dI00D0B6K400<0e3dI00000018I/@0
1`18I/@01@000000B6K404QVa018I/@0e3dI00<0000000<0AV:l00000016H[`00P16H[`00`3D?AT0
AV:l04IR_00304IR_00300000016H[`0AV:l00L0AV:l00<0e3dI04IR_016H[`01`16H[`0103D?AT0
AV:l00000000000504=N/P0300000013G[80@ejb00P0@ejb00<0e3dI04=N/P13G[801013G[80103D
?AT0@ejb04=N/P00000304=N/P<000000`0oF:H00`000000?eRV03mHYP0603mHYP040000000oF:H0
?eRV0=@m6@H0?eRV00<0000003mHYP0000000`3D?AT303Y?U0<000001@0jCi@00`000000ooK^0?of
kP040?ofkP030=@m6@3om^h0ooK^0080ooK^0`0mFJ/40?ofkP80?EV[00@0e3dI03eIZ`000000ooK^
100mFJ/20?ofkP040=@m6@0mFJ/0ooK^03eIZ`80e3dI0`3om^h303eIZe@0ooK^00<000000?ofkP3o
m^h03P3om^h10?ooo`00=`3om^h00`000000ooK^0?ofkP090?ofkP<00000303om^h00`0mFJ/0ooK^
0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0000000mFJ/01@3om^h00`0mFJ/0ooK^
0?ofkP0A0?ofkP0303eIZ`3om^h0ooK^00<0ooK^0`0mFJ/;0?ofkP80?EV[00H0ooK^000000000000
5@H203eIZ`00000202@:1@050000000T2PD0000003H?200000001@0f3`P00`000000=Pl800000002
05LH30030000001G60`0EaP<00<0EaP<00<0?EV[000000000000101h8Q000`000000N28@03eIZ`02
03eIZ`0407PR40000000N28@000000@0TbXC00<0000009<Z4`2C:Q<00P2C:Q<00`0mFJ/0B6K40=@m
6@0404QVa0030=@m6@18I/@0000000P0B6K400<0000004QVa018I/@00P18I/@00`3D?AT0B6K404QV
a0030000000304IR_03D?AT0AV:l00D0AV:l00<0000004IR_016H[`01`16H[`00`000000e3dI04IR
_00604IR_0030=@m6@000000AV:l0080AV:l0P00000304=N/P0300000013G[80@ejb00L0@ejb00@0
000004=N/P3D?AT0e3dI0`13G[80103D?AT0@ejb04=N/P00000704=N/P80000000<0?eRV0000000o
F:H01`0oF:H00`000000?eRV0=@m6@0703mHYP030000000oF:H0?eRV0080?eRV00D000000=@m6@3D
?AT0>TnD0000000203Y?U08000000`0jCi@00`000000?EV[0?ofkP030?ofkP80e3dI00<0?EV[0?of
kP3om^h0103om^h203eIZ`<0ooK^0P3D?AT303eIZ`D0ooK^0P3D?AT0103om^h0e3dI0=@m6@3D?AT7
0?ofkP<0?EV[D@3om^h00`000000ooK^0?ofkP0>0?ofkP40oooo000g0?ofkP030000003om^h0ooK^
00`0ooK^0`0000090?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0m
FJ/000000?ofkP0303eIZ`030?ofkP0mFJ/0ooK^01<0ooK^00<0?EV[0?ofkP3om^h01P3om^h303eI
Z`T0ooK^00H0?EV[000000000000000001D60P0mFJ/302@:1@8000000P0f3`P00`000000=Pl803H?
200303H?208000000`1G60`00`000000EaP<05LH300305LH300303eIZ`000000N28@00@0N28@00<0
000007PR401h8Q000P1h8Q0403eIZ`@0TbXC00H0000009<Z4`2C:Q<0TbXC03eIZ`00000204QVa004
0=@m6@18I/@0B6K40=@m6@80B6K400<0000004QVa018I/@01P18I/@00`000000B6K404QVa00304QV
a0070=@m6@18I/@0B6K400000018I/@0e3dI0000000604IR_00300000016H[`0AV:l00H0AV:l00@0
000004IR_016H[`0e3dI1@16H[`00`3D?AT0000004IR_00504IR_080000000<0@ejb03eIZ`13G[80
2013G[801`000000@ejb04=N/P13G[80e3dI04=N/P3D?AT00`13G[800`000000@ejb04=N/P0704=N
/P<000001`0oF:H00`000000e3dI03mHYP0703mHYP030000000oF:H0?eRV00D0?eRV0`3D?AT303Y?
U0@0000000P0ooK^03eIZ`0mFJ/0?EV[0=@m6@3om^h0e3dI03eIZ`P0ooK^0P0mFJ/20=@m6@0303eI
Z`3om^h0?EV[00@0ooK^1`3D?AT303eIZ`P0ooK^0P0mFJ]@0?ofkP030000003om^h0ooK^00d0ooK^
0@3oool003L0ooK^00<000000?ofkP3om^h03`3om^h4000000@0ooK^00<0?EV[0?ofkP3om^h04`3o
m^h00`0mFJ/0ooK^0?ofkP0<0?ofkP030000003om^h0ooK^00<0ooK^0`0mFJ/B0?ofkP80?EV[2`3o
m^h203eIZ`H0ooK^00L0?EV[0000000000005@H20000000mFJ/00000008090X500<0000002@:1@00
00000P0f3`P00`000000=Pl803H?200303H?20030000001G60`0EaP<00<0EaP<00D0000005LH301G
60`0EaP<03eIZ`02000000D0N28@00<0000007PR401h8Q000`1h8Q000`000000TbXC09<Z4`0303eI
Z`0309<Z4`000000TbXC0080TbXC00L0?EV[09<Z4`000000B6K40=@m6@18I/@0e3dI00<0B6K400<0
000004QVa018I/@01P18I/@00`000000B6K404QVa00404QVa0040=@m6@18I/@000000=@m6@80B6K4
0`00000304IR_00300000016H[`0AV:l00H0AV:l00D0000004IR_016H[`0AV:l0=@m6@0304IR_003
0=@m6@16H[`0000000P0AV:l0`00000804=N/P0300000013G[80@ejb0080@ejb00<0e3dI04=N/P13
G[800P13G[800`000000@ejb04=N/P0804=N/P0300000013G[80000000800000100oF:H00`3D?AT0
?eRV03mHYP0703mHYP030000000oF:H0?eRV00H0?eRV00<0000003mHYP3D?AT00`3D?AT203Y?U080
00000P3om^h01@3D?AT0?EV[03eIZ`3D?AT0?EV[00P0ooK^0P3D?AT01P0mFJ/0e3dI03eIZ`0mFJ/0
ooK^03eIZ`80ooK^103D?AT00`3om^h0e3dI0=@m6@030?ofkP@0?EV[1`3om^h00`0mFJ/0ooK^0?of
kP1=0?ofkP030000003om^h0ooK^00d0ooK^0@3oool003L0ooK^00<000000?ofkP3om^h04`3om^h3
000000030?ofkP0mFJ/0?EV[01@0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`000000?EV[0?ofkP05
0?ofkP0303eIZ`3om^h0?EV[0080?EV[3`3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP<0?EV[0`3om^h0
1`0mFJ/0000001D60P0000005@H203eIZ`0000000P0T2PD2000000<0=Pl800<0000003H?200f3`P0
0P0f3`P2000000D0EaP<00L0000005LH301G60`0EaP<03eIZ`1h8Q00000000D0N28@00<0000007PR
401h8Q000P1h8Q02000000D0TbXC0`0mFJ/01@2C:Q<0?EV[09<Z4`2C:Q<000000080B6K400<0e3dI
04QVa018I/@00P18I/@00`000000B6K404QVa00604QVa00300000018I/@0B6K400@0B6K400<0e3dI
04QVa03D?AT01P18I/@20000000304IR_0000000AV:l00L0AV:l00<0000004IR_016H[`00P16H[`0
0`3D?AT0AV:l0=@m6@0204IR_00300000016H[`0AV:l00L0AV:l00<0000004IR_00000000P000005
04=N/P0600000013G[80@ejb04=N/P3D?AT0@ejb0P3D?AT204=N/P0300000013G[80@ejb00P0@ejb
00<0000004=N/P13G[800P13G[8200000080e3dI00<0000003mHYP0oF:H01P0oF:H00`000000?eRV
03mHYP0703mHYP040000000oF:H0e3dI03mHYP800000103D?AT300000080ooK^00<0e3dI03eIZ`0m
FJ/01P3om^h01@3D?AT0?EV[03eIZ`000000e3dI0080ooK^0P0mFJ/30=@m6@030?ofkP3D?AT0ooK^
0080e3dI103om^h0100mFJ/0ooK^0?ofkP3om^h303eIZ`D0ooK^00<0?EV[0?ofkP3om^h0C03om^h0
0`000000ooK^0?ofkP0=0?ofkP40oooo000f0?ofkP030000003om^h0ooK^01L0ooK^00<0000003eI
Z`000000100mFJ/@0?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0000003eIZ`3om^h01P3om^h00`0m
FJ/0ooK^0?ofkP020?ofkP<0?EV[303om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP<0?EV[0P0000001@0E
1P8000000000000mFJ/00000008090X500<0000003H?200f3`P00`0f3`P01P000000=Pl803H?2000
0000EaP<000000D0EaP<00D0000005LH301G60`0000003eIZ`0207PR40030000001h8Q00N28@0080
N28@00D0000007PR401h8Q00N28@0000000209<Z4`030000002C:Q<0TbXC00@0TbXC00X0000003eI
Z`0mFJ/0?EV[09<Z4`000000B6K40=@m6@18I/@0e3dI0`18I/@00`000000B6K404QVa00604QVa003
00000018I/@0B6K400D0B6K400<0e3dI00000018I/@01`18I/@3000000L0AV:l00<0000004IR_016
H[`00`16H[`01@3D?AT0AV:l04IR_016H[`0000000T0AV:l00<0000004IR_016H[`00P16H[`40000
000504=N/P000000@ejb04=N/P3D?AT01013G[820=@m6@0300000013G[80@ejb00L0@ejb00<00000
04=N/P13G[801013G[800`3D?AT0@ejb00000002000000L0?eRV00<0000003mHYP0oF:H01`0oF:H0
0`000000e3dI03mHYP0303mHYP80000000<0>TnD0000003D?AT00P3D?AT30000000303eIZ`3om^h0
?EV[0080?EV[0P3om^h00`3D?AT0?EV[0=@m6@080=@m6@80?EV[00@0ooK^0=@m6@3D?AT0e3dI1P3o
m^h00`0mFJ/0ooK^0?ofkP030?ofkP80?EV[103om^h00`0mFJ/0ooK^0?ofkP1;0?ofkP030000003o
m^h0ooK^00d0ooK^0@3oool003H0ooK^00<000000?ofkP3om^h0603om^h00`0mFJ/0ooK^00000002
000000040?ofkP0mFJ/0?EV[03eIZ`d0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`000000?EV[0?of
kP050?ofkP0303eIZ`3om^h0ooK^00H0ooK^100mFJ/70?ofkP80?EV[4`3om^h02@000000?EV[03eI
Z`0mFJ/0000003eIZ`0T2PD0000002@:1@02000000D0=Pl800<0000003H?200000000P1G60`00`00
0000EaP<05LH300305LH30040000001G60`0000003eIZ`<0N28@00<0000007PR401h8Q000`1h8Q00
0`000000N28@0000000309<Z4`030000002C:Q<0TbXC00@0TbXC00@0000009<Z4`0mFJ/0TbXC0P0m
FJ/0103D?AT0B6K404QVa03D?AT404QVa00300000018I/@0B6K400H0B6K400<0000004QVa018I/@0
0`18I/@00`3D?AT0B6K40=@m6@0904QVa00300000018I/@00000008000001016H[`00`000000AV:l
04IR_00204IR_0060=@m6@16H[`0e3dI0=@m6@16H[`000002016H[`00`000000AV:l04IR_00704IR
_0<0000000<0e3dI04=N/P13G[801@13G[820=@m6@P0@ejb00<0000004=N/P13G[800`13G[801P3D
?AT0@ejb04=N/P13G[80?EV[04=N/P8000001@0oF:H00`000000?eRV03mHYP0703mHYP030=@m6@0o
F:H0?eRV00D0?eRV00<000000=@m6@0mFJ/0103om^h00`3D?AT00000000000070=@m6@030000003o
m^h0e3dI0080ooK^00<0e3dI0?ofkP3D?AT00`3om^h20=@m6@0303eIZ`3om^h0ooK^00D0ooK^00<0
?EV[0?ofkP3om^h01@3om^h303eIZ`80ooK^00<0?EV[0?ofkP3om^h0B`3om^h00`000000ooK^0?of
kP0<0?ofkP40oooo000f0?ofkP030000003om^h0ooK^01P0ooK^00<0?EV[0?ofkP3om^h00P3om^h3
000000030?ofkP0mFJ/0?EV[0080?EV[2@3om^h00`0mFJ/0ooK^0?ofkP090?ofkP030000000mFJ/0
ooK^00H0ooK^00<0?EV[0?ofkP3om^h02P3om^h303eIZ`@0ooK^0P0mFJ/B0?ofkP<0000000<05@H2
0000000mFJ/00P0mFJ/202@:1@8000001@0f3`P00`000000=Pl80000000205LH30030000001G60`0
EaP<00<0EaP<0P0000000`1h8Q00?EV[07PR400207PR40030000001h8Q00N28@00<0N28@00<00000
07PR400000000`2C:Q<00`000000TbXC09<Z4`0409<Z4`040000000mFJ/0TbXC09<Z4`80000000D0
BFW;00000000000000000=@m6@0304QVa00300000018I/@0B6K400H0B6K400<0000004QVa018I/@0
0P18I/@01@3D?AT0B6K404QVa0000000e3dI00P0B6K400<0000004QVa018I/@00P18I/@300000003
04IR_0000000AV:l0080AV:l00<0e3dI04IR_016H[`00P16H[`00`3D?AT0000004IR_00704IR_003
00000016H[`0AV:l00P0AV:l00<000000=@m6@0000000P00000404=N/P0300000013G[80@ejb0080
e3dI1P13G[800`000000@ejb04=N/P0204=N/P030=@m6@13G[80@ejb0080@ejb00@0000004=N/P13
G[80@ejb0P00000303mHYP030000000oF:H0?eRV00H0?eRV00<0e3dI0000000oF:H01`0oF:H01000
0000ooK^03eIZ`0mFJ/20?ofkP030=@m6@3om^h0e3dI00<0000000<0e3dI0?ofkP0000000`3om^h0
1`3D?AT0ooK^0=@m6@3om^h0e3dI0?ofkP0mFJ/00P3om^h00`3D?AT0ooK^0?ofkP0203eIZ`H0ooK^
00<0?EV[0?ofkP3om^h01`3om^h403eIZd`0ooK^00<000000?ofkP3om^h0303om^h10?ooo`00=P3o
m^h00`000000ooK^0?ofkP0G0?ofkP0303eIZ`3om^h0ooK^00H0ooK^0`0000020?ofkP<0?EV[1@3o
m^h00`0mFJ/0ooK^0?ofkP090?ofkP040000003om^h0?EV[03eIZ`H0ooK^00<0?EV[0?ofkP3om^h0
3@3om^h503eIZa80ooK^0`00000201D60P040000000T2PD0?EV[000000<0?EV[00<0000003H?200f
3`P00`0f3`P2000000<0EaP<00<0000005LH301G60`00`1G60`00`000000N28@03eIZ`0407PR4003
0000001h8Q00N28@00<0N28@0P00000409<Z4`030000002C:Q<0TbXC00@0TbXC00@0000003eIZ`2C
:Q<0TbXC0P00000404UYb`050000003D?AT0000004QVa00000002018I/@01@000000B6K404QVa018
I/@0e3dI00<0B6K400<0000004QVa03D?AT01`18I/@00`000000B6K404QVa00504QVa0<0000000<0
AV:l0=@m6@16H[`01016H[`00`000000e3dI04IR_00704IR_00300000016H[`0AV:l00L0AV:l00<0
00000=@m6@16H[`00`16H[`30000000304=N/P000000@ejb00<0@ejb0P3D?AT404=N/P0500000013
G[80@ejb04=N/P3D?AT01013G[800`000000@ejb04=N/P0404=N/P80000000<0?eRV0000000oF:H0
1P0oF:H00`3D?AT0?eRV0000000803mHYP040000003om^h0ooK^0?ofkP80?EV[0P3D?AT0100mFJ/0
ooK^0?ofkP3D?AT3000000<0ooK^103D?AT20?ofkP0303eIZ`3D?AT0e3dI00D0ooK^0P0mFJ/40?of
kP0303eIZ`3om^h0ooK^00X0ooK^0P0mFJ];0?ofkP030000003om^h0ooK^00`0ooK^0@3oool003H0
ooK^00<000000?ofkP3om^h05`3om^h00`0mFJ/0ooK^0?ofkP090?ofkP<000000P3om^h403eIZ`03
0?ofkP0mFJ/0ooK^00T0ooK^00D000000?ofkP3om^h0?EV[0?ofkP0303eIZ`<0ooK^00<0?EV[0?of
kP3om^h0403om^h303eIZa40ooK^0`0000001@0E1P8000000000000mFJ/090X5008000000P0f3`P2
03eIZ`@0=Pl800<0000005LH301G60`00`1G60`010000000EaP<05LH301G60`20000000307PR400m
FJ/0N28@00@0N28@00<0000007PR401h8Q000P1h8Q000`000000TbXC09<Z4`0409<Z4`030000002C
:Q<0TbXC00<0TbXC00@0000003eIZ`2C:Q<000000P2Y<AH00`000000BFW;04UYb`0204UYb`030=@m
6@19JL/00000008000001`18I/@01@000000B6K404QVa018I/@0e3dI00<0B6K400@0000004QVa018
I/@0e3dI1P18I/@00`000000B6K404QVa00604QVa00300000018I/@0e3dI008000001016H[`01000
0000AV:l0=@m6@3D?AT604IR_00300000016H[`0AV:l00L0AV:l00<0e3dI04IR_016H[`01P16H[`3
000000D0@ejb0P3D?AT204=N/P0400000013G[80@ejb0=@m6@D0@ejb00<0000004=N/P13G[801P13
G[83000000D0?eRV00@0e3dI03mHYP0oF:H00000200oF:H00`000000ooK^0?ofkP030?ofkP030=@m
6@0mFJ/0?EV[0080e3dI00@0ooK^0000003om^h0ooK^0P0000000`3om^h0e3dI0=@m6@040?ofkP80
e3dI203om^h303eIZ`80ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP180?ofkP03
0000003om^h0ooK^00`0ooK^0@3oool003H0ooK^00<000000?ofkP3om^h05`3om^h00`0mFJ/0ooK^
0?ofkP0<0?ofkP<000000`3om^h303eIZ`T0ooK^00<000000?ofkP0mFJ/01@3om^h303eIZa80ooK^
00@0?EV[0?ofkP0mFJ/0ooK^0`0mFJ/=0?ofkP<0000000H05@H20000000T2PD0000003eIZ`0T2PD2
00000080=Pl800<0000003H?200mFJ/00P0mFJ/2000000030=@m6@1G60`0EaP<0080EaP<00@00000
05LH301G60`000000P1h8Q000`000000?EV[07PR400407PR40040000001h8Q00N28@07PR40800000
1P2C:Q<00`000000TbXC09<Z4`0309<Z4`0303eIZ`000000000000<0ZC4F00<0000004UYb`19JL/0
0`19JL/0103D?AT0BFW;00000019JL/3000000@0B6K400@0000004QVa018I/@0e3dI1018I/@01@00
0000B6K404QVa018I/@0e3dI00D0B6K400<0000004QVa018I/@01P18I/@00`000000e3dI04QVa002
04QVa0<0000000<0AV:l00000016H[`00P16H[`00`3D?AT0AV:l04IR_00304IR_00300000016H[`0
AV:l00D0AV:l0P3D?AT00`000000AV:l04IR_00704IR_00400000016H[`00000000000D0@ejb0P3D
?AT00`000000@ejb0=@m6@0604=N/P0300000013G[80@ejb00L0@ejb00<0000004=N/P0000000P00
00020=@m6@<0?eRV00<0000003mHYP0oF:H01P0oF:H00`000000ooK^0?ofkP020?ofkP80e3dI00<0
ooK^0=@m6@0mFJ/00P0mFJ/50?ofkP<000000`3om^h20=@m6@`0ooK^0`0mFJ/=0?ofkP0303eIZ`3o
m^h0ooK^04T0ooK^00<000000?ofkP3om^h02`3om^h10?ooo`00=@3om^h00`000000ooK^0?ofkP0H
0?ofkP0303eIZ`3om^h0ooK^00l0ooK^0`0000000`3om^h0?EV[0?ofkP0303eIZ`D0ooK^00@00000
0?ofkP3om^h0?EV[1`3om^h403eIZ`l0ooK^00<0?EV[0?ofkP0mFJ/0103om^h203eIZ`X0ooK^0P00
00001P0E1P8000000000000T2PD0000003eIZ`8090X500<0000003H?200f3`P00P0f3`P010000000
=Pl803H?2000000303eIZ`@0EaP<00<0000005LH300000000`1h8Q000`0mFJ/0N28@07PR400407PR
40040000001h8Q00N28@00000080TbXC00<0000009<Z4`2C:Q<00`2C:Q<00`000000TbXC09<Z4`03
09<Z4`0303eIZ`000000000000<0ZC4F00<0000004UYb`19JL/01019JL/00`3D?AT0000004UYb`03
04UYb`<0000000@0B6K400000018I/@0e3dI1@18I/@00`000000B6K404QVa00204QVa0030=@m6@18
I/@0B6K40080B6K400<0000004QVa018I/@01P18I/@00`3D?AT0B6K404QVa00504QVa0<000000`16
H[`00`3D?AT0AV:l04IR_00204IR_00300000016H[`0AV:l00@0AV:l00@0e3dI04IR_016H[`00000
2016H[`00`000000AV:l04IR_00204IR_0<000000`13G[8010000000e3dI0=@m6@3D?AT604=N/P03
00000013G[80@ejb00L0@ejb00D0000004=N/P13G[80@ejb0=@m6@040000000303mHYP000000?eRV
00L0?eRV00H000000?ofkP3om^h0ooK^0=@m6@3om^h20=@m6@0403eIZ`3om^h000000?ofkP<0?EV[
00<0ooK^0=@m6@3D?AT00P3om^h3000000030=@m6@3om^h0?EV[00d0ooK^0`0mFJ/<0?ofkP0303eI
Z`3om^h0ooK^04P0ooK^00<000000?ofkP3om^h02`3om^h10?ooo`00=@3om^h00`000000ooK^0?of
kP0H0?ofkP0303eIZ`3om^h0ooK^0180ooK^00<0000003eIZ`0000000`3om^h303eIZ`050?ofkP00
0000ooK^0?ofkP0mFJ/0203om^h0100mFJ/0ooK^0?ofkP3om^h303eIZ``0ooK^0P0mFJ/70?ofkP<0
?EV[1P3om^h50000008090X500<0000003eIZ`0T2PD00P00000403H?20030000000f3`P0000000<0
EaP<00P0000003eIZ`0mFJ/0?EV[05LH30000000EaP<000000<0N28@00<0?EV[07PR401h8Q00101h
8Q0010000000N28@07PR4000000209<Z4`030000002C:Q<0TbXC00@0TbXC00<0000009<Z4`2C:Q<0
0P2C:Q<00`0mFJ/000000:Ta5P030:Ta5P0300000019JL/0BFW;00@0BFW;00<0e3dI00000019JL/0
1P19JL/2000000030=@m6@18I/@0B6K400@0B6K400<0000004QVa018I/@00P18I/@01@3D?AT0B6K4
04QVa018I/@0000000P0B6K400<0e3dI04QVa018I/@01`18I/@010000000B6K400000000000204IR
_080e3dI00<0AV:l00000016H[`01@16H[`0103D?AT0AV:l04IR_000000904IR_00300000016H[`0
AV:l00D0AV:l0P0000000`13G[8000000=@m6@0204=N/P80e3dI1013G[800`000000@ejb04=N/P06
04=N/P0500000013G[80@ejb04=N/P3D?AT01@13G[83000000L0?eRV00@000000?ofkP3om^h0e3dI
0P3om^h0103D?AT0ooK^03eIZ`0000040?ofkP<0e3dI103om^h20=@m6@80000000<0?EV[0?ofkP3o
m^h0303om^h00`0mFJ/0ooK^03eIZ`0203eIZ`T0ooK^00<0?EV[0?ofkP3om^h0B03om^h00`000000
ooK^0?ofkP0;0?ofkP40oooo000e0?ofkP030000003om^h0ooK^01P0ooK^00<0?EV[0?ofkP3om^h0
4P3om^h00`0mFJ/0ooK^0?ofkP03000000<0ooK^00D0?EV[0000003om^h0ooK^03eIZ`080?ofkP03
03eIZ`3om^h0ooK^00@0ooK^0`0mFJ/80?ofkP0303eIZ`3om^h0?EV[00X0ooK^0`0mFJ/20?ofkP80
000000<05@H20000000000000`0T2PD01@0mFJ/090X50000000f3`P0000000@0=Pl800<0000003H?
200000000`1G60`010000000EaP<05LH301G60`203eIZ`030000001h8Q00N28@0080N28@00<0?EV[
0000001h8Q001@1h8Q02000000<0TbXC00<0000009<Z4`2C:Q<0102C:Q<01@000000TbXC09<Z4`2C
:Q<0?EV[008000001@2Y<AH00`000000BFW;04UYb`0404UYb`030=@m6@000000BFW;00H0BFW;00@0
e3dI04UYb`00000000001018I/@00`000000B6K404QVa00304QVa0040=@m6@18I/@0B6K4000000P0
B6K400<0e3dI04QVa018I/@01`18I/@010000000B6K404QVa018I/@200000080AV:l00<0e3dI0000
0016H[`01016H[`01@3D?AT0AV:l04IR_016H[`0000000T0AV:l00<0000004IR_016H[`01`16H[`0
0`000000e3dI0000000404=N/P<0e3dI00<0@ejb00000013G[801`13G[8010000000@ejb04=N/P3D
?AT704=N/P0400000013G[800000000000D0?eRV00<000000=@m6@3D?AT00P3om^h20=@m6@030000
000mFJ/0ooK^00<0ooK^00@0e3dI0?ofkP3D?AT0e3dI0`0mFJ/00`3D?AT0ooK^0?ofkP020?ofkP<0
0000303om^h00`0mFJ/0ooK^0?ofkP020?ofkP<0?EV[1`3om^h00`0mFJ/0ooK^0?ofkP170?ofkP03
0000003om^h0ooK^00/0ooK^0@3oool003D0ooK^00<000000?ofkP3om^h05`3om^h00`0mFJ/0ooK^
0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^00<0ooK^10000000103om^h0?EV[03eIZ`0mFJ/80?ofkP03
03eIZ`3om^h0ooK^00L0ooK^0`0mFJ/50?ofkP0303eIZ`3om^h0?EV[00d0ooK^0P0mFJ/00`000000
5@H200000002000000<090X500D0?EV[0000000f3`P0=Pl80000000403H?20800000101G60`00`00
0000EaP<05LH300205LH30080000000mFJ/0?EV[03eIZ`1h8Q00?EV[07PR4000000607PR40030000
002C:Q<0TbXC00<0TbXC00<0000009<Z4`2C:Q<00`2C:Q<01@000000TbXC09<Z4`2C:Q<0?EV[0080
ZC4F00<000000:Ta5P2Y<AH00P2Y<AH00`000000BFW;04UYb`0504UYb`030=@m6@19JL/0BFW;00@0
BFW;00<0e3dI00000019JL/00P19JL/30000000304QVa0000000B6K400D0B6K400<0e3dI04QVa000
00001`18I/@00`3D?AT0000004QVa00804QVa00300000018I/@0B6K400<0B6K40P0000000`16H[`0
e3dI04IR_00304IR_0030=@m6@16H[`0AV:l0080AV:l00<0000004IR_016H[`01`16H[`00`000000
AV:l04IR_00704IR_0030=@m6@000000AV:l00<000001013G[830=@m6@L0@ejb00<0000004=N/P3D
?AT01`13G[800`000000@ejb04=N/P0204=N/P8000000`0oF:H0103D?AT0ooK^0?ofkP0mFJ/20=@m
6@030000003om^h0?EV[00<0ooK^103D?AT30?ofkP040=@m6@0mFJ/0?EV[03eIZ`80ooK^00<0?EV[
0?ofkP3om^h00P00000;0?ofkP0303eIZ`3om^h0ooK^00@0ooK^0P0mFJ/50?ofkP0303eIZ`3om^h0
ooK^04L0ooK^00<000000?ofkP3om^h02`3om^h10?ooo`00=@3om^h00`000000ooK^0?ofkP0G0?of
kP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h01@3om^h01P000000ooK^000000000000
?EV[0?ofkP<0?EV[103om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP<0?EV[00D0ooK^03eIZ`3om^h0ooK^
03eIZ`0>0?ofkP030000000E1P805@H200<000000P0T2PD00`0mFJ/090X50000000203H?20030000
000f3`P0=Pl80080=Pl800<0000005LH301G60`00`1G60`010000000EaP<05LH301G60`2000000<0
N28@0`0mFJ/00`000000N28@07PR400307PR408000001@2C:Q<00`000000TbXC09<Z4`0309<Z4`04
0000002C:Q<0TbXC03eIZ`<0ZC4F00<000000:Ta5P2Y<AH00P2Y<AH00`000000BFW;04UYb`0504UY
b`030=@m6@19JL/0BFW;00<0BFW;00<0e3dI04UYb`0000001P19JL/3000000H0B6K400<0e3dI0000
0018I/@01@18I/@00`3D?AT0B6K40000000804QVa00300000018I/@0B6K400H0B6K40P0000020=@m
6@0304IR_03D?AT0AV:l00@0AV:l00<0000004IR_016H[`01P16H[`00`000000AV:l04IR_00704IR
_0030=@m6@000000AV:l00@0AV:l0`0000001013G[80000004=N/P13G[820=@m6@D0@ejb00<00000
0=@m6@13G[801`13G[800`000000@ejb04=N/P0404=N/P80000000L0e3dI0000003om^h0ooK^0=@m
6@3om^h0e3dI0080ooK^00<0?EV[0?ofkP3om^h00P3D?AT20?ofkP040=@m6@3om^h0e3dI0=@m6@@0
ooK^0P0mFJ/00`3om^h0?EV[0?ofkP020?ofkP<00000203om^h00`0mFJ/0ooK^0?ofkP060?ofkP<0
?EV[0`3om^h00`0mFJ/0ooK^0?ofkP170?ofkP030000003om^h0ooK^00X0ooK^0@3oool003@0ooK^
00<000000?ofkP3om^h0603om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^00@0ooK^
00H000000?ofkP3om^h0ooK^03eIZ`3om^h3000000060?ofkP0mFJ/0?EV[03eIZ`3om^h0?EV[403o
m^h403eIZ`h0ooK^0P000000100E1P80000000000000000302@:1@0303eIZ`000000=Pl80080=Pl8
00@0000003H?200f3`P0=Pl80P00000505LH30070000001G60`0EaP<05LH30000000N28@00000003
07PR400303eIZ`1h8Q00?EV[0080?EV[0P1h8Q0010000000TbXC09<Z4`00000409<Z4`030000002C
:Q<0TbXC00@0TbXC0P0000001@0mFJ/0ZC4F0:Ta5P2Y<AH0000000@0ZC4F00<0000004UYb`19JL/0
1@19JL/00`000000e3dI04UYb`0304UYb`030=@m6@19JL/0000000L0BFW;00<0000004UYb`000000
0P00000404QVa0030=@m6@18I/@0B6K400<0B6K400@0e3dI04QVa018I/@000002018I/@00`000000
B6K404QVa00704QVa00500000018I/@000000=@m6@0000001016H[`00`000000AV:l04IR_00704IR
_00300000016H[`0AV:l00H0AV:l00<0e3dI04IR_00000002016H[`3000000<0@ejb0`3D?AT204=N
/P030=@m6@13G[80@ejb00L0@ejb00<0000004=N/P13G[801@13G[80203D?AT000000000003om^h0
e3dI0?ofkP000000e3dI0P3om^h0100mFJ/0ooK^0=@m6@3D?AT20?ofkP@0e3dI1`3om^h303eIZ`D0
ooK^0`0000050?ofkP0303eIZ`3om^h0ooK^00T0ooK^100mFJ]90?ofkP030000003om^h0ooK^00X0
ooK^0@3oool003@0ooK^00<000000?ofkP3om^h0603om^h203eIZa<0ooK^00<0?EV[0?ofkP3om^h0
1@3om^h01@000000ooK^0?ofkP3om^h0?EV[00@0ooK^0`000000103om^h0?EV[03eIZ`0mFJ/?0?of
kP0303eIZ`3om^h0ooK^00<0?EV[2`3om^h2000000050=@m6@0E1P80000002@:1@0000000`0T2PD0
0`0mFJ/0=Pl803H?200203H?20060000000f3`P0=Pl80000001G60`000001@1G60`010000000EaP<
05LH3000000207PR40040000001h8Q00N28@03eIZ`<0N28@00<0000007PR400mFJ/00P0mFJ/209<Z
4`030000002C:Q<0TbXC0080TbXC00<0000009<Z4`2C:Q<0102C:Q<00`000000ZC4F03eIZ`030:Ta
5P030000002Y<AH0ZC4F00<0ZC4F00<0000004UYb`19JL/01019JL/00`000000BFW;0=@m6@0204UY
b`040=@m6@19JL/0BFW;000000L0BFW;00<0000004UYb`19JL/00P19JL/30000000304QVa0000000
e3dI00<0B6K400D0e3dI04QVa018I/@0B6K40000000804QVa00300000018I/@0B6K400H0B6K400D0
000004QVa018I/@0e3dI04QVa0020=@m6@80000000<0AV:l00000016H[`02016H[`00`000000AV:l
04IR_00504IR_0040=@m6@16H[`0AV:l000000T0AV:l00@0000004IR_000000000001013G[840=@m
6@P0@ejb00<0000004=N/P13G[801013G[802@3D?AT0@ejb04=N/P000000e3dI0?ofkP000000ooK^
0=@m6@020?ofkP0403eIZ`3D?AT0e3dI0?ofkP80e3dI00<0ooK^0=@m6@3D?AT02@3om^h0100mFJ/0
ooK^03eIZ`0mFJ/60?ofkP8000000`3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP80?EV[B03om^h00`00
0000ooK^0?ofkP0:0?ofkP40oooo000d0?ofkP030000003om^h0ooK^01P0ooK^00<0?EV[0?ofkP0m
FJ/00P0mFJ/@0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00D000000?ofkP3om^h0ooK^03eIZ`080?of
kP80000000<0?EV[0?ofkP0mFJ/00P0mFJ/<0?ofkP0403eIZ`3om^h0ooK^03eIZ`80ooK^100mFJ/7
0?ofkP80000000D05@H200000000000090X50000000202@:1@0303eIZ`000000=Pl800<0=Pl800<0
000003H?200000000`1G60`00`000000EaP<05LH300305LH308000000`1h8Q0010000000N28@07PR
400mFJ/307PR40050000001h8Q00N28@0000002C:Q<00`0mFJ/509<Z4`030000002C:Q<0TbXC0080
TbXC0P0000000`0mFJ/0ZC4F0:Ta5P030:Ta5P030000002Y<AH0ZC4F0080ZC4F00<0000004UYb`19
JL/01019JL/01@000000BFW;0=@m6@19JL/0e3dI00<0BFW;00<0000004UYb`19JL/01@19JL/00`00
0000BFW;04UYb`0504UYb`<0000000<0e3dI04QVa03D?AT00`18I/@00`000000B6K404QVa00704QV
a00300000018I/@0B6K400H0B6K400<0000004QVa03D?AT01018I/@20=@m6@<000002016H[`00`00
0000AV:l04IR_00404IR_0040=@m6@16H[`0AV:l000000T0AV:l00<0000004IR_016H[`00P16H[`2
00000080@ejb00@0e3dI00000013G[80@ejb1@3D?AT204=N/P0300000013G[80@ejb00@0@ejb00T0
e3dI04=N/P13G[8000000=@m6@3om^h000000?ofkP3D?AT00`3om^h40=@m6@040?ofkP3D?AT0e3dI
0=@m6@X0ooK^00@0?EV[0?ofkP3om^h0ooK^0`0mFJ/50?ofkP<0000000<0ooK^03eIZ`3om^h03@3o
m^h00`0mFJ/0ooK^0?ofkP160?ofkP030000003om^h0ooK^00X0ooK^0@3oool003@0ooK^00<00000
0?ofkP3om^h0603om^h00`0mFJ/0ooK^0?ofkP020?ofkP@0?EV[303om^h00`0mFJ/0ooK^0?ofkP03
0?ofkP030000003om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h0203om^h01@0mFJ/0000000000000
0000ooK^00<0?EV[203om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00H0ooK^0`0mFJ/30?ofkP800000
0P0E1P802000000090X502@:1@00000090X50000000mFJ/00000100f3`P00`000000=Pl800000003
05LH30030000001G60`0EaP<00<0EaP<00<0e3dI0000001h8Q000`1h8Q000`000000?EV[07PR4004
07PR408000001@2C:Q<403eIZ`0309<Z4`000000TbXC0080TbXC00@000000:Ta5P2Y<AH0?EV[1@2Y
<AH00`000000ZC4F0:Ta5P020:Ta5P0300000019JL/0BFW;00@0BFW;00@0000004UYb`19JL/0e3dI
1019JL/00`000000BFW;04UYb`0504UYb`0300000019JL/0BFW;00H0BFW;00@0000004UYb`000000
e3dI1018I/@00`000000B6K404QVa00704QVa00300000018I/@0B6K400H0B6K400<000000=@m6@18
I/@01P18I/@20=@m6@0404QVa00000000000000000@0AV:l00<0000004IR_016H[`01016H[`01@3D
?AT0AV:l04IR_016H[`0000000T0AV:l00<0000004IR_016H[`01016H[`010000000e3dI04=N/P00
000704=N/PD0e3dI0`13G[80103D?AT0@ejb04=N/P3D?AT203eIZ`P0e3dI0`3om^h20=@m6@`0ooK^
00<0?EV[0?ofkP3om^h0103om^h203eIZ`H0ooK^0`00000=0?ofkP0303eIZ`3om^h0ooK^04L0ooK^
00<000000?ofkP3om^h02@3om^h10?ooo`00=03om^h00`000000ooK^0?ofkP0G0?ofkP0303eIZ`3o
m^h0ooK^00L0ooK^0`0mFJ/90?ofkP0303eIZ`3om^h0ooK^00<0ooK^00D000000?ofkP3om^h0ooK^
03eIZ`0:0?ofkP0303eIZ`3om^h0ooK^0080ooK^0`0000000`3om^h0?EV[03eIZ`0203eIZ`@0ooK^
00D0?EV[0?ofkP3om^h0ooK^03eIZ`090?ofkP<0?EV[00<05@H20000000E1P800P00000202@:1@80
000000<0?EV[03H?20000000100f3`P2000000@0EaP<00<0000005LH301G60`00`1G60`00`000000
N28@07PR400307PR40030000000mFJ/0N28@00@0N28@00<0000009<Z4`2C:Q<0102C:Q<010000000
TbXC09<Z4`2C:Q<303eIZ`0309<Z4`000000ZC4F0080ZC4F00<0?EV[0:Ta5P2Y<AH00`2Y<AH00`00
0000ZC4F0:Ta5P020:Ta5P0300000019JL/0BFW;00@0BFW;00D0000004UYb`3D?AT0BFW;0=@m6@04
04UYb`0300000019JL/0BFW;00@0BFW;00<0000004UYb`19JL/01P19JL/010000000BFW;0=@m6@19
JL/20=@m6@0300000018I/@0000000T0B6K400<0000004QVa018I/@01P18I/@00`3D?AT0B6K404QV
a00604QVa00300000018I/@0e3dI00<0B6K40`0000000`16H[`0000004IR_00404IR_0050=@m6@16
H[`0AV:l04IR_00000002@16H[`00`000000AV:l04IR_00404IR_080e3dI00@0AV:l000000000000
00002013G[800`000000@ejb04=N/P090=@m6@<0ooK^00D0e3dI0?ofkP3D?AT0e3dI03eIZ`030?of
kP030=@m6@3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h01P3om^h203eIZ`D0ooK^00@0?EV[0?of
kP0000000000303om^h00`0mFJ/0ooK^0?ofkP160?ofkP030000003om^h0ooK^00T0ooK^0@3oool0
03<0ooK^00<000000?ofkP3om^h0603om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP<0?EV[1@3om^h00`0m
FJ/0ooK^0?ofkP030?ofkP030000003om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h0203om^h00`0m
FJ/0ooK^0?ofkP050?ofkP<000000P3om^h403eIZ`<0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`3D
?AT05@H203eIZ`0303eIZ`080000000T2PD000000=@m6@000000?EV[03H?2000000403H?20030000
001G60`0EaP<00<0EaP<00<0000005LH301G60`00P1G60`2000000030=@m6@1h8Q00N28@0080N28@
00<0?EV[0000001h8Q000`1h8Q02000000H0TbXC00<0000009<Z4`2C:Q<00`2C:Q<01`000000?EV[
03eIZ`0mFJ/0ZC4F03eIZ`0000001P2Y<AH00`000000ZC4F0:Ta5P020:Ta5P0300000019JL/0BFW;
00@0BFW;00D0e3dI04UYb`19JL/0BFW;0=@m6@0304UYb`0300000019JL/0BFW;00@0BFW;00<00000
04UYb`19JL/01P19JL/00`000000e3dI04UYb`0304UYb`040=@m6@0000000000000000L0B6K400<0
000004QVa018I/@01P18I/@00`3D?AT0B6K404QVa00704QVa00300000018I/@0B6K40080e3dI1018
I/@3000000<0AV:l00<0e3dI04IR_016H[`00P16H[`00`000000AV:l04IR_00704IR_00300000016
H[`0AV:l00<0AV:l00D0e3dI04IR_016H[`0AV:l0000000204IR_0<000001@13G[801@000000@ejb
04=N/P13G[80e3dI00@0@ejb00<000000?ofkP3om^h00`0mFJ/20=@m6@80ooK^00@0?EV[0?ofkP3D
?AT0e3dI3P3om^h00`0mFJ/0ooK^0?ofkP080?ofkP<0?EV[0P3om^h0100mFJ/0ooK^0?ofkP3om^h3
000000T0ooK^00<0?EV[0?ofkP3om^h0AP3om^h00`000000ooK^0?ofkP090?ofkP40oooo000c0?of
kP030000003om^h0ooK^01P0ooK^00<0?EV[0?ofkP3om^h03@3om^h403eIZ`030?ofkP0mFJ/0ooK^
00<0ooK^00<000000?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^
00P0ooK^0`0000020?ofkP<0?EV[00<0ooK^03eIZ`3om^h02P3om^h01P0000005@H2000000000000
90X5000000<0?EV[00D0000003eIZ`0f3`P0=Pl80000000303H?2080000000<0e3dI05LH301G60`0
0P1G60`01@000000EaP<05LH301G60`000000080N28@00<0000007PR401h8Q000P1h8Q000`0mFJ/0
000007PR400207PR40040000002C:Q<0TbXC000000D0TbXC00<0000009<Z4`2C:Q<00`2C:Q<01000
0000ZC4F0:Ta5P2Y<AH303eIZ`H0ZC4F00<000000:Ta5P2Y<AH00P2Y<AH2000000@0BFW;00<0e3dI
00000019JL/00`19JL/0103D?AT0BFW;04UYb`00000604UYb`0300000019JL/0BFW;00H0BFW;00<0
e3dI04UYb`19JL/01019JL/00`3D?AT0000004UYb`03000000@0B6K400<0000004QVa018I/@01@18
I/@00`3D?AT0000004QVa00804QVa00300000018I/@0B6K40080B6K40P3D?AT304QVa00500000018
I/@000000000003D?AT01@16H[`00`000000AV:l04IR_00604IR_00300000016H[`0AV:l00<0AV:l
00<0e3dI04IR_016H[`00P16H[`00`000000AV:l04IR_00304IR_0<0000000<0@ejb00000013G[80
0P13G[800`3D?AT0@ejb04=N/P0304=N/P030000003om^h0ooK^0080ooK^0P3D?AT203eIZ`040?of
kP0mFJ/0e3dI0=@m6@l0ooK^00<0?EV[0?ofkP3om^h02`3om^h203eIZ`030?ofkP0mFJ/0ooK^00@0
ooK^0P0000070?ofkP0303eIZ`3om^h0ooK^04H0ooK^00<000000?ofkP3om^h02@3om^h10?ooo`00
<`3om^h00`000000ooK^0?ofkP0H0?ofkP0303eIZ`3om^h0ooK^0140ooK^0`0mFJ/20?ofkP030000
003om^h0ooK^00<0ooK^0P0mFJ/:0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0000003eIZ`000000
0P3om^h303eIZ`T0ooK^00@0e3dI00000000000000000P0T2PD01000000090X502@:1@00000303eI
Z`0703H?20000000=Pl803H?20000000EaP<0000000505LH30040000001G60`0EaP<000000<0N28@
00L0000007PR401h8Q00N28@03eIZ`1h8Q0000000080N28@00D0000009<Z4`2C:Q<0TbXC00000006
09<Z4`040000002C:Q<0TbXC09<Z4`800000102Y<AH00`0mFJ/0ZC4F03eIZ`0203eIZ`<0ZC4F00@0
00000:Ta5P2Y<AH0ZC4F0P0000001`1:K=000000000000000000e3dI04UYb`0000001@19JL/00`3D
?AT0BFW;0000000604UYb`0300000019JL/0BFW;00D0BFW;00<0e3dI00000019JL/01P19JL/20=@m
6@<0BFW;0`0000000`18I/@0000004QVa00504QVa0030=@m6@18I/@0000000P0B6K400<0000004QV
a018I/@01@18I/@20=@m6@0600000018I/@0B6K404QVa03D?AT0B6K40`0000000`16H[`0000004IR
_00804IR_00300000016H[`0AV:l0080AV:l00<0e3dI04IR_016H[`00P16H[`00`000000AV:l04IR
_00704IR_0<000000P3D?AT604=N/P040000003om^h0ooK^0?ofkP80e3dI0`3om^h00`0mFJ/0e3dI
0=@m6@0@0?ofkP0303eIZ`3om^h0ooK^00d0ooK^0`0mFJ/60?ofkP<00000103om^h00`0mFJ/0ooK^
0?ofkP160?ofkP030000003om^h0ooK^00T0ooK^0@3oool003<0ooK^00<000000?ofkP3om^h0603o
m^h00`0mFJ/0ooK^0?ofkP0B0?ofkP0503eIZ`3om^h0?EV[03eIZ`000000103om^h00`0mFJ/0ooK^
0?ofkP0303eIZ`H0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^000000020000000303eI
Z`3om^h0?EV[0080?EV[1@3om^h0103D?AT0000001D60P00000302@:1@050000000T2PD000000000
000mFJ/00P0f3`P303eIZ`050000001G60`0EaP<05LH300000001@1G60`00`000000EaP<00000003
07PR40050000001h8Q00N28@07PR400mFJ/00P1h8Q02000000D0TbXC00<0000009<Z4`2C:Q<00`2C
:Q<010000000TbXC09<Z4`0000020:Ta5P040000002Y<AH0ZC4F03eIZ`80ZC4F00<000000:Ta5P2Y
<AH0100mFJ/20:Ta5P040000002l=aP0_3LH00000080BVc@00<0e3dI04Y/d00000000P00000504UY
b`030=@m6@000000BFW;00D0BFW;00<0000004UYb`19JL/01019JL/00`3D?AT0BFW;0000000704UY
b`0300000019JL/0e3dI00D0BFW;0`00000504QVa0030=@m6@18I/@0000000P0B6K400<0000004QV
a018I/@01`18I/@20=@m6@0304QVa03D?AT0B6K400@0B6K40`00000704IR_00300000016H[`0AV:l
0080AV:l00<0e3dI04IR_016H[`00`16H[`00`000000AV:l04IR_00704IR_00300000016H[`0e3dI
00<000001@13G[800`000000ooK^0?ofkP020=@m6@@0ooK^0P3D?AT00`3om^h0?EV[03eIZ`0>0?of
kP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP0mFJ/00P0mFJ/60?ofkP<000000P3om^h00`0m
FJ/0ooK^0?ofkP160?ofkP030000003om^h0ooK^00P0ooK^0@3oool003<0ooK^00<000000?ofkP3o
m^h0603om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP0503eIZ`3om^h0ooK^0000003om^h00`0mFJ/00`3o
m^h0?EV[0?ofkP040?ofkP<0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^
00<0ooK^00D0?EV[00000000000000000?ofkP0403eIZ`80e3dI0`00000302@:1@80000000<0=Pl8
0000000mFJ/00`0f3`P010000000=Pl803eIZ`0mFJ/205LH30030000001G60`0EaP<00<0EaP<0P00
000407PR40050000001h8Q00N28@07PR400mFJ/00P1h8Q000`000000TbXC09<Z4`0409<Z4`030000
002C:Q<0TbXC00<0TbXC00@0000009<Z4`2C:Q<000000P2Y<AH010000000ZC4F0:Ta5P0mFJ/20:Ta
5P030000002Y<AH0ZC4F00@0ZC4F0`0mFJ/20;`g60030000001:K=00e3dI00<0BVc@00@0000004Y/
d000000000001019JL/20=@m6@D0BFW;00<0000004UYb`19JL/00`19JL/00`3D?AT0BFW;00000007
04UYb`0500000019JL/0BFW;04UYb`3D?AT01@19JL/010000000BFW;00000000000204QVa0030=@m
6@18I/@0000000T0B6K400<0000004QVa018I/@01P18I/@00`000000B6K404QVa0020=@m6@D0B6K4
00<0000004QVa018I/@00P00000504IR_00500000016H[`0AV:l04IR_03D?AT01@16H[`00`000000
AV:l04IR_00804IR_0030000003D?AT0AV:l00<0AV:l0`0000001013G[8000000?ofkP3om^h30=@m
6@80ooK^0P3D?AT00`3om^h0?EV[0?ofkP020?ofkP<0?EV[2`3om^h00`0mFJ/0ooK^0?ofkP0>0?of
kP0303eIZ`3om^h0ooK^0080ooK^0`0mFJ/60?ofkP80000000<0?EV[0?ofkP3om^h0AP3om^h00`00
0000ooK^0?ofkP080?ofkP40oooo000b0?ofkP030000003om^h0ooK^01P0ooK^00<0?EV[0?ofkP3o
m^h04`3om^h00`0mFJ/0ooK^000000050?ofkP80?EV[203om^h403eIZ`h0ooK^00<0?EV[0?ofkP3o
m^h00`3om^h0100mFJ/0ooK^0?ofkP3om^h300000080ooK^0P0mFJ/30000008090X500D0000002@:
1@000000=Pl803eIZ`0403H?208000000P1G60`303eIZ`D0EaP<00<0000007PR401h8Q00101h8Q00
0`000000N28@03eIZ`0207PR408000001P2C:Q<00`000000TbXC09<Z4`0409<Z4`800000102Y<AH0
0`000000?EV[0:Ta5P030:Ta5P030000002Y<AH0ZC4F00<0ZC4F00<000000;`g602l=aP00P0mFJ/0
0`000000e3dI04Y/d00304Y/d0040000001:K=00BVc@04Y/d0<0000000@0BFW;00000019JL/0e3dI
1019JL/00`000000BFW;04UYb`0204UYb`040=@m6@19JL/0BFW;000000L0BFW;00<0000004UYb`19
JL/00P19JL/20=@m6@80BFW;00<0000004UYb`19JL/00P19JL/01@000000e3dI00000018I/@00000
00P0B6K400<0000004QVa018I/@01`18I/@00`000000B6K40=@m6@0204QVa0<0e3dI0P18I/@00`00
0000B6K404QVa00204QVa0<0000000<0AV:l00000016H[`00P16H[`00`3D?AT0AV:l04IR_00404IR
_00300000016H[`0AV:l00L0AV:l00<000000=@m6@16H[`01`16H[`2000000040?ofkP3D?AT0e3dI
0=@m6@80ooK^0P3D?AT20?ofkP0303eIZ`3om^h0ooK^00@0ooK^0P0mFJ/90?ofkP0303eIZ`3om^h0
ooK^00h0ooK^00<0?EV[0?ofkP3om^h01@3om^h203eIZ`H0ooK^0`0000160?ofkP030000003om^h0
ooK^00P0ooK^0@3oool00380ooK^00<000000?ofkP3om^h0603om^h00`0mFJ/0ooK^0?ofkP0C0?of
kP0303eIZ`000000ooK^00D0ooK^00<0?EV[0?ofkP0mFJ/00P0mFJ/80?ofkP80?EV[303om^h00`0m
FJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<000000=@m6@3D?AT00`00000302@:
1@8000000P0f3`P00`0mFJ/0=Pl803H?200203H?20030000001G60`0EaP<00<0EaP<00D0000003eI
Z`0mFJ/0?EV[05LH3002000000H0N28@00D0000007PR400mFJ/0N28@0000000209<Z4`030000002C
:Q<0TbXC00@0TbXC00<0000009<Z4`2C:Q<00`2C:Q<00`000000ZC4F0:Ta5P030:Ta5P030000000m
FJ/0ZC4F00<0ZC4F00<000000:Ta5P2Y<AH00P2Y<AH2000000<0_3LH00<0?EV[0000001:K=001@1:
K=000`000000BVc@04Y/d00304Y/d0<0000000<0BFW;0=@m6@19JL/00P19JL/01@000000BFW;04UY
b`19JL/0e3dI00<0BFW;00<0000004UYb`19JL/01@19JL/00`000000BFW;04UYb`0404UYb`030=@m
6@19JL/0000000@0BFW;00<0e3dI04UYb`19JL/00`00000704QVa00300000018I/@0B6K400H0B6K4
00<0000004QVa03D?AT01P18I/@30=@m6@L0B6K40`0000020=@m6@H0AV:l00<0000004IR_016H[`0
2016H[`00`3D?AT0AV:l04IR_00704IR_0050000003om^h0e3dI0=@m6@3om^h0103D?AT30?ofkP03
03eIZ`3om^h0ooK^00H0ooK^0`0mFJ/60?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3o
m^h01`3om^h303eIZ`<0ooK^00<0?EV[0?ofkP3om^h00`0000130?ofkP030000003om^h0ooK^00P0
ooK^0@3oool00380ooK^00<000000?ofkP3om^h0603om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eI
Z`000000ooK^00@0ooK^00<0?EV[0?ofkP3om^h00`3om^h303eIZ`@0ooK^00<0?EV[0?ofkP3om^h0
0`0mFJ/90?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h01@3om^h30=@m6@030000
000T2PD0000000<090X500D0000003H?200f3`P0?EV[0000000303H?208000001@1G60`010000000
EaP<05LH301G60`303eIZ`030000001h8Q00N28@00<0N28@00@0000003eIZ`1h8Q0000000`2C:Q<0
0`000000TbXC09<Z4`0409<Z4`030000002C:Q<0TbXC0080TbXC0P0000050:Ta5P0303eIZ`2Y<AH0
ZC4F00<0ZC4F00D000000:Ta5P2Y<AH0ZC4F000000020;`g60030000002l=aP0_3LH0080_3LH00<0
000004Y/d01:K=000`1:K=000`000000BVc@04Y/d00404Y/d0050000001:K=0000000000003D?AT0
0P19JL/010000000BFW;04UYb`3D?AT404UYb`0300000019JL/0BFW;00D0BFW;00<0000004UYb`19
JL/01@19JL/00`3D?AT0000004UYb`0204UYb`030=@m6@19JL/0BFW;0080BFW;00@0000004UYb`00
000000001@18I/@00`000000B6K404QVa00604QVa0030000003D?AT0B6K400L0B6K400<0000004QV
a03D?AT00P3D?AT404QVa00300000018I/@0e3dI00<000001@16H[`00`000000AV:l04IR_00704IR
_0030=@m6@16H[`0AV:l00P0AV:l00@000000=@m6@3D?AT0ooK^103D?AT40?ofkP0303eIZ`3om^h0
ooK^00T0ooK^0`0mFJ/30?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h02P3om^h3
03eIZ`030?ofkP0mFJ/0ooK^00<0ooK^0P0000120?ofkP030000003om^h0ooK^00L0ooK^0@3oool0
0380ooK^00<000000?ofkP3om^h0603om^h203eIZa<0ooK^00<0?EV[0000003om^h0103om^h00`0m
FJ/0ooK^0?ofkP070?ofkP<0?EV[00<0ooK^03eIZ`3om^h0103om^h303eIZ`D0ooK^00<0?EV[0?of
kP3om^h0103om^h00`0mFJ/0ooK^0?ofkP040?ofkP<0e3dI0P000000100T2PD0000002@:1@0T2PD2
00000080=Pl800L0?EV[0000000f3`P0=Pl80000001G60`0000000H0EaP<00<0000005LH30000000
0`1h8Q0203eIZ`@0N28@00@0000003eIZ`1h8Q000000102C:Q<00`000000TbXC09<Z4`0409<Z4`04
0000002C:Q<0TbXC00000080ZC4F00<000000:Ta5P2Y<AH00P2Y<AH00`0mFJ/000000:Ta5P030:Ta
5P040000002Y<AH0ZC4F000000<0_3LH00<000000;`g602l=aP00P2l=aP00`000000BVc@04Y/d003
04Y/d0030000001:K=00BVc@00@0BVc@00X0000004Y/d01:K=00BVc@0000003D?AT0BFW;00000019
JL/0e3dI1@19JL/00`000000BFW;04UYb`0504UYb`0300000019JL/0BFW;00D0BFW;00D000000=@m
6@3D?AT0BFW;0=@m6@0404UYb`0300000019JL/0BFW;0080BFW;0`0000000`18I/@0000004QVa008
04QVa0030=@m6@18I/@0B6K400H0B6K400<0000004QVa018I/@00`18I/@30=@m6@0304QVa0000000
e3dI00@0B6K40`0000000`16H[`0000004IR_00804IR_0030=@m6@16H[`0AV:l00@0AV:l00@0e3dI
04IR_016H[`0AV:l0P3D?AT0103om^h0e3dI0=@m6@3om^h20=@m6@D0ooK^00<0?EV[0?ofkP3om^h0
303om^h203eIZ`030?ofkP0mFJ/0ooK^00l0ooK^00<0?EV[0?ofkP3om^h03@3om^h203eIZ`H0ooK^
0`00000o0?ofkP030000003om^h0ooK^00L0ooK^0@3oool00380ooK^00<000000?ofkP3om^h0603o
m^h00`0mFJ/0ooK^03eIZ`0303eIZ`l0ooK^00<000000?ofkP3om^h0103om^h00`0mFJ/0ooK^0?of
kP0:0?ofkP<0?EV[1`3om^h303eIZ`80ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?of
kP030?ofkP@0e3dI00h0000002@:1@0T2PD0000002@:1@000000=Pl80000000f3`P0?EV[03H?2000
0000=Pl8000000<0EaP<00<0000005LH301G60`00`1G60`2000000D0N28@00H0000003eIZ`0mFJ/0
?EV[07PR400mFJ/2000000D0TbXC00<0000009<Z4`2C:Q<0102C:Q<010000000TbXC09<Z4`000002
0:Ta5P070000002Y<AH0ZC4F0:Ta5P0mFJ/0ZC4F000000050:Ta5P800000102l=aP00`000000_3LH
0;`g60020;`g60030000001:K=00BVc@00<0BVc@00<0000004Y/d01:K=00101:K=000`000000BVc@
04Y/d00304Y/d0030=@m6@000000e3dI00H0BFW;00<0000004UYb`19JL/01@19JL/00`000000BFW;
04UYb`0504UYb`0400000019JL/0BFW;0=@m6@D0BFW;00<0000004UYb`19JL/01@19JL/3000000L0
B6K400<0e3dI04QVa018I/@01`18I/@00`000000B6K404QVa00604QVa0@0e3dI1P18I/@3000000H0
AV:l0P3D?AT00`000000AV:l04IR_00704IR_0@0e3dI00@0ooK^0=@m6@3D?AT0e3dI1P3om^h00`0m
FJ/0ooK^0?ofkP0>0?ofkP<0?EV[403om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^
00L0ooK^0P00000m0?ofkP030000003om^h0ooK^00L0ooK^0@3oool00340ooK^00<000000?ofkP3o
m^h06@3om^h00`0mFJ/0ooK^0?ofkP030?ofkP<0?EV[303om^h00`000000ooK^0?ofkP030?ofkP03
03eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP0mFJ/00P0mFJ/70?ofkP<0?EV[1P3om^h00`0mFJ/0
ooK^0?ofkP030?ofkP<0e3dI00@0ooK^0000000T2PD090X50P00000203H?20040000000f3`P0?EV[
03H?20800000101G60`00`000000EaP<05LH300305LH30030000001h8Q00N28@00@0N28@00@00000
07PR401h8Q00N28@0`0mFJ/609<Z4`030000002C:Q<0TbXC00D0TbXC0P0000040:Ta5P060000002Y
<AH0ZC4F03eIZ`2Y<AH000001@2Y<AH00`000000_3LH0;`g60030;`g60030000002l=aP0_3LH0080
_3LH00<0000004Y/d01:K=000`1:K=000`000000BVc@04Y/d00404Y/d0030000001:K=00BVc@00@0
BVc@00<0e3dI04Y/d00000000`00000204UYb`0300000019JL/0BFW;00D0BFW;00<0000004UYb`19
JL/01@19JL/010000000BFW;0=@m6@19JL/20=@m6@<0BFW;00<0000004UYb`19JL/01P19JL/01000
0000BFW;00000000000404QVa0030=@m6@000000B6K400L0B6K400<0000004QVa018I/@01`18I/@0
103D?AT0B6K404QVa018I/@50=@m6@0404QVa0000000B6K404QVa08000000`16H[`00`3D?AT0AV:l
0000000904IR_0<0e3dI0P3om^h20=@m6@L0ooK^00<0?EV[0?ofkP3om^h0403om^h00`0mFJ/0ooK^
03eIZ`0203eIZ`d0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP090?ofkP<00000
>P3om^h00`000000ooK^0?ofkP070?ofkP40oooo000a0?ofkP030000003om^h0ooK^01T0ooK^00<0
?EV[0?ofkP3om^h01P3om^h403eIZ`L0ooK^00<0000003eIZ`3om^h0103om^h00`0mFJ/0ooK^0?of
kP0<0?ofkP0303eIZ`3om^h0ooK^0080ooK^100mFJ/30?ofkP0303eIZ`3om^h0ooK^00<0?EV[0`3o
m^h00`0mFJ/0ooK^0?ofkP020?ofkPD0e3dI00D0000002@:1@00000090X50000000203H?20050000
000mFJ/0=Pl803H?200000001@1G60`00`000000EaP<05LH300205LH3080000000<0e3dI07PR401h
8Q000`1h8Q001`000000N28@07PR401h8Q00?EV[0000002C:Q<00`0mFJ/409<Z4`030000002C:Q<0
TbXC00@0TbXC00<000000:Ta5P2Y<AH00`2Y<AH010000000ZC4F0:Ta5P0mFJ/20:Ta5P040000002Y
<AH0ZC4F0:Ta5P8000001P2l=aP00`000000_3LH0;`g60020;`g60030000001:K=00BVc@00<0BVc@
00<0000004Y/d01:K=000`1:K=000`000000BVc@04Y/d00304Y/d0030=@m6@000000e3dI00@0BVc@
1000000504UYb`0300000019JL/0BFW;00H0BFW;00<000000=@m6@19JL/00`19JL/20=@m6@030000
0019JL/0BFW;00H0BFW;00<0000004UYb`19JL/00P19JL/200000080e3dI00<0000004QVa018I/@0
1`18I/@00`000000B6K404QVa00604QVa0030=@m6@18I/@0B6K400L0B6K41@3D?AT01018I/@00000
0000003D?AT204IR_00300000016H[`0AV:l00P0e3dI103om^h00`3D?AT0ooK^0?ofkP060?ofkP03
03eIZ`3om^h0ooK^0100ooK^00<0?EV[0?ofkP3om^h00P3om^h303eIZ`X0ooK^00<0?EV[0?ofkP3o
m^h03@3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP<00000>03om^h00`000000ooK^0?ofkP060?ofkP40
oooo000a0?ofkP030000003om^h0ooK^01T0ooK^00<0?EV[0?ofkP3om^h02P3om^h303eIZ`<0ooK^
00<000000?ofkP0mFJ/0103om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00H0ooK^
100mFJ/50?ofkP@0?EV[0`3om^h01P3D?AT0ooK^0=@m6@3D?AT0ooK^0000008090X50P00000303H?
20030000000mFJ/0=Pl80080000000<0e3dI05LH301G60`00P1G60`01@000000EaP<05LH301G60`0
00000080N28@00<0000007PR401h8Q00101h8Q0010000000N28@07PR400mFJ/209<Z4`030000002C
:Q<0TbXC00<0?EV[00<0TbXC0000002C:Q<0102C:Q<2000000D0ZC4F00<000000:Ta5P0mFJ/00`2Y
<AH010000000ZC4F0:Ta5P0000020;`g60030000002l=aP0_3LH00<0_3LH00<000000;`g602l=aP0
0P2l=aP00`000000BVc@04Y/d00304Y/d0030000001:K=00BVc@00<0BVc@00<0000004Y/d01:K=00
0P1:K=00103D?AT0BVc@0000001:K=020=@m6@@0BVc@00@0000004Y/d000000000000`19JL/00`00
0000BFW;04UYb`0504UYb`030000003D?AT0BFW;00H0BFW;0P3D?AT704UYb`0300000019JL/0BFW;
00<0BFW;00<0e3dI04UYb`0000000P00000704QVa00300000018I/@0B6K400H0B6K400<0e3dI0000
0018I/@02018I/@00`000000B6K404QVa00204QVa0T0e3dI1@16H[`20=@m6@80?EV[0P3om^h00`3D
?AT0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^0100ooK^00<0?EV[0?ofkP3om^h01@3om^h303eI
Z`L0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP800000=P3om^h00`00
0000ooK^0?ofkP060?ofkP40oooo000a0?ofkP030000003om^h0ooK^01T0ooK^00<0?EV[0?ofkP3o
m^h03@3om^h203eIZ`040000000mFJ/0ooK^03eIZ`@0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0m
FJ/0ooK^0?ofkP080?ofkP@0?EV[1@3om^h00`0mFJ/0ooK^03eIZ`0203eIZ`060?ofkP3D?AT0e3dI
0=@m6@3om^h000000P0T2PD00`000000=Pl803H?200203H?200603eIZ`0f3`P0=Pl80000001G60`0
0000101G60`010000000EaP<05LH3000000307PR40030000001h8Q00N28@00@0N28@00@0000007PR
400mFJ/000000`2C:Q<00`000000TbXC09<Z4`0209<Z4`<0?EV[0`2C:Q<010000000ZC4F0:Ta5P00
00050:Ta5P030000000mFJ/0ZC4F00<0ZC4F0P0000030;`g60030000002l=aP0_3LH00<0_3LH00<0
00000;`g602l=aP00P2l=aP00`000000BVc@04Y/d00304Y/d0030000001:K=00BVc@00<0BVc@00D0
000004Y/d01:K=00BVc@0=@m6@0204Y/d0050000001:K=00BVc@04Y/d03D?AT00`1:K=0010000000
BVc@04Y/d01:K=020000000304UYb`000000BFW;00H0BFW;00<0e3dI04UYb`19JL/01P19JL/01000
0000BFW;0=@m6@3D?AT404UYb`0300000019JL/0BFW;00<0BFW;00@0e3dI04UYb`19JL/000000P19
JL/2000000D0B6K400<0000004QVa018I/@01@18I/@00`3D?AT0000004QVa00804QVa00300000018
I/@0B6K400@0B6K400@0e3dI04QVa018I/@000000P18I/@3000000<0AV:l00<0e3dI04IR_0000000
0P3om^h20=@m6@0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h0403om^h00`0mFJ/0ooK^
0?ofkP080?ofkP<0?EV[103om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^0140ooK^
0`00000c0?ofkP030000003om^h0ooK^00H0ooK^0@3oool00340ooK^00<000000?ofkP3om^h06@3o
m^h00`0mFJ/0ooK^0?ofkP0?0?ofkP030000003om^h0?EV[0080?EV[0P3om^h203eIZ`l0ooK^00<0
?EV[0?ofkP3om^h0203om^h0100mFJ/0ooK^0?ofkP3om^h403eIZ`040?ofkP0mFJ/0ooK^0?ofkP80
e3dI0`0mFJ/0103om^h0e3dI0000000T2PD2000000@0=Pl800<0?EV[03H?200000000P1G60`00`00
0000EaP<05LH300305LH30030000001G60`0000000@0N28@00<0000007PR401h8Q00101h8Q000`00
0000?EV[09<Z4`0309<Z4`030000002C:Q<0TbXC00@0TbXC00<0000003eIZ`0mFJ/00P0mFJ/20:Ta
5P030000002Y<AH0ZC4F00<0ZC4F00<0?EV[0:Ta5P2Y<AH00`2Y<AH00`000000_3LH0;`g60030;`g
60030000002l=aP0_3LH0080_3LH00<000000;`g602l=aP00P2l=aP00`000000BVc@04Y/d00304Y/
d0030000001:K=00BVc@00@0BVc@00<0000004Y/d03D?AT00`1:K=000`000000BVc@04Y/d00204Y/
d0040=@m6@1:K=00BVc@000000D0BVc@0`00000504UYb`030=@m6@000000BFW;00L0BFW;00@00000
04UYb`19JL/0BFW;0P3D?AT204UYb`0300000019JL/0BFW;0080BFW;00D0e3dI04UYb`19JL/0BFW;
0000000404UYb`<0000000<0B6K400000018I/@01P18I/@00`3D?AT0B6K40000000904QVa0030000
0018I/@0B6K400<0B6K400D0e3dI04QVa018I/@0B6K40000000504QVa0030000003D?AT0e3dI0080
AV:l00@000000?ofkP3D?AT0e3dI0P3om^h203eIZ`L0ooK^00<0?EV[0?ofkP3om^h0403om^h00`0m
FJ/0ooK^0?ofkP0;0?ofkP<0?EV[00<0ooK^03eIZ`3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0D0?of
kP<00000<03om^h00`000000ooK^0?ofkP060?ofkP40oooo000a0?ofkP030000003om^h0ooK^01T0
ooK^00<0?EV[0?ofkP3om^h03P3om^h01P000000ooK^0?ofkP3om^h0?EV[0?ofkP<0?EV[00@0ooK^
03eIZ`0mFJ/0?EV[303om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00H0ooK^0`0m
FJ/0103om^h0e3dI0=@m6@3om^h20=@m6@@0?EV[00<0=Pl80000000f3`P00P0f3`P00`0mFJ/00000
0000000305LH30030000001G60`0EaP<00<0EaP<0P00000507PR40030000001h8Q00N28@00@0N28@
00<0?EV[09<Z4`2C:Q<0102C:Q<00`000000TbXC09<Z4`0409<Z4`8000000P2Y<AH303eIZ`030000
002Y<AH0ZC4F0080ZC4F00<0?EV[0000002Y<AH00P2Y<AH2000000D0_3LH00<000000;`g602l=aP0
0`2l=aP00`000000_3LH0;`g60020;`g60030000001:K=00BVc@0080BVc@00<0000004Y/d01:K=00
101:K=000`000000e3dI04Y/d00304Y/d0030000001:K=00BVc@00<0BVc@00<0e3dI0000001:K=00
1P1:K=000`000000BVc@0000000200000080e3dI00<0000004UYb`19JL/01P19JL/00`000000BFW;
04UYb`0404UYb`80e3dI1019JL/01@3D?AT0BFW;04UYb`19JL/0000000P0BFW;0`00000504QVa003
0=@m6@18I/@0000000T0B6K400<0000004QVa018I/@00P18I/@20=@m6@<0B6K400<0000004QVa018
I/@01018I/@00`3D?AT0B6K404QVa002000000030?ofkP3D?AT0e3dI00D0ooK^0`0mFJ/40?ofkP03
03eIZ`3om^h0ooK^0100ooK^00<0?EV[0?ofkP3om^h03P3om^h303eIZ`l0ooK^00<0?EV[0?ofkP3o
m^h05P3om^h2000002h0ooK^00<000000?ofkP3om^h01P3om^h10?ooo`00<03om^h00`000000ooK^
0?ofkP0J0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<000000?ofkP3om^h00P3om^h01@0mFJ/0ooK^
0?ofkP0mFJ/0ooK^00<0?EV[00@0ooK^03eIZ`0mFJ/0?EV[2@3om^h00`0mFJ/0ooK^0?ofkP060?of
kP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP0mFJ/00P0mFJ/01`3D?AT0ooK^0=@m6@3D?AT0
000002@:1@0000000`0mFJ/203H?200303eIZ`000000000000<0EaP<00<0000005LH301G60`00`1G
60`00`000000N28@07PR400407PR40030000001h8Q00N28@00<0N28@00<0000003eIZ`0000001@2C
:Q<00`000000TbXC09<Z4`0409<Z4`030000002Y<AH0ZC4F00@0ZC4F0`0mFJ/0102Y<AH0?EV[0:Ta
5P0000020:Ta5P040000002l=aP0_3LH000000D0_3LH00<000000;`g602l=aP00P2l=aP00`000000
_3LH0;`g60020;`g60800000101:K=000`000000BVc@04Y/d00304Y/d0030=@m6@1:K=00BVc@00<0
BVc@00<0000004Y/d01:K=00101:K=020=@m6@D0BVc@00<0000004Y/d01:K=000P1:K=000`3D?AT0
BVc@00000002000000L0BFW;00<0000004UYb`19JL/01@19JL/01@000000e3dI0=@m6@19JL/0e3dI
00@0BFW;00<0000004UYb`19JL/01P19JL/00`000000BFW;04UYb`0300000080e3dI0P18I/@00`00
0000B6K404QVa00704QVa00500000018I/@0B6K404QVa03D?AT01018I/@00`000000B6K404QVa004
04QVa0060=@m6@18I/@0B6K404QVa0000000ooK^0P3D?AT90?ofkP<0?EV[00<0ooK^03eIZ`3om^h0
4@3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0?EV[0080?EV[303om^h00`0mFJ/0ooK^
0?ofkP0H0?ofkP<00000;03om^h00`000000ooK^0?ofkP050?ofkP40oooo000`0?ofkP030000003o
m^h0ooK^01X0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`000000ooK^0?ofkP020?ofkP0303eIZ`3o
m^h0?EV[00D0ooK^0`0mFJ/0103om^h0?EV[03eIZ`0mFJ/60?ofkP0303eIZ`3om^h0ooK^00H0ooK^
00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0e3dI0=@m6@020=@m6@<0?EV[00<0e3dI000000000000
0P0f3`P00`000000=Pl803eIZ`0203eIZ`030000001G60`0EaP<00<0EaP<00L0000005LH301G60`0
EaP<0000001h8Q00000000H0N28@00P0000007PR401h8Q00N28@0000000mFJ/0TbXC000000H0TbXC
00<0000009<Z4`2C:Q<00P2C:Q<00`000000ZC4F000000060:Ta5P030000002Y<AH0?EV[0080?EV[
00<0ZC4F0000000000000`2l=aP00`000000_3LH0;`g60030;`g60030000002l=aP0_3LH0080_3LH
00@000000;`g602l=aP0_3LH0P0000001P1;K]@00000000000000000BVc@000000D0BVc@00<0e3dI
04Y/d01:K=000`1:K=000`000000BVc@04Y/d00404Y/d0030000001:K=00e3dI00@0BVc@00D00000
04Y/d01:K=00BVc@0=@m6@0304Y/d0040000001:K=000000000000D0BFW;00<0000004UYb`19JL/0
1@19JL/00`000000BFW;04UYb`020=@m6@<0BFW;00<0000004UYb`19JL/01`19JL/00`000000BFW;
04UYb`0204UYb`030=@m6@19JL/0000000<000002018I/@01@000000B6K404QVa018I/@0e3dI00D0
B6K400<0000004QVa018I/@00`18I/@01`3D?AT0B6K404QVa03D?AT000000?ofkP3D?AT03P3om^h3
03eIZa00ooK^00<0?EV[0?ofkP3om^h0403om^h00`0mFJ/0ooK^0?ofkP020?ofkP<0?EV[2@3om^h0
0`0mFJ/0ooK^0?ofkP0K0?ofkP800000:P3om^h00`000000ooK^0?ofkP050?ofkP40oooo000`0?of
kP030000003om^h0ooK^01X0ooK^0P0mFJ/=0?ofkP030000003om^h0ooK^00<0ooK^0P0mFJ/90?of
kP<0?EV[00<0ooK^03eIZ`0mFJ/0103om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^
00T0ooK^00@0?EV[0=@m6@3D?AT0e3dI0P3om^h20=@m6@80?EV[0`0f3`P01@000000=Pl803eIZ`0f
3`P0000000<0?EV[0`1G60`010000000EaP<05LH3000000207PR40030000001h8Q00N28@00@0N28@
00H0000007PR401h8Q00000009<Z4`0mFJ/209<Z4`030000002C:Q<0TbXC00<0TbXC00D0000009<Z
4`2C:Q<0TbXC000000020:Ta5P030000002Y<AH0ZC4F00@0ZC4F00<000000:Ta5P0mFJ/00P2Y<AH3
03eIZ`@0_3LH00<000000;`g602l=aP00`2l=aP01@000000_3LH0;`g602l=aP000000080_3LH00@0
00000<hl6P3>?1X000000`1;K]@3000000<0BVc@00<0e3dI0000001:K=00101:K=000`000000BVc@
04Y/d00404Y/d0040000001:K=00BVc@0=@m6@<0BVc@00@0000004Y/d01:K=00e3dI0`1:K=000`00
0000BVc@04Y/d00204Y/d0<0000000<0BFW;00000019JL/01P19JL/010000000BFW;04UYb`3D?AT2
04UYb`<0e3dI00<0000004UYb`19JL/01P19JL/00`000000BFW;04UYb`0204UYb`050=@m6@19JL/0
BFW;04UYb`0000000P19JL/2000000D0B6K400D0000004QVa018I/@0B6K40=@m6@0504QVa0030000
0018I/@0B6K400<0B6K400<0e3dI04QVa018I/@00P18I/@00`000000e3dI0?ofkP0?0?ofkP0403eI
Z`3om^h0?EV[03eIZ`h0ooK^00<0?EV[0?ofkP3om^h0403om^h00`0mFJ/0ooK^0?ofkP050?ofkP80
?EV[1`3om^h00`0mFJ/0ooK^0?ofkP0M0?ofkP<000009`3om^h00`000000ooK^0?ofkP050?ofkP40
oooo000`0?ofkP030000003om^h0ooK^01X0ooK^00<0?EV[0?ofkP0mFJ/00`0mFJ/80?ofkP030000
003om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h02`3om^h603eIZ`030?ofkP0mFJ/0ooK^00H0ooK^
00<0?EV[0?ofkP3om^h0203om^h01@3D?AT0?EV[0=@m6@3D?AT0ooK^00<0e3dI0P3om^h020000000
=Pl803H?200f3`P0000003H?200mFJ/000000P1G60`00`000000EaP<03eIZ`0303eIZ`80EaP<00D0
000007PR401h8Q00N28@0000000607PR4080000000<0TbXC03eIZ`2C:Q<00P2C:Q<00`000000TbXC
09<Z4`0409<Z4`040000002C:Q<0TbXC000000<0ZC4F00<000000:Ta5P2Y<AH0102Y<AH01`000000
?EV[0:Ta5P2Y<AH000000;`g600000000`0mFJ/00`2l=aP000000;`g60040;`g60030000002l=aP0
_3LH0080_3LH0P0000030<hl6P030000003D?AT0BfkD0080BfkD00L0000004]^e000000000000=@m
6@1:K=00000000D0BVc@00<0000004Y/d01:K=00101:K=0010000000BVc@04Y/d01:K=020=@m6@04
04Y/d0000000BVc@0=@m6@@0BVc@00<0000004Y/d01:K=001@1:K=03000000H0BFW;00<0000004UY
b`3D?AT01@19JL/010000000e3dI0=@m6@3D?AT504UYb`0300000019JL/0BFW;0080BFW;00<0e3dI
04UYb`19JL/00P19JL/00`000000BFW;04UYb`0204UYb`<000000P18I/@010000000B6K404QVa03D
?AT604QVa00300000018I/@0B6K40080B6K400<0e3dI04QVa018I/@00P18I/@20=@m6A00ooK^00<0
?EV[0?ofkP3om^h00P3om^h303eIZ`/0ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?of
kP080?ofkP<0?EV[103om^h00`0mFJ/0ooK^0?ofkP0P0?ofkP<00000903om^h00`000000ooK^0?of
kP050?ofkP40oooo000`0?ofkP030000003om^h0ooK^01X0ooK^00<0?EV[0?ofkP3om^h00`3om^h3
03eIZ`@0ooK^00<000000?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkPH0?EV[1@3om^h0
0`0mFJ/0ooK^0?ofkP090?ofkP030=@m6@0mFJ/0e3dI0080e3dI0P3om^h0103D?AT0ooK^0=@m6@00
000303H?20030000000mFJ/0000000<0EaP<00<0000005LH301G60`00`1G60`303eIZ`<0N28@00<0
000007PR401h8Q00101h8Q0010000000TbXC09<Z4`0mFJ/409<Z4`030000002C:Q<0TbXC00<0TbXC
00<000000=@m6@0000001@2Y<AH00`000000ZC4F0:Ta5P030:Ta5P0703eIZ`2Y<AH0ZC4F0:Ta5P00
0000_3LH000000030;`g60<0?EV[1@2l=aP01@000000_3LH0;`g602l=aP000000080cS`J00D0?EV[
0<hl6P000000BfkD0=@m6@0204]^e0050000001;K]@0BfkD0=@m6@1;K]@00`00000404Y/d0030000
001:K=00BVc@00@0BVc@00<0000004Y/d01:K=000`1:K=000`3D?AT0BVc@0=@m6@0504Y/d0030000
001:K=00BVc@00H0BVc@00<0000004Y/d00000000`0000001019JL/0000004UYb`3D?AT604UYb`04
00000019JL/0BFW;04UYb`<0e3dI0P19JL/01@000000BFW;04UYb`19JL/0e3dI00@0BFW;00<00000
04UYb`19JL/01P19JL/30000000304QVa03D?AT0B6K400D0B6K400@0000004QVa018I/@0B6K40P3D
?AT204QVa0@0e3dI4@3om^h00`0mFJ/0ooK^0?ofkP050?ofkP80?EV[2@3om^h00`0mFJ/0ooK^0?of
kP0?0?ofkP0303eIZ`3om^h0ooK^00/0ooK^0`0mFJ/00`3om^h0?EV[0?ofkP0T0?ofkP8000008`3o
m^h00`000000ooK^0?ofkP040?ofkP40oooo000_0?ofkP030000003om^h0ooK^01/0ooK^00<0?EV[
0?ofkP3om^h01P3om^h403eIZ`030000003om^h0ooK^00@0ooK^0P0mFJ/C0?ofkPH0?EV[0P3om^h0
0`0mFJ/0ooK^0?ofkP080?ofkP030=@m6@0mFJ/0e3dI0080e3dI0`3om^h20=@m6@030?ofkP000000
=Pl80080=Pl800<0000003eIZ`1G60`00`1G60`00`000000EaP<05LH300305LH30030000001h8Q00
N28@00<0?EV[00<0N28@0000001h8Q000`1h8Q0010000000TbXC0000000mFJ/609<Z4`030000002C
:Q<0TbXC00<0TbXC00<000000:Ta5P2Y<AH0102Y<AH00`000000ZC4F0:Ta5P030:Ta5P0403eIZ`00
0000ZC4F000000<0_3LH00<000000;`g602l=aP00P2l=aP010000000?EV[03eIZ`0mFJ/20;`g6003
0000002l=aP0_3LH0080000000D0cS`J03eIZ`3>?1X0cS`J0000000204]^e0050=@m6@1;K]@0BfkD
0000003D?AT00`1;K]@00`000000BfkD000000020000000304Y/d0000000BVc@00@0BVc@00<00000
04Y/d01:K=00101:K=000`000000e3dI04Y/d00504Y/d0030000001:K=00BVc@00D0BVc@00<00000
04Y/d01:K=00101:K=02000000030=@m6@19JL/0BFW;00@0BFW;00<0000004UYb`19JL/01@19JL/3
0=@m6@80BFW;00<0e3dI04UYb`19JL/00P19JL/00`000000BFW;04UYb`0704UYb`0500000019JL/0
e3dI0=@m6@0000001@18I/@01@000000B6K404QVa018I/@0e3dI0080B6K41@3D?ATB0?ofkP0303eI
Z`3om^h0ooK^00L0ooK^0`0mFJ/60?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h0
3P3om^h203eIZbL0ooK^0`00000P0?ofkP030000003om^h0ooK^00@0ooK^0@3oool002l0ooK^00<0
00000?ofkP3om^h0703om^h00`0mFJ/0ooK^0?ofkP080?ofkP040000000mFJ/0?EV[03eIZ`<0ooK^
00<0?EV[0?ofkP0mFJ/0503om^h00`0mFJ/0ooK^03eIZ`0503eIZ`T0ooK^00@0e3dI0?ofkP0mFJ/0
e3dI103om^h20=@m6@80ooK^00D0000003H?200f3`P0=Pl803eIZ`0605LH30070000001G60`0EaP<
05LH30000000N28@0000000407PR40@0?EV[00H0N28@0000002C:Q<0TbXC0000000mFJ/609<Z4`03
0000002C:Q<0TbXC0080TbXC00<000000:Ta5P0000001P2Y<AH02@000000ZC4F0:Ta5P2Y<AH0?EV[
0:Ta5P000000ZC4F000000030;`g60030000002l=aP0_3LH00<0_3LH00<000000;`g602l=aP00`0m
FJ/200000080cS`J00<0000003eIZ`3>?1X00P3>?1X01P000000BfkD04]^e03D?AT0BfkD0=@m6@@0
BfkD00<0000004]^e01;K]@00P1;K]@3000000@0BVc@00<0000004Y/d01:K=00101:K=00103D?AT0
BVc@0=@m6@3D?AT304Y/d0030000001:K=00BVc@00H0BVc@00<0000004Y/d01:K=00101:K=000`00
0000e3dI04Y/d00400000080BFW;00<0000004UYb`19JL/01P19JL/00`000000BFW;0=@m6@040=@m
6@0304UYb`000000BFW;00P0BFW;00<0000004UYb`3D?AT00`19JL/300000080B6K400<0000004QV
a018I/@0103D?AT01018I/@0e3dI0=@m6@0mFJ/C0?ofkP0303eIZ`3om^h0ooK^00X0ooK^0`0mFJ/3
0?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP0X
0?ofkP<000007@3om^h00`000000ooK^0?ofkP040?ofkP40oooo000_0?ofkP030000003om^h0ooK^
01`0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`000000ooK^0?ofkP020?ofkP@0?EV[00<0ooK^03eI
Z`3om^h04`3om^h00`0mFJ/0ooK^0?ofkP020?ofkPH0?EV[1@3om^h01@3D?AT0ooK^0=@m6@0mFJ/0
e3dI00@0ooK^00D0e3dI0?ofkP3om^h0ooK^0000000203H?200303eIZ`000000e3dI00D0EaP<00@0
000005LH301G60`000000P1h8Q000`000000N28@07PR400407PR40030000001h8Q00?EV[0080?EV[
00<0TbXC03eIZ`0000001`2C:Q<010000000TbXC09<Z4`0000020:Ta5P030000002Y<AH0ZC4F00@0
ZC4F00D000000:Ta5P2Y<AH0ZC4F03eIZ`020:Ta5P030000002l=aP0_3LH00<0_3LH00<000000;`g
602l=aP00P2l=aP00`000000_3LH0;`g60030;`g60<0?EV[00<0cS`J03eIZ`3>?1X00`3>?1X01P00
0000BfkD04]^e01;K]@0e3dI000000@0BfkD00<0000004]^e01;K]@00`1;K]@00`000000BfkD0000
00020000000304Y/d0000000BVc@00@0BVc@00<0e3dI0000001:K=000P1:K=020=@m6@0304Y/d000
0000BVc@00H0BVc@00<0000004Y/d01:K=00101:K=020=@m6@H0BVc@0`00000704UYb`0400000019
JL/0BFW;0=@m6@@0BFW;203D?AT304UYb`030000003D?AT0BFW;00@0BFW;203D?AT404QVa0030=@m
6@0mFJ/0ooK^0180ooK^00<0?EV[0?ofkP3om^h03P3om^h203eIZ`030?ofkP0mFJ/0ooK^0100ooK^
00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP0[0?ofkP8000006`3om^h00`000000ooK^
0?ofkP040?ofkP40oooo000_0?ofkP030000003om^h0ooK^01`0ooK^00<0?EV[0?ofkP3om^h01`3o
m^h00`000000ooK^0?ofkP040?ofkPD0?EV[4`3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00<0ooK^
1`0mFJ/40=@m6@0303eIZ`3om^h0ooK^0080ooK^0P3D?AT30?ofkP060000000f3`P0=Pl803eIZ`1G
60`000001@1G60`010000000EaP<05LH3000000307PR40030000001h8Q00N28@00<0N28@00<00000
07PR400000000P2C:Q<303eIZ`030000002C:Q<0TbXC00@0TbXC00<0000009<Z4`000000102Y<AH0
0`000000ZC4F0:Ta5P040:Ta5P030000002Y<AH0?EV[0080ZC4F00<000000;`g60000000102l=aP0
0`000000_3LH0;`g60030;`g60040000002l=aP0_3LH0;`g608000000P3>?1X303eIZ`<0cS`J00D0
000004]^e03D?AT0e3dI04]^e0020=@m6@<0BfkD00<0000004]^e01;K]@00`1;K]@00`000000BfkD
04]^e00204]^e0<000000`1:K=000`3D?AT0000004Y/d00504Y/d080e3dI1`1:K=000`000000BVc@
04Y/d00304Y/d0030=@m6@000000BVc@00H0BVc@00<0000004Y/d01:K=000P00000404UYb`040000
0019JL/0BFW;0=@m6@D0BFW;00<0000004UYb`19JL/01@19JL/:0=@m6@80BFW;00D0000004UYb`19
JL/0e3dI0000000404QVa0030=@m6@000000?EV[01<0ooK^00<0?EV[0?ofkP3om^h0403om^h303eI
Za00ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP0]0?ofkP<00000603om^h00`00
0000ooK^0?ofkP040?ofkP40oooo000_0?ofkP030000003om^h0ooK^01`0ooK^0P0mFJ/70?ofkP03
0000003om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h01P0mFJ/@0?ofkP0503eIZ`3om^h0ooK^0?of
kP0mFJ/01`3om^h603eIZ`030=@m6@0mFJ/0ooK^00<0ooK^0P3D?AT30?ofkP030000000f3`P0?EV[
0080EaP<00<0000005LH301G60`0101G60`2000000@0N28@00<0000007PR401h8Q00101h8Q001@00
0000TbXC09<Z4`2C:Q<0?EV[0080TbXC0`0mFJ/509<Z4`030000002Y<AH0ZC4F00@0ZC4F00<00000
0:Ta5P2Y<AH0102Y<AH0100mFJ/0ZC4F0:Ta5P0000020;`g60030000002l=aP0_3LH00<0_3LH00<0
00000;`g602l=aP00P2l=aP010000000_3LH0;`g600000020<hl6P050000003>?1X0?EV[0<hl6P00
0000100mFJ/01`3D?AT0BfkD04]^e01;K]@0000004]^e03D?AT00P1;K]@00`000000BfkD04]^e003
04]^e0030000001;K]@0BfkD00<0BfkD00L0000004]^e000000000000=@m6@1:K=00000000L0BVc@
00<000000=@m6@3D?AT0101:K=000`000000BVc@04Y/d00304Y/d0030=@m6@000000BVc@00L0BVc@
00<0000004Y/d01:K=000P1:K=0200000080BFW;00<0000004UYb`3D?AT01@19JL/00`000000BFW;
04UYb`0704UYb`030000003D?AT0BFW;00L0BFW;00@0000004UYb`19JL/0e3dI0P19JL/200000080
e3dI00<0000003eIZ`0mFJ/04`3om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP0303eIZ`3om^h0?EV[0080
?EV[3@3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^0340ooK^0`00000F0?ofkP03
0000003om^h0ooK^00<0ooK^0@3oool002h0ooK^00<000000?ofkP3om^h07@3om^h00`0mFJ/0ooK^
03eIZ`0203eIZ`<0ooK^00<000000?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eI
Z`3om^h0?EV[00D0?EV[3@3om^h0100mFJ/0ooK^0?ofkP0mFJ/:0?ofkP030=@m6@0mFJ/0?EV[00@0
?EV[0P3om^h00`3D?AT0ooK^0=@m6@030?ofkP80000000@0?EV[05LH301G60`000001P1G60`00`00
0000N28@07PR400407PR40030000001h8Q00N28@0080N28@00<0000009<Z4`0000000P2C:Q<01P0m
FJ/0TbXC09<Z4`2C:Q<0000009<Z4`<0?EV[00@0TbXC0000002Y<AH000001@2Y<AH00`000000ZC4F
0:Ta5P040:Ta5P0303eIZ`2Y<AH0000000@0_3LH00<000000;`g602l=aP00`2l=aP00`000000_3LH
0;`g60020;`g608000000`3>?1X01@000000cS`J03eIZ`3>?1X0000000@0cS`J00<0000004]^e01;
K]@00P1;K]@01@000000BfkD0=@m6@1;K]@0000000D0BfkD00<0000004]^e01;K]@00`1;K]@01@00
0000BfkD04]^e03D?AT0BfkD00<000001@1:K=0010000000BVc@04Y/d01:K=020=@m6@80BVc@00<0
000004Y/d01:K=000P1:K=000`3D?AT0BVc@0000000704Y/d0030000001:K=00BVc@00D0BVc@0`00
00000`3D?AT0BFW;04UYb`0304UYb`0300000019JL/0BFW;00L0BFW;00<000000=@m6@19JL/01`19
JL/010000000BFW;0=@m6@3D?AT404UYb`030=@m6@000000000000@0?EV[4P3om^h00`0mFJ/0ooK^
0?ofkP0@0?ofkP0303eIZ`3om^h0ooK^00<0ooK^0`0mFJ/:0?ofkP0303eIZ`3om^h0ooK^00h0ooK^
00<0?EV[0?ofkP3om^h0=03om^h2000001@0ooK^00<000000?ofkP3om^h00`3om^h10?ooo`00;P3o
m^h00`000000ooK^0?ofkP0N0?ofkP0403eIZ`3om^h0ooK^0?ofkP80?EV[00<000000?ofkP3om^h0
0`3om^h203eIZ`H0ooK^00<0?EV[0?ofkP3om^h00P3om^h503eIZ`X0ooK^00<0?EV[0?ofkP0mFJ/0
2P3om^h20=@m6@030?ofkP3D?AT0ooK^00L0?EV[00H0e3dI0?ofkP3om^h0ooK^0000000mFJ/405LH
30030000001G60`0EaP<0080EaP<0P00000607PR40050000001h8Q00N28@07PR400000000P2C:Q<0
0`000000TbXC03eIZ`0509<Z4`040000002C:Q<0TbXC09<Z4`<0?EV[00<000000:Ta5P2Y<AH0102Y
<AH00`000000ZC4F0:Ta5P020:Ta5P0303eIZ`2Y<AH0000000H0_3LH00<000000;`g602l=aP00P2l
=aP00`000000_3LH0;`g60020;`g60030000003>?1X0cS`J00<0cS`J00@0?EV[0<hl6P3>?1X00000
103>?1X00`000000BfkD04]^e00204]^e0030000001;K]@0BfkD0080e3dI1@1;K]@00`000000BfkD
04]^e00304]^e0030000001;K]@0e3dI00<0BfkD00<0000004]^e00000000`0000000`1:K=000000
04Y/d00404Y/d080e3dI00L0000004Y/d01:K=00BVc@0=@m6@1:K=00000000L0BVc@00<0000004Y/
d01:K=001P1:K=000`000000BVc@0=@m6@0400000080BFW;00<0000004UYb`19JL/01P19JL/20=@m
6@P0BFW;00<0000004UYb`3D?AT01@19JL/0203D?AT0BFW;0000003om^h0?EV[0?ofkP0mFJ/0ooK^
0P0mFJ/?0?ofkP0303eIZ`3om^h0ooK^0140ooK^00<0?EV[0?ofkP3om^h01P3om^h203eIZ`L0ooK^
00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP0f0?ofkP<000004@3om^h00`000000ooK^
0?ofkP030?ofkP40oooo000^0?ofkP030000003om^h0ooK^01h0ooK^00<0?EV[0?ofkP3om^h00`3o
m^h01P000000?EV[03eIZ`0mFJ/0ooK^03eIZ`P0ooK^00<0?EV[0?ofkP3om^h01@3om^h503eIZ`L0
ooK^0P0mFJ/:0?ofkP@0e3dI0P3om^h00`3D?AT0?EV[0?ofkP0703eIZ`030?ofkP000000?EV[00@0
EaP<00D0000005LH301G60`0EaP<0000000207PR40030000001h8Q00N28@00@0N28@00@0000007PR
401h8Q0000000`2C:Q<00`0mFJ/0TbXC09<Z4`0509<Z4`040000002C:Q<0TbXC00000080ZC4F0`0m
FJ/50:Ta5P080000002Y<AH0ZC4F0:Ta5P0mFJ/000000;`g600000050;`g60030000002l=aP0_3LH
00<0_3LH00H000000;`g602l=aP000000<hl6P0000040<hl6P0503eIZ`3>?1X0cS`J0<hl6P000000
0`3>?1X00`000000BfkD04]^e00204]^e0030000001;K]@0BfkD0080BfkD00<0e3dI04]^e01;K]@0
0P1;K]@00`000000BfkD04]^e00304]^e0030000003D?AT0BfkD00<0BfkD00<0000004]^e01;K]@0
0`1;K]@2000000H0BVc@00D000000=@m6@3D?AT0BVc@0=@m6@0204Y/d0030000001:K=00BVc@00@0
BVc@00<0000004Y/d01:K=001P1:K=000`000000e3dI0=@m6@0504Y/d0<000001`19JL/00`3D?AT0
BFW;04UYb`0704UYb`0300000019JL/0e3dI00@0BFW;0P3D?AT200000080ooK^0P0mFJ/40?ofkP<0
?EV[303om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP0303eIZ`3om^h0ooK^00P0ooK^0`0mFJ/40?ofkP03
03eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h0>@3om^h2000000l0ooK^00<000000?ofkP3o
m^h00`3om^h10?ooo`00;P3om^h00`000000ooK^0?ofkP0O0?ofkP0503eIZ`3om^h0ooK^0?ofkP00
00000`3om^h503eIZ`H0ooK^00<0?EV[0?ofkP3om^h0203om^h503eIZ`@0ooK^0P0mFJ/90?ofkP@0
e3dI0`3om^h0103D?AT0?EV[0?ofkP3D?AT30?ofkPH0?EV[101G60`010000000EaP<05LH30000003
07PR40030000001h8Q00N28@00@0N28@00<0000007PR40000000102C:Q<00`0mFJ/0000009<Z4`05
09<Z4`030000002C:Q<0000000D0ZC4F00@0000003eIZ`0mFJ/0?EV[0`2Y<AH010000000ZC4F03eI
Z`0000030;`g60030000002l=aP0_3LH00<0_3LH00<000000;`g602l=aP00P2l=aP00`000000_3LH
000000020<hl6P070000003>?1X0cS`J0<hl6P0mFJ/0cS`J000000020<hl6P050000003>?1X0cS`J
0<hl6P000000101;K]@00`000000BfkD04]^e00204]^e0030000003D?AT0e3dI0080BfkD00<00000
04]^e01;K]@00`1;K]@00`3D?AT0BfkD04]^e00304]^e0030000001;K]@0BfkD00@0BfkD0`000004
04Y/d0030000001:K=00BVc@0080e3dI00<0BVc@0000001:K=001P1:K=000`000000BVc@04Y/d005
04Y/d0030000003D?AT0BVc@00H0BVc@00<0000004Y/d01:K=000P00000404UYb`030=@m6@000000
BFW;00L0BFW;00<0000004UYb`3D?AT01019JL/00`3D?AT0BFW;000000030?ofkP0303eIZ`3om^h0
?EV[00L0ooK^0P0mFJ/:0?ofkP0303eIZ`3om^h0ooK^0140ooK^00<0?EV[0?ofkP3om^h02`3om^h3
03eIZ`030?ofkP0mFJ/0ooK^0100ooK^00<0?EV[0?ofkP3om^h0>`3om^h3000000d0ooK^00<00000
0?ofkP3om^h00P3om^h10?ooo`00;P3om^h00`000000ooK^0?ofkP0O0?ofkP80?EV[00@0ooK^0000
003om^h0ooK^0P0mFJ/30?ofkPD0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP@0?EV[00<0ooK^
03eIZ`3om^h02@3om^h0103D?AT0ooK^0=@m6@3D?AT30?ofkP030=@m6@0mFJ/0e3dI00D0ooK^00<0
e3dI0?ofkP0mFJ/01@0mFJ/205LH308000001@1h8Q000`000000N28@07PR400407PR40030000002C
:Q<0TbXC0080TbXC00<0?EV[09<Z4`0000001`2C:Q<00`000000ZC4F0:Ta5P040:Ta5P040000002Y
<AH0ZC4F0:Ta5P<0?EV[00<000000:Ta5P0mFJ/0102l=aP00`000000_3LH0;`g60030;`g60030000
002l=aP0_3LH00<0_3LH00<000000<hl6P3>?1X00P3>?1X01P000000cS`J0<hl6P0mFJ/0cS`J0000
00<0cS`J00D000000<hl6P3>?1X0cS`J0000000404]^e0050000001;K]@0BfkD04]^e00000000P1;
K]@00`3D?AT0BfkD0000000404]^e0030=@m6@000000BfkD00<0BfkD00<0000004]^e01;K]@0101;
K]@010000000BfkD04]^e01;K]@20000000504Y/d0000000BVc@04Y/d03D?AT00P1:K=030=@m6@D0
BVc@00<0000004Y/d01:K=001@1:K=000`000000e3dI04Y/d00604Y/d0030000001:K=00BVc@00<0
BVc@0P0000000`19JL/0e3dI0000000804UYb`0300000019JL/0e3dI00<0BFW;0P3D?AT00`19JL/0
00000?ofkP030?ofkP80?EV[2P3om^h303eIZ`L0ooK^00<0?EV[0?ofkP3om^h0403om^h00`0mFJ/0
ooK^0?ofkP0?0?ofkP<0?EV[403om^h00`0mFJ/0ooK^0?ofkP0n0?ofkP<000002P3om^h00`000000
ooK^0?ofkP020?ofkP40oooo000]0?ofkP030000003om^h0ooK^0280ooK^00@0000003eIZ`0mFJ/0
?EV[203om^h503eIZ`030?ofkP0mFJ/0ooK^00l0ooK^100mFJ/80?ofkP040=@m6@3om^h0e3dI0=@m
6@@0ooK^00<0e3dI03eIZ`3om^h01@3om^h01@3D?AT0?EV[0?ofkP3om^h0e3dI00<0EaP<0`0mFJ/6
07PR40030000001h8Q00N28@00<0N28@00<0000009<Z4`0000000P2C:Q<01@0mFJ/0TbXC09<Z4`2C
:Q<0000000D0TbXC00<000000:Ta5P0000001P2Y<AH00`000000ZC4F0:Ta5P030:Ta5P<0?EV[1@2l
=aP00`000000_3LH0;`g60030;`g60070000002l=aP0_3LH0;`g60000000cS`J000000030<hl6P03
0000003>?1X0?EV[00<0cS`J00@000000<hl6P3>?1X000000`3>?1X300000080BfkD00D0000004]^
e01;K]@0BfkD0000000304]^e0030=@m6@000000BfkD0080BfkD00<0e3dI0000001;K]@0101;K]@0
0`000000BfkD04]^e00404]^e0030000001;K]@0BfkD00<0BfkD0`0000001@3D?AT0BVc@04Y/d01:
K=0000000080BVc@0`3D?AT00`1:K=00000004Y/d00604Y/d0030000003D?AT0BVc@00H0BVc@00<0
000004Y/d01:K=001P1:K=000`3D?AT000000000000704UYb`0300000019JL/0e3dI0080BFW;0`3D
?AT00`19JL/000000?ofkP040?ofkP80?EV[3@3om^h303eIZ`<0ooK^00<0?EV[0?ofkP3om^h04@3o
m^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0303eIZ`3om^h0?EV[0080?EV[3@3om^h00`0mFJ/0ooK^0?of
kP110?ofkP800000203om^h00`000000ooK^0?ofkP020?ofkP40oooo000]0?ofkP030000003om^h0
ooK^0280ooK^00@000000?ofkP3om^h0ooK^100mFJ/80?ofkP@0?EV[3`3om^h00`0mFJ/0ooK^03eI
Z`0403eIZ`@0ooK^00@0e3dI0?ofkP3om^h0e3dI103om^h20=@m6@0303eIZ`3om^h0ooK^00@0ooK^
00D0?EV[0?ofkP3om^h0e3dI0000000405LH30030000001h8Q00?EV[0080?EV[101h8Q001@000000
N28@07PR401h8Q0000000080TbXC00@0000009<Z4`2C:Q<0?EV[102C:Q<00`000000TbXC09<Z4`02
000000<0ZC4F00<000000:Ta5P2Y<AH0102Y<AH00`000000ZC4F0:Ta5P020:Ta5P0303eIZ`2l=aP0
000000<0?EV[0`2l=aP00`000000_3LH0;`g60030;`g60030000002l=aP000000080cS`J00<00000
0<hl6P3>?1X00P3>?1X00`000000?EV[0<hl6P020<hl6P040000003>?1X0cS`J00000080cS`J0P00
000204a_f0<000000`1;K]@00`000000BfkD04]^e00204]^e080e3dI00@0BfkD0=@m6@1;K]@00000
1@1;K]@00`000000BfkD04]^e00304]^e0030000001;K]@0BfkD00@0BfkD00@0000004]^e03D?AT0
BfkD1000000504Y/d0<0e3dI1P1:K=000`3D?AT0BVc@04Y/d00504Y/d0030000001:K=00BVc@00H0
BVc@00@0e3dI0000001:K=00BVc@1000000204UYb`040000003D?AT0e3dI04UYb`80e3dI00@0BFW;
0=@m6@19JL/000001@3om^h00`0mFJ/0ooK^03eIZ`0@0?ofkP80?EV[00<0ooK^03eIZ`3om^h04P3o
m^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0303eIZ`3om^h0ooK^0080ooK^0`0mFJ/:0?ofkP0303eIZ`3o
m^h0ooK^04<0ooK^0`0000050?ofkP030000003om^h0ooK^0080ooK^0@3oool002d0ooK^00<00000
0?ofkP3om^h08@3om^h00`000000ooK^0?ofkP050?ofkP@0?EV[1`3om^h603eIZ`X0ooK^00D0?EV[
0?ofkP3om^h0ooK^03eIZ`020?ofkPD0?EV[0P3om^h20=@m6@@0ooK^0P3D?AT00`3om^h0?EV[0?of
kP030?ofkP0403eIZ`3D?AT0ooK^0=@m6@80ooK^00@0000005LH301G60`000000P1h8Q000`000000
N28@07PR400403eIZ`040000001h8Q00N28@000000@0TbXC00<0000003eIZ`2C:Q<0102C:Q<00`00
0000TbXC000000050:Ta5P030000002Y<AH0ZC4F00D0ZC4F00D000000:Ta5P2Y<AH0000003eIZ`02
0;`g60030000002l=aP0_3LH00<0?EV[00<0_3LH0000002l=aP00`2l=aP00`000000_3LH00000003
0<hl6P050000003>?1X0cS`J0<hl6P0mFJ/01@3>?1X00`000000cS`J0<hl6P0200000080gD4L00@0
000004a_f01<KmP0C6oH0`0000000`1;K]@0000004]^e00304]^e0030000001;K]@0e3dI0080BfkD
00<0000004]^e01;K]@00`1;K]@00`000000BfkD04]^e00304]^e0030000001;K]@0BfkD00@0BfkD
00<000000=@m6@1;K]@00P1;K]@00`000000BfkD04]^e00300000080BVc@00<0000004Y/d01:K=00
0`3D?AT204Y/d0030=@m6@1:K=00BVc@00D0BVc@00<0000004Y/d01:K=001@1:K=020=@m6@030000
001:K=00BVc@00D0BVc@0P000000103D?AT0BFW;0=@m6@3D?AT204UYb`030=@m6@000000000000H0
ooK^0P0mFJ/C0?ofkP<0?EV[4P3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00H0
ooK^0P0mFJ/70?ofkP0303eIZ`3om^h0ooK^04L0ooK^0`0000030?ofkP040000003om^h0ooK^0?of
kP40oooo000]0?ofkP030000003om^h0ooK^0200ooK^00<000000?ofkP3om^h02@3om^h503eIZ`@0
ooK^00<0?EV[0?ofkP3om^h01@0mFJ/50?ofkP80?EV[103om^h00`0mFJ/0ooK^0?ofkP030?ofkPD0
?EV[1@3om^h0103D?AT0ooK^0?ofkP0mFJ/40?ofkP0403eIZ`3D?AT0ooK^0=@m6@80ooK^00@00000
05LH301G60`000000`1h8Q000`000000N28@07PR400307PR40<0?EV[1@2C:Q<00`0mFJ/0000009<Z
4`0509<Z4`030000002Y<AH0ZC4F00D0ZC4F00<000000:Ta5P2Y<AH0102Y<AH010000000ZC4F0000
000mFJ/30;`g60030000002l=aP0_3LH00<0_3LH0`0mFJ/40;`g60030000003>?1X0cS`J00<0cS`J
00D000000<hl6P3>?1X0?EV[000000040<hl6P040000003>?1X0cS`J000000<0gD4L00D0000004a_
f01<KmP0C6oH0000000204a_f0@000000P1;K]@00`000000e3dI04]^e0020=@m6@030000001;K]@0
BfkD00<0BfkD00<0000004]^e01;K]@00P1;K]@00`000000BfkD04]^e00404]^e0030000003D?AT0
BfkD00<0BfkD00<0000004]^e01;K]@00`1;K]@3000000D0BVc@1@3D?AT404Y/d0030000001:K=00
BVc@00D0BVc@00<0e3dI0000001:K=00201:K=0010000000e3dI0=@m6@3D?AT200000080e3dI0P00
00070?ofkP80?EV[503om^h00`0mFJ/0ooK^03eIZ`0203eIZ`h0ooK^00<0?EV[0?ofkP3om^h0403o
m^h00`0mFJ/0ooK^0?ofkP080?ofkP<0?EV[103om^h00`0mFJ/0ooK^0?ofkP1:0?ofkP80000000<0
ooK^0000003om^h00P3om^h10?ooo`00;@3om^h00`000000ooK^0?ofkP0P0?ofkP030000003om^h0
ooK^00`0ooK^1`0mFJ/60?ofkPH0?EV[1P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP030=@m6@3om^h0
ooK^00D0?EV[00<0ooK^0=@m6@3D?AT00P3om^h01P0mFJ/0ooK^0?ofkP3om^h0?EV[0?ofkP80e3dI
103om^h2000000@0N28@00<0000007PR401h8Q00101h8Q000`000000TbXC03eIZ`0203eIZ`80TbXC
00<0?EV[0000002C:Q<0102C:Q<00`000000ZC4F000000070:Ta5P030000002Y<AH0ZC4F00@0ZC4F
00<0000003eIZ`2l=aP0102l=aP00`000000_3LH0;`g60040;`g60030000000mFJ/0?EV[0080?EV[
00<0cS`J0000003>?1X00`3>?1X00`000000cS`J03eIZ`020<hl6P030000003>?1X0cS`J0080cS`J
0`0000040=e170050000001<KmP0C6oH04a_f00000000P1<KmP00`000000C6oH04a_f00200000003
0=@m6@000000BfkD0080BfkD0P3D?AT404]^e0030000001;K]@0BfkD0080BfkD00<0000004]^e01;
K]@00`1;K]@20=@m6@@0BfkD00<0000004]^e01;K]@0101;K]@00`000000BfkD04]^e00300000080
BVc@00<0e3dI04Y/d01:K=000P1:K=070=@m6@@0BVc@00<0e3dI0000001:K=000`1:K=080=@m6@<0
BVc@00@0e3dI00000000000000001`3om^h00`0mFJ/0ooK^03eIZ`0C0?ofkP0303eIZ`3om^h0ooK^
00<0ooK^0`0mFJ/;0?ofkP0303eIZ`3om^h0ooK^0100ooK^00<0?EV[0?ofkP3om^h02`3om^h303eI
Z`030?ofkP0mFJ/0ooK^04d0ooK^0P0000030?ofkP40oooo000/0?ofkP030000003om^h0ooK^0200
ooK^00<000000?ofkP3om^h04@3om^h503eIZ`L0ooK^1@0mFJ/40?ofkP0303eIZ`3om^h0ooK^00<0
ooK^00D0e3dI0?ofkP3D?AT0ooK^0=@m6@020?ofkPD0?EV[00D0ooK^03eIZ`3om^h0ooK^03eIZ`02
0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0000007PR401h8Q00101h8Q000`000000N28@07PR4002
07PR40030000002C:Q<0000000<0TbXC0`0mFJ/00`2C:Q<0000009<Z4`0209<Z4`050000002Y<AH0
ZC4F0:Ta5P0000001`2Y<AH00`000000ZC4F0:Ta5P020:Ta5P030000000mFJ/0000000H0_3LH00<0
00000;`g602l=aP0102l=aP010000000_3LH0000003>?1X303eIZ`@0cS`J00D0000003eIZ`3>?1X0
cS`J000000040<hl6P040000003M@A`0gD4L000000<0gD4L00D0000004a_f01<KmP0C6oH00000002
04a_f0070000001<KmP0C6oH04a_f03D?AT0000004a_f0020000000304]^e0000000BfkD0080e3dI
00<0BfkD0000001;K]@0101;K]@00`000000BfkD04]^e00204]^e0030=@m6@000000BfkD00<0BfkD
00<0000004]^e01;K]@01@1;K]@00`000000BfkD04]^e00304]^e0030000003D?AT0000000H0BVc@
00<0000004Y/d01:K=000P1:K=0:0=@m6@<0BVc@00<0000004Y/d03D?AT0101:K=001@3D?AT00000
000000000000ooK^00<0?EV[103om^h203eIZa@0ooK^00<0?EV[0?ofkP3om^h01P3om^h303eIZ`P0
ooK^00<0?EV[0?ofkP3om^h0403om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP80?EV[C@3om^h2000000@0
ooK^0@3oool002`0ooK^00<000000?ofkP3om^h07`3om^h00`000000ooK^0?ofkP0E0?ofkPD0?EV[
00@0ooK^03eIZ`0mFJ/0?EV[0`3om^h603eIZ`030?ofkP0mFJ/0ooK^0080ooK^00<0e3dI0?ofkP3D
?AT00P3om^h0103D?AT0ooK^0?ofkP3D?AT20?ofkPH0?EV[0P3om^h20=@m6@H0ooK^00<0000007PR
401h8Q000`1h8Q001@000000N28@07PR401h8Q00000000<0TbXC00@0000009<Z4`2C:Q<0?EV[0P2C
:Q<403eIZ`0309<Z4`000000ZC4F00<0ZC4F00<000000:Ta5P2Y<AH0102Y<AH02@000000ZC4F0:Ta
5P2Y<AH000000;`g600mFJ/0_3LH000000060;`g60030000002l=aP0_3LH00@0_3LH00<000000<hl
6P3>?1X00P3>?1X01P000000?EV[03eIZ`0mFJ/0cS`J03eIZ`@0cS`J00<000000<hl6P3>?1X00P00
00020=e170050000003M@A`0gD4L0=e1700000000`1<KmP01@000000C6oH04a_f0000000C6oH0080
e3dI00<0C6oH0000001<KmP00P1<KmP300000080BfkD00<0e3dI0000001;K]@00`1;K]@00`000000
BfkD04]^e00204]^e0030=@m6@1;K]@0000000@0BfkD00<0000004]^e01;K]@0101;K]@00`000000
BfkD04]^e00404]^e0030=@m6@1;K]@0BfkD00<000000P1:K=000`000000BVc@04Y/d00504Y/d003
0=@m6@000000BVc@00L0BVc@00<0000004Y/d03D?AT0101:K=00103D?AT000000=@m6@0000050?of
kP80?EV[00@0ooK^03eIZ`3om^h0?EV[4`3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP<0?EV[1@3om^h0
0`0mFJ/0ooK^0?ofkP0@0?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h0BP3om^h0
0`000000ooK^0?ofkP040?ofkP40oooo000/0?ofkP030000003om^h0ooK^01h0ooK^00<000000?of
kP3om^h06@3om^h503eIZ`L0ooK^1P0mFJ/20?ofkP80e3dI0P3om^h0103D?AT0ooK^0?ofkP3D?AT3
0?ofkP030=@m6@3om^h0ooK^00H0?EV[00<0e3dI0?ofkP3om^h0103om^h00`000000N28@07PR4004
07PR40040000001h8Q00N28@000000@0TbXC00<0000003eIZ`2C:Q<0102C:Q<00`000000TbXC03eI
Z`0203eIZ`@0ZC4F00<000000:Ta5P2Y<AH0102Y<AH01@000000ZC4F0000002l=aP0?EV[00<0_3LH
00<000000;`g602l=aP0102l=aP00`000000_3LH0;`g60020;`g60030000003>?1X0000000@0cS`J
00<000000<hl6P3>?1X00`0mFJ/30<hl6P030000003>?1X000000080gD4L00@000000=e1703M@A`0
00000`3M@A`010000000C6oH04a_f000000304a_f0050=@m6@1<KmP0C6oH04a_f0000000101<KmP0
1@000000C6oH000000000000BfkD0080e3dI0`1;K]@01`000000BfkD04]^e01;K]@0e3dI04]^e000
0000101;K]@00`000000BfkD04]^e00404]^e0030000001;K]@0BfkD00@0BfkD00<0e3dI04]^e01;
K]@0101;K]@3000000H0BVc@00<0e3dI0000001:K=001P1:K=0200000080e3dI101:K=0010000000
e3dI03eIZ`0mFJ/80?ofkP<0?EV[503om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP<0?EV[00<0ooK^03eI
Z`3om^h04@3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0303eIZ`3om^h0ooK^04P0ooK^0P0000070?of
kP40oooo000/0?ofkP030000003om^h0ooK^01h0ooK^00<000000?ofkP3om^h0703om^h503eIZ`L0
ooK^1P0mFJ/30?ofkP040=@m6@3om^h0ooK^0=@m6@<0ooK^00<0e3dI0?ofkP3om^h00P0mFJ/00`3o
m^h0?EV[03eIZ`0503eIZ`@0ooK^00<0000007PR401h8Q000`1h8Q000`000000N28@0000000509<Z
4`0303eIZ`000000TbXC00D0TbXC00@000000:Ta5P2Y<AH0ZC4F100mFJ/00`2Y<AH000000:Ta5P05
0:Ta5P030000002l=aP0?EV[00D0_3LH00<000000;`g602l=aP00`2l=aP01@000000_3LH0;`g602l
=aP0000000<0cS`J00<000000<hl6P3>?1X00P3>?1X00`000000cS`J03eIZ`020<hl6P@0?EV[00D0
00000=e1703M@A`0gD4L000000020=e170050000003M@A`0gD4L0=e1700000000`1<KmP010000000
C6oH0=@m6@00000304a_f0030000001<KmP0C6oH0080C6oH00@0000004a_f01<KmP0C6oH0`000002
0=@m6@050000001;K]@0BfkD04]^e03D?AT00P1;K]@00`000000BfkD04]^e00204]^e0030000001;
K]@0BfkD00<0BfkD00<0000004]^e01;K]@0101;K]@00`3D?AT0BfkD04]^e00504]^e0030000001;
K]@0BfkD00<000000P1:K=000`3D?AT0BVc@04Y/d00604Y/d0030000001:K=00e3dI00D0BVc@00<0
00000=@m6@0000000P3om^h303eIZ`H0ooK^0P0mFJ/D0?ofkP0303eIZ`3om^h0ooK^0100ooK^0`0m
FJ/A0?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h0B03om^h00`000000ooK^0?of
kP070?ofkP40oooo000/0?ofkP030000003om^h0ooK^01d0ooK^00<000000?ofkP3om^h0803om^h6
03eIZ`D0ooK^200mFJ/00`3om^h0e3dI0?ofkP030?ofkP060=@m6@3om^h0?EV[0?ofkP0mFJ/0e3dI
103om^h703eIZ`030000001h8Q00N28@00@0N28@00<0000009<Z4`2C:Q<00`2C:Q<0100mFJ/0TbXC
09<Z4`00000409<Z4`030000002Y<AH0000000H0ZC4F0`0mFJ/40:Ta5P030000002l=aP0?EV[00L0
_3LH00<000000;`g602l=aP00`2l=aP00`000000_3LH000000040<hl6P030000003>?1X0cS`J00<0
cS`J00H0?EV[0<hl6P3>?1X0cS`J0000003>?1X2000000<0?EV[0P3M@A`010000000gD4L0=e17000
00020=e170080000001<KmP0C6oH04a_f0000000e3dI04a_f000000304a_f0050000001<KmP0C6oH
04a_f00000001@1<KmP010000000C6oH0000000000020=@m6@0504]^e03D?AT0BfkD04]^e0000000
101;K]@00`000000BfkD04]^e00404]^e0030000001;K]@0BfkD0080BfkD0P3D?AT704]^e0030000
001;K]@0BfkD00@0BfkD00<000000=@m6@0000001`1:K=000`000000BVc@0=@m6@0504Y/d0<00000
1P3om^h203eIZ`@0ooK^0P0mFJ/C0?ofkP0303eIZ`3om^h0ooK^0180ooK^00@0?EV[0?ofkP0mFJ/0
?EV[3`3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^04H0ooK^0P00000:0?ofkP40
oooo000/0?ofkP030000003om^h0ooK^01`0ooK^00<000000?ofkP3om^h0903om^h603eIZ`<0ooK^
00@0?EV[0=@m6@3om^h0ooK^1P0mFJ/30?ofkP80?EV[0P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP04
0=@m6@3om^h0ooK^0?ofkPD0?EV[101h8Q000`000000TbXC0000000309<Z4`0303eIZ`2C:Q<0TbXC
0080TbXC00@0000009<Z4`2C:Q<000000`2Y<AH00`000000ZC4F0:Ta5P060:Ta5P@0?EV[0P2l=aP0
0`0mFJ/00000000000060;`g60030000002l=aP0_3LH00<0_3LH00<000000<hl6P3>?1X0103>?1X0
0`000000cS`J0<hl6P020<hl6P0303eIZ`000000cS`J0080cS`J00H000000=e1703M@A`0gD4L0000
003M@A`403eIZ`030=e170000000gD4L0080gD4L00@0000004a_f01<KmP0e3dI0P1<KmP01@000000
C6oH04a_f01<KmP0000000<0C6oH00<0000004a_f01<KmP00P1<KmP00`000000C6oH04a_f00204a_
f0040000001<KmP0e3dI0=@m6@80BfkD00D0000004]^e01;K]@0BfkD0000000604]^e0030000001;
K]@0BfkD0080BfkD00<0e3dI0000001;K]@01P1;K]@00`000000BfkD04]^e00504]^e0030=@m6@1;
K]@0BfkD00<000000P1:K=020000000304Y/d03D?AT0BVc@00<0BVc@100000090?ofkPD0?EV[503o
m^h00`0mFJ/0ooK^0?ofkP0A0?ofkP0303eIZ`3om^h0ooK^0080ooK^0`0mFJ/<0?ofkP0303eIZ`3o
m^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h0A@3om^h00`000000ooK^0?ofkP0:0?ofkP40oooo000[
0?ofkP030000003om^h0ooK^01d0ooK^00<000000?ofkP3om^h09`3om^h703eIZ`@0ooK^0P3D?AT6
03eIZ`050=@m6@3om^h0ooK^0?ofkP0mFJ/01@3om^h00`3D?AT0ooK^0?ofkP040?ofkP@0?EV[00<0
N28@0000002C:Q<00P2C:Q<00`000000TbXC03eIZ`0609<Z4`030000002C:Q<0000000@0ZC4F00<0
00000:Ta5P2Y<AH01P2Y<AH00`000000ZC4F0000000303eIZ`80_3LH00<000000;`g602l=aP0102l
=aP01`000000_3LH0;`g602l=aP000000<hl6P0000001P3>?1X01P000000cS`J0<hl6P0mFJ/0cS`J
00000080cS`J00<000000=e1700000000`3M@A`01@000000gD4L0=e1703M@A`000000080?EV[00L0
00000=e1703M@A`0000004a_f03D?AT000000080C6oH00D0000004a_f01<KmP0C6oH0000000304a_
f0030000001<KmP0C6oH0080C6oH00L0000004a_f01<KmP0C6oH0000001<KmP0e3dI0080C6oH0`3D
?AT304]^e0030000001;K]@0BfkD00<0BfkD00<0000004]^e01;K]@00P1;K]@00`3D?AT0BfkD0000
000604]^e0030000001;K]@0BfkD00@0BfkD0P3D?AT604]^e0<0000000<0BVc@0=@m6@1:K=000`1:
K=03000000h0ooK^0`0mFJ/B0?ofkP0303eIZ`3om^h0ooK^0180ooK^00<0?EV[0?ofkP3om^h01@3o
m^h203eIZ`X0ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP140?ofkP030000003o
m^h0ooK^00/0ooK^0@3oool002/0ooK^00<000000?ofkP3om^h0703om^h00`000000ooK^0?ofkP0/
0?ofkPD0?EV[0P3om^h00`3D?AT0ooK^0?ofkP020?ofkPL0?EV[00<0ooK^03eIZ`3om^h00`3om^h0
0`3D?AT0ooK^0?ofkP050?ofkP030=@m6@000000N28@00@0?EV[0P2C:Q<00`0mFJ/0TbXC09<Z4`06
09<Z4`030000002Y<AH0ZC4F00@0ZC4F0P0000070:Ta5P030000002l=aP0?EV[0080_3LH0`0mFJ/0
0`000000_3LH0;`g60040;`g60030000002l=aP0000000<0cS`J0P0000050<hl6P030000000mFJ/0
cS`J0080cS`J00<000000<hl6P0000000P3M@A`01@000000gD4L0=e1703M@A`000000080gD4L00<0
00000=e1703M@A`00`0mFJ/01`3M@A`000000=@m6@1<KmP0000004a_f00000000`1<KmP01@000000
C6oH04a_f01<KmP0000000<0C6oH00<0000004a_f01<KmP00P1<KmP00`000000e3dI04a_f00204a_
f0030000001<KmP0C6oH00<0e3dI00<0000004]^e01;K]@00P1;K]@00`000000BfkD04]^e00204]^
e0030=@m6@1;K]@0000000D0BfkD0P00000604]^e0030=@m6@1;K]@0BfkD00D0BfkD0P000000101;
K]@0e3dI0=@m6@00000204Y/d0@000003`3om^h203eIZ`040?ofkP0mFJ/0?EV[03eIZ`l0ooK^00<0
?EV[0?ofkP3om^h04P3om^h00`0mFJ/0ooK^0?ofkP070?ofkP<0?EV[1`3om^h00`0mFJ/0ooK^0?of
kP0?0?ofkP0303eIZ`3om^h0ooK^0480ooK^0P00000>0?ofkP40oooo000[0?ofkP030000003om^h0
ooK^01/0ooK^00<000000?ofkP3om^h0;P3om^h00`3D?AT0ooK^03eIZ`0803eIZ`<0ooK^1`0mFJ/4
0?ofkP030=@m6@3om^h0ooK^00<0ooK^00D0e3dI0?ofkP000000N28@0000000309<Z4`<0?EV[00<0
000009<Z4`2C:Q<0102C:Q<00`000000ZC4F000000070:Ta5P030000002Y<AH0ZC4F00<0ZC4F00@0
00000;`g600mFJ/000001@2l=aP303eIZ`D0_3LH00<000000<hl6P3>?1X0103>?1X00`000000cS`J
0<hl6P020<hl6P0303eIZ`000000cS`J00<0cS`J00D000000=e1703M@A`0gD4L000000030=e17005
0000003M@A`0gD4L0=e1700000000P3M@A`00`000000gD4L0=@m6@020000000504a_f0000000C6oH
04a_f00000000P1<KmP01@000000C6oH04a_f01<KmP0000000<0C6oH00H0000004a_f01<KmP0C6oH
0000003D?AT404a_f0060000001<KmP0C6oH04a_f0000000C6oH0`3D?AT204]^e0070000001;K]@0
BfkD04]^e03D?AT0BfkD0000000504]^e0030000001;K]@0BfkD00D0BfkD00<0e3dI04]^e01;K]@0
101;K]@200000080BfkD00@0e3dI04]^e01;K]@0BfkD1@00000@0?ofkP0303eIZ`3om^h0ooK^00<0
ooK^0`0mFJ/<0?ofkP0303eIZ`3om^h0ooK^0140ooK^00<0?EV[0?ofkP3om^h02`3om^h303eIZ`<0
ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP120?ofkP030000003om^h0ooK^00h0
ooK^0@3oool002/0ooK^00<000000?ofkP3om^h06P3om^h00`000000ooK^0?ofkP0_0?ofkP050=@m
6@3om^h0ooK^0?ofkP3D?AT01P0mFJ/30?ofkP80e3dI0P3om^h603eIZ`030?ofkP3D?AT0ooK^00<0
ooK^00D0e3dI0?ofkP3om^h0ooK^0000000309<Z4`80?EV[0P2C:Q<303eIZ`<0TbXC00D000000:Ta
5P2Y<AH0ZC4F000000070:Ta5P050000002Y<AH0ZC4F0:Ta5P0000000P2l=aP00`0mFJ/0_3LH0000
00060;`g60080000000mFJ/0?EV[03eIZ`2l=aP000000<hl6P0000060<hl6P060000003>?1X0cS`J
03eIZ`3>?1X000000`3>?1X00`000000gD4L000000030=e170050000003M@A`0gD4L0=e170000000
0P3M@A`01@000000gD4L0=e170000000gD4L0080000000H0?EV[000000000000000004a_f0000002
04a_f0050000001<KmP0C6oH04a_f00000000`1<KmP01@000000C6oH04a_f01<KmP0e3dI00@0C6oH
00D0000004a_f01<KmP0C6oH0000000504a_f0<0e3dI00D0000004]^e03D?AT0BfkD0000000504]^
e0030000001;K]@0BfkD00@0BfkD00<000000=@m6@1;K]@0101;K]@2000000<0BfkD0`3D?AT01`1;
K]@00000000000000000e3dI0000000mFJ/03`3om^h203eIZ`P0ooK^0`0mFJ/80?ofkP0303eIZ`3o
m^h0ooK^0180ooK^00<0?EV[0?ofkP3om^h03P3om^h203eIZ`030?ofkP0mFJ/0ooK^0100ooK^00<0
?EV[0?ofkP3om^h0@03om^h200000140ooK^0@3oool002/0ooK^00<000000?ofkP3om^h06P3om^h0
0`000000ooK^0?ofkP0_0?ofkP080=@m6@3om^h0ooK^0?ofkP3D?AT0ooK^0=@m6@3om^h703eIZ`H0
ooK^1`0mFJ/00`3om^h0e3dI0?ofkP040?ofkP030000002C:Q<0?EV[00H0TbXC00D0000003eIZ`0m
FJ/0?EV[000000040:Ta5P030000002Y<AH0ZC4F00D0ZC4F00<000000:Ta5P0000000P2l=aP01@0m
FJ/0_3LH0;`g602l=aP0000000L0_3LH00<000000;`g600mFJ/00P0mFJ/00`3>?1X0000000000005
0<hl6P030000000mFJ/0cS`J0080cS`J00<000000<hl6P0000000`3M@A`01@000000gD4L0=e1703M
@A`000000080gD4L00D000000=e1703M@A`0gD4L000000020=e170040000003/AAh0k4DN000000<0
C73J0`0000001@1<KmP0000004a_f01<KmP0000000<0C6oH00H0000004a_f01<KmP0C6oH0=@m6@00
000304a_f0030000001<KmP0C6oH0080C6oH00<0000004a_f01<KmP00`1<KmP00`000000C6oH04a_
f0050=@m6@@0BfkD00<0000004]^e01;K]@0101;K]@00`000000e3dI04]^e00404]^e0030000001;
K]@0e3dI00@0e3dI00<0BfkD0000000000001000000303eIZ`h0ooK^00<0?EV[0?ofkP3om^h02P3o
m^h303eIZ`D0ooK^00<0?EV[0?ofkP3om^h04P3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP<0?EV[403o
m^h00`0mFJ/0ooK^0?ofkP0o0?ofkP030000003om^h0ooK^0140ooK^0@3oool002X0ooK^00<00000
0?ofkP3om^h06P3om^h00`000000ooK^0?ofkP0`0?ofkP040=@m6@3om^h0ooK^0=@m6@80ooK^00<0
e3dI0?ofkP3om^h00`3om^h603eIZ`<0ooK^00@0?EV[0?ofkP3om^h0ooK^1P0mFJ/50?ofkP0303eI
Z`2C:Q<0TbXC00H0TbXC00<0000009<Z4`0000000`0mFJ/30:Ta5P8000001P2Y<AH010000000_3LH
0;`g600mFJ/50;`g608000001P2l=aP010000000cS`J0<hl6P3>?1X303eIZ`030000003>?1X0cS`J
00<0cS`J00<0?EV[0000003>?1X00P3>?1X00`000000gD4L0=e170030=e170050000003M@A`0gD4L
0=e1700000000P3M@A`01@000000gD4L0=e170000000gD4L008000000P3/AAh00`000000C73J04a`
fP0204a`fP030000001<L=X000000080000000<0C6oH0000001<KmP00P1<KmP01@000000C6oH04a_
f03D?AT0000000@0C6oH00D0000004a_f01<KmP0C6oH0000000504a_f0050000001<KmP0C6oH04a_
f03D?AT00P0000000`1<KmP000000=@m6@060=@m6@<0BfkD00@000000=@m6@1;K]@0BfkD1P3D?AT2
04]^e0060=@m6@1;K]@000000000003oD240?EV[0`0000020?ofkP0303eIZ`3om^h0?EV[0080?EV[
2`3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP<0?EV[00<0ooK^03eIZ`3om^h04`3om^h00`0mFJ/0ooK^
0?ofkP0B0?ofkP0303eIZ`3om^h0?EV[0080?EV[3@3om^h00`0mFJ/0ooK^0?ofkP0m0?ofkP800000
503om^h10?ooo`00:P3om^h00`000000ooK^0?ofkP0I0?ofkP030000003om^h0ooK^0300ooK^00@0
e3dI0?ofkP3om^h0e3dI0`3om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0e3dI00P0?EV[
0`3om^h00`3D?AT0ooK^03eIZ`0703eIZ`040?ofkP000000TbXC03eIZ`H0TbXC00<000000:Ta5P2Y
<AH00P2Y<AH403eIZ`030:Ta5P000000ZC4F00<0ZC4F00@000000;`g60000000?EV[202l=aP00`00
0000_3LH0;`g60020;`g60040000003>?1X00000000000@0cS`J0`0mFJ/20<hl6P0803eIZ`3>?1X0
cS`J0000003>?1X000000=e1700000050=e170050000003M@A`0gD4L0=e1700000000P3M@A`01000
0000gD4L0=e1700000020>a57P030000003/AAh000000080C73J0`3D?AT204a`fP070000001<L=X0
00000000000mFJ/0C6oH0000000204a_f0030=@m6@1<KmP0000000<0C6oH00D0000004a_f01<KmP0
C6oH0000000504a_f0060000001<KmP0C6oH04a_f03D?AT000001@1<KmP400000080BfkD1`3D?AT2
000000D0BfkD00H0e3dI04]^e0000000oe0Q0000000mFJ/3000000<0ooK^00<0?EV[0?ofkP3om^h0
0P3om^h303eIZ`L0ooK^0P0mFJ/B0?ofkP<0?EV[4`3om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP0303eI
Z`3om^h0ooK^00<0ooK^0`0mFJ/:0?ofkP0303eIZ`3om^h0ooK^03`0ooK^00<000000?ofkP3om^h0
503om^h10?ooo`00:P3om^h00`000000ooK^0?ofkP0H0?ofkP030000003om^h0ooK^0340ooK^00<0
e3dI0?ofkP3D?AT0103om^h00`3D?AT0ooK^0?ofkP030?ofkP040=@m6@3om^h0ooK^0=@m6@<0ooK^
1P0mFJ/00`3om^h0e3dI0=@m6@040?ofkPH0?EV[00<0000003eIZ`2C:Q<0102C:Q<010000000ZC4F
0000000000060:Ta5P<0?EV[0P2Y<AH01P000000_3LH0;`g602l=aP0?EV[000000P0_3LH0P000000
0`2l=aP000000<hl6P030<hl6P030000003>?1X0cS`J00<0cS`J00@0000003eIZ`0mFJ/0?EV[0`3>
?1X010000000gD4L0=e1703M@A`2000000@0gD4L00@000000=e1703M@A`000000P3M@A`00`000000
e3dI000000020>a57P0903eIZ`000000k4DN0>a57P000000C73J0000001<L=X000000080e3dI00D0
000004a`fP1<L=X0000004a`fP020000000403eIZ`3D?AT0C6oH000000<0C6oH00D0000004a_f01<
KmP0C6oH0000000404a_f08000000`1<KmP00`3D?AT0000004a_f00404a_f08000000`1<KmP40000
00030=@m6@1;K]@0BfkD008000001`1;K]@50000000303eIZ`000000000000@0ooK^00<0?EV[0?of
kP3om^h01@3om^h303eIZ`@0ooK^00<0?EV[0?ofkP3om^h04P3om^h00`0mFJ/0ooK^03eIZ`0203eI
Za00ooK^00<0?EV[0?ofkP3om^h04@3om^h00`0mFJ/0ooK^0?ofkP060?ofkP80?EV[203om^h00`0m
FJ/0ooK^0?ofkP0j0?ofkP8000005`3om^h10?ooo`00:P3om^h00`000000ooK^0?ofkP0H0?ofkP03
0000003om^h0ooK^0340ooK^0P3D?AT50?ofkP030=@m6@3om^h0ooK^0080ooK^00D0e3dI0?ofkP3o
m^h0ooK^0=@m6@060?ofkPH0?EV[00@0ooK^03eIZ`0mFJ/0?EV[0`3om^h603eIZ`<0TbXC00<00000
0:Ta5P2Y<AH00P2Y<AH00`000000ZC4F0:Ta5P060:Ta5P<0?EV[0P2l=aP00`0mFJ/0_3LH0;`g6002
000000P0_3LH00<000000<hl6P3>?1X0103>?1X2000000@0cS`J00<0?EV[0000003>?1X0100mFJ/0
0`000000gD4L0=e170020=e170030000003M@A`0gD4L0080gD4L00@000000=e1703M@A`000000P3M
@A`010000000k4DN0>a57P0mFJ/20>a57P070000003/AAh0000004a`fP000000C73J0000000204a`
fP80e3dI00H0C73J0000001<L=X0C73J0000003D?AT400000080C6oH00D0000004a_f01<KmP0C6oH
0000000304a_f0030000001<KmP0C6oH0080C6oH00<0e3dI0000001<KmP00`1<KmP2000000D0C6oH
0P0000000`1<KmP0e3dI00000003000000H0BfkD0`00000203eIZ`030000000mFJ/0000000D0ooK^
00<0?EV[0?ofkP3om^h02@3om^h503eIZa<0ooK^00<0?EV[0?ofkP3om^h00`3om^h203eIZ`h0ooK^
00<0?EV[0?ofkP3om^h0403om^h00`0mFJ/0ooK^0?ofkP090?ofkP<0?EV[103om^h00`0mFJ/0ooK^
0?ofkP0j0?ofkP030000003om^h0ooK^01L0ooK^0@3oool002X0ooK^00<000000?ofkP3om^h05`3o
m^h00`000000ooK^0?ofkP0b0?ofkP80e3dI1@3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00@0ooK^
00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0?EV[03eIZ`0403eIZ`H0ooK^1@0mFJ/00`000000ZC4F
0:Ta5P040:Ta5P8000001`2Y<AH00`000000_3LH03eIZ`0203eIZ`@0_3LH0P0000050;`g60040000
003>?1X00000000000H0cS`J0P0000001`3>?1X0?EV[0<hl6P3>?1X000000<hl6P0000000P3M@A`3
03eIZ`<0gD4L00<000000=e1703M@A`00P3M@A`00`000000gD4L0=e1700200000080k4DN00/0?EV[
0>a57P000000k4DN0000003/AAh0000004a`fP000000C73J0000000204a`fP040000001<L=X0e3dI
0=@m6@80C73J00<0e3dI04a`fP1<L=X00`1<L=X300000080C6oH00D0000004a_f01<KmP0C6oH0000
000304a_f080e3dI1@1<KmP00`000000C6oH04a_f00304a_f08000000P1<KmP00`3D?AT000000000
000304a_f08000000P1;K]@4000000030?m@8@000000000000<0?EV[1@3om^h00`0mFJ/0ooK^0?of
kP0<0?ofkP80?EV[4`3om^h00`0mFJ/0ooK^0?ofkP050?ofkP<0?EV[2P3om^h00`0mFJ/0ooK^0?of
kP0A0?ofkP0303eIZ`3om^h0ooK^00`0ooK^0`0mFJ/00`3om^h0?EV[0?ofkP0i0?ofkP8000006P3o
m^h10?ooo`00:@3om^h00`000000ooK^0?ofkP0G0?ofkP030000003om^h0ooK^0380ooK^0P3D?AT6
0?ofkP040=@m6@3om^h0ooK^0=@m6@D0ooK^00<0e3dI0?ofkP3om^h01P3om^h01@3D?AT0ooK^0?of
kP3D?AT0ooK^00H0?EV[1P3om^h303eIZ`P0ZC4F00<000000:Ta5P2Y<AH00`2Y<AH010000000_3LH
03eIZ`0mFJ/20;`g60@0?EV[0P2l=aP01@000000_3LH0;`g602l=aP0000000@0cS`J00<000000<hl
6P3>?1X01@3>?1X00`0mFJ/0cS`J0<hl6P020<hl6P030000003M@A`0gD4L00@0gD4L100mFJ/00`00
0000gD4L0=e170020=e17080000000@0k4DN0000003/AAh0?EV[0P3/AAh030000000k4DN0>a57P00
0000k4DN0000001<L=X0000004a`fP000000C73J00000080C73J00<000000=@m6@3D?AT00`1<L=X0
10000000C73J04a`fP00000204a`fP<000000P1<KmP01P000000C6oH04a_f01<KmP0e3dI000000@0
C6oH0P00000404a_f08000000P1<KmP20=@m6@030000001<KmP0C6oH00D0C6oH100000000`3oD240
0000000000020000000303eIZ`3om^h0ooK^00<0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP03
03eIZ`3om^h0?EV[0180ooK^00<0?EV[0?ofkP3om^h02@3om^h303eIZ`L0ooK^00<0?EV[0?ofkP3o
m^h04@3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP80?EV[>@3om^h00`000000ooK^0?ofkP0J0?ofkP40
oooo000Y0?ofkP030000003om^h0ooK^01L0ooK^00<000000?ofkP3om^h0<P3om^h00`3D?AT0ooK^
0?ofkP050?ofkP030=@m6@3om^h0e3dI00H0ooK^00<0e3dI0?ofkP3om^h01@3om^h01@3D?AT0ooK^
0?ofkP3om^h0e3dI00D0ooK^1@0mFJ/30?ofkP0303eIZ`3om^h0000000<0?EV[1P2Y<AH200000005
0:Ta5P00000000000;`g600mFJ/00P2l=aP2000000@0_3LH0`0mFJ/2000000030;`g60000000cS`J
00@0cS`J0P0000040<hl6P0703eIZ`3>?1X000000000003>?1X000000=e17002000000D0gD4L00<0
00000=e1703M@A`00`0mFJ/20=e170060=@m6@000000k4DN0>a57P000000?EV[0`3/AAh040000000
k4DN0000003/AAh0000004a`fP000000C73J0000001<L=X0000004a`fP000000e3dI04a`fP000003
0=@m6@80C73J00D0000004a`fP1<L=X0C73J0000000204a`fP80000000D0?EV[04a_f01<KmP0e3dI
0000000304a_f0800000101<KmP2000000<0C6oH00<0e3dI0000001<KmP01@1<KmP5000000030?m@
8@000000000000@0000000<0?EV[0?ofkP3om^h00`3om^h303eIZ`d0ooK^00<0?EV[0?ofkP0mFJ/0
4P3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP80?EV[1@3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0303eI
Z`3om^h0ooK^0140ooK^00<0?EV[0?ofkP3om^h0=@3om^h2000001d0ooK^0@3oool002T0ooK^00<0
00000?ofkP3om^h05P3om^h00`000000ooK^0?ofkP0c0?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0
e3dI0?ofkP3D?AT01`3om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0
e3dI0?ofkP3om^h01@3om^h703eIZ`80ooK^0P00000303eIZ`D0ZC4F00@000000;`g600mFJ/0?EV[
1@2l=aP2000000D0_3LH100mFJ/70<hl6P8000000P3>?1X01@0mFJ/0cS`J0<hl6P3>?1X0000000@0
gD4L0P0000040=e170030000003M@A`0gD4L0080gD4L100mFJ/010000000k4DN03eIZ`0000040>a5
7P0>0000003/AAh000000000001<L=X0000004a`fP000000C73J0000001<L=X0e3dI04a`fP000003
04a`fP040000003D?AT0e3dI0=@m6@80C73J00D0000004a`fP1<L=X0C73J0000000204a`fP030000
003D?AT0?EV[0080C6oH0P00000404a_f08000000`1<KmP00`000000e3dI04a_f00404a_f0H00000
00<0oe0Q0000000000000`0000000`3aBAd0000003eIZ`080?ofkPD0?EV[203om^h0100mFJ/0ooK^
0?ofkP0mFJ/A0?ofkP0303eIZ`3om^h0ooK^00l0ooK^0`0mFJ/00`3om^h0?EV[0?ofkP0B0?ofkP03
03eIZ`3om^h0ooK^0100ooK^00<0?EV[0?ofkP3om^h0=@3om^h00`000000ooK^0?ofkP0M0?ofkP40
oooo000Y0?ofkP030000003om^h0ooK^01D0ooK^00<000000?ofkP3om^h0=03om^h00`3D?AT0ooK^
0?ofkP050?ofkP80e3dI203om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00@0ooK^
00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0?EV[03eIZ`0303eIZ`80ooK^00<000000:Ta5P2Y<AH0
0`0mFJ/01@2Y<AH0000003eIZ`0mFJ/0000000P0_3LH0P0000040;`g60030000003>?1X0cS`J00<0
?EV[1P3>?1X00`000000?EV[0<hl6P020<hl6P040000003M@A`00000000000@0gD4L0P0000030=e1
708000000`3M@A`00`000000k4DN0>a57P0303eIZ`090>a57P000000k4DN0000003/AAh000000>a5
7P000000k4DN0080000000P0C73J0000001<L=X0000004a`fP3D?AT0C73J00000080C73J00D00000
04a`fP1<L=X0000004a`fP030=@m6@80C73J00D0000004a`fP1<L=X0C73J0=@m6@0204a`fP800000
00@0?EV[04a_f01<KmP0C6oH0P00000304a_f080000000<0e3dI04a_f01<KmP00P1<KmP200000005
0?mB8P00000000000000003oD2401P0000000`3aBAd0000003eIZ`090?ofkP0303eIZ`3om^h0ooK^
0080ooK^0`0mFJ/50?ofkP0303eIZ`3om^h0?EV[0180ooK^00<0?EV[0?ofkP3om^h04P3om^h303eI
Za40ooK^00<0?EV[0?ofkP3om^h04@3om^h00`0mFJ/0ooK^0?ofkP0d0?ofkP030000003om^h0ooK^
01h0ooK^0@3oool002T0ooK^00<000000?ofkP3om^h0503om^h00`000000ooK^0?ofkP0e0?ofkP03
0=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP020?ofkP03
0=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP020?ofkPD0
?EV[0P0000020:Ta5P@0?EV[0P2l=aP2000000P0_3LH0P0000000`2l=aP000000<hl6P040<hl6P03
0000000mFJ/0?EV[0080?EV[0P3>?1X01@0mFJ/000000000003>?1X0000000@0gD4L0P0000040=e1
708000000`3M@A`02@000000gD4L0000003/AAh000000>a57P0mFJ/0k4DN0000000303eIZ`050>a5
7P000000k4DN0000003/AAh00P0000002@1<L=X000000000001<L=X000000=@m6@000000C73J0000
000204a`fP030000001<L=X000000080C73J00<0000004a`fP1<L=X00`3D?AT00`1<L=X000000=@m
6@0204a`fP8000000P1<L=X3000000<0C6oH0P000000101<KmP0e3dI04a_f01<KmP6000000030?mB
8P000000000000D0000000@0lDTM000000000000ooK^0`0mFJ/60?ofkP0303eIZ`3om^h0ooK^00H0
ooK^0`0mFJ/01@3om^h0?EV[0?ofkP3om^h0?EV[0140ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0m
FJ/0ooK^0?ofkP0303eIZ`h0ooK^00<0?EV[0?ofkP3om^h04@3om^h00`0mFJ/0ooK^0?ofkP0b0?of
kP8000008@3om^h10?ooo`00:03om^h00`000000ooK^0?ofkP0E0?ofkP030000003om^h0ooK^03D0
ooK^00<0e3dI0?ofkP3om^h0103om^h20=@m6@T0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@080?of
kP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP0503eI
Z`040:Ta5P000000_3LH0;`g60@0?EV[0P0000080;`g60030000003>?1X0cS`J00H0cS`J0`000003
03eIZ`80cS`J00<000000=e1703M@A`01@3M@A`2000000@0gD4L0P0000020=e170060000003/AAh0
k4DN0>a57P0mFJ/000000P3/AAh2000000030>a57P0mFJ/0?EV[0080000000<0k4DN000000000000
0`0000002P1<L=X0e3dI04a`fP000000C73J0000001<L=X0000004a`fP00000204a`fP030000001<
L=X0C73J0080000000<0C73J0000003D?AT01@3D?AT204a`fP040000001<L=X0C73J04a`fP<00000
0P1<KmP00`3D?AT0000000000004000000030?mB8P3D?AT0000000H0000000H0lDTM000000000000
00000?ofkP0mFJ/30?ofkP80?EV[103om^h00`0mFJ/0ooK^0?ofkP090?ofkP<0?EV[00<0ooK^03eI
Z`3om^h0403om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^00<0ooK^0`0mFJ/;0?of
kP0303eIZ`3om^h0ooK^0100ooK^00<0?EV[0?ofkP3om^h0<P3om^h00`000000ooK^0?ofkP0Q0?of
kP40oooo000X0?ofkP030000003om^h0ooK^01@0ooK^00<000000?ofkP3om^h0=P3om^h00`3D?AT0
ooK^0?ofkP030?ofkP030=@m6@3om^h0e3dI00X0ooK^00<0e3dI0?ofkP3D?AT02P3om^h00`3D?AT0
ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h00`3om^h403eIZ`H0
_3LH0`0mFJ/00`000000_3LH0;`g60030;`g60030000003>?1X0cS`J008000001`3>?1X203eIZ`03
0000003>?1X0?EV[0080?EV[00<0gD4L0000000000001P3M@A`2000000@0gD4L0P0000020>a57P05
0000000mFJ/0k4DN0>a57P0000000`3/AAh00`000000k4DN0000000203eIZ`030000003iBQl00000
00P000000P1<L=X01@000000C73J0000001<L=X000000080C73J00P0000004a`fP1<L=X0000004a`
fP3D?AT0C73J00000080C73J00<000000=@m6@3D?AT00`3D?AT010000000C73J04a`fP1<L=X30000
0080?EV[00<000000?mB8P3oDR801@0000000`3oD24000000000000400000080ooK^00<0?EV[0?of
kP3om^h0103om^h303eIZ`030?ofkP0mFJ/0ooK^00X0ooK^00<0?EV[0?ofkP3om^h00`0mFJ/?0?of
kP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h01`3om^h203eIZ`P0ooK^00<0?EV[0?of
kP3om^h04@3om^h00`0mFJ/0ooK^0?ofkP0`0?ofkP800000903om^h10?ooo`00:03om^h00`000000
ooK^0?ofkP0C0?ofkP030000003om^h0ooK^03L0ooK^00<0e3dI0?ofkP3om^h00`3om^h0103D?AT0
ooK^0?ofkP3D?AT90?ofkP80e3dI2`3om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^
00H0ooK^00<0e3dI0?ofkP3om^h01P3om^h303eIZ`H0_3LH100mFJ/00`2l=aP000000<hl6P040<hl
6P<000000`3>?1X0100mFJ/0cS`J0<hl6P3>?1X200000080gD4L100mFJ/2000000D0gD4L0P000000
103M@A`000000>a57P3/AAh20000000303eIZ`3/AAh000000080k4DN0P0000020>a57P040000003/
AAh000000>a57P@0000000D0BfoK0000001;Km/0000004]_f`040000000404a`fP000000C73J0000
0080C73J00<0000004a`fP0000000P1<L=X0103D?AT000000000001<L=X200000080C73J0`000003
04a`fP80000000D0e3dI00000000000000000?mB8P0303eIZ`<0000000@0oe0Q000000000000oe0Q
100000030?ofkP0303eIZ`3om^h0ooK^00L0ooK^0`0mFJ/:0?ofkP0603eIZ`3om^h0ooK^0?ofkP0m
FJ/0ooK^0`0mFJ/<0?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h02@3om^h303eI
Z`D0ooK^00<0?EV[0?ofkP3om^h04@3om^h00`0mFJ/0ooK^0?ofkP0_0?ofkP030000003om^h0ooK^
02@0ooK^0@3oool002P0ooK^00<000000?ofkP3om^h04`3om^h00`000000ooK^0?ofkP0g0?ofkP03
0=@m6@3om^h0ooK^0080ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@090?ofkP030=@m6@3om^h0ooK^
00/0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0:0?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI
03eIZ`0mFJ/00P0mFJ/50;`g60040000000mFJ/0?EV[03eIZ`L0cS`J00<0000003eIZ`0mFJ/0103>
?1X00`000000gD4L0=e1700300000080gD4L0`0mFJ/2000000@0gD4L0P0000030>a57P0303eIZ`00
000000000080k4DN0P000000203/AAh000000>a57P3/AAh000000>a57P000000nDXO1`0000001@1;
Km/00000000000000000BfoK00<000000P1<L=X300000080C73J00@0e3dI00000000000000000`1<
L=X200000080C73J0P0000030?m@8P8000000P3oDR85000000<0?EV[00<000000?m@8@0000001000
00030?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP0mFJ/00P0mFJ/60?ofkP0303eIZ`3o
m^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h00P3om^h303eIZ`P0ooK^00<0?EV[0?ofkP3om^h04`3o
m^h00`0mFJ/0ooK^0?ofkP0=0?ofkP<0?EV[00<0ooK^03eIZ`3om^h04P3om^h00`0mFJ/0ooK^0?of
kP0^0?ofkP8000009`3om^h10?ooo`00:03om^h00`000000ooK^0?ofkP0B0?ofkP030000003om^h0
ooK^03P0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@040?ofkP030=@m6@3om^h0ooK^00H0ooK^0P3D
?AT=0?ofkP040=@m6@3om^h0ooK^0=@m6@`0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^
0?ofkP03000000<0?EV[0P2l=aP010000000cS`J0<hl6P00000403eIZ`80cS`J0P0mFJ/20<hl6P80
00000P3>?1X00`000000gD4L0=e170030=e170@0000000D0gD4L03eIZ`0mFJ/0?EV[000000020=e1
70060000003/AAh0k4DN0000000mFJ/000000P3/AAh3000000030>a57P00000000000080000000D0
k4DN0000003iBQl000000?U:7`080000000604]_f`000000000004]_f`000000BfoK0`00000204a`
fP040000003D?AT0000000000080C73J0`000000101<L=X000000000003oD285000000030?mB8P00
0000000000<000000P3oDR84000000@0?EV[0P000000100mFJ/0ooK^0?ofkP0mFJ/<0?ofkP0303eI
Z`3om^h0ooK^0080ooK^0`0mFJ/30?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/0203om^h303eIZ`D0
ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP<0?EV[4P3om^h00`0mFJ/0
ooK^0?ofkP0]0?ofkP030000003om^h0ooK^02L0ooK^0@3oool002L0ooK^00<000000?ofkP3om^h0
4P3om^h00`000000ooK^0?ofkP0i0?ofkP040=@m6@3om^h0ooK^0=@m6@D0ooK^00<0e3dI0?ofkP3o
m^h01@3om^h0103D?AT0ooK^0?ofkP3D?AT=0?ofkP80e3dI3@3om^h00`3D?AT0ooK^0?ofkP040?of
kP030=@m6@3om^h0ooK^00@0ooK^0P0000000`2l=aP0?EV[03eIZ`0203eIZ`@0cS`J00<0000003eI
Z`0mFJ/00P0mFJ/50<hl6P8000002P3M@A`3000000030=e1700mFJ/0?EV[0080?EV[0P3/AAh00`0m
FJ/0k4DN0>a57P0300000080k4DN0P0000001@3/AAh00000000000000000nDXO00<0000000<0nDXO
0000000000001`0000000`1;Km/0000004]_f`030000000504]_f`00000000000=@m6@0000000P1<
L=X9000000030?m@8P0mFJ/0000000@00000103oDR85000000050?m@8@00000000000?597@000000
0`0mFJ/20?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h01@3om^h303eIZ`@0ooK^
00<0?EV[0?ofkP3om^h02@3om^h303eIZ`030?ofkP0mFJ/0ooK^01@0ooK^00<0?EV[0?ofkP3om^h0
4@3om^h00`0mFJ/0ooK^0?ofkP0303eIZ`l0ooK^00<0?EV[0?ofkP3om^h0:`3om^h2000002X0ooK^
0@3oool002L0ooK^00<000000?ofkP3om^h04@3om^h00`000000ooK^0?ofkP0j0?ofkP030=@m6@3o
m^h0e3dI00L0ooK^00<0e3dI0?ofkP3om^h00`3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00d0ooK^
00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00L0ooK^
0P0000020<hl6PH0?EV[0`3>?1X00`000000?EV[03eIZ`0203eIZ`8000000`3M@A`4000000L0gD4L
0`0000020>a57P<0?EV[0P0000030>a57P<0000000D0k4DN00000000000000000?U:7`0200000003
0?U:7`000000000000P0000000<0BfoK0000000000000P000000101;Km/0000000000000000204]_
f`P0000000D0oe0R000000000000000003eIZ`03000000<0oe8R1`000000103oD24000000000003a
BAd300000080ooK^100mFJ/<0?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP0mFJ/00P0m
FJ/00`3om^h0?EV[0?ofkP0=0?ofkP<0?EV[4`3om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP0303eIZ`3o
m^h0ooK^00<0ooK^0`0mFJ/;0?ofkP0303eIZ`3om^h0ooK^02/0ooK^00<000000?ofkP3om^h0:P3o
m^h10?ooo`009`3om^h00`000000ooK^0?ofkP0A0?ofkP030000003om^h0ooK^03X0ooK^00<0e3dI
0?ofkP3D?AT01`3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI
0?ofkP3om^h02@3om^h00`3D?AT0ooK^0=@m6@0?0?ofkP040=@m6@3om^h0ooK^0=@m6@d0ooK^0P00
0000103D?AT0000003eIZ`0mFJ/70<hl6P8000000`0mFJ/60=e170D000000P3M@A`01P000000k4DN
0>a57P3/AAh0000003eIZ`8000000P0mFJ/400000080k4DN600000000`1;Km/000000000000>0000
000303eIZ`3D?AT0oe8R00@0000000@0oe8R00000000000000000P3oD247000000<0ooK^0P0mFJ/2
0?ofkP<0?EV[2@3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^0080ooK^0P0mFJ/>
0?ofkP0303eIZ`3om^h0ooK^00<0?EV[403om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP0303eIZ`3om^h0
ooK^00L0ooK^0`0mFJ/80?ofkP0303eIZ`3om^h0ooK^02T0ooK^0P00000]0?ofkP40oooo000W0?of
kP030000003om^h0ooK^0100ooK^00<000000?ofkP3om^h0>`3om^h20=@m6@P0ooK^00<0e3dI0?of
kP3om^h00P3om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00P0ooK^00@0e3dI0?of
kP3om^h0e3dI3`3om^h00`3D?AT0ooK^0=@m6@0A0?ofkP030=@m6@00000000000080?EV[0P000003
0<hl6P050000003M@A`0gD4L0=e170000000100mFJ/70=e170<000000P3/AAh203eIZ`<0k4DN0P00
000303eIZ`030>a57P000000000002D0000000@0oe0R000000000000?EV[0`0000000`3oDR800000
0000000300000080oe0Q0P0000001@3oD24000000000003aBAd0000000@0?EV[00<0ooK^03eIZ`3o
m^h01@3om^h203eIZ`L0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP040?ofkP03
03eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h00`3om^h303eIZ``0ooK^00<0?EV[0?ofkP3o
m^h04P3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP<0?EV[1@3om^h00`0mFJ/0ooK^0?ofkP0X0?ofkP03
0000003om^h0ooK^02d0ooK^0@3oool002L0ooK^00<000000?ofkP3om^h03`3om^h00`000000ooK^
0?ofkP0l0?ofkP030=@m6@3om^h0ooK^00L0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@070?ofkP03
0=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP03
0=@m6@3om^h0ooK^0140ooK^00<0e3dI0?ofkP3D?AT01P0000090=e170<0?EV[0P0000030=e17005
0000003/AAh0?EV[03eIZ`3/AAh0200000000`3/AAh0?EV[03eIZ`0P000000<0?EV[100000000`3o
D280?EV[00000004000000@0oe8R0`000000103oD24000000000003aBAd200000080ooK^00<00000
0?ofkP3om^h00`0mFJ/70?ofkP<0?EV[103om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0
ooK^00D0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP070?ofkP<0?EV[2@3om^h0
0`0mFJ/0ooK^0?ofkP0A0?ofkP0303eIZ`3om^h0ooK^00h0ooK^0`0mFJ/00`3om^h0?EV[0?ofkP0X
0?ofkP800000<03om^h10?ooo`009`3om^h00`000000ooK^0?ofkP0?0?ofkP030000003om^h0ooK^
03`0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0=@m6@080?ofkP030=@m6@3om^h0ooK^
00D0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0e3dI
01<0ooK^00@0e3dI0?ofkP3om^h0ooK^1P0000000`0fEjl0000000000006000000030=e1700mFJ/0
?EV[00<000003@3/AAhT00000080oe0R0`0mFJ/20000000403eIZ`000000oe8R0?mB8Ph000000`3o
m^h00`000000ooK^0?ofkP0203eIZ`040?ofkP0mFJ/0?EV[03eIZ`L0ooK^0`0mFJ/00`3om^h0?EV[
0?ofkP050?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^
0?ofkP0;0?ofkP<0?EV[1@3om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^0140ooK^
0P0mFJ/X0?ofkP030000003om^h0ooK^0300ooK^0@3oool002H0ooK^00<000000?ofkP3om^h03`3o
m^h00`000000ooK^0?ofkP0m0?ofkP030=@m6@3om^h0ooK^00P0ooK^0P3D?AT:0?ofkP030=@m6@3o
m^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP050=@m6@3o
m^h0ooK^0?ofkP3D?AT04@3om^h00`3D?AT0ooK^0=@m6@060?ofkPX0000000<0=UN_000000000000
0`0000080>a57Rl000000`0mFJ/3000000<0oe8R100000000`3oD240000000000003000000@0ooK^
00D000000?ofkP0mFJ/0ooK^03eIZ`040?ofkP<0?EV[1`3om^h203eIZ`D0ooK^00<0?EV[0?ofkP3o
m^h01P3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00h0ooK^0`0mFJ/20?ofkP03
03eIZ`3om^h0ooK^0140ooK^00<0?EV[0?ofkP3om^h04P3om^h00`0mFJ/0ooK^0?ofkP0V0?ofkP03
0000003om^h0ooK^0340ooK^0@3oool002H0ooK^00<000000?ofkP3om^h03P3om^h00`000000ooK^
0?ofkP0o0?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^
0?ofkP030?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^
0?ofkP030?ofkP030=@m6@3om^h0ooK^00d0ooK^00@0e3dI0?ofkP3om^h0ooK^0P3D?AT80?ofkPT0
000000<0e3dI0000000000005P0000000`18KML000000000000G000000H0oe0R00@0000003eIZ`3o
DR80oe8R0`0mFJ/400000080oe0Q0`0000000`3aBAd000000?ofkP050?ofkP050000000mFJ/0ooK^
0?ofkP0mFJ/01`3om^h403eIZ`@0ooK^100mFJ/20?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[
0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP<0?EV[4`3om^h00`0mFJ/0ooK^0?ofkP0B
0?ofkP0303eIZ`3om^h0ooK^02@0ooK^0P00000d0?ofkP40oooo000V0?ofkP030000003om^h0ooK^
00d0ooK^00<000000?ofkP3om^h0@03om^h00`3D?AT0ooK^0?ofkP060?ofkP80e3dI303om^h01@3D
?AT0ooK^0?ofkP3om^h0e3dI00X0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP05
0?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP08
0?ofkP@0000000<0=UN_0=@m6@0fEjl0200000000`3D?AT0000000000003000000<0@VK;0`000000
0`3D?AT000000000000200000080B6gG3`0000000`3oCB40000000000002000000<0oe0R1@000002
03eIZ`@000000P3oDR8303eIZ`@0000000<0lDTM0000000000001`3om^h01@0mFJ/0ooK^0?ofkP3o
m^h0?EV[00/0ooK^0`0mFJ/00`3om^h0?EV[0?ofkP020?ofkP<0?EV[203om^h00`0mFJ/0ooK^0?of
kP080?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h00`0mFJ/?0?ofkP0303eIZ`3o
m^h0ooK^0180ooK^00<0?EV[0?ofkP3om^h0903om^h00`000000ooK^0?ofkP0d0?ofkP40oooo000V
0?ofkP030000003om^h0ooK^00d0ooK^00<000000?ofkP3om^h0@03om^h00`3D?AT0ooK^0?ofkP05
0?ofkP040=@m6@3om^h0ooK^0=@m6@/0ooK^00@0e3dI0?ofkP3om^h0e3dI303om^h00`3D?AT0ooK^
0?ofkP040?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^
0?ofkP060?ofkP030=@m6@3om^h0ooK^00X0ooK^00<000000=@m6@0000002P0000020=@m6@P00000
00@0e3dI00000012I//0@VK;1@0000001018KML0000000000018KML>000000030?m@8P0000000000
008000000P3oD2800`3D?AT0?EV[0?mB8P020?mB8PL0000000<0oe0Q03eIZ`0mFJ/00P0mFJ/20000
00L0ooK^00<0?EV[0000003om^h00P3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP<0?EV[0P3om^h00`0m
FJ/0ooK^0?ofkP0403eIZ`@0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP0C0?of
kP0303eIZ`3om^h0ooK^00<0ooK^0`0mFJ/<0?ofkP0303eIZ`3om^h0ooK^0180ooK^00<0?EV[0?of
kP3om^h08P3om^h2000003L0ooK^0@3oool002H0ooK^00<000000?ofkP3om^h0303om^h00`000000
ooK^0?ofkP110?ofkP030=@m6@3om^h0ooK^00D0ooK^00@0e3dI0?ofkP3om^h0e3dI303om^h20=@m
6@d0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^
00L0ooK^00<0e3dI0?ofkP3om^h0203om^h20=@m6@X0ooK^00<0e3dI0?ofkP3om^h0300000020=@m
6@<0000000<0@VK;03eIZ`3D?AT01P000002049Vb`<0000000@0B6gG000000000000B6gG1`000000
0`3oCB400000000000020?m@8P@0000000@0oe0R000000000000?EV[100000030?mB8P030000003o
D240oe0Q0080oe0Q0`000000103aBAd0?EV[03eIZ`0mFJ/60?ofkP0303eIZ`000000ooK^00<0ooK^
00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^03eIZ`0203eIZ`H0ooK^0`0mFJ/00`3om^h0?EV[
0?ofkP080?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h01`3om^h303eIZ`P0ooK^
00<0?EV[0?ofkP3om^h04P3om^h00`0mFJ/0ooK^0?ofkP0R0?ofkP030000003om^h0ooK^03L0ooK^
0@3oool002D0ooK^00<000000?ofkP3om^h0303om^h00`000000ooK^0?ofkP130?ofkP030=@m6@3o
m^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3o
m^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3o
m^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3o
m^h0ooK^00D0ooK^2P0000020=@m6@80000000@0e3dI00000012I//0?EV[0P000003049Vb`<00000
00D0@VK;000000000000000004Q]e`020000000404Q]e`00000000000?m=8@8000000P0mFJ/20000
00@0oe0R00<0000003eIZ`0mFJ/00`0000050?mB8PH0000000<0lDTM0000000000001P0mFJ/20?of
kP0303eIZ`3om^h0000000@0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^03eIZ`020?of
kP<0?EV[1P3om^h403eIZ`H0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP0;0?of
kP<0?EV[1@3om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^0200ooK^0P00000j0?of
kP40oooo000U0?ofkP030000003om^h0ooK^00/0ooK^00<000000?ofkP3om^h0A03om^h00`3D?AT0
ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0
ooK^0=@m6@0?0?ofkP040=@m6@3om^h0ooK^0=@m6@h0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D
?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h02`3om^h30000
000403IG[`0mFJ/0?EV[03IG[`<0e3dI0`000003049Vb`80000000H0@VK;00000012I//0@VK;0000
0012I//8000000040?m@8P000000oe0R000000@0?EV[00@000000=@m6@0mFJ/00000103oDR860000
0080oe0Q1@0000000`0mFJ/0ooK^0?ofkP020?ofkPD0?EV[00<0ooK^0000003om^h00`3om^h00`0m
FJ/0ooK^0?ofkP0<0?ofkP80?EV[1P3om^h303eIZ`@0ooK^00<0?EV[0?ofkP3om^h0100mFJ/20?of
kP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h03P3om^h303eIZ`030?ofkP0mFJ/0ooK^
01<0ooK^00<0?EV[0?ofkP3om^h0803om^h00`000000ooK^0?ofkP0j0?ofkP40oooo000U0?ofkP03
0000003om^h0ooK^00/0ooK^00<000000?ofkP3om^h0A03om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI
00L0ooK^00<0e3dI0?ofkP3om^h01P3om^h0103D?AT0ooK^0?ofkP3D?AT?0?ofkP030=@m6@3om^h0
e3dI0100ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0A0?ofkP80e3dI0`3om^h00`3D?AT0ooK^0?of
kP0>0?ofkPD0000000<0e3dI03IG[`0fEjl0103D?AT200000003049Vb`0mFJ/000000080@VK;00D0
0000049Vb`000000@VK;0=@m6@0200000003049Vb`00000000000080000000@0oe0R0000003oD280
oe0R0P0000000`3oD280?EV[03eIZ`04000000@0oe8R0P0000001P3oD2400000000000000000e3dI
0?597@80000000<0ooK^03eIZ`3om^h01@3om^h603eIZ`<0ooK^00<0?EV[0?ofkP3om^h0303om^h0
0`0mFJ/0ooK^0?ofkP080?ofkP<0?EV[00<0ooK^03eIZ`3om^h01@3om^h303eIZa@0ooK^00<0?EV[
0?ofkP3om^h04P3om^h303eIZa<0ooK^00<0?EV[0?ofkP3om^h07P3om^h2000003d0ooK^0@3oool0
02D0ooK^00<000000?ofkP3om^h02P3om^h00`000000ooK^0?ofkP150?ofkP040=@m6@3om^h0ooK^
0=@m6@P0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0
ooK^00d0ooK^00<0e3dI0?ofkP3om^h0403om^h00`3D?AT0ooK^0=@m6@0D0?ofkP030=@m6@3om^h0
e3dI01@0ooK^00<000000=@m6@0000001000000203IG[`<0e3dI0P0000003@12I//0?EV[00000012
I//000000=@m6@12I//00000049Vb`000000@VK;00000012I//00P0000000`3oD280000000000002
0?m@8P040000000mFJ/000000?mB8P<0?EV[1`0000020=@m6@030?597@000000000000<0ooK^00<0
?EV[0?ofkP3om^h00P3om^h203eIZ`@0ooK^1P0mFJ/>0?ofkP0303eIZ`3om^h0ooK^00/0ooK^0P0m
FJ/60?ofkP0303eIZ`3om^h0ooK^00<0?EV[403om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3o
m^h0ooK^00@0?EV[3P3om^h00`0mFJ/0ooK^0?ofkP0N0?ofkP030000003om^h0ooK^03d0ooK^0@3o
ool002D0ooK^00<000000?ofkP3om^h02@3om^h00`000000ooK^0?ofkP170?ofkP030=@m6@3om^h0
e3dI00T0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0
ooK^00/0ooK^00<0e3dI0?ofkP3D?AT04P3om^h00`3D?AT0ooK^0?ofkP0D0?ofkP030=@m6@3om^h0
ooK^01<0ooK^00<0e3dI0?ofkP3om^h0200000000`0fEjl0e3dI0=@m6@020=@m6@80000000`0e3dI
00000012I//00000049Vb`000000@VK;00000012I//000000?m@8P0000020?m@8P030000000mFJ/0
?EV[0080oe8R0`000000103oDR80?EV[03eIZ`0mFJ/40?m@8@@00000103om^h01@0mFJ/0ooK^0?of
kP3om^h0?EV[00H0ooK^00@000000?ofkP3om^h0ooK^1@0mFJ/:0?ofkP0303eIZ`3om^h0?EV[00d0
ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP040?ofkP<0?EV[3@3om^h00`0mFJ/0
ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^00@0ooK^0`0mFJ/;0?ofkP0303eIZ`3om^h0ooK^01`0
ooK^0P0000100?ofkP40oooo000T0?ofkP030000003om^h0ooK^00X0ooK^00<000000?ofkP3om^h0
A`3om^h20=@m6@X0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m
6@3om^h0ooK^00X0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0@0?ofkP030=@m6@3om^h0e3dI01@0
ooK^00@0e3dI0?ofkP3D?AT0e3dI4P3om^h00`3D?AT0ooK^0?ofkP040?ofkPD000000P0fEjl20000
000303IG[`3D?AT0e3dI00<0e3dI0P000000200mFJ/00000049Vb`000000@VK;0000003oD2800000
0P0mFJ/00`000000oe8R0?mB8P040?mB8P80000000<0e3dI0000000mFJ/00`0mFJ/00`000000lDTM
000000060?ofkP0303eIZ`3om^h0?EV[00L0ooK^00<000000?ofkP3om^h00P3om^h00`0mFJ/0ooK^
03eIZ`0403eIZ`H0ooK^00@0?EV[0?ofkP3om^h0?EV[3@3om^h00`0mFJ/0ooK^0?ofkP020?ofkP03
03eIZ`3om^h0ooK^00P0ooK^0`0mFJ/90?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3o
m^h0203om^h403eIZ`H0ooK^00<0?EV[0?ofkP3om^h0703om^h00`000000ooK^0?ofkP100?ofkP40
oooo000T0?ofkP030000003om^h0ooK^00T0ooK^00<000000?ofkP3om^h0B03om^h00`3D?AT0ooK^
0?ofkP0:0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT0203om^h00`3D?AT0ooK^0?ofkP080?ofkP03
0=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h0303om^h0103D?AT0ooK^0?ofkP3om^h20=@m
6A40ooK^00<0e3dI0?ofkP3om^h00P3om^h20=@m6@l0ooK^00<0e3dI0?ofkP3om^h0203om^h50000
0080=UN_00<0e3dI0000000fEjl00P0fEjl60=@m6@80@VK;00D000000?m@8P00000000000?mB8P02
000000@0oe8R00<000000?m@8@3oD2400`3oD2400`000000lDTM03eIZ`0203eIZ`H0ooK^0P0mFJ/8
0?ofkP030000003om^h0ooK^00<0ooK^00@0?EV[0?ofkP3om^h0ooK^1@0mFJ/20?ofkP0503eIZ`3o
m^h0ooK^0?ofkP0mFJ/03P3om^h0100mFJ/0ooK^0?ofkP0mFJ/>0?ofkP<0?EV[1@3om^h00`0mFJ/0
ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^00d0ooK^100mFJ/20?ofkP0303eIZ`3om^h0ooK^01X0
ooK^0P0000130?ofkP40oooo000T0?ofkP030000003om^h0ooK^00P0ooK^00<000000?ofkP3om^h0
B@3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP040=@m6@3om^h0ooK^0=@m6@X0ooK^00<0e3dI0?ofkP3o
m^h01P3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3o
m^h0103om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00D0ooK^0P3D?AT;0?ofkP80
e3dI3@3om^h0203D?AT0ooK^000000000000e3dI0000000mFJ/000000P0fEjl01@000000=UN_03IG
[`000000=UN_00@0000000<0e3dI0?m@8P0000000`3oDR8200000080oe8R00<000000?m@8@3oD240
0P3oD24010000000lDTM0000000000020?ofkP<0?EV[0P3om^h203eIZ`T0ooK^00<000000?ofkP3o
m^h00`3om^h00`0mFJ/0ooK^0?ofkP040?ofkPD0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP03
03eIZ`3om^h0?EV[0180ooK^0`0mFJ/20?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3o
m^h04@3om^h203eIZa`0ooK^00<000000?ofkP3om^h0@`3om^h10?ooo`00903om^h00`000000ooK^
0?ofkP070?ofkP030000003om^h0ooK^04/0ooK^00<0e3dI0?ofkP3om^h02P3om^h20=@m6@`0ooK^
00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00P0ooK^
00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00P0ooK^
0P3D?AT80?ofkP030=@m6@3om^h0ooK^00d0ooK^00@0e3dI0?ofkP3om^h0e3dI0P3om^h300000003
03eIZ`00000000000080=UN_00D0000003IG[`000000=UN_0=@m6@020000000303eIZ`000000oe8R
00<0oe8R2P0000060?ofkP<0?EV[00<0ooK^03eIZ`3om^h01`3om^h00`000000ooK^0?ofkP030?of
kP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP0mFJ/0100mFJ/>0?ofkP0303eIZ`3om^h0?EV[
01D0ooK^0`0mFJ/D0?ofkP0303eIZ`3om^h0ooK^0180ooK^00<0?EV[0?ofkP3om^h06@3om^h20000
04H0ooK^0@3oool002@0ooK^00<000000?ofkP3om^h01`3om^h00`000000ooK^0?ofkP1;0?ofkP03
0=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP040?ofkP03
0=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP080?ofkP80
e3dI2P3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP80e3dI1@3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP03
0=@m6@3om^h0e3dI00D0ooK^00<0e3dI0000000000001000000203IG[`050=@m6@0fEjl0=UN_0000
003oDR80100mFJ/2000000@0oe0Q00@000000?597@00000000001P3om^h203eIZ`80ooK^0`0mFJ/7
0?ofkP030000003om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h0103om^h203eIZ`D0ooK^1@0mFJ/;
0?ofkP80?EV[5P3om^h00`0mFJ/0ooK^0?ofkP0303eIZa00ooK^00<0?EV[0?ofkP3om^h04P3om^h0
0`0mFJ/0ooK^0?ofkP0I0?ofkP030000003om^h0ooK^04H0ooK^0@3oool002<0ooK^00<000000?of
kP3om^h01`3om^h00`000000ooK^0?ofkP1=0?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?of
kP3D?AT03@3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?of
kP3om^h01@3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?of
kP3om^h03P3om^h20=@m6@80ooK^00<0e3dI0?ofkP3om^h0403om^h00`3D?AT0ooK^0?ofkP030?of
kP050=@m6@3om^h0ooK^0=@m6@3om^h0100000000`3D?AT0000003eIZ`0203IG[`050000003oDR80
oe8R0?mB8P000000100mFJ/40000000303eIZ`3om^h0ooK^00<0ooK^0P0mFJ/60?ofkPD0?EV[0`3o
m^h00`000000ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h01P3o
m^h00`0mFJ/0ooK^03eIZ`0503eIZ`L0ooK^00<0?EV[0?ofkP3om^h0503om^h00`0mFJ/0ooK^0?of
kP040?ofkP<0?EV[3@3om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^01P0ooK^00<0
00000?ofkP3om^h0A`3om^h10?ooo`008`3om^h00`000000ooK^0?ofkP060?ofkP030000003om^h0
ooK^04h0ooK^00<0e3dI0?ofkP3om^h01`3om^h0103D?AT0ooK^0?ofkP3D?AT>0?ofkP040=@m6@3o
m^h0ooK^0=@m6@h0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m
6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h04@3om^h30=@m6A00ooK^0`3D?AT40?ofkP050=@m
6@3om^h0ooK^0?ofkP3D?AT00`3om^h00`000000e3dI000000040000000403IG[`000000oe8R0000
0080oe0Q0`00000603eIZ`80ooK^0P0mFJ/80?ofkP0403eIZ`3om^h0ooK^0?ofkP@0?EV[00<00000
0?ofkP3om^h0103om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00X0ooK^00@0?EV[0?ofkP3om^h0ooK^
1`0mFJ/20?ofkP80?EV[5@3om^h00`0mFJ/0ooK^0?ofkP080?ofkP<0?EV[2@3om^h00`0mFJ/0ooK^
0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^01L0ooK^0P00001:0?ofkP40oooo000S0?ofkP030000003o
m^h0ooK^00H0ooK^00<000000?ofkP3om^h0C`3om^h00`3D?AT0ooK^0?ofkP060?ofkP050=@m6@3o
m^h0ooK^0?ofkP3D?AT03@3om^h00`3D?AT0ooK^0=@m6@0@0?ofkP050=@m6@3om^h0ooK^0?ofkP3D
?AT0403om^h20=@m6@<0ooK^00<0e3dI0?ofkP3om^h04P3om^h00`3D?AT0ooK^0?ofkP040=@m6@/0
ooK^00@0e3dI0?ofkP3om^h0e3dI0`3om^h00`3D?AT0ooK^0?ofkP020?ofkP050=@m6@3om^h0ooK^
0?ofkP3D?AT00P3om^h00`3D?AT0000000000004000000060?m@8@0mFJ/0?EV[0?m@8@000000lDTM
0P0000000`3om^h0?EV[03eIZ`0403eIZ`X0ooK^00<0?EV[0?ofkP3om^h0103om^h303eIZ`@0ooK^
00@0?EV[0?ofkP0mFJ/0?EV[2`3om^h00`0mFJ/0ooK^0?ofkP040?ofkPL0?EV[00<0ooK^03eIZ`3o
m^h04P3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP<0?EV[1@3om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP03
03eIZ`3om^h0ooK^01L0ooK^00<000000?ofkP3om^h0BP3om^h10?ooo`008`3om^h00`000000ooK^
0?ofkP050?ofkP030000003om^h0ooK^0500ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^
0?ofkP020?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h0403om^h00`3D?AT0ooK^
0=@m6@0C0?ofkP030=@m6@3om^h0e3dI01@0ooK^00<0e3dI0?ofkP3om^h01@3om^h30=@m6@L0ooK^
00H0e3dI0?ofkP3om^h0ooK^0=@m6@3om^h20=@m6@D0ooK^00@0e3dI0?ofkP3D?AT0e3dI0P3om^h0
0`3D?AT0ooK^0=@m6@030?ofkP<0e3dI00<0000003eIZ`0mFJ/01@0mFJ/30?ofkP0303eIZ`3om^h0
?EV[00<0?EV[1`3om^h00`0mFJ/0ooK^0?ofkP040?ofkP030000003om^h0ooK^00@0?EV[00<0ooK^
03eIZ`3om^h0303om^h00`0mFJ/0ooK^0?ofkP080?ofkPH0?EV[4@3om^h00`0mFJ/0ooK^0?ofkP0@
0?ofkP<0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP0303eIZ`3om^h0ooK^01H0ooK^0P00001=
0?ofkP40oooo000S0?ofkP030000003om^h0ooK^00@0ooK^00<000000?ofkP3om^h0DP3om^h00`3D
?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D
?AT0ooK^0=@m6@0B0?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h04P3om^h00`3D
?AT0ooK^0?ofkP090?ofkP@0e3dI0P3om^h00`3D?AT0ooK^0?ofkP020?ofkP80e3dI1`3om^h20=@m
6@<0ooK^00<0e3dI0?ofkP3om^h01`3D?AT2000000030=@m6@3om^h0ooK^00@0?EV[0`3om^h0100m
FJ/0ooK^0?ofkP3om^h403eIZ`D0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`000000ooK^0?ofkP03
0?ofkP@0?EV[303om^h00`0mFJ/0ooK^0?ofkP070?ofkP0403eIZ`3om^h0ooK^0?ofkP80?EV[00@0
ooK^03eIZ`0mFJ/0?EV[3P3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP<0?EV[4`3om^h00`0mFJ/0ooK^
0?ofkP0E0?ofkP030000003om^h0ooK^04d0ooK^0@3oool00280ooK^00<000000?ofkP3om^h0103o
m^h00`000000ooK^0?ofkP1C0?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h01P3o
m^h00`3D?AT0ooK^0?ofkP080?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT0403om^h00`3D?AT0ooK^
0=@m6@0C0?ofkP040=@m6@3om^h0e3dI0=@m6A40ooK^00<0e3dI0?ofkP3om^h03P3om^h80=@m6@P0
ooK^00<0e3dI0?ofkP3om^h01P3D?AT00`3om^h0e3dI0?ofkP020=@m6@80ooK^00<0e3dI0?ofkP3o
m^h0103om^h303eIZ`80ooK^00<0?EV[0?ofkP3om^h00`3om^h403eIZ`<0ooK^00<0?EV[0?ofkP3o
m^h00`3om^h00`000000ooK^0?ofkP0203eIZ`80ooK^1@0mFJ/:0?ofkP0303eIZ`3om^h0ooK^00D0
ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP020?ofkP<0?EV[2P3om^h00`0mFJ/0
ooK^0?ofkP0D0?ofkP0303eIZ`3om^h0ooK^00@0?EV[3P3om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP80
0000D03om^h10?ooo`008P3om^h00`000000ooK^0?ofkP040?ofkP030000003om^h0ooK^05@0ooK^
00@0e3dI0?ofkP3om^h0e3dI2@3om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00<0
ooK^00<0e3dI0?ofkP3om^h0303om^h0103D?AT0ooK^0?ofkP3om^h20=@m6A00ooK^00<0e3dI0?of
kP3om^h00P3om^h20=@m6@h0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP040?of
kP`0e3dI103om^h0103D?AT0ooK^0=@m6@3om^h20=@m6@030?ofkP3D?AT0e3dI00X0ooK^100mFJ/7
0?ofkPD0?EV[1@3om^h00`000000?EV[03eIZ`050?ofkP0303eIZ`3om^h0ooK^00@0?EV[1`3om^h0
0`0mFJ/0ooK^0?ofkP030?ofkP80?EV[1`3om^h00`0mFJ/0ooK^0?ofkP040?ofkP<0?EV[1P3om^h0
0`0mFJ/0ooK^0?ofkP0D0?ofkP0303eIZ`3om^h0ooK^00D0ooK^0`0mFJ/:0?ofkP0303eIZ`3om^h0
ooK^01@0ooK^00<000000?ofkP3om^h0D03om^h10?ooo`008P3om^h00`000000ooK^0?ofkP030?of
kP030000003om^h0ooK^05D0ooK^00@0e3dI0?ofkP3om^h0e3dI2P3om^h00`3D?AT0ooK^0?ofkP05
0?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP04
0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h01@3om^h20=@m6@/0ooK^00<0e3dI
0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00@0ooK^0P3D?AT0
0`3om^h0e3dI0?ofkP030?ofkP030=@m6@3om^h0e3dI0080e3dI00@0ooK^0=@m6@3D?AT0e3dI3P3o
m^h403eIZ`L0ooK^100mFJ/20?ofkP80?EV[1`3om^h00`0mFJ/0ooK^0?ofkP030?ofkPD0?EV[0`3o
m^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h01`3o
m^h303eIZ`80ooK^00<0?EV[0?ofkP3om^h0503om^h00`0mFJ/0ooK^0?ofkP090?ofkP<0?EV[1P3o
m^h00`0mFJ/0ooK^0?ofkP0C0?ofkP800000D`3om^h10?ooo`008P3om^h00`000000ooK^0?ofkP02
0?ofkP030000003om^h0ooK^05L0ooK^0P3D?AT<0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI
0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI
0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP080?ofkP80e3dI203om^h00`3D?AT0ooK^0?ofkP0?
0?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h00`3om^h0103D?AT0ooK^0=@m6@3D
?AT50?ofkP<0e3dI0P3om^h20=@m6A<0ooK^100mFJ/50?ofkPH0?EV[00<000000?ofkP3om^h01P3o
m^h00`0mFJ/0ooK^0?ofkP050?ofkPD0?EV[00D0ooK^03eIZ`3om^h0ooK^03eIZ`0:0?ofkP0303eI
Z`3om^h0ooK^00X0ooK^0`0mFJ/E0?ofkP0303eIZ`3om^h0ooK^00d0ooK^100mFJ/20?ofkP0303eI
Z`3om^h0ooK^0180ooK^00<000000?ofkP3om^h0D`3om^h10?ooo`008P3om^h01@000000ooK^0?of
kP3om^h0000005X0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m
6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP080?ofkP80e3dI
203om^h20=@m6@d0ooK^0P3D?AT50?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h0
1`3om^h00`3D?AT0ooK^0?ofkP020?ofkP040=@m6@3om^h0ooK^0=@m6@D0ooK^0`3D?AT20?ofkP80
e3dI603om^h503eIZ`<0ooK^00<0?EV[0?ofkP0mFJ/00`0mFJ/60?ofkP0303eIZ`3om^h0ooK^00P0
ooK^1P0mFJ/;0?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h00`0mFJ/A0?ofkP03
03eIZ`3om^h0ooK^0180ooK^0P0mFJ/C0?ofkP800000EP3om^h10?ooo`008P3om^h01@000000ooK^
0?ofkP3om^h0000005/0ooK^00<0e3dI0?ofkP3om^h02`3om^h0103D?AT0ooK^0?ofkP3D?AT=0?of
kP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP040?of
kP030=@m6@3om^h0ooK^00l0ooK^0P3D?AT20?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?of
kP3om^h0203om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI0080ooK^0P3D?AT40?ofkP<0e3dI00@0ooK^
0=@m6@3D?AT0e3dI703om^h403eIZ`80ooK^00<0?EV[0?ofkP0000000P3om^h403eIZ`<0ooK^00<0
?EV[0?ofkP3om^h02P3om^h503eIZ`X0ooK^00<0?EV[0?ofkP3om^h01`3om^h203eIZ`H0ooK^0`0m
FJ/>0?ofkP0303eIZ`3om^h0ooK^0180ooK^00<0?EV[0?ofkP3om^h04@3om^h00`000000ooK^0?of
kP1F0?ofkP40oooo000Q0?ofkP050000003om^h0ooK^0?ofkP000000G03om^h00`3D?AT0ooK^0?of
kP0;0?ofkP030=@m6@3om^h0e3dI00l0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?of
kP0<0?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h04P3om^h30=@m6A00ooK^00<0
e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP020=@m6@80ooK^0P3D?AT40?ofkP030=@m6@3o
m^h0e3dI0080e3dI00<0ooK^0=@m6@3om^h07`3om^h503eIZ`030000003om^h0ooK^00<0ooK^1@0m
FJ/90?ofkP<0?EV[00<0ooK^03eIZ`3om^h01@0mFJ/70?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0
?EV[0?ofkP3om^h02@3om^h303eIZ`X0ooK^00<0?EV[0?ofkP3om^h04P3om^h00`0mFJ/0ooK^0?of
kP0@0?ofkP800000F@3om^h10?ooo`008@3om^h010000000ooK^0?ofkP00001N0?ofkP030=@m6@3o
m^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h03`3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI0100ooK^
0P3D?AT00`3om^h0e3dI0?ofkP0D0?ofkP030=@m6@3om^h0ooK^00@0e3dI2`3om^h00`3D?AT0ooK^
0?ofkP090?ofkP030=@m6@3om^h0e3dI00<0ooK^00<0e3dI0?ofkP3D?AT00`3om^h0103D?AT0ooK^
0=@m6@3D?AT20?ofkP030=@m6@3om^h0ooK^02<0ooK^0`0mFJ/80?ofkP@0?EV[0`3om^h303eIZ`D0
ooK^00<0?EV[0?ofkP3om^h00P3om^h503eIZ`<0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0
ooK^0?ofkP0=0?ofkP<0?EV[1P3om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^0100
ooK^00<000000?ofkP3om^h0F@3om^h10?ooo`008@3om^h010000000ooK^0?ofkP00001O0?ofkP03
0=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3D?AT04@3om^h00`3D?AT0ooK^0=@m6@0C0?ofkP03
0=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h01@3om^h30=@m6@L0ooK^00<0e3dI0?ofkP3o
m^h02P3om^h20=@m6@80ooK^0P3D?AT20?ofkP030=@m6@3om^h0ooK^00@0e3dI0P3om^h00`3D?AT0
ooK^0?ofkP0U0?ofkP030000003om^h0?EV[00<0?EV[1P3om^h503eIZ`P0ooK^00<0?EV[0?ofkP3o
m^h01@3om^h503eIZ`030?ofkP0mFJ/0ooK^00<0ooK^0P0mFJ/C0?ofkP<0?EV[0P3om^h00`0mFJ/0
ooK^0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^0100ooK^00<000000?ofkP3om^h0FP3om^h10?ooo`00
8@3om^h00`000000ooK^0000001P0?ofkP030=@m6@3om^h0ooK^00P0ooK^00D0e3dI0?ofkP3om^h0
ooK^0=@m6@0A0?ofkP030=@m6@3om^h0ooK^0140ooK^00@0e3dI0?ofkP3D?AT0e3dI4P3om^h00`3D
?AT0ooK^0?ofkP090?ofkP@0e3dI0P3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP040=@m6@3om^h0ooK^
0=@m6@<0ooK^1`3D?AT00`3om^h0e3dI0=@m6@0X0?ofkP030000003om^h0ooK^00<0ooK^1P0mFJ/0
0`3om^h0?EV[0?ofkP020?ofkP<0?EV[1P3om^h00`0mFJ/0ooK^0?ofkP080?ofkP@0?EV[0P3om^h0
0`0mFJ/0ooK^0?ofkP0F0?ofkP<0?EV[4`3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP800000G@3om^h1
0?ooo`008@3om^h200000680ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP030?of
kP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3D?AT04@3om^h00`3D?AT0ooK^0?ofkP020?of
kP80e3dI3`3om^h00`3D?AT0ooK^0?ofkP0>0?ofkPP0e3dI1`3om^h20=@m6@030?ofkP3D?AT0e3dI
00@0e3dI00<0ooK^0=@m6@3D?AT00P3D?AT00`3om^h0e3dI0=@m6@0Y0?ofkP030000003om^h0ooK^
00H0ooK^100mFJ/00`3om^h0?EV[03eIZ`040?ofkP<0?EV[103om^h00`0mFJ/0ooK^0?ofkP0:0?of
kP@0?EV[5`3om^h203eIZ`80ooK^100mFJ/?0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<000000?of
kP3om^h0G@3om^h10?ooo`00803om^h2000006@0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0
ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00/0ooK^00@0e3dI0?ofkP3om^h0ooK^0P3D?AT>0?of
kP030=@m6@3om^h0ooK^00D0ooK^0P3D?AT;0?ofkP80e3dI4@3om^h00`3D?AT0ooK^0?ofkP050?of
kPX0e3dI1@3om^h30=@m6@80ooK^0`3D?ATZ0?ofkP030000003om^h0ooK^00T0ooK^1@0mFJ/60?of
kPD0?EV[2`3om^h203eIZ`<0ooK^100mFJ/A0?ofkP80?EV[203om^h303eIZ`/0ooK^00<0?EV[0?of
kP3om^h03@3om^h200000600ooK^0@3oool00200ooK^0P00001T0?ofkP030=@m6@3om^h0ooK^00@0
ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^00@0
ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP080?ofkP80e3dI203om^h00`3D?AT0
ooK^0?ofkP0@0?ofkP030=@m6@3om^h0ooK^00/0ooK^00@0e3dI0?ofkP3om^h0e3dI1P3om^h20=@m
6@80ooK^0P3D?AT/0?ofkP030000003om^h0ooK^00d0ooK^100mFJ/60?ofkP@0?EV[1`3om^h203eI
Z`80ooK^00<0?EV[0?ofkP3om^h0103om^h303eIZ`d0ooK^00<0?EV[0?ofkP3om^h02`3om^h303eI
Z`L0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`000000ooK^0?ofkP1P0?ofkP40oooo000P0?ofkP80
0000I@3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3o
m^h01`3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3o
m^h02`3om^h20=@m6@D0ooK^00<0e3dI0?ofkP3om^h0403om^h00`3D?AT0ooK^0?ofkP0;0?ofkP05
0=@m6@3om^h0ooK^0?ofkP3D?AT01@3om^h20=@m6@80ooK^0P3D?AT]0?ofkP030000003om^h0ooK^
0100ooK^1@0mFJ/50?ofkP@0?EV[0P3om^h203eIZ`@0ooK^00<0?EV[0?ofkP3om^h01`3om^h303eI
Z`P0ooK^0P0mFJ/A0?ofkP@0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP800000H`3om^h10?oo
o`008P3om^h400000680ooK^00@0e3dI0?ofkP3om^h0e3dI303om^h00`3D?AT0ooK^0?ofkP050?of
kP030=@m6@3om^h0ooK^00P0ooK^0P3D?AT80?ofkP030=@m6@3om^h0ooK^00d0ooK^0P3D?AT20?of
kP030=@m6@3om^h0ooK^0100ooK^00<0e3dI0?ofkP3om^h02`3om^h01@3D?AT0ooK^0?ofkP3om^h0
e3dI00@0ooK^0`3D?AT0103om^h0e3dI0=@m6@3D?AT^0?ofkP030000003om^h0ooK^01@0ooK^3@0m
FJ/60?ofkP0303eIZ`3om^h0ooK^00T0ooK^100mFJ/20?ofkP80?EV[5`3om^h203eIZ`h0ooK^00<0
00000?ofkP3om^h0H`3om^h10?ooo`009P3om^h4000005h0ooK^00<0e3dI0?ofkP3D?AT03P3om^h0
0`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h0103om^h0
0`3D?AT0ooK^0?ofkP0@0?ofkP<0e3dI403om^h20=@m6@d0ooK^00<0e3dI0?ofkP3om^h00P3om^h0
1P3D?AT0ooK^0?ofkP3om^h0e3dI0?ofkP<0e3dI00<0ooK^0=@m6@3om^h0;P3om^h00`000000ooK^
0?ofkP0G0?ofkP@0?EV[00<0ooK^03eIZ`0mFJ/00P3om^h503eIZ`<0ooK^00<0?EV[0?ofkP3om^h0
303om^h303eIZaP0ooK^00<0?EV[0?ofkP3om^h02`3om^h2000006H0ooK^0@3oool002X0ooK^1000
001K0?ofkP030=@m6@3om^h0ooK^00h0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0?0?ofkP030=@m
6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h04@3om^h00`3D?AT0ooK^0?ofkP040=@m6@/0ooK^
00<0e3dI0?ofkP3om^h02`3om^h20=@m6@@0ooK^00@0e3dI0?ofkP3om^h0ooK^103D?AT20?ofkP03
0=@m6@3om^h0ooK^02h0ooK^00<000000?ofkP3om^h06P3om^h503eIZ`D0ooK^1@0mFJ/<0?ofkP80
?EV[0`3om^h303eIZa<0ooK^0P0mFJ/=0?ofkP030000003om^h0ooK^06H0ooK^0@3oool002h0ooK^
1000001H0?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3D?AT04@3om^h20=@m6@030?of
kP3D?AT0ooK^0180ooK^00<0e3dI0?ofkP3om^h01@3om^h30=@m6@L0ooK^00<0e3dI0?ofkP3om^h0
2`3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00@0e3dI00<0ooK^0=@m6@3D?AT0
<@3om^h00`000000ooK^0?ofkP0N0?ofkP<0?EV[1P3om^h303eIZ`T0ooK^0P0mFJ/80?ofkP<0?EV[
3`3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP800000J@3om^h10?ooo`00<P3om^h4000005D0ooK^00<0
e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0B0?ofkP80e3dI4P3om^h00`3D?AT0ooK^0?of
kP090?ofkP@0e3dI0P3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00D0ooK^103D
?AT00`3om^h0e3dI0?ofkP020=@m6C80ooK^00<000000?ofkP3om^h0803om^h503eIZ`D0ooK^100m
FJ/30?ofkP80?EV[3@3om^h303eIZ`/0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`000000ooK^0?of
kP1Y0?ofkP40oooo000f0?ofkP@00000DP3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP040=@m6@3om^h0
e3dI0=@m6A40ooK^00<0e3dI0?ofkP3om^h00P3D?AT?0?ofkP030=@m6@3om^h0ooK^00h0ooK^203D
?AT70?ofkP030=@m6@3om^h0ooK^00H0e3dI00H0ooK^0=@m6@3D?AT0ooK^0=@m6@3om^h20=@m6C<0
ooK^00<000000?ofkP3om^h08`3om^h503eIZ`@0ooK^1@0mFJ/B0?ofkP<0?EV[1P3om^h203eIZ``0
ooK^0P00001/0?ofkP40oooo000j0?ofkP@00000C`3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m
6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP030?ofkP80e3dI
2`3om^h20=@m6A40ooK^00<0e3dI0?ofkP3om^h01@3om^h:0=@m6@D0ooK^0`3D?AT0103om^h0e3dI
0?ofkP3D?ATe0?ofkP030000003om^h0ooK^02H0ooK^1P0mFJ/00`3om^h0?EV[0?ofkP020?ofkP@0
?EV[4@3om^h303eIZ`80ooK^00<0?EV[0?ofkP3om^h02`3om^h00`000000ooK^0?ofkP1/0?ofkP40
oooo000n0?ofkP@00000C03om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00@0ooK^
0P3D?AT<0?ofkP030=@m6@3om^h0ooK^00H0ooK^0P3D?AT80?ofkP030=@m6@3om^h0ooK^0100ooK^
00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP060?ofkP80e3dI0`3om^h20=@m6CH0ooK^
00<000000?ofkP3om^h0:@3om^h703eIZ`D0ooK^0`0mFJ/A0?ofkP80?EV[3@3om^h00`000000ooK^
0?ofkP1]0?ofkP40oooo00120?ofkP@00000B@3om^h00`3D?AT0ooK^0?ofkP050?ofkP80e3dI2@3o
m^h00`3D?AT0ooK^0?ofkP070?ofkP80e3dI2`3om^h20=@m6@D0ooK^00<0e3dI0?ofkP3om^h0403o
m^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00H0ooK^0P3D?AT30?ofkP80e3dI=`3o
m^h00`000000ooK^0?ofkP0]0?ofkPD0?EV[1P3om^h303eIZ`/0ooK^0`0mFJ/=0?ofkP800000L03o
m^h10?ooo`00AP3om^h4000004H0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP0:
0?ofkP80e3dI1P3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP80e3dI0P3om^h00`3D?AT0ooK^0?ofkP0@
0?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h01P3om^h20=@m6@030?ofkP3D?AT0
e3dI0080e3dI>03om^h00`000000ooK^0?ofkP0`0?ofkP@0?EV[1`3om^h403eIZ`<0ooK^100mFJ/?
0?ofkP030000003om^h0ooK^0700ooK^0@3oool004X0ooK^100000130?ofkP050=@m6@3om^h0ooK^
0?ofkP3D?AT03`3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^0100ooK^0`3D?AT@
0?ofkP80e3dI3@3om^h00`3D?AT0ooK^0?ofkP050?ofkP80e3dI00@0ooK^0=@m6@3D?AT0ooK^0P3D
?ATj0?ofkP030000003om^h0ooK^0380ooK^100mFJ/60?ofkPD0?EV[4@3om^h2000007<0ooK^0@3o
ool004h0ooK^100000100?ofkP030=@m6@3om^h0e3dI0140ooK^0P3D?AT00`3om^h0e3dI0?ofkP0B
0?ofkP030=@m6@3om^h0ooK^00@0e3dI2`3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP80e3dI1`3om^h4
0=@m6@80ooK^00<0e3dI0?ofkP3om^h0>P3om^h00`000000ooK^0?ofkP0f0?ofkPH0?EV[5@3om^h0
0`000000ooK^0?ofkP1c0?ofkP40oooo001B0?ofkP@00000?@3om^h00`3D?AT0ooK^0?ofkP0B0?of
kP030=@m6@3om^h0ooK^0140ooK^00<0e3dI0?ofkP3om^h01@3om^h30=@m6@L0ooK^00<0e3dI0?of
kP3om^h02`3om^h00`3D?AT0ooK^0?ofkP050?ofkP<0e3dI00D0ooK^0=@m6@3om^h0ooK^0=@m6@0m
0?ofkP030000003om^h0ooK^04l0ooK^0P00001f0?ofkP40oooo001F0?ofkP<00000>`3om^h00`3D
?AT0ooK^0?ofkP0@0?ofkP040=@m6@3om^h0e3dI0=@m6A00ooK^00<0e3dI0?ofkP3om^h02@3om^h4
0=@m6@80ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP020?ofkPD0e3dI0`3om^h3
0=@m6Ch0ooK^00<000000?ofkP3om^h0CP3om^h00`000000ooK^0?ofkP1f0?ofkP40oooo001I0?of
kP@00000>03om^h20=@m6@l0ooK^00<0e3dI0?ofkP3om^h00P3om^h20=@m6@d0ooK^00<0e3dI0?of
kP3om^h03P3om^h80=@m6@L0ooK^00<0e3dI0?ofkP3D?AT00`3D?AT30?ofkP040=@m6@3om^h0ooK^
0?ofkP<0e3dI?`3om^h00`000000ooK^0?ofkP1<0?ofkP800000N@3om^h10?ooo`00G@3om^h40000
03H0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP050?ofkP80e3dI2P3om^h00`3D
?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00D0ooK^2@3D?AT60?ofkP040=@m6@3om^h0ooK^
0?ofkP80e3dI@@3om^h00`000000ooK^0?ofkP1;0?ofkP030000003om^h0ooK^07T0ooK^0@3oool0
0640ooK^1000000c0?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h0203om^h20=@m
6@L0ooK^00<0e3dI0?ofkP3om^h03P3om^h20=@m6@d0ooK^00<0e3dI0?ofkP3om^h01P3om^h0103D
?AT0ooK^0?ofkP3om^h20=@m6D80ooK^00<000000?ofkP3om^h0B@3om^h2000007`0ooK^0@3oool0
06D0ooK^1000000`0?ofkP80e3dI203om^h00`3D?AT0ooK^0?ofkP0;0?ofkP80e3dI103om^h00`3D
?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00/0ooK^0P3D?AT70?ofkP80e3dI0P3om^h30=@m
6D<0ooK^00<000000?ofkP3om^h0B03om^h00`000000ooK^0?ofkP1l0?ofkP40oooo001Y0?ofkP@0
0000;P3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00h0ooK^0P3D?AT00`3om^h0
e3dI0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0
ooK^0?ofkP020=@m6@030?ofkP3D?AT0ooK^04<0ooK^00<000000?ofkP3om^h0AP3om^h2000007l0
ooK^0@3oool006d0ooK^1000000[0?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h0
4@3om^h30=@m6@h0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP060?ofkP040=@m
6@3om^h0e3dI0=@m6@80ooK^00<0e3dI0?ofkP3om^h0@`3om^h00`000000ooK^0?ofkP150?ofkP03
0000003om^h0ooK^07l0ooK^0@3oool00740ooK^1000000X0?ofkP80e3dI00<0ooK^0=@m6@3om^h0
4P3om^h0103D?AT0ooK^0?ofkP3om^h40=@m6@P0ooK^0P3D?AT=0?ofkP030=@m6@3om^h0ooK^00H0
ooK^0`3D?AT20?ofkP80e3dIAP3om^h00`000000ooK^0?ofkP140?ofkP030000003om^h0ooK^0800
ooK^0@3oool007D0ooK^1000000V0?ofkP80e3dI4P3om^h00`3D?AT0ooK^0?ofkP060?ofkP@0e3dI
0`3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP80e3dI1P3om^h40=@m6@<0ooK^0P3D?AU70?ofkP030000
003om^h0ooK^0480ooK^0P0000230?ofkP40oooo001i0?ofkP@00000903om^h20=@m6@l0ooK^00<0
e3dI0?ofkP3om^h02`3om^h90=@m6@L0ooK^00<0e3dI0?ofkP3om^h01P3D?AT00`3om^h0e3dI0?of
kP030?ofkP030=@m6@3om^h0ooK^04L0ooK^00<000000?ofkP3om^h0@@3om^h00`000000ooK^0?of
kP230?ofkP40oooo001m0?ofkP@000008P3om^h20=@m6@/0ooK^0P3D?AT?0?ofkP030=@m6@3om^h0
ooK^00D0ooK^2P3D?AT60?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h0B03om^h0
0`000000ooK^0?ofkP0o0?ofkP800000QP3om^h10?ooo`00P@3om^h400000200ooK^0P3D?AT80?of
kP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP070?of
kP040=@m6@3om^h0ooK^0?ofkP80e3dIB`3om^h00`000000ooK^0?ofkP0n0?ofkP030000003om^h0
ooK^08H0ooK^0@3oool008D0ooK^1000000N0?ofkP80e3dI1@3om^h00`3D?AT0ooK^0?ofkP0>0?of
kP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h01P3om^h20=@m6@80ooK^0P3D?AU=0?of
kP030000003om^h0ooK^03`0ooK^0P0000290?ofkP40oooo00290?ofkP<000007@3om^h20=@m6@80
ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00H0
ooK^00<0e3dI0?ofkP3om^h00P3D?AU?0?ofkP030000003om^h0ooK^03/0ooK^00<000000?ofkP3o
m^h0R@3om^h10?ooo`00S03om^h4000001/0ooK^0`3D?AT?0?ofkP030=@m6@3om^h0ooK^00X0ooK^
0P3D?AT80?ofkP040=@m6@3om^h0e3dI0=@m6E40ooK^00<000000?ofkP3om^h0>@3om^h2000008`0
ooK^0@3oool00900ooK^1000000J0?ofkP<0e3dI2`3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m
6@3om^h0ooK^00L0ooK^0`3D?AUC0?ofkP030000003om^h0ooK^03P0ooK^00<000000?ofkP3om^h0
S03om^h10?ooo`00U03om^h4000001T0ooK^103D?AT60?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0
e3dI0?ofkP3om^h01@3om^h40=@m6ED0ooK^00<000000?ofkP3om^h0=P3om^h2000008l0ooK^0@3o
ool009P0ooK^1000000I0?ofkP<0e3dI0P3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0
ooK^00H0e3dIF@3om^h00`000000ooK^0?ofkP0e0?ofkP030000003om^h0ooK^08l0ooK^0@3oool0
09`0ooK^1000000H0?ofkQ80e3dIG`3om^h00`000000ooK^0?ofkP0c0?ofkP800000TP3om^h10?oo
o`00X03om^h4000008D0ooK^00<000000?ofkP3om^h0<P3om^h00`000000ooK^0?ofkP2B0?ofkP40
oooo002T0?ofkP@00000PP3om^h00`000000ooK^0?ofkP0`0?ofkP030000003om^h0ooK^09<0ooK^
0@3oool00:P0ooK^1000001n0?ofkP030000003om^h0ooK^02h0ooK^0P00002F0?ofkP40oooo002/
0?ofkP@00000NP3om^h00`000000ooK^0?ofkP0]0?ofkP030000003om^h0ooK^09H0ooK^0@3oool0
0;00ooK^1000001f0?ofkP030000003om^h0ooK^02/0ooK^0P00002I0?ofkP40oooo002d0?ofkP@0
0000LP3om^h00`000000ooK^0?ofkP0Z0?ofkP030000003om^h0ooK^09T0ooK^0@3oool00;P0ooK^
1000001^0?ofkP030000003om^h0ooK^02P0ooK^0P00002L0?ofkP40oooo002l0?ofkP@00000JP3o
m^h00`000000ooK^0?ofkP0W0?ofkP030000003om^h0ooK^09`0ooK^0@3oool00<00ooK^0`00001W
0?ofkP030000003om^h0ooK^02D0ooK^0P00002O0?ofkP40oooo00330?ofkP@00000H`3om^h00`00
0000ooK^0?ofkP0T0?ofkP030000003om^h0ooK^09l0ooK^0@3oool00<L0ooK^1000001O0?ofkP03
0000003om^h0ooK^0280ooK^0P00002R0?ofkP40oooo003;0?ofkP@00000F`3om^h00`000000ooK^
0?ofkP0Q0?ofkP030000003om^h0ooK^0:80ooK^0@3oool00<l0ooK^1000001G0?ofkP030000003o
m^h0ooK^01l0ooK^0P00002U0?ofkP40oooo003C0?ofkP@00000D`3om^h00`000000ooK^0?ofkP0N
0?ofkP030000003om^h0ooK^0:D0ooK^0@3oool00=L0ooK^1000001?0?ofkP030000003om^h0ooK^
01`0ooK^0P00002X0?ofkP40oooo003K0?ofkP@00000B`3om^h00`000000ooK^0?ofkP0K0?ofkP03
0000003om^h0ooK^0:P0ooK^0@3oool00=l0ooK^100000170?ofkP030000003om^h0ooK^01X0ooK^
00<000000?ofkP3om^h0Z@3om^h10?ooo`00h`3om^h4000004<0ooK^00<000000?ofkP3om^h0603o
m^h200000:`0ooK^0@3oool00>L0ooK^1000000o0?ofkP030000003om^h0ooK^01L0ooK^00<00000
0?ofkP3om^h0[03om^h10?ooo`00j`3om^h4000003/0ooK^00<000000?ofkP3om^h05@3om^h20000
0:l0ooK^0@3oool00>l0ooK^1000000g0?ofkP030000003om^h0ooK^01@0ooK^00<000000?ofkP3o
m^h0[`3om^h10?ooo`00l`3om^h3000003@0ooK^00<000000?ofkP3om^h04P3om^h200000;80ooK^
0@3oool00?H0ooK^1000000`0?ofkP030000003om^h0ooK^0140ooK^00<000000?ofkP3om^h0/P3o
m^h10?ooo`00nP3om^h4000002`0ooK^00<000000?ofkP3om^h03`3om^h200000;D0ooK^0@3oool0
0?h0ooK^1000000Y0?ofkP030000003om^h0ooK^00d0ooK^00<000000?ofkP3om^h0]@3om^h10?oo
o`00o`3om^h30?ofkP@000009@3om^h00`000000ooK^0?ofkP0;0?ofkP800000^03om^h10?ooo`00
o`3om^h70?ofkP@000008@3om^h00`000000ooK^0?ofkP0:0?ofkP030000003om^h0ooK^0;P0ooK^
0@3oool00?l0ooK^2`3om^h4000001d0ooK^00<000000?ofkP3om^h0203om^h200000;/0ooK^0@3o
ool00?l0ooK^3`3om^h4000001T0ooK^00<000000?ofkP3om^h01`3om^h00`000000ooK^0?ofkP2k
0?ofkP40oooo003o0?ofkQ<0ooK^1000000E0?ofkP030000003om^h0ooK^00H0ooK^00<000000?of
kP3om^h0_03om^h10?ooo`00o`3om^hG0?ofkP@000004@3om^h00`000000ooK^0?ofkP040?ofkP80
0000_`3om^h10?ooo`00o`3om^hK0?ofkP@000003@3om^h00`000000ooK^0?ofkP030?ofkP030000
003om^h0ooK^0;l0ooK^0@3oool00?l0ooK^7`3om^h4000000T0ooK^00@000000?ofkP3om^h0ooK^
0P0000320?ofkP40oooo003o0?ofkR<0ooK^100000050?ofkP040000003om^h0ooK^00000<@0ooK^
0@3oool00?l0ooK^9`3om^h4000000040?ofkP000000000000000<D0ooK^0@3oool00?l0ooK^:`3o
m^h200000<L0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0
ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool0
0?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03o
m^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00
o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?of
kP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o
0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^
0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0
ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h1
0?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3o
m^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40
oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?of
k_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3o
ool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^
m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?oo
o`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd
0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo
003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0
ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool0
0?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03o
m^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00
o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?of
kP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o
0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00\
\>"],
  ImageRangeCache->{{{0, 499}, {499, 0}} -> {-5.00005*^-06, -5.00005*^-06, \
0.00200403, 0.00200403}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
%%ImageSize: 500 500 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics3D
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Background color
1 .961 .933 r
MFill
% Scaling calculations
0 1 0 1 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 0 r
.25 Mabswid
[ ] 0 setdash
.5 .60969 m
.5 .84126 L
s
.5 .84126 m
.97811 .6366 L
s
.97811 .6366 m
.92347 .37901 L
s
.92347 .37901 m
.5 .60969 L
s
.07653 .37901 m
.5 .02321 L
s
.5 .02321 m
.5 .30205 L
s
.5 .30205 m
.02189 .6366 L
s
.02189 .6366 m
.07653 .37901 L
s
.5 .60969 m
.5 .84126 L
s
.5 .84126 m
.02189 .6366 L
s
.02189 .6366 m
.07653 .37901 L
s
.07653 .37901 m
.5 .60969 L
s
.92347 .37901 m
.5 .02321 L
s
.5 .02321 m
.5 .30205 L
s
.5 .30205 m
.97811 .6366 L
s
.97811 .6366 m
.92347 .37901 L
s
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
.83 .24 .1 r
.5 Mabswid
.36454 .54698 m
.38003 .56857 L
s
.38003 .56857 m
.40454 .55382 L
s
.38003 .56857 m
.39252 .59209 L
s
.24 .35 .67 r
.63546 .54698 m
.61997 .56857 L
s
.61997 .56857 m
.59546 .55382 L
s
.61997 .56857 m
.60748 .59209 L
s
.83 .24 .1 r
.39252 .59209 m
.41723 .57763 L
s
.39252 .59209 m
.40156 .6167 L
s
.24 .35 .67 r
.60748 .59209 m
.58277 .57763 L
s
.60748 .59209 m
.59844 .6167 L
s
.83 .24 .1 r
.34659 .52807 m
.36454 .54698 L
s
.36454 .54698 m
.3889 .53191 L
s
.24 .35 .67 r
.65341 .52807 m
.63546 .54698 L
s
.63546 .54698 m
.6111 .53191 L
s
.83 .24 .1 r
.40156 .6167 m
.42649 .6025 L
s
.40156 .6167 m
.40679 .64154 L
s
.24 .35 .67 r
.59844 .6167 m
.57351 .6025 L
s
.59844 .6167 m
.59321 .64154 L
s
.83 .24 .1 r
.32679 .51257 m
.34659 .52807 L
s
.34659 .52807 m
.37083 .51268 L
s
.24 .35 .67 r
.67321 .51257 m
.65341 .52807 L
s
.65341 .52807 m
.62917 .51268 L
s
.83 .24 .1 r
.40679 .64154 m
.43196 .62758 L
s
.40679 .64154 m
.40794 .6657 L
s
.24 .35 .67 r
.59321 .64154 m
.56804 .62758 L
s
.59321 .64154 m
.59206 .6657 L
s
.83 .24 .1 r
.3889 .53191 m
.40454 .55382 L
s
.40454 .55382 m
.42972 .53867 L
s
.40454 .55382 m
.41723 .57763 L
s
.24 .35 .67 r
.6111 .53191 m
.59546 .55382 L
s
.59546 .55382 m
.57028 .53867 L
s
.59546 .55382 m
.58277 .57763 L
s
.83 .24 .1 r
.30581 .50112 m
.32679 .51257 L
s
.32679 .51257 m
.35094 .49686 L
s
.24 .35 .67 r
.69419 .50112 m
.67321 .51257 L
s
.67321 .51257 m
.64906 .49686 L
s
.83 .24 .1 r
.41723 .57763 m
.4426 .56278 L
s
.41723 .57763 m
.42649 .6025 L
s
.24 .35 .67 r
.58277 .57763 m
.5574 .56278 L
s
.58277 .57763 m
.57351 .6025 L
s
.83 .24 .1 r
.37083 .51268 m
.3889 .53191 L
s
.3889 .53191 m
.41391 .51644 L
s
.24 .35 .67 r
.62917 .51268 m
.6111 .53191 L
s
.6111 .53191 m
.58609 .51644 L
s
.83 .24 .1 r
.42649 .6025 m
.45208 .58793 L
s
.42649 .6025 m
.43196 .62758 L
s
.24 .35 .67 r
.57351 .6025 m
.54792 .58793 L
s
.57351 .6025 m
.56804 .62758 L
s
.83 .24 .1 r
.35094 .49686 m
.37083 .51268 L
s
.37083 .51268 m
.39571 .49688 L
s
.24 .35 .67 r
.64906 .49686 m
.62917 .51268 L
s
.62917 .51268 m
.60429 .49688 L
s
.83 .24 .1 r
.40794 .6657 m
.43336 .65194 L
s
.40794 .6657 m
.40486 .68827 L
s
.24 .35 .67 r
.59206 .6657 m
.56664 .65194 L
s
.59206 .6657 m
.59514 .68827 L
s
.83 .24 .1 r
.28443 .49427 m
.30581 .50112 L
s
.30581 .50112 m
.32992 .4851 L
s
.24 .35 .67 r
.71557 .49427 m
.69419 .50112 L
s
.69419 .50112 m
.67008 .4851 L
s
.83 .24 .1 r
.43196 .62758 m
.45781 .61324 L
s
.43196 .62758 m
.43336 .65194 L
s
.24 .35 .67 r
.56804 .62758 m
.54219 .61324 L
s
.56804 .62758 m
.56664 .65194 L
s
.83 .24 .1 r
.41391 .51644 m
.42972 .53867 L
s
.42972 .53867 m
.45557 .52311 L
s
.42972 .53867 m
.4426 .56278 L
s
.24 .35 .67 r
.58609 .51644 m
.57028 .53867 L
s
.57028 .53867 m
.54443 .52311 L
s
.57028 .53867 m
.5574 .56278 L
s
.83 .24 .1 r
.32992 .4851 m
.35094 .49686 L
s
.35094 .49686 m
.37574 .48073 L
s
.24 .35 .67 r
.67008 .4851 m
.64906 .49686 L
s
.64906 .49686 m
.62426 .48073 L
s
.83 .24 .1 r
.4426 .56278 m
.46865 .54753 L
s
.4426 .56278 m
.45208 .58793 L
s
.24 .35 .67 r
.5574 .56278 m
.53135 .54753 L
s
.5574 .56278 m
.54792 .58793 L
s
.83 .24 .1 r
.39571 .49688 m
.41391 .51644 L
s
.41391 .51644 m
.43959 .50056 L
s
.24 .35 .67 r
.60429 .49688 m
.58609 .51644 L
s
.58609 .51644 m
.56041 .50056 L
s
.83 .24 .1 r
.45208 .58793 m
.47838 .57296 L
s
.45208 .58793 m
.45781 .61324 L
s
.24 .35 .67 r
.54792 .58793 m
.52162 .57296 L
s
.54792 .58793 m
.54219 .61324 L
s
.83 .24 .1 r
.40486 .68827 m
.43053 .67465 L
s
.40486 .68827 m
.39752 .70829 L
s
.24 .35 .67 r
.59514 .68827 m
.56947 .67465 L
s
.59514 .68827 m
.60248 .70829 L
s
.83 .24 .1 r
.37574 .48073 m
.39571 .49688 L
s
.39571 .49688 m
.42127 .48066 L
s
.24 .35 .67 r
.62426 .48073 m
.60429 .49688 L
s
.60429 .49688 m
.57873 .48066 L
s
.83 .24 .1 r
.43336 .65194 m
.45947 .63779 L
s
.43336 .65194 m
.43053 .67465 L
s
.24 .35 .67 r
.56664 .65194 m
.54053 .63779 L
s
.56664 .65194 m
.56947 .67465 L
s
.83 .24 .1 r
.26348 .49245 m
.28443 .49427 L
s
.28443 .49427 m
.30854 .47797 L
s
.24 .35 .67 r
.73652 .49245 m
.71557 .49427 L
s
.71557 .49427 m
.69146 .47797 L
s
.83 .24 .1 r
.30854 .47797 m
.32992 .4851 L
s
.32992 .4851 m
.35468 .46865 L
s
.24 .35 .67 r
.69146 .47797 m
.67008 .4851 L
s
.67008 .4851 m
.64532 .46865 L
s
.83 .24 .1 r
.45781 .61324 m
.48436 .59851 L
s
.45781 .61324 m
.45947 .63779 L
s
.24 .35 .67 r
.54219 .61324 m
.51564 .59851 L
s
.54219 .61324 m
.54053 .63779 L
s
.83 .24 .1 r
.43959 .50056 m
.45557 .52311 L
s
.45557 .52311 m
.48212 .50713 L
s
.45557 .52311 m
.46865 .54753 L
s
.24 .35 .67 r
.56041 .50056 m
.54443 .52311 L
s
.54443 .52311 m
.51788 .50713 L
s
.54443 .52311 m
.53135 .54753 L
s
.83 .24 .1 r
.35468 .46865 m
.37574 .48073 L
s
.37574 .48073 m
.40122 .46416 L
s
.24 .35 .67 r
.64532 .46865 m
.62426 .48073 L
s
.62426 .48073 m
.59878 .46416 L
s
.83 .24 .1 r
.46865 .54753 m
.49542 .53186 L
s
.46865 .54753 m
.47838 .57296 L
s
.24 .35 .67 r
.53135 .54753 m
.50458 .53186 L
s
.53135 .54753 m
.52162 .57296 L
s
.83 .24 .1 r
.42127 .48066 m
.43959 .50056 L
s
.43959 .50056 m
.46598 .48423 L
s
.24 .35 .67 r
.57873 .48066 m
.56041 .50056 L
s
.56041 .50056 m
.53402 .48423 L
s
.83 .24 .1 r
.47838 .57296 m
.48436 .59851 L
s
.24 .35 .67 r
.52162 .57296 m
.51564 .59851 L
s
.83 .24 .1 r
.39752 .70829 m
.42343 .69477 L
s
.39752 .70829 m
.38606 .72487 L
s
.24 .35 .67 r
.60248 .70829 m
.57657 .69477 L
s
.60248 .70829 m
.61394 .72487 L
s
.83 .24 .1 r
.43053 .67465 m
.45691 .66065 L
s
.43053 .67465 m
.42343 .69477 L
s
.24 .35 .67 r
.56947 .67465 m
.54309 .66065 L
s
.56947 .67465 m
.57657 .69477 L
s
.83 .24 .1 r
.40122 .46416 m
.42127 .48066 L
s
.42127 .48066 m
.44753 .46398 L
s
.24 .35 .67 r
.59878 .46416 m
.57873 .48066 L
s
.57873 .48066 m
.55247 .46398 L
s
.83 .24 .1 r
.45947 .63779 m
.4863 .62326 L
s
.45947 .63779 m
.45691 .66065 L
s
.24 .35 .67 r
.54053 .63779 m
.5137 .62326 L
s
.54053 .63779 m
.54309 .66065 L
s
.83 .24 .1 r
.24382 .49594 m
.26348 .49245 L
s
.26348 .49245 m
.28762 .4759 L
s
.24 .35 .67 r
.75618 .49594 m
.73652 .49245 L
s
.73652 .49245 m
.71238 .4759 L
s
.83 .24 .1 r
.28762 .4759 m
.30854 .47797 L
s
.30854 .47797 m
.3333 .46122 L
s
.24 .35 .67 r
.71238 .4759 m
.69146 .47797 L
s
.69146 .47797 m
.6667 .46122 L
s
.83 .24 .1 r
.3333 .46122 m
.35468 .46865 L
s
.35468 .46865 m
.38013 .45174 L
s
.24 .35 .67 r
.6667 .46122 m
.64532 .46865 L
s
.64532 .46865 m
.61987 .45174 L
s
.83 .24 .1 r
.46598 .48423 m
.48212 .50713 L
s
.48212 .50713 m
.49542 .53186 L
s
.24 .35 .67 r
.53402 .48423 m
.51788 .50713 L
s
.51788 .50713 m
.50458 .53186 L
s
.83 .24 .1 r
.38013 .45174 m
.40122 .46416 L
s
.40122 .46416 m
.4274 .44712 L
s
.24 .35 .67 r
.61987 .45174 m
.59878 .46416 L
s
.59878 .46416 m
.5726 .44712 L
s
.721 .205 .091 r
.51232 .54637 m .5 .55343 L .5 .52944 L p F P
0 0 0 r
s
.24 .35 .67 r
.5036 .53439 m
.50458 .53186 L
s
.667 .188 .084 r
.5 .55343 m .51232 .54637 L .51317 .56886 L p F P
0 0 0 r
s
.24 .35 .67 r
.51315 .56813 m
.52162 .57296 L
s
.667 .188 .084 r
.51317 .56886 m .5 .57626 L .5 .55343 L p F P
0 0 0 r
s
.292 .417 .795 r
.48768 .54637 m .5 .55343 L .5 .52944 L p F P
0 0 0 r
s
.83 .24 .1 r
.49542 .53186 m
.4964 .53439 L
s
.287 .407 .773 r
.5 .55343 m .48768 .54637 L .48683 .56886 L p F P
0 0 0 r
s
.83 .24 .1 r
.47838 .57296 m
.48685 .56813 L
s
.287 .407 .773 r
.48683 .56886 m .5 .57626 L .5 .55343 L p F P
0 0 0 r
s
.83 .24 .1 r
.49924 .56107 m
.50539 .55757 L
s
.24 .35 .67 r
.49461 .55757 m
.50076 .56107 L
s
.83 .24 .1 r
.44753 .46398 m
.46598 .48423 L
s
.24 .35 .67 r
.55247 .46398 m
.53402 .48423 L
s
.77 .221 .097 r
.51119 .52289 m .5 .52944 L .5 .50469 L p F P
0 0 0 r
s
.721 .205 .091 r
.5 .52944 m .51119 .52289 L .51232 .54637 L p F P
0 0 0 r
s
.296 .424 .813 r
.48881 .52289 m .5 .52944 L .5 .50469 L p F P
0 0 0 r
s
.292 .417 .795 r
.5 .52944 m .48881 .52289 L .48768 .54637 L p F P
0 0 0 r
s
.83 .24 .1 r
.49867 .54025 m
.50539 .55757 L
s
.24 .35 .67 r
.49461 .55757 m
.50133 .54025 L
s
.604 .168 .076 r
.5 .57626 m .51317 .56886 L .51374 .58997 L p F P
0 0 0 r
s
.604 .168 .076 r
.51374 .58997 m .5 .59754 L .5 .57626 L p F P
0 0 0 r
s
.24 .35 .67 r
.50697 .5937 m
.51564 .59851 L
s
.28 .394 .743 r
.5 .57626 m .48683 .56886 L .48626 .58997 L p F P
0 0 0 r
s
.28 .394 .743 r
.48626 .58997 m .5 .59754 L .5 .57626 L p F P
0 0 0 r
s
.83 .24 .1 r
.48436 .59851 m
.49303 .5937 L
s
.50539 .55757 m
.51165 .58337 L
s
.24 .35 .67 r
.48835 .58337 m
.49461 .55757 L
s
.83 .24 .1 r
.42343 .69477 m
.45007 .68087 L
s
.42343 .69477 m
.41218 .71138 L
s
.24 .35 .67 r
.57657 .69477 m
.54993 .68087 L
s
.57657 .69477 m
.58782 .71138 L
s
.83 .24 .1 r
.45691 .66065 m
.48402 .64627 L
s
.45691 .66065 m
.45007 .68087 L
s
.24 .35 .67 r
.54309 .66065 m
.51598 .64627 L
s
.54309 .66065 m
.54993 .68087 L
s
.815 .235 .102 r
.50981 .49883 m .5 .50469 L .5 .47958 L p F P
0 0 0 r
s
.24 .35 .67 r
.50693 .50055 m
.51788 .50713 L
s
.77 .221 .097 r
.5 .50469 m .50981 .49883 L .51119 .52289 L p F P
0 0 0 r
s
.298 .43 .827 r
.49019 .49883 m .5 .50469 L .5 .47958 L p F P
0 0 0 r
s
.83 .24 .1 r
.48212 .50713 m
.49307 .50055 L
s
.296 .424 .813 r
.5 .50469 m .49019 .49883 L .48881 .52289 L p F P
0 0 0 r
s
.83 .24 .1 r
.38606 .72487 m
.41218 .71138 L
s
.38606 .72487 m
.37078 .73714 L
s
.24 .35 .67 r
.61394 .72487 m
.58782 .71138 L
s
.61394 .72487 m
.62922 .73714 L
s
.83 .24 .1 r
.4274 .44712 m
.44753 .46398 L
s
.44753 .46398 m
.47453 .44684 L
s
.24 .35 .67 r
.5726 .44712 m
.55247 .46398 L
s
.55247 .46398 m
.52547 .44684 L
s
.528 .145 .066 r
.5 .59754 m .51374 .58997 L .51401 .60931 L p F P
0 0 0 r
s
.528 .145 .066 r
.51401 .60931 m .5 .6169 L .5 .59754 L p F P
0 0 0 r
s
.24 .35 .67 r
.5137 .62326 m
.51564 .59851 L
s
.269 .375 .705 r
.5 .59754 m .48626 .58997 L .48599 .60931 L p F P
0 0 0 r
s
.83 .24 .1 r
.49928 .59023 m
.51165 .58337 L
s
.24 .35 .67 r
.48835 .58337 m
.50072 .59023 L
s
.269 .375 .705 r
.48599 .60931 m .5 .6169 L .5 .59754 L p F P
0 0 0 r
s
.83 .24 .1 r
.48436 .59851 m
.4863 .62326 L
s
.721 .205 .091 r
.52479 .53922 m .51232 .54637 L .51119 .52289 L p F P
0 0 0 r
s
.667 .188 .084 r
.51232 .54637 m .52479 .53922 L .52652 .56136 L p F P
0 0 0 r
s
.667 .188 .084 r
.52652 .56136 m .51317 .56886 L .51232 .54637 L p F P
0 0 0 r
s
.292 .417 .795 r
.47521 .53922 m .48768 .54637 L .48881 .52289 L p F P
0 0 0 r
s
.287 .407 .773 r
.48768 .54637 m .47521 .53922 L .47348 .56136 L p F P
0 0 0 r
s
.287 .407 .773 r
.47348 .56136 m .48683 .56886 L .48768 .54637 L p F P
0 0 0 r
s
.77 .221 .097 r
.52251 .51627 m .51119 .52289 L .50981 .49883 L p F P
0 0 0 r
s
.721 .205 .091 r
.51119 .52289 m .52251 .51627 L .52479 .53922 L p F P
0 0 0 r
s
.296 .424 .813 r
.47749 .51627 m .48881 .52289 L .49019 .49883 L p F P
0 0 0 r
s
.292 .417 .795 r
.48881 .52289 m .47749 .51627 L .47521 .53922 L p F P
0 0 0 r
s
.83 .24 .1 r
.26804 .4792 m
.28762 .4759 L
s
.28762 .4759 m
.31243 .45889 L
s
.24 .35 .67 r
.73196 .4792 m
.71238 .4759 L
s
.71238 .4759 m
.68757 .45889 L
s
.83 .24 .1 r
.31243 .45889 m
.3333 .46122 L
s
.3333 .46122 m
.35876 .444 L
s
.24 .35 .67 r
.68757 .45889 m
.6667 .46122 L
s
.6667 .46122 m
.64124 .444 L
s
.83 .24 .1 r
.22636 .50483 m
.24382 .49594 L
s
.24382 .49594 m
.26804 .4792 L
s
.24 .35 .67 r
.77364 .50483 m
.75618 .49594 L
s
.75618 .49594 m
.73196 .4792 L
s
.604 .168 .076 r
.51317 .56886 m .52652 .56136 L .52768 .58229 L p F P
0 0 0 r
s
.604 .168 .076 r
.52768 .58229 m .51374 .58997 L .51317 .56886 L p F P
0 0 0 r
s
.28 .394 .743 r
.48683 .56886 m .47348 .56136 L .47232 .58229 L p F P
0 0 0 r
s
.28 .394 .743 r
.47232 .58229 m .48626 .58997 L .48683 .56886 L p F P
0 0 0 r
s
.83 .24 .1 r
.35876 .444 m
.38013 .45174 L
s
.38013 .45174 m
.40629 .43436 L
s
.24 .35 .67 r
.64124 .444 m
.61987 .45174 L
s
.61987 .45174 m
.59371 .43436 L
s
.815 .235 .102 r
.5 .47958 m .5082 .47458 L .50981 .49883 L p F P
0 0 0 r
s
.815 .235 .102 r
.51972 .49291 m .50981 .49883 L .5082 .47458 L p F P
0 0 0 r
s
.77 .221 .097 r
.50981 .49883 m .51972 .49291 L .52251 .51627 L p F P
0 0 0 r
s
.298 .43 .827 r
.5 .47958 m .4918 .47458 L .49019 .49883 L p F P
0 0 0 r
s
.83 .24 .1 r
.49892 .49702 m
.50942 .4907 L
s
.298 .43 .827 r
.48028 .49291 m .49019 .49883 L .4918 .47458 L p F P
0 0 0 r
s
.24 .35 .67 r
.49058 .4907 m
.50108 .49702 L
s
.296 .424 .813 r
.49019 .49883 m .48028 .49291 L .47749 .51627 L p F P
0 0 0 r
s
.858 .248 .108 r
.5082 .47458 m .5 .47958 L .5 .45454 L p F P
0 0 0 r
s
.24 .35 .67 r
.5069 .46746 m
.53402 .48423 L
s
.299 .434 .837 r
.4918 .47458 m .5 .47958 L .5 .45454 L p F P
0 0 0 r
s
.83 .24 .1 r
.46598 .48423 m
.4931 .46746 L
s
.77 .221 .097 r
.53395 .50958 m .52251 .51627 L .51972 .49291 L p F P
0 0 0 r
s
.721 .205 .091 r
.52251 .51627 m .53395 .50958 L .53742 .53199 L p F P
0 0 0 r
s
.721 .205 .091 r
.53742 .53199 m .52479 .53922 L .52251 .51627 L p F P
0 0 0 r
s
.83 .24 .1 r
.49887 .52984 m
.52293 .51576 L
s
.296 .424 .813 r
.46605 .50958 m .47749 .51627 L .48028 .49291 L p F P
0 0 0 r
s
.292 .417 .795 r
.47749 .51627 m .46605 .50958 L .46258 .53199 L p F P
0 0 0 r
s
.292 .417 .795 r
.46258 .53199 m .47521 .53922 L .47749 .51627 L p F P
0 0 0 r
s
.24 .35 .67 r
.47707 .51576 m
.50113 .52984 L
s
.667 .188 .084 r
.52479 .53922 m .53742 .53199 L .54006 .55376 L p F P
0 0 0 r
s
.667 .188 .084 r
.54006 .55376 m .52652 .56136 L .52479 .53922 L p F P
0 0 0 r
s
.287 .407 .773 r
.47521 .53922 m .46258 .53199 L .45994 .55376 L p F P
0 0 0 r
s
.287 .407 .773 r
.45994 .55376 m .47348 .56136 L .47521 .53922 L p F P
0 0 0 r
s
.83 .24 .1 r
.49778 .47412 m
.50942 .4907 L
s
.4931 .46746 m
.49412 .46891 L
s
.50942 .4907 m
.52293 .51576 L
s
.24 .35 .67 r
.49058 .4907 m
.50222 .47412 L
s
.50588 .46891 m
.5069 .46746 L
s
.47707 .51576 m
.49058 .4907 L
s
.528 .145 .066 r
.51374 .58997 m .52768 .58229 L .52823 .60162 L p F P
0 0 0 r
s
.528 .145 .066 r
.52823 .60162 m .51401 .60931 L .51374 .58997 L p F P
0 0 0 r
s
.83 .24 .1 r
.51165 .58337 m
.51389 .60832 L
s
.269 .375 .705 r
.48626 .58997 m .47232 .58229 L .47177 .60162 L p F P
0 0 0 r
s
.269 .375 .705 r
.47177 .60162 m .48599 .60931 L .48626 .58997 L p F P
0 0 0 r
s
.24 .35 .67 r
.48611 .60832 m
.48835 .58337 L
s
.435 .116 .054 r
.5 .6169 m .51401 .60931 L .51397 .62651 L p F P
0 0 0 r
s
.24 .35 .67 r
.51397 .62606 m
.51598 .64627 L
s
.435 .116 .054 r
.51397 .62651 m .5 .63395 L .5 .6169 L p F P
0 0 0 r
s
.254 .35 .652 r
.5 .6169 m .48599 .60931 L .48603 .62651 L p F P
0 0 0 r
s
.83 .24 .1 r
.49903 .61637 m
.51389 .60832 L
s
.24 .35 .67 r
.48611 .60832 m
.50097 .61637 L
s
.83 .24 .1 r
.48402 .64627 m
.48603 .62606 L
s
.254 .35 .652 r
.48603 .62651 m .5 .63395 L .5 .6169 L p F P
0 0 0 r
s
.83 .24 .1 r
.40629 .43436 m
.4274 .44712 L
s
.4274 .44712 m
.45433 .42961 L
s
.24 .35 .67 r
.59371 .43436 m
.5726 .44712 L
s
.5726 .44712 m
.54567 .42961 L
s
.83 .24 .1 r
.52293 .51576 m
.53316 .54176 L
s
.24 .35 .67 r
.46684 .54176 m
.47707 .51576 L
s
.815 .235 .102 r
.5082 .47458 m .51647 .46953 L .51972 .49291 L p F P
0 0 0 r
s
.815 .235 .102 r
.52972 .48693 m .51972 .49291 L .51647 .46953 L p F P
0 0 0 r
s
.77 .221 .097 r
.51972 .49291 m .52972 .48693 L .53395 .50958 L p F P
0 0 0 r
s
.298 .43 .827 r
.4918 .47458 m .48353 .46953 L .48028 .49291 L p F P
0 0 0 r
s
.298 .43 .827 r
.47028 .48693 m .48028 .49291 L .48353 .46953 L p F P
0 0 0 r
s
.296 .424 .813 r
.48028 .49291 m .47028 .48693 L .46605 .50958 L p F P
0 0 0 r
s
.604 .168 .076 r
.52652 .56136 m .54006 .55376 L .54181 .57451 L p F P
0 0 0 r
s
.83 .24 .1 r
.50539 .55757 m
.53316 .54176 L
s
.604 .168 .076 r
.54181 .57451 m .52768 .58229 L .52652 .56136 L p F P
0 0 0 r
s
.28 .394 .743 r
.47348 .56136 m .45994 .55376 L .45819 .57451 L p F P
0 0 0 r
s
.24 .35 .67 r
.46684 .54176 m
.49461 .55757 L
s
.28 .394 .743 r
.45819 .57451 m .47232 .58229 L .47348 .56136 L p F P
0 0 0 r
s
.858 .248 .108 r
.5 .45454 m .50638 .45057 L .5082 .47458 L p F P
0 0 0 r
s
.858 .248 .108 r
.51647 .46953 m .5082 .47458 L .50638 .45057 L p F P
0 0 0 r
s
.24 .35 .67 r
.51222 .46155 m
.52547 .44684 L
s
.299 .434 .837 r
.5 .45454 m .49362 .45057 L .4918 .47458 L p F P
0 0 0 r
s
.299 .434 .837 r
.48353 .46953 m .4918 .47458 L .49362 .45057 L p F P
0 0 0 r
s
.83 .24 .1 r
.47453 .44684 m
.48778 .46155 L
s
.77 .221 .097 r
.54553 .5028 m .53395 .50958 L .52972 .48693 L p F P
0 0 0 r
s
.721 .205 .091 r
.53395 .50958 m .54553 .5028 L .5502 .52466 L p F P
0 0 0 r
s
.721 .205 .091 r
.5502 .52466 m .53742 .53199 L .53395 .50958 L p F P
0 0 0 r
s
.296 .424 .813 r
.45447 .5028 m .46605 .50958 L .47028 .48693 L p F P
0 0 0 r
s
.292 .417 .795 r
.46605 .50958 m .45447 .5028 L .4498 .52466 L p F P
0 0 0 r
s
.292 .417 .795 r
.4498 .52466 m .46258 .53199 L .46605 .50958 L p F P
0 0 0 r
s
.83 .24 .1 r
.45007 .68087 m
.47745 .66657 L
s
.45007 .68087 m
.43905 .69751 L
s
.24 .35 .67 r
.54993 .68087 m
.52255 .66657 L
s
.54993 .68087 m
.56095 .69751 L
s
.667 .188 .084 r
.53742 .53199 m .5502 .52466 L .55377 .54606 L p F P
0 0 0 r
s
.667 .188 .084 r
.55377 .54606 m .54006 .55376 L .53742 .53199 L p F P
0 0 0 r
s
.83 .24 .1 r
.53316 .54176 m
.53971 .5678 L
s
.287 .407 .773 r
.46258 .53199 m .4498 .52466 L .44623 .54606 L p F P
0 0 0 r
s
.287 .407 .773 r
.44623 .54606 m .45994 .55376 L .46258 .53199 L p F P
0 0 0 r
s
.24 .35 .67 r
.46029 .5678 m
.46684 .54176 L
s
.83 .24 .1 r
.48402 .64627 m
.47745 .66657 L
s
.24 .35 .67 r
.51598 .64627 m
.52255 .66657 L
s
.83 .24 .1 r
.41218 .71138 m
.43905 .69751 L
s
.41218 .71138 m
.39708 .72362 L
s
.24 .35 .67 r
.58782 .71138 m
.56095 .69751 L
s
.58782 .71138 m
.60292 .72362 L
s
.858 .248 .108 r
.50638 .45057 m .51281 .44656 L .51647 .46953 L p F P
0 0 0 r
s
.858 .248 .108 r
.52481 .46444 m .51647 .46953 L .51281 .44656 L p F P
0 0 0 r
s
.815 .235 .102 r
.51647 .46953 m .52481 .46444 L .52972 .48693 L p F P
0 0 0 r
s
.299 .434 .837 r
.49362 .45057 m .48719 .44656 L .48353 .46953 L p F P
0 0 0 r
s
.299 .434 .837 r
.47519 .46444 m .48353 .46953 L .48719 .44656 L p F P
0 0 0 r
s
.298 .43 .827 r
.48353 .46953 m .47519 .46444 L .47028 .48693 L p F P
0 0 0 r
s
.83 .24 .1 r
.37078 .73714 m
.39708 .72362 L
s
.37078 .73714 m
.35219 .74436 L
s
.24 .35 .67 r
.62922 .73714 m
.60292 .72362 L
s
.62922 .73714 m
.64781 .74436 L
s
.815 .235 .102 r
.53983 .48089 m .52972 .48693 L .52481 .46444 L p F P
0 0 0 r
s
.77 .221 .097 r
.52972 .48693 m .53983 .48089 L .54553 .5028 L p F P
0 0 0 r
s
.298 .43 .827 r
.46017 .48089 m .47028 .48693 L .47519 .46444 L p F P
0 0 0 r
s
.296 .424 .813 r
.47028 .48693 m .46017 .48089 L .45447 .5028 L p F P
0 0 0 r
s
.528 .145 .066 r
.52768 .58229 m .54181 .57451 L .54265 .59382 L p F P
0 0 0 r
s
.528 .145 .066 r
.54265 .59382 m .52823 .60162 L .52768 .58229 L p F P
0 0 0 r
s
.83 .24 .1 r
.51165 .58337 m
.53971 .5678 L
s
.269 .375 .705 r
.47232 .58229 m .45819 .57451 L .45735 .59382 L p F P
0 0 0 r
s
.269 .375 .705 r
.45735 .59382 m .47177 .60162 L .47232 .58229 L p F P
0 0 0 r
s
.24 .35 .67 r
.46029 .5678 m
.48835 .58337 L
s
.435 .116 .054 r
.51401 .60931 m .52823 .60162 L .52814 .61897 L p F P
0 0 0 r
s
.435 .116 .054 r
.52814 .61897 m .51397 .62651 L .51401 .60931 L p F P
0 0 0 r
s
.254 .35 .652 r
.48599 .60931 m .47177 .60162 L .47186 .61897 L p F P
0 0 0 r
s
.254 .35 .652 r
.47186 .61897 m .48603 .62651 L .48599 .60931 L p F P
0 0 0 r
s
.898 .261 .113 r
.50638 .45057 m .5 .45454 L .5 .43002 L p F P
0 0 0 r
s
.298 .435 .844 r
.49362 .45057 m .5 .45454 L .5 .43002 L p F P
0 0 0 r
s
.83 .24 .1 r
.29294 .46199 m
.31243 .45889 L
s
.31243 .45889 m
.33795 .4414 L
s
.24 .35 .67 r
.70706 .46199 m
.68757 .45889 L
s
.68757 .45889 m
.66205 .4414 L
s
.83 .24 .1 r
.33795 .4414 m
.35876 .444 L
s
.35876 .444 m
.38494 .42629 L
s
.24 .35 .67 r
.66205 .4414 m
.64124 .444 L
s
.64124 .444 m
.61506 .42629 L
s
.604 .168 .076 r
.54006 .55376 m .55377 .54606 L .55615 .56661 L p F P
0 0 0 r
s
.604 .168 .076 r
.55615 .56661 m .54181 .57451 L .54006 .55376 L p F P
0 0 0 r
s
.28 .394 .743 r
.45994 .55376 m .44623 .54606 L .44385 .56661 L p F P
0 0 0 r
s
.28 .394 .743 r
.44385 .56661 m .45819 .57451 L .45994 .55376 L p F P
0 0 0 r
s
.83 .24 .1 r
.2507 .48796 m
.26804 .4792 L
s
.26804 .4792 m
.29294 .46199 L
s
.24 .35 .67 r
.7493 .48796 m
.73196 .4792 L
s
.73196 .4792 m
.70706 .46199 L
s
.319 .081 .039 r
.5 .63395 m .51397 .62651 L .51361 .64118 L p F P
0 0 0 r
s
.319 .081 .039 r
.51361 .64118 m .5 .64833 L .5 .63395 L p F P
0 0 0 r
s
.24 .35 .67 r
.50999 .64309 m
.51598 .64627 L
s
.232 .315 .578 r
.5 .63395 m .48603 .62651 L .48639 .64118 L p F P
0 0 0 r
s
.232 .315 .578 r
.48639 .64118 m .5 .64833 L .5 .63395 L p F P
0 0 0 r
s
.83 .24 .1 r
.48402 .64627 m
.49001 .64309 L
s
.49926 .63818 m
.5119 .63147 L
s
.24 .35 .67 r
.4881 .63147 m
.50074 .63818 L
s
.83 .24 .1 r
.21199 .51895 m
.22636 .50483 L
s
.22636 .50483 m
.2507 .48796 L
s
.24 .35 .67 r
.78801 .51895 m
.77364 .50483 L
s
.77364 .50483 m
.7493 .48796 L
s
.83 .24 .1 r
.38494 .42629 m
.40629 .43436 L
s
.40629 .43436 m
.43319 .41648 L
s
.24 .35 .67 r
.61506 .42629 m
.59371 .43436 L
s
.59371 .43436 m
.56681 .41648 L
s
.898 .261 .113 r
.5 .43002 m .50439 .42723 L .50638 .45057 L p F P
0 0 0 r
s
.898 .261 .113 r
.51281 .44656 m .50638 .45057 L .50439 .42723 L p F P
0 0 0 r
s
.298 .435 .844 r
.5 .43002 m .49561 .42723 L .49362 .45057 L p F P
0 0 0 r
s
.298 .435 .844 r
.48719 .44656 m .49362 .45057 L .49561 .42723 L p F P
0 0 0 r
s
.858 .248 .108 r
.51281 .44656 m .51928 .44254 L .52481 .46444 L p F P
0 0 0 r
s
.24 .35 .67 r
.51939 .44298 m
.52547 .44684 L
s
.858 .248 .108 r
.53321 .45931 m .52481 .46444 L .51928 .44254 L p F P
0 0 0 r
s
.24 .35 .67 r
.52547 .44684 m
.54567 .42961 L
s
.815 .235 .102 r
.52481 .46444 m .53321 .45931 L .53983 .48089 L p F P
0 0 0 r
s
.299 .434 .837 r
.48719 .44656 m .48072 .44254 L .47519 .46444 L p F P
0 0 0 r
s
.83 .24 .1 r
.47453 .44684 m
.48061 .44298 L
s
.299 .434 .837 r
.46679 .45931 m .47519 .46444 L .48072 .44254 L p F P
0 0 0 r
s
.83 .24 .1 r
.45433 .42961 m
.47453 .44684 L
s
.298 .43 .827 r
.47519 .46444 m .46679 .45931 L .46017 .48089 L p F P
0 0 0 r
s
.77 .221 .097 r
.55724 .49595 m .54553 .5028 L .53983 .48089 L p F P
0 0 0 r
s
.721 .205 .091 r
.54553 .5028 m .55724 .49595 L .56315 .51724 L p F P
0 0 0 r
s
.721 .205 .091 r
.56315 .51724 m .5502 .52466 L .54553 .5028 L p F P
0 0 0 r
s
.83 .24 .1 r
.52293 .51576 m
.55122 .4992 L
s
.296 .424 .813 r
.44276 .49595 m .45447 .5028 L .46017 .48089 L p F P
0 0 0 r
s
.292 .417 .795 r
.45447 .5028 m .44276 .49595 L .43685 .51724 L p F P
0 0 0 r
s
.292 .417 .795 r
.43685 .51724 m .4498 .52466 L .45447 .5028 L p F P
0 0 0 r
s
.24 .35 .67 r
.44878 .4992 m
.47707 .51576 L
s
.815 .235 .102 r
.55004 .47478 m .53983 .48089 L .53321 .45931 L p F P
0 0 0 r
s
.83 .24 .1 r
.50942 .4907 m
.53748 .47381 L
s
.77 .221 .097 r
.53983 .48089 m .55004 .47478 L .55724 .49595 L p F P
0 0 0 r
s
.298 .43 .827 r
.44996 .47478 m .46017 .48089 L .46679 .45931 L p F P
0 0 0 r
s
.24 .35 .67 r
.46252 .47381 m
.49058 .4907 L
s
.296 .424 .813 r
.46017 .48089 m .44996 .47478 L .44276 .49595 L p F P
0 0 0 r
s
.667 .188 .084 r
.5502 .52466 m .56315 .51724 L .56767 .53826 L p F P
0 0 0 r
s
.667 .188 .084 r
.56767 .53826 m .55377 .54606 L .5502 .52466 L p F P
0 0 0 r
s
.287 .407 .773 r
.4498 .52466 m .43685 .51724 L .43233 .53826 L p F P
0 0 0 r
s
.287 .407 .773 r
.43233 .53826 m .44623 .54606 L .4498 .52466 L p F P
0 0 0 r
s
.83 .24 .1 r
.53748 .47381 m
.55122 .4992 L
s
.24 .35 .67 r
.44878 .4992 m
.46252 .47381 L
s
.898 .261 .113 r
.50439 .42723 m .5088 .42443 L .51281 .44656 L p F P
0 0 0 r
s
.24 .35 .67 r
.51122 .43779 m
.51898 .44272 L
s
.898 .261 .113 r
.51928 .44254 m .51281 .44656 L .5088 .42443 L p F P
0 0 0 r
s
.298 .435 .844 r
.49561 .42723 m .4912 .42443 L .48719 .44656 L p F P
0 0 0 r
s
.83 .24 .1 r
.48102 .44272 m
.48878 .43779 L
s
.298 .435 .844 r
.48072 .44254 m .48719 .44656 L .4912 .42443 L p F P
0 0 0 r
s
.528 .145 .066 r
.54181 .57451 m .55615 .56661 L .55727 .58591 L p F P
0 0 0 r
s
.528 .145 .066 r
.55727 .58591 m .54265 .59382 L .54181 .57451 L p F P
0 0 0 r
s
.83 .24 .1 r
.53971 .5678 m
.54225 .59296 L
s
.269 .375 .705 r
.45819 .57451 m .44385 .56661 L .44273 .58591 L p F P
0 0 0 r
s
.269 .375 .705 r
.44273 .58591 m .45735 .59382 L .45819 .57451 L p F P
0 0 0 r
s
.24 .35 .67 r
.45775 .59296 m
.46029 .5678 L
s
.435 .116 .054 r
.52823 .60162 m .54265 .59382 L .54252 .61131 L p F P
0 0 0 r
s
.435 .116 .054 r
.54252 .61131 m .52814 .61897 L .52823 .60162 L p F P
0 0 0 r
s
.83 .24 .1 r
.51389 .60832 m
.54225 .59296 L
s
.254 .35 .652 r
.47177 .60162 m .45735 .59382 L .45748 .61131 L p F P
0 0 0 r
s
.254 .35 .652 r
.45748 .61131 m .47186 .61897 L .47177 .60162 L p F P
0 0 0 r
s
.24 .35 .67 r
.45775 .59296 m
.48611 .60832 L
s
.83 .24 .1 r
.43319 .41648 m
.45433 .42961 L
s
.24 .35 .67 r
.56681 .41648 m
.54567 .42961 L
s
.858 .248 .108 r
.51928 .44254 m .52579 .43848 L .53321 .45931 L p F P
0 0 0 r
s
.83 .24 .1 r
.49864 .46403 m
.52099 .45021 L
s
.858 .248 .108 r
.54169 .45414 m .53321 .45931 L .52579 .43848 L p F P
0 0 0 r
s
.815 .235 .102 r
.53321 .45931 m .54169 .45414 L .55004 .47478 L p F P
0 0 0 r
s
.83 .24 .1 r
.52099 .45021 m
.53748 .47381 L
s
.299 .434 .837 r
.48072 .44254 m .47421 .43848 L .46679 .45931 L p F P
0 0 0 r
s
.24 .35 .67 r
.47901 .45021 m
.50136 .46403 L
s
.299 .434 .837 r
.45831 .45414 m .46679 .45931 L .47421 .43848 L p F P
0 0 0 r
s
.298 .43 .827 r
.46679 .45931 m .45831 .45414 L .44996 .47478 L p F P
0 0 0 r
s
.24 .35 .67 r
.46252 .47381 m
.47901 .45021 L
s
.604 .168 .076 r
.55377 .54606 m .56767 .53826 L .57068 .5586 L p F P
0 0 0 r
s
.83 .24 .1 r
.53316 .54176 m
.56172 .5255 L
s
.604 .168 .076 r
.57068 .5586 m .55615 .56661 L .55377 .54606 L p F P
0 0 0 r
s
.28 .394 .743 r
.44623 .54606 m .43233 .53826 L .42932 .5586 L p F P
0 0 0 r
s
.24 .35 .67 r
.43828 .5255 m
.46684 .54176 L
s
.28 .394 .743 r
.42932 .5586 m .44385 .56661 L .44623 .54606 L p F P
0 0 0 r
s
.319 .081 .039 r
.51397 .62651 m .52814 .61897 L .52741 .63394 L p F P
0 0 0 r
s
.319 .081 .039 r
.52741 .63394 m .51361 .64118 L .51397 .62651 L p F P
0 0 0 r
s
.83 .24 .1 r
.5119 .63147 m
.51389 .60832 L
s
.232 .315 .578 r
.48603 .62651 m .47186 .61897 L .47259 .63394 L p F P
0 0 0 r
s
.232 .315 .578 r
.47259 .63394 m .48639 .64118 L .48603 .62651 L p F P
0 0 0 r
s
.24 .35 .67 r
.48611 .60832 m
.4881 .63147 L
s
.77 .221 .097 r
.56908 .48902 m .55724 .49595 L .55004 .47478 L p F P
0 0 0 r
s
.721 .205 .091 r
.55724 .49595 m .56908 .48902 L .57627 .50972 L p F P
0 0 0 r
s
.721 .205 .091 r
.57627 .50972 m .56315 .51724 L .55724 .49595 L p F P
0 0 0 r
s
.83 .24 .1 r
.55122 .4992 m
.56172 .5255 L
s
.296 .424 .813 r
.43092 .48902 m .44276 .49595 L .44996 .47478 L p F P
0 0 0 r
s
.292 .417 .795 r
.44276 .49595 m .43092 .48902 L .42373 .50972 L p F P
0 0 0 r
s
.292 .417 .795 r
.42373 .50972 m .43685 .51724 L .44276 .49595 L p F P
0 0 0 r
s
.24 .35 .67 r
.43828 .5255 m
.44878 .4992 L
s
.815 .235 .102 r
.56035 .46862 m .55004 .47478 L .54169 .45414 L p F P
0 0 0 r
s
.77 .221 .097 r
.55004 .47478 m .56035 .46862 L .56908 .48902 L p F P
0 0 0 r
s
.298 .43 .827 r
.43965 .46862 m .44996 .47478 L .45831 .45414 L p F P
0 0 0 r
s
.296 .424 .813 r
.44996 .47478 m .43965 .46862 L .43092 .48902 L p F P
0 0 0 r
s
.898 .261 .113 r
.5088 .42443 m .51323 .42162 L .51928 .44254 L p F P
0 0 0 r
s
.898 .261 .113 r
.52579 .43848 m .51928 .44254 L .51323 .42162 L p F P
0 0 0 r
s
.298 .435 .844 r
.4912 .42443 m .48677 .42162 L .48072 .44254 L p F P
0 0 0 r
s
.298 .435 .844 r
.47421 .43848 m .48072 .44254 L .48677 .42162 L p F P
0 0 0 r
s
.667 .188 .084 r
.56315 .51724 m .57627 .50972 L .58176 .53034 L p F P
0 0 0 r
s
.667 .188 .084 r
.58176 .53034 m .56767 .53826 L .56315 .51724 L p F P
0 0 0 r
s
.287 .407 .773 r
.43685 .51724 m .42373 .50972 L .41824 .53034 L p F P
0 0 0 r
s
.287 .407 .773 r
.41824 .53034 m .43233 .53826 L .43685 .51724 L p F P
0 0 0 r
s
.938 .274 .118 r
.50439 .42723 m .5 .43002 L .5 .4065 L p F P
0 0 0 r
s
.296 .435 .847 r
.49561 .42723 m .5 .43002 L .5 .4065 L p F P
0 0 0 r
s
.24 .35 .67 r
.49771 .42921 m
.50258 .43231 L
s
.83 .24 .1 r
.49742 .43231 m
.50229 .42921 L
s
.858 .248 .108 r
.52579 .43848 m .53234 .4344 L .54169 .45414 L p F P
0 0 0 r
s
.858 .248 .108 r
.55024 .44892 m .54169 .45414 L .53234 .4344 L p F P
0 0 0 r
s
.815 .235 .102 r
.54169 .45414 m .55024 .44892 L .56035 .46862 L p F P
0 0 0 r
s
.299 .434 .837 r
.47421 .43848 m .46766 .4344 L .45831 .45414 L p F P
0 0 0 r
s
.299 .434 .837 r
.44976 .44892 m .45831 .45414 L .46766 .4344 L p F P
0 0 0 r
s
.298 .43 .827 r
.45831 .45414 m .44976 .44892 L .43965 .46862 L p F P
0 0 0 r
s
.83 .24 .1 r
.47745 .66657 m
.46668 .68324 L
s
.24 .35 .67 r
.52255 .66657 m
.53332 .68324 L
s
.83 .24 .1 r
.43905 .69751 m
.46668 .68324 L
s
.43905 .69751 m
.42414 .70971 L
s
.24 .35 .67 r
.56095 .69751 m
.53332 .68324 L
s
.56095 .69751 m
.57586 .70971 L
s
.898 .261 .113 r
.51323 .42162 m .51768 .41879 L .52579 .43848 L p F P
0 0 0 r
s
.898 .261 .113 r
.53234 .4344 m .52579 .43848 L .51768 .41879 L p F P
0 0 0 r
s
.83 .24 .1 r
.50229 .42921 m
.52099 .45021 L
s
.298 .435 .844 r
.48677 .42162 m .48232 .41879 L .47421 .43848 L p F P
0 0 0 r
s
.298 .435 .844 r
.46766 .4344 m .47421 .43848 L .48232 .41879 L p F P
0 0 0 r
s
.24 .35 .67 r
.47901 .45021 m
.49771 .42921 L
s
.938 .274 .118 r
.5 .4065 m .50225 .40504 L .50439 .42723 L p F P
0 0 0 r
s
.938 .274 .118 r
.5088 .42443 m .50439 .42723 L .50225 .40504 L p F P
0 0 0 r
s
.296 .435 .847 r
.5 .4065 m .49775 .40504 L .49561 .42723 L p F P
0 0 0 r
s
.296 .435 .847 r
.4912 .42443 m .49561 .42723 L .49775 .40504 L p F P
0 0 0 r
s
.83 .24 .1 r
.39708 .72362 m
.42414 .70971 L
s
.39708 .72362 m
.37862 .73074 L
s
.24 .35 .67 r
.60292 .72362 m
.57586 .70971 L
s
.60292 .72362 m
.62138 .73074 L
s
.528 .145 .066 r
.55615 .56661 m .57068 .5586 L .57211 .57788 L p F P
0 0 0 r
s
.528 .145 .066 r
.57211 .57788 m .55727 .58591 L .55615 .56661 L p F P
0 0 0 r
s
.269 .375 .705 r
.44385 .56661 m .42932 .5586 L .42789 .57788 L p F P
0 0 0 r
s
.269 .375 .705 r
.42789 .57788 m .44273 .58591 L .44385 .56661 L p F P
0 0 0 r
s
.215 .055 .025 r
.5 .64833 m .51361 .64118 L .51292 .65296 L p F P
0 0 0 r
s
.215 .055 .025 r
.51292 .65296 m .5 .65967 L .5 .64833 L p F P
0 0 0 r
s
.24 .35 .67 r
.50468 .65724 m
.52255 .66657 L
s
.83 .24 .1 r
.50563 .65186 m
.5119 .63147 L
s
.199 .262 .472 r
.5 .64833 m .48639 .64118 L .48708 .65296 L p F P
0 0 0 r
s
.199 .262 .472 r
.48708 .65296 m .5 .65967 L .5 .64833 L p F P
0 0 0 r
s
.24 .35 .67 r
.4881 .63147 m
.49437 .65186 L
s
.83 .24 .1 r
.47745 .66657 m
.49532 .65724 L
s
.49921 .65521 m
.50563 .65186 L
s
.24 .35 .67 r
.49437 .65186 m
.50079 .65521 L
s
.435 .116 .054 r
.54265 .59382 m .55727 .58591 L .5571 .60355 L p F P
0 0 0 r
s
.435 .116 .054 r
.5571 .60355 m .54252 .61131 L .54265 .59382 L p F P
0 0 0 r
s
.254 .35 .652 r
.45735 .59382 m .44273 .58591 L .4429 .60355 L p F P
0 0 0 r
s
.254 .35 .652 r
.4429 .60355 m .45748 .61131 L .45735 .59382 L p F P
0 0 0 r
s
.83 .24 .1 r
.35219 .74436 m
.37862 .73074 L
s
.35219 .74436 m
.33101 .74598 L
s
.24 .35 .67 r
.64781 .74436 m
.62138 .73074 L
s
.64781 .74436 m
.66899 .74598 L
s
.815 .235 .102 r
.57077 .4624 m .56035 .46862 L .55024 .44892 L p F P
0 0 0 r
s
.77 .221 .097 r
.56035 .46862 m .57077 .4624 L .58107 .482 L p F P
0 0 0 r
s
.77 .221 .097 r
.58107 .482 m .56908 .48902 L .56035 .46862 L p F P
0 0 0 r
s
.298 .43 .827 r
.42923 .4624 m .43965 .46862 L .44976 .44892 L p F P
0 0 0 r
s
.296 .424 .813 r
.43965 .46862 m .42923 .4624 L .41893 .482 L p F P
0 0 0 r
s
.296 .424 .813 r
.41893 .482 m .43092 .48902 L .43965 .46862 L p F P
0 0 0 r
s
.604 .168 .076 r
.56767 .53826 m .58176 .53034 L .58543 .55048 L p F P
0 0 0 r
s
.604 .168 .076 r
.58543 .55048 m .57068 .5586 L .56767 .53826 L p F P
0 0 0 r
s
.83 .24 .1 r
.56172 .5255 m
.56856 .5518 L
s
.53971 .5678 m
.56856 .5518 L
s
.28 .394 .743 r
.43233 .53826 m .41824 .53034 L .41457 .55048 L p F P
0 0 0 r
s
.28 .394 .743 r
.41457 .55048 m .42932 .5586 L .43233 .53826 L p F P
0 0 0 r
s
.24 .35 .67 r
.43144 .5518 m
.43828 .5255 L
s
.43144 .5518 m
.46029 .5678 L
s
.721 .205 .091 r
.56908 .48902 m .58107 .482 L .58955 .50211 L p F P
0 0 0 r
s
.721 .205 .091 r
.58955 .50211 m .57627 .50972 L .56908 .48902 L p F P
0 0 0 r
s
.83 .24 .1 r
.55122 .4992 m
.58032 .48217 L
s
.292 .417 .795 r
.43092 .48902 m .41893 .482 L .41045 .50211 L p F P
0 0 0 r
s
.292 .417 .795 r
.41045 .50211 m .42373 .50972 L .43092 .48902 L p F P
0 0 0 r
s
.24 .35 .67 r
.41968 .48217 m
.44878 .4992 L
s
.83 .24 .1 r
.31857 .44427 m
.33795 .4414 L
s
.33795 .4414 m
.3642 .4234 L
s
.24 .35 .67 r
.68143 .44427 m
.66205 .4414 L
s
.66205 .4414 m
.6358 .4234 L
s
.83 .24 .1 r
.3642 .4234 m
.38494 .42629 L
s
.38494 .42629 m
.41188 .40807 L
s
.24 .35 .67 r
.6358 .4234 m
.61506 .42629 L
s
.61506 .42629 m
.58812 .40807 L
s
.938 .274 .118 r
.50225 .40504 m .50451 .40358 L .5088 .42443 L p F P
0 0 0 r
s
.938 .274 .118 r
.51323 .42162 m .5088 .42443 L .50451 .40358 L p F P
0 0 0 r
s
.296 .435 .847 r
.49775 .40504 m .49549 .40358 L .4912 .42443 L p F P
0 0 0 r
s
.24 .35 .67 r
.49771 .42921 m
.50511 .42278 L
s
.296 .435 .847 r
.48677 .42162 m .4912 .42443 L .49549 .40358 L p F P
0 0 0 r
s
.83 .24 .1 r
.49489 .42278 m
.50229 .42921 L
s
.27574 .47061 m
.29294 .46199 L
s
.29294 .46199 m
.31857 .44427 L
s
.24 .35 .67 r
.72426 .47061 m
.70706 .46199 L
s
.70706 .46199 m
.68143 .44427 L
s
.858 .248 .108 r
.53234 .4344 m .53893 .43029 L .55024 .44892 L p F P
0 0 0 r
s
.858 .248 .108 r
.55886 .44366 m .55024 .44892 L .53893 .43029 L p F P
0 0 0 r
s
.815 .235 .102 r
.55024 .44892 m .55886 .44366 L .57077 .4624 L p F P
0 0 0 r
s
.299 .434 .837 r
.46766 .4344 m .46107 .43029 L .44976 .44892 L p F P
0 0 0 r
s
.299 .434 .837 r
.44114 .44366 m .44976 .44892 L .46107 .43029 L p F P
0 0 0 r
s
.298 .43 .827 r
.44976 .44892 m .44114 .44366 L .42923 .4624 L p F P
0 0 0 r
s
.898 .261 .113 r
.51768 .41879 m .52215 .41595 L .53234 .4344 L p F P
0 0 0 r
s
.898 .261 .113 r
.53893 .43029 m .53234 .4344 L .52215 .41595 L p F P
0 0 0 r
s
.298 .435 .844 r
.48232 .41879 m .47785 .41595 L .46766 .4344 L p F P
0 0 0 r
s
.298 .435 .844 r
.46107 .43029 m .46766 .4344 L .47785 .41595 L p F P
0 0 0 r
s
.319 .081 .039 r
.52814 .61897 m .54252 .61131 L .5414 .62659 L p F P
0 0 0 r
s
.319 .081 .039 r
.5414 .62659 m .52741 .63394 L .52814 .61897 L p F P
0 0 0 r
s
.83 .24 .1 r
.5119 .63147 m
.54059 .61625 L
s
.232 .315 .578 r
.47186 .61897 m .45748 .61131 L .4586 .62659 L p F P
0 0 0 r
s
.232 .315 .578 r
.4586 .62659 m .47259 .63394 L .47186 .61897 L p F P
0 0 0 r
s
.24 .35 .67 r
.45941 .61625 m
.4881 .63147 L
s
.83 .24 .1 r
.23648 .50203 m
.2507 .48796 L
s
.2507 .48796 m
.27574 .47061 L
s
.24 .35 .67 r
.76352 .50203 m
.7493 .48796 L
s
.7493 .48796 m
.72426 .47061 L
s
.83 .24 .1 r
.20151 .53787 m
.21199 .51895 L
s
.21199 .51895 m
.23648 .50203 L
s
.24 .35 .67 r
.79849 .53787 m
.78801 .51895 L
s
.78801 .51895 m
.76352 .50203 L
s
.667 .188 .084 r
.57627 .50972 m .58955 .50211 L .59605 .52232 L p F P
0 0 0 r
s
.667 .188 .084 r
.59605 .52232 m .58176 .53034 L .57627 .50972 L p F P
0 0 0 r
s
.287 .407 .773 r
.42373 .50972 m .41045 .50211 L .40395 .52232 L p F P
0 0 0 r
s
.287 .407 .773 r
.40395 .52232 m .41824 .53034 L .42373 .50972 L p F P
0 0 0 r
s
.938 .274 .118 r
.50451 .40358 m .50677 .40212 L .51323 .42162 L p F P
0 0 0 r
s
.938 .274 .118 r
.51768 .41879 m .51323 .42162 L .50677 .40212 L p F P
0 0 0 r
s
.296 .435 .847 r
.49549 .40358 m .49323 .40212 L .48677 .42162 L p F P
0 0 0 r
s
.296 .435 .847 r
.48232 .41879 m .48677 .42162 L .49323 .40212 L p F P
0 0 0 r
s
.898 .261 .113 r
.52215 .41595 m .52664 .4131 L .53893 .43029 L p F P
0 0 0 r
s
.24 .35 .67 r
.53216 .42082 m
.54567 .42961 L
s
.898 .261 .113 r
.54557 .42616 m .53893 .43029 L .52664 .4131 L p F P
0 0 0 r
s
.858 .248 .108 r
.53893 .43029 m .54557 .42616 L .55886 .44366 L p F P
0 0 0 r
s
.298 .435 .844 r
.47785 .41595 m .47336 .4131 L .46107 .43029 L p F P
0 0 0 r
s
.83 .24 .1 r
.45433 .42961 m
.46784 .42082 L
s
.298 .435 .844 r
.45443 .42616 m .46107 .43029 L .47336 .4131 L p F P
0 0 0 r
s
.299 .434 .837 r
.46107 .43029 m .45443 .42616 L .44114 .44366 L p F P
0 0 0 r
s
.815 .235 .102 r
.58129 .45611 m .57077 .4624 L .55886 .44366 L p F P
0 0 0 r
s
.83 .24 .1 r
.53748 .47381 m
.56635 .45644 L
s
.77 .221 .097 r
.57077 .4624 m .58129 .45611 L .59319 .47491 L p F P
0 0 0 r
s
.77 .221 .097 r
.59319 .47491 m .58107 .482 L .57077 .4624 L p F P
0 0 0 r
s
.298 .43 .827 r
.41871 .45611 m .42923 .4624 L .44114 .44366 L p F P
0 0 0 r
s
.24 .35 .67 r
.43365 .45644 m
.46252 .47381 L
s
.296 .424 .813 r
.42923 .4624 m .41871 .45611 L .40681 .47491 L p F P
0 0 0 r
s
.296 .424 .813 r
.40681 .47491 m .41893 .482 L .42923 .4624 L p F P
0 0 0 r
s
.938 .274 .118 r
.50677 .40212 m .50903 .40065 L .51768 .41879 L p F P
0 0 0 r
s
.938 .274 .118 r
.52215 .41595 m .51768 .41879 L .50903 .40065 L p F P
0 0 0 r
s
.24 .35 .67 r
.51897 .41224 m
.52342 .41514 L
s
.296 .435 .847 r
.49323 .40212 m .49097 .40065 L .48232 .41879 L p F P
0 0 0 r
s
.296 .435 .847 r
.47785 .41595 m .48232 .41879 L .49097 .40065 L p F P
0 0 0 r
s
.83 .24 .1 r
.47658 .41514 m
.48103 .41224 L
s
.858 .248 .108 r
.56755 .43835 m .55886 .44366 L .54557 .42616 L p F P
0 0 0 r
s
.83 .24 .1 r
.52099 .45021 m
.54967 .43247 L
s
.815 .235 .102 r
.55886 .44366 m .56755 .43835 L .58129 .45611 L p F P
0 0 0 r
s
.299 .434 .837 r
.43245 .43835 m .44114 .44366 L .45443 .42616 L p F P
0 0 0 r
s
.24 .35 .67 r
.45033 .43247 m
.47901 .45021 L
s
.298 .43 .827 r
.44114 .44366 m .43245 .43835 L .41871 .45611 L p F P
0 0 0 r
s
.83 .24 .1 r
.54967 .43247 m
.56635 .45644 L
s
.56635 .45644 m
.58032 .48217 L
s
.24 .35 .67 r
.43365 .45644 m
.45033 .43247 L
s
.41968 .48217 m
.43365 .45644 L
s
.215 .055 .025 r
.51361 .64118 m .52741 .63394 L .52602 .64616 L p F P
0 0 0 r
s
.215 .055 .025 r
.52602 .64616 m .51292 .65296 L .51361 .64118 L p F P
0 0 0 r
s
.199 .262 .472 r
.48639 .64118 m .47259 .63394 L .47398 .64616 L p F P
0 0 0 r
s
.199 .262 .472 r
.47398 .64616 m .48708 .65296 L .48639 .64118 L p F P
0 0 0 r
s
.528 .145 .066 r
.57068 .5586 m .58543 .55048 L .58716 .56973 L p F P
0 0 0 r
s
.528 .145 .066 r
.58716 .56973 m .57211 .57788 L .57068 .5586 L p F P
0 0 0 r
s
.83 .24 .1 r
.56856 .5518 m
.57144 .57715 L
s
.269 .375 .705 r
.42932 .5586 m .41457 .55048 L .41284 .56973 L p F P
0 0 0 r
s
.269 .375 .705 r
.41284 .56973 m .42789 .57788 L .42932 .5586 L p F P
0 0 0 r
s
.24 .35 .67 r
.42856 .57715 m
.43144 .5518 L
s
.721 .205 .091 r
.58107 .482 m .59319 .47491 L .60301 .4944 L p F P
0 0 0 r
s
.721 .205 .091 r
.60301 .4944 m .58955 .50211 L .58107 .482 L p F P
0 0 0 r
s
.292 .417 .795 r
.41893 .482 m .40681 .47491 L .39699 .4944 L p F P
0 0 0 r
s
.292 .417 .795 r
.39699 .4944 m .41045 .50211 L .41893 .482 L p F P
0 0 0 r
s
.435 .116 .054 r
.55727 .58591 m .57211 .57788 L .57189 .59567 L p F P
0 0 0 r
s
.435 .116 .054 r
.57189 .59567 m .5571 .60355 L .55727 .58591 L p F P
0 0 0 r
s
.83 .24 .1 r
.54225 .59296 m
.57144 .57715 L
s
.254 .35 .652 r
.44273 .58591 m .42789 .57788 L .42811 .59567 L p F P
0 0 0 r
s
.254 .35 .652 r
.42811 .59567 m .4429 .60355 L .44273 .58591 L p F P
0 0 0 r
s
.24 .35 .67 r
.42856 .57715 m
.45775 .59296 L
s
.604 .168 .076 r
.58176 .53034 m .59605 .52232 L .60039 .54224 L p F P
0 0 0 r
s
.604 .168 .076 r
.60039 .54224 m .58543 .55048 L .58176 .53034 L p F P
0 0 0 r
s
.28 .394 .743 r
.41824 .53034 m .40395 .52232 L .39961 .54224 L p F P
0 0 0 r
s
.28 .394 .743 r
.39961 .54224 m .41457 .55048 L .41824 .53034 L p F P
0 0 0 r
s
.938 .274 .118 r
.50903 .40065 m .5113 .39918 L .52215 .41595 L p F P
0 0 0 r
s
.938 .274 .118 r
.52664 .4131 m .52215 .41595 L .5113 .39918 L p F P
0 0 0 r
s
.296 .435 .847 r
.49097 .40065 m .4887 .39918 L .47785 .41595 L p F P
0 0 0 r
s
.296 .435 .847 r
.47336 .4131 m .47785 .41595 L .4887 .39918 L p F P
0 0 0 r
s
.898 .261 .113 r
.52664 .4131 m .53115 .41024 L .54557 .42616 L p F P
0 0 0 r
s
.898 .261 .113 r
.55225 .422 m .54557 .42616 L .53115 .41024 L p F P
0 0 0 r
s
.858 .248 .108 r
.54557 .42616 m .55225 .422 L .56755 .43835 L p F P
0 0 0 r
s
.298 .435 .844 r
.47336 .4131 m .46885 .41024 L .45443 .42616 L p F P
0 0 0 r
s
.298 .435 .844 r
.44775 .422 m .45443 .42616 L .46885 .41024 L p F P
0 0 0 r
s
.299 .434 .837 r
.45443 .42616 m .44775 .422 L .43245 .43835 L p F P
0 0 0 r
s
.319 .081 .039 r
.54252 .61131 m .5571 .60355 L .55558 .61914 L p F P
0 0 0 r
s
.319 .081 .039 r
.55558 .61914 m .5414 .62659 L .54252 .61131 L p F P
0 0 0 r
s
.83 .24 .1 r
.54059 .61625 m
.54225 .59296 L
s
.232 .315 .578 r
.45748 .61131 m .4429 .60355 L .44442 .61914 L p F P
0 0 0 r
s
.232 .315 .578 r
.44442 .61914 m .4586 .62659 L .45748 .61131 L p F P
0 0 0 r
s
.24 .35 .67 r
.45775 .59296 m
.45941 .61625 L
s
.667 .188 .084 r
.58955 .50211 m .60301 .4944 L .61053 .51419 L p F P
0 0 0 r
s
.667 .188 .084 r
.61053 .51419 m .59605 .52232 L .58955 .50211 L p F P
0 0 0 r
s
.83 .24 .1 r
.58032 .48217 m
.59109 .50877 L
s
.56172 .5255 m
.59109 .50877 L
s
.287 .407 .773 r
.41045 .50211 m .39699 .4944 L .38947 .51419 L p F P
0 0 0 r
s
.287 .407 .773 r
.38947 .51419 m .40395 .52232 L .41045 .50211 L p F P
0 0 0 r
s
.24 .35 .67 r
.40891 .50877 m
.41968 .48217 L
s
.40891 .50877 m
.43828 .5255 L
s
.938 .274 .118 r
.5113 .39918 m .51358 .39771 L .52664 .4131 L p F P
0 0 0 r
s
.938 .274 .118 r
.53115 .41024 m .52664 .4131 L .51358 .39771 L p F P
0 0 0 r
s
.83 .24 .1 r
.50229 .42921 m
.53085 .41108 L
s
.296 .435 .847 r
.4887 .39918 m .48642 .39771 L .47336 .4131 L p F P
0 0 0 r
s
.296 .435 .847 r
.46885 .41024 m .47336 .4131 L .48642 .39771 L p F P
0 0 0 r
s
.24 .35 .67 r
.46915 .41108 m
.49771 .42921 L
s
.858 .248 .108 r
.57632 .433 m .56755 .43835 L .55225 .422 L p F P
0 0 0 r
s
.815 .235 .102 r
.56755 .43835 m .57632 .433 L .59192 .44975 L p F P
0 0 0 r
s
.815 .235 .102 r
.59192 .44975 m .58129 .45611 L .56755 .43835 L p F P
0 0 0 r
s
.299 .434 .837 r
.42368 .433 m .43245 .43835 L .44775 .422 L p F P
0 0 0 r
s
.298 .43 .827 r
.43245 .43835 m .42368 .433 L .40808 .44975 L p F P
0 0 0 r
s
.298 .43 .827 r
.40808 .44975 m .41871 .45611 L .43245 .43835 L p F P
0 0 0 r
s
.978 .287 .123 r
.50225 .40504 m .5 .4065 L .5 .38446 L closepath p F P
0 0 0 r
s
.292 .431 .844 r
.49775 .40504 m .5 .4065 L .5 .38446 L closepath p F P
0 0 0 r
s
.77 .221 .097 r
.58129 .45611 m .59192 .44975 L .60546 .46773 L p F P
0 0 0 r
s
.77 .221 .097 r
.60546 .46773 m .59319 .47491 L .58129 .45611 L p F P
0 0 0 r
s
.296 .424 .813 r
.41871 .45611 m .40808 .44975 L .39454 .46773 L p F P
0 0 0 r
s
.296 .424 .813 r
.39454 .46773 m .40681 .47491 L .41871 .45611 L p F P
0 0 0 r
s
.978 .287 .123 r
.50451 .40358 m .50225 .40504 L .5 .38446 L closepath p F P
0 0 0 r
s
.292 .431 .844 r
.49549 .40358 m .49775 .40504 L .5 .38446 L closepath p F P
0 0 0 r
s
.898 .261 .113 r
.53115 .41024 m .53567 .40736 L .55225 .422 L p F P
0 0 0 r
s
.898 .261 .113 r
.55898 .41781 m .55225 .422 L .53567 .40736 L p F P
0 0 0 r
s
.83 .24 .1 r
.53085 .41108 m
.54967 .43247 L
s
.858 .248 .108 r
.55225 .422 m .55898 .41781 L .57632 .433 L p F P
0 0 0 r
s
.298 .435 .844 r
.46885 .41024 m .46433 .40736 L .44775 .422 L p F P
0 0 0 r
s
.298 .435 .844 r
.44102 .41781 m .44775 .422 L .46433 .40736 L p F P
0 0 0 r
s
.24 .35 .67 r
.45033 .43247 m
.46915 .41108 L
s
.299 .434 .837 r
.44775 .422 m .44102 .41781 L .42368 .433 L p F P
0 0 0 r
s
.938 .274 .118 r
.51358 .39771 m .51586 .39623 L .53115 .41024 L p F P
0 0 0 r
s
.938 .274 .118 r
.53567 .40736 m .53115 .41024 L .51586 .39623 L p F P
0 0 0 r
s
.296 .435 .847 r
.48642 .39771 m .48414 .39623 L .46885 .41024 L p F P
0 0 0 r
s
.296 .435 .847 r
.46433 .40736 m .46885 .41024 L .48414 .39623 L p F P
0 0 0 r
s
.721 .205 .091 r
.59319 .47491 m .60546 .46773 L .61665 .48658 L p F P
0 0 0 r
s
.721 .205 .091 r
.61665 .48658 m .60301 .4944 L .59319 .47491 L p F P
0 0 0 r
s
.292 .417 .795 r
.40681 .47491 m .39454 .46773 L .38335 .48658 L p F P
0 0 0 r
s
.292 .417 .795 r
.38335 .48658 m .39699 .4944 L .40681 .47491 L p F P
0 0 0 r
s
.978 .287 .123 r
.50677 .40212 m .50451 .40358 L .5 .38446 L closepath p F P
0 0 0 r
s
.292 .431 .844 r
.49323 .40212 m .49549 .40358 L .5 .38446 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.46668 .68324 m
.49513 .66855 L
s
.46668 .68324 m
.45199 .69539 L
s
.24 .35 .67 r
.53332 .68324 m
.50487 .66855 L
s
.53332 .68324 m
.54801 .69539 L
s
.215 .055 .025 r
.52741 .63394 m .5414 .62659 L .53928 .63926 L p F P
0 0 0 r
s
.215 .055 .025 r
.53928 .63926 m .52602 .64616 L .52741 .63394 L p F P
0 0 0 r
s
.199 .262 .472 r
.47259 .63394 m .4586 .62659 L .46072 .63926 L p F P
0 0 0 r
s
.199 .262 .472 r
.46072 .63926 m .47398 .64616 L .47259 .63394 L p F P
0 0 0 r
s
.1 .028 .011 r
.5 .65967 m .51292 .65296 L .51191 .66148 L p F P
0 0 0 r
s
.1 .028 .011 r
.51191 .66148 m .5 .66762 L .5 .65967 L p F P
0 0 0 r
s
.24 .35 .67 r
.50324 .66595 m
.50336 .66615 L
s
.50336 .66615 m
.50487 .66855 L
s
.156 .195 .345 r
.5 .65967 m .48708 .65296 L .48809 .66148 L p F P
0 0 0 r
s
.156 .195 .345 r
.48809 .66148 m .5 .66762 L .5 .65967 L p F P
0 0 0 r
s
.83 .24 .1 r
.49664 .66615 m
.49676 .66595 L
s
.4986 .66303 m
.50563 .65186 L
s
.24 .35 .67 r
.49437 .65186 m
.5014 .66303 L
s
.83 .24 .1 r
.49513 .66855 m
.49664 .66615 L
s
.42414 .70971 m
.45199 .69539 L
s
.42414 .70971 m
.40583 .71672 L
s
.24 .35 .67 r
.57586 .70971 m
.54801 .69539 L
s
.57586 .70971 m
.59417 .71672 L
s
.528 .145 .066 r
.58543 .55048 m .60039 .54224 L .60244 .56147 L p F P
0 0 0 r
s
.528 .145 .066 r
.60244 .56147 m .58716 .56973 L .58543 .55048 L p F P
0 0 0 r
s
.269 .375 .705 r
.41457 .55048 m .39961 .54224 L .39756 .56147 L p F P
0 0 0 r
s
.269 .375 .705 r
.39756 .56147 m .41284 .56973 L .41457 .55048 L p F P
0 0 0 r
s
.978 .287 .123 r
.50903 .40065 m .50677 .40212 L .5 .38446 L closepath p F P
0 0 0 r
s
.292 .431 .844 r
.49097 .40065 m .49323 .40212 L .5 .38446 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.33101 .74598 m
.35751 .73219 L
s
.33101 .74598 m
.30815 .74169 L
s
.24 .35 .67 r
.66899 .74598 m
.64249 .73219 L
s
.66899 .74598 m
.69185 .74169 L
s
.435 .116 .054 r
.57211 .57788 m .58716 .56973 L .58689 .58768 L p F P
0 0 0 r
s
.435 .116 .054 r
.58689 .58768 m .57189 .59567 L .57211 .57788 L p F P
0 0 0 r
s
.254 .35 .652 r
.42789 .57788 m .41284 .56973 L .41311 .58768 L p F P
0 0 0 r
s
.254 .35 .652 r
.41311 .58768 m .42811 .59567 L .42789 .57788 L p F P
0 0 0 r
s
.83 .24 .1 r
.37862 .73074 m
.40583 .71672 L
s
.37862 .73074 m
.35751 .73219 L
s
.24 .35 .67 r
.62138 .73074 m
.59417 .71672 L
s
.62138 .73074 m
.64249 .73219 L
s
.604 .168 .076 r
.59605 .52232 m .61053 .51419 L .61556 .53388 L p F P
0 0 0 r
s
.604 .168 .076 r
.61556 .53388 m .60039 .54224 L .59605 .52232 L p F P
0 0 0 r
s
.83 .24 .1 r
.59109 .50877 m
.59825 .53532 L
s
.56856 .5518 m
.59825 .53532 L
s
.28 .394 .743 r
.40395 .52232 m .38947 .51419 L .38444 .53388 L p F P
0 0 0 r
s
.28 .394 .743 r
.38444 .53388 m .39961 .54224 L .40395 .52232 L p F P
0 0 0 r
s
.24 .35 .67 r
.40175 .53532 m
.40891 .50877 L
s
.40175 .53532 m
.43144 .5518 L
s
.858 .248 .108 r
.58517 .4276 m .57632 .433 L .55898 .41781 L p F P
0 0 0 r
s
.815 .235 .102 r
.57632 .433 m .58517 .4276 L .60267 .44333 L p F P
0 0 0 r
s
.815 .235 .102 r
.60267 .44333 m .59192 .44975 L .57632 .433 L p F P
0 0 0 r
s
.299 .434 .837 r
.41483 .4276 m .42368 .433 L .44102 .41781 L p F P
0 0 0 r
s
.298 .43 .827 r
.42368 .433 m .41483 .4276 L .39733 .44333 L p F P
0 0 0 r
s
.298 .43 .827 r
.39733 .44333 m .40808 .44975 L .42368 .433 L p F P
0 0 0 r
s
.938 .274 .118 r
.51586 .39623 m .51814 .39476 L .53567 .40736 L p F P
0 0 0 r
s
.938 .274 .118 r
.54022 .40447 m .53567 .40736 L .51814 .39476 L p F P
0 0 0 r
s
.898 .261 .113 r
.53567 .40736 m .54022 .40447 L .55898 .41781 L p F P
0 0 0 r
s
.296 .435 .847 r
.48414 .39623 m .48186 .39476 L .46433 .40736 L p F P
0 0 0 r
s
.296 .435 .847 r
.45978 .40447 m .46433 .40736 L .48186 .39476 L p F P
0 0 0 r
s
.298 .435 .844 r
.46433 .40736 m .45978 .40447 L .44102 .41781 L p F P
0 0 0 r
s
.978 .287 .123 r
.5113 .39918 m .50903 .40065 L .5 .38446 L closepath p F P
0 0 0 r
s
.292 .431 .844 r
.4887 .39918 m .49097 .40065 L .5 .38446 L closepath p F P
0 0 0 r
s
.898 .261 .113 r
.56575 .41359 m .55898 .41781 L .54022 .40447 L p F P
0 0 0 r
s
.24 .35 .67 r
.56405 .41465 m
.56681 .41648 L
s
.858 .248 .108 r
.55898 .41781 m .56575 .41359 L .58517 .4276 L p F P
0 0 0 r
s
.24 .35 .67 r
.56871 .41573 m
.58812 .40807 L
s
.298 .435 .844 r
.43425 .41359 m .44102 .41781 L .45978 .40447 L p F P
0 0 0 r
s
.83 .24 .1 r
.43319 .41648 m
.43595 .41465 L
s
.299 .434 .837 r
.44102 .41781 m .43425 .41359 L .41483 .4276 L p F P
0 0 0 r
s
.83 .24 .1 r
.41188 .40807 m
.43129 .41573 L
s
.34494 .42604 m
.3642 .4234 L
s
.24 .35 .67 r
.65506 .42604 m
.6358 .4234 L
s
.77 .221 .097 r
.59192 .44975 m .60267 .44333 L .61787 .46047 L p F P
0 0 0 r
s
.77 .221 .097 r
.61787 .46047 m .60546 .46773 L .59192 .44975 L p F P
0 0 0 r
s
.296 .424 .813 r
.40808 .44975 m .39733 .44333 L .38213 .46047 L p F P
0 0 0 r
s
.296 .424 .813 r
.38213 .46047 m .39454 .46773 L .40808 .44975 L p F P
0 0 0 r
s
.83 .24 .1 r
.30151 .45274 m
.31857 .44427 L
s
.31857 .44427 m
.34494 .42604 L
s
.24 .35 .67 r
.69849 .45274 m
.68143 .44427 L
s
.68143 .44427 m
.65506 .42604 L
s
.978 .287 .123 r
.51358 .39771 m .5113 .39918 L .5 .38446 L closepath p F P
0 0 0 r
s
.292 .431 .844 r
.48642 .39771 m .4887 .39918 L .5 .38446 L closepath p F P
0 0 0 r
s
.667 .188 .084 r
.60301 .4944 m .61665 .48658 L .62522 .50594 L p F P
0 0 0 r
s
.667 .188 .084 r
.62522 .50594 m .61053 .51419 L .60301 .4944 L p F P
0 0 0 r
s
.287 .407 .773 r
.39699 .4944 m .38335 .48658 L .37478 .50594 L p F P
0 0 0 r
s
.287 .407 .773 r
.37478 .50594 m .38947 .51419 L .39699 .4944 L p F P
0 0 0 r
s
.319 .081 .039 r
.5571 .60355 m .57189 .59567 L .56997 .61158 L p F P
0 0 0 r
s
.319 .081 .039 r
.56997 .61158 m .55558 .61914 L .5571 .60355 L p F P
0 0 0 r
s
.232 .315 .578 r
.4429 .60355 m .42811 .59567 L .43003 .61158 L p F P
0 0 0 r
s
.232 .315 .578 r
.43003 .61158 m .44442 .61914 L .4429 .60355 L p F P
0 0 0 r
s
.83 .24 .1 r
.26169 .48462 m
.27574 .47061 L
s
.27574 .47061 m
.30151 .45274 L
s
.24 .35 .67 r
.73831 .48462 m
.72426 .47061 L
s
.72426 .47061 m
.69849 .45274 L
s
.83 .24 .1 r
.19559 .56088 m
.20151 .53787 L
s
.20151 .53787 m
.22619 .521 L
s
.24 .35 .67 r
.80441 .56088 m
.79849 .53787 L
s
.79849 .53787 m
.77381 .521 L
s
.938 .274 .118 r
.51814 .39476 m .52044 .39327 L .54022 .40447 L p F P
0 0 0 r
s
.938 .274 .118 r
.54479 .40157 m .54022 .40447 L .52044 .39327 L p F P
0 0 0 r
s
.24 .35 .67 r
.53755 .3991 m
.53913 .39809 L
s
.53913 .39809 m
.5439 .40126 L
s
.54457 .40171 m
.55863 .41105 L
s
.898 .261 .113 r
.54022 .40447 m .54479 .40157 L .56575 .41359 L p F P
0 0 0 r
s
.296 .435 .847 r
.48186 .39476 m .47956 .39327 L .45978 .40447 L p F P
0 0 0 r
s
.296 .435 .847 r
.45521 .40157 m .45978 .40447 L .47956 .39327 L p F P
0 0 0 r
s
.83 .24 .1 r
.46087 .39809 m
.46245 .3991 L
s
.44137 .41105 m
.45543 .40171 L
s
.4561 .40126 m
.46087 .39809 L
s
.298 .435 .844 r
.45978 .40447 m .45521 .40157 L .43425 .41359 L p F P
0 0 0 r
s
.978 .287 .123 r
.51586 .39623 m .51358 .39771 L .5 .38446 L closepath p F P
0 0 0 r
s
.292 .431 .844 r
.48414 .39623 m .48642 .39771 L .5 .38446 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.22619 .521 m
.23648 .50203 L
s
.23648 .50203 m
.26169 .48462 L
s
.24 .35 .67 r
.77381 .521 m
.76352 .50203 L
s
.76352 .50203 m
.73831 .48462 L
s
.898 .261 .113 r
.57256 .40934 m .56575 .41359 L .54479 .40157 L p F P
0 0 0 r
s
.858 .248 .108 r
.56575 .41359 m .57256 .40934 L .59409 .42216 L p F P
0 0 0 r
s
.858 .248 .108 r
.59409 .42216 m .58517 .4276 L .56575 .41359 L p F P
0 0 0 r
s
.298 .435 .844 r
.42744 .40934 m .43425 .41359 L .45521 .40157 L p F P
0 0 0 r
s
.299 .434 .837 r
.43425 .41359 m .42744 .40934 L .40591 .42216 L p F P
0 0 0 r
s
.299 .434 .837 r
.40591 .42216 m .41483 .4276 L .43425 .41359 L p F P
0 0 0 r
s
.978 .287 .123 r
.51814 .39476 m .51586 .39623 L .5 .38446 L closepath p F P
0 0 0 r
s
.292 .431 .844 r
.48186 .39476 m .48414 .39623 L .5 .38446 L closepath p F P
0 0 0 r
s
.721 .205 .091 r
.60546 .46773 m .61787 .46047 L .63046 .47867 L p F P
0 0 0 r
s
.721 .205 .091 r
.63046 .47867 m .61665 .48658 L .60546 .46773 L p F P
0 0 0 r
s
.83 .24 .1 r
.58032 .48217 m
.61026 .46465 L
s
.292 .417 .795 r
.39454 .46773 m .38213 .46047 L .36954 .47867 L p F P
0 0 0 r
s
.292 .417 .795 r
.36954 .47867 m .38335 .48658 L .39454 .46773 L p F P
0 0 0 r
s
.24 .35 .67 r
.38974 .46465 m
.41968 .48217 L
s
.815 .235 .102 r
.58517 .4276 m .59409 .42216 L .61352 .43685 L p F P
0 0 0 r
s
.815 .235 .102 r
.61352 .43685 m .60267 .44333 L .58517 .4276 L p F P
0 0 0 r
s
.83 .24 .1 r
.56635 .45644 m
.59605 .43857 L
s
.298 .43 .827 r
.41483 .4276 m .40591 .42216 L .38648 .43685 L p F P
0 0 0 r
s
.298 .43 .827 r
.38648 .43685 m .39733 .44333 L .41483 .4276 L p F P
0 0 0 r
s
.24 .35 .67 r
.40395 .43857 m
.43365 .45644 L
s
.938 .274 .118 r
.52044 .39327 m .52273 .39179 L .54479 .40157 L p F P
0 0 0 r
s
.938 .274 .118 r
.54939 .39865 m .54479 .40157 L .52273 .39179 L p F P
0 0 0 r
s
.898 .261 .113 r
.54479 .40157 m .54939 .39865 L .57256 .40934 L p F P
0 0 0 r
s
.296 .435 .847 r
.47956 .39327 m .47727 .39179 L .45521 .40157 L p F P
0 0 0 r
s
.296 .435 .847 r
.45061 .39865 m .45521 .40157 L .47727 .39179 L p F P
0 0 0 r
s
.298 .435 .844 r
.45521 .40157 m .45061 .39865 L .42744 .40934 L p F P
0 0 0 r
s
.978 .287 .123 r
.52044 .39327 m .51814 .39476 L .5 .38446 L closepath p F P
0 0 0 r
s
.292 .431 .844 r
.47956 .39327 m .48186 .39476 L .5 .38446 L closepath p F P
0 0 0 r
s
.1 .028 .011 r
.51292 .65296 m .52602 .64616 L .52397 .65527 L p F P
0 0 0 r
s
.1 .028 .011 r
.52397 .65527 m .51191 .66148 L .51292 .65296 L p F P
0 0 0 r
s
.156 .195 .345 r
.48708 .65296 m .47398 .64616 L .47603 .65527 L p F P
0 0 0 r
s
.156 .195 .345 r
.47603 .65527 m .48809 .66148 L .48708 .65296 L p F P
0 0 0 r
s
.215 .055 .025 r
.5414 .62659 m .55558 .61914 L .55273 .63228 L p F P
0 0 0 r
s
.215 .055 .025 r
.55273 .63228 m .53928 .63926 L .5414 .62659 L p F P
0 0 0 r
s
.83 .24 .1 r
.53462 .63673 m
.54059 .61625 L
s
.199 .262 .472 r
.4586 .62659 m .44442 .61914 L .44727 .63228 L p F P
0 0 0 r
s
.199 .262 .472 r
.44727 .63228 m .46072 .63926 L .4586 .62659 L p F P
0 0 0 r
s
.24 .35 .67 r
.45941 .61625 m
.46538 .63673 L
s
.978 .287 .123 r
.52273 .39179 m .52044 .39327 L .5 .38446 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.51052 .39306 m
.53085 .41108 L
s
.292 .431 .844 r
.47727 .39179 m .47956 .39327 L .5 .38446 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.49336 .40423 m
.51052 .39306 L
s
.24 .35 .67 r
.48948 .39306 m
.50664 .40423 L
s
.46915 .41108 m
.48948 .39306 L
s
.77 .221 .097 r
.60267 .44333 m .61352 .43685 L .63044 .45311 L p F P
0 0 0 r
s
.77 .221 .097 r
.63044 .45311 m .61787 .46047 L .60267 .44333 L p F P
0 0 0 r
s
.83 .24 .1 r
.59605 .43857 m
.61026 .46465 L
s
.296 .424 .813 r
.39733 .44333 m .38648 .43685 L .36956 .45311 L p F P
0 0 0 r
s
.296 .424 .813 r
.36956 .45311 m .38213 .46047 L .39733 .44333 L p F P
0 0 0 r
s
.24 .35 .67 r
.38974 .46465 m
.40395 .43857 L
s
.528 .145 .066 r
.60039 .54224 m .61556 .53388 L .61795 .55308 L p F P
0 0 0 r
s
.528 .145 .066 r
.61795 .55308 m .60244 .56147 L .60039 .54224 L p F P
0 0 0 r
s
.83 .24 .1 r
.59825 .53532 m
.60147 .56088 L
s
.269 .375 .705 r
.39961 .54224 m .38444 .53388 L .38205 .55308 L p F P
0 0 0 r
s
.269 .375 .705 r
.38205 .55308 m .39756 .56147 L .39961 .54224 L p F P
0 0 0 r
s
.24 .35 .67 r
.39853 .56088 m
.40175 .53532 L
s
.604 .168 .076 r
.61053 .51419 m .62522 .50594 L .63096 .5254 L p F P
0 0 0 r
s
.604 .168 .076 r
.63096 .5254 m .61556 .53388 L .61053 .51419 L p F P
0 0 0 r
s
.28 .394 .743 r
.38947 .51419 m .37478 .50594 L .36904 .5254 L p F P
0 0 0 r
s
.28 .394 .743 r
.36904 .5254 m .38444 .53388 L .38947 .51419 L p F P
0 0 0 r
s
.435 .116 .054 r
.58716 .56973 m .60244 .56147 L .60212 .57957 L p F P
0 0 0 r
s
.435 .116 .054 r
.60212 .57957 m .58689 .58768 L .58716 .56973 L p F P
0 0 0 r
s
.83 .24 .1 r
.57144 .57715 m
.60147 .56088 L
s
.254 .35 .652 r
.41284 .56973 m .39756 .56147 L .39788 .57957 L p F P
0 0 0 r
s
.254 .35 .652 r
.39788 .57957 m .41311 .58768 L .41284 .56973 L p F P
0 0 0 r
s
.24 .35 .67 r
.39853 .56088 m
.42856 .57715 L
s
.938 .274 .118 r
.52273 .39179 m .52503 .3903 L .54939 .39865 L p F P
0 0 0 r
s
.938 .274 .118 r
.554 .39572 m .54939 .39865 L .52503 .3903 L p F P
0 0 0 r
s
.898 .261 .113 r
.54939 .39865 m .554 .39572 L .57942 .40507 L p F P
0 0 0 r
s
.898 .261 .113 r
.57942 .40507 m .57256 .40934 L .54939 .39865 L p F P
0 0 0 r
s
.296 .435 .847 r
.47727 .39179 m .47497 .3903 L .45061 .39865 L p F P
0 0 0 r
s
.296 .435 .847 r
.446 .39572 m .45061 .39865 L .47497 .3903 L p F P
0 0 0 r
s
.298 .435 .844 r
.45061 .39865 m .446 .39572 L .42058 .40507 L p F P
0 0 0 r
s
.298 .435 .844 r
.42058 .40507 m .42744 .40934 L .45061 .39865 L p F P
0 0 0 r
s
.858 .248 .108 r
.57256 .40934 m .57942 .40507 L .60309 .41667 L p F P
0 0 0 r
s
.858 .248 .108 r
.60309 .41667 m .59409 .42216 L .57256 .40934 L p F P
0 0 0 r
s
.83 .24 .1 r
.54967 .43247 m
.57919 .41421 L
s
.57919 .41421 m
.59605 .43857 L
s
.299 .434 .837 r
.42744 .40934 m .42058 .40507 L .39691 .41667 L p F P
0 0 0 r
s
.299 .434 .837 r
.39691 .41667 m .40591 .42216 L .42744 .40934 L p F P
0 0 0 r
s
.24 .35 .67 r
.42081 .41421 m
.45033 .43247 L
s
.40395 .43857 m
.42081 .41421 L
s
.978 .287 .123 r
.52503 .3903 m .52273 .39179 L .5 .38446 L closepath p F P
0 0 0 r
s
.292 .431 .844 r
.47497 .3903 m .47727 .39179 L .5 .38446 L closepath p F P
0 0 0 r
s
.667 .188 .084 r
.61665 .48658 m .63046 .47867 L .64011 .49757 L p F P
0 0 0 r
s
.667 .188 .084 r
.64011 .49757 m .62522 .50594 L .61665 .48658 L p F P
0 0 0 r
s
.83 .24 .1 r
.59109 .50877 m
.62132 .49156 L
s
.287 .407 .773 r
.38335 .48658 m .36954 .47867 L .35989 .49757 L p F P
0 0 0 r
s
.287 .407 .773 r
.35989 .49757 m .37478 .50594 L .38335 .48658 L p F P
0 0 0 r
s
.24 .35 .67 r
.37868 .49156 m
.40891 .50877 L
s
.978 .287 .123 r
.52734 .3888 m .52503 .3903 L .5 .38446 L closepath p F P
0 0 0 r
s
.938 .274 .118 r
.52503 .3903 m .52734 .3888 L .554 .39572 L p F P
0 0 0 r
s
.292 .431 .844 r
.47266 .3888 m .47497 .3903 L .5 .38446 L closepath p F P
0 0 0 r
s
.296 .435 .847 r
.47497 .3903 m .47266 .3888 L .446 .39572 L p F P
0 0 0 r
s
.815 .235 .102 r
.59409 .42216 m .60309 .41667 L .62449 .43029 L p F P
0 0 0 r
s
.815 .235 .102 r
.62449 .43029 m .61352 .43685 L .59409 .42216 L p F P
0 0 0 r
s
.298 .43 .827 r
.40591 .42216 m .39691 .41667 L .37551 .43029 L p F P
0 0 0 r
s
.298 .43 .827 r
.37551 .43029 m .38648 .43685 L .40591 .42216 L p F P
0 0 0 r
s
.319 .081 .039 r
.57189 .59567 m .58689 .58768 L .58456 .60391 L p F P
0 0 0 r
s
.319 .081 .039 r
.58456 .60391 m .56997 .61158 L .57189 .59567 L p F P
0 0 0 r
s
.83 .24 .1 r
.54059 .61625 m
.57011 .60059 L
s
.57011 .60059 m
.57144 .57715 L
s
.232 .315 .578 r
.42811 .59567 m .41311 .58768 L .41544 .60391 L p F P
0 0 0 r
s
.232 .315 .578 r
.41544 .60391 m .43003 .61158 L .42811 .59567 L p F P
0 0 0 r
s
.24 .35 .67 r
.42989 .60059 m
.45941 .61625 L
s
.42856 .57715 m
.42989 .60059 L
s
.938 .274 .118 r
.55863 .39278 m .554 .39572 L .52734 .3888 L p F P
0 0 0 r
s
.898 .261 .113 r
.554 .39572 m .55863 .39278 L .58633 .40077 L p F P
0 0 0 r
s
.24 .35 .67 r
.57462 .39894 m
.58812 .40807 L
s
.898 .261 .113 r
.58633 .40077 m .57942 .40507 L .554 .39572 L p F P
0 0 0 r
s
.24 .35 .67 r
.56917 .39525 m
.57063 .39624 L
s
.296 .435 .847 r
.44137 .39278 m .446 .39572 L .47266 .3888 L p F P
0 0 0 r
s
.298 .435 .844 r
.446 .39572 m .44137 .39278 L .41367 .40077 L p F P
0 0 0 r
s
.83 .24 .1 r
.41188 .40807 m
.42538 .39894 L
s
.298 .435 .844 r
.41367 .40077 m .42058 .40507 L .446 .39572 L p F P
0 0 0 r
s
.83 .24 .1 r
.42937 .39624 m
.43083 .39525 L
s
.978 .287 .123 r
.52965 .38731 m .52734 .3888 L .5 .38446 L closepath p F P
0 0 0 r
s
.938 .274 .118 r
.52734 .3888 m .52965 .38731 L .55863 .39278 L p F P
0 0 0 r
s
.292 .431 .844 r
.47035 .38731 m .47266 .3888 L .5 .38446 L closepath p F P
0 0 0 r
s
.296 .435 .847 r
.47266 .3888 m .47035 .38731 L .44137 .39278 L p F P
0 0 0 r
s
.721 .205 .091 r
.61787 .46047 m .63044 .45311 L .64445 .47065 L p F P
0 0 0 r
s
.721 .205 .091 r
.64445 .47065 m .63046 .47867 L .61787 .46047 L p F P
0 0 0 r
s
.83 .24 .1 r
.61026 .46465 m
.62132 .49156 L
s
.292 .417 .795 r
.38213 .46047 m .36956 .45311 L .35555 .47065 L p F P
0 0 0 r
s
.292 .417 .795 r
.35555 .47065 m .36954 .47867 L .38213 .46047 L p F P
0 0 0 r
s
.24 .35 .67 r
.37868 .49156 m
.38974 .46465 L
s
.858 .248 .108 r
.57942 .40507 m .58633 .40077 L .61216 .41113 L p F P
0 0 0 r
s
.24 .35 .67 r
.58812 .40807 m
.59221 .40744 L
s
.858 .248 .108 r
.61216 .41113 m .60309 .41667 L .57942 .40507 L p F P
0 0 0 r
s
.299 .434 .837 r
.42058 .40507 m .41367 .40077 L .38784 .41113 L p F P
0 0 0 r
s
.83 .24 .1 r
.40779 .40744 m
.41188 .40807 L
s
.299 .434 .837 r
.38784 .41113 m .39691 .41667 L .42058 .40507 L p F P
0 0 0 r
s
.978 .287 .123 r
.53197 .38581 m .52965 .38731 L .5 .38446 L closepath p F P
0 0 0 r
s
.938 .274 .118 r
.52965 .38731 m .53197 .38581 L .56328 .38982 L p F P
0 0 0 r
s
.938 .274 .118 r
.56328 .38982 m .55863 .39278 L .52965 .38731 L p F P
0 0 0 r
s
.292 .431 .844 r
.46803 .38581 m .47035 .38731 L .5 .38446 L closepath p F P
0 0 0 r
s
.296 .435 .847 r
.47035 .38731 m .46803 .38581 L .43672 .38982 L p F P
0 0 0 r
s
.296 .435 .847 r
.43672 .38982 m .44137 .39278 L .47035 .38731 L p F P
0 0 0 r
s
1 .3 .128 r
.5 .38446 m .5 .36444 L .49768 .36599 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.5 .38446 m .49768 .36599 L .49537 .36754 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.5 .38446 m .49537 .36754 L .49306 .36908 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.5 .38446 m .49306 .36908 L .49076 .37062 L closepath p F P
0 0 0 r
s
.284 .424 .834 r
.5 .38446 m .5 .36444 L .50232 .36599 L closepath p F P
0 0 0 r
s
.284 .424 .834 r
.5 .38446 m .50232 .36599 L .50463 .36754 L closepath p F P
0 0 0 r
s
.284 .424 .834 r
.5 .38446 m .50463 .36754 L .50694 .36908 L closepath p F P
0 0 0 r
s
.284 .424 .834 r
.5 .38446 m .50694 .36908 L .50924 .37062 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.5 .38446 m .49076 .37062 L .48846 .37215 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.5 .38446 m .48846 .37215 L .48617 .37368 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.5 .38446 m .48617 .37368 L .48388 .37521 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.5 .38446 m .48388 .37521 L .4816 .37673 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.5 .38446 m .4816 .37673 L .47933 .37826 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.5 .38446 m .47933 .37826 L .47706 .37977 L closepath p F P
0 0 0 r
s
.284 .424 .834 r
.5 .38446 m .50924 .37062 L .51154 .37215 L closepath p F P
0 0 0 r
s
.284 .424 .834 r
.5 .38446 m .51154 .37215 L .51383 .37368 L closepath p F P
0 0 0 r
s
.284 .424 .834 r
.5 .38446 m .51383 .37368 L .51612 .37521 L closepath p F P
0 0 0 r
s
.284 .424 .834 r
.5 .38446 m .51612 .37521 L .5184 .37673 L closepath p F P
0 0 0 r
s
.284 .424 .834 r
.5 .38446 m .5184 .37673 L .52067 .37826 L closepath p F P
0 0 0 r
s
.284 .424 .834 r
.5 .38446 m .52067 .37826 L .52294 .37977 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.5 .38446 m .47706 .37977 L .47479 .38129 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.5 .38446 m .47479 .38129 L .47253 .3828 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.5 .38446 m .47253 .3828 L .47028 .3843 L closepath p F P
0 0 0 r
s
1 .3 .128 r
.5 .38446 m .47028 .3843 L .46803 .38581 L closepath p F P
0 0 0 r
s
.284 .424 .834 r
.5 .38446 m .52294 .37977 L .52521 .38129 L closepath p F P
0 0 0 r
s
.284 .424 .834 r
.5 .38446 m .52521 .38129 L .52747 .3828 L closepath p F P
0 0 0 r
s
.284 .424 .834 r
.5 .38446 m .52747 .3828 L .52972 .3843 L closepath p F P
0 0 0 r
s
.284 .424 .834 r
.5 .38446 m .52972 .3843 L .53197 .38581 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.48937 .37916 m
.51052 .39306 L
s
.24 .35 .67 r
.48948 .39306 m
.51063 .37916 L
s
.77 .221 .097 r
.61352 .43685 m .62449 .43029 L .64315 .44568 L p F P
0 0 0 r
s
.77 .221 .097 r
.64315 .44568 m .63044 .45311 L .61352 .43685 L p F P
0 0 0 r
s
.296 .424 .813 r
.38648 .43685 m .37551 .43029 L .35685 .44568 L p F P
0 0 0 r
s
.296 .424 .813 r
.35685 .44568 m .36956 .45311 L .38648 .43685 L p F P
0 0 0 r
s
.898 .261 .113 r
.55863 .39278 m .56328 .38982 L .59328 .39644 L p F P
0 0 0 r
s
.898 .261 .113 r
.59328 .39644 m .58633 .40077 L .55863 .39278 L p F P
0 0 0 r
s
.83 .24 .1 r
.53085 .41108 m
.56025 .39241 L
s
.56025 .39241 m
.57919 .41421 L
s
.298 .435 .844 r
.44137 .39278 m .43672 .38982 L .40672 .39644 L p F P
0 0 0 r
s
.298 .435 .844 r
.40672 .39644 m .41367 .40077 L .44137 .39278 L p F P
0 0 0 r
s
.24 .35 .67 r
.43975 .39241 m
.46915 .41108 L
s
.42081 .41421 m
.43975 .39241 L
s
1 .312 .132 r
.4411 .38685 m .43672 .38982 L .46803 .38581 L p F P
0 0 0 r
s
1 .312 .132 r
.46803 .38581 m .47028 .3843 L .4411 .38685 L p F P
0 0 0 r
s
.271 .409 .811 r
.5589 .38685 m .56328 .38982 L .53197 .38581 L p F P
0 0 0 r
s
.271 .409 .811 r
.53197 .38581 m .52972 .3843 L .5589 .38685 L p F P
0 0 0 r
s
.1 .028 .011 r
.52602 .64616 m .53928 .63926 L .53618 .64897 L p F P
0 0 0 r
s
.1 .028 .011 r
.53618 .64897 m .52397 .65527 L .52602 .64616 L p F P
0 0 0 r
s
.83 .24 .1 r
.50563 .65186 m
.53462 .63673 L
s
.156 .195 .345 r
.47398 .64616 m .46072 .63926 L .46382 .64897 L p F P
0 0 0 r
s
.156 .195 .345 r
.46382 .64897 m .47603 .65527 L .47398 .64616 L p F P
0 0 0 r
s
.24 .35 .67 r
.46538 .63673 m
.49437 .65186 L
s
.83 .24 .1 r
.30815 .74169 m
.33466 .72765 L
s
.30815 .74169 m
.2847 .73146 L
s
.24 .35 .67 r
.69185 .74169 m
.66534 .72765 L
s
.69185 .74169 m
.7153 .73146 L
s
.83 .24 .1 r
.49513 .66855 m
.49846 .66683 L
s
.24 .35 .67 r
.50154 .66683 m
.50487 .66855 L
s
.215 .055 .025 r
.55558 .61914 m .56997 .61158 L .56635 .6252 L p F P
0 0 0 r
s
.215 .055 .025 r
.56635 .6252 m .55273 .63228 L .55558 .61914 L p F P
0 0 0 r
s
.199 .262 .472 r
.44442 .61914 m .43003 .61158 L .43365 .6252 L p F P
0 0 0 r
s
.199 .262 .472 r
.43365 .6252 m .44727 .63228 L .44442 .61914 L p F P
0 0 0 r
s
.815 .235 .102 r
.60309 .41667 m .61216 .41113 L .63557 .42367 L p F P
0 0 0 r
s
.815 .235 .102 r
.63557 .42367 m .62449 .43029 L .60309 .41667 L p F P
0 0 0 r
s
.298 .43 .827 r
.39691 .41667 m .38784 .41113 L .36443 .42367 L p F P
0 0 0 r
s
.298 .43 .827 r
.36443 .42367 m .37551 .43029 L .39691 .41667 L p F P
0 0 0 r
s
1 .312 .132 r
.44551 .38387 m .4411 .38685 L .47028 .3843 L p F P
0 0 0 r
s
1 .312 .132 r
.47028 .3843 m .47253 .3828 L .44551 .38387 L p F P
0 0 0 r
s
.271 .409 .811 r
.55449 .38387 m .5589 .38685 L .52972 .3843 L p F P
0 0 0 r
s
.271 .409 .811 r
.52972 .3843 m .52747 .3828 L .55449 .38387 L p F P
0 0 0 r
s
.83 .24 .1 r
.45199 .69539 m
.48066 .68066 L
s
.45199 .69539 m
.43384 .70229 L
s
.24 .35 .67 r
.54801 .69539 m
.51934 .68066 L
s
.54801 .69539 m
.56616 .70229 L
s
.528 .145 .066 r
.61556 .53388 m .63096 .5254 L .63368 .54456 L p F P
0 0 0 r
s
.528 .145 .066 r
.63368 .54456 m .61795 .55308 L .61556 .53388 L p F P
0 0 0 r
s
.269 .375 .705 r
.38444 .53388 m .36904 .5254 L .36632 .54456 L p F P
0 0 0 r
s
.269 .375 .705 r
.36632 .54456 m .38205 .55308 L .38444 .53388 L p F P
0 0 0 r
s
.858 .248 .108 r
.58633 .40077 m .59328 .39644 L .62132 .40554 L p F P
0 0 0 r
s
.858 .248 .108 r
.62132 .40554 m .61216 .41113 L .58633 .40077 L p F P
0 0 0 r
s
.24 .35 .67 r
.61519 .40928 m
.6358 .4234 L
s
.299 .434 .837 r
.41367 .40077 m .40672 .39644 L .37868 .40554 L p F P
0 0 0 r
s
.299 .434 .837 r
.37868 .40554 m .38784 .41113 L .41367 .40077 L p F P
0 0 0 r
s
.83 .24 .1 r
.3642 .4234 m
.38481 .40928 L
s
1 .32 .135 r
.41309 .39208 m .40672 .39644 L .43672 .38982 L p F P
0 0 0 r
s
1 .32 .135 r
.43672 .38982 m .4411 .38685 L .41309 .39208 L p F P
0 0 0 r
s
.83 .24 .1 r
.43473 .39261 m
.43961 .38932 L
s
.24 .35 .67 r
.43456 .38912 m
.43975 .39241 L
s
.83 .24 .1 r
.43961 .38932 m
.44747 .39256 L
s
.25 .383 .767 r
.58691 .39208 m .59328 .39644 L .56328 .38982 L p F P
0 0 0 r
s
.25 .383 .767 r
.56328 .38982 m .5589 .38685 L .58691 .39208 L p F P
0 0 0 r
s
.24 .35 .67 r
.56039 .38932 m
.56527 .39261 L
s
.83 .24 .1 r
.56025 .39241 m
.56544 .38912 L
s
.24 .35 .67 r
.55253 .39256 m
.56039 .38932 L
s
.604 .168 .076 r
.62522 .50594 m .64011 .49757 L .64658 .51679 L p F P
0 0 0 r
s
.604 .168 .076 r
.64658 .51679 m .63096 .5254 L .62522 .50594 L p F P
0 0 0 r
s
.83 .24 .1 r
.62132 .49156 m
.62882 .51837 L
s
.59825 .53532 m
.62882 .51837 L
s
.28 .394 .743 r
.37478 .50594 m .35989 .49757 L .35342 .51679 L p F P
0 0 0 r
s
.28 .394 .743 r
.35342 .51679 m .36904 .5254 L .37478 .50594 L p F P
0 0 0 r
s
.24 .35 .67 r
.37118 .51837 m
.37868 .49156 L
s
.37118 .51837 m
.40175 .53532 L
s
.83 .24 .1 r
.35751 .73219 m
.3848 .71799 L
s
.35751 .73219 m
.33466 .72765 L
s
.24 .35 .67 r
.64249 .73219 m
.6152 .71799 L
s
.64249 .73219 m
.66534 .72765 L
s
1 .312 .132 r
.44993 .38087 m .44551 .38387 L .47253 .3828 L p F P
0 0 0 r
s
1 .312 .132 r
.47253 .3828 m .47479 .38129 L .44993 .38087 L p F P
0 0 0 r
s
.24 .35 .67 r
.47201 .3817 m
.48948 .39306 L
s
.271 .409 .811 r
.55007 .38087 m .55449 .38387 L .52747 .3828 L p F P
0 0 0 r
s
.271 .409 .811 r
.52747 .3828 m .52521 .38129 L .55007 .38087 L p F P
0 0 0 r
s
.83 .24 .1 r
.51052 .39306 m
.52799 .3817 L
s
.435 .116 .054 r
.60244 .56147 m .61795 .55308 L .61757 .57134 L p F P
0 0 0 r
s
.435 .116 .054 r
.61757 .57134 m .60212 .57957 L .60244 .56147 L p F P
0 0 0 r
s
.254 .35 .652 r
.39756 .56147 m .38205 .55308 L .38243 .57134 L p F P
0 0 0 r
s
.254 .35 .652 r
.38243 .57134 m .39788 .57957 L .39756 .56147 L p F P
0 0 0 r
s
.83 .24 .1 r
.40583 .71672 m
.43384 .70229 L
s
.40583 .71672 m
.3848 .71799 L
s
.24 .35 .67 r
.59417 .71672 m
.56616 .70229 L
s
.59417 .71672 m
.6152 .71799 L
s
.083 .024 .01 r
.5 .66762 m .51191 .66148 L .51059 .66642 L p F P
0 0 0 r
s
.083 .024 .01 r
.51059 .66642 m .5 .67186 L .5 .66762 L p F P
0 0 0 r
s
.24 .35 .67 r
.50547 .66905 m
.51934 .68066 L
s
.111 .126 .238 r
.5 .66762 m .48809 .66148 L .48941 .66642 L p F P
0 0 0 r
s
.111 .126 .238 r
.48941 .66642 m .5 .67186 L .5 .66762 L p F P
0 0 0 r
s
.83 .24 .1 r
.48066 .68066 m
.49453 .66905 L
s
.667 .188 .084 r
.63046 .47867 m .64445 .47065 L .65522 .48909 L p F P
0 0 0 r
s
.667 .188 .084 r
.65522 .48909 m .64011 .49757 L .63046 .47867 L p F P
0 0 0 r
s
.287 .407 .773 r
.36954 .47867 m .35555 .47065 L .34478 .48909 L p F P
0 0 0 r
s
.287 .407 .773 r
.34478 .48909 m .35989 .49757 L .36954 .47867 L p F P
0 0 0 r
s
.83 .24 .1 r
.2205 .54413 m
.19559 .56088 L
s
.24 .35 .67 r
.7795 .54413 m
.80441 .56088 L
s
.83 .24 .1 r
.19471 .58696 m
.19559 .56088 L
s
.24 .35 .67 r
.80529 .58696 m
.80441 .56088 L
s
1 .312 .132 r
.45438 .37786 m .44993 .38087 L .47479 .38129 L p F P
0 0 0 r
s
1 .312 .132 r
.47479 .38129 m .47706 .37977 L .45438 .37786 L p F P
0 0 0 r
s
.271 .409 .811 r
.54562 .37786 m .55007 .38087 L .52521 .38129 L p F P
0 0 0 r
s
.271 .409 .811 r
.52521 .38129 m .52294 .37977 L .54562 .37786 L p F P
0 0 0 r
s
.721 .205 .091 r
.63044 .45311 m .64315 .44568 L .65863 .46252 L p F P
0 0 0 r
s
.721 .205 .091 r
.65863 .46252 m .64445 .47065 L .63044 .45311 L p F P
0 0 0 r
s
.83 .24 .1 r
.61026 .46465 m
.64108 .44661 L
s
.292 .417 .795 r
.36956 .45311 m .35685 .44568 L .34137 .46252 L p F P
0 0 0 r
s
.292 .417 .795 r
.34137 .46252 m .35555 .47065 L .36956 .45311 L p F P
0 0 0 r
s
.24 .35 .67 r
.35892 .44661 m
.38974 .46465 L
s
1 .32 .135 r
.41951 .38769 m .41309 .39208 L .4411 .38685 L p F P
0 0 0 r
s
1 .32 .135 r
.4411 .38685 m .44551 .38387 L .41951 .38769 L p F P
0 0 0 r
s
.24 .35 .67 r
.43975 .39241 m
.4472 .38568 L
s
.25 .383 .767 r
.58049 .38769 m .58691 .39208 L .5589 .38685 L p F P
0 0 0 r
s
.25 .383 .767 r
.5589 .38685 m .55449 .38387 L .58049 .38769 L p F P
0 0 0 r
s
.83 .24 .1 r
.5528 .38568 m
.56025 .39241 L
s
.319 .081 .039 r
.58689 .58768 m .60212 .57957 L .59936 .59614 L p F P
0 0 0 r
s
.319 .081 .039 r
.59936 .59614 m .58456 .60391 L .58689 .58768 L p F P
0 0 0 r
s
.232 .315 .578 r
.41311 .58768 m .39788 .57957 L .40064 .59614 L p F P
0 0 0 r
s
.232 .315 .578 r
.40064 .59614 m .41544 .60391 L .41311 .58768 L p F P
0 0 0 r
s
1 .312 .132 r
.45885 .37484 m .45438 .37786 L .47706 .37977 L p F P
0 0 0 r
s
1 .312 .132 r
.47706 .37977 m .47933 .37826 L .45885 .37484 L p F P
0 0 0 r
s
.83 .24 .1 r
.4722 .39056 m
.48937 .37916 L
s
.271 .409 .811 r
.54115 .37484 m .54562 .37786 L .52294 .37977 L p F P
0 0 0 r
s
.271 .409 .811 r
.52294 .37977 m .52067 .37826 L .54115 .37484 L p F P
0 0 0 r
s
.24 .35 .67 r
.51063 .37916 m
.5278 .39056 L
s
.77 .221 .097 r
.62449 .43029 m .63557 .42367 L .65602 .43815 L p F P
0 0 0 r
s
.77 .221 .097 r
.65602 .43815 m .64315 .44568 L .62449 .43029 L p F P
0 0 0 r
s
.296 .424 .813 r
.37551 .43029 m .36443 .42367 L .34398 .43815 L p F P
0 0 0 r
s
.296 .424 .813 r
.34398 .43815 m .35685 .44568 L .37551 .43029 L p F P
0 0 0 r
s
.83 .24 .1 r
.28765 .46669 m
.30151 .45274 L
s
.24 .35 .67 r
.71235 .46669 m
.69849 .45274 L
s
.83 .24 .1 r
.2205 .54413 m
.22619 .521 L
s
.22619 .521 m
.25161 .50362 L
s
.24 .35 .67 r
.7795 .54413 m
.77381 .521 L
s
.77381 .521 m
.74839 .50362 L
s
1 .322 .134 r
.38685 .39991 m .37868 .40554 L .40672 .39644 L p F P
0 0 0 r
s
1 .322 .134 r
.40672 .39644 m .41309 .39208 L .38685 .39991 L p F P
0 0 0 r
s
.24 .35 .67 r
.3966 .39923 m
.42081 .41421 L
s
.215 .337 .686 r
.61315 .39991 m .62132 .40554 L .59328 .39644 L p F P
0 0 0 r
s
.215 .337 .686 r
.59328 .39644 m .58691 .39208 L .61315 .39991 L p F P
0 0 0 r
s
.83 .24 .1 r
.57919 .41421 m
.6034 .39923 L
s
.815 .235 .102 r
.61216 .41113 m .62132 .40554 L .64677 .41697 L p F P
0 0 0 r
s
.815 .235 .102 r
.64677 .41697 m .63557 .42367 L .61216 .41113 L p F P
0 0 0 r
s
.24 .35 .67 r
.64418 .41852 m
.65506 .42604 L
s
.83 .24 .1 r
.59605 .43857 m
.62662 .42017 L
s
.298 .43 .827 r
.38784 .41113 m .37868 .40554 L .35323 .41697 L p F P
0 0 0 r
s
.298 .43 .827 r
.35323 .41697 m .36443 .42367 L .38784 .41113 L p F P
0 0 0 r
s
.83 .24 .1 r
.34494 .42604 m
.35582 .41852 L
s
.24 .35 .67 r
.37338 .42017 m
.40395 .43857 L
s
.83 .24 .1 r
.25161 .50362 m
.26169 .48462 L
s
.26169 .48462 m
.28765 .46669 L
s
.24 .35 .67 r
.74839 .50362 m
.73831 .48462 L
s
.73831 .48462 m
.71235 .46669 L
s
1 .312 .132 r
.46334 .3718 m .45885 .37484 L .47933 .37826 L p F P
0 0 0 r
s
1 .312 .132 r
.47933 .37826 m .4816 .37673 L .46334 .3718 L p F P
0 0 0 r
s
.271 .409 .811 r
.53666 .3718 m .54115 .37484 L .52067 .37826 L p F P
0 0 0 r
s
.271 .409 .811 r
.52067 .37826 m .5184 .37673 L .53666 .3718 L p F P
0 0 0 r
s
1 .32 .135 r
.42596 .38327 m .41951 .38769 L .44551 .38387 L p F P
0 0 0 r
s
1 .32 .135 r
.44551 .38387 m .44993 .38087 L .42596 .38327 L p F P
0 0 0 r
s
.25 .383 .767 r
.57404 .38327 m .58049 .38769 L .55449 .38387 L p F P
0 0 0 r
s
.25 .383 .767 r
.55449 .38387 m .55007 .38087 L .57404 .38327 L p F P
0 0 0 r
s
.1 .028 .011 r
.53928 .63926 m .55273 .63228 L .54853 .6426 L p F P
0 0 0 r
s
.1 .028 .011 r
.54853 .6426 m .53618 .64897 L .53928 .63926 L p F P
0 0 0 r
s
.156 .195 .345 r
.46072 .63926 m .44727 .63228 L .45147 .6426 L p F P
0 0 0 r
s
.156 .195 .345 r
.45147 .6426 m .46382 .64897 L .46072 .63926 L p F P
0 0 0 r
s
1 .312 .132 r
.46785 .36874 m .46334 .3718 L .4816 .37673 L p F P
0 0 0 r
s
1 .312 .132 r
.4816 .37673 m .48388 .37521 L .46785 .36874 L p F P
0 0 0 r
s
.271 .409 .811 r
.53215 .36874 m .53666 .3718 L .5184 .37673 L p F P
0 0 0 r
s
.271 .409 .811 r
.5184 .37673 m .51612 .37521 L .53215 .36874 L p F P
0 0 0 r
s
.215 .055 .025 r
.56997 .61158 m .58456 .60391 L .58015 .61803 L p F P
0 0 0 r
s
.215 .055 .025 r
.58015 .61803 m .56635 .6252 L .56997 .61158 L p F P
0 0 0 r
s
.83 .24 .1 r
.56447 .62114 m
.57011 .60059 L
s
.199 .262 .472 r
.43003 .61158 m .41544 .60391 L .41985 .61803 L p F P
0 0 0 r
s
.199 .262 .472 r
.41985 .61803 m .43365 .6252 L .43003 .61158 L p F P
0 0 0 r
s
.24 .35 .67 r
.42989 .60059 m
.43553 .62114 L
s
1 .312 .132 r
.47237 .36568 m .46785 .36874 L .48388 .37521 L p F P
0 0 0 r
s
1 .312 .132 r
.48388 .37521 m .48617 .37368 L .47237 .36568 L p F P
0 0 0 r
s
.271 .409 .811 r
.52763 .36568 m .53215 .36874 L .51612 .37521 L p F P
0 0 0 r
s
.271 .409 .811 r
.51612 .37521 m .51383 .37368 L .52763 .36568 L p F P
0 0 0 r
s
1 .322 .134 r
.3951 .39422 m .38685 .39991 L .41309 .39208 L p F P
0 0 0 r
s
.24 .35 .67 r
.39043 .39541 m
.39198 .39637 L
s
1 .322 .134 r
.41309 .39208 m .41951 .38769 L .3951 .39422 L p F P
0 0 0 r
s
.215 .337 .686 r
.6049 .39422 m .61315 .39991 L .58691 .39208 L p F P
0 0 0 r
s
.83 .24 .1 r
.60802 .39637 m
.60957 .39541 L
s
.215 .337 .686 r
.58691 .39208 m .58049 .38769 L .6049 .39422 L p F P
0 0 0 r
s
.083 .024 .01 r
.51191 .66148 m .52397 .65527 L .52129 .66093 L p F P
0 0 0 r
s
.083 .024 .01 r
.52129 .66093 m .51059 .66642 L .51191 .66148 L p F P
0 0 0 r
s
.111 .126 .238 r
.48809 .66148 m .47603 .65527 L .47871 .66093 L p F P
0 0 0 r
s
.111 .126 .238 r
.47871 .66093 m .48941 .66642 L .48809 .66148 L p F P
0 0 0 r
s
.83 .24 .1 r
.60957 .39541 m
.61224 .39928 L
s
.62662 .42017 m
.64108 .44661 L
s
.24 .35 .67 r
.38776 .39928 m
.39043 .39541 L
s
.35892 .44661 m
.37338 .42017 L
s
1 .32 .135 r
.43246 .37882 m .42596 .38327 L .44993 .38087 L p F P
0 0 0 r
s
1 .32 .135 r
.44993 .38087 m .45438 .37786 L .43246 .37882 L p F P
0 0 0 r
s
.25 .383 .767 r
.56754 .37882 m .57404 .38327 L .55007 .38087 L p F P
0 0 0 r
s
.25 .383 .767 r
.55007 .38087 m .54562 .37786 L .56754 .37882 L p F P
0 0 0 r
s
.528 .145 .066 r
.63096 .5254 m .64658 .51679 L .64966 .53592 L p F P
0 0 0 r
s
.528 .145 .066 r
.64966 .53592 m .63368 .54456 L .63096 .5254 L p F P
0 0 0 r
s
.83 .24 .1 r
.62882 .51837 m
.6324 .54413 L
s
.269 .375 .705 r
.36904 .5254 m .35342 .51679 L .35034 .53592 L p F P
0 0 0 r
s
.269 .375 .705 r
.35034 .53592 m .36632 .54456 L .36904 .5254 L p F P
0 0 0 r
s
.24 .35 .67 r
.3676 .54413 m
.37118 .51837 L
s
.604 .168 .076 r
.64011 .49757 m .65522 .48909 L .66244 .50806 L p F P
0 0 0 r
s
.604 .168 .076 r
.66244 .50806 m .64658 .51679 L .64011 .49757 L p F P
0 0 0 r
s
.28 .394 .743 r
.35989 .49757 m .34478 .48909 L .33756 .50806 L p F P
0 0 0 r
s
.28 .394 .743 r
.33756 .50806 m .35342 .51679 L .35989 .49757 L p F P
0 0 0 r
s
1 .312 .132 r
.47693 .3626 m .47237 .36568 L .48617 .37368 L p F P
0 0 0 r
s
1 .312 .132 r
.48617 .37368 m .48846 .37215 L .47693 .3626 L p F P
0 0 0 r
s
.271 .409 .811 r
.52307 .3626 m .52763 .36568 L .51383 .37368 L p F P
0 0 0 r
s
.271 .409 .811 r
.51383 .37368 m .51154 .37215 L .52307 .3626 L p F P
0 0 0 r
s
.667 .188 .084 r
.64445 .47065 m .65863 .46252 L .67055 .48048 L p F P
0 0 0 r
s
.667 .188 .084 r
.67055 .48048 m .65522 .48909 L .64445 .47065 L p F P
0 0 0 r
s
.83 .24 .1 r
.62132 .49156 m
.65245 .47383 L
s
.287 .407 .773 r
.35555 .47065 m .34137 .46252 L .32945 .48048 L p F P
0 0 0 r
s
.287 .407 .773 r
.32945 .48048 m .34478 .48909 L .35555 .47065 L p F P
0 0 0 r
s
.24 .35 .67 r
.34755 .47383 m
.37868 .49156 L
s
1 .308 .127 r
.36299 .41021 m .35323 .41697 L .37868 .40554 L p F P
0 0 0 r
s
1 .308 .127 r
.37868 .40554 m .38685 .39991 L .36299 .41021 L p F P
0 0 0 r
s
.24 .35 .67 r
.37338 .42017 m
.38554 .40251 L
s
.159 .261 .547 r
.63701 .41021 m .64677 .41697 L .62132 .40554 L p F P
0 0 0 r
s
.159 .261 .547 r
.62132 .40554 m .61315 .39991 L .63701 .41021 L p F P
0 0 0 r
s
.83 .24 .1 r
.61446 .40251 m
.62662 .42017 L
s
.435 .116 .054 r
.61795 .55308 m .63368 .54456 L .63326 .56299 L p F P
0 0 0 r
s
.435 .116 .054 r
.63326 .56299 m .61757 .57134 L .61795 .55308 L p F P
0 0 0 r
s
.83 .24 .1 r
.60147 .56088 m
.6324 .54413 L
s
.254 .35 .652 r
.38205 .55308 m .36632 .54456 L .36674 .56299 L p F P
0 0 0 r
s
.254 .35 .652 r
.36674 .56299 m .38243 .57134 L .38205 .55308 L p F P
0 0 0 r
s
.24 .35 .67 r
.3676 .54413 m
.39853 .56088 L
s
.721 .205 .091 r
.64315 .44568 m .65602 .43815 L .67301 .45428 L p F P
0 0 0 r
s
.721 .205 .091 r
.67301 .45428 m .65863 .46252 L .64315 .44568 L p F P
0 0 0 r
s
.292 .417 .795 r
.35685 .44568 m .34398 .43815 L .32699 .45428 L p F P
0 0 0 r
s
.292 .417 .795 r
.32699 .45428 m .34137 .46252 L .35685 .44568 L p F P
0 0 0 r
s
.83 .24 .1 r
.64108 .44661 m
.65245 .47383 L
s
.24 .35 .67 r
.34755 .47383 m
.35892 .44661 L
s
.77 .221 .097 r
.63557 .42367 m .64677 .41697 L .66904 .43053 L p F P
0 0 0 r
s
.83 .24 .1 r
.62662 .42017 m
.63852 .41301 L
s
.77 .221 .097 r
.66904 .43053 m .65602 .43815 L .63557 .42367 L p F P
0 0 0 r
s
.296 .424 .813 r
.36443 .42367 m .35323 .41697 L .33096 .43053 L p F P
0 0 0 r
s
.24 .35 .67 r
.36148 .41301 m
.37338 .42017 L
s
.296 .424 .813 r
.33096 .43053 m .34398 .43815 L .36443 .42367 L p F P
0 0 0 r
s
1 .312 .132 r
.4815 .3595 m .47693 .3626 L .48846 .37215 L p F P
0 0 0 r
s
1 .312 .132 r
.48846 .37215 m .49076 .37062 L .4815 .3595 L p F P
0 0 0 r
s
.271 .409 .811 r
.5185 .3595 m .52307 .3626 L .51154 .37215 L p F P
0 0 0 r
s
.271 .409 .811 r
.51154 .37215 m .50924 .37062 L .5185 .3595 L p F P
0 0 0 r
s
.83 .24 .1 r
.2847 .73146 m
.31115 .71712 L
s
.2847 .73146 m
.26183 .71564 L
s
.24 .35 .67 r
.7153 .73146 m
.68885 .71712 L
s
.7153 .73146 m
.73817 .71564 L
s
1 .32 .135 r
.43901 .37434 m .43246 .37882 L .45438 .37786 L p F P
0 0 0 r
s
1 .32 .135 r
.45438 .37786 m .45885 .37484 L .43901 .37434 L p F P
0 0 0 r
s
.25 .383 .767 r
.56099 .37434 m .56754 .37882 L .54562 .37786 L p F P
0 0 0 r
s
.25 .383 .767 r
.54562 .37786 m .54115 .37484 L .56099 .37434 L p F P
0 0 0 r
s
1 .312 .132 r
.48609 .35639 m .4815 .3595 L .49076 .37062 L p F P
0 0 0 r
s
1 .312 .132 r
.49076 .37062 m .49306 .36908 L .48609 .35639 L p F P
0 0 0 r
s
.83 .24 .1 r
.46816 .37001 m
.48937 .37916 L
s
.271 .409 .811 r
.51391 .35639 m .5185 .3595 L .50924 .37062 L p F P
0 0 0 r
s
.271 .409 .811 r
.50924 .37062 m .50694 .36908 L .51391 .35639 L p F P
0 0 0 r
s
.24 .35 .67 r
.51063 .37916 m
.53184 .37001 L
s
.319 .081 .039 r
.60212 .57957 m .61757 .57134 L .61437 .58826 L p F P
0 0 0 r
s
.319 .081 .039 r
.61437 .58826 m .59936 .59614 L .60212 .57957 L p F P
0 0 0 r
s
.83 .24 .1 r
.6005 .58447 m
.60147 .56088 L
s
.232 .315 .578 r
.39788 .57957 m .38243 .57134 L .38563 .58826 L p F P
0 0 0 r
s
.232 .315 .578 r
.38563 .58826 m .40064 .59614 L .39788 .57957 L p F P
0 0 0 r
s
.24 .35 .67 r
.39853 .56088 m
.3995 .58447 L
s
1 .322 .134 r
.40341 .38848 m .3951 .39422 L .41951 .38769 L p F P
0 0 0 r
s
1 .322 .134 r
.41951 .38769 m .42596 .38327 L .40341 .38848 L p F P
0 0 0 r
s
.215 .337 .686 r
.59659 .38848 m .6049 .39422 L .58049 .38769 L p F P
0 0 0 r
s
.215 .337 .686 r
.58049 .38769 m .57404 .38327 L .59659 .38848 L p F P
0 0 0 r
s
1 .312 .132 r
.49071 .35327 m .48609 .35639 L .49306 .36908 L p F P
0 0 0 r
s
1 .312 .132 r
.49306 .36908 m .49537 .36754 L .49071 .35327 L p F P
0 0 0 r
s
.271 .409 .811 r
.50929 .35327 m .51391 .35639 L .50694 .36908 L p F P
0 0 0 r
s
.271 .409 .811 r
.50694 .36908 m .50463 .36754 L .50929 .35327 L p F P
0 0 0 r
s
.24 .35 .67 r
.49317 .36755 m
.51063 .37916 L
s
.83 .24 .1 r
.48937 .37916 m
.50683 .36755 L
s
.19906 .61486 m
.19471 .58696 L
s
.19471 .58696 m
.21986 .57043 L
s
.24 .35 .67 r
.80094 .61486 m
.80529 .58696 L
s
.80529 .58696 m
.78014 .57043 L
s
.1 .028 .011 r
.55273 .63228 m .56635 .6252 L .56104 .63616 L p F P
0 0 0 r
s
.1 .028 .011 r
.56104 .63616 m .54853 .6426 L .55273 .63228 L p F P
0 0 0 r
s
.83 .24 .1 r
.53462 .63673 m
.56447 .62114 L
s
.156 .195 .345 r
.44727 .63228 m .43365 .6252 L .43896 .63616 L p F P
0 0 0 r
s
.156 .195 .345 r
.43896 .63616 m .45147 .6426 L .44727 .63228 L p F P
0 0 0 r
s
.24 .35 .67 r
.43553 .62114 m
.46538 .63673 L
s
1 .32 .135 r
.4456 .36983 m .43901 .37434 L .45885 .37484 L p F P
0 0 0 r
s
1 .32 .135 r
.45885 .37484 m .46334 .3718 L .4456 .36983 L p F P
0 0 0 r
s
.25 .383 .767 r
.5544 .36983 m .56099 .37434 L .54115 .37484 L p F P
0 0 0 r
s
.25 .383 .767 r
.54115 .37484 m .53666 .3718 L .5544 .36983 L p F P
0 0 0 r
s
1 .312 .132 r
.49534 .35013 m .49071 .35327 L .49537 .36754 L p F P
0 0 0 r
s
1 .312 .132 r
.49537 .36754 m .49768 .36599 L .49534 .35013 L p F P
0 0 0 r
s
.271 .409 .811 r
.50466 .35013 m .50929 .35327 L .50463 .36754 L p F P
0 0 0 r
s
.271 .409 .811 r
.50463 .36754 m .50232 .36599 L .50466 .35013 L p F P
0 0 0 r
s
1 .308 .127 r
.37286 .40337 m .36299 .41021 L .38685 .39991 L p F P
0 0 0 r
s
.83 .24 .1 r
.3721 .40727 m
.38581 .40556 L
s
1 .308 .127 r
.38685 .39991 m .3951 .39422 L .37286 .40337 L p F P
0 0 0 r
s
.159 .261 .547 r
.62714 .40337 m .63701 .41021 L .61315 .39991 L p F P
0 0 0 r
s
.24 .35 .67 r
.61419 .40556 m
.6279 .40727 L
s
.159 .261 .547 r
.61315 .39991 m .6049 .39422 L .62714 .40337 L p F P
0 0 0 r
s
.083 .024 .01 r
.52397 .65527 m .53618 .64897 L .5321 .65537 L p F P
0 0 0 r
s
.83 .24 .1 r
.52441 .65343 m
.53462 .63673 L
s
.083 .024 .01 r
.5321 .65537 m .52129 .66093 L .52397 .65527 L p F P
0 0 0 r
s
.83 .24 .1 r
.4988 .66665 m
.52441 .65343 L
s
.111 .126 .238 r
.47603 .65527 m .46382 .64897 L .4679 .65537 L p F P
0 0 0 r
s
.24 .35 .67 r
.46538 .63673 m
.47559 .65343 L
s
.111 .126 .238 r
.4679 .65537 m .47871 .66093 L .47603 .65527 L p F P
0 0 0 r
s
.24 .35 .67 r
.47559 .65343 m
.5012 .66665 L
s
.215 .055 .025 r
.58456 .60391 m .59936 .59614 L .59415 .61076 L p F P
0 0 0 r
s
.83 .24 .1 r
.57011 .60059 m
.6005 .58447 L
s
.215 .055 .025 r
.59415 .61076 m .58015 .61803 L .58456 .60391 L p F P
0 0 0 r
s
.199 .262 .472 r
.41544 .60391 m .40064 .59614 L .40585 .61076 L p F P
0 0 0 r
s
.24 .35 .67 r
.3995 .58447 m
.42989 .60059 L
s
.199 .262 .472 r
.40585 .61076 m .41985 .61803 L .41544 .60391 L p F P
0 0 0 r
s
1 .312 .132 r
.5 .34697 m .49534 .35013 L .49768 .36599 L p F P
0 0 0 r
s
1 .312 .132 r
.49768 .36599 m .5 .36444 L .5 .34697 L p F P
0 0 0 r
s
.271 .409 .811 r
.5 .34697 m .50466 .35013 L .50232 .36599 L p F P
0 0 0 r
s
.271 .409 .811 r
.50232 .36599 m .5 .36444 L .5 .34697 L p F P
0 0 0 r
s
.83 .24 .1 r
.33466 .72765 m
.36197 .7132 L
s
.33466 .72765 m
.31115 .71712 L
s
.24 .35 .67 r
.66534 .72765 m
.63803 .7132 L
s
.66534 .72765 m
.68885 .71712 L
s
1 .322 .134 r
.41181 .3827 m .40341 .38848 L .42596 .38327 L p F P
0 0 0 r
s
.24 .35 .67 r
.39043 .39541 m
.40949 .3732 L
s
.83 .24 .1 r
.41905 .38581 m
.43961 .38932 L
s
.39675 .40109 m
.41905 .38581 L
s
1 .322 .134 r
.42596 .38327 m .43246 .37882 L .41181 .3827 L p F P
0 0 0 r
s
.24 .35 .67 r
.40949 .3732 m
.42156 .38087 L
s
.215 .337 .686 r
.58819 .3827 m .59659 .38848 L .57404 .38327 L p F P
0 0 0 r
s
.83 .24 .1 r
.59051 .3732 m
.60957 .39541 L
s
.24 .35 .67 r
.56039 .38932 m
.58095 .38581 L
s
.58095 .38581 m
.60325 .40109 L
s
.215 .337 .686 r
.57404 .38327 m .56754 .37882 L .58819 .3827 L p F P
0 0 0 r
s
.83 .24 .1 r
.57844 .38087 m
.59051 .3732 L
s
.862 .266 .108 r
.34207 .42281 m .33096 .43053 L .35323 .41697 L p F P
0 0 0 r
s
.862 .266 .108 r
.35323 .41697 m .36299 .41021 L .34207 .42281 L p F P
0 0 0 r
s
.83 .24 .1 r
.36164 .4145 m
.3721 .40727 L
s
.119 .189 .415 r
.65793 .42281 m .66904 .43053 L .64677 .41697 L p F P
0 0 0 r
s
.119 .189 .415 r
.64677 .41697 m .63701 .41021 L .65793 .42281 L p F P
0 0 0 r
s
.24 .35 .67 r
.6279 .40727 m
.63836 .4145 L
s
1 .32 .135 r
.45224 .36529 m .4456 .36983 L .46334 .3718 L p F P
0 0 0 r
s
.24 .35 .67 r
.42993 .35433 m
.44958 .36711 L
s
1 .32 .135 r
.46334 .3718 m .46785 .36874 L .45224 .36529 L p F P
0 0 0 r
s
.83 .24 .1 r
.43961 .38932 m
.46816 .37001 L
s
.25 .383 .767 r
.54776 .36529 m .5544 .36983 L .53666 .3718 L p F P
0 0 0 r
s
.83 .24 .1 r
.55042 .36711 m
.57007 .35433 L
s
.25 .383 .767 r
.53666 .3718 m .53215 .36874 L .54776 .36529 L p F P
0 0 0 r
s
.24 .35 .67 r
.53184 .37001 m
.56039 .38932 L
s
.721 .205 .091 r
.65602 .43815 m .66904 .43053 L .68757 .44594 L p F P
0 0 0 r
s
.24 .35 .67 r
.68209 .44137 m
.69849 .45274 L
s
.721 .205 .091 r
.68757 .44594 m .67301 .45428 L .65602 .43815 L p F P
0 0 0 r
s
.292 .417 .795 r
.34398 .43815 m .33096 .43053 L .31243 .44594 L p F P
0 0 0 r
s
.83 .24 .1 r
.30151 .45274 m
.31791 .44137 L
s
.292 .417 .795 r
.31243 .44594 m .32699 .45428 L .34398 .43815 L p F P
0 0 0 r
s
.83 .24 .1 r
.59051 .3732 m
.62169 .35341 L
s
.24 .35 .67 r
.40949 .3732 m
.37831 .35341 L
s
.667 .188 .084 r
.65863 .46252 m .67301 .45428 L .68609 .47175 L p F P
0 0 0 r
s
.667 .188 .084 r
.68609 .47175 m .67055 .48048 L .65863 .46252 L p F P
0 0 0 r
s
.287 .407 .773 r
.34137 .46252 m .32699 .45428 L .31391 .47175 L p F P
0 0 0 r
s
.287 .407 .773 r
.31391 .47175 m .32945 .48048 L .34137 .46252 L p F P
0 0 0 r
s
.604 .168 .076 r
.65522 .48909 m .67055 .48048 L .67854 .49919 L p F P
0 0 0 r
s
.604 .168 .076 r
.67854 .49919 m .66244 .50806 L .65522 .48909 L p F P
0 0 0 r
s
.83 .24 .1 r
.65245 .47383 m
.66029 .50091 L
s
.28 .394 .743 r
.34478 .48909 m .32945 .48048 L .32146 .49919 L p F P
0 0 0 r
s
.28 .394 .743 r
.32146 .49919 m .33756 .50806 L .34478 .48909 L p F P
0 0 0 r
s
.24 .35 .67 r
.33971 .50091 m
.34755 .47383 L
s
.83 .24 .1 r
.48066 .68066 m
.46269 .68742 L
s
.24 .35 .67 r
.51934 .68066 m
.53731 .68742 L
s
.528 .145 .066 r
.64658 .51679 m .66244 .50806 L .66587 .52714 L p F P
0 0 0 r
s
.528 .145 .066 r
.66587 .52714 m .64966 .53592 L .64658 .51679 L p F P
0 0 0 r
s
.83 .24 .1 r
.62882 .51837 m
.66029 .50091 L
s
.269 .375 .705 r
.35342 .51679 m .33756 .50806 L .33413 .52714 L p F P
0 0 0 r
s
.269 .375 .705 r
.33413 .52714 m .35034 .53592 L .35342 .51679 L p F P
0 0 0 r
s
.24 .35 .67 r
.33971 .50091 m
.37118 .51837 L
s
.83 .24 .1 r
.3848 .71799 m
.41291 .70336 L
s
.3848 .71799 m
.36197 .7132 L
s
.24 .35 .67 r
.6152 .71799 m
.58709 .70336 L
s
.6152 .71799 m
.63803 .7132 L
s
.83 .24 .1 r
.43384 .70229 m
.46269 .68742 L
s
.43384 .70229 m
.41291 .70336 L
s
.24 .35 .67 r
.56616 .70229 m
.53731 .68742 L
s
.56616 .70229 m
.58709 .70336 L
s
.435 .116 .054 r
.63368 .54456 m .64966 .53592 L .64918 .55451 L p F P
0 0 0 r
s
.435 .116 .054 r
.64918 .55451 m .63326 .56299 L .63368 .54456 L p F P
0 0 0 r
s
.254 .35 .652 r
.36632 .54456 m .35034 .53592 L .35082 .55451 L p F P
0 0 0 r
s
.254 .35 .652 r
.35082 .55451 m .36674 .56299 L .36632 .54456 L p F P
0 0 0 r
s
.83 .24 .1 r
.24616 .52688 m
.2205 .54413 L
s
.24 .35 .67 r
.75384 .52688 m
.7795 .54413 L
s
.83 .24 .1 r
.21986 .57043 m
.2205 .54413 L
s
.24 .35 .67 r
.78014 .57043 m
.7795 .54413 L
s
1 .32 .135 r
.45892 .36072 m .45224 .36529 L .46785 .36874 L p F P
0 0 0 r
s
1 .32 .135 r
.46785 .36874 m .47237 .36568 L .45892 .36072 L p F P
0 0 0 r
s
.25 .383 .767 r
.54108 .36072 m .54776 .36529 L .53215 .36874 L p F P
0 0 0 r
s
.25 .383 .767 r
.53215 .36874 m .52763 .36568 L .54108 .36072 L p F P
0 0 0 r
s
1 .308 .127 r
.38282 .39646 m .37286 .40337 L .3951 .39422 L p F P
0 0 0 r
s
1 .308 .127 r
.3951 .39422 m .40341 .38848 L .38282 .39646 L p F P
0 0 0 r
s
.159 .261 .547 r
.61718 .39646 m .62714 .40337 L .6049 .39422 L p F P
0 0 0 r
s
.159 .261 .547 r
.6049 .39422 m .59659 .38848 L .61718 .39646 L p F P
0 0 0 r
s
1 .322 .134 r
.42027 .37686 m .41181 .3827 L .43246 .37882 L p F P
0 0 0 r
s
1 .322 .134 r
.43246 .37882 m .43901 .37434 L .42027 .37686 L p F P
0 0 0 r
s
.215 .337 .686 r
.57973 .37686 m .58819 .3827 L .56754 .37882 L p F P
0 0 0 r
s
.215 .337 .686 r
.56754 .37882 m .56099 .37434 L .57973 .37686 L p F P
0 0 0 r
s
.319 .081 .039 r
.61757 .57134 m .63326 .56299 L .6296 .58026 L p F P
0 0 0 r
s
.319 .081 .039 r
.6296 .58026 m .61437 .58826 L .61757 .57134 L p F P
0 0 0 r
s
.232 .315 .578 r
.38243 .57134 m .36674 .56299 L .3704 .58026 L p F P
0 0 0 r
s
.232 .315 .578 r
.3704 .58026 m .38563 .58826 L .38243 .57134 L p F P
0 0 0 r
s
.83 .24 .1 r
.26183 .71564 m
.28816 .70094 L
s
.26183 .71564 m
.24078 .69491 L
s
.24 .35 .67 r
.73817 .71564 m
.71184 .70094 L
s
.73817 .71564 m
.75922 .69491 L
s
.83 .24 .1 r
.24616 .52688 m
.25161 .50362 L
s
.25161 .50362 m
.2778 .48571 L
s
.24 .35 .67 r
.75384 .52688 m
.74839 .50362 L
s
.74839 .50362 m
.7222 .48571 L
s
.083 .024 .01 r
.5 .67186 m .51059 .66642 L .50896 .66749 L p F P
0 0 0 r
s
.083 .024 .01 r
.50896 .66749 m .5 .67208 L .5 .67186 L p F P
0 0 0 r
s
.24 .35 .67 r
.50133 .6714 m
.50212 .67181 L
s
.50212 .67181 m
.51934 .68066 L
s
.073 .085 .162 r
.5 .67186 m .48941 .66642 L .49104 .66749 L p F P
0 0 0 r
s
.073 .085 .162 r
.49104 .66749 m .5 .67208 L .5 .67186 L p F P
0 0 0 r
s
.83 .24 .1 r
.48066 .68066 m
.49788 .67181 L
s
.49788 .67181 m
.49867 .6714 L
s
.1 .028 .011 r
.56635 .6252 m .58015 .61803 L .5737 .62963 L p F P
0 0 0 r
s
.1 .028 .011 r
.5737 .62963 m .56104 .63616 L .56635 .6252 L p F P
0 0 0 r
s
.156 .195 .345 r
.43365 .6252 m .41985 .61803 L .4263 .62963 L p F P
0 0 0 r
s
.156 .195 .345 r
.4263 .62963 m .43896 .63616 L .43365 .6252 L p F P
0 0 0 r
s
1 .32 .135 r
.46565 .35611 m .45892 .36072 L .47237 .36568 L p F P
0 0 0 r
s
1 .32 .135 r
.47237 .36568 m .47693 .3626 L .46565 .35611 L p F P
0 0 0 r
s
.25 .383 .767 r
.53435 .35611 m .54108 .36072 L .52763 .36568 L p F P
0 0 0 r
s
.25 .383 .767 r
.52763 .36568 m .52307 .3626 L .53435 .35611 L p F P
0 0 0 r
s
.83 .24 .1 r
.2778 .48571 m
.28765 .46669 L
s
.24 .35 .67 r
.7222 .48571 m
.71235 .46669 L
s
.862 .266 .108 r
.35332 .415 m .34207 .42281 L .36299 .41021 L p F P
0 0 0 r
s
.862 .266 .108 r
.36299 .41021 m .37286 .40337 L .35332 .415 L p F P
0 0 0 r
s
.24 .35 .67 r
.3419 .40122 m
.35909 .41157 L
s
.119 .189 .415 r
.64668 .415 m .65793 .42281 L .63701 .41021 L p F P
0 0 0 r
s
.119 .189 .415 r
.63701 .41021 m .62714 .40337 L .64668 .415 L p F P
0 0 0 r
s
.83 .24 .1 r
.64091 .41157 m
.6581 .40122 L
s
.20852 .64315 m
.19906 .61486 L
s
.19906 .61486 m
.22447 .59862 L
s
.24 .35 .67 r
.79148 .64315 m
.80094 .61486 L
s
.80094 .61486 m
.77553 .59862 L
s
.083 .024 .01 r
.53618 .64897 m .54853 .6426 L .54304 .64976 L p F P
0 0 0 r
s
.083 .024 .01 r
.54304 .64976 m .5321 .65537 L .53618 .64897 L p F P
0 0 0 r
s
.111 .126 .238 r
.46382 .64897 m .45147 .6426 L .45696 .64976 L p F P
0 0 0 r
s
.111 .126 .238 r
.45696 .64976 m .4679 .65537 L .46382 .64897 L p F P
0 0 0 r
s
.083 .024 .01 r
.32464 .43747 m .31243 .44594 L .33096 .43053 L p F P
0 0 0 r
s
.083 .024 .01 r
.33096 .43053 m .34207 .42281 L .32464 .43747 L p F P
0 0 0 r
s
.24 .35 .67 r
.33111 .43033 m
.33127 .43042 L
s
.33231 .43103 m
.35892 .44661 L
s
.32718 .42803 m
.33111 .43033 L
s
.104 .117 .224 r
.67536 .43747 m .68757 .44594 L .66904 .43053 L p F P
0 0 0 r
s
.104 .117 .224 r
.66904 .43053 m .65793 .42281 L .67536 .43747 L p F P
0 0 0 r
s
.83 .24 .1 r
.66873 .43042 m
.66889 .43033 L
s
.64108 .44661 m
.66769 .43103 L
s
.66889 .43033 m
.67282 .42803 L
s
.215 .055 .025 r
.59936 .59614 m .61437 .58826 L .60833 .60339 L p F P
0 0 0 r
s
.215 .055 .025 r
.60833 .60339 m .59415 .61076 L .59936 .59614 L p F P
0 0 0 r
s
.83 .24 .1 r
.59522 .60509 m
.6005 .58447 L
s
.199 .262 .472 r
.40064 .59614 m .38563 .58826 L .39167 .60339 L p F P
0 0 0 r
s
.199 .262 .472 r
.39167 .60339 m .40585 .61076 L .40064 .59614 L p F P
0 0 0 r
s
.24 .35 .67 r
.3995 .58447 m
.40478 .60509 L
s
1 .322 .134 r
.42881 .37097 m .42027 .37686 L .43901 .37434 L p F P
0 0 0 r
s
1 .322 .134 r
.43901 .37434 m .4456 .36983 L .42881 .37097 L p F P
0 0 0 r
s
.24 .35 .67 r
.40949 .3732 m
.42993 .35433 L
s
.215 .337 .686 r
.57119 .37097 m .57973 .37686 L .56099 .37434 L p F P
0 0 0 r
s
.215 .337 .686 r
.56099 .37434 m .5544 .36983 L .57119 .37097 L p F P
0 0 0 r
s
.83 .24 .1 r
.57007 .35433 m
.59051 .3732 L
s
1 .32 .135 r
.47242 .35148 m .46565 .35611 L .47693 .3626 L p F P
0 0 0 r
s
.24 .35 .67 r
.45107 .33958 m
.47072 .35264 L
s
1 .32 .135 r
.47693 .3626 m .4815 .3595 L .47242 .35148 L p F P
0 0 0 r
s
.25 .383 .767 r
.52758 .35148 m .53435 .35611 L .52307 .3626 L p F P
0 0 0 r
s
.83 .24 .1 r
.52928 .35264 m
.54893 .33958 L
s
.25 .383 .767 r
.52307 .3626 m .5185 .3595 L .52758 .35148 L p F P
0 0 0 r
s
.667 .188 .084 r
.67301 .45428 m .68757 .44594 L .70186 .4629 L p F P
0 0 0 r
s
.667 .188 .084 r
.70186 .4629 m .68609 .47175 L .67301 .45428 L p F P
0 0 0 r
s
.287 .407 .773 r
.32699 .45428 m .31243 .44594 L .29814 .4629 L p F P
0 0 0 r
s
.287 .407 .773 r
.29814 .4629 m .31391 .47175 L .32699 .45428 L p F P
0 0 0 r
s
1 .308 .127 r
.3929 .38948 m .38282 .39646 L .40341 .38848 L p F P
0 0 0 r
s
.24 .35 .67 r
.35913 .37606 m
.38721 .39342 L
s
1 .308 .127 r
.40341 .38848 m .41181 .3827 L .3929 .38948 L p F P
0 0 0 r
s
.159 .261 .547 r
.6071 .38948 m .61718 .39646 L .59659 .38848 L p F P
0 0 0 r
s
.83 .24 .1 r
.61279 .39342 m
.64087 .37606 L
s
.159 .261 .547 r
.59659 .38848 m .58819 .3827 L .6071 .38948 L p F P
0 0 0 r
s
.604 .168 .076 r
.67055 .48048 m .68609 .47175 L .69488 .49019 L p F P
0 0 0 r
s
.83 .24 .1 r
.65245 .47383 m
.6845 .45558 L
s
.604 .168 .076 r
.69488 .49019 m .67854 .49919 L .67055 .48048 L p F P
0 0 0 r
s
.28 .394 .743 r
.32945 .48048 m .31391 .47175 L .30512 .49019 L p F P
0 0 0 r
s
.24 .35 .67 r
.3155 .45558 m
.34755 .47383 L
s
.28 .394 .743 r
.30512 .49019 m .32146 .49919 L .32945 .48048 L p F P
0 0 0 r
s
.83 .24 .1 r
.64087 .37606 m
.6581 .40122 L
s
.6581 .40122 m
.69054 .3817 L
s
.6581 .40122 m
.67282 .42803 L
s
.24 .35 .67 r
.35913 .37606 m
.3419 .40122 L
s
.3419 .40122 m
.30946 .3817 L
s
.32718 .42803 m
.3419 .40122 L
s
.528 .145 .066 r
.66244 .50806 m .67854 .49919 L .68234 .51823 L p F P
0 0 0 r
s
.528 .145 .066 r
.68234 .51823 m .66587 .52714 L .66244 .50806 L p F P
0 0 0 r
s
.83 .24 .1 r
.66029 .50091 m
.66425 .52688 L
s
.269 .375 .705 r
.33756 .50806 m .32146 .49919 L .31766 .51823 L p F P
0 0 0 r
s
.269 .375 .705 r
.31766 .51823 m .33413 .52714 L .33756 .50806 L p F P
0 0 0 r
s
.24 .35 .67 r
.33575 .52688 m
.33971 .50091 L
s
.83 .24 .1 r
.57007 .35433 m
.60119 .33409 L
s
.24 .35 .67 r
.42993 .35433 m
.39881 .33409 L
s
.83 .24 .1 r
.24078 .69491 m
.26692 .67982 L
s
.24078 .69491 m
.22268 .67032 L
s
.24 .35 .67 r
.75922 .69491 m
.73308 .67982 L
s
.75922 .69491 m
.77732 .67032 L
s
.435 .116 .054 r
.64966 .53592 m .66587 .52714 L .66534 .54591 L p F P
0 0 0 r
s
.435 .116 .054 r
.66534 .54591 m .64918 .55451 L .64966 .53592 L p F P
0 0 0 r
s
.83 .24 .1 r
.6324 .54413 m
.66425 .52688 L
s
.254 .35 .652 r
.35034 .53592 m .33413 .52714 L .33466 .54591 L p F P
0 0 0 r
s
.254 .35 .652 r
.33466 .54591 m .35082 .55451 L .35034 .53592 L p F P
0 0 0 r
s
.24 .35 .67 r
.33575 .52688 m
.3676 .54413 L
s
.83 .24 .1 r
.67282 .42803 m
.67663 .43702 L
s
.67743 .43891 m
.6845 .45558 L
s
.24 .35 .67 r
.32337 .43702 m
.32718 .42803 L
s
.3155 .45558 m
.32257 .43891 L
s
1 .32 .135 r
.47925 .34681 m .47242 .35148 L .4815 .3595 L p F P
0 0 0 r
s
1 .32 .135 r
.4815 .3595 m .48609 .35639 L .47925 .34681 L p F P
0 0 0 r
s
.25 .383 .767 r
.52075 .34681 m .52758 .35148 L .5185 .3595 L p F P
0 0 0 r
s
.25 .383 .767 r
.5185 .3595 m .51391 .35639 L .52075 .34681 L p F P
0 0 0 r
s
.083 .024 .01 r
.51059 .66642 m .52129 .66093 L .51799 .66285 L p F P
0 0 0 r
s
.083 .024 .01 r
.51799 .66285 m .50896 .66749 L .51059 .66642 L p F P
0 0 0 r
s
.83 .24 .1 r
.49883 .67132 m
.5102 .66547 L
s
.073 .085 .162 r
.48941 .66642 m .47871 .66093 L .48201 .66285 L p F P
0 0 0 r
s
.073 .085 .162 r
.48201 .66285 m .49104 .66749 L .48941 .66642 L p F P
0 0 0 r
s
.24 .35 .67 r
.4898 .66547 m
.50117 .67132 L
s
.83 .24 .1 r
.22268 .67032 m
.20852 .64315 L
s
.20852 .64315 m
.2342 .62726 L
s
.24 .35 .67 r
.77732 .67032 m
.79148 .64315 L
s
.79148 .64315 m
.7658 .62726 L
s
1 .322 .134 r
.43743 .36502 m .42881 .37097 L .4456 .36983 L p F P
0 0 0 r
s
1 .322 .134 r
.4456 .36983 m .45224 .36529 L .43743 .36502 L p F P
0 0 0 r
s
.83 .24 .1 r
.44771 .36616 m
.46816 .37001 L
s
.215 .337 .686 r
.56257 .36502 m .57119 .37097 L .5544 .36983 L p F P
0 0 0 r
s
.215 .337 .686 r
.5544 .36983 m .54776 .36529 L .56257 .36502 L p F P
0 0 0 r
s
.24 .35 .67 r
.53184 .37001 m
.55229 .36616 L
s
.83 .24 .1 r
.62169 .35341 m
.64087 .37606 L
s
.64087 .37606 m
.67311 .35611 L
s
.24 .35 .67 r
.37831 .35341 m
.35913 .37606 L
s
.35913 .37606 m
.32689 .35611 L
s
.83 .24 .1 r
.31115 .71712 m
.3384 .70234 L
s
.31115 .71712 m
.28816 .70094 L
s
.24 .35 .67 r
.68885 .71712 m
.6616 .70234 L
s
.68885 .71712 m
.71184 .70094 L
s
.862 .266 .108 r
.36471 .4071 m .35332 .415 L .37286 .40337 L p F P
0 0 0 r
s
.862 .266 .108 r
.37286 .40337 m .38282 .39646 L .36471 .4071 L p F P
0 0 0 r
s
.119 .189 .415 r
.63529 .4071 m .64668 .415 L .62714 .40337 L p F P
0 0 0 r
s
.119 .189 .415 r
.62714 .40337 m .61718 .39646 L .63529 .4071 L p F P
0 0 0 r
s
.319 .081 .039 r
.63326 .56299 m .64918 .55451 L .64505 .57214 L p F P
0 0 0 r
s
.319 .081 .039 r
.64505 .57214 m .6296 .58026 L .63326 .56299 L p F P
0 0 0 r
s
.83 .24 .1 r
.6318 .56786 m
.6324 .54413 L
s
.232 .315 .578 r
.36674 .56299 m .35082 .55451 L .35495 .57214 L p F P
0 0 0 r
s
.232 .315 .578 r
.35495 .57214 m .3704 .58026 L .36674 .56299 L p F P
0 0 0 r
s
.24 .35 .67 r
.3676 .54413 m
.3682 .56786 L
s
.83 .24 .1 r
.22268 .67032 m
.2486 .65483 L
s
.24 .35 .67 r
.77732 .67032 m
.7514 .65483 L
s
.1 .028 .011 r
.58015 .61803 m .59415 .61076 L .58651 .62302 L p F P
0 0 0 r
s
.1 .028 .011 r
.58651 .62302 m .5737 .62963 L .58015 .61803 L p F P
0 0 0 r
s
.83 .24 .1 r
.56447 .62114 m
.59522 .60509 L
s
.156 .195 .345 r
.41985 .61803 m .40585 .61076 L .41349 .62302 L p F P
0 0 0 r
s
.156 .195 .345 r
.41349 .62302 m .4263 .62963 L .41985 .61803 L p F P
0 0 0 r
s
.24 .35 .67 r
.40478 .60509 m
.43553 .62114 L
s
.083 .024 .01 r
.54853 .6426 m .56104 .63616 L .55409 .64409 L p F P
0 0 0 r
s
.83 .24 .1 r
.55457 .63785 m
.56447 .62114 L
s
.083 .024 .01 r
.55409 .64409 m .54304 .64976 L .54853 .6426 L p F P
0 0 0 r
s
.83 .24 .1 r
.52441 .65343 m
.55457 .63785 L
s
.111 .126 .238 r
.45147 .6426 m .43896 .63616 L .44591 .64409 L p F P
0 0 0 r
s
.24 .35 .67 r
.43553 .62114 m
.44543 .63785 L
s
.111 .126 .238 r
.44591 .64409 m .45696 .64976 L .45147 .6426 L p F P
0 0 0 r
s
.24 .35 .67 r
.44543 .63785 m
.47559 .65343 L
s
1 .32 .135 r
.48611 .34211 m .47925 .34681 L .48609 .35639 L p F P
0 0 0 r
s
1 .32 .135 r
.48609 .35639 m .49071 .35327 L .48611 .34211 L p F P
0 0 0 r
s
.25 .383 .767 r
.51389 .34211 m .52075 .34681 L .51391 .35639 L p F P
0 0 0 r
s
.25 .383 .767 r
.51391 .35639 m .50929 .35327 L .51389 .34211 L p F P
0 0 0 r
s
1 .308 .127 r
.40309 .38242 m .3929 .38948 L .41181 .3827 L p F P
0 0 0 r
s
.83 .24 .1 r
.40007 .38793 m
.41905 .38581 L
s
1 .308 .127 r
.41181 .3827 m .42027 .37686 L .40309 .38242 L p F P
0 0 0 r
s
.159 .261 .547 r
.59691 .38242 m .6071 .38948 L .58819 .3827 L p F P
0 0 0 r
s
.24 .35 .67 r
.58095 .38581 m
.59993 .38793 L
s
.159 .261 .547 r
.58819 .3827 m .57973 .37686 L .59691 .38242 L p F P
0 0 0 r
s
.83 .24 .1 r
.22447 .59862 m
.21986 .57043 L
s
.21986 .57043 m
.24578 .55339 L
s
.24 .35 .67 r
.77553 .59862 m
.78014 .57043 L
s
.78014 .57043 m
.75422 .55339 L
s
.083 .024 .01 r
.33702 .4289 m .32464 .43747 L .34207 .42281 L p F P
0 0 0 r
s
.24 .35 .67 r
.29448 .40889 m
.32718 .42803 L
s
.083 .024 .01 r
.34207 .42281 m .35332 .415 L .33702 .4289 L p F P
0 0 0 r
s
.104 .117 .224 r
.66298 .4289 m .67536 .43747 L .65793 .42281 L p F P
0 0 0 r
s
.83 .24 .1 r
.67282 .42803 m
.70552 .40889 L
s
.104 .117 .224 r
.65793 .42281 m .64668 .415 L .66298 .4289 L p F P
0 0 0 r
s
1 .322 .134 r
.44613 .35903 m .43743 .36502 L .45224 .36529 L p F P
0 0 0 r
s
1 .322 .134 r
.45224 .36529 m .45892 .36072 L .44613 .35903 L p F P
0 0 0 r
s
.215 .337 .686 r
.55387 .35903 m .56257 .36502 L .54776 .36529 L p F P
0 0 0 r
s
.215 .337 .686 r
.54776 .36529 m .54108 .36072 L .55387 .35903 L p F P
0 0 0 r
s
.215 .055 .025 r
.61437 .58826 m .6296 .58026 L .62271 .59592 L p F P
0 0 0 r
s
.83 .24 .1 r
.6005 .58447 m
.6318 .56786 L
s
.215 .055 .025 r
.62271 .59592 m .60833 .60339 L .61437 .58826 L p F P
0 0 0 r
s
.199 .262 .472 r
.38563 .58826 m .3704 .58026 L .37729 .59592 L p F P
0 0 0 r
s
.24 .35 .67 r
.3682 .56786 m
.3995 .58447 L
s
.199 .262 .472 r
.37729 .59592 m .39167 .60339 L .38563 .58826 L p F P
0 0 0 r
s
.083 .024 .01 r
.31119 .45391 m .29814 .4629 L .31243 .44594 L p F P
0 0 0 r
s
.24 .35 .67 r
.30696 .45072 m
.30815 .45139 L
s
.28246 .43677 m
.30696 .45072 L
s
.83 .24 .1 r
.28765 .46669 m
.30509 .45465 L
s
.083 .024 .01 r
.31243 .44594 m .32464 .43747 L .31119 .45391 L p F P
0 0 0 r
s
.24 .35 .67 r
.31163 .45337 m
.3155 .45558 L
s
.83 .24 .1 r
.32301 .43947 m
.32363 .43884 L
s
.157 .196 .347 r
.68881 .45391 m .70186 .4629 L .68757 .44594 L p F P
0 0 0 r
s
.83 .24 .1 r
.69185 .45139 m
.69304 .45072 L
s
.69304 .45072 m
.71754 .43677 L
s
.24 .35 .67 r
.69491 .45465 m
.71235 .46669 L
s
.157 .196 .347 r
.68757 .44594 m .67536 .43747 L .68881 .45391 L p F P
0 0 0 r
s
.83 .24 .1 r
.6845 .45558 m
.68837 .45337 L
s
.24 .35 .67 r
.67637 .43884 m
.67699 .43947 L
s
1 .32 .135 r
.49303 .33737 m .48611 .34211 L .49071 .35327 L p F P
0 0 0 r
s
1 .32 .135 r
.49071 .35327 m .49534 .35013 L .49303 .33737 L p F P
0 0 0 r
s
.25 .383 .767 r
.50697 .33737 m .51389 .34211 L .50929 .35327 L p F P
0 0 0 r
s
.25 .383 .767 r
.50929 .35327 m .50466 .35013 L .50697 .33737 L p F P
0 0 0 r
s
.83 .24 .1 r
.36197 .7132 m
.3901 .6983 L
s
.36197 .7132 m
.3384 .70234 L
s
.24 .35 .67 r
.63803 .7132 m
.6099 .6983 L
s
.63803 .7132 m
.6616 .70234 L
s
.604 .168 .076 r
.68609 .47175 m .70186 .4629 L .71146 .48105 L p F P
0 0 0 r
s
.604 .168 .076 r
.71146 .48105 m .69488 .49019 L .68609 .47175 L p F P
0 0 0 r
s
.83 .24 .1 r
.6845 .45558 m
.69271 .48292 L
s
.28 .394 .743 r
.31391 .47175 m .29814 .4629 L .28854 .48105 L p F P
0 0 0 r
s
.28 .394 .743 r
.28854 .48105 m .30512 .49019 L .31391 .47175 L p F P
0 0 0 r
s
.24 .35 .67 r
.30729 .48292 m
.3155 .45558 L
s
.083 .024 .01 r
.52129 .66093 m .5321 .65537 L .52711 .65817 L p F P
0 0 0 r
s
.083 .024 .01 r
.52711 .65817 m .51799 .66285 L .52129 .66093 L p F P
0 0 0 r
s
.83 .24 .1 r
.5102 .66547 m
.52441 .65343 L
s
.073 .085 .162 r
.47871 .66093 m .4679 .65537 L .47289 .65817 L p F P
0 0 0 r
s
.073 .085 .162 r
.47289 .65817 m .48201 .66285 L .47871 .66093 L p F P
0 0 0 r
s
.24 .35 .67 r
.47559 .65343 m
.4898 .66547 L
s
.83 .24 .1 r
.60119 .33409 m
.62169 .35341 L
s
.62169 .35341 m
.65381 .33301 L
s
.24 .35 .67 r
.39881 .33409 m
.37831 .35341 L
s
.37831 .35341 m
.34619 .33301 L
s
.528 .145 .066 r
.67854 .49919 m .69488 .49019 L .69906 .50919 L p F P
0 0 0 r
s
.528 .145 .066 r
.69906 .50919 m .68234 .51823 L .67854 .49919 L p F P
0 0 0 r
s
.83 .24 .1 r
.66029 .50091 m
.69271 .48292 L
s
.269 .375 .705 r
.32146 .49919 m .30512 .49019 L .30094 .50919 L p F P
0 0 0 r
s
.269 .375 .705 r
.30094 .50919 m .31766 .51823 L .32146 .49919 L p F P
0 0 0 r
s
.24 .35 .67 r
.30729 .48292 m
.33971 .50091 L
s
.862 .266 .108 r
.37625 .39909 m .36471 .4071 L .38282 .39646 L p F P
0 0 0 r
s
.862 .266 .108 r
.38282 .39646 m .3929 .38948 L .37625 .39909 L p F P
0 0 0 r
s
.83 .24 .1 r
.3721 .40727 m
.40007 .38793 L
s
.119 .189 .415 r
.62375 .39909 m .63529 .4071 L .61718 .39646 L p F P
0 0 0 r
s
.119 .189 .415 r
.61718 .39646 m .6071 .38948 L .62375 .39909 L p F P
0 0 0 r
s
.24 .35 .67 r
.59993 .38793 m
.6279 .40727 L
s
.83 .24 .1 r
.41291 .70336 m
.44188 .68829 L
s
.41291 .70336 m
.3901 .6983 L
s
.24 .35 .67 r
.58709 .70336 m
.55812 .68829 L
s
.58709 .70336 m
.6099 .6983 L
s
1 .308 .127 r
.41339 .37528 m .40309 .38242 L .42027 .37686 L p F P
0 0 0 r
s
1 .308 .127 r
.42027 .37686 m .42881 .37097 L .41339 .37528 L p F P
0 0 0 r
s
.83 .24 .1 r
.41905 .38581 m
.44771 .36616 L
s
.159 .261 .547 r
.58661 .37528 m .59691 .38242 L .57973 .37686 L p F P
0 0 0 r
s
.159 .261 .547 r
.57973 .37686 m .57119 .37097 L .58661 .37528 L p F P
0 0 0 r
s
.24 .35 .67 r
.55229 .36616 m
.58095 .38581 L
s
1 .32 .135 r
.5 .3326 m .49303 .33737 L .49534 .35013 L p F P
0 0 0 r
s
1 .32 .135 r
.49534 .35013 m .5 .34697 L .5 .3326 L p F P
0 0 0 r
s
.83 .24 .1 r
.46816 .37001 m
.49756 .35012 L
s
.25 .383 .767 r
.5 .3326 m .50697 .33737 L .50466 .35013 L p F P
0 0 0 r
s
.25 .383 .767 r
.50466 .35013 m .5 .34697 L .5 .3326 L p F P
0 0 0 r
s
.24 .35 .67 r
.50244 .35012 m
.53184 .37001 L
s
.49461 .35365 m
.50244 .35012 L
s
.83 .24 .1 r
.49756 .35012 m
.50539 .35365 L
s
.46269 .68742 m
.49242 .6721 L
s
.46269 .68742 m
.44188 .68829 L
s
.24 .35 .67 r
.53731 .68742 m
.50758 .6721 L
s
.53731 .68742 m
.55812 .68829 L
s
.435 .116 .054 r
.66587 .52714 m .68234 .51823 L .68174 .53717 L p F P
0 0 0 r
s
.435 .116 .054 r
.68174 .53717 m .66534 .54591 L .66587 .52714 L p F P
0 0 0 r
s
.254 .35 .652 r
.33413 .52714 m .31766 .51823 L .31826 .53717 L p F P
0 0 0 r
s
.254 .35 .652 r
.31826 .53717 m .33466 .54591 L .33413 .52714 L p F P
0 0 0 r
s
1 .322 .134 r
.4549 .35297 m .44613 .35903 L .45892 .36072 L p F P
0 0 0 r
s
.24 .35 .67 r
.42993 .35433 m
.45107 .33958 L
s
1 .322 .134 r
.45892 .36072 m .46565 .35611 L .4549 .35297 L p F P
0 0 0 r
s
.215 .337 .686 r
.5451 .35297 m .55387 .35903 L .54108 .36072 L p F P
0 0 0 r
s
.83 .24 .1 r
.54893 .33958 m
.57007 .35433 L
s
.215 .337 .686 r
.54108 .36072 m .53435 .35611 L .5451 .35297 L p F P
0 0 0 r
s
.83 .24 .1 r
.2726 .5091 m
.24616 .52688 L
s
.24 .35 .67 r
.7274 .5091 m
.75384 .52688 L
s
.83 .24 .1 r
.24578 .55339 m
.24616 .52688 L
s
.24 .35 .67 r
.75422 .55339 m
.75384 .52688 L
s
.083 .024 .01 r
.56104 .63616 m .5737 .62963 L .56526 .63835 L p F P
0 0 0 r
s
.083 .024 .01 r
.56526 .63835 m .55409 .64409 L .56104 .63616 L p F P
0 0 0 r
s
.111 .126 .238 r
.43896 .63616 m .4263 .62963 L .43474 .63835 L p F P
0 0 0 r
s
.111 .126 .238 r
.43474 .63835 m .44591 .64409 L .43896 .63616 L p F P
0 0 0 r
s
.83 .24 .1 r
.49756 .35012 m
.50276 .3466 L
s
.24 .35 .67 r
.49724 .3466 m
.50244 .35012 L
s
.1 .028 .011 r
.59415 .61076 m .60833 .60339 L .59949 .61633 L p F P
0 0 0 r
s
.1 .028 .011 r
.59949 .61633 m .58651 .62302 L .59415 .61076 L p F P
0 0 0 r
s
.156 .195 .345 r
.40585 .61076 m .39167 .60339 L .40051 .61633 L p F P
0 0 0 r
s
.156 .195 .345 r
.40051 .61633 m .41349 .62302 L .40585 .61076 L p F P
0 0 0 r
s
.319 .081 .039 r
.64918 .55451 m .66534 .54591 L .66073 .5639 L p F P
0 0 0 r
s
.319 .081 .039 r
.66073 .5639 m .64505 .57214 L .64918 .55451 L p F P
0 0 0 r
s
.232 .315 .578 r
.35082 .55451 m .33466 .54591 L .33927 .5639 L p F P
0 0 0 r
s
.232 .315 .578 r
.33927 .5639 m .35495 .57214 L .35082 .55451 L p F P
0 0 0 r
s
.83 .24 .1 r
.28816 .70094 m
.31529 .68579 L
s
.28816 .70094 m
.26692 .67982 L
s
.24 .35 .67 r
.71184 .70094 m
.68471 .68579 L
s
.71184 .70094 m
.73308 .67982 L
s
.083 .024 .01 r
.34958 .4202 m .33702 .4289 L .35332 .415 L p F P
0 0 0 r
s
.083 .024 .01 r
.35332 .415 m .36471 .4071 L .34958 .4202 L p F P
0 0 0 r
s
.83 .24 .1 r
.35406 .41632 m
.35539 .4154 L
s
.35539 .4154 m
.3721 .40727 L
s
.104 .117 .224 r
.65042 .4202 m .66298 .4289 L .64668 .415 L p F P
0 0 0 r
s
.104 .117 .224 r
.64668 .415 m .63529 .4071 L .65042 .4202 L p F P
0 0 0 r
s
.24 .35 .67 r
.64461 .4154 m
.64594 .41632 L
s
.6279 .40727 m
.64461 .4154 L
s
.83 .24 .1 r
.2726 .5091 m
.2778 .48571 L
s
.24 .35 .67 r
.7274 .5091 m
.7222 .48571 L
s
.83 .24 .1 r
.52787 .32962 m
.54893 .33958 L
s
.54893 .33958 m
.58008 .31888 L
s
.24 .35 .67 r
.47213 .32962 m
.45107 .33958 L
s
.45107 .33958 m
.41992 .31888 L
s
.83 .24 .1 r
.2342 .62726 m
.22447 .59862 L
s
.22447 .59862 m
.25066 .58189 L
s
.24 .35 .67 r
.7658 .62726 m
.77553 .59862 L
s
.77553 .59862 m
.74934 .58189 L
s
1 .322 .134 r
.46376 .34686 m .4549 .35297 L .46565 .35611 L p F P
0 0 0 r
s
1 .322 .134 r
.46565 .35611 m .47242 .35148 L .46376 .34686 L p F P
0 0 0 r
s
.215 .337 .686 r
.53624 .34686 m .5451 .35297 L .53435 .35611 L p F P
0 0 0 r
s
.215 .337 .686 r
.53435 .35611 m .52758 .35148 L .53624 .34686 L p F P
0 0 0 r
s
.083 .024 .01 r
.5321 .65537 m .54304 .64976 L .53632 .65344 L p F P
0 0 0 r
s
.083 .024 .01 r
.53632 .65344 m .52711 .65817 L .5321 .65537 L p F P
0 0 0 r
s
.073 .085 .162 r
.4679 .65537 m .45696 .64976 L .46368 .65344 L p F P
0 0 0 r
s
.073 .085 .162 r
.46368 .65344 m .47289 .65817 L .4679 .65537 L p F P
0 0 0 r
s
1 .308 .127 r
.4238 .36807 m .41339 .37528 L .42881 .37097 L p F P
0 0 0 r
s
1 .308 .127 r
.42881 .37097 m .43743 .36502 L .4238 .36807 L p F P
0 0 0 r
s
.159 .261 .547 r
.5762 .36807 m .58661 .37528 L .57119 .37097 L p F P
0 0 0 r
s
.159 .261 .547 r
.57119 .37097 m .56257 .36502 L .5762 .36807 L p F P
0 0 0 r
s
.083 .024 .01 r
.32443 .44479 m .31119 .45391 L .32464 .43747 L p F P
0 0 0 r
s
.083 .024 .01 r
.32464 .43747 m .33702 .4289 L .32443 .44479 L p F P
0 0 0 r
s
.157 .196 .347 r
.67557 .44479 m .68881 .45391 L .67536 .43747 L p F P
0 0 0 r
s
.157 .196 .347 r
.67536 .43747 m .66298 .4289 L .67557 .44479 L p F P
0 0 0 r
s
.215 .055 .025 r
.6296 .58026 m .64505 .57214 L .63728 .58835 L p F P
0 0 0 r
s
.215 .055 .025 r
.63728 .58835 m .62271 .59592 L .6296 .58026 L p F P
0 0 0 r
s
.83 .24 .1 r
.6269 .58855 m
.6318 .56786 L
s
.199 .262 .472 r
.3704 .58026 m .35495 .57214 L .36272 .58835 L p F P
0 0 0 r
s
.199 .262 .472 r
.36272 .58835 m .37729 .59592 L .3704 .58026 L p F P
0 0 0 r
s
.24 .35 .67 r
.3682 .56786 m
.3731 .58855 L
s
.862 .266 .108 r
.38792 .39099 m .37625 .39909 L .3929 .38948 L p F P
0 0 0 r
s
.862 .266 .108 r
.3929 .38948 m .40309 .38242 L .38792 .39099 L p F P
0 0 0 r
s
.119 .189 .415 r
.61208 .39099 m .62375 .39909 L .6071 .38948 L p F P
0 0 0 r
s
.119 .189 .415 r
.6071 .38948 m .59691 .38242 L .61208 .39099 L p F P
0 0 0 r
s
.15 .041 .019 r
.30213 .47178 m .28854 .48105 L .29814 .4629 L p F P
0 0 0 r
s
.15 .041 .019 r
.29814 .4629 m .31119 .45391 L .30213 .47178 L p F P
0 0 0 r
s
.202 .266 .472 r
.69787 .47178 m .71146 .48105 L .70186 .4629 L p F P
0 0 0 r
s
.202 .266 .472 r
.70186 .4629 m .68881 .45391 L .69787 .47178 L p F P
0 0 0 r
s
.914 .283 .117 r
.5 .67208 m .50896 .66749 L .50704 .66444 L p F P
0 0 0 r
s
.83 .24 .1 r
.50817 .66623 m
.5102 .66547 L
s
.914 .283 .117 r
.50704 .66444 m .5 .66807 L .5 .67208 L p F P
0 0 0 r
s
.24 .35 .67 r
.50243 .67018 m
.50321 .67048 L
s
.50321 .67048 m
.50758 .6721 L
s
.156 .257 .535 r
.5 .67208 m .49104 .66749 L .49296 .66444 L p F P
0 0 0 r
s
.24 .35 .67 r
.4898 .66547 m
.49183 .66623 L
s
.156 .257 .535 r
.49296 .66444 m .5 .66807 L .5 .67208 L p F P
0 0 0 r
s
.83 .24 .1 r
.49242 .6721 m
.49679 .67048 L
s
.49679 .67048 m
.49757 .67018 L
s
.67311 .35611 m
.69054 .3817 L
s
.69054 .3817 m
.72397 .36158 L
s
.69054 .3817 m
.70552 .40889 L
s
.24 .35 .67 r
.32689 .35611 m
.30946 .3817 L
s
.30946 .3817 m
.27603 .36158 L
s
.30946 .3817 m
.29448 .40889 L
s
.528 .145 .066 r
.69488 .49019 m .71146 .48105 L .71603 .5 L p F P
0 0 0 r
s
.24 .35 .67 r
.70924 .47685 m
.7222 .48571 L
s
.83 .24 .1 r
.69271 .48292 m
.70457 .47635 L
s
.528 .145 .066 r
.71603 .5 m .69906 .50919 L .69488 .49019 L p F P
0 0 0 r
s
.83 .24 .1 r
.69271 .48292 m
.69708 .5091 L
s
.269 .375 .705 r
.30512 .49019 m .28854 .48105 L .28397 .5 L p F P
0 0 0 r
s
.83 .24 .1 r
.2778 .48571 m
.29076 .47685 L
s
.24 .35 .67 r
.29543 .47635 m
.30729 .48292 L
s
.269 .375 .705 r
.28397 .5 m .30094 .50919 L .30512 .49019 L p F P
0 0 0 r
s
.24 .35 .67 r
.30292 .5091 m
.30729 .48292 L
s
.083 .024 .01 r
.5737 .62963 m .58651 .62302 L .57656 .63255 L p F P
0 0 0 r
s
.083 .024 .01 r
.57656 .63255 m .56526 .63835 L .5737 .62963 L p F P
0 0 0 r
s
.111 .126 .238 r
.4263 .62963 m .41349 .62302 L .42344 .63255 L p F P
0 0 0 r
s
.111 .126 .238 r
.42344 .63255 m .43474 .63835 L .4263 .62963 L p F P
0 0 0 r
s
.83 .24 .1 r
.58008 .31888 m
.60119 .33409 L
s
.60119 .33409 m
.63327 .31322 L
s
.24 .35 .67 r
.41992 .31888 m
.39881 .33409 L
s
.39881 .33409 m
.36673 .31322 L
s
1 .322 .134 r
.47269 .3407 m .46376 .34686 L .47242 .35148 L p F P
0 0 0 r
s
1 .322 .134 r
.47242 .35148 m .47925 .34681 L .47269 .3407 L p F P
0 0 0 r
s
.215 .337 .686 r
.52731 .3407 m .53624 .34686 L .52758 .35148 L p F P
0 0 0 r
s
.215 .337 .686 r
.52758 .35148 m .52075 .34681 L .52731 .3407 L p F P
0 0 0 r
s
.83 .24 .1 r
.26692 .67982 m
.29388 .66427 L
s
.26692 .67982 m
.2486 .65483 L
s
.24 .35 .67 r
.73308 .67982 m
.70612 .66427 L
s
.73308 .67982 m
.7514 .65483 L
s
.83 .24 .1 r
.70552 .40889 m
.73923 .38916 L
s
.70552 .40889 m
.71754 .43677 L
s
.24 .35 .67 r
.29448 .40889 m
.26077 .38916 L
s
.29448 .40889 m
.28246 .43677 L
s
.435 .116 .054 r
.68234 .51823 m .69906 .50919 L .6984 .5283 L p F P
0 0 0 r
s
.435 .116 .054 r
.6984 .5283 m .68174 .53717 L .68234 .51823 L p F P
0 0 0 r
s
.83 .24 .1 r
.66425 .52688 m
.69708 .5091 L
s
.254 .35 .652 r
.31766 .51823 m .30094 .50919 L .3016 .5283 L p F P
0 0 0 r
s
.254 .35 .652 r
.3016 .5283 m .31826 .53717 L .31766 .51823 L p F P
0 0 0 r
s
.24 .35 .67 r
.30292 .5091 m
.33575 .52688 L
s
.1 .028 .011 r
.60833 .60339 m .62271 .59592 L .61263 .60956 L p F P
0 0 0 r
s
.1 .028 .011 r
.61263 .60956 m .59949 .61633 L .60833 .60339 L p F P
0 0 0 r
s
.83 .24 .1 r
.59522 .60509 m
.6269 .58855 L
s
.156 .195 .345 r
.39167 .60339 m .37729 .59592 L .38737 .60956 L p F P
0 0 0 r
s
.156 .195 .345 r
.38737 .60956 m .40051 .61633 L .39167 .60339 L p F P
0 0 0 r
s
.24 .35 .67 r
.3731 .58855 m
.40478 .60509 L
s
.83 .24 .1 r
.2486 .65483 m
.2342 .62726 L
s
.2342 .62726 m
.26067 .61089 L
s
.24 .35 .67 r
.7514 .65483 m
.7658 .62726 L
s
.7658 .62726 m
.73933 .61089 L
s
.083 .024 .01 r
.3623 .41139 m .34958 .4202 L .36471 .4071 L p F P
0 0 0 r
s
.083 .024 .01 r
.36471 .4071 m .37625 .39909 L .3623 .41139 L p F P
0 0 0 r
s
.104 .117 .224 r
.6377 .41139 m .65042 .4202 L .63529 .4071 L p F P
0 0 0 r
s
.104 .117 .224 r
.63529 .4071 m .62375 .39909 L .6377 .41139 L p F P
0 0 0 r
s
.83 .24 .1 r
.65381 .33301 m
.67311 .35611 L
s
.67311 .35611 m
.70635 .33556 L
s
.24 .35 .67 r
.34619 .33301 m
.32689 .35611 L
s
.32689 .35611 m
.29365 .33556 L
s
1 .308 .127 r
.43432 .36077 m .4238 .36807 L .43743 .36502 L p F P
0 0 0 r
s
.83 .24 .1 r
.4289 .368 m
.44771 .36616 L
s
1 .308 .127 r
.43743 .36502 m .44613 .35903 L .43432 .36077 L p F P
0 0 0 r
s
.159 .261 .547 r
.56568 .36077 m .5762 .36807 L .56257 .36502 L p F P
0 0 0 r
s
.24 .35 .67 r
.55229 .36616 m
.5711 .368 L
s
.159 .261 .547 r
.56257 .36502 m .55387 .35903 L .56568 .36077 L p F P
0 0 0 r
s
.83 .24 .1 r
.3384 .70234 m
.36649 .68711 L
s
.3384 .70234 m
.31529 .68579 L
s
.24 .35 .67 r
.6616 .70234 m
.63351 .68711 L
s
.6616 .70234 m
.68471 .68579 L
s
.083 .024 .01 r
.54304 .64976 m .55409 .64409 L .5456 .64867 L p F P
0 0 0 r
s
.083 .024 .01 r
.5456 .64867 m .53632 .65344 L .54304 .64976 L p F P
0 0 0 r
s
.83 .24 .1 r
.54064 .64983 m
.55457 .63785 L
s
.073 .085 .162 r
.45696 .64976 m .44591 .64409 L .4544 .64867 L p F P
0 0 0 r
s
.073 .085 .162 r
.4544 .64867 m .46368 .65344 L .45696 .64976 L p F P
0 0 0 r
s
.24 .35 .67 r
.44543 .63785 m
.45936 .64983 L
s
.319 .081 .039 r
.66534 .54591 m .68174 .53717 L .67665 .55554 L p F P
0 0 0 r
s
.319 .081 .039 r
.67665 .55554 m .66073 .5639 L .66534 .54591 L p F P
0 0 0 r
s
.83 .24 .1 r
.66406 .55074 m
.66425 .52688 L
s
.232 .315 .578 r
.33466 .54591 m .31826 .53717 L .32335 .55554 L p F P
0 0 0 r
s
.232 .315 .578 r
.32335 .55554 m .33927 .5639 L .33466 .54591 L p F P
0 0 0 r
s
.24 .35 .67 r
.33575 .52688 m
.33594 .55074 L
s
.83 .24 .1 r
.2486 .65483 m
.27533 .63885 L
s
.24 .35 .67 r
.7514 .65483 m
.72467 .63885 L
s
.862 .266 .108 r
.39975 .38278 m .38792 .39099 L .40309 .38242 L p F P
0 0 0 r
s
.862 .266 .108 r
.40309 .38242 m .41339 .37528 L .39975 .38278 L p F P
0 0 0 r
s
.119 .189 .415 r
.60025 .38278 m .61208 .39099 L .59691 .38242 L p F P
0 0 0 r
s
.119 .189 .415 r
.59691 .38242 m .58661 .37528 L .60025 .38278 L p F P
0 0 0 r
s
.914 .283 .117 r
.50896 .66749 m .51799 .66285 L .51414 .66079 L p F P
0 0 0 r
s
.83 .24 .1 r
.5102 .66547 m
.51072 .66521 L
s
.51668 .66214 m
.54064 .64983 L
s
.914 .283 .117 r
.51414 .66079 m .50704 .66444 L .50896 .66749 L p F P
0 0 0 r
s
.156 .257 .535 r
.49104 .66749 m .48201 .66285 L .48586 .66079 L p F P
0 0 0 r
s
.24 .35 .67 r
.45936 .64983 m
.48332 .66214 L
s
.48928 .66521 m
.4898 .66547 L
s
.156 .257 .535 r
.48586 .66079 m .49296 .66444 L .49104 .66749 L p F P
0 0 0 r
s
1 .322 .134 r
.48171 .33448 m .47269 .3407 L .47925 .34681 L p F P
0 0 0 r
s
1 .322 .134 r
.47925 .34681 m .48611 .34211 L .48171 .33448 L p F P
0 0 0 r
s
.24 .35 .67 r
.48325 .33714 m
.48834 .34058 L
s
.47213 .32962 m
.48052 .3353 L
s
.83 .24 .1 r
.47725 .34591 m
.49756 .35012 L
s
.215 .337 .686 r
.51829 .33448 m .52731 .3407 L .52075 .34681 L p F P
0 0 0 r
s
.215 .337 .686 r
.52075 .34681 m .51389 .34211 L .51829 .33448 L p F P
0 0 0 r
s
.83 .24 .1 r
.51948 .3353 m
.52787 .32962 L
s
.51166 .34058 m
.51675 .33714 L
s
.24 .35 .67 r
.50244 .35012 m
.52275 .34591 L
s
.83 .24 .1 r
.25066 .58189 m
.24578 .55339 L
s
.24578 .55339 m
.2725 .53583 L
s
.24 .35 .67 r
.74934 .58189 m
.75422 .55339 L
s
.75422 .55339 m
.7275 .53583 L
s
.083 .024 .01 r
.33786 .43554 m .32443 .44479 L .33702 .4289 L p F P
0 0 0 r
s
.083 .024 .01 r
.33702 .4289 m .34958 .4202 L .33786 .43554 L p F P
0 0 0 r
s
.83 .24 .1 r
.34547 .42558 m
.35306 .41779 L
s
.157 .196 .347 r
.66214 .43554 m .67557 .44479 L .66298 .4289 L p F P
0 0 0 r
s
.157 .196 .347 r
.66298 .4289 m .65042 .4202 L .66214 .43554 L p F P
0 0 0 r
s
.24 .35 .67 r
.64694 .41779 m
.65453 .42558 L
s
.215 .055 .025 r
.64505 .57214 m .66073 .5639 L .65207 .58067 L p F P
0 0 0 r
s
.83 .24 .1 r
.6318 .56786 m
.66406 .55074 L
s
.215 .055 .025 r
.65207 .58067 m .63728 .58835 L .64505 .57214 L p F P
0 0 0 r
s
.199 .262 .472 r
.35495 .57214 m .33927 .5639 L .34793 .58067 L p F P
0 0 0 r
s
.24 .35 .67 r
.33594 .55074 m
.3682 .56786 L
s
.199 .262 .472 r
.34793 .58067 m .36272 .58835 L .35495 .57214 L p F P
0 0 0 r
s
.83 .24 .1 r
.71754 .43677 m
.75159 .41737 L
s
.71754 .43677 m
.72613 .46438 L
s
.24 .35 .67 r
.28246 .43677 m
.24841 .41737 L
s
.28246 .43677 m
.27387 .46438 L
s
.15 .041 .019 r
.31594 .46236 m .30213 .47178 L .31119 .45391 L p F P
0 0 0 r
s
.83 .24 .1 r
.31136 .45423 m
.3117 .45356 L
s
.15 .041 .019 r
.31119 .45391 m .32443 .44479 L .31594 .46236 L p F P
0 0 0 r
s
.202 .266 .472 r
.68406 .46236 m .69787 .47178 L .68881 .45391 L p F P
0 0 0 r
s
.24 .35 .67 r
.6883 .45356 m
.68864 .45423 L
s
.202 .266 .472 r
.68881 .45391 m .67557 .44479 L .68406 .46236 L p F P
0 0 0 r
s
.83 .24 .1 r
.3901 .6983 m
.41911 .68294 L
s
.3901 .6983 m
.36649 .68711 L
s
.24 .35 .67 r
.6099 .6983 m
.58089 .68294 L
s
.6099 .6983 m
.63351 .68711 L
s
1 .308 .127 r
.44497 .3534 m .43432 .36077 L .44613 .35903 L p F P
0 0 0 r
s
1 .308 .127 r
.44613 .35903 m .4549 .35297 L .44497 .3534 L p F P
0 0 0 r
s
.83 .24 .1 r
.44771 .36616 m
.47725 .34591 L
s
.159 .261 .547 r
.55503 .3534 m .56568 .36077 L .55387 .35903 L p F P
0 0 0 r
s
.159 .261 .547 r
.55387 .35903 m .5451 .35297 L .55503 .3534 L p F P
0 0 0 r
s
.24 .35 .67 r
.52275 .34591 m
.55229 .36616 L
s
.083 .024 .01 r
.58651 .62302 m .59949 .61633 L .58798 .62669 L p F P
0 0 0 r
s
.83 .24 .1 r
.58566 .6218 m
.59522 .60509 L
s
.083 .024 .01 r
.58798 .62669 m .57656 .63255 L .58651 .62302 L p F P
0 0 0 r
s
.83 .24 .1 r
.55457 .63785 m
.58566 .6218 L
s
.111 .126 .238 r
.41349 .62302 m .40051 .61633 L .41202 .62669 L p F P
0 0 0 r
s
.24 .35 .67 r
.40478 .60509 m
.41434 .6218 L
s
.111 .126 .238 r
.41202 .62669 m .42344 .63255 L .41349 .62302 L p F P
0 0 0 r
s
.24 .35 .67 r
.41434 .6218 m
.44543 .63785 L
s
.83 .24 .1 r
.63327 .31322 m
.65381 .33301 L
s
.65381 .33301 m
.68693 .31198 L
s
.24 .35 .67 r
.36673 .31322 m
.34619 .33301 L
s
.34619 .33301 m
.31307 .31198 L
s
1 .322 .134 r
.49081 .3282 m .48171 .33448 L .48611 .34211 L p F P
0 0 0 r
s
1 .322 .134 r
.48611 .34211 m .49303 .33737 L .49081 .3282 L p F P
0 0 0 r
s
.215 .337 .686 r
.50919 .3282 m .51829 .33448 L .51389 .34211 L p F P
0 0 0 r
s
.215 .337 .686 r
.51389 .34211 m .50697 .33737 L .50919 .3282 L p F P
0 0 0 r
s
.276 .072 .035 r
.29783 .49067 m .28397 .5 L .28854 .48105 L p F P
0 0 0 r
s
.276 .072 .035 r
.28854 .48105 m .30213 .47178 L .29783 .49067 L p F P
0 0 0 r
s
.24 .35 .67 r
.27387 .46438 m
.29144 .47413 L
s
.29144 .47413 m
.29238 .47465 L
s
.24 .327 .596 r
.70217 .49067 m .71603 .5 L .71146 .48105 L p F P
0 0 0 r
s
.24 .327 .596 r
.71146 .48105 m .69787 .47178 L .70217 .49067 L p F P
0 0 0 r
s
.83 .24 .1 r
.70856 .47413 m
.72613 .46438 L
s
.70762 .47465 m
.70856 .47413 L
s
.083 .024 .01 r
.37521 .40245 m .3623 .41139 L .37625 .39909 L p F P
0 0 0 r
s
.083 .024 .01 r
.37625 .39909 m .38792 .39099 L .37521 .40245 L p F P
0 0 0 r
s
.83 .24 .1 r
.37898 .39905 m
.38356 .39587 L
s
.38356 .39587 m
.40007 .38793 L
s
.104 .117 .224 r
.62479 .40245 m .6377 .41139 L .62375 .39909 L p F P
0 0 0 r
s
.104 .117 .224 r
.62375 .39909 m .61208 .39099 L .62479 .40245 L p F P
0 0 0 r
s
.24 .35 .67 r
.61644 .39587 m
.62102 .39905 L
s
.59993 .38793 m
.61644 .39587 L
s
.083 .024 .01 r
.55409 .64409 m .56526 .63835 L .55498 .64386 L p F P
0 0 0 r
s
.083 .024 .01 r
.55498 .64386 m .5456 .64867 L .55409 .64409 L p F P
0 0 0 r
s
.073 .085 .162 r
.44591 .64409 m .43474 .63835 L .44502 .64386 L p F P
0 0 0 r
s
.073 .085 .162 r
.44502 .64386 m .4544 .64867 L .44591 .64409 L p F P
0 0 0 r
s
.83 .24 .1 r
.44188 .68829 m
.47174 .67275 L
s
.44188 .68829 m
.41911 .68294 L
s
.24 .35 .67 r
.55812 .68829 m
.52826 .67275 L
s
.55812 .68829 m
.58089 .68294 L
s
.1 .028 .011 r
.62271 .59592 m .63728 .58835 L .62594 .60269 L p F P
0 0 0 r
s
.1 .028 .011 r
.62594 .60269 m .61263 .60956 L .62271 .59592 L p F P
0 0 0 r
s
.156 .195 .345 r
.37729 .59592 m .36272 .58835 L .37406 .60269 L p F P
0 0 0 r
s
.156 .195 .345 r
.37406 .60269 m .38737 .60956 L .37729 .59592 L p F P
0 0 0 r
s
.83 .24 .1 r
.49242 .6721 m
.49851 .66897 L
s
.49242 .6721 m
.47174 .67275 L
s
.24 .35 .67 r
.50149 .66897 m
.50758 .6721 L
s
.50758 .6721 m
.52826 .67275 L
s
.914 .283 .117 r
.51799 .66285 m .52711 .65817 L .52128 .6571 L p F P
0 0 0 r
s
.914 .283 .117 r
.52128 .6571 m .51414 .66079 L .51799 .66285 L p F P
0 0 0 r
s
.156 .257 .535 r
.48201 .66285 m .47289 .65817 L .47872 .6571 L p F P
0 0 0 r
s
.156 .257 .535 r
.47872 .6571 m .48586 .66079 L .48201 .66285 L p F P
0 0 0 r
s
.862 .266 .108 r
.41172 .37447 m .39975 .38278 L .41339 .37528 L p F P
0 0 0 r
s
.862 .266 .108 r
.41339 .37528 m .4238 .36807 L .41172 .37447 L p F P
0 0 0 r
s
.83 .24 .1 r
.40007 .38793 m
.4289 .368 L
s
.119 .189 .415 r
.58828 .37447 m .60025 .38278 L .58661 .37528 L p F P
0 0 0 r
s
.119 .189 .415 r
.58661 .37528 m .5762 .36807 L .58828 .37447 L p F P
0 0 0 r
s
.24 .35 .67 r
.5711 .368 m
.59993 .38793 L
s
.435 .116 .054 r
.69906 .50919 m .71603 .5 L .71532 .51929 L p F P
0 0 0 r
s
.435 .116 .054 r
.71532 .51929 m .6984 .5283 L .69906 .50919 L p F P
0 0 0 r
s
.254 .35 .652 r
.30094 .50919 m .28397 .5 L .28468 .51929 L p F P
0 0 0 r
s
.254 .35 .652 r
.28468 .51929 m .3016 .5283 L .30094 .50919 L p F P
0 0 0 r
s
.83 .24 .1 r
.2726 .5091 m
.28402 .50142 L
s
.24 .35 .67 r
.71598 .50142 m
.7274 .5091 L
s
.83 .24 .1 r
.2725 .53583 m
.2726 .5091 L
s
.24 .35 .67 r
.7275 .53583 m
.7274 .5091 L
s
.83 .24 .1 r
.52787 .32962 m
.55912 .30849 L
s
.24 .35 .67 r
.47213 .32962 m
.44088 .30849 L
s
.319 .081 .039 r
.68174 .53717 m .6984 .5283 L .6928 .54706 L p F P
0 0 0 r
s
.319 .081 .039 r
.6928 .54706 m .67665 .55554 L .68174 .53717 L p F P
0 0 0 r
s
.232 .315 .578 r
.31826 .53717 m .3016 .5283 L .3072 .54706 L p F P
0 0 0 r
s
.232 .315 .578 r
.3072 .54706 m .32335 .55554 L .31826 .53717 L p F P
0 0 0 r
s
.83 .24 .1 r
.31529 .68579 m
.34326 .67017 L
s
.31529 .68579 m
.29388 .66427 L
s
.24 .35 .67 r
.68471 .68579 m
.65674 .67017 L
s
.68471 .68579 m
.70612 .66427 L
s
1 .308 .127 r
.45573 .34594 m .44497 .3534 L .4549 .35297 L p F P
0 0 0 r
s
1 .308 .127 r
.4549 .35297 m .46376 .34686 L .45573 .34594 L p F P
0 0 0 r
s
.159 .261 .547 r
.54427 .34594 m .55503 .3534 L .5451 .35297 L p F P
0 0 0 r
s
.159 .261 .547 r
.5451 .35297 m .53624 .34686 L .54427 .34594 L p F P
0 0 0 r
s
1 .322 .134 r
.5 .32187 m .49081 .3282 L .49303 .33737 L p F P
0 0 0 r
s
1 .322 .134 r
.49303 .33737 m .5 .3326 L .5 .32187 L p F P
0 0 0 r
s
.24 .35 .67 r
.4923 .32504 m
.49385 .3261 L
s
.215 .337 .686 r
.5 .32187 m .50919 .3282 L .50697 .33737 L p F P
0 0 0 r
s
.215 .337 .686 r
.50697 .33737 m .5 .3326 L .5 .32187 L p F P
0 0 0 r
s
.83 .24 .1 r
.50615 .3261 m
.5077 .32504 L
s
.083 .024 .01 r
.3515 .42615 m .33786 .43554 L .34958 .4202 L p F P
0 0 0 r
s
.083 .024 .01 r
.34958 .4202 m .3623 .41139 L .3515 .42615 L p F P
0 0 0 r
s
.157 .196 .347 r
.6485 .42615 m .66214 .43554 L .65042 .4202 L p F P
0 0 0 r
s
.157 .196 .347 r
.65042 .4202 m .6377 .41139 L .6485 .42615 L p F P
0 0 0 r
s
.83 .24 .1 r
.55912 .30849 m
.58008 .31888 L
s
.58008 .31888 m
.6122 .29754 L
s
.24 .35 .67 r
.44088 .30849 m
.41992 .31888 L
s
.41992 .31888 m
.3878 .29754 L
s
.83 .24 .1 r
.26067 .61089 m
.25066 .58189 L
s
.25066 .58189 m
.27767 .56463 L
s
.24 .35 .67 r
.73933 .61089 m
.74934 .58189 L
s
.74934 .58189 m
.72233 .56463 L
s
.215 .055 .025 r
.66073 .5639 m .67665 .55554 L .66705 .57288 L p F P
0 0 0 r
s
.215 .055 .025 r
.66705 .57288 m .65207 .58067 L .66073 .5639 L p F P
0 0 0 r
s
.83 .24 .1 r
.65957 .5715 m
.66406 .55074 L
s
.199 .262 .472 r
.33927 .5639 m .32335 .55554 L .33295 .57288 L p F P
0 0 0 r
s
.199 .262 .472 r
.33295 .57288 m .34793 .58067 L .33927 .5639 L p F P
0 0 0 r
s
.24 .35 .67 r
.33594 .55074 m
.34043 .5715 L
s
.083 .024 .01 r
.59949 .61633 m .61263 .60956 L .59953 .62076 L p F P
0 0 0 r
s
.083 .024 .01 r
.59953 .62076 m .58798 .62669 L .59949 .61633 L p F P
0 0 0 r
s
.111 .126 .238 r
.40051 .61633 m .38737 .60956 L .40047 .62076 L p F P
0 0 0 r
s
.111 .126 .238 r
.40047 .62076 m .41202 .62669 L .40051 .61633 L p F P
0 0 0 r
s
.914 .283 .117 r
.52711 .65817 m .53632 .65344 L .52848 .6534 L p F P
0 0 0 r
s
.83 .24 .1 r
.53093 .65341 m
.54064 .64983 L
s
.914 .283 .117 r
.52848 .6534 m .52128 .6571 L .52711 .65817 L p F P
0 0 0 r
s
.156 .257 .535 r
.47289 .65817 m .46368 .65344 L .47152 .6534 L p F P
0 0 0 r
s
.24 .35 .67 r
.45936 .64983 m
.46907 .65341 L
s
.156 .257 .535 r
.47152 .6534 m .47872 .6571 L .47289 .65817 L p F P
0 0 0 r
s
.083 .024 .01 r
.56526 .63835 m .57656 .63255 L .56444 .63901 L p F P
0 0 0 r
s
.083 .024 .01 r
.56444 .63901 m .55498 .64386 L .56526 .63835 L p F P
0 0 0 r
s
.073 .085 .162 r
.43474 .63835 m .42344 .63255 L .43556 .63901 L p F P
0 0 0 r
s
.073 .085 .162 r
.43556 .63901 m .44502 .64386 L .43474 .63835 L p F P
0 0 0 r
s
.15 .041 .019 r
.32997 .45279 m .31594 .46236 L .32443 .44479 L p F P
0 0 0 r
s
.15 .041 .019 r
.32443 .44479 m .33786 .43554 L .32997 .45279 L p F P
0 0 0 r
s
.202 .266 .472 r
.67003 .45279 m .68406 .46236 L .67557 .44479 L p F P
0 0 0 r
s
.202 .266 .472 r
.67557 .44479 m .66214 .43554 L .67003 .45279 L p F P
0 0 0 r
s
.83 .24 .1 r
.72613 .46438 m
.76059 .44527 L
s
.72613 .46438 m
.73093 .49076 L
s
.24 .35 .67 r
.27387 .46438 m
.23941 .44527 L
s
.27387 .46438 m
.26907 .49076 L
s
.083 .024 .01 r
.38829 .39338 m .37521 .40245 L .38792 .39099 L p F P
0 0 0 r
s
.083 .024 .01 r
.38792 .39099 m .39975 .38278 L .38829 .39338 L p F P
0 0 0 r
s
.104 .117 .224 r
.61171 .39338 m .62479 .40245 L .61208 .39099 L p F P
0 0 0 r
s
.104 .117 .224 r
.61208 .39099 m .60025 .38278 L .61171 .39338 L p F P
0 0 0 r
s
.862 .266 .108 r
.42385 .36605 m .41172 .37447 L .4238 .36807 L p F P
0 0 0 r
s
.862 .266 .108 r
.4238 .36807 m .43432 .36077 L .42385 .36605 L p F P
0 0 0 r
s
.83 .24 .1 r
.41261 .37574 m
.4289 .368 L
s
.119 .189 .415 r
.57615 .36605 m .58828 .37447 L .5762 .36807 L p F P
0 0 0 r
s
.119 .189 .415 r
.5762 .36807 m .56568 .36077 L .57615 .36605 L p F P
0 0 0 r
s
.24 .35 .67 r
.5711 .368 m
.58739 .37574 L
s
.83 .24 .1 r
.70635 .33556 m
.72397 .36158 L
s
.72397 .36158 m
.75845 .34083 L
s
.72397 .36158 m
.73923 .38916 L
s
.24 .35 .67 r
.29365 .33556 m
.27603 .36158 L
s
.27603 .36158 m
.24155 .34083 L
s
.27603 .36158 m
.26077 .38916 L
s
.1 .028 .011 r
.63728 .58835 m .65207 .58067 L .63942 .59574 L p F P
0 0 0 r
s
.1 .028 .011 r
.63942 .59574 m .62594 .60269 L .63728 .58835 L p F P
0 0 0 r
s
.83 .24 .1 r
.6269 .58855 m
.65957 .5715 L
s
.156 .195 .345 r
.36272 .58835 m .34793 .58067 L .36058 .59574 L p F P
0 0 0 r
s
.156 .195 .345 r
.36058 .59574 m .37406 .60269 L .36272 .58835 L p F P
0 0 0 r
s
.24 .35 .67 r
.34043 .5715 m
.3731 .58855 L
s
.276 .072 .035 r
.3119 .48119 m .29783 .49067 L .30213 .47178 L p F P
0 0 0 r
s
.83 .24 .1 r
.29986 .49076 m
.30022 .48906 L
s
.30355 .47314 m
.30412 .47042 L
s
.276 .072 .035 r
.30213 .47178 m .31594 .46236 L .3119 .48119 L p F P
0 0 0 r
s
.24 .327 .596 r
.6881 .48119 m .70217 .49067 L .69787 .47178 L p F P
0 0 0 r
s
.24 .35 .67 r
.69588 .47042 m
.69645 .47314 L
s
.69978 .48906 m
.70014 .49076 L
s
.24 .327 .596 r
.69787 .47178 m .68406 .46236 L .6881 .48119 L p F P
0 0 0 r
s
1 .308 .127 r
.46661 .3384 m .45573 .34594 L .46376 .34686 L p F P
0 0 0 r
s
1 .308 .127 r
.46376 .34686 m .47269 .3407 L .46661 .3384 L p F P
0 0 0 r
s
.83 .24 .1 r
.45863 .34746 m
.47725 .34591 L
s
.159 .261 .547 r
.53339 .3384 m .54427 .34594 L .53624 .34686 L p F P
0 0 0 r
s
.159 .261 .547 r
.53624 .34686 m .52731 .3407 L .53339 .3384 L p F P
0 0 0 r
s
.24 .35 .67 r
.52275 .34591 m
.54137 .34746 L
s
.83 .24 .1 r
.6122 .29754 m
.63327 .31322 L
s
.63327 .31322 m
.66636 .2917 L
s
.24 .35 .67 r
.3878 .29754 m
.36673 .31322 L
s
.36673 .31322 m
.33364 .2917 L
s
.83 .24 .1 r
.29388 .66427 m
.32167 .64822 L
s
.29388 .66427 m
.27533 .63885 L
s
.24 .35 .67 r
.70612 .66427 m
.67833 .64822 L
s
.70612 .66427 m
.72467 .63885 L
s
.83 .24 .1 r
.73923 .38916 m
.77399 .36881 L
s
.73923 .38916 m
.75159 .41737 L
s
.24 .35 .67 r
.26077 .38916 m
.22601 .36881 L
s
.26077 .38916 m
.24841 .41737 L
s
.4 .107 .051 r
.2985 .51014 m .28468 .51929 L .28397 .5 L p F P
0 0 0 r
s
.4 .107 .051 r
.28397 .5 m .29783 .49067 L .2985 .51014 L p F P
0 0 0 r
s
.83 .24 .1 r
.29787 .4921 m
.29986 .49076 L
s
.24 .35 .67 r
.29838 .50664 m
.30292 .5091 L
s
.26907 .49076 m
.28493 .49935 L
s
.265 .367 .679 r
.7015 .51014 m .71532 .51929 L .71603 .5 L p F P
0 0 0 r
s
.265 .367 .679 r
.71603 .5 m .70217 .49067 L .7015 .51014 L p F P
0 0 0 r
s
.24 .35 .67 r
.70014 .49076 m
.70213 .4921 L
s
.83 .24 .1 r
.69708 .5091 m
.70162 .50664 L
s
.71507 .49935 m
.73093 .49076 L
s
.27533 .63885 m
.26067 .61089 L
s
.26067 .61089 m
.28796 .594 L
s
.24 .35 .67 r
.72467 .63885 m
.73933 .61089 L
s
.73933 .61089 m
.71204 .594 L
s
.83 .24 .1 r
.68693 .31198 m
.70635 .33556 L
s
.70635 .33556 m
.74062 .31435 L
s
.24 .35 .67 r
.31307 .31198 m
.29365 .33556 L
s
.29365 .33556 m
.25938 .31435 L
s
.83 .24 .1 r
.36649 .68711 m
.39546 .6714 L
s
.36649 .68711 m
.34326 .67017 L
s
.24 .35 .67 r
.63351 .68711 m
.60454 .6714 L
s
.63351 .68711 m
.65674 .67017 L
s
.914 .283 .117 r
.53632 .65344 m .5456 .64867 L .53573 .64966 L p F P
0 0 0 r
s
.914 .283 .117 r
.53573 .64966 m .52848 .6534 L .53632 .65344 L p F P
0 0 0 r
s
.156 .257 .535 r
.46368 .65344 m .4544 .64867 L .46427 .64966 L p F P
0 0 0 r
s
.156 .257 .535 r
.46427 .64966 m .47152 .6534 L .46368 .65344 L p F P
0 0 0 r
s
.319 .081 .039 r
.6984 .5283 m .71532 .51929 L .70919 .53845 L p F P
0 0 0 r
s
.319 .081 .039 r
.70919 .53845 m .6928 .54706 L .6984 .5283 L p F P
0 0 0 r
s
.83 .24 .1 r
.69708 .5091 m
.69732 .5331 L
s
.232 .315 .578 r
.3016 .5283 m .28468 .51929 L .29081 .53845 L p F P
0 0 0 r
s
.232 .315 .578 r
.29081 .53845 m .3072 .54706 L .3016 .5283 L p F P
0 0 0 r
s
.24 .35 .67 r
.30268 .5331 m
.30292 .5091 L
s
.083 .024 .01 r
.36534 .41661 m .3515 .42615 L .3623 .41139 L p F P
0 0 0 r
s
.083 .024 .01 r
.3623 .41139 m .37521 .40245 L .36534 .41661 L p F P
0 0 0 r
s
.157 .196 .347 r
.63466 .41661 m .6485 .42615 L .6377 .41139 L p F P
0 0 0 r
s
.157 .196 .347 r
.6377 .41139 m .62479 .40245 L .63466 .41661 L p F P
0 0 0 r
s
.83 .24 .1 r
.27533 .63885 m
.30289 .62238 L
s
.24 .35 .67 r
.72467 .63885 m
.69711 .62238 L
s
1 .308 .129 r
.5 .66807 m .50704 .66444 L .50488 .65714 L p F P
0 0 0 r
s
1 .308 .129 r
.50488 .65714 m .5 .65968 L .5 .66807 L p F P
0 0 0 r
s
.215 .34 .689 r
.5 .66807 m .49296 .66444 L .49512 .65714 L p F P
0 0 0 r
s
.215 .34 .689 r
.49512 .65714 m .5 .65968 L .5 .66807 L p F P
0 0 0 r
s
.083 .024 .01 r
.57656 .63255 m .58798 .62669 L .57399 .63411 L p F P
0 0 0 r
s
.083 .024 .01 r
.57399 .63411 m .56444 .63901 L .57656 .63255 L p F P
0 0 0 r
s
.83 .24 .1 r
.57202 .6337 m
.58566 .6218 L
s
.073 .085 .162 r
.42344 .63255 m .41202 .62669 L .42601 .63411 L p F P
0 0 0 r
s
.073 .085 .162 r
.42601 .63411 m .43556 .63901 L .42344 .63255 L p F P
0 0 0 r
s
.24 .35 .67 r
.41434 .6218 m
.42798 .6337 L
s
.083 .024 .01 r
.61263 .60956 m .62594 .60269 L .61121 .61476 L p F P
0 0 0 r
s
.83 .24 .1 r
.6177 .60526 m
.6269 .58855 L
s
.083 .024 .01 r
.61121 .61476 m .59953 .62076 L .61263 .60956 L p F P
0 0 0 r
s
.83 .24 .1 r
.58566 .6218 m
.6177 .60526 L
s
.111 .126 .238 r
.38737 .60956 m .37406 .60269 L .38879 .61476 L p F P
0 0 0 r
s
.24 .35 .67 r
.3731 .58855 m
.3823 .60526 L
s
.111 .126 .238 r
.38879 .61476 m .40047 .62076 L .38737 .60956 L p F P
0 0 0 r
s
.24 .35 .67 r
.3823 .60526 m
.41434 .6218 L
s
.83 .24 .1 r
.27767 .56463 m
.2725 .53583 L
s
.24 .35 .67 r
.72233 .56463 m
.7275 .53583 L
s
.215 .055 .025 r
.67665 .55554 m .6928 .54706 L .68225 .56498 L p F P
0 0 0 r
s
.83 .24 .1 r
.66406 .55074 m
.69732 .5331 L
s
.215 .055 .025 r
.68225 .56498 m .66705 .57288 L .67665 .55554 L p F P
0 0 0 r
s
.199 .262 .472 r
.32335 .55554 m .3072 .54706 L .31775 .56498 L p F P
0 0 0 r
s
.24 .35 .67 r
.30268 .5331 m
.33594 .55074 L
s
.199 .262 .472 r
.31775 .56498 m .33295 .57288 L .32335 .55554 L p F P
0 0 0 r
s
.862 .266 .108 r
.43613 .35752 m .42385 .36605 L .43432 .36077 L p F P
0 0 0 r
s
.862 .266 .108 r
.43432 .36077 m .44497 .3534 L .43613 .35752 L p F P
0 0 0 r
s
.119 .189 .415 r
.56387 .35752 m .57615 .36605 L .56568 .36077 L p F P
0 0 0 r
s
.119 .189 .415 r
.56568 .36077 m .55503 .3534 L .56387 .35752 L p F P
0 0 0 r
s
1 .308 .127 r
.47761 .33077 m .46661 .3384 L .47269 .3407 L p F P
0 0 0 r
s
1 .308 .127 r
.47269 .3407 m .48171 .33448 L .47761 .33077 L p F P
0 0 0 r
s
.83 .24 .1 r
.47725 .34591 m
.50151 .32928 L
s
.159 .261 .547 r
.52239 .33077 m .53339 .3384 L .52731 .3407 L p F P
0 0 0 r
s
.159 .261 .547 r
.52731 .3407 m .51829 .33448 L .52239 .33077 L p F P
0 0 0 r
s
.24 .35 .67 r
.49849 .32928 m
.52275 .34591 L
s
.083 .024 .01 r
.40156 .38419 m .38829 .39338 L .39975 .38278 L p F P
0 0 0 r
s
.083 .024 .01 r
.39975 .38278 m .41172 .37447 L .40156 .38419 L p F P
0 0 0 r
s
.83 .24 .1 r
.40458 .3813 m
.41261 .37574 L
s
.104 .117 .224 r
.59844 .38419 m .61171 .39338 L .60025 .38278 L p F P
0 0 0 r
s
.104 .117 .224 r
.60025 .38278 m .58828 .37447 L .59844 .38419 L p F P
0 0 0 r
s
.24 .35 .67 r
.58739 .37574 m
.59542 .3813 L
s
.15 .041 .019 r
.34421 .44307 m .32997 .45279 L .33786 .43554 L p F P
0 0 0 r
s
.83 .24 .1 r
.33848 .43627 m
.33934 .43452 L
s
.15 .041 .019 r
.33786 .43554 m .3515 .42615 L .34421 .44307 L p F P
0 0 0 r
s
.202 .266 .472 r
.65579 .44307 m .67003 .45279 L .66214 .43554 L p F P
0 0 0 r
s
.24 .35 .67 r
.66066 .43452 m
.66152 .43627 L
s
.202 .266 .472 r
.66214 .43554 m .6485 .42615 L .65579 .44307 L p F P
0 0 0 r
s
.83 .24 .1 r
.75159 .41737 m
.78672 .39737 L
s
.75159 .41737 m
.76059 .44527 L
s
.24 .35 .67 r
.24841 .41737 m
.21328 .39737 L
s
.24841 .41737 m
.23941 .44527 L
s
.83 .24 .1 r
.41911 .68294 m
.44903 .6671 L
s
.41911 .68294 m
.39546 .6714 L
s
.24 .35 .67 r
.58089 .68294 m
.55097 .6671 L
s
.58089 .68294 m
.60454 .6714 L
s
.1 .028 .011 r
.65207 .58067 m .66705 .57288 L .65308 .58871 L p F P
0 0 0 r
s
.1 .028 .011 r
.65308 .58871 m .63942 .59574 L .65207 .58067 L p F P
0 0 0 r
s
.156 .195 .345 r
.34793 .58067 m .33295 .57288 L .34692 .58871 L p F P
0 0 0 r
s
.156 .195 .345 r
.34692 .58871 m .36058 .59574 L .34793 .58067 L p F P
0 0 0 r
s
1 .308 .129 r
.50704 .66444 m .51414 .66079 L .50979 .65459 L p F P
0 0 0 r
s
1 .308 .129 r
.50979 .65459 m .50488 .65714 L .50704 .66444 L p F P
0 0 0 r
s
.215 .34 .689 r
.49296 .66444 m .48586 .66079 L .49021 .65459 L p F P
0 0 0 r
s
.215 .34 .689 r
.49021 .65459 m .49512 .65714 L .49296 .66444 L p F P
0 0 0 r
s
.914 .283 .117 r
.5456 .64867 m .55498 .64386 L .54303 .6459 L p F P
0 0 0 r
s
.83 .24 .1 r
.54223 .64901 m
.54473 .64773 L
s
.55089 .64456 m
.57202 .6337 L
s
.914 .283 .117 r
.54303 .6459 m .53573 .64966 L .5456 .64867 L p F P
0 0 0 r
s
.156 .257 .535 r
.4544 .64867 m .44502 .64386 L .45697 .6459 L p F P
0 0 0 r
s
.24 .35 .67 r
.42798 .6337 m
.44911 .64456 L
s
.45527 .64773 m
.45777 .64901 L
s
.156 .257 .535 r
.45697 .6459 m .46427 .64966 L .4544 .64867 L p F P
0 0 0 r
s
.83 .24 .1 r
.66636 .2917 m
.68693 .31198 L
s
.68693 .31198 m
.72109 .29029 L
s
.24 .35 .67 r
.33364 .2917 m
.31307 .31198 L
s
.31307 .31198 m
.27891 .29029 L
s
.276 .072 .035 r
.32621 .47156 m .3119 .48119 L .31594 .46236 L p F P
0 0 0 r
s
.276 .072 .035 r
.31594 .46236 m .32997 .45279 L .32621 .47156 L p F P
0 0 0 r
s
.24 .327 .596 r
.67379 .47156 m .6881 .48119 L .68406 .46236 L p F P
0 0 0 r
s
.24 .327 .596 r
.68406 .46236 m .67003 .45279 L .67379 .47156 L p F P
0 0 0 r
s
.83 .24 .1 r
.47174 .67275 m
.49279 .6618 L
s
.49279 .6618 m
.49713 .65954 L
s
.47174 .67275 m
.44903 .6671 L
s
.24 .35 .67 r
.50721 .6618 m
.52826 .67275 L
s
.50287 .65954 m
.50721 .6618 L
s
.52826 .67275 m
.55097 .6671 L
s
.83 .24 .1 r
.73093 .49076 m
.76584 .47185 L
s
.73093 .49076 m
.73162 .5149 L
s
.24 .35 .67 r
.26907 .49076 m
.23416 .47185 L
s
.26907 .49076 m
.26838 .5149 L
s
.4 .107 .051 r
.31254 .50085 m .2985 .51014 L .29783 .49067 L p F P
0 0 0 r
s
.4 .107 .051 r
.29783 .49067 m .3119 .48119 L .31254 .50085 L p F P
0 0 0 r
s
.265 .367 .679 r
.68746 .50085 m .7015 .51014 L .70217 .49067 L p F P
0 0 0 r
s
.265 .367 .679 r
.70217 .49067 m .6881 .48119 L .68746 .50085 L p F P
0 0 0 r
s
.083 .024 .01 r
.58798 .62669 m .59953 .62076 L .58363 .62916 L p F P
0 0 0 r
s
.083 .024 .01 r
.58363 .62916 m .57399 .63411 L .58798 .62669 L p F P
0 0 0 r
s
.073 .085 .162 r
.41202 .62669 m .40047 .62076 L .41637 .62916 L p F P
0 0 0 r
s
.073 .085 .162 r
.41637 .62916 m .42601 .63411 L .41202 .62669 L p F P
0 0 0 r
s
1 .308 .127 r
.48874 .32305 m .47761 .33077 L .48171 .33448 L p F P
0 0 0 r
s
.24 .35 .67 r
.47213 .32962 m
.48275 .32721 L
s
1 .308 .127 r
.48171 .33448 m .49081 .3282 L .48874 .32305 L p F P
0 0 0 r
s
.24 .35 .67 r
.48977 .32561 m
.4923 .32504 L
s
.159 .261 .547 r
.51126 .32305 m .52239 .33077 L .51829 .33448 L p F P
0 0 0 r
s
.83 .24 .1 r
.51725 .32721 m
.52787 .32962 L
s
.159 .261 .547 r
.51829 .33448 m .50919 .3282 L .51126 .32305 L p F P
0 0 0 r
s
.83 .24 .1 r
.5077 .32504 m
.51023 .32561 L
s
.50487 .32523 m
.5077 .32504 L
s
.24 .35 .67 r
.4923 .32504 m
.49513 .32523 L
s
.083 .024 .01 r
.37939 .40693 m .36534 .41661 L .37521 .40245 L p F P
0 0 0 r
s
.83 .24 .1 r
.3762 .40351 m
.38127 .39825 L
s
.083 .024 .01 r
.37521 .40245 m .38829 .39338 L .37939 .40693 L p F P
0 0 0 r
s
.157 .196 .347 r
.62061 .40693 m .63466 .41661 L .62479 .40245 L p F P
0 0 0 r
s
.24 .35 .67 r
.61873 .39825 m
.6238 .40351 L
s
.157 .196 .347 r
.62479 .40245 m .61171 .39338 L .62061 .40693 L p F P
0 0 0 r
s
.83 .24 .1 r
.53912 .3035 m
.55912 .30849 L
s
.55912 .30849 m
.59135 .28669 L
s
.24 .35 .67 r
.46088 .3035 m
.44088 .30849 L
s
.44088 .30849 m
.40865 .28669 L
s
.862 .266 .108 r
.44857 .34889 m .43613 .35752 L .44497 .3534 L p F P
0 0 0 r
s
.862 .266 .108 r
.44497 .3534 m .45573 .34594 L .44857 .34889 L p F P
0 0 0 r
s
.83 .24 .1 r
.4289 .368 m
.45863 .34746 L
s
.119 .189 .415 r
.55143 .34889 m .56387 .35752 L .55503 .3534 L p F P
0 0 0 r
s
.119 .189 .415 r
.55503 .3534 m .54427 .34594 L .55143 .34889 L p F P
0 0 0 r
s
.24 .35 .67 r
.54137 .34746 m
.5711 .368 L
s
.083 .024 .01 r
.62594 .60269 m .63942 .59574 L .62302 .6087 L p F P
0 0 0 r
s
.083 .024 .01 r
.62302 .6087 m .61121 .61476 L .62594 .60269 L p F P
0 0 0 r
s
.111 .126 .238 r
.37406 .60269 m .36058 .59574 L .37698 .6087 L p F P
0 0 0 r
s
.111 .126 .238 r
.37698 .6087 m .38879 .61476 L .37406 .60269 L p F P
0 0 0 r
s
.511 .142 .065 r
.30428 .52971 m .29081 .53845 L .28468 .51929 L p F P
0 0 0 r
s
.24 .35 .67 r
.30069 .53204 m
.30268 .5331 L
s
.511 .142 .065 r
.28468 .51929 m .2985 .51014 L .30428 .52971 L p F P
0 0 0 r
s
.83 .24 .1 r
.28678 .52645 m
.28694 .52634 L
s
.2725 .53583 m
.28678 .52645 L
s
.24 .35 .67 r
.26838 .5149 m
.28642 .52447 L
s
.28642 .52447 m
.28738 .52498 L
s
.281 .394 .737 r
.69572 .52971 m .70919 .53845 L .71532 .51929 L p F P
0 0 0 r
s
.83 .24 .1 r
.69732 .5331 m
.69931 .53204 L
s
.281 .394 .737 r
.71532 .51929 m .7015 .51014 L .69572 .52971 L p F P
0 0 0 r
s
.24 .35 .67 r
.71306 .52634 m
.71322 .52645 L
s
.71322 .52645 m
.7275 .53583 L
s
.83 .24 .1 r
.71358 .52447 m
.73162 .5149 L
s
.71262 .52498 m
.71358 .52447 L
s
1 .308 .129 r
.51414 .66079 m .52128 .6571 L .51472 .65203 L p F P
0 0 0 r
s
.83 .24 .1 r
.52033 .65636 m
.52282 .65631 L
s
1 .308 .129 r
.51472 .65203 m .50979 .65459 L .51414 .66079 L p F P
0 0 0 r
s
.215 .34 .689 r
.48586 .66079 m .47872 .6571 L .48528 .65203 L p F P
0 0 0 r
s
.24 .35 .67 r
.47718 .65631 m
.47967 .65636 L
s
.215 .34 .689 r
.48528 .65203 m .49021 .65459 L .48586 .66079 L p F P
0 0 0 r
s
.83 .24 .1 r
.34326 .67017 m
.37212 .65406 L
s
.34326 .67017 m
.32167 .64822 L
s
.24 .35 .67 r
.65674 .67017 m
.62788 .65406 L
s
.65674 .67017 m
.67833 .64822 L
s
.083 .024 .01 r
.41502 .37487 m .40156 .38419 L .41172 .37447 L p F P
0 0 0 r
s
.083 .024 .01 r
.41172 .37447 m .42385 .36605 L .41502 .37487 L p F P
0 0 0 r
s
.104 .117 .224 r
.58498 .37487 m .59844 .38419 L .58828 .37447 L p F P
0 0 0 r
s
.104 .117 .224 r
.58828 .37447 m .57615 .36605 L .58498 .37487 L p F P
0 0 0 r
s
.914 .283 .117 r
.55498 .64386 m .56444 .63901 L .55039 .64211 L p F P
0 0 0 r
s
.914 .283 .117 r
.55039 .64211 m .54303 .6459 L .55498 .64386 L p F P
0 0 0 r
s
.156 .257 .535 r
.44502 .64386 m .43556 .63901 L .44961 .64211 L p F P
0 0 0 r
s
.156 .257 .535 r
.44961 .64211 m .45697 .6459 L .44502 .64386 L p F P
0 0 0 r
s
.83 .24 .1 r
.59135 .28669 m
.6122 .29754 L
s
.6122 .29754 m
.64533 .27553 L
s
.24 .35 .67 r
.40865 .28669 m
.3878 .29754 L
s
.3878 .29754 m
.35467 .27553 L
s
.215 .055 .025 r
.6928 .54706 m .70919 .53845 L .69767 .55697 L p F P
0 0 0 r
s
.215 .055 .025 r
.69767 .55697 m .68225 .56498 L .6928 .54706 L p F P
0 0 0 r
s
.199 .262 .472 r
.3072 .54706 m .29081 .53845 L .30233 .55697 L p F P
0 0 0 r
s
.199 .262 .472 r
.30233 .55697 m .31775 .56498 L .3072 .54706 L p F P
0 0 0 r
s
.83 .24 .1 r
.28796 .594 m
.27767 .56463 L
s
.24 .35 .67 r
.71204 .594 m
.72233 .56463 L
s
.15 .041 .019 r
.35868 .4332 m .34421 .44307 L .3515 .42615 L p F P
0 0 0 r
s
.15 .041 .019 r
.3515 .42615 m .36534 .41661 L .35868 .4332 L p F P
0 0 0 r
s
.202 .266 .472 r
.64132 .4332 m .65579 .44307 L .6485 .42615 L p F P
0 0 0 r
s
.202 .266 .472 r
.6485 .42615 m .63466 .41661 L .64132 .4332 L p F P
0 0 0 r
s
.1 .028 .011 r
.66705 .57288 m .68225 .56498 L .6669 .58158 L p F P
0 0 0 r
s
.1 .028 .011 r
.6669 .58158 m .65308 .58871 L .66705 .57288 L p F P
0 0 0 r
s
.83 .24 .1 r
.65075 .58819 m
.65957 .5715 L
s
.156 .195 .345 r
.33295 .57288 m .31775 .56498 L .3331 .58158 L p F P
0 0 0 r
s
.156 .195 .345 r
.3331 .58158 m .34692 .58871 L .33295 .57288 L p F P
0 0 0 r
s
.24 .35 .67 r
.34043 .5715 m
.34925 .58819 L
s
.83 .24 .1 r
.76059 .44527 m
.79615 .42555 L
s
.76059 .44527 m
.76584 .47185 L
s
.24 .35 .67 r
.23941 .44527 m
.20385 .42555 L
s
.23941 .44527 m
.23416 .47185 L
s
1 .308 .129 r
.52128 .6571 m .52848 .6534 L .51968 .64945 L p F P
0 0 0 r
s
1 .308 .129 r
.51968 .64945 m .51472 .65203 L .52128 .6571 L p F P
0 0 0 r
s
.215 .34 .689 r
.47872 .6571 m .47152 .6534 L .48032 .64945 L p F P
0 0 0 r
s
.215 .34 .689 r
.48032 .64945 m .48528 .65203 L .47872 .6571 L p F P
0 0 0 r
s
1 .308 .127 r
.5 .31525 m .48874 .32305 L .49081 .3282 L p F P
0 0 0 r
s
.24 .35 .67 r
.46088 .3035 m
.48907 .32283 L
s
1 .308 .127 r
.49081 .3282 m .5 .32187 L .5 .31525 L p F P
0 0 0 r
s
.159 .261 .547 r
.5 .31525 m .51126 .32305 L .50919 .3282 L p F P
0 0 0 r
s
.83 .24 .1 r
.51093 .32283 m
.53912 .3035 L
s
.159 .261 .547 r
.50919 .3282 m .5 .32187 L .5 .31525 L p F P
0 0 0 r
s
.83 .24 .1 r
.48929 .32626 m
.50249 .32538 L
s
.24 .35 .67 r
.49751 .32538 m
.51071 .32626 L
s
.083 .024 .01 r
.59953 .62076 m .61121 .61476 L .59335 .62416 L p F P
0 0 0 r
s
.083 .024 .01 r
.59335 .62416 m .58363 .62916 L .59953 .62076 L p F P
0 0 0 r
s
.073 .085 .162 r
.40047 .62076 m .38879 .61476 L .40665 .62416 L p F P
0 0 0 r
s
.073 .085 .162 r
.40665 .62416 m .41637 .62916 L .40047 .62076 L p F P
0 0 0 r
s
.83 .24 .1 r
.74062 .31435 m
.75845 .34083 L
s
.75845 .34083 m
.79402 .31942 L
s
.75845 .34083 m
.77399 .36881 L
s
.24 .35 .67 r
.25938 .31435 m
.24155 .34083 L
s
.24155 .34083 m
.20598 .31942 L
s
.24155 .34083 m
.22601 .36881 L
s
.276 .072 .035 r
.34074 .46178 m .32621 .47156 L .32997 .45279 L p F P
0 0 0 r
s
.83 .24 .1 r
.32798 .47185 m
.32832 .47014 L
s
.33147 .45405 m
.33199 .45141 L
s
.276 .072 .035 r
.32997 .45279 m .34421 .44307 L .34074 .46178 L p F P
0 0 0 r
s
.24 .327 .596 r
.65926 .46178 m .67379 .47156 L .67003 .45279 L p F P
0 0 0 r
s
.24 .35 .67 r
.66801 .45141 m
.66853 .45405 L
s
.67168 .47014 m
.67202 .47185 L
s
.24 .327 .596 r
.67003 .45279 m .65579 .44307 L .65926 .46178 L p F P
0 0 0 r
s
.862 .266 .108 r
.46118 .34014 m .44857 .34889 L .45573 .34594 L p F P
0 0 0 r
s
.862 .266 .108 r
.45573 .34594 m .46661 .3384 L .46118 .34014 L p F P
0 0 0 r
s
.119 .189 .415 r
.53882 .34014 m .55143 .34889 L .54427 .34594 L p F P
0 0 0 r
s
.119 .189 .415 r
.54427 .34594 m .53339 .3384 L .53882 .34014 L p F P
0 0 0 r
s
.83 .24 .1 r
.64533 .27553 m
.66636 .2917 L
s
.66636 .2917 m
.70049 .2695 L
s
.24 .35 .67 r
.35467 .27553 m
.33364 .2917 L
s
.33364 .2917 m
.29951 .2695 L
s
.914 .283 .117 r
.56444 .63901 m .57399 .63411 L .55779 .63829 L p F P
0 0 0 r
s
.83 .24 .1 r
.56341 .63684 m
.57202 .6337 L
s
.914 .283 .117 r
.55779 .63829 m .55039 .64211 L .56444 .63901 L p F P
0 0 0 r
s
.156 .257 .535 r
.43556 .63901 m .42601 .63411 L .44221 .63829 L p F P
0 0 0 r
s
.24 .35 .67 r
.42798 .6337 m
.43659 .63684 L
s
.156 .257 .535 r
.44221 .63829 m .44961 .64211 L .43556 .63901 L p F P
0 0 0 r
s
.83 .24 .1 r
.32167 .64822 m
.35034 .63167 L
s
.32167 .64822 m
.30289 .62238 L
s
.24 .35 .67 r
.67833 .64822 m
.64966 .63167 L
s
.67833 .64822 m
.69711 .62238 L
s
.083 .024 .01 r
.63942 .59574 m .65308 .58871 L .63496 .60257 L p F P
0 0 0 r
s
.083 .024 .01 r
.63496 .60257 m .62302 .6087 L .63942 .59574 L p F P
0 0 0 r
s
.83 .24 .1 r
.6177 .60526 m
.65075 .58819 L
s
.111 .126 .238 r
.36058 .59574 m .34692 .58871 L .36504 .60257 L p F P
0 0 0 r
s
.111 .126 .238 r
.36504 .60257 m .37698 .6087 L .36058 .59574 L p F P
0 0 0 r
s
.24 .35 .67 r
.34925 .58819 m
.3823 .60526 L
s
.83 .24 .1 r
.77399 .36881 m
.80986 .34782 L
s
.77399 .36881 m
.78672 .39737 L
s
.24 .35 .67 r
.22601 .36881 m
.19014 .34782 L
s
.22601 .36881 m
.21328 .39737 L
s
.083 .024 .01 r
.39366 .39711 m .37939 .40693 L .38829 .39338 L p F P
0 0 0 r
s
.083 .024 .01 r
.38829 .39338 m .40156 .38419 L .39366 .39711 L p F P
0 0 0 r
s
.157 .196 .347 r
.60634 .39711 m .62061 .40693 L .61171 .39338 L p F P
0 0 0 r
s
.157 .196 .347 r
.61171 .39338 m .59844 .38419 L .60634 .39711 L p F P
0 0 0 r
s
.4 .107 .051 r
.3268 .49141 m .31254 .50085 L .3119 .48119 L p F P
0 0 0 r
s
.4 .107 .051 r
.3119 .48119 m .32621 .47156 L .3268 .49141 L p F P
0 0 0 r
s
.83 .24 .1 r
.32625 .47302 m
.32798 .47185 L
s
.265 .367 .679 r
.6732 .49141 m .68746 .50085 L .6881 .48119 L p F P
0 0 0 r
s
.265 .367 .679 r
.6881 .48119 m .67379 .47156 L .6732 .49141 L p F P
0 0 0 r
s
.24 .35 .67 r
.67202 .47185 m
.67375 .47302 L
s
.83 .24 .1 r
.30289 .62238 m
.28796 .594 L
s
.28796 .594 m
.31613 .57657 L
s
.24 .35 .67 r
.69711 .62238 m
.71204 .594 L
s
.71204 .594 m
.68387 .57657 L
s
.83 .24 .1 r
.72109 .29029 m
.74062 .31435 L
s
.74062 .31435 m
.77599 .29248 L
s
.24 .35 .67 r
.27891 .29029 m
.25938 .31435 L
s
.25938 .31435 m
.22401 .29248 L
s
1 .308 .129 r
.52848 .6534 m .53573 .64966 L .52466 .64686 L p F P
0 0 0 r
s
1 .308 .129 r
.52466 .64686 m .51968 .64945 L .52848 .6534 L p F P
0 0 0 r
s
.215 .34 .689 r
.47152 .6534 m .46427 .64966 L .47534 .64686 L p F P
0 0 0 r
s
.215 .34 .689 r
.47534 .64686 m .48032 .64945 L .47152 .6534 L p F P
0 0 0 r
s
.83 .24 .1 r
.39546 .6714 m
.42535 .6552 L
s
.39546 .6714 m
.37212 .65406 L
s
.24 .35 .67 r
.60454 .6714 m
.57465 .6552 L
s
.60454 .6714 m
.62788 .65406 L
s
.083 .024 .01 r
.42868 .36541 m .41502 .37487 L .42385 .36605 L p F P
0 0 0 r
s
.083 .024 .01 r
.42385 .36605 m .43613 .35752 L .42868 .36541 L p F P
0 0 0 r
s
.104 .117 .224 r
.57132 .36541 m .58498 .37487 L .57615 .36605 L p F P
0 0 0 r
s
.104 .117 .224 r
.57615 .36605 m .56387 .35752 L .57132 .36541 L p F P
0 0 0 r
s
.511 .142 .065 r
.31795 .52083 m .30428 .52971 L .2985 .51014 L p F P
0 0 0 r
s
.83 .24 .1 r
.3 .50915 m
.30001 .51097 L
s
.511 .142 .065 r
.2985 .51014 m .31254 .50085 L .31795 .52083 L p F P
0 0 0 r
s
.281 .394 .737 r
.68205 .52083 m .69572 .52971 L .7015 .51014 L p F P
0 0 0 r
s
.24 .35 .67 r
.69999 .51097 m
.7 .50915 L
s
.281 .394 .737 r
.7015 .51014 m .68746 .50085 L .68205 .52083 L p F P
0 0 0 r
s
.83 .24 .1 r
.30289 .62238 m
.33133 .60538 L
s
.24 .35 .67 r
.69711 .62238 m
.66867 .60538 L
s
.599 .169 .076 r
.31514 .54885 m .30233 .55697 L .29081 .53845 L p F P
0 0 0 r
s
.83 .24 .1 r
.27767 .56463 m
.29757 .55191 L
s
.29757 .55191 m
.29872 .55117 L
s
.24 .35 .67 r
.30268 .5331 m
.3049 .54447 L
s
.599 .169 .076 r
.29081 .53845 m .30428 .52971 L .31514 .54885 L p F P
0 0 0 r
s
.291 .413 .778 r
.68486 .54885 m .69767 .55697 L .70919 .53845 L p F P
0 0 0 r
s
.24 .35 .67 r
.70243 .55191 m
.72233 .56463 L
s
.70128 .55117 m
.70243 .55191 L
s
.83 .24 .1 r
.6951 .54447 m
.69732 .5331 L
s
.291 .413 .778 r
.70919 .53845 m .69572 .52971 L .68486 .54885 L p F P
0 0 0 r
s
.083 .024 .01 r
.61121 .61476 m .62302 .6087 L .60317 .61912 L p F P
0 0 0 r
s
.083 .024 .01 r
.60317 .61912 m .59335 .62416 L .61121 .61476 L p F P
0 0 0 r
s
.83 .24 .1 r
.60438 .61706 m
.6177 .60526 L
s
.073 .085 .162 r
.38879 .61476 m .37698 .6087 L .39683 .61912 L p F P
0 0 0 r
s
.073 .085 .162 r
.39683 .61912 m .40665 .62416 L .38879 .61476 L p F P
0 0 0 r
s
.24 .35 .67 r
.3823 .60526 m
.39562 .61706 L
s
.15 .041 .019 r
.37338 .42317 m .35868 .4332 L .36534 .41661 L p F P
0 0 0 r
s
.83 .24 .1 r
.36655 .4176 m
.36784 .41489 L
s
.15 .041 .019 r
.36534 .41661 m .37939 .40693 L .37338 .42317 L p F P
0 0 0 r
s
.202 .266 .472 r
.62662 .42317 m .64132 .4332 L .63466 .41661 L p F P
0 0 0 r
s
.24 .35 .67 r
.63216 .41489 m
.63345 .4176 L
s
.202 .266 .472 r
.63466 .41661 m .62061 .40693 L .62662 .42317 L p F P
0 0 0 r
s
.1 .028 .011 r
.68225 .56498 m .69767 .55697 L .68091 .57435 L p F P
0 0 0 r
s
.1 .028 .011 r
.68091 .57435 m .6669 .58158 L .68225 .56498 L p F P
0 0 0 r
s
.83 .24 .1 r
.65957 .5715 m
.69303 .55403 L
s
.156 .195 .345 r
.31775 .56498 m .30233 .55697 L .31909 .57435 L p F P
0 0 0 r
s
.156 .195 .345 r
.31909 .57435 m .3331 .58158 L .31775 .56498 L p F P
0 0 0 r
s
.24 .35 .67 r
.30697 .55403 m
.34043 .5715 L
s
.914 .283 .117 r
.57399 .63411 m .58363 .62916 L .56525 .63445 L p F P
0 0 0 r
s
.83 .24 .1 r
.57733 .63097 m
.60438 .61706 L
s
.914 .283 .117 r
.56525 .63445 m .55779 .63829 L .57399 .63411 L p F P
0 0 0 r
s
.156 .257 .535 r
.42601 .63411 m .41637 .62916 L .43475 .63445 L p F P
0 0 0 r
s
.24 .35 .67 r
.39562 .61706 m
.42267 .63097 L
s
.156 .257 .535 r
.43475 .63445 m .44221 .63829 L .42601 .63411 L p F P
0 0 0 r
s
.862 .266 .108 r
.47395 .33127 m .46118 .34014 L .46661 .3384 L p F P
0 0 0 r
s
.862 .266 .108 r
.46661 .3384 m .47761 .33077 L .47395 .33127 L p F P
0 0 0 r
s
.83 .24 .1 r
.45863 .34746 m
.48929 .32626 L
s
.119 .189 .415 r
.52605 .33127 m .53882 .34014 L .53339 .3384 L p F P
0 0 0 r
s
.119 .189 .415 r
.53339 .3384 m .52239 .33077 L .52605 .33127 L p F P
0 0 0 r
s
.24 .35 .67 r
.51071 .32626 m
.54137 .34746 L
s
1 .308 .129 r
.53573 .64966 m .54303 .6459 L .52967 .64426 L p F P
0 0 0 r
s
1 .308 .129 r
.52967 .64426 m .52466 .64686 L .53573 .64966 L p F P
0 0 0 r
s
.215 .34 .689 r
.46427 .64966 m .45697 .6459 L .47033 .64426 L p F P
0 0 0 r
s
.215 .34 .689 r
.47033 .64426 m .47534 .64686 L .46427 .64966 L p F P
0 0 0 r
s
.83 .24 .1 r
.78672 .39737 m
.82296 .37673 L
s
.78672 .39737 m
.79615 .42555 L
s
.24 .35 .67 r
.21328 .39737 m
.17704 .37673 L
s
.21328 .39737 m
.20385 .42555 L
s
.83 .24 .1 r
.70298 .54884 m
.72802 .53577 L
s
.70099 .54988 m
.70298 .54884 L
s
.24 .35 .67 r
.27198 .53577 m
.29702 .54884 L
s
.29702 .54884 m
.29901 .54988 L
s
.83 .24 .1 r
.44903 .6671 m
.47991 .65076 L
s
.44903 .6671 m
.42535 .6552 L
s
.24 .35 .67 r
.52009 .65076 m
.55097 .6671 L
s
.55097 .6671 m
.57465 .6552 L
s
.83 .24 .1 r
.73162 .5149 m
.76702 .49611 L
s
.73162 .5149 m
.72802 .53577 L
s
.24 .35 .67 r
.26838 .5149 m
.23298 .49611 L
s
.26838 .5149 m
.27198 .53577 L
s
1 .311 .131 r
.5 .65968 m .50488 .65714 L .50252 .64553 L p F P
0 0 0 r
s
.83 .24 .1 r
.50479 .65667 m
.50582 .65665 L
s
.49843 .65886 m
.50032 .65788 L
s
1 .311 .131 r
.50252 .64553 m .5 .64685 L .5 .65968 L p F P
0 0 0 r
s
.256 .395 .786 r
.5 .65968 m .49512 .65714 L .49748 .64553 L p F P
0 0 0 r
s
.24 .35 .67 r
.49968 .65788 m
.5 .65804 L
s
.49418 .65665 m
.49521 .65667 L
s
.256 .395 .786 r
.49748 .64553 m .5 .64685 L .5 .65968 L p F P
0 0 0 r
s
.083 .024 .01 r
.65308 .58871 m .6669 .58158 L .64704 .59636 L p F P
0 0 0 r
s
.083 .024 .01 r
.64704 .59636 m .63496 .60257 L .65308 .58871 L p F P
0 0 0 r
s
.111 .126 .238 r
.34692 .58871 m .3331 .58158 L .35296 .59636 L p F P
0 0 0 r
s
.111 .126 .238 r
.35296 .59636 m .36504 .60257 L .34692 .58871 L p F P
0 0 0 r
s
.83 .24 .1 r
.70049 .2695 m
.72109 .29029 L
s
.72109 .29029 m
.75634 .26791 L
s
.24 .35 .67 r
.29951 .2695 m
.27891 .29029 L
s
.27891 .29029 m
.24366 .26791 L
s
.276 .072 .035 r
.3555 .45183 m .34074 .46178 L .34421 .44307 L p F P
0 0 0 r
s
.276 .072 .035 r
.34421 .44307 m .35868 .4332 L .3555 .45183 L p F P
0 0 0 r
s
.24 .327 .596 r
.6445 .45183 m .65926 .46178 L .65579 .44307 L p F P
0 0 0 r
s
.24 .327 .596 r
.65579 .44307 m .64132 .4332 L .6445 .45183 L p F P
0 0 0 r
s
.083 .024 .01 r
.40815 .38713 m .39366 .39711 L .40156 .38419 L p F P
0 0 0 r
s
.83 .24 .1 r
.40367 .38513 m
.41037 .37809 L
s
.083 .024 .01 r
.40156 .38419 m .41502 .37487 L .40815 .38713 L p F P
0 0 0 r
s
.157 .196 .347 r
.59185 .38713 m .60634 .39711 L .59844 .38419 L p F P
0 0 0 r
s
.24 .35 .67 r
.58963 .37809 m
.59633 .38513 L
s
.157 .196 .347 r
.59844 .38419 m .58498 .37487 L .59185 .38713 L p F P
0 0 0 r
s
.083 .024 .01 r
.44253 .35582 m .42868 .36541 L .43613 .35752 L p F P
0 0 0 r
s
.083 .024 .01 r
.43613 .35752 m .44857 .34889 L .44253 .35582 L p F P
0 0 0 r
s
.83 .24 .1 r
.44375 .35442 m
.45863 .34746 L
s
.104 .117 .224 r
.55747 .35582 m .57132 .36541 L .56387 .35752 L p F P
0 0 0 r
s
.104 .117 .224 r
.56387 .35752 m .55143 .34889 L .55747 .35582 L p F P
0 0 0 r
s
.24 .35 .67 r
.54137 .34746 m
.55625 .35442 L
s
.83 .24 .1 r
.76584 .47185 m
.80187 .45234 L
s
.76584 .47185 m
.76702 .49611 L
s
.24 .35 .67 r
.23416 .47185 m
.19813 .45234 L
s
.23416 .47185 m
.23298 .49611 L
s
1 .308 .129 r
.54303 .6459 m .55039 .64211 L .5347 .64165 L p F P
0 0 0 r
s
1 .308 .129 r
.5347 .64165 m .52967 .64426 L .54303 .6459 L p F P
0 0 0 r
s
.215 .34 .689 r
.45697 .6459 m .44961 .64211 L .4653 .64165 L p F P
0 0 0 r
s
.215 .34 .689 r
.4653 .64165 m .47033 .64426 L .45697 .6459 L p F P
0 0 0 r
s
.4 .107 .051 r
.34128 .48182 m .3268 .49141 L .32621 .47156 L p F P
0 0 0 r
s
.4 .107 .051 r
.32621 .47156 m .34074 .46178 L .34128 .48182 L p F P
0 0 0 r
s
.265 .367 .679 r
.65872 .48182 m .6732 .49141 L .67379 .47156 L p F P
0 0 0 r
s
.265 .367 .679 r
.67379 .47156 m .65926 .46178 L .65872 .48182 L p F P
0 0 0 r
s
.83 .24 .1 r
.52094 .30438 m
.53912 .3035 L
s
.53912 .3035 m
.57154 .28128 L
s
.24 .35 .67 r
.47906 .30438 m
.46088 .3035 L
s
.46088 .3035 m
.42846 .28128 L
s
1 .311 .131 r
.50488 .65714 m .50979 .65459 L .50504 .6442 L p F P
0 0 0 r
s
.83 .24 .1 r
.50458 .65566 m
.5049 .65549 L
s
1 .311 .131 r
.50504 .6442 m .50252 .64553 L .50488 .65714 L p F P
0 0 0 r
s
.256 .395 .786 r
.49512 .65714 m .49021 .65459 L .49496 .6442 L p F P
0 0 0 r
s
.24 .35 .67 r
.4951 .65549 m
.49542 .65566 L
s
.256 .395 .786 r
.49496 .6442 m .49748 .64553 L .49512 .65714 L p F P
0 0 0 r
s
.914 .283 .117 r
.58363 .62916 m .59335 .62416 L .57277 .63057 L p F P
0 0 0 r
s
.914 .283 .117 r
.57277 .63057 m .56525 .63445 L .58363 .62916 L p F P
0 0 0 r
s
.156 .257 .535 r
.41637 .62916 m .40665 .62416 L .42723 .63057 L p F P
0 0 0 r
s
.156 .257 .535 r
.42723 .63057 m .43475 .63445 L .41637 .62916 L p F P
0 0 0 r
s
.83 .24 .1 r
.57154 .28128 m
.59135 .28669 L
s
.59135 .28669 m
.62461 .26419 L
s
.24 .35 .67 r
.42846 .28128 m
.40865 .28669 L
s
.40865 .28669 m
.37539 .26419 L
s
.083 .024 .01 r
.62302 .6087 m .63496 .60257 L .61309 .61403 L p F P
0 0 0 r
s
.083 .024 .01 r
.61309 .61403 m .60317 .61912 L .62302 .6087 L p F P
0 0 0 r
s
.073 .085 .162 r
.37698 .6087 m .36504 .60257 L .38691 .61403 L p F P
0 0 0 r
s
.073 .085 .162 r
.38691 .61403 m .39683 .61912 L .37698 .6087 L p F P
0 0 0 r
s
.83 .24 .1 r
.48929 .32626 m
.50124 .318 L
s
.24 .35 .67 r
.49876 .318 m
.51071 .32626 L
s
.511 .142 .065 r
.33184 .51182 m .31795 .52083 L .31254 .50085 L p F P
0 0 0 r
s
.511 .142 .065 r
.31254 .50085 m .3268 .49141 L .33184 .51182 L p F P
0 0 0 r
s
.281 .394 .737 r
.66816 .51182 m .68205 .52083 L .68746 .50085 L p F P
0 0 0 r
s
.281 .394 .737 r
.68746 .50085 m .6732 .49141 L .66816 .51182 L p F P
0 0 0 r
s
.83 .24 .1 r
.37212 .65406 m
.4019 .63743 L
s
.37212 .65406 m
.35034 .63167 L
s
.24 .35 .67 r
.62788 .65406 m
.5981 .63743 L
s
.62788 .65406 m
.64966 .63167 L
s
.862 .266 .108 r
.48689 .32229 m .47395 .33127 L .47761 .33077 L p F P
0 0 0 r
s
.862 .266 .108 r
.47761 .33077 m .48874 .32305 L .48689 .32229 L p F P
0 0 0 r
s
.119 .189 .415 r
.51311 .32229 m .52605 .33127 L .52239 .33077 L p F P
0 0 0 r
s
.119 .189 .415 r
.52239 .33077 m .51126 .32305 L .51311 .32229 L p F P
0 0 0 r
s
.599 .169 .076 r
.32813 .54061 m .31514 .54885 L .30428 .52971 L p F P
0 0 0 r
s
.599 .169 .076 r
.30428 .52971 m .31795 .52083 L .32813 .54061 L p F P
0 0 0 r
s
.291 .413 .778 r
.67187 .54061 m .68486 .54885 L .69572 .52971 L p F P
0 0 0 r
s
.291 .413 .778 r
.69572 .52971 m .68205 .52083 L .67187 .54061 L p F P
0 0 0 r
s
.83 .24 .1 r
.62461 .26419 m
.64533 .27553 L
s
.64533 .27553 m
.67953 .2528 L
s
.24 .35 .67 r
.37539 .26419 m
.35467 .27553 L
s
.35467 .27553 m
.32047 .2528 L
s
1 .311 .131 r
.50979 .65459 m .51472 .65203 L .50757 .64287 L p F P
0 0 0 r
s
.83 .24 .1 r
.50919 .65326 m
.50951 .6531 L
s
1 .311 .131 r
.50757 .64287 m .50504 .6442 L .50979 .65459 L p F P
0 0 0 r
s
.24 .35 .67 r
.50569 .65455 m
.50808 .65392 L
s
.256 .395 .786 r
.49021 .65459 m .48528 .65203 L .49243 .64287 L p F P
0 0 0 r
s
.24 .35 .67 r
.49049 .6531 m
.49081 .65326 L
s
.256 .395 .786 r
.49243 .64287 m .49496 .6442 L .49021 .65459 L p F P
0 0 0 r
s
.83 .24 .1 r
.49192 .65392 m
.49431 .65455 L
s
.672 .192 .086 r
.33091 .56704 m .31909 .57435 L .30233 .55697 L p F P
0 0 0 r
s
.24 .35 .67 r
.30684 .55411 m
.30957 .55952 L
s
.31393 .56818 m
.31514 .57058 L
s
.672 .192 .086 r
.30233 .55697 m .31514 .54885 L .33091 .56704 L p F P
0 0 0 r
s
.24 .35 .67 r
.31236 .56506 m
.31393 .56818 L
s
.299 .426 .808 r
.66909 .56704 m .68091 .57435 L .69767 .55697 L p F P
0 0 0 r
s
.83 .24 .1 r
.69043 .55952 m
.69316 .55411 L
s
.68486 .57058 m
.68607 .56818 L
s
.299 .426 .808 r
.69767 .55697 m .68486 .54885 L .66909 .56704 L p F P
0 0 0 r
s
.83 .24 .1 r
.68607 .56818 m
.68764 .56506 L
s
.31314 .56819 m
.31613 .57657 L
s
.24 .35 .67 r
.68387 .57657 m
.68686 .56819 L
s
.15 .041 .019 r
.38832 .41298 m .37338 .42317 L .37939 .40693 L p F P
0 0 0 r
s
.15 .041 .019 r
.37939 .40693 m .39366 .39711 L .38832 .41298 L p F P
0 0 0 r
s
.202 .266 .472 r
.61168 .41298 m .62662 .42317 L .62061 .40693 L p F P
0 0 0 r
s
.202 .266 .472 r
.62061 .40693 m .60634 .39711 L .61168 .41298 L p F P
0 0 0 r
s
1 .308 .129 r
.55039 .64211 m .55779 .63829 L .53976 .63902 L p F P
0 0 0 r
s
1 .308 .129 r
.53976 .63902 m .5347 .64165 L .55039 .64211 L p F P
0 0 0 r
s
.215 .34 .689 r
.44961 .64211 m .44221 .63829 L .46024 .63902 L p F P
0 0 0 r
s
.215 .34 .689 r
.46024 .63902 m .4653 .64165 L .44961 .64211 L p F P
0 0 0 r
s
.083 .024 .01 r
.6669 .58158 m .68091 .57435 L .65926 .59009 L p F P
0 0 0 r
s
.083 .024 .01 r
.65926 .59009 m .64704 .59636 L .6669 .58158 L p F P
0 0 0 r
s
.83 .24 .1 r
.65075 .58819 m
.67938 .57341 L
s
.111 .126 .238 r
.3331 .58158 m .31909 .57435 L .34074 .59009 L p F P
0 0 0 r
s
.111 .126 .238 r
.34074 .59009 m .35296 .59636 L .3331 .58158 L p F P
0 0 0 r
s
.24 .35 .67 r
.32062 .57341 m
.34925 .58819 L
s
.83 .24 .1 r
.79615 .42555 m
.83284 .40519 L
s
.79615 .42555 m
.80187 .45234 L
s
.24 .35 .67 r
.20385 .42555 m
.16716 .40519 L
s
.20385 .42555 m
.19813 .45234 L
s
.914 .283 .117 r
.59335 .62416 m .60317 .61912 L .58034 .62667 L p F P
0 0 0 r
s
.914 .283 .117 r
.58034 .62667 m .57277 .63057 L .59335 .62416 L p F P
0 0 0 r
s
.156 .257 .535 r
.40665 .62416 m .39683 .61912 L .41966 .62667 L p F P
0 0 0 r
s
.156 .257 .535 r
.41966 .62667 m .42723 .63057 L .40665 .62416 L p F P
0 0 0 r
s
1 .311 .131 r
.51472 .65203 m .51968 .64945 L .51011 .64153 L p F P
0 0 0 r
s
.83 .24 .1 r
.51381 .65086 m
.51414 .65069 L
s
1 .311 .131 r
.51011 .64153 m .50757 .64287 L .51472 .65203 L p F P
0 0 0 r
s
.24 .35 .67 r
.50808 .65392 m
.52009 .65076 L
s
.256 .395 .786 r
.48528 .65203 m .48032 .64945 L .48989 .64153 L p F P
0 0 0 r
s
.24 .35 .67 r
.48586 .65069 m
.48619 .65086 L
s
.256 .395 .786 r
.48989 .64153 m .49243 .64287 L .48528 .65203 L p F P
0 0 0 r
s
.83 .24 .1 r
.47991 .65076 m
.49192 .65392 L
s
.083 .024 .01 r
.45658 .34608 m .44253 .35582 L .44857 .34889 L p F P
0 0 0 r
s
.083 .024 .01 r
.44857 .34889 m .46118 .34014 L .45658 .34608 L p F P
0 0 0 r
s
.104 .117 .224 r
.54342 .34608 m .55747 .35582 L .55143 .34889 L p F P
0 0 0 r
s
.104 .117 .224 r
.55143 .34889 m .53882 .34014 L .54342 .34608 L p F P
0 0 0 r
s
.083 .024 .01 r
.42286 .377 m .40815 .38713 L .41502 .37487 L p F P
0 0 0 r
s
.083 .024 .01 r
.41502 .37487 m .42868 .36541 L .42286 .377 L p F P
0 0 0 r
s
.157 .196 .347 r
.57714 .377 m .59185 .38713 L .58498 .37487 L p F P
0 0 0 r
s
.157 .196 .347 r
.58498 .37487 m .57132 .36541 L .57714 .377 L p F P
0 0 0 r
s
.83 .24 .1 r
.79402 .31942 m
.77599 .29248 L
s
.80986 .34782 m
.79402 .31942 L
s
.24 .35 .67 r
.20598 .31942 m
.22401 .29248 L
s
.19014 .34782 m
.20598 .31942 L
s
.276 .072 .035 r
.37051 .44173 m .3555 .45183 L .35868 .4332 L p F P
0 0 0 r
s
.83 .24 .1 r
.35701 .45234 m
.35732 .45061 L
s
.36028 .43435 m
.36074 .43179 L
s
.276 .072 .035 r
.35868 .4332 m .37338 .42317 L .37051 .44173 L p F P
0 0 0 r
s
.24 .327 .596 r
.62949 .44173 m .6445 .45183 L .64132 .4332 L p F P
0 0 0 r
s
.24 .35 .67 r
.63926 .43179 m
.63972 .43435 L
s
.64268 .45061 m
.64299 .45234 L
s
.24 .327 .596 r
.64132 .4332 m .62662 .42317 L .62949 .44173 L p F P
0 0 0 r
s
.083 .024 .01 r
.63496 .60257 m .64704 .59636 L .6231 .6089 L p F P
0 0 0 r
s
.083 .024 .01 r
.6231 .6089 m .61309 .61403 L .63496 .60257 L p F P
0 0 0 r
s
.073 .085 .162 r
.36504 .60257 m .35296 .59636 L .3769 .6089 L p F P
0 0 0 r
s
.073 .085 .162 r
.3769 .6089 m .38691 .61403 L .36504 .60257 L p F P
0 0 0 r
s
.83 .24 .1 r
.67953 .2528 m
.70049 .2695 L
s
.70049 .2695 m
.73573 .24658 L
s
.24 .35 .67 r
.32047 .2528 m
.29951 .2695 L
s
.29951 .2695 m
.26427 .24658 L
s
.83 .24 .1 r
.35034 .63167 m
.33133 .60538 L
s
.24 .35 .67 r
.64966 .63167 m
.66867 .60538 L
s
1 .308 .129 r
.55779 .63829 m .56525 .63445 L .54484 .63638 L p F P
0 0 0 r
s
1 .308 .129 r
.54484 .63638 m .53976 .63902 L .55779 .63829 L p F P
0 0 0 r
s
.215 .34 .689 r
.44221 .63829 m .43475 .63445 L .45516 .63638 L p F P
0 0 0 r
s
.215 .34 .689 r
.45516 .63638 m .46024 .63902 L .44221 .63829 L p F P
0 0 0 r
s
.83 .24 .1 r
.82296 .37673 m
.80986 .34782 L
s
.24 .35 .67 r
.17704 .37673 m
.19014 .34782 L
s
.862 .266 .108 r
.5 .31319 m .48689 .32229 L .48874 .32305 L p F P
0 0 0 r
s
.862 .266 .108 r
.48874 .32305 m .5 .31525 L .5 .31319 L p F P
0 0 0 r
s
.24 .35 .67 r
.47906 .30438 m
.49591 .31603 L
s
.119 .189 .415 r
.5 .31319 m .51311 .32229 L .51126 .32305 L p F P
0 0 0 r
s
.119 .189 .415 r
.51126 .32305 m .5 .31525 L .5 .31319 L p F P
0 0 0 r
s
.83 .24 .1 r
.50409 .31603 m
.52094 .30438 L
s
1 .311 .131 r
.51968 .64945 m .52466 .64686 L .51265 .6402 L p F P
0 0 0 r
s
.83 .24 .1 r
.51846 .64844 m
.51878 .64827 L
s
1 .311 .131 r
.51265 .6402 m .51011 .64153 L .51968 .64945 L p F P
0 0 0 r
s
.256 .395 .786 r
.48032 .64945 m .47534 .64686 L .48735 .6402 L p F P
0 0 0 r
s
.24 .35 .67 r
.48122 .64827 m
.48154 .64844 L
s
.256 .395 .786 r
.48735 .6402 m .48989 .64153 L .48032 .64945 L p F P
0 0 0 r
s
.83 .24 .1 r
.31613 .57657 m
.33133 .60538 L
s
.31613 .57657 m
.31938 .57456 L
s
.24 .35 .67 r
.66867 .60538 m
.68387 .57657 L
s
.68062 .57456 m
.68387 .57657 L
s
.4 .107 .051 r
.356 .47207 m .34128 .48182 L .34074 .46178 L p F P
0 0 0 r
s
.4 .107 .051 r
.34074 .46178 m .3555 .45183 L .356 .47207 L p F P
0 0 0 r
s
.83 .24 .1 r
.35554 .45332 m
.35701 .45234 L
s
.265 .367 .679 r
.644 .47207 m .65872 .48182 L .65926 .46178 L p F P
0 0 0 r
s
.265 .367 .679 r
.65926 .46178 m .6445 .45183 L .644 .47207 L p F P
0 0 0 r
s
.24 .35 .67 r
.64299 .45234 m
.64446 .45332 L
s
.83 .24 .1 r
.77599 .29248 m
.75634 .26791 L
s
.24 .35 .67 r
.22401 .29248 m
.24366 .26791 L
s
.83 .24 .1 r
.42535 .6552 m
.4019 .63743 L
s
.24 .35 .67 r
.57465 .6552 m
.5981 .63743 L
s
.511 .142 .065 r
.34594 .50267 m .33184 .51182 L .3268 .49141 L p F P
0 0 0 r
s
.83 .24 .1 r
.32833 .49039 m
.32837 .49234 L
s
.511 .142 .065 r
.3268 .49141 m .34128 .48182 L .34594 .50267 L p F P
0 0 0 r
s
.281 .394 .737 r
.65406 .50267 m .66816 .51182 L .6732 .49141 L p F P
0 0 0 r
s
.24 .35 .67 r
.67163 .49234 m
.67167 .49039 L
s
.281 .394 .737 r
.6732 .49141 m .65872 .48182 L .65406 .50267 L p F P
0 0 0 r
s
.599 .169 .076 r
.3413 .53225 m .32813 .54061 L .31795 .52083 L p F P
0 0 0 r
s
.599 .169 .076 r
.31795 .52083 m .33184 .51182 L .3413 .53225 L p F P
0 0 0 r
s
.291 .413 .778 r
.6587 .53225 m .67187 .54061 L .68205 .52083 L p F P
0 0 0 r
s
.291 .413 .778 r
.68205 .52083 m .66816 .51182 L .6587 .53225 L p F P
0 0 0 r
s
.914 .283 .117 r
.60317 .61912 m .61309 .61403 L .58797 .62274 L p F P
0 0 0 r
s
.914 .283 .117 r
.58797 .62274 m .58034 .62667 L .60317 .61912 L p F P
0 0 0 r
s
.156 .257 .535 r
.39683 .61912 m .38691 .61403 L .41203 .62274 L p F P
0 0 0 r
s
.156 .257 .535 r
.41203 .62274 m .41966 .62667 L .39683 .61912 L p F P
0 0 0 r
s
.672 .192 .086 r
.34289 .55962 m .33091 .56704 L .31514 .54885 L p F P
0 0 0 r
s
.672 .192 .086 r
.31514 .54885 m .32813 .54061 L .34289 .55962 L p F P
0 0 0 r
s
.299 .426 .808 r
.65711 .55962 m .66909 .56704 L .68486 .54885 L p F P
0 0 0 r
s
.299 .426 .808 r
.68486 .54885 m .67187 .54061 L .65711 .55962 L p F P
0 0 0 r
s
1 .311 .131 r
.52466 .64686 m .52967 .64426 L .5152 .63885 L p F P
0 0 0 r
s
.83 .24 .1 r
.52313 .64601 m
.52345 .64584 L
s
1 .311 .131 r
.5152 .63885 m .51265 .6402 L .52466 .64686 L p F P
0 0 0 r
s
.256 .395 .786 r
.47534 .64686 m .47033 .64426 L .4848 .63885 L p F P
0 0 0 r
s
.24 .35 .67 r
.47655 .64584 m
.47687 .64601 L
s
.256 .395 .786 r
.4848 .63885 m .48735 .6402 L .47534 .64686 L p F P
0 0 0 r
s
1 .308 .129 r
.56525 .63445 m .57277 .63057 L .54995 .63373 L p F P
0 0 0 r
s
1 .308 .129 r
.54995 .63373 m .54484 .63638 L .56525 .63445 L p F P
0 0 0 r
s
.215 .34 .689 r
.43475 .63445 m .42723 .63057 L .45005 .63373 L p F P
0 0 0 r
s
.215 .34 .689 r
.45005 .63373 m .45516 .63638 L .43475 .63445 L p F P
0 0 0 r
s
.15 .041 .019 r
.4035 .40262 m .38832 .41298 L .39366 .39711 L p F P
0 0 0 r
s
.83 .24 .1 r
.39561 .3982 m
.39725 .39464 L
s
.15 .041 .019 r
.39366 .39711 m .40815 .38713 L .4035 .40262 L p F P
0 0 0 r
s
.202 .266 .472 r
.5965 .40262 m .61168 .41298 L .60634 .39711 L p F P
0 0 0 r
s
.24 .35 .67 r
.60275 .39464 m
.60439 .3982 L
s
.202 .266 .472 r
.60634 .39711 m .59185 .38713 L .5965 .40262 L p F P
0 0 0 r
s
.735 .211 .094 r
.35126 .58375 m .34074 .59009 L .31909 .57435 L p F P
0 0 0 r
s
.735 .211 .094 r
.31909 .57435 m .33091 .56704 L .35126 .58375 L p F P
0 0 0 r
s
.24 .35 .67 r
.31514 .57058 m
.31936 .57276 L
s
.31936 .57276 m
.31953 .57285 L
s
.303 .436 .831 r
.64874 .58375 m .65926 .59009 L .68091 .57435 L p F P
0 0 0 r
s
.303 .436 .831 r
.68091 .57435 m .66909 .56704 L .64874 .58375 L p F P
0 0 0 r
s
.83 .24 .1 r
.68064 .57276 m
.68486 .57058 L
s
.68047 .57285 m
.68064 .57276 L
s
.083 .024 .01 r
.47084 .3362 m .45658 .34608 L .46118 .34014 L p F P
0 0 0 r
s
.083 .024 .01 r
.46118 .34014 m .47395 .33127 L .47084 .3362 L p F P
0 0 0 r
s
.83 .24 .1 r
.47177 .33473 m
.47351 .33352 L
s
.47351 .33352 m
.48929 .32626 L
s
.104 .117 .224 r
.52916 .3362 m .54342 .34608 L .53882 .34014 L p F P
0 0 0 r
s
.104 .117 .224 r
.53882 .34014 m .52605 .33127 L .52916 .3362 L p F P
0 0 0 r
s
.24 .35 .67 r
.52649 .33352 m
.52823 .33473 L
s
.51071 .32626 m
.52649 .33352 L
s
.83 .24 .1 r
.83284 .40519 m
.82296 .37673 L
s
.24 .35 .67 r
.16716 .40519 m
.17704 .37673 L
s
.083 .024 .01 r
.64704 .59636 m .65926 .59009 L .6332 .60371 L p F P
0 0 0 r
s
.083 .024 .01 r
.6332 .60371 m .6231 .6089 L .64704 .59636 L p F P
0 0 0 r
s
.83 .24 .1 r
.60446 .61703 m
.63779 .59989 L
s
.63779 .59989 m
.65075 .58819 L
s
.073 .085 .162 r
.35296 .59636 m .34074 .59009 L .3668 .60371 L p F P
0 0 0 r
s
.073 .085 .162 r
.3668 .60371 m .3769 .6089 L .35296 .59636 L p F P
0 0 0 r
s
.24 .35 .67 r
.36221 .59989 m
.39554 .61703 L
s
.34925 .58819 m
.36221 .59989 L
s
.83 .24 .1 r
.72802 .53577 m
.76392 .51703 L
s
.72802 .53577 m
.72008 .5524 L
s
.24 .35 .67 r
.27198 .53577 m
.23608 .51703 L
s
.27198 .53577 m
.27992 .5524 L
s
1 .311 .131 r
.52967 .64426 m .5347 .64165 L .51776 .63751 L p F P
0 0 0 r
s
.83 .24 .1 r
.52782 .64357 m
.52815 .6434 L
s
.53253 .64112 m
.53434 .64018 L
s
.53434 .64018 m
.53758 .64015 L
s
1 .311 .131 r
.51776 .63751 m .5152 .63885 L .52967 .64426 L p F P
0 0 0 r
s
.256 .395 .786 r
.47033 .64426 m .4653 .64165 L .48224 .63751 L p F P
0 0 0 r
s
.24 .35 .67 r
.46566 .64018 m
.46747 .64112 L
s
.47185 .6434 m
.47218 .64357 L
s
.46242 .64015 m
.46566 .64018 L
s
.256 .395 .786 r
.48224 .63751 m .4848 .63885 L .47033 .64426 L p F P
0 0 0 r
s
.83 .24 .1 r
.47991 .65076 m
.49257 .64406 L
s
.24 .35 .67 r
.50743 .64406 m
.52009 .65076 L
s
.083 .024 .01 r
.43781 .3667 m .42286 .377 L .42868 .36541 L p F P
0 0 0 r
s
.083 .024 .01 r
.42868 .36541 m .44253 .35582 L .43781 .3667 L p F P
0 0 0 r
s
.157 .196 .347 r
.56219 .3667 m .57714 .377 L .57132 .36541 L p F P
0 0 0 r
s
.157 .196 .347 r
.57132 .36541 m .55747 .35582 L .56219 .3667 L p F P
0 0 0 r
s
.83 .24 .1 r
.76702 .49611 m
.80357 .47672 L
s
.76702 .49611 m
.76392 .51703 L
s
.24 .35 .67 r
.23298 .49611 m
.19643 .47672 L
s
.23298 .49611 m
.23608 .51703 L
s
.83 .24 .1 r
.68486 .57058 m
.72008 .5524 L
s
.67228 .58217 m
.68486 .57058 L
s
.24 .35 .67 r
.27992 .5524 m
.31514 .57058 L
s
.31514 .57058 m
.32772 .58217 L
s
.83 .24 .1 r
.75634 .26791 m
.73573 .24658 L
s
.24 .35 .67 r
.24366 .26791 m
.26427 .24658 L
s
.276 .072 .035 r
.38577 .43146 m .37051 .44173 L .37338 .42317 L p F P
0 0 0 r
s
.276 .072 .035 r
.37338 .42317 m .38832 .41298 L .38577 .43146 L p F P
0 0 0 r
s
.24 .327 .596 r
.61423 .43146 m .62949 .44173 L .62662 .42317 L p F P
0 0 0 r
s
.24 .327 .596 r
.62662 .42317 m .61168 .41298 L .61423 .43146 L p F P
0 0 0 r
s
1 .308 .129 r
.57277 .63057 m .58034 .62667 L .55508 .63106 L p F P
0 0 0 r
s
1 .308 .129 r
.55508 .63106 m .54995 .63373 L .57277 .63057 L p F P
0 0 0 r
s
.215 .34 .689 r
.42723 .63057 m .41966 .62667 L .44492 .63106 L p F P
0 0 0 r
s
.215 .34 .689 r
.44492 .63106 m .45005 .63373 L .42723 .63057 L p F P
0 0 0 r
s
.914 .283 .117 r
.61309 .61403 m .6231 .6089 L .59565 .61878 L p F P
0 0 0 r
s
.914 .283 .117 r
.59565 .61878 m .58797 .62274 L .61309 .61403 L p F P
0 0 0 r
s
.156 .257 .535 r
.38691 .61403 m .3769 .6089 L .40435 .61878 L p F P
0 0 0 r
s
.156 .257 .535 r
.40435 .61878 m .41203 .62274 L .38691 .61403 L p F P
0 0 0 r
s
1 .311 .131 r
.5347 .64165 m .53976 .63902 L .52032 .63616 L p F P
0 0 0 r
s
1 .311 .131 r
.52032 .63616 m .51776 .63751 L .5347 .64165 L p F P
0 0 0 r
s
.256 .395 .786 r
.4653 .64165 m .46024 .63902 L .47968 .63616 L p F P
0 0 0 r
s
.256 .395 .786 r
.47968 .63616 m .48224 .63751 L .4653 .64165 L p F P
0 0 0 r
s
.83 .24 .1 r
.80187 .45234 m
.83908 .43218 L
s
.80187 .45234 m
.80357 .47672 L
s
.24 .35 .67 r
.19813 .45234 m
.16092 .43218 L
s
.19813 .45234 m
.19643 .47672 L
s
.4 .107 .051 r
.37096 .46217 m .356 .47207 L .3555 .45183 L p F P
0 0 0 r
s
.83 .24 .1 r
.35701 .45234 m
.35702 .45285 L
s
.4 .107 .051 r
.3555 .45183 m .37051 .44173 L .37096 .46217 L p F P
0 0 0 r
s
.265 .367 .679 r
.62904 .46217 m .644 .47207 L .6445 .45183 L p F P
0 0 0 r
s
.24 .35 .67 r
.64298 .45285 m
.64299 .45234 L
s
.265 .367 .679 r
.6445 .45183 m .62949 .44173 L .62904 .46217 L p F P
0 0 0 r
s
.83 .24 .1 r
.55362 .28179 m
.57154 .28128 L
s
.57154 .28128 m
.60501 .25833 L
s
.24 .35 .67 r
.44638 .28179 m
.42846 .28128 L
s
.42846 .28128 m
.39499 .25833 L
s
.83 .24 .1 r
.60501 .25833 m
.62461 .26419 L
s
.62461 .26419 m
.65896 .24096 L
s
.24 .35 .67 r
.39499 .25833 m
.37539 .26419 L
s
.37539 .26419 m
.34104 .24096 L
s
.511 .142 .065 r
.36026 .49337 m .34594 .50267 L .34128 .48182 L p F P
0 0 0 r
s
.511 .142 .065 r
.34128 .48182 m .356 .47207 L .36026 .49337 L p F P
0 0 0 r
s
.281 .394 .737 r
.63974 .49337 m .65406 .50267 L .65872 .48182 L p F P
0 0 0 r
s
.281 .394 .737 r
.65872 .48182 m .644 .47207 L .63974 .49337 L p F P
0 0 0 r
s
.83 .24 .1 r
.50545 .31139 m
.52094 .30438 L
s
.52094 .30438 m
.55362 .28179 L
s
.24 .35 .67 r
.49455 .31139 m
.47906 .30438 L
s
.47906 .30438 m
.44638 .28179 L
s
1 .303 .129 r
.5 .62969 m .5 .64685 L .50252 .64553 L closepath p F P
0 0 0 r
s
.281 .425 .837 r
.5 .62969 m .5 .64685 L .49748 .64553 L closepath p F P
0 0 0 r
s
.599 .169 .076 r
.35467 .52376 m .3413 .53225 L .33184 .51182 L p F P
0 0 0 r
s
.599 .169 .076 r
.33184 .51182 m .34594 .50267 L .35467 .52376 L p F P
0 0 0 r
s
.291 .413 .778 r
.64533 .52376 m .6587 .53225 L .66816 .51182 L p F P
0 0 0 r
s
.291 .413 .778 r
.66816 .51182 m .65406 .50267 L .64533 .52376 L p F P
0 0 0 r
s
.672 .192 .086 r
.35502 .55211 m .34289 .55962 L .32813 .54061 L p F P
0 0 0 r
s
.672 .192 .086 r
.32813 .54061 m .3413 .53225 L .35502 .55211 L p F P
0 0 0 r
s
.299 .426 .808 r
.64498 .55211 m .65711 .55962 L .67187 .54061 L p F P
0 0 0 r
s
.299 .426 .808 r
.67187 .54061 m .6587 .53225 L .64498 .55211 L p F P
0 0 0 r
s
.735 .211 .094 r
.36191 .57733 m .35126 .58375 L .33091 .56704 L p F P
0 0 0 r
s
.735 .211 .094 r
.33091 .56704 m .34289 .55962 L .36191 .57733 L p F P
0 0 0 r
s
.83 .24 .1 r
.34314 .55986 m
.3452 .55859 L
s
.303 .436 .831 r
.63809 .57733 m .64874 .58375 L .66909 .56704 L p F P
0 0 0 r
s
.303 .436 .831 r
.66909 .56704 m .65711 .55962 L .63809 .57733 L p F P
0 0 0 r
s
.24 .35 .67 r
.6548 .55859 m
.65686 .55986 L
s
1 .311 .131 r
.53976 .63902 m .54484 .63638 L .52289 .63481 L p F P
0 0 0 r
s
.83 .24 .1 r
.53726 .63865 m
.5376 .63848 L
s
.24 .35 .67 r
.54379 .63847 m
.57465 .6552 L
s
1 .311 .131 r
.52289 .63481 m .52032 .63616 L .53976 .63902 L p F P
0 0 0 r
s
.24 .35 .67 r
.52009 .65076 m
.54379 .63847 L
s
.256 .395 .786 r
.46024 .63902 m .45516 .63638 L .47711 .63481 L p F P
0 0 0 r
s
.24 .35 .67 r
.4624 .63848 m
.46274 .63865 L
s
.83 .24 .1 r
.42535 .6552 m
.45621 .63847 L
s
.256 .395 .786 r
.47711 .63481 m .47968 .63616 L .46024 .63902 L p F P
0 0 0 r
s
.83 .24 .1 r
.45621 .63847 m
.47991 .65076 L
s
.791 .229 .101 r
.37572 .59847 m .3668 .60371 L .34074 .59009 L p F P
0 0 0 r
s
.791 .229 .101 r
.34074 .59009 m .35126 .58375 L .37572 .59847 L p F P
0 0 0 r
s
.83 .24 .1 r
.34844 .59516 m
.34937 .5946 L
s
.33133 .60538 m
.34844 .59516 L
s
.24 .35 .67 r
.34809 .59263 m
.34919 .5932 L
s
.32772 .58217 m
.34809 .59263 L
s
.306 .443 .849 r
.62428 .59847 m .6332 .60371 L .65926 .59009 L p F P
0 0 0 r
s
.306 .443 .849 r
.65926 .59009 m .64874 .58375 L .62428 .59847 L p F P
0 0 0 r
s
.24 .35 .67 r
.65063 .5946 m
.65156 .59516 L
s
.65156 .59516 m
.66867 .60538 L
s
.83 .24 .1 r
.65081 .5932 m
.65191 .59263 L
s
.65191 .59263 m
.67228 .58217 L
s
1 .308 .129 r
.58034 .62667 m .58797 .62274 L .56024 .62838 L p F P
0 0 0 r
s
1 .308 .129 r
.56024 .62838 m .55508 .63106 L .58034 .62667 L p F P
0 0 0 r
s
.215 .34 .689 r
.41966 .62667 m .41203 .62274 L .43976 .62838 L p F P
0 0 0 r
s
.215 .34 .689 r
.43976 .62838 m .44492 .63106 L .41966 .62667 L p F P
0 0 0 r
s
.83 .24 .1 r
.65896 .24096 m
.67953 .2528 L
s
.67953 .2528 m
.71485 .22934 L
s
.24 .35 .67 r
.34104 .24096 m
.32047 .2528 L
s
.32047 .2528 m
.28515 .22934 L
s
1 .303 .129 r
.5 .62969 m .50252 .64553 L .50504 .6442 L closepath p F P
0 0 0 r
s
.281 .425 .837 r
.5 .62969 m .49748 .64553 L .49496 .6442 L closepath p F P
0 0 0 r
s
.15 .041 .019 r
.41892 .3921 m .4035 .40262 L .40815 .38713 L p F P
0 0 0 r
s
.15 .041 .019 r
.40815 .38713 m .42286 .377 L .41892 .3921 L p F P
0 0 0 r
s
.202 .266 .472 r
.58108 .3921 m .5965 .40262 L .59185 .38713 L p F P
0 0 0 r
s
.202 .266 .472 r
.59185 .38713 m .57714 .377 L .58108 .3921 L p F P
0 0 0 r
s
.083 .024 .01 r
.48531 .32618 m .47084 .3362 L .47395 .33127 L p F P
0 0 0 r
s
.083 .024 .01 r
.47395 .33127 m .48689 .32229 L .48531 .32618 L p F P
0 0 0 r
s
.104 .117 .224 r
.51469 .32618 m .52916 .3362 L .52605 .33127 L p F P
0 0 0 r
s
.104 .117 .224 r
.52605 .33127 m .51311 .32229 L .51469 .32618 L p F P
0 0 0 r
s
.83 .24 .1 r
.34508 .55826 m
.3452 .55859 L
s
.24 .35 .67 r
.6548 .55859 m
.65492 .55826 L
s
.914 .283 .117 r
.6231 .6089 m .6332 .60371 L .60339 .61479 L p F P
0 0 0 r
s
.914 .283 .117 r
.60339 .61479 m .59565 .61878 L .6231 .6089 L p F P
0 0 0 r
s
.24 .35 .67 r
.62005 .61459 m
.64966 .63167 L
s
.5981 .63743 m
.62005 .61459 L
s
.156 .257 .535 r
.3769 .6089 m .3668 .60371 L .39661 .61479 L p F P
0 0 0 r
s
.156 .257 .535 r
.39661 .61479 m .40435 .61878 L .3769 .6089 L p F P
0 0 0 r
s
.83 .24 .1 r
.35034 .63167 m
.37995 .61459 L
s
.37995 .61459 m
.4019 .63743 L
s
1 .303 .129 r
.5 .62969 m .50504 .6442 L .50757 .64287 L closepath p F P
0 0 0 r
s
.281 .425 .837 r
.5 .62969 m .49496 .6442 L .49243 .64287 L closepath p F P
0 0 0 r
s
1 .311 .131 r
.54484 .63638 m .54995 .63373 L .52547 .63346 L p F P
0 0 0 r
s
.83 .24 .1 r
.54202 .63618 m
.54235 .636 L
s
1 .311 .131 r
.52547 .63346 m .52289 .63481 L .54484 .63638 L p F P
0 0 0 r
s
.256 .395 .786 r
.45516 .63638 m .45005 .63373 L .47453 .63346 L p F P
0 0 0 r
s
.24 .35 .67 r
.45765 .636 m
.45798 .63618 L
s
.256 .395 .786 r
.47453 .63346 m .47711 .63481 L .45516 .63638 L p F P
0 0 0 r
s
.083 .024 .01 r
.45299 .35625 m .43781 .3667 L .44253 .35582 L p F P
0 0 0 r
s
.083 .024 .01 r
.44253 .35582 m .45658 .34608 L .45299 .35625 L p F P
0 0 0 r
s
.157 .196 .347 r
.54701 .35625 m .56219 .3667 L .55747 .35582 L p F P
0 0 0 r
s
.157 .196 .347 r
.55747 .35582 m .54342 .34608 L .54701 .35625 L p F P
0 0 0 r
s
.83 .24 .1 r
.83908 .43218 m
.83284 .40519 L
s
.24 .35 .67 r
.16092 .43218 m
.16716 .40519 L
s
1 .303 .129 r
.5 .62969 m .50757 .64287 L .51011 .64153 L closepath p F P
0 0 0 r
s
.281 .425 .837 r
.5 .62969 m .49243 .64287 L .48989 .64153 L closepath p F P
0 0 0 r
s
1 .308 .129 r
.58797 .62274 m .59565 .61878 L .56542 .62568 L p F P
0 0 0 r
s
.83 .24 .1 r
.58456 .62319 m
.58575 .62319 L
s
1 .308 .129 r
.56542 .62568 m .56024 .62838 L .58797 .62274 L p F P
0 0 0 r
s
.24 .35 .67 r
.57709 .6257 m
.5981 .63743 L
s
.215 .34 .689 r
.41203 .62274 m .40435 .61878 L .43458 .62568 L p F P
0 0 0 r
s
.24 .35 .67 r
.41425 .62319 m
.41544 .62319 L
s
.215 .34 .689 r
.43458 .62568 m .43976 .62838 L .41203 .62274 L p F P
0 0 0 r
s
.83 .24 .1 r
.4019 .63743 m
.42291 .6257 L
s
.276 .072 .035 r
.40127 .42102 m .38577 .43146 L .38832 .41298 L p F P
0 0 0 r
s
.83 .24 .1 r
.38697 .43218 m
.38726 .43045 L
s
.39 .41402 m
.39041 .41155 L
s
.276 .072 .035 r
.38832 .41298 m .4035 .40262 L .40127 .42102 L p F P
0 0 0 r
s
.24 .327 .596 r
.59873 .42102 m .61423 .43146 L .61168 .41298 L p F P
0 0 0 r
s
.24 .35 .67 r
.60959 .41155 m
.61 .41402 L
s
.61274 .43045 m
.61303 .43218 L
s
.24 .327 .596 r
.61168 .41298 m .5965 .40262 L .59873 .42102 L p F P
0 0 0 r
s
1 .303 .129 r
.5 .62969 m .51011 .64153 L .51265 .6402 L closepath p F P
0 0 0 r
s
.281 .425 .837 r
.5 .62969 m .48989 .64153 L .48735 .6402 L closepath p F P
0 0 0 r
s
1 .311 .131 r
.54995 .63373 m .55508 .63106 L .52805 .6321 L p F P
0 0 0 r
s
.83 .24 .1 r
.5468 .63369 m
.54714 .63352 L
s
1 .311 .131 r
.52805 .6321 m .52547 .63346 L .54995 .63373 L p F P
0 0 0 r
s
.256 .395 .786 r
.45005 .63373 m .44492 .63106 L .47195 .6321 L p F P
0 0 0 r
s
.24 .35 .67 r
.45286 .63352 m
.4532 .63369 L
s
.256 .395 .786 r
.47195 .6321 m .47453 .63346 L .45005 .63373 L p F P
0 0 0 r
s
.83 .24 .1 r
.73573 .24658 m
.71485 .22934 L
s
.24 .35 .67 r
.26427 .24658 m
.28515 .22934 L
s
.83 .24 .1 r
.37444 .60694 m
.37528 .60811 L
s
.37054 .60152 m
.37406 .60641 L
s
.37528 .60811 m
.37995 .61459 L
s
.24 .35 .67 r
.62472 .60811 m
.62556 .60694 L
s
.62594 .60641 m
.62946 .60152 L
s
.62005 .61459 m
.62472 .60811 L
s
1 .303 .129 r
.5 .62969 m .51265 .6402 L .5152 .63885 L closepath p F P
0 0 0 r
s
.281 .425 .837 r
.5 .62969 m .48735 .6402 L .4848 .63885 L closepath p F P
0 0 0 r
s
.791 .229 .101 r
.38472 .59319 m .37572 .59847 L .35126 .58375 L p F P
0 0 0 r
s
.791 .229 .101 r
.35126 .58375 m .36191 .57733 L .38472 .59319 L p F P
0 0 0 r
s
.306 .443 .849 r
.61528 .59319 m .62428 .59847 L .64874 .58375 L p F P
0 0 0 r
s
.306 .443 .849 r
.64874 .58375 m .63809 .57733 L .61528 .59319 L p F P
0 0 0 r
s
.735 .211 .094 r
.37268 .57083 m .36191 .57733 L .34289 .55962 L p F P
0 0 0 r
s
.83 .24 .1 r
.3452 .55859 m
.34646 .56097 L
s
.735 .211 .094 r
.34289 .55962 m .35502 .55211 L .37268 .57083 L p F P
0 0 0 r
s
.303 .436 .831 r
.62732 .57083 m .63809 .57733 L .65711 .55962 L p F P
0 0 0 r
s
.24 .35 .67 r
.65354 .56097 m
.6548 .55859 L
s
.303 .436 .831 r
.65711 .55962 m .64498 .55211 L .62732 .57083 L p F P
0 0 0 r
s
.4 .107 .051 r
.38617 .4521 m .37096 .46217 L .37051 .44173 L p F P
0 0 0 r
s
.4 .107 .051 r
.37051 .44173 m .38577 .43146 L .38617 .4521 L p F P
0 0 0 r
s
.83 .24 .1 r
.3858 .43298 m
.38697 .43218 L
s
.265 .367 .679 r
.61383 .4521 m .62904 .46217 L .62949 .44173 L p F P
0 0 0 r
s
.265 .367 .679 r
.62949 .44173 m .61423 .43146 L .61383 .4521 L p F P
0 0 0 r
s
.24 .35 .67 r
.61303 .43218 m
.6142 .43298 L
s
.843 .246 .107 r
.40363 .61077 m .39661 .61479 L .3668 .60371 L p F P
0 0 0 r
s
.83 .24 .1 r
.37995 .61459 m
.38601 .61109 L
s
.843 .246 .107 r
.3668 .60371 m .37572 .59847 L .40363 .61077 L p F P
0 0 0 r
s
.24 .35 .67 r
.37411 .60412 m
.37485 .60438 L
s
.307 .447 .861 r
.59637 .61077 m .60339 .61479 L .6332 .60371 L p F P
0 0 0 r
s
.24 .35 .67 r
.61399 .61109 m
.62005 .61459 L
s
.307 .447 .861 r
.6332 .60371 m .62428 .59847 L .59637 .61077 L p F P
0 0 0 r
s
.83 .24 .1 r
.62515 .60438 m
.62589 .60412 L
s
.672 .192 .086 r
.36732 .5445 m .35502 .55211 L .3413 .53225 L p F P
0 0 0 r
s
.672 .192 .086 r
.3413 .53225 m .35467 .52376 L .36732 .5445 L p F P
0 0 0 r
s
.299 .426 .808 r
.63268 .5445 m .64498 .55211 L .6587 .53225 L p F P
0 0 0 r
s
.299 .426 .808 r
.6587 .53225 m .64533 .52376 L .63268 .5445 L p F P
0 0 0 r
s
1 .303 .129 r
.5 .62969 m .5152 .63885 L .51776 .63751 L closepath p F P
0 0 0 r
s
.281 .425 .837 r
.5 .62969 m .4848 .63885 L .48224 .63751 L closepath p F P
0 0 0 r
s
.599 .169 .076 r
.36824 .51516 m .35467 .52376 L .34594 .50267 L p F P
0 0 0 r
s
.599 .169 .076 r
.34594 .50267 m .36026 .49337 L .36824 .51516 L p F P
0 0 0 r
s
.291 .413 .778 r
.63176 .51516 m .64533 .52376 L .65406 .50267 L p F P
0 0 0 r
s
.291 .413 .778 r
.65406 .50267 m .63974 .49337 L .63176 .51516 L p F P
0 0 0 r
s
.511 .142 .065 r
.37481 .48393 m .36026 .49337 L .356 .47207 L p F P
0 0 0 r
s
.83 .24 .1 r
.35759 .47102 m
.35765 .47311 L
s
.511 .142 .065 r
.356 .47207 m .37096 .46217 L .37481 .48393 L p F P
0 0 0 r
s
.281 .394 .737 r
.62519 .48393 m .63974 .49337 L .644 .47207 L p F P
0 0 0 r
s
.24 .35 .67 r
.64235 .47311 m
.64241 .47102 L
s
.281 .394 .737 r
.644 .47207 m .62904 .46217 L .62519 .48393 L p F P
0 0 0 r
s
1 .311 .131 r
.55508 .63106 m .56024 .62838 L .53064 .63073 L p F P
0 0 0 r
s
.83 .24 .1 r
.5516 .63119 m
.55194 .63102 L
s
1 .311 .131 r
.53064 .63073 m .52805 .6321 L .55508 .63106 L p F P
0 0 0 r
s
.24 .35 .67 r
.53113 .6316 m
.54379 .63847 L
s
.256 .395 .786 r
.44492 .63106 m .43976 .62838 L .46936 .63073 L p F P
0 0 0 r
s
.24 .35 .67 r
.44806 .63102 m
.4484 .63119 L
s
.256 .395 .786 r
.46936 .63073 m .47195 .6321 L .44492 .63106 L p F P
0 0 0 r
s
.83 .24 .1 r
.45621 .63847 m
.46887 .6316 L
s
.083 .024 .01 r
.5 .316 m .48531 .32618 L .48689 .32229 L p F P
0 0 0 r
s
.083 .024 .01 r
.48689 .32229 m .5 .31319 L .5 .316 L p F P
0 0 0 r
s
.24 .35 .67 r
.4985 .31413 m
.49866 .31424 L
s
.49455 .31139 m
.4985 .31413 L
s
.104 .117 .224 r
.5 .316 m .51469 .32618 L .51311 .32229 L p F P
0 0 0 r
s
.104 .117 .224 r
.51311 .32229 m .5 .31319 L .5 .316 L p F P
0 0 0 r
s
.83 .24 .1 r
.50134 .31424 m
.5015 .31413 L
s
.5015 .31413 m
.50545 .31139 L
s
1 .308 .129 r
.59565 .61878 m .60339 .61479 L .57064 .62298 L p F P
0 0 0 r
s
1 .308 .129 r
.57064 .62298 m .56542 .62568 L .59565 .61878 L p F P
0 0 0 r
s
.24 .35 .67 r
.57276 .62328 m
.57709 .6257 L
s
.215 .34 .689 r
.40435 .61878 m .39661 .61479 L .42936 .62298 L p F P
0 0 0 r
s
.215 .34 .689 r
.42936 .62298 m .43458 .62568 L .40435 .61878 L p F P
0 0 0 r
s
.83 .24 .1 r
.42291 .6257 m
.42724 .62328 L
s
1 .303 .129 r
.5 .62969 m .51776 .63751 L .52032 .63616 L closepath p F P
0 0 0 r
s
.281 .425 .837 r
.5 .62969 m .48224 .63751 L .47968 .63616 L closepath p F P
0 0 0 r
s
.15 .041 .019 r
.43461 .3814 m .41892 .3921 L .42286 .377 L p F P
0 0 0 r
s
.15 .041 .019 r
.42286 .377 m .43781 .3667 L .43461 .3814 L p F P
0 0 0 r
s
.202 .266 .472 r
.56539 .3814 m .58108 .3921 L .57714 .377 L p F P
0 0 0 r
s
.202 .266 .472 r
.57714 .377 m .56219 .3667 L .56539 .3814 L p F P
0 0 0 r
s
.83 .24 .1 r
.36062 .49314 m
.3612 .49595 L
s
.24 .35 .67 r
.6388 .49595 m
.63938 .49314 L
s
1 .303 .129 r
.5 .62969 m .52032 .63616 L .52289 .63481 L closepath p F P
0 0 0 r
s
.281 .425 .837 r
.5 .62969 m .47968 .63616 L .47711 .63481 L closepath p F P
0 0 0 r
s
.083 .024 .01 r
.46841 .34563 m .45299 .35625 L .45658 .34608 L p F P
0 0 0 r
s
.083 .024 .01 r
.45658 .34608 m .47084 .3362 L .46841 .34563 L p F P
0 0 0 r
s
.83 .24 .1 r
.47077 .33649 m
.47138 .33583 L
s
.157 .196 .347 r
.53159 .34563 m .54701 .35625 L .54342 .34608 L p F P
0 0 0 r
s
.157 .196 .347 r
.54342 .34608 m .52916 .3362 L .53159 .34563 L p F P
0 0 0 r
s
.24 .35 .67 r
.52862 .33583 m
.52923 .33649 L
s
1 .311 .131 r
.56024 .62838 m .56542 .62568 L .53324 .62937 L p F P
0 0 0 r
s
.83 .24 .1 r
.55643 .62868 m
.55676 .62851 L
s
1 .311 .131 r
.53324 .62937 m .53064 .63073 L .56024 .62838 L p F P
0 0 0 r
s
.24 .35 .67 r
.55615 .62891 m
.55865 .62698 L
s
.54379 .63847 m
.55615 .62891 L
s
.256 .395 .786 r
.43976 .62838 m .43458 .62568 L .46676 .62937 L p F P
0 0 0 r
s
.24 .35 .67 r
.44324 .62851 m
.44357 .62868 L
s
.256 .395 .786 r
.46676 .62937 m .46936 .63073 L .43976 .62838 L p F P
0 0 0 r
s
.83 .24 .1 r
.44135 .62698 m
.44385 .62891 L
s
.44385 .62891 m
.45621 .63847 L
s
1 .303 .129 r
.5 .62969 m .52289 .63481 L .52547 .63346 L closepath p F P
0 0 0 r
s
.281 .425 .837 r
.5 .62969 m .47711 .63481 L .47453 .63346 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.76392 .51703 m
.80099 .49768 L
s
.76392 .51703 m
.75645 .53361 L
s
.24 .35 .67 r
.23608 .51703 m
.19901 .49768 L
s
.23608 .51703 m
.24355 .53361 L
s
.843 .246 .107 r
.41071 .60672 m .40363 .61077 L .37572 .59847 L p F P
0 0 0 r
s
.843 .246 .107 r
.37572 .59847 m .38472 .59319 L .41071 .60672 L p F P
0 0 0 r
s
.24 .35 .67 r
.37485 .60438 m
.37897 .60584 L
s
.37897 .60584 m
.38583 .60937 L
s
.307 .447 .861 r
.58929 .60672 m .59637 .61077 L .62428 .59847 L p F P
0 0 0 r
s
.307 .447 .861 r
.62428 .59847 m .61528 .59319 L .58929 .60672 L p F P
0 0 0 r
s
.83 .24 .1 r
.62103 .60584 m
.62515 .60438 L
s
.61417 .60937 m
.62103 .60584 L
s
.891 .261 .113 r
.43424 .62026 m .42936 .62298 L .39661 .61479 L p F P
0 0 0 r
s
.891 .261 .113 r
.39661 .61479 m .40363 .61077 L .43424 .62026 L p F P
0 0 0 r
s
.306 .449 .868 r
.56576 .62026 m .57064 .62298 L .60339 .61479 L p F P
0 0 0 r
s
.306 .449 .868 r
.60339 .61479 m .59637 .61077 L .56576 .62026 L p F P
0 0 0 r
s
.83 .24 .1 r
.80357 .47672 m
.84132 .45669 L
s
.80357 .47672 m
.80099 .49768 L
s
.24 .35 .67 r
.19643 .47672 m
.15868 .45669 L
s
.19643 .47672 m
.19901 .49768 L
s
.83 .24 .1 r
.72008 .5524 m
.75645 .53361 L
s
.72008 .5524 m
.7079 .56386 L
s
.24 .35 .67 r
.27992 .5524 m
.24355 .53361 L
s
.27992 .5524 m
.2921 .56386 L
s
.791 .229 .101 r
.39381 .58785 m .38472 .59319 L .36191 .57733 L p F P
0 0 0 r
s
.791 .229 .101 r
.36191 .57733 m .37268 .57083 L .39381 .58785 L p F P
0 0 0 r
s
.306 .443 .849 r
.60619 .58785 m .61528 .59319 L .63809 .57733 L p F P
0 0 0 r
s
.306 .443 .849 r
.63809 .57733 m .62732 .57083 L .60619 .58785 L p F P
0 0 0 r
s
1 .303 .129 r
.5 .62969 m .52547 .63346 L .52805 .6321 L closepath p F P
0 0 0 r
s
.281 .425 .837 r
.5 .62969 m .47453 .63346 L .47195 .6321 L closepath p F P
0 0 0 r
s
.276 .072 .035 r
.41704 .4104 m .40127 .42102 L .4035 .40262 L p F P
0 0 0 r
s
.276 .072 .035 r
.4035 .40262 m .41892 .3921 L .41704 .4104 L p F P
0 0 0 r
s
.24 .327 .596 r
.58296 .4104 m .59873 .42102 L .5965 .40262 L p F P
0 0 0 r
s
.24 .327 .596 r
.5965 .40262 m .58108 .3921 L .58296 .4104 L p F P
0 0 0 r
s
1 .311 .131 r
.56542 .62568 m .57064 .62298 L .53584 .628 L p F P
0 0 0 r
s
.83 .24 .1 r
.56127 .62616 m
.56161 .62598 L
s
.56614 .62363 m
.56716 .62309 L
s
.56716 .62309 m
.56973 .62311 L
s
1 .311 .131 r
.53584 .628 m .53324 .62937 L .56542 .62568 L p F P
0 0 0 r
s
.256 .395 .786 r
.43458 .62568 m .42936 .62298 L .46416 .628 L p F P
0 0 0 r
s
.24 .35 .67 r
.43284 .62309 m
.43386 .62363 L
s
.43839 .62598 m
.43873 .62616 L
s
.43027 .62311 m
.43284 .62309 L
s
.256 .395 .786 r
.46416 .628 m .46676 .62937 L .43458 .62568 L p F P
0 0 0 r
s
.83 .24 .1 r
.67228 .58217 m
.7079 .56386 L
s
.67228 .58217 m
.65584 .5879 L
s
.24 .35 .67 r
.32772 .58217 m
.2921 .56386 L
s
.32772 .58217 m
.34416 .5879 L
s
.735 .211 .094 r
.38357 .56426 m .37268 .57083 L .35502 .55211 L p F P
0 0 0 r
s
.735 .211 .094 r
.35502 .55211 m .36732 .5445 L .38357 .56426 L p F P
0 0 0 r
s
.303 .436 .831 r
.61643 .56426 m .62732 .57083 L .64498 .55211 L p F P
0 0 0 r
s
.303 .436 .831 r
.64498 .55211 m .63268 .5445 L .61643 .56426 L p F P
0 0 0 r
s
.83 .24 .1 r
.56716 .62309 m
.56907 .6221 L
s
.24 .35 .67 r
.43093 .6221 m
.43284 .62309 L
s
.83 .24 .1 r
.62103 .60584 m
.65584 .5879 L
s
.24 .35 .67 r
.34416 .5879 m
.37897 .60584 L
s
1 .303 .129 r
.5 .62969 m .52805 .6321 L .53064 .63073 L closepath p F P
0 0 0 r
s
.281 .425 .837 r
.5 .62969 m .47195 .6321 L .46936 .63073 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.84132 .45669 m
.83908 .43218 L
s
.24 .35 .67 r
.15868 .45669 m
.16092 .43218 L
s
.672 .192 .086 r
.37979 .53678 m .36732 .5445 L .35467 .52376 L p F P
0 0 0 r
s
.672 .192 .086 r
.35467 .52376 m .36824 .51516 L .37979 .53678 L p F P
0 0 0 r
s
.299 .426 .808 r
.62021 .53678 m .63268 .5445 L .64533 .52376 L p F P
0 0 0 r
s
.299 .426 .808 r
.64533 .52376 m .63176 .51516 L .62021 .53678 L p F P
0 0 0 r
s
.83 .24 .1 r
.58738 .25846 m
.60501 .25833 L
s
.60501 .25833 m
.6396 .23463 L
s
.24 .35 .67 r
.41262 .25846 m
.39499 .25833 L
s
.39499 .25833 m
.3604 .23463 L
s
.4 .107 .051 r
.40162 .44186 m .38617 .4521 L .38577 .43146 L p F P
0 0 0 r
s
.83 .24 .1 r
.38697 .43218 m
.38698 .43225 L
s
.4 .107 .051 r
.38577 .43146 m .40127 .42102 L .40162 .44186 L p F P
0 0 0 r
s
.265 .367 .679 r
.59838 .44186 m .61383 .4521 L .61423 .43146 L p F P
0 0 0 r
s
.24 .35 .67 r
.61302 .43225 m
.61303 .43218 L
s
.265 .367 .679 r
.61423 .43146 m .59873 .42102 L .59838 .44186 L p F P
0 0 0 r
s
1 .303 .129 r
.5 .62969 m .53064 .63073 L .53324 .62937 L closepath p F P
0 0 0 r
s
.281 .425 .837 r
.5 .62969 m .46936 .63073 L .46676 .62937 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.6396 .23463 m
.65896 .24096 L
s
.65896 .24096 m
.69445 .21696 L
s
.24 .35 .67 r
.3604 .23463 m
.34104 .24096 L
s
.34104 .24096 m
.30555 .21696 L
s
.599 .169 .076 r
.38201 .50642 m .36824 .51516 L .36026 .49337 L p F P
0 0 0 r
s
.599 .169 .076 r
.36026 .49337 m .37481 .48393 L .38201 .50642 L p F P
0 0 0 r
s
.291 .413 .778 r
.61799 .50642 m .63176 .51516 L .63974 .49337 L p F P
0 0 0 r
s
.291 .413 .778 r
.63974 .49337 m .62519 .48393 L .61799 .50642 L p F P
0 0 0 r
s
.937 .276 .119 r
.46668 .62663 m .46416 .628 L .42936 .62298 L p F P
0 0 0 r
s
.937 .276 .119 r
.42936 .62298 m .43424 .62026 L .46668 .62663 L p F P
0 0 0 r
s
.302 .447 .869 r
.53332 .62663 m .53584 .628 L .57064 .62298 L p F P
0 0 0 r
s
.302 .447 .869 r
.57064 .62298 m .56576 .62026 L .53332 .62663 L p F P
0 0 0 r
s
.891 .261 .113 r
.43915 .61752 m .43424 .62026 L .40363 .61077 L p F P
0 0 0 r
s
.24 .35 .67 r
.42233 .61763 m
.42703 .62007 L
s
.891 .261 .113 r
.40363 .61077 m .41071 .60672 L .43915 .61752 L p F P
0 0 0 r
s
.306 .449 .868 r
.56085 .61752 m .56576 .62026 L .59637 .61077 L p F P
0 0 0 r
s
.83 .24 .1 r
.57297 .62007 m
.57767 .61763 L
s
.306 .449 .868 r
.59637 .61077 m .58929 .60672 L .56085 .61752 L p F P
0 0 0 r
s
.511 .142 .065 r
.38959 .47434 m .37481 .48393 L .37096 .46217 L p F P
0 0 0 r
s
.511 .142 .065 r
.37096 .46217 m .38617 .4521 L .38959 .47434 L p F P
0 0 0 r
s
.281 .394 .737 r
.61041 .47434 m .62519 .48393 L .62904 .46217 L p F P
0 0 0 r
s
.281 .394 .737 r
.62904 .46217 m .61383 .4521 L .61041 .47434 L p F P
0 0 0 r
s
.83 .24 .1 r
.53845 .28851 m
.55362 .28179 L
s
.55362 .28179 m
.58738 .25846 L
s
.24 .35 .67 r
.46155 .28851 m
.44638 .28179 L
s
.44638 .28179 m
.41262 .25846 L
s
1 .303 .129 r
.5 .62969 m .53324 .62937 L .53584 .628 L closepath p F P
0 0 0 r
s
.281 .425 .837 r
.5 .62969 m .46676 .62937 L .46416 .628 L closepath p F P
0 0 0 r
s
.843 .246 .107 r
.41784 .60264 m .41071 .60672 L .38472 .59319 L p F P
0 0 0 r
s
.24 .35 .67 r
.37897 .60584 m
.39893 .60545 L
s
.843 .246 .107 r
.38472 .59319 m .39381 .58785 L .41784 .60264 L p F P
0 0 0 r
s
.307 .447 .861 r
.58216 .60264 m .58929 .60672 L .61528 .59319 L p F P
0 0 0 r
s
.83 .24 .1 r
.60107 .60545 m
.62103 .60584 L
s
.307 .447 .861 r
.61528 .59319 m .60619 .58785 L .58216 .60264 L p F P
0 0 0 r
s
.15 .041 .019 r
.45055 .37053 m .43461 .3814 L .43781 .3667 L p F P
0 0 0 r
s
.15 .041 .019 r
.43781 .3667 m .45299 .35625 L .45055 .37053 L p F P
0 0 0 r
s
.202 .266 .472 r
.54945 .37053 m .56539 .3814 L .56219 .3667 L p F P
0 0 0 r
s
.202 .266 .472 r
.56219 .3667 m .54701 .35625 L .54945 .37053 L p F P
0 0 0 r
s
.83 .24 .1 r
.50158 .31564 m
.50545 .31139 L
s
.50545 .31139 m
.53845 .28851 L
s
.24 .35 .67 r
.49455 .31139 m
.49842 .31564 L
s
.49455 .31139 m
.46155 .28851 L
s
.83 .24 .1 r
.71485 .22934 m
.69445 .21696 L
s
.24 .35 .67 r
.28515 .22934 m
.30555 .21696 L
s
.083 .024 .01 r
.48408 .33484 m .46841 .34563 L .47084 .3362 L p F P
0 0 0 r
s
.083 .024 .01 r
.47084 .3362 m .48531 .32618 L .48408 .33484 L p F P
0 0 0 r
s
.157 .196 .347 r
.51592 .33484 m .53159 .34563 L .52916 .3362 L p F P
0 0 0 r
s
.157 .196 .347 r
.52916 .3362 m .51469 .32618 L .51592 .33484 L p F P
0 0 0 r
s
.98 .291 .125 r
.46416 .628 m .46668 .62663 L .5 .62969 L closepath p F P
0 0 0 r
s
.295 .44 .861 r
.53584 .628 m .53332 .62663 L .5 .62969 L closepath p F P
0 0 0 r
s
.937 .276 .119 r
.4692 .62525 m .46668 .62663 L .43424 .62026 L p F P
0 0 0 r
s
.937 .276 .119 r
.43424 .62026 m .43915 .61752 L .4692 .62525 L p F P
0 0 0 r
s
.302 .447 .869 r
.5308 .62525 m .53332 .62663 L .56576 .62026 L p F P
0 0 0 r
s
.302 .447 .869 r
.56576 .62026 m .56085 .61752 L .5308 .62525 L p F P
0 0 0 r
s
.791 .229 .101 r
.403 .58246 m .39381 .58785 L .37268 .57083 L p F P
0 0 0 r
s
.791 .229 .101 r
.37268 .57083 m .38357 .56426 L .403 .58246 L p F P
0 0 0 r
s
.306 .443 .849 r
.597 .58246 m .60619 .58785 L .62732 .57083 L p F P
0 0 0 r
s
.306 .443 .849 r
.62732 .57083 m .61643 .56426 L .597 .58246 L p F P
0 0 0 r
s
.98 .291 .125 r
.4974 .60988 m .5 .60846 L .5 .62969 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.49662 .62938 m
.49974 .62771 L
s
.83 .24 .1 r
.5 .62757 m
.50338 .62938 L
s
.98 .291 .125 r
.4948 .61129 m .4974 .60988 L .5 .62969 L closepath p F P
0 0 0 r
s
.98 .291 .125 r
.49221 .6127 m .4948 .61129 L .5 .62969 L closepath p F P
0 0 0 r
s
.98 .291 .125 r
.48963 .61411 m .49221 .6127 L .5 .62969 L closepath p F P
0 0 0 r
s
.98 .291 .125 r
.48705 .61552 m .48963 .61411 L .5 .62969 L closepath p F P
0 0 0 r
s
.98 .291 .125 r
.48448 .61692 m .48705 .61552 L .5 .62969 L closepath p F P
0 0 0 r
s
.98 .291 .125 r
.48192 .61832 m .48448 .61692 L .5 .62969 L closepath p F P
0 0 0 r
s
.98 .291 .125 r
.47936 .61971 m .48192 .61832 L .5 .62969 L closepath p F P
0 0 0 r
s
.98 .291 .125 r
.47681 .6211 m .47936 .61971 L .5 .62969 L closepath p F P
0 0 0 r
s
.98 .291 .125 r
.47427 .62249 m .47681 .6211 L .5 .62969 L closepath p F P
0 0 0 r
s
.98 .291 .125 r
.47173 .62387 m .47427 .62249 L .5 .62969 L closepath p F P
0 0 0 r
s
.98 .291 .125 r
.4692 .62525 m .47173 .62387 L .5 .62969 L closepath p F P
0 0 0 r
s
.98 .291 .125 r
.46668 .62663 m .4692 .62525 L .5 .62969 L closepath p F P
0 0 0 r
s
.295 .44 .861 r
.5026 .60988 m .5 .60846 L .5 .62969 L closepath p F P
0 0 0 r
s
.295 .44 .861 r
.5052 .61129 m .5026 .60988 L .5 .62969 L closepath p F P
0 0 0 r
s
.295 .44 .861 r
.50779 .6127 m .5052 .61129 L .5 .62969 L closepath p F P
0 0 0 r
s
.295 .44 .861 r
.51037 .61411 m .50779 .6127 L .5 .62969 L closepath p F P
0 0 0 r
s
.295 .44 .861 r
.51295 .61552 m .51037 .61411 L .5 .62969 L closepath p F P
0 0 0 r
s
.295 .44 .861 r
.51552 .61692 m .51295 .61552 L .5 .62969 L closepath p F P
0 0 0 r
s
.295 .44 .861 r
.51808 .61832 m .51552 .61692 L .5 .62969 L closepath p F P
0 0 0 r
s
.295 .44 .861 r
.52064 .61971 m .51808 .61832 L .5 .62969 L closepath p F P
0 0 0 r
s
.295 .44 .861 r
.52319 .6211 m .52064 .61971 L .5 .62969 L closepath p F P
0 0 0 r
s
.295 .44 .861 r
.52573 .62249 m .52319 .6211 L .5 .62969 L closepath p F P
0 0 0 r
s
.295 .44 .861 r
.52827 .62387 m .52573 .62249 L .5 .62969 L closepath p F P
0 0 0 r
s
.295 .44 .861 r
.5308 .62525 m .52827 .62387 L .5 .62969 L closepath p F P
0 0 0 r
s
.295 .44 .861 r
.53332 .62663 m .5308 .62525 L .5 .62969 L closepath p F P
0 0 0 r
s
.891 .261 .113 r
.44407 .61477 m .43915 .61752 L .41071 .60672 L p F P
0 0 0 r
s
.891 .261 .113 r
.41071 .60672 m .41784 .60264 L .44407 .61477 L p F P
0 0 0 r
s
.306 .449 .868 r
.55593 .61477 m .56085 .61752 L .58929 .60672 L p F P
0 0 0 r
s
.306 .449 .868 r
.58929 .60672 m .58216 .60264 L .55593 .61477 L p F P
0 0 0 r
s
.735 .211 .094 r
.3946 .55761 m .38357 .56426 L .36732 .5445 L p F P
0 0 0 r
s
.735 .211 .094 r
.36732 .5445 m .37979 .53678 L .3946 .55761 L p F P
0 0 0 r
s
.303 .436 .831 r
.6054 .55761 m .61643 .56426 L .63268 .5445 L p F P
0 0 0 r
s
.303 .436 .831 r
.63268 .5445 m .62021 .53678 L .6054 .55761 L p F P
0 0 0 r
s
.937 .276 .119 r
.47173 .62387 m .4692 .62525 L .43915 .61752 L p F P
0 0 0 r
s
.24 .35 .67 r
.441 .62068 m
.44337 .61998 L
s
.302 .447 .869 r
.52827 .62387 m .5308 .62525 L .56085 .61752 L p F P
0 0 0 r
s
.83 .24 .1 r
.55663 .61998 m
.559 .62068 L
s
.937 .276 .119 r
.43915 .61752 m .44407 .61477 L .47173 .62387 L p F P
0 0 0 r
s
.302 .447 .869 r
.56085 .61752 m .55593 .61477 L .52827 .62387 L p F P
0 0 0 r
s
.276 .072 .035 r
.43307 .39961 m .41704 .4104 L .41892 .3921 L p F P
0 0 0 r
s
.83 .24 .1 r
.41793 .41137 m
.41819 .40963 L
s
.4207 .39304 m
.42106 .39064 L
s
.276 .072 .035 r
.41892 .3921 m .43461 .3814 L .43307 .39961 L p F P
0 0 0 r
s
.24 .327 .596 r
.56693 .39961 m .58296 .4104 L .58108 .3921 L p F P
0 0 0 r
s
.24 .35 .67 r
.57894 .39064 m
.5793 .39304 L
s
.58181 .40963 m
.58207 .41137 L
s
.24 .327 .596 r
.58108 .3921 m .56539 .3814 L .56693 .39961 L p F P
0 0 0 r
s
.843 .246 .107 r
.42503 .59853 m .41784 .60264 L .39381 .58785 L p F P
0 0 0 r
s
.843 .246 .107 r
.39381 .58785 m .403 .58246 L .42503 .59853 L p F P
0 0 0 r
s
.307 .447 .861 r
.57497 .59853 m .58216 .60264 L .60619 .58785 L p F P
0 0 0 r
s
.307 .447 .861 r
.60619 .58785 m .597 .58246 L .57497 .59853 L p F P
0 0 0 r
s
.937 .276 .119 r
.47427 .62249 m .47173 .62387 L .44407 .61477 L p F P
0 0 0 r
s
.302 .447 .869 r
.52573 .62249 m .52827 .62387 L .55593 .61477 L p F P
0 0 0 r
s
.672 .192 .086 r
.39242 .52897 m .37979 .53678 L .36824 .51516 L p F P
0 0 0 r
s
.672 .192 .086 r
.36824 .51516 m .38201 .50642 L .39242 .52897 L p F P
0 0 0 r
s
.299 .426 .808 r
.60758 .52897 m .62021 .53678 L .63176 .51516 L p F P
0 0 0 r
s
.299 .426 .808 r
.63176 .51516 m .61799 .50642 L .60758 .52897 L p F P
0 0 0 r
s
.937 .276 .119 r
.47681 .6211 m .47427 .62249 L .44903 .61201 L p F P
0 0 0 r
s
.937 .276 .119 r
.44407 .61477 m .44903 .61201 L .47427 .62249 L p F P
0 0 0 r
s
.302 .447 .869 r
.52319 .6211 m .52573 .62249 L .55097 .61201 L p F P
0 0 0 r
s
.302 .447 .869 r
.55593 .61477 m .55097 .61201 L .52573 .62249 L p F P
0 0 0 r
s
.891 .261 .113 r
.44903 .61201 m .44407 .61477 L .41784 .60264 L p F P
0 0 0 r
s
.891 .261 .113 r
.41784 .60264 m .42503 .59853 L .44903 .61201 L p F P
0 0 0 r
s
.24 .35 .67 r
.39893 .60545 m
.42233 .61763 L
s
.306 .449 .868 r
.55097 .61201 m .55593 .61477 L .58216 .60264 L p F P
0 0 0 r
s
.306 .449 .868 r
.58216 .60264 m .57497 .59853 L .55097 .61201 L p F P
0 0 0 r
s
.83 .24 .1 r
.57767 .61763 m
.60107 .60545 L
s
.4 .107 .051 r
.41734 .43146 m .40162 .44186 L .40127 .42102 L p F P
0 0 0 r
s
.4 .107 .051 r
.40127 .42102 m .41704 .4104 L .41734 .43146 L p F P
0 0 0 r
s
.83 .24 .1 r
.41706 .41195 m
.41793 .41137 L
s
.265 .367 .679 r
.58266 .43146 m .59838 .44186 L .59873 .42102 L p F P
0 0 0 r
s
.265 .367 .679 r
.59873 .42102 m .58296 .4104 L .58266 .43146 L p F P
0 0 0 r
s
.24 .35 .67 r
.58207 .41137 m
.58294 .41195 L
s
.599 .169 .076 r
.39599 .49755 m .38201 .50642 L .37481 .48393 L p F P
0 0 0 r
s
.599 .169 .076 r
.37481 .48393 m .38959 .47434 L .39599 .49755 L p F P
0 0 0 r
s
.291 .413 .778 r
.60401 .49755 m .61799 .50642 L .62519 .48393 L p F P
0 0 0 r
s
.291 .413 .778 r
.62519 .48393 m .61041 .47434 L .60401 .49755 L p F P
0 0 0 r
s
.511 .142 .065 r
.4046 .46459 m .38959 .47434 L .38617 .4521 L p F P
0 0 0 r
s
.83 .24 .1 r
.3878 .45102 m
.38789 .45327 L
s
.511 .142 .065 r
.38617 .4521 m .40162 .44186 L .4046 .46459 L p F P
0 0 0 r
s
.281 .394 .737 r
.5954 .46459 m .61041 .47434 L .61383 .4521 L p F P
0 0 0 r
s
.24 .35 .67 r
.61211 .45327 m
.6122 .45102 L
s
.281 .394 .737 r
.61383 .4521 m .59838 .44186 L .5954 .46459 L p F P
0 0 0 r
s
.791 .229 .101 r
.41227 .57701 m .403 .58246 L .38357 .56426 L p F P
0 0 0 r
s
.791 .229 .101 r
.38357 .56426 m .3946 .55761 L .41227 .57701 L p F P
0 0 0 r
s
.306 .443 .849 r
.58773 .57701 m .597 .58246 L .61643 .56426 L p F P
0 0 0 r
s
.306 .443 .849 r
.61643 .56426 m .6054 .55761 L .58773 .57701 L p F P
0 0 0 r
s
.937 .276 .119 r
.47936 .61971 m .47681 .6211 L .45401 .60923 L p F P
0 0 0 r
s
.937 .276 .119 r
.44903 .61201 m .45401 .60923 L .47681 .6211 L p F P
0 0 0 r
s
.302 .447 .869 r
.52064 .61971 m .52319 .6211 L .54599 .60923 L p F P
0 0 0 r
s
.302 .447 .869 r
.55097 .61201 m .54599 .60923 L .52319 .6211 L p F P
0 0 0 r
s
.15 .041 .019 r
.46675 .35947 m .45055 .37053 L .45299 .35625 L p F P
0 0 0 r
s
.15 .041 .019 r
.45299 .35625 m .46841 .34563 L .46675 .35947 L p F P
0 0 0 r
s
.202 .266 .472 r
.53325 .35947 m .54945 .37053 L .54701 .35625 L p F P
0 0 0 r
s
.202 .266 .472 r
.54701 .35625 m .53159 .34563 L .53325 .35947 L p F P
0 0 0 r
s
.083 .024 .01 r
.5 .32387 m .48408 .33484 L .48531 .32618 L p F P
0 0 0 r
s
.083 .024 .01 r
.48531 .32618 m .5 .316 L .5 .32387 L p F P
0 0 0 r
s
.83 .24 .1 r
.5 .31738 m
.50077 .31654 L
s
.157 .196 .347 r
.5 .32387 m .51592 .33484 L .51469 .32618 L p F P
0 0 0 r
s
.157 .196 .347 r
.51469 .32618 m .5 .316 L .5 .32387 L p F P
0 0 0 r
s
.937 .276 .119 r
.48192 .61832 m .47936 .61971 L .45901 .60644 L p F P
0 0 0 r
s
.937 .276 .119 r
.45401 .60923 m .45901 .60644 L .47936 .61971 L p F P
0 0 0 r
s
.24 .35 .67 r
.44337 .61998 m
.45529 .61645 L
s
.302 .447 .869 r
.51808 .61832 m .52064 .61971 L .54099 .60644 L p F P
0 0 0 r
s
.302 .447 .869 r
.54599 .60923 m .54099 .60644 L .52064 .61971 L p F P
0 0 0 r
s
.83 .24 .1 r
.54471 .61645 m
.55663 .61998 L
s
.891 .261 .113 r
.45401 .60923 m .44903 .61201 L .42503 .59853 L p F P
0 0 0 r
s
.306 .449 .868 r
.54599 .60923 m .55097 .61201 L .57497 .59853 L p F P
0 0 0 r
s
.843 .246 .107 r
.43227 .59439 m .42503 .59853 L .403 .58246 L p F P
0 0 0 r
s
.843 .246 .107 r
.403 .58246 m .41227 .57701 L .43227 .59439 L p F P
0 0 0 r
s
.307 .447 .861 r
.56773 .59439 m .57497 .59853 L .597 .58246 L p F P
0 0 0 r
s
.307 .447 .861 r
.597 .58246 m .58773 .57701 L .56773 .59439 L p F P
0 0 0 r
s
.735 .211 .094 r
.40575 .55089 m .3946 .55761 L .37979 .53678 L p F P
0 0 0 r
s
.735 .211 .094 r
.37979 .53678 m .39242 .52897 L .40575 .55089 L p F P
0 0 0 r
s
.303 .436 .831 r
.59425 .55089 m .6054 .55761 L .62021 .53678 L p F P
0 0 0 r
s
.303 .436 .831 r
.62021 .53678 m .60758 .52897 L .59425 .55089 L p F P
0 0 0 r
s
.937 .276 .119 r
.48448 .61692 m .48192 .61832 L .46404 .60363 L p F P
0 0 0 r
s
.937 .276 .119 r
.45901 .60644 m .46404 .60363 L .48192 .61832 L p F P
0 0 0 r
s
.24 .35 .67 r
.45529 .61645 m
.46863 .62351 L
s
.302 .447 .869 r
.51552 .61692 m .51808 .61832 L .53596 .60363 L p F P
0 0 0 r
s
.302 .447 .869 r
.54099 .60644 m .53596 .60363 L .51808 .61832 L p F P
0 0 0 r
s
.83 .24 .1 r
.53137 .62351 m
.54471 .61645 L
s
.891 .261 .113 r
.42503 .59853 m .43227 .59439 L .45401 .60923 L p F P
0 0 0 r
s
.306 .449 .868 r
.57497 .59853 m .56773 .59439 L .54599 .60923 L p F P
0 0 0 r
s
.83 .24 .1 r
.80099 .49768 m
.83931 .47767 L
s
.80099 .49768 m
.79405 .5142 L
s
.24 .35 .67 r
.19901 .49768 m
.16069 .47767 L
s
.19901 .49768 m
.20595 .5142 L
s
.83 .24 .1 r
.54471 .61645 m
.54689 .6153 L
s
.24 .35 .67 r
.45311 .6153 m
.45529 .61645 L
s
.937 .276 .119 r
.48705 .61552 m .48448 .61692 L .4691 .60081 L p F P
0 0 0 r
s
.937 .276 .119 r
.46404 .60363 m .4691 .60081 L .48448 .61692 L p F P
0 0 0 r
s
.83 .24 .1 r
.46443 .60251 m
.4651 .60304 L
s
.302 .447 .869 r
.51295 .61552 m .51552 .61692 L .5309 .60081 L p F P
0 0 0 r
s
.302 .447 .869 r
.53596 .60363 m .5309 .60081 L .51552 .61692 L p F P
0 0 0 r
s
.24 .35 .67 r
.5349 .60304 m
.53557 .60251 L
s
.891 .261 .113 r
.45901 .60644 m .45401 .60923 L .43227 .59439 L p F P
0 0 0 r
s
.306 .449 .868 r
.54099 .60644 m .54599 .60923 L .56773 .59439 L p F P
0 0 0 r
s
.83 .24 .1 r
.83931 .47767 m
.84132 .45669 L
s
.24 .35 .67 r
.16069 .47767 m
.15868 .45669 L
s
.83 .24 .1 r
.75645 .53361 m
.79405 .5142 L
s
.75645 .53361 m
.74473 .54493 L
s
.24 .35 .67 r
.24355 .53361 m
.20595 .5142 L
s
.24355 .53361 m
.25527 .54493 L
s
.276 .072 .035 r
.44938 .38863 m .43307 .39961 L .43461 .3814 L p F P
0 0 0 r
s
.276 .072 .035 r
.43461 .3814 m .45055 .37053 L .44938 .38863 L p F P
0 0 0 r
s
.24 .327 .596 r
.55062 .38863 m .56693 .39961 L .56539 .3814 L p F P
0 0 0 r
s
.24 .327 .596 r
.56539 .3814 m .54945 .37053 L .55062 .38863 L p F P
0 0 0 r
s
.672 .192 .086 r
.40522 .52104 m .39242 .52897 L .38201 .50642 L p F P
0 0 0 r
s
.672 .192 .086 r
.38201 .50642 m .39599 .49755 L .40522 .52104 L p F P
0 0 0 r
s
.299 .426 .808 r
.59478 .52104 m .60758 .52897 L .61799 .50642 L p F P
0 0 0 r
s
.299 .426 .808 r
.61799 .50642 m .60401 .49755 L .59478 .52104 L p F P
0 0 0 r
s
.937 .276 .119 r
.48963 .61411 m .48705 .61552 L .47418 .59797 L p F P
0 0 0 r
s
.937 .276 .119 r
.4691 .60081 m .47418 .59797 L .48705 .61552 L p F P
0 0 0 r
s
.302 .447 .869 r
.51037 .61411 m .51295 .61552 L .52582 .59797 L p F P
0 0 0 r
s
.302 .447 .869 r
.5309 .60081 m .52582 .59797 L .51295 .61552 L p F P
0 0 0 r
s
.83 .24 .1 r
.7079 .56386 m
.74473 .54493 L
s
.7079 .56386 m
.69182 .56936 L
s
.24 .35 .67 r
.2921 .56386 m
.25527 .54493 L
s
.2921 .56386 m
.30818 .56936 L
s
.791 .229 .101 r
.42163 .57152 m .41227 .57701 L .3946 .55761 L p F P
0 0 0 r
s
.791 .229 .101 r
.3946 .55761 m .40575 .55089 L .42163 .57152 L p F P
0 0 0 r
s
.306 .443 .849 r
.57837 .57152 m .58773 .57701 L .6054 .55761 L p F P
0 0 0 r
s
.306 .443 .849 r
.6054 .55761 m .59425 .55089 L .57837 .57152 L p F P
0 0 0 r
s
.83 .24 .1 r
.60107 .60545 m
.63612 .58721 L
s
.57874 .59844 m
.60107 .60545 L
s
.24 .35 .67 r
.39893 .60545 m
.36388 .58721 L
s
.39893 .60545 m
.42126 .59844 L
s
.83 .24 .1 r
.65584 .5879 m
.69182 .56936 L
s
.65584 .5879 m
.63612 .58721 L
s
.24 .35 .67 r
.34416 .5879 m
.30818 .56936 L
s
.34416 .5879 m
.36388 .58721 L
s
.891 .261 .113 r
.43227 .59439 m .43957 .59022 L .45901 .60644 L p F P
0 0 0 r
s
.843 .246 .107 r
.43957 .59022 m .43227 .59439 L .41227 .57701 L p F P
0 0 0 r
s
.306 .449 .868 r
.56773 .59439 m .56043 .59022 L .54099 .60644 L p F P
0 0 0 r
s
.307 .447 .861 r
.56043 .59022 m .56773 .59439 L .58773 .57701 L p F P
0 0 0 r
s
.937 .276 .119 r
.49221 .6127 m .48963 .61411 L .47929 .59512 L p F P
0 0 0 r
s
.937 .276 .119 r
.47418 .59797 m .47929 .59512 L .48963 .61411 L p F P
0 0 0 r
s
.302 .447 .869 r
.50779 .6127 m .51037 .61411 L .52071 .59512 L p F P
0 0 0 r
s
.302 .447 .869 r
.52582 .59797 m .52071 .59512 L .51037 .61411 L p F P
0 0 0 r
s
.891 .261 .113 r
.46404 .60363 m .45901 .60644 L .43957 .59022 L p F P
0 0 0 r
s
.83 .24 .1 r
.46323 .60318 m
.46443 .60251 L
s
.306 .449 .868 r
.53596 .60363 m .54099 .60644 L .56043 .59022 L p F P
0 0 0 r
s
.24 .35 .67 r
.53557 .60251 m
.53677 .60318 L
s
.843 .246 .107 r
.41227 .57701 m .42163 .57152 L .43957 .59022 L p F P
0 0 0 r
s
.307 .447 .861 r
.58773 .57701 m .57837 .57152 L .56043 .59022 L p F P
0 0 0 r
s
.599 .169 .076 r
.41017 .48855 m .39599 .49755 L .38959 .47434 L p F P
0 0 0 r
s
.83 .24 .1 r
.39111 .47335 m
.39163 .47575 L
s
.599 .169 .076 r
.38959 .47434 m .4046 .46459 L .41017 .48855 L p F P
0 0 0 r
s
.291 .413 .778 r
.58983 .48855 m .60401 .49755 L .61041 .47434 L p F P
0 0 0 r
s
.24 .35 .67 r
.60837 .47575 m
.60889 .47335 L
s
.291 .413 .778 r
.61041 .47434 m .5954 .46459 L .58983 .48855 L p F P
0 0 0 r
s
.83 .24 .1 r
.62227 .23433 m
.6396 .23463 L
s
.6396 .23463 m
.67534 .21012 L
s
.24 .35 .67 r
.37773 .23433 m
.3604 .23463 L
s
.3604 .23463 m
.32466 .21012 L
s
.4 .107 .051 r
.43331 .42088 m .41734 .43146 L .41704 .4104 L p F P
0 0 0 r
s
.4 .107 .051 r
.41704 .4104 m .43307 .39961 L .43331 .42088 L p F P
0 0 0 r
s
.265 .367 .679 r
.56669 .42088 m .58266 .43146 L .58296 .4104 L p F P
0 0 0 r
s
.265 .367 .679 r
.58296 .4104 m .56693 .39961 L .56669 .42088 L p F P
0 0 0 r
s
.83 .24 .1 r
.69445 .21696 m
.67534 .21012 L
s
.24 .35 .67 r
.30555 .21696 m
.32466 .21012 L
s
.937 .276 .119 r
.4948 .61129 m .49221 .6127 L .48443 .59226 L p F P
0 0 0 r
s
.937 .276 .119 r
.47929 .59512 m .48443 .59226 L .49221 .6127 L p F P
0 0 0 r
s
.302 .447 .869 r
.5052 .61129 m .50779 .6127 L .51557 .59226 L p F P
0 0 0 r
s
.302 .447 .869 r
.52071 .59512 m .51557 .59226 L .50779 .6127 L p F P
0 0 0 r
s
.511 .142 .065 r
.41986 .45469 m .4046 .46459 L .40162 .44186 L p F P
0 0 0 r
s
.511 .142 .065 r
.40162 .44186 m .41734 .43146 L .41986 .45469 L p F P
0 0 0 r
s
.281 .394 .737 r
.58014 .45469 m .5954 .46459 L .59838 .44186 L p F P
0 0 0 r
s
.281 .394 .737 r
.59838 .44186 m .58266 .43146 L .58014 .45469 L p F P
0 0 0 r
s
.83 .24 .1 r
.57256 .26487 m
.58738 .25846 L
s
.58738 .25846 m
.62227 .23433 L
s
.24 .35 .67 r
.42744 .26487 m
.41262 .25846 L
s
.41262 .25846 m
.37773 .23433 L
s
.15 .041 .019 r
.48324 .34822 m .46675 .35947 L .46841 .34563 L p F P
0 0 0 r
s
.15 .041 .019 r
.46841 .34563 m .48408 .33484 L .48324 .34822 L p F P
0 0 0 r
s
.202 .266 .472 r
.51676 .34822 m .53325 .35947 L .53159 .34563 L p F P
0 0 0 r
s
.202 .266 .472 r
.53159 .34563 m .51592 .33484 L .51676 .34822 L p F P
0 0 0 r
s
.83 .24 .1 r
.52687 .30147 m
.53845 .28851 L
s
.53845 .28851 m
.57256 .26487 L
s
.24 .35 .67 r
.47313 .30147 m
.46155 .28851 L
s
.46155 .28851 m
.42744 .26487 L
s
.937 .276 .119 r
.4974 .60988 m .4948 .61129 L .48959 .58938 L p F P
0 0 0 r
s
.937 .276 .119 r
.48443 .59226 m .48959 .58938 L .4948 .61129 L p F P
0 0 0 r
s
.24 .35 .67 r
.47899 .60333 m
.48922 .60888 L
s
.302 .447 .869 r
.5026 .60988 m .5052 .61129 L .51041 .58938 L p F P
0 0 0 r
s
.302 .447 .869 r
.51557 .59226 m .51041 .58938 L .5052 .61129 L p F P
0 0 0 r
s
.83 .24 .1 r
.51078 .60888 m
.52101 .60333 L
s
.735 .211 .094 r
.41704 .54408 m .40575 .55089 L .39242 .52897 L p F P
0 0 0 r
s
.735 .211 .094 r
.39242 .52897 m .40522 .52104 L .41704 .54408 L p F P
0 0 0 r
s
.303 .436 .831 r
.58296 .54408 m .59425 .55089 L .60758 .52897 L p F P
0 0 0 r
s
.303 .436 .831 r
.60758 .52897 m .59478 .52104 L .58296 .54408 L p F P
0 0 0 r
s
.891 .261 .113 r
.4691 .60081 m .46404 .60363 L .44692 .58601 L p F P
0 0 0 r
s
.891 .261 .113 r
.43957 .59022 m .44692 .58601 L .46404 .60363 L p F P
0 0 0 r
s
.24 .35 .67 r
.45529 .61645 m
.47899 .60333 L
s
.306 .449 .868 r
.5309 .60081 m .53596 .60363 L .55308 .58601 L p F P
0 0 0 r
s
.306 .449 .868 r
.56043 .59022 m .55308 .58601 L .53596 .60363 L p F P
0 0 0 r
s
.83 .24 .1 r
.52101 .60333 m
.54471 .61645 L
s
.50092 .31939 m
.52687 .30147 L
s
.24 .35 .67 r
.47313 .30147 m
.49908 .31939 L
s
.843 .246 .107 r
.44692 .58601 m .43957 .59022 L .42163 .57152 L p F P
0 0 0 r
s
.307 .447 .861 r
.55308 .58601 m .56043 .59022 L .57837 .57152 L p F P
0 0 0 r
s
.937 .276 .119 r
.5 .60846 m .4974 .60988 L .49478 .58648 L p F P
0 0 0 r
s
.937 .276 .119 r
.48959 .58938 m .49478 .58648 L .4974 .60988 L p F P
0 0 0 r
s
.24 .35 .67 r
.48922 .60888 m
.49233 .61056 L
s
.302 .447 .869 r
.5 .60846 m .5026 .60988 L .50522 .58648 L p F P
0 0 0 r
s
.302 .447 .869 r
.51041 .58938 m .50522 .58648 L .5026 .60988 L p F P
0 0 0 r
s
.83 .24 .1 r
.50767 .61056 m
.51078 .60888 L
s
.791 .229 .101 r
.43109 .56596 m .42163 .57152 L .40575 .55089 L p F P
0 0 0 r
s
.791 .229 .101 r
.40575 .55089 m .41704 .54408 L .43109 .56596 L p F P
0 0 0 r
s
.83 .24 .1 r
.42171 .55136 m
.42235 .55098 L
s
.306 .443 .849 r
.56891 .56596 m .57837 .57152 L .59425 .55089 L p F P
0 0 0 r
s
.306 .443 .849 r
.59425 .55089 m .58296 .54408 L .56891 .56596 L p F P
0 0 0 r
s
.24 .35 .67 r
.57765 .55098 m
.57829 .55136 L
s
.937 .276 .119 r
.49478 .58648 m .5 .58357 L .5 .60846 L p F P
0 0 0 r
s
.302 .447 .869 r
.50522 .58648 m .5 .58357 L .5 .60846 L p F P
0 0 0 r
s
.843 .246 .107 r
.42163 .57152 m .43109 .56596 L .44692 .58601 L p F P
0 0 0 r
s
.307 .447 .861 r
.57837 .57152 m .56891 .56596 L .55308 .58601 L p F P
0 0 0 r
s
.891 .261 .113 r
.47418 .59797 m .4691 .60081 L .45433 .58178 L p F P
0 0 0 r
s
.83 .24 .1 r
.46836 .60032 m
.46861 .60018 L
s
.891 .261 .113 r
.44692 .58601 m .45433 .58178 L .4691 .60081 L p F P
0 0 0 r
s
.24 .35 .67 r
.42126 .59844 m
.45311 .6153 L
s
.306 .449 .868 r
.52582 .59797 m .5309 .60081 L .54567 .58178 L p F P
0 0 0 r
s
.24 .35 .67 r
.53139 .60018 m
.53164 .60032 L
s
.306 .449 .868 r
.55308 .58601 m .54567 .58178 L .5309 .60081 L p F P
0 0 0 r
s
.83 .24 .1 r
.54689 .6153 m
.57874 .59844 L
s
.672 .192 .086 r
.41821 .513 m .40522 .52104 L .39599 .49755 L p F P
0 0 0 r
s
.83 .24 .1 r
.39725 .49675 m
.3981 .49902 L
s
.40613 .52048 m
.40625 .52081 L
s
.40538 .52135 m
.40625 .52081 L
s
.672 .192 .086 r
.39599 .49755 m .41017 .48855 L .41821 .513 L p F P
0 0 0 r
s
.299 .426 .808 r
.58179 .513 m .59478 .52104 L .60401 .49755 L p F P
0 0 0 r
s
.24 .35 .67 r
.59375 .52081 m
.59387 .52048 L
s
.6019 .49902 m
.60275 .49675 L
s
.59375 .52081 m
.59462 .52135 L
s
.299 .426 .808 r
.60401 .49755 m .58983 .48855 L .58179 .513 L p F P
0 0 0 r
s
.276 .072 .035 r
.46596 .37747 m .44938 .38863 L .45055 .37053 L p F P
0 0 0 r
s
.83 .24 .1 r
.44993 .38985 m
.45017 .3881 L
s
.45241 .37136 m
.45272 .36904 L
s
.276 .072 .035 r
.45055 .37053 m .46675 .35947 L .46596 .37747 L p F P
0 0 0 r
s
.24 .327 .596 r
.53404 .37747 m .55062 .38863 L .54945 .37053 L p F P
0 0 0 r
s
.24 .35 .67 r
.54728 .36904 m
.54759 .37136 L
s
.54983 .3881 m
.55007 .38985 L
s
.24 .327 .596 r
.54945 .37053 m .53325 .35947 L .53404 .37747 L p F P
0 0 0 r
s
.843 .246 .107 r
.45433 .58178 m .44692 .58601 L .43109 .56596 L p F P
0 0 0 r
s
.307 .447 .861 r
.54567 .58178 m .55308 .58601 L .56891 .56596 L p F P
0 0 0 r
s
.83 .24 .1 r
.42235 .55098 m
.43485 .56852 L
s
.24 .35 .67 r
.56515 .56852 m
.57765 .55098 L
s
.891 .261 .113 r
.47929 .59512 m .47418 .59797 L .46179 .57751 L p F P
0 0 0 r
s
.83 .24 .1 r
.47352 .59744 m
.47377 .5973 L
s
.891 .261 .113 r
.45433 .58178 m .46179 .57751 L .47418 .59797 L p F P
0 0 0 r
s
.306 .449 .868 r
.52071 .59512 m .52582 .59797 L .53821 .57751 L p F P
0 0 0 r
s
.24 .35 .67 r
.52623 .5973 m
.52648 .59744 L
s
.306 .449 .868 r
.54567 .58178 m .53821 .57751 L .52582 .59797 L p F P
0 0 0 r
s
.599 .169 .076 r
.42458 .47941 m .41017 .48855 L .4046 .46459 L p F P
0 0 0 r
s
.599 .169 .076 r
.4046 .46459 m .41986 .45469 L .42458 .47941 L p F P
0 0 0 r
s
.291 .413 .778 r
.57542 .47941 m .58983 .48855 L .5954 .46459 L p F P
0 0 0 r
s
.291 .413 .778 r
.5954 .46459 m .58014 .45469 L .57542 .47941 L p F P
0 0 0 r
s
.4 .107 .051 r
.44956 .41012 m .43331 .42088 L .43307 .39961 L p F P
0 0 0 r
s
.4 .107 .051 r
.43307 .39961 m .44938 .38863 L .44956 .41012 L p F P
0 0 0 r
s
.83 .24 .1 r
.44939 .39021 m
.44993 .38985 L
s
.265 .367 .679 r
.55044 .41012 m .56669 .42088 L .56693 .39961 L p F P
0 0 0 r
s
.265 .367 .679 r
.56693 .39961 m .55062 .38863 L .55044 .41012 L p F P
0 0 0 r
s
.24 .35 .67 r
.55007 .38985 m
.55061 .39021 L
s
.83 .24 .1 r
.52101 .60333 m
.5232 .60214 L
s
.50604 .59125 m
.50855 .59328 L
s
.24 .35 .67 r
.4768 .60214 m
.47899 .60333 L
s
.49145 .59328 m
.49396 .59125 L
s
.735 .211 .094 r
.42847 .53719 m .41704 .54408 L .40522 .52104 L p F P
0 0 0 r
s
.83 .24 .1 r
.40625 .52081 m
.40705 .52231 L
s
.41827 .54334 m
.42235 .55098 L
s
.735 .211 .094 r
.40522 .52104 m .41821 .513 L .42847 .53719 L p F P
0 0 0 r
s
.303 .436 .831 r
.57153 .53719 m .58296 .54408 L .59478 .52104 L p F P
0 0 0 r
s
.24 .35 .67 r
.57765 .55098 m
.58173 .54334 L
s
.59295 .52231 m
.59375 .52081 L
s
.303 .436 .831 r
.59478 .52104 m .58179 .513 L .57153 .53719 L p F P
0 0 0 r
s
.511 .142 .065 r
.43537 .44463 m .41986 .45469 L .41734 .43146 L p F P
0 0 0 r
s
.83 .24 .1 r
.41901 .43035 m
.41915 .43279 L
s
.511 .142 .065 r
.41734 .43146 m .43331 .42088 L .43537 .44463 L p F P
0 0 0 r
s
.281 .394 .737 r
.56463 .44463 m .58014 .45469 L .58266 .43146 L p F P
0 0 0 r
s
.24 .35 .67 r
.58085 .43279 m
.58099 .43035 L
s
.281 .394 .737 r
.58266 .43146 m .56669 .42088 L .56463 .44463 L p F P
0 0 0 r
s
.15 .041 .019 r
.5 .33679 m .48324 .34822 L .48408 .33484 L p F P
0 0 0 r
s
.15 .041 .019 r
.48408 .33484 m .5 .32387 L .5 .33679 L p F P
0 0 0 r
s
.202 .266 .472 r
.5 .33679 m .51676 .34822 L .51592 .33484 L p F P
0 0 0 r
s
.202 .266 .472 r
.51592 .33484 m .5 .32387 L .5 .33679 L p F P
0 0 0 r
s
.843 .246 .107 r
.43109 .56596 m .44064 .56036 L .45433 .58178 L p F P
0 0 0 r
s
.791 .229 .101 r
.44064 .56036 m .43109 .56596 L .41704 .54408 L p F P
0 0 0 r
s
.307 .447 .861 r
.56891 .56596 m .55936 .56036 L .54567 .58178 L p F P
0 0 0 r
s
.306 .443 .849 r
.55936 .56036 m .56891 .56596 L .58296 .54408 L p F P
0 0 0 r
s
.891 .261 .113 r
.48443 .59226 m .47929 .59512 L .46932 .5732 L p F P
0 0 0 r
s
.83 .24 .1 r
.47871 .59454 m
.47896 .5944 L
s
.891 .261 .113 r
.46179 .57751 m .46932 .5732 L .47929 .59512 L p F P
0 0 0 r
s
.24 .35 .67 r
.47899 .60333 m
.49145 .59328 L
s
.306 .449 .868 r
.51557 .59226 m .52071 .59512 L .53068 .5732 L p F P
0 0 0 r
s
.24 .35 .67 r
.52104 .5944 m
.52129 .59454 L
s
.306 .449 .868 r
.53821 .57751 m .53068 .5732 L .52071 .59512 L p F P
0 0 0 r
s
.83 .24 .1 r
.50855 .59328 m
.52101 .60333 L
s
.791 .229 .101 r
.41704 .54408 m .42847 .53719 L .44064 .56036 L p F P
0 0 0 r
s
.306 .443 .849 r
.58296 .54408 m .57153 .53719 L .55936 .56036 L p F P
0 0 0 r
s
.843 .246 .107 r
.46179 .57751 m .45433 .58178 L .44064 .56036 L p F P
0 0 0 r
s
.307 .447 .861 r
.53821 .57751 m .54567 .58178 L .55936 .56036 L p F P
0 0 0 r
s
.891 .261 .113 r
.48959 .58938 m .48443 .59226 L .4769 .56887 L p F P
0 0 0 r
s
.83 .24 .1 r
.48393 .59163 m
.48418 .59149 L
s
.891 .261 .113 r
.46932 .5732 m .4769 .56887 L .48443 .59226 L p F P
0 0 0 r
s
.24 .35 .67 r
.44494 .58487 m
.4768 .60214 L
s
.306 .449 .868 r
.51041 .58938 m .51557 .59226 L .5231 .56887 L p F P
0 0 0 r
s
.24 .35 .67 r
.51582 .59149 m
.51607 .59163 L
s
.306 .449 .868 r
.53068 .5732 m .5231 .56887 L .51557 .59226 L p F P
0 0 0 r
s
.83 .24 .1 r
.5232 .60214 m
.55506 .58487 L
s
.672 .192 .086 r
.43137 .50486 m .41821 .513 L .41017 .48855 L p F P
0 0 0 r
s
.672 .192 .086 r
.41017 .48855 m .42458 .47941 L .43137 .50486 L p F P
0 0 0 r
s
.299 .426 .808 r
.56863 .50486 m .58179 .513 L .58983 .48855 L p F P
0 0 0 r
s
.299 .426 .808 r
.58983 .48855 m .57542 .47941 L .56863 .50486 L p F P
0 0 0 r
s
.83 .24 .1 r
.83293 .49412 m
.83931 .47767 L
s
.24 .35 .67 r
.16707 .49412 m
.16069 .47767 L
s
.83 .24 .1 r
.57874 .59844 m
.61393 .5798 L
s
.57874 .59844 m
.55506 .58487 L
s
.24 .35 .67 r
.42126 .59844 m
.38607 .5798 L
s
.42126 .59844 m
.44494 .58487 L
s
.83 .24 .1 r
.79405 .5142 m
.83293 .49412 L
s
.79405 .5142 m
.78281 .52535 L
s
.24 .35 .67 r
.20595 .5142 m
.16707 .49412 L
s
.20595 .5142 m
.21719 .52535 L
s
.276 .072 .035 r
.48283 .36611 m .46596 .37747 L .46675 .35947 L p F P
0 0 0 r
s
.276 .072 .035 r
.46675 .35947 m .48324 .34822 L .48283 .36611 L p F P
0 0 0 r
s
.24 .327 .596 r
.51717 .36611 m .53404 .37747 L .53325 .35947 L p F P
0 0 0 r
s
.24 .327 .596 r
.53325 .35947 m .51676 .34822 L .51717 .36611 L p F P
0 0 0 r
s
.843 .246 .107 r
.46932 .5732 m .46179 .57751 L .45028 .55469 L p F P
0 0 0 r
s
.843 .246 .107 r
.44064 .56036 m .45028 .55469 L .46179 .57751 L p F P
0 0 0 r
s
.307 .447 .861 r
.53068 .5732 m .53821 .57751 L .54972 .55469 L p F P
0 0 0 r
s
.307 .447 .861 r
.55936 .56036 m .54972 .55469 L .53821 .57751 L p F P
0 0 0 r
s
.791 .229 .101 r
.45028 .55469 m .44064 .56036 L .42847 .53719 L p F P
0 0 0 r
s
.306 .443 .849 r
.54972 .55469 m .55936 .56036 L .57153 .53719 L p F P
0 0 0 r
s
.83 .24 .1 r
.74473 .54493 m
.78281 .52535 L
s
.74473 .54493 m
.72903 .55019 L
s
.24 .35 .67 r
.25527 .54493 m
.21719 .52535 L
s
.25527 .54493 m
.27097 .55019 L
s
.891 .261 .113 r
.49478 .58648 m .48959 .58938 L .48454 .5645 L p F P
0 0 0 r
s
.83 .24 .1 r
.48917 .5887 m
.48943 .58856 L
s
.891 .261 .113 r
.4769 .56887 m .48454 .5645 L .48959 .58938 L p F P
0 0 0 r
s
.306 .449 .868 r
.50522 .58648 m .51041 .58938 L .51546 .5645 L p F P
0 0 0 r
s
.24 .35 .67 r
.51057 .58856 m
.51083 .5887 L
s
.306 .449 .868 r
.5231 .56887 m .51546 .5645 L .51041 .58938 L p F P
0 0 0 r
s
.83 .24 .1 r
.63612 .58721 m
.67237 .56835 L
s
.63612 .58721 m
.61393 .5798 L
s
.24 .35 .67 r
.36388 .58721 m
.32763 .56835 L
s
.36388 .58721 m
.38607 .5798 L
s
.83 .24 .1 r
.69182 .56936 m
.72903 .55019 L
s
.69182 .56936 m
.67237 .56835 L
s
.24 .35 .67 r
.30818 .56936 m
.27097 .55019 L
s
.30818 .56936 m
.32763 .56835 L
s
.735 .211 .094 r
.44003 .53022 m .42847 .53719 L .41821 .513 L p F P
0 0 0 r
s
.735 .211 .094 r
.41821 .513 m .43137 .50486 L .44003 .53022 L p F P
0 0 0 r
s
.303 .436 .831 r
.55997 .53022 m .57153 .53719 L .58179 .513 L p F P
0 0 0 r
s
.303 .436 .831 r
.58179 .513 m .56863 .50486 L .55997 .53022 L p F P
0 0 0 r
s
.599 .169 .076 r
.4392 .47013 m .42458 .47941 L .41986 .45469 L p F P
0 0 0 r
s
.599 .169 .076 r
.41986 .45469 m .43537 .44463 L .4392 .47013 L p F P
0 0 0 r
s
.291 .413 .778 r
.5608 .47013 m .57542 .47941 L .58014 .45469 L p F P
0 0 0 r
s
.291 .413 .778 r
.58014 .45469 m .56463 .44463 L .5608 .47013 L p F P
0 0 0 r
s
.791 .229 .101 r
.42847 .53719 m .44003 .53022 L .45028 .55469 L p F P
0 0 0 r
s
.306 .443 .849 r
.57153 .53719 m .55997 .53022 L .54972 .55469 L p F P
0 0 0 r
s
.83 .24 .1 r
.67534 .21012 m
.65837 .20938 L
s
.24 .35 .67 r
.32466 .21012 m
.34163 .20938 L
s
.4 .107 .051 r
.46609 .39918 m .44956 .41012 L .44938 .38863 L p F P
0 0 0 r
s
.4 .107 .051 r
.44938 .38863 m .46596 .37747 L .46609 .39918 L p F P
0 0 0 r
s
.265 .367 .679 r
.53391 .39918 m .55044 .41012 L .55062 .38863 L p F P
0 0 0 r
s
.265 .367 .679 r
.55062 .38863 m .53404 .37747 L .53391 .39918 L p F P
0 0 0 r
s
.511 .142 .065 r
.45113 .4344 m .43537 .44463 L .43331 .42088 L p F P
0 0 0 r
s
.511 .142 .065 r
.43331 .42088 m .44956 .41012 L .45113 .4344 L p F P
0 0 0 r
s
.281 .394 .737 r
.54887 .4344 m .56463 .44463 L .56669 .42088 L p F P
0 0 0 r
s
.281 .394 .737 r
.56669 .42088 m .55044 .41012 L .54887 .4344 L p F P
0 0 0 r
s
.83 .24 .1 r
.60785 .24042 m
.62227 .23433 L
s
.62227 .23433 m
.65837 .20938 L
s
.24 .35 .67 r
.39215 .24042 m
.37773 .23433 L
s
.37773 .23433 m
.34163 .20938 L
s
.891 .261 .113 r
.5 .58357 m .49478 .58648 L .49224 .56009 L p F P
0 0 0 r
s
.83 .24 .1 r
.49444 .58576 m
.4947 .58561 L
s
.891 .261 .113 r
.48454 .5645 m .49224 .56009 L .49478 .58648 L p F P
0 0 0 r
s
.306 .449 .868 r
.5 .58357 m .50522 .58648 L .50776 .56009 L p F P
0 0 0 r
s
.24 .35 .67 r
.5053 .58561 m
.50556 .58576 L
s
.306 .449 .868 r
.51546 .5645 m .50776 .56009 L .50522 .58648 L p F P
0 0 0 r
s
.83 .24 .1 r
.49974 .5828 m
.50037 .58245 L
s
.24 .35 .67 r
.49963 .58245 m
.50026 .5828 L
s
.843 .246 .107 r
.4769 .56887 m .46932 .5732 L .46003 .54897 L p F P
0 0 0 r
s
.843 .246 .107 r
.45028 .55469 m .46003 .54897 L .46932 .5732 L p F P
0 0 0 r
s
.307 .447 .861 r
.5231 .56887 m .53068 .5732 L .53997 .54897 L p F P
0 0 0 r
s
.307 .447 .861 r
.54972 .55469 m .53997 .54897 L .53068 .5732 L p F P
0 0 0 r
s
.83 .24 .1 r
.5614 .27762 m
.57256 .26487 L
s
.57256 .26487 m
.60785 .24042 L
s
.24 .35 .67 r
.4386 .27762 m
.42744 .26487 L
s
.42744 .26487 m
.39215 .24042 L
s
.83 .24 .1 r
.50089 .33317 m
.51962 .32037 L
s
.24 .35 .67 r
.48038 .32037 m
.49911 .33317 L
s
.83 .24 .1 r
.51962 .32037 m
.52687 .30147 L
s
.52687 .30147 m
.5614 .27762 L
s
.24 .35 .67 r
.48038 .32037 m
.47313 .30147 L
s
.47313 .30147 m
.4386 .27762 L
s
.791 .229 .101 r
.46003 .54897 m .45028 .55469 L .44003 .53022 L p F P
0 0 0 r
s
.306 .443 .849 r
.53997 .54897 m .54972 .55469 L .55997 .53022 L p F P
0 0 0 r
s
.891 .261 .113 r
.49224 .56009 m .5 .55565 L .5 .58357 L p F P
0 0 0 r
s
.24 .35 .67 r
.4922 .5783 m
.49493 .57982 L
s
.49493 .57982 m
.49691 .58093 L
s
.306 .449 .868 r
.50776 .56009 m .5 .55565 L .5 .58357 L p F P
0 0 0 r
s
.83 .24 .1 r
.50507 .57982 m
.5078 .5783 L
s
.50309 .58093 m
.50507 .57982 L
s
.672 .192 .086 r
.44471 .4966 m .43137 .50486 L .42458 .47941 L p F P
0 0 0 r
s
.672 .192 .086 r
.42458 .47941 m .4392 .47013 L .44471 .4966 L p F P
0 0 0 r
s
.299 .426 .808 r
.55529 .4966 m .56863 .50486 L .57542 .47941 L p F P
0 0 0 r
s
.299 .426 .808 r
.57542 .47941 m .5608 .47013 L .55529 .4966 L p F P
0 0 0 r
s
.843 .246 .107 r
.48454 .5645 m .4769 .56887 L .46987 .54319 L p F P
0 0 0 r
s
.843 .246 .107 r
.46003 .54897 m .46987 .54319 L .4769 .56887 L p F P
0 0 0 r
s
.24 .35 .67 r
.46876 .56521 m
.4922 .5783 L
s
.307 .447 .861 r
.51546 .5645 m .5231 .56887 L .53013 .54319 L p F P
0 0 0 r
s
.307 .447 .861 r
.53997 .54897 m .53013 .54319 L .5231 .56887 L p F P
0 0 0 r
s
.83 .24 .1 r
.5078 .5783 m
.53124 .56521 L
s
.791 .229 .101 r
.44003 .53022 m .45173 .52316 L .46003 .54897 L p F P
0 0 0 r
s
.735 .211 .094 r
.45173 .52316 m .44003 .53022 L .43137 .50486 L p F P
0 0 0 r
s
.306 .443 .849 r
.55997 .53022 m .54827 .52316 L .53997 .54897 L p F P
0 0 0 r
s
.303 .436 .831 r
.54827 .52316 m .55997 .53022 L .56863 .50486 L p F P
0 0 0 r
s
.735 .211 .094 r
.43137 .50486 m .44471 .4966 L .45173 .52316 L p F P
0 0 0 r
s
.303 .436 .831 r
.56863 .50486 m .55529 .4966 L .54827 .52316 L p F P
0 0 0 r
s
.276 .072 .035 r
.5 .35455 m .48283 .36611 L .48324 .34822 L p F P
0 0 0 r
s
.83 .24 .1 r
.48302 .36759 m
.48323 .36584 L
s
.48519 .34896 m
.48545 .34671 L
s
.276 .072 .035 r
.48324 .34822 m .5 .33679 L .5 .35455 L p F P
0 0 0 r
s
.24 .327 .596 r
.5 .35455 m .51717 .36611 L .51676 .34822 L p F P
0 0 0 r
s
.24 .35 .67 r
.51455 .34671 m
.51481 .34896 L
s
.51677 .36584 m
.51698 .36759 L
s
.24 .327 .596 r
.51676 .34822 m .5 .33679 L .5 .35455 L p F P
0 0 0 r
s
.599 .169 .076 r
.45405 .46071 m .4392 .47013 L .43537 .44463 L p F P
0 0 0 r
s
.599 .169 .076 r
.43537 .44463 m .45113 .4344 L .45405 .46071 L p F P
0 0 0 r
s
.291 .413 .778 r
.54595 .46071 m .5608 .47013 L .56463 .44463 L p F P
0 0 0 r
s
.291 .413 .778 r
.56463 .44463 m .54887 .4344 L .54595 .46071 L p F P
0 0 0 r
s
.791 .229 .101 r
.46987 .54319 m .46003 .54897 L .45173 .52316 L p F P
0 0 0 r
s
.306 .443 .849 r
.53013 .54319 m .53997 .54897 L .54827 .52316 L p F P
0 0 0 r
s
.83 .24 .1 r
.55506 .58487 m
.59029 .56576 L
s
.53124 .56521 m
.55506 .58487 L
s
.24 .35 .67 r
.44494 .58487 m
.40971 .56576 L
s
.44494 .58487 m
.46876 .56521 L
s
.4 .107 .051 r
.4829 .38805 m .46609 .39918 L .46596 .37747 L p F P
0 0 0 r
s
.4 .107 .051 r
.46596 .37747 m .48283 .36611 L .4829 .38805 L p F P
0 0 0 r
s
.83 .24 .1 r
.48284 .36772 m
.48302 .36759 L
s
.265 .367 .679 r
.5171 .38805 m .53391 .39918 L .53404 .37747 L p F P
0 0 0 r
s
.265 .367 .679 r
.53404 .37747 m .51717 .36611 L .5171 .38805 L p F P
0 0 0 r
s
.24 .35 .67 r
.51698 .36759 m
.51716 .36772 L
s
.511 .142 .065 r
.46715 .424 m .45113 .4344 L .44956 .41012 L p F P
0 0 0 r
s
.83 .24 .1 r
.45129 .40898 m
.45148 .41164 L
s
.511 .142 .065 r
.44956 .41012 m .46609 .39918 L .46715 .424 L p F P
0 0 0 r
s
.281 .394 .737 r
.53285 .424 m .54887 .4344 L .55044 .41012 L p F P
0 0 0 r
s
.24 .35 .67 r
.54852 .41164 m
.54871 .40898 L
s
.281 .394 .737 r
.55044 .41012 m .53391 .39918 L .53285 .424 L p F P
0 0 0 r
s
.843 .246 .107 r
.49224 .56009 m .48454 .5645 L .47981 .53736 L p F P
0 0 0 r
s
.843 .246 .107 r
.46987 .54319 m .47981 .53736 L .48454 .5645 L p F P
0 0 0 r
s
.307 .447 .861 r
.50776 .56009 m .51546 .5645 L .52019 .53736 L p F P
0 0 0 r
s
.307 .447 .861 r
.53013 .54319 m .52019 .53736 L .51546 .5645 L p F P
0 0 0 r
s
.672 .192 .086 r
.45824 .48822 m .44471 .4966 L .4392 .47013 L p F P
0 0 0 r
s
.672 .192 .086 r
.4392 .47013 m .45405 .46071 L .45824 .48822 L p F P
0 0 0 r
s
.299 .426 .808 r
.54176 .48822 m .55529 .4966 L .5608 .47013 L p F P
0 0 0 r
s
.299 .426 .808 r
.5608 .47013 m .54595 .46071 L .54176 .48822 L p F P
0 0 0 r
s
.791 .229 .101 r
.45173 .52316 m .46358 .51602 L .46987 .54319 L p F P
0 0 0 r
s
.735 .211 .094 r
.46358 .51602 m .45173 .52316 L .44471 .4966 L p F P
0 0 0 r
s
.306 .443 .849 r
.54827 .52316 m .53642 .51602 L .53013 .54319 L p F P
0 0 0 r
s
.303 .436 .831 r
.53642 .51602 m .54827 .52316 L .55529 .4966 L p F P
0 0 0 r
s
.735 .211 .094 r
.44471 .4966 m .45824 .48822 L .46358 .51602 L p F P
0 0 0 r
s
.303 .436 .831 r
.55529 .4966 m .54176 .48822 L .53642 .51602 L p F P
0 0 0 r
s
.791 .229 .101 r
.47981 .53736 m .46987 .54319 L .46358 .51602 L p F P
0 0 0 r
s
.306 .443 .849 r
.52019 .53736 m .53013 .54319 L .53642 .51602 L p F P
0 0 0 r
s
.843 .246 .107 r
.5 .55565 m .49224 .56009 L .48985 .53146 L p F P
0 0 0 r
s
.843 .246 .107 r
.47981 .53736 m .48985 .53146 L .49224 .56009 L p F P
0 0 0 r
s
.307 .447 .861 r
.5 .55565 m .50776 .56009 L .51015 .53146 L p F P
0 0 0 r
s
.307 .447 .861 r
.52019 .53736 m .51015 .53146 L .50776 .56009 L p F P
0 0 0 r
s
.83 .24 .1 r
.61393 .5798 m
.65035 .56053 L
s
.61393 .5798 m
.59029 .56576 L
s
.24 .35 .67 r
.38607 .5798 m
.34965 .56053 L
s
.38607 .5798 m
.40971 .56576 L
s
.83 .24 .1 r
.82221 .5051 m
.83293 .49412 L
s
.24 .35 .67 r
.17779 .5051 m
.16707 .49412 L
s
.83 .24 .1 r
.78281 .52535 m
.82221 .5051 L
s
.78281 .52535 m
.76753 .53035 L
s
.24 .35 .67 r
.21719 .52535 m
.17779 .5051 L
s
.21719 .52535 m
.23247 .53035 L
s
.599 .169 .076 r
.46913 .45115 m .45405 .46071 L .45113 .4344 L p F P
0 0 0 r
s
.599 .169 .076 r
.45113 .4344 m .46715 .424 L .46913 .45115 L p F P
0 0 0 r
s
.291 .413 .778 r
.53087 .45115 m .54595 .46071 L .54887 .4344 L p F P
0 0 0 r
s
.291 .413 .778 r
.54887 .4344 m .53285 .424 L .53087 .45115 L p F P
0 0 0 r
s
.83 .24 .1 r
.67237 .56835 m
.70988 .54883 L
s
.67237 .56835 m
.65035 .56053 L
s
.24 .35 .67 r
.32763 .56835 m
.29012 .54883 L
s
.32763 .56835 m
.34965 .56053 L
s
.83 .24 .1 r
.72903 .55019 m
.76753 .53035 L
s
.72903 .55019 m
.70988 .54883 L
s
.24 .35 .67 r
.27097 .55019 m
.23247 .53035 L
s
.27097 .55019 m
.29012 .54883 L
s
.843 .246 .107 r
.48985 .53146 m .5 .5255 L .5 .55565 L p F P
0 0 0 r
s
.24 .35 .67 r
.49144 .54036 m
.49514 .54249 L
s
.49514 .54249 m
.49833 .54433 L
s
.307 .447 .861 r
.51015 .53146 m .5 .5255 L .5 .55565 L p F P
0 0 0 r
s
.83 .24 .1 r
.50486 .54249 m
.50856 .54036 L
s
.50167 .54433 m
.50486 .54249 L
s
.4 .107 .051 r
.5 .37673 m .4829 .38805 L .48283 .36611 L p F P
0 0 0 r
s
.4 .107 .051 r
.48283 .36611 m .5 .35455 L .5 .37673 L p F P
0 0 0 r
s
.24 .35 .67 r
.48273 .34457 m
.49879 .35536 L
s
.265 .367 .679 r
.5 .37673 m .5171 .38805 L .51717 .36611 L p F P
0 0 0 r
s
.265 .367 .679 r
.51717 .36611 m .5 .35455 L .5 .37673 L p F P
0 0 0 r
s
.83 .24 .1 r
.50121 .35536 m
.51727 .34457 L
s
.511 .142 .065 r
.48344 .41343 m .46715 .424 L .46609 .39918 L p F P
0 0 0 r
s
.511 .142 .065 r
.46609 .39918 m .4829 .38805 L .48344 .41343 L p F P
0 0 0 r
s
.281 .394 .737 r
.51656 .41343 m .53285 .424 L .53391 .39918 L p F P
0 0 0 r
s
.281 .394 .737 r
.53391 .39918 m .5171 .38805 L .51656 .41343 L p F P
0 0 0 r
s
.791 .229 .101 r
.46358 .51602 m .47557 .50879 L .47981 .53736 L p F P
0 0 0 r
s
.735 .211 .094 r
.47557 .50879 m .46358 .51602 L .45824 .48822 L p F P
0 0 0 r
s
.306 .443 .849 r
.53642 .51602 m .52443 .50879 L .52019 .53736 L p F P
0 0 0 r
s
.303 .436 .831 r
.52443 .50879 m .53642 .51602 L .54176 .48822 L p F P
0 0 0 r
s
.83 .24 .1 r
.65837 .20938 m
.64436 .21511 L
s
.24 .35 .67 r
.34163 .20938 m
.35564 .21511 L
s
.791 .229 .101 r
.48985 .53146 m .47981 .53736 L .47557 .50879 L p F P
0 0 0 r
s
.306 .443 .849 r
.51015 .53146 m .52019 .53736 L .52443 .50879 L p F P
0 0 0 r
s
.83 .24 .1 r
.53124 .56521 m
.56639 .54558 L
s
.50856 .54036 m
.53124 .56521 L
s
.24 .35 .67 r
.46876 .56521 m
.43361 .54558 L
s
.46876 .56521 m
.49144 .54036 L
s
.83 .24 .1 r
.59712 .25295 m
.60785 .24042 L
s
.60785 .24042 m
.64436 .21511 L
s
.24 .35 .67 r
.40288 .25295 m
.39215 .24042 L
s
.39215 .24042 m
.35564 .21511 L
s
.83 .24 .1 r
.51727 .34457 m
.51962 .32037 L
s
.51962 .32037 m
.5546 .29645 L
s
.24 .35 .67 r
.48273 .34457 m
.48038 .32037 L
s
.48038 .32037 m
.4454 .29645 L
s
.672 .192 .086 r
.47197 .47973 m .45824 .48822 L .45405 .46071 L p F P
0 0 0 r
s
.672 .192 .086 r
.45405 .46071 m .46913 .45115 L .47197 .47973 L p F P
0 0 0 r
s
.299 .426 .808 r
.52803 .47973 m .54176 .48822 L .54595 .46071 L p F P
0 0 0 r
s
.299 .426 .808 r
.54595 .46071 m .53087 .45115 L .52803 .47973 L p F P
0 0 0 r
s
.83 .24 .1 r
.5546 .29645 m
.5614 .27762 L
s
.5614 .27762 m
.59712 .25295 L
s
.24 .35 .67 r
.4454 .29645 m
.4386 .27762 L
s
.4386 .27762 m
.40288 .25295 L
s
.735 .211 .094 r
.45824 .48822 m .47197 .47973 L .47557 .50879 L p F P
0 0 0 r
s
.303 .436 .831 r
.54176 .48822 m .52803 .47973 L .52443 .50879 L p F P
0 0 0 r
s
.791 .229 .101 r
.5 .5255 m .48985 .53146 L .48771 .50147 L p F P
0 0 0 r
s
.791 .229 .101 r
.47557 .50879 m .48771 .50147 L .48985 .53146 L p F P
0 0 0 r
s
.306 .443 .849 r
.5 .5255 m .51015 .53146 L .51229 .50147 L p F P
0 0 0 r
s
.306 .443 .849 r
.52443 .50879 m .51229 .50147 L .51015 .53146 L p F P
0 0 0 r
s
.599 .169 .076 r
.48444 .44143 m .46913 .45115 L .46715 .424 L p F P
0 0 0 r
s
.599 .169 .076 r
.46715 .424 m .48344 .41343 L .48444 .44143 L p F P
0 0 0 r
s
.291 .413 .778 r
.51556 .44143 m .53087 .45115 L .53285 .424 L p F P
0 0 0 r
s
.291 .413 .778 r
.53285 .424 m .51656 .41343 L .51556 .44143 L p F P
0 0 0 r
s
.735 .211 .094 r
.48771 .50147 m .47557 .50879 L .47197 .47973 L p F P
0 0 0 r
s
.303 .436 .831 r
.51229 .50147 m .52443 .50879 L .52803 .47973 L p F P
0 0 0 r
s
.83 .24 .1 r
.50276 .53213 m
.50856 .54036 L
s
.24 .35 .67 r
.49144 .54036 m
.49724 .53213 L
s
.83 .24 .1 r
.59029 .56576 m
.62676 .54599 L
s
.59029 .56576 m
.56639 .54558 L
s
.24 .35 .67 r
.40971 .56576 m
.37324 .54599 L
s
.40971 .56576 m
.43361 .54558 L
s
.511 .142 .065 r
.5 .40268 m .48344 .41343 L .4829 .38805 L p F P
0 0 0 r
s
.83 .24 .1 r
.48468 .38687 m
.48493 .38979 L
s
.511 .142 .065 r
.4829 .38805 m .5 .37673 L .5 .40268 L p F P
0 0 0 r
s
.281 .394 .737 r
.5 .40268 m .51656 .41343 L .5171 .38805 L p F P
0 0 0 r
s
.24 .35 .67 r
.51507 .38979 m
.51532 .38687 L
s
.281 .394 .737 r
.5171 .38805 m .5 .37673 L .5 .40268 L p F P
0 0 0 r
s
.672 .192 .086 r
.48588 .47112 m .47197 .47973 L .46913 .45115 L p F P
0 0 0 r
s
.672 .192 .086 r
.46913 .45115 m .48444 .44143 L .48588 .47112 L p F P
0 0 0 r
s
.299 .426 .808 r
.51412 .47112 m .52803 .47973 L .53087 .45115 L p F P
0 0 0 r
s
.299 .426 .808 r
.53087 .45115 m .51556 .44143 L .51412 .47112 L p F P
0 0 0 r
s
.735 .211 .094 r
.47197 .47973 m .48588 .47112 L .48771 .50147 L p F P
0 0 0 r
s
.303 .436 .831 r
.52803 .47973 m .51412 .47112 L .51229 .50147 L p F P
0 0 0 r
s
.791 .229 .101 r
.48771 .50147 m .5 .49406 L .5 .5255 L p F P
0 0 0 r
s
.24 .35 .67 r
.49753 .50309 m
.49864 .50375 L
s
.45647 .52017 m
.49144 .54036 L
s
.306 .443 .849 r
.51229 .50147 m .5 .49406 L .5 .5255 L p F P
0 0 0 r
s
.83 .24 .1 r
.50136 .50375 m
.50247 .50309 L
s
.50856 .54036 m
.54353 .52017 L
s
.50189 .38506 m
.52016 .37305 L
s
.50091 .3857 m
.50189 .38506 L
s
.24 .35 .67 r
.47984 .37305 m
.49811 .38506 L
s
.49811 .38506 m
.49909 .3857 L
s
.735 .211 .094 r
.5 .49406 m .48771 .50147 L .48588 .47112 L p F P
0 0 0 r
s
.303 .436 .831 r
.5 .49406 m .51229 .50147 L .51412 .47112 L p F P
0 0 0 r
s
.83 .24 .1 r
.65035 .56053 m
.68805 .54057 L
s
.65035 .56053 m
.62676 .54599 L
s
.24 .35 .67 r
.34965 .56053 m
.31195 .54057 L
s
.34965 .56053 m
.37324 .54599 L
s
.599 .169 .076 r
.5 .43156 m .48444 .44143 L .48344 .41343 L p F P
0 0 0 r
s
.599 .169 .076 r
.48344 .41343 m .5 .40268 L .5 .43156 L p F P
0 0 0 r
s
.291 .413 .778 r
.5 .43156 m .51556 .44143 L .51656 .41343 L p F P
0 0 0 r
s
.291 .413 .778 r
.51656 .41343 m .5 .40268 L .5 .43156 L p F P
0 0 0 r
s
.83 .24 .1 r
.8074 .50981 m
.82221 .5051 L
s
.24 .35 .67 r
.1926 .50981 m
.17779 .5051 L
s
.83 .24 .1 r
.70988 .54883 m
.74871 .52862 L
s
.70988 .54883 m
.68805 .54057 L
s
.24 .35 .67 r
.29012 .54883 m
.25129 .52862 L
s
.29012 .54883 m
.31195 .54057 L
s
.83 .24 .1 r
.76753 .53035 m
.8074 .50981 L
s
.76753 .53035 m
.74871 .52862 L
s
.24 .35 .67 r
.23247 .53035 m
.1926 .50981 L
s
.23247 .53035 m
.25129 .52862 L
s
.83 .24 .1 r
.55273 .32072 m
.51727 .34457 L
s
.52016 .37305 m
.51727 .34457 L
s
.24 .35 .67 r
.44727 .32072 m
.48273 .34457 L
s
.47984 .37305 m
.48273 .34457 L
s
.735 .211 .094 r
.48588 .47112 m .5 .46238 L .5 .49406 L p F P
0 0 0 r
s
.24 .35 .67 r
.47703 .49084 m
.49753 .50309 L
s
.672 .192 .086 r
.5 .46238 m .48588 .47112 L .48444 .44143 L p F P
0 0 0 r
s
.303 .436 .831 r
.51412 .47112 m .5 .46238 L .5 .49406 L p F P
0 0 0 r
s
.83 .24 .1 r
.50247 .50309 m
.52297 .49084 L
s
.299 .426 .808 r
.5 .46238 m .51412 .47112 L .51556 .44143 L p F P
0 0 0 r
s
.672 .192 .086 r
.48444 .44143 m .5 .43156 L .5 .46238 L p F P
0 0 0 r
s
.24 .35 .67 r
.49413 .45917 m
.49839 .46181 L
s
.49839 .46181 m
.49856 .46192 L
s
.299 .426 .808 r
.51556 .44143 m .5 .43156 L .5 .46238 L p F P
0 0 0 r
s
.83 .24 .1 r
.50161 .46181 m
.50587 .45917 L
s
.50144 .46192 m
.50161 .46181 L
s
.56639 .54558 m
.6028 .52526 L
s
.56639 .54558 m
.54353 .52017 L
s
.24 .35 .67 r
.43361 .54558 m
.3972 .52526 L
s
.43361 .54558 m
.45647 .52017 L
s
.83 .24 .1 r
.64436 .21511 m
.63412 .2274 L
s
.24 .35 .67 r
.35564 .21511 m
.36588 .2274 L
s
.83 .24 .1 r
.55273 .32072 m
.5546 .29645 L
s
.5546 .29645 m
.59081 .27169 L
s
.24 .35 .67 r
.44727 .32072 m
.4454 .29645 L
s
.4454 .29645 m
.40919 .27169 L
s
.83 .24 .1 r
.59081 .27169 m
.59712 .25295 L
s
.59712 .25295 m
.63412 .2274 L
s
.24 .35 .67 r
.40919 .27169 m
.40288 .25295 L
s
.40288 .25295 m
.36588 .2274 L
s
.83 .24 .1 r
.50406 .45457 m
.50587 .45917 L
s
.50169 .44858 m
.50406 .45457 L
s
.50298 .42065 m
.52832 .40446 L
s
.50097 .42194 m
.50298 .42065 L
s
.24 .35 .67 r
.49413 .45917 m
.49594 .45457 L
s
.49594 .45457 m
.49831 .44858 L
s
.47168 .40446 m
.49702 .42065 L
s
.49702 .42065 m
.49903 .42194 L
s
.83 .24 .1 r
.54353 .52017 m
.57975 .49927 L
s
.54353 .52017 m
.52297 .49084 L
s
.24 .35 .67 r
.45647 .52017 m
.42025 .49927 L
s
.45647 .52017 m
.47703 .49084 L
s
.83 .24 .1 r
.52297 .49084 m
.50587 .45917 L
s
.50587 .45917 m
.54145 .43716 L
s
.24 .35 .67 r
.47703 .49084 m
.49413 .45917 L
s
.49413 .45917 m
.45855 .43716 L
s
.83 .24 .1 r
.62676 .54599 m
.66453 .52551 L
s
.62676 .54599 m
.6028 .52526 L
s
.24 .35 .67 r
.37324 .54599 m
.33547 .52551 L
s
.37324 .54599 m
.3972 .52526 L
s
.83 .24 .1 r
.52297 .49084 m
.55891 .46936 L
s
.24 .35 .67 r
.47703 .49084 m
.44109 .46936 L
s
.83 .24 .1 r
.52832 .40446 m
.52016 .37305 L
s
.52016 .37305 m
.55611 .34942 L
s
.24 .35 .67 r
.47168 .40446 m
.47984 .37305 L
s
.47984 .37305 m
.44389 .34942 L
s
.83 .24 .1 r
.68805 .54057 m
.7271 .51989 L
s
.68805 .54057 m
.66453 .52551 L
s
.24 .35 .67 r
.31195 .54057 m
.2729 .51989 L
s
.31195 .54057 m
.33547 .52551 L
s
.83 .24 .1 r
.74871 .52862 m
.78895 .50768 L
s
.74871 .52862 m
.7271 .51989 L
s
.24 .35 .67 r
.25129 .52862 m
.21105 .50768 L
s
.25129 .52862 m
.2729 .51989 L
s
.83 .24 .1 r
.78895 .50768 m
.8074 .50981 L
s
.24 .35 .67 r
.21105 .50768 m
.1926 .50981 L
s
.83 .24 .1 r
.58947 .29602 m
.55273 .32072 L
s
.55611 .34942 m
.55273 .32072 L
s
.24 .35 .67 r
.41053 .29602 m
.44727 .32072 L
s
.44389 .34942 m
.44727 .32072 L
s
.83 .24 .1 r
.6028 .52526 m
.64051 .5042 L
s
.6028 .52526 m
.57975 .49927 L
s
.24 .35 .67 r
.3972 .52526 m
.35949 .5042 L
s
.3972 .52526 m
.42025 .49927 L
s
.83 .24 .1 r
.58947 .29602 m
.59081 .27169 L
s
.59081 .27169 m
.62834 .24603 L
s
.24 .35 .67 r
.41053 .29602 m
.40919 .27169 L
s
.40919 .27169 m
.37166 .24603 L
s
.83 .24 .1 r
.63412 .2274 m
.62834 .24603 L
s
.24 .35 .67 r
.36588 .2274 m
.37166 .24603 L
s
.83 .24 .1 r
.54145 .43716 m
.52832 .40446 L
s
.52832 .40446 m
.56475 .38118 L
s
.24 .35 .67 r
.45855 .43716 m
.47168 .40446 L
s
.47168 .40446 m
.43525 .38118 L
s
.83 .24 .1 r
.57975 .49927 m
.61729 .4776 L
s
.57975 .49927 m
.55891 .46936 L
s
.24 .35 .67 r
.42025 .49927 m
.38271 .4776 L
s
.42025 .49927 m
.44109 .46936 L
s
.83 .24 .1 r
.55891 .46936 m
.54145 .43716 L
s
.54145 .43716 m
.57833 .41434 L
s
.24 .35 .67 r
.44109 .46936 m
.45855 .43716 L
s
.45855 .43716 m
.42167 .41434 L
s
.83 .24 .1 r
.66453 .52551 m
.70367 .50429 L
s
.66453 .52551 m
.64051 .5042 L
s
.24 .35 .67 r
.33547 .52551 m
.29633 .50429 L
s
.33547 .52551 m
.35949 .5042 L
s
.83 .24 .1 r
.55891 .46936 m
.59616 .44709 L
s
.24 .35 .67 r
.44109 .46936 m
.40384 .44709 L
s
.83 .24 .1 r
.56475 .38118 m
.55611 .34942 L
s
.55611 .34942 m
.59337 .32493 L
s
.24 .35 .67 r
.43525 .38118 m
.44389 .34942 L
s
.44389 .34942 m
.40663 .32493 L
s
.83 .24 .1 r
.7271 .51989 m
.76758 .49846 L
s
.7271 .51989 m
.70367 .50429 L
s
.24 .35 .67 r
.2729 .51989 m
.23242 .49846 L
s
.2729 .51989 m
.29633 .50429 L
s
.83 .24 .1 r
.76758 .49846 m
.78895 .50768 L
s
.24 .35 .67 r
.23242 .49846 m
.21105 .50768 L
s
.83 .24 .1 r
.62755 .27041 m
.58947 .29602 L
s
.59337 .32493 m
.58947 .29602 L
s
.24 .35 .67 r
.37245 .27041 m
.41053 .29602 L
s
.40663 .32493 m
.41053 .29602 L
s
.83 .24 .1 r
.64051 .5042 m
.67962 .48236 L
s
.64051 .5042 m
.61729 .4776 L
s
.24 .35 .67 r
.35949 .5042 m
.32038 .48236 L
s
.35949 .5042 m
.38271 .4776 L
s
.83 .24 .1 r
.62834 .24603 m
.62755 .27041 L
s
.24 .35 .67 r
.37166 .24603 m
.37245 .27041 L
s
.83 .24 .1 r
.57833 .41434 m
.56475 .38118 L
s
.56475 .38118 m
.60253 .35704 L
s
.24 .35 .67 r
.42167 .41434 m
.43525 .38118 L
s
.43525 .38118 m
.39747 .35704 L
s
.83 .24 .1 r
.61729 .4776 m
.65622 .45513 L
s
.61729 .4776 m
.59616 .44709 L
s
.24 .35 .67 r
.38271 .4776 m
.34378 .45513 L
s
.38271 .4776 m
.40384 .44709 L
s
.83 .24 .1 r
.59616 .44709 m
.57833 .41434 L
s
.57833 .41434 m
.61657 .39068 L
s
.24 .35 .67 r
.40384 .44709 m
.42167 .41434 L
s
.42167 .41434 m
.38343 .39068 L
s
.83 .24 .1 r
.70367 .50429 m
.74427 .48227 L
s
.70367 .50429 m
.67962 .48236 L
s
.24 .35 .67 r
.29633 .50429 m
.25573 .48227 L
s
.29633 .50429 m
.32038 .48236 L
s
.83 .24 .1 r
.59616 .44709 m
.6348 .424 L
s
.24 .35 .67 r
.40384 .44709 m
.3652 .424 L
s
.83 .24 .1 r
.60253 .35704 m
.59337 .32493 L
s
.59337 .32493 m
.63203 .29952 L
s
.24 .35 .67 r
.39747 .35704 m
.40663 .32493 L
s
.40663 .32493 m
.36797 .29952 L
s
.83 .24 .1 r
.74427 .48227 m
.76758 .49846 L
s
.24 .35 .67 r
.25573 .48227 m
.23242 .49846 L
s
.83 .24 .1 r
.62755 .27041 m
.63203 .29952 L
s
.24 .35 .67 r
.37245 .27041 m
.36797 .29952 L
s
.83 .24 .1 r
.67962 .48236 m
.72019 .45971 L
s
.67962 .48236 m
.65622 .45513 L
s
.24 .35 .67 r
.32038 .48236 m
.27981 .45971 L
s
.32038 .48236 m
.34378 .45513 L
s
.83 .24 .1 r
.61657 .39068 m
.60253 .35704 L
s
.60253 .35704 m
.64172 .33199 L
s
.24 .35 .67 r
.38343 .39068 m
.39747 .35704 L
s
.39747 .35704 m
.35828 .33199 L
s
.83 .24 .1 r
.65622 .45513 m
.69662 .43181 L
s
.65622 .45513 m
.6348 .424 L
s
.24 .35 .67 r
.34378 .45513 m
.30338 .43181 L
s
.34378 .45513 m
.3652 .424 L
s
.83 .24 .1 r
.6348 .424 m
.61657 .39068 L
s
.61657 .39068 m
.65626 .36612 L
s
.24 .35 .67 r
.3652 .424 m
.38343 .39068 L
s
.38343 .39068 m
.34374 .36612 L
s
.83 .24 .1 r
.72019 .45971 m
.74427 .48227 L
s
.24 .35 .67 r
.27981 .45971 m
.25573 .48227 L
s
.83 .24 .1 r
.6348 .424 m
.6749 .40003 L
s
.24 .35 .67 r
.3652 .424 m
.3251 .40003 L
s
.83 .24 .1 r
.63203 .29952 m
.64172 .33199 L
s
.24 .35 .67 r
.36797 .29952 m
.35828 .33199 L
s
.83 .24 .1 r
.69662 .43181 m
.72019 .45971 L
s
.24 .35 .67 r
.30338 .43181 m
.27981 .45971 L
s
.83 .24 .1 r
.64172 .33199 m
.65626 .36612 L
s
.24 .35 .67 r
.35828 .33199 m
.34374 .36612 L
s
.83 .24 .1 r
.6749 .40003 m
.69662 .43181 L
s
.24 .35 .67 r
.3251 .40003 m
.30338 .43181 L
s
.83 .24 .1 r
.65626 .36612 m
.6749 .40003 L
s
.24 .35 .67 r
.34374 .36612 m
.3251 .40003 L
s
0 0 0 r
.25 Mabswid
.07653 .37901 m
.5 .02321 L
s
.5 .02321 m
.5 .30205 L
s
.5 .30205 m
.02189 .6366 L
s
.02189 .6366 m
.07653 .37901 L
s
.92347 .37901 m
.5 .02321 L
s
.5 .02321 m
.5 .30205 L
s
.5 .30205 m
.97811 .6366 L
s
.97811 .6366 m
.92347 .37901 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{500, 500},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40007d0001m2000`400?l00000o`00003oo`3ooooe
0?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3o
m^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40
oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?of
k_@0ooK^0@3oool00?T0ooK^00<000000?ofkP3om^h0m`3om^h10?ooo`00n03om^h300000?P0ooK^
0@3oool00?L0ooK^00D000000?ofkP000000ooK^0000003g0?ofkP40oooo003e0?ofkP8000000P3o
m^h00`000000ooK^0?ofkP0200000?D0ooK^0@3oool00?@0ooK^00<000000?ofkP3om^h00P3om^h0
0`000000ooK^0?ofkP020?ofkP030000003om^h0ooK^0?80ooK^0@3oool00?<0ooK^00<000000?of
kP3om^h00`3om^h00`000000ooK^0?ofkP030?ofkP030000003om^h0ooK^0?40ooK^0@3oool00?80
ooK^00<000000?ofkP3om^h0103om^h00`000000ooK^0?ofkP040?ofkP030000003om^h0ooK^0?00
ooK^0@3oool00?40ooK^00<000000?ofkP3om^h01@3om^h00`000000ooK^0?ofkP050?ofkP030000
003om^h0ooK^0>l0ooK^0@3oool00>l0ooK^0P0000080?ofkP030000003om^h0ooK^00H0ooK^0P00
003_0?ofkP40oooo003^0?ofkP030000003om^h0ooK^00P0ooK^00<000000?ofkP3om^h0203om^h0
0`000000ooK^0?ofkP3/0?ofkP40oooo003]0?ofkP030000003om^h0ooK^00T0ooK^00<000000?of
kP3om^h02@3om^h00`000000ooK^0?ofkP3[0?ofkP40oooo003/0?ofkP030000003om^h0ooK^00X0
ooK^00<000000?ofkP3om^h02P3om^h00`000000ooK^0?ofkP3Z0?ofkP40oooo003[0?ofkP030000
003om^h0ooK^00/0ooK^00<000000?ofkP3om^h02`3om^h00`000000ooK^0?ofkP3Y0?ofkP40oooo
003Y0?ofkP8000003P3om^h00`000000ooK^0?ofkP0<0?ofkP800000j@3om^h10?ooo`00j03om^h0
0`000000ooK^0?ofkP0>0?ofkP030000003om^h0ooK^00h0ooK^00<000000?ofkP3om^h0iP3om^h1
0?ooo`00i`3om^h00`000000ooK^0?ofkP0?0?ofkP030000003om^h0ooK^00l0ooK^00<000000?of
kP3om^h0i@3om^h10?ooo`00iP3om^h00`000000ooK^0?ofkP0@0?ofkP030000003om^h0ooK^0100
ooK^00<000000?ofkP3om^h0i03om^h10?ooo`00i@3om^h00`000000ooK^0?ofkP0A0?ofkP030000
003om^h0ooK^0140ooK^00<000000?ofkP3om^h0h`3om^h10?ooo`00i03om^h00`000000ooK^0?of
kP0B0?ofkP030000003om^h0ooK^0180ooK^00<000000?ofkP3om^h0hP3om^h10?ooo`00hP3om^h2
000001D0ooK^00<000000?ofkP3om^h04`3om^h200000>80ooK^0@3oool00>40ooK^00<000000?of
kP3om^h05@3om^h00`000000ooK^0?ofkP0E0?ofkP030000003om^h0ooK^0=l0ooK^0@3oool00>00
ooK^00<000000?ofkP3om^h05P3om^h00`000000ooK^0?ofkP0F0?ofkP030000003om^h0ooK^0=h0
ooK^0@3oool00=l0ooK^00<000000?ofkP3om^h05`3om^h00`000000ooK^0?ofkP0G0?ofkP030000
003om^h0ooK^0=d0ooK^0@3oool00=h0ooK^00<000000?ofkP3om^h0603om^h00`000000ooK^0?of
kP0H0?ofkP030000003om^h0ooK^0=`0ooK^0@3oool00=`0ooK^0P00000K0?ofkP030000003om^h0
ooK^01T0ooK^0P00003L0?ofkP40oooo003K0?ofkP030000003om^h0ooK^01/0ooK^00<000000?of
kP3om^h06`3om^h00`000000ooK^0?ofkP3I0?ofkP40oooo003J0?ofkP030000003om^h0ooK^01`0
ooK^00<000000?ofkP3om^h0703om^h00`000000ooK^0?ofkP3H0?ofkP40oooo003I0?ofkP030000
003om^h0ooK^01d0ooK^00<000000?ofkP3om^h07@3om^h00`000000ooK^0?ofkP3G0?ofkP40oooo
003H0?ofkP030000003om^h0ooK^01h0ooK^00<000000?ofkP3om^h07P3om^h00`000000ooK^0?of
kP3F0?ofkP40oooo003G0?ofkP030000003om^h0ooK^01l0ooK^00<000000?ofkP3om^h07`3om^h0
0`000000ooK^0?ofkP3E0?ofkP40oooo003E0?ofkP8000008P3om^h00`000000ooK^0?ofkP0P0?of
kP800000e@3om^h10?ooo`00e03om^h00`000000ooK^0?ofkP0R0?ofkP030000003om^h0ooK^0280
ooK^00<000000?ofkP3om^h0dP3om^h10?ooo`00d`3om^h00`000000ooK^0?ofkP0S0?ofkP030000
003om^h0ooK^02<0ooK^00<000000?ofkP3om^h0d@3om^h10?ooo`00dP3om^h00`000000ooK^0?of
kP0T0?ofkP030000003om^h0ooK^02@0ooK^00<000000?ofkP3om^h0d03om^h10?ooo`00d@3om^h0
0`000000ooK^0?ofkP0U0?ofkP030000003om^h0ooK^02D0ooK^00<000000?ofkP3om^h0c`3om^h1
0?ooo`00c`3om^h2000002P0ooK^00<000000?ofkP3om^h09P3om^h200000<l0ooK^0@3oool00<h0
ooK^00<000000?ofkP3om^h0:03om^h00`000000ooK^0?ofkP0X0?ofkP030000003om^h0ooK^0<`0
ooK^0@3oool00<d0ooK^00<000000?ofkP3om^h0:@3om^h00`000000ooK^0?ofkP0Y0?ofkP030000
003om^h0ooK^0</0ooK^0@3oool00<`0ooK^00<000000?ofkP3om^h0:P3om^h00`000000ooK^0?of
kP0Z0?ofkP030000003om^h0ooK^0<X0ooK^0@3oool00</0ooK^00<000000?ofkP3om^h0:`3om^h0
0`000000ooK^0?ofkP0[0?ofkP030000003om^h0ooK^0<T0ooK^0@3oool00<T0ooK^0P00000^0?of
kP030000003om^h0ooK^02`0ooK^0P0000390?ofkP40oooo00380?ofkP030000003om^h0ooK^02h0
ooK^00<000000?ofkP3om^h0;P3om^h00`000000ooK^0?ofkP360?ofkP40oooo00370?ofkP030000
003om^h0ooK^02l0ooK^00<000000?ofkP3om^h0;`3om^h00`000000ooK^0?ofkP350?ofkP40oooo
00360?ofkP030000003om^h0ooK^0300ooK^00<000000?ofkP3om^h0<03om^h00`000000ooK^0?of
kP340?ofkP40oooo00350?ofkP030000003om^h0ooK^0340ooK^00<000000?ofkP3om^h0<@3om^h0
0`000000ooK^0?ofkP330?ofkP40oooo00340?ofkP030000003om^h0ooK^0380ooK^00<000000?of
kP3om^h0<P3om^h00`000000ooK^0?ofkP320?ofkP40oooo00320?ofkP800000=@3om^h00`000000
ooK^0?ofkP0c0?ofkP800000`P3om^h10?ooo`00`@3om^h00`000000ooK^0?ofkP0e0?ofkP030000
003om^h0ooK^03D0ooK^00<000000?ofkP3om^h0_`3om^h10?ooo`00`03om^h00`000000ooK^0?of
kP0f0?ofkP030000003om^h0ooK^03H0ooK^00<000000?ofkP3om^h0_P3om^h10?ooo`00_`3om^h0
0`000000ooK^0?ofkP0g0?ofkP030000003om^h0ooK^03L0ooK^00<000000?ofkP3om^h0_@3om^h1
0?ooo`00_P3om^h00`000000ooK^0?ofkP0h0?ofkP030000003om^h0ooK^03P0ooK^00<000000?of
kP3om^h0_03om^h10?ooo`00_03om^h2000003/0ooK^00<000000?ofkP3om^h0>@3om^h200000;`0
ooK^0@3oool00;/0ooK^00<000000?ofkP3om^h0>`3om^h00`000000ooK^0?ofkP0k0?ofkP030000
003om^h0ooK^0;T0ooK^0@3oool00;X0ooK^00<000000?ofkP3om^h0?03om^h00`000000ooK^0?of
kP0l0?ofkP030000003om^h0ooK^0;P0ooK^0@3oool00;T0ooK^00<000000?ofkP3om^h0?@3om^h0
0`000000ooK^0?ofkP0m0?ofkP030000003om^h0ooK^0;L0ooK^0@3oool00;P0ooK^00<000000?of
kP3om^h0?P3om^h00`000000ooK^0?ofkP0n0?ofkP030000003om^h0ooK^0;H0ooK^0@3oool00;L0
ooK^00<000000?ofkP3om^h0?`3om^h00`000000ooK^0?ofkP0o0?ofkP030000003om^h0ooK^0;D0
ooK^0@3oool00;D0ooK^0P0000120?ofkP030000003om^h0ooK^0400ooK^0P00002e0?ofkP40oooo
002d0?ofkP030000003om^h0ooK^0480ooK^00<000000?ofkP3om^h0@P3om^h00`000000ooK^0?of
kP2b0?ofkP40oooo002c0?ofkP030000003om^h0ooK^04<0ooK^00<000000?ofkP3om^h0@`3om^h0
0`000000ooK^0?ofkP2a0?ofkP40oooo002b0?ofkP030000003om^h0ooK^04@0ooK^00<000000?of
kP3om^h0A03om^h00`000000ooK^0?ofkP2`0?ofkP40oooo002a0?ofkP030000003om^h0ooK^04D0
ooK^00<000000?ofkP3om^h0A@3om^h00`000000ooK^0?ofkP2_0?ofkP40oooo002_0?ofkP800000
B03om^h00`000000ooK^0?ofkP160?ofkP800000[`3om^h10?ooo`00[P3om^h00`000000ooK^0?of
kP180?ofkP030000003om^h0ooK^04P0ooK^00<000000?ofkP3om^h0[03om^h10?ooo`00[@3om^h0
0`000000ooK^0?ofkP190?ofkP030000003om^h0ooK^04T0ooK^00<000000?ofkP3om^h0Z`3om^h1
0?ooo`00[03om^h00`000000ooK^0?ofkP1:0?ofkP030000003om^h0ooK^04X0ooK^00<000000?of
kP3om^h0ZP3om^h10?ooo`00Z`3om^h00`000000ooK^0?ofkP1;0?ofkP030000003om^h0ooK^04/0
ooK^00<000000?ofkP3om^h0Z@3om^h10?ooo`00Z@3om^h2000004h0ooK^00<000000?ofkP3om^h0
C03om^h200000:T0ooK^0@3oool00:P0ooK^00<000000?ofkP3om^h0CP3om^h00`000000ooK^0?of
kP1>0?ofkP030000003om^h0ooK^0:H0ooK^0@3oool00:L0ooK^00<000000?ofkP3om^h0C`3om^h0
0`000000ooK^0?ofkP1?0?ofkP030000003om^h0ooK^0:D0ooK^0@3oool00:H0ooK^00<000000?of
kP3om^h0D03om^h00`000000ooK^0?ofkP1@0?ofkP030000003om^h0ooK^0:@0ooK^0@3oool00:D0
ooK^00<000000?ofkP3om^h0D@3om^h00`000000ooK^0?ofkP1A0?ofkP030000003om^h0ooK^0:<0
ooK^0@3oool00:@0ooK^00<000000?ofkP3om^h0DP3om^h00`000000ooK^0?ofkP1B0?ofkP030000
003om^h0ooK^0:80ooK^0@3oool00:80ooK^0P00001E0?ofkP030000003om^h0ooK^05<0ooK^0P00
002R0?ofkP40oooo002Q0?ofkP030000003om^h0ooK^05D0ooK^00<000000?ofkP3om^h0E@3om^h0
0`000000ooK^0?ofkP2O0?ofkP40oooo002P0?ofkP030000003om^h0ooK^05H0ooK^00<000000?of
kP3om^h0EP3om^h00`000000ooK^0?ofkP2N0?ofkP40oooo002O0?ofkP030000003om^h0ooK^05L0
ooK^00<000000?ofkP3om^h0E`3om^h00`000000ooK^0?ofkP2M0?ofkP40oooo002N0?ofkP030000
003om^h0ooK^05P0ooK^00<000000?ofkP3om^h0F03om^h00`000000ooK^0?ofkP2L0?ofkP40oooo
002L0?ofkP800000F`3om^h00`000000ooK^0?ofkP1I0?ofkP800000W03om^h10?ooo`00V`3om^h0
0`000000ooK^0?ofkP1K0?ofkP030000003om^h0ooK^05/0ooK^00<000000?ofkP3om^h0V@3om^h1
0?ooo`00VP3om^h00`000000ooK^0?ofkP1L0?ofkP030000003om^h0ooK^05`0ooK^00<000000?of
kP3om^h0V03om^h10?ooo`00V@3om^h00`000000ooK^0?ofkP1M0?ofkP030000003om^h0ooK^05d0
ooK^00<000000?ofkP3om^h0U`3om^h10?ooo`00V03om^h00`000000ooK^0?ofkP1N0?ofkP030000
003om^h0ooK^05h0ooK^00<000000?ofkP3om^h0UP3om^h10?ooo`00U`3om^h00`000000ooK^0?of
kP1O0?ofkP030000003om^h0ooK^05l0ooK^00<000000?ofkP3om^h0U@3om^h10?ooo`00U@3om^h2
00000680ooK^00<000000?ofkP3om^h0H03om^h2000009D0ooK^0@3oool009@0ooK^00<000000?of
kP3om^h0HP3om^h00`000000ooK^0?ofkP1R0?ofkP030000003om^h0ooK^0980ooK^0@3oool009<0
ooK^00<000000?ofkP3om^h0H`3om^h00`000000ooK^0?ofkP1S0?ofkP030000003om^h0ooK^0940
ooK^0@3oool00980ooK^00<000000?ofkP3om^h0I03om^h00`000000ooK^0?ofkP1T0?ofkP030000
003om^h0ooK^0900ooK^0@3oool00940ooK^00<000000?ofkP3om^h0I@3om^h00`000000ooK^0?of
kP1U0?ofkP030000003om^h0ooK^08l0ooK^0@3oool008l0ooK^0P00001X0?ofkP030000003om^h0
ooK^06H0ooK^0P00002?0?ofkP40oooo002>0?ofkP030000003om^h0ooK^06P0ooK^00<000000?of
kP3om^h0J03om^h00`000000ooK^0?ofkP2<0?ofkP40oooo002=0?ofkP030000003om^h0ooK^06T0
ooK^00<000000?ofkP3om^h0J@3om^h00`000000ooK^0?ofkP2;0?ofkP40oooo002<0?ofkP030000
003om^h0ooK^06X0ooK^00<000000?ofkP3om^h0JP3om^h00`000000ooK^0?ofkP2:0?ofkP40oooo
002;0?ofkP030000003om^h0ooK^01<0ooK^2`0mFJ]=0?ofkP030000003om^h0ooK^04/0ooK^2`3D
?ATE0?ofkP030000003om^h0ooK^08T0ooK^0@3oool008T0ooK^0P00000D0?ofkP80?EV[0P3om^h0
0`0mFJ/0ooK^0?ofkP050?ofkP<0?EV[B`3om^h00`000000ooK^0?ofkP190?ofkP<0e3dI1`3om^h0
0`3D?AT0ooK^0?ofkP020=@m6A@0ooK^0P0000290?ofkP40oooo00280?ofkP030000003om^h0ooK^
0140ooK^0`0mFJ/50?ofkP80?EV[1`3om^h303eIZdT0ooK^00<000000?ofkP3om^h0A`3om^h30=@m
6@L0ooK^0P3D?AT50?ofkP<0e3dI4`3om^h00`000000ooK^0?ofkP260?ofkP40oooo00270?ofkP03
0000003om^h0ooK^0100ooK^0P0mFJ/:0?ofkP0303eIZ`3om^h0ooK^00D0ooK^100mFJ]70?ofkP03
0000003om^h0ooK^04D0ooK^103D?AT70?ofkP030=@m6@3om^h0ooK^00P0ooK^0P3D?ATB0?ofkP03
0000003om^h0ooK^08D0ooK^0@3oool008H0ooK^00<000000?ofkP3om^h03`3om^h203eIZ`d0ooK^
00<0?EV[0?ofkP3om^h01P3om^h0100mFJ/0ooK^03eIZ`0mFJ]50?ofkP030000003om^h0ooK^04<0
ooK^0P3D?AT00`3om^h0e3dI0?ofkP070?ofkP030=@m6@3om^h0ooK^00/0ooK^0P3D?ATA0?ofkP03
0000003om^h0ooK^08@0ooK^0@3oool008D0ooK^00<000000?ofkP3om^h03P3om^h203eIZ`030?of
kP0mFJ/0?EV[00d0ooK^0P0mFJ/70?ofkP@0?EV[A03om^h00`000000ooK^0?ofkP120?ofkP@0e3dI
1`3om^h20=@m6@d0ooK^0P3D?AT00`3om^h0e3dI0=@m6@0@0?ofkP030000003om^h0ooK^08<0ooK^
0@3oool008@0ooK^00<000000?ofkP3om^h03@3om^h203eIZ`D0ooK^00<0?EV[0?ofkP3om^h0303o
m^h00`0mFJ/0ooK^0?ofkP060?ofkP0403eIZ`3om^h0?EV[03eIZd80ooK^00<000000?ofkP3om^h0
@03om^h40=@m6@P0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP030?ofkP80e3dI
3`3om^h00`000000ooK^0?ofkP220?ofkP40oooo00220?ofkP8000003`3om^h00`0mFJ/0ooK^0?of
kP060?ofkP80?EV[3@3om^h00`0mFJ/0ooK^0?ofkP060?ofkP80?EV[00<0ooK^03eIZ`3om^h0@03o
m^h00`000000ooK^0?ofkP0o0?ofkP040=@m6@3om^h0e3dI0=@m6@P0ooK^00<0e3dI0?ofkP3om^h0
2`3om^h20=@m6@P0ooK^00<0e3dI0?ofkP3om^h03@3om^h200000880ooK^0@3oool00840ooK^00<0
00000?ofkP3om^h03@3om^h203eIZ`/0ooK^00<0?EV[0?ofkP3om^h02`3om^h203eIZ`L0ooK^0P0m
FJ/00`3om^h0?EV[03eIZ`0o0?ofkP030000003om^h0ooK^03d0ooK^0P3D?AT00`3om^h0e3dI0=@m
6@070?ofkP80e3dI3@3om^h00`3D?AT0ooK^0?ofkP090?ofkP80e3dI3`3om^h00`000000ooK^0?of
kP1o0?ofkP40oooo00200?ofkP030000003om^h0ooK^00`0ooK^0P0mFJ/>0?ofkP80?EV[3@3om^h0
0`0mFJ/0ooK^0?ofkP050?ofkP<0?EV[00<0ooK^03eIZ`3om^h0?@3om^h00`000000ooK^0?ofkP0l
0?ofkP030=@m6@3om^h0e3dI0080e3dI1`3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP80e3dI3P3om^h2
0=@m6@h0ooK^00<000000?ofkP3om^h0OP3om^h10?ooo`00O`3om^h00`000000ooK^0?ofkP0<0?of
kP0303eIZ`3om^h0ooK^0100ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP040?of
kP@0?EV[00<0ooK^03eIZ`0mFJ/0?03om^h00`000000ooK^0?ofkP0j0?ofkP80e3dI00<0ooK^0=@m
6@3D?AT00P3D?AT60?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h0403om^h00`3D
?AT0ooK^0?ofkP0<0?ofkP030000003om^h0ooK^07d0ooK^0@3oool007h0ooK^00<000000?ofkP3o
m^h0303om^h0100mFJ/0ooK^03eIZ`0mFJ/A0?ofkP80?EV[303om^h203eIZ`D0ooK^00<0?EV[0?of
kP0mFJ/00P0mFJ/00`3om^h0?EV[0?ofkP0j0?ofkP030000003om^h0ooK^03T0ooK^00<0e3dI0?of
kP3D?AT00P3D?AT00`3om^h0e3dI0?ofkP040?ofkP80e3dI303om^h20=@m6A40ooK^0P3D?AT00`3o
m^h0e3dI0?ofkP0=0?ofkP030000003om^h0ooK^07`0ooK^0@3oool007`0ooK^0P00000=0?ofkP80
?EV[103om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3o
m^h00P3om^h903eIZcT0ooK^00<000000?ofkP3om^h0=`3om^h90=@m6@@0ooK^00<0e3dI0?ofkP3o
m^h02`3om^h00`3D?AT0ooK^0?ofkP0@0?ofkP030=@m6@3om^h0ooK^0080ooK^0P3D?AT=0?ofkP80
0000O03om^h10?ooo`00N`3om^h00`000000ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00D0ooK^
00<0?EV[0?ofkP3om^h0403om^h203eIZ`/0ooK^1P0mFJ/40?ofkPD0?EV[>03om^h00`000000ooK^
0?ofkP0f0?ofkPD0e3dI103om^h60=@m6@/0ooK^0P3D?ATB0?ofkP030=@m6@3om^h0ooK^00D0ooK^
00<0e3dI0?ofkP3om^h0303om^h00`000000ooK^0?ofkP1i0?ofkP40oooo001j0?ofkP030000003o
m^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h01`3om^h203eIZa80ooK^00<0?EV[0?ofkP3om^h01@3o
m^h303eIZ`80ooK^0P0mFJ/20?ofkP0303eIZ`3om^h0ooK^0080ooK^1P0mFJ/f0?ofkP030000003o
m^h0ooK^03@0ooK^1P3D?AT40?ofkP030=@m6@3om^h0ooK^0080e3dI0P3om^h30=@m6@L0ooK^00<0
e3dI0?ofkP3om^h0403om^h20=@m6@T0ooK^00<0e3dI0?ofkP3om^h0303om^h00`000000ooK^0?of
kP1h0?ofkP40oooo001i0?ofkP030000003om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h02P3om^h0
0`0mFJ/0ooK^0?ofkP0@0?ofkP80?EV[0P3om^h303eIZ`L0ooK^0`0mFJ/60?ofkP80?EV[00<0ooK^
03eIZ`0mFJ/0=@3om^h00`000000ooK^0?ofkP0c0?ofkP80e3dI00<0ooK^0=@m6@3D?AT01P3om^h3
0=@m6@L0ooK^0`3D?AT20?ofkP80e3dI4P3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0
ooK^00`0ooK^00<000000?ofkP3om^h0M`3om^h10?ooo`00N03om^h00`000000ooK^0?ofkP0<0?of
kP0303eIZ`3om^h0ooK^00`0ooK^0P0mFJ/B0?ofkP80?EV[303om^h00`0mFJ/0ooK^0?ofkP050?of
kP<0?EV[00<0ooK^03eIZ`0mFJ/0<`3om^h00`000000ooK^0?ofkP0a0?ofkP80e3dI00@0ooK^0=@m
6@3D?AT0e3dI1`3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP80e3dI4P3om^h20=@m6@h0ooK^00<0e3dI
0?ofkP3om^h0303om^h00`000000ooK^0?ofkP1f0?ofkP40oooo001g0?ofkP030000003om^h0ooK^
00/0ooK^0P0mFJ/A0?ofkP0303eIZ`3om^h0ooK^00d0ooK^0P0mFJ/00`3om^h0?EV[03eIZ`0<0?of
kP80?EV[1P3om^h303eIZ`030?ofkP0mFJ/0?EV[0380ooK^00<000000?ofkP3om^h0<03om^h20=@m
6@040?ofkP3D?AT0e3dI0=@m6@H0ooK^0P3D?AT<0?ofkP80e3dI00<0ooK^0=@m6@3D?AT03`3om^h0
0`3D?AT0ooK^0?ofkP0?0?ofkP80e3dI3@3om^h00`000000ooK^0?ofkP1e0?ofkP40oooo001e0?of
kP8000003@3om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP80?EV[2`3om^h203eIZ`D0ooK^00<0?EV[0?of
kP3om^h02@3om^h00`0mFJ/0ooK^03eIZ`070?ofkPD0?EV[<@3om^h00`000000ooK^0?ofkP0_0?of
kPD0e3dI1`3om^h00`3D?AT0ooK^0=@m6@0;0?ofkP030=@m6@3om^h0ooK^00<0ooK^0P3D?AT;0?of
kP80e3dI503om^h00`3D?AT0ooK^0?ofkP0;0?ofkP800000M@3om^h10?ooo`00M03om^h00`000000
ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^01D0ooK^00<0?EV[0?ofkP3om^h01P3om^h203eIZ`P0
ooK^0P0mFJ/90?ofkPD0?EV[1P3om^h303eIZ`030?ofkP0mFJ/0?EV[02l0ooK^00<000000?ofkP3o
m^h0;@3om^h20=@m6@040?ofkP3D?AT0e3dI0=@m6@H0ooK^1@3D?AT90?ofkP80e3dI203om^h20=@m
6@P0ooK^00<0e3dI0?ofkP3om^h05@3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030000003om^h0ooK^
0780ooK^0@3oool007<0ooK^00<000000?ofkP3om^h0303om^h0100mFJ/0ooK^03eIZ`0mFJ/F0?of
kP0303eIZ`3om^h0ooK^00<0ooK^0P0mFJ/<0?ofkP0303eIZ`3om^h0ooK^00H0ooK^00D0?EV[0?of
kP3om^h0?EV[0?ofkP0203eIZ`H0ooK^0`0mFJ/00`3om^h0?EV[0?ofkP0]0?ofkP030000003om^h0
ooK^02`0ooK^00<0e3dI0?ofkP3D?AT00P3D?AT60?ofkP80e3dI00D0ooK^0=@m6@3om^h0ooK^0=@m
6@080?ofkP030=@m6@3om^h0ooK^00X0ooK^0P3D?AT50?ofkP030=@m6@3om^h0ooK^01@0ooK^0P3D
?AT00`3om^h0e3dI0?ofkP0=0?ofkP030000003om^h0ooK^0740ooK^0@3oool00780ooK^00<00000
0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP020?ofkP80?EV[5@3om^h203eIZ`030?ofkP0mFJ/0
?EV[00l0ooK^0P0mFJ/60?ofkP0403eIZ`3om^h0ooK^0?ofkP80?EV[00<0ooK^03eIZ`3om^h01@3o
m^h303eIZ`030?ofkP0mFJ/0ooK^02`0ooK^00<000000?ofkP3om^h0:`3om^h00`3D?AT0ooK^0=@m
6@020=@m6@H0ooK^00@0e3dI0?ofkP3D?AT0e3dI0`3om^h00`3D?AT0ooK^0?ofkP040?ofkP80e3dI
3`3om^h20=@m6@030?ofkP3D?AT0e3dI01D0ooK^0P3D?AT40?ofkP030=@m6@3om^h0ooK^00`0ooK^
00<000000?ofkP3om^h0L03om^h10?ooo`00L@3om^h00`000000ooK^0?ofkP0<0?ofkP0303eIZ`3o
m^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h0503om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP80?EV[103o
m^h00`0mFJ/0ooK^0?ofkP030?ofkP0403eIZ`3om^h0?EV[03eIZ`H0ooK^0P0mFJ/00`3om^h0?EV[
03eIZ`0[0?ofkP030000003om^h0ooK^02T0ooK^0P3D?AT00`3om^h0e3dI0=@m6@060?ofkP80e3dI
00<0ooK^0=@m6@3om^h0103om^h00`3D?AT0ooK^0?ofkP020?ofkP80e3dI4`3om^h00`3D?AT0ooK^
0?ofkP0D0?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h0303om^h00`000000ooK^
0?ofkP1_0?ofkP40oooo001_0?ofkP8000003P3om^h00`0mFJ/0ooK^0?ofkP070?ofkP80?EV[4`3o
m^h0100mFJ/0ooK^03eIZ`0mFJ/C0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/01P3om^h203eIZ`03
0?ofkP0mFJ/0?EV[00@0ooK^100mFJ/00`3om^h0?EV[0?ofkP0Y0?ofkP030000003om^h0ooK^02P0
ooK^00<0e3dI0?ofkP3D?AT00`3D?AT40?ofkP80e3dI00<0ooK^0=@m6@3D?AT01P3om^h01@3D?AT0
ooK^0?ofkP3om^h0e3dI01<0ooK^0P3D?AT00`3om^h0e3dI0?ofkP0B0?ofkP80e3dI2@3om^h00`3D
?AT0ooK^0?ofkP0<0?ofkP800000K`3om^h10?ooo`00KP3om^h00`000000ooK^0?ofkP0=0?ofkP03
03eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h03P3om^h203eIZ`@0ooK^00<0?EV[0?ofkP3o
m^h04@3om^h203eIZ`030?ofkP0mFJ/0ooK^00L0ooK^00<0?EV[0?ofkP0mFJ/02@0mFJ/00`3om^h0
?EV[03eIZ`0X0?ofkP030000003om^h0ooK^02H0ooK^0P3D?AT00`3om^h0e3dI0=@m6@080=@m6@03
0?ofkP3D?AT0ooK^00L0ooK^00@0e3dI0?ofkP3D?AT0e3dI4`3om^h00`3D?AT0ooK^0?ofkP020?of
kP80e3dI403om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<000000?of
kP3om^h0K03om^h10?ooo`00K@3om^h00`000000ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00`0
ooK^0P0mFJ/=0?ofkP0303eIZ`3om^h0ooK^00D0ooK^0P0mFJ/C0?ofkP80?EV[1`3om^h303eIZ`80
ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`020?ofkP<0?EV[00<0ooK^03eIZ`3om^h09P3om^h00`00
0000ooK^0?ofkP0U0?ofkP030=@m6@3om^h0e3dI0080e3dI0P3om^h01@3D?AT0ooK^0?ofkP3om^h0
e3dI0080ooK^0`3D?AT70?ofkP80e3dI4`3om^h20=@m6@L0ooK^00<0e3dI0?ofkP3om^h02`3om^h2
0=@m6@h0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`000000ooK^0?ofkP1[0?ofkP40oooo001/0?of
kP030000003om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h03`3om^h203eIZ`X0ooK^00<0?EV[0?of
kP3om^h0203om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP80?EV[0P3om^h403eIZ`<0ooK^0P0mFJ/01@3o
m^h0?EV[03eIZ`3om^h0?EV[00<0ooK^1@0mFJ/V0?ofkP030000003om^h0ooK^02@0ooK^1@3D?AT3
0?ofkP050=@m6@3om^h0e3dI0=@m6@3om^h00P3D?AT30?ofkP@0e3dI0P3om^h20=@m6A<0ooK^00<0
e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP080?ofkP80e3dI4@3om^h00`3D?AT0ooK^0?of
kP0=0?ofkP030000003om^h0ooK^06X0ooK^0@3oool006/0ooK^00<000000?ofkP3om^h03@3om^h0
0`0mFJ/0ooK^0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h02P3om^h2
03eIZa40ooK^00@0?EV[0?ofkP0mFJ/0?EV[2@3om^h01P0mFJ/0ooK^0?ofkP0mFJ/0ooK^03eIZ`@0
ooK^1@0mFJ/T0?ofkP030000003om^h0ooK^0280ooK^1@3D?AT40?ofkP030=@m6@3om^h0e3dI0080
ooK^00<0e3dI0?ofkP3om^h01`3om^h20=@m6@030?ofkP3D?AT0ooK^0100ooK^0P3D?AT<0?ofkP03
0=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h04P3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP03
0000003om^h0ooK^06T0ooK^0@3oool006T0ooK^0P00000?0?ofkP0303eIZ`3om^h0ooK^01@0ooK^
0P0mFJ/40?ofkP80?EV[3`3om^h203eIZ`l0ooK^0P0mFJ/00`3om^h0?EV[0?ofkP090?ofkP80?EV[
00<0ooK^03eIZ`0mFJ/01@3om^h503eIZb<0ooK^00<000000?ofkP3om^h08@3om^h50=@m6@D0ooK^
0P3D?AT00`3om^h0e3dI0=@m6@0:0?ofkP040=@m6@3om^h0e3dI0=@m6@l0ooK^0P3D?AT?0?ofkP80
e3dI103om^h20=@m6AH0ooK^00<0e3dI0?ofkP3om^h03@3om^h2000006T0ooK^0@3oool006P0ooK^
00<000000?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0G0?ofkP80?EV[00<0ooK^03eIZ`3om^h0
4P3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP<0?EV[0`3om^h203eIZ`X0ooK^00@0?EV[0?ofkP0mFJ/0
?EV[1P3om^h203eIZ`030?ofkP0mFJ/0?EV[0240ooK^00<000000?ofkP3om^h07`3om^h20=@m6@03
0?ofkP3D?AT0e3dI00H0ooK^0P3D?AT00`3om^h0e3dI0?ofkP090?ofkP80e3dI0`3om^h30=@m6@`0
ooK^00<0e3dI0?ofkP3om^h04@3om^h0103D?AT0ooK^0=@m6@3D?ATI0?ofkP030=@m6@3om^h0ooK^
00h0ooK^00<000000?ofkP3om^h0IP3om^h10?ooo`00I`3om^h00`000000ooK^0?ofkP0>0?ofkP04
03eIZ`3om^h0?EV[03eIZaT0ooK^00<0?EV[0?ofkP3om^h04`3om^h203eIZ`P0ooK^0P0mFJ/20?of
kP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h0203om^h403eIZ`H0ooK^1@0mFJ/P0?of
kP030000003om^h0ooK^01h0ooK^1@3D?AT60?ofkP@0e3dI2P3om^h00`3D?AT0ooK^0?ofkP030?of
kP030=@m6@3om^h0ooK^0080e3dI203om^h20=@m6AD0ooK^00<0e3dI0?ofkP3om^h05`3om^h20=@m
6@030?ofkP3D?AT0ooK^00l0ooK^00<000000?ofkP3om^h0I@3om^h10?ooo`00IP3om^h00`000000
ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^0080ooK^0P0mFJ/F0?ofkP0403eIZ`3om^h0?EV[03eI
ZaD0ooK^00<0?EV[0?ofkP3om^h00`3om^h203eIZ`@0ooK^0`0mFJ/40?ofkP0303eIZ`3om^h0ooK^
00T0ooK^00<0?EV[0?ofkP0mFJ/01`3om^h203eIZ`030?ofkP0mFJ/0?EV[01h0ooK^00<000000?of
kP3om^h0703om^h50=@m6@L0ooK^00<0e3dI0?ofkP3D?AT02`3om^h00`3D?AT0ooK^0?ofkP020?of
kP<0e3dI103om^h20=@m6@D0ooK^00<0e3dI0?ofkP3om^h04`3om^h20=@m6@030?ofkP3D?AT0ooK^
01D0ooK^0P3D?AT40?ofkP030=@m6@3om^h0ooK^00h0ooK^00<000000?ofkP3om^h0I03om^h10?oo
o`00I@3om^h00`000000ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3o
m^h04P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^01<0ooK^0P0mFJ/00`3om^h0
?EV[03eIZ`060?ofkP0403eIZ`3om^h0ooK^03eIZ`@0ooK^0P0mFJ/90?ofkPD0?EV[1P3om^h303eI
Z`030?ofkP0mFJ/0ooK^01`0ooK^00<000000?ofkP3om^h06`3om^h00`3D?AT0ooK^0=@m6@020=@m
6@H0ooK^1@3D?AT90?ofkP80e3dI103om^h0103D?AT0ooK^0?ofkP3D?AT60?ofkP80e3dI00<0ooK^
0=@m6@3D?AT05@3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^0180ooK^00<0e3dI
0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030000003om^h0ooK^06<0ooK^0@3oool0
06@0ooK^00<000000?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP060?ofkP80?EV[4@3om^h00`0m
FJ/0ooK^0?ofkP040?ofkP80?EV[5@3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0403eIZ`3om^h0ooK^
0?ofkP80?EV[103om^h00`0mFJ/0ooK^0?ofkP060?ofkP0603eIZ`3om^h0ooK^03eIZ`3om^h0?EV[
1P3om^h303eIZ`030?ofkP0mFJ/0?EV[01/0ooK^00<000000?ofkP3om^h06@3om^h20=@m6@040?of
kP3D?AT0e3dI0=@m6@H0ooK^00<0e3dI0?ofkP3D?AT00P3om^h00`3D?AT0ooK^0?ofkP060?ofkP03
0=@m6@3om^h0ooK^0080ooK^0P3D?AT30?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3o
m^h04`3om^h20=@m6@H0ooK^00<0e3dI0?ofkP3om^h03`3om^h20=@m6@P0ooK^00<0e3dI0?ofkP3o
m^h03`3om^h00`000000ooK^0?ofkP1R0?ofkP40oooo001R0?ofkP8000004@3om^h00`0mFJ/0ooK^
0?ofkP090?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^
0?ofkP0A0?ofkP0403eIZ`3om^h0?EV[03eIZ`D0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0
ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00D0ooK^00@0?EV[0?ofkP3om^h0ooK^0`0mFJ/70?of
kP80?EV[0P3om^h203eIZaT0ooK^00<000000?ofkP3om^h05`3om^h20=@m6@80ooK^0P3D?AT70?of
kP<0e3dI0`3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?of
kP3om^h0103om^h00`3D?AT0ooK^0?ofkP030?ofkP80e3dI00<0ooK^0=@m6@3om^h04P3om^h00`3D
?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D
?AT0ooK^0?ofkP0?0?ofkP800000HP3om^h10?ooo`00H@3om^h00`000000ooK^0?ofkP0@0?ofkP03
03eIZ`3om^h0ooK^00/0ooK^0P0mFJ/<0?ofkP0303eIZ`3om^h0ooK^00T0ooK^0P0mFJ/?0?ofkP80
?EV[103om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00D0ooK^0P0mFJ/30?ofkP80
?EV[1@3om^h00`0mFJ/0ooK^0?ofkP030?ofkP<0?EV[1@3om^h403eIZ`80ooK^00<0?EV[0?ofkP3o
m^h05P3om^h00`000000ooK^0?ofkP0F0?ofkP030=@m6@3om^h0ooK^00@0e3dI1@3om^h30=@m6@D0
ooK^00<0e3dI0?ofkP3om^h00`3om^h20=@m6@<0ooK^0P3D?AT70?ofkP030=@m6@3om^h0ooK^0080
ooK^00<0e3dI0?ofkP3om^h00P3om^h20=@m6@l0ooK^0P3D?AT;0?ofkP030=@m6@3om^h0ooK^00X0
ooK^0P3D?AT=0?ofkP030=@m6@3om^h0ooK^0100ooK^00<000000?ofkP3om^h0G`3om^h10?ooo`00
H03om^h00`000000ooK^0?ofkP0@0?ofkP0303eIZ`3om^h0ooK^00h0ooK^0P0mFJ/90?ofkP0303eI
Z`3om^h0ooK^00`0ooK^0P0mFJ/<0?ofkP0303eIZ`3om^h0ooK^00D0ooK^0P0mFJ/20?ofkP0303eI
Z`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eI
Z`3om^h0ooK^00@0ooK^3@0mFJ/00`3om^h0?EV[03eIZ`0F0?ofkP030000003om^h0ooK^01@0ooK^
0P3D?AT00`3om^h0e3dI0=@m6@0;0=@m6@H0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^
0?ofkP020?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h00P3D?AT70?ofkP030=@m
6@3om^h0ooK^00X0ooK^0P3D?AT>0?ofkP030=@m6@3om^h0ooK^00L0ooK^0P3D?AT@0?ofkP030=@m
6@3om^h0ooK^0100ooK^00<000000?ofkP3om^h0GP3om^h10?ooo`00G`3om^h00`000000ooK^0?of
kP0@0?ofkP0303eIZ`3om^h0ooK^0140ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?of
kP0?0?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^03eI
Z`0:0?ofkP0303eIZ`3om^h0ooK^0080ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`040?ofkP<0?EV[
00@0ooK^03eIZ`0mFJ/0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP0403eIZ`030?ofkP0mFJ/0ooK^01@0
ooK^00<000000?ofkP3om^h04`3om^h00`3D?AT0ooK^0=@m6@030=@m6@80ooK^00@0e3dI0?ofkP3o
m^h0ooK^0`3D?AT0103om^h0e3dI0=@m6@3D?AT40?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT0103o
m^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0e3dI00X0ooK^00<0e3dI0?ofkP3om^h0203o
m^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h04@3o
m^h00`3D?AT0ooK^0?ofkP0@0?ofkP030000003om^h0ooK^05d0ooK^0@3oool005h0ooK^00<00000
0?ofkP3om^h0403om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP80?EV[103om^h00`0mFJ/0ooK^0?ofkP0A
0?ofkP80?EV[1`3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP80?EV[2`3om^h203eIZ`<0ooK^0P0mFJ/0
0`3om^h0?EV[03eIZ`0303eIZ`D0ooK^0`0mFJ/30?ofkP0403eIZ`3om^h0ooK^0?ofkPH0?EV[4`3o
m^h00`000000ooK^0?ofkP0A0?ofkPH0e3dI0`3om^h0103D?AT0ooK^0?ofkP3om^h30=@m6@D0ooK^
1@3D?AT00`3om^h0e3dI0=@m6@030?ofkP80e3dI2`3om^h20=@m6@`0ooK^00<0e3dI0?ofkP3om^h0
1@3om^h20=@m6A<0ooK^00<0e3dI0?ofkP3om^h00P3om^h20=@m6A@0ooK^00<0e3dI0?ofkP3om^h0
4@3om^h00`000000ooK^0?ofkP1L0?ofkP40oooo001L0?ofkP8000004`3om^h00`0mFJ/0ooK^0?of
kP0E0?ofkP80?EV[00<0ooK^03eIZ`3om^h05@3om^h00`0mFJ/0ooK^0?ofkP020?ofkP80?EV[3P3o
m^h303eIZ`/0ooK^00<0?EV[0?ofkP3om^h00P3om^h203eIZ`/0ooK^0`0mFJ/00`3om^h0?EV[0?of
kP030?ofkP<0?EV[00<0ooK^03eIZ`0mFJ/04P3om^h00`000000ooK^0?ofkP0@0?ofkP80e3dI00@0
ooK^0=@m6@3D?AT0e3dI103om^h00`3D?AT0ooK^0=@m6@020=@m6@/0ooK^0P3D?AT40?ofkP030=@m
6@3om^h0ooK^00T0ooK^0`3D?AT>0?ofkP80e3dI103om^h00`3D?AT0ooK^0?ofkP0D0?ofkP040=@m
6@3om^h0e3dI0=@m6AL0ooK^00<0e3dI0?ofkP3om^h04@3om^h2000005`0ooK^0@3oool005/0ooK^
00<000000?ofkP3om^h04P3om^h00`0mFJ/0ooK^0?ofkP0H0?ofkP0303eIZ`3om^h0ooK^01H0ooK^
0P0mFJ/00`3om^h0?EV[0?ofkP0?0?ofkP0403eIZ`3om^h0ooK^03eIZ`/0ooK^100mFJ/00`3om^h0
?EV[03eIZ`0;0?ofkP<0?EV[00<0ooK^03eIZ`3om^h0103om^h203eIZ`80ooK^00<0?EV[0?ofkP3o
m^h03`3om^h00`000000ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^0080e3dI1@3om^h00`3D?AT0
ooK^0=@m6@020=@m6@/0ooK^0P3D?AT00`3om^h0e3dI0=@m6@020=@m6@/0ooK^00@0e3dI0?ofkP3o
m^h0e3dI403om^h0103D?AT0ooK^0=@m6@3D?ATH0?ofkP030=@m6@3om^h0ooK^01P0ooK^00<0e3dI
0?ofkP3om^h04P3om^h00`000000ooK^0?ofkP1I0?ofkP40oooo001J0?ofkP030000003om^h0ooK^
0180ooK^00<0?EV[0?ofkP3om^h0603om^h0100mFJ/0ooK^03eIZ`0mFJ/H0?ofkP0303eIZ`3om^h0
ooK^00l0ooK^00@0?EV[0?ofkP3om^h0ooK^0P0mFJ/90?ofkP<0?EV[0P3om^h0100mFJ/0ooK^03eI
Z`0mFJ/;0?ofkP<0?EV[1P3om^h303eIZ`030?ofkP0mFJ/0?EV[00l0ooK^00<000000?ofkP3om^h0
3@3om^h20=@m6@040?ofkP3D?AT0e3dI0=@m6@H0ooK^0`3D?AT<0?ofkP030=@m6@3om^h0e3dI0080
ooK^0`3D?AT90?ofkP80e3dI0`3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^01H0
ooK^0P3D?AT00`3om^h0e3dI0?ofkP0I0?ofkP030=@m6@3om^h0ooK^0180ooK^00<000000?ofkP3o
m^h0F03om^h10?ooo`00F@3om^h00`000000ooK^0?ofkP0B0?ofkP0403eIZ`3om^h0?EV[03eIZaL0
ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP0403eIZ`3om^h0?EV[03eI
Z`h0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP040?ofkP80?EV[0`3om^h303eI
Z`<0ooK^00<0?EV[0?ofkP3om^h02@3om^h303eIZ`L0ooK^1@0mFJ/>0?ofkP030000003om^h0ooK^
00`0ooK^1@3D?AT70?ofkP<0e3dI2`3om^h20=@m6@80ooK^0`3D?AT30?ofkP80e3dI1P3om^h00`3D
?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00`0ooK^0P3D?AT00`3om^h0e3dI0?ofkP0E0?of
kP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h05@3om^h20=@m6@030?ofkP3D?AT0ooK^
01<0ooK^00<000000?ofkP3om^h0E`3om^h10?ooo`00F03om^h00`000000ooK^0?ofkP0C0?ofkP04
03eIZ`3om^h0ooK^0?ofkP80?EV[503om^h00`0mFJ/0ooK^0?ofkP040?ofkP80?EV[4`3om^h00`0m
FJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h01@3om^h203eI
Z`80ooK^0P0mFJ/70?ofkP0303eIZ`3om^h0ooK^0080ooK^0P0mFJ/;0?ofkP80?EV[1`3om^h303eI
Z`030?ofkP0mFJ/0ooK^00`0ooK^00<000000?ofkP3om^h02`3om^h00`3D?AT0ooK^0=@m6@020=@m
6@L0ooK^0P3D?AT;0?ofkP80e3dI103om^h00`3D?AT0ooK^0?ofkP050?ofkP80e3dI0P3om^h20=@m
6@L0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^
0140ooK^0P3D?AT50?ofkP030=@m6@3om^h0ooK^01<0ooK^0P3D?AT30?ofkP030=@m6@3om^h0ooK^
01<0ooK^00<000000?ofkP3om^h0EP3om^h10?ooo`00E`3om^h00`000000ooK^0?ofkP0C0?ofkP03
03eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h04@3om^h00`0mFJ/0ooK^0?ofkP060?ofkP03
03eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h0103om^h203eIZ`/0ooK^00<0?EV[0?ofkP3o
m^h01`3om^h203eIZ`T0ooK^0`0mFJ/40?ofkP80?EV[2@3om^h403eIZ`L0ooK^1@0mFJ/;0?ofkP03
0000003om^h0ooK^00T0ooK^1@3D?AT70?ofkP@0e3dI2P3om^h00`3D?AT0ooK^0?ofkP020?ofkP<0
e3dI2@3om^h20=@m6@T0ooK^00<0e3dI0?ofkP3om^h02@3om^h20=@m6@H0ooK^00<0e3dI0?ofkP3o
m^h03`3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^0140ooK^00<0e3dI0?ofkP3o
m^h0103om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030000003om^h0ooK^05D0ooK^0@3oool005D0ooK^
0P00000E0?ofkP0303eIZ`3om^h0ooK^00H0ooK^0P0mFJ/@0?ofkP0303eIZ`3om^h0ooK^00P0ooK^
0P0mFJ/>0?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^
0?ofkP060?ofkP0403eIZ`3om^h0?EV[03eIZ`P0ooK^00@0?EV[0?ofkP3om^h0?EV[1@3om^h203eI
Z`L0ooK^00<0?EV[0?ofkP3om^h00P0mFJ/70?ofkP<0?EV[00<0ooK^03eIZ`3om^h02@3om^h00`00
0000ooK^0?ofkP080?ofkP030=@m6@3om^h0e3dI0080e3dI1`3om^h20=@m6@80ooK^00<0e3dI0?of
kP3om^h01P3om^h20=@m6@@0ooK^00@0e3dI0?ofkP3om^h0e3dI203om^h20=@m6@030?ofkP3D?AT0
e3dI00L0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0
ooK^00`0ooK^0P3D?AT:0?ofkP030=@m6@3om^h0ooK^00h0ooK^0P3D?AT80?ofkP030=@m6@3om^h0
ooK^01<0ooK^0P00001E0?ofkP40oooo001D0?ofkP030000003om^h0ooK^01D0ooK^00<0?EV[0?of
kP3om^h0203om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00/0ooK^0P0mFJ/;0?of
kP0303eIZ`3om^h0ooK^00T0ooK^0P0mFJ/80?ofkP<0?EV[103om^h203eIZ`@0ooK^00<0?EV[0?of
kP3om^h01@3om^h0100mFJ/0ooK^0?ofkP3om^h203eIZ`D0ooK^00<0?EV[0?ofkP3om^h0103om^h0
100mFJ/0ooK^0?ofkP3om^h303eIZ`L0ooK^100mFJ/90?ofkP030000003om^h0ooK^00L0ooK^103D
?AT70?ofkP<0e3dI0`3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^0080ooK^0P3D
?AT30?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?of
kP020?ofkP<0e3dI2@3om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^00T0ooK^0P3D
?AT=0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?of
kP0E0?ofkP030000003om^h0ooK^0580ooK^0@3oool005<0ooK^00<000000?ofkP3om^h05@3om^h0
0`0mFJ/0ooK^0?ofkP0:0?ofkP80?EV[2`3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0
ooK^00L0ooK^00<0?EV[0?ofkP3om^h0303om^h203eIZ`D0ooK^00D0?EV[0?ofkP3om^h0ooK^03eI
Z`020?ofkP0303eIZ`3om^h0ooK^00D0ooK^0P0mFJ/40?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0
?EV[0?ofkP3om^h00`3om^h203eIZ`@0ooK^00<0?EV[0?ofkP3om^h00P3om^h?03eIZ`D0ooK^0P00
00000`3om^h00000000000050?ofkPl0e3dI103om^h00`3D?AT0ooK^0?ofkP030?ofkP80e3dI103o
m^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^0080ooK^0P3D?AT70?ofkP040=@m6@3o
m^h0ooK^0=@m6@<0ooK^00<0e3dI0?ofkP3om^h0103om^h20=@m6@d0ooK^00<0e3dI0?ofkP3om^h0
1`3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00T0ooK^0P3D?AT<0?ofkP030=@m
6@3om^h0ooK^01D0ooK^00<000000?ofkP3om^h0D@3om^h10?ooo`00DP3om^h00`000000ooK^0?of
kP0E0?ofkP0303eIZ`3om^h0ooK^00d0ooK^0P0mFJ/80?ofkP0303eIZ`3om^h0ooK^0100ooK^0P0m
FJ/60?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?of
kP020?ofkP80?EV[2P3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00L0ooK^0P0mFJ/50?ofkP80?EV[
0P3om^h503eIZ`80ooK^0`0mFJ/50?ofkP0303eIZ`3om^h0?EV[00<0?EV[0`3om^h00`000000ooK^
0?ofkP030?ofkP040000003om^h0ooK^0?ofkP@0e3dI00<0ooK^0=@m6@3om^h0103om^h30=@m6@80
ooK^1@3D?AT30?ofkP80e3dI103om^h20=@m6@L0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0:0?of
kP80e3dI103om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?of
kP3om^h0103om^h20=@m6A80ooK^00<0e3dI0?ofkP3om^h01P3om^h20=@m6@h0ooK^00<0e3dI0?of
kP3om^h05P3om^h00`000000ooK^0?ofkP1@0?ofkP40oooo001A0?ofkP030000003om^h0ooK^01H0
ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^01<0
ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP80?EV[0P3om^h00`0mFJ/0
ooK^0?ofkP020?ofkP0303eIZ`3om^h0?EV[00X0ooK^00@0?EV[0?ofkP3om^h0?EV[2@3om^h00`0m
FJ/0ooK^0?ofkP040?ofkP<0?EV[1`3om^h303eIZ`@0ooK^00<0?EV[0?ofkP3om^h0100mFJ/20000
00L0ooK^0P0000040=@m6@80ooK^00<0e3dI0?ofkP3om^h00P3om^h30=@m6@L0ooK^103D?AT50?of
kP030=@m6@3om^h0ooK^00L0ooK^00@0e3dI0?ofkP3om^h0e3dI2P3om^h0103D?AT0ooK^0?ofkP3D
?AT30?ofkP040=@m6@3om^h0ooK^0?ofkP80e3dI4P3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m
6@3om^h0ooK^0180ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m
6@3om^h0ooK^01H0ooK^00<000000?ofkP3om^h0C`3om^h10?ooo`00C`3om^h2000001P0ooK^00<0
?EV[0?ofkP3om^h04@3om^h203eIZ`@0ooK^00<0?EV[0?ofkP3om^h0503om^h203eIZ`030?ofkP0m
FJ/0ooK^01D0ooK^0P0mFJ/30?ofkP80?EV[0`3om^h203eIZ`T0ooK^0`0mFJ/:0?ofkP0403eIZ`3o
m^h0ooK^0?ofkP80?EV[00@0ooK^03eIZ`0mFJ/0?EV[203om^h303eIZ`80ooK^00<0?EV[0?ofkP3o
m^h00P3om^h0100mFJ/0000003eIZ`0mFJ/70?ofkP80e3dI00<000000=@m6@3om^h00`3om^h00`3D
?AT0ooK^0?ofkP030=@m6@P0ooK^00D0e3dI0?ofkP3D?AT0e3dI0?ofkP020=@m6@80ooK^00<0e3dI
0?ofkP3om^h0203om^h30=@m6@T0ooK^0P3D?AT40?ofkP070=@m6@3om^h0ooK^0?ofkP3D?AT0ooK^
0=@m6@0E0?ofkP040=@m6@3om^h0e3dI0=@m6AH0ooK^00<0e3dI0?ofkP3om^h00P3om^h20=@m6A<0
ooK^00<0e3dI0?ofkP3om^h05P3om^h2000004l0ooK^0@3oool004h0ooK^00<000000?ofkP3om^h0
603om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP80?EV[00<0ooK^03eIZ`3om^h0603om^h00`0mFJ/0ooK^
0?ofkP0F0?ofkP80?EV[00<0ooK^03eIZ`3om^h01P3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eI
Z`3om^h0ooK^00T0ooK^0`0mFJ/50?ofkP0303eIZ`3om^h0ooK^00L0ooK^0`0mFJ/20?ofkP0503eI
Z`3om^h0ooK^0?ofkP0000000P0mFJ/00`3om^h0?EV[0?ofkP040?ofkP050=@m6@3om^h0e3dI0=@m
6@0000000`3om^h00`3D?AT0ooK^0?ofkP030=@m6@T0ooK^0P3D?AT50?ofkP80e3dI2`3om^h00`3D
?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00D0ooK^0P3D?AT00`3om^h0e3dI0=@m6@0G0?of
kP030=@m6@3om^h0ooK^01L0ooK^00@0e3dI0?ofkP3D?AT0e3dI5@3om^h00`3D?AT0ooK^0?ofkP0H
0?ofkP030000003om^h0ooK^04`0ooK^0@3oool004d0ooK^00<000000?ofkP3om^h0603om^h00`0m
FJ/0ooK^0?ofkP0F0?ofkP0303eIZ`3om^h0ooK^01L0ooK^00@0?EV[0?ofkP0mFJ/0?EV[5P3om^h0
0`0mFJ/0ooK^03eIZ`090?ofkP0303eIZ`3om^h0ooK^00L0ooK^0`0mFJ/80?ofkP80?EV[00<0ooK^
03eIZ`3om^h0103om^h203eIZ`X0ooK^100mFJ/00`3om^h00000000000020?ofkPD0?EV[00<00000
0=@m6@3D?AT00`3D?AT20?ofkP80000000<0ooK^0=@m6@3D?AT00P3D?AT:0?ofkP80e3dI1@3om^h0
103D?AT0ooK^0?ofkP3D?AT80?ofkP<0e3dI2@3om^h00`3D?AT0ooK^0?ofkP080?ofkP80e3dI5P3o
m^h20=@m6@030?ofkP3D?AT0ooK^01P0ooK^00<0e3dI0?ofkP3om^h05P3om^h00`3D?AT0ooK^0?of
kP0H0?ofkP030000003om^h0ooK^04/0ooK^0@3oool004`0ooK^00<000000?ofkP3om^h0603om^h0
0`0mFJ/0ooK^0?ofkP0F0?ofkP0403eIZ`3om^h0?EV[03eIZaH0ooK^00<0?EV[0?ofkP3om^h00P3o
m^h00`0mFJ/0ooK^0?ofkP0B0?ofkP0403eIZ`3om^h0?EV[0?ofkP80?EV[203om^h203eIZ`L0ooK^
00@0?EV[0?ofkP3om^h0?EV[1@3om^h203eIZ`@0ooK^0P0mFJ/30?ofkP0403eIZ`3om^h0?EV[03eI
Z`T0ooK^00@0?EV[0?ofkP0mFJ/000001P3om^h01`0mFJ/0000003eIZ`000000e3dI0000003D?AT0
1P3om^h010000000e3dI0?ofkP3D?AT:0?ofkP030=@m6@3om^h0e3dI00<0ooK^0P3D?AT40?ofkP80
e3dI1@3om^h0103D?AT0ooK^0?ofkP3D?AT70?ofkP80e3dI2@3om^h20=@m6@030?ofkP3D?AT0ooK^
01@0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP0D0?ofkP80e3dI00<0ooK^0=@m
6@3om^h05`3om^h00`3D?AT0ooK^0?ofkP0H0?ofkP030000003om^h0ooK^04X0ooK^0@3oool004/0
ooK^00<000000?ofkP3om^h06@3om^h00`0mFJ/0ooK^0?ofkP0F0?ofkP0503eIZ`3om^h0ooK^0?of
kP0mFJ/0503om^h00`0mFJ/0ooK^0?ofkP040?ofkP80?EV[4P3om^h203eIZ`@0ooK^00<0?EV[0?of
kP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0403eIZ`3om^h0ooK^0?ofkP80?EV[00<0ooK^
03eIZ`0mFJ/0203om^h0100mFJ/0ooK^0?ofkP0mFJ/30?ofkP0303eIZ`3om^h0ooK^00L0ooK^0P00
000203eIZ`@0ooK^0P00000203eIZ`030000003D?AT0e3dI00800000103om^h20=@m6@8000002P3o
m^h0103D?AT0ooK^0?ofkP3D?AT20?ofkP030=@m6@3om^h0ooK^00H0ooK^0P3D?AT00`3om^h0e3dI
0=@m6@030?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h01`3om^h20=@m6@@0ooK^
00<0e3dI0?ofkP3om^h0403om^h20=@m6@D0ooK^00<0e3dI0?ofkP3om^h04`3om^h01@3D?AT0ooK^
0?ofkP3om^h0e3dI01P0ooK^00<0e3dI0?ofkP3om^h06@3om^h00`000000ooK^0?ofkP190?ofkP40
oooo00190?ofkP8000006`3om^h00`0mFJ/0ooK^0?ofkP0F0?ofkP0303eIZ`3om^h0ooK^00<0ooK^
0P0mFJ/B0?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^
0?ofkP040?ofkP80?EV[203om^h203eIZ`<0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^
0?ofkP090?ofkP<0?EV[103om^h00`0mFJ/0ooK^0?ofkP050?ofkP070000003om^h0ooK^03eIZ`3o
m^h0?EV[0?ofkP020000000501D60P0000005@H201D60P0mFJ/00P0X<UP0200000006Qdi00000000
0000ooK^0=@m6@3om^h0e3dI0P3om^h00`000000ooK^0?ofkP050?ofkP80e3dI0`3om^h30=@m6@/0
ooK^00<0e3dI0?ofkP3om^h0103om^h0103D?AT0ooK^0?ofkP3om^h20=@m6@T0ooK^00<0e3dI0?of
kP3om^h0103om^h20=@m6A00ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP0@0?of
kP80e3dI1@3om^h00`3D?AT0ooK^0?ofkP0F0?ofkP030=@m6@3om^h0ooK^01T0ooK^0P0000190?of
kP40oooo00180?ofkP030000003om^h0ooK^01X0ooK^00@0?EV[0?ofkP0mFJ/0?EV[5@3om^h00`0m
FJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0m
FJ/0ooK^0?ofkP0=0?ofkP80?EV[203om^h203eIZ`P0ooK^00@0?EV[0?ofkP3om^h0?EV[103om^h2
03eIZ`030?ofkP0mFJ/0?EV[00/0ooK^00<0?EV[0?ofkP3om^h00`3om^h203eIZ`<0ooK^0P000003
0?ofkP<0?EV[00@0000001D60P0E1P8000000`0E1P801@000000:39H02PbF00X<UP0000000806Qdi
00@000000=@m6@3D?AT0e3dI0`3om^h2000000@0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0
ooK^0?ofkP090?ofkP80e3dI00<0ooK^0=@m6@3D?AT0103om^h0103D?AT0ooK^0?ofkP3D?AT90?of
kP80e3dI1`3om^h00`3D?AT0ooK^0=@m6@0>0?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?of
kP3om^h03P3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^01<0ooK^0P3D?AT00`3o
m^h0e3dI0?ofkP0K0?ofkP030000003om^h0ooK^04H0ooK^0@3oool004L0ooK^00<000000?ofkP3o
m^h06`3om^h0100mFJ/0ooK^0?ofkP3om^h203eIZa<0ooK^00<0?EV[0?ofkP3om^h01`3om^h203eI
Z`d0ooK^00<0?EV[0?ofkP3om^h02P3om^h203eIZ`/0ooK^0`0mFJ/;0?ofkP0303eIZ`3om^h0ooK^
00H0ooK^0`0mFJ/30?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h0203om^h303eI
Z`D0ooK^00<0?EV[0?ofkP0000001@3om^h0100mFJ/0ooK^0000000mFJ/2000000@05@H200<00000
02PbF00X<UP00P0X<UP2000000040=@m6@000000ooK^0=@m6@D0ooK^00@000000?ofkP3D?AT0e3dI
103om^h30=@m6@X0ooK^00<0e3dI0?ofkP3om^h00`3om^h0103D?AT0ooK^0?ofkP3om^h30=@m6@P0
ooK^0P3D?AT:0?ofkP030=@m6@3om^h0e3dI00/0ooK^0P3D?AT<0?ofkP030=@m6@3om^h0ooK^00/0
ooK^0P3D?AT90?ofkP030=@m6@3om^h0ooK^0140ooK^0P3D?AT30?ofkP030=@m6@3om^h0ooK^01/0
ooK^00<000000?ofkP3om^h0A@3om^h10?ooo`00AP3om^h00`000000ooK^0?ofkP0K0?ofkP0303eI
Z`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP80?EV[
2P3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00L0ooK^00@0?EV[0?ofkP3om^h0
?EV[303om^h203eIZ`P0ooK^00@0?EV[0?ofkP3om^h0?EV[1`3om^h203eIZ`P0ooK^00@0?EV[0?of
kP3om^h0?EV[1@3om^h00`000000ooK^0?ofkP040?ofkP0503eIZ`0000005@H20000000mFJ/0100E
1P83000000@0:39H00D0e3dI0000000J7CT000000=@m6@060?ofkP030000003om^h0ooK^00<0ooK^
00@0e3dI0?ofkP3om^h0e3dI203om^h20=@m6@L0ooK^00@0e3dI0?ofkP3om^h0e3dI203om^h20=@m
6@`0ooK^00@0e3dI0?ofkP3om^h0e3dI2@3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0
ooK^00P0ooK^0P3D?AT<0?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h0103om^h0
0`3D?AT0ooK^0?ofkP0K0?ofkP030000003om^h0ooK^04@0ooK^0@3oool004D0ooK^00<000000?of
kP3om^h0703om^h00`0mFJ/0ooK^0?ofkP050?ofkP80?EV[3P3om^h00`0mFJ/0ooK^0?ofkP0=0?of
kP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h03`3om^h203eIZ`H0ooK^00D0?EV[0?of
kP3om^h0ooK^03eIZ`0>0?ofkP0303eIZ`3om^h0ooK^00D0ooK^0`0mFJ/:0?ofkP80?EV[1P3om^h0
100mFJ/0ooK^0?ofkP3om^h203eIZ`040?ofkP00000000000?ofkP80?EV[0`3om^h00`000000?EV[
000000020000000301D60P0mFJ/0?EV[0080000000<09PX40000000cA7P00P0000020=@m6@0602Pb
F000000000000000003D?AT000000`3om^h20=@m6@040?ofkP00000000000?ofkP80e3dI0`3om^h0
0`3D?AT0ooK^0?ofkP040?ofkP80e3dI2P3om^h30=@m6@L0ooK^00<0e3dI0?ofkP3om^h0303om^h0
1@3D?AT0ooK^0?ofkP3om^h0e3dI00H0ooK^0P3D?ATA0?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0
e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP0=0?ofkP80e3dI1`3om^h00`3D?AT0ooK^0?of
kP0L0?ofkP030000003om^h0ooK^04<0ooK^0@3oool004@0ooK^00<000000?ofkP3om^h0703om^h0
0`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h03P3om^h2
03eIZ`D0ooK^00<0?EV[0?ofkP3om^h04P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0503eIZ`3om^h0
ooK^0?ofkP0mFJ/0403om^h203eIZ`@0ooK^0P0mFJ/20?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0
?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP040?ofkP030000003om^h0ooK^00<0ooK^0P0m
FJ/00`0000005@H203eIZ`0201D60P050000000E1P805@H20000000mFJ/00P0V2P@01@000000<dAh
03=4N03D?AT000000080:39H00H0000002PbF00X<UP0e3dI01XM>@0000020=@m6@D0ooK^00<00000
0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00T0ooK^00@0e3dI
0?ofkP3om^h0e3dI1@3om^h20=@m6A00ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@040?ofkP030=@m
6@3om^h0ooK^0140ooK^00<0e3dI0?ofkP3om^h0103om^h20=@m6A00ooK^00<0e3dI0?ofkP3om^h0
2`3om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^01`0ooK^00<000000?ofkP3om^h0
@P3om^h10?ooo`00@P3om^h2000001l0ooK^00<0?EV[0?ofkP3om^h02@3om^h203eIZ`X0ooK^00<0
?EV[0?ofkP3om^h04@3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^01<0ooK^0P0m
FJ/00`3om^h0?EV[0?ofkP030?ofkP0303eIZ`3om^h0ooK^0100ooK^0P0mFJ/00`3om^h0?EV[03eI
Z`040?ofkP80?EV[2P3om^h203eIZ`80ooK^00<0?EV[0?ofkP3om^h00P3om^h2000000040?ofkP0m
FJ/0?EV[0?ofkP80?EV[00L0ooK^000000000000000003eIZ`0E1P80000000805@H200<0000002H:
100V2P@00P0mFJ/00`000000e3dI0=@m6@0203=4N0060000000X<UP0:39H0000003D?AT0:39H0`00
0000103om^h0e3dI0=@m6@3om^h20=@m6@030?ofkP000000000000@0ooK^00<0e3dI0?ofkP3om^h0
0P3D?AT:0?ofkP80e3dI103om^h20=@m6@030?ofkP3D?AT0e3dI0180ooK^00<0e3dI0?ofkP3om^h0
0P3om^h0103D?AT0ooK^0=@m6@3D?ATE0?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3o
m^h04@3om^h00`3D?AT0ooK^0?ofkP080?ofkP80e3dI2`3om^h00`3D?AT0ooK^0?ofkP0M0?ofkP80
0000@P3om^h10?ooo`00@@3om^h00`000000ooK^0?ofkP0N0?ofkP0303eIZ`3om^h0ooK^00`0ooK^
0P0mFJ/80?ofkP0303eIZ`3om^h0ooK^0180ooK^0P0mFJ/00`3om^h0?EV[0?ofkP0G0?ofkP0303eI
Z`3om^h0ooK^00<0ooK^0`0mFJ/B0?ofkP0303eIZ`3om^h0?EV[00H0ooK^0P0mFJ/:0?ofkP0303eI
Z`3om^h0?EV[00<0ooK^00<000000?ofkP3om^h00P3om^h303eIZ`<000000`0E1P80100mFJ/00000
00000000000502H:100303eIZ`0cA7P0<dAh00<0<dAh0`000000103D?AT0:39H02PbF00X<UP30000
00<0e3dI103om^h01`000000ooK^0?ofkP3om^h0e3dI0?ofkP3D?AT02P3om^h20=@m6@H0ooK^00<0
e3dI0?ofkP3D?AT04P3om^h30=@m6@D0ooK^00<0e3dI0?ofkP3om^h05P3om^h0103D?AT0ooK^0=@m
6@3D?ATD0?ofkP030=@m6@3om^h0ooK^00H0ooK^0P3D?AT>0?ofkP030=@m6@3om^h0ooK^01h0ooK^
00<000000?ofkP3om^h0?`3om^h10?ooo`00@03om^h00`000000ooK^0?ofkP0N0?ofkP0303eIZ`3o
m^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0E0?ofkP0303eIZ`3o
m^h0ooK^01H0ooK^00@0?EV[0?ofkP0mFJ/0?EV[0P3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[0100
ooK^00@0?EV[0?ofkP0mFJ/0?EV[203om^h00`0mFJ/0ooK^0?ofkP080?ofkP80?EV[00<0ooK^0000
000000000`3om^h203eIZ`80ooK^00<0000003eIZ`0E1P80100E1P800`0mFJ/0000002H:100602H:
10030000000cA7P0<dAh00D0<dAh00<000000=@m6@0X<UP0100X<UP0103D?AT000000?ofkP3om^h2
0=@m6@<0ooK^0P0000000`3om^h0e3dI0=@m6@0:0?ofkP030=@m6@3om^h0ooK^00H0ooK^0P3D?AT0
0`3om^h0e3dI0?ofkP0?0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT00P3om^h20=@m6@030?ofkP3D
?AT0ooK^01L0ooK^00<0e3dI0?ofkP3om^h05@3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3o
m^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h07P3om^h00`000000ooK^0?ofkP0n0?ofkP40oooo000o
0?ofkP030000003om^h0ooK^01l0ooK^00<0?EV[0?ofkP3om^h0403om^h203eIZ`<0ooK^00<0?EV[
0?ofkP3om^h05@3om^h0100mFJ/0ooK^03eIZ`0mFJ/E0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0
?EV[0?ofkP0mFJ/0103om^h203eIZ`d0ooK^00H0?EV[0?ofkP3om^h0?EV[0?ofkP0mFJ/80?ofkP80
?EV[2@3om^h00`0mFJ/0000003eIZ`020?ofkP80?EV[0P3om^h400000080?EV[0P0E1P800`000000
?EV[0000000702H:10030000000cA7P0<dAh00D0<dAh00<000000=@m6@0000000P0X<UP20=@m6@@0
00000P3om^h20=@m6@80ooK^00<0e3dI0000003D?AT02@3om^h20=@m6@P0ooK^0P3D?AT30?ofkP03
0=@m6@3om^h0ooK^00/0ooK^0P3D?AT40?ofkP030=@m6@3om^h0e3dI00@0ooK^00<0e3dI0?ofkP3o
m^h04`3om^h20=@m6@030?ofkP3D?AT0ooK^01H0ooK^00@0e3dI0?ofkP3om^h0ooK^0P3D?ATB0?of
kP030=@m6@3om^h0ooK^01l0ooK^00<000000?ofkP3om^h0?@3om^h10?ooo`00?P3om^h00`000000
ooK^0?ofkP0O0?ofkP0303eIZ`3om^h0ooK^01<0ooK^0P0mFJ/00`3om^h0?EV[0?ofkP0F0?ofkP04
03eIZ`3om^h0ooK^0?ofkP80?EV[4`3om^h00`0mFJ/0ooK^0?ofkP030?ofkP80?EV[1P3om^h00`0m
FJ/0ooK^0?ofkP090?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/00P3om^h203eIZ`P0ooK^00<0?EV[
0?ofkP3om^h01P3om^h00`000000ooK^0?ofkP0203eIZ`<0ooK^0P00000201D60P080000000E1P80
5@H203eIZ`0000009PX403eIZ`00000502H:10D000001@0cA7P01@000000e3dI03=4N0000000e3dI
0080:39H00<0000002PbF00X<UP00P0000030?ofkP80e3dI0P3om^h00`000000ooK^0?ofkP060?of
kP030=@m6@3om^h0ooK^00H0ooK^0P3D?AT20?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT02`3om^h0
0`3D?AT0ooK^0?ofkP040?ofkP80e3dI1@3om^h00`3D?AT0ooK^0?ofkP0A0?ofkP80e3dI0`3om^h0
0`3D?AT0ooK^0?ofkP0E0?ofkP040=@m6@3om^h0e3dI0=@m6AD0ooK^00<0e3dI0?ofkP3om^h07`3o
m^h00`000000ooK^0?ofkP0l0?ofkP40oooo000l0?ofkP8000008P3om^h00`0mFJ/0ooK^0?ofkP0E
0?ofkP0303eIZ`3om^h0ooK^01D0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0?
0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00@0?EV[0?ofkP0mFJ/0?EV[1@3om^h203eIZ`P0ooK^00<0
?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00H0ooK^0P0m
FJ/40?ofkP8000000`0mFJ/00`3om^h0?EV[03eIZ`03000000805@H200<0000001D60P0E1P800P00
000303eIZ`030000000V2P@09PX400809PX400@0000004HB20164PP000000P0mDiP00`000000<dAh
03=4N00203=4N0040000003D?AT0e3dI0=@m6@8000000P0X<UP00`000000:39H02PbF00300000080
e3dI00@0ooK^0=@m6@3D?AT0e3dI0P0000040?ofkP80e3dI203om^h00`3D?AT0ooK^0?ofkP020?of
kP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h01P3om^h20=@m6@D0ooK^0P3D?AT00`3o
m^h0e3dI0?ofkP050?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D
?AT0ooK^0?ofkP0E0?ofkP030=@m6@3om^h0ooK^01D0ooK^00<0e3dI0?ofkP3om^h0803om^h20000
03`0ooK^0@3oool003/0ooK^00<000000?ofkP3om^h08@3om^h00`0mFJ/0ooK^0?ofkP0E0?ofkP04
03eIZ`3om^h0?EV[03eIZa@0ooK^00<0?EV[0?ofkP3om^h01P3om^h203eIZ`h0ooK^00<0?EV[0?of
kP3om^h01@3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00H0ooK^00<0?EV[0?ofkP3om^h00`3om^h2
03eIZ`D0ooK^00<0?EV[0?ofkP3om^h00`3om^h203eIZ`P0ooK^0P0mFJ/00`3om^h000000?ofkP02
03eIZ`@0ooK^0`00000301D60P<00000100V2P@0100mFJ/0000002H:100V2P@2000000<0AQ8800@0
000003eCV00mDiP0?E>H0P00000203=4N0030000003D?AT0<dAh00<0<dAh0`00000302PbF0<00000
103om^h20=@m6@030?ofkP000000ooK^0080e3dI203om^h20=@m6@D0ooK^00<0e3dI0?ofkP3om^h0
0`3om^h20=@m6@D0ooK^00<0e3dI0?ofkP3om^h0103om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00L0
ooK^00<0e3dI0?ofkP3om^h0303om^h20=@m6@P0ooK^00<0e3dI0?ofkP3om^h04P3om^h20=@m6@03
0?ofkP3D?AT0ooK^01H0ooK^00<0e3dI0?ofkP3om^h08@3om^h00`000000ooK^0?ofkP0i0?ofkP40
oooo000j0?ofkP030000003om^h0ooK^0280ooK^00<0?EV[0?ofkP3om^h05@3om^h0100mFJ/0ooK^
0?ofkP3om^h203eIZa80ooK^00<0?EV[0?ofkP3om^h0203om^h203eIZ`/0ooK^00<0?EV[0?ofkP3o
m^h01@3om^h00`0mFJ/0ooK^0?ofkP030?ofkP80?EV[1@3om^h203eIZ`80ooK^00<0?EV[0?ofkP3o
m^h0103om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00H0ooK^0P0000000`3om^h0
?EV[03eIZ`040?ofkP8000001@0E1P800`0000009PX402H:100402H:1080?EV[0P00000504HB2003
0000000mDiP0?E>H00<0?E>H0P0000020=@m6@H0<dAh00<0000002PbF00X<UP00`0X<UP2000000@0
ooK^0P3D?AT00`3om^h00000000000080?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3o
m^h01@3om^h00`3D?AT0ooK^0?ofkP020=@m6@D0ooK^0P3D?AT50?ofkP030=@m6@3om^h0ooK^00D0
ooK^00<0e3dI0?ofkP3om^h02@3om^h20=@m6@X0ooK^00<0e3dI0?ofkP3om^h0403om^h20=@m6@<0
ooK^00<0e3dI0?ofkP3om^h05@3om^h00`3D?AT0ooK^0?ofkP0R0?ofkP030000003om^h0ooK^03P0
ooK^0@3oool003T0ooK^00<000000?ofkP3om^h08P3om^h00`0mFJ/0ooK^0?ofkP0E0?ofkP0303eI
Z`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP80?EV[
203om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h0
103om^h203eIZ`L0ooK^00<0?EV[0?ofkP3om^h01`3om^h203eIZ`D0ooK^00<000000?ofkP0mFJ/0
0`0mFJ/20?ofkP@000000`0E1P83000000H09PX400@0?EV[0000000mFJ/0?EV[1@164PP00`000000
?E>H03eCV00303eCV080e3dI00<000000=@m6@0cA7P01@0cA7P3000000<0:39H100000020?ofkP@0
e3dI00<0ooK^0000003om^h0103om^h20=@m6@T0ooK^00<0e3dI0?ofkP3om^h01@3om^h20=@m6@H0
ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00H0
ooK^0P3D?AT=0?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0
ooK^0?ofkP0E0?ofkP030=@m6@3om^h0ooK^0280ooK^00<000000?ofkP3om^h0=`3om^h10?ooo`00
>03om^h00`000000ooK^0?ofkP0S0?ofkP<0?EV[5@3om^h00`0mFJ/0ooK^0?ofkP050?ofkP80?EV[
3@3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h0
1P3om^h00`0mFJ/0ooK^0?ofkP070?ofkP80?EV[103om^h00`0mFJ/0ooK^03eIZ`060?ofkP0303eI
Z`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h00P0000000`3om^h0?EV[0?ofkP020?ofkP0403eI
Z`3om^h00000000000805@H200@0000001D60P0E1P8000000P0V2P@00`0000009PX402H:100302H:
10060000000mFJ/000000=@m6@164PP0?EV[10164PP00`000000?E>H03eCV00203eCV0060=@m6@0m
DiP0?EV[0000003D?AT000001@0cA7P010000000<dAh03=4N000000202PbF0030000000X<UP0:39H
0080000000<0ooK^0=@m6@3om^h00P3om^h0103D?AT0ooK^0000000000020?ofkP030=@m6@3om^h0
ooK^00T0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0=@m6@040?ofkP80e3dI2@3om^h0
0`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h03P3om^h0
0`3D?AT0ooK^0?ofkP0;0?ofkP80e3dI1`3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP<0e3dI9@3om^h0
0`000000ooK^0?ofkP0f0?ofkP40oooo000g0?ofkP030000003om^h0ooK^02<0ooK^00@0?EV[0?of
kP3om^h0ooK^0P0mFJ/B0?ofkP0303eIZ`3om^h0ooK^00P0ooK^0P0mFJ/:0?ofkP0303eIZ`3om^h0
ooK^0100ooK^0P0mFJ/40?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h02@3om^h2
03eIZ`030?ofkP0mFJ/0ooK^0080ooK^0P0mFJ/40?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[
0000003om^h00P0mFJ/40?ofkP<0?EV[0P0E1P80100000005@H201D60P00000302H:10030000000V
2P@09PX400809PX400@0000004HB200mFJ/000000`164PP01@0mFJ/0AQ8804HB20164PP0000000<0
?E>H00P0e3dI03eCV00mDiP0?E>H0000003D?AT0?E>H000000@0<dAh00D0000003=4N00cA7P0<dAh
0000000202PbF0030000000X<UP0:39H00<0e3dI103om^h20=@m6@030?ofkP000000e3dI00`0ooK^
00<0e3dI0?ofkP3om^h00P3om^h20=@m6@<0ooK^00@0e3dI0?ofkP3D?AT0e3dI2`3om^h00`3D?AT0
ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^0080ooK^0P3D?ATB0?ofkP030=@m6@3om^h0ooK^00P0
ooK^0P3D?AT:0?ofkP030=@m6@3om^h0ooK^0100ooK^0P3D?AT30?ofkP030=@m6@3om^h0ooK^02<0
ooK^00<000000?ofkP3om^h0=@3om^h10?ooo`00=@3om^h2000002H0ooK^00<0?EV[0?ofkP3om^h0
0`3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00X0ooK^0P0mFJ/80?ofkP0303eI
Z`3om^h0ooK^0180ooK^0P0mFJ/00`3om^h0?EV[0?ofkP070?ofkP0303eIZ`3om^h0ooK^00`0ooK^
00<0?EV[0?ofkP3om^h0103om^h0100mFJ/0ooK^0?ofkP0mFJ/=0?ofkP030000003om^h0?EV[00D0
ooK^00H0?EV[0000000000005@H203eIZ`0E1P83000000<09PX400@0000002H:100V2P@09PX40P00
000204HB200303eIZ`000000AQ8800<0AQ880P0mFJ/00`164PP0000003eCV0020=@m6@@0?E>H00@0
00000=@m6@0mDiP0?E>H0P00000303=4N0040000000cA7P0<dAh03=4N0<0000000H0:39H0=@m6@0X
<UP000000=@m6@0000050?ofkP030=@m6@3om^h0000000`0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m
6@060?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h01P3om^h0103D?AT0ooK^0=@m
6@3D?ATD0?ofkP030=@m6@3om^h0ooK^00H0ooK^0P3D?AT<0?ofkP030=@m6@3om^h0ooK^00l0ooK^
00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP0T0?ofkP800000=@3om^h10?ooo`00=03o
m^h00`000000ooK^0?ofkP0U0?ofkP0303eIZ`3om^h0ooK^00D0ooK^0P0mFJ/>0?ofkP0303eIZ`3o
m^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0E0?ofkP0303eIZ`3o
m^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h02`3om^h0100mFJ/0ooK^03eIZ`0mFJ/50?ofkP<0?EV[
2`3om^h2000000030?ofkP0mFJ/0ooK^0080?EV[00@0ooK^000000000000?EV[100E1P8203eIZ`D0
9PX400@0000002H:100V2P@0000010164PP00`0mFJ/0000004HB200404HB20050000000mFJ/00000
0=@m6@0000001@0mDiP00`000000e3dI03eCV00303eCV0040000000cA7P0<dAh000000D0<dAh0P3D
?AT402PbF0040=@m6@00000000000?ofkP80e3dI00<0ooK^0=@m6@3om^h00P00000;0?ofkP<0e3dI
1@3om^h20=@m6@030?ofkP3D?AT0ooK^00`0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^
0?ofkP0E0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^
0?ofkP0<0?ofkP80e3dI1`3om^h00`3D?AT0ooK^0?ofkP0U0?ofkP030000003om^h0ooK^0380ooK^
0@3oool003<0ooK^00<000000?ofkP3om^h09P3om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3o
m^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h03`3om^h203eIZ`<0ooK^00<0?EV[0?ofkP3om^h05@3o
m^h0100mFJ/0ooK^03eIZ`0mFJ/70?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h0
0P3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00P0ooK^00@000000?ofkP3om^h0
?EV[103om^h30000000403eIZ`0E1P805@H201D60P<0000000<0?EV[02H:100V2P@00P0V2P@30000
00D0AQ8800<0?EV[04HB20164PP00`164PP010000000IQ/=06HK3@00000204=M[@030000000mDiP0
?E>H00<0?E>H00<0e3dI03eCV00mDiP00`0mDiP3000000@0<dAh00@0e3dI00000000000000000`0X
<UP0103D?AT000000000000000040?ofkP040=@m6@3om^h0ooK^000000X0ooK^00<0e3dI0?ofkP3o
m^h0103om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3o
m^h01@3om^h20=@m6@030?ofkP3D?AT0ooK^01H0ooK^00@0e3dI0?ofkP3om^h0ooK^0P3D?ATA0?of
kP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP0V0?of
kP030000003om^h0ooK^0340ooK^0@3oool00380ooK^00<000000?ofkP3om^h09P3om^h00`0mFJ/0
ooK^0?ofkP090?ofkP80?EV[2P3om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP80?EV[00<0ooK^03eIZ`3o
m^h05P3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00D0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0m
FJ/0ooK^0?ofkP030?ofkP80?EV[103om^h303eIZ`H0ooK^0P0000020?ofkP0403eIZ`3om^h0ooK^
0?ofkP<0000000<05@H20000000mFJ/00P0E1P800`0000009PX40000000202H:1080?EV[0P0V2P@0
0`000000AQ8804HB200404HB200303eIZ`000000AQ880080AQ880P00000306HK3@0400000013GJd0
@ef]04=M[@8000000`0mDiP00`000000e3dI03eCV00503eCV0030000000cA7P0<dAh0080e3dI0P0c
A7P00`000000<dAh0000000202PbF0030=@m6@000000:39H00<000000`3om^h00`3D?AT0ooK^0?of
kP02000000H0ooK^0`3D?AT40?ofkP80e3dI1@3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3o
m^h0ooK^00<0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0G0?ofkP040=@m6@3om^h0e3dI0=@m6A<0
ooK^00<0e3dI0?ofkP3om^h0203om^h20=@m6@/0ooK^00<0e3dI0?ofkP3om^h09P3om^h00`000000
ooK^0?ofkP0`0?ofkP40oooo000a0?ofkP030000003om^h0ooK^02L0ooK^00<0?EV[0?ofkP3om^h0
2`3om^h203eIZ`L0ooK^00<0?EV[0?ofkP3om^h0503om^h00`0mFJ/0ooK^0?ofkP0E0?ofkP0303eI
Z`3om^h0ooK^00<0ooK^0P0mFJ/30?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h0
1P3om^h203eIZ`030?ofkP0mFJ/0ooK^0080ooK^00<0?EV[0?ofkP3om^h00P3om^h01@000000ooK^
0?ofkP3om^h0?EV[00<0ooK^0`00000201D60P0403eIZ`0E1P800000000000809PX400<0000002H:
100V2P@00P0V2P@00`0mFJ/000000000000604HB200503eIZ`000000AQ8804HB200000001@1V6`d0
0`000000@ef]04=M[@0304=M[@050000000mDiP0?E>H0000003D?AT01P0mDiP2000000030=@m6@0c
A7P0<dAh0080<dAh00<0000003=4N00cA7P00P000000103D?AT0000002PbF00X<UP3000000<0ooK^
00D0e3dI0?ofkP3om^h0ooK^000000040?ofkP060=@m6@3om^h0ooK^0?ofkP3D?AT0ooK^0P3D?AT8
0?ofkP030=@m6@3om^h0ooK^00X0ooK^00@0e3dI0?ofkP3om^h0ooK^0P3D?AT50?ofkP030=@m6@3o
m^h0ooK^01D0ooK^00<0e3dI0?ofkP3om^h0503om^h00`3D?AT0ooK^0?ofkP050?ofkP80e3dI3@3o
m^h00`3D?AT0ooK^0?ofkP0W0?ofkP030000003om^h0ooK^02l0ooK^0@3oool002l0ooK^0P00000Z
0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0C
0?ofkP0403eIZ`3om^h0?EV[03eIZa@0ooK^00<0?EV[0?ofkP3om^h01P3om^h303eIZ``0ooK^00<0
?EV[0?ofkP3om^h02@3om^h203eIZ`@0ooK^0P0mFJ/2000000<0ooK^00<0?EV[0?ofkP3om^h01000
000201D60P030000000mFJ/0000000@09PX400H0000002H:100V2P@09PX4000000164PP203eIZ`H0
AQ8800@0?EV[00000000000000001P1V6`d00`000000@ef]04=M[@0404=M[@<0000000<0e3dI03eC
V00mDiP0100mDiP20=@m6@0303eCV0000000<dAh0080<dAh00<0000003=4N00cA7P00P0cA7P00`00
0000e3dI0000000202PbF0@000000P3om^h0103D?AT0ooK^0?ofkP3om^h200000080e3dI103om^h2
0=@m6@/0ooK^00<0e3dI0?ofkP3om^h02P3om^h30=@m6@P0ooK^00<0e3dI0?ofkP3om^h04P3om^h3
0=@m6AH0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0
ooK^02P0ooK^0P00000_0?ofkP40oooo000^0?ofkP030000003om^h0ooK^02T0ooK^00<0?EV[0?of
kP3om^h03`3om^h203eIZ`<0ooK^00<0?EV[0?ofkP3om^h0503om^h0100mFJ/0ooK^0?ofkP3om^h2
03eIZa80ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0
ooK^00X0ooK^0`0mFJ/40?ofkP030000000mFJ/0?EV[0080ooK^00H0?EV[0?ofkP3om^h0000001D6
0P00000401D60P030000000mFJ/09PX400@09PX400@0000002H:1000000000000`164PP00`000000
?EV[04HB200404HB200303eIZ`000000IQ/=00L0IQ/=00<0000004=M[@13GJd01P13GJd00`000000
e3dI03eCV00403eCV0030=@m6@000000?E>H0080?E>H0P0000000`0cA7P0000003=4N00403=4N003
0=@m6@000000:39H00<0:39H00<0000001XM>@0000000P3om^h00`3D?AT0ooK^0?ofkP020=@m6@03
0000003om^h0ooK^0080ooK^0`3D?AT<0?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3o
m^h0203om^h00`3D?AT0ooK^0?ofkP0@0?ofkP80e3dI0`3om^h00`3D?AT0ooK^0?ofkP0D0?ofkP04
0=@m6@3om^h0ooK^0?ofkP80e3dI4@3om^h00`3D?AT0ooK^0?ofkP0Y0?ofkP030000003om^h0ooK^
02`0ooK^0@3oool002d0ooK^00<000000?ofkP3om^h0:P3om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP80
?EV[00<0ooK^03eIZ`3om^h0503om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00h0
ooK^00<0?EV[0?ofkP3om^h0203om^h0100mFJ/0ooK^03eIZ`0mFJ/80?ofkP0303eIZ`3om^h0ooK^
00/0ooK^00@0?EV[0?ofkP3om^h0?EV[0P3om^h010000000ooK^0?ofkP3om^h203eIZ`040?ofkP00
0000000001D60P8000000`0E1P820000000303eIZ`0V2P@09PX400809PX40`00000504HB20040000
00164PP0?EV[03eIZ`<0AQ8800<0?EV[0000001V6`d01`1V6`d00`000000@ef]04=M[@0604=M[@03
0000003D?AT0?E>H0080?E>H0P3D?AT00`0mDiP0000003eCV00403eCV0<00000100cA7P00`3D?AT0
00000000000302PbF080000000@06Qdi000000000000ooK^0P3D?AT30?ofkP040000003om^h0ooK^
0=@m6@80ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP060?ofkP80e3dI00<0ooK^
0=@m6@3om^h02@3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI
0?ofkP3om^h0503om^h0103D?AT0ooK^0=@m6@3D?ATC0?ofkP030=@m6@3om^h0ooK^02X0ooK^00<0
00000?ofkP3om^h0:`3om^h10?ooo`00;03om^h00`000000ooK^0?ofkP0Z0?ofkP0303eIZ`3om^h0
ooK^01@0ooK^00<0?EV[0?ofkP3om^h0503om^h00`0mFJ/0ooK^0?ofkP050?ofkP80?EV[3@3om^h0
0`0mFJ/0ooK^0?ofkP090?ofkP0403eIZ`3om^h0ooK^0?ofkP80?EV[1@3om^h00`0mFJ/0ooK^0?of
kP0;0?ofkP0303eIZ`3om^h0ooK^0080ooK^0P0000040?ofkP<0?EV[00@0000001D60P0000000000
0`0E1P820000000303eIZ`0V2P@09PX400<09PX400<0000004HB20164PP01@164PP01@000000AQ88
04HB20164PP0?EV[0080000000<0?EV[0000001V6`d01`1V6`d00`000000@ef]04=M[@0604=M[@05
0000003D?AT000000000003D?AT00`0mDiP00`000000?E>H03eCV00503eCV0030000000cA7P0<dAh
0080<dAh00@0e3dI0000000cA7P000000`0X<UP20000000301XM>@000000e3dI0080e3dI103om^h2
000000@0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP030?ofkP80e3dI0`3om^h0
0`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^00/0ooK^0P3D?AT70?ofkP030=@m6@3om^h0
ooK^01@0ooK^00<0e3dI0?ofkP3om^h0503om^h00`3D?AT0ooK^0?ofkP0Z0?ofkP030000003om^h0
ooK^02X0ooK^0@3oool002/0ooK^00<000000?ofkP3om^h0:`3om^h00`0mFJ/0ooK^0?ofkP0D0?of
kP<0?EV[4`3om^h00`0mFJ/0ooK^0?ofkP080?ofkP80?EV[2P3om^h00`0mFJ/0ooK^0?ofkP090?of
kP0303eIZ`3om^h0ooK^00<0ooK^0P0mFJ/40?ofkP0303eIZ`3om^h0ooK^00/0ooK^00D0?EV[0?of
kP3om^h0ooK^000000020?ofkP80?EV[00X0ooK^03eIZ`000000000001D60P0mFJ/0000001D60P00
00005@H20P0000000`0V2P@0000003eIZ`0402H:1080000000<0e3dI04HB20164PP010164PP01@00
0000AQ8804HB20164PP0000000<0?EV[00<0000006HK3@1V6`d01P1V6`d00`000000@ef]04=M[@06
04=M[@050000003D?AT0e3dI0=@m6@0000000`0mDiP00`000000?E>H03eCV00403eCV00303eIZ`00
0000000000@0<dAh00<0e3dI0000000cA7P00P0000001P0X<UP0000002PbF0000000e3dI01XM>@80
000000@0e3dI0?ofkP3D?AT0e3dI0P3om^h01@000000ooK^0?ofkP3om^h0e3dI00d0ooK^00<0e3dI
0?ofkP3om^h00P3om^h20=@m6@D0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP08
0?ofkP80e3dI2@3om^h00`3D?AT0ooK^0?ofkP0B0?ofkP<0e3dI5P3om^h00`3D?AT0ooK^0?ofkP0[
0?ofkP030000003om^h0ooK^02T0ooK^0@3oool002T0ooK^0P00000]0?ofkP0303eIZ`3om^h0ooK^
01@0ooK^00@0?EV[0?ofkP3om^h0ooK^0P0mFJ/A0?ofkP0303eIZ`3om^h0ooK^00X0ooK^0P0mFJ/8
0?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h01@3om^h203eIZ`030?ofkP0mFJ/0
ooK^00`0ooK^00<0?EV[0?ofkP3om^h00P0000050?ofkP0603eIZ`0000005@H201D60P0000005@H2
0P0mFJ/2000000<09PX400@0000003eIZ`0V2P@09PX40P0000000`164PP0000004HB200604HB2004
000000164PP0AQ88000000<0IQ/=00<0?EV[0000001V6`d01`1V6`d00`000000@ef]04=M[@0604=M
[@030000003D?AT0@ef]0080@ef]00@0000003eCV00mDiP000001`0mDiP010000000?E>H00000000
000203=4N0030=@m6@000000<dAh0080<dAh0P0000020=@m6@0602PbF00000006Qdi01XM>@000000
e3dI1@3om^h2000000030?ofkP3D?AT0ooK^00d0ooK^00@0e3dI0?ofkP3D?AT0e3dI1`3om^h00`3D
?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^00H0ooK^0P3D?AT<0?ofkP030=@m6@3om^h0ooK^
00l0ooK^0P3D?AT30?ofkP030=@m6@3om^h0ooK^01@0ooK^00<0e3dI0?ofkP3om^h0:`3om^h20000
02T0ooK^0@3oool002P0ooK^00<000000?ofkP3om^h0;@3om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP03
03eIZ`3om^h0ooK^00<0ooK^0P0mFJ/>0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3o
m^h0103om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^00P0ooK^0P0mFJ/=0?ofkP03
03eIZ`3om^h0000000H0ooK^00D0?EV[0000000E1P805@H20000000301D60P030000000mFJ/0?EV[
00<09PX400@0000003eIZ`0V2P@000000`164PP00`000000AQ8804HB200504HB20<00000101V6`d3
03eIZ`L0IQ/=00<0000004=M[@13GJd01@13GJd30=@m6@@0@ef]0`00000703eCV0080000000mDiP0
?E>H03eCV0000000<dAh0=@m6@00000303=4N080e3dI00D0000002PbF00X<UP0:39H0000000201XM
>@030000003D?AT0ooK^00D0ooK^00<000000?ofkP3D?AT03@3om^h20=@m6@X0ooK^00<0e3dI0?of
kP3om^h02@3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?of
kP3om^h03@3om^h20=@m6@D0ooK^00<0e3dI0?ofkP3om^h0503om^h00`3D?AT0ooK^0?ofkP0]0?of
kP030000003om^h0ooK^02H0ooK^0@3oool002L0ooK^00<000000?ofkP3om^h0;P3om^h303eIZa<0
ooK^00<0?EV[0?ofkP3om^h01P3om^h203eIZ``0ooK^00<0?EV[0?ofkP3om^h03P3om^h203eIZ`<0
ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP070?ofkP0403eIZ`3om^h0?EV[03eI
Z``0ooK^0P0000060?ofkP0303eIZ`000000e3dI00800000100E1P802@0000009PX402H:100mFJ/0
9PX40000000mFJ/09PX40000000404HB2003000000164PP0AQ8800D0AQ8800<0000006HK3@1V6`d0
0`1V6`d01@0mFJ/0IQ/=0000001V6`d0?EV[00@0IQ/=1@00000404=M[@050=@m6@13GJd0000004=M
[@3D?AT01@13GJd00`000000?E>H03eCV00503eCV0030000000mDiP0?E>H0080?E>H00<000000=@m
6@0000000P0cA7P0103D?AT0<dAh03=4N000000402PbF080000000<0?EV[0000003D?AT01P3om^h2
000000`0ooK^0P3D?AT00`3om^h0e3dI0?ofkP080?ofkP030=@m6@3om^h0ooK^00X0ooK^00@0e3dI
0?ofkP3om^h0ooK^0P3D?AT@0?ofkP030=@m6@3om^h0ooK^00X0ooK^0P3D?AT80?ofkP030=@m6@3o
m^h0ooK^0140ooK^0`3D?AT`0?ofkP030000003om^h0ooK^02D0ooK^0@3oool002H0ooK^00<00000
0?ofkP3om^h0;P3om^h0100mFJ/0ooK^0?ofkP3om^h203eIZa40ooK^00<0?EV[0?ofkP3om^h0203o
m^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^0140ooK^0P0mFJ/00`3om^h0?EV[0?of
kP0:0?ofkP0303eIZ`3om^h0ooK^00P0ooK^00@0?EV[0?ofkP3om^h0ooK^0P0mFJ/90?ofkP030000
003om^h0ooK^00D0ooK^10000000100E1P80000001D60P0E1P83000000<09PX40`0mFJ/00`000000
AQ8804HB200304HB2003000000164PP0AQ8800<0AQ880`00000506HK3@0303eIZ`1V6`d000000080
IQ/=0P0mFJ/01@1V6`d00000088T4022910000000080AfBl00@0000004=M[@3D?AT0e3dI0P13GJd0
0`000000@ef]0=@m6@0504=M[@<000001@0mDiP00`000000?E>H03eCV00303eCV0040000003D?AT0
e3dI0=@m6@<0<dAh0`00000202PbF0030000000X<UP0000000<000001`3om^h00`000000ooK^0?of
kP070?ofkP80e3dI0`3om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00T0ooK^00@0
e3dI0?ofkP3D?AT0e3dI4P3om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^00P0ooK^
00<0e3dI0?ofkP3om^h03`3om^h20=@m6@<0ooK^00<0e3dI0?ofkP3om^h0;P3om^h00`000000ooK^
0?ofkP0T0?ofkP40oooo000V0?ofkP<00000;P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3o
m^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h02P3om^h203eIZ`P0ooK^00<0?EV[0?ofkP3om^h04`3o
m^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h00`3o
m^h303eIZ`H0ooK^00<0000003eIZ`3om^h01@3om^h3000000805@H200H0000001D60P0E1P800000
02H:1000000502H:10030000000mFJ/0AQ8800D0AQ8800<0000004HB20164PP00P164PP010000000
IQ/=06HK3@00000506HK3@0303eIZ`1V6`d0000000<0IQ/=00<0000003eIZ`2291000P2291001P00
0000AfBl04MT_017I;`0e3dI000000<0@ef]00<0000004=M[@3D?AT01@13GJd010000000@ef]04=M
[@00000403eCV0030000000mDiP0?E>H00@0?E>H00<0e3dI0000000cA7P0100cA7P00`000000<dAh
0000000202PbF0030000000X<UP0:39H00<000001P3om^h00`3D?AT000000?ofkP050?ofkP<0e3dI
1@3om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h0
4`3om^h00`3D?AT0ooK^0?ofkP060?ofkP80e3dI303om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m
6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h0;03om^h3000002H0ooK^0@3oool002H0ooK^00<0
00000?ofkP3om^h00P00000/0?ofkP0303eIZ`3om^h0ooK^00@0ooK^0P0mFJ/=0?ofkP0303eIZ`3o
m^h0ooK^00`0ooK^0P0mFJ/50?ofkP0303eIZ`3om^h0ooK^01<0ooK^00@0?EV[0?ofkP0mFJ/0?EV[
2@3om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00H0ooK^0P0mFJ/30?ofkP800000
00<0?EV[0?ofkP3om^h0103om^h2000000<05@H200@0000001D60P00000000000P0V2P@010000000
9PX402H:100V2P@3000000<0?EV[10164PP00`000000AQ8804HB2002000000<0IQ/=00<0000006HK
3@1V6`d00`1V6`d00`0mFJ/0IQ/=0000000206HK3@03000000229100PR@@0080?EV[00<0PR@@0000
0017I;`00P3D?AT204MT_00600000013GJd0@ef]00000013GJd0e3dI1@13GJd010000000@ef]04=M
[@13GJd200000080?E>H00<0000003eCV00mDiP00P0mDiP30=@m6@<000000`0cA7P00`000000<dAh
03=4N0020000000302PbF0000000:39H0080:39H0P0000060?ofkP030=@m6@000000000000<0ooK^
0P3D?AT80?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h01`3om^h20=@m6@030?of
kP3D?AT0ooK^01<0ooK^00<0e3dI0?ofkP3om^h0103om^h20=@m6@h0ooK^00<0e3dI0?ofkP3om^h0
2`3om^h20=@m6@H0ooK^00<0e3dI0?ofkP3om^h0:P3om^h200000080ooK^00<000000?ofkP3om^h0
903om^h10?ooo`009@3om^h00`000000ooK^0?ofkP030?ofkP800000:@3om^h00`0mFJ/0ooK^0?of
kP070?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h03P3om^h203eIZ`<0ooK^00<0
?EV[0?ofkP3om^h04`3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00P0ooK^00<0?EV[0?ofkP3om^h0
1`3om^h00`0mFJ/0ooK^0?ofkP070?ofkP<0?EV[00@000000?ofkP3om^h0?EV[103om^h300000004
01D60P3D?AT05@H201D60P800000100V2P@0100000009PX402H:1000000204HB200403eIZ`164PP0
AQ8804HB2080?EV[0P164PP3000000D0IQ/=00<0000006HK3@1V6`d00P1V6`d00`0mFJ/0IQ/=06HK
3@03000000D0PR@@0P0mFJ/00`3D?AT0AfBl04MT_00304MT_0<000000P13GJd00`3D?AT0@ef]04=M
[@0204=M[@0300000013GJd0@ef]00<0@ef]0`00000203eCV080e3dI0`0mDiP0103D?AT0?E>H03eC
V000000203=4N0030000000cA7P0<dAh0080<dAh0P00000202PbF00303eIZ`0X<UP0000000800000
103om^h0103D?AT0ooK^0?ofkP0000030=@m6@T0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0
ooK^0?ofkP060?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT05@3om^h0103D?AT0ooK^0?ofkP3om^h2
0=@m6A00ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0
ooK^02L0ooK^0P0000050?ofkP030000003om^h0ooK^02<0ooK^0@3oool002D0ooK^00<000000?of
kP3om^h01@3om^h2000002L0ooK^00<0?EV[0?ofkP3om^h0203om^h203eIZ`T0ooK^00<0?EV[0?of
kP3om^h04@3om^h303eIZaD0ooK^00<0?EV[0?ofkP3om^h00`3om^h203eIZ`D0ooK^00<0?EV[0?of
kP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP090?ofkP8000000`0mFJ/40?ofkP80000000<05@H20000
000E1P800P0E1P800`0000009PX402H:100402H:10030000000V2P@0000000<0AQ8800<0?EV[04HB
20164PP00`164PP00`0mFJ/0AQ880000000706HK3@030000001V6`d0IQ/=0080IQ/=00@0?EV[06HK
3@1V6`d00000202291000`000000AfBl04MT_00604MT_00400000013GJd0@ef]0=@m6@@0@ef]00<0
000004=M[@13GJd01@13GJd00`000000?E>H0=@m6@0503eCV0070=@m6@0mDiP0?E>H03eCV0000000
<dAh0000000603=4N0060000000X<UP0:39H02PbF0000000:39H0P0000040?ofkP<0e3dI0P00000;
0?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h00`3om^h20=@m6@D0ooK^00<0e3dI
0?ofkP3om^h04P3om^h0103D?AT0ooK^0=@m6@3D?ATC0?ofkP030=@m6@3om^h0ooK^00L0ooK^0P3D
?AT:0?ofkP030=@m6@3om^h0ooK^02D0ooK^0P0000070?ofkP030000003om^h0ooK^02<0ooK^0@3o
ool002D0ooK^00<000000?ofkP3om^h01`3om^h2000002D0ooK^00<0?EV[0?ofkP3om^h02P3om^h2
03eIZ`L0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0
ooK^00D0ooK^0P0mFJ/30?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h02@3om^h0
10000000ooK^0?ofkP3om^h203eIZ`80ooK^0`000000100E1P80000001D60P0E1P83000000D09PX4
0`00000304HB200303eIZ`000000AQ8800D0AQ880P0mFJ/706HK3@030000001V6`d0IQ/=0080IQ/=
00D0?EV[06HK3@00000000000=@m6@07088T400300000017I;`0AfBl00D0AfBl00D0?EV[00000000
0000@ef]0=@m6@0404=M[@0300000013GJd0@ef]00D0@ef]0P3D?AT603eCV0030000003D?AT0?E>H
0080?E>H0`00000503=4N0<000000P0X<UP00`000000:39H0000000200000080ooK^0P3D?AT30?of
kP030000003om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h01P3om^h0103D?AT0ooK^0?ofkP3om^h2
0=@m6@L0ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0
ooK^00D0ooK^0P3D?AT<0?ofkP030=@m6@3om^h0ooK^02<0ooK^0P0000090?ofkP030000003om^h0
ooK^02<0ooK^0@3oool002D0ooK^00<000000?ofkP3om^h02@3om^h00`000000ooK^0?ofkP0Q0?of
kP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP0C0?of
kP0403eIZ`3om^h0?EV[03eIZa80ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^03eIZ`08
0?ofkP0303eIZ`3om^h0ooK^00P0ooK^0P0000040?ofkP@0?EV[0P00000201D60P050000000E1P80
000002H:100000001P0V2P@00`000000AQ8804HB200304HB200303eIZ`000000AQ8800<0AQ880P00
00000`1V6`d0000003eIZ`0606HK3@030000001V6`d0IQ/=0080IQ/=00@0?EV[0000002291000000
202291000`000000AfBl04MT_00604MT_00400000017I;`000000=@m6@@0@ef]00<0000004=M[@13
GJd01013GJd00`3D?AT0000004=M[@02000000@0?E>H00<000000=@m6@0mDiP0100mDiP00`000000
<dAh03=4N00403=4N0050000000cA7P0000002PbF00000000P0X<UP2000000@0e3dI103om^h20000
00X0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0=@m6@0:0?ofkP030=@m6@3om^h0ooK^
0100ooK^0`3D?ATF0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D
?AT0ooK^0?ofkP0Q0?ofkP030000003om^h0ooK^00T0ooK^00<000000?ofkP3om^h08`3om^h10?oo
o`00903om^h00`000000ooK^0?ofkP0;0?ofkP8000008@3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP80
?EV[0`3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/04@3om^h00`0m
FJ/0ooK^0?ofkP090?ofkP80?EV[203om^h00`0mFJ/0ooK^0?ofkP070?ofkP030000003om^h0ooK^
00@0ooK^00D0?EV[000000000000000003eIZ`0201D60P030000003D?AT0000000809PX400<00000
02H:100V2P@00P0V2P@2000000030=@m6@164PP0AQ880080AQ8800<0?EV[04HB200000000`164PP0
1P000000IQ/=06HK3@1V6`d0000006HK3@80?EV[101V6`d01@000000IQ/=06HK3@1V6`d0?EV[00<0
PR@@00<00000088T402291001P2291000`000000AfBl04MT_00604MT_00500000017I;`0AfBl04MT
_03D?AT00`13GJd00`000000@ef]04=M[@0204=M[@80e3dI00<0@ef]00000013GJd00P13GJd01`00
0000?E>H03eCV00mDiP0000003eCV03D?AT0100mDiP00`0mFJ/000000000000403=4N0060000000c
A7P0<dAh0000000mFJ/000000P0X<UP01@3D?AT00000000000000000e3dI00H0ooK^00<000000?of
kP3om^h01`3om^h00`3D?AT0ooK^0?ofkP060?ofkP80e3dI2`3om^h00`3D?AT0ooK^0?ofkP0?0?of
kP050=@m6@3om^h0ooK^0?ofkP3D?AT05@3om^h0103D?AT0ooK^0?ofkP3om^h20=@m6A00ooK^00<0
e3dI0?ofkP3om^h07`3om^h2000000d0ooK^00<000000?ofkP3om^h08P3om^h10?ooo`00903om^h0
0`000000ooK^0?ofkP0=0?ofkP8000007`3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP<0?EV[5@3om^h0
0`0mFJ/0ooK^0?ofkP030?ofkP80?EV[3P3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0
?EV[00H0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`000000ooK^0?ofkP040?ofkP0403eIZ`000000
0000000000805@H20P0mFJ/2000000<09PX400D0000002H:100V2P@09PX40000000204HB20030000
00164PP0AQ880080AQ8800<0?EV[04HB200000000P164PP00`000000IQ/=06HK3@0206HK3@040000
001V6`d0IQ/=06HK3@80?EV[0P1V6`d01@000000IQ/=06HK3@000000?EV[00<0PR@@00<00000088T
402291001P2291000`000000AfBl04MT_00604MT_00600000017I;`0AfBl04MT_03D?AT000000P13
GJd00`000000@ef]04=M[@020=@m6@<0@ef]00<0000004=M[@13GJd00P13GJd01P000000?E>H03eC
V0000000?E>H0=@m6@@0?E>H00@0000003eCV00mDiP000000`0cA7P010000000<dAh03=4N00cA7P2
00000080e3dI0P0X<UP3000000030=@m6@3om^h0ooK^00@0ooK^00<000000?ofkP3om^h01`3om^h0
0`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0e3dI00`0ooK^00<0e3dI0?ofkP3om^h0303om^h2
0=@m6@@0ooK^00<0e3dI0?ofkP3om^h0503om^h30=@m6A80ooK^00<0e3dI0?ofkP3om^h07@3om^h2
000000l0ooK^00<000000?ofkP3om^h08P3om^h10?ooo`00903om^h00`000000ooK^0?ofkP0?0?of
kP800000703om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?of
kP3om^h01@3om^h203eIZ`/0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP0203eI
Z`<0ooK^00<0?EV[0?ofkP3om^h01P3om^h2000000H0ooK^00D0000003eIZ`0000005@H200000003
01D60P030000000mFJ/0?EV[00<09PX400@0000002H:1000000000000`164PP01@000000AQ8804HB
20164PP0?EV[0080AQ880`00000506HK3@030000001V6`d0IQ/=00<0IQ/=00<0?EV[06HK3@000000
0P0000000`229100?EV[088T4002088T4003000000229100PR@@00H0PR@@00<0000004MT_017I;`0
1P17I;`01P000000AfBl04MT_017I;`0e3dI04MT_0<0000000<0@ef]0=@m6@13GJd01013GJd00`00
0000@ef]04=M[@0304=M[@<0000000<0?E>H0=@m6@0mDiP00`0mDiP010000000?E>H03eCV00mDiP2
0000000303=4N0000000<dAh0080<dAh0P3D?AT02@000000:39H02PbF00X<UP0000002PbF0000000
e3dI000000060?ofkP800000203om^h0103D?AT0ooK^0?ofkP3om^h20=@m6@80ooK^00<0e3dI0?of
kP3om^h02`3om^h00`3D?AT0ooK^0?ofkP090?ofkP80e3dI1`3om^h00`3D?AT0ooK^0?ofkP0C0?of
kP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h06P3om^h200000140ooK^00<000000?of
kP3om^h08P3om^h10?ooo`00903om^h00`000000ooK^0?ofkP0A0?ofkP8000006P3om^h00`0mFJ/0
ooK^0?ofkP0C0?ofkP<0?EV[4P3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00P0
ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP80?EV[00<0ooK^03eIZ`3o
m^h01P3om^h00`000000ooK^0?ofkP050?ofkP050000000mFJ/0000001D60P0000000P0E1P830000
00809PX400<0?EV[02H:100000000P00000504HB2005000000164PP0AQ8804HB200mFJ/00P164PP0
0`000000IQ/=06HK3@0506HK3@030000001V6`d0IQ/=00@0IQ/=0P0mFJ/3088T400503eIZ`229100
PR@@088T40000000202291000`000000AfBl04MT_00604MT_00500000017I;`0AfBl04MT_03D?AT0
0`17I;`20=@m6@H0@ef]00<0000004=M[@13GJd01@13GJd010000000?E>H03eCV03D?AT303eCV003
0000000mDiP0?E>H00<0?E>H0`000000100cA7P0e3dI03=4N00cA7P300000080:39H00D0000002Pb
F0000000e3dI000000070?ofkP030000003om^h0ooK^00D0ooK^00@0e3dI0?ofkP3D?AT0e3dI1@3o
m^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h01`3o
m^h00`3D?AT0ooK^0?ofkP0A0?ofkP<0e3dI5@3om^h00`3D?AT0ooK^0?ofkP0H0?ofkP8000004`3o
m^h00`000000ooK^0?ofkP0R0?ofkP40oooo000T0?ofkP030000003om^h0ooK^01<0ooK^0P00000H
0?ofkP0303eIZ`3om^h0ooK^0180ooK^00@0?EV[0?ofkP3om^h0ooK^0P0mFJ/@0?ofkP0303eIZ`3o
m^h0ooK^00T0ooK^0P0mFJ/70?ofkP0303eIZ`3om^h0ooK^00X0ooK^00@0?EV[0?ofkP0mFJ/0?EV[
1@3om^h00`0mFJ/0ooK^0?ofkP040?ofkP8000001P3om^h30000000803eIZ`0E1P805@H20000000E
1P80000002H:1000000402H:1080?EV[1P164PP00`000000AQ8804HB200204HB200403eIZ`000000
0000000000L0IQ/=00<0000006HK3@1V6`d00`1V6`d3000000<0?EV[1@2291000`000000PR@@088T
4005088T400300000017I;`0AfBl00D0AfBl00<0000004MT_017I;`00`17I;`30=@m6@<000001@13
GJd00`000000@ef]04=M[@0504=M[@<0000000<0e3dI03eCV00mDiP00P0mDiP00`000000?E>H03eC
V00403eCV080e3dI100cA7P01@000000<dAh0000000X<UP000000080:39H00@0e3dI000000000000
00001P3om^h2000000H0ooK^00<0e3dI0?ofkP3om^h00`3om^h20=@m6@030?ofkP3D?AT0ooK^00/0
ooK^00<0e3dI0?ofkP3om^h01@3om^h20=@m6@/0ooK^00<0e3dI0?ofkP3om^h03P3om^h20=@m6@<0
ooK^00<0e3dI0?ofkP3om^h04P3om^h00`3D?AT0ooK^0?ofkP0F0?ofkP8000005@3om^h00`000000
ooK^0?ofkP0R0?ofkP40oooo000S0?ofkP030000003om^h0ooK^01H0ooK^00<000000?ofkP3om^h0
503om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h0
303om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h0
2P3om^h0100mFJ/0ooK^0?ofkP3om^h203eIZ`80ooK^00@0?EV[0?ofkP0mFJ/0?EV[0`3om^h00`00
0000ooK^0?ofkP050?ofkP<0000000H0?EV[01D60P0E1P80000001D60P00000202H:10030000000V
2P@09PX400809PX40P0000000`0mFJ/0AQ8804HB200304HB2006000000164PP0AQ8804HB200mFJ/0
00000P1V6`d00`000000IQ/=06HK3@0506HK3@030000001V6`d0IQ/=0080IQ/=00@00000088T4022
910000000P2291000`0mFJ/0PR@@088T4003088T4003000000229100PR@@00@0PR@@0`00000604MT
_00300000017I;`0AfBl00<0AfBl00@0e3dI04MT_017I;`000000P17I;`00`000000@ef]04=M[@02
04=M[@0300000013GJd0@ef]00D0@ef]00D0000004=M[@13GJd000000=@m6@0303eCV0030000000m
DiP0?E>H00<0?E>H00<0e3dI000000000000100cA7P01P000000<dAh03=4N0000000:39H00000080
:39H00@0e3dI00000000000000001`3om^h010000000ooK^0?ofkP3om^h20=@m6@040?ofkP3D?AT0
ooK^0?ofkP80e3dI0`3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0
e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0
e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP0D0?ofkP030000003om^h0ooK^01H0ooK^00<0
00000?ofkP3om^h08@3om^h10?ooo`008`3om^h00`000000ooK^0?ofkP0G0?ofkP800000503om^h0
0`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^00@0ooK^0P0mFJ/<0?ofkP0303eIZ`3om^h0
ooK^00d0ooK^0P0mFJ/30?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h0103om^h0
0`0mFJ/0ooK^03eIZ`030?ofkP0303eIZ`000000000000H0ooK^0`0000000`0E1P80000003eIZ`02
01D60P8000000P0V2P@0100000009PX402H:100V2P@20000000304HB20000000AQ880080?EV[0`16
4PP01@000000AQ8804HB20000000?EV[00<0IQ/=00<0000006HK3@1V6`d01@1V6`d00`000000IQ/=
06HK3@02000000<0PR@@00<00000088T402291000`0mFJ/3088T4003000000229100PR@@0080PR@@
0P0000000`2I:a<0000004YYa`02000000@0AfBl00@0000004MT_017I;`0AfBl0`3D?AT204MT_004
00000017I;`0AfBl04MT_08000000P13GJd00`000000@ef]04=M[@0504=M[@0600000013GJd0@ef]
04=M[@3D?AT000000P0mDiP010000000?E>H03eCV00mDiP20=@m6@0303eCV0000000?E>H00800000
0P0cA7P010000000<dAh03=4N00cA7P200000080:39H00<0e3dI0000000X<UP00`0000060?ofkP80
000000L0e3dI0?ofkP3om^h0ooK^0=@m6@3om^h0e3dI00H0ooK^00<0e3dI0?ofkP3om^h02P3om^h0
103D?AT0ooK^0?ofkP3om^h20=@m6@l0ooK^00<0e3dI0?ofkP3om^h02P3om^h20=@m6@H0ooK^00<0
e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP0B0?ofkP8000006@3om^h00`000000ooK^0?of
kP0Q0?ofkP40oooo000S0?ofkP030000003om^h0ooK^01T0ooK^0P00000B0?ofkP<0?EV[4P3om^h0
0`0mFJ/0ooK^0?ofkP070?ofkP80?EV[2@3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP80?EV[00<0ooK^
03eIZ`3om^h02P3om^h00`0mFJ/0ooK^0?ofkP060?ofkP80?EV[0`3om^h010000000ooK^03eIZ`0m
FJ/40?ofkP<0000000<05@H20000000mFJ/00P0E1P800`0000009PX402H:100202H:10040000000V
2P@09PX4000000<0AQ8800@0000004HB20164PP0AQ880P0mFJ/01@164PP00000000000000000?EV[
00@0IQ/=00<0000006HK3@1V6`d01@1V6`d3000000D0PR@@00<00000088T400mFJ/00`22910203eI
Z`03088T40000000PR@@0080PR@@00D0000009T[4`2I:a<0VB/C0000000304YYa`0600000017I;`0
AfBl04MT_0000000AfBl0P3D?AT304MT_0030=@m6@17I;`0000000D0AfBl0`00000704=M[@030000
0013GJd0@ef]0080@ef]00D0e3dI000000000000000003eCV0020=@m6@<0?E>H00D0000003eCV00m
DiP0?E>H0000000203=4N0030000000cA7P0<dAh0080<dAh00H0000002PbF00X<UP0e3dI0000000X
<UP3000000@0ooK^0P3D?AT00`3om^h000000?ofkP020?ofkP80e3dI203om^h00`3D?AT0ooK^0?of
kP090?ofkP040=@m6@3om^h0e3dI0=@m6A40ooK^00<0e3dI0?ofkP3om^h0203om^h20=@m6@T0ooK^
00<0e3dI0?ofkP3om^h0403om^h30=@m6A80ooK^0P00000K0?ofkP030000003om^h0ooK^0240ooK^
0@3oool002<0ooK^00<000000?ofkP3om^h06`3om^h200000100ooK^00<0?EV[0?ofkP3om^h00P0m
FJ/@0?ofkP0303eIZ`3om^h0ooK^00T0ooK^0P0mFJ/70?ofkP0303eIZ`3om^h0ooK^0180ooK^00<0
?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0503eIZ`3om^h0?EV[03eIZ`000000
103om^h203eIZ`080?ofkP00000000000000000E1P80000001D60P0mFJ/3000000@09PX400<00000
02H:1000000010164PP00`000000AQ8804HB200304HB200503eIZ`000000IQ/=06HK3@0mFJ/0101V
6`d00`000000IQ/=06HK3@0506HK3@03000000229100PR@@00D0PR@@00<00000088T400mFJ/01@22
91001@0mFJ/00000088T40229100000000@0VB/C00<0000004YYa`1:JLL00P1:JLL01@000000AfBl
04MT_0000000e3dI00D0AfBl00<0e3dI04MT_00000001`17I;`00`000000@ef]04=M[@0504=M[@03
00000013GJd0@ef]0080@ef]00D0e3dI04=M[@13GJd000000=@m6@0503eCV0030000000mDiP0?E>H
0080?E>H00<0000003=4N0000000100cA7P3000000040=@m6@0X<UP0000002PbF0<0000000<0ooK^
0=@m6@3D?AT0103om^h01@000000e3dI0=@m6@3om^h0e3dI00P0ooK^00<0e3dI0?ofkP3om^h02P3o
m^h00`3D?AT0ooK^0?ofkP0B0?ofkP030=@m6@3om^h0ooK^00D0ooK^0P3D?AT;0?ofkP030=@m6@3o
m^h0ooK^00h0ooK^0P3D?AT20?ofkP030=@m6@3om^h0ooK^00h0ooK^0P00000M0?ofkP030000003o
m^h0ooK^0240ooK^0@3oool00280ooK^00<000000?ofkP3om^h07P3om^h2000000d0ooK^00<0?EV[
0?ofkP3om^h00`3om^h203eIZ`d0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP03
0?ofkP0303eIZ`3om^h0ooK^01<0ooK^0`0mFJ/90?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[
0?ofkP3om^h00P0000000`0mFJ/0ooK^0?ofkP030?ofkP<000000P0E1P801P0000005@H203eIZ`00
00009PX4000000@09PX40`00000404HB2003000000164PP0AQ8800@0AQ8800@0000003eIZ`0mFJ/0
?EV[1@1V6`d00`000000IQ/=06HK3@0406HK3@80000000<0e3dI088T40229100102291000`000000
?EV[088T4006088T4080?EV[00<0000009T[4`2I:a<00`2I:a<00`000000BVW704YYa`0304YYa`03
0000003D?AT0e3dI00L0AfBl00<0e3dI04MT_017I;`01@17I;`00`0mFJ/000000000000604=M[@03
00000013GJd0@ef]00<0@ef]0`3D?AT00`000000?E>H03eCV00303eCV0030000000mDiP0?E>H00<0
?E>H0`00000403=4N0060000000cA7P000000=@m6@0X<UP000000P0X<UP3000000D0ooK^00<0e3dI
0000000000000P3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00L0ooK^0`3D?ATD
0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP0<
0?ofkP80e3dI1@3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP8000007`3om^h00`000000ooK^0?ofkP0Q
0?ofkP40oooo000R0?ofkP030000003om^h0ooK^0200ooK^0P00000;0?ofkP0303eIZ`3om^h0ooK^
00D0ooK^0P0mFJ/;0?ofkP0303eIZ`3om^h0ooK^00d0ooK^0P0mFJ/30?ofkP0303eIZ`3om^h0ooK^
0180ooK^00@0?EV[0?ofkP3om^h0ooK^0P0mFJ/60?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[
0?ofkP0000000`3om^h203eIZ`80ooK^0`00000301D60P80000000@0?EV[02H:100V2P@00000100V
2P@00`000000AQ8804HB200404HB2003000000164PP0AQ880080AQ880P000000101V6`d0000006HK
3@0mFJ/506HK3@030000001V6`d0IQ/=0080IQ/=0P0000000`2291000000088T4007088T400303eI
Z`229100PR@@00D0PR@@00<0000009T[4`0mFJ/01@2I:a<00`000000BVW704YYa`0304YYa`030=@m
6@1:JLL0000000L0AfBl00<0e3dI04MT_017I;`01P17I;`010000000AfBl00000000000404=M[@03
00000013GJd0@ef]00<0@ef]00@0e3dI04=M[@000000@ef]0P00000403eCV0030000000mDiP0?E>H
00@0?E>H00<0000003=4N00cA7P00P0cA7P010000000<dAh03=4N03D?AT2000000<0:39H0`000002
0?ofkP80e3dI0`3om^h00`000000ooK^0=@m6@090?ofkP030=@m6@3om^h0ooK^00@0ooK^0P3D?AT3
0?ofkP030=@m6@3om^h0ooK^0180ooK^00@0e3dI0?ofkP3om^h0ooK^0P3D?AT?0?ofkP030=@m6@3o
m^h0ooK^00T0ooK^0P3D?AT70?ofkP030=@m6@3om^h0ooK^00T0ooK^0P00000R0?ofkP030000003o
m^h0ooK^0200ooK^0@3oool00280ooK^00<000000?ofkP3om^h08P3om^h00`000000ooK^0?ofkP08
0?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP0?
0?ofkP<0?EV[5@3om^h00`0mFJ/0ooK^0?ofkP030?ofkP80?EV[0`3om^h00`0mFJ/0ooK^0?ofkP07
0?ofkP0303eIZ`000000000000H0ooK^0P0mFJ/00`0000005@H20000000201D60P030000000V2P@0
?EV[00809PX400@0000002H:100V2P@09PX40`00000604HB2005000000164PP0AQ8804HB20000000
0`1V6`d00`000000?EV[06HK3@0203eIZ`<0IQ/=00D0000006HK3@1V6`d0IQ/=00000003088T4003
000000229100PR@@00H0PR@@00<0?EV[088T402291000`22910300000080VB/C0P0mFJ/309T[4`04
0000001:JLL0BVW704YYa`80e3dI0P1:JLL3000000D0AfBl00<0e3dI04MT_017I;`01P17I;`01@00
0000AfBl04MT_017I;`0000000<0@ef]00@0000004=M[@13GJd0@ef]0P3D?AT00`13GJd0e3dI0000
000304=M[@050000000mDiP0?E>H03eCV00000001P0mDiP300000080<dAh00L0000003=4N00cA7P0
<dAh0=@m6@0cA7P000000080:39H00<0000002PbF00000000P3D?AT60?ofkP80000000<0e3dI0?of
kP3om^h01P3om^h00`3D?AT0ooK^0?ofkP020?ofkP80e3dI1@3om^h00`3D?AT0ooK^0?ofkP0B0?of
kP040=@m6@3om^h0e3dI0=@m6A40ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP07
0?ofkP030=@m6@3om^h0ooK^00P0ooK^00<000000?ofkP3om^h08P3om^h00`000000ooK^0?ofkP0P
0?ofkP40oooo000R0?ofkP030000003om^h0ooK^02<0ooK^0P0000080?ofkP0303eIZ`3om^h0ooK^
00P0ooK^0P0mFJ/70?ofkP0303eIZ`3om^h0ooK^0180ooK^00<0?EV[0?ofkP3om^h04P3om^h00`0m
FJ/0ooK^0?ofkP060?ofkP80?EV[00<0ooK^03eIZ`3om^h0203om^h00`000000ooK^0?ofkP040?of
kP@0000000<0?EV[0000000E1P800P0000000`3D?AT09PX403eIZ`0202H:10040000000V2P@09PX4
00000080AQ8800<0000004HB20164PP010164PP010000000AQ8804HB2000000406HK3@030000000m
FJ/0IQ/=0080IQ/=00@0?EV[06HK3@1V6`d000000P1V6`d00`000000PR@@088T4002088T40030000
00229100PR@@00D0PR@@00<0?EV[0000002291000`22910010000000VB/C09T[4`00000409T[4`80
?EV[00<0VB/C0000001:JLL00P3D?AT404YYa`040000001:JLL0BVW7000000@0AfBl00<000000=@m
6@17I;`01P17I;`00`000000AfBl04MT_00204MT_00400000013GJd0@ef]00000080@ef]00H0e3dI
04=M[@13GJd0@ef]0=@m6@00000404=M[@040000000mDiP0?E>H000000H0?E>H00@0000003eCV00m
DiP000000P0cA7P01P000000<dAh03=4N03D?AT0<dAh03eIZ`80000000<0:39H0000003D?AT01000
00060?ofkP030000003om^h0ooK^00L0ooK^00@0e3dI0?ofkP3D?AT0e3dI203om^h00`3D?AT0ooK^
0?ofkP0B0?ofkP030=@m6@3om^h0ooK^0180ooK^00<0e3dI0?ofkP3om^h01@3om^h20=@m6@X0ooK^
00<0e3dI0?ofkP3om^h01P3om^h2000002D0ooK^00<000000?ofkP3om^h0803om^h10?ooo`008P3o
m^h00`000000ooK^0?ofkP0U0?ofkP8000001@3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP80?EV[1@3o
m^h00`0mFJ/0ooK^0?ofkP0B0?ofkP<0?EV[4P3om^h00`0mFJ/0ooK^0?ofkP080?ofkP80?EV[1`3o
m^h2000000D0ooK^1000000201D60P070000000mFJ/0?EV[02H:100000009PX403eIZ`0302H:1003
0000000V2P@0000000<0AQ8800<0000004HB20164PP010164PP3000000D0IQ/=00<0?EV[06HK3@1V
6`d00`1V6`d203eIZ`<000001@2291000`000000PR@@088T4005088T400403eIZ`000000PR@@088T
408000000`2I:a<00`000000VB/C09T[4`0409T[4`0303eIZ`000000e3dI00H0BVW700@0000004YY
a`1:JLL0BVW70P00000204MT_0030000003D?AT0AfBl00H0AfBl00<0000004MT_017I;`00`17I;`3
00000080e3dI1@13GJd00`3D?AT0@ef]04=M[@0304=M[@<000001P0mDiP01`000000?E>H03eCV00m
DiP0000003=4N00000000`0cA7P0103D?AT0<dAh0000000cA7P20=@m6@030000000X<UP0:39H00@0
00001@3om^h2000000L0ooK^0P3D?AT:0?ofkP030=@m6@3om^h0ooK^0100ooK^0`3D?ATD0?ofkP03
0=@m6@3om^h0ooK^00<0ooK^0P3D?AT=0?ofkP030=@m6@3om^h0ooK^00<0ooK^0P00000W0?ofkP03
0000003om^h0ooK^0200ooK^0@3oool00240ooK^00<000000?ofkP3om^h0:03om^h2000000<0ooK^
00<0?EV[0?ofkP3om^h03@3om^h203eIZ`<0ooK^00<0?EV[0?ofkP3om^h04@3om^h0100mFJ/0ooK^
0?ofkP3om^h203eIZ`l0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP0203eIZ`@0
ooK^00<000000?ofkP0mFJ/0103om^h20000000801D60P0000005@H201D60P0000005@H20000000V
2P@203eIZ`0402H:100mFJ/09PX402H:10<0000010164PP00`000000AQ8804HB200404HB20030000
001V6`d0IQ/=00D0IQ/=00<0?EV[06HK3@1V6`d01@1V6`d00`0mFJ/0PR@@088T4005088T40030000
00229100PR@@00@0PR@@00<0?EV[088T400000000P00000509T[4`030000002I:a<0VB/C00D0VB/C
00<0?EV[04YYa`1:JLL01@1:JLL00`000000BVW704YYa`0304YYa`<0000000<0AfBl0=@m6@17I;`0
1017I;`00`000000AfBl04MT_00604MT_0030=@m6@13GJd0@ef]00D0@ef]00<0e3dI04=M[@13GJd0
1@13GJd00`000000?E>H03eCV00403eCV0030000000mDiP0?E>H0080?E>H0`00000203=4N0080=@m
6@0cA7P0e3dI0=@m6@0cA7P0000002PbF000000202PbF0040000000J7CT00000000000@0ooK^00<0
e3dI0?ofkP000000103om^h20=@m6@80ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?of
kP0=0?ofkP80e3dI0`3om^h00`3D?AT0ooK^0?ofkP0A0?ofkP040=@m6@3om^h0ooK^0?ofkP80e3dI
3`3om^h0103D?AT0ooK^0?ofkP3om^h2000002X0ooK^00<000000?ofkP3om^h07`3om^h10?ooo`00
8@3om^h00`000000ooK^0?ofkP0Z0?ofkP80000000<0ooK^03eIZ`3om^h0403om^h303eIZa@0ooK^
00<0?EV[0?ofkP3om^h00`3om^h203eIZ`d0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^
0?ofkP020?ofkP80?EV[0P0000000`3om^h0?EV[0?ofkP030?ofkP040000000E1P800000000000<0
5@H20P00000202H:10030000000V2P@0?EV[00<09PX400<0000004HB20164PP00`164PP00`000000
AQ8804HB200304HB20<000001P1V6`d00`0mFJ/0000006HK3@0406HK3@<000000P0mFJ/6088T4003
000000229100PR@@00<0PR@@00<0?EV[088T400000001`2I:a<00`000000VB/C09T[4`0509T[4`03
0000001:JLL0BVW700D0BVW700<0000004YYa`1:JLL01@1:JLL00`000000AfBl0=@m6@0504MT_003
00000017I;`0AfBl00@0AfBl0P3D?AT3000000D0@ef]00<000000=@m6@13GJd01@13GJd3000000D0
?E>H00<0000003eCV00mDiP00`0mDiP01`000000<dAh03=4N00cA7P0e3dI03=4N00000000P0cA7P2
00000080:39H0`0000000`0J7CT000000?ofkP030?ofkP040=@m6@3om^h0000000000080e3dI103o
m^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00/0ooK^0P3D?AT50?ofkP030=@m6@3o
m^h0ooK^0180ooK^0`3D?ATA0?ofkP040=@m6@3om^h00000000002`0ooK^00<000000?ofkP3om^h0
7`3om^h10?ooo`008@3om^h00`000000ooK^0?ofkP0/0?ofkP030000000mFJ/0ooK^0180ooK^00<0
?EV[0?ofkP3om^h04P3om^h00`0mFJ/0ooK^0?ofkP050?ofkP80?EV[2P3om^h00`0mFJ/0ooK^0?of
kP080?ofkP0303eIZ`3om^h0ooK^00@0ooK^00D0000003eIZ`0mFJ/0ooK^03eIZ`020?ofkP800000
00@05@H200000000000000000P0E1P800`0000009PX402H:100202H:10030000000mFJ/09PX40080
?EV[0P00000504HB2003000000164PP0AQ880080AQ8800@0000006HK3@1V6`d000001P1V6`d00`0m
FJ/0000006HK3@0306HK3@04000000229100PR@@00000080PR@@00<0?EV[088T402291000`229100
0`000000PR@@088T4002088T400403eIZ`0000000000000000L0VB/C00<0000009T[4`2I:a<01@2I
:a<00`000000BVW704YYa`0504YYa`030000001:JLL0BVW700D0BVW70`0000000`3D?AT0AfBl04MT
_00204MT_00300000017I;`0AfBl00<0AfBl00@0e3dI04MT_017I;`000000P17I;`00`000000@ef]
04=M[@0204=M[@030000003D?AT0@ef]00D0@ef]00@0000004=M[@13GJd00000100mDiP00`000000
?E>H03eCV00303eCV08000000P3D?AT00`0cA7P0e3dI0000000403=4N0030000000X<UP0:39H00<0
000000<06Qdi0000000000000P3om^h01@3D?AT0ooK^0=@m6@3D?AT0000000H0ooK^00<0e3dI0?of
kP3om^h0203om^h00`3D?AT0ooK^0?ofkP080?ofkP80e3dI1`3om^h00`3D?AT0ooK^0?ofkP0B0?of
kP030=@m6@3om^h0ooK^0140ooK^00<0e3dI0000003om^h0;@3om^h00`000000ooK^0?ofkP0O0?of
kP40oooo000Q0?ofkP030000003om^h0ooK^02`0ooK^00<0?EV[0?ofkP0000004P3om^h303eIZa80
ooK^00<0?EV[0?ofkP3om^h01`3om^h203eIZ`P0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0
ooK^0?ofkP040?ofkP050000003om^h0ooK^0?ofkP0mFJ/00P3om^h20000000501D60P0000005@H2
0000000E1P800`00000302H:10080000000V2P@0?EV[02H:10000000AQ8803eIZ`00000504HB2003
000000164PP0AQ88008000000`1V6`d00`000000IQ/=06HK3@0306HK3@0303eIZ`1V6`d000000080
IQ/=0P000003088T4004000000229100PR@@088T4080?EV[0`2291000`000000PR@@088T4002088T
400403eIZ`2I:a<0VB/C000000L0VB/C00<0000009T[4`2I:a<01@2I:a<00`000000BVW704YYa`05
04YYa`030000001:JLL0BVW700D0BVW700@0000004YYa`1:JLL0e3dI1017I;`010000000AfBl04MT
_017I;`20=@m6@<0AfBl00@0000004MT_017I;`0AfBl0P00000204=M[@0300000013GJd0e3dI00D0
@ef]00@0000004=M[@13GJd0@ef]0P00000203eCV0030000000mDiP0?E>H00<0?E>H00P000000=@m
6@0mDiP0000003=4N03D?AT0<dAh000000<0<dAh0`0000001@0X<UP0000002PbF00000006Qdi0080
00000P3om^h01@3D?AT0ooK^0?ofkP3om^h0000000H0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D
?AT0ooK^0?ofkP060?ofkP80e3dI2@3om^h00`3D?AT0ooK^0?ofkP0@0?ofkP<0e3dI4P3om^h00`00
0000ooK^0=@m6@0^0?ofkP030000003om^h0ooK^01l0ooK^0@3oool00240ooK^00<000000?ofkP3o
m^h0;03om^h00`0mFJ/0ooK^0?ofkP0200000100ooK^00<0?EV[0?ofkP3om^h00P0mFJ/?0?ofkP03
03eIZ`3om^h0ooK^00X0ooK^0P0mFJ/50?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3o
m^h00P3om^h2000000@0ooK^0P0mFJ/20000000801D60P0000005@H20000000E1P80000002H:1000
000402H:10040000000mFJ/0000000000080AQ8800<0000003eIZ`0mFJ/010164PP3000000D0IQ/=
00<0000006HK3@1V6`d00`1V6`d00`0mFJ/0IQ/=00000002000000D0PR@@00<00000088T40229100
0`229100100mFJ/0PR@@088T40000002088T4080000000@0?EV[09T[4`2I:a<000001`2I:a<00`00
0000VB/C09T[4`0509T[4`030000001:JLL0BVW700D0BVW700<0000004YYa`1:JLL01@1:JLL01000
0000BVW704YYa`3D?AT200000080AfBl00@0000004MT_017I;`0e3dI1@17I;`00`000000AfBl04MT
_00304MT_0<0000000<0@ef]0=@m6@13GJd01013GJd00`000000@ef]04=M[@0304=M[@<00000100m
DiP20=@m6@030000000mDiP0?E>H0080000000<0e3dI0000000cA7P00`0cA7P020000000<dAh0000
000X<UP0000002PbF00000006Qdi0P0000020=@m6@@0ooK^0P0000040?ofkP030=@m6@3om^h0ooK^
00P0ooK^00<0e3dI0?ofkP3om^h00`3om^h20=@m6@`0ooK^00<0e3dI0?ofkP3om^h03@3om^h20=@m
6@80ooK^00<0e3dI0?ofkP3om^h03P3om^h200000080ooK^00<0e3dI0?ofkP3om^h0;03om^h00`00
0000ooK^0?ofkP0O0?ofkP40oooo000P0?ofkP030000003om^h0ooK^02d0ooK^00<0?EV[0?ofkP3o
m^h00P3om^h2000000d0ooK^00<0?EV[0?ofkP3om^h00`3om^h203eIZ`d0ooK^00<0?EV[0?ofkP3o
m^h0303om^h203eIZ`<0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP020?ofkP03
0000003om^h0ooK^00<0ooK^00@0?EV[0?ofkP0000005@H20P000000100E1P80000001D60P000002
02H:10070000000V2P@09PX402H:10000000?EV[0000000404HB2003000000164PP0AQ880080?EV[
0P164PP00`000000IQ/=06HK3@0506HK3@030000001V6`d0IQ/=0080IQ/=00@0?EV[06HK3@1V6`d0
00001`2291000`000000PR@@088T4004088T4080?EV[0`0000000`2I:a<0?EV[09T[4`0209T[4`03
0000002I:a<0VB/C00D0VB/C00<0000009T[4`2I:a<01@2I:a<00`000000BVW704YYa`0504YYa`03
0000001:JLL0BVW700D0BVW700H0000004YYa`1:JLL0BVW70=@m6@1:JLL300000080e3dI1P17I;`0
0`000000AfBl04MT_00504MT_00400000013GJd0@ef]0=@m6@@0@ef]00<0000004=M[@13GJd01@13
GJd00`000000?E>H03eCV0020=@m6@80?E>H00<0000003eCV00mDiP00P0mDiP00`000000e3dI0000
000303=4N0030000000cA7P0<dAh008000000P0X<UP20000000401XM>@000000ooK^0=@m6@D0ooK^
00<000000?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP070?ofkP040=@m6@3om^h0ooK^0?ofkP80
e3dI3P3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP80e3dI1@3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP80
0000103om^h00`3D?AT0ooK^0?ofkP0]0?ofkP030000003om^h0ooK^01h0ooK^0@3oool00200ooK^
00<000000?ofkP3om^h0;@3om^h303eIZ`@0ooK^0P00000;0?ofkP0303eIZ`3om^h0ooK^00D0ooK^
0P0mFJ/;0?ofkP0303eIZ`3om^h0ooK^00h0ooK^0`0mFJ/90?ofkP0403eIZ`3om^h0?EV[03eIZ`80
00001P3om^h00`0mFJ/0000000000002000000805@H20P00000202H:10030000000V2P@09PX40080
9PX400<0000003eIZ`164PP010164PP00`000000AQ8804HB200204HB200303eIZ`000000000000L0
IQ/=00<0000006HK3@1V6`d00P1V6`d0100mFJ/00000000000000008088T4003000000229100PR@@
00D0PR@@00D0?EV[09T[4`2I:a<0VB/C03eIZ`0309T[4`030000002I:a<0VB/C00D0VB/C00<00000
09T[4`2I:a<00`2I:a<5000000D0BVW700<0000004YYa`1:JLL01@1:JLL01@000000BVW704YYa`1:
JLL0e3dI00<0BVW700<0e3dI04MT_017I;`01@17I;`00`000000AfBl04MT_00604MT_0<0000000<0
e3dI04=M[@13GJd00P13GJd00`000000@ef]04=M[@0504=M[@80000000<0e3dI03eCV00mDiP00P0m
DiP00`000000?E>H03eCV00303eCV0030=@m6@000000<dAh00<0<dAh00<0000003=4N00cA7P00P00
000202PbF0@0000000<0e3dI0?ofkP3om^h0103om^h200000080e3dI00<0ooK^0=@m6@3om^h0203o
m^h30=@m6A00ooK^00<0e3dI0?ofkP3om^h02@3om^h20=@m6@L0ooK^00<0e3dI0?ofkP3om^h02@3o
m^h2000000@0ooK^0`3D?AT_0?ofkP030000003om^h0ooK^01h0ooK^0@3oool00200ooK^00<00000
0?ofkP3om^h0;@3om^h00`0mFJ/0ooK^0?ofkP0203eIZ`@0ooK^0P0000090?ofkP0303eIZ`3om^h0
ooK^00L0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP0303eIZ`3om^h0
ooK^00H0ooK^00D0?EV[0?ofkP3om^h0ooK^0000000203eIZ`D0ooK^00D0?EV[0000000000005@H2
0000000201D60P030000000V2P@09PX400809PX400<0000002H:100V2P@00P0000000`0mFJ/0AQ88
04HB200404HB2006000000164PP0AQ8804HB20000000IQ/=0P0mFJ/706HK3@060000001V6`d0IQ/=
06HK3@0mFJ/000000P2291000`000000PR@@088T4006088T4003000000229100PR@@00<0PR@@0`00
000303eIZ`@0VB/C00<0000009T[4`2I:a<01@2I:a<00`000000VB/C09T[4`0209T[4`040000002/
<AH0[34F00000080C6g>00<0000004YYa`1:JLL00P1:JLL00`000000BVW704YYa`0504YYa`030000
001:JLL0BVW70080BVW70`3D?AT3000000D0AfBl00<0000004MT_017I;`01P17I;`01@000000AfBl
04MT_0000000e3dI00<0@ef]00<0000004=M[@13GJd01@13GJd20=@m6@0304=M[@000000?E>H0080
?E>H00<0000003eCV00mDiP0100mDiP00`3D?AT000000000000203=4N0030000000cA7P0<dAh0080
<dAh00D0000002PbF00X<UP0000002PbF002000000030=@m6@3om^h0ooK^00<0ooK^0P3D?AT01@00
0000ooK^0?ofkP3om^h0e3dI00P0ooK^00<0e3dI0?ofkP3om^h04@3om^h00`3D?AT0ooK^0?ofkP07
0?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h01`3om^h2000000@0ooK^0P3D?AT2
0?ofkP030=@m6@3om^h0ooK^02d0ooK^00<000000?ofkP3om^h07P3om^h10?ooo`00803om^h00`00
0000ooK^0?ofkP0]0?ofkP0303eIZ`3om^h0ooK^0080ooK^0P0mFJ/40?ofkP8000001`3om^h00`0m
FJ/0ooK^0?ofkP080?ofkP80?EV[1`3om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP<0?EV[1@3om^h00`0m
FJ/0ooK^0?ofkP02000000<0ooK^00@0?EV[0?ofkP3om^h0ooK^0P00000201D60P040000000E1P80
0000000000@09PX400L0000002H:100V2P@0000004HB200mFJ/0000000D0AQ8800<0000004HB2016
4PP00P00000306HK3@030000000mFJ/0IQ/=00D0IQ/=00D0000006HK3@1V6`d0000003eIZ`03088T
4003000000229100PR@@00H0PR@@00<00000088T402291000P22910010000000VB/C09T[4`000002
09T[4`0303eIZ`2I:a<0VB/C0080VB/C00<0000009T[4`2I:a<01@2I:a<00`000000VB/C09T[4`02
000000<0[34F00@0000004a]cP1<KLh0C6g>0P00000204YYa`030000001:JLL0BVW700@0BVW700<0
000004YYa`1:JLL00`1:JLL0103D?AT0BVW704YYa`00000204YYa`0300000017I;`0AfBl0080AfBl
00<0000004MT_017I;`01P17I;`01P000000AfBl04MT_017I;`0e3dI00000080@ef]00<0000004=M
[@13GJd01013GJd00`3D?AT0000004=M[@0204=M[@8000000P0mDiP00`000000?E>H03eCV00303eC
V0040000003D?AT0?E>H00000080<dAh00@0000003=4N00cA7P0<dAh0`000000100X<UP0000002Pb
F00X<UP2000000<0ooK^00@0e3dI0?ofkP3om^h0ooK^0P0000020?ofkP030=@m6@3om^h0ooK^00<0
ooK^0`3D?ATC0?ofkP030=@m6@3om^h0ooK^00D0ooK^0P3D?AT:0?ofkP030=@m6@3om^h0ooK^00D0
ooK^0P0000040?ofkP80e3dI103om^h00`3D?AT0ooK^0?ofkP0]0?ofkP030000003om^h0ooK^01h0
ooK^0@3oool001l0ooK^00<000000?ofkP3om^h0;P3om^h00`0mFJ/0ooK^0?ofkP040?ofkP80?EV[
103om^h00`000000ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00/0ooK^0P0mFJ/50?ofkP0303eI
Z`3om^h0ooK^0100ooK^00@0?EV[0?ofkP3om^h0ooK^0P0mFJ/30?ofkP0303eIZ`3om^h0000000H0
ooK^0P0mFJ/2000000805@H20`0000000`0V2P@0000002H:100302H:10070000000V2P@0000004HB
200mFJ/0AQ880000000504HB20<000001@1V6`d010000000IQ/=03eIZ`0mFJ/406HK3@<0000000<0
?EV[088T402291000P2291000`000000PR@@088T4006088T4003000000229100PR@@008000000`2I
:a<010000000VB/C03eIZ`2I:a<203eIZ`<0VB/C00<0000009T[4`2I:a<0102I:a<3000000D0[34F
00<0000004a]cP1<KLh00`1<KLh3000000H0BVW700@0000004YYa`1:JLL0BVW70`3D?AT204YYa`04
0000001:JLL0BVW704YYa`8000000P17I;`00`000000AfBl04MT_00604MT_00300000017I;`0AfBl
0080AfBl00@0e3dI00000000000000001013GJd20=@m6@0304=M[@000000@ef]00@0@ef]0`000005
03eCV0070000003D?AT0?E>H03eCV0000000<dAh0000000403=4N0030000000cA7P0000000800000
0P0X<UP200000080e3dI1P3om^h00`000000ooK^0=@m6@030?ofkP80e3dI0`3om^h00`3D?AT0ooK^
0?ofkP0@0?ofkP030=@m6@3om^h0ooK^00<0ooK^0P3D?AT=0?ofkP030=@m6@3om^h0ooK^00<0ooK^
00<000000?ofkP3om^h00P3om^h20=@m6@H0ooK^00<0e3dI0?ofkP3om^h0;P3om^h00`000000ooK^
0?ofkP0M0?ofkP40oooo000O0?ofkP030000003om^h0ooK^02h0ooK^00<0?EV[0?ofkP3om^h01P3o
m^h00`0mFJ/0ooK^0?ofkP020?ofkP8000000`3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP80?EV[0`3o
m^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0303eIZ`3om^h0ooK^00<0ooK^0`0mFJ/00`3om^h000000?of
kP060?ofkP8000000P0mFJ/00`0E1P8000000000000202H:10030000000V2P@09PX400809PX40`00
000204HB200303eIZ`164PP0000000D0AQ8800<0000006HK3@1V6`d01@1V6`d010000000IQ/=06HK
3@1V6`d203eIZ`80IQ/=00@00000088T40229100?EV[102291000`000000PR@@088T4006088T40<0
00001@2I:a<00`000000VB/C03eIZ`0309T[4`80?EV[00<0VB/C0000002I:a<01@2I:a<00`000000
[34F0:`a5P050:`a5P030000001<KLh0C6g>00D0C6g>00<0000004YYa`1:JLL0101:JLL010000000
BVW70=@m6@3D?AT304YYa`030=@m6@1:JLL0000000D0BVW70`00000804MT_00300000017I;`0AfBl
0080AfBl00@0e3dI04MT_017I;`000000P13GJd20=@m6@<0@ef]00<0000004=M[@13GJd01@13GJd0
0`000000?E>H03eCV00303eCV0030000000mDiP0e3dI0080?E>H0`00000303=4N0040000000cA7P0
<dAh03=4N080000000<0:39H0=@m6@3D?AT00P0000070?ofkP030000003om^h0e3dI0080e3dI1@3o
m^h00`3D?AT0ooK^0?ofkP0@0?ofkP040=@m6@3om^h0ooK^0?ofkP80e3dI3`3om^h0103D?AT0ooK^
0?ofkP3om^h2000000@0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP0^0?ofkP03
0000003om^h0ooK^01d0ooK^0@3oool001l0ooK^00<000000?ofkP3om^h0;@3om^h00`0mFJ/0ooK^
0?ofkP080?ofkP80?EV[103om^h2000000030?ofkP0mFJ/0ooK^0100ooK^0`0mFJ/C0?ofkP0303eI
Z`3om^h0ooK^00@0ooK^00<0?EV[0000000000001`3om^h20000000401D60P0000005@H203eIZ`@0
9PX400<0000002H:100V2P@00P0V2P@01`000000AQ8804HB20164PP0?EV[04HB2000000010164PP3
000000L0IQ/=00<0000006HK3@1V6`d00`1V6`d01@0mFJ/00000000000229100?EV[00H0PR@@00<0
0000088T402291001@2291000`000000VB/C09T[4`0509T[4`030000000mFJ/0VB/C00D0VB/C00<0
?EV[0000002I:a<00`2I:a<3000000L0[34F00<0000004a]cP1<KLh01@1<KLh3000000@0BVW700<0
00000=@m6@1:JLL0101:JLL00`3D?AT0BVW70000000704YYa`0300000017I;`0AfBl00D0AfBl00<0
000004MT_017I;`01017I;`01@3D?AT0AfBl000000000000e3dI00D0@ef]00<0000004=M[@13GJd0
1@13GJd3000000@0?E>H00<0000003eCV03D?AT00`0mDiP00`000000<dAh03=4N00203=4N0030000
000cA7P0<dAh0080<dAh00@0e3dI02PbF0000000:39H0P0000070?ofkP80000000<0e3dI0?ofkP3o
m^h0103om^h00`3D?AT0ooK^0?ofkP0A0?ofkP<0e3dI4@3om^h0103D?AT0ooK^0000000000040?of
kP80e3dI2@3om^h00`3D?AT0ooK^0?ofkP0^0?ofkP030000003om^h0ooK^01d0ooK^0@3oool001l0
ooK^00<000000?ofkP3om^h0;@3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP80?EV[103om^h00`000000
?EV[0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^0140ooK^00<0?EV[0?ofkP3om^h00`3om^h0100mFJ/0
00000?ofkP3om^h203eIZ`@0ooK^00D0000001D60P0E1P80000001D60P0200000080?EV[00<09PX4
0000000V2P@00P0V2P@300000080AQ8800@0?EV[04HB20164PP000000`164PP010000000IQ/=06HK
3@00000706HK3@030000001V6`d0IQ/=0080IQ/=00H00000088T400mFJ/0?EV[088T400mFJ/6088T
4003000000229100PR@@00<0PR@@0`00000709T[4`030000000mFJ/0VB/C00H0VB/C0P0mFJ/209T[
4`040000002/<AH0[34F000000L0[34F00<0000004a]cP1<KLh01@1<KLh010000000C6g>04a]cP00
000204YYa`80e3dI1`1:JLL00`3D?AT0000004YYa`0604YYa`<000001@17I;`00`000000AfBl04MT
_00404MT_0060=@m6@17I;`0e3dI0=@m6@17I;`000001013GJd00`000000@ef]04=M[@0504=M[@04
00000013GJd0@ef]000000<0?E>H00@0000003eCV00mDiP0e3dI0P0mDiP300000080<dAh00<00000
03=4N00cA7P00P3D?AT20000000502PbF0000000:39H02PbF0000000103om^h20=@m6@80ooK^00<0
00000=@m6@3om^h0103om^h00`3D?AT0ooK^0?ofkP0A0?ofkP030=@m6@3om^h0ooK^0140ooK^00<0
e3dI0000003om^h00`3om^h20=@m6@`0ooK^00<0e3dI0?ofkP3om^h0;@3om^h00`000000ooK^0?of
kP0M0?ofkP40oooo000O0?ofkP030000003om^h0ooK^02d0ooK^00<0?EV[0?ofkP3om^h0303om^h2
03eIZ`80ooK^00@0?EV[0?ofkP00000000004@3om^h303eIZa00ooK^00<0?EV[0?ofkP3om^h00`3o
m^h2000000D0ooK^0P0mFJ/01P3D?AT0000001D60P0E1P80000001D60P8000000`0V2P@203eIZ`03
02H:1000000000000080AQ8800@0000004HB20164PP0?EV[0P164PP010000000AQ8804HB20000003
06HK3@030000001V6`d0IQ/=00D0IQ/=00<0000006HK3@1V6`d00P000003088T40030000000mFJ/0
PR@@00H0PR@@00<00000088T402291000P22910010000000VB/C09T[4`00000709T[4`0303eIZ`00
0000VB/C00H0VB/C00@0000009T[4`0mFJ/000000`2/<AH00`000000[34F0:`a5P040:`a5P0303eI
Z`000000e3dI00H0C6g>00P0000004a]cP1<KLh0C6g>0000003D?AT0BVW7000000L0BVW700<0e3dI
04YYa`1:JLL01P1:JLL010000000BVW704YYa`00000404MT_00300000017I;`0AfBl00D0AfBl00<0
e3dI00000017I;`00P17I;`200000080@ef]00<0000004=M[@13GJd01@13GJd01@000000@ef]04=M
[@13GJd000000080?E>H00@0000003eCV00mDiP0e3dI0P0mDiP00`000000?E>H03eCV00200000003
03=4N03D?AT0e3dI00<0<dAh0P0000001P0X<UP0000002PbF00X<UP0000003eIZ`80e3dI1@3om^h2
000000D0ooK^00<0e3dI0?ofkP3om^h03P3om^h30=@m6A40ooK^0P000000103om^h0e3dI0?ofkP3o
m^h20=@m6@h0ooK^00<0e3dI0?ofkP3om^h0;@3om^h00`000000ooK^0?ofkP0M0?ofkP40oooo000N
0?ofkP030000003om^h0ooK^02h0ooK^00<0?EV[0?ofkP3om^h03P3om^h303eIZ`<0ooK^0P00000?
0?ofkP0303eIZ`3om^h0ooK^0080?EV[3P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP030000003om^h0
ooK^00D0ooK^0P3D?AT00`0mFJ/05@H201D60P030000000302H:100000009PX400809PX40P000000
0`0mFJ/0AQ8804HB200204HB2003000000164PP0?EV[00<0AQ880`00000406HK3@030000001V6`d0
IQ/=00D0IQ/=0`000005088T400403eIZ`229100?EV[03eIZ`D0PR@@00<00000088T402291000P00
000309T[4`030000002I:a<0VB/C00D0VB/C00<0?EV[0000002I:a<01P2I:a<300000080?EV[0P2/
<AH00`000000[34F0:`a5P040:`a5P0303eIZ`000000e3dI00H0C6g>00<0000004a]cP1<KLh00P3D
?AT3000000L0BVW700<000000=@m6@1:JLL01P1:JLL010000000BVW704YYa`1:JLL200000080AfBl
00<0000004MT_017I;`00`17I;`20=@m6@0304MT_03D?AT0AfBl00@0AfBl0`00000704=M[@030000
0013GJd0@ef]0080@ef]0`00000303eCV0030=@m6@0mDiP0000000@0?E>H00<0e3dI0000000cA7P0
0`0cA7P010000000<dAh00000000000302PbF0030=@m6@0mFJ/0?EV[00L0ooK^00<000000?ofkP3o
m^h00P3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP80e3dI0P3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP80
00000`3om^h30=@m6A00ooK^00<0e3dI0?ofkP3om^h0;P3om^h00`000000ooK^0?ofkP0L0?ofkP40
oooo000N0?ofkP030000003om^h0ooK^02h0ooK^00<0?EV[0?ofkP3om^h0403om^h00`0mFJ/0ooK^
0?ofkP030?ofkP030000003om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h00`3om^h203eIZ``0ooK^
00<0?EV[0?ofkP3om^h00P0000070?ofkP80e3dI00D0000003eIZ`0E1P805@H20000000202H:1003
0000000V2P@09PX400809PX400<0000004HB20164PP00P0mFJ/204HB20030000000mFJ/0AQ8800<0
AQ8800<0000006HK3@1V6`d0101V6`d00`000000IQ/=06HK3@0506HK3@03000000229100PR@@00D0
PR@@00@0?EV[088T40229100PR@@0P0mFJ/3088T40<000001P2I:a<00`000000VB/C09T[4`0309T[
4`0303eIZ`2I:a<0000000L0VB/C00<000000:`a5P2/<AH00P2/<AH203eIZ`030000002/<AH0[34F
00<0[34F00D0?EV[0:`a5P000000C6g>0=@m6@0504a]cP030000003D?AT0e3dI00@0C6g>00<00000
04YYa`1:JLL01@1:JLL00`000000e3dI04YYa`0504YYa`030000001:JLL0BVW700@0BVW70`000003
04MT_080e3dI0`17I;`00`3D?AT0AfBl04MT_00504MT_00300000013GJd0@ef]00@0@ef]00<00000
04=M[@13GJd01@13GJd00`000000?E>H03eCV00203eCV0040=@m6@000000?E>H03eCV080e3dI0P0m
DiP00`000000<dAh03=4N00203=4N0040000000cA7P0<dAh00000080:39H00@0e3dI0000000mFJ/0
?EV[1`3om^h200000080ooK^00<0e3dI0?ofkP3om^h02P3om^h20=@m6@D0ooK^00<0e3dI0?ofkP3o
m^h02`3om^h00`000000ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^0100ooK^00<0e3dI0?ofkP3o
m^h0;P3om^h00`000000ooK^0?ofkP0L0?ofkP40oooo000N0?ofkP030000003om^h0ooK^02h0ooK^
00<0?EV[0?ofkP3om^h0403om^h303eIZ`@0ooK^0P00000;0?ofkP0303eIZ`3om^h0ooK^00D0ooK^
0P0mFJ/90?ofkP0603eIZ`3om^h0ooK^0000003om^h0?EV[1@3om^h20=@m6@030?ofkP000000e3dI
00805@H200D0000002H:100V2P@09PX40000000202H:10<0000000@0e3dI04HB20164PP0AQ880P0m
FJ/010164PP0?EV[04HB20164PP3000000L0IQ/=00<0000006HK3@1V6`d00P1V6`d3000000030=@m
6@229100PR@@00<0PR@@00<0?EV[088T400000001022910203eIZ`03088T40000000VB/C00L0VB/C
00<0000009T[4`2I:a<00`2I:a<00`0mFJ/0VB/C0000000509T[4`<000001P2/<AH00`0mFJ/0[34F
0:`a5P030:`a5P0503eIZ`2/<AH0000004a]cP3D?AT01@1<KLh00`3D?AT0C6g>04a]cP0404a]cP<0
00001@1:JLL00`000000BVW70=@m6@0504YYa`030000001:JLL0BVW700H0BVW700@0000004MT_03D
?AT0e3dI1017I;`00`000000AfBl0=@m6@0504MT_00403eIZ`0000000000000000@0@ef]00<00000
04=M[@13GJd01@13GJd300000080?E>H00@0e3dI03eCV03D?AT0e3dI0`0mDiP0100mFJ/000000000
0000000203=4N0050000000cA7P0<dAh03=4N00000000P0X<UP203eIZ`030?ofkP0mFJ/0?EV[00D0
ooK^00<0e3dI0?ofkP0000000P3om^h00`3D?AT0ooK^0?ofkP070?ofkP80e3dI1`3om^h00`3D?AT0
ooK^0?ofkP090?ofkP800000103om^h30=@m6A80ooK^00<0e3dI0?ofkP3om^h0;P3om^h00`000000
ooK^0?ofkP0L0?ofkP40oooo000N0?ofkP030000003om^h0ooK^02h0ooK^00<0?EV[0?ofkP3om^h0
403om^h00`0mFJ/0ooK^0?ofkP0203eIZ`@0ooK^0P0000090?ofkP0303eIZ`3om^h0ooK^00L0ooK^
0P0mFJ/70?ofkP0503eIZ`3om^h000000?ofkP0mFJ/01@3om^h20=@m6@040?ofkP3D?AT0e3dI01D6
0P8000000`0V2P@0100000009PX402H:1000000204HB2003000000164PP0AQ8800<0AQ8800D00000
03eIZ`164PP0AQ880000000206HK3@030000001V6`d0IQ/=00D0IQ/=00D0000006HK3@1V6`d0IQ/=
00000002088T4003000000229100PR@@00<0PR@@00@0?EV[088T4022910000001@2291000`000000
?EV[0000000809T[4`030000002I:a<0VB/C0080VB/C00@0?EV[09T[4`2I:a<000000`2I:a<20000
0080[34F00<000000:`a5P2/<AH0102/<AH00`000000?EV[03eIZ`030:`a5P0503eIZ`2/<AH00000
04a]cP3D?AT00`1<KLh20=@m6@030000001<KLh0C6g>00@0C6g>00<0000004a]cP1<KLh00P000003
04YYa`030000001:JLL0e3dI00D0BVW700<0000004YYa`1:JLL01P1:JLL00`000000e3dI00000005
04MT_00400000017I;`0AfBl0=@m6@D0AfBl00@0000004MT_017I;`000000`13GJd00`000000@ef]
04=M[@0504=M[@0400000013GJd0@ef]00000080?E>H00<0e3dI0000000mDiP0100mDiP010000000
?E>H03eCV000000203=4N0040000000cA7P0<dAh03=4N080000000@0:39H03eIZ`0mFJ/0ooK^0P0m
FJ/50?ofkP050=@m6@3om^h000000?ofkP3D?AT01`3om^h20=@m6@T0ooK^00<0e3dI0?ofkP3om^h0
1`3om^h2000000@0ooK^0P3D?AT20?ofkP030=@m6@3om^h0ooK^0100ooK^00<0e3dI0?ofkP3om^h0
;P3om^h00`000000ooK^0?ofkP0L0?ofkP40oooo000M0?ofkP030000003om^h0ooK^02l0ooK^0`0m
FJ/@0?ofkP0303eIZ`3om^h0ooK^0080ooK^0P0mFJ/40?ofkP8000001`3om^h00`0mFJ/0ooK^0?of
kP090?ofkP80?EV[1@3om^h2000000030?ofkP0mFJ/0ooK^00<0ooK^0`3D?AT00`3om^h0e3dI0000
00020000000302H:100000009PX400809PX400<0000002H:100000000P164PP00`000000AQ8804HB
200404HB200403eIZ`164PP0?EV[03eIZ`<0IQ/=00<0000006HK3@1V6`d01@1V6`d010000000IQ/=
06HK3@000004088T4005000000229100PR@@088T400mFJ/00`2291000`000000PR@@088T4002088T
40030000002I:a<0VB/C0080?EV[1`2I:a<00`000000VB/C09T[4`0209T[4`0503eIZ`2I:a<0VB/C
0000002I:a<00P0000040:`a5P030000002/<AH0[34F00D0[34F00<000000:`a5P0mFJ/00P0mFJ/2
0:`a5P030000001<KLh0C6g>00<0e3dI00<0C6g>0000001<KLh01P1<KLh00`000000C6g>04a]cP02
04a]cP80000000D0BVW70000001:JLL0BVW70=@m6@0404YYa`030000001:JLL0BVW700D0BVW70P3D
?AT204YYa`0300000017I;`0AfBl0080AfBl00D0000004MT_017I;`0AfBl0=@m6@0304MT_0030000
0017I;`0AfBl0080AfBl00@0000004=M[@13GJd000001`13GJd010000000@ef]04=M[@13GJd20=@m
6@0303eCV03D?AT0?E>H00D0?E>H00H0000003eCV00mDiP0000003=4N000000303=4N0030000000c
A7P000000080000000<0?EV[0?ofkP0mFJ/00P0mFJ/40?ofkP040=@m6@3om^h00000000000D0ooK^
0P3D?AT;0?ofkP030=@m6@3om^h0ooK^00D0ooK^0P0000040?ofkP80e3dI103om^h00`3D?AT0ooK^
0?ofkP0>0?ofkP<0e3dI<@3om^h00`000000ooK^0?ofkP0K0?ofkP40oooo000M0?ofkP030000003o
m^h0ooK^02l0ooK^00<0?EV[0?ofkP3om^h00P0mFJ/>0?ofkP0303eIZ`3om^h0ooK^00@0ooK^0P0m
FJ/40?ofkP800000103om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP80?EV[0P3om^h010000000?EV[0?of
kP0mFJ/40?ofkP030=@m6@3om^h0e3dI0080e3dI0P00000202H:10040000000V2P@09PX402H:10<0
00000`164PP00`000000AQ8804HB200304HB200503eIZ`00000000000000001V6`d00P0mFJ/00`1V
6`d0000006HK3@0606HK3@<000001@2291001@000000PR@@088T40229100?EV[00<0PR@@00<00000
088T402291000P00000309T[4`040000002I:a<0?EV[03eIZ`D0VB/C00D0000009T[4`2I:a<0VB/C
03eIZ`0309T[4`8000001P2/<AH00`000000[34F0:`a5P050:`a5P050000002/<AH0[34F0:`a5P0m
FJ/00P2/<AH010000000C6g>04a]cP3D?AT304a]cP030000001<KLh0C6g>00D0C6g>00<0000004a]
cP1<KLh0101<KLh200000080BVW700<0e3dI04YYa`1:JLL00P1:JLL00`000000BVW704YYa`0304YY
a`80e3dI00<0BVW70000001:JLL00P1:JLL200000080AfBl00D0000004MT_017I;`0AfBl0=@m6@03
04MT_00300000017I;`0AfBl00<0AfBl0`00000704=M[@0500000013GJd0e3dI0=@m6@13GJd00`00
00000`3D?AT0?E>H03eCV00303eCV0040000000mDiP0?E>H03eCV0<000000`0cA7P00`000000<dAh
03=4N002000000<0?EV[00<0ooK^03eIZ`3om^h00`3om^h0103D?AT0ooK^0=@m6@0000020?ofkP80
e3dI3P3om^h00`3D?AT0ooK^0?ofkP020?ofkP800000103om^h20=@m6@H0ooK^00<0e3dI0?ofkP3o
m^h0303om^h20=@m6@80ooK^00<0e3dI0?ofkP3om^h0;`3om^h00`000000ooK^0?ofkP0K0?ofkP40
oooo000M0?ofkP030000003om^h0ooK^02l0ooK^00<0?EV[0?ofkP3om^h00P3om^h203eIZ``0ooK^
00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP8000000P3om^h00`0mFJ/0ooK^
0?ofkP0>0?ofkP80000000@0?EV[0?ofkP0mFJ/0ooK^0P0mFJ/00`3om^h0e3dI0?ofkP030=@m6@03
0000000V2P@09PX400809PX400D0000002H:100V2P@09PX40000000504HB2003000000164PP0AQ88
0080AQ8800<0?EV[04HB200000001@1V6`d203eIZ`L0IQ/=00<00000088T402291001@2291001000
0000PR@@088T400mFJ/4088T40<000001P2I:a<010000000VB/C09T[4`0mFJ/409T[4`060000002I
:a<0VB/C09T[4`0mFJ/0VB/C0`0000070:`a5P030000002/<AH0[34F00D0[34F00D000000:`a5P2/
<AH0?EV[0:`a5P0203eIZ`050000003D?AT0e3dI04a]cP3D?AT00P1<KLh00`000000C6g>04a]cP05
04a]cP030000001<KLh0C6g>00D0C6g>0`0000000`1:JLL0e3dI04YYa`0204YYa`030000001:JLL0
BVW70080BVW700@0e3dI04YYa`1:JLL000001P1:JLL3000000@0AfBl00@0e3dI04MT_017I;`00000
1`17I;`00`000000@ef]04=M[@0504=M[@80e3dI1@13GJd00`000000?E>H0=@m6@0403eCV0030000
000mDiP0?E>H00<0?E>H00D0000003=4N00cA7P0<dAh0000000403=4N0070000000mFJ/0?EV[03eI
Z`3om^h0?EV[0?ofkP020=@m6@040?ofkP3D?AT0ooK^0=@m6@800000403om^h00`3D?AT0ooK^0?of
kP02000000D0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP80e3dI103o
m^h00`3D?AT0ooK^0?ofkP0_0?ofkP030000003om^h0ooK^01/0ooK^0@3oool001d0ooK^00<00000
0?ofkP3om^h0;`3om^h00`0mFJ/0ooK^0?ofkP040?ofkP80?EV[2P3om^h00`0mFJ/0ooK^0?ofkP07
0?ofkP80?EV[1@3om^h00`000000ooK^03eIZ`0?0?ofkP030000003om^h0ooK^0080?EV[0`3om^h0
0`3D?AT0?EV[03eIZ`020=@m6@030?ofkP0000009PX400<09PX400<0000002H:100V2P@00`000005
04HB2005000000164PP0AQ8804HB200mFJ/00`00000606HK3@030000000mFJ/0IQ/=00<0IQ/=0`00
0007088T4003000000229100?EV[00D0PR@@00<0000009T[4`2I:a<01P2I:a<010000000VB/C09T[
4`2I:a<203eIZ`<0VB/C00D0000009T[4`0mFJ/0VB/C000000020:`a5P030000002/<AH0[34F00D0
[34F00<000000:`a5P2/<AH01@2/<AH01@000000[34F0:`a5P0mFJ/0[34F00D0000000D0C6g>0=@m
6@1<KLh0C6g>0000000704a]cP030000001<KLh0C6g>00D0C6g>00D0000004a]cP1<KLh000000=@m
6@0204YYa`040000001:JLL0BVW704YYa`80e3dI0`1:JLL00`000000BVW704YYa`0604YYa`030000
0017I;`0AfBl00<0AfBl00<0e3dI04MT_00000001`17I;`3000000@0@ef]00<0e3dI00000013GJd0
1@13GJd3000000050=@m6@0mDiP0?E>H03eCV00000001@0mDiP300000080<dAh00D0000003=4N00c
A7P0<dAh000000020?ofkP80?EV[0P3D?AT0100mFJ/0ooK^0?ofkP3om^h20=@m6@80ooK^00<00000
0?ofkP3om^h03@3om^h00`3D?AT0ooK^000000050?ofkP80e3dI2@3om^h00`3D?AT0ooK^0?ofkP08
0?ofkP80e3dI1P3om^h00`3D?AT0ooK^0?ofkP0_0?ofkP030000003om^h0ooK^01/0ooK^0@3oool0
01d0ooK^00<000000?ofkP3om^h0;`3om^h00`0mFJ/0ooK^0?ofkP060?ofkP80?EV[203om^h00`0m
FJ/0ooK^0?ofkP090?ofkP80?EV[103om^h00`000000?EV[0?ofkP0<0?ofkP8000000`3om^h303eI
Z`030?ofkP3D?AT0e3dI0080e3dI0P0mFJ/00`3om^h0000002H:100302H:10030000000V2P@00000
0080AQ8800<0000004HB20164PP00`164PP01@000000AQ8804HB200mFJ/000000080IQ/=00<00000
06HK3@1V6`d0101V6`d01P000000IQ/=03eIZ`0mFJ/0IQ/=00000080PR@@00<00000088T40229100
1@2291000`000000?EV[088T4003088T40<00000202I:a<00`000000VB/C09T[4`0309T[4`80?EV[
00D0VB/C0000002I:a<0?EV[000000030:`a5P030000002/<AH0[34F00D0[34F00<000000:`a5P2/
<AH01@2/<AH01@000000[34F03eIZ`2/<AH000000080_3HH00P0000004e_e01=Km@0000004a]cP3D
?AT0C6g>000000H0C6g>00<0000004a]cP1<KLh01P1<KLh02@000000C6g>04a]cP1<KLh000000=@m
6@1:JLL0000004YYa`020=@m6@D0BVW700<0000004YYa`1:JLL01P1:JLL3000000@0AfBl00<0e3dI
00000017I;`01P17I;`01@000000AfBl04MT_0000000@ef]0080e3dI00<0@ef]00000013GJd01@13
GJd01@000000@ef]04=M[@000000e3dI0080?E>H00<0000003eCV00mDiP00`0mDiP01P000000?E>H
03eCV0000000<dAh000000@0<dAh00@000000?ofkP3D?AT0e3dI100mFJ/0103om^h0e3dI0=@m6@3D
?AT30?ofkP8000003@3om^h00`3D?AT000000?ofkP030?ofkP80e3dI2`3om^h00`3D?AT0ooK^0?of
kP060?ofkP80e3dI203om^h00`3D?AT0ooK^0?ofkP0_0?ofkP030000003om^h0ooK^01/0ooK^0@3o
ool001`0ooK^00<000000?ofkP3om^h0<@3om^h00`0mFJ/0ooK^0?ofkP070?ofkP80?EV[1P3om^h0
0`0mFJ/0ooK^0?ofkP0;0?ofkP80?EV[0P3om^h0100mFJ/0ooK^00000000000:0?ofkP030000003o
m^h0ooK^0080ooK^0P0mFJ/0103om^h0e3dI03eIZ`0mFJ/20=@m6@<0ooK^0P0mFJ/302H:10030000
000V2P@000000080AQ8800<0000004HB20164PP00`164PP01@000000AQ8804HB200mFJ/0000000<0
IQ/=00<0000006HK3@1V6`d0101V6`d010000000IQ/=06HK3@00000203eIZ`<0PR@@00<00000088T
40229100102291000`000000?EV[088T4002088T40040000002I:a<0VB/C000000P0VB/C00<00000
09T[4`2I:a<01@2I:a<303eIZ`030000002/<AH0[34F00<0[34F00<000000:`a5P2/<AH01@2/<AH0
0`000000[34F0:`a5P040:`a5P040000002/<AH0?EV[000000<0_3HH00P0000004e_e01=Km@0CFoD
0000003D?AT0C6g>000000H0C6g>00<0000004a]cP1<KLh01@1<KLh00`000000C6g>04a]cP0304a]
cP040=@m6@000000e3dI0=@m6@L0BVW700<0000004YYa`1:JLL01@1:JLL01@000000BVW704YYa`1:
JLL0000000<0AfBl00<0e3dI00000017I;`01@17I;`010000000AfBl04MT_017I;`20=@m6@040000
0013GJd0@ef]000000H0@ef]00H0000004=M[@13GJd0@ef]0000003D?AT203eCV0030000000mDiP0
?E>H00<0?E>H00H0000003eCV00mDiP0000003=4N000000303=4N080e3dI0P3om^h303eIZ`80e3dI
00@0?EV[0?ofkP3D?AT0e3dI103om^h00`000000ooK^0?ofkP080?ofkP80000000@0ooK^0=@m6@3o
m^h0ooK^0P3D?AT=0?ofkP030=@m6@3om^h0ooK^00@0ooK^0P3D?AT90?ofkP030=@m6@3om^h0ooK^
0340ooK^00<000000?ofkP3om^h06P3om^h10?ooo`00703om^h00`000000ooK^0?ofkP0a0?ofkP03
03eIZ`3om^h0ooK^00T0ooK^0P0mFJ/40?ofkP0303eIZ`3om^h0ooK^00d0ooK^0`0mFJ/30?ofkP80
00001`3om^h00`000000ooK^0?ofkP020?ofkP0303eIZ`3om^h0?EV[0080e3dI00@0ooK^0=@m6@0m
FJ/0?EV[0`3om^h00`0000009PX403eIZ`0202H:108000000`164PP00`000000AQ8804HB200304HB
20<0000000<0?EV[06HK3@1V6`d00P1V6`d00`000000IQ/=06HK3@0406HK3@<000000`229100100m
FJ/0PR@@088T40000006088T400503eIZ`000000PR@@088T40000000102I:a<00`000000VB/C09T[
4`0509T[4`030000002I:a<0VB/C00H0VB/C00<0000003eIZ`2/<AH01@2/<AH00`000000[34F0:`a
5P050:`a5P030000002/<AH0[34F00@0[34F00<0000003eIZ`000000102l=QP00`000000CFoD04e_
e00204e_e0030000003D?AT0000000H0C6g>00<0000004a]cP1<KLh01@1<KLh00`000000C6g>04a]
cP0404a]cP030=@m6@000000BVW700L0BVW700<0000004YYa`1:JLL01@1:JLL00`000000BVW704YY
a`0204YYa`0500000017I;`0AfBl0000003D?AT01P17I;`010000000AfBl04MT_03D?AT304MT_0<0
00001P13GJd00`000000@ef]04=M[@0204=M[@040=@m6@0000000000000000D0?E>H00@0000003eC
V00mDiP0?E>H0P00000203=4N0030=@m6@0cA7P0000000<0ooK^0P3D?AT01`0mFJ/0ooK^03eIZ`0m
FJ/0e3dI0?ofkP3D?AT0103om^h00`000000ooK^0?ofkP050?ofkP8000000`3om^h30=@m6@l0ooK^
00<0e3dI0?ofkP3om^h00P3om^h20=@m6@/0ooK^00<0e3dI0?ofkP3om^h0<@3om^h00`000000ooK^
0?ofkP0J0?ofkP40oooo000L0?ofkP030000003om^h0ooK^0340ooK^00<0?EV[0?ofkP3om^h02`3o
m^h203eIZ`80ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP030?ofkP8000000`3o
m^h2000000<0ooK^0P0mFJ/0103om^h0?EV[0=@m6@3om^h20=@m6@030?ofkP3D?AT0ooK^0080?EV[
00@0000002H:100V2P@09PX40P0mFJ/504HB2003000000164PP0AQ8800<0AQ8800<0000006HK3@0m
FJ/01@1V6`d00`000000IQ/=06HK3@0406HK3@03000000229100PR@@00@0PR@@0P0mFJ/00`000000
PR@@088T4003088T400303eIZ`2291000000008000001@2I:a<00`000000VB/C09T[4`0509T[4`03
0000002I:a<0VB/C00@0VB/C0P000000100mFJ/0[34F03eIZ`0mFJ/40:`a5P030000002/<AH0[34F
00D0[34F00<000000:`a5P2/<AH0102/<AH00`000000?EV[0;`f60040;`f60030000001=Km@0CFoD
00<0CFoD00<0e3dI0000001<KLh01@1<KLh00`000000C6g>04a]cP0504a]cP030000001<KLh0C6g>
0080C6g>0P3D?AT0101<KLh0e3dI00000000000604YYa`030000001:JLL0BVW700D0BVW700<00000
04YYa`1:JLL00`1:JLL30000000304MT_03D?AT0AfBl00@0AfBl00<000000=@m6@3D?AT01P17I;`0
0`000000@ef]04=M[@0404=M[@0300000013GJd0@ef]00<0@ef]00<0e3dI04=M[@0000001@0mDiP0
0`000000?E>H03eCV00303eCV080e3dI0P0cA7P01@000000ooK^0=@m6@3D?AT0?EV[0080ooK^0P0m
FJ/0103om^h0?EV[0=@m6@3om^h20=@m6@<0ooK^0P0000030?ofkP8000001@3om^h00`3D?AT0ooK^
0?ofkP0?0?ofkP030=@m6@3om^h0ooK^0080e3dI3@3om^h00`3D?AT0ooK^0?ofkP0a0?ofkP030000
003om^h0ooK^01X0ooK^0@3oool001`0ooK^00<000000?ofkP3om^h0<@3om^h00`0mFJ/0ooK^0?of
kP0=0?ofkP<0?EV[4@3om^h303eIZ`D0ooK^0`0000040?ofkP0603eIZ`3om^h0ooK^0=@m6@0mFJ/0
ooK^0P3D?AT20?ofkP050=@m6@3om^h0ooK^0=@m6@0mFJ/00P0V2P@300000080?EV[0`164PP01000
0000AQ8804HB20164PP30000000303eIZ`1V6`d0IQ/=00@0IQ/=00<0000006HK3@1V6`d00P1V6`d3
000000030=@m6@229100PR@@00D0PR@@0P0mFJ/3088T400403eIZ`229100PR@@000000L0VB/C00<0
000009T[4`2I:a<01P2I:a<00`000000VB/C09T[4`0209T[4`040000002/<AH0[34F03eIZ`<0[34F
0P0mFJ/20:`a5P030000002/<AH0[34F00D0[34F00<000000:`a5P2/<AH00P2/<AH20000000303eI
Z`2l=QP0_3HH00@0_3HH00<0000004e_e01=Km@0101=Km@00`3D?AT000000000000404a]cP030000
001<KLh0C6g>00D0C6g>00<0000004a]cP1<KLh00P3D?AT304a]cP040=@m6@1<KLh0C6g>000000@0
BVW700<0000004YYa`1:JLL01P1:JLL00`000000BVW704YYa`0504YYa`0400000017I;`0AfBl0=@m
6@<0AfBl0P3D?AT704MT_00403eIZ`0000000000000000@0@ef]00<0000004=M[@13GJd01013GJd0
103D?AT0000000000000000303eCV0040000000mDiP0?E>H03eCV080e3dI0`00000203=4N0050=@m
6@0mFJ/0ooK^0?ofkP0mFJ/00P3om^h203eIZ`030?ofkP3D?AT0?EV[0080ooK^00<0e3dI0?ofkP3o
m^h00P3om^h3000000D0ooK^0`3D?ATA0?ofkP<0e3dI3`3om^h00`3D?AT0ooK^0?ofkP0a0?ofkP03
0000003om^h0ooK^01X0ooK^0@3oool001/0ooK^00<000000?ofkP3om^h0<P3om^h00`0mFJ/0ooK^
0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h00P0mFJ/30?ofkP<00000
0`3om^h00`0mFJ/0ooK^0?ofkP020=@m6@0303eIZ`3D?AT0ooK^0080ooK^103D?AT010000000e3dI
02H:1000000204HB2003000000164PP0AQ880080?EV[00D0AQ88000000164PP0AQ880000000206HK
3@0303eIZ`1V6`d0IQ/=00D0IQ/=00D0000006HK3@1V6`d0IQ/=00000002088T4003000000229100
PR@@00H0PR@@00H00000088T400mFJ/0?EV[088T400mFJ/3000000030=@m6@2I:a<0VB/C00@0VB/C
00<0000009T[4`2I:a<01P2I:a<00`000000VB/C09T[4`0200000080[34F00<0?EV[0000002/<AH0
102/<AH203eIZ`030000002/<AH0[34F00D0[34F00<000000:`a5P2/<AH00P0000020;`f600303eI
Z`2l=QP0_3HH00@0_3HH00<0000004e_e01=Km@0101=Km@00`3D?AT0CFoD04e_e00200000080C6g>
00<0000004a]cP1<KLh01@1<KLh00`000000e3dI0=@m6@0504a]cP040000003D?AT0C6g>04a]cP80
00000P1:JLL00`000000BVW704YYa`0504YYa`030000001:JLL0BVW700D0BVW700H0?EV[00000000
000000000=@m6@17I;`20=@m6@0304MT_0000000AfBl00L0AfBl00@0000004MT_017I;`000000`13
GJd00`000000@ef]04=M[@0504=M[@040=@m6@13GJd0@ef]00000080?E>H00@0000003eCV03D?AT0
e3dI0P0mDiP01@000000?E>H03eCV0000000<dAh00D0?EV[103om^h0100mFJ/0e3dI03eIZ`0mFJ/2
0?ofkP040=@m6@3om^h0ooK^0?ofkP<000000`3om^h20=@m6@80ooK^00<0e3dI0?ofkP3om^h03`3o
m^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^0340ooK^00<000000?ofkP3om^h06P3o
m^h10?ooo`006`3om^h00`000000ooK^0?ofkP0b0?ofkP0303eIZ`3om^h0ooK^00l0ooK^0`0mFJ/?
0?ofkP0303eIZ`3om^h0ooK^0080ooK^0P0mFJ/010000000ooK^0?ofkP3om^h20000000303eIZ`3o
m^h0ooK^00<0e3dI00<0?EV[0=@m6@3D?AT01`3D?AT01@0V2P@0000004HB20164PP0000000D0AQ88
0P0mFJ/01P164PP0000006HK3@1V6`d0?EV[000000L0IQ/=00@0000006HK3@1V6`d0000010229100
0`000000PR@@088T4005088T4006000000229100PR@@088T400mFJ/000000P2I:a<00`000000VB/C
09T[4`0609T[4`030000002I:a<0VB/C00D0VB/C0`0000030:`a5P0403eIZ`2/<AH0[34F000000H0
[34F0P0mFJ/60:`a5P<000000`2l=QP00`0mFJ/000000;`f60050;`f60030000001=Km@0CFoD00@0
CFoD00<000000=@m6@1=Km@00P1=Km@3000000H0C6g>0P3D?AT604a]cP040000001<KLh0C6g>0=@m
6@<0C6g>0`00000704YYa`030000001:JLL0BVW700D0BVW700H0000004YYa`1:JLL0BVW70000003D
?AT304MT_00300000017I;`0AfBl00D0AfBl00<0000004MT_017I;`00P17I;`010000000@ef]04=M
[@00000704=M[@060000003D?AT0@ef]04=M[@000000?E>H0P3D?AT503eCV0050000000mDiP0?E>H
0000000cA7P02@0mFJ/0103D?AT0?EV[03eIZ`0mFJ/20?ofkP030=@m6@000000000000<0ooK^00<0
00000=@m6@3D?AT0103om^h00`3D?AT0ooK^0?ofkP0=0?ofkP<0e3dI4@3om^h00`3D?AT0ooK^0?of
kP0b0?ofkP030000003om^h0ooK^01T0ooK^0@3oool001/0ooK^00<000000?ofkP3om^h0<P3om^h3
03eIZ`l0ooK^00<0?EV[0?ofkP3om^h00P0mFJ/=0?ofkP0303eIZ`3om^h0ooK^0080ooK^0P000002
03eIZ`<0ooK^00<0?EV[0000003D?AT0103D?AT0100mFJ/0ooK^0?ofkP3om^h20=@m6@030?ofkP3D
?AT00000008000000`164PP00`000000AQ8804HB200304HB208000000P0mFJ/0101V6`d0?EV[06HK
3@00000706HK3@<000001@2291000`000000PR@@088T4006088T4004000000229100?EV[00000080
?EV[0P2I:a<00`000000VB/C09T[4`0509T[4`030000002I:a<0VB/C00D0VB/C00<000000:`a5P2/
<AH00P2/<AH01@0mFJ/0[34F0:`a5P2/<AH0000000H0[34F00<000000:`a5P0mFJ/01@2/<AH00`00
0000_3HH0;`f60030;`f600303eIZ`000000_3HH00D0_3HH00<0000004e_e01=Km@0101=Km@00`00
0000e3dI04e_e00404e_e0030000001<KLh0C6g>00<0C6g>00<0e3dI04a]cP0000001P1<KLh01@00
0000C6g>04a]cP1<KLh0e3dI00@0C6g>00<0000004YYa`1:JLL01@1:JLL00`000000BVW704YYa`05
04YYa`030000001:JLL0BVW70080e3dI00@000000=@m6@17I;`000002017I;`00`000000AfBl04MT
_00304MT_0<000001`13GJd010000000@ef]0=@m6@13GJd20=@m6@8000001@0mDiP010000000?E>H
03eCV00mDiP2000000040?ofkP0mFJ/0ooK^03eIZ`@0ooK^00<0e3dI03eIZ`0mFJ/00`0mFJ/00`00
0000e3dI0?ofkP020?ofkP80e3dI0P0000040?ofkP030=@m6@3om^h0ooK^00/0ooK^0P3D?AT20?of
kP030=@m6@3om^h0ooK^00d0ooK^0`3D?ATd0?ofkP030000003om^h0ooK^01T0ooK^0@3oool001/0
ooK^00<000000?ofkP3om^h0<`3om^h0100mFJ/0ooK^03eIZ`0mFJ/=0?ofkP0303eIZ`3om^h0ooK^
0080ooK^0P0mFJ/;0?ofkP0503eIZ`3om^h0ooK^0?ofkP000000103om^h303eIZ`030?ofkP3D?AT0
ooK^0080e3dI0P3om^h00`0mFJ/0ooK^0?ofkP020=@m6@040?ofkP3D?AT0ooK^000000D0AQ8800<0
000004HB20164PP00`164PP01@000000IQ/=06HK3@1V6`d0?EV[0080IQ/=00<0000006HK3@1V6`d0
1@1V6`d00`000000PR@@088T4005088T4003000000229100PR@@00H0PR@@00<0000003eIZ`000000
0`2I:a<203eIZ`030000002I:a<0VB/C00D0VB/C00<0000009T[4`2I:a<00`2I:a<3000000@0[34F
00D0?EV[0:`a5P2/<AH0[34F000000070:`a5P050000002/<AH0?EV[03eIZ`2/<AH00`0000040;`f
600303eIZ`2l=QP0000000H0_3HH00<0000004e_e01=Km@0101=Km@00`000000CFoD0=@m6@0404e_
e0<0000000D0C6g>0=@m6@3D?AT0C6g>0000000704a]cP050000001<KLh0C6g>04a]cP3D?AT0101<
KLh3000000D0BVW700<0000004YYa`1:JLL01@1:JLL00`000000e3dI0=@m6@0304YYa`030000003D
?AT0000000P0AfBl00<0000004MT_017I;`01@17I;`00`000000@ef]04=M[@0404=M[@0500000013
GJd0@ef]04=M[@3D?AT00`13GJd00`000000?E>H03eCV00303eCV0030000000mDiP0?E>H00<0?E>H
00@000000?ofkP0mFJ/0ooK^0P0mFJ/20?ofkP030=@m6@3om^h0ooK^0080?EV[00<0ooK^03eIZ`3o
m^h00`3D?AT40?ofkP050000003om^h0ooK^0?ofkP3D?AT02`3om^h20=@m6@@0ooK^00<0e3dI0?of
kP3om^h02`3om^h20=@m6@030?ofkP3D?AT0ooK^03@0ooK^00<000000?ofkP3om^h06@3om^h10?oo
o`006`3om^h00`000000ooK^0?ofkP0c0?ofkP0403eIZ`3om^h0ooK^0?ofkP80?EV[2`3om^h00`0m
FJ/0ooK^0?ofkP040?ofkP80?EV[2@3om^h0100mFJ/0ooK^0?ofkP0000050?ofkPD0?EV[00D0e3dI
0?ofkP3om^h0000003eIZ`020?ofkP@0e3dI0P3om^h00`000000AQ8804HB200304HB200400000016
4PP0AQ8804HB20<000000P1V6`d01P0mFJ/0IQ/=03eIZ`0mFJ/0IQ/=000000@0IQ/=0`000007088T
4003000000229100PR@@00H0PR@@00<0?EV[09T[4`2I:a<01@2I:a<203eIZ`H0VB/C00@0000009T[
4`2I:a<0VB/C0P0000030:`a5P040000002/<AH0[34F03eIZ`@0[34F00<000000:`a5P2/<AH01@2/
<AH010000000[34F0:`a5P00000203eIZ`030;`f60000000_3HH00<0_3HH00<0?EV[0;`f60000000
1P2l=QP00`000000CFoD04e_e00404e_e0030000001=Km@0e3dI00@0CFoD00D0000004e_e03D?AT0
e3dI0000000204a]cP030000001<KLh0C6g>00D0C6g>00<0000004a]cP1<KLh00P1<KLh0103D?AT0
C6g>04a]cP00000304a]cP8000000P1:JLL00`000000BVW704YYa`0504YYa`80e3dI1`1:JLL00`3D
?AT0AfBl04MT_00604MT_00300000017I;`0AfBl00D0AfBl0`00000404=M[@0600000013GJd0e3dI
0=@m6@13GJd0e3dI0P13GJd3000000<0?E>H00<0000003eCV00mDiP00`0mDiP00`000000ooK^0?of
kP0203eIZ`060?ofkP0mFJ/0ooK^0?ofkP3D?AT000000P3om^h00`0mFJ/0e3dI0=@m6@030=@m6@D0
ooK^00@000000?ofkP3om^h0e3dI2@3om^h20=@m6@H0ooK^00<0e3dI0?ofkP3om^h02@3om^h20=@m
6@<0ooK^00<0e3dI0?ofkP3om^h0<`3om^h00`000000ooK^0?ofkP0I0?ofkP40oooo000J0?ofkP03
0000003om^h0ooK^03@0ooK^00<0?EV[0?ofkP3om^h00`3om^h203eIZ`T0ooK^00<0?EV[0?ofkP3o
m^h01P3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`000000000000D0ooK^00<0?EV[0?ofkP3D
?AT00P3D?AT303eIZ`80ooK^00D0?EV[0=@m6@3D?AT0ooK^0=@m6@040?ofkP03000000164PP0AQ88
0080AQ8800<0000004HB20164PP00P00000206HK3@030000001V6`d0?EV[00@0IQ/=0P0mFJ/306HK
3@04000000229100PR@@000000L0PR@@00<00000088T40229100102291020000000303eIZ`2I:a<0
VB/C00D0VB/C00<0000009T[4`0mFJ/01P2I:a<3000000D0[34F00<000000:`a5P0mFJ/01@2/<AH0
0`000000[34F0:`a5P050:`a5P<000000`2l=QP203eIZ`<0_3HH00@0?EV[0;`f602l=QP000001P2l
=QP00`000000CFoD04e_e00404e_e0040000001=Km@0CFoD0=@m6@<0CFoD0P3D?AT304e_e0<00000
1`1<KLh00`000000C6g>04a]cP0304a]cP030=@m6@1<KLh0000000D0C6g>0`00000604YYa`030=@m
6@000000BVW700L0BVW700<0e3dI0000000000001P17I;`00`000000AfBl04MT_00504MT_0040000
0017I;`0AfBl000000<0@ef]0P3D?AT404=M[@030=@m6@13GJd000000080@ef]0P00000203eCV003
0000000mDiP0?E>H0080?E>H00<000000?ofkP3om^h00P3om^h01@0mFJ/0ooK^03eIZ`0mFJ/0e3dI
0080ooK^0`3D?AT303eIZ`030?ofkP3D?AT0ooK^00@0ooK^0P0000000`3D?AT0ooK^0?ofkP060?of
kP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h01`3om^h20=@m6@@0ooK^00<0e3dI0?of
kP3om^h0=@3om^h00`000000ooK^0?ofkP0H0?ofkP40oooo000J0?ofkP030000003om^h0ooK^03D0
ooK^00<0?EV[0?ofkP3om^h0103om^h203eIZ`P0ooK^00<0?EV[0?ofkP3om^h01P3om^h203eIZ`H0
ooK^00<000000?ofkP3om^h00`3om^h203eIZ`030?ofkP3D?AT0e3dI00<0e3dI00<0ooK^03eIZ`0m
FJ/00P0mFJ/0103om^h0e3dI0=@m6@3D?AT30?ofkP03000000164PP0AQ8800<0AQ880`00000406HK
3@030000000mFJ/0IQ/=00D0IQ/=00@0000003eIZ`0mFJ/00000102291000`000000PR@@088T4004
088T4003000000229100PR@@00<0PR@@00D0000009T[4`0mFJ/0VB/C0000000709T[4`040000002I
:a<0?EV[03eIZ`@0VB/C00<000000:`a5P2/<AH01@2/<AH00`000000?EV[0:`a5P050:`a5P030000
002/<AH0[34F00D0[34F00<000000;`f602l=QP01@2l=QP203eIZ`030;`f600mFJ/0_3HH0080_3HH
00<000000;`f602l=QP00`2l=QP00`000000CFoD04e_e00304e_e0060000001=Km@0CFoD04e_e03D
?AT0CFoD0P3D?AT704e_e0030000001<KLh0C6g>00D0C6g>00<0000004a]cP1<KLh0101<KLh00`3D
?AT0000004a]cP0604a]cP030000001:JLL0BVW70080BVW70P3D?AT00`1:JLL0000004YYa`0604YY
a`050000001:JLL0e3dI04YYa`0000001@17I;`00`000000AfBl04MT_00404MT_00300000017I;`0
AfBl0080AfBl00@000000=@m6@3D?AT000001P13GJd00`3D?AT0000004=M[@0304=M[@<000001@0m
DiP010000000ooK^0?ofkP3om^h303eIZ`030?ofkP3D?AT0e3dI0080e3dI00<0ooK^03eIZ`0mFJ/0
0`0mFJ/00`3om^h0e3dI0=@m6@050?ofkP030000003om^h0ooK^00@0ooK^0P3D?AT80?ofkP030=@m
6@3om^h0ooK^00H0ooK^0P3D?AT60?ofkP030=@m6@3om^h0ooK^03D0ooK^00<000000?ofkP3om^h0
603om^h10?ooo`006P3om^h00`000000ooK^0?ofkP0e0?ofkP0303eIZ`3om^h0ooK^00H0ooK^0P0m
FJ/60?ofkP0303eIZ`3om^h0ooK^00P0ooK^0P0mFJ/20?ofkP80000000<0?EV[0?ofkP3om^h00P3o
m^h00`0mFJ/0ooK^0=@m6@030=@m6@030?ofkP3D?AT0ooK^0080ooK^00@0e3dI03eIZ`0mFJ/0?EV[
0P3om^h01@3D?AT000000?ofkP3om^h0000000D0AQ8800<0000006HK3@1V6`d0101V6`d00`0mFJ/0
IQ/=06HK3@0506HK3@030=@m6@00000000000080?EV[0`2291000`000000PR@@088T4005088T4003
000000229100PR@@0080000000D0VB/C03eIZ`2I:a<0VB/C0000000709T[4`040000002I:a<0VB/C
09T[4`80?EV[0`0000080:`a5P0303eIZ`2/<AH0[34F00D0[34F00<000000:`a5P2/<AH00P2/<AH3
000000L0_3HH00<000000;`f600mFJ/0102l=QP00`000000_3HH0;`f60030;`f60030000001=Km@0
CFoD00<0CFoD00<0000004e_e01=Km@00P1=Km@00`3D?AT0CFoD0000000704e_e0<00000101<KLh0
0`000000C6g>04a]cP0504a]cP030=@m6@1<KLh0C6g>00H0C6g>0`0000020=@m6@<0BVW700<00000
04YYa`1:JLL01@1:JLL01@000000BVW704YYa`3D?AT0BVW7008000000P17I;`00`000000AfBl04MT
_00504MT_00400000017I;`0AfBl04MT_080e3dI0P0000000`0mFJ/0@ef]04=M[@0504=M[@030=@m
6@13GJd0@ef]00@0@ef]00<0000003eCV00mDiP00`0mDiP01@000000ooK^0?ofkP000000?EV[0080
ooK^0`3D?AT0100mFJ/0ooK^0?ofkP0mFJ/20?ofkP@0?EV[00<0ooK^0=@m6@3om^h00`3om^h00`3D
?AT00000000000020?ofkP80e3dI2P3om^h00`3D?AT0ooK^0?ofkP040?ofkP80e3dI203om^h00`3D
?AT0ooK^0?ofkP0e0?ofkP030000003om^h0ooK^01P0ooK^0@3oool001X0ooK^00<000000?ofkP3o
m^h0=P3om^h00`0mFJ/0ooK^0?ofkP070?ofkP80?EV[103om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP05
03eIZ`000000ooK^0?ofkP0mFJ/00P3om^h203eIZ`D0e3dI0P3om^h60=@m6@<0?EV[00<0e3dI0?of
kP3om^h00`00000304HB20<000001@1V6`d00`0mFJ/0000006HK3@0606HK3@03000000229100PR@@
0080PR@@00@0?EV[088T4022910000001`22910300000080VB/C00D0?EV[09T[4`2I:a<0VB/C0000
000709T[4`030000002I:a<0VB/C0080VB/C00D0000003eIZ`2/<AH0[34F000000060:`a5P0303eI
Z`000000[34F00H0[34F00<000000:`a5P2/<AH00P0000020;`f60030000002l=QP0_3HH00D0_3HH
00<0000003eIZ`2l=QP00P0mFJ/20;`f60030000002l=QP0_3HH00<0_3HH00<0000004e_e01=Km@0
0`1=Km@00`000000CFoD04e_e0020=@m6@0304e_e03D?AT0000000L0CFoD00<0000004e_e01=Km@0
0P00000204a]cP030000001<KLh0C6g>00D0C6g>00<000000=@m6@1<KLh01@1<KLh01@000000C6g>
04a]cP3D?AT0000000@0BVW700<0000004YYa`1:JLL01@1:JLL01@000000BVW704YYa`1:JLL0e3dI
0080BVW70`00000704MT_00400000017I;`0AfBl0=@m6@@0AfBl00<0000004=M[@13GJd01@13GJd0
0`000000e3dI04=M[@0404=M[@<000000`0mDiP3000000030?ofkP0mFJ/0ooK^00<0e3dI1P0mFJ/2
0?ofkPD0?EV[0P3D?AT20?ofkP050=@m6@3om^h0ooK^0000003D?AT0303om^h00`3D?AT0ooK^0?of
kP020?ofkP80e3dI2@3om^h00`3D?AT0ooK^0?ofkP0f0?ofkP030000003om^h0ooK^01P0ooK^0@3o
ool001X0ooK^00<000000?ofkP3om^h0=P3om^h00`0mFJ/0ooK^0?ofkP090?ofkP80?EV[0P3om^h0
0`0mFJ/0ooK^0?ofkP090?ofkP80000000T0ooK^03eIZ`0mFJ/0?EV[0?ofkP0mFJ/0ooK^0=@m6@3o
m^h01`3D?AT30?ofkP050=@m6@3om^h0?EV[0?ofkP3D?AT00P0mFJ/30=@m6@04000000164PP0AQ88
00000080IQ/=00@0000006HK3@1V6`d0IQ/=0P0mFJ/00`1V6`d0000006HK3@0406HK3@<000001@22
910203eIZ`03000000229100PR@@00D0PR@@00D0000009T[4`2I:a<0VB/C03eIZ`0409T[4`030000
002I:a<0VB/C00D0VB/C00D0000009T[4`2I:a<0VB/C000000020:`a5P80?EV[00<000000:`a5P2/
<AH00`2/<AH00`0mFJ/0[34F000000070:`a5P<000001@2l=QP00`000000_3HH0;`f60040;`f6003
0000000mFJ/0_3HH0080_3HH00<0?EV[0;`f600000001@2l=QP00`000000CFoD04e_e00304e_e003
0000001=Km@0e3dI00<0CFoD00<0e3dI0000001=Km@01@1=Km@00`000000CFoD04e_e00304e_e0<0
00001`1<KLh00`000000C6g>0=@m6@0504a]cP030000003D?AT0e3dI0080C6g>00@0000004YYa`1:
JLL00000201:JLL00`000000BVW704YYa`0204YYa`050=@m6@1:JLL0BVW704YYa`0000001`17I;`0
0`000000e3dI0=@m6@0504MT_0<000001@13GJd010000000@ef]0=@m6@3D?AT304=M[@0400000013
GJd0@ef]00000080?E>H00@0000003eIZ`0mFJ/0?EV[0P3D?AT01@0mFJ/0ooK^0=@m6@3om^h0?EV[
00<0ooK^1`0mFJ/01@3om^h0?EV[0?ofkP3D?AT0ooK^00<0e3dI00<0ooK^0000000000002`3om^h0
0`3D?AT0ooK^0?ofkP020=@m6@/0ooK^00<0e3dI0?ofkP3om^h0=P3om^h00`000000ooK^0?ofkP0H
0?ofkP40oooo000I0?ofkP030000003om^h0ooK^03P0ooK^0P0mFJ/;0?ofkP<0?EV[2P3om^h00`00
0000ooK^0?ofkP030?ofkP80?EV[1P3D?AT30?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT00P3om^h0
100mFJ/0ooK^0?ofkP3D?AT303eIZ`04000000164PP0AQ88000000<0IQ/=00@0000006HK3@1V6`d0
?EV[0`1V6`d010000000IQ/=06HK3@1V6`d200000080PR@@00<00000088T402291001@22910203eI
Z`@0PR@@0`00000209T[4`0303eIZ`2I:a<0VB/C00@0VB/C00<0000009T[4`2I:a<01@2I:a<30000
00D0[34F0P0mFJ/30:`a5P0503eIZ`2/<AH0[34F0:`a5P0000001P2/<AH00`000000_3HH0;`f6005
0;`f60030000002l=QP0_3HH00@0_3HH00<0?EV[0;`f602l=QP00`2l=QP00`0mFJ/000000;`f6002
0;`f60D000000`1=Km@00`000000e3dI04e_e00404e_e0030=@m6@1=Km@0CFoD00@0CFoD00<00000
04e_e01=Km@01@1=Km@00`000000C6g>04a]cP0404a]cP050000001<KLh0C6g>04a]cP3D?AT00`1<
KLh20=@m6@D0C6g>0`00000704YYa`030000001:JLL0BVW700@0BVW700<0e3dI04YYa`1:JLL00`00
000404MT_080e3dI1`17I;`00`000000AfBl04MT_002000000<0@ef]00D0000004=M[@13GJd0@ef]
0=@m6@0204=M[@0500000013GJd0@ef]04=M[@0000000P0mDiP01@000000e3dI0=@m6@3D?AT0?EV[
0080ooK^00@0e3dI0?ofkP3om^h0?EV[0`3om^h0100mFJ/0ooK^0?ofkP3om^h603eIZ`80e3dI1@3o
m^h00`000000ooK^0?ofkP080?ofkP<0e3dI2`3om^h20=@m6CX0ooK^00<000000?ofkP3om^h05`3o
m^h10?ooo`006@3om^h00`000000ooK^0?ofkP0i0?ofkP<0?EV[2`3om^h00`0mFJ/0ooK^0?ofkP07
0?ofkP030000003om^h0ooK^00<0ooK^100mFJ/30=@m6@@0ooK^00<0e3dI0?ofkP3om^h00P3D?AT3
0?ofkP0403eIZ`3om^h0ooK^0=@m6@80ooK^0`0mFJ/00`000000IQ/=06HK3@0206HK3@030000001V
6`d0?EV[00@0IQ/=00@0000006HK3@00000000001@2291000`000000PR@@088T4005088T40030000
000mFJ/0?EV[008000000`2I:a<00`000000VB/C03eIZ`0609T[4`030000002I:a<0VB/C00D0VB/C
00<000000:`a5P2/<AH01P2/<AH01@000000?EV[03eIZ`2/<AH0?EV[00<0[34F00<000000:`a5P2/
<AH00P2/<AH3000000L0_3HH00<000000;`f602l=QP00`2l=QP00`0mFJ/000000;`f60050;`f6080
?EV[00D0_3HH0000003:>QT0bSXI0000000204iaf@040000001=Km@0e3dI0=@m6@H0CFoD00<00000
0=@m6@1=Km@0101=Km@00`000000CFoD04e_e00504e_e0<00000101<KLh01P000000C6g>04a]cP1<
KLh0e3dI04a]cP80e3dI00<0000004a]cP1<KLh01P1<KLh00`000000BVW704YYa`0504YYa`030000
001:JLL0BVW700@0BVW700<0e3dI04YYa`0000000`1:JLL200000080e3dI00<0000004MT_017I;`0
1@17I;`00`000000AfBl04MT_00304MT_080000000<0@ef]00000013GJd00`13GJd00`3D?AT0@ef]
0000000404=M[@040000003D?AT0e3dI0=@m6@80ooK^00@0?EV[0?ofkP3om^h0e3dI0`3om^h203eI
Z`030?ofkP0mFJ/0ooK^00@0ooK^0`0mFJ/40=@m6@D0ooK^00<000000?ofkP3om^h01`3om^h00`3D
?AT0ooK^0?ofkP090?ofkP<0e3dI>`3om^h00`000000ooK^0?ofkP0G0?ofkP40oooo000I0?ofkP03
0000003om^h0ooK^03T0ooK^00<0?EV[0?ofkP3om^h00P0mFJ/90?ofkP<0?EV[1@3om^h2000000@0
ooK^0P0mFJ/0103D?AT0?EV[03eIZ`3om^h203eIZ`D0ooK^00<0e3dI0?ofkP3D?AT01@3om^h0100m
FJ/0ooK^0?ofkP3D?AT30?ofkP040000000mFJ/0?EV[03eIZ`<0IQ/=00<0000003eIZ`1V6`d0101V
6`d2000000L0PR@@00<00000088T402291001@22910300000080?EV[0`2I:a<00`000000?EV[09T[
4`0609T[4`030000002I:a<0VB/C00<0VB/C0`0000000`3D?AT0[34F0:`a5P050:`a5P040000002/
<AH0[34F03eIZ`@0[34F00D000000:`a5P2/<AH0[34F000000030;`f60030000002l=QP0_3HH00@0
_3HH00<000000;`f602l=QP00P2l=QP00`0mFJ/0_3HH000000060;`f6080000000D0?EV[0<Xj6@3:
>QT0bSXI0000000304iaf@030=@m6@000000000000H0CFoD00<0000004e_e03D?AT0101=Km@00`00
0000CFoD04e_e00404e_e0050000001=Km@0CFoD04e_e00000000`1<KLh00`000000C6g>04a]cP02
04a]cP040=@m6@1<KLh0C6g>000000L0C6g>00@0?EV[00000000000000001@1:JLL00`000000BVW7
04YYa`0504YYa`030=@m6@000000BVW70080BVW70P3D?AT3000000L0AfBl00<0000004MT_017I;`0
1@17I;`2000000D0@ef]00<0e3dI00000013GJd00P13GJd30=@m6@050000003om^h0ooK^0?ofkP0m
FJ/00P3om^h00`3D?AT0ooK^0?ofkP030?ofkP0303eIZ`3om^h0?EV[00D0ooK^0P3D?AT0103om^h0
e3dI0=@m6@0mFJ/20=@m6@@0ooK^0P0000050?ofkP<0e3dI2@3om^h20=@m6@030?ofkP3D?AT0ooK^
03/0ooK^00<000000?ofkP3om^h05`3om^h10?ooo`006@3om^h00`000000ooK^0?ofkP0j0?ofkP04
03eIZ`3om^h0ooK^0?ofkP80?EV[203om^h0100mFJ/0ooK^03eIZ`0mFJ/20?ofkP030000003om^h0
ooK^0080ooK^0P0mFJ/30=@m6@0503eIZ`3om^h0?EV[03eIZ`3om^h00P0mFJ/20?ofkP<0e3dI1@3o
m^h01@0mFJ/0ooK^0?ofkP3om^h0e3dI00<0ooK^00@0000006HK3@1V6`d0IQ/=0P0mFJ/00`1V6`d0
?EV[06HK3@0306HK3@<00000202291000`000000PR@@088T4005088T40030000002I:a<0VB/C0080
VB/C0P0mFJ/00`2I:a<0?EV[09T[4`0709T[4`040000002I:a<0VB/C09T[4`8000000`2/<AH00`00
0000[34F0:`a5P050:`a5P040000002/<AH0?EV[0:`a5P80?EV[0`2/<AH3000000@0_3HH00<00000
0;`f602l=QP0102l=QP00`000000_3HH0;`f60020;`f600403eIZ`2l=QP0_3HH000000D0_3HH00<0
00000<Xj6@3:>QT00P0mFJ/00`3:>QT0000004iaf@020=@m6@80CW7I00<0000004e_e01=Km@00`1=
Km@010000000CFoD04e_e03D?AT304e_e0030000001=Km@0CFoD00D0CFoD00<0000004e_e01=Km@0
0P1=Km@3000000<0C6g>0P3D?AT0101<KLh0e3dI04a]cP00000704a]cP040000001<KLh0C6g>04a]
cP8000000`1:JLL00`000000BVW704YYa`0604YYa`040=@m6@1:JLL0e3dI0=@m6@@0BVW700<00000
04MT_017I;`01@17I;`00`000000AfBl04MT_00604MT_0<000001013GJd0103D?AT0@ef]0=@m6@3D
?AT304=M[@050000003om^h0ooK^0?ofkP0mFJ/00P3om^h00`3D?AT0ooK^0?ofkP040?ofkP80?EV[
0`3om^h20=@m6@050?ofkP3D?AT0e3dI0?ofkP3D?AT00`0mFJ/20=@m6@@0ooK^00<000000?ofkP3o
m^h00P3D?AT00`3om^h0e3dI0?ofkP070?ofkP80e3dI0`3om^h00`3D?AT0ooK^0?ofkP0j0?ofkP03
0000003om^h0ooK^01L0ooK^0@3oool001P0ooK^00<000000?ofkP3om^h0?03om^h00`0mFJ/0ooK^
0?ofkP020?ofkP80?EV[1P3om^h0100mFJ/0ooK^0?ofkP3om^h2000000<0ooK^0P0mFJ/00`3om^h0
e3dI0=@m6@020?ofkP0403eIZ`3D?AT0ooK^0?ofkP80?EV[00@0ooK^03eIZ`0mFJ/0e3dI1`3om^h0
100mFJ/0ooK^0?ofkP3D?AT30?ofkP030=@m6@000000IQ/=00@0IQ/=00<0?EV[0000001V6`d00P1V
6`d01@000000PR@@088T40229100000000L0PR@@00<00000088T402291000`229103000000H0VB/C
00<0?EV[09T[4`000000202I:a<3000000D0[34F00<000000:`a5P2/<AH01P2/<AH00`0mFJ/0[34F
0:`a5P020:`a5P80?EV[00<0[34F0000002l=QP01@2l=QP00`000000_3HH0;`f60050;`f60040000
002l=QP0_3HH03eIZ`<0_3HH00@000000;`f602l=QP0_3HH0`0000040<Xj6@0303eIZ`000000e3dI
00@0CW7I0`00000304e_e0050000001=Km@0CFoD04e_e03D?AT00P1=Km@00`000000CFoD04e_e005
04e_e0030000001=Km@0CFoD00@0CFoD00@0000004a]cP3D?AT0e3dI101<KLh00`3D?AT0C6g>04a]
cP0604a]cP030000001<KLh0C6g>00<0C6g>0`00000804YYa`030000001:JLL0e3dI00H0BVW70`00
000504MT_00300000017I;`0AfBl00D0AfBl00D0000004MT_017I;`0AfBl0000000304=M[@030000
003D?AT0@ef]00@0@ef]00D0000003eIZ`3om^h0ooK^03eIZ`030?ofkP030=@m6@3om^h0ooK^00D0
ooK^00@0?EV[0=@m6@3D?AT0ooK^0P3D?AT20?ofkP0403eIZ`3D?AT0ooK^0?ofkP80?EV[00<0ooK^
0=@m6@3D?AT00`3om^h2000000<0ooK^00<0e3dI0?ofkP3om^h0103om^h20=@m6@@0ooK^00<0e3dI
0?ofkP3om^h0?03om^h00`000000ooK^0?ofkP0F0?ofkP40oooo000H0?ofkP030000003om^h0ooK^
03d0ooK^0P0mFJ/40?ofkP80?EV[103om^h0100mFJ/0ooK^0?ofkP0000020?ofkP<0?EV[0P3om^h0
0`3D?AT0ooK^0?ofkP020=@m6@0303eIZ`3D?AT0ooK^00<0ooK^0P0mFJ/00`3D?AT0?EV[03eIZ`06
0?ofkP0503eIZ`3om^h0ooK^0=@m6@3om^h00P3D?AT00`3om^h0000006HK3@0206HK3@80?EV[00D0
IQ/=03eIZ`0mFJ/0IQ/=00000004088T4003000000229100PR@@00D0PR@@00<00000088T40229100
0P2291001@000000VB/C09T[4`2I:a<0000000@0VB/C00@0?EV[09T[4`0mFJ/0?EV[202I:a<00`00
0000[34F0:`a5P060:`a5P030000002/<AH0[34F00@0[34F00<0?EV[0000002/<AH0102/<AH00`00
0000?EV[03eIZ`060;`f60030000002l=QP0_3HH00D0_3HH00<000000;`f600mFJ/0102l=QP01000
0000_3HH0000000000020<Xj6@030000003:>QT0bSXI00<0bSXI00<0000004iaf@1>LMT00`1>LMT0
0`000000CW7I04iaf@020000000304e_e0000000CFoD00<0CFoD00<0e3dI04e_e00000001`1=Km@0
0`000000CFoD04e_e00404e_e080e3dI00<0000004a]cP1<KLh00`1<KLh00`000000e3dI04a]cP05
04a]cP030000001<KLh0C6g>00H0C6g>00<0000004YYa`1:JLL01P1:JLL20=@m6@0304YYa`3D?AT0
BVW700<0BVW700D0000004YYa`1:JLL0BVW70000000404MT_00300000017I;`0AfBl00D0AfBl00<0
000004MT_017I;`00P17I;`01@000000@ef]0=@m6@3D?AT0@ef]0080e3dI0`13GJd01P000000ooK^
03eIZ`0mFJ/0ooK^03eIZ`80ooK^00<0e3dI0?ofkP3om^h0103om^h20=@m6@0303eIZ`3D?AT0e3dI
00@0ooK^00@0e3dI0?ofkP0mFJ/0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP030=@m6@80ooK^00<00000
0?ofkP3D?AT01@3om^h20=@m6@@0ooK^0P3D?ATo0?ofkP030000003om^h0ooK^01H0ooK^0@3oool0
01P0ooK^00<000000?ofkP3om^h0?P3om^h503eIZ`80ooK^0P0mFJ/30?ofkP800000100mFJ/0103o
m^h0?EV[03eIZ`3D?AT20?ofkP050=@m6@3om^h0ooK^0=@m6@0mFJ/00`3om^h20=@m6@040?ofkP0m
FJ/0?EV[0?ofkP80?EV[103om^h00`0mFJ/0ooK^0?ofkP020=@m6@<0ooK^00@0000006HK3@1V6`d0
?EV[0`1V6`d200000080?EV[102291000`000000PR@@088T4006088T4004000000229100PR@@0000
00@0VB/C00D0000009T[4`2I:a<0VB/C03eIZ`0409T[4`80?EV[102I:a<3000000P0[34F00<00000
0:`a5P2/<AH0102/<AH00`0mFJ/000000:`a5P020:`a5P8000000`2l=QP203eIZ`D0_3HH00<00000
0;`f602l=QP0102l=QP00`000000?EV[0;`f60040;`f60800000103:>QT00`000000bSXI0<Xj6@03
0<Xj6@030000001>LMT0CW7I00<0CW7I00<0000004iaf@1>LMT00P1>LMT2000000D0CFoD00<0e3dI
0000001=Km@01@1=Km@00`000000CFoD04e_e00304e_e080e3dI0`1=Km@2000000<0C6g>00<00000
0=@m6@1<KLh01@1<KLh00`000000C6g>04a]cP0604a]cP<00000101:JLL20=@m6@@0BVW700D0e3dI
04YYa`1:JLL0BVW70000000404YYa`0400000017I;`0AfBl000000P0AfBl00<0000004MT_017I;`0
0P17I;`20=@m6@8000000`13GJd0103D?AT0@ef]04=M[@0000030?ofkP80?EV[0P3om^h00`3D?AT0
ooK^0?ofkP020?ofkP80e3dI00@0ooK^0=@m6@3D?AT0ooK^0P0mFJ/30?ofkP050=@m6@0mFJ/0ooK^
0?ofkP0mFJ/00P3om^h0100mFJ/0e3dI0=@m6@3om^h40=@m6@8000000`3om^h20=@m6@80ooK^1@3D
?AU00?ofkP030000003om^h0ooK^01H0ooK^0@3oool001P0ooK^00<000000?ofkP3om^h0@03om^h2
03eIZ`030?ofkP0mFJ/0?EV[00@0?EV[00<0000003eIZ`3om^h00`3om^h203eIZ`050?ofkP3D?AT0
?EV[03eIZ`3D?AT00P3om^h00`3D?AT0ooK^03eIZ`020?ofkP060=@m6@3om^h0ooK^0?ofkP3D?AT0
ooK^0P0mFJ/00`3om^h0?EV[03eIZ`020?ofkP0403eIZ`3om^h0ooK^0=@m6@@0ooK^00<0000006HK
3@0mFJ/0101V6`d010000000PR@@088T4022910203eIZ`80PR@@00<00000088T402291001P229103
000000D0VB/C00@0000009T[4`2I:a<0?EV[1@2I:a<01P000000VB/C03eIZ`0mFJ/0VB/C000000<0
[34F00<000000:`a5P2/<AH01P2/<AH00`000000[34F0:`a5P020:`a5P0303eIZ`2/<AH0[34F00<0
00001@2l=QP00`000000_3HH03eIZ`040;`f60030000002l=QP0_3HH00@0_3HH00<0000003eIZ`2l
=QP00P2l=QP3000000D0bSXI00<000000<Xj6@3:>QT00`3:>QT00`000000CW7I04iaf@0304iaf@03
0000001>LMT0CW7I00<0CW7I0`00000304e_e0030=@m6@000000CFoD00D0CFoD00<0000004e_e01=
Km@00P1=Km@00`3D?AT0CFoD0000000504e_e0<000000P1<KLh00`3D?AT0C6g>04a]cP0204a]cP03
0000001<KLh0C6g>00H0C6g>00H0000004a]cP1<KLh0C6g>0000001:JLL20=@m6@0304YYa`000000
BVW700@0BVW700@0e3dI04YYa`1:JLL000001@1:JLL3000000L0AfBl00@0000004MT_017I;`0AfBl
0P3D?AT304MT_00300000013GJd0@ef]0080@ef]00<0e3dI0000003om^h0103om^h0100mFJ/0ooK^
0?ofkP3D?AT20?ofkP80e3dI00D0ooK^0=@m6@3D?AT0ooK^03eIZ`030?ofkP0603eIZ`3om^h0ooK^
0=@m6@3om^h0?EV[0P3om^h01@0mFJ/0e3dI0=@m6@0mFJ/0ooK^0080e3dI103om^h00`3D?AT00000
0=@m6@050=@m6@030?ofkP3D?AT0e3dI0480ooK^00<000000?ofkP3om^h05P3om^h10?ooo`00603o
m^h00`000000ooK^0?ofkP120?ofkP80?EV[0P3om^h203eIZ`040000000mFJ/0?EV[03eIZ`D0ooK^
0P0mFJ/0203D?AT0ooK^03eIZ`0mFJ/0ooK^0=@m6@3om^h0?EV[0P3D?AT40?ofkP040=@m6@3om^h0
ooK^0?ofkP80?EV[00@0ooK^03eIZ`0mFJ/0?EV[0`3D?AT40?ofkP80?EV[101V6`d2000000D0PR@@
0P0mFJ/00`2291000000088T4006088T40030000002I:a<0VB/C00H0VB/C00<0000003eIZ`2I:a<0
1@2I:a<01@000000VB/C09T[4`2I:a<0?EV[00@0[34F00<000000:`a5P2/<AH01P2/<AH01@000000
[34F0:`a5P2/<AH0?EV[00<0[34F00<000000;`f602l=QP01@2l=QP00`000000_3HH0;`f600203eI
Z`80_3HH00<000000;`f602l=QP0102l=QP01@0mFJ/000000;`f602l=QP000000080bSXI00<00000
0<Xj6@3:>QT00`3:>QT00`000000bSXI0<Xj6@030<Xj6@030000001>LMT0CW7I00<0CW7I00<00000
04iaf@1>LMT00`1>LMT010000000CW7I04iaf@00000204e_e0030000003D?AT0CFoD00D0CFoD00<0
000004e_e01=Km@00P3D?AT204e_e0030000001=Km@0CFoD00D0CFoD00D0000004a]cP1<KLh0C6g>
0=@m6@0304a]cP030000001<KLh0C6g>00H0C6g>00<0000004a]cP1<KLh00P1<KLh01@3D?AT0BVW7
04YYa`1:JLL0000000H0BVW700<0e3dI0000001:JLL01`1:JLL00`000000AfBl04MT_00504MT_004
00000017I;`0e3dI0=@m6@D0AfBl0P00000404=M[@80e3dI103om^h303eIZ`<0e3dI00<0ooK^0=@m
6@3D?AT00`3om^h00`0mFJ/0ooK^0?ofkP020?ofkP80?EV[00@0e3dI0?ofkP0mFJ/0ooK^0P3D?AT0
103om^h0?EV[0=@m6@3D?AT50?ofkP<0e3dI00<000000=@m6@3D?AT00P3om^h20=@m6D@0ooK^00<0
00000?ofkP3om^h05P3om^h10?ooo`005`3om^h00`000000ooK^0?ofkP150?ofkP80?EV[0P000002
03eIZ`030?ofkP0mFJ/0ooK^00<0ooK^0`3D?AT203eIZ`80ooK^0P0mFJ/00`3om^h0?EV[0?ofkP05
0?ofkP030=@m6@3om^h0ooK^00<0ooK^0P0mFJ/01@3D?AT0?EV[0?ofkP3om^h0e3dI00<0ooK^00<0
?EV[0?ofkP0000000`1V6`d010000000PR@@088T40000006088T400303eIZ`000000PR@@00@0PR@@
0`00000809T[4`0303eIZ`2I:a<0VB/C00H0VB/C0`0000000`2/<AH0?EV[03eIZ`030:`a5P030000
002/<AH0[34F00H0[34F00<000000:`a5P0mFJ/00P2/<AH3000000P0_3HH00@000000;`f602l=QP0
_3HH0P0mFJ/00`2l=QP000000;`f60030;`f600303eIZ`2l=QP00000008000000`3:>QT00`000000
bSXI0<Xj6@030<Xj6@030000003:>QT0bSXI00<0bSXI00<0000004iaf@1>LMT00`1>LMT00`000000
CW7I04iaf@0304iaf@040000001>LMT0CW7I04iaf@<0000000<0CFoD0=@m6@1=Km@00`1=Km@01000
0000CFoD0=@m6@3D?AT304e_e0030000001=Km@0CFoD00H0CFoD0`00000204a]cP030=@m6@1<KLh0
000000P0C6g>00@0000004a]cP1<KLh0C6g>0P3D?AT0101<KLh0000000000000000804YYa`030=@m
6@1:JLL0BVW700D0BVW700@0000004YYa`00000000001@17I;`00`000000e3dI04MT_00504MT_004
00000017I;`0AfBl000000<0@ef]00<000000?ofkP3D?AT00`3om^h01@0mFJ/0ooK^0?ofkP3D?AT0
?EV[0080e3dI1@3om^h00`0mFJ/0ooK^0?ofkP040?ofkP040=@m6@3om^h0e3dI0=@m6@80ooK^0P3D
?AT303eIZ`@0ooK^00@0e3dI0?ofkP3D?AT0e3dI0P0000020=@m6DL0ooK^00<000000?ofkP3om^h0
5@3om^h10?ooo`005`3om^h00`000000ooK^0?ofkP160?ofkP030000000mFJ/0?EV[0080ooK^100m
FJ/00`3om^h0e3dI0=@m6@040?ofkP80?EV[00@0ooK^0=@m6@0mFJ/0?EV[1@3om^h00`3D?AT0ooK^
0?ofkP040?ofkP80e3dI100mFJ/0103D?AT0ooK^0?ofkP0mFJ/20?ofkP040000001V6`d000000000
00<0PR@@00<00000088T402291001@22910203eIZ`80PR@@0P00000309T[4`030000002I:a<0VB/C
00<0VB/C0P0mFJ/00`2I:a<0000009T[4`0609T[4`030000002/<AH0[34F00<0[34F0P0mFJ/00`2/
<AH000000:`a5P070:`a5P050000000mFJ/0[34F0:`a5P0000000`2l=QP00`000000_3HH0;`f6005
0;`f60030000002l=QP0_3HH00<0_3HH0P0mFJ/30;`f600403eIZ`2l=QP0_3HH000000H0bSXI00<0
00000<Xj6@3:>QT00P3:>QT00`000000bSXI0<Xj6@030<Xj6@030000001>LMT0CW7I00<0CW7I00<0
000004iaf@1>LMT00P1>LMT00`000000CW7I04iaf@0404iaf@040000001=Km@0CFoD0=@m6@<0CFoD
0P3D?AT504e_e0030000001=Km@0CFoD00D0CFoD00D0000004e_e01=Km@0CFoD0000000204a]cP03
0=@m6@000000C6g>00L0C6g>00@0000004a]cP3D?AT0e3dI1@1<KLh00`000000BVW704YYa`0504YY
a`040000001:JLL0e3dI0=@m6@D0BVW700@0000004YYa`1:JLL0BVW70P00000204MT_080e3dI1`17
I;`010000000AfBl04MT_017I;`20000000504=M[@000000ooK^0?ofkP3D?AT00P3om^h00`0mFJ/0
e3dI0=@m6@020=@m6@80?EV[1P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP80e3dI00@0?EV[0?ofkP3D
?AT0e3dI103om^h203eIZ`030?ofkP3D?AT0e3dI0080e3dI0P3om^h20=@m6@030000003om^h0ooK^
04H0ooK^00<000000?ofkP3om^h05@3om^h10?ooo`005`3om^h00`000000ooK^0?ofkP140?ofkP80
00000`3om^h203eIZ`80ooK^100mFJ/60?ofkP040=@m6@0mFJ/0?EV[0?ofkP<0?EV[0`3om^h00`3D
?AT0ooK^0?ofkP030?ofkP040=@m6@3om^h0ooK^0?ofkPH0?EV[0`3om^h2000000D0PR@@00<00000
088T402291001P2291000`000000?EV[03eIZ`0509T[4`030000002I:a<0VB/C0080VB/C00D0?EV[
09T[4`2I:a<0VB/C0000000509T[4`80000000<0[34F0000002/<AH01@2/<AH00`0mFJ/0[34F0000
00070:`a5P0403eIZ`0000000000000000@0_3HH00<000000;`f602l=QP01@2l=QP00`000000_3HH
0;`f60040;`f60050000000mFJ/0?EV[0;`f600mFJ/00`0000060<Xj6@030000003:>QT0bSXI00<0
bSXI00<000000<Xj6@3:>QT00P3:>QT00`000000CW7I04iaf@0204iaf@030000001>LMT0CW7I00<0
CW7I00<0000004iaf@1>LMT0101>LMT3000000050=@m6@1=Km@0e3dI0=@m6@0000001P1=Km@00`00
0000CFoD04e_e00504e_e0030000001=Km@0CFoD0080CFoD0`0000000`3D?AT0C6g>04a]cP0504a]
cP030000001<KLh0e3dI00H0C6g>00@0000004a]cP00000000001@1:JLL01@000000BVW704YYa`1:
JLL0e3dI00<0BVW700<0000004YYa`1:JLL0101:JLL20=@m6@0300000017I;`0AfBl00H0AfBl00<0
000004MT_017I;`00`17I;`2000000<0ooK^1P3D?AT30?ofkP0303eIZ`3om^h0ooK^00<0ooK^00@0
?EV[0?ofkP3om^h0ooK^0`3D?AT0103om^h0e3dI0=@m6@0mFJ/60?ofkP@0e3dI0P3om^h20=@m6@<0
ooK^0P0000160?ofkP030000003om^h0ooK^01D0ooK^0@3oool001L0ooK^00<000000?ofkP3om^h0
@`3om^h00`000000ooK^0?ofkP050?ofkP80?EV[00<0ooK^0=@m6@0mFJ/00`0mFJ/30?ofkP040=@m
6@3om^h0ooK^0?ofkP<0?EV[00D0ooK^03eIZ`0mFJ/0ooK^0=@m6@030?ofkP80e3dI1@3om^h303eI
Z`030?ofkP0mFJ/0?EV[0080ooK^00<00000088T40229100102291000`000000PR@@088T4006088T
40030000002I:a<0VB/C0080?EV[102I:a<010000000VB/C09T[4`0mFJ/409T[4`040000002I:a<0
VB/C09T[4`8000000`2/<AH00`000000[34F0:`a5P050:`a5P80?EV[1`2/<AH00`0mFJ/000000;`f
60060;`f60030000002l=QP0_3HH00@0_3HH00<000000;`f602l=QP0102l=QP01@000000_3HH0;`f
600mFJ/000000080bSXI00<000000<Xj6@3:>QT0103:>QT00`000000bSXI0<Xj6@030<Xj6@030000
003:>QT0bSXI0080bSXI00<0000004iaf@1>LMT00P1>LMT00`000000CW7I04iaf@0304iaf@030000
001>LMT0CW7I00@0CW7I00D0000004iaf@1>LMT000000=@m6@0204e_e0030000001=Km@0CFoD00@0
CFoD00<0000004e_e01=Km@0101=Km@00`000000CFoD04e_e00504e_e0030000003D?AT0C6g>00H0
C6g>0P3D?AT704a]cP040000001<KLh0C6g>04a]cP8000000`1:JLL00`000000BVW704YYa`0204YY
a`040=@m6@1:JLL0BVW7000000@0BVW70P3D?AT204YYa`0300000017I;`0AfBl00D0AfBl00<00000
04MT_017I;`01@17I;`00`000000ooK^0?ofkP020=@m6@040?ofkP3D?AT0e3dI0=@m6@D0ooK^0P0m
FJ/30?ofkP0503eIZ`3om^h0e3dI0=@m6@3om^h00`3D?AT30?ofkP0403eIZ`3om^h0ooK^0?ofkP@0
e3dI0P3om^h20=@m6@L0ooK^00<000000?ofkP3om^h0@`3om^h00`000000ooK^0?ofkP0E0?ofkP40
oooo000F0?ofkP030000003om^h0ooK^0480ooK^0P00000:0?ofkP80?EV[00<0ooK^03eIZ`0mFJ/0
0`0mFJ/20=@m6@D0ooK^0P0mFJ/20?ofkP80?EV[00<0ooK^0=@m6@3D?AT01@3om^h303eIZ`050?of
kP3D?AT0?EV[03eIZ`3om^h00P0mFJ/00`000000PR@@088T4005088T4003000000229100PR@@00<0
PR@@0`00000409T[4`80?EV[0P2I:a<00`000000VB/C03eIZ`0609T[4`<000001P2/<AH00`000000
[34F0:`a5P060:`a5P80?EV[102/<AH0100mFJ/000000000003D?AT60;`f60030000002l=QP0_3HH
00D0_3HH00<000000;`f602l=QP0102l=QP00`000000?EV[0000000203eIZ`80bSXI00<000000<Xj
6@3:>QT00`3:>QT00`000000bSXI0<Xj6@030<Xj6@030000003:>QT0bSXI0080bSXI00<0000004ia
f@1>LMT00P1>LMT00`000000CW7I04iaf@0304iaf@030000001>LMT0CW7I00<0CW7I00<0000004ia
f@1>LMT00P3D?AT00`000000e3dI0000000604e_e0030000001=Km@0CFoD00D0CFoD00<0000004e_
e01=Km@0101=Km@203eIZ`030000003D?AT0C6g>00<0C6g>0P3D?AT804a]cP030000001<KLh0C6g>
00@0C6g>0`00000604YYa`030=@m6@000000BVW70080BVW70P3D?AT304YYa`040000001:JLL00000
000000D0AfBl00<0000004MT_017I;`01@17I;`010000000e3dI0=@m6@3om^h20=@m6@0303eIZ`3o
m^h0e3dI0080e3dI1@3om^h203eIZ`030?ofkP3D?AT0e3dI0080ooK^0P3D?AT50?ofkP80?EV[1@3D
?AT00`3om^h0e3dI0=@m6@0:0?ofkP800000A03om^h00`000000ooK^0?ofkP0D0?ofkP40oooo000F
0?ofkP030000003om^h0ooK^0440ooK^00<000000?ofkP3om^h02P3om^h00`3D?AT0ooK^03eIZ`02
03eIZ`030?ofkP0mFJ/0?EV[0080?EV[1P3om^h303eIZ`80e3dI0P0mFJ/40?ofkP80?EV[0P3om^h0
0`0mFJ/0e3dI0?ofkP020?ofkP80?EV[00<0ooK^03eIZ`0mFJ/01P2291000`000000PR@@088T4002
088T40050000002I:a<0VB/C09T[4`0000001@2I:a<203eIZ`0309T[4`0mFJ/0VB/C00H0VB/C00<0
00000:`a5P2/<AH01P2/<AH00`000000[34F0:`a5P060:`a5P060000002/<AH0?EV[03eIZ`000000
?EV[0`2l=QP00`000000_3HH0;`f60040;`f60030000002l=QP0_3HH00D0_3HH00<000000;`f602l
=QP0102l=QP00`0mFJ/0bSXI0<Xj6@020<Xj6@80?EV[00<000000<Xj6@3:>QT00`3:>QT00`000000
bSXI0<Xj6@030<Xj6@030000003:>QT0bSXI0080bSXI00<0000004iaf@1>LMT00P1>LMT00`000000
CW7I04iaf@0304iaf@030000001>LMT0CW7I00<0CW7I00<000000=@m6@3D?AT0101>LMT00`3D?AT0
CFoD04e_e00404e_e0030000001=Km@0CFoD00D0CFoD00<0000004e_e01=Km@0101=Km@01P000000
CFoD04e_e01=Km@0e3dI00000080e3dI00<0C6g>0000001<KLh01`1<KLh00`000000C6g>04a]cP06
04a]cP030000001:JLL0BVW700D0BVW700@0e3dI04YYa`3D?AT0e3dI1@1:JLL01@000000BVW704YY
a`1:JLL0000000@0AfBl00<0000004MT_017I;`01017I;`20=@m6@030?ofkP3D?AT0e3dI00<0ooK^
00@0?EV[0=@m6@3om^h0ooK^0P3D?AT40?ofkP80e3dI0P0mFJ/30=@m6@H0ooK^103D?AT01@3om^h0
e3dI0=@m6@3D?AT0?EV[00d0ooK^00<000000?ofkP3om^h0@@3om^h00`000000ooK^0?ofkP0D0?of
kP40oooo000F0?ofkP030000003om^h0ooK^03l0ooK^0P00000=0?ofkP040=@m6@3om^h0ooK^0?of
kP<0?EV[00<0ooK^03eIZ`0mFJ/00P0mFJ/40?ofkP0303eIZ`3om^h0ooK^0080?EV[0P3om^h403eI
Z`@0ooK^00<0?EV[0=@m6@3om^h0103om^h203eIZ`030=@m6@229100PR@@00@0PR@@00D00000088T
40229100PR@@0000000409T[4`030000002I:a<0VB/C00D0VB/C00<0?EV[0000002I:a<0102I:a<2
000000030:`a5P000000[34F00L0[34F00<000000:`a5P2/<AH01P2/<AH30000000303eIZ`2l=QP0
_3HH0080_3HH00<000000;`f602l=QP01@2l=QP00`000000_3HH0;`f60040;`f60030000002l=QP0
_3HH0080_3HH00<0000003eIZ`0000001P3:>QT203eIZ`@0bSXI00<000000<Xj6@3:>QT00`3:>QT0
0`000000bSXI0<Xj6@020<Xj6@030000001>LMT0CW7I0080CW7I00<0000004iaf@1>LMT00`1>LMT0
0`000000CW7I04iaf@0204iaf@80e3dI1P1>LMT00`000000e3dI0000000404e_e0030000001=Km@0
CFoD00@0CFoD00<0000004e_e01=Km@0101=Km@00`000000CFoD04e_e00304e_e0040=@m6@000000
0000000000P0C6g>00<0000004a]cP1<KLh01P1<KLh010000000C6g>00000000000404YYa`030000
001:JLL0e3dI00H0BVW700<0000004YYa`1:JLL00`1:JLL01@000000AfBl04MT_017I;`0000000H0
AfBl00<0?EV[0=@m6@3D?AT01@3om^h00`0mFJ/0e3dI0?ofkP030?ofkP@0e3dI0P3om^h20=@m6@80
ooK^00<0e3dI0?ofkP3om^h00P3om^h40=@m6@040?ofkP3D?AT0e3dI0=@m6@<0ooK^00<0?EV[0?of
kP3om^h02`3om^h200000440ooK^00<000000?ofkP3om^h0503om^h10?ooo`005P3om^h00`000000
ooK^0?ofkP0n0?ofkP030000003om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0
ooK^0?ofkP0703eIZ`<0ooK^2@0mFJ/50?ofkP0303eIZ`3D?AT0ooK^00@0ooK^0P3D?AT203eIZ`H0
PR@@0`00000609T[4`030000002I:a<0VB/C0080VB/C0P0mFJ/00`2I:a<0?EV[03eIZ`0309T[4`05
0000002/<AH0[34F0:`a5P0000002@2/<AH00`000000[34F0:`a5P050:`a5P040000002l=QP0?EV[
0;`f6080?EV[0`2l=QP00`000000_3HH0;`f60040;`f60030000002l=QP0_3HH00D0_3HH00P00000
0;`f6000000000000<Xj6@0mFJ/0bSXI000000D0bSXI00@000000<Xj6@0mFJ/0?EV[0P3:>QT00`00
0000bSXI0<Xj6@030<Xj6@030000003:>QT0bSXI00D000000P1>LMT00`000000CW7I04iaf@0304ia
f@030000001>LMT0CW7I0080e3dI00<0CW7I0000001>LMT0101>LMT010000000CW7I0=@m6@1>LMT2
0000000304e_e0000000CFoD00H0CFoD00<0000004e_e01=Km@0101=Km@010000000CFoD04e_e01=
Km@20=@m6@0404e_e03D?AT0CFoD000000L0C6g>00<0000004a]cP1<KLh01`1<KLh01@000000C6g>
04a]cP1<KLh0000000<0BVW70P3D?AT00`1:JLL0e3dI0=@m6@0404YYa`030000001:JLL0BVW700@0
BVW70`00000604MT_080e3dI0P0mFJ/50?ofkP0303eIZ`3D?AT0ooK^00@0ooK^2@3D?AT30?ofkPL0
e3dI0P3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00l0ooK^00<000000?ofkP3om^h0?P3om^h00`00
0000ooK^0?ofkP0D0?ofkP40oooo000F0?ofkP030000003om^h0ooK^03d0ooK^00<000000?ofkP3o
m^h03@3om^h00`3D?AT0ooK^0?ofkP020=@m6@@0ooK^00<0e3dI03eIZ`0mFJ/01`0mFJ/00`3om^h0
e3dI0?ofkP020?ofkP80?EV[00<0ooK^03eIZ`0mFJ/00`3om^h00`0mFJ/0e3dI0?ofkP030?ofkP05
0=@m6@3om^h0ooK^0?ofkP0000000P0mFJ/4088T40030000002I:a<0VB/C00H0VB/C00<0000009T[
4`2I:a<00P0mFJ/409T[4`040000000mFJ/0?EV[000000D0[34F00<000000:`a5P2/<AH01P2/<AH0
0`000000[34F0:`a5P030:`a5P80000000<0_3HH03eIZ`2l=QP00`2l=QP203eIZ`030;`f60000000
_3HH00D0_3HH00<000000;`f602l=QP01@2l=QP200000080bSXI00@0?EV[0<Xj6@3:>QT000001@3:
>QT01`000000bSXI0<Xj6@3:>QT0?EV[0<Xj6@0000001@3:>QT300000080echK00<0000004ibg01>
L]`00`00000504iaf@030000001>LMT0e3dI0080CW7I00<0000004iaf@1>LMT0101>LMT010000000
CW7I04iaf@3D?AT204iaf@8000001`1=Km@00`000000CFoD04e_e00304e_e0030000001=Km@0CFoD
0080e3dI101=Km@0103D?AT0CFoD00000000000504a]cP030000001<KLh0C6g>00H0C6g>00<00000
04a]cP1<KLh00`1<KLh00`000000e3dI0=@m6@0504YYa`80e3dI00<0BVW70000001:JLL0201:JLL0
0`000000AfBl04MT_00204MT_080e3dI00D000000?ofkP3om^h0ooK^03eIZ`040?ofkP0303eIZ`3D
?AT0ooK^0080ooK^0P3D?AT00`3om^h0e3dI0=@m6@030?ofkP0303eIZ`3om^h0e3dI00P0e3dI00<0
?EV[0?ofkP3om^h00P3om^h203eIZ`80ooK^00<0?EV[0?ofkP3om^h03@3om^h00`000000ooK^0?of
kP0m0?ofkP030000003om^h0ooK^01@0ooK^0@3oool001D0ooK^00<000000?ofkP3om^h0?03om^h2
000000l0ooK^00@0e3dI0?ofkP3om^h0e3dI1P3om^h00`3D?AT0ooK^0?ofkP0203eIZ`030?ofkP0m
FJ/0?EV[00<0?EV[00<0e3dI0?ofkP3om^h00`3om^h203eIZ`030?ofkP0mFJ/0?EV[0080ooK^00<0
?EV[0?ofkP3om^h00P3D?AT40?ofkP03000000229100PR@@0080?EV[0P0000000`2I:a<0000009T[
4`0709T[4`030000000mFJ/0VB/C00H0VB/C00@000000:`a5P0mFJ/0?EV[1@2/<AH00`000000[34F
0:`a5P060:`a5P060000002/<AH0[34F0:`a5P000000_3HH0P0mFJ/00`000000_3HH0;`f60040;`f
6080?EV[00<000000;`f602l=QP0102l=QP00`000000_3HH0;`f60020;`f60<000000P3:>QT01@0m
FJ/0bSXI0<Xj6@3:>QT0000000H0bSXI00@000000<Xj6@3:>QT0bSXI0P0mFJ/00`000000bSXI0<Xj
6@020<Xj6@070000003G?Q/0echK0=Ln6`0mFJ/000000=@m6@0304ibg0030000001>LMT0CW7I0080
CW7I00<000000=@m6@3D?AT00`1>LMT00`000000CW7I04iaf@0404iaf@050000001>LMT0CW7I04ia
f@3D?AT00P1>LMT3000000@0CFoD00<0000004e_e01=Km@0101=Km@00`000000e3dI0=@m6@0604e_
e0050000003D?AT0e3dI04e_e00000000`1<KLh00`000000C6g>04a]cP0604a]cP030000001<KLh0
C6g>00<0C6g>0P3D?AT00`1<KLh0000004YYa`0604YYa`030=@m6@000000BVW700L0BVW700@00000
04YYa`00000000000P3D?AT204MT_0030000003om^h0ooK^0080ooK^0P0mFJ/20?ofkP030=@m6@3o
m^h0ooK^0080e3dI00<0ooK^0=@m6@3D?AT01@3om^h00`0mFJ/0e3dI0=@m6@030=@m6@030?ofkP3D
?AT0e3dI0080ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^03eIZ`0@0?ofkP800000?P3o
m^h00`000000ooK^0?ofkP0C0?ofkP40oooo000E0?ofkP030000003om^h0ooK^03/0ooK^00<00000
0?ofkP3om^h03`3om^h00`3D?AT0ooK^0=@m6@070?ofkP030=@m6@3om^h0ooK^0080ooK^0P0mFJ/0
1@3om^h0?EV[03eIZ`0mFJ/0e3dI00L0ooK^0P0mFJ/0103om^h0?EV[03eIZ`0mFJ/20=@m6@H0ooK^
00D00000088T40229100PR@@0000000203eIZ`0309T[4`000000VB/C00H0VB/C0P0mFJ/609T[4`80
000000@0[34F0000002/<AH0[34F0P0mFJ/30:`a5P030000002/<AH0[34F00H0[34F00H000000:`a
5P00000000000;`f600mFJ/30;`f60030000002l=QP0_3HH00D0_3HH0P0mFJ/50;`f60050000002l
=QP0_3HH0;`f600000000`3:>QT00`000000?EV[0<Xj6@040<Xj6@030000003:>QT0bSXI00<0bSXI
00<000000<Xj6@3:>QT00`3:>QT203eIZ`040<Xj6@000000000000000080echK00D0?EV[0=Ln6`00
0000CW;L0=@m6@0204ibg0<0000000<0CW7I0=@m6@3D?AT01@1>LMT00`000000CW7I04iaf@0304ia
f@030000001>LMT0CW7I00<0CW7I00<0e3dI0000001>LMT00P1>LMT01@000000CFoD04e_e01=Km@0
000000D0CFoD0P3D?AT704e_e0060000001=Km@0CFoD04e_e03D?AT0CFoD0P0000000`1<KLh00000
04a]cP0604a]cP030000001<KLh0C6g>0080C6g>0P3D?AT204a]cP040000001<KLh00000000000D0
BVW700<000000=@m6@3D?AT01`1:JLL01@000000BVW70=@m6@3D?AT0000000<0AfBl00<000000?of
kP3om^h0103om^h203eIZ`<0e3dI00<0ooK^0=@m6@3D?AT01`3om^h01@0mFJ/0e3dI0=@m6@3D?AT0
ooK^0080e3dI103om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0?EV[0140ooK^00<00000
0?ofkP3om^h0>`3om^h00`000000ooK^0?ofkP0C0?ofkP40oooo000E0?ofkP030000003om^h0ooK^
03T0ooK^0P00000A0?ofkP<0e3dI203om^h0103D?AT0ooK^0?ofkP3om^h20=@m6@040?ofkP0mFJ/0
?EV[0?ofkP<0?EV[203om^h203eIZ`030?ofkP0mFJ/0?EV[00P0ooK^0`00000309T[4`80?EV[00<0
000009T[4`2I:a<00P2I:a<203eIZ`80VB/C00@0000009T[4`2I:a<0VB/C0P0000030:`a5P030000
002/<AH0[34F0080[34F0P0mFJ/20:`a5P030000002/<AH0[34F00H0[34F00@000000;`f602l=QP0
?EV[1@2l=QP00`000000_3HH0;`f60050;`f60030000000mFJ/0_3HH00@0_3HH0`0000040<Xj6@03
03eIZ`3:>QT0bSXI00@0bSXI00<000000<Xj6@3:>QT00`3:>QT00`000000bSXI0<Xj6@030<Xj6@80
00000P0mFJ/0103G?Q/000000=Ln6`0mFJ/20=Ln6`030000001>L]`0e3dI0080CW;L00@0000004ib
g03D?AT0e3dI0P00000504iaf@030000001>LMT0CW7I00<0CW7I00<0000004iaf@1>LMT0101>LMT0
0`3D?AT0CW7I04iaf@0204iaf@<000001@1=Km@00`3D?AT0000004e_e00604e_e0030000001=Km@0
CFoD00<0CFoD00@0e3dI04e_e01=Km@00000201<KLh00`000000C6g>04a]cP020=@m6@@0C6g>00@0
000004a]cP1<KLh0C6g>0P00000304YYa`030000001:JLL0BVW70080e3dI101:JLL00`000000e3dI
0=@m6@0304YYa`<00000203om^h20=@m6@030?ofkP3D?AT0e3dI00P0ooK^0`3D?AT0103om^h0e3dI
0=@m6@3om^h203eIZ`<0ooK^00<0?EV[0?ofkP3om^h01P3om^h203eIZa80ooK^0P00000k0?ofkP03
0000003om^h0ooK^01<0ooK^0@3oool001D0ooK^00<000000?ofkP3om^h0>03om^h00`000000ooK^
0?ofkP0A0?ofkP030=@m6@3om^h0ooK^00L0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@050?ofkP80
?EV[00@0e3dI03eIZ`0mFJ/0?EV[1`3om^h0103D?AT0?EV[03eIZ`3om^h203eIZ`H0ooK^00<00000
09T[4`2I:a<01@2I:a<203eIZ`0309T[4`0mFJ/0?EV[00@0VB/C00@0000009T[4`00000000001P2/
<AH00`000000[34F0:`a5P030:`a5P80?EV[00<0[34F0000002/<AH0102/<AH2000000030;`f6000
0000?EV[00H0_3HH00<000000;`f602l=QP01@2l=QP010000000_3HH03eIZ`0mFJ/30;`f60030000
003:>QT0bSXI00<0bSXI00<0?EV[0<Xj6@0000001@3:>QT00`000000bSXI0<Xj6@030<Xj6@030000
003:>QT0bSXI00<0bSXI00@000000=Ln6`3G?Q/0echK0P0mFJ/01@3G?Q/0?EV[0=Ln6`3G?Q/00000
0080CW;L00@0e3dI04ibg03D?AT0e3dI0`1>L]`00`000000CW7I04iaf@0304iaf@030000001>LMT0
CW7I00<0CW7I00<0000004iaf@1>LMT00`1>LMT00`000000CW7I0=@m6@0504iaf@040000001=Km@0
CFoD04e_e080e3dI00<0000004e_e01=Km@01P1=Km@00`000000CFoD04e_e00404e_e0030=@m6@00
0000CFoD008000001@1<KLh010000000C6g>0=@m6@3D?AT504a]cP030000001<KLh0C6g>00@0C6g>
0`00000504YYa`80e3dI00<0BVW70=@m6@3D?AT01`1:JLL00`000000ooK^0?ofkP040?ofkPD0e3dI
00<0?EV[0?ofkP3om^h01@3om^h30=@m6@0303eIZ`3D?AT0e3dI00D0ooK^00@0?EV[0?ofkP3om^h0
?EV[2P3om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP030000003om^h0ooK^03P0ooK^00<000000?ofkP3o
m^h04`3om^h10?ooo`00503om^h00`000000ooK^0?ofkP0g0?ofkP800000503om^h00`3D?AT0ooK^
0?ofkP070?ofkP040=@m6@3om^h0ooK^0=@m6@P0ooK^1P0mFJ/40?ofkP040=@m6@3om^h0ooK^0=@m
6@80?EV[00<0ooK^03eIZ`0mFJ/01@3om^h00`000000VB/C09T[4`0509T[4`80?EV[1`2I:a<00`00
0000[34F0:`a5P070:`a5P030000002/<AH0[34F00@0[34F0P0mFJ/01@000000[34F0:`a5P2/<AH0
000000<0_3HH00<0?EV[0;`f602l=QP01P2l=QP00`000000_3HH0;`f60050;`f60030000002l=QP0
_3HH0080?EV[00<000000<Xj6@000000103:>QT00`0mFJ/0bSXI000000060<Xj6@030000003:>QT0
bSXI00<0bSXI00<000000<Xj6@3:>QT00`0000040=Ln6`030000000mFJ/0echK0080echK00H00000
04ibg01>L]`0CW;L0=@m6@00000404ibg0<000000P1>LMT00`000000CW7I04iaf@0304iaf@030000
001>LMT0CW7I00@0CW7I00<0000004iaf@3D?AT0101>LMT00`000000CW7I000000020=@m6@80CFoD
00<0000004e_e01=Km@01@1=Km@00`000000CFoD04e_e00604e_e0050=@m6@1=Km@0CFoD04e_e000
00000`1<KLh00`000000e3dI0=@m6@0604a]cP030000001<KLh0C6g>00L0C6g>00<0000004YYa`1:
JLL01@1:JLL20=@m6@L0BVW700<000000?ofkP3om^h00`3om^h20=@m6@040?ofkP3D?AT0e3dI03eI
Z`80ooK^00<0?EV[0?ofkP3om^h00P3om^h60=@m6@P0ooK^00@0?EV[0?ofkP3om^h0?EV[2@3om^h0
0`0mFJ/0ooK^0?ofkP0B0?ofkP800000>03om^h00`000000ooK^0?ofkP0C0?ofkP40oooo000D0?of
kP030000003om^h0ooK^03H0ooK^00<000000?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP080?of
kP<0e3dI2@3om^h00`3D?AT0ooK^03eIZ`0503eIZ`80e3dI103om^h01@0mFJ/0ooK^03eIZ`0mFJ/0
ooK^0080?EV[0`3om^h00`000000VB/C09T[4`0209T[4`<0?EV[00@0VB/C0000000mFJ/0?EV[0`2I
:a<2000000030:`a5P000000[34F00L0[34F00<000000:`a5P2/<AH01P2/<AH203eIZ`8000000P2l
=QP203eIZ`030;`f60000000_3HH00H0_3HH00<000000;`f602l=QP01@2l=QP01@000000_3HH0000
00000000bSXI0080?EV[00D000000<Xj6@3:>QT0bSXI03eIZ`020<Xj6@030000003:>QT0bSXI00@0
bSXI00<000000<Xj6@3:>QT00`3:>QT300000080echK00<000000=Ln6`3G?Q/00P3G?Q/01`0mFJ/0
echK03eIZ`0mFJ/0echK0000001>L]`00P3D?AT00`1>L]`0e3dI04ibg00304ibg0030000001>L]`0
CW;L00<000001@1>LMT00`000000CW7I04iaf@0304iaf@050000001>LMT0CW7I04iaf@3D?AT00`1>
LMT010000000e3dI0=@m6@1>LMT3000000P0CFoD00<0000004e_e01=Km@01@1=Km@010000000CFoD
0=@m6@3D?AT204e_e08000000P3D?AT704a]cP030000001<KLh0C6g>00L0C6g>00@0000004a]cP00
000000000`1:JLL20=@m6@030000001:JLL0e3dI0080e3dI101:JLL010000000ooK^0?ofkP3om^h2
0=@m6@050?ofkP3D?AT0e3dI0=@m6@0mFJ/0103om^h203eIZ`H0e3dI00<0ooK^03eIZ`3om^h0203o
m^h303eIZ`X0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`000000ooK^0?ofkP0f0?ofkP030000003o
m^h0ooK^0180ooK^0@3oool001@0ooK^00<000000?ofkP3om^h0=@3om^h00`000000ooK^0?ofkP0D
0?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h02@3om^h0103D?AT0ooK^0?ofkP3o
m^h603eIZ`@0ooK^00@0e3dI03eIZ`3om^h0ooK^0P0mFJ/00`3om^h0?EV[03eIZ`020?ofkP060000
002I:a<0?EV[03eIZ`2I:a<0?EV[0`2I:a<01@000000VB/C03eIZ`0mFJ/0000000@0[34F00<00000
0:`a5P2/<AH01P2/<AH00`000000[34F0:`a5P060:`a5P050000000mFJ/0?EV[0;`f600mFJ/0102l
=QP00`000000_3HH0;`f60050;`f60030000002l=QP0_3HH00D0_3HH00<000000<Xj6@3:>QT00`3:
>QT203eIZ`030<Xj6@0mFJ/0bSXI00<0bSXI00<000000<Xj6@3:>QT00`3:>QT00`000000bSXI0<Xj
6@020<Xj6@800000103G?Q/01P000000echK0=Ln6`3G?Q/0?EV[000000<0echK00<0?EV[0000003D
?AT00`1>L]`00`000000e3dI04ibg00204ibg0030000001>L]`0CW;L0080CW;L0P00000404iaf@03
0000001>LMT0CW7I00<0CW7I00<0000004iaf@1>LMT00P1>LMT0103D?AT0CW7I0=@m6@3D?AT504ia
f@030000001=Km@0CFoD00D0CFoD00<0000004e_e01=Km@01@1=Km@00`000000CFoD04e_e00204e_
e0050=@m6@1=Km@0e3dI0=@m6@000000201<KLh00`000000C6g>04a]cP0604a]cP030000001<KLh0
C6g>0080C6g>00D000000=@m6@3D?AT0BVW70000000304YYa`060=@m6@1:JLL0e3dI0=@m6@1:JLL0
00000P3om^h20=@m6@030?ofkP3D?AT0e3dI0080ooK^00<0e3dI03eIZ`3om^h00`3om^h60=@m6@<0
ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^01@0
ooK^00<000000?ofkP3om^h0=@3om^h00`000000ooK^0?ofkP0B0?ofkP40oooo000D0?ofkP030000
003om^h0ooK^03<0ooK^0P00000G0?ofkP030=@m6@3om^h0ooK^00H0ooK^0`3D?AT;0?ofkP030=@m
6@3om^h0ooK^00<0ooK^1P0mFJ/20?ofkP030=@m6@0mFJ/0ooK^00<0ooK^0P0mFJ/00`3om^h0?EV[
03eIZ`0203eIZ`L0VB/C00@0000009T[4`00000000000P0mFJ/30:`a5P030000002/<AH0[34F00L0
[34F00<000000:`a5P2/<AH00`2/<AH2000000040;`f60000000_3HH03eIZ`D0_3HH00<000000;`f
602l=QP01P2l=QP00`000000_3HH0;`f60020;`f6080000000<0bSXI0000003:>QT0103:>QT00`00
0000?EV[0<Xj6@040<Xj6@030000003:>QT0bSXI00@0bSXI00H000000<Xj6@00000000000=Ln6`00
00050=Ln6`050000003G?Q/0?EV[0=Ln6`000000103G?Q/01@000000CW;L04ibg01>L]`000000080
CW;L00<0e3dI04ibg00000001@1>L]`01P000000CW;L000000000000CW7I000000H0CW7I00<00000
04iaf@1>LMT00`1>LMT00`3D?AT0000004iaf@0404iaf@040000001>LMT00000000000@0CFoD00<0
000004e_e01=Km@01P1=Km@00`000000CFoD04e_e00304e_e0040=@m6@1=Km@0000004e_e0800000
1@1<KLh00`000000C6g>04a]cP0704a]cP040000001<KLh0C6g>04a]cP80e3dI0P0000000`1:JLL0
000004YYa`0604YYa`@0e3dI00<0ooK^0=@m6@3D?AT00`3om^h00`3D?AT0ooK^03eIZ`020?ofkPH0
e3dI1@3om^h00`0mFJ/0ooK^0?ofkP090?ofkP<0?EV[203om^h00`0mFJ/0ooK^0?ofkP0E0?ofkP80
0000=@3om^h00`000000ooK^0?ofkP0B0?ofkP40oooo000D0?ofkP030000003om^h0ooK^0380ooK^
00<000000?ofkP3om^h05`3om^h00`3D?AT0ooK^0?ofkP040?ofkP80e3dI0P3om^h00`3D?AT0ooK^
0?ofkP090?ofkP040=@m6@3om^h0ooK^0?ofkP80e3dI0P3om^h603eIZ`040=@m6@3om^h0?EV[0?of
kPH0?EV[00<0ooK^03eIZ`0mFJ/0202I:a<00`000000[34F0:`a5P020:`a5P80?EV[0P2/<AH00`00
0000[34F0:`a5P070:`a5P050000002/<AH0[34F0:`a5P0000000`2l=QP203eIZ`030;`f600mFJ/0
?EV[00@0_3HH00<000000;`f602l=QP01@2l=QP00`000000_3HH0;`f6002000000<0bSXI00<00000
0<Xj6@3:>QT00`3:>QT0100mFJ/0000003eIZ`0mFJ/40<Xj6@030000003:>QT0bSXI00<0bSXI0P00
00030=Ln6`030000003G?Q/0echK00<0echK00<0000003eIZ`3G?Q/00P3G?Q/01@000000echK0=Ln
6`3G?Q/0000000<0CW;L00H0000004ibg01>L]`0CW;L0=@m6@00000404ibg0030000001>L]`0CW;L
0080CW;L0P00000504iaf@030000001>LMT0CW7I0080CW7I0P3D?AT00`000000e3dI04iaf@0404ia
f@040000001>LMT0CW7I04iaf@8000000P1=Km@00`000000CFoD04e_e00504e_e0030000001=Km@0
CFoD0080CFoD0P3D?AT00`1=Km@0e3dI0=@m6@0304e_e0050000001<KLh0C6g>04a]cP0000002@1<
KLh00`000000C6g>04a]cP020=@m6@@0C6g>00<0000004YYa`1:JLL01P1:JLL20=@m6@030?ofkP3D
?AT0e3dI00@0e3dI00@0ooK^0=@m6@3om^h0?EV[1P3D?AT20?ofkP80?EV[0`3om^h00`0mFJ/0ooK^
0?ofkP090?ofkP0303eIZ`3om^h0ooK^0080?EV[1P3om^h00`0mFJ/0ooK^0?ofkP0G0?ofkP030000
003om^h0ooK^0380ooK^00<000000?ofkP3om^h04P3om^h10?ooo`004`3om^h00`000000ooK^0?of
kP0a0?ofkP8000006@3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^0080ooK^00<0
e3dI0?ofkP3om^h02@3om^h0103D?AT0ooK^0?ofkP3D?AT60?ofkPP0?EV[1@3om^h203eIZ`030?of
kP000000?EV[00D0VB/C0P0000000`2/<AH000000:`a5P040:`a5P80?EV[00<0[34F0000002/<AH0
1`2/<AH010000000[34F0000000000020;`f6080?EV[00<0_3HH0000002l=QP00P2l=QP203eIZ`80
_3HH00<000000;`f602l=QP01P2l=QP2000000H0bSXI00L000000<Xj6@3:>QT0bSXI03eIZ`3:>QT0
00000080bSXI0P0mFJ/20<Xj6@040000003:>QT0bSXI0<Xj6@<000001@3G?Q/00`000000echK0=Ln
6`020=Ln6`0303eIZ`3G?Q/0echK0080echK00D000000=Ln6`3G?Q/0echK0000000304ibg0030000
001>L]`0CW;L0080CW;L00<0e3dI04ibg01>L]`00P1>L]`00`000000CW;L04ibg00304ibg0<00000
0`1>LMT00`000000CW7I04iaf@020=@m6@80CW7I00<0000004iaf@3D?AT00`1>LMT00`000000CW7I
04iaf@0404iaf@800000201=Km@00`000000CFoD04e_e0020=@m6@<0CFoD00@0000004e_e03D?AT0
e3dI0P1=Km@20000000304a]cP000000C6g>00L0C6g>00@0000004a]cP3D?AT0e3dI1@1<KLh01000
0000C6g>00000000000504YYa`030=@m6@000000ooK^0080e3dI1@3om^h80=@m6@H0ooK^00@0?EV[
0?ofkP3om^h0?EV[2`3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0
?EV[0?ofkP3om^h05`3om^h2000003<0ooK^00<000000?ofkP3om^h04@3om^h10?ooo`004`3om^h0
0`000000ooK^0?ofkP0`0?ofkP030000003om^h0ooK^01T0ooK^00<0e3dI0?ofkP3om^h00P3om^h2
0=@m6@D0ooK^00<0e3dI0?ofkP3om^h02@3om^h30=@m6@T0ooK^1P0mFJ/70?ofkP80?EV[00@0e3dI
09T[4`2I:a<0VB/C0P0000040:`a5P030000002/<AH0[34F00@0[34F0P0mFJ/00`000000[34F0:`a
5P060:`a5P050000002l=QP0_3HH0;`f600mFJ/0102l=QP00`000000_3HH0;`f60020;`f6080?EV[
00<0_3HH0000002l=QP0102l=QP2000000030<Xj6@000000bSXI00D0bSXI00@0e3dI0000000mFJ/0
?EV[0`3:>QT01@000000bSXI0<Xj6@3:>QT0?EV[0080bSXI0`0000030=Ln6`030000003G?Q/0echK
0080echK00H000000=Ln6`3G?Q/0echK03eIZ`0000040=Ln6`050000003G?Q/0echK0=Ln6`000000
0`1>L]`00`000000CW;L04ibg00204ibg0030000003D?AT0CW;L0080CW;L00<0000004ibg01>L]`0
0P1>L]`010000000CW;L04ibg01>L]`300000080CW7I00D0e3dI04iaf@1>LMT0CW7I0000000304ia
f@80e3dI00<0000003eIZ`1>LMT01@1>LMT010000000CW7I00000000000504e_e0040000001=Km@0
e3dI0=@m6@@0CFoD00<0000004e_e01=Km@00P1=Km@01@3D?AT0CFoD04e_e01=Km@0000000P0C6g>
00<000000=@m6@3D?AT01P1<KLh00`000000C6g>04a]cP0204a]cP8000000`1:JLL00`0mFJ/0e3dI
0=@m6@070?ofkPH0e3dI2@3om^h303eIZ`/0ooK^00<0?EV[0?ofkP3om^h00`3om^h203eIZ`@0ooK^
00<0?EV[0?ofkP3om^h06@3om^h00`000000ooK^0?ofkP0`0?ofkP030000003om^h0ooK^0140ooK^
0@3oool001<0ooK^00<000000?ofkP3om^h0;P3om^h2000001`0ooK^00D0e3dI0?ofkP3om^h0ooK^
0=@m6@070?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`0mFJ/0e3dI
03eIZ`0303eIZ`@0ooK^0P3D?AT00`3om^h0?EV[03eIZ`02000000L0[34F00<000000:`a5P2/<AH0
1@2/<AH203eIZ`D0[34F0P000000102l=QP0000003eIZ`0mFJ/60;`f60030000002l=QP0_3HH00<0
_3HH0P0mFJ/01@000000_3HH0;`f602l=QP0000000<0bSXI00<000000<Xj6@3:>QT01@3:>QT00`0m
FJ/0bSXI0<Xj6@030<Xj6@030000003:>QT0bSXI0080bSXI0P0mFJ/00`000000echK0=Ln6`030=Ln
6`030000003G?Q/0echK0080echK00H000000=Ln6`3G?Q/0echK03eIZ`0000040=Ln6`050000003G
?Q/0echK0=Ln6`0000000`1>L]`00`000000CW;L04ibg00204ibg0030000003D?AT0CW;L0080CW;L
00<0000004ibg01>L]`00P1>L]`00`000000CW;L04ibg00304ibg0030000003D?AT0e3dI00@0CW7I
00<0000004iaf@1>LMT00`1>LMT00`3D?AT0CW7I04iaf@0504iaf@050000001>LMT0CW7I04iaf@00
00000`1=Km@00`000000e3dI0=@m6@0504e_e0030000001=Km@0CFoD00@0CFoD0P3D?AT010000000
CFoD00000000000504a]cP80e3dI1`1<KLh00`000000C6g>04a]cP0504a]cP8000000P3D?AT00`3o
m^h0?EV[03eIZ`040?ofkP@0e3dI00<0?EV[0=@m6@3om^h0303om^h00`0mFJ/0ooK^0?ofkP090?of
kP0303eIZ`3om^h0ooK^00D0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0L0?ofkP800000<03om^h0
0`000000ooK^0?ofkP0A0?ofkP40oooo000C0?ofkP030000003om^h0ooK^02d0ooK^00<000000?of
kP3om^h0703om^h0103D?AT0ooK^0=@m6@3D?AT80?ofkP030=@m6@3om^h0ooK^00L0ooK^0`3D?AT>
0?ofkP80?EV[00<0ooK^03eIZ`0mFJ/00P0mFJ/20=@m6@@0ooK^00<0000003eIZ`0mFJ/0202/<AH0
0`000000[34F0:`a5P050:`a5P030000000mFJ/0?EV[0080[34F00<000000;`f602l=QP00P0mFJ/0
0`000000_3HH0;`f60060;`f60030000002l=QP0_3HH00@0_3HH00@0?EV[0;`f6000000000001@3:
>QT00`000000bSXI0<Xj6@030<Xj6@0303eIZ`3:>QT0000000D0bSXI00@000000<Xj6@3:>QT0bSXI
0P00000203eIZ`D0echK00D000000=Ln6`3G?Q/0echK000000020=Ln6`0303eIZ`3G?Q/0000000@0
echK00D000000=Ln6`3G?Q/0echK0000000304ibg0030000001>L]`0CW;L0080CW;L00D0000004ib
g03D?AT0CW;L0000000404ibg0030000001>L]`0CW;L00<0CW;L0P3D?AT2000000<0CW7I00<00000
04iaf@1>LMT00`1>LMT00`000000CW7I0=@m6@0504iaf@030000001>LMT0CW7I00<0CW7I0P000000
0`1=Km@0e3dI04e_e00504e_e0030000001=Km@0CFoD00H0CFoD00<000000=@m6@3D?AT00P1=Km@0
0`000000C6g>04a]cP020=@m6@030000001<KLh0C6g>00D0C6g>00<0000004a]cP1<KLh01P1<KLh2
0=@m6@030000003om^h0ooK^0080ooK^0P0mFJ/40=@m6@030?ofkP3D?AT0e3dI00h0ooK^0`0mFJ/9
0?ofkP0303eIZ`3om^h0ooK^00H0ooK^0P0mFJ/00`3om^h0?EV[0?ofkP0M0?ofkP030000003om^h0
ooK^02d0ooK^00<000000?ofkP3om^h04@3om^h10?ooo`004`3om^h00`000000ooK^0?ofkP0/0?of
kP030000003om^h0ooK^01`0ooK^0`3D?AT90?ofkP030=@m6@3om^h0ooK^00H0ooK^0P3D?AT20?of
kP030=@m6@3om^h0ooK^00`0ooK^00D0e3dI0?ofkP0mFJ/0?EV[0?ofkP0403eIZ`D0ooK^00@00000
0:`a5P0mFJ/0?EV[1P2/<AH00`000000[34F0:`a5P060:`a5P050000002/<AH0?EV[03eIZ`2l=QP0
0P0mFJ/30;`f60030000002l=QP0_3HH00H0_3HH00<000000;`f602l=QP0102l=QP203eIZ`L0bSXI
00D000000<Xj6@3:>QT0bSXI03eIZ`020<Xj6@030000003:>QT0bSXI00<0bSXI00@000000<Xj6@00
000000000`3G?Q/00`000000?EV[03eIZ`030=Ln6`030000003G?Q/0echK0080echK00<0000003eI
Z`3G?Q/00P3G?Q/01P000000echK0=Ln6`3G?Q/000000=Ln6`D0000000<0CW;L0000001>L]`00P1>
L]`01P000000CW;L04ibg01>L]`0e3dI000000@0CW;L00@0000004ibg01>L]`0CW;L0P3D?AT01000
0000CW;L04ibg01>L]`20000000304iaf@000000CW7I00@0CW7I00@0000004iaf@1>LMT0e3dI0`1>
LMT00`000000CW7I04iaf@0504iaf@80e3dI1P1=Km@00`000000CFoD04e_e00604e_e0040000001=
Km@0CFoD04e_e080e3dI00D0CFoD0=@m6@3D?AT0C6g>0000000804a]cP030000001<KLh0C6g>00@0
C6g>0P3D?AT00`1<KLh000000?ofkP040?ofkP@0e3dI00D0ooK^0=@m6@3D?AT0ooK^03eIZ`0>0?of
kP0303eIZ`3om^h0ooK^0080?EV[203om^h00`0mFJ/0ooK^0?ofkP070?ofkP<0?EV[7P3om^h00`00
0000ooK^0?ofkP0/0?ofkP030000003om^h0ooK^0140ooK^0@3oool00180ooK^00<000000?ofkP3o
m^h0:`3om^h2000001l0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP050?ofkP03
0=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP0403eIZ`03
0?ofkP0mFJ/0?EV[00@0ooK^00<000000:`a5P0mFJ/00P0mFJ/50:`a5P030000002/<AH0[34F00H0
[34F00@000000;`f600mFJ/0?EV[1P2l=QP00`000000_3HH0;`f60050;`f60030000002l=QP0_3HH
0080_3HH0P000000103:>QT0000003eIZ`0mFJ/60<Xj6@030000003:>QT0?EV[00@0bSXI00<00000
0<Xj6@3:>QT00`3:>QT00`000000echK0=Ln6`030=Ln6`040000003G?Q/0echK03eIZ`80echK00<0
00000=Ln6`3G?Q/00P3G?Q/00`0mFJ/0echK0=Ln6`020=Ln6`040000003G?Q/0echK0=Ln6`800000
0P3T@Q`00`000000CW;N04ibgP02000000<0CW;L00<0000004ibg01>L]`00P1>L]`00`3D?AT0CW;L
04ibg00204ibg0060000001>L]`0CW;L0=@m6@1>L]`000001P1>L]`00`000000CW7I04iaf@0304ia
f@030000001>LMT0CW7I0080CW7I00<0e3dI04iaf@0000001P1>LMT20=@m6@040000001>LMT00000
000000@0CFoD00<0000004e_e01=Km@01@1=Km@00`000000CFoD04e_e00404e_e080e3dI00<0CFoD
0000001<KLh01`1<KLh00`000000C6g>04a]cP0304a]cP<0e3dI00<0C6g>0000003om^h00`3om^h2
0=@m6@030?ofkP3D?AT0e3dI0080e3dI0P3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0
ooK^00<0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0
ooK^01d0ooK^0P00000]0?ofkP030000003om^h0ooK^0100ooK^0@3oool00180ooK^00<000000?of
kP3om^h0:P3om^h00`000000ooK^0?ofkP0O0?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?of
kP3om^h00`3om^h20=@m6@H0ooK^00<0e3dI0?ofkP3om^h0303om^h30=@m6@80ooK^100mFJ/00`3o
m^h0?EV[03eIZ`030?ofkP040000002/<AH0[34F0:`a5P80?EV[102/<AH00`000000[34F0:`a5P03
0:`a5P040000000mFJ/0?EV[03eIZ`80_3HH0P0mFJ/40;`f60030000002l=QP0_3HH00H0_3HH00@0
00000;`f600000000000103:>QT010000000bSXI03eIZ`0mFJ/40<Xj6@80?EV[1P3:>QT01`000000
bSXI0<Xj6@3:>QT000000=Ln6`0000001@3G?Q/00`000000echK0=Ln6`0203eIZ`060=Ln6`000000
echK0=Ln6`0mFJ/00000103G?Q/00`000000echK00000002000000<0i48L00@0000004ibgP1>L]h0
CW;N0`0000000`1>L]`0000004ibg00304ibg0060000003D?AT0CW;L04ibg0000000CW;L0P3D?AT2
04ibg0030000001>L]`0CW;L00<0CW;L00<0000004ibg00000000`1>LMT00`000000CW7I04iaf@04
04iaf@80e3dI101>LMT20=@m6@0304iaf@000000CW7I00<0CW7I0P0000000`1=Km@0000004e_e007
04e_e0030000001=Km@0CFoD0080CFoD0P3D?AT204e_e0<0e3dI00<0000004a]cP1<KLh00`1<KLh0
0`000000C6g>04a]cP0204a]cP80e3dI0`1<KLh010000000ooK^0?ofkP3om^h20=@m6@030?ofkP3D
?AT0e3dI0080e3dI0P3om^h303eIZ`h0ooK^00<0?EV[0?ofkP3om^h0103om^h203eIZ`D0ooK^00<0
?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP0O0?ofkP030000003om^h0ooK^02X0ooK^00<0
00000?ofkP3om^h0403om^h10?ooo`004P3om^h00`000000ooK^0?ofkP0X0?ofkP8000008P3om^h0
0`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h01P3om^h0
0`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00@0ooK^100mFJ/00`3om^h0?EV[03eIZ`02
0?ofkP030000000mFJ/0[34F0080[34F0P0mFJ/30:`a5P040000002/<AH0[34F00000080?EV[0`2l
=QP010000000_3HH0;`f602l=QP203eIZ`<0_3HH00<000000;`f602l=QP01P2l=QP00`000000bSXI
0<Xj6@050<Xj6@030000003:>QT0bSXI0080?EV[00@0bSXI03eIZ`3:>QT000001P3:>QT010000000
bSXI0000000000020=Ln6`030000003G?Q/0echK00<0echK00<000000=Ln6`3G?Q/00P3G?Q/203eI
Z`040=Ln6`0mFJ/0echK000000@0echK0P0000020>A270050000003T@Q`0i48L0>A2700000000`1>
L]h00`000000CW;N04ibgP02000000<0CW;L00D0000004ibg01>L]`0e3dI04ibg0020=@m6@<0CW;L
00<0000004ibg01>L]`0101>L]`00`000000CW;L04ibg0020000000304iaf@000000CW7I00D0CW7I
00@0000004iaf@3D?AT0CW7I0P3D?AT204iaf@030000001>LMT0CW7I00D0CW7I00<0000004e_e01=
Km@01P1=Km@010000000CFoD04e_e01=Km@20=@m6@<0CFoD00@0000004e_e01=Km@0CFoD0P3D?AT0
10000000C6g>04a]cP00000304a]cP80e3dI0`1<KLh0103D?AT000000?ofkP3om^h20=@m6@030?of
kP3D?AT0e3dI0080e3dI1P3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00H0ooK^
00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^0200ooK^
0P00000Z0?ofkP030000003om^h0ooK^0100ooK^0@3oool00180ooK^00<000000?ofkP3om^h09`3o
m^h00`000000ooK^0?ofkP0R0?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h00P3D
?AT90?ofkP030=@m6@3om^h0ooK^00X0ooK^0`3D?AT70?ofkPD0?EV[00D0ooK^03eIZ`0mFJ/0ooK^
03eIZ`050:`a5P80?EV[0P2/<AH303eIZ`H0_3HH00<000000;`f602l=QP00P2l=QP203eIZ`80_3HH
00<000000;`f602l=QP00`2l=QP2000000030<Xj6@000000bSXI00H0bSXI00D000000<Xj6@3:>QT0
bSXI03eIZ`030<Xj6@030000003:>QT0bSXI00@0bSXI00<000000=Ln6`3G?Q/00`3G?Q/00`000000
echK0=Ln6`030=Ln6`030000003G?Q/0echK0080echK00<0000003eIZ`3G?Q/00P3G?Q/00`000000
echK00000002000000<0i48L00D000000>A2703T@Q`0i48L0000000304ibgP040000001>L]h0CW;N
04ibgP<0000000<0CW;L0000001>L]`00P1>L]`00`3D?AT0000004ibg00304ibg0030000001>L]`0
CW;L00<0CW;L00<0000004ibg01>L]`00`1>L]`00`000000CW7I04iaf@0404iaf@050000001>LMT0
CW7I04iaf@3D?AT00`1>LMT00`000000CW7I04iaf@0504iaf@040000001>LMT00000000000D0CFoD
00<0000004e_e01=Km@00P3D?AT404e_e0030000001=Km@0CFoD00@0CFoD0`3D?AT204a]cP80e3dI
101<KLh00`3D?AT000000?ofkP020=@m6@030?ofkP3D?AT0e3dI00<0e3dI1`3om^h303eIZ``0ooK^
00<0?EV[0?ofkP3om^h01`3om^h203eIZ`80ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^
0?ofkP0R0?ofkP030000003om^h0ooK^02L0ooK^00<000000?ofkP3om^h0403om^h10?ooo`004@3o
m^h00`000000ooK^0?ofkP0V0?ofkP8000009@3om^h00`3D?AT0ooK^0?ofkP090?ofkP<0e3dI2`3o
m^h00`3D?AT0ooK^0?ofkP090?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT0203om^h503eIZ`040?of
kP0mFJ/0?EV[0=@m6@80[34F1P0mFJ/00`2l=QP000000;`f60070;`f60030000002l=QP0_3HH00<0
_3HH0P0mFJ/0102l=QP000000;`f602l=QP2000000@0bSXI00<000000<Xj6@3:>QT01@3:>QT01000
0000?EV[03eIZ`3:>QT203eIZ`80bSXI00@000000<Xj6@3:>QT0bSXI0P0000000`3G?Q/0e3dI0=Ln
6`040=Ln6`030000003G?Q/0echK0080echK00<000000=Ln6`3G?Q/00P3G?Q/01@0mFJ/0000003eI
Z`0mFJ/0echK008000000P3T@Q`01@000000i48L0>A2703T@Q`0000000<0i48L00D0000004ibgP1>
L]h0CW;N0000000304ibgP030000001>L]h0CW;N0080000000D0CW;L0=@m6@3D?AT000000=@m6@03
04ibg0030000001>L]`0CW;L00<0CW;L00<0000004ibg01>L]`00`1>L]`0100mFJ/0CW;L00000000
000304iaf@030000001>LMT0CW7I0080e3dI00@0CW7I0=@m6@3D?AT000001`1>LMT00`000000CW7I
04iaf@0204iaf@8000000P1=Km@010000000CFoD0=@m6@3D?AT504e_e0030000001=Km@0CFoD00H0
CFoD00<0000004e_e03D?AT01@3D?AT204a]cP0403eIZ`3D?AT0e3dI0?ofkPD0e3dI203om^h01@0m
FJ/0ooK^0?ofkP3om^h0?EV[00X0ooK^00<0?EV[0?ofkP3om^h02P3om^h303eIZ`/0ooK^00<0?EV[
0?ofkP3om^h08`3om^h2000002P0ooK^00<000000?ofkP3om^h03`3om^h10?ooo`004@3om^h00`00
0000ooK^0?ofkP0U0?ofkP030000003om^h0ooK^02D0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D
?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00H0ooK^0P3D?AT40?ofkP030=@m6@3om^h0ooK^
00P0ooK^2@0mFJ/30:`a5P060000002l=QP0?EV[03eIZ`2l=QP00000202l=QP00`000000_3HH0;`f
60040;`f600403eIZ`2l=QP00000000000L0bSXI00<000000<Xj6@3:>QT00`3:>QT203eIZ`030000
003:>QT0bSXI0080bSXI0P0mFJ/010000000bSXI0000000000040=Ln6`030000003G?Q/0echK0080
echK00<000000=Ln6`3G?Q/00`3G?Q/01P000000echK03eIZ`0mFJ/0echK00000080echK0P0mFJ/4
0>A270040000003T@Q`0i48L000000<0i48L00D0000004ibgP1>L]h0CW;N0000000204ibgP030000
001>L]h0CW;N0080CW;N0P3D?AT204ibg0060000001>L]`0e3dI0=@m6@1>L]`000001@1>L]`00`00
0000CW;L04ibg00204ibg0030000001>L]`0CW;L0080CW;L0P000000101>LMT000000=@m6@3D?AT4
04iaf@030000003D?AT0e3dI00D0CW7I00<0000004iaf@1>LMT01@1>LMT20000000304e_e03D?AT0
CFoD00D0CFoD00<0000004e_e01=Km@01P1=Km@01P000000CFoD0=@m6@3D?AT0CFoD000000<0C6g>
2@3D?AT:0?ofkP0303eIZ`3om^h0ooK^0080ooK^0P0mFJ/80?ofkP0303eIZ`3om^h0ooK^00`0ooK^
00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP0U0?ofkP030000003om^h0ooK^02D0ooK^
00<000000?ofkP3om^h03`3om^h10?ooo`004@3om^h00`000000ooK^0?ofkP0T0?ofkP030000003o
m^h0ooK^02H0ooK^00<0e3dI0?ofkP3om^h01`3om^h30=@m6@h0ooK^00<0e3dI0?ofkP3om^h01@3o
m^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00X0ooK^100mFJ/0103D?AT0ooK^03eI
Z`0mFJ/2000000@0_3HH0P0mFJ/00`000000_3HH0;`f60060;`f60030000002l=QP0_3HH00@0_3HH
0P0mFJ/00`000000bSXI0<Xj6@060<Xj6@050000003:>QT0bSXI0<Xj6@0mFJ/00`3:>QT00`000000
bSXI0<Xj6@030<Xj6@80?EV[1P3G?Q/00`000000echK0=Ln6`030=Ln6`030000003G?Q/0echK0080
echK00<0000003eIZ`3G?Q/00`3G?Q/200000080i48L0P0mFJ/20>A270040000003T@Q`0i48L0000
00<0i48L00D0000004ibgP1>L]h0CW;N0000000204ibgP030000001>L]h0CW;N0080e3dI0P1>L]h2
000000@0CW;L00<0e3dI04ibg01>L]`00`1>L]`00`000000CW;L04ibg00304ibg0030000001>L]`0
CW;L00@0CW;L0P3D?AT504iaf@050000001>LMT0CW7I04iaf@3D?AT00`1>LMT00`000000CW7I04ia
f@0604iaf@030000003D?AT0e3dI00H0CFoD00<0000004e_e01=Km@01P1=Km@00`000000e3dI0=@m
6@0404e_e08000000P3D?AT00`0mFJ/0ooK^0=@m6@030=@m6@`0ooK^00<0?EV[0?ofkP3om^h0103o
m^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00`0ooK^0`0mFJ/90?ofkP0303eIZ`3o
m^h0ooK^02H0ooK^00<000000?ofkP3om^h0903om^h00`000000ooK^0?ofkP0?0?ofkP40oooo000A
0?ofkP030000003om^h0ooK^0280ooK^0P00000Y0?ofkP030=@m6@3om^h0ooK^00H0ooK^00@0e3dI
0?ofkP3om^h0e3dI3P3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0
e3dI0?ofkP3om^h02`3om^h403eIZ`030?ofkP0mFJ/0_3HH00L0_3HH0P0mFJ/80;`f60040000002l
=QP0_3HH0;`f608000000P3:>QT203eIZ`030000003:>QT0bSXI00D0bSXI00<0000003eIZ`0mFJ/0
1@3:>QT00`000000bSXI0<Xj6@0200000080echK0P0mFJ/50=Ln6`030000003G?Q/0echK0080echK
00<000000=Ln6`3G?Q/00P3G?Q/00`0mFJ/000000=Ln6`030=Ln6`060000003T@Q`0i48L0>A27000
0000i48L0P0mFJ/01@000000i48L0>A2703T@Q`000000080i48L00@0000004ibgP1>L]h000000`1>
L]h01@000000e3dI0=@m6@1>L]h0000000<0CW;N00<0000004ibg01>L]`00P1>L]`00`000000e3dI
04ibg00304ibg0030000001>L]`0CW;L0080CW;L00<0000004ibg01>L]`00`1>L]`20=@m6@80CW;L
0P00000204iaf@030000001>LMT0CW7I00<0CW7I0P3D?AT00`000000CW7I04iaf@0504iaf@030000
003D?AT0e3dI0080CW7I0P00000304e_e0030000001=Km@0CFoD00H0CFoD0P3D?AT804e_e0030=@m
6@3om^h0e3dI00<0e3dI3@3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00@0ooK^
00<0?EV[0?ofkP3om^h0303om^h0100mFJ/0ooK^0?ofkP0mFJ/80?ofkP0303eIZ`3om^h0ooK^02L0
ooK^0P00000T0?ofkP030000003om^h0ooK^00l0ooK^0@3oool00140ooK^00<000000?ofkP3om^h0
8@3om^h00`000000ooK^0?ofkP0Y0?ofkP030=@m6@3om^h0ooK^00@0ooK^0P3D?AT40?ofkP030=@m
6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h00P3om^h20=@m6@T0ooK^00<0e3dI0?ofkP3om^h0
3@3om^h503eIZ`030000002l=QP0_3HH00H0_3HH0P0mFJ/70;`f60030000002l=QP0000000H0bSXI
0P0mFJ/50<Xj6@80?EV[00<0bSXI0000003:>QT01@3:>QT2000000D0echK00<0000003eIZ`0mFJ/0
103G?Q/00`000000echK0=Ln6`020=Ln6`060000003G?Q/0echK03eIZ`3G?Q/000000P3G?Q/30000
00<0i48L00@000000>A2703T@Q`0i48L0P0mFJ/20>A270040000003T@Q`0i48L00000080CW;N00<0
000004ibgP1>L]h00P3D?AT304ibgP030000001>L]h0CW;N0080CW;N0P0000001@1>L]`0000004ib
g01>L]`0e3dI0080CW;L00<0000004ibg01>L]`00P1>L]`00`000000CW;L04ibg00204ibg080e3dI
00<0000004ibg01>L]`00`1>L]`2000000H0CW7I00@0000004iaf@3D?AT0e3dI1@1>LMT20=@m6@H0
CW7I00<0000004e_e00000001`1=Km@20=@m6@P0CFoD00<000000=@m6@3D?AT00`3D?AT?0?ofkP03
03eIZ`3om^h0ooK^00L0ooK^0P0mFJ/40?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3o
m^h00P3om^h203eIZ`H0ooK^00<0?EV[0?ofkP3om^h0:@3om^h00`000000ooK^0?ofkP0Q0?ofkP03
0000003om^h0ooK^00l0ooK^0@3oool00100ooK^00<000000?ofkP3om^h0803om^h2000002`0ooK^
00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00`0ooK^
00@0e3dI0?ofkP3om^h0e3dI2`3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP80e3dI00<0ooK^03eIZ`0m
FJ/00P0mFJ/00`000000_3HH0;`f60070;`f600303eIZ`2l=QP0_3HH00D0_3HH00<000000<Xj6@3:
>QT01`3:>QT203eIZ`030<Xj6@0mFJ/0?EV[00@0bSXI00<000000<Xj6@3:>QT00P3:>QT00`000000
echK000000060=Ln6`040000003G?Q/0?EV[03eIZ`<0echK00<000000=Ln6`3G?Q/00P3G?Q/00`00
0000?EV[0=Ln6`020=Ln6`8000000`3T@Q`01@000000i48L0>A2703T@Q`0000000<0i48L00@00000
03eIZ`0mFJ/000000P3T@Q`010000000CW;N04ibgP0000020=@m6@050000001>L]h0CW;N04ibgP00
00000`1>L]h010000000CW;N04ibgP1>L]h2000000<0CW;L00<0e3dI0000001>L]`00`1>L]`01000
0000CW;L04ibg01>L]`20=@m6@0304ibg0000000CW;L00D0CW;L00<0000004ibg0000000101>LMT0
0`000000CW7I04iaf@0204iaf@80e3dI00<0CW7I0=@m6@3D?AT02@1>LMT00`000000CFoD04e_e005
04e_e0030=@m6@1=Km@0CFoD00L0CFoD00<000000=@m6@3D?AT00P3D?AT00`3om^h0?EV[03eIZ`0>
0?ofkP0303eIZ`3om^h0ooK^00T0ooK^00@0?EV[0?ofkP3om^h0?EV[3P3om^h00`0mFJ/0ooK^0?of
kP040?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h0:P3om^h200000280ooK^00<0
00000?ofkP3om^h03P3om^h10?ooo`00403om^h00`000000ooK^0?ofkP0O0?ofkP030000003om^h0
ooK^02`0ooK^00@0e3dI0?ofkP3om^h0ooK^0P3D?AT70?ofkP030=@m6@3om^h0ooK^00`0ooK^0`3D
?AT=0?ofkP030=@m6@3om^h0ooK^00X0ooK^00H0e3dI0?ofkP3om^h0ooK^0=@m6@3om^h403eIZ`T0
_3HH0P0mFJ/30;`f6080000000<0bSXI000000000000203:>QT203eIZ`L0bSXI00@000000<Xj6@00
000000000`3G?Q/00`000000echK0=Ln6`040=Ln6`030000003G?Q/0echK0080?EV[0P3G?Q/00`00
0000echK0=Ln6`0203eIZ`80echK0P0000000`3T@Q`000000>A270020>A270050000003T@Q`0i48L
0>A2700000000`3T@Q`00`000000i48L0>A2700203eIZ`030>A270000000CW;N0080e3dI0P1>L]h0
1@000000CW;N04ibgP1>L]h000000080CW;N00<0000004ibgP1>L]h00P1>L]h010000000CW;N0000
0000000204ibg080e3dI0P1>L]`00`000000CW;L04ibg0020=@m6@80CW;L00<0000004ibg01>L]`0
101>L]`010000000CW;L04ibg01>L]`20000000304iaf@000000CW7I00H0CW7I0P3D?AT804iaf@80
000000<0CW7I0000000000000`1=Km@20=@m6@T0CFoD103D?AT00`3om^h0?EV[0?ofkP020?ofkP03
03eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h02`3om^h303eIZ`h0ooK^00<0?EV[0?ofkP3o
m^h01@3om^h203eIZ`<0ooK^00<0?EV[0?ofkP3om^h0;03om^h00`000000ooK^0?ofkP0O0?ofkP03
0000003om^h0ooK^00h0ooK^0@3oool00100ooK^00<000000?ofkP3om^h07@3om^h2000002l0ooK^
00@0e3dI0?ofkP3om^h0e3dI2@3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00d0
ooK^00<0e3dI0?ofkP3om^h0203om^h20=@m6@D0ooK^00<0e3dI0?ofkP3om^h0100mFJ/80;`f6004
0000000mFJ/0?EV[000000D0bSXI00<000000<Xj6@3:>QT00P3:>QT303eIZ`040<Xj6@000000?EV[
03eIZ`H0bSXI00<000000=Ln6`3G?Q/0103G?Q/00`000000echK0=Ln6`040=Ln6`040000003G?Q/0
echK0=Ln6`80?EV[00<000000=Ln6`0mFJ/00P3G?Q/2000000<0i48L00<000000>A2703T@Q`00P3T
@Q`010000000i48L0>A2700000030>A270040000003T@Q`0i48L00000080i48L00@0000004ibgP1>
L]h000000P1>L]h01@000000CW;N04ibgP1>L]h000000080CW;N00<0000004ibgP1>L]h00P1>L]h0
10000000CW;N04ibgP1>L]h200000080CW;L00<0e3dI04ibg00000000P3D?AT304ibg0030000001>
L]`0CW;L00@0CW;L00<0000004ibg01>L]`0101>L]`00`000000CW7I04iaf@0404iaf@80e3dI00<0
000004iaf@3D?AT00P3D?AT404iaf@030000001>LMT0CW7I00<0CW7I00@000000=@m6@3D?AT00000
201=Km@40=@m6@80ooK^00<0?EV[0?ofkP3om^h00`3om^h203eIZ`X0ooK^00<0?EV[0?ofkP3om^h0
3@3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00L0ooK^00@0?EV[0?ofkP3om^h0
?EV[;`3om^h2000001l0ooK^00<000000?ofkP3om^h03P3om^h10?ooo`00403om^h00`000000ooK^
0?ofkP0L0?ofkP030000003om^h0ooK^02l0ooK^0`3D?AT:0?ofkP030=@m6@3om^h0ooK^00X0ooK^
0`3D?AT?0?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^
0?ofkP020?ofkP@0?EV[1`2l=QP010000000bSXI03eIZ`0mFJ/50<Xj6@8000000P0mFJ/50<Xj6@80
00000P0mFJ/20<Xj6@80000000<0echK0000000000001@3G?Q/00`000000echK0=Ln6`040=Ln6`03
0000003G?Q/0echK0080echK0P0mFJ/01@3G?Q/000000000003T@Q`0000000@0i48L00D000000>A2
703T@Q`0i48L000000030>A270040000003T@Q`0i48L00000080i48L00<000000>A2700000000P00
00001@1>L]h0000004ibgP1>L]h000000080CW;N00@0000004ibgP1>L]h00000101>L]h00`000000
CW;N04ibgP0204ibgP050000001>L]h000000000001>L]`00P3D?AT404ibg0030000001>L]`0CW;L
00@0CW;L00<0000004ibg01>L]`00`1>L]`20000000304ibg000000000000080CW7I0P3D?AT20000
00D0CW7I0P3D?AT2000000D0CW7I0P3D?AT00`1>LMT0000004e_e00604e_e0@0e3dI103om^h00`0m
FJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h03@3om^h303eI
Z`/0ooK^00<0?EV[0?ofkP3om^h02@3om^h303eIZc40ooK^00<000000?ofkP3om^h0703om^h00`00
0000ooK^0?ofkP0>0?ofkP40oooo000?0?ofkP030000003om^h0ooK^01`0ooK^00<000000?ofkP3o
m^h0<03om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00L0ooK^0P3D?AT30?ofkP03
0=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h0103om^h20=@m6@T0ooK^00<0e3dI0?ofkP3o
m^h00`3om^h403eIZ`<0_3HH0P000000103:>QT000000000003:>QT203eIZ`80bSXI0`0mFJ/20000
00L0bSXI00@000000<Xj6@0mFJ/0?EV[1@3G?Q/00`000000echK0=Ln6`030=Ln6`8000001@3G?Q/0
0`000000echK0=Ln6`0203eIZ`030=Ln6`0mFJ/0?EV[00<0i48L00D000000>A2703T@Q`0i48L0000
00040>A270040000003T@Q`0i48L000000<0i48L00L000000>A27000000000000>m67P000000CG;N
0080000000<0CW;N0000001>L]h00P1>L]h010000000CW;N04ibgP00000404ibgP050000001>L]h0
CW;N04ibgP0000000`1>L]h20=@m6@0304ibg03D?AT0e3dI0080CW;L00<0000004ibg01>L]`00`1>
L]`2000000D0CW;L00<0000004ibg01>L]`00`1>L]`20=@m6@0304iaf@000000CW7I00H0CW7I0P00
00030=@m6@80CW7I0P3D?AT0101>LMT000000000001>LMT2000000<0CFoD103D?AT50?ofkP0303eI
Z`3om^h0ooK^00L0ooK^0P0mFJ/60?ofkP0303eIZ`3om^h0ooK^00d0ooK^00@0?EV[0?ofkP3om^h0
ooK^0P0mFJ/90?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h0<03om^h00`000000
ooK^0?ofkP0L0?ofkP030000003om^h0ooK^00d0ooK^0@3oool000l0ooK^00<000000?ofkP3om^h0
6P3om^h2000003<0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m
6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP020?ofkP80e3dI
2`3om^h00`3D?AT0ooK^0?ofkP050?ofkPl0?EV[1@3:>QT00`000000bSXI0<Xj6@040<Xj6@800000
0P3G?Q/203eIZ`@0echK00<000000=Ln6`3G?Q/0103G?Q/00`000000echK0=Ln6`030=Ln6`80?EV[
00D0echK000000000000i48L0000000203eIZ`80i48L00D000000>A2703T@Q`0i48L000000030>A2
70040000003T@Q`0i48L000000<0i48L0`0000020>m67P030000001=L]h0CG;N00<000000`1>L]h0
0`000000CW;N0000000404ibgP050000001>L]h0CW;N04ibgP0000000P1>L]h20=@m6@050000001>
L]h000000000001>L]`00P3D?AT504ibg0030000001>L]`0CW;L00@0CW;L00<0000004ibg01>L]`0
0P1>L]`20=@m6@80CW;L0P00000604iaf@030000001>LMT0CW7I00<0CW7I3`3D?AT70?ofkP0303eI
Z`3om^h0ooK^00T0ooK^0P0mFJ/40?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h0
0`3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h0
<@3om^h2000001`0ooK^00<000000?ofkP3om^h03@3om^h10?ooo`003`3om^h00`000000ooK^0?of
kP0I0?ofkP030000003om^h0ooK^03<0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?of
kP040?ofkP80e3dI1P3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT0
3P3om^h00`3D?AT0ooK^0?ofkP060?ofkP@0?EV[1P3:>QT010000000bSXI03eIZ`0mFJ/50<Xj6@80
00000P3:>QT200000080echK0P0000020=Ln6`80?EV[0`3G?Q/2000000D0echK00H000000=Ln6`3G
?Q/0echK03eIZ`3G?Q/2000000@0i48L00<000000>A2700mFJ/00P3T@Q`01@000000i48L0>A2703T
@Q`0000000<0i48L00D000000>A2703T@Q`000000>A27002000000050>m67P000000kdHN0>m67P00
00000P1=L]h01P000000CG;N000000000000CW;N00000080CW;N00D0000004ibgP1>L]h0CW;N0000
000304ibgP060000001>L]h0CW;N0=@m6@1>L]h00000101>L]h20000000304ibg03D?AT0CW;L0080
CW;L00<0000004ibg01>L]`00`1>L]`2000000<0CW;L0P3D?AT204ibg08000000P1>L]`200000080
CW7I0P00000504iaf@80e3dI00<0CW7I0000001>LMT01@1>LMT40=@m6@P0ooK^00<0?EV[0?ofkP3o
m^h0303om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00l0ooK^00<0?EV[0?ofkP3om^h0103om^h203eI
Z`H0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP0c0?ofkP030000003om^h0ooK^
01T0ooK^00<000000?ofkP3om^h03@3om^h10?ooo`003`3om^h00`000000ooK^0?ofkP0G0?ofkP80
0000=P3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3o
m^h01`3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP<0e3dI3`3om^h00`3D?AT0ooK^0?ofkP070?ofkP03
0000000mFJ/0?EV[0080?EV[1@3:>QT2000000030<Xj6@0mFJ/0?EV[00D0bSXI0P0000060=Ln6`80
00000P3G?Q/203eIZ`<0echK00<000000=Ln6`3G?Q/00`3G?Q/00`000000?EV[03eIZ`0200000003
0>A270000000i48L00@0i48L00D000000>A2700mFJ/0?EV[000000030>A270050000003T@Q`0i48L
0>A2700000000P3T@Q`2000000040>m67P000000kdHN03eIZ`80kdHN00L0000004ebgP1=L]h0e3dI
04ebgP000000CG;N0080000000<0CW;N0000001>L]h00`1>L]h01@000000CW;N04ibgP1>L]h00000
0080e3dI00<0CW;N0000001>L]h0101>L]h010000000CW;N0000000000020=@m6@030000001>L]`0
CW;L00<0CW;L00@0000004ibg01>L]`0CW;L0P3D?AT204ibg08000001P1>L]`2000000D0CW7I0P3D
?AT00`1>LMT000000000000504iaf@@0e3dI00<000000?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?of
kP0=0?ofkP<0?EV[3`3om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0
?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP0d0?ofkP8000006@3om^h00`000000ooK^0?of
kP0=0?ofkP40oooo000?0?ofkP030000003om^h0ooK^01H0ooK^00<000000?ofkP3om^h0=`3om^h0
0`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^0080e3dI2P3om^h00`3D?AT0ooK^0?ofkP0=
0?ofkP030=@m6@3om^h0ooK^0100ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0?EV[0<Xj6@02
03eIZ`D0bSXI0P0000000`3:>QT0?EV[03eIZ`020<Xj6@040000003G?Q/00000000000L0echK00@0
00000=Ln6`3G?Q/0echK0P0mFJ/20=Ln6`040000003G?Q/0echK0=Ln6`80?EV[0P0000040>A27080
0000103T@Q`00`000000i48L0>A2700203eIZ`<0i48L00@000000>A2703T@Q`0e3dI0`0000020>m6
7P0;0000000mFJ/0kdHN0000003_AQh0000004ebgP000000CG;N0=@m6@0000000P1=L]h300000004
03eIZ`1>L]h0CW;N000000<0CW;N0P3D?AT204ibgP030000001>L]h0CW;N0080CW;N0P00000404ib
gP8000000P3D?AT304ibg0030000001>L]`0CW;L0080e3dI0`1>L]`00`000000CW;L04ibg00504ib
g080000000@0CW;L0000001>LMT0CW7I0P3D?AT00`1>LMT000000000000504iaf@80e3dI00<0CW7I
0=@m6@0mFJ/02P3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[
0?ofkP3om^h0203om^h203eIZ`80ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP0g
0?ofkP030000003om^h0ooK^01H0ooK^00<000000?ofkP3om^h03@3om^h10?ooo`003P3om^h00`00
0000ooK^0?ofkP0E0?ofkP800000>P3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP<0e3dI303om^h00`3D
?AT0ooK^0?ofkP0;0?ofkP80e3dI00<0ooK^0=@m6@3om^h0403om^h00`3D?AT0ooK^0?ofkP070?of
kP030=@m6@3om^h0ooK^0080000000<0bSXI03eIZ`0mFJ/01@3:>QT2000000030<Xj6@0mFJ/0?EV[
00@0echK0P0000060=Ln6`8000000`3G?Q/203eIZ`040=Ln6`000000?EV[03eIZ`80000000<0i48L
0000000000001@3T@Q`01@000000i48L0>A2703T@Q`0000000@0i48L00D0?EV[0>A2703T@Q`00000
0>A27003000000@0kdHN00d0?EV[0000003_AQh000000>m67P000000CG;N0000001=L]h000000=@m
6@1=L]h0000000<0CG;N0P0000001@1>L]h0000004ibgP1>L]h0e3dI00@0CW;N00D0000004ibgP1>
L]h0CW;N0000000504ibgP80000000<0CW;N0000000000000P3D?AT010000000CW;L0=@m6@3D?AT3
04ibg08000001P1>L]`2000000@0CW;L0P3D?AT00`1>LMT000000000000504iaf@80e3dI00<0CW7I
0000000000000P3om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00l0ooK^00@0?EV[
0?ofkP0mFJ/0?EV[303om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP<0?EV[3@3om^h00`0mFJ/0ooK^0?of
kP0h0?ofkP8000005`3om^h00`000000ooK^0?ofkP0<0?ofkP40oooo000>0?ofkP030000003om^h0
ooK^01@0ooK^00<000000?ofkP3om^h0>P3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0
ooK^00d0ooK^00<0e3dI0?ofkP3om^h0203om^h20=@m6@<0ooK^00<0e3dI0?ofkP3om^h0403om^h0
0`3D?AT0ooK^0?ofkP040?ofkP80e3dI1@3om^h2000000030<Xj6@0mFJ/0?EV[00D0bSXI00<00000
0=Ln6`3G?Q/00P0mFJ/40=Ln6`8000001P3G?Q/2000000<0echK0P0mFJ/00`3G?Q/000000>A27004
0>A270030000003T@Q`0i48L00<0i48L00D000000>A2703T@Q`0i48L000000040>A27080?EV[00<0
i48L0000003_AQh00P3_AQh04`000000kdHN0000000mFJ/0kdHN0000003_AQh000000>m67P000000
CG;N0000001=L]h0000004ebgP3D?AT0000004ebgP0000000`1=L]h010000000CW;N0=@m6@3D?AT4
04ibgP050000001>L]h0CW;N04ibgP0000001@1>L]h00`000000CW;N04ibgP0304ibgP040000001>
L]`0e3dI0=@m6@<0CW;L0P00000604ibg0800000101>L]`20=@m6@80CW;L00<0000004iaf@1>LMT0
0`1>LMT20=@m6@0304iaf@000000000000D0ooK^0P0mFJ/60?ofkP0303eIZ`3om^h0ooK^0100ooK^
00@0?EV[0?ofkP3om^h0ooK^0P0mFJ/:0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3o
m^h02`3om^h00`0mFJ/0ooK^0?ofkP0j0?ofkP030000003om^h0ooK^01@0ooK^00<000000?ofkP3o
m^h0303om^h10?ooo`003P3om^h00`000000ooK^0?ofkP0C0?ofkP030000003om^h0ooK^03/0ooK^
00<0e3dI0?ofkP3om^h02@3om^h30=@m6@l0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^
0?ofkP040?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^
0?ofkP070?ofkP80000000<0bSXI03eIZ`0mFJ/00P3:>QT00`000000echK0=Ln6`02000000030=Ln
6`0mFJ/0?EV[00@0echK0P0000060=Ln6`<0?EV[00@0echK0000000mFJ/0?EV[0P0000040>A27003
0000003T@Q`0i48L00<0i48L00D000000>A2703T@Q`0i48L000000030>A270040=@m6@000000?EV[
03eIZ`<0kdHN00<0000003eIZ`0mFJ/00P3_AQh02`000000kdHN0000003_AQh0000004ebgP000000
CG;N0000001=L]h000000080e3dI0`1=L]h01@000000e3dI0=@m6@000000?EV[00<0CW;N00D00000
04ibgP1>L]h0CW;N0000000504ibgP030000001>L]h0CW;N0080CW;N0P0000020=@m6@030000001>
L]`0e3dI0080e3dI1P1>L]`2000000@0CW;L0P3D?AT00`1>L]`000000000000204ibg0030000001>
LMT0CW7I0080e3dI00<0CW7I0000000000002@3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3o
m^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3o
m^h0ooK^00d0ooK^0`0mFJ/;0?ofkP0303eIZ`3om^h0ooK^03/0ooK^00<000000?ofkP3om^h04`3o
m^h00`000000ooK^0?ofkP0<0?ofkP40oooo000>0?ofkP030000003om^h0ooK^0140ooK^0P00000n
0?ofkP030=@m6@3om^h0ooK^00L0ooK^0P3D?AT30?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI
0?ofkP3om^h0103om^h20=@m6@L0ooK^00<0e3dI0?ofkP3om^h0403om^h01@3D?AT0ooK^0?ofkP3o
m^h0e3dI00`0ooK^0P0000000`3:>QT0?EV[03eIZ`050=Ln6`80000000<0echK03eIZ`0mFJ/0103G
?Q/200000080echK0P0mFJ/20=Ln6`8000000`3T@Q`203eIZ`8000000`3T@Q`2000000@0i48L0P00
00020>A270080000003T@Q`000000000003_AQh000000>m67P0mFJ/20>m67P0I03eIZ`000000kdHN
0000003_AQh000000>m67P000000kdHN0000001=L]h0000004ebgP000000CG;N0000001=L]h00000
0=@m6@1=L]h000000=@m6@1=L]h0000004ebgP020000000404ibgP000000CW;N04ibgP800000101>
L]h2000000<0CW;N0P0000020=@m6@<0CW;N0P00000204ibg080e3dI0P1>L]`2000000@0CW;L0P3D
?AT00`1>L]`000000000000504ibg080e3dI00<0CW7I000000000000303om^h01@0mFJ/0ooK^0?of
kP3om^h0?EV[0180ooK^00<0?EV[0?ofkP3om^h01@3om^h203eIZ`H0ooK^00<0?EV[0?ofkP3om^h0
3@3om^h0100mFJ/0ooK^0?ofkP3om^h203eIZ`T0ooK^00<0?EV[0?ofkP3om^h0?03om^h2000001<0
ooK^00<000000?ofkP3om^h0303om^h10?ooo`003@3om^h00`000000ooK^0?ofkP0A0?ofkP030000
003om^h0ooK^03h0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m
6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m
6@3om^h0ooK^00l0ooK^00@0e3dI0?ofkP3D?AT0e3dI3`3om^h00`000000echK0=Ln6`0203eIZ`D0
echK0`00000203eIZ`<0echK0`0mFJ/20=Ln6`8000000P3T@Q`2000000<0i48L0P0mFJ/00`000000
i48L0>A270020>A270030000003T@Q`0i48L00<0i48L00@000000>A2703T@Q`00000103_AQh00`00
0000kdHN03eIZ`0203eIZ`080000003_AQh000000>m67P000000kdHN0000003_AQh200000080CG;N
00D0000004ebgP000000000004ebgP030=@m6@0304ebgP000000CG;N00<0CG;N00@0000004ibgP1>
L]h000001@1>L]h00`000000CW;N04ibgP0204ibgP030000003D?AT0e3dI00<0CW;N0P00000204ib
gP8000000P1>L]`30=@m6@<0CW;L0P3D?AT3000000D0CW;L0P3D?AT204ibg0030000003om^h0ooK^
00d0ooK^0P0mFJ/00`3om^h0?EV[0?ofkP0@0?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?of
kP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?of
kP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP0n0?ofkP030000003om^h0ooK^0100ooK^00<000000?of
kP3om^h0303om^h10?ooo`003@3om^h00`000000ooK^0?ofkP0?0?ofkP800000@@3om^h00`3D?AT0
ooK^0?ofkP040?ofkP80e3dI1P3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP040=@m6@3om^h0ooK^0?of
kP80e3dI2`3om^h00`3D?AT0ooK^0?ofkP0@0?ofkP030=@m6@3om^h0ooK^0140ooK^0`00000=03eI
Z`<0echK0P0000060>A2708000000`3T@Q`00`0mFJ/00000000000030>A270030000003T@Q`0i48L
00<0i48L0P0000000`3_AQh000000>m67P030>m67P80?EV[00D000000>m67P0mFJ/0?EV[0>m67P02
00000080kdHN0`00000204ebgP80000000D0CG;N0=@m6@3D?AT0CG;N000000020=@m6@@0CG;N00@0
000004ebgP00000000001@1>L]h010000000CW;N04ibgP1>L]h2000000040=@m6@1>L]h0CW;N04ib
gP8000001P1>L]h2000000<0CW;L3@3D?AT3000001<0ooK^00<0?EV[0?ofkP3om^h0403om^h00`0m
FJ/0ooK^0?ofkP090?ofkP80?EV[0`3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^
00@0ooK^0P0mFJ/60?ofkP0303eIZ`3om^h0ooK^03l0ooK^0P00000A0?ofkP030000003om^h0ooK^
00/0ooK^0@3oool000d0ooK^00<000000?ofkP3om^h03P3om^h00`000000ooK^0?ofkP120?ofkP03
0=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP<0
e3dI3P3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP80e3dI00<0ooK^0=@m6@3om^h04`3om^h00`3D?AT0
00000000000203eIZ`H0echK0P00000203eIZ`8000000P3T@Q`2000000H0i48L0P0000020>A27080
?EV[0P0000020>A27080000000D0i48L000000000000kdHN000000020>m67P8000000P0mFJ/01P00
0000kdHN0>m67P000000kdHN00000080?EV[00<0kdHN0000003_AQh00`0000000`1=L]h0000004eb
gP020=@m6@80CG;N00@0000004ebgP000000CG;N0P3D?AT200000080CG;N00D0000004ebgP000000
000004ibgP0200000080CW;N0P0000020=@m6@80CW;N0P00000604ibgP8000000P1>L]h200000080
e3dI0P00000604ibg080e3dI0P0000000`0mFJ/0ooK^0?ofkP0B0?ofkP0403eIZ`3om^h0?EV[03eI
Z`l0ooK^00<0?EV[0?ofkP3om^h0303om^h303eIZa00ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0m
FJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^0480ooK^00<000000?ofkP3om^h03P3om^h00`00
0000ooK^0?ofkP0;0?ofkP40oooo000=0?ofkP030000003om^h0ooK^00`0ooK^0P0000150?ofkP03
0=@m6@3om^h0ooK^0080e3dI2P3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00l0
ooK^00<0e3dI0?ofkP3om^h02P3om^h20=@m6@<0ooK^00<0e3dI0?ofkP3om^h04`3om^h01@3D?AT0
0000000000000000?EV[00L0echK0P00000203eIZ`@0i48L0`0000050>A2708000000P3T@Q`203eI
Z`8000000P3T@Q`00`000000kdHN0>m67P030>m67P040000000mFJ/0?EV[00000080kdHN00X00000
0>m67P3_AQh000000>m67P000000kdHN03eIZ`000000kdHN0`0000001`1=L]h000000=@m6@1=L]h0
000004ebgP0000000P1=L]h010000000CG;N04ebgP0000020=@m6@030000001=L]h0CG;N00<0CG;N
00<0000004ibgP1>L]h00P0000020=@m6@80CW;N0P00000504ibgP<00000101>L]h20=@m6@800000
1`1>L]`01@3D?AT00000000000000000?EV[01D0ooK^00@0?EV[0?ofkP3om^h0ooK^0P0mFJ/<0?of
kP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP080?of
kP80?EV[0P3om^h00`0mFJ/0ooK^0?ofkP130?ofkP8000003P3om^h00`000000ooK^0?ofkP0;0?of
kP40oooo000=0?ofkP030000003om^h0ooK^00/0ooK^00<000000?ofkP3om^h0A@3om^h30=@m6@`0
ooK^00<0e3dI0?ofkP3om^h02`3om^h30=@m6A40ooK^00<0e3dI0?ofkP3om^h0203om^h20=@m6@H0
ooK^00<0e3dI0?ofkP3om^h04P3om^h0103D?AT0ooK^0=@m6@3D?AT4000000<0echK0P0000020>A2
70030000000mFJ/0?EV[00D0i48L0P0000050>A2708000000P3T@Q`203eIZ`8000000P3_AQh00`00
0000kdHN0>m67P0203eIZ`040000003_AQh0kdHN00000080kdHN00H000000>m67P000000kdHN0000
003_AQh:00000080CG;N00<0000004ebgP0000000P1=L]h010000000CG;N04ebgP0000020=@m6@80
CG;N00<0000004ebgP1=L]h00P0000020=@m6@80CW;N0P00000504ibgP8000001@1>L]h20=@m6@03
0000001>L]h0CW;N008000000`1>L]`400000080?EV[00<0ooK^03eIZ`3om^h04`3om^h00`0mFJ/0
ooK^0?ofkP040?ofkP80?EV[2P3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0403eIZ`3om^h0?EV[03eI
Z`d0ooK^00<0?EV[0?ofkP3om^h02P3om^h303eIZdL0ooK^00<000000?ofkP3om^h02`3om^h00`00
0000ooK^0?ofkP0;0?ofkP40oooo000<0?ofkP030000003om^h0ooK^00/0ooK^00<000000?ofkP3o
m^h0AP3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00X0ooK^00D0e3dI0?ofkP3o
m^h0ooK^0=@m6@0A0?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D
?AT0ooK^0?ofkP0B0?ofkP040=@m6@3om^h0ooK^0?ofkPH000001`3T@Q`203eIZ`030000003T@Q`0
i48L0080i48L0`0000040>A270<0000000<0kdHN03eIZ`0mFJ/00P000000103_AQh0?EV[03eIZ`00
00020>m67P80000000P0kdHN000000000000kdHN0000003_AQh000000>m67P<0000000D0nTXO0000
00000000000004]`g0030000000504ebgP000000CG;N0000001=L]h00P0000000`1=L]h000000000
000204ebgP040000003D?AT0e3dI04ebgP8000000P3D?AT0101=L]h0000000000000000404ibgP<0
0000101>L]h00`000000e3dI0=@m6@0704ibgPH000000`3om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP03
03eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP05
03eIZ`3om^h0ooK^0?ofkP0mFJ/0303om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^
04H0ooK^00<000000?ofkP3om^h02`3om^h00`000000ooK^0?ofkP0:0?ofkP40oooo000<0?ofkP03
0000003om^h0ooK^00T0ooK^0P0000190?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3o
m^h0203om^h20=@m6@@0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP040?ofkP80
e3dI2P3om^h00`3D?AT0ooK^0?ofkP0@0?ofkP80e3dI00<0ooK^0=@m6@3om^h00`3om^h9000000@0
i48L0P0mFJ/2000000@0i48L0P0000020>A270030000003_AQh0kdHN0080000000D0kdHN03eIZ`0m
FJ/0?EV[000000020>m67P8000000P3_AQh01@000000kdHN0>m67P000000kdHN00<0000000<0nTXO
0000000000001`0000001P1;L=`00000000000000000CG;N00000080CG;N00<0000004ebgP1=L]h0
0P00000204ebgP050000003D?AT0e3dI0=@m6@1=L]h00P00000204ebgP030000001>L]h0CW;N0080
0000101>L]h200000080e3dI101>L]h9000000@0ooK^00@0?EV[0?ofkP0mFJ/0?EV[4P3om^h00`0m
FJ/0ooK^0?ofkP080?ofkP80?EV[1P3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^
00<0ooK^0P0mFJ/:0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h0A`3om^h20000
00/0ooK^00<000000?ofkP3om^h02P3om^h10?ooo`00303om^h00`000000ooK^0?ofkP080?ofkP03
0000003om^h0ooK^04X0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP060?ofkP03
0=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h03`3om^h0103D?AT0ooK^0?ofkP3om^h20=@m
6@d0ooK^00<0e3dI0?ofkP3om^h03@3om^h20=@m6@@0ooK^00<0e3dI0?ofkP3om^h00`3om^h60000
000303MG/00000000000008000000P3T@Q`203eIZ`<000000`3T@Q`2000000<0kdHN0`0mFJ/20000
0080?EV[0`000000103_AQh000000000003_AQh2000000050>m67P000000nTXO0000003jBQl02`00
00001@1;L=`0000004]`g0000000CG;N0080000000@0CG;N000000000000CG;N0`0000020=@m6@80
00000`3D?AT304ebgP8000000`1>L]h300000080e3dI0P1>L]h4000000030?m>8@000000000000@0
00001@3om^h00`0mFJ/0ooK^0?ofkP020?ofkP80?EV[3`3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP80
?EV[0`3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3o
m^h01P3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^04X0ooK^00<000000?ofkP3o
m^h0203om^h00`000000ooK^0?ofkP0:0?ofkP40oooo000<0?ofkP030000003om^h0ooK^00H0ooK^
0P00001=0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h0103om^h20=@m6@P0ooK^
00<0e3dI0?ofkP3om^h03`3om^h0103D?AT0ooK^0=@m6@3D?AT@0?ofkP030=@m6@3om^h0ooK^00/0
ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP030?ofkPT0000000<0=eN`00000000
00000P00000203eIZ`040>A270000000000000000080kdHN0`0mFJ/2000000<0kdHN0P0000000`0m
FJ/0kdHN0>m67P02000000030>m67P00000000000080000000D0nTXO00000000000000000?Y:7`05
0000000504]`g000000000000000001;L=`00`0000000`1;L=`00000000000020000000304ebgP00
000000000080CG;N00<0e3dI0000000000000`1=L]h2000000<0e3dI0P1=L]h30000000304ibgP3D
?AT0e3dI00@0000000<0odhQ0000000000001`0000050?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0
?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP80?EV[00<0ooK^03eIZ`3om^h03`3o
m^h00`0mFJ/0ooK^0?ofkP070?ofkP80?EV[1P3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3o
m^h0ooK^04/0ooK^0P0000080?ofkP030000003om^h0ooK^00X0ooK^0@3oool000`0ooK^00<00000
0?ofkP3om^h01@3om^h00`000000ooK^0?ofkP1=0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI
0?ofkP3om^h00P3om^h20=@m6@/0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP0A
0?ofkP030=@m6@3om^h0ooK^00P0ooK^0P3D?AT90?ofkP030=@m6@3om^h0ooK^00@0ooK^0P000000
0`0W@HP00000000000060000000303MG/00000000000008000000`3_AQh5000000<0kdHN0`000000
1@3_AQh0?EV[03eIZ`000000kdHN00<0000000D0nTXO00000000000000000?Y:7`02000000030?Y:
7`000000000000D0000000@0Bg3L000000000000Bg3L0`0000001P1;L=`00000000000000000CG;N
00000080e3dI00@0CG;N00000000000000000`1=L]h5000000<0CG;N100000000`3oCR4000000000
0006000000030>U87@000000000000H0ooK^00<0?EV[0?ofkP3om^h01`3om^h203eIZ`X0ooK^00<0
?EV[0?ofkP3om^h04@3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00T0ooK^0P0m
FJ/40?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h0C@3om^h00`000000ooK^0?of
kP050?ofkP030000003om^h0ooK^00X0ooK^0@3oool000/0ooK^00<000000?ofkP3om^h0103om^h2
00000540ooK^00<0e3dI0?ofkP3om^h02`3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00d0ooK^00<0
e3dI0?ofkP3om^h03@3om^h20=@m6@030?ofkP3D?AT0ooK^0140ooK^00<0e3dI0?ofkP3om^h01P3o
m^h20=@m6@`0ooK^00<0e3dI0?ofkP3om^h0103om^h0103D?AT000000000000W@HP8000000040=@m
6@000000000003eIZ`H0000000<0kdHN000000000000100000020>m67P030000000mFJ/0000001h0
000000@0e3dI0000001=L]h0CG;N1P0000000`1=L]h0000000000004000000040=@m6@0000000000
03eIZ`P0000000@0jDPM000000000000?EV[1P3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP80?EV[203o
m^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0403eIZ`3om^h0?EV[03eIZ`h0ooK^00<0?EV[0?ofkP3om^h0
303om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00d0ooK^00<0?EV[0?ofkP3om^h0C`3om^h2000000H0
ooK^00<000000?ofkP3om^h02@3om^h10?ooo`002`3om^h00`000000ooK^0?ofkP030?ofkP030000
003om^h0ooK^0540ooK^00<0e3dI0?ofkP3om^h0303om^h30=@m6@l0ooK^00<0e3dI0?ofkP3om^h0
2P3om^h20=@m6@<0ooK^00<0e3dI0?ofkP3om^h04@3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m
6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP0700000080e3dI
1`000003045Ub@H0000000<0kdHN0000000000009@0000000`1=L]h0000000000004000000<0odlQ
1`00000203eIZ`L000000P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00d0ooK^
00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP0403eIZ`3om^h0ooK^0?ofkP80
?EV[303om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP<0?EV[3P3om^h00`0mFJ/0ooK^0?ofkP1A0?ofkP03
0000003om^h0ooK^00<0ooK^00<000000?ofkP3om^h02@3om^h10?ooo`002`3om^h00`000000ooK^
0?ofkP020?ofkP030000003om^h0ooK^0580ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^
0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00P0ooK^0P3D?AT60?ofkP030=@m6@3om^h0ooK^0140ooK^
00@0e3dI0?ofkP3om^h0ooK^0P3D?AT@0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3o
m^h00P3om^h300000080e3dI00<0000003MG/00000003P0000000`11ILT000000000000W00000003
0?m?8@000000000000d0000000@0odhQ0000000mFJ/0?EV[0`0000040?ofkP0303eIZ`3om^h0ooK^
00<0ooK^00<0?EV[0?ofkP3om^h03P3om^h203eIZ`<0ooK^00<0?EV[0?ofkP3om^h04@3om^h00`0m
FJ/0ooK^0?ofkP040?ofkP80?EV[2@3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0303eIZ`3om^h0ooK^
00/0ooK^00<0?EV[0?ofkP3om^h0D`3om^h00`000000ooK^0?ofkP020?ofkP030000003om^h0ooK^
00T0ooK^0@3oool000/0ooK^00<000000?ofkP3om^h00P00001F0?ofkP030=@m6@3om^h0ooK^00T0
ooK^0P3D?AT00`3om^h0e3dI0?ofkP0@0?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3o
m^h01`3om^h00`3D?AT0ooK^0?ofkP0@0?ofkP040=@m6@3om^h0e3dI0=@m6A<0ooK^00<0e3dI0?of
kP3om^h00P3om^h00`3D?AT0ooK^0?ofkP030?ofkP80e3dI1`00000303MG/0<0000000<0e3dI0000
00000000<`000000100mFJ/000000000000000030?m>8@L000000P0mFJ/50?ofkP0303eIZ`3om^h0
ooK^0080ooK^00<0?EV[0?ofkP3om^h04@3om^h203eIZ`030?ofkP0mFJ/0ooK^0140ooK^00<0?EV[
0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00l0ooK^00@0?EV[
0?ofkP0mFJ/0?EV[2`3om^h00`0mFJ/0ooK^0?ofkP1D0?ofkP8000000P3om^h00`000000ooK^0?of
kP090?ofkP40oooo000:0?ofkP040000003om^h0ooK^000005P0ooK^00<0e3dI0?ofkP3om^h01`3o
m^h20=@m6@<0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?ofkP040?ofkP80e3dI2P3o
m^h00`3D?AT0ooK^0?ofkP0A0?ofkP030=@m6@3om^h0ooK^01@0ooK^00D0e3dI0?ofkP3om^h0ooK^
0=@m6@030?ofkP80e3dI0`3om^h<0000000303MG/03D?AT0@FG900@0@FG9100000000`3D?AT00000
0000000M0000000303eIZ`0000000000008000001@3oCb400`0mFJ/0odhQ0000000;000000<0ooK^
0P0mFJ/30?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/05P3om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP03
03eIZ`3om^h0ooK^00P0ooK^0P0mFJ/50?ofkP0303eIZ`3om^h0ooK^0100ooK^00@0?EV[0?ofkP3o
m^h0ooK^0P0mFJ/90?ofkP0303eIZ`3om^h0ooK^05H0ooK^00@000000?ofkP3om^h000002P3om^h1
0?ooo`002P3om^h3000005X0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP040?of
kP030=@m6@3om^h0ooK^00l0ooK^00@0e3dI0?ofkP3om^h0ooK^0P3D?AT=0?ofkP030=@m6@3om^h0
ooK^00h0ooK^0P3D?AT00`3om^h0e3dI0?ofkP0E0?ofkP050=@m6@3om^h0ooK^0=@m6@3om^h00P3D
?AT40?ofkP80e3dI00@0ooK^0000000000009d682@0000020=@m6@D000000P3D?ATQ00000080?EV[
1@00000203eIZ`T0000000@0jDPM000000000000ooK^0P0mFJ/40?ofkP80?EV[00D0ooK^03eIZ`3o
m^h0ooK^03eIZ`0F0?ofkP0403eIZ`3om^h0?EV[03eIZa00ooK^00<0?EV[0?ofkP3om^h02`3om^h2
03eIZ`<0ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0
ooK^00D0ooK^00<0?EV[0?ofkP3om^h0F03om^h3000000X0ooK^0@3oool000X0ooK^0P00001K0?of
kP030=@m6@3om^h0ooK^00<0ooK^0P3D?AT70?ofkP030=@m6@3om^h0ooK^00l0ooK^00@0e3dI0?of
kP3D?AT0e3dI403om^h00`3D?AT0ooK^0?ofkP0;0?ofkP80e3dI103om^h00`3D?AT0ooK^0?ofkP0D
0?ofkP040=@m6@3om^h0e3dI0=@m6@@0ooK^0P3D?AT50?ofkPD000000`0gEk04000000030=@m6@00
000000000080e3dI0P000002045Ub@H0000000<0AfcF0000000000003@0000000`3oCB4000000000
000400000080odlQ0P00000203eIZ`80000000<0?EV[0000000000000P0000030?m>8@D000001@3o
m^h203eIZ`@0ooK^0P0mFJ/00`3om^h0?EV[0?ofkP0E0?ofkP0303eIZ`3om^h0ooK^0080ooK^0P0m
FJ/=0?ofkP0303eIZ`3om^h0ooK^00h0ooK^0`0mFJ/B0?ofkP0303eIZ`3om^h0ooK^00D0ooK^0P0m
FJ/50?ofkP0303eIZ`3om^h0ooK^05T0ooK^0P00000:0?ofkP40oooo000<0?ofkP800000F@3om^h0
103D?AT0ooK^0?ofkP3om^h20=@m6@X0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?of
kP0A0?ofkP030=@m6@3om^h0ooK^00P0ooK^0P3D?AT70?ofkP030=@m6@3om^h0ooK^01@0ooK^00<0
e3dI0?ofkP3D?AT00P3om^h20=@m6@P0ooK^00<0e3dI0000000000002@0000020=@m6@H000001011
ILT40000000304M/eP000000AfcF00@0000000H0oddQ000000000000oddQ0000003oCB44000000@0
odlQ1P00000203eIZ`/0000000<0?EV[0?ofkP3om^h01P3om^h203eIZ`80ooK^00<0?EV[0?ofkP0m
FJ/05P3om^h00`0mFJ/0ooK^0?ofkP050?ofkP80?EV[2P3om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP03
03eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h0203om^h203eIZ`<0ooK^00<0?EV[0?ofkP3o
m^h0E`3om^h2000000`0ooK^0@3oool000h0ooK^0P00001H0?ofkP<0e3dI3@3om^h00`3D?AT0ooK^
0?ofkP0<0?ofkP80e3dI00<0ooK^0=@m6@3om^h04@3om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m
6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h04@3om^h20=@m6@030?ofkP3D?AT0e3dI0080e3dI
2P3om^h00`3D?AT0ooK^0000000500000080=eN`0P3D?AT00`0gEk00e3dI0=@m6@02000000<0@FG9
1@000002045Ub@80000000<0AfcF0000000000001`0000000`3oCB400000000000020?m?8@D00000
0`3oCb4200000080?EV[00<0odhQ03eIZ`0mFJ/00P3oCR460000000303eIZ`3om^h0ooK^00T0ooK^
100mFJ/00`3om^h0?EV[03eIZ`0C0?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h0
1`3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0403eIZ`3om^h0?EV[03eIZ`h0ooK^00<0?EV[0?ofkP3o
m^h02`3om^h303eIZeP0ooK^0P00000>0?ofkP40oooo000@0?ofkP<00000E@3om^h00`3D?AT0ooK^
0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00X0ooK^0P3D?AT30?ofkP030=@m6@3om^h0ooK^0140ooK^
00<0e3dI0?ofkP3om^h0103om^h20=@m6@`0ooK^00<0e3dI0?ofkP3om^h03P3om^h20=@m6@@0ooK^
0P3D?AT<0?ofkP030=@m6@3om^h0ooK^00<0000000<09d680=@m6@3D?AT01@0000020=@m6@<00000
00<0@FG90000000000000`11ILT200000005045Ub@000000000000000017K=H00`0000001@3oCB40
0000000000000000odlQ008000000`3oCb42000000040?m?8@000000000000000080?EV[1@000002
03eIZ`040>U87@000000000000000080ooK^00<0?EV[0?ofkP3om^h02P3om^h203eIZ`@0ooK^0P0m
FJ/@0?ofkP0303eIZ`3om^h0ooK^00X0ooK^0P0mFJ/60?ofkP0303eIZ`3om^h0ooK^0140ooK^00@0
?EV[0?ofkP3om^h0ooK^0P0mFJ/<0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h0
D`3om^h300000100ooK^0@3oool001<0ooK^0P00001C0?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0
e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^0140ooK^00@0
e3dI0?ofkP3om^h0ooK^0P3D?AT?0?ofkP030=@m6@3om^h0ooK^00/0ooK^0P3D?AT60?ofkP040=@m
6@3om^h0e3dI0=@m6@X0ooK^00<0e3dI0?ofkP3om^h00P3om^h20=@m6@@000001@0gEk020=@m6@80
00000`11ILT200000080@FG90P0000000`3D?AT0000004M/eP03000000030?m=8@000000?EV[0080
00000P3oCb42000000<0odlQ0P00000203eIZ`D0odhQ1000000203eIZ`@0ooK^00<0?EV[0?ofkP3o
m^h0203om^h203eIZ`030?ofkP0mFJ/0ooK^00D0ooK^0P0mFJ/=0?ofkP0303eIZ`3om^h0ooK^00d0
ooK^0P0mFJ/30?ofkP0303eIZ`3om^h0ooK^0140ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0
ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h0DP3om^h2000001<0
ooK^0@3oool001D0ooK^0P00001B0?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h0
1@3om^h20=@m6@P0ooK^00<0e3dI0?ofkP3om^h0403om^h0103D?AT0ooK^0=@m6@3D?ATB0?ofkP03
0=@m6@3om^h0ooK^00P0ooK^0P3D?AT80?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT02@3om^h00`3D
?AT0ooK^0?ofkP040=@m6@T000000P0gEk020=@m6@<000000P11ILT200000080e3dI00<0@FG90000
000000001@0000000`3oCb40?EV[03eIZ`0200000080odlQ0`00000203eIZ`80odhQ2@00000403eI
Z`80ooK^00<0?EV[0?ofkP3om^h01`3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00P0ooK^0P0mFJ/:
0?ofkP0303eIZ`3om^h0ooK^0100ooK^0P0mFJ/00`3om^h0?EV[0?ofkP0A0?ofkP0303eIZ`3om^h0
ooK^00H0ooK^0P0mFJ/70?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h0D03om^h2
000001D0ooK^0@3oool001L0ooK^0`00001?0?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?of
kP3om^h0103om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^0140ooK^00<0e3dI0?of
kP3om^h04`3om^h00`3D?AT0ooK^0?ofkP050?ofkP80e3dI2P3om^h00`3D?AT0ooK^0?ofkP020?of
kP80e3dI1`3om^h50=@m6@@0ooK^1P00000203MG/0<000000P3D?AT00`000000@FG9000000020=@m
6@0300000011ILT000000080@FG90`0000020?m?8@030000003oCb4000000080?EV[00<000000?m?
8@0000000P0mFJ/300000080odhQ1P0000040?ofkPD0?EV[1`3om^h203eIZ`@0ooK^00<0?EV[0?of
kP3om^h0203om^h203eIZ`L0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP0A0?of
kP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0=0?of
kP0303eIZ`3om^h0ooK^04h0ooK^0`00000G0?ofkP40oooo000J0?ofkP800000CP3om^h00`3D?AT0
ooK^0?ofkP0>0?ofkP040=@m6@3om^h0ooK^0?ofkP80e3dI303om^h00`3D?AT0ooK^0?ofkP0>0?of
kP80e3dI00<0ooK^0=@m6@3om^h0503om^h00`3D?AT0ooK^0?ofkP020?ofkP80e3dI303om^h00`3D
?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00<0ooK^103D?AT80?ofkPH000001@0gEk030=@m
6@05045Ub@0mFJ/00000045Ub@0000000P11ILT300000080odlQ00D000000?m?8@000000e3dI0?m?
8@0303eIZ`D0odhQ1P0000080?ofkP@0?EV[1@3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3o
m^h0ooK^00X0ooK^0P0mFJ/40?ofkP0303eIZ`3om^h0ooK^01<0ooK^00@0?EV[0?ofkP0mFJ/0?EV[
403om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP80?EV[0`3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eI
Z`3om^h0ooK^04`0ooK^0P00000J0?ofkP40oooo000L0?ofkP800000C03om^h00`3D?AT0ooK^0?of
kP0>0?ofkP040=@m6@3om^h0e3dI0=@m6@l0ooK^00<0e3dI0?ofkP3om^h02`3om^h20=@m6@@0ooK^
00<0e3dI0?ofkP3om^h04`3om^h0103D?AT0ooK^0=@m6@3D?AT>0?ofkP030=@m6@3om^h0ooK^00D0
ooK^0P3D?AT01@3om^h0e3dI0=@m6@3om^h0e3dI00/0ooK^00@0e3dI0000000000009d680P000003
03MG/080e3dI0P0gEk030=@m6@0800000011ILT0@FG900000011ILT000000?m?8@0000020?m?8@04
0000000mFJ/0?EV[03eIZ`80odhQ0P0mFJ/30?m>8@80000000@0jDPM000000000000?EV[2`3om^h0
1@0mFJ/0ooK^03eIZ`0mFJ/0ooK^0080?EV[1`3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP80?EV[00<0
ooK^03eIZ`3om^h0503om^h00`0mFJ/0ooK^0?ofkP020?ofkP80?EV[3@3om^h00`0mFJ/0ooK^0?of
kP0=0?ofkP80?EV[00<0ooK^03eIZ`3om^h03P3om^h00`0mFJ/0ooK^0?ofkP1;0?ofkP800000703o
m^h10?ooo`007P3om^h3000004X0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0@
0?ofkP030=@m6@3om^h0ooK^00P0ooK^0P3D?AT70?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI
0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0e3dI0080e3dI2`3om^h0
0`3D?AT0ooK^0?ofkP0400000080e3dI0`0gEk020000000303MG/0000000e3dI0080e3dI00D00000
045Ub@000000odlQ0000000303eIZ`040000003oCR400000000000<0odhQ0P0mFJ/400000080ooK^
00<0?EV[0?ofkP3om^h02@3om^h303eIZ`030?ofkP0mFJ/0ooK^00L0ooK^00<0?EV[0?ofkP3om^h0
3`3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^00D0ooK^0P0mFJ/:0?ofkP0303eI
Z`3om^h0ooK^0100ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP180?ofkP<00000
7P3om^h10?ooo`008@3om^h2000004P0ooK^00<0e3dI0?ofkP3om^h0303om^h20=@m6@030?ofkP3D
?AT0ooK^0100ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3o
m^h0ooK^0100ooK^0P3D?AT00`3om^h0e3dI0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00@0ooK^1@3D
?AT00`3om^h0e3dI0?ofkP0:0?ofkP050=@m6@3om^h0ooK^0=@m6@0000000P3D?AT202M1R0<00000
0`0gEk000`000000=eN`03MG/00200000003045Ub@000000odlQ008000000P3oCR4010000000odhQ
0?m>8@3oCR4300000080jDPM0P0mFJ/00`000000?EV[0?ofkP020?ofkP0303eIZ`3om^h0ooK^00P0
ooK^00<0?EV[0?ofkP0mFJ/0100mFJ/60?ofkP0303eIZ`3om^h0ooK^00h0ooK^00@0?EV[0?ofkP0m
FJ/0?EV[4P3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?of
kP3om^h03`3om^h0100mFJ/0ooK^03eIZ`0mFJ/=0?ofkP0303eIZ`3om^h0ooK^04L0ooK^0P00000Q
0?ofkP40oooo000S0?ofkP800000A`3om^h00`3D?AT0ooK^0?ofkP090?ofkP80e3dI0`3om^h00`3D
?AT0ooK^0?ofkP0@0?ofkP030=@m6@3om^h0ooK^00@0ooK^0P3D?AT<0?ofkP030=@m6@3om^h0ooK^
00d0ooK^0P3D?AT40?ofkP80e3dI3P3om^h00`3D?AT0ooK^0?ofkP020?ofkP@0e3dI0`3om^h20=@m
6@/0ooK^1@3D?AT0103om^h0000000000000000202M1R08000000P0gEk001@000000=eN`03MG/000
0000=eN`00@000000`3oCR400`000000odhQ0?m>8@0200000080jDPM0`0000000`3om^h0?EV[03eI
Z`0203eIZ`030?ofkP0mFJ/0ooK^00T0ooK^0P0mFJ/30?ofkP@0?EV[103om^h00`0mFJ/0ooK^0?of
kP0<0?ofkP80?EV[103om^h203eIZ`l0ooK^00<0?EV[0?ofkP3om^h02P3om^h203eIZ`H0ooK^00<0
?EV[0?ofkP3om^h0403om^h0100mFJ/0ooK^0?ofkP3om^h203eIZ`/0ooK^00<0?EV[0?ofkP3om^h0
A@3om^h2000002<0ooK^0@3oool002D0ooK^0`0000140?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0
e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP0@0?ofkP040=@m6@3om^h0ooK^0?ofkP80e3dI
3`3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP80e3dI203om^h00`3D?AT0ooK^0?ofkP0;0?ofkP040=@m
6@3om^h0ooK^0?ofkP<0e3dI1@3om^h0103D?AT0ooK^0=@m6@3D?AT90?ofkP<0e3dI1P3om^h20000
00809d680P00000303MG/0040000003D?AT0e3dI00000080?EV[00@000000?m>8@3oCR40odhQ0P00
00020>U87@8000001P3om^h403eIZ`P0ooK^0P0mFJ/00`3om^h0?EV[0?ofkP040?ofkP<0?EV[0`3o
m^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00H0ooK^0P0mFJ/<0?ofkP0303eIZ`3o
m^h0ooK^00d0ooK^0P0mFJ/30?ofkP0303eIZ`3om^h0ooK^0100ooK^00<0?EV[0?ofkP3om^h0103o
m^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^04<0ooK^0`00000U0?ofkP40oooo000X
0?ofkP800000@`3om^h00`3D?AT0ooK^0?ofkP050?ofkP80e3dI203om^h00`3D?AT0ooK^0?ofkP0?
0?ofkP040=@m6@3om^h0e3dI0=@m6A80ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?of
kP090?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3D?AT00P3D?AT70?ofkP040=@m6@3o
m^h0ooK^0?ofkP80e3dI1@3om^h30=@m6@X0ooK^0`0000000`0W@HP00000000000020=@m6@80=eN`
00<000000?m>8@3oCR400P0mFJ/2000000040>U87@0000000000000000X0ooK^100mFJ/40?ofkP80
?EV[0`3om^h00`0mFJ/0ooK^0?ofkP050?ofkP<0?EV[00<0ooK^03eIZ`3om^h02`3om^h00`0mFJ/0
ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h0403om^h203eIZ`03
0?ofkP0mFJ/0ooK^0100ooK^00<0?EV[0?ofkP3om^h01P3om^h203eIZ`L0ooK^00<0?EV[0?ofkP3o
m^h0@@3om^h2000002P0ooK^0@3oool002X0ooK^0P0000110?ofkP030=@m6@3om^h0ooK^00@0ooK^
00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP0@0?ofkP030=@m6@3om^h0ooK^01<0ooK^
00<0e3dI0?ofkP3om^h01@3om^h20=@m6@d0ooK^0P3D?AT:0?ofkP<0e3dI2@3om^h00`3D?AT0ooK^
0?ofkP030?ofkP80e3dI00<0ooK^0=@m6@3D?AT00P3D?AT:0?ofkP<0e3dI0P0000020=@m6@050000
000gEk00=eN`03MG/00000000`3oCR400`000000?EV[03eIZ`02000000<0?EV[2`3om^h603eIZ`D0
ooK^00<0?EV[0?ofkP3om^h01`3om^h303eIZ`X0ooK^0P0mFJ/=0?ofkP80?EV[1`3om^h00`0mFJ/0
ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^0100ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0
ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^0400ooK^0P00000Z0?ofkP40oooo000/0?ofkP<00000
?`3om^h0103D?AT0ooK^0?ofkP3om^h20=@m6@`0ooK^00<0e3dI0?ofkP3om^h03@3om^h20=@m6@03
0?ofkP3D?AT0ooK^01@0ooK^00<0e3dI0?ofkP3om^h00P3om^h20=@m6A40ooK^00<0e3dI0?ofkP3o
m^h01P3om^h20=@m6@/0ooK^00<0e3dI0?ofkP3om^h0103om^h40=@m6@030?ofkP3D?AT0ooK^00T0
ooK^00<0e3dI0?ofkP3om^h00P3D?AT00`000000?EV[000000020000000303MG/0000000odhQ00<0
000000@0e3dI0000000mFJ/0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP090?ofkPH0?EV[1@3om^h00`0m
FJ/0ooK^0?ofkP090?ofkP80?EV[203om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP80?EV[103om^h00`0m
FJ/0ooK^0?ofkP0C0?ofkP0403eIZ`3om^h0?EV[03eIZ`l0ooK^00<0?EV[0?ofkP3om^h02P3om^h2
03eIZ`<0ooK^00<0?EV[0?ofkP3om^h0?@3om^h3000002`0ooK^0@3oool002l0ooK^0P00000m0?of
kP040=@m6@3om^h0e3dI0=@m6@l0ooK^00<0e3dI0?ofkP3om^h02P3om^h20=@m6@@0ooK^00<0e3dI
0?ofkP3om^h04`3om^h0103D?AT0ooK^0=@m6@3D?ATD0?ofkP030=@m6@3om^h0ooK^00<0ooK^0P3D
?AT00`3om^h0e3dI0?ofkP0:0?ofkP030=@m6@3om^h0ooK^0080ooK^103D?AT20?ofkP@0e3dI1P3o
m^h20=@m6@030?ofkP3D?AT0e3dI00@0ooK^00<0000002M1R00W@HP00`0000020>U87@030000003o
m^h0ooK^0080ooK^0P0mFJ/00`3om^h0?EV[03eIZ`060?ofkP@0?EV[0P3om^h203eIZ`030?ofkP0m
FJ/0?EV[00<0ooK^00<0?EV[0?ofkP3om^h02@3om^h0100mFJ/0ooK^03eIZ`0mFJ/50?ofkP0303eI
Z`3om^h0ooK^0180ooK^0P0mFJ/00`3om^h0?EV[0?ofkP0D0?ofkP0303eIZ`3om^h0ooK^0080ooK^
0P0mFJ/<0?ofkP0303eIZ`3om^h0ooK^00d0ooK^0`0mFJ/n0?ofkP800000;`3om^h10?ooo`00<@3o
m^h3000003/0ooK^00<0e3dI0?ofkP3om^h0403om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3o
m^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP0E0?ofkP80e3dI00<0
ooK^0=@m6@3D?AT00`3om^h00`3D?AT0ooK^0?ofkP080?ofkP040=@m6@3om^h0ooK^0?ofkP@0e3dI
103om^h0103D?AT0ooK^0?ofkP3om^h90=@m6@D0ooK^1@3D?AT00`000000?EV[03eIZ`0303eIZ`D0
ooK^0P0mFJ/00`3om^h0?EV[03eIZ`0403eIZ`<0ooK^00<0?EV[0?ofkP3om^h00P3om^h203eIZ`03
0?ofkP0mFJ/0?EV[0080ooK^00<0?EV[0?ofkP3om^h0203om^h0100mFJ/0ooK^0?ofkP3om^h203eI
Z`030?ofkP0mFJ/0?EV[01L0ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP050?of
kP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h0403om^h00`0mFJ/0ooK^0?ofkP0i0?of
kP<00000<@3om^h10?ooo`00=03om^h2000003X0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0
ooK^0?ofkP060?ofkP80e3dI2@3om^h00`3D?AT0ooK^0?ofkP0@0?ofkP80e3dI00<0ooK^0=@m6@3D
?AT05P3om^h30=@m6@@0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0=@m6@030=@m6@H0
ooK^00<0e3dI0?ofkP3om^h00`3om^h@0=@m6@<00000400mFJ/60?ofkP0303eIZ`3om^h0ooK^00<0
ooK^0P0mFJ/0103om^h0?EV[03eIZ`0mFJ/:0?ofkP0303eIZ`3om^h0ooK^0080ooK^0`0mFJ/F0?of
kP80?EV[00<0ooK^03eIZ`0mFJ/04P3om^h00`0mFJ/0ooK^0?ofkP070?ofkP80?EV[203om^h00`0m
FJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^03P0ooK^0P00000d0?ofkP40oooo000f0?ofkP80
0000>03om^h00`3D?AT0ooK^0?ofkP0@0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3o
m^h02P3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP80e3dI1@3om^h00`3D?AT0ooK^0?ofkP0A0?ofkP80
e3dI0`3om^h20=@m6@80ooK^00<0e3dI0?ofkP3om^h0203om^h40=@m6@L0ooK^00<0e3dI0?ofkP3o
m^h00P3om^h20=@m6@040?ofkP3D?AT0e3dI0=@m6@@0ooK^1`3D?AT20?ofkP030000003om^h0ooK^
00L0?EV[103om^h303eIZ`030?ofkP0mFJ/0?EV[00@0ooK^00<0?EV[0?ofkP3om^h01@3om^h203eI
Z`030?ofkP0mFJ/0ooK^00T0ooK^00<0?EV[0?ofkP3om^h00P0mFJ/30?ofkP80?EV[4`3om^h00`0m
FJ/0ooK^0?ofkP030?ofkP80?EV[3`3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^
00@0ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP0g0?ofkP800000=P3om^h10?oo
o`00>03om^h3000003H0ooK^00<0e3dI0?ofkP3om^h0403om^h0103D?AT0ooK^0?ofkP3om^h20=@m
6@h0ooK^00<0e3dI0?ofkP3om^h02P3om^h20=@m6@P0ooK^00<0e3dI0?ofkP3om^h03P3om^h20=@m
6@L0ooK^0`3D?AT80?ofkP@0e3dI2@3om^h00`3D?AT0ooK^0?ofkP020=@m6@050?ofkP3D?AT0e3dI
0?ofkP3D?AT00`3om^h20=@m6@030?ofkP3D?AT0e3dI0080e3dI103om^h00`000000ooK^0?ofkP02
0?ofkP@0?EV[00<0ooK^03eIZ`0mFJ/00`3om^h01@0mFJ/0ooK^03eIZ`0mFJ/0ooK^0080?EV[0P3o
m^h00`0mFJ/0ooK^0?ofkP070?ofkP@0?EV[203om^h303eIZ`L0ooK^0P0mFJ/@0?ofkP0303eIZ`3o
m^h0ooK^00H0ooK^0P0mFJ/<0?ofkP0303eIZ`3om^h0ooK^00`0ooK^0P0mFJ/30?ofkP0303eIZ`3o
m^h0ooK^0100ooK^00<0?EV[0?ofkP3om^h0=03om^h3000003P0ooK^0@3oool003/0ooK^0P00000e
0?ofkP030=@m6@3om^h0ooK^00l0ooK^00@0e3dI0?ofkP3D?AT0e3dI4@3om^h00`3D?AT0ooK^0?of
kP080?ofkP030=@m6@3om^h0ooK^00T0ooK^0P3D?AT<0?ofkP80e3dI2P3om^h40=@m6@@0ooK^103D
?AT:0?ofkP050=@m6@3om^h0e3dI0=@m6@3om^h00P3D?AT20?ofkP030=@m6@3om^h0ooK^0080e3dI
00<0ooK^0=@m6@3D?AT00P3D?AT60?ofkP030000003om^h0ooK^00@0ooK^100mFJ/01@3om^h0?EV[
03eIZ`3om^h0?EV[00<0ooK^0P0mFJ/01@3om^h0?EV[03eIZ`3om^h0?EV[00X0ooK^100mFJ/40?of
kP@0?EV[2P3om^h203eIZ``0ooK^0P0mFJ/;0?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?of
kP3om^h03`3om^h203eIZ`030?ofkP0mFJ/0ooK^0100ooK^00<0?EV[0?ofkP3om^h0<`3om^h20000
03/0ooK^0@3oool003d0ooK^0P00000d0?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3o
m^h04P3om^h00`3D?AT0ooK^0?ofkP050?ofkP80e3dI3P3om^h00`3D?AT0ooK^0?ofkP070?ofkP80
e3dI303om^h0103D?AT0ooK^0?ofkP3om^h20=@m6@060?ofkP3D?AT0e3dI0=@m6@3om^h0e3dI2P3o
m^h20=@m6@030?ofkP3D?AT0e3dI00@0ooK^0`3D?AT00`3om^h0e3dI0=@m6@020=@m6@P0ooK^00<0
00000?ofkP3om^h01P3om^h403eIZ`040?ofkP0mFJ/0?EV[03eIZ`@0ooK^0P0mFJ/00`3om^h0?EV[
03eIZ`0:0?ofkP0303eIZ`3om^h0?EV[0080?EV[00<0ooK^03eIZ`0mFJ/00`3om^h00`0mFJ/0ooK^
0?ofkP0:0?ofkP80?EV[2@3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP80?EV[1`3om^h00`0mFJ/0ooK^
0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h0<P3om^h2000003d0ooK^
0@3oool003l0ooK^0`00000a0?ofkP030=@m6@3om^h0ooK^00d0ooK^0P3D?AT00`3om^h0e3dI0?of
kP0C0?ofkP030=@m6@3om^h0ooK^0080ooK^0P3D?ATA0?ofkP030=@m6@3om^h0ooK^00@0ooK^0P3D
?AT>0?ofkP030=@m6@3om^h0ooK^0080ooK^103D?AT20?ofkP030=@m6@3om^h0ooK^00H0ooK^0P3D
?AT00`3om^h0e3dI0=@m6@050?ofkP80e3dI00<0ooK^0=@m6@3D?AT00P3D?AT:0?ofkP030000003o
m^h0ooK^00P0ooK^100mFJ/00`3om^h0?EV[03eIZ`050?ofkP80?EV[00<0ooK^03eIZ`0mFJ/0203o
m^h00`0mFJ/0ooK^0?ofkP0403eIZ`@0ooK^00<0?EV[0?ofkP3om^h0303om^h203eIZ`H0ooK^00<0
?EV[0?ofkP3om^h03`3om^h203eIZ`@0ooK^00<0?EV[0?ofkP3om^h04P3om^h0100mFJ/0ooK^03eI
Z`0mFJ/>0?ofkP0303eIZ`3om^h0ooK^0300ooK^0`00000o0?ofkP40oooo00120?ofkP800000<03o
m^h00`3D?AT0ooK^0?ofkP0:0?ofkP80e3dI103om^h00`3D?AT0ooK^0?ofkP0B0?ofkP040=@m6@3o
m^h0e3dI0=@m6A@0ooK^0P3D?AT20?ofkP80e3dI403om^h00`3D?AT0ooK^0?ofkP040=@m6@80ooK^
103D?AT50?ofkP80e3dI00<0ooK^0=@m6@3D?AT01@3om^h20=@m6@030?ofkP3D?AT0e3dI0080e3dI
303om^h00`000000ooK^0?ofkP0:0?ofkP@0?EV[00<0ooK^03eIZ`0mFJ/01@3om^h203eIZ`030?of
kP0mFJ/0?EV[00D0ooK^100mFJ/20?ofkP@0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP80?EV[
0P3om^h203eIZa@0ooK^0P0mFJ/00`3om^h0?EV[0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^0080ooK^
0P0mFJ/<0?ofkP0303eIZ`3om^h0ooK^02h0ooK^0P0000120?ofkP40oooo00140?ofkP800000;`3o
m^h00`3D?AT0ooK^0?ofkP070?ofkP80e3dI1`3om^h00`3D?AT0ooK^0?ofkP0B0?ofkP030=@m6@3o
m^h0ooK^01H0ooK^0P3D?ATB0?ofkPD0e3dI1@3om^h00`3D?AT0ooK^0?ofkP050=@m6@030?ofkP3D
?AT0e3dI00D0ooK^1`3D?AT>0?ofkP030000003om^h0ooK^00`0ooK^1`0mFJ/50?ofkP80?EV[00<0
ooK^03eIZ`0mFJ/00`0mFJ/20?ofkP0303eIZ`3om^h0ooK^00<0ooK^1@0mFJ/B0?ofkP80?EV[603o
m^h00`0mFJ/0ooK^0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^00D0ooK^0P0mFJ/90?ofkP0303eIZ`3o
m^h0ooK^02d0ooK^0P0000140?ofkP40oooo00160?ofkP<00000;@3om^h00`3D?AT0ooK^0?ofkP04
0?ofkP80e3dI2P3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP80e3dI00<0ooK^0=@m6@3D?AT0503om^h2
0=@m6@030?ofkP3D?AT0e3dI0140ooK^0`3D?AT70?ofkP040=@m6@3om^h0ooK^0?ofkP80e3dI00<0
ooK^0=@m6@3D?AT0303D?AT@0?ofkP030000003om^h0ooK^00h0ooK^3P0mFJ/00`3om^h0?EV[03eI
Z`030?ofkP0303eIZ`3om^h0ooK^00D0ooK^0`0mFJ/A0?ofkP80?EV[00<0ooK^03eIZ`0mFJ/0503o
m^h203eIZ`030?ofkP0mFJ/0?EV[0140ooK^00<0?EV[0?ofkP3om^h0203om^h203eIZ`H0ooK^00<0
?EV[0?ofkP3om^h0:`3om^h3000004H0ooK^0@3oool004T0ooK^0P00000[0?ofkP030=@m6@3om^h0
ooK^0080ooK^0P3D?AT=0?ofkP030=@m6@3om^h0ooK^00`0ooK^0P3D?AT50?ofkP030=@m6@3om^h0
ooK^00l0ooK^0P3D?AT50?ofkP80e3dI3P3om^h20=@m6@T0ooK^00@0e3dI0?ofkP3D?AT0e3dI0P3o
m^h20=@m6@030?ofkP3D?AT0ooK^0080ooK^1P3D?ATB0?ofkP030000003om^h0ooK^0100ooK^1P0m
FJ/30?ofkP0403eIZ`3om^h0?EV[03eIZ`80ooK^0P0mFJ/00`3om^h0?EV[0?ofkP080?ofkP80?EV[
3P3om^h203eIZ`D0ooK^0P0mFJ/A0?ofkP0303eIZ`3om^h0ooK^00<0ooK^0P0mFJ/>0?ofkP0303eI
Z`3om^h0ooK^00/0ooK^0P0mFJ/30?ofkP0303eIZ`3om^h0ooK^02X0ooK^0P0000190?ofkP40oooo
001;0?ofkP800000:P3om^h0103D?AT0ooK^0=@m6@3D?AT@0?ofkP030=@m6@3om^h0ooK^00T0ooK^
0P3D?AT80?ofkP030=@m6@3om^h0ooK^00`0ooK^0P3D?AT90?ofkP80e3dI2P3om^h30=@m6@T0ooK^
0`3D?AT20?ofkP80e3dI0`3om^h01@3D?AT0ooK^0?ofkP3D?AT0ooK^00<0e3dI503om^h00`000000
ooK^0?ofkP0B0?ofkP<0?EV[00D0ooK^03eIZ`3om^h0ooK^03eIZ`030?ofkP80?EV[0P3om^h303eI
Z`T0ooK^0`0mFJ/:0?ofkP80?EV[2@3om^h203eIZ`h0ooK^00<0?EV[0?ofkP3om^h01P3om^h203eI
Z`/0ooK^00<0?EV[0?ofkP3om^h03P3om^h203eIZ`030?ofkP0mFJ/0ooK^02T0ooK^0P00001;0?of
kP40oooo001=0?ofkP<00000:03om^h00`3D?AT0ooK^0?ofkP0A0?ofkP030=@m6@3om^h0ooK^00H0
ooK^0P3D?AT;0?ofkP80e3dI2`3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP80e3dI1P3om^h20=@m6@80
ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP020=@m6@@0ooK^00<0e3dI0?ofkP3D
?AT0103D?ATF0?ofkP030000003om^h0ooK^01@0ooK^1@0mFJ/00`3om^h0?EV[0?ofkP030?ofkP80
?EV[0P3om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^0080?EV[1P3om^h203eIZ`d0
ooK^00<0?EV[0?ofkP3om^h02@3om^h203eIZ`/0ooK^0P0mFJ/80?ofkP0303eIZ`3om^h0ooK^0140
ooK^00<0?EV[0?ofkP3om^h09P3om^h3000004d0ooK^0@3oool00500ooK^0P00000W0?ofkP030=@m
6@3om^h0ooK^0140ooK^00<0e3dI0?ofkP3om^h00`3om^h20=@m6@l0ooK^00<0e3dI0?ofkP3om^h0
1P3om^h20=@m6A00ooK^0P3D?AT20?ofkP80e3dI0`3om^h00`3D?AT0ooK^0?ofkP060?ofkP80e3dI
00<0ooK^0=@m6@3D?AT01P3om^h50=@m6AP0ooK^00<000000?ofkP3om^h05P3om^h503eIZ`H0ooK^
0P0mFJ/00`3om^h0?EV[03eIZ`080?ofkP0403eIZ`3om^h0ooK^0?ofkP80?EV[0P3om^h203eIZa00
ooK^0P0mFJ/80?ofkP0303eIZ`3om^h0ooK^00d0ooK^0P0mFJ/50?ofkP0303eIZ`3om^h0ooK^0140
ooK^00<0?EV[0?ofkP3om^h09@3om^h200000500ooK^0@3oool00580ooK^0P00000V0?ofkP030=@m
6@3om^h0ooK^0140ooK^00<0e3dI0?ofkP3om^h00P3D?ATB0?ofkP030=@m6@3om^h0ooK^00<0ooK^
0P3D?ATD0?ofkP@0e3dI0`3om^h00`3D?AT0ooK^0?ofkP040?ofkPD0e3dI1P3om^h50=@m6AX0ooK^
00<000000?ofkP3om^h0603om^h503eIZ`H0ooK^0P0mFJ/00`3om^h0?EV[03eIZ`060?ofkP0403eI
Z`3om^h0ooK^0?ofkP@0?EV[503om^h203eIZ`D0ooK^00<0?EV[0?ofkP3om^h0403om^h203eIZ`80
ooK^00<0?EV[0?ofkP3om^h04@3om^h00`0mFJ/0ooK^0?ofkP0T0?ofkP800000DP3om^h10?ooo`00
E03om^h3000002@0ooK^00<0e3dI0?ofkP3om^h04@3om^h20=@m6AD0ooK^0P3D?AT00`3om^h0e3dI
0=@m6@0E0?ofkP80e3dI0`3om^h60=@m6@80ooK^0P3D?AT00`3om^h0e3dI0=@m6@060?ofkPD0e3dI
703om^h00`000000ooK^0?ofkP0J0?ofkPD0?EV[1P3om^h203eIZ`030?ofkP0mFJ/0?EV[0080ooK^
1P0mFJ/30?ofkP80?EV[5@3om^h203eIZ`030?ofkP0mFJ/0?EV[01D0ooK^0P0mFJ/C0?ofkP0303eI
Z`3om^h0ooK^0280ooK^0`00001D0?ofkP40oooo001G0?ofkP8000008`3om^h00`3D?AT0ooK^0?of
kP0>0?ofkP80e3dI00<0ooK^0=@m6@3D?AT05P3om^h20=@m6A@0ooK^0P3D?AT70?ofkP040=@m6@3o
m^h0ooK^0?ofkQ00e3dI7P3om^h00`000000ooK^0?ofkP0L0?ofkQ00?EV[0`3om^h00`0mFJ/0ooK^
0?ofkP050?ofkP80?EV[503om^h203eIZaH0ooK^0P0mFJ/00`3om^h0?EV[03eIZ`0@0?ofkP0303eI
Z`3om^h0ooK^0240ooK^0P00001G0?ofkP40oooo001I0?ofkP8000008P3om^h00`3D?AT0ooK^0?of
kP0;0?ofkP80e3dI1@3om^h00`3D?AT0ooK^0?ofkP0A0?ofkP80e3dI0P3om^h20=@m6A00ooK^0P3D
?AT90?ofkP050=@m6@3om^h0e3dI0=@m6@3om^h00P3D?AT00`3om^h0e3dI0?ofkP020?ofkPL0e3dI
7`3om^h00`000000ooK^0?ofkP0M0?ofkPL0?EV[0`3om^h01@0mFJ/0ooK^03eIZ`0mFJ/0ooK^0080
?EV[00<0ooK^03eIZ`3om^h0203om^h203eIZa00ooK^0P0mFJ/20?ofkP80?EV[4`3om^h00`0mFJ/0
ooK^0?ofkP030?ofkP80?EV[3@3om^h00`0mFJ/0ooK^0?ofkP0P0?ofkP800000F@3om^h10?ooo`00
F`3om^h3000001l0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP060?ofkP80e3dI
3`3om^h20=@m6@H0ooK^0P3D?AT<0?ofkP80e3dI2P3om^h30=@m6@030?ofkP3D?AT0e3dI0080ooK^
00<0e3dI0?ofkP3om^h00P3D?AT00`3om^h0e3dI0=@m6@020=@m6B40ooK^00<000000?ofkP3om^h0
7`3om^h403eIZ`050?ofkP0mFJ/0?EV[0?ofkP0mFJ/00`3om^h203eIZ`040?ofkP0mFJ/0?EV[03eI
Z`X0ooK^0P0mFJ/<0?ofkP80?EV[1P3om^h203eIZ`l0ooK^0P0mFJ/80?ofkP0303eIZ`3om^h0ooK^
00X0ooK^00<0?EV[0?ofkP3om^h07@3om^h3000005/0ooK^0@3oool005h0ooK^0P00000N0?ofkP03
0=@m6@3om^h0ooK^00L0ooK^0P3D?AT;0?ofkP030=@m6@3om^h0ooK^00X0ooK^0P3D?AT:0?ofkP<0
e3dI1`3om^h20=@m6@`0ooK^00@0e3dI0?ofkP3D?AT0e3dI103om^h30=@m6@030?ofkP3D?AT0e3dI
0080e3dI8`3om^h00`000000ooK^0?ofkP0Q0?ofkP@0?EV[00@0ooK^03eIZ`0mFJ/0?EV[103om^h2
03eIZ`030?ofkP0mFJ/0ooK^00/0ooK^0P0mFJ/70?ofkP<0?EV[2P3om^h203eIZ``0ooK^00<0?EV[
0?ofkP3om^h02@3om^h203eIZ`T0ooK^00<0?EV[0?ofkP3om^h0703om^h2000005h0ooK^0@3oool0
0600ooK^0P00000M0?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h0303om^h20=@m
6@P0ooK^0P3D?AT?0?ofkP80e3dI0`3om^h20=@m6@d0ooK^00<0e3dI0?ofkP3D?AT01@3om^h20=@m
6@030?ofkP3D?AT0e3dI0080e3dI9@3om^h00`000000ooK^0?ofkP0S0?ofkP@0?EV[00<0ooK^03eI
Z`0mFJ/01@3om^h00`0mFJ/0ooK^03eIZ`0=0?ofkP80?EV[0`3om^h203eIZ`l0ooK^0P0mFJ/80?of
kP80?EV[3P3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^01/0ooK^0P00001P0?of
kP40oooo001R0?ofkP<000006`3om^h00`3D?AT0ooK^0?ofkP020?ofkP80e3dI4@3om^h00`3D?AT0
ooK^0?ofkP030?ofkP80e3dI4`3om^h30=@m6@h0ooK^0`3D?AT40?ofkP80e3dI00<0ooK^0=@m6@3D
?AT00`3D?ATV0?ofkP030000003om^h0ooK^02@0ooK^1@0mFJ/00`3om^h0?EV[03eIZ`040?ofkP80
?EV[3`3om^h303eIZa<0ooK^0P0mFJ/50?ofkP0303eIZ`3om^h0ooK^00l0ooK^0P0mFJ/40?ofkP03
03eIZ`3om^h0ooK^01T0ooK^0`00001R0?ofkP40oooo001U0?ofkP8000006P3om^h0103D?AT0ooK^
0=@m6@3D?ATD0?ofkP80e3dI00<0ooK^0=@m6@3D?AT0503om^h20=@m6@80ooK^103D?AT90?ofkP80
e3dI103om^h80=@m6BP0ooK^00<000000?ofkP3om^h09P3om^h803eIZ`@0ooK^0P0mFJ/90?ofkP@0
?EV[0P3om^h203eIZa@0ooK^0P0mFJ/00`3om^h0?EV[03eIZ`0D0?ofkP80?EV[00<0ooK^03eIZ`3o
m^h06@3om^h2000006D0ooK^0@3oool006L0ooK^0P00000I0?ofkP030=@m6@3om^h0ooK^01H0ooK^
00<0e3dI0?ofkP3om^h04P3om^h20=@m6@P0ooK^103D?AT30?ofkP<0e3dI0P3om^h60=@m6@030?of
kP3D?AT0e3dI02X0ooK^00<000000?ofkP3om^h0:03om^h203eIZ`030?ofkP0mFJ/0?EV[00@0?EV[
0P3om^h303eIZ`<0ooK^100mFJ/80?ofkP80?EV[503om^h00`0mFJ/0ooK^0?ofkP0F0?ofkP0303eI
Z`3om^h0ooK^01L0ooK^0P00001W0?ofkP40oooo001Y0?ofkP<000005`3om^h20=@m6A@0ooK^0P3D
?AT00`3om^h0e3dI0=@m6@0@0?ofkP80e3dI3P3om^h90=@m6@040?ofkP3D?AT0e3dI0?ofkP80e3dI
;03om^h00`000000ooK^0?ofkP0Z0?ofkP80?EV[00@0ooK^03eIZ`0mFJ/0ooK^2@0mFJ/>0?ofkP80
?EV[403om^h203eIZ`030?ofkP0mFJ/0?EV[01@0ooK^0P0mFJ/G0?ofkP<00000J@3om^h10?ooo`00
K03om^h2000001L0ooK^0P3D?AT@0?ofkP80e3dI1@3om^h20=@m6@d0ooK^00<0e3dI0?ofkP3om^h0
3P3om^h20=@m6@030?ofkP3D?AT0ooK^0080e3dI00<0ooK^0=@m6@3D?AT00`3D?AT^0?ofkP030000
003om^h0ooK^02`0ooK^1@0mFJ/0103om^h0?EV[03eIZ`0mFJ/20?ofkP80?EV[403om^h00`0mFJ/0
ooK^0?ofkP0;0?ofkP80?EV[1@3om^h203eIZa00ooK^0P0mFJ/G0?ofkP800000K03om^h10?ooo`00
KP3om^h2000001L0ooK^00<0e3dI0?ofkP3om^h02`3om^h20=@m6@T0ooK^0P3D?AT90?ofkP80e3dI
3`3om^h20=@m6@<0ooK^0P3D?AT0103om^h0e3dI0=@m6@3om^h20=@m6C00ooK^00<000000?ofkP3o
m^h0;P3om^h203eIZ`040?ofkP0mFJ/0?EV[0?ofkP80?EV[0`3om^h203eIZ`l0ooK^0P0mFJ/90?of
kP80?EV[2@3om^h203eIZ`d0ooK^00<0?EV[0?ofkP3om^h05@3om^h2000006h0ooK^0@3oool00700
ooK^0`00000E0?ofkP80e3dI2@3om^h20=@m6@d0ooK^0P3D?AT50?ofkP80e3dI3`3om^h20=@m6@@0
ooK^00D0e3dI0?ofkP3D?AT0e3dI0?ofkP020=@m6C80ooK^00<000000?ofkP3om^h0<03om^h203eI
Z`050?ofkP0mFJ/0?EV[0?ofkP0mFJ/0103om^h203eIZ`l0ooK^0P0mFJ/50?ofkP80?EV[3@3om^h2
03eIZ`T0ooK^0P0mFJ/E0?ofkP<00000L03om^h10?ooo`00L`3om^h2000001D0ooK^0P3D?AT50?of
kP80e3dI4@3om^h20=@m6@030?ofkP3D?AT0e3dI00l0ooK^0P3D?AT50?ofkPH0e3dI=03om^h00`00
0000ooK^0?ofkP0b0?ofkPH0?EV[1@3om^h203eIZ`l0ooK^0P0mFJ/00`3om^h0?EV[03eIZ`0A0?of
kP80?EV[1@3om^h203eIZaD0ooK^0P00001c0?ofkP40oooo001e0?ofkP8000005@3om^h20=@m6@03
0?ofkP3D?AT0e3dI01D0ooK^0`3D?AT=0?ofkP80e3dI1P3om^h50=@m6CH0ooK^00<000000?ofkP3o
m^h0=03om^h503eIZ`H0ooK^0P0mFJ/=0?ofkP<0?EV[5@3om^h203eIZ`030?ofkP0mFJ/0?EV[01D0
ooK^0P00001e0?ofkP40oooo001g0?ofkP<00000503om^h00`3D?AT0ooK^0?ofkP0C0?ofkP80e3dI
0`3om^h60=@m6@D0ooK^0P3D?AT20?ofkPH0e3dI00<0ooK^0=@m6@3D?AT0>03om^h00`000000ooK^
0?ofkP0f0?ofkP80?EV[00<0ooK^03eIZ`0mFJ/0100mFJ/20?ofkP80?EV[1@3om^h603eIZ`<0ooK^
0P0mFJ/E0?ofkP0303eIZ`3om^h0ooK^0180ooK^0`00001g0?ofkP40oooo001j0?ofkP8000004`3o
m^h20=@m6A40ooK^0P3D?AT;0?ofkPT0e3dI0P3om^h20=@m6@030?ofkP3D?AT0e3dI03X0ooK^00<0
00000?ofkP3om^h0>03om^h203eIZ`030?ofkP0mFJ/0?EV[0080ooK^2@0mFJ/;0?ofkP80?EV[4@3o
m^h203eIZa<0ooK^0P00001j0?ofkP40oooo001l0?ofkP8000004`3om^h20=@m6@d0ooK^0P3D?AT>
0?ofkP80e3dI1P3om^h50=@m6C`0ooK^00<000000?ofkP3om^h0>P3om^h503eIZ`H0ooK^0P0mFJ/>
0?ofkP80?EV[3@3om^h203eIZa<0ooK^0P00001l0?ofkP40oooo001n0?ofkP<000004P3om^h20=@m
6@T0ooK^0P3D?AT>0?ofkP80e3dI1P3om^h50=@m6Ch0ooK^00<000000?ofkP3om^h0?03om^h503eI
Z`H0ooK^0P0mFJ/>0?ofkP80?EV[2@3om^h203eIZa80ooK^0`00001n0?ofkP40oooo00210?ofkP80
00004P3om^h20=@m6@D0ooK^0P3D?AT>0?ofkP80e3dI1P3om^h40=@m6D40ooK^00<000000?ofkP3o
m^h0?`3om^h403eIZ`H0ooK^0P0mFJ/>0?ofkP80?EV[1@3om^h203eIZa80ooK^0P0000210?ofkP40
oooo00230?ofkP<000004@3om^h20=@m6@030?ofkP3D?AT0e3dI00h0ooK^0P3D?AT60?ofkP@0e3dI
@`3om^h00`000000ooK^0?ofkP110?ofkP@0?EV[1P3om^h203eIZ`h0ooK^0P0mFJ/00`3om^h0?EV[
03eIZ`0A0?ofkP<00000P`3om^h10?ooo`00QP3om^h200000140ooK^0`3D?AT<0?ofkP80e3dI1P3o
m^h30=@m6DH0ooK^00<000000?ofkP3om^h0A03om^h303eIZ`H0ooK^0P0mFJ/<0?ofkP<0?EV[4@3o
m^h2000008H0ooK^0@3oool008P0ooK^0P00000B0?ofkPH0e3dI103om^h20=@m6@<0ooK^1P3D?AU8
0?ofkP030000003om^h0ooK^04H0ooK^1P0mFJ/30?ofkP80?EV[103om^h603eIZa80ooK^0P000028
0?ofkP40oooo002:0?ofkP<000005@3om^h90=@m6Dh0ooK^00<000000?ofkP3om^h0C03om^h903eI
ZaD0ooK^0`00002:0?ofkP40oooo002=0?ofkP800000JP3om^h00`000000ooK^0?ofkP1X0?ofkP80
0000S@3om^h10?ooo`00S`3om^h2000006P0ooK^00<000000?ofkP3om^h0IP3om^h2000008l0ooK^
0@3oool00940ooK^0`00001U0?ofkP030000003om^h0ooK^06<0ooK^0`00002A0?ofkP40oooo002D
0?ofkP800000H`3om^h00`000000ooK^0?ofkP1Q0?ofkP800000U03om^h10?ooo`00UP3om^h20000
0640ooK^00<000000?ofkP3om^h0G`3om^h2000009H0ooK^0@3oool009P0ooK^0`00001N0?ofkP03
0000003om^h0ooK^05`0ooK^0`00002H0?ofkP40oooo002K0?ofkP800000G03om^h00`000000ooK^
0?ofkP1J0?ofkP800000V`3om^h10?ooo`00W@3om^h2000005X0ooK^00<000000?ofkP3om^h0F03o
m^h2000009d0ooK^0@3oool009l0ooK^0`00001G0?ofkP030000003om^h0ooK^05D0ooK^0`00002O
0?ofkP40oooo002R0?ofkP800000E@3om^h00`000000ooK^0?ofkP1C0?ofkP800000XP3om^h10?oo
o`00Y03om^h2000005<0ooK^00<000000?ofkP3om^h0D@3om^h200000:@0ooK^0@3oool00:H0ooK^
0`00001@0?ofkP030000003om^h0ooK^04h0ooK^0`00002V0?ofkP40oooo002Y0?ofkP800000CP3o
m^h00`000000ooK^0?ofkP1<0?ofkP800000Z@3om^h10?ooo`00Z`3om^h2000004`0ooK^00<00000
0?ofkP3om^h0BP3om^h200000:/0ooK^0@3oool00:d0ooK^0`0000190?ofkP030000003om^h0ooK^
04L0ooK^0`00002]0?ofkP40oooo002`0?ofkP800000A`3om^h00`000000ooK^0?ofkP150?ofkP80
0000/03om^h10?ooo`00/P3om^h2000004D0ooK^00<000000?ofkP3om^h0@`3om^h200000;80ooK^
0@3oool00;@0ooK^0`0000120?ofkP030000003om^h0ooK^0400ooK^0`00002d0?ofkP40oooo002g
0?ofkP800000@03om^h00`000000ooK^0?ofkP0n0?ofkP800000]`3om^h10?ooo`00^@3om^h20000
03h0ooK^00<000000?ofkP3om^h0?03om^h200000;T0ooK^0@3oool00;/0ooK^0`00000k0?ofkP03
0000003om^h0ooK^03T0ooK^0`00002k0?ofkP40oooo002n0?ofkP800000>@3om^h00`000000ooK^
0?ofkP0g0?ofkP800000_P3om^h10?ooo`00`03om^h2000003L0ooK^00<000000?ofkP3om^h0=@3o
m^h200000<00ooK^0@3oool00<80ooK^0`00000d0?ofkP030000003om^h0ooK^0380ooK^0`000032
0?ofkP40oooo00350?ofkP800000<P3om^h00`000000ooK^0?ofkP0`0?ofkP800000a@3om^h10?oo
o`00a`3om^h200000300ooK^00<000000?ofkP3om^h0;P3om^h200000<L0ooK^0@3oool00<T0ooK^
0`00000]0?ofkP030000003om^h0ooK^02/0ooK^0`0000390?ofkP40oooo003<0?ofkP800000:`3o
m^h00`000000ooK^0?ofkP0Y0?ofkP800000c03om^h10?ooo`00cP3om^h2000002T0ooK^00<00000
0?ofkP3om^h09`3om^h200000<h0ooK^0@3oool00=00ooK^0`00000V0?ofkP030000003om^h0ooK^
02@0ooK^0`00003@0?ofkP40oooo003C0?ofkP800000903om^h00`000000ooK^0?ofkP0R0?ofkP80
0000d`3om^h10?ooo`00e@3om^h300000240ooK^00<000000?ofkP3om^h07`3om^h300000=D0ooK^
0@3oool00=P0ooK^0P00000O0?ofkP030000003om^h0ooK^01d0ooK^0P00003H0?ofkP40oooo003J
0?ofkP8000007@3om^h00`000000ooK^0?ofkP0K0?ofkP800000fP3om^h10?ooo`00g03om^h30000
01X0ooK^00<000000?ofkP3om^h0603om^h300000=`0ooK^0@3oool00=l0ooK^0P00000H0?ofkP03
0000003om^h0ooK^01H0ooK^0P00003O0?ofkP40oooo003Q0?ofkP8000005P3om^h00`000000ooK^
0?ofkP0D0?ofkP800000h@3om^h10?ooo`00h`3om^h3000001<0ooK^00<000000?ofkP3om^h04@3o
m^h300000><0ooK^0@3oool00>H0ooK^0P00000A0?ofkP030000003om^h0ooK^00l0ooK^0P00003V
0?ofkP40oooo003X0?ofkP8000003`3om^h00`000000ooK^0?ofkP0=0?ofkP800000j03om^h10?oo
o`00jP3om^h3000000`0ooK^00<000000?ofkP3om^h02P3om^h300000>X0ooK^0@3oool00>d0ooK^
0P00000:0?ofkP030000003om^h0ooK^00P0ooK^0P00003]0?ofkP40oooo003_0?ofkP800000203o
m^h00`000000ooK^0?ofkP060?ofkP800000k`3om^h10?ooo`00l@3om^h3000000D0ooK^00<00000
0?ofkP3om^h00`3om^h300000?40ooK^0@3oool00?@0ooK^0P0000030?ofkP040000003om^h0ooK^
0?ofkP800000m03om^h10?ooo`00mP3om^h2000000030?ofkP000000ooK^00800000mP3om^h10?oo
o`00n03om^h300000?P0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o
0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^
0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0
ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h1
0?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3o
m^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40
oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?of
k_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3o
ool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^
m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?oo
o`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd
0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo
003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0
ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool0
0?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03o
m^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00
o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?of
kP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o
0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^
0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0
ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h1
0?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3o
m^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00\
\>"],
  ImageRangeCache->{{{0, 499}, {499, 0}} -> {-5.00005*^-06, -5.00005*^-06, \
0.00200403, 0.00200403}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
%%ImageSize: 500 500 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics3D
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Background color
1 .961 .933 r
MFill
% Scaling calculations
0 1 0 1 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 0 r
.25 Mabswid
[ ] 0 setdash
.40912 .60318 m
.39961 .8356 L
s
.39961 .8356 m
.93472 .69847 L
s
.93472 .69847 m
.88764 .44767 L
s
.88764 .44767 m
.40912 .60318 L
s
.06705 .30234 m
.63805 .03848 L
s
.63805 .03848 m
.66126 .3169 L
s
.66126 .3169 m
.00747 .5665 L
s
.00747 .5665 m
.06705 .30234 L
s
.40912 .60318 m
.39961 .8356 L
s
.39961 .8356 m
.00747 .5665 L
s
.00747 .5665 m
.06705 .30234 L
s
.06705 .30234 m
.40912 .60318 L
s
.88764 .44767 m
.63805 .03848 L
s
.63805 .03848 m
.66126 .3169 L
s
.66126 .3169 m
.93472 .69847 L
s
.93472 .69847 m
.88764 .44767 L
s
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
.24 .35 .67 r
.5 Mabswid
.59245 .54684 m
.57143 .56253 L
s
.57143 .56253 m
.55428 .54453 L
s
.57143 .56253 m
.553 .58135 L
s
.553 .58135 m
.53555 .56364 L
s
.553 .58135 m
.53784 .60261 L
s
.61531 .53486 m
.59245 .54684 L
s
.59245 .54684 m
.5756 .52855 L
s
.53784 .60261 m
.5201 .58518 L
s
.53784 .60261 m
.52654 .62555 L
s
.6392 .52709 m
.61531 .53486 L
s
.61531 .53486 m
.59876 .5163 L
s
.52654 .62555 m
.50852 .6084 L
s
.52654 .62555 m
.51958 .64934 L
s
.66322 .52391 m
.6392 .52709 L
s
.6392 .52709 m
.62292 .50827 L
s
.5756 .52855 m
.55428 .54453 L
s
.55428 .54453 m
.53658 .52595 L
s
.55428 .54453 m
.53555 .56364 L
s
.51958 .64934 m
.50131 .63245 L
s
.51958 .64934 m
.51732 .6731 L
s
.53555 .56364 m
.51754 .54535 L
s
.53555 .56364 m
.5201 .58518 L
s
.59876 .5163 m
.5756 .52855 L
s
.5756 .52855 m
.55821 .50967 L
s
.5201 .58518 m
.50178 .56719 L
s
.5201 .58518 m
.50852 .6084 L
s
.68644 .52555 m
.66322 .52391 L
s
.66322 .52391 m
.64718 .50487 L
s
.62292 .50827 m
.59876 .5163 L
s
.59876 .5163 m
.58167 .49713 L
s
.50852 .6084 m
.48991 .59069 L
s
.50852 .6084 m
.50131 .63245 L
s
.51732 .6731 m
.49883 .65643 L
s
.51732 .6731 m
.51998 .69588 L
s
.64718 .50487 m
.62292 .50827 L
s
.62292 .50827 m
.6061 .48884 L
s
.83 .24 .1 r
.31825 .54593 m
.3274 .57153 L
s
.3274 .57153 m
.35824 .56096 L
s
.3274 .57153 m
.3337 .59771 L
s
.30656 .5218 m
.31825 .54593 L
s
.31825 .54593 m
.34901 .53511 L
s
.24 .35 .67 r
.55821 .50967 m
.53658 .52595 L
s
.53658 .52595 m
.5183 .50675 L
s
.53658 .52595 m
.51754 .54535 L
s
.7079 .53211 m
.68644 .52555 L
s
.68644 .52555 m
.67062 .50634 L
s
.50131 .63245 m
.48243 .61499 L
s
.50131 .63245 m
.49883 .65643 L
s
.51754 .54535 m
.49893 .52646 L
s
.51754 .54535 m
.50178 .56719 L
s
.58167 .49713 m
.55821 .50967 L
s
.55821 .50967 m
.54025 .49016 L
s
.83 .24 .1 r
.3337 .59771 m
.36469 .58735 L
s
.3337 .59771 m
.33691 .62359 L
s
.29271 .49996 m
.30656 .5218 L
s
.30656 .5218 m
.33733 .51071 L
s
.24 .35 .67 r
.50178 .56719 m
.48286 .5486 L
s
.50178 .56719 m
.48991 .59069 L
s
.51998 .69588 m
.50133 .6794 L
s
.51998 .69588 m
.52762 .71672 L
s
.67062 .50634 m
.64718 .50487 L
s
.64718 .50487 m
.63062 .4852 L
s
.6061 .48884 m
.58167 .49713 L
s
.58167 .49713 m
.56401 .47732 L
s
.83 .24 .1 r
.33691 .62359 m
.36813 .61341 L
s
.33691 .62359 m
.33687 .64824 L
s
.24 .35 .67 r
.48991 .59069 m
.47068 .57239 L
s
.48991 .59069 m
.48243 .61499 L
s
.83 .24 .1 r
.34901 .53511 m
.35824 .56096 L
s
.35824 .56096 m
.38967 .55018 L
s
.35824 .56096 m
.36469 .58735 L
s
.33733 .51071 m
.34901 .53511 L
s
.34901 .53511 m
.38037 .52409 L
s
.24 .35 .67 r
.49883 .65643 m
.47973 .63921 L
s
.49883 .65643 m
.50133 .6794 L
s
.83 .24 .1 r
.27714 .48125 m
.29271 .49996 L
s
.29271 .49996 m
.32356 .48859 L
s
.24 .35 .67 r
.72665 .54349 m
.7079 .53211 L
s
.7079 .53211 m
.69225 .51278 L
s
.83 .24 .1 r
.36469 .58735 m
.39628 .5768 L
s
.36469 .58735 m
.36813 .61341 L
s
.32356 .48859 m
.33733 .51071 L
s
.33733 .51071 m
.36868 .49941 L
s
.24 .35 .67 r
.63062 .4852 m
.6061 .48884 L
s
.6061 .48884 m
.58873 .46875 L
s
.54025 .49016 m
.5183 .50675 L
s
.5183 .50675 m
.4994 .4869 L
s
.5183 .50675 m
.49893 .52646 L
s
.69225 .51278 m
.67062 .50634 L
s
.67062 .50634 m
.65427 .48648 L
s
.52762 .71672 m
.50887 .70039 L
s
.52762 .71672 m
.54009 .73466 L
s
.48243 .61499 m
.46293 .59696 L
s
.48243 .61499 m
.47973 .63921 L
s
.49893 .52646 m
.4797 .50694 L
s
.49893 .52646 m
.48286 .5486 L
s
.83 .24 .1 r
.33687 .64824 m
.36838 .63821 L
s
.33687 .64824 m
.33348 .67076 L
s
.36813 .61341 m
.39995 .60304 L
s
.36813 .61341 m
.36838 .63821 L
s
.24 .35 .67 r
.56401 .47732 m
.54025 .49016 L
s
.54025 .49016 m
.52168 .46999 L
s
.83 .24 .1 r
.38037 .52409 m
.38967 .55018 L
s
.38967 .55018 m
.42171 .5392 L
s
.38967 .55018 m
.39628 .5768 L
s
.36868 .49941 m
.38037 .52409 L
s
.38037 .52409 m
.41233 .51285 L
s
.30814 .46959 m
.32356 .48859 L
s
.32356 .48859 m
.35499 .477 L
s
.26038 .46644 m
.27714 .48125 L
s
.27714 .48125 m
.30814 .46959 L
s
.24 .35 .67 r
.48286 .5486 m
.4633 .52939 L
s
.48286 .5486 m
.47068 .57239 L
s
.50133 .6794 m
.48206 .66237 L
s
.50133 .6794 m
.50887 .70039 L
s
.83 .24 .1 r
.39628 .5768 m
.42848 .56604 L
s
.39628 .5768 m
.39995 .60304 L
s
.35499 .477 m
.36868 .49941 L
s
.36868 .49941 m
.40065 .48789 L
s
.24 .35 .67 r
.65427 .48648 m
.63062 .4852 L
s
.63062 .4852 m
.6135 .46487 L
s
.58873 .46875 m
.56401 .47732 L
s
.56401 .47732 m
.54575 .45684 L
s
.74177 .55936 m
.72665 .54349 L
s
.72665 .54349 m
.71112 .5241 L
s
.47068 .57239 m
.46293 .59696 L
s
.47973 .63921 m
.45999 .6214 L
s
.47973 .63921 m
.48206 .66237 L
s
.83 .24 .1 r
.36838 .63821 m
.4005 .62799 L
s
.36838 .63821 m
.36533 .66082 L
s
.39995 .60304 m
.43239 .59247 L
s
.39995 .60304 m
.4005 .62799 L
s
.41233 .51285 m
.42171 .5392 L
s
.42171 .5392 m
.42848 .56604 L
s
.40065 .48789 m
.41233 .51285 L
s
.41233 .51285 m
.44491 .50139 L
s
.24 .35 .67 r
.71112 .5241 m
.69225 .51278 L
s
.69225 .51278 m
.67607 .49279 L
s
.54009 .73466 m
.52132 .71843 L
s
.54009 .73466 m
.55704 .74882 L
s
.83 .24 .1 r
.33974 .4577 m
.35499 .477 L
s
.35499 .477 m
.38705 .46519 L
s
.29159 .45448 m
.30814 .46959 L
s
.30814 .46959 m
.33974 .4577 L
s
.33348 .67076 m
.36533 .66082 L
s
.33348 .67076 m
.32675 .6902 L
s
.24 .35 .67 r
.6135 .46487 m
.58873 .46875 L
s
.58873 .46875 m
.57076 .44798 L
s
.83 .24 .1 r
.42848 .56604 m
.43239 .59247 L
s
.243 .45621 m
.26038 .46644 L
s
.26038 .46644 m
.29159 .45448 L
s
.38705 .46519 m
.40065 .48789 L
s
.40065 .48789 m
.43323 .47615 L
s
.24 .35 .67 r
.52168 .46999 m
.4994 .4869 L
s
.4994 .4869 m
.4797 .50694 L
s
.67607 .49279 m
.65427 .48648 L
s
.65427 .48648 m
.63736 .46595 L
s
.50887 .70039 m
.48949 .6835 L
s
.50887 .70039 m
.52132 .71843 L
s
.46293 .59696 m
.45999 .6214 L
s
.4797 .50694 m
.4633 .52939 L
s
.54575 .45684 m
.52168 .46999 L
s
.52168 .46999 m
.50248 .44914 L
s
.75243 .57919 m
.74177 .55936 L
s
.74177 .55936 m
.72629 .53999 L
s
.83 .24 .1 r
.4005 .62799 m
.43325 .61756 L
s
.4005 .62799 m
.39781 .6507 L
s
.43239 .59247 m
.43325 .61756 L
s
.774 .219 .095 r
.47042 .54506 m .45551 .55007 L .45957 .52633 L p F P
0 0 0 r
s
.24 .35 .67 r
.46238 .53117 m
.4633 .52939 L
s
.731 .205 .09 r
.45551 .55007 m .47042 .54506 L .46836 .56749 L p F P
0 0 0 r
s
.731 .205 .09 r
.46836 .56749 m .45243 .57274 L .45551 .55007 L p F P
0 0 0 r
s
.24 .35 .67 r
.46626 .56818 m
.47068 .57239 L
s
.307 .441 .834 r
.44643 .54137 m .45551 .55007 L .45957 .52633 L p F P
0 0 0 r
s
.83 .24 .1 r
.42171 .5392 m
.45437 .528 L
s
.303 .432 .811 r
.45551 .55007 m .44643 .54137 L .44268 .56361 L p F P
0 0 0 r
s
.83 .24 .1 r
.42848 .56604 m
.44309 .56116 L
s
.303 .432 .811 r
.44268 .56361 m .45243 .57274 L .45551 .55007 L p F P
0 0 0 r
s
.24 .35 .67 r
.4508 .55347 m
.45534 .55778 L
s
.83 .24 .1 r
.45386 .55756 m
.46131 .55507 L
s
.24 .35 .67 r
.48206 .66237 m
.46213 .64475 L
s
.48206 .66237 m
.48949 .6835 L
s
.83 .24 .1 r
.44491 .50139 m
.45437 .528 L
s
.45437 .528 m
.45522 .53131 L
s
.43323 .47615 m
.44491 .50139 L
s
.813 .232 .1 r
.47313 .52168 m .45957 .52633 L .46455 .5019 L p F P
0 0 0 r
s
.774 .219 .095 r
.45957 .52633 m .47313 .52168 L .47042 .54506 L p F P
0 0 0 r
s
.309 .446 .849 r
.45135 .51826 m .45957 .52633 L .46455 .5019 L p F P
0 0 0 r
s
.307 .441 .834 r
.45957 .52633 m .45135 .51826 L .44643 .54137 L p F P
0 0 0 r
s
.83 .24 .1 r
.45664 .53684 m
.46131 .55507 L
s
.24 .35 .67 r
.4508 .55347 m
.45922 .53724 L
s
.83 .24 .1 r
.37196 .44558 m
.38705 .46519 L
s
.38705 .46519 m
.41973 .45314 L
s
.32342 .4423 m
.33974 .4577 L
s
.33974 .4577 m
.37196 .44558 L
s
.24 .35 .67 r
.63736 .46595 m
.6135 .46487 L
s
.6135 .46487 m
.59579 .44384 L
s
.83 .24 .1 r
.36533 .66082 m
.39781 .6507 L
s
.36533 .66082 m
.35899 .68032 L
s
.683 .19 .083 r
.45243 .57274 m .46836 .56749 L .46699 .58856 L p F P
0 0 0 r
s
.683 .19 .083 r
.46699 .58856 m .45038 .59394 L .45243 .57274 L p F P
0 0 0 r
s
.24 .35 .67 r
.45726 .59171 m
.46293 .59696 L
s
.295 .418 .779 r
.45243 .57274 m .44268 .56361 L .44019 .58459 L p F P
0 0 0 r
s
.295 .418 .779 r
.44019 .58459 m .45038 .59394 L .45243 .57274 L p F P
0 0 0 r
s
.83 .24 .1 r
.43239 .59247 m
.44448 .58853 L
s
.45051 .58656 m
.46547 .58169 L
s
.24 .35 .67 r
.57076 .44798 m
.54575 .45684 L
s
.54575 .45684 m
.52687 .43566 L
s
.83 .24 .1 r
.46131 .55507 m
.46547 .58169 L
s
.24 .35 .67 r
.72629 .53999 m
.71112 .5241 L
s
.71112 .5241 m
.69505 .50405 L
s
.83 .24 .1 r
.2745 .44399 m
.29159 .45448 L
s
.29159 .45448 m
.32342 .4423 L
s
.849 .243 .105 r
.47645 .49774 m .46455 .5019 L .47035 .4772 L p F P
0 0 0 r
s
.24 .35 .67 r
.47213 .49925 m
.4797 .50694 L
s
.813 .232 .1 r
.46455 .5019 m .47645 .49774 L .47313 .52168 L p F P
0 0 0 r
s
.31 .449 .858 r
.45737 .49468 m .46455 .5019 L .47035 .4772 L p F P
0 0 0 r
s
.309 .446 .849 r
.46455 .5019 m .45737 .49468 L .45135 .51826 L p F P
0 0 0 r
s
.83 .24 .1 r
.44491 .50139 m
.45671 .49724 L
s
.41973 .45314 m
.43323 .47615 L
s
.24 .35 .67 r
.55704 .74882 m
.53831 .73262 L
s
.55704 .74882 m
.57784 .75839 L
s
.774 .219 .095 r
.48546 .54001 m .47042 .54506 L .47313 .52168 L p F P
0 0 0 r
s
.731 .205 .09 r
.47042 .54506 m .48546 .54001 L .48444 .56218 L p F P
0 0 0 r
s
.731 .205 .09 r
.48444 .56218 m .46836 .56749 L .47042 .54506 L p F P
0 0 0 r
s
.813 .232 .1 r
.4868 .517 m .47313 .52168 L .47645 .49774 L p F P
0 0 0 r
s
.774 .219 .095 r
.47313 .52168 m .4868 .517 L .48546 .54001 L p F P
0 0 0 r
s
.83 .24 .1 r
.32675 .6902 m
.35899 .68032 L
s
.32675 .6902 m
.31682 .70568 L
s
.625 .171 .076 r
.45038 .59394 m .46699 .58856 L .46634 .60791 L p F P
0 0 0 r
s
.625 .171 .076 r
.46634 .60791 m .44941 .61329 L .45038 .59394 L p F P
0 0 0 r
s
.283 .397 .733 r
.45038 .59394 m .44019 .58459 L .43901 .60393 L p F P
0 0 0 r
s
.24 .35 .67 r
.44276 .5783 m
.45192 .58677 L
s
.283 .397 .733 r
.43901 .60393 m .44941 .61329 L .45038 .59394 L p F P
0 0 0 r
s
.683 .19 .083 r
.46836 .56749 m .48444 .56218 L .48376 .58313 L p F P
0 0 0 r
s
.683 .19 .083 r
.48376 .58313 m .46699 .58856 L .46836 .56749 L p F P
0 0 0 r
s
.307 .441 .834 r
.4372 .53252 m .44643 .54137 L .45135 .51826 L p F P
0 0 0 r
s
.303 .432 .811 r
.44643 .54137 m .4372 .53252 L .43277 .55433 L p F P
0 0 0 r
s
.303 .432 .811 r
.43277 .55433 m .44268 .56361 L .44643 .54137 L p F P
0 0 0 r
s
.24 .35 .67 r
.44276 .5783 m
.4508 .55347 L
s
.309 .446 .849 r
.44301 .51007 m .45135 .51826 L .45737 .49468 L p F P
0 0 0 r
s
.307 .441 .834 r
.45135 .51826 m .44301 .51007 L .4372 .53252 L p F P
0 0 0 r
s
.849 .243 .105 r
.47035 .4772 m .48032 .47365 L .47645 .49774 L p F P
0 0 0 r
s
.849 .243 .105 r
.48843 .49355 m .47645 .49774 L .48032 .47365 L p F P
0 0 0 r
s
.813 .232 .1 r
.47645 .49774 m .48843 .49355 L .4868 .517 L p F P
0 0 0 r
s
.24 .35 .67 r
.69505 .50405 m
.67607 .49279 L
s
.67607 .49279 m
.65933 .47212 L
s
.52132 .71843 m
.50189 .70163 L
s
.52132 .71843 m
.53831 .73262 L
s
.83 .24 .1 r
.22568 .4512 m
.243 .45621 L
s
.243 .45621 m
.2745 .44399 L
s
.813 .232 .1 r
.50057 .51227 m .4868 .517 L .48843 .49355 L p F P
0 0 0 r
s
.774 .219 .095 r
.4868 .517 m .50057 .51227 L .50063 .53491 L p F P
0 0 0 r
s
.774 .219 .095 r
.50063 .53491 m .48546 .54001 L .4868 .517 L p F P
0 0 0 r
s
.83 .24 .1 r
.45857 .52656 m
.48767 .51658 L
s
.731 .205 .09 r
.48546 .54001 m .50063 .53491 L .50068 .55683 L p F P
0 0 0 r
s
.731 .205 .09 r
.50068 .55683 m .48444 .56218 L .48546 .54001 L p F P
0 0 0 r
s
.83 .24 .1 r
.46131 .55507 m
.49479 .54388 L
s
.43325 .61756 m
.43093 .64037 L
s
.24 .35 .67 r
.59579 .44384 m
.57076 .44798 L
s
.57076 .44798 m
.55217 .4265 L
s
.295 .418 .779 r
.44268 .56361 m .43277 .55433 L .42982 .57508 L p F P
0 0 0 r
s
.295 .418 .779 r
.42982 .57508 m .44019 .58459 L .44268 .56361 L p F P
0 0 0 r
s
.83 .24 .1 r
.47813 .48971 m
.48767 .51658 L
s
.48767 .51658 m
.49479 .54388 L
s
.883 .255 .11 r
.48032 .47365 m .47035 .4772 L .47691 .45265 L p F P
0 0 0 r
s
.308 .449 .863 r
.46439 .47104 m .47035 .4772 L .47691 .45265 L p F P
0 0 0 r
s
.31 .449 .858 r
.47035 .4772 m .46439 .47104 L .45737 .49468 L p F P
0 0 0 r
s
.83 .24 .1 r
.46538 .4942 m
.47813 .48971 L
s
.31 .449 .858 r
.45011 .48737 m .45737 .49468 L .46439 .47104 L p F P
0 0 0 r
s
.24 .35 .67 r
.45982 .48675 m
.46748 .49453 L
s
.83 .24 .1 r
.43323 .47615 m
.46646 .46417 L
s
.309 .446 .849 r
.45737 .49468 m .45011 .48737 L .44301 .51007 L p F P
0 0 0 r
s
.83 .24 .1 r
.46981 .4715 m
.47813 .48971 L
s
.46646 .46417 m
.46751 .46646 L
s
.625 .171 .076 r
.46699 .58856 m .48376 .58313 L .48344 .60246 L p F P
0 0 0 r
s
.625 .171 .076 r
.48344 .60246 m .46634 .60791 L .46699 .58856 L p F P
0 0 0 r
s
.83 .24 .1 r
.40482 .43322 m
.41973 .45314 L
s
.849 .243 .105 r
.48032 .47365 m .49034 .47008 L .48843 .49355 L p F P
0 0 0 r
s
.24 .35 .67 r
.47986 .46638 m
.48515 .47193 L
s
.48979 .47681 m
.4994 .4869 L
s
.849 .243 .105 r
.5005 .48933 m .48843 .49355 L .49034 .47008 L p F P
0 0 0 r
s
.813 .232 .1 r
.48843 .49355 m .5005 .48933 L .50057 .51227 L p F P
0 0 0 r
s
.683 .19 .083 r
.48444 .56218 m .50068 .55683 L .50071 .57765 L p F P
0 0 0 r
s
.683 .19 .083 r
.50071 .57765 m .48376 .58313 L .48444 .56218 L p F P
0 0 0 r
s
.83 .24 .1 r
.35589 .42987 m
.37196 .44558 L
s
.37196 .44558 m
.40482 .43322 L
s
.39781 .6507 m
.43093 .64037 L
s
.39781 .6507 m
.39187 .67024 L
s
.24 .35 .67 r
.75798 .6022 m
.75243 .57919 L
s
.75243 .57919 m
.73695 .55992 L
s
.47899 .46546 m
.47986 .46638 L
s
.45982 .48675 m
.47413 .47221 L
s
.47924 .46702 m
.47986 .46638 L
s
.65933 .47212 m
.63736 .46595 L
s
.63736 .46595 m
.61987 .44471 L
s
.48949 .6835 m
.46943 .66603 L
s
.48949 .6835 m
.50189 .70163 L
s
.813 .232 .1 r
.51446 .50751 m .50057 .51227 L .5005 .48933 L p F P
0 0 0 r
s
.774 .219 .095 r
.50057 .51227 m .51446 .50751 L .51594 .52976 L p F P
0 0 0 r
s
.774 .219 .095 r
.51594 .52976 m .50063 .53491 L .50057 .51227 L p F P
0 0 0 r
s
.83 .24 .1 r
.49479 .54388 m
.4992 .57069 L
s
.883 .255 .11 r
.47691 .45265 m .48468 .44983 L .48032 .47365 L p F P
0 0 0 r
s
.883 .255 .11 r
.49034 .47008 m .48032 .47365 L .48468 .44983 L p F P
0 0 0 r
s
.24 .35 .67 r
.48765 .46045 m
.50248 .44914 L
s
.731 .205 .09 r
.50063 .53491 m .51594 .52976 L .51707 .55142 L p F P
0 0 0 r
s
.731 .205 .09 r
.51707 .55142 m .50068 .55683 L .50063 .53491 L p F P
0 0 0 r
s
.554 .149 .066 r
.44941 .61329 m .46634 .60791 L .46644 .62513 L p F P
0 0 0 r
s
.24 .35 .67 r
.45636 .61813 m
.45999 .6214 L
s
.554 .149 .066 r
.46644 .62513 m .44956 .63042 L .44941 .61329 L p F P
0 0 0 r
s
.24 .35 .67 r
.4605 .62699 m
.46213 .64475 L
s
.264 .365 .665 r
.44941 .61329 m .43901 .60393 L .43919 .62123 L p F P
0 0 0 r
s
.83 .24 .1 r
.43325 .61756 m
.43913 .61568 L
s
.264 .365 .665 r
.43919 .62123 m .44956 .63042 L .44941 .61329 L p F P
0 0 0 r
s
.83 .24 .1 r
.30662 .43152 m
.32342 .4423 L
s
.32342 .4423 m
.35589 .42987 L
s
.46646 .46417 m
.4699 .46294 L
s
.309 .446 .849 r
.43456 .50177 m .44301 .51007 L .45011 .48737 L p F P
0 0 0 r
s
.24 .35 .67 r
.44307 .50952 m
.46076 .5269 L
s
.307 .441 .834 r
.44301 .51007 m .43456 .50177 L .42783 .52354 L p F P
0 0 0 r
s
.307 .441 .834 r
.42783 .52354 m .4372 .53252 L .44301 .51007 L p F P
0 0 0 r
s
.849 .243 .105 r
.49034 .47008 m .50042 .46649 L .5005 .48933 L p F P
0 0 0 r
s
.849 .243 .105 r
.51266 .48509 m .5005 .48933 L .50042 .46649 L p F P
0 0 0 r
s
.813 .232 .1 r
.5005 .48933 m .51266 .48509 L .51446 .50751 L p F P
0 0 0 r
s
.283 .397 .733 r
.44019 .58459 m .42982 .57508 L .42843 .5944 L p F P
0 0 0 r
s
.283 .397 .733 r
.42843 .5944 m .43901 .60393 L .44019 .58459 L p F P
0 0 0 r
s
.24 .35 .67 r
.43956 .60298 m
.44276 .5783 L
s
.43956 .60298 m
.45059 .61292 L
s
.303 .432 .811 r
.4372 .53252 m .42783 .52354 L .4227 .54489 L p F P
0 0 0 r
s
.303 .432 .811 r
.4227 .54489 m .43277 .55433 L .4372 .53252 L p F P
0 0 0 r
s
.308 .449 .863 r
.47691 .45265 m .47229 .44776 L .46439 .47104 L p F P
0 0 0 r
s
.308 .449 .863 r
.45836 .46482 m .46439 .47104 L .47229 .44776 L p F P
0 0 0 r
s
.31 .449 .858 r
.46439 .47104 m .45836 .46482 L .45011 .48737 L p F P
0 0 0 r
s
.24 .35 .67 r
.44307 .50952 m
.45982 .48675 L
s
.83 .24 .1 r
.35899 .68032 m
.39187 .67024 L
s
.35899 .68032 m
.34946 .6958 L
s
.683 .19 .083 r
.50068 .55683 m .51707 .55142 L .51782 .57211 L p F P
0 0 0 r
s
.683 .19 .083 r
.51782 .57211 m .50071 .57765 L .50068 .55683 L p F P
0 0 0 r
s
.883 .255 .11 r
.48468 .44983 m .49248 .447 L .49034 .47008 L p F P
0 0 0 r
s
.883 .255 .11 r
.50042 .46649 m .49034 .47008 L .49248 .447 L p F P
0 0 0 r
s
.625 .171 .076 r
.48376 .58313 m .50071 .57765 L .50072 .59697 L p F P
0 0 0 r
s
.83 .24 .1 r
.46547 .58169 m
.4992 .57069 L
s
.625 .171 .076 r
.50072 .59697 m .48344 .60246 L .48376 .58313 L p F P
0 0 0 r
s
.31 .449 .858 r
.44275 .47997 m .45011 .48737 L .45836 .46482 L p F P
0 0 0 r
s
.309 .446 .849 r
.45011 .48737 m .44275 .47997 L .43456 .50177 L p F P
0 0 0 r
s
.24 .35 .67 r
.73695 .55992 m
.72629 .53999 L
s
.72629 .53999 m
.71028 .51995 L
s
.57784 .75839 m
.55924 .74215 L
s
.57784 .75839 m
.60167 .76276 L
s
.813 .232 .1 r
.52846 .50272 m .51446 .50751 L .51266 .48509 L p F P
0 0 0 r
s
.774 .219 .095 r
.51446 .50751 m .52846 .50272 L .53138 .52457 L p F P
0 0 0 r
s
.774 .219 .095 r
.53138 .52457 m .51594 .52976 L .51446 .50751 L p F P
0 0 0 r
s
.83 .24 .1 r
.48767 .51658 m
.52164 .50494 L
s
.731 .205 .09 r
.51594 .52976 m .53138 .52457 L .53361 .54597 L p F P
0 0 0 r
s
.731 .205 .09 r
.53361 .54597 m .51707 .55142 L .51594 .52976 L p F P
0 0 0 r
s
.83 .24 .1 r
.49479 .54388 m
.52893 .53248 L
s
.295 .418 .779 r
.43277 .55433 m .4227 .54489 L .41928 .56541 L p F P
0 0 0 r
s
.24 .35 .67 r
.43024 .5339 m
.4508 .55347 L
s
.295 .418 .779 r
.41928 .56541 m .42982 .57508 L .43277 .55433 L p F P
0 0 0 r
s
.554 .149 .066 r
.46634 .60791 m .48344 .60246 L .48349 .61979 L p F P
0 0 0 r
s
.83 .24 .1 r
.46547 .58169 m
.46665 .60692 L
s
.554 .149 .066 r
.48349 .61979 m .46644 .62513 L .46634 .60791 L p F P
0 0 0 r
s
.83 .24 .1 r
.44868 .61264 m
.46665 .60692 L
s
.849 .243 .105 r
.50042 .46649 m .51056 .46288 L .51266 .48509 L p F P
0 0 0 r
s
.849 .243 .105 r
.5249 .48081 m .51266 .48509 L .51056 .46288 L p F P
0 0 0 r
s
.83 .24 .1 r
.47813 .48971 m
.51201 .4778 L
s
.813 .232 .1 r
.51266 .48509 m .5249 .48081 L .52846 .50272 L p F P
0 0 0 r
s
.83 .24 .1 r
.25751 .43872 m
.2745 .44399 L
s
.2745 .44399 m
.30662 .43152 L
s
.917 .266 .114 r
.48468 .44983 m .47691 .45265 L .48411 .42869 L p F P
0 0 0 r
s
.305 .447 .863 r
.47229 .44776 m .47691 .45265 L .48411 .42869 L p F P
0 0 0 r
s
.24 .35 .67 r
.61987 .44471 m
.59579 .44384 L
s
.59579 .44384 m
.57746 .42208 L
s
.883 .255 .11 r
.49248 .447 m .50033 .44416 L .50042 .46649 L p F P
0 0 0 r
s
.24 .35 .67 r
.50034 .44681 m
.50248 .44914 L
s
.883 .255 .11 r
.51056 .46288 m .50042 .46649 L .50033 .44416 L p F P
0 0 0 r
s
.24 .35 .67 r
.50292 .4489 m
.52687 .43566 L
s
.55217 .4265 m
.52687 .43566 L
s
.83 .24 .1 r
.51201 .4778 m
.52164 .50494 L
s
.308 .449 .863 r
.47229 .44776 m .46764 .44283 L .45836 .46482 L p F P
0 0 0 r
s
.308 .449 .863 r
.45227 .45853 m .45836 .46482 L .46764 .44283 L p F P
0 0 0 r
s
.83 .24 .1 r
.45306 .44085 m
.45917 .45148 L
s
.41973 .45314 m
.45306 .44085 L
s
.31 .449 .858 r
.45836 .46482 m .45227 .45853 L .44275 .47997 L p F P
0 0 0 r
s
.24 .35 .67 r
.71028 .51995 m
.69505 .50405 L
s
.69505 .50405 m
.67843 .4833 L
s
.683 .19 .083 r
.51707 .55142 m .53361 .54597 L .5351 .56651 L p F P
0 0 0 r
s
.683 .19 .083 r
.5351 .56651 m .51782 .57211 L .51707 .55142 L p F P
0 0 0 r
s
.813 .232 .1 r
.54257 .49788 m .52846 .50272 L .5249 .48081 L p F P
0 0 0 r
s
.774 .219 .095 r
.52846 .50272 m .54257 .49788 L .54697 .51933 L p F P
0 0 0 r
s
.774 .219 .095 r
.54697 .51933 m .53138 .52457 L .52846 .50272 L p F P
0 0 0 r
s
.83 .24 .1 r
.52164 .50494 m
.52893 .53248 L
s
.917 .266 .114 r
.48411 .42869 m .48946 .42672 L .48468 .44983 L p F P
0 0 0 r
s
.917 .266 .114 r
.49248 .447 m .48468 .44983 L .48946 .42672 L p F P
0 0 0 r
s
.625 .171 .076 r
.50071 .57765 m .51782 .57211 L .51817 .59142 L p F P
0 0 0 r
s
.625 .171 .076 r
.51817 .59142 m .50072 .59697 L .50071 .57765 L p F P
0 0 0 r
s
.83 .24 .1 r
.4992 .57069 m
.50071 .59608 L
s
.389 .41719 m
.40482 .43322 L
s
.40482 .43322 m
.43834 .4206 L
s
.43093 .64037 m
.42541 .65996 L
s
.24 .35 .67 r
.53831 .73262 m
.51892 .71585 L
s
.53831 .73262 m
.55924 .74215 L
s
.83 .24 .1 r
.31682 .70568 m
.34946 .6958 L
s
.31682 .70568 m
.30393 .71638 L
s
.309 .446 .849 r
.42598 .49335 m .43456 .50177 L .44275 .47997 L p F P
0 0 0 r
s
.307 .441 .834 r
.43456 .50177 m .42598 .49335 L .41831 .51442 L p F P
0 0 0 r
s
.307 .441 .834 r
.41831 .51442 m .42783 .52354 L .43456 .50177 L p F P
0 0 0 r
s
.24 .35 .67 r
.43024 .5339 m
.44307 .50952 L
s
.849 .243 .105 r
.51056 .46288 m .52076 .45925 L .5249 .48081 L p F P
0 0 0 r
s
.849 .243 .105 r
.53723 .4765 m .5249 .48081 L .52076 .45925 L p F P
0 0 0 r
s
.813 .232 .1 r
.5249 .48081 m .53723 .4765 L .54257 .49788 L p F P
0 0 0 r
s
.264 .365 .665 r
.43901 .60393 m .42843 .5944 L .42864 .61188 L p F P
0 0 0 r
s
.264 .365 .665 r
.42864 .61188 m .43919 .62123 L .43901 .60393 L p F P
0 0 0 r
s
.883 .255 .11 r
.50033 .44416 m .5082 .4413 L .51056 .46288 L p F P
0 0 0 r
s
.83 .24 .1 r
.47322 .46174 m
.50035 .45196 L
s
.883 .255 .11 r
.52076 .45925 m .51056 .46288 L .5082 .4413 L p F P
0 0 0 r
s
.83 .24 .1 r
.50035 .45196 m
.51201 .4778 L
s
.731 .205 .09 r
.53138 .52457 m .54697 .51933 L .55032 .54046 L p F P
0 0 0 r
s
.731 .205 .09 r
.55032 .54046 m .53361 .54597 L .53138 .52457 L p F P
0 0 0 r
s
.31 .449 .858 r
.43531 .47247 m .44275 .47997 L .45227 .45853 L p F P
0 0 0 r
s
.309 .446 .849 r
.44275 .47997 m .43531 .47247 L .42598 .49335 L p F P
0 0 0 r
s
.305 .447 .863 r
.48411 .42869 m .48096 .42527 L .47229 .44776 L p F P
0 0 0 r
s
.305 .447 .863 r
.46764 .44283 m .47229 .44776 L .48096 .42527 L p F P
0 0 0 r
s
.464 .121 .054 r
.44956 .63042 m .46644 .62513 L .46731 .63986 L p F P
0 0 0 r
s
.464 .121 .054 r
.46731 .63986 m .45086 .64493 L .44956 .63042 L p F P
0 0 0 r
s
.24 .35 .67 r
.45936 .64231 m
.46213 .64475 L
s
.46213 .64475 m
.46943 .66603 L
s
.234 .317 .566 r
.44956 .63042 m .43919 .62123 L .44077 .63611 L p F P
0 0 0 r
s
.234 .317 .566 r
.44077 .63611 m .45086 .64493 L .44956 .63042 L p F P
0 0 0 r
s
.83 .24 .1 r
.43093 .64037 m
.44178 .63698 L
s
.24 .35 .67 r
.4415 .62652 m
.45087 .6348 L
s
.83 .24 .1 r
.44943 .6346 m
.46471 .62983 L
s
.303 .432 .811 r
.42783 .52354 m .41831 .51442 L .41246 .53529 L p F P
0 0 0 r
s
.303 .432 .811 r
.41246 .53529 m .4227 .54489 L .42783 .52354 L p F P
0 0 0 r
s
.83 .24 .1 r
.52893 .53248 m
.53361 .55948 L
s
.917 .266 .114 r
.48946 .42672 m .49484 .42474 L .49248 .447 L p F P
0 0 0 r
s
.24 .35 .67 r
.49331 .43918 m
.4985 .44482 L
s
.917 .266 .114 r
.50033 .44416 m .49248 .447 L .49484 .42474 L p F P
0 0 0 r
s
.554 .149 .066 r
.48344 .60246 m .50072 .59697 L .50072 .6144 L p F P
0 0 0 r
s
.554 .149 .066 r
.50072 .6144 m .48349 .61979 L .48344 .60246 L p F P
0 0 0 r
s
.83 .24 .1 r
.46665 .60692 m
.50071 .59608 L
s
.283 .397 .733 r
.42982 .57508 m .41928 .56541 L .41766 .5847 L p F P
0 0 0 r
s
.283 .397 .733 r
.41766 .5847 m .42843 .5944 L .42982 .57508 L p F P
0 0 0 r
s
.24 .35 .67 r
.74241 .58311 m
.75798 .6022 L
s
.75797 .62739 m
.75798 .6022 L
s
.83 .24 .1 r
.3394 .4188 m
.35589 .42987 L
s
.35589 .42987 m
.389 .41719 L
s
.20913 .45184 m
.22568 .4512 L
s
.22568 .4512 m
.25751 .43872 L
s
.24 .35 .67 r
.67843 .4833 m
.65933 .47212 L
s
.65933 .47212 m
.64201 .45071 L
s
.883 .255 .11 r
.5082 .4413 m .51612 .43843 L .52076 .45925 L p F P
0 0 0 r
s
.883 .255 .11 r
.53102 .45559 m .52076 .45925 L .51612 .43843 L p F P
0 0 0 r
s
.849 .243 .105 r
.52076 .45925 m .53102 .45559 L .53723 .4765 L p F P
0 0 0 r
s
.813 .232 .1 r
.5568 .493 m .54257 .49788 L .53723 .4765 L p F P
0 0 0 r
s
.774 .219 .095 r
.54257 .49788 m .5568 .493 L .56269 .51404 L p F P
0 0 0 r
s
.774 .219 .095 r
.56269 .51404 m .54697 .51933 L .54257 .49788 L p F P
0 0 0 r
s
.83 .24 .1 r
.52164 .50494 m
.55628 .49306 L
s
.849 .243 .105 r
.54964 .47216 m .53723 .4765 L .53102 .45559 L p F P
0 0 0 r
s
.813 .232 .1 r
.53723 .4765 m .54964 .47216 L .5568 .493 L p F P
0 0 0 r
s
.308 .449 .863 r
.46764 .44283 m .46295 .43787 L .45227 .45853 L p F P
0 0 0 r
s
.308 .449 .863 r
.44612 .45218 m .45227 .45853 L .46295 .43787 L p F P
0 0 0 r
s
.24 .35 .67 r
.45965 .44515 m
.47586 .46218 L
s
.31 .449 .858 r
.45227 .45853 m .44612 .45218 L .43531 .47247 L p F P
0 0 0 r
s
.683 .19 .083 r
.53361 .54597 m .55032 .54046 L .55255 .56086 L p F P
0 0 0 r
s
.683 .19 .083 r
.55255 .56086 m .5351 .56651 L .53361 .54597 L p F P
0 0 0 r
s
.917 .266 .114 r
.49484 .42474 m .50022 .42275 L .50033 .44416 L p F P
0 0 0 r
s
.917 .266 .114 r
.5082 .4413 m .50033 .44416 L .50022 .42275 L p F P
0 0 0 r
s
.24 .35 .67 r
.50189 .70163 m
.48178 .68424 L
s
.50189 .70163 m
.51892 .71585 L
s
.83 .24 .1 r
.39187 .67024 m
.42541 .65996 L
s
.39187 .67024 m
.38277 .68572 L
s
.625 .171 .076 r
.51782 .57211 m .5351 .56651 L .5358 .58581 L p F P
0 0 0 r
s
.83 .24 .1 r
.4992 .57069 m
.53361 .55948 L
s
.625 .171 .076 r
.5358 .58581 m .51817 .59142 L .51782 .57211 L p F P
0 0 0 r
s
.295 .418 .779 r
.4227 .54489 m .41246 .53529 L .40855 .55556 L p F P
0 0 0 r
s
.295 .418 .779 r
.40855 .55556 m .41928 .56541 L .4227 .54489 L p F P
0 0 0 r
s
.24 .35 .67 r
.42188 .559 m
.43024 .5339 L
s
.42188 .559 m
.44276 .5783 L
s
.57746 .42208 m
.55217 .4265 L
s
.305 .447 .863 r
.48096 .42527 m .47779 .42183 L .46764 .44283 L p F P
0 0 0 r
s
.305 .447 .863 r
.46295 .43787 m .46764 .44283 L .47779 .42183 L p F P
0 0 0 r
s
.83 .24 .1 r
.45306 .44085 m
.46387 .43687 L
s
.731 .205 .09 r
.54697 .51933 m .56269 .51404 L .56718 .53489 L p F P
0 0 0 r
s
.731 .205 .09 r
.56718 .53489 m .55032 .54046 L .54697 .51933 L p F P
0 0 0 r
s
.24 .35 .67 r
.60167 .76276 m
.58328 .74641 L
s
.60167 .76276 m
.62746 .76154 L
s
.464 .121 .054 r
.46644 .62513 m .48349 .61979 L .48392 .63473 L p F P
0 0 0 r
s
.464 .121 .054 r
.48392 .63473 m .46731 .63986 L .46644 .62513 L p F P
0 0 0 r
s
.83 .24 .1 r
.46471 .62983 m
.46665 .60692 L
s
.917 .266 .114 r
.50022 .42275 m .50563 .42076 L .5082 .4413 L p F P
0 0 0 r
s
.917 .266 .114 r
.51612 .43843 m .5082 .4413 L .50563 .42076 L p F P
0 0 0 r
s
.883 .255 .11 r
.51612 .43843 m .52407 .43555 L .53102 .45559 L p F P
0 0 0 r
s
.883 .255 .11 r
.54134 .45192 m .53102 .45559 L .52407 .43555 L p F P
0 0 0 r
s
.849 .243 .105 r
.53102 .45559 m .54134 .45192 L .54964 .47216 L p F P
0 0 0 r
s
.554 .149 .066 r
.50072 .59697 m .51817 .59142 L .51812 .60895 L p F P
0 0 0 r
s
.554 .149 .066 r
.51812 .60895 m .50072 .6144 L .50072 .59697 L p F P
0 0 0 r
s
.83 .24 .1 r
.28999 .42599 m
.30662 .43152 L
s
.30662 .43152 m
.3394 .4188 L
s
.31 .449 .858 r
.42777 .46489 m .43531 .47247 L .44612 .45218 L p F P
0 0 0 r
s
.24 .35 .67 r
.43924 .46586 m
.45982 .48675 L
s
.309 .446 .849 r
.43531 .47247 m .42777 .46489 L .41728 .48481 L p F P
0 0 0 r
s
.309 .446 .849 r
.41728 .48481 m .42598 .49335 L .43531 .47247 L p F P
0 0 0 r
s
.307 .441 .834 r
.42598 .49335 m .41728 .48481 L .40865 .50516 L p F P
0 0 0 r
s
.307 .441 .834 r
.40865 .50516 m .41831 .51442 L .42598 .49335 L p F P
0 0 0 r
s
.24 .35 .67 r
.42213 .48896 m
.44307 .50952 L
s
.849 .243 .105 r
.56215 .46779 m .54964 .47216 L .54134 .45192 L p F P
0 0 0 r
s
.83 .24 .1 r
.51201 .4778 m
.54656 .46565 L
s
.813 .232 .1 r
.54964 .47216 m .56215 .46779 L .57115 .48808 L p F P
0 0 0 r
s
.813 .232 .1 r
.57115 .48808 m .5568 .493 L .54964 .47216 L p F P
0 0 0 r
s
.774 .219 .095 r
.5568 .493 m .57115 .48808 L .57856 .50871 L p F P
0 0 0 r
s
.774 .219 .095 r
.57856 .50871 m .56269 .51404 L .5568 .493 L p F P
0 0 0 r
s
.24 .35 .67 r
.74241 .58311 m
.73695 .55992 L
s
.73695 .55992 m
.72091 .53997 L
s
.43924 .46586 m
.45965 .44515 L
s
.949 .277 .119 r
.48946 .42672 m .48411 .42869 L .49185 .4058 L p F P
0 0 0 r
s
.3 .442 .859 r
.48096 .42527 m .48411 .42869 L .49185 .4058 L p F P
0 0 0 r
s
.83 .24 .1 r
.4811 .43051 m
.48705 .42832 L
s
.24 .35 .67 r
.48261 .42756 m
.48611 .43136 L
s
.83 .24 .1 r
.48705 .42832 m
.50035 .45196 L
s
.24 .35 .67 r
.64201 .45071 m
.61987 .44471 L
s
.83 .24 .1 r
.54656 .46565 m
.55628 .49306 L
s
.24 .35 .67 r
.46943 .66603 m
.48178 .68424 L
s
.42213 .48896 m
.43924 .46586 L
s
.917 .266 .114 r
.50563 .42076 m .51105 .41876 L .51612 .43843 L p F P
0 0 0 r
s
.917 .266 .114 r
.52407 .43555 m .51612 .43843 L .51105 .41876 L p F P
0 0 0 r
s
.683 .19 .083 r
.55032 .54046 m .56718 .53489 L .57019 .55515 L p F P
0 0 0 r
s
.683 .19 .083 r
.57019 .55515 m .55255 .56086 L .55032 .54046 L p F P
0 0 0 r
s
.305 .447 .863 r
.47779 .42183 m .4746 .41836 L .46295 .43787 L p F P
0 0 0 r
s
.305 .447 .863 r
.45822 .43286 m .46295 .43787 L .4746 .41836 L p F P
0 0 0 r
s
.308 .449 .863 r
.46295 .43787 m .45822 .43286 L .44612 .45218 L p F P
0 0 0 r
s
.24 .35 .67 r
.45965 .44515 m
.48261 .42756 L
s
.308 .449 .863 r
.43991 .44577 m .44612 .45218 L .45822 .43286 L p F P
0 0 0 r
s
.83 .24 .1 r
.43834 .4206 m
.45096 .43797 L
s
.31 .449 .858 r
.44612 .45218 m .43991 .44577 L .42777 .46489 L p F P
0 0 0 r
s
.264 .365 .665 r
.42843 .5944 m .41766 .5847 L .41791 .60236 L p F P
0 0 0 r
s
.264 .365 .665 r
.41791 .60236 m .42864 .61188 L .42843 .5944 L p F P
0 0 0 r
s
.303 .432 .811 r
.41831 .51442 m .40865 .50516 L .40204 .52554 L p F P
0 0 0 r
s
.303 .432 .811 r
.40204 .52554 m .41246 .53529 L .41831 .51442 L p F P
0 0 0 r
s
.883 .255 .11 r
.52407 .43555 m .53206 .43265 L .54134 .45192 L p F P
0 0 0 r
s
.883 .255 .11 r
.55173 .44822 m .54134 .45192 L .53206 .43265 L p F P
0 0 0 r
s
.849 .243 .105 r
.54134 .45192 m .55173 .44822 L .56215 .46779 L p F P
0 0 0 r
s
.625 .171 .076 r
.5351 .56651 m .55255 .56086 L .55361 .58014 L p F P
0 0 0 r
s
.625 .171 .076 r
.55361 .58014 m .5358 .58581 L .5351 .56651 L p F P
0 0 0 r
s
.83 .24 .1 r
.53361 .55948 m
.53547 .58501 L
s
.949 .277 .119 r
.49185 .4058 m .4946 .40477 L .48946 .42672 L p F P
0 0 0 r
s
.949 .277 .119 r
.49484 .42474 m .48946 .42672 L .4946 .40477 L p F P
0 0 0 r
s
.731 .205 .09 r
.56269 .51404 m .57856 .50871 L .58422 .52928 L p F P
0 0 0 r
s
.731 .205 .09 r
.58422 .52928 m .56718 .53489 L .56269 .51404 L p F P
0 0 0 r
s
.83 .24 .1 r
.52893 .53248 m
.56375 .52084 L
s
.55628 .49306 m
.56375 .52084 L
s
.234 .317 .566 r
.43919 .62123 m .42864 .61188 L .43052 .62713 L p F P
0 0 0 r
s
.234 .317 .566 r
.43052 .62713 m .44077 .63611 L .43919 .62123 L p F P
0 0 0 r
s
.24 .35 .67 r
.43956 .60298 m
.4415 .62652 L
s
.83 .24 .1 r
.34946 .6958 m
.38277 .68572 L
s
.34946 .6958 m
.337 .70644 L
s
.283 .397 .733 r
.41928 .56541 m .40855 .55556 L .4067 .57483 L p F P
0 0 0 r
s
.283 .397 .733 r
.4067 .57483 m .41766 .5847 L .41928 .56541 L p F P
0 0 0 r
s
.24 .35 .67 r
.41842 .58391 m
.42188 .559 L
s
.3 .442 .859 r
.49185 .4058 m .49025 .40402 L .48096 .42527 L p F P
0 0 0 r
s
.3 .442 .859 r
.47779 .42183 m .48096 .42527 L .49025 .40402 L p F P
0 0 0 r
s
.83 .24 .1 r
.48176 .42082 m
.48705 .42832 L
s
.24 .35 .67 r
.48261 .42756 m
.49165 .42251 L
s
.917 .266 .114 r
.51105 .41876 m .51649 .41675 L .52407 .43555 L p F P
0 0 0 r
s
.24 .35 .67 r
.50863 .4152 m
.51162 .41855 L
s
.52184 .43002 m
.52611 .43481 L
s
.917 .266 .114 r
.53206 .43265 m .52407 .43555 L .51649 .41675 L p F P
0 0 0 r
s
.849 .243 .105 r
.57474 .46339 m .56215 .46779 L .55173 .44822 L p F P
0 0 0 r
s
.813 .232 .1 r
.56215 .46779 m .57474 .46339 L .58561 .48312 L p F P
0 0 0 r
s
.813 .232 .1 r
.58561 .48312 m .57115 .48808 L .56215 .46779 L p F P
0 0 0 r
s
.949 .277 .119 r
.4946 .40477 m .49736 .40374 L .49484 .42474 L p F P
0 0 0 r
s
.949 .277 .119 r
.50022 .42275 m .49484 .42474 L .49736 .40374 L p F P
0 0 0 r
s
.464 .121 .054 r
.48349 .61979 m .50072 .6144 L .5007 .62955 L p F P
0 0 0 r
s
.464 .121 .054 r
.5007 .62955 m .48392 .63473 L .48349 .61979 L p F P
0 0 0 r
s
.83 .24 .1 r
.46471 .62983 m
.49918 .61908 L
s
.774 .219 .095 r
.57115 .48808 m .58561 .48312 L .59457 .50333 L p F P
0 0 0 r
s
.774 .219 .095 r
.59457 .50333 m .57856 .50871 L .57115 .48808 L p F P
0 0 0 r
s
.554 .149 .066 r
.51817 .59142 m .5358 .58581 L .53569 .60345 L p F P
0 0 0 r
s
.554 .149 .066 r
.53569 .60345 m .51812 .60895 L .51817 .59142 L p F P
0 0 0 r
s
.83 .24 .1 r
.50071 .59608 m
.53547 .58501 L
s
.24 .35 .67 r
.75223 .65357 m
.75797 .62739 L
s
.75797 .62739 m
.74224 .60854 L
s
.72091 .53997 m
.71028 .51995 L
s
.71028 .51995 m
.6937 .4992 L
s
.55924 .74215 m
.53999 .72534 L
s
.55924 .74215 m
.58328 .74641 L
s
.883 .255 .11 r
.53206 .43265 m .54008 .42974 L .55173 .44822 L p F P
0 0 0 r
s
.83 .24 .1 r
.50035 .45196 m
.53493 .4395 L
s
.883 .255 .11 r
.56217 .4445 m .55173 .44822 L .54008 .42974 L p F P
0 0 0 r
s
.83 .24 .1 r
.53493 .4395 m
.54656 .46565 L
s
.849 .243 .105 r
.55173 .44822 m .56217 .4445 L .57474 .46339 L p F P
0 0 0 r
s
.83 .24 .1 r
.37284 .40581 m
.389 .41719 L
s
.389 .41719 m
.42279 .40425 L
s
.949 .277 .119 r
.49736 .40374 m .50011 .40271 L .50022 .42275 L p F P
0 0 0 r
s
.949 .277 .119 r
.50563 .42076 m .50022 .42275 L .50011 .40271 L p F P
0 0 0 r
s
.343 .084 .039 r
.45086 .64493 m .46731 .63986 L .46896 .65171 L p F P
0 0 0 r
s
.343 .084 .039 r
.46896 .65171 m .45333 .65648 L .45086 .64493 L p F P
0 0 0 r
s
.24 .35 .67 r
.45714 .65532 m
.46943 .66603 L
s
.83 .24 .1 r
.45963 .64947 m
.46471 .62983 L
s
.188 .246 .422 r
.45086 .64493 m .44077 .63611 L .44377 .64819 L p F P
0 0 0 r
s
.188 .246 .422 r
.44377 .64819 m .45333 .65648 L .45086 .64493 L p F P
0 0 0 r
s
.24 .35 .67 r
.44866 .64794 m
.4534 .65206 L
s
.305 .447 .863 r
.4746 .41836 m .4714 .41488 L .45822 .43286 L p F P
0 0 0 r
s
.305 .447 .863 r
.45346 .42781 m .45822 .43286 L .4714 .41488 L p F P
0 0 0 r
s
.308 .449 .863 r
.45822 .43286 m .45346 .42781 L .43991 .44577 L p F P
0 0 0 r
s
.83 .24 .1 r
.24134 .43916 m
.25751 .43872 L
s
.25751 .43872 m
.28999 .42599 L
s
.917 .266 .114 r
.51649 .41675 m .52195 .41474 L .53206 .43265 L p F P
0 0 0 r
s
.917 .266 .114 r
.54008 .42974 m .53206 .43265 L .52195 .41474 L p F P
0 0 0 r
s
.295 .418 .779 r
.41246 .53529 m .40204 .52554 L .39763 .54555 L p F P
0 0 0 r
s
.24 .35 .67 r
.40896 .51364 m
.43024 .5339 L
s
.295 .418 .779 r
.39763 .54555 m .40855 .55556 L .41246 .53529 L p F P
0 0 0 r
s
.3 .442 .859 r
.49025 .40402 m .48864 .40223 L .47779 .42183 L p F P
0 0 0 r
s
.3 .442 .859 r
.4746 .41836 m .47779 .42183 L .48864 .40223 L p F P
0 0 0 r
s
.31 .449 .858 r
.42014 .45721 m .42777 .46489 L .43991 .44577 L p F P
0 0 0 r
s
.309 .446 .849 r
.42777 .46489 m .42014 .45721 L .40846 .47615 L p F P
0 0 0 r
s
.309 .446 .849 r
.40846 .47615 m .41728 .48481 L .42777 .46489 L p F P
0 0 0 r
s
.683 .19 .083 r
.56718 .53489 m .58422 .52928 L .588 .54939 L p F P
0 0 0 r
s
.683 .19 .083 r
.588 .54939 m .57019 .55515 L .56718 .53489 L p F P
0 0 0 r
s
.83 .24 .1 r
.56375 .52084 m
.56871 .54804 L
s
.731 .205 .09 r
.57856 .50871 m .59457 .50333 L .60141 .5236 L p F P
0 0 0 r
s
.731 .205 .09 r
.60141 .5236 m .58422 .52928 L .57856 .50871 L p F P
0 0 0 r
s
.949 .277 .119 r
.50011 .40271 m .50288 .40167 L .50563 .42076 L p F P
0 0 0 r
s
.949 .277 .119 r
.51105 .41876 m .50563 .42076 L .50288 .40167 L p F P
0 0 0 r
s
.83 .24 .1 r
.45186 .65185 m
.45963 .64947 L
s
.42541 .65996 m
.449 .65273 L
s
.42541 .65996 m
.41677 .67543 L
s
.308 .449 .863 r
.43363 .43928 m .43991 .44577 L .45346 .42781 L p F P
0 0 0 r
s
.31 .449 .858 r
.43991 .44577 m .43363 .43928 L .42014 .45721 L p F P
0 0 0 r
s
.307 .441 .834 r
.41728 .48481 m .40846 .47615 L .39883 .49575 L p F P
0 0 0 r
s
.307 .441 .834 r
.39883 .49575 m .40865 .50516 L .41728 .48481 L p F P
0 0 0 r
s
.24 .35 .67 r
.40896 .51364 m
.42213 .48896 L
s
.625 .171 .076 r
.55255 .56086 m .57019 .55515 L .57161 .57442 L p F P
0 0 0 r
s
.83 .24 .1 r
.53361 .55948 m
.56871 .54804 L
s
.625 .171 .076 r
.57161 .57442 m .55361 .58014 L .55255 .56086 L p F P
0 0 0 r
s
.849 .243 .105 r
.58743 .45896 m .57474 .46339 L .56217 .4445 L p F P
0 0 0 r
s
.813 .232 .1 r
.57474 .46339 m .58743 .45896 L .6002 .47813 L p F P
0 0 0 r
s
.813 .232 .1 r
.6002 .47813 m .58561 .48312 L .57474 .46339 L p F P
0 0 0 r
s
.883 .255 .11 r
.54008 .42974 m .54814 .42682 L .56217 .4445 L p F P
0 0 0 r
s
.883 .255 .11 r
.57268 .44076 m .56217 .4445 L .54814 .42682 L p F P
0 0 0 r
s
.849 .243 .105 r
.56217 .4445 m .57268 .44076 L .58743 .45896 L p F P
0 0 0 r
s
.917 .266 .114 r
.52195 .41474 m .52742 .41272 L .54008 .42974 L p F P
0 0 0 r
s
.917 .266 .114 r
.54814 .42682 m .54008 .42974 L .52742 .41272 L p F P
0 0 0 r
s
.24 .35 .67 r
.62746 .76154 m
.60935 .74501 L
s
.62746 .76154 m
.65397 .75463 L
s
.774 .219 .095 r
.58561 .48312 m .6002 .47813 L .61072 .49789 L p F P
0 0 0 r
s
.774 .219 .095 r
.61072 .49789 m .59457 .50333 L .58561 .48312 L p F P
0 0 0 r
s
.83 .24 .1 r
.55628 .49306 m
.59162 .48095 L
s
.949 .277 .119 r
.50288 .40167 m .50565 .40063 L .51105 .41876 L p F P
0 0 0 r
s
.949 .277 .119 r
.51649 .41675 m .51105 .41876 L .50565 .40063 L p F P
0 0 0 r
s
.3 .442 .859 r
.48864 .40223 m .48703 .40043 L .4746 .41836 L p F P
0 0 0 r
s
.3 .442 .859 r
.4714 .41488 m .4746 .41836 L .48703 .40043 L p F P
0 0 0 r
s
.464 .121 .054 r
.50072 .6144 m .51812 .60895 L .51764 .62432 L p F P
0 0 0 r
s
.464 .121 .054 r
.51764 .62432 m .5007 .62955 L .50072 .6144 L p F P
0 0 0 r
s
.83 .24 .1 r
.49918 .61908 m
.50071 .59608 L
s
.24 .35 .67 r
.6937 .4992 m
.67843 .4833 L
s
.83 .24 .1 r
.30393 .71638 m
.337 .70644 L
s
.30393 .71638 m
.28849 .72158 L
s
.554 .149 .066 r
.5358 .58581 m .55361 .58014 L .55345 .59789 L p F P
0 0 0 r
s
.554 .149 .066 r
.55345 .59789 m .53569 .60345 L .5358 .58581 L p F P
0 0 0 r
s
.305 .447 .863 r
.4714 .41488 m .46818 .41138 L .45346 .42781 L p F P
0 0 0 r
s
.305 .447 .863 r
.44865 .42272 m .45346 .42781 L .46818 .41138 L p F P
0 0 0 r
s
.308 .449 .863 r
.45346 .42781 m .44865 .42272 L .43363 .43928 L p F P
0 0 0 r
s
.83 .24 .1 r
.32313 .41301 m
.3394 .4188 L
s
.3394 .4188 m
.37284 .40581 L
s
.303 .432 .811 r
.40865 .50516 m .39883 .49575 L .39145 .51561 L p F P
0 0 0 r
s
.303 .432 .811 r
.39145 .51561 m .40204 .52554 L .40865 .50516 L p F P
0 0 0 r
s
.24 .35 .67 r
.51892 .71585 m
.49885 .69848 L
s
.51892 .71585 m
.53999 .72534 L
s
.949 .277 .119 r
.50565 .40063 m .50842 .3996 L .51649 .41675 L p F P
0 0 0 r
s
.949 .277 .119 r
.52195 .41474 m .51649 .41675 L .50842 .3996 L p F P
0 0 0 r
s
.83 .24 .1 r
.48705 .42832 m
.52174 .41553 L
s
.343 .084 .039 r
.46731 .63986 m .48392 .63473 L .48474 .6469 L p F P
0 0 0 r
s
.343 .084 .039 r
.48474 .6469 m .46896 .65171 L .46731 .63986 L p F P
0 0 0 r
s
.917 .266 .114 r
.52742 .41272 m .53291 .41069 L .54814 .42682 L p F P
0 0 0 r
s
.917 .266 .114 r
.55624 .42388 m .54814 .42682 L .53291 .41069 L p F P
0 0 0 r
s
.24 .35 .67 r
.55142 .42563 m
.55217 .4265 L
s
.83 .24 .1 r
.52174 .41553 m
.53493 .4395 L
s
.883 .255 .11 r
.54814 .42682 m .55624 .42388 L .57268 .44076 L p F P
0 0 0 r
s
.264 .365 .665 r
.41766 .5847 m .4067 .57483 L .40699 .59268 L p F P
0 0 0 r
s
.264 .365 .665 r
.40699 .59268 m .41791 .60236 L .41766 .5847 L p F P
0 0 0 r
s
.849 .243 .105 r
.60021 .45449 m .58743 .45896 L .57268 .44076 L p F P
0 0 0 r
s
.813 .232 .1 r
.58743 .45896 m .60021 .45449 L .6149 .47308 L p F P
0 0 0 r
s
.813 .232 .1 r
.6149 .47308 m .6002 .47813 L .58743 .45896 L p F P
0 0 0 r
s
.883 .255 .11 r
.58326 .43699 m .57268 .44076 L .55624 .42388 L p F P
0 0 0 r
s
.849 .243 .105 r
.57268 .44076 m .58326 .43699 L .60021 .45449 L p F P
0 0 0 r
s
.83 .24 .1 r
.54656 .46565 m
.58182 .45325 L
s
.58182 .45325 m
.59162 .48095 L
s
.234 .317 .566 r
.42864 .61188 m .41791 .60236 L .42008 .618 L p F P
0 0 0 r
s
.24 .35 .67 r
.41842 .58391 m
.43956 .60298 L
s
.234 .317 .566 r
.42008 .618 m .43052 .62713 L .42864 .61188 L p F P
0 0 0 r
s
.683 .19 .083 r
.58422 .52928 m .60141 .5236 L .60599 .54356 L p F P
0 0 0 r
s
.683 .19 .083 r
.60599 .54356 m .588 .54939 L .58422 .52928 L p F P
0 0 0 r
s
.731 .205 .09 r
.59457 .50333 m .61072 .49789 L .61878 .51788 L p F P
0 0 0 r
s
.731 .205 .09 r
.61878 .51788 m .60141 .5236 L .59457 .50333 L p F P
0 0 0 r
s
.83 .24 .1 r
.56375 .52084 m
.59929 .50897 L
s
.59162 .48095 m
.59929 .50897 L
s
.3 .442 .859 r
.48703 .40043 m .48541 .39863 L .4714 .41488 L p F P
0 0 0 r
s
.3 .442 .859 r
.46818 .41138 m .4714 .41488 L .48541 .39863 L p F P
0 0 0 r
s
.83 .24 .1 r
.47253 .40774 m
.47273 .40801 L
s
.43834 .4206 m
.47253 .40774 L
s
.949 .277 .119 r
.50842 .3996 m .51119 .39856 L .52195 .41474 L p F P
0 0 0 r
s
.949 .277 .119 r
.52742 .41272 m .52195 .41474 L .51119 .39856 L p F P
0 0 0 r
s
.283 .397 .733 r
.40855 .55556 m .39763 .54555 L .39554 .56478 L p F P
0 0 0 r
s
.283 .397 .733 r
.39554 .56478 m .4067 .57483 L .40855 .55556 L p F P
0 0 0 r
s
.24 .35 .67 r
.72628 .56333 m
.74241 .58311 L
s
.74224 .60854 m
.74241 .58311 L
s
.308 .449 .863 r
.42728 .43273 m .43363 .43928 L .44865 .42272 L p F P
0 0 0 r
s
.31 .449 .858 r
.43363 .43928 m .42728 .43273 L .41241 .44943 L p F P
0 0 0 r
s
.31 .449 .858 r
.41241 .44943 m .42014 .45721 L .43363 .43928 L p F P
0 0 0 r
s
.625 .171 .076 r
.57019 .55515 m .588 .54939 L .58979 .56863 L p F P
0 0 0 r
s
.625 .171 .076 r
.58979 .56863 m .57161 .57442 L .57019 .55515 L p F P
0 0 0 r
s
.83 .24 .1 r
.56871 .54804 m
.57094 .57372 L
s
.309 .446 .849 r
.42014 .45721 m .41241 .44943 L .39951 .46737 L p F P
0 0 0 r
s
.309 .446 .849 r
.39951 .46737 m .40846 .47615 L .42014 .45721 L p F P
0 0 0 r
s
.83 .24 .1 r
.47253 .40774 m
.47369 .4073 L
s
.774 .219 .095 r
.6002 .47813 m .6149 .47308 L .62703 .49241 L p F P
0 0 0 r
s
.774 .219 .095 r
.62703 .49241 m .61072 .49789 L .6002 .47813 L p F P
0 0 0 r
s
.83 .24 .1 r
.19413 .4584 m
.20913 .45184 L
s
.20913 .45184 m
.24134 .43916 L
s
.38277 .68572 m
.41677 .67543 L
s
.38277 .68572 m
.37075 .69629 L
s
.917 .266 .114 r
.53291 .41069 m .53842 .40866 L .55624 .42388 L p F P
0 0 0 r
s
.917 .266 .114 r
.56438 .42093 m .55624 .42388 L .53842 .40866 L p F P
0 0 0 r
s
.883 .255 .11 r
.55624 .42388 m .56438 .42093 L .58326 .43699 L p F P
0 0 0 r
s
.24 .35 .67 r
.74091 .67945 m
.75223 .65357 L
s
.75223 .65357 m
.73626 .63504 L
s
.949 .277 .119 r
.51119 .39856 m .51397 .39751 L .52742 .41272 L p F P
0 0 0 r
s
.949 .277 .119 r
.53291 .41069 m .52742 .41272 L .51397 .39751 L p F P
0 0 0 r
s
.982 .288 .123 r
.4946 .40477 m .49185 .4058 L .5 .38446 L closepath p F P
0 0 0 r
s
.293 .434 .848 r
.49025 .40402 m .49185 .4058 L .5 .38446 L closepath p F P
0 0 0 r
s
.305 .447 .863 r
.46818 .41138 m .46494 .40786 L .44865 .42272 L p F P
0 0 0 r
s
.305 .447 .863 r
.44381 .4176 m .44865 .42272 L .46494 .40786 L p F P
0 0 0 r
s
.308 .449 .863 r
.44865 .42272 m .44381 .4176 L .42728 .43273 L p F P
0 0 0 r
s
.83 .24 .1 r
.42279 .40425 m
.43834 .4206 L
s
.188 .246 .422 r
.44077 .63611 m .43052 .62713 L .43407 .63977 L p F P
0 0 0 r
s
.188 .246 .422 r
.43407 .63977 m .44377 .64819 L .44077 .63611 L p F P
0 0 0 r
s
.24 .35 .67 r
.4415 .62652 m
.44866 .64794 L
s
.464 .121 .054 r
.51812 .60895 m .53569 .60345 L .53475 .61904 L p F P
0 0 0 r
s
.464 .121 .054 r
.53475 .61904 m .51764 .62432 L .51812 .60895 L p F P
0 0 0 r
s
.83 .24 .1 r
.49918 .61908 m
.53436 .60811 L
s
.883 .255 .11 r
.59389 .4332 m .58326 .43699 L .56438 .42093 L p F P
0 0 0 r
s
.849 .243 .105 r
.58326 .43699 m .59389 .4332 L .61308 .44999 L p F P
0 0 0 r
s
.849 .243 .105 r
.61308 .44999 m .60021 .45449 L .58326 .43699 L p F P
0 0 0 r
s
.307 .441 .834 r
.40846 .47615 m .39951 .46737 L .38885 .48619 L p F P
0 0 0 r
s
.307 .441 .834 r
.38885 .48619 m .39883 .49575 L .40846 .47615 L p F P
0 0 0 r
s
.24 .35 .67 r
.40045 .46767 m
.42213 .48896 L
s
.3 .442 .859 r
.48541 .39863 m .48379 .39682 L .46818 .41138 L p F P
0 0 0 r
s
.3 .442 .859 r
.46494 .40786 m .46818 .41138 L .48379 .39682 L p F P
0 0 0 r
s
.24 .35 .67 r
.48178 .68424 m
.46096 .66623 L
s
.48178 .68424 m
.49885 .69848 L
s
.982 .288 .123 r
.49736 .40374 m .4946 .40477 L .5 .38446 L closepath p F P
0 0 0 r
s
.295 .418 .779 r
.40204 .52554 m .39145 .51561 L .38652 .53535 L p F P
0 0 0 r
s
.295 .418 .779 r
.38652 .53535 m .39763 .54555 L .40204 .52554 L p F P
0 0 0 r
s
.24 .35 .67 r
.40028 .53902 m
.40896 .51364 L
s
.40028 .53902 m
.42188 .559 L
s
.813 .232 .1 r
.60021 .45449 m .61308 .44999 L .62973 .468 L p F P
0 0 0 r
s
.813 .232 .1 r
.62973 .468 m .6149 .47308 L .60021 .45449 L p F P
0 0 0 r
s
.554 .149 .066 r
.55361 .58014 m .57161 .57442 L .57138 .59227 L p F P
0 0 0 r
s
.554 .149 .066 r
.57138 .59227 m .55345 .59789 L .55361 .58014 L p F P
0 0 0 r
s
.83 .24 .1 r
.53547 .58501 m
.57094 .57372 L
s
.949 .277 .119 r
.51397 .39751 m .51676 .39647 L .53291 .41069 L p F P
0 0 0 r
s
.949 .277 .119 r
.53842 .40866 m .53291 .41069 L .51676 .39647 L p F P
0 0 0 r
s
.24 .35 .67 r
.53152 .40478 m
.53293 .40425 L
s
.53293 .40425 m
.53516 .40683 L
s
.293 .434 .848 r
.48864 .40223 m .49025 .40402 L .5 .38446 L closepath p F P
0 0 0 r
s
.982 .288 .123 r
.50011 .40271 m .49736 .40374 L .5 .38446 L closepath p F P
0 0 0 r
s
.917 .266 .114 r
.53842 .40866 m .54394 .40662 L .56438 .42093 L p F P
0 0 0 r
s
.917 .266 .114 r
.57255 .41797 m .56438 .42093 L .54394 .40662 L p F P
0 0 0 r
s
.883 .255 .11 r
.56438 .42093 m .57255 .41797 L .59389 .4332 L p F P
0 0 0 r
s
.83 .24 .1 r
.5702 .42679 m
.58182 .45325 L
s
.53493 .4395 m
.5702 .42679 L
s
.343 .084 .039 r
.48392 .63473 m .5007 .62955 L .50066 .64204 L p F P
0 0 0 r
s
.343 .084 .039 r
.50066 .64204 m .48474 .6469 L .48392 .63473 L p F P
0 0 0 r
s
.83 .24 .1 r
.49456 .63876 m
.49918 .61908 L
s
.24 .35 .67 r
.65397 .75463 m
.63619 .73785 L
s
.65397 .75463 m
.67986 .74226 L
s
.83 .24 .1 r
.27421 .42621 m
.28999 .42599 L
s
.28999 .42599 m
.32313 .41301 L
s
.731 .205 .09 r
.61072 .49789 m .62703 .49241 L .63632 .51209 L p F P
0 0 0 r
s
.731 .205 .09 r
.63632 .51209 m .61878 .51788 L .61072 .49789 L p F P
0 0 0 r
s
.982 .288 .123 r
.50288 .40167 m .50011 .40271 L .5 .38446 L closepath p F P
0 0 0 r
s
.683 .19 .083 r
.60141 .5236 m .61878 .51788 L .62417 .53768 L p F P
0 0 0 r
s
.683 .19 .083 r
.62417 .53768 m .60599 .54356 L .60141 .5236 L p F P
0 0 0 r
s
.83 .24 .1 r
.59929 .50897 m
.60453 .53636 L
s
.24 .35 .67 r
.58328 .74641 m
.56423 .72948 L
s
.58328 .74641 m
.60935 .74501 L
s
.293 .434 .848 r
.48703 .40043 m .48864 .40223 L .5 .38446 L closepath p F P
0 0 0 r
s
.949 .277 .119 r
.51676 .39647 m .51955 .39542 L .53842 .40866 L p F P
0 0 0 r
s
.949 .277 .119 r
.54394 .40662 m .53842 .40866 L .51955 .39542 L p F P
0 0 0 r
s
.774 .219 .095 r
.6149 .47308 m .62973 .468 L .64348 .48688 L p F P
0 0 0 r
s
.774 .219 .095 r
.64348 .48688 m .62703 .49241 L .6149 .47308 L p F P
0 0 0 r
s
.83 .24 .1 r
.59162 .48095 m
.62769 .46858 L
s
.982 .288 .123 r
.50565 .40063 m .50288 .40167 L .5 .38446 L closepath p F P
0 0 0 r
s
.3 .442 .859 r
.48379 .39682 m .48216 .39501 L .46494 .40786 L p F P
0 0 0 r
s
.3 .442 .859 r
.46168 .40433 m .46494 .40786 L .48216 .39501 L p F P
0 0 0 r
s
.305 .447 .863 r
.46494 .40786 m .46168 .40433 L .44381 .4176 L p F P
0 0 0 r
s
.24 .35 .67 r
.46204 .40522 m
.48261 .42756 L
s
.883 .255 .11 r
.60459 .42939 m .59389 .4332 L .57255 .41797 L p F P
0 0 0 r
s
.849 .243 .105 r
.59389 .4332 m .60459 .42939 L .62605 .44546 L p F P
0 0 0 r
s
.24 .35 .67 r
.61795 .44238 m
.61987 .44471 L
s
.849 .243 .105 r
.62605 .44546 m .61308 .44999 L .59389 .4332 L p F P
0 0 0 r
s
.625 .171 .076 r
.588 .54939 m .60599 .54356 L .60816 .56279 L p F P
0 0 0 r
s
.83 .24 .1 r
.56871 .54804 m
.60453 .53636 L
s
.625 .171 .076 r
.60816 .56279 m .58979 .56863 L .588 .54939 L p F P
0 0 0 r
s
.308 .449 .863 r
.42087 .42611 m .42728 .43273 L .44381 .4176 L p F P
0 0 0 r
s
.31 .449 .858 r
.42728 .43273 m .42087 .42611 L .40459 .44156 L p F P
0 0 0 r
s
.31 .449 .858 r
.40459 .44156 m .41241 .44943 L .42728 .43273 L p F P
0 0 0 r
s
.24 .35 .67 r
.41794 .44424 m
.43924 .46586 L
s
.917 .266 .114 r
.54394 .40662 m .54949 .40458 L .57255 .41797 L p F P
0 0 0 r
s
.917 .266 .114 r
.58077 .41499 m .57255 .41797 L .54949 .40458 L p F P
0 0 0 r
s
.24 .35 .67 r
.5645 .40669 m
.56788 .4107 L
s
.57366 .41756 m
.57462 .4187 L
s
.883 .255 .11 r
.57255 .41797 m .58077 .41499 L .60459 .42939 L p F P
0 0 0 r
s
.24 .35 .67 r
.60176 .42271 m
.61156 .43461 L
s
.59317 .42249 m
.60176 .42271 L
s
.982 .288 .123 r
.50842 .3996 m .50565 .40063 L .5 .38446 L closepath p F P
0 0 0 r
s
.293 .434 .848 r
.48541 .39863 m .48703 .40043 L .5 .38446 L closepath p F P
0 0 0 r
s
.303 .432 .811 r
.39883 .49575 m .38885 .48619 L .38068 .50552 L p F P
0 0 0 r
s
.303 .432 .811 r
.38068 .50552 m .39145 .51561 L .39883 .49575 L p F P
0 0 0 r
s
.305 .447 .863 r
.43893 .41243 m .44381 .4176 L .46168 .40433 L p F P
0 0 0 r
s
.308 .449 .863 r
.44381 .4176 m .43893 .41243 L .42087 .42611 L p F P
0 0 0 r
s
.24 .35 .67 r
.43871 .42317 m
.45965 .44515 L
s
.72628 .56333 m
.72091 .53997 L
s
.72091 .53997 m
.70431 .51931 L
s
.949 .277 .119 r
.51955 .39542 m .52234 .39438 L .54394 .40662 L p F P
0 0 0 r
s
.949 .277 .119 r
.54949 .40458 m .54394 .40662 L .52234 .39438 L p F P
0 0 0 r
s
.24 .35 .67 r
.41794 .44424 m
.43871 .42317 L
s
.813 .232 .1 r
.61308 .44999 m .62605 .44546 L .64468 .46288 L p F P
0 0 0 r
s
.813 .232 .1 r
.64468 .46288 m .62973 .468 L .61308 .44999 L p F P
0 0 0 r
s
.982 .288 .123 r
.51119 .39856 m .50842 .3996 L .5 .38446 L closepath p F P
0 0 0 r
s
.309 .446 .849 r
.41241 .44943 m .40459 .44156 L .39043 .45845 L p F P
0 0 0 r
s
.309 .446 .849 r
.39043 .45845 m .39951 .46737 L .41241 .44943 L p F P
0 0 0 r
s
.24 .35 .67 r
.40045 .46767 m
.41794 .44424 L
s
.464 .121 .054 r
.53569 .60345 m .55345 .59789 L .55203 .61371 L p F P
0 0 0 r
s
.464 .121 .054 r
.55203 .61371 m .53475 .61904 L .53569 .60345 L p F P
0 0 0 r
s
.83 .24 .1 r
.53436 .60811 m
.53547 .58501 L
s
.24 .35 .67 r
.7245 .70368 m
.74091 .67945 L
s
.74091 .67945 m
.72464 .66127 L
s
.293 .434 .848 r
.48379 .39682 m .48541 .39863 L .5 .38446 L closepath p F P
0 0 0 r
s
.229 .055 .024 r
.45333 .65648 m .46896 .65171 L .47139 .66034 L p F P
0 0 0 r
s
.229 .055 .024 r
.47139 .66034 m .45696 .6647 L .45333 .65648 L p F P
0 0 0 r
s
.24 .35 .67 r
.45943 .66396 m
.46096 .66623 L
s
.147 .182 .324 r
.45333 .65648 m .44377 .64819 L .44819 .65713 L p F P
0 0 0 r
s
.147 .182 .324 r
.44819 .65713 m .45696 .6647 L .45333 .65648 L p F P
0 0 0 r
s
.83 .24 .1 r
.45264 .6627 m
.45327 .66151 L
s
.45416 .65981 m
.45963 .64947 L
s
.24 .35 .67 r
.44866 .64794 m
.4569 .66019 L
s
.83 .24 .1 r
.45146 .66493 m
.45264 .6627 L
s
.982 .288 .123 r
.51397 .39751 m .51119 .39856 L .5 .38446 L closepath p F P
0 0 0 r
s
.264 .365 .665 r
.4067 .57483 m .39554 .56478 L .39587 .58282 L p F P
0 0 0 r
s
.264 .365 .665 r
.39587 .58282 m .40699 .59268 L .4067 .57483 L p F P
0 0 0 r
s
.949 .277 .119 r
.52234 .39438 m .52514 .39333 L .54949 .40458 L p F P
0 0 0 r
s
.949 .277 .119 r
.55505 .40253 m .54949 .40458 L .52514 .39333 L p F P
0 0 0 r
s
.917 .266 .114 r
.54949 .40458 m .55505 .40253 L .58077 .41499 L p F P
0 0 0 r
s
.83 .24 .1 r
.337 .70644 m
.37075 .69629 L
s
.337 .70644 m
.32198 .71152 L
s
.3 .442 .859 r
.48216 .39501 m .48053 .3932 L .46168 .40433 L p F P
0 0 0 r
s
.3 .442 .859 r
.4584 .40077 m .46168 .40433 L .48053 .3932 L p F P
0 0 0 r
s
.305 .447 .863 r
.46168 .40433 m .4584 .40077 L .43893 .41243 L p F P
0 0 0 r
s
.24 .35 .67 r
.43871 .42317 m
.46204 .40522 L
s
.917 .266 .114 r
.58902 .41199 m .58077 .41499 L .55505 .40253 L p F P
0 0 0 r
s
.883 .255 .11 r
.58077 .41499 m .58902 .41199 L .61536 .42556 L p F P
0 0 0 r
s
.883 .255 .11 r
.61536 .42556 m .60459 .42939 L .58077 .41499 L p F P
0 0 0 r
s
.554 .149 .066 r
.57161 .57442 m .58979 .56863 L .58951 .5866 L p F P
0 0 0 r
s
.554 .149 .066 r
.58951 .5866 m .57138 .59227 L .57161 .57442 L p F P
0 0 0 r
s
.83 .24 .1 r
.35696 .39975 m
.37284 .40581 L
s
.234 .317 .566 r
.41791 .60236 m .40699 .59268 L .40947 .60871 L p F P
0 0 0 r
s
.234 .317 .566 r
.40947 .60871 m .42008 .618 L .41791 .60236 L p F P
0 0 0 r
s
.24 .35 .67 r
.41842 .58391 m
.42014 .60765 L
s
.982 .288 .123 r
.51676 .39647 m .51397 .39751 L .5 .38446 L closepath p F P
0 0 0 r
s
.849 .243 .105 r
.60459 .42939 m .61536 .42556 L .63911 .4409 L p F P
0 0 0 r
s
.849 .243 .105 r
.63911 .4409 m .62605 .44546 L .60459 .42939 L p F P
0 0 0 r
s
.24 .35 .67 r
.63517 .44227 m
.64201 .45071 L
s
.83 .24 .1 r
.58182 .45325 m
.6178 .4406 L
s
.343 .084 .039 r
.5007 .62955 m .51764 .62432 L .51674 .63714 L p F P
0 0 0 r
s
.343 .084 .039 r
.51674 .63714 m .50066 .64204 L .5007 .62955 L p F P
0 0 0 r
s
.293 .434 .848 r
.48216 .39501 m .48379 .39682 L .5 .38446 L closepath p F P
0 0 0 r
s
.731 .205 .09 r
.62703 .49241 m .64348 .48688 L .65403 .50625 L p F P
0 0 0 r
s
.731 .205 .09 r
.65403 .50625 m .63632 .51209 L .62703 .49241 L p F P
0 0 0 r
s
.83 .24 .1 r
.59929 .50897 m
.63555 .49685 L
s
.24 .35 .67 r
.67986 .74226 m
.66246 .72517 L
s
.67986 .74226 m
.70379 .72498 L
s
.283 .397 .733 r
.39763 .54555 m .38652 .53535 L .38418 .55455 L p F P
0 0 0 r
s
.283 .397 .733 r
.38418 .55455 m .39554 .56478 L .39763 .54555 L p F P
0 0 0 r
s
.24 .35 .67 r
.39653 .56417 m
.40028 .53902 L
s
.982 .288 .123 r
.51955 .39542 m .51676 .39647 L .5 .38446 L closepath p F P
0 0 0 r
s
.774 .219 .095 r
.62973 .468 m .64468 .46288 L .66009 .4813 L p F P
0 0 0 r
s
.774 .219 .095 r
.66009 .4813 m .64348 .48688 L .62973 .468 L p F P
0 0 0 r
s
.683 .19 .083 r
.61878 .51788 m .63632 .51209 L .64253 .53173 L p F P
0 0 0 r
s
.683 .19 .083 r
.64253 .53173 m .62417 .53768 L .61878 .51788 L p F P
0 0 0 r
s
.949 .277 .119 r
.52514 .39333 m .52795 .39228 L .55505 .40253 L p F P
0 0 0 r
s
.949 .277 .119 r
.56063 .40047 m .55505 .40253 L .52795 .39228 L p F P
0 0 0 r
s
.917 .266 .114 r
.55505 .40253 m .56063 .40047 L .58902 .41199 L p F P
0 0 0 r
s
.83 .24 .1 r
.52174 .41553 m
.55714 .40248 L
s
.6178 .4406 m
.62769 .46858 L
s
.62769 .46858 m
.63555 .49685 L
s
.307 .441 .834 r
.39951 .46737 m .39043 .45845 L .37871 .47647 L p F P
0 0 0 r
s
.307 .441 .834 r
.37871 .47647 m .38885 .48619 L .39951 .46737 L p F P
0 0 0 r
s
.982 .288 .123 r
.52234 .39438 m .51955 .39542 L .5 .38446 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.50743 .39461 m
.52174 .41553 L
s
.813 .232 .1 r
.62605 .44546 m .63911 .4409 L .65976 .45771 L p F P
0 0 0 r
s
.813 .232 .1 r
.65976 .45771 m .64468 .46288 L .62605 .44546 L p F P
0 0 0 r
s
.305 .447 .863 r
.43401 .40721 m .43893 .41243 L .4584 .40077 L p F P
0 0 0 r
s
.308 .449 .863 r
.43893 .41243 m .43401 .40721 L .41439 .41942 L p F P
0 0 0 r
s
.308 .449 .863 r
.41439 .41942 m .42087 .42611 L .43893 .41243 L p F P
0 0 0 r
s
.293 .434 .848 r
.48053 .3932 m .48216 .39501 L .5 .38446 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.48645 .4025 m
.50743 .39461 L
s
.217 .336 .687 r
.6099 .41886 m .61536 .42556 L .58902 .41199 L p F P
0 0 0 r
s
.217 .336 .687 r
.58902 .41199 m .58471 .40678 L .6099 .41886 L p F P
0 0 0 r
s
.83 .24 .1 r
.60231 .41522 m
.6062 .41382 L
s
.5702 .42679 m
.59891 .41645 L
s
.6062 .41382 m
.60799 .41794 L
s
.247 .376 .756 r
.58471 .40678 m .58902 .41199 L .56063 .40047 L p F P
0 0 0 r
s
.83 .24 .1 r
.55714 .40248 m
.5702 .42679 L
s
.188 .246 .422 r
.43052 .62713 m .42008 .618 L .4242 .63121 L p F P
0 0 0 r
s
.24 .35 .67 r
.42014 .60765 m
.4415 .62652 L
s
.188 .246 .422 r
.4242 .63121 m .43407 .63977 L .43052 .62713 L p F P
0 0 0 r
s
.24 .35 .67 r
.70379 .72498 m
.7245 .70368 L
s
.7245 .70368 m
.70788 .68587 L
s
.625 .171 .076 r
.60599 .54356 m .62417 .53768 L .62672 .55688 L p F P
0 0 0 r
s
.625 .171 .076 r
.62672 .55688 m .60816 .56279 L .60599 .54356 L p F P
0 0 0 r
s
.83 .24 .1 r
.60453 .53636 m
.60713 .56219 L
s
.982 .288 .123 r
.52514 .39333 m .52234 .39438 L .5 .38446 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.73626 .63504 m
.74224 .60854 L
s
.74224 .60854 m
.72594 .58902 L
s
.70431 .51931 m
.6937 .4992 L
s
.3 .442 .859 r
.48053 .3932 m .4789 .39138 L .4584 .40077 L p F P
0 0 0 r
s
.3 .442 .859 r
.45511 .39719 m .4584 .40077 L .4789 .39138 L p F P
0 0 0 r
s
.305 .447 .863 r
.4584 .40077 m .45511 .39719 L .43401 .40721 L p F P
0 0 0 r
s
.24 .35 .67 r
.53999 .72534 m
.52003 .70792 L
s
.53999 .72534 m
.56423 .72948 L
s
.31 .449 .858 r
.42087 .42611 m .41439 .41942 L .39666 .43358 L p F P
0 0 0 r
s
.31 .449 .858 r
.39666 .43358 m .40459 .44156 L .42087 .42611 L p F P
0 0 0 r
s
.83 .24 .1 r
.22674 .44557 m
.24134 .43916 L
s
.24134 .43916 m
.27421 .42621 L
s
.949 .277 .119 r
.52795 .39228 m .53075 .39123 L .56063 .40047 L p F P
0 0 0 r
s
.247 .376 .756 r
.56063 .40047 m .55762 .39689 L .58471 .40678 L p F P
0 0 0 r
s
.268 .403 .801 r
.55762 .39689 m .56063 .40047 L .53075 .39123 L p F P
0 0 0 r
s
.83 .24 .1 r
.55714 .40248 m
.56336 .40019 L
s
.24 .35 .67 r
.55848 .39954 m
.56183 .40351 L
s
.54905 .40128 m
.55848 .39954 L
s
.295 .418 .779 r
.39145 .51561 m .38068 .50552 L .37521 .52497 L p F P
0 0 0 r
s
.295 .418 .779 r
.37521 .52497 m .38652 .53535 L .39145 .51561 L p F P
0 0 0 r
s
.24 .35 .67 r
.70379 .72498 m
.68679 .70755 L
s
.83 .24 .1 r
.41677 .67543 m
.45146 .66493 L
s
.41677 .67543 m
.4052 .68593 L
s
.174 .276 .58 r
.63267 .43291 m .63911 .4409 L .61536 .42556 L p F P
0 0 0 r
s
.83 .24 .1 r
.6178 .4406 m
.63172 .4357 L
s
.174 .276 .58 r
.61536 .42556 m .6099 .41886 L .63267 .43291 L p F P
0 0 0 r
s
.83 .24 .1 r
.60953 .42151 m
.6178 .4406 L
s
.982 .288 .123 r
.52795 .39228 m .52514 .39333 L .5 .38446 L closepath p F P
0 0 0 r
s
.293 .434 .848 r
.4789 .39138 m .48053 .3932 L .5 .38446 L closepath p F P
0 0 0 r
s
.229 .055 .024 r
.46896 .65171 m .48474 .6469 L .48594 .65595 L p F P
0 0 0 r
s
.83 .24 .1 r
.45963 .64947 m
.49456 .63876 L
s
.229 .055 .024 r
.48594 .65595 m .47139 .66034 L .46896 .65171 L p F P
0 0 0 r
s
.982 .288 .123 r
.53075 .39123 m .52795 .39228 L .5 .38446 L closepath p F P
0 0 0 r
s
.464 .121 .054 r
.55345 .59789 m .57138 .59227 L .56948 .60832 L p F P
0 0 0 r
s
.464 .121 .054 r
.56948 .60832 m .55203 .61371 L .55345 .59789 L p F P
0 0 0 r
s
.293 .434 .848 r
.47726 .38955 m .4789 .39138 L .5 .38446 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.48709 .39105 m
.4993 .40473 L
s
.3 .442 .859 r
.4789 .39138 m .47726 .38955 L .45511 .39719 L p F P
0 0 0 r
s
.268 .403 .801 r
.53075 .39123 m .52919 .3894 L .55762 .39689 L p F P
0 0 0 r
s
.283 .421 .83 r
.5 .38446 m .52919 .3894 L .53075 .39123 L closepath p F P
0 0 0 r
s
.309 .446 .849 r
.40459 .44156 m .39666 .43358 L .38122 .44941 L p F P
0 0 0 r
s
.309 .446 .849 r
.38122 .44941 m .39043 .45845 L .40459 .44156 L p F P
0 0 0 r
s
.343 .084 .039 r
.51764 .62432 m .53475 .61904 L .53296 .63219 L p F P
0 0 0 r
s
.343 .084 .039 r
.53296 .63219 m .51674 .63714 L .51764 .62432 L p F P
0 0 0 r
s
.774 .219 .095 r
.64468 .46288 m .65976 .45771 L .67686 .47566 L p F P
0 0 0 r
s
.24 .35 .67 r
.67018 .47301 m
.67843 .4833 L
s
.774 .219 .095 r
.67686 .47566 m .66009 .4813 L .64468 .46288 L p F P
0 0 0 r
s
.554 .149 .066 r
.58979 .56863 m .60816 .56279 L .60782 .58087 L p F P
0 0 0 r
s
.554 .149 .066 r
.60782 .58087 m .58951 .5866 L .58979 .56863 L p F P
0 0 0 r
s
.83 .24 .1 r
.57094 .57372 m
.60713 .56219 L
s
.731 .205 .09 r
.64348 .48688 m .66009 .4813 L .67191 .50035 L p F P
0 0 0 r
s
.731 .205 .09 r
.67191 .50035 m .65403 .50625 L .64348 .48688 L p F P
0 0 0 r
s
.3 .442 .859 r
.4518 .39359 m .45511 .39719 L .47726 .38955 L p F P
0 0 0 r
s
.83 .24 .1 r
.45727 .39105 m
.45861 .39251 L
s
.24 .35 .67 r
.46204 .40522 m
.48709 .39105 L
s
.305 .447 .863 r
.45511 .39719 m .4518 .39359 L .42905 .40196 L p F P
0 0 0 r
s
.305 .447 .863 r
.42905 .40196 m .43401 .40721 L .45511 .39719 L p F P
0 0 0 r
s
.83 .24 .1 r
.42279 .40425 m
.45727 .39105 L
s
.131 .209 .459 r
.65252 .44865 m .65976 .45771 L .63911 .4409 L p F P
0 0 0 r
s
.131 .209 .459 r
.63911 .4409 m .63267 .43291 L .65252 .44865 L p F P
0 0 0 r
s
.247 .376 .756 r
.58036 .40152 m .58471 .40678 L .55762 .39689 L p F P
0 0 0 r
s
.247 .376 .756 r
.55762 .39689 m .55459 .39329 L .58036 .40152 L p F P
0 0 0 r
s
.268 .403 .801 r
.55459 .39329 m .55762 .39689 L .52919 .3894 L p F P
0 0 0 r
s
.83 .24 .1 r
.552 .39473 m
.55714 .40248 L
s
.303 .432 .811 r
.38885 .48619 m .37871 .47647 L .36972 .49525 L p F P
0 0 0 r
s
.303 .432 .811 r
.36972 .49525 m .38068 .50552 L .38885 .48619 L p F P
0 0 0 r
s
.24 .35 .67 r
.38692 .49266 m
.40045 .46767 L
s
.38692 .49266 m
.40896 .51364 L
s
.683 .19 .083 r
.63632 .51209 m .65403 .50625 L .66109 .52572 L p F P
0 0 0 r
s
.683 .19 .083 r
.66109 .52572 m .64253 .53173 L .63632 .51209 L p F P
0 0 0 r
s
.83 .24 .1 r
.63555 .49685 m
.64109 .52445 L
s
.24 .35 .67 r
.60935 .74501 m
.59058 .72789 L
s
.60935 .74501 m
.63619 .73785 L
s
.308 .449 .863 r
.43401 .40721 m .42905 .40196 L .40784 .41266 L p F P
0 0 0 r
s
.308 .449 .863 r
.40784 .41266 m .41439 .41942 L .43401 .40721 L p F P
0 0 0 r
s
.293 .434 .848 r
.47561 .38772 m .47726 .38955 L .5 .38446 L closepath p F P
0 0 0 r
s
.3 .442 .859 r
.47726 .38955 m .47561 .38772 L .4518 .39359 L p F P
0 0 0 r
s
.83 .24 .1 r
.30777 .413 m
.32313 .41301 L
s
.32313 .41301 m
.35696 .39975 L
s
.268 .403 .801 r
.52919 .3894 m .52762 .38757 L .55459 .39329 L p F P
0 0 0 r
s
.283 .421 .83 r
.5 .38446 m .52762 .38757 L .52919 .3894 L closepath p F P
0 0 0 r
s
.217 .336 .687 r
.60439 .4121 m .6099 .41886 L .58471 .40678 L p F P
0 0 0 r
s
.217 .336 .687 r
.58471 .40678 m .58036 .40152 L .60439 .4121 L p F P
0 0 0 r
s
.83 .24 .1 r
.28849 .72158 m
.32198 .71152 L
s
.28849 .72158 m
.27109 .72076 L
s
.147 .182 .324 r
.44377 .64819 m .43407 .63977 L .43928 .64944 L p F P
0 0 0 r
s
.147 .182 .324 r
.43928 .64944 m .44819 .65713 L .44377 .64819 L p F P
0 0 0 r
s
.625 .171 .076 r
.62417 .53768 m .64253 .53173 L .64548 .55091 L p F P
0 0 0 r
s
.83 .24 .1 r
.60453 .53636 m
.64109 .52445 L
s
.625 .171 .076 r
.64548 .55091 m .62672 .55688 L .62417 .53768 L p F P
0 0 0 r
s
.293 .434 .848 r
.47396 .38588 m .47561 .38772 L .5 .38446 L closepath p F P
0 0 0 r
s
.3 .442 .859 r
.47561 .38772 m .47396 .38588 L .44847 .38997 L p F P
0 0 0 r
s
.83 .24 .1 r
.45517 .38942 m
.45727 .39105 L
s
.45727 .39105 m
.46331 .38874 L
s
.3 .442 .859 r
.44847 .38997 m .4518 .39359 L .47561 .38772 L p F P
0 0 0 r
s
.268 .403 .801 r
.55154 .38967 m .55459 .39329 L .52762 .38757 L p F P
0 0 0 r
s
.268 .403 .801 r
.52762 .38757 m .52604 .38573 L .55154 .38967 L p F P
0 0 0 r
s
.283 .421 .83 r
.5 .38446 m .52604 .38573 L .52762 .38757 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.50743 .39461 m
.52867 .38662 L
s
.24 .35 .67 r
.49885 .69848 m
.47805 .68048 L
s
.49885 .69848 m
.52003 .70792 L
s
.31 .449 .858 r
.41439 .41942 m .40784 .41266 L .38863 .4255 L p F P
0 0 0 r
s
.31 .449 .858 r
.38863 .4255 m .39666 .43358 L .41439 .41942 L p F P
0 0 0 r
s
.305 .447 .863 r
.4518 .39359 m .44847 .38997 L .42405 .39666 L p F P
0 0 0 r
s
.305 .447 .863 r
.42405 .39666 m .42905 .40196 L .4518 .39359 L p F P
0 0 0 r
s
1 .299 .127 r
.5 .38446 m .50841 .36518 L .50556 .36627 L closepath p F P
0 0 0 r
s
1 .299 .127 r
.5 .38446 m .50556 .36627 L .50272 .36737 L closepath p F P
0 0 0 r
s
1 .299 .127 r
.5 .38446 m .50272 .36737 L .49988 .36846 L closepath p F P
0 0 0 r
s
1 .299 .127 r
.5 .38446 m .49988 .36846 L .49705 .36955 L closepath p F P
0 0 0 r
s
1 .299 .127 r
.5 .38446 m .49705 .36955 L .49422 .37064 L closepath p F P
0 0 0 r
s
1 .299 .127 r
.5 .38446 m .49422 .37064 L .4914 .37172 L closepath p F P
0 0 0 r
s
1 .299 .127 r
.5 .38446 m .47177 .37927 L .46899 .38034 L closepath p F P
0 0 0 r
s
.283 .421 .83 r
.5 .38446 m .50841 .36518 L .51003 .36707 L closepath p F P
0 0 0 r
s
.283 .421 .83 r
.5 .38446 m .51003 .36707 L .51165 .36896 L closepath p F P
0 0 0 r
s
.283 .421 .83 r
.5 .38446 m .51165 .36896 L .51327 .37085 L closepath p F P
0 0 0 r
s
.283 .421 .83 r
.5 .38446 m .51969 .37833 L .52129 .38019 L closepath p F P
0 0 0 r
s
1 .299 .127 r
.5 .38446 m .4914 .37172 L .48858 .37281 L closepath p F P
0 0 0 r
s
1 .299 .127 r
.5 .38446 m .48858 .37281 L .48577 .37389 L closepath p F P
0 0 0 r
s
1 .299 .127 r
.5 .38446 m .48577 .37389 L .48296 .37497 L closepath p F P
0 0 0 r
s
1 .299 .127 r
.5 .38446 m .48296 .37497 L .48016 .37605 L closepath p F P
0 0 0 r
s
1 .299 .127 r
.5 .38446 m .48016 .37605 L .47736 .37712 L closepath p F P
0 0 0 r
s
1 .299 .127 r
.5 .38446 m .47736 .37712 L .47456 .3782 L closepath p F P
0 0 0 r
s
1 .299 .127 r
.5 .38446 m .47456 .3782 L .47177 .37927 L closepath p F P
0 0 0 r
s
.283 .421 .83 r
.5 .38446 m .51327 .37085 L .51488 .37273 L closepath p F P
0 0 0 r
s
.283 .421 .83 r
.5 .38446 m .51488 .37273 L .51649 .3746 L closepath p F P
0 0 0 r
s
.283 .421 .83 r
.5 .38446 m .51649 .3746 L .51809 .37647 L closepath p F P
0 0 0 r
s
.283 .421 .83 r
.5 .38446 m .51809 .37647 L .51969 .37833 L closepath p F P
0 0 0 r
s
.283 .421 .83 r
.5 .38446 m .52129 .38019 L .52287 .38204 L closepath p F P
0 0 0 r
s
.283 .421 .83 r
.5 .38446 m .52287 .38204 L .52446 .38389 L closepath p F P
0 0 0 r
s
.283 .421 .83 r
.5 .38446 m .52446 .38389 L .52604 .38573 L closepath p F P
0 0 0 r
s
.293 .434 .848 r
.47231 .38404 m .47396 .38588 L .5 .38446 L closepath p F P
0 0 0 r
s
.293 .434 .848 r
.47065 .3822 m .47231 .38404 L .5 .38446 L closepath p F P
0 0 0 r
s
.293 .434 .848 r
.46899 .38034 m .47065 .3822 L .5 .38446 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.49247 .37758 m
.50743 .39461 L
s
.24 .35 .67 r
.48709 .39105 m
.513 .38121 L
s
.247 .376 .756 r
.57598 .39622 m .58036 .40152 L .55459 .39329 L p F P
0 0 0 r
s
.247 .376 .756 r
.55459 .39329 m .55154 .38967 L .57598 .39622 L p F P
0 0 0 r
s
.229 .055 .024 r
.48474 .6469 m .50066 .64204 L .50061 .65151 L p F P
0 0 0 r
s
.229 .055 .024 r
.50061 .65151 m .48594 .65595 L .48474 .6469 L p F P
0 0 0 r
s
.174 .276 .58 r
.62616 .42483 m .63267 .43291 L .6099 .41886 L p F P
0 0 0 r
s
.24 .35 .67 r
.62406 .42854 m
.63098 .43709 L
s
.174 .276 .58 r
.6099 .41886 m .60439 .4121 L .62616 .42483 L p F P
0 0 0 r
s
.24 .35 .67 r
.60809 .42436 m
.62406 .42854 L
s
.264 .365 .665 r
.39554 .56478 m .38418 .55455 L .38454 .57279 L p F P
0 0 0 r
s
.264 .365 .665 r
.38454 .57279 m .39587 .58282 L .39554 .56478 L p F P
0 0 0 r
s
.307 .441 .834 r
.39043 .45845 m .38122 .44941 L .36841 .4666 L p F P
0 0 0 r
s
.307 .441 .834 r
.36841 .4666 m .37871 .47647 L .39043 .45845 L p F P
0 0 0 r
s
.234 .317 .566 r
.40699 .59268 m .39587 .58282 L .39867 .59926 L p F P
0 0 0 r
s
.24 .35 .67 r
.39653 .56417 m
.41842 .58391 L
s
.234 .317 .566 r
.39867 .59926 m .40947 .60871 L .40699 .59268 L p F P
0 0 0 r
s
.3 .442 .859 r
.47396 .38588 m .47231 .38404 L .44512 .38633 L p F P
0 0 0 r
s
.3 .442 .859 r
.44512 .38633 m .44847 .38997 L .47396 .38588 L p F P
0 0 0 r
s
.268 .403 .801 r
.54848 .38603 m .55154 .38967 L .52604 .38573 L p F P
0 0 0 r
s
.268 .403 .801 r
.52604 .38573 m .52446 .38389 L .54848 .38603 L p F P
0 0 0 r
s
.464 .121 .054 r
.57138 .59227 m .58951 .5866 L .5871 .60288 L p F P
0 0 0 r
s
.464 .121 .054 r
.5871 .60288 m .56948 .60832 L .57138 .59227 L p F P
0 0 0 r
s
.83 .24 .1 r
.53436 .60811 m
.57026 .59692 L
s
.57026 .59692 m
.57094 .57372 L
s
.089 .134 .321 r
.66897 .46577 m .67686 .47566 L .65976 .45771 L p F P
0 0 0 r
s
.089 .134 .321 r
.65976 .45771 m .65252 .44865 L .66897 .46577 L p F P
0 0 0 r
s
.83 .24 .1 r
.62769 .46858 m
.65978 .45758 L
s
.66077 .45724 m
.6645 .45596 L
s
.283 .397 .733 r
.38652 .53535 m .37521 .52497 L .37261 .54413 L p F P
0 0 0 r
s
.283 .397 .733 r
.37261 .54413 m .38418 .55455 L .38652 .53535 L p F P
0 0 0 r
s
.83 .24 .1 r
.18145 .47088 m
.19413 .4584 L
s
.19413 .4584 m
.22674 .44557 L
s
.731 .205 .09 r
.66009 .4813 m .67686 .47566 L .68998 .49439 L p F P
0 0 0 r
s
.24 .35 .67 r
.68979 .49431 m
.6937 .4992 L
s
.731 .205 .09 r
.68998 .49439 m .67191 .50035 L .66009 .4813 L p F P
0 0 0 r
s
.83 .24 .1 r
.63555 .49685 m
.67256 .48448 L
s
.24 .35 .67 r
.70957 .54284 m
.72628 .56333 L
s
.72594 .58902 m
.72628 .56333 L
s
.83 .24 .1 r
.37075 .69629 m
.4052 .68593 L
s
.37075 .69629 m
.35616 .70125 L
s
.343 .084 .039 r
.53475 .61904 m .55203 .61371 L .54934 .6272 L p F P
0 0 0 r
s
.343 .084 .039 r
.54934 .6272 m .53296 .63219 L .53475 .61904 L p F P
0 0 0 r
s
.83 .24 .1 r
.53021 .62783 m
.53436 .60811 L
s
.308 .449 .863 r
.42905 .40196 m .42405 .39666 L .40122 .40583 L p F P
0 0 0 r
s
.83 .24 .1 r
.40698 .39257 m
.41658 .39966 L
s
.42117 .40305 m
.42279 .40425 L
s
.308 .449 .863 r
.40122 .40583 m .40784 .41266 L .42905 .40196 L p F P
0 0 0 r
s
.83 .24 .1 r
.37284 .40581 m
.40698 .39257 L
s
.554 .149 .066 r
.60816 .56279 m .62672 .55688 L .62632 .57508 L p F P
0 0 0 r
s
.554 .149 .066 r
.62632 .57508 m .60782 .58087 L .60816 .56279 L p F P
0 0 0 r
s
.3 .442 .859 r
.47231 .38404 m .47065 .3822 L .44175 .38268 L p F P
0 0 0 r
s
.3 .442 .859 r
.44175 .38268 m .44512 .38633 L .47231 .38404 L p F P
0 0 0 r
s
.217 .336 .687 r
.59882 .40526 m .60439 .4121 L .58036 .40152 L p F P
0 0 0 r
s
.217 .336 .687 r
.58036 .40152 m .57598 .39622 L .59882 .40526 L p F P
0 0 0 r
s
.83 .24 .1 r
.59327 .38916 m
.6057 .41286 L
s
.268 .403 .801 r
.5454 .38237 m .54848 .38603 L .52446 .38389 L p F P
0 0 0 r
s
.268 .403 .801 r
.52446 .38389 m .52287 .38204 L .5454 .38237 L p F P
0 0 0 r
s
.683 .19 .083 r
.65403 .50625 m .67191 .50035 L .67983 .51965 L p F P
0 0 0 r
s
.683 .19 .083 r
.67983 .51965 m .66109 .52572 L .65403 .50625 L p F P
0 0 0 r
s
.24 .35 .67 r
.72464 .66127 m
.73626 .63504 L
s
.73626 .63504 m
.71971 .61583 L
s
.305 .447 .863 r
.44847 .38997 m .44512 .38633 L .419 .39132 L p F P
0 0 0 r
s
.305 .447 .863 r
.419 .39132 m .42405 .39666 L .44847 .38997 L p F P
0 0 0 r
s
.188 .246 .422 r
.42008 .618 m .40947 .60871 L .41417 .62252 L p F P
0 0 0 r
s
.188 .246 .422 r
.41417 .62252 m .4242 .63121 L .42008 .618 L p F P
0 0 0 r
s
.24 .35 .67 r
.42014 .60765 m
.42715 .6292 L
s
.247 .376 .756 r
.57156 .39087 m .57598 .39622 L .55154 .38967 L p F P
0 0 0 r
s
.83 .24 .1 r
.57555 .3957 m
.59327 .38916 L
s
.247 .376 .756 r
.55154 .38967 m .54848 .38603 L .57156 .39087 L p F P
0 0 0 r
s
.309 .446 .849 r
.39666 .43358 m .38863 .4255 L .37187 .44023 L p F P
0 0 0 r
s
.309 .446 .849 r
.37187 .44023 m .38122 .44941 L .39666 .43358 L p F P
0 0 0 r
s
.295 .418 .779 r
.38068 .50552 m .36972 .49525 L .36369 .5144 L p F P
0 0 0 r
s
.295 .418 .779 r
.36369 .5144 m .37521 .52497 L .38068 .50552 L p F P
0 0 0 r
s
.24 .35 .67 r
.37789 .51832 m
.40028 .53902 L
s
.83 .24 .1 r
.65452 .42769 m
.6645 .45596 L
s
.6645 .45596 m
.66656 .46327 L
s
.3 .442 .859 r
.47065 .3822 m .46899 .38034 L .43836 .379 L p F P
0 0 0 r
s
.3 .442 .859 r
.43836 .379 m .44175 .38268 L .47065 .3822 L p F P
0 0 0 r
s
.131 .209 .459 r
.64517 .43946 m .65252 .44865 L .63267 .43291 L p F P
0 0 0 r
s
.131 .209 .459 r
.63267 .43291 m .62616 .42483 L .64517 .43946 L p F P
0 0 0 r
s
.83 .24 .1 r
.6376 .43364 m
.65452 .42769 L
s
.268 .403 .801 r
.54231 .37869 m .5454 .38237 L .52287 .38204 L p F P
0 0 0 r
s
.268 .403 .801 r
.52287 .38204 m .52129 .38019 L .54231 .37869 L p F P
0 0 0 r
s
.24 .35 .67 r
.513 .38121 m
.52502 .39511 L
s
.83 .24 .1 r
.64295 .40058 m
.65452 .42769 L
s
.65452 .42769 m
.69201 .4145 L
s
.24 .35 .67 r
.45861 .66421 m
.46096 .66623 L
s
.625 .171 .076 r
.64253 .53173 m .66109 .52572 L .66443 .54488 L p F P
0 0 0 r
s
.625 .171 .076 r
.66443 .54488 m .64548 .55091 L .64253 .53173 L p F P
0 0 0 r
s
.83 .24 .1 r
.64109 .52445 m
.64409 .55043 L
s
.59327 .38916 m
.63015 .37557 L
s
.229 .055 .024 r
.50066 .64204 m .51674 .63714 L .51541 .64704 L p F P
0 0 0 r
s
.83 .24 .1 r
.49456 .63876 m
.53021 .62783 L
s
.229 .055 .024 r
.51541 .64704 m .50061 .65151 L .50066 .64204 L p F P
0 0 0 r
s
.83 .24 .1 r
.26003 .43246 m
.27421 .42621 L
s
.27421 .42621 m
.30777 .413 L
s
1 .308 .131 r
.44385 .37686 m .43836 .379 L .46899 .38034 L p F P
0 0 0 r
s
1 .308 .131 r
.46899 .38034 m .47177 .37927 L .44385 .37686 L p F P
0 0 0 r
s
.31 .449 .858 r
.40784 .41266 m .40122 .40583 L .3805 .41732 L p F P
0 0 0 r
s
.31 .449 .858 r
.3805 .41732 m .38863 .4255 L .40784 .41266 L p F P
0 0 0 r
s
.24 .35 .67 r
.39587 .42183 m
.41794 .44424 L
s
.268 .403 .801 r
.5392 .37499 m .54231 .37869 L .52129 .38019 L p F P
0 0 0 r
s
.268 .403 .801 r
.52129 .38019 m .51969 .37833 L .5392 .37499 L p F P
0 0 0 r
s
.83 .24 .1 r
.45146 .66493 m
.44038 .67536 L
s
.24 .35 .67 r
.63619 .73785 m
.61777 .72047 L
s
.63619 .73785 m
.66246 .72517 L
s
.305 .447 .863 r
.44512 .38633 m .44175 .38268 L .41392 .38593 L p F P
0 0 0 r
s
.305 .447 .863 r
.41392 .38593 m .419 .39132 L .44512 .38633 L p F P
0 0 0 r
s
.83 .24 .1 r
.40698 .39257 m
.41664 .38881 L
s
.174 .276 .58 r
.61956 .41663 m .62616 .42483 L .60439 .4121 L p F P
0 0 0 r
s
.174 .276 .58 r
.60439 .4121 m .59882 .40526 L .61956 .41663 L p F P
0 0 0 r
s
.83 .24 .1 r
.61117 .41203 m
.64295 .40058 L
s
.303 .432 .811 r
.37871 .47647 m .36841 .4666 L .35856 .4848 L p F P
0 0 0 r
s
.303 .432 .811 r
.35856 .4848 m .36972 .49525 L .37871 .47647 L p F P
0 0 0 r
s
.24 .35 .67 r
.37789 .51832 m
.38692 .49266 L
s
.247 .376 .756 r
.56711 .38548 m .57156 .39087 L .54848 .38603 L p F P
0 0 0 r
s
.247 .376 .756 r
.54848 .38603 m .5454 .38237 L .56711 .38548 L p F P
0 0 0 r
s
1 .308 .131 r
.44936 .37472 m .44385 .37686 L .47177 .37927 L p F P
0 0 0 r
s
.83 .24 .1 r
.44182 .37904 m
.44755 .38349 L
s
1 .308 .131 r
.47177 .37927 m .47456 .3782 L .44936 .37472 L p F P
0 0 0 r
s
.24 .35 .67 r
.56423 .72948 m
.54449 .71193 L
s
.56423 .72948 m
.59058 .72789 L
s
.308 .449 .863 r
.42405 .39666 m .419 .39132 L .39453 .39892 L p F P
0 0 0 r
s
.308 .449 .863 r
.39453 .39892 m .40122 .40583 L .42405 .39666 L p F P
0 0 0 r
s
.24 .35 .67 r
.41703 .4004 m
.43871 .42317 L
s
.464 .121 .054 r
.58951 .5866 m .60782 .58087 L .60491 .59738 L p F P
0 0 0 r
s
.464 .121 .054 r
.60491 .59738 m .5871 .60288 L .58951 .5866 L p F P
0 0 0 r
s
.136 .17 .302 r
.68162 .48393 m .68998 .49439 L .67686 .47566 L p F P
0 0 0 r
s
.136 .17 .302 r
.67686 .47566 m .66897 .46577 L .68162 .48393 L p F P
0 0 0 r
s
.24 .35 .67 r
.67652 .4777 m
.68044 .48261 L
s
.83 .24 .1 r
.66713 .46528 m
.67256 .48448 L
s
.24 .35 .67 r
.66617 .46696 m
.67652 .4777 L
s
.217 .336 .687 r
.59319 .39835 m .59882 .40526 L .57598 .39622 L p F P
0 0 0 r
s
.24 .35 .67 r
.55848 .39954 m
.583 .39992 L
s
.583 .39992 m
.59804 .4182 L
s
.217 .336 .687 r
.57598 .39622 m .57156 .39087 L .59319 .39835 L p F P
0 0 0 r
s
.145 .037 .015 r
.45696 .6647 m .47139 .66034 L .47458 .66541 L p F P
0 0 0 r
s
.145 .037 .015 r
.47458 .66541 m .46175 .66927 L .45696 .6647 L p F P
0 0 0 r
s
.24 .35 .67 r
.46384 .66864 m
.47805 .68048 L
s
.094 .106 .204 r
.45696 .6647 m .44819 .65713 L .45398 .66257 L p F P
0 0 0 r
s
.83 .24 .1 r
.45146 .66493 m
.45554 .66369 L
s
.094 .106 .204 r
.45398 .66257 m .46175 .66927 L .45696 .6647 L p F P
0 0 0 r
s
.268 .403 .801 r
.53606 .37127 m .5392 .37499 L .51969 .37833 L p F P
0 0 0 r
s
.268 .403 .801 r
.51969 .37833 m .51809 .37647 L .53606 .37127 L p F P
0 0 0 r
s
1 .308 .131 r
.45489 .37257 m .44936 .37472 L .47456 .3782 L p F P
0 0 0 r
s
1 .308 .131 r
.47456 .3782 m .47736 .37712 L .45489 .37257 L p F P
0 0 0 r
s
.83 .24 .1 r
.47131 .38568 m
.49247 .37758 L
s
.681 .48166 m
.68236 .48121 L
s
.67256 .48448 m
.68022 .48192 L
s
.68236 .48121 m
.71035 .47185 L
s
.343 .084 .039 r
.55203 .61371 m .56948 .60832 L .56587 .62215 L p F P
0 0 0 r
s
.343 .084 .039 r
.56587 .62215 m .54934 .6272 L .55203 .61371 L p F P
0 0 0 r
s
.147 .182 .324 r
.43407 .63977 m .4242 .63121 L .43024 .64163 L p F P
0 0 0 r
s
.147 .182 .324 r
.43024 .64163 m .43928 .64944 L .43407 .63977 L p F P
0 0 0 r
s
.24 .35 .67 r
.42715 .6292 m
.44866 .64794 L
s
.554 .149 .066 r
.62672 .55688 m .64548 .55091 L .64502 .56922 L p F P
0 0 0 r
s
.554 .149 .066 r
.64502 .56922 m .62632 .57508 L .62672 .55688 L p F P
0 0 0 r
s
.83 .24 .1 r
.60713 .56219 m
.64409 .55043 L
s
.24 .35 .67 r
.70957 .54284 m
.70431 .51931 L
s
1 .308 .131 r
.46044 .37042 m .45489 .37257 L .47736 .37712 L p F P
0 0 0 r
s
1 .308 .131 r
.47736 .37712 m .48016 .37605 L .46044 .37042 L p F P
0 0 0 r
s
.24 .35 .67 r
.47463 .37706 m
.48709 .39105 L
s
.683 .19 .083 r
.67191 .50035 m .68998 .49439 L .69878 .51352 L p F P
0 0 0 r
s
.683 .19 .083 r
.69878 .51352 m .67983 .51965 L .67191 .50035 L p F P
0 0 0 r
s
.83 .24 .1 r
.67256 .48448 m
.67841 .51228 L
s
.63015 .37557 m
.64295 .40058 L
s
.64295 .40058 m
.68046 .38706 L
s
.24 .35 .67 r
.39587 .42183 m
.41703 .4004 L
s
.307 .441 .834 r
.38122 .44941 m .37187 .44023 L .35794 .45656 L p F P
0 0 0 r
s
.307 .441 .834 r
.35794 .45656 m .36841 .4666 L .38122 .44941 L p F P
0 0 0 r
s
.24 .35 .67 r
.378 .44562 m
.40045 .46767 L
s
.268 .403 .801 r
.53292 .36752 m .53606 .37127 L .51809 .37647 L p F P
0 0 0 r
s
.268 .403 .801 r
.51809 .37647 m .51649 .3746 L .53292 .36752 L p F P
0 0 0 r
s
.24 .35 .67 r
.513 .38121 m
.53882 .37619 L
s
1 .308 .131 r
.466 .36826 m .46044 .37042 L .48016 .37605 L p F P
0 0 0 r
s
1 .308 .131 r
.48016 .37605 m .48296 .37497 L .466 .36826 L p F P
0 0 0 r
s
.305 .447 .863 r
.44175 .38268 m .43836 .379 L .40879 .3805 L p F P
0 0 0 r
s
.305 .447 .863 r
.40879 .3805 m .41392 .38593 L .44175 .38268 L p F P
0 0 0 r
s
.24 .35 .67 r
.44073 .38208 m
.46204 .40522 L
s
.089 .134 .321 r
.66096 .45572 m .66897 .46577 L .65252 .44865 L p F P
0 0 0 r
s
.83 .24 .1 r
.6645 .45596 m
.70208 .44308 L
s
.089 .134 .321 r
.65252 .44865 m .64517 .43946 L .66096 .45572 L p F P
0 0 0 r
s
.247 .376 .756 r
.56262 .38005 m .56711 .38548 L .5454 .38237 L p F P
0 0 0 r
s
.247 .376 .756 r
.5454 .38237 m .54231 .37869 L .56262 .38005 L p F P
0 0 0 r
s
.83 .24 .1 r
.32198 .71152 m
.35616 .70125 L
s
.32198 .71152 m
.30496 .71052 L
s
.24 .35 .67 r
.70788 .68587 m
.72464 .66127 L
s
.72464 .66127 m
.70778 .64242 L
s
1 .308 .131 r
.47158 .36609 m .466 .36826 L .48296 .37497 L p F P
0 0 0 r
s
.24 .35 .67 r
.46613 .36753 m
.46658 .36803 L
s
1 .308 .131 r
.48296 .37497 m .48577 .37389 L .47158 .36609 L p F P
0 0 0 r
s
.268 .403 .801 r
.52975 .36376 m .53292 .36752 L .51649 .3746 L p F P
0 0 0 r
s
.268 .403 .801 r
.51649 .3746 m .51488 .37273 L .52975 .36376 L p F P
0 0 0 r
s
.264 .365 .665 r
.38418 .55455 m .37261 .54413 L .37302 .56257 L p F P
0 0 0 r
s
.264 .365 .665 r
.37302 .56257 m .38454 .57279 L .38418 .55455 L p F P
0 0 0 r
s
.229 .055 .024 r
.51674 .63714 m .53296 .63219 L .53034 .64252 L p F P
0 0 0 r
s
.229 .055 .024 r
.53034 .64252 m .51541 .64704 L .51674 .63714 L p F P
0 0 0 r
s
.309 .446 .849 r
.38863 .4255 m .3805 .41732 L .36238 .43091 L p F P
0 0 0 r
s
.309 .446 .849 r
.36238 .43091 m .37187 .44023 L .38863 .4255 L p F P
0 0 0 r
s
.24 .35 .67 r
.378 .44562 m
.39587 .42183 L
s
.234 .317 .566 r
.39587 .58282 m .38454 .57279 L .38768 .58964 L p F P
0 0 0 r
s
.234 .317 .566 r
.38768 .58964 m .39867 .59926 L .39587 .58282 L p F P
0 0 0 r
s
.24 .35 .67 r
.39653 .56417 m
.39801 .58809 L
s
.625 .171 .076 r
.66109 .52572 m .67983 .51965 L .68359 .53879 L p F P
0 0 0 r
s
.83 .24 .1 r
.64109 .52445 m
.67841 .51228 L
s
.625 .171 .076 r
.68359 .53879 m .66443 .54488 L .66109 .52572 L p F P
0 0 0 r
s
1 .308 .131 r
.47718 .36391 m .47158 .36609 L .48577 .37389 L p F P
0 0 0 r
s
1 .308 .131 r
.48577 .37389 m .48858 .37281 L .47718 .36391 L p F P
0 0 0 r
s
.308 .449 .863 r
.419 .39132 m .41392 .38593 L .38777 .39194 L p F P
0 0 0 r
s
.83 .24 .1 r
.40463 .3916 m
.40698 .39257 L
s
.308 .449 .863 r
.38777 .39194 m .39453 .39892 L .419 .39132 L p F P
0 0 0 r
s
.24 .35 .67 r
.41703 .4004 m
.44073 .38208 L
s
.131 .209 .459 r
.63771 .43014 m .64517 .43946 L .62616 .42483 L p F P
0 0 0 r
s
.131 .209 .459 r
.62616 .42483 m .61956 .41663 L .63771 .43014 L p F P
0 0 0 r
s
.24 .35 .67 r
.46243 .36965 m
.46613 .36753 L
s
.283 .397 .733 r
.37521 .52497 m .36369 .5144 L .36083 .53352 L p F P
0 0 0 r
s
.283 .397 .733 r
.36083 .53352 m .37261 .54413 L .37521 .52497 L p F P
0 0 0 r
s
.24 .35 .67 r
.37384 .5437 m
.37789 .51832 L
s
.66246 .72517 m
.64443 .70747 L
s
.66246 .72517 m
.68679 .70755 L
s
.31 .449 .858 r
.40122 .40583 m .39453 .39892 L .37227 .40903 L p F P
0 0 0 r
s
.31 .449 .858 r
.37227 .40903 m .3805 .41732 L .40122 .40583 L p F P
0 0 0 r
s
.217 .336 .687 r
.5875 .39136 m .59319 .39835 L .57156 .39087 L p F P
0 0 0 r
s
.217 .336 .687 r
.57156 .39087 m .56711 .38548 L .5875 .39136 L p F P
0 0 0 r
s
.145 .037 .015 r
.47139 .66034 m .48594 .65595 L .48751 .66153 L p F P
0 0 0 r
s
.145 .037 .015 r
.48751 .66153 m .47458 .66541 L .47139 .66034 L p F P
0 0 0 r
s
1 .308 .131 r
.4828 .36173 m .47718 .36391 L .48858 .37281 L p F P
0 0 0 r
s
1 .308 .131 r
.48858 .37281 m .4914 .37172 L .4828 .36173 L p F P
0 0 0 r
s
.268 .403 .801 r
.52656 .35997 m .52975 .36376 L .51488 .37273 L p F P
0 0 0 r
s
.268 .403 .801 r
.51488 .37273 m .51327 .37085 L .52656 .35997 L p F P
0 0 0 r
s
.174 .276 .58 r
.61288 .40833 m .61956 .41663 L .59882 .40526 L p F P
0 0 0 r
s
.174 .276 .58 r
.59882 .40526 m .59319 .39835 L .61288 .40833 L p F P
0 0 0 r
s
1 .312 .132 r
.41685 .37734 m .40879 .3805 L .43836 .379 L p F P
0 0 0 r
s
.83 .24 .1 r
.43572 .38141 m
.44182 .37904 L
s
1 .312 .132 r
.43836 .379 m .44385 .37686 L .41685 .37734 L p F P
0 0 0 r
s
.24 .35 .67 r
.43695 .37797 m
.44073 .38208 L
s
.44073 .38208 m
.45002 .37676 L
s
.247 .376 .756 r
.55809 .37457 m .56262 .38005 L .54231 .37869 L p F P
0 0 0 r
s
.83 .24 .1 r
.55871 .37532 m
.57941 .36752 L
s
.247 .376 .756 r
.54231 .37869 m .5392 .37499 L .55809 .37457 L p F P
0 0 0 r
s
.24 .35 .67 r
.53882 .37619 m
.55848 .39954 L
s
.464 .121 .054 r
.60782 .58087 m .62632 .57508 L .62289 .59183 L p F P
0 0 0 r
s
.464 .121 .054 r
.62289 .59183 m .60491 .59738 L .60782 .58087 L p F P
0 0 0 r
s
.83 .24 .1 r
.57026 .59692 m
.60692 .58549 L
s
.60692 .58549 m
.60713 .56219 L
s
.188 .246 .422 r
.40947 .60871 m .39867 .59926 L .40398 .61367 L p F P
0 0 0 r
s
.24 .35 .67 r
.39801 .58809 m
.42014 .60765 L
s
.188 .246 .422 r
.40398 .61367 m .41417 .62252 L .40947 .60871 L p F P
0 0 0 r
s
1 .308 .131 r
.48844 .35954 m .4828 .36173 L .4914 .37172 L p F P
0 0 0 r
s
1 .308 .131 r
.4914 .37172 m .49422 .37064 L .48844 .35954 L p F P
0 0 0 r
s
.343 .084 .039 r
.56948 .60832 m .5871 .60288 L .58256 .61706 L p F P
0 0 0 r
s
.343 .084 .039 r
.58256 .61706 m .56587 .62215 L .56948 .60832 L p F P
0 0 0 r
s
.83 .24 .1 r
.56661 .61668 m
.57026 .59692 L
s
.21447 .45797 m
.22674 .44557 L
s
.22674 .44557 m
.26003 .43246 L
s
.295 .418 .779 r
.36972 .49525 m .35856 .4848 L .35196 .50364 L p F P
0 0 0 r
s
.295 .418 .779 r
.35196 .50364 m .36369 .5144 L .36972 .49525 L p F P
0 0 0 r
s
.83 .24 .1 r
.4052 .68593 m
.44038 .67536 L
s
.4052 .68593 m
.39107 .69076 L
s
.24 .35 .67 r
.68679 .70755 m
.70788 .68587 L
s
.70788 .68587 m
.69064 .66741 L
s
.71971 .61583 m
.72594 .58902 L
s
.72594 .58902 m
.70904 .56878 L
s
.268 .403 .801 r
.52336 .35616 m .52656 .35997 L .51327 .37085 L p F P
0 0 0 r
s
.268 .403 .801 r
.51327 .37085 m .51165 .36896 L .52336 .35616 L p F P
0 0 0 r
s
.24 .35 .67 r
.52003 .70792 m
.49935 .68986 L
s
.52003 .70792 m
.54449 .71193 L
s
1 .308 .131 r
.49409 .35734 m .48844 .35954 L .49422 .37064 L p F P
0 0 0 r
s
.24 .35 .67 r
.49235 .35733 m
.49279 .35785 L
s
.83 .24 .1 r
.4774 .36523 m
.49247 .37758 L
s
1 .308 .131 r
.49422 .37064 m .49705 .36955 L .49409 .35734 L p F P
0 0 0 r
s
.554 .149 .066 r
.64548 .55091 m .66443 .54488 L .66391 .56331 L p F P
0 0 0 r
s
.554 .149 .066 r
.66391 .56331 m .64502 .56922 L .64548 .55091 L p F P
0 0 0 r
s
.185 .244 .417 r
.69011 .50274 m .69878 .51352 L .68998 .49439 L p F P
0 0 0 r
s
.24 .35 .67 r
.69761 .51098 m
.70431 .51931 L
s
.185 .244 .417 r
.68998 .49439 m .68162 .48393 L .69011 .50274 L p F P
0 0 0 r
s
.24 .35 .67 r
.68679 .70755 m
.66916 .68948 L
s
1 .312 .132 r
.42495 .37417 m .41685 .37734 L .44385 .37686 L p F P
0 0 0 r
s
1 .312 .132 r
.44385 .37686 m .44936 .37472 L .42495 .37417 L p F P
0 0 0 r
s
1 .308 .131 r
.49976 .35514 m .49409 .35734 L .49705 .36955 L p F P
0 0 0 r
s
1 .308 .131 r
.49705 .36955 m .49988 .36846 L .49976 .35514 L p F P
0 0 0 r
s
.83 .24 .1 r
.49247 .37758 m
.5139 .36937 L
s
.67841 .51228 m
.69376 .50728 L
s
.268 .403 .801 r
.52014 .35233 m .52336 .35616 L .51165 .36896 L p F P
0 0 0 r
s
.268 .403 .801 r
.51165 .36896 m .51003 .36707 L .52014 .35233 L p F P
0 0 0 r
s
.303 .432 .811 r
.36841 .4666 m .35794 .45656 L .34722 .47417 L p F P
0 0 0 r
s
.303 .432 .811 r
.34722 .47417 m .35856 .4848 L .36841 .4666 L p F P
0 0 0 r
s
.24 .35 .67 r
.36408 .47093 m
.38692 .49266 L
s
.83 .24 .1 r
.69201 .4145 m
.70208 .44308 L
s
.70208 .44308 m
.74045 .42993 L
s
.70208 .44308 m
.71035 .47185 L
s
.094 .106 .204 r
.44819 .65713 m .43928 .64944 L .44611 .65578 L p F P
0 0 0 r
s
.094 .106 .204 r
.44611 .65578 m .45398 .66257 L .44819 .65713 L p F P
0 0 0 r
s
1 .308 .131 r
.50546 .35293 m .49976 .35514 L .49988 .36846 L p F P
0 0 0 r
s
1 .308 .131 r
.49988 .36846 m .50272 .36737 L .50546 .35293 L p F P
0 0 0 r
s
.83 .24 .1 r
.68046 .38706 m
.69201 .4145 L
s
.69201 .4145 m
.73028 .40104 L
s
.247 .376 .756 r
.55352 .36904 m .55809 .37457 L .5392 .37499 L p F P
0 0 0 r
s
.247 .376 .756 r
.5392 .37499 m .53606 .37127 L .55352 .36904 L p F P
0 0 0 r
s
.229 .055 .024 r
.53296 .63219 m .54934 .6272 L .54539 .63797 L p F P
0 0 0 r
s
.229 .055 .024 r
.54539 .63797 m .53034 .64252 L .53296 .63219 L p F P
0 0 0 r
s
.308 .449 .863 r
.41392 .38593 m .40879 .3805 L .38093 .38488 L p F P
0 0 0 r
s
.308 .449 .863 r
.38093 .38488 m .38777 .39194 L .41392 .38593 L p F P
0 0 0 r
s
.136 .17 .302 r
.67311 .47328 m .68162 .48393 L .66897 .46577 L p F P
0 0 0 r
s
.136 .17 .302 r
.66897 .46577 m .66096 .45572 L .67311 .47328 L p F P
0 0 0 r
s
1 .312 .132 r
.43309 .37098 m .42495 .37417 L .44936 .37472 L p F P
0 0 0 r
s
1 .312 .132 r
.44936 .37472 m .45489 .37257 L .43309 .37098 L p F P
0 0 0 r
s
.217 .336 .687 r
.58175 .38429 m .5875 .39136 L .56711 .38548 L p F P
0 0 0 r
s
.217 .336 .687 r
.56711 .38548 m .56262 .38005 L .58175 .38429 L p F P
0 0 0 r
s
.83 .24 .1 r
.57941 .36752 m
.59327 .38916 L
s
1 .308 .131 r
.51117 .35071 m .50546 .35293 L .50272 .36737 L p F P
0 0 0 r
s
1 .308 .131 r
.50272 .36737 m .50556 .36627 L .51117 .35071 L p F P
0 0 0 r
s
.625 .171 .076 r
.67983 .51965 m .69878 .51352 L .70296 .53263 L p F P
0 0 0 r
s
.625 .171 .076 r
.70296 .53263 m .68359 .53879 L .67983 .51965 L p F P
0 0 0 r
s
.83 .24 .1 r
.67841 .51228 m
.68182 .53841 L
s
.27109 .72076 m
.30496 .71052 L
s
.27109 .72076 m
.25246 .71367 L
s
.145 .037 .015 r
.48594 .65595 m .50061 .65151 L .50054 .65761 L p F P
0 0 0 r
s
.83 .24 .1 r
.48688 .6542 m
.49456 .63876 L
s
.145 .037 .015 r
.50054 .65761 m .48751 .66153 L .48594 .65595 L p F P
0 0 0 r
s
.83 .24 .1 r
.45592 .66358 m
.48688 .6542 L
s
.61654 .35355 m
.63015 .37557 L
s
.63015 .37557 m
.66781 .36168 L
s
.268 .403 .801 r
.5169 .34848 m .52014 .35233 L .51003 .36707 L p F P
0 0 0 r
s
.268 .403 .801 r
.51003 .36707 m .50841 .36518 L .5169 .34848 L p F P
0 0 0 r
s
.24 .35 .67 r
.50072 .36702 m
.513 .38121 L
s
.147 .182 .324 r
.4242 .63121 m .41417 .62252 L .42106 .63371 L p F P
0 0 0 r
s
.147 .182 .324 r
.42106 .63371 m .43024 .64163 L .4242 .63121 L p F P
0 0 0 r
s
.83 .24 .1 r
.57941 .36752 m
.61654 .35355 L
s
.307 .441 .834 r
.37187 .44023 m .36238 .43091 L .34729 .44636 L p F P
0 0 0 r
s
.307 .441 .834 r
.34729 .44636 m .35794 .45656 L .37187 .44023 L p F P
0 0 0 r
s
.24 .35 .67 r
.36408 .47093 m
.378 .44562 L
s
.83 .24 .1 r
.29404 .41908 m
.30777 .413 L
s
.30777 .413 m
.34203 .39951 L
s
1 .308 .131 r
.5169 .34848 m .51117 .35071 L .50556 .36627 L p F P
0 0 0 r
s
1 .308 .131 r
.50556 .36627 m .50841 .36518 L .5169 .34848 L p F P
0 0 0 r
s
.24 .35 .67 r
.59058 .72789 m
.57112 .71013 L
s
.59058 .72789 m
.61777 .72047 L
s
.31 .449 .858 r
.39453 .39892 m .38777 .39194 L .36392 .40063 L p F P
0 0 0 r
s
.31 .449 .858 r
.36392 .40063 m .37227 .40903 L .39453 .39892 L p F P
0 0 0 r
s
.83 .24 .1 r
.35696 .39975 m
.38478 .38885 L
s
.089 .134 .321 r
.65281 .44551 m .66096 .45572 L .64517 .43946 L p F P
0 0 0 r
s
.089 .134 .321 r
.64517 .43946 m .63771 .43014 L .65281 .44551 L p F P
0 0 0 r
s
.24 .35 .67 r
.64336 .43953 m
.65897 .45902 L
s
1 .312 .132 r
.44127 .36778 m .43309 .37098 L .45489 .37257 L p F P
0 0 0 r
s
1 .312 .132 r
.45489 .37257 m .46044 .37042 L .44127 .36778 L p F P
0 0 0 r
s
.309 .446 .849 r
.3805 .41732 m .37227 .40903 L .35274 .42146 L p F P
0 0 0 r
s
.309 .446 .849 r
.35274 .42146 m .36238 .43091 L .3805 .41732 L p F P
0 0 0 r
s
.174 .276 .58 r
.6061 .39993 m .61288 .40833 L .59319 .39835 L p F P
0 0 0 r
s
.174 .276 .58 r
.59319 .39835 m .5875 .39136 L .6061 .39993 L p F P
0 0 0 r
s
.24 .35 .67 r
.583 .39992 m
.60546 .40557 L
s
.131 .209 .459 r
.63014 .42067 m .63771 .43014 L .61956 .41663 L p F P
0 0 0 r
s
.24 .35 .67 r
.62406 .42854 m
.64336 .43953 L
s
.131 .209 .459 r
.61956 .41663 m .61288 .40833 L .63014 .42067 L p F P
0 0 0 r
s
.24 .35 .67 r
.60546 .40557 m
.62406 .42854 L
s
.464 .121 .054 r
.62632 .57508 m .64502 .56922 L .64106 .58623 L p F P
0 0 0 r
s
.464 .121 .054 r
.64106 .58623 m .62289 .59183 L .62632 .57508 L p F P
0 0 0 r
s
.343 .084 .039 r
.5871 .60288 m .60491 .59738 L .59941 .61192 L p F P
0 0 0 r
s
.343 .084 .039 r
.59941 .61192 m .58256 .61706 L .5871 .60288 L p F P
0 0 0 r
s
.247 .376 .756 r
.54891 .36347 m .55352 .36904 L .53606 .37127 L p F P
0 0 0 r
s
.247 .376 .756 r
.53606 .37127 m .53292 .36752 L .54891 .36347 L p F P
0 0 0 r
s
.83 .24 .1 r
.71035 .47185 m
.74894 .45896 L
s
.71035 .47185 m
.71652 .49986 L
s
.24 .35 .67 r
.47805 .68048 m
.49935 .68986 L
s
1 .312 .132 r
.44949 .36456 m .44127 .36778 L .46044 .37042 L p F P
0 0 0 r
s
1 .312 .132 r
.46044 .37042 m .466 .36826 L .44949 .36456 L p F P
0 0 0 r
s
.554 .149 .066 r
.66443 .54488 m .68359 .53879 L .683 .55733 L p F P
0 0 0 r
s
.554 .149 .066 r
.683 .55733 m .66391 .56331 L .66443 .54488 L p F P
0 0 0 r
s
.83 .24 .1 r
.64409 .55043 m
.68182 .53841 L
s
.17182 .48898 m
.18145 .47088 L
s
.18145 .47088 m
.21447 .45797 L
s
.66781 .36168 m
.68046 .38706 L
s
.68046 .38706 m
.71877 .37326 L
s
.996 .304 .128 r
.39138 .38077 m .38093 .38488 L .40879 .3805 L p F P
0 0 0 r
s
.24 .35 .67 r
.39914 .38161 m
.41703 .4004 L
s
.996 .304 .128 r
.40879 .3805 m .41685 .37734 L .39138 .38077 L p F P
0 0 0 r
s
.264 .365 .665 r
.37261 .54413 m .36083 .53352 L .36127 .55216 L p F P
0 0 0 r
s
.264 .365 .665 r
.36127 .55216 m .37302 .56257 L .37261 .54413 L p F P
0 0 0 r
s
.234 .317 .566 r
.38454 .57279 m .37302 .56257 L .3765 .57985 L p F P
0 0 0 r
s
.24 .35 .67 r
.37384 .5437 m
.39653 .56417 L
s
.234 .317 .566 r
.3765 .57985 m .38768 .58964 L .38454 .57279 L p F P
0 0 0 r
s
.217 .336 .687 r
.57593 .37715 m .58175 .38429 L .56262 .38005 L p F P
0 0 0 r
s
.217 .336 .687 r
.56262 .38005 m .55809 .37457 L .57593 .37715 L p F P
0 0 0 r
s
.229 .055 .024 r
.54934 .6272 m .56587 .62215 L .56058 .63338 L p F P
0 0 0 r
s
.229 .055 .024 r
.56058 .63338 m .54539 .63797 L .54934 .6272 L p F P
0 0 0 r
s
.83 .24 .1 r
.53021 .62783 m
.56661 .61668 L
s
.35616 .70125 m
.39107 .69076 L
s
.35616 .70125 m
.33955 .70007 L
s
.145 .037 .015 r
.50061 .65151 m .51541 .64704 L .51367 .65367 L p F P
0 0 0 r
s
.145 .037 .015 r
.51367 .65367 m .50054 .65761 L .50061 .65151 L p F P
0 0 0 r
s
1 .312 .132 r
.45774 .36133 m .44949 .36456 L .466 .36826 L p F P
0 0 0 r
s
1 .312 .132 r
.466 .36826 m .47158 .36609 L .45774 .36133 L p F P
0 0 0 r
s
.283 .397 .733 r
.36369 .5144 m .35196 .50364 L .34882 .52271 L p F P
0 0 0 r
s
.283 .397 .733 r
.34882 .52271 m .36083 .53352 L .36369 .5144 L p F P
0 0 0 r
s
.24 .35 .67 r
.70904 .56878 m
.70957 .54284 L
s
.247 .376 .756 r
.54427 .35785 m .54891 .36347 L .53292 .36752 L p F P
0 0 0 r
s
.247 .376 .756 r
.53292 .36752 m .52975 .36376 L .54427 .35785 L p F P
0 0 0 r
s
.188 .246 .422 r
.39867 .59926 m .38768 .58964 L .39361 .60468 L p F P
0 0 0 r
s
.188 .246 .422 r
.39361 .60468 m .40398 .61367 L .39867 .59926 L p F P
0 0 0 r
s
.24 .35 .67 r
.39801 .58809 m
.40485 .60977 L
s
.235 .32 .564 r
.69414 .5218 m .70296 .53263 L .69878 .51352 L p F P
0 0 0 r
s
.235 .32 .564 r
.69878 .51352 m .69011 .50274 L .69414 .5218 L p F P
0 0 0 r
s
.83 .24 .1 r
.69653 .50638 m
.71652 .49986 L
s
.69546 .50673 m
.69653 .50638 L
s
.295 .418 .779 r
.35856 .4848 m .34722 .47417 L .34002 .49268 L p F P
0 0 0 r
s
.295 .418 .779 r
.34002 .49268 m .35196 .50364 L .35856 .4848 L p F P
0 0 0 r
s
.24 .35 .67 r
.35469 .49687 m
.37789 .51832 L
s
.70778 .64242 m
.71971 .61583 L
s
.71971 .61583 m
.70255 .5959 L
s
.996 .304 .128 r
.40189 .37664 m .39138 .38077 L .41685 .37734 L p F P
0 0 0 r
s
.24 .35 .67 r
.39456 .3768 m
.39644 .37878 L
s
.996 .304 .128 r
.41685 .37734 m .42495 .37417 L .40189 .37664 L p F P
0 0 0 r
s
1 .312 .132 r
.46604 .35808 m .45774 .36133 L .47158 .36609 L p F P
0 0 0 r
s
1 .312 .132 r
.47158 .36609 m .47718 .36391 L .46604 .35808 L p F P
0 0 0 r
s
.83 .24 .1 r
.44182 .37904 m
.4774 .36523 L
s
.31 .449 .858 r
.38777 .39194 m .38093 .38488 L .35547 .39212 L p F P
0 0 0 r
s
.31 .449 .858 r
.35547 .39212 m .36392 .40063 L .38777 .39194 L p F P
0 0 0 r
s
.24 .35 .67 r
.373 .39861 m
.39587 .42183 L
s
.83 .24 .1 r
.34203 .39951 m
.35696 .39975 L
s
.094 .106 .204 r
.43928 .64944 m .43024 .64163 L .43814 .64891 L p F P
0 0 0 r
s
.24 .35 .67 r
.42715 .6292 m
.43937 .64757 L
s
.094 .106 .204 r
.43814 .64891 m .44611 .65578 L .43928 .64944 L p F P
0 0 0 r
s
.24 .35 .67 r
.43937 .64757 m
.45826 .6639 L
s
.185 .244 .417 r
.68128 .49177 m .69011 .50274 L .68162 .48393 L p F P
0 0 0 r
s
.24 .35 .67 r
.67652 .4777 m
.68148 .48718 L
s
.185 .244 .417 r
.68162 .48393 m .67311 .47328 L .68128 .49177 L p F P
0 0 0 r
s
.174 .276 .58 r
.59924 .39141 m .6061 .39993 L .5875 .39136 L p F P
0 0 0 r
s
.174 .276 .58 r
.5875 .39136 m .58175 .38429 L .59924 .39141 L p F P
0 0 0 r
s
.343 .084 .039 r
.60491 .59738 m .62289 .59183 L .61642 .60673 L p F P
0 0 0 r
s
.343 .084 .039 r
.61642 .60673 m .59941 .61192 L .60491 .59738 L p F P
0 0 0 r
s
.83 .24 .1 r
.60378 .60528 m
.60692 .58549 L
s
.464 .121 .054 r
.64502 .56922 m .66391 .56331 L .65942 .58056 L p F P
0 0 0 r
s
.464 .121 .054 r
.65942 .58056 m .64106 .58623 L .64502 .56922 L p F P
0 0 0 r
s
.83 .24 .1 r
.60692 .58549 m
.64434 .57381 L
s
.64409 .55043 m
.64434 .57381 L
s
.303 .432 .811 r
.35794 .45656 m .34729 .44636 L .33567 .46335 L p F P
0 0 0 r
s
.303 .432 .811 r
.33567 .46335 m .34722 .47417 L .35794 .45656 L p F P
0 0 0 r
s
.24 .35 .67 r
.35469 .49687 m
.36408 .47093 L
s
.83 .24 .1 r
.2482 .44478 m
.26003 .43246 L
s
.26003 .43246 m
.29404 .41908 L
s
.309 .446 .849 r
.37227 .40903 m .36392 .40063 L .34297 .41186 L p F P
0 0 0 r
s
.309 .446 .849 r
.34297 .41186 m .35274 .42146 L .37227 .40903 L p F P
0 0 0 r
s
.83 .24 .1 r
.44038 .67536 m
.42673 .68005 L
s
.136 .17 .302 r
.66446 .46244 m .67311 .47328 L .66096 .45572 L p F P
0 0 0 r
s
.136 .17 .302 r
.66096 .45572 m .65281 .44551 L .66446 .46244 L p F P
0 0 0 r
s
1 .312 .132 r
.47438 .35482 m .46604 .35808 L .47718 .36391 L p F P
0 0 0 r
s
1 .312 .132 r
.47718 .36391 m .4828 .36173 L .47438 .35482 L p F P
0 0 0 r
s
.24 .35 .67 r
.48223 .36126 m
.49235 .35733 L
s
.307 .441 .834 r
.36238 .43091 m .35274 .42146 L .33647 .43599 L p F P
0 0 0 r
s
.307 .441 .834 r
.33647 .43599 m .34729 .44636 L .36238 .43091 L p F P
0 0 0 r
s
.24 .35 .67 r
.35471 .42275 m
.378 .44562 L
s
.247 .376 .756 r
.53959 .35218 m .54427 .35785 L .52975 .36376 L p F P
0 0 0 r
s
.83 .24 .1 r
.52946 .36341 m
.53032 .36309 L
s
.54421 .35777 m
.5651 .34977 L
s
.247 .376 .756 r
.52975 .36376 m .52656 .35997 L .53959 .35218 L p F P
0 0 0 r
s
.24 .35 .67 r
.49235 .35733 m
.4961 .35656 L
s
.217 .336 .687 r
.57005 .36993 m .57593 .37715 L .55809 .37457 L p F P
0 0 0 r
s
.24 .35 .67 r
.56355 .3763 m
.583 .39992 L
s
.53882 .37619 m
.56355 .3763 L
s
.217 .336 .687 r
.55809 .37457 m .55352 .36904 L .57005 .36993 L p F P
0 0 0 r
s
.131 .209 .459 r
.62245 .41106 m .63014 .42067 L .61288 .40833 L p F P
0 0 0 r
s
.131 .209 .459 r
.61288 .40833 m .6061 .39993 L .62245 .41106 L p F P
0 0 0 r
s
.554 .149 .066 r
.68359 .53879 m .70296 .53263 L .7023 .55129 L p F P
0 0 0 r
s
.24 .35 .67 r
.70289 .53465 m
.70957 .54284 L
s
.554 .149 .066 r
.7023 .55129 m .683 .55733 L .68359 .53879 L p F P
0 0 0 r
s
.996 .304 .128 r
.41246 .37248 m .40189 .37664 L .42495 .37417 L p F P
0 0 0 r
s
.996 .304 .128 r
.42495 .37417 m .43309 .37098 L .41246 .37248 L p F P
0 0 0 r
s
.089 .134 .321 r
.64453 .43512 m .65281 .44551 L .63771 .43014 L p F P
0 0 0 r
s
.24 .35 .67 r
.64336 .43953 m
.65871 .45541 L
s
.089 .134 .321 r
.63771 .43014 m .63014 .42067 L .64453 .43512 L p F P
0 0 0 r
s
.147 .182 .324 r
.41417 .62252 m .40398 .61367 L .41174 .62567 L p F P
0 0 0 r
s
.147 .182 .324 r
.41174 .62567 m .42106 .63371 L .41417 .62252 L p F P
0 0 0 r
s
.24 .35 .67 r
.40485 .60977 m
.42715 .6292 L
s
.083 .024 .01 r
.46175 .66927 m .47458 .66541 L .4785 .66664 L p F P
0 0 0 r
s
.083 .024 .01 r
.4785 .66664 m .46762 .6699 L .46175 .66927 L p F P
0 0 0 r
s
.127 .202 .442 r
.46175 .66927 m .45398 .66257 L .46109 .66424 L p F P
0 0 0 r
s
.127 .202 .442 r
.46109 .66424 m .46762 .6699 L .46175 .66927 L p F P
0 0 0 r
s
.83 .24 .1 r
.44038 .67536 m
.46136 .66905 L
s
.46136 .66905 m
.46252 .6687 L
s
.24 .35 .67 r
.46556 .66968 m
.47805 .68048 L
s
.61777 .72047 m
.59867 .70243 L
s
.61777 .72047 m
.64443 .70747 L
s
.145 .037 .015 r
.51541 .64704 m .53034 .64252 L .5269 .64969 L p F P
0 0 0 r
s
.83 .24 .1 r
.52305 .64326 m
.53021 .62783 L
s
.145 .037 .015 r
.5269 .64969 m .51367 .65367 L .51541 .64704 L p F P
0 0 0 r
s
.83 .24 .1 r
.48688 .6542 m
.52305 .64326 L
s
.229 .055 .024 r
.56587 .62215 m .58256 .61706 L .5759 .62875 L p F P
0 0 0 r
s
.229 .055 .024 r
.5759 .62875 m .56058 .63338 L .56587 .62215 L p F P
0 0 0 r
s
.83 .24 .1 r
.71652 .49986 m
.75544 .48718 L
s
.71652 .49986 m
.72035 .52614 L
s
.24 .35 .67 r
.54449 .71193 m
.52401 .69373 L
s
.54449 .71193 m
.57112 .71013 L
s
1 .312 .132 r
.48276 .35153 m .47438 .35482 L .4828 .36173 L p F P
0 0 0 r
s
1 .312 .132 r
.4828 .36173 m .48844 .35954 L .48276 .35153 L p F P
0 0 0 r
s
.83 .24 .1 r
.73028 .40104 m
.74045 .42993 L
s
.74045 .42993 m
.77964 .41649 L
s
.74045 .42993 m
.74894 .45896 L
s
.71877 .37326 m
.73028 .40104 L
s
.73028 .40104 m
.76938 .3873 L
s
.30496 .71052 m
.33955 .70007 L
s
.30496 .71052 m
.28666 .70319 L
s
.247 .376 .756 r
.53486 .34646 m .53959 .35218 L .52656 .35997 L p F P
0 0 0 r
s
.247 .376 .756 r
.52656 .35997 m .52336 .35616 L .53486 .34646 L p F P
0 0 0 r
s
.83 .24 .1 r
.65447 .33929 m
.66781 .36168 L
s
.66781 .36168 m
.70628 .3475 L
s
.996 .304 .128 r
.4231 .36829 m .41246 .37248 L .43309 .37098 L p F P
0 0 0 r
s
.83 .24 .1 r
.42678 .37239 m
.44182 .37904 L
s
.39853 .38346 m
.42678 .37239 L
s
.996 .304 .128 r
.43309 .37098 m .44127 .36778 L .4231 .36829 L p F P
0 0 0 r
s
.83 .24 .1 r
.60258 .33542 m
.61654 .35355 L
s
.61654 .35355 m
.65447 .33929 L
s
1 .312 .132 r
.49118 .34824 m .48276 .35153 L .48844 .35954 L p F P
0 0 0 r
s
.24 .35 .67 r
.48971 .35429 m
.49235 .35733 L
s
1 .312 .132 r
.48844 .35954 m .49409 .35734 L .49118 .34824 L p F P
0 0 0 r
s
.24 .35 .67 r
.39456 .3768 m
.41863 .35808 L
s
.373 .39861 m
.38839 .38304 L
s
.39016 .38125 m
.39456 .3768 L
s
.865 .27 .112 r
.36805 .38715 m .35547 .39212 L .38093 .38488 L p F P
0 0 0 r
s
.24 .35 .67 r
.36405 .38953 m
.373 .39861 L
s
.865 .27 .112 r
.38093 .38488 m .39138 .38077 L .36805 .38715 L p F P
0 0 0 r
s
.343 .084 .039 r
.62289 .59183 m .64106 .58623 L .6336 .60149 L p F P
0 0 0 r
s
.343 .084 .039 r
.6336 .60149 m .61642 .60673 L .62289 .59183 L p F P
0 0 0 r
s
.24 .35 .67 r
.69064 .66741 m
.70778 .64242 L
s
.70778 .64242 m
.69028 .62287 L
s
.174 .276 .58 r
.59229 .38278 m .59924 .39141 L .58175 .38429 L p F P
0 0 0 r
s
.174 .276 .58 r
.58175 .38429 m .57593 .37715 L .59229 .38278 L p F P
0 0 0 r
s
.464 .121 .054 r
.66391 .56331 m .683 .55733 L .67796 .57484 L p F P
0 0 0 r
s
.464 .121 .054 r
.67796 .57484 m .65942 .58056 L .66391 .56331 L p F P
0 0 0 r
s
.217 .336 .687 r
.56411 .36264 m .57005 .36993 L .55352 .36904 L p F P
0 0 0 r
s
.83 .24 .1 r
.5651 .34977 m
.57941 .36752 L
s
.217 .336 .687 r
.55352 .36904 m .54891 .36347 L .56411 .36264 L p F P
0 0 0 r
s
.083 .024 .01 r
.47458 .66541 m .48751 .66153 L .48944 .66335 L p F P
0 0 0 r
s
.083 .024 .01 r
.48944 .66335 m .4785 .66664 L .47458 .66541 L p F P
0 0 0 r
s
.83 .24 .1 r
.47631 .66456 m
.48688 .6542 L
s
.46529 .66787 m
.47631 .66456 L
s
1 .312 .132 r
.49965 .34492 m .49118 .34824 L .49409 .35734 L p F P
0 0 0 r
s
1 .312 .132 r
.49409 .35734 m .49976 .35514 L .49965 .34492 L p F P
0 0 0 r
s
.83 .24 .1 r
.74894 .45896 m
.78835 .44579 L
s
.74894 .45896 m
.75544 .48718 L
s
.234 .317 .566 r
.37302 .56257 m .36127 .55216 L .36511 .56989 L p F P
0 0 0 r
s
.234 .317 .566 r
.36511 .56989 m .3765 .57985 L .37302 .56257 L p F P
0 0 0 r
s
.24 .35 .67 r
.37384 .5437 m
.37506 .56781 L
s
.264 .365 .665 r
.36083 .53352 m .34882 .52271 L .34931 .54156 L p F P
0 0 0 r
s
.264 .365 .665 r
.34931 .54156 m .36127 .55216 L .36083 .53352 L p F P
0 0 0 r
s
.145 .037 .015 r
.53034 .64252 m .54539 .63797 L .54023 .64568 L p F P
0 0 0 r
s
.145 .037 .015 r
.54023 .64568 m .5269 .64969 L .53034 .64252 L p F P
0 0 0 r
s
.996 .304 .128 r
.43381 .36407 m .4231 .36829 L .44127 .36778 L p F P
0 0 0 r
s
.24 .35 .67 r
.41863 .35808 m
.42672 .36687 L
s
.996 .304 .128 r
.44127 .36778 m .44949 .36456 L .43381 .36407 L p F P
0 0 0 r
s
.24 .35 .67 r
.44439 .34314 m
.41863 .35808 L
s
.41863 .35808 m
.39571 .33319 L
s
.247 .376 .756 r
.5301 .3407 m .53486 .34646 L .52336 .35616 L p F P
0 0 0 r
s
.247 .376 .756 r
.52336 .35616 m .52014 .35233 L .5301 .3407 L p F P
0 0 0 r
s
.229 .055 .024 r
.58256 .61706 m .59941 .61192 L .59136 .62408 L p F P
0 0 0 r
s
.83 .24 .1 r
.56661 .61668 m
.60378 .60528 L
s
.229 .055 .024 r
.59136 .62408 m .5759 .62875 L .58256 .61706 L p F P
0 0 0 r
s
.83 .24 .1 r
.20524 .47606 m
.21447 .45797 L
s
.21447 .45797 m
.2482 .44478 L
s
.283 .397 .733 r
.35196 .50364 m .34002 .49268 L .33659 .51169 L p F P
0 0 0 r
s
.283 .397 .733 r
.33659 .51169 m .34882 .52271 L .35196 .50364 L p F P
0 0 0 r
s
.24 .35 .67 r
.35031 .52248 m
.35469 .49687 L
s
.272 .378 .683 r
.69351 .54067 m .7023 .55129 L .70296 .53263 L p F P
0 0 0 r
s
.272 .378 .683 r
.70296 .53263 m .69414 .5218 L .69351 .54067 L p F P
0 0 0 r
s
.83 .24 .1 r
.68182 .53841 m
.69371 .53463 L
s
.70234 .53188 m
.72035 .52614 L
s
.5651 .34977 m
.60258 .33542 L
s
.24 .35 .67 r
.64443 .70747 m
.62572 .6891 L
s
.64443 .70747 m
.66916 .68948 L
s
.83 .24 .1 r
.70628 .3475 m
.71877 .37326 L
s
.71877 .37326 m
.7579 .35916 L
s
.094 .106 .204 r
.43024 .64163 m .42106 .63371 L .43006 .64194 L p F P
0 0 0 r
s
.094 .106 .204 r
.43006 .64194 m .43814 .64891 L .43024 .64163 L p F P
0 0 0 r
s
.188 .246 .422 r
.38768 .58964 m .3765 .57985 L .38307 .59554 L p F P
0 0 0 r
s
.24 .35 .67 r
.37506 .56781 m
.39801 .58809 L
s
.188 .246 .422 r
.38307 .59554 m .39361 .60468 L .38768 .58964 L p F P
0 0 0 r
s
.309 .446 .849 r
.36392 .40063 m .35547 .39212 L .33304 .40212 L p F P
0 0 0 r
s
.309 .446 .849 r
.33304 .40212 m .34297 .41186 L .36392 .40063 L p F P
0 0 0 r
s
.24 .35 .67 r
.35471 .42275 m
.373 .39861 L
s
1 .312 .132 r
.50815 .34159 m .49965 .34492 L .49976 .35514 L p F P
0 0 0 r
s
1 .312 .132 r
.49976 .35514 m .50546 .35293 L .50815 .34159 L p F P
0 0 0 r
s
.235 .32 .564 r
.68516 .51077 m .69414 .5218 L .69011 .50274 L p F P
0 0 0 r
s
.235 .32 .564 r
.69011 .50274 m .68128 .49177 L .68516 .51077 L p F P
0 0 0 r
s
.295 .418 .779 r
.34722 .47417 m .33567 .46335 L .32785 .48152 L p F P
0 0 0 r
s
.295 .418 .779 r
.32785 .48152 m .34002 .49268 L .34722 .47417 L p F P
0 0 0 r
s
.131 .209 .459 r
.61465 .4013 m .62245 .41106 L .6061 .39993 L p F P
0 0 0 r
s
.131 .209 .459 r
.6061 .39993 m .59924 .39141 L .61465 .4013 L p F P
0 0 0 r
s
.83 .24 .1 r
.39107 .69076 m
.42673 .68005 L
s
.39107 .69076 m
.37488 .68938 L
s
.865 .27 .112 r
.38074 .38215 m .36805 .38715 L .39138 .38077 L p F P
0 0 0 r
s
.83 .24 .1 r
.37703 .38573 m
.38741 .38608 L
s
.865 .27 .112 r
.39138 .38077 m .40189 .37664 L .38074 .38215 L p F P
0 0 0 r
s
.127 .202 .442 r
.45398 .66257 m .44611 .65578 L .45449 .65851 L p F P
0 0 0 r
s
.24 .35 .67 r
.43937 .64757 m
.45124 .65745 L
s
.127 .202 .442 r
.45449 .65851 m .46109 .66424 L .45398 .66257 L p F P
0 0 0 r
s
.303 .432 .811 r
.34729 .44636 m .33647 .43599 L .32391 .45233 L p F P
0 0 0 r
s
.303 .432 .811 r
.32391 .45233 m .33567 .46335 L .34729 .44636 L p F P
0 0 0 r
s
.24 .35 .67 r
.34039 .44838 m
.36408 .47093 L
s
.307 .441 .834 r
.35274 .42146 m .34297 .41186 L .32547 .42545 L p F P
0 0 0 r
s
.307 .441 .834 r
.32547 .42545 m .33647 .43599 L .35274 .42146 L p F P
0 0 0 r
s
.24 .35 .67 r
.34039 .44838 m
.35471 .42275 L
s
.185 .244 .417 r
.67228 .48059 m .68128 .49177 L .67311 .47328 L p F P
0 0 0 r
s
.185 .244 .417 r
.67311 .47328 m .66446 .46244 L .67228 .48059 L p F P
0 0 0 r
s
.24 .35 .67 r
.65871 .45541 m
.66461 .4628 L
s
.66916 .68948 m
.69064 .66741 L
s
.69064 .66741 m
.67277 .64825 L
s
.70255 .5959 m
.70904 .56878 L
s
.83 .24 .1 r
.25246 .71367 m
.28666 .70319 L
s
.25246 .71367 m
.23348 .70035 L
s
.996 .304 .128 r
.44459 .35983 m .43381 .36407 L .44949 .36456 L p F P
0 0 0 r
s
.996 .304 .128 r
.44949 .36456 m .45774 .36133 L .44459 .35983 L p F P
0 0 0 r
s
.24 .35 .67 r
.49935 .68986 m
.47788 .67112 L
s
.49935 .68986 m
.52401 .69373 L
s
.089 .134 .321 r
.63611 .42456 m .64453 .43512 L .63014 .42067 L p F P
0 0 0 r
s
.089 .134 .321 r
.63014 .42067 m .62245 .41106 L .63611 .42456 L p F P
0 0 0 r
s
.24 .35 .67 r
.62486 .41644 m
.64336 .43953 L
s
.60546 .40557 m
.62486 .41644 L
s
.136 .17 .302 r
.65564 .45141 m .66446 .46244 L .65281 .44551 L p F P
0 0 0 r
s
.136 .17 .302 r
.65281 .44551 m .64453 .43512 L .65564 .45141 L p F P
0 0 0 r
s
1 .312 .132 r
.5167 .33825 m .50815 .34159 L .50546 .35293 L p F P
0 0 0 r
s
1 .312 .132 r
.50546 .35293 m .51117 .35071 L .5167 .33825 L p F P
0 0 0 r
s
.83 .24 .1 r
.4774 .36523 m
.51374 .35113 L
s
.083 .024 .01 r
.48751 .66153 m .50054 .65761 L .50046 .66005 L p F P
0 0 0 r
s
.083 .024 .01 r
.50046 .66005 m .48944 .66335 L .48751 .66153 L p F P
0 0 0 r
s
.24 .35 .67 r
.66916 .68948 m
.65087 .67073 L
s
.247 .376 .756 r
.52529 .33488 m .5301 .3407 L .52014 .35233 L p F P
0 0 0 r
s
.247 .376 .756 r
.52014 .35233 m .5169 .34848 L .52529 .33488 L p F P
0 0 0 r
s
.24 .35 .67 r
.51843 .35198 m
.53882 .37619 L
s
.5088 .35395 m
.51843 .35198 L
s
.83 .24 .1 r
.51374 .35113 m
.51917 .35583 L
s
.217 .336 .687 r
.5581 .35525 m .56411 .36264 L .54891 .36347 L p F P
0 0 0 r
s
.217 .336 .687 r
.54891 .36347 m .54427 .35785 L .5581 .35525 L p F P
0 0 0 r
s
.147 .182 .324 r
.40398 .61367 m .39361 .60468 L .40228 .6175 L p F P
0 0 0 r
s
.147 .182 .324 r
.40228 .6175 m .41174 .62567 L .40398 .61367 L p F P
0 0 0 r
s
.343 .084 .039 r
.64106 .58623 m .65942 .58056 L .65094 .5962 L p F P
0 0 0 r
s
.343 .084 .039 r
.65094 .5962 m .6336 .60149 L .64106 .58623 L p F P
0 0 0 r
s
.83 .24 .1 r
.64175 .59364 m
.64434 .57381 L
s
.145 .037 .015 r
.54539 .63797 m .56058 .63338 L .55367 .64165 L p F P
0 0 0 r
s
.145 .037 .015 r
.55367 .64165 m .54023 .64568 L .54539 .63797 L p F P
0 0 0 r
s
.464 .121 .054 r
.683 .55733 m .7023 .55129 L .6967 .56905 L p F P
0 0 0 r
s
.464 .121 .054 r
.6967 .56905 m .67796 .57484 L .683 .55733 L p F P
0 0 0 r
s
.83 .24 .1 r
.64434 .57381 m
.68257 .56189 L
s
.68182 .53841 m
.68257 .56189 L
s
1 .312 .132 r
.52529 .33488 m .5167 .33825 L .51117 .35071 L p F P
0 0 0 r
s
1 .312 .132 r
.51117 .35071 m .5169 .34848 L .52529 .33488 L p F P
0 0 0 r
s
.174 .276 .58 r
.58524 .37403 m .59229 .38278 L .57593 .37715 L p F P
0 0 0 r
s
.174 .276 .58 r
.57593 .37715 m .57005 .36993 L .58524 .37403 L p F P
0 0 0 r
s
.24 .35 .67 r
.56355 .3763 m
.58617 .38174 L
s
.83 .24 .1 r
.28265 .4313 m
.29404 .41908 L
s
.24 .35 .67 r
.51481 .34768 m
.51843 .35198 L
s
.865 .27 .112 r
.39352 .37711 m .38074 .38215 L .40189 .37664 L p F P
0 0 0 r
s
.865 .27 .112 r
.40189 .37664 m .41246 .37248 L .39352 .37711 L p F P
0 0 0 r
s
.996 .304 .128 r
.45544 .35556 m .44459 .35983 L .45774 .36133 L p F P
0 0 0 r
s
.996 .304 .128 r
.45774 .36133 m .46604 .35808 L .45544 .35556 L p F P
0 0 0 r
s
.24 .35 .67 r
.44439 .34314 m
.45547 .35557 L
s
.83 .24 .1 r
.46281 .35827 m
.4774 .36523 L
s
.16585 .51203 m
.17182 .48898 L
s
.17182 .48898 m
.20524 .47606 L
s
.229 .055 .024 r
.59941 .61192 m .61642 .60673 L .60695 .61936 L p F P
0 0 0 r
s
.229 .055 .024 r
.60695 .61936 m .59136 .62408 L .59941 .61192 L p F P
0 0 0 r
s
.24 .35 .67 r
.47092 .33257 m
.44439 .34314 L
s
.44439 .34314 m
.42183 .31784 L
s
.83 .24 .1 r
.51374 .35113 m
.52013 .34865 L
s
.24 .35 .67 r
.57112 .71013 m
.55093 .69171 L
s
.57112 .71013 m
.59867 .70243 L
s
.83 .24 .1 r
.72035 .52614 m
.75971 .51361 L
s
.72035 .52614 m
.72162 .54971 L
s
.75544 .48718 m
.7952 .47422 L
s
.75544 .48718 m
.75971 .51361 L
s
.083 .024 .01 r
.50054 .65761 m .51367 .65367 L .51154 .65673 L p F P
0 0 0 r
s
.083 .024 .01 r
.51154 .65673 m .50046 .66005 L .50054 .65761 L p F P
0 0 0 r
s
.83 .24 .1 r
.76938 .3873 m
.77964 .41649 L
s
.77964 .41649 m
.81967 .40277 L
s
.77964 .41649 m
.78835 .44579 L
s
.7579 .35916 m
.76938 .3873 L
s
.76938 .3873 m
.80931 .37325 L
s
.996 .304 .128 r
.46636 .35127 m .45544 .35556 L .46604 .35808 L p F P
0 0 0 r
s
.996 .304 .128 r
.46604 .35808 m .47438 .35482 L .46636 .35127 L p F P
0 0 0 r
s
.217 .336 .687 r
.55202 .34779 m .5581 .35525 L .54427 .35785 L p F P
0 0 0 r
s
.217 .336 .687 r
.54427 .35785 m .53959 .35218 L .55202 .34779 L p F P
0 0 0 r
s
.083 .024 .01 r
.34749 .39642 m .33304 .40212 L .35547 .39212 L p F P
0 0 0 r
s
.083 .024 .01 r
.35547 .39212 m .36805 .38715 L .34749 .39642 L p F P
0 0 0 r
s
.83 .24 .1 r
.36359 .39102 m
.37703 .38573 L
s
.24 .35 .67 r
.36329 .38876 m
.36349 .38896 L
s
.83 .24 .1 r
.33955 .70007 m
.37488 .68938 L
s
.33955 .70007 m
.3216 .69249 L
s
.865 .27 .112 r
.4064 .37203 m .39352 .37711 L .41246 .37248 L p F P
0 0 0 r
s
.24 .35 .67 r
.37124 .35232 m
.39449 .37673 L
s
.865 .27 .112 r
.41246 .37248 m .4231 .36829 L .4064 .37203 L p F P
0 0 0 r
s
.131 .209 .459 r
.60673 .3914 m .61465 .4013 L .59924 .39141 L p F P
0 0 0 r
s
.131 .209 .459 r
.59924 .39141 m .59229 .38278 L .60673 .3914 L p F P
0 0 0 r
s
.24 .35 .67 r
.58617 .38174 m
.60546 .40557 L
s
.83 .24 .1 r
.69321 .32471 m
.70628 .3475 L
s
.70628 .3475 m
.74557 .33302 L
s
.094 .106 .204 r
.42106 .63371 m .41174 .62567 L .42187 .63487 L p F P
0 0 0 r
s
.24 .35 .67 r
.40485 .60977 m
.41698 .62821 L
s
.094 .106 .204 r
.42187 .63487 m .43006 .64194 L .42106 .63371 L p F P
0 0 0 r
s
.24 .35 .67 r
.41698 .62821 m
.43937 .64757 L
s
.83 .24 .1 r
.64088 .32076 m
.65447 .33929 L
s
.65447 .33929 m
.69321 .32471 L
s
.127 .202 .442 r
.44611 .65578 m .43814 .64891 L .44781 .65272 L p F P
0 0 0 r
s
.127 .202 .442 r
.44781 .65272 m .45449 .65851 L .44611 .65578 L p F P
0 0 0 r
s
.145 .037 .015 r
.56058 .63338 m .5759 .62875 L .56721 .63758 L p F P
0 0 0 r
s
.83 .24 .1 r
.55999 .63207 m
.56661 .61668 L
s
.145 .037 .015 r
.56721 .63758 m .55367 .64165 L .56058 .63338 L p F P
0 0 0 r
s
.83 .24 .1 r
.52305 .64326 m
.55999 .63207 L
s
.234 .317 .566 r
.36127 .55216 m .34931 .54156 L .35352 .55974 L p F P
0 0 0 r
s
.24 .35 .67 r
.35031 .52248 m
.37384 .5437 L
s
.234 .317 .566 r
.35352 .55974 m .36511 .56989 L .36127 .55216 L p F P
0 0 0 r
s
.264 .365 .665 r
.34882 .52271 m .33659 .51169 L .33713 .53076 L p F P
0 0 0 r
s
.264 .365 .665 r
.33713 .53076 m .34931 .54156 L .34882 .52271 L p F P
0 0 0 r
s
.343 .084 .039 r
.65942 .58056 m .67796 .57484 L .66845 .59086 L p F P
0 0 0 r
s
.343 .084 .039 r
.66845 .59086 m .65094 .5962 L .65942 .58056 L p F P
0 0 0 r
s
.307 .441 .834 r
.34297 .41186 m .33304 .40212 L .31428 .41472 L p F P
0 0 0 r
s
.307 .441 .834 r
.31428 .41472 m .32547 .42545 L .34297 .41186 L p F P
0 0 0 r
s
.83 .24 .1 r
.29404 .41908 m
.32722 .40602 L
s
.283 .397 .733 r
.34002 .49268 m .32785 .48152 L .32413 .50047 L p F P
0 0 0 r
s
.283 .397 .733 r
.32413 .50047 m .33659 .51169 L .34002 .49268 L p F P
0 0 0 r
s
.294 .415 .762 r
.6881 .55889 m .6967 .56905 L .7023 .55129 L p F P
0 0 0 r
s
.83 .24 .1 r
.68257 .56189 m
.68896 .5599 L
s
.294 .415 .762 r
.7023 .55129 m .69351 .54067 L .6881 .55889 L p F P
0 0 0 r
s
.24 .35 .67 r
.70014 .55813 m
.70904 .56878 L
s
.83 .24 .1 r
.70114 .5561 m
.72162 .54971 L
s
.70004 .55645 m
.70114 .5561 L
s
.188 .246 .422 r
.3765 .57985 m .36511 .56989 L .37235 .58624 L p F P
0 0 0 r
s
.188 .246 .422 r
.37235 .58624 m .38307 .59554 L .3765 .57985 L p F P
0 0 0 r
s
.24 .35 .67 r
.37506 .56781 m
.38172 .58962 L
s
.996 .304 .128 r
.47735 .34694 m .46636 .35127 L .47438 .35482 L p F P
0 0 0 r
s
.996 .304 .128 r
.47438 .35482 m .48276 .35153 L .47735 .34694 L p F P
0 0 0 r
s
.272 .378 .683 r
.68455 .52985 m .69351 .54067 L .69414 .5218 L p F P
0 0 0 r
s
.272 .378 .683 r
.69414 .5218 m .68516 .51077 L .68455 .52985 L p F P
0 0 0 r
s
.229 .055 .024 r
.61642 .60673 m .6336 .60149 L .62268 .61461 L p F P
0 0 0 r
s
.83 .24 .1 r
.60378 .60528 m
.64175 .59364 L
s
.229 .055 .024 r
.62268 .61461 m .60695 .61936 L .61642 .60673 L p F P
0 0 0 r
s
.174 .276 .58 r
.5781 .36516 m .58524 .37403 L .57005 .36993 L p F P
0 0 0 r
s
.174 .276 .58 r
.57005 .36993 m .56411 .36264 L .5781 .36516 L p F P
0 0 0 r
s
.83 .24 .1 r
.78835 .44579 m
.82861 .43234 L
s
.78835 .44579 m
.7952 .47422 L
s
.295 .418 .779 r
.33567 .46335 m .32391 .45233 L .31545 .47015 L p F P
0 0 0 r
s
.295 .418 .779 r
.31545 .47015 m .32785 .48152 L .33567 .46335 L p F P
0 0 0 r
s
.24 .35 .67 r
.33062 .47461 m
.35469 .49687 L
s
.089 .134 .321 r
.62755 .41382 m .63611 .42456 L .62245 .41106 L p F P
0 0 0 r
s
.089 .134 .321 r
.62245 .41106 m .61465 .4013 L .62755 .41382 L p F P
0 0 0 r
s
.303 .432 .811 r
.33647 .43599 m .32547 .42545 L .31194 .44112 L p F P
0 0 0 r
s
.303 .432 .811 r
.31194 .44112 m .32391 .45233 L .33647 .43599 L p F P
0 0 0 r
s
.24 .35 .67 r
.33062 .47461 m
.34039 .44838 L
s
.235 .32 .564 r
.67601 .49953 m .68516 .51077 L .68128 .49177 L p F P
0 0 0 r
s
.235 .32 .564 r
.68128 .49177 m .67228 .48059 L .67601 .49953 L p F P
0 0 0 r
s
.083 .024 .01 r
.51367 .65367 m .5269 .64969 L .5227 .65338 L p F P
0 0 0 r
s
.083 .024 .01 r
.5227 .65338 m .51154 .65673 L .51367 .65367 L p F P
0 0 0 r
s
.185 .244 .417 r
.66312 .46919 m .67228 .48059 L .66446 .46244 L p F P
0 0 0 r
s
.24 .35 .67 r
.65871 .45541 m
.66388 .46537 L
s
.185 .244 .417 r
.66446 .46244 m .65564 .45141 L .66312 .46919 L p F P
0 0 0 r
s
.83 .24 .1 r
.2394 .46286 m
.2482 .44478 L
s
.2482 .44478 m
.28265 .4313 L
s
.136 .17 .302 r
.64667 .44018 m .65564 .45141 L .64453 .43512 L p F P
0 0 0 r
s
.136 .17 .302 r
.64453 .43512 m .63611 .42456 L .64667 .44018 L p F P
0 0 0 r
s
.24 .35 .67 r
.69028 .62287 m
.70255 .5959 L
s
.83 .24 .1 r
.58878 .322 m
.60258 .33542 L
s
.60258 .33542 m
.64088 .32076 L
s
.865 .27 .112 r
.41938 .36691 m .4064 .37203 L .4231 .36829 L p F P
0 0 0 r
s
.83 .24 .1 r
.41279 .37165 m
.42678 .37239 L
s
.865 .27 .112 r
.4231 .36829 m .43381 .36407 L .41938 .36691 L p F P
0 0 0 r
s
.83 .24 .1 r
.42678 .37239 m
.46281 .35827 L
s
.74557 .33302 m
.7579 .35916 L
s
.7579 .35916 m
.79788 .34475 L
s
.083 .024 .01 r
.36207 .39068 m .34749 .39642 L .36805 .38715 L p F P
0 0 0 r
s
.083 .024 .01 r
.36805 .38715 m .38074 .38215 L .36207 .39068 L p F P
0 0 0 r
s
.217 .336 .687 r
.54587 .34025 m .55202 .34779 L .53959 .35218 L p F P
0 0 0 r
s
.83 .24 .1 r
.55085 .33672 m
.5651 .34977 L
s
.217 .336 .687 r
.53959 .35218 m .53486 .34646 L .54587 .34025 L p F P
0 0 0 r
s
.24 .35 .67 r
.51843 .35198 m
.54338 .3518 L
s
.147 .182 .324 r
.39361 .60468 m .38307 .59554 L .39267 .60921 L p F P
0 0 0 r
s
.147 .182 .324 r
.39267 .60921 m .40228 .6175 L .39361 .60468 L p F P
0 0 0 r
s
.24 .35 .67 r
.38172 .58962 m
.40485 .60977 L
s
.996 .304 .128 r
.48841 .34259 m .47735 .34694 L .48276 .35153 L p F P
0 0 0 r
s
.24 .35 .67 r
.47092 .33257 m
.48183 .34518 L
s
.48469 .34848 m
.48617 .3502 L
s
.996 .304 .128 r
.48276 .35153 m .49118 .34824 L .48841 .34259 L p F P
0 0 0 r
s
.83 .24 .1 r
.42673 .68005 m
.41099 .67847 L
s
.145 .037 .015 r
.5759 .62875 m .59136 .62408 L .58085 .63348 L p F P
0 0 0 r
s
.145 .037 .015 r
.58085 .63348 m .56721 .63758 L .5759 .62875 L p F P
0 0 0 r
s
.83 .24 .1 r
.28666 .70319 m
.3216 .69249 L
s
.28666 .70319 m
.26794 .68959 L
s
.24 .35 .67 r
.49728 .32686 m
.47092 .33257 L
s
.47092 .33257 m
.44869 .30686 L
s
.763 .242 .101 r
.46762 .6699 m .4785 .66664 L .48309 .66377 L p F P
0 0 0 r
s
.763 .242 .101 r
.48309 .66377 m .47452 .66634 L .46762 .6699 L p F P
0 0 0 r
s
.83 .24 .1 r
.47631 .66456 m
.51301 .65352 L
s
.168 .272 .57 r
.46762 .6699 m .46109 .66424 L .46942 .66188 L p F P
0 0 0 r
s
.24 .35 .67 r
.46014 .66341 m
.46166 .66407 L
s
.83 .24 .1 r
.46639 .66798 m
.46697 .66778 L
s
.42673 .68005 m
.46316 .6691 L
s
.46316 .6691 m
.46639 .66798 L
s
.168 .272 .57 r
.46942 .66188 m .47452 .66634 L .46762 .6699 L p F P
0 0 0 r
s
.83 .24 .1 r
.47356 .66551 m
.47631 .66456 L
s
.24 .35 .67 r
.47264 .66884 m
.47788 .67112 L
s
.4717 .66843 m
.47264 .66884 L
s
.59867 .70243 m
.57884 .68372 L
s
.59867 .70243 m
.62572 .6891 L
s
.343 .084 .039 r
.67796 .57484 m .6967 .56905 L .68613 .58547 L p F P
0 0 0 r
s
.343 .084 .039 r
.68613 .58547 m .66845 .59086 L .67796 .57484 L p F P
0 0 0 r
s
.083 .024 .01 r
.5269 .64969 m .54023 .64568 L .53393 .65002 L p F P
0 0 0 r
s
.083 .024 .01 r
.53393 .65002 m .5227 .65338 L .5269 .64969 L p F P
0 0 0 r
s
.83 .24 .1 r
.51301 .65352 m
.52305 .64326 L
s
.865 .27 .112 r
.43246 .36175 m .41938 .36691 L .43381 .36407 L p F P
0 0 0 r
s
.865 .27 .112 r
.43381 .36407 m .44459 .35983 L .43246 .36175 L p F P
0 0 0 r
s
.24 .35 .67 r
.52401 .69373 m
.50275 .67484 L
s
.52401 .69373 m
.55093 .69171 L
s
.996 .304 .128 r
.49954 .33821 m .48841 .34259 L .49118 .34824 L p F P
0 0 0 r
s
.996 .304 .128 r
.49118 .34824 m .49965 .34492 L .49954 .33821 L p F P
0 0 0 r
s
.131 .209 .459 r
.59868 .38134 m .60673 .3914 L .59229 .38278 L p F P
0 0 0 r
s
.131 .209 .459 r
.59229 .38278 m .58524 .37403 L .59868 .38134 L p F P
0 0 0 r
s
.229 .055 .024 r
.6336 .60149 m .65094 .5962 L .63855 .60981 L p F P
0 0 0 r
s
.229 .055 .024 r
.63855 .60981 m .62268 .61461 L .6336 .60149 L p F P
0 0 0 r
s
.127 .202 .442 r
.43814 .64891 m .43006 .64194 L .44105 .64687 L p F P
0 0 0 r
s
.127 .202 .442 r
.44105 .64687 m .44781 .65272 L .43814 .64891 L p F P
0 0 0 r
s
.083 .024 .01 r
.37678 .38488 m .36207 .39068 L .38074 .38215 L p F P
0 0 0 r
s
.24 .35 .67 r
.34927 .37452 m
.36329 .38876 L
s
.083 .024 .01 r
.38074 .38215 m .39352 .37711 L .37678 .38488 L p F P
0 0 0 r
s
.174 .276 .58 r
.57087 .35618 m .5781 .36516 L .56411 .36264 L p F P
0 0 0 r
s
.174 .276 .58 r
.56411 .36264 m .5581 .35525 L .57087 .35618 L p F P
0 0 0 r
s
.24 .35 .67 r
.54338 .3518 m
.56355 .3763 L
s
.83 .24 .1 r
.19966 .49919 m
.20524 .47606 L
s
.20524 .47606 m
.2394 .46286 L
s
.094 .106 .204 r
.41174 .62567 m .40228 .6175 L .41358 .62771 L p F P
0 0 0 r
s
.094 .106 .204 r
.41358 .62771 m .42187 .63487 L .41174 .62567 L p F P
0 0 0 r
s
.83 .24 .1 r
.23348 .70035 m
.26794 .68959 L
s
.23348 .70035 m
.21511 .68126 L
s
.217 .336 .687 r
.53966 .33261 m .54587 .34025 L .53486 .34646 L p F P
0 0 0 r
s
.83 .24 .1 r
.53265 .34378 m
.53628 .34238 L
s
.54488 .33903 m
.55085 .33672 L
s
.217 .336 .687 r
.53486 .34646 m .5301 .3407 L .53966 .33261 L p F P
0 0 0 r
s
.83 .24 .1 r
.55085 .33672 m
.58878 .322 L
s
.24 .35 .67 r
.39571 .33319 m
.37124 .35232 L
s
.37124 .35232 m
.34705 .32691 L
s
.37124 .35232 m
.34927 .37452 L
s
.763 .242 .101 r
.4785 .66664 m .48944 .66335 L .4917 .66119 L p F P
0 0 0 r
s
.763 .242 .101 r
.4917 .66119 m .48309 .66377 L .4785 .66664 L p F P
0 0 0 r
s
.83 .24 .1 r
.75971 .51361 m
.79993 .50081 L
s
.75971 .51361 m
.76152 .53727 L
s
.24 .35 .67 r
.34927 .37452 m
.32464 .34952 L
s
.996 .304 .128 r
.51074 .3338 m .49954 .33821 L .49965 .34492 L p F P
0 0 0 r
s
.24 .35 .67 r
.50661 .33794 m
.50931 .34114 L
s
.996 .304 .128 r
.49965 .34492 m .50815 .34159 L .51074 .3338 L p F P
0 0 0 r
s
.24 .35 .67 r
.49728 .32686 m
.50502 .33605 L
s
.83 .24 .1 r
.49961 .34385 m
.51374 .35113 L
s
.092 .026 .011 r
.33027 .40845 m .31428 .41472 L .33304 .40212 L p F P
0 0 0 r
s
.092 .026 .011 r
.33304 .40212 m .34749 .39642 L .33027 .40845 L p F P
0 0 0 r
s
.24 .35 .67 r
.33056 .39903 m
.34927 .37452 L
s
.33356 .40197 m
.33368 .40209 L
s
.33604 .40441 m
.35471 .42275 L
s
.33056 .39903 m
.33356 .40197 L
s
.83 .24 .1 r
.7952 .47422 m
.83583 .46098 L
s
.7952 .47422 m
.79993 .50081 L
s
.145 .037 .015 r
.59136 .62408 m .60695 .61936 L .59461 .62934 L p F P
0 0 0 r
s
.83 .24 .1 r
.59772 .62065 m
.60378 .60528 L
s
.145 .037 .015 r
.59461 .62934 m .58085 .63348 L .59136 .62408 L p F P
0 0 0 r
s
.83 .24 .1 r
.55999 .63207 m
.59772 .62065 L
s
.24 .35 .67 r
.67277 .64825 m
.69028 .62287 L
s
.69028 .62287 m
.67212 .60257 L
s
.83 .24 .1 r
.81967 .40277 m
.80931 .37325 L
s
.82861 .43234 m
.81967 .40277 L
s
.865 .27 .112 r
.44565 .35655 m .43246 .36175 L .44459 .35983 L p F P
0 0 0 r
s
.865 .27 .112 r
.44459 .35983 m .45544 .35556 L .44565 .35655 L p F P
0 0 0 r
s
.83 .24 .1 r
.44932 .35727 m
.46281 .35827 L
s
.089 .134 .321 r
.61883 .4029 m .62755 .41382 L .61465 .4013 L p F P
0 0 0 r
s
.089 .134 .321 r
.61465 .4013 m .60673 .3914 L .61883 .4029 L p F P
0 0 0 r
s
.83 .24 .1 r
.80931 .37325 m
.79788 .34475 L
s
.19966 .49919 m
.16585 .51203 L
s
.16402 .53904 m
.16585 .51203 L
s
.083 .024 .01 r
.54023 .64568 m .55367 .64165 L .54523 .64663 L p F P
0 0 0 r
s
.083 .024 .01 r
.54523 .64663 m .53393 .65002 L .54023 .64568 L p F P
0 0 0 r
s
.234 .317 .566 r
.34931 .54156 m .33713 .53076 L .34172 .54941 L p F P
0 0 0 r
s
.234 .317 .566 r
.34172 .54941 m .35352 .55974 L .34931 .54156 L p F P
0 0 0 r
s
.24 .35 .67 r
.35031 .52248 m
.35126 .54677 L
s
.264 .365 .665 r
.33659 .51169 m .32413 .50047 L .32471 .51975 L p F P
0 0 0 r
s
.264 .365 .665 r
.32471 .51975 m .33713 .53076 L .33659 .51169 L p F P
0 0 0 r
s
.188 .246 .422 r
.36511 .56989 m .35352 .55974 L .36145 .57679 L p F P
0 0 0 r
s
.24 .35 .67 r
.35126 .54677 m
.37506 .56781 L
s
.188 .246 .422 r
.36145 .57679 m .37235 .58624 L .36511 .56989 L p F P
0 0 0 r
s
.303 .432 .811 r
.32547 .42545 m .31428 .41472 L .29975 .4297 L p F P
0 0 0 r
s
.303 .432 .811 r
.29975 .4297 m .31194 .44112 L .32547 .42545 L p F P
0 0 0 r
s
.83 .24 .1 r
.37488 .68938 m
.41099 .67847 L
s
.37488 .68938 m
.35731 .68155 L
s
.24 .35 .67 r
.42183 .31784 m
.39571 .33319 L
s
.39571 .33319 m
.37192 .30736 L
s
.168 .272 .57 r
.46109 .66424 m .45449 .65851 L .46427 .65738 L p F P
0 0 0 r
s
.168 .272 .57 r
.46427 .65738 m .46942 .66188 L .46109 .66424 L p F P
0 0 0 r
s
.83 .24 .1 r
.73279 .30982 m
.74557 .33302 L
s
.74557 .33302 m
.78572 .31822 L
s
.283 .397 .733 r
.32785 .48152 m .31545 .47015 L .31143 .48903 L p F P
0 0 0 r
s
.283 .397 .733 r
.31143 .48903 m .32413 .50047 L .32785 .48152 L p F P
0 0 0 r
s
.24 .35 .67 r
.32589 .50047 m
.33062 .47461 L
s
.294 .415 .762 r
.67935 .54855 m .6881 .55889 L .69351 .54067 L p F P
0 0 0 r
s
.24 .35 .67 r
.69167 .54169 m
.69176 .53856 L
s
.294 .415 .762 r
.69351 .54067 m .68455 .52985 L .67935 .54855 L p F P
0 0 0 r
s
.83 .24 .1 r
.68 .30578 m
.69321 .32471 L
s
.69321 .32471 m
.73279 .30982 L
s
.24 .35 .67 r
.62572 .6891 m
.6063 .67003 L
s
.62572 .6891 m
.65087 .67073 L
s
.083 .024 .01 r
.39162 .37904 m .37678 .38488 L .39352 .37711 L p F P
0 0 0 r
s
.083 .024 .01 r
.39352 .37711 m .4064 .37203 L .39162 .37904 L p F P
0 0 0 r
s
.83 .24 .1 r
.37703 .38573 m
.41279 .37165 L
s
.295 .418 .779 r
.32391 .45233 m .31194 .44112 L .30282 .45856 L p F P
0 0 0 r
s
.24 .35 .67 r
.31581 .42499 m
.34039 .44838 L
s
.295 .418 .779 r
.30282 .45856 m .31545 .47015 L .32391 .45233 L p F P
0 0 0 r
s
.272 .378 .683 r
.67543 .51883 m .68455 .52985 L .68516 .51077 L p F P
0 0 0 r
s
.272 .378 .683 r
.68516 .51077 m .67601 .49953 L .67543 .51883 L p F P
0 0 0 r
s
.24 .35 .67 r
.67425 .49953 m
.67595 .50162 L
s
.83 .24 .1 r
.72162 .54971 m
.76152 .53727 L
s
.72162 .54971 m
.72019 .5696 L
s
.308 .438 .814 r
.67791 .576 m .68613 .58547 L .6967 .56905 L p F P
0 0 0 r
s
.83 .24 .1 r
.68055 .58175 m
.6808 .57932 L
s
.68126 .57476 m
.68257 .56189 L
s
.24 .35 .67 r
.68931 .58054 m
.70255 .5959 L
s
.308 .438 .814 r
.6967 .56905 m .6881 .55889 L .67791 .576 L p F P
0 0 0 r
s
.136 .17 .302 r
.63753 .42874 m .64667 .44018 L .63611 .42456 L p F P
0 0 0 r
s
.136 .17 .302 r
.63611 .42456 m .62755 .41382 L .63753 .42874 L p F P
0 0 0 r
s
.24 .35 .67 r
.62486 .41644 m
.64023 .43229 L
s
.996 .304 .128 r
.52202 .32936 m .51074 .3338 L .50815 .34159 L p F P
0 0 0 r
s
.996 .304 .128 r
.50815 .34159 m .5167 .33825 L .52202 .32936 L p F P
0 0 0 r
s
.229 .055 .024 r
.65094 .5962 m .66845 .59086 L .65456 .60497 L p F P
0 0 0 r
s
.83 .24 .1 r
.64175 .59364 m
.68055 .58175 L
s
.229 .055 .024 r
.65456 .60497 m .63855 .60981 L .65094 .5962 L p F P
0 0 0 r
s
.83 .24 .1 r
.63628 .60898 m
.64175 .59364 L
s
.235 .32 .564 r
.66668 .48807 m .67601 .49953 L .67228 .48059 L p F P
0 0 0 r
s
.24 .35 .67 r
.67363 .49661 m
.67425 .49953 L
s
.235 .32 .564 r
.67228 .48059 m .66312 .46919 L .66668 .48807 L p F P
0 0 0 r
s
.763 .242 .101 r
.48944 .66335 m .50046 .66005 L .50036 .65859 L p F P
0 0 0 r
s
.763 .242 .101 r
.50036 .65859 m .4917 .66119 L .48944 .66335 L p F P
0 0 0 r
s
.185 .244 .417 r
.65378 .45759 m .66312 .46919 L .65564 .45141 L p F P
0 0 0 r
s
.185 .244 .417 r
.65564 .45141 m .64667 .44018 L .65378 .45759 L p F P
0 0 0 r
s
.24 .35 .67 r
.64023 .43229 m
.64681 .44052 L
s
.147 .182 .324 r
.38307 .59554 m .37235 .58624 L .38292 .60079 L p F P
0 0 0 r
s
.147 .182 .324 r
.38292 .60079 m .39267 .60921 L .38307 .59554 L p F P
0 0 0 r
s
.217 .336 .687 r
.53337 .3249 m .53966 .33261 L .5301 .3407 L p F P
0 0 0 r
s
.217 .336 .687 r
.5301 .3407 m .52529 .33488 L .53337 .3249 L p F P
0 0 0 r
s
.24 .35 .67 r
.31581 .42499 m
.32376 .411 L
s
.865 .27 .112 r
.45894 .35131 m .44565 .35655 L .45544 .35556 L p F P
0 0 0 r
s
.865 .27 .112 r
.45544 .35556 m .46636 .35127 L .45894 .35131 L p F P
0 0 0 r
s
.83 .24 .1 r
.46281 .35827 m
.49961 .34385 L
s
.24 .35 .67 r
.65087 .67073 m
.67277 .64825 L
s
.67277 .64825 m
.65421 .62837 L
s
.83 .24 .1 r
.83583 .46098 m
.82861 .43234 L
s
.174 .276 .58 r
.56353 .34707 m .57087 .35618 L .5581 .35525 L p F P
0 0 0 r
s
.174 .276 .58 r
.5581 .35525 m .55202 .34779 L .56353 .34707 L p F P
0 0 0 r
s
.24 .35 .67 r
.54338 .3518 m
.56616 .35701 L
s
.47348 .66727 m
.47788 .67112 L
s
.47788 .67112 m
.50275 .67484 L
s
.65087 .67073 m
.63188 .65126 L
s
.131 .209 .459 r
.59051 .37112 m .59868 .38134 L .58524 .37403 L p F P
0 0 0 r
s
.131 .209 .459 r
.58524 .37403 m .5781 .36516 L .59051 .37112 L p F P
0 0 0 r
s
.092 .026 .011 r
.34641 .40211 m .33027 .40845 L .34749 .39642 L p F P
0 0 0 r
s
.24 .35 .67 r
.32575 .40749 m
.33056 .39903 L
s
.30548 .3744 m
.33056 .39903 L
s
.092 .026 .011 r
.34749 .39642 m .36207 .39068 L .34641 .40211 L p F P
0 0 0 r
s
.145 .037 .015 r
.60695 .61936 m .62268 .61461 L .60846 .62518 L p F P
0 0 0 r
s
.145 .037 .015 r
.60846 .62518 m .59461 .62934 L .60695 .61936 L p F P
0 0 0 r
s
.127 .202 .442 r
.43006 .64194 m .42187 .63487 L .43422 .64095 L p F P
0 0 0 r
s
.24 .35 .67 r
.41698 .62821 m
.4295 .63863 L
s
.127 .202 .442 r
.43422 .64095 m .44105 .64687 L .43006 .64194 L p F P
0 0 0 r
s
.83 .24 .1 r
.2743 .44937 m
.28265 .4313 L
s
.62754 .30695 m
.64088 .32076 L
s
.64088 .32076 m
.68 .30578 L
s
.083 .024 .01 r
.55367 .64165 m .56721 .63758 L .55661 .64322 L p F P
0 0 0 r
s
.083 .024 .01 r
.55661 .64322 m .54523 .64663 L .55367 .64165 L p F P
0 0 0 r
s
.83 .24 .1 r
.79788 .34475 m
.78572 .31822 L
s
.996 .304 .128 r
.53337 .3249 m .52202 .32936 L .5167 .33825 L p F P
0 0 0 r
s
.996 .304 .128 r
.5167 .33825 m .52529 .33488 L .53337 .3249 L p F P
0 0 0 r
s
.24 .35 .67 r
.52244 .32637 m
.5242 .32851 L
s
.52671 .33156 m
.54338 .3518 L
s
.83 .24 .1 r
.49961 .34385 m
.52961 .33209 L
s
.5369 .32923 m
.53723 .32911 L
s
.763 .242 .101 r
.50046 .66005 m .51154 .65673 L .50906 .65597 L p F P
0 0 0 r
s
.763 .242 .101 r
.50906 .65597 m .50036 .65859 L .50046 .66005 L p F P
0 0 0 r
s
.083 .024 .01 r
.40659 .37314 m .39162 .37904 L .4064 .37203 L p F P
0 0 0 r
s
.083 .024 .01 r
.4064 .37203 m .41938 .36691 L .40659 .37314 L p F P
0 0 0 r
s
.83 .24 .1 r
.46316 .6691 m
.47058 .66687 L
s
.44789 .66731 m
.46316 .6691 L
s
.094 .106 .204 r
.40228 .6175 m .39267 .60921 L .40516 .62046 L p F P
0 0 0 r
s
.094 .106 .204 r
.40516 .62046 m .41358 .62771 L .40228 .6175 L p F P
0 0 0 r
s
.24 .35 .67 r
.49728 .32686 m
.52244 .32637 L
s
.49728 .32686 m
.47531 .30077 L
s
.83 .24 .1 r
.3216 .69249 m
.35731 .68155 L
s
.3216 .69249 m
.30316 .67858 L
s
.6894 .57904 m
.72019 .5696 L
s
.68055 .58175 m
.68241 .58118 L
s
.865 .27 .112 r
.47233 .34603 m .45894 .35131 L .46636 .35127 L p F P
0 0 0 r
s
.865 .27 .112 r
.46636 .35127 m .47735 .34694 L .47233 .34603 L p F P
0 0 0 r
s
.24 .35 .67 r
.44869 .30686 m
.42183 .31784 L
s
.42183 .31784 m
.39841 .29157 L
s
.168 .272 .57 r
.45449 .65851 m .44781 .65272 L .45907 .65283 L p F P
0 0 0 r
s
.168 .272 .57 r
.45907 .65283 m .46427 .65738 L .45449 .65851 L p F P
0 0 0 r
s
.229 .055 .024 r
.66845 .59086 m .68613 .58547 L .67072 .60009 L p F P
0 0 0 r
s
.229 .055 .024 r
.67072 .60009 m .65456 .60497 L .66845 .59086 L p F P
0 0 0 r
s
.24 .35 .67 r
.55093 .69171 m
.52997 .67258 L
s
.55093 .69171 m
.57884 .68372 L
s
.089 .134 .321 r
.60997 .39179 m .61883 .4029 L .60673 .3914 L p F P
0 0 0 r
s
.24 .35 .67 r
.60566 .39248 m
.62486 .41644 L
s
.089 .134 .321 r
.60673 .3914 m .59868 .38134 L .60997 .39179 L p F P
0 0 0 r
s
.24 .35 .67 r
.58617 .38174 m
.60566 .39248 L
s
.083 .024 .01 r
.56721 .63758 m .58085 .63348 L .56806 .63978 L p F P
0 0 0 r
s
.083 .024 .01 r
.56806 .63978 m .55661 .64322 L .56721 .63758 L p F P
0 0 0 r
s
.83 .24 .1 r
.55051 .64225 m
.55999 .63207 L
s
.092 .026 .011 r
.36272 .39571 m .34641 .40211 L .36207 .39068 L p F P
0 0 0 r
s
.092 .026 .011 r
.36207 .39068 m .37678 .38488 L .36272 .39571 L p F P
0 0 0 r
s
.83 .24 .1 r
.3738 .38718 m
.37703 .38573 L
s
.145 .037 .015 r
.62268 .61461 m .63855 .60981 L .62243 .62098 L p F P
0 0 0 r
s
.145 .037 .015 r
.62243 .62098 m .60846 .62518 L .62268 .61461 L p F P
0 0 0 r
s
.83 .24 .1 r
.59772 .62065 m
.63628 .60898 L
s
.763 .242 .101 r
.51154 .65673 m .5227 .65338 L .5178 .65335 L p F P
0 0 0 r
s
.763 .242 .101 r
.5178 .65335 m .50906 .65597 L .51154 .65673 L p F P
0 0 0 r
s
.83 .24 .1 r
.51301 .65352 m
.55051 .64225 L
s
.50039 .65792 m
.51301 .65352 L
s
.23421 .48607 m
.2394 .46286 L
s
.2394 .46286 m
.2743 .44937 L
s
.174 .276 .58 r
.55609 .33784 m .56353 .34707 L .55202 .34779 L p F P
0 0 0 r
s
.174 .276 .58 r
.55202 .34779 m .54587 .34025 L .55609 .33784 L p F P
0 0 0 r
s
.83 .24 .1 r
.26794 .68959 m
.30316 .67858 L
s
.26794 .68959 m
.24975 .67016 L
s
.083 .024 .01 r
.4217 .36718 m .40659 .37314 L .41938 .36691 L p F P
0 0 0 r
s
.083 .024 .01 r
.41938 .36691 m .43246 .36175 L .4217 .36718 L p F P
0 0 0 r
s
.83 .24 .1 r
.41279 .37165 m
.44932 .35727 L
s
.21511 .68126 m
.24975 .67016 L
s
.21511 .68126 m
.19835 .65721 L
s
.57568 .31404 m
.58878 .322 L
s
.58878 .322 m
.62754 .30695 L
s
.178 .043 .018 r
.31692 .42301 m .29975 .4297 L .31428 .41472 L p F P
0 0 0 r
s
.24 .35 .67 r
.30924 .41874 m
.31015 .4196 L
s
.31466 .42389 m
.31581 .42499 L
s
.29029 .40071 m
.30924 .41874 L
s
.178 .043 .018 r
.31428 .41472 m .33027 .40845 L .31692 .42301 L p F P
0 0 0 r
s
.865 .27 .112 r
.48583 .34071 m .47233 .34603 L .47735 .34694 L p F P
0 0 0 r
s
.865 .27 .112 r
.47735 .34694 m .48841 .34259 L .48583 .34071 L p F P
0 0 0 r
s
.234 .317 .566 r
.33713 .53076 m .32471 .51975 L .3297 .53889 L p F P
0 0 0 r
s
.24 .35 .67 r
.32589 .50047 m
.35031 .52248 L
s
.234 .317 .566 r
.3297 .53889 m .34172 .54941 L .33713 .53076 L p F P
0 0 0 r
s
.83 .24 .1 r
.79993 .50081 m
.84104 .48772 L
s
.79993 .50081 m
.80231 .52455 L
s
.188 .246 .422 r
.35352 .55974 m .34172 .54941 L .35036 .56717 L p F P
0 0 0 r
s
.188 .246 .422 r
.35036 .56717 m .36145 .57679 L .35352 .55974 L p F P
0 0 0 r
s
.24 .35 .67 r
.35126 .54677 m
.35771 .56871 L
s
.136 .17 .302 r
.62822 .4171 m .63753 .42874 L .62755 .41382 L p F P
0 0 0 r
s
.136 .17 .302 r
.62755 .41382 m .61883 .4029 L .62822 .4171 L p F P
0 0 0 r
s
.264 .365 .665 r
.32413 .50047 m .31143 .48903 L .31206 .50854 L p F P
0 0 0 r
s
.264 .365 .665 r
.31206 .50854 m .32471 .51975 L .32413 .50047 L p F P
0 0 0 r
s
.83 .24 .1 r
.84104 .48772 m
.83583 .46098 L
s
.131 .209 .459 r
.58222 .36074 m .59051 .37112 L .5781 .36516 L p F P
0 0 0 r
s
.131 .209 .459 r
.5781 .36516 m .57087 .35618 L .58222 .36074 L p F P
0 0 0 r
s
.24 .35 .67 r
.56616 .35701 m
.58617 .38174 L
s
.295 .418 .779 r
.31194 .44112 m .29975 .4297 L .28995 .44675 L p F P
0 0 0 r
s
.83 .24 .1 r
.28265 .4313 m
.3077 .42151 L
s
.295 .418 .779 r
.28995 .44675 m .30282 .45856 L .31194 .44112 L p F P
0 0 0 r
s
.24 .35 .67 r
.30564 .45151 m
.31581 .42499 L
s
.283 .397 .733 r
.31545 .47015 m .30282 .45856 L .29848 .47737 L p F P
0 0 0 r
s
.283 .397 .733 r
.29848 .47737 m .31143 .48903 L .31545 .47015 L p F P
0 0 0 r
s
.24 .35 .67 r
.30564 .45151 m
.33062 .47461 L
s
.294 .415 .762 r
.67043 .53801 m .67935 .54855 L .68455 .52985 L p F P
0 0 0 r
s
.294 .415 .762 r
.68455 .52985 m .67543 .51883 L .67043 .53801 L p F P
0 0 0 r
s
.308 .438 .814 r
.66955 .56637 m .67791 .576 L .6881 .55889 L p F P
0 0 0 r
s
.308 .438 .814 r
.6881 .55889 m .67935 .54855 L .66955 .56637 L p F P
0 0 0 r
s
.127 .202 .442 r
.42187 .63487 m .41358 .62771 L .42731 .63496 L p F P
0 0 0 r
s
.24 .35 .67 r
.39375 .60812 m
.41698 .62821 L
s
.127 .202 .442 r
.42731 .63496 m .43422 .64095 L .42187 .63487 L p F P
0 0 0 r
s
.83 .24 .1 r
.16654 .56866 m
.16402 .53904 L
s
.16402 .53904 m
.19816 .52636 L
s
.272 .378 .683 r
.66612 .5076 m .67543 .51883 L .67601 .49953 L p F P
0 0 0 r
s
.272 .378 .683 r
.67601 .49953 m .66668 .48807 L .66612 .5076 L p F P
0 0 0 r
s
.147 .182 .324 r
.37235 .58624 m .36145 .57679 L .37301 .59224 L p F P
0 0 0 r
s
.147 .182 .324 r
.37301 .59224 m .38292 .60079 L .37235 .58624 L p F P
0 0 0 r
s
.24 .35 .67 r
.35771 .56871 m
.38172 .58962 L
s
.38172 .58962 m
.39375 .60812 L
s
.185 .244 .417 r
.64427 .44576 m .65378 .45759 L .64667 .44018 L p F P
0 0 0 r
s
.24 .35 .67 r
.64023 .43229 m
.64559 .44269 L
s
.185 .244 .417 r
.64667 .44018 m .63753 .42874 L .64427 .44576 L p F P
0 0 0 r
s
.83 .24 .1 r
.23421 .48607 m
.19966 .49919 L
s
.19816 .52636 m
.19966 .49919 L
s
.235 .32 .564 r
.65717 .47639 m .66668 .48807 L .66312 .46919 L p F P
0 0 0 r
s
.235 .32 .564 r
.66312 .46919 m .65378 .45759 L .65717 .47639 L p F P
0 0 0 r
s
.763 .242 .101 r
.5227 .65338 m .53393 .65002 L .52659 .65071 L p F P
0 0 0 r
s
.763 .242 .101 r
.52659 .65071 m .5178 .65335 L .5227 .65338 L p F P
0 0 0 r
s
.315 .452 .849 r
.66306 .59152 m .67072 .60009 L .68613 .58547 L p F P
0 0 0 r
s
.83 .24 .1 r
.67569 .59705 m
.67639 .59484 L
s
.67639 .59484 m
.6773 .59198 L
s
.315 .452 .849 r
.68613 .58547 m .67791 .576 L .66306 .59152 L p F P
0 0 0 r
s
.83 .24 .1 r
.41099 .67847 m
.44789 .66731 L
s
.41099 .67847 m
.39381 .67037 L
s
.78572 .31822 m
.77325 .29459 L
s
.083 .024 .01 r
.58085 .63348 m .59461 .62934 L .57959 .63633 L p F P
0 0 0 r
s
.083 .024 .01 r
.57959 .63633 m .56806 .63978 L .58085 .63348 L p F P
0 0 0 r
s
.24 .35 .67 r
.67212 .60257 m
.67525 .59579 L
s
.83 .24 .1 r
.72 .29047 m
.73279 .30982 L
s
.73279 .30982 m
.77325 .29459 L
s
.168 .272 .57 r
.44781 .65272 m .44105 .64687 L .45383 .64825 L p F P
0 0 0 r
s
.24 .35 .67 r
.43777 .64403 m
.44553 .64735 L
s
.168 .272 .57 r
.45383 .64825 m .45907 .65283 L .44781 .65272 L p F P
0 0 0 r
s
.83 .24 .1 r
.76152 .53727 m
.80231 .52455 L
s
.76152 .53727 m
.76071 .55718 L
s
.865 .27 .112 r
.49943 .33534 m .48583 .34071 L .48841 .34259 L p F P
0 0 0 r
s
.865 .27 .112 r
.48841 .34259 m .49954 .33821 L .49943 .33534 L p F P
0 0 0 r
s
.83 .24 .1 r
.48666 .34257 m
.49961 .34385 L
s
.092 .026 .011 r
.37919 .38925 m .36272 .39571 L .37678 .38488 L p F P
0 0 0 r
s
.092 .026 .011 r
.37678 .38488 m .39162 .37904 L .37919 .38925 L p F P
0 0 0 r
s
.145 .037 .015 r
.63855 .60981 m .65456 .60497 L .63651 .61675 L p F P
0 0 0 r
s
.145 .037 .015 r
.63651 .61675 m .62243 .62098 L .63855 .60981 L p F P
0 0 0 r
s
.083 .024 .01 r
.43695 .36118 m .4217 .36718 L .43246 .36175 L p F P
0 0 0 r
s
.083 .024 .01 r
.43246 .36175 m .44565 .35655 L .43695 .36118 L p F P
0 0 0 r
s
.094 .106 .204 r
.39267 .60921 m .38292 .60079 L .39664 .6131 L p F P
0 0 0 r
s
.094 .106 .204 r
.39664 .6131 m .40516 .62046 L .39267 .60921 L p F P
0 0 0 r
s
.934 .288 .121 r
.47452 .66634 m .48309 .66377 L .48828 .65667 L p F P
0 0 0 r
s
.83 .24 .1 r
.47396 .66586 m
.47615 .6652 L
s
.934 .288 .121 r
.48828 .65667 m .48233 .65847 L .47452 .66634 L p F P
0 0 0 r
s
.83 .24 .1 r
.48371 .66293 m
.50039 .65792 L
s
.22 .344 .7 r
.47452 .66634 m .46942 .66188 L .47881 .65535 L p F P
0 0 0 r
s
.22 .344 .7 r
.47881 .65535 m .48233 .65847 L .47452 .66634 L p F P
0 0 0 r
s
.24 .35 .67 r
.47531 .30077 m
.44869 .30686 L
s
.44869 .30686 m
.42559 .28017 L
s
.178 .043 .018 r
.33427 .41625 m .31692 .42301 L .33027 .40845 L p F P
0 0 0 r
s
.178 .043 .018 r
.33027 .40845 m .34641 .40211 L .33427 .41625 L p F P
0 0 0 r
s
.174 .276 .58 r
.54855 .32848 m .55609 .33784 L .54587 .34025 L p F P
0 0 0 r
s
.174 .276 .58 r
.54587 .34025 m .53966 .33261 L .54855 .32848 L p F P
0 0 0 r
s
.83 .24 .1 r
.53723 .32911 m
.54176 .33164 L
s
.24 .35 .67 r
.57884 .68372 m
.55825 .66428 L
s
.57884 .68372 m
.6063 .67003 L
s
.763 .242 .101 r
.53393 .65002 m .54523 .64663 L .53543 .64806 L p F P
0 0 0 r
s
.763 .242 .101 r
.53543 .64806 m .52659 .65071 L .53393 .65002 L p F P
0 0 0 r
s
.83 .24 .1 r
.66715 .29157 m
.68 .30578 L
s
.68 .30578 m
.72 .29047 L
s
.24 .35 .67 r
.50275 .67484 m
.52997 .67258 L
s
.089 .134 .321 r
.60096 .38049 m .60997 .39179 L .59868 .38134 L p F P
0 0 0 r
s
.089 .134 .321 r
.59868 .38134 m .59051 .37112 L .60096 .38049 L p F P
0 0 0 r
s
.83 .24 .1 r
.53675 .32905 m
.53723 .32911 L
s
.083 .024 .01 r
.59461 .62934 m .60846 .62518 L .59119 .63285 L p F P
0 0 0 r
s
.083 .024 .01 r
.59119 .63285 m .57959 .63633 L .59461 .62934 L p F P
0 0 0 r
s
.83 .24 .1 r
.58883 .63073 m
.59772 .62065 L
s
.55051 .64225 m
.58883 .63073 L
s
.865 .27 .112 r
.51315 .32993 m .49943 .33534 L .49954 .33821 L p F P
0 0 0 r
s
.865 .27 .112 r
.49954 .33821 m .51074 .3338 L .51315 .32993 L p F P
0 0 0 r
s
.934 .288 .121 r
.48309 .66377 m .4917 .66119 L .49425 .65487 L p F P
0 0 0 r
s
.934 .288 .121 r
.49425 .65487 m .48828 .65667 L .48309 .66377 L p F P
0 0 0 r
s
.24 .35 .67 r
.48768 .66145 m
.50275 .67484 L
s
.48457 .65868 m
.48768 .66145 L
s
.83 .24 .1 r
.19835 .65721 m
.23309 .64576 L
s
.19835 .65721 m
.18417 .62942 L
s
.083 .024 .01 r
.45233 .35511 m .43695 .36118 L .44565 .35655 L p F P
0 0 0 r
s
.83 .24 .1 r
.43759 .36259 m
.44932 .35727 L
s
.083 .024 .01 r
.44565 .35655 m .45894 .35131 L .45233 .35511 L p F P
0 0 0 r
s
.83 .24 .1 r
.35731 .68155 m
.39381 .67037 L
s
.35731 .68155 m
.33917 .66734 L
s
.72019 .5696 m
.76071 .55718 L
s
.72019 .5696 m
.71598 .58485 L
s
.131 .209 .459 r
.57378 .3502 m .58222 .36074 L .57087 .35618 L p F P
0 0 0 r
s
.131 .209 .459 r
.57087 .35618 m .56353 .34707 L .57378 .3502 L p F P
0 0 0 r
s
.092 .026 .011 r
.39583 .38272 m .37919 .38925 L .39162 .37904 L p F P
0 0 0 r
s
.092 .026 .011 r
.39162 .37904 m .40659 .37314 L .39583 .38272 L p F P
0 0 0 r
s
.83 .24 .1 r
.40362 .37578 m
.41279 .37165 L
s
.145 .037 .015 r
.65456 .60497 m .67072 .60009 L .6507 .61249 L p F P
0 0 0 r
s
.145 .037 .015 r
.6507 .61249 m .63651 .61675 L .65456 .60497 L p F P
0 0 0 r
s
.127 .202 .442 r
.41358 .62771 m .40516 .62046 L .42032 .62891 L p F P
0 0 0 r
s
.127 .202 .442 r
.42032 .62891 m .42731 .63496 L .41358 .62771 L p F P
0 0 0 r
s
.24 .35 .67 r
.37192 .30736 m
.34705 .32691 L
s
.34705 .32691 m
.32191 .30052 L
s
.34705 .32691 m
.32464 .34952 L
s
.168 .272 .57 r
.44105 .64687 m .43422 .64095 L .44854 .64362 L p F P
0 0 0 r
s
.168 .272 .57 r
.44854 .64362 m .45383 .64825 L .44105 .64687 L p F P
0 0 0 r
s
.83 .24 .1 r
.17336 .59935 m
.16654 .56866 L
s
.16654 .56866 m
.20095 .55622 L
s
.24 .35 .67 r
.32464 .34952 m
.29906 .32355 L
s
.32464 .34952 m
.30548 .3744 L
s
.763 .242 .101 r
.54523 .64663 m .55661 .64322 L .5443 .64539 L p F P
0 0 0 r
s
.763 .242 .101 r
.5443 .64539 m .53543 .64806 L .54523 .64663 L p F P
0 0 0 r
s
.24 .35 .67 r
.67019 .60041 m
.67212 .60257 L
s
.22 .344 .7 r
.46942 .66188 m .46427 .65738 L .47528 .65221 L p F P
0 0 0 r
s
.22 .344 .7 r
.47528 .65221 m .47881 .65535 L .46942 .66188 L p F P
0 0 0 r
s
.136 .17 .302 r
.61874 .40523 m .62822 .4171 L .61883 .4029 L p F P
0 0 0 r
s
.136 .17 .302 r
.61883 .4029 m .60997 .39179 L .61874 .40523 L p F P
0 0 0 r
s
.24 .35 .67 r
.60566 .39248 m
.62105 .40828 L
s
.188 .246 .422 r
.34172 .54941 m .3297 .53889 L .33908 .55738 L p F P
0 0 0 r
s
.188 .246 .422 r
.33908 .55738 m .35036 .56717 L .34172 .54941 L p F P
0 0 0 r
s
.865 .27 .112 r
.52697 .32448 m .51315 .32993 L .51074 .3338 L p F P
0 0 0 r
s
.865 .27 .112 r
.51074 .3338 m .52202 .32936 L .52697 .32448 L p F P
0 0 0 r
s
.24 .35 .67 r
.52458 .32684 m
.52707 .32737 L
s
.234 .317 .566 r
.32471 .51975 m .31206 .50854 L .31745 .52817 L p F P
0 0 0 r
s
.234 .317 .566 r
.31745 .52817 m .3297 .53889 L .32471 .51975 L p F P
0 0 0 r
s
.24 .35 .67 r
.32655 .52494 m
.35126 .54677 L
s
.32589 .50047 m
.32655 .52494 L
s
.178 .043 .018 r
.35181 .40942 m .33427 .41625 L .34641 .40211 L p F P
0 0 0 r
s
.178 .043 .018 r
.34641 .40211 m .36272 .39571 L .35181 .40942 L p F P
0 0 0 r
s
.934 .288 .121 r
.4917 .66119 m .50036 .65859 L .50025 .65306 L p F P
0 0 0 r
s
.83 .24 .1 r
.50035 .65791 m
.50039 .65792 L
s
.934 .288 .121 r
.50025 .65306 m .49425 .65487 L .4917 .66119 L p F P
0 0 0 r
s
.147 .182 .324 r
.36145 .57679 m .35036 .56717 L .36294 .58355 L p F P
0 0 0 r
s
.147 .182 .324 r
.36294 .58355 m .37301 .59224 L .36145 .57679 L p F P
0 0 0 r
s
.31 .076 .035 r
.30791 .43982 m .28995 .44675 L .29975 .4297 L p F P
0 0 0 r
s
.24 .35 .67 r
.29244 .4393 m
.29409 .44083 L
s
.27969 .42751 m
.29244 .4393 L
s
.31 .076 .035 r
.29975 .4297 m .31692 .42301 L .30791 .43982 L p F P
0 0 0 r
s
.83 .24 .1 r
.26953 .47265 m
.2743 .44937 L
s
.264 .365 .665 r
.31143 .48903 m .29848 .47737 L .29916 .4971 L p F P
0 0 0 r
s
.264 .365 .665 r
.29916 .4971 m .31206 .50854 L .31143 .48903 L p F P
0 0 0 r
s
.308 .438 .814 r
.66104 .55656 m .66955 .56637 L .67935 .54855 L p F P
0 0 0 r
s
.308 .438 .814 r
.67935 .54855 m .67043 .53801 L .66104 .55656 L p F P
0 0 0 r
s
.083 .024 .01 r
.60846 .62518 m .62243 .62098 L .60287 .62935 L p F P
0 0 0 r
s
.083 .024 .01 r
.60287 .62935 m .59119 .63285 L .60846 .62518 L p F P
0 0 0 r
s
.24 .35 .67 r
.39841 .29157 m
.37192 .30736 L
s
.37192 .30736 m
.34721 .28052 L
s
.83 .24 .1 r
.30316 .67858 m
.33917 .66734 L
s
.30316 .67858 m
.28517 .65882 L
s
.283 .397 .733 r
.30282 .45856 m .28995 .44675 L .28528 .46548 L p F P
0 0 0 r
s
.83 .24 .1 r
.2743 .44937 m
.29248 .44234 L
s
.24 .35 .67 r
.29739 .44388 m
.30564 .45151 L
s
.283 .397 .733 r
.28528 .46548 m .29848 .47737 L .30282 .45856 L p F P
0 0 0 r
s
.24 .35 .67 r
.30053 .4776 m
.30564 .45151 L
s
.294 .415 .762 r
.66135 .52728 m .67043 .53801 L .67543 .51883 L p F P
0 0 0 r
s
.24 .35 .67 r
.67351 .51998 m
.67363 .51667 L
s
.294 .415 .762 r
.67543 .51883 m .66612 .5076 L .66135 .52728 L p F P
0 0 0 r
s
.83 .24 .1 r
.24975 .67016 m
.28517 .65882 L
s
.24975 .67016 m
.23309 .64576 L
s
.174 .276 .58 r
.54091 .31899 m .54855 .32848 L .53966 .33261 L p F P
0 0 0 r
s
.83 .24 .1 r
.53723 .32911 m
.54008 .32799 L
s
.54622 .32558 m
.57568 .31404 L
s
.174 .276 .58 r
.53966 .33261 m .53337 .3249 L .54091 .31899 L p F P
0 0 0 r
s
.24 .35 .67 r
.6063 .67003 m
.58613 .65022 L
s
.6063 .67003 m
.63188 .65126 L
s
.83 .24 .1 r
.61498 .29864 m
.62754 .30695 L
s
.62754 .30695 m
.66715 .29157 L
s
.315 .452 .849 r
.65529 .58282 m .66306 .59152 L .67791 .576 L p F P
0 0 0 r
s
.315 .452 .849 r
.67791 .576 m .66955 .56637 L .65529 .58282 L p F P
0 0 0 r
s
.185 .244 .417 r
.63456 .4337 m .64427 .44576 L .63753 .42874 L p F P
0 0 0 r
s
.185 .244 .417 r
.63753 .42874 m .62822 .4171 L .63456 .4337 L p F P
0 0 0 r
s
.24 .35 .67 r
.62105 .40828 m
.62835 .41742 L
s
.272 .378 .683 r
.65664 .49614 m .66612 .5076 L .66668 .48807 L p F P
0 0 0 r
s
.272 .378 .683 r
.66668 .48807 m .65717 .47639 L .65664 .49614 L p F P
0 0 0 r
s
.24 .35 .67 r
.65557 .47663 m
.65711 .47853 L
s
.235 .32 .564 r
.64748 .46448 m .65717 .47639 L .65378 .45759 L p F P
0 0 0 r
s
.24 .35 .67 r
.65497 .47369 m
.65557 .47663 L
s
.235 .32 .564 r
.65378 .45759 m .64427 .44576 L .64748 .46448 L p F P
0 0 0 r
s
.083 .024 .01 r
.46786 .349 m .45233 .35511 L .45894 .35131 L p F P
0 0 0 r
s
.083 .024 .01 r
.45894 .35131 m .47233 .34603 L .46786 .349 L p F P
0 0 0 r
s
.83 .24 .1 r
.44932 .35727 m
.48666 .34257 L
s
.844 .51155 m
.84104 .48772 L
s
.18417 .62942 m
.21889 .61761 L
s
.18417 .62942 m
.17336 .59935 L
s
.094 .106 .204 r
.38292 .60079 m .37301 .59224 L .38799 .60564 L p F P
0 0 0 r
s
.094 .106 .204 r
.38799 .60564 m .39664 .6131 L .38292 .60079 L p F P
0 0 0 r
s
.763 .242 .101 r
.55661 .64322 m .56806 .63978 L .55323 .64271 L p F P
0 0 0 r
s
.763 .242 .101 r
.55323 .64271 m .5443 .64539 L .55661 .64322 L p F P
0 0 0 r
s
.83 .24 .1 r
.53844 .64648 m
.55051 .64225 L
s
.17336 .59935 m
.20798 .5872 L
s
.24 .35 .67 r
.30548 .3744 m
.27944 .34882 L
s
.30548 .3744 m
.29029 .40071 L
s
.092 .026 .011 r
.41264 .37612 m .39583 .38272 L .40659 .37314 L p F P
0 0 0 r
s
.092 .026 .011 r
.40659 .37314 m .4217 .36718 L .41264 .37612 L p F P
0 0 0 r
s
.83 .24 .1 r
.20095 .55622 m
.19816 .52636 L
s
.19816 .52636 m
.23306 .5134 L
s
.319 .46 .871 r
.64381 .60502 m .6507 .61249 L .67072 .60009 L p F P
0 0 0 r
s
.83 .24 .1 r
.63628 .60898 m
.64502 .60633 L
s
.319 .46 .871 r
.67072 .60009 m .66306 .59152 L .64381 .60502 L p F P
0 0 0 r
s
.24 .35 .67 r
.65421 .62837 m
.67212 .60257 L
s
.83 .24 .1 r
.67084 .59852 m
.67569 .59705 L
s
.67064 .59858 m
.67084 .59852 L
s
.934 .288 .121 r
.50036 .65859 m .50906 .65597 L .50627 .65124 L p F P
0 0 0 r
s
.83 .24 .1 r
.50039 .65792 m
.50106 .65771 L
s
.934 .288 .121 r
.50627 .65124 m .50025 .65306 L .50036 .65859 L p F P
0 0 0 r
s
.24 .35 .67 r
.63188 .65126 m
.65421 .62837 L
s
.67005 .53876 m
.67029 .53784 L
s
.83 .24 .1 r
.26953 .47265 m
.23421 .48607 L
s
.23306 .5134 m
.23421 .48607 L
s
.865 .27 .112 r
.54091 .31899 m .52697 .32448 L .52202 .32936 L p F P
0 0 0 r
s
.865 .27 .112 r
.52202 .32936 m .53337 .3249 L .54091 .31899 L p F P
0 0 0 r
s
.24 .35 .67 r
.52894 .32778 m
.54537 .33133 L
s
.83 .24 .1 r
.52483 .32754 m
.53372 .32866 L
s
.44789 .66731 m
.4737 .65951 L
s
.4737 .65951 m
.479 .65791 L
s
.44789 .66731 m
.43112 .65894 L
s
.22 .344 .7 r
.46427 .65738 m .45907 .65283 L .47172 .64906 L p F P
0 0 0 r
s
.24 .35 .67 r
.45816 .65203 m
.4606 .65238 L
s
.22 .344 .7 r
.47172 .64906 m .47528 .65221 L .46427 .65738 L p F P
0 0 0 r
s
.83 .24 .1 r
.77325 .29459 m
.76089 .27481 L
s
.089 .134 .321 r
.59179 .36898 m .60096 .38049 L .59051 .37112 L p F P
0 0 0 r
s
.089 .134 .321 r
.59051 .37112 m .58222 .36074 L .59179 .36898 L p F P
0 0 0 r
s
.24 .35 .67 r
.58573 .3676 m
.60566 .39248 L
s
.56616 .35701 m
.58573 .3676 L
s
.83 .24 .1 r
.80231 .52455 m
.844 .51155 L
s
.80231 .52455 m
.80214 .54448 L
s
.67569 .59705 m
.71598 .58485 L
s
.66806 .60691 m
.67569 .59705 L
s
.168 .272 .57 r
.43422 .64095 m .42731 .63496 L .44321 .63896 L p F P
0 0 0 r
s
.168 .272 .57 r
.44321 .63896 m .44854 .64362 L .43422 .64095 L p F P
0 0 0 r
s
.083 .024 .01 r
.62243 .62098 m .63651 .61675 L .61463 .62582 L p F P
0 0 0 r
s
.083 .024 .01 r
.61463 .62582 m .60287 .62935 L .62243 .62098 L p F P
0 0 0 r
s
.131 .209 .459 r
.56522 .33949 m .57378 .3502 L .56353 .34707 L p F P
0 0 0 r
s
.131 .209 .459 r
.56353 .34707 m .55609 .33784 L .56522 .33949 L p F P
0 0 0 r
s
.178 .043 .018 r
.36954 .40251 m .35181 .40942 L .36272 .39571 L p F P
0 0 0 r
s
.178 .043 .018 r
.36272 .39571 m .37919 .38925 L .36954 .40251 L p F P
0 0 0 r
s
.127 .202 .442 r
.40516 .62046 m .39664 .6131 L .41325 .62278 L p F P
0 0 0 r
s
.24 .35 .67 r
.39375 .60812 m
.40699 .61914 L
s
.127 .202 .442 r
.41325 .62278 m .42032 .62891 L .40516 .62046 L p F P
0 0 0 r
s
.934 .288 .121 r
.50906 .65597 m .5178 .65335 L .5123 .64942 L p F P
0 0 0 r
s
.83 .24 .1 r
.50873 .65541 m
.50944 .6552 L
s
.934 .288 .121 r
.5123 .64942 m .50627 .65124 L .50906 .65597 L p F P
0 0 0 r
s
.24 .35 .67 r
.50069 .29996 m
.47531 .30077 L
s
.47531 .30077 m
.45249 .27368 L
s
.763 .242 .101 r
.56806 .63978 m .57959 .63633 L .5622 .64002 L p F P
0 0 0 r
s
.763 .242 .101 r
.5622 .64002 m .55323 .64271 L .56806 .63978 L p F P
0 0 0 r
s
.083 .024 .01 r
.48353 .34282 m .46786 .349 L .47233 .34603 L p F P
0 0 0 r
s
.083 .024 .01 r
.47233 .34603 m .48583 .34071 L .48353 .34282 L p F P
0 0 0 r
s
.31 .076 .035 r
.32607 .43282 m .30791 .43982 L .31692 .42301 L p F P
0 0 0 r
s
.31 .076 .035 r
.31692 .42301 m .33427 .41625 L .32607 .43282 L p F P
0 0 0 r
s
.24 .35 .67 r
.42559 .28017 m
.39841 .29157 L
s
.39841 .29157 m
.37408 .26427 L
s
.50964 .65403 m
.52997 .67258 L
s
.50819 .65271 m
.50964 .65403 L
s
.52997 .67258 m
.55825 .66428 L
s
.83 .24 .1 r
.70766 .27585 m
.72 .29047 L
s
.72 .29047 m
.76089 .27481 L
s
.092 .026 .011 r
.42961 .36946 m .41264 .37612 L .4217 .36718 L p F P
0 0 0 r
s
.092 .026 .011 r
.4217 .36718 m .43695 .36118 L .42961 .36946 L p F P
0 0 0 r
s
.83 .24 .1 r
.43468 .36374 m
.43759 .36259 L
s
.56386 .31217 m
.57568 .31404 L
s
.57568 .31404 m
.61498 .29864 L
s
.934 .288 .121 r
.5178 .65335 m .52659 .65071 L .51836 .64759 L p F P
0 0 0 r
s
.83 .24 .1 r
.51715 .65288 m
.51787 .65266 L
s
.52561 .65034 m
.53844 .64648 L
s
.934 .288 .121 r
.51836 .64759 m .5123 .64942 L .5178 .65335 L p F P
0 0 0 r
s
.136 .17 .302 r
.60909 .39314 m .61874 .40523 L .60997 .39179 L p F P
0 0 0 r
s
.136 .17 .302 r
.60997 .39179 m .60096 .38049 L .60909 .39314 L p F P
0 0 0 r
s
.22 .344 .7 r
.45907 .65283 m .45383 .64825 L .46815 .64589 L p F P
0 0 0 r
s
.22 .344 .7 r
.46815 .64589 m .47172 .64906 L .45907 .65283 L p F P
0 0 0 r
s
.083 .024 .01 r
.63651 .61675 m .6507 .61249 L .62647 .62227 L p F P
0 0 0 r
s
.083 .024 .01 r
.62647 .62227 m .61463 .62582 L .63651 .61675 L p F P
0 0 0 r
s
.83 .24 .1 r
.62801 .61895 m
.63628 .60898 L
s
.58883 .63073 m
.62801 .61895 L
s
.23309 .64576 m
.2686 .63406 L
s
.23309 .64576 m
.21889 .61761 L
s
.763 .242 .101 r
.57959 .63633 m .59119 .63285 L .57121 .63731 L p F P
0 0 0 r
s
.763 .242 .101 r
.57121 .63731 m .5622 .64002 L .57959 .63633 L p F P
0 0 0 r
s
.83 .24 .1 r
.39381 .67037 m
.43112 .65894 L
s
.39381 .67037 m
.37598 .65584 L
s
.24 .35 .67 r
.29029 .40071 m
.26377 .37547 L
s
.29029 .40071 m
.27969 .42751 L
s
.147 .182 .324 r
.35036 .56717 m .33908 .55738 L .35271 .57472 L p F P
0 0 0 r
s
.147 .182 .324 r
.35271 .57472 m .36294 .58355 L .35036 .56717 L p F P
0 0 0 r
s
.83 .24 .1 r
.76071 .55718 m
.80214 .54448 L
s
.76071 .55718 m
.75718 .57238 L
s
.188 .246 .422 r
.3297 .53889 m .31745 .52817 L .3276 .54742 L p F P
0 0 0 r
s
.188 .246 .422 r
.3276 .54742 m .33908 .55738 L .3297 .53889 L p F P
0 0 0 r
s
.24 .35 .67 r
.32655 .52494 m
.33277 .54698 L
s
.083 .024 .01 r
.49934 .33659 m .48353 .34282 L .48583 .34071 L p F P
0 0 0 r
s
.083 .024 .01 r
.48583 .34071 m .49943 .33534 L .49934 .33659 L p F P
0 0 0 r
s
.234 .317 .566 r
.31206 .50854 m .29916 .4971 L .30498 .51726 L p F P
0 0 0 r
s
.24 .35 .67 r
.30053 .4776 m
.32589 .50047 L
s
.234 .317 .566 r
.30498 .51726 m .31745 .52817 L .31206 .50854 L p F P
0 0 0 r
s
.315 .452 .849 r
.64738 .57399 m .65529 .58282 L .66955 .56637 L p F P
0 0 0 r
s
.315 .452 .849 r
.66955 .56637 m .66104 .55656 L .64738 .57399 L p F P
0 0 0 r
s
.094 .106 .204 r
.37301 .59224 m .36294 .58355 L .37923 .59808 L p F P
0 0 0 r
s
.24 .35 .67 r
.35771 .56871 m
.36962 .58725 L
s
.094 .106 .204 r
.37923 .59808 m .38799 .60564 L .37301 .59224 L p F P
0 0 0 r
s
.308 .438 .814 r
.65238 .54659 m .66104 .55656 L .67043 .53801 L p F P
0 0 0 r
s
.308 .438 .814 r
.67043 .53801 m .66135 .52728 L .65238 .54659 L p F P
0 0 0 r
s
.83 .24 .1 r
.20798 .5872 m
.20095 .55622 L
s
.20095 .55622 m
.23614 .5435 L
s
.168 .272 .57 r
.42731 .63496 m .42032 .62891 L .43783 .63425 L p F P
0 0 0 r
s
.168 .272 .57 r
.43783 .63425 m .44321 .63896 L .42731 .63496 L p F P
0 0 0 r
s
.178 .043 .018 r
.38746 .39553 m .36954 .40251 L .37919 .38925 L p F P
0 0 0 r
s
.178 .043 .018 r
.37919 .38925 m .39583 .38272 L .38746 .39553 L p F P
0 0 0 r
s
.83 .24 .1 r
.39552 .3832 m
.39596 .38267 L
s
.264 .365 .665 r
.29848 .47737 m .28528 .46548 L .28601 .48545 L p F P
0 0 0 r
s
.264 .365 .665 r
.28601 .48545 m .29916 .4971 L .29848 .47737 L p F P
0 0 0 r
s
.934 .288 .121 r
.52659 .65071 m .53543 .64806 L .52444 .64575 L p F P
0 0 0 r
s
.934 .288 .121 r
.52444 .64575 m .51836 .64759 L .52659 .65071 L p F P
0 0 0 r
s
.185 .244 .417 r
.62467 .4214 m .63456 .4337 L .62822 .4171 L p F P
0 0 0 r
s
.185 .244 .417 r
.62822 .4171 m .61874 .40523 L .62467 .4214 L p F P
0 0 0 r
s
.44 .115 .052 r
.30361 .45851 m .28528 .46548 L .28995 .44675 L p F P
0 0 0 r
s
.44 .115 .052 r
.28995 .44675 m .30791 .43982 L .30361 .45851 L p F P
0 0 0 r
s
.294 .415 .762 r
.6521 .51634 m .66135 .52728 L .66612 .5076 L p F P
0 0 0 r
s
.294 .415 .762 r
.66612 .5076 m .65664 .49614 L .6521 .51634 L p F P
0 0 0 r
s
.319 .46 .871 r
.63682 .59745 m .64381 .60502 L .66306 .59152 L p F P
0 0 0 r
s
.319 .46 .871 r
.66306 .59152 m .65529 .58282 L .63682 .59745 L p F P
0 0 0 r
s
.31 .076 .035 r
.34444 .42574 m .32607 .43282 L .33427 .41625 L p F P
0 0 0 r
s
.31 .076 .035 r
.33427 .41625 m .35181 .40942 L .34444 .42574 L p F P
0 0 0 r
s
.272 .378 .683 r
.64697 .48447 m .65664 .49614 L .65717 .47639 L p F P
0 0 0 r
s
.272 .378 .683 r
.65717 .47639 m .64748 .46448 L .64697 .48447 L p F P
0 0 0 r
s
.235 .32 .564 r
.63759 .45234 m .64748 .46448 L .64427 .44576 L p F P
0 0 0 r
s
.235 .32 .564 r
.64427 .44576 m .63456 .4337 L .63759 .45234 L p F P
0 0 0 r
s
.092 .026 .011 r
.44676 .36273 m .42961 .36946 L .43695 .36118 L p F P
0 0 0 r
s
.092 .026 .011 r
.43695 .36118 m .45233 .35511 L .44676 .36273 L p F P
0 0 0 r
s
.131 .209 .459 r
.55652 .32861 m .56522 .33949 L .55609 .33784 L p F P
0 0 0 r
s
.131 .209 .459 r
.55609 .33784 m .54855 .32848 L .55652 .32861 L p F P
0 0 0 r
s
.24 .35 .67 r
.54537 .33133 m
.56616 .35701 L
s
.83 .24 .1 r
.33917 .66734 m
.37598 .65584 L
s
.33917 .66734 m
.32138 .64722 L
s
.089 .134 .321 r
.58245 .35728 m .59179 .36898 L .58222 .36074 L p F P
0 0 0 r
s
.089 .134 .321 r
.58222 .36074 m .57378 .3502 L .58245 .35728 L p F P
0 0 0 r
s
.83 .24 .1 r
.28517 .65882 m
.32138 .64722 L
s
.28517 .65882 m
.2686 .63406 L
s
.127 .202 .442 r
.39664 .6131 m .38799 .60564 L .4061 .61659 L p F P
0 0 0 r
s
.24 .35 .67 r
.36962 .58725 m
.39375 .60812 L
s
.127 .202 .442 r
.4061 .61659 m .41325 .62278 L .39664 .6131 L p F P
0 0 0 r
s
.763 .242 .101 r
.59119 .63285 m .60287 .62935 L .58028 .63459 L p F P
0 0 0 r
s
.763 .242 .101 r
.58028 .63459 m .57121 .63731 L .59119 .63285 L p F P
0 0 0 r
s
.83 .24 .1 r
.65518 .28288 m
.66715 .29157 L
s
.66715 .29157 m
.70766 .27585 L
s
.24 .35 .67 r
.54537 .33133 m
.56502 .34175 L
s
.319 .464 .884 r
.62055 .61607 m .62647 .62227 L .6507 .61249 L p F P
0 0 0 r
s
.24 .35 .67 r
.64299 .61635 m
.65421 .62837 L
s
.319 .464 .884 r
.6507 .61249 m .64381 .60502 L .62055 .61607 L p F P
0 0 0 r
s
.24 .35 .67 r
.64248 .61581 m
.64299 .61635 L
s
.83 .24 .1 r
.64446 .61401 m
.66806 .60691 L
s
.64318 .61439 m
.64446 .61401 L
s
.22 .344 .7 r
.45383 .64825 m .44854 .64362 L .46455 .64269 L p F P
0 0 0 r
s
.22 .344 .7 r
.46455 .64269 m .46815 .64589 L .45383 .64825 L p F P
0 0 0 r
s
.934 .288 .121 r
.53543 .64806 m .5443 .64539 L .53054 .64391 L p F P
0 0 0 r
s
.934 .288 .121 r
.53054 .64391 m .52444 .64575 L .53543 .64806 L p F P
0 0 0 r
s
.83 .24 .1 r
.21889 .61761 m
.2544 .60554 L
s
.21889 .61761 m
.20798 .5872 L
s
.20798 .5872 m
.24337 .57479 L
s
.083 .024 .01 r
.5153 .3303 m .49934 .33659 L .49943 .33534 L p F P
0 0 0 r
s
.083 .024 .01 r
.49943 .33534 m .51315 .32993 L .5153 .3303 L p F P
0 0 0 r
s
.83 .24 .1 r
.48666 .34257 m
.52483 .32754 L
s
.23614 .5435 m
.23306 .5134 L
s
.23306 .5134 m
.26875 .50014 L
s
1 .304 .129 r
.48233 .65847 m .48828 .65667 L .49396 .64528 L p F P
0 0 0 r
s
.83 .24 .1 r
.48847 .65629 m
.48919 .65639 L
s
1 .304 .129 r
.49396 .64528 m .49088 .64622 L .48233 .65847 L p F P
0 0 0 r
s
.256 .392 .783 r
.48233 .65847 m .47881 .65535 L .48909 .6446 L p F P
0 0 0 r
s
.24 .35 .67 r
.48293 .65722 m
.48309 .65737 L
s
.47828 .65488 m
.47915 .655 L
s
.256 .392 .783 r
.48909 .6446 m .49088 .64622 L .48233 .65847 L p F P
0 0 0 r
s
.83 .24 .1 r
.26953 .47265 m
.28532 .46666 L
s
.26875 .50014 m
.26953 .47265 L
s
.24 .35 .67 r
.45249 .27368 m
.42559 .28017 L
s
.42559 .28017 m
.40159 .25242 L
s
.53826 .64542 m
.55825 .66428 L
s
.55825 .66428 m
.58613 .65022 L
s
.178 .043 .018 r
.40558 .38847 m .38746 .39553 L .39583 .38272 L p F P
0 0 0 r
s
.178 .043 .018 r
.39583 .38272 m .41264 .37612 L .40558 .38847 L p F P
0 0 0 r
s
.83 .24 .1 r
.84451 .53149 m
.844 .51155 L
s
.934 .288 .121 r
.5443 .64539 m .55323 .64271 L .53666 .64206 L p F P
0 0 0 r
s
.83 .24 .1 r
.54266 .64522 m
.54339 .645 L
s
.934 .288 .121 r
.53666 .64206 m .53054 .64391 L .5443 .64539 L p F P
0 0 0 r
s
.24 .35 .67 r
.53684 .64408 m
.53826 .64542 L
s
.763 .242 .101 r
.60287 .62935 m .61463 .62582 L .58939 .63186 L p F P
0 0 0 r
s
.763 .242 .101 r
.58939 .63186 m .58028 .63459 L .60287 .62935 L p F P
0 0 0 r
s
.83 .24 .1 r
.57735 .6348 m
.58883 .63073 L
s
.71598 .58485 m
.75718 .57238 L
s
.71598 .58485 m
.70903 .5946 L
s
.168 .272 .57 r
.42032 .62891 m .41325 .62278 L .4324 .6295 L p F P
0 0 0 r
s
.168 .272 .57 r
.4324 .6295 m .43783 .63425 L .42032 .62891 L p F P
0 0 0 r
s
1 .304 .129 r
.48828 .65667 m .49425 .65487 L .49704 .64434 L p F P
0 0 0 r
s
1 .304 .129 r
.49704 .64434 m .49396 .64528 L .48828 .65667 L p F P
0 0 0 r
s
.24 .35 .67 r
.49071 .6543 m
.49361 .65404 L
s
.44 .115 .052 r
.32216 .45146 m .30361 .45851 L .30791 .43982 L p F P
0 0 0 r
s
.83 .24 .1 r
.30565 .45894 m
.30589 .45764 L
s
.30902 .44073 m
.30929 .43929 L
s
.44 .115 .052 r
.30791 .43982 m .32607 .43282 L .32216 .45146 L p F P
0 0 0 r
s
.092 .026 .011 r
.46408 .35594 m .44676 .36273 L .45233 .35511 L p F P
0 0 0 r
s
.092 .026 .011 r
.45233 .35511 m .46786 .349 L .46408 .35594 L p F P
0 0 0 r
s
.31 .076 .035 r
.36301 .41858 m .34444 .42574 L .35181 .40942 L p F P
0 0 0 r
s
.31 .076 .035 r
.35181 .40942 m .36954 .40251 L .36301 .41858 L p F P
0 0 0 r
s
.136 .17 .302 r
.59924 .38082 m .60909 .39314 L .60096 .38049 L p F P
0 0 0 r
s
.136 .17 .302 r
.60096 .38049 m .59179 .36898 L .59924 .38082 L p F P
0 0 0 r
s
.24 .35 .67 r
.58573 .3676 m
.60112 .38334 L
s
.22 .344 .7 r
.44854 .64362 m .44321 .63896 L .46093 .63948 L p F P
0 0 0 r
s
.22 .344 .7 r
.46093 .63948 m .46455 .64269 L .44854 .64362 L p F P
0 0 0 r
s
.256 .392 .783 r
.47881 .65535 m .47528 .65221 L .48729 .64297 L p F P
0 0 0 r
s
.24 .35 .67 r
.47957 .65424 m
.47974 .65438 L
s
.256 .392 .783 r
.48729 .64297 m .48909 .6446 L .47881 .65535 L p F P
0 0 0 r
s
.24 .35 .67 r
.34721 .28052 m
.32191 .30052 L
s
.32191 .30052 m
.29578 .27308 L
s
.32191 .30052 m
.29906 .32355 L
s
.083 .024 .01 r
.53141 .32396 m .5153 .3303 L .51315 .32993 L p F P
0 0 0 r
s
.24 .35 .67 r
.52145 .32518 m
.52237 .32629 L
s
.083 .024 .01 r
.51315 .32993 m .52697 .32448 L .53141 .32396 L p F P
0 0 0 r
s
.24 .35 .67 r
.50069 .29996 m
.52145 .32518 L
s
.83 .24 .1 r
.52483 .32754 m
.53961 .32172 L
s
1 .304 .129 r
.49425 .65487 m .50025 .65306 L .50013 .6434 L p F P
0 0 0 r
s
.83 .24 .1 r
.49471 .65316 m
.49521 .65301 L
s
1 .304 .129 r
.50013 .6434 m .49704 .64434 L .49425 .65487 L p F P
0 0 0 r
s
.147 .182 .324 r
.33908 .55738 m .3276 .54742 L .34232 .56575 L p F P
0 0 0 r
s
.147 .182 .324 r
.34232 .56575 m .35271 .57472 L .33908 .55738 L p F P
0 0 0 r
s
.24 .35 .67 r
.33277 .54698 m
.35771 .56871 L
s
.094 .106 .204 r
.36294 .58355 m .35271 .57472 L .37034 .59041 L p F P
0 0 0 r
s
.094 .106 .204 r
.37034 .59041 m .37923 .59808 L .36294 .58355 L p F P
0 0 0 r
s
.24 .35 .67 r
.52376 .30464 m
.50069 .29996 L
s
.50069 .29996 m
.47808 .2725 L
s
.934 .288 .121 r
.55323 .64271 m .5622 .64002 L .54281 .64021 L p F P
0 0 0 r
s
.83 .24 .1 r
.55125 .64264 m
.55199 .64241 L
s
.55988 .64004 m
.57735 .6348 L
s
.934 .288 .121 r
.54281 .64021 m .53666 .64206 L .55323 .64271 L p F P
0 0 0 r
s
.83 .24 .1 r
.76089 .27481 m
.74909 .25977 L
s
.24 .35 .67 r
.27969 .42751 m
.25271 .40257 L
s
.27969 .42751 m
.27419 .45384 L
s
.29906 .32355 m
.27246 .29655 L
s
.29906 .32355 m
.27944 .34882 L
s
.188 .246 .422 r
.31745 .52817 m .30498 .51726 L .31591 .53729 L p F P
0 0 0 r
s
.188 .246 .422 r
.31591 .53729 m .3276 .54742 L .31745 .52817 L p F P
0 0 0 r
s
.319 .46 .871 r
.62974 .58977 m .63682 .59745 L .65529 .58282 L p F P
0 0 0 r
s
.319 .46 .871 r
.65529 .58282 m .64738 .57399 L .62974 .58977 L p F P
0 0 0 r
s
.315 .452 .849 r
.63936 .565 m .64738 .57399 L .66104 .55656 L p F P
0 0 0 r
s
.315 .452 .849 r
.66104 .55656 m .65238 .54659 L .63936 .565 L p F P
0 0 0 r
s
.131 .209 .459 r
.54767 .31755 m .55652 .32861 L .54855 .32848 L p F P
0 0 0 r
s
.131 .209 .459 r
.54855 .32848 m .54091 .31899 L .54767 .31755 L p F P
0 0 0 r
s
.83 .24 .1 r
.54828 .3183 m
.56386 .31217 L
s
.24 .35 .67 r
.53723 .32127 m
.54537 .33133 L
s
.763 .242 .101 r
.61463 .62582 m .62647 .62227 L .59854 .62911 L p F P
0 0 0 r
s
.763 .242 .101 r
.59854 .62911 m .58939 .63186 L .61463 .62582 L p F P
0 0 0 r
s
.24 .35 .67 r
.61215 .63104 m
.63188 .65126 L
s
.83 .24 .1 r
.60378 .29645 m
.61498 .29864 L
s
.61498 .29864 m
.65518 .28288 L
s
.127 .202 .442 r
.38799 .60564 m .37923 .59808 L .39887 .61032 L p F P
0 0 0 r
s
.127 .202 .442 r
.39887 .61032 m .4061 .61659 L .38799 .60564 L p F P
0 0 0 r
s
.308 .438 .814 r
.64357 .53644 m .65238 .54659 L .66135 .52728 L p F P
0 0 0 r
s
.308 .438 .814 r
.66135 .52728 m .6521 .51634 L .64357 .53644 L p F P
0 0 0 r
s
.234 .317 .566 r
.29916 .4971 m .28601 .48545 L .29227 .50613 L p F P
0 0 0 r
s
.234 .317 .566 r
.29227 .50613 m .30498 .51726 L .29916 .4971 L p F P
0 0 0 r
s
.24 .35 .67 r
.30087 .50225 m
.32655 .52494 L
s
1 .304 .129 r
.50025 .65306 m .50627 .65124 L .50322 .64246 L p F P
0 0 0 r
s
.83 .24 .1 r
.50023 .65149 m
.50073 .65134 L
s
1 .304 .129 r
.50322 .64246 m .50013 .6434 L .50025 .65306 L p F P
0 0 0 r
s
.24 .35 .67 r
.49361 .65404 m
.50819 .65271 L
s
.319 .464 .884 r
.61456 .60979 m .62055 .61607 L .64381 .60502 L p F P
0 0 0 r
s
.319 .464 .884 r
.64381 .60502 m .63682 .59745 L .61456 .60979 L p F P
0 0 0 r
s
.185 .244 .417 r
.61459 .40886 m .62467 .4214 L .61874 .40523 L p F P
0 0 0 r
s
.185 .244 .417 r
.61874 .40523 m .60909 .39314 L .61459 .40886 L p F P
0 0 0 r
s
.24 .35 .67 r
.60112 .38334 m
.60919 .39345 L
s
.089 .134 .321 r
.57295 .34536 m .58245 .35728 L .57378 .3502 L p F P
0 0 0 r
s
.089 .134 .321 r
.57378 .3502 m .56522 .33949 L .57295 .34536 L p F P
0 0 0 r
s
.83 .24 .1 r
.2686 .63406 m
.30491 .62209 L
s
.2686 .63406 m
.2544 .60554 L
s
.24 .35 .67 r
.37408 .26427 m
.34721 .28052 L
s
.34721 .28052 m
.32151 .25262 L
s
.83 .24 .1 r
.43112 .65894 m
.41363 .64408 L
s
.545 .147 .066 r
.30429 .47861 m .28601 .48545 L .28528 .46548 L p F P
0 0 0 r
s
.24 .35 .67 r
.30057 .48 m
.30087 .50225 L
s
.545 .147 .066 r
.28528 .46548 m .30361 .45851 L .30429 .47861 L p F P
0 0 0 r
s
.83 .24 .1 r
.30365 .45969 m
.30565 .45894 L
s
.24 .35 .67 r
.27419 .45384 m
.28656 .46499 L
s
.294 .415 .762 r
.64267 .5052 m .6521 .51634 L .65664 .49614 L p F P
0 0 0 r
s
.24 .35 .67 r
.65465 .49743 m
.6548 .49393 L
s
.294 .415 .762 r
.65664 .49614 m .64697 .48447 L .64267 .5052 L p F P
0 0 0 r
s
.83 .24 .1 r
.80214 .54448 m
.84451 .53149 L
s
.80214 .54448 m
.79932 .55963 L
s
.178 .043 .018 r
.42389 .38134 m .40558 .38847 L .41264 .37612 L p F P
0 0 0 r
s
.178 .043 .018 r
.41264 .37612 m .42961 .36946 L .42389 .38134 L p F P
0 0 0 r
s
.256 .392 .783 r
.47528 .65221 m .47172 .64906 L .48548 .64133 L p F P
0 0 0 r
s
.24 .35 .67 r
.47619 .65124 m
.47636 .65138 L
s
.256 .392 .783 r
.48548 .64133 m .48729 .64297 L .47528 .65221 L p F P
0 0 0 r
s
.83 .24 .1 r
.47796 .65185 m
.47968 .65276 L
s
.24 .35 .67 r
.58613 .65022 m
.61215 .63104 L
s
.934 .288 .121 r
.5622 .64002 m .57121 .63731 L .54898 .63835 L p F P
0 0 0 r
s
.934 .288 .121 r
.54898 .63835 m .54281 .64021 L .5622 .64002 L p F P
0 0 0 r
s
.092 .026 .011 r
.48158 .34907 m .46408 .35594 L .46786 .349 L p F P
0 0 0 r
s
.092 .026 .011 r
.46786 .349 m .48353 .34282 L .48158 .34907 L p F P
0 0 0 r
s
.83 .24 .1 r
.4831 .34419 m
.48666 .34257 L
s
.272 .378 .683 r
.63711 .47256 m .64697 .48447 L .64748 .46448 L p F P
0 0 0 r
s
.272 .378 .683 r
.64748 .46448 m .63759 .45234 L .63711 .47256 L p F P
0 0 0 r
s
.24 .35 .67 r
.63616 .45283 m
.63754 .45452 L
s
.235 .32 .564 r
.6275 .43995 m .63759 .45234 L .63456 .4337 L p F P
0 0 0 r
s
.24 .35 .67 r
.63174 .43019 m
.63274 .43531 L
s
.63558 .44987 m
.63616 .45283 L
s
.235 .32 .564 r
.63456 .4337 m .62467 .4214 L .6275 .43995 L p F P
0 0 0 r
s
.83 .24 .1 r
.24337 .57479 m
.23614 .5435 L
s
.23614 .5435 m
.27213 .53049 L
s
1 .304 .129 r
.50627 .65124 m .5123 .64942 L .50632 .64152 L p F P
0 0 0 r
s
.83 .24 .1 r
.50577 .64981 m
.50627 .64966 L
s
1 .304 .129 r
.50632 .64152 m .50322 .64246 L .50627 .65124 L p F P
0 0 0 r
s
.083 .024 .01 r
.54767 .31755 m .53141 .32396 L .52697 .32448 L p F P
0 0 0 r
s
.24 .35 .67 r
.53654 .32042 m
.53671 .32064 L
s
.083 .024 .01 r
.52697 .32448 m .54091 .31899 L .54767 .31755 L p F P
0 0 0 r
s
.24 .35 .67 r
.52376 .30464 m
.53654 .32042 L
s
.22 .344 .7 r
.44321 .63896 m .43783 .63425 L .45728 .63625 L p F P
0 0 0 r
s
.22 .344 .7 r
.45728 .63625 m .46093 .63948 L .44321 .63896 L p F P
0 0 0 r
s
.44 .115 .052 r
.34092 .44432 m .32216 .45146 L .32607 .43282 L p F P
0 0 0 r
s
.44 .115 .052 r
.32607 .43282 m .34444 .42574 L .34092 .44432 L p F P
0 0 0 r
s
.168 .272 .57 r
.41325 .62278 m .4061 .61659 L .42692 .62471 L p F P
0 0 0 r
s
.168 .272 .57 r
.42692 .62471 m .4324 .6295 L .41325 .62278 L p F P
0 0 0 r
s
.24 .35 .67 r
.27944 .34882 m
.25235 .32222 L
s
.27944 .34882 m
.26377 .37547 L
s
.31 .076 .035 r
.3818 .41134 m .36301 .41858 L .36954 .40251 L p F P
0 0 0 r
s
.31 .076 .035 r
.36954 .40251 m .38746 .39553 L .3818 .41134 L p F P
0 0 0 r
s
.318 .465 .89 r
.59381 .62431 m .59854 .62911 L .62647 .62227 L p F P
0 0 0 r
s
.318 .465 .89 r
.62647 .62227 m .62055 .61607 L .59381 .62431 L p F P
0 0 0 r
s
.83 .24 .1 r
.61981 .62189 m
.62029 .62171 L
s
.24 .35 .67 r
.61215 .63104 m
.61867 .62436 L
s
.6081 .62688 m
.61215 .63104 L
s
1 .304 .129 r
.5123 .64942 m .51836 .64759 L .50942 .64057 L p F P
0 0 0 r
s
.83 .24 .1 r
.51133 .64813 m
.51183 .64798 L
s
1 .304 .129 r
.50942 .64057 m .50632 .64152 L .5123 .64942 L p F P
0 0 0 r
s
.83 .24 .1 r
.66806 .60691 m
.70903 .5946 L
s
.66806 .60691 m
.65783 .61062 L
s
.37598 .65584 m
.41363 .64408 L
s
.37598 .65584 m
.35841 .63537 L
s
.934 .288 .121 r
.57121 .63731 m .58028 .63459 L .55516 .63648 L p F P
0 0 0 r
s
.83 .24 .1 r
.57735 .6348 m
.59803 .62858 L
s
.934 .288 .121 r
.55516 .63648 m .54898 .63835 L .57121 .63731 L p F P
0 0 0 r
s
.83 .24 .1 r
.32138 .64722 m
.35841 .63537 L
s
.32138 .64722 m
.30491 .62209 L
s
.256 .392 .783 r
.47172 .64906 m .46815 .64589 L .48367 .63969 L p F P
0 0 0 r
s
.24 .35 .67 r
.4728 .64822 m
.47296 .64836 L
s
.83 .24 .1 r
.43112 .65894 m
.46928 .64725 L
s
.256 .392 .783 r
.48367 .63969 m .48548 .64133 L .47172 .64906 L p F P
0 0 0 r
s
.83 .24 .1 r
.46928 .64725 m
.47796 .65185 L
s
.69629 .26677 m
.70766 .27585 L
s
.70766 .27585 m
.74909 .25977 L
s
.2544 .60554 m
.29071 .59319 L
s
.2544 .60554 m
.24337 .57479 L
s
.24337 .57479 m
.27957 .56209 L
s
1 .304 .129 r
.51836 .64759 m .52444 .64575 L .51253 .63962 L p F P
0 0 0 r
s
.83 .24 .1 r
.51691 .64645 m
.51741 .64629 L
s
.5225 .64476 m
.52419 .64425 L
s
.52419 .64425 m
.52764 .64479 L
s
1 .304 .129 r
.51253 .63962 m .50942 .64057 L .51836 .64759 L p F P
0 0 0 r
s
.24 .35 .67 r
.47808 .2725 m
.45249 .27368 L
s
.45249 .27368 m
.42877 .2455 L
s
.83 .24 .1 r
.27213 .53049 m
.26875 .50014 L
s
.178 .043 .018 r
.44241 .37413 m .42389 .38134 L .42961 .36946 L p F P
0 0 0 r
s
.83 .24 .1 r
.43157 .37018 m
.43328 .36802 L
s
.178 .043 .018 r
.42961 .36946 m .44676 .36273 L .44241 .37413 L p F P
0 0 0 r
s
.092 .026 .011 r
.49926 .34213 m .48158 .34907 L .48353 .34282 L p F P
0 0 0 r
s
.092 .026 .011 r
.48353 .34282 m .49934 .33659 L .49926 .34213 L p F P
0 0 0 r
s
.24 .35 .67 r
.40159 .25242 m
.37408 .26427 L
s
.37408 .26427 m
.34877 .23589 L
s
.136 .17 .302 r
.58921 .36827 m .59924 .38082 L .59179 .36898 L p F P
0 0 0 r
s
.136 .17 .302 r
.59179 .36898 m .58245 .35728 L .58921 .36827 L p F P
0 0 0 r
s
.24 .35 .67 r
.56502 .34175 m
.58573 .3676 L
s
.094 .106 .204 r
.35271 .57472 m .34232 .56575 L .36132 .58263 L p F P
0 0 0 r
s
.094 .106 .204 r
.36132 .58263 m .37034 .59041 L .35271 .57472 L p F P
0 0 0 r
s
.24 .35 .67 r
.34454 .56557 m
.36962 .58725 L
s
.934 .288 .121 r
.58028 .63459 m .58939 .63186 L .56137 .6346 L p F P
0 0 0 r
s
.83 .24 .1 r
.57623 .63459 m
.57735 .6348 L
s
.934 .288 .121 r
.56137 .6346 m .55516 .63648 L .58028 .63459 L p F P
0 0 0 r
s
.24 .35 .67 r
.57182 .63616 m
.58613 .65022 L
s
.545 .147 .066 r
.32277 .4717 m .30429 .47861 L .30361 .45851 L p F P
0 0 0 r
s
.545 .147 .066 r
.30361 .45851 m .32216 .45146 L .32277 .4717 L p F P
0 0 0 r
s
.127 .202 .442 r
.37923 .59808 m .37034 .59041 L .39155 .60398 L p F P
0 0 0 r
s
.24 .35 .67 r
.36962 .58725 m
.3837 .59896 L
s
.127 .202 .442 r
.39155 .60398 m .39887 .61032 L .37923 .59808 L p F P
0 0 0 r
s
.22 .344 .7 r
.43783 .63425 m .4324 .6295 L .45362 .63299 L p F P
0 0 0 r
s
.22 .344 .7 r
.45362 .63299 m .45728 .63625 L .43783 .63425 L p F P
0 0 0 r
s
.256 .392 .783 r
.46815 .64589 m .46455 .64269 L .48185 .63805 L p F P
0 0 0 r
s
.24 .35 .67 r
.46938 .64518 m
.46955 .64533 L
s
.256 .392 .783 r
.48185 .63805 m .48367 .63969 L .46815 .64589 L p F P
0 0 0 r
s
.319 .46 .871 r
.62255 .58198 m .62974 .58977 L .64738 .57399 L p F P
0 0 0 r
s
.319 .46 .871 r
.64738 .57399 m .63936 .565 L .62255 .58198 L p F P
0 0 0 r
s
1 .304 .129 r
.52444 .64575 m .53054 .64391 L .51565 .63867 L p F P
0 0 0 r
s
1 .304 .129 r
.51565 .63867 m .51253 .63962 L .52444 .64575 L p F P
0 0 0 r
s
.24 .35 .67 r
.50819 .65271 m
.53684 .64408 L
s
.147 .182 .324 r
.3276 .54742 m .31591 .53729 L .33176 .55664 L p F P
0 0 0 r
s
.147 .182 .324 r
.33176 .55664 m .34232 .56575 L .3276 .54742 L p F P
0 0 0 r
s
.24 .35 .67 r
.33277 .54698 m
.34454 .56557 L
s
.83 .24 .1 r
.55391 .31682 m
.56386 .31217 L
s
.56386 .31217 m
.60378 .29645 L
s
.319 .464 .884 r
.60851 .60345 m .61456 .60979 L .63682 .59745 L p F P
0 0 0 r
s
.319 .464 .884 r
.63682 .59745 m .62974 .58977 L .60851 .60345 L p F P
0 0 0 r
s
.83 .24 .1 r
.75718 .57238 m
.79932 .55963 L
s
.75718 .57238 m
.75093 .582 L
s
.315 .452 .849 r
.6312 .55588 m .63936 .565 L .65238 .54659 L p F P
0 0 0 r
s
.315 .452 .849 r
.65238 .54659 m .64357 .53644 L .6312 .55588 L p F P
0 0 0 r
s
.44 .115 .052 r
.3599 .43711 m .34092 .44432 L .34444 .42574 L p F P
0 0 0 r
s
.83 .24 .1 r
.34258 .44491 m
.3428 .44361 L
s
.34561 .4266 m
.34584 .4252 L
s
.44 .115 .052 r
.34444 .42574 m .36301 .41858 L .3599 .43711 L p F P
0 0 0 r
s
.31 .076 .035 r
.4008 .40402 m .3818 .41134 L .38746 .39553 L p F P
0 0 0 r
s
.83 .24 .1 r
.38803 .39589 m
.38829 .39521 L
s
.31 .076 .035 r
.38746 .39553 m .40558 .38847 L .4008 .40402 L p F P
0 0 0 r
s
.168 .272 .57 r
.4061 .61659 m .39887 .61032 L .42139 .61987 L p F P
0 0 0 r
s
.168 .272 .57 r
.42139 .61987 m .42692 .62471 L .4061 .61659 L p F P
0 0 0 r
s
.188 .246 .422 r
.30498 .51726 m .29227 .50613 L .30402 .52697 L p F P
0 0 0 r
s
.188 .246 .422 r
.30402 .52697 m .31591 .53729 L .30498 .51726 L p F P
0 0 0 r
s
.089 .134 .321 r
.56327 .33323 m .57295 .34536 L .56522 .33949 L p F P
0 0 0 r
s
.089 .134 .321 r
.56522 .33949 m .55652 .32861 L .56327 .33323 L p F P
0 0 0 r
s
.318 .465 .89 r
.58904 .61947 m .59381 .62431 L .62055 .61607 L p F P
0 0 0 r
s
.83 .24 .1 r
.60907 .62527 m
.61713 .62284 L
s
.61713 .62284 m
.61981 .62189 L
s
.318 .465 .89 r
.62055 .61607 m .61456 .60979 L .58904 .61947 L p F P
0 0 0 r
s
1 .304 .129 r
.53054 .64391 m .53666 .64206 L .51877 .63772 L p F P
0 0 0 r
s
.83 .24 .1 r
.52811 .64306 m
.52862 .6429 L
s
1 .304 .129 r
.51877 .63772 m .51565 .63867 L .53054 .64391 L p F P
0 0 0 r
s
.934 .288 .121 r
.58939 .63186 m .59854 .62911 L .56761 .63272 L p F P
0 0 0 r
s
.934 .288 .121 r
.56761 .63272 m .56137 .6346 L .58939 .63186 L p F P
0 0 0 r
s
.24 .35 .67 r
.56886 .63326 m
.57182 .63616 L
s
.26377 .37547 m
.2362 .34922 L
s
.26377 .37547 m
.25271 .40257 L
s
.308 .438 .814 r
.6346 .52611 m .64357 .53644 L .6521 .51634 L p F P
0 0 0 r
s
.24 .35 .67 r
.65078 .51708 m
.65124 .51533 L
s
.308 .438 .814 r
.6521 .51634 m .64267 .5052 L .6346 .52611 L p F P
0 0 0 r
s
.626 .173 .077 r
.31004 .49961 m .29227 .50613 L .28601 .48545 L p F P
0 0 0 r
s
.626 .173 .077 r
.28601 .48545 m .30429 .47861 L .31004 .49961 L p F P
0 0 0 r
s
.24 .35 .67 r
.27418 .47866 m
.28824 .49108 L
s
.28824 .49108 m
.28899 .49175 L
s
.83 .24 .1 r
.2877 .49311 m
.28827 .4929 L
s
.26875 .50014 m
.2877 .49311 L
s
.30531 .48235 m
.30537 .47821 L
s
.185 .244 .417 r
.6043 .39608 m .61459 .40886 L .60909 .39314 L p F P
0 0 0 r
s
.185 .244 .417 r
.60909 .39314 m .59924 .38082 L .6043 .39608 L p F P
0 0 0 r
s
.256 .392 .783 r
.46455 .64269 m .46093 .63948 L .48002 .6364 L p F P
0 0 0 r
s
.24 .35 .67 r
.46594 .64212 m
.46611 .64227 L
s
.256 .392 .783 r
.48002 .6364 m .48185 .63805 L .46455 .64269 L p F P
0 0 0 r
s
.24 .35 .67 r
.27419 .45384 m
.24679 .42913 L
s
.27419 .45384 m
.27418 .47866 L
s
.294 .415 .762 r
.63306 .49384 m .64267 .5052 L .64697 .48447 L p F P
0 0 0 r
s
.294 .415 .762 r
.64697 .48447 m .63711 .47256 L .63306 .49384 L p F P
0 0 0 r
s
1 .304 .129 r
.53666 .64206 m .54281 .64021 L .52189 .63677 L p F P
0 0 0 r
s
.83 .24 .1 r
.53374 .64136 m
.53426 .6412 L
s
1 .304 .129 r
.52189 .63677 m .51877 .63772 L .53666 .64206 L p F P
0 0 0 r
s
.092 .026 .011 r
.51713 .33512 m .49926 .34213 L .49934 .33659 L p F P
0 0 0 r
s
.092 .026 .011 r
.49934 .33659 m .5153 .3303 L .51713 .33512 L p F P
0 0 0 r
s
.83 .24 .1 r
.51583 .3317 m
.52483 .32754 L
s
.64462 .28037 m
.65518 .28288 L
s
.65518 .28288 m
.69629 .26677 L
s
.178 .043 .018 r
.46113 .36683 m .44241 .37413 L .44676 .36273 L p F P
0 0 0 r
s
.178 .043 .018 r
.44676 .36273 m .46408 .35594 L .46113 .36683 L p F P
0 0 0 r
s
.83 .24 .1 r
.61713 .62284 m
.65783 .61062 L
s
.604 .62012 m
.61713 .62284 L
s
.22 .344 .7 r
.4324 .6295 m .42692 .62471 L .44993 .62972 L p F P
0 0 0 r
s
.22 .344 .7 r
.44993 .62972 m .45362 .63299 L .4324 .6295 L p F P
0 0 0 r
s
.235 .32 .564 r
.61721 .42731 m .6275 .43995 L .62467 .4214 L p F P
0 0 0 r
s
.235 .32 .564 r
.62467 .4214 m .61459 .40886 L .61721 .42731 L p F P
0 0 0 r
s
.272 .378 .683 r
.62706 .46042 m .63711 .47256 L .63759 .45234 L p F P
0 0 0 r
s
.24 .35 .67 r
.63612 .45346 m
.63616 .45283 L
s
.272 .378 .683 r
.63759 .45234 m .6275 .43995 L .62706 .46042 L p F P
0 0 0 r
s
.313 .462 .89 r
.56427 .62945 m .56761 .63272 L .59854 .62911 L p F P
0 0 0 r
s
.313 .462 .89 r
.59854 .62911 m .59381 .62431 L .56427 .62945 L p F P
0 0 0 r
s
.83 .24 .1 r
.30491 .62209 m
.34206 .60985 L
s
.30491 .62209 m
.29071 .59319 L
s
.46928 .64725 m
.48484 .64249 L
s
.84243 .54658 m
.84451 .53149 L
s
.545 .147 .066 r
.34147 .46471 m .32277 .4717 L .32216 .45146 L p F P
0 0 0 r
s
.545 .147 .066 r
.32216 .45146 m .34092 .44432 L .34147 .46471 L p F P
0 0 0 r
s
.83 .24 .1 r
.34095 .44553 m
.34258 .44491 L
s
1 .304 .129 r
.54281 .64021 m .54898 .63835 L .52503 .63582 L p F P
0 0 0 r
s
.83 .24 .1 r
.53939 .63965 m
.53991 .63949 L
s
1 .304 .129 r
.52503 .63582 m .52189 .63677 L .54281 .64021 L p F P
0 0 0 r
s
.24 .35 .67 r
.54348 .31487 m
.52376 .30464 L
s
.52376 .30464 m
.50129 .27689 L
s
.83 .24 .1 r
.27957 .56209 m
.27213 .53049 L
s
.256 .392 .783 r
.46093 .63948 m .45728 .63625 L .47819 .63474 L p F P
0 0 0 r
s
.24 .35 .67 r
.45773 .63482 m
.45918 .63611 L
s
.46249 .63905 m
.46265 .6392 L
s
.45532 .6345 m
.45773 .63482 L
s
.256 .392 .783 r
.47819 .63474 m .48002 .6364 L .46093 .63948 L p F P
0 0 0 r
s
.31 .076 .035 r
.42002 .39661 m .4008 .40402 L .40558 .38847 L p F P
0 0 0 r
s
.31 .076 .035 r
.40558 .38847 m .42389 .38134 L .42002 .39661 L p F P
0 0 0 r
s
.44 .115 .052 r
.37909 .42981 m .3599 .43711 L .36301 .41858 L p F P
0 0 0 r
s
.44 .115 .052 r
.36301 .41858 m .3818 .41134 L .37909 .42981 L p F P
0 0 0 r
s
.127 .202 .442 r
.37034 .59041 m .36132 .58263 L .38414 .59756 L p F P
0 0 0 r
s
.127 .202 .442 r
.38414 .59756 m .39155 .60398 L .37034 .59041 L p F P
0 0 0 r
s
1 .301 .129 r
.5 .62969 m .49088 .64622 L .49396 .64528 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.50133 .64645 m
.50819 .65271 L
s
.28 .423 .834 r
.5 .62969 m .49088 .64622 L .48909 .6446 L closepath p F P
0 0 0 r
s
.168 .272 .57 r
.39887 .61032 m .39155 .60398 L .41581 .61499 L p F P
0 0 0 r
s
.168 .272 .57 r
.41581 .61499 m .42139 .61987 L .39887 .61032 L p F P
0 0 0 r
s
.319 .464 .884 r
.60238 .59702 m .60851 .60345 L .62974 .58977 L p F P
0 0 0 r
s
.319 .464 .884 r
.62974 .58977 m .62255 .58198 L .60238 .59702 L p F P
0 0 0 r
s
1 .304 .129 r
.54898 .63835 m .55516 .63648 L .52816 .63486 L p F P
0 0 0 r
s
.83 .24 .1 r
.54506 .63793 m
.54558 .63778 L
s
1 .304 .129 r
.52816 .63486 m .52503 .63582 L .54898 .63835 L p F P
0 0 0 r
s
.094 .106 .204 r
.34232 .56575 m .33176 .55664 L .35218 .57475 L p F P
0 0 0 r
s
.094 .106 .204 r
.35218 .57475 m .36132 .58263 L .34232 .56575 L p F P
0 0 0 r
s
.318 .465 .89 r
.58422 .61459 m .58904 .61947 L .61456 .60979 L p F P
0 0 0 r
s
.318 .465 .89 r
.61456 .60979 m .60851 .60345 L .58422 .61459 L p F P
0 0 0 r
s
.24 .35 .67 r
.42877 .2455 m
.40159 .25242 L
s
.40159 .25242 m
.37663 .22356 L
s
1 .301 .129 r
.5 .62969 m .49396 .64528 L .49704 .64434 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.49922 .64452 m
.50133 .64645 L
s
.83 .24 .1 r
.70903 .5946 m
.75093 .582 L
s
.70903 .5946 m
.69946 .59811 L
s
.319 .46 .871 r
.61527 .57409 m .62255 .58198 L .63936 .565 L p F P
0 0 0 r
s
.319 .46 .871 r
.63936 .565 m .6312 .55588 L .61527 .57409 L p F P
0 0 0 r
s
.83 .24 .1 r
.3963 .62323 m
.41363 .64408 L
s
.136 .17 .302 r
.57899 .35547 m .58921 .36827 L .58245 .35728 L p F P
0 0 0 r
s
.136 .17 .302 r
.58245 .35728 m .57295 .34536 L .57899 .35547 L p F P
0 0 0 r
s
.24 .35 .67 r
.56502 .34175 m
.5804 .35742 L
s
.28 .423 .834 r
.5 .62969 m .48909 .6446 L .48729 .64297 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.35841 .63537 m
.3963 .62323 L
s
.35841 .63537 m
.34206 .60985 L
s
.092 .026 .011 r
.53518 .32804 m .51713 .33512 L .5153 .3303 L p F P
0 0 0 r
s
.092 .026 .011 r
.5153 .3303 m .53141 .32396 L .53518 .32804 L p F P
0 0 0 r
s
.83 .24 .1 r
.74909 .25977 m
.73836 .25029 L
s
.626 .173 .077 r
.32801 .49302 m .31004 .49961 L .30429 .47861 L p F P
0 0 0 r
s
.626 .173 .077 r
.30429 .47861 m .32277 .4717 L .32801 .49302 L p F P
0 0 0 r
s
1 .301 .129 r
.5 .62969 m .49704 .64434 L .50013 .6434 L closepath p F P
0 0 0 r
s
.22 .344 .7 r
.42692 .62471 m .42139 .61987 L .44622 .62643 L p F P
0 0 0 r
s
.22 .344 .7 r
.44622 .62643 m .44993 .62972 L .42692 .62471 L p F P
0 0 0 r
s
1 .304 .129 r
.55516 .63648 m .56137 .6346 L .53131 .6339 L p F P
0 0 0 r
s
.83 .24 .1 r
.55075 .63621 m
.55127 .63606 L
s
1 .304 .129 r
.53131 .6339 m .52816 .63486 L .55516 .63648 L p F P
0 0 0 r
s
.24 .35 .67 r
.52802 .63575 m
.53684 .64408 L
s
.53684 .64408 m
.55173 .63648 L
s
.55173 .63648 m
.55473 .63495 L
s
.147 .182 .324 r
.31591 .53729 m .30402 .52697 L .32103 .54738 L p F P
0 0 0 r
s
.147 .182 .324 r
.32103 .54738 m .33176 .55664 L .31591 .53729 L p F P
0 0 0 r
s
.313 .462 .89 r
.56091 .62615 m .56427 .62945 L .59381 .62431 L p F P
0 0 0 r
s
.313 .462 .89 r
.59381 .62431 m .58904 .61947 L .56091 .62615 L p F P
0 0 0 r
s
.178 .043 .018 r
.48006 .35946 m .46113 .36683 L .46408 .35594 L p F P
0 0 0 r
s
.178 .043 .018 r
.46408 .35594 m .48158 .34907 L .48006 .35946 L p F P
0 0 0 r
s
.256 .392 .783 r
.45728 .63625 m .45362 .63299 L .47636 .63308 L p F P
0 0 0 r
s
.256 .392 .783 r
.47636 .63308 m .47819 .63474 L .45728 .63625 L p F P
0 0 0 r
s
.83 .24 .1 r
.29071 .59319 m
.32785 .58056 L
s
.29071 .59319 m
.27957 .56209 L
s
1 .301 .129 r
.5 .62969 m .50013 .6434 L .50322 .64246 L closepath p F P
0 0 0 r
s
.089 .134 .321 r
.55342 .32088 m .56327 .33323 L .55652 .32861 L p F P
0 0 0 r
s
.089 .134 .321 r
.55652 .32861 m .54767 .31755 L .55342 .32088 L p F P
0 0 0 r
s
.83 .24 .1 r
.27957 .56209 m
.3166 .54909 L
s
.315 .452 .849 r
.6229 .5466 m .6312 .55588 L .64357 .53644 L p F P
0 0 0 r
s
.315 .452 .849 r
.64357 .53644 m .6346 .52611 L .6229 .5466 L p F P
0 0 0 r
s
.28 .423 .834 r
.5 .62969 m .48729 .64297 L .48548 .64133 L closepath p F P
0 0 0 r
s
1 .301 .129 r
.5 .62969 m .50322 .64246 L .50632 .64152 L closepath p F P
0 0 0 r
s
1 .304 .129 r
.56137 .6346 m .56761 .63272 L .53446 .63294 L p F P
0 0 0 r
s
.83 .24 .1 r
.55645 .63449 m
.55697 .63433 L
s
.56218 .63276 m
.56364 .63232 L
s
.56364 .63232 m
.56595 .63273 L
s
1 .304 .129 r
.53446 .63294 m .53131 .6339 L .56137 .6346 L p F P
0 0 0 r
s
.24 .35 .67 r
.32151 .25262 m
.29578 .27308 L
s
.29578 .27308 m
.26861 .24454 L
s
.29578 .27308 m
.27246 .29655 L
s
.691 .194 .085 r
.32084 .52093 m .30402 .52697 L .29227 .50613 L p F P
0 0 0 r
s
.24 .35 .67 r
.30811 .5255 m
.33277 .54698 L
s
.30105 .50291 m
.30349 .51194 L
s
.691 .194 .085 r
.29227 .50613 m .31004 .49961 L .32084 .52093 L p F P
0 0 0 r
s
.83 .24 .1 r
.27213 .53049 m
.30027 .52032 L
s
.545 .147 .066 r
.36038 .45764 m .34147 .46471 L .34092 .44432 L p F P
0 0 0 r
s
.83 .24 .1 r
.34258 .44491 m
.34258 .44546 L
s
.545 .147 .066 r
.34092 .44432 m .3599 .43711 L .36038 .45764 L p F P
0 0 0 r
s
.83 .24 .1 r
.57058 .63022 m
.57619 .62852 L
s
.56364 .63232 m
.56636 .6315 L
s
1 .301 .129 r
.5 .62969 m .50632 .64152 L .50942 .64057 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.50129 .27689 m
.47808 .2725 L
s
.47808 .2725 m
.45456 .24394 L
s
.27988 .50091 m
.29933 .51785 L
s
.29933 .51785 m
.30087 .51919 L
s
.28 .423 .834 r
.5 .62969 m .48548 .64133 L .48367 .63969 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.25271 .40257 m
.22465 .37662 L
s
.25271 .40257 m
.24679 .42913 L
s
.27246 .29655 m
.2448 .26846 L
s
.27246 .29655 m
.25235 .32222 L
s
.83 .24 .1 r
.59449 .30085 m
.60378 .29645 L
s
.60378 .29645 m
.64462 .28037 L
s
.308 .438 .814 r
.62546 .51559 m .6346 .52611 L .64267 .5052 L p F P
0 0 0 r
s
.308 .438 .814 r
.64267 .5052 m .63306 .49384 L .62546 .51559 L p F P
0 0 0 r
s
.83 .24 .1 r
.79932 .55963 m
.84243 .54658 L
s
.79932 .55963 m
.79381 .56911 L
s
.31 .076 .035 r
.43946 .38912 m .42002 .39661 L .42389 .38134 L p F P
0 0 0 r
s
.83 .24 .1 r
.42551 .38215 m
.4261 .38048 L
s
.31 .076 .035 r
.42389 .38134 m .44241 .37413 L .43946 .38912 L p F P
0 0 0 r
s
1 .301 .129 r
.5 .62969 m .50942 .64057 L .51253 .63962 L closepath p F P
0 0 0 r
s
.185 .244 .417 r
.5938 .38303 m .6043 .39608 L .59924 .38082 L p F P
0 0 0 r
s
.185 .244 .417 r
.59924 .38082 m .58921 .36827 L .5938 .38303 L p F P
0 0 0 r
s
.24 .35 .67 r
.5804 .35742 m
.5893 .36856 L
s
.44 .115 .052 r
.39852 .42243 m .37909 .42981 L .3818 .41134 L p F P
0 0 0 r
s
.83 .24 .1 r
.38037 .43055 m
.38056 .42925 L
s
.38303 .41216 m
.38322 .41079 L
s
.44 .115 .052 r
.3818 .41134 m .4008 .40402 L .39852 .42243 L p F P
0 0 0 r
s
.256 .392 .783 r
.45362 .63299 m .44993 .62972 L .47452 .63142 L p F P
0 0 0 r
s
.24 .35 .67 r
.45551 .63285 m
.45568 .633 L
s
.83 .24 .1 r
.41363 .64408 m
.45215 .63205 L
s
.256 .392 .783 r
.47452 .63142 m .47636 .63308 L .45362 .63299 L p F P
0 0 0 r
s
.83 .24 .1 r
.45215 .63205 m
.46928 .64725 L
s
.306 .454 .882 r
.53271 .63128 m .53446 .63294 L .56761 .63272 L p F P
0 0 0 r
s
.306 .454 .882 r
.56761 .63272 m .56427 .62945 L .53271 .63128 L p F P
0 0 0 r
s
.168 .272 .57 r
.39155 .60398 m .38414 .59756 L .41018 .61007 L p F P
0 0 0 r
s
.168 .272 .57 r
.41018 .61007 m .41581 .61499 L .39155 .60398 L p F P
0 0 0 r
s
.28 .423 .834 r
.5 .62969 m .48367 .63969 L .48185 .63805 L closepath p F P
0 0 0 r
s
1 .301 .129 r
.5 .62969 m .51253 .63962 L .51565 .63867 L closepath p F P
0 0 0 r
s
.092 .026 .011 r
.55342 .32088 m .53518 .32804 L .53141 .32396 L p F P
0 0 0 r
s
.092 .026 .011 r
.53141 .32396 m .54767 .31755 L .55342 .32088 L p F P
0 0 0 r
s
.24 .35 .67 r
.54952 .32241 m
.56502 .34175 L
s
.54616 .31821 m
.54627 .31834 L
s
.83 .24 .1 r
.54945 .31857 m
.55391 .31682 L
s
.24 .35 .67 r
.54348 .31487 m
.54616 .31821 L
s
.22 .344 .7 r
.42139 .61987 m .41581 .61499 L .44248 .62311 L p F P
0 0 0 r
s
.22 .344 .7 r
.44248 .62311 m .44622 .62643 L .42139 .61987 L p F P
0 0 0 r
s
.318 .465 .89 r
.57936 .60966 m .58422 .61459 L .60851 .60345 L p F P
0 0 0 r
s
.318 .465 .89 r
.60851 .60345 m .60238 .59702 L .57936 .60966 L p F P
0 0 0 r
s
.24 .35 .67 r
.34877 .23589 m
.32151 .25262 L
s
.32151 .25262 m
.29478 .22359 L
s
.294 .415 .762 r
.62327 .48227 m .63306 .49384 L .63711 .47256 L p F P
0 0 0 r
s
.24 .35 .67 r
.63503 .47402 m
.63523 .47029 L
s
.294 .415 .762 r
.63711 .47256 m .62706 .46042 L .62327 .48227 L p F P
0 0 0 r
s
.127 .202 .442 r
.36132 .58263 m .35218 .57475 L .37665 .59106 L p F P
0 0 0 r
s
.127 .202 .442 r
.37665 .59106 m .38414 .59756 L .36132 .58263 L p F P
0 0 0 r
s
.313 .462 .89 r
.55753 .62284 m .56091 .62615 L .58904 .61947 L p F P
0 0 0 r
s
.313 .462 .89 r
.58904 .61947 m .58422 .61459 L .55753 .62284 L p F P
0 0 0 r
s
1 .301 .129 r
.5 .62969 m .51565 .63867 L .51877 .63772 L closepath p F P
0 0 0 r
s
.626 .173 .077 r
.34619 .48636 m .32801 .49302 L .32277 .4717 L p F P
0 0 0 r
s
.626 .173 .077 r
.32277 .4717 m .34147 .46471 L .34619 .48636 L p F P
0 0 0 r
s
.235 .32 .564 r
.60671 .41442 m .61721 .42731 L .61459 .40886 L p F P
0 0 0 r
s
.24 .35 .67 r
.61172 .4053 m
.61264 .41024 L
s
.61541 .4251 m
.61597 .42808 L
s
.235 .32 .564 r
.61459 .40886 m .6043 .39608 L .60671 .41442 L p F P
0 0 0 r
s
.319 .464 .884 r
.59618 .59052 m .60238 .59702 L .62255 .58198 L p F P
0 0 0 r
s
.319 .464 .884 r
.62255 .58198 m .61527 .57409 L .59618 .59052 L p F P
0 0 0 r
s
.178 .043 .018 r
.4992 .352 m .48006 .35946 L .48158 .34907 L p F P
0 0 0 r
s
.178 .043 .018 r
.48158 .34907 m .49926 .34213 L .4992 .352 L p F P
0 0 0 r
s
.272 .378 .683 r
.6168 .44803 m .62706 .46042 L .6275 .43995 L p F P
0 0 0 r
s
.272 .378 .683 r
.6275 .43995 m .61721 .42731 L .6168 .44803 L p F P
0 0 0 r
s
.24 .35 .67 r
.61597 .42808 m
.61717 .42955 L
s
.28 .423 .834 r
.5 .62969 m .48185 .63805 L .48002 .6364 L closepath p F P
0 0 0 r
s
1 .301 .129 r
.5 .62969 m .51877 .63772 L .52189 .63677 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.25235 .32222 m
.22418 .29455 L
s
.25235 .32222 m
.2362 .34922 L
s
.83 .24 .1 r
.68641 .26392 m
.69629 .26677 L
s
.69629 .26677 m
.73836 .25029 L
s
.256 .392 .783 r
.44993 .62972 m .44622 .62643 L .47267 .62975 L p F P
0 0 0 r
s
.24 .35 .67 r
.45199 .62972 m
.45216 .62988 L
s
.256 .392 .783 r
.47267 .62975 m .47452 .63142 L .44993 .62972 L p F P
0 0 0 r
s
.094 .106 .204 r
.33176 .55664 m .32103 .54738 L .34291 .56675 L p F P
0 0 0 r
s
.094 .106 .204 r
.34291 .56675 m .35218 .57475 L .33176 .55664 L p F P
0 0 0 r
s
.306 .454 .882 r
.53095 .62961 m .53271 .63128 L .56427 .62945 L p F P
0 0 0 r
s
.306 .454 .882 r
.56427 .62945 m .56091 .62615 L .53095 .62961 L p F P
0 0 0 r
s
.83 .24 .1 r
.65783 .61062 m
.69946 .59811 L
s
.65783 .61062 m
.64531 .60763 L
s
1 .301 .129 r
.5 .62969 m .52189 .63677 L .52503 .63582 L closepath p F P
0 0 0 r
s
.28 .423 .834 r
.5 .62969 m .48002 .6364 L .47819 .63474 L closepath p F P
0 0 0 r
s
.319 .46 .871 r
.60787 .56608 m .61527 .57409 L .6312 .55588 L p F P
0 0 0 r
s
.319 .46 .871 r
.6312 .55588 m .6229 .5466 L .60787 .56608 L p F P
0 0 0 r
s
.83 .24 .1 r
.34206 .60985 m
.32785 .58056 L
s
.691 .194 .085 r
.33784 .51483 m .32084 .52093 L .31004 .49961 L p F P
0 0 0 r
s
.691 .194 .085 r
.31004 .49961 m .32801 .49302 L .33784 .51483 L p F P
0 0 0 r
s
1 .301 .129 r
.5 .62969 m .52503 .63582 L .52816 .63486 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.27418 .47866 m
.2464 .45411 L
s
.27418 .47866 m
.27988 .50091 L
s
.545 .147 .066 r
.37952 .45048 m .36038 .45764 L .3599 .43711 L p F P
0 0 0 r
s
.545 .147 .066 r
.3599 .43711 m .37909 .42981 L .37952 .45048 L p F P
0 0 0 r
s
.83 .24 .1 r
.37912 .43103 m
.38037 .43055 L
s
.136 .17 .302 r
.56857 .34243 m .57899 .35547 L .57295 .34536 L p F P
0 0 0 r
s
.136 .17 .302 r
.57295 .34536 m .56327 .33323 L .56857 .34243 L p F P
0 0 0 r
s
.31 .076 .035 r
.45913 .38154 m .43946 .38912 L .44241 .37413 L p F P
0 0 0 r
s
.31 .076 .035 r
.44241 .37413 m .46113 .36683 L .45913 .38154 L p F P
0 0 0 r
s
1 .301 .129 r
.5 .62969 m .52816 .63486 L .53131 .6339 L closepath p F P
0 0 0 r
s
.28 .423 .834 r
.5 .62969 m .47819 .63474 L .47636 .63308 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.47624 .63297 m
.47913 .63268 L
s
.22 .344 .7 r
.41581 .61499 m .41018 .61007 L .43872 .61978 L p F P
0 0 0 r
s
.22 .344 .7 r
.43872 .61978 m .44248 .62311 L .41581 .61499 L p F P
0 0 0 r
s
.746 .211 .092 r
.33647 .54196 m .32103 .54738 L .30402 .52697 L p F P
0 0 0 r
s
.83 .24 .1 r
.31551 .54455 m
.3166 .54909 L
s
.24 .35 .67 r
.32279 .54676 m
.34454 .56557 L
s
.30764 .52567 m
.31025 .52985 L
s
.746 .211 .092 r
.30402 .52697 m .32084 .52093 L .33647 .54196 L p F P
0 0 0 r
s
.24 .35 .67 r
.31679 .54033 m
.31846 .54301 L
s
.31462 .53686 m
.31679 .54033 L
s
.83 .24 .1 r
.31424 .53923 m
.31551 .54455 L
s
.44 .115 .052 r
.41817 .41496 m .39852 .42243 L .4008 .40402 L p F P
0 0 0 r
s
.44 .115 .052 r
.4008 .40402 m .42002 .39661 L .41817 .41496 L p F P
0 0 0 r
s
.313 .462 .89 r
.55413 .6195 m .55753 .62284 L .58422 .61459 L p F P
0 0 0 r
s
.83 .24 .1 r
.57619 .62852 m
.604 .62012 L
s
.313 .462 .89 r
.58422 .61459 m .57936 .60966 L .55413 .6195 L p F P
0 0 0 r
s
.24 .35 .67 r
.45456 .24394 m
.42877 .2455 L
s
.42877 .2455 m
.40408 .21618 L
s
1 .301 .129 r
.5 .62969 m .53131 .6339 L .53446 .63294 L closepath p F P
0 0 0 r
s
.256 .392 .783 r
.44622 .62643 m .44248 .62311 L .47082 .62807 L p F P
0 0 0 r
s
.24 .35 .67 r
.44845 .62658 m
.44862 .62673 L
s
.256 .392 .783 r
.47082 .62807 m .47267 .62975 L .44622 .62643 L p F P
0 0 0 r
s
.315 .452 .849 r
.61448 .53717 m .6229 .5466 L .6346 .52611 L p F P
0 0 0 r
s
.315 .452 .849 r
.6346 .52611 m .62546 .51559 L .61448 .53717 L p F P
0 0 0 r
s
.168 .272 .57 r
.38414 .59756 m .37665 .59106 L .4045 .6051 L p F P
0 0 0 r
s
.168 .272 .57 r
.4045 .6051 m .41018 .61007 L .38414 .59756 L p F P
0 0 0 r
s
.306 .454 .882 r
.52919 .62793 m .53095 .62961 L .56091 .62615 L p F P
0 0 0 r
s
.83 .24 .1 r
.55643 .62798 m
.55806 .62896 L
s
.306 .454 .882 r
.56091 .62615 m .55753 .62284 L .52919 .62793 L p F P
0 0 0 r
s
.24 .35 .67 r
.37663 .22356 m
.34877 .23589 L
s
.34877 .23589 m
.32244 .20636 L
s
.83 .24 .1 r
.55183 .31996 m
.55391 .31682 L
s
.55391 .31682 m
.59449 .30085 L
s
.28 .423 .834 r
.5 .62969 m .47636 .63308 L .47452 .63142 L closepath p F P
0 0 0 r
s
.318 .465 .89 r
.57445 .60469 m .57936 .60966 L .60238 .59702 L p F P
0 0 0 r
s
.318 .465 .89 r
.60238 .59702 m .59618 .59052 L .57445 .60469 L p F P
0 0 0 r
s
.296 .442 .865 r
.53446 .63294 m .53271 .63128 L .5 .62969 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.75093 .582 m
.79381 .56911 L
s
.75093 .582 m
.74208 .5853 L
s
.178 .043 .018 r
.51856 .34446 m .4992 .352 L .49926 .34213 L p F P
0 0 0 r
s
.178 .043 .018 r
.49926 .34213 m .51713 .33512 L .51856 .34446 L p F P
0 0 0 r
s
.83 .24 .1 r
.45215 .63205 m
.46416 .6283 L
s
.626 .173 .077 r
.36456 .47962 m .34619 .48636 L .34147 .46471 L p F P
0 0 0 r
s
.83 .24 .1 r
.34259 .46429 m
.34259 .46543 L
s
.626 .173 .077 r
.34147 .46471 m .36038 .45764 L .36456 .47962 L p F P
0 0 0 r
s
.24 .35 .67 r
.54348 .31487 m
.54846 .31991 L
s
.54348 .31487 m
.52107 .28689 L
s
.83 .24 .1 r
.3166 .54909 m
.32785 .58056 L
s
.28 .423 .834 r
.5 .62969 m .47452 .63142 L .47267 .62975 L closepath p F P
0 0 0 r
s
.127 .202 .442 r
.35218 .57475 m .34291 .56675 L .36906 .58449 L p F P
0 0 0 r
s
.83 .24 .1 r
.32785 .58056 m
.35004 .57302 L
s
.35004 .57302 m
.35126 .5726 L
s
.24 .35 .67 r
.34454 .56557 m
.3596 .57807 L
s
.36316 .58109 m
.36813 .58539 L
s
.127 .202 .442 r
.36906 .58449 m .37665 .59106 L .35218 .57475 L p F P
0 0 0 r
s
.296 .442 .865 r
.53271 .63128 m .53095 .62961 L .5 .62969 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.3166 .54909 m
.32116 .54749 L
s
.308 .438 .814 r
.61616 .50488 m .62546 .51559 L .63306 .49384 L p F P
0 0 0 r
s
.24 .35 .67 r
.63046 .49554 m
.63144 .49193 L
s
.308 .438 .814 r
.63306 .49384 m .62327 .48227 L .61616 .50488 L p F P
0 0 0 r
s
.319 .464 .884 r
.5899 .58394 m .59618 .59052 L .61527 .57409 L p F P
0 0 0 r
s
.319 .464 .884 r
.61527 .57409 m .60787 .56608 L .5899 .58394 L p F P
0 0 0 r
s
.256 .392 .783 r
.44248 .62311 m .43872 .61978 L .46896 .62639 L p F P
0 0 0 r
s
.24 .35 .67 r
.44489 .62341 m
.44506 .62357 L
s
.256 .392 .783 r
.46896 .62639 m .47082 .62807 L .44248 .62311 L p F P
0 0 0 r
s
.83 .24 .1 r
.46416 .6283 m
.46785 .62715 L
s
.185 .244 .417 r
.58309 .36972 m .5938 .38303 L .58921 .36827 L p F P
0 0 0 r
s
.185 .244 .417 r
.58921 .36827 m .57899 .35547 L .58309 .36972 L p F P
0 0 0 r
s
.306 .454 .882 r
.52742 .62625 m .52919 .62793 L .55753 .62284 L p F P
0 0 0 r
s
.306 .454 .882 r
.55753 .62284 m .55413 .6195 L .52742 .62625 L p F P
0 0 0 r
s
.24 .35 .67 r
.2362 .34922 m
.2075 .32191 L
s
.2362 .34922 m
.22465 .37662 L
s
.691 .194 .085 r
.35502 .50866 m .33784 .51483 L .32801 .49302 L p F P
0 0 0 r
s
.691 .194 .085 r
.32801 .49302 m .34619 .48636 L .35502 .50866 L p F P
0 0 0 r
s
.28 .423 .834 r
.5 .62969 m .47267 .62975 L .47082 .62807 L closepath p F P
0 0 0 r
s
.22 .344 .7 r
.41018 .61007 m .4045 .6051 L .43494 .61643 L p F P
0 0 0 r
s
.24 .35 .67 r
.41298 .61102 m
.41474 .61124 L
s
.22 .344 .7 r
.43494 .61643 m .43872 .61978 L .41018 .61007 L p F P
0 0 0 r
s
.296 .442 .865 r
.53095 .62961 m .52919 .62793 L .5 .62969 L closepath p F P
0 0 0 r
s
.545 .147 .066 r
.39887 .44324 m .37952 .45048 L .37909 .42981 L p F P
0 0 0 r
s
.83 .24 .1 r
.38037 .43055 m
.38037 .43068 L
s
.545 .147 .066 r
.37909 .42981 m .39852 .42243 L .39887 .44324 L p F P
0 0 0 r
s
.83 .24 .1 r
.604 .62012 m
.64531 .60763 L
s
.58914 .61054 m
.604 .62012 L
s
.313 .462 .89 r
.55071 .61615 m .55413 .6195 L .57936 .60966 L p F P
0 0 0 r
s
.313 .462 .89 r
.57936 .60966 m .57445 .60469 L .55071 .61615 L p F P
0 0 0 r
s
.31 .076 .035 r
.47903 .37387 m .45913 .38154 L .46113 .36683 L p F P
0 0 0 r
s
.83 .24 .1 r
.46396 .36795 m
.46478 .36541 L
s
.31 .076 .035 r
.46113 .36683 m .48006 .35946 L .47903 .37387 L p F P
0 0 0 r
s
.83 .24 .1 r
.63602 .28451 m
.64462 .28037 L
s
.64462 .28037 m
.68641 .26392 L
s
.24 .35 .67 r
.24679 .42913 m
.21827 .40341 L
s
.24679 .42913 m
.2464 .45411 L
s
.746 .211 .092 r
.35205 .53649 m .33647 .54196 L .32084 .52093 L p F P
0 0 0 r
s
.746 .211 .092 r
.32084 .52093 m .33784 .51483 L .35205 .53649 L p F P
0 0 0 r
s
.83 .24 .1 r
.8377 .55592 m
.84243 .54658 L
s
.294 .415 .762 r
.61328 .47047 m .62327 .48227 L .62706 .46042 L p F P
0 0 0 r
s
.294 .415 .762 r
.62706 .46042 m .6168 .44803 L .61328 .47047 L p F P
0 0 0 r
s
.794 .227 .099 r
.35654 .56207 m .34291 .56675 L .32103 .54738 L p F P
0 0 0 r
s
.794 .227 .099 r
.32103 .54738 m .33647 .54196 L .35654 .56207 L p F P
0 0 0 r
s
.24 .35 .67 r
.31846 .54301 m
.3217 .54582 L
s
.3217 .54582 m
.32183 .54593 L
s
.44 .115 .052 r
.43805 .4074 m .41817 .41496 L .42002 .39661 L p F P
0 0 0 r
s
.83 .24 .1 r
.41904 .41587 m
.4192 .41456 L
s
.4213 .39738 m
.42147 .39605 L
s
.44 .115 .052 r
.42002 .39661 m .43946 .38912 L .43805 .4074 L p F P
0 0 0 r
s
.28 .423 .834 r
.5 .62969 m .47082 .62807 L .46896 .62639 L closepath p F P
0 0 0 r
s
.296 .442 .865 r
.52919 .62793 m .52742 .62625 L .5 .62969 L closepath p F P
0 0 0 r
s
.235 .32 .564 r
.596 .40125 m .60671 .41442 L .6043 .39608 L p F P
0 0 0 r
s
.235 .32 .564 r
.6043 .39608 m .5938 .38303 L .596 .40125 L p F P
0 0 0 r
s
.319 .46 .871 r
.60037 .55795 m .60787 .56608 L .6229 .5466 L p F P
0 0 0 r
s
.319 .46 .871 r
.6229 .5466 m .61448 .53717 L .60037 .55795 L p F P
0 0 0 r
s
.272 .378 .683 r
.60633 .43539 m .6168 .44803 L .61721 .42731 L p F P
0 0 0 r
s
.24 .35 .67 r
.61596 .42824 m
.61597 .42808 L
s
.272 .378 .683 r
.61721 .42731 m .60671 .41442 L .60633 .43539 L p F P
0 0 0 r
s
.168 .272 .57 r
.37665 .59106 m .36906 .58449 L .39876 .60008 L p F P
0 0 0 r
s
.168 .272 .57 r
.39876 .60008 m .4045 .6051 L .37665 .59106 L p F P
0 0 0 r
s
.83 .24 .1 r
.34206 .60985 m
.38007 .59732 L
s
.38007 .59732 m
.3963 .62323 L
s
.178 .043 .018 r
.53814 .33684 m .51856 .34446 L .51713 .33512 L p F P
0 0 0 r
s
.178 .043 .018 r
.51713 .33512 m .53518 .32804 L .53814 .33684 L p F P
0 0 0 r
s
.256 .392 .783 r
.43872 .61978 m .43494 .61643 L .46709 .6247 L p F P
0 0 0 r
s
.24 .35 .67 r
.44131 .62023 m
.44148 .62038 L
s
.256 .392 .783 r
.46709 .6247 m .46896 .62639 L .43872 .61978 L p F P
0 0 0 r
s
.83 .24 .1 r
.44138 .61867 m
.44319 .62092 L
s
.44319 .62092 m
.45215 .63205 L
s
.986 .292 .125 r
.48403 .61711 m .48719 .61612 L .5 .62969 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.4949 .62915 m
.49807 .62817 L
s
.986 .292 .125 r
.48088 .61809 m .48403 .61711 L .5 .62969 L closepath p F P
0 0 0 r
s
.986 .292 .125 r
.47774 .61908 m .48088 .61809 L .5 .62969 L closepath p F P
0 0 0 r
s
.986 .292 .125 r
.4746 .62007 m .47774 .61908 L .5 .62969 L closepath p F P
0 0 0 r
s
.986 .292 .125 r
.47147 .62105 m .4746 .62007 L .5 .62969 L closepath p F P
0 0 0 r
s
.986 .292 .125 r
.46834 .62203 m .47147 .62105 L .5 .62969 L closepath p F P
0 0 0 r
s
.986 .292 .125 r
.46522 .62301 m .46834 .62203 L .5 .62969 L closepath p F P
0 0 0 r
s
.28 .423 .834 r
.5 .62969 m .46896 .62639 L .46709 .6247 L closepath p F P
0 0 0 r
s
.28 .423 .834 r
.5 .62969 m .46709 .6247 L .46522 .62301 L closepath p F P
0 0 0 r
s
.296 .442 .865 r
.5185 .61776 m .5167 .61604 L .5 .62969 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.50135 .62882 m
.50201 .62944 L
s
.296 .442 .865 r
.5203 .61947 m .5185 .61776 L .5 .62969 L closepath p F P
0 0 0 r
s
.296 .442 .865 r
.52209 .62117 m .5203 .61947 L .5 .62969 L closepath p F P
0 0 0 r
s
.296 .442 .865 r
.52387 .62287 m .52209 .62117 L .5 .62969 L closepath p F P
0 0 0 r
s
.296 .442 .865 r
.52565 .62456 m .52387 .62287 L .5 .62969 L closepath p F P
0 0 0 r
s
.296 .442 .865 r
.52742 .62625 m .52565 .62456 L .5 .62969 L closepath p F P
0 0 0 r
s
.986 .292 .125 r
.49669 .61313 m .49987 .61214 L .5 .62969 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.49998 .62756 m
.50122 .6287 L
s
.24 .35 .67 r
.49845 .62805 m
.4996 .6277 L
s
.986 .292 .125 r
.49352 .61413 m .49669 .61313 L .5 .62969 L closepath p F P
0 0 0 r
s
.986 .292 .125 r
.49035 .61512 m .49352 .61413 L .5 .62969 L closepath p F P
0 0 0 r
s
.986 .292 .125 r
.48719 .61612 m .49035 .61512 L .5 .62969 L closepath p F P
0 0 0 r
s
.296 .442 .865 r
.5149 .61433 m .51308 .6126 L .5 .62969 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.49998 .62758 m
.50213 .62691 L
s
.296 .442 .865 r
.5167 .61604 m .5149 .61433 L .5 .62969 L closepath p F P
0 0 0 r
s
.986 .292 .125 r
.50624 .61014 m .50944 .60913 L .5 .62969 L closepath p F P
0 0 0 r
s
.986 .292 .125 r
.50305 .61114 m .50624 .61014 L .5 .62969 L closepath p F P
0 0 0 r
s
.986 .292 .125 r
.49987 .61214 m .50305 .61114 L .5 .62969 L closepath p F P
0 0 0 r
s
.296 .442 .865 r
.51126 .61087 m .50944 .60913 L .5 .62969 L closepath p F P
0 0 0 r
s
.296 .442 .865 r
.51308 .6126 m .51126 .61087 L .5 .62969 L closepath p F P
0 0 0 r
s
.306 .454 .882 r
.52565 .62456 m .52742 .62625 L .55413 .6195 L p F P
0 0 0 r
s
.306 .454 .882 r
.55413 .6195 m .55071 .61615 L .52565 .62456 L p F P
0 0 0 r
s
.318 .465 .89 r
.5695 .59967 m .57445 .60469 L .59618 .59052 L p F P
0 0 0 r
s
.318 .465 .89 r
.59618 .59052 m .5899 .58394 L .5695 .59967 L p F P
0 0 0 r
s
.24 .35 .67 r
.52107 .28689 m
.50129 .27689 L
s
.50129 .27689 m
.47791 .248 L
s
.626 .173 .077 r
.38314 .4728 m .36456 .47962 L .36038 .45764 L p F P
0 0 0 r
s
.626 .173 .077 r
.36038 .45764 m .37952 .45048 L .38314 .4728 L p F P
0 0 0 r
s
.136 .17 .302 r
.55794 .32912 m .56857 .34243 L .56327 .33323 L p F P
0 0 0 r
s
.136 .17 .302 r
.56327 .33323 m .55342 .32088 L .55794 .32912 L p F P
0 0 0 r
s
.24 .35 .67 r
.29131 .51954 m
.31846 .54301 L
s
.31846 .54301 m
.33545 .55711 L
s
.83 .24 .1 r
.73836 .25029 m
.72919 .24707 L
s
.22 .344 .7 r
.4045 .6051 m .39876 .60008 L .43114 .61305 L p F P
0 0 0 r
s
.22 .344 .7 r
.43114 .61305 m .43494 .61643 L .4045 .6051 L p F P
0 0 0 r
s
.83 .24 .1 r
.42282 .61474 m
.42827 .613 L
s
.3963 .62323 m
.42282 .61474 L
s
.256 .392 .783 r
.46522 .62301 m .46709 .6247 L .43494 .61643 L p F P
0 0 0 r
s
.83 .24 .1 r
.69946 .59811 m
.74208 .5853 L
s
.69946 .59811 m
.68758 .59485 L
s
.306 .454 .882 r
.52387 .62287 m .52565 .62456 L .55071 .61615 L p F P
0 0 0 r
s
.83 .24 .1 r
.53213 .628 m
.54826 .62306 L
s
.54826 .62306 m
.55643 .62798 L
s
.313 .462 .89 r
.54727 .61277 m .55071 .61615 L .57445 .60469 L p F P
0 0 0 r
s
.313 .462 .89 r
.57445 .60469 m .5695 .59967 L .54727 .61277 L p F P
0 0 0 r
s
.24 .35 .67 r
.40408 .21618 m
.37663 .22356 L
s
.37663 .22356 m
.35064 .19352 L
s
.691 .194 .085 r
.37238 .50243 m .35502 .50866 L .34619 .48636 L p F P
0 0 0 r
s
.691 .194 .085 r
.34619 .48636 m .36456 .47962 L .37238 .50243 L p F P
0 0 0 r
s
.315 .452 .849 r
.60591 .52759 m .61448 .53717 L .62546 .51559 L p F P
0 0 0 r
s
.24 .35 .67 r
.61325 .53678 m
.61356 .53615 L
s
.62264 .51733 m
.62418 .51412 L
s
.61325 .53678 m
.6141 .53773 L
s
.315 .452 .849 r
.62546 .51559 m .61616 .50488 L .60591 .52759 L p F P
0 0 0 r
s
.256 .392 .783 r
.43494 .61643 m .43114 .61305 L .46522 .62301 L p F P
0 0 0 r
s
.83 .24 .1 r
.38007 .59732 m
.38781 .59477 L
s
.37664 .59015 m
.38007 .59732 L
s
.37602 .58885 m
.37664 .59015 L
s
.838 .241 .105 r
.38051 .58066 m .36906 .58449 L .34291 .56675 L p F P
0 0 0 r
s
.83 .24 .1 r
.37326 .58309 m
.37557 .58791 L
s
.838 .241 .105 r
.34291 .56675 m .35654 .56207 L .38051 .58066 L p F P
0 0 0 r
s
.24 .35 .67 r
.35091 .57048 m
.35174 .5712 L
s
.306 .454 .882 r
.55071 .61615 m .54727 .61277 L .52387 .62287 L p F P
0 0 0 r
s
.746 .211 .092 r
.36779 .53097 m .35205 .53649 L .33784 .51483 L p F P
0 0 0 r
s
.746 .211 .092 r
.33784 .51483 m .35502 .50866 L .36779 .53097 L p F P
0 0 0 r
s
.545 .147 .066 r
.41846 .43592 m .39887 .44324 L .39852 .42243 L p F P
0 0 0 r
s
.545 .147 .066 r
.39852 .42243 m .41817 .41496 L .41846 .43592 L p F P
0 0 0 r
s
.83 .24 .1 r
.41818 .41619 m
.41904 .41587 L
s
.794 .227 .099 r
.37029 .55736 m .35654 .56207 L .33647 .54196 L p F P
0 0 0 r
s
.794 .227 .099 r
.33647 .54196 m .35205 .53649 L .37029 .55736 L p F P
0 0 0 r
s
.24 .35 .67 r
.33545 .55711 m
.35091 .57048 L
s
.83 .24 .1 r
.35216 .53662 m
.3545 .5358 L
s
.31 .076 .035 r
.49916 .36611 m .47903 .37387 L .48006 .35946 L p F P
0 0 0 r
s
.31 .076 .035 r
.48006 .35946 m .4992 .352 L .49916 .36611 L p F P
0 0 0 r
s
.319 .464 .884 r
.58355 .57729 m .5899 .58394 L .60787 .56608 L p F P
0 0 0 r
s
.319 .464 .884 r
.60787 .56608 m .60037 .55795 L .58355 .57729 L p F P
0 0 0 r
s
.24 .35 .67 r
.59403 .56389 m
.59464 .56455 L
s
.954 .28 .12 r
.46834 .62203 m .46522 .62301 L .43114 .61305 L p F P
0 0 0 r
s
.24 .35 .67 r
.43304 .61351 m
.43386 .61361 L
s
.43386 .61361 m
.43401 .61374 L
s
.306 .454 .882 r
.52209 .62117 m .52387 .62287 L .54727 .61277 L p F P
0 0 0 r
s
.83 .24 .1 r
.35446 .53565 m
.3545 .5358 L
s
.44 .115 .052 r
.45817 .39975 m .43805 .4074 L .43946 .38912 L p F P
0 0 0 r
s
.44 .115 .052 r
.43946 .38912 m .45913 .38154 L .45817 .39975 L p F P
0 0 0 r
s
.954 .28 .12 r
.47147 .62105 m .46834 .62203 L .43726 .61109 L p F P
0 0 0 r
s
.954 .28 .12 r
.43114 .61305 m .43726 .61109 L .46834 .62203 L p F P
0 0 0 r
s
.178 .043 .018 r
.55794 .32912 m .53814 .33684 L .53518 .32804 L p F P
0 0 0 r
s
.24 .35 .67 r
.55765 .32923 m
.55884 .33044 L
s
.178 .043 .018 r
.53518 .32804 m .55342 .32088 L .55794 .32912 L p F P
0 0 0 r
s
.306 .454 .882 r
.5203 .61947 m .52209 .62117 L .54381 .60937 L p F P
0 0 0 r
s
.306 .454 .882 r
.54727 .61277 m .54381 .60937 L .52209 .62117 L p F P
0 0 0 r
s
.954 .28 .12 r
.4746 .62007 m .47147 .62105 L .44341 .60912 L p F P
0 0 0 r
s
.954 .28 .12 r
.43726 .61109 m .44341 .60912 L .47147 .62105 L p F P
0 0 0 r
s
.879 .254 .11 r
.40769 .59717 m .39876 .60008 L .36906 .58449 L p F P
0 0 0 r
s
.879 .254 .11 r
.36906 .58449 m .38051 .58066 L .40769 .59717 L p F P
0 0 0 r
s
.24 .35 .67 r
.37706 .58603 m
.37802 .58642 L
s
.83 .24 .1 r
.58767 .312 m
.59449 .30085 L
s
.59449 .30085 m
.63602 .28451 L
s
.24 .35 .67 r
.26861 .24454 m
.29478 .22359 L
s
.2448 .26846 m
.26861 .24454 L
s
.308 .438 .814 r
.60669 .49397 m .61616 .50488 L .62327 .48227 L p F P
0 0 0 r
s
.308 .438 .814 r
.62327 .48227 m .61328 .47047 L .60669 .49397 L p F P
0 0 0 r
s
.917 .268 .115 r
.43726 .61109 m .43114 .61305 L .39876 .60008 L p F P
0 0 0 r
s
.83 .24 .1 r
.79381 .56911 m
.8377 .55592 L
s
.79381 .56911 m
.7857 .5722 L
s
.318 .465 .89 r
.5645 .5946 m .5695 .59967 L .5899 .58394 L p F P
0 0 0 r
s
.318 .465 .89 r
.5899 .58394 m .58355 .57729 L .5645 .5946 L p F P
0 0 0 r
s
.24 .35 .67 r
.5703 .58813 m
.57092 .58877 L
s
.47791 .248 m
.45456 .24394 L
s
.45456 .24394 m
.43008 .2142 L
s
.313 .462 .89 r
.54381 .60937 m .54727 .61277 L .5695 .59967 L p F P
0 0 0 r
s
.83 .24 .1 r
.54826 .62306 m
.58914 .61054 L
s
.24 .35 .67 r
.27988 .50091 m
.2518 .47645 L
s
.27988 .50091 m
.29131 .51954 L
s
.22465 .37662 m
.19544 .3496 L
s
.22465 .37662 m
.21827 .40341 L
s
.954 .28 .12 r
.47774 .61908 m .4746 .62007 L .44957 .60715 L p F P
0 0 0 r
s
.954 .28 .12 r
.44341 .60912 m .44957 .60715 L .4746 .62007 L p F P
0 0 0 r
s
.626 .173 .077 r
.40193 .46591 m .38314 .4728 L .37952 .45048 L p F P
0 0 0 r
s
.83 .24 .1 r
.38067 .45005 m
.38069 .45129 L
s
.626 .173 .077 r
.37952 .45048 m .39887 .44324 L .40193 .46591 L p F P
0 0 0 r
s
.24 .35 .67 r
.22418 .29455 m
.2448 .26846 L
s
.185 .244 .417 r
.57217 .35613 m .58309 .36972 L .57899 .35547 L p F P
0 0 0 r
s
.185 .244 .417 r
.57899 .35547 m .56857 .34243 L .57217 .35613 L p F P
0 0 0 r
s
.24 .35 .67 r
.55884 .33044 m
.56864 .34269 L
s
.917 .268 .115 r
.39876 .60008 m .40769 .59717 L .43726 .61109 L p F P
0 0 0 r
s
.306 .454 .882 r
.5185 .61776 m .5203 .61947 L .54032 .60595 L p F P
0 0 0 r
s
.306 .454 .882 r
.54381 .60937 m .54032 .60595 L .5203 .61947 L p F P
0 0 0 r
s
.24 .35 .67 r
.54286 .60844 m
.54334 .6082 L
s
.313 .462 .89 r
.5695 .59967 m .5645 .5946 L .54381 .60937 L p F P
0 0 0 r
s
.24 .35 .67 r
.54334 .6082 m
.54423 .60907 L
s
.838 .241 .105 r
.39204 .57681 m .38051 .58066 L .35654 .56207 L p F P
0 0 0 r
s
.838 .241 .105 r
.35654 .56207 m .37029 .55736 L .39204 .57681 L p F P
0 0 0 r
s
.83 .24 .1 r
.3545 .5358 m
.35661 .5417 L
s
.954 .28 .12 r
.48088 .61809 m .47774 .61908 L .45576 .60517 L p F P
0 0 0 r
s
.954 .28 .12 r
.44957 .60715 m .45576 .60517 L .47774 .61908 L p F P
0 0 0 r
s
.319 .46 .871 r
.59276 .54971 m .60037 .55795 L .61448 .53717 L p F P
0 0 0 r
s
.24 .35 .67 r
.59403 .56389 m
.59917 .55664 L
s
.61193 .53865 m
.61325 .53678 L
s
.319 .46 .871 r
.61448 .53717 m .60591 .52759 L .59276 .54971 L p F P
0 0 0 r
s
.917 .268 .115 r
.44341 .60912 m .43726 .61109 L .40769 .59717 L p F P
0 0 0 r
s
.24 .35 .67 r
.42817 .60855 m
.42962 .60984 L
s
.691 .194 .085 r
.38992 .49613 m .37238 .50243 L .36456 .47962 L p F P
0 0 0 r
s
.691 .194 .085 r
.36456 .47962 m .38314 .4728 L .38992 .49613 L p F P
0 0 0 r
s
.794 .227 .099 r
.38415 .55261 m .37029 .55736 L .35205 .53649 L p F P
0 0 0 r
s
.794 .227 .099 r
.35205 .53649 m .36779 .53097 L .38415 .55261 L p F P
0 0 0 r
s
.954 .28 .12 r
.48403 .61711 m .48088 .61809 L .46198 .60318 L p F P
0 0 0 r
s
.954 .28 .12 r
.45576 .60517 m .46198 .60318 L .48088 .61809 L p F P
0 0 0 r
s
.24 .35 .67 r
.46932 .61724 m
.47155 .61927 L
s
.294 .415 .762 r
.6031 .45843 m .61328 .47047 L .6168 .44803 L p F P
0 0 0 r
s
.24 .35 .67 r
.61462 .44969 m
.61487 .4457 L
s
.294 .415 .762 r
.6168 .44803 m .60633 .43539 L .6031 .45843 L p F P
0 0 0 r
s
.24 .35 .67 r
.29478 .22359 m
.32244 .20636 L
s
.746 .211 .092 r
.38367 .5254 m .36779 .53097 L .35502 .50866 L p F P
0 0 0 r
s
.746 .211 .092 r
.35502 .50866 m .37238 .50243 L .38367 .5254 L p F P
0 0 0 r
s
.306 .454 .882 r
.5167 .61604 m .5185 .61776 L .53681 .60251 L p F P
0 0 0 r
s
.306 .454 .882 r
.54032 .60595 m .53681 .60251 L .5185 .61776 L p F P
0 0 0 r
s
.31 .076 .035 r
.51953 .35825 m .49916 .36611 L .4992 .352 L p F P
0 0 0 r
s
.31 .076 .035 r
.4992 .352 m .51856 .34446 L .51953 .35825 L p F P
0 0 0 r
s
.879 .254 .11 r
.41666 .59423 m .40769 .59717 L .38051 .58066 L p F P
0 0 0 r
s
.879 .254 .11 r
.38051 .58066 m .39204 .57681 L .41666 .59423 L p F P
0 0 0 r
s
.24 .35 .67 r
.38336 .58859 m
.38847 .59306 L
s
.37802 .58642 m
.38336 .58859 L
s
.954 .28 .12 r
.48719 .61612 m .48403 .61711 L .46821 .60119 L p F P
0 0 0 r
s
.954 .28 .12 r
.46198 .60318 m .46821 .60119 L .48403 .61711 L p F P
0 0 0 r
s
.24 .35 .67 r
.44411 .61249 m
.46198 .61054 L
s
.235 .32 .564 r
.58506 .38782 m .596 .40125 L .5938 .38303 L p F P
0 0 0 r
s
.24 .35 .67 r
.59089 .37941 m
.59174 .38416 L
s
.59443 .39932 m
.59496 .40232 L
s
.235 .32 .564 r
.5938 .38303 m .58309 .36972 L .58506 .38782 L p F P
0 0 0 r
s
.83 .24 .1 r
.64531 .60763 m
.68758 .59485 L
s
.64531 .60763 m
.63098 .59772 L
s
.545 .147 .066 r
.43827 .42851 m .41846 .43592 L .41817 .41496 L p F P
0 0 0 r
s
.545 .147 .066 r
.41817 .41496 m .43805 .4074 L .43827 .42851 L p F P
0 0 0 r
s
.917 .268 .115 r
.40769 .59717 m .41666 .59423 L .44341 .60912 L p F P
0 0 0 r
s
.313 .462 .89 r
.54032 .60595 m .54381 .60937 L .5645 .5946 L p F P
0 0 0 r
s
.24 .35 .67 r
.55667 .59828 m
.5703 .58813 L
s
.83 .24 .1 r
.67854 .26777 m
.68641 .26392 L
s
.68641 .26392 m
.72919 .24707 L
s
.917 .268 .115 r
.44957 .60715 m .44341 .60912 L .41666 .59423 L p F P
0 0 0 r
s
.24 .35 .67 r
.42618 .60678 m
.42817 .60855 L
s
.272 .378 .683 r
.59565 .42249 m .60633 .43539 L .60671 .41442 L p F P
0 0 0 r
s
.272 .378 .683 r
.60671 .41442 m .596 .40125 L .59565 .42249 L p F P
0 0 0 r
s
.24 .35 .67 r
.59496 .40232 m
.59596 .40355 L
s
.954 .28 .12 r
.49035 .61512 m .48719 .61612 L .47447 .59919 L p F P
0 0 0 r
s
.954 .28 .12 r
.46821 .60119 m .47447 .59919 L .48719 .61612 L p F P
0 0 0 r
s
.24 .35 .67 r
.46198 .61054 m
.46932 .61724 L
s
.306 .454 .882 r
.5149 .61433 m .5167 .61604 L .53328 .59904 L p F P
0 0 0 r
s
.306 .454 .882 r
.53681 .60251 m .53328 .59904 L .5167 .61604 L p F P
0 0 0 r
s
.24 .35 .67 r
.2075 .32191 m
.22418 .29455 L
s
.44 .115 .052 r
.47853 .392 m .45817 .39975 L .45913 .38154 L p F P
0 0 0 r
s
.83 .24 .1 r
.45862 .40083 m
.45875 .39952 L
s
.46047 .38226 m
.4606 .38097 L
s
.44 .115 .052 r
.45913 .38154 m .47903 .37387 L .47853 .392 L p F P
0 0 0 r
s
.319 .464 .884 r
.57712 .57055 m .58355 .57729 L .60037 .55795 L p F P
0 0 0 r
s
.24 .35 .67 r
.5703 .58813 m
.58225 .57592 L
s
.319 .464 .884 r
.60037 .55795 m .59276 .54971 L .57712 .57055 L p F P
0 0 0 r
s
.24 .35 .67 r
.53639 .30235 m
.55387 .32421 L
s
.55783 .32917 m
.55884 .33044 L
s
.954 .28 .12 r
.49352 .61413 m .49035 .61512 L .48075 .59718 L p F P
0 0 0 r
s
.954 .28 .12 r
.47447 .59919 m .48075 .59718 L .49035 .61512 L p F P
0 0 0 r
s
.83 .24 .1 r
.47475 .59811 m
.47536 .5989 L
s
.838 .241 .105 r
.40364 .57292 m .39204 .57681 L .37029 .55736 L p F P
0 0 0 r
s
.838 .241 .105 r
.37029 .55736 m .38415 .55261 L .40364 .57292 L p F P
0 0 0 r
s
.24 .35 .67 r
.35729 .56583 m
.38336 .58859 L
s
.917 .268 .115 r
.45576 .60517 m .44957 .60715 L .42568 .59129 L p F P
0 0 0 r
s
.83 .24 .1 r
.4482 .60661 m
.44858 .60649 L
s
.917 .268 .115 r
.41666 .59423 m .42568 .59129 L .44957 .60715 L p F P
0 0 0 r
s
.24 .35 .67 r
.2464 .45411 m
.21748 .42855 L
s
.2464 .45411 m
.2518 .47645 L
s
.313 .462 .89 r
.5645 .5946 m .55946 .58949 L .54032 .60595 L p F P
0 0 0 r
s
.318 .465 .89 r
.55946 .58949 m .5645 .5946 L .58355 .57729 L p F P
0 0 0 r
s
.315 .452 .849 r
.59719 .51784 m .60591 .52759 L .61616 .50488 L p F P
0 0 0 r
s
.315 .452 .849 r
.61616 .50488 m .60669 .49397 L .59719 .51784 L p F P
0 0 0 r
s
.306 .454 .882 r
.51308 .6126 m .5149 .61433 L .52973 .59555 L p F P
0 0 0 r
s
.306 .454 .882 r
.53328 .59904 m .52973 .59555 L .5149 .61433 L p F P
0 0 0 r
s
.83 .24 .1 r
.5319 .60714 m
.54826 .62306 L
s
.954 .28 .12 r
.49669 .61313 m .49352 .61413 L .48706 .59516 L p F P
0 0 0 r
s
.954 .28 .12 r
.48075 .59718 m .48706 .59516 L .49352 .61413 L p F P
0 0 0 r
s
.879 .254 .11 r
.42568 .59129 m .41666 .59423 L .39204 .57681 L p F P
0 0 0 r
s
.318 .465 .89 r
.58355 .57729 m .57712 .57055 L .55946 .58949 L p F P
0 0 0 r
s
.626 .173 .077 r
.42094 .45894 m .40193 .46591 L .39887 .44324 L p F P
0 0 0 r
s
.626 .173 .077 r
.39887 .44324 m .41846 .43592 L .42094 .45894 L p F P
0 0 0 r
s
.83 .24 .1 r
.55562 .32454 m
.58767 .312 L
s
.879 .254 .11 r
.39204 .57681 m .40364 .57292 L .42568 .59129 L p F P
0 0 0 r
s
.83 .24 .1 r
.41794 .58484 m
.41897 .5845 L
s
.41897 .5845 m
.42047 .58695 L
s
.313 .462 .89 r
.53681 .60251 m .54032 .60595 L .55946 .58949 L p F P
0 0 0 r
s
.954 .28 .12 r
.49987 .61214 m .49669 .61313 L .49338 .59313 L p F P
0 0 0 r
s
.954 .28 .12 r
.48706 .59516 m .49338 .59313 L .49669 .61313 L p F P
0 0 0 r
s
.794 .227 .099 r
.39813 .54782 m .38415 .55261 L .36779 .53097 L p F P
0 0 0 r
s
.794 .227 .099 r
.36779 .53097 m .38367 .5254 L .39813 .54782 L p F P
0 0 0 r
s
.917 .268 .115 r
.46198 .60318 m .45576 .60517 L .43474 .58832 L p F P
0 0 0 r
s
.83 .24 .1 r
.45451 .60459 m
.45489 .60447 L
s
.917 .268 .115 r
.42568 .59129 m .43474 .58832 L .45576 .60517 L p F P
0 0 0 r
s
.24 .35 .67 r
.40901 .59153 m
.42618 .60678 L
s
.306 .454 .882 r
.51126 .61087 m .51308 .6126 L .52615 .59205 L p F P
0 0 0 r
s
.306 .454 .882 r
.52973 .59555 m .52615 .59205 L .51308 .6126 L p F P
0 0 0 r
s
.83 .24 .1 r
.5156 .61223 m
.5194 .61104 L
s
.24 .35 .67 r
.43008 .2142 m
.40408 .21618 L
s
.40408 .21618 m
.37837 .18565 L
s
.691 .194 .085 r
.40765 .48976 m .38992 .49613 L .38314 .4728 L p F P
0 0 0 r
s
.691 .194 .085 r
.38314 .4728 m .40193 .46591 L .40765 .48976 L p F P
0 0 0 r
s
.954 .28 .12 r
.50305 .61114 m .49987 .61214 L .49974 .5911 L p F P
0 0 0 r
s
.954 .28 .12 r
.49338 .59313 m .49974 .5911 L .49987 .61214 L p F P
0 0 0 r
s
.24 .35 .67 r
.4914 .60119 m
.49862 .608 L
s
.746 .211 .092 r
.39971 .51977 m .38367 .5254 L .37238 .50243 L p F P
0 0 0 r
s
.746 .211 .092 r
.37238 .50243 m .38992 .49613 L .39971 .51977 L p F P
0 0 0 r
s
.83 .24 .1 r
.74208 .5853 m
.7857 .5722 L
s
.74208 .5853 m
.73087 .58176 L
s
.24 .35 .67 r
.32244 .20636 m
.35064 .19352 L
s
.31 .076 .035 r
.54015 .35031 m .51953 .35825 L .51856 .34446 L p F P
0 0 0 r
s
.31 .076 .035 r
.51856 .34446 m .53814 .33684 L .54015 .35031 L p F P
0 0 0 r
s
.83 .24 .1 r
.58914 .61054 m
.63098 .59772 L
s
.57319 .59424 m
.58914 .61054 L
s
.879 .254 .11 r
.43474 .58832 m .42568 .59129 L .40364 .57292 L p F P
0 0 0 r
s
.24 .35 .67 r
.38336 .58859 m
.40901 .59153 L
s
.954 .28 .12 r
.50624 .61014 m .50305 .61114 L .50611 .58906 L p F P
0 0 0 r
s
.954 .28 .12 r
.49974 .5911 m .50611 .58906 L .50305 .61114 L p F P
0 0 0 r
s
.24 .35 .67 r
.49862 .608 m
.50081 .61007 L
s
.306 .454 .882 r
.50944 .60913 m .51126 .61087 L .52255 .58851 L p F P
0 0 0 r
s
.306 .454 .882 r
.52615 .59205 m .52255 .58851 L .51126 .61087 L p F P
0 0 0 r
s
.917 .268 .115 r
.46821 .60119 m .46198 .60318 L .44386 .58534 L p F P
0 0 0 r
s
.24 .35 .67 r
.46198 .61054 m
.4914 .60119 L
s
.83 .24 .1 r
.46084 .60256 m
.46122 .60244 L
s
.917 .268 .115 r
.43474 .58832 m .44386 .58534 L .46198 .60318 L p F P
0 0 0 r
s
.545 .147 .066 r
.45832 .42102 m .43827 .42851 L .43805 .4074 L p F P
0 0 0 r
s
.545 .147 .066 r
.43805 .4074 m .45817 .39975 L .45832 .42102 L p F P
0 0 0 r
s
.83 .24 .1 r
.45818 .401 m
.45862 .40083 L
s
.838 .241 .105 r
.41533 .56901 m .40364 .57292 L .38415 .55261 L p F P
0 0 0 r
s
.838 .241 .105 r
.38415 .55261 m .39813 .54782 L .41533 .56901 L p F P
0 0 0 r
s
.83 .24 .1 r
.40376 .55476 m
.40477 .55441 L
s
.40477 .55441 m
.40657 .55822 L
s
.308 .438 .814 r
.59705 .48287 m .60669 .49397 L .61328 .47047 L p F P
0 0 0 r
s
.308 .438 .814 r
.61328 .47047 m .6031 .45843 L .59705 .48287 L p F P
0 0 0 r
s
.954 .28 .12 r
.50944 .60913 m .50624 .61014 L .51251 .58701 L p F P
0 0 0 r
s
.954 .28 .12 r
.50611 .58906 m .51251 .58701 L .50624 .61014 L p F P
0 0 0 r
s
.24 .35 .67 r
.53639 .30235 m
.52107 .28689 L
s
.52107 .28689 m
.49773 .25776 L
s
.313 .462 .89 r
.53328 .59904 m .53681 .60251 L .55437 .58433 L p F P
0 0 0 r
s
.24 .35 .67 r
.53717 .60214 m
.53727 .60224 L
s
.313 .462 .89 r
.55946 .58949 m .55437 .58433 L .53681 .60251 L p F P
0 0 0 r
s
.319 .46 .871 r
.58504 .54134 m .59276 .54971 L .60591 .52759 L p F P
0 0 0 r
s
.319 .46 .871 r
.60591 .52759 m .59719 .51784 L .58504 .54134 L p F P
0 0 0 r
s
.879 .254 .11 r
.40364 .57292 m .41533 .56901 L .43474 .58832 L p F P
0 0 0 r
s
.44 .115 .052 r
.49914 .38417 m .47853 .392 L .47903 .37387 L p F P
0 0 0 r
s
.44 .115 .052 r
.47903 .37387 m .49916 .36611 L .49914 .38417 L p F P
0 0 0 r
s
.185 .244 .417 r
.56101 .34227 m .57217 .35613 L .56857 .34243 L p F P
0 0 0 r
s
.185 .244 .417 r
.56857 .34243 m .55794 .32912 L .56101 .34227 L p F P
0 0 0 r
s
.318 .465 .89 r
.55437 .58433 m .55946 .58949 L .57712 .57055 L p F P
0 0 0 r
s
.954 .28 .12 r
.51251 .58701 m .51893 .58496 L .50944 .60913 L p F P
0 0 0 r
s
.306 .454 .882 r
.52255 .58851 m .51893 .58496 L .50944 .60913 L p F P
0 0 0 r
s
.83 .24 .1 r
.5194 .61104 m
.5319 .60714 L
s
.24 .35 .67 r
.33545 .55711 m
.30823 .53356 L
s
.33545 .55711 m
.35729 .56583 L
s
.917 .268 .115 r
.47447 .59919 m .46821 .60119 L .45302 .58234 L p F P
0 0 0 r
s
.83 .24 .1 r
.4672 .60053 m
.46758 .60041 L
s
.47358 .59849 m
.47475 .59811 L
s
.917 .268 .115 r
.44386 .58534 m .45302 .58234 L .46821 .60119 L p F P
0 0 0 r
s
.24 .35 .67 r
.19544 .3496 m
.2075 .32191 L
s
.879 .254 .11 r
.44386 .58534 m .43474 .58832 L .41533 .56901 L p F P
0 0 0 r
s
.24 .35 .67 r
.46041 .60911 m
.46198 .61054 L
s
.83 .24 .1 r
.6299 .29548 m
.63602 .28451 L
s
.63602 .28451 m
.67854 .26777 L
s
.83037 .55878 m
.8377 .55592 L
s
.794 .227 .099 r
.41223 .54299 m .39813 .54782 L .38367 .5254 L p F P
0 0 0 r
s
.794 .227 .099 r
.38367 .5254 m .39971 .51977 L .41223 .54299 L p F P
0 0 0 r
s
.83 .24 .1 r
.51537 .5851 m
.51597 .58591 L
s
.319 .464 .884 r
.57062 .56373 m .57712 .57055 L .59276 .54971 L p F P
0 0 0 r
s
.319 .464 .884 r
.59276 .54971 m .58504 .54134 L .57062 .56373 L p F P
0 0 0 r
s
.626 .173 .077 r
.44016 .45189 m .42094 .45894 L .41846 .43592 L p F P
0 0 0 r
s
.83 .24 .1 r
.41965 .43548 m
.41969 .43683 L
s
.626 .173 .077 r
.41846 .43592 m .43827 .42851 L .44016 .45189 L p F P
0 0 0 r
s
.318 .465 .89 r
.57712 .57055 m .57062 .56373 L .55437 .58433 L p F P
0 0 0 r
s
.24 .35 .67 r
.21827 .40341 m
.18856 .37662 L
s
.21827 .40341 m
.21748 .42855 L
s
.294 .415 .762 r
.59271 .44616 m .6031 .45843 L .60633 .43539 L p F P
0 0 0 r
s
.294 .415 .762 r
.60633 .43539 m .59565 .42249 L .59271 .44616 L p F P
0 0 0 r
s
.917 .268 .115 r
.48075 .59718 m .47447 .59919 L .46224 .57933 L p F P
0 0 0 r
s
.917 .268 .115 r
.45302 .58234 m .46224 .57933 L .47447 .59919 L p F P
0 0 0 r
s
.24 .35 .67 r
.43744 .58814 m
.46041 .60911 L
s
.313 .462 .89 r
.52973 .59555 m .53328 .59904 L .54923 .57912 L p F P
0 0 0 r
s
.83 .24 .1 r
.52323 .59559 m
.5319 .60714 L
s
.52148 .59325 m
.52323 .59559 L
s
.24 .35 .67 r
.5336 .59864 m
.53371 .59874 L
s
.313 .462 .89 r
.55437 .58433 m .54923 .57912 L .53328 .59904 L p F P
0 0 0 r
s
.83 .24 .1 r
.40196 .54651 m
.40477 .55441 L
s
.746 .211 .092 r
.4159 .51409 m .39971 .51977 L .38992 .49613 L p F P
0 0 0 r
s
.746 .211 .092 r
.38992 .49613 m .40765 .48976 L .4159 .51409 L p F P
0 0 0 r
s
.691 .194 .085 r
.42558 .48333 m .40765 .48976 L .40193 .46591 L p F P
0 0 0 r
s
.691 .194 .085 r
.40193 .46591 m .42094 .45894 L .42558 .48333 L p F P
0 0 0 r
s
.235 .32 .564 r
.57389 .3741 m .58506 .38782 L .58309 .36972 L p F P
0 0 0 r
s
.235 .32 .564 r
.58309 .36972 m .57217 .35613 L .57389 .3741 L p F P
0 0 0 r
s
.879 .254 .11 r
.41533 .56901 m .4271 .56508 L .44386 .58534 L p F P
0 0 0 r
s
.838 .241 .105 r
.4271 .56508 m .41533 .56901 L .39813 .54782 L p F P
0 0 0 r
s
.838 .241 .105 r
.39813 .54782 m .41223 .54299 L .4271 .56508 L p F P
0 0 0 r
s
.272 .378 .683 r
.58475 .40933 m .59565 .42249 L .596 .40125 L p F P
0 0 0 r
s
.272 .378 .683 r
.596 .40125 m .58506 .38782 L .58475 .40933 L p F P
0 0 0 r
s
.879 .254 .11 r
.45302 .58234 m .44386 .58534 L .4271 .56508 L p F P
0 0 0 r
s
.31 .076 .035 r
.56101 .34227 m .54015 .35031 L .53814 .33684 L p F P
0 0 0 r
s
.31 .076 .035 r
.53814 .33684 m .55794 .32912 L .56101 .34227 L p F P
0 0 0 r
s
.917 .268 .115 r
.48706 .59516 m .48075 .59718 L .47151 .5763 L p F P
0 0 0 r
s
.83 .24 .1 r
.47998 .59644 m
.48037 .59631 L
s
.917 .268 .115 r
.46224 .57933 m .47151 .5763 L .48075 .59718 L p F P
0 0 0 r
s
.24 .35 .67 r
.49773 .25776 m
.47791 .248 L
s
.47791 .248 m
.45354 .2179 L
s
.315 .452 .849 r
.58833 .50793 m .59719 .51784 L .60669 .49397 L p F P
0 0 0 r
s
.315 .452 .849 r
.60669 .49397 m .59705 .48287 L .58833 .50793 L p F P
0 0 0 r
s
.83 .24 .1 r
.68758 .59485 m
.73087 .58176 L
s
.68758 .59485 m
.67383 .58459 L
s
.318 .465 .89 r
.54923 .57912 m .55437 .58433 L .57062 .56373 L p F P
0 0 0 r
s
.545 .147 .066 r
.47861 .41343 m .45832 .42102 L .45817 .39975 L p F P
0 0 0 r
s
.545 .147 .066 r
.45817 .39975 m .47853 .392 L .47861 .41343 L p F P
0 0 0 r
s
.83 .24 .1 r
.72919 .24707 m
.72208 .25064 L
s
.24 .35 .67 r
.29131 .51954 m
.26303 .49508 L
s
.29131 .51954 m
.30823 .53356 L
s
.44 .115 .052 r
.52 .37624 m .49914 .38417 L .49916 .36611 L p F P
0 0 0 r
s
.83 .24 .1 r
.49915 .38544 m
.49925 .38413 L
s
.50057 .36679 m
.50066 .36553 L
s
.44 .115 .052 r
.49916 .36611 m .51953 .35825 L .52 .37624 L p F P
0 0 0 r
s
.313 .462 .89 r
.52615 .59205 m .52973 .59555 L .54404 .57386 L p F P
0 0 0 r
s
.24 .35 .67 r
.53002 .59512 m
.53012 .59522 L
s
.313 .462 .89 r
.54923 .57912 m .54404 .57386 L .52973 .59555 L p F P
0 0 0 r
s
.83 .24 .1 r
.5319 .60714 m
.57319 .59424 L
s
.917 .268 .115 r
.49338 .59313 m .48706 .59516 L .48082 .57326 L p F P
0 0 0 r
s
.83 .24 .1 r
.48641 .59438 m
.4868 .59425 L
s
.917 .268 .115 r
.47151 .5763 m .48082 .57326 L .48706 .59516 L p F P
0 0 0 r
s
.794 .227 .099 r
.42645 .53812 m .41223 .54299 L .39971 .51977 L p F P
0 0 0 r
s
.794 .227 .099 r
.39971 .51977 m .4159 .51409 L .42645 .53812 L p F P
0 0 0 r
s
.24 .35 .67 r
.35064 .19352 m
.37837 .18565 L
s
.879 .254 .11 r
.46224 .57933 m .45302 .58234 L .43895 .56111 L p F P
0 0 0 r
s
.879 .254 .11 r
.4271 .56508 m .43895 .56111 L .45302 .58234 L p F P
0 0 0 r
s
.838 .241 .105 r
.43895 .56111 m .4271 .56508 L .41223 .54299 L p F P
0 0 0 r
s
.24 .35 .67 r
.4914 .60119 m
.50676 .59315 L
s
.50676 .59315 m
.50986 .59152 L
s
.838 .241 .105 r
.41223 .54299 m .42645 .53812 L .43895 .56111 L p F P
0 0 0 r
s
.24 .35 .67 r
.40901 .59153 m
.38313 .56852 L
s
.40901 .59153 m
.43744 .58814 L
s
.626 .173 .077 r
.4596 .44476 m .44016 .45189 L .43827 .42851 L p F P
0 0 0 r
s
.626 .173 .077 r
.43827 .42851 m .45832 .42102 L .4596 .44476 L p F P
0 0 0 r
s
.319 .46 .871 r
.57721 .53285 m .58504 .54134 L .59719 .51784 L p F P
0 0 0 r
s
.319 .46 .871 r
.59719 .51784 m .58833 .50793 L .57721 .53285 L p F P
0 0 0 r
s
.318 .465 .89 r
.57062 .56373 m .56403 .55683 L .54923 .57912 L p F P
0 0 0 r
s
.319 .464 .884 r
.56403 .55683 m .57062 .56373 L .58504 .54134 L p F P
0 0 0 r
s
.83 .24 .1 r
.58378 .32975 m
.58767 .312 L
s
.58767 .312 m
.6299 .29548 L
s
.917 .268 .115 r
.49974 .5911 m .49338 .59313 L .49019 .57019 L p F P
0 0 0 r
s
.83 .24 .1 r
.49286 .59231 m
.49325 .59219 L
s
.917 .268 .115 r
.48082 .57326 m .49019 .57019 L .49338 .59313 L p F P
0 0 0 r
s
.746 .211 .092 r
.43226 .50835 m .4159 .51409 L .40765 .48976 L p F P
0 0 0 r
s
.746 .211 .092 r
.40765 .48976 m .42558 .48333 L .43226 .50835 L p F P
0 0 0 r
s
.691 .194 .085 r
.44369 .47683 m .42558 .48333 L .42094 .45894 L p F P
0 0 0 r
s
.83 .24 .1 r
.4221 .45851 m
.42232 .46003 L
s
.691 .194 .085 r
.42094 .45894 m .44016 .45189 L .44369 .47683 L p F P
0 0 0 r
s
.319 .464 .884 r
.58504 .54134 m .57721 .53285 L .56403 .55683 L p F P
0 0 0 r
s
.313 .462 .89 r
.52255 .58851 m .52615 .59205 L .5388 .56855 L p F P
0 0 0 r
s
.24 .35 .67 r
.52641 .59157 m
.52651 .59168 L
s
.313 .462 .89 r
.54404 .57386 m .5388 .56855 L .52615 .59205 L p F P
0 0 0 r
s
.308 .438 .814 r
.58722 .47155 m .59705 .48287 L .6031 .45843 L p F P
0 0 0 r
s
.308 .438 .814 r
.6031 .45843 m .59271 .44616 L .58722 .47155 L p F P
0 0 0 r
s
.879 .254 .11 r
.47151 .5763 m .46224 .57933 L .45089 .55712 L p F P
0 0 0 r
s
.24 .35 .67 r
.46726 .5784 m
.48986 .59973 L
s
.48986 .59973 m
.4914 .60119 L
s
.879 .254 .11 r
.43895 .56111 m .45089 .55712 L .46224 .57933 L p F P
0 0 0 r
s
.83 .24 .1 r
.7857 .5722 m
.83037 .55878 L
s
.7857 .5722 m
.7752 .56836 L
s
.318 .465 .89 r
.54404 .57386 m .54923 .57912 L .56403 .55683 L p F P
0 0 0 r
s
.24 .35 .67 r
.54636 .3228 m
.55747 .33662 L
s
.55747 .33662 m
.5589 .3384 L
s
.917 .268 .115 r
.50611 .58906 m .49974 .5911 L .49961 .56712 L p F P
0 0 0 r
s
.83 .24 .1 r
.49934 .59024 m
.49973 .59011 L
s
.917 .268 .115 r
.49019 .57019 m .49961 .56712 L .49974 .5911 L p F P
0 0 0 r
s
.83 .24 .1 r
.63098 .59772 m
.67383 .58459 L
s
.63098 .59772 m
.61549 .58103 L
s
.838 .241 .105 r
.45089 .55712 m .43895 .56111 L .42645 .53812 L p F P
0 0 0 r
s
.24 .35 .67 r
.45354 .2179 m
.43008 .2142 L
s
.43008 .2142 m
.40456 .18321 L
s
.2518 .47645 m
.22255 .45096 L
s
.2518 .47645 m
.26303 .49508 L
s
.18856 .37662 m
.19544 .3496 L
s
.545 .147 .066 r
.49914 .40575 m .47861 .41343 L .47853 .392 L p F P
0 0 0 r
s
.545 .147 .066 r
.47853 .392 m .49914 .38417 L .49914 .40575 L p F P
0 0 0 r
s
.83 .24 .1 r
.49914 .38544 m
.49915 .38544 L
s
.794 .227 .099 r
.44078 .53321 m .42645 .53812 L .4159 .51409 L p F P
0 0 0 r
s
.794 .227 .099 r
.4159 .51409 m .43226 .50835 L .44078 .53321 L p F P
0 0 0 r
s
.44 .115 .052 r
.54111 .36821 m .52 .37624 L .51953 .35825 L p F P
0 0 0 r
s
.44 .115 .052 r
.51953 .35825 m .54015 .35031 L .54111 .36821 L p F P
0 0 0 r
s
.917 .268 .115 r
.51251 .58701 m .50611 .58906 L .50908 .56402 L p F P
0 0 0 r
s
.83 .24 .1 r
.50584 .58816 m
.50623 .58803 L
s
.51237 .58607 m
.51537 .5851 L
s
.917 .268 .115 r
.49961 .56712 m .50908 .56402 L .50611 .58906 L p F P
0 0 0 r
s
.838 .241 .105 r
.42645 .53812 m .44078 .53321 L .45089 .55712 L p F P
0 0 0 r
s
.879 .254 .11 r
.48082 .57326 m .47151 .5763 L .46291 .55309 L p F P
0 0 0 r
s
.879 .254 .11 r
.45089 .55712 m .46291 .55309 L .47151 .5763 L p F P
0 0 0 r
s
.313 .462 .89 r
.51893 .58496 m .52255 .58851 L .53352 .56319 L p F P
0 0 0 r
s
.24 .35 .67 r
.52277 .58801 m
.52288 .58811 L
s
.313 .462 .89 r
.5388 .56855 m .53352 .56319 L .52255 .58851 L p F P
0 0 0 r
s
.294 .415 .762 r
.58212 .43364 m .59271 .44616 L .59565 .42249 L p F P
0 0 0 r
s
.294 .415 .762 r
.59565 .42249 m .58475 .40933 L .58212 .43364 L p F P
0 0 0 r
s
.83 .24 .1 r
.67316 .27856 m
.67854 .26777 L
s
.67854 .26777 m
.72208 .25064 L
s
.5606 .33871 m
.58378 .32975 L
s
.235 .32 .564 r
.56248 .36009 m .57389 .3741 L .57217 .35613 L p F P
0 0 0 r
s
.24 .35 .67 r
.56921 .35246 m
.56997 .35703 L
s
.57257 .37247 m
.57307 .37549 L
s
.235 .32 .564 r
.57217 .35613 m .56101 .34227 L .56248 .36009 L p F P
0 0 0 r
s
.83 .24 .1 r
.57319 .59424 m
.61549 .58103 L
s
.746 .211 .092 r
.44877 .50255 m .43226 .50835 L .42558 .48333 L p F P
0 0 0 r
s
.83 .24 .1 r
.42656 .48297 m
.42694 .48446 L
s
.43296 .5081 m
.433 .50826 L
s
.43231 .5085 m
.433 .50826 L
s
.746 .211 .092 r
.42558 .48333 m .44369 .47683 L .44877 .50255 L p F P
0 0 0 r
s
.917 .268 .115 r
.51893 .58496 m .51251 .58701 L .5186 .56091 L p F P
0 0 0 r
s
.83 .24 .1 r
.51892 .58397 m
.51978 .58369 L
s
.24 .35 .67 r
.51892 .58422 m
.51923 .58452 L
s
.917 .268 .115 r
.50908 .56402 m .5186 .56091 L .51251 .58701 L p F P
0 0 0 r
s
.24 .35 .67 r
.5152 .58057 m
.51658 .58192 L
s
.626 .173 .077 r
.47927 .43754 m .4596 .44476 L .45832 .42102 L p F P
0 0 0 r
s
.83 .24 .1 r
.45956 .42055 m
.45963 .42205 L
s
.626 .173 .077 r
.45832 .42102 m .47861 .41343 L .47927 .43754 L p F P
0 0 0 r
s
.838 .241 .105 r
.46291 .55309 m .45089 .55712 L .44078 .53321 L p F P
0 0 0 r
s
.315 .452 .849 r
.57932 .49786 m .58833 .50793 L .59705 .48287 L p F P
0 0 0 r
s
.315 .452 .849 r
.59705 .48287 m .58722 .47155 L .57932 .49786 L p F P
0 0 0 r
s
.272 .378 .683 r
.57362 .39588 m .58475 .40933 L .58506 .38782 L p F P
0 0 0 r
s
.272 .378 .683 r
.58506 .38782 m .57389 .3741 L .57362 .39588 L p F P
0 0 0 r
s
.24 .35 .67 r
.57307 .37549 m
.57386 .37645 L
s
.318 .465 .89 r
.56403 .55683 m .55737 .54984 L .54404 .57386 L p F P
0 0 0 r
s
.319 .464 .884 r
.55737 .54984 m .56403 .55683 L .57721 .53285 L p F P
0 0 0 r
s
.318 .465 .89 r
.5388 .56855 m .54404 .57386 L .55737 .54984 L p F P
0 0 0 r
s
.83 .24 .1 r
.55697 .57178 m
.57319 .59424 L
s
.691 .194 .085 r
.462 .47025 m .44369 .47683 L .44016 .45189 L p F P
0 0 0 r
s
.691 .194 .085 r
.44016 .45189 m .4596 .44476 L .462 .47025 L p F P
0 0 0 r
s
.83 .24 .1 r
.433 .50826 m
.44239 .53465 L
s
.879 .254 .11 r
.49019 .57019 m .48082 .57326 L .47502 .54904 L p F P
0 0 0 r
s
.879 .254 .11 r
.46291 .55309 m .47502 .54904 L .48082 .57326 L p F P
0 0 0 r
s
.24 .35 .67 r
.54636 .3228 m
.53639 .30235 L
s
.53639 .30235 m
.513 .27307 L
s
.35729 .56583 m
.33011 .54211 L
s
.35729 .56583 m
.38313 .56852 L
s
.917 .268 .115 r
.5186 .56091 m .52818 .55777 L .51893 .58496 L p F P
0 0 0 r
s
.313 .462 .89 r
.53352 .56319 m .52818 .55777 L .51893 .58496 L p F P
0 0 0 r
s
.83 .24 .1 r
.52252 .58281 m
.52495 .58204 L
s
.52495 .58204 m
.5283 .58096 L
s
.5283 .58096 m
.55697 .57178 L
s
.24 .35 .67 r
.21748 .42855 m
.18734 .40191 L
s
.21748 .42855 m
.22255 .45096 L
s
.794 .227 .099 r
.45525 .52825 m .44078 .53321 L .43226 .50835 L p F P
0 0 0 r
s
.794 .227 .099 r
.43226 .50835 m .44877 .50255 L .45525 .52825 L p F P
0 0 0 r
s
.838 .241 .105 r
.44078 .53321 m .45525 .52825 L .46291 .55309 L p F P
0 0 0 r
s
.319 .46 .871 r
.56926 .52424 m .57721 .53285 L .58833 .50793 L p F P
0 0 0 r
s
.319 .46 .871 r
.58833 .50793 m .57932 .49786 L .56926 .52424 L p F P
0 0 0 r
s
.319 .464 .884 r
.57721 .53285 m .56926 .52424 L .55737 .54984 L p F P
0 0 0 r
s
.83 .24 .1 r
.73087 .58176 m
.7752 .56836 L
s
.73087 .58176 m
.71773 .57115 L
s
.545 .147 .066 r
.51993 .39798 m .49914 .40575 L .49914 .38417 L p F P
0 0 0 r
s
.545 .147 .066 r
.49914 .38417 m .52 .37624 L .51993 .39798 L p F P
0 0 0 r
s
.838 .241 .105 r
.47502 .54904 m .46291 .55309 L .45525 .52825 L p F P
0 0 0 r
s
.879 .254 .11 r
.49961 .56712 m .49019 .57019 L .48721 .54496 L p F P
0 0 0 r
s
.24 .35 .67 r
.5133 .57871 m
.5152 .58057 L
s
.879 .254 .11 r
.47502 .54904 m .48721 .54496 L .49019 .57019 L p F P
0 0 0 r
s
.44 .115 .052 r
.56248 .36009 m .54111 .36821 L .54015 .35031 L p F P
0 0 0 r
s
.83 .24 .1 r
.54161 .35095 m
.54168 .34972 L
s
.44 .115 .052 r
.54015 .35031 m .56101 .34227 L .56248 .36009 L p F P
0 0 0 r
s
.24 .35 .67 r
.37837 .18565 m
.40456 .18321 L
s
.746 .211 .092 r
.46544 .4967 m .44877 .50255 L .44369 .47683 L p F P
0 0 0 r
s
.746 .211 .092 r
.44369 .47683 m .462 .47025 L .46544 .4967 L p F P
0 0 0 r
s
.318 .465 .89 r
.53352 .56319 m .5388 .56855 L .55062 .54277 L p F P
0 0 0 r
s
.318 .465 .89 r
.55737 .54984 m .55062 .54277 L .5388 .56855 L p F P
0 0 0 r
s
.24 .35 .67 r
.43744 .58814 m
.41185 .5648 L
s
.43744 .58814 m
.46726 .5784 L
s
.308 .438 .814 r
.57721 .46002 m .58722 .47155 L .59271 .44616 L p F P
0 0 0 r
s
.308 .438 .814 r
.59271 .44616 m .58212 .43364 L .57721 .46002 L p F P
0 0 0 r
s
.626 .173 .077 r
.49917 .43024 m .47927 .43754 L .47861 .41343 L p F P
0 0 0 r
s
.626 .173 .077 r
.47861 .41343 m .49914 .40575 L .49917 .43024 L p F P
0 0 0 r
s
.83 .24 .1 r
.6267 .31316 m
.6299 .29548 L
s
.6299 .29548 m
.67316 .27856 L
s
.24 .35 .67 r
.513 .27307 m
.49773 .25776 L
s
.49773 .25776 m
.47339 .22739 L
s
.879 .254 .11 r
.50908 .56402 m .49961 .56712 L .49949 .54086 L p F P
0 0 0 r
s
.879 .254 .11 r
.48721 .54496 m .49949 .54086 L .49961 .56712 L p F P
0 0 0 r
s
.691 .194 .085 r
.48051 .46361 m .462 .47025 L .4596 .44476 L p F P
0 0 0 r
s
.83 .24 .1 r
.46231 .44376 m
.46296 .44778 L
s
.691 .194 .085 r
.4596 .44476 m .47927 .43754 L .48051 .46361 L p F P
0 0 0 r
s
.319 .464 .884 r
.55062 .54277 m .55737 .54984 L .56926 .52424 L p F P
0 0 0 r
s
.838 .241 .105 r
.45525 .52825 m .46983 .52325 L .47502 .54904 L p F P
0 0 0 r
s
.794 .227 .099 r
.46983 .52325 m .45525 .52825 L .44877 .50255 L p F P
0 0 0 r
s
.794 .227 .099 r
.44877 .50255 m .46544 .4967 L .46983 .52325 L p F P
0 0 0 r
s
.838 .241 .105 r
.48721 .54496 m .47502 .54904 L .46983 .52325 L p F P
0 0 0 r
s
.24 .35 .67 r
.30823 .53356 m
.27985 .50901 L
s
.30823 .53356 m
.33011 .54211 L
s
.83 .24 .1 r
.82062 .55462 m
.83037 .55878 L
s
.67383 .58459 m
.71773 .57115 L
s
.67383 .58459 m
.65881 .5675 L
s
.24 .35 .67 r
.18734 .40191 m
.18856 .37662 L
s
.294 .415 .762 r
.57131 .42087 m .58212 .43364 L .58475 .40933 L p F P
0 0 0 r
s
.294 .415 .762 r
.58475 .40933 m .57362 .39588 L .57131 .42087 L p F P
0 0 0 r
s
.545 .147 .066 r
.54096 .39012 m .51993 .39798 L .52 .37624 L p F P
0 0 0 r
s
.545 .147 .066 r
.52 .37624 m .54111 .36821 L .54096 .39012 L p F P
0 0 0 r
s
.879 .254 .11 r
.5186 .56091 m .50908 .56402 L .51186 .53672 L p F P
0 0 0 r
s
.879 .254 .11 r
.49949 .54086 m .51186 .53672 L .50908 .56402 L p F P
0 0 0 r
s
.24 .35 .67 r
.49695 .56264 m
.5133 .57871 L
s
.315 .452 .849 r
.57016 .4876 m .57932 .49786 L .58722 .47155 L p F P
0 0 0 r
s
.315 .452 .849 r
.58722 .47155 m .57721 .46002 L .57016 .4876 L p F P
0 0 0 r
s
.24 .35 .67 r
.55026 .34751 m
.55893 .35815 L
s
.318 .465 .89 r
.52818 .55777 m .53352 .56319 L .54378 .5356 L p F P
0 0 0 r
s
.318 .465 .89 r
.55062 .54277 m .54378 .5356 L .53352 .56319 L p F P
0 0 0 r
s
.319 .464 .884 r
.56926 .52424 m .56119 .51549 L .55062 .54277 L p F P
0 0 0 r
s
.319 .46 .871 r
.56119 .51549 m .56926 .52424 L .57932 .49786 L p F P
0 0 0 r
s
.746 .211 .092 r
.48228 .49079 m .46544 .4967 L .462 .47025 L p F P
0 0 0 r
s
.746 .211 .092 r
.462 .47025 m .48051 .46361 L .48228 .49079 L p F P
0 0 0 r
s
.838 .241 .105 r
.49949 .54086 m .48721 .54496 L .48454 .51821 L p F P
0 0 0 r
s
.838 .241 .105 r
.46983 .52325 m .48454 .51821 L .48721 .54496 L p F P
0 0 0 r
s
.272 .378 .683 r
.56225 .38215 m .57362 .39588 L .57389 .3741 L p F P
0 0 0 r
s
.272 .378 .683 r
.57389 .3741 m .56248 .36009 L .56225 .38215 L p F P
0 0 0 r
s
.794 .227 .099 r
.48454 .51821 m .46983 .52325 L .46544 .4967 L p F P
0 0 0 r
s
.319 .46 .871 r
.57932 .49786 m .57016 .4876 L .56119 .51549 L p F P
0 0 0 r
s
.83 .24 .1 r
.72208 .25064 m
.71749 .26123 L
s
.24 .35 .67 r
.47339 .22739 m
.45354 .2179 L
s
.45354 .2179 m
.42814 .18652 L
s
.83 .24 .1 r
.58317 .35352 m
.58378 .32975 L
s
.58378 .32975 m
.6267 .31316 L
s
.61549 .58103 m
.65881 .5675 L
s
.61549 .58103 m
.59959 .55814 L
s
.55697 .57178 m
.59959 .55814 L
s
.626 .173 .077 r
.5193 .42286 m .49917 .43024 L .49914 .40575 L p F P
0 0 0 r
s
.83 .24 .1 r
.50042 .40527 m
.50053 .40692 L
s
.626 .173 .077 r
.49914 .40575 m .51993 .39798 L .5193 .42286 L p F P
0 0 0 r
s
.879 .254 .11 r
.52818 .55777 m .5186 .56091 L .52432 .53255 L p F P
0 0 0 r
s
.879 .254 .11 r
.51186 .53672 m .52432 .53255 L .5186 .56091 L p F P
0 0 0 r
s
.794 .227 .099 r
.46544 .4967 m .48228 .49079 L .48454 .51821 L p F P
0 0 0 r
s
.691 .194 .085 r
.49922 .45689 m .48051 .46361 L .47927 .43754 L p F P
0 0 0 r
s
.691 .194 .085 r
.47927 .43754 m .49917 .43024 L .49922 .45689 L p F P
0 0 0 r
s
.24 .35 .67 r
.26303 .49508 m
.23354 .46958 L
s
.26303 .49508 m
.27985 .50901 L
s
.319 .464 .884 r
.54378 .5356 m .55062 .54277 L .56119 .51549 L p F P
0 0 0 r
s
.24 .35 .67 r
.46726 .5784 m
.44208 .55464 L
s
.46726 .5784 m
.49695 .56264 L
s
.83 .24 .1 r
.56329 .36108 m
.58317 .35352 L
s
.838 .241 .105 r
.51186 .53672 m .49949 .54086 L .49938 .51313 L p F P
0 0 0 r
s
.838 .241 .105 r
.48454 .51821 m .49938 .51313 L .49949 .54086 L p F P
0 0 0 r
s
.24 .35 .67 r
.38313 .56852 m
.35614 .54453 L
s
.38313 .56852 m
.41185 .5648 L
s
.879 .254 .11 r
.52432 .53255 m .53686 .52835 L .52818 .55777 L p F P
0 0 0 r
s
.24 .35 .67 r
.52492 .54161 m
.52747 .54422 L
s
.318 .465 .89 r
.54378 .5356 m .53686 .52835 L .52818 .55777 L p F P
0 0 0 r
s
.83 .24 .1 r
.53679 .54566 m
.54134 .54416 L
s
.53287 .54696 m
.53679 .54566 L
s
.24 .35 .67 r
.52747 .54422 m
.52965 .54646 L
s
.83 .24 .1 r
.54134 .54416 m
.55697 .57178 L
s
.7752 .56836 m
.82062 .55462 L
s
.7752 .56836 m
.7627 .55737 L
s
.794 .227 .099 r
.49938 .51313 m .48454 .51821 L .48228 .49079 L p F P
0 0 0 r
s
.545 .147 .066 r
.56225 .38215 m .54096 .39012 L .54111 .36821 L p F P
0 0 0 r
s
.545 .147 .066 r
.54111 .36821 m .56248 .36009 L .56225 .38215 L p F P
0 0 0 r
s
.24 .35 .67 r
.55893 .35815 m
.56098 .36066 L
s
.308 .438 .814 r
.56701 .44826 m .57721 .46002 L .58212 .43364 L p F P
0 0 0 r
s
.308 .438 .814 r
.58212 .43364 m .57131 .42087 L .56701 .44826 L p F P
0 0 0 r
s
.746 .211 .092 r
.49929 .48483 m .48228 .49079 L .48051 .46361 L p F P
0 0 0 r
s
.746 .211 .092 r
.48051 .46361 m .49922 .45689 L .49929 .48483 L p F P
0 0 0 r
s
.24 .35 .67 r
.54636 .3228 m
.55026 .34751 L
s
.54636 .3228 m
.52282 .2935 L
s
.794 .227 .099 r
.48228 .49079 m .49929 .48483 L .49938 .51313 L p F P
0 0 0 r
s
.24 .35 .67 r
.40456 .18321 m
.42814 .18652 L
s
.22255 .45096 m
.19204 .42439 L
s
.22255 .45096 m
.23354 .46958 L
s
.319 .464 .884 r
.56119 .51549 m .553 .50662 L .54378 .5356 L p F P
0 0 0 r
s
.319 .46 .871 r
.553 .50662 m .56119 .51549 L .57016 .4876 L p F P
0 0 0 r
s
.626 .173 .077 r
.53967 .41539 m .5193 .42286 L .51993 .39798 L p F P
0 0 0 r
s
.626 .173 .077 r
.51993 .39798 m .54096 .39012 L .53967 .41539 L p F P
0 0 0 r
s
.838 .241 .105 r
.52432 .53255 m .51186 .53672 L .51435 .508 L p F P
0 0 0 r
s
.838 .241 .105 r
.49938 .51313 m .51435 .508 L .51186 .53672 L p F P
0 0 0 r
s
.691 .194 .085 r
.51814 .4501 m .49922 .45689 L .49917 .43024 L p F P
0 0 0 r
s
.691 .194 .085 r
.49917 .43024 m .5193 .42286 L .51814 .4501 L p F P
0 0 0 r
s
.83 .24 .1 r
.67069 .29616 m
.67316 .27856 L
s
.67316 .27856 m
.71749 .26123 L
s
.319 .464 .884 r
.53686 .52835 m .54378 .5356 L .553 .50662 L p F P
0 0 0 r
s
.315 .452 .849 r
.56083 .47717 m .57016 .4876 L .57721 .46002 L p F P
0 0 0 r
s
.315 .452 .849 r
.57721 .46002 m .56701 .44826 L .56083 .47717 L p F P
0 0 0 r
s
.294 .415 .762 r
.56028 .40783 m .57131 .42087 L .57362 .39588 L p F P
0 0 0 r
s
.294 .415 .762 r
.57362 .39588 m .56225 .38215 L .56028 .40783 L p F P
0 0 0 r
s
.794 .227 .099 r
.51435 .508 m .49938 .51313 L .49929 .48483 L p F P
0 0 0 r
s
.319 .46 .871 r
.57016 .4876 m .56083 .47717 L .553 .50662 L p F P
0 0 0 r
s
.24 .35 .67 r
.49695 .56264 m
.47225 .5384 L
s
.49695 .56264 m
.52492 .54161 L
s
.83 .24 .1 r
.54134 .54416 m
.58414 .53006 L
s
.53792 .53658 m
.54134 .54416 L
s
.5373 .53521 m
.53792 .53658 L
s
.71773 .57115 m
.7627 .55737 L
s
.71773 .57115 m
.7032 .55363 L
s
.746 .211 .092 r
.51647 .4788 m .49929 .48483 L .49922 .45689 L p F P
0 0 0 r
s
.746 .211 .092 r
.49922 .45689 m .51814 .4501 L .51647 .4788 L p F P
0 0 0 r
s
.838 .241 .105 r
.53686 .52835 m .52432 .53255 L .52945 .50282 L p F P
0 0 0 r
s
.838 .241 .105 r
.51435 .508 m .52945 .50282 L .52432 .53255 L p F P
0 0 0 r
s
.794 .227 .099 r
.49929 .48483 m .51647 .4788 L .51435 .508 L p F P
0 0 0 r
s
.24 .35 .67 r
.52492 .54161 m
.53201 .53438 L
s
.52282 .2935 m
.513 .27307 L
s
.513 .27307 m
.4886 .24253 L
s
.33011 .54211 m
.30177 .51737 L
s
.33011 .54211 m
.35614 .54453 L
s
.50077 .51684 m
.52492 .54161 L
s
.19204 .42439 m
.18734 .40191 L
s
.83 .24 .1 r
.62675 .33698 m
.6267 .31316 L
s
.6267 .31316 m
.67069 .29616 L
s
.65881 .5675 m
.7032 .55363 L
s
.65881 .5675 m
.64326 .54415 L
s
.691 .194 .085 r
.53726 .44323 m .51814 .4501 L .5193 .42286 L p F P
0 0 0 r
s
.691 .194 .085 r
.5193 .42286 m .53967 .41539 L .53726 .44323 L p F P
0 0 0 r
s
.794 .227 .099 r
.52945 .50282 m .51435 .508 L .51647 .4788 L p F P
0 0 0 r
s
.83 .24 .1 r
.59959 .55814 m
.64326 .54415 L
s
.59959 .55814 m
.58414 .53006 L
s
.626 .173 .077 r
.56028 .40783 m .53967 .41539 L .54096 .39012 L p F P
0 0 0 r
s
.83 .24 .1 r
.54228 .38962 m
.54243 .39146 L
s
.626 .173 .077 r
.54096 .39012 m .56225 .38215 L .56028 .40783 L p F P
0 0 0 r
s
.24 .35 .67 r
.55983 .39008 m
.56048 .39086 L
s
.54762 .37546 m
.55983 .39008 L
s
.319 .464 .884 r
.553 .50662 m .54468 .49761 L .53686 .52835 L p F P
0 0 0 r
s
.319 .46 .871 r
.54468 .49761 m .553 .50662 L .56083 .47717 L p F P
0 0 0 r
s
.83 .24 .1 r
.54477 .50681 m
.57001 .49823 L
s
.838 .241 .105 r
.52945 .50282 m .54468 .49761 L .53686 .52835 L p F P
0 0 0 r
s
.83 .24 .1 r
.5434 .50728 m
.54477 .50681 L
s
.24 .35 .67 r
.54004 .50605 m
.54079 .50686 L
s
.308 .438 .814 r
.55661 .43629 m .56701 .44826 L .57131 .42087 L p F P
0 0 0 r
s
.308 .438 .814 r
.57131 .42087 m .56028 .40783 L .55661 .43629 L p F P
0 0 0 r
s
.83 .24 .1 r
.56344 .39071 m
.58604 .38232 L
s
.56222 .39117 m
.56344 .39071 L
s
.24 .35 .67 r
.41185 .5648 m
.38516 .54044 L
s
.41185 .5648 m
.44208 .55464 L
s
.83 .24 .1 r
.62675 .33698 m
.58317 .35352 L
s
.58604 .38232 m
.58317 .35352 L
s
.746 .211 .092 r
.53382 .47271 m .51647 .4788 L .51814 .4501 L p F P
0 0 0 r
s
.746 .211 .092 r
.51814 .4501 m .53726 .44323 L .53382 .47271 L p F P
0 0 0 r
s
.794 .227 .099 r
.51647 .4788 m .53382 .47271 L .52945 .50282 L p F P
0 0 0 r
s
.83 .24 .1 r
.80879 .54325 m
.82062 .55462 L
s
.24 .35 .67 r
.4886 .24253 m
.47339 .22739 L
s
.47339 .22739 m
.44801 .1957 L
s
.27985 .50901 m
.25025 .4834 L
s
.27985 .50901 m
.30177 .51737 L
s
.794 .227 .099 r
.54468 .49761 m .52945 .50282 L .53382 .47271 L p F P
0 0 0 r
s
.319 .46 .871 r
.56083 .47717 m .55134 .46656 L .54468 .49761 L p F P
0 0 0 r
s
.315 .452 .849 r
.55134 .46656 m .56083 .47717 L .56701 .44826 L p F P
0 0 0 r
s
.315 .452 .849 r
.56701 .44826 m .55661 .43629 L .55134 .46656 L p F P
0 0 0 r
s
.691 .194 .085 r
.55661 .43629 m .53726 .44323 L .53967 .41539 L p F P
0 0 0 r
s
.691 .194 .085 r
.53967 .41539 m .56028 .40783 L .55661 .43629 L p F P
0 0 0 r
s
.83 .24 .1 r
.71749 .26123 m
.71578 .27873 L
s
.24 .35 .67 r
.52645 .31832 m
.55026 .34751 L
s
.54762 .37546 m
.55026 .34751 L
s
.794 .227 .099 r
.53382 .47271 m .55134 .46656 L .54468 .49761 L p F P
0 0 0 r
s
.24 .35 .67 r
.52607 .49109 m
.54004 .50605 L
s
.746 .211 .092 r
.55134 .46656 m .53382 .47271 L .53726 .44323 L p F P
0 0 0 r
s
.24 .35 .67 r
.53835 .40532 m
.55671 .42663 L
s
.746 .211 .092 r
.53726 .44323 m .55661 .43629 L .55134 .46656 L p F P
0 0 0 r
s
.24 .35 .67 r
.54681 .46252 m
.55178 .45271 L
s
.54681 .46252 m
.54968 .46573 L
s
.54968 .46573 m
.54979 .46586 L
s
.83 .24 .1 r
.55254 .46632 m
.55276 .46624 L
s
.55276 .46624 m
.55803 .46439 L
s
.24 .35 .67 r
.42814 .18652 m
.44801 .1957 L
s
.83 .24 .1 r
.58414 .53006 m
.628 .5156 L
s
.58414 .53006 m
.57001 .49823 L
s
.7627 .55737 m
.80879 .54325 L
s
.7627 .55737 m
.74871 .53942 L
s
.24 .35 .67 r
.23354 .46958 m
.20276 .44297 L
s
.23354 .46958 m
.25025 .4834 L
s
.83 .24 .1 r
.55672 .45955 m
.55803 .46439 L
s
.55502 .45325 m
.55672 .45955 L
s
.56105 .42605 m
.59233 .41474 L
s
.55855 .42695 m
.56105 .42605 L
s
.24 .35 .67 r
.44208 .55464 m
.4158 .52984 L
s
.44208 .55464 m
.47225 .5384 L
s
.83 .24 .1 r
.67141 .32001 m
.67069 .29616 L
s
.67069 .29616 m
.71578 .27873 L
s
.24 .35 .67 r
.35614 .54453 m
.32796 .51949 L
s
.35614 .54453 m
.38516 .54044 L
s
.83 .24 .1 r
.7032 .55363 m
.74871 .53942 L
s
.7032 .55363 m
.68802 .52982 L
s
.64326 .54415 m
.68802 .52982 L
s
.64326 .54415 m
.628 .5156 L
s
.57001 .49823 m
.61391 .4833 L
s
.55803 .46439 m
.57001 .49823 L
s
.55803 .46439 m
.60179 .44904 L
s
.24 .35 .67 r
.52645 .31832 m
.52282 .2935 L
s
.52282 .2935 m
.49824 .26292 L
s
.83 .24 .1 r
.59233 .41474 m
.58604 .38232 L
s
.58604 .38232 m
.63017 .36593 L
s
.67141 .32001 m
.62675 .33698 L
s
.63017 .36593 m
.62675 .33698 L
s
.24 .35 .67 r
.20276 .44297 m
.19204 .42439 L
s
.52607 .49109 m
.54681 .46252 L
s
.54681 .46252 m
.52272 .4356 L
s
.47225 .5384 m
.44648 .51309 L
s
.47225 .5384 m
.50077 .51684 L
s
.50077 .51684 m
.52607 .49109 L
s
.52607 .49109 m
.50142 .46468 L
s
.53835 .40532 m
.54762 .37546 L
s
.54762 .37546 m
.52345 .3465 L
s
.49824 .26292 m
.4886 .24253 L
s
.4886 .24253 m
.46312 .21065 L
s
.30177 .51737 m
.27218 .49153 L
s
.30177 .51737 m
.32796 .51949 L
s
.50077 .51684 m
.47555 .49099 L
s
.83 .24 .1 r
.628 .5156 m
.67297 .50078 L
s
.628 .5156 m
.61391 .4833 L
s
.79536 .52485 m
.80879 .54325 L
s
.60179 .44904 m
.59233 .41474 L
s
.59233 .41474 m
.63691 .39862 L
s
.24 .35 .67 r
.38516 .54044 m
.35729 .51501 L
s
.38516 .54044 m
.4158 .52984 L
s
.83 .24 .1 r
.71578 .27873 m
.71721 .30262 L
s
.74871 .53942 m
.79536 .52485 L
s
.74871 .53942 m
.73391 .51512 L
s
.68802 .52982 m
.73391 .51512 L
s
.68802 .52982 m
.67297 .50078 L
s
.24 .35 .67 r
.44801 .1957 m
.46312 .21065 L
s
.25025 .4834 m
.21933 .45665 L
s
.25025 .4834 m
.27218 .49153 L
s
.83 .24 .1 r
.61391 .4833 m
.65892 .468 L
s
.61391 .4833 m
.60179 .44904 L
s
.60179 .44904 m
.64666 .43329 L
s
.63691 .39862 m
.63017 .36593 L
s
.63017 .36593 m
.67542 .34913 L
s
.71721 .30262 m
.67141 .32001 L
s
.67542 .34913 m
.67141 .32001 L
s
.24 .35 .67 r
.50158 .28784 m
.52645 .31832 L
s
.52345 .3465 m
.52645 .31832 L
s
.52272 .4356 m
.53835 .40532 L
s
.53835 .40532 m
.51371 .37673 L
s
.21933 .45665 m
.20276 .44297 L
s
.4158 .52984 m
.38835 .50393 L
s
.4158 .52984 m
.44648 .51309 L
s
.32796 .51949 m
.29854 .49333 L
s
.32796 .51949 m
.35729 .51501 L
s
.83 .24 .1 r
.67297 .50078 m
.71909 .48558 L
s
.67297 .50078 m
.65892 .468 L
s
.64666 .43329 m
.63691 .39862 L
s
.63691 .39862 m
.68262 .3821 L
s
.24 .35 .67 r
.50158 .28784 m
.49824 .26292 L
s
.49824 .26292 m
.47256 .23097 L
s
.50142 .46468 m
.52272 .4356 L
s
.52272 .4356 m
.49755 .40747 L
s
.83 .24 .1 r
.78098 .50005 m
.79536 .52485 L
s
.73391 .51512 m
.78098 .50005 L
s
.73391 .51512 m
.71909 .48558 L
s
.65892 .468 m
.70508 .45231 L
s
.65892 .468 m
.64666 .43329 L
s
.64666 .43329 m
.69269 .41715 L
s
.24 .35 .67 r
.44648 .51309 m
.41955 .48664 L
s
.44648 .51309 m
.47555 .49099 L
s
.83 .24 .1 r
.68262 .3821 m
.67542 .34913 L
s
.67542 .34913 m
.72183 .3319 L
s
.71721 .30262 m
.72183 .3319 L
s
.24 .35 .67 r
.47555 .49099 m
.50142 .46468 L
s
.50142 .46468 m
.47567 .43709 L
s
.51371 .37673 m
.52345 .3465 L
s
.52345 .3465 m
.49819 .31625 L
s
.46312 .21065 m
.47256 .23097 L
s
.27218 .49153 m
.24126 .46454 L
s
.27218 .49153 m
.29854 .49333 L
s
.47555 .49099 m
.44919 .46396 L
s
.35729 .51501 m
.32816 .48843 L
s
.35729 .51501 m
.38835 .50393 L
s
.83 .24 .1 r
.71909 .48558 m
.7664 .46998 L
s
.71909 .48558 m
.70508 .45231 L
s
.69269 .41715 m
.68262 .3821 L
s
.68262 .3821 m
.72952 .36514 L
s
.24 .35 .67 r
.24126 .46454 m
.21933 .45665 L
s
.83 .24 .1 r
.7664 .46998 m
.78098 .50005 L
s
.24 .35 .67 r
.47559 .25597 m
.50158 .28784 L
s
.49819 .31625 m
.50158 .28784 L
s
.83 .24 .1 r
.70508 .45231 m
.75244 .4362 L
s
.70508 .45231 m
.69269 .41715 L
s
.69269 .41715 m
.73991 .40058 L
s
.24 .35 .67 r
.49755 .40747 m
.51371 .37673 L
s
.51371 .37673 m
.48796 .34683 L
s
.83 .24 .1 r
.72183 .3319 m
.72952 .36514 L
s
.24 .35 .67 r
.38835 .50393 m
.35965 .47684 L
s
.38835 .50393 m
.41955 .48664 L
s
.29854 .49333 m
.26776 .46598 L
s
.29854 .49333 m
.32816 .48843 L
s
.47256 .23097 m
.47559 .25597 L
s
.47567 .43709 m
.49755 .40747 L
s
.49755 .40747 m
.47122 .37805 L
s
.83 .24 .1 r
.75244 .4362 m
.7664 .46998 L
s
.72952 .36514 m
.73991 .40058 L
s
.24 .35 .67 r
.41955 .48664 m
.39138 .45898 L
s
.41955 .48664 m
.44919 .46396 L
s
.44919 .46396 m
.47567 .43709 L
s
.47567 .43709 m
.44872 .40822 L
s
.48796 .34683 m
.49819 .31625 L
s
.49819 .31625 m
.47176 .2846 L
s
.26776 .46598 m
.24126 .46454 L
s
.44919 .46396 m
.42162 .4357 L
s
.83 .24 .1 r
.73991 .40058 m
.75244 .4362 L
s
.24 .35 .67 r
.32816 .48843 m
.29769 .46062 L
s
.32816 .48843 m
.35965 .47684 L
s
.47559 .25597 m
.47176 .2846 L
s
.47122 .37805 m
.48796 .34683 L
s
.48796 .34683 m
.46101 .31555 L
s
.35965 .47684 m
.32961 .44848 L
s
.35965 .47684 m
.39138 .45898 L
s
.29769 .46062 m
.26776 .46598 L
s
.44872 .40822 m
.47122 .37805 L
s
.47122 .37805 m
.44366 .34725 L
s
.39138 .45898 m
.36188 .43002 L
s
.39138 .45898 m
.42162 .4357 L
s
.42162 .4357 m
.44872 .40822 L
s
.44872 .40822 m
.42051 .378 L
s
.47176 .2846 m
.46101 .31555 L
s
.42162 .4357 m
.39275 .4061 L
s
.32961 .44848 m
.29769 .46062 L
s
.46101 .31555 m
.44366 .34725 L
s
.36188 .43002 m
.32961 .44848 L
s
.44366 .34725 m
.42051 .378 L
s
.39275 .4061 m
.36188 .43002 L
s
.42051 .378 m
.39275 .4061 L
s
0 0 0 r
.25 Mabswid
.06705 .30234 m
.63805 .03848 L
s
.63805 .03848 m
.66126 .3169 L
s
.66126 .3169 m
.00747 .5665 L
s
.00747 .5665 m
.06705 .30234 L
s
.88764 .44767 m
.63805 .03848 L
s
.63805 .03848 m
.66126 .3169 L
s
.66126 .3169 m
.93472 .69847 L
s
.93472 .69847 m
.88764 .44767 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{500, 500},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40007d0001m2000`400?l00000o`00003oo`3ooooe
0?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3o
m^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40
oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?of
k_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3o
ool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^
m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofkSh0ooK^0P00002d0?ofkP40oooo003o0?of
kS`0ooK^0P0000000`3om^h000000000002c0?ofkP40oooo003o0?ofkSX0ooK^0P0000030?ofkP80
0000/`3om^h10?ooo`00o`3om^hh0?ofkP8000001@3om^h00`000000ooK^0000002b0?ofkP40oooo
003o0?ofkSH0ooK^0P0000070?ofkP030000003om^h000000;80ooK^0@3oool00?l0ooK^=03om^h2
000000T0ooK^00@000000?ofkP3om^h00000/@3om^h10?ooo`00o`3om^ha0?ofkP<000002`3om^h0
1@000000ooK^0?ofkP3om^h000000;00ooK^0@3oool00?l0ooK^;`3om^h2000000l0ooK^00@00000
0?ofkP3om^h00000/03om^h10?ooo`00o`3om^h]0?ofkP8000004@3om^h01@000000ooK^0?ofkP3o
m^h000000:l0ooK^0@3oool00?l0ooK^:`3om^h2000001<0ooK^00D000000?ofkP3om^h0ooK^0000
002_0?ofkP40oooo003o0?ofkRT0ooK^0P00000E0?ofkP030000003om^h0ooK^0080ooK^00<00000
0?ofkP3om^h0[03om^h10?ooo`00o`3om^hV0?ofkP<000005`3om^h00`000000ooK^0?ofkP030?of
kP030000003om^h0ooK^0:/0ooK^0@3oool00?l0ooK^903om^h2000001X0ooK^00<000000?ofkP3o
m^h00`3om^h00`000000ooK^0?ofkP2[0?ofkP40oooo003o0?ofkR80ooK^0P00000L0?ofkP030000
003om^h0ooK^00@0ooK^00<000000?ofkP3om^h0ZP3om^h10?ooo`00o`3om^hP0?ofkP8000007P3o
m^h00`000000ooK^0?ofkP050?ofkP030000003om^h0ooK^0:T0ooK^0@3oool00?l0ooK^7P3om^h2
00000200ooK^00<000000?ofkP3om^h01@3om^h00`000000ooK^0?ofkP2Y0?ofkP40oooo003o0?of
kQ`0ooK^0P00000R0?ofkP030000003om^h0ooK^00H0ooK^00<000000?ofkP3om^h0Z03om^h10?oo
o`00o`3om^hI0?ofkP<00000903om^h00`000000ooK^0?ofkP060?ofkP030000003om^h0ooK^0:P0
ooK^0@3oool00?l0ooK^5`3om^h2000002L0ooK^00<000000?ofkP3om^h01`3om^h00`000000ooK^
0?ofkP2W0?ofkP40oooo003o0?ofkQD0ooK^0P00000Z0?ofkP030000003om^h0ooK^00L0ooK^00<0
00000?ofkP3om^h0YP3om^h10?ooo`00o`3om^hC0?ofkP800000;03om^h00`000000ooK^0?ofkP07
0?ofkP030000003om^h0ooK^0:H0ooK^0@3oool00?l0ooK^4@3om^h2000002h0ooK^00<000000?of
kP3om^h0203om^h00`000000ooK^0?ofkP2U0?ofkP40oooo003o0?ofkPl0ooK^0P00000`0?ofkP03
0000003om^h0ooK^00P0ooK^00<000000?ofkP3om^h0Y@3om^h10?ooo`00o`3om^h<0?ofkP<00000
<P3om^h00`000000ooK^0?ofkP090?ofkP030000003om^h0ooK^0:@0ooK^0@3oool00?l0ooK^2P3o
m^h2000003D0ooK^00<000000?ofkP3om^h02P3om^h00`000000ooK^0?ofkP2S0?ofkP40oooo003o
0?ofkPP0ooK^0P00000g0?ofkP030000003om^h0ooK^00X0ooK^00<000000?ofkP3om^h0X`3om^h1
0?ooo`00o`3om^h60?ofkP800000>@3om^h00`000000ooK^0?ofkP0;0?ofkP030000003om^h0ooK^
0:80ooK^0@3oool00?l0ooK^103om^h2000003/0ooK^00<000000?ofkP3om^h02`3om^h00`000000
ooK^0?ofkP2R0?ofkP40oooo003o0?ofkP40ooK^0`00000m0?ofkP030000003om^h0ooK^00`0ooK^
00<000000?ofkP3om^h0X@3om^h10?ooo`00oP3om^h200000400ooK^00<000000?ofkP3om^h03@3o
m^h00`000000ooK^0?ofkP2P0?ofkP40oooo003l0?ofkP800000@P3om^h00`000000ooK^0?ofkP0=
0?ofkP030000003om^h0ooK^0:00ooK^0@3oool00?X0ooK^0P0000140?ofkP030000003om^h0ooK^
00h0ooK^00<000000?ofkP3om^h0W`3om^h10?ooo`00n03om^h2000004L0ooK^00<000000?ofkP3o
m^h03@3om^h00`000000ooK^0?ofkP2O0?ofkP40oooo003f0?ofkP800000B@3om^h00`000000ooK^
0?ofkP0>0?ofkP030000003om^h0ooK^09h0ooK^0@3oool00?<0ooK^0`00001;0?ofkP030000003o
m^h0ooK^00l0ooK^00<000000?ofkP3om^h0W@3om^h10?ooo`00l@3om^h2000004h0ooK^00<00000
0?ofkP3om^h03`3om^h00`000000ooK^0?ofkP2M0?ofkP40oooo003_0?ofkP800000D03om^h00`00
0000ooK^0?ofkP0@0?ofkP030000003om^h0ooK^09`0ooK^0@3oool00>d0ooK^0P00001B0?ofkP03
0000003om^h0ooK^0100ooK^00<000000?ofkP3om^h0W03om^h10?ooo`00j`3om^h2000005@0ooK^
00<000000?ofkP3om^h04@3om^h00`000000ooK^0?ofkP2K0?ofkP40oooo003Y0?ofkP800000EP3o
m^h00`000000ooK^0?ofkP0B0?ofkP030000003om^h0ooK^09X0ooK^0@3oool00>H0ooK^0`00001H
0?ofkP030000003om^h0ooK^0180ooK^00<000000?ofkP3om^h0VP3om^h10?ooo`00i03om^h20000
05/0ooK^00<000000?ofkP3om^h04`3om^h00`000000ooK^0?ofkP2I0?ofkP40oooo003R0?ofkP80
0000G@3om^h00`000000ooK^0?ofkP0D0?ofkP030000003om^h0ooK^09P0ooK^0@3oool00>00ooK^
0P00001O0?ofkP030000003om^h0ooK^01@0ooK^00<000000?ofkP3om^h0V03om^h10?ooo`00gP3o
m^h200000640ooK^00<000000?ofkP3om^h05@3om^h00`000000ooK^0?ofkP2G0?ofkP40oooo003L
0?ofkP800000I03om^h00`000000ooK^0?ofkP0D0?ofkP030000003om^h0ooK^09L0ooK^0@3oool0
0=T0ooK^0`00001V0?ofkP030000003om^h0ooK^01D0ooK^00<000000?ofkP3om^h0UP3om^h10?oo
o`00e`3om^h2000006T0ooK^00<000000?ofkP3om^h05P3om^h00`000000ooK^0?ofkP2E0?ofkP40
oooo003E0?ofkP800000J`3om^h00`000000ooK^0?ofkP0F0?ofkP030000003om^h0ooK^09D0ooK^
0@3oool00=<0ooK^0P00001]0?ofkP030000003om^h0ooK^01L0ooK^00<000000?ofkP3om^h0U03o
m^h10?ooo`00d@3om^h2000006l0ooK^00<000000?ofkP3om^h05`3om^h00`000000ooK^0?ofkP2D
0?ofkP40oooo003>0?ofkP<00000L@3om^h00`000000ooK^0?ofkP0H0?ofkP030000003om^h0ooK^
09<0ooK^0@3oool00<`0ooK^0P00001d0?ofkP030000003om^h0ooK^01T0ooK^00<000000?ofkP3o
m^h0TP3om^h10?ooo`00bP3om^h2000007H0ooK^00<000000?ofkP3om^h06@3om^h00`000000ooK^
0?ofkP2B0?ofkP40oooo00380?ofkP800000N03om^h00`000000ooK^0?ofkP0J0?ofkP030000003o
m^h0ooK^0940ooK^0@3oool00<H0ooK^0P00001j0?ofkP030000003om^h0ooK^01X0ooK^00<00000
0?ofkP3om^h0T@3om^h10?ooo`00a03om^h2000007`0ooK^00<000000?ofkP3om^h06`3om^h00`00
0000ooK^0?ofkP2@0?ofkP40oooo00310?ofkP<00000O`3om^h00`000000ooK^0?ofkP0K0?ofkP03
0000003om^h0ooK^08l0ooK^0@3oool00;l0ooK^0P0000220?ofkP030000003om^h0ooK^01/0ooK^
00<000000?ofkP3om^h0S`3om^h10?ooo`00_@3om^h2000008@0ooK^00<000000?ofkP3om^h0703o
m^h00`000000ooK^0?ofkP2>0?ofkP40oooo002k0?ofkP800000QP3om^h00`000000ooK^0?ofkP0L
0?ofkP030000003om^h0ooK^08h0ooK^0@3oool00;T0ooK^0P0000280?ofkP030000003om^h0ooK^
01d0ooK^00<000000?ofkP3om^h0S@3om^h10?ooo`00]`3om^h2000008X0ooK^00<000000?ofkP3o
m^h07P3om^h00`000000ooK^0?ofkP2<0?ofkP40oooo002d0?ofkP<00000S03om^h00`000000ooK^
0?ofkP0N0?ofkP030000003om^h0ooK^08`0ooK^0@3oool00;80ooK^0P00002?0?ofkP030000003o
m^h0ooK^01l0ooK^00<000000?ofkP3om^h0R`3om^h10?ooo`00/03om^h200000940ooK^00<00000
0?ofkP3om^h0803om^h00`000000ooK^0?ofkP2:0?ofkP40oooo002^0?ofkP800000T`3om^h00`00
0000ooK^0?ofkP0P0?ofkP030000003om^h0ooK^08X0ooK^0@3oool00:`0ooK^0P00002E0?ofkP03
0000003om^h0ooK^0240ooK^00<000000?ofkP3om^h0R@3om^h10?ooo`00Z@3om^h3000009L0ooK^
00<000000?ofkP3om^h08@3om^h00`000000ooK^0?ofkP290?ofkP40oooo002W0?ofkP800000VP3o
m^h00`000000ooK^0?ofkP0R0?ofkP030000003om^h0ooK^08P0ooK^0@3oool00:D0ooK^0P00002M
0?ofkP030000003om^h0ooK^0280ooK^00<000000?ofkP3om^h0Q`3om^h10?ooo`00X`3om^h20000
09l0ooK^00<000000?ofkP3om^h08P3om^h00`000000ooK^0?ofkP270?ofkP40oooo002Q0?ofkP80
0000803om^h903eIZgP0ooK^00<000000?ofkP3om^h08`3om^h00`000000ooK^0?ofkP260?ofkP40
oooo002O0?ofkP8000006P3om^h803eIZ`L0ooK^00<0?EV[0?ofkP0mFJ/01@0mFJ]b0?ofkP030000
003om^h0ooK^02<0ooK^00<000000?ofkP3om^h0QP3om^h10?ooo`00W03om^h3000001P0ooK^100m
FJ/20?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h0103om^h503eIZfd0ooK^00<0
00000?ofkP3om^h0903om^h00`000000ooK^0?ofkP250?ofkP40oooo002J0?ofkP800000603om^h3
03eIZ`L0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP070?ofkP<0?EV[J`3om^h0
0`000000ooK^0?ofkP0U0?ofkP030000003om^h0ooK^08@0ooK^0@3oool009P0ooK^0P00000F0?of
kP@0?EV[2`3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?of
kP0mFJ/00P0mFJ]X0?ofkP030000003om^h0ooK^02D0ooK^00<000000?ofkP3om^h0Q03om^h10?oo
o`00UP3om^h2000001D0ooK^0`0mFJ/?0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3o
m^h0203om^h0100mFJ/0ooK^0?ofkP3om^h203eIZfH0ooK^00<000000?ofkP3om^h09P3om^h00`00
0000ooK^0?ofkP230?ofkP40oooo002D0?ofkP8000005@3om^h203eIZ`80ooK^00<0?EV[0?ofkP3o
m^h03P3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3o
m^h00`3om^h203eIZf@0ooK^00<000000?ofkP3om^h09P3om^h00`000000ooK^0?ofkP230?ofkP40
oooo002B0?ofkP8000005@3om^h203eIZ`D0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^
0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^
0?ofkP1Q0?ofkP030000003om^h0ooK^02L0ooK^00<000000?ofkP3om^h0PP3om^h10?ooo`00S`3o
m^h3000001@0ooK^0`0mFJ/80?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h02`3o
m^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h0H03o
m^h00`000000ooK^0?ofkP0X0?ofkP030000003om^h0ooK^0840ooK^0@3oool008d0ooK^0P00000E
0?ofkP80?EV[2`3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[
0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP030?ofkP80?EV[H@3om^h00`000000ooK^0?ofkP0X
0?ofkP030000003om^h0ooK^0840ooK^0@3oool008/0ooK^0P00000E0?ofkP80?EV[3P3om^h00`0m
FJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0m
FJ/0ooK^0?ofkP030?ofkP80?EV[H03om^h00`000000ooK^0?ofkP0Y0?ofkP030000003om^h0ooK^
0800ooK^0@3oool008T0ooK^0P00000E0?ofkP80?EV[4@3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP03
03eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP030?ofkP80
?EV[H03om^h00`000000ooK^0?ofkP0X0?ofkP030000003om^h0ooK^0800ooK^0@3oool008L0ooK^
0P00000E0?ofkP80?EV[00<0ooK^03eIZ`3om^h04@3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eI
Z`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP030?ofkP80?EV[
G`3om^h00`000000ooK^0?ofkP0Y0?ofkP030000003om^h0ooK^07l0ooK^0@3oool008@0ooK^0`00
000F0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h0403om^h00`0mFJ/0ooK^0?of
kP0>0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?of
kP030?ofkP80?EV[GP3om^h00`000000ooK^0?ofkP0Z0?ofkP030000003om^h0ooK^07h0ooK^0@3o
ool00880ooK^0P00000G0?ofkP80?EV[1P3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0303eIZ`3om^h0
ooK^00h0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0
ooK^00<0ooK^00<0?EV[0?ofkP0mFJ/0G@3om^h00`000000ooK^0?ofkP0Z0?ofkP030000003om^h0
ooK^07h0ooK^0@3oool00800ooK^0P00000H0?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?of
kP3om^h0403om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00D0ooK^2@0mFJ/70?of
kP0303eIZ`3om^h0ooK^00<0ooK^0`0mFJ]L0?ofkP030000003om^h0ooK^02/0ooK^00<000000?of
kP3om^h0O@3om^h10?ooo`00OP3om^h2000001T0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0
ooK^0?ofkP0@0?ofkP0303eIZ`3om^h0ooK^00d0ooK^200mFJ/70?ofkP0303eIZ`3om^h0?EV[00D0
?EV[0P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP80?EV[G03om^h00`000000ooK^0?ofkP0[0?ofkP03
0000003om^h0ooK^07d0ooK^0@3oool007`0ooK^0P00000I0?ofkP80?EV[3@3om^h00`0mFJ/0ooK^
0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00T0ooK^100mFJ/20?ofkP0303eIZ`3om^h0ooK^00/0ooK^
00<0?EV[0?ofkP3om^h0103om^h403eIZ`D0ooK^0P0mFJ]K0?ofkP030000003om^h0ooK^02`0ooK^
00<000000?ofkP3om^h0O03om^h10?ooo`00NP3om^h2000001X0ooK^00<0?EV[0?ofkP3om^h03P3o
m^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00D0ooK^0`0mFJ/70?ofkP0303eIZ`3o
m^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h0203om^h203eIZ`@0ooK^0P0mFJ]J0?ofkP030000003o
m^h0ooK^02d0ooK^00<000000?ofkP3om^h0N`3om^h10?ooo`00M`3om^h3000001X0ooK^0P0mFJ/A
0?ofkP0303eIZ`3om^h0ooK^0100ooK^00<0?EV[0?ofkP3om^h0100mFJ/:0?ofkP0303eIZ`3om^h0
ooK^00/0ooK^00<0?EV[0?ofkP3om^h0203om^h303eIZ`80ooK^0`0mFJ]I0?ofkP030000003om^h0
ooK^02d0ooK^00<000000?ofkP3om^h0N`3om^h10?ooo`00M@3om^h2000001`0ooK^00<0?EV[0?of
kP3om^h04P3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP<0?EV[3`3om^h00`0mFJ/0ooK^0?ofkP0;0?of
kP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h01@0mFJ]I0?ofkP030000003om^h0ooK^
02h0ooK^00<000000?ofkP3om^h0NP3om^h10?ooo`00L`3om^h2000001d0ooK^00<0?EV[0?ofkP0m
FJ/0503om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP80?EV[0P3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP03
03eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h01`3om^h0100mFJ/0ooK^0?ofkP3om^h403eI
ZeP0ooK^00<000000?ofkP3om^h0;`3om^h00`000000ooK^0?ofkP1i0?ofkP40oooo001a0?ofkP80
00007P3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[01@0ooK^00<0?EV[0?ofkP3om^h02@3om^h203eI
Z`D0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^
00L0ooK^00@0?EV[0?ofkP3om^h0ooK^100mFJ]G0?ofkP030000003om^h0ooK^02l0ooK^00<00000
0?ofkP3om^h0N@3om^h10?ooo`00K`3om^h2000001h0ooK^0P0mFJ/50?ofkP0303eIZ`3om^h0ooK^
0180ooK^00<0?EV[0?ofkP3om^h01P3om^h203eIZ`P0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0m
FJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00P0ooK^00H0?EV[0?ofkP3om^h0ooK^03eIZ`3o
m^h203eIZeL0ooK^00<000000?ofkP3om^h0;`3om^h00`000000ooK^0?ofkP1h0?ofkP40oooo001]
0?ofkP8000007`3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[
0?ofkP3om^h00`3om^h203eIZ`/0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0;
0?ofkP0303eIZ`3om^h0ooK^00P0ooK^00@0?EV[0?ofkP3om^h0?EV[0P3om^h00`0mFJ/0ooK^0?of
kP1E0?ofkP030000003om^h0ooK^02l0ooK^00<000000?ofkP3om^h0N03om^h10?ooo`00JP3om^h3
00000200ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0
ooK^0080?EV[3P3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[
0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP0203eIZ`030?ofkP0mFJ/0?EV[05H0ooK^00<00000
0?ofkP3om^h0<03om^h00`000000ooK^0?ofkP1g0?ofkP40oooo001X0?ofkP8000008P3om^h00`0m
FJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^01<0ooK^0P0mFJ/A0?ofkP0303eIZ`3om^h0ooK^
00d0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP070?ofkP0603eIZ`3om^h0?EV[
0?ofkP0mFJ/0ooK^0P0mFJ]E0?ofkP030000003om^h0ooK^0340ooK^00<000000?ofkP3om^h0MP3o
m^h10?ooo`00IP3om^h2000002<0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP0@
0?ofkP80?EV[00<0ooK^03eIZ`3om^h0403om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0
ooK^00/0ooK^00<0?EV[0?ofkP3om^h01`3om^h203eIZ`040?ofkP0mFJ/0ooK^0?ofkP80?EV[E03o
m^h00`000000ooK^0?ofkP0a0?ofkP030000003om^h0ooK^07H0ooK^0@3oool006@0ooK^0P00000S
0?ofkP80?EV[3`3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[
0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[
0?ofkP3om^h0203om^h203eIZ`050?ofkP0mFJ/0ooK^0?ofkP0mFJ/0E03om^h00`000000ooK^0?of
kP0b0?ofkP030000003om^h0ooK^07D0ooK^0@3oool00680ooK^0P00000T0?ofkP0303eIZ`3om^h0
ooK^0100ooK^00<0?EV[0?ofkP3om^h02`3om^h203eIZ`H0ooK^00<0?EV[0?ofkP3om^h03`3om^h0
0`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h0203om^h0
100mFJ/0ooK^0?ofkP0mFJ/20?ofkP0303eIZ`3om^h0ooK^0540ooK^00<000000?ofkP3om^h0<P3o
m^h00`000000ooK^0?ofkP1e0?ofkP40oooo001P0?ofkP8000009@3om^h00`0mFJ/0ooK^0?ofkP0B
0?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP0@
0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h01@3om^h903eIZ`L0ooK^00H0?EV[
0?ofkP3om^h0ooK^03eIZ`3om^h203eIZe80ooK^00<000000?ofkP3om^h0<`3om^h00`000000ooK^
0?ofkP1d0?ofkP40oooo001M0?ofkP<000009P3om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP0303eIZ`3o
m^h0ooK^00H0ooK^0P0mFJ/:0?ofkP0303eIZ`3om^h0ooK^0100ooK^00<0?EV[0?ofkP3om^h02`3o
m^h903eIZ`L0ooK^00<0?EV[0?ofkP0mFJ/01@0mFJ/00`3om^h0?EV[03eIZ`030?ofkP0403eIZ`3o
m^h0?EV[03eIZe40ooK^00<000000?ofkP3om^h0=03om^h00`000000ooK^0?ofkP1c0?ofkP40oooo
001K0?ofkP800000:03om^h00`0mFJ/0ooK^03eIZ`0E0?ofkP0303eIZ`3om^h0ooK^00@0ooK^0P0m
FJ/=0?ofkP0303eIZ`3om^h0ooK^0100ooK^00<0?EV[0?ofkP3om^h01P3om^h403eIZ`<0ooK^00<0
?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP040?ofkP@0?EV[0P3om^h00`0mFJ/0ooK^0?of
kP0203eIZe00ooK^00<000000?ofkP3om^h08@3om^h40=@m6@l0ooK^00<000000?ofkP3om^h0L`3o
m^h10?ooo`00F@3om^h2000002T0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0E0?ofkP0303eIZ`3o
m^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0403eIZ`3o
m^h0ooK^0?ofkP@0?EV[203om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00@0ooK^
00<0?EV[0?ofkP3om^h00P0mFJ/00`3om^h0?EV[0?ofkP0203eIZe00ooK^00<000000?ofkP3om^h0
7`3om^h30=@m6@<0ooK^0`3D?AT=0?ofkP030000003om^h0ooK^0780ooK^0@3oool005L0ooK^0P00
000Z0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h04`3om^h0100mFJ/0ooK^03eI
Z`0mFJ/B0?ofkP0303eIZ`3om^h0ooK^00l0ooK^100mFJ/=0?ofkP0303eIZ`3om^h0ooK^00X0ooK^
00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP0403eIZ`030?ofkP0mFJ/0?EV[04l0ooK^
00<000000?ofkP3om^h0703om^h40=@m6@@0ooK^0P3D?AT20?ofkP030=@m6@3om^h0ooK^00X0ooK^
00<000000?ofkP3om^h0LP3om^h10?ooo`00E@3om^h2000002/0ooK^00<0?EV[0?ofkP3om^h01@3o
m^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h0303o
m^h203eIZ`80ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3o
m^h0ooK^00@0ooK^00@0?EV[0?ofkP3om^h0?EV[0P3om^h503eIZdh0ooK^00<000000?ofkP3om^h0
6@3om^h50=@m6@040?ofkP3D?AT0ooK^0?ofkP80e3dI1@3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP03
0000003om^h0ooK^0740ooK^0@3oool00580ooK^0`00000/0?ofkP0303eIZ`3om^h0ooK^00L0ooK^
00<0?EV[0?ofkP3om^h04@3om^h00`0mFJ/0ooK^03eIZ`0E0?ofkP0303eIZ`3om^h0ooK^00T0ooK^
0P0mFJ/50?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^
0?ofkP030?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/00`3om^h403eIZdh0ooK^00<000000?ofkP3o
m^h05P3om^h40=@m6@<0ooK^103D?AT80?ofkP030=@m6@3om^h0ooK^00X0ooK^00<000000?ofkP3o
m^h0L03om^h10?ooo`00D03om^h2000002d0ooK^0P0mFJ/;0?ofkP0303eIZ`3om^h0ooK^00h0ooK^
0P0mFJ/30?ofkP0303eIZ`3om^h0ooK^0180ooK^00<0?EV[0?ofkP3om^h01P3om^h303eIZ`P0ooK^
00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^0080ooK^
0P0mFJ/30?ofkP0403eIZ`3om^h0ooK^0?ofkP@0?EV[C@3om^h00`000000ooK^0?ofkP0C0?ofkPD0
e3dI103om^h20=@m6@`0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`000000ooK^0?ofkP1`0?ofkP40
oooo001>0?ofkP800000;P3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00d0ooK^
00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^00<0ooK^
0P0mFJ/;0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h02`3om^h01`0mFJ/0ooK^
0?ofkP3om^h0?EV[0?ofkP0mFJ/00`3om^h00`0mFJ/0ooK^0?ofkP0203eIZ`030?ofkP0mFJ/0ooK^
04`0ooK^00<000000?ofkP3om^h0403om^h50=@m6@D0ooK^0`3D?AT=0?ofkP80e3dI2`3om^h00`00
0000ooK^0?ofkP1_0?ofkP40oooo001<0?ofkP800000;`3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP03
03eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP03
03eIZ`3om^h0ooK^0080?EV[3P3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00/0
ooK^00H0?EV[0?ofkP3om^h0?EV[0?ofkP0mFJ/40?ofkP0403eIZ`3om^h0ooK^03eIZ`80ooK^00<0
?EV[0?ofkP3om^h0BP3om^h00`000000ooK^0?ofkP0>0?ofkP@0e3dI1@3om^h30=@m6@030?ofkP3D
?AT0e3dI00/0ooK^0P3D?AT20?ofkP030=@m6@3om^h0ooK^00P0ooK^00<000000?ofkP3om^h0K`3o
m^h10?ooo`00BP3om^h200000300ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP08
0?ofkP80?EV[2P3om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP80?EV[4@3om^h00`0mFJ/0ooK^0?ofkP0=
0?ofkP0303eIZ`3om^h0ooK^00/0ooK^0P0mFJ/30?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/00`3o
m^h0100mFJ/0ooK^03eIZ`0mFJ];0?ofkP030000003om^h0ooK^00/0ooK^103D?AT60?ofkP80e3dI
0P3om^h20=@m6@030?ofkP3D?AT0ooK^00L0ooK^0`3D?AT40?ofkP030=@m6@3om^h0ooK^00T0ooK^
00<000000?ofkP3om^h0KP3om^h10?ooo`00B03om^h200000340ooK^00<0?EV[0?ofkP3om^h04@3o
m^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h03`3o
m^h203eIZ`030?ofkP0mFJ/0ooK^0140ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?of
kP0:0?ofkP80?EV[103om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[0080ooK^0P0mFJ/00`3om^h0?EV[
03eIZ`1:0?ofkP030000003om^h0ooK^00T0ooK^103D?AT00`3om^h0e3dI0=@m6@030?ofkP80e3dI
00@0ooK^0=@m6@3D?AT0e3dI0`3om^h00`3D?AT0ooK^0?ofkP040?ofkP80e3dI203om^h00`3D?AT0
ooK^0?ofkP090?ofkP030000003om^h0ooK^06d0ooK^0@3oool004D0ooK^0`00000b0?ofkP0303eI
Z`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eI
Z`3om^h0ooK^00`0ooK^0P0mFJ/40?ofkP0303eIZ`3om^h0ooK^0100ooK^00<0?EV[0?ofkP3om^h0
303om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00X0?EV[0?ofkP3om^h0
ooK^03eIZ`3om^h0?EV[0?ofkP0mFJ/0ooK^0P0mFJ]90?ofkP030000003om^h0ooK^00H0ooK^103D
?AT60?ofkP<0e3dI00<0ooK^0=@m6@3D?AT01P3om^h0103D?AT0ooK^0?ofkP3om^h30=@m6@/0ooK^
00<0e3dI0?ofkP3om^h0203om^h00`000000ooK^0?ofkP1]0?ofkP40oooo00130?ofkP800000=03o
m^h00`0mFJ/0ooK^03eIZ`0E0?ofkP0403eIZ`3om^h0ooK^0?ofkP80?EV[4@3om^h00`0mFJ/0ooK^
0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h0403om^h00`0mFJ/0ooK^
0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00X0ooK^0P0mFJ/50?ofkP0403eIZ`3om^h0ooK^0?ofkP80
?EV[00D0ooK^03eIZ`3om^h0ooK^03eIZ`190?ofkP030000003om^h0ooK^00<0ooK^1@3D?AT60?of
kP80e3dI00@0ooK^0=@m6@3D?AT0e3dI203om^h0103D?AT0ooK^0=@m6@3D?AT?0?ofkP030=@m6@3o
m^h0ooK^00P0ooK^00<000000?ofkP3om^h0K03om^h10?ooo`00@@3om^h2000003D0ooK^00D0?EV[
0?ofkP3om^h0ooK^03eIZ`0E0?ofkP0303eIZ`3om^h0?EV[01@0ooK^00<0?EV[0?ofkP3om^h01`3o
m^h203eIZ`P0ooK^00<0?EV[0?ofkP3om^h04@3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3o
m^h0ooK^00D0ooK^200mFJ/30?ofkP0303eIZ`3om^h0ooK^0080ooK^0P0mFJ/01@3om^h0?EV[0?of
kP3om^h0?EV[04P0ooK^00@000000?ofkP3om^h0ooK^103D?AT20?ofkP040=@m6@3om^h0ooK^0?of
kPH0e3dI0`3om^h00`3D?AT0ooK^0?ofkP040?ofkP<0e3dI4@3om^h00`3D?AT0ooK^0?ofkP090?of
kP030000003om^h0ooK^06/0ooK^0@3oool003l0ooK^0P00000f0?ofkP0303eIZ`3om^h0ooK^00<0
ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?ofkP0D0?ofkP0303eIZ`3om^h0ooK^00D0
ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0303eIZ`3om^h0ooK^00/0
ooK^2@0mFJ/40?ofkP0303eIZ`3om^h0ooK^00H0?EV[0`3om^h203eIZ`80ooK^00@0?EV[0?ofkP0m
FJ/0?EV[A`3om^h00`000000e3dI0=@m6@020=@m6@@0ooK^00<0e3dI0?ofkP3D?AT00P3D?AT00`3o
m^h0e3dI0=@m6@070?ofkP80e3dI0P3om^h30=@m6A@0ooK^00<0e3dI0?ofkP3om^h0203om^h00`00
0000ooK^0?ofkP1[0?ofkP40oooo000m0?ofkP800000>03om^h00`0mFJ/0ooK^0?ofkP040?ofkP03
03eIZ`3om^h0ooK^0140ooK^00<0?EV[0?ofkP0mFJ/05P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP80
?EV[3@3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0303eIZ`3om^h0ooK^00H0ooK^100mFJ/30?ofkP03
03eIZ`3om^h0ooK^00L0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`030?ofkP@0?EV[00<0ooK^03eI
Z`3om^h00P3om^h0100mFJ/0ooK^03eIZ`0mFJ]40?ofkP80e3dI00<000000=@m6@3om^h01P3om^h2
0=@m6@040?ofkP3D?AT0e3dI0=@m6@X0ooK^0`3D?AT20?ofkP030=@m6@3om^h0ooK^0180ooK^0P3D
?AT:0?ofkP030000003om^h0ooK^06X0ooK^0@3oool003/0ooK^0P00000i0?ofkP0303eIZ`3om^h0
ooK^00H0ooK^00<0?EV[0?ofkP3om^h03`3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[01H0ooK^00@0
?EV[0?ofkP0mFJ/0?EV[403om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0403eIZ`3om^h0ooK^0?ofkP@0
?EV[203om^h00`0mFJ/0ooK^0?ofkP060?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/01@3om^h00`0m
FJ/0ooK^03eIZ`0203eIZ`<0ooK^00@0?EV[0?ofkP0mFJ/0?EV[@@3om^h40=@m6@030000003om^h0
ooK^00<0ooK^0`3D?AT00`3om^h0e3dI0=@m6@0;0?ofkP80e3dI0P3om^h0103D?AT0ooK^0?ofkP3D
?ATA0?ofkP<0e3dI0P3om^h00`3D?AT0ooK^0?ofkP070?ofkP030000003om^h0ooK^06X0ooK^0@3o
ool003P0ooK^0`00000j0?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h03@3om^h0
0`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^01@0ooK^00<0?EV[0?ofkP3om^h04@3om^h0
0`0mFJ/0ooK^0?ofkP0?0?ofkP@0?EV[3@3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0
ooK^00<0ooK^00<0?EV[0?ofkP3om^h00`3om^h0100mFJ/0ooK^03eIZ`3om^h203eIZ`030?ofkP0m
FJ/0ooK^00<0?EV[?@3om^h40=@m6@<0ooK^00<000000?ofkP3om^h00`3D?AT0103om^h0e3dI0=@m
6@3D?AT:0?ofkP<0e3dI1@3om^h30=@m6@h0ooK^0`3D?AT50?ofkP030=@m6@3om^h0ooK^00P0ooK^
00<000000?ofkP3om^h0J@3om^h10?ooo`00=P3om^h2000003`0ooK^00<0?EV[0?ofkP3om^h02@3o
m^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h04P3o
m^h00`0mFJ/0ooK^03eIZ`0C0?ofkP0303eIZ`3om^h0ooK^00`0ooK^0P0mFJ/20?ofkP0303eIZ`3o
m^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3o
m^h0ooK^00<0ooK^0P0mFJ/20?ofkP@0?EV[00<0ooK^03eIZ`0mFJ/0>`3om^h30=@m6@80ooK^0P3D
?AT30?ofkP040000003D?AT0ooK^0?ofkP80e3dI00<0ooK^0=@m6@3om^h01`3om^h30=@m6@H0ooK^
1@3D?AT<0?ofkP80e3dI2@3om^h00`3D?AT0ooK^0?ofkP080?ofkP030000003om^h0ooK^06P0ooK^
0@3oool003@0ooK^0P00000m0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h02P3o
m^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00l0ooK^0P0mFJ/30?ofkP0303eIZ`3o
m^h0ooK^0140ooK^00<0?EV[0?ofkP3om^h02@3om^h203eIZ`D0ooK^00<0?EV[0?ofkP3om^h0303o
m^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h00P3o
m^h01@0mFJ/0ooK^03eIZ`3om^h0?EV[0080ooK^1@0mFJ/g0?ofkP@0e3dI1P3om^h30=@m6@040000
003D?AT0e3dI0=@m6@<0ooK^00<0e3dI0?ofkP3om^h0103om^h20=@m6@H0ooK^0`3D?AT30?ofkP80
e3dI2@3om^h30=@m6@`0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`000000ooK^0?ofkP1X0?ofkP40
oooo000b0?ofkP800000?P3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00L0ooK^
0P0mFJ/;0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^
0?ofkP0@0?ofkP0303eIZ`3om^h0ooK^00H0ooK^0`0mFJ/70?ofkP0303eIZ`3om^h0ooK^00d0ooK^
00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00<0ooK^
0P0mFJ/20?ofkP0403eIZ`3om^h0ooK^0?ofkP@0?EV[=03om^h40=@m6@H0ooK^0P3D?AT0103om^h0
e3dI0=@m6@0000060?ofkP040=@m6@3om^h0ooK^0?ofkP<0e3dI1@3om^h30=@m6@L0ooK^00<0e3dI
0?ofkP3om^h0103om^h30=@m6@l0ooK^00<0e3dI0?ofkP3om^h0203om^h00`000000ooK^0?ofkP1W
0?ofkP40oooo000`0?ofkP800000@03om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^
00D0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^
00D0ooK^00<0?EV[0?ofkP3om^h04@3om^h00`0mFJ/0ooK^0?ofkP030?ofkP80?EV[2`3om^h00`0m
FJ/0ooK^0?ofkP0=0?ofkP0403eIZ`3om^h0ooK^0?ofkP80?EV[1`3om^h00`0mFJ/0ooK^0?ofkP03
0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/00`3om^h403eIZc00ooK^103D?AT20?ofkP040=@m6@3o
m^h0ooK^0?ofkP<0e3dI00<0ooK^0=@m6@3D?AT00P3om^h00`000000e3dI0?ofkP030?ofkP030=@m
6@3om^h0e3dI0080e3dI1P3om^h20=@m6@X0ooK^0P3D?AT20?ofkP<0e3dI4`3om^h00`3D?AT0ooK^
0?ofkP070?ofkP030000003om^h0ooK^06L0ooK^0@3oool002d0ooK^0`0000110?ofkP0303eIZ`3o
m^h0ooK^0100ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3o
m^h0ooK^00P0ooK^0P0mFJ/90?ofkP0303eIZ`3om^h0ooK^0140ooK^00<0?EV[0?ofkP3om^h00P0m
FJ/>0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP0mFJ/00P3om^h00`0mFJ/0ooK^0?of
kP050?ofkP0303eIZ`3om^h0ooK^0080ooK^0P0mFJ/30?ofkP0303eIZ`3om^h0ooK^0080?EV[00<0
ooK^03eIZ`0mFJ/0;@3om^h40=@m6@<0ooK^00<0e3dI0?ofkP3om^h00P3D?AT0103om^h0e3dI0=@m
6@3D?AT40?ofkP040000003om^h0e3dI0=@m6@80ooK^0P3D?AT60?ofkP<0e3dI303om^h40=@m6AL0
ooK^00<0e3dI0?ofkP3om^h01`3om^h00`000000ooK^0?ofkP1V0?ofkP40oooo000[0?ofkP800000
@`3om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/04P3om^h00`0mFJ/0
ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h04@3om^h203eIZa40
ooK^00<0?EV[0?ofkP3om^h03@3om^h203eIZ`<0ooK^00<0?EV[0?ofkP3om^h01@3om^h01`0mFJ/0
ooK^0?ofkP3om^h0?EV[0?ofkP0mFJ/00P3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[0080ooK^0P0m
FJ/Y0?ofkP@0e3dI1P3om^h60=@m6@L0ooK^00<000000?ofkP3om^h0103D?AT40?ofkP<0e3dI3P3o
m^h20=@m6@80ooK^00<0e3dI0?ofkP3om^h05@3om^h00`3D?AT0ooK^0?ofkP080?ofkP030000003o
m^h0ooK^06D0ooK^0@3oool002T0ooK^0P0000140?ofkP0303eIZ`3om^h0ooK^01@0ooK^00<0?EV[
0?ofkP0mFJ/0503om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[
0?ofkP3om^h03P3om^h203eIZ`030?ofkP0mFJ/0ooK^0100ooK^00<0?EV[0?ofkP3om^h03P3om^h0
1@0mFJ/0ooK^0?ofkP3om^h0?EV[00P0ooK^00H0?EV[0?ofkP3om^h0?EV[0?ofkP0mFJ/30?ofkP06
03eIZ`3om^h0ooK^0?ofkP0mFJ/0ooK^0`0mFJ/V0?ofkP@0e3dI1P3om^h20=@m6@030?ofkP3D?AT0
e3dI00X0ooK^00<000000=@m6@3D?AT00P3om^h20=@m6@040?ofkP3D?AT0e3dI0=@m6@h0ooK^0`3D
?AT01@3om^h0e3dI0?ofkP3om^h0e3dI01L0ooK^0P3D?AT90?ofkP030000003om^h0ooK^06D0ooK^
0@3oool002L0ooK^0P0000150?ofkP0303eIZ`3om^h0?EV[01H0ooK^00<0?EV[0?ofkP3om^h0503o
m^h0100mFJ/0ooK^0?ofkP3om^h203eIZa00ooK^00<0?EV[0?ofkP3om^h02`3om^h203eIZ`@0ooK^
00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP80?EV[103om^h00`0mFJ/0ooK^
0?ofkP050?ofkP0303eIZ`3om^h0?EV[00<0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`020?ofkP80
?EV[00<0ooK^03eIZ`0mFJ/08`3om^h50=@m6@D0ooK^1P3D?AT;0?ofkP030=@m6@000000ooK^00<0
ooK^0`3D?AT?0?ofkP80e3dI103om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI01@0ooK^0P3D?AT20?of
kP030=@m6@3om^h0ooK^00L0ooK^00<000000?ofkP3om^h0I03om^h10?ooo`009@3om^h2000004L0
ooK^00@0?EV[0?ofkP3om^h0?EV[503om^h00`0mFJ/0ooK^03eIZ`0F0?ofkP0303eIZ`3om^h0?EV[
01<0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^
00l0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^03eIZ`040?ofkP0303eIZ`3om^h0ooK^
00D0ooK^0P0mFJ/40?ofkP0:03eIZ`3om^h0ooK^0?ofkP0mFJ/0ooK^03eIZ`3om^h0?EV[0?ofkP80
?EV[803om^h40=@m6@030?ofkP3D?AT0e3dI00<0ooK^0P3D?AT01@3om^h0e3dI0=@m6@3om^h0e3dI
00T0ooK^0`3D?AT0103om^h000000?ofkP3om^h20=@m6@030?ofkP3D?AT0e3dI00`0ooK^0`3D?AT6
0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT04@3om^h30=@m6@@0ooK^00<0e3dI0?ofkP3om^h01`3o
m^h00`000000ooK^0?ofkP1T0?ofkP40oooo000S0?ofkP800000B03om^h00`0mFJ/0ooK^0?ofkP02
0?ofkP0303eIZ`3om^h0ooK^0100ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0F0?ofkP0303eIZ`3o
m^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h01P3om^h203eIZ`T0ooK^00<0?EV[0?ofkP3om^h03`3o
m^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0403eIZ`3om^h0ooK^03eIZ`@0ooK^00<0?EV[0?ofkP3om^h0
1`0mFJ/40?ofkP0403eIZ`3om^h0ooK^0?ofkP80?EV[00@0ooK^03eIZ`3om^h0ooK^0P0mFJ/L0?of
kPD0e3dI1@3om^h60=@m6@<0ooK^00<0e3dI0?ofkP3om^h01@3om^h20=@m6@@0ooK^00<000000=@m
6@3D?AT00`3om^h00`3D?AT0ooK^0=@m6@090?ofkP80e3dI2@3om^h00`3D?AT0ooK^0?ofkP020?of
kP030=@m6@3om^h0ooK^00`0ooK^0P3D?AT80?ofkP030=@m6@3om^h0ooK^00L0ooK^00<000000?of
kP3om^h0H`3om^h10?ooo`008@3om^h2000004X0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0
ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h04P3om^h00`0mFJ/0
ooK^03eIZ`0D0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0
ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h02@0mFJ/50?ofkPH0
?EV[00d0ooK^03eIZ`3om^h0ooK^03eIZ`3om^h0?EV[0?ofkP0mFJ/0ooK^03eIZ`3om^h0?EV[01T0
ooK^1@3D?AT40?ofkPL0e3dI103om^h00`3D?AT0ooK^0?ofkP030?ofkP<0e3dI103om^h20=@m6@03
0000003om^h0ooK^00<0ooK^00@0e3dI0?ofkP3om^h0e3dI1@3om^h30=@m6@/0ooK^00<0e3dI0?of
kP3om^h00`3om^h00`3D?AT0ooK^0?ofkP080?ofkP<0e3dI2P3om^h00`3D?AT0ooK^0?ofkP080?of
kP030000003om^h0ooK^0680ooK^0@3oool00240ooK^0P0000190?ofkP0303eIZ`3om^h0ooK^00D0
ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^0100
ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0D0?ofkP0303eIZ`3om^h0ooK^0080ooK^0P0mFJ/>0?of
kP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h01`3om^h403eIZ`<0ooK^00<0?EV[0?of
kP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0?EV[00<0ooK^100mFJ/00`3o
m^h0?EV[03eIZ`020?ofkP0303eIZ`3om^h0?EV[0080?EV[5@3om^h60=@m6@@0ooK^0P3D?AT00`3o
m^h0e3dI0=@m6@040?ofkP80e3dI0P3om^h0103D?AT0ooK^0?ofkP3om^h20=@m6@D0ooK^0P3D?AT2
0?ofkP030000003om^h0ooK^00<0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@020?ofkP80e3dI3@3o
m^h20=@m6@D0ooK^00<0e3dI0?ofkP3om^h01P3om^h20=@m6@h0ooK^00<0e3dI0?ofkP3om^h01`3o
m^h00`000000ooK^0?ofkP1R0?ofkP40oooo000Q0?ofkP030000003om^h0000004P0ooK^00<0?EV[
0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[
0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^0180ooK^00@0?EV[
0?ofkP0mFJ/0?EV[403om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0403eIZ`3om^h0ooK^0?ofkPD0?EV[
00<0ooK^03eIZ`3om^h01@3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^0080ooK^
00@0?EV[0?ofkP3om^h0?EV[103om^h00`0mFJ/0ooK^03eIZ`0203eIZ`<0ooK^00<0?EV[0?ofkP0m
FJ/00P0mFJ/B0?ofkPD0e3dI0P3om^h00`3D?AT0ooK^0=@m6@050=@m6@P0ooK^0`3D?AT00`3om^h0
e3dI0=@m6@040?ofkP<0e3dI1@3om^h00`000000ooK^0?ofkP020?ofkP040=@m6@3om^h0ooK^0?of
kP<0e3dI303om^h30=@m6@030?ofkP3D?AT0ooK^00D0ooK^00<0e3dI0?ofkP3om^h00P3om^h30=@m
6A00ooK^00<0e3dI0?ofkP3om^h0203om^h00`000000ooK^0?ofkP1Q0?ofkP40oooo000P0?ofkP05
0000003om^h0ooK^0?ofkP000000AP3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^
00T0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^
00D0ooK^00<0?EV[0?ofkP3om^h04P3om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP0303eIZ`3om^h0ooK^
00h0ooK^100mFJ/50?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h00P3om^h01@0m
FJ/0ooK^0?ofkP3om^h0?EV[0080ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP03
03eIZ`80ooK^00@0?EV[0?ofkP0mFJ/0?EV[3`3om^h50=@m6@@0ooK^1P3D?AT<0?ofkP<0e3dI103o
m^h20=@m6@P0ooK^00<000000?ofkP3om^h00P3om^h0103D?AT0ooK^0=@m6@3D?AT20?ofkP030=@m
6@3om^h0ooK^00P0ooK^0P3D?AT40?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h0
0P3D?ATD0?ofkP030=@m6@3om^h0ooK^00L0ooK^00<000000?ofkP3om^h0H@3om^h10?ooo`00803o
m^h00`000000ooK^0?ofkP020?ofkP800000@`3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3o
m^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3o
m^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h0403om^h00`0mFJ/0ooK^03eIZ`0C0?ofkP0303eIZ`3o
m^h0ooK^00/0ooK^0P0mFJ/20?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h01P3o
m^h00`0mFJ/0ooK^0?ofkP020?ofkP0403eIZ`3om^h0ooK^03eIZ`@0ooK^00<0?EV[0?ofkP3om^h0
0`3om^h0100mFJ/0ooK^03eIZ`3om^h403eIZ`80ooK^0P0mFJ/<0?ofkPD0e3dI103om^h50=@m6@`0
ooK^103D?AT00`3om^h0e3dI0?ofkP030=@m6@X0ooK^00@000000?ofkP3om^h0ooK^0`3D?AT40?of
kP030=@m6@3om^h0ooK^00D0ooK^0`3D?AT70?ofkP030=@m6@3om^h0ooK^00<0ooK^0`3D?ATG0?of
kP030=@m6@3om^h0ooK^00L0ooK^00<000000?ofkP3om^h0H03om^h10?ooo`00803om^h00`000000
ooK^0?ofkP040?ofkP030000003om^h0ooK^0400ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0
ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0
ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^00h0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0C0?of
kP0303eIZ`3om^h0ooK^00L0ooK^0`0mFJ/50?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?of
kP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0?EV[00D0ooK^00<0?EV[0?of
kP3om^h00`3om^h203eIZ`80ooK^00P0?EV[0?ofkP0mFJ/0?EV[0?ofkP0mFJ/0ooK^03eIZ`P0ooK^
1@3D?AT40?ofkPH0e3dI2`3om^h30=@m6@<0ooK^00@0e3dI0?ofkP3D?AT0e3dI3@3om^h010000000
ooK^0=@m6@3D?AT20?ofkP030=@m6@3om^h0ooK^00<0ooK^00@0e3dI0?ofkP3om^h0ooK^0`3D?AT:
0?ofkP040=@m6@3om^h0ooK^0?ofkP80e3dI0P3om^h00`3D?AT0ooK^0?ofkP0E0?ofkP030=@m6@3o
m^h0ooK^00P0ooK^00<000000?ofkP3om^h0G`3om^h10?ooo`00803om^h00`000000ooK^0?ofkP05
0?ofkP030000003om^h0ooK^03h0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP04
0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP09
0?ofkP0303eIZ`3om^h0ooK^00`0ooK^0P0mFJ/50?ofkP0303eIZ`3om^h0ooK^0140ooK^00<0?EV[
0?ofkP3om^h00`3om^h303eIZ`T0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0;0?ofkP0303eIZ`3o
m^h0ooK^0080ooK^0P0mFJ/60?ofkP0303eIZ`3om^h0ooK^0080ooK^00D0?EV[0?ofkP0mFJ/0ooK^
03eIZ`030?ofkP<0?EV[00<0ooK^03eIZ`3om^h0103om^h50=@m6@030?ofkP3D?AT0e3dI00<0e3dI
00D0ooK^0=@m6@3D?AT0ooK^0=@m6@0:0?ofkP80e3dI1@3om^h30=@m6@80ooK^00<0e3dI0?ofkP3o
m^h02@3om^h00`3D?AT000000=@m6@040?ofkP030=@m6@3om^h0ooK^00<0ooK^103D?AT=0?ofkP@0
e3dI103om^h00`3D?AT0ooK^0?ofkP0F0?ofkP030=@m6@3om^h0ooK^00L0ooK^00<000000?ofkP3o
m^h0G`3om^h10?ooo`007`3om^h00`000000ooK^0?ofkP070?ofkP030000003om^h0ooK^03d0ooK^
00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00l0ooK^
00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00X0ooK^
00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP0303eIZ`3om^h0ooK^0080?EV[
3@3om^h0100mFJ/0ooK^0?ofkP0mFJ/<0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3o
m^h01@3om^h00`0mFJ/0ooK^0?ofkP020?ofkP80?EV[0P3om^h0100mFJ/0ooK^0?ofkP3om^h303eI
Z`030?ofkP0mFJ/0ooK^00D0e3dI103om^h20=@m6@040?ofkP3D?AT0e3dI0=@m6@<0ooK^00<0e3dI
0?ofkP3om^h01@3om^h30=@m6@D0ooK^0P3D?AT00`3om^h0e3dI0?ofkP020?ofkP030=@m6@3om^h0
ooK^00L0ooK^0P3D?AT00`3om^h000000?ofkP040?ofkP030=@m6@3om^h0ooK^0080ooK^0`3D?AT>
0?ofkP80e3dI203om^h00`3D?AT0ooK^0?ofkP0E0?ofkP030=@m6@3om^h0ooK^00P0ooK^00<00000
0?ofkP3om^h0GP3om^h10?ooo`007`3om^h00`000000ooK^0?ofkP080?ofkP030000003om^h0ooK^
03/0ooK^00<0?EV[0?ofkP3om^h0403om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[0180ooK^00<0?EV[
0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[
0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP80?EV[403om^h203eIZ`030?ofkP0mFJ/0
ooK^00/0ooK^00@0?EV[0?ofkP3om^h0ooK^0P0mFJ/70?ofkP0303eIZ`3om^h0ooK^0080ooK^00D0
?EV[0?ofkP3om^h0ooK^03eIZ`030?ofkP<0?EV[00<0000003eIZ`3D?AT00P3D?AT30?ofkPH0e3dI
0`3om^h00`3D?AT0ooK^0=@m6@050?ofkP<0e3dI1@3om^h30=@m6@<0ooK^00<0e3dI0?ofkP3om^h0
0P3om^h00`3D?AT0ooK^0?ofkP030?ofkP<0e3dI0P3om^h2000000D0ooK^00<0e3dI0?ofkP3D?AT0
0P3D?AT30?ofkP030=@m6@3om^h0ooK^00P0ooK^0`3D?AT00`3om^h0e3dI0?ofkP070?ofkP030=@m
6@3om^h0ooK^01D0ooK^0P3D?AT90?ofkP030000003om^h0ooK^05h0ooK^0@3oool001l0ooK^00<0
00000?ofkP3om^h02@3om^h00`000000ooK^0?ofkP0j0?ofkP0303eIZ`3om^h0ooK^0140ooK^00<0
?EV[0?ofkP0mFJ/0503om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[0140ooK^00<0?EV[0?ofkP3om^h0
1P3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00h0ooK^0P0mFJ/00`3om^h0?EV[
0?ofkP0?0?ofkP80?EV[0P3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0?EV[0080ooK^
00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP020?ofkP80?EV[0`3om^h00`0mFJ/00000
0000000203eIZ`0401L60P0mFJ/0?EV[0=@m6@<0ooK^0P3D?AT00`3om^h0e3dI0=@m6@070?ofkP80
e3dI0P3om^h30=@m6@D0ooK^0`3D?AT60?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3o
m^h00P3D?AT30?ofkP8000000P3om^h010000000ooK^0?ofkP3om^h30=@m6@H0ooK^00<0e3dI0?of
kP3om^h01P3om^h20=@m6@D0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP0B0?of
kP80e3dI00<0ooK^0=@m6@3om^h02@3om^h00`000000ooK^0?ofkP1M0?ofkP40oooo000O0?ofkP03
0000003om^h0ooK^00X0ooK^00<000000?ofkP3om^h0>03om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP03
03eIZ`3om^h0ooK^01@0ooK^00<0?EV[0?ofkP0mFJ/04`3om^h00`0mFJ/0ooK^0?ofkP040?ofkP03
03eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h0303om^h203eIZ`@0ooK^00<0?EV[0?ofkP3o
m^h03@3om^h203eIZ`80ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^03eIZ`030?ofkP03
03eIZ`3om^h0ooK^00@0ooK^00L0?EV[0?ofkP3om^h0ooK^03eIZ`3om^h0?EV[00D0000000@05`H2
03eIZ`0mFJ/05`H20P0mFJ/00`000000e3dI0=@m6@030=@m6@X0ooK^0`3D?AT60?ofkP80e3dI2@3o
m^h00`3D?AT0ooK^0?ofkP030?ofkP<0e3dI0P3om^h3000000@0ooK^00H000000?ofkP3D?AT0e3dI
0?ofkP3D?AT80?ofkP030=@m6@3om^h0ooK^0080ooK^0`3D?AT70?ofkP030=@m6@3om^h0ooK^00H0
ooK^00<0e3dI0?ofkP3om^h03`3om^h30=@m6@@0ooK^00<0e3dI0?ofkP3om^h0203om^h00`000000
ooK^0?ofkP1L0?ofkP40oooo000N0?ofkP030000003om^h0ooK^00`0ooK^0P00000h0?ofkP80?EV[
4`3om^h00`0mFJ/0ooK^03eIZ`0F0?ofkP0303eIZ`3om^h0ooK^01<0ooK^00@0?EV[0?ofkP3om^h0
ooK^0P0mFJ/?0?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0
ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0?EV[0080ooK^00<0?EV[0?ofkP3om^h02P3om^h203eIZ`<0
ooK^00<0?EV[0?ofkP3om^h01@3om^h01P0mFJ/0ooK^0?ofkP0mFJ/0000003eIZ`8000001@0G1P80
1@0mFJ/000000000000]2`@0?EV[0080e3dI2`3om^h30=@m6@030?ofkP3D?AT0ooK^0080ooK^0`3D
?AT;0?ofkP030=@m6@3om^h0ooK^00<0e3dI0P3om^h3000000H0ooK^0P3D?AT01@000000ooK^0?of
kP3om^h0e3dI00P0ooK^00<0e3dI0?ofkP3om^h00P3D?AT:0?ofkP030=@m6@3om^h0ooK^00L0ooK^
00<0e3dI0?ofkP3om^h0303om^h20=@m6@L0ooK^00<0e3dI0?ofkP3om^h0203om^h00`000000ooK^
0?ofkP1L0?ofkP40oooo000N0?ofkP030000003om^h0ooK^00h0ooK^00<000000?ofkP3om^h0=03o
m^h0100mFJ/0ooK^0?ofkP0mFJ/B0?ofkP0403eIZ`3om^h0ooK^03eIZa@0ooK^00<0?EV[0?ofkP0m
FJ/05@3om^h00`0mFJ/0ooK^03eIZ`0B0?ofkP0303eIZ`3om^h0ooK^00L0ooK^0P0mFJ/80?ofkP03
03eIZ`3om^h0ooK^00/0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`020?ofkP0303eIZ`3om^h0ooK^
00T0ooK^0P0mFJ/40?ofkP0303eIZ`3om^h0ooK^00H0?EV[00H0000003eIZ`0000005`H203eIZ`00
000201L60P<000000P0mFJ/302d;108000002@3om^h20=@m6@030?ofkP3D?AT0ooK^0080ooK^0`3D
?AT>0?ofkP<0e3dI0`3om^h2000000030?ofkP3D?AT0ooK^00@0ooK^0P3D?AT30?ofkP040000003o
m^h0ooK^0=@m6@P0ooK^0`3D?AT<0?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h0
203om^h30=@m6@X0ooK^00<0e3dI0?ofkP3om^h0203om^h00`000000ooK^0?ofkP1K0?ofkP40oooo
000N0?ofkP030000003om^h0ooK^00l0ooK^00<000000?ofkP3om^h0<`3om^h01@0mFJ/0ooK^0?of
kP3om^h0?EV[0100ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0503eI
Z`3om^h0ooK^0?ofkP0mFJ/05@3om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^00D0
ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^0080
ooK^00@0?EV[0?ofkP3om^h0?EV[2@3om^h:03eIZ`<0ooK^100000001@0mFJ/05`H201L60P0G1P80
?EV[008000000`0]2`@00`0mFJ/0;@/403eIZ`0202d;108000001P3om^h30=@m6@<0ooK^00H0e3dI
0?ofkP3D?AT0e3dI0?ofkP3D?AT=0?ofkP<0e3dI0P3om^h3000000<0ooK^00<0e3dI0?ofkP3om^h0
0`3D?AT60?ofkP040000003om^h0ooK^0=@m6@@0ooK^0`3D?AT20?ofkP030=@m6@3om^h0ooK^00/0
ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP060?ofkP80e3dI3@3om^h00`3D?AT0
ooK^0?ofkP090?ofkP030000003om^h0ooK^05X0ooK^0@3oool001h0ooK^00<000000?ofkP3om^h0
403om^h00`000000ooK^0?ofkP0a0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h0
3@3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h0
0P3om^h00`0mFJ/0ooK^0?ofkP0A0?ofkP0303eIZ`3om^h0?EV[01@0ooK^00<0?EV[0?ofkP3om^h0
0P3om^h203eIZ`d0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP040?ofkP0503eI
Z`3om^h0ooK^03eIZ`3om^h01`0mFJ/01@3om^h0?EV[0?ofkP3om^h0?EV[00@0ooK^00<0?EV[0000
000000000P00000301L60P0603eIZ`0G1P8000000000000]2`@0?EV[100]2`@01@0mFJ/0;@/402d;
100mFJ/0;@/400<000000`3om^h20=@m6@D0ooK^0`3D?AT40?ofkP030=@m6@3om^h0ooK^00L0ooK^
0`3D?AT20?ofkP<000001P3om^h30=@m6@T0ooK^00@000000?ofkP3om^h0e3dI0P3om^h20=@m6@D0
ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^0080
ooK^0`3D?AT@0?ofkP030=@m6@3om^h0ooK^00P0ooK^00<000000?ofkP3om^h0FP3om^h10?ooo`00
7P3om^h00`000000ooK^0?ofkP0A0?ofkP030000003om^h0ooK^0300ooK^00<0?EV[0?ofkP3om^h0
103om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h0
3@3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00l0ooK^00D0?EV[0?ofkP3om^h0
ooK^03eIZ`0D0?ofkP0403eIZ`3om^h0?EV[03eIZa00ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0m
FJ/0ooK^0?ofkP050?ofkPD0?EV[1`3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^
0080000000<0?EV[01L60P0000000`0G1P800`0mFJ/000000000000302d;10030000000mFJ/0;@/4
00<0;@/400D0?EV[02d;10000000?EV[04lC200300000080e3dI1@3om^h20=@m6@030?ofkP3D?AT0
ooK^00D0ooK^00<0e3dI0?ofkP3om^h0103om^h20=@m6@<0ooK^0P0000000`3D?AT0ooK^0?ofkP04
0?ofkP80e3dI0P3om^h00`3D?AT0ooK^0?ofkP080?ofkP030000003om^h0e3dI0080e3dI203om^h0
0`3D?AT0ooK^0?ofkP090?ofkP80e3dI2P3om^h00`3D?AT0ooK^0?ofkP020=@m6A<0ooK^00<0e3dI
0?ofkP3om^h02@3om^h00`000000ooK^0?ofkP1I0?ofkP40oooo000M0?ofkP030000003om^h0ooK^
01<0ooK^00<000000?ofkP3om^h0;P3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^
00X0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^
00H0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^
0180ooK^00<0?EV[0?ofkP3om^h04@3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^
00<0ooK^0P0mFJ/20?ofkP0303eIZ`3om^h0?EV[00L0ooK^00<0?EV[0?ofkP3om^h00`3om^h30000
00805`H200H0?EV[01L60P0000005`H20000000mFJ/602d;100703eIZ`0]2`@0;@/402d;10000000
?EV[0000000204lC200303eIZ`000000;ciZ00800000103om^h20=@m6@<0ooK^00<0e3dI0?ofkP3o
m^h01@3om^h00`3D?AT0ooK^0?ofkP030=@m6@80ooK^0`0000020?ofkP040=@m6@3om^h0ooK^0?of
kP<0e3dI1@3om^h00`3D?AT0ooK^0?ofkP060?ofkP80e3dI00<000000=@m6@3om^h02P3om^h00`3D
?AT0ooK^0?ofkP060?ofkP80e3dI00<0ooK^0=@m6@3om^h02@3om^h30=@m6AD0ooK^00<0e3dI0?of
kP3om^h02@3om^h00`000000ooK^0?ofkP1I0?ofkP40oooo000M0?ofkP030000003om^h0ooK^01@0
ooK^00<000000?ofkP3om^h0;@3om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00P0
ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^00P0
ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^0100
ooK^00<0?EV[0?ofkP0mFJ/04`3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^0080
ooK^0P0mFJ/50?ofkP0303eIZ`3om^h0?EV[00H0ooK^00<0?EV[0?ofkP3om^h00`00000601L60P05
03eIZ`000000000002d;100mFJ/01P0]2`@01P000000?EV[000000000000Ca<803eIZ`@0Ca<800<0
?EV[02lnJP0000000P0000030=@m6@D0ooK^00<0e3dI0?ofkP3om^h01@3om^h30=@m6@<0ooK^0P00
00050?ofkP040=@m6@3om^h0e3dI0=@m6@P0ooK^00<0e3dI0?ofkP3om^h0103om^h20=@m6@80ooK^
00<000000=@m6@3om^h02P3om^h00`3D?AT0ooK^0?ofkP030?ofkP<0e3dI0`3om^h00`3D?AT0ooK^
0?ofkP050?ofkP<0e3dI00<0ooK^0=@m6@3om^h05P3om^h00`3D?AT0ooK^0?ofkP090?ofkP030000
003om^h0ooK^05P0ooK^0@3oool001d0ooK^00<000000?ofkP3om^h05@3om^h2000002d0ooK^00<0
?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0
?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0
?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP80?EV[0`3om^h00`0mFJ/0ooK^0?of
kP0@0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h00P0mFJ/80?ofkP0303eIZ`3o
m^h0?EV[00D0ooK^00<0?EV[0000000000000P00000401L60P<0000000D0;@/403eIZ`0]2`@0;@/4
03eIZ`0502d;10<0000000@0?EV[04lC201?4`P0?EV[101?4`P00`0mFJ/0000002lnJP020=@m6@P0
ooK^00<0e3dI0?ofkP3om^h00P3om^h30=@m6@80ooK^00@0e3dI00000000000000001P3om^h30=@m
6@/0ooK^00<0e3dI0?ofkP3om^h00`3D?AT50?ofkP030000003om^h0ooK^00X0ooK^00<0e3dI0?of
kP3om^h00P3D?AT70?ofkP040=@m6@3om^h0ooK^0?ofkP<0e3dI1@3om^h00`3D?AT0ooK^0?ofkP0D
0?ofkP030=@m6@3om^h0ooK^00X0ooK^00<000000?ofkP3om^h0E`3om^h10?ooo`007@3om^h00`00
0000ooK^0?ofkP0G0?ofkP030000003om^h0ooK^02T0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0m
FJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0m
FJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00L0ooK^0P0mFJ/;0?ofkP0303eIZ`3om^h0ooK^
00/0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0603eIZ`3om^h0ooK^
0?ofkP0mFJ/0ooK^0P0mFJ/:0?ofkP0403eIZ`3om^h0ooK^03eIZ`<0ooK^00<0?EV[000000000000
0P0G1P800`0000005`H200000002000000@0;@/400@0?EV[02d;100]2`@0?EV[0P0]2`@300000007
04lC20000000Ca<804lC200mFJ/0Ca<803eIZ`0504lC2080e3dI00<0;ciZ0000000000001`3om^h0
0`3D?AT0ooK^0?ofkP020=@m6@<0ooK^0`0000000`3D?AT0ooK^0?ofkP040?ofkP80e3dI00<0ooK^
0=@m6@3om^h02`3om^h30=@m6@P0ooK^00<0e3dI0000003om^h02P3om^h30=@m6@T0ooK^00@0e3dI
0?ofkP3D?AT0e3dI203om^h00`3D?AT0ooK^0?ofkP0E0?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0
00000?ofkP3om^h0E`3om^h10?ooo`00703om^h00`000000ooK^0?ofkP0I0?ofkP030000003om^h0
ooK^02P0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0
ooK^00d0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0
ooK^00D0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0
ooK^00H0ooK^00<0?EV[0?ofkP3om^h0403om^h00`0mFJ/0ooK^0?ofkP0203eIZ`d0ooK^00L0?EV[
0?ofkP3om^h0?EV[0=@m6@000000?EV[00<05`H20`00000702d;10040000000mFJ/0000003eIZ`80
0000101?4`P010000000Ca<804lC201?4`P203eIZ`@0Ca<80P00000302lnJP8000001P3om^h30=@m
6@<0ooK^0P0000030?ofkP040=@m6@3om^h0ooK^0?ofkP<0e3dI0`3om^h00`3D?AT0ooK^0?ofkP07
0?ofkP<0e3dI0P3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0000000L0ooK^0`3D?AT0
0`3om^h0e3dI0?ofkP080?ofkP<0e3dI2`3om^h00`3D?AT0ooK^0?ofkP0D0?ofkP030=@m6@3om^h0
ooK^00X0ooK^00<000000?ofkP3om^h0EP3om^h10?ooo`00703om^h00`000000ooK^0?ofkP0J0?of
kP030000003om^h0ooK^02H0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP020?of
kP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP0>0?of
kP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP060?of
kP80?EV[2P3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP80?EV[3P3om^h40000000503eIZ`0000005`H2
03eIZ`0G1P800P0000000`0]2`@0000002d;100602d;10<000000P0mFJ/604lC20080000001?4`P0
Ca<804lC200mFJ/0Ca<803eIZ`1?4`P200000003070M3@00000000000080;ciZ0P0000030?ofkP@0
e3dI0P3om^h3000000H0ooK^0`3D?AT60?ofkP030=@m6@3om^h0ooK^00D0ooK^0P3D?AT50?ofkP03
0=@m6@3om^h0ooK^00L0ooK^00<0e3dI0000003om^h0103om^h20=@m6@D0ooK^00<0e3dI0?ofkP3o
m^h00`3om^h30=@m6@030?ofkP3D?AT0ooK^00/0ooK^00<0e3dI0?ofkP3om^h05@3om^h00`3D?AT0
ooK^0?ofkP090?ofkP030000003om^h0ooK^05H0ooK^0@3oool001`0ooK^00<000000?ofkP3om^h0
6`3om^h00`000000ooK^0?ofkP0U0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00@0?EV[0?ofkP3om^h0
?EV[4P3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[0140ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0B
0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP0>
0?ofkP80?EV[00<0ooK^03eIZ`3om^h02`3om^h20000000501D60P000000000001L60P0000000P0m
FJ/2000000<0;@/400<0000002d;100]2`@00`0]2`@20000000504lC20000000Ca<804lC200mFJ/0
1`1?4`P010000000Ca<804lC201?4`P203eIZ`070000001`7@d0L1d=070M3@000000?56@00000002
02lnJP8000000P3D?AT30?ofkP<000001`3om^h20=@m6@030?ofkP3D?AT0ooK^00L0ooK^00@0e3dI
0?ofkP3om^h0ooK^0`3D?AT80?ofkP030=@m6@3om^h0ooK^00H0ooK^00@0e3dI0?ofkP000000ooK^
0`3D?AT70?ofkP030=@m6@3om^h0ooK^00<0e3dI1@3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m
6@3om^h0ooK^01<0ooK^0P3D?AT<0?ofkP030000003om^h0ooK^05D0ooK^0@3oool001`0ooK^00<0
00000?ofkP3om^h0703om^h00`000000ooK^0?ofkP0S0?ofkP0303eIZ`3om^h0ooK^0100ooK^00<0
?EV[0?ofkP0mFJ/04`3om^h00`0mFJ/0ooK^03eIZ`0C0?ofkP0303eIZ`3om^h0?EV[01@0ooK^00<0
?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00/0ooK^0P0m
FJ/20?ofkP0303eIZ`3om^h0?EV[00T0ooK^1@00000201L60P040000000G1P80000003eIZ`D0;@/4
00@0000002d;100]2`@0;@/40P00000304lC20030000001?4`P0Ca<80080?EV[1P1?4`P01P000000
Ca<8000000000000L1d=03eIZ`@0L1d=00D0000003aAT00lDI00000002lnJP0300000080ooK^0P00
00000`3D?AT0ooK^0?ofkP040?ofkP<0e3dI103om^h00`3D?AT0ooK^0?ofkP050?ofkP@0e3dI303o
m^h00`3D?AT0ooK^0?ofkP050?ofkP040=@m6@3om^h0e3dI000000X0ooK^0`3D?AT80?ofkP030=@m
6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h0403om^h30=@m6@030?ofkP3D?AT0ooK^00`0ooK^
00<000000?ofkP3om^h0E03om^h10?ooo`00703om^h00`000000ooK^0?ofkP0M0?ofkP030000003o
m^h0ooK^0280ooK^00<0?EV[0?ofkP3om^h04@3om^h00`0mFJ/0ooK^0?ofkP0C0?ofkP0303eIZ`3o
m^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h0503om^h0100mFJ/0ooK^03eIZ`0mFJ/@0?ofkP0303eI
Z`3om^h0ooK^00P0ooK^0P0mFJ/30?ofkP0503eIZ`3om^h0?EV[0?ofkP0mFJ/01P3om^h4000000@0
5`H20`0000000`0mFJ/0;@/403eIZ`0402d;10040000000]2`@00000000000D0Ca<800<0000004lC
200mFJ/00P1?4`P00`0mFJ/0Ca<804lC200204lC20<000000`1`7@d203eIZ`<0L1d=00L0000003aA
T00lDI00000002lnJP000000;ciZ00<000000P3om^h0103D?AT0ooK^0?ofkP3om^h30=@m6@L0ooK^
00<0e3dI0?ofkP3om^h0103om^h20=@m6@l0ooK^00<0e3dI0?ofkP3om^h0103om^h30=@m6@80ooK^
00<000000?ofkP3om^h0103om^h30=@m6@030?ofkP3D?AT0ooK^00P0ooK^00<0e3dI0?ofkP3om^h0
2`3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP<0e3dI1@3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030000
003om^h0ooK^05@0ooK^0@3oool001/0ooK^00<000000?ofkP3om^h07`3om^h200000280ooK^0P0m
FJ/B0?ofkP80?EV[4`3om^h00`0mFJ/0ooK^03eIZ`0C0?ofkP0303eIZ`3om^h0?EV[01H0ooK^00<0
?EV[0?ofkP3om^h04@3om^h00`0mFJ/0ooK^0?ofkP050?ofkP80?EV[103om^h01`0mFJ/0ooK^0?of
kP3om^h0?EV[0?ofkP0mFJ/00P3om^h5000000<05`H20`000000100]2`@0000002d;100mFJ/202d;
100303eIZ`0]2`@0;@/400<00000201?4`P01@000000?EV[04lC201?4`P0?EV[0080Ca<80P000000
0`1`7@d000000=@m6@03070M3@0303eIZ`1`7@d0?EV[00<0L1d=00<0000003aAT00lDI000`000000
0`0_?VX000000?ofkP020?ofkP040=@m6@3om^h0e3dI0=@m6@/0ooK^00<0e3dI0?ofkP3om^h00`3D
?AT00`3om^h0e3dI0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00<0e3dI00<0ooK^0=@m6@3om^h00P3o
m^h00`000000ooK^0?ofkP020?ofkP80e3dI1@3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3o
m^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h02P3om^h20=@m6@P0ooK^00<0e3dI0?ofkP3om^h02`3o
m^h00`000000ooK^0?ofkP1C0?ofkP40oooo000K0?ofkP030000003om^h0ooK^0240ooK^00<00000
0?ofkP3om^h07`3om^h00`0mFJ/0ooK^03eIZ`0@0?ofkP0403eIZ`3om^h0ooK^03eIZa80ooK^00@0
?EV[0?ofkP3om^h0?EV[4@3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[01@0ooK^00<0?EV[0?ofkP0m
FJ/04`3om^h00`0mFJ/0ooK^0?ofkP020?ofkP80?EV[1P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP03
03eIZ`000000000000<000000P0G1P84000000@0;@/400<0000003eIZ`0]2`@00`0]2`@0100mFJ/0
000004lC2000000904lC20070000000mFJ/0Ca<804lC20000000?EV[00000003070M3@030000001`
7@d0L1d=0080L1d=00<0?EV[070M3@0mFJ/00`1`7@d30000000403aAT0000000000002lnJP800000
00@0ooK^0=@m6@3D?AT0e3dI3@3om^h30=@m6@@0ooK^00<0e3dI0?ofkP3om^h03P3om^h30=@m6@@0
ooK^00<0e3dI0?ofkP3om^h00P3om^h010000000e3dI0=@m6@3D?AT70?ofkP030=@m6@3om^h0ooK^
00L0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP060?ofkP<0e3dI2P3om^h00`3D
?AT0ooK^0?ofkP0;0?ofkP030000003om^h0ooK^05<0ooK^0@3oool001/0ooK^00<000000?ofkP3o
m^h08P3om^h00`000000ooK^0?ofkP0M0?ofkP0403eIZ`3om^h0ooK^0?ofkP80?EV[3P3om^h01@0m
FJ/0ooK^0?ofkP3om^h0?EV[0100ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP0>
0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h0403om^h01@0mFJ/0ooK^0?ofkP3o
m^h0?EV[01<0ooK^00@0?EV[0?ofkP0mFJ/0?EV[1`3om^h00`0mFJ/0ooK^0?ofkP040000000303eI
Z`0000005`H200805`H20`00000602d;10040000000]2`@0?EV[02d;10<0000000@0Ca<803eIZ`1?
4`P000002@1?4`P0100mFJ/0Ca<8000000000002070M3@0503eIZ`1`7@d0L1d=070M3@000000101`
7@d0100mFJ/0L1d=070M3@0mFJ/3000000@0?56@00<0000002lnJP0_?VX00P3D?AT00`3om^h0e3dI
0?ofkP0;0?ofkP80e3dI0P3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00/0ooK^
0`3D?AT00`3om^h0e3dI0?ofkP050?ofkP030=@m6@3om^h0e3dI0080e3dI00<000000?ofkP3om^h0
203om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h0
0`3om^h30=@m6@h0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`000000ooK^0?ofkP1B0?ofkP40oooo
000K0?ofkP030000003om^h0ooK^02<0ooK^00<000000?ofkP3om^h0703om^h00`0mFJ/0ooK^0?of
kP030?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?of
kP0=0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?of
kP040?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?of
kP0A0?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP0000001@0000000`0G1P80?EV[01L6
0P020000000302d;10000000;@/400H0;@/400@0000003eIZ`00000000001@1?4`P00`0mFJ/00000
04lC200704lC20030000000mFJ/0000000D0L1d=00@0?EV[070M3@1`7@d00000101`7@d01`0mFJ/0
L1d=000000000000?EV[070M3@0000000`0lDI00100mFJ/0e3dI0=@m6@3D?AT3000000030=@m6@3o
m^h0ooK^00L0ooK^0`3D?AT40?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h02@3o
m^h20=@m6@D0ooK^00<0e3dI0?ofkP3om^h00`3om^h20=@m6@<0ooK^00<000000?ofkP3om^h0203o
m^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3D?AT00P3D
?ATA0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<000000?ofkP3om^h0D@3om^h10?ooo`006P3om^h0
0`000000ooK^0?ofkP0U0?ofkP030000003om^h0ooK^01/0ooK^00<0?EV[0?ofkP3om^h0103om^h0
0`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h02`3om^h0
0`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h01P3om^h0
0`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h03`3om^h0
0`0mFJ/0ooK^03eIZ`060?ofkP0303eIZ`000000000000<0000000H05`H20000000G1P805`H20000
000mFJ/302d;10030000000]2`@0;@/400@0;@/40P0000000`0mFJ/0Ca<804lC200604lC200303eI
Z`1?4`P0Ca<800@0Ca<80P0000000`1`7@d0?EV[070M3@06070M3@0403eIZ`1`7@d0L1d=00000080
L1d=0`000003070M3@0403eIZ`000000?56@03aAT080e3dI0P00000202lnJP80000000<0e3dI0?of
kP3om^h01@3om^h20=@m6@P0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP050?of
kP<0e3dI1`3om^h00`3D?AT0ooK^0?ofkP040=@m6@D0ooK^00<000000?ofkP3om^h0203om^h00`3D
?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00/0ooK^0`3D?ATD0?ofkP030=@m6@3om^h0ooK^
00`0ooK^00<000000?ofkP3om^h0D@3om^h10?ooo`006P3om^h00`000000ooK^0?ofkP0V0?ofkP03
0000003om^h0ooK^01X0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP080?ofkP03
03eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP070?ofkP80
?EV[2@3om^h00`0mFJ/0ooK^0?ofkP080?ofkP80?EV[2`3om^h00`0mFJ/0ooK^0?ofkP070?ofkP03
03eIZ`3om^h0ooK^00d0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`040?ofkP0303eIZ`0000000000
008000000`0G1P8300000080;@/400<0?EV[02d;100000001@0]2`@20000000304lC200mFJ/0Ca<8
00P0Ca<800@0?EV[04lC201?4`P0Ca<80`000002070M3@0303eIZ`000000L1d=00H0L1d=00<0?EV[
070M3@1`7@d00`000000100mFJ/0L1d=070M3@1`7@d20000000408/U40000000e3dI0=@m6@80?56@
00P0000003aAT0000000;ciZ0000000_?VX0e3dI000000<0ooK^0`3D?AT;0?ofkP050=@m6@3om^h0
ooK^0?ofkP3D?AT0103om^h30=@m6@X0ooK^0`3D?AT30?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0
00000?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00L0ooK^0`3D
?AT00`3om^h0e3dI0?ofkP0E0?ofkP030=@m6@3om^h0ooK^00`0ooK^00<000000?ofkP3om^h0D03o
m^h10?ooo`006P3om^h00`000000ooK^0?ofkP0W0?ofkP030000003om^h0ooK^01P0ooK^00<0?EV[
0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00L0ooK^0P0mFJ/9
0?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP0:
0?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP0;
0?ofkP80?EV[103om^h00`0mFJ/0ooK^0?ofkP020000000303eIZ`3D?AT0000000<05`H20`000004
02d;100303eIZ`0]2`@0000000<0;@/40P00000304lC200303eIZ`1?4`P0Ca<800L0Ca<800@00000
03eIZ`00000000001@1`7@d00`0mFJ/00000070M3@07070M3@<000000P1`7@d0100mFJ/000000000
0000000308/U400300000015H:h000000080?56@00<0000003aAT00lDI000P0000000`0_?VX0e3dI
000000030=@m6@h0ooK^00H0e3dI0?ofkP3om^h0ooK^0=@m6@3om^h30=@m6@X0ooK^0`3D?AT00`3o
m^h0e3dI0?ofkP030?ofkP030=@m6@3om^h0ooK^00D0ooK^00<000000?ofkP3om^h01`3om^h00`3D
?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00@0ooK^0`3D?AT50?ofkP030=@m6@3om^h0ooK^
01<0ooK^00<0e3dI0?ofkP3om^h0303om^h00`000000ooK^0?ofkP1@0?ofkP40oooo000J0?ofkP03
0000003om^h0ooK^02P0ooK^0P00000H0?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3o
m^h01@3om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3o
m^h02`3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3o
m^h01@3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3o
m^h01@3om^h30000000303eIZ`0G1P80000000805`H20P0000000`0]2`@0000002d;100502d;1003
03eIZ`000000e3dI00800000101?4`P00`0mFJ/0000004lC200704lC20<0000000<0?EV[070M3@1`
7@d0101`7@d00`0mFJ/00000070M3@04070M3@<0000000H0L1d=03eIZ`000000L1d=0000000mFJ/6
08/U400400000015H:h0AF2^00000080?56@00P0000003aAT00lDI00000002lnJP3D?AT0;ciZ0000
0140ooK^00<0e3dI0?ofkP3D?AT00P3D?AT;0?ofkP80e3dI1@3om^h01@3D?AT0ooK^0?ofkP3om^h0
e3dI00L0ooK^00<000000?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP040?ofkP80e3dI103om^h2
0=@m6@P0ooK^00<0e3dI0?ofkP3om^h0503om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030000003om^h0
ooK^04l0ooK^0@3oool001T0ooK^00<000000?ofkP3om^h0:`3om^h00`000000ooK^0?ofkP0E0?of
kP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0:0?of
kP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP020?of
kP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP0<0?of
kP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h00`3om^h40000000301L60P0mFJ/05`H2
00@000000P0]2`@00`000000;@/402d;100502d;10030000000mFJ/0000000H0Ca<800<0?EV[0000
001?4`P01@1?4`P200000005070M3@3D?AT0L1d=070M3@0mFJ/0101`7@d00`0mFJ/0L1d=00000002
070M3@<00000101`7@d01@000000?EV[0000002;9A00?EV[00H0RbD@00@0000004EP[P15H:h00000
0P0lDI000`000000?56@03aAT002000000040=@m6@0_?VX0;ciZ000000l0ooK^0`3D?AT00`3om^h0
e3dI0?ofkP080?ofkP<0e3dI1`3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00D0
ooK^00<000000?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP030=@m6@030?ofkP3D?AT0ooK^00<0
e3dI2P3om^h00`3D?AT0ooK^0?ofkP0D0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<000000?ofkP3o
m^h0CP3om^h10?ooo`006@3om^h00`000000ooK^0?ofkP0/0?ofkP030000003om^h0ooK^01@0ooK^
00<0?EV[0?ofkP3om^h02P3om^h203eIZ`<0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^
0?ofkP020?ofkP0303eIZ`3om^h0ooK^00h0ooK^00@0?EV[0?ofkP3om^h0?EV[4P3om^h01@0mFJ/0
ooK^0?ofkP3om^h0?EV[0100ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP060000
00805`H200@0?EV[00000000000000001@0]2`@00`000000;@/402d;100202d;10<0000000<0Ca<8
0000000mFJ/01@1?4`P00`0mFJ/0Ca<80000000304lC20<000000`1`7@d01@000000L1d=070M3@1`
7@d0?EV[00<0L1d=00<0?EV[070M3@0000000P000004070M3@<0000000D0RbD@0000000mFJ/0RbD@
03eIZ`0608/U400700000015H:h0AF2^04EP[P000000?56@0000000303aAT0040000000_?VX0e3dI
02lnJP800000303om^h20=@m6@80ooK^00<0e3dI0?ofkP3D?AT01P3om^h30=@m6@/0ooK^00D0e3dI
0?ofkP3om^h0ooK^0=@m6@080?ofkP030000003om^h0ooK^00H0ooK^0`3D?AT30?ofkP<0e3dI3P3o
m^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<000000?ofkP3om^h0CP3o
m^h10?ooo`006@3om^h00`000000ooK^0?ofkP0]0?ofkP030000003om^h0ooK^0180ooK^00<0?EV[
0?ofkP3om^h03@3om^h0100mFJ/0ooK^0?ofkP0mFJ/?0?ofkP0403eIZ`3om^h0ooK^03eIZa80ooK^
00<0?EV[0?ofkP0mFJ/04`3om^h00`0mFJ/0ooK^03eIZ`0B0?ofkP0303eIZ`3om^h0ooK^00<0ooK^
00<0?EV[0?ofkP0000001P0000000`0G1P80000003eIZ`02000000H0;@/400<0000002d;10000000
0`00000404lC20030000001?4`P0?EV[00@0Ca<800@0?EV[04lC20000000Ca<80P000006070M3@03
0000001`7@d0L1d=0080L1d=00<0?EV[070M3@1`7@d00`000004070M3@800000102;9A0010000000
?EV[08/U400mFJ/608/U400300000015H:h0AF2^0080AF2^0P00000303aAT080000000<0e3dI02ln
JP0000000P0000080?ofkP<0e3dI1@3om^h00`3D?AT0ooK^0=@m6@030?ofkP80e3dI3P3om^h01@3D
?AT0ooK^0?ofkP3om^h0e3dI00P0ooK^00<000000?ofkP3om^h00`3om^h30=@m6@030?ofkP3D?AT0
ooK^00<0e3dI0P3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^01@0ooK^00<0e3dI
0?ofkP3om^h03@3om^h00`000000ooK^0?ofkP1=0?ofkP40oooo000I0?ofkP030000003om^h0ooK^
02h0ooK^00<000000?ofkP3om^h04@3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP80?EV[4@3om^h00`0m
FJ/0ooK^03eIZ`0C0?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3om^h04P3om^h00`0m
FJ/0ooK^0?ofkP0203eIZ`@000000P0G1P840000000402d;100mFJ/0;@/4000000D0;@/40`000008
04lC20040000001?4`P0Ca<803eIZ`80Ca<800<0?EV[04lC200000000P000008070M3@030000001`
7@d0L1d=00<0L1d=0P000002070M3@030000001`7@d00000008000001P2;9A0010000000RbD@03eI
Z`0mFJ/608/U400300000015H:h0AF2^00<0AF2^00L0000003aAT00lDI00?56@0000000lDI00e3dI
0080;ciZ0`0000040?ofkP<0e3dI203om^h00`3D?AT0ooK^0=@m6@030=@m6A40ooK^00@0e3dI0?of
kP3om^h0e3dI2@3om^h00`000000ooK^0=@m6@020=@m6@<0ooK^0`3D?AT50?ofkP030=@m6@3om^h0
ooK^00`0ooK^00<0e3dI0?ofkP3om^h04`3om^h20=@m6A00ooK^00<000000?ofkP3om^h0C03om^h1
0?ooo`006@3om^h00`000000ooK^0?ofkP0_0?ofkP030000003om^h0ooK^0100ooK^00<0?EV[0?of
kP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0303eIZ`3om^h0ooK^0140ooK^00<0?EV[0?of
kP0mFJ/04`3om^h00`0mFJ/0ooK^03eIZ`0D0?ofkP80?EV[1000000201L60P<000000`0]2`@00`0m
FJ/0;@/40000000402d;1080000000<0Ca<80000001?4`P01`1?4`P00`000000Ca<804lC200204lC
200603eIZ`1?4`P0?EV[0000001`7@d000002@1`7@d00`000000L1d=070M3@0300000003070M3@0m
FJ/0L1d=00<000002@2;9A0010000000RbD@08/U400mFJ/608/U400300000015H:h0AF2^00<0AF2^
0P00000203aAT0090000000lDI00e3dI0000000_?VX0000002lnJP000000ooK^00<0e3dI2`3om^h3
0=@m6A@0ooK^00@0e3dI0?ofkP3om^h0e3dI203om^h20=@m6@040000003om^h0ooK^0?ofkP<0e3dI
00<0ooK^0=@m6@3om^h01@3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00l0ooK^
0`3D?AT00`3om^h0e3dI0?ofkP0?0?ofkP030000003om^h0ooK^04`0ooK^0@3oool001P0ooK^00<0
00000?ofkP3om^h0<@3om^h00`000000ooK^0?ofkP0?0?ofkP80?EV[403om^h203eIZa40ooK^0P0m
FJ/B0?ofkP0403eIZ`3om^h0ooK^03eIZa40ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0B0?ofkPH0
000000@05`H20000000000000000100]2`@0100mFJ/0;@/402d;1000000202d;108000000`1?4`P0
0`000000Ca<804lC200604lC20040000001?4`P0Ca<804lC2080000000D0?EV[070M3@1`7@d0L1d=
00000009070M3@<000000`1`7@d01@0mFJ/0000003eIZ`2;9A00000000X0RbD@00<0000008/U402;
9A000P0mFJ/508/U400300000015H:h0AF2^00<0AF2^0P00000203aAT0070000000lDI00e3dI0000
000_?VX0000002lnJP020=@m6@`0ooK^0P3D?AT00`3om^h0e3dI0=@m6@0E0?ofkP040=@m6@3om^h0
ooK^0=@m6@@0ooK^0`3D?AT30?ofkP030000003D?AT0e3dI00D0ooK^00<0e3dI0?ofkP3om^h0103o
m^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00`0ooK^0`3D?AT50?ofkP030=@m6@3o
m^h0ooK^00h0ooK^00<000000?ofkP3om^h0B`3om^h10?ooo`00603om^h00`000000ooK^0?ofkP0b
0?ofkP8000003`3om^h00`0mFJ/0ooK^03eIZ`0>0?ofkP0403eIZ`3om^h0ooK^03eIZ`l0ooK^00@0
?EV[0?ofkP3om^h0?EV[403om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00h0ooK^
00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkPH0000000<05`H2000000000000
0P00000202d;10090000000]2`@0;@/402d;100mFJ/0;@/403eIZ`000000e3dI008000001@1?4`P0
0`000000Ca<804lC200604lC20080000001?4`P000000000001`7@d0?EV[070M3@0mFJ/2070M3@03
0000001`7@d0L1d=00D0L1d=0`000003070M3@80000000D0?EV[08/U402;9A00?EV[0000000908/U
40040000002;9A00RbD@03eIZ`80RbD@00<0?EV[08/U402;9A000P2;9A000`000000AF2^04EP[P03
04EP[P0300000015H:h000000080?56@00<000000=@m6@0lDI000`3D?AT00`0_?VX0000000000008
0?ofkP<0e3dI103om^h00`3D?AT0ooK^0?ofkP0C0?ofkP050=@m6@3om^h0ooK^0=@m6@3om^h00`3D
?AT40?ofkP80e3dI00<000000?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3o
m^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h02@3om^h20=@m6@P0ooK^00<0e3dI0?ofkP3om^h03P3o
m^h00`000000ooK^0?ofkP1;0?ofkP40oooo000H0?ofkP030000003om^h0ooK^03@0ooK^00<00000
0?ofkP3om^h0303om^h0100mFJ/0ooK^0?ofkP0mFJ/=0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/0
3P3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00l0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0
ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h01`3om^h300000004
01D60P0000000000000000805`H20P00000402d;10050000000]2`@0;@/402d;100mFJ/00P0]2`@0
0`000000?EV[0000000604lC20030000001?4`P0Ca<800H0Ca<80`000002070M3@0703eIZ`1`7@d0
L1d=070M3@0mFJ/0L1d=00000004070M3@<000000P1`7@d01P000000L1d=000000000000RbD@03eI
Z`<0RbD@00<0?EV[0000002;9A00202;9A0010000000RbD@08/U400mFJ/308/U400303eIZ`2;9A00
RbD@008000001@15H:h01@000000AF2^04EP[P000000?56@00<0e3dI00<0?56@0000000000000P0_
?VX2000000D0ooK^0P3D?AT70?ofkP030=@m6@3om^h0ooK^01@0ooK^103D?AT40?ofkP<0e3dI0`3o
m^h00`000000ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h03@3o
m^h00`3D?AT0ooK^0?ofkP060?ofkP<0e3dI2`3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030000003o
m^h0ooK^04X0ooK^0@3oool001P0ooK^00<000000?ofkP3om^h0=@3om^h00`000000ooK^0?ofkP0;
0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/0303om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3o
m^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3o
m^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3o
m^h0ooK^00@0ooK^0P00000201D60P80000000<05`H20000000G1P800P00000602d;10040000000]
2`@0;@/403eIZ`<0000000<0Ca<80000000mFJ/01P1?4`P00`000000Ca<804lC200404lC20800000
00<0L1d=0000001`7@d00P1`7@d00`0mFJ/0L1d=070M3@02070M3@0303eIZ`1`7@d0L1d=00<00000
101`7@d3000000<0RbD@00<0?EV[08/U402;9A000P2;9A000`0mFJ/0RbD@08/U400708/U40040000
002;9A00RbD@03eIZ`<0RbD@00@0?EV[000000000000X2`C0P00000404EP[P0300000015H:h0e3dI
0080e3dI00<000000=@m6@0lDI000P0lDI000`000000;ciZ02lnJP03000000040?ofkP3D?AT0e3dI
0=@m6@X0ooK^00<0e3dI0?ofkP3om^h04@3om^h30=@m6@030?ofkP3D?AT0ooK^0080ooK^0P3D?AT7
0?ofkP030000003om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP0<
0?ofkP030=@m6@3om^h0ooK^00<0ooK^0`3D?AT>0?ofkP030=@m6@3om^h0ooK^00l0ooK^00<00000
0?ofkP3om^h0B@3om^h10?ooo`005`3om^h00`000000ooK^0?ofkP0g0?ofkP030000003om^h0ooK^
00X0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^
00<0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^
00T0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^
00P0ooK^00@0?EV[0?ofkP3om^h0ooK^0P0000001@0E1P8000000000000000005`H200@0000000<0
;@/40000000]2`@0100]2`@01@000000;@/40000000mFJ/0000000<0Ca<800@0000004lC201?4`P0
?EV[1@1?4`P010000000Ca<804lC201?4`P3000000<0L1d=00@00000070M3@1`7@d0?EV[1@1`7@d0
0`0mFJ/0000000000004070M3@<0000000<0RbD@0000002;9A000P2;9A000`0mFJ/0RbD@08/U4003
08/U40030000000mFJ/0RbD@00L0RbD@00<0000008/U400mFJ/00P2;9A02000000070:0/4`0mFJ/0
X2`C0:0/4`000000Bf[30000000304EP[P80e3dI0P15H:h2000000040=@m6@0lDI00?56@03aAT080
00000P0_?VX2000000030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h03P3om^h30=@m6@<0
ooK^00<0e3dI0?ofkP3D?AT00P3D?AT:0?ofkP030000003om^h0ooK^00@0ooK^00<0e3dI0?ofkP3o
m^h00`3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0e3dI0080e3dI4P3om^h00`3D?AT0
ooK^0?ofkP0>0?ofkP030000003om^h0ooK^04T0ooK^0@3oool001L0ooK^00<000000?ofkP3om^h0
>03om^h00`000000ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h0
1`3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h0
1@3om^h203eIZ`T0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eI
Z`3om^h0ooK^00T0ooK^00<0?EV[0000000000001000000201L60P<000000P0]2`@00`000000;@/4
02d;100302d;10<0000000<0?EV[04lC201?4`P00`1?4`P01@000000Ca<804lC201?4`P0?EV[00@0
Ca<800@0000004lC2000000000001P1`7@d00`000000L1d=03eIZ`04070M3@<0000000@0?EV[070M
3@1`7@d0L1d=0P00000408/U40050000002;9A00RbD@08/U400mFJ/01@2;9A000`000000RbD@03eI
Z`0708/U40030000002;9A00?EV[00800000102P;1<00`0mFJ/0X2`C0000000204]Z``<0e3dI00<0
000004EP[P15H:h00P15H:h00`000000?56@0=@m6@0203aAT0040000000lDI00000002lnJP<00000
3@3om^h20=@m6@`0ooK^0`3D?AT50?ofkP@0e3dI303om^h00`000000ooK^0?ofkP040?ofkP030=@m
6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h0303om^h30=@m6AD0ooK^00<0e3dI0?ofkP3om^h0
3`3om^h00`000000ooK^0?ofkP180?ofkP40oooo000G0?ofkP030000003om^h0ooK^03T0ooK^00<0
00000?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0
?EV[0?ofkP3om^h01P3om^h203eIZ`L0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?of
kP050?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?of
kP080?ofkP@000000P0G1P800`0000005`H201L60P03000000@0;@/400@0000002d;100]2`@0;@/4
0P0000000`1?4`P0000003eIZ`0604lC20030000001?4`P0Ca<80080Ca<800<0?EV[04lC201?4`P0
0`000008070M3@030000000mFJ/0L1d=0080L1d=0P000002070M3@030000001`7@d0?EV[00800000
1P2;9A0010000000RbD@08/U400mFJ/608/U40040000002;9A00RbD@03eIZ`D0RbD@0`0000000`0m
FJ/0X2`C0:0/4`050:0/4`0503eIZ`000000e3dI0=@m6@0000000P15H:h00`000000AF2^04EP[P02
04EP[P80000000T0e3dI03aAT00lDI00000003aAT0000000;ciZ0000000_?VX00P00000<0?ofkP80
e3dI2P3om^h20=@m6@D0ooK^0`3D?AT0103om^h0e3dI0?ofkP3D?AT=0?ofkP030000003om^h0ooK^
00<0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP080?ofkP<0e3dI00<0ooK^0=@m
6@3om^h05@3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030000003om^h0ooK^04P0ooK^0@3oool001L0
ooK^00<000000?ofkP3om^h0>P3om^h00`000000ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00H0
ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00@0
ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00/0
ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP060?ofkP@000000`0G1P86000000D0
;@/400<0000002d;100]2`@00P00000204lC20030000000mFJ/0Ca<800H0Ca<800<0000004lC201?
4`P00P1?4`P01@000000?EV[0000001`7@d0000000P0L1d=00<0000003eIZ`1`7@d00`000003070M
3@<0000000<0RbD@03eIZ`2;9A001P2;9A0010000000RbD@08/U400mFJ/608/U40040000002;9A00
RbD@03eIZ`<0RbD@0P0000000`2P;1<0000003eIZ`080:0/4`0303eIZ`3D?AT0Bf[30080Bf[300<0
000004EP[P0000001015H:h00`000000AF2^0=@m6@0203aAT0030000000lDI00?56@0080000000@0
;ciZ0000000R:dd000002`3om^h00`3D?AT0ooK^0=@m6@060?ofkP<0e3dI103om^h30=@m6@D0ooK^
0P3D?AT>0?ofkP030000003om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^
0?ofkP060?ofkP80e3dI1@3om^h00`3D?AT0ooK^0?ofkP0D0?ofkP030=@m6@3om^h0ooK^00l0ooK^
00<000000?ofkP3om^h0A`3om^h10?ooo`005`3om^h00`000000ooK^0?ofkP0k0?ofkP8000001P3o
m^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h02P3o
m^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h00P3o
m^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h01@3o
m^h5000000805`H21000000202d;10030000000]2`@0;@/400@0;@/40`00000404lC200303eIZ`1?
4`P0Ca<800D0Ca<800<0000004lC200000000`0000001@1`7@d0?EV[070M3@1`7@d0000000P0L1d=
0`000004070M3@80000000<0RbD@0000002;9A000P2;9A000`0mFJ/0RbD@08/U400408/U40030000
002;9A00?EV[00L0RbD@00D0000008/U402;9A00RbD@03eIZ`02000000<0X2`C00<0000003eIZ`2P
;1<0202P;1<00`000000Bf[304]Z``0204]Z``8000001015H:h010000000AF2^0=@m6@00000203aA
T0030000000lDI00?56@0080000000@0;ciZ0000000R:dd000002`3om^h20=@m6@<0ooK^0`3D?AT3
0?ofkP@0e3dI203om^h00`3D?AT0ooK^0=@m6@0=0?ofkP030000003om^h0ooK^00<0ooK^00<0e3dI
0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP030?ofkP<0e3dI1`3om^h00`3D?AT0ooK^0?ofkP0D
0?ofkP030=@m6@3om^h0ooK^0100ooK^00<000000?ofkP3om^h0AP3om^h10?ooo`005P3om^h00`00
0000ooK^0?ofkP0n0?ofkP030000003om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0m
FJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00/0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0>
0?ofkP0403eIZ`3om^h0ooK^03eIZa00ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`050?ofkP<00000
00@05`H20000000G1P805`H20`00000402d;10030000000]2`@0;@/400<0;@/40`00000504lC2003
03eIZ`000000Ca<800D0Ca<80`000006070M3@0303eIZ`1`7@d0000000H0L1d=0P000000100mFJ/0
L1d=070M3@1`7@d3000000<0RbD@00<0000008/U402;9A000P2;9A000`0mFJ/0RbD@08/U400308/U
40030000002;9A00?EV[00L0RbD@00H0000008/U4000000000000:0/4`0mFJ/40:0/4`030000000m
FJ/0X2`C00L0X2`C00<0000004]Z``1;J/<0101;J/<00`000000AF2^04EP[P0204EP[P0400000015
H:h0e3dI00000080?56@00H0000003aAT00lDI00?56@0000000_?VX3000000/0ooK^00<0e3dI0?of
kP3D?AT00P3D?AT30?ofkP<0e3dI3@3om^h20=@m6@h0ooK^00<000000?ofkP3om^h00`3om^h00`3D
?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00<0e3dI2`3om^h00`3D?AT0ooK^0?ofkP0D0?of
kP030=@m6@3om^h0ooK^00l0ooK^00<000000?ofkP3om^h0AP3om^h10?ooo`005P3om^h00`000000
ooK^0?ofkP0o0?ofkP030000003om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h02@3om^h01@0mFJ/0
ooK^0?ofkP3om^h0?EV[00h0ooK^00@0?EV[0?ofkP3om^h0?EV[3`3om^h00`0mFJ/0ooK^03eIZ`0A
0?ofkP0303eIZ`3om^h0?EV[00@0ooK^0`00000201L60P030000000G1P800000008000001P0]2`@0
0`000000;@/402d;10030000000304lC20000000Ca<800@0Ca<800<0?EV[04lC20000000101?4`P2
00000003070M3@000000e3dI00L0L1d=00<0?EV[0000001`7@d00P1`7@d300000004070M3@0mFJ/0
0000070M3@8000001P2;9A000`000000RbD@08/U400308/U400303eIZ`2;9A00RbD@0080RbD@00<0
000003eIZ`2;9A001P2;9A03000000@0X2`C00D0?EV[0:0/4`2P;1<0X2`C03eIZ`090:0/4`030000
001;J/<0Bf[300@0Bf[30P00000304EP[P0700000015H:h0e3dI04EP[P000000?56@0000000303aA
T080000000@0;ciZ00000000000000002@3om^h40=@m6@80ooK^0`3D?AT@0?ofkP80e3dI3`3om^h0
0`000000ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00<0ooK^0P3D?AT>0?ofkP030=@m6@3om^h0
ooK^01@0ooK^00<0e3dI0?ofkP3om^h0403om^h00`000000ooK^0?ofkP150?ofkP40oooo000F0?of
kP030000003om^h0ooK^0400ooK^00D000000?ofkP3om^h0ooK^03eIZ`0<0?ofkP0403eIZ`3om^h0
ooK^03eIZ`l0ooK^0P0mFJ/A0?ofkP0303eIZ`3om^h0ooK^0140ooK^00@0?EV[0?ofkP3om^h0ooK^
0`00000201L60P@000000P0]2`@00`000000;@/402d;100302d;10@000000`1?4`P00`000000Ca<8
04lC200304lC200303eIZ`1?4`P0000000<0Ca<80P000003070M3@030000001`7@d0L1d=00H0L1d=
00<0000003eIZ`0000000P000003070M3@0403eIZ`0000000000000000P0RbD@00<0000008/U402;
9A00102;9A001P0mFJ/0RbD@08/U402;9A00000003eIZ`D0RbD@0P0000000`2P;1<000000:0/4`05
0:0/4`0403eIZ`2P;1<0X2`C03eIZ`T0X2`C00<0000004]Z``1;J/<0101;J/<2000000<0AF2^00D0
000004EP[P15H:h0e3dI04EP[P02000000<0?56@0P0000000`0_?VX0000000000002000000D0ooK^
0`3D?AT00`3om^h0e3dI0?ofkP030=@m6A@0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`000000ooK^
0?ofkP020?ofkP030=@m6@3om^h0e3dI00<0e3dI403om^h00`3D?AT0ooK^0?ofkP0D0?ofkP030=@m
6@3om^h0ooK^00l0ooK^00<000000?ofkP3om^h0A@3om^h10?ooo`005P3om^h00`000000ooK^0?of
kP110?ofkP040000003om^h0ooK^03eIZ`d0ooK^0P0mFJ/A0?ofkP0303eIZ`3om^h0ooK^00l0ooK^
0P0mFJ/A0?ofkP0403eIZ`3om^h0?EV[03eIZ`<0000000@05`H20000000000000000100]2`@00`00
0000;@/402d;100202d;10<000001P1?4`P00`000000Ca<804lC200204lC200503eIZ`1?4`P0Ca<8
0000001?4`P00P000005070M3@030000001`7@d0L1d=00H0L1d=0P0000000`0mFJ/0L1d=070M3@02
070M3@0403eIZ`000000RbD@000000T0RbD@00<0000008/U402;9A00102;9A001@0mFJ/0RbD@08/U
402;9A00?EV[00<0RbD@0`0000030:0/4`030000002P;1<0X2`C00@0X2`C00@0?EV[0:0/4`2P;1<0
?EV[2@2P;1<00`000000Bf[304]Z``0404]Z``030000001;J/<000000080AF2^00@0000004EP[P15
H:h0e3dI0P15H:h01P000000?56@03aAT00lDI00000003aAT080000000<0;ciZ0000000000000`3o
m^h20=@m6@@0ooK^0P3D?AT00`3om^h0e3dI0?ofkP0D0?ofkP80e3dI3`3om^h010000000ooK^0?of
kP3om^h50=@m6@030?ofkP3D?AT0ooK^00l0ooK^00<0e3dI0?ofkP3om^h04`3om^h20=@m6A80ooK^
00<000000?ofkP3om^h0A03om^h10?ooo`005@3om^h00`000000ooK^0?ofkP130?ofkP040000003o
m^h0?EV[03eIZ`d0ooK^00<0?EV[0?ofkP3om^h03`3om^h203eIZ`l0ooK^00@0?EV[0?ofkP3om^h0
?EV[403om^h01P0mFJ/000000000000G1P80000001L60P<000001@0]2`@010000000;@/402d;100]
2`@20000000304lC20000000Ca<800D0Ca<800<0000004lC201?4`P00P1?4`P00`0mFJ/0Ca<804lC
2003000000L0L1d=00<00000070M3@1`7@d00`1`7@d400000080L1d=00D0?EV[0000000000000000
03eIZ`0208/U40030000002;9A00RbD@00L0RbD@00<0000008/U402;9A001@2;9A001@0mFJ/0RbD@
08/U400mFJ/0RbD@008000001P2P;1<00`000000X2`C0:0/4`050:0/4`80?EV[00<000000:0/4`2P
;1<01`2P;1<00`000000Bf[304]Z``0404]Z``060000001;J/<0Bf[300000015H:h000000P15H:h0
0`3D?AT0AF2^04EP[P0200000080?56@00<0000003aAT00lDI000P0000000`0_?VX000000=@m6@02
0=@m6@<0ooK^0`3D?AT01@3om^h0e3dI0?ofkP3om^h0e3dI01D0ooK^00<0e3dI0?ofkP3om^h03P3o
m^h00`000000e3dI0=@m6@030=@m6@@0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?of
kP0@0?ofkP<0e3dI00<0ooK^0=@m6@3om^h04P3om^h00`000000ooK^0?ofkP130?ofkP40oooo000E
0?ofkP030000003om^h0ooK^04@0ooK^00@0000003eIZ`3om^h0?EV[303om^h203eIZa00ooK^00<0
?EV[0?ofkP0mFJ/03P3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00h0ooK^00<0?EV[0000000G1P80
100000000`0]2`@0000002d;100402d;10030000000]2`@0;@/4008000000P1?4`P00`000000Ca<8
04lC200504lC20060000001?4`P0Ca<804lC200mFJ/0Ca<80P0000000`1`7@d00000070M3@06070M
3@030000001`7@d0L1d=0080L1d=0P000003070M3@070000001`7@d000000000000mFJ/0RbD@03eI
Z`0308/U40030000002;9A00RbD@00L0RbD@00<0000008/U402;9A001P2;9A0203eIZ`800000202P
;1<00`000000X2`C0:0/4`060:0/4`0303eIZ`000000X2`C00P0X2`C00<0000004]Z``1;J/<0101;
J/<010000000Bf[304]Z``1;J/<200000080AF2^00H0e3dI04EP[P15H:h0000004EP[P00000203aA
T0030000000lDI00?56@00<0e3dI0P000000103om^h0e3dI0=@m6@3D?AT40?ofkP040=@m6@3om^h0
ooK^0=@m6AD0ooK^00<0e3dI0?ofkP3om^h02`3om^h40=@m6@050000003D?AT0ooK^0?ofkP3D?AT0
103om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00`0ooK^0`3D?AT50?ofkP030=@m
6@3om^h0ooK^0100ooK^00<000000?ofkP3om^h0@`3om^h10?ooo`005@3om^h00`000000ooK^0?of
kP150?ofkP030000000mFJ/0ooK^0080?EV[2P3om^h00`0mFJ/0ooK^03eIZ`0>0?ofkP0503eIZ`3o
m^h0ooK^0?ofkP0mFJ/03@3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00T0ooK^
00<0e3dI0000000mFJ/00`00000302d;10030000000]2`@0;@/400@0;@/40`00000404lC20030000
001?4`P0Ca<800D0Ca<800H0000004lC201?4`P0?EV[0000000mFJ/3070M3@030000001`7@d0L1d=
00D0L1d=00<00000070M3@0000000P000004070M3@<000000`2;9A000`0mFJ/0RbD@08/U400208/U
40030000002;9A00RbD@00L0RbD@00<0000008/U402;9A00102;9A030000000303eIZ`3D?AT0X2`C
00P0X2`C00<000000:0/4`2P;1<01@2P;1<00`0mFJ/0X2`C03eIZ`080:0/4`8000001P1;J/<01000
0000Bf[304]Z``1;J/<200000080AF2^00H0e3dI04EP[P15H:h0000004EP[P00000203aAT0<0e3dI
0P000000100_?VX000000000000000070?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT05@3om^h00`3D
?AT0ooK^0?ofkP060?ofkP@0e3dI00D0ooK^0=@m6@3D?AT0ooK^000000030?ofkP030=@m6@3om^h0
ooK^0080ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP80e3dI203om^h0
0`3D?AT0ooK^0?ofkP0A0?ofkP030000003om^h0ooK^0480ooK^0@3oool001D0ooK^00<000000?of
kP3om^h0AP3om^h01@0mFJ/000000?ofkP3om^h0?EV[00T0ooK^00<0?EV[0?ofkP3om^h00P0mFJ/<
0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP04
0?ofkP80?EV[1P3om^h20=@m6@D000001@0]2`@00`000000;@/402d;100202d;10<000001@1?4`P0
0`000000Ca<804lC200504lC20040000003D?AT0?EV[03eIZ`<0L1d=00<0?EV[070M3@0000001`1`
7@d3000000D0L1d=0P0000000`2;9A00000008/U400208/U400303eIZ`2;9A00?EV[00<0RbD@00<0
000008/U402;9A001`2;9A000`000000RbD@08/U400208/U408000000P2P;1<00`0mFJ/0X2`C03eI
Z`090:0/4`030000002P;1<0X2`C00D0X2`C00@0?EV[0:0/4`000000?EV[1@2P;1<2000000030;0a
5@000000000000@0Bf[300<0000004]Z``1;J/<00`1;J/<01`000000AF2^04EP[P15H:h0e3dI04EP
[P0000000P15H:h20=@m6@050000000lDI00?56@03aAT00000000P0_?VX3000000L0ooK^00@0e3dI
0?ofkP3om^h0e3dI5@3om^h00`3D?AT0ooK^0?ofkP030?ofkP<0e3dI0P3om^h30=@m6@@0ooK^00@0
00000?ofkP3om^h0e3dI1@3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00H0ooK^
0`3D?AT:0?ofkP030=@m6@3om^h0ooK^0140ooK^00<000000?ofkP3om^h0@P3om^h10?ooo`00503o
m^h00`000000ooK^0?ofkP170?ofkP0303eIZ`3om^h000000080ooK^00<0?EV[0?ofkP3om^h01P3o
m^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h00`3o
m^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00H0ooK^00@0?EV[0?ofkP3om^h0ooK^
0P3D?AT40000000302d;10000000;@/400@0;@/400<0000002d;100]2`@01000000704lC20030000
001?4`P0Ca<800@0Ca<80P0000000`0mFJ/0L1d=070M3@04070M3@0303eIZ`000000L1d=00@0L1d=
0P0000000`1`7@d00000070M3@02070M3@<000000`2;9A0010000000RbD@08/U400mFJ/308/U4004
03eIZ`2;9A00RbD@000000T0RbD@00<0000008/U400000000P0000040:0/4`0403eIZ`2P;1<00000
03eIZ`P0X2`C00<000000:0/4`2P;1<0102P;1<01`0mFJ/0X2`C0:0/4`000000X2`C03eIZ`2P;1<0
0`0000030;0a5@030000001>L=00000000<0Bf[300<0000004]Z``1;J/<00`1;J/<200000080AF2^
00<0e3dI04EP[P3D?AT00P3D?AT00`15H:h000000000000303aAT080000000D0;ciZ000000000000
?EV[000000060?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT0503om^h20=@m6@040?ofkP3D?AT0e3dI
0=@m6@80ooK^0`3D?AT80?ofkP040000003om^h0ooK^0=@m6@@0ooK^00<0e3dI0?ofkP3om^h03P3o
m^h00`3D?AT0ooK^0?ofkP030?ofkP<0e3dI3@3om^h00`3D?AT0ooK^0?ofkP0B0?ofkP030000003o
m^h0ooK^0440ooK^0@3oool001@0ooK^00<000000?ofkP3om^h0A`3om^h0100mFJ/0ooK^0?ofkP00
00020?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?of
kP080?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?of
kP080?ofkP0403eIZ`3D?AT0e3dI0=@m6@800000100]2`@00`000000;@/402d;100202d;10@00000
0`1?4`P00`000000Ca<804lC200504lC20040000001?4`P0Ca<804lC20<0000000<0L1d=03eIZ`1`
7@d01`1`7@d00`0mFJ/0L1d=070M3@03000000<0L1d=00@000000=@m6@00000000001P2;9A000`00
0000RbD@03eIZ`0508/U400303eIZ`2;9A00000000P0RbD@0`0000060:0/4`0603eIZ`2P;1<0X2`C
0000002P;1<0?EV[1`2P;1<00`000000X2`C0:0/4`040:0/4`0703eIZ`2P;1<0X2`C0000002P;1<0
000003eIZ`060;0a5@040000001>L=00CW3@00000080Bf[300<0000004]Z``1;J/<00`1;J/<00`00
0000Bf[3000000030=@m6@0300000015H:h0AF2^0080AF2^00H0000003aAT00lDI00?56@0000000l
DI020000000402lnJP0000000000000000D0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0D0?ofkP<0
e3dI0`3om^h20=@m6@`0ooK^00<000000?ofkP3D?AT0103om^h00`3D?AT0ooK^0?ofkP0?0?ofkP03
0=@m6@3om^h0e3dI0080e3dI4@3om^h00`3D?AT0ooK^0?ofkP0B0?ofkP030000003om^h0ooK^0400
ooK^0@3oool001@0ooK^00<000000?ofkP3om^h0A`3om^h01@0mFJ/0ooK^0?ofkP3om^h000000080
ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00H0
ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00D0
ooK^103D?AT00`0mFJ/0ooK^0000000502d;10030000000]2`@0;@/40080;@/40P00000504lC2003
0000001?4`P0Ca<800D0Ca<800<0000004lC200000000P000003070M3@0303eIZ`000000L1d=00L0
L1d=0`000005070M3@<00000202;9A000`000000?EV[08/U400608/U400303eIZ`000000RbD@00D0
RbD@0P0000000`2P;1<000000:0/4`050:0/4`0703eIZ`2P;1<0X2`C0:0/4`000000X2`C03eIZ`07
0:0/4`030000002P;1<0X2`C00<0X2`C00<0?EV[0:0/4`2P;1<00`0000000`2`<AD0?EV[0;0a5@04
0;0a5@050000001>L=00CW3@04i`d00000000P1;J/<00`000000Bf[304]Z``0304]Z``070000003D
?AT0e3dI0000003D?AT0AF2^0000000404EP[P8000000P0lDI002@000000?56@0000000_?VX00000
02lnJP0000008R]=000000040?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT04@3om^h30=@m6@030?of
kP3D?AT0ooK^00<0e3dI3P3om^h00`000000ooK^0=@m6@050?ofkP030=@m6@3om^h0ooK^00d0ooK^
0`3D?ATD0?ofkP030=@m6@3om^h0ooK^0180ooK^00<000000?ofkP3om^h0@03om^h10?ooo`00503o
m^h00`000000ooK^0?ofkP170?ofkP0303eIZ`3om^h0ooK^0080ooK^00@000000?ofkP3om^h0?EV[
1@3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h0
1`3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^0080ooK^103D?AT40?ofkP0303eI
Z`0]2`@0;@/400<0;@/400@0000002d;100]2`@0;@/40P00000704lC20030000001?4`P0Ca<800@0
Ca<80`000004070M3@80?EV[00<0L1d=0000001`7@d01@1`7@d200000080L1d=00<0?EV[070M3@1`
7@d00`0000000`2;9A00000008/U400808/U400303eIZ`2;9A00RbD@00L0RbD@00@0?EV[08/U402;
9A00RbD@0`0000030:0/4`030000002P;1<0X2`C00<0X2`C00<0?EV[0:0/4`2P;1<00P2P;1<01000
0000X2`C0:0/4`0mFJ/60:0/4`030000002P;1<0X2`C00<0X2`C00D0?EV[000000000000/34E0000
00030;0a5@0303eIZ`2`<AD0/34E0080/34E00<0000004i`d01>L=000P1>L=000`000000Bf[30000
000304]Z``<0e3dI0`1;J/<00`000000e3dI0000000404EP[P8000000P0lDI000`000000?56@03aA
T00200000080;ciZ0`0000040?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT03P3om^h20=@m6@<0ooK^
0`3D?ATB0?ofkP030000003om^h0e3dI00@0ooK^00<0e3dI0?ofkP3om^h02P3om^h30=@m6@030?of
kP3D?AT0ooK^01@0ooK^00<0e3dI0?ofkP3om^h04`3om^h00`000000ooK^0?ofkP0o0?ofkP40oooo
000D0?ofkP030000003om^h0ooK^04P0ooK^00<0?EV[0?ofkP3om^h00P3om^h010000000ooK^0?of
kP0mFJ/40?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^
0?ofkP080?ofkP0303eIZ`3om^h0ooK^0080ooK^00@0?EV[0?ofkP3om^h0ooK^103D?AT40?ofkP03
0=@m6@000000?EV[00@0;@/400<0000002d;100]2`@00P0000000`1?4`P0000004lC200504lC2003
0000001?4`P0Ca<800<0Ca<80P0000000`1`7@d00000070M3@03070M3@0503eIZ`1`7@d0L1d=070M
3@0000000`1`7@d300000003070M3@000000L1d=0080000000<0?EV[0000002;9A000`2;9A000`00
0000RbD@08/U400608/U400303eIZ`000000RbD@00P0RbD@00@0000003eIZ`00000000001P2P;1<0
0`000000X2`C0:0/4`030:0/4`0303eIZ`2P;1<0X2`C0080X2`C00D000000:0/4`2P;1<0X2`C03eI
Z`050:0/4`070000002P;1<0X2`C0:0/4`000000?EV[000000030;0a5@030000002`<AD0/34E0080
/34E00D0?EV[0;0a5@2`<AD0/34E0000000504i`d08000000`3D?AT204]Z``030000001;J/<0Bf[3
0080Bf[300<0e3dI00000015H:h00`15H:h00`000000AF2^0000000203aAT0030000000lDI00?56@
0080000000@0;ciZ0000000000000000103om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00/0ooK^0`3D
?AT20?ofkP<0e3dI00<0ooK^0=@m6@3D?AT04`3om^h00`000000e3dI0?ofkP030?ofkP030=@m6@3o
m^h0ooK^00L0ooK^0`3D?AT50?ofkP030=@m6@3om^h0ooK^0180ooK^00<0e3dI0?ofkP3om^h04`3o
m^h00`000000ooK^0?ofkP0o0?ofkP40oooo000C0?ofkP030000003om^h0ooK^04T0ooK^00<0?EV[
0?ofkP3om^h00`3om^h00`000000ooK^0?ofkP0203eIZ`80ooK^00<0?EV[0?ofkP3om^h01`3om^h0
0`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00T0ooK^00D0?EV[0?ofkP3om^h0ooK^03eI
Z`050=@m6@<0ooK^1@3D?AT502d;10<000000P1?4`P00`000000Ca<804lC200504lC20030000001?
4`P0Ca<800<000000`1`7@d01@000000L1d=070M3@1`7@d0?EV[00<0L1d=00<00000070M3@000000
0P000003070M3@<000000`2;9A000`0mFJ/0RbD@08/U400208/U40030000002;9A00RbD@00D0RbD@
00<0?EV[08/U40000000202;9A030000000303eIZ`2P;1<0X2`C00D0X2`C00<000000:0/4`2P;1<0
0P2P;1<00`0mFJ/0X2`C0:0/4`030:0/4`030000002P;1<0X2`C0080X2`C00<0?EV[0:0/4`2P;1<0
0P2P;1<01P000000X2`C000000000000/34E03eIZ`@0/34E00<000000;0a5@2`<AD00`2`<AD0100m
FJ/0/34E0;0a5@00000504i`d080e3dI101;J/<00`000000Bf[304]Z``0304]Z``030=@m6@000000
AF2^00<0AF2^00H0000004EP[P15H:h0000003aAT000000303aAT0030000000_?VX0;ciZ00<00000
0`3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00D0ooK^0`3D?AT20?ofkP<0e3dI
1@3om^h00`3D?AT0ooK^0?ofkP0A0?ofkP030000003om^h0e3dI00@0ooK^00<0e3dI0?ofkP3om^h0
103om^h20=@m6@P0ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030000
003om^h0ooK^03h0ooK^0@3oool001<0ooK^00<000000?ofkP3om^h0B@3om^h00`0mFJ/0ooK^0?of
kP040?ofkP8000000P3om^h00`0mFJ/0ooK^03eIZ`0:0?ofkP80?EV[0`3om^h00`0mFJ/0ooK^0?of
kP0:0?ofkP0503eIZ`3D?AT0e3dI03eIZ`3D?AT00P3om^h00`3D?AT0ooK^0=@m6@020=@m6@040?of
kP3D?AT0e3dI000000@0;@/40`00000404lC20030000001?4`P0Ca<800@0Ca<800@0000004lC2000
000000001@1`7@d01@000000L1d=070M3@1`7@d0?EV[00@0L1d=0P000004070M3@80000000<0RbD@
0000002;9A00102;9A001@0mFJ/0RbD@08/U402;9A00000000L0RbD@00<0?EV[08/U400000001@2;
9A03000000040:0/4`000000X2`C03eIZ`L0X2`C00D000000:0/4`2P;1<0X2`C03eIZ`060:0/4`03
0000002P;1<0X2`C00<0X2`C00<0?EV[0:0/4`2P;1<00`0000020;0a5@0303eIZ`2`<AD0/34E00<0
/34E00<000000;0a5@2`<AD0102`<AD00`0mFJ/0/34E0000000204i`d0<0e3dI00<0CW3@00000000
00000`1;J/<00`000000Bf[304]Z``0304]Z``030=@m6@000000000000<0AF2^00@0000004EP[P15
H:h0AF2^0P00000303aAT080000000<0;ciZ0000000_?VX00P0000030?ofkP050=@m6@3om^h0ooK^
0?ofkP3D?AT01@3om^h20=@m6@80ooK^0`3D?AT80?ofkP80e3dI4`3om^h00`000000e3dI0?ofkP03
0?ofkP040=@m6@3om^h0ooK^0?ofkP<0e3dI2P3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3o
m^h0ooK^01@0ooK^00<000000?ofkP3om^h0?@3om^h10?ooo`004`3om^h00`000000ooK^0?ofkP1:
0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<000000?ofkP3om^h00P0mFJ/<0?ofkP0303eIZ`3om^h0
?EV[00/0ooK^0`3D?AT203eIZ`H0e3dI0P3om^h20=@m6@040?ofkP000000;@/402d;10@000001@1?
4`P00`000000Ca<804lC200404lC20<000001`1`7@d010000000L1d=03eIZ`0mFJ/2070M3@@00000
0`1`7@d2000000<0RbD@00<0000008/U402;9A00102;9A00100mFJ/0RbD@08/U4000000608/U4005
03eIZ`2;9A00RbD@0000002;9A00100000040:0/4`040000002P;1<0X2`C03eIZ`H0X2`C00@00000
0:0/4`2P;1<0?EV[1`2P;1<00`000000X2`C0:0/4`030:0/4`050000000mFJ/000000;0a5@000000
0`2`<AD00`0mFJ/0/34E0;0a5@030;0a5@030000002`<AD0/34E00D0/34E00@0?EV[0000003D?AT0
e3dI101>L=000`000000CW3@0000000204]Z``030000001;J/<0Bf[300@0Bf[300<0e3dI00000015
H:h00P15H:h01P000000AF2^04EP[P15H:h0000003eIZ`<0?56@00@0000003aAT000000000000P0_
?VX200000080ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0=@m6@020=@m6@80ooK^0P3D
?AT;0?ofkP80e3dI503om^h00`000000ooK^0?ofkP020?ofkP@0e3dI3@3om^h00`3D?AT0ooK^0?of
kP0C0?ofkP030=@m6@3om^h0ooK^01@0ooK^00<000000?ofkP3om^h0?@3om^h10?ooo`004`3om^h0
0`000000ooK^0?ofkP1:0?ofkP80?EV[1`3om^h010000000ooK^0?ofkP0mFJ/=0?ofkP80?EV[2@3o
m^h40=@m6@80ooK^00<0?EV[0?ofkP3D?AT00P3D?AT00`3om^h0e3dI0=@m6@020=@m6@030?ofkP00
00000000008000000`1?4`P00`000000Ca<804lC200304lC20040000001?4`P0Ca<804lC20<00000
00<0L1d=0000001`7@d01`1`7@d010000000?EV[070M3@1`7@d2000000<0L1d=00@00000070M3@00
000000001@2;9A000`000000RbD@08/U400508/U400303eIZ`2;9A00000000D0RbD@00<0?EV[08/U
402;9A000`0000080:0/4`050000002P;1<0X2`C0:0/4`0mFJ/01P2P;1<00`000000X2`C03eIZ`07
0:0/4`030000002P;1<0000000<000000P2`<AD00`0mFJ/0/34E000000020;0a5@0303eIZ`2`<AD0
/34E00@0/34E00<000000;0a5@2`<AD01P2`<AD00`3D?AT0CW3@04i`d00304i`d0040000001>L=00
CW3@00000080Bf[300<0000004]Z``1;J/<00`1;J/<010000000e3dI04]Z``00000204EP[P030000
0015H:h0AF2^0080AF2^00<0000003aAT00lDI000P0lDI020000000502lnJP000000;ciZ02lnJP00
00000P3om^h0103D?AT0ooK^0?ofkP3om^h30=@m6@80ooK^0`3D?AT>0?ofkP030=@m6@3om^h0ooK^
01<0ooK^00<000000?ofkP3D?AT00`3D?AT@0?ofkP030=@m6@3om^h0ooK^0180ooK^00<0e3dI0?of
kP3om^h05@3om^h00`000000ooK^0?ofkP0l0?ofkP40oooo000B0?ofkP030000003om^h0ooK^04`0
ooK^0P0mFJ/70?ofkP040000003om^h0?EV[03eIZ`d0ooK^00<0?EV[0?ofkP3om^h01@3om^h30=@m
6@@0ooK^00@0e3dI03eIZ`0mFJ/0ooK^0`3D?AT40?ofkP8000001@1?4`P00`000000Ca<804lC2003
04lC20030000001?4`P0000000800000101`7@d00`000000L1d=070M3@06070M3@0403eIZ`000000
0000000000@0L1d=0`00000708/U40030000002;9A00RbD@00H0RbD@00<0?EV[0000002;9A000`2;
9A001P0mFJ/0RbD@000000000000X2`C000000T0X2`C00<000000:0/4`2P;1<00P2P;1<00`0mFJ/0
X2`C0:0/4`030:0/4`030000000mFJ/0X2`C00H0X2`C0`0000060;0a5@0303eIZ`2`<AD000000080
/34E00<0?EV[0;0a5@2`<AD00`2`<AD00`000000/34E0;0a5@060;0a5@030000001>L=00CW3@00@0
CW3@00L0000004i`d01>L=00CW3@0000001;J/<0000000D0Bf[300L000000=@m6@1;J/<0Bf[30000
0015H:h0000000@0AF2^0P00000303aAT0040000000lDI00000003eIZ`80;ciZ0P0000000`3om^h0
e3dI0?ofkP020=@m6@030?ofkP3D?AT0e3dI0080e3dI4@3om^h20=@m6A<0ooK^00<0e3dI0000003D
?AT00`3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3o
m^h05@3om^h00`000000ooK^0?ofkP0k0?ofkP40oooo000B0?ofkP030000003om^h0ooK^04`0ooK^
00@0?EV[0?ofkP0mFJ/0?EV[1P3om^h010000000?EV[0?ofkP0mFJ/<0?ofkP80?EV[0`3om^h30=@m
6@@0ooK^0`3D?AT01@3om^h0?EV[0=@m6@0mFJ/0e3dI00D0ooK^00<0000004lC201?4`P0101?4`P0
0`000000Ca<804lC200304lC20<000001`1`7@d00`000000L1d=070M3@04070M3@<0000000<0?EV[
070M3@1`7@d00P1`7@d20000000308/U40000000RbD@00L0RbD@00<0000008/U402;9A001`2;9A00
1@0mFJ/0RbD@08/U402;9A00?EV[008000000`2P;1<00`000000X2`C0:0/4`070:0/4`030000002P
;1<0X2`C00<0X2`C00<0?EV[0:0/4`2P;1<00P2P;1<00`0mFJ/0X2`C0:0/4`040:0/4`80000000<0
/34E0000002`<AD01`2`<AD0100mFJ/000000;0a5@0mFJ/60;0a5@030000002`<AD0/34E00H0/34E
00<0000004i`d01>L=00101>L=000`000000CW3@04i`d00204i`d08000001@1;J/<00`000000e3dI
04]Z``0204]Z``8000001015H:h00`000000AF2^0000000203aAT0030000000lDI00?56@00800000
0P0_?VX200000080e3dI00<0ooK^0=@m6@3D?AT00P3D?ATC0?ofkP80e3dI403om^h30=@m6@030?of
kP3D?AT0000000<0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0B0?ofkP80e3dI
5`3om^h00`000000ooK^0?ofkP0k0?ofkP40oooo000B0?ofkP030000003om^h0ooK^04d0ooK^00@0
?EV[0?ofkP3om^h0?EV[1P3om^h010000000?EV[0?ofkP0mFJ/;0?ofkP0303eIZ`3om^h0?EV[00<0
e3dI103om^h20=@m6@80ooK^00H0e3dI03eIZ`3D?AT0e3dI0?ofkP0mFJ/50?ofkP030000001?4`P0
Ca<800@0Ca<800@0000004lC201?4`P0Ca<80P0000000`1`7@d00000070M3@07070M3@030000001`
7@d0L1d=0080L1d=0P0000001@1`7@d00000070M3@1`7@d0?EV[00<000000`2;9A000`000000RbD@
08/U400708/U40030000002;9A00RbD@00H0RbD@00@0000003eIZ`000000?EV[1P2P;1<00`000000
X2`C0:0/4`080:0/4`030000002P;1<0X2`C00<0X2`C00D0?EV[0:0/4`2P;1<0?EV[000000030:0/
4`<000000`2`<AD00`000000/34E0;0a5@070;0a5@0303eIZ`2`<AD0?EV[00H0/34E00<000000;0a
5@2`<AD01P2`<AD00`000000CW3@04i`d00404i`d0030000001>L=00CW3@00<0CW3@00<0000004]Z
``1;J/<00`1;J/<00`000000Bf[30=@m6@0204]Z``8000001015H:h01P000000AF2^04EP[P000000
?56@000000<0?56@00<0000002lnJP0_?VX00P0000030=@m6@<0ooK^00<0e3dI0?ofkP3om^h04P3o
m^h00`3D?AT0ooK^0?ofkP0<0?ofkP80e3dI1@3om^h00`3D?AT000000?ofkP020?ofkP030=@m6@3o
m^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h03`3om^h30=@m6@030?ofkP3D?AT0ooK^01L0ooK^00<0
00000?ofkP3om^h0>P3om^h10?ooo`004P3om^h00`000000ooK^0?ofkP1>0?ofkP0403eIZ`3om^h0
ooK^03eIZ`H0ooK^00@0?EV[0?ofkP3om^h0?EV[2P3om^h01@0mFJ/0e3dI0=@m6@0mFJ/0e3dI0080
ooK^0`3D?AT0203om^h0e3dI0=@m6@3D?AT0ooK^03eIZ`3om^h0e3dI0P3om^h01@0mFJ/0ooK^0?of
kP3D?AT0000000H0Ca<800<0000004lC201?4`P00P000003070M3@030000001`7@d0L1d=00D0L1d=
00<00000070M3@1`7@d00`000003070M3@050000001`7@d000000000000mFJ/01@2;9A000`000000
RbD@08/U400708/U40030000002;9A00RbD@00D0RbD@0`0000000`0mFJ/0X2`C0:0/4`050:0/4`03
0000002P;1<0X2`C00P0X2`C00<000000:0/4`2P;1<0102P;1<01@0mFJ/0X2`C03eIZ`000000X2`C
008000001P2`<AD00`000000/34E0;0a5@070;0a5@030000000mFJ/0/34E00H0/34E00<000000;0a
5@2`<AD01@2`<AD2000000D0CW3@00<0000004i`d01>L=00101>L=02000000@0Bf[300<0000004]Z
``3D?AT00`1;J/<00`000000AF2^04EP[P0204EP[P0900000015H:h0AF2^04EP[P000000?56@0000
000lDI00?EV[008000000`3D?AT00`000000e3dI0?ofkP030?ofkP030=@m6@3om^h0ooK^0180ooK^
0P3D?AT:0?ofkP<0e3dI1`3om^h0103D?AT0ooK^0000003om^h20=@m6A00ooK^00<0e3dI0?ofkP3o
m^h02`3om^h30=@m6@D0ooK^00<0e3dI0?ofkP3om^h05@3om^h00`000000ooK^0?ofkP0j0?ofkP40
oooo000B0?ofkP030000003om^h0ooK^04h0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`050?ofkP05
03eIZ`00000000000?ofkP0mFJ/0203om^h00`3D?AT0?EV[0?ofkP020=@m6@0403eIZ`3D?AT0e3dI
0?ofkP<0e3dI103om^h00`0mFJ/0e3dI0?ofkP030?ofkP0303eIZ`3D?AT0000000L0Ca<80`000004
070M3@030000001`7@d0L1d=00H0L1d=0`0000000`0mFJ/0L1d=070M3@02070M3@<000000`2;9A00
0`0mFJ/0RbD@08/U400208/U40030000002;9A00RbD@00L0RbD@00<0000008/U402;9A000`2;9A02
000000050:0/4`000000?EV[0:0/4`0mFJ/01P2P;1<00`000000X2`C0:0/4`080:0/4`030000002P
;1<0X2`C00D0X2`C00@0?EV[0000000000000000202`<AD00`000000/34E0;0a5@060;0a5@040000
000mFJ/0/34E03eIZ`H0/34E00<000000;0a5@2`<AD00`2`<AD2000000030;hf5`000000000000@0
CW3@00<0000004i`d01>L=00101>L=000`000000CW3@0000000304]Z``030000001;J/<0e3dI00<0
Bf[30P00000304EP[P0300000015H:h0AF2^0080AF2^0P00000203aAT080e3dI00<0000002lnJP00
00000P0000000`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^0180ooK^00<0e3dI0?ofkP3o
m^h01@3om^h30=@m6@X0ooK^0P3D?AT010000000e3dI0?ofkP3D?AT@0?ofkP030=@m6@3om^h0ooK^
00T0ooK^0P3D?AT80?ofkP030=@m6@3om^h0ooK^01H0ooK^00<000000?ofkP3om^h0>@3om^h10?oo
o`004@3om^h00`000000ooK^0?ofkP1@0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/0103om^h01P0m
FJ/0ooK^0?ofkP000000ooK^03eIZ`@0ooK^103D?AT01P0mFJ/0e3dI0=@m6@3D?AT0ooK^03eIZ`<0
e3dI1P3om^h00`0mFJ/0e3dI0?ofkP030=@m6@030?ofkP0mFJ/0?EV[00D0Ca<80`000006070M3@03
0000001`7@d0L1d=00@0L1d=0`00000203eIZ`80L1d=0`0000000`2;9A00000008/U400408/U4005
03eIZ`2;9A00RbD@08/U400000002@2;9A0010000000RbD@08/U402;9A0200000080X2`C0P0mFJ/3
0:0/4`0303eIZ`2P;1<0X2`C00<0X2`C00<000000:0/4`2P;1<0202P;1<00`000000X2`C0:0/4`03
0:0/4`050000000mFJ/0000003eIZ`0000002@2`<AD00`000000/34E0;0a5@060;0a5@050000000m
FJ/0/34E0;0a5@0mFJ/01@2`<AD010000000/34E0;0a5@2`<AD2000000<0_SHG00<00000051cf@00
00000`1>L=000`000000CW3@04i`d00404i`d0030000001>L=0000000080Bf[300D0000004]Z``1;
J/<0Bf[30=@m6@0204]Z``030000001;J/<000000080AF2^00<0000004EP[P15H:h00`15H:h30=@m
6@0803aAT0000000000002lnJP000000;ciZ0000003D?AT40?ofkP030=@m6@3om^h0ooK^0180ooK^
00<0e3dI0?ofkP3om^h00`3om^h20=@m6@/0ooK^0`3D?AT20?ofkP040000003om^h0ooK^0=@m6@l0
ooK^00<0e3dI0?ofkP3om^h01P3om^h30=@m6@X0ooK^00<0e3dI0?ofkP3om^h05`3om^h00`000000
ooK^0?ofkP0h0?ofkP40oooo000A0?ofkP030000003om^h0ooK^0500ooK^00<0?EV[0?ofkP3om^h0
0P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0503eIZ`3om^h0ooK^0000003om^h00P0mFJ/20=@m6@<0
ooK^00<0?EV[0=@m6@3D?AT00`3D?AT0103om^h0?EV[03eIZ`3om^h30=@m6@80ooK^00@0?EV[0=@m
6@3D?AT0e3dI0`3om^h20=@m6@<0Ca<80`0000000`1`7@d00000070M3@06070M3@040000001`7@d0
L1d=070M3@<0000000@0L1d=03eIZ`0mFJ/0L1d=0`00000408/U40030000002;9A00RbD@00@0RbD@
00@0?EV[08/U402;9A0000002@2;9A0010000000RbD@0000000000030:0/4`0303eIZ`2P;1<00000
00@0X2`C00<0?EV[0:0/4`2P;1<00`2P;1<00`000000X2`C0:0/4`070:0/4`030000002P;1<00000
00<0000000D0?EV[0;0a5@2`<AD0/34E03eIZ`090;0a5@030000002`<AD0/34E00H0/34E00<0?EV[
0;0a5@2`<AD00P2`<AD00`0mFJ/0/34E0;0a5@020;0a5@040000002`<AD00000000000D0_SHG00<0
0000051cf@0000000`1>L=000`000000CW3@04i`d00304i`d0070000001>L=00CW3@04i`d0000000
Bf[30000000304]Z``030=@m6@1;J/<000000080Bf[300@0000004EP[P15H:h000000P15H:h30=@m
6@8000000P0lDI001`000000?56@000000000000;ciZ03eIZ`3D?AT0103om^h00`3D?AT0ooK^0?of
kP0B0?ofkP80e3dI00@0ooK^0=@m6@3D?AT0e3dI2P3om^h30=@m6@<0ooK^00H0e3dI0?ofkP3om^h0
00000?ofkP3D?AT?0?ofkP030=@m6@3om^h0ooK^00<0ooK^0`3D?AT=0?ofkP030=@m6@3om^h0ooK^
01L0ooK^00<000000?ofkP3om^h0>03om^h10?ooo`004@3om^h00`000000ooK^0?ofkP1A0?ofkP03
03eIZ`3om^h0ooK^0080ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`030?ofkP<0e3dI00H0?EV[0?of
kP3om^h0ooK^0=@m6@0mFJ/20=@m6@H0ooK^00@0?EV[0?ofkP3om^h0ooK^0P3D?AT00`0mFJ/0e3dI
0?ofkP020?ofkP80e3dI00<0ooK^0000000000000P000004070M3@030000001`7@d0L1d=00D0L1d=
00@00000070M3@00000000000P1`7@d203eIZ`<000001`2;9A000`000000RbD@08/U400508/U4003
03eIZ`2;9A00000000P0RbD@0`0000040:0/4`0503eIZ`2P;1<0X2`C0:0/4`000000102P;1<00`0m
FJ/0X2`C0:0/4`020:0/4`030000002P;1<0X2`C00H0X2`C0`0000030;0a5@0303eIZ`2`<AD0/34E
0080/34E00<0000003eIZ`2`<AD01`2`<AD00`000000/34E0;0a5@050;0a5@0303eIZ`000000/34E
00@0/34E00<0?EV[0;0a5@2`<AD00`0000060;hf5`070000001@LmT0D7?I051cf@000000CW3@0000
000604i`d0030000001>L=00CW3@0080CW3@0P00000304]Z``030=@m6@1;J/<0000000<0Bf[300<0
000004EP[P3D?AT00P3D?AT304EP[P0500000015H:h0000003aAT00000000P0lDI020000000302ln
JP000000e3dI00@0ooK^00<0e3dI0?ofkP3om^h04@3om^h30=@m6@X0ooK^0`3D?AT60?ofkP040=@m
6@3om^h0ooK^00000080ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0=@m6@020=@m6A40
ooK^00<0e3dI0?ofkP3om^h05`3om^h00`000000ooK^0?ofkP0g0?ofkP40oooo000A0?ofkP030000
003om^h0ooK^0580ooK^00<0?EV[0?ofkP3om^h00P3om^h203eIZ`030?ofkP0mFJ/0e3dI00<0e3dI
00@000000?ofkP3om^h0?EV[0`3D?AT00`0mFJ/0e3dI0?ofkP070?ofkP0303eIZ`3D?AT0e3dI0080
ooK^00<0?EV[0=@m6@3om^h00P3D?AT20?ofkP8000001P1`7@d00`000000L1d=070M3@05070M3@<0
00000P1`7@d203eIZ`80000000<0RbD@0=@m6@2;9A001`2;9A000`000000RbD@08/U400608/U4003
03eIZ`000000RbD@00@0RbD@0`0000000`2P;1<000000:0/4`030:0/4`0303eIZ`2P;1<0X2`C0080
X2`C00<000000:0/4`2P;1<00`2P;1<01@0mFJ/0X2`C0:0/4`2P;1<0000000H0X2`C0P0000000`2`
<AD000000;0a5@020;0a5@0303eIZ`2`<AD0/34E00<0/34E00<000000;0a5@0mFJ/01`2`<AD00`00
0000/34E0;0a5@040;0a5@0303eIZ`2`<AD0000000D0/34E00D0000003eIZ`000000_SHG00000007
0;hf5`030000001@LmT0D7?I0080D7?I0P00000604i`d0030000001>L=00CW3@00<0CW3@00L00000
04]Z``1;J/<0Bf[30=@m6@1;J/<0000000<0Bf[30P3D?AT00`000000AF2^04EP[P0304EP[P050000
0015H:h0000003aAT00000000`0lDI001@000000;ciZ0000003D?AT0000000<0ooK^00<0e3dI0?of
kP3om^h03P3om^h30=@m6@030?ofkP3D?AT0ooK^00L0ooK^0`3D?AT90?ofkP070=@m6@3om^h0ooK^
0?ofkP000000ooK^0=@m6@0>0?ofkP<0e3dI503om^h00`3D?AT0ooK^0?ofkP0G0?ofkP030000003o
m^h0ooK^03L0ooK^0@3oool00100ooK^00<000000?ofkP3om^h0E03om^h203eIZ`@0ooK^0P0mFJ/2
0=@m6@<0ooK^0`3D?AT0100mFJ/0ooK^0?ofkP0mFJ/70?ofkP<0e3dI00D0?EV[0?ofkP3om^h0ooK^
03eIZ`030=@m6@<0ooK^00<00000070M3@1`7@d01@1`7@d00`000000L1d=070M3@02070M3@@00000
0P1`7@d203eIZ`8000000`2;9A000`000000RbD@08/U400608/U40030000002;9A00RbD@00L0RbD@
00<0?EV[08/U400000000`0000040:0/4`030000002P;1<0X2`C0080?EV[1@2P;1<00`000000X2`C
0:0/4`040:0/4`0403eIZ`2P;1<0X2`C000000<0X2`C0`0000030;0a5@040000002`<AD0/34E03eI
Z`H0/34E00@000000;0a5@2`<AD0?EV[1P2`<AD00`000000/34E0;0a5@040;0a5@0403eIZ`2`<AD0
00000;0a5@@000000P2n=QL00`0mFJ/0_SHG000000070;hf5`030000001@LmT0D7?I00<0D7?I00<0
000004i`d01>L=00101>L=000`000000CW3@04i`d00304i`d08000000`1;J/<00`3D?AT000000=@m
6@020=@m6@80Bf[300<0000004EP[P15H:h00`15H:h01P000000AF2^04EP[P000000?56@00000080
?56@0P000000100_?VX0e3dI0000000000030?ofkP030=@m6@3om^h0ooK^00X0ooK^0`3D?AT40?of
kP80e3dI103om^h30=@m6@`0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`000000e3dI0?ofkP0:0?of
kP<0e3dI00<0ooK^0=@m6@3om^h0503om^h00`3D?AT0ooK^0?ofkP0G0?ofkP800000>03om^h10?oo
o`00403om^h00`000000ooK^0?ofkP1E0?ofkP80?EV[0`3D?AT00`3om^h0?EV[03eIZ`020?ofkP@0
e3dI0P3om^h00`0mFJ/0ooK^03eIZ`050?ofkP80e3dI103om^h0100mFJ/0e3dI03eIZ`3D?AT30?of
kP80e3dI00<0ooK^0000001`7@d01P1`7@d00`000000L1d=070M3@02000000<0L1d=00H0000003eI
Z`0mFJ/0000008/U400mFJ/408/U40030000002;9A00RbD@00H0RbD@00<0000008/U402;9A001P2;
9A020000000303eIZ`2P;1<0X2`C00H0X2`C00<000000:0/4`0mFJ/01`2P;1<00`000000X2`C0:0/
4`050:0/4`0403eIZ`2P;1<000000:0/4`8000001P2`<AD00`000000/34E03eIZ`070;0a5@050000
002`<AD0/34E0;0a5@0mFJ/01@2`<AD00`000000/34E0;0a5@030;0a5@0303eIZ`2`<AD000000080
00001P2n=QL00`0mFJ/0_SHG000000070;hf5`030000001@LmT0D7?I00<0D7?I0P00000504i`d003
0000001>L=00CW3@00<0CW3@00@0000004i`d0000000Bf[30`3D?AT404]Z``0303eIZ`0000000000
00<0AF2^00<0000004EP[P15H:h00P15H:h200000080?56@00D0000003aAT000000000000=@m6@02
00000080ooK^00<0e3dI0?ofkP3om^h01P3om^h40=@m6@P0ooK^00<0e3dI0?ofkP3D?AT00P3D?AT@
0?ofkP030=@m6@3om^h0ooK^0080ooK^00<000000=@m6@3om^h01P3om^h30=@m6@@0ooK^00<0e3dI
0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP0D0?ofkP<0000000<0ooK^0000003om^h0=`3om^h1
0?ooo`00403om^h00`000000ooK^0?ofkP1D0?ofkP<0e3dI00<0?EV[0=@m6@3D?AT00P3D?AT00`0m
FJ/0e3dI0=@m6@020=@m6@80ooK^0P0000000`3om^h0?EV[03eIZ`020?ofkP<0e3dI103om^h30=@m
6@80?EV[1P3om^h00`000000L1d=070M3@06070M3@<000000`1`7@d303eIZ`030000002;9A00RbD@
0080RbD@00D0?EV[08/U402;9A00RbD@0000000808/U40030000002;9A00RbD@00@0RbD@0P000000
102P;1<0e3dI0:0/4`0mFJ/70:0/4`030000000mFJ/0X2`C00L0X2`C00<000000:0/4`2P;1<01P2P
;1<00`0mFJ/00000000000080;0a5@030000000mFJ/0/34E00L0/34E00<000000;0a5@2`<AD00P2`
<AD00`0mFJ/0/34E0;0a5@020;0a5@030000002`<AD0/34E0080/34E00D0?EV[000000000000_SHG
000000080;hf5`0303eIZ`2n=QL0_SHG00D0_SHG00<0?EV[0000001@LmT0101@LmT00`000000D7?I
0000000404i`d0030000001>L=00CW3@00<0CW3@00L000000=@m6@3D?AT0e3dI04]Z``3D?AT00000
00D0Bf[300<0000004]Z``0000000P15H:h00`000000AF2^04EP[P0304EP[P040000000lDI00?56@
03aAT080000000@0;ciZ0=@m6@0_?VX000000P3om^h00`3D?AT0ooK^0?ofkP030?ofkP<0e3dI2`3o
m^h30=@m6A<0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`000000e3dI0?ofkP040?ofkP80e3dI203o
m^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^0100ooK^0`0000040?ofkP030000003o
m^h0ooK^03H0ooK^0@3oool00100ooK^00<000000?ofkP3om^h0DP3om^h30=@m6@<0ooK^0P0mFJ/0
103D?AT0ooK^0=@m6@0mFJ/20?ofkP@0e3dI00@0ooK^0000003D?AT0?EV[0P3D?AT40?ofkP<0e3dI
103om^h00`0mFJ/0ooK^0?ofkP040?ofkP030000001`7@d0L1d=00<0L1d=0`000003070M3@<0?EV[
00<0000008/U400000001P2;9A00100mFJ/0RbD@08/U4000000808/U40040000002;9A00RbD@08/U
40<000000`2P;1<010000000X2`C0:0/4`0mFJ/60:0/4`0303eIZ`2P;1<0X2`C00L0X2`C00<00000
0:0/4`2P;1<0102P;1<2000000030;0a5@0mFJ/0/34E00P0/34E00<0?EV[0;0a5@2`<AD01`2`<AD0
0`000000/34E0;0a5@030;0a5@0603eIZ`2`<AD0/34E0;0a5@000000/34E0`0000001@0mFJ/0_SHG
0;hf5`2n=QL0000000P0_SHG00<0000003eIZ`2n=QL0102n=QL00`0mFJ/0_SHG0=@m6@04051cf@05
0000001@LmT0D7?I051cf@0000000P1>L=000`000000CW3@04i`d00204i`d0<0e3dI0P1>L=001000
0000Bf[30000003D?AT504]Z``030000001;J/<000000080AF2^00<0000004EP[P15H:h00P15H:h0
0`0mFJ/000000000000203aAT0050000000lDI0000000000003D?AT00P0000020?ofkP030=@m6@3o
m^h0e3dI0080e3dI2`3om^h30=@m6@030?ofkP3D?AT0ooK^01<0ooK^00<0e3dI0?ofkP3om^h00`3o
m^h00`000000e3dI0?ofkP030=@m6@X0ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?of
kP0=0?ofkP<00000203om^h00`000000ooK^0?ofkP0e0?ofkP40oooo000?0?ofkP030000003om^h0
ooK^0500ooK^0`3D?AT70?ofkP<0?EV[00<0ooK^03eIZ`0mFJ/01@3om^h30=@m6@80?EV[0`3om^h2
0=@m6@H0ooK^00<0e3dI03eIZ`0mFJ/0103om^h00`3D?AT00000070M3@02070M3@8000000P1`7@d0
1@000000L1d=03eIZ`0mFJ/0000000@0RbD@00<0000008/U402;9A001@2;9A000`0mFJ/0RbD@0000
000808/U40040000002;9A000000000000L0X2`C00@000000:0/4`2P;1<0?EV[0`2P;1<203eIZ`03
0:0/4`000000X2`C00P0X2`C00@000000:0/4`2P;1<0X2`C0P0000030;0a5@030000000mFJ/0/34E
00H0/34E00<0?EV[0000002`<AD0202`<AD00`000000/34E0;0a5@040;0a5@0303eIZ`2`<AD00000
008000000P2n=QL00`0mFJ/0_SHG0;hf5`020;hf5`030000002n=QL0_SHG00H0_SHG00<000000;hf
5`0mFJ/0102n=QL00`0mFJ/0_SHG0=@m6@04051cf@030000001@LmT0D7?I0080D7?I00@0000004i`
d0000000CW3@0`3D?AT00`1>L=00000004i`d00304i`d080000000<0e3dI04]Z``1;J/<00`1;J/<0
1P000000Bf[304]Z``000000AF2^000000D0AF2^00D0000004EP[P000000?56@0000000203aAT003
0000003D?AT0;ciZ0080000000<0ooK^0=@m6@3D?AT02`3om^h30=@m6@D0ooK^00<0e3dI0?ofkP3o
m^h04@3om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@000000e3dI00d0ooK^00<0e3dI0?ofkP3o
m^h04`3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP<000002`3om^h00`000000ooK^0?ofkP0e0?ofkP40
oooo000?0?ofkP030000003om^h0ooK^04h0ooK^0P3D?AT80?ofkP<0e3dI1`0mFJ/40?ofkP030=@m
6@3om^h0e3dI0080?EV[0P3D?AT80?ofkP040=@m6@0mFJ/0ooK^03eIZ`<0e3dI00<0ooK^00000000
00000P000003070M3@<0?EV[1`2;9A000`000000RbD@08/U400608/U400303eIZ`000000RbD@00H0
RbD@0`0000090:0/4`070000002P;1<0X2`C0:0/4`0mFJ/0X2`C03eIZ`030:0/4`030000002P;1<0
X2`C00L0X2`C00@0e3dI0:0/4`00000000001@2`<AD00`000000/34E03eIZ`050;0a5@0403eIZ`2`
<AD0/34E000000P0/34E00<000000;0a5@2`<AD0102`<AD010000000?EV[0;hf5`0000020;hf5`03
03eIZ`2n=QL0_SHG00<0_SHG00<000000;hf5`2n=QL01P2n=QL010000000_SHG0;hf5`0mFJ/20;hf
5`0503eIZ`2n=QL0_SHG0000003D?AT00`1@LmT00`000000D7?I051cf@02051cf@@0e3dI101>L=00
0`000000CW3@04i`d00304i`d0030000003D?AT0Bf[300@0Bf[300@0000004]Z``1;J/<0Bf[30P00
000504EP[P0500000015H:h0000003aAT00000000`0lDI000`3D?AT0;ciZ00000002000000030=@m
6@3om^h0ooK^00L0ooK^0`3D?AT80?ofkP030=@m6@3om^h0ooK^0180ooK^00<0e3dI0?ofkP3D?AT0
0P3D?AT00`3om^h000000=@m6@0=0?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h0
1`3om^h3000000h0ooK^00<000000?ofkP3om^h0=@3om^h10?ooo`003`3om^h00`000000ooK^0?of
kP1=0?ofkP030=@m6@3om^h0ooK^00D0ooK^103D?AT30?ofkP80?EV[00<0ooK^03eIZ`0mFJ/00P0m
FJ/20?ofkP060=@m6@3om^h0e3dI0=@m6@0mFJ/0e3dI0P0mFJ/80?ofkP050=@m6@0mFJ/0e3dI0=@m
6@0mFJ/00P3om^h200000080L1d=100mFJ/00`2;9A00000008/U400708/U40030000002;9A00RbD@
00L0RbD@00<0?EV[08/U402;9A000P2;9A03000000030:0/4`000000X2`C00T0X2`C00<000000:0/
4`2P;1<00P2P;1<00`0mFJ/0X2`C0:0/4`020:0/4`030000002P;1<0X2`C00H0X2`C0`0000080;0a
5@030000002`<AD0?EV[00<0/34E00D0?EV[0;0a5@2`<AD0/34E000000080;0a5@040000002`<AD0
/34E0;0a5@<000000P2n=QL0100mFJ/000000;hf5`0mFJ/60;hf5`030000002n=QL0_SHG00H0_SHG
00/000000;hf5`2n=QL0_SHG03eIZ`2n=QL0?EV[0;hf5`000000D7?I0=@m6@03051cf@030000001@
LmT0e3dI0080e3dI0P1@LmT00`000000CW3@04i`d00304i`d0030000001>L=00CW3@00<0CW3@0P00
00001@3D?AT0Bf[304]Z``1;J/<0000000D0Bf[300<0000004EP[P15H:h00`15H:h01P000000AF2^
04EP[P000000?56@00000080?56@00@000000=@m6@000000;ciZ0P0000070?ofkP80e3dI2`3om^h2
0=@m6A80ooK^0`3D?AT50?ofkP030000003om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h0503om^h0
0`3D?AT0ooK^0?ofkP020?ofkP@000004@3om^h00`000000ooK^0?ofkP0e0?ofkP40oooo000?0?of
kP030000003om^h0ooK^04`0ooK^00<0e3dI0?ofkP3om^h00`3om^h30=@m6@<0ooK^00<0e3dI0?of
kP3om^h00P3om^h203eIZ`030?ofkP0mFJ/0ooK^00<0?EV[0P3D?AT20?ofkP0503eIZ`000000e3dI
0=@m6@0mFJ/01P3om^h20=@m6@0303eIZ`3om^h0ooK^00<00000100mFJ/20000000408/U400mFJ/0
RbD@000000P0RbD@00<0000008/U402;9A001`2;9A000`000000?EV[03eIZ`02000000@0X2`C00<0
00000:0/4`2P;1<0202P;1<00`000000X2`C0:0/4`0203eIZ`030:0/4`0mFJ/0X2`C0080X2`C00<0
00000:0/4`2P;1<00`2P;1<3000000030;0a5@000000/34E00P0/34E00H000000;0a5@2`<AD0?EV[
0;0a5@0mFJ/40;0a5@030000002`<AD0/34E00H0/34E00@000000;0a5@00000000001P2n=QL00`0m
FJ/0_SHG03eIZ`060;hf5`030000002n=QL0_SHG00H0_SHG00<000000;hf5`2n=QL00P2n=QL01P0m
FJ/0_SHG0;hf5`000000D7?I0=@m6@80D7?I0`3D?AT5051cf@800000101>L=000`000000CW3@04i`
d00204i`d0040000001>L=00CW3@0=@m6@<0Bf[300<0000004]Z``1;J/<00`1;J/<2000000<0AF2^
00<0000004EP[P15H:h00P15H:h200000080?56@00L000000=@m6@0_?VX0000002lnJP000000e3dI
00<0ooK^0`3D?AT>0?ofkP030=@m6@3om^h0ooK^00d0ooK^0`3D?AT00`3om^h0e3dI0?ofkP050?of
kP030=@m6@000000ooK^00`0ooK^00<0e3dI0?ofkP3om^h04P3om^h20=@m6@040?ofkP0000000000
000001D0ooK^00<000000?ofkP3om^h0=@3om^h10?ooo`003`3om^h00`000000ooK^0?ofkP1;0?of
kP030=@m6@3om^h0ooK^0080ooK^0P3D?AT50?ofkP030=@m6@3om^h0ooK^00@0ooK^0`0mFJ/00`3o
m^h0e3dI0=@m6@0903eIZ`040=@m6@0mFJ/0ooK^0?ofkP<0e3dI00<0ooK^0=@m6@0000000P000003
03eIZ`040000001`7@d00000000000@0RbD@00<0?EV[0000002;9A00202;9A000`000000RbD@08/U
400508/U40<0000000<0X2`C03eIZ`2P;1<01@2P;1<00`000000X2`C0:0/4`070:0/4`030000000m
FJ/0?EV[00@0X2`C00D0?EV[0:0/4`2P;1<000000:0/4`04000000@0/34E00<000000;0a5@2`<AD0
1`2`<AD01@000000/34E0;0a5@2`<AD0?EV[00D0/34E00<000000;0a5@2`<AD01@2`<AD3000000P0
_SHG00<0000003eIZ`2n=QL01@2n=QL00`000000_SHG0;hf5`070;hf5`0:0000002n=QL0_SHG0;hf
5`0mFJ/0_SHG03eIZ`2n=QL00000051cf@<0e3dI00<00000051cf@1@LmT0101@LmT010000000D7?I
051cf@00000304i`d0030000001>L=00CW3@0080CW3@00D0000004i`d01>L=00e3dI0000000204]Z
``030000001;J/<0Bf[300<0Bf[300<0000004]Z``0000000P15H:h00`000000AF2^04EP[P0304EP
[P050000000lDI00?56@0000003D?AT00P0000000`0_?VX00000000000030=@m6A40ooK^00<0e3dI
0?ofkP3om^h02P3om^h30=@m6@@0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT000000?ofkP0;
0?ofkP030=@m6@3om^h0ooK^00h0ooK^103D?AT00`000000e3dI0000000I0?ofkP030000003om^h0
ooK^03@0ooK^0@3oool000h0ooK^00<000000?ofkP3om^h0B`3om^h00`3D?AT0ooK^0?ofkP030=@m
6@L0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0?EV[03eIZ`020?ofkP040=@m6@0mFJ/0ooK^
03eIZ`80ooK^00<0?EV[0?ofkP0000001`0mFJ/20000000303eIZ`3om^h0ooK^0080ooK^00<0e3dI
03eIZ`0000001`2;9A000`0mFJ/0RbD@08/U400708/U40030000002;9A00RbD@00<0RbD@0P000000
0`2P;1<0e3dI0:0/4`020:0/4`0303eIZ`2P;1<0X2`C00<0X2`C00<000000:0/4`2P;1<01P2P;1<2
03eIZ`L0X2`C00@0?EV[0000000000000000202`<AD00`000000/34E0;0a5@070;0a5@060000002`
<AD0?EV[03eIZ`2`<AD0?EV[102`<AD00`000000/34E0;0a5@020;0a5@<0000000<0_SHG0000002n
=QL0202n=QL00`0mFJ/0_SHG03eIZ`050;hf5`030000002n=QL0_SHG00H0_SHG00<000000;hf5`2n
=QL00P2n=QL0100mFJ/0_SHG0;hf5`0mFJ/20=@m6@04051cf@3D?AT0D7?I000000H0D7?I00@00000
051cf@1@LmT000000P1>L=000`000000CW3@04i`d00304i`d0080000001>L=00CW3@04i`d03D?AT0
000004]Z``00000504]Z``030000001;J/<000000080AF2^00<0000004EP[P15H:h00`15H:h20000
000503aAT0000000?56@0=@m6@0000000`3D?AT00`000000ooK^0?ofkP0A0?ofkP80e3dI1`3om^h4
0=@m6@P0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT000000?ofkP0;0?ofkP030=@m6@3om^h0
ooK^00/0ooK^0`3D?AT01P3om^h00000000000000000ooK^0=@m6AX0ooK^00<000000?ofkP3om^h0
=03om^h10?ooo`003P3om^h00`000000ooK^0?ofkP1:0?ofkP@0e3dI2@3om^h00`3D?AT0ooK^0?of
kP040?ofkP80e3dI0P3om^h02P0mFJ/0ooK^0?ofkP3D?AT0ooK^03eIZ`3om^h0?EV[0?ofkP0mFJ/3
0?ofkP030000003om^h0?EV[00<0000000<0?EV[0?ofkP0mFJ/00P3om^h20=@m6@030?ofkP000000
RbD@00L0RbD@00<0000003eIZ`2;9A001`2;9A0010000000RbD@08/U402;9A02000000<0X2`C00<0
00000:0/4`2P;1<00P2P;1<00`0mFJ/0X2`C0:0/4`020:0/4`030000002P;1<0X2`C00@0X2`C0P0m
FJ/20:0/4`030000002P;1<0X2`C0080X2`C0`0000000`0mFJ/000000;0a5@090;0a5@030000002`
<AD0/34E00H0/34E00<0000003eIZ`2`<AD00`2`<AD01P0mFJ/0/34E0;0a5@2`<AD000000;0a5@<0
0000102n=QL00`000000_SHG0;hf5`060;hf5`0503eIZ`000000_SHG0;hf5`0mFJ/0102n=QL00`00
0000_SHG0;hf5`060;hf5`050000002n=QL0_SHG0;hf5`0mFJ/00`0000000`3;>QT0000000000002
051cf@030=@m6@000000D7?I00D0D7?I00L00000051cf@1@LmT0D7?I0000001>L=00000000D0CW3@
00H0000004i`d01>L=00CW3@0=@m6@1>L=02000000D0Bf[300H0000004]Z``1;J/<0000004EP[P00
000504EP[P8000000P0lDI030=@m6@030000000_?VX00000008000004P3om^h20=@m6@@0ooK^0`3D
?AT<0?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0000003om^h02P3om^h00`3D?AT0ooK^0?of
kP070?ofkP@0e3dI00@0ooK^0000000000000000103om^h00`3D?AT0ooK^0?ofkP0H0?ofkP030000
003om^h0ooK^03@0ooK^0@3oool000h0ooK^00<000000?ofkP3om^h0B@3om^h20=@m6@`0ooK^00<0
e3dI0?ofkP3om^h00P3om^h20=@m6@D0ooK^0P0mFJ/00`3D?AT0ooK^0?ofkP0403eIZ`<0ooK^0`00
0000100mFJ/0ooK^0?ofkP3D?AT203eIZ`80e3dI0`3om^h00`000000RbD@08/U400608/U40030000
002;9A00?EV[00L0RbD@00@0000008/U4000000000001P2P;1<00`000000X2`C0:0/4`020:0/4`05
03eIZ`2P;1<0X2`C0:0/4`000000102P;1<203eIZ`@0X2`C00<000000:0/4`0000000P0000040;0a
5@0303eIZ`2`<AD0/34E00P0/34E00<000000;0a5@2`<AD01P2`<AD00`0mFJ/0/34E0;0a5@040;0a
5@0303eIZ`2`<AD00000008000001`2n=QL00`000000_SHG0;hf5`050;hf5`0303eIZ`2n=QL00000
00<0_SHG00D0?EV[0;hf5`2n=QL0_SHG000000080;hf5`050000002n=QL0000003eIZ`0000000`3;
>QT00`000000DGGN00000002051cf@030=@m6@000000D7?I00D0D7?I00<00000051cf@1@LmT00P1@
LmT2000000@0CW3@00<0000004i`d01>L=000`1>L=000`3D?AT0CW3@0000000504]Z``040000001;
J/<0Bf[304]Z``8000001@15H:h020000000e3dI0=@m6@3D?AT000000=@m6@0lDI0000000P0_?VX3
00000180ooK^1@3D?AT?0?ofkP030=@m6@3om^h0ooK^00@0ooK^0P3D?AT00`3om^h000000?ofkP0:
0?ofkP030=@m6@3om^h0ooK^00<0ooK^0`3D?AT20?ofkP<00000203om^h00`3D?AT0ooK^0?ofkP0G
0?ofkP030000003om^h0ooK^03@0ooK^0@3oool000h0ooK^00<000000?ofkP3om^h0B03om^h00`3D
?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00<0e3dI203om^h203eIZ`@0ooK^0P0mFJ/00`3o
m^h00000000000020?ofkP040000003om^h0?EV[03eIZ`80e3dI00<0?EV[0?ofkP3om^h00`3om^h0
0`000000RbD@08/U400608/U40040000002;9A00RbD@03eIZ`D0RbD@0`0000080:0/4`030000002P
;1<0X2`C00<0X2`C00@0?EV[0:0/4`2P;1<000000P2P;1<203eIZ`D0X2`C0`0000080;0a5@0303eI
Z`2`<AD0/34E00L0/34E00<000000;0a5@2`<AD0102`<AD203eIZ`030;0a5@000000/34E00<0/34E
0P0000000`0mFJ/0_SHG000000080;hf5`030000002n=QL0_SHG00@0_SHG00@0?EV[0;hf5`2n=QL0
00000`2n=QL01@0mFJ/0_SHG0;hf5`2n=QL0000000L0_SHG0`0000000`3;>QT0?EV[0</j6@030</j
6@070000001AMMh0DGGN0000001@LmT0e3dI00000005051cf@030000001@LmT0D7?I00@0D7?I00<0
000004i`d01>L=000P1>L=000`000000CW3@04i`d00304i`d0040=@m6@1>L=000000000000<0Bf[3
00<0000004]Z``1;J/<00`1;J/<00`000000AF2^04EP[P0204EP[P80e3dI0P15H:h20000000503aA
T03D?AT000000000000_?VX00`00000A0?ofkP<0e3dI4P3om^h0103D?AT0ooK^0?ofkP3om^h30=@m
6@050?ofkP3D?AT0ooK^0?ofkP0000002P3om^h00`3D?AT0ooK^0=@m6@030=@m6@80ooK^0`00000;
0?ofkP030=@m6@3om^h0ooK^01L0ooK^00<000000?ofkP3om^h0=03om^h10?ooo`003@3om^h00`00
0000ooK^0?ofkP190?ofkP030=@m6@3om^h0ooK^00/0ooK^0`3D?AT;0?ofkP030=@m6@0mFJ/0?EV[
00<0ooK^0`0000050?ofkP<0e3dI00@0?EV[0?ofkP0mFJ/0?EV[103om^h00`000000RbD@08/U4006
08/U40040000002;9A00RbD@08/U4080?EV[0`0000000`2P;1<000000:0/4`080:0/4`030000002P
;1<0X2`C00@0X2`C00<0?EV[0:0/4`0000000P0mFJ/50:0/4`80000000<0/34E0000002`<AD0202`
<AD00`000000?EV[03eIZ`070;0a5@030000002`<AD0/34E00<0/34E00H0?EV[0;0a5@2`<AD0/34E
0000002`<AD3000000<0_SHG00<0?EV[0000002n=QL01`2n=QL00`000000_SHG0;hf5`030;hf5`05
03eIZ`2n=QL0_SHG0;hf5`000000102n=QL0100mFJ/0_SHG0;hf5`0000040;hf5`<0000000@0bcXI
0000003;>QT0?EV[1@3;>QT010000000DGGN055egP1AMMh2000000030=@m6@1@LmT0D7?I00<0D7?I
00<00000051cf@1@LmT0101@LmT2000000<0CW3@00<0000004i`d01>L=000`1>L=001@3D?AT00000
04i`d01>L=0000000080Bf[300<0000004]Z``1;J/<00P1;J/<00`0mFJ/00000000000030=@m6@04
00000015H:h0AF2^04EP[P80000000H0?56@0=@m6@000000?56@0000000_?VX3000000d0ooK^0`3D
?AT0103om^h0e3dI0?ofkP3D?ATA0?ofkP@0e3dI1@3om^h00`3D?AT0ooK^000000090?ofkP<0e3dI
0`3om^h3000000h0ooK^00<0e3dI0?ofkP3om^h05`3om^h00`000000ooK^0?ofkP0d0?ofkP40oooo
000=0?ofkP030000003om^h0ooK^04P0ooK^00<0e3dI0?ofkP3om^h02P3om^h30=@m6@d0ooK^00<0
e3dI0?ofkP0mFJ/00`0000020?ofkP80?EV[00P0ooK^0=@m6@3D?AT0e3dI0?ofkP000000ooK^0=@m
6@80?EV[00<0ooK^03eIZ`3om^h00P3om^h00`000000RbD@08/U400608/U40030000002;9A000000
00<0000000D0?EV[0:0/4`2P;1<0X2`C000000090:0/4`030000002P;1<0X2`C00@0X2`C0`0mFJ/0
10000000X2`C0:0/4`2P;1<3000000<0/34E00<000000;0a5@2`<AD01`2`<AD010000000/34E0;0a
5@0mFJ/60;0a5@030000002`<AD0/34E0080/34E00@0?EV[0;0a5@2`<AD0/34E0`0000070;hf5`03
03eIZ`2n=QL0_SHG00H0_SHG00<000000;hf5`2n=QL00P2n=QL00`0mFJ/0_SHG0;hf5`020;hf5`03
0000002n=QL0_SHG00<0_SHG00@0?EV[0;hf5`000000_SHG0`0000040</j6@030000000mFJ/0bcXI
00D0bcXI00@00000055egP1AMMh0DGGN0P0000000`3D?AT0D7?I051cf@03051cf@030000001@LmT0
D7?I00<0D7?I00@00000051cf@1@LmT000000P1>L=000`000000CW3@04i`d00404i`d0040=@m6@1>
L=00CW3@00000080Bf[300<0000004]Z``1;J/<00P1;J/<30=@m6@0400000015H:h0AF2^000000@0
AF2^00H0000003aAT00lDI00e3dI0000000lDI05000000X0ooK^0P3D?AT40?ofkP030=@m6@3om^h0
e3dI00l0ooK^103D?AT70?ofkP040=@m6@3om^h0ooK^000000D0ooK^0`3D?AT00`3om^h0e3dI0?of
kP0300000140ooK^00<0e3dI0?ofkP3om^h0603om^h00`000000ooK^0?ofkP0c0?ofkP40oooo000=
0?ofkP030000003om^h0ooK^04P0ooK^00<0e3dI0?ofkP3om^h01`3om^h30=@m6@030?ofkP3D?AT0
ooK^00d0ooK^00<0e3dI0000000000000P0mFJ/40?ofkP<0?EV[103om^h010000000e3dI0?ofkP0m
FJ/20?ofkP0403eIZ`3om^h0ooK^000000L0RbD@0`0000050:0/4`0503eIZ`2P;1<0X2`C0:0/4`00
0000202P;1<00`000000X2`C0:0/4`020:0/4`80?EV[0P2P;1<00`0mFJ/000000:0/4`02000000L0
/34E00<000000;0a5@2`<AD01P2`<AD01@000000/34E0;0a5@2`<AD0?EV[00D0/34E00<000000;0a
5@2`<AD00P0mFJ/20;0a5@80000000<0_SHG0000002n=QL01`2n=QL00`0mFJ/000000;hf5`070;hf
5`040000002n=QL0_SHG03eIZ`D0_SHG00<000000;hf5`2n=QL0102n=QL00`0mFJ/0000000000007
0</j6@030000000mFJ/0bcXI00@0bcXI00<00000055egP1AMMh00`1AMMh00`000000e3dI051cf@03
051cf@030000001@LmT0D7?I00@0D7?I00H00000051cf@1@LmT0000004i`d000000704i`d0080=@m
6@1>L=00CW3@04i`d0000000Bf[30000001;J/<30=@m6@040000001;J/<0Bf[300000080AF2^00<0
000004EP[P15H:h00P15H:h20000000303aAT03D?AT000000080?56@1@0000060?ofkP<0e3dI1`3o
m^h20=@m6@`0ooK^0`3D?AT30?ofkP030=@m6@3om^h0ooK^00H0ooK^00D0e3dI0?ofkP3om^h00000
0?ofkP030=@m6@<0ooK^00<000000=@m6@000000503om^h00`3D?AT0ooK^0?ofkP0H0?ofkP030000
003om^h0ooK^03<0ooK^0@3oool000d0ooK^00<000000?ofkP3om^h0A`3om^h00`3D?AT0ooK^0?of
kP050?ofkP<0e3dI0`3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP<00000103om^h0100mFJ/0e3dI0=@m
6@3D?AT203eIZ`030?ofkP0mFJ/0ooK^00<0ooK^00@0e3dI0000000mFJ/0?EV[0P3om^h203eIZ`03
0000002;9A00RbD@00<0RbD@0P0000000`2P;1<000000:0/4`060:0/4`0403eIZ`2P;1<0X2`C0000
00P0X2`C00<000000:0/4`0mFJ/00P0mFJ/40:0/4`030000000mFJ/0000000T0/34E00<000000;0a
5@2`<AD01`2`<AD01@000000/34E0;0a5@2`<AD0?EV[00D0/34E00@0000003eIZ`2`<AD0/34E0P00
00030;hf5`030000002n=QL0_SHG00L0_SHG00<0?EV[0;hf5`2n=QL01P2n=QL010000000_SHG0;hf
5`0mFJ/50;hf5`030000002n=QL0_SHG0080_SHG0P0000000`3;>QT0?EV[0</j6@060</j6@030000
000mFJ/0bcXI00D0bcXI00<00000055egP1AMMh00`1AMMh2000000050=@m6@1@LmT0D7?I051cf@00
00001P1@LmT010000000D7?I051cf@1@LmT2000000H0CW3@00<000000=@m6@1>L=000`1>L=000`00
0000e3dI0=@m6@0304]Z``070000001;J/<0Bf[304]Z``000000AF2^0000000404EP[P0500000015
H:h0000003aAT03D?AT00`0lDI020000000302lnJP00000000000080ooK^0`3D?AT:0?ofkP030=@m
6@3om^h0e3dI00P0ooK^0`3D?AT60?ofkP030=@m6@3om^h0ooK^00H0ooK^00D0e3dI0?ofkP3om^h0
00000=@m6@030?ofkP<000000P3om^h00`3D?AT0ooK^0?ofkP0B0?ofkP030=@m6@3om^h0ooK^01P0
ooK^00<000000?ofkP3om^h0<`3om^h10?ooo`003@3om^h00`000000ooK^0?ofkP170?ofkP030=@m
6@3om^h0ooK^00<0ooK^0P3D?AT60?ofkP030=@m6@3om^h0ooK^00T0ooK^0P0000000`3om^h0e3dI
0?ofkP020?ofkP<0e3dI00@0?EV[0?ofkP3om^h0ooK^100mFJ/30?ofkP030=@m6@3om^h000000080
?EV[00@0e3dI0?ofkP3om^h0?EV[0`2;9A02000000@0X2`C00<000000:0/4`2P;1<01@2P;1<00`0m
FJ/0X2`C000000070:0/4`<0?EV[102P;1<3000000030;0a5@000000?EV[00T0/34E00<000000;0a
5@2`<AD01`2`<AD00`000000/34E0;0a5@020;0a5@0303eIZ`2`<AD0/34E0080/34E00@0?EV[0;0a
5@00000000001@2n=QL00`000000_SHG0;hf5`070;hf5`030000000mFJ/0_SHG00H0_SHG00<00000
0;hf5`0mFJ/01P2n=QL00`000000_SHG00000002000000<0bcXI00<0000003eIZ`3;>QT01@3;>QT0
0`0mFJ/0bcXI0</j6@050</j6@030000001AMMh0DGGN0080DGGN00@00000055egP1AMMh0e3dI0`1@
LmT00`000000D7?I051cf@03051cf@030000001@LmT0D7?I00<0D7?I00<0000004i`d01>L=00101>
L=0010000000CW3@0=@m6@1>L=030=@m6@030000001;J/<0Bf[30080Bf[300<0000004]Z``1;J/<0
0P1;J/<2000000@0AF2^00D0000004EP[P000000?56@0=@m6@0303aAT0<0000000@0;ciZ0000003D
?AT0e3dI3@3om^h00`3D?AT0ooK^0=@m6@050?ofkP<0e3dI2@3om^h00`3D?AT0ooK^0?ofkP060?of
kP<0e3dI00<0ooK^0000000000000P0000050?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?of
kP3om^h05`3om^h00`000000ooK^0?ofkP0c0?ofkP40oooo000<0?ofkP030000003om^h0ooK^04L0
ooK^00@0e3dI0?ofkP3om^h0ooK^0`3D?AT80?ofkP030=@m6@3om^h0ooK^00H0ooK^0`0000030?of
kP040=@m6@3om^h0e3dI0=@m6@@0ooK^0P0mFJ/0103om^h0?EV[0?ofkP3om^h203eIZ`80ooK^00H0
e3dI0?ofkP3om^h0?EV[0?ofkP0mFJ/20?ofkP040000000mFJ/00000000000H0X2`C00<000000:0/
4`2P;1<01P2P;1<00`0mFJ/000000:0/4`040:0/4`80?EV[0P2P;1<00`000000X2`C000000020000
00D0/34E00<0000003eIZ`2`<AD01`2`<AD00`000000/34E0;0a5@070;0a5@030000002`<AD0/34E
00<0/34E00@0?EV[0;0a5@0mFJ/0?EV[0P0000080;hf5`030000002n=QL0_SHG00H0_SHG00<00000
0;hf5`0mFJ/01P2n=QL00`000000?EV[0;hf5`050;hf5`<000001P3;>QT00`000000bcXI03eIZ`05
0</j6@0303eIZ`3;>QT0bcXI00D0bcXI00<00000055egP1AMMh00P1AMMh01@000000DGGN055egP1A
MMh0e3dI0080D7?I00<00000051cf@1@LmT00`1@LmT00`000000D7?I051cf@03051cf@8000001@1>
L=0010000000e3dI0=@m6@3D?AT304i`d08000000`1;J/<00`000000Bf[304]Z``0304]Z``030000
0015H:h0AF2^0080AF2^00H0000004EP[P15H:h000000=@m6@00000203aAT0<000000P0_?VX00`00
0000ooK^0?ofkP0<0?ofkP050=@m6@3om^h0ooK^0=@m6@3om^h00`3D?AT=0?ofkP030=@m6@3om^h0
ooK^0080ooK^0`3D?AT01P3om^h0e3dI000000000000ooK^000000L0ooK^00<0e3dI0?ofkP3om^h0
4`3om^h00`3D?AT0ooK^0?ofkP0G0?ofkP030000003om^h0ooK^03<0ooK^0@3oool000`0ooK^00<0
00000?ofkP3om^h0A`3om^h40=@m6@/0ooK^00<0e3dI0?ofkP3om^h00`3om^h3000000D0ooK^0`3D
?AT70?ofkP@0?EV[0P3om^h203eIZ`090?ofkP3D?AT0ooK^0?ofkP0mFJ/000000?ofkP0mFJ/0ooK^
0080000000<0?EV[0:0/4`2P;1<01@2P;1<00`000000X2`C0:0/4`070:0/4`0303eIZ`2P;1<0X2`C
00<0?EV[0`2P;1<3000000P0/34E00<000000;0a5@0mFJ/0202`<AD00`000000/34E0;0a5@060;0a
5@030000002`<AD0/34E00<0/34E00D0000003eIZ`000000_SHG000000090;hf5`030000002n=QL0
_SHG00H0_SHG00@000000;hf5`2n=QL0?EV[1@2n=QL00`0mFJ/0_SHG0;hf5`020;hf5`<0000000<0
bcXI0000003;>QT01P3;>QT00`000000bcXI03eIZ`040</j6@0303eIZ`000000bcXI00D0bcXI00<0
0000055egP1AMMh00`1AMMh01@000000DGGN055egP1AMMh0e3dI008000001P1@LmT00`000000D7?I
051cf@02051cf@040000001@LmT0D7?I00000080CW3@0`3D?AT00`1>L=00e3dI04i`d00204i`d003
0000001>L=00000000<0Bf[300<0000004]Z``1;J/<00`1;J/<2000000<0AF2^00H0000004EP[P15
H:h0AF2^0000003D?AT303aAT0<0000000<0;ciZ0000000000003@3om^h00`3D?AT0ooK^0=@m6@02
0=@m6A00ooK^00<0e3dI0?ofkP3D?AT00P3D?AT01P3om^h00000000000000000ooK^0=@m6@<0ooK^
00<000000?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^01P0ooK^
00<000000?ofkP3om^h0<P3om^h10?ooo`00303om^h00`000000ooK^0?ofkP160?ofkP80e3dI3@3o
m^h00`3D?AT0ooK^0?ofkP020?ofkP8000001P3om^h20=@m6@030?ofkP3D?AT0ooK^00P0ooK^0P0m
FJ/0103om^h0?EV[03eIZ`3om^h203eIZ`090=@m6@3om^h0ooK^03eIZ`3om^h000000?ofkP0mFJ/0
00000080X2`C00<0?EV[0:0/4`2P;1<0102P;1<00`000000X2`C0:0/4`060:0/4`@0?EV[102P;1<2
000000030;0a5@000000/34E00P0/34E00@000000;0a5@2`<AD0?EV[1`2`<AD00`000000/34E0;0a
5@070;0a5@040000002`<AD0000000000080?EV[00@0_SHG03eIZ`2n=QL000002@2n=QL00`000000
_SHG0;hf5`060;hf5`050000002n=QL0_SHG0;hf5`0mFJ/00`2n=QL00`0mFJ/000000;hf5`030000
00@0bcXI00<000000</j6@3;>QT01@3;>QT010000000bcXI0</j6@0mFJ/20</j6@0303eIZ`3;>QT0
000000H0bcXI00<00000055egP1AMMh00`1AMMh01`000000DGGN055egP1AMMh0e3dI055egP000000
1P1@LmT00`000000D7?I051cf@02051cf@030000001@LmT0D7?I00<0e3dI00<0CW3@0000001>L=00
0P1>L=00103D?AT0CW3@04i`d000000204i`d0040000001;J/<0Bf[3000000D0Bf[300<0000004]Z
``0000000P15H:h00`000000AF2^04EP[P0204EP[P090=@m6@0lDI00?56@03aAT0000000?56@0000
000_?VX0?EV[008000002`3om^h30=@m6@80ooK^00<0e3dI0?ofkP3om^h03@3om^h30=@m6@040?of
kP0000000000000000@0ooK^00D0e3dI0?ofkP3om^h0ooK^000000070?ofkP030=@m6@3om^h0ooK^
0140ooK^0P3D?ATJ0?ofkP030000003om^h0ooK^0380ooK^0@3oool000`0ooK^00<000000?ofkP3o
m^h0AP3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h00000008000001@3om^h30=@m6@<0
ooK^00<0e3dI0?ofkP3om^h0203om^h303eIZ`030?ofkP0mFJ/0?EV[0080?EV[0`3om^h01P0mFJ/0
ooK^0000003om^h0?EV[00000080X2`C00<0?EV[0:0/4`2P;1<0102P;1<00`000000X2`C0:0/4`05
03eIZ`80X2`C00@0000003eIZ`2P;1<0X2`C0P0000040;0a5@030000002`<AD0/34E00L0/34E00@0
00000;0a5@2`<AD0?EV[1P2`<AD00`000000/34E0;0a5@060;0a5@<000000P0mFJ/40;hf5`0303eI
Z`2n=QL0000000P0_SHG00<000000;hf5`2n=QL01`2n=QL01`000000_SHG0;hf5`2n=QL0?EV[0;hf
5`0mFJ/00`0000070</j6@030000003;>QT0bcXI00D0bcXI00T000000</j6@3;>QT0bcXI03eIZ`3;
>QT0?EV[0</j6@0000001P3;>QT00`000000DGGN055egP02055egP030000001AMMh0DGGN00<0DGGN
00<0e3dI000000000000101@LmT00`000000D7?I051cf@03051cf@<0e3dI00D0D7?I0000001>L=00
CW3@0000000304i`d0040=@m6@1>L=00CW3@000000<0CW3@0P00000504]Z``040000001;J/<0Bf[3
00000080AF2^00<0000004EP[P15H:h00P15H:h01P000000e3dI03aAT00lDI00000003aAT0800000
00<0;ciZ0000000000001`3om^h40=@m6@80ooK^00@0e3dI0?ofkP3om^h0e3dI303om^h30=@m6@04
0?ofkP3D?AT00000000000P0ooK^00D0e3dI0?ofkP3om^h0ooK^000000060?ofkP030=@m6@3om^h0
ooK^00h0ooK^0`3D?AT00`3om^h0e3dI0?ofkP0I0?ofkP030000003om^h0ooK^0380ooK^0@3oool0
00/0ooK^00<000000?ofkP3om^h0AP3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP<000001P3om^h20=@m
6@H0ooK^00<0e3dI0?ofkP3om^h02P3om^h203eIZ`<0ooK^200mFJ/20=@m6@0403eIZ`2P;1<0X2`C
03eIZ`<0X2`C1@0mFJ/70:0/4`040000002P;1<0?EV[000000H0/34E00<000000;0a5@2`<AD01`2`
<AD01@000000/34E0;0a5@2`<AD0?EV[00D0/34E00<000000;0a5@2`<AD00`2`<AD3000000030;hf
5`0mFJ/0?EV[00L0_SHG00<0?EV[0000002n=QL01`2n=QL00`000000_SHG0;hf5`070;hf5`030000
002n=QL0_SHG0080_SHG00@0?EV[0000003;>QT00000203;>QT00`000000bcXI0</j6@050</j6@03
0000003;>QT0bcXI0080bcXI00@0?EV[0</j6@3;>QT000001P3;>QT00`000000DGGN055egP02055e
gP030000001AMMh0DGGN00<0DGGN00@0e3dI055egP1AMMh000000`1@LmT00`000000D7?I0=@m6@03
0=@m6@D0D7?I0P00000504i`d0030=@m6@000000CW3@00<0CW3@00<0000003eIZ`1;J/<0101;J/<0
1`000000Bf[304]Z``1;J/<0000004EP[P0000001015H:h01@000000e3dI0000000lDI0000000080
?56@00<0000002lnJP0_?VX00P0000030?ofkP<0e3dI1P3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI
00P0ooK^0`3D?AT01@3om^h00000000000000000e3dI00X0ooK^00<0e3dI0?ofkP3om^h00P3om^h0
0`000000ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00X0ooK^103D?AT40?ofkP030=@m6@3om^h0
ooK^01P0ooK^00<000000?ofkP3om^h0<P3om^h10?ooo`002`3om^h00`000000ooK^0?ofkP160?of
kP030=@m6@3om^h0ooK^00X0ooK^0P0000000`3om^h0e3dI0?ofkP040?ofkP80e3dI203om^h00`3D
?AT0ooK^0?ofkP0;0?ofkP0503eIZ`3om^h0ooK^0?ofkP3D?AT00P0mFJ/00`3om^h0?EV[0?ofkP02
0?ofkPT0?EV[0P2P;1<00`000000X2`C0:0/4`060:0/4`<0000000<0/34E03eIZ`0mFJ/01P2`<AD0
0`000000/34E0;0a5@070;0a5@050000002`<AD0/34E0;0a5@0mFJ/01@2`<AD00`000000/34E0000
0002000000<0_SHG00<0?EV[0;hf5`000000202n=QL00`0mFJ/0_SHG0;hf5`060;hf5`030000002n
=QL0_SHG00L0_SHG00<000000;hf5`0000000P0mFJ/0103;>QT0?EV[0</j6@0000080</j6@030000
003;>QT0bcXI00@0bcXI00<000000</j6@3;>QT00P3;>QT01@0mFJ/0bcXI03eIZ`3;>QT0000000D0
bcXI00<00000055egP1AMMh00`1AMMh00`000000DGGN055egP03055egP060=@m6@1AMMh0DGGN055e
gP000000D7?I0`3D?AT3051cf@030000001@LmT0D7?I00@0D7?I00<0000004i`d01>L=000`1>L=00
0`3D?AT0000004i`d00404i`d0030000001;J/<0Bf[300<0Bf[300<0000004]Z``1;J/<00P1;J/<2
000000@0AF2^00D0000004EP[P3D?AT0?56@0000000203aAT080000000<0;ciZ0000000_?VX00`3D
?AT90?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT0103om^h40=@m6@040?ofkP0000000000000000@0
ooK^00<0e3dI0?ofkP3om^h0203om^h01@3D?AT0ooK^0?ofkP3om^h0000000D0ooK^00<0e3dI0?of
kP3om^h01`3om^h30=@m6@P0ooK^00<0e3dI0?ofkP3om^h0603om^h00`000000ooK^0?ofkP0b0?of
kP40oooo000;0?ofkP030000003om^h0ooK^04H0ooK^00<0e3dI0?ofkP3om^h01`3om^h300000080
ooK^00@0e3dI0?ofkP3om^h0ooK^0`3D?AT:0?ofkP030=@m6@3om^h0ooK^00`0ooK^0P0mFJ/0103o
m^h0e3dI0?ofkP3om^h203eIZ`<0e3dI00<0ooK^0000002P;1<0102P;1<01@0mFJ/0X2`C0:0/4`2P
;1<0000000D0X2`C0`0000000`2`<AD000000;0a5@030;0a5@0303eIZ`2`<AD0/34E00<0/34E00<0
00000;0a5@2`<AD01`2`<AD00`000000/34E0;0a5@020;0a5@0403eIZ`2`<AD0/34E0;0a5@<00000
102n=QL203eIZ`80_SHG00<000000;hf5`2n=QL01P2n=QL00`000000?EV[0;hf5`070;hf5`030000
002n=QL0_SHG00D0_SHG0`0000000`0mFJ/0bcXI0</j6@020</j6@0303eIZ`000000bcXI00L0bcXI
00<000000</j6@3;>QT0103;>QT01@000000bcXI0</j6@3;>QT0?EV[00<0bcXI00<0?EV[0</j6@3;
>QT0103;>QT00`000000DGGN055egP02055egP030000001AMMh0DGGN00@0DGGN00<000000=@m6@1A
MMh00`3D?AT00`000000D7?I051cf@03051cf@030000001@LmT0D7?I00@0D7?I0P00000404i`d003
0000003D?AT0CW3@00<0CW3@00<0?EV[000000000000101;J/<00`000000Bf[304]Z``0304]Z``03
00000015H:h0AF2^0080AF2^00P0000004EP[P3D?AT0000003eIZ`000000?56@000000@0e3dI00<0
000003eIZ`3om^h02P3om^h0103D?AT0ooK^0?ofkP3om^h40=@m6@80ooK^0`0000070?ofkP030=@m
6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`000000ooK^0?ofkP030?ofkP030=@m
6@3om^h0ooK^00<0ooK^0`3D?AT<0?ofkP030=@m6@3om^h0ooK^01P0ooK^00<000000?ofkP3om^h0
<@3om^h10?ooo`002`3om^h00`000000ooK^0?ofkP160?ofkP030=@m6@3om^h0ooK^00D0ooK^0P00
00050?ofkP040=@m6@3om^h0e3dI0=@m6@d0ooK^00<0e3dI0?ofkP3om^h03@3om^h203eIZ`040=@m
6@3om^h0e3dI0=@m6@80?EV[103om^h00`000000X2`C0:0/4`030:0/4`0603eIZ`2P;1<0X2`C0:0/
4`000000X2`C0`0000050;0a5@030000002`<AD0/34E0080/34E00<0?EV[0;0a5@2`<AD00`2`<AD0
0`000000/34E0;0a5@060;0a5@030000002`<AD0/34E00<0/34E00D0?EV[000000000000_SHG0000
00030;hf5`80?EV[102n=QL00`000000_SHG0;hf5`070;hf5`030000000mFJ/0_SHG00H0_SHG00<0
00000;hf5`2n=QL00P2n=QL3000000030</j6@000000?EV[00H0bcXI00<0?EV[0</j6@3;>QT01P3;
>QT00`000000bcXI0</j6@040</j6@040000003;>QT0bcXI03eIZ`@0bcXI00<0000003eIZ`3;>QT0
0`3;>QT2000000@0DGGN00<00000055egP1AMMh0101AMMh30=@m6@<0DGGN00<00000051cf@1@LmT0
0`1@LmT00`000000D7?I051cf@03051cf@040000001@LmT0D7?I000000<0CW3@00<000000=@m6@1>
L=000`1>L=0010000000CW3@04i`d000000304]Z``030000001;J/<0Bf[30080Bf[300<0?EV[0000
000000000`15H:h01@000000AF2^04EP[P3D?AT0000000<0e3dI00H0000003aAT0000000000002ln
JP00000;0?ofkP030=@m6@3om^h0e3dI0080e3dI0P3om^h3000000X0ooK^00<0e3dI0?ofkP3om^h0
2@3om^h00`3D?AT0ooK^0?ofkP020?ofkP030000003om^h0ooK^0080ooK^00<0e3dI0?ofkP3D?AT0
0`3D?AT?0?ofkP030=@m6@3om^h0ooK^01P0ooK^00<000000?ofkP3om^h0<@3om^h10?ooo`002P3o
m^h00`000000ooK^0?ofkP160?ofkP030=@m6@3om^h0ooK^00<0ooK^0`0000060?ofkP<0e3dI3`3o
m^h00`3D?AT0ooK^0?ofkP0>0?ofkP80?EV[00@0e3dI0?ofkP3om^h0ooK^0P0mFJ/30?ofkP030000
002P;1<0X2`C00@0X2`C0P0mFJ/3000000P0/34E00<000000;0a5@2`<AD00`2`<AD00`0mFJ/0/34E
0;0a5@020;0a5@030000002`<AD0/34E00L0/34E00<000000;0a5@0000000P0000000`2n=QL0?EV[
0;hf5`020;hf5`030000000mFJ/0?EV[00L0_SHG00<000000;hf5`2n=QL01P2n=QL00`000000?EV[
0;hf5`060;hf5`030000002n=QL00000008000000`3;>QT203eIZ`L0bcXI00<0000003eIZ`3;>QT0
1P3;>QT00`000000bcXI0</j6@040</j6@030000003;>QT0?EV[00D0bcXI00<000000</j6@0mFJ/0
0`0000000`3F?AX0000000000003055egP040000001AMMh0DGGN055egP<0e3dI00<0DGGN0=@m6@1A
MMh00`1AMMh2000000<0D7?I00<00000051cf@1@LmT0101@LmT01@000000D7?I051cf@1@LmT00000
0080CW3@00<000000=@m6@1>L=000`1>L=0010000000CW3@04i`d000000304]Z``030000001;J/<0
Bf[300<0Bf[300<0000004]Z``0000000P15H:h00`000000AF2^0=@m6@020=@m6@040000000lDI00
?56@00000080?56@0`0000000`0mFJ/0ooK^0?ofkP070?ofkP<0e3dI0P3om^h00`000000e3dI0000
000=0?ofkP030=@m6@3om^h0ooK^00P0ooK^0P3D?AT50?ofkP030000003om^h0ooK^00<0e3dI4`3o
m^h00`3D?AT0ooK^0?ofkP0H0?ofkP030000003om^h0ooK^0340ooK^0@3oool000X0ooK^00<00000
0?ofkP3om^h0AP3om^h00`3D?AT0ooK^0?ofkP03000000H0ooK^0`3D?AT00`3om^h0e3dI0?ofkP0?
0?ofkP030=@m6@3om^h0ooK^00`0ooK^0P3D?AT00`3om^h0?EV[03eIZ`040?ofkP80?EV[0P3om^h0
0`000000X2`C0:0/4`030:0/4`<0000000<0?EV[0;0a5@0000002@2`<AD00`000000/34E0;0a5@03
0;0a5@0303eIZ`2`<AD0/34E0080/34E00<000000;0a5@2`<AD01@2`<AD3000000D0_SHG00@0?EV[
0;hf5`0mFJ/0?EV[2@2n=QL00`000000_SHG0;hf5`060;hf5`030000002n=QL0?EV[00D0_SHG0`00
00050</j6@0303eIZ`3;>QT0000000L0bcXI00<000000</j6@0mFJ/01P3;>QT00`000000bcXI0</j
6@040</j6@030000000mFJ/0bcXI00@0bcXI0`0000001@3F?AX0?EV[0=Hm6P3F?AX000000080DGKR
00<00000055egP1AMMh0103D?AT2055egP040000001AMMh0DGGN0=@m6@80DGGN00@00000055egP1A
MMh000000P1@LmT00`000000D7?I051cf@03051cf@030000001@LmT0D7?I00<0D7?I0P00000204i`
d0050=@m6@1>L=00CW3@04i`d00000000`1>L=000`000000Bf[30000000504]Z``050000001;J/<0
Bf[300000015H:h00`3D?AT204EP[P050=@m6@000000000003aAT00000000`0lDI0010000000;ciZ
0000000mFJ/50?ofkP<0e3dI00<0ooK^0=@m6@0000000P0000000`3om^h0e3dI0?ofkP0>0?ofkP03
0=@m6@3om^h0ooK^00@0ooK^0`3D?AT20?ofkP030=@m6@3om^h0ooK^0080ooK^00D000000=@m6@3D
?AT0ooK^0=@m6@0D0?ofkP030=@m6@3om^h0ooK^01P0ooK^00<000000?ofkP3om^h0<@3om^h10?oo
o`002P3om^h00`000000ooK^0?ofkP160?ofkP030=@m6@000000000000H0ooK^0`3D?AT40?ofkP03
0=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h02@3om^h30=@m6@<0ooK^00@0e3dI0?ofkP0m
FJ/0?EV[0P3om^h303eIZ`80ooK^00<000000:0/4`0000000P0000040;0a5@0303eIZ`000000/34E
00P0/34E00<000000;0a5@2`<AD0102`<AD01@0mFJ/0/34E0;0a5@2`<AD0000000D0/34E0P000000
0`2n=QL000000;hf5`050;hf5`80?EV[0P2n=QL00`000000_SHG0;hf5`060;hf5`030000002n=QL0
_SHG00H0_SHG00@000000;hf5`2n=QL0?EV[0P2n=QL2000000030</j6@000000bcXI00@0bcXI00D0
?EV[0</j6@3;>QT0bcXI000000060</j6@040000003;>QT0bcXI03eIZ`D0bcXI00<000000</j6@3;
>QT00`3;>QT203eIZ`@0bcXI0P0000000`3F?AX000000=Hm6P020=Hm6P0303eIZ`3F?AX000000080
DGKR0`3D?AT6055egP040000001AMMh0DGGN0=@m6@80DGGN00@00000055egP1AMMh000000P1@LmT0
0`000000D7?I051cf@03051cf@030000001@LmT0D7?I00@0D7?I00@0000004i`d01>L=00e3dI0`1>
L=000`000000CW3@04i`d00204i`d08000001@1;J/<00`000000Bf[304]Z``020=@m6@0304EP[P00
0000AF2^0080AF2^00<0e3dI00000015H:h00P00000303aAT0<000000P0mFJ/40=@m6@050?ofkP00
000000000000003D?AT01@3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP040=@m6@3om^h0ooK^0?ofkP<0
e3dI1@3om^h00`3D?AT0ooK^0=@m6@020=@m6@050?ofkP000000ooK^0?ofkP3D?AT0503om^h00`3D
?AT0ooK^0?ofkP0H0?ofkP030000003om^h0ooK^0340ooK^0@3oool000X0ooK^00<000000?ofkP3o
m^h0A03om^h3000000H0ooK^0P3D?AT70?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3o
m^h01`3om^h20=@m6@H0ooK^00<0e3dI0?ofkP3om^h00P0mFJ/20?ofkP<0?EV[00<0ooK^00000000
0000202`<AD00`0mFJ/000000;0a5@080;0a5@030000002`<AD0/34E00@0/34E00H0?EV[0;0a5@2`
<AD0/34E0000002`<AD3000000@0_SHG00<000000;hf5`2n=QL00`0mFJ/20;hf5`0303eIZ`2n=QL0
000000T0_SHG00<000000;hf5`2n=QL01P2n=QL01@000000_SHG0000000mFJ/0000000@0bcXI00<0
00000</j6@3;>QT00P0mFJ/40</j6@030000003;>QT0bcXI00D0bcXI00@000000</j6@3;>QT0?EV[
103;>QT00`000000bcXI0</j6@020</j6@0403eIZ`3;>QT000000</j6@<000000`3F?AX00`000000
eSdJ0=Hm6P020=Hm6P0403eIZ`000000e3dI0=@m6@80DGKR00<00000055egP1AMMh00`1AMMh00`00
0000DGGN055egP02055egP030=@m6@000000DGGN00<0DGGN0P000005051cf@030000001@LmT0D7?I
00D0D7?I0P00000204i`d0030=@m6@1>L=00000000H0CW3@00<0000004]Z``1;J/<00`1;J/<30=@m
6@80Bf[30P00000404EP[P050=@m6@15H:h0000003aAT00000000P0lDI0300000080e3dI0P3om^h3
000000<0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP@0e3dI203om^h2
0=@m6@D0ooK^00<000000?ofkP3D?AT0503om^h00`3D?AT0ooK^0?ofkP0I0?ofkP030000003om^h0
ooK^0300ooK^0@3oool000X0ooK^00<000000?ofkP3om^h0@@3om^h3000000030?ofkP3D?AT0ooK^
00<0ooK^0`3D?AT90?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h0103om^h30=@m
6@P0ooK^00@0e3dI0?ofkP3om^h0ooK^100mFJ/01@3om^h0?EV[03eIZ`3om^h0000000T0/34E00<0
?EV[0;0a5@2`<AD01`2`<AD00`000000/34E0;0a5@050;0a5@80?EV[0`0000070;hf5`<0?EV[1P2n
=QL00`0mFJ/000000;hf5`080;hf5`030000002n=QL0_SHG00D0_SHG0`0000020</j6@0303eIZ`3;
>QT0bcXI0080bcXI00<000000</j6@0mFJ/01P3;>QT00`000000bcXI0</j6@050</j6@050000003;
>QT0bcXI0</j6@0mFJ/00`3;>QT01P000000bcXI0</j6@3;>QT0?EV[0</j6@<000001@3F?AX00`00
0000eSdJ0=Hm6P040=Hm6P030000003D?AT0DGKR0080DGKR0P000004055egP030000001AMMh0DGGN
0080DGGN00<0e3dI0000001AMMh0101AMMh00`000000D7?I051cf@03051cf@030000001@LmT0D7?I
00@0D7?I00P00000051cf@1@LmT0000004i`d03D?AT0CW3@000000H0CW3@0P0000001@1;J/<0e3dI
0=@m6@3D?AT0000000D0Bf[300<0000004EP[P15H:h00P15H:h00`3D?AT0AF2^04EP[P02000000<0
?56@0`00000203eIZ`030000003om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0
ooK^0?ofkP0:0?ofkP80e3dI203om^h30=@m6@030?ofkP3D?AT0ooK^00@0ooK^00<000000?ofkP3D
?AT05@3om^h00`3D?AT0ooK^0?ofkP0H0?ofkP030000003om^h0ooK^0300ooK^0@3oool000T0ooK^
00<000000?ofkP3om^h0@03om^h2000000@0ooK^00<0e3dI0?ofkP3D?AT00P3D?AT<0?ofkP030=@m
6@3om^h0ooK^00h0ooK^00@0e3dI0?ofkP3om^h0ooK^0`3D?AT;0?ofkP030=@m6@3om^h0ooK^0080
ooK^100mFJ/0103om^h0?EV[03eIZ`00000:0;0a5@0303eIZ`2`<AD0/34E00L0/34E00<000000;0a
5@2`<AD00`2`<AD30000000303eIZ`2n=QL0000000@0_SHG0`0mFJ/00`2n=QL000000;hf5`070;hf
5`0303eIZ`000000_SHG00L0_SHG00<000000;hf5`2n=QL00`2n=QL2000000030</j6@000000bcXI
00<0bcXI00H0?EV[0</j6@3;>QT0bcXI0000000mFJ/70</j6@030000003;>QT0bcXI00D0bcXI00<0
00000</j6@3;>QT00P3;>QT0100mFJ/0bcXI0</j6@0000020</j6@0503eIZ`00000000000=Hm6P00
00001P3F?AX00`000000eSdJ0=Hm6P030=Hm6P030000001AM^80DGKR0080DGKR00@00000055fhP1A
M^8000000`1AMMh00`000000DGGN055egP03055egP030=@m6@1AMMh0DGGN00<0DGGN0P000004051c
f@030000001@LmT0D7?I00@0D7?I00@00000051cf@1@LmT000000P1>L=000`3D?AT0000004i`d004
04i`d0040000003D?AT0e3dI0=@m6@<0Bf[300<0000004]Z``1;J/<00`1;J/<2000000<0AF2^00D0
00000=@m6@15H:h0AF2^0000000303aAT0030000000lDI00000000<0?EV[1`3om^h00`3D?AT0ooK^
0?ofkP030?ofkP030=@m6@3om^h0ooK^00L0ooK^0`3D?AT20?ofkP030=@m6@3om^h0ooK^0080ooK^
0`3D?AT50?ofkP030=@m6@3om^h0ooK^00<0ooK^00<000000=@m6@3om^h0503om^h00`3D?AT0ooK^
0?ofkP0H0?ofkP030000003om^h0ooK^0300ooK^0@3oool000T0ooK^00<000000?ofkP3om^h0?@3o
m^h3000000H0ooK^0P3D?AT?0?ofkP030=@m6@3om^h0ooK^00h0ooK^00@0e3dI0?ofkP3D?AT0e3dI
3P3om^h00`3D?AT0ooK^0?ofkP030?ofkP80?EV[00@0ooK^03eIZ`0mFJ/0ooK^0P0mFJ/30;0a5@03
03eIZ`2`<AD0/34E00@0/34E00<0?EV[0;0a5@2`<AD01P2`<AD00`000000/34E0;0a5@03000000@0
_SHG00<0?EV[0000002n=QL00`0mFJ/40;hf5`030000002n=QL0_SHG00L0_SHG00<0?EV[0;hf5`2n
=QL01`2n=QL00`000000_SHG00000002000000@0bcXI00<000000</j6@3;>QT00P3;>QT01@0mFJ/0
bcXI03eIZ`0mFJ/0000000L0bcXI00<000000</j6@3;>QT01@3;>QT00`000000bcXI0</j6@030</j
6@0603eIZ`3;>QT000000</j6@0mFJ/000000`3F?AX00`000000eSdJ0=Hm6P040=Hm6P030000003F
?AX0eSdJ00<0eSdJ00<00000055fhP1AM^800P1AM^801@000000DGKR055fhP1AM^8000000080DGGN
00<00000055egP1AMMh00P1AMMh00`000000e3dI055egP03055egP040000001AMMh0DGGN00000080
D7?I00<00000051cf@1@LmT0101@LmT00`000000D7?I051cf@02051cf@040000001>L=00e3dI0000
00@0CW3@0P3D?AT304i`d0030000001;J/<0000000H0Bf[300<0000004]Z``0000000P15H:h01000
0000e3dI04EP[P15H:h200000080?56@00@0000003aAT000000000000`0mFJ/60?ofkP030=@m6@3o
m^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h00`3om^h30=@m6@D0ooK^00<0e3dI0?ofkP3D?AT00P3D
?AT80?ofkP030=@m6@3om^h0ooK^00@0ooK^00<000000?ofkP3om^h04P3om^h20=@m6AX0ooK^00<0
00000?ofkP3om^h0<03om^h10?ooo`002@3om^h00`000000ooK^0?ofkP0k0?ofkP8000002@3om^h0
0`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00h0ooK^0`3D?AT@0?ofkP030=@m6@3om^h0
ooK^00@0ooK^0`0mFJ/00`3om^h0?EV[03eIZ`0203eIZ`T0/34E00<0000003eIZ`0mFJ/01P2`<AD3
000000H0_SHG100mFJ/80;hf5`030000002n=QL0_SHG00L0_SHG00<0?EV[0;hf5`2n=QL01@2n=QL3
000000L0bcXI00<000000</j6@3;>QT00`3;>QT0100mFJ/0bcXI0</j6@0000070</j6@030000003;
>QT0bcXI00D0bcXI00<000000</j6@3;>QT0103;>QT00`0mFJ/0000003eIZ`050=Hm6P030000003F
?AX0eSdJ00@0eSdJ00<000000=Hm6P3F?AX00`3F?AX00`000000DGKR055fhP02055fhP030000001A
M^80DGKR0080DGKR0P000005055egP030000003D?AT0DGGN00<0DGGN00@00000055egP1AMMh00000
0P1@LmT00`000000D7?I051cf@04051cf@030000001@LmT0D7?I00<0D7?I0P0000000`3D?AT0CW3@
0=@m6@020=@m6@030000001>L=00CW3@00<0CW3@0P00000504]Z``0?0000001;J/<0Bf[304]Z``00
0000AF2^00000015H:h0e3dI04EP[P000000AF2^0000000lDI0000000080?56@00<0000003eIZ`0m
FJ/00P0mFJ/50?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h00`3D?AT70?ofkP<0
e3dI303om^h00`3D?AT0ooK^0?ofkP040?ofkP030000003om^h0ooK^00d0ooK^103D?AT00`3om^h0
e3dI0?ofkP0I0?ofkP030000003om^h0ooK^0300ooK^0@3oool000T0ooK^00<000000?ofkP3om^h0
>03om^h3000000/0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP<0e3dI
00<0ooK^0=@m6@3om^h04@3om^h00`3D?AT0ooK^0?ofkP050?ofkP80?EV[0P3om^h303eIZ`T0/34E
00<000000;0a5@0mFJ/00`2`<AD200000080_SHG00<000000;hf5`0mFJ/0100mFJ/30;hf5`0303eI
Z`2n=QL0_SHG00H0_SHG00<000000;hf5`2n=QL01`2n=QL00`000000?EV[0;hf5`030;hf5`800000
00<0bcXI0000003;>QT01`3;>QT010000000bcXI0</j6@3;>QT203eIZ`040</j6@0mFJ/0bcXI0000
00L0bcXI00<000000</j6@3;>QT01@3;>QT00`000000bcXI0</j6@04000000030=Hm6P0mFJ/0eSdJ
00D0eSdJ00<000000=Hm6P3F?AX0103F?AX00`000000eSdJ0=Hm6P030=Hm6P030000001AM^80DGKR
0080DGKR00<00000055fhP1AM^800`1AM^800`000000DGGN055egP03055egP030000001AMMh0e3dI
0080DGGN00<00000055egP1AMMh00P1AMMh2000000H0D7?I00<00000051cf@1@LmT01@1@LmT30=@m
6@<0CW3@00<0000004i`d01>L=00101>L=000`000000Bf[304]Z``0304]Z``030000001;J/<0Bf[3
0080Bf[30P0000002015H:h0e3dI04EP[P000000AF2^0000000lDI0000000P0lDI000`000000ooK^
03eIZ`0203eIZ`D0ooK^00<0e3dI0?ofkP3om^h0103om^h30=@m6@L0ooK^0`3D?AT00`3om^h0e3dI
0?ofkP0=0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<000000?ofkP3om^h02P3om^h30=@m6@D0ooK^
00<0e3dI0?ofkP3om^h06@3om^h00`000000ooK^0?ofkP0_0?ofkP40oooo00080?ofkP030000003o
m^h0ooK^03H0ooK^0`00000>0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h0203o
m^h30=@m6@@0ooK^00<0e3dI0?ofkP3om^h0403om^h00`3D?AT0ooK^0?ofkP060?ofkP0303eIZ`3o
m^h0ooK^0080ooK^200mFJ/20;0a5@040000002`<AD0/34E03eIZ`80000000<0_SHG03eIZ`0mFJ/0
0`0mFJ/90;hf5`0303eIZ`2n=QL0_SHG00H0_SHG00<000000;hf5`2n=QL01`2n=QL00`000000?EV[
03eIZ`02000000@0bcXI00<000000</j6@3;>QT01P3;>QT00`000000?EV[03eIZ`040</j6@0303eI
Z`000000bcXI00L0bcXI00<000000</j6@3;>QT00`3;>QT4000000@0eSdJ00<0?EV[0000000mFJ/0
1@3F?AX00`000000eSdJ0=Hm6P030=Hm6P030000003F?AX0eSdJ00<0eSdJ00<00000055fhP1AM^80
0P1AM^800`000000DGKR055fhP04055fhP8000000`1AMMh010000000DGGN055egP3D?AT2055egP03
0000001AMMh0DGGN00<0DGGN00<00000051cf@1@LmT0101@LmT00`000000D7?I051cf@02051cf@<0
e3dI00<0D7?I0=@m6@1>L=000`1>L=000`000000CW3@04i`d00304i`d00303eIZ`000000000000@0
Bf[300<0000004]Z``1;J/<00`1;J/<01@000000AF2^04EP[P3D?AT000000080AF2^00D0000003aA
T0000000?56@0000000203eIZ`030?ofkP0mFJ/0?EV[00@0ooK^00@0e3dI0?ofkP3om^h0ooK^0`3D
?AT20?ofkP040=@m6@3om^h0ooK^0?ofkP@0e3dI103om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m
6@3om^h0ooK^00<0ooK^00<0e3dI0000003om^h01P3om^h40=@m6@P0ooK^00<0e3dI0?ofkP3om^h0
6@3om^h00`000000ooK^0?ofkP0_0?ofkP40oooo00080?ofkP030000003om^h0ooK^03@0ooK^0P00
000A0?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3om^h01@3om^h30=@m6@L0ooK^00<0
e3dI0?ofkP3om^h0403om^h00`3D?AT0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^0080e3dI0P0m
FJ/50;0a5@T0?EV[102n=QL00`000000_SHG0;hf5`070;hf5`030000000mFJ/0_SHG00H0_SHG00<0
00000;hf5`2n=QL01P2n=QL3000000030</j6@0mFJ/0bcXI00@0bcXI00<000000</j6@3;>QT01@3;
>QT203eIZ`L0bcXI00<0?EV[0000003;>QT01P3;>QT010000000bcXI0</j6@3;>QT2000000030=Hm
6P000000eSdJ00<0eSdJ0P0mFJ/0103F?AX000000=Hm6P0mFJ/40=Hm6P030000003F?AX0eSdJ00<0
eSdJ00<000000=Hm6P3F?AX00`3F?AX00`000000DGKR055fhP02055fhP030000001AM^80DGKR00<0
DGKR00@00000055fhP1AM^8000000P1AMMh01P000000DGGN055egP1AMMh0e3dI000000D0DGGN00<0
0000055egP0000001@1@LmT00`000000D7?I0=@m6@020=@m6@80D7?I00@00000051cf@1@LmT0e3dI
0P1>L=000`000000CW3@04i`d00404i`d0040000001>L=00CW3@000000<0Bf[300<0000004]Z``1;
J/<00P1;J/<01P0mFJ/0000000000015H:h0e3dI000000<0AF2^0P00000203aAT0060000003om^h0
?EV[03eIZ`3om^h0?EV[0`3om^h40=@m6@D0ooK^103D?AT80?ofkP030=@m6@3om^h0ooK^00d0ooK^
00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^000000030?ofkP<0e3dI303om^h00`3D?AT0ooK^
0?ofkP0I0?ofkP030000003om^h0ooK^02l0ooK^0@3oool000P0ooK^00<000000?ofkP3om^h0<@3o
m^h3000001<0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP020?ofkP<0e3dI2P3o
m^h00`3D?AT0ooK^0?ofkP0@0?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI03eIZ`0mFJ/00P3o
m^h00`000000/34E03eIZ`030;0a5@<000000P2n=QL010000000_SHG0;hf5`0mFJ/60;hf5`030000
002n=QL0_SHG00L0_SHG00<0000003eIZ`2n=QL01P2n=QL00`000000_SHG0;hf5`030;hf5`800000
0P3;>QT010000000bcXI0</j6@0mFJ/50</j6@030000003;>QT0bcXI0080bcXI0P0mFJ/00`3;>QT0
00000</j6@070</j6@0303eIZ`3;>QT0bcXI00D0bcXI00@000000</j6@00000000000`3F?AX01@00
0000eSdJ0=Hm6P3F?AX0?EV[00<0eSdJ00@000000=Hm6P3F?AX0?EV[0P3F?AX00`000000eSdJ0=Hm
6P040=Hm6P030000003F?AX0eSdJ00<0eSdJ00<00000055fhP1AM^800P1AM^800`000000DGKR055f
hP03055fhP040000001AM^80DGKR055fhP800000101AMMh00`3D?AT00000055egP04055egP040000
001AMMh0DGGN000000<0D7?I0`3D?AT4051cf@050000001@LmT0D7?I051cf@3D?AT00P1>L=000`00
0000CW3@04i`d00404i`d0040000001>L=00CW3@000000<0Bf[300<0000004]Z``1;J/<00P1;J/<0
0`000000Bf[30000000204EP[P030=@m6@15H:h0AF2^0080AF2^00D0000003aAT00lDI0000000?of
kP0403eIZ`<0e3dI00<0ooK^0=@m6@3om^h0103om^h40=@m6@X0ooK^00<0e3dI0?ofkP3om^h03@3o
m^h00`3D?AT0ooK^0?ofkP020?ofkP040=@m6@3om^h0e3dI00000080e3dI3`3om^h00`3D?AT0ooK^
0?ofkP0I0?ofkP030000003om^h0ooK^02l0ooK^0@3oool000P0ooK^00<000000?ofkP3om^h0;P3o
m^h3000001H0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0=@m6@020=@m6@d0ooK^00<0
e3dI0?ofkP3om^h0403om^h00`3D?AT0ooK^0?ofkP050?ofkP80e3dI0P3om^h203eIZ`040?ofkP00
0000/34E0;0a5@80?EV[00<000000;hf5`2n=QL00`2n=QL01@000000_SHG0;hf5`2n=QL0?EV[00D0
_SHG00<000000;hf5`2n=QL01`2n=QL00`000000_SHG03eIZ`060;hf5`030000002n=QL0_SHG00<0
0000103;>QT01@000000bcXI0</j6@3;>QT0?EV[00@0bcXI00<000000</j6@3;>QT00P0mFJ/30</j
6@030000003;>QT0bcXI00H0bcXI00<0000003eIZ`3;>QT0103;>QT3000000D0eSdJ00@000000=Hm
6P3F?AX0?EV[103F?AX01`000000eSdJ0=Hm6P3F?AX0?EV[0=Hm6P0000001P3F?AX00`000000eSdJ
0=Hm6P030=Hm6P030000001AM^80DGKR0080DGKR00<00000055fhP1AM^800P1AM^800`000000DGKR
055fhP03055fhP030000001AMMh0DGGN00<0DGGN00<0e3dI055egP1AMMh00P1AMMh010000000DGGN
055egP1AMMh40=@m6@030000001@LmT0D7?I00@0D7?I00<00000051cf@1@LmT00P1@LmT00`3D?AT0
000004i`d00504i`d0030000001>L=00CW3@0080CW3@00<0000004]Z``0000001@1;J/<01P000000
Bf[304]Z``000000AF2^0=@m6@@0AF2^0P000000100lDI00000003eIZ`3om^h30=@m6@80?EV[0P3o
m^h00`3D?AT0ooK^0=@m6@030=@m6@<0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?of
kP0=0?ofkP80e3dI0P3om^h30=@m6@030?ofkP000000ooK^0100ooK^00<0e3dI0?ofkP3om^h06@3o
m^h00`000000ooK^0?ofkP0_0?ofkP40oooo00080?ofkP030000003om^h0ooK^02`0ooK^0P00000H
0?ofkP030=@m6@3om^h0ooK^00d0ooK^0`3D?AT@0?ofkP030=@m6@3om^h0ooK^0100ooK^00<0e3dI
0?ofkP3om^h00P3om^h30=@m6@D0ooK^0P0mFJ/00`3om^h00000000000020;hf5`0303eIZ`2n=QL0
_SHG00@0_SHG00@000000;hf5`2n=QL0_SHG0P0mFJ/40;hf5`030000002n=QL0_SHG00L0_SHG00<0
00000;hf5`0mFJ/01@2n=QL3000000P0bcXI00D000000</j6@3;>QT0bcXI03eIZ`030</j6@030000
000mFJ/0?EV[00H0bcXI00<000000</j6@3;>QT01P3;>QT00`000000?EV[03eIZ`03000000030=Hm
6P000000eSdJ00H0eSdJ00<0000003eIZ`3F?AX0103F?AX00`000000eSdJ0=Hm6P020=Hm6P0303eI
Z`000000eSdJ00D0eSdJ00<000000=Hm6P3F?AX00P3F?AX00`000000DGKR055fhP02055fhP030000
001AM^80DGKR00<0DGKR00<00000055fhP1AM^800`1AM^82000000<0DGGN00<000000=@m6@1AMMh0
0`1AMMh010000000e3dI0=@m6@3D?AT2055egP8000001P1@LmT00`000000D7?I051cf@03051cf@03
0=@m6@000000CW3@00D0CW3@00<0000004i`d01>L=000`1>L=02000000D0Bf[300@0000004]Z``1;
J/<0Bf[30P0000001P3D?AT0AF2^04EP[P15H:h0000004EP[P@0e3dI0P0mFJ/0103om^h0?EV[03eI
Z`3om^h30=@m6@P0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP<0e3dI
00H0ooK^0=@m6@3D?AT0e3dI0?ofkP3D?AT30?ofkP030000003om^h0ooK^00h0ooK^00<0e3dI0?of
kP3om^h06@3om^h00`000000ooK^0?ofkP0_0?ofkP40oooo00070?ofkP030000003om^h0ooK^02X0
ooK^0`00000J0?ofkP030=@m6@3om^h0ooK^00X0ooK^0`3D?AT00`3om^h0e3dI0?ofkP0@0?ofkP03
0=@m6@3om^h0ooK^0100ooK^00<0e3dI0?ofkP3D?AT00P3D?AT90?ofkP80?EV[00<0ooK^0000002n
=QL00P2n=QL00`0mFJ/0_SHG0;hf5`040;hf5`030000002n=QL0_SHG0080_SHG00D0?EV[0;hf5`2n
=QL0_SHG000000090;hf5`030000002n=QL0_SHG0080?EV[0`0000020</j6@030000003;>QT0bcXI
00H0bcXI00<000000</j6@3;>QT00P3;>QT01@0mFJ/0bcXI03eIZ`0mFJ/0000000L0bcXI00<00000
0</j6@3;>QT01@3;>QT3000000030=Hm6P0mFJ/0eSdJ0080eSdJ00<000000=Hm6P3F?AX0103F?AX2
03eIZ`H0eSdJ00<000000=Hm6P3F?AX00`3F?AX00`0mFJ/0eSdJ0=Hm6P030=Hm6P030000003F?AX0
eSdJ0080eSdJ0P000004055fhP030000001AM^80DGKR0080DGKR00<00000055fhP1AM^800`1AM^80
10000000DGKR055fhP000002055egP040000001AMMh0e3dI055egP<0e3dI1P1AMMh00`000000D7?I
051cf@04051cf@030000001@LmT0D7?I00<0D7?I00<000000=@m6@0000001@1>L=000`000000CW3@
04i`d00404i`d0030000001;J/<0Bf[30080Bf[300<0000004]Z``1;J/<00P1;J/<2000000030=@m
6@15H:h0AF2^00<0e3dI00<0000003aAT00000000P0mFJ/00`3om^h0?EV[0=@m6@020=@m6@030?of
kP3D?AT0ooK^00P0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP070?ofkP<0e3dI
00H0ooK^0=@m6@3D?AT0e3dI0?ofkP3D?AT20?ofkP030=@m6@3om^h0ooK^0080ooK^00<000000?of
kP3om^h03@3om^h00`3D?AT0ooK^0?ofkP0J0?ofkP030000003om^h0ooK^02h0ooK^0@3oool000L0
ooK^00<000000?ofkP3om^h0:03om^h2000001d0ooK^00<0e3dI0?ofkP3om^h01`3om^h30=@m6@@0
ooK^00<0e3dI0?ofkP3om^h0403om^h00`3D?AT0ooK^0?ofkP0>0?ofkP<0e3dI3P3om^h0100mFJ/0
ooK^0000000mFJ/20;hf5`0303eIZ`2n=QL0_SHG00<0_SHG00<000000;hf5`2n=QL00`2n=QL01@0m
FJ/0_SHG0;hf5`2n=QL0000000P0_SHG100000000`3;>QT0?EV[0</j6@030</j6@030000003;>QT0
bcXI00L0bcXI00@000000</j6@3;>QT0bcXI0P0mFJ/20</j6@030000003;>QT0bcXI00D0bcXI00<0
00000</j6@3;>QT00`3;>QT2000000030=Hm6P000000eSdJ0080eSdJ00D0?EV[0=Hm6P3F?AX0eSdJ
000000040=Hm6P0303eIZ`3F?AX0000000H0eSdJ00<000000=Hm6P3F?AX00`3F?AX00`0mFJ/0eSdJ
0=Hm6P030=Hm6P030000003F?AX000000080000000<0hD4L0000000000000`1AM^800`000000DGKR
055fhP02055fhP030000001AM^80DGKR00<0DGKR00@00000055fhP1AM^80DGKR0P0000001P1AMMh0
e3dI0=@m6@3D?AT0DGGN000000H0DGGN00<00000055egP000000101@LmT00`000000D7?I051cf@04
051cf@040000003D?AT0D7?I000000<0CW3@00<0000004i`d01>L=00101>L=000`000000CW3@0000
000304]Z``030000001;J/<0Bf[300<0Bf[300H000000=@m6@3D?AT0e3dI04EP[P00000204EP[P80
000000@0?EV[0=@m6@3D?AT0e3dI100mFJ/00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^
00H0ooK^00<0e3dI0?ofkP3om^h0103om^h30=@m6@040?ofkP3D?AT0e3dI0=@m6@D0ooK^00<0e3dI
0?ofkP3D?AT0103om^h00`000000ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^01X0ooK^00<00000
0?ofkP3om^h0;P3om^h10?ooo`001`3om^h00`000000ooK^0?ofkP0U0?ofkP<000007`3om^h00`3D
?AT0ooK^0?ofkP050?ofkP80e3dI1`3om^h00`3D?AT0ooK^0?ofkP0@0?ofkP030=@m6@3om^h0ooK^
00`0ooK^0P3D?AT00`3om^h0e3dI0?ofkP0?0?ofkP0303eIZ`000000_SHG00<0_SHG00<0?EV[0;hf
5`2n=QL00`2n=QL00`000000_SHG0;hf5`030;hf5`0503eIZ`2n=QL0_SHG0;hf5`0000001@2n=QL2
00000080bcXI00D000000</j6@3;>QT0bcXI03eIZ`040</j6@030000003;>QT0bcXI00H0bcXI00@0
000003eIZ`0mFJ/0?EV[0P3;>QT0100mFJ/0bcXI0</j6@0000070</j6@030000003;>QT000000080
00000`3F?AX00`000000eSdJ0=Hm6P020=Hm6P0403eIZ`3F?AX0eSdJ000000<0eSdJ00@0?EV[0=Hm
6P3F?AX000001P3F?AX00`000000eSdJ0=Hm6P030=Hm6P030000000mFJ/0eSdJ0080eSdJ0`000003
0>5170040000001AMn<0DGOS00000080DGKR00D00000055fhP1AM^80DGKR00000005055fhP030000
001AM^80DGKR0080DGKR0`3D?AT2055egP030=@m6@000000DGGN00H0DGGN00@00000055egP1AMMh0
00000`1@LmT00`000000D7?I051cf@03051cf@060000001@LmT0D7?I0=@m6@1@LmT000000P1>L=00
0`000000CW3@04i`d00404i`d0040000001>L=00CW3@00000080Bf[300@0000004]Z``1;J/<0Bf[3
0`3D?AT01@000000AF2^0=@m6@15H:h0000000<0AF2^0P3D?AT203eIZ`80ooK^0`0mFJ/00`3D?AT0
ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h00P3om^h20=@m6@04
0?ofkP3D?AT0e3dI0=@m6@T0ooK^0P3D?AT50?ofkP030000003om^h0ooK^00/0ooK^0P3D?ATL0?of
kP030000003om^h0ooK^02h0ooK^0@3oool000L0ooK^00<000000?ofkP3om^h08P3om^h300000280
ooK^00<0e3dI0?ofkP3om^h00P3om^h30=@m6@X0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0
ooK^0?ofkP090?ofkP<0e3dI0`3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP80?EV[102n=QL00`0mFJ/0
_SHG0;hf5`020;hf5`030000002n=QL0_SHG00@0_SHG00@0?EV[0;hf5`2n=QL000000P2n=QL30000
00@0bcXI00<000000</j6@3;>QT00P3;>QT00`0mFJ/0bcXI0</j6@020</j6@030000003;>QT0bcXI
00<0bcXI0`0mFJ/00`000000bcXI0</j6@030</j6@0303eIZ`3;>QT0000000H0bcXI0`0000070=Hm
6P030000003F?AX0eSdJ0080eSdJ00@0?EV[0=Hm6P000000eSdJ0P0mFJ/30=Hm6P030000003F?AX0
eSdJ00@0eSdJ00<000000=Hm6P3F?AX00`3F?AX00`000000eSdJ03eIZ`02000000030>5170000000
hD4L0080hD4L00<0?EV[0000001AMn<00P1AMn<2000000@0DGKR00<00000055fhP1AM^800`1AM^80
0`000000DGKR0=@m6@020=@m6@030000001AM^8000000080DGGN00<0e3dI0000001AMMh01@1AMMh0
1@000000DGGN055egP1AMMh000000080D7?I00<00000051cf@1@LmT0101@LmT010000000D7?I051c
f@3D?AT2051cf@8000001P1>L=001@000000CW3@04i`d01>L=0000000080Bf[3103D?AT0201;J/<0
000004]Z``1;J/<000000=@m6@15H:h000000`15H:h00`000000ooK^0?ofkP0303eIZ`050?ofkP0m
FJ/0?EV[0=@m6@0mFJ/02P3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0e3dI00D0e3dI
303om^h20=@m6@H0ooK^00<000000?ofkP3om^h01P3om^h40=@m6@030?ofkP3D?AT0ooK^01/0ooK^
00<000000?ofkP3om^h0;P3om^h10?ooo`001P3om^h00`000000ooK^0?ofkP0Q0?ofkP8000009@3o
m^h00`3D?AT0ooK^0=@m6@020=@m6@d0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?of
kP070?ofkP80e3dI1`3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP@0?EV[0P2n=QL203eIZ`<0_SHG00<0
00000;hf5`2n=QL0102n=QL00`0mFJ/0_SHG00000002000000P0bcXI00<000000</j6@3;>QT00P3;
>QT01@0mFJ/0bcXI0</j6@3;>QT000000080bcXI0`0mFJ/30</j6@030000003;>QT0bcXI00@0bcXI
00@0?EV[0</j6@000000bcXI100000000`3F?AX000000=Hm6P070=Hm6P030000003F?AX0eSdJ00<0
eSdJ00<0?EV[0000000mFJ/01@3F?AX00`000000eSdJ0=Hm6P040=Hm6P030000003F?AX0eSdJ0080
eSdJ0`0000001@3Q@A`0?EV[0>51703Q@A`000000080hD4L00D0?EV[0>5170000000DGOS0=@m6@02
055gh`050000001AM^80DGKR055fhP0000001@1AM^830=@m6@<0DGKR00<00000055fhP0000000P1A
MMh00`000000e3dI055egP04055egP030000001AMMh0DGGN00<0DGGN00<0000003eIZ`0000001@1@
LmT00`000000D7?I051cf@02051cf@040=@m6@1@LmT0D7?I000000H0CW3@00@0000004i`d01>L=00
CW3@0`3D?AT504]Z``070000001;J/<0Bf[304]Z``000000e3dI0000000304EP[P040000000mFJ/0
ooK^03eIZ`80ooK^0`0mFJ/00`3D?AT0?EV[0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00<0ooK^1P3D
?AT@0?ofkP030=@m6@3om^h0ooK^00D0ooK^00<000000?ofkP3om^h00P3om^h30=@m6@D0ooK^00<0
e3dI0?ofkP3om^h06P3om^h00`000000ooK^0?ofkP0^0?ofkP40oooo00060?ofkP030000003om^h0
ooK^01h0ooK^0`00000W0?ofkP80e3dI403om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0
ooK^00@0ooK^0`3D?AT90?ofkP030=@m6@3om^h0ooK^0100ooK^1@0mFJ/20;hf5`0503eIZ`2n=QL0
_SHG0;hf5`0000001@2n=QL01@000000?EV[03eIZ`3;>QT0000000T0bcXI00<000000</j6@3;>QT0
0P3;>QT00`0mFJ/0bcXI0</j6@0303eIZ`L0bcXI00<000000</j6@3;>QT0103;>QT00`0mFJ/00000
000000060=Hm6P030000003F?AX0eSdJ00D0eSdJ00<000000=Hm6P3F?AX0103F?AX00`0mFJ/00000
0=Hm6P050=Hm6P030000003F?AX0eSdJ00<0eSdJ00<000000=Hm6P0000000P0000000`3Q@A`00000
0>5170020>51700503eIZ`000000hD4L0>51700mFJ/00P3Q@A`00`000000DGOS0=@m6@02055gh`80
00000P1AM^800`000000DGKR055fhP030=@m6@030000001AM^80DGKR0080DGKR00P00000055fhP1A
M^80DGKR0000001AMMh000000=@m6@D0DGGN00<00000055egP1AMMh0101AMMh00`000000D7?I051c
f@03051cf@030000001@LmT0D7?I00<0D7?I00D0e3dI051cf@000000D7?I0000000404i`d0030000
001>L=00e3dI0080e3dI0P1>L=000`000000Bf[304]Z``0304]Z``030000001;J/<0Bf[30080Bf[3
00<0e3dI00000015H:h00P15H:h010000000ooK^03eIZ`0mFJ/30?ofkP80?EV[00<0e3dI03eIZ`0m
FJ/02P3om^h00`3D?AT0ooK^0?ofkP060=@m6A<0ooK^0P3D?AT60?ofkP030000003D?AT0e3dI0080
e3dI203om^h00`3D?AT0ooK^0?ofkP0K0?ofkP030000003om^h0ooK^02d0ooK^0@3oool000H0ooK^
00<000000?ofkP3om^h06`3om^h3000002X0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^
0?ofkP0?0?ofkP040=@m6@3om^h0ooK^0?ofkP<0e3dI303om^h00`3D?AT0ooK^0?ofkP0A0?ofkP04
0=@m6@0mFJ/0?EV[0;hf5`@0?EV[0P2n=QL00`000000_SHG0;hf5`03000000<0bcXI00<0?EV[0</j
6@0000002@3;>QT00`000000bcXI03eIZ`0403eIZ`030</j6@000000bcXI00L0bcXI00<000000</j
6@3;>QT0100000000`3F?AX0?EV[000000060=Hm6P030000003F?AX0eSdJ00D0eSdJ00<000000=Hm
6P3F?AX00P3F?AX203eIZ`030=Hm6P0mFJ/0eSdJ00D0eSdJ00<000000=Hm6P3F?AX00P3F?AX30000
00@0hD4L00<000000>51703Q@A`00P3Q@A`00`0mFJ/0hD4L03eIZ`020>5170060000001AMn<0DGOS
055gh`3D?AT000000P1AMn<2000000<0e3dI0P1AM^800`000000DGKR055fhP03055fhP040000001A
M^80DGKR055fhP8000000P1AMMh01@3D?AT0DGGN055egP1AMMh0000000H0DGGN00<00000055egP00
0000101@LmT00`000000D7?I051cf@04051cf@060=@m6@000000D7?I051cf@000000CW3@103D?AT4
04i`d0030000001>L=00000000<0Bf[300<0000004]Z``1;J/<0101;J/<01@3D?AT0AF2^04EP[P15
H:h000000080ooK^0P0mFJ/40?ofkP0403eIZ`3D?AT0ooK^03eIZ`T0ooK^1P3D?AT00`3om^h0e3dI
0?ofkP0C0?ofkP030=@m6@3om^h0e3dI00<0ooK^0`3D?AT00`000000ooK^0?ofkP080?ofkP030=@m
6@3om^h0ooK^01`0ooK^00<000000?ofkP3om^h0;@3om^h10?ooo`001P3om^h00`000000ooK^0?of
kP0I0?ofkP800000;@3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^00l0ooK^00@0
e3dI0?ofkP3D?AT0e3dI3`3om^h00`3D?AT0ooK^0?ofkP0A0?ofkP80e3dI00<0?EV[0;hf5`2n=QL0
0P2n=QL803eIZ`D0bcXI00<0?EV[0000003;>QT00P3;>QT803eIZ`@0bcXI00@0?EV[0</j6@3;>QT0
00001`3;>QT3000000H0eSdJ0P0mFJ/60=Hm6P030000003F?AX0eSdJ00D0eSdJ00@000000=Hm6P0m
FJ/0?EV[0`3F?AX00`000000?EV[0=Hm6P040=Hm6P030000003F?AX000000080000000<0hD4L0000
003Q@A`0103Q@A`00`000000hD4L0>5170020>5170030000000mFJ/0hD4L0080hD4L00L00000055g
h`1AMn<0DGOS0=@m6@000000DGOS00<0e3dI1@1AM^800`000000DGKR055fhP02055fhP030000001A
M^80DGKR00<0DGKR00@00000055egP1AMMh0e3dI0`1AMMh00`000000DGGN055egP04055egP040000
001AMMh0DGGN00000080D7?I00<00000051cf@1@LmT01@1@LmT00`3D?AT0D7?I051cf@030=@m6@03
04i`d0000000CW3@00D0CW3@00@0000004i`d01>L=0000000P1;J/<00`000000Bf[304]Z``0304]Z
``0303eIZ`3D?AT000000080AF2^00D000000?ofkP3om^h0ooK^03eIZ`040?ofkP0303eIZ`3D?AT0
?EV[0080?EV[1@3om^h60=@m6@@0ooK^00<0e3dI0?ofkP3om^h04P3om^h00`3D?AT0ooK^0=@m6@03
0=@m6@@0ooK^00<000000?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP0L0?ofkP030000003om^h0
ooK^02d0ooK^0@3oool000D0ooK^00<000000?ofkP3om^h05`3om^h3000002l0ooK^00<0e3dI0?of
kP3om^h03`3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP<0e3dI4P3om^h00`3D?AT0ooK^0?ofkP0A0?of
kP030=@m6@000000?EV[00@0_SHG00D0000003eIZ`3;>QT0bcXI000000020</j6@X0?EV[1`3;>QT0
0`000000bcXI0</j6@030</j6@0403eIZ`3;>QT0bcXI000000@0bcXI0P0000020=Hm6P030000003F
?AX0eSdJ00D0eSdJ00<0000003eIZ`3F?AX0103F?AX00`000000eSdJ0=Hm6P050=Hm6P80?EV[1@3F
?AX00`000000eSdJ03eIZ`030=Hm6P<00000103Q@A`00`000000hD4L0>5170030>5170040000003Q
@A`0hD4L0>517080?EV[00D0hD4L03eIZ`0mFJ/0hD4L00000003055gh`<0e3dI0P1AMn<2000000<0
DGKR00<00000055fhP1AM^800P1AM^800`000000DGKR055fhP03055fhP030000001AM^8000000080
DGGN00<0e3dI055egP0000001P1AMMh00`000000DGGN055egP02055egP030000001@LmT0000000H0
D7?I00@000000=@m6@3D?AT0e3dI0P1@LmT00`000000CW3@0000000504i`d0050000001>L=00CW3@
04i`d00000000P1;J/<00`000000Bf[304]Z``0304]Z``030000001;J/<0e3dI0080AF2^00@00000
0?ofkP3om^h0ooK^0P0mFJ/30?ofkP0303eIZ`3D?AT0?EV[00<0?EV[1`3D?AT30?ofkP050=@m6@3o
m^h0ooK^0?ofkP3D?AT04`3om^h50=@m6@H0ooK^00<000000?ofkP3om^h01`3om^h00`3D?AT0ooK^
0?ofkP0L0?ofkP030000003om^h0ooK^02d0ooK^0@3oool000D0ooK^00<000000?ofkP3om^h0503o
m^h3000003<0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP<0e3dI00<0
ooK^0=@m6@3om^h04P3om^h00`3D?AT0ooK^0?ofkP0A0?ofkP80e3dI00<0000003eIZ`0mFJ/00P00
00020</j6@0403eIZ`3;>QT0bcXI000000P0bcXI00<0?EV[0000003;>QT0203;>QT00`000000bcXI
0</j6@030</j6@0303eIZ`3;>QT000000080bcXI0P0000040=Hm6P030000003F?AX0eSdJ00H0eSdJ
00<0000003eIZ`3F?AX00`3F?AX00`000000eSdJ0=Hm6P030=Hm6P80?EV[00<000000=Hm6P3F?AX0
1@3F?AX00`000000eSdJ03eIZ`02000000030>5170000000hD4L00@0hD4L00<000000>51703Q@A`0
0`3Q@A`01@000000hD4L0>51700mFJ/0000000@0hD4L00<0?EV[0=@m6@3D?AT00P3D?AT01@000000
e3dI055gh`1AMn<000000080DGOS00@00000055fhP1AM^800000101AM^800`000000DGKR055fhP03
055fhP040000001AM^80DGKR00000080DGGN00<0e3dI055egP1AMMh0101AMMh00`000000DGGN055e
gP04055egP030000001@LmT0D7?I00<0D7?I0`3D?AT2051cf@050=@m6@1@LmT0D7?I051cf@000000
1P1>L=000`000000CW3@04i`d00204i`d08000001P1;J/<01P000000Bf[304]Z``3D?AT0AF2^0000
00<0ooK^0P0mFJ/40?ofkP030=@m6@0mFJ/0e3dI00D0e3dI1`3om^h01@3D?AT0ooK^0?ofkP3om^h0
e3dI0100ooK^1P3D?AT20?ofkP030=@m6@3om^h0ooK^00@0ooK^00<000000?ofkP3om^h01@3om^h2
0=@m6Ah0ooK^00<000000?ofkP3om^h0;@3om^h10?ooo`001@3om^h00`000000ooK^0?ofkP0B0?of
kP800000=P3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00P0ooK^0`3D?AT50?of
kP030=@m6@3om^h0ooK^0100ooK^00<0e3dI0?ofkP3om^h0403om^h40=@m6@80000000<0?EV[0</j
6@3;>QT00P3;>QT203eIZ`030</j6@000000bcXI00L0bcXI00<0?EV[0000003;>QT0203;>QT00`00
0000bcXI0</j6@030</j6@0403eIZ`0000000000000000L0eSdJ00<000000=Hm6P3F?AX01@3F?AX0
0`000000eSdJ03eIZ`040=Hm6P030000003F?AX0eSdJ0080?EV[0P3F?AX00`000000eSdJ0=Hm6P04
0=Hm6P<0000000D0hD4L03eIZ`3Q@A`0hD4L000000050>5170030000003Q@A`0hD4L00<0hD4L00D0
00000>51700mFJ/0hD4L000000040>5170030000001AMn<0DGOS0080DGOS00D00000055gh`3D?AT0
DGOS00000003055gh`800000101AM^800`000000DGKR055fhP03055fhP030000001AM^80DGKR0080
DGKR00<00000055egP3D?AT01@1AMMh00`000000DGGN055egP04055egP040000001AMMh00000051c
f@<0e3dI00<0D7?I0000001@LmT00P1@LmT01P3D?AT0D7?I051cf@000000D7?I000000@0CW3@00<0
000004i`d01>L=00101>L=000`000000Bf[304]Z``0404]Z``040000001;J/<0Bf[30=@m6@800000
0`3om^h00`0mFJ/0ooK^03eIZ`020?ofkPH0e3dI00<0?EV[0?ofkP3om^h0203om^h0103D?AT0ooK^
0?ofkP3D?AT=0?ofkPL0e3dI1@3om^h00`3D?AT0ooK^0?ofkP040?ofkP040000003om^h0ooK^0?of
kP<0e3dI00<0ooK^0=@m6@3om^h07P3om^h00`000000ooK^0?ofkP0/0?ofkP40oooo00050?ofkP03
0000003om^h0ooK^00l0ooK^0`00000h0?ofkP030=@m6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3o
m^h01@3om^h20=@m6@P0ooK^00<0e3dI0?ofkP3om^h0403om^h00`3D?AT0ooK^0?ofkP0>0?ofkP80
e3dI00P0ooK^0=@m6@3om^h0e3dI0?ofkP000000bcXI03eIZ`D0bcXI00<0?EV[0</j6@000000203;
>QT203eIZ`P0bcXI00<000000</j6@3;>QT0100000000`0mFJ/0eSdJ000000080=Hm6P030000003F
?AX0eSdJ00D0eSdJ00<000000=Hm6P0mFJ/00`3F?AX00`000000?EV[03eIZ`050=Hm6P030000003F
?AX0000000<0000000<0hD4L0000003Q@A`00P3Q@A`00`0mFJ/0hD4L000000050>5170030000003Q
@A`0hD4L0080hD4L00<0000003eIZ`0mFJ/00P3Q@A`00`000000hD4L0>5170020>5170050000001A
Mn<0DGOS055gh`0000000P1AMn<00`3D?AT00000055gh`04055gh`030000001AM^80DGKR0080DGKR
00<00000055fhP1AM^800P1AM^800`000000DGKR055fhP04055fhP030000001AMMh0e3dI00@0DGGN
00<00000055egP1AMMh0101AMMh010000000e3dI0=@m6@3D?AT3051cf@030000001@LmT0D7?I00<0
D7?I00<0e3dI051cf@0000000P1@LmT01@000000CW3@04i`d01>L=00000000H0CW3@0P00000404]Z
``030000001;J/<0Bf[30080Bf[300<0e3dI0000003om^h00P3om^h00`0mFJ/0e3dI0=@m6@050=@m
6@030?ofkP0mFJ/0?EV[0080?EV[2P3om^h00`3D?AT0ooK^0=@m6@0:0?ofkPD0e3dI103om^h00`3D
?AT0ooK^0?ofkP040?ofkP80e3dI1@3om^h00`000000e3dI0=@m6@030?ofkP030=@m6@3om^h0ooK^
01h0ooK^00<000000?ofkP3om^h0;03om^h10?ooo`001@3om^h00`000000ooK^0?ofkP0=0?ofkP80
0000>`3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^0080ooK^0`3D?AT:0?ofkP03
0=@m6@3om^h0ooK^0140ooK^00<0e3dI0?ofkP3om^h02P3om^h30=@m6@@0ooK^0P3D?AT20?ofkP80
00000P0mFJ/40</j6@0303eIZ`3;>QT0000000T0bcXI00<0?EV[0</j6@3;>QT01@3;>QT3000000D0
eSdJ0P0mFJ/00`000000eSdJ0=Hm6P060=Hm6P030000003F?AX0eSdJ00@0eSdJ00D000000=Hm6P3F
?AX0?EV[0=Hm6P0203eIZ`030000003F?AX0eSdJ00@0eSdJ0P0000050>5170030000003Q@A`0hD4L
0080hD4L00<0?EV[0000003Q@A`0103Q@A`00`000000hD4L0>5170020>51700303eIZ`3Q@A`0hD4L
0080hD4L00<000000>51703Q@A`00P3Q@A`01@000000DGOS055gh`1AMn<0000000<0DGOS00<0e3dI
055gh`1AMn<00P1AMn<00`000000DGOS00000002055fhP030000001AM^80DGKR00<0DGKR00<00000
055fhP1AM^800`1AM^8010000000DGKR0000003D?AT3055egP030000001AMMh0DGGN00<0DGGN0`3D
?AT2055egP040000001@LmT0D7?I000000L0D7?I00D0e3dI051cf@1@LmT0D7?I0000000204i`d003
0000001>L=00CW3@00@0CW3@00@0000004i`d01>L=0000000`1;J/<00`000000Bf[304]Z``0204]Z
``030=@m6@000000ooK^00L0e3dI00<0ooK^0=@m6@3om^h00P3om^h403eIZ`X0ooK^0P3D?AT70?of
kPD0e3dI1`3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0e3dI0080e3dI00<000000?of
kP3om^h00`3om^h00`3D?AT0ooK^0?ofkP0N0?ofkP030000003om^h0ooK^02`0ooK^0@3oool000@0
ooK^00<000000?ofkP3om^h02`3om^h3000003d0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0
ooK^0=@m6@020=@m6@d0ooK^00<0e3dI0?ofkP3om^h04@3om^h00`3D?AT0ooK^0?ofkP080?ofkP80
e3dI1`3om^h00`3D?AT0ooK^0=@m6@030?ofkP030000003;>QT0?EV[00@0bcXI00<0?EV[0</j6@00
0000203;>QT00`000000?EV[0</j6@030</j6@8000000P3F?AX00`000000eSdJ0=Hm6P050=Hm6P03
03eIZ`000000eSdJ00H0eSdJ00<000000=Hm6P3F?AX01@3F?AX010000000eSdJ03eIZ`0mFJ/20=Hm
6P030000003F?AX0eSdJ0080eSdJ0`0000060>5170030000003Q@A`0hD4L00<0hD4L00<0?EV[0>51
703Q@A`00`3Q@A`00`000000hD4L0>51700203eIZ`030000003Q@A`0hD4L0080hD4L00<000000>51
703Q@A`00P3Q@A`01@000000DGOS055gh`1AMn<000000080DGOS00<000000=@m6@1AMn<00`1AMn<0
1P000000DGOS055gh`000000DGKR000000@0DGKR00<00000055fhP1AM^800`1AM^8020000000DGKR
055fhP1AM^8000000=@m6@1AMMh000000`1AMMh30=@m6@030000001AMMh0DGGN00<0DGGN00<00000
051cf@0000001P1@LmT00`000000e3dI051cf@03051cf@030000001>L=00000000H0CW3@00D00000
04i`d01>L=00CW3@0000000204]Z``030000001;J/<0Bf[30080Bf[31P3D?AT30?ofkP0403eIZ`3o
m^h0e3dI03eIZ`<0ooK^00@0?EV[0?ofkP0mFJ/0?EV[2@3om^h20=@m6@@0ooK^1@3D?AT:0?ofkP03
0=@m6@3om^h0ooK^00@0ooK^1@3D?AT30?ofkP050000003om^h0ooK^0?ofkP3D?AT08@3om^h00`00
0000ooK^0?ofkP0/0?ofkP40oooo00040?ofkP030000003om^h0ooK^00P0ooK^0`0000100?ofkP03
0=@m6@3om^h0ooK^00h0ooK^0`3D?ATA0?ofkP030=@m6@3om^h0ooK^0100ooK^00<0e3dI0?ofkP3o
m^h01@3om^h30=@m6@T0ooK^00<0e3dI0?ofkP3D?AT0103om^h010000000bcXI03eIZ`0mFJ/30</j
6@0303eIZ`3;>QT0000000P0bcXI00<0000003eIZ`3;>QT00P0000050=Hm6P030000003F?AX0eSdJ
00D0eSdJ00<0?EV[0000003F?AX01P3F?AX00`000000eSdJ0=Hm6P030=Hm6P<0?EV[0P3F?AX01@0m
FJ/0eSdJ0=Hm6P000000eSdJ008000000`3Q@A`00`000000hD4L0>5170040>5170030000003Q@A`0
hD4L0080hD4L00<0000003eIZ`3Q@A`00`3Q@A`00`000000hD4L03eIZ`020>5170050000003Q@A`0
hD4L0>5170000000103Q@A`01@000000DGOS055gh`1AMn<0000000<0DGOS00<00000055gh`3D?AT0
0P1AMn<00`000000DGOS055gh`02055gh`030000001AM^80DGKR00<0DGKR00<00000055fhP1AM^80
0`1AM^800`000000DGKR055fhP02055fhP030=@m6@1AMMh0000000<0e3dI0P1AMMh00`000000DGGN
055egP05055egP030000001@LmT0D7?I00D0D7?I00<00000051cf@3D?AT0101@LmT00`000000CW3@
04i`d00404i`d0030000001>L=00CW3@00<0CW3@0P00000204]Z``H0e3dI00<0ooK^03eIZ`3om^h0
103om^h00`0mFJ/0e3dI03eIZ`030?ofkP80?EV[00<0ooK^03eIZ`3om^h02@3om^h00`3D?AT0ooK^
0=@m6@030=@m6@d0ooK^00<0e3dI0?ofkP3om^h00P3om^h50=@m6@<0ooK^0P3D?AT20?ofkP040000
003om^h0e3dI0=@m6B40ooK^00<000000?ofkP3om^h0;03om^h10?ooo`00103om^h00`000000ooK^
0?ofkP060?ofkP800000@`3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP<0e3dI00<0ooK^0=@m6@3om^h0
4@3om^h00`3D?AT0ooK^0?ofkP0@0?ofkP030=@m6@3om^h0ooK^0080ooK^0`3D?AT=0?ofkP80e3dI
1@3om^h00`000000bcXI03eIZ`0203eIZ`80bcXI00<0?EV[0</j6@0000001`3;>QT20000000303eI
Z`3F?AX0eSdJ00H0eSdJ00<000000=Hm6P3F?AX01@3F?AX00`0mFJ/0eSdJ0=Hm6P060=Hm6P030000
003F?AX0?EV[0080?EV[0P3F?AX01@000000eSdJ0=Hm6P3F?AX0?EV[00<000001@3Q@A`00`000000
hD4L0>5170040>5170030000003Q@A`0hD4L00<0hD4L00<0000003eIZ`3Q@A`00P3Q@A`00`000000
?EV[0>5170020>5170050000003Q@A`0hD4L0>51700000000P3Q@A`3000000<0DGOS00@00000055g
h`1AMn<000000P1AMn<0103D?AT0DGOS055gh`000003055gh`030000001AMn<0000000<0DGKR00<0
0000055fhP1AM^800`1AM^800`000000DGKR055fhP03055fhP<0e3dI1@1AMMh00`000000DGGN055e
gP04055egP030000001AMMh0000000D0D7?I00D00000051cf@1@LmT0D7?I0=@m6@02051cf@030000
001@LmT0000000D0CW3@00<0000004i`d01>L=00101>L=030=@m6@<0Bf[300D0?EV[0?ofkP3om^h0
e3dI03eIZ`060?ofkP030=@m6@0mFJ/0ooK^00<0ooK^00@0?EV[0?ofkP3om^h0?EV[203om^h40=@m
6A00ooK^00<0e3dI0?ofkP3D?AT0103D?AT80?ofkP<0e3dI00<000000?ofkP3om^h08P3om^h00`00
0000ooK^0?ofkP0[0?ofkP40oooo00040?ofkP030000003om^h0ooK^00<0ooK^0`0000150?ofkP03
0=@m6@3om^h0ooK^00P0ooK^0`3D?AT40?ofkP030=@m6@3om^h0ooK^0100ooK^00<0e3dI0?ofkP3o
m^h04@3om^h0103D?AT0ooK^0=@m6@3D?AT@0?ofkP030=@m6@3om^h0e3dI00D0ooK^00@000000</j
6@0mFJ/0bcXI0P0mFJ/0103;>QT0?EV[03eIZ`0000020</j6@@000000P3F?AX00`000000?EV[0=Hm
6P070=Hm6P030000003F?AX0eSdJ00D0eSdJ00<0?EV[0=Hm6P3F?AX0103F?AX303eIZ`D0eSdJ1000
0000103Q@A`0?EV[0>51700000060>5170030000003Q@A`0hD4L00<0hD4L00<000000>51703Q@A`0
0`3Q@A`010000000hD4L03eIZ`3Q@A`203eIZ`@0hD4L00@000000>51703Q@A`0hD4L0`0000020>Y4
7@8000000P1AMn<010000000DGOS055gh`000003055gh`030=@m6@000000DGOS00<0DGOS00<00000
055gh`0000000P1AM^800`000000DGKR055fhP03055fhP040000001AM^80DGKR055fhP<0e3dI00<0
0000055fhP3D?AT0101AMMh00`000000DGGN055egP04055egP040000001AMMh0DGGN055egP800000
0P1@LmT00`000000D7?I051cf@02051cf@040=@m6@1@LmT0D7?I00000080D7?I00D0000004i`d01>
L=00CW3@0000000404i`d0<0e3dI00<0CW3@0000001;J/<00P1;J/<00`000000ooK^03eIZ`020?of
kP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP0mFJ/01@3om^h0100mFJ/0ooK^0?ofkP0mFJ/4
0?ofkPD0e3dI00<0ooK^0=@m6@3om^h03P3om^h40=@m6@P0ooK^103D?AT30?ofkP030000003om^h0
ooK^0280ooK^00<000000?ofkP3om^h0:`3om^h10?ooo`000`3om^h010000000ooK^0?ofkP3om^h3
000004T0ooK^00<0e3dI0?ofkP3om^h01@3om^h20=@m6@P0ooK^00<0e3dI0?ofkP3om^h03`3om^h0
0`3D?AT0ooK^0?ofkP0@0?ofkP<0e3dI4`3om^h20=@m6@H0ooK^0P0000000`0mFJ/0bcXI0</j6@02
03eIZ`040</j6@0mFJ/00000000000L0eSdJ00<0000003eIZ`0mFJ/01`3F?AX00`000000eSdJ0=Hm
6P050=Hm6P0303eIZ`3F?AX0eSdJ00<0?EV[0P3F?AX00`000000eSdJ0=Hm6P0300000080hD4L00H0
00000>51703Q@A`0hD4L03eIZ`0000060>5170030000003Q@A`0hD4L00<0hD4L00<000000>51703Q
@A`00`3Q@A`01P000000hD4L0>51700mFJ/0hD4L000000@0hD4L00@000000>51700000000000103Z
A1d00`000000D7KS051fh`0200000080DGOS00<00000055gh`1AMn<00P1AMn<00`3D?AT0DGOS055g
h`02055gh`070000001AMn<0DGOS055gh`000000DGKR00000004055fhP030000001AM^80e3dI0080
e3dI0P1AM^801@000000DGKR055fhP3D?AT000000080DGGN00<00000055egP1AMMh01@1AMMh00`00
0000DGGN055egP03055egP030000001@LmT0000000D0D7?I00<0e3dI0000001@LmT00`1@LmT01000
0000CW3@04i`d00000040=@m6@80CW3@00@0000004i`d01>L=0000000P1;J/<01`000000ooK^0?of
kP0mFJ/0ooK^03eIZ`3D?AT0103om^h0103D?AT0ooK^03eIZ`0mFJ/40?ofkP80?EV[00<0ooK^03eI
Z`3D?AT0103D?AT20?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT02P3om^h50=@m6@P0ooK^103D?AT7
0?ofkP030000003om^h0ooK^0240ooK^00<000000?ofkP3om^h0:`3om^h10?ooo`000`3om^h01000
0000ooK^00000000001<0?ofkP030=@m6@3om^h0ooK^0080ooK^0`3D?AT:0?ofkP030=@m6@3om^h0
ooK^0100ooK^00<0e3dI0?ofkP3om^h0303om^h30=@m6@030?ofkP3D?AT0ooK^01<0ooK^0P3D?AT7
0?ofkP8000000P0mFJ/2000000<0?EV[00<000000=Hm6P3F?AX01`3F?AX00`000000?EV[0=Hm6P06
0=Hm6P030000003F?AX0eSdJ0080eSdJ1@0mFJ/50=Hm6P<000001@3Q@A`00`000000hD4L0>517002
0>51700303eIZ`000000hD4L00@0hD4L00<000000>51703Q@A`00`3Q@A`00`000000hD4L0>517003
0>5170060000000mFJ/0?EV[0>51700mFJ/000000P3Q@A`4000000H0jT@M00D00000051fh`1@M^<0
D7KS00000002055gh`030000001AMn<0DGOS0080DGOS00D000000=@m6@1AMn<0DGOS00000005055g
h`030000001AM^80DGKR0080DGKR0`3D?AT5055fhP080000001AM^80DGKR055fhP3D?AT00000055e
gP000006055egP030000001AMMh0DGGN00D0DGGN00<00000051cf@1@LmT0101@LmT00`000000e3dI
051cf@04051cf@<0e3dI1@1>L=001@000000CW3@04i`d01>L=0000000080Bf[300L000000?ofkP3o
m^h0?EV[0?ofkP0mFJ/0e3dI00@0ooK^00@0e3dI0?ofkP3om^h0?EV[1@3om^h50=@m6@D0ooK^00<0
e3dI0?ofkP3om^h00P3om^h20=@m6@D0ooK^1@3D?AT20?ofkP030=@m6@3om^h0ooK^0080ooK^1@3D
?AT;0?ofkP030000003om^h0ooK^0200ooK^00<000000?ofkP3om^h0:`3om^h10?ooo`000`3om^h2
000004h0ooK^00<0e3dI0?ofkP3D?AT00P3D?AT=0?ofkP030=@m6@3om^h0ooK^0100ooK^00<0e3dI
0?ofkP3om^h02@3om^h30=@m6@D0ooK^00<0e3dI0?ofkP3om^h04@3om^h00`3D?AT0ooK^0=@m6@07
0?ofkP<0000000@0?EV[0=Hm6P3F?AX0eSdJ200mFJ/40=Hm6P030000000mFJ/0eSdJ00<0eSdJ1`0m
FJ/40=Hm6P0303eIZ`3F?AX0eSdJ00<000000P3Q@A`00`000000hD4L0>5170040>5170030000003Q
@A`0hD4L0080hD4L0P0mFJ/50>5170030000003Q@A`0hD4L0080hD4L00<000000>51703Q@A`00P3Q
@A`203eIZ`<0hD4L00@0000003eIZ`00000000000P3ZA1d010000000jT@M0>Y47@0000030>Y47@03
0000001@M^<0D7KS00<0D7KS0P000004055gh`030000001AMn<0e3dI0080DGOS00<00000055gh`1A
Mn<00P1AMn<00`000000DGOS0=@m6@030=@m6@030000001AM^80DGKR00@0DGKR00<00000055fhP1A
M^800`1AM^800`3D?AT00000055egP05055egP030000001AMMh0DGGN00D0DGGN00<00000055egP00
00001@1@LmT010000000e3dI051cf@1@LmT30=@m6@03051cf@000000CW3@00D0CW3@00<0000004i`
d01>L=000P1>L=02000000@0ooK^0P0mFJ/00`3om^h0e3dI0?ofkP020?ofkP030=@m6@3om^h0ooK^
0080?EV[00<0ooK^0=@m6@3D?AT00`3D?AT00`3om^h0?EV[0?ofkP050?ofkP030=@m6@3om^h0ooK^
00@0ooK^1P3D?AT50?ofkP030=@m6@3om^h0e3dI00D0e3dI3P3om^h00`000000ooK^0?ofkP0P0?of
kP030000003om^h0ooK^02/0ooK^0@3oool000@0ooK^0P00001=0?ofkP80e3dI403om^h00`3D?AT0
ooK^0?ofkP0@0?ofkP030=@m6@3om^h0ooK^00H0ooK^0`3D?AT80?ofkP030=@m6@3om^h0ooK^0180
ooK^0P3D?AT40?ofkP<0e3dI00D0ooK^000000000000000003eIZ`040=Hm6P0303eIZ`3F?AX00000
00<0eSdJ2P0mFJ/40=Hm6P030000003F?AX0eSdJ00@0eSdJ00<0000003eIZ`0000001@3Q@A`00`00
0000hD4L0>5170050>5170030000003Q@A`0hD4L0080hD4L00<0000003eIZ`3Q@A`00`3Q@A`00`00
0000hD4L0>5170030>5170070000003Q@A`0?EV[03eIZ`3Q@A`000000>517002000000030>Y47@00
0000?EV[00<0jT@M00@000000>Y47@3ZA1d000000`3ZA1d01@000000D7KS051fh`1@M^<000000080
D7KS00<00000055gh`1AMn<00P1AMn<01@000000DGOS055gh`3D?AT0000000@0DGOS0`3D?AT0101A
Mn<00000055fhP000006055fhP030000001AM^80DGKR00@0DGKR00<000000=@m6@000000101AMMh0
0`000000DGGN055egP05055egP050000001AMMh0DGGN055egP0000000`1@LmT00`000000D7?I0=@m
6@020=@m6@<0D7?I00<00000051cf@000000101>L=000`000000CW3@04i`d00404i`d0030000003o
m^h0ooK^00<0ooK^00@0?EV[0?ofkP3om^h0e3dI0P3om^h00`3D?AT0ooK^0=@m6@040=@m6@80ooK^
00D0?EV[0?ofkP0mFJ/0ooK^03eIZ`050?ofkP030=@m6@3om^h0ooK^0080ooK^1@3D?AT70?ofkPD0
e3dI4`3om^h00`000000ooK^0?ofkP0P0?ofkP030000003om^h0ooK^02X0ooK^0@3oool000H0ooK^
00<000000?ofkP3om^h0BP3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^0100ooK^
00<0e3dI0?ofkP3om^h00`3om^h30=@m6@`0ooK^00<0e3dI0?ofkP3om^h04@3om^h0103D?AT0ooK^
0=@m6@3om^h20=@m6@D0ooK^00@0000003eIZ`000000?EV[103F?AX00`0mFJ/0eSdJ000000080=Hm
6P030000000mFJ/0eSdJ00H0eSdJ00<000000=Hm6P3F?AX00`0000020>51700303eIZ`3Q@A`0hD4L
00@0hD4L00<000000>51703Q@A`0103Q@A`00`000000hD4L0>5170020>5170030000003Q@A`0?EV[
00@0hD4L00<000000>51703Q@A`00P3Q@A`010000000?EV[0>51703Q@A`3000000<0jT@M00D00000
0>Y47@0mFJ/0?EV[000000030>Y47@050000003ZA1d0jT@M0>Y47@0000000P1@M^<00`000000D7KS
051fh`02051fh`040000001AMn<0DGOS000000<0DGOS00<0e3dI0000001AMn<00`3D?AT00`000000
DGOS055gh`02055gh`030000001AM^80DGKR00@0DGKR00<00000055fhP1AM^80101AM^801@000000
DGKR0=@m6@1AM^80000000<0DGGN00<00000055egP1AMMh0101AMMh00`000000DGGN055egP02055e
gP030000001@LmT0e3dI00<0e3dI0P1@LmT0103D?AT0D7?I051cf@000003051cf@050000001>L=00
CW3@04i`d00000001@1>L=000`000000ooK^0?ofkP040?ofkP80?EV[0P3om^h60=@m6@80ooK^00@0
?EV[0?ofkP3om^h0?EV[0P3om^h203eIZ`@0ooK^00<0e3dI0?ofkP3D?AT01@3D?AT30?ofkP<0e3dI
00<0ooK^0=@m6@3D?AT00`3D?ATG0?ofkP030000003om^h0ooK^01l0ooK^00<000000?ofkP3om^h0
:P3om^h10?ooo`001`3om^h2000004X0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0?of
kP0A0?ofkP030=@m6@3om^h0e3dI0080e3dI3`3om^h00`3D?AT0ooK^0?ofkP0A0?ofkP040=@m6@3o
m^h0e3dI0=@m6@P0ooK^0P3D?AT00`0mFJ/000000=Hm6P030=Hm6P80?EV[0P0000070=Hm6P030000
000mFJ/0eSdJ00D0eSdJ0`0000060>51700303eIZ`3Q@A`0hD4L00@0hD4L00<000000>51703Q@A`0
103Q@A`00`000000hD4L0>5170020>5170030000003Q@A`0?EV[00<0hD4L00@000000>51703Q@A`0
hD4L0P0mFJ/01@3Q@A`000000000003ZA1d0000000@0jT@M00D000000>Y47@3ZA1d0jT@M03eIZ`03
0>Y47@040000003ZA1d0jT@M000000<0D7KS00@00000051fh`1@M^<000000P1@M^<00`000000DGOS
00000003055gh`<0e3dI0P1AMn<00`000000DGOS055gh`02055gh`030000001AMn<0000000@0DGKR
00<00000055fhP1AM^80101AM^802@000000DGKR055fhP1AM^80e3dI055fhP000000DGGN00000006
055egP030000001AMMh0DGGN0080DGGN0`3D?AT00`1@LmT00000051cf@04051cf@030=@m6@000000
D7?I00<0D7?I00@0000004i`d01>L=0000001P1>L=000`000000ooK^0?ofkP040?ofkP0303eIZ`3D
?AT0e3dI00@0e3dI0P3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[0080ooK^00<0?EV[0?ofkP3om^h0
0P0mFJ/20?ofkPH0e3dI1`3om^h50=@m6A/0ooK^00<000000?ofkP3om^h07P3om^h00`000000ooK^
0?ofkP0Z0?ofkP40oooo00090?ofkP030000003om^h0ooK^04P0ooK^00<0e3dI0?ofkP3om^h03`3o
m^h00`3D?AT0ooK^0?ofkP0?0?ofkP<0e3dI4P3om^h00`3D?AT0ooK^0?ofkP0B0?ofkP80e3dI1P3o
m^h30=@m6@80ooK^00<0000003eIZ`0000001@3F?AX00`0mFJ/0eSdJ000000080=Hm6P0303eIZ`3F
?AX0eSdJ00<000000P3Q@A`00`000000hD4L0>5170050>51700303eIZ`3Q@A`0hD4L00@0hD4L00<0
00000>51703Q@A`00`3Q@A`00`000000hD4L0>5170020>5170040000003Q@A`0hD4L03eIZ`<0hD4L
00<0000003eIZ`0mFJ/00`0000030>Y47@030000003ZA1d0jT@M0080jT@M00P000000>Y47@3ZA1d0
jT@M0000000mFJ/0jT@M000000<0jT@M00@00000051fh`1@M^<000000P1@M^<00`000000D7KS051f
h`02051fh`030000003D?AT0e3dI0080e3dI0P1AMn<00`3D?AT0DGOS00000004055gh`050000001A
Mn<0DGOS055gh`0000000`1AM^800`000000DGKR055fhP03055fhP030000001AM^80DGKR00<0DGKR
00<0e3dI055fhP0000001P1AMMh00`000000DGGN0=@m6@030=@m6@<0DGGN00<00000051cf@1@LmT0
101@LmT00`000000e3dI051cf@04051cf@030000001>L=00000000D0CW3@00<000000?ofkP3om^h0
0P3om^h70=@m6@030?ofkP3D?AT0e3dI0080ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`020?ofkP04
03eIZ`3om^h0ooK^0?ofkPH0e3dI1`3om^h50=@m6Ah0ooK^00<000000?ofkP3om^h07P3om^h00`00
0000ooK^0?ofkP0Z0?ofkP40oooo000:0?ofkP800000B03om^h00`3D?AT0ooK^0?ofkP0?0?ofkP03
0=@m6@3om^h0ooK^00d0ooK^0P3D?AT00`3om^h0e3dI0?ofkP0C0?ofkP030=@m6@3om^h0ooK^0140
ooK^0P3D?AT40?ofkP80e3dI1P3om^h3000000D0eSdJ00<0?EV[0=Hm6P0000001`3F?AX00`000000
?EV[000000060>5170030000003Q@A`0hD4L00D0hD4L0P0mFJ/40>5170030000003Q@A`0hD4L00@0
hD4L00<000000>51703Q@A`00P3Q@A`01@000000hD4L0>51700mFJ/0hD4L0080?EV[0P0000000`3Z
A1d000000>Y47@040>Y47@050000003ZA1d0jT@M0>Y47@0000000`3ZA1d010000000jT@M03eIZ`00
00030>Y47@040000001@M^<0D7KS00000080D7KS00<00000051fh`1@M^<00`3D?AT200000003055g
h`000000DGOS0080DGOS00<0e3dI055gh`1AMn<00`1AMn<00`000000DGOS055gh`02055gh`030000
001AM^80000000D0DGKR00<00000055fhP1AM^801@1AM^800`3D?AT0DGKR00000004055egP<0e3dI
1P1AMMh00`000000DGGN00000004051cf@040000001@LmT0D7?I0=@m6@D0D7?I00<0000004i`d01>
L=00101>L=000`000000e3dI0=@m6@050=@m6@@0ooK^00H0?EV[0=@m6@3om^h0e3dI0?ofkP0mFJ/4
0?ofkP0303eIZ`3om^h0e3dI00L0e3dI1@3om^h60=@m6B80ooK^00<000000?ofkP3om^h07@3om^h0
0`000000ooK^0?ofkP0Z0?ofkP40oooo000<0?ofkP030000003om^h0ooK^04D0ooK^00<0e3dI0?of
kP3om^h03`3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP<0e3dI103om^h00`3D?AT0ooK^0?ofkP0A0?of
kP030=@m6@3om^h0ooK^0180ooK^1@3D?AT90?ofkP@00000103F?AX0100mFJ/0eSdJ000000000002
0=Hm6P<000000P3Q@A`00`0mFJ/0hD4L0>5170050>5170030000003Q@A`0hD4L00@0hD4L00<00000
0>51700mFJ/0103Q@A`00`000000hD4L0>5170040>5170050000003Q@A`0hD4L0>51700000000P3Q
@A`203eIZ`030>Y47@000000jT@M00<0jT@M00<000000>Y47@3ZA1d00P3ZA1d01@000000jT@M0>Y4
7@3ZA1d0000000<0jT@M00@000000>Y47@3ZA1d0?EV[0P3ZA1d010000000D7KS051fh`000002051f
h`@0e3dI00<0D7KS0000001@M^<00P1@M^<01P000000DGOS055gh`1AMn<000000=@m6@@0DGOS00<0
0000055gh`1AMn<0101AMn<00`000000DGKR055fhP03055fhP030000001AM^80DGKR00@0DGKR0P00
00000`3D?AT0DGKR000000040=@m6@P0DGGN00@00000055egP1AMMh000000`1@LmT00`000000D7?I
051cf@02051cf@070=@m6@1@LmT0D7?I051cf@000000D7?I0000000404i`d0D0e3dI0`3om^h00`0m
FJ/0ooK^0?ofkP020?ofkP0403eIZ`3D?AT0ooK^0?ofkP80e3dI0`3om^h60=@m6@80ooK^00<0?EV[
0=@m6@3om^h00P3om^h60=@m6BH0ooK^00<000000?ofkP3om^h0703om^h00`000000ooK^0?ofkP0Z
0?ofkP40oooo000=0?ofkP030000003om^h0ooK^04@0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D
?AT0ooK^0?ofkP080?ofkP80e3dI1`3om^h00`3D?AT0ooK^0?ofkP0B0?ofkP030=@m6@3om^h0ooK^
0100ooK^0`3D?AT>0?ofkP<00000103F?AX00`0mFJ/0eSdJ00000002000000H0hD4L0P0mFJ/60>51
70030000003Q@A`0hD4L00@0hD4L00<000000>51700mFJ/0103Q@A`00`000000hD4L0>5170030>51
70040000003Q@A`0hD4L0>5170<0?EV[0P3ZA1d00`0mFJ/0jT@M000000030>Y47@030000003ZA1d0
jT@M0080jT@M00D000000>Y47@3ZA1d0jT@M000000030>Y47@070000003ZA1d0jT@M0000000mFJ/0
jT@M00000002051fh`040000003D?AT0e3dI000000<0D7KS00L00000051fh`1@M^<0D7KS0000001@
M^<000000080DGOS00<00000055gh`3D?AT00P1AMn<00`000000DGOS055gh`04055gh`030000001A
Mn<0000000<0DGKR00<00000055fhP1AM^80101AM^800`000000DGKR055fhP030=@m6@030000001A
MMh0000000P0DGGN00<00000055egP1AMMh00P1AMMh00`000000D7?I00000006051cf@030=@m6@1@
LmT0000000<0D7?I00<0000004i`d03D?AT00`3D?AT60?ofkP0303eIZ`3om^h0ooK^00<0ooK^00D0
e3dI0?ofkP3om^h0ooK^03eIZ`060=@m6@80?EV[103om^h70=@m6BT0ooK^00<000000?ofkP3om^h0
7@3om^h00`000000ooK^0?ofkP0Y0?ofkP40oooo000>0?ofkP800000A03om^h00`3D?AT0ooK^0?of
kP0?0?ofkP030=@m6@3om^h0ooK^00D0ooK^0`3D?AT90?ofkP030=@m6@3om^h0ooK^0180ooK^00<0
e3dI0?ofkP3om^h03@3om^h30=@m6@030?ofkP3D?AT0e3dI00l0ooK^100000020=Hm6P040000000m
FJ/0?EV[0>51708000001`3Q@A`00`0mFJ/0hD4L0>5170040>51708000001@3Q@A`00`000000hD4L
03eIZ`040>5170030000003Q@A`0hD4L0080hD4L00@0000003eIZ`0mFJ/0?EV[0P3ZA1d01P000000
jT@M0>Y47@3ZA1d0?EV[000000@0jT@M00D000000>Y47@3ZA1d0jT@M000000030>Y47@040000003Z
A1d0jT@M00000080jT@M00D000000>Y47@0mFJ/00000051fh`030=@m6@03051fh`000000D7KS0080
D7KS00D00000051fh`1@M^<0D7KS00000002051fh`030000001AMn<0000000<0DGOS00<0e3dI0000
001AMn<0101AMn<2000000<0DGOS00<00000055fhP0000001P1AM^8010000000e3dI0=@m6@3D?AT2
055fhP030=@m6@1AM^80000000L0DGGN0P000006055egP030000001@LmT0D7?I00H0D7?I00<0e3dI
051cf@1@LmT0103D?AT00`1>L=00000003eIZ`060?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0e3dI
0?ofkP3D?AT01P3D?AT40?ofkP0303eIZ`3om^h0ooK^00D0e3dI;P3om^h00`000000ooK^0?ofkP0L
0?ofkP030000003om^h0ooK^02T0ooK^0@3oool00100ooK^00<000000?ofkP3om^h0@@3om^h00`3D
?AT0ooK^0?ofkP0@0?ofkP040=@m6@3om^h0ooK^0?ofkP<0e3dI3@3om^h00`3D?AT0ooK^0?ofkP0A
0?ofkP030=@m6@3om^h0ooK^00X0ooK^0`3D?AT50?ofkP030=@m6@3om^h0ooK^00h0ooK^1@000003
0>51700303eIZ`3Q@A`0hD4L008000001P3Q@A`00`0mFJ/0hD4L0>5170050>5170030000003Q@A`0
hD4L00<0hD4L00<000000>51700mFJ/00`3Q@A`00`000000hD4L0>51700303eIZ`030>Y47@000000
jT@M0080jT@M00<000000>Y47@3ZA1d00P3ZA1d00`0mFJ/000000>Y47@020>Y47@050000003ZA1d0
jT@M0>Y47@0000000`3ZA1d010000000jT@M0>Y47@0000020>Y47@070000003ZA1d000000000000m
FJ/0D7KS00000002051fh`050000001@M^<0D7KS051fh`0000000`1@M^<01@000000D7KS051fh`1@
M^<0000000@0DGOS00<000000=@m6@1AMn<00`1AMn<00`000000DGOS055gh`04055gh`030000001A
M^80DGKR00<0DGKR0`3D?AT5055fhP040000003D?AT0DGKR000000D0DGGN00<00000055egP1AMMh0
1@1AMMh00`000000DGGN00000006051cf@040000003D?AT0e3dI0=@m6@<0D7?I00D0000004i`d000
0000ooK^03eIZ`050?ofkP0303eIZ`3om^h0ooK^0080ooK^1`3D?AT30?ofkPT0e3dI00<0ooK^03eI
Z`3om^h0;`3om^h00`000000ooK^0?ofkP0K0?ofkP030000003om^h0ooK^02T0ooK^0@3oool00140
ooK^0P0000120?ofkP030=@m6@3om^h0ooK^00l0ooK^00@0e3dI0?ofkP3D?AT0e3dI403om^h00`3D
?AT0ooK^0?ofkP0B0?ofkP030=@m6@3om^h0ooK^00H0ooK^0`3D?AT80?ofkP80e3dI3`3om^h00`3D
?AT0000003eIZ`03000000040>51700mFJ/0?EV[03eIZ`<0hD4L0P0000050>51700303eIZ`000000
hD4L00D0hD4L00<000000>51703Q@A`00`3Q@A`01@000000hD4L03eIZ`3Q@A`0000000<0?EV[1@3Z
A1d01@000000jT@M0>Y47@3ZA1d0000000@0jT@M00D0?EV[0>Y47@3ZA1d0jT@M000000030>Y47@05
0000003ZA1d0jT@M0>Y47@0000000P3ZA1d00`000000jT@M00000002000000040=@m6@0000000000
00000080D7KS00D00000051fh`1@M^<0D7KS00000003051fh`070000001@M^<0D7KS051fh`000000
D7KS00000003055gh`030000001AMn<0e3dI0080DGOS00<00000055gh`1AMn<0101AMn<010000000
DGOS0000001AM^830=@m6@030000001AM^80DGKR00@0DGKR00<00000055fhP3D?AT00P1AM^801@00
0000DGGN055egP1AMMh0000000L0DGGN00D00000055egP1AMMh0DGGN00000003051cf@<0e3dI0P1@
LmT20=@m6@<0D7?I00D000000?ofkP3om^h0ooK^03eIZ`040?ofkP0303eIZ`3om^h0e3dI00D0e3dI
0P3om^h203eIZ`<0ooK^1P3D?AT01@0mFJ/0ooK^0?ofkP3om^h0?EV[0340ooK^00<000000?ofkP3o
m^h06P3om^h00`000000ooK^0?ofkP0Y0?ofkP40oooo000C0?ofkP030000003om^h0ooK^03l0ooK^
00<0e3dI0?ofkP3om^h03P3om^h30=@m6A80ooK^00<0e3dI0?ofkP3om^h04P3om^h00`3D?AT0ooK^
0?ofkP030?ofkP<0e3dI303om^h00`3D?AT0ooK^0?ofkP0<0?ofkP<0e3dI1P0000000`3Q@A`0?EV[
03eIZ`0303eIZ`030>5170000000hD4L00@0hD4L00<0?EV[0000003Q@A`01@3Q@A`00`000000hD4L
0>5170020>5170D0?EV[0P3ZA1d00`000000jT@M0>Y47@030>Y47@030000003ZA1d0jT@M0080jT@M
00H000000>Y47@3ZA1d0jT@M0000000mFJ/30>Y47@050000003ZA1d0jT@M0>Y47@0000000P3ZA1d0
0`000000jT@M00000002000000<0m4LN00@0000004idh@1>M>4000000P1@M^<01@000000D7KS051f
h`1@M^<000000080D7KS00D00000051fh`1@M^<0D7KS00000003051fh`030000001AMn<0000000<0
DGOS00<0e3dI0000001AMn<0101AMn<200000006055gh`3D?AT0e3dI0=@m6@1AM^8000001`1AM^80
1@000000DGKR055fhP1AM^80e3dI0080DGKR00<00000055egP0000001`1AMMh00`000000DGGN055e
gP02055egP050000003D?AT0e3dI0=@m6@0000001P1@LmT00`3D?AT0D7?I000000040?ofkP0303eI
Z`3om^h0ooK^00L0e3dI1P3om^h70=@m6@040?ofkP0mFJ/0ooK^03eIZ`<0ooK^00<0?EV[0?ofkP3o
m^h0;`3om^h00`000000ooK^0?ofkP0J0?ofkP030000003om^h0ooK^02T0ooK^0@3oool001@0ooK^
0P00000o0?ofkP030=@m6@3om^h0ooK^00/0ooK^0`3D?AT00`3om^h0e3dI0?ofkP0B0?ofkP030=@m
6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3D?AT00P3D?AT?0?ofkP030=@m6@3om^h0ooK^00T0ooK^
0`3D?AT0103om^h0e3dI0?ofkP3om^h3000000060=@m6@0[AI4000000000003Q@A`0?EV[0P3Q@A`6
03eIZ`80hD4L00<0?EV[0000003Q@A`00P3Q@A`703eIZ`050000003ZA1d000000>Y47@0mFJ/00`3Z
A1d00`000000jT@M0>Y47@030>Y47@050000003ZA1d0jT@M0>Y47@000000103ZA1d01@000000?EV[
0>Y47@3ZA1d0000000<0jT@M00<000000>Y47@0000000P0000030?A77P040000003dAah0m4LN0000
0080CWCQ0`000003051fh`040000001@M^<0D7KS000000<0D7KS00<00000051fh`1@M^<00`1@M^<0
1P000000DGOS055gh`1AMn<000000=@m6@D0DGOS00@000000=@m6@3D?AT0e3dI0`1AMn<00`000000
DGKR055fhP04055fhP8000001@1AM^80103D?AT0DGKR055fhP000006055egP8000000`1AMMh30=@m
6@030000001@LmT0000000P0D7?I00<0e3dI0?ofkP3om^h00`3om^h60=@m6@<0ooK^00@0e3dI0?of
kP3om^h0ooK^1P3D?AT50?ofkP0403eIZ`3om^h0ooK^03eIZ`80ooK^00<0?EV[0?ofkP3om^h0<03o
m^h00`000000ooK^0?ofkP0J0?ofkP030000003om^h0ooK^02P0ooK^0@3oool001H0ooK^00<00000
0?ofkP3om^h0?03om^h00`3D?AT0ooK^0?ofkP080?ofkP<0e3dI1@3om^h00`3D?AT0ooK^0?ofkP0A
0?ofkP030=@m6@3om^h0ooK^0140ooK^0`3D?ATB0?ofkP80e3dI1`3om^h30=@m6@@0ooK^00@0e3dI
0?ofkP3om^h0ooK^0P0000001`3D?AT000000000000[AI4000000>51700mFJ/01@3Q@A`2000000L0
?EV[0P3Q@A`4000000D0jT@M00<0000003eIZ`3ZA1d00P3ZA1d00`000000jT@M0>Y47@030>Y47@05
0000003ZA1d0jT@M0>Y47@0000000`3ZA1d00`000000jT@M03eIZ`020>Y47@030000003ZA1d0e3dI
0080000000@0m4LN0000003dAah0m4LN0`0mFJ/20?A77P030000001>M>4000000080CWCQ00@00000
051fh`1@M^<000000P1@M^<01@000000D7KS051fh`1@M^<0000000D0D7KS00D00000051fh`000000
DGOS00000002055gh`030=@m6@1AMn<0DGOS00<0e3dI101AMn<200000003055gh`000000DGKR00<0
DGKR00<00000055fhP1AM^801P1AM^80103D?AT00000055fhP000004055egP030000001AMMh0e3dI
00<0e3dI101AMMh00`000000D7?I051cf@04051cf@040=@m6@1@LmT000000?ofkPP0e3dI00<0ooK^
03eIZ`3om^h00P3om^h80=@m6@0303eIZ`3om^h0?EV[00D0ooK^00D0?EV[0?ofkP3om^h0ooK^03eI
Z`020?ofkP0303eIZ`3om^h0ooK^0300ooK^00<000000?ofkP3om^h06@3om^h00`000000ooK^0?of
kP0X0?ofkP40oooo000G0?ofkP800000?03om^h00`3D?AT0ooK^0?ofkP060?ofkP80e3dI203om^h0
0`3D?AT0ooK^0?ofkP0A0?ofkP030=@m6@3om^h0ooK^00h0ooK^0`3D?AT00`3om^h0e3dI0?ofkP0C
0?ofkP030=@m6@3om^h0ooK^0080ooK^0`3D?AT70?ofkP030=@m6@3om^h0ooK^0080ooK^0P000000
0`3D?AT0000000000003000000L0hD4L0P0000020>51700303eIZ`0000000000008000000`3ZA1d2
000000D0jT@M00<0000003eIZ`3ZA1d00P3ZA1d2000000@0jT@M00D000000>Y47@3ZA1d0jT@M0000
00030>Y47@040000003ZA1d0?EV[0=@m6@80000000D0m4LN0000003dAah0m4LN0000000203eIZ`80
m4LN00<000000?A77P0000000P1>M>401`000000e3dI04idh@1>M>40000003eIZ`0000000P1@M^<0
10000000D7KS051fh`000004051fh`8000000`1@M^<010000000DGOS055gh`1AMn<30=@m6@030000
001AMn<0DGOS00<0DGOS00<00000055gh`1AMn<00P1AMn<010000000DGKR000000000008055fhP05
0000003D?AT0DGKR055fhP0000000`1AMMh30=@m6@H0DGGN0P0000000`1AMMh00000051cf@04051c
f@030=@m6@000000e3dI00D0e3dI103om^h203eIZ`030?ofkP3D?AT0e3dI00@0e3dI0`3om^h0100m
FJ/0ooK^0?ofkP0mFJ/50?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP0mFJ/0<`3om^h0
0`000000ooK^0?ofkP0H0?ofkP030000003om^h0ooK^02P0ooK^0@3oool001T0ooK^00<000000?of
kP3om^h0>P3om^h00`3D?AT0ooK^0?ofkP020?ofkP<0e3dI2`3om^h00`3D?AT0ooK^0?ofkP0@0?of
kP030=@m6@3om^h0ooK^00`0ooK^0P3D?AT50?ofkP030=@m6@3om^h0ooK^0140ooK^1@3D?AT;0?of
kP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0000000000000P3D?AT3000000H0hD4L10000000100m
FJ/0jT@M0000000000050>Y47@800000103ZA1d00`000000?EV[0>Y47@030>Y47@050000003ZA1d0
jT@M0>Y47@0000000`3ZA1d00`000000jT@M0>Y47@040000000603eIZ`000000m4LN0?A77P000000
m4LN0P0mFJ/40?A77P050000003dAah0000004idh@0000000P1>M>40103D?AT0CWCQ04idh@000002
051fh`040000001@M^<0D7KS000000@0D7KS00H00000051fh`1@M^<0D7KS03eIZ`0000040=@m6@03
055gh`000000e3dI00@0DGOS0P000006055gh`030000001AM^80DGKR00H0DGKR0P000002055fhP03
0=@m6@1AM^80DGKR00<0e3dI201AMMh00`000000DGGN055egP02055egP040000001@LmT0D7?I051c
f@H0e3dI0`3om^h30=@m6@030?ofkP3D?AT0e3dI00@0e3dI1P3om^h01@0mFJ/0ooK^0?ofkP3om^h0
?EV[00@0ooK^00<0?EV[0?ofkP3om^h00`3om^h203eIZc<0ooK^00<000000?ofkP3om^h0603om^h0
0`000000ooK^0?ofkP0X0?ofkP40oooo000J0?ofkP800000>P3om^h00`3D?AT0ooK^0=@m6@020=@m
6@h0ooK^00<0e3dI0?ofkP3om^h04@3om^h00`3D?AT0ooK^0?ofkP080?ofkP<0e3dI1`3om^h00`3D
?AT0ooK^0?ofkP0A0?ofkP80e3dI3P3om^h00`3D?AT0ooK^0?ofkP030?ofkP<0e3dI0P0000000`0[
AI4000000000000200000080hD4L0P0000030>Y47@030000003ZA1d0?EV[0080jT@M0P0000050>Y4
7@030000003ZA1d0jT@M00<0jT@M0P0mFJ/30>Y47@050000003ZA1d0jT@M0>Y47@0000000P3ZA1d3
000000D0m4LN00<0?EV[0?A77P3dAah00P0mFJ/00`3dAah000000?A77P020?A77P0<0000003dAah0
m4LN0000001>M>40000004idh@000000CWCQ0=@m6@000000CWCQ0P000002051fh`030000001@M^<0
D7KS0080D7KS00@00000051fh`1@M^<0?EV[0`3D?AT2051fh`030000001AMn<000000080DGOS00@0
e3dI055gh`00000000001P1AMn<200000003055gh`000000DGKR00@0DGKR0P000004055fhP<0e3dI
00<0DGKR0000001AMMh01P1AMMh2000000H0DGGN00<000000=@m6@3D?AT00`3D?AT60?ofkPH0e3dI
00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0503eIZ`3om^h0ooK^0?ofkP0m
FJ/01@3om^h203eIZc@0ooK^00<000000?ofkP3om^h05`3om^h00`000000ooK^0?ofkP0X0?ofkP40
oooo000L0?ofkP030000003om^h0ooK^03L0ooK^0P3D?ATA0?ofkP030=@m6@3om^h0ooK^0140ooK^
00<0e3dI0?ofkP3om^h01@3om^h30=@m6@/0ooK^00<0e3dI0?ofkP3om^h0403om^h00`3D?AT0ooK^
0=@m6@0=0?ofkP030=@m6@3om^h0ooK^00<0e3dI0P3om^h00`3D?AT00000000000020000000302]5
T@0000000000008000001`3ZA1d00`000000?EV[03eIZ`020>Y47@800000103ZA1d2000000@0jT@M
00<0000003eIZ`3ZA1d00P3ZA1d00`000000jT@M0>Y47@03000000D0m4LN00@000000?A77P3dAah0
m4LN0P0mFJ/030000000m4LN0?A77P000000m4LN0000003dAah000000?A77P000000CWCQ00000080
CWCQ00D0000004idh@000000e3dI04idh@0200000003051fh`000000D7KS00<0D7KS00<000000=@m
6@3D?AT00P3D?AT6051fh`030000001AMn<0DGOS0080DGOS00<0e3dI055gh`1AMn<01@1AMn<01@00
0000DGOS055gh`1AMn<0000000@0DGKR00<00000055fhP1AM^80103D?AT2055fhP80e3dI00<0DGKR
0000001AMMh0101AMMh00`000000DGGN055egP06055egP<0e3dI1P3om^h60=@m6@050?ofkP0mFJ/0
ooK^0?ofkP0mFJ/0203om^h00`0mFJ/0ooK^0?ofkP030?ofkP0403eIZ`3om^h0ooK^03eIZ`H0ooK^
0P0mFJ/d0?ofkP030000003om^h0ooK^01L0ooK^00<000000?ofkP3om^h09`3om^h10?ooo`007@3o
m^h2000003L0ooK^00<0e3dI0?ofkP3om^h04@3om^h00`3D?AT0ooK^0?ofkP0@0?ofkP030=@m6@3o
m^h0ooK^00<0ooK^0P3D?AT>0?ofkP030=@m6@3om^h0ooK^0100ooK^00<0e3dI0?ofkP3D?AT03@3o
m^h30=@m6@D0ooK^00<0e3dI000000000000100000000`0[AI40000000000002000000L0jT@M00<0
000003eIZ`3ZA1d00P3ZA1d2000000@0jT@M0P0000030>Y47@050000000mFJ/0jT@M0>Y47@3D?AT0
0P0000020?A77P030000003dAah0m4LN00@0m4LN0`0mFJ/00`000000m4LN03eIZ`020?A77P0@0000
003dAah000000?A77P000000m4LN0000001>M>40000004idh@000000CWCQ0000001>M>40e3dI0000
0080CWCQ00@0000003eIZ`1@M^<0D7KS0`3D?AT2051fh`030000001@M^<0D7KS00<0D7KS0P000000
0`1@M^<00000055gh`02000000030=@m6@1AMn<0DGOS00<0DGOS0P000005055gh`040000001AM^80
0000000000<0e3dI101AM^8200000080DGKR00D0e3dI055fhP0000000000055egP02000000H0DGGN
0`3D?AT00`000000ooK^0=@m6@030?ofkPD0e3dI1@3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00H0
ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^03eIZ`070?ofkP0303eIZ`3om^h0ooK^0380
ooK^00<000000?ofkP3om^h05`3om^h00`000000ooK^0?ofkP0W0?ofkP40oooo000O0?ofkP030000
003om^h0ooK^03D0ooK^00<0e3dI0?ofkP3om^h0403om^h00`3D?AT0ooK^0?ofkP0A0?ofkP030=@m
6@3om^h0e3dI0080e3dI4@3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP040=@m6@3om^h0ooK^0=@m6@P0
ooK^1@3D?AT80?ofkP030=@m6@00000083=a00D0000000<0:dFA000000000000100000050>Y47@03
03eIZ`000000jT@M0080jT@M0P0000040>Y47@8000000P3ZA1d00`3D?AT0?EV[000000020?A77P05
0000003dAah0m4LN0?A77P0000000P3dAah303eIZ`0>0000003dAah0m4LN0000003dAah0?EV[0000
003dAah000000?A77P000000m4LN0000003dAah20000000404idh@000000CWCQ00000080CWCQ00@0
00000=@m6@1>M>400000103D?AT4051fh`030000001@M^<0D7KS0080D7KS0P000004051fh`050000
001AMn<0DGOS055gh`3D?AT00P1AMn<2000000L0DGOS103D?AT5055fhP8000001@1AM^820=@m6@03
055fhP000000DGGN00@0DGGN0`3D?AT200000080ooK^1`3D?AT70?ofkP0303eIZ`3om^h0ooK^00<0
ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0?EV[00L0
ooK^00<0?EV[0?ofkP3om^h0<`3om^h00`000000ooK^0?ofkP0F0?ofkP030000003om^h0ooK^02L0
ooK^0@3oool00200ooK^00<000000?ofkP3om^h0=03om^h00`3D?AT0ooK^0?ofkP0A0?ofkP030=@m
6@3om^h0ooK^00l0ooK^0`3D?ATD0?ofkP030=@m6@3om^h0ooK^0100ooK^00<0e3dI0?ofkP3D?AT0
1@3om^h30=@m6@@0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT00000020cL@060000000502]5
T@00000000000000000hF;<00P0000040>Y47@0303eIZ`000000000000<0jT@M0P0000030>Y47@03
0=@m6@00000000000080m4LN00D0?EV[0?A77P3dAah0m4LN000000020?A77P<0?EV[00D0m4LN0000
003dAah0m4LN000000020?A77P060000003dAah0?EV[0?A77P000000m4LN0P0000002`3dAah00000
04idh@000000CWCQ0000001>M>40000004idh@000000CWCQ00<0e3dI0P1>M>4010000000D7KS051f
h`1@M^<2000000<0D7KS0P000004051fh`80000000<0D7KS0000001AMn<00P1AMn<00`3D?AT00000
055gh`05055gh`<0e3dI0P1AMn<00`000000DGKR055fhP02055fhP800000201AM^801@000000e3dI
0=@m6@000000DGGN00<0e3dI0P1AMMh00`000000ooK^0?ofkP050=@m6@0303eIZ`3om^h0ooK^00P0
ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00H0
ooK^0P0mFJ/70?ofkP0303eIZ`3om^h0ooK^03@0ooK^00<000000?ofkP3om^h05@3om^h00`000000
ooK^0?ofkP0W0?ofkP40oooo000Q0?ofkP800000=03om^h00`3D?AT0ooK^0?ofkP0A0?ofkP030=@m
6@3om^h0ooK^00`0ooK^0`3D?AT20?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h0
3`3om^h01@3D?AT0ooK^0?ofkP3D?AT0ooK^00<0e3dI203om^h00`3D?AT0ooK^0?ofkP040?ofkP<0
e3dI00@0ooK^00000000000083=a1`0000000`0hF;<000000000000400000080jT@M00@0?EV[0>Y4
7@00000000000`3ZA1d300000080m4LN0P0000020?A77P0303eIZ`000000m4LN00<0?EV[0P3dAah0
1P000000m4LN0?A77P000000m4LN00000080m4LN00H000000?A77P000000?EV[0000003dAah20000
00080?A77P000000000004idh@000000CWCQ0000001>M>430=@m6@090000001>M>40e3dI04idh@00
0000CWCQ0000001@M^<0000000<0D7KS0P000004051fh`800000101@M^<01@000000DGOS00000000
0000e3dI0080DGOS103D?AT00`000000DGOS055gh`03055gh`040000001AM^800000000000P0DGKR
0P000002055fhP@0e3dI0P1AMMh2000000D0e3dI103om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eI
Z`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eI
Z`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h0=@3om^h00`000000ooK^0?ofkP0D0?ofkP030000
003om^h0ooK^02L0ooK^0@3oool002<0ooK^00<000000?ofkP3om^h0<P3om^h00`3D?AT0ooK^0?of
kP0@0?ofkP030=@m6@3om^h0ooK^00T0ooK^0`3D?AT50?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0
e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0=@m6@020=@m6@/0ooK^00<0e3dI0?ofkP3om^h00P3o
m^h20=@m6@<0ooK^00<0e3dI0?ofkP0000000P0000000`0P<g400000000000050000000303eIZ`0h
F;<0000000D0000000<0?EV[0>Y47@3ZA1d00`0000030?A77P030000003dAah0m4LN00H0?EV[00@0
00000?A77P00000000000P3dAah03@000000m4LN0?A77P000000m4LN0000003dAah000000?A77P00
0000m4LN03eIZ`3dAah01@0000000`1>M>400000000000020=@m6@0304idh@00000000000080CWCQ
00<000000=@m6@1>M>400P1>M>400`000000D7KS051fh`02000000@0D7KS0P000007051fh`030000
001AMn<0DGOS00<0e3dI0`000008055gh`030000001AM^80DGKR00H0DGKR0P0000040=@m6@80DGKR
00<00000055egP3D?AT0103D?AT20?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h0
1@3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/02@3om^h203eIZ`H0
ooK^00<0?EV[0?ofkP3om^h0=@3om^h00`000000ooK^0?ofkP0E0?ofkP030000003om^h0ooK^02H0
ooK^0@3oool002@0ooK^0P00000b0?ofkP030=@m6@3om^h0ooK^0140ooK^00<0e3dI0?ofkP3om^h0
1P3om^h20=@m6@T0ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP<0e3dI
0P3om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0e3dI0080e3dI1P3om^h00`3D?AT0ooK^
0?ofkP060000000302]5T@000000000000<000000P0hF;<00`000000e3dI0=@m6@03000000<0m4LN
00<0000003eIZ`0mFJ/00`0mFJ/30?A77P050000003dAah0?EV[0?A77P0000000P3dAah020000000
m4LN0?A77P000000m4LN0000003dAah000000P3dAah90000000704]ag@000000e3dI0=@m6@000000
CWCQ0000000304idh@050000001>M>40CWCQ0=@m6@0000000P1>M>42000000@0D7KS0P000006051f
h`80000000H0D7KS0=@m6@3D?AT0e3dI055gh`0000020=@m6@L0DGOS0P000002055gh`030000001A
M^80DGKR00<0DGKR00@000000=@m6@3D?AT0e3dI1P1AM^840=@m6@D0ooK^00<0?EV[0?ofkP3om^h0
103om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP0mFJ/0
2P3om^h00`0mFJ/0ooK^03eIZ`050?ofkP0303eIZ`3om^h0ooK^03H0ooK^00<000000?ofkP3om^h0
503om^h00`000000ooK^0?ofkP0V0?ofkP40oooo000V0?ofkP030000003om^h0ooK^02l0ooK^00<0
e3dI0?ofkP3om^h04@3om^h00`3D?AT0ooK^0?ofkP030?ofkP<0e3dI2`3om^h00`3D?AT0ooK^0?of
kP0C0?ofkP030=@m6@3om^h0ooK^00X0ooK^0`3D?AT00`3om^h0e3dI0?ofkP020?ofkP030=@m6@3o
m^h0ooK^00P0ooK^0`3D?AT90?ofkP040=@m6@3om^h0ooK^0?ofkP@0000000@0:dFA000000000000
:dFA0`0000030=@m6@0503QH/`00000000000000000mFJ/00P0000030?A77P<000000P3dAah20000
00040?A77P000000000003eIZ`80m4LN00<000000?A77P0000000P3dAah010000000m4LN0000003d
Aah4000000050?a:7`000000o4XO0000003lBQl010000000101>M>40000004idh@00000204idh@80
00000P1>M>400`000000CWCQ0=@m6@020000000404idh@000000D7KS051fh`8000001@1@M^<20000
00@0e3dI0P1@M^<2000000<0DGOS00@0e3dI055gh`1AMn<0DGOS0`000005055gh`030000001AM^80
e3dI00<0e3dI1P1AM^830=@m6@P0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP03
0?ofkP0303eIZ`3om^h0ooK^00T0ooK^0P0mFJ/90?ofkP0403eIZ`3om^h0ooK^03eIZ`D0ooK^00<0
?EV[0?ofkP3om^h0=`3om^h00`000000ooK^0?ofkP0C0?ofkP030000003om^h0ooK^02H0ooK^0@3o
ool002L0ooK^0P00000`0?ofkP030=@m6@3om^h0ooK^0140ooK^00<0e3dI0?ofkP3D?AT00P3D?AT?
0?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h01P3om^h30=@m6@@0ooK^00<0e3dI
0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP040?ofkP<0e3dI00<0ooK^0=@m6@3om^h02P3om^h0
103D?AT0ooK^0?ofkP3om^h50000000302]5T@000000e3dI0080e3dI1@00000203QH/`8000000`11
I<P200000080m4LN0P0000030?A77P040000003dAah0000003eIZ`80m4LN0`0000020?A77P<00000
00D0o4XO00000000000000000?a:7`070000000404]ag@000000CWCQ00000080CWCQ00@0000004id
h@00000000000P1>M>42000000040=@m6@1>M>40CWCQ04idh@800000101@M^<2000000<0e3dI0P1@
M^<300000080D7KS00<00000055gh`1AMn<00P1AMn<20=@m6@030000001AMn<0DGOS00D0DGOS0`3D
?AT00`000000DGKR055fhP03055fhP@0e3dI00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?of
kP080?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/03@3om^h00`0mFJ/0ooK^0?ofkP070?ofkP0503eI
Z`3om^h0ooK^0?ofkP0mFJ/0103om^h00`0mFJ/0ooK^0?ofkP0g0?ofkP030000003om^h0ooK^01<0
ooK^00<000000?ofkP3om^h09P3om^h10?ooo`00:@3om^h00`000000ooK^0?ofkP0]0?ofkP030=@m
6@3om^h0ooK^0100ooK^0`3D?ATB0?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h0
0`3om^h30=@m6@P0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@030?ofkP<0e3dI103om^h00`3D?AT0
ooK^0?ofkP0:0?ofkP040=@m6@3om^h0ooK^0=@m6@800000103D?AT400000080>5Rc1P0000001011
I<P00000000000000002045Tb080000000@0m4LN00000000000000000P3dAah20000000403eIZ`00
0000m4LN0?A77P<0000000<0o4XO0000003lBQl00P0000000`3lBQl00000000000060000000504]a
g@000000Bg7M0000001>M>4010000000101>M>40000000000000000204idh@030000003D?AT00000
0080CWCQ00@00000051fh`1@M^<000000`3D?AT00`1@M^<0000000000002000000D0D7KS00<00000
055gh`1AMn<00P000002055gh`80e3dI0P1AMn<40=@m6@040000001AMn<0DGOS00000080DGKR0`3D
?AT300000080ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0403eIZ`3o
m^h0ooK^03eIZ`d0ooK^0P0mFJ/80?ofkP0303eIZ`3om^h0ooK^0080ooK^00D0?EV[0?ofkP3om^h0
ooK^03eIZ`0j0?ofkP030000003om^h0ooK^0180ooK^00<000000?ofkP3om^h09P3om^h10?ooo`00
:P3om^h2000002d0ooK^00<0e3dI0?ofkP3om^h03@3om^h30=@m6@030?ofkP3D?AT0ooK^01<0ooK^
00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0=@m6@020=@m6@/0ooK^00<0e3dI0?ofkP3om^h0
0P3om^h30=@m6@L0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP030=@m6@050000
000P<g4000000000000[AI401@00000403QH/`D0000000<0e3dI045Tb0000000200000020?A77P05
0000000mFJ/000000000003lBQl00`0000000`3lBQl000000?a:7`090000000504]ag@0000000000
0000001;LMd00`0000000`1>M>4000000000000204idh@<000000P1>M>400`3D?AT0CWCQ04idh@04
0=@m6@04051fh`0000000000000000X0D7KS0P000005055gh`@0e3dI00<00000055gh`1AMn<00P1A
Mn<40=@m6@03055fhP000000000000H0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?of
kP0;0?ofkP80?EV[3@3om^h0100mFJ/0ooK^0?ofkP0mFJ/70?ofkP0303eIZ`3om^h0ooK^00<0ooK^
00@0?EV[0?ofkP3om^h0?EV[>`3om^h00`000000ooK^0?ofkP0B0?ofkP030000003om^h0ooK^02D0
ooK^0@3oool002`0ooK^00<000000?ofkP3om^h0:`3om^h00`3D?AT0ooK^0?ofkP090?ofkP<0e3dI
1@3om^h00`3D?AT0ooK^0?ofkP0B0?ofkP030=@m6@3om^h0ooK^0140ooK^0`3D?AT>0?ofkP030=@m
6@3om^h0e3dI0080e3dI00<0ooK^0=@m6@3om^h01`3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP@0e3dI
0P3om^h300000004020cL@000000000002]5T@L000000`0hF;<3000000050=@m6@00000000000000
0011I<P0200000020?a:7`<0000000<0o4XO0000000000000P0000000`3lBQl00000000000050000
000404]ag@000000000004]ag@80000000D0Bg7M000000000000000004idh@03000000<0CWCQ0P00
00030=@m6@80CWCQ0`000007051fh`@000000`1@M^<2000000@0e3dI00@00000055gh`1AMn<0DGOS
1P3D?AT2055gh`8000002@3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00d0ooK^
00<0?EV[0?ofkP3om^h02`3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00D0ooK^00<0?EV[0?ofkP3o
m^h01@3om^h00`0mFJ/0ooK^03eIZ`0l0?ofkP030000003om^h0ooK^0140ooK^00<000000?ofkP3o
m^h09@3om^h10?ooo`00;@3om^h2000002/0ooK^00<0e3dI0?ofkP3om^h01P3om^h30=@m6@P0ooK^
00<0e3dI0?ofkP3om^h04P3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP<0e3dI0P3om^h00`3D?AT0ooK^
0?ofkP0<0?ofkP80e3dI103om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00L0ooK^
0`3D?AT20?ofkP80e3dI0`3om^h700000080:dFA0`0000000`0hF;<00000000000020000000303QH
/`000000e3dI0100000000<0o4XO0000000000005P00000204idh@@000000P3D?AT2000000050=@m
6@000000CWCQ04idh@0000000`1@M^<5000000H0D7KS0`3D?AT2000000L0DGOS0P3D?AT010000000
?EV[00000000000=0?ofkP0403eIZ`3om^h0ooK^03eIZ`l0ooK^00<0?EV[0?ofkP0mFJ/02`3om^h0
0`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h01@3om^h0
0`0mFJ/0ooK^03eIZ`0l0?ofkP030000003om^h0ooK^0140ooK^00<000000?ofkP3om^h09@3om^h1
0?ooo`00;`3om^h00`000000ooK^0?ofkP0X0?ofkP030=@m6@3om^h0ooK^00<0ooK^0`3D?AT<0?of
kP030=@m6@3om^h0ooK^0180ooK^00<0e3dI0?ofkP3om^h02P3om^h30=@m6@D0ooK^00<0e3dI0?of
kP3om^h0303om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?of
kP3om^h01@3om^h20=@m6@H0ooK^00<0e3dI0?ofkP3D?AT00`3D?AT01@00000083=a000000000000
:dFA008000000P0[AI450000000503QH/`00000000000000003D?AT00P0000000`11I<P000000000
000U0000000404idh@3D?AT0e3dI0=@m6@8000000`1>M>420=@m6@80CWCQ0`000007051fh`@0e3dI
00D00000051fh`1@M^<0D7KS00000003055gh`8000000P3D?AT20000000303eIZ`3om^h0ooK^00l0
ooK^00<0?EV[0?ofkP0mFJ/03`3om^h0100mFJ/0ooK^0?ofkP0mFJ/:0?ofkP0303eIZ`3om^h0ooK^
00<0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP060?ofkP80?EV[?@3om^h00`00
0000ooK^0?ofkP0@0?ofkP030000003om^h0ooK^02D0ooK^0@3oool00300ooK^0P00000Y0?ofkP03
0=@m6@3om^h0e3dI0080e3dI3`3om^h00`3D?AT0ooK^0?ofkP0B0?ofkP030=@m6@3om^h0ooK^00L0
ooK^0`3D?AT90?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0
ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^0080ooK^0`3D?AT70?ofkP<0e3dI0P3om^h00`000000
ooK^0?ofkP0200000004020cL@000000000002]5T@<00000100hF;<5000000030=@m6@11I<P00000
00<000000`3D?ATP00000080e3dI00<0CWCQ0000000000001P0000001@1>M>40e3dI0=@m6@1>M>40
000000<0D7KS0P0000030=@m6@T0D7KS1P0000000`0mFJ/0ooK^03eIZ`0C0?ofkP0303eIZ`3om^h0
ooK^00d0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0
ooK^00D0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`090?ofkP0303eIZ`3om^h0ooK^03`0ooK^00<0
00000?ofkP3om^h03`3om^h00`000000ooK^0?ofkP0U0?ofkP40oooo000b0?ofkP030000003om^h0
ooK^02H0ooK^0P3D?ATC0?ofkP030=@m6@3om^h0ooK^0180ooK^00<0e3dI0?ofkP3om^h00`3om^h3
0=@m6@d0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0
ooK^00@0ooK^00<0e3dI0?ofkP3D?AT00P3D?AT70?ofkP<0e3dI00<0ooK^0=@m6@3D?AT00P3om^h0
10000000ooK^0?ofkP3om^h>00000080>5Rc00@000000=@m6@00000000000`3D?AT2045Tb2@00000
3@1>M>4300000080e3dI00<0D7KS0000000000001P0000000`3_BAh0000000000004000000<0ooK^
00<0?EV[0?ofkP3om^h04@3om^h00`0mFJ/0ooK^03eIZ`0=0?ofkP0303eIZ`3om^h0ooK^00@0ooK^
00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0?EV[00X0ooK^
00<0?EV[0?ofkP3om^h0?03om^h00`000000ooK^0?ofkP0?0?ofkP030000003om^h0ooK^02D0ooK^
0@3oool003<0ooK^00<000000?ofkP3om^h09P3om^h00`3D?AT0ooK^0?ofkP0A0?ofkP030=@m6@3o
m^h0ooK^0180ooK^00<0e3dI0?ofkP3om^h00`3D?AT@0?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0
e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP030?ofkP80e3dI1`3om^h30=@m6@@0ooK^00D0
e3dI0?ofkP3D?AT0ooK^000000040?ofkPD0000000<0:dFA0000000000000P00000303QH/`<00000
0`3D?AT_000000P0CWCQ1@0000000`3_BAh0000000000008000000H0ooK^00<0?EV[0?ofkP0mFJ/0
4@3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00`0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0
ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00P0ooK^0P0mFJ/:0?ofkP0303eIZ`3om^h0ooK^03d0
ooK^00<000000?ofkP3om^h03`3om^h00`000000ooK^0?ofkP0T0?ofkP40oooo000d0?ofkP800000
9P3om^h00`3D?AT0ooK^0?ofkP0B0?ofkP030=@m6@3om^h0ooK^0140ooK^0`3D?ATD0?ofkP030=@m
6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP040=@m6@@0ooK^
103D?AT70?ofkP050=@m6@3om^h0ooK^0=@m6@0000001P3om^h00`00000083=a0000000200000080
:dFA100000030=@m6@80>5Rc00<0e3dI00000011I<P01@11I<PI000000030?m=8@000000000001H0
000000<0?EV[0000000000001`0000080?ofkP80?EV[0`3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP03
03eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP060?ofkP03
03eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP070?ofkP03
03eIZ`3om^h0ooK^03l0ooK^00<000000?ofkP3om^h03P3om^h00`000000ooK^0?ofkP0T0?ofkP40
oooo000f0?ofkP030000003om^h0ooK^02@0ooK^00<0e3dI0?ofkP3om^h04@3om^h00`3D?AT0ooK^
0?ofkP0>0?ofkP<0e3dI0P3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^00P0ooK^
00<0e3dI0?ofkP3om^h01P3om^h30=@m6@<0ooK^00<0e3dI0?ofkP3D?AT00P3D?AT;0?ofkP050=@m
6@3om^h0ooK^0?ofkP3D?AT01`3om^h200000003020cL@0000000000008000000`3D?AT203QH/`@0
00000P3D?AT5000000<0@FC8100000000`17K=D0000000000007000000030?m=8@000000000000<0
00000P3oCB440000000403eIZ`0000000000000000<0oddQ1@0000000`0mFJ/00000000000060000
00030>m97P0mFJ/0kdTN00@000002P3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^
00/0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^
00P0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0<0?ofkP80?EV[203om^h00`0mFJ/0ooK^0?ofkP10
0?ofkP030000003om^h0ooK^00d0ooK^00<000000?ofkP3om^h0903om^h10?ooo`00=`3om^h20000
02@0ooK^00<0e3dI0?ofkP3om^h04P3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP<0e3dI1@3om^h00`3D
?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h00P3om^h40=@m
6@80ooK^00<0e3dI0?ofkP3om^h00`3D?AT>0?ofkP060=@m6@3om^h0ooK^0?ofkP000000e3dI1`3o
m^h2000000@0e3dI00<0:dFA0000000000001@00000303QH/`040=@m6@0mFJ/0@FC8045Tb0@00000
00<0@FC800000000000030000000103oCB4000000000003oCB4500000080oddQ00<0000003eIZ`00
00001`00000203eIZ`/0000000<0?EV[0000003om^h02`3om^h00`0mFJ/0ooK^0?ofkP060?ofkP03
03eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP050?ofkP03
03eIZ`3om^h0ooK^00X0ooK^00@0?EV[0?ofkP3om^h0?EV[2`3om^h0100mFJ/0ooK^0?ofkP0mFJ/7
0?ofkP0303eIZ`3om^h0ooK^0400ooK^00<000000?ofkP3om^h03@3om^h00`000000ooK^0?ofkP0T
0?ofkP40oooo000i0?ofkP030000003om^h0ooK^0280ooK^00<0e3dI0?ofkP3om^h04@3om^h00`3D
?AT0ooK^0?ofkP070?ofkP<0e3dI2@3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^
00L0ooK^00<0e3dI0?ofkP3D?AT00P3D?AT60?ofkP<0e3dI00<0ooK^0=@m6@3om^h03@3om^h00`3D
?AT0ooK^0?ofkP020?ofkP030000003D?AT0ooK^00D0ooK^0`3D?AT0100P<g400000000000000004
02]5T@040000000hF;<0>5Rc03QH/`@0000000@0e3dI000000000000@FC810000002045Tb0800000
00<0AfcE0000000000001@000000103oCB4000000?m=8@3oCB4300000080oddQ1P0000000`0mFJ/0
e3dI0?m=8@0300000080?EV[300000020?ofkP0303eIZ`3om^h0ooK^00P0ooK^0P0mFJ/:0?ofkP03
03eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP040?ofkP03
03eIZ`3om^h0ooK^00/0ooK^0P0mFJ/<0?ofkP0403eIZ`3om^h0ooK^03eIZ`L0ooK^00<0?EV[0?of
kP3om^h0@@3om^h00`000000ooK^0?ofkP0<0?ofkP030000003om^h0ooK^02@0ooK^0@3oool003X0
ooK^0P00000R0?ofkP030=@m6@3om^h0ooK^0180ooK^00<0e3dI0?ofkP3om^h00`3om^h30=@m6@d0
ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP040?ofkP@0e3dI1P3om^h30=@m6@80
ooK^00<0e3dI0?ofkP3D?AT03P3om^h00`3D?AT0ooK^0?ofkP020?ofkP030000003om^h0e3dI0080
ooK^1P3D?AT200000003020cL@000000000000@000001@0hF;<300000080e3dI00<00000045Tb011
I<P00P11I<P200000080e3dI0P0000001017K=D000000000003oCB42000000050?m=8@0000000000
0000003oCB400`0000030?m=8@80000000@0e3dI0?m=8@000000?EV[0P00000203eIZ`X000001`3o
m^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h01@3o
m^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h03@3o
m^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h00`3o
m^h00`0mFJ/0ooK^0?ofkP130?ofkP030000003om^h0ooK^00`0ooK^00<000000?ofkP3om^h08`3o
m^h10?ooo`00?03om^h00`000000ooK^0?ofkP0P0?ofkP030=@m6@3om^h0ooK^0140ooK^00<0e3dI
0?ofkP3om^h00`3D?AT@0?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h0103D?AT2
0?ofkP030=@m6@3om^h0ooK^0080ooK^0`3D?AT60?ofkP80e3dI3P3om^h00`3D?AT0ooK^0?ofkP02
0?ofkP030000003om^h0e3dI00@0e3dI103om^h00`3D?AT000000000000300000080:dFA1P000004
03QH/`040000003D?AT0?EV[000000@0e3dI00@00000045Tb0000000@FC8200000001P3oCB400000
0?m=8@3oCB4000000?m=8@8000000`3oCB43000000<0?EV[00@0kdTN0=@m6@3D?AT0kdTN0`00000=
0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP03
0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00@0?EV[0?ofkP3om^h0?EV[3`3om^h00`0mFJ/0ooK^03eI
Z`0:0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?of
kP140?ofkP030000003om^h0ooK^00/0ooK^00<000000?ofkP3om^h08`3om^h10?ooo`00?@3om^h2
00000200ooK^00<0e3dI0?ofkP3om^h04@3om^h30=@m6A@0ooK^00<0e3dI0?ofkP3om^h04P3om^h3
0=@m6@H0ooK^00<0e3dI0?ofkP3D?AT00P3D?AT90?ofkP80e3dI3P3om^h0103D?AT0ooK^0?ofkP3o
m^h60=@m6@H0ooK^00H0e3dI0?ofkP0000000000020cL@0mFJ/30000000302]5T@000000000000@0
>5Rc100000020=@m6@03045Tb000000000000080@FC800<00000045Tb00000000P0000020?m=8@80
000000@0?EV[0000003oCB4000000`3oCB400`000000e3dI0?m=8@02000000@0?EV[0P3_BAh00`0m
FJ/000000000000300000100ooK^00@0?EV[0?ofkP3om^h0ooK^0P0mFJ/A0?ofkP0503eIZ`3om^h0
ooK^0?ofkP0mFJ/0403om^h00`0mFJ/0ooK^03eIZ`0?0?ofkP0403eIZ`3om^h0ooK^03eIZ`P0ooK^
00<0?EV[0?ofkP3om^h01@3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[04H0ooK^00<000000?ofkP3o
m^h02`3om^h00`000000ooK^0?ofkP0S0?ofkP40oooo000o0?ofkP030000003om^h0ooK^01h0ooK^
00<0e3dI0?ofkP3om^h0303om^h40=@m6@80ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^
0?ofkP0>0?ofkP<0e3dI0P3om^h00`3D?AT0ooK^0?ofkP040?ofkP80e3dI3@3om^h00`3D?AT0ooK^
0?ofkP0<0?ofkPH0e3dI103om^h20=@m6@@0ooK^00@0e3dI0?ofkP3om^h0ooK^0P0000000`0P<g40
?EV[03eIZ`07000000<0e3dI00@0>5Rc0000003D?AT000000P11I<P20000000@045Tb00000000000
0?m=8@000000oddQ0000003oCB4000000?m=8@0mFJ/000000?m=8@000000e3dI0?m=8@8000000`0m
FJ/20>m97PD0000000<0?EV[0000003om^h04`3om^h00`0mFJ/0ooK^03eIZ`0D0?ofkP0303eIZ`3o
m^h0?EV[0180ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3o
m^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h01P3om^h0100mFJ/0ooK^0?ofkP0mFJ]70?ofkP030000
003om^h0ooK^00X0ooK^00<000000?ofkP3om^h08`3om^h10?ooo`00@03om^h2000001h0ooK^00<0
e3dI0?ofkP3om^h02@3om^h30=@m6@H0ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?of
kP0;0?ofkP<0e3dI1P3om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0
e3dI0?ofkP3D?AT02P3om^h50=@m6@<0ooK^00<000000?ofkP3om^h0103om^h0103D?AT0ooK^0?of
kP3D?AT50?ofkP@00000100[AI430=@m6@0403QH/`000000000000000080>5Rc0P3D?AT01@000000
@FC8045Tb0000000@FC8008000000P3oCB401P000000oddQ0000003oCB40000003eIZ`800000100m
FJ/00`3_BAh000000000000600000080ooK^00<0?EV[0?ofkP3om^h04`3om^h00`0mFJ/0ooK^0?of
kP0D0?ofkP0303eIZ`3om^h0ooK^0100ooK^00<0?EV[0?ofkP0mFJ/03@3om^h00`0mFJ/0ooK^0?of
kP040?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^03eI
Z`190?ofkP030000003om^h0ooK^00T0ooK^00<000000?ofkP3om^h08`3om^h10?ooo`00@P3om^h0
0`000000ooK^0?ofkP0L0?ofkP030=@m6@3om^h0ooK^00@0ooK^103D?AT:0?ofkP030=@m6@3om^h0
ooK^01<0ooK^00<0e3dI0?ofkP3om^h01`3om^h30=@m6@X0ooK^00<0e3dI0?ofkP3om^h00P3om^h0
0`3D?AT0ooK^0?ofkP0;0?ofkP040=@m6@3om^h0ooK^0=@m6@H0ooK^1@3D?AT00`3om^h0e3dI0?of
kP030?ofkP030000003om^h0ooK^00D0ooK^00<0e3dI0?ofkP3D?AT01P3om^h00`00000083=a0000
00040=@m6@040000000mFJ/00000000000H0>5Rc00/000000=@m6@3D?AT00000045Tb0000000oddQ
0000003oCB4000000=@m6@02000000D0?EV[00D0kdTN000000000000e3dI0>m97P05000000H0ooK^
00<0?EV[0?ofkP3om^h0403om^h203eIZ`030?ofkP0mFJ/0ooK^01<0ooK^00<0?EV[0?ofkP0mFJ/0
403om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00`0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0
ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00P0ooK^0P0mFJ]90?ofkP030000003om^h0ooK^00X0
ooK^00<000000?ofkP3om^h08P3om^h10?ooo`00@`3om^h2000001`0ooK^00<0e3dI0?ofkP3om^h0
103D?AT?0?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h00`3om^h30=@m6@h0ooK^
00@0e3dI0?ofkP3om^h0e3dI3P3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI0080ooK^1@3D?AT30?of
kP030=@m6@3om^h0ooK^00<0ooK^00<000000?ofkP3om^h01P3om^h20=@m6@H0ooK^0`3D?AT00`0P
<g40000002]5T@0402]5T@030000000hF;<0>5Rc0080>5Rc0`0000001P11I<P00000045Tb0000000
oddQ000000H0?EV[0`3_BAh010000000?EV[0>m97P3_BAh5000000X0ooK^00<0?EV[0?ofkP3om^h0
3@3om^h203eIZ`@0ooK^00<0?EV[0?ofkP3om^h03`3om^h203eIZ`<0ooK^00<0?EV[0?ofkP3om^h0
303om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h0
1P3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00`0ooK^00<0?EV[0?ofkP3om^h0B03om^h00`000000
ooK^0?ofkP090?ofkP030000003om^h0ooK^0280ooK^0@3oool004D0ooK^00<000000?ofkP3om^h0
6P3om^h20=@m6A<0ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP030=@m6A40ooK^
00@0e3dI0?ofkP3om^h0e3dI3P3om^h0103D?AT0ooK^0?ofkP3om^h50=@m6@H0ooK^00<0e3dI0?of
kP3om^h00`3om^h00`000000ooK^0?ofkP070?ofkP80e3dI0P3om^h30=@m6@80ooK^0P0000000`0P
<g40000002]5T@0302]5T@030000000hF;<0>5Rc008000000`0hF;<00`000000@FC803eIZ`040000
00050>m97P000000kdTN0>m97P0000000P3_BAh010000000e3dI0000000mFJ/2000000030?ofkP0m
FJ/0ooK^00`0ooK^0P0mFJ/;0?ofkP80?EV[1`3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3o
m^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3o
m^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h0203om^h0100mFJ/0ooK^0?ofkP0mFJ/<0?ofkP0303eI
Z`3om^h0ooK^04T0ooK^00<000000?ofkP3om^h0203om^h00`000000ooK^0?ofkP0R0?ofkP40oooo
00160?ofkP8000006`3om^h00`3D?AT0ooK^0?ofkP0B0?ofkP030=@m6@3om^h0ooK^0180ooK^0`3D
?ATE0?ofkP030=@m6@3om^h0e3dI00h0ooK^1@3D?AT00`3om^h0e3dI0?ofkP070?ofkP030=@m6@3o
m^h0ooK^00<0ooK^00<000000?ofkP3om^h01P3om^h00`3D?AT0ooK^0=@m6@020=@m6@H0ooK^2P00
000403QH/`060000003D?AT000000000000mFJ/000000P3_BAh00`000000kdTN0>m97P0200000004
0=@m6@000000000000000080ooK^00@0?EV[0?ofkP3om^h0?EV[3`3om^h00`0mFJ/0ooK^0?ofkP06
0?ofkP80?EV[2P3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[
0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[
0?ofkP3om^h02P3om^h203eIZ``0ooK^00<0?EV[0?ofkP3om^h0B`3om^h00`000000ooK^0?ofkP07
0?ofkP030000003om^h0ooK^0280ooK^0@3oool004P0ooK^00<000000?ofkP3om^h0603om^h00`3D
?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^00h0ooK^0`3D?AT20?ofkP030=@m6@3om^h0ooK^
01@0ooK^0P3D?AT;0?ofkPD0e3dI1@3om^h20=@m6@D0ooK^00<0e3dI0?ofkP3om^h0103om^h00`00
0000ooK^0?ofkP050?ofkP<0e3dI0P3om^h20=@m6@H0ooK^0P0000000`0P<g40000002]5T@0302]5
T@800000103D?AT01@0hF;<000000>m97P3_BAh0?EV[0080kdTN1P0000000`0mFJ/0ooK^0?ofkP03
0?ofkP0303eIZ`3om^h0?EV[0100ooK^00<0?EV[0?ofkP3om^h00`3om^h203eIZ`d0ooK^00<0?EV[
0?ofkP3om^h0203om^h203eIZ`T0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP08
0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP0:
0?ofkP0303eIZ`3om^h0ooK^04/0ooK^00<000000?ofkP3om^h01`3om^h00`000000ooK^0?ofkP0R
0?ofkP40oooo00190?ofkP030000003om^h0ooK^01P0ooK^00<0e3dI0?ofkP3om^h04P3om^h00`3D
?AT0ooK^0?ofkP0;0?ofkP<0e3dI1P3om^h00`3D?AT0ooK^0?ofkP0D0?ofkP030=@m6@3om^h0ooK^
00D0ooK^1P3D?AT00`3om^h0e3dI0?ofkP070?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?of
kP3om^h0103om^h010000000ooK^0?ofkP3om^h50=@m6@H0ooK^0P3D?AT50?ofkP030=@m6@000000
000000800000103D?AT01@000000>5Rc03QH/`0hF;<000000080kdTN00D000000>m97P0mFJ/00000
0<<m6@020000000503eIZ`3om^h0ooK^0?ofkP0mFJ/01@3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP03
03eIZ`3om^h0ooK^0080?EV[403om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00X0
ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^0080
ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^03eIZ`0:0?ofkP0303eIZ`3om^h0ooK^04d0
ooK^00<000000?ofkP3om^h01`3om^h00`000000ooK^0?ofkP0Q0?ofkP40oooo001:0?ofkP800000
6@3om^h00`3D?AT0ooK^0?ofkP0B0?ofkP030=@m6@3om^h0ooK^00L0ooK^0`3D?AT:0?ofkP030=@m
6@3om^h0ooK^01<0ooK^0P3D?AT20?ofkPL0e3dI0`3om^h00`3D?AT0ooK^0?ofkP080?ofkP050=@m
6@3om^h0ooK^0?ofkP3D?AT01P3om^h00`000000e3dI0=@m6@020=@m6@<0ooK^00<0e3dI0?ofkP3o
m^h01P3om^h20=@m6@80ooK^1P3D?AT300000080:dFA00@0000003QH/`000000kdTN1@0000000`0m
FJ/000000?ofkP020?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/0103om^h303eIZa00ooK^0`0mFJ/C
0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP03
0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00@0?EV[0?ofkP3om^h0?EV[3P3om^h0100mFJ/0ooK^0?of
kP0mFJ/90?ofkP0303eIZ`3om^h0ooK^04h0ooK^00<000000?ofkP3om^h01P3om^h00`000000ooK^
0?ofkP0Q0?ofkP40oooo001<0?ofkP030000003om^h0ooK^01L0ooK^00<0e3dI0?ofkP3om^h04P3o
m^h00`3D?AT0ooK^0?ofkP030?ofkP<0e3dI3P3om^h00`3D?AT0ooK^0?ofkP0A0?ofkP030=@m6@3o
m^h0e3dI00H0e3dI1P3om^h00`3D?AT0ooK^0?ofkP090?ofkP80e3dI00<0ooK^0=@m6@3om^h00`3o
m^h30=@m6@H0ooK^00<0e3dI0?ofkP3om^h0203om^h60=@m6@060?ofkP0000000000020cL@000000
:dFA0P3D?AT00`0[AI400000000000040000000403eIZ`3om^h0ooK^03eIZ`<0ooK^00<0?EV[0?of
kP3om^h00P3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[0080ooK^00<0?EV[0?ofkP3om^h02@3om^h4
03eIZ`80ooK^00<0?EV[0?ofkP3om^h04P3om^h0100mFJ/0ooK^0?ofkP3om^h203eIZa00ooK^00D0
?EV[0?ofkP3om^h0ooK^03eIZ`0@0?ofkP0303eIZ`3om^h0?EV[00d0ooK^00D0?EV[0?ofkP3om^h0
ooK^03eIZ`080?ofkP0303eIZ`3om^h0ooK^04l0ooK^00<000000?ofkP3om^h01P3om^h00`000000
ooK^0?ofkP0Q0?ofkP40oooo001=0?ofkP8000005`3om^h00`3D?AT0ooK^0?ofkP0B0?ofkP030=@m
6@3om^h0ooK^00<0e3dI4@3om^h00`3D?AT0ooK^0?ofkP0@0?ofkPH0e3dI2P3om^h00`3D?AT0ooK^
0?ofkP0;0?ofkP030=@m6@3om^h0e3dI00<0e3dI0P3om^h00`000000ooK^0?ofkP030?ofkP030=@m
6@3om^h0ooK^00H0ooK^103D?AT00`3om^h0e3dI0?ofkP020?ofkPL0e3dI00@0000003eIZ`0mFJ/0
?EV[0`3om^h00`0mFJ/0ooK^03eIZ`020?ofkP80?EV[00<0ooK^03eIZ`3om^h0103om^h203eIZ`03
0?ofkP0mFJ/0ooK^0080ooK^00<0?EV[0?ofkP3om^h01@3om^h303eIZ`L0ooK^00<0?EV[0?ofkP3o
m^h04P3om^h00`0mFJ/0ooK^03eIZ`0C0?ofkP0303eIZ`3om^h0?EV[0180ooK^00<0?EV[0?ofkP3o
m^h0303om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3o
m^h0D03om^h00`000000ooK^0?ofkP050?ofkP030000003om^h0ooK^0240ooK^0@3oool004l0ooK^
00<000000?ofkP3om^h05@3om^h00`3D?AT0ooK^0?ofkP0A0?ofkP<0e3dI5@3om^h00`3D?AT0ooK^
0?ofkP0<0?ofkP<0e3dI00<0ooK^0=@m6@3D?AT00`3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m
6@3om^h0ooK^00/0ooK^103D?AT50?ofkP030000003om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h0
0`3om^h40=@m6@<0ooK^00@0e3dI0?ofkP3om^h0ooK^103D?AT20?ofkP0303eIZ`000000000000L0
?EV[0P3om^h0100mFJ/0ooK^0?ofkP3om^h203eIZ`L0ooK^0P0mFJ/40?ofkP0303eIZ`3om^h0ooK^
00@0?EV[2`3om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?of
kP3om^h0403om^h00`0mFJ/0ooK^03eIZ`0<0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?of
kP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP1B0?ofkP030000003om^h0ooK^00@0ooK^00<000000?of
kP3om^h08@3om^h10?ooo`00D03om^h2000001H0ooK^00<0e3dI0?ofkP3om^h0303om^h40=@m6@80
ooK^00<0e3dI0?ofkP3om^h0503om^h00`3D?AT0ooK^0?ofkP080?ofkP<0e3dI103om^h00`3D?AT0
ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h0203om^h40=@m6@<0
ooK^0P3D?AT20?ofkP030000003om^h0ooK^00<0ooK^00@0e3dI0?ofkP3om^h0ooK^103D?AT50?of
kP030=@m6@3om^h0ooK^00<0e3dI1P3om^h00`0mFJ/0ooK^0?ofkP0203eIZ`030?ofkP0mFJ/0ooK^
00H0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP060?ofkPP0?EV[403om^h00`0mFJ/0ooK^0?ofkP0?0?of
kP80?EV[00<0ooK^03eIZ`3om^h04P3om^h00`0mFJ/0ooK^03eIZ`0@0?ofkP0503eIZ`3om^h0ooK^
0?ofkP0mFJ/02P3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[
0?ofkP3om^h0D`3om^h00`000000ooK^0?ofkP040?ofkP030000003om^h0ooK^0200ooK^0@3oool0
0580ooK^00<000000?ofkP3om^h0503om^h00`3D?AT0ooK^0?ofkP080?ofkP<0e3dI1`3om^h00`3D
?AT0ooK^0?ofkP0D0?ofkP030=@m6@3om^h0ooK^00@0ooK^0`3D?AT60?ofkP030=@m6@3om^h0ooK^
00D0ooK^0P3D?AT50?ofkP030=@m6@3om^h0ooK^00D0ooK^103D?AT20?ofkP030=@m6@3om^h0ooK^
00<0ooK^0P3D?AT00`000000ooK^0?ofkP030?ofkPD0e3dI1`3om^h40=@m6@X0ooK^0P0mFJ/01`3o
m^h0?EV[03eIZ`3om^h0?EV[0?ofkP0mFJ/0103om^h<03eIZ`H0ooK^00<0?EV[0?ofkP3om^h03`3o
m^h00`0mFJ/0ooK^0?ofkP0<0?ofkP80?EV[103om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP80?EV[0`3o
m^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h01`3o
m^h00`0mFJ/0ooK^0?ofkP070?ofkP0403eIZ`3om^h0ooK^03eIZeH0ooK^00<000000?ofkP3om^h0
103om^h00`000000ooK^0?ofkP0P0?ofkP40oooo001C0?ofkP800000503om^h00`3D?AT0ooK^0?of
kP050?ofkP<0e3dI2`3om^h00`3D?AT0ooK^0?ofkP0D0?ofkP030=@m6@3om^h0ooK^00<0e3dI2@3o
m^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^0080ooK^00@0e3dI0?ofkP3om^h0ooK^
1@3D?AT40?ofkP030=@m6@3om^h0ooK^00H0ooK^0P3D?AT20?ofkP@0e3dI1`3om^h40=@m6@h0ooK^
0`0mFJ/01P3om^h0?EV[03eIZ`0mFJ/0ooK^03eIZ`@0ooK^00@0?EV[0?ofkP0mFJ/0?EV[1P3om^h0
0`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h02@3om^h2
03eIZ`L0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0
ooK^00X0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0
ooK^00P0ooK^00@0?EV[0?ofkP3om^h0?EV[E`3om^h00`000000ooK^0?ofkP030?ofkP030000003o
m^h0ooK^0200ooK^0@3oool005D0ooK^00<000000?ofkP3om^h04P3om^h00`3D?AT0ooK^0?ofkP04
0=@m6@l0ooK^00<0e3dI0?ofkP3om^h04`3om^h30=@m6@`0ooK^00<0e3dI0?ofkP3om^h0203om^h0
1@3D?AT0ooK^0?ofkP3D?AT0ooK^00D0e3dI1`3om^h00`3D?AT0ooK^0?ofkP060?ofkP030000003D
?AT0e3dI00@0e3dI1@3om^h40=@m6A<0ooK^0P0mFJ/20?ofkP<0?EV[1@3om^h203eIZ`030?ofkP0m
FJ/0ooK^00@0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3o
m^h0ooK^00H0ooK^0P0mFJ/:0?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h01P3o
m^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h00`3o
m^h00`0mFJ/0ooK^0?ofkP0:0?ofkP80?EV[F@3om^h00`000000ooK^0?ofkP020?ofkP030000003o
m^h0ooK^0200ooK^0@3oool005H0ooK^0P00000C0?ofkP80e3dI4`3om^h00`3D?AT0ooK^0?ofkP0@
0?ofkP<0e3dI0P3om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^00X0ooK^1P3D?AT9
0?ofkP030=@m6@3om^h0ooK^00D0ooK^103D?AT00`3om^h0e3dI0?ofkP020?ofkPD0e3dI603om^h2
03eIZ`80ooK^0`0mFJ/50?ofkP0403eIZ`3om^h0ooK^03eIZ`@0ooK^00<0?EV[0?ofkP3om^h01`3o
m^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00<0ooK^0P0mFJ/=0?ofkP80?EV[203o
m^h203eIZ`T0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3o
m^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP1H0?ofkP050000003o
m^h0ooK^0?ofkP0000008P3om^h10?ooo`00F03om^h00`000000ooK^0?ofkP0A0?ofkP030=@m6@3o
m^h0ooK^0180ooK^00<0e3dI0?ofkP3om^h0303om^h30=@m6@H0ooK^0P3D?AT90?ofkP030=@m6@3o
m^h0ooK^00P0ooK^1@3D?AT<0?ofkP040=@m6@3om^h0ooK^0?ofkP@0e3dI0P3om^h00`000000ooK^
0=@m6@020?ofkP@0e3dI703om^h303eIZ`040?ofkP0mFJ/0?EV[03eIZ`@0ooK^0P0mFJ/20?ofkP05
03eIZ`3om^h0ooK^0?ofkP0mFJ/02P3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^
0080?EV[4@3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?of
kP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0403eIZ`3om^h0ooK^03eIZ`d0ooK^00<0?EV[
0?ofkP3om^h0F@3om^h01@000000ooK^0?ofkP3om^h000000280ooK^0@3oool005T0ooK^0P00000B
0?ofkP030=@m6@3om^h0ooK^0180ooK^00<0e3dI0?ofkP3om^h0203om^h30=@m6@/0ooK^00<0e3dI
0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP050?ofkPD0e3dI00<0ooK^0=@m6@3om^h00`3D?AT8
0?ofkP030=@m6@3om^h0e3dI00<0e3dI1@3om^h00`000000e3dI0=@m6@030=@m6B00ooK^00<0?EV[
0?ofkP0mFJ/00P0mFJ/00`3om^h0?EV[0?ofkP030?ofkP80?EV[0P3om^h203eIZ`030?ofkP0mFJ/0
ooK^00X0ooK^00<0?EV[0?ofkP3om^h03P3om^h303eIZa@0ooK^00<0?EV[0?ofkP3om^h00P3om^h0
0`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h03@3om^h0
0`0mFJ/0ooK^03eIZ`0=0?ofkP0303eIZ`3om^h0ooK^05X0ooK^00D000000?ofkP3om^h0ooK^0000
000Q0?ofkP40oooo001K0?ofkP030000003om^h0ooK^0100ooK^00<0e3dI0?ofkP3om^h04P3om^h0
0`3D?AT0ooK^0?ofkP040?ofkP<0e3dI3`3om^h00`3D?AT0ooK^0?ofkP050?ofkP040=@m6@3om^h0
ooK^0?ofkPD0e3dI103om^h00`3D?AT0ooK^0?ofkP030?ofkP<0e3dI0`3om^h40=@m6@P0ooK^0`3D
?ATU0?ofkP0303eIZ`3om^h0ooK^0080?EV[00<0ooK^03eIZ`3om^h00P3om^h00`0mFJ/0ooK^03eI
Z`030?ofkP0303eIZ`3om^h0?EV[00/0ooK^00<0?EV[0?ofkP3om^h02@3om^h403eIZ`80ooK^00<0
?EV[0?ofkP3om^h04`3om^h0100mFJ/0ooK^03eIZ`0mFJ/@0?ofkP0503eIZ`3om^h0ooK^0?ofkP0m
FJ/04@3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^05`0ooK^00@000000?ofkP3o
m^h000008@3om^h10?ooo`00G03om^h00`000000ooK^0?ofkP0@0?ofkP030=@m6@3om^h0ooK^0180
ooK^00<0e3dI0?ofkP3om^h00`3D?ATC0?ofkP80e3dI103om^h00`3D?AT0ooK^0=@m6@040=@m6@H0
ooK^00<0e3dI0?ofkP3om^h01`3om^h50=@m6@H0ooK^103D?AT00`3om^h000000?ofkP0V0?ofkP03
03eIZ`3om^h0ooK^00@0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP0203eIZ`80ooK^0P0mFJ/<0?ofkP03
03eIZ`3om^h0ooK^00D0ooK^0`0mFJ/70?ofkP0303eIZ`3om^h0ooK^01<0ooK^00<0?EV[0?ofkP3o
m^h04@3om^h00`0mFJ/0ooK^03eIZ`0A0?ofkP0303eIZ`3om^h0?EV[00/0ooK^00<0?EV[0?ofkP3o
m^h0G@3om^h010000000ooK^0?ofkP00000Q0?ofkP40oooo001M0?ofkP800000403om^h00`3D?AT0
ooK^0?ofkP0B0?ofkP<0e3dI603om^h00`3D?AT0ooK^0?ofkP040=@m6@X0ooK^00<0e3dI0?ofkP3o
m^h0103om^h30=@m6@<0ooK^00<0e3dI0?ofkP3D?AT01@3D?AT50?ofkP030000003om^h0ooK^02H0
ooK^0P0mFJ/00`3om^h0?EV[03eIZ`0403eIZ`@0ooK^00@0?EV[0?ofkP3om^h0?EV[3@3om^h00`0m
FJ/0ooK^0?ofkP0403eIZ`/0ooK^00<0?EV[0?ofkP3om^h0403om^h203eIZ`030?ofkP0mFJ/0ooK^
0180ooK^00<0?EV[0?ofkP3om^h03`3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00X0ooK^00<0?EV[
0?ofkP3om^h0GP3om^h00`000000ooK^0000000Q0?ofkP40oooo001O0?ofkP030000003om^h0ooK^
00h0ooK^00<0e3dI0?ofkP3om^h03@3om^h40=@m6@80ooK^0P3D?ATG0?ofkP@0e3dI303om^h00`3D
?AT0ooK^0?ofkP020?ofkP<0e3dI103om^h20=@m6@030?ofkP3D?AT0e3dI0080e3dI203om^h00`00
0000ooK^0?ofkP0W0?ofkP80?EV[00<0ooK^03eIZ`0mFJ/00P0mFJ/00`3om^h0?EV[03eIZ`0403eI
Z`030?ofkP0mFJ/0?EV[00L0ooK^200mFJ/@0?ofkP0303eIZ`3om^h0ooK^00d0ooK^0P0mFJ/40?of
kP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP0mFJ/03`3om^h00`0mFJ/0ooK^0?ofkP030?of
kP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h0H03om^h200000240ooK^0@3oool00600
ooK^0P00000?0?ofkP030=@m6@3om^h0ooK^00T0ooK^0`3D?AT80?ofkP80e3dI4@3om^h40=@m6@<0
ooK^0P3D?AT;0?ofkPD0e3dI1P3om^h50=@m6@/0ooK^00<000000?ofkP3om^h0:03om^h303eIZ`80
ooK^0`0mFJ/50?ofkPX0?EV[1`3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP80?EV[2`3om^h203eIZ`L0
ooK^00<0?EV[0?ofkP3om^h0303om^h203eIZ`<0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0
ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h0HP3om^h200000200
ooK^0@3oool00680ooK^00<000000?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP050?ofkP<0e3dI
3@3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP<0e3dI1P3om^h00`3D?AT0ooK^0?ofkP020=@m6@L0ooK^
103D?AT60?ofkP@0e3dI3`3om^h00`000000ooK^0?ofkP0Z0?ofkP80?EV[0P3om^h203eIZ`H0ooK^
00@0?EV[0?ofkP3om^h0?EV[3@3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0303eIZ`3om^h0ooK^00H0
ooK^0P0mFJ/:0?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0
ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0
ooK^0?ofkP1R0?ofkP800000803om^h10?ooo`00H`3om^h2000000h0ooK^00<0e3dI0?ofkP3om^h0
103D?ATA0?ofkP80e3dI203om^h30=@m6@P0ooK^00<0e3dI0?ofkP3om^h00`3om^h20=@m6@80ooK^
103D?AT50?ofkPD0e3dI4P3om^h00`000000ooK^0?ofkP0[0?ofkP80?EV[0P3om^h203eIZ`D0ooK^
00D0?EV[0?ofkP3om^h0ooK^03eIZ`0=0?ofkP0303eIZ`3om^h0ooK^0100ooK^00<0?EV[0?ofkP3o
m^h00`3om^h203eIZ``0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP060?ofkP03
03eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP020?ofkP03
03eIZ`3om^h0ooK^06<0ooK^0P00000P0?ofkP40oooo001U0?ofkP030000003om^h0ooK^00`0ooK^
0P3D?ATG0?ofkP80e3dI0P3om^h40=@m6@/0ooK^00<0e3dI0?ofkP3om^h0103om^h=0=@m6AH0ooK^
00<000000?ofkP3om^h0;03om^h303eIZ`040?ofkP0mFJ/0?EV[03eIZ`@0ooK^00D0?EV[0?ofkP3o
m^h0ooK^03eIZ`0=0?ofkP0303eIZ`3om^h0ooK^0100ooK^00<0?EV[0?ofkP3om^h00P0mFJ/?0?of
kP0303eIZ`3om^h0ooK^00H0ooK^0P0mFJ/:0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?of
kP3om^h02P3om^h0100mFJ/0ooK^0?ofkP0mFJ]R0?ofkP@000008P3om^h10?ooo`00IP3om^h20000
00d0ooK^00<0e3dI0?ofkP3om^h05P3om^h30=@m6@h0ooK^00@0e3dI0?ofkP3om^h0ooK^1@3D?AT2
0?ofkP80e3dI00<0ooK^0=@m6@3D?AT00P3D?ATI0?ofkP030000003om^h0ooK^02d0ooK^00<0?EV[
0?ofkP0mFJ/00P0mFJ/00`3om^h0?EV[0?ofkP020?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[
0?ofkP3om^h02`3om^h203eIZa00ooK^0`0mFJ/B0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[
0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[
0?ofkP0mFJ/0GP3om^h4000002H0ooK^0@3oool006P0ooK^00<000000?ofkP3om^h02`3om^h20=@m
6A<0ooK^0`3D?AT30?ofkP80e3dI303om^h50=@m6@D0ooK^1@3D?ATL0?ofkP030000003om^h0ooK^
02h0ooK^00<0?EV[0?ofkP3om^h0100mFJ/30?ofkP0303eIZ`3om^h0ooK^0080ooK^0P0mFJ/=0?of
kP0303eIZ`3om^h0ooK^00T0ooK^100mFJ/20?ofkP0303eIZ`3om^h0ooK^0140ooK^00<0?EV[0?of
kP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/0403om^h0
0`0mFJ/0ooK^0?ofkP1I0?ofkP@00000:P3om^h10?ooo`00J@3om^h2000000d0ooK^00<0e3dI0?of
kP3om^h03@3om^h30=@m6@P0ooK^0P3D?AT90?ofkP<0e3dI1P3om^h30=@m6B00ooK^00<000000?of
kP3om^h0;`3om^h203eIZ`030?ofkP0mFJ/0?EV[0080?EV[0P3om^h00`0mFJ/0ooK^0?ofkP040?of
kP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h01@3om^h303eIZ`L0ooK^00<0?EV[0?of
kP3om^h04@3om^h0100mFJ/0ooK^03eIZ`0mFJ/A0?ofkP0303eIZ`3om^h0?EV[0100ooK^00<0?EV[
0?ofkP3om^h0EP3om^h4000002h0ooK^0@3oool006/0ooK^00<000000?ofkP3om^h02`3om^h00`3D
?AT0ooK^0?ofkP090?ofkP<0e3dI3@3om^h20=@m6@<0ooK^103D?AT50?ofkPD0e3dI8P3om^h00`00
0000ooK^0?ofkP0`0?ofkP80?EV[00<0ooK^03eIZ`3om^h0100mFJ/70?ofkP0303eIZ`3om^h0ooK^
00/0ooK^00<0?EV[0?ofkP3om^h0100mFJ/;0?ofkP0303eIZ`3om^h0ooK^0100ooK^0P0mFJ/D0?of
kP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h0D`3om^h400000380ooK^0@3oool006`0
ooK^0P00000<0?ofkP80e3dI1P3om^h30=@m6A80ooK^1@3D?AT40?ofkPD0e3dI9@3om^h00`000000
ooK^0?ofkP0a0?ofkP80?EV[00<0ooK^03eIZ`3om^h00P0mFJ/00`3om^h0?EV[03eIZ`0403eIZ`80
ooK^00<0?EV[0?ofkP3om^h01@3om^h803eIZa00ooK^00<0?EV[0?ofkP3om^h03@3om^h203eIZ`80
ooK^00<0?EV[0?ofkP3om^h03`3om^h203eIZ`030?ofkP0mFJ/0ooK^00d0ooK^00<0?EV[0?ofkP3o
m^h0D03om^h4000003H0ooK^0@3oool006h0ooK^00<000000?ofkP3om^h02`3om^h00`3D?AT0ooK^
0?ofkP030=@m6A40ooK^103D?AT30?ofkP030=@m6@3om^h0e3dI00D0e3dI:03om^h00`000000ooK^
0?ofkP0c0?ofkP0403eIZ`3om^h0?EV[0?ofkP<0?EV[1@3om^h:03eIZ`L0ooK^00<0?EV[0?ofkP3o
m^h03`3om^h203eIZ`/0ooK^0P0mFJ/50?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3o
m^h00P3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^04d0ooK^1000000j0?ofkP40
oooo001_0?ofkP030000003om^h0ooK^00/0ooK^0P3D?ATA0?ofkP<0e3dI1@3om^h70=@m6B/0ooK^
00<000000?ofkP3om^h0=03om^h203eIZ`<0ooK^0P0mFJ/80?ofkP0303eIZ`3om^h0ooK^00/0ooK^
00<0?EV[0?ofkP3om^h0403om^h00`0mFJ/0ooK^0?ofkP060?ofkP80?EV[203om^h00`0mFJ/0ooK^
0?ofkP0:0?ofkP80?EV[1P3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^04X0ooK^
1000000n0?ofkP40oooo001`0?ofkP8000003@3om^h30=@m6@/0ooK^0`3D?AT60?ofkPD0e3dI;`3o
m^h00`000000ooK^0?ofkP0e0?ofkP80?EV[0`3om^h203eIZ`P0ooK^00<0?EV[0?ofkP3om^h02`3o
m^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0303eIZ`3om^h0ooK^00<0ooK^0P0mFJ/;0?ofkP80?EV[2@3o
m^h00`0mFJ/0ooK^0?ofkP070?ofkP80?EV[1`3om^h00`0mFJ/0ooK^0?ofkP170?ofkP@00000@P3o
m^h10?ooo`00LP3om^h00`000000ooK^0?ofkP0=0?ofkP@0e3dI0`3om^h40=@m6@L0ooK^103D?ATa
0?ofkP030000003om^h0ooK^03L0ooK^100mFJ/00`3om^h0?EV[03eIZ`080?ofkP0303eIZ`3om^h0
ooK^00/0ooK^00<0?EV[0?ofkP3om^h0403om^h00`0mFJ/0ooK^0?ofkP0203eIZ`l0ooK^00<0?EV[
0?ofkP3om^h0103om^h203eIZ``0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP14
0?ofkP@00000AP3om^h10?ooo`00L`3om^h200000140ooK^1@3D?AT60?ofkP@0e3dI=03om^h00`00
0000ooK^0?ofkP0h0?ofkP80?EV[00@0ooK^03eIZ`0mFJ/0ooK^0P0mFJ/70?ofkP0303eIZ`3om^h0
ooK^00/0ooK^0P0mFJ/@0?ofkP<0?EV[4P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0
ooK^00d0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`130?ofkP@00000BP3om^h10?ooo`00M@3om^h0
0`000000ooK^0?ofkP0C0?ofkPH0e3dI>03om^h00`000000ooK^0?ofkP0j0?ofkP0303eIZ`3om^h0
ooK^00@0?EV[1`3om^h203eIZ`d0ooK^00<0?EV[0?ofkP3om^h02@3om^h403eIZ`80ooK^00<0?EV[
0?ofkP3om^h04@3om^h0100mFJ/0ooK^03eIZ`0mFJ/A0?ofkP0303eIZ`3om^h0?EV[0400ooK^1000
001>0?ofkP40oooo001f0?ofkP800000D@3om^h00`000000ooK^0?ofkP0k0?ofkP0503eIZ`3om^h0
ooK^03eIZ`3om^h00`0mFJ/70?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h01@3o
m^h303eIZ`L0ooK^00<0?EV[0?ofkP3om^h04@3om^h00`0mFJ/0ooK^0?ofkP0B0?ofkP0303eIZ`3o
m^h0ooK^03/0ooK^1000001B0?ofkP40oooo001h0?ofkP030000003om^h0ooK^04h0ooK^00<00000
0?ofkP3om^h0?03om^h303eIZ`<0ooK^1@0mFJ/40?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[
0?ofkP3om^h0100mFJ/;0?ofkP0303eIZ`3om^h0ooK^00h0ooK^0P0mFJ/00`3om^h0?EV[0?ofkP0A
0?ofkP0303eIZ`3om^h0ooK^03T0ooK^0`00001F0?ofkP40oooo001i0?ofkP800000CP3om^h00`00
0000ooK^0?ofkP0m0?ofkP<0?EV[0`3om^h0100mFJ/0ooK^0?ofkP3om^h403eIZ`030?ofkP0mFJ/0
ooK^00H0ooK^200mFJ/@0?ofkP0303eIZ`3om^h0ooK^00/0ooK^0P0mFJ/40?ofkP0303eIZ`3om^h0
ooK^00d0ooK^0P0mFJ/h0?ofkP@00000F@3om^h10?ooo`00N`3om^h00`000000ooK^0?ofkP1;0?of
kP030000003om^h0ooK^03l0ooK^0P0mFJ/30?ofkP0303eIZ`3om^h0ooK^00@0ooK^2@0mFJ/70?of
kP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h0203om^h203eIZ`L0ooK^00<0?EV[0?of
kP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP0d0?ofkP@00000G@3om^h10?ooo`00O03om^h2000004/0
ooK^00<000000?ofkP3om^h0@03om^h203eIZ`<0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0
ooK^0?ofkP0;0?ofkP80?EV[403om^h00`0mFJ/0ooK^0?ofkP050?ofkP80?EV[2P3om^h00`0mFJ/0
ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^0340ooK^1000001Q0?ofkP40oooo001n0?ofkP030000
003om^h0ooK^04P0ooK^00<000000?ofkP3om^h0@@3om^h303eIZ`80ooK^0P0mFJ/70?ofkP80?EV[
3@3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^0080ooK^0P0mFJ/=0?ofkP0303eI
Z`3om^h0ooK^00H0ooK^0P0mFJ/`0?ofkP@00000I@3om^h10?ooo`00O`3om^h2000004P0ooK^00<0
00000?ofkP3om^h0@P3om^h0100mFJ/0ooK^03eIZ`0mFJ/20?ofkP0303eIZ`3om^h0ooK^00H0ooK^
00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0403eIZ`3om^h0?EV[03eIZa00
ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0/0?ofkP@00000J@3om^h10?ooo`00
P@3om^h00`000000ooK^0?ofkP150?ofkP030000003om^h0ooK^04<0ooK^00<0?EV[0?ofkP3om^h0
0P0mFJ/00`3om^h0?EV[0?ofkP070?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h0
303om^h303eIZa<0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP0Y0?ofkP@00000
K@3om^h10?ooo`00PP3om^h00`000000ooK^0?ofkP140?ofkP030000003om^h0ooK^04@0ooK^0P0m
FJ/20?ofkP<0?EV[203om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP80?EV[203om^h403eIZ`<0ooK^00<0
?EV[0?ofkP3om^h04@3om^h0100mFJ/0ooK^03eIZ`0mFJ/X0?ofkP@00000L@3om^h10?ooo`00P`3o
m^h2000004@0ooK^00<000000?ofkP3om^h0A@3om^h203eIZ`<0ooK^100mFJ/60?ofkP80?EV[3@3o
m^h0100mFJ/0ooK^0?ofkP3om^h403eIZ`P0ooK^00<0?EV[0?ofkP3om^h0403om^h203eIZbH0ooK^
1000001e0?ofkP40oooo00250?ofkP030000003om^h0ooK^0440ooK^00<000000?ofkP3om^h0A`3o
m^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0?EV[00D0?EV[0P3om^h00`0mFJ/0ooK^0?of
kP050?ofkPT0?EV[3@3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP80?EV[903om^h4000007T0ooK^0@3o
ool008H0ooK^0P0000110?ofkP030000003om^h0ooK^04P0ooK^00<0?EV[0?ofkP3om^h00P3om^h0
0`0mFJ/0ooK^0?ofkP040?ofkPX0?EV[1`3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP80?EV[2`3om^h2
03eIZb80ooK^1000001m0?ofkP40oooo00280?ofkP030000003om^h0ooK^03h0ooK^00<000000?of
kP3om^h0B@3om^h203eIZ`<0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP0;0?of
kP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h01P3om^h203eIZb00ooK^100000210?of
kP40oooo00290?ofkP800000?P3om^h00`000000ooK^0?ofkP1;0?ofkP80?EV[0P3om^h203eIZ`P0
ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00<0
ooK^0P0mFJ/N0?ofkP@00000Q@3om^h10?ooo`00R`3om^h00`000000ooK^0?ofkP0k0?ofkP030000
003om^h0ooK^04d0ooK^0P0mFJ/20?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h0
2`3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^0080?EV[7@3om^h3000008T0ooK^
0@3oool008`0ooK^0P00000k0?ofkP030000003om^h0ooK^04l0ooK^0P0mFJ/00`3om^h0?EV[0?of
kP070?ofkP80?EV[303om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP<0?EV[6`3om^h4000008`0ooK^0@3o
ool008h0ooK^00<000000?ofkP3om^h0>03om^h00`000000ooK^0?ofkP1A0?ofkP<0?EV[2@3om^h0
0`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00T0ooK^0`0mFJ/J0?ofkP@00000T03om^h1
0?ooo`00S`3om^h2000003P0ooK^00<000000?ofkP3om^h0D`3om^h403eIZ`L0ooK^00<0?EV[0?of
kP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP040?ofkP@0?EV[6@3om^h4000009@0ooK^0@3oool00940
ooK^00<000000?ofkP3om^h0=@3om^h00`000000ooK^0?ofkP1G0?ofkPH0?EV[0P3om^h00`0mFJ/0
ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00<0?EV[6@3om^h4000009P0ooK^0@3oool00980ooK^
0P00000e0?ofkP030000003om^h0ooK^05d0ooK^4P0mFJ/H0?ofkP@00000W03om^h10?ooo`00U03o
m^h00`000000ooK^0?ofkP0b0?ofkP030000003om^h0ooK^08<0ooK^1000002P0?ofkP40oooo002E
0?ofkP030000003om^h0ooK^0300ooK^00<000000?ofkP3om^h0P03om^h400000:@0ooK^0@3oool0
09H0ooK^0P00000`0?ofkP030000003om^h0ooK^07`0ooK^1000002X0?ofkP40oooo002H0?ofkP03
0000003om^h0ooK^02d0ooK^00<000000?ofkP3om^h0N03om^h400000:`0ooK^0@3oool009T0ooK^
0P00000]0?ofkP030000003om^h0ooK^07@0ooK^1000002`0?ofkP40oooo002K0?ofkP030000003o
m^h0ooK^02X0ooK^00<000000?ofkP3om^h0L03om^h400000;@0ooK^0@3oool009`0ooK^0P00000Z
0?ofkP030000003om^h0ooK^06`0ooK^1000002h0?ofkP40oooo002N0?ofkP030000003om^h0ooK^
02L0ooK^00<000000?ofkP3om^h0J03om^h400000;`0ooK^0@3oool009l0ooK^0P00000W0?ofkP03
0000003om^h0ooK^06D0ooK^0`0000300?ofkP40oooo002Q0?ofkP030000003om^h0ooK^02@0ooK^
00<000000?ofkP3om^h0H@3om^h400000<<0ooK^0@3oool00:80ooK^0P00000T0?ofkP030000003o
m^h0ooK^05d0ooK^100000370?ofkP40oooo002T0?ofkP030000003om^h0ooK^0240ooK^00<00000
0?ofkP3om^h0F@3om^h400000</0ooK^0@3oool00:D0ooK^0P00000Q0?ofkP030000003om^h0ooK^
05D0ooK^1000003?0?ofkP40oooo002W0?ofkP030000003om^h0ooK^01h0ooK^00<000000?ofkP3o
m^h0D@3om^h400000=<0ooK^0@3oool00:P0ooK^0P00000N0?ofkP030000003om^h0ooK^04d0ooK^
1000003G0?ofkP40oooo002Z0?ofkP030000003om^h0ooK^01/0ooK^00<000000?ofkP3om^h0B@3o
m^h400000=/0ooK^0@3oool00:/0ooK^00<000000?ofkP3om^h06P3om^h00`000000ooK^0?ofkP15
0?ofkP@00000g`3om^h10?ooo`00[03om^h2000001X0ooK^00<000000?ofkP3om^h0@@3om^h40000
0><0ooK^0@3oool00:h0ooK^00<000000?ofkP3om^h05`3om^h00`000000ooK^0?ofkP0m0?ofkP@0
0000i`3om^h10?ooo`00[`3om^h2000001L0ooK^00<000000?ofkP3om^h0>@3om^h400000>/0ooK^
0@3oool00;40ooK^00<000000?ofkP3om^h0503om^h00`000000ooK^0?ofkP0e0?ofkP@00000k`3o
m^h10?ooo`00/P3om^h2000001@0ooK^00<000000?ofkP3om^h0<P3om^h300000?<0ooK^0@3oool0
0;@0ooK^00<000000?ofkP3om^h04@3om^h00`000000ooK^0?ofkP0^0?ofkP@00000mP3om^h10?oo
o`00]@3om^h200000140ooK^00<000000?ofkP3om^h0:P3om^h400000?X0ooK^0@3oool00;L0ooK^
00<000000?ofkP3om^h03@3om^h00`000000ooK^0?ofkP0W0?ofkP@00000oP3om^h10?ooo`00^03o
m^h2000000d0ooK^00<000000?ofkP3om^h08`3om^h400000?l0ooK^0`3om^h10?ooo`00^P3om^h0
0`000000ooK^0?ofkP0:0?ofkP030000003om^h0ooK^01l0ooK^1000003o0?ofkPL0ooK^0@3oool0
0;/0ooK^0P00000:0?ofkP030000003om^h0ooK^01/0ooK^1000003o0?ofkP/0ooK^0@3oool00;d0
ooK^00<000000?ofkP3om^h01`3om^h00`000000ooK^0?ofkP0G0?ofkP@00000o`3om^h?0?ofkP40
oooo002n0?ofkP030000003om^h0ooK^00H0ooK^00<000000?ofkP3om^h04`3om^h400000?l0ooK^
4`3om^h10?ooo`00_`3om^h2000000H0ooK^00<000000?ofkP3om^h03`3om^h400000?l0ooK^5`3o
m^h10?ooo`00`@3om^h00`000000ooK^0?ofkP030?ofkP030000003om^h0ooK^00/0ooK^1000003o
0?ofkQ/0ooK^0@3oool00<80ooK^0P0000030?ofkP030000003om^h0ooK^00L0ooK^1000003o0?of
kQl0ooK^0@3oool00<@0ooK^00@000000?ofkP3om^h000001@3om^h400000?l0ooK^8`3om^h10?oo
o`00a@3om^h3000000030?ofkP000000000000800000o`3om^hW0?ofkP40oooo00370?ofkP800000
o`3om^h[0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?of
kP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o
0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^
0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0
ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h1
0?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3o
m^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40
oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?of
k_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3o
ool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^
m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?oo
o`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd
0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo
003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0
ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool0
0?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03o
m^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00
o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?of
kP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o
0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^
0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0
ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h1
0?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3o
m^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00001\
\>"],
  ImageRangeCache->{{{0, 499}, {499, 0}} -> {-5.00005*^-06, -5.00005*^-06, \
0.00200403, 0.00200403}}],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
%%ImageSize: 500 500 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics3D
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Background color
1 .961 .933 r
MFill
% Scaling calculations
0 1 0 1 [
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 0 0 r
.25 Mabswid
[ ] 0 setdash
.32128 .58361 m
.3022 .81857 L
s
.3022 .81857 m
.86955 .74993 L
s
.86955 .74993 m
.83139 .50547 L
s
.83139 .50547 m
.32128 .58361 L
s
.08947 .22236 m
.75972 .08168 L
s
.75972 .08168 m
.80207 .35868 L
s
.80207 .35868 m
.02925 .49223 L
s
.02925 .49223 m
.08947 .22236 L
s
.32128 .58361 m
.3022 .81857 L
s
.3022 .81857 m
.02925 .49223 L
s
.02925 .49223 m
.08947 .22236 L
s
.08947 .22236 m
.32128 .58361 L
s
.83139 .50547 m
.75972 .08168 L
s
.75972 .08168 m
.80207 .35868 L
s
.80207 .35868 m
.86955 .74993 L
s
.86955 .74993 m
.83139 .50547 L
s
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
.24 .35 .67 r
.5 Mabswid
.55225 .54761 m
.52744 .55588 L
s
.52744 .55588 m
.51851 .53577 L
s
.52744 .55588 m
.50435 .56818 L
s
.50435 .56818 m
.49499 .54826 L
s
.50435 .56818 m
.48382 .58405 L
s
.57783 .54369 m
.55225 .54761 L
s
.55225 .54761 m
.54374 .52733 L
s
.48382 .58405 m
.47407 .56436 L
s
.48382 .58405 m
.46666 .60293 L
s
.60325 .54431 m
.57783 .54369 L
s
.57783 .54369 m
.56975 .52327 L
s
.46666 .60293 m
.45655 .58347 L
s
.46666 .60293 m
.45358 .62415 L
s
.6275 .54952 m
.60325 .54431 L
s
.60325 .54431 m
.59557 .52378 L
s
.45358 .62415 m
.44317 .60493 L
s
.45358 .62415 m
.44518 .64691 L
s
.64963 .55922 m
.6275 .54952 L
s
.6275 .54952 m
.62021 .52894 L
s
.54374 .52733 m
.51851 .53577 L
s
.51851 .53577 m
.50925 .51493 L
s
.51851 .53577 m
.49499 .54826 L
s
.49499 .54826 m
.4853 .52763 L
s
.49499 .54826 m
.47407 .56436 L
s
.56975 .52327 m
.54374 .52733 L
s
.54374 .52733 m
.53492 .50631 L
s
.47407 .56436 m
.46397 .54395 L
s
.47407 .56436 m
.45655 .58347 L
s
.59557 .52378 m
.56975 .52327 L
s
.56975 .52327 m
.56137 .5021 L
s
.44518 .64691 m
.43452 .62794 L
s
.44518 .64691 m
.4419 .67035 L
s
.66866 .57313 m
.64963 .55922 L
s
.64963 .55922 m
.64267 .53862 L
s
.45655 .58347 m
.44608 .5633 L
s
.45655 .58347 m
.44317 .60493 L
s
.62021 .52894 m
.59557 .52378 L
s
.59557 .52378 m
.58762 .5025 L
s
.44317 .60493 m
.43237 .58501 L
s
.44317 .60493 m
.43452 .62794 L
s
.4419 .67035 m
.43108 .65162 L
s
.4419 .67035 m
.44405 .6935 L
s
.64267 .53862 m
.62021 .52894 L
s
.62021 .52894 m
.61265 .50759 L
s
.53492 .50631 m
.50925 .51493 L
s
.50925 .51493 m
.49964 .49333 L
s
.50925 .51493 m
.4853 .52763 L
s
.68373 .59079 m
.66866 .57313 L
s
.66866 .57313 m
.66199 .55258 L
s
.4853 .52763 m
.47525 .50624 L
s
.4853 .52763 m
.46397 .54395 L
s
.56137 .5021 m
.53492 .50631 L
s
.53492 .50631 m
.52578 .48451 L
s
.46397 .54395 m
.45349 .52279 L
s
.46397 .54395 m
.44608 .5633 L
s
.58762 .5025 m
.56137 .5021 L
s
.56137 .5021 m
.55269 .48015 L
s
.43452 .62794 m
.42346 .60827 L
s
.43452 .62794 m
.43108 .65162 L
s
.66199 .55258 m
.64267 .53862 L
s
.64267 .53862 m
.63546 .51727 L
s
.44608 .5633 m
.43521 .54239 L
s
.44608 .5633 m
.43237 .58501 L
s
.44405 .6935 m
.43314 .675 L
s
.44405 .6935 m
.45169 .71538 L
s
.61265 .50759 m
.58762 .5025 L
s
.58762 .5025 m
.57937 .48044 L
s
.69405 .61157 m
.68373 .59079 L
s
.68373 .59079 m
.67726 .57035 L
s
.43237 .58501 m
.42117 .56435 L
s
.43237 .58501 m
.42346 .60827 L
s
.43108 .65162 m
.41985 .63219 L
s
.43108 .65162 m
.43314 .675 L
s
.63546 .51727 m
.61265 .50759 L
s
.61265 .50759 m
.6048 .48545 L
s
.52578 .48451 m
.49964 .49333 L
s
.49964 .49333 m
.48968 .47091 L
s
.49964 .49333 m
.47525 .50624 L
s
.67726 .57035 m
.66199 .55258 L
s
.66199 .55258 m
.65506 .53126 L
s
.47525 .50624 m
.46482 .48405 L
s
.47525 .50624 m
.45349 .52279 L
s
.55269 .48015 m
.52578 .48451 L
s
.52578 .48451 m
.51629 .4619 L
s
.45169 .71538 m
.44081 .69708 L
s
.45169 .71538 m
.46468 .73497 L
s
.699 .63465 m
.69405 .61157 L
s
.69405 .61157 m
.6877 .59129 L
s
.45349 .52279 m
.44262 .50083 L
s
.45349 .52279 m
.43521 .54239 L
s
.57937 .48044 m
.55269 .48015 L
s
.55269 .48015 m
.54367 .45737 L
s
.42346 .60827 m
.41199 .58786 L
s
.42346 .60827 m
.41985 .63219 L
s
.65506 .53126 m
.63546 .51727 L
s
.63546 .51727 m
.62797 .4951 L
s
.43521 .54239 m
.42394 .52068 L
s
.43521 .54239 m
.42117 .56435 L
s
.43314 .675 m
.42183 .6558 L
s
.43314 .675 m
.44081 .69708 L
s
.83 .24 .1 r
.26487 .51389 m
.27 .54129 L
s
.27 .54129 m
.30589 .53554 L
s
.27 .54129 m
.27308 .56888 L
s
.24 .35 .67 r
.6048 .48545 m
.57937 .48044 L
s
.57937 .48044 m
.57081 .45753 L
s
.6877 .59129 m
.67726 .57035 L
s
.67726 .57035 m
.67054 .54912 L
s
.83 .24 .1 r
.25786 .48758 m
.26487 .51389 L
s
.26487 .51389 m
.30078 .50799 L
s
.27308 .56888 m
.30907 .56326 L
s
.27308 .56888 m
.274 .59574 L
s
.24 .35 .67 r
.46468 .73497 m
.45392 .71683 L
s
.46468 .73497 m
.48259 .75129 L
s
.69267 .61457 m
.699 .63465 L
s
.69818 .65903 m
.699 .63465 L
s
.83 .24 .1 r
.30078 .50799 m
.30589 .53554 L
s
.30589 .53554 m
.34213 .52974 L
s
.30589 .53554 m
.30907 .56326 L
s
.24917 .46327 m
.25786 .48758 L
s
.25786 .48758 m
.2939 .48153 L
s
.2939 .48153 m
.30078 .50799 L
s
.30078 .50799 m
.33704 .50204 L
s
.24 .35 .67 r
.42117 .56435 m
.41199 .58786 L
s
.41985 .63219 m
.40819 .61202 L
s
.41985 .63219 m
.42183 .6558 L
s
.83 .24 .1 r
.30907 .56326 m
.34541 .55758 L
s
.30907 .56326 m
.3102 .59022 L
s
.24 .35 .67 r
.62797 .4951 m
.6048 .48545 L
s
.6048 .48545 m
.59666 .46246 L
s
.51629 .4619 m
.48968 .47091 L
s
.48968 .47091 m
.47934 .44764 L
s
.48968 .47091 m
.46482 .48405 L
s
.83 .24 .1 r
.274 .59574 m
.3102 .59022 L
s
.274 .59574 m
.27268 .62095 L
s
.24 .35 .67 r
.67054 .54912 m
.65506 .53126 L
s
.65506 .53126 m
.64787 .50913 L
s
.46482 .48405 m
.44262 .50083 L
s
.54367 .45737 m
.51629 .4619 L
s
.51629 .4619 m
.50645 .43843 L
s
.83 .24 .1 r
.33704 .50204 m
.34213 .52974 L
s
.34213 .52974 m
.37874 .52387 L
s
.34213 .52974 m
.34541 .55758 L
s
.24 .35 .67 r
.44081 .69708 m
.42951 .67808 L
s
.44081 .69708 m
.45392 .71683 L
s
.83 .24 .1 r
.28547 .45704 m
.2939 .48153 L
s
.2939 .48153 m
.33031 .47541 L
s
.33031 .47541 m
.33704 .50204 L
s
.33704 .50204 m
.37368 .49603 L
s
.24 .35 .67 r
.69267 .61457 m
.6877 .59129 L
s
.6877 .59129 m
.6811 .57022 L
s
.44262 .50083 m
.42394 .52068 L
s
.83 .24 .1 r
.34541 .55758 m
.38213 .55184 L
s
.34541 .55758 m
.34677 .58464 L
s
.24 .35 .67 r
.48259 .75129 m
.47206 .73327 L
s
.48259 .75129 m
.50473 .76347 L
s
.57081 .45753 m
.54367 .45737 L
s
.54367 .45737 m
.53431 .43372 L
s
.83 .24 .1 r
.3102 .59022 m
.34677 .58464 L
s
.3102 .59022 m
.30921 .6155 L
s
.23906 .44185 m
.24917 .46327 L
s
.24917 .46327 m
.28547 .45704 L
s
.24 .35 .67 r
.69145 .6836 m
.69818 .65903 L
s
.69818 .65903 m
.69177 .63921 L
s
.83 .24 .1 r
.37368 .49603 m
.37874 .52387 L
s
.37874 .52387 m
.38213 .55184 L
s
.24 .35 .67 r
.41199 .58786 m
.40819 .61202 L
s
.83 .24 .1 r
.32213 .45075 m
.33031 .47541 L
s
.33031 .47541 m
.36709 .46924 L
s
.36709 .46924 m
.37368 .49603 L
s
.37368 .49603 m
.41068 .48996 L
s
.24 .35 .67 r
.64787 .50913 m
.62797 .4951 L
s
.62797 .4951 m
.6202 .47208 L
s
.83 .24 .1 r
.27268 .62095 m
.30921 .6155 L
s
.27268 .62095 m
.26911 .64356 L
s
.38213 .55184 m
.38371 .57901 L
s
.24 .35 .67 r
.42183 .6558 m
.41008 .63586 L
s
.42183 .6558 m
.42951 .67808 L
s
.83 .24 .1 r
.34677 .58464 m
.38371 .57901 L
s
.34677 .58464 m
.34612 .61 L
s
.24 .35 .67 r
.59666 .46246 m
.57081 .45753 L
s
.57081 .45753 m
.56192 .43375 L
s
.83 .24 .1 r
.27572 .43545 m
.28547 .45704 L
s
.28547 .45704 m
.32213 .45075 L
s
.24 .35 .67 r
.6811 .57022 m
.67054 .54912 L
s
.67054 .54912 m
.66357 .52708 L
s
.822 .232 .1 r
.43007 .53748 m .41331 .54012 L .42129 .5171 L p F P
0 0 0 r
s
.24 .35 .67 r
.42327 .52171 m
.42394 .52068 L
s
.787 .22 .095 r
.41331 .54012 m .43007 .53748 L .42516 .55954 L p F P
0 0 0 r
s
.787 .22 .095 r
.42516 .55954 m .40724 .5623 L .41331 .54012 L p F P
0 0 0 r
s
.24 .35 .67 r
.41907 .56048 m
.42117 .56435 L
s
.322 .464 .871 r
.40799 .53023 m .41331 .54012 L .42129 .5171 L p F P
0 0 0 r
s
.317 .455 .846 r
.41331 .54012 m .40799 .53023 L .40149 .55191 L p F P
0 0 0 r
s
.317 .455 .846 r
.40149 .55191 m .40724 .5623 L .41331 .54012 L p F P
0 0 0 r
s
.24 .35 .67 r
.40954 .5429 m
.4122 .5478 L
s
.83 .24 .1 r
.38213 .55184 m
.40246 .54866 L
s
.41084 .54736 m
.41922 .54605 L
s
.853 .242 .104 r
.43651 .51466 m .42129 .5171 L .43103 .49365 L p F P
0 0 0 r
s
.822 .232 .1 r
.42129 .5171 m .43651 .51466 L .43007 .53748 L p F P
0 0 0 r
s
.323 .468 .885 r
.41652 .50795 m .42129 .5171 L .43103 .49365 L p F P
0 0 0 r
s
.322 .464 .871 r
.42129 .5171 m .41652 .50795 L .40799 .53023 L p F P
0 0 0 r
s
.24 .35 .67 r
.40954 .5429 m
.41925 .52792 L
s
.83 .24 .1 r
.37874 .52387 m
.41249 .51847 L
s
.41068 .48996 m
.41476 .51256 L
s
.41687 .52713 m
.41922 .54605 L
s
.35918 .4444 m
.36709 .46924 L
s
.36709 .46924 m
.40424 .463 L
s
.40424 .463 m
.41068 .48996 L
s
.24 .35 .67 r
.45392 .71683 m
.44275 .698 L
s
.45392 .71683 m
.47206 .73327 L
s
.853 .242 .104 r
.43103 .49365 m .44439 .49147 L .43651 .51466 L p F P
0 0 0 r
s
.24 .35 .67 r
.44178 .49914 m
.44262 .50083 L
s
.853 .242 .104 r
.45181 .51221 m .43651 .51466 L .44439 .49147 L p F P
0 0 0 r
s
.822 .232 .1 r
.43651 .51466 m .45181 .51221 L .4469 .53484 L p F P
0 0 0 r
s
.822 .232 .1 r
.4469 .53484 m .43007 .53748 L .43651 .51466 L p F P
0 0 0 r
s
.787 .22 .095 r
.43007 .53748 m .4469 .53484 L .44317 .55676 L p F P
0 0 0 r
s
.787 .22 .095 r
.44317 .55676 m .42516 .55954 L .43007 .53748 L p F P
0 0 0 r
s
.24 .35 .67 r
.50473 .76347 m
.49453 .74552 L
s
.50473 .76347 m
.53016 .77082 L
s
.747 .207 .089 r
.40724 .5623 m .42516 .55954 L .42189 .58042 L p F P
0 0 0 r
s
.747 .207 .089 r
.42189 .58042 m .4032 .58325 L .40724 .5623 L p F P
0 0 0 r
s
.24 .35 .67 r
.40892 .58239 m
.41199 .58786 L
s
.307 .437 .803 r
.40724 .5623 m .40149 .55191 L .39716 .57261 L p F P
0 0 0 r
s
.307 .437 .803 r
.39716 .57261 m .4032 .58325 L .40724 .5623 L p F P
0 0 0 r
s
.882 .252 .108 r
.44439 .49147 m .43103 .49365 L .44239 .47016 L p F P
0 0 0 r
s
.321 .468 .89 r
.42693 .48547 m .43103 .49365 L .44239 .47016 L p F P
0 0 0 r
s
.323 .468 .885 r
.43103 .49365 m .42693 .48547 L .41652 .50795 L p F P
0 0 0 r
s
.83 .24 .1 r
.41068 .48996 m
.42602 .48744 L
s
.30921 .6155 m
.34612 .61 L
s
.30921 .6155 m
.30608 .63817 L
s
.41922 .54605 m
.42103 .57332 L
s
.24 .35 .67 r
.6861 .59372 m
.69267 .61457 L
s
.69177 .63921 m
.69267 .61457 L
s
.83 .24 .1 r
.4042 .57589 m
.42103 .57332 L
s
.38371 .57901 m
.39943 .57661 L
s
.38371 .57901 m
.3834 .60445 L
s
.24 .35 .67 r
.67899 .70718 m
.69145 .6836 L
s
.69145 .6836 m
.68485 .66408 L
s
.853 .242 .104 r
.44439 .49147 m .4578 .48928 L .45181 .51221 L p F P
0 0 0 r
s
.853 .242 .104 r
.46716 .50975 m .45181 .51221 L .4578 .48928 L p F P
0 0 0 r
s
.822 .232 .1 r
.45181 .51221 m .46716 .50975 L .46381 .53218 L p F P
0 0 0 r
s
.822 .232 .1 r
.46381 .53218 m .4469 .53484 L .45181 .51221 L p F P
0 0 0 r
s
.83 .24 .1 r
.42046 .51719 m
.45309 .51197 L
s
.882 .252 .108 r
.44239 .47016 m .45356 .4683 L .44439 .49147 L p F P
0 0 0 r
s
.882 .252 .108 r
.4578 .48928 m .44439 .49147 L .45356 .4683 L p F P
0 0 0 r
s
.83 .24 .1 r
.43376 .48617 m
.44807 .48382 L
s
.31276 .42897 m
.32213 .45075 L
s
.32213 .45075 m
.35918 .4444 L
s
.787 .22 .095 r
.4469 .53484 m .46381 .53218 L .46126 .55397 L p F P
0 0 0 r
s
.787 .22 .095 r
.46126 .55397 m .44317 .55676 L .4469 .53484 L p F P
0 0 0 r
s
.83 .24 .1 r
.41922 .54605 m
.45669 .54019 L
s
.747 .207 .089 r
.42516 .55954 m .44317 .55676 L .44068 .57757 L p F P
0 0 0 r
s
.747 .207 .089 r
.44068 .57757 m .42189 .58042 L .42516 .55954 L p F P
0 0 0 r
s
.83 .24 .1 r
.44807 .48382 m
.45309 .51197 L
s
.45309 .51197 m
.45669 .54019 L
s
.22786 .4242 m
.23906 .44185 L
s
.23906 .44185 m
.27572 .43545 L
s
.882 .252 .108 r
.45356 .4683 m .46477 .46644 L .4578 .48928 L p F P
0 0 0 r
s
.24 .35 .67 r
.46153 .47705 m
.46482 .48405 L
s
.882 .252 .108 r
.47125 .48708 m .4578 .48928 L .46477 .46644 L p F P
0 0 0 r
s
.853 .242 .104 r
.4578 .48928 m .47125 .48708 L .46716 .50975 L p F P
0 0 0 r
s
.853 .242 .104 r
.48258 .50728 m .46716 .50975 L .47125 .48708 L p F P
0 0 0 r
s
.822 .232 .1 r
.46716 .50975 m .48258 .50728 L .4808 .52951 L p F P
0 0 0 r
s
.822 .232 .1 r
.4808 .52951 m .46381 .53218 L .46716 .50975 L p F P
0 0 0 r
s
.83 .24 .1 r
.3966 .43798 m
.40424 .463 L
s
.24 .35 .67 r
.6202 .47208 m
.59666 .46246 L
s
.787 .22 .095 r
.46381 .53218 m .4808 .52951 L .47945 .55116 L p F P
0 0 0 r
s
.787 .22 .095 r
.47945 .55116 m .46126 .55397 L .46381 .53218 L p F P
0 0 0 r
s
.24 .35 .67 r
.50645 .43843 m
.47934 .44764 L
s
.7 .192 .083 r
.4032 .58325 m .42189 .58042 L .42034 .59975 L p F P
0 0 0 r
s
.7 .192 .083 r
.42034 .59975 m .40129 .60259 L .4032 .58325 L p F P
0 0 0 r
s
.288 .406 .735 r
.4032 .58325 m .39716 .57261 L .39511 .59192 L p F P
0 0 0 r
s
.288 .406 .735 r
.39511 .59192 m .40129 .60259 L .4032 .58325 L p F P
0 0 0 r
s
.91 .262 .112 r
.45356 .4683 m .44239 .47016 L .45518 .44706 L p F P
0 0 0 r
s
.317 .464 .889 r
.43903 .46321 m .44239 .47016 L .45518 .44706 L p F P
0 0 0 r
s
.24 .35 .67 r
.4541 .46124 m
.45714 .46771 L
s
.83 .24 .1 r
.44358 .46449 m
.44807 .48382 L
s
.44178 .45669 m
.44249 .45975 L
s
.24 .35 .67 r
.45413 .46093 m
.47934 .44764 L
s
.83 .24 .1 r
.40424 .463 m
.44178 .45669 L
s
.321 .468 .89 r
.44239 .47016 m .43903 .46321 L .42693 .48547 L p F P
0 0 0 r
s
.747 .207 .089 r
.44317 .55676 m .46126 .55397 L .45956 .57471 L p F P
0 0 0 r
s
.747 .207 .089 r
.45956 .57471 m .44068 .57757 L .44317 .55676 L p F P
0 0 0 r
s
.83 .24 .1 r
.34612 .61 m
.3834 .60445 L
s
.34612 .61 m
.34342 .63272 L
s
.45669 .54019 m
.45874 .56757 L
s
.24 .35 .67 r
.66357 .52708 m
.64787 .50913 L
s
.64787 .50913 m
.6404 .48613 L
s
.323 .468 .885 r
.41169 .49865 m .41652 .50795 L .42693 .48547 L p F P
0 0 0 r
s
.322 .464 .871 r
.41652 .50795 m .41169 .49865 L .40258 .52016 L p F P
0 0 0 r
s
.322 .464 .871 r
.40258 .52016 m .40799 .53023 L .41652 .50795 L p F P
0 0 0 r
s
.882 .252 .108 r
.46477 .46644 m .47601 .46458 L .47125 .48708 L p F P
0 0 0 r
s
.882 .252 .108 r
.48476 .48488 m .47125 .48708 L .47601 .46458 L p F P
0 0 0 r
s
.853 .242 .104 r
.47125 .48708 m .48476 .48488 L .48258 .50728 L p F P
0 0 0 r
s
.853 .242 .104 r
.49807 .5048 m .48258 .50728 L .48476 .48488 L p F P
0 0 0 r
s
.822 .232 .1 r
.48258 .50728 m .49807 .5048 L .49787 .52683 L p F P
0 0 0 r
s
.822 .232 .1 r
.49787 .52683 m .4808 .52951 L .48258 .50728 L p F P
0 0 0 r
s
.83 .24 .1 r
.45309 .51197 m
.49083 .50592 L
s
.24 .35 .67 r
.53431 .43372 m
.50645 .43843 L
s
.83 .24 .1 r
.42103 .57332 m
.45874 .56757 L
s
.317 .455 .846 r
.40799 .53023 m .40258 .52016 L .39564 .54133 L p F P
0 0 0 r
s
.317 .455 .846 r
.39564 .54133 m .40149 .55191 L .40799 .53023 L p F P
0 0 0 r
s
.91 .262 .112 r
.45518 .44706 m .46389 .44559 L .45356 .4683 L p F P
0 0 0 r
s
.91 .262 .112 r
.46477 .46644 m .45356 .4683 L .46389 .44559 L p F P
0 0 0 r
s
.787 .22 .095 r
.4808 .52951 m .49787 .52683 L .49772 .54834 L p F P
0 0 0 r
s
.787 .22 .095 r
.49772 .54834 m .47945 .55116 L .4808 .52951 L p F P
0 0 0 r
s
.83 .24 .1 r
.45669 .54019 m
.49455 .53428 L
s
.321 .468 .89 r
.42277 .47719 m .42693 .48547 L .43903 .46321 L p F P
0 0 0 r
s
.24 .35 .67 r
.43133 .47804 m
.44752 .46587 L
s
.43133 .47804 m
.43569 .48683 L
s
.323 .468 .885 r
.42693 .48547 m .42277 .47719 L .41169 .49865 L p F P
0 0 0 r
s
.24 .35 .67 r
.42951 .67808 m
.41777 .65834 L
s
.42951 .67808 m
.44275 .698 L
s
.83 .24 .1 r
.35019 .42243 m
.35918 .4444 L
s
.35918 .4444 m
.3966 .43798 L
s
.26911 .64356 m
.30608 .63817 L
s
.26911 .64356 m
.26334 .66268 L
s
.882 .252 .108 r
.47601 .46458 m .48728 .4627 L .48476 .48488 L p F P
0 0 0 r
s
.882 .252 .108 r
.49831 .48267 m .48476 .48488 L .48728 .4627 L p F P
0 0 0 r
s
.853 .242 .104 r
.48476 .48488 m .49831 .48267 L .49807 .5048 L p F P
0 0 0 r
s
.83 .24 .1 r
.44807 .48382 m
.48583 .47763 L
s
.747 .207 .089 r
.46126 .55397 m .47945 .55116 L .47854 .57184 L p F P
0 0 0 r
s
.747 .207 .089 r
.47854 .57184 m .45956 .57471 L .46126 .55397 L p F P
0 0 0 r
s
.7 .192 .083 r
.42189 .58042 m .44068 .57757 L .4395 .5969 L p F P
0 0 0 r
s
.7 .192 .083 r
.4395 .5969 m .42034 .59975 L .42189 .58042 L p F P
0 0 0 r
s
.24 .35 .67 r
.53016 .77082 m
.52037 .75287 L
s
.53016 .77082 m
.55768 .77285 L
s
.83 .24 .1 r
.49083 .50592 m
.49455 .53428 L
s
.91 .262 .112 r
.46389 .44559 m .47261 .44412 L .46477 .46644 L p F P
0 0 0 r
s
.91 .262 .112 r
.47601 .46458 m .46477 .46644 L .47261 .44412 L p F P
0 0 0 r
s
.853 .242 .104 r
.51362 .50231 m .49807 .5048 L .49831 .48267 L p F P
0 0 0 r
s
.822 .232 .1 r
.49807 .5048 m .51362 .50231 L .51502 .52413 L p F P
0 0 0 r
s
.822 .232 .1 r
.51502 .52413 m .49787 .52683 L .49807 .5048 L p F P
0 0 0 r
s
.83 .24 .1 r
.26498 .41761 m
.27572 .43545 L
s
.27572 .43545 m
.31276 .42897 L
s
.24 .35 .67 r
.6861 .59372 m
.6811 .57022 L
s
.6811 .57022 m
.67425 .54833 L
s
.66127 .72857 m
.67899 .70718 L
s
.67899 .70718 m
.67209 .68796 L
s
.83 .24 .1 r
.44178 .45669 m
.44631 .45593 L
s
.787 .22 .095 r
.49787 .52683 m .51502 .52413 L .51609 .54551 L p F P
0 0 0 r
s
.787 .22 .095 r
.51609 .54551 m .49772 .54834 L .49787 .52683 L p F P
0 0 0 r
s
.882 .252 .108 r
.48728 .4627 m .49859 .46083 L .49831 .48267 L p F P
0 0 0 r
s
.83 .24 .1 r
.48583 .47763 m
.49083 .50592 L
s
.882 .252 .108 r
.51192 .48045 m .49831 .48267 L .49859 .46083 L p F P
0 0 0 r
s
.853 .242 .104 r
.49831 .48267 m .51192 .48045 L .51362 .50231 L p F P
0 0 0 r
s
.307 .437 .803 r
.40149 .55191 m .39564 .54133 L .391 .56176 L p F P
0 0 0 r
s
.307 .437 .803 r
.391 .56176 m .39716 .57261 L .40149 .55191 L p F P
0 0 0 r
s
.24 .35 .67 r
.40008 .56666 m
.40954 .5429 L
s
.40008 .56666 m
.4055 .5763 L
s
.91 .262 .112 r
.47261 .44412 m .48135 .44264 L .47601 .46458 L p F P
0 0 0 r
s
.91 .262 .112 r
.48728 .4627 m .47601 .46458 L .48135 .44264 L p F P
0 0 0 r
s
.24 .35 .67 r
.47206 .73327 m
.46112 .71456 L
s
.47206 .73327 m
.49453 .74552 L
s
.56192 .43375 m
.53431 .43372 L
s
.747 .207 .089 r
.47945 .55116 m .49772 .54834 L .49762 .56895 L p F P
0 0 0 r
s
.747 .207 .089 r
.49762 .56895 m .47854 .57184 L .47945 .55116 L p F P
0 0 0 r
s
.7 .192 .083 r
.44068 .57757 m .45956 .57471 L .45876 .59403 L p F P
0 0 0 r
s
.7 .192 .083 r
.45876 .59403 m .4395 .5969 L .44068 .57757 L p F P
0 0 0 r
s
.853 .242 .104 r
.52924 .49981 m .51362 .50231 L .51192 .48045 L p F P
0 0 0 r
s
.822 .232 .1 r
.51362 .50231 m .52924 .49981 L .53225 .52142 L p F P
0 0 0 r
s
.822 .232 .1 r
.53225 .52142 m .51502 .52413 L .51362 .50231 L p F P
0 0 0 r
s
.83 .24 .1 r
.49083 .50592 m
.52897 .49981 L
s
.3834 .60445 m
.38116 .62721 L
s
.49455 .53428 m
.49683 .56176 L
s
.317 .464 .889 r
.45518 .44706 m .45263 .44156 L .43903 .46321 L p F P
0 0 0 r
s
.317 .464 .889 r
.43564 .45617 m .43903 .46321 L .45263 .44156 L p F P
0 0 0 r
s
.83 .24 .1 r
.44936 .45542 m
.4797 .45032 L
s
.321 .468 .89 r
.43903 .46321 m .43564 .45617 L .42277 .47719 L p F P
0 0 0 r
s
.91 .262 .112 r
.48135 .44264 m .49012 .44116 L .48728 .4627 L p F P
0 0 0 r
s
.83 .24 .1 r
.4797 .45032 m
.48583 .47763 L
s
.91 .262 .112 r
.49859 .46083 m .48728 .4627 L .49012 .44116 L p F P
0 0 0 r
s
.882 .252 .108 r
.49859 .46083 m .50993 .45894 L .51192 .48045 L p F P
0 0 0 r
s
.882 .252 .108 r
.52557 .47822 m .51192 .48045 L .50993 .45894 L p F P
0 0 0 r
s
.853 .242 .104 r
.51192 .48045 m .52557 .47822 L .52924 .49981 L p F P
0 0 0 r
s
.83 .24 .1 r
.45874 .56757 m
.49683 .56176 L
s
.24 .35 .67 r
.68485 .66408 m
.69177 .63921 L
s
.69177 .63921 m
.68511 .61862 L
s
.787 .22 .095 r
.51502 .52413 m .53225 .52142 L .53454 .54266 L p F P
0 0 0 r
s
.787 .22 .095 r
.53454 .54266 m .51609 .54551 L .51502 .52413 L p F P
0 0 0 r
s
.642 .174 .075 r
.40129 .60259 m .42034 .59975 L .42059 .61713 L p F P
0 0 0 r
s
.24 .35 .67 r
.40385 .60451 m
.40819 .61202 L
s
.642 .174 .075 r
.42059 .61713 m .40159 .61991 L .40129 .60259 L p F P
0 0 0 r
s
.24 .35 .67 r
.40873 .61886 m
.41008 .63586 L
s
.257 .356 .631 r
.40129 .60259 m .39511 .59192 L .39543 .60945 L p F P
0 0 0 r
s
.83 .24 .1 r
.3834 .60445 m
.3953 .60267 L
s
.257 .356 .631 r
.39543 .60945 m .40159 .61991 L .40129 .60259 L p F P
0 0 0 r
s
.937 .271 .116 r
.46389 .44559 m .45518 .44706 L .46921 .42478 L p F P
0 0 0 r
s
.311 .457 .882 r
.45263 .44156 m .45518 .44706 L .46921 .42478 L p F P
0 0 0 r
s
.853 .242 .104 r
.54492 .4973 m .52924 .49981 L .52557 .47822 L p F P
0 0 0 r
s
.822 .232 .1 r
.52924 .49981 m .54492 .4973 L .54955 .5187 L p F P
0 0 0 r
s
.822 .232 .1 r
.54955 .5187 m .53225 .52142 L .52924 .49981 L p F P
0 0 0 r
s
.83 .24 .1 r
.388 .41582 m
.3966 .43798 L
s
.747 .207 .089 r
.49772 .54834 m .51609 .54551 L .5168 .56604 L p F P
0 0 0 r
s
.747 .207 .089 r
.5168 .56604 m .49762 .56895 L .49772 .54834 L p F P
0 0 0 r
s
.83 .24 .1 r
.30608 .63817 m
.34342 .63272 L
s
.30608 .63817 m
.30083 .6573 L
s
.91 .262 .112 r
.49012 .44116 m .49891 .43968 L .49859 .46083 L p F P
0 0 0 r
s
.91 .262 .112 r
.50993 .45894 m .49859 .46083 L .49891 .43968 L p F P
0 0 0 r
s
.7 .192 .083 r
.45956 .57471 m .47854 .57184 L .47811 .59115 L p F P
0 0 0 r
s
.7 .192 .083 r
.47811 .59115 m .45876 .59403 L .45956 .57471 L p F P
0 0 0 r
s
.882 .252 .108 r
.50993 .45894 m .52131 .45705 L .52557 .47822 L p F P
0 0 0 r
s
.882 .252 .108 r
.53927 .47599 m .52557 .47822 L .52131 .45705 L p F P
0 0 0 r
s
.83 .24 .1 r
.48583 .47763 m
.52399 .47136 L
s
.853 .242 .104 r
.52557 .47822 m .53927 .47599 L .54492 .4973 L p F P
0 0 0 r
s
.83 .24 .1 r
.52399 .47136 m
.52897 .49981 L
s
.323 .468 .885 r
.40677 .4892 m .41169 .49865 L .42277 .47719 L p F P
0 0 0 r
s
.24 .35 .67 r
.41223 .49814 m
.42247 .51787 L
s
.322 .464 .871 r
.41169 .49865 m .40677 .4892 L .39708 .50992 L p F P
0 0 0 r
s
.322 .464 .871 r
.39708 .50992 m .40258 .52016 L .41169 .49865 L p F P
0 0 0 r
s
.937 .271 .116 r
.46921 .42478 m .4752 .42375 L .46389 .44559 L p F P
0 0 0 r
s
.937 .271 .116 r
.47261 .44412 m .46389 .44559 L .4752 .42375 L p F P
0 0 0 r
s
.83 .24 .1 r
.30249 .41095 m
.31276 .42897 L
s
.31276 .42897 m
.35019 .42243 L
s
.321 .468 .89 r
.41856 .46878 m .42277 .47719 L .43564 .45617 L p F P
0 0 0 r
s
.323 .468 .885 r
.42277 .47719 m .41856 .46878 L .40677 .4892 L p F P
0 0 0 r
s
.24 .35 .67 r
.41223 .49814 m
.43133 .47804 L
s
.787 .22 .095 r
.53225 .52142 m .54955 .5187 L .55309 .5398 L p F P
0 0 0 r
s
.787 .22 .095 r
.55309 .5398 m .53454 .54266 L .53225 .52142 L p F P
0 0 0 r
s
.83 .24 .1 r
.49455 .53428 m
.53279 .5283 L
s
.52897 .49981 m
.53279 .5283 L
s
.24 .35 .67 r
.55768 .77285 m
.54838 .75484 L
s
.55768 .77285 m
.58596 .76938 L
s
.91 .262 .112 r
.49891 .43968 m .50771 .43819 L .50993 .45894 L p F P
0 0 0 r
s
.91 .262 .112 r
.52131 .45705 m .50993 .45894 L .50771 .43819 L p F P
0 0 0 r
s
.853 .242 .104 r
.56067 .49478 m .54492 .4973 L .53927 .47599 L p F P
0 0 0 r
s
.822 .232 .1 r
.54492 .4973 m .56067 .49478 L .56694 .51597 L p F P
0 0 0 r
s
.822 .232 .1 r
.56694 .51597 m .54955 .5187 L .54492 .4973 L p F P
0 0 0 r
s
.937 .271 .116 r
.4752 .42375 m .4812 .42272 L .47261 .44412 L p F P
0 0 0 r
s
.24 .35 .67 r
.47506 .43801 m
.47742 .44331 L
s
.937 .271 .116 r
.48135 .44264 m .47261 .44412 L .4812 .42272 L p F P
0 0 0 r
s
.83 .24 .1 r
.47262 .42494 m
.4797 .45032 L
s
.288 .406 .735 r
.39716 .57261 m .391 .56176 L .38881 .58104 L p F P
0 0 0 r
s
.288 .406 .735 r
.38881 .58104 m .39511 .59192 L .39716 .57261 L p F P
0 0 0 r
s
.24 .35 .67 r
.39608 .59107 m
.40008 .56666 L
s
.39608 .59107 m
.40262 .60239 L
s
.6391 .74666 m
.66127 .72857 L
s
.66127 .72857 m
.65399 .70967 L
s
.41008 .63586 m
.41777 .65834 L
s
.642 .174 .075 r
.42034 .59975 m .4395 .5969 L .43968 .61433 L p F P
0 0 0 r
s
.83 .24 .1 r
.42103 .57332 m
.42107 .59883 L
s
.642 .174 .075 r
.43968 .61433 m .42059 .61713 L .42034 .59975 L p F P
0 0 0 r
s
.83 .24 .1 r
.40086 .60185 m
.42107 .59883 L
s
.882 .252 .108 r
.52131 .45705 m .53273 .45516 L .53927 .47599 L p F P
0 0 0 r
s
.882 .252 .108 r
.55303 .47374 m .53927 .47599 L .53273 .45516 L p F P
0 0 0 r
s
.853 .242 .104 r
.53927 .47599 m .55303 .47374 L .56067 .49478 L p F P
0 0 0 r
s
.317 .455 .846 r
.40258 .52016 m .39708 .50992 L .38967 .53055 L p F P
0 0 0 r
s
.317 .455 .846 r
.38967 .53055 m .39564 .54133 L .40258 .52016 L p F P
0 0 0 r
s
.24 .35 .67 r
.39746 .52061 m
.40954 .5429 L
s
.747 .207 .089 r
.51609 .54551 m .53454 .54266 L .53608 .56312 L p F P
0 0 0 r
s
.747 .207 .089 r
.53608 .56312 m .5168 .56604 L .51609 .54551 L p F P
0 0 0 r
s
.7 .192 .083 r
.47854 .57184 m .49762 .56895 L .49757 .58825 L p F P
0 0 0 r
s
.7 .192 .083 r
.49757 .58825 m .47811 .59115 L .47854 .57184 L p F P
0 0 0 r
s
.91 .262 .112 r
.50771 .43819 m .51654 .4367 L .52131 .45705 L p F P
0 0 0 r
s
.91 .262 .112 r
.53273 .45516 m .52131 .45705 L .51654 .4367 L p F P
0 0 0 r
s
.937 .271 .116 r
.4812 .42272 m .4872 .42169 L .48135 .44264 L p F P
0 0 0 r
s
.937 .271 .116 r
.49012 .44116 m .48135 .44264 L .4872 .42169 L p F P
0 0 0 r
s
.787 .22 .095 r
.54955 .5187 m .56694 .51597 L .57173 .53692 L p F P
0 0 0 r
s
.787 .22 .095 r
.57173 .53692 m .55309 .5398 L .54955 .5187 L p F P
0 0 0 r
s
.317 .464 .889 r
.45263 .44156 m .45006 .436 L .43564 .45617 L p F P
0 0 0 r
s
.317 .464 .889 r
.4322 .44906 m .43564 .45617 L .45006 .436 L p F P
0 0 0 r
s
.83 .24 .1 r
.43442 .43149 m
.43825 .44463 L
s
.3966 .43798 m
.43442 .43149 L
s
.321 .468 .89 r
.43564 .45617 m .4322 .44906 L .41856 .46878 L p F P
0 0 0 r
s
.853 .242 .104 r
.57648 .49224 m .56067 .49478 L .55303 .47374 L p F P
0 0 0 r
s
.822 .232 .1 r
.56067 .49478 m .57648 .49224 L .58441 .51322 L p F P
0 0 0 r
s
.822 .232 .1 r
.58441 .51322 m .56694 .51597 L .56067 .49478 L p F P
0 0 0 r
s
.83 .24 .1 r
.52897 .49981 m
.5675 .49364 L
s
.311 .457 .882 r
.46921 .42478 m .4675 .42094 L .45263 .44156 L p F P
0 0 0 r
s
.311 .457 .882 r
.45006 .436 m .45263 .44156 L .4675 .42094 L p F P
0 0 0 r
s
.882 .252 .108 r
.53273 .45516 m .54417 .45326 L .55303 .47374 L p F P
0 0 0 r
s
.882 .252 .108 r
.56683 .47149 m .55303 .47374 L .54417 .45326 L p F P
0 0 0 r
s
.853 .242 .104 r
.55303 .47374 m .56683 .47149 L .57648 .49224 L p F P
0 0 0 r
s
.24 .35 .67 r
.67425 .54833 m
.66357 .52708 L
s
.937 .271 .116 r
.4872 .42169 m .49322 .42066 L .49012 .44116 L p F P
0 0 0 r
s
.937 .271 .116 r
.49891 .43968 m .49012 .44116 L .49322 .42066 L p F P
0 0 0 r
s
.91 .262 .112 r
.51654 .4367 m .52539 .4352 L .53273 .45516 L p F P
0 0 0 r
s
.83 .24 .1 r
.51802 .44389 m
.52399 .47136 L
s
.4797 .45032 m
.51802 .44389 L
s
.91 .262 .112 r
.54417 .45326 m .53273 .45516 L .52539 .4352 L p F P
0 0 0 r
s
.83 .24 .1 r
.21593 .41113 m
.22786 .4242 L
s
.22786 .4242 m
.26498 .41761 L
s
.642 .174 .075 r
.4395 .5969 m .45876 .59403 L .45888 .61151 L p F P
0 0 0 r
s
.642 .174 .075 r
.45888 .61151 m .43968 .61433 L .4395 .5969 L p F P
0 0 0 r
s
.747 .207 .089 r
.53454 .54266 m .55309 .5398 L .55545 .56018 L p F P
0 0 0 r
s
.747 .207 .089 r
.55545 .56018 m .53608 .56312 L .53454 .54266 L p F P
0 0 0 r
s
.83 .24 .1 r
.53279 .5283 m
.53532 .55589 L
s
.49683 .56176 m
.53532 .55589 L
s
.24 .35 .67 r
.58596 .76938 m
.57718 .75122 L
s
.58596 .76938 m
.61357 .7605 L
s
.83 .24 .1 r
.34342 .63272 m
.38116 .62721 L
s
.34342 .63272 m
.33871 .65187 L
s
.7 .192 .083 r
.49762 .56895 m .5168 .56604 L .51714 .58533 L p F P
0 0 0 r
s
.7 .192 .083 r
.51714 .58533 m .49757 .58825 L .49762 .56895 L p F P
0 0 0 r
s
.24 .35 .67 r
.61357 .7605 m
.6391 .74666 L
s
.6391 .74666 m
.63136 .72805 L
s
.937 .271 .116 r
.49322 .42066 m .49925 .41963 L .49891 .43968 L p F P
0 0 0 r
s
.24 .35 .67 r
.4969 .41566 m
.4986 .41974 L
s
.937 .271 .116 r
.50771 .43819 m .49891 .43968 L .49925 .41963 L p F P
0 0 0 r
s
.24 .35 .67 r
.44275 .698 m
.43113 .67842 L
s
.44275 .698 m
.46112 .71456 L
s
.787 .22 .095 r
.56694 .51597 m .58441 .51322 L .59047 .53403 L p F P
0 0 0 r
s
.787 .22 .095 r
.59047 .53403 m .57173 .53692 L .56694 .51597 L p F P
0 0 0 r
s
.83 .24 .1 r
.53279 .5283 m
.57143 .52226 L
s
.5675 .49364 m
.57143 .52226 L
s
.882 .252 .108 r
.54417 .45326 m .55566 .45135 L .56683 .47149 L p F P
0 0 0 r
s
.882 .252 .108 r
.58069 .46923 m .56683 .47149 L .55566 .45135 L p F P
0 0 0 r
s
.83 .24 .1 r
.52399 .47136 m
.56254 .46504 L
s
.853 .242 .104 r
.56683 .47149 m .58069 .46923 L .59236 .4897 L p F P
0 0 0 r
s
.853 .242 .104 r
.59236 .4897 m .57648 .49224 L .56683 .47149 L p F P
0 0 0 r
s
.83 .24 .1 r
.56254 .46504 m
.5675 .49364 L
s
.307 .437 .803 r
.39564 .54133 m .38967 .53055 L .38472 .5507 L p F P
0 0 0 r
s
.307 .437 .803 r
.38472 .5507 m .391 .56176 L .39564 .54133 L p F P
0 0 0 r
s
.822 .232 .1 r
.57648 .49224 m .59236 .4897 L .60196 .51046 L p F P
0 0 0 r
s
.822 .232 .1 r
.60196 .51046 m .58441 .51322 L .57648 .49224 L p F P
0 0 0 r
s
.83 .24 .1 r
.3404 .40422 m
.35019 .42243 L
s
.35019 .42243 m
.388 .41582 L
s
.91 .262 .112 r
.52539 .4352 m .53426 .4337 L .54417 .45326 L p F P
0 0 0 r
s
.91 .262 .112 r
.55566 .45135 m .54417 .45326 L .53426 .4337 L p F P
0 0 0 r
s
.24 .35 .67 r
.61357 .7605 m
.60532 .74214 L
s
.49453 .74552 m
.48393 .72687 L
s
.49453 .74552 m
.52037 .75287 L
s
.937 .271 .116 r
.49925 .41963 m .50529 .41859 L .50771 .43819 L p F P
0 0 0 r
s
.937 .271 .116 r
.51654 .4367 m .50771 .43819 L .50529 .41859 L p F P
0 0 0 r
s
.747 .207 .089 r
.55309 .5398 m .57173 .53692 L .57493 .55723 L p F P
0 0 0 r
s
.747 .207 .089 r
.57493 .55723 m .55545 .56018 L .55309 .5398 L p F P
0 0 0 r
s
.642 .174 .075 r
.45876 .59403 m .47811 .59115 L .47818 .60869 L p F P
0 0 0 r
s
.83 .24 .1 r
.45874 .56757 m
.45914 .59316 L
s
.642 .174 .075 r
.47818 .60869 m .45888 .61151 L .45876 .59403 L p F P
0 0 0 r
s
.83 .24 .1 r
.42107 .59883 m
.45914 .59316 L
s
.24 .35 .67 r
.67927 .57204 m
.6861 .59372 L
s
.68511 .61862 m
.6861 .59372 L
s
.91 .262 .112 r
.53426 .4337 m .54315 .4322 L .55566 .45135 L p F P
0 0 0 r
s
.91 .262 .112 r
.56718 .44943 m .55566 .45135 L .54315 .4322 L p F P
0 0 0 r
s
.882 .252 .108 r
.55566 .45135 m .56718 .44943 L .58069 .46923 L p F P
0 0 0 r
s
.882 .252 .108 r
.5946 .46696 m .58069 .46923 L .56718 .44943 L p F P
0 0 0 r
s
.853 .242 .104 r
.58069 .46923 m .5946 .46696 L .60831 .48715 L p F P
0 0 0 r
s
.853 .242 .104 r
.60831 .48715 m .59236 .4897 L .58069 .46923 L p F P
0 0 0 r
s
.7 .192 .083 r
.5168 .56604 m .53608 .56312 L .5368 .58241 L p F P
0 0 0 r
s
.7 .192 .083 r
.5368 .58241 m .51714 .58533 L .5168 .56604 L p F P
0 0 0 r
s
.937 .271 .116 r
.50529 .41859 m .51133 .41755 L .51654 .4367 L p F P
0 0 0 r
s
.937 .271 .116 r
.52539 .4352 m .51654 .4367 L .51133 .41755 L p F P
0 0 0 r
s
.321 .468 .89 r
.41428 .46027 m .41856 .46878 L .4322 .44906 L p F P
0 0 0 r
s
.323 .468 .885 r
.41856 .46878 m .41428 .46027 L .40178 .4796 L p F P
0 0 0 r
s
.323 .468 .885 r
.40178 .4796 m .40677 .4892 L .41856 .46878 L p F P
0 0 0 r
s
.24 .35 .67 r
.67209 .68796 m
.68485 .66408 L
s
.68485 .66408 m
.678 .64378 L
s
.822 .232 .1 r
.59236 .4897 m .60831 .48715 L .6196 .50769 L p F P
0 0 0 r
s
.822 .232 .1 r
.6196 .50769 m .60196 .51046 L .59236 .4897 L p F P
0 0 0 r
s
.83 .24 .1 r
.5675 .49364 m
.60643 .48741 L
s
.787 .22 .095 r
.58441 .51322 m .60196 .51046 L .6093 .53112 L p F P
0 0 0 r
s
.787 .22 .095 r
.6093 .53112 m .59047 .53403 L .58441 .51322 L p F P
0 0 0 r
s
.311 .457 .882 r
.4675 .42094 m .46578 .41707 L .45006 .436 L p F P
0 0 0 r
s
.83 .24 .1 r
.43442 .43149 m
.45702 .42762 L
s
.46596 .42608 m
.47262 .42494 L
s
.311 .457 .882 r
.44746 .4304 m .45006 .436 L .46578 .41707 L p F P
0 0 0 r
s
.317 .464 .889 r
.45006 .436 m .44746 .4304 L .4322 .44906 L p F P
0 0 0 r
s
.322 .464 .871 r
.40677 .4892 m .40178 .4796 L .39148 .4995 L p F P
0 0 0 r
s
.322 .464 .871 r
.39148 .4995 m .39708 .50992 L .40677 .4892 L p F P
0 0 0 r
s
.24 .35 .67 r
.39746 .52061 m
.41223 .49814 L
s
.568 .15 .065 r
.40159 .61991 m .42059 .61713 L .42266 .63217 L p F P
0 0 0 r
s
.568 .15 .065 r
.42266 .63217 m .40415 .63484 L .40159 .61991 L p F P
0 0 0 r
s
.24 .35 .67 r
.40906 .63413 m
.41008 .63586 L
s
.208 .282 .479 r
.40159 .61991 m .39543 .60945 L .39818 .6248 L p F P
0 0 0 r
s
.208 .282 .479 r
.39818 .6248 m .40415 .63484 L .40159 .61991 L p F P
0 0 0 r
s
.962 .28 .12 r
.4752 .42375 m .46921 .42478 L .48423 .40376 L p F P
0 0 0 r
s
.304 .448 .87 r
.4675 .42094 m .46921 .42478 L .48423 .40376 L p F P
0 0 0 r
s
.24 .35 .67 r
.4686 .42347 m
.4705 .42774 L
s
.937 .271 .116 r
.51133 .41755 m .51739 .41651 L .52539 .4352 L p F P
0 0 0 r
s
.937 .271 .116 r
.53426 .4337 m .52539 .4352 L .51739 .41651 L p F P
0 0 0 r
s
.91 .262 .112 r
.54315 .4322 m .55206 .4307 L .56718 .44943 L p F P
0 0 0 r
s
.91 .262 .112 r
.57873 .44752 m .56718 .44943 L .55206 .4307 L p F P
0 0 0 r
s
.882 .252 .108 r
.56718 .44943 m .57873 .44752 L .5946 .46696 L p F P
0 0 0 r
s
.257 .356 .631 r
.39511 .59192 m .38881 .58104 L .38915 .59877 L p F P
0 0 0 r
s
.257 .356 .631 r
.38915 .59877 m .39543 .60945 L .39511 .59192 L p F P
0 0 0 r
s
.83 .24 .1 r
.26334 .66268 m
.30083 .6573 L
s
.26334 .66268 m
.2555 .67739 L
s
.317 .464 .889 r
.42873 .44186 m .4322 .44906 L .44746 .4304 L p F P
0 0 0 r
s
.24 .35 .67 r
.44275 .43707 m
.45177 .45627 L
s
.321 .468 .89 r
.4322 .44906 m .42873 .44186 L .41428 .46027 L p F P
0 0 0 r
s
.882 .252 .108 r
.60856 .46468 m .5946 .46696 L .57873 .44752 L p F P
0 0 0 r
s
.853 .242 .104 r
.5946 .46696 m .60856 .46468 L .62433 .48458 L p F P
0 0 0 r
s
.853 .242 .104 r
.62433 .48458 m .60831 .48715 L .5946 .46696 L p F P
0 0 0 r
s
.962 .28 .12 r
.48423 .40376 m .48731 .40323 L .4752 .42375 L p F P
0 0 0 r
s
.962 .28 .12 r
.4812 .42272 m .4752 .42375 L .48731 .40323 L p F P
0 0 0 r
s
.747 .207 .089 r
.57173 .53692 m .59047 .53403 L .59451 .55427 L p F P
0 0 0 r
s
.747 .207 .089 r
.59451 .55427 m .57493 .55723 L .57173 .53692 L p F P
0 0 0 r
s
.83 .24 .1 r
.57143 .52226 m
.57422 .54996 L
s
.53532 .55589 m
.57422 .54996 L
s
.2536 .40437 m
.26498 .41761 L
s
.26498 .41761 m
.30249 .41095 L
s
.642 .174 .075 r
.47811 .59115 m .49757 .58825 L .49758 .60584 L p F P
0 0 0 r
s
.642 .174 .075 r
.49758 .60584 m .47818 .60869 L .47811 .59115 L p F P
0 0 0 r
s
.83 .24 .1 r
.40209 .62416 m
.41929 .62165 L
s
.38116 .62721 m
.39817 .62473 L
s
.38116 .62721 m
.37699 .64638 L
s
.937 .271 .116 r
.51739 .41651 m .52346 .41547 L .53426 .4337 L p F P
0 0 0 r
s
.937 .271 .116 r
.54315 .4322 m .53426 .4337 L .52346 .41547 L p F P
0 0 0 r
s
.822 .232 .1 r
.60831 .48715 m .62433 .48458 L .63731 .50491 L p F P
0 0 0 r
s
.822 .232 .1 r
.63731 .50491 m .6196 .50769 L .60831 .48715 L p F P
0 0 0 r
s
.7 .192 .083 r
.53608 .56312 m .55545 .56018 L .55657 .57946 L p F P
0 0 0 r
s
.7 .192 .083 r
.55657 .57946 m .5368 .58241 L .53608 .56312 L p F P
0 0 0 r
s
.83 .24 .1 r
.53532 .55589 m
.53646 .58164 L
s
.787 .22 .095 r
.60196 .51046 m .6196 .50769 L .62822 .5282 L p F P
0 0 0 r
s
.787 .22 .095 r
.62822 .5282 m .6093 .53112 L .60196 .51046 L p F P
0 0 0 r
s
.83 .24 .1 r
.57143 .52226 m
.61048 .51616 L
s
.962 .28 .12 r
.48731 .40323 m .49038 .40269 L .4812 .42272 L p F P
0 0 0 r
s
.962 .28 .12 r
.4872 .42169 m .4812 .42272 L .49038 .40269 L p F P
0 0 0 r
s
.91 .262 .112 r
.55206 .4307 m .561 .42919 L .57873 .44752 L p F P
0 0 0 r
s
.83 .24 .1 r
.51802 .44389 m
.55673 .43739 L
s
.91 .262 .112 r
.59032 .44559 m .57873 .44752 L .561 .42919 L p F P
0 0 0 r
s
.24 .35 .67 r
.57269 .43573 m
.5882 .43858 L
s
.83 .24 .1 r
.55673 .43739 m
.56254 .46504 L
s
.882 .252 .108 r
.57873 .44752 m .59032 .44559 L .60856 .46468 L p F P
0 0 0 r
s
.24 .35 .67 r
.5882 .43858 m
.5909 .44619 L
s
.83 .24 .1 r
.60643 .48741 m
.61048 .51616 L
s
.317 .455 .846 r
.39708 .50992 m .39148 .4995 L .38359 .51957 L p F P
0 0 0 r
s
.317 .455 .846 r
.38359 .51957 m .38967 .53055 L .39708 .50992 L p F P
0 0 0 r
s
.24 .35 .67 r
.4686 .42347 m
.47873 .42001 L
s
.44275 .43707 m
.4686 .42347 L
s
.83 .24 .1 r
.37871 .39742 m
.388 .41582 L
s
.388 .41582 m
.42621 .40915 L
s
.962 .28 .12 r
.49038 .40269 m .49346 .40216 L .4872 .42169 L p F P
0 0 0 r
s
.962 .28 .12 r
.49322 .42066 m .4872 .42169 L .49346 .40216 L p F P
0 0 0 r
s
.882 .252 .108 r
.62257 .4624 m .60856 .46468 L .59032 .44559 L p F P
0 0 0 r
s
.83 .24 .1 r
.6015 .45864 m
.60643 .48741 L
s
.56254 .46504 m
.6015 .45864 L
s
.24 .35 .67 r
.61722 .46327 m
.6202 .47208 L
s
.853 .242 .104 r
.60856 .46468 m .62257 .4624 L .64041 .482 L p F P
0 0 0 r
s
.853 .242 .104 r
.64041 .482 m .62433 .48458 L .60856 .46468 L p F P
0 0 0 r
s
.24 .35 .67 r
.63558 .48278 m
.6404 .48613 L
s
.937 .271 .116 r
.52346 .41547 m .52954 .41443 L .54315 .4322 L p F P
0 0 0 r
s
.24 .35 .67 r
.52523 .41078 m
.52686 .41489 L
s
.937 .271 .116 r
.55206 .4307 m .54315 .4322 L .52954 .41443 L p F P
0 0 0 r
s
.568 .15 .065 r
.42059 .61713 m .43968 .61433 L .44126 .62948 L p F P
0 0 0 r
s
.568 .15 .065 r
.44126 .62948 m .42266 .63217 L .42059 .61713 L p F P
0 0 0 r
s
.83 .24 .1 r
.41929 .62165 m
.42107 .59883 L
s
.288 .406 .735 r
.391 .56176 m .38472 .5507 L .38238 .56995 L p F P
0 0 0 r
s
.288 .406 .735 r
.38238 .56995 m .38881 .58104 L .391 .56176 L p F P
0 0 0 r
s
.304 .448 .87 r
.48423 .40376 m .48338 .40176 L .4675 .42094 L p F P
0 0 0 r
s
.304 .448 .87 r
.46578 .41707 m .4675 .42094 L .48338 .40176 L p F P
0 0 0 r
s
.83 .24 .1 r
.46978 .41673 m
.47262 .42494 L
s
.962 .28 .12 r
.49346 .40216 m .49653 .40162 L .49322 .42066 L p F P
0 0 0 r
s
.962 .28 .12 r
.49925 .41963 m .49322 .42066 L .49653 .40162 L p F P
0 0 0 r
s
.747 .207 .089 r
.59047 .53403 m .6093 .53112 L .6142 .55128 L p F P
0 0 0 r
s
.747 .207 .089 r
.6142 .55128 m .59451 .55427 L .59047 .53403 L p F P
0 0 0 r
s
.91 .262 .112 r
.561 .42919 m .56995 .42767 L .59032 .44559 L p F P
0 0 0 r
s
.91 .262 .112 r
.60195 .44366 m .59032 .44559 L .56995 .42767 L p F P
0 0 0 r
s
.882 .252 .108 r
.59032 .44559 m .60195 .44366 L .62257 .4624 L p F P
0 0 0 r
s
.822 .232 .1 r
.62433 .48458 m .64041 .482 L .65511 .50211 L p F P
0 0 0 r
s
.822 .232 .1 r
.65511 .50211 m .63731 .50491 L .62433 .48458 L p F P
0 0 0 r
s
.642 .174 .075 r
.49757 .58825 m .51714 .58533 L .51708 .60299 L p F P
0 0 0 r
s
.83 .24 .1 r
.49683 .56176 m
.4976 .58743 L
s
.642 .174 .075 r
.51708 .60299 m .49758 .60584 L .49757 .58825 L p F P
0 0 0 r
s
.83 .24 .1 r
.45914 .59316 m
.4976 .58743 L
s
.937 .271 .116 r
.52954 .41443 m .53562 .41338 L .55206 .4307 L p F P
0 0 0 r
s
.937 .271 .116 r
.561 .42919 m .55206 .4307 L .53562 .41338 L p F P
0 0 0 r
s
.787 .22 .095 r
.6196 .50769 m .63731 .50491 L .64724 .52527 L p F P
0 0 0 r
s
.787 .22 .095 r
.64724 .52527 m .62822 .5282 L .6196 .50769 L p F P
0 0 0 r
s
.311 .457 .882 r
.46578 .41707 m .46405 .41318 L .44746 .4304 L p F P
0 0 0 r
s
.311 .457 .882 r
.44484 .42475 m .44746 .4304 L .46405 .41318 L p F P
0 0 0 r
s
.317 .464 .889 r
.44746 .4304 m .44484 .42475 L .42873 .44186 L p F P
0 0 0 r
s
.7 .192 .083 r
.55545 .56018 m .57493 .55723 L .57645 .5765 L p F P
0 0 0 r
s
.7 .192 .083 r
.57645 .5765 m .55657 .57946 L .55545 .56018 L p F P
0 0 0 r
s
.962 .28 .12 r
.49653 .40162 m .49962 .40108 L .49925 .41963 L p F P
0 0 0 r
s
.962 .28 .12 r
.50529 .41859 m .49925 .41963 L .49962 .40108 L p F P
0 0 0 r
s
.146 .23 .499 r
.63727 .47229 m .64041 .482 L .62257 .4624 L p F P
0 0 0 r
s
.146 .23 .499 r
.62257 .4624 m .61971 .45379 L .63727 .47229 L p F P
0 0 0 r
s
.189 .292 .609 r
.61971 .45379 m .62257 .4624 L .60195 .44366 L p F P
0 0 0 r
s
.83 .24 .1 r
.62124 .4554 m
.64086 .45218 L
s
.6015 .45864 m
.61647 .45619 L
s
.24 .35 .67 r
.41777 .65834 m
.43113 .67842 L
s
.962 .28 .12 r
.49962 .40108 m .5027 .40055 L .50529 .41859 L p F P
0 0 0 r
s
.962 .28 .12 r
.51133 .41755 m .50529 .41859 L .5027 .40055 L p F P
0 0 0 r
s
.83 .24 .1 r
.47262 .42494 m
.51123 .41832 L
s
.51123 .41832 m
.51802 .44389 L
s
.937 .271 .116 r
.53562 .41338 m .54172 .41234 L .561 .42919 L p F P
0 0 0 r
s
.937 .271 .116 r
.56995 .42767 m .561 .42919 L .54172 .41234 L p F P
0 0 0 r
s
.91 .262 .112 r
.56995 .42767 m .57893 .42616 L .60195 .44366 L p F P
0 0 0 r
s
.189 .292 .609 r
.60195 .44366 m .59945 .4364 L .61971 .45379 L p F P
0 0 0 r
s
.222 .338 .69 r
.59945 .4364 m .60195 .44366 L .57893 .42616 L p F P
0 0 0 r
s
.83 .24 .1 r
.59748 .43881 m
.6015 .45864 L
s
.55673 .43739 m
.58796 .43214 L
s
.568 .15 .065 r
.43968 .61433 m .45888 .61151 L .45996 .62678 L p F P
0 0 0 r
s
.568 .15 .065 r
.45996 .62678 m .44126 .62948 L .43968 .61433 L p F P
0 0 0 r
s
.11 .17 .391 r
.65177 .49155 m .65511 .50211 L .64041 .482 L p F P
0 0 0 r
s
.11 .17 .391 r
.64041 .482 m .63727 .47229 L .65177 .49155 L p F P
0 0 0 r
s
.83 .24 .1 r
.60643 .48741 m
.64074 .48191 L
s
.64411 .48137 m
.64577 .4811 L
s
.24 .35 .67 r
.52037 .75287 m
.5102 .73421 L
s
.52037 .75287 m
.54838 .75484 L
s
.962 .28 .12 r
.5027 .40055 m .50579 .40001 L .51133 .41755 L p F P
0 0 0 r
s
.962 .28 .12 r
.51739 .41651 m .51133 .41755 L .50579 .40001 L p F P
0 0 0 r
s
.83 .24 .1 r
.30083 .6573 m
.33871 .65187 L
s
.30083 .6573 m
.29358 .672 L
s
.747 .207 .089 r
.6093 .53112 m .62822 .5282 L .63398 .54829 L p F P
0 0 0 r
s
.747 .207 .089 r
.63398 .54829 m .6142 .55128 L .6093 .53112 L p F P
0 0 0 r
s
.83 .24 .1 r
.61048 .51616 m
.61352 .54397 L
s
.57422 .54996 m
.61352 .54397 L
s
.304 .448 .87 r
.48338 .40176 m .48253 .39976 L .46578 .41707 L p F P
0 0 0 r
s
.304 .448 .87 r
.46405 .41318 m .46578 .41707 L .48253 .39976 L p F P
0 0 0 r
s
.321 .468 .89 r
.40995 .45163 m .41428 .46027 L .42873 .44186 L p F P
0 0 0 r
s
.24 .35 .67 r
.4196 .45435 m
.43133 .47804 L
s
.323 .468 .885 r
.41428 .46027 m .40995 .45163 L .39671 .46985 L p F P
0 0 0 r
s
.323 .468 .885 r
.39671 .46985 m .40178 .4796 L .41428 .46027 L p F P
0 0 0 r
s
.937 .271 .116 r
.54172 .41234 m .54783 .41129 L .56995 .42767 L p F P
0 0 0 r
s
.937 .271 .116 r
.57893 .42616 m .56995 .42767 L .54783 .41129 L p F P
0 0 0 r
s
.83 .24 .1 r
.29167 .39753 m
.30249 .41095 L
s
.30249 .41095 m
.3404 .40422 L
s
.787 .22 .095 r
.63731 .50491 m .65511 .50211 L .66636 .52232 L p F P
0 0 0 r
s
.24 .35 .67 r
.66106 .51914 m
.66357 .52708 L
s
.787 .22 .095 r
.66636 .52232 m .64724 .52527 L .63731 .50491 L p F P
0 0 0 r
s
.83 .24 .1 r
.61048 .51616 m
.64994 .51 L
s
.642 .174 .075 r
.51714 .58533 m .5368 .58241 L .53669 .60011 L p F P
0 0 0 r
s
.642 .174 .075 r
.53669 .60011 m .51708 .60299 L .51714 .58533 L p F P
0 0 0 r
s
.83 .24 .1 r
.4976 .58743 m
.53646 .58164 L
s
.307 .437 .803 r
.38967 .53055 m .38359 .51957 L .37832 .53942 L p F P
0 0 0 r
s
.307 .437 .803 r
.37832 .53942 m .38472 .5507 L .38967 .53055 L p F P
0 0 0 r
s
.24 .35 .67 r
.3877 .54463 m
.39746 .52061 L
s
.3877 .54463 m
.40008 .56666 L
s
.317 .464 .889 r
.42521 .43458 m .42873 .44186 L .44484 .42475 L p F P
0 0 0 r
s
.83 .24 .1 r
.42621 .40915 m
.43394 .43021 L
s
.321 .468 .89 r
.42873 .44186 m .42521 .43458 L .40995 .45163 L p F P
0 0 0 r
s
.24 .35 .67 r
.4196 .45435 m
.44275 .43707 L
s
.83 .24 .1 r
.41929 .62165 m
.45782 .61602 L
s
.962 .28 .12 r
.50579 .40001 m .50888 .39947 L .51739 .41651 L p F P
0 0 0 r
s
.962 .28 .12 r
.52346 .41547 m .51739 .41651 L .50888 .39947 L p F P
0 0 0 r
s
.7 .192 .083 r
.57493 .55723 m .59451 .55427 L .59643 .57353 L p F P
0 0 0 r
s
.7 .192 .083 r
.59643 .57353 m .57645 .5765 L .57493 .55723 L p F P
0 0 0 r
s
.83 .24 .1 r
.57422 .54996 m
.57573 .57579 L
s
.24 .35 .67 r
.65399 .70967 m
.67209 .68796 L
s
.67209 .68796 m
.66493 .66798 L
s
.83 .24 .1 r
.64086 .45218 m
.64577 .4811 L
s
.64577 .4811 m
.68552 .47474 L
s
.64713 .49055 m
.64994 .51 L
s
.64577 .4811 m
.64621 .48416 L
s
.937 .271 .116 r
.54783 .41129 m .55395 .41024 L .57893 .42616 L p F P
0 0 0 r
s
.222 .338 .69 r
.57893 .42616 m .57689 .42047 L .59945 .4364 L p F P
0 0 0 r
s
.83 .24 .1 r
.59237 .4314 m
.59585 .43082 L
s
.59585 .43082 m
.59657 .43437 L
s
.247 .373 .75 r
.57689 .42047 m .57893 .42616 L .55395 .41024 L p F P
0 0 0 r
s
.962 .28 .12 r
.50888 .39947 m .51197 .39893 L .52346 .41547 L p F P
0 0 0 r
s
.962 .28 .12 r
.52954 .41443 m .52346 .41547 L .51197 .39893 L p F P
0 0 0 r
s
.24 .35 .67 r
.52372 .4093 m
.52459 .40915 L
s
.52459 .40915 m
.52514 .41055 L
s
.46112 .71456 m
.44974 .69509 L
s
.46112 .71456 m
.48393 .72687 L
s
.322 .464 .871 r
.40178 .4796 m .39671 .46985 L .38578 .48889 L p F P
0 0 0 r
s
.24 .35 .67 r
.40006 .47471 m
.4196 .45435 L
s
.322 .464 .871 r
.38578 .48889 m .39148 .4995 L .40178 .4796 L p F P
0 0 0 r
s
.24 .35 .67 r
.40006 .47471 m
.41223 .49814 L
s
.568 .15 .065 r
.45888 .61151 m .47818 .60869 L .47876 .62407 L p F P
0 0 0 r
s
.568 .15 .065 r
.47876 .62407 m .45996 .62678 L .45888 .61151 L p F P
0 0 0 r
s
.83 .24 .1 r
.45782 .61602 m
.45914 .59316 L
s
.962 .28 .12 r
.51197 .39893 m .51506 .39839 L .52954 .41443 L p F P
0 0 0 r
s
.962 .28 .12 r
.53562 .41338 m .52954 .41443 L .51506 .39839 L p F P
0 0 0 r
s
.747 .207 .089 r
.62822 .5282 m .64724 .52527 L .65388 .54527 L p F P
0 0 0 r
s
.747 .207 .089 r
.65388 .54527 m .63398 .54829 L .62822 .5282 L p F P
0 0 0 r
s
.311 .457 .882 r
.46405 .41318 m .46231 .40926 L .44484 .42475 L p F P
0 0 0 r
s
.311 .457 .882 r
.44219 .41904 m .44484 .42475 L .46231 .40926 L p F P
0 0 0 r
s
.317 .464 .889 r
.44484 .42475 m .44219 .41904 L .42521 .43458 L p F P
0 0 0 r
s
.83 .24 .1 r
.63539 .42418 m
.64086 .45218 L
s
.64086 .45218 m
.68064 .44566 L
s
.077 .112 .279 r
.66287 .51118 m .66636 .52232 L .65511 .50211 L p F P
0 0 0 r
s
.077 .112 .279 r
.65511 .50211 m .65177 .49155 L .66287 .51118 L p F P
0 0 0 r
s
.24 .35 .67 r
.64557 .49199 m
.65632 .50418 L
s
.65632 .50418 m
.65798 .50941 L
s
.962 .28 .12 r
.51506 .39839 m .51816 .39786 L .53562 .41338 L p F P
0 0 0 r
s
.962 .28 .12 r
.54172 .41234 m .53562 .41338 L .51816 .39786 L p F P
0 0 0 r
s
.642 .174 .075 r
.5368 .58241 m .55657 .57946 L .5564 .59723 L p F P
0 0 0 r
s
.642 .174 .075 r
.5564 .59723 m .53669 .60011 L .5368 .58241 L p F P
0 0 0 r
s
.304 .448 .87 r
.48253 .39976 m .48168 .39775 L .46405 .41318 L p F P
0 0 0 r
s
.304 .448 .87 r
.46231 .40926 m .46405 .41318 L .48168 .39775 L p F P
0 0 0 r
s
.7 .192 .083 r
.59451 .55427 m .6142 .55128 L .61652 .57054 L p F P
0 0 0 r
s
.7 .192 .083 r
.61652 .57054 m .59643 .57353 L .59451 .55427 L p F P
0 0 0 r
s
.24 .35 .67 r
.678 .64378 m
.68511 .61862 L
s
.68511 .61862 m
.67819 .5972 L
s
.208 .282 .479 r
.39543 .60945 m .38915 .59877 L .39209 .61456 L p F P
0 0 0 r
s
.208 .282 .479 r
.39209 .61456 m .39818 .6248 L .39543 .60945 L p F P
0 0 0 r
s
.24 .35 .67 r
.39608 .59107 m
.39786 .61514 L
s
.39786 .61514 m
.40342 .62456 L
s
.83 .24 .1 r
.64994 .51 m
.65888 .5086 L
s
.66121 .50823 m
.68981 .50376 L
s
.962 .28 .12 r
.51816 .39786 m .52126 .39732 L .54172 .41234 L p F P
0 0 0 r
s
.962 .28 .12 r
.54783 .41129 m .54172 .41234 L .52126 .39732 L p F P
0 0 0 r
s
.83 .24 .1 r
.51123 .41832 m
.55024 .41163 L
s
.257 .356 .631 r
.38881 .58104 m .38238 .56995 L .38274 .58789 L p F P
0 0 0 r
s
.257 .356 .631 r
.38274 .58789 m .38915 .59877 L .38881 .58104 L p F P
0 0 0 r
s
.568 .15 .065 r
.47818 .60869 m .49758 .60584 L .49764 .62134 L p F P
0 0 0 r
s
.568 .15 .065 r
.49764 .62134 m .47876 .62407 L .47818 .60869 L p F P
0 0 0 r
s
.962 .28 .12 r
.52126 .39732 m .52436 .39678 L .54783 .41129 L p F P
0 0 0 r
s
.962 .28 .12 r
.55395 .41024 m .54783 .41129 L .52436 .39678 L p F P
0 0 0 r
s
.189 .292 .609 r
.6168 .44506 m .61971 .45379 L .59945 .4364 L p F P
0 0 0 r
s
.24 .35 .67 r
.61212 .44816 m
.61523 .45739 L
s
.189 .292 .609 r
.59945 .4364 m .59691 .42906 L .6168 .44506 L p F P
0 0 0 r
s
.24 .35 .67 r
.595 .4413 m
.61212 .44816 L
s
.83 .24 .1 r
.59585 .43082 m
.59743 .43055 L
s
.222 .338 .69 r
.59691 .42906 m .59945 .4364 L .57689 .42047 L p F P
0 0 0 r
s
.83 .24 .1 r
.59854 .43037 m
.63539 .42418 L
s
.317 .455 .846 r
.39148 .4995 m .38578 .48889 L .3774 .50838 L p F P
0 0 0 r
s
.317 .455 .846 r
.3774 .50838 m .38359 .51957 L .39148 .4995 L p F P
0 0 0 r
s
.747 .207 .089 r
.64724 .52527 m .66636 .52232 L .67387 .54224 L p F P
0 0 0 r
s
.747 .207 .089 r
.67387 .54224 m .65388 .54527 L .64724 .52527 L p F P
0 0 0 r
s
.24 .35 .67 r
.67242 .54246 m
.67425 .54833 L
s
.83 .24 .1 r
.64994 .51 m
.65324 .53791 L
s
.61352 .54397 m
.65324 .53791 L
s
.33871 .65187 m
.37699 .64638 L
s
.33871 .65187 m
.33207 .66656 L
s
.467 .119 .052 r
.40415 .63484 m .42266 .63217 L .42659 .6445 L p F P
0 0 0 r
s
.467 .119 .052 r
.42659 .6445 m .40901 .64701 L .40415 .63484 L p F P
0 0 0 r
s
.24 .35 .67 r
.41087 .64674 m
.41777 .65834 L
s
.83 .24 .1 r
.41568 .64083 m
.41929 .62165 L
s
.162 .212 .366 r
.40415 .63484 m .39818 .6248 L .40339 .63758 L p F P
0 0 0 r
s
.162 .212 .366 r
.40339 .63758 m .40901 .64701 L .40415 .63484 L p F P
0 0 0 r
s
.24 .35 .67 r
.40556 .63782 m
.40835 .64251 L
s
.146 .23 .499 r
.63407 .46242 m .63727 .47229 L .61971 .45379 L p F P
0 0 0 r
s
.146 .23 .499 r
.61971 .45379 m .6168 .44506 L .63407 .46242 L p F P
0 0 0 r
s
.986 .289 .124 r
.48731 .40323 m .48423 .40376 L .5 .38446 L closepath p F P
0 0 0 r
s
.294 .436 .852 r
.48338 .40176 m .48423 .40376 L .5 .38446 L closepath p F P
0 0 0 r
s
.962 .28 .12 r
.52436 .39678 m .52747 .39623 L .55395 .41024 L p F P
0 0 0 r
s
.247 .373 .75 r
.55395 .41024 m .55248 .4063 L .57689 .42047 L p F P
0 0 0 r
s
.83 .24 .1 r
.55024 .41163 m
.55673 .43739 L
s
.267 .399 .794 r
.55248 .4063 m .55395 .41024 L .52747 .39623 L p F P
0 0 0 r
s
.83 .24 .1 r
.33015 .39061 m
.3404 .40422 L
s
.3404 .40422 m
.37871 .39742 L
s
.642 .174 .075 r
.55657 .57946 m .57645 .5765 L .57621 .59432 L p F P
0 0 0 r
s
.642 .174 .075 r
.57621 .59432 m .5564 .59723 L .55657 .57946 L p F P
0 0 0 r
s
.83 .24 .1 r
.53646 .58164 m
.57573 .57579 L
s
.24 .35 .67 r
.54838 .75484 m
.5387 .7361 L
s
.54838 .75484 m
.57718 .75122 L
s
.83 .24 .1 r
.45782 .61602 m
.49676 .61034 L
s
.222 .338 .69 r
.57689 .42047 m .57483 .41472 L .59691 .42906 L p F P
0 0 0 r
s
.247 .373 .75 r
.57483 .41472 m .57689 .42047 L .55248 .4063 L p F P
0 0 0 r
s
.83 .24 .1 r
.55024 .41163 m
.55706 .41046 L
s
.24 .35 .67 r
.54233 .40907 m
.55267 .40902 L
s
.55267 .40902 m
.55431 .41339 L
s
.986 .289 .124 r
.49038 .40269 m .48731 .40323 L .5 .38446 L closepath p F P
0 0 0 r
s
.7 .192 .083 r
.6142 .55128 m .63398 .54829 L .63671 .56753 L p F P
0 0 0 r
s
.7 .192 .083 r
.63671 .56753 m .61652 .57054 L .6142 .55128 L p F P
0 0 0 r
s
.83 .24 .1 r
.61352 .54397 m
.61542 .56987 L
s
.20372 .40341 m
.21593 .41113 L
s
.21593 .41113 m
.2536 .40437 L
s
.304 .448 .87 r
.48168 .39775 m .48082 .39573 L .46231 .40926 L p F P
0 0 0 r
s
.304 .448 .87 r
.46056 .40532 m .46231 .40926 L .48082 .39573 L p F P
0 0 0 r
s
.83 .24 .1 r
.46482 .4024 m
.46509 .40318 L
s
.311 .457 .882 r
.46231 .40926 m .46056 .40532 L .44219 .41904 L p F P
0 0 0 r
s
.83 .24 .1 r
.42621 .40915 m
.46482 .4024 L
s
.317 .464 .889 r
.42165 .42722 m .42521 .43458 L .44219 .41904 L p F P
0 0 0 r
s
.321 .468 .89 r
.42521 .43458 m .42165 .42722 L .40555 .44287 L p F P
0 0 0 r
s
.321 .468 .89 r
.40555 .44287 m .40995 .45163 L .42521 .43458 L p F P
0 0 0 r
s
.986 .289 .124 r
.49346 .40216 m .49038 .40269 L .5 .38446 L closepath p F P
0 0 0 r
s
.288 .406 .735 r
.38472 .5507 m .37832 .53942 L .37582 .55863 L p F P
0 0 0 r
s
.288 .406 .735 r
.37582 .55863 m .38238 .56995 L .38472 .5507 L p F P
0 0 0 r
s
.24 .35 .67 r
.38349 .56929 m
.3877 .54463 L
s
.83 .24 .1 r
.68064 .44566 m
.68552 .47474 L
s
.68552 .47474 m
.72569 .4683 L
s
.68552 .47474 m
.68981 .50376 L
s
.24 .35 .67 r
.63136 .72805 m
.65399 .70967 L
s
.65399 .70967 m
.64642 .69 L
s
.986 .289 .124 r
.49653 .40162 m .49346 .40216 L .5 .38446 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.46482 .4024 m
.46786 .40187 L
s
.311 .457 .882 r
.43952 .41329 m .44219 .41904 L .46056 .40532 L p F P
0 0 0 r
s
.317 .464 .889 r
.44219 .41904 m .43952 .41329 L .42165 .42722 L p F P
0 0 0 r
s
.294 .436 .852 r
.48253 .39976 m .48338 .40176 L .5 .38446 L closepath p F P
0 0 0 r
s
.568 .15 .065 r
.49758 .60584 m .51708 .60299 L .51663 .6186 L p F P
0 0 0 r
s
.568 .15 .065 r
.51663 .6186 m .49764 .62134 L .49758 .60584 L p F P
0 0 0 r
s
.83 .24 .1 r
.49676 .61034 m
.4976 .58743 L
s
.986 .289 .124 r
.49962 .40108 m .49653 .40162 L .5 .38446 L closepath p F P
0 0 0 r
s
.323 .468 .885 r
.40995 .45163 m .40555 .44287 L .39155 .45994 L p F P
0 0 0 r
s
.323 .468 .885 r
.39155 .45994 m .39671 .46985 L .40995 .45163 L p F P
0 0 0 r
s
.054 .079 .187 r
.6703 .53079 m .67387 .54224 L .66636 .52232 L p F P
0 0 0 r
s
.054 .079 .187 r
.66636 .52232 m .66287 .51118 L .6703 .53079 L p F P
0 0 0 r
s
.986 .289 .124 r
.5027 .40055 m .49962 .40108 L .5 .38446 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.62951 .39803 m
.63539 .42418 L
s
.63539 .42418 m
.67534 .41747 L
s
.11 .17 .391 r
.64836 .4808 m .65177 .49155 L .63727 .47229 L p F P
0 0 0 r
s
.11 .17 .391 r
.63727 .47229 m .63407 .46242 L .64836 .4808 L p F P
0 0 0 r
s
.83 .24 .1 r
.67534 .41747 m
.68064 .44566 L
s
.68064 .44566 m
.72084 .43906 L
s
.467 .119 .052 r
.42266 .63217 m .44126 .62948 L .44426 .64198 L p F P
0 0 0 r
s
.467 .119 .052 r
.44426 .64198 m .42659 .6445 L .42266 .63217 L p F P
0 0 0 r
s
.986 .289 .124 r
.50579 .40001 m .5027 .40055 L .5 .38446 L closepath p F P
0 0 0 r
s
.642 .174 .075 r
.57645 .5765 m .59643 .57353 L .59613 .5914 L p F P
0 0 0 r
s
.642 .174 .075 r
.59613 .5914 m .57621 .59432 L .57645 .5765 L p F P
0 0 0 r
s
.986 .289 .124 r
.50888 .39947 m .50579 .40001 L .5 .38446 L closepath p F P
0 0 0 r
s
.294 .436 .852 r
.48168 .39775 m .48253 .39976 L .5 .38446 L closepath p F P
0 0 0 r
s
.247 .373 .75 r
.55248 .4063 m .551 .40235 L .57483 .41472 L p F P
0 0 0 r
s
.267 .399 .794 r
.551 .40235 m .55248 .4063 L .52668 .39421 L p F P
0 0 0 r
s
.267 .399 .794 r
.52747 .39623 m .52668 .39421 L .55248 .4063 L p F P
0 0 0 r
s
.83 .24 .1 r
.54771 .40327 m
.55024 .41163 L
s
.7 .192 .083 r
.63398 .54829 m .65388 .54527 L .65702 .56451 L p F P
0 0 0 r
s
.7 .192 .083 r
.65702 .56451 m .63671 .56753 L .63398 .54829 L p F P
0 0 0 r
s
.986 .289 .124 r
.51197 .39893 m .50888 .39947 L .5 .38446 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.68981 .50376 m
.7301 .49747 L
s
.68981 .50376 m
.69337 .53179 L
s
.986 .289 .124 r
.51506 .39839 m .51197 .39893 L .5 .38446 L closepath p F P
0 0 0 r
s
.304 .448 .87 r
.48082 .39573 m .47996 .39371 L .46056 .40532 L p F P
0 0 0 r
s
.304 .448 .87 r
.4588 .40136 m .46056 .40532 L .47996 .39371 L p F P
0 0 0 r
s
.311 .457 .882 r
.46056 .40532 m .4588 .40136 L .43952 .41329 L p F P
0 0 0 r
s
.986 .289 .124 r
.51816 .39786 m .51506 .39839 L .5 .38446 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.57718 .75122 m
.56804 .73233 L
s
.57718 .75122 m
.60532 .74214 L
s
.322 .464 .871 r
.39671 .46985 m .39155 .45994 L .37997 .47809 L p F P
0 0 0 r
s
.322 .464 .871 r
.37997 .47809 m .38578 .48889 L .39671 .46985 L p F P
0 0 0 r
s
.568 .15 .065 r
.51708 .60299 m .53669 .60011 L .53571 .61584 L p F P
0 0 0 r
s
.568 .15 .065 r
.53571 .61584 m .51663 .6186 L .51708 .60299 L p F P
0 0 0 r
s
.307 .437 .803 r
.38359 .51957 m .3774 .50838 L .37179 .52791 L p F P
0 0 0 r
s
.307 .437 .803 r
.37179 .52791 m .37832 .53942 L .38359 .51957 L p F P
0 0 0 r
s
.83 .24 .1 r
.65324 .53791 m
.67124 .53516 L
s
.986 .289 .124 r
.52126 .39732 m .51816 .39786 L .5 .38446 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.60532 .74214 m
.63136 .72805 L
s
.63136 .72805 m
.62331 .70869 L
s
.294 .436 .852 r
.48082 .39573 m .48168 .39775 L .5 .38446 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.40693 .64209 m
.41568 .64083 L
s
.37699 .64638 m
.40615 .6422 L
s
.37699 .64638 m
.37098 .66105 L
s
.222 .338 .69 r
.59435 .42162 m .59691 .42906 L .57483 .41472 L p F P
0 0 0 r
s
.222 .338 .69 r
.57483 .41472 m .57276 .40893 L .59435 .42162 L p F P
0 0 0 r
s
.83 .24 .1 r
.58967 .40486 m
.59355 .42115 L
s
.247 .373 .75 r
.57276 .40893 m .57483 .41472 L .551 .40235 L p F P
0 0 0 r
s
.83 .24 .1 r
.5703 .40818 m
.58967 .40486 L
s
.24 .35 .67 r
.43113 .67842 m
.41905 .65806 L
s
.43113 .67842 m
.44974 .69509 L
s
.986 .289 .124 r
.52436 .39678 m .52126 .39732 L .5 .38446 L closepath p F P
0 0 0 r
s
.467 .119 .052 r
.44126 .62948 m .45996 .62678 L .46201 .63945 L p F P
0 0 0 r
s
.467 .119 .052 r
.46201 .63945 m .44426 .64198 L .44126 .62948 L p F P
0 0 0 r
s
.83 .24 .1 r
.45478 .63523 m
.45782 .61602 L
s
.189 .292 .609 r
.61385 .43621 m .6168 .44506 L .59691 .42906 L p F P
0 0 0 r
s
.189 .292 .609 r
.59691 .42906 m .59435 .42162 L .61385 .43621 L p F P
0 0 0 r
s
.83 .24 .1 r
.36905 .38363 m
.37871 .39742 L
s
.37871 .39742 m
.41742 .39055 L
s
.986 .289 .124 r
.52747 .39623 m .52436 .39678 L .5 .38446 L closepath p F P
0 0 0 r
s
.642 .174 .075 r
.59643 .57353 m .61652 .57054 L .61615 .58847 L p F P
0 0 0 r
s
.642 .174 .075 r
.61615 .58847 m .59613 .5914 L .59643 .57353 L p F P
0 0 0 r
s
.83 .24 .1 r
.57573 .57579 m
.61542 .56987 L
s
.24 .35 .67 r
.60532 .74214 m
.59673 .72305 L
s
.7 .192 .083 r
.65388 .54527 m .67387 .54224 L .67744 .56147 L p F P
0 0 0 r
s
.7 .192 .083 r
.67744 .56147 m .65702 .56451 L .65388 .54527 L p F P
0 0 0 r
s
.24 .35 .67 r
.67704 .56152 m
.67927 .57204 L
s
.83 .24 .1 r
.65324 .53791 m
.65553 .56389 L
s
.282 .42 .827 r
.5 .38446 m .52668 .39421 L .52747 .39623 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.50384 .39558 m
.51123 .41832 L
s
.24 .35 .67 r
.48393 .72687 m
.4729 .70746 L
s
.48393 .72687 m
.5102 .73421 L
s
.83 .24 .1 r
.242 .39647 m
.2536 .40437 L
s
.2536 .40437 m
.29167 .39753 L
s
.2555 .67739 m
.29358 .672 L
s
.2555 .67739 m
.24578 .68689 L
s
.311 .457 .882 r
.43683 .40748 m .43952 .41329 L .4588 .40136 L p F P
0 0 0 r
s
.317 .464 .889 r
.43952 .41329 m .43683 .40748 L .41806 .41976 L p F P
0 0 0 r
s
.317 .464 .889 r
.41806 .41976 m .42165 .42722 L .43952 .41329 L p F P
0 0 0 r
s
.077 .112 .279 r
.65932 .49983 m .66287 .51118 L .65177 .49155 L p F P
0 0 0 r
s
.077 .112 .279 r
.65177 .49155 m .64836 .4808 L .65932 .49983 L p F P
0 0 0 r
s
.247 .373 .75 r
.551 .40235 m .54951 .39836 L .57276 .40893 L p F P
0 0 0 r
s
.267 .399 .794 r
.54951 .39836 m .551 .40235 L .52589 .39218 L p F P
0 0 0 r
s
.83 .24 .1 r
.54693 .4007 m
.54702 .40102 L
s
.267 .399 .794 r
.52668 .39421 m .52589 .39218 L .551 .40235 L p F P
0 0 0 r
s
.294 .436 .852 r
.47996 .39371 m .48082 .39573 L .5 .38446 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.48043 .39967 m
.50384 .39558 L
s
.72084 .43906 m
.72569 .4683 L
s
.72569 .4683 m
.76629 .4618 L
s
.72569 .4683 m
.7301 .49747 L
s
.321 .468 .89 r
.42165 .42722 m .41806 .41976 L .40109 .43398 L p F P
0 0 0 r
s
.321 .468 .89 r
.40109 .43398 m .40555 .44287 L .42165 .42722 L p F P
0 0 0 r
s
.568 .15 .065 r
.53669 .60011 m .5564 .59723 L .5549 .61307 L p F P
0 0 0 r
s
.568 .15 .065 r
.5549 .61307 m .53571 .61584 L .53669 .60011 L p F P
0 0 0 r
s
.83 .24 .1 r
.49676 .61034 m
.53612 .6046 L
s
.53612 .6046 m
.53646 .58164 L
s
.24 .35 .67 r
.67819 .5972 m
.67927 .57204 L
s
.304 .448 .87 r
.47996 .39371 m .47909 .39168 L .4588 .40136 L p F P
0 0 0 r
s
.304 .448 .87 r
.45703 .39737 m .4588 .40136 L .47909 .39168 L p F P
0 0 0 r
s
.311 .457 .882 r
.4588 .40136 m .45703 .39737 L .43683 .40748 L p F P
0 0 0 r
s
.24 .35 .67 r
.45743 .39834 m
.4686 .42347 L
s
.146 .23 .499 r
.63083 .45239 m .63407 .46242 L .6168 .44506 L p F P
0 0 0 r
s
.146 .23 .499 r
.6168 .44506 m .61385 .43621 L .63083 .45239 L p F P
0 0 0 r
s
.24 .35 .67 r
.66493 .66798 m
.678 .64378 L
s
.678 .64378 m
.67086 .62267 L
s
.282 .42 .827 r
.5 .38446 m .52589 .39218 L .52668 .39421 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.66978 .39112 m
.67534 .41747 L
s
.67534 .41747 m
.71572 .41069 L
s
.467 .119 .052 r
.45996 .62678 m .47876 .62407 L .47984 .6369 L p F P
0 0 0 r
s
.467 .119 .052 r
.47984 .6369 m .46201 .63945 L .45996 .62678 L p F P
0 0 0 r
s
.83 .24 .1 r
.71572 .41069 m
.72084 .43906 L
s
.72084 .43906 m
.76147 .43239 L
s
.294 .436 .852 r
.47909 .39168 m .47996 .39371 L .5 .38446 L closepath p F P
0 0 0 r
s
.208 .282 .479 r
.38915 .59877 m .38274 .58789 L .38589 .60412 L p F P
0 0 0 r
s
.24 .35 .67 r
.38349 .56929 m
.39608 .59107 L
s
.208 .282 .479 r
.38589 .60412 m .39209 .61456 L .38915 .59877 L p F P
0 0 0 r
s
.642 .174 .075 r
.61652 .57054 m .63671 .56753 L .63629 .58552 L p F P
0 0 0 r
s
.642 .174 .075 r
.63629 .58552 m .61615 .58847 L .61652 .57054 L p F P
0 0 0 r
s
.317 .455 .846 r
.38578 .48889 m .37997 .47809 L .37108 .49697 L p F P
0 0 0 r
s
.317 .455 .846 r
.37108 .49697 m .3774 .50838 L .38578 .48889 L p F P
0 0 0 r
s
.24 .35 .67 r
.3849 .49745 m
.40006 .47471 L
s
.3849 .49745 m
.39746 .52061 L
s
.191 .261 .437 r
.67383 .54997 m .67744 .56147 L .67387 .54224 L p F P
0 0 0 r
s
.191 .261 .437 r
.67387 .54224 m .6703 .53079 L .67383 .54997 L p F P
0 0 0 r
s
.83 .24 .1 r
.67237 .53499 m
.69337 .53179 L
s
.67165 .5351 m
.67237 .53499 L
s
.323 .468 .885 r
.40555 .44287 m .40109 .43398 L .38632 .44987 L p F P
0 0 0 r
s
.323 .468 .885 r
.38632 .44987 m .39155 .45994 L .40555 .44287 L p F P
0 0 0 r
s
.257 .356 .631 r
.38238 .56995 m .37582 .55863 L .37621 .57679 L p F P
0 0 0 r
s
.257 .356 .631 r
.37621 .57679 m .38274 .58789 L .38238 .56995 L p F P
0 0 0 r
s
.83 .24 .1 r
.7301 .49747 m
.77083 .4911 L
s
.7301 .49747 m
.73394 .5256 L
s
.267 .399 .794 r
.52589 .39218 m .5251 .39015 L .54951 .39836 L p F P
0 0 0 r
s
.282 .42 .827 r
.5 .38446 m .5251 .39015 L .52589 .39218 L closepath p F P
0 0 0 r
s
.247 .373 .75 r
.57066 .40308 m .57276 .40893 L .54951 .39836 L p F P
0 0 0 r
s
.247 .373 .75 r
.54951 .39836 m .54802 .39436 L .57066 .40308 L p F P
0 0 0 r
s
.267 .399 .794 r
.54802 .39436 m .54951 .39836 L .5251 .39015 L p F P
0 0 0 r
s
.83 .24 .1 r
.50384 .39558 m
.52741 .39146 L
s
.52987 .39103 m
.53112 .39081 L
s
.294 .436 .852 r
.47823 .38964 m .47909 .39168 L .5 .38446 L closepath p F P
0 0 0 r
s
.304 .448 .87 r
.47909 .39168 m .47823 .38964 L .45703 .39737 L p F P
0 0 0 r
s
.162 .212 .366 r
.39818 .6248 m .39209 .61456 L .39767 .62799 L p F P
0 0 0 r
s
.162 .212 .366 r
.39767 .62799 m .40339 .63758 L .39818 .6248 L p F P
0 0 0 r
s
.24 .35 .67 r
.39786 .61514 m
.40556 .63782 L
s
.222 .338 .69 r
.59176 .4141 m .59435 .42162 L .57276 .40893 L p F P
0 0 0 r
s
.222 .338 .69 r
.57276 .40893 m .57066 .40308 L .59176 .4141 L p F P
0 0 0 r
s
.24 .35 .67 r
.57941 .41375 m
.58646 .43367 L
s
.55267 .40902 m
.57941 .41375 L
s
.83 .24 .1 r
.58967 .40486 m
.62951 .39803 L
s
.568 .15 .065 r
.5564 .59723 m .57621 .59432 L .57418 .61028 L p F P
0 0 0 r
s
.568 .15 .065 r
.57418 .61028 m .5549 .61307 L .5564 .59723 L p F P
0 0 0 r
s
.83 .24 .1 r
.69337 .53179 m
.73394 .5256 L
s
.69337 .53179 m
.69608 .55785 L
s
.304 .448 .87 r
.45524 .39336 m .45703 .39737 L .47823 .38964 L p F P
0 0 0 r
s
.311 .457 .882 r
.45703 .39737 m .45524 .39336 L .43411 .40162 L p F P
0 0 0 r
s
.311 .457 .882 r
.43411 .40162 m .43683 .40748 L .45703 .39737 L p F P
0 0 0 r
s
.467 .119 .052 r
.47876 .62407 m .49764 .62134 L .49777 .63434 L p F P
0 0 0 r
s
.467 .119 .052 r
.49777 .63434 m .47984 .6369 L .47876 .62407 L p F P
0 0 0 r
s
.83 .24 .1 r
.4943 .62956 m
.49676 .61034 L
s
.41568 .64083 m
.45478 .63523 L
s
.11 .17 .391 r
.64489 .46985 m .64836 .4808 L .63407 .46242 L p F P
0 0 0 r
s
.11 .17 .391 r
.63407 .46242 m .63083 .45239 L .64489 .46985 L p F P
0 0 0 r
s
.24 .35 .67 r
.63263 .46223 m
.63943 .48315 L
s
.61212 .44816 m
.63263 .46223 L
s
.267 .399 .794 r
.5251 .39015 m .5243 .38811 L .54802 .39436 L p F P
0 0 0 r
s
.83 .24 .1 r
.53318 .39045 m
.54328 .38868 L
s
.54328 .38868 m
.54474 .39349 L
s
.282 .42 .827 r
.5 .38446 m .5243 .38811 L .5251 .39015 L closepath p F P
0 0 0 r
s
.317 .464 .889 r
.43683 .40748 m .43411 .40162 L .41441 .41222 L p F P
0 0 0 r
s
.83 .24 .1 r
.41742 .39055 m
.42498 .40653 L
s
.317 .464 .889 r
.41441 .41222 m .41806 .41976 L .43683 .40748 L p F P
0 0 0 r
s
.24 .35 .67 r
.43105 .41218 m
.44275 .43707 L
s
.43105 .41218 m
.45743 .39834 L
s
.83 .24 .1 r
.62342 .37468 m
.62951 .39803 L
s
.62951 .39803 m
.66978 .39112 L
s
.288 .406 .735 r
.37832 .53942 m .37179 .52791 L .36913 .54708 L p F P
0 0 0 r
s
.288 .406 .735 r
.36913 .54708 m .37582 .55863 L .37832 .53942 L p F P
0 0 0 r
s
.294 .436 .852 r
.47736 .3876 m .47823 .38964 L .5 .38446 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.48558 .38869 m
.492 .40399 L
s
.304 .448 .87 r
.47823 .38964 m .47736 .3876 L .45524 .39336 L p F P
0 0 0 r
s
.24 .35 .67 r
.45743 .39834 m
.48558 .38869 L
s
.642 .174 .075 r
.63671 .56753 m .65702 .56451 L .65653 .58255 L p F P
0 0 0 r
s
.642 .174 .075 r
.65653 .58255 m .63629 .58552 L .63671 .56753 L p F P
0 0 0 r
s
.83 .24 .1 r
.61542 .56987 m
.65553 .56389 L
s
.189 .292 .609 r
.61086 .42723 m .61385 .43621 L .59435 .42162 L p F P
0 0 0 r
s
.189 .292 .609 r
.59435 .42162 m .59176 .4141 L .61086 .42723 L p F P
0 0 0 r
s
.83 .24 .1 r
.28071 .38947 m
.29167 .39753 L
s
.29167 .39753 m
.33015 .39061 L
s
.29358 .672 m
.33207 .66656 L
s
.29358 .672 m
.28452 .68145 L
s
.054 .079 .187 r
.66666 .51911 m .6703 .53079 L .66287 .51118 L p F P
0 0 0 r
s
.24 .35 .67 r
.66713 .52558 m
.67037 .53593 L
s
.054 .079 .187 r
.66287 .51118 m .65932 .49983 L .66666 .51911 L p F P
0 0 0 r
s
.24 .35 .67 r
.65632 .50418 m
.66713 .52558 L
s
.83 .24 .1 r
.76147 .43239 m
.76629 .4618 L
s
.76629 .4618 m
.80732 .45523 L
s
.76629 .4618 m
.77083 .4911 L
s
.267 .399 .794 r
.54652 .39033 m .54802 .39436 L .5243 .38811 L p F P
0 0 0 r
s
.267 .399 .794 r
.5243 .38811 m .5235 .38606 L .54652 .39033 L p F P
0 0 0 r
s
.282 .42 .827 r
.5 .38446 m .5235 .38606 L .5243 .38811 L closepath p F P
0 0 0 r
s
.568 .15 .065 r
.57621 .59432 m .59613 .5914 L .59356 .60749 L p F P
0 0 0 r
s
.568 .15 .065 r
.59356 .60749 m .57418 .61028 L .57621 .59432 L p F P
0 0 0 r
s
.83 .24 .1 r
.53612 .6046 m
.57589 .59879 L
s
.57573 .57579 m
.57589 .59879 L
s
.322 .464 .871 r
.39155 .45994 m .38632 .44987 L .37406 .4671 L p F P
0 0 0 r
s
.322 .464 .871 r
.37406 .4671 m .37997 .47809 L .39155 .45994 L p F P
0 0 0 r
s
.24 .35 .67 r
.3874 .45035 m
.40006 .47471 L
s
.247 .373 .75 r
.56855 .39718 m .57066 .40308 L .54802 .39436 L p F P
0 0 0 r
s
.247 .373 .75 r
.54802 .39436 m .54652 .39033 L .56855 .39718 L p F P
0 0 0 r
s
.294 .436 .852 r
.47649 .38555 m .47736 .3876 L .5 .38446 L closepath p F P
0 0 0 r
s
.304 .448 .87 r
.47736 .3876 m .47649 .38555 L .45345 .38932 L p F P
0 0 0 r
s
.83 .24 .1 r
.4589 .38893 m
.46027 .39205 L
s
.304 .448 .87 r
.45345 .38932 m .45524 .39336 L .47736 .3876 L p F P
0 0 0 r
s
.321 .468 .89 r
.41806 .41976 m .41441 .41222 L .39657 .42497 L p F P
0 0 0 r
s
.321 .468 .89 r
.39657 .42497 m .40109 .43398 L .41806 .41976 L p F P
0 0 0 r
s
.24 .35 .67 r
.40741 .42972 m
.43105 .41218 L
s
.40741 .42972 m
.4196 .45435 L
s
.467 .119 .052 r
.49764 .62134 m .51663 .6186 L .51577 .63177 L p F P
0 0 0 r
s
.467 .119 .052 r
.51577 .63177 m .49777 .63434 L .49764 .62134 L p F P
0 0 0 r
s
.83 .24 .1 r
.71048 .38414 m
.71572 .41069 L
s
.71572 .41069 m
.75653 .40383 L
s
.75653 .40383 m
.76147 .43239 L
s
.76147 .43239 m
.80253 .42565 L
s
.33 .077 .034 r
.40901 .64701 m .42659 .6445 L .43237 .65375 L p F P
0 0 0 r
s
.33 .077 .034 r
.43237 .65375 m .41616 .65604 L .40901 .64701 L p F P
0 0 0 r
s
.24 .35 .67 r
.41757 .65584 m
.41905 .65806 L
s
.071 .103 .253 r
.40901 .64701 m .40339 .63758 L .41104 .64744 L p F P
0 0 0 r
s
.071 .103 .253 r
.41104 .64744 m .41616 .65604 L .40901 .64701 L p F P
0 0 0 r
s
.83 .24 .1 r
.41241 .64974 m
.41568 .64083 L
s
.4103 .65549 m
.41208 .65064 L
s
.24 .35 .67 r
.40556 .63782 m
.4146 .65138 L
s
.311 .457 .882 r
.45524 .39336 m .45345 .38932 L .43137 .3957 L p F P
0 0 0 r
s
.311 .457 .882 r
.43137 .3957 m .43411 .40162 L .45524 .39336 L p F P
0 0 0 r
s
1 .298 .127 r
.5 .38446 m .51621 .36734 L .51304 .36791 L closepath p F P
0 0 0 r
s
1 .298 .127 r
.5 .38446 m .51304 .36791 L .50988 .36847 L closepath p F P
0 0 0 r
s
1 .298 .127 r
.5 .38446 m .50988 .36847 L .50671 .36904 L closepath p F P
0 0 0 r
s
1 .298 .127 r
.5 .38446 m .50671 .36904 L .50355 .3696 L closepath p F P
0 0 0 r
s
1 .298 .127 r
.5 .38446 m .50355 .3696 L .50039 .37016 L closepath p F P
0 0 0 r
s
1 .298 .127 r
.5 .38446 m .50039 .37016 L .49724 .37073 L closepath p F P
0 0 0 r
s
1 .298 .127 r
.5 .38446 m .49724 .37073 L .49408 .37129 L closepath p F P
0 0 0 r
s
1 .298 .127 r
.5 .38446 m .49408 .37129 L .49093 .37185 L closepath p F P
0 0 0 r
s
.282 .42 .827 r
.5 .38446 m .51621 .36734 L .51703 .36945 L closepath p F P
0 0 0 r
s
.282 .42 .827 r
.5 .38446 m .51703 .36945 L .51785 .37155 L closepath p F P
0 0 0 r
s
1 .298 .127 r
.5 .38446 m .49093 .37185 L .48779 .37241 L closepath p F P
0 0 0 r
s
1 .298 .127 r
.5 .38446 m .48779 .37241 L .48464 .37297 L closepath p F P
0 0 0 r
s
1 .298 .127 r
.5 .38446 m .48464 .37297 L .4815 .37353 L closepath p F P
0 0 0 r
s
1 .298 .127 r
.5 .38446 m .4815 .37353 L .47836 .37409 L closepath p F P
0 0 0 r
s
1 .298 .127 r
.5 .38446 m .47836 .37409 L .47522 .37465 L closepath p F P
0 0 0 r
s
1 .298 .127 r
.5 .38446 m .47522 .37465 L .47209 .37521 L closepath p F P
0 0 0 r
s
.282 .42 .827 r
.5 .38446 m .51785 .37155 L .51867 .37364 L closepath p F P
0 0 0 r
s
.282 .42 .827 r
.5 .38446 m .51867 .37364 L .51948 .37573 L closepath p F P
0 0 0 r
s
.282 .42 .827 r
.5 .38446 m .51948 .37573 L .52029 .37781 L closepath p F P
0 0 0 r
s
.282 .42 .827 r
.5 .38446 m .52029 .37781 L .5211 .37988 L closepath p F P
0 0 0 r
s
.282 .42 .827 r
.5 .38446 m .5211 .37988 L .5219 .38195 L closepath p F P
0 0 0 r
s
.282 .42 .827 r
.5 .38446 m .5219 .38195 L .5227 .38401 L closepath p F P
0 0 0 r
s
.282 .42 .827 r
.5 .38446 m .5227 .38401 L .5235 .38606 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.51448 .3836 m
.52058 .39902 L
s
.294 .436 .852 r
.47561 .3835 m .47649 .38555 L .5 .38446 L closepath p F P
0 0 0 r
s
.294 .436 .852 r
.47473 .38144 m .47561 .3835 L .5 .38446 L closepath p F P
0 0 0 r
s
.294 .436 .852 r
.47385 .37937 m .47473 .38144 L .5 .38446 L closepath p F P
0 0 0 r
s
.294 .436 .852 r
.47297 .37729 m .47385 .37937 L .5 .38446 L closepath p F P
0 0 0 r
s
.294 .436 .852 r
.47209 .37521 m .47297 .37729 L .5 .38446 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.4961 .37658 m
.50384 .39558 L
s
.24 .35 .67 r
.48558 .38869 m
.51448 .3836 L
s
.642 .174 .075 r
.65702 .56451 m .67744 .56147 L .67688 .57957 L p F P
0 0 0 r
s
.24 .35 .67 r
.6773 .5658 m
.67927 .57204 L
s
.642 .174 .075 r
.67688 .57957 m .65653 .58255 L .65702 .56451 L p F P
0 0 0 r
s
.267 .399 .794 r
.545 .38627 m .54652 .39033 L .5235 .38606 L p F P
0 0 0 r
s
.267 .399 .794 r
.5235 .38606 m .5227 .38401 L .545 .38627 L p F P
0 0 0 r
s
.307 .437 .803 r
.3774 .50838 m .37108 .49697 L .36513 .51617 L p F P
0 0 0 r
s
.307 .437 .803 r
.36513 .51617 m .37179 .52791 L .3774 .50838 L p F P
0 0 0 r
s
.24 .35 .67 r
.37483 .52173 m
.3849 .49745 L
s
.37483 .52173 m
.3877 .54463 L
s
.5102 .73421 m
.49961 .71479 L
s
.5102 .73421 m
.5387 .7361 L
s
.222 .338 .69 r
.58914 .4065 m .59176 .4141 L .57066 .40308 L p F P
0 0 0 r
s
.222 .338 .69 r
.57066 .40308 m .56855 .39718 L .58914 .4065 L p F P
0 0 0 r
s
.83 .24 .1 r
.58314 .38172 m
.58967 .40486 L
s
.304 .448 .87 r
.47649 .38555 m .47561 .3835 L .45164 .38526 L p F P
0 0 0 r
s
.304 .448 .87 r
.45164 .38526 m .45345 .38932 L .47649 .38555 L p F P
0 0 0 r
s
.146 .23 .499 r
.62752 .44219 m .63083 .45239 L .61385 .43621 L p F P
0 0 0 r
s
.146 .23 .499 r
.61385 .43621 m .61086 .42723 L .62752 .44219 L p F P
0 0 0 r
s
.83 .24 .1 r
.77083 .4911 m
.81199 .48467 L
s
.77083 .4911 m
.77494 .51935 L
s
.568 .15 .065 r
.59613 .5914 m .61615 .58847 L .61304 .60467 L p F P
0 0 0 r
s
.568 .15 .065 r
.61304 .60467 m .59356 .60749 L .59613 .5914 L p F P
0 0 0 r
s
.077 .112 .279 r
.6557 .48825 m .65932 .49983 L .64836 .4808 L p F P
0 0 0 r
s
.077 .112 .279 r
.64836 .4808 m .64489 .46985 L .6557 .48825 L p F P
0 0 0 r
s
.83 .24 .1 r
.73394 .5256 m
.77494 .51935 L
s
.73394 .5256 m
.73706 .55175 L
s
.317 .464 .889 r
.43411 .40162 m .43137 .3957 L .41073 .40459 L p F P
0 0 0 r
s
.317 .464 .889 r
.41073 .40459 m .41441 .41222 L .43411 .40162 L p F P
0 0 0 r
s
.24 .35 .67 r
.64642 .69 m
.66493 .66798 L
s
.66493 .66798 m
.65747 .64719 L
s
.467 .119 .052 r
.51663 .6186 m .53571 .61584 L .53387 .62919 L p F P
0 0 0 r
s
.467 .119 .052 r
.53387 .62919 m .51577 .63177 L .51663 .6186 L p F P
0 0 0 r
s
.267 .399 .794 r
.54348 .38219 m .545 .38627 L .5227 .38401 L p F P
0 0 0 r
s
.267 .399 .794 r
.5227 .38401 m .5219 .38195 L .54348 .38219 L p F P
0 0 0 r
s
.247 .373 .75 r
.56642 .39122 m .56855 .39718 L .54652 .39033 L p F P
0 0 0 r
s
.247 .373 .75 r
.54652 .39033 m .545 .38627 L .56642 .39122 L p F P
0 0 0 r
s
.83 .24 .1 r
.55021 .38747 m
.58314 .38172 L
s
.45478 .63523 m
.4943 .62956 L
s
.33 .077 .034 r
.42659 .6445 m .44426 .64198 L .44866 .65145 L p F P
0 0 0 r
s
.33 .077 .034 r
.44866 .65145 m .43237 .65375 L .42659 .6445 L p F P
0 0 0 r
s
.304 .448 .87 r
.47561 .3835 m .47473 .38144 L .44983 .38117 L p F P
0 0 0 r
s
.304 .448 .87 r
.44983 .38117 m .45164 .38526 L .47561 .3835 L p F P
0 0 0 r
s
.83 .24 .1 r
.41742 .39055 m
.45132 .38453 L
s
.323 .468 .885 r
.40109 .43398 m .39657 .42497 L .38099 .43963 L p F P
0 0 0 r
s
.323 .468 .885 r
.38099 .43963 m .38632 .44987 L .40109 .43398 L p F P
0 0 0 r
s
.24 .35 .67 r
.3874 .45035 m
.40741 .42972 L
s
.44974 .69509 m
.4379 .67484 L
s
.44974 .69509 m
.4729 .70746 L
s
.51448 .3836 m
.54306 .38331 L
s
.83 .24 .1 r
.66415 .36756 m
.66978 .39112 L
s
.66978 .39112 m
.71048 .38414 L
s
.311 .457 .882 r
.45345 .38932 m .45164 .38526 L .4286 .38973 L p F P
0 0 0 r
s
.311 .457 .882 r
.4286 .38973 m .43137 .3957 L .45345 .38932 L p F P
0 0 0 r
s
.247 .347 .604 r
.67328 .5683 m .67688 .57957 L .67744 .56147 L p F P
0 0 0 r
s
.247 .347 .604 r
.67744 .56147 m .67383 .54997 L .67328 .5683 L p F P
0 0 0 r
s
.83 .24 .1 r
.65553 .56389 m
.67349 .56122 L
s
.67719 .56067 m
.69608 .55785 L
s
.31983 .38238 m
.33015 .39061 L
s
.33015 .39061 m
.36905 .38363 L
s
.33207 .66656 m
.37098 .66105 L
s
.33207 .66656 m
.32367 .67596 L
s
.267 .399 .794 r
.54194 .37808 m .54348 .38219 L .5219 .38195 L p F P
0 0 0 r
s
.267 .399 .794 r
.5219 .38195 m .5211 .37988 L .54194 .37808 L p F P
0 0 0 r
s
.189 .292 .609 r
.60782 .41812 m .61086 .42723 L .59176 .4141 L p F P
0 0 0 r
s
.24 .35 .67 r
.60371 .42328 m
.61212 .44816 L
s
.189 .292 .609 r
.59176 .4141 m .58914 .4065 L .60782 .41812 L p F P
0 0 0 r
s
.24 .35 .67 r
.57941 .41375 m
.60371 .42328 L
s
.83 .24 .1 r
.80732 .45523 m
.80253 .42565 L
s
.81199 .48467 m
.80732 .45523 L
s
.304 .448 .87 r
.47473 .38144 m .47385 .37937 L .448 .37705 L p F P
0 0 0 r
s
.304 .448 .87 r
.448 .37705 m .44983 .38117 L .47473 .38144 L p F P
0 0 0 r
s
.317 .455 .846 r
.37997 .47809 m .37406 .4671 L .36465 .48534 L p F P
0 0 0 r
s
.317 .455 .846 r
.36465 .48534 m .37108 .49697 L .37997 .47809 L p F P
0 0 0 r
s
.83 .24 .1 r
.58314 .38172 m
.62342 .37468 L
s
.568 .15 .065 r
.61615 .58847 m .63629 .58552 L .63262 .60184 L p F P
0 0 0 r
s
.568 .15 .065 r
.63262 .60184 m .61304 .60467 L .61615 .58847 L p F P
0 0 0 r
s
.83 .24 .1 r
.57589 .59879 m
.61609 .59293 L
s
.61542 .56987 m
.61609 .59293 L
s
.467 .119 .052 r
.53571 .61584 m .5549 .61307 L .55206 .6266 L p F P
0 0 0 r
s
.467 .119 .052 r
.55206 .6266 m .53387 .62919 L .53571 .61584 L p F P
0 0 0 r
s
.83 .24 .1 r
.53425 .62383 m
.53612 .6046 L
s
.33 .077 .034 r
.44426 .64198 m .46201 .63945 L .46501 .64914 L p F P
0 0 0 r
s
.33 .077 .034 r
.46501 .64914 m .44866 .65145 L .44426 .64198 L p F P
0 0 0 r
s
.208 .282 .479 r
.38274 .58789 m .37621 .57679 L .37957 .59347 L p F P
0 0 0 r
s
.208 .282 .479 r
.37957 .59347 m .38589 .60412 L .38274 .58789 L p F P
0 0 0 r
s
.24 .35 .67 r
.38349 .56929 m
.38516 .59358 L
s
.83 .24 .1 r
.75162 .37708 m
.75653 .40383 L
s
.75653 .40383 m
.79778 .39691 L
s
.191 .261 .437 r
.67015 .53825 m .67383 .54997 L .6703 .53079 L p F P
0 0 0 r
s
.191 .261 .437 r
.6703 .53079 m .66666 .51911 L .67015 .53825 L p F P
0 0 0 r
s
.83 .24 .1 r
.80253 .42565 m
.79778 .39691 L
s
.267 .399 .794 r
.5404 .37394 m .54194 .37808 L .5211 .37988 L p F P
0 0 0 r
s
.267 .399 .794 r
.5211 .37988 m .52029 .37781 L .5404 .37394 L p F P
0 0 0 r
s
.11 .17 .391 r
.64136 .45871 m .64489 .46985 L .63083 .45239 L p F P
0 0 0 r
s
.24 .35 .67 r
.63263 .46223 m
.64878 .48035 L
s
.11 .17 .391 r
.63083 .45239 m .62752 .44219 L .64136 .45871 L p F P
0 0 0 r
s
.321 .468 .89 r
.41441 .41222 m .41073 .40459 L .39198 .41583 L p F P
0 0 0 r
s
.321 .468 .89 r
.39198 .41583 m .39657 .42497 L .41441 .41222 L p F P
0 0 0 r
s
.83 .24 .1 r
.19172 .40163 m
.20372 .40341 L
s
.20372 .40341 m
.242 .39647 L
s
.222 .338 .69 r
.58648 .3988 m .58914 .4065 L .56855 .39718 L p F P
0 0 0 r
s
.222 .338 .69 r
.56855 .39718 m .56642 .39122 L .58648 .3988 L p F P
0 0 0 r
s
.247 .373 .75 r
.56426 .38521 m .56642 .39122 L .545 .38627 L p F P
0 0 0 r
s
.247 .373 .75 r
.545 .38627 m .54348 .38219 L .56426 .38521 L p F P
0 0 0 r
s
.304 .448 .87 r
.47385 .37937 m .47297 .37729 L .44616 .37291 L p F P
0 0 0 r
s
.304 .448 .87 r
.44616 .37291 m .448 .37705 L .47385 .37937 L p F P
0 0 0 r
s
.257 .356 .631 r
.37582 .55863 m .36913 .54708 L .36955 .56546 L p F P
0 0 0 r
s
.257 .356 .631 r
.36955 .56546 m .37621 .57679 L .37582 .55863 L p F P
0 0 0 r
s
.162 .212 .366 r
.39209 .61456 m .38589 .60412 L .39184 .61822 L p F P
0 0 0 r
s
.162 .212 .366 r
.39184 .61822 m .39767 .62799 L .39209 .61456 L p F P
0 0 0 r
s
.24 .35 .67 r
.38516 .59358 m
.39786 .61514 L
s
.311 .457 .882 r
.45164 .38526 m .44983 .38117 L .42581 .3837 L p F P
0 0 0 r
s
.311 .457 .882 r
.42581 .3837 m .4286 .38973 L .45164 .38526 L p F P
0 0 0 r
s
.83 .24 .1 r
.69608 .55785 m
.73706 .55175 L
s
.69608 .55785 m
.6978 .581 L
s
.81639 .51303 m
.81199 .48467 L
s
.317 .464 .889 r
.43137 .3957 m .4286 .38973 L .407 .39687 L p F P
0 0 0 r
s
.317 .464 .889 r
.407 .39687 m .41073 .40459 L .43137 .3957 L p F P
0 0 0 r
s
.267 .399 .794 r
.53885 .36978 m .5404 .37394 L .52029 .37781 L p F P
0 0 0 r
s
.267 .399 .794 r
.52029 .37781 m .51948 .37573 L .53885 .36978 L p F P
0 0 0 r
s
.24 .35 .67 r
.5387 .7361 m
.52862 .71659 L
s
.5387 .7361 m
.56804 .73233 L
s
.568 .15 .065 r
.63629 .58552 m .65653 .58255 L .65231 .599 L p F P
0 0 0 r
s
.568 .15 .065 r
.65231 .599 m .63262 .60184 L .63629 .58552 L p F P
0 0 0 r
s
.33 .077 .034 r
.46201 .63945 m .47984 .6369 L .48144 .64682 L p F P
0 0 0 r
s
.33 .077 .034 r
.48144 .64682 m .46501 .64914 L .46201 .63945 L p F P
0 0 0 r
s
.304 .448 .87 r
.47297 .37729 m .47209 .37521 L .44431 .36874 L p F P
0 0 0 r
s
.304 .448 .87 r
.44431 .36874 m .44616 .37291 L .47297 .37729 L p F P
0 0 0 r
s
.83 .24 .1 r
.47236 .38079 m
.4961 .37658 L
s
.467 .119 .052 r
.5549 .61307 m .57418 .61028 L .57033 .62399 L p F P
0 0 0 r
s
.467 .119 .052 r
.57033 .62399 m .55206 .6266 L .5549 .61307 L p F P
0 0 0 r
s
.83 .24 .1 r
.77494 .51935 m
.81639 .51303 L
s
.77494 .51935 m
.77848 .54557 L
s
.322 .464 .871 r
.38632 .44987 m .38099 .43963 L .36805 .45591 L p F P
0 0 0 r
s
.322 .464 .871 r
.36805 .45591 m .37406 .4671 L .38632 .44987 L p F P
0 0 0 r
s
.288 .406 .735 r
.37179 .52791 m .36513 .51617 L .3623 .53529 L p F P
0 0 0 r
s
.288 .406 .735 r
.3623 .53529 m .36913 .54708 L .37179 .52791 L p F P
0 0 0 r
s
.24 .35 .67 r
.37039 .54663 m
.37483 .52173 L
s
.83 .24 .1 r
.4943 .62956 m
.53425 .62383 L
s
.24 .35 .67 r
.62331 .70869 m
.64642 .69 L
s
.64642 .69 m
.63854 .66954 L
s
.054 .079 .187 r
.66295 .50719 m .66666 .51911 L .65932 .49983 L p F P
0 0 0 r
s
.054 .079 .187 r
.65932 .49983 m .6557 .48825 L .66295 .50719 L p F P
0 0 0 r
s
.24 .35 .67 r
.64878 .48035 m
.65632 .50418 L
s
.146 .23 .499 r
.62417 .43183 m .62752 .44219 L .61086 .42723 L p F P
0 0 0 r
s
.146 .23 .499 r
.61086 .42723 m .60782 .41812 L .62417 .43183 L p F P
0 0 0 r
s
.83 .24 .1 r
.70531 .36037 m
.71048 .38414 L
s
.71048 .38414 m
.75162 .37708 L
s
.267 .399 .794 r
.53729 .3656 m .53885 .36978 L .51948 .37573 L p F P
0 0 0 r
s
.267 .399 .794 r
.51948 .37573 m .51867 .37364 L .53729 .3656 L p F P
0 0 0 r
s
.247 .373 .75 r
.56209 .37914 m .56426 .38521 L .54348 .38219 L p F P
0 0 0 r
s
.24 .35 .67 r
.54306 .38331 m
.55267 .40902 L
s
.247 .373 .75 r
.54348 .38219 m .54194 .37808 L .56209 .37914 L p F P
0 0 0 r
s
.83 .24 .1 r
.35938 .37522 m
.36905 .38363 L
s
.36905 .38363 m
.40836 .37656 L
s
1 .303 .129 r
.45054 .36762 m .44431 .36874 L .47209 .37521 L p F P
0 0 0 r
s
1 .303 .129 r
.47209 .37521 m .47522 .37465 L .45054 .36762 L p F P
0 0 0 r
s
.83 .24 .1 r
.37098 .66105 m
.4103 .65549 L
s
.37098 .66105 m
.36325 .6704 L
s
.071 .103 .253 r
.40339 .63758 m .39767 .62799 L .40584 .6387 L p F P
0 0 0 r
s
.071 .103 .253 r
.40584 .6387 m .41104 .64744 L .40339 .63758 L p F P
0 0 0 r
s
1 .303 .129 r
.45678 .3665 m .45054 .36762 L .47522 .37465 L p F P
0 0 0 r
s
.83 .24 .1 r
.4481 .36942 m
.45123 .37468 L
s
1 .303 .129 r
.47522 .37465 m .47836 .37409 L .45678 .3665 L p F P
0 0 0 r
s
.311 .457 .882 r
.44983 .38117 m .448 .37705 L .42299 .37762 L p F P
0 0 0 r
s
.311 .457 .882 r
.42299 .37762 m .42581 .3837 L .44983 .38117 L p F P
0 0 0 r
s
.33 .077 .034 r
.47984 .6369 m .49777 .63434 L .49794 .64449 L p F P
0 0 0 r
s
.33 .077 .034 r
.49794 .64449 m .48144 .64682 L .47984 .6369 L p F P
0 0 0 r
s
.83 .24 .1 r
.49024 .64418 m
.4943 .62956 L
s
.61734 .35506 m
.62342 .37468 L
s
.62342 .37468 m
.66415 .36756 L
s
1 .303 .129 r
.46304 .36538 m .45678 .3665 L .47836 .37409 L p F P
0 0 0 r
s
1 .303 .129 r
.47836 .37409 m .4815 .37353 L .46304 .36538 L p F P
0 0 0 r
s
.568 .15 .065 r
.65653 .58255 m .67688 .57957 L .6721 .59614 L p F P
0 0 0 r
s
.568 .15 .065 r
.6721 .59614 m .65231 .599 L .65653 .58255 L p F P
0 0 0 r
s
.83 .24 .1 r
.65553 .56389 m
.65673 .587 L
s
.61609 .59293 m
.65673 .587 L
s
.24 .35 .67 r
.67086 .62267 m
.67819 .5972 L
s
.189 .292 .609 r
.60474 .40888 m .60782 .41812 L .58914 .4065 L p F P
0 0 0 r
s
.189 .292 .609 r
.58914 .4065 m .58648 .3988 L .60474 .40888 L p F P
0 0 0 r
s
.467 .119 .052 r
.57418 .61028 m .59356 .60749 L .5887 .62137 L p F P
0 0 0 r
s
.467 .119 .052 r
.5887 .62137 m .57033 .62399 L .57418 .61028 L p F P
0 0 0 r
s
.83 .24 .1 r
.57463 .61804 m
.57589 .59879 L
s
.323 .468 .885 r
.39657 .42497 m .39198 .41583 L .37558 .42922 L p F P
0 0 0 r
s
.323 .468 .885 r
.37558 .42922 m .38099 .43963 L .39657 .42497 L p F P
0 0 0 r
s
.267 .399 .794 r
.53572 .36138 m .53729 .3656 L .51867 .37364 L p F P
0 0 0 r
s
.267 .399 .794 r
.51867 .37364 m .51785 .37155 L .53572 .36138 L p F P
0 0 0 r
s
.83 .24 .1 r
.4961 .37658 m
.51999 .37234 L
s
.222 .338 .69 r
.5838 .391 m .58648 .3988 L .56642 .39122 L p F P
0 0 0 r
s
.222 .338 .69 r
.56642 .39122 m .56426 .38521 L .5838 .391 L p F P
0 0 0 r
s
1 .303 .129 r
.4693 .36425 m .46304 .36538 L .4815 .37353 L p F P
0 0 0 r
s
1 .303 .129 r
.4815 .37353 m .48464 .37297 L .4693 .36425 L p F P
0 0 0 r
s
.24 .35 .67 r
.47901 .37301 m
.48558 .38869 L
s
.307 .437 .803 r
.37108 .49697 m .36465 .48534 L .35833 .50419 L p F P
0 0 0 r
s
.307 .437 .803 r
.35833 .50419 m .36513 .51617 L .37108 .49697 L p F P
0 0 0 r
s
.83 .24 .1 r
.79778 .39691 m
.79321 .36995 L
s
1 .303 .129 r
.47558 .36312 m .4693 .36425 L .48464 .37297 L p F P
0 0 0 r
s
.24 .35 .67 r
.47451 .3623 m
.47491 .36324 L
s
1 .303 .129 r
.48464 .37297 m .48779 .37241 L .47558 .36312 L p F P
0 0 0 r
s
.83 .24 .1 r
.23067 .39455 m
.242 .39647 L
s
.242 .39647 m
.28071 .38947 L
s
.077 .112 .279 r
.65201 .47645 m .6557 .48825 L .64489 .46985 L p F P
0 0 0 r
s
.077 .112 .279 r
.64489 .46985 m .64136 .45871 L .65201 .47645 L p F P
0 0 0 r
s
1 .303 .129 r
.48186 .36199 m .47558 .36312 L .48779 .37241 L p F P
0 0 0 r
s
1 .303 .129 r
.48779 .37241 m .49093 .37185 L .48186 .36199 L p F P
0 0 0 r
s
.24 .35 .67 r
.56804 .73233 m
.55853 .71267 L
s
.56804 .73233 m
.59673 .72305 L
s
.83 .24 .1 r
.24578 .68689 m
.28452 .68145 L
s
.24578 .68689 m
.23452 .69047 L
s
.317 .464 .889 r
.4286 .38973 m .42581 .3837 L .40323 .38905 L p F P
0 0 0 r
s
.83 .24 .1 r
.40836 .37656 m
.41469 .38634 L
s
.41669 .38941 m
.41742 .39055 L
s
.317 .464 .889 r
.40323 .38905 m .407 .39687 L .4286 .38973 L p F P
0 0 0 r
s
.321 .468 .89 r
.41073 .40459 m .407 .39687 L .38733 .40656 L p F P
0 0 0 r
s
.321 .468 .89 r
.38733 .40656 m .39198 .41583 L .41073 .40459 L p F P
0 0 0 r
s
1 .303 .129 r
.48816 .36086 m .48186 .36199 L .49093 .37185 L p F P
0 0 0 r
s
1 .303 .129 r
.49093 .37185 m .49408 .37129 L .48816 .36086 L p F P
0 0 0 r
s
.24 .35 .67 r
.59673 .72305 m
.62331 .70869 L
s
.62331 .70869 m
.61493 .68853 L
s
.267 .399 .794 r
.53413 .35714 m .53572 .36138 L .51785 .37155 L p F P
0 0 0 r
s
.267 .399 .794 r
.51785 .37155 m .51703 .36945 L .53413 .35714 L p F P
0 0 0 r
s
.247 .373 .75 r
.5599 .37302 m .56209 .37914 L .54194 .37808 L p F P
0 0 0 r
s
.247 .373 .75 r
.54194 .37808 m .5404 .37394 L .5599 .37302 L p F P
0 0 0 r
s
.24 .35 .67 r
.41772 .65582 m
.41905 .65806 L
s
.83 .24 .1 r
.73706 .55175 m
.77848 .54557 L
s
.73706 .55175 m
.73933 .57494 L
s
1 .303 .129 r
.49447 .35972 m .48816 .36086 L .49408 .37129 L p F P
0 0 0 r
s
1 .303 .129 r
.49408 .37129 m .49724 .37073 L .49447 .35972 L p F P
0 0 0 r
s
.33 .077 .034 r
.49777 .63434 m .51577 .63177 L .51452 .64214 L p F P
0 0 0 r
s
.33 .077 .034 r
.51452 .64214 m .49794 .64449 L .49777 .63434 L p F P
0 0 0 r
s
1 .303 .129 r
.50079 .35859 m .49447 .35972 L .49724 .37073 L p F P
0 0 0 r
s
.83 .24 .1 r
.48828 .36221 m
.4961 .37658 L
s
1 .303 .129 r
.49724 .37073 m .50039 .37016 L .50079 .35859 L p F P
0 0 0 r
s
.467 .119 .052 r
.59356 .60749 m .61304 .60467 L .60715 .61874 L p F P
0 0 0 r
s
.467 .119 .052 r
.60715 .61874 m .5887 .62137 L .59356 .60749 L p F P
0 0 0 r
s
.288 .411 .737 r
.66855 .58534 m .6721 .59614 L .67688 .57957 L p F P
0 0 0 r
s
.24 .35 .67 r
.67481 .58675 m
.67819 .5972 L
s
.288 .411 .737 r
.67688 .57957 m .67328 .5683 L .66855 .58534 L p F P
0 0 0 r
s
.24 .35 .67 r
.59673 .72305 m
.5878 .70317 L
s
.311 .457 .882 r
.448 .37705 m .44616 .37291 L .42015 .37149 L p F P
0 0 0 r
s
.311 .457 .882 r
.42015 .37149 m .42299 .37762 L .448 .37705 L p F P
0 0 0 r
s
1 .303 .129 r
.50712 .35745 m .50079 .35859 L .50039 .37016 L p F P
0 0 0 r
s
1 .303 .129 r
.50039 .37016 m .50355 .3696 L .50712 .35745 L p F P
0 0 0 r
s
.24 .35 .67 r
.4729 .70746 m
.46142 .68725 L
s
.4729 .70746 m
.49961 .71479 L
s
.83 .24 .1 r
.82036 .53933 m
.81639 .51303 L
s
1 .303 .129 r
.51346 .35631 m .50712 .35745 L .50355 .3696 L p F P
0 0 0 r
s
1 .303 .129 r
.50355 .3696 m .50671 .36904 L .51346 .35631 L p F P
0 0 0 r
s
.24 .35 .67 r
.50395 .35701 m
.50433 .35795 L
s
.83 .24 .1 r
.53425 .62383 m
.57463 .61804 L
s
.317 .455 .846 r
.37406 .4671 m .36805 .45591 L .35808 .47348 L p F P
0 0 0 r
s
.317 .455 .846 r
.35808 .47348 m .36465 .48534 L .37406 .4671 L p F P
0 0 0 r
s
.24 .35 .67 r
.37184 .47335 m
.3849 .49745 L
s
.267 .399 .794 r
.53254 .35288 m .53413 .35714 L .51703 .36945 L p F P
0 0 0 r
s
.267 .399 .794 r
.51703 .36945 m .51621 .36734 L .53254 .35288 L p F P
0 0 0 r
s
.247 .347 .604 r
.6696 .5568 m .67328 .5683 L .67383 .54997 L p F P
0 0 0 r
s
.247 .347 .604 r
.67383 .54997 m .67015 .53825 L .6696 .5568 L p F P
0 0 0 r
s
.24 .35 .67 r
.66713 .52558 m
.67011 .53972 L
s
1 .303 .129 r
.51981 .35517 m .51346 .35631 L .50671 .36904 L p F P
0 0 0 r
s
1 .303 .129 r
.50671 .36904 m .50988 .36847 L .51981 .35517 L p F P
0 0 0 r
s
.11 .17 .391 r
.63776 .44736 m .64136 .45871 L .62752 .44219 L p F P
0 0 0 r
s
.11 .17 .391 r
.62752 .44219 m .62417 .43183 L .63776 .44736 L p F P
0 0 0 r
s
.24 .35 .67 r
.62455 .43735 m
.63263 .46223 L
s
.83 .24 .1 r
.74693 .35309 m
.75162 .37708 L
s
.75162 .37708 m
.79321 .36995 L
s
.67515 .58431 m
.6978 .581 L
s
.65673 .587 m
.66857 .58527 L
s
1 .303 .129 r
.52617 .35402 m .51981 .35517 L .50988 .36847 L p F P
0 0 0 r
s
1 .303 .129 r
.50988 .36847 m .51304 .36791 L .52617 .35402 L p F P
0 0 0 r
s
.83 .24 .1 r
.40836 .37656 m
.42141 .37422 L
s
.40327 .66478 m
.4103 .65549 L
s
.24 .35 .67 r
.65747 .64719 m
.67086 .62267 L
s
1 .303 .129 r
.53254 .35288 m .52617 .35402 L .51304 .36791 L p F P
0 0 0 r
s
1 .303 .129 r
.51304 .36791 m .51621 .36734 L .53254 .35288 L p F P
0 0 0 r
s
.24 .35 .67 r
.50823 .3678 m
.51448 .3836 L
s
.33 .077 .034 r
.51577 .63177 m .53387 .62919 L .53117 .63979 L p F P
0 0 0 r
s
.33 .077 .034 r
.53117 .63979 m .51452 .64214 L .51577 .63177 L p F P
0 0 0 r
s
.222 .338 .69 r
.58108 .38311 m .5838 .391 L .56426 .38521 L p F P
0 0 0 r
s
.24 .35 .67 r
.57026 .38792 m
.57941 .41375 L
s
.222 .338 .69 r
.56426 .38521 m .56209 .37914 L .58108 .38311 L p F P
0 0 0 r
s
.24 .35 .67 r
.54306 .38331 m
.57026 .38792 L
s
.83 .24 .1 r
.57649 .36231 m
.58314 .38172 L
s
.238 .055 .023 r
.41616 .65604 m .43237 .65375 L .43996 .65959 L p F P
0 0 0 r
s
.238 .055 .023 r
.43996 .65959 m .42554 .66161 L .41616 .65604 L p F P
0 0 0 r
s
.105 .162 .375 r
.41616 .65604 m .41104 .64744 L .42107 .65402 L p F P
0 0 0 r
s
.83 .24 .1 r
.4103 .65549 m
.41513 .6548 L
s
.41513 .6548 m
.41533 .65478 L
s
.105 .162 .375 r
.42107 .65402 m .42554 .66161 L .41616 .65604 L p F P
0 0 0 r
s
.247 .373 .75 r
.55768 .36684 m .5599 .37302 L .5404 .37394 L p F P
0 0 0 r
s
.247 .373 .75 r
.5404 .37394 m .53885 .36978 L .55768 .36684 L p F P
0 0 0 r
s
.208 .282 .479 r
.37621 .57679 m .36955 .56546 L .37311 .58262 L p F P
0 0 0 r
s
.24 .35 .67 r
.37039 .54663 m
.38349 .56929 L
s
.208 .282 .479 r
.37311 .58262 m .37957 .59347 L .37621 .57679 L p F P
0 0 0 r
s
.467 .119 .052 r
.61304 .60467 m .63262 .60184 L .6257 .61609 L p F P
0 0 0 r
s
.467 .119 .052 r
.6257 .61609 m .60715 .61874 L .61304 .60467 L p F P
0 0 0 r
s
.83 .24 .1 r
.61545 .61219 m
.61609 .59293 L
s
.65864 .34773 m
.66415 .36756 L
s
.66415 .36756 m
.70531 .36037 L
s
.191 .261 .437 r
.66639 .52627 m .67015 .53825 L .66666 .51911 L p F P
0 0 0 r
s
.191 .261 .437 r
.66666 .51911 m .66295 .50719 L .66639 .52627 L p F P
0 0 0 r
s
.146 .23 .499 r
.62075 .42129 m .62417 .43183 L .60782 .41812 L p F P
0 0 0 r
s
.24 .35 .67 r
.60371 .42328 m
.62455 .43735 L
s
.146 .23 .499 r
.60782 .41812 m .60474 .40888 L .62075 .42129 L p F P
0 0 0 r
s
.162 .212 .366 r
.38589 .60412 m .37957 .59347 L .3859 .60827 L p F P
0 0 0 r
s
.162 .212 .366 r
.3859 .60827 m .39184 .61822 L .38589 .60412 L p F P
0 0 0 r
s
.24 .35 .67 r
.38516 .59358 m
.39286 .61646 L
s
.322 .464 .871 r
.38099 .43963 m .37558 .42922 L .36192 .44451 L p F P
0 0 0 r
s
.322 .464 .871 r
.36192 .44451 m .36805 .45591 L .38099 .43963 L p F P
0 0 0 r
s
.24 .35 .67 r
.37184 .47335 m
.3874 .45035 L
s
.311 .457 .882 r
.44616 .37291 m .44431 .36874 L .41727 .36529 L p F P
0 0 0 r
s
.311 .457 .882 r
.41727 .36529 m .42015 .37149 L .44616 .37291 L p F P
0 0 0 r
s
.24 .35 .67 r
.44581 .37219 m
.45743 .39834 L
s
.83 .24 .1 r
.44117 .37067 m
.4481 .36942 L
s
.189 .292 .609 r
.60162 .3995 m .60474 .40888 L .58648 .3988 L p F P
0 0 0 r
s
.189 .292 .609 r
.58648 .3988 m .5838 .391 L .60162 .3995 L p F P
0 0 0 r
s
.317 .464 .889 r
.42581 .3837 m .42299 .37762 L .39941 .38114 L p F P
0 0 0 r
s
.317 .464 .889 r
.39941 .38114 m .40323 .38905 L .42581 .3837 L p F P
0 0 0 r
s
.24 .35 .67 r
.41889 .38628 m
.43105 .41218 L
s
.257 .356 .631 r
.36913 .54708 m .3623 .53529 L .36274 .5539 L p F P
0 0 0 r
s
.257 .356 .631 r
.36274 .5539 m .36955 .56546 L .36913 .54708 L p F P
0 0 0 r
s
.83 .24 .1 r
.27004 .3874 m
.28071 .38947 L
s
.28071 .38947 m
.31983 .38238 L
s
.28452 .68145 m
.32367 .67596 L
s
.28452 .68145 m
.27392 .68495 L
s
.33 .077 .034 r
.53387 .62919 m .55206 .6266 L .54789 .63743 L p F P
0 0 0 r
s
.33 .077 .034 r
.54789 .63743 m .53117 .63979 L .53387 .62919 L p F P
0 0 0 r
s
.238 .055 .023 r
.43237 .65375 m .44866 .65145 L .45442 .65756 L p F P
0 0 0 r
s
.238 .055 .023 r
.45442 .65756 m .43996 .65959 L .43237 .65375 L p F P
0 0 0 r
s
.24 .35 .67 r
.41905 .65806 m
.4379 .67484 L
s
.323 .468 .885 r
.39198 .41583 m .38733 .40656 L .37007 .41864 L p F P
0 0 0 r
s
.323 .468 .885 r
.37007 .41864 m .37558 .42922 L .39198 .41583 L p F P
0 0 0 r
s
.83 .24 .1 r
.77848 .54557 m
.82036 .53933 L
s
.77848 .54557 m
.78131 .56882 L
s
.321 .468 .89 r
.407 .39687 m .40323 .38905 L .38261 .39715 L p F P
0 0 0 r
s
.321 .468 .89 r
.38261 .39715 m .38733 .40656 L .407 .39687 L p F P
0 0 0 r
s
.24 .35 .67 r
.39472 .40408 m
.40741 .42972 L
s
.44581 .37219 m
.45633 .36856 L
s
.46839 .36441 m
.47451 .3623 L
s
.41889 .38628 m
.44581 .37219 L
s
.467 .119 .052 r
.63262 .60184 m .65231 .599 L .64434 .61343 L p F P
0 0 0 r
s
.467 .119 .052 r
.64434 .61343 m .6257 .61609 L .63262 .60184 L p F P
0 0 0 r
s
.054 .079 .187 r
.65916 .49503 m .66295 .50719 L .6557 .48825 L p F P
0 0 0 r
s
.24 .35 .67 r
.65972 .50189 m
.66509 .51905 L
s
.054 .079 .187 r
.6557 .48825 m .65201 .47645 L .65916 .49503 L p F P
0 0 0 r
s
.24 .35 .67 r
.64878 .48035 m
.65972 .50189 L
s
.288 .406 .735 r
.36513 .51617 m .35833 .50419 L .35533 .52326 L p F P
0 0 0 r
s
.288 .406 .735 r
.35533 .52326 m .3623 .53529 L .36513 .51617 L p F P
0 0 0 r
s
.247 .373 .75 r
.55545 .3606 m .55768 .36684 L .53885 .36978 L p F P
0 0 0 r
s
.83 .24 .1 r
.53857 .36904 m
.54096 .36862 L
s
.55728 .36572 m
.57649 .36231 L
s
.247 .373 .75 r
.53885 .36978 m .53729 .3656 L .55545 .3606 L p F P
0 0 0 r
s
.071 .103 .253 r
.39767 .62799 m .39184 .61822 L .40055 .6298 L p F P
0 0 0 r
s
.071 .103 .253 r
.40055 .6298 m .40584 .6387 L .39767 .62799 L p F P
0 0 0 r
s
.24 .35 .67 r
.39286 .61646 m
.40556 .63782 L
s
.83 .24 .1 r
.57463 .61804 m
.61545 .61219 L
s
.24 .35 .67 r
.39472 .40408 m
.41889 .38628 L
s
.994 .301 .128 r
.4265 .36362 m .41727 .36529 L .44431 .36874 L p F P
0 0 0 r
s
.994 .301 .128 r
.44431 .36874 m .45054 .36762 L .4265 .36362 L p F P
0 0 0 r
s
.83 .24 .1 r
.57649 .36231 m
.61734 .35506 L
s
.238 .055 .023 r
.44866 .65145 m .46501 .64914 L .46895 .65552 L p F P
0 0 0 r
s
.83 .24 .1 r
.45005 .64986 m
.45478 .63523 L
s
.238 .055 .023 r
.46895 .65552 m .45442 .65756 L .44866 .65145 L p F P
0 0 0 r
s
.83 .24 .1 r
.421 .65397 m
.45005 .64986 L
s
.79321 .36995 m
.789 .34574 L
s
.6978 .581 m
.73933 .57494 L
s
.6978 .581 m
.69845 .60029 L
s
.222 .338 .69 r
.57833 .37513 m .58108 .38311 L .56209 .37914 L p F P
0 0 0 r
s
.222 .338 .69 r
.56209 .37914 m .5599 .37302 L .57833 .37513 L p F P
0 0 0 r
s
.33 .077 .034 r
.55206 .6266 m .57033 .62399 L .56469 .63505 L p F P
0 0 0 r
s
.33 .077 .034 r
.56469 .63505 m .54789 .63743 L .55206 .6266 L p F P
0 0 0 r
s
.994 .301 .128 r
.43575 .36194 m .4265 .36362 L .45054 .36762 L p F P
0 0 0 r
s
.994 .301 .128 r
.45054 .36762 m .45678 .3665 L .43575 .36194 L p F P
0 0 0 r
s
.24 .35 .67 r
.44375 .36754 m
.44581 .37219 L
s
.077 .112 .279 r
.64825 .46441 m .65201 .47645 L .64136 .45871 L p F P
0 0 0 r
s
.077 .112 .279 r
.64136 .45871 m .63776 .44736 L .64825 .46441 L p F P
0 0 0 r
s
.307 .437 .803 r
.36465 .48534 m .35808 .47348 L .35139 .49197 L p F P
0 0 0 r
s
.307 .437 .803 r
.35139 .49197 m .35833 .50419 L .36465 .48534 L p F P
0 0 0 r
s
.24 .35 .67 r
.36143 .49788 m
.37483 .52173 L
s
.467 .119 .052 r
.65231 .599 m .6721 .59614 L .66307 .61076 L p F P
0 0 0 r
s
.467 .119 .052 r
.66307 .61076 m .64434 .61343 L .65231 .599 L p F P
0 0 0 r
s
.83 .24 .1 r
.65672 .60627 m
.65673 .587 L
s
.317 .464 .889 r
.42299 .37762 m .42015 .37149 L .39554 .37313 L p F P
0 0 0 r
s
.83 .24 .1 r
.40667 .37495 m
.40836 .37656 L
s
.317 .464 .889 r
.39554 .37313 m .39941 .38114 L .42299 .37762 L p F P
0 0 0 r
s
.83 .24 .1 r
.70039 .34031 m
.70531 .36037 L
s
.70531 .36037 m
.74693 .35309 L
s
.994 .301 .128 r
.44503 .36027 m .43575 .36194 L .45678 .3665 L p F P
0 0 0 r
s
.994 .301 .128 r
.45678 .3665 m .46304 .36538 L .44503 .36027 L p F P
0 0 0 r
s
.24 .35 .67 r
.49961 .71479 m
.48858 .69456 L
s
.49961 .71479 m
.52862 .71659 L
s
.247 .373 .75 r
.55319 .3543 m .55545 .3606 L .53729 .3656 L p F P
0 0 0 r
s
.247 .373 .75 r
.53729 .3656 m .53572 .36138 L .55319 .3543 L p F P
0 0 0 r
s
.994 .301 .128 r
.45433 .35858 m .44503 .36027 L .46304 .36538 L p F P
0 0 0 r
s
.994 .301 .128 r
.46304 .36538 m .4693 .36425 L .45433 .35858 L p F P
0 0 0 r
s
.238 .055 .023 r
.46501 .64914 m .48144 .64682 L .48353 .65347 L p F P
0 0 0 r
s
.238 .055 .023 r
.48353 .65347 m .46895 .65552 L .46501 .64914 L p F P
0 0 0 r
s
.83 .24 .1 r
.30986 .38017 m
.31983 .38238 L
s
.31983 .38238 m
.35938 .37522 L
s
.11 .17 .391 r
.6341 .4358 m .63776 .44736 L .62417 .43183 L p F P
0 0 0 r
s
.11 .17 .391 r
.62417 .43183 m .62075 .42129 L .6341 .4358 L p F P
0 0 0 r
s
.189 .292 .609 r
.59845 .38998 m .60162 .3995 L .5838 .391 L p F P
0 0 0 r
s
.189 .292 .609 r
.5838 .391 m .58108 .38311 L .59845 .38998 L p F P
0 0 0 r
s
.24 .35 .67 r
.57026 .38792 m
.59497 .39738 L
s
.33 .077 .034 r
.57033 .62399 m .5887 .62137 L .58157 .63267 L p F P
0 0 0 r
s
.33 .077 .034 r
.58157 .63267 m .56469 .63505 L .57033 .62399 L p F P
0 0 0 r
s
.83 .24 .1 r
.57194 .63262 m
.57463 .61804 L
s
.32367 .67596 m
.36325 .6704 L
s
.32367 .67596 m
.31377 .67937 L
s
.24 .35 .67 r
.63854 .66954 m
.65747 .64719 L
s
.65747 .64719 m
.6497 .62554 L
s
.994 .301 .128 r
.46365 .3569 m .45433 .35858 L .4693 .36425 L p F P
0 0 0 r
s
.994 .301 .128 r
.4693 .36425 m .47558 .36312 L .46365 .3569 L p F P
0 0 0 r
s
.24 .35 .67 r
.47451 .3623 m
.50395 .35701 L
s
.317 .455 .846 r
.36805 .45591 m .36192 .44451 L .35139 .46138 L p F P
0 0 0 r
s
.317 .455 .846 r
.35139 .46138 m .35808 .47348 L .36805 .45591 L p F P
0 0 0 r
s
.24 .35 .67 r
.36143 .49788 m
.37184 .47335 L
s
.146 .23 .499 r
.61728 .41057 m .62075 .42129 L .60474 .40888 L p F P
0 0 0 r
s
.146 .23 .499 r
.60474 .40888 m .60162 .3995 L .61728 .41057 L p F P
0 0 0 r
s
.24 .35 .67 r
.59497 .39738 m
.60371 .42328 L
s
.288 .411 .737 r
.66493 .57433 m .66855 .58534 L .67328 .5683 L p F P
0 0 0 r
s
.288 .411 .737 r
.67328 .5683 m .6696 .5568 L .66493 .57433 L p F P
0 0 0 r
s
.83 .24 .1 r
.82375 .56262 m
.82036 .53933 L
s
.313 .45 .822 r
.65962 .60067 m .66307 .61076 L .6721 .59614 L p F P
0 0 0 r
s
.24 .35 .67 r
.6655 .60681 m
.67086 .62267 L
s
.313 .45 .822 r
.6721 .59614 m .66855 .58534 L .65962 .60067 L p F P
0 0 0 r
s
.24 .35 .67 r
.4379 .67484 m
.46142 .68725 L
s
.50395 .35701 m
.51013 .35691 L
s
.105 .162 .375 r
.41104 .64744 m .40584 .6387 L .41654 .64632 L p F P
0 0 0 r
s
.24 .35 .67 r
.41257 .64713 m
.41384 .64928 L
s
.105 .162 .375 r
.41654 .64632 m .42107 .65402 L .41104 .64744 L p F P
0 0 0 r
s
.994 .301 .128 r
.47299 .35521 m .46365 .3569 L .47558 .36312 L p F P
0 0 0 r
s
.994 .301 .128 r
.47558 .36312 m .48186 .36199 L .47299 .35521 L p F P
0 0 0 r
s
.83 .24 .1 r
.4481 .36942 m
.48828 .36221 L
s
.321 .468 .89 r
.40323 .38905 m .39941 .38114 L .37781 .3876 L p F P
0 0 0 r
s
.321 .468 .89 r
.37781 .3876 m .38261 .39715 L .40323 .38905 L p F P
0 0 0 r
s
.247 .347 .604 r
.66585 .54506 m .6696 .5568 L .67015 .53825 L p F P
0 0 0 r
s
.247 .347 .604 r
.67015 .53825 m .66639 .52627 L .66585 .54506 L p F P
0 0 0 r
s
.238 .055 .023 r
.48144 .64682 m .49794 .64449 L .49818 .65142 L p F P
0 0 0 r
s
.238 .055 .023 r
.49818 .65142 m .48353 .65347 L .48144 .64682 L p F P
0 0 0 r
s
.83 .24 .1 r
.45005 .64986 m
.49024 .64418 L
s
.322 .464 .871 r
.37558 .42922 m .37007 .41864 L .35568 .43289 L p F P
0 0 0 r
s
.322 .464 .871 r
.35568 .43289 m .36192 .44451 L .37558 .42922 L p F P
0 0 0 r
s
.24 .35 .67 r
.37422 .42498 m
.3874 .45035 L
s
.994 .301 .128 r
.48236 .35351 m .47299 .35521 L .48186 .36199 L p F P
0 0 0 r
s
.994 .301 .128 r
.48186 .36199 m .48816 .36086 L .48236 .35351 L p F P
0 0 0 r
s
.222 .338 .69 r
.57554 .36705 m .57833 .37513 L .5599 .37302 L p F P
0 0 0 r
s
.222 .338 .69 r
.5599 .37302 m .55768 .36684 L .57554 .36705 L p F P
0 0 0 r
s
.83 .24 .1 r
.61545 .61219 m
.65672 .60627 L
s
.18049 .40621 m
.19172 .40163 L
s
.19172 .40163 m
.23067 .39455 L
s
.33 .077 .034 r
.5887 .62137 m .60715 .61874 L .59852 .63027 L p F P
0 0 0 r
s
.33 .077 .034 r
.59852 .63027 m .58157 .63267 L .5887 .62137 L p F P
0 0 0 r
s
.323 .468 .885 r
.38733 .40656 m .38261 .39715 L .36447 .40788 L p F P
0 0 0 r
s
.323 .468 .885 r
.36447 .40788 m .37007 .41864 L .38733 .40656 L p F P
0 0 0 r
s
.24 .35 .67 r
.37422 .42498 m
.39472 .40408 L
s
.247 .373 .75 r
.55092 .34794 m .55319 .3543 L .53572 .36138 L p F P
0 0 0 r
s
.247 .373 .75 r
.53572 .36138 m .53413 .35714 L .55092 .34794 L p F P
0 0 0 r
s
.83 .24 .1 r
.61148 .34007 m
.61734 .35506 L
s
.61734 .35506 m
.65864 .34773 L
s
.73933 .57494 m
.78131 .56882 L
s
.73933 .57494 m
.74063 .59424 L
s
.994 .301 .128 r
.49176 .35181 m .48236 .35351 L .48816 .36086 L p F P
0 0 0 r
s
.994 .301 .128 r
.48816 .36086 m .49447 .35972 L .49176 .35181 L p F P
0 0 0 r
s
.24 .35 .67 r
.6673 .58749 m
.66822 .58434 L
s
.208 .282 .479 r
.36955 .56546 m .36274 .5539 L .36654 .57155 L p F P
0 0 0 r
s
.208 .282 .479 r
.36654 .57155 m .37311 .58262 L .36955 .56546 L p F P
0 0 0 r
s
.24 .35 .67 r
.37039 .54663 m
.37194 .57115 L
s
.317 .464 .889 r
.42015 .37149 m .41727 .36529 L .39162 .36502 L p F P
0 0 0 r
s
.317 .464 .889 r
.39162 .36502 m .39554 .37313 L .42015 .37149 L p F P
0 0 0 r
s
.162 .212 .366 r
.37957 .59347 m .37311 .58262 L .37985 .59813 L p F P
0 0 0 r
s
.162 .212 .366 r
.37985 .59813 m .3859 .60827 L .37957 .59347 L p F P
0 0 0 r
s
.24 .35 .67 r
.37194 .57115 m
.38516 .59358 L
s
.191 .261 .437 r
.66256 .51405 m .66639 .52627 L .66295 .50719 L p F P
0 0 0 r
s
.191 .261 .437 r
.66295 .50719 m .65916 .49503 L .66256 .51405 L p F P
0 0 0 r
s
.994 .301 .128 r
.50117 .35011 m .49176 .35181 L .49447 .35972 L p F P
0 0 0 r
s
.994 .301 .128 r
.49447 .35972 m .50079 .35859 L .50117 .35011 L p F P
0 0 0 r
s
.238 .055 .023 r
.49794 .64449 m .51452 .64214 L .51287 .64936 L p F P
0 0 0 r
s
.238 .055 .023 r
.51287 .64936 m .49818 .65142 L .49794 .64449 L p F P
0 0 0 r
s
.83 .24 .1 r
.74261 .33282 m
.74693 .35309 L
s
.74693 .35309 m
.789 .34574 L
s
.257 .356 .631 r
.3623 .53529 m .35533 .52326 L .3558 .5421 L p F P
0 0 0 r
s
.257 .356 .631 r
.3558 .5421 m .36274 .5539 L .3623 .53529 L p F P
0 0 0 r
s
.994 .301 .128 r
.51061 .3484 m .50117 .35011 L .50079 .35859 L p F P
0 0 0 r
s
.24 .35 .67 r
.50348 .3558 m
.50395 .35701 L
s
.994 .301 .128 r
.50079 .35859 m .50712 .35745 L .51061 .3484 L p F P
0 0 0 r
s
.33 .077 .034 r
.60715 .61874 m .6257 .61609 L .61555 .62787 L p F P
0 0 0 r
s
.33 .077 .034 r
.61555 .62787 m .59852 .63027 L .60715 .61874 L p F P
0 0 0 r
s
.83 .24 .1 r
.61347 .62674 m
.61545 .61219 L
s
.35012 .37286 m
.35938 .37522 L
s
.071 .103 .253 r
.39184 .61822 m .3859 .60827 L .39517 .62076 L p F P
0 0 0 r
s
.071 .103 .253 r
.39517 .62076 m .40055 .6298 L .39184 .61822 L p F P
0 0 0 r
s
.24 .35 .67 r
.52862 .71659 m
.51813 .69627 L
s
.52862 .71659 m
.55853 .71267 L
s
.83 .24 .1 r
.36325 .6704 m
.40327 .66478 L
s
.36325 .6704 m
.35406 .67373 L
s
.994 .301 .128 r
.52008 .34668 m .51061 .3484 L .50712 .35745 L p F P
0 0 0 r
s
.994 .301 .128 r
.50712 .35745 m .51346 .35631 L .52008 .34668 L p F P
0 0 0 r
s
.054 .079 .187 r
.65529 .48262 m .65916 .49503 L .65201 .47645 L p F P
0 0 0 r
s
.054 .079 .187 r
.65201 .47645 m .64825 .46441 L .65529 .48262 L p F P
0 0 0 r
s
.247 .373 .75 r
.54862 .34152 m .55092 .34794 L .53413 .35714 L p F P
0 0 0 r
s
.247 .373 .75 r
.53413 .35714 m .53254 .35288 L .54862 .34152 L p F P
0 0 0 r
s
.24 .35 .67 r
.53306 .35654 m
.54306 .38331 L
s
.52233 .35671 m
.53306 .35654 L
s
.189 .292 .609 r
.59523 .38033 m .59845 .38998 L .58108 .38311 L p F P
0 0 0 r
s
.189 .292 .609 r
.58108 .38311 m .57833 .37513 L .59523 .38033 L p F P
0 0 0 r
s
.288 .406 .735 r
.35833 .50419 m .35139 .49197 L .34821 .51097 L p F P
0 0 0 r
s
.288 .406 .735 r
.34821 .51097 m .35533 .52326 L .35833 .50419 L p F P
0 0 0 r
s
.24 .35 .67 r
.35675 .52303 m
.36143 .49788 L
s
.238 .055 .023 r
.51452 .64214 m .53117 .63979 L .52763 .64728 L p F P
0 0 0 r
s
.238 .055 .023 r
.52763 .64728 m .51287 .64936 L .51452 .64214 L p F P
0 0 0 r
s
.24 .35 .67 r
.61493 .68853 m
.63854 .66954 L
s
.63854 .66954 m
.63033 .64822 L
s
.994 .301 .128 r
.52957 .34497 m .52008 .34668 L .51346 .35631 L p F P
0 0 0 r
s
.994 .301 .128 r
.51346 .35631 m .51981 .35517 L .52957 .34497 L p F P
0 0 0 r
s
.222 .338 .69 r
.57272 .35887 m .57554 .36705 L .55768 .36684 L p F P
0 0 0 r
s
.222 .338 .69 r
.55768 .36684 m .55545 .3606 L .57272 .35887 L p F P
0 0 0 r
s
.24 .35 .67 r
.56073 .36102 m
.57026 .38792 L
s
.994 .301 .128 r
.53908 .34324 m .52957 .34497 L .51981 .35517 L p F P
0 0 0 r
s
.994 .301 .128 r
.51981 .35517 m .52617 .35402 L .53908 .34324 L p F P
0 0 0 r
s
.83 .24 .1 r
.52889 .35491 m
.53156 .36032 L
s
.48828 .36221 m
.52889 .35491 L
s
.077 .112 .279 r
.64441 .45213 m .64825 .46441 L .63776 .44736 L p F P
0 0 0 r
s
.24 .35 .67 r
.64093 .45555 m
.64878 .48035 L
s
.077 .112 .279 r
.63776 .44736 m .6341 .4358 L .64441 .45213 L p F P
0 0 0 r
s
.24 .35 .67 r
.62455 .43735 m
.64093 .45555 L
s
.33 .077 .034 r
.6257 .61609 m .64434 .61343 L .63266 .62545 L p F P
0 0 0 r
s
.33 .077 .034 r
.63266 .62545 m .61555 .62787 L .6257 .61609 L p F P
0 0 0 r
s
.321 .468 .89 r
.39941 .38114 m .39554 .37313 L .37295 .3779 L p F P
0 0 0 r
s
.83 .24 .1 r
.35938 .37522 m
.39356 .36903 L
s
.321 .468 .89 r
.37295 .3779 m .37781 .3876 L .39941 .38114 L p F P
0 0 0 r
s
.83 .24 .1 r
.65672 .60627 m
.66131 .60561 L
s
.22011 .39903 m
.23067 .39455 L
s
.23067 .39455 m
.27004 .3874 L
s
.23452 .69047 m
.27392 .68495 L
s
.23452 .69047 m
.22212 .68765 L
s
.146 .23 .499 r
.61376 .39967 m .61728 .41057 L .60162 .3995 L p F P
0 0 0 r
s
.146 .23 .499 r
.60162 .3995 m .59845 .38998 L .61376 .39967 L p F P
0 0 0 r
s
.91 .282 .119 r
.40368 .36283 m .39162 .36502 L .41727 .36529 L p F P
0 0 0 r
s
.91 .282 .119 r
.41727 .36529 m .4265 .36362 L .40368 .36283 L p F P
0 0 0 r
s
.24 .35 .67 r
.4088 .36482 m
.41889 .38628 L
s
.307 .437 .803 r
.35808 .47348 m .35139 .46138 L .34431 .47949 L p F P
0 0 0 r
s
.307 .437 .803 r
.34431 .47949 m .35139 .49197 L .35808 .47348 L p F P
0 0 0 r
s
.994 .301 .128 r
.54862 .34152 m .53908 .34324 L .52617 .35402 L p F P
0 0 0 r
s
.994 .301 .128 r
.52617 .35402 m .53254 .35288 L .54862 .34152 L p F P
0 0 0 r
s
.24 .35 .67 r
.53128 .35178 m
.53306 .35654 L
s
.83 .24 .1 r
.65346 .33253 m
.65864 .34773 L
s
.65864 .34773 m
.70039 .34031 L
s
.11 .17 .391 r
.63037 .42402 m .6341 .4358 L .62075 .42129 L p F P
0 0 0 r
s
.11 .17 .391 r
.62075 .42129 m .61728 .41057 L .63037 .42402 L p F P
0 0 0 r
s
.83 .24 .1 r
.78131 .56882 m
.82375 .56262 L
s
.78131 .56882 m
.78329 .58812 L
s
.238 .055 .023 r
.53117 .63979 m .54789 .63743 L .54245 .64521 L p F P
0 0 0 r
s
.83 .24 .1 r
.53087 .63843 m
.53425 .62383 L
s
.238 .055 .023 r
.54245 .64521 m .52763 .64728 L .53117 .63979 L p F P
0 0 0 r
s
.83 .24 .1 r
.49024 .64418 m
.53087 .63843 L
s
.52889 .35491 m
.53599 .35363 L
s
.145 .036 .015 r
.42554 .66161 m .43996 .65959 L .44926 .66172 L p F P
0 0 0 r
s
.145 .036 .015 r
.44926 .66172 m .43706 .66343 L .42554 .66161 L p F P
0 0 0 r
s
.14 .226 .491 r
.42554 .66161 m .42107 .65402 L .43335 .65703 L p F P
0 0 0 r
s
.14 .226 .491 r
.43335 .65703 m .43706 .66343 L .42554 .66161 L p F P
0 0 0 r
s
.24 .35 .67 r
.43073 .66257 m
.4379 .67484 L
s
.43064 .66242 m
.43073 .66257 L
s
.91 .282 .119 r
.41577 .36064 m .40368 .36283 L .4265 .36362 L p F P
0 0 0 r
s
.24 .35 .67 r
.40622 .35932 m
.40754 .36213 L
s
.91 .282 .119 r
.4265 .36362 m .43575 .36194 L .41577 .36064 L p F P
0 0 0 r
s
.24 .35 .67 r
.55853 .71267 m
.54862 .69219 L
s
.55853 .71267 m
.5878 .70317 L
s
.105 .162 .375 r
.40584 .6387 m .40055 .6298 L .41193 .6385 L p F P
0 0 0 r
s
.24 .35 .67 r
.39286 .61646 m
.40303 .6317 L
s
.40753 .63864 m
.40882 .64082 L
s
.105 .162 .375 r
.41193 .6385 m .41654 .64632 L .40584 .6387 L p F P
0 0 0 r
s
.83 .24 .1 r
.789 .34574 m
.7853 .32524 L
s
.317 .455 .846 r
.36192 .44451 m .35568 .43289 L .34456 .44904 L p F P
0 0 0 r
s
.317 .455 .846 r
.34456 .44904 m .35139 .46138 L .36192 .44451 L p F P
0 0 0 r
s
.24 .35 .67 r
.35824 .44825 m
.37184 .47335 L
s
.323 .468 .885 r
.38261 .39715 m .37781 .3876 L .35878 .39693 L p F P
0 0 0 r
s
.323 .468 .885 r
.35878 .39693 m .36447 .40788 L .38261 .39715 L p F P
0 0 0 r
s
.33 .077 .034 r
.64434 .61343 m .66307 .61076 L .64985 .62302 L p F P
0 0 0 r
s
.33 .077 .034 r
.64985 .62302 m .63266 .62545 L .64434 .61343 L p F P
0 0 0 r
s
.24 .35 .67 r
.5878 .70317 m
.61493 .68853 L
s
.61493 .68853 m
.60619 .66753 L
s
.322 .464 .871 r
.37007 .41864 m .36447 .40788 L .34932 .42106 L p F P
0 0 0 r
s
.322 .464 .871 r
.34932 .42106 m .35568 .43289 L .37007 .41864 L p F P
0 0 0 r
s
.24 .35 .67 r
.35824 .44825 m
.37422 .42498 L
s
.91 .282 .119 r
.4279 .35843 m .41577 .36064 L .43575 .36194 L p F P
0 0 0 r
s
.91 .282 .119 r
.43575 .36194 m .44503 .36027 L .4279 .35843 L p F P
0 0 0 r
s
.83 .24 .1 r
.4398 .36066 m
.4481 .36942 L
s
.40745 .36652 m
.4398 .36066 L
s
.238 .055 .023 r
.54789 .63743 m .56469 .63505 L .55732 .64312 L p F P
0 0 0 r
s
.238 .055 .023 r
.55732 .64312 m .54245 .64521 L .54789 .63743 L p F P
0 0 0 r
s
.145 .036 .015 r
.43996 .65959 m .45442 .65756 L .4615 .66001 L p F P
0 0 0 r
s
.83 .24 .1 r
.44373 .65911 m
.45005 .64986 L
s
.145 .036 .015 r
.4615 .66001 m .44926 .66172 L .43996 .65959 L p F P
0 0 0 r
s
.313 .45 .822 r
.65611 .59039 m .65962 .60067 L .66855 .58534 L p F P
0 0 0 r
s
.83 .24 .1 r
.66608 .60493 m
.69845 .60029 L
s
.313 .45 .822 r
.66855 .58534 m .66493 .57433 L .65611 .59039 L p F P
0 0 0 r
s
.288 .411 .737 r
.66124 .56309 m .66493 .57433 L .6696 .5568 L p F P
0 0 0 r
s
.288 .411 .737 r
.6696 .5568 m .66585 .54506 L .66124 .56309 L p F P
0 0 0 r
s
.83 .24 .1 r
.40327 .66478 m
.42695 .66146 L
s
.42695 .66146 m
.42825 .66128 L
s
.43525 .6603 m
.44373 .65911 L
s
.40327 .66478 m
.3948 .66802 L
s
.24 .35 .67 r
.5878 .70317 m
.57848 .68245 L
s
.46142 .68725 m
.44945 .6662 L
s
.46142 .68725 m
.48858 .69456 L
s
.222 .338 .69 r
.56987 .35058 m .57272 .35887 L .55545 .3606 L p F P
0 0 0 r
s
.83 .24 .1 r
.56996 .34753 m
.57649 .36231 L
s
.222 .338 .69 r
.55545 .3606 m .55319 .3543 L .56987 .35058 L p F P
0 0 0 r
s
.24 .35 .67 r
.53306 .35654 m
.56073 .36102 L
s
.83 .24 .1 r
.55193 .35077 m
.56996 .34753 L
s
.91 .282 .119 r
.44007 .35622 m .4279 .35843 L .44503 .36027 L p F P
0 0 0 r
s
.24 .35 .67 r
.43371 .34496 m
.43882 .35645 L
s
.91 .282 .119 r
.44503 .36027 m .45433 .35858 L .44007 .35622 L p F P
0 0 0 r
s
.247 .347 .604 r
.66203 .53307 m .66585 .54506 L .66639 .52627 L p F P
0 0 0 r
s
.247 .347 .604 r
.66639 .52627 m .66256 .51405 L .66203 .53307 L p F P
0 0 0 r
s
.24 .35 .67 r
.65972 .50189 m
.66252 .5153 L
s
.189 .292 .609 r
.59197 .37053 m .59523 .38033 L .57833 .37513 L p F P
0 0 0 r
s
.189 .292 .609 r
.57833 .37513 m .57554 .36705 L .59197 .37053 L p F P
0 0 0 r
s
.326 .471 .874 r
.64657 .61386 m .64985 .62302 L .66307 .61076 L p F P
0 0 0 r
s
.83 .24 .1 r
.65547 .6208 m
.65588 .61599 L
s
.326 .471 .874 r
.66307 .61076 m .65962 .60067 L .64657 .61386 L p F P
0 0 0 r
s
.24 .35 .67 r
.6497 .62554 m
.6524 .62065 L
s
.145 .036 .015 r
.45442 .65756 m .46895 .65552 L .47378 .65829 L p F P
0 0 0 r
s
.145 .036 .015 r
.47378 .65829 m .4615 .66001 L .45442 .65756 L p F P
0 0 0 r
s
.238 .055 .023 r
.56469 .63505 m .58157 .63267 L .57226 .64102 L p F P
0 0 0 r
s
.238 .055 .023 r
.57226 .64102 m .55732 .64312 L .56469 .63505 L p F P
0 0 0 r
s
.83 .24 .1 r
.53087 .63843 m
.57194 .63262 L
s
.91 .282 .119 r
.45228 .354 m .44007 .35622 L .45433 .35858 L p F P
0 0 0 r
s
.91 .282 .119 r
.45433 .35858 m .46365 .3569 L .45228 .354 L p F P
0 0 0 r
s
.83 .24 .1 r
.69845 .60029 m
.74063 .59424 L
s
.69845 .60029 m
.69794 .61479 L
s
.26018 .39177 m
.27004 .3874 L
s
.27004 .3874 m
.30986 .38017 L
s
.162 .212 .366 r
.37311 .58262 m .36654 .57155 L .37369 .5878 L p F P
0 0 0 r
s
.162 .212 .366 r
.37369 .5878 m .37985 .59813 L .37311 .58262 L p F P
0 0 0 r
s
.24 .35 .67 r
.37194 .57115 m
.37964 .59422 L
s
.208 .282 .479 r
.36274 .5539 m .3558 .5421 L .35982 .56026 L p F P
0 0 0 r
s
.24 .35 .67 r
.35675 .52303 m
.37039 .54663 L
s
.208 .282 .479 r
.35982 .56026 m .36654 .57155 L .36274 .5539 L p F P
0 0 0 r
s
.83 .24 .1 r
.27392 .68495 m
.31377 .67937 L
s
.27392 .68495 m
.2622 .68201 L
s
.69592 .3249 m
.70039 .34031 L
s
.70039 .34031 m
.74261 .33282 L
s
.321 .468 .89 r
.39554 .37313 m .39162 .36502 L .36801 .36807 L p F P
0 0 0 r
s
.321 .468 .89 r
.36801 .36807 m .37295 .3779 L .39554 .37313 L p F P
0 0 0 r
s
.24 .35 .67 r
.3815 .37739 m
.39472 .40408 L
s
.191 .261 .437 r
.65864 .50157 m .66256 .51405 L .65916 .49503 L p F P
0 0 0 r
s
.191 .261 .437 r
.65916 .49503 m .65529 .48262 L .65864 .50157 L p F P
0 0 0 r
s
.83 .24 .1 r
.82643 .58194 m
.82375 .56262 L
s
.56996 .34753 m
.61148 .34007 L
s
.91 .282 .119 r
.46454 .35178 m .45228 .354 L .46365 .3569 L p F P
0 0 0 r
s
.91 .282 .119 r
.46365 .3569 m .47299 .35521 L .46454 .35178 L p F P
0 0 0 r
s
.071 .103 .253 r
.3859 .60827 m .37985 .59813 L .3897 .61156 L p F P
0 0 0 r
s
.071 .103 .253 r
.3897 .61156 m .39517 .62076 L .3859 .60827 L p F P
0 0 0 r
s
.24 .35 .67 r
.37964 .59422 m
.39286 .61646 L
s
.257 .356 .631 r
.35533 .52326 m .34821 .51097 L .34871 .53005 L p F P
0 0 0 r
s
.257 .356 .631 r
.34871 .53005 m .3558 .5421 L .35533 .52326 L p F P
0 0 0 r
s
.145 .036 .015 r
.46895 .65552 m .48353 .65347 L .4861 .65657 L p F P
0 0 0 r
s
.145 .036 .015 r
.4861 .65657 m .47378 .65829 L .46895 .65552 L p F P
0 0 0 r
s
.238 .055 .023 r
.58157 .63267 m .59852 .63027 L .58725 .63892 L p F P
0 0 0 r
s
.238 .055 .023 r
.58725 .63892 m .57226 .64102 L .58157 .63267 L p F P
0 0 0 r
s
.146 .23 .499 r
.61017 .38858 m .61376 .39967 L .59845 .38998 L p F P
0 0 0 r
s
.146 .23 .499 r
.59845 .38998 m .59523 .38033 L .61017 .38858 L p F P
0 0 0 r
s
.054 .079 .187 r
.65134 .46994 m .65529 .48262 L .64825 .46441 L p F P
0 0 0 r
s
.24 .35 .67 r
.652 .47723 m
.65737 .49439 L
s
.054 .079 .187 r
.64825 .46441 m .64441 .45213 L .65134 .46994 L p F P
0 0 0 r
s
.24 .35 .67 r
.64093 .45555 m
.652 .47723 L
s
.91 .282 .119 r
.47683 .34955 m .46454 .35178 L .47299 .35521 L p F P
0 0 0 r
s
.24 .35 .67 r
.46299 .33483 m
.4697 .35084 L
s
.91 .282 .119 r
.47299 .35521 m .48236 .35351 L .47683 .34955 L p F P
0 0 0 r
s
.24 .35 .67 r
.46299 .33483 m
.43371 .34496 L
s
.43371 .34496 m
.4211 .31658 L
s
.40622 .35932 m
.43371 .34496 L
s
.14 .226 .491 r
.42107 .65402 m .41654 .64632 L .4296 .65055 L p F P
0 0 0 r
s
.24 .35 .67 r
.41584 .64514 m
.41755 .64665 L
s
.14 .226 .491 r
.4296 .65055 m .43335 .65703 L .42107 .65402 L p F P
0 0 0 r
s
.222 .338 .69 r
.56698 .3422 m .56987 .35058 L .55319 .3543 L p F P
0 0 0 r
s
.83 .24 .1 r
.56756 .3439 m
.56996 .34753 L
s
.222 .338 .69 r
.55319 .3543 m .55092 .34794 L .56698 .3422 L p F P
0 0 0 r
s
.288 .406 .735 r
.35139 .49197 m .34431 .47949 L .34094 .49843 L p F P
0 0 0 r
s
.288 .406 .735 r
.34094 .49843 m .34821 .51097 L .35139 .49197 L p F P
0 0 0 r
s
.077 .112 .279 r
.64049 .43961 m .64441 .45213 L .6341 .4358 L p F P
0 0 0 r
s
.077 .112 .279 r
.6341 .4358 m .63037 .42402 L .64049 .43961 L p F P
0 0 0 r
s
.11 .17 .391 r
.62657 .41202 m .63037 .42402 L .61728 .41057 L p F P
0 0 0 r
s
.11 .17 .391 r
.61728 .41057 m .61376 .39967 L .62657 .41202 L p F P
0 0 0 r
s
.24 .35 .67 r
.61613 .41145 m
.62455 .43735 L
s
.59497 .39738 m
.61613 .41145 L
s
.145 .036 .015 r
.48353 .65347 m .49818 .65142 L .49846 .65484 L p F P
0 0 0 r
s
.83 .24 .1 r
.48464 .65336 m
.49024 .64418 L
s
.145 .036 .015 r
.49846 .65484 m .4861 .65657 L .48353 .65347 L p F P
0 0 0 r
s
.83 .24 .1 r
.44373 .65911 m
.48464 .65336 L
s
.91 .282 .119 r
.48917 .34731 m .47683 .34955 L .48236 .35351 L p F P
0 0 0 r
s
.83 .24 .1 r
.4398 .36066 m
.48067 .35326 L
s
.91 .282 .119 r
.48236 .35351 m .49176 .35181 L .48917 .34731 L p F P
0 0 0 r
s
.83 .24 .1 r
.48067 .35326 m
.48828 .36221 L
s
.323 .468 .885 r
.37781 .3876 m .37295 .3779 L .35299 .3858 L p F P
0 0 0 r
s
.323 .468 .885 r
.35299 .3858 m .35878 .39693 L .37781 .3876 L p F P
0 0 0 r
s
.24 .35 .67 r
.40622 .35932 m
.39301 .33121 L
s
.40065 .36338 m
.40622 .35932 L
s
.238 .055 .023 r
.59852 .63027 m .61555 .62787 L .60231 .6368 L p F P
0 0 0 r
s
.238 .055 .023 r
.60231 .6368 m .58725 .63892 L .59852 .63027 L p F P
0 0 0 r
s
.24 .35 .67 r
.49299 .32931 m
.46299 .33483 L
s
.46299 .33483 m
.45098 .30619 L
s
.307 .437 .803 r
.35139 .46138 m .34456 .44904 L .33708 .46675 L p F P
0 0 0 r
s
.307 .437 .803 r
.33708 .46675 m .34431 .47949 L .35139 .46138 L p F P
0 0 0 r
s
.24 .35 .67 r
.34748 .47305 m
.36143 .49788 L
s
.105 .162 .375 r
.40055 .6298 m .39517 .62076 L .40726 .63057 L p F P
0 0 0 r
s
.24 .35 .67 r
.40241 .63001 m
.40373 .63223 L
s
.105 .162 .375 r
.40726 .63057 m .41193 .6385 L .40055 .6298 L p F P
0 0 0 r
s
.91 .282 .119 r
.50154 .34506 m .48917 .34731 L .49176 .35181 L p F P
0 0 0 r
s
.24 .35 .67 r
.49972 .34631 m
.50122 .3501 L
s
.91 .282 .119 r
.49176 .35181 m .50117 .35011 L .50154 .34506 L p F P
0 0 0 r
s
.24 .35 .67 r
.49299 .32931 m
.49938 .34545 L
s
.189 .292 .609 r
.58865 .36058 m .59197 .37053 L .57554 .36705 L p F P
0 0 0 r
s
.189 .292 .609 r
.57554 .36705 m .57272 .35887 L .58865 .36058 L p F P
0 0 0 r
s
.24 .35 .67 r
.56073 .36102 m
.58585 .3704 L
s
.83 .24 .1 r
.74063 .59424 m
.78329 .58812 L
s
.74063 .59424 m
.74088 .60871 L
s
.145 .036 .015 r
.49818 .65142 m .51287 .64936 L .51086 .6531 L p F P
0 0 0 r
s
.145 .036 .015 r
.51086 .6531 m .49846 .65484 L .49818 .65142 L p F P
0 0 0 r
s
.83 .24 .1 r
.30071 .38442 m
.30986 .38017 L
s
.30986 .38017 m
.35012 .37286 L
s
.322 .464 .871 r
.36447 .40788 m .35878 .39693 L .34284 .40901 L p F P
0 0 0 r
s
.322 .464 .871 r
.34284 .40901 m .34932 .42106 L .36447 .40788 L p F P
0 0 0 r
s
.24 .35 .67 r
.3605 .39856 m
.37422 .42498 L
s
.317 .455 .846 r
.35568 .43289 m .34932 .42106 L .33759 .43645 L p F P
0 0 0 r
s
.317 .455 .846 r
.33759 .43645 m .34456 .44904 L .35568 .43289 L p F P
0 0 0 r
s
.24 .35 .67 r
.34748 .47305 m
.35824 .44825 L
s
.83 .24 .1 r
.31377 .67937 m
.35406 .67373 L
s
.31377 .67937 m
.30273 .6763 L
s
.73885 .31719 m
.74261 .33282 L
s
.74261 .33282 m
.7853 .32524 L
s
.91 .282 .119 r
.51396 .3428 m .50154 .34506 L .50117 .35011 L p F P
0 0 0 r
s
.91 .282 .119 r
.50117 .35011 m .51061 .3484 L .51396 .3428 L p F P
0 0 0 r
s
.24 .35 .67 r
.48858 .69456 m
.47708 .67348 L
s
.48858 .69456 m
.51813 .69627 L
s
.713 .229 .096 r
.38265 .36541 m .36801 .36807 L .39162 .36502 L p F P
0 0 0 r
s
.83 .24 .1 r
.39083 .36547 m
.39696 .36727 L
s
.713 .229 .096 r
.39162 .36502 m .40368 .36283 L .38265 .36541 L p F P
0 0 0 r
s
.24 .35 .67 r
.3815 .37739 m
.39916 .36448 L
s
.238 .055 .023 r
.61555 .62787 m .63266 .62545 L .61743 .63468 L p F P
0 0 0 r
s
.238 .055 .023 r
.61743 .63468 m .60231 .6368 L .61555 .62787 L p F P
0 0 0 r
s
.83 .24 .1 r
.57194 .63262 m
.61347 .62674 L
s
.60609 .33056 m
.61148 .34007 L
s
.61148 .34007 m
.65346 .33253 L
s
.65011 .62156 m
.65547 .6208 L
s
.91 .282 .119 r
.52642 .34054 m .51396 .3428 L .51061 .3484 L p F P
0 0 0 r
s
.91 .282 .119 r
.51061 .3484 m .52008 .34668 L .52642 .34054 L p F P
0 0 0 r
s
.145 .036 .015 r
.51287 .64936 m .52763 .64728 L .52331 .65136 L p F P
0 0 0 r
s
.145 .036 .015 r
.52331 .65136 m .51086 .6531 L .51287 .64936 L p F P
0 0 0 r
s
.313 .45 .822 r
.65253 .57991 m .65611 .59039 L .66493 .57433 L p F P
0 0 0 r
s
.313 .45 .822 r
.66493 .57433 m .66124 .56309 L .65253 .57991 L p F P
0 0 0 r
s
.24 .35 .67 r
.37631 .36691 m
.3815 .37739 L
s
.83 .24 .1 r
.17059 .41731 m
.18049 .40621 L
s
.18049 .40621 m
.22011 .39903 L
s
.222 .338 .69 r
.56405 .3337 m .56698 .3422 L .55092 .34794 L p F P
0 0 0 r
s
.222 .338 .69 r
.55092 .34794 m .54862 .34152 L .56405 .3337 L p F P
0 0 0 r
s
.288 .411 .737 r
.65747 .55162 m .66124 .56309 L .66585 .54506 L p F P
0 0 0 r
s
.288 .411 .737 r
.66585 .54506 m .66203 .53307 L .65747 .55162 L p F P
0 0 0 r
s
.713 .229 .096 r
.39734 .36273 m .38265 .36541 L .40368 .36283 L p F P
0 0 0 r
s
.713 .229 .096 r
.40368 .36283 m .41577 .36064 L .39734 .36273 L p F P
0 0 0 r
s
.326 .471 .874 r
.64324 .60454 m .64657 .61386 L .65962 .60067 L p F P
0 0 0 r
s
.326 .471 .874 r
.65962 .60067 m .65611 .59039 L .64324 .60454 L p F P
0 0 0 r
s
.24 .35 .67 r
.52263 .32866 m
.49299 .32931 L
s
.49299 .32931 m
.48157 .30044 L
s
.91 .282 .119 r
.53892 .33827 m .52642 .34054 L .52008 .34668 L p F P
0 0 0 r
s
.24 .35 .67 r
.52804 .34313 m
.52878 .34511 L
s
.91 .282 .119 r
.52008 .34668 m .52957 .34497 L .53892 .33827 L p F P
0 0 0 r
s
.24 .35 .67 r
.52263 .32866 m
.52703 .34043 L
s
.83 .24 .1 r
.52201 .34578 m
.52889 .35491 L
s
.48067 .35326 m
.52201 .34578 L
s
.238 .055 .023 r
.63266 .62545 m .64985 .62302 L .6326 .63255 L p F P
0 0 0 r
s
.24 .35 .67 r
.64897 .6235 m
.6497 .62554 L
s
.238 .055 .023 r
.6326 .63255 m .61743 .63468 L .63266 .62545 L p F P
0 0 0 r
s
.247 .347 .604 r
.65812 .52083 m .66203 .53307 L .66256 .51405 L p F P
0 0 0 r
s
.247 .347 .604 r
.66256 .51405 m .65864 .50157 L .65812 .52083 L p F P
0 0 0 r
s
.145 .036 .015 r
.52763 .64728 m .54245 .64521 L .5358 .64961 L p F P
0 0 0 r
s
.145 .036 .015 r
.5358 .64961 m .52331 .65136 L .52763 .64728 L p F P
0 0 0 r
s
.83 .24 .1 r
.52601 .64756 m
.53087 .63843 L
s
.48464 .65336 m
.52601 .64756 L
s
.146 .23 .499 r
.60651 .3773 m .61017 .38858 L .59523 .38033 L p F P
0 0 0 r
s
.146 .23 .499 r
.59523 .38033 m .59197 .37053 L .60651 .3773 L p F P
0 0 0 r
s
.24 .35 .67 r
.58585 .3704 m
.59497 .39738 L
s
.713 .229 .096 r
.4121 .36005 m .39734 .36273 L .41577 .36064 L p F P
0 0 0 r
s
.713 .229 .096 r
.41577 .36064 m .4279 .35843 L .4121 .36005 L p F P
0 0 0 r
s
.91 .282 .119 r
.55146 .33599 m .53892 .33827 L .52957 .34497 L p F P
0 0 0 r
s
.91 .282 .119 r
.52957 .34497 m .53908 .34324 L .55146 .33599 L p F P
0 0 0 r
s
.162 .212 .366 r
.36654 .57155 m .35982 .56026 L .36741 .57727 L p F P
0 0 0 r
s
.162 .212 .366 r
.36741 .57727 m .37369 .5878 L .36654 .57155 L p F P
0 0 0 r
s
.24 .35 .67 r
.65849 .56839 m
.66063 .56124 L
s
.14 .226 .491 r
.41654 .64632 m .41193 .6385 L .42581 .64399 L p F P
0 0 0 r
s
.14 .226 .491 r
.42581 .64399 m .4296 .65055 L .41654 .64632 L p F P
0 0 0 r
s
.208 .282 .479 r
.3558 .5421 m .34871 .53005 L .35297 .54874 L p F P
0 0 0 r
s
.208 .282 .479 r
.35297 .54874 m .35982 .56026 L .3558 .5421 L p F P
0 0 0 r
s
.24 .35 .67 r
.35816 .54777 m
.37194 .57115 L
s
.35675 .52303 m
.35816 .54777 L
s
.071 .103 .253 r
.37985 .59813 m .37369 .5878 L .38413 .6022 L p F P
0 0 0 r
s
.071 .103 .253 r
.38413 .6022 m .3897 .61156 L .37985 .59813 L p F P
0 0 0 r
s
.191 .261 .437 r
.65464 .48882 m .65864 .50157 L .65529 .48262 L p F P
0 0 0 r
s
.191 .261 .437 r
.65529 .48262 m .65134 .46994 L .65464 .48882 L p F P
0 0 0 r
s
.83 .24 .1 r
.78329 .58812 m
.82643 .58194 L
s
.78329 .58812 m
.78432 .60257 L
s
.37524 .3683 m
.39083 .36547 L
s
.33 .481 .902 r
.62957 .62452 m .6326 .63255 L .64985 .62302 L p F P
0 0 0 r
s
.24 .35 .67 r
.63033 .64822 m
.6497 .62554 L
s
.33 .481 .902 r
.64985 .62302 m .64657 .61386 L .62957 .62452 L p F P
0 0 0 r
s
.83 .24 .1 r
.61347 .62674 m
.6297 .62444 L
s
.189 .292 .609 r
.58529 .35048 m .58865 .36058 L .57272 .35887 L p F P
0 0 0 r
s
.189 .292 .609 r
.57272 .35887 m .56987 .35058 L .58529 .35048 L p F P
0 0 0 r
s
.91 .282 .119 r
.56405 .3337 m .55146 .33599 L .53908 .34324 L p F P
0 0 0 r
s
.91 .282 .119 r
.53908 .34324 m .54862 .34152 L .56405 .3337 L p F P
0 0 0 r
s
.24 .35 .67 r
.55282 .33872 m
.56073 .36102 L
s
.5508 .33299 m
.55183 .33592 L
s
.83 .24 .1 r
.35406 .67373 m
.3948 .66802 L
s
.35406 .67373 m
.34373 .67053 L
s
.323 .468 .885 r
.37295 .3779 m .36801 .36807 L .3471 .37447 L p F P
0 0 0 r
s
.83 .24 .1 r
.35012 .37286 m
.35561 .37186 L
s
.323 .468 .885 r
.3471 .37447 m .35299 .3858 L .37295 .3779 L p F P
0 0 0 r
s
.24 .35 .67 r
.3605 .39856 m
.3815 .37739 L
s
.145 .036 .015 r
.54245 .64521 m .55732 .64312 L .54833 .64786 L p F P
0 0 0 r
s
.145 .036 .015 r
.54833 .64786 m .5358 .64961 L .54245 .64521 L p F P
0 0 0 r
s
.83 .24 .1 r
.7853 .32524 m
.78227 .30939 L
s
.713 .229 .096 r
.42691 .35736 m .4121 .36005 L .4279 .35843 L p F P
0 0 0 r
s
.713 .229 .096 r
.4279 .35843 m .44007 .35622 L .42691 .35736 L p F P
0 0 0 r
s
.83 .24 .1 r
.43199 .35799 m
.4398 .36066 L
s
.257 .356 .631 r
.34821 .51097 m .34094 .49843 L .34147 .51775 L p F P
0 0 0 r
s
.257 .356 .631 r
.34147 .51775 m .34871 .53005 L .34821 .51097 L p F P
0 0 0 r
s
.11 .17 .391 r
.62269 .3998 m .62657 .41202 L .61376 .39967 L p F P
0 0 0 r
s
.11 .17 .391 r
.61376 .39967 m .61017 .38858 L .62269 .3998 L p F P
0 0 0 r
s
.83 .24 .1 r
.64884 .32282 m
.65346 .33253 L
s
.65346 .33253 m
.69592 .3249 L
s
.65547 .6208 m
.69794 .61479 L
s
.65295 .62974 m
.65547 .6208 L
s
.054 .079 .187 r
.64731 .45699 m .65134 .46994 L .64441 .45213 L p F P
0 0 0 r
s
.054 .079 .187 r
.64441 .45213 m .64049 .43961 L .64731 .45699 L p F P
0 0 0 r
s
.626 .205 .086 r
.43706 .66343 m .44926 .66172 L .46014 .6599 L p F P
0 0 0 r
s
.626 .205 .086 r
.46014 .6599 m .45053 .66124 L .43706 .66343 L p F P
0 0 0 r
s
.188 .295 .615 r
.43706 .66343 m .43335 .65703 L .44769 .65621 L p F P
0 0 0 r
s
.83 .24 .1 r
.44297 .65942 m
.44373 .65911 L
s
.188 .295 .615 r
.44769 .65621 m .45053 .66124 L .43706 .66343 L p F P
0 0 0 r
s
.83 .24 .1 r
.43601 .66225 m
.43791 .66148 L
s
.43791 .66148 m
.43825 .66134 L
s
.24 .35 .67 r
.44256 .66261 m
.44362 .66316 L
s
.44362 .66316 m
.44945 .6662 L
s
.077 .112 .279 r
.63649 .42683 m .64049 .43961 L .63037 .42402 L p F P
0 0 0 r
s
.24 .35 .67 r
.63276 .4297 m
.64093 .45555 L
s
.077 .112 .279 r
.63037 .42402 m .62657 .41202 L .63649 .42683 L p F P
0 0 0 r
s
.24 .35 .67 r
.61613 .41145 m
.63276 .4297 L
s
.51813 .69627 m
.50719 .67509 L
s
.51813 .69627 m
.54862 .69219 L
s
.713 .229 .096 r
.44178 .35465 m .42691 .35736 L .44007 .35622 L p F P
0 0 0 r
s
.713 .229 .096 r
.44007 .35622 m .45228 .354 L .44178 .35465 L p F P
0 0 0 r
s
.105 .162 .375 r
.39517 .62076 m .3897 .61156 L .40251 .62251 L p F P
0 0 0 r
s
.24 .35 .67 r
.37964 .59422 m
.39325 .6146 L
s
.39721 .62124 m
.39855 .6235 L
s
.105 .162 .375 r
.40251 .62251 m .40726 .63057 L .39517 .62076 L p F P
0 0 0 r
s
.83 .24 .1 r
.21088 .41007 m
.22011 .39903 L
s
.22011 .39903 m
.26018 .39177 L
s
.22212 .68765 m
.2622 .68201 L
s
.22212 .68765 m
.20911 .67818 L
s
.145 .036 .015 r
.55732 .64312 m .57226 .64102 L .5609 .6461 L p F P
0 0 0 r
s
.145 .036 .015 r
.5609 .6461 m .54833 .64786 L .55732 .64312 L p F P
0 0 0 r
s
.288 .406 .735 r
.34431 .47949 m .33708 .46675 L .33351 .48561 L p F P
0 0 0 r
s
.288 .406 .735 r
.33351 .48561 m .34094 .49843 L .34431 .47949 L p F P
0 0 0 r
s
.24 .35 .67 r
.34253 .49844 m
.34748 .47305 L
s
.60619 .66753 m
.63033 .64822 L
s
.322 .464 .871 r
.35878 .39693 m .35299 .3858 L .33623 .39672 L p F P
0 0 0 r
s
.322 .464 .871 r
.33623 .39672 m .34284 .40901 L .35878 .39693 L p F P
0 0 0 r
s
.83 .24 .1 r
.52201 .34578 m
.55538 .33974 L
s
.626 .205 .086 r
.44926 .66172 m .4615 .66001 L .46976 .65855 L p F P
0 0 0 r
s
.626 .205 .086 r
.46976 .65855 m .46014 .6599 L .44926 .66172 L p F P
0 0 0 r
s
.307 .437 .803 r
.34456 .44904 m .33759 .43645 L .32969 .45373 L p F P
0 0 0 r
s
.307 .437 .803 r
.32969 .45373 m .33708 .46675 L .34456 .44904 L p F P
0 0 0 r
s
.713 .229 .096 r
.45672 .35194 m .44178 .35465 L .45228 .354 L p F P
0 0 0 r
s
.713 .229 .096 r
.45228 .354 m .46454 .35178 L .45672 .35194 L p F P
0 0 0 r
s
.24 .35 .67 r
.5508 .33299 m
.52263 .32866 L
s
.52263 .32866 m
.51177 .29958 L
s
.317 .455 .846 r
.34932 .42106 m .34284 .40901 L .33048 .42361 L p F P
0 0 0 r
s
.317 .455 .846 r
.33048 .42361 m .33759 .43645 L .34932 .42106 L p F P
0 0 0 r
s
.24 .35 .67 r
.34406 .4221 m
.3605 .39856 L
s
.34406 .4221 m
.35824 .44825 L
s
.145 .036 .015 r
.57226 .64102 m .58725 .63892 L .57351 .64434 L p F P
0 0 0 r
s
.145 .036 .015 r
.57351 .64434 m .5609 .6461 L .57226 .64102 L p F P
0 0 0 r
s
.83 .24 .1 r
.52601 .64756 m
.56785 .64168 L
s
.56785 .64168 m
.57194 .63262 L
s
.626 .205 .086 r
.4615 .66001 m .47378 .65829 L .47941 .6572 L p F P
0 0 0 r
s
.626 .205 .086 r
.47941 .6572 m .46976 .65855 L .4615 .66001 L p F P
0 0 0 r
s
.713 .229 .096 r
.47171 .34921 m .45672 .35194 L .46454 .35178 L p F P
0 0 0 r
s
.713 .229 .096 r
.46454 .35178 m .47683 .34955 L .47171 .34921 L p F P
0 0 0 r
s
.83 .24 .1 r
.47363 .35043 m
.48067 .35326 L
s
.82825 .59635 m
.82643 .58194 L
s
.3948 .66802 m
.43601 .66225 L
s
.3948 .66802 m
.3852 .6647 L
s
.146 .23 .499 r
.6028 .36583 m .60651 .3773 L .59197 .37053 L p F P
0 0 0 r
s
.146 .23 .499 r
.59197 .37053 m .58865 .36058 L .6028 .36583 L p F P
0 0 0 r
s
.24 .35 .67 r
.54862 .69219 m
.53828 .67083 L
s
.54862 .69219 m
.57848 .68245 L
s
.189 .292 .609 r
.58187 .34023 m .58529 .35048 L .56987 .35058 L p F P
0 0 0 r
s
.189 .292 .609 r
.56987 .35058 m .56698 .3422 L .58187 .34023 L p F P
0 0 0 r
s
.24 .35 .67 r
.57848 .68245 m
.60619 .66753 L
s
.60619 .66753 m
.59708 .64564 L
s
.145 .036 .015 r
.58725 .63892 m .60231 .6368 L .58617 .64257 L p F P
0 0 0 r
s
.145 .036 .015 r
.58617 .64257 m .57351 .64434 L .58725 .63892 L p F P
0 0 0 r
s
.626 .205 .086 r
.47378 .65829 m .4861 .65657 L .48909 .65585 L p F P
0 0 0 r
s
.626 .205 .086 r
.48909 .65585 m .47941 .6572 L .47378 .65829 L p F P
0 0 0 r
s
.83 .24 .1 r
.47768 .65641 m
.48464 .65336 L
s
.313 .45 .822 r
.64889 .56923 m .65253 .57991 L .66124 .56309 L p F P
0 0 0 r
s
.313 .45 .822 r
.66124 .56309 m .65747 .55162 L .64889 .56923 L p F P
0 0 0 r
s
.83 .24 .1 r
.69209 .31499 m
.69592 .3249 L
s
.69592 .3249 m
.73885 .31719 L
s
.69794 .61479 m
.74088 .60871 L
s
.69794 .61479 m
.69623 .62367 L
s
.326 .471 .874 r
.63984 .59506 m .64324 .60454 L .65611 .59039 L p F P
0 0 0 r
s
.326 .471 .874 r
.65611 .59039 m .65253 .57991 L .63984 .59506 L p F P
0 0 0 r
s
.14 .226 .491 r
.41193 .6385 m .40726 .63057 L .42196 .63735 L p F P
0 0 0 r
s
.14 .226 .491 r
.42196 .63735 m .42581 .64399 L .41193 .6385 L p F P
0 0 0 r
s
.713 .229 .096 r
.48677 .34648 m .47171 .34921 L .47683 .34955 L p F P
0 0 0 r
s
.713 .229 .096 r
.47683 .34955 m .48917 .34731 L .48677 .34648 L p F P
0 0 0 r
s
.288 .411 .737 r
.65362 .53992 m .65747 .55162 L .66203 .53307 L p F P
0 0 0 r
s
.288 .411 .737 r
.66203 .53307 m .65812 .52083 L .65362 .53992 L p F P
0 0 0 r
s
.24 .35 .67 r
.57848 .68245 m
.56877 .66085 L
s
.188 .295 .615 r
.43335 .65703 m .4296 .65055 L .44482 .65113 L p F P
0 0 0 r
s
.188 .295 .615 r
.44482 .65113 m .44769 .65621 L .43335 .65703 L p F P
0 0 0 r
s
.24 .35 .67 r
.44699 .66186 m
.44945 .6662 L
s
.44945 .6662 m
.47708 .67348 L
s
.103 .028 .012 r
.36401 .3714 m .3471 .37447 L .36801 .36807 L p F P
0 0 0 r
s
.103 .028 .012 r
.36801 .36807 m .38265 .36541 L .36401 .3714 L p F P
0 0 0 r
s
.24 .35 .67 r
.37587 .36602 m
.37615 .36659 L
s
.83 .24 .1 r
.25163 .40273 m
.26018 .39177 L
s
.26018 .39177 m
.30071 .38442 L
s
.2622 .68201 m
.30273 .6763 L
s
.2622 .68201 m
.24984 .67239 L
s
.626 .205 .086 r
.4861 .65657 m .49846 .65484 L .49879 .65449 L p F P
0 0 0 r
s
.626 .205 .086 r
.49879 .65449 m .48909 .65585 L .4861 .65657 L p F P
0 0 0 r
s
.145 .036 .015 r
.60231 .6368 m .61743 .63468 L .59887 .64079 L p F P
0 0 0 r
s
.145 .036 .015 r
.59887 .64079 m .58617 .64257 L .60231 .6368 L p F P
0 0 0 r
s
.33 .481 .902 r
.6265 .61637 m .62957 .62452 L .64657 .61386 L p F P
0 0 0 r
s
.33 .481 .902 r
.64657 .61386 m .64324 .60454 L .6265 .61637 L p F P
0 0 0 r
s
.713 .229 .096 r
.50188 .34373 m .48677 .34648 L .48917 .34731 L p F P
0 0 0 r
s
.713 .229 .096 r
.48917 .34731 m .50154 .34506 L .50188 .34373 L p F P
0 0 0 r
s
.247 .347 .604 r
.65412 .50833 m .65812 .52083 L .65864 .50157 L p F P
0 0 0 r
s
.247 .347 .604 r
.65864 .50157 m .65464 .48882 L .65412 .50833 L p F P
0 0 0 r
s
.24 .35 .67 r
.652 .47723 m
.65461 .4898 L
s
.162 .212 .366 r
.35982 .56026 m .35297 .54874 L .36101 .56654 L p F P
0 0 0 r
s
.162 .212 .366 r
.36101 .56654 m .36741 .57727 L .35982 .56026 L p F P
0 0 0 r
s
.24 .35 .67 r
.35816 .54777 m
.36585 .57104 L
s
.071 .103 .253 r
.37369 .5878 m .36741 .57727 L .37846 .59267 L p F P
0 0 0 r
s
.071 .103 .253 r
.37846 .59267 m .38413 .6022 L .37369 .5878 L p F P
0 0 0 r
s
.24 .35 .67 r
.36585 .57104 m
.37964 .59422 L
s
.11 .17 .391 r
.61874 .38733 m .62269 .3998 L .61017 .38858 L p F P
0 0 0 r
s
.11 .17 .391 r
.61017 .38858 m .60651 .3773 L .61874 .38733 L p F P
0 0 0 r
s
.24 .35 .67 r
.60736 .38445 m
.61613 .41145 L
s
.58585 .3704 m
.60736 .38445 L
s
.626 .205 .086 r
.49846 .65484 m .51086 .6531 L .50852 .65313 L p F P
0 0 0 r
s
.626 .205 .086 r
.50852 .65313 m .49879 .65449 L .49846 .65484 L p F P
0 0 0 r
s
.103 .028 .012 r
.381 .36832 m .36401 .3714 L .38265 .36541 L p F P
0 0 0 r
s
.24 .35 .67 r
.36772 .34956 m
.37587 .36602 L
s
.103 .028 .012 r
.38265 .36541 m .39734 .36273 L .381 .36832 L p F P
0 0 0 r
s
.83 .24 .1 r
.39083 .36547 m
.43199 .35799 L
s
.208 .282 .479 r
.34871 .53005 m .34147 .51775 L .34598 .53697 L p F P
0 0 0 r
s
.24 .35 .67 r
.34253 .49844 m
.35675 .52303 L
s
.208 .282 .479 r
.34598 .53697 m .35297 .54874 L .34871 .53005 L p F P
0 0 0 r
s
.191 .261 .437 r
.65055 .4758 m .65464 .48882 L .65134 .46994 L p F P
0 0 0 r
s
.191 .261 .437 r
.65134 .46994 m .64731 .45699 L .65055 .4758 L p F P
0 0 0 r
s
.145 .036 .015 r
.61743 .63468 m .6326 .63255 L .61161 .63901 L p F P
0 0 0 r
s
.145 .036 .015 r
.61161 .63901 m .59887 .64079 L .61743 .63468 L p F P
0 0 0 r
s
.713 .229 .096 r
.51706 .34097 m .50188 .34373 L .50154 .34506 L p F P
0 0 0 r
s
.713 .229 .096 r
.50154 .34506 m .51396 .3428 L .51706 .34097 L p F P
0 0 0 r
s
.105 .162 .375 r
.3897 .61156 m .38413 .6022 L .39769 .61433 L p F P
0 0 0 r
s
.24 .35 .67 r
.39192 .61233 m
.39328 .61462 L
s
.105 .162 .375 r
.39769 .61433 m .40251 .62251 L .3897 .61156 L p F P
0 0 0 r
s
.077 .112 .279 r
.63241 .41378 m .63649 .42683 L .62657 .41202 L p F P
0 0 0 r
s
.077 .112 .279 r
.62657 .41202 m .62269 .3998 L .63241 .41378 L p F P
0 0 0 r
s
.054 .079 .187 r
.64318 .44377 m .64731 .45699 L .64049 .43961 L p F P
0 0 0 r
s
.24 .35 .67 r
.64395 .45151 m
.64932 .46867 L
s
.054 .079 .187 r
.64049 .43961 m .63649 .42683 L .64318 .44377 L p F P
0 0 0 r
s
.24 .35 .67 r
.63276 .4297 m
.64395 .45151 L
s
.257 .356 .631 r
.34094 .49843 m .33351 .48561 L .33407 .50518 L p F P
0 0 0 r
s
.257 .356 .631 r
.33407 .50518 m .34147 .51775 L .34094 .49843 L p F P
0 0 0 r
s
.626 .205 .086 r
.51086 .6531 m .52331 .65136 L .51827 .65176 L p F P
0 0 0 r
s
.626 .205 .086 r
.51827 .65176 m .50852 .65313 L .51086 .6531 L p F P
0 0 0 r
s
.83 .24 .1 r
.43601 .66225 m
.44434 .66108 L
s
.45 .66029 m
.47768 .65641 L
s
.42714 .6588 m
.43601 .66225 L
s
.322 .464 .871 r
.35299 .3858 m .3471 .37447 L .3295 .38419 L p F P
0 0 0 r
s
.83 .24 .1 r
.34169 .377 m
.35012 .37286 L
s
.322 .464 .871 r
.3295 .38419 m .33623 .39672 L .35299 .3858 L p F P
0 0 0 r
s
.103 .028 .012 r
.39807 .36522 m .381 .36832 L .39734 .36273 L p F P
0 0 0 r
s
.83 .24 .1 r
.38314 .36948 m
.3877 .3671 L
s
.103 .028 .012 r
.39734 .36273 m .4121 .36005 L .39807 .36522 L p F P
0 0 0 r
s
.713 .229 .096 r
.5323 .3382 m .51706 .34097 L .51396 .3428 L p F P
0 0 0 r
s
.713 .229 .096 r
.51396 .3428 m .52642 .34054 L .5323 .3382 L p F P
0 0 0 r
s
.83 .24 .1 r
.51574 .34278 m
.52201 .34578 L
s
.73583 .30707 m
.73885 .31719 L
s
.73885 .31719 m
.78227 .30939 L
s
.74088 .60871 m
.78432 .60257 L
s
.74088 .60871 m
.74001 .61752 L
s
.33 .484 .915 r
.60893 .6323 m .61161 .63901 L .6326 .63255 L p F P
0 0 0 r
s
.83 .24 .1 r
.56785 .64168 m
.61016 .63575 L
s
.61016 .63575 m
.61023 .63555 L
s
.61142 .63233 m
.61347 .62674 L
s
.24 .35 .67 r
.62517 .63484 m
.62535 .6353 L
s
.62535 .6353 m
.63033 .64822 L
s
.33 .484 .915 r
.6326 .63255 m .62957 .62452 L .60893 .6323 L p F P
0 0 0 r
s
.24 .35 .67 r
.5508 .33299 m
.55652 .33507 L
s
.189 .292 .609 r
.57841 .32981 m .58187 .34023 L .56698 .3422 L p F P
0 0 0 r
s
.83 .24 .1 r
.5655 .33791 m
.57203 .33672 L
s
.58021 .33524 m
.60609 .33056 L
s
.189 .292 .609 r
.56698 .3422 m .56405 .3337 L .57841 .32981 L p F P
0 0 0 r
s
.24 .35 .67 r
.45098 .30619 m
.4211 .31658 L
s
.4211 .31658 m
.40795 .28698 L
s
.4211 .31658 m
.39301 .33121 L
s
.288 .406 .735 r
.33708 .46675 m .32969 .45373 L .32593 .47251 L p F P
0 0 0 r
s
.288 .406 .735 r
.32593 .47251 m .33351 .48561 L .33708 .46675 L p F P
0 0 0 r
s
.626 .205 .086 r
.52331 .65136 m .5358 .64961 L .52805 .6504 L p F P
0 0 0 r
s
.626 .205 .086 r
.52805 .6504 m .51827 .65176 L .52331 .65136 L p F P
0 0 0 r
s
.83 .24 .1 r
.51982 .65051 m
.52601 .64756 L
s
.146 .23 .499 r
.59902 .35415 m .6028 .36583 L .58865 .36058 L p F P
0 0 0 r
s
.146 .23 .499 r
.58865 .36058 m .58529 .35048 L .59902 .35415 L p F P
0 0 0 r
s
.317 .455 .846 r
.34284 .40901 m .33623 .39672 L .32323 .41049 L p F P
0 0 0 r
s
.317 .455 .846 r
.32323 .41049 m .33048 .42361 L .34284 .40901 L p F P
0 0 0 r
s
.83 .24 .1 r
.29285 .39532 m
.30071 .38442 L
s
.30071 .38442 m
.34169 .377 L
s
.30273 .6763 m
.34373 .67053 L
s
.30273 .6763 m
.29103 .66653 L
s
.307 .437 .803 r
.33759 .43645 m .33048 .42361 L .32215 .44044 L p F P
0 0 0 r
s
.307 .437 .803 r
.32215 .44044 m .32969 .45373 L .33759 .43645 L p F P
0 0 0 r
s
.24 .35 .67 r
.33293 .44716 m
.34406 .4221 L
s
.33293 .44716 m
.34748 .47305 L
s
.713 .229 .096 r
.54761 .33541 m .5323 .3382 L .52642 .34054 L p F P
0 0 0 r
s
.713 .229 .096 r
.52642 .34054 m .53892 .33827 L .54761 .33541 L p F P
0 0 0 r
s
.103 .028 .012 r
.41522 .36211 m .39807 .36522 L .4121 .36005 L p F P
0 0 0 r
s
.103 .028 .012 r
.4121 .36005 m .42691 .35736 L .41522 .36211 L p F P
0 0 0 r
s
.24 .35 .67 r
.39301 .33121 m
.37924 .30189 L
s
.39301 .33121 m
.36772 .34956 L
s
.188 .295 .615 r
.4296 .65055 m .42581 .64399 L .44193 .646 L p F P
0 0 0 r
s
.188 .295 .615 r
.44193 .646 m .44482 .65113 L .4296 .65055 L p F P
0 0 0 r
s
.24 .35 .67 r
.48157 .30044 m
.45098 .30619 L
s
.45098 .30619 m
.43845 .27632 L
s
.14 .226 .491 r
.40726 .63057 m .40251 .62251 L .41807 .63062 L p F P
0 0 0 r
s
.14 .226 .491 r
.41807 .63062 m .42196 .63735 L .40726 .63057 L p F P
0 0 0 r
s
.83 .24 .1 r
.60142 .32722 m
.60609 .33056 L
s
.60609 .33056 m
.64884 .32282 L
s
.62642 .63346 m
.62779 .63327 L
s
.61016 .63575 m
.6103 .63573 L
s
.16258 .43474 m
.17059 .41731 L
s
.17059 .41731 m
.21088 .41007 L
s
.626 .205 .086 r
.5358 .64961 m .54833 .64786 L .53786 .64902 L p F P
0 0 0 r
s
.626 .205 .086 r
.53786 .64902 m .52805 .6504 L .5358 .64961 L p F P
0 0 0 r
s
.713 .229 .096 r
.56297 .33262 m .54761 .33541 L .53892 .33827 L p F P
0 0 0 r
s
.713 .229 .096 r
.53892 .33827 m .55146 .33599 L .56297 .33262 L p F P
0 0 0 r
s
.103 .028 .012 r
.43245 .35898 m .41522 .36211 L .42691 .35736 L p F P
0 0 0 r
s
.83 .24 .1 r
.43099 .35855 m
.43199 .35799 L
s
.103 .028 .012 r
.42691 .35736 m .44178 .35465 L .43245 .35898 L p F P
0 0 0 r
s
.83 .24 .1 r
.43625 .35722 m
.47363 .35043 L
s
.326 .471 .874 r
.63639 .58541 m .63984 .59506 L .65253 .57991 L p F P
0 0 0 r
s
.326 .471 .874 r
.65253 .57991 m .64889 .56923 L .63639 .58541 L p F P
0 0 0 r
s
.24 .35 .67 r
.47708 .67348 m
.50719 .67509 L
s
.626 .205 .086 r
.54833 .64786 m .5609 .6461 L .54769 .64765 L p F P
0 0 0 r
s
.626 .205 .086 r
.54769 .64765 m .53786 .64902 L .54833 .64786 L p F P
0 0 0 r
s
.313 .45 .822 r
.64517 .55834 m .64889 .56923 L .65747 .55162 L p F P
0 0 0 r
s
.313 .45 .822 r
.65747 .55162 m .65362 .53992 L .64517 .55834 L p F P
0 0 0 r
s
.713 .229 .096 r
.57841 .32981 m .56297 .33262 L .55146 .33599 L p F P
0 0 0 r
s
.713 .229 .096 r
.55146 .33599 m .56405 .3337 L .57841 .32981 L p F P
0 0 0 r
s
.83 .24 .1 r
.55834 .33505 m
.56227 .33732 L
s
.24 .35 .67 r
.55806 .33563 m
.57636 .34228 L
s
.33 .481 .902 r
.62338 .6081 m .6265 .61637 L .64324 .60454 L p F P
0 0 0 r
s
.33 .481 .902 r
.64324 .60454 m .63984 .59506 L .62338 .6081 L p F P
0 0 0 r
s
.24 .35 .67 r
.36772 .34956 m
.35335 .32053 L
s
.288 .411 .737 r
.6497 .52798 m .65362 .53992 L .65812 .52083 L p F P
0 0 0 r
s
.288 .411 .737 r
.65812 .52083 m .65412 .50833 L .6497 .52798 L p F P
0 0 0 r
s
.103 .028 .012 r
.44976 .35584 m .43245 .35898 L .44178 .35465 L p F P
0 0 0 r
s
.103 .028 .012 r
.44178 .35465 m .45672 .35194 L .44976 .35584 L p F P
0 0 0 r
s
.83 .24 .1 r
.78227 .30939 m
.78008 .29906 L
s
.78432 .60257 m
.82825 .59635 L
s
.78432 .60257 m
.78429 .61131 L
s
.11 .17 .391 r
.61471 .37462 m .61874 .38733 L .60651 .3773 L p F P
0 0 0 r
s
.11 .17 .391 r
.60651 .3773 m .6028 .36583 L .61471 .37462 L p F P
0 0 0 r
s
.626 .205 .086 r
.5609 .6461 m .57351 .64434 L .55754 .64627 L p F P
0 0 0 r
s
.626 .205 .086 r
.55754 .64627 m .54769 .64765 L .5609 .6461 L p F P
0 0 0 r
s
.24 .35 .67 r
.51177 .29958 m
.48157 .30044 L
s
.48157 .30044 m
.46965 .27032 L
s
.071 .103 .253 r
.36741 .57727 m .36101 .56654 L .3727 .58298 L p F P
0 0 0 r
s
.071 .103 .253 r
.3727 .58298 m .37846 .59267 L .36741 .57727 L p F P
0 0 0 r
s
.24 .35 .67 r
.36585 .57104 m
.3797 .59173 L
s
.856 .268 .114 r
.45053 .66124 m .46014 .6599 L .4724 .65397 L p F P
0 0 0 r
s
.856 .268 .114 r
.4724 .65397 m .46574 .65491 L .45053 .66124 L p F P
0 0 0 r
s
.228 .351 .713 r
.45053 .66124 m .44769 .65621 L .46382 .6514 L p F P
0 0 0 r
s
.228 .351 .713 r
.46382 .6514 m .46574 .65491 L .45053 .66124 L p F P
0 0 0 r
s
.162 .212 .366 r
.35297 .54874 m .34598 .53697 L .35448 .5556 L p F P
0 0 0 r
s
.162 .212 .366 r
.35448 .5556 m .36101 .56654 L .35297 .54874 L p F P
0 0 0 r
s
.83 .24 .1 r
.34169 .377 m
.34293 .37677 L
s
.34373 .67053 m
.3852 .6647 L
s
.34373 .67053 m
.33269 .6606 L
s
.105 .162 .375 r
.38413 .6022 m .37846 .59267 L .3928 .60602 L p F P
0 0 0 r
s
.24 .35 .67 r
.3797 .59173 m
.38248 .59641 L
s
.38654 .60326 m
.38792 .60559 L
s
.105 .162 .375 r
.3928 .60602 m .39769 .61433 L .38413 .6022 L p F P
0 0 0 r
s
.247 .347 .604 r
.65004 .49556 m .65412 .50833 L .65464 .48882 L p F P
0 0 0 r
s
.247 .347 .604 r
.65464 .48882 m .65055 .4758 L .65004 .49556 L p F P
0 0 0 r
s
.24 .35 .67 r
.64902 .47604 m
.65043 .48053 L
s
.626 .205 .086 r
.57351 .64434 m .58617 .64257 L .56743 .64489 L p F P
0 0 0 r
s
.626 .205 .086 r
.56743 .64489 m .55754 .64627 L .57351 .64434 L p F P
0 0 0 r
s
.83 .24 .1 r
.20911 .67818 m
.24984 .67239 L
s
.20911 .67818 m
.19613 .6622 L
s
.103 .028 .012 r
.46715 .35268 m .44976 .35584 L .45672 .35194 L p F P
0 0 0 r
s
.103 .028 .012 r
.45672 .35194 m .47171 .34921 L .46715 .35268 L p F P
0 0 0 r
s
.33 .484 .915 r
.60622 .62551 m .60893 .6323 L .62957 .62452 L p F P
0 0 0 r
s
.83 .24 .1 r
.62779 .63327 m
.65295 .62974 L
s
.33 .484 .915 r
.62957 .62452 m .6265 .61637 L .60622 .62551 L p F P
0 0 0 r
s
.83 .24 .1 r
.64501 .31931 m
.64884 .32282 L
s
.64884 .32282 m
.69209 .31499 L
s
.856 .268 .114 r
.46014 .6599 m .46976 .65855 L .47907 .65303 L p F P
0 0 0 r
s
.856 .268 .114 r
.47907 .65303 m .4724 .65397 L .46014 .6599 L p F P
0 0 0 r
s
.24 .35 .67 r
.46721 .65537 m
.46891 .65848 L
s
.188 .295 .615 r
.42581 .64399 m .42196 .63735 L .439 .64081 L p F P
0 0 0 r
s
.24 .35 .67 r
.42127 .63616 m
.42464 .63789 L
s
.188 .295 .615 r
.439 .64081 m .44193 .646 L .42581 .64399 L p F P
0 0 0 r
s
.209 .049 .021 r
.34832 .38079 m .3295 .38419 L .3471 .37447 L p F P
0 0 0 r
s
.83 .24 .1 r
.34121 .37772 m
.34169 .377 L
s
.209 .049 .021 r
.3471 .37447 m .36401 .3714 L .34832 .38079 L p F P
0 0 0 r
s
.24 .35 .67 r
.35057 .37945 m
.3605 .39856 L
s
.34797 .37444 m
.34804 .37458 L
s
.34619 .37101 m
.34797 .37444 L
s
.83 .24 .1 r
.65295 .62974 m
.69623 .62367 L
s
.65295 .62974 m
.6492 .63239 L
s
.2035 .42747 m
.21088 .41007 L
s
.21088 .41007 m
.25163 .40273 L
s
.208 .282 .479 r
.34147 .51775 m .33407 .50518 L .33885 .52497 L p F P
0 0 0 r
s
.208 .282 .479 r
.33885 .52497 m .34598 .53697 L .34147 .51775 L p F P
0 0 0 r
s
.24 .35 .67 r
.3438 .5234 m
.35816 .54777 L
s
.34253 .49844 m
.3438 .5234 L
s
.077 .112 .279 r
.62824 .40046 m .63241 .41378 L .62269 .3998 L p F P
0 0 0 r
s
.077 .112 .279 r
.62269 .3998 m .61874 .38733 L .62824 .40046 L p F P
0 0 0 r
s
.24 .35 .67 r
.60736 .38445 m
.62423 .40276 L
s
.191 .261 .437 r
.64638 .46248 m .65055 .4758 L .64731 .45699 L p F P
0 0 0 r
s
.191 .261 .437 r
.64731 .45699 m .64318 .44377 L .64638 .46248 L p F P
0 0 0 r
s
.24 .35 .67 r
.64395 .45151 m
.64902 .47604 L
s
.146 .23 .499 r
.59517 .34226 m .59902 .35415 L .58529 .35048 L p F P
0 0 0 r
s
.146 .23 .499 r
.58529 .35048 m .58187 .34023 L .59517 .34226 L p F P
0 0 0 r
s
.24 .35 .67 r
.57636 .34228 m
.58585 .3704 L
s
.054 .079 .187 r
.63897 .43026 m .64318 .44377 L .63649 .42683 L p F P
0 0 0 r
s
.054 .079 .187 r
.63649 .42683 m .63241 .41378 L .63897 .43026 L p F P
0 0 0 r
s
.24 .35 .67 r
.62423 .40276 m
.63276 .4297 L
s
.856 .268 .114 r
.46976 .65855 m .47941 .6572 L .48576 .65209 L p F P
0 0 0 r
s
.856 .268 .114 r
.48576 .65209 m .47907 .65303 L .46976 .65855 L p F P
0 0 0 r
s
.24 .35 .67 r
.46891 .65848 m
.47708 .67348 L
s
.626 .205 .086 r
.58617 .64257 m .59887 .64079 L .57733 .6435 L p F P
0 0 0 r
s
.626 .205 .086 r
.57733 .6435 m .56743 .64489 L .58617 .64257 L p F P
0 0 0 r
s
.83 .24 .1 r
.56245 .64454 m
.56785 .64168 L
s
.14 .226 .491 r
.40251 .62251 m .39769 .61433 L .41412 .6238 L p F P
0 0 0 r
s
.14 .226 .491 r
.41412 .6238 m .41807 .63062 L .40251 .62251 L p F P
0 0 0 r
s
.103 .028 .012 r
.48463 .34951 m .46715 .35268 L .47171 .34921 L p F P
0 0 0 r
s
.83 .24 .1 r
.46749 .35419 m
.47113 .35196 L
s
.103 .028 .012 r
.47171 .34921 m .48677 .34648 L .48463 .34951 L p F P
0 0 0 r
s
.83 .24 .1 r
.4855 .34827 m
.51574 .34278 L
s
.257 .356 .631 r
.33351 .48561 m .32593 .47251 L .32652 .49234 L p F P
0 0 0 r
s
.257 .356 .631 r
.32652 .49234 m .33407 .50518 L .33351 .48561 L p F P
0 0 0 r
s
.209 .049 .021 r
.36723 .37738 m .34832 .38079 L .36401 .3714 L p F P
0 0 0 r
s
.209 .049 .021 r
.36401 .3714 m .381 .36832 L .36723 .37738 L p F P
0 0 0 r
s
.83 .24 .1 r
.37774 .37046 m
.38314 .36948 L
s
.24 .35 .67 r
.34619 .37101 m
.36772 .34956 L
s
.856 .268 .114 r
.47941 .6572 m .48909 .65585 L .49246 .65115 L p F P
0 0 0 r
s
.83 .24 .1 r
.48096 .65595 m
.4826 .65572 L
s
.856 .268 .114 r
.49246 .65115 m .48576 .65209 L .47941 .6572 L p F P
0 0 0 r
s
.83 .24 .1 r
.48991 .6547 m
.51982 .65051 L
s
.24 .35 .67 r
.50719 .67509 m
.53828 .67083 L
s
.57636 .34228 m
.59821 .35629 L
s
.57262 .33123 m
.57636 .34228 L
s
.317 .455 .846 r
.33623 .39672 m .3295 .38419 L .31582 .39711 L p F P
0 0 0 r
s
.317 .455 .846 r
.31582 .39711 m .32323 .41049 L .33623 .39672 L p F P
0 0 0 r
s
.626 .205 .086 r
.59887 .64079 m .61161 .63901 L .58727 .64211 L p F P
0 0 0 r
s
.626 .205 .086 r
.58727 .64211 m .57733 .6435 L .59887 .64079 L p F P
0 0 0 r
s
.288 .406 .735 r
.32969 .45373 m .32215 .44044 L .31817 .45913 L p F P
0 0 0 r
s
.288 .406 .735 r
.31817 .45913 m .32593 .47251 L .32969 .45373 L p F P
0 0 0 r
s
.24 .35 .67 r
.32771 .47279 m
.33293 .44716 L
s
.228 .351 .713 r
.44769 .65621 m .44482 .65113 L .4619 .64788 L p F P
0 0 0 r
s
.228 .351 .713 r
.4619 .64788 m .46382 .6514 L .44769 .65621 L p F P
0 0 0 r
s
.83 .24 .1 r
.8291 .60502 m
.82825 .59635 L
s
.24 .35 .67 r
.34619 .37101 m
.33125 .34227 L
s
.34068 .37876 m
.34619 .37101 L
s
.32927 .39482 m
.3379 .38267 L
s
.307 .437 .803 r
.33048 .42361 m .32323 .41049 L .31444 .42686 L p F P
0 0 0 r
s
.24 .35 .67 r
.32927 .39482 m
.34406 .4221 L
s
.307 .437 .803 r
.31444 .42686 m .32215 .44044 L .33048 .42361 L p F P
0 0 0 r
s
.103 .028 .012 r
.50219 .34632 m .48463 .34951 L .48677 .34648 L p F P
0 0 0 r
s
.103 .028 .012 r
.48677 .34648 m .50188 .34373 L .50219 .34632 L p F P
0 0 0 r
s
.856 .268 .114 r
.48909 .65585 m .49879 .65449 L .49916 .65021 L p F P
0 0 0 r
s
.856 .268 .114 r
.49916 .65021 m .49246 .65115 L .48909 .65585 L p F P
0 0 0 r
s
.24 .35 .67 r
.49577 .65298 m
.49653 .65445 L
s
.83 .24 .1 r
.3852 .6647 m
.42714 .6588 L
s
.3852 .6647 m
.37485 .6546 L
s
.209 .049 .021 r
.38625 .37395 m .36723 .37738 L .381 .36832 L p F P
0 0 0 r
s
.209 .049 .021 r
.381 .36832 m .39807 .36522 L .38625 .37395 L p F P
0 0 0 r
s
.326 .48 .916 r
.58506 .63689 m .58727 .64211 L .61161 .63901 L p F P
0 0 0 r
s
.24 .35 .67 r
.59708 .64564 m
.60309 .64086 L
s
.60309 .64086 m
.60417 .64 L
s
.326 .48 .916 r
.61161 .63901 m .60893 .6323 L .58506 .63689 L p F P
0 0 0 r
s
.83 .24 .1 r
.60557 .6385 m
.6067 .63782 L
s
.6067 .63782 m
.6069 .6377 L
s
.24 .35 .67 r
.54044 .30375 m
.51177 .29958 L
s
.51177 .29958 m
.50042 .26924 L
s
.856 .268 .114 r
.49879 .65449 m .50852 .65313 L .50589 .64927 L p F P
0 0 0 r
s
.856 .268 .114 r
.50589 .64927 m .49916 .65021 L .49879 .65449 L p F P
0 0 0 r
s
.24 .35 .67 r
.49653 .65445 m
.50719 .67509 L
s
.83 .24 .1 r
.24984 .67239 m
.29103 .66653 L
s
.24984 .67239 m
.23742 .65622 L
s
.6891 .3113 m
.69209 .31499 L
s
.69209 .31499 m
.73583 .30707 L
s
.326 .471 .874 r
.63288 .57559 m .63639 .58541 L .64889 .56923 L p F P
0 0 0 r
s
.326 .471 .874 r
.64889 .56923 m .64517 .55834 L .63288 .57559 L p F P
0 0 0 r
s
.33 .481 .902 r
.62021 .5997 m .62338 .6081 L .63984 .59506 L p F P
0 0 0 r
s
.33 .481 .902 r
.63984 .59506 m .63639 .58541 L .62021 .5997 L p F P
0 0 0 r
s
.83 .24 .1 r
.69623 .62367 m
.74001 .61752 L
s
.69623 .62367 m
.69333 .62621 L
s
.103 .028 .012 r
.51983 .34312 m .50219 .34632 L .50188 .34373 L p F P
0 0 0 r
s
.83 .24 .1 r
.515 .34329 m
.51574 .34278 L
s
.103 .028 .012 r
.50188 .34373 m .51706 .34097 L .51983 .34312 L p F P
0 0 0 r
s
.83 .24 .1 r
.24488 .42011 m
.25163 .40273 L
s
.25163 .40273 m
.29285 .39532 L
s
.188 .295 .615 r
.42196 .63735 m .41807 .63062 L .43605 .63558 L p F P
0 0 0 r
s
.188 .295 .615 r
.43605 .63558 m .439 .64081 L .42196 .63735 L p F P
0 0 0 r
s
.856 .268 .114 r
.50852 .65313 m .51827 .65176 L .51262 .64832 L p F P
0 0 0 r
s
.856 .268 .114 r
.51262 .64832 m .50589 .64927 L .50852 .65313 L p F P
0 0 0 r
s
.11 .17 .391 r
.61061 .36166 m .61471 .37462 L .6028 .36583 L p F P
0 0 0 r
s
.11 .17 .391 r
.6028 .36583 m .59902 .35415 L .61061 .36166 L p F P
0 0 0 r
s
.24 .35 .67 r
.59821 .35629 m
.60736 .38445 L
s
.313 .45 .822 r
.64138 .54724 m .64517 .55834 L .65362 .53992 L p F P
0 0 0 r
s
.24 .35 .67 r
.65148 .5412 m
.65271 .53715 L
s
.313 .45 .822 r
.65362 .53992 m .6497 .52798 L .64138 .54724 L p F P
0 0 0 r
s
.24 .35 .67 r
.53828 .67083 m
.56877 .66085 L
s
.209 .049 .021 r
.40536 .3705 m .38625 .37395 L .39807 .36522 L p F P
0 0 0 r
s
.209 .049 .021 r
.39807 .36522 m .41522 .36211 L .40536 .3705 L p F P
0 0 0 r
s
.24 .35 .67 r
.56877 .66085 m
.59708 .64564 L
s
.59521 .64112 m
.59708 .64564 L
s
.33 .484 .915 r
.60347 .61863 m .60622 .62551 L .6265 .61637 L p F P
0 0 0 r
s
.33 .484 .915 r
.6265 .61637 m .62338 .6081 L .60347 .61863 L p F P
0 0 0 r
s
.856 .268 .114 r
.51827 .65176 m .52805 .6504 L .51937 .64737 L p F P
0 0 0 r
s
.83 .24 .1 r
.52593 .64965 m
.56245 .64454 L
s
.856 .268 .114 r
.51937 .64737 m .51262 .64832 L .51827 .65176 L p F P
0 0 0 r
s
.103 .028 .012 r
.53756 .33991 m .51983 .34312 L .51706 .34097 L p F P
0 0 0 r
s
.103 .028 .012 r
.51706 .34097 m .5323 .3382 L .53756 .33991 L p F P
0 0 0 r
s
.83 .24 .1 r
.53541 .33921 m
.55834 .33505 L
s
.105 .162 .375 r
.37846 .59267 m .3727 .58298 L .38783 .59759 L p F P
0 0 0 r
s
.105 .162 .375 r
.38783 .59759 m .3928 .60602 L .37846 .59267 L p F P
0 0 0 r
s
.071 .103 .253 r
.36101 .56654 m .35448 .5556 L .36683 .57312 L p F P
0 0 0 r
s
.071 .103 .253 r
.36683 .57312 m .3727 .58298 L .36101 .56654 L p F P
0 0 0 r
s
.83 .24 .1 r
.55834 .33505 m
.57471 .33207 L
s
.288 .411 .737 r
.64569 .51578 m .6497 .52798 L .65412 .50833 L p F P
0 0 0 r
s
.288 .411 .737 r
.65412 .50833 m .65004 .49556 L .64569 .51578 L p F P
0 0 0 r
s
.228 .351 .713 r
.44482 .65113 m .44193 .646 L .45996 .64433 L p F P
0 0 0 r
s
.228 .351 .713 r
.45996 .64433 m .4619 .64788 L .44482 .65113 L p F P
0 0 0 r
s
.83 .24 .1 r
.59687 .63972 m
.60557 .6385 L
s
.56245 .64454 m
.58685 .64112 L
s
.146 .23 .499 r
.59125 .33016 m .59517 .34226 L .58187 .34023 L p F P
0 0 0 r
s
.146 .23 .499 r
.58187 .34023 m .57841 .32981 L .59125 .33016 L p F P
0 0 0 r
s
.83 .24 .1 r
.58601 .33002 m
.60142 .32722 L
s
.24 .35 .67 r
.44161 .64544 m
.44329 .64587 L
s
.856 .268 .114 r
.52805 .6504 m .53786 .64902 L .52613 .64642 L p F P
0 0 0 r
s
.24 .35 .67 r
.52821 .65002 m
.53828 .67083 L
s
.856 .268 .114 r
.52613 .64642 m .51937 .64737 L .52805 .6504 L p F P
0 0 0 r
s
.162 .212 .366 r
.34598 .53697 m .33885 .52497 L .34782 .54445 L p F P
0 0 0 r
s
.162 .212 .366 r
.34782 .54445 m .35448 .5556 L .34598 .53697 L p F P
0 0 0 r
s
.24 .35 .67 r
.3438 .5234 m
.35147 .54685 L
s
.35147 .54685 m
.36585 .57104 L
s
.14 .226 .491 r
.39769 .61433 m .3928 .60602 L .41013 .6169 L p F P
0 0 0 r
s
.14 .226 .491 r
.41013 .6169 m .41412 .6238 L .39769 .61433 L p F P
0 0 0 r
s
.209 .049 .021 r
.42457 .36703 m .40536 .3705 L .41522 .36211 L p F P
0 0 0 r
s
.209 .049 .021 r
.41522 .36211 m .43245 .35898 L .42457 .36703 L p F P
0 0 0 r
s
.103 .028 .012 r
.55537 .33667 m .53756 .33991 L .5323 .3382 L p F P
0 0 0 r
s
.103 .028 .012 r
.5323 .3382 m .54761 .33541 L .55537 .33667 L p F P
0 0 0 r
s
.247 .347 .604 r
.64588 .48251 m .65004 .49556 L .65055 .4758 L p F P
0 0 0 r
s
.247 .347 .604 r
.65055 .4758 m .64638 .46248 L .64588 .48251 L p F P
0 0 0 r
s
.077 .112 .279 r
.62399 .38686 m .62824 .40046 L .61874 .38733 L p F P
0 0 0 r
s
.077 .112 .279 r
.61874 .38733 m .61471 .37462 L .62399 .38686 L p F P
0 0 0 r
s
.24 .35 .67 r
.64481 .55885 m
.64514 .55826 L
s
.856 .268 .114 r
.53786 .64902 m .54769 .64765 L .5329 .64547 L p F P
0 0 0 r
s
.856 .268 .114 r
.5329 .64547 m .52613 .64642 L .53786 .64902 L p F P
0 0 0 r
s
.24 .35 .67 r
.52749 .64853 m
.52821 .65002 L
s
.83 .24 .1 r
.42714 .6588 m
.46217 .65387 L
s
.41749 .64853 m
.42714 .6588 L
s
.15699 .45788 m
.16258 .43474 L
s
.16258 .43474 m
.2035 .42747 L
s
.208 .282 .479 r
.33407 .50518 m .32652 .49234 L .33156 .51271 L p F P
0 0 0 r
s
.24 .35 .67 r
.32771 .47279 m
.34253 .49844 L
s
.208 .282 .479 r
.33156 .51271 m .33885 .52497 L .33407 .50518 L p F P
0 0 0 r
s
.326 .48 .916 r
.58282 .63161 m .58506 .63689 L .60893 .6323 L p F P
0 0 0 r
s
.326 .48 .916 r
.60893 .6323 m .60622 .62551 L .58282 .63161 L p F P
0 0 0 r
s
.83 .24 .1 r
.29103 .66653 m
.33269 .6606 L
s
.29103 .66653 m
.2792 .65017 L
s
.73371 .3032 m
.73583 .30707 L
s
.73583 .30707 m
.78008 .29906 L
s
.191 .261 .437 r
.64211 .44888 m .64638 .46248 L .64318 .44377 L p F P
0 0 0 r
s
.191 .261 .437 r
.64318 .44377 m .63897 .43026 L .64211 .44888 L p F P
0 0 0 r
s
.054 .079 .187 r
.63467 .41646 m .63897 .43026 L .63241 .41378 L p F P
0 0 0 r
s
.24 .35 .67 r
.63556 .42469 m
.64092 .44182 L
s
.054 .079 .187 r
.63241 .41378 m .62824 .40046 L .63467 .41646 L p F P
0 0 0 r
s
.24 .35 .67 r
.62423 .40276 m
.63556 .42469 L
s
.83 .24 .1 r
.74001 .61752 m
.78429 .61131 L
s
.74001 .61752 m
.73798 .61995 L
s
.28676 .41267 m
.29285 .39532 L
s
.856 .268 .114 r
.54769 .64765 m .55754 .64627 L .53968 .64452 L p F P
0 0 0 r
s
.856 .268 .114 r
.53968 .64452 m .5329 .64547 L .54769 .64765 L p F P
0 0 0 r
s
.209 .049 .021 r
.44389 .36354 m .42457 .36703 L .43245 .35898 L p F P
0 0 0 r
s
.209 .049 .021 r
.43245 .35898 m .44976 .35584 L .44389 .36354 L p F P
0 0 0 r
s
.103 .028 .012 r
.57327 .33343 m .55537 .33667 L .54761 .33541 L p F P
0 0 0 r
s
.103 .028 .012 r
.54761 .33541 m .56297 .33262 L .57327 .33343 L p F P
0 0 0 r
s
.24 .35 .67 r
.54044 .30375 m
.55033 .33167 L
s
.55033 .33167 m
.5508 .33299 L
s
.305 .071 .031 r
.33611 .39347 m .31582 .39711 L .3295 .38419 L p F P
0 0 0 r
s
.24 .35 .67 r
.31384 .36635 m
.32586 .38852 L
s
.32921 .39471 m
.32927 .39482 L
s
.83 .24 .1 r
.29285 .39532 m
.32357 .38979 L
s
.305 .071 .031 r
.3295 .38419 m .34832 .38079 L .33611 .39347 L p F P
0 0 0 r
s
.188 .295 .615 r
.41807 .63062 m .41412 .6238 L .43306 .63029 L p F P
0 0 0 r
s
.188 .295 .615 r
.43306 .63029 m .43605 .63558 L .41807 .63062 L p F P
0 0 0 r
s
.257 .356 .631 r
.32593 .47251 m .31817 .45913 L .3188 .47922 L p F P
0 0 0 r
s
.257 .356 .631 r
.3188 .47922 m .32652 .49234 L .32593 .47251 L p F P
0 0 0 r
s
.856 .268 .114 r
.55754 .64627 m .56743 .64489 L .54647 .64356 L p F P
0 0 0 r
s
.24 .35 .67 r
.56186 .64547 m
.56877 .66085 L
s
.856 .268 .114 r
.54647 .64356 m .53968 .64452 L .55754 .64627 L p F P
0 0 0 r
s
.228 .351 .713 r
.44193 .646 m .439 .64081 L .45801 .64076 L p F P
0 0 0 r
s
.228 .351 .713 r
.45801 .64076 m .45996 .64433 L .44193 .646 L p F P
0 0 0 r
s
.24 .35 .67 r
.56644 .31292 m
.54044 .30375 L
s
.54044 .30375 m
.52962 .27323 L
s
.43845 .27632 m
.40795 .28698 L
s
.40795 .28698 m
.39421 .25608 L
s
.40795 .28698 m
.37924 .30189 L
s
.83 .24 .1 r
.60142 .32722 m
.64501 .31931 L
s
.288 .406 .735 r
.32215 .44044 m .31444 .42686 L .31025 .44545 L p F P
0 0 0 r
s
.288 .406 .735 r
.31025 .44545 m .31817 .45913 L .32215 .44044 L p F P
0 0 0 r
s
.307 .437 .803 r
.32323 .41049 m .31582 .39711 L .30656 .41298 L p F P
0 0 0 r
s
.307 .437 .803 r
.30656 .41298 m .31444 .42686 L .32323 .41049 L p F P
0 0 0 r
s
.24 .35 .67 r
.31775 .42014 m
.32927 .39482 L
s
.31775 .42014 m
.33293 .44716 L
s
.103 .028 .012 r
.59125 .33016 m .57327 .33343 L .56297 .33262 L p F P
0 0 0 r
s
.24 .35 .67 r
.57231 .33029 m
.57251 .33089 L
s
.103 .028 .012 r
.56297 .33262 m .57841 .32981 L .59125 .33016 L p F P
0 0 0 r
s
.24 .35 .67 r
.56644 .31292 m
.57231 .33029 L
s
.209 .049 .021 r
.4633 .36003 m .44389 .36354 L .44976 .35584 L p F P
0 0 0 r
s
.209 .049 .021 r
.44976 .35584 m .46715 .35268 L .4633 .36003 L p F P
0 0 0 r
s
.83 .24 .1 r
.46624 .35442 m
.46749 .35419 L
s
.60557 .6385 m
.6492 .63239 L
s
.59985 .63449 m
.60557 .6385 L
s
.856 .268 .114 r
.56743 .64489 m .57733 .6435 L .55328 .64261 L p F P
0 0 0 r
s
.83 .24 .1 r
.56139 .64391 m
.56245 .64454 L
s
.856 .268 .114 r
.55328 .64261 m .54647 .64356 L .56743 .64489 L p F P
0 0 0 r
s
.33 .481 .902 r
.61699 .59116 m .62021 .5997 L .63639 .58541 L p F P
0 0 0 r
s
.33 .481 .902 r
.63639 .58541 m .63288 .57559 L .61699 .59116 L p F P
0 0 0 r
s
.24 .35 .67 r
.37924 .30189 m
.36486 .27128 L
s
.37924 .30189 m
.35335 .32053 L
s
.305 .071 .031 r
.35652 .38982 m .33611 .39347 L .34832 .38079 L p F P
0 0 0 r
s
.305 .071 .031 r
.34832 .38079 m .36723 .37738 L .35652 .38982 L p F P
0 0 0 r
s
.33 .484 .915 r
.60068 .61166 m .60347 .61863 L .62338 .6081 L p F P
0 0 0 r
s
.33 .484 .915 r
.62338 .6081 m .62021 .5997 L .60068 .61166 L p F P
0 0 0 r
s
.326 .471 .874 r
.6293 .56559 m .63288 .57559 L .64517 .55834 L p F P
0 0 0 r
s
.326 .471 .874 r
.64517 .55834 m .64138 .54724 L .6293 .56559 L p F P
0 0 0 r
s
.83 .24 .1 r
.19613 .6622 m
.23742 .65622 L
s
.19613 .6622 m
.18384 .64023 L
s
.11 .17 .391 r
.60642 .34845 m .61061 .36166 L .59902 .35415 L p F P
0 0 0 r
s
.11 .17 .391 r
.59902 .35415 m .59517 .34226 L .60642 .34845 L p F P
0 0 0 r
s
.24 .35 .67 r
.46965 .27032 m
.43845 .27632 L
s
.43845 .27632 m
.42536 .24514 L
s
.856 .268 .114 r
.57733 .6435 m .58727 .64211 L .5601 .64165 L p F P
0 0 0 r
s
.856 .268 .114 r
.5601 .64165 m .55328 .64261 L .57733 .6435 L p F P
0 0 0 r
s
.24 .35 .67 r
.56043 .64229 m
.56186 .64547 L
s
.967 .295 .126 r
.46574 .65491 m .4724 .65397 L .48579 .64388 L p F P
0 0 0 r
s
.967 .295 .126 r
.48579 .64388 m .48236 .64436 L .46574 .65491 L p F P
0 0 0 r
s
.257 .392 .782 r
.46574 .65491 m .46382 .6514 L .4814 .64255 L p F P
0 0 0 r
s
.24 .35 .67 r
.46659 .65423 m
.46664 .65433 L
s
.46367 .65112 m
.46414 .65124 L
s
.257 .392 .782 r
.4814 .64255 m .48236 .64436 L .46574 .65491 L p F P
0 0 0 r
s
.209 .049 .021 r
.48282 .35651 m .4633 .36003 L .46715 .35268 L p F P
0 0 0 r
s
.209 .049 .021 r
.46715 .35268 m .48463 .34951 L .48282 .35651 L p F P
0 0 0 r
s
.83 .24 .1 r
.19844 .45065 m
.2035 .42747 L
s
.2035 .42747 m
.24488 .42011 L
s
.105 .162 .375 r
.3727 .58298 m .36683 .57312 L .38278 .58902 L p F P
0 0 0 r
s
.24 .35 .67 r
.37551 .58466 m
.37694 .58707 L
s
.105 .162 .375 r
.38278 .58902 m .38783 .59759 L .3727 .58298 L p F P
0 0 0 r
s
.83 .24 .1 r
.33269 .6606 m
.37485 .6546 L
s
.33269 .6606 m
.32147 .64405 L
s
.967 .295 .126 r
.4724 .65397 m .47907 .65303 L .48923 .64339 L p F P
0 0 0 r
s
.967 .295 .126 r
.48923 .64339 m .48579 .64388 L .4724 .65397 L p F P
0 0 0 r
s
.313 .45 .822 r
.63752 .53592 m .64138 .54724 L .6497 .52798 L p F P
0 0 0 r
s
.313 .45 .822 r
.6497 .52798 m .64569 .51578 L .63752 .53592 L p F P
0 0 0 r
s
.319 .473 .909 r
.55849 .63806 m .5601 .64165 L .58727 .64211 L p F P
0 0 0 r
s
.319 .473 .909 r
.58727 .64211 m .58506 .63689 L .55849 .63806 L p F P
0 0 0 r
s
.14 .226 .491 r
.3928 .60602 m .38783 .59759 L .40608 .60991 L p F P
0 0 0 r
s
.14 .226 .491 r
.40608 .60991 m .41013 .6169 L .3928 .60602 L p F P
0 0 0 r
s
.83 .24 .1 r
.78008 .29906 m
.77885 .295 L
s
.78429 .61131 m
.8291 .60502 L
s
.78429 .61131 m
.78316 .61362 L
s
.326 .48 .916 r
.58056 .62629 m .58282 .63161 L .60622 .62551 L p F P
0 0 0 r
s
.326 .48 .916 r
.60622 .62551 m .60347 .61863 L .58056 .62629 L p F P
0 0 0 r
s
.305 .071 .031 r
.37704 .38614 m .35652 .38982 L .36723 .37738 L p F P
0 0 0 r
s
.305 .071 .031 r
.36723 .37738 m .38625 .37395 L .37704 .38614 L p F P
0 0 0 r
s
.071 .103 .253 r
.35448 .5556 m .34782 .54445 L .36085 .56308 L p F P
0 0 0 r
s
.071 .103 .253 r
.36085 .56308 m .36683 .57312 L .35448 .5556 L p F P
0 0 0 r
s
.967 .295 .126 r
.47907 .65303 m .48576 .65209 L .49268 .6429 L p F P
0 0 0 r
s
.967 .295 .126 r
.49268 .6429 m .48923 .64339 L .47907 .65303 L p F P
0 0 0 r
s
.24 .35 .67 r
.47955 .65219 m
.49577 .65298 L
s
.4763 .65203 m
.47955 .65219 L
s
.228 .351 .713 r
.439 .64081 m .43605 .63558 L .45604 .63716 L p F P
0 0 0 r
s
.228 .351 .713 r
.45604 .63716 m .45801 .64076 L .439 .64081 L p F P
0 0 0 r
s
.967 .295 .126 r
.48576 .65209 m .49246 .65115 L .49612 .64242 L p F P
0 0 0 r
s
.83 .24 .1 r
.48706 .65037 m
.4877 .65028 L
s
.967 .295 .126 r
.49612 .64242 m .49268 .6429 L .48576 .65209 L p F P
0 0 0 r
s
.24 .35 .67 r
.35335 .32053 m
.33834 .29022 L
s
.35335 .32053 m
.33125 .34227 L
s
.209 .049 .021 r
.50245 .35297 m .48282 .35651 L .48463 .34951 L p F P
0 0 0 r
s
.209 .049 .021 r
.48463 .34951 m .50219 .34632 L .50245 .35297 L p F P
0 0 0 r
s
.288 .411 .737 r
.6416 .50333 m .64569 .51578 L .65004 .49556 L p F P
0 0 0 r
s
.288 .411 .737 r
.65004 .49556 m .64588 .48251 L .6416 .50333 L p F P
0 0 0 r
s
.188 .295 .615 r
.41412 .6238 m .41013 .6169 L .43005 .62495 L p F P
0 0 0 r
s
.188 .295 .615 r
.43005 .62495 m .43306 .63029 L .41412 .6238 L p F P
0 0 0 r
s
.257 .392 .782 r
.46382 .6514 m .4619 .64788 L .48044 .64072 L p F P
0 0 0 r
s
.24 .35 .67 r
.46473 .65082 m
.46478 .65092 L
s
.257 .392 .782 r
.48044 .64072 m .4814 .64255 L .46382 .6514 L p F P
0 0 0 r
s
.83 .24 .1 r
.46539 .64794 m
.46633 .64904 L
s
.162 .212 .366 r
.33885 .52497 m .33156 .51271 L .34104 .53307 L p F P
0 0 0 r
s
.162 .212 .366 r
.34104 .53307 m .34782 .54445 L .33885 .52497 L p F P
0 0 0 r
s
.967 .295 .126 r
.49246 .65115 m .49916 .65021 L .49957 .64193 L p F P
0 0 0 r
s
.83 .24 .1 r
.49314 .64951 m
.49379 .64942 L
s
.967 .295 .126 r
.49957 .64193 m .49612 .64242 L .49246 .65115 L p F P
0 0 0 r
s
.83 .24 .1 r
.64217 .32253 m
.64501 .31931 L
s
.64501 .31931 m
.6891 .3113 L
s
.24 .35 .67 r
.50042 .26924 m
.46965 .27032 L
s
.46965 .27032 m
.4572 .23886 L
s
.077 .112 .279 r
.61965 .37298 m .62399 .38686 L .61471 .37462 L p F P
0 0 0 r
s
.077 .112 .279 r
.61471 .37462 m .61061 .36166 L .61965 .37298 L p F P
0 0 0 r
s
.24 .35 .67 r
.59821 .35629 m
.61533 .37464 L
s
.83 .24 .1 r
.6492 .63239 m
.69333 .62621 L
s
.6492 .63239 m
.64431 .62824 L
s
.305 .071 .031 r
.39768 .38245 m .37704 .38614 L .38625 .37395 L p F P
0 0 0 r
s
.305 .071 .031 r
.38625 .37395 m .40536 .3705 L .39768 .38245 L p F P
0 0 0 r
s
.967 .295 .126 r
.49916 .65021 m .50589 .64927 L .50302 .64144 L p F P
0 0 0 r
s
.83 .24 .1 r
.49924 .64865 m
.49989 .64856 L
s
.967 .295 .126 r
.50302 .64144 m .49957 .64193 L .49916 .65021 L p F P
0 0 0 r
s
.247 .347 .604 r
.64162 .46917 m .64588 .48251 L .64638 .46248 L p F P
0 0 0 r
s
.247 .347 .604 r
.64638 .46248 m .64211 .44888 L .64162 .46917 L p F P
0 0 0 r
s
.24 .35 .67 r
.64063 .44941 m
.64199 .45374 L
s
.83 .24 .1 r
.23742 .65622 m
.2792 .65017 L
s
.23742 .65622 m
.22561 .63404 L
s
.209 .049 .021 r
.52217 .3494 m .50245 .35297 L .50219 .34632 L p F P
0 0 0 r
s
.209 .049 .021 r
.50219 .34632 m .51983 .34312 L .52217 .3494 L p F P
0 0 0 r
s
.967 .295 .126 r
.50589 .64927 m .51262 .64832 L .50648 .64095 L p F P
0 0 0 r
s
.83 .24 .1 r
.50535 .64779 m
.506 .6477 L
s
.51146 .64693 m
.51249 .64679 L
s
.51249 .64679 m
.51488 .648 L
s
.967 .295 .126 r
.50648 .64095 m .50302 .64144 L .50589 .64927 L p F P
0 0 0 r
s
.208 .282 .479 r
.32652 .49234 m .3188 .47922 L .32412 .50019 L p F P
0 0 0 r
s
.208 .282 .479 r
.32412 .50019 m .33156 .51271 L .32652 .49234 L p F P
0 0 0 r
s
.24 .35 .67 r
.32882 .49797 m
.3438 .5234 L
s
.32771 .47279 m
.32882 .49797 L
s
.054 .079 .187 r
.63028 .40235 m .63467 .41646 L .62824 .40046 L p F P
0 0 0 r
s
.054 .079 .187 r
.62824 .40046 m .62399 .38686 L .63028 .40235 L p F P
0 0 0 r
s
.24 .35 .67 r
.61533 .37464 m
.62423 .40276 L
s
.319 .473 .909 r
.55686 .63444 m .55849 .63806 L .58506 .63689 L p F P
0 0 0 r
s
.319 .473 .909 r
.58506 .63689 m .58282 .63161 L .55686 .63444 L p F P
0 0 0 r
s
.191 .261 .437 r
.63774 .43497 m .64211 .44888 L .63897 .43026 L p F P
0 0 0 r
s
.191 .261 .437 r
.63897 .43026 m .63467 .41646 L .63774 .43497 L p F P
0 0 0 r
s
.24 .35 .67 r
.63556 .42469 m
.64063 .44941 L
s
.967 .295 .126 r
.51262 .64832 m .51937 .64737 L .50994 .64046 L p F P
0 0 0 r
s
.967 .295 .126 r
.50994 .64046 m .50648 .64095 L .51262 .64832 L p F P
0 0 0 r
s
.83 .24 .1 r
.24038 .44333 m
.24488 .42011 L
s
.24488 .42011 m
.28676 .41267 L
s
.37485 .6546 m
.41749 .64853 L
s
.37485 .6546 m
.36423 .63786 L
s
.257 .392 .782 r
.4619 .64788 m .45996 .64433 L .47948 .63889 L p F P
0 0 0 r
s
.24 .35 .67 r
.46286 .64739 m
.46291 .64749 L
s
.257 .392 .782 r
.47948 .63889 m .48044 .64072 L .4619 .64788 L p F P
0 0 0 r
s
.33 .484 .915 r
.59786 .6046 m .60068 .61166 L .62021 .5997 L p F P
0 0 0 r
s
.33 .484 .915 r
.62021 .5997 m .61699 .59116 L .59786 .6046 L p F P
0 0 0 r
s
.305 .071 .031 r
.41843 .37873 m .39768 .38245 L .40536 .3705 L p F P
0 0 0 r
s
.305 .071 .031 r
.40536 .3705 m .42457 .36703 L .41843 .37873 L p F P
0 0 0 r
s
.83 .24 .1 r
.82887 .60722 m
.8291 .60502 L
s
.228 .351 .713 r
.43605 .63558 m .43306 .63029 L .45406 .63354 L p F P
0 0 0 r
s
.228 .351 .713 r
.45406 .63354 m .45604 .63716 L .43605 .63558 L p F P
0 0 0 r
s
.967 .295 .126 r
.51937 .64737 m .52613 .64642 L .5134 .63997 L p F P
0 0 0 r
s
.83 .24 .1 r
.51759 .64607 m
.51824 .64598 L
s
.967 .295 .126 r
.5134 .63997 m .50994 .64046 L .51937 .64737 L p F P
0 0 0 r
s
.33 .481 .902 r
.61372 .58249 m .61699 .59116 L .63288 .57559 L p F P
0 0 0 r
s
.33 .481 .902 r
.63288 .57559 m .6293 .56559 L .61372 .58249 L p F P
0 0 0 r
s
.209 .049 .021 r
.54201 .34582 m .52217 .3494 L .51983 .34312 L p F P
0 0 0 r
s
.209 .049 .021 r
.51983 .34312 m .53756 .33991 L .54201 .34582 L p F P
0 0 0 r
s
.257 .356 .631 r
.31817 .45913 m .31025 .44545 L .3109 .46581 L p F P
0 0 0 r
s
.257 .356 .631 r
.3109 .46581 m .3188 .47922 L .31817 .45913 L p F P
0 0 0 r
s
.326 .48 .916 r
.57828 .62091 m .58056 .62629 L .60347 .61863 L p F P
0 0 0 r
s
.326 .48 .916 r
.60347 .61863 m .60068 .61166 L .57828 .62091 L p F P
0 0 0 r
s
.967 .295 .126 r
.52613 .64642 m .5329 .64547 L .51687 .63948 L p F P
0 0 0 r
s
.83 .24 .1 r
.52373 .64521 m
.52438 .64511 L
s
.967 .295 .126 r
.51687 .63948 m .5134 .63997 L .52613 .64642 L p F P
0 0 0 r
s
.11 .17 .391 r
.60215 .33496 m .60642 .34845 L .59517 .34226 L p F P
0 0 0 r
s
.11 .17 .391 r
.59517 .34226 m .59125 .33016 L .60215 .33496 L p F P
0 0 0 r
s
.24 .35 .67 r
.49105 .64384 m
.49577 .65298 L
s
.49577 .65298 m
.52749 .64853 L
s
.58866 .32689 m
.56644 .31292 L
s
.56644 .31292 m
.55609 .28227 L
s
.45 .114 .05 r
.32785 .40921 m .30656 .41298 L .31582 .39711 L p F P
0 0 0 r
s
.24 .35 .67 r
.30969 .40581 m
.3107 .4076 L
s
.30189 .39193 m
.30969 .40581 L
s
.45 .114 .05 r
.31582 .39711 m .33611 .39347 L .32785 .40921 L p F P
0 0 0 r
s
.83 .24 .1 r
.19844 .45065 m
.15699 .45788 L
s
.15419 .48576 m
.15699 .45788 L
s
.288 .406 .735 r
.31444 .42686 m .30656 .41298 L .30214 .43146 L p F P
0 0 0 r
s
.24 .35 .67 r
.31307 .41183 m
.31775 .42014 L
s
.288 .406 .735 r
.30214 .43146 m .31025 .44545 L .31444 .42686 L p F P
0 0 0 r
s
.24 .35 .67 r
.31223 .44602 m
.31775 .42014 L
s
.14 .226 .491 r
.38783 .59759 m .38278 .58902 L .40198 .60282 L p F P
0 0 0 r
s
.14 .226 .491 r
.40198 .60282 m .40608 .60991 L .38783 .59759 L p F P
0 0 0 r
s
.326 .471 .874 r
.62566 .55541 m .6293 .56559 L .64138 .54724 L p F P
0 0 0 r
s
.326 .471 .874 r
.64138 .54724 m .63752 .53592 L .62566 .55541 L p F P
0 0 0 r
s
.967 .295 .126 r
.5329 .64547 m .53968 .64452 L .52033 .63899 L p F P
0 0 0 r
s
.83 .24 .1 r
.52988 .64434 m
.53053 .64425 L
s
.967 .295 .126 r
.52033 .63899 m .51687 .63948 L .5329 .64547 L p F P
0 0 0 r
s
.24 .35 .67 r
.33125 .34227 m
.31566 .31224 L
s
.33125 .34227 m
.31384 .36635 L
s
.83 .24 .1 r
.68715 .31438 m
.6891 .3113 L
s
.6891 .3113 m
.73371 .3032 L
s
.305 .071 .031 r
.43931 .37499 m .41843 .37873 L .42457 .36703 L p F P
0 0 0 r
s
.305 .071 .031 r
.42457 .36703 m .44389 .36354 L .43931 .37499 L p F P
0 0 0 r
s
.188 .295 .615 r
.41013 .6169 m .40608 .60991 L .427 .61956 L p F P
0 0 0 r
s
.188 .295 .615 r
.427 .61956 m .43005 .62495 L .41013 .6169 L p F P
0 0 0 r
s
.105 .162 .375 r
.36683 .57312 m .36085 .56308 L .37766 .58031 L p F P
0 0 0 r
s
.24 .35 .67 r
.36543 .56769 m
.36557 .56791 L
s
.36985 .57512 m
.3713 .57758 L
s
.105 .162 .375 r
.37766 .58031 m .38278 .58902 L .36683 .57312 L p F P
0 0 0 r
s
.83 .24 .1 r
.69333 .62621 m
.73798 .61995 L
s
.69333 .62621 m
.68929 .62191 L
s
.209 .049 .021 r
.56195 .34222 m .54201 .34582 L .53756 .33991 L p F P
0 0 0 r
s
.209 .049 .021 r
.53756 .33991 m .55537 .33667 L .56195 .34222 L p F P
0 0 0 r
s
.83 .24 .1 r
.55578 .33702 m
.5565 .33647 L
s
.967 .295 .126 r
.53968 .64452 m .54647 .64356 L .52381 .63849 L p F P
0 0 0 r
s
.83 .24 .1 r
.53603 .64347 m
.53669 .64338 L
s
.967 .295 .126 r
.52381 .63849 m .52033 .63899 L .53968 .64452 L p F P
0 0 0 r
s
.257 .392 .782 r
.45996 .64433 m .45801 .64076 L .47852 .63705 L p F P
0 0 0 r
s
.24 .35 .67 r
.46097 .64393 m
.46103 .64403 L
s
.257 .392 .782 r
.47852 .63705 m .47948 .63889 L .45996 .64433 L p F P
0 0 0 r
s
.83 .24 .1 r
.46064 .64239 m
.46539 .64794 L
s
.24 .35 .67 r
.52962 .27323 m
.50042 .26924 L
s
.50042 .26924 m
.48857 .23754 L
s
.967 .295 .126 r
.54647 .64356 m .55328 .64261 L .52728 .638 L p F P
0 0 0 r
s
.83 .24 .1 r
.5422 .64261 m
.54286 .64251 L
s
.967 .295 .126 r
.52728 .638 m .52381 .63849 L .54647 .64356 L p F P
0 0 0 r
s
.83 .24 .1 r
.2792 .65017 m
.32147 .64405 L
s
.2792 .65017 m
.26787 .62778 L
s
.319 .473 .909 r
.55522 .6308 m .55686 .63444 L .58282 .63161 L p F P
0 0 0 r
s
.319 .473 .909 r
.58282 .63161 m .58056 .62629 L .55522 .6308 L p F P
0 0 0 r
s
.45 .114 .05 r
.34926 .40541 m .32785 .40921 L .33611 .39347 L p F P
0 0 0 r
s
.45 .114 .05 r
.33611 .39347 m .35652 .38982 L .34926 .40541 L p F P
0 0 0 r
s
.313 .45 .822 r
.63357 .52438 m .63752 .53592 L .64569 .51578 L p F P
0 0 0 r
s
.313 .45 .822 r
.64569 .51578 m .6416 .50333 L .63357 .52438 L p F P
0 0 0 r
s
.071 .103 .253 r
.34782 .54445 m .34104 .53307 L .35477 .55285 L p F P
0 0 0 r
s
.071 .103 .253 r
.35477 .55285 m .36085 .56308 L .34782 .54445 L p F P
0 0 0 r
s
.24 .35 .67 r
.35147 .54685 m
.36543 .56769 L
s
.967 .295 .126 r
.55328 .64261 m .5601 .64165 L .53076 .63751 L p F P
0 0 0 r
s
.83 .24 .1 r
.54838 .64174 m
.54904 .64164 L
s
.55457 .64087 m
.55591 .64068 L
s
.55591 .64068 m
.55676 .64118 L
s
.967 .295 .126 r
.53076 .63751 m .52728 .638 L .55328 .64261 L p F P
0 0 0 r
s
.83 .24 .1 r
.56351 .63961 m
.59985 .63449 L
s
.55591 .64068 m
.55944 .64018 L
s
.305 .071 .031 r
.4603 .37123 m .43931 .37499 L .44389 .36354 L p F P
0 0 0 r
s
.305 .071 .031 r
.44389 .36354 m .4633 .36003 L .4603 .37123 L p F P
0 0 0 r
s
.228 .351 .713 r
.43306 .63029 m .43005 .62495 L .45207 .62989 L p F P
0 0 0 r
s
.228 .351 .713 r
.45207 .62989 m .45406 .63354 L .43306 .63029 L p F P
0 0 0 r
s
.83 .24 .1 r
.28282 .43592 m
.28676 .41267 L
s
.28676 .41267 m
.30905 .40871 L
s
.18384 .64023 m
.22561 .63404 L
s
.18384 .64023 m
.17295 .61323 L
s
.209 .049 .021 r
.58199 .3386 m .56195 .34222 L .55537 .33667 L p F P
0 0 0 r
s
.209 .049 .021 r
.55537 .33667 m .57327 .33343 L .58199 .3386 L p F P
0 0 0 r
s
.24 .35 .67 r
.52303 .63931 m
.52749 .64853 L
s
.52749 .64853 m
.5439 .64314 L
s
.5439 .64314 m
.5472 .64206 L
s
.83 .24 .1 r
.41749 .64853 m
.46064 .64239 L
s
.41749 .64853 m
.40751 .63159 L
s
.31 .461 .893 r
.52988 .63567 m .53076 .63751 L .5601 .64165 L p F P
0 0 0 r
s
.31 .461 .893 r
.5601 .64165 m .55849 .63806 L .52988 .63567 L p F P
0 0 0 r
s
.077 .112 .279 r
.61521 .35879 m .61965 .37298 L .61061 .36166 L p F P
0 0 0 r
s
.077 .112 .279 r
.61061 .36166 m .60642 .34845 L .61521 .35879 L p F P
0 0 0 r
s
.257 .392 .782 r
.45801 .64076 m .45604 .63716 L .47755 .63521 L p F P
0 0 0 r
s
.24 .35 .67 r
.45908 .64045 m
.45913 .64055 L
s
.257 .392 .782 r
.47755 .63521 m .47852 .63705 L .45801 .64076 L p F P
0 0 0 r
s
.288 .411 .737 r
.63742 .49061 m .6416 .50333 L .64588 .48251 L p F P
0 0 0 r
s
.288 .411 .737 r
.64588 .48251 m .64162 .46917 L .63742 .49061 L p F P
0 0 0 r
s
.162 .212 .366 r
.33156 .51271 m .32412 .50019 L .33411 .52147 L p F P
0 0 0 r
s
.162 .212 .366 r
.33411 .52147 m .34104 .53307 L .33156 .51271 L p F P
0 0 0 r
s
.45 .114 .05 r
.3708 .4016 m .34926 .40541 L .35652 .38982 L p F P
0 0 0 r
s
.45 .114 .05 r
.35652 .38982 m .37704 .38614 L .3708 .4016 L p F P
0 0 0 r
s
.326 .48 .916 r
.57598 .61547 m .57828 .62091 L .60068 .61166 L p F P
0 0 0 r
s
.326 .48 .916 r
.60068 .61166 m .59786 .6046 L .57598 .61547 L p F P
0 0 0 r
s
.83 .24 .1 r
.24038 .44333 m
.19844 .45065 L
s
.19608 .47861 m
.19844 .45065 L
s
.33 .484 .915 r
.59501 .59744 m .59786 .6046 L .61699 .59116 L p F P
0 0 0 r
s
.33 .484 .915 r
.61699 .59116 m .61372 .58249 L .59501 .59744 L p F P
0 0 0 r
s
.209 .049 .021 r
.60215 .33496 m .58199 .3386 L .57327 .33343 L p F P
0 0 0 r
s
.24 .35 .67 r
.59188 .33682 m
.59821 .35629 L
s
.209 .049 .021 r
.57327 .33343 m .59125 .33016 L .60215 .33496 L p F P
0 0 0 r
s
.24 .35 .67 r
.58985 .33055 m
.5899 .3307 L
s
.83 .24 .1 r
.59382 .3313 m
.59773 .33059 L
s
.59773 .33059 m
.60142 .32722 L
s
.24 .35 .67 r
.58866 .32689 m
.58985 .33055 L
s
.305 .071 .031 r
.48141 .36745 m .4603 .37123 L .4633 .36003 L p F P
0 0 0 r
s
.83 .24 .1 r
.46455 .36054 m
.46492 .35974 L
s
.305 .071 .031 r
.4633 .36003 m .48282 .35651 L .48141 .36745 L p F P
0 0 0 r
s
.83 .24 .1 r
.73266 .30613 m
.73371 .3032 L
s
.73371 .3032 m
.77885 .295 L
s
.73798 .61995 m
.78316 .61362 L
s
.73798 .61995 m
.73481 .6155 L
s
.247 .347 .604 r
.63726 .45554 m .64162 .46917 L .64211 .44888 L p F P
0 0 0 r
s
.247 .347 .604 r
.64211 .44888 m .63774 .43497 L .63726 .45554 L p F P
0 0 0 r
s
.319 .473 .909 r
.55358 .62713 m .55522 .6308 L .58056 .62629 L p F P
0 0 0 r
s
.319 .473 .909 r
.58056 .62629 m .57828 .62091 L .55358 .62713 L p F P
0 0 0 r
s
.188 .295 .615 r
.40608 .60991 m .40198 .60282 L .42393 .61411 L p F P
0 0 0 r
s
.188 .295 .615 r
.42393 .61411 m .427 .61956 L .40608 .60991 L p F P
0 0 0 r
s
.31 .461 .893 r
.529 .63382 m .52988 .63567 L .55849 .63806 L p F P
0 0 0 r
s
.31 .461 .893 r
.55849 .63806 m .55686 .63444 L .529 .63382 L p F P
0 0 0 r
s
.83 .24 .1 r
.55243 .63563 m
.55322 .63676 L
s
.33 .481 .902 r
.6104 .57368 m .61372 .58249 L .6293 .56559 L p F P
0 0 0 r
s
.33 .481 .902 r
.6293 .56559 m .62566 .55541 L .6104 .57368 L p F P
0 0 0 r
s
.054 .079 .187 r
.62578 .38792 m .63028 .40235 L .62399 .38686 L p F P
0 0 0 r
s
.054 .079 .187 r
.62399 .38686 m .61965 .37298 L .62578 .38792 L p F P
0 0 0 r
s
.24 .35 .67 r
.61533 .37464 m
.62679 .39668 L
s
.14 .226 .491 r
.38278 .58902 m .37766 .58031 L .39782 .59565 L p F P
0 0 0 r
s
.14 .226 .491 r
.39782 .59565 m .40198 .60282 L .38278 .58902 L p F P
0 0 0 r
s
.208 .282 .479 r
.3188 .47922 m .3109 .46581 L .31652 .48741 L p F P
0 0 0 r
s
.24 .35 .67 r
.31223 .44602 m
.32771 .47279 L
s
.208 .282 .479 r
.31652 .48741 m .32412 .50019 L .3188 .47922 L p F P
0 0 0 r
s
.83 .24 .1 r
.32147 .64405 m
.36423 .63786 L
s
.32147 .64405 m
.31063 .62144 L
s
.45 .114 .05 r
.39247 .39776 m .3708 .4016 L .37704 .38614 L p F P
0 0 0 r
s
.45 .114 .05 r
.37704 .38614 m .39768 .38245 L .39247 .39776 L p F P
0 0 0 r
s
.191 .261 .437 r
.63328 .42074 m .63774 .43497 L .63467 .41646 L p F P
0 0 0 r
s
.191 .261 .437 r
.63467 .41646 m .63028 .40235 L .63328 .42074 L p F P
0 0 0 r
s
.24 .35 .67 r
.62679 .39668 m
.63214 .41377 L
s
.257 .392 .782 r
.45604 .63716 m .45406 .63354 L .47658 .63336 L p F P
0 0 0 r
s
.24 .35 .67 r
.45717 .63695 m
.45722 .63705 L
s
.257 .392 .782 r
.47658 .63336 m .47755 .63521 L .45604 .63716 L p F P
0 0 0 r
s
.998 .299 .128 r
.5 .62969 m .48236 .64436 L .48579 .64388 L closepath p F P
0 0 0 r
s
.28 .422 .832 r
.5 .62969 m .48236 .64436 L .4814 .64255 L closepath p F P
0 0 0 r
s
.228 .351 .713 r
.43005 .62495 m .427 .61956 L .45006 .62621 L p F P
0 0 0 r
s
.228 .351 .713 r
.45006 .62621 m .45207 .62989 L .43005 .62495 L p F P
0 0 0 r
s
.24 .35 .67 r
.45112 .62816 m
.45257 .62852 L
s
.305 .071 .031 r
.50265 .36364 m .48141 .36745 L .48282 .35651 L p F P
0 0 0 r
s
.305 .071 .031 r
.48282 .35651 m .50245 .35297 L .50265 .36364 L p F P
0 0 0 r
s
.998 .299 .128 r
.5 .62969 m .48579 .64388 L .48923 .64339 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.31384 .36635 m
.29771 .3366 L
s
.31384 .36635 m
.30189 .39193 L
s
.83 .24 .1 r
.5972 .33279 m
.59773 .33059 L
s
.59773 .33059 m
.64217 .32253 L
s
.59985 .63449 m
.64431 .62824 L
s
.59319 .62353 m
.59985 .63449 L
s
.998 .299 .128 r
.5 .62969 m .48923 .64339 L .49268 .6429 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.22561 .63404 m
.26787 .62778 L
s
.22561 .63404 m
.21506 .60682 L
s
.46064 .64239 m
.47809 .6399 L
s
.105 .162 .375 r
.36085 .56308 m .35477 .55285 L .37245 .57147 L p F P
0 0 0 r
s
.24 .35 .67 r
.36409 .56542 m
.36543 .56769 L
s
.105 .162 .375 r
.37245 .57147 m .37766 .58031 L .36085 .56308 L p F P
0 0 0 r
s
.998 .299 .128 r
.5 .62969 m .49268 .6429 L .49612 .64242 L closepath p F P
0 0 0 r
s
.257 .356 .631 r
.31025 .44545 m .30214 .43146 L .30283 .4521 L p F P
0 0 0 r
s
.257 .356 .631 r
.30283 .4521 m .3109 .46581 L .31025 .44545 L p F P
0 0 0 r
s
.28 .422 .832 r
.5 .62969 m .4814 .64255 L .48044 .64072 L closepath p F P
0 0 0 r
s
.326 .471 .874 r
.62195 .54505 m .62566 .55541 L .63752 .53592 L p F P
0 0 0 r
s
.24 .35 .67 r
.62434 .55483 m
.62488 .55635 L
s
.62434 .55483 m
.62503 .55363 L
s
.326 .471 .874 r
.63752 .53592 m .63357 .52438 L .62195 .54505 L p F P
0 0 0 r
s
.998 .299 .128 r
.5 .62969 m .49612 .64242 L .49957 .64193 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.15445 .51698 m
.15419 .48576 L
s
.15419 .48576 m
.19608 .47861 L
s
.24 .35 .67 r
.55609 .28227 m
.52962 .27323 L
s
.52962 .27323 m
.51832 .24133 L
s
.998 .299 .128 r
.5 .62969 m .49957 .64193 L .50302 .64144 L closepath p F P
0 0 0 r
s
.31 .461 .893 r
.52812 .63196 m .529 .63382 L .55686 .63444 L p F P
0 0 0 r
s
.31 .461 .893 r
.55686 .63444 m .55522 .6308 L .52812 .63196 L p F P
0 0 0 r
s
.24 .35 .67 r
.42536 .24514 m
.39421 .25608 L
s
.39421 .25608 m
.37986 .22379 L
s
.39421 .25608 m
.36486 .27128 L
s
.564 .15 .065 r
.3239 .42766 m .30214 .43146 L .30656 .41298 L p F P
0 0 0 r
s
.564 .15 .065 r
.30656 .41298 m .32785 .40921 L .3239 .42766 L p F P
0 0 0 r
s
.45 .114 .05 r
.41427 .3939 m .39247 .39776 L .39768 .38245 L p F P
0 0 0 r
s
.45 .114 .05 r
.39768 .38245 m .41843 .37873 L .41427 .3939 L p F P
0 0 0 r
s
.998 .299 .128 r
.5 .62969 m .50302 .64144 L .50648 .64095 L closepath p F P
0 0 0 r
s
.305 .071 .031 r
.524 .35982 m .50265 .36364 L .50245 .35297 L p F P
0 0 0 r
s
.305 .071 .031 r
.50245 .35297 m .52217 .3494 L .524 .35982 L p F P
0 0 0 r
s
.998 .299 .128 r
.5 .62969 m .50648 .64095 L .50994 .64046 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.28282 .43592 m
.24038 .44333 L
s
.23846 .47138 m
.24038 .44333 L
s
.24 .35 .67 r
.58866 .32689 m
.5943 .33285 L
s
.58866 .32689 m
.57868 .29617 L
s
.257 .392 .782 r
.45406 .63354 m .45207 .62989 L .4756 .6315 L p F P
0 0 0 r
s
.24 .35 .67 r
.45257 .62852 m
.45336 .62998 L
s
.45524 .63342 m
.4553 .63353 L
s
.257 .392 .782 r
.4756 .6315 m .47658 .63336 L .45406 .63354 L p F P
0 0 0 r
s
.28 .422 .832 r
.5 .62969 m .48044 .64072 L .47948 .63889 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.36486 .27128 m
.34983 .2393 L
s
.36486 .27128 m
.33834 .29022 L
s
.998 .299 .128 r
.5 .62969 m .50994 .64046 L .5134 .63997 L closepath p F P
0 0 0 r
s
.326 .48 .916 r
.57365 .60998 m .57598 .61547 L .59786 .6046 L p F P
0 0 0 r
s
.326 .48 .916 r
.59786 .6046 m .59501 .59744 L .57365 .60998 L p F P
0 0 0 r
s
.319 .473 .909 r
.55192 .62344 m .55358 .62713 L .57828 .62091 L p F P
0 0 0 r
s
.319 .473 .909 r
.57828 .62091 m .57598 .61547 L .55192 .62344 L p F P
0 0 0 r
s
.83 .24 .1 r
.77885 .295 m
.77872 .29779 L
s
.24 .35 .67 r
.4572 .23886 m
.42536 .24514 L
s
.42536 .24514 m
.41169 .21254 L
s
.998 .299 .128 r
.5 .62969 m .5134 .63997 L .51687 .63948 L closepath p F P
0 0 0 r
s
.071 .103 .253 r
.34104 .53307 m .33411 .52147 L .34858 .54244 L p F P
0 0 0 r
s
.24 .35 .67 r
.32882 .49797 m
.33645 .5216 L
s
.071 .103 .253 r
.34858 .54244 m .35477 .55285 L .34104 .53307 L p F P
0 0 0 r
s
.24 .35 .67 r
.33645 .5216 m
.35147 .54685 L
s
.83 .24 .1 r
.78316 .61362 m
.82887 .60722 L
s
.78316 .61362 m
.78089 .60902 L
s
.998 .299 .128 r
.5 .62969 m .51687 .63948 L .52033 .63899 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.17295 .61323 m
.21506 .60682 L
s
.17295 .61323 m
.16409 .58255 L
s
.313 .45 .822 r
.62955 .5126 m .63357 .52438 L .6416 .50333 L p F P
0 0 0 r
s
.313 .45 .822 r
.6416 .50333 m .63742 .49061 L .62955 .5126 L p F P
0 0 0 r
s
.998 .299 .128 r
.5 .62969 m .52033 .63899 L .52381 .63849 L closepath p F P
0 0 0 r
s
.228 .351 .713 r
.427 .61956 m .42393 .61411 L .44804 .62252 L p F P
0 0 0 r
s
.228 .351 .713 r
.44804 .62252 m .45006 .62621 L .427 .61956 L p F P
0 0 0 r
s
.28 .422 .832 r
.5 .62969 m .47948 .63889 L .47852 .63705 L closepath p F P
0 0 0 r
s
.33 .484 .915 r
.59211 .59019 m .59501 .59744 L .61372 .58249 L p F P
0 0 0 r
s
.33 .484 .915 r
.61372 .58249 m .6104 .57368 L .59211 .59019 L p F P
0 0 0 r
s
.45 .114 .05 r
.4362 .39001 m .41427 .3939 L .41843 .37873 L p F P
0 0 0 r
s
.45 .114 .05 r
.41843 .37873 m .43931 .37499 L .4362 .39001 L p F P
0 0 0 r
s
.188 .295 .615 r
.40198 .60282 m .39782 .59565 L .42082 .60861 L p F P
0 0 0 r
s
.188 .295 .615 r
.42082 .60861 m .42393 .61411 L .40198 .60282 L p F P
0 0 0 r
s
.564 .15 .065 r
.3458 .42383 m .3239 .42766 L .32785 .40921 L p F P
0 0 0 r
s
.83 .24 .1 r
.32577 .42843 m
.32593 .4273 L
s
.32846 .40971 m
.32855 .40908 L
s
.564 .15 .065 r
.32785 .40921 m .34926 .40541 L .3458 .42383 L p F P
0 0 0 r
s
.998 .299 .128 r
.5 .62969 m .52381 .63849 L .52728 .638 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.36423 .63786 m
.40751 .63159 L
s
.36423 .63786 m
.3539 .61503 L
s
.305 .071 .031 r
.54548 .35597 m .524 .35982 L .52217 .3494 L p F P
0 0 0 r
s
.305 .071 .031 r
.52217 .3494 m .54201 .34582 L .54548 .35597 L p F P
0 0 0 r
s
.31 .461 .893 r
.52723 .6301 m .52812 .63196 L .55522 .6308 L p F P
0 0 0 r
s
.31 .461 .893 r
.55522 .6308 m .55358 .62713 L .52723 .6301 L p F P
0 0 0 r
s
.998 .299 .128 r
.5 .62969 m .52728 .638 L .53076 .63751 L closepath p F P
0 0 0 r
s
.077 .112 .279 r
.61068 .34429 m .61521 .35879 L .60642 .34845 L p F P
0 0 0 r
s
.077 .112 .279 r
.60642 .34845 m .60215 .33496 L .61068 .34429 L p F P
0 0 0 r
s
.83 .24 .1 r
.64054 .33276 m
.64217 .32253 L
s
.64217 .32253 m
.68715 .31438 L
s
.297 .444 .868 r
.53076 .63751 m .52988 .63567 L .5 .62969 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.64431 .62824 m
.68929 .62191 L
s
.64431 .62824 m
.63844 .61709 L
s
.257 .392 .782 r
.45207 .62989 m .45006 .62621 L .47462 .62964 L p F P
0 0 0 r
s
.257 .392 .782 r
.47462 .62964 m .4756 .6315 L .45207 .62989 L p F P
0 0 0 r
s
.28 .422 .832 r
.5 .62969 m .47852 .63705 L .47755 .63521 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.26787 .62778 m
.31063 .62144 L
s
.26787 .62778 m
.25766 .60033 L
s
.5307 .63242 m
.53486 .63183 L
s
.14 .226 .491 r
.37766 .58031 m .37245 .57147 L .39361 .58837 L p F P
0 0 0 r
s
.14 .226 .491 r
.39361 .58837 m .39782 .59565 L .37766 .58031 L p F P
0 0 0 r
s
.162 .212 .366 r
.32412 .50019 m .31652 .48741 L .32705 .50963 L p F P
0 0 0 r
s
.162 .212 .366 r
.32705 .50963 m .33411 .52147 L .32412 .50019 L p F P
0 0 0 r
s
.24 .35 .67 r
.33834 .29022 m
.32265 .25853 L
s
.33834 .29022 m
.31566 .31224 L
s
.288 .411 .737 r
.63315 .47762 m .63742 .49061 L .64162 .46917 L p F P
0 0 0 r
s
.288 .411 .737 r
.64162 .46917 m .63726 .45554 L .63315 .47762 L p F P
0 0 0 r
s
.33 .481 .902 r
.60702 .56474 m .6104 .57368 L .62566 .55541 L p F P
0 0 0 r
s
.33 .481 .902 r
.62566 .55541 m .62195 .54505 L .60702 .56474 L p F P
0 0 0 r
s
.83 .24 .1 r
.19663 .50996 m
.19608 .47861 L
s
.19608 .47861 m
.23846 .47138 L
s
.45 .114 .05 r
.45826 .38611 m .4362 .39001 L .43931 .37499 L p F P
0 0 0 r
s
.45 .114 .05 r
.43931 .37499 m .4603 .37123 L .45826 .38611 L p F P
0 0 0 r
s
.297 .444 .868 r
.52988 .63567 m .529 .63382 L .5 .62969 L closepath p F P
0 0 0 r
s
.305 .071 .031 r
.56709 .3521 m .54548 .35597 L .54201 .34582 L p F P
0 0 0 r
s
.305 .071 .031 r
.54201 .34582 m .56195 .34222 L .56709 .3521 L p F P
0 0 0 r
s
.564 .15 .065 r
.36783 .41999 m .3458 .42383 L .34926 .40541 L p F P
0 0 0 r
s
.564 .15 .065 r
.34926 .40541 m .3708 .4016 L .36783 .41999 L p F P
0 0 0 r
s
.24 .35 .67 r
.48857 .23754 m
.4572 .23886 L
s
.4572 .23886 m
.44418 .20598 L
s
.28 .422 .832 r
.5 .62969 m .47755 .63521 L .47658 .63336 L closepath p F P
0 0 0 r
s
.319 .473 .909 r
.55024 .61972 m .55192 .62344 L .57598 .61547 L p F P
0 0 0 r
s
.319 .473 .909 r
.57598 .61547 m .57365 .60998 L .55024 .61972 L p F P
0 0 0 r
s
.83 .24 .1 r
.15781 .54985 m
.15445 .51698 L
s
.15445 .51698 m
.19663 .50996 L
s
.28282 .43592 m
.30218 .43254 L
s
.28136 .46406 m
.28282 .43592 L
s
.31 .461 .893 r
.52635 .62823 m .52723 .6301 L .55358 .62713 L p F P
0 0 0 r
s
.83 .24 .1 r
.53486 .63183 m
.54848 .62989 L
s
.54848 .62989 m
.55243 .63563 L
s
.31 .461 .893 r
.55358 .62713 m .55192 .62344 L .52635 .62823 L p F P
0 0 0 r
s
.054 .079 .187 r
.62118 .37317 m .62578 .38792 L .61965 .37298 L p F P
0 0 0 r
s
.054 .079 .187 r
.61965 .37298 m .61521 .35879 L .62118 .37317 L p F P
0 0 0 r
s
.247 .347 .604 r
.63281 .44159 m .63726 .45554 L .63774 .43497 L p F P
0 0 0 r
s
.247 .347 .604 r
.63774 .43497 m .63328 .42074 L .63281 .44159 L p F P
0 0 0 r
s
.24 .35 .67 r
.63186 .42159 m
.63316 .42574 L
s
.297 .444 .868 r
.529 .63382 m .52812 .63196 L .5 .62969 L closepath p F P
0 0 0 r
s
.257 .392 .782 r
.45006 .62621 m .44804 .62252 L .47364 .62777 L p F P
0 0 0 r
s
.24 .35 .67 r
.45136 .6263 m
.45142 .6264 L
s
.257 .392 .782 r
.47364 .62777 m .47462 .62964 L .45006 .62621 L p F P
0 0 0 r
s
.228 .351 .713 r
.42393 .61411 m .42082 .60861 L .446 .61879 L p F P
0 0 0 r
s
.228 .351 .713 r
.446 .61879 m .44804 .62252 L .42393 .61411 L p F P
0 0 0 r
s
.83 .24 .1 r
.82752 .60246 m
.82887 .60722 L
s
.326 .48 .916 r
.5713 .60443 m .57365 .60998 L .59501 .59744 L p F P
0 0 0 r
s
.326 .48 .916 r
.59501 .59744 m .59211 .59019 L .5713 .60443 L p F P
0 0 0 r
s
.105 .162 .375 r
.35477 .55285 m .34858 .54244 L .36716 .56249 L p F P
0 0 0 r
s
.24 .35 .67 r
.35053 .54257 m
.3538 .54808 L
s
.35823 .55554 m
.35974 .55808 L
s
.105 .162 .375 r
.36716 .56249 m .37245 .57147 L .35477 .55285 L p F P
0 0 0 r
s
.28 .422 .832 r
.5 .62969 m .47658 .63336 L .4756 .6315 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.16409 .58255 m
.20639 .57592 L
s
.16409 .58255 m
.15781 .54985 L
s
.208 .282 .479 r
.3109 .46581 m .30283 .4521 L .30876 .47434 L p F P
0 0 0 r
s
.208 .282 .479 r
.30876 .47434 m .31652 .48741 L .3109 .46581 L p F P
0 0 0 r
s
.24 .35 .67 r
.31316 .47141 m
.32882 .49797 L
s
.83 .24 .1 r
.21506 .60682 m
.25766 .60033 L
s
.21506 .60682 m
.20639 .57592 L
s
.191 .261 .437 r
.62871 .40619 m .63328 .42074 L .63028 .40235 L p F P
0 0 0 r
s
.24 .35 .67 r
.62875 .40632 m
.63186 .42159 L
s
.191 .261 .437 r
.63028 .40235 m .62578 .38792 L .62871 .40619 L p F P
0 0 0 r
s
.24 .35 .67 r
.62679 .39668 m
.62866 .40586 L
s
.305 .071 .031 r
.58882 .34821 m .56709 .3521 L .56195 .34222 L p F P
0 0 0 r
s
.305 .071 .031 r
.56195 .34222 m .58199 .3386 L .58882 .34821 L p F P
0 0 0 r
s
.45 .114 .05 r
.48046 .38217 m .45826 .38611 L .4603 .37123 L p F P
0 0 0 r
s
.83 .24 .1 r
.46125 .37175 m
.46139 .37103 L
s
.45 .114 .05 r
.4603 .37123 m .48141 .36745 L .48046 .38217 L p F P
0 0 0 r
s
.24 .35 .67 r
.30189 .39193 m
.28532 .36243 L
s
.30189 .39193 m
.29606 .41804 L
s
.564 .15 .065 r
.38999 .41611 m .36783 .41999 L .3708 .4016 L p F P
0 0 0 r
s
.83 .24 .1 r
.36923 .42084 m
.36937 .41972 L
s
.37145 .40209 m
.37152 .40147 L
s
.564 .15 .065 r
.3708 .4016 m .39247 .39776 L .38999 .41611 L p F P
0 0 0 r
s
.326 .471 .874 r
.61818 .53449 m .62195 .54505 L .63357 .52438 L p F P
0 0 0 r
s
.326 .471 .874 r
.63357 .52438 m .62955 .5126 L .61818 .53449 L p F P
0 0 0 r
s
.297 .444 .868 r
.52812 .63196 m .52723 .6301 L .5 .62969 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.15781 .54985 m
.20012 .54302 L
s
.188 .295 .615 r
.39782 .59565 m .39361 .58837 L .41768 .60304 L p F P
0 0 0 r
s
.188 .295 .615 r
.41768 .60304 m .42082 .60861 L .39782 .59565 L p F P
0 0 0 r
s
.83 .24 .1 r
.3977 .60854 m
.40751 .63159 L
s
.28 .422 .832 r
.5 .62969 m .4756 .6315 L .47462 .62964 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.47454 .62948 m
.47822 .62965 L
s
.83 .24 .1 r
.68637 .32451 m
.68715 .31438 L
s
.68715 .31438 m
.73266 .30613 L
s
.68929 .62191 m
.73481 .6155 L
s
.68929 .62191 m
.68424 .61057 L
s
.648 .176 .076 r
.32452 .44837 m .30283 .4521 L .30214 .43146 L p F P
0 0 0 r
s
.24 .35 .67 r
.31239 .45046 m
.31316 .47141 L
s
.648 .176 .076 r
.30214 .43146 m .3239 .42766 L .32452 .44837 L p F P
0 0 0 r
s
.83 .24 .1 r
.32394 .42875 m
.32577 .42843 L
s
.24 .35 .67 r
.29606 .41804 m
.30366 .43119 L
s
.31 .461 .893 r
.52545 .62636 m .52635 .62823 L .55192 .62344 L p F P
0 0 0 r
s
.31 .461 .893 r
.55192 .62344 m .55024 .61972 L .52545 .62636 L p F P
0 0 0 r
s
.83 .24 .1 r
.31063 .62144 m
.3539 .61503 L
s
.31063 .62144 m
.30078 .59377 L
s
.24 .35 .67 r
.57868 .29617 m
.55609 .28227 L
s
.55609 .28227 m
.54526 .25022 L
s
.33 .484 .915 r
.58918 .58285 m .59211 .59019 L .6104 .57368 L p F P
0 0 0 r
s
.24 .35 .67 r
.6062 .57549 m
.60961 .57161 L
s
.33 .484 .915 r
.6104 .57368 m .60702 .56474 L .58918 .58285 L p F P
0 0 0 r
s
.297 .444 .868 r
.52723 .6301 m .52635 .62823 L .5 .62969 L closepath p F P
0 0 0 r
s
.305 .071 .031 r
.61068 .34429 m .58882 .34821 L .58199 .3386 L p F P
0 0 0 r
s
.24 .35 .67 r
.60603 .34526 m
.61533 .37464 L
s
.60593 .34515 m
.60603 .34526 L
s
.305 .071 .031 r
.58199 .3386 m .60215 .33496 L .61068 .34429 L p F P
0 0 0 r
s
.257 .392 .782 r
.44804 .62252 m .446 .61879 L .47266 .62589 L p F P
0 0 0 r
s
.24 .35 .67 r
.4494 .6227 m
.44945 .62281 L
s
.257 .392 .782 r
.47266 .62589 m .47364 .62777 L .44804 .62252 L p F P
0 0 0 r
s
.28 .422 .832 r
.5 .62969 m .47462 .62964 L .47364 .62777 L closepath p F P
0 0 0 r
s
.45 .114 .05 r
.50278 .37822 m .48046 .38217 L .48141 .36745 L p F P
0 0 0 r
s
.45 .114 .05 r
.48141 .36745 m .50265 .36364 L .50278 .37822 L p F P
0 0 0 r
s
.24 .35 .67 r
.31566 .31224 m
.29935 .28084 L
s
.31566 .31224 m
.29771 .3366 L
s
.319 .473 .909 r
.54856 .61598 m .55024 .61972 L .57365 .60998 L p F P
0 0 0 r
s
.319 .473 .909 r
.57365 .60998 m .5713 .60443 L .54856 .61598 L p F P
0 0 0 r
s
.24 .35 .67 r
.54804 .61474 m
.54859 .61596 L
s
.83 .24 .1 r
.23932 .50287 m
.23846 .47138 L
s
.23846 .47138 m
.28136 .46406 L
s
.071 .103 .253 r
.33411 .52147 m .32705 .50963 L .34227 .53184 L p F P
0 0 0 r
s
.071 .103 .253 r
.34227 .53184 m .34858 .54244 L .33411 .52147 L p F P
0 0 0 r
s
.24 .35 .67 r
.33645 .5216 m
.35053 .54257 L
s
.564 .15 .065 r
.41228 .41222 m .38999 .41611 L .39247 .39776 L p F P
0 0 0 r
s
.564 .15 .065 r
.39247 .39776 m .41427 .3939 L .41228 .41222 L p F P
0 0 0 r
s
.83 .24 .1 r
.20012 .54302 m
.19663 .50996 L
s
.19663 .50996 m
.23932 .50287 L
s
.14 .226 .491 r
.37245 .57147 m .36716 .56249 L .38935 .581 L p F P
0 0 0 r
s
.14 .226 .491 r
.38935 .581 m .39361 .58837 L .37245 .57147 L p F P
0 0 0 r
s
.297 .444 .868 r
.52635 .62823 m .52545 .62636 L .5 .62969 L closepath p F P
0 0 0 r
s
.228 .351 .713 r
.42082 .60861 m .41768 .60304 L .44395 .61504 L p F P
0 0 0 r
s
.228 .351 .713 r
.44395 .61504 m .446 .61879 L .42082 .60861 L p F P
0 0 0 r
s
.24 .35 .67 r
.51832 .24133 m
.48857 .23754 L
s
.48857 .23754 m
.47619 .2044 L
s
.313 .45 .822 r
.62545 .50058 m .62955 .5126 L .63742 .49061 L p F P
0 0 0 r
s
.313 .45 .822 r
.63742 .49061 m .63315 .47762 L .62545 .50058 L p F P
0 0 0 r
s
.28 .422 .832 r
.5 .62969 m .47364 .62777 L .47266 .62589 L closepath p F P
0 0 0 r
s
.648 .176 .076 r
.34634 .44462 m .32452 .44837 L .3239 .42766 L p F P
0 0 0 r
s
.83 .24 .1 r
.32575 .42905 m
.32577 .42843 L
s
.648 .176 .076 r
.3239 .42766 m .3458 .42383 L .34634 .44462 L p F P
0 0 0 r
s
.992 .294 .126 r
.48276 .61627 m .48629 .61576 L .5 .62969 L closepath p F P
0 0 0 r
s
.24 .35 .67 r
.4925 .62865 m
.4977 .6279 L
s
.992 .294 .126 r
.47924 .61678 m .48276 .61627 L .5 .62969 L closepath p F P
0 0 0 r
s
.992 .294 .126 r
.47571 .61729 m .47924 .61678 L .5 .62969 L closepath p F P
0 0 0 r
s
.992 .294 .126 r
.4722 .61781 m .47571 .61729 L .5 .62969 L closepath p F P
0 0 0 r
s
.992 .294 .126 r
.46868 .61832 m .4722 .61781 L .5 .62969 L closepath p F P
0 0 0 r
s
.28 .422 .832 r
.5 .62969 m .47266 .62589 L .47167 .62401 L closepath p F P
0 0 0 r
s
.28 .422 .832 r
.5 .62969 m .47167 .62401 L .47068 .62212 L closepath p F P
0 0 0 r
s
.28 .422 .832 r
.5 .62969 m .47068 .62212 L .46968 .62022 L closepath p F P
0 0 0 r
s
.28 .422 .832 r
.5 .62969 m .46968 .62022 L .46868 .61832 L closepath p F P
0 0 0 r
s
.297 .444 .868 r
.52185 .61879 m .52095 .61688 L .5 .62969 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.50085 .62927 m
.501 .62956 L
s
.24 .35 .67 r
.49817 .62783 m
.50453 .62692 L
s
.297 .444 .868 r
.52276 .62069 m .52185 .61879 L .5 .62969 L closepath p F P
0 0 0 r
s
.297 .444 .868 r
.52366 .62259 m .52276 .62069 L .5 .62969 L closepath p F P
0 0 0 r
s
.297 .444 .868 r
.52456 .62448 m .52366 .62259 L .5 .62969 L closepath p F P
0 0 0 r
s
.297 .444 .868 r
.52545 .62636 m .52456 .62448 L .5 .62969 L closepath p F P
0 0 0 r
s
.992 .294 .126 r
.51464 .61163 m .5182 .61112 L .5 .62969 L closepath p F P
0 0 0 r
s
.83 .24 .1 r
.5007 .62898 m
.50081 .6292 L
s
.992 .294 .126 r
.51109 .61215 m .51464 .61163 L .5 .62969 L closepath p F P
0 0 0 r
s
.992 .294 .126 r
.50754 .61267 m .51109 .61215 L .5 .62969 L closepath p F P
0 0 0 r
s
.992 .294 .126 r
.50399 .61318 m .50754 .61267 L .5 .62969 L closepath p F P
0 0 0 r
s
.992 .294 .126 r
.50044 .6137 m .50399 .61318 L .5 .62969 L closepath p F P
0 0 0 r
s
.992 .294 .126 r
.4969 .61421 m .50044 .6137 L .5 .62969 L closepath p F P
0 0 0 r
s
.992 .294 .126 r
.49336 .61473 m .4969 .61421 L .5 .62969 L closepath p F P
0 0 0 r
s
.992 .294 .126 r
.48982 .61524 m .49336 .61473 L .5 .62969 L closepath p F P
0 0 0 r
s
.992 .294 .126 r
.48629 .61576 m .48982 .61524 L .5 .62969 L closepath p F P
0 0 0 r
s
.297 .444 .868 r
.51912 .61304 m .5182 .61112 L .5 .62969 L closepath p F P
0 0 0 r
s
.297 .444 .868 r
.52004 .61497 m .51912 .61304 L .5 .62969 L closepath p F P
0 0 0 r
s
.297 .444 .868 r
.52095 .61688 m .52004 .61497 L .5 .62969 L closepath p F P
0 0 0 r
s
.31 .461 .893 r
.52456 .62448 m .52545 .62636 L .55024 .61972 L p F P
0 0 0 r
s
.31 .461 .893 r
.55024 .61972 m .54856 .61598 L .52456 .62448 L p F P
0 0 0 r
s
.24 .35 .67 r
.59631 .31454 m
.60388 .33846 L
s
.60599 .34513 m
.60603 .34526 L
s
.83 .24 .1 r
.20639 .57592 m
.24919 .56921 L
s
.20639 .57592 m
.20012 .54302 L
s
.25766 .60033 m
.30078 .59377 L
s
.25766 .60033 m
.24919 .56921 L
s
.45 .114 .05 r
.52525 .37424 m .50278 .37822 L .50265 .36364 L p F P
0 0 0 r
s
.83 .24 .1 r
.5051 .3648 m
.50535 .36316 L
s
.45 .114 .05 r
.50265 .36364 m .524 .35982 L .52525 .37424 L p F P
0 0 0 r
s
.326 .48 .916 r
.56892 .59883 m .5713 .60443 L .59211 .59019 L p F P
0 0 0 r
s
.24 .35 .67 r
.58568 .59259 m
.5913 .58817 L
s
.326 .48 .916 r
.59211 .59019 m .58918 .58285 L .56892 .59883 L p F P
0 0 0 r
s
.257 .392 .782 r
.446 .61879 m .44395 .61504 L .47167 .62401 L p F P
0 0 0 r
s
.24 .35 .67 r
.44742 .61908 m
.44748 .61918 L
s
.257 .392 .782 r
.47167 .62401 m .47266 .62589 L .446 .61879 L p F P
0 0 0 r
s
.83 .24 .1 r
.40751 .63159 m
.4513 .62525 L
s
.4513 .62525 m
.46064 .64239 L
s
.33 .481 .902 r
.60359 .55564 m .60702 .56474 L .62195 .54505 L p F P
0 0 0 r
s
.33 .481 .902 r
.62195 .54505 m .61818 .53449 L .60359 .55564 L p F P
0 0 0 r
s
.564 .15 .065 r
.43472 .4083 m .41228 .41222 L .41427 .3939 L p F P
0 0 0 r
s
.83 .24 .1 r
.41322 .41316 m
.41333 .41204 L
s
.41495 .39438 m
.415 .39377 L
s
.564 .15 .065 r
.41427 .3939 m .4362 .39001 L .43472 .4083 L p F P
0 0 0 r
s
.83 .24 .1 r
.20012 .54302 m
.24295 .5361 L
s
.24 .35 .67 r
.54804 .61474 m
.57056 .60269 L
s
.162 .212 .366 r
.31652 .48741 m .30876 .47434 L .31984 .49755 L p F P
0 0 0 r
s
.162 .212 .366 r
.31984 .49755 m .32705 .50963 L .31652 .48741 L p F P
0 0 0 r
s
.83 .24 .1 r
.73277 .31616 m
.73266 .30613 L
s
.73266 .30613 m
.77872 .29779 L
s
.73481 .6155 m
.78089 .60902 L
s
.73481 .6155 m
.7306 .60397 L
s
.188 .295 .615 r
.39361 .58837 m .38935 .581 L .41451 .59743 L p F P
0 0 0 r
s
.188 .295 .615 r
.41451 .59743 m .41768 .60304 L .39361 .58837 L p F P
0 0 0 r
s
.648 .176 .076 r
.36829 .44085 m .34634 .44462 L .3458 .42383 L p F P
0 0 0 r
s
.648 .176 .076 r
.3458 .42383 m .36783 .41999 L .36829 .44085 L p F P
0 0 0 r
s
.83 .24 .1 r
.36785 .42108 m
.36923 .42084 L
s
.31 .461 .893 r
.52366 .62259 m .52456 .62448 L .54856 .61598 L p F P
0 0 0 r
s
.24 .35 .67 r
.52679 .62176 m
.54804 .61474 L
s
.83 .24 .1 r
.54848 .62989 m
.59319 .62353 L
s
.288 .411 .737 r
.62879 .46434 m .63315 .47762 L .63726 .45554 L p F P
0 0 0 r
s
.288 .411 .737 r
.63726 .45554 m .63281 .44159 L .62879 .46434 L p F P
0 0 0 r
s
.83 .24 .1 r
.3539 .61503 m
.3977 .60854 L
s
.3539 .61503 m
.34443 .58713 L
s
.59319 .62353 m
.63844 .61709 L
s
.58589 .60576 m
.59319 .62353 L
s
.319 .473 .909 r
.54687 .61221 m .54856 .61598 L .5713 .60443 L p F P
0 0 0 r
s
.319 .473 .909 r
.5713 .60443 m .56892 .59883 L .54687 .61221 L p F P
0 0 0 r
s
.257 .392 .782 r
.47068 .62212 m .47167 .62401 L .44395 .61504 L p F P
0 0 0 r
s
.83 .24 .1 r
.46486 .62328 m
.46902 .62268 L
s
.4513 .62525 m
.46486 .62328 L
s
.105 .162 .375 r
.34858 .54244 m .34227 .53184 L .36178 .55336 L p F P
0 0 0 r
s
.105 .162 .375 r
.36178 .55336 m .36716 .56249 L .34858 .54244 L p F P
0 0 0 r
s
.83 .24 .1 r
.60584 .339 m
.64054 .33276 L
s
.45 .114 .05 r
.54785 .37024 m .52525 .37424 L .524 .35982 L p F P
0 0 0 r
s
.45 .114 .05 r
.524 .35982 m .54548 .35597 L .54785 .37024 L p F P
0 0 0 r
s
.31 .461 .893 r
.54856 .61598 m .54687 .61221 L .52366 .62259 L p F P
0 0 0 r
s
.83 .24 .1 r
.28252 .49569 m
.28136 .46406 L
s
.564 .15 .065 r
.45729 .40436 m .43472 .4083 L .4362 .39001 L p F P
0 0 0 r
s
.564 .15 .065 r
.4362 .39001 m .45826 .38611 L .45729 .40436 L p F P
0 0 0 r
s
.228 .351 .713 r
.41768 .60304 m .41451 .59743 L .44189 .61126 L p F P
0 0 0 r
s
.228 .351 .713 r
.44189 .61126 m .44395 .61504 L .41768 .60304 L p F P
0 0 0 r
s
.054 .079 .187 r
.61648 .35808 m .62118 .37317 L .61521 .35879 L p F P
0 0 0 r
s
.054 .079 .187 r
.61521 .35879 m .61068 .34429 L .61648 .35808 L p F P
0 0 0 r
s
.31 .461 .893 r
.52276 .62069 m .52366 .62259 L .54687 .61221 L p F P
0 0 0 r
s
.257 .392 .782 r
.44395 .61504 m .44189 .61126 L .47068 .62212 L p F P
0 0 0 r
s
.257 .392 .782 r
.46968 .62022 m .47068 .62212 L .44189 .61126 L p F P
0 0 0 r
s
.83 .24 .1 r
.24295 .5361 m
.23932 .50287 L
s
.23932 .50287 m
.28252 .49569 L
s
.247 .347 .604 r
.62825 .42733 m .63281 .44159 L .63328 .42074 L p F P
0 0 0 r
s
.24 .35 .67 r
.63178 .4227 m
.63186 .42159 L
s
.247 .347 .604 r
.63328 .42074 m .62871 .40619 L .62825 .42733 L p F P
0 0 0 r
s
.33 .484 .915 r
.5862 .5754 m .58918 .58285 L .60702 .56474 L p F P
0 0 0 r
s
.33 .484 .915 r
.60702 .56474 m .60359 .55564 L .5862 .5754 L p F P
0 0 0 r
s
.712 .196 .085 r
.32981 .47079 m .30876 .47434 L .30283 .4521 L p F P
0 0 0 r
s
.24 .35 .67 r
.31382 .47349 m
.32076 .49521 L
s
.712 .196 .085 r
.30283 .4521 m .32452 .44837 L .32981 .47079 L p F P
0 0 0 r
s
.24 .35 .67 r
.29679 .44363 m
.30543 .45829 L
s
.30543 .45829 m
.30589 .45907 L
s
.83 .24 .1 r
.32499 .45036 m
.32507 .44828 L
s
.30395 .4602 m
.30495 .46003 L
s
.28136 .46406 m
.30395 .4602 L
s
.326 .471 .874 r
.61433 .52374 m .61818 .53449 L .62955 .5126 L p F P
0 0 0 r
s
.326 .471 .874 r
.62955 .5126 m .62545 .50058 L .61433 .52374 L p F P
0 0 0 r
s
.648 .176 .076 r
.39038 .43706 m .36829 .44085 L .36783 .41999 L p F P
0 0 0 r
s
.83 .24 .1 r
.36923 .42105 m
.36923 .42084 L
s
.648 .176 .076 r
.36783 .41999 m .38999 .41611 L .39038 .43706 L p F P
0 0 0 r
s
.191 .261 .437 r
.62404 .3913 m .62871 .40619 L .62578 .38792 L p F P
0 0 0 r
s
.191 .261 .437 r
.62578 .38792 m .62118 .37317 L .62404 .3913 L p F P
0 0 0 r
s
.24 .35 .67 r
.61763 .3674 m
.62296 .38443 L
s
.31 .461 .893 r
.52185 .61879 m .52276 .62069 L .54516 .60841 L p F P
0 0 0 r
s
.31 .461 .893 r
.54687 .61221 m .54516 .60841 L .52276 .62069 L p F P
0 0 0 r
s
.83 .24 .1 r
.24919 .56921 m
.29251 .56242 L
s
.24919 .56921 m
.24295 .5361 L
s
.45 .114 .05 r
.57058 .36621 m .54785 .37024 L .54548 .35597 L p F P
0 0 0 r
s
.83 .24 .1 r
.54957 .35764 m
.54984 .35519 L
s
.45 .114 .05 r
.54548 .35597 m .56709 .3521 L .57058 .36621 L p F P
0 0 0 r
s
.83 .24 .1 r
.30078 .59377 m
.34443 .58713 L
s
.30078 .59377 m
.29251 .56242 L
s
.257 .392 .782 r
.44189 .61126 m .43981 .60746 L .46968 .62022 L p F P
0 0 0 r
s
.257 .392 .782 r
.46868 .61832 m .46968 .62022 L .43981 .60746 L p F P
0 0 0 r
s
.83 .24 .1 r
.44644 .61306 m
.4513 .62525 L
s
.24 .35 .67 r
.29771 .3366 m
.28084 .30548 L
s
.29771 .3366 m
.28532 .36243 L
s
.14 .226 .491 r
.36716 .56249 m .36178 .55336 L .38502 .57353 L p F P
0 0 0 r
s
.24 .35 .67 r
.37066 .55981 m
.37216 .56237 L
s
.14 .226 .491 r
.38502 .57353 m .38935 .581 L .36716 .56249 L p F P
0 0 0 r
s
.319 .473 .909 r
.54516 .60841 m .54687 .61221 L .56892 .59883 L p F P
0 0 0 r
s
.24 .35 .67 r
.29606 .41804 m
.27914 .38877 L
s
.29606 .41804 m
.29679 .44363 L
s
.564 .15 .065 r
.48 .40039 m .45729 .40436 L .45826 .38611 L p F P
0 0 0 r
s
.83 .24 .1 r
.45775 .40539 m
.45782 .40426 L
s
.45897 .38657 m
.45901 .38597 L
s
.564 .15 .065 r
.45826 .38611 m .48046 .38217 L .48 .40039 L p F P
0 0 0 r
s
.326 .48 .916 r
.56652 .59317 m .56892 .59883 L .58918 .58285 L p F P
0 0 0 r
s
.326 .48 .916 r
.58918 .58285 m .5862 .5754 L .56652 .59317 L p F P
0 0 0 r
s
.83 .24 .1 r
.24295 .5361 m
.2863 .5291 L
s
.31 .461 .893 r
.52095 .61688 m .52185 .61879 L .54344 .60459 L p F P
0 0 0 r
s
.31 .461 .893 r
.54516 .60841 m .54344 .60459 L .52185 .61879 L p F P
0 0 0 r
s
.228 .351 .713 r
.43981 .60746 m .44189 .61126 L .41451 .59743 L p F P
0 0 0 r
s
.071 .103 .253 r
.32705 .50963 m .31984 .49755 L .33584 .52104 L p F P
0 0 0 r
s
.071 .103 .253 r
.33584 .52104 m .34227 .53184 L .32705 .50963 L p F P
0 0 0 r
s
.24 .35 .67 r
.32076 .49521 m
.33645 .5216 L
s
.319 .473 .909 r
.56892 .59883 m .56652 .59317 L .54516 .60841 L p F P
0 0 0 r
s
.83 .24 .1 r
.77872 .29779 m
.77974 .30771 L
s
.78089 .60902 m
.82752 .60246 L
s
.78089 .60902 m
.77753 .59729 L
s
.24 .35 .67 r
.54526 .25022 m
.51832 .24133 L
s
.51832 .24133 m
.5065 .20796 L
s
.971 .285 .122 r
.4722 .61781 m .46868 .61832 L .43772 .60363 L p F P
0 0 0 r
s
.257 .392 .782 r
.43981 .60746 m .43772 .60363 L .46868 .61832 L p F P
0 0 0 r
s
.712 .196 .085 r
.35098 .46722 m .32981 .47079 L .32452 .44837 L p F P
0 0 0 r
s
.712 .196 .085 r
.32452 .44837 m .34634 .44462 L .35098 .46722 L p F P
0 0 0 r
s
.24 .35 .67 r
.41169 .21254 m
.37986 .22379 L
s
.37986 .22379 m
.36485 .19001 L
s
.37986 .22379 m
.34983 .2393 L
s
.648 .176 .076 r
.4126 .43324 m .39038 .43706 L .38999 .41611 L p F P
0 0 0 r
s
.648 .176 .076 r
.38999 .41611 m .41228 .41222 L .4126 .43324 L p F P
0 0 0 r
s
.83 .24 .1 r
.4123 .41332 m
.41322 .41316 L
s
.971 .285 .122 r
.47571 .61729 m .4722 .61781 L .44468 .6026 L p F P
0 0 0 r
s
.971 .285 .122 r
.43772 .60363 m .44468 .6026 L .4722 .61781 L p F P
0 0 0 r
s
.83 .24 .1 r
.44203 .60198 m
.44241 .60294 L
s
.63844 .61709 m
.68424 .61057 L
s
.63844 .61709 m
.63185 .5991 L
s
.188 .295 .615 r
.38935 .581 m .38502 .57353 L .4113 .59175 L p F P
0 0 0 r
s
.188 .295 .615 r
.4113 .59175 m .41451 .59743 L .38935 .581 L p F P
0 0 0 r
s
.45 .114 .05 r
.59346 .36216 m .57058 .36621 L .56709 .3521 L p F P
0 0 0 r
s
.45 .114 .05 r
.56709 .3521 m .58882 .34821 L .59346 .36216 L p F P
0 0 0 r
s
.971 .285 .122 r
.47924 .61678 m .47571 .61729 L .45166 .60157 L p F P
0 0 0 r
s
.971 .285 .122 r
.44468 .6026 m .45166 .60157 L .47571 .61729 L p F P
0 0 0 r
s
.83 .24 .1 r
.44546 .61059 m
.44644 .61306 L
s
.24 .35 .67 r
.59631 .31454 m
.57868 .29617 L
s
.57868 .29617 m
.56823 .26403 L
s
.228 .351 .713 r
.41451 .59743 m .4113 .59175 L .43981 .60746 L p F P
0 0 0 r
s
.83 .24 .1 r
.64025 .34987 m
.64054 .33276 L
s
.64054 .33276 m
.68637 .32451 L
s
.31 .461 .893 r
.52004 .61497 m .52095 .61688 L .54171 .60073 L p F P
0 0 0 r
s
.31 .461 .893 r
.54344 .60459 m .54171 .60073 L .52095 .61688 L p F P
0 0 0 r
s
.83 .24 .1 r
.52243 .61495 m
.52665 .61434 L
s
.24 .35 .67 r
.34983 .2393 m
.33411 .20583 L
s
.34983 .2393 m
.32265 .25853 L
s
.971 .285 .122 r
.48276 .61627 m .47924 .61678 L .45865 .60053 L p F P
0 0 0 r
s
.971 .285 .122 r
.45166 .60157 m .45865 .60053 L .47924 .61678 L p F P
0 0 0 r
s
.313 .45 .822 r
.62126 .48831 m .62545 .50058 L .63315 .47762 L p F P
0 0 0 r
s
.313 .45 .822 r
.63315 .47762 m .62879 .46434 L .62126 .48831 L p F P
0 0 0 r
s
.564 .15 .065 r
.50285 .3964 m .48 .40039 L .48046 .38217 L p F P
0 0 0 r
s
.564 .15 .065 r
.48046 .38217 m .50278 .37822 L .50285 .3964 L p F P
0 0 0 r
s
.33 .481 .902 r
.60011 .5464 m .60359 .55564 L .61818 .53449 L p F P
0 0 0 r
s
.33 .481 .902 r
.61818 .53449 m .61433 .52374 L .60011 .5464 L p F P
0 0 0 r
s
.24 .35 .67 r
.44418 .20598 m
.41169 .21254 L
s
.41169 .21254 m
.39739 .17845 L
s
.971 .285 .122 r
.48629 .61576 m .48276 .61627 L .46566 .59949 L p F P
0 0 0 r
s
.971 .285 .122 r
.45865 .60053 m .46566 .59949 L .48276 .61627 L p F P
0 0 0 r
s
.319 .473 .909 r
.54344 .60459 m .54516 .60841 L .56652 .59317 L p F P
0 0 0 r
s
.971 .285 .122 r
.48982 .61524 m .48629 .61576 L .47268 .59846 L p F P
0 0 0 r
s
.971 .285 .122 r
.46566 .59949 m .47268 .59846 L .48629 .61576 L p F P
0 0 0 r
s
.83 .24 .1 r
.2863 .5291 m
.28252 .49569 L
s
.971 .285 .122 r
.49336 .61473 m .48982 .61524 L .47971 .59741 L p F P
0 0 0 r
s
.971 .285 .122 r
.47268 .59846 m .47971 .59741 L .48982 .61524 L p F P
0 0 0 r
s
.24 .35 .67 r
.47138 .60575 m
.47527 .61328 L
s
.47527 .61328 m
.47645 .61556 L
s
.712 .196 .085 r
.37228 .46363 m .35098 .46722 L .34634 .44462 L p F P
0 0 0 r
s
.712 .196 .085 r
.34634 .44462 m .36829 .44085 L .37228 .46363 L p F P
0 0 0 r
s
.83 .24 .1 r
.36881 .4438 m
.36886 .44075 L
s
.228 .351 .713 r
.43772 .60363 m .43981 .60746 L .4113 .59175 L p F P
0 0 0 r
s
.83 .24 .1 r
.3977 .60854 m
.42807 .60404 L
s
.42807 .60404 m
.43167 .60351 L
s
.43167 .60351 m
.43429 .60312 L
s
.31 .461 .893 r
.51912 .61304 m .52004 .61497 L .53997 .59686 L p F P
0 0 0 r
s
.31 .461 .893 r
.54171 .60073 m .53997 .59686 L .52004 .61497 L p F P
0 0 0 r
s
.83 .24 .1 r
.54049 .61233 m
.54848 .62989 L
s
.971 .285 .122 r
.4969 .61421 m .49336 .61473 L .48675 .59637 L p F P
0 0 0 r
s
.971 .285 .122 r
.47971 .59741 m .48675 .59637 L .49336 .61473 L p F P
0 0 0 r
s
.648 .176 .076 r
.43495 .4294 m .4126 .43324 L .41228 .41222 L p F P
0 0 0 r
s
.648 .176 .076 r
.41228 .41222 m .43472 .4083 L .43495 .4294 L p F P
0 0 0 r
s
.971 .285 .122 r
.50044 .6137 m .4969 .61421 L .49381 .59533 L p F P
0 0 0 r
s
.971 .285 .122 r
.48675 .59637 m .49381 .59533 L .4969 .61421 L p F P
0 0 0 r
s
.83 .24 .1 r
.48689 .59533 m
.48725 .5963 L
s
.45 .114 .05 r
.61648 .35808 m .59346 .36216 L .58882 .34821 L p F P
0 0 0 r
s
.24 .35 .67 r
.60603 .34526 m
.61189 .35644 L
s
.61306 .35868 m
.61763 .3674 L
s
.45 .114 .05 r
.58882 .34821 m .61068 .34429 L .61648 .35808 L p F P
0 0 0 r
s
.83 .24 .1 r
.29251 .56242 m
.33636 .55555 L
s
.29251 .56242 m
.2863 .5291 L
s
.24 .35 .67 r
.45114 .60497 m
.47138 .60575 L
s
.105 .162 .375 r
.34227 .53184 m .33584 .52104 L .35631 .54408 L p F P
0 0 0 r
s
.24 .35 .67 r
.3462 .53526 m
.34776 .53789 L
s
.105 .162 .375 r
.35631 .54408 m .36178 .55336 L .34227 .53184 L p F P
0 0 0 r
s
.24 .35 .67 r
.3604 .55102 m
.37066 .55981 L
s
.83 .24 .1 r
.34443 .58713 m
.33636 .55555 L
s
.971 .285 .122 r
.50399 .61318 m .50044 .6137 L .50088 .59428 L p F P
0 0 0 r
s
.971 .285 .122 r
.49381 .59533 m .50088 .59428 L .50044 .6137 L p F P
0 0 0 r
s
.764 .213 .092 r
.3397 .49427 m .31984 .49755 L .30876 .47434 L p F P
0 0 0 r
s
.764 .213 .092 r
.30876 .47434 m .32981 .47079 L .3397 .49427 L p F P
0 0 0 r
s
.83 .24 .1 r
.28252 .49569 m
.31627 .49008 L
s
.24 .35 .67 r
.30434 .4676 m
.31619 .48753 L
s
.31619 .48753 m
.31712 .4891 L
s
.33 .484 .915 r
.58319 .56786 m .5862 .5754 L .60359 .55564 L p F P
0 0 0 r
s
.33 .484 .915 r
.60359 .55564 m .60011 .5464 L .58319 .56786 L p F P
0 0 0 r
s
.24 .35 .67 r
.59375 .55324 m
.59407 .55406 L
s
.971 .285 .122 r
.50754 .61267 m .50399 .61318 L .50797 .59323 L p F P
0 0 0 r
s
.971 .285 .122 r
.50088 .59428 m .50797 .59323 L .50399 .61318 L p F P
0 0 0 r
s
.564 .15 .065 r
.52584 .39238 m .50285 .3964 L .50278 .37822 L p F P
0 0 0 r
s
.83 .24 .1 r
.50352 .37867 m
.50355 .37808 L
s
.564 .15 .065 r
.50278 .37822 m .52525 .37424 L .52584 .39238 L p F P
0 0 0 r
s
.31 .461 .893 r
.5182 .61112 m .51912 .61304 L .53821 .59295 L p F P
0 0 0 r
s
.31 .461 .893 r
.53997 .59686 m .53821 .59295 L .51912 .61304 L p F P
0 0 0 r
s
.83 .24 .1 r
.52665 .61434 m
.54049 .61233 L
s
.319 .473 .909 r
.56652 .59317 m .5641 .58745 L .54344 .60459 L p F P
0 0 0 r
s
.326 .48 .916 r
.5641 .58745 m .56652 .59317 L .5862 .5754 L p F P
0 0 0 r
s
.83 .24 .1 r
.54049 .61233 m
.58589 .60576 L
s
.971 .285 .122 r
.51109 .61215 m .50754 .61267 L .51506 .59218 L p F P
0 0 0 r
s
.971 .285 .122 r
.50797 .59323 m .51506 .59218 L .50754 .61267 L p F P
0 0 0 r
s
.24 .35 .67 r
.50812 .60849 m
.50923 .61079 L
s
.50444 .60089 m
.50812 .60849 L
s
.60804 .33677 m
.61276 .35185 L
s
.61276 .35185 m
.61337 .35379 L
s
.32265 .25853 m
.30624 .22537 L
s
.32265 .25853 m
.29935 .28084 L
s
.83 .24 .1 r
.2863 .5291 m
.33018 .52201 L
s
.288 .411 .737 r
.62432 .45076 m .62879 .46434 L .63281 .44159 L p F P
0 0 0 r
s
.288 .411 .737 r
.63281 .44159 m .62825 .42733 L .62432 .45076 L p F P
0 0 0 r
s
.971 .285 .122 r
.51464 .61163 m .51109 .61215 L .52218 .59113 L p F P
0 0 0 r
s
.971 .285 .122 r
.51506 .59218 m .52218 .59113 L .51109 .61215 L p F P
0 0 0 r
s
.326 .48 .916 r
.5862 .5754 m .58319 .56786 L .5641 .58745 L p F P
0 0 0 r
s
.319 .473 .909 r
.54171 .60073 m .54344 .60459 L .5641 .58745 L p F P
0 0 0 r
s
.83 .24 .1 r
.82504 .59053 m
.82752 .60246 L
s
.712 .196 .085 r
.39371 .46002 m .37228 .46363 L .36829 .44085 L p F P
0 0 0 r
s
.712 .196 .085 r
.36829 .44085 m .39038 .43706 L .39371 .46002 L p F P
0 0 0 r
s
.971 .285 .122 r
.5182 .61112 m .51464 .61163 L .5293 .59007 L p F P
0 0 0 r
s
.971 .285 .122 r
.52218 .59113 m .5293 .59007 L .51464 .61163 L p F P
0 0 0 r
s
.188 .295 .615 r
.40806 .58601 m .4113 .59175 L .38502 .57353 L p F P
0 0 0 r
s
.228 .351 .713 r
.4113 .59175 m .40806 .58601 L .43772 .60363 L p F P
0 0 0 r
s
.83 .24 .1 r
.43635 .60282 m
.44203 .60198 L
s
.24 .35 .67 r
.47619 .2044 m
.44418 .20598 L
s
.44418 .20598 m
.43057 .17158 L
s
.648 .176 .076 r
.45744 .42554 m .43495 .4294 L .43472 .4083 L p F P
0 0 0 r
s
.648 .176 .076 r
.43472 .4083 m .45729 .40436 L .45744 .42554 L p F P
0 0 0 r
s
.83 .24 .1 r
.4573 .40547 m
.45775 .40539 L
s
.68424 .61057 m
.7306 .60397 L
s
.68424 .61057 m
.67839 .59236 L
s
.944 .274 .118 r
.44468 .6026 m .43772 .60363 L .40806 .58601 L p F P
0 0 0 r
s
.971 .285 .122 r
.5293 .59007 m .53644 .58902 L .5182 .61112 L p F P
0 0 0 r
s
.31 .461 .893 r
.53821 .59295 m .53644 .58902 L .5182 .61112 L p F P
0 0 0 r
s
.14 .226 .491 r
.36178 .55336 m .35631 .54408 L .38064 .56596 L p F P
0 0 0 r
s
.14 .226 .491 r
.38064 .56596 m .38502 .57353 L .36178 .55336 L p F P
0 0 0 r
s
.83 .24 .1 r
.6869 .34158 m
.68637 .32451 L
s
.68637 .32451 m
.73277 .31616 L
s
.764 .213 .092 r
.35967 .49098 m .3397 .49427 L .32981 .47079 L p F P
0 0 0 r
s
.764 .213 .092 r
.32981 .47079 m .35098 .46722 L .35967 .49098 L p F P
0 0 0 r
s
.326 .471 .874 r
.61042 .51279 m .61433 .52374 L .62545 .50058 L p F P
0 0 0 r
s
.326 .471 .874 r
.62545 .50058 m .62126 .48831 L .61042 .51279 L p F P
0 0 0 r
s
.188 .295 .615 r
.38502 .57353 m .38064 .56596 L .40806 .58601 L p F P
0 0 0 r
s
.83 .24 .1 r
.3886 .5804 m
.3977 .60854 L
s
.34443 .58713 m
.3886 .5804 L
s
.944 .274 .118 r
.45166 .60157 m .44468 .6026 L .41831 .58447 L p F P
0 0 0 r
s
.83 .24 .1 r
.44299 .60183 m
.44347 .60176 L
s
.44156 .60045 m
.44182 .6013 L
s
.944 .274 .118 r
.40806 .58601 m .41831 .58447 L .44468 .6026 L p F P
0 0 0 r
s
.564 .15 .065 r
.54898 .38834 m .52584 .39238 L .52525 .37424 L p F P
0 0 0 r
s
.564 .15 .065 r
.52525 .37424 m .54785 .37024 L .54898 .38834 L p F P
0 0 0 r
s
.247 .347 .604 r
.62359 .41274 m .62825 .42733 L .62871 .40619 L p F P
0 0 0 r
s
.247 .347 .604 r
.62871 .40619 m .62404 .3913 L .62359 .41274 L p F P
0 0 0 r
s
.24 .35 .67 r
.62269 .39249 m
.62393 .39644 L
s
.944 .274 .118 r
.45865 .60053 m .45166 .60157 L .42858 .58291 L p F P
0 0 0 r
s
.83 .24 .1 r
.45012 .60078 m
.4506 .60071 L
s
.944 .274 .118 r
.41831 .58447 m .42858 .58291 L .45166 .60157 L p F P
0 0 0 r
s
.24 .35 .67 r
.43635 .59878 m
.43715 .60024 L
s
.191 .261 .437 r
.61926 .37606 m .62404 .3913 L .62118 .37317 L p F P
0 0 0 r
s
.24 .35 .67 r
.61959 .37711 m
.62269 .39249 L
s
.191 .261 .437 r
.62118 .37317 m .61648 .35808 L .61926 .37606 L p F P
0 0 0 r
s
.24 .35 .67 r
.61763 .3674 m
.61887 .37358 L
s
.6148 .35838 m
.61763 .3674 L
s
.28532 .36243 m
.26797 .33157 L
s
.28532 .36243 m
.27914 .38877 L
s
.712 .196 .085 r
.41526 .45639 m .39371 .46002 L .39038 .43706 L p F P
0 0 0 r
s
.712 .196 .085 r
.39038 .43706 m .4126 .43324 L .41526 .45639 L p F P
0 0 0 r
s
.319 .473 .909 r
.53997 .59686 m .54171 .60073 L .56165 .58166 L p F P
0 0 0 r
s
.24 .35 .67 r
.54174 .60071 m
.54174 .60072 L
s
.83 .24 .1 r
.53621 .5999 m
.54049 .61233 L
s
.53534 .59738 m
.53621 .5999 L
s
.319 .473 .909 r
.5641 .58745 m .56165 .58166 L .54171 .60073 L p F P
0 0 0 r
s
.648 .176 .076 r
.48007 .42165 m .45744 .42554 L .45729 .40436 L p F P
0 0 0 r
s
.648 .176 .076 r
.45729 .40436 m .48 .40039 L .48007 .42165 L p F P
0 0 0 r
s
.944 .274 .118 r
.46566 .59949 m .45865 .60053 L .43888 .58136 L p F P
0 0 0 r
s
.83 .24 .1 r
.45726 .59972 m
.45774 .59965 L
s
.944 .274 .118 r
.42858 .58291 m .43888 .58136 L .45865 .60053 L p F P
0 0 0 r
s
.808 .228 .098 r
.35397 .51811 m .33584 .52104 L .31984 .49755 L p F P
0 0 0 r
s
.83 .24 .1 r
.32718 .49634 m
.32788 .50239 L
s
.24 .35 .67 r
.32208 .49718 m
.32403 .50007 L
s
.33759 .52076 m
.34161 .52753 L
s
.808 .228 .098 r
.31984 .49755 m .3397 .49427 L .35397 .51811 L p F P
0 0 0 r
s
.24 .35 .67 r
.33291 .51327 m
.33495 .5163 L
s
.33026 .50934 m
.33291 .51327 L
s
.83 .24 .1 r
.32889 .511 m
.32962 .51723 L
s
.32962 .51723 m
.33018 .52201 L
s
.33636 .55555 m
.36232 .55148 L
s
.36232 .55148 m
.36375 .55125 L
s
.33018 .52201 m
.33636 .55555 L
s
.326 .48 .916 r
.56165 .58166 m .5641 .58745 L .58319 .56786 L p F P
0 0 0 r
s
.764 .213 .092 r
.37975 .48766 m .35967 .49098 L .35098 .46722 L p F P
0 0 0 r
s
.764 .213 .092 r
.35098 .46722 m .37228 .46363 L .37975 .48766 L p F P
0 0 0 r
s
.944 .274 .118 r
.47268 .59846 m .46566 .59949 L .44921 .5798 L p F P
0 0 0 r
s
.83 .24 .1 r
.46442 .59866 m
.4649 .59859 L
s
.944 .274 .118 r
.43888 .58136 m .44921 .5798 L .46566 .59949 L p F P
0 0 0 r
s
.564 .15 .065 r
.57226 .38427 m .54898 .38834 L .54785 .37024 L p F P
0 0 0 r
s
.83 .24 .1 r
.54862 .37068 m
.54862 .3701 L
s
.564 .15 .065 r
.54785 .37024 m .57058 .36621 L .57226 .38427 L p F P
0 0 0 r
s
.83 .24 .1 r
.58589 .60576 m
.63185 .5991 L
s
.5783 .58179 m
.58589 .60576 L
s
.24 .35 .67 r
.47138 .60575 m
.50444 .60089 L
s
.33 .481 .902 r
.59656 .53701 m .60011 .5464 L .61433 .52374 L p F P
0 0 0 r
s
.24 .35 .67 r
.59375 .55324 m
.60002 .54617 L
s
.33 .481 .902 r
.61433 .52374 m .61042 .51279 L .59656 .53701 L p F P
0 0 0 r
s
.24 .35 .67 r
.56823 .26403 m
.54526 .25022 L
s
.54526 .25022 m
.53393 .21667 L
s
.944 .274 .118 r
.47971 .59741 m .47268 .59846 L .45957 .57823 L p F P
0 0 0 r
s
.83 .24 .1 r
.47159 .5976 m
.47207 .59752 L
s
.944 .274 .118 r
.44921 .5798 m .45957 .57823 L .47268 .59846 L p F P
0 0 0 r
s
.913 .264 .113 r
.41831 .58447 m .40806 .58601 L .38064 .56596 L p F P
0 0 0 r
s
.83 .24 .1 r
.38636 .57134 m
.3886 .5804 L
s
.3886 .5804 m
.39754 .57904 L
s
.33018 .52201 m
.33579 .52111 L
s
.24 .35 .67 r
.29935 .28084 m
.28228 .24798 L
s
.29935 .28084 m
.28084 .30548 L
s
.29679 .44363 m
.27966 .41457 L
s
.29679 .44363 m
.30434 .4676 L
s
.712 .196 .085 r
.43694 .45273 m .41526 .45639 L .4126 .43324 L p F P
0 0 0 r
s
.83 .24 .1 r
.4132 .43372 m
.4132 .43314 L
s
.712 .196 .085 r
.4126 .43324 m .43495 .4294 L .43694 .45273 L p F P
0 0 0 r
s
.944 .274 .118 r
.48675 .59637 m .47971 .59741 L .46996 .57666 L p F P
0 0 0 r
s
.83 .24 .1 r
.47878 .59653 m
.47926 .59646 L
s
.48598 .59546 m
.48689 .59533 L
s
.944 .274 .118 r
.45957 .57823 m .46996 .57666 L .47971 .59741 L p F P
0 0 0 r
s
.83 .24 .1 r
.61492 .35437 m
.64025 .34987 L
s
.326 .48 .916 r
.58319 .56786 m .58013 .56021 L .56165 .58166 L p F P
0 0 0 r
s
.33 .484 .915 r
.58013 .56021 m .58319 .56786 L .60011 .5464 L p F P
0 0 0 r
s
.313 .45 .822 r
.61699 .47579 m .62126 .48831 L .62879 .46434 L p F P
0 0 0 r
s
.313 .45 .822 r
.62879 .46434 m .62432 .45076 L .61699 .47579 L p F P
0 0 0 r
s
.648 .176 .076 r
.50284 .41774 m .48007 .42165 L .48 .40039 L p F P
0 0 0 r
s
.648 .176 .076 r
.48 .40039 m .50285 .3964 L .50284 .41774 L p F P
0 0 0 r
s
.83 .24 .1 r
.50285 .3967 m
.50286 .3964 L
s
.808 .228 .098 r
.3722 .51517 m .35397 .51811 L .3397 .49427 L p F P
0 0 0 r
s
.808 .228 .098 r
.3397 .49427 m .35967 .49098 L .3722 .51517 L p F P
0 0 0 r
s
.83 .24 .1 r
.7306 .60397 m
.77753 .59729 L
s
.7306 .60397 m
.72549 .58554 L
s
.913 .264 .113 r
.42858 .58291 m .41831 .58447 L .39389 .56392 L p F P
0 0 0 r
s
.24 .35 .67 r
.43526 .59677 m
.43635 .59878 L
s
.913 .264 .113 r
.38064 .56596 m .39389 .56392 L .41831 .58447 L p F P
0 0 0 r
s
.24 .35 .67 r
.37759 .56322 m
.38256 .56567 L
s
.33 .484 .915 r
.60011 .5464 m .59656 .53701 L .58013 .56021 L p F P
0 0 0 r
s
.319 .473 .909 r
.53821 .59295 m .53997 .59686 L .55917 .57582 L p F P
0 0 0 r
s
.24 .35 .67 r
.53999 .59683 m
.53999 .59684 L
s
.319 .473 .909 r
.56165 .58166 m .55917 .57582 L .53997 .59686 L p F P
0 0 0 r
s
.764 .213 .092 r
.39994 .48433 m .37975 .48766 L .37228 .46363 L p F P
0 0 0 r
s
.764 .213 .092 r
.37228 .46363 m .39371 .46002 L .39994 .48433 L p F P
0 0 0 r
s
.83 .24 .1 r
.73412 .33319 m
.73277 .31616 L
s
.73277 .31616 m
.77974 .30771 L
s
.944 .274 .118 r
.49381 .59533 m .48675 .59637 L .48038 .57509 L p F P
0 0 0 r
s
.944 .274 .118 r
.46996 .57666 m .48038 .57509 L .48675 .59637 L p F P
0 0 0 r
s
.24 .35 .67 r
.45833 .58049 m
.47138 .60575 L
s
.5065 .20796 m
.47619 .2044 L
s
.47619 .2044 m
.46322 .16971 L
s
.846 .24 .104 r
.37222 .54157 m .35631 .54408 L .33584 .52104 L p F P
0 0 0 r
s
.846 .24 .104 r
.33584 .52104 m .35397 .51811 L .37222 .54157 L p F P
0 0 0 r
s
.24 .35 .67 r
.33495 .5163 m
.33689 .51957 L
s
.33689 .51957 m
.33697 .51971 L
s
.564 .15 .065 r
.59568 .38018 m .57226 .38427 L .57058 .36621 L p F P
0 0 0 r
s
.564 .15 .065 r
.57058 .36621 m .59346 .36216 L .59568 .38018 L p F P
0 0 0 r
s
.881 .252 .108 r
.39389 .56392 m .38064 .56596 L .35631 .54408 L p F P
0 0 0 r
s
.913 .264 .113 r
.43888 .58136 m .42858 .58291 L .4072 .56186 L p F P
0 0 0 r
s
.913 .264 .113 r
.39389 .56392 m .4072 .56186 L .42858 .58291 L p F P
0 0 0 r
s
.24 .35 .67 r
.38877 .56873 m
.39611 .57234 L
s
.39611 .57234 m
.39902 .57747 L
s
.944 .274 .118 r
.50088 .59428 m .49381 .59533 L .49083 .57351 L p F P
0 0 0 r
s
.83 .24 .1 r
.49319 .5944 m
.49367 .59432 L
s
.944 .274 .118 r
.48038 .57509 m .49083 .57351 L .49381 .59533 L p F P
0 0 0 r
s
.24 .35 .67 r
.60804 .33677 m
.59631 .31454 L
s
.59631 .31454 m
.58614 .28238 L
s
.881 .252 .108 r
.35631 .54408 m .37222 .54157 L .39389 .56392 L p F P
0 0 0 r
s
.24 .35 .67 r
.36441 .54912 m
.3649 .54995 L
s
.944 .274 .118 r
.50797 .59323 m .50088 .59428 L .5013 .57193 L p F P
0 0 0 r
s
.83 .24 .1 r
.50042 .59332 m
.5009 .59325 L
s
.944 .274 .118 r
.49083 .57351 m .5013 .57193 L .50088 .59428 L p F P
0 0 0 r
s
.712 .196 .085 r
.45875 .44905 m .43694 .45273 L .43495 .4294 L p F P
0 0 0 r
s
.712 .196 .085 r
.43495 .4294 m .45744 .42554 L .45875 .44905 L p F P
0 0 0 r
s
.326 .48 .916 r
.55917 .57582 m .56165 .58166 L .58013 .56021 L p F P
0 0 0 r
s
.808 .228 .098 r
.39051 .51221 m .3722 .51517 L .35967 .49098 L p F P
0 0 0 r
s
.83 .24 .1 r
.37459 .51478 m
.37459 .51484 L
s
.808 .228 .098 r
.35967 .49098 m .37975 .48766 L .39051 .51221 L p F P
0 0 0 r
s
.24 .35 .67 r
.50444 .60089 m
.52158 .59521 L
s
.52158 .59521 m
.52502 .59407 L
s
.913 .264 .113 r
.44921 .5798 m .43888 .58136 L .42055 .5598 L p F P
0 0 0 r
s
.913 .264 .113 r
.4072 .56186 m .42055 .5598 L .43888 .58136 L p F P
0 0 0 r
s
.648 .176 .076 r
.52575 .4138 m .50284 .41774 L .50285 .3964 L p F P
0 0 0 r
s
.648 .176 .076 r
.50285 .3964 m .52584 .39238 L .52575 .4138 L p F P
0 0 0 r
s
.846 .24 .104 r
.3882 .53905 m .37222 .54157 L .35397 .51811 L p F P
0 0 0 r
s
.846 .24 .104 r
.35397 .51811 m .3722 .51517 L .3882 .53905 L p F P
0 0 0 r
s
.24 .35 .67 r
.35535 .5336 m
.36441 .54912 L
s
.83 .24 .1 r
.37223 .51522 m
.37459 .51484 L
s
.881 .252 .108 r
.4072 .56186 m .39389 .56392 L .37222 .54157 L p F P
0 0 0 r
s
.764 .213 .092 r
.42024 .48097 m .39994 .48433 L .39371 .46002 L p F P
0 0 0 r
s
.764 .213 .092 r
.39371 .46002 m .41526 .45639 L .42024 .48097 L p F P
0 0 0 r
s
.83 .24 .1 r
.37459 .51484 m
.37557 .5202 L
s
.37926 .54046 m
.38032 .54627 L
s
.944 .274 .118 r
.51506 .59218 m .50797 .59323 L .51181 .57034 L p F P
0 0 0 r
s
.83 .24 .1 r
.50766 .59225 m
.50814 .59218 L
s
.944 .274 .118 r
.5013 .57193 m .51181 .57034 L .50797 .59323 L p F P
0 0 0 r
s
.24 .35 .67 r
.49211 .57539 m
.50444 .60089 L
s
.33495 .5163 m
.31863 .48881 L
s
.33495 .5163 m
.35535 .5336 L
s
.319 .473 .909 r
.53644 .58902 m .53821 .59295 L .55667 .56992 L p F P
0 0 0 r
s
.24 .35 .67 r
.53823 .59292 m
.53824 .59293 L
s
.319 .473 .909 r
.55917 .57582 m .55667 .56992 L .53821 .59295 L p F P
0 0 0 r
s
.288 .411 .737 r
.61976 .43689 m .62432 .45076 L .62825 .42733 L p F P
0 0 0 r
s
.288 .411 .737 r
.62825 .42733 m .62359 .41274 L .61976 .43689 L p F P
0 0 0 r
s
.564 .15 .065 r
.61926 .37606 m .59568 .38018 L .59346 .36216 L p F P
0 0 0 r
s
.83 .24 .1 r
.59425 .36202 m
.59426 .36259 L
s
.564 .15 .065 r
.59346 .36216 m .61648 .35808 L .61926 .37606 L p F P
0 0 0 r
s
.913 .264 .113 r
.45957 .57823 m .44921 .5798 L .43395 .55773 L p F P
0 0 0 r
s
.913 .264 .113 r
.42055 .5598 m .43395 .55773 L .44921 .5798 L p F P
0 0 0 r
s
.24 .35 .67 r
.42579 .57941 m
.43526 .59677 L
s
.881 .252 .108 r
.37222 .54157 m .3882 .53905 L .4072 .56186 L p F P
0 0 0 r
s
.944 .274 .118 r
.52218 .59113 m .51506 .59218 L .52235 .56875 L p F P
0 0 0 r
s
.83 .24 .1 r
.51491 .59118 m
.5154 .5911 L
s
.944 .274 .118 r
.51181 .57034 m .52235 .56875 L .51506 .59218 L p F P
0 0 0 r
s
.83 .24 .1 r
.63185 .5991 m
.67839 .59236 L
s
.63185 .5991 m
.62485 .57489 L
s
.24 .35 .67 r
.39611 .57234 m
.42579 .57941 L
s
.326 .471 .874 r
.60642 .50163 m .61042 .51279 L .62126 .48831 L p F P
0 0 0 r
s
.326 .471 .874 r
.62126 .48831 m .61699 .47579 L .60642 .50163 L p F P
0 0 0 r
s
.881 .252 .108 r
.42055 .5598 m .4072 .56186 L .3882 .53905 L p F P
0 0 0 r
s
.944 .274 .118 r
.5293 .59007 m .52218 .59113 L .53292 .56716 L p F P
0 0 0 r
s
.83 .24 .1 r
.52218 .5901 m
.52267 .59003 L
s
.944 .274 .118 r
.52235 .56875 m .53292 .56716 L .52218 .59113 L p F P
0 0 0 r
s
.83 .24 .1 r
.53231 .5886 m
.53265 .58958 L
s
.52947 .58902 m
.53231 .5886 L
s
.808 .228 .098 r
.40891 .50924 m .39051 .51221 L .37975 .48766 L p F P
0 0 0 r
s
.808 .228 .098 r
.37975 .48766 m .39994 .48433 L .40891 .50924 L p F P
0 0 0 r
s
.712 .196 .085 r
.48068 .44536 m .45875 .44905 L .45744 .42554 L p F P
0 0 0 r
s
.83 .24 .1 r
.45807 .42543 m
.45808 .42608 L
s
.712 .196 .085 r
.45744 .42554 m .48007 .42165 L .48068 .44536 L p F P
0 0 0 r
s
.846 .24 .104 r
.40425 .53651 m .3882 .53905 L .3722 .51517 L p F P
0 0 0 r
s
.846 .24 .104 r
.3722 .51517 m .39051 .51221 L .40425 .53651 L p F P
0 0 0 r
s
.913 .264 .113 r
.46996 .57666 m .45957 .57823 L .4474 .55566 L p F P
0 0 0 r
s
.913 .264 .113 r
.43395 .55773 m .4474 .55566 L .45957 .57823 L p F P
0 0 0 r
s
.83 .24 .1 r
.6414 .37334 m
.64025 .34987 L
s
.64025 .34987 m
.6869 .34158 L
s
.24 .35 .67 r
.61309 .36202 m
.61674 .37362 L
s
.648 .176 .076 r
.5488 .40984 m .52575 .4138 L .52584 .39238 L p F P
0 0 0 r
s
.648 .176 .076 r
.52584 .39238 m .54898 .38834 L .5488 .40984 L p F P
0 0 0 r
s
.83 .24 .1 r
.77753 .59729 m
.82504 .59053 L
s
.77753 .59729 m
.77319 .57863 L
s
.764 .213 .092 r
.44066 .4776 m .42024 .48097 L .41526 .45639 L p F P
0 0 0 r
s
.764 .213 .092 r
.41526 .45639 m .43694 .45273 L .44066 .4776 L p F P
0 0 0 r
s
.944 .274 .118 r
.53644 .58902 m .5293 .59007 L .54351 .56556 L p F P
0 0 0 r
s
.24 .35 .67 r
.53646 .58896 m
.53647 .58899 L
s
.944 .274 .118 r
.53292 .56716 m .54351 .56556 L .5293 .59007 L p F P
0 0 0 r
s
.24 .35 .67 r
.53432 .58421 m
.53499 .58571 L
s
.83 .24 .1 r
.53677 .58794 m
.53773 .5878 L
s
.881 .252 .108 r
.3882 .53905 m .40425 .53651 L .42055 .5598 L p F P
0 0 0 r
s
.24 .35 .67 r
.38121 .54613 m
.39611 .57234 L
s
.326 .48 .916 r
.58013 .56021 m .57703 .55245 L .55917 .57582 L p F P
0 0 0 r
s
.33 .484 .915 r
.57703 .55245 m .58013 .56021 L .59656 .53701 L p F P
0 0 0 r
s
.83 .24 .1 r
.77974 .30771 m
.78194 .32469 L
s
.247 .347 .604 r
.61882 .39781 m .62359 .41274 L .62404 .3913 L p F P
0 0 0 r
s
.24 .35 .67 r
.62265 .39304 m
.62269 .39249 L
s
.247 .347 .604 r
.62404 .3913 m .61926 .37606 L .61882 .39781 L p F P
0 0 0 r
s
.881 .252 .108 r
.43395 .55773 m .42055 .5598 L .40425 .53651 L p F P
0 0 0 r
s
.913 .264 .113 r
.48038 .57509 m .46996 .57666 L .4609 .55357 L p F P
0 0 0 r
s
.913 .264 .113 r
.4474 .55566 m .4609 .55357 L .46996 .57666 L p F P
0 0 0 r
s
.944 .274 .118 r
.54351 .56556 m .55414 .56395 L .53644 .58902 L p F P
0 0 0 r
s
.319 .473 .909 r
.55667 .56992 m .55414 .56395 L .53644 .58902 L p F P
0 0 0 r
s
.83 .24 .1 r
.54026 .58742 m
.5783 .58179 L
s
.33 .481 .902 r
.59296 .52746 m .59656 .53701 L .61042 .51279 L p F P
0 0 0 r
s
.33 .481 .902 r
.61042 .51279 m .60642 .50163 L .59296 .52746 L p F P
0 0 0 r
s
.24 .35 .67 r
.60547 .50223 m
.60573 .50296 L
s
.326 .48 .916 r
.55667 .56992 m .55917 .57582 L .57703 .55245 L p F P
0 0 0 r
s
.808 .228 .098 r
.42741 .50625 m .40891 .50924 L .39994 .48433 L p F P
0 0 0 r
s
.808 .228 .098 r
.39994 .48433 m .42024 .48097 L .42741 .50625 L p F P
0 0 0 r
s
.846 .24 .104 r
.42037 .53397 m .40425 .53651 L .39051 .51221 L p F P
0 0 0 r
s
.846 .24 .104 r
.39051 .51221 m .40891 .50924 L .42037 .53397 L p F P
0 0 0 r
s
.24 .35 .67 r
.28084 .30548 m
.26318 .27289 L
s
.28084 .30548 m
.26797 .33157 L
s
.33 .484 .915 r
.59656 .53701 m .59296 .52746 L .57703 .55245 L p F P
0 0 0 r
s
.913 .264 .113 r
.49083 .57351 m .48038 .57509 L .47445 .55148 L p F P
0 0 0 r
s
.913 .264 .113 r
.4609 .55357 m .47445 .55148 L .48038 .57509 L p F P
0 0 0 r
s
.712 .196 .085 r
.50275 .44164 m .48068 .44536 L .48007 .42165 L p F P
0 0 0 r
s
.712 .196 .085 r
.48007 .42165 m .50284 .41774 L .50275 .44164 L p F P
0 0 0 r
s
.881 .252 .108 r
.40425 .53651 m .42037 .53397 L .43395 .55773 L p F P
0 0 0 r
s
.881 .252 .108 r
.4474 .55566 m .43395 .55773 L .42037 .53397 L p F P
0 0 0 r
s
.24 .35 .67 r
.27914 .38877 m
.26143 .35813 L
s
.27914 .38877 m
.27966 .41457 L
s
.648 .176 .076 r
.572 .40585 m .5488 .40984 L .54898 .38834 L p F P
0 0 0 r
s
.648 .176 .076 r
.54898 .38834 m .57226 .38427 L .572 .40585 L p F P
0 0 0 r
s
.764 .213 .092 r
.46118 .47421 m .44066 .4776 L .43694 .45273 L p F P
0 0 0 r
s
.764 .213 .092 r
.43694 .45273 m .45875 .44905 L .46118 .47421 L p F P
0 0 0 r
s
.913 .264 .113 r
.5013 .57193 m .49083 .57351 L .48805 .54938 L p F P
0 0 0 r
s
.913 .264 .113 r
.47445 .55148 m .48805 .54938 L .49083 .57351 L p F P
0 0 0 r
s
.24 .35 .67 r
.53393 .21667 m
.5065 .20796 L
s
.5065 .20796 m
.49412 .17302 L
s
.36485 .19001 m
.39739 .17845 L
s
.33411 .20583 m
.36485 .19001 L
s
.881 .252 .108 r
.4609 .55357 m .4474 .55566 L .43656 .53141 L p F P
0 0 0 r
s
.881 .252 .108 r
.42037 .53397 m .43656 .53141 L .4474 .55566 L p F P
0 0 0 r
s
.83 .24 .1 r
.67839 .59236 m
.72549 .58554 L
s
.67839 .59236 m
.67199 .5679 L
s
.846 .24 .104 r
.43656 .53141 m .42037 .53397 L .40891 .50924 L p F P
0 0 0 r
s
.846 .24 .104 r
.40891 .50924 m .42741 .50625 L .43656 .53141 L p F P
0 0 0 r
s
.313 .45 .822 r
.61262 .463 m .61699 .47579 L .62432 .45076 L p F P
0 0 0 r
s
.313 .45 .822 r
.62432 .45076 m .61976 .43689 L .61262 .463 L p F P
0 0 0 r
s
.808 .228 .098 r
.44601 .50325 m .42741 .50625 L .42024 .48097 L p F P
0 0 0 r
s
.808 .228 .098 r
.42024 .48097 m .44066 .4776 L .44601 .50325 L p F P
0 0 0 r
s
.24 .35 .67 r
.58614 .28238 m
.56823 .26403 L
s
.56823 .26403 m
.5573 .23037 L
s
.913 .264 .113 r
.51181 .57034 m .5013 .57193 L .5017 .54728 L p F P
0 0 0 r
s
.913 .264 .113 r
.48805 .54938 m .5017 .54728 L .5013 .57193 L p F P
0 0 0 r
s
.24 .35 .67 r
.30624 .22537 m
.33411 .20583 L
s
.712 .196 .085 r
.52495 .43789 m .50275 .44164 L .50284 .41774 L p F P
0 0 0 r
s
.83 .24 .1 r
.5035 .41762 m
.50353 .41836 L
s
.712 .196 .085 r
.50284 .41774 m .52575 .4138 L .52495 .43789 L p F P
0 0 0 r
s
.83 .24 .1 r
.68875 .36507 m
.6869 .34158 L
s
.6869 .34158 m
.73412 .33319 L
s
.24 .35 .67 r
.39739 .17845 m
.43057 .17158 L
s
.83 .24 .1 r
.5783 .58179 m
.62485 .57489 L
s
.764 .213 .092 r
.48183 .47081 m .46118 .47421 L .45875 .44905 L p F P
0 0 0 r
s
.83 .24 .1 r
.45937 .44895 m
.45943 .4497 L
s
.764 .213 .092 r
.45875 .44905 m .48068 .44536 L .48183 .47081 L p F P
0 0 0 r
s
.648 .176 .076 r
.59534 .40184 m .572 .40585 L .57226 .38427 L p F P
0 0 0 r
s
.648 .176 .076 r
.57226 .38427 m .59568 .38018 L .59534 .40184 L p F P
0 0 0 r
s
.83 .24 .1 r
.82149 .57164 m
.82504 .59053 L
s
.881 .252 .108 r
.47445 .55148 m .4609 .55357 L .45283 .52884 L p F P
0 0 0 r
s
.881 .252 .108 r
.43656 .53141 m .45283 .52884 L .4609 .55357 L p F P
0 0 0 r
s
.913 .264 .113 r
.52235 .56875 m .51181 .57034 L .5154 .54516 L p F P
0 0 0 r
s
.913 .264 .113 r
.5017 .54728 m .5154 .54516 L .51181 .57034 L p F P
0 0 0 r
s
.24 .35 .67 r
.30434 .4676 m
.28714 .43869 L
s
.30434 .4676 m
.31863 .48881 L
s
.846 .24 .104 r
.45283 .52884 m .43656 .53141 L .42741 .50625 L p F P
0 0 0 r
s
.326 .48 .916 r
.55414 .56395 m .55667 .56992 L .57389 .54459 L p F P
0 0 0 r
s
.326 .48 .916 r
.57703 .55245 m .57389 .54459 L .55667 .56992 L p F P
0 0 0 r
s
.846 .24 .104 r
.42741 .50625 m .44601 .50325 L .45283 .52884 L p F P
0 0 0 r
s
.33 .484 .915 r
.57389 .54459 m .57703 .55245 L .59296 .52746 L p F P
0 0 0 r
s
.808 .228 .098 r
.46469 .50023 m .44601 .50325 L .44066 .4776 L p F P
0 0 0 r
s
.808 .228 .098 r
.44066 .4776 m .46118 .47421 L .46469 .50023 L p F P
0 0 0 r
s
.24 .35 .67 r
.42579 .57941 m
.41145 .55311 L
s
.42579 .57941 m
.45833 .58049 L
s
.913 .264 .113 r
.53292 .56716 m .52235 .56875 L .52915 .54304 L p F P
0 0 0 r
s
.24 .35 .67 r
.53339 .58215 m
.53432 .58421 L
s
.913 .264 .113 r
.5154 .54516 m .52915 .54304 L .52235 .56875 L p F P
0 0 0 r
s
.881 .252 .108 r
.48805 .54938 m .47445 .55148 L .46916 .52626 L p F P
0 0 0 r
s
.881 .252 .108 r
.45283 .52884 m .46916 .52626 L .47445 .55148 L p F P
0 0 0 r
s
.83 .24 .1 r
.6196 .37714 m
.6414 .37334 L
s
.712 .196 .085 r
.54729 .43413 m .52495 .43789 L .52575 .4138 L p F P
0 0 0 r
s
.712 .196 .085 r
.52575 .4138 m .5488 .40984 L .54729 .43413 L p F P
0 0 0 r
s
.764 .213 .092 r
.50259 .46738 m .48183 .47081 L .48068 .44536 L p F P
0 0 0 r
s
.764 .213 .092 r
.48068 .44536 m .50275 .44164 L .50259 .46738 L p F P
0 0 0 r
s
.326 .471 .874 r
.60236 .49026 m .60642 .50163 L .61699 .47579 L p F P
0 0 0 r
s
.24 .35 .67 r
.60547 .50223 m
.6062 .50101 L
s
.326 .471 .874 r
.61699 .47579 m .61262 .463 L .60236 .49026 L p F P
0 0 0 r
s
.846 .24 .104 r
.46916 .52626 m .45283 .52884 L .44601 .50325 L p F P
0 0 0 r
s
.648 .176 .076 r
.61882 .39781 m .59534 .40184 L .59568 .38018 L p F P
0 0 0 r
s
.648 .176 .076 r
.59568 .38018 m .61926 .37606 L .61882 .39781 L p F P
0 0 0 r
s
.24 .35 .67 r
.61674 .37362 m
.6176 .37635 L
s
.60804 .33677 m
.61309 .36202 L
s
.60804 .33677 m
.598 .30468 L
s
.28228 .24798 m
.30624 .22537 L
s
.288 .411 .737 r
.6151 .42269 m .61976 .43689 L .62359 .41274 L p F P
0 0 0 r
s
.288 .411 .737 r
.62359 .41274 m .61882 .39781 L .6151 .42269 L p F P
0 0 0 r
s
.913 .264 .113 r
.54351 .56556 m .53292 .56716 L .54295 .54091 L p F P
0 0 0 r
s
.913 .264 .113 r
.52915 .54304 m .54295 .54091 L .53292 .56716 L p F P
0 0 0 r
s
.24 .35 .67 r
.52537 .56431 m
.53339 .58215 L
s
.846 .24 .104 r
.44601 .50325 m .46469 .50023 L .46916 .52626 L p F P
0 0 0 r
s
.881 .252 .108 r
.5017 .54728 m .48805 .54938 L .48557 .52367 L p F P
0 0 0 r
s
.881 .252 .108 r
.46916 .52626 m .48557 .52367 L .48805 .54938 L p F P
0 0 0 r
s
.24 .35 .67 r
.35535 .5336 m
.3393 .50615 L
s
.35535 .5336 m
.38121 .54613 L
s
.43057 .17158 m
.46322 .16971 L
s
.808 .228 .098 r
.48347 .4972 m .46469 .50023 L .46118 .47421 L p F P
0 0 0 r
s
.83 .24 .1 r
.46508 .50023 m
.4697 .52618 L
s
.4647 .50029 m
.46508 .50023 L
s
.46172 .47413 m
.46182 .47487 L
s
.46507 .50017 m
.46508 .50023 L
s
.808 .228 .098 r
.46118 .47421 m .48183 .47081 L .48347 .4972 L p F P
0 0 0 r
s
.33 .484 .915 r
.59296 .52746 m .5893 .51776 L .57389 .54459 L p F P
0 0 0 r
s
.33 .481 .902 r
.5893 .51776 m .59296 .52746 L .60642 .50163 L p F P
0 0 0 r
s
.24 .35 .67 r
.60381 .50409 m
.60547 .50223 L
s
.83 .24 .1 r
.72549 .58554 m
.77319 .57863 L
s
.72549 .58554 m
.71972 .56083 L
s
.913 .264 .113 r
.55414 .56395 m .54351 .56556 L .55681 .53877 L p F P
0 0 0 r
s
.913 .264 .113 r
.54295 .54091 m .55681 .53877 L .54351 .56556 L p F P
0 0 0 r
s
.33 .481 .902 r
.60642 .50163 m .60236 .49026 L .5893 .51776 L p F P
0 0 0 r
s
.846 .24 .104 r
.48557 .52367 m .46916 .52626 L .46469 .50023 L p F P
0 0 0 r
s
.712 .196 .085 r
.56976 .43034 m .54729 .43413 L .5488 .40984 L p F P
0 0 0 r
s
.83 .24 .1 r
.54949 .40972 m
.54954 .41056 L
s
.712 .196 .085 r
.5488 .40984 m .572 .40585 L .56976 .43034 L p F P
0 0 0 r
s
.881 .252 .108 r
.5154 .54516 m .5017 .54728 L .50205 .52107 L p F P
0 0 0 r
s
.881 .252 .108 r
.48557 .52367 m .50205 .52107 L .5017 .54728 L p F P
0 0 0 r
s
.83 .24 .1 r
.7367 .3567 m
.73412 .33319 L
s
.73412 .33319 m
.78194 .32469 L
s
.764 .213 .092 r
.52346 .46393 m .50259 .46738 L .50275 .44164 L p F P
0 0 0 r
s
.83 .24 .1 r
.50511 .44124 m
.5054 .44448 L
s
.764 .213 .092 r
.50275 .44164 m .52495 .43789 L .52346 .46393 L p F P
0 0 0 r
s
.83 .24 .1 r
.62485 .57489 m
.67199 .5679 L
s
.62485 .57489 m
.61779 .54552 L
s
.846 .24 .104 r
.46469 .50023 m .48347 .4972 L .48557 .52367 L p F P
0 0 0 r
s
.326 .48 .916 r
.57389 .54459 m .57071 .53663 L .55414 .56395 L p F P
0 0 0 r
s
.83 .24 .1 r
.57081 .55267 m
.5783 .58179 L
s
.913 .264 .113 r
.55681 .53877 m .57071 .53663 L .55414 .56395 L p F P
0 0 0 r
s
.83 .24 .1 r
.56144 .5541 m
.57081 .55267 L
s
.24 .35 .67 r
.55639 .5478 m
.55862 .55315 L
s
.808 .228 .098 r
.50235 .49415 m .48347 .4972 L .48183 .47081 L p F P
0 0 0 r
s
.808 .228 .098 r
.48183 .47081 m .50259 .46738 L .50235 .49415 L p F P
0 0 0 r
s
.24 .35 .67 r
.26797 .33157 m
.2498 .29923 L
s
.26797 .33157 m
.26143 .35813 L
s
.846 .24 .104 r
.50205 .52107 m .48557 .52367 L .48347 .4972 L p F P
0 0 0 r
s
.881 .252 .108 r
.52915 .54304 m .5154 .54516 L .51861 .51846 L p F P
0 0 0 r
s
.881 .252 .108 r
.50205 .52107 m .51861 .51846 L .5154 .54516 L p F P
0 0 0 r
s
.33 .484 .915 r
.57071 .53663 m .57389 .54459 L .5893 .51776 L p F P
0 0 0 r
s
.83 .24 .1 r
.68875 .36507 m
.6414 .37334 L
s
.64398 .40217 m
.6414 .37334 L
s
.846 .24 .104 r
.48347 .4972 m .50235 .49415 L .50205 .52107 L p F P
0 0 0 r
s
.712 .196 .085 r
.59236 .42653 m .56976 .43034 L .572 .40585 L p F P
0 0 0 r
s
.712 .196 .085 r
.572 .40585 m .59534 .40184 L .59236 .42653 L p F P
0 0 0 r
s
.764 .213 .092 r
.54446 .46046 m .52346 .46393 L .52495 .43789 L p F P
0 0 0 r
s
.764 .213 .092 r
.52495 .43789 m .54729 .43413 L .54446 .46046 L p F P
0 0 0 r
s
.24 .35 .67 r
.45833 .58049 m
.44466 .55402 L
s
.45833 .58049 m
.49211 .57539 L
s
.5573 .23037 m
.53393 .21667 L
s
.53393 .21667 m
.52206 .18153 L
s
.881 .252 .108 r
.54295 .54091 m .52915 .54304 L .53524 .51583 L p F P
0 0 0 r
s
.881 .252 .108 r
.51861 .51846 m .53524 .51583 L .52915 .54304 L p F P
0 0 0 r
s
.313 .45 .822 r
.60816 .44995 m .61262 .463 L .61976 .43689 L p F P
0 0 0 r
s
.313 .45 .822 r
.61976 .43689 m .6151 .42269 L .60816 .44995 L p F P
0 0 0 r
s
.846 .24 .104 r
.51861 .51846 m .50205 .52107 L .50235 .49415 L p F P
0 0 0 r
s
.808 .228 .098 r
.52133 .49108 m .50235 .49415 L .50259 .46738 L p F P
0 0 0 r
s
.83 .24 .1 r
.50769 .46654 m
.50885 .4753 L
s
.808 .228 .098 r
.50259 .46738 m .52346 .46393 L .52133 .49108 L p F P
0 0 0 r
s
.83 .24 .1 r
.57081 .55267 m
.61779 .54552 L
s
.56913 .54476 m
.57081 .55267 L
s
.56883 .54333 m
.56913 .54476 L
s
.24 .35 .67 r
.26318 .27289 m
.28228 .24798 L
s
.55639 .5478 m
.56419 .54175 L
s
.27966 .41457 m
.26172 .38411 L
s
.27966 .41457 m
.28714 .43869 L
s
.83 .24 .1 r
.77319 .57863 m
.82149 .57164 L
s
.77319 .57863 m
.76805 .55367 L
s
.846 .24 .104 r
.50235 .49415 m .52133 .49108 L .51861 .51846 L p F P
0 0 0 r
s
.881 .252 .108 r
.55681 .53877 m .54295 .54091 L .55194 .5132 L p F P
0 0 0 r
s
.881 .252 .108 r
.53524 .51583 m .55194 .5132 L .54295 .54091 L p F P
0 0 0 r
s
.24 .35 .67 r
.46322 .16971 m
.49412 .17302 L
s
.712 .196 .085 r
.6151 .42269 m .59236 .42653 L .59534 .40184 L p F P
0 0 0 r
s
.83 .24 .1 r
.59606 .40172 m
.59613 .40268 L
s
.712 .196 .085 r
.59534 .40184 m .61882 .39781 L .6151 .42269 L p F P
0 0 0 r
s
.24 .35 .67 r
.61094 .38925 m
.6161 .4052 L
s
.6161 .4052 m
.61637 .40605 L
s
.764 .213 .092 r
.56557 .45698 m .54446 .46046 L .54729 .43413 L p F P
0 0 0 r
s
.764 .213 .092 r
.54729 .43413 m .56976 .43034 L .56557 .45698 L p F P
0 0 0 r
s
.846 .24 .104 r
.53524 .51583 m .51861 .51846 L .52133 .49108 L p F P
0 0 0 r
s
.83 .24 .1 r
.78194 .32469 m
.78526 .34823 L
s
.67199 .5679 m
.71972 .56083 L
s
.67199 .5679 m
.66537 .53828 L
s
.24 .35 .67 r
.598 .30468 m
.58614 .28238 L
s
.58614 .28238 m
.57548 .24869 L
s
.33 .484 .915 r
.5893 .51776 m .58558 .50788 L .57071 .53663 L p F P
0 0 0 r
s
.33 .481 .902 r
.58558 .50788 m .5893 .51776 L .60236 .49026 L p F P
0 0 0 r
s
.808 .228 .098 r
.5404 .488 m .52133 .49108 L .52346 .46393 L p F P
0 0 0 r
s
.808 .228 .098 r
.52346 .46393 m .54446 .46046 L .5404 .488 L p F P
0 0 0 r
s
.881 .252 .108 r
.57071 .53663 m .55681 .53877 L .56872 .51055 L p F P
0 0 0 r
s
.881 .252 .108 r
.55194 .5132 m .56872 .51055 L .55681 .53877 L p F P
0 0 0 r
s
.326 .471 .874 r
.59821 .47867 m .60236 .49026 L .61262 .463 L p F P
0 0 0 r
s
.326 .471 .874 r
.61262 .463 m .60816 .44995 L .59821 .47867 L p F P
0 0 0 r
s
.83 .24 .1 r
.61921 .4064 m
.64398 .40217 L
s
.61788 .40663 m
.61921 .4064 L
s
.24 .35 .67 r
.49211 .57539 m
.47918 .54868 L
s
.49211 .57539 m
.52537 .56431 L
s
.846 .24 .104 r
.52133 .49108 m .5404 .488 L .53524 .51583 L p F P
0 0 0 r
s
.24 .35 .67 r
.52537 .56431 m
.55639 .5478 L
s
.545 .52041 m
.55639 .5478 L
s
.846 .24 .104 r
.55194 .5132 m .53524 .51583 L .5404 .488 L p F P
0 0 0 r
s
.33 .481 .902 r
.60236 .49026 m .59821 .47867 L .58558 .50788 L p F P
0 0 0 r
s
.24 .35 .67 r
.31863 .48881 m
.30154 .45999 L
s
.31863 .48881 m
.3393 .50615 L
s
.83 .24 .1 r
.7367 .3567 m
.68875 .36507 L
s
.6919 .394 m
.68875 .36507 L
s
.764 .213 .092 r
.58681 .45347 m .56557 .45698 L .56976 .43034 L p F P
0 0 0 r
s
.764 .213 .092 r
.56976 .43034 m .59236 .42653 L .58681 .45347 L p F P
0 0 0 r
s
.881 .252 .108 r
.56872 .51055 m .58558 .50788 L .57071 .53663 L p F P
0 0 0 r
s
.24 .35 .67 r
.52537 .56431 m
.51322 .53729 L
s
.808 .228 .098 r
.55957 .48491 m .5404 .488 L .54446 .46046 L p F P
0 0 0 r
s
.808 .228 .098 r
.54446 .46046 m .56557 .45698 L .55957 .48491 L p F P
0 0 0 r
s
.24 .35 .67 r
.38121 .54613 m
.3656 .51866 L
s
.38121 .54613 m
.41145 .55311 L
s
.83 .24 .1 r
.58331 .51684 m
.61108 .51249 L
s
.5818 .51708 m
.58331 .51684 L
s
.61779 .54552 m
.66537 .53828 L
s
.61779 .54552 m
.61108 .51249 L
s
.846 .24 .104 r
.5404 .488 m .55957 .48491 L .55194 .5132 L p F P
0 0 0 r
s
.846 .24 .104 r
.56872 .51055 m .55194 .5132 L .55957 .48491 L p F P
0 0 0 r
s
.24 .35 .67 r
.60302 .33009 m
.61309 .36202 L
s
.61094 .38925 m
.61309 .36202 L
s
.83 .24 .1 r
.817 .54642 m
.82149 .57164 L
s
.764 .213 .092 r
.60816 .44995 m .58681 .45347 L .59236 .42653 L p F P
0 0 0 r
s
.764 .213 .092 r
.59236 .42653 m .6151 .42269 L .60816 .44995 L p F P
0 0 0 r
s
.24 .35 .67 r
.60143 .41721 m
.6093 .4405 L
s
.808 .228 .098 r
.57884 .48179 m .55957 .48491 L .56557 .45698 L p F P
0 0 0 r
s
.808 .228 .098 r
.56557 .45698 m .58681 .45347 L .57884 .48179 L p F P
0 0 0 r
s
.83 .24 .1 r
.71972 .56083 m
.76805 .55367 L
s
.71972 .56083 m
.71356 .53094 L
s
.846 .24 .104 r
.58558 .50788 m .56872 .51055 L .57884 .48179 L p F P
0 0 0 r
s
.24 .35 .67 r
.57918 .51539 m
.57952 .51628 L
s
.846 .24 .104 r
.55957 .48491 m .57884 .48179 L .56872 .51055 L p F P
0 0 0 r
s
.24 .35 .67 r
.2498 .29923 m
.26318 .27289 L
s
.83 .24 .1 r
.6479 .43495 m
.64398 .40217 L
s
.64398 .40217 m
.6919 .394 L
s
.24 .35 .67 r
.26143 .35813 m
.24286 .32601 L
s
.26143 .35813 m
.26172 .38411 L
s
.83 .24 .1 r
.61364 .44064 m
.6479 .43495 L
s
.6109 .4411 m
.61364 .44064 L
s
.78526 .34823 m
.7367 .3567 L
s
.74043 .38571 m
.7367 .3567 L
s
.846 .24 .104 r
.57884 .48179 m .59821 .47867 L .58558 .50788 L p F P
0 0 0 r
s
.24 .35 .67 r
.57285 .49894 m
.57918 .51539 L
s
.49412 .17302 m
.52206 .18153 L
s
.808 .228 .098 r
.59821 .47867 m .57884 .48179 L .58681 .45347 L p F P
0 0 0 r
s
.808 .228 .098 r
.58681 .45347 m .60816 .44995 L .59821 .47867 L p F P
0 0 0 r
s
.24 .35 .67 r
.59537 .47407 m
.6007 .46519 L
s
.59537 .47407 m
.59663 .47758 L
s
.59663 .47758 m
.59668 .47772 L
s
.83 .24 .1 r
.6035 .46622 m
.60511 .47761 L
s
.59907 .47859 m
.60511 .47761 L
s
.24 .35 .67 r
.57548 .24869 m
.5573 .23037 L
s
.5573 .23037 m
.54583 .19509 L
s
.83 .24 .1 r
.61108 .51249 m
.65891 .50499 L
s
.60511 .47761 m
.61108 .51249 L
s
.66537 .53828 m
.71356 .53094 L
s
.66537 .53828 m
.65891 .50499 L
s
.60511 .47761 m
.65297 .46988 L
s
.24 .35 .67 r
.28714 .43869 m
.26912 .40837 L
s
.28714 .43869 m
.30154 .45999 L
s
.83 .24 .1 r
.76805 .55367 m
.817 .54642 L
s
.76805 .55367 m
.76236 .52352 L
s
.24 .35 .67 r
.41145 .55311 m
.39642 .52553 L
s
.41145 .55311 m
.44466 .55402 L
s
.83 .24 .1 r
.6962 .42692 m
.6919 .394 L
s
.6919 .394 m
.74043 .38571 L
s
.24 .35 .67 r
.60302 .33009 m
.598 .30468 L
s
.598 .30468 m
.58747 .27104 L
s
.57285 .49894 m
.59537 .47407 L
s
.59537 .47407 m
.58478 .44453 L
s
.83 .24 .1 r
.65297 .46988 m
.6479 .43495 L
s
.6479 .43495 m
.6962 .42692 L
s
.78526 .34823 m
.78958 .37733 L
s
.24 .35 .67 r
.3393 .50615 m
.32248 .47737 L
s
.3393 .50615 m
.3656 .51866 L
s
.83 .24 .1 r
.65891 .50499 m
.70735 .4974 L
s
.65891 .50499 m
.65297 .46988 L
s
.71356 .53094 m
.76236 .52352 L
s
.71356 .53094 m
.70735 .4974 L
s
.24 .35 .67 r
.60143 .41721 m
.61094 .38925 L
s
.61094 .38925 m
.60069 .35756 L
s
.83 .24 .1 r
.65297 .46988 m
.70145 .46205 L
s
.24 .35 .67 r
.24286 .32601 m
.2498 .29923 L
s
.83 .24 .1 r
.81178 .51599 m
.817 .54642 L
s
.74513 .41879 m
.74043 .38571 L
s
.74043 .38571 m
.78958 .37733 L
s
.24 .35 .67 r
.44466 .55402 m
.43032 .52626 L
s
.44466 .55402 m
.47918 .54868 L
s
.52206 .18153 m
.54583 .19509 L
s
.83 .24 .1 r
.70145 .46205 m
.6962 .42692 L
s
.6962 .42692 m
.74513 .41879 L
s
.24 .35 .67 r
.545 .52041 m
.57285 .49894 L
s
.57285 .49894 m
.56163 .46981 L
s
.26172 .38411 m
.24289 .35217 L
s
.26172 .38411 m
.26912 .40837 L
s
.83 .24 .1 r
.70735 .4974 m
.75641 .48971 L
s
.70735 .4974 m
.70145 .46205 L
s
.76236 .52352 m
.81178 .51599 L
s
.76236 .52352 m
.75641 .48971 L
s
.24 .35 .67 r
.58747 .27104 m
.57548 .24869 L
s
.57548 .24869 m
.56429 .21335 L
s
.83 .24 .1 r
.70145 .46205 m
.75056 .45412 L
s
.24 .35 .67 r
.47918 .54868 m
.46562 .52065 L
s
.47918 .54868 m
.51322 .53729 L
s
.51322 .53729 m
.545 .52041 L
s
.545 .52041 m
.53305 .49167 L
s
.30154 .45999 m
.2836 .42976 L
s
.30154 .45999 m
.32248 .47737 L
s
.83 .24 .1 r
.78958 .37733 m
.79468 .41055 L
s
.24 .35 .67 r
.51322 .53729 m
.50048 .50893 L
s
.3656 .51866 m
.34922 .48984 L
s
.3656 .51866 m
.39642 .52553 L
s
.83 .24 .1 r
.75056 .45412 m
.74513 .41879 L
s
.74513 .41879 m
.79468 .41055 L
s
.24 .35 .67 r
.59247 .29659 m
.60302 .33009 L
s
.60069 .35756 m
.60302 .33009 L
s
.58478 .44453 m
.60143 .41721 L
s
.60143 .41721 m
.59083 .38583 L
s
.83 .24 .1 r
.75641 .48971 m
.80611 .48192 L
s
.75641 .48971 m
.75056 .45412 L
s
.80611 .48192 m
.81178 .51599 L
s
.75056 .45412 m
.8003 .44609 L
s
.24 .35 .67 r
.24289 .35217 m
.24286 .32601 L
s
.54583 .19509 m
.56429 .21335 L
s
.83 .24 .1 r
.79468 .41055 m
.8003 .44609 L
s
.8003 .44609 m
.80611 .48192 L
s
.24 .35 .67 r
.26912 .40837 m
.25019 .37655 L
s
.26912 .40837 m
.2836 .42976 L
s
.39642 .52553 m
.38063 .49659 L
s
.39642 .52553 m
.43032 .52626 L
s
.59247 .29659 m
.58747 .27104 L
s
.58747 .27104 m
.57642 .23572 L
s
.56163 .46981 m
.58478 .44453 L
s
.58478 .44453 m
.57366 .41353 L
s
.32248 .47737 m
.30482 .44716 L
s
.32248 .47737 m
.34922 .48984 L
s
.59083 .38583 m
.60069 .35756 L
s
.60069 .35756 m
.58994 .32428 L
s
.43032 .52626 m
.41526 .4971 L
s
.43032 .52626 m
.46562 .52065 L
s
.53305 .49167 m
.56163 .46981 L
s
.56163 .46981 m
.54984 .43921 L
s
.25019 .37655 m
.24289 .35217 L
s
.56429 .21335 m
.57642 .23572 L
s
.46562 .52065 m
.45138 .49122 L
s
.46562 .52065 m
.50048 .50893 L
s
.50048 .50893 m
.53305 .49167 L
s
.53305 .49167 m
.52049 .46149 L
s
.2836 .42976 m
.26476 .39801 L
s
.2836 .42976 m
.30482 .44716 L
s
.50048 .50893 m
.48709 .47914 L
s
.34922 .48984 m
.33201 .45956 L
s
.34922 .48984 m
.38063 .49659 L
s
.58138 .2614 m
.59247 .29659 L
s
.58994 .32428 m
.59247 .29659 L
s
.57366 .41353 m
.59083 .38583 L
s
.59083 .38583 m
.57969 .35287 L
s
.26476 .39801 m
.25019 .37655 L
s
.38063 .49659 m
.36405 .46617 L
s
.38063 .49659 m
.41526 .4971 L
s
.57642 .23572 m
.58138 .2614 L
s
.54984 .43921 m
.57366 .41353 L
s
.57366 .41353 m
.56197 .38094 L
s
.30482 .44716 m
.28625 .4154 L
s
.30482 .44716 m
.33201 .45956 L
s
.57969 .35287 m
.58994 .32428 L
s
.58994 .32428 m
.57863 .28931 L
s
.41526 .4971 m
.39944 .46646 L
s
.41526 .4971 m
.45138 .49122 L
s
.52049 .46149 m
.54984 .43921 L
s
.54984 .43921 m
.53746 .40704 L
s
.45138 .49122 m
.4364 .46026 L
s
.45138 .49122 m
.48709 .47914 L
s
.48709 .47914 m
.52049 .46149 L
s
.52049 .46149 m
.50729 .42975 L
s
.28625 .4154 m
.26476 .39801 L
s
.48709 .47914 m
.473 .44782 L
s
.33201 .45956 m
.31391 .42772 L
s
.33201 .45956 m
.36405 .46617 L
s
.58138 .2614 m
.57863 .28931 L
s
.56197 .38094 m
.57969 .35287 L
s
.57969 .35287 m
.56798 .3182 L
s
.36405 .46617 m
.34659 .43416 L
s
.36405 .46617 m
.39944 .46646 L
s
.53746 .40704 m
.56197 .38094 L
s
.56197 .38094 m
.54967 .34665 L
s
.31391 .42772 m
.28625 .4154 L
s
.57863 .28931 m
.56798 .3182 L
s
.39944 .46646 m
.38277 .43419 L
s
.39944 .46646 m
.4364 .46026 L
s
.50729 .42975 m
.53746 .40704 L
s
.53746 .40704 m
.52441 .37317 L
s
.4364 .46026 m
.42063 .42767 L
s
.4364 .46026 m
.473 .44782 L
s
.473 .44782 m
.50729 .42975 L
s
.50729 .42975 m
.49339 .39633 L
s
.473 .44782 m
.45817 .41483 L
s
.34659 .43416 m
.31391 .42772 L
s
.56798 .3182 m
.54967 .34665 L
s
.38277 .43419 m
.34659 .43416 L
s
.54967 .34665 m
.52441 .37317 L
s
.42063 .42767 m
.38277 .43419 L
s
.52441 .37317 m
.49339 .39633 L
s
.45817 .41483 m
.42063 .42767 L
s
.49339 .39633 m
.45817 .41483 L
s
0 0 0 r
.25 Mabswid
.08947 .22236 m
.75972 .08168 L
s
.75972 .08168 m
.80207 .35868 L
s
.80207 .35868 m
.02925 .49223 L
s
.02925 .49223 m
.08947 .22236 L
s
.83139 .50547 m
.75972 .08168 L
s
.75972 .08168 m
.80207 .35868 L
s
.80207 .35868 m
.86955 .74993 L
s
.86955 .74993 m
.83139 .50547 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{500, 500},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40007d0001m2000`400?l00000o`00003oo`3ooooe
0?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3o
m^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40
oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?of
k_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3o
ool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^
m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?oo
o`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd
0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo
003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0
ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool0
0?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03o
m^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofkWX0ooK^0`00001g0?ofkP40oooo003o0?ofkWD0
ooK^1@0000020?ofkP030000003om^h0ooK^07D0ooK^0@3oool00?l0ooK^L@3om^h4000000L0ooK^
00<000000?ofkP3om^h0M@3om^h10?ooo`00o`3om^i/0?ofkPD000002`3om^h00`000000ooK^0?of
kP1e0?ofkP40oooo003o0?ofkVL0ooK^1@00000A0?ofkP030000003om^h0ooK^07@0ooK^0@3oool0
0?l0ooK^HP3om^h5000001H0ooK^00<000000?ofkP3om^h0M03om^h10?ooo`00o`3om^iM0?ofkPD0
00006`3om^h00`000000ooK^0?ofkP1d0?ofkP40oooo003o0?ofkUT0ooK^1000000P0?ofkP030000
003om^h0ooK^07@0ooK^0@3oool00?l0ooK^E03om^h5000002@0ooK^00<000000?ofkP3om^h0M03o
m^h10?ooo`00o`3om^i?0?ofkPD00000:@3om^h00`000000ooK^0?ofkP1d0?ofkP40oooo003o0?of
kTX0ooK^1@00000_0?ofkP030000003om^h0ooK^07<0ooK^0@3oool00?l0ooK^A@3om^h5000003@0
ooK^00<000000?ofkP3om^h0L`3om^h10?ooo`00o`3om^i10?ofkP@00000>@3om^h00`000000ooK^
0?ofkP1c0?ofkP40oooo003o0?ofkS`0ooK^1@00000m0?ofkP030000003om^h0ooK^07<0ooK^0@3o
ool00?l0ooK^=`3om^h500000480ooK^00<000000?ofkP3om^h0L`3om^h10?ooo`00o`3om^hb0?of
kPD00000A`3om^h00`000000ooK^0?ofkP1c0?ofkP40oooo003o0?ofkRh0ooK^1000001<0?ofkP80
0000M03om^h10?ooo`00o`3om^hY0?ofkPD00000D@3om^h00`000000ooK^0?ofkP1b0?ofkP40oooo
003o0?ofkR@0ooK^1@00001F0?ofkP030000003om^h0ooK^0780ooK^0@3oool00?l0ooK^7`3om^h5
000005/0ooK^00<000000?ofkP3om^h0LP3om^h10?ooo`00o`3om^hJ0?ofkPD00000H03om^h00`00
0000ooK^0?ofkP1b0?ofkP40oooo003o0?ofkQH0ooK^1000001U0?ofkP030000003om^h0ooK^0780
ooK^0@3oool00?l0ooK^4@3om^h5000006T0ooK^0P00001c0?ofkP40oooo003o0?ofkP`0ooK^1@00
001^0?ofkP800000L`3om^h10?ooo`00o`3om^h70?ofkPD00000M03om^h00`000000ooK^0?ofkP1a
0?ofkP40oooo003o0?ofkP80ooK^1@00001i0?ofkP030000003om^h0ooK^0740ooK^0@3oool00?d0
ooK^1000001n0?ofkP030000003om^h0ooK^0740ooK^0@3oool00?P0ooK^1@0000220?ofkP030000
003om^h0ooK^0740ooK^0@3oool00?<0ooK^1@0000270?ofkP800000LP3om^h10?ooo`00kP3om^h5
000008`0ooK^0P00001b0?ofkP40oooo003Z0?ofkP@00000TP3om^h00`000000ooK^0?ofkP1`0?of
kP40oooo003U0?ofkPD00000UP3om^h00`000000ooK^0?ofkP1`0?ofkP40oooo003P0?ofkPD00000
V`3om^h00`000000ooK^0?ofkP1`0?ofkP40oooo003K0?ofkPD00000X03om^h00`000000ooK^0?of
kP1`0?ofkP40oooo003F0?ofkPD00000Y@3om^h200000740ooK^0@3oool00=80ooK^1000002Z0?of
kP800000L@3om^h10?ooo`00c@3om^h500000:h0ooK^0P00001a0?ofkP40oooo00380?ofkPD00000
]03om^h00`000000ooK^0?ofkP1_0?ofkP40oooo00330?ofkPD00000^@3om^h00`000000ooK^0?of
kP1_0?ofkP40oooo002n0?ofkPD00000_P3om^h00`000000ooK^0?ofkP1_0?ofkP40oooo002j0?of
kP@00000``3om^h200000700ooK^0@3oool00;D0ooK^1@0000370?ofkP800000L03om^h10?ooo`00
/03om^h500000<`0ooK^0P00001`0?ofkP40oooo002[0?ofkPD00000dP3om^h00`000000ooK^0?of
kP1^0?ofkP40oooo002W0?ofkP@00000=03om^h<03eIZiL0ooK^00<000000?ofkP3om^h0KP3om^h1
0?ooo`00XP3om^h5000002h0ooK^2P0mFJ/80?ofkP0403eIZ`3om^h0ooK^0?ofkPP0?EV[S`3om^h0
0`000000ooK^0?ofkP1^0?ofkP40oooo002M0?ofkPD00000;`3om^h403eIZ`030?ofkP0mFJ/0ooK^
0100ooK^00<0?EV[0?ofkP3om^h0203om^h503eIZhX0ooK^0P00001_0?ofkP40oooo002H0?ofkPD0
0000<03om^h403eIZ`H0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP03
03eIZ`3om^h0?EV[00<0?EV[QP3om^h2000006l0ooK^0@3oool009<0ooK^1@00000a0?ofkP@0?EV[
2P3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h0
0P3om^h303eIZh<0ooK^0P00001_0?ofkP40oooo002?0?ofkP@00000<P3om^h403eIZ`l0ooK^00<0
?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00D0ooK^100m
FJ]o0?ofkP800000K`3om^h10?ooo`00RP3om^h5000003<0ooK^0`0mFJ/00`3om^h0?EV[0?ofkP0@
0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP09
0?ofkP80?EV[OP3om^h00`000000ooK^0?ofkP1]0?ofkP40oooo00250?ofkPD00000=@3om^h303eI
Z`D0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^
00`0ooK^00<0?EV[0?ofkP3om^h02@3om^h303eIZg`0ooK^00<000000?ofkP3om^h0K@3om^h10?oo
o`00P03om^h5000003H0ooK^100mFJ/80?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3o
m^h03P3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00X0ooK^00@0?EV[0?ofkP0m
FJ/0?EV[NP3om^h2000006h0ooK^0@3oool007/0ooK^1@00000h0?ofkP<0?EV[3@3om^h00`0mFJ/0
ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0
ooK^0?ofkP0:0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/0N@3om^h2000006h0ooK^0@3oool007L0
ooK^1000000k0?ofkP80?EV[403om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00h0
ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^0080
ooK^0P0mFJ]g0?ofkP800000KP3om^h10?ooo`00LP3om^h5000003d0ooK^0`0mFJ/A0?ofkP0303eI
Z`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eI
Z`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h00`3om^h203eIZgD0ooK^0P00001^0?ofkP40oooo
001]0?ofkPD00000@03om^h203eIZ`<0ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?of
kP0?0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?of
kP090?ofkP0303eIZ`3om^h0ooK^00D0ooK^0P0mFJ]d0?ofkP030000003om^h0ooK^06`0ooK^0@3o
ool006P0ooK^1@0000130?ofkP80?EV[1@3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0
ooK^00l0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0
ooK^00T0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP1a0?ofkP030000003om^h0
ooK^06`0ooK^0@3oool006@0ooK^100000160?ofkP80?EV[203om^h00`0mFJ/0ooK^0?ofkP0?0?of
kP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0;0?of
kP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h01P3om^h203eIZg80ooK^0P00001]0?of
kP40oooo001O0?ofkPD00000B03om^h203eIZ`X0ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0
ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0
ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^00L0ooK^0P0mFJ]a0?ofkP800000K@3om^h10?ooo`00
FP3om^h5000004/0ooK^0P0mFJ/<0?ofkP0303eIZ`3om^h0ooK^0100ooK^00<0?EV[0?ofkP3om^h0
3P3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h0
2@3om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0?EV[0700ooK^0P00001]0?ofkP40oooo
001E0?ofkPD00000CP3om^h203eIZ`l0ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?of
kP0?0?ofkP0303eIZ`3om^h0ooK^00H0ooK^2`0mFJ/:0?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0
?EV[0?ofkP3om^h01P3om^h0100mFJ/0ooK^0?ofkP0mFJ]_0?ofkP800000K@3om^h10?ooo`00D03o
m^h500000540ooK^0P0mFJ/A0?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h03P3o
m^h:03eIZ`L0ooK^00@0?EV[0?ofkP3om^h0ooK^200mFJ/30?ofkP0303eIZ`3om^h0ooK^00T0ooK^
00<0?EV[0?ofkP3om^h01`3om^h0100mFJ/0ooK^0?ofkP0mFJ]^0?ofkP800000K@3om^h10?ooo`00
C03om^h4000005@0ooK^0`0mFJ/C0?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h0
2@3om^h403eIZ`030?ofkP0mFJ/0ooK^00l0ooK^00<0?EV[0?ofkP3om^h0203om^h503eIZ`X0ooK^
00<0?EV[0?ofkP3om^h01`3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[06h0ooK^00<000000?ofkP3o
m^h0J`3om^h10?ooo`00A`3om^h5000005L0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0B0?ofkP03
03eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h01@3om^h403eIZ`H0ooK^00<0?EV[0?ofkP3o
m^h03@3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0?EV[0080?EV[203om^h00`0mFJ/0
ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h0J`3om^h2000006`0
ooK^0@3oool00480ooK^1@00001K0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h0
4@3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00@0?EV[2P3om^h00`0mFJ/0ooK^
0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00@0?EV[0?ofkP3om^h0ooK^0P0mFJ/60?ofkP03
03eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP1Z0?ofkP80
0000K03om^h10?ooo`00?@3om^h5000005h0ooK^0P0mFJ/60?ofkP0303eIZ`3om^h0ooK^0100ooK^
00<0?EV[0?ofkP3om^h03P3om^h403eIZ`l0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^
0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00<0ooK^0`0mFJ/30?ofkP0303eIZ`3om^h0ooK^00L0ooK^
00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP1Y0?ofkP800000K03om^h10?ooo`00>03o
m^h500000680ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0303eIZ`3o
m^h0ooK^00/0ooK^0`0mFJ/00`3om^h0?EV[0?ofkP0@0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0
?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP060?ofkP<0?EV[00<0ooK^03eIZ`3om^h0203o
m^h00`0mFJ/0ooK^0?ofkP020?ofkP80?EV[JP3om^h2000006`0ooK^0@3oool003@0ooK^1000001U
0?ofkP80?EV[2P3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0303eIZ`3om^h0ooK^00L0ooK^0`0mFJ/5
0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0<
0?ofkP0303eIZ`3om^h0ooK^00P0ooK^0P0mFJ/90?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[
0?ofkP3om^h0J03om^h2000006`0ooK^0@3oool002l0ooK^1@00001X0?ofkP0303eIZ`3om^h0ooK^
00X0ooK^00<0?EV[0?ofkP3om^h0403om^h00`0mFJ/0ooK^0?ofkP030?ofkP@0?EV[203om^h00`0m
FJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0m
FJ/0ooK^0?ofkP090?ofkP<0?EV[1`3om^h00`0mFJ/0ooK^0?ofkP030?ofkP80?EV[J@3om^h20000
06`0ooK^0@3oool002`0ooK^0`00001/0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3o
m^h0403om^h00`0mFJ/0ooK^03eIZ`0203eIZ`d0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0
ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h02P3om^h0100mFJ/0
ooK^03eIZ`0mFJ/60?ofkP0303eIZ`3om^h0ooK^0080ooK^0P0mFJ]Z0?ofkP800000J`3om^h10?oo
o`00;03om^h2000006/0ooK^0P0mFJ/?0?ofkP0303eIZ`3om^h0ooK^0100ooK^0P0mFJ/@0?ofkP03
03eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP03
03eIZ`3om^h0ooK^00T0ooK^00@0?EV[0?ofkP3om^h0ooK^0P0mFJ/40?ofkP0303eIZ`3om^h0ooK^
00<0ooK^0P0mFJ]Y0?ofkP800000J`3om^h10?ooo`00;03om^h2000006X0ooK^00<0?EV[0?ofkP3o
m^h0403om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP<0?EV[4P3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP03
03eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP090?ofkP03
03eIZ`3om^h0ooK^00<0ooK^0P0mFJ/20?ofkP0303eIZ`3om^h0ooK^00<0ooK^0P0mFJ]Y0?ofkP80
0000J`3om^h10?ooo`00:`3om^h010000000ooK^0?ofkP00001X0?ofkP0303eIZ`3om^h0?EV[0140
ooK^00<0?EV[0?ofkP3om^h02`3om^h203eIZ`<0ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0
ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0
ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^00@0ooK^0P0mFJ/00`3om^h0?EV[0?ofkP030?ofkP03
03eIZ`3om^h0?EV[06P0ooK^0P00001[0?ofkP40oooo000[0?ofkP050000003om^h0ooK^0?ofkP00
0000IP3om^h0100mFJ/0ooK^0?ofkP0mFJ/B0?ofkP0303eIZ`3om^h0ooK^00P0ooK^0P0mFJ/50?of
kP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP0=0?of
kP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP060?of
kP80?EV[1@3om^h203eIZfP0ooK^0P00001[0?ofkP40oooo000[0?ofkP050000003om^h0ooK^0?of
kP000000I@3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?of
kP3om^h01P3om^h203eIZ`P0ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP0>0?of
kP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP0:0?of
kP0303eIZ`3om^h0ooK^00H0ooK^0P0mFJ/40?ofkP0303eIZ`3om^h0?EV[06L0ooK^0P00001[0?of
kP40oooo000[0?ofkP030000003om^h0ooK^0080ooK^00<000000?ofkP3om^h0H@3om^h00`0mFJ/0
ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^0100ooK^00<0?EV[0?ofkP3om^h00`3om^h203eIZ`X0
ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00`0
ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^00L0
ooK^0P0mFJ/30?ofkP0303eIZ`3om^h0?EV[06P0ooK^0P00001Z0?ofkP40oooo000Z0?ofkP030000
003om^h0ooK^00<0ooK^00<000000?ofkP3om^h0H03om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eI
Z`3om^h0ooK^00l0ooK^00@0?EV[0?ofkP3om^h0ooK^0P0mFJ/=0?ofkP0303eIZ`3om^h0ooK^00l0
ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00/0
ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0?EV[00<0
ooK^00<0?EV[0?ofkP0mFJ/0I`3om^h2000006X0ooK^0@3oool002X0ooK^00<000000?ofkP3om^h0
103om^h00`000000ooK^0?ofkP1M0?ofkP80?EV[203om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP<0?EV[
3`3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h0
1@3om^h;03eIZ`X0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0403eI
Z`3om^h0ooK^03eIZ`80ooK^00<0?EV[0?ofkP0mFJ/0I`3om^h2000006X0ooK^0@3oool002X0ooK^
00<000000?ofkP3om^h01@3om^h00`000000ooK^0?ofkP1K0?ofkP0303eIZ`3om^h0ooK^00T0ooK^
00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^0100ooK^
00<0?EV[0?ofkP3om^h0303om^h:03eIZ`L0ooK^00@0?EV[0?ofkP3om^h0ooK^200mFJ/30?ofkP03
03eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h01P3om^h0100mFJ/0ooK^0?ofkP0mFJ/20?of
kP0403eIZ`3om^h0?EV[03eIZfH0ooK^0P00001Z0?ofkP40oooo000Z0?ofkP030000003om^h0ooK^
00D0ooK^00<000000?ofkP3om^h0FP3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^
00h0ooK^0P0mFJ/B0?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h01`3om^h503eI
Z`80ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP080?ofkPD0?EV[2P3om^h00`0m
FJ/0ooK^0?ofkP070?ofkP0403eIZ`3om^h0ooK^03eIZ`80ooK^00<0?EV[0?ofkP0mFJ/0IP3om^h2
000006X0ooK^0@3oool002X0ooK^00<000000?ofkP3om^h01P3om^h00`000000ooK^0?ofkP1H0?of
kP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h02`3om^h203eIZ`80ooK^00<0?EV[0?of
kP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP0@0?ofkP0303eIZ`3om^h0ooK^00H0?EV[203om^h00`0m
FJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP0mFJ/00`0mFJ/70?of
kP0303eIZ`3om^h0ooK^00H0ooK^00T0?EV[0?ofkP3om^h0ooK^03eIZ`3om^h0?EV[0?ofkP0mFJ/0
IP3om^h2000006X0ooK^0@3oool002T0ooK^00<000000?ofkP3om^h0203om^h00`000000ooK^0?of
kP1F0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?of
kP020?ofkP0303eIZ`3om^h0ooK^0100ooK^00<0?EV[0?ofkP3om^h03P3om^h403eIZ`h0ooK^00<0
?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^0080ooK^0`0m
FJ/40?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h00P3om^h203eIZ`030?ofkP0m
FJ/0?EV[06D0ooK^00<000000?ofkP000000J@3om^h10?ooo`00:@3om^h00`000000ooK^0?ofkP08
0?ofkP030000003om^h0ooK^05D0ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP08
0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP0;
0?ofkP<0?EV[00<0ooK^03eIZ`3om^h0403om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0
ooK^00/0ooK^00<0?EV[0?ofkP3om^h01@3om^h403eIZ`030?ofkP0mFJ/0ooK^00L0ooK^00<0?EV[
0?ofkP3om^h00P3om^h403eIZfH0ooK^0P00001Y0?ofkP40oooo000Y0?ofkP030000003om^h0ooK^
00T0ooK^00<000000?ofkP3om^h0D`3om^h00`0mFJ/0ooK^03eIZ`0@0?ofkP0303eIZ`3om^h0ooK^
00H0ooK^0P0mFJ/70?ofkP0303eIZ`3om^h0ooK^0100ooK^00<0?EV[0?ofkP3om^h01`3om^h303eI
Z`D0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^
00/0ooK^00<0?EV[0?ofkP3om^h02@3om^h203eIZ`P0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0m
FJ/0ooK^03eIZ`1V0?ofkP800000J@3om^h10?ooo`00:@3om^h00`000000ooK^0?ofkP0:0?ofkP03
0000003om^h0ooK^0580ooK^00<0?EV[0?ofkP0mFJ/04@3om^h00`0mFJ/0ooK^0?ofkP040?ofkP03
03eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP030?ofkP@0
?EV[203om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3o
m^h02`3om^h00`0mFJ/0ooK^0?ofkP090?ofkP<0?EV[1P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP@0
?EV[I@3om^h2000006T0ooK^0@3oool002P0ooK^00<000000?ofkP3om^h02`3om^h00`000000ooK^
0?ofkP1A0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/0403om^h00`0mFJ/0ooK^0?ofkP030?ofkP03
03eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h0403om^h00`0mFJ/0ooK^03eIZ`0203eIZ`d0
ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00/0
ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^03eIZ`060?ofkP0303eIZ`3om^h0ooK^00<0
ooK^0`0mFJ]U0?ofkP800000J@3om^h10?ooo`00:03om^h00`000000ooK^0?ofkP0<0?ofkP030000
003om^h0ooK^04l0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eI
Z`3om^h0ooK^0080?EV[3@3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP80?EV[403om^h00`0mFJ/0ooK^
0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^
0?ofkP090?ofkP0303eIZ`3om^h0ooK^0080?EV[103om^h00`0mFJ/0ooK^0?ofkP030?ofkP<0?EV[
I@3om^h2000006T0ooK^0@3oool002P0ooK^00<000000?ofkP3om^h03@3om^h00`000000ooK^0?of
kP1>0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^03eI
Z`0?0?ofkP0303eIZ`3om^h0ooK^00d0ooK^0`0mFJ/A0?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0
?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0
?EV[0?ofkP3om^h00P3om^h203eIZ`80ooK^00<0?EV[0?ofkP3om^h00`3om^h403eIZf@0ooK^00<0
00000?ofkP000000J03om^h10?ooo`00:03om^h00`000000ooK^0?ofkP0=0?ofkP030000003om^h0
ooK^04d0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0
ooK^00l0ooK^00<0?EV[0?ofkP3om^h02P3om^h203eIZ`<0ooK^00<0?EV[0?ofkP3om^h03`3om^h0
0`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h02`3om^h0
0`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP0mFJ/01P3om^h3
03eIZfD0ooK^0P00001X0?ofkP40oooo000X0?ofkP030000003om^h0ooK^00h0ooK^00<000000?of
kP3om^h0B`3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00d0ooK^0P0mFJ/A0?of
kP0303eIZ`3om^h0ooK^00P0ooK^0P0mFJ/50?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?of
kP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?of
kP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP040?ofkP<0?EV[1@3om^h303eIZfD0ooK^0P00001X0?of
kP40oooo000W0?ofkP030000003om^h0ooK^00l0ooK^00<000000?ofkP3om^h0BP3om^h00`0mFJ/0
ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00`0ooK^00@0?EV[0?ofkP3om^h0?EV[4@3om^h00`0m
FJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0m
FJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0m
FJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h00`3om^h403eI
Zf@0ooK^0P00001X0?ofkP40oooo000W0?ofkP030000003om^h0ooK^0100ooK^00<000000?ofkP3o
m^h0B@3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00X0ooK^00D0?EV[0?ofkP3o
m^h0ooK^03eIZ`0A0?ofkP0303eIZ`3om^h0ooK^00@0ooK^0P0mFJ/90?ofkP0303eIZ`3om^h0ooK^
00l0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^
00/0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP060?ofkP80?EV[103om^h403eI
Zf@0ooK^0P00001X0?ofkP40oooo000W0?ofkP030000003om^h0ooK^0140ooK^00<000000?ofkP3o
m^h0A`3om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3o
m^h00`3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0403eIZ`3om^h0ooK^0?ofkP80?EV[303om^h00`0m
FJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0m
FJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h01P3om^h203eI
Z`@0ooK^0`0mFJ]T0?ofkP800000J03om^h10?ooo`009`3om^h00`000000ooK^0?ofkP0A0?ofkP03
0000003om^h0ooK^04H0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP070?ofkP03
03eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h03`3om^h0100mFJ/0ooK^03eIZ`0mFJ/>0?of
kP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h0303om^hE03eIZ`X0ooK^00<0?EV[0?of
kP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0?EV[0080ooK^1@0mFJ]S0?of
kP030000003om^h0000006L0ooK^0@3oool002H0ooK^00<000000?ofkP3om^h04`3om^h00`000000
ooK^0?ofkP150?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h01@3om^h203eIZ`P0
ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00l0
ooK^00<0?EV[0?ofkP3om^h01`3om^h503eIZ`80ooK^00<0?EV[0?ofkP3om^h0303om^h0100mFJ/0
ooK^0?ofkP3om^h803eIZ`<0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP060?of
kP0503eIZ`3om^h0ooK^03eIZ`3om^h00`0mFJ/00`3om^h0?EV[0?ofkP1R0?ofkP030000003om^h0
000006L0ooK^0@3oool002H0ooK^00<000000?ofkP3om^h0503om^h00`000000ooK^0?ofkP130?of
kP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP080?of
kP0303eIZ`3om^h0ooK^00d0ooK^0`0mFJ/A0?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?of
kP3om^h01P0mFJ/80?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h0203om^h503eI
Z`X0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP0203eIZ`040?ofkP0mFJ/0?EV[
03eIZf@0ooK^0P00001W0?ofkP40oooo000V0?ofkP030000003om^h0ooK^01@0ooK^00<000000?of
kP3om^h0@P3om^h00`0mFJ/0ooK^03eIZ`0>0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?of
kP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/0403om^h0
0`0mFJ/0ooK^0?ofkP0>0?ofkP@0?EV[3P3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0
ooK^00/0ooK^00<0?EV[0?ofkP0mFJ/00P0mFJ/70?ofkP0303eIZ`3om^h0ooK^00H0ooK^00H0?EV[
0?ofkP3om^h0ooK^03eIZ`3om^h403eIZf<0ooK^0P00001W0?ofkP40oooo000V0?ofkP030000003o
m^h0ooK^01D0ooK^00<000000?ofkP3om^h0@@3om^h00`0mFJ/0ooK^03eIZ`0?0?ofkP0403eIZ`3o
m^h0ooK^03eIZ`d0ooK^00<0?EV[0?ofkP3om^h02@3om^h203eIZ`@0ooK^00<0?EV[0?ofkP3om^h0
3`3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP80?EV[00<0ooK^03eIZ`3om^h0403om^h00`0mFJ/0ooK^
0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00@0?EV[0?ofkP3om^h0ooK^100mFJ/30?ofkP03
03eIZ`3om^h0ooK^00H0ooK^00@0?EV[0?ofkP3om^h0ooK^1P0mFJ]S0?ofkP800000I`3om^h10?oo
o`009P3om^h00`000000ooK^0?ofkP0F0?ofkP030000003om^h0ooK^03l0ooK^00D0?EV[0?ofkP3o
m^h0ooK^03eIZ`0>0?ofkP0303eIZ`3om^h0?EV[00l0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0m
FJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h0203om^h303eI
Z`@0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^
00/0ooK^00<0?EV[0?ofkP3om^h01@3om^h303eIZ`030?ofkP0mFJ/0ooK^00H0ooK^00H0?EV[0?of
kP3om^h0ooK^03eIZ`3om^h403eIZf<0ooK^0P00001W0?ofkP40oooo000U0?ofkP030000003om^h0
ooK^01L0ooK^00<000000?ofkP3om^h0?`3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00l0ooK^00<0
?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP050?ofkP80?EV[203om^h00`0mFJ/0ooK^0?of
kP0?0?ofkP0303eIZ`3om^h0ooK^00D0ooK^0P0mFJ/70?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0
?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00P0ooK^0P0m
FJ/80?ofkP0403eIZ`3om^h0ooK^03eIZ`80ooK^0`0mFJ]S0?ofkP030000003om^h0000006H0ooK^
0@3oool002D0ooK^00<000000?ofkP3om^h0603om^h00`000000ooK^0?ofkP0m0?ofkP0303eIZ`3o
m^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^03eIZ`0@0?ofkP0303eIZ`3o
m^h0ooK^0080ooK^0P0mFJ/;0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h00P3o
m^h303eIZ`X0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3o
m^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h0203om^h303eIZ`H0ooK^00<0?EV[0?ofkP0mFJ/00`3o
m^h403eIZf80ooK^00<000000?ofkP000000IP3om^h10?ooo`009@3om^h00`000000ooK^0?ofkP0I
0?ofkP030000003om^h0ooK^03`0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP0:
0?ofkP0403eIZ`3om^h0ooK^03eIZa00ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0=0?ofkP0303eI
Z`3om^h0ooK^00l0ooK^00@0?EV[0?ofkP0mFJ/0?EV[3@3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP03
03eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP090?ofkP03
03eIZ`3om^h0?EV[00D0ooK^00<0?EV[0?ofkP0mFJ/0103om^h303eIZf<0ooK^0P00001V0?ofkP40
oooo000U0?ofkP030000003om^h0ooK^01T0ooK^00<000000?ofkP3om^h0>`3om^h00`0mFJ/0ooK^
0?ofkP050?ofkP0303eIZ`3om^h0ooK^00T0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0@0?ofkP<0
?EV[3`3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP80?EV[403om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP03
03eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP090?ofkP03
03eIZ`3om^h0ooK^0080?EV[103om^h203eIZ`@0ooK^0`0mFJ]S0?ofkP800000IP3om^h10?ooo`00
903om^h00`000000ooK^0?ofkP0K0?ofkP030000003om^h0ooK^03X0ooK^00<0?EV[0?ofkP3om^h0
1@3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h0
3P3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00`0ooK^0`0mFJ/A0?ofkP0303eI
Z`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eI
Z`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h00P3om^h203eIZ`80ooK^0P0mFJ/40?ofkP80?EV[
00<0ooK^03eIZ`3om^h0H@3om^h2000006H0ooK^0@3oool002@0ooK^00<000000?ofkP3om^h06`3o
m^h00`000000ooK^0?ofkP0i0?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h01P3o
m^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP0mFJ/04@3o
m^h00`0mFJ/0ooK^0?ofkP090?ofkP80?EV[0`3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3o
m^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3o
m^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h00`3om^h0100mFJ/0ooK^03eIZ`0mFJ/50?ofkP<0?EV[
HP3om^h2000006H0ooK^0@3oool002@0ooK^00<000000?ofkP3om^h0703om^h00`000000ooK^0?of
kP0h0?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?of
kP050?ofkP0303eIZ`3om^h0ooK^00/0ooK^00@0?EV[0?ofkP3om^h0?EV[4@3om^h00`0mFJ/0ooK^
0?ofkP070?ofkP80?EV[1@3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00h0ooK^
00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00T0ooK^
00<0?EV[0?ofkP3om^h0103om^h403eIZ`@0ooK^0`0mFJ]R0?ofkP800000IP3om^h10?ooo`00903o
m^h00`000000ooK^0?ofkP0M0?ofkP030000003om^h0ooK^03H0ooK^00<0?EV[0?ofkP3om^h02@3o
m^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h02@3o
m^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h0103o
m^h203eIZ`P0ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3o
m^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3o
m^h0ooK^00D0ooK^0`0mFJ/40?ofkP80?EV[00<0ooK^03eIZ`3om^h0E`3om^h30=@m6@H0ooK^00<0
00000?ofkP000000I@3om^h10?ooo`00903om^h00`000000ooK^0?ofkP0M0?ofkP030000003om^h0
ooK^03H0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0
ooK^00L0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0
ooK^00l0ooK^00<0?EV[0?ofkP3om^h00P3om^h203eIZ`X0ooK^00<0?EV[0?ofkP3om^h03`3om^h0
0`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h02P3om^h0
0`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00D0ooK^0`0mFJ/40?ofkP@0?EV[DP3om^h9
0=@m6@H0ooK^00<000000?ofkP000000I@3om^h10?ooo`008`3om^h00`000000ooK^0?ofkP0O0?of
kP030000003om^h0ooK^03@0ooK^00<0?EV[0?ofkP3om^h02`3om^h01@0mFJ/0ooK^0?ofkP3om^h0
?EV[00/0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0
ooK^00l0ooK^00@0?EV[0?ofkP0mFJ/0?EV[3@3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3o
m^h0ooK^00/0ooK^5@0mFJ/90?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?ofkP3om^h00`3o
m^h00`0mFJ/0ooK^0?ofkP0203eIZ`@0ooK^0`0mFJ]=0?ofkP/0e3dI00@0ooK^0=@m6@3D?AT0e3dI
1P3om^h2000006D0ooK^0@3oool002<0ooK^00<000000?ofkP3om^h0803om^h00`000000ooK^0?of
kP0c0?ofkP80?EV[3@3om^h00`0mFJ/0ooK^03eIZ`0<0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0
?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP80?EV[3`3om^h00`0mFJ/0ooK^0?of
kP0?0?ofkP0303eIZ`3om^h0ooK^00H0ooK^1@0mFJ/20?ofkP0303eIZ`3om^h0ooK^00`0ooK^00@0
?EV[0?ofkP3om^h0ooK^1`0mFJ/30?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h0
0`3om^h00`0mFJ/0ooK^0?ofkP0303eIZ`<0ooK^0`0mFJ]70?ofkP/0e3dI00<0ooK^0=@m6@3D?AT0
103D?AT00`3om^h0e3dI0=@m6@060?ofkP800000I@3om^h10?ooo`008`3om^h00`000000ooK^0?of
kP0P0?ofkP030000003om^h0ooK^03<0ooK^0P0mFJ/=0?ofkP0303eIZ`3om^h0?EV[00d0ooK^00<0
?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00`0ooK^0`0m
FJ/A0?ofkP0303eIZ`3om^h0ooK^00l0ooK^00<0?EV[0?ofkP3om^h01@0mFJ/80?ofkP0303eIZ`3o
m^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h01`3om^h503eIZ`T0ooK^00<0?EV[0?ofkP3om^h00P3o
m^h0100mFJ/0ooK^0?ofkP3om^h203eIZ`040?ofkP0mFJ/0ooK^0?ofkP@0?EV[@@3om^h:0=@m6@80
ooK^1@3D?AT80?ofkP030=@m6@3om^h0ooK^00@0ooK^0P00001U0?ofkP40oooo000S0?ofkP030000
003om^h0ooK^0240ooK^00<000000?ofkP3om^h0<@3om^h0100mFJ/0ooK^0?ofkP0mFJ/=0?ofkP03
03eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP090?ofkP03
03eIZ`3om^h0ooK^00/0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0@0?ofkP0303eIZ`3om^h0ooK^
00h0ooK^100mFJ/=0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h02P3om^h0100m
FJ/0ooK^03eIZ`0mFJ/80?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/0103om^h203eIZ`030?ofkP0m
FJ/0ooK^0080?EV[00<0ooK^03eIZ`3om^h0>P3om^h:0=@m6@80ooK^1P3D?AT=0?ofkP80e3dI1@3o
m^h2000006D0ooK^0@3oool00280ooK^00<000000?ofkP3om^h08`3om^h00`000000ooK^0?ofkP0`
0?ofkP0403eIZ`3om^h0ooK^03eIZ``0ooK^00<0?EV[0?ofkP0mFJ/03P3om^h0100mFJ/0ooK^0?of
kP0mFJ/=0?ofkP0303eIZ`3om^h0ooK^00P0ooK^0P0mFJ/40?ofkP0303eIZ`3om^h0ooK^00l0ooK^
00<0?EV[0?ofkP3om^h02P3om^h303eIZ`030?ofkP0mFJ/0ooK^00l0ooK^00<0?EV[0?ofkP3om^h0
2`3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00<0?EV[1@3om^h01@0mFJ/0ooK^
0?ofkP3om^h0?EV[00@0ooK^0P0mFJ/20?ofkPD0?EV[=@3om^h;0=@m6@80ooK^1@3D?ATA0?ofkP@0
e3dI1@3om^h00`000000ooK^0000001T0?ofkP40oooo000R0?ofkP030000003om^h0ooK^02<0ooK^
00<000000?ofkP3om^h0<03om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00/0ooK^00<0?EV[0?ofkP0m
FJ/03P3om^h00`0mFJ/0ooK^03eIZ`0>0?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3o
m^h01@3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00L0ooK^0`0mFJ/50?ofkP03
03eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP03
03eIZ`3om^h0ooK^00<0ooK^0`0mFJ/20?ofkP0403eIZ`3om^h0ooK^03eIZ`D0ooK^00@0?EV[0?of
kP0mFJ/0ooK^1P0mFJ/^0?ofkP/0e3dI0P3om^h70=@m6@030?ofkP3D?AT0ooK^00`0ooK^1P3D?AT0
103om^h0e3dI0=@m6@3D?AT50?ofkP030000003om^h0000006@0ooK^0@3oool00280ooK^00<00000
0?ofkP3om^h0903om^h00`000000ooK^0?ofkP0_0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/02P3o
m^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00h0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^
0?ofkP050?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^
0?ofkP030?ofkP<0?EV[203om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00`0ooK^
00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP060?ofkP80?EV[00@0ooK^03eIZ`3om^h0
?EV[1@3om^h01P0mFJ/0ooK^03eIZ`3om^h0?EV[0?ofkP@0?EV[:@3om^h:0=@m6@<0ooK^1@3D?AT6
0?ofkP030=@m6@3om^h0e3dI00L0ooK^1P3D?AT00`3om^h0e3dI0=@m6@040=@m6@030?ofkP3D?AT0
e3dI00D0ooK^00<000000?ofkP000000I03om^h10?ooo`008P3om^h00`000000ooK^0?ofkP0T0?of
kP030000003om^h0ooK^02h0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP070?of
kP0503eIZ`3om^h0ooK^0?ofkP0mFJ/03@3om^h00`0mFJ/0ooK^03eIZ`0?0?ofkP0303eIZ`3om^h0
ooK^00<0ooK^0P0mFJ/:0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h00`0mFJ/<
0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP0;
0?ofkP0303eIZ`3om^h0ooK^00L0ooK^0P0mFJ/00`3om^h0?EV[0?ofkP050?ofkP80?EV[00@0ooK^
03eIZ`3om^h0ooK^0`0mFJ/S0?ofkPX0e3dI0`3om^h60=@m6@/0ooK^00<0e3dI0?ofkP3om^h01`3D
?AT20?ofkPD0e3dI1`3om^h20=@m6@H0ooK^0P00001T0?ofkP40oooo000R0?ofkP030000003om^h0
ooK^02D0ooK^00<000000?ofkP3om^h0;@3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0
ooK^00H0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP090?ofkP0403eIZ`3om^h0
ooK^03eIZa00ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0<0?ofkP0303eIZ`3om^h0ooK^00l0ooK^
0P0mFJ/?0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^
0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00P0ooK^0`0mFJ/60?ofkP0403eIZ`3om^h0?EV[03eIZ`80
ooK^100mFJ/M0?ofkPX0e3dI0P3om^h60=@m6@l0ooK^1P3D?AT20?ofkPH0e3dI303om^h20=@m6@H0
ooK^0P00001T0?ofkP40oooo000Q0?ofkP030000003om^h0ooK^02L0ooK^00<000000?ofkP3om^h0
;03om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h0
0`3om^h00`0mFJ/0ooK^0?ofkP090?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/03`3om^h0100mFJ/0
ooK^03eIZ`0mFJ/>0?ofkP0303eIZ`3om^h0ooK^00`0ooK^0`0mFJ/@0?ofkP0303eIZ`3om^h0ooK^
00h0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^
00T0ooK^00<0?EV[0?ofkP0mFJ/01@3om^h0100mFJ/0ooK^03eIZ`0mFJ/30?ofkP<0?EV[5`3om^h:
0=@m6@<0ooK^1P3D?AT20?ofkP030=@m6@3om^h0ooK^00T0ooK^1P3D?AT20?ofkPH0e3dI4`3om^h0
0`3D?AT0ooK^0?ofkP040?ofkP800000I03om^h10?ooo`008@3om^h00`000000ooK^0?ofkP0W0?of
kP030000003om^h0ooK^02`0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP030?of
kP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP020?of
kP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0:0?of
kP80?EV[0`3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?of
kP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00L0ooK^0P0mFJ/20?of
kP80?EV[103om^h303eIZ`<0ooK^0`0mFJ/B0?ofkPX0e3dI0`3om^h50=@m6@D0ooK^00D0e3dI0?of
kP3om^h0ooK^0=@m6@040?ofkPH0e3dI103om^h50=@m6@80ooK^00<0e3dI0?ofkP3om^h04`3om^h2
0=@m6@D0ooK^00<000000?ofkP000000H`3om^h10?ooo`008@3om^h00`000000ooK^0?ofkP0X0?of
kP030000003om^h0ooK^02X0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP030?of
kP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP040?of
kP0303eIZ`3om^h0ooK^00`0ooK^0P0mFJ/A0?ofkP0303eIZ`3om^h0ooK^00L0ooK^0P0mFJ/50?of
kP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0<0?of
kP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h01`3om^h303eIZ`<0ooK^0P0mFJ/20?of
kP0303eIZ`3om^h0?EV[00<0ooK^0`0mFJ/=0?ofkPT0e3dI0`3om^h60=@m6@X0ooK^00<0e3dI0?of
kP3om^h01P3D?AT40?ofkPH0e3dI103om^h0103D?AT0ooK^0?ofkP3D?ATE0?ofkP80e3dI1@3om^h0
0`000000ooK^0000001S0?ofkP40oooo000Q0?ofkP030000003om^h0ooK^02T0ooK^00<000000?of
kP3om^h0:@3om^h00`0mFJ/0ooK^0?ofkP070?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/02@3om^h0
0`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h02`3om^h0
100mFJ/0ooK^0?ofkP0mFJ/@0?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h01P3o
m^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h02`3o
m^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00@0?EV[0?ofkP3om^h0?EV[
1@3om^h01@0mFJ/0ooK^03eIZ`3om^h0?EV[00@0ooK^00<0?EV[0?ofkP0mFJ/01P3om^h:0=@m6@80
ooK^1P3D?AT>0?ofkPD0e3dI0P3om^h00`3D?AT0ooK^0?ofkP050=@m6@X0ooK^00D0e3dI0?ofkP3o
m^h0ooK^0=@m6@0D0?ofkP80e3dI1@3om^h00`000000ooK^0000001S0?ofkP40oooo000P0?ofkP03
0000003om^h0ooK^02X0ooK^00<000000?ofkP3om^h0:@3om^h00`0mFJ/0ooK^0?ofkP070?ofkP05
03eIZ`3om^h0ooK^0?ofkP0mFJ/02@3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^
00H0ooK^00<0?EV[0?ofkP3om^h02@3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[0140ooK^00<0?EV[
0?ofkP3om^h00`3om^h203eIZ`T0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0=
0?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP04
0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/01P3om^h403eIZ`@0ooK^0`0mFJ/00`3om^h0e3dI0=@m
6@070=@m6@030?ofkP3D?AT0e3dI00H0e3dI0`3om^h00`3D?AT0ooK^0?ofkP090?ofkP@0e3dI0P3o
m^h00`3D?AT0ooK^0=@m6@050=@m6A00ooK^00@0e3dI0?ofkP3om^h0e3dI4P3om^h40=@m6@H0ooK^
0P00001S0?ofkP40oooo000P0?ofkP030000003om^h0ooK^02/0ooK^00<000000?ofkP3om^h0:03o
m^h203eIZ`T0ooK^00<0?EV[0?ofkP0mFJ/02`3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3o
m^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3o
m^h0ooK^00h0ooK^00@0?EV[0?ofkP3om^h0ooK^0P0mFJ/;0?ofkP0303eIZ`3om^h0ooK^00h0ooK^
00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00X0ooK^
00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00D0ooK^
00@0?EV[0?ofkP0mFJ/0ooK^0P3D?AT303eIZ`/0e3dI1P3om^h00`3D?AT0ooK^0?ofkP020?ofkP03
0=@m6@3om^h0ooK^00@0ooK^1@3D?AT00`3om^h0e3dI0=@m6@050=@m6@<0ooK^00<0e3dI0?ofkP3o
m^h0403om^h0103D?AT0ooK^0?ofkP3D?AT<0?ofkPL0e3dI00<0ooK^0=@m6@3D?AT01P3om^h20000
06<0ooK^0@3oool00200ooK^00<000000?ofkP3om^h0;03om^h00`000000ooK^0?ofkP0W0?ofkP80
?EV[2@3om^h00`0mFJ/0ooK^03eIZ`0;0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/02`3om^h00`0m
FJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h03`3om^h303eI
Z`h0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkQ@0?EV[2P3om^h00`0m
FJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0000000000001@00000303eI
Z`040=@m6@3om^h0e3dI0=@m6@<0?EV[0`3D?AT=0?ofkP030=@m6@3om^h0ooK^00<0ooK^303D?AT5
0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h03`3om^h0103D?AT0ooK^0?ofkP3D
?AT60?ofkPP0e3dI1P3om^h20=@m6@H0ooK^0P00001S0?ofkP40oooo000P0?ofkP030000003om^h0
ooK^02`0ooK^00<000000?ofkP3om^h09`3om^h00`0mFJ/0ooK^03eIZ`090?ofkP0303eIZ`3om^h0
ooK^00/0ooK^00<0?EV[0?ofkP0mFJ/0303om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0
ooK^00H0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0
ooK^00h0ooK^00<0?EV[0?ofkP3om^h01P3om^h503eIZ`80ooK^00<0?EV[0?ofkP3om^h02`3om^h0
100mFJ/0ooK^0?ofkP3om^h703eIZ`<0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`060000000403eI
Z`0J1`<06PL301X70`@000000`0mFJ/40=@m6@<0?EV[00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0
ooK^0?ofkP080=@m6@`0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP04
0=@m6@3om^h0ooK^0?ofkPP0e3dI303om^h00`3D?AT0ooK^0=@m6@050?ofkP030000003om^h00000
0680ooK^0@3oool00200ooK^00<000000?ofkP3om^h0;@3om^h00`000000ooK^0?ofkP0V0?ofkP03
03eIZ`3om^h0?EV[00T0ooK^0P0mFJ/<0?ofkP0303eIZ`3om^h0?EV[00d0ooK^00<0?EV[0?ofkP3o
m^h00`3om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00`0ooK^0`0mFJ/A0?ofkP03
03eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h01@0mFJ/80?ofkP0303eIZ`3om^h0ooK^00/0
ooK^00<0?EV[0?ofkP3om^h01`3om^h403eIZ`<0000000@0?EV[01X70`0J1`<06PL3100000000`0m
FJ/000000000000303D<1@0303eIZ`0e30D0=@`50080?EV[00<0=@`50=@m6@0000000`0mFJ/00`3D
?AT0ooK^0?ofkP0;0?ofkPL0e3dI0P3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^
00<0ooK^00<0e3dI0?ofkP3om^h03@3om^h90=@m6A40ooK^00<0e3dI0?ofkP3D?AT01@3om^h00`00
0000ooK^0000001R0?ofkP40oooo000O0?ofkP030000003om^h0ooK^02l0ooK^00<000000?ofkP3o
m^h09@3om^h0100mFJ/0ooK^0?ofkP0mFJ/80?ofkP80?EV[3@3om^h00`0mFJ/0ooK^0?ofkP0<0?of
kP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP0:0?of
kP0503eIZ`3om^h0ooK^0?ofkP0mFJ/0403om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP@0?EV[3@3om^h0
0`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00H0ooK^1`0000000`0mFJ/0000000000002
000000@0=@`500<0?EV[0000000000000`0e30D01@0mFJ/0=@`503D<1@0e30D0?EV[00<00000100m
FJ/00`3D?AT0ooK^0?ofkP040?ofkPT0e3dI1P3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3o
m^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h01`3om^h90=@m6@<0ooK^00<0e3dI0?ofkP3om^h04@3o
m^h00`3D?AT0ooK^0=@m6@050?ofkP030000003om^h000000680ooK^0@3oool001l0ooK^00<00000
0?ofkP3om^h0;`3om^h00`000000ooK^0?ofkP0U0?ofkP0403eIZ`3om^h0ooK^03eIZ`L0ooK^00@0
?EV[0?ofkP3om^h0?EV[303om^h203eIZ`h0ooK^00@0?EV[0?ofkP3om^h0?EV[303om^h00`0mFJ/0
ooK^0?ofkP080?ofkP80?EV[103om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00X0
ooK^0`0mFJ/00`3om^h0?EV[0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP00
00001@0000000`0J1`<000000000000200000080=@`500<0?EV[0000000e30D01P0e30D00`0mFJ/0
=@`5000000030000000503eIZ`00000000000000000mFJ/00`1>4PL203eIZ`030?ofkP0mFJ/0e3dI
00P0e3dI1P3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?of
kP3om^h0103om^h00`3D?AT0ooK^0?ofkP080=@m6@H0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0D
0?ofkP80e3dI1@3om^h00`000000ooK^0000001R0?ofkP40oooo000O0?ofkP030000003om^h0ooK^
0300ooK^00<000000?ofkP3om^h0903om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00H0ooK^00@0?EV[
0?ofkP3om^h0?EV[2`3om^h00`0mFJ/0ooK^03eIZ`0>0?ofkP0303eIZ`3om^h0?EV[00h0ooK^00<0
?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP050?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0
?EV[0?ofkP3om^h01P3om^h303eIZ`D0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?of
kP090?ofkP@000000P0J1`<5000000D0=@`500@0?EV[03D<1@0e30D000000`0e30D40000000503eI
Z`1>4PL0CQ8704hB1`0mFJ/0101>4PL01P0mFJ/0CQ8704hB1`1>4PL0?EV[04hB1`80?EV[103D?AT;
0?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h0303om^h0103D?AT0ooK^0?ofkP3o
m^h70=@m6@d0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP0A0?ofkP80e3dI1P3o
m^h200000680ooK^0@3oool001l0ooK^00<000000?ofkP3om^h0<03om^h00`000000ooK^0?ofkP0T
0?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/01P3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00X0ooK^
00@0?EV[0?ofkP3om^h0?EV[3P3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00D0
ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00<0
ooK^0`0mFJ/80?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h0103om^h500000080
6PL31000000303D<1@030000000e30D0=@`500<0=@`500<0?EV[03D<1@0e30D01@00000404hB1`05
03eIZ`1>4PL0CQ8704hB1`0mFJ/01@1>4PL01@0mFJ/0CQ8704hB1`0mFJ/0CQ8700<0?EV[00<0e3dI
0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00X0ooK^1`3D?AT2
0?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP0A
0?ofkP030=@m6@3om^h0e3dI00D0ooK^0P00001R0?ofkP40oooo000N0?ofkP030000003om^h0ooK^
0380ooK^00<000000?ofkP3om^h08`3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^
00<0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0503eIZ`3om^h0ooK^
0?ofkP0mFJ/03@3om^h203eIZa00ooK^00<0?EV[0?ofkP3om^h00P3om^h203eIZ`X0ooK^00<0?EV[
0?ofkP3om^h03P3om^h00`0mFJ/0ooK^03eIZ`0203eIZ`/0ooK^00<0?EV[0?ofkP3om^h0303om^h?
000000L0=@`500@0000003D<1@0e30D0=@`50P0000000`0mFJ/000000000000204hB1`030000001>
4PL0CQ8700@0CQ8700H0?EV[04hB1`1>4PL0CQ8703eIZ`00000404hB1`0303eIZ`1>4PL0?EV[0080
CQ870`0mFJ/00`3om^h0e3dI0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3o
m^h0103om^h90=@m6@H0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP020?ofkP03
0=@m6@3om^h0ooK^0140ooK^00<0e3dI0?ofkP3D?AT01@3om^h00`000000ooK^0000001Q0?ofkP40
oooo000N0?ofkP030000003om^h0ooK^03<0ooK^00<000000?ofkP3om^h08P3om^h00`0mFJ/0ooK^
0?ofkP030?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/01@3om^h00`0mFJ/0ooK^0?ofkP060?ofkP03
03eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h02@3om^h0100mFJ/0ooK^0?ofkP0mFJ/?0?of
kP0503eIZ`3om^h0ooK^0?ofkP0mFJ/0303om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP80?EV[3`3om^h0
0`0mFJ/0ooK^0?ofkP050?ofkPH0000000<06PL30000000000001@00000403D<1@030000000e30D0
=@`500H0=@`51@0000000`1>4PL0?EV[04hB1`0504hB1`030000001>4PL0CQ8700@0CQ8700D0?EV[
04hB1`0mFJ/0CQ870000000304hB1`040000000mFJ/0000003eIZ`80000000D0?EV[07<M300mFJ/0
ooK^0=@m6@0<0?ofkP030=@m6@3om^h0ooK^00H0ooK^203D?AT60?ofkP030=@m6@3om^h0ooK^00D0
ooK^00<0e3dI0?ofkP3om^h03P3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI01<0ooK^0`3D?AT50?of
kP030000003om^h000000640ooK^0@3oool001h0ooK^00<000000?ofkP3om^h0<`3om^h00`000000
ooK^0?ofkP0R0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`060?of
kP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP090?of
kP0403eIZ`3om^h0ooK^03eIZa00ooK^0`0mFJ/=0?ofkP0303eIZ`3om^h0ooK^00`0ooK^0`0mFJ/@
0?ofkP0403eIZ`3om^h0ooK^0?ofkPD000000P0J1`<400000080=@`500<0000003D<1@0e30D01`0e
30D00`000000=@`503D<1@0500000080CQ8700<0000004hB1`1>4PL00P0mFJ/604hB1`030000001>
4PL0CQ8700@0CQ8700<0?EV[04hB1`0mFJ/01@00000207<M3080?EV[0`1c7@`203eIZ`030000003D
?AT0ooK^00/0ooK^00<0e3dI0?ofkP3om^h02@3D?AT;0?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0
e3dI0?ofkP3om^h03P3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00h0ooK^1P3D?AT00`3om^h0e3dI
0?ofkP040?ofkP030000003om^h000000640ooK^0@3oool001h0ooK^00<000000?ofkP3om^h0=03o
m^h00`000000ooK^0?ofkP0Q0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00@0?EV[0?ofkP3om^h0?EV[
1P3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h0
1`3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h0
3P3om^h00`0mFJ/0ooK^0?ofkP090?ofkP80?EV[0`3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkPD00000
00<06PL30000000000001000000603D<1@030000000e30D0=@`500D0=@`51@00000804hB1`050000
000mFJ/0CQ8704hB1`0mFJ/01P1>4PL00`000000CQ8704hB1`030000000303eIZ`000000?EV[0080
Lad<00<0000007<M301c7@`00P1c7@`203eIZ`<0Lad<0`0mFJ/00`3om^h0e3dI0?ofkP070?ofkPX0
e3dI0P3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3o
m^h03P3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00D0ooK^2@3D?AT20?ofkP03
0=@m6@3om^h0e3dI00D0ooK^00<000000?ofkP000000H@3om^h10?ooo`007P3om^h00`000000ooK^
0?ofkP0e0?ofkP030000003om^h0ooK^0200ooK^00<0?EV[0?ofkP3om^h0103om^h0100mFJ/0ooK^
0?ofkP0mFJ/70?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0
ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h0303om^h203eIZa00
ooK^00<0?EV[0?ofkP3om^h01`3om^h203eIZ`D0ooK^00<0?EV[0?ofkP3om^h0103om^h>000000<0
=@`500<0000003D<1@0e30D01P0e30D00`000000=@`503D<1@0500000080CQ8700<0000004hB1`1>
4PL0201>4PL01@0mFJ/0CQ8704hB1`1>4PL0?EV[00@0CQ871@00000407<M300303eIZ`1c7@`0Lad<
0080Lad<00@0000007<M301c7@`0Lad<0P0mFJ/307<M30<0?EV[00@000000=@m6@3om^h0ooK^2`3D
?AT80?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?of
kP0>0?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h0203D?AT80?ofkP030=@m6@3o
m^h0e3dI00H0ooK^0P00001Q0?ofkP40oooo000M0?ofkP030000003om^h0ooK^03H0ooK^00<00000
0?ofkP3om^h0803om^h203eIZ`H0ooK^0P0mFJ/90?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/0203o
m^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h02P3o
m^h0100mFJ/0ooK^0?ofkP0mFJ/@0?ofkP0303eIZ`3om^h0ooK^00@0ooK^0P0mFJ/80?ofkP0303eI
Z`000000000000<0000000<06PL3000000000000100000000`0e30D0000003D<1@0603D<1@030000
000e30D0=@`500<0=@`51`00000704hB1`030000001>4PL0CQ8700L0CQ8700<0?EV[04hB1`000000
0P1>4PL00`0mFJ/000000000000200000080Lad<00<0000007<M301c7@`0101c7@`00`0mFJ/0Lad<
07<M300207<M30040000001c7@`0Lad<07<M3080?EV[101c7@`00`0mFJ/0Lad<0=@m6@030=@m6@03
0?ofkP3D?AT0e3dI00<0e3dI0`3om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00X0
ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0e3dI00L0
e3dI3`3om^h00`3D?AT0ooK^0=@m6@050?ofkP800000H@3om^h10?ooo`007@3om^h00`000000ooK^
0?ofkP0g0?ofkP030000003om^h0ooK^01l0ooK^0P0mFJ/60?ofkP80?EV[2@3om^h0100mFJ/0ooK^
0?ofkP0mFJ/90?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0
ooK^0?ofkP090?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/0403om^h00`0mFJ/0ooK^0?ofkP020?of
kP80?EV[1`3om^h5000000806PL31@00000503D<1@030000000e30D0=@`500<0=@`52000000404hB
1`030000001>4PL0CQ8700P0CQ8700<0000004hB1`1>4PL01@1>4PL00`0mFJ/00000000000030000
000307<M300mFJ/0Lad<00D0Lad<00<0000007<M301c7@`00P1c7@`203eIZ`D0Lad<00D0000007<M
301c7@`0Lad<03eIZ`0407<M300403eIZ`1c7@`0Lad<000000<0e3dI203om^h00`3D?AT0ooK^0?of
kP070?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?of
kP080?ofkPT0e3dI00<0ooK^0=@m6@3om^h04P3om^h00`3D?AT0ooK^0=@m6@050?ofkP030000003o
m^h000000600ooK^0@3oool001d0ooK^00<000000?ofkP3om^h0>03om^h00`000000ooK^0?ofkP0O
0?ofkP80?EV[1P3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0?EV[00X0ooK^00<0?EV[
0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[
0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0403eIZ`3om^h0?EV[03eIZ`@0ooK^1@00
00000`0J1`<00000000000040000000303D<1@000000=@`500H0=@`500<0000003D<1@0e30D01000
000204hB1`030000001>4PL0CQ8700L0CQ8700<0000004hB1`1>4PL0201>4PL00`000000CQ8704hB
1`040000000903eIZ`000000Lad<07<M30000000Lad<0=@m6@1c7@`0?EV[00H0Lad<00<0000007<M
301c7@`00P1c7@`00`0mFJ/0Lad<03eIZ`0407<M30050000001c7@`0Lad<07<M300mFJ/0101c7@`2
03eIZ`80000000<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0
ooK^00/0ooK^00<0e3dI0?ofkP3om^h01@3om^h0103D?AT0ooK^0?ofkP3om^h:0=@m6@80ooK^00<0
e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP0A0?ofkP030=@m6@3om^h0e3dI00<0ooK^0`00
00000`3om^h000000?ofkP1O0?ofkP40oooo000M0?ofkP030000003om^h0ooK^03P0ooK^00<00000
0?ofkP3om^h07`3om^h203eIZ`H0ooK^0P0mFJ/90?ofkP80?EV[2`3om^h01@0mFJ/0ooK^0?ofkP3o
m^h0?EV[00X0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3o
m^h0ooK^00h0ooK^0P0mFJ/>000000@0=@`500<0000003D<1@0e30D0100e30D5000000H0CQ8700<0
000004hB1`1>4PL01`1>4PL00`000000CQ8704hB1`0604hB1`D000000`1c7@`00`0mFJ/0Lad<07<M
300207<M30050000001c7@`0Lad<07<M300mFJ/01P1c7@`01@000000Lad<07<M301c7@`0?EV[0080
Lad<00<0?EV[07<M301c7@`00`1c7@`010000000Lad<07<M300mFJ/50000000503eIZ`2@9Q000000
0?ofkP3D?AT02@3om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI
0?ofkP3om^h00`3om^h60=@m6@030?ofkP3D?AT0e3dI0080e3dI1`3om^h00`3D?AT0ooK^0?ofkP03
0?ofkP030=@m6@3om^h0ooK^0100ooK^1P0000020?ofkP030000003om^h000000600ooK^0@3oool0
01`0ooK^00<000000?ofkP3om^h0>P3om^h00`000000ooK^0?ofkP0N0?ofkP0303eIZ`3om^h0?EV[
00D0ooK^0P0mFJ/:0?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP0mFJ/0303om^h00`0m
FJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h02`3om^h40000
000301X70`000000000000D000000P0e30D00`000000=@`503D<1@0503D<1@030000000e30D00000
00@000000P1>4PL00`000000CQ8704hB1`0604hB1`030000001>4PL0CQ8700L0CQ8700<0000004hB
1`1>4PL01P00000207<M30030000001c7@`0Lad<00<0Lad<00<0?EV[07<M301c7@`00P1c7@`00`00
0000Lad<07<M300207<M300303eIZ`1c7@`0Lad<00<0Lad<00@0000007<M301c7@`0?EV[0`1c7@`0
100mFJ/0Lad<07<M301c7@`40000000303eIZ`2@9Q00?EV[00@0T2H@00D0?EV[090V40000000ooK^
0=@m6@090?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h02P3om^h60=@m6@80ooK^
1@3D?AT;0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h02P3om^h6000000030=@m
6@3om^h0e3dI00D0ooK^00<000000?ofkP000000H03om^h10?ooo`00703om^h00`000000ooK^0?of
kP0k0?ofkP030000003om^h0ooK^01d0ooK^00<0?EV[0?ofkP0mFJ/01@3om^h00`0mFJ/0ooK^03eI
Z`090?ofkP80?EV[2`3om^h00`0mFJ/0ooK^03eIZ`0<0?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0
?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP060?ofkPX0000000<0=@`50000000e30D01@0e
30D00`000000=@`503D<1@0303D<1@D000001P1>4PL00`000000CQ8704hB1`0704hB1`030000001>
4PL0CQ8700D0CQ871@00000807<M30030000001c7@`0Lad<0080Lad<00<0?EV[07<M301c7@`0101c
7@`01@000000Lad<07<M301c7@`0?EV[00H0Lad<00@0000007<M300mFJ/0Lad<0`0000000`0mFJ/0
000000000002090V40050000002@9Q00?EV[090V400mFJ/0102@9Q001@0mFJ/0T2H@090V40000000
e3dI00X0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP060?ofkPD0e3dI0P3om^h6
0=@m6A00ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP040?ofkPH000001`3om^h2
0=@m6@H0ooK^0P00001P0?ofkP40oooo000L0?ofkP030000003om^h0ooK^03/0ooK^00<000000?of
kP3om^h07P3om^h00`0mFJ/0ooK^03eIZ`040?ofkP0303eIZ`3om^h0?EV[00T0ooK^0P0mFJ/<0?of
kP0303eIZ`3om^h0ooK^00`0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`0;0?ofkP0303eIZ`000000
000000/000000`0e30D2000000H0=@`500<0000003D<1@0000001000000204hB1`030000001>4PL0
CQ8700H0CQ8700<0000004hB1`1>4PL01`1>4PL00`000000CQ8704hB1`0500000080Lad<00<00000
07<M303D?AT0201c7@`01@000000Lad<07<M301c7@`0?EV[00L0Lad<00D0000007<M301c7@`0Lad<
03eIZ`0407<M30<0000000<0?EV[0000000000000`2@9Q000`0mFJ/0T2H@090V4002090V40050000
002@9Q00?EV[090V400mFJ/0102@9Q0203eIZ`04090V40000000ooK^0=@m6@T0ooK^00<0e3dI0?of
kP3om^h0203om^h00`3D?AT0ooK^0?ofkP050=@m6@80ooK^1@3D?AT60?ofkP030=@m6@3om^h0ooK^
00d0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^00000004000000d0ooK^00<0e3dI0?of
kP3D?AT01@3om^h200000600ooK^0@3oool001`0ooK^00<000000?ofkP3om^h0?03om^h00`000000
ooK^0?ofkP0M0?ofkP0303eIZ`3om^h0?EV[00@0ooK^00@0?EV[0?ofkP3om^h0?EV[1`3om^h0100m
FJ/0ooK^0?ofkP0mFJ/;0?ofkP80?EV[3@3om^h0100mFJ/0ooK^0?ofkP0mFJ/70?ofkPd0000000<0
=@`50000000000001@0e30D010000000=@`503D<1@0e30D7000000H0CQ8700<0000004hB1`1>4PL0
1`1>4PL00`000000CQ8704hB1`0504hB1`D000001`1c7@`00`000000Lad<07<M300907<M30030000
001c7@`0?EV[00P0Lad<00<0000007<M301c7@`00P000000100mFJ/00000000000000002090V4003
03eIZ`2@9Q00T2H@00@0T2H@00<0?EV[090V402@9Q000P2@9Q000`000000?EV[090V4002090V4004
03eIZ`2@9Q00T2H@090V4080?EV[00@0T2H@0000003om^h0e3dI2@3om^h00`3D?AT0ooK^0?ofkP05
0?ofkPH0e3dI00<0ooK^0=@m6@3D?AT0103D?AT20?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI
0?ofkP3om^h03@3om^h00`3D?AT000000000000400000180ooK^00<0e3dI0?ofkP3D?AT01@3om^h0
0`000000ooK^0000001O0?ofkP40oooo000L0?ofkP030000003om^h0ooK^03`0ooK^00<000000?of
kP3om^h07@3om^h0100mFJ/0ooK^0?ofkP0mFJ/30?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/01P3o
m^h0100mFJ/0ooK^0?ofkP0mFJ/:0?ofkP0303eIZ`3om^h0?EV[00h0ooK^0P0mFJ/50?ofkP<00000
00<06PL30000000000001@00000503D<1@030000000e30D0=@`50080=@`51`00000304hB1`030000
001>4PL0CQ8700L0CQ8700<0000004hB1`1>4PL01P1>4PL00`000000CQ8704hB1`0600000080Lad<
00<0000007<M301c7@`01`1c7@`00`000000Lad<07<M300907<M30030000000mFJ/0Lad<00H0Lad<
1@000002090V400303eIZ`2@9Q00T2H@00<0T2H@00<0?EV[090V402@9Q00102@9Q000`0mFJ/0T2H@
090V4002090V40030000000mFJ/0T2H@0080T2H@00@0?EV[090V402@9Q00T2H@0P0mFJ/0102@9Q00
00000?ofkP3D?AT90?ofkP030=@m6@3om^h0e3dI00D0e3dI00<0ooK^0=@m6@3D?AT0103D?AT80?of
kP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h0203om^h6000000D0ooK^00<0e3dI0?of
kP3om^h0403om^h30=@m6@D0ooK^00<000000?ofkP000000G`3om^h10?ooo`006`3om^h00`000000
ooK^0?ofkP0n0?ofkP030000003om^h0ooK^01`0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`020?of
kP0503eIZ`3om^h0ooK^0?ofkP0mFJ/01P3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00T0ooK^00@0
?EV[0?ofkP3om^h0?EV[3@3om^h00`0mFJ/0ooK^0?ofkP09000000<0=@`500<0000003D<1@0e30D0
0`0e30D70000000304hB1`000000CQ8700L0CQ8700<0000004hB1`1>4PL01`1>4PL00`000000CQ87
04hB1`0404hB1`D00000201c7@`00`000000Lad<07<M300707<M30030000001c7@`0Lad<00T0Lad<
00<0?EV[07<M301c7@`01P000002090V40030000002@9Q00T2H@0080T2H@00<0?EV[090V402@9Q00
0P2@9Q000`0mFJ/00000090V4006090V400603eIZ`2@9Q00T2H@090V400mFJ/000000`2@9Q002`0m
FJ/0T2H@090V402@9Q00?EV[090V400mFJ/0T2H@0000003om^h0e3dI00<0ooK^1`3D?AT00`3om^h0
e3dI0=@m6@040=@m6@80ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP060?ofkP03
0=@m6@3om^h0ooK^0080ooK^1P0000050?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3o
m^h02`3om^h60=@m6@030?ofkP3D?AT0ooK^00@0ooK^00<000000?ofkP000000G`3om^h10?ooo`00
6`3om^h00`000000ooK^0?ofkP0o0?ofkP030000003om^h0ooK^01`0ooK^00@0?EV[0?ofkP3om^h0
?EV[0P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00<0ooK^00D0?EV[0?ofkP3o
m^h0ooK^03eIZ`080?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/0303om^h00`0mFJ/0e3dI03eIZ`04
0000000303D<1@000000000000D0=@`500@0000003D<1@0e30D0=@`51@00000604hB1`030000001>
4PL0CQ8700D0CQ8700<0000004hB1`1>4PL01`1>4PL00`000000CQ8704hB1`0500000080Lad<00<0
000007<M301c7@`0201c7@`00`000000Lad<07<M300707<M30030000001c7@`0Lad<00L0Lad<00<0
000003eIZ`0000000P000008090V40030000002@9Q00T2H@00<0T2H@00H0?EV[090V402@9Q00T2H@
03eIZ`000007090V400603eIZ`2@9Q00T2H@090V400mFJ/000000`2@9Q002@0mFJ/0T2H@090V402@
9Q00?EV[090V400mFJ/0T2H@000000050=@m6@<0ooK^1@3D?AT90?ofkP030=@m6@3om^h0ooK^00T0
ooK^00<0e3dI0?ofkP3om^h01@3om^h5000000/0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0
ooK^0?ofkP060?ofkPD0e3dI1P3om^h20=@m6@D0ooK^00<000000?ofkP000000G`3om^h10?ooo`00
6`3om^h00`000000ooK^0?ofkP0o0?ofkP030000003om^h0ooK^01`0ooK^00L0?EV[0?ofkP3om^h0
ooK^03eIZ`3om^h0?EV[00@0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP030?of
kP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP030?of
kPH0e3dI00<0?EV[0000000e30D0100e30D00`000000=@`503D<1@0303D<1@H0000000<0CQ870000
001>4PL01`1>4PL00`000000CQ8704hB1`0604hB1`030000001>4PL0CQ870080CQ872000000707<M
30030000001c7@`0Lad<00L0Lad<00<0000007<M301c7@`0201c7@`010000000Lad<07<M301c7@`5
000000<0?EV[00<00000090V402@9Q00202@9Q000`000000T2H@090V4003090V400403eIZ`2@9Q00
T2H@03eIZ`80T2H@00<00000090V402@9Q00102@9Q001P0mFJ/0T2H@090V402@9Q00?EV[000000@0
T2H@00<0?EV[090V400mFJ/00P2@9Q0010000000?EV[0000003om^h70=@m6@80ooK^00<0e3dI0?of
kP3om^h02@3om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0000000D0000000<0ooK^0=@m
6@3om^h03@3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00D0e3dI2`3om^h00`3D
?AT0ooK^0=@m6@050?ofkP800000G`3om^h10?ooo`006`3om^h00`000000ooK^0?ofkP100?ofkP03
0000003om^h0ooK^01`0ooK^00H0?EV[0?ofkP3om^h0?EV[0?ofkP0mFJ/50?ofkP0503eIZ`3om^h0
ooK^0?ofkP0mFJ/01@3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0
e3dI03eIZ`3D?AT0103D?AT20?ofkP80e3dI00<0000003eIZ`0e30D0100e30D2000000<0=@`51@00
000504hB1`030000001>4PL0CQ8700D0CQ8700<0000004hB1`1>4PL0101>4PL8000000D0Lad<00<0
000007<M301c7@`01`1c7@`00`000000Lad<07<M300707<M30030000001c7@`0Lad<00H0Lad<1P00
0004090V400503eIZ`2@9Q00T2H@090V400mFJ/02P2@9Q000`000000T2H@090V4003090V400303eI
Z`2@9Q00?EV[00<0T2H@00<00000090V402@9Q001@2@9Q001@0mFJ/0T2H@03eIZ`2@9Q00000000<0
T2H@00@0000003eIZ`000000?EV[0P0000020:D]4`030000003D?AT0e3dI00P0ooK^00<0e3dI0?of
kP3om^h02@3om^h00`3D?AT0ooK^0?ofkP050?ofkPH000001`3om^h00`3D?AT0ooK^0?ofkP0<0?of
kP040=@m6@3om^h0ooK^0?ofkPH0e3dI3@3om^h40=@m6@030?ofkP3D?AT0ooK^00@0ooK^0P00001O
0?ofkP40oooo000J0?ofkP030000003om^h0ooK^0480ooK^00<000000?ofkP3om^h06`3om^h0100m
FJ/0ooK^0?ofkP3om^h203eIZ`H0ooK^00@0?EV[0?ofkP3om^h0?EV[1P3om^h00`0mFJ/0ooK^0?of
kP020?ofkP030=@m6@0mFJ/0e3dI00<0e3dI0P3om^h00`0mFJ/0e3dI0=@m6@040=@m6@8000001@0e
30D70000000304hB1`000000CQ8700H0CQ8700<0000004hB1`1>4PL01P1>4PL00`000000CQ870000
000400000080Lad<00<0000007<M301c7@`01`1c7@`00`000000Lad<07<M300707<M30030000001c
7@`0Lad<00P0Lad<00<0000007<M301c7@`01P000002090V40030000002@9Q00T2H@00@0T2H@00<0
?EV[090V402@9Q000P2@9Q000`0mFJ/0T2H@090V4008090V40030000002@9Q00T2H@00@0T2H@0P0m
FJ/3090V40030000002@9Q00T2H@00D0T2H@00<0?EV[090V400mFJ/01@000000102U;A<0?EV[0:D]
4`0mFJ/40:D]4`80000000<0ooK^0=@m6@3om^h01P3om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m
6@3om^h0000000D00000103om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00T0ooK^
1`3D?AT30?ofkP030=@m6@3om^h0ooK^00L0ooK^1P3D?AT30?ofkP030=@m6@3om^h0e3dI00D0ooK^
00<000000?ofkP000000GP3om^h10?ooo`006P3om^h00`000000ooK^0?ofkP120?ofkP030000003o
m^h0ooK^01`0ooK^00<0?EV[0?ofkP3om^h00P0mFJ/60?ofkP0403eIZ`3om^h0ooK^03eIZ`H0ooK^
00<0?EV[0=@m6@3D?AT00P3D?AT00`0mFJ/0e3dI0=@m6@050=@m6@0303eIZ`3D?AT0e3dI0080ooK^
0P0000000`0e30D0?EV[00000006000000D0CQ8700<0000004hB1`1>4PL01@1>4PL00`000000CQ87
04hB1`0404hB1`D000001P1c7@`00`000000Lad<07<M300807<M30030000001c7@`0Lad<00L0Lad<
00<0000007<M301c7@`01P1c7@`5000000P0T2H@00<00000090V402@9Q000P2@9Q0203eIZ`D0T2H@
00<0000003eIZ`2@9Q00202@9Q000`000000T2H@090V4004090V400303eIZ`2@9Q00T2H@0080T2H@
00@00000090V402@9Q00T2H@100000001@0mFJ/0000003eIZ`2U;A<0000000D0YBdC0P0mFJ/40:D]
4`<0000000<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP050?ofkPH000002P3om^h00`3D
?AT0ooK^0?ofkP070?ofkP040=@m6@3om^h0ooK^0?ofkPL0e3dI103om^h00`3D?AT0ooK^0?ofkP03
0?ofkP040=@m6@3om^h0ooK^0?ofkPH0e3dI2@3om^h00`3D?AT0ooK^0=@m6@050?ofkP030000003o
m^h0000005h0ooK^0@3oool001X0ooK^00<000000?ofkP3om^h0@`3om^h00`000000ooK^0?ofkP0K
0?ofkP80?EV[0P3om^h00`0mFJ/0ooK^0?ofkP050?ofkP80?EV[0P3om^h50=@m6@030?ofkP0mFJ/0
e3dI0080e3dI00<0?EV[0=@m6@3D?AT00P3D?AT30?ofkP040=@m6@0mFJ/0ooK^0?ofkPD000000`1>
4PL00`000000CQ8704hB1`0504hB1`030000001>4PL0CQ8700H0CQ8700<0000004hB1`0000001000
000207<M30030000001c7@`0Lad<00H0Lad<00<0000007<M301c7@`0201c7@`00`000000Lad<07<M
300707<M30030000001c7@`0Lad<00H000000P2@9Q000`000000T2H@090V4008090V40050000002@
9Q00T2H@090V400mFJ/01`2@9Q000`000000?EV[090V4008090V40030000002@9Q00T2H@00<0T2H@
0P0mFJ/2090V40H000001@2U;A<0100mFJ/0YBdC0:D]4`0000050:D]4`80?EV[102U;A<300000003
0=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h01@0000050?ofkP030=@m6@3om^h0ooK^00P0
ooK^00<0e3dI0?ofkP3om^h01@3om^h60=@m6@/0ooK^00@0e3dI0?ofkP3om^h0ooK^1P3D?AT?0?of
kP030=@m6@3om^h0e3dI00D0ooK^00<000000?ofkP000000GP3om^h10?ooo`006P3om^h00`000000
ooK^0?ofkP140?ofkP030000003om^h0ooK^01/0ooK^0P0mFJ/00`3om^h0?EV[03eIZ`050?ofkP03
0=@m6@0mFJ/0?EV[0080e3dI00<0ooK^0=@m6@3D?AT00`3D?AT0100mFJ/0e3dI0=@m6@0mFJ/90?of
kP0303eIZ`3D?AT0000000L0CQ8700<0000004hB1`1>4PL01@1>4PL00`000000CQ8704hB1`0404hB
1`D000001P1c7@`00`000000Lad<07<M300707<M30030000001c7@`0Lad<00P0Lad<00<0000007<M
301c7@`01@1c7@`5000000P0T2H@00<00000090V402@9Q00202@9Q0010000000T2H@090V400mFJ/8
090V40030000000mFJ/0T2H@00P0T2H@00H00000090V402@9Q00T2H@0000000mFJ/20000000503eI
Z`000000YBdC0:D]4`000000202U;A<0100mFJ/0YBdC0:D]4`0000050:D]4`80?EV[102U;A<20000
00030312K`000000ooK^00<0ooK^1P00000:0?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?of
kP3om^h01@3D?AT20?ofkP030=@m6@3om^h0ooK^00X0ooK^1P3D?AT30?ofkP030=@m6@3om^h0ooK^
00l0ooK^00@0e3dI0?ofkP3om^h0e3dI103om^h00`000000ooK^0000001N0?ofkP40oooo000J0?of
kP030000003om^h0ooK^04@0ooK^00<000000?ofkP3om^h0703om^h0100mFJ/0ooK^0?ofkP0mFJ/7
0=@m6@0303eIZ`3D?AT0e3dI00H0e3dI00@0ooK^03eIZ`3om^h0?EV[2P3om^h00`0mFJ/0CQ8704hB
1`0504hB1`030000001>4PL0CQ8700D0CQ8700<0000004hB1`0000001@00000207<M30030000001c
7@`0Lad<00H0Lad<00<0000007<M301c7@`01`1c7@`00`000000Lad<07<M300707<M30030000001c
7@`0Lad<00H000000P2@9Q000`000000T2H@090V4008090V40030000002@9Q00T2H@00P0T2H@00<0
000003eIZ`0mFJ/02@2@9Q000`000000T2H@03eIZ`06090V40H0000000D0?EV[0:D]4`2U;A<0YBdC
03eIZ`030:D]4`030000002U;A<0YBdC00D0YBdC0P0mFJ/20:D]4`030000002U;A<0YBdC00@0YBdC
00H0?EV[0:D]4`2U;A<0YBdC0000000oF9X7000000<0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D
?AT0ooK^0?ofkP060?ofkPD0e3dI1`3om^h00`3D?AT0ooK^0?ofkP040?ofkPH0e3dI0P3om^h00`3D
?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^0100ooK^00<0e3dI0?ofkP3D?AT01@3om^h20000
05h0ooK^0@3oool001T0ooK^00<000000?ofkP3om^h0AP3om^h00`000000ooK^0?ofkP0H0?ofkP<0
e3dI0P0mFJ/00`3D?AT0?EV[03eIZ`060=@m6@80?EV[0P3D?AT50?ofkP030=@m6@0mFJ/0?EV[00P0
ooK^0`3D?AT704hB1`030000001>4PL0CQ8700<0CQ871@00000707<M30030000001c7@`0Lad<00H0
Lad<00<0000007<M301c7@`01`1c7@`00`000000Lad<07<M300607<M30D00000202@9Q000`000000
T2H@090V4008090V40030000002@9Q00T2H@00P0T2H@00<0?EV[090V402@9Q002@2@9Q000`000000
T2H@03eIZ`0600000080YBdC00@000000:D]4`2U;A<0?EV[102U;A<01@0mFJ/0YBdC0:D]4`2U;A<0
000000L0YBdC00D0?EV[0:D]4`0mFJ/0YBdC000000060:D]4`0303eIZ`000000000000H0000000<0
e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00D0e3dI0`3o
m^h00`3D?AT0ooK^0?ofkP070?ofkPH0e3dI203om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3o
m^h0ooK^0100ooK^00<0e3dI0?ofkP3D?AT01@3om^h2000005h0ooK^0@3oool001T0ooK^00<00000
0?ofkP3om^h0AP3om^h00`000000ooK^0?ofkP0B0?ofkPH0e3dI0P3om^h20=@m6@@0?EV[103D?AT2
0?ofkP80?EV[00<0e3dI0?ofkP3om^h00`3om^h0103D?AT0ooK^0?ofkP0mFJ/30?ofkPH0e3dI00<0
000004hB1`1>4PL01@1>4PL00`000000CQ870000000400000080Lad<00<0000007<M301c7@`01`1c
7@`00`000000Lad<07<M300607<M30030000001c7@`0Lad<00L0Lad<00<0000007<M301c7@`01P00
0002090V40030000002@9Q00T2H@00P0T2H@00<00000090V402@9Q00202@9Q000`000000T2H@090V
4007090V400303eIZ`000000T2H@00P0T2H@1@0000000`0mFJ/0YBdC0:D]4`050:D]4`030000002U
;A<0?EV[00H0YBdC00@0?EV[0:D]4`2U;A<000001P2U;A<01P0mFJ/0YBdC0:D]4`0mFJ/0YBdC0000
0080YBdC1@0000030:D]4`030000000oF9X0?eRJ00<000001`3om^h00`3D?AT0ooK^0?ofkP070?of
kPH0e3dI203om^h0103D?AT0ooK^0?ofkP3om^h70=@m6@d0ooK^00<0e3dI0?ofkP3om^h0103om^h0
0`3D?AT0ooK^0?ofkP0@0?ofkP030=@m6@3om^h0e3dI00D0ooK^00<000000?ofkP000000G@3om^h1
0?ooo`006@3om^h00`000000ooK^0?ofkP170?ofkP030000003om^h0ooK^00/0ooK^1P3D?AT30?of
kPP0e3dI100mFJ/50?ofkP0303eIZ`3om^h0?EV[0080e3dI0`3om^h00`3D?AT0ooK^0=@m6@0203eI
Z`D0e3dI0P3om^h00`000000CQ8704hB1`0204hB1`0303eIZ`000000000000<000001P1c7@`00`00
0000Lad<07<M300707<M30030000001c7@`0Lad<00L0Lad<00<0000007<M301c7@`01@1c7@`50000
00P0T2H@00<00000090V402@9Q00202@9Q000`000000T2H@090V4008090V40030000002@9Q00T2H@
00D0T2H@0P0mFJ/00`2@9Q000000090V4002090V40H000000P2U;A<010000000YBdC0:D]4`0mFJ/7
0:D]4`030000000mFJ/0YBdC00H0YBdC00@0?EV[0:D]4`2U;A<000001P2U;A<00`0mFJ/0YBdC0000
0005000000<0YBdC00<0?EV[0:D]4`0mFJ/00P2U;A<00`000000?eRJ03eIZ`03000000L0ooK^00@0
e3dI0?ofkP3om^h0ooK^1P3D?AT30?ofkP030=@m6@3om^h0ooK^00H0ooK^1P3D?AT60?ofkP030=@m
6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP0@0?ofkP040=@m
6@3om^h0ooK^0=@m6@@0ooK^00<000000?ofkP000000G@3om^h10?ooo`006@3om^h00`000000ooK^
0?ofkP180?ofkP030000003om^h0ooK^00D0ooK^1`3D?AT20?ofkPL0e3dI0`3om^h00`3D?AT0ooK^
0?ofkP0303eIZ`030?ofkP0mFJ/0ooK^00<0ooK^00@0?EV[0?ofkP0mFJ/0ooK^1`3D?AT203eIZ`03
0=@m6@3om^h0ooK^00<0ooK^00<0000004hB1`000000100000000`1c7@`0000007<M300807<M3003
0000001c7@`0Lad<00L0Lad<00<0000007<M301c7@`01P1c7@`00`000000Lad<07<M300600000080
T2H@00<00000090V402@9Q00202@9Q000`000000T2H@090V4008090V40030000002@9Q00T2H@00P0
T2H@00<00000090V402@9Q00102@9Q000`0mFJ/0T2H@00000005000000P0YBdC00D000000:D]4`2U
;A<0YBdC03eIZ`060:D]4`030000000mFJ/0YBdC00L0YBdC00<0?EV[0:D]4`0000000P2U;A<60000
0080YBdC00<0?EV[0000002U;A<0102U;A<00`0mFJ/0YBdC03eIZ`020:D]4`030000000oF9X0?eRJ
00<0000000@0e3dI0?ofkP3om^h0ooK^1`3D?AT90?ofkP030=@m6@3om^h0ooK^00H0e3dI0P3om^h0
0`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h00`3om^h0
0`3D?AT0ooK^0?ofkP0@0?ofkP040=@m6@3om^h0ooK^0=@m6@@0ooK^00<000000?ofkP000000G@3o
m^h10?ooo`00603om^h00`000000ooK^0?ofkP190?ofkP030000003om^h0ooK^00D0e3dI0`3om^h7
0=@m6@<0ooK^0P3D?AT40?ofkP040=@m6@3om^h0ooK^0?ofkP80?EV[00<0ooK^03eIZ`3om^h00`3D
?AT0100mFJ/0e3dI0=@m6@0mFJ/50=@m6@050?ofkP0mFJ/0ooK^0?ofkP0mFJ/0103om^h3000000H0
Lad<00<0000007<M301c7@`01P1c7@`00`000000Lad<07<M300807<M30030000001c7@`0Lad<00@0
Lad<1@000008090V40030000002@9Q00T2H@00P0T2H@00<00000090V402@9Q00202@9Q000`000000
T2H@090V4008090V40030000002@9Q00T2H@008000000`0mFJ/010000000YBdC0:D]4`00000;0:D]
4`050000002U;A<0YBdC0:D]4`0mFJ/01P2U;A<00`0mFJ/0YBdC0:D]4`060:D]4`H000000`2U;A<0
0`0mFJ/0YBdC0:D]4`020:D]4`0303eIZ`000000YBdC00@0YBdC00<0?EV[0:D]4`0mFJ/00`000002
03mHVP<00000103D?AT30?ofkP030=@m6@3om^h0ooK^00L0ooK^1P3D?AT80?ofkP030=@m6@3om^h0
ooK^00P0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0
ooK^00l0ooK^103D?AT40?ofkP030000003om^h0000005d0ooK^0@3oool001P0ooK^00<000000?of
kP3om^h0A`3om^h50=@m6@<0ooK^1`3D?AT:0?ofkP040=@m6@3om^h0ooK^0=@m6@80ooK^0P3D?AT0
1@0mFJ/0e3dI03eIZ`3D?AT0?EV[00<0e3dI00@0?EV[0=@m6@3D?AT0?EV[0P3om^h20=@m6@80ooK^
00@0?EV[0?ofkP3om^h0?EV[0`3om^h00`000000Lad<07<M300607<M30030000001c7@`0Lad<00L0
Lad<00<0000007<M301c7@`01`1c7@`00`000000Lad<07<M300500000080T2H@00<00000090V402@
9Q00202@9Q000`000000T2H@090V4007090V40030000002@9Q00T2H@00T0T2H@00<00000090V402@
9Q001P2@9Q0500000080?EV[0`2U;A<0100mFJ/0YBdC0:D]4`00000;0:D]4`050000002U;A<0YBdC
0:D]4`0mFJ/01@2U;A<00`0mFJ/000000:D]4`020:D]4`D0000000@0YBdC03eIZ`2U;A<00000102U
;A<00`0mFJ/0YBdC0:D]4`040:D]4`0303eIZ`2U;A<0YBdC00<0000000H0?EV[000000000000?EV[
0;Hb5@00000203mHVP@000001P3om^h0103D?AT0ooK^0?ofkP3om^h60=@m6@@0ooK^00<0e3dI0?of
kP3om^h01`3om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?of
kP3om^h0103om^h00`3D?AT0ooK^0?ofkP080?ofkPP0e3dI0P3om^h00`3D?AT0ooK^0?ofkP030?of
kP800000G@3om^h10?ooo`00603om^h00`000000ooK^0?ofkP130?ofkP@0e3dI0P3om^h90=@m6@h0
ooK^1P3D?AT00`3om^h0e3dI0=@m6@0403eIZ`<0ooK^00H0?EV[0?ofkP3om^h0ooK^03eIZ`3om^h2
0=@m6@80ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`020?ofkP030000001c7@`0Lad<00H0Lad<00<0
000007<M301c7@`01`1c7@`00`000000Lad<07<M300507<M30D000001`2@9Q000`000000T2H@090V
4008090V40030000002@9Q00T2H@00L0T2H@00<00000090V402@9Q002@2@9Q000`000000T2H@090V
400600000080YBdC00<0000003eIZ`0mFJ/01@2U;A<0100mFJ/0YBdC0:D]4`00000;0:D]4`030000
002U;A<0YBdC0080YBdC00@0?EV[0:D]4`2U;A<0YBdC1P0000070:D]4`0303eIZ`000000YBdC0080
YBdC00<0?EV[0:D]4`2U;A<00`2U;A<20000000303eIZ`00000000000080]S8E00H0?EV[0;Hb5@2f
<QD0]S8E03eIZ`2f<QD20000000303mHVP0000000000008000000`3om^h70=@m6@X0ooK^00<0e3dI
0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI
0?ofkP3om^h0103om^h0103D?AT0ooK^0?ofkP3om^h70=@m6@L0ooK^00@0e3dI0?ofkP3om^h0e3dI
1@3om^h2000005d0ooK^0@3oool001P0ooK^00<000000?ofkP3om^h0@@3om^h<0=@m6@<0ooK^00<0
e3dI0?ofkP3om^h0203om^h50=@m6@030?ofkP3D?AT0e3dI00@0e3dI0`3om^h403eIZ`80ooK^00H0
?EV[0?ofkP3om^h0ooK^03eIZ`3D?AT20?ofkP030=@m6@3om^h0?EV[00<0ooK^00<0?EV[0?ofkP00
0000201c7@`00`000000Lad<07<M300707<M30030000001c7@`0Lad<00H000000P2@9Q000`000000
T2H@090V4007090V40030000002@9Q00T2H@00L0T2H@00<00000090V402@9Q00202@9Q000`000000
T2H@090V4007090V40D000001`2U;A<203eIZ`P0YBdC00<0?EV[0:D]4`0000002`2U;A<00`000000
YBdC0:D]4`0600000080YBdC00<000000:D]4`2U;A<0202U;A<00`0mFJ/000000:D]4`020:D]4`03
03eIZ`000000000000<000000P2f<QD00`0mFJ/0]S8E0;Hb5@020;Hb5@0303eIZ`2f<QD0]S8E0080
]S8E00D0?EV[04UY_0000000?eRJ000000060=@m6@<0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D
?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h02`3om^h0103D
?AT0ooK^0?ofkP3om^h70=@m6@l0ooK^00<0e3dI0?ofkP3D?AT01@3om^h00`000000ooK^0000001L
0?ofkP40oooo000H0?ofkP030000003om^h0ooK^03l0ooK^103D?AT80?ofkP80e3dI0`3om^h00`3D
?AT0ooK^0?ofkP030?ofkPD0e3dI00<0ooK^0=@m6@3D?AT0103D?AT20?ofkP030=@m6@3om^h0ooK^
00<0ooK^0P0mFJ/01@3om^h0?EV[03eIZ`3om^h0?EV[00@0ooK^00D0?EV[0?ofkP3om^h0ooK^03eI
Z`050?ofkP0303eIZ`1c7@`0Lad<00L0Lad<00<0000007<M301c7@`01@1c7@`5000000P0T2H@00<0
0000090V402@9Q001`2@9Q000`000000T2H@090V4007090V40030000002@9Q00T2H@00P0T2H@00@0
0000090V402@9Q00T2H@1P0000020:D]4`030000002U;A<0YBdC00D0YBdC0P0mFJ/00`2U;A<00000
0:D]4`070:D]4`0303eIZ`2U;A<0000000P0YBdC1P0000030:D]4`80?EV[0`2U;A<00`000000YBdC
0:D]4`070:D]4`030000000mFJ/000000080000000<0?EV[0;Hb5@2f<QD01P2f<QD00`000000?EV[
0;Hb5@020;Hb5@0303eIZ`2f<QD0]S8E0080]S8E00<0?EV[0=@m6@3D?AT00P3D?AT0100oF9X00000
0000000000050?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0
ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00P0ooK^1P3D?AT30?ofkP030=@m6@3om^h0ooK^0100
ooK^00@0e3dI0?ofkP3om^h0e3dI103om^h00`000000ooK^0000001L0?ofkP40oooo000G0?ofkP03
0000003om^h0ooK^03l0ooK^00<0e3dI0?ofkP3om^h0303om^h0103D?AT0ooK^0=@m6@3om^h50=@m
6@80ooK^103D?AT50?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT01@3om^h203eIZ`040?ofkP0mFJ/0
?EV[03eIZ`@0ooK^00H0?EV[0?ofkP3om^h0ooK^03eIZ`3D?AT20?ofkP<0e3dI00<0?EV[07<M301c
7@`01@1c7@`00`000000Lad<07<M300600000080T2H@00<00000090V402@9Q001`2@9Q000`000000
T2H@090V4007090V40030000002@9Q00T2H@00P0T2H@00<00000090V402@9Q001P2@9Q06000000P0
YBdC00<000000:D]4`2U;A<00`2U;A<203eIZ`<0YBdC00<000000:D]4`2U;A<01P2U;A<00`0mFJ/0
YBdC000000030:D]4`D000000`2U;A<00`000000YBdC0:D]4`030:D]4`0303eIZ`2U;A<0YBdC0080
YBdC00@000000:D]4`2U;A<0YBdC1P0000020;Hb5@0403eIZ`2f<QD0]S8E03eIZ`L0]S8E00<00000
0;Hb5@0mFJ/00P2f<QD00`0mFJ/0]S8E0;Hb5@030;Hb5@0300000019JK`0BFVl0080000000@0?eRJ
0000000`@Vl000001@3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0
e3dI0?ofkP3om^h0203om^h0103D?AT0ooK^0?ofkP3om^h70=@m6@80ooK^00<0e3dI0?ofkP3om^h0
103om^h00`3D?AT0ooK^0?ofkP0@0?ofkP040=@m6@3om^h0ooK^0=@m6@@0ooK^00<000000?ofkP00
0000G03om^h10?ooo`005`3om^h00`000000ooK^0?ofkP0n0?ofkP030=@m6@3om^h0ooK^00`0ooK^
1@3D?AT20?ofkPD0e3dI2@3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00<0ooK^
00<0?EV[0?ofkP3om^h00P0mFJ/30?ofkP030=@m6@3om^h0?EV[0080e3dI00H0?EV[0=@m6@3D?AT0
e3dI0?ofkP00000707<M30D00000202@9Q000`000000T2H@090V4007090V40030000002@9Q00T2H@
00L0T2H@00<00000090V402@9Q00202@9Q000`000000T2H@090V400600000080YBdC00<000000:D]
4`2U;A<02@2U;A<010000000YBdC0:D]4`2U;A<203eIZ`D0YBdC00<000000:D]4`2U;A<01P2U;A<6
000000P0YBdC00@000000:D]4`2U;A<0YBdC0`0mFJ/20:D]4`H00000202f<QD00`0mFJ/0]S8E03eI
Z`080;Hb5@030000002f<QD0?EV[0080]S8E00<0?EV[0;Hb5@2f<QD00`2f<QD01P000000BFVl04UY
_019JK`0000003mHVP<000001@3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00P0
ooK^00<0e3dI0?ofkP3om^h01P3om^h60=@m6@T0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0
ooK^0?ofkP0=0?ofkP@0e3dI0P3om^h00`3D?AT0ooK^0?ofkP020?ofkP030000003om^h0000005`0
ooK^0@3oool001L0ooK^00<000000?ofkP3om^h0?@3om^h00`3D?AT0ooK^0?ofkP080?ofkPD0e3dI
0P3om^h00`3D?AT0ooK^0=@m6@020=@m6@d0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^
0?ofkP030?ofkP80?EV[00@0ooK^03eIZ`0mFJ/0?EV[103D?AT0100mFJ/0ooK^0?ofkP0mFJ/40=@m
6@030000001c7@`0000000D000000P2@9Q000`000000T2H@090V4007090V40030000002@9Q00T2H@
00P0T2H@00<00000090V402@9Q001`2@9Q000`000000T2H@090V4006090V40D00000202U;A<00`00
0000YBdC0:D]4`090:D]4`040000002U;A<0?EV[03eIZ`L0YBdC00<000000:D]4`2U;A<01P000000
0`2U;A<0?EV[0000000;0:D]4`040000002U;A<0YBdC03eIZ`<0000000D0?EV[0000002f<QD0]S8E
0000000;0;Hb5@030000000mFJ/0?EV[00P0]S8E00H000000;Hb5@2f<QD0?EV[0;Hb5@0mFJ/50;Hb
5@0600000019JK`0BFVl04UY_0000000?eRJ0`0000000`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3o
m^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h01`3om^h0103D?AT0ooK^0?ofkP3om^h50=@m6@80ooK^
00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00H0ooK^
1P3D?AT30?ofkP040=@m6@3om^h0ooK^0=@m6@D0ooK^0P00001L0?ofkP40oooo000G0?ofkP030000
003om^h0ooK^03d0ooK^00<0e3dI0?ofkP3om^h00`3om^h50=@m6@H0ooK^00D0e3dI0?ofkP000000
ooK^0=@m6@0>0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h00`3om^h01P0mFJ/0
e3dI0=@m6@0mFJ/0e3dI03eIZ`@0e3dI0P0mFJ/30?ofkP040=@m6@0000000000000000P0T2H@00<0
0000090V402@9Q001`2@9Q000`000000T2H@090V4008090V40030000002@9Q00T2H@00L0T2H@00<0
0000090V402@9Q001P0000020:D]4`030000002U;A<0YBdC00P0YBdC00<000000:D]4`2U;A<0202U
;A<303eIZ`H0YBdC1P0000080:D]4`0303eIZ`2U;A<0YBdC00L0YBdC100000000`0mFJ/0]S8E0;Hb
5@020;Hb5@0503eIZ`2f<QD0]S8E0;Hb5@0000002`2f<QD00`000000?EV[0;Hb5@080;Hb5@060000
002f<QD0]S8E03eIZ`2f<QD0?EV[1@2f<QD020000000BFVl04UY_019JK`0000003mHVP000000?eRJ
0P0000050?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h01@3om^h60=@m6@L0ooK^
00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00H0e3dI
2@3om^h0103D?AT0ooK^0?ofkP3D?AT50?ofkP800000G03om^h10?ooo`005P3om^h00`000000ooK^
0?ofkP0m0?ofkP030=@m6@3om^h0e3dI00@0e3dI2`3om^h00`3D?AT0ooK^000000020?ofkP030=@m
6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h0103om^h60=@m6@80?EV[00@0e3dI03eIZ`0mFJ/0
e3dI0P0mFJ/20?ofkP80?EV[0`3om^h00`3D?AT00000090V4008090V40030000002@9Q00T2H@00P0
T2H@00<00000090V402@9Q001`2@9Q000`000000T2H@090V4006090V40D00000202U;A<00`000000
YBdC0:D]4`080:D]4`030000002U;A<0YBdC00D0YBdC0`0mFJ/0102U;A<0?EV[0:D]4`2U;A<50000
00<0YBdC00<000000:D]4`2U;A<0202U;A<0100mFJ/0YBdC0:D]4`2U;A<600000080]S8E0P0mFJ/5
0;Hb5@0503eIZ`2f<QD0]S8E0;Hb5@0000002`2f<QD203eIZ`T0]S8E00D000000;Hb5@2f<QD0]S8E
03eIZ`050;Hb5@0300000019JK`0BFVl0080BFVl00@0000003mHVP000000?eRJ0P0000050?ofkP03
0=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h01@3D?AT20?ofkP030=@m6@3om^h0ooK^00P0
ooK^00<0e3dI0?ofkP3om^h02`3om^h0103D?AT0ooK^0?ofkP3om^h60=@m6@l0ooK^00@0e3dI0?of
kP3om^h0e3dI1@3om^h00`000000ooK^0000001K0?ofkP40oooo000F0?ofkP030000003om^h0ooK^
03`0ooK^0`3D?AT?0?ofkP050=@m6@3om^h0ooK^0?ofkP0000000P3om^h00`3D?AT0ooK^0?ofkP09
0?ofkP030=@m6@3om^h0ooK^00/0e3dI00L0ooK^03eIZ`0mFJ/0ooK^03eIZ`3om^h0e3dI00<0?EV[
00<0ooK^03eIZ`3om^h00`3om^h00`000000T2H@090V4007090V40030000002@9Q00T2H@00P0T2H@
00<00000090V402@9Q001`2@9Q000`000000T2H@090V400600000080YBdC00<000000:D]4`2U;A<0
202U;A<00`000000YBdC0:D]4`080:D]4`030000002U;A<0YBdC00<0YBdC0P0mFJ/00`2U;A<00000
00000004000000P0YBdC00<000000:D]4`2U;A<01P2U;A<30000000303eIZ`000000000000L0]S8E
00<0?EV[0000002f<QD01P2f<QD0100mFJ/0]S8E0;Hb5@00000:0;Hb5@0403eIZ`2f<QD0]S8E03eI
Z`P0]S8E00D000000;Hb5@2f<QD0]S8E03eIZ`050;Hb5@0300000019JK`0BFVl0080BFVl0`000002
03mHVP030000003om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h0203om^h60=@m6@L0ooK^00<0e3dI
0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP080?ofkPH0e3dI0`3om^h00`3D?AT0ooK^0?ofkP0@
0?ofkP030=@m6@3om^h0e3dI00D0ooK^00<000000?ofkP000000F`3om^h10?ooo`005P3om^h00`00
0000ooK^0?ofkP0k0?ofkP030=@m6@3om^h0ooK^0100ooK^00D0e3dI0?ofkP3om^h0ooK^00000003
0?ofkP030=@m6@3om^h0ooK^00H0ooK^2@3D?AT40?ofkP030=@m6@3om^h0ooK^0080ooK^00H0?EV[
0?ofkP0mFJ/0?EV[0=@m6@0mFJ/20?ofkP<0?EV[0P3om^h00`000000T2H@090V4008090V40030000
002@9Q00T2H@00L0T2H@00<00000090V402@9Q001P2@9Q05000000P0YBdC00<000000:D]4`2U;A<0
202U;A<00`000000YBdC0:D]4`090:D]4`030000002U;A<0000000D000000`2U;A<00`000000?EV[
0:D]4`080:D]4`030000002U;A<0YBdC00H000000P2f<QD00`000000?EV[0;Hb5@070;Hb5@0303eI
Z`2f<QD0000000L0]S8E00@0?EV[0;Hb5@2f<QD000002@2f<QD01@0mFJ/000000;Hb5@2f<QD0?EV[
00L0]S8E00@000000;Hb5@2f<QD0]S8E0P0mFJ/50;Hb5@0600000019JK`0BFVl04UY_0000000BFVl
0P00000203mHVP800000103om^h00`3D?AT0ooK^0?ofkP020?ofkPH0e3dI0`3om^h00`3D?AT0ooK^
0?ofkP080?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h00`3om^h50=@m6@80ooK^
00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP0@0?ofkP040=@m6@3om^h0ooK^0=@m6@@0
ooK^00<000000?ofkP000000F`3om^h10?ooo`005P3om^h00`000000ooK^0?ofkP0k0?ofkP030=@m
6@3om^h0ooK^00l0ooK^00<0e3dI0?ofkP3om^h00`3om^h01@000000ooK^0?ofkP3om^h0e3dI0080
ooK^203D?AT:0?ofkP030=@m6@3om^h0ooK^0080ooK^100mFJ/00`3D?AT0ooK^03eIZ`020?ofkP@0
?EV[00<00000090V402@9Q00202@9Q000`000000T2H@090V4007090V40030000002@9Q00T2H@00H0
00000P2U;A<00`000000e3dI0:D]4`080:D]4`030000002U;A<0YBdC00P0YBdC00<000000:D]4`2U
;A<01@2U;A<6000000T0YBdC00<000000:D]4`0mFJ/01P2U;A<5000000P0]S8E00<0000003eIZ`2f
<QD01@2f<QD203eIZ`80]S8E00<000000;Hb5@2f<QD01P2f<QD00`0mFJ/0]S8E000000080;Hb5@03
03eIZ`2f<QD000000080]S8E00<0?EV[0;Hb5@2f<QD01@2f<QD01`000000]S8E0;Hb5@2f<QD0?EV[
0;Hb5@0mFJ/00P2f<QD3000000<0BFVl00@0000004UY_000000000000P0oF9X2000000<0ooK^1P3D
?AT90?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0=@m
6@030=@m6@L0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP0@0?ofkP040=@m6@3o
m^h0ooK^0=@m6@@0ooK^00<000000?ofkP000000F`3om^h10?ooo`005P3om^h00`000000ooK^0?of
kP0j0?ofkP030=@m6@3om^h0ooK^0100ooK^00<0e3dI0?ofkP3om^h0103om^h80=@m6@@0ooK^00<0
e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP020?ofkP0603eIZ`3om^h0?EV[03eIZ`3om^h0
?EV[0P3om^h0100mFJ/0ooK^03eIZ`3om^h203eIZ`P0T2H@00<00000090V402@9Q001P2@9Q050000
00P0YBdC00<000000:D]4`2U;A<0202U;A<00`000000YBdC0:D]4`080:D]4`030000002U;A<0YBdC
00D0000000D0YBdC03eIZ`0mFJ/0YBdC0000000:0:D]4`030000002U;A<0?EV[00H000000P2f<QD0
0`000000]S8E0;Hb5@080;Hb5@030000002f<QD0?EV[00@0]S8E00<0?EV[0;Hb5@2f<QD00P2f<QD0
0`000000]S8E0;Hb5@060;Hb5@0303eIZ`2f<QD0000000L0]S8E00@0?EV[0;Hb5@2f<QD000000`2f
<QD00`0mFJ/0]S8E0;Hb5@040;Hb5@040000002f<QD0]S8E03eIZ`80000000<0?EV[000000000000
0P33=QL01P000000BFVl04UY_019JK`0000004UY_08000000P0oF9X2000000<0e3dI00<0ooK^0=@m
6@3om^h03@3om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00D0ooK^1@3D?AT;0?of
kP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h0403om^h0103D?AT0ooK^0?ofkP3D?AT5
0?ofkP800000F`3om^h10?ooo`005@3om^h00`000000ooK^0?ofkP0k0?ofkP030=@m6@3om^h0ooK^
00l0ooK^00<0e3dI0?ofkP3om^h01@3D?AT00`000000ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^
00@0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP020?ofkP<0?EV[00/0e3dI03eI
Z`3om^h0?EV[0?ofkP0mFJ/0ooK^03eIZ`3om^h00000090V400203eIZ`H0T2H@00<00000090V402@
9Q001P0000020:D]4`030000002U;A<0YBdC00P0YBdC00<000000:D]4`2U;A<0202U;A<00`000000
YBdC0:D]4`050:D]4`H000000`2U;A<303eIZ`<0YBdC00<000000:D]4`2U;A<01P2U;A<500000003
03eIZ`2f<QD0]S8E00D0]S8E00<000000;Hb5@2f<QD0202f<QD00`000000]S8E03eIZ`030;Hb5@03
03eIZ`2f<QD0]S8E0080]S8E00<000000;Hb5@2f<QD01`2f<QD00`0mFJ/0]S8E000000060;Hb5@05
03eIZ`2f<QD0]S8E0;Hb5@0000000`2f<QD00`0mFJ/0]S8E0;Hb5@020;Hb5@@0000000D0?EV[0<<f
5`33=QL0`cHG03eIZ`040<<f5`8000000P19JK`010000000BFVl04UY_000000203mHVP800000103o
m^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h01@3D
?AT30?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?of
kP0?0?ofkP@0e3dI1@3om^h2000005/0ooK^0@3oool001D0ooK^00<000000?ofkP3om^h0>P3om^h0
0`3D?AT0ooK^0?ofkP0=0?ofkPH0e3dI1P3om^h01@000000ooK^0?ofkP3om^h0e3dI00H0ooK^00<0
e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP020?ofkP80?EV[00@0e3dI03eIZ`3om^h0ooK^
0P0mFJ/20?ofkP0303eIZ`2@9Q00T2H@0080T2H@100mFJ/5000000P0YBdC00<000000:D]4`2U;A<0
202U;A<00`000000YBdC0:D]4`080:D]4`030000002U;A<0000000D000000`2U;A<00`000000YBdC
03eIZ`0303eIZ`H0YBdC00<000000:D]4`2U;A<01P0000020;Hb5@040000002f<QD0]S8E03eIZ`L0
]S8E00<000000;Hb5@2f<QD0202f<QD00`000000]S8E0;Hb5@0303eIZ`D0]S8E00<000000;Hb5@2f
<QD0202f<QD00`0mFJ/000000;Hb5@050;Hb5@0503eIZ`2f<QD0]S8E0;Hb5@0000000P2f<QD00`00
0000?EV[0000000300000080`cHG00<000000<<f5`0mFJ/01033=QL01P0mFJ/0`cHG0<<f5`000000
D7?B00000080BFVl00@0000004UY_019JK`000000P0oF9X3000000@0ooK^00<0e3dI0?ofkP3om^h0
2`3om^h00`3D?AT0ooK^0?ofkP050?ofkPD0e3dI203om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m
6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h0203om^h80=@m6@80ooK^00<0e3dI0?ofkP3om^h0
0`3om^h00`000000ooK^0000001J0?ofkP40oooo000E0?ofkP030000003om^h0ooK^03X0ooK^00<0
e3dI0?ofkP3om^h01`3om^h60=@m6@<0ooK^00<0e3dI0?ofkP3om^h01`3om^h01@000000ooK^0?of
kP3om^h0e3dI00D0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP030?ofkP80?EV[
00<0ooK^03eIZ`3om^h00P0mFJ/20?ofkP0303eIZ`2@9Q00T2H@00@0000000<0?EV[0000000mFJ/0
100mFJ/80:D]4`030000002U;A<0YBdC00P0YBdC00<000000:D]4`2U;A<0102U;A<6000000D0YBdC
1P0mFJ/20:D]4`0303eIZ`2U;A<0YBdC00<0YBdC1@0000080;Hb5@050000002f<QD0]S8E0;Hb5@0m
FJ/01P2f<QD00`000000]S8E0;Hb5@080;Hb5@040000002f<QD0]S8E03eIZ`L0]S8E00<000000;Hb
5@2f<QD0202f<QD00`0mFJ/000000;Hb5@040;Hb5@0303eIZ`2f<QD0]S8E00D000000P33=QL00`0m
FJ/0`cHG0<<f5`030<<f5`030000000mFJ/0`cHG00@0`cHG00H0?EV[0<<f5`33=QL00000051cdP00
000204UY_00400000019JK`0BFVl00000080?eRJ0`0000040?ofkP030=@m6@3om^h0ooK^00/0ooK^
00<0e3dI0?ofkP3D?AT01@3D?AT20?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h0
2`3om^h00`3D?AT0ooK^0?ofkP040?ofkP040=@m6@3om^h0ooK^0?ofkPL0e3dI203om^h00`3D?AT0
ooK^0=@m6@050?ofkP030000003om^h0000005X0ooK^0@3oool001D0ooK^00<000000?ofkP3om^h0
>@3om^h0103D?AT0ooK^0?ofkP3om^h70=@m6@T0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`000000
ooK^0?ofkP020?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT03`3om^h00`3D?AT0ooK^0?ofkP020?of
kP80?EV[00@0ooK^03eIZ`3om^h0ooK^0P0mFJ/0103D?AT0000003eIZ`0000040:D]4`0503eIZ`2U
;A<0YBdC0:D]4`0000000P2U;A<603eIZ`80YBdC00<000000:D]4`2U;A<0202U;A<7000000@0YBdC
00<0000003eIZ`0mFJ/0100mFJ/40:D]4`060000002U;A<0YBdC0:D]4`000000?EV[100000020;Hb
5@030000002f<QD0]S8E00P0]S8E00D000000;Hb5@2f<QD0]S8E03eIZ`060;Hb5@030000002f<QD0
]S8E00P0]S8E00@0000003eIZ`0mFJ/0?EV[1`2f<QD00`000000]S8E0;Hb5@080;Hb5@0403eIZ`00
0000]S8E0;Hb5@80000000@0?EV[00000000000000000P33=QL00`000000`cHG0<<f5`020<<f5`03
03eIZ`33=QL0`cHG0080`cHG00<0000003eIZ`33=QL01P33=QL00`0mFJ/0`cHG00000002051cdP80
00000`19JK`30000000303mHVP000000000000@0ooK^00<0e3dI0?ofkP3om^h01`3om^h60=@m6@P0
ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^0080
ooK^1P3D?AT?0?ofkP030=@m6@3om^h0e3dI00D0ooK^00<000000?ofkP000000FP3om^h10?ooo`00
503om^h00`000000ooK^0?ofkP0j0?ofkP@0e3dI3`3om^h00`3D?AT0ooK^0?ofkP090?ofkP050000
003om^h0ooK^0?ofkP3D?AT00`3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^0080
ooK^00<0e3dI03eIZ`0mFJ/00P0mFJ/20=@m6@0303eIZ`3om^h0000000L0YBdC00@0?EV[0:D]4`2U
;A<00000202U;A<903eIZ`D000002`0mFJ/80:D]4`H0000000<0]S8E03eIZ`2f<QD01@2f<QD00`00
0000]S8E0;Hb5@080;Hb5@030000002f<QD0]S8E0080]S8E00<0?EV[0;Hb5@2f<QD00`2f<QD00`00
0000]S8E0;Hb5@070;Hb5@80?EV[0`2f<QD00`0mFJ/0]S8E0;Hb5@040;Hb5@030000002f<QD0]S8E
00L0]S8E0P0000001@0mFJ/0000000000033=QL0?EV[00H0`cHG00<000000<<f5`33=QL00P33=QL0
0`0mFJ/0`cHG0<<f5`020<<f5`0303eIZ`33=QL0`cHG00H0`cHG00<0?EV[0<<f5`0000000P1@Lm82
00000080BFVl00@0000004UY_000000000000P0oF9X2000000<0ooK^00@0e3dI0?ofkP3om^h0ooK^
1P3D?AT50?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^
0?ofkP0:0?ofkPD0e3dI0P3om^h00`3D?AT0ooK^0?ofkP0@0?ofkP040=@m6@3om^h0ooK^0=@m6@@0
ooK^00<000000?ofkP000000FP3om^h10?ooo`00503om^h00`000000ooK^0?ofkP0j0?ofkP030=@m
6@3om^h0ooK^0100ooK^00<0e3dI0?ofkP3om^h02P3om^h01@000000ooK^0?ofkP3om^h0e3dI0080
ooK^00<0e3dI0?ofkP3om^h0303om^h70=@m6@80?EV[00L0ooK^03eIZ`0mFJ/0ooK^03eIZ`3om^h0
000000L0YBdC00@0?EV[0:D]4`2U;A<000002P2U;A<7000000@0YBdC00<000000:D]4`2U;A<01@2U
;A<0100mFJ/0YBdC0:D]4`0000020:D]4`H000000P2f<QD00`000000]S8E0;Hb5@030;Hb5@0303eI
Z`2f<QD0]S8E00<0]S8E00<000000;Hb5@2f<QD0202f<QD00`000000]S8E0;Hb5@020;Hb5@0303eI
Z`2f<QD0]S8E00<0]S8E00<000000;Hb5@2f<QD01@2f<QD203eIZ`030;Hb5@000000]S8E0080]S8E
00<0?EV[0;Hb5@2f<QD0102f<QD010000000]S8E0;Hb5@2f<QD600000080`cHG00@0?EV[0<<f5`33
=QL0?EV[1`33=QL00`000000`cHG0<<f5`030<<f5`0503eIZ`33=QL0`cHG0<<f5`0mFJ/02033=QL0
0`0mFJ/00000051cdP03051cdP0500000019JK`0BFVl00000019JK`00P00000203mHVP030000003D
?AT0e3dI00H0e3dI2`3om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0
e3dI0?ofkP3om^h01@3om^h60=@m6@H0ooK^00<0e3dI0?ofkP3om^h0403om^h0103D?AT0ooK^0?of
kP3D?AT50?ofkP800000FP3om^h10?ooo`00503om^h00`000000ooK^0?ofkP0i0?ofkP030=@m6@3o
m^h0ooK^0140ooK^00<0e3dI0?ofkP3om^h02P3om^h00`000000ooK^0?ofkP020?ofkP030=@m6@3o
m^h0e3dI00P0ooK^2P3D?AT20?ofkP030=@m6@3om^h0?EV[0080ooK^00D0?EV[0?ofkP0mFJ/0?EV[
000000080:D]4`0303eIZ`2U;A<0000000D0YBdC1P0000000`0mFJ/0YBdC0:D]4`070:D]4`030000
002U;A<0YBdC00<0YBdC0`0000000`0mFJ/0000000000002000000P0]S8E00<000000;Hb5@2f<QD0
0`2f<QD00`0mFJ/0]S8E0;Hb5@030;Hb5@030000002f<QD0]S8E00P0]S8E00<000000;Hb5@2f<QD0
0`2f<QD00`0mFJ/0]S8E0;Hb5@020;Hb5@030000002f<QD0]S8E00<0]S8E0P0mFJ/30;Hb5@050000
002f<QD0]S8E0;Hb5@0mFJ/0102f<QD6000000P0`cHG00<0000003eIZ`0mFJ/01`33=QL00`000000
`cHG0<<f5`040<<f5`0503eIZ`33=QL0`cHG03eIZ`0000002@33=QL00`0mFJ/0D7?B051cdP02051c
dP0300000019JK`0e3dI00L0e3dI00D000000?ofkP3om^h0ooK^0=@m6@0>0?ofkP030=@m6@3om^h0
ooK^00L0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP050=@m6@H0ooK^00<0e3dI
0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP0?0?ofkP040=@m6@3om^h0ooK^0=@m6@D0ooK^0P00
001J0?ofkP40oooo000D0?ofkP030000003om^h0ooK^03T0ooK^00<0e3dI0?ofkP3om^h04@3om^h0
0`3D?AT0ooK^0?ofkP0;0?ofkP040000003om^h0ooK^0?ofkP80e3dI0`3om^h:0=@m6@D0ooK^00@0
e3dI0?ofkP3om^h0e3dI0P3om^h00`0mFJ/0ooK^0?ofkP0303eIZ`030000002U;A<0YBdC00H0YBdC
00<0?EV[0:D]4`0000001@0000050:D]4`030000002U;A<0?EV[00H0YBdC200000030;Hb5@0303eI
Z`2f<QD0000000/0]S8E00<000000;Hb5@2f<QD00`2f<QD00`0mFJ/0]S8E0;Hb5@020;Hb5@030000
002f<QD0]S8E00P0]S8E00<000000;Hb5@2f<QD00`2f<QD00`0mFJ/0]S8E0;Hb5@020;Hb5@040000
002f<QD0]S8E0;Hb5@80?EV[1@2f<QD00`000000]S8E0;Hb5@020000000403eIZ`00000000000000
0080`cHG00<000000<<f5`33=QL02@33=QL00`000000?EV[0<<f5`070<<f5`0300000033=QL0`cHG
00@0`cHG00@0?EV[0<<f5`0mFJ/000002P33=QL00`0mFJ/0D7?B0=@m6@040=@m6@0504UY_0000000
BFVl04UY_00000000P0oF9X2000000<0ooK^00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?of
kP070?ofkP030=@m6@3om^h0ooK^00D0ooK^1P3D?AT;0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0
e3dI0?ofkP3om^h03`3om^h0103D?AT0ooK^0?ofkP3D?AT50?ofkP030000003om^h0000005T0ooK^
0@3oool001@0ooK^00<000000?ofkP3om^h0>@3om^h00`3D?AT0ooK^0?ofkP0A0?ofkP030=@m6@3o
m^h0ooK^00/0ooK^00<000000?ofkP3om^h00P3om^h90=@m6@X0ooK^00@0e3dI0?ofkP3om^h0e3dI
0P3om^h203eIZ`050?ofkP0mFJ/0?EV[0?ofkP0mFJ/01@2U;A<6000000X0YBdC00<000000:D]4`0m
FJ/01P0000020;Hb5@030000002f<QD0]S8E00L0]S8E00<0?EV[0000002f<QD02P2f<QD00`000000
]S8E0;Hb5@030;Hb5@0303eIZ`2f<QD0]S8E00<0]S8E00<000000;Hb5@2f<QD01`2f<QD00`000000
]S8E0;Hb5@040;Hb5@0603eIZ`2f<QD0]S8E0;Hb5@000000]S8E0P0mFJ/50;Hb5@D000000P33=QL0
0`0mFJ/0`cHG0<<f5`030<<f5`0300000033=QL0`cHG00P0`cHG0`0mFJ/80<<f5`0300000033=QL0
`cHG00D0`cHG0P0mFJ/00`000000`cHG0<<f5`080<<f5`80e3dI0P1@Lm801@000000D7?B00000019
JK`000000080BFVl00<0000003mHVP0oF9X00`0000020?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0
e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0=@m6@050=@m6@<0ooK^00<0e3dI0?ofkP3om^h02`3o
m^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^0100ooK^00<0e3dI0?ofkP3D?AT01@3o
m^h00`000000ooK^0000001I0?ofkP40oooo000C0?ofkP030000003om^h0ooK^03X0ooK^00<0e3dI
0?ofkP3om^h04@3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030000003D?AT0e3dI00@0e3dI4@3om^h0
0`3D?AT0ooK^0=@m6@030?ofkP0303eIZ`3om^h0ooK^0080?EV[1P0000040:D]4`0303eIZ`000000
YBdC00L0YBdC1@0000000`0mFJ/0]S8E0;Hb5@050;Hb5@030000002f<QD0]S8E00L0]S8E00<0?EV[
0;Hb5@0000002P2f<QD00`000000]S8E0;Hb5@040;Hb5@0303eIZ`2f<QD0]S8E0080]S8E00<00000
0;Hb5@2f<QD01`2f<QD00`000000]S8E0;Hb5@040;Hb5@0403eIZ`2f<QD0]S8E0;Hb5@80?EV[00<0
]S8E000000000000100000020<<f5`0300000033=QL0`cHG00<0`cHG00<0?EV[0<<f5`33=QL00P33
=QL00`000000`cHG0<<f5`070<<f5`0503eIZ`000000`cHG0<<f5`0mFJ/01`33=QL00`000000`cHG
0<<f5`050<<f5`0303eIZ`33=QL0000000X0`cHG00T00000051cdP1@Lm80D7?B0000001@Lm800000
04UY_00000000P19JK`00`000000?eRJ03mHVP0300000080ooK^00<0e3dI0?ofkP3om^h03@3om^h0
103D?AT0ooK^0?ofkP3om^h70=@m6@T0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?of
kP040?ofkP030=@m6@3om^h0ooK^0100ooK^00<0e3dI0?ofkP3D?AT01@3om^h00`000000ooK^0000
001I0?ofkP40oooo000C0?ofkP030000003om^h0ooK^03T0ooK^00<0e3dI0?ofkP3om^h04@3om^h0
0`3D?AT0ooK^0?ofkP080?ofkPH0e3dI00<000000?ofkP3om^h00P3D?ATB0?ofkP030=@m6@3om^h0
e3dI0080ooK^1P0000000`3om^h0?EV[0:D]4`080:D]4`0303eIZ`2U;A<0YBdC00H000000P2f<QD0
10000000]S8E0;Hb5@0mFJ/70;Hb5@030000002f<QD0]S8E00P0]S8E00<0?EV[0000002f<QD02@2f
<QD00`000000]S8E0;Hb5@040;Hb5@0303eIZ`2f<QD0]S8E0080]S8E00<000000;Hb5@2f<QD01`2f
<QD00`000000]S8E0;Hb5@050;Hb5@<0?EV[0`0000080<<f5`0300000033=QL0`cHG00<0`cHG00<0
?EV[0<<f5`33=QL00P33=QL00`000000`cHG0<<f5`060<<f5`0303eIZ`33=QL000000080`cHG00<0
?EV[0<<f5`33=QL01@33=QL00`000000`cHG0<<f5`040<<f5`80?EV[00<0`cHG00000033=QL02033
=QL00`000000D7?B051cdP02051cdP040000001@Lm800000000000<0BFVl0`00000203mHVP050000
003om^h0ooK^0?ofkP3D?AT02`3om^h70=@m6@H0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0
ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h03@3om^h40=@m6@03
0?ofkP3D?AT0ooK^00@0ooK^00<000000?ofkP000000F@3om^h10?ooo`004`3om^h00`000000ooK^
0?ofkP0i0?ofkP030=@m6@3om^h0ooK^0140ooK^00@0e3dI0?ofkP3om^h0ooK^1`3D?AT60?ofkP03
0000003om^h0ooK^0080e3dI4@3om^h600000080ooK^00H0?EV[0?ofkP0mFJ/0?EV[0?ofkP000002
03eIZ`D0YBdC0`0000000`0mFJ/000000;Hb5@070;Hb5@050000002f<QD0]S8E0;Hb5@0mFJ/01`2f
<QD00`000000]S8E0;Hb5@070;Hb5@0303eIZ`000000]S8E00T0]S8E00<000000;Hb5@2f<QD01@2f
<QD01@0mFJ/0]S8E0;Hb5@2f<QD0000000T0]S8E00<000000;Hb5@2f<QD01000000203eIZ`80`cHG
00<000000<<f5`33=QL02033=QL00`000000`cHG0<<f5`030<<f5`0303eIZ`33=QL0`cHG0080`cHG
00<000000<<f5`33=QL01033=QL203eIZ`80`cHG00D000000<<f5`33=QL0`cHG03eIZ`060<<f5`03
00000033=QL0`cHG00<0`cHG00D0?EV[0<<f5`33=QL0?EV[000000090<<f5`050000001@Lm80D7?B
051cdP0000000`1@Lm801@000000BFVl04UY_0000000BFVl008000000P0oF9X200000080ooK^00<0
e3dI0?ofkP3om^h00`3om^h60=@m6@<0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?of
kP080?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?of
kP060?ofkPH0e3dI0`3om^h00`3D?AT0ooK^0=@m6@060?ofkP800000F@3om^h10?ooo`004`3om^h0
0`000000ooK^0?ofkP0i0?ofkP030=@m6@3om^h0ooK^00l0ooK^1P3D?AT>0?ofkP050000003om^h0
e3dI0?ofkP3D?AT02`3om^h500000080ooK^00<0e3dI0?ofkP3om^h00`3om^h203eIZ`050?ofkP0m
FJ/0?EV[0000002U;A<00`0mFJ/300000080]S8E00<0000003eIZ`2f<QD02@2f<QD010000000]S8E
0;Hb5@0mFJ/70;Hb5@030000002f<QD0]S8E00P0]S8E00<0?EV[0;Hb5@2f<QD0202f<QD00`000000
]S8E0;Hb5@050;Hb5@0503eIZ`2f<QD0]S8E0;Hb5@0000001@2f<QD7000000060<<f5`0mFJ/0?EV[
03eIZ`33=QL0?EV[0P33=QL00`000000`cHG0<<f5`080<<f5`0300000033=QL0`cHG00@0`cHG00D0
?EV[0<<f5`33=QL0`cHG000000050<<f5`0303eIZ`33=QL0`cHG0080`cHG00D000000<<f5`33=QL0
`cHG03eIZ`060<<f5`0300000033=QL0`cHG0080`cHG00D0?EV[0<<f5`33=QL0`cHG03eIZ`080<<f
5`<000000`1@Lm801@000000D7?B051cdP1@Lm8000000080BFVl00@0000004UY_000000000000P0o
F9X2000000030?ofkP3D?AT0e3dI00D0e3dI2@3om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3o
m^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3o
m^h0ooK^00H0e3dI2@3om^h0103D?AT0ooK^0?ofkP3D?AT50?ofkP800000F@3om^h10?ooo`004P3o
m^h00`000000ooK^0?ofkP0j0?ofkP030=@m6@3om^h0ooK^00X0ooK^1@3D?AT20?ofkP030=@m6@3o
m^h0ooK^0100ooK^00@000000=@m6@3om^h0e3dI1@3om^h6000000L0ooK^0P3D?AT50?ofkP@0?EV[
0P0000000`0mFJ/0]S8E0;Hb5@0203eIZ`@0]S8E00<0000003eIZ`2f<QD0202f<QD01@000000]S8E
0;Hb5@2f<QD0?EV[00H0]S8E00<000000;Hb5@2f<QD0202f<QD00`0mFJ/0]S8E0;Hb5@090;Hb5@03
0000002f<QD0]S8E00D0]S8E00<0?EV[0000000000001P0000040<<f5`040000000mFJ/0?EV[03eI
Z`D0`cHG00<0?EV[0<<f5`0000002P33=QL00`000000`cHG0<<f5`040<<f5`0503eIZ`33=QL0`cHG
0<<f5`0000001033=QL00`0mFJ/0`cHG0<<f5`030<<f5`0500000033=QL0`cHG0<<f5`0mFJ/01@33
=QL00`000000`cHG0<<f5`030<<f5`0703eIZ`33=QL0`cHG0<<f5`000000?EV[0<<f5`0600000080
cSXI00D00000051cdP1@Lm80D7?B00000003051cdP0500000019JK`0BFVl00000019JK`00P000002
03mHVP<0000000<0ooK^0=@m6@3om^h03P3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0
ooK^00P0ooK^00<0e3dI0?ofkP3om^h02`3om^h0103D?AT0ooK^0?ofkP3om^h60=@m6@l0ooK^00@0
e3dI0?ofkP3om^h0e3dI1@3om^h00`000000ooK^0000001H0?ofkP40oooo000B0?ofkP030000003o
m^h0ooK^03T0ooK^00<0e3dI0?ofkP3om^h01@3om^h60=@m6@L0ooK^00<0e3dI0?ofkP3om^h0403o
m^h00`000000e3dI0?ofkP06000000d0ooK^0P3D?AT50?ofkP<0?EV[00D0e3dI03eIZ`2f<QD0]S8E
03eIZ`030;Hb5@80?EV[0P2f<QD00`000000?EV[0;Hb5@080;Hb5@030000002f<QD0]S8E0080]S8E
00<0?EV[0;Hb5@2f<QD00`2f<QD00`000000]S8E0;Hb5@080;Hb5@030000000mFJ/0]S8E00T0]S8E
00<000000;Hb5@2f<QD01@000000100mFJ/0`cHG0<<f5`0000060<<f5`@0?EV[2033=QL00`0mFJ/0
`cHG0000000:0<<f5`0300000033=QL0`cHG00@0`cHG00D0?EV[0<<f5`33=QL0`cHG000000020<<f
5`80?EV[1@33=QL00`000000`cHG0<<f5`030<<f5`0303eIZ`33=QL0`cHG0080`cHG00<000000<<f
5`33=QL00P33=QL00`0mFJ/0`cHG0<<f5`030000000303eIZ`000000cSXI00H0cSXI00<0000005=h
g`0000000P1@Lm8020000000D7?B051cdP000000D7?B00000019JK`000000P19JK`00`000000?eRJ
03mHVP03000000030?ofkP3D?AT0ooK^00h0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^
0?ofkP080?ofkP030=@m6@3om^h0ooK^00T0ooK^1P3D?AT30?ofkP030=@m6@3om^h0ooK^0100ooK^
00<0e3dI0?ofkP3D?AT01@3om^h00`000000ooK^0000001H0?ofkP40oooo000B0?ofkP030000003o
m^h0ooK^03T0ooK^00<0e3dI0?ofkP3om^h01@3D?AT=0?ofkP030=@m6@3om^h0ooK^00d0ooK^1P00
00000`3om^h0e3dI0?ofkP0@0?ofkP030=@m6@3om^h0e3dI0080ooK^0`3D?AT203eIZ`050?ofkP0m
FJ/000000;Hb5@0mFJ/01@2f<QD203eIZ`030000002f<QD0?EV[00P0]S8E00<000000;Hb5@2f<QD0
0P2f<QD00`0mFJ/0]S8E0;Hb5@030;Hb5@030000002f<QD0]S8E00T0]S8E00<0?EV[0;Hb5@2f<QD0
1P2f<QD5000000H0`cHG00<0?EV[0<<f5`0000000`33=QL303eIZ`<0`cHG00<000000<<f5`33=QL0
1`33=QL00`0mFJ/000000<<f5`090<<f5`0300000033=QL0`cHG00D0`cHG00H0?EV[0<<f5`33=QL0
00000<<f5`0mFJ/70<<f5`0300000033=QL0`cHG00<0`cHG00<0?EV[0<<f5`33=QL00P33=QL01@00
0000`cHG0<<f5`000000?EV[00<000000P3>>QT00`000000?EV[0<hj6@070<hj6@050000001CN=l0
0000051cdP0000000`1@Lm801@000000D7?B00000019JK`000000080BFVl00<0000003mHVP0oF9X0
0P0000000`0`@Vl000000=@m6@0?0?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h0
2@3om^h00`3D?AT0ooK^0?ofkP020?ofkPH0e3dI0P3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m
6@3om^h0ooK^00l0ooK^103D?AT50?ofkP030000003om^h0000005P0ooK^0@3oool00180ooK^00<0
00000?ofkP3om^h0>@3om^h30=@m6A40ooK^00<0e3dI0?ofkP3om^h02@3om^h5000000<0ooK^00<0
e3dI0?ofkP0000000P3om^h00`3D?AT0ooK^0?ofkP0>0?ofkPD0e3dI0`3om^h303eIZ`050?ofkP0m
FJ/0]S8E0;Hb5@0mFJ/01P2f<QD303eIZ`T0]S8E00<000000;Hb5@2f<QD00P2f<QD00`0mFJ/0]S8E
0;Hb5@020;Hb5@030000002f<QD0]S8E00T0]S8E00<0000003eIZ`2f<QD01P0000020<<f5`030000
0033=QL0`cHG00H0`cHG00<0?EV[0<<f5`0000000`0mFJ/70<<f5`0300000033=QL0`cHG00H0`cHG
00<0?EV[00000033=QL02@33=QL00`000000`cHG0<<f5`050<<f5`0503eIZ`33=QL0`cHG0000000m
FJ/02033=QL00`000000`cHG0<<f5`030<<f5`030000000mFJ/0000000D0000000<0?EV[0<hj6@3>
>QT00`3>>QT010000000cSXI0<hj6@0mFJ/70<hj6@050000001CN=l00000051cdP0000000`1@Lm80
1@000000D7?B00000019JK`000000080BFVl00<0000003mHVP0oF9X0100000000`3D?AT0ooK^0?of
kP0=0?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?ofkP3om^h01`3om^h60=@m6@P0ooK^00<0
e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP080?ofkPH0e3dI00@0ooK^0=@m6@3om^h0e3dI
1@3om^h00`000000ooK^0000001H0?ofkP40oooo000B0?ofkP030000003om^h0ooK^03T0ooK^00<0
e3dI0?ofkP3om^h04@3om^h00`3D?AT0ooK^0?ofkP030?ofkPH00000203om^h00`3D?AT0ooK^0000
00020?ofkP030=@m6@3om^h0ooK^00P0ooK^1`3D?AT00`3om^h0e3dI0?ofkP050?ofkP80?EV[0P3D
?AT20;Hb5@0303eIZ`2f<QD0]S8E00D0]S8E00<0000003eIZ`0mFJ/00P0mFJ/60;Hb5@030000002f
<QD0]S8E0080]S8E00<0?EV[0;Hb5@2f<QD00`2f<QD00`000000]S8E0;Hb5@060;Hb5@<0000000<0
?EV[00000033=QL01`33=QL00`000000`cHG0<<f5`050<<f5`@0?EV[2P33=QL00`000000`cHG0<<f
5`070<<f5`0303eIZ`000000`cHG00P0`cHG00<000000<<f5`33=QL01P33=QL303eIZ`L0`cHG2000
00000`3>>QT0?EV[0<hj6@020<hj6@030000003>>QT0?EV[00H0cSXI00@000000<hj6@3>>QT0?EV[
1P3>>QT01P000000DgSO05=hg`000000D7?B00000080D7?B00<00000051cdP1@Lm800P00000304UY
_080000000<0?eRJ0000000oF9X00P0000000`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^
00L0ooK^00@0e3dI0?ofkP3om^h0ooK^1P3D?AT00`3om^h0e3dI0?ofkP0;0?ofkP030=@m6@3om^h0
ooK^00D0ooK^00@0e3dI0?ofkP3om^h0ooK^1`3D?AT70?ofkP030=@m6@3om^h0e3dI00H0ooK^0P00
001H0?ofkP40oooo000A0?ofkP030000003om^h0ooK^03X0ooK^00<0e3dI0?ofkP3om^h04@3om^h6
000000h0ooK^00@0e3dI0?ofkP3om^h000000P3om^h0103D?AT0ooK^0?ofkP3om^h60=@m6@H0ooK^
00<0e3dI0?ofkP3om^h01P3D?AT303eIZ`050000002f<QD0]S8E0;Hb5@0mFJ/01P2f<QD01@000000
]S8E0;Hb5@0mFJ/0]S8E00D0?EV[00<0]S8E0000002f<QD0102f<QD00`0mFJ/0]S8E0;Hb5@020;Hb
5@030000002f<QD0]S8E00H000000P33=QL00`000000`cHG03eIZ`080<<f5`0300000033=QL0?EV[
00D0?EV[0P33=QL00`0mFJ/000000<<f5`090<<f5`0300000033=QL0`cHG00L0`cHG00<0?EV[0000
0033=QL02033=QL00`000000`cHG0<<f5`060<<f5`0303eIZ`33=QL000000080`cHG1@0000020<hj
6@030000003>>QT0cSXI00@0cSXI00H0?EV[0<hj6@3>>QT0cSXI0000000mFJ/70<hj6@050000003>
>QT0cSXI0<hj6@0mFJ/01@3>>QT01@000000DgSO05=hg`1CN=l0000000<0D7?B00D00000051cdP1@
Lm80D7?B0000000204UY_00600000019JK`0000003mHVP000000?eRJ0`0000000`3D?AT0ooK^0?of
kP0=0?ofkP030=@m6@3om^h0ooK^00<0ooK^1`3D?AT70?ofkP030=@m6@3om^h0ooK^00/0ooK^00@0
e3dI0?ofkP3om^h0ooK^1`3D?AT>0?ofkP040=@m6@3om^h0ooK^0=@m6@D0ooK^0P00001H0?ofkP40
oooo000A0?ofkP030000003om^h0ooK^03X0ooK^00<0e3dI0?ofkP3om^h02`3om^h6000000030=@m
6@3om^h0ooK^0140ooK^00H0e3dI0?ofkP3om^h0ooK^0000003om^h40=@m6@X0ooK^1P3D?AT60?of
kP<0?EV[00@000000;Hb5@2f<QD0?EV[1P2f<QD010000000]S8E0;Hb5@0mFJ/60;Hb5@H0?EV[00@0
]S8E03eIZ`2f<QD0]S8E1@0000080<<f5`0300000033=QL0?EV[00@0`cHG1P0mFJ/90<<f5`0303eI
Z`33=QL0`cHG00P0`cHG00<000000<<f5`33=QL01`33=QL00`0mFJ/000000<<f5`080<<f5`030000
0033=QL0`cHG00@0`cHG0`0mFJ/4000000L0cSXI00<000000<hj6@3>>QT01@3>>QT01@0mFJ/0cSXI
0000003>>QT0?EV[00L0cSXI00D000000<hj6@3>>QT0cSXI03eIZ`040<hj6@030000001CN=l0DgSO
0080DgSO00D00000051cdP1@Lm80D7?B00000003051cdP0400000019JK`0BFVl00000080BFVl0P00
00001@0oF9X00000000000000000e3dI00l0ooK^1P3D?AT30?ofkP030=@m6@3om^h0ooK^00T0ooK^
00<0e3dI0?ofkP3om^h0203om^h60=@m6@<0ooK^00<0e3dI0?ofkP3om^h03`3om^h0103D?AT0ooK^
0?ofkP3D?AT50?ofkP030000003om^h0000005L0ooK^0@3oool00140ooK^00<000000?ofkP3om^h0
>@3om^h00`3D?AT0ooK^0?ofkP070?ofkPD000001P3om^h00`3D?AT0ooK^0?ofkP0A0?ofkP070=@m
6@3om^h0ooK^0?ofkP000000ooK^0=@m6@070?ofkPH0e3dI0P3om^h0103D?AT0ooK^0?ofkP3D?AT6
0?ofkP@0?EV[0`2f<QD00`0mFJ/0]S8E0;Hb5@030;Hb5@050000002f<QD0]S8E0;Hb5@0mFJ/01`2f
<QD010000000]S8E0;Hb5@00000H03eIZ`D0`cHG00<000000<<f5`33=QL01`33=QL00`0mFJ/00000
0<<f5`080<<f5`0300000033=QL0`cHG00P0`cHG00<0?EV[0<<f5`33=QL01`33=QL00`000000`cHG
0<<f5`0200000080?EV[0P0000000`3>>QT0?EV[000000090<hj6@030000003>>QT0cSXI00D0cSXI
00@0?EV[0<hj6@000000?EV[1`3>>QT00`000000cSXI0<hj6@020<hj6@0703eIZ`3>>QT0cSXI0<hj
6@0mFJ/000000=@m6@0305=hg`050000001@Lm80D7?B051cdP0000000`1@Lm8010000000BFVl04UY
_000000204UY_080000000D0?eRJ000000000000?EV[0=@m6@090?ofkPL0e3dI203om^h00`3D?AT0
ooK^0?ofkP090?ofkP040=@m6@3om^h0ooK^0?ofkPL0e3dI0P3om^h00`3D?AT0ooK^0?ofkP040?of
kP030=@m6@3om^h0ooK^0100ooK^00<0e3dI0?ofkP3D?AT01@3om^h00`000000ooK^0000001G0?of
kP40oooo000A0?ofkP030000003om^h0ooK^03T0ooK^00@0e3dI0?ofkP3om^h0ooK^1P00000;0?of
kP030=@m6@3om^h0ooK^0140ooK^00<0e3dI0?ofkP3om^h00P3om^h010000000ooK^0=@m6@3om^h5
0=@m6@P0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@060?ofkP80?EV[00D0000003eIZ`2f<QD0]S8E
03eIZ`060;Hb5@040000002f<QD0]S8E03eIZ`80]S8E200000040<<f5`0503eIZ`33=QL0`cHG0<<f
5`0000002P33=QL00`000000`cHG03eIZ`080<<f5`0300000033=QL0`cHG00P0`cHG00<0?EV[0<<f
5`33=QL01`33=QL00`000000`cHG0<<f5`080<<f5`0303eIZ`33=QL0`cHG00<0`cHG1`00000203eI
Z`D0cSXI00<0?EV[0000003>>QT01`3>>QT00`000000cSXI0<hj6@070<hj6@80?EV[203>>QT00`00
0000cSXI0<hj6@030<hj6@0603eIZ`3>>QT0?EV[0<hj6@000000e3dI0P1CN=l01@000000DgSO0000
001@Lm80000000<0D7?B00D00000051cdP000000BFVl0000000304UY_0030000000oF9X000000080
000000@0e3dI0?ofkP3om^h0ooK^1P3D?AT60?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?of
kP3om^h01P3om^h70=@m6@T0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP0@0?of
kP030=@m6@3om^h0e3dI00D0ooK^00<000000?ofkP000000E`3om^h10?ooo`00403om^h00`000000
ooK^0?ofkP0h0?ofkPH000004@3om^h00`3D?AT0ooK^0?ofkP0A0?ofkP030=@m6@3om^h0ooK^00H0
e3dI3@3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00L0ooK^0P0mFJ/01@2f<QD0?EV[03eIZ`2f<QD0
?EV[00<0]S8E1P0000000`0mFJ/000000<<f5`040<<f5`0300000033=QL0`cHG00@0`cHG00D0?EV[
0<<f5`33=QL0`cHG0000000:0<<f5`0400000033=QL0`cHG03eIZ`L0`cHG00<000000<<f5`33=QL0
2033=QL00`0mFJ/0`cHG0<<f5`080<<f5`0300000033=QL0`cHG00D0`cHG0`0000000`0mFJ/00000
00000002000000@0cSXI00<000000<hj6@0mFJ/0203>>QT00`0mFJ/0cSXI0<hj6@060<hj6@030000
003>>QT0cSXI00L0cSXI00<0?EV[0000003>>QT01`3>>QT00`000000cSXI0<hj6@030<hj6@0603eI
Z`3>>QT0?EV[0000001CN=l0e3dI0P1CN=l01@000000DgSO0000001@Lm80000000<0D7?B00D00000
051cdP000000BFVl0000000304UY_0030000000oF9X0000000H0e3dI3@3om^h00`3D?AT0ooK^0?of
kP050?ofkP030=@m6@3om^h0ooK^00H0e3dI0`3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3o
m^h0ooK^00D0ooK^00<0e3dI0?ofkP3om^h03`3om^h00`3D?AT0ooK^0=@m6@050?ofkP030000003o
m^h0000005L0ooK^0@3oool00100ooK^00<000000?ofkP3om^h0<P3om^h600000080ooK^00<0e3dI
0?ofkP3om^h04@3om^h00`3D?AT0ooK^0?ofkP0?0?ofkPH0e3dI0`3om^h00`000000e3dI0?ofkP0=
0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT01`3om^h203eIZ`030000002f<QD0]S8E0080?EV[0`00
00020<<f5`0300000033=QL0`cHG0080`cHG00<0?EV[0<<f5`33=QL01033=QL00`000000`cHG0<<f
5`040<<f5`0403eIZ`33=QL0`cHG000000X0`cHG00@000000<<f5`33=QL0?EV[1`33=QL00`000000
`cHG0<<f5`080<<f5`030000000mFJ/0`cHG00P0`cHG00<000000<<f5`33=QL01@0000020<hj6@03
0000000mFJ/0cSXI00L0cSXI0P0mFJ/90<hj6@0303eIZ`3>>QT0cSXI00H0cSXI00<000000<hj6@3>
>QT01@3>>QT303eIZ`P0cSXI00<000000<hj6@3>>QT01@3>>QT01`0mFJ/0cSXI0000001CN=l0e3dI
05=hg`0000000P1CN=l00`000000D7?B00000003051cdP050000001@Lm80000004UY_00000001P3D
?AT2000000030=@m6@3om^h0ooK^00h0ooK^00@0e3dI0?ofkP3om^h0ooK^1`3D?AT90?ofkP030=@m
6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP040=@m
6@3om^h0ooK^0=@m6@D0ooK^0P00001G0?ofkP40oooo000@0?ofkP030000003om^h0ooK^02`0ooK^
1P0000080?ofkP030=@m6@3om^h0ooK^0140ooK^00<0e3dI0?ofkP3om^h0203om^h70=@m6@<0ooK^
00<0e3dI0?ofkP3om^h0103om^h00`000000e3dI0?ofkP0<0?ofkP030=@m6@3om^h0ooK^0080ooK^
00<0e3dI0?ofkP3om^h01@3om^h203eIZ`80000000<0`cHG03eIZ`0mFJ/01@33=QL01@000000`cHG
0<<f5`33=QL0?EV[00H0`cHG00<000000<<f5`33=QL01033=QL01@0mFJ/0`cHG0<<f5`33=QL00000
00X0`cHG00@000000<<f5`33=QL0?EV[1P33=QL00`000000`cHG0<<f5`080<<f5`030000000mFJ/0
`cHG00H0`cHG1@0000070<hj6@030000003>>QT0?EV[00D0cSXI0P0mFJ/00`000000cSXI0<hj6@08
0<hj6@0303eIZ`3>>QT0cSXI00H0cSXI00<000000<hj6@3>>QT0103>>QT01@0mFJ/0cSXI0<hj6@00
0000?EV[00L0cSXI00<000000<hj6@3>>QT01@3>>QT01`0mFJ/0cSXI0000001CN=l0e3dI05=hg`00
00000`1CN=l010000000D7?B051cdP1@Lm860=@m6@<0BFVl0`0000000`0oF9X000000=@m6@0>0?of
kPH0e3dI1@3om^h00`3D?AT0ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?of
kP3om^h0103om^h00`3D?AT0ooK^0?ofkP0?0?ofkP040=@m6@3om^h0ooK^0=@m6@D0ooK^0P00001G
0?ofkP40oooo000@0?ofkP030000003om^h0ooK^02L0ooK^1@00000>0?ofkP030=@m6@3om^h0ooK^
0140ooK^00@0e3dI0?ofkP3om^h0ooK^1`3D?AT:0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<00000
0=@m6@3om^h0303om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00D0ooK^0`0mFJ/3
0<<f5`0303eIZ`33=QL0`cHG00<0`cHG00<000000<<f5`33=QL00P33=QL00`0mFJ/0`cHG0<<f5`03
0<<f5`0300000033=QL0`cHG00D0`cHG00@0?EV[0<<f5`33=QL000002P33=QL010000000`cHG0<<f
5`0mFJ/70<<f5`0300000033=QL0`cHG00L0`cHG00<000000<<f5`0mFJ/01P0000020<hj6@030000
003>>QT0cSXI00L0cSXI00<000000<hj6@0mFJ/00`3>>QT203eIZ`80cSXI00@000000<hj6@3>>QT0
e3dI1`3>>QT00`000000?EV[0<hj6@060<hj6@030000003>>QT0cSXI00<0cSXI00H0?EV[0<hj6@3>
>QT0cSXI0000000mFJ/70<hj6@030000003>>QT0cSXI00@0cSXI0P0mFJ/01`000000DgSO05=hg`3D
?AT0DgSO0000001CN=l01P3D?AT01@000000D7?B051cdP1@Lm80000000<0BFVl00D0000004UY_000
0000000003mHVP02000000030=@m6@3om^h0ooK^00H0ooK^1@3D?AT20?ofkP030=@m6@3om^h0ooK^
00H0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^
00@0ooK^00<0e3dI0?ofkP3om^h03`3om^h0103D?AT0ooK^0?ofkP3D?AT50?ofkP030000003om^h0
000005H0ooK^0@3oool00100ooK^00<000000?ofkP3om^h08@3om^h6000001<0ooK^00<0e3dI0?of
kP3om^h03`3om^h60=@m6A40ooK^00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP0;0?of
kP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h01P3om^h203eIZ`@0`cHG0P0mFJ/40<<f
5`0500000033=QL0`cHG0<<f5`0mFJ/01P33=QL00`000000`cHG0<<f5`040<<f5`0403eIZ`33=QL0
`cHG000000X0`cHG00D000000<<f5`33=QL0`cHG03eIZ`060<<f5`0300000033=QL0`cHG00D0`cHG
100000000`0mFJ/0cSXI0<hj6@060<hj6@030000003>>QT0cSXI00L0cSXI00<000000<hj6@3>>QT0
0`0mFJ/40<hj6@030000003>>QT0cSXI00L0cSXI00<000000<hj6@0mFJ/01`3>>QT010000000cSXI
0<hj6@3>>QT203eIZ`@0cSXI00<0000003eIZ`3>>QT01P3>>QT00`000000cSXI0<hj6@030<hj6@03
03eIZ`000000?EV[00L0e3dI0P1CN=l01@000000D7?B051cdP1@Lm80000000<0D7?B00H0000004UY
_019JK`0BFVl00000019JK`20000000403mHVP00000000000=@m6@<0ooK^1@3D?AT70?ofkP030=@m
6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m
6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h0403om^h00`3D?AT0ooK^0=@m6@050?ofkP030000
003om^h0000005H0ooK^0@3oool000l0ooK^00<000000?ofkP3om^h0703om^h6000001P0ooK^00<0
e3dI0?ofkP3om^h02`3om^h50=@m6@80ooK^00<0e3dI0?ofkP3om^h04P3om^h00`3D?AT0ooK^0?of
kP060?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h00`3om^h0103D?AT0ooK^0?of
kP3om^h50=@m6@80?EV[1033=QL303eIZ`80`cHG00<000000<<f5`33=QL00P33=QL00`0mFJ/0`cHG
0<<f5`030<<f5`0300000033=QL0`cHG00D0`cHG00@0?EV[0<<f5`33=QL000002@33=QL01@000000
`cHG0<<f5`33=QL0?EV[00H0`cHG00<000000<<f5`33=QL01@0000020<hj6@040000003>>QT0cSXI
03eIZ`L0cSXI00<000000<hj6@3>>QT01`3>>QT010000000cSXI03eIZ`0mFJ/60<hj6@030000003>
>QT0cSXI00L0cSXI00@000000<hj6@3>>QT0?EV[1P3>>QT010000000cSXI0<hj6@0mFJ/50<hj6@04
0000003>>QT0cSXI03eIZ`D0cSXI00<000000<hj6@3>>QT00`0000001@0mFJ/000000=Pm6P3H?AX0
00000080DgSO00<0e3dI0000001CN=l00P1CN=l00`000000DgSO00000002051cdP050000001@Lm80
D7?B051cdP0000000`19JK`01@000000BFVl04UY_0000000?eRJ00800000103D?AT<0?ofkP030=@m
6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m
6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h0403om^h0103D?AT0ooK^0?ofkP3D?AT40?ofkP03
0000003om^h0000005H0ooK^0@3oool000l0ooK^00<000000?ofkP3om^h05P3om^h6000001h0ooK^
00<0e3dI0?ofkP3om^h01@3om^h60=@m6@L0ooK^00<0e3dI0?ofkP3om^h04P3om^h00`3D?AT0ooK^
0?ofkP060?ofkP030=@m6@3om^h0ooK^00X0ooK^00@0e3dI0?ofkP3om^h0ooK^1P3D?AT50?ofkP80
?EV[1033=QL00`0mFJ/0`cHG0<<f5`0203eIZ`0300000033=QL0`cHG00<0`cHG00<0?EV[0<<f5`33
=QL00`33=QL00`000000`cHG0<<f5`040<<f5`0403eIZ`33=QL0`cHG000000X0`cHG00H000000<<f
5`33=QL0`cHG03eIZ`33=QL7000000L0cSXI00@000000<hj6@3>>QT0?EV[1`3>>QT00`000000cSXI
0<hj6@060<hj6@<0?EV[00<0cSXI03eIZ`3>>QT01@3>>QT00`000000cSXI0<hj6@070<hj6@040000
003>>QT0cSXI03eIZ`D0cSXI00@000000<hj6@3>>QT0?EV[1P3>>QT01@000000cSXI0<hj6@0mFJ/0
cSXI00L000000P3H?AX02P0mFJ/0f3dJ0=Pm6P3H?AX0000005AkiP000000DgSO0=@m6@00000305=h
g`030000001CN=l000000080D7?B00H00000051cdP1@Lm800000051cdP00000204UY_00500000019
JK`0BFVl0000000oF9X00P0000000`3D?AT0ooK^0?ofkP0>0?ofkP030=@m6@3om^h0ooK^00D0ooK^
00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00@0ooK^
00<0e3dI0?ofkP3om^h03@3om^h40=@m6@80ooK^00<0e3dI0?ofkP3om^h00P3om^h00`000000ooK^
0000001F0?ofkP40oooo000?0?ofkP030000003om^h0ooK^0140ooK^1@00000T0?ofkP030=@m6@3o
m^h0ooK^00D0e3dI3@3om^h00`3D?AT0ooK^0?ofkP0B0?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0
e3dI0000003om^h0203om^h60=@m6@80ooK^00<0e3dI0?ofkP3om^h01`3om^h203eIZ`@0`cHG00@0
?EV[0<<f5`33=QL0`cHG0`0mFJ/30<<f5`0303eIZ`33=QL0`cHG00<0`cHG00<000000<<f5`33=QL0
1@33=QL00`0mFJ/0`cHG000000080<<f5`H0000000<0?EV[0000003>>QT00`3>>QT00`000000cSXI
0<hj6@080<hj6@040000003>>QT0cSXI03eIZ`H0cSXI00<000000<hj6@3>>QT00`3>>QT303eIZ`03
0<hj6@000000cSXI0080cSXI00<0?EV[0<hj6@3>>QT00`3>>QT00`000000cSXI0<hj6@070<hj6@04
0000003>>QT0cSXI03eIZ`D0cSXI00<0000003eIZ`0mFJ/01@3>>QT50000000303eIZ`000000f3dJ
00<0f3dJ00D000000=Pm6P3H?AX0f3dJ03eIZ`040=Pm6P060000001DNnH0000005=hg`000000e3dI
0P1CN=l010000000DgSO05=hg`1CN=l2000000<0D7?B00<00000051cdP0000000P19JK`01@000000
BFVl04UY_0000000?eRJ0080000000<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP050?of
kP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP040?of
kP030=@m6@3om^h0ooK^00L0ooK^1P3D?AT30?ofkP@0e3dI1@3om^h2000005H0ooK^0@3oool000l0
ooK^00<000000?ofkP3om^h02`3om^h6000002T0ooK^0`3D?ATB0?ofkP030=@m6@3om^h0ooK^0180
ooK^00<0e3dI0?ofkP3om^h01`3om^h0103D?AT000000?ofkP3om^h60=@m6@80ooK^00<0e3dI0?of
kP3om^h0103om^h00`3D?AT0ooK^0?ofkP060?ofkP80?EV[1@33=QL01P0mFJ/0`cHG0<<f5`33=QL0
00000<<f5`80?EV[0P33=QL00`0mFJ/0`cHG0<<f5`020<<f5`0300000033=QL0`cHG00D0`cHG00@0
?EV[0<<f5`33=QL000000P33=QL500000080cSXI00<000000<hj6@3>>QT00P3>>QT00`0mFJ/0cSXI
0<hj6@030<hj6@030000003>>QT0cSXI00L0cSXI00@000000<hj6@3>>QT0?EV[1P3>>QT00`000000
cSXI0<hj6@0303eIZ`D0cSXI00@000000<hj6@3>>QT0?EV[1@3>>QT00`000000cSXI0<hj6@070<hj
6@050000003>>QT0cSXI0<hj6@0mFJ/0103>>QT00`0mFJ/0cSXI0<hj6@0500000080f3dJ00D00000
0=Pm6P3H?AX0f3dJ03eIZ`030=Pm6P050000003H?AX0f3dJ0=Pm6P0mFJ/0103H?AX01`000000E7_V
05AkiP000000DgSO0000003D?AT00P1CN=l010000000DgSO05=hg`1CN=l2000000<0D7?B00<00000
051cdP1@Lm800P00000304UY_0<0000000<0?eRJ0=@m6@0000003`3om^h00`3D?AT0ooK^0?ofkP05
0?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP04
0?ofkP030=@m6@3om^h0ooK^00H0e3dI1@3om^h50=@m6@80ooK^00<0e3dI0?ofkP3om^h00`3om^h2
000005H0ooK^0@3oool000h0ooK^00<000000?ofkP3om^h01P3om^h6000002l0ooK^00<0e3dI0?of
kP3om^h04P3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^00H0ooK^103D?AT80?of
kP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h01`3om^h203eIZ`@0`cHG00<0?EV[0<<f
5`33=QL00P33=QL00`000000`cHG0<<f5`0303eIZ`D0`cHG00<000000<<f5`33=QL00`33=QL20000
000303eIZ`000000000000800000203>>QT01@000000cSXI0<hj6@3>>QT0?EV[00D0cSXI00<00000
0<hj6@3>>QT01`3>>QT01@000000cSXI0<hj6@3>>QT0?EV[00D0cSXI0`0mFJ/80<hj6@050000003>
>QT0cSXI0<hj6@0mFJ/0103>>QT00`000000cSXI0<hj6@070<hj6@050000003>>QT0cSXI0<hj6@0m
FJ/00P3>>QT00`000000?EV[00000002000000H0f3dJ00<000000=Pm6P3H?AX00P3H?AX01@0mFJ/0
f3dJ0=Pm6P3H?AX000000080f3dJ00<0?EV[0=Pm6P3H?AX00`3H?AX01`000000E7_V05AkiP1DNnH0
000005=hg`3D?AT00P1CN=l00`000000DgSO05=hg`0205=hg`050000001@Lm80D7?B051cdP000000
0P1@Lm8200000080BFVl00L0000004UY_0000000000003mHVP000000e3dI00l0ooK^00<0e3dI0?of
kP3om^h01@3om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^00/0ooK^00@0e3dI0?of
kP3om^h0ooK^1P3D?AT50?ofkPH0e3dI1@3om^h00`3D?AT0ooK^0=@m6@050?ofkP030000003om^h0
000005D0ooK^0@3oool000h0ooK^00<000000?ofkP3om^h01P00000e0?ofkP030=@m6@3om^h0ooK^
0180ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h00000
00T0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP050?ofkP<0e3dI0P0mFJ/40<<f
5`0503eIZ`33=QL0`cHG0<<f5`0000001033=QL403eIZ`P000000P3>>QT00`0mFJ/0cSXI0000000:
0<hj6@030000003>>QT0cSXI0080cSXI00<0?EV[0<hj6@3>>QT00P3>>QT00`000000cSXI0<hj6@07
0<hj6@050000003>>QT0cSXI0<hj6@0mFJ/00P3>>QT303eIZ`030<hj6@000000cSXI00P0cSXI00D0
00000<hj6@3>>QT0cSXI03eIZ`040<hj6@030000003>>QT0cSXI00L0cSXI00<000000<hj6@3>>QT0
0P00000303eIZ`030=Pm6P000000f3dJ00L0f3dJ00<000000=Pm6P3H?AX00`3H?AX01P0mFJ/0f3dJ
0=Pm6P000000f3dJ03eIZ`H0f3dJ00T0000005AkiP1DNnH0E7_V0000001CN=l0e3dI05=hg`000000
101CN=l200000080D7?B00<00000051cdP1@Lm800P1@Lm801@000000BFVl04UY_0000000BFVl0080
000000<0?eRJ0000003D?AT03`3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00P0
ooK^00<0e3dI0?ofkP3om^h0203om^h70=@m6@<0ooK^00<0e3dI0?ofkP3om^h01@3D?AT;0?ofkP03
0=@m6@3om^h0e3dI00D0ooK^00<000000?ofkP000000E@3om^h10?ooo`003P3om^h3000003/0ooK^
00<0e3dI0?ofkP3om^h04P3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^00L0ooK^
00<0e3dI0?ofkP000000203om^h00`3D?AT0ooK^0?ofkP050?ofkPL0e3dI0`3om^h010000000?EV[
03eIZ`0mFJ/20<<f5`0303eIZ`33=QL0`cHG0080`cHG00<000000<<f5`33=QL00`0000000`0mFJ/0
000003eIZ`0403eIZ`H0cSXI00<0?EV[0<hj6@0000002P3>>QT01@000000cSXI0<hj6@3>>QT0?EV[
00D0cSXI00<000000<hj6@3>>QT01`3>>QT00`000000cSXI03eIZ`0303eIZ`@0cSXI00<000000<hj
6@3>>QT01`3>>QT00`000000cSXI0<hj6@020<hj6@0503eIZ`3>>QT0cSXI0<hj6@0000001@3>>QT7
00000080f3dJ00D0?EV[0=Pm6P3H?AX0f3dJ000000080=Pm6P030000003H?AX0f3dJ00<0f3dJ00D0
?EV[0=Pm6P000000f3dJ03eIZ`060=Pm6P030000001DNnH0E7_V0080E7_V00D0000005=hg`3D?AT0
DgSO0000000405=hg`050000001CN=l00000051cdP000000101@Lm801@000000BFVl04UY_0000000
BFVl0080000000@0?eRJ0000003D?AT0?EV[3P3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3o
m^h0ooK^00T0ooK^00@0e3dI0?ofkP3om^h0ooK^1P3D?AT30?ofkP040=@m6@3om^h0ooK^0?ofkPH0
e3dI403om^h0103D?AT0ooK^0?ofkP3D?AT40?ofkP030000003om^h0000005D0ooK^0@3oool000l0
ooK^00<000000?ofkP3om^h0>P3om^h00`3D?AT0ooK^0?ofkP0B0?ofkP030=@m6@3om^h0ooK^01<0
ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^000000080?ofkP030=@m6@3om^h0ooK^00H0
e3dI2@3om^h01@000000`cHG03eIZ`33=QL0?EV[0080`cHG00<0?EV[0<<f5`000000100000030<hj
6@0303eIZ`3>>QT0cSXI0080cSXI00<000000<hj6@0mFJ/0100mFJ/0103>>QT0?EV[0<hj6@00000:
0<hj6@030000003>>QT0cSXI0080cSXI00<0?EV[0<hj6@3>>QT00P3>>QT00`000000cSXI0<hj6@03
0<hj6@H0?EV[0P3>>QT00`0mFJ/0cSXI0<hj6@030<hj6@030000003>>QT0cSXI00L0cSXI00<00000
0<hj6@3>>QT00P3>>QT00`0mFJ/0cSXI00000007000000@0f3dJ00<000000=Pm6P3H?AX00`0mFJ/3
0=Pm6P030000003H?AX0f3dJ00H0f3dJ00<000000=Pm6P3H?AX00`3H?AX0100mFJ/0f3dJ0000000m
FJ/70=Pm6P0:0000001DNnH0E7_V05AkiP000000E7_V0000003D?AT0DgSO000000<0DgSO00H00000
05=hg`1CN=l00000051cdP000003051cdP050000001@Lm80000004UY_00000000P19JK`01@000000
?eRJ0000003D?AT0?EV[00h0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP070?of
kPH0e3dI1`3om^h60=@m6@<0ooK^00<0e3dI0?ofkP3om^h0403om^h0103D?AT0ooK^0?ofkP3D?AT4
0?ofkP030000003om^h0000005D0ooK^0@3oool00100ooK^00<000000?ofkP3om^h0>@3om^h00`3D
?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^0180ooK^00<0e3dI0?ofkP3om^h01`3om^h0103D
?AT0ooK^0?ofkP0000040?ofkPH0e3dI1@3om^h00`3D?AT0ooK^0?ofkP080?ofkP0500000033=QL0
?EV[0000000mFJ/00P0000001@0mFJ/0cSXI0<hj6@3>>QT0000000D0cSXI00D0?EV[0<hj6@3>>QT0
cSXI000000060<hj6@/0?EV[0`3>>QT00`000000cSXI0<hj6@020<hj6@0303eIZ`3>>QT0cSXI0080
cSXI1P0mFJ/40<hj6@030000003>>QT0cSXI0080cSXI00<0?EV[0<hj6@3>>QT00P3>>QT00`000000
cSXI0<hj6@070<hj6@030000003>>QT0cSXI0080000000D0?EV[0000003H?AX0f3dJ000000090=Pm
6P030000000mFJ/0?EV[00<0f3dJ00<0?EV[0=Pm6P000000203H?AX00`000000f3dJ0=Pm6P050=Pm
6P80?EV[1`3H?AX00`000000E7_V05AkiP0205AkiP050000001DNnH0000005=hg`3D?AT0101CN=l0
1P000000DgSO05=hg`000000D7?B000000<0D7?B00D00000051cdP000000BFVl0000000204UY_005
0000000oF9X000000=@m6@0000003P3om^h00`3D?AT0ooK^0?ofkP060?ofkP040=@m6@3om^h0ooK^
0?ofkPH0e3dI0P3om^h0103D?AT0ooK^0?ofkP3om^h70=@m6@<0ooK^00<0e3dI0?ofkP3om^h00`3o
m^h00`3D?AT0ooK^0?ofkP0@0?ofkP040=@m6@3om^h0ooK^0=@m6@D0ooK^0P00001E0?ofkP40oooo
000A0?ofkP030000003om^h0ooK^03P0ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?of
kP0B0?ofkP030=@m6@3om^h0ooK^00P0ooK^1`3D?AT30?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0
e3dI0?ofkP3om^h0203om^h20000000603eIZ`3>>QT0cSXI03eIZ`3>>QT0?EV[0`3>>QT00`000000
cSXI0<hj6@030<hj6@0303eIZ`3>>QT0cSXI0080cSXI00<000000<hj6@3>>QT01P3>>QT00`0mFJ/0
00000<hj6@050<hj6@d0?EV[00<0cSXI0000003>>QT01`3>>QT00`000000cSXI0<hj6@020<hj6@03
03eIZ`3>>QT0cSXI0080cSXI00<000000<hj6@3>>QT00`3>>QT7000000<0f3dJ00@0?EV[0=Pm6P3H
?AX00000203H?AX203eIZ`D0f3dJ00<0?EV[0=Pm6P000000203H?AX00`000000f3dJ0=Pm6P050=Pm
6P0303eIZ`3H?AX0f3dJ00H0f3dJ00D0000005AkiP1DNnH0E7_V0000000205AkiP030000001CN=l0
e3dI00<0DgSO00<0000005=hg`1CN=l00P1CN=l00`000000D7?B051cdP02051cdP050000001@Lm80
000004UY_00000000P19JK`010000000?eRJ0000003D?AT2000000h0ooK^00<0e3dI0?ofkP3om^h0
0P3om^h70=@m6@D0ooK^1`3D?AT:0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h0
403om^h0103D?AT0ooK^0?ofkP3D?AT50?ofkP800000E@3om^h10?ooo`004@3om^h00`000000ooK^
0?ofkP0h0?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h04P3om^h0103D?AT0ooK^
0?ofkP3om^h80=@m6@80ooK^00<000000?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP060?ofkP03
0=@m6@3om^h0ooK^00P0ooK^00<000000<hj6@0mFJ/00P3>>QT00`0mFJ/0cSXI03eIZ`030<hj6@03
0000003>>QT0cSXI00<0cSXI00D0?EV[0<hj6@3>>QT0cSXI000000080<hj6@0303eIZ`000000cSXI
00T0cSXI00<000000<hj6@3>>QT00P3>>QT00`0mFJ/0cSXI0<hj6@020<hj6@030000003>>QT0cSXI
00L0cSXI00<000000<hj6@3>>QT00P3>>QT00`0mFJ/0cSXI00000007000000@0f3dJ00<000000=Pm
6P3H?AX00`3H?AX0100mFJ/0f3dJ0=Pm6P0000060=Pm6P80?EV[00<000000=Pm6P3H?AX01@3H?AX0
0`0mFJ/000000=Pm6P070=Pm6P030000003H?AX0f3dJ00@0f3dJ0P0mFJ/80=Pm6P050000001DNnH0
E7_V05AkiP0000000`1DNnH00`000000e3dI05=hg`0205=hg`030000001CN=l0DgSO0080DgSO00D0
0000051cdP1@Lm80D7?B00000002051cdP8000000`19JK`30000000303mHVP3D?AT0000000/0ooK^
203D?AT30?ofkP030=@m6@3om^h0ooK^00H0e3dI0`3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m
6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h0403om^h00`3D?AT0ooK^0=@m6@050?ofkP030000
003om^h0000005@0ooK^0@3oool00180ooK^00<000000?ofkP3om^h0>03om^h00`3D?AT0ooK^0?of
kP0B0?ofkP030=@m6@3om^h0ooK^0100ooK^1P3D?AT70?ofkP050=@m6@3om^h0ooK^0?ofkP000000
1@3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00P0ooK^00<000000<hj6@0mFJ/0
0`3>>QT303eIZ`80cSXI00<000000<hj6@3>>QT00`3>>QT00`0mFJ/0cSXI0<hj6@020<hj6@030000
003>>QT0cSXI00H0cSXI00<0?EV[0000003>>QT0203>>QT00`000000cSXI0<hj6@030<hj6@0503eI
Z`3>>QT0cSXI0<hj6@0000002@3>>QT00`000000cSXI0<hj6@020000000503eIZ`000000f3dJ0=Pm
6P0000002@3H?AX00`000000f3dJ0=Pm6P040=Pm6P0303eIZ`3H?AX0000000@0f3dJ0P0mFJ/20=Pm
6P030000003H?AX0f3dJ00D0f3dJ00<0?EV[0000003H?AX01`3H?AX00`000000f3dJ0=Pm6P020=Pm
6P80?EV[00<000000=Pm6P0mFJ/01P3H?AX01@000000E7_V05AkiP1DNnH0000000@0E7_V00D00000
0=@m6@1CN=l0DgSO0000000405=hg`8000000`1@Lm801@000000D7?B051cdP1@Lm8000000080BFVl
00L0000004UY_0000000000003mHVP3D?AT0000000<0ooK^203D?AT30?ofkP040=@m6@3om^h0ooK^
0?ofkPL0e3dI2@3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI
0?ofkP3om^h0403om^h00`3D?AT0ooK^0=@m6@050?ofkP030000003om^h0000005@0ooK^0@3oool0
01<0ooK^00<000000?ofkP3om^h0=`3om^h00`3D?AT0ooK^0?ofkP0B0?ofkP030=@m6@3om^h0ooK^
00/0ooK^1@3D?AT20?ofkP030=@m6@3om^h0ooK^00P0ooK^00D0e3dI0?ofkP3om^h0ooK^00000005
0?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h0203om^h0103D?AT000000<hj6@0m
FJ/40<hj6@0503eIZ`3>>QT0cSXI0<hj6@0000001@3>>QT01@0mFJ/0cSXI0<hj6@3>>QT0000000P0
cSXI00<0?EV[0000003>>QT02@3>>QT00`000000cSXI0<hj6@020<hj6@0303eIZ`3>>QT0cSXI0080
cSXI00<000000<hj6@3>>QT00P3>>QT7000000<0f3dJ00@0?EV[0=Pm6P3H?AX000002@3H?AX00`00
0000f3dJ0=Pm6P040=Pm6P0303eIZ`3H?AX000000080f3dJ0P0mFJ/40=Pm6P030000003H?AX0f3dJ
00H0f3dJ00<0?EV[0=Pm6P3H?AX01@3H?AX00`000000f3dJ0=Pm6P020=Pm6P0603eIZ`3H?AX0f3dJ
0000003H?AX0?EV[1P3H?AX01@000000E7_V05AkiP1DNnH0000000<0E7_V00<0?EV[0000003D?AT0
0P1CN=l00`000000DgSO05=hg`0205=hg`050000001CN=l00000051cdP000000101@Lm801P000000
BFVl04UY_0000000BFVl000000L0e3dI203om^h70=@m6@D0ooK^00<0e3dI0?ofkP3om^h0203om^h0
0`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h0403om^h0
0`3D?AT0ooK^0=@m6@050?ofkP030000003om^h0000005@0ooK^0@3oool001@0ooK^00<000000?of
kP3om^h0=P3om^h00`3D?AT0ooK^0?ofkP0B0?ofkP030=@m6@3om^h0ooK^00D0ooK^1P3D?AT70?of
kP030=@m6@3om^h0ooK^00T0ooK^00D0e3dI0?ofkP3om^h0ooK^000000050?ofkP030=@m6@3om^h0
ooK^00H0ooK^00@0e3dI0?ofkP3om^h0ooK^1P3D?AT20?ofkP030000003>>QT0?EV[00@0cSXI0P0m
FJ/00`3>>QT000000<hj6@050<hj6@0503eIZ`3>>QT0cSXI0<hj6@000000203>>QT00`0mFJ/00000
0<hj6@080<hj6@030000003>>QT0cSXI00<0cSXI00<0?EV[0<hj6@0000001P0000040=Pm6P030000
003H?AX0f3dJ00<0f3dJ00D0?EV[0=Pm6P3H?AX0f3dJ000000080=Pm6P030000003H?AX0f3dJ00D0
f3dJ00@0?EV[0000000mFJ/0?EV[1P3H?AX00`000000f3dJ0=Pm6P060=Pm6P0303eIZ`3H?AX0f3dJ
00D0f3dJ00D000000=Pm6P3H?AX0f3dJ03eIZ`030=Pm6P040000003H?AX0f3dJ03eIZ`@0f3dJ00<0
000005AkiP1DNnH00P1DNnH02@000000E7_V05AkiP1DNnH0000005AkiP3D?AT0DgSO0000000405=h
g`060000001CN=l0DgSO0000001@Lm800000101@Lm860=@m6@030000000oF9X0e3dI008000000P3o
m^h80=@m6@<0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3o
m^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP0@0?ofkP040=@m6@3o
m^h0ooK^0=@m6@<0ooK^1000001D0?ofkP40oooo000E0?ofkP030000003om^h0ooK^03D0ooK^00<0
e3dI0?ofkP3om^h04P3om^h00`3D?AT0ooK^0?ofkP050=@m6@d0ooK^00<0e3dI0?ofkP3om^h02@3o
m^h00`3D?AT0ooK^0?ofkP020?ofkP030000003om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h0103o
m^h60=@m6@P0ooK^0P0000000`0mFJ/0cSXI0<hj6@030<hj6@<0?EV[00<000000<hj6@3>>QT00`3>
>QT01@0mFJ/0cSXI0<hj6@3>>QT0000000P0cSXI00<0?EV[0000003>>QT02@3>>QT00`000000cSXI
0<hj6@020000000503eIZ`000000f3dJ0=Pm6P000000203H?AX00`000000f3dJ0=Pm6P040=Pm6P04
03eIZ`3H?AX0f3dJ000000P0f3dJ00<000000=Pm6P3H?AX0103H?AX303eIZ`P0f3dJ00<000000=Pm
6P3H?AX01P3H?AX00`0mFJ/0f3dJ0=Pm6P050=Pm6P040000003H?AX0f3dJ03eIZ`<0f3dJ00D00000
0=Pm6P3H?AX0f3dJ03eIZ`05000000<0E7_V00D0000005AkiP1DNnH0E7_V0000000205AkiP030000
003D?AT0000000@0DgSO00@0000005=hg`1CN=l000001P3D?AT0101@Lm80000004UY_000000204UY
_0030000000oF9X0e3dI008000000P3D?AT;0?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?of
kP3om^h02@3om^h00`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?of
kP3om^h0403om^h0103D?AT000000000003D?AT300000080ooK^0P00001D0?ofkP40oooo000F0?of
kP030000003om^h0ooK^03@0ooK^00<0e3dI0?ofkP3om^h03`3om^h60=@m6A80ooK^00<0e3dI0?of
kP3om^h02@3om^h00`3D?AT0ooK^0?ofkP020?ofkP030000003om^h0ooK^0080ooK^1`3D?AT20?of
kP030=@m6@3om^h0ooK^00X0ooK^00<000000=@m6@0mFJ/0103>>QT00`0mFJ/0cSXI0<hj6@0203eI
Z`D0cSXI00D0?EV[0<hj6@3>>QT0cSXI000000080<hj6@0303eIZ`000000cSXI00@0cSXI1`000003
0=Pm6P0503eIZ`3H?AX0f3dJ0=Pm6P000000203H?AX00`000000f3dJ0=Pm6P030=Pm6P0403eIZ`3H
?AX0f3dJ000000P0f3dJ00@000000=Pm6P3H?AX0f3dJ0`0mFJ/00`3H?AX0?EV[000000080=Pm6P03
0000003H?AX0f3dJ00D0f3dJ00<000000=Pm6P0mFJ/01P3H?AX00`000000?EV[03eIZ`030=Pm6PH0
000000<0?EV[0>506`3Q@1/00P00000305AkiP050000001DNnH0E7_V05AkiP0000000`1DNnH0103D
?AT0DgSO05=hg`1CN=l60=@m6@030000001@Lm80D7?B0080D7?B00D00000051cdP000000BFVl0000
000204UY_0050000000oF9X000000=@m6@0000003@3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m
6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m
6@3om^h0ooK^00X0ooK^1P000000103D?AT0ooK^0?ofkP3D?AT50?ofkP800000E03om^h10?ooo`00
5P3om^h00`000000ooK^0?ofkP0d0?ofkP030=@m6@3om^h0ooK^00P0ooK^1`3D?AT30?ofkP030=@m
6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h02@3om^h0103D?AT0ooK^0?ofkP3om^h60=@m6@P0
ooK^00<0e3dI0?ofkP3om^h02P3om^h010000000e3dI03eIZ`0mFJ/40<hj6@0403eIZ`3>>QT0cSXI
00000080?EV[0`3>>QT01@0mFJ/0cSXI0<hj6@3>>QT0000000L0cSXI00<0000003eIZ`0000001@00
00040=Pm6P030000003H?AX0f3dJ00<0f3dJ00D0?EV[0=Pm6P3H?AX0f3dJ000000080=Pm6P030000
003H?AX0f3dJ00@0f3dJ00<0?EV[0=Pm6P0000002@3H?AX303eIZ`D0f3dJ00<0?EV[0=Pm6P3H?AX0
1@3H?AX00`000000f3dJ0=Pm6P060=Pm6P030000003H?AX0?EV[00D0f3dJ00<0000003eIZ`3H?AX0
100000000`3Q@1/000000>506`030>506`0803eIZ`3Q@1/0hD0K0000001DNnX0000005AkiP000003
05AkiP030000001DNnH0e3dI00H0e3dI00<0DgSO0000001CN=l00`1CN=l01@000000D7?B051cdP1@
Lm8000000080D7?B0P00000304UY_0<0000000<0e3dI000000000000303om^h00`3D?AT0ooK^0?of
kP070?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h02`3om^h00`3D?AT0ooK^0?of
kP030?ofkP030=@m6@3om^h0ooK^00@0ooK^1P0000070?ofkP<0e3dI1@3om^h2000005@0ooK^0@3o
ool001L0ooK^00<000000?ofkP3om^h0<`3om^h0103D?AT0ooK^0?ofkP3om^h70=@m6@X0ooK^00<0
e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP090?ofkP@0e3dI0P3om^h010000000ooK^0?of
kP3D?AT80?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0000000mFJ/0103>>QT01P0mFJ/0cSXI
0<hj6@3>>QT000000<hj6@80?EV[0P3>>QT01`0mFJ/0cSXI0<hj6@3>>QT000000=@m6@3>>QT01000
00020=Pm6P0303eIZ`000000f3dJ00P0f3dJ00<000000=Pm6P3H?AX00`3H?AX0100mFJ/0f3dJ0=Pm
6P0000080=Pm6P030000003H?AX0f3dJ00@0f3dJ00@0?EV[0=Pm6P3H?AX000001P3H?AX203eIZ`03
0000003H?AX0f3dJ00D0f3dJ00<0?EV[0=Pm6P3H?AX01@3H?AX00`000000f3dJ0=Pm6P060=Pm6P05
0000003H?AX0f3dJ03eIZ`3H?AX00`0000000`0mFJ/00000000000040>506`030000003Q@1/0hD0K
00@0hD0K00H0?EV[0000001DNnX0E7_Z0000001DNnH60=@m6@80E7_V00<000000=@m6@1CN=l00P1C
N=l00`000000DgSO05=hg`0205=hg`8000000`1@Lm801@000000D7?B051cdP1@Lm8000000080BFVl
00D0000004UY_000000000000=@m6@02000000`0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0
ooK^0?ofkP080?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`000000
e3dI00000004000000P0ooK^1P3D?AT00`3om^h0e3dI0?ofkP040?ofkP030000003om^h0000005<0
ooK^0@3oool001P0ooK^00<000000?ofkP3om^h0<P3om^h40=@m6A40ooK^00<0e3dI0?ofkP3om^h0
4`3om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^00<0ooK^00@000000?ofkP3om^h0
e3dI2@3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP040=@m6@0mFJ/0000003eIZ`@0cSXI00@0?EV[0<hj
6@3>>QT000000`3>>QT303eIZ`H000001P3H?AX00`0mFJ/000000=Pm6P080=Pm6P030000003H?AX0
f3dJ00<0f3dJ00D0?EV[0=Pm6P3H?AX0f3dJ000000070=Pm6P030000003H?AX0f3dJ00D0f3dJ00<0
?EV[0=Pm6P0000000`3H?AX303eIZ`80f3dJ00<000000=Pm6P3H?AX01@3H?AX00`000000?EV[0=Pm
6P050=Pm6P030000003H?AX0f3dJ0080f3dJ1`0000000`0mFJ/000000>506`0203eIZ`030000003Q
@1/0hD0K00@0hD0K00<000000>506`3Q@1/0103Q@1/00`0mFJ/000000=@m6@030=@m6@<0E7_V00<0
000005AkiP1DNnH00P1DNnH00`000000e3dI0000000205=hg`030000001CN=l0DgSO0080DgSO00<0
000005=hg`0000000P1@Lm801@000000D7?B051cdP1@Lm8000000080BFVl00D0000004UY_0000000
00000=@m6@02000000`0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP080?ofkP03
0=@m6@3om^h0ooK^00/0ooK^00<0e3dI0000000000000`0000000`3om^h0e3dI0?ofkP060?ofkPH0
e3dI0P3om^h40=@m6@030?ofkP3D?AT0ooK^00@0ooK^00<000000?ofkP000000D`3om^h10?ooo`00
6@3om^h00`000000ooK^0?ofkP0a0?ofkP030=@m6@3om^h0ooK^0180ooK^00<0e3dI0?ofkP3om^h0
4`3om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^00@0ooK^00<000000?ofkP3D?AT0
2@3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@00000000000080?EV[0`3>>QT00`0mFJ/00000
00000006000000<0?EV[0P3H?AX00`000000f3dJ0=Pm6P060=Pm6P0303eIZ`000000f3dJ00P0f3dJ
00<000000=Pm6P3H?AX00`3H?AX0100mFJ/0f3dJ0=Pm6P0000080=Pm6P030000003H?AX0f3dJ00@0
f3dJ00<0?EV[0=Pm6P0000000`0mFJ/50=Pm6P030000003H?AX0f3dJ00D0f3dJ00<0000003eIZ`3H
?AX0103H?AX6000000@0hD0K00@000000>506`3Q@1/0hD0K0P0mFJ/00`3Q@1/000000>506`050>50
6`030000003Q@1/0hD0K00D0hD0K00<000000=@m6@1DNnX00P1DNnX01@000000E7_V05AkiP1DNnH0
000000<0E7_V00H0000005AkiP1DNnH0e3dI05=hg`00000405=hg`060000001CN=l0DgSO0000001@
Lm800000101@Lm8010000000BFVl04UY_000000204UY_0030000000oF9X0e3dI008000002`3om^h0
0`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h0103om^h7
000000030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h01@3D?AT20?ofkPH0e3dI0`3om^h0
0`3D?AT0ooK^0=@m6@050?ofkP030000003om^h0000005<0ooK^0@3oool001X0ooK^00<000000?of
kP3om^h0<03om^h00`3D?AT0ooK^0?ofkP0B0?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?of
kP3om^h02@3om^h00`3D?AT0ooK^0?ofkP040?ofkP030000003om^h0e3dI00T0ooK^00<0e3dI0?of
kP3om^h02P3om^h0103D?AT0000003eIZ`00000203eIZ`80000000<0f3dJ03eIZ`3H?AX00P3H?AX0
0`000000f3dJ0=Pm6P030=Pm6PD0?EV[1`3H?AX00`0mFJ/000000=Pm6P080=Pm6P030000003H?AX0
f3dJ00<0f3dJ00@0?EV[0=Pm6P3H?AX00000203H?AX00`000000f3dJ0=Pm6P030=Pm6P@0?EV[203H
?AX00`000000f3dJ0=Pm6P050=Pm6P030000003H?AX0?EV[00@0000000<0hD0K0000003Q@1/01`3Q
@1/01@000000hD0K0>506`3Q@1/0?EV[0080hD0K00<000000>506`3Q@1/0103Q@1/00`000000hD0K
0>506`050>506`040000001DNnX0E7_Z05AkjP8000000P1DNnH00`000000E7_V05AkiP0205AkiP06
0000001DNnH0E7_V0=@m6@1CN=l00000101CN=l01P000000DgSO05=hg`000000D7?B000000<0D7?B
00D00000051cdP000000BFVl0000000204UY_0030000000oF9X0e3dI00800000303om^h00`3D?AT0
ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0000000000000`0000080?ofkP03
0=@m6@3om^h0ooK^00H0e3dI00<0ooK^0=@m6@3D?AT0103D?AT90?ofkP040=@m6@3om^h0ooK^0=@m
6@D0ooK^0P00001C0?ofkP40oooo000K0?ofkP030000003om^h0ooK^02l0ooK^00<0e3dI0?ofkP3o
m^h04P3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3o
m^h0103om^h00`000000ooK^0=@m6@080?ofkP030=@m6@3om^h0ooK^00P0ooK^1P3D?AT00`000000
f3dJ03eIZ`030=Pm6P0403eIZ`3H?AX0f3dJ000000D0f3dJ00D0?EV[0=Pm6P3H?AX0f3dJ00000004
03eIZ`@0f3dJ00<0?EV[0000003H?AX01`3H?AX00`000000f3dJ0=Pm6P040=Pm6P0303eIZ`3H?AX0
000000P0f3dJ1P0mFJ/20=Pm6P0303eIZ`3H?AX0000000L0f3dJ00<000000=Pm6P3H?AX00P3H?AX5
0000000303eIZ`3Q@1/0hD0K00<0hD0K00<000000>506`3Q@1/01@3Q@1/00`000000hD0K0>506`03
03eIZ`030>506`000000hD0K00D0hD0K00<000000>506`3Q@1/01@3Q@1/00`000000E7_Z05AkjP02
05AkjP8000000P1DNnH01@000000E7_V05AkiP1DNnH0000000<0E7_V00<0e3dI0000001CN=l00`1C
N=l00`000000DgSO05=hg`0205=hg`030000001@Lm80D7?B0080D7?B00D00000051cdP000000BFVl
0000000204UY_0030000000oF9X0e3dI00800000303om^h00`3D?AT0ooK^0?ofkP070?ofkP040=@m
6@3om^h0ooK^0?ofkPL0000000<0e3dI0?ofkP3om^h0203om^h60=@m6@030?ofkP3D?AT0e3dI00@0
e3dI3`3om^h0103D?AT0ooK^0?ofkP3D?AT50?ofkP800000D`3om^h10?ooo`006`3om^h00`000000
ooK^0?ofkP0_0?ofkP030=@m6@3om^h0ooK^0180ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0
ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00D0ooK^00<000000=@m6@3om^h01`3om^h00`3D?AT0
ooK^0?ofkP020?ofkPH0e3dI0P3om^h00`3D?AT0ooK^0?ofkP03000000050=Pm6P0mFJ/0f3dJ0=Pm
6P0mFJ/00`3H?AX00`000000f3dJ0=Pm6P030=Pm6P0503eIZ`3H?AX0f3dJ0=Pm6P0000000`3H?AX5
03eIZ`030000003H?AX0f3dJ00L0f3dJ00<000000=Pm6P3H?AX00`3H?AX01@0mFJ/0f3dJ0=Pm6P00
0000f3dJ00H0?EV[00<000000=Pm6P3H?AX01P3H?AX00`0mFJ/000000=Pm6P030=Pm6PP000000`3Q
@1/010000000hD0K0>506`0mFJ/40>506`030000003Q@1/0hD0K00D0hD0K00<0000003eIZ`0mFJ/0
0`3Q@1/00`0mFJ/000000>506`050>506`030000003Q@1/0hD0K00@0hD0K00<0000005AkjP1DNnX0
0P1DNnX00`000000E7_Z05AkjP02000000<0E7_V00<0000005AkiP1DNnH00P1DNnH00`3D?AT00000
05=hg`0305=hg`030000001CN=l0DgSO0080DgSO00D00000051cdP1@Lm80D7?B00000002051cdP80
00000`19JK`2000000040=@m6@0oF9X00000000000/0ooK^00<0e3dI0?ofkP3om^h01@3om^h20000
00040=@m6@0000000000000000L0ooK^00@0e3dI0?ofkP3om^h0ooK^3P3D?AT20?ofkP030=@m6@3o
m^h0ooK^0140ooK^00<0e3dI0?ofkP3D?AT01@3om^h2000005<0ooK^0@3oool001`0ooK^00<00000
0?ofkP3om^h0;P3om^h00`3D?AT0ooK^0?ofkP0B0?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI
0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP050?ofkP030000003D?AT0ooK^00L0ooK^1@3D?AT8
0?ofkP030=@m6@3om^h0ooK^00<000000P3H?AX203eIZ`030=Pm6P0mFJ/0f3dJ0080f3dJ00<00000
0=Pm6P3H?AX00P3H?AX00`0mFJ/0f3dJ0=Pm6P020=Pm6P030000003H?AX0f3dJ00@0f3dJ5P0mFJ/7
0=Pm6P030000003H?AX0f3dJ0080f3dJ0`0000000`0mFJ/0000000000003000000<0hD0K00<00000
0>506`3Q@1/01@3Q@1/010000000hD0K0>506`0mFJ/40>506`030000003Q@1/0hD0K00D0hD0K00<0
?EV[0>506`3Q@1/00`3Q@1/00`0mFJ/000000>506`050>506`030000003Q@1/0hD0K00@0hD0K00<0
000005AkjP1DNnX00P1DNnX00`000000E7_Z05AkjP02000000<0E7_V00<0000005AkiP1DNnH00P1D
NnH00`000000e3dI05=hg`0205=hg`030000001CN=l0DgSO0080DgSO0P000003051cdP050000001@
Lm80D7?B051cdP0000000P19JK`01@000000BFVl000000000000e3dI008000002`3om^h00`3D?AT0
00000000000500000080ooK^00<0e3dI0?ofkP3om^h01@3om^h>0=@m6@<0ooK^00<0e3dI0?ofkP3o
m^h00`3om^h00`3D?AT0ooK^0?ofkP0A0?ofkP030=@m6@3om^h0e3dI00D0ooK^00<000000?ofkP00
0000DP3om^h10?ooo`007@3om^h00`000000ooK^0?ofkP0]0?ofkP030=@m6@3om^h0ooK^01<0ooK^
00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^00H0ooK^
00<0e3dI0?ofkP3om^h01`3D?AT=0?ofkP030=@m6@3om^h0ooK^00<000000`3H?AX203eIZ`@0f3dJ
00<000000=Pm6P3H?AX00P3H?AX01@0mFJ/0f3dJ0=Pm6P3H?AX0000000P0f3dJ00<0?EV[0000003H
?AX01`3H?AX00`000000f3dJ0=Pm6P030=Pm6P0303eIZ`3H?AX0000000L0f3dJ1P0000040>506`03
03eIZ`3Q@1/0hD0K00D0hD0K00<000000>506`3Q@1/01@3Q@1/01@000000hD0K0>506`3Q@1/0?EV[
00<0hD0K00<000000>506`3Q@1/00`3Q@1/203eIZ`030000003Q@1/0hD0K00<0hD0K00<0000003eI
Z`3Q@1/0103Q@1/00`000000hD0K0>506`040>506`030000001DNnX0E7_Z0080E7_Z00D0000005Ak
jP1DNnX0E7_Z0000000305AkiP030000001DNnH0E7_V00<0E7_V00<000000=@m6@0000000P1CN=l0
0`000000DgSO05=hg`0205=hg`030000001CN=l000000080D7?B00D00000051cdP1@Lm80D7?B0000
000204UY_00500000019JK`000000000003D?AT00`0000050?ofkPD0000000<0e3dI0?ofkP3om^h0
203om^h=0=@m6@/0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP0@0?ofkP030=@m
6@3om^h0e3dI00D0ooK^00<000000?ofkP000000DP3om^h10?ooo`007P3om^h00`000000ooK^0?of
kP0/0?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?of
kP090?ofkP030=@m6@3om^h0ooK^00<0ooK^1P3D?AT70?ofkP030=@m6@3om^h0ooK^00X0ooK^00L0
e3dI0?ofkP3om^h0e3dI0000000J:El0000000<0f3dJ0P0mFJ/30=Pm6P030000003H?AX0f3dJ0080
f3dJ00<0?EV[0=Pm6P3H?AX00P3H?AX00`000000f3dJ0=Pm6P050=Pm6P0303eIZ`000000f3dJ00L0
f3dJ00<000000=Pm6P3H?AX0103H?AX00`0mFJ/0f3dJ000000020=Pm6P@0000000<0hD0K0000003Q
@1/01`3Q@1/00`0mFJ/0hD0K0>506`050>506`030000003Q@1/0hD0K00D0hD0K00D000000>506`3Q
@1/0hD0K03eIZ`030>506`040000003Q@1/0hD0K0>506`80?EV[00<0hD0K0000003Q@1/01@3Q@1/0
0`000000?EV[0>506`040>506`030000003Q@1/0hD0K00@0hD0K00D0000005AkjP1DNnX0E7_Z0000
000305AkjP8000000`1DNnH00`000000E7_V05AkiP0205AkiP060000001DNnH0e3dI0000001CN=l0
0000101CN=l01P000000DgSO05=hg`000000D7?B000000@0D7?B00@0000004UY_019JK`000000P19
JK`00`000000e3dI00000007000000D0ooK^00@0e3dI0?ofkP3om^h0ooK^303D?AT50?ofkP030=@m
6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP0@0?ofkP030=@m
6@3om^h0e3dI00D0ooK^00<000000?ofkP000000DP3om^h10?ooo`007`3om^h00`000000ooK^0?of
kP0[0?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?of
kP080?ofkPL0e3dI0`3om^h00`3D?AT000000?ofkP070?ofkP030=@m6@3om^h0ooK^00L0ooK^1P3D
?AT01@3om^h000000000000J:El0000000<0f3dJ00<0?EV[0=Pm6P3H?AX00P3H?AX00`000000f3dJ
0=Pm6P020=Pm6P0303eIZ`3H?AX0f3dJ0080f3dJ00<000000=Pm6P3H?AX01@3H?AX00`0mFJ/00000
0=Pm6P070=Pm6P030000003H?AX0f3dJ0080f3dJ00<0000003eIZ`0000000`0000060>506`030000
003Q@1/0hD0K00D0hD0K00<0000003eIZ`3Q@1/01@3Q@1/00`000000hD0K0>506`050>506`030000
003Q@1/0hD0K0080hD0K00<0?EV[0>506`0000000`3Q@1/01@0mFJ/0hD0K0>506`3Q@1/0000000H0
hD0K00<000000>506`0mFJ/00`3Q@1/00`000000hD0K0>506`040>506`030000001DNnX0E7_Z0080
E7_Z00T0000005AkjP1DNnX0E7_Z0000001DNnX0000005AkiP000000101DNnH01@000000E7_V05Ak
iP3D?AT0E7_V00800000101CN=l01P000000DgSO05=hg`000000D7?B000000<0D7?B00D00000051c
dP000000BFVl0000000204UY_0030000003D?AT00000008000001P3om^h=0=@m6@80ooK^00<0e3dI
0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI
0?ofkP3om^h0403om^h00`3D?AT0ooK^0=@m6@060?ofkP800000DP3om^h10?ooo`00803om^h00`00
0000ooK^0?ofkP0[0?ofkP030=@m6@3om^h0ooK^0180ooK^00<0e3dI0?ofkP3om^h04`3om^h0103D
?AT0ooK^0?ofkP3om^h70=@m6@030?ofkP3D?AT0ooK^00L0ooK^00<0e3dI0?ofkP0000001`3om^h0
103D?AT0ooK^0?ofkP3om^h60=@m6@<0ooK^00<0e3dI0?ofkP3om^h00P3om^h20000000301XYG`00
0000f3dJ0080f3dJ0P0mFJ/30=Pm6P030000003H?AX0f3dJ0080f3dJ00<0?EV[0=Pm6P3H?AX00P3H
?AX00`000000f3dJ0=Pm6P040=Pm6P0303eIZ`000000f3dJ00@0f3dJ200000020>506`0303eIZ`00
0000hD0K00L0hD0K00<000000>506`3Q@1/01P3Q@1/00`0mFJ/0hD0K0>506`040>506`030000003Q
@1/0hD0K00D0hD0K00<000000>506`3Q@1/00P3Q@1/0100mFJ/0hD0K0000003Q@1/203eIZ`@0hD0K
00<000000>506`3Q@1/00`3Q@1/010000000hD0K0>506`0mFJ/30>506`030000003Q@1/0hD0K00@0
hD0K00D0000005AkjP1DNnX0E7_Z0000000305AkjP060000001DNnX0E7_Z0000001DNnH00000101D
NnH01P000000E7_V05AkiP1DNnH0e3dI000000@0DgSO00<0000005=hg`1CN=l00P1CN=l00`000000
D7?B051cdP02051cdP050000001@Lm80000004UY_00000000P19JK`00`000000?eRJ0=@m6@020000
00H0e3dI00<0ooK^0=@m6@3D?AT0103D?AT80?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI0?of
kP3om^h0303om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^0100ooK^00@0e3dI0?of
kP3om^h0e3dI1@3om^h200000580ooK^0@3oool00200ooK^00<000000?ofkP3om^h0:`3om^h00`3D
?AT0ooK^0?ofkP0B0?ofkP030=@m6@3om^h0ooK^0100ooK^1`3D?AT90?ofkP030=@m6@3om^h0ooK^
00H0ooK^00<0e3dI0?ofkP000000103om^h60=@m6@T0ooK^00<0e3dI0?ofkP3om^h00P3om^h01@3D
?AT000000000000J:El000000080f3dJ00@0?EV[0=Pm6P0mFJ/0?EV[0P3H?AX01@000000f3dJ0=Pm
6P3H?AX0?EV[00@0f3dJ00<000000=Pm6P3H?AX00`3H?AX20000000303eIZ`000000000000<00000
103Q@1/00`000000hD0K0>506`030>506`0303eIZ`3Q@1/0000000L0hD0K00<000000>506`3Q@1/0
1P3Q@1/00`000000?EV[0>506`040>506`030000003Q@1/0hD0K00D0hD0K00<000000>506`3Q@1/0
0`3Q@1/303eIZ`H0hD0K00<000000>506`3Q@1/00`3Q@1/010000000hD0K0>506`0mFJ/20>506`04
0000003Q@1/0hD0K0>506`@000000`1DNnX01@000000E7_Z05AkjP1DNnX0000000@0E7_Z00<00000
05AkiP1DNnH00P1DNnH00`000000E7_V05AkiP0205AkiP030=@m6@000000DgSO0080DgSO00<00000
05=hg`1CN=l00`1CN=l01@000000D7?B051cdP1@Lm8000000080D7?B0P00000304UY_080000000@0
e3dI03mHVP00000000001P3D?AT30?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h0
1P3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h0
403om^h0103D?AT0ooK^0?ofkP3D?AT50?ofkP800000DP3om^h10?ooo`008@3om^h00`000000ooK^
0?ofkP0Z0?ofkP030=@m6@3om^h0ooK^0180ooK^00<0e3dI0?ofkP3om^h02@3om^h70=@m6@<0ooK^
00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP060?ofkPL0e3dI0P3om^h00`3D?AT0ooK^
0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00<0ooK^100000030=Pm6P0303eIZ`3H?AX0f3dJ0080?EV[
00<000000=Pm6P3H?AX00P3H?AX0100mFJ/0f3dJ0=Pm6P3H?AX6000000<0hD0K00<0?EV[0000003Q
@1/01P3Q@1/00`000000hD0K0>506`040>506`0303eIZ`000000hD0K00L0hD0K00<000000>506`3Q
@1/01@3Q@1/00`000000?EV[0>506`050>506`030000003Q@1/0hD0K00@0hD0K00<000000>506`3Q
@1/00P3Q@1/203eIZ`030000003Q@1/0hD0K00@0hD0K00<000000>506`3Q@1/00`3Q@1/01P000000
hD0K0>506`3Q@1/0000003eIZ`D000000P3Y@a`2000000<0E7_Z00D0000005AkjP1DNnX0E7_Z0000
000305AkjP800000101DNnH00`000000E7_V05AkiP0205AkiP030=@m6@1DNnH000000080DgSO00<0
000005=hg`1CN=l00P1CN=l2000000<0D7?B00D00000051cdP1@Lm80D7?B0000000204UY_0030000
003D?AT0e3dI00@0e3dI2@3om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^00H0ooK^
00<0e3dI0?ofkP3om^h0303om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^0100ooK^
00@0e3dI0?ofkP3om^h0e3dI1@3om^h200000580ooK^0@3oool00280ooK^00<000000?ofkP3om^h0
:@3om^h00`3D?AT0ooK^0?ofkP0B0?ofkP040=@m6@3om^h0ooK^0?ofkPP0e3dI2P3om^h00`3D?AT0
ooK^0?ofkP0:0?ofkP040=@m6@3om^h0ooK^0?ofkPH0e3dI0P3om^h00`000000ooK^0?ofkP030?of
kP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0000001XYG`020000
0080f3dJ00<0?EV[0=Pm6P3H?AX00P3H?AX203eIZ`<0f3dJ00@0?EV[00000000000000000P3Q@1/0
0`000000hD0K0>506`040>506`0303eIZ`000000hD0K00L0hD0K00<000000>506`3Q@1/00`3Q@1/0
0`0mFJ/0hD0K000000070>506`030000003Q@1/0hD0K00D0hD0K00<000000>506`0mFJ/01@3Q@1/0
0`000000hD0K0>506`040>506`030000000mFJ/0?EV[0080?EV[00<0hD0K03eIZ`0000001P3Q@1/0
10000000hD0K0>506`3Q@1/6000000030>U3700mFJ/0jD<L00H0jD<L00D0000005=jjP000000E7_Z
0000000305AkjP030000001DNnX0E7_Z0080E7_Z00<0000005AkjP0000000P1DNnH00`000000E7_V
05AkiP0205AkiP060000003D?AT0E7_V0000001CN=l000001@1CN=l00`000000DgSO00000002051c
dP030000001@Lm80e3dI00D0e3dI00@0BFVl0000003D?AT0?eRJ0`0000090?ofkP030=@m6@3om^h0
ooK^00P0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0
ooK^00<0ooK^00<0e3dI0?ofkP3om^h03`3om^h40=@m6@D0ooK^00<000000?ofkP000000D@3om^h1
0?ooo`008`3om^h00`000000ooK^0?ofkP0X0?ofkP030=@m6@3om^h0ooK^0100ooK^1P3D?ATC0?of
kP030=@m6@3om^h0ooK^00T0ooK^103D?AT50?ofkP050=@m6@3om^h0ooK^0?ofkP000000103om^h0
0`3D?AT0ooK^0?ofkP0;0?ofkP030=@m6@3om^h0ooK^0080ooK^00@0e3dI0000000000006RUO0P00
00020=Pm6P0303eIZ`3H?AX0f3dJ00<000000P0mFJ/00`000000hD0K03eIZ`050>506`030000003Q
@1/0hD0K00@0hD0K00<0?EV[0000003Q@1/01P3Q@1/00`000000hD0K0>506`040>506`0303eIZ`00
0000hD0K00H0hD0K00<000000>506`3Q@1/01@3Q@1/00`000000hD0K03eIZ`050>506`030000003Q
@1/0hD0K0080hD0K0`0mFJ/60>506`0303eIZ`3Q@1/0hD0K00<0hD0K1@0000020>U370030000003Y
@a`0jD<L00<0jD<L00<0?EV[0>U3703Y@a`00P3Y@a`01`0mFJ/0000005=jjP1CN^X0000005AkjP00
00000P1DNnX00`000000E7_Z05AkjP0205AkjP060000001DNnX0E7_Z0000001DNnH00000101DNnH0
1@000000E7_V05AkiP3D?AT0E7_V00800000101CN=l00`000000DgSO0=@m6@050=@m6@03051cdP0m
FJ/000000080BFVl00D0000004UY_019JK`0e3dI03mHVP03000000T0ooK^00<0e3dI0?ofkP3om^h0
203om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3om^h0
0`3om^h00`3D?AT0ooK^0?ofkP080?ofkPL0e3dI00@0ooK^0=@m6@3om^h0e3dI1@3om^h00`000000
ooK^0000001A0?ofkP40oooo000T0?ofkP030000003om^h0ooK^02L0ooK^00<0e3dI0?ofkP3om^h0
2`3om^h50=@m6@80ooK^00<0e3dI0?ofkP3om^h0503om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m
6@3om^h0ooK^00H0ooK^00D0e3dI0?ofkP3om^h0ooK^000000050?ofkP030=@m6@3om^h0ooK^00X0
ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^000000020000000401XYG`000000000003eI
Z`800000103Q@1/010000000?EV[03eIZ`0mFJ/50>506`030000003Q@1/0hD0K00D0hD0K00<0?EV[
0000003Q@1/01P3Q@1/00`000000hD0K0>506`030>506`0303eIZ`3Q@1/0000000H0hD0K00<00000
0>506`3Q@1/01@3Q@1/010000000hD0K0>506`0mFJ/40>506`030000003Q@1/0?EV[0080?EV[0P3Q
@1/00`000000hD0K0>506`040>506`0303eIZ`3Q@1/0000000<0000000<0jD<L0000003Y@a`00`3Y
@a`00`000000jD<L0>U370040>U3700803eIZ`3Y@a`0jD<L0>U3700mFJ/0jD<L0000003D?AT205=j
jP050000001DNnX0E7_Z05AkjP0000000`1DNnX00`000000E7_Z05AkjP0205AkjP800000101DNnH0
1`000000E7_V05AkiP3D?AT0E7_V0000001CN=l01P3D?AT0101CN=l00000051cdP000003051cdP05
0000001@Lm80000004UY_00000000P19JK`00`000000e3dI00000002000000T0ooK^00<0e3dI0?of
kP3om^h0203om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?of
kP3om^h00`3om^h0103D?AT0ooK^0?ofkP3om^h70=@m6@P0ooK^00<0e3dI0?ofkP3D?AT01P3om^h2
00000540ooK^0@3oool002D0ooK^00<000000?ofkP3om^h09P3om^h00`3D?AT0ooK^0?ofkP050?of
kPH0e3dI1`3om^h00`3D?AT0ooK^0?ofkP0D0?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?of
kP3om^h01P3om^h00`3D?AT0ooK^0?ofkP020?ofkP030000003om^h0ooK^0080ooK^00<0e3dI0?of
kP3om^h02P3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0000000<0000000@06RUO0000
003Q@1/0?EV[1P3Q@1/00`000000hD0K03eIZ`0303eIZ`<0hD0K00<000000>506`3Q@1/0103Q@1/0
0`0mFJ/000000>506`060>506`030000003Q@1/0hD0K00@0hD0K00<0?EV[0000003Q@1/01P3Q@1/0
0`000000hD0K0>506`050>506`030000003Q@1/0?EV[0080hD0K100mFJ/50>506`040000003Q@1/0
hD0K0>506`@0000000<0?EV[0>U3703Y@a`00P3Y@a`00`000000jD<L0>U370030>U370030000003Y
@a`0jD<L00<0jD<L00<000000>U3700mFJ/00P0mFJ/01@3Y@a`0000005=jjP3D?AT0Dg[Z00800000
0P1DNnX00`000000E7_Z05AkjP0205AkjP030000001DNnX0E7_Z0080E7_Z00<0000005AkiP1DNnH0
0P1DNnH00`000000e3dI0=@m6@050=@m6@<0DgSO00<0000005=hg`1CN=l00P1CN=l01@000000D7?B
051cdP1@Lm8000000080D7?B00<0000004UY_00000000P19JK`00`000000e3dI00000002000000T0
ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00`0
ooK^00<0e3dI0?ofkP3om^h01`3D?AT=0?ofkP<0e3dI0P3om^h00`3D?AT0ooK^0?ofkP030?ofkP80
0000D@3om^h10?ooo`009@3om^h00`000000ooK^0?ofkP0V0?ofkP030=@m6@3om^h0ooK^00D0e3dI
3P3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h0
1`3om^h01@3D?AT0ooK^0?ofkP3om^h0000000@0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0
ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00H0000000<0?EV[0>506`3Q@1/01@3Q@1/01@000000
hD0K0>506`0mFJ/0hD0K00D0?EV[1P3Q@1/00`0mFJ/000000>506`060>506`030000003Q@1/0hD0K
00<0hD0K00<0?EV[0>506`0000001P3Q@1/00`000000hD0K0>506`050>506`030000000mFJ/0?EV[
0080?EV[0P3Q@1/010000000hD0K0>506`3Q@1/7000000<0jD<L00<0000003eIZ`3Y@a`00`3Y@a`0
0`000000jD<L0>U370030>U370030000003Y@a`0jD<L00<0jD<L00<000000>U3700mFJ/00`3Y@a`0
10000000Dg[Z0=@m6@1CN^X20000000305AkjP000000E7_Z00<0E7_Z00@0000005AkjP1DNnX0E7_Z
203D?AT305AkiP040=@m6@1DNnH0E7_V00000080DgSO00<0000005=hg`1CN=l00`1CN=l01@000000
D7?B051cdP1@Lm8000000080D7?B0P00000204UY_00500000019JK`0e3dI0000000oF9X00P000008
0?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP08
0?ofkPL0e3dI0`3om^h00`3D?AT0ooK^0?ofkP080?ofkPH0e3dI0P3om^h0103D?AT0ooK^0?ofkP3D
?AT50?ofkP800000D@3om^h10?ooo`009P3om^h00`000000ooK^0?ofkP0U0?ofkP<0e3dI4`3om^h0
0`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h01P3om^h0
0`3D?AT0ooK^0?ofkP020?ofkP050000003om^h0ooK^0?ofkP3D?AT0303om^h00`3D?AT0ooK^0?of
kP020?ofkP030=@m6@3om^h0ooK^00L000000P0mFJ/60>506`030000003Q@1/0?EV[00H0hD0K1@0m
FJ/0103Q@1/0?EV[0>506`0000070>506`030000003Q@1/0hD0K00<0hD0K00<0?EV[0000003Q@1/0
1@3Q@1/00`000000hD0K0>506`0603eIZ`80hD0K00<0?EV[0000000000001@0000030>U370030000
003Y@a`0jD<L00@0jD<L00<000000>U3700mFJ/00`3Y@a`00`000000jD<L0>U370020>U370030000
003Y@a`0jD<L00<0jD<L00@0000003eIZ`0mFJ/0?EV[0P3Y@a`01@000000Dg[Z05=jjP1CN^X0e3dI
0080Dg[Z0P0000080=@m6@0405AkjP000000E7_Z00000080E7_V00<0000005AkiP1DNnH00P1DNnH0
103D?AT0E7_V05AkiP00000205=hg`030000001CN=l0DgSO0080DgSO0P000002051cdP030000001@
Lm80D7?B0080D7?B00P0000004UY_019JK`0000004UY_03D?AT0000003mHVP800000203om^h00`3D
?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^00H0ooK^00@0e3dI0?ofkP3om^h0ooK^1`3D?AT5
0?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h00P3om^h60=@m6@P0ooK^00@0e3dI
0?ofkP3om^h0e3dI1@3om^h200000540ooK^0@3oool002L0ooK^00<000000?ofkP3om^h0903om^h0
0`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h02P3om^h0
0`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00<0ooK^00@000000?ofkP3om^h0e3dI3@3o
m^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00800000103D?AT00`000000hD0K0>50
6`060>506`030000003Q@1/0?EV[00H0hD0K00@000000>506`3Q@1/0hD0K2P0mFJ/00`3Q@1/00000
0>506`040>506`0303eIZ`3Q@1/000000080hD0K1P0mFJ/20>506`L0000000@0?EV[0>U3703Y@a`0
00001P3Y@a`00`000000jD<L0>U370030>U370040000003Y@a`0jD<L03eIZ`80jD<L00<000000>U3
703Y@a`00`3Y@a`00`000000jD<L0>U370020>U37080?EV[0`3Y@a`00`0mFJ/0000005=jjP0205=j
jPH0e3dI0`1DNnX00`000000E7_Z05AkjP0205AkjP060000001DNnX0E7_Z0000001DNnH00000101D
NnH01`000000E7_V0=@m6@1DNnH0000005=hg`0000001@1CN=l200000080D7?B00<00000051cdP1@
Lm800P1@Lm8020000000BFVl04UY_0000000BFVl0=@m6@000000?eRJ0P0000090?ofkP030=@m6@3o
m^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h00`3om^h70=@m6@`0ooK^00@0e3dI0?ofkP3om^h0ooK^
1P3D?AT>0?ofkP040=@m6@3om^h0ooK^0=@m6@D0ooK^00<000000?ofkP000000D03om^h10?ooo`00
:03om^h00`000000ooK^0?ofkP0S0?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h0
503om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h0
0`3om^h010000000ooK^0?ofkP3D?AT=0?ofkP040=@m6@3om^h0ooK^0?ofkPH0e3dI100000000`0S
>Gd000000>506`070>506`030000000mFJ/0hD0K00H0hD0K00<000000>506`3Q@1/00P3Q@1/00`0m
FJ/0hD0K000000050>506``0?EV[0P3Q@1/6000000<0jD<L00D000000>U3703Y@a`0jD<L03eIZ`02
0>U370030000003Y@a`0jD<L00@0jD<L00<000000>U3703Y@a`00`3Y@a`01`000000jD<L0>U3703Y
@a`0?EV[0>U370000000103Y@a`010000000jD<L0>U3703Y@a`203eIZ`030>U370000000jD<L0080
jD<L00<0?EV[0000003D?AT00P3D?AT00`000000e3dI05=jjP02000000<0E7_Z00<0000005AkjP1D
NnX00P1DNnX00`000000E7_Z05AkjP0205AkjP8000000`1DNnH010000000E7_V05AkiP3D?AT205Ak
iP800000101CN=l00`000000DgSO05=hg`02000000@0D7?B0P0000000`19JK`0000004UY_00204UY
_0040=@m6@0oF9X00000000000T0ooK^00<0e3dI0?ofkP3om^h0203om^h60=@m6@<0ooK^00<0e3dI
0?ofkP3om^h02P3om^h70=@m6@030?ofkP3D?AT0ooK^0180ooK^00<0e3dI0?ofkP3D?AT01@3om^h0
0`000000ooK^0000001@0?ofkP40oooo000Y0?ofkP030000003om^h0ooK^02<0ooK^00<0e3dI0?of
kP3om^h04P3om^h00`3D?AT0ooK^0?ofkP0D0?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?of
kP3om^h01P3om^h00`3D?AT0ooK^0?ofkP040?ofkP030000003om^h0e3dI00X0ooK^1`3D?AT00`3o
m^h0e3dI0?ofkP020?ofkP030000000B6T00?EV[00<0000000<08cUm0000000000001`3Q@1/00`00
0000?EV[0>506`050>506`030000003Q@1/0hD0K00<0hD0K00<0?EV[0>506`0000001P3Q@1/00`00
0000hD0K0>506`020>506`80000000<0?EV[0000000000000P0000020>U370030000003Y@a`0jD<L
00D0jD<L00L000000>U3703Y@a`0jD<L03eIZ`3Y@a`0000000H0jD<L00<000000>U3703Y@a`00`3Y
@a`01`000000jD<L0>U3703Y@a`0?EV[0>U370000000103Y@a`010000000jD<L03eIZ`0mFJ/20>U3
70030000003Y@a`0jD<L0080jD<L00D0000005=jjP1CN^X0Dg[Z0000000205=jjP060=@m6@000000
Dg[Z0000001DNnX00000101DNnX00`000000E7_Z05AkjP0305AkjP050000001DNnH0E7_V05AkiP00
00000`1DNnH0103D?AT0E7_V05AkiP00000405=hg`040000001CN=l0DgSO05=hg`800000101@Lm82
0000000304UY_0000000BFVl0080BFVl00@0e3dI03mHVP00000000002@3om^h0103D?AT0ooK^0?of
kP3om^h70=@m6@030?ofkP3D?AT0ooK^00H0ooK^00<0e3dI0?ofkP3om^h00P3om^h80=@m6@<0ooK^
00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP0A0?ofkP030=@m6@3om^h0e3dI00H0ooK^
0P00001@0?ofkP40oooo000Z0?ofkP030000003om^h0ooK^0280ooK^00<0e3dI0?ofkP3om^h04P3o
m^h00`3D?AT0ooK^0?ofkP0D0?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h01`3o
m^h00`3D?AT0ooK^0?ofkP040?ofkP030000003om^h0e3dI0080ooK^1`3D?AT30?ofkP030=@m6@3o
m^h0ooK^00H0e3dI00D0ooK^000000000000000001XYG`02000000808cUm00<000000>506`3Q@1/0
1@3Q@1/00`0mFJ/0hD0K0>506`050>506`030000003Q@1/0hD0K0080hD0K00<0?EV[0>506`000000
103Q@1/700000080jD<L00<0?EV[0>U3700000001@3Y@a`00`000000jD<L0>U370040>U370070000
003Y@a`0jD<L0>U3700mFJ/0jD<L000000060>U370030000003Y@a`0jD<L00<0jD<L00<000000>U3
703Y@a`00P3Y@a`00`0mFJ/000000>U370030>U37080?EV[103Y@a`00`000000jD<L0>U370020>U3
70040000001CN^X0Dg[Z000000<0Dg[Z00H0e3dI05=jjP1CN^X0000005AkjP00000405AkjP030000
001DNnX0E7_Z0080E7_Z0P00000205AkiP030000001DNnH0E7_V0080E7_V00@0e3dI05AkiP000000
0000101CN=l01@000000DgSO05=hg`1CN=l0000000@0D7?B00<00000051cdP1@Lm800P00000304UY
_0030=@m6@0oF9X0000000800000103om^h80=@m6@P0ooK^00<0e3dI0?ofkP3om^h00P3om^h80=@m
6@/0ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP0@0?ofkP040=@m6@3om^h0ooK^
0=@m6@D0ooK^0P00001@0?ofkP40oooo000Z0?ofkP030000003om^h0ooK^0280ooK^00<0e3dI0?of
kP3om^h04`3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?of
kP3om^h01`3om^h0103D?AT0ooK^0?ofkP3om^h80=@m6@L0ooK^1P3D?AT20?ofkP030=@m6@3om^h0
ooK^00<0ooK^0`0000001P0J:El000000000000000008cUm000000L0hD0K00<0?EV[0>506`3Q@1/0
1@3Q@1/00`000000hD0K0>506`020>506`0303eIZ`000000000000<00000103Y@a`00`000000jD<L
0>U370030>U3700303eIZ`000000jD<L00@0jD<L00<000000>U3703Y@a`0103Y@a`00`000000jD<L
0>U370020>U3700303eIZ`000000jD<L00D0jD<L00<000000>U3703Y@a`00`3Y@a`00`000000jD<L
0>U370020>U3700403eIZ`3Y@a`0jD<L0>U37080?EV[1@3Y@a`00`000000jD<L0>U370020>U37004
0000001CN^X0Dg[Z000000<0Dg[Z00<000000=@m6@1CN^X00P1CN^X00`000000E7_Z05AkjP0205Ak
jP030000001DNnX0E7_Z0080E7_Z00<0000005AkjP0000000P1DNnH00`000000E7_V05AkiP0205Ak
iP050=@m6@000000E7_V05AkiP0000000P1CN=l010000000DgSO05=hg`1CN=l2000000@0D7?B00@0
0000051cdP1@Lm8000000`19JK`010000000e3dI0000000oF9X60=@m6@@0ooK^00<0e3dI0?ofkP3o
m^h01`3om^h70=@m6@<0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP030?ofkP03
0=@m6@3om^h0ooK^0100ooK^00@0e3dI0?ofkP3om^h0e3dI1@3om^h200000500ooK^0@3oool002/0
ooK^00<000000?ofkP3om^h08@3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^01<0
ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP040?ofkPH0e3dI103om^h00`000000
e3dI0?ofkP020?ofkPH0e3dI103om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00D0ooK^100000001P0J
:El0000002<iO@0000008cUm000000H0hD0K00<0?EV[0000003Q@1/00`3Q@1/70000000403eIZ`3Y
@a`0jD<L000000H0jD<L00<000000>U3703Y@a`00`3Y@a`00`0mFJ/0jD<L000000050>U370030000
003Y@a`0jD<L00<0jD<L00<000000>U3703Y@a`00P3Y@a`00`0mFJ/000000>U370050>U370030000
003Y@a`0jD<L00<0jD<L00<000000>U3703Y@a`00P3Y@a`01P000000?EV[03eIZ`0mFJ/0jD<L0000
00D0jD<L00<000000>U3703Y@a`00P3Y@a`010000000Dg[Z05=jjP00000305=jjP040000003D?AT0
Dg[Z05=jjP8000000`1DNnX00`000000E7_Z05AkjP0205AkjP040000001DNnX0E7_Z05AkjP800000
1@1DNnH01`000000e3dI05AkiP1DNnH0000005=hg`000000101CN=l00`000000DgSO00000002051c
dP050000001@Lm80D7?B051cdP0000000`19JK`01P000000e3dI0000003D?AT0?eRJ000000P0ooK^
00@0e3dI0?ofkP3om^h0ooK^1P3D?AT20?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3o
m^h03P3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^0100ooK^103D?AT50?ofkP80
0000D03om^h10?ooo`00;03om^h00`000000ooK^0?ofkP0P0?ofkP030=@m6@3om^h0ooK^01<0ooK^
00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0e3dI00@0e3dI
0P3om^h00`3D?AT0ooK^0?ofkP020?ofkPP0e3dI2P3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00H0
ooK^00<00000018J@00000000`000000100S>Gd0000002<iO@0000040>506`80000000<0?EV[0000
000000000P0000040>U370050000003Y@a`0jD<L0>U3700mFJ/00P3Y@a`00`000000jD<L0>U37004
0>U370030000003Y@a`0jD<L00<0jD<L00<0?EV[0000003Y@a`0103Y@a`00`000000jD<L0>U37004
0>U370070000003Y@a`0jD<L0>U3700mFJ/0jD<L000000050>U370030000003Y@a`0jD<L0080jD<L
00<000000>U3703Y@a`00`3Y@a`203eIZ`<0jD<L00<000000>U3703Y@a`00P3Y@a`00`000000jD<L
0>U3700300000080Dg[Z00D0000005=jjP1CN^X0Dg[Z0000000205=jjP070=@m6@000000Dg[Z05=j
jP000000E7_Z0000000405AkjP030000001DNnX0E7_Z0080E7_Z00<0000005AkiP1DNnH00`1DNnH0
0`000000E7_V0=@m6@0305AkiP8000000`1CN=l010000000DgSO05=hg`000002051cdP050000001@
Lm80D7?B051cdP0000000`19JK`00`000000BFVl0=@m6@0203mHVP030000003om^h0ooK^00@0ooK^
1P3D?AT80?ofkP030=@m6@3om^h0ooK^00H0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^
0?ofkP020?ofkP030=@m6@3om^h0ooK^00T0ooK^203D?AT20?ofkP030=@m6@3om^h0ooK^00<0ooK^
00<000000?ofkP000000C`3om^h10?ooo`00;@3om^h00`000000ooK^0?ofkP0O0?ofkP030=@m6@3o
m^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h0503om^h00`3D?AT0ooK^0?ofkP050?ofkPH0e3dI0`3o
m^h90=@m6@@0ooK^00<0e3dI0?ofkP3om^h02`3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI00L0ooK^
00<0000003eIZ`0000001@0000000`0S>Gd000000000000200000080jD<L00<0?EV[0>U370000000
1`3Y@a`010000000jD<L0>U3700mFJ/30>U370030000003Y@a`0jD<L00@0jD<L00<000000>U3703Y
@a`00P3Y@a`00`0mFJ/0jD<L000000050>U370030000003Y@a`0jD<L00<0jD<L00<000000>U3703Y
@a`00P3Y@a`00`0mFJ/000000>U370040>U370030000003Y@a`0jD<L0080jD<L00<000000>U3703Y
@a`00`0mFJ/01@3Y@a`0?EV[0>U3703Y@a`0000000<0jD<L1@0000001@3aAQh000000000001CN^X0
000000<0Dg[Z00H0000005=jjP1CN^X0Dg[Z0=@m6@00000205=jjP030000001DNnX0000000<0E7_Z
00<0000005AkjP1DNnX00P1DNnX2000000D0E7_V00<0000005AkiP3D?AT00`1DNnH01@000000DgSO
05=hg`1CN=l0000000<0DgSO00<00000051cdP0000000`1@Lm801@000000D7?B00000019JK`00000
0080BFVl00@0e3dI03mHVP0oF9X000001P3D?AT20?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI
0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP0=0?ofkP030=@m6@3om^h0ooK^0080ooK^00@0e3dI
0?ofkP3om^h0ooK^203D?AT80?ofkP030=@m6@3om^h0e3dI00H0ooK^0P00001?0?ofkP40oooo000^
0?ofkP030000003om^h0ooK^01l0ooK^00<0e3dI0?ofkP3om^h04P3om^h00`3D?AT0ooK^0?ofkP0D
0?ofkP030=@m6@3om^h0ooK^00D0e3dI103om^h50=@m6@D0ooK^00<0e3dI0?ofkP3om^h01@3om^h0
0`3D?AT000000?ofkP0<0?ofkP040=@m6@3om^h0ooK^0=@m6@L0ooK^0P0000000`0mFJ/000000000
000202<iO@80000000D08cUm000000000000jD<L03eIZ`020>U3700303eIZ`3Y@a`0000000L0jD<L
00@000000>U3703Y@a`0?EV[0`3Y@a`00`000000jD<L0>U370040>U370030000003Y@a`0jD<L0080
jD<L00<0?EV[0000003Y@a`0103Y@a`00`000000jD<L0>U370030>U370030000003Y@a`0jD<L0080
jD<L00<0?EV[0000003Y@a`0103Y@a`00`000000jD<L0>U370020>U370<0?EV[1@0000000`0mFJ/0
000000000003000000030?567P000000lDHN0080lDHN00<00000055ij01ANNP00P00000305=jjP05
0000001CN^X0Dg[Z05=jjP3D?AT0101CN^X00`000000E7_Z05AkjP0205AkjP050000001DNnX0E7_Z
05AkjP0000000P1DNnX01@000000E7_V05AkiP1DNnH000000080E7_V00<0e3dI05AkiP1DNnH00P00
000305=hg`030000001CN=l0DgSO0080DgSO0P000003051cdP040000001@Lm80000004UY_0L0e3dI
00<0?EV[0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00D0ooK^
00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0=@m6@060=@m6A00ooK^00<0e3dI0?ofkP3D?AT0
1P3om^h2000004l0ooK^0@3oool002l0ooK^00<000000?ofkP3om^h07P3om^h00`3D?AT0ooK^0?of
kP0B0?ofkP030=@m6@3om^h0ooK^0140ooK^1P3D?AT90?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0
e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0000000<0?ofkP040=@m6@3om^h0ooK^0=@m6@P0ooK^
0P0000000`0J:El000000000000202<iO@<0000000<0<4^M0000003Y@a`00`0mFJ/20>U370800000
1P3Y@a`00`000000jD<L03eIZ`040>U370030000003Y@a`0jD<L00<0jD<L00<000000>U3703Y@a`0
0P3Y@a`00`0mFJ/0jD<L000000050>U370030000003Y@a`0jD<L0080jD<L00<000000>U3703Y@a`0
0`3Y@a`00`0mFJ/0jD<L0>U370030>U370030000003Y@a`0jD<L0080?EV[0`0000050?567P0303eI
Z`3aAQh0lDHN00@0lDHN00D000000?567P3aAQh0lDHN00000002055ij0050000001CN^X0Dg[Z05=j
jP0000000`1CN^X00`000000e3dI05=jjP0205=jjP8000000`1DNnX01@000000E7_Z05AkjP1DNnX0
000000<0E7_Z00@0000005AkiP1DNnH00000101DNnH0103D?AT0000005AkiP00000205=hg`030000
001CN=l0DgSO00<0DgSO00<000000=@m6@3D?AT01P3D?AT010000000BFVl04UY_03D?AT203mHVP03
0000000mFJ/0ooK^00L0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP050?ofkP03
0=@m6@3om^h0ooK^00P0ooK^1`3D?AT30?ofkP030=@m6@3om^h0ooK^0140ooK^00<0e3dI0?ofkP3D
?AT01P3om^h2000004l0ooK^0@3oool002l0ooK^00<000000?ofkP3om^h07P3om^h00`3D?AT0ooK^
0?ofkP0C0?ofkP030=@m6@3om^h0ooK^00T0ooK^1`3D?AT30?ofkP030=@m6@3om^h0ooK^00T0ooK^
00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0000000`0ooK^
00D0e3dI0?ofkP3om^h0ooK^0=@m6@070?ofkPD000000`0S>Gd01@0000008cUm0000003D?AT00000
0080jD<L0`0mFJ/20>U370030000003Y@a`0jD<L00@0jD<L00<000000>U3700mFJ/00`3Y@a`00`00
0000jD<L0>U370040>U370030000003Y@a`0jD<L0080jD<L00<0?EV[0000003Y@a`0103Y@a`00`00
0000jD<L0>U370030>U370030000003Y@a`0jD<L0080jD<L00@0?EV[0>U3703Y@a`0jD<L0P000003
03eIZ`80lDHN00D000000?567P3aAQh0lDHN000000040?567P0303eIZ`3aAQh0lDHN0080lDHN00D0
00000?567P3aAQh0lDHN00000002055ij0050000001ANNP0000005=jjP0000000`1CN^X020000000
Dg[Z05=jjP3D?AT0Dg[Z0000001CN^X000000P1DNnX01@000000E7_Z05AkjP1DNnX0000000D0E7_Z
0P00000505AkiP050=@m6@1DNnH0E7_V05AkiP000000203D?AT3051cdP050000001@Lm80D7?B051c
dP0000000`19JK`00`3D?AT000000000000203eIZ`P0ooK^00<0e3dI0?ofkP3om^h02@3om^h00`3D
?AT0ooK^0?ofkP050?ofkP040=@m6@3om^h0ooK^0?ofkPL0e3dI1@3om^h00`3D?AT0ooK^0?ofkP02
0?ofkP030=@m6@3om^h0ooK^00h0ooK^103D?AT00`3om^h0e3dI0?ofkP050?ofkP800000C`3om^h1
0?ooo`00<03om^h00`000000ooK^0?ofkP0M0?ofkP030=@m6@3om^h0ooK^01<0ooK^00@0e3dI0?of
kP3om^h0ooK^203D?AT;0?ofkP030=@m6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h0203om^h0
0`3D?AT0ooK^0?ofkP040?ofkP040=@m6@3om^h0ooK^000000/0ooK^00D0e3dI0?ofkP3om^h0ooK^
0=@m6@080?ofkPH000000P0S>Gd0100000008cUm0=@m6@0`Bid200000080jD<L1@0mFJ/60>U37003
0000000mFJ/0jD<L00<0jD<L00<000000>U3703Y@a`0103Y@a`01`000000jD<L0>U3703Y@a`0?EV[
0>U3700000001@3Y@a`00`000000jD<L0>U370080000000303eIZ`000000?EV[0080?EV[00<00000
0?567P3aAQh00P3aAQh01@000000lDHN0?567P3aAQh0000000@0lDHN00<0?EV[0?567P3aAQh00P3a
AQh010000000lDHN0?567P000002055ij0060000001ANNP0DGWX0000001CN^X000000P1CN^X01P00
0000Dg[Z05=jjP1CN^X0e3dI000000<0Dg[Z0P00000405AkjP030000001DNnX0E7_Z00<0E7_Z00<0
000005AkiP1DNnH00P1DNnH70=@m6@030000001CN=l0DgSO0080DgSO00H0000005=hg`1CN=l00000
051cdP000004051cdP0700000019JK`0BFVl00000019JK`0e3dI0000000303eIZ`L0ooK^00<0e3dI
0?ofkP3om^h02P3om^h0103D?AT0ooK^0?ofkP3om^h70=@m6@d0ooK^00D0e3dI0?ofkP3om^h0ooK^
0=@m6@080?ofkPP0e3dI0`3om^h0103D?AT0ooK^0?ofkP3D?AT50?ofkP800000C`3om^h10?ooo`00
<@3om^h00`000000ooK^0?ofkP0L0?ofkP030=@m6@3om^h0ooK^0100ooK^1`3D?ATC0?ofkP030=@m
6@3om^h0ooK^00P0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?ofkP040?ofkP040=@m
6@3om^h0ooK^000000`0ooK^00@0e3dI0?ofkP3om^h0e3dI203om^h20000000503eIZ`0000000000
02<iO@0000000P0S>Gd00`000000e3dI00000002031;W@030000003Y@a`0?EV[00@0jD<L100mFJ/3
0>U370030000000mFJ/0jD<L00<0jD<L00<000000>U3703Y@a`0103Y@a`01P000000jD<L0>U3703Y
@a`0?EV[000000<0jD<L1@0000020?567P030000003aAQh0?EV[00D0?EV[0`3aAQh01@000000lDHN
0?567P3aAQh0000000@0lDHN00L000000?567P3aAQh0lDHN0000003aAQh0?EV[0080lDHN00@00000
0?567P3aAQh000000`1ANNP01@000000DGWX055ij01ANNP000000080Dg[Z00<0000005=jjP1CN^X0
0P1CN^X00`3D?AT0Dg[Z05=jjP0205=jjP030000001DNnX0E7_Z0080E7_Z00<0000005AkjP1DNnX0
0P1DNnX00`0mFJ/0e3dI0=@m6@040=@m6@030000001DNnH0e3dI00<0E7_V00<0000005=hg`1CN=l0
0`1CN=l01P000000DgSO05=hg`000000D7?B000000<0D7?B0P00000204UY_00400000019JK`0e3dI
000000<0?EV[1`3om^h00`3D?AT0ooK^0?ofkP080?ofkPH0e3dI0`3om^h00`3D?AT0ooK^0?ofkP0>
0?ofkP040=@m6@3om^h0ooK^0?ofkPT0e3dI2`3om^h0103D?AT0ooK^0?ofkP3D?AT50?ofkP800000
C`3om^h10?ooo`00<P3om^h00`000000ooK^0?ofkP0L0?ofkP030=@m6@3om^h0ooK^00P0ooK^1`3D
?AT30?ofkP030=@m6@3om^h0ooK^01@0ooK^00<0e3dI0?ofkP3om^h0203om^h00`3D?AT0ooK^0?of
kP080?ofkP030=@m6@3om^h0ooK^00@0ooK^00D0e3dI0?ofkP3om^h0ooK^0000000;0?ofkP040=@m
6@3om^h0ooK^0=@m6@<0ooK^200000001@0mFJ/000000000000S>Gd0000000<08cUm00<0e3dI031;
W@0000000`3D?AT00`0mFJ/0jD<L0>U370020>U370030000003Y@a`0jD<L00D0?EV[1@3Y@a`00`00
0000jD<L0>U370030>U370050000003Y@a`0jD<L0>U3700mFJ/0100000000`3aAQh0?EV[03eIZ`06
03eIZ`<0lDHN00<0000003eIZ`3aAQh00`3aAQh01@000000lDHN0?567P3aAQh0000000@0lDHN00T0
00000?567P3aAQh0lDHN0000003aAQh0?EV[0?567P0000000`3aAQh010000000DGWX055ij0000003
055ij08000000P1CN^X01P000000Dg[Z05=jjP1CN^X000000=@m6@<0Dg[Z00<0000005=jjP000000
0P1DNnX00`000000e3dI0=@m6@040=@m6@80E7_Z00@0000005AkiP1DNnH000000`1DNnH0103D?AT0
E7_V00000000000405=hg`030000001CN=l0DgSO0080DgSO00<00000051cdP1@Lm800P1@Lm802000
0000D7?B00000019JK`0000004UY_03D?AT000000`0mFJ/70?ofkP040=@m6@3om^h0ooK^0?ofkPL0
e3dI0P3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00`0ooK^1`3D?ATD0?ofkP03
0=@m6@3om^h0e3dI00H0ooK^0P00001>0?ofkP40oooo000c0?ofkP030000003om^h0ooK^01/0ooK^
00@0e3dI0?ofkP3om^h0ooK^1`3D?AT;0?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3o
m^h0203om^h00`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3o
m^h00P3om^h00`000000ooK^0?ofkP080?ofkP040=@m6@00000000000=@m6@<000001P3om^h0103D
?AT000000000000J:El20000000302<iO@3D?AT0e3dI00@0e3dI0P0000000`0`Bid000000>U37004
0>U370800000103Y@a`F03eIZ`80lDHN00<000000?567P3aAQh00P3aAQh00`000000lDHN0?567P02
0?567P030000000mFJ/0lDHN0080lDHN00D000000?567P3aAQh0lDHN000000030?567P050000003a
AQh0lDHN0?567P0000000`3aAQh01@0mFJ/000000?567P3aAQh000000080DGWX00D00000055ij01A
NNP0DGWX00000002055ij08000000`1CN^X010000000Dg[Z05=jjP3D?AT2000000H0e3dI101DNnX0
1`000000E7_Z05AkjP1DNnX0000005AkiP000000101DNnH01@3D?AT0000005AkiP1DNnH000000080
DgSO00<0000005=hg`1CN=l00`1CN=l01@000000D7?B051cdP1@Lm8000000080D7?B00H0000004UY
_0000000BFVl0=@m6@00000403eIZ`@0ooK^1P3D?AT90?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0
e3dI0?ofkP3om^h01P3om^h60=@m6@80ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?of
kP0A0?ofkP030=@m6@3om^h0e3dI00H0ooK^0P00001>0?ofkP40oooo000d0?ofkP030000003om^h0
ooK^01X0ooK^103D?ATB0?ofkP030=@m6@3om^h0ooK^01@0ooK^00<0e3dI0?ofkP3om^h01`3om^h0
0`3D?AT0ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h00P3om^h0
0`000000ooK^0?ofkP020?ofkPH0000000@0e3dI0?ofkP3om^h0e3dI0`3om^h=0=@m6@808cUm00@0
00000=@m6@00000000000P0`Bid00`000000<4^M000000060>U370040000003Y@a`0jD<L0>U37080
000000<0?EV[0000000000001P0000030?567P060000003aAQh0lDHN0?567P0mFJ/00000103aAQh0
0`000000lDHN0?567P020?567P030000003aAQh0lDHN0080lDHN00<0000003eIZ`3aAQh00P3aAQh0
1@000000lDHN0?567P3aAQh0000000<0lDHN00D000000?567P3aAQh0lDHN000000030?567P0403eI
Z`3aAQh0lDHN00000080DGWX00D00000055ij01ANNP0DGWX00000003055ij0050000001CN^X0Dg[Z
05=jjP0000001P3D?AT305=jjP030000001DNnX0E7_Z0080E7_Z0P00000505AkjP030000001DNnH0
E7_V00<0E7_V00L0e3dI05AkiP1DNnH0E7_V0000001CN=l0000000D0DgSO0P000003051cdP030000
001@Lm80D7?B008000000`19JK`00`3D?AT0?EV[03eIZ`060=@m6@80ooK^00<0e3dI0?ofkP3om^h0
2`3om^h00`3D?AT0ooK^0?ofkP030?ofkP030=@m6@3om^h0ooK^00H0e3dI203om^h00`3D?AT0ooK^
0?ofkP020?ofkP030=@m6@3om^h0ooK^0100ooK^103D?AT60?ofkP800000CP3om^h10?ooo`00=03o
m^h00`000000ooK^0?ofkP0J0?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h0503o
m^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h00`3o
m^h00`3D?AT0ooK^0?ofkP030?ofkP@000001P3om^h=0=@m6@80ooK^0P0000000`0mFJ/06RUO0000
00020000000302<iO@000000e3dI00<0000000<0<4^M0000000`Bid00P0000030>U370D000000P3a
AQh00`0mFJ/000000?567P040?567P030000003aAQh0lDHN00<0lDHN00H000000?567P3aAQh0?EV[
0?567P0000040?567P050000003aAQh0lDHN0?567P000000103aAQh01@000000lDHN03eIZ`3aAQh0
000000@0lDHN00D000000?567P3aAQh0lDHN000000020?567P030000003aAQh0lDHN0080lDHN00<0
?EV[0?567P0000000P1ANNP01@000000DGWX055ij01ANNP0000000<0DGWX1P3D?AT205=jjP030000
003D?AT0Dg[Z0080Dg[Z0`00000305AkjP030000001DNnX0E7_Z00@0E7_Z0P00000305AkiP800000
00<0E7_V0=@m6@1DNnH00P1DNnH2000000@0DgSO00H0000005=hg`1CN=l00000051cdP000004051c
dP0300000019JK`0BFVl00@0e3dI0`0mFJ/50?ofkP030=@m6@3om^h0ooK^00/0ooK^00<0e3dI0?of
kP3om^h01P3D?AT?0?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT02`3om^h70=@m6@040?ofkP3D?AT0
ooK^0=@m6@H0ooK^0P00001>0?ofkP40oooo000e0?ofkP030000003om^h0ooK^01X0ooK^00<0e3dI
0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^00L0ooK^00<0e3dI
0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00<0ooK^00@00000
0?ofkP3om^h0ooK^2`3D?AT:0?ofkP<000000P0J:El01P0000008cUm0000000S>Gd0e3dI00000080
<4^M00D00000031;W@0000000000031;W@03000000<0lDHN00<000000?567P3aAQh00P3aAQh00`0m
FJ/000000?567P040?567P030000003aAQh0lDHN0080lDHN00H000000?567P3aAQh0lDHN03eIZ`00
00040?567P030000003aAQh0lDHN0080lDHN00T000000?567P3aAQh0lDHN0000003aAQh0?EV[0?56
7P000000103aAQh01@000000lDHN0?567P3aAQh000000080lDHN00X000000?567P3aAQh0lDHN0000
000mFJ/0lDHN0000001ANNP000000P1ANNP60=@m6@80DGWX0P00000305=jjP060000001CN^X0Dg[Z
0=@m6@1CN^X000000P1CN^X010000000E7_Z05AkjP00000505AkjP80000000D0E7_Z0000001DNnH0
E7_V0000000305AkiP050=@m6@1DNnH0E7_V05AkiP000000101CN=l01`000000DgSO05=hg`1CN=l0
0000051cdP000000101@Lm801@000000BFVl04UY_00mFJ/0e3dI00D0?EV[1@3om^h00`3D?AT0ooK^
0?ofkP080?ofkPH0e3dI103om^h00`3D?AT0ooK^0?ofkP0>0?ofkP050=@m6@3om^h0ooK^0?ofkP3D
?AT00`3om^h80=@m6@T0ooK^0P3D?AT60?ofkP800000CP3om^h10?ooo`00=P3om^h00`000000ooK^
0?ofkP0I0?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^
0?ofkP070?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h00P3om^h0103D?AT0ooK^
0?ofkP3om^h;0=@m6@80ooK^00<0e3dI0?ofkP3D?AT0303om^h3000000806RUO00H0000002<iO@00
0000e3dI02<iO@000002031;W@050000000`Bid0<4^M0000000`Bid00P0000050?567P050000003a
AQh0lDHN03eIZ`3aAQh00P0000040?567P030000003aAQh0lDHN0080lDHN00H000000?567P3aAQh0
?EV[0?567P0000040?567P050000003aAQh0lDHN0?567P0000000`3aAQh01@000000lDHN0?567P0m
FJ/0000000<0lDHN00D000000?567P3aAQh0lDHN000000020?567P050000003aAQh0lDHN0?567P3D
?AT00`0000050=@m6@050000001ANNP0DGWX055ij00000000`1ANNP00`000000Dg[Z05=jjP020000
00<0Dg[Z00<0e3dI0000001CN^X00`1CN^X2000000D0E7_Z00<0000005AkjP1DNnX00P1DNnX20000
00@0E7_V00<0e3dI05AkiP1DNnH00P00000405=hg`030000001CN=l0DgSO0080DgSO00<00000051c
dP1@Lm800P1@Lm8200000080BFVl00@0?EV[0=@m6@0mFJ/0ooK^0`0mFJ/50?ofkP030=@m6@3om^h0
ooK^00P0e3dI0`3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00h0ooK^203D?ATA
0?ofkP80e3dI1P3om^h2000004h0ooK^0@3oool003L0ooK^00<000000?ofkP3om^h0603om^h00`3D
?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^01@0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D
?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00`0e3dI203om^h20=@m6@d0ooK^00@0000001XY
G`0000006RUO0P0000000`0S>Gd000000=@m6@0300000004031;W@0000000000031;W@80000000<0
>UVf000000000000103aAQh2000000050?567P0mFJ/0lDHN0?567P000000103aAQh00`000000lDHN
0?567P020?567P060000003aAQh0lDHN03eIZ`3aAQh000000`3aAQh01@000000lDHN0?567P3aAQh0
000000<0lDHN00D000000?567P3aAQh0?EV[000000030?567P060000003aAQh0lDHN0=@m6@000000
lDHN2@0000001@1ANNP00000055ij01ANNP0000000<0DGWX00@00000055ij01ANNP0DGWX0P000000
0`1CN^X0000005=jjP0305=jjP030000003D?AT0Dg[Z00@0Dg[Z00<0000005AkjP1DNnX00`1DNnX0
0`000000E7_Z05AkjP0305AkjP030000001DNnH0E7_V00@0E7_V00D0e3dI0000001DNnH0E7_V0000
000205=hg`030000001CN=l0DgSO00<0DgSO00<00000051cdP1@Lm800P1@Lm801`000000D7?B0000
0019JK`0000003eIZ`3D?AT00P3om^h203eIZ`P0e3dI2`3om^h00`3D?AT0ooK^0?ofkP040?ofkP03
0=@m6@3om^h0ooK^00P0ooK^1`3D?AT30?ofkP030=@m6@3om^h0ooK^0100ooK^0`3D?AT00`3om^h0
e3dI0?ofkP050?ofkP800000C@3om^h10?ooo`00>03om^h00`000000ooK^0?ofkP0H0?ofkP030=@m
6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m
6@3om^h0ooK^00L0ooK^1P3D?AT00`3om^h0e3dI0=@m6@030=@m6@80ooK^00<000000?ofkP3om^h0
2@3om^h20=@m6@d0ooK^0P0000000`0J:El0000001XYG`03000000040=@m6@0000000000031;W@80
000000D0<4^M0000000`Bid0<4^M0000000203YI]P030000003aAQh0lDHN00<0lDHN00<000000?56
7P0mFJ/00P3aAQh00`000000lDHN0?567P020?567P030000003aAQh0lDHN0080lDHN00D000000?56
7P0mFJ/0lDHN000000040?567P040000003aAQh0lDHN000000@0lDHN00@000000?567P3aAQh0?EV[
0`3aAQh00`000000lDHN0?567P03000000@0n4PO00<000000?Q87`0000000P1?M^@010000000DGWX
055ij0000002055ij08000000P1ANNP200000080DGWX00<0000005=jjP1CN^X00P1CN^X01P000000
Dg[Z05=jjP3D?AT0Dg[Z03eIZ`<00000101DNnX00`000000E7_Z05AkjP0305AkjP8000001P1DNnH0
1`3D?AT0E7_V05AkiP1DNnH0000005=hg`0000001@1CN=l2000000<0D7?B00@00000051cdP1@Lm80
0000203D?AT00`0mFJ/0ooK^0?ofkP020?ofkP030=@m6@3om^h0ooK^00`0ooK^00<0e3dI0?ofkP3o
m^h00`3om^h0103D?AT0ooK^0?ofkP3om^h70=@m6@H0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@0<
0?ofkPH0e3dI0P3om^h00`3D?AT0ooK^0=@m6@060?ofkP800000C@3om^h10?ooo`00>@3om^h00`00
0000ooK^0?ofkP0G0?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D
?AT0ooK^0?ofkP060?ofkP040=@m6@3om^h0ooK^0?ofkPH0e3dI00<0ooK^0=@m6@3D?AT0103D?AT0
0`3om^h0e3dI0?ofkP040?ofkP030000003om^h0ooK^00T0ooK^0P3D?AT>0?ofkP80000000<06RUO
0000000000000P0S>Gd00`3D?AT08cUm00000003031;W@040000000`Bid00000031;W@<0000000<0
>UVf000000000000103aAQh00`000000?EV[0?567P020?567P030000003aAQh0lDHN0080lDHN00<0
00000?567P3aAQh00P3aAQh01@000000lDHN03eIZ`3aAQh0000000<0lDHN00D000000?567P3aAQh0
lDHN000000030?567P040000003aAQh0000003eIZ`H000000`3hB1l00`000000n4PO03eIZ`030?Q8
7`060000001?M^@000000000001ANNP000000P1ANNP01@000000DGWX055ij01ANNP0000000<0DGWX
0P00000305=jjP070000001CN^X0Dg[Z05=jjP3D?AT0Dg[Z0000000205=jjP030000001DNnX0E7_Z
00800000101DNnX200000080E7_Z00@0000005AkiP1DNnH0E7_V0P0000000`3D?AT0E7_V05AkiP02
05AkiP030000001CN=l0DgSO00<0DgSO00<0000005=hg`3D?AT01`3D?AT010000000ooK^03eIZ`3D
?AT30?ofkP80?EV[103om^h00`3D?AT0ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^00L0e3dI3P3o
m^h0103D?AT0ooK^0?ofkP3D?AT60?ofkPH0e3dI203om^h00`3D?AT0ooK^0=@m6@060?ofkP800000
C@3om^h10?ooo`00>@3om^h00`000000ooK^0?ofkP0G0?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0
e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP060?ofkP/0e3dI0`3om^h01@3D?AT0ooK^0?of
kP3om^h0e3dI00@0ooK^00<000000?ofkP3om^h02`3om^h00`3D?AT0ooK^0?ofkP0<0?ofkP<00000
00<06RUO0000000000000P0S>Gd00`3D?AT08cUm00000003031;W@D0000000@0>UVf000000000000
>UVf0P0000030?567P030000000mFJ/0lDHN0080lDHN00<000000?567P3aAQh00P3aAQh02@000000
lDHN0?567P3aAQh000000?567P0mFJ/0lDHN000000040?567P030000003aAQh0000000H0000000<0
n4PO0000000mFJ/01@3hB1l00`000000n4PO03eIZ`0203eIZ`060?Q87`000000n4PO0000001?M^@0
00000P1?M^@010000000DGWX055ij0000003055ij0030000001ANNP0DGWX008000000P1ANNP30000
00@0Dg[Z00<0e3dI0000001CN^X00`1CN^X2000000D0E7_Z00<0000005AkjP1DNnX00P1DNnX01000
0000E7_V05AkiP00000305AkiP040=@m6@1DNnH0E7_V000000P0e3dI00@0DgSO0000001@Lm800000
101@Lm801@000000ooK^0?ofkP0mFJ/0e3dI0080ooK^0`0mFJ/30?ofkP030=@m6@3om^h0ooK^00P0
ooK^1`3D?AT30?ofkP030=@m6@3om^h0ooK^00l0ooK^00@0e3dI0?ofkP3om^h0ooK^1P3D?AT=0?of
kP@0e3dI1P3om^h2000004d0ooK^0@3oool003X0ooK^00<000000?ofkP3om^h05`3om^h00`3D?AT0
ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^01<0ooK^00@0e3dI0?ofkP3om^h0ooK^203D?AT;0?of
kP040=@m6@3om^h0ooK^0=@m6@@0ooK^00<000000?ofkP3om^h02P3om^h20=@m6@l0ooK^0`000000
1@0J:El0000002<iO@0S>Gd0e3dI00@000000`0`Bid3000000<0>UVf0P0000000`0jFKH000000?56
7P020?567P0303eIZ`000000lDHN0080lDHN0P0000030?567P070000003aAQh0lDHN0?567P000000
lDHN03eIZ`07000000030?Q87`000000n4PO0080n4PO00D000000?Q87`3hB1l0000003eIZ`030?Q8
7`@0?EV[00X000000?Q87`3hB1l000000?Q87`000000CgKT0000001?M^@0e3dI0P0000000`1ANNP0
0000055ij002055ij0040000001ANNP0DGWX000000@0DGWX00<0000005=jjP1CN^X00`1CN^X20000
00030=@m6@1CN^X0Dg[Z0080Dg[Z00<0000005AkjP1DNnX00`1DNnX00`000000E7_Z05AkjP0405Ak
jP8000000P1DNnH60=@m6@050000001CN=l0DgSO05=hg`0000001@1CN=l2000000<0D7?B00H00000
0?ofkP3om^h0ooK^03eIZ`3D?AT20?ofkP<0?EV[0`3om^h0103D?AT0ooK^0?ofkP3om^h70=@m6@@0
ooK^00<0e3dI0?ofkP3om^h00`3om^h00`3D?AT0ooK^0?ofkP0<0?ofkPP0e3dI2`3om^h70=@m6@80
ooK^0P3D?AT60?ofkP800000C@3om^h10?ooo`00>`3om^h00`000000ooK^0?ofkP0F0?ofkP030=@m
6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h0403om^h70=@m6@@0ooK^00<0e3dI0?ofkP3om^h0
303om^h0103D?AT0ooK^0?ofkP3D?AT40?ofkP030000003om^h0ooK^00X0ooK^0P3D?AT@0?ofkP03
0000000J:El0000000<0000000D08cUm0=@m6@0S>Gd00000031;W@02000000<0<4^M0`00000303YI
]P040000000jFKH0000000000080lDHN00<0?EV[0000000000000`3aAQh00`000000lDHN0?567P06
0000000303eIZ`3hB1l0n4PO00L0n4PO00@000000?Q87`3hB1l000000P3hB1l503eIZ`0;0?Q87`00
0000n4PO0?Q87`000000n4PO0000003hB1l0000004mfi00000000P1?M^@0103D?AT0CgKT04mfi000
0002055ij08000000P1ANNP010000000DGWX055ij01ANNP200000003055ij0000000Dg[Z0080Dg[Z
00@0000005=jjP1CN^X0e3dI0P1CN^X20000000405=jjP000000E7_Z05AkjP8000001@1DNnX60=@m
6@80E7_V00<0e3dI0000001DNnH00P1DNnH00`000000DgSO0000000605=hg`030000001@Lm80D7?B
0080D7?B00H000000?ofkP3om^h0ooK^03eIZ`3D?AT20?ofkP<0?EV[1`3D?AT<0?ofkP030=@m6@3o
m^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h0103om^h80=@m6@<0ooK^00D0e3dI0?ofkP3om^h0ooK^
0=@m6@030?ofkPP0e3dI2@3om^h20=@m6@H0ooK^0P00001=0?ofkP40oooo000l0?ofkP030000003o
m^h0ooK^01D0ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP090?ofkPL0e3dI0`3o
m^h00`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00`0ooK^00@0e3dI0?ofkP3om^h0e3dI
103om^h00`000000ooK^0?ofkP0:0?ofkP030=@m6@3om^h0e3dI00l0ooK^0P00000201XYG`040000
000S>Gd000000=@m6@808cUm00<00000031;W@0`Bid00P000003031;W@<000000P0jFKH200000003
03YI]P00000000000080lDHN00<0e3dI000000000000100000020?Q87`060000003hB1l0n4PO0?Q8
7`000000?EV[1@3hB1l010000000n4PO0?Q87`00000503eIZ`040000003hB1l0?EV[00000080n4PO
00<000000?Q87`0000000P3hB1l20000000704mfi0000000CgKT04mfi0000000e3dI04mfi0020000
0003055ij0000000DGWX0080DGWX00D00000055ij01ANNP0DGWX00000003055ij0040000001CN^X0
0000000000<0Dg[Z00<0e3dI0000000000000`1CN^X010000000E7_Z0000001DNnX60=@m6@<00000
101DNnH2000000040=@m6@1DNnH0E7_V05AkiP8000001P1CN=l2000000<0D7?B00@000000?ofkP3o
m^h0ooK^203D?AT30?ofkP030=@m6@3om^h0ooK^00d0ooK^00@0e3dI0?ofkP3om^h0ooK^203D?AT<
0?ofkPL0e3dI3P3om^h50=@m6@L0ooK^00<000000?ofkP3om^h0B`3om^h10?ooo`00?@3om^h00`00
0000ooK^0?ofkP0E0?ofkP030=@m6@3om^h0ooK^01<0ooK^00@0e3dI0?ofkP3om^h0ooK^1`3D?AT;
0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h03@3om^h00`3D?AT0ooK^0=@m6@04
0?ofkP030000003om^h0ooK^00X0ooK^00<0e3dI0?ofkP3D?AT03@3om^h30=@m6@8000000P0J:El0
1@0000008cUm0=@m6@0000008cUm00<000000P0`Bid200000003031;W@000000>UVf00H0e3dI00@0
000003YI]P00000000000P3hB1l00`000000n4PO0?Q87`0503eIZ`@0n4PO00@0?EV[0?Q87`3hB1l0
00001P0mFJ/00`000000n4PO000000020?Q87`040000003hB1l0n4PO03eIZ`80n4PO00@000000?Q8
7`000000n4PO0P00000204mfi0060000001?M^@0000004mfi0000000e3dI0P1?M^@00`000000DGWX
055ij00200000080DGWX0P000005055ij0030000001CN^X0Dg[Z00<0Dg[Z00@000000=@m6@1CN^X0
Dg[Z1P3D?AT405AkjP8000000`1DNnX010000000E7_V05AkiP00000205AkiP050=@m6@1DNnH0E7_V
05AkiP0000001P1CN=l00`000000DgSO00000002051cdPD0e3dI00D0?EV[0?ofkP0mFJ/0e3dI0?of
kP0403eIZ`80ooK^00<0e3dI0?ofkP3om^h02P3om^h70=@m6@030?ofkP3D?AT0ooK^00X0ooK^203D
?AT20?ofkP030=@m6@3om^h0ooK^00L0ooK^203D?AT20?ofkP<0e3dI1`3om^h2000004`0ooK^0@3o
ool003h0ooK^00<000000?ofkP3om^h0503om^h00`3D?AT0ooK^0?ofkP0@0?ofkPL0e3dI4P3om^h0
0`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3D?AT0103om^h0
0`000000ooK^0?ofkP0:0?ofkP040=@m6@3om^h0ooK^0=@m6@H0ooK^1P3D?AT30?ofkP<000000P0J
:El01P0000008cUm0=@m6@0000008cUm000000P0e3dI0P0jFKH300000080>UVf0P0000000`11I<P0
00000?Q87`020?Q87`060000003hB1l0n4PO0?Q87`000000n4PO200mFJ/010000000n4PO0?Q87`00
00020?Q87`060000003hB1l0n4PO0000003hB1l000000P3hB1l02P0mFJ/0n4PO0000003hB1l00000
0?Q87`000000n4PO0000001?M^@30000000404mfi0000000CgKT0=@m6@<0000000@0DGWX0000001A
NNP0DGWX0P000005055ij0<000000`1CN^X60=@m6@0405=jjP0000000000000000D0E7_Z00<00000
05AkjP1DNnX00`1DNnX00`000000E7_V0000000305AkiP030=@m6@1DNnH0E7_V008000001@1CN=l0
10000000DgSO05=hg`1CN=l20000000303eIZ`3om^h0ooK^0080ooK^00D0?EV[0?ofkP0mFJ/0e3dI
03eIZ`020?ofkP80?EV[0P3om^h00`3D?AT0ooK^0?ofkP020?ofkPP0e3dI0`3om^h00`3D?AT0ooK^
0?ofkP020?ofkP040=@m6@3om^h0ooK^0?ofkPP0e3dI203om^h0103D?AT0ooK^0=@m6@3om^h80=@m
6@@0ooK^1P3D?AT20?ofkP030=@m6@3om^h0ooK^00D0ooK^0P00001<0?ofkP40oooo000n0?ofkP03
0000003om^h0ooK^01@0ooK^00<0e3dI0?ofkP3om^h02@3om^h70=@m6@<0ooK^00<0e3dI0?ofkP3o
m^h04`3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^00d0ooK^00<0e3dI0?ofkP3D
?AT0103om^h00`000000ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00L0e3dI2@3om^h0103D?AT0
00000000000000070=@m6@<0<4^M0P000002031;W@8000000`0jFKH300000080>UVf00@00000045T
b011I<P000000`3hB1l00`000000n4PO0?Q87`0200000080n4PO00@000000?Q87`0mFJ/000000P3h
B1l010000000n4PO0?Q87`0000020?Q87`0;0000003hB1l000000?Q87`000000n4PO0000003hB1l0
?EV[0000003hB1l00P0000000`3hB1l0000004mfi0020000000304mfi000000000000080CgKT00D0
e3dI04mfi01?M^@0CgKT00000002055ij0030000001ANNP0DGWX00<0DGWX203D?AT305=jjP040=@m
6@1CN^X0000000000080Dg[Z00@0000005AkjP1DNnX0E7_Z0P00000705AkjP030000001DNnH0E7_V
00<0E7_V00D0e3dI0000001DNnH0E7_V0000000305=hg`030000001CN=l0DgSO0080DgSO0P000000
1@0mFJ/0ooK^0?ofkP3om^h0?EV[0080ooK^00<0?EV[0?ofkP3D?AT00P3om^h00`0mFJ/0e3dI0=@m
6@060=@m6@`0ooK^203D?AT>0?ofkPH0e3dI1`3om^h50=@m6@D0ooK^103D?AT70?ofkP800000C03o
m^h10?ooo`00?`3om^h00`000000ooK^0?ofkP0D0?ofkP040=@m6@3om^h0ooK^0?ofkPL0e3dI2`3o
m^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h03P3o
m^h20=@m6@@0ooK^00<000000?ofkP3om^h0203om^h60=@m6@`0ooK^1`3D?AT01@0J:El000000000
003D?AT0000000808cUm0P000003031;W@80000000@0<4^M00000000000000000`0jFKH400000004
045Tb0000000e3dI045Tb08000000P3hB1l010000000n4PO0?Q87`0000030?Q87`030000000mFJ/0
00000080n4PO00<000000?Q87`0000000P3hB1l030000000n4PO0000003hB1l000000?Q87`000000
n4PO0000000mFJ/000000?Q87`80000000D0CgKT000000000000CgKT0000000204mfi080000000<0
CgKT0=@m6@0000000P0000080=@m6@D0DGWX00<0000005=jjP1CN^X00`1CN^X00`000000e3dI05=j
jP0405=jjP<000001`1DNnX3000000@0E7_V00<000000=@m6@1DNnH00P1DNnH010000000DgSO05=h
g`00000505=hg`030000003om^h0?EV[00<0ooK^00<0?EV[0?ofkP3D?AT01P3D?AT203eIZ`030?of
kP3D?AT0ooK^00T0ooK^1`3D?AT30?ofkP030=@m6@3om^h0ooK^00T0ooK^1P3D?AT20?ofkP030=@m
6@3om^h0e3dI0080ooK^1P3D?AT20?ofkPP0e3dI2`3om^h2000004`0ooK^0@3oool00400ooK^00<0
00000?ofkP3om^h04`3om^h40=@m6A80ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?of
kP030?ofkP030=@m6@3om^h0ooK^00h0ooK^0P3D?AT40?ofkP030000003om^h0ooK^0080ooK^1P3D
?AT20?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT00`3om^h80=@m6@<0ooK^00T0e3dI0?ofkP000000
000003eIZ`0J:El0000002<iO@3D?AT00P000000100S>Gd00000000000000003031;W@8000000P0j
FKH300000080>UVf0`0000001@11I<P0e3dI000000000000@FC80080000000@0n4PO000000000000
n4PO0P0000020?Q87`0503eIZ`3hB1l000000?Q87`0000000P3hB1l00`000000n4PO0?Q87`020000
00030?Q87`000000n4PO00L0000000H0C77N000000000000CgKT0000001?M^@2000000L0e3dI101A
NNP2000000@0DGWX0P0000000`1ANNP0000005=jjP0205=jjP80000000<0Dg[Z0=@m6@1CN^X0101C
N^X00`000000E7_Z05AkjP0505AkjP8000000P1DNnX01`000000E7_V05AkiP1DNnH0000005AkiP3D
?AT0101DNnH2000000D0DgSO00<000000=@m6@3D?AT01P3D?AT20?ofkP0303eIZ`3D?AT0ooK^0080
ooK^0P0mFJ/00`3om^h0e3dI0?ofkP020?ofkPL0e3dI1P3om^h01@3D?AT0ooK^0?ofkP3om^h0e3dI
00D0ooK^1P3D?AT70?ofkPh0e3dI4`3om^h2000004`0ooK^0@3oool00440ooK^00<000000?ofkP3o
m^h04P3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3o
m^h00`3om^h00`3D?AT0ooK^0?ofkP0?0?ofkP040=@m6@3om^h0ooK^0?ofkPH0e3dI203om^h00`3D
?AT0ooK^0=@m6@050=@m6@/0ooK^00<0e3dI0?ofkP3om^h00P00000201XYG`040000003D?AT08cUm
02<iO@8000000P0`Bid2000000<0<4^M0P00000303YI]P<0000000D0>UVf000000000000e3dI0000
0002045Tb0@0000000D0n4PO000000000000n4PO000000020?Q87`0703eIZ`00000000000?Q87`00
0000n4PO000000020?Q87`H0000000<0oD/P0000000000000P0000000`1<LMh00000000000060=@m
6@80000000D0CgKT0=@m6@000000CgKT00000002055ij0800000101ANNP2000000@0DGWX0`000004
05=jjP040=@m6@000000000000000080Dg[Z00<0000005AkjP1DNnX00P1DNnX2000000D0E7_Z0`00
000305AkiP040=@m6@1DNnH0E7_V05AkiPP0e3dI0`3om^h00`0mFJ/0ooK^03eIZ`040?ofkP80?EV[
00<0e3dI0?ofkP3om^h01`3D?AT>0?ofkP030=@m6@3om^h0ooK^00H0e3dI1P3om^h=0=@m6A`0ooK^
00<000000?ofkP3om^h0BP3om^h10?ooo`00@P3om^h00`000000ooK^0?ofkP0B0?ofkP030=@m6@3o
m^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP020?ofkP030=@m6@3o
m^h0ooK^00/0ooK^203D?AT00`3om^h000000?ofkP080?ofkPD0e3dI0P3om^h00`3D?AT0ooK^0?of
kP0;0?ofkP040=@m6@3om^h0ooK^0?ofkP<0000000@06RUO000000000000e3dI0`0S>Gd200000080
<4^M0P000002031;W@@000000`0jFKH300000003045Tb03D?AT000000080000000<0@FC800000000
00000P0000000`3hB1l00000000000020000000303eIZ`3hB1l0000000P0000000<0oD/P0000003m
Bb000P000000103mBb0000000000001<LMh30000000404mfi0000000000004mfi080000000D0CgKT
000000000000CgKT0=@m6@0204mfi08000000`1ANNP3000000H0DGWX00<0000005=jjP1CN^X00`1C
N^X00`000000e3dI05=jjP0405=jjP030000001DNnX0E7_Z008000001`1DNnX010000000E7_V05Ak
iP1DNnH60=@m6@030000001CN=l0DgSO0080DgSO00<0e3dI0?ofkP3om^h00`3om^h00`0mFJ/0ooK^
03eIZ`020?ofkPL0e3dI0P0mFJ/00`3om^h0e3dI0?ofkP0=0?ofkPL0e3dI0`3om^h>0=@m6B<0ooK^
0P00001;0?ofkP40oooo00130?ofkP030000003om^h0ooK^0140ooK^00<0e3dI0?ofkP3om^h04`3o
m^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h00P3o
m^h90=@m6@@0ooK^00<0e3dI0?ofkP3om^h00P3om^h010000000ooK^0?ofkP3om^h60=@m6@<0ooK^
00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^0080ooK^
1@0000001P3D?AT0000002<iO@0S>Gd00000031;W@8000000P0`Bid3000000<0>UVf0`00000203YI
]P80000000<0e3dI045Tb011I<P0100000000`11I<P00000000000060000000:0?e;800000000000
0?e;80000000oD/P0000003mBb0000000?e;8080000000D0oD/P000000000000000004aagP030000
000304aagP000000CgKT0080000000<0CgKT0000000000000P1?M^@01@000000e3dI0000001?M^@0
00000080DGWX0P000005055ij0<0000000@0DGWX0000001CN^X0Dg[Z0`00000205=jjP030=@m6@1C
N^X0Dg[Z00<0Dg[Z0P00000705AkjPH0e3dI0P1DNnH00`3D?AT0000005AkiP0205AkiP050000001C
N=l0DgSO0000003D?AT00`3om^h70=@m6@<0ooK^00@0?EV[0=@m6@3om^h0ooK^0`0mFJ/00`3D?AT0
ooK^0?ofkP040?ofkPP0e3dI0`3om^h>0=@m6BX0ooK^0P00001;0?ofkP40oooo00130?ofkP030000
003om^h0ooK^0140ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP0D0?ofkP040=@m
6@3om^h0ooK^0?ofkPD0e3dI3@3om^h20=@m6@80ooK^1@3D?AT90?ofkP030=@m6@3om^h0ooK^0080
ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP030?ofkP80000000@0?EV[0000003D
?AT08cUm0P000000100S>Gd00000031;W@0`Bid300000004031;W@0000000000000000@0>UVf1000
00001@11I<P0e3dI000000000000@FC800`000000P3mBb04000000030?e;80000000000000D00000
00@0C77N000000000000C77N100000000`1?M^@000000000000203eIZ`8000000P1?M^@00`3D?AT0
CgKT04mfi002000000@0DGWX0`000005055ij08000001@1CN^X00`3D?AT0Dg[Z0000000200000003
05=jjP000000E7_Z0080E7_Z1@3D?AT305AkjP040000001DNnH0E7_V05AkiP80000000L0e3dI05Ak
iP1DNnH0E7_V0000001CN=l0?EV[00D0e3dI0`3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0403eIZ`3o
m^h0e3dI0?ofkP80?EV[203D?AT40?ofkPd0e3dI<P3om^h2000004/0ooK^0@3oool004@0ooK^00<0
00000?ofkP3om^h04@3om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^01<0ooK^00D0
e3dI0?ofkP3om^h0ooK^0=@m6@0?0?ofkPH0e3dI00<000000?ofkP3om^h02P3om^h00`3D?AT0ooK^
0?ofkP040?ofkP030=@m6@3om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h00`3om^h30000000301XY
G`000000e3dI00808cUm0P000005031;W@<0000000<0>UVf0000000000000P00000303YI]P800000
00<0e3dI00000011I<P03`0000000`3mBb0000000000000>0000000504aagP00000000000000000m
FJ/00P00000304mfi080000000@0e3dI0000001?M^@000000P1ANNP3000000<0DGWX100000000`1A
NNP0000005=jjP0405=jjP80000000<0e3dI05=jjP1CN^X01P3D?AT00`1DNnX000000000000505Ak
jP040000001DNnH0000000000080E7_V00<0e3dI05AkiP1DNnH00P1DNnH010000000e3dI0?ofkP3D
?AT60?ofkP0303eIZ`3om^h0ooK^00<0ooK^203D?AT30?ofkPh0e3dI>@3om^h2000004/0ooK^0@3o
ool004D0ooK^00<000000?ofkP3om^h0403om^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0
ooK^01<0ooK^00D0e3dI0?ofkP3om^h0ooK^0=@m6@080?ofkPL0e3dI00@0ooK^0=@m6@3om^h0e3dI
0P3om^h00`000000ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h0
2@3om^h00`3D?AT0ooK^0?ofkP020?ofkP80e3dI00H0000003eIZ`0000006RUO0=@m6@00000302<i
O@8000001@0`Bid3000000<0>UVf1000000:0=@m6Ah000000P1?M^@4000000<0CgKT00<0e3dI04mf
i01?M^@00P000002055ij0@000001P1ANNP010000000Dg[Z0000000000060=@m6@<0Dg[Z00@00000
05AkjP0000000000201DNnX00`000000E7_V05AkiP0305AkiP070=@m6@1DNnH000000000000mFJ/0
ooK^0=@m6@060?ofkPL0e3dI00@0?EV[0?ofkP0mFJ/0ooK^3@3D?AU10?ofkP800000B`3om^h10?oo
o`00AP3om^h00`000000ooK^0?ofkP0?0?ofkP030=@m6@3om^h0ooK^01@0ooK^00<0e3dI0?ofkP3o
m^h04`3om^h0103D?AT0ooK^0=@m6@3om^h80=@m6@P0ooK^00H0e3dI0?ofkP3om^h0e3dI0?ofkP00
000<0?ofkP030=@m6@3om^h0ooK^00@0ooK^00<0e3dI0?ofkP3om^h01P3om^h80=@m6@80ooK^0P00
0000100J:El000000000003D?AT2000000808cUm10000004031;W@8000001P3D?AT2000000030=@m
6@000000@FC80080@FC88`0000000`1?M^@0000000000004000000040=@m6@1?M^@0CgKT04mfi0<0
00001P1ANNP80=@m6@@0Dg[Z00<0e3dI05=jjP1CN^X00P1CN^X2000000H0E7_Z0`0000000`1DNnX0
000005AkiP0405AkiP050=@m6@000000ooK^0?ofkP0mFJ/0203D?AT0100mFJ/0ooK^03eIZ`3om^h<
0=@m6DX0ooK^00<000000?ofkP3om^h0B@3om^h10?ooo`00A`3om^h00`000000ooK^0?ofkP0?0?of
kP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h0403om^h70=@m6A00ooK^00H0e3dI0?of
kP3om^h0e3dI0?ofkP00000<0?ofkP030=@m6@3om^h0ooK^00D0ooK^00<0e3dI0?ofkP3D?AT01@3D
?AT30?ofkP030=@m6@3om^h0ooK^00D0ooK^0P00000201XYG`030=@m6@0S>Gd08cUm00<000000`0`
Bid00`000000e3dI0=@m6@030=@m6@<0>UVf1@0000000`11I<P0e3dI0000000500000003045Tb000
0000000001h0000000<0CgKT00000000000010000000103D?AT0CgKT04mfi00000080=@m6@800000
0P1ANNP00`000000Dg[Z05=jjP0505=jjP060=@m6@00000000000000001CN^X000001@1DNnX20000
00@0E7_Z00@0000005AkiP1DNnH0E7_V203D?AT30?ofkPd0e3dI00H0ooK^03eIZ`3om^h0?EV[0?of
kP0mFJ];0?ofkP030000003om^h0ooK^04T0ooK^0@3oool004P0ooK^00<000000?ofkP3om^h03P3o
m^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^00T0ooK^1`3D?AT40?ofkP80e3dI4@3o
m^h01P3D?AT0ooK^0?ofkP3om^h0e3dI000000`0ooK^00@0e3dI0?ofkP3om^h0ooK^1P3D?AT90?of
kP030=@m6@3om^h0ooK^00H0ooK^00D0000003eIZ`0J:El06RUO0=@m6@0202<iO@H0e3dI0`0`Bid4
000000D0>UVf0P0000000`3D?AT000000000000200000080@FC88P00000304mfi0L0e3dI10000009
055ij0030000001CN^X0Dg[Z00@0000000<0Dg[Z0=@m6@1CN^X00`1CN^X00`000000E7_Z00000002
000000<0E7_Z1`3D?AT20?ofkPl0e3dI00<0?EV[0?ofkP3om^h00P3om^h01`0mFJ/0ooK^0?ofkP0m
FJ/0ooK^03eIZ`3om^h00P0mFJ]:0?ofkP800000BP3om^h10?ooo`00B03om^h00`000000ooK^0?of
kP0?0?ofkP030=@m6@3om^h0ooK^01<0ooK^00@0e3dI0?ofkP3om^h0ooK^1`3D?AT;0?ofkP80e3dI
4@3om^h01P3D?AT0ooK^0?ofkP3om^h0e3dI000000T0ooK^1`3D?AT50?ofkP030=@m6@3om^h0ooK^
00H0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`000000e3dI0=@m6@040=@m6@808cUm00<00000031;
W@0000000P000003031;W@030000000jFKH0>UVf00D0000000@0>UVf00000011I<P0e3dI0`11I<PQ
000000H0e3dI00D0000004mfi01?M^@0CgKT0=@m6@0204mfi0030000001ANNP0DGWX00@0DGWX2@00
000505=jjP030=@m6@1CN^X0Dg[Z0080Dg[Z203D?AT205AkjPh0e3dI103om^h00`0mFJ/0ooK^0?of
kP020?ofkP0403eIZ`3om^h0ooK^03eIZ`@0ooK^0P0mFJ/20?ofkP0303eIZ`3om^h0ooK^04P0ooK^
0P00001:0?ofkP40oooo00190?ofkP030000003om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h0403o
m^h70=@m6A<0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?ofkP030?ofkP040=@m6@3o
m^h0ooK^0?ofkPH0e3dI0`3om^h00`3D?AT0ooK^0?ofkP060?ofkP030=@m6@3om^h0ooK^00H0ooK^
00@0e3dI0?ofkP3om^h0ooK^1`3D?AT01P0000006RUO0000000J:El0e3dI02<iO@80000000<08cUm
0000000`Bid00P0`Bid300000003031;W@000000>UVf00D0>UVf0`0000000`3D?AT000000000000/
000000030=@m6@000000000000L000001P1ANNP00`000000Dg[Z05=jjP0205=jjP8000001P3D?AT0
0`1CN^X0000005AkjP0505AkjP0303eIZ`3D?AT0e3dI00H0e3dI00<0?EV[0?ofkP3om^h00`3om^h0
0`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^0080ooK^00@0?EV[0?ofkP3om^h0?EV[103o
m^h203eIZ`80ooK^00<0?EV[0?ofkP3om^h0B03om^h2000004X0ooK^0@3oool004X0ooK^00<00000
0?ofkP3om^h03@3om^h00`3D?AT0ooK^0?ofkP090?ofkPL0e3dI103om^h00`3D?AT0ooK^0?ofkP0C
0?ofkP030=@m6@3om^h0ooK^00h0ooK^00@0e3dI0?ofkP3om^h0ooK^1P3D?AT90?ofkP030=@m6@3o
m^h0ooK^00L0ooK^00@0e3dI0?ofkP3om^h0ooK^203D?AT70?ofkP80000000<06RUO0000003D?AT0
0`0S>Gd2000000H0<4^M300000000`3D?AT0000000000002000000<0@FC8100000000`17K=@00000
0000000<000000030?m<80000000000000d00000101?M^@20=@m6@030000001ANNP0DGWX00D0DGWX
1P0000060=@m6@<0Dg[Z0P3D?AT205=jjP030000001DNnX0e3dI00H0e3dI1P3om^h00`0mFJ/0ooK^
0?ofkP040?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/01P3om^h00`0mFJ/0ooK^03eIZ`050?ofkP04
03eIZ`3om^h0ooK^03eIZdX0ooK^0P00001:0?ofkP40oooo001;0?ofkP030000003om^h0ooK^00d0
ooK^00@0e3dI0?ofkP3om^h0ooK^1`3D?AT;0?ofkP030=@m6@3om^h0ooK^0180ooK^00<0e3dI0?of
kP3D?AT03@3om^h60=@m6@80ooK^00<000000=@m6@3om^h02@3om^h00`3D?AT0ooK^0?ofkP050?of
kPL0e3dI103om^h00`3D?AT0ooK^0?ofkP090?ofkP80000000@0?EV[01XYG`3D?AT000000`0S>Gd5
000000<0<4^M00<0000003YI]P0jFKH01P0jFKH010000000e3dI045Tb011I<P500000080@FC82@00
00000`3oC200000000000002000000030?m<8000000000000080000000<0od`P0000000000002000
000304mfi0h000001P3D?AT00`1ANNP0000005=jjP0605=jjPH0e3dI00<000000?ofkP3om^h00`3o
m^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00@0ooK^00D0?EV[0?ofkP3om^h0ooK^
03eIZ`060?ofkP0303eIZ`3om^h0?EV[00D0ooK^00@0?EV[0?ofkP3om^h0?EV[B`3om^h00`000000
ooK^0?ofkP180?ofkP40oooo001<0?ofkP030000003om^h0ooK^00`0ooK^103D?ATC0?ofkP030=@m
6@3om^h0ooK^0140ooK^00<0e3dI0?ofkP3D?AT01`3om^h60=@m6@80ooK^00<0e3dI0?ofkP3om^h0
0`3om^h00`000000e3dI0?ofkP090?ofkPP0e3dI103om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m
6@3om^h0ooK^00X0ooK^0P0000000`0J:El0e3dI02<iO@02000000808cUm00@00000031;W@0`Bid0
<4^M3P0000000`3D?AT00000045Tb002045Tb0D0e3dI2@0000000`3oC20000000?m<800800000003
0?M;800mFJ/0000000`00000101?M^@00`000000e3dI055ij0040=@m6@L0DGWX00<0000005=jjP1C
N^X00P1CN^X30=@m6@80?EV[00<000000?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP020?ofkP03
03eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP0mFJ/01`3om^h203eIZ`H0ooK^00@0?EV[0?ofkP3o
m^h0?EV[B`3om^h00`000000ooK^0?ofkP180?ofkP40oooo001=0?ofkP030000003om^h0ooK^00`0
ooK^00<0e3dI0?ofkP3om^h04`3om^h00`3D?AT0ooK^0?ofkP0A0?ofkP030=@m6@3om^h0ooK^00L0
e3dI203om^h00`3D?AT0ooK^0?ofkP030?ofkP030000003om^h0e3dI00<0ooK^1`3D?AT;0?ofkP03
0=@m6@3om^h0ooK^00<0ooK^00<0e3dI0?ofkP3om^h0203om^h30=@m6@@0000000<0e3dI02<iO@0S
>Gd00`000007031;W@030000000jFKH0>UVf00@0>UVf203D?AT010000000@FC8000000000002045T
b080000000<0od`P0000003oC2001`0000001@3gBb0000000?M;80000000md/P00@0000000<0?EV[
0?M;803gBb001P00000403eIZaL0000000<0?EV[0?ofkP0mFJ/03@3om^h01@0mFJ/0ooK^0?ofkP3o
m^h0?EV[00T0ooK^00<0?EV[0?ofkP0mFJ/0203om^h00`0mFJ/0ooK^0?ofkP030?ofkP0503eIZ`3o
m^h0?EV[0?ofkP0mFJ/0B`3om^h2000004T0ooK^0@3oool004d0ooK^00<000000?ofkP3om^h0303o
m^h00`3D?AT0ooK^0?ofkP0D0?ofkP030=@m6@3om^h0ooK^0100ooK^103D?AT=0?ofkP030=@m6@3o
m^h0ooK^00<0ooK^1`3D?AT60?ofkP030=@m6@3om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h00P3o
m^h0103D?AT0ooK^0?ofkP3om^h70=@m6@@0ooK^0P0000000`0J:El000000=@m6@0302<iO@D00000
0`0`Bid70=@m6@@0000000@0e3dI045Tb011I<P0@FC80P000002045Tb0L0000000T0?EV[0000003g
Bb00md/P0000003gBb0000000?M;800000000P3gBb02000000040?M;80000000000003eIZ`800000
00@0e3dI0?M;803gBb00e3dI0P0mFJ/90000000303eIZ`000000000000T000001P3om^h203eIZ`h0
ooK^00@0?EV[0?ofkP3om^h0?EV[2`3om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^
00<0ooK^00D0?EV[0?ofkP0mFJ/0ooK^03eIZ`1;0?ofkP800000B@3om^h10?ooo`00CP3om^h00`00
0000ooK^0?ofkP0<0?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h0403om^h01@3D
?AT0ooK^0?ofkP3om^h0e3dI00/0ooK^1`3D?AT01@000000ooK^0?ofkP3om^h0e3dI00P0ooK^00<0
e3dI0?ofkP3om^h02`3om^h80=@m6@`0ooK^00D0000003eIZ`0J:El0e3dI0000000302<iO@L0e3dI
1P00000403YI]P0300000011I<P0e3dI008000000P11I<P6000000050?M;80000000000003eIZ`00
00000P3gBb001P000000md/P0?M;80000000md/P000000<0md/P00D000000?M;803gBb00000003eI
Z`02000000<0?EV[00<000000=]47@3KA1d00`3KA1d60000000303eIZ`000000000000h0ooK^00<0
?EV[0?ofkP3om^h03P3om^h203eIZ``0ooK^00<0?EV[0?ofkP3om^h01P3om^h203eIZ`D0ooK^00D0
?EV[0?ofkP0mFJ/0ooK^03eIZ`1;0?ofkP800000B@3om^h10?ooo`00C`3om^h00`000000ooK^0?of
kP0;0?ofkP030=@m6@3om^h0ooK^01@0ooK^00<0e3dI0?ofkP3om^h03P3om^h00`3D?AT0ooK^0?of
kP020?ofkP030=@m6@3om^h0ooK^0080ooK^1`3D?AT00`3om^h0e3dI0?ofkP040?ofkP050000003o
m^h0ooK^0?ofkP3D?AT01`3om^h00`3D?AT0ooK^0?ofkP070?ofkPL0e3dI0P3om^h00`3D?AT0ooK^
0?ofkP0>0?ofkPL0e3dI0P000006031;W@030000000jFKH0>UVf00<0>UVf1P0000002@3D?AT0@FC8
000000000000@FC80000003gBb0000000?M;8003000000030?M;80000000?EV[0080md/P00<00000
0?M;800000002000000503eIZ``000000`3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP<0?EV[403om^h0
0`0mFJ/0ooK^0?ofkP0:0?ofkP80?EV[203om^h00`0mFJ/0ooK^03eIZ`030?ofkP0603eIZ`3om^h0
ooK^03eIZ`3om^h0?EV[B`3om^h2000004T0ooK^0@3oool00500ooK^00<000000?ofkP3om^h02`3o
m^h00`3D?AT0ooK^0?ofkP0C0?ofkP030=@m6@3om^h0ooK^00h0ooK^00<0e3dI0?ofkP3om^h01`3D
?AT80?ofkP030=@m6@3om^h0ooK^00<0ooK^00<000000?ofkP3om^h00P3om^h00`3D?AT0ooK^0?of
kP040?ofkP040=@m6@3om^h0ooK^0?ofkPH0e3dI1P3om^h00`3D?AT0ooK^0=@m6@0:0?ofkPL0e3dI
10000000103D?AT08cUm02<iO@0S>Gd=000000@0>UVf00D00000045Tb00000000000045Tb0020000
00040?M;80000000md/P00000080md/P0`0000000`0mFJ/0000000000002000000030=]47@0mFJ/0
?EV[00H0?EV[00@0fd@M000000000000?EV[1`00000:0?ofkP0303eIZ`3om^h0ooK^00T0ooK^0P0m
FJ/30?ofkP0303eIZ`3om^h0ooK^00`0ooK^0P0mFJ/;0?ofkP0403eIZ`3om^h0ooK^03eIZ`H0ooK^
00@0?EV[0?ofkP3om^h0?EV[0`3om^h0100mFJ/0ooK^0?ofkP3om^h203eIZd`0ooK^00<000000?of
kP3om^h0A`3om^h10?ooo`00D@3om^h00`000000ooK^0?ofkP0:0?ofkP030=@m6@3om^h0ooK^01@0
ooK^00<0e3dI0?ofkP3om^h02@3om^h70=@m6@@0ooK^00<0e3dI0?ofkP3om^h01`3om^h00`3D?AT0
ooK^0?ofkP040?ofkP030000003om^h0ooK^00<0ooK^00<0e3dI0?ofkP3D?AT01`3D?AT=0?ofkP80
e3dI0`3om^h70=@m6@L0ooK^00<0e3dI0000000J:El00P0000000`3D?AT08cUm02<iO@0202<iO@03
0000000`Bid0<4^M00@0<4^M00<0000003YI]P0jFKH01@0jFKH200000005045Tb000000000000?M;
800000001@0mFJ/2000000P0?EV[2`0000000`0mFJ/000000?ofkP0?0?ofkP0303eIZ`3om^h0ooK^
00L0ooK^0P0mFJ/50?ofkP0303eIZ`3om^h0ooK^00/0ooK^00@0?EV[0?ofkP3om^h0?EV[2@3om^h0
1@0mFJ/0ooK^0?ofkP3om^h0?EV[00H0ooK^00@0?EV[0?ofkP3om^h0?EV[0`3om^h0100mFJ/0ooK^
0?ofkP3om^h203eIZd`0ooK^00<000000?ofkP3om^h0A`3om^h10?ooo`00DP3om^h00`000000ooK^
0?ofkP0:0?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h00P3om^h70=@m6@<0ooK^
00<0e3dI0?ofkP3om^h01@3om^h00`3D?AT0ooK^0?ofkP070?ofkP030=@m6@3om^h0ooK^0080ooK^
2P3D?AT30?ofkP030=@m6@3om^h0ooK^00d0ooK^1`3D?AT=0?ofkP040=@m6@3om^h0e3dI0=@m6@80
6RUO00<000000=@m6@0000000P0S>Gd00`000000<4^M031;W@04031;W@040000000jFKH0>UVf03YI
]PD0e3dI200000000`3KA1d00000000000020=]47@040000003KA1d0fd@M03eIZ`@00000303om^h0
0`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00@0ooK^0P0mFJ/80?ofkP0303eIZ`3om^h0
ooK^00P0ooK^0P0mFJ/30?ofkP0303eIZ`3om^h0ooK^00L0ooK^00D0?EV[0?ofkP3om^h0ooK^03eI
Z`050?ofkP0503eIZ`3om^h0ooK^0?ofkP0mFJ/00`3om^h0100mFJ/0ooK^0?ofkP3om^h203eIZd`0
ooK^0P0000180?ofkP40oooo001B0?ofkP030000003om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h0
4@3om^h70=@m6@X0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D?AT0ooK^0?ofkP030?ofkPP0e3dI
0P3om^h00`000000ooK^0?ofkP040?ofkP050=@m6@3om^h0ooK^0?ofkP3D?AT0203om^h70=@m6@80
ooK^00<0e3dI0?ofkP3D?AT02`3om^h60=@m6@070?ofkP0000006RUO01XYG`0000008cUm0=@m6@05
000000P0e3dI0`0jFKH200000080fd@M00<0?EV[000000000000100000000`3D?AT0000000000004
000000030?ofkP0mFJ/0ooK^00h0ooK^00<0?EV[0?ofkP3om^h03`3om^h00`0mFJ/0ooK^0?ofkP02
0?ofkP80?EV[2P3om^h00`0mFJ/0ooK^0?ofkP070?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[
0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[
0?ofkP3om^h00`3om^h00`0mFJ/0ooK^03eIZ`050?ofkP0303eIZ`3om^h0ooK^04X0ooK^0P000018
0?ofkP40oooo001C0?ofkP030000003om^h0ooK^00X0ooK^00<0e3dI0?ofkP3om^h02@3om^h70=@m
6@@0ooK^00<0e3dI0?ofkP3om^h02P3om^h00`3D?AT0ooK^0?ofkP060?ofkPH0e3dI0P3om^h00`3D
?AT0ooK^0?ofkP050?ofkP030000003om^h0ooK^00D0ooK^00<0e3dI0?ofkP3D?AT00P3om^h70=@m
6@P0ooK^00@0e3dI0?ofkP3om^h0ooK^2`3D?AT30?ofkP030=@m6@3om^h0ooK^0080ooK^00<00000
03eIZ`3D?AT01`3D?AT3031;W@030=@m6@0`Bid000000080>UVf0`0000020=]47@80000000<0?EV[
000000000000100000080?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h03`3om^h0
100mFJ/0ooK^03eIZ`0mFJ/=0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h01@3o
m^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00@0ooK^00D0?EV[0?ofkP3om^h0ooK^
03eIZ`050?ofkP0303eIZ`3om^h0?EV[00D0ooK^00<0?EV[0?ofkP3om^h0BP3om^h2000004P0ooK^
0@3oool005@0ooK^00<000000?ofkP3om^h02@3om^h00`3D?AT0ooK^0?ofkP020?ofkPL0e3dI2`3o
m^h00`3D?AT0ooK^0?ofkP090?ofkP040=@m6@3om^h0ooK^0?ofkPH0e3dI0P3om^h00`3D?AT0ooK^
0?ofkP030?ofkP030=@m6@3om^h0ooK^00D0ooK^00<000000?ofkP3om^h00`3om^h70=@m6@`0ooK^
2@3D?AT;0?ofkPP0e3dI00<0?EV[0000000S>Gd00`3D?AT0100S>Gd00000031;W@0`Bid20=@m6@03
031;W@000000000000T0000000<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP03
03eIZ`3om^h0ooK^00h0ooK^0`0mFJ/?0?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3o
m^h01P3om^h00`0mFJ/0ooK^0?ofkP030?ofkP0303eIZ`3om^h0ooK^00D0ooK^00@0?EV[0?ofkP3o
m^h0?EV[1P3om^h00`0mFJ/0ooK^03eIZ`050?ofkP0303eIZ`3om^h0ooK^04X0ooK^0P0000180?of
kP40oooo001E0?ofkP030000003om^h0ooK^00T0ooK^103D?ATC0?ofkP030=@m6@3om^h0ooK^00P0
ooK^103D?AT80?ofkP030=@m6@3om^h0ooK^0080ooK^00<0e3dI0?ofkP3om^h01@3om^h70=@m6@<0
ooK^0P3D?AT80?ofkPH0e3dI0P3om^h00`3D?AT0ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^0080
ooK^1`3D?AT50?ofkP`0e3dI0P0mFJ/00`000000?EV[00000003000000H0ooK^00<0?EV[0?ofkP3o
m^h0303om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00X0ooK^0`0mFJ/00`3om^h0
?EV[0?ofkP0@0?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h0203om^h01@0mFJ/0
ooK^0?ofkP3om^h0?EV[00P0ooK^00@0?EV[0?ofkP3om^h0?EV[1`3om^h00`0mFJ/0ooK^0?ofkP04
0?ofkP0303eIZ`3om^h0ooK^04/0ooK^00<000000?ofkP3om^h0AP3om^h10?ooo`00EP3om^h00`00
0000ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^01@0ooK^00<0e3dI0?ofkP3om^h01P3om^h00`3D
?AT0ooK^0?ofkP0;0?ofkP040=@m6@3om^h0ooK^0?ofkPP0e3dI00<0ooK^0000003om^h01`3om^h0
0`3D?AT0ooK^0=@m6@070=@m6@L0ooK^00<0e3dI0?ofkP3om^h00`3om^h70=@m6@80ooK^403D?AT0
0`3om^h0?EV[0000000500000080?EV[2`3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0
ooK^00d0ooK^00<0?EV[0?ofkP3om^h01`3om^h303eIZ`D0ooK^00<0?EV[0?ofkP3om^h03P3om^h0
0`0mFJ/0ooK^0?ofkP0203eIZ`/0ooK^00@0?EV[0?ofkP3om^h0?EV[2@3om^h00`0mFJ/0ooK^03eI
Z`080?ofkP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h0C03om^h00`000000ooK^0?of
kP160?ofkP40oooo001G0?ofkP030000003om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h0503om^h0
0`3D?AT0ooK^0?ofkP050?ofkP030=@m6@3om^h0ooK^00T0ooK^1`3D?AT70?ofkP030000003om^h0
ooK^00<0ooK^203D?AT<0?ofkPL0e3dI0`3om^h60=@m6@030?ofkP3D?AT0e3dI00L0e3dI0P3om^h7
03eIZ`80ooK^0P0mFJ/30?ofkP80?EV[2@3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0
ooK^00d0ooK^00<0?EV[0?ofkP3om^h00`3om^h303eIZ`P0ooK^00<0?EV[0?ofkP3om^h03`3om^h2
03eIZ`d0ooK^00@0?EV[0?ofkP3om^h0?EV[2P3om^h203eIZ`L0ooK^0P0mFJ/50?ofkP0303eIZ`3o
m^h0ooK^04`0ooK^00<000000?ofkP3om^h0AP3om^h10?ooo`00E`3om^h00`000000ooK^0?ofkP0:
0?ofkP030=@m6@3om^h0ooK^01<0ooK^00<0e3dI0?ofkP3om^h0103om^h00`3D?AT0ooK^0?ofkP03
0?ofkPL0e3dI103om^h20=@m6@P0ooK^1P3D?AT20?ofkP030=@m6@3om^h0ooK^00<0ooK^00<0e3dI
0?ofkP3om^h00P3om^h80=@m6@80ooK^1`3D?AT20?ofkPL0e3dI2P3om^h203eIZ`040?ofkP0mFJ/0
?EV[03eIZ`80ooK^0P0mFJ/40?ofkPD0?EV[1P3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3o
m^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h00`0mFJ/<0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0
?EV[0?ofkP3om^h03@3om^h203eIZ`/0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^03eI
Z`040?ofkP0303eIZ`3om^h0ooK^04`0ooK^0P0000170?ofkP40oooo001H0?ofkP030000003om^h0
ooK^00T0ooK^00<0e3dI0?ofkP3om^h0503om^h00`3D?AT0ooK^0?ofkP020?ofkPL0e3dI2`3om^h2
0=@m6@80ooK^1P3D?AT00`000000ooK^0?ofkP040?ofkP030=@m6@3om^h0ooK^0080ooK^1`3D?AT3
0?ofkPL0e3dI0P3om^h70=@m6A80ooK^0P0mFJ/0103om^h0?EV[03eIZ`0mFJ/20?ofkP0303eIZ`3o
m^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h00P3om^h303eIZ`@0ooK^00<0?EV[0?ofkP3om^h0303o
m^h00`0mFJ/0ooK^0?ofkP0:0?ofkPD0?EV[3`3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP<0?EV[3`3o
m^h00`0mFJ/0ooK^0?ofkP090?ofkP80?EV[1`3om^h0100mFJ/0ooK^0?ofkP0mFJ/40?ofkP0303eI
Z`3om^h0ooK^04`0ooK^0P0000170?ofkP40oooo001I0?ofkP030000003om^h0ooK^00T0ooK^00<0
e3dI0?ofkP3om^h04@3om^h80=@m6@h0ooK^1`3D?AT60?ofkP030000003om^h0ooK^00<0ooK^1P3D
?AT40?ofkPl0e3dI6@3om^h203eIZ`040?ofkP0mFJ/0?EV[03eIZ`80ooK^00<0?EV[0?ofkP3om^h0
0`3om^h00`0mFJ/0ooK^0?ofkP040?ofkPD0?EV[3P3om^h00`0mFJ/0ooK^0?ofkP020?ofkPP0?EV[
0`3om^h00`0mFJ/0ooK^0?ofkP0?0?ofkP0303eIZ`3om^h0ooK^00T0ooK^0P0mFJ/30?ofkP0303eI
Z`3om^h0ooK^00/0ooK^0P0mFJ/:0?ofkP0403eIZ`3om^h0ooK^03eIZ`H0ooK^00D0?EV[0?ofkP3o
m^h0ooK^03eIZ`020?ofkP0303eIZ`3om^h0ooK^04d0ooK^0P0000170?ofkP40oooo001J0?ofkP03
0000003om^h0ooK^00T0ooK^00<0e3dI0?ofkP3om^h02P3om^h60=@m6@@0ooK^00@0e3dI0?ofkP3o
m^h0e3dI203om^h60=@m6@80ooK^00<0e3dI0?ofkP3om^h00P3om^h00`3D?AT0ooK^0?ofkP020?of
kPP0e3dI0P3om^h70=@m6@030?ofkP3D?AT0e3dI00D0e3dI8@3om^h203eIZ`060?ofkP0mFJ/0ooK^
03eIZ`3om^h0?EV[1@3om^h00`0mFJ/0ooK^0?ofkP080?ofkQ@0?EV[303om^h00`0mFJ/0ooK^0?of
kP0>0?ofkP0303eIZ`3om^h0ooK^00L0ooK^0P0mFJ/50?ofkP0303eIZ`3om^h0ooK^00T0ooK^0P0m
FJ/20?ofkP0303eIZ`3om^h0ooK^00L0ooK^00@0?EV[0?ofkP3om^h0?EV[1@3om^h00`0mFJ/0ooK^
0?ofkP020?ofkP0403eIZ`3om^h0ooK^03eIZe00ooK^00<000000?ofkP3om^h0A@3om^h10?ooo`00
F`3om^h00`000000ooK^0?ofkP090?ofkP030=@m6@3om^h0ooK^0080ooK^1`3D?AT;0?ofkP80e3dI
0`3om^h60=@m6@L0ooK^00@0e3dI0?ofkP3om^h0ooK^1`3D?AT00`3om^h000000?ofkP070=@m6@80
ooK^1P3D?ATX0?ofkP80?EV[00@0ooK^03eIZ`3om^h0ooK^0P0mFJ/60?ofkP0303eIZ`3om^h0ooK^
00P0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^
00l0ooK^00<0?EV[0?ofkP3om^h0103om^h203eIZ`P0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0m
FJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0m
FJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^0080ooK^00@0?EV[0?ofkP3om^h0?EV[D03om^h0
0`000000ooK^0?ofkP150?ofkP40oooo001L0?ofkP030000003om^h0ooK^00T0ooK^103D?ATC0?of
kP@0e3dI2P3om^h70=@m6@@0ooK^3`3D?AT_0?ofkP80?EV[00<0ooK^03eIZ`3om^h0100mFJ/50?of
kP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0=0?of
kP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h00P3om^h203eIZ`X0ooK^00<0?EV[0?of
kP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?of
kP3om^h00`3om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00H0ooK^00<0?EV[0?ofkP0mFJ/0D03om^h0
0`000000ooK^0?ofkP150?ofkP40oooo001L0?ofkP030000003om^h0ooK^00X0ooK^00<0e3dI0?of
kP3om^h04P3om^h0103D?AT0ooK^0?ofkP3D?AT40?ofkPL0e3dI00@0ooK^0=@m6@3om^h0ooK^3`3D
?ATg0?ofkP<0?EV[0P3om^h00`0mFJ/0ooK^0?ofkP0203eIZ`<0ooK^00<0?EV[0?ofkP3om^h0203o
m^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h03`3o
m^h0100mFJ/0ooK^03eIZ`0mFJ/<0?ofkP0303eIZ`3om^h0ooK^00@0ooK^0P0mFJ/70?ofkP0303eI
Z`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h0103om^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[00H0
ooK^0P0mFJ]A0?ofkP800000AP3om^h10?ooo`00G@3om^h00`000000ooK^0?ofkP0:0?ofkP030=@m
6@3om^h0ooK^00l0ooK^0P3D?AT00`3om^h0e3dI0=@m6@050=@m6@<0ooK^3`3D?AT40?ofkP030000
003om^h0ooK^03P0ooK^100mFJ/00`3om^h0?EV[0?ofkP030?ofkP80?EV[0P3om^h00`0mFJ/0ooK^
0?ofkP080?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^
0?ofkP0=0?ofkP<0?EV[3`3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00L0ooK^
00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0?EV[00P0ooK^
00<0?EV[0?ofkP3om^h0C`3om^h2000004H0ooK^0@3oool005h0ooK^00<000000?ofkP3om^h02P3o
m^h20=@m6@`0ooK^5@3D?AT>0?ofkP030000003om^h0ooK^03T0ooK^0`0mFJ/20?ofkP0303eIZ`3o
m^h0ooK^00<0ooK^0`0mFJ/:0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h03@3o
m^h00`0mFJ/0ooK^0?ofkP0:0?ofkP<0?EV[00<0ooK^03eIZ`3om^h03`3om^h01@0mFJ/0ooK^0?of
kP3om^h0?EV[00/0ooK^00@0?EV[0?ofkP3om^h0?EV[2@3om^h00`0mFJ/0ooK^03eIZ`080?ofkP03
03eIZ`3om^h0ooK^04l0ooK^0P0000160?ofkP40oooo001O0?ofkP030000003om^h0ooK^00/0ooK^
00<0e3dI0?ofkP3om^h00P3om^hC0=@m6AL0ooK^00<000000?ofkP3om^h0>@3om^h703eIZ`H0ooK^
0`0mFJ/90?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^
0?ofkP060?ofkP<0?EV[1@3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP<0?EV[303om^h0100mFJ/0ooK^
0?ofkP0mFJ/:0?ofkP0303eIZ`3om^h0ooK^00H0ooK^00<0?EV[0?ofkP3om^h0D@3om^h00`000000
ooK^0?ofkP140?ofkP40oooo001P0?ofkP030000003om^h0ooK^00/0ooK^103D?AT50?ofkPP0e3dI
7@3om^h00`000000ooK^0?ofkP0j0?ofkP<0?EV[00<0ooK^03eIZ`0mFJ/01`3om^h00`0mFJ/0ooK^
03eIZ`0203eIZ`H0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eI
Z`3om^h0ooK^00<0ooK^0`0mFJ/80?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h0
3@3om^h203eIZ`/0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP1A0?ofkP030000
003om^h0ooK^04@0ooK^0@3oool00640ooK^00<000000?ofkP3om^h03P3om^h70=@m6B80ooK^00<0
00000?ofkP3om^h0>`3om^h203eIZ`030?ofkP0mFJ/0?EV[0080?EV[1`3om^h0100mFJ/0ooK^0?of
kP3om^h403eIZ`<0ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eI
Z`3om^h0?EV[0080?EV[303om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP<0?EV[3`3om^h00`0mFJ/0ooK^
0?ofkP090?ofkP80?EV[1`3om^h00`0mFJ/0ooK^0?ofkP1B0?ofkP030000003om^h0ooK^04@0ooK^
0@3oool00640ooK^00<000000?ofkP3om^h0=`3om^h00`000000ooK^0?ofkP0l0?ofkP0603eIZ`3o
m^h0?EV[03eIZ`3om^h0?EV[1`3om^h00`0mFJ/0ooK^0?ofkP050?ofkP@0?EV[3P3om^h00`0mFJ/0
ooK^0?ofkP0:0?ofkPD0?EV[3`3om^h00`0mFJ/0ooK^0?ofkP090?ofkP80?EV[0`3om^h00`0mFJ/0
ooK^0?ofkP0;0?ofkP80?EV[2P3om^h0100mFJ/0ooK^0?ofkP0mFJ/50?ofkP0303eIZ`3om^h0ooK^
05<0ooK^00<000000?ofkP3om^h0A03om^h10?ooo`00HP3om^h00`000000ooK^0?ofkP0f0?ofkP03
0000003om^h0ooK^03`0ooK^0P0mFJ/01@3om^h0?EV[0?ofkP3om^h0?EV[00L0ooK^00<0?EV[0?of
kP3om^h01`3om^h903eIZ`L0ooK^00@0?EV[0?ofkP3om^h0ooK^200mFJ/30?ofkP0303eIZ`3om^h0
ooK^00l0ooK^00<0?EV[0?ofkP3om^h01P3om^h203eIZ`D0ooK^00<0?EV[0?ofkP3om^h02@3om^h2
03eIZ`80ooK^00<0?EV[0?ofkP3om^h01`3om^h0100mFJ/0ooK^0?ofkP0mFJ/50?ofkP0303eIZ`3o
m^h0ooK^05<0ooK^0P0000150?ofkP40oooo001S0?ofkP030000003om^h0ooK^03D0ooK^00<00000
0?ofkP3om^h0?@3om^h00`0mFJ/0ooK^03eIZ`030?ofkP80?EV[1@3om^h00`0mFJ/0ooK^0?ofkP09
0?ofkP0303eIZ`3om^h0ooK^00@0ooK^2`0mFJ/<0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[
0?ofkP3om^h0103om^h203eIZ`P0ooK^00<0?EV[0?ofkP3om^h01`3om^h00`0mFJ/0ooK^0?ofkP02
0?ofkP0303eIZ`3om^h0ooK^00H0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`040?ofkP0303eIZ`3o
m^h0ooK^05@0ooK^0P0000150?ofkP40oooo001T0?ofkP030000003om^h0ooK^03@0ooK^00<00000
0?ofkP3om^h0?P3om^h00`0mFJ/0ooK^03eIZ`020?ofkP0303eIZ`3om^h0?EV[00D0ooK^00<0?EV[
0?ofkP3om^h0203om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[
0?ofkP3om^h03`3om^h0100mFJ/0ooK^0?ofkP3om^h203eIZ`X0ooK^00<0?EV[0?ofkP3om^h01P3o
m^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h00`3o
m^h01@0mFJ/0ooK^0?ofkP3om^h0?EV[05L0ooK^00<000000?ofkP3om^h0@`3om^h10?ooo`00I@3o
m^h00`000000ooK^0?ofkP0c0?ofkP030000003om^h0ooK^03h0ooK^0`0mFJ/30?ofkP0403eIZ`3o
m^h0?EV[03eIZ`<0ooK^00<0?EV[0?ofkP3om^h02@3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eI
Z`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h03P3om^h0100mFJ/0ooK^03eIZ`0mFJ/=0?ofkP03
03eIZ`3om^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^0?ofkP030?ofkP03
03eIZ`3om^h0ooK^00@0ooK^00@0?EV[0?ofkP3om^h0?EV[F03om^h00`000000ooK^0?ofkP130?of
kP40oooo001V0?ofkP030000003om^h0ooK^0380ooK^00<000000?ofkP3om^h0?`3om^h303eIZ`80
ooK^00@0?EV[0?ofkP3om^h0ooK^0P0mFJ/20?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?of
kP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0ooK^00h0ooK^0P0mFJ/?0?of
kP0303eIZ`3om^h0ooK^00<0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP020?of
kP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP0mFJ/0F@3om^h00`000000ooK^0?ofkP130?of
kP40oooo001V0?ofkP030000003om^h0ooK^0380ooK^00<000000?ofkP3om^h0@03om^h303eIZ`80
ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^03eIZ`0;0?ofkP0303eIZ`3om^h0ooK^00/0
ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP<0?EV[00<0ooK^03eIZ`3o
m^h03`3om^h00`0mFJ/0ooK^0?ofkP0203eIZ`X0ooK^00@0?EV[0?ofkP3om^h0?EV[2@3om^h203eI
ZeT0ooK^00<000000?ofkP3om^h0@`3om^h10?ooo`00I`3om^h00`000000ooK^0?ofkP0a0?ofkP03
0000003om^h0ooK^0400ooK^0P0mFJ/01@3om^h0?EV[0?ofkP3om^h0?EV[00@0ooK^0`0mFJ/;0?of
kP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP070?of
kP<0?EV[1@3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0?EV[00`0ooK^00@0?EV[0?of
kP3om^h0?EV[2@3om^h00`0mFJ/0ooK^0?ofkP1H0?ofkP800000A03om^h10?ooo`00J03om^h00`00
0000ooK^0?ofkP0`0?ofkP030000003om^h0ooK^0440ooK^0P0mFJ/0103om^h0?EV[0?ofkP0mFJ/6
0?ofkP<0?EV[2@3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[
0?ofkP3om^h00`3om^h303eIZ`P0ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0<
0?ofkP80?EV[2@3om^h00`0mFJ/0ooK^0?ofkP1I0?ofkP800000A03om^h10?ooo`00J@3om^h00`00
0000ooK^0?ofkP0_0?ofkP030000003om^h0ooK^0480ooK^00<0?EV[0?ofkP3om^h00`0mFJ/60?of
kP0303eIZ`3om^h0?EV[00<0?EV[1P3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^
00d0ooK^00<0?EV[0?ofkP3om^h00`0mFJ/<0?ofkP0303eIZ`3om^h0ooK^00/0ooK^0`0mFJ/>0?of
kP0303eIZ`3om^h0ooK^00L0ooK^00<0?EV[0?ofkP3om^h0F`3om^h00`000000ooK^0?ofkP120?of
kP40oooo001Z0?ofkP030000003om^h0ooK^02h0ooK^00<000000?ofkP3om^h0@P3om^h203eIZ`<0
ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^0?ofkP030?ofkPD0?EV[00<0ooK^03eIZ`3o
m^h0303om^h00`0mFJ/0ooK^0?ofkP0:0?ofkPD0?EV[3`3om^h00`0mFJ/0ooK^0?ofkP090?ofkP80
?EV[0`3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP80?EV[2@3om^h00`0mFJ/0ooK^0?ofkP1K0?ofkP03
0000003om^h0ooK^0480ooK^0@3oool006/0ooK^00<000000?ofkP3om^h0;03om^h00`000000ooK^
0?ofkP140?ofkP0303eIZ`3om^h0ooK^0080ooK^00<0?EV[0?ofkP3om^h0103om^h00`0mFJ/0ooK^
0?ofkP070?ofkPT0?EV[1P3om^h00`0mFJ/0ooK^0?ofkP020?ofkPP0?EV[0`3om^h00`0mFJ/0ooK^
0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^00L0ooK^0P0mFJ/50?ofkP0303eIZ`3om^h0ooK^00P0ooK^
0P0mFJ/20?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h0G03om^h00`000000ooK^
0?ofkP120?ofkP40oooo001[0?ofkP030000003om^h0ooK^02`0ooK^00<000000?ofkP3om^h0A@3o
m^h00`0mFJ/0ooK^0?ofkP020?ofkP80?EV[1@3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3o
m^h0ooK^00@0ooK^2`0mFJ/<0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00<0?EV[0?ofkP3om^h0103o
m^h203eIZ`P0ooK^00<0?EV[0?ofkP3om^h01P3om^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3o
m^h0ooK^00@0ooK^00<0?EV[0?ofkP3om^h0G@3om^h00`000000ooK^0?ofkP120?ofkP40oooo001/
0?ofkP030000003om^h0ooK^02/0ooK^00<000000?ofkP3om^h0A@3om^h203eIZ`<0ooK^00@0?EV[
0?ofkP0mFJ/0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP090?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0
?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP0303eIZ`3om^h0ooK^0080ooK^0P0m
FJ/:0?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3om^h00`3om^h00`0mFJ/0ooK^0?of
kP030?ofkP0303eIZ`3om^h0ooK^05h0ooK^0P0000130?ofkP40oooo001]0?ofkP030000003om^h0
ooK^02X0ooK^00<000000?ofkP3om^h0AP3om^h203eIZ`<0ooK^00<0?EV[0?ofkP3om^h00P0mFJ/2
0?ofkP0303eIZ`3om^h0ooK^00P0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP0=
0?ofkP0303eIZ`3om^h0ooK^00h0ooK^00@0?EV[0?ofkP0mFJ/0?EV[303om^h00`0mFJ/0ooK^0?of
kP040?ofkP0303eIZ`3om^h0ooK^00D0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`1Q0?ofkP800000
@`3om^h10?ooo`00KP3om^h00`000000ooK^0?ofkP0Y0?ofkP030000003om^h0ooK^04H0ooK^0`0m
FJ/20?ofkP0303eIZ`3om^h0ooK^0080ooK^0P0mFJ/00`3om^h0?EV[0?ofkP090?ofkP0303eIZ`3o
m^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP<0?EV[3`3o
m^h00`0mFJ/0ooK^0?ofkP020?ofkP0303eIZ`3om^h0ooK^00H0ooK^00@0?EV[0?ofkP3om^h0?EV[
H`3om^h00`000000ooK^0?ofkP110?ofkP40oooo001_0?ofkP030000003om^h0ooK^02P0ooK^00<0
00000?ofkP3om^h0A`3om^h01P0mFJ/0ooK^03eIZ`0mFJ/0ooK^03eIZ`D0ooK^0P0mFJ/:0?ofkP03
03eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP090?ofkP<0
?EV[00<0ooK^03eIZ`3om^h03`3om^h00`0mFJ/0ooK^0?ofkP0203eIZ`T0ooK^00@0?EV[0?ofkP3o
m^h0?EV[H`3om^h00`000000ooK^0?ofkP110?ofkP40oooo001`0?ofkP030000003om^h0ooK^02L0
ooK^00<000000?ofkP3om^h0B03om^h00`0mFJ/0ooK^0?ofkP0203eIZ`L0ooK^0P0mFJ/90?ofkP03
03eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP070?ofkP80
?EV[1@3om^h00`0mFJ/0ooK^0?ofkP0>0?ofkP80?EV[303om^h203eIZf@0ooK^00<000000?ofkP3o
m^h0@@3om^h10?ooo`00L03om^h00`000000ooK^0?ofkP0W0?ofkP030000003om^h0ooK^04P0ooK^
00@0?EV[0?ofkP3om^h0ooK^0P0mFJ/60?ofkP0303eIZ`3om^h0?EV[0080?EV[1P3om^h00`0mFJ/0
ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h00`3om^h303eIZ`L0
ooK^00<0?EV[0?ofkP3om^h03P3om^h00`0mFJ/0ooK^0?ofkP0;0?ofkP0303eIZ`3om^h0ooK^06<0
ooK^00<000000?ofkP3om^h0@@3om^h10?ooo`00L@3om^h00`000000ooK^0?ofkP0V0?ofkP030000
003om^h0ooK^04T0ooK^00D0?EV[0?ofkP3om^h0ooK^03eIZ`070?ofkP0403eIZ`3om^h0ooK^0?of
kP@0?EV[0`3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?of
kP3om^h00`0mFJ/;0?ofkP0303eIZ`3om^h0ooK^00/0ooK^0`0mFJ/<0?ofkP0303eIZ`3om^h0ooK^
06@0ooK^00<000000?ofkP3om^h0@@3om^h10?ooo`00LP3om^h00`000000ooK^0?ofkP0U0?ofkP03
0000003om^h0ooK^04T0ooK^00<0?EV[0?ofkP3om^h00P3om^h00`0mFJ/0ooK^0?ofkP040?ofkP03
03eIZ`3om^h0ooK^00D0ooK^100mFJ/=0?ofkP0303eIZ`3om^h0ooK^00X0ooK^1@0mFJ/>0?ofkP03
03eIZ`3om^h0ooK^00T0ooK^0P0mFJ/30?ofkP0303eIZ`3om^h0ooK^00L0ooK^0P0mFJ]W0?ofkP80
0000@P3om^h10?ooo`00L`3om^h00`000000ooK^0?ofkP0T0?ofkP030000003om^h0ooK^04X0ooK^
00<0?EV[0?ofkP3om^h00P3om^h203eIZ`D0ooK^00<0?EV[0?ofkP3om^h01`3om^h803eIZ`H0ooK^
00<0?EV[0?ofkP3om^h00P3om^h803eIZ`@0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^
0?ofkP060?ofkP80?EV[1@3om^h00`0mFJ/0ooK^0?ofkP060?ofkP0303eIZ`3om^h0ooK^06P0ooK^
00<000000?ofkP3om^h0@03om^h10?ooo`00M03om^h00`000000ooK^0?ofkP0S0?ofkP030000003o
m^h0ooK^04/0ooK^00L0?EV[0?ofkP3om^h0ooK^03eIZ`3om^h0?EV[00@0ooK^00<0?EV[0?ofkP3o
m^h02@3om^h00`0mFJ/0ooK^0?ofkP030?ofkP/0?EV[303om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP03
03eIZ`3om^h0ooK^00@0ooK^0P0mFJ/70?ofkP0303eIZ`3om^h0ooK^00D0ooK^00<0?EV[0?ofkP3o
m^h0J@3om^h00`000000ooK^0?ofkP100?ofkP40oooo001e0?ofkP030000003om^h0ooK^0240ooK^
00<000000?ofkP3om^h0C@3om^h01P0mFJ/0ooK^0?ofkP3om^h0?EV[0?ofkP80?EV[0`3om^h00`0m
FJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0m
FJ/0ooK^0?ofkP0=0?ofkP0403eIZ`3om^h0ooK^0?ofkP80?EV[2P3om^h00`0mFJ/0ooK^0?ofkP03
0?ofkP0303eIZ`3om^h0ooK^06X0ooK^00<000000?ofkP3om^h0@03om^h10?ooo`00M@3om^h00`00
0000ooK^0?ofkP0Q0?ofkP030000003om^h0ooK^04h0ooK^00@0?EV[0?ofkP3om^h0?EV[0`3om^h2
03eIZ`030?ofkP0mFJ/0ooK^00X0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP0=
0?ofkP0303eIZ`3om^h0ooK^00d0ooK^00@0?EV[0?ofkP0mFJ/0?EV[303om^h00`0mFJ/0ooK^0?of
kP020?ofkP0303eIZ`3om^h0ooK^06/0ooK^00<000000?ofkP3om^h0@03om^h10?ooo`00MP3om^h0
0`000000ooK^0?ofkP0P0?ofkP030000003om^h0ooK^04l0ooK^0P0mFJ/00`3om^h0?EV[0?ofkP03
0?ofkP0303eIZ`3om^h0?EV[00X0ooK^00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP0=
0?ofkP0303eIZ`3om^h0ooK^00`0ooK^0P0mFJ/>0?ofkP0303eIZ`3om^h0ooK^0080?EV[KP3om^h0
0`000000ooK^0?ofkP100?ofkP40oooo001g0?ofkP030000003om^h0ooK^01l0ooK^00<000000?of
kP3om^h0D@3om^h203eIZ`D0ooK^0P0mFJ/;0?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?of
kP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP080?ofkP@0?EV[00<0ooK^03eIZ`3om^h03P3om^h203eI
Zg00ooK^0P0000110?ofkP40oooo001h0?ofkP030000003om^h0ooK^01h0ooK^00<000000?ofkP3o
m^h0DP3om^h203eIZ`H0ooK^0`0mFJ/80?ofkP0303eIZ`3om^h0ooK^00/0ooK^00<0?EV[0?ofkP3o
m^h03@3om^h00`0mFJ/0ooK^0?ofkP040?ofkP<0?EV[1P3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP03
03eIZ`3om^h0ooK^0700ooK^00<000000?ofkP3om^h0?`3om^h10?ooo`00N@3om^h00`000000ooK^
0?ofkP0M0?ofkP030000003om^h0ooK^05<0ooK^00<0?EV[0?ofkP3om^h01@3om^h00`0mFJ/0ooK^
03eIZ`0303eIZ`D0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eI
Z`3om^h0ooK^00@0?EV[2@3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP80?EV[L`3om^h00`000000ooK^
0?ofkP0o0?ofkP40oooo001j0?ofkP030000003om^h0ooK^01`0ooK^00<000000?ofkP3om^h0E03o
m^h00`0mFJ/0ooK^0?ofkP040?ofkP0303eIZ`3om^h0ooK^00<0ooK^100mFJ/00`3om^h0?EV[0?of
kP0<0?ofkP0303eIZ`3om^h0ooK^00X0ooK^1@0mFJ/>0?ofkP0303eIZ`3om^h0ooK^00L0ooK^0P0m
FJ]a0?ofkPD00000@@3om^h10?ooo`00NP3om^h00`000000ooK^0?ofkP0L0?ofkP030000003om^h0
ooK^05D0ooK^0P0mFJ/50?ofkP0303eIZ`3om^h0ooK^00H0ooK^2@0mFJ/60?ofkP0303eIZ`3om^h0
ooK^0080ooK^200mFJ/30?ofkP0303eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h01P3om^h0
0`0mFJ/0ooK^0?ofkP1Y0?ofkPP00000AP3om^h10?ooo`00N`3om^h00`000000ooK^0?ofkP0K0?of
kP030000003om^h0ooK^05L0ooK^0P0mFJ/30?ofkP0303eIZ`3om^h0ooK^00T0ooK^00<0?EV[0?of
kP3om^h00`3om^h;03eIZ``0ooK^00<0?EV[0?ofkP3om^h03@3om^h00`0mFJ/0ooK^0?ofkP030?of
kP80?EV[I03om^h8000004h0ooK^0@3oool007`0ooK^00<000000?ofkP3om^h06P3om^h00`000000
ooK^0?ofkP1I0?ofkP80?EV[0P3om^h00`0mFJ/0ooK^0?ofkP080?ofkP0303eIZ`3om^h0ooK^00/0
ooK^00<0?EV[0?ofkP3om^h0303om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0403eIZ`3om^h0ooK^0?of
kP80?EV[G@3om^h9000005H0ooK^0@3oool007d0ooK^00<000000?ofkP3om^h06@3om^h00`000000
ooK^0?ofkP1K0?ofkP80?EV[00<0ooK^03eIZ`3om^h02@3om^h00`0mFJ/0ooK^0?ofkP0:0?ofkP03
03eIZ`3om^h0ooK^00d0ooK^00<0?EV[0?ofkP3om^h03@3om^h303eIZeL0ooK^2000001O0?ofkP40
oooo001n0?ofkP030000003om^h0ooK^01L0ooK^00<000000?ofkP3om^h0GP3om^h203eIZ`X0ooK^
00<0?EV[0?ofkP3om^h02`3om^h00`0mFJ/0ooK^0?ofkP0<0?ofkP0303eIZ`3om^h0ooK^00`0ooK^
0P0mFJ]A0?ofkPP00000I`3om^h10?ooo`00O`3om^h00`000000ooK^0?ofkP0F0?ofkP030000003o
m^h0ooK^0600ooK^0P0mFJ/90?ofkP0303eIZ`3om^h0ooK^00X0ooK^00<0?EV[0?ofkP3om^h03@3o
m^h00`0mFJ/0ooK^0?ofkP070?ofkP@0?EV[BP3om^h9000006l0ooK^0@3oool007l0ooK^00<00000
0?ofkP3om^h05P3om^h00`000000ooK^0?ofkP1R0?ofkP<0?EV[1P3om^h00`0mFJ/0ooK^0?ofkP0;
0?ofkP0303eIZ`3om^h0ooK^00`0ooK^00<0?EV[0?ofkP3om^h0103om^h303eIZdH0ooK^2000001h
0?ofkP40oooo00200?ofkP030000003om^h0ooK^01D0ooK^00<000000?ofkP3om^h0I@3om^h403eI
Z`<0ooK^00<0?EV[0?ofkP3om^h02P3om^h00`0mFJ/0ooK^0?ofkP0=0?ofkP0303eIZ`3om^h0?EV[
00<0?EV[@@3om^h800000800ooK^0@3oool00840ooK^00<000000?ofkP3om^h0503om^h00`000000
ooK^0?ofkP1Y0?ofkP@0?EV[3@3om^h00`0mFJ/0ooK^0?ofkP090?ofkPD0?EV[?03om^h9000008P0
ooK^0@3oool00880ooK^00<000000?ofkP3om^h04`3om^h00`000000ooK^0?ofkP1/0?ofkPP0?EV[
1P3om^h00`0mFJ/0ooK^0?ofkP020?ofkPL0?EV[>@3om^h800000940ooK^0@3oool008<0ooK^00<0
00000?ofkP3om^h04P3om^h00`000000ooK^0?ofkP1d0?ofkP/0?EV[>03om^h8000009T0ooK^0@3o
ool008@0ooK^00<000000?ofkP3om^h04@3om^h00`000000ooK^0?ofkP2^0?ofkPT00000X@3om^h1
0?ooo`00Q03om^h00`000000ooK^0?ofkP0A0?ofkP030000003om^h0ooK^0:H0ooK^2000002Z0?of
kP40oooo00250?ofkP030000003om^h0ooK^0100ooK^00<000000?ofkP3om^h0WP3om^h800000;80
ooK^0@3oool008H0ooK^00<000000?ofkP3om^h03`3om^h00`000000ooK^0?ofkP2E0?ofkPT00000
^P3om^h10?ooo`00Q`3om^h00`000000ooK^0?ofkP0>0?ofkP030000003om^h0ooK^08d0ooK^2000
00330?ofkP40oooo00280?ofkP030000003om^h0ooK^00`0ooK^00<000000?ofkP3om^h0QP3om^h8
00000</0ooK^0@3oool008T0ooK^00<000000?ofkP3om^h02`3om^h00`000000ooK^0?ofkP1n0?of
kPP00000d`3om^h10?ooo`00R@3om^h00`000000ooK^0?ofkP0;0?ofkP030000003om^h0ooK^07D0
ooK^2@00003K0?ofkP40oooo002:0?ofkP030000003om^h0ooK^00X0ooK^00<000000?ofkP3om^h0
K@3om^h800000>@0ooK^0@3oool008/0ooK^00<000000?ofkP3om^h02@3om^h00`000000ooK^0?of
kP1U0?ofkPP00000k03om^h10?ooo`00S03om^h00`000000ooK^0?ofkP080?ofkP030000003om^h0
ooK^05`0ooK^2@00003d0?ofkP40oooo002=0?ofkP030000003om^h0ooK^00L0ooK^00<000000?of
kP3om^h0E03om^h800000?d0ooK^0@3oool008h0ooK^00<000000?ofkP3om^h01P3om^h00`000000
ooK^0?ofkP1<0?ofkPP00000o`3om^h60?ofkP40oooo002>0?ofkP030000003om^h0ooK^00H0ooK^
00<000000?ofkP3om^h0@`3om^h900000?l0ooK^3P3om^h10?ooo`00S`3om^h00`000000ooK^0?of
kP050?ofkP030000003om^h0ooK^03/0ooK^2000003o0?ofkQL0ooK^0@3oool00900ooK^00<00000
0?ofkP3om^h0103om^h00`000000ooK^0?ofkP0c0?ofkPP00000o`3om^hO0?ofkP40oooo002A0?of
kP030000003om^h0ooK^00<0ooK^00<000000?ofkP3om^h0:P3om^h900000?l0ooK^9`3om^h10?oo
o`00TP3om^h01@000000ooK^0?ofkP3om^h0000002D0ooK^2000003o0?ofkS00ooK^0@3oool009<0
ooK^00@000000?ofkP3om^h000007@3om^h800000?l0ooK^>03om^h10?ooo`00T`3om^h010000000
ooK^0?ofkP00000D0?ofkPT00000o`3om^i00?ofkP40oooo002D0?ofkP030000003om^h0000000`0
ooK^2000003o0?ofkTT0ooK^0@3oool009D0ooK^0P0000040?ofkPP00000o`3om^iA0?ofkP40oooo
002F0?ofkPD00000o`3om^iI0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?oo
o`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd
0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo
003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0
ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool0
0?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03o
m^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00
o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?of
kP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o
0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^
0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0
ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h1
0?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3o
m^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40
oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?of
k_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3o
ool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^
m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?oo
o`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd
0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo
003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0
ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool0
0?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03o
m^h10?ooo`00o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00
o`3om^kd0?ofkP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?of
kP40oooo003o0?ofk_@0ooK^0@3oool00?l0ooK^m03om^h10?ooo`00o`3om^kd0?ofkP40oooo0000
\
\>"],
  ImageRangeCache->{{{0, 499}, {499, 0}} -> {-5.00005*^-06, -5.00005*^-06, \
0.00200403, 0.00200403}}]
}, Closed]]
}, Open  ]],

Cell[BoxData[
    \(Clear[xcylinder, ycylinder, eqns, plot1]\)], "Input"]
}, Open  ]]
},
FrontEndVersion->"5.0 for Microsoft Windows",
ScreenRectangle->{{0, 1024}, {0, 677}},
WindowSize->{683, 639},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
ShowSelection->True,
StyleDefinitions -> "Classroom.nb"
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{
Cell[1754, 51, 39, 0, 67, "Title"],
Cell[1796, 53, 73, 1, 50, "Input"],

Cell[CellGroupData[{
Cell[1894, 58, 44, 0, 52, "Subsection"],
Cell[1941, 60, 231, 4, 48, "Text"],
Cell[2175, 66, 63, 0, 29, "Text"],

Cell[CellGroupData[{
Cell[2263, 70, 209, 4, 70, "Input"],
Cell[2475, 76, 365, 5, 44, "Message"],
Cell[2843, 83, 371, 6, 44, "Message"]
}, Open  ]],
Cell[3229, 92, 99, 2, 29, "Text"],

Cell[CellGroupData[{
Cell[3353, 98, 755, 13, 250, "Input"],
Cell[4111, 113, 462117, 12889, 484, 183551, 9447, "GraphicsData", \
"PostScript", "Graphics"]
}, Open  ]],
Cell[466243, 13005, 191, 6, 29, "Text"],

Cell[CellGroupData[{
Cell[466459, 13015, 130, 2, 71, "Input"],
Cell[466592, 13019, 52, 1, 49, "Output"]
}, Open  ]],
Cell[466659, 13023, 410, 9, 67, "Text"],

Cell[CellGroupData[{
Cell[467094, 13036, 139, 2, 50, "Input"],
Cell[467236, 13040, 109, 2, 49, "Output"]
}, Open  ]],
Cell[467360, 13045, 52, 0, 29, "Text"],

Cell[CellGroupData[{
Cell[467437, 13049, 139, 2, 50, "Input"],
Cell[467579, 13053, 109, 2, 49, "Output"]
}, Open  ]],
Cell[467703, 13058, 337, 7, 67, "Text"],

Cell[CellGroupData[{
Cell[468065, 13069, 1372, 23, 390, "Input"],
Cell[469440, 13094, 457225, 17710, 329, 246090, 15100, "GraphicsData", \
"PostScript", "Graphics"]
}, Open  ]],
Cell[926680, 30807, 109, 3, 29, "Text"],

Cell[CellGroupData[{
Cell[926814, 30814, 146, 3, 90, "Input"],
Cell[926963, 30819, 406351, 6379, 296, 336597, 5516, "BoxData", "Graphics3D", \
"Graphics"]
}, Open  ]],

Cell[CellGroupData[{
Cell[1333351, 37203, 259, 4, 110, "Input"],

Cell[CellGroupData[{
Cell[1333635, 37211, 438331, 16964, 508, 237988, 14486, "GraphicsData", \
"PostScript", "Graphics"],
Cell[1771969, 54177, 456249, 17616, 508, 245439, 15010, "GraphicsData", \
"PostScript", "Graphics"],
Cell[2228221, 71795, 475913, 17969, 508, 247194, 15142, "GraphicsData", \
"PostScript", "Graphics"],
Cell[2704137, 89766, 475889, 18021, 508, 245821, 15177, "GraphicsData", \
"PostScript", "Graphics"],
Cell[3180029, 107789, 475284, 17995, 508, 246387, 15166, "GraphicsData", \
"PostScript", "Graphics"],
Cell[3655316, 125786, 454942, 17603, 508, 244128, 14997, "GraphicsData", \
"PostScript", "Graphics"],
Cell[4110261, 143391, 436560, 16917, 508, 236082, 14439, "GraphicsData", \
"PostScript", "Graphics"],
Cell[4546824, 160310, 454850, 17554, 508, 243910, 14946, "GraphicsData", \
"PostScript", "Graphics"],
Cell[5001677, 177866, 475900, 17989, 508, 247080, 15161, "GraphicsData", \
"PostScript", "Graphics"],
Cell[5477580, 195857, 477729, 18087, 508, 247633, 15243, "GraphicsData", \
"PostScript", "Graphics"],
Cell[5955312, 213946, 476586, 17993, 508, 247567, 15162, "GraphicsData", \
"PostScript", "Graphics"],
Cell[6431901, 231941, 455518, 17551, 508, 244672, 14945, "GraphicsData", \
"PostScript", "Graphics"],
Cell[6887422, 249494, 437854, 16916, 508, 237380, 14438, "GraphicsData", \
"PostScript", "Graphics"],
Cell[7325279, 266412, 456215, 17603, 508, 245280, 14996, "GraphicsData", \
"PostScript", "Graphics"],
Cell[7781497, 284017, 476168, 17989, 508, 247441, 15162, "GraphicsData", \
"PostScript", "Graphics"],
Cell[8257668, 302008, 476102, 18040, 508, 246115, 15197, "GraphicsData", \
"PostScript", "Graphics"],
Cell[8733773, 320050, 474971, 17969, 508, 246118, 15140, "GraphicsData", \
"PostScript", "Graphics"],
Cell[9208747, 338021, 455105, 17616, 508, 244299, 15010, "GraphicsData", \
"PostScript", "Graphics"],
Cell[9663855, 355639, 437016, 16963, 508, 236675, 14486, "GraphicsData", \
"PostScript", "Graphics"],
Cell[10100874, 372604, 456243, 17685, 508, 245506, 15080, "GraphicsData", \
"PostScript", "Graphics"],
Cell[10557120, 390291, 476279, 18032, 508, 247637, 15206, "GraphicsData", \
"PostScript", "Graphics"],
Cell[11033402, 408325, 479421, 18221, 508, 249220, 15376, "GraphicsData", \
"PostScript", "Graphics"],
Cell[11512826, 426548, 476792, 18031, 508, 248069, 15204, "GraphicsData", \
"PostScript", "Graphics"],
Cell[11989621, 444581, 456947, 17687, 508, 246331, 15083, "GraphicsData", \
"PostScript", "Graphics"]
}, Closed]]
}, Open  ]],
Cell[12446595, 462272, 73, 1, 50, "Input"]
}, Open  ]]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

